#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 20990
#define LARGE_STATE_COUNT 2733
#define SYMBOL_COUNT 434
#define ALIAS_COUNT 12
#define TOKEN_COUNT 122
#define EXTERNAL_TOKEN_COUNT 23
#define FIELD_COUNT 24
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 100

enum {
  sym__varid = 1,
  anon_sym_SEMI = 2,
  sym_float = 3,
  sym_char = 4,
  sym_string = 5,
  sym__integer_literal = 6,
  sym__binary_literal = 7,
  sym__octal_literal = 8,
  sym__hex_literal = 9,
  anon_sym_LPAREN_POUND = 10,
  anon_sym_LPAREN_POUND_LF = 11,
  anon_sym_ = 12,
  anon_sym_EQ_GT = 13,
  anon_sym_2 = 14,
  anon_sym_DASH_GT = 15,
  anon_sym_3 = 16,
  anon_sym_LT_DASH = 17,
  anon_sym_4 = 18,
  anon_sym_COLON_COLON = 19,
  sym__immediate_dot = 20,
  sym_pragma = 21,
  sym__immediate_varid = 22,
  sym_label = 23,
  anon_sym_DASH = 24,
  anon_sym_LPAREN = 25,
  anon_sym_RPAREN = 26,
  anon_sym_BQUOTE = 27,
  sym_implicit_parid = 28,
  sym__conid = 29,
  anon_sym_LBRACK = 30,
  anon_sym_RBRACK = 31,
  anon_sym_SQUOTE = 32,
  anon_sym_forall = 33,
  anon_sym_5 = 34,
  anon_sym_DOT = 35,
  anon_sym_PIPE = 36,
  anon_sym_STAR = 37,
  anon_sym_6 = 38,
  anon_sym_PERCENT = 39,
  anon_sym_type = 40,
  anon_sym_EQ = 41,
  anon_sym_family = 42,
  anon_sym_LBRACE = 43,
  anon_sym_RBRACE = 44,
  anon_sym_instance = 45,
  anon_sym_representational = 46,
  anon_sym_nominal = 47,
  anon_sym_phantom = 48,
  anon_sym__ = 49,
  anon_sym_role = 50,
  anon_sym_DOT_DOT = 51,
  anon_sym_thengroupby = 52,
  anon_sym_using = 53,
  anon_sym_thengroupusing = 54,
  anon_sym_then = 55,
  anon_sym_SQUOTE_SQUOTE = 56,
  anon_sym_AT = 57,
  anon_sym_BSLASH = 58,
  anon_sym_in = 59,
  anon_sym_let = 60,
  anon_sym_if = 61,
  anon_sym_else = 62,
  anon_sym_case = 63,
  anon_sym_of = 64,
  anon_sym_rec = 65,
  anon_sym_mdo = 66,
  anon_sym_do = 67,
  anon_sym_AT2 = 68,
  anon_sym_pattern = 69,
  anon_sym_hiding = 70,
  anon_sym_import = 71,
  anon_sym_qualified = 72,
  anon_sym_as = 73,
  anon_sym_module = 74,
  anon_sym_via = 75,
  anon_sym_stock = 76,
  anon_sym_newtype = 77,
  anon_sym_anyclass = 78,
  anon_sym_deriving = 79,
  anon_sym_data = 80,
  anon_sym_default = 81,
  anon_sym_class = 82,
  anon_sym_infixl = 83,
  anon_sym_infixr = 84,
  anon_sym_infix = 85,
  anon_sym_ccall = 86,
  anon_sym_stdcall = 87,
  anon_sym_cplusplus = 88,
  anon_sym_jvm = 89,
  anon_sym_dotnet = 90,
  anon_sym_prim = 91,
  anon_sym_capi = 92,
  anon_sym_unsafe = 93,
  anon_sym_safe = 94,
  anon_sym_interruptible = 95,
  anon_sym_foreign = 96,
  anon_sym_export = 97,
  anon_sym_7 = 98,
  anon_sym_PIPE_RBRACK = 99,
  anon_sym_8 = 100,
  aux_sym__token1 = 101,
  sym__layout_semicolon = 102,
  sym__layout_start = 103,
  sym__layout_end = 104,
  sym__dot = 105,
  sym__arith_dotdot = 106,
  sym_where = 107,
  sym__splice_dollar = 108,
  sym__varsym = 109,
  sym__consym = 110,
  sym__tyconsym = 111,
  sym_comment = 112,
  sym_cpp = 113,
  sym_comma = 114,
  sym_quasiquote_start = 115,
  sym_quasiquote_bar = 116,
  sym_quasiquote_body = 117,
  sym__strict = 118,
  sym__lazy = 119,
  sym__unboxed_close = 120,
  sym_empty_file = 121,
  sym_haskell = 122,
  sym__topdecl = 123,
  sym_integer = 124,
  sym__literal = 125,
  sym__unboxed_open = 126,
  sym__carrow = 127,
  sym__arrow = 128,
  sym__larrow = 129,
  sym__colon2 = 130,
  sym_variable = 131,
  sym__immediate_variable = 132,
  sym_qualified_variable = 133,
  sym_operator = 134,
  sym__minus = 135,
  sym_qualified_operator = 136,
  sym_varop = 137,
  sym__qvarop = 138,
  sym__qvarop_nominus = 139,
  sym_constructor = 140,
  sym_qualified_constructor = 141,
  sym_constructor_operator = 142,
  sym_qualified_constructor_operator = 143,
  sym__qcon = 144,
  sym__qop = 145,
  sym_con_unit = 146,
  sym_con_list = 147,
  sym_con_tuple = 148,
  sym_literal = 149,
  sym_qualified_type = 150,
  sym__type_operator = 151,
  sym_qualified_type_operator = 152,
  sym__qualified_type_operator = 153,
  sym__ticked_tycon = 154,
  sym__ticked_qtycon = 155,
  sym__qtyconops = 156,
  sym__promoted_tyconop = 157,
  sym__qtyconop = 158,
  sym_tycon_arrow = 159,
  sym_type_literal = 160,
  sym__promoted_tycon = 161,
  sym__name = 162,
  sym_type_variable = 163,
  sym_annotated_type_variable = 164,
  sym__forall_kw = 165,
  sym__forall_dot = 166,
  sym__forall = 167,
  sym_forall = 168,
  sym_type_parens = 169,
  sym_type_list = 170,
  sym__type_tuple = 171,
  sym_type_tuple = 172,
  sym__type_sum = 173,
  sym__type_promotable_literal = 174,
  sym__type_promoted_literal = 175,
  sym__type_literal = 176,
  sym_strict_type = 177,
  sym_lazy_type = 178,
  sym_type_name = 179,
  sym_type_star = 180,
  sym_type_unboxed_tuple = 181,
  sym_type_unboxed_sum = 182,
  sym__atype = 183,
  sym_type_apply = 184,
  sym__btype = 185,
  sym_implicit_param = 186,
  sym_type_infix = 187,
  sym__type_infix = 188,
  sym_constraint = 189,
  sym__quantified_constraint = 190,
  sym__constraint_context = 191,
  sym__constraint = 192,
  sym__context_constraints = 193,
  sym__context = 194,
  sym_context = 195,
  sym__type_quantifiers = 196,
  sym__type_context = 197,
  sym_modifier = 198,
  sym__fun_arrow = 199,
  sym__type_fun = 200,
  sym__type = 201,
  sym__type_or_implicit = 202,
  sym__type_annotation = 203,
  sym__simpletype_infix = 204,
  sym__simpletype = 205,
  sym_decl_type = 206,
  sym_tyfam_head = 207,
  sym_tyfam_pat = 208,
  sym_tyfam_eq = 209,
  sym_tyfam_result_type = 210,
  sym_tyfam_injectivity = 211,
  sym__tyfam_inj = 212,
  sym_decl_tyfam = 213,
  sym_decl_tyinst = 214,
  sym_type_role = 215,
  sym_decl_role = 216,
  sym_exp_parens = 217,
  sym__exp_tuple = 218,
  sym_exp_tuple = 219,
  sym_exp_unboxed_tuple = 220,
  sym__exp_unboxed_sum = 221,
  sym_exp_unboxed_sum = 222,
  sym_exp_list = 223,
  sym_bind_pattern = 224,
  sym_exp_arithmetic_sequence = 225,
  sym_transform = 226,
  sym_qual = 227,
  sym_exp_list_comprehension = 228,
  sym_exp_section_left = 229,
  sym_exp_section_right = 230,
  sym_exp_th_quoted_name = 231,
  sym_exp_field = 232,
  sym_exp_type_application = 233,
  sym_exp_lambda = 234,
  sym_exp_in = 235,
  sym_let = 236,
  sym__let_decls = 237,
  sym_exp_let = 238,
  sym_exp_let_in = 239,
  sym_exp_cond = 240,
  sym_exp_if_guard = 241,
  sym_pattern_guard = 242,
  sym_guard = 243,
  sym_guards = 244,
  sym_gdpat = 245,
  sym__alt_variants = 246,
  sym_alt = 247,
  sym_alts = 248,
  sym_exp_case = 249,
  sym_exp_lambda_case = 250,
  sym_rec = 251,
  sym_stmt = 252,
  sym__do_keyword = 253,
  sym_do_module = 254,
  sym_exp_do = 255,
  sym_exp_negation = 256,
  sym_exp_record = 257,
  sym_exp_name = 258,
  sym_exp_projection_selector = 259,
  sym__aexp_projection = 260,
  sym_exp_projection = 261,
  sym__aexp = 262,
  sym__exp_apply = 263,
  sym__fexp = 264,
  sym__lexp = 265,
  sym_exp_infix = 266,
  sym__exp_infix = 267,
  sym__exp = 268,
  sym_pat_field = 269,
  sym_pat_fields = 270,
  sym_pat_as = 271,
  sym_pat_parens = 272,
  sym_pat_view = 273,
  sym_pat_tuple = 274,
  sym_pat_unboxed_tuple = 275,
  sym__pat_unboxed_sum = 276,
  sym_pat_unboxed_sum = 277,
  sym_pat_list = 278,
  sym_pat_strict = 279,
  sym_pat_irrefutable = 280,
  sym_pat_negation = 281,
  sym_pat_name = 282,
  sym__pat_constructor = 283,
  sym_pat_wildcard = 284,
  sym_pat_record = 285,
  sym__apat = 286,
  sym_pat_apply = 287,
  sym__lpat = 288,
  sym_pat_infix = 289,
  sym__pat = 290,
  sym_pat_typed = 291,
  sym__typed_pat = 292,
  sym__nested_pat = 293,
  sym__import_name = 294,
  sym_namespace = 295,
  sym_import_con_names = 296,
  sym_import_item = 297,
  sym_import_list = 298,
  sym_decl_import = 299,
  sym__modid = 300,
  aux_sym__qualifying_module = 301,
  sym_qualified_module = 302,
  sym__qmodid = 303,
  sym_export_names = 304,
  sym_export = 305,
  sym_exports = 306,
  sym__module = 307,
  sym_field = 308,
  sym_data_constructor = 309,
  sym_data_constructor_infix = 310,
  sym__record_field = 311,
  sym_record_fields = 312,
  sym_data_constructor_record = 313,
  sym_constructors = 314,
  sym_via = 315,
  sym_deriving_strategy = 316,
  sym_deriving = 317,
  sym__adt_rhs = 318,
  sym__gadt_fun = 319,
  sym__gadt_sig = 320,
  sym__gadt_constr_type = 321,
  sym_gadt_constructor = 322,
  sym__gadt_rhs = 323,
  sym__adt = 324,
  sym_decl_adt = 325,
  sym_newtype_constructor = 326,
  sym__newtype = 327,
  sym__context_newtype = 328,
  sym_decl_newtype = 329,
  sym_decl_datafam = 330,
  sym__datainst = 331,
  sym_decl_datainst = 332,
  sym_default_signature = 333,
  sym_class_datafam = 334,
  sym_class_tyfam = 335,
  sym__cdecl = 336,
  sym_fundep = 337,
  sym_fundeps = 338,
  sym_class_body = 339,
  sym_decl_class = 340,
  sym_inst_datainst = 341,
  sym_inst_tyinst = 342,
  sym__idecl = 343,
  sym__instance = 344,
  sym_decl_instance = 345,
  sym_decl_deriving = 346,
  sym__funpat_infix = 347,
  sym__funpat = 348,
  sym__fun_name = 349,
  sym_guard_equation = 350,
  aux_sym__fun_guards = 351,
  sym__funrhs = 352,
  aux_sym__fun_patterns = 353,
  sym__funvar = 354,
  sym__funlhs = 355,
  sym_function = 356,
  sym_fixity = 357,
  sym_signature = 358,
  sym__gendecl = 359,
  sym__decl_fun = 360,
  sym__decl = 361,
  sym_decls = 362,
  sym_calling_convention = 363,
  sym_safety = 364,
  sym_impent = 365,
  sym_expent = 366,
  sym__foreign_pre = 367,
  sym_decl_foreign_import = 368,
  sym_decl_foreign_export = 369,
  sym__decl_foreign = 370,
  sym__pattern_type = 371,
  sym__pattern_equals = 372,
  sym__pattern_decl = 373,
  sym__pattern_arrow = 374,
  sym_decl_pattern = 375,
  sym_decl_default = 376,
  sym__splice_exp = 377,
  sym_splice = 378,
  sym_top_splice = 379,
  sym_quasiquote = 380,
  aux_sym_haskell_repeat1 = 381,
  aux_sym_con_tuple_repeat1 = 382,
  aux_sym__forall_repeat1 = 383,
  aux_sym_type_list_repeat1 = 384,
  aux_sym__type_sum_repeat1 = 385,
  aux_sym_type_apply_repeat1 = 386,
  aux_sym__context_constraints_repeat1 = 387,
  aux_sym_tyfam_injectivity_repeat1 = 388,
  aux_sym_decl_tyfam_repeat1 = 389,
  aux_sym_decl_tyfam_repeat2 = 390,
  aux_sym_decl_role_repeat1 = 391,
  aux_sym__exp_tuple_repeat1 = 392,
  aux_sym__exp_unboxed_sum_repeat1 = 393,
  aux_sym_exp_list_repeat1 = 394,
  aux_sym_exp_list_comprehension_repeat1 = 395,
  aux_sym_exp_field_repeat1 = 396,
  aux_sym_exp_lambda_repeat1 = 397,
  aux_sym__let_decls_repeat1 = 398,
  aux_sym__let_decls_repeat2 = 399,
  aux_sym_exp_if_guard_repeat1 = 400,
  aux_sym_guards_repeat1 = 401,
  aux_sym_alts_repeat1 = 402,
  aux_sym_alts_repeat2 = 403,
  aux_sym_rec_repeat1 = 404,
  aux_sym_rec_repeat2 = 405,
  aux_sym_exp_record_repeat1 = 406,
  aux_sym_exp_projection_selector_repeat1 = 407,
  aux_sym_pat_fields_repeat1 = 408,
  aux_sym_pat_tuple_repeat1 = 409,
  aux_sym__pat_unboxed_sum_repeat1 = 410,
  aux_sym_import_con_names_repeat1 = 411,
  aux_sym_import_list_repeat1 = 412,
  aux_sym_export_names_repeat1 = 413,
  aux_sym_exports_repeat1 = 414,
  aux_sym__module_repeat1 = 415,
  aux_sym_field_repeat1 = 416,
  aux_sym_data_constructor_repeat1 = 417,
  aux_sym_record_fields_repeat1 = 418,
  aux_sym_constructors_repeat1 = 419,
  aux_sym_deriving_repeat1 = 420,
  aux_sym__adt_rhs_repeat1 = 421,
  aux_sym__gadt_rhs_repeat1 = 422,
  aux_sym__gadt_rhs_repeat2 = 423,
  aux_sym_fundeps_repeat1 = 424,
  aux_sym_class_body_repeat1 = 425,
  aux_sym_class_body_repeat2 = 426,
  aux_sym_decl_instance_repeat1 = 427,
  aux_sym_decl_instance_repeat2 = 428,
  aux_sym_fixity_repeat1 = 429,
  aux_sym_signature_repeat1 = 430,
  aux_sym__pattern_arrow_repeat1 = 431,
  aux_sym__pattern_arrow_repeat2 = 432,
  aux_sym_decl_default_repeat1 = 433,
  alias_sym_all_names = 434,
  alias_sym_class_head = 435,
  alias_sym_class_name = 436,
  alias_sym_exp_apply = 437,
  alias_sym_import_package = 438,
  alias_sym_instance_head = 439,
  alias_sym_module = 440,
  alias_sym_pat_literal = 441,
  alias_sym_patterns = 442,
  alias_sym_quoter = 443,
  alias_sym_type = 444,
  alias_sym_wildcard = 445,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__varid] = "_varid",
  [anon_sym_SEMI] = ";",
  [sym_float] = "float",
  [sym_char] = "char",
  [sym_string] = "string",
  [sym__integer_literal] = "_integer_literal",
  [sym__binary_literal] = "_binary_literal",
  [sym__octal_literal] = "_octal_literal",
  [sym__hex_literal] = "_hex_literal",
  [anon_sym_LPAREN_POUND] = "(# ",
  [anon_sym_LPAREN_POUND_LF] = "(#\n",
  [anon_sym_] = "⇒",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_2] = "→",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_3] = "←",
  [anon_sym_LT_DASH] = "<-",
  [anon_sym_4] = "∷",
  [anon_sym_COLON_COLON] = "::",
  [sym__immediate_dot] = "_immediate_dot",
  [sym_pragma] = "pragma",
  [sym__immediate_varid] = "variable",
  [sym_label] = "label",
  [anon_sym_DASH] = "-",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_BQUOTE] = "`",
  [sym_implicit_parid] = "implicit_parid",
  [sym__conid] = "_conid",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_forall] = "forall",
  [anon_sym_5] = "∀",
  [anon_sym_DOT] = ".",
  [anon_sym_PIPE] = "|",
  [anon_sym_STAR] = "*",
  [anon_sym_6] = "★",
  [anon_sym_PERCENT] = "%",
  [anon_sym_type] = "type",
  [anon_sym_EQ] = "=",
  [anon_sym_family] = "family",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_instance] = "instance",
  [anon_sym_representational] = "representational",
  [anon_sym_nominal] = "nominal",
  [anon_sym_phantom] = "phantom",
  [anon_sym__] = "_",
  [anon_sym_role] = "role",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_thengroupby] = "then group by",
  [anon_sym_using] = "using",
  [anon_sym_thengroupusing] = "then group using",
  [anon_sym_then] = "then",
  [anon_sym_SQUOTE_SQUOTE] = "''",
  [anon_sym_AT] = "@",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_in] = "in",
  [anon_sym_let] = "let",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_of] = "of",
  [anon_sym_rec] = "rec",
  [anon_sym_mdo] = "mdo",
  [anon_sym_do] = "do",
  [anon_sym_AT2] = "@",
  [anon_sym_pattern] = "pattern",
  [anon_sym_hiding] = "hiding",
  [anon_sym_import] = "import",
  [anon_sym_qualified] = "qualified",
  [anon_sym_as] = "as",
  [anon_sym_module] = "module",
  [anon_sym_via] = "via",
  [anon_sym_stock] = "stock",
  [anon_sym_newtype] = "newtype",
  [anon_sym_anyclass] = "anyclass",
  [anon_sym_deriving] = "deriving",
  [anon_sym_data] = "data",
  [anon_sym_default] = "default",
  [anon_sym_class] = "class",
  [anon_sym_infixl] = "infixl",
  [anon_sym_infixr] = "infixr",
  [anon_sym_infix] = "infix",
  [anon_sym_ccall] = "ccall",
  [anon_sym_stdcall] = "stdcall",
  [anon_sym_cplusplus] = "cplusplus",
  [anon_sym_jvm] = "jvm",
  [anon_sym_dotnet] = "dotnet",
  [anon_sym_prim] = "prim",
  [anon_sym_capi] = "capi",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_safe] = "safe",
  [anon_sym_interruptible] = "interruptible",
  [anon_sym_foreign] = "foreign",
  [anon_sym_export] = "export",
  [anon_sym_7] = "⟦",
  [anon_sym_PIPE_RBRACK] = "|]",
  [anon_sym_8] = "⟧",
  [aux_sym__token1] = "_token1",
  [sym__layout_semicolon] = "_layout_semicolon",
  [sym__layout_start] = "_layout_start",
  [sym__layout_end] = "_layout_end",
  [sym__dot] = "_dot",
  [sym__arith_dotdot] = "_arith_dotdot",
  [sym_where] = "where",
  [sym__splice_dollar] = "_splice_dollar",
  [sym__varsym] = "_varsym",
  [sym__consym] = "_consym",
  [sym__tyconsym] = "type_operator",
  [sym_comment] = "comment",
  [sym_cpp] = "cpp",
  [sym_comma] = "comma",
  [sym_quasiquote_start] = "quasiquote_start",
  [sym_quasiquote_bar] = "quasiquote_bar",
  [sym_quasiquote_body] = "quasiquote_body",
  [sym__strict] = "_strict",
  [sym__lazy] = "_lazy",
  [sym__unboxed_close] = "_unboxed_close",
  [sym_empty_file] = "empty_file",
  [sym_haskell] = "haskell",
  [sym__topdecl] = "_topdecl",
  [sym_integer] = "integer",
  [sym__literal] = "_literal",
  [sym__unboxed_open] = "_unboxed_open",
  [sym__carrow] = "_carrow",
  [sym__arrow] = "_arrow",
  [sym__larrow] = "_larrow",
  [sym__colon2] = "_colon2",
  [sym_variable] = "variable",
  [sym__immediate_variable] = "_immediate_variable",
  [sym_qualified_variable] = "qualified_variable",
  [sym_operator] = "operator",
  [sym__minus] = "_minus",
  [sym_qualified_operator] = "qualified_operator",
  [sym_varop] = "varop",
  [sym__qvarop] = "_qvarop",
  [sym__qvarop_nominus] = "_qvarop_nominus",
  [sym_constructor] = "constructor",
  [sym_qualified_constructor] = "qualified_constructor",
  [sym_constructor_operator] = "constructor_operator",
  [sym_qualified_constructor_operator] = "qualified_constructor_operator",
  [sym__qcon] = "_qcon",
  [sym__qop] = "_qop",
  [sym_con_unit] = "con_unit",
  [sym_con_list] = "con_list",
  [sym_con_tuple] = "con_tuple",
  [sym_literal] = "exp_literal",
  [sym_qualified_type] = "qualified_type",
  [sym__type_operator] = "_type_operator",
  [sym_qualified_type_operator] = "qualified_type_operator",
  [sym__qualified_type_operator] = "_qualified_type_operator",
  [sym__ticked_tycon] = "ticked",
  [sym__ticked_qtycon] = "ticked",
  [sym__qtyconops] = "_qtyconops",
  [sym__promoted_tyconop] = "promoted",
  [sym__qtyconop] = "_qtyconop",
  [sym_tycon_arrow] = "tycon_arrow",
  [sym_type_literal] = "type_literal",
  [sym__promoted_tycon] = "promoted",
  [sym__name] = "_name",
  [sym_type_variable] = "type_variable",
  [sym_annotated_type_variable] = "annotated_type_variable",
  [sym__forall_kw] = "_forall_kw",
  [sym__forall_dot] = "_forall_dot",
  [sym__forall] = "quantifiers",
  [sym_forall] = "forall",
  [sym_type_parens] = "type_parens",
  [sym_type_list] = "type_list",
  [sym__type_tuple] = "_type_tuple",
  [sym_type_tuple] = "type_tuple",
  [sym__type_sum] = "_type_sum",
  [sym__type_promotable_literal] = "_type_promotable_literal",
  [sym__type_promoted_literal] = "promoted",
  [sym__type_literal] = "_type_literal",
  [sym_strict_type] = "strict_type",
  [sym_lazy_type] = "lazy_type",
  [sym_type_name] = "type_name",
  [sym_type_star] = "type_star",
  [sym_type_unboxed_tuple] = "type_unboxed_tuple",
  [sym_type_unboxed_sum] = "type_unboxed_sum",
  [sym__atype] = "_atype",
  [sym_type_apply] = "type_apply",
  [sym__btype] = "_btype",
  [sym_implicit_param] = "implicit_param",
  [sym_type_infix] = "type_infix",
  [sym__type_infix] = "_type_infix",
  [sym_constraint] = "constraint",
  [sym__quantified_constraint] = "forall",
  [sym__constraint_context] = "context",
  [sym__constraint] = "_constraint",
  [sym__context_constraints] = "_context_constraints",
  [sym__context] = "_context",
  [sym_context] = "context",
  [sym__type_quantifiers] = "forall",
  [sym__type_context] = "context",
  [sym_modifier] = "modifier",
  [sym__fun_arrow] = "_fun_arrow",
  [sym__type_fun] = "fun",
  [sym__type] = "_type",
  [sym__type_or_implicit] = "_type_or_implicit",
  [sym__type_annotation] = "_type_annotation",
  [sym__simpletype_infix] = "type_infix",
  [sym__simpletype] = "_simpletype",
  [sym_decl_type] = "type_alias",
  [sym_tyfam_head] = "head",
  [sym_tyfam_pat] = "pattern",
  [sym_tyfam_eq] = "equation",
  [sym_tyfam_result_type] = "tyfam_result_type",
  [sym_tyfam_injectivity] = "tyfam_injectivity",
  [sym__tyfam_inj] = "_tyfam_inj",
  [sym_decl_tyfam] = "type_family",
  [sym_decl_tyinst] = "type_instance",
  [sym_type_role] = "type_role",
  [sym_decl_role] = "role_annotation",
  [sym_exp_parens] = "exp_parens",
  [sym__exp_tuple] = "_exp_tuple",
  [sym_exp_tuple] = "exp_tuple",
  [sym_exp_unboxed_tuple] = "exp_unboxed_tuple",
  [sym__exp_unboxed_sum] = "_exp_unboxed_sum",
  [sym_exp_unboxed_sum] = "exp_unboxed_sum",
  [sym_exp_list] = "exp_list",
  [sym_bind_pattern] = "bind_pattern",
  [sym_exp_arithmetic_sequence] = "exp_arithmetic_sequence",
  [sym_transform] = "transform",
  [sym_qual] = "qual",
  [sym_exp_list_comprehension] = "exp_list_comprehension",
  [sym_exp_section_left] = "exp_section_left",
  [sym_exp_section_right] = "exp_section_right",
  [sym_exp_th_quoted_name] = "exp_th_quoted_name",
  [sym_exp_field] = "exp_field",
  [sym_exp_type_application] = "exp_type_application",
  [sym_exp_lambda] = "exp_lambda",
  [sym_exp_in] = "exp_in",
  [sym_let] = "let",
  [sym__let_decls] = "decls",
  [sym_exp_let] = "exp_let",
  [sym_exp_let_in] = "exp_let_in",
  [sym_exp_cond] = "exp_cond",
  [sym_exp_if_guard] = "exp_if_guard",
  [sym_pattern_guard] = "pattern_guard",
  [sym_guard] = "guard",
  [sym_guards] = "guards",
  [sym_gdpat] = "gdpat",
  [sym__alt_variants] = "_alt_variants",
  [sym_alt] = "alt",
  [sym_alts] = "alts",
  [sym_exp_case] = "exp_case",
  [sym_exp_lambda_case] = "exp_lambda_case",
  [sym_rec] = "rec",
  [sym_stmt] = "stmt",
  [sym__do_keyword] = "_do_keyword",
  [sym_do_module] = "do_module",
  [sym_exp_do] = "exp_do",
  [sym_exp_negation] = "exp_negation",
  [sym_exp_record] = "exp_record",
  [sym_exp_name] = "exp_name",
  [sym_exp_projection_selector] = "exp_projection_selector",
  [sym__aexp_projection] = "_aexp_projection",
  [sym_exp_projection] = "exp_projection",
  [sym__aexp] = "_aexp",
  [sym__exp_apply] = "_exp_apply",
  [sym__fexp] = "_fexp",
  [sym__lexp] = "_lexp",
  [sym_exp_infix] = "exp_infix",
  [sym__exp_infix] = "_exp_infix",
  [sym__exp] = "_exp",
  [sym_pat_field] = "pat_field",
  [sym_pat_fields] = "pat_fields",
  [sym_pat_as] = "pat_as",
  [sym_pat_parens] = "pat_parens",
  [sym_pat_view] = "pat_view",
  [sym_pat_tuple] = "pat_tuple",
  [sym_pat_unboxed_tuple] = "pat_unboxed_tuple",
  [sym__pat_unboxed_sum] = "_pat_unboxed_sum",
  [sym_pat_unboxed_sum] = "pat_unboxed_sum",
  [sym_pat_list] = "pat_list",
  [sym_pat_strict] = "pat_strict",
  [sym_pat_irrefutable] = "pat_irrefutable",
  [sym_pat_negation] = "pat_negation",
  [sym_pat_name] = "pat_name",
  [sym__pat_constructor] = "_pat_constructor",
  [sym_pat_wildcard] = "pat_wildcard",
  [sym_pat_record] = "pat_record",
  [sym__apat] = "_apat",
  [sym_pat_apply] = "pat_apply",
  [sym__lpat] = "_lpat",
  [sym_pat_infix] = "pat_infix",
  [sym__pat] = "_pat",
  [sym_pat_typed] = "pat_typed",
  [sym__typed_pat] = "_typed_pat",
  [sym__nested_pat] = "_nested_pat",
  [sym__import_name] = "_import_name",
  [sym_namespace] = "namespace",
  [sym_import_con_names] = "import_con_names",
  [sym_import_item] = "import_item",
  [sym_import_list] = "import_list",
  [sym_decl_import] = "import",
  [sym__modid] = "_modid",
  [aux_sym__qualifying_module] = "_qualifying_module",
  [sym_qualified_module] = "qualified_module",
  [sym__qmodid] = "_qmodid",
  [sym_export_names] = "export_names",
  [sym_export] = "export",
  [sym_exports] = "exports",
  [sym__module] = "_module",
  [sym_field] = "field",
  [sym_data_constructor] = "data_constructor",
  [sym_data_constructor_infix] = "data_constructor_infix",
  [sym__record_field] = "_record_field",
  [sym_record_fields] = "record_fields",
  [sym_data_constructor_record] = "data_constructor_record",
  [sym_constructors] = "constructors",
  [sym_via] = "via",
  [sym_deriving_strategy] = "deriving_strategy",
  [sym_deriving] = "deriving",
  [sym__adt_rhs] = "_adt_rhs",
  [sym__gadt_fun] = "fun",
  [sym__gadt_sig] = "_gadt_sig",
  [sym__gadt_constr_type] = "_gadt_constr_type",
  [sym_gadt_constructor] = "gadt_constructor",
  [sym__gadt_rhs] = "_gadt_rhs",
  [sym__adt] = "_adt",
  [sym_decl_adt] = "adt",
  [sym_newtype_constructor] = "newtype_constructor",
  [sym__newtype] = "_newtype",
  [sym__context_newtype] = "_context_newtype",
  [sym_decl_newtype] = "newtype",
  [sym_decl_datafam] = "data_family",
  [sym__datainst] = "_datainst",
  [sym_decl_datainst] = "data_instance",
  [sym_default_signature] = "default_signature",
  [sym_class_datafam] = "data_family",
  [sym_class_tyfam] = "type_family",
  [sym__cdecl] = "_cdecl",
  [sym_fundep] = "fundep",
  [sym_fundeps] = "fundeps",
  [sym_class_body] = "class_body",
  [sym_decl_class] = "class",
  [sym_inst_datainst] = "inst_datainst",
  [sym_inst_tyinst] = "inst_tyinst",
  [sym__idecl] = "_idecl",
  [sym__instance] = "_instance",
  [sym_decl_instance] = "instance",
  [sym_decl_deriving] = "deriving_declaration",
  [sym__funpat_infix] = "infix",
  [sym__funpat] = "function",
  [sym__fun_name] = "_fun_name",
  [sym_guard_equation] = "guard_equation",
  [aux_sym__fun_guards] = "_fun_guards",
  [sym__funrhs] = "_funrhs",
  [aux_sym__fun_patterns] = "_fun_patterns",
  [sym__funvar] = "_funvar",
  [sym__funlhs] = "_funlhs",
  [sym_function] = "function",
  [sym_fixity] = "fixity",
  [sym_signature] = "signature",
  [sym__gendecl] = "_gendecl",
  [sym__decl_fun] = "_decl_fun",
  [sym__decl] = "_decl",
  [sym_decls] = "decls",
  [sym_calling_convention] = "calling_convention",
  [sym_safety] = "safety",
  [sym_impent] = "impent",
  [sym_expent] = "expent",
  [sym__foreign_pre] = "_foreign_pre",
  [sym_decl_foreign_import] = "foreign_import",
  [sym_decl_foreign_export] = "foreign_export",
  [sym__decl_foreign] = "_decl_foreign",
  [sym__pattern_type] = "signature",
  [sym__pattern_equals] = "equation",
  [sym__pattern_decl] = "_pattern_decl",
  [sym__pattern_arrow] = "equation",
  [sym_decl_pattern] = "pattern_synonym",
  [sym_decl_default] = "default_declaration",
  [sym__splice_exp] = "_splice_exp",
  [sym_splice] = "splice",
  [sym_top_splice] = "top_splice",
  [sym_quasiquote] = "quasiquote",
  [aux_sym_haskell_repeat1] = "haskell_repeat1",
  [aux_sym_con_tuple_repeat1] = "con_tuple_repeat1",
  [aux_sym__forall_repeat1] = "_forall_repeat1",
  [aux_sym_type_list_repeat1] = "type_list_repeat1",
  [aux_sym__type_sum_repeat1] = "_type_sum_repeat1",
  [aux_sym_type_apply_repeat1] = "type_apply_repeat1",
  [aux_sym__context_constraints_repeat1] = "_context_constraints_repeat1",
  [aux_sym_tyfam_injectivity_repeat1] = "tyfam_injectivity_repeat1",
  [aux_sym_decl_tyfam_repeat1] = "decl_tyfam_repeat1",
  [aux_sym_decl_tyfam_repeat2] = "decl_tyfam_repeat2",
  [aux_sym_decl_role_repeat1] = "decl_role_repeat1",
  [aux_sym__exp_tuple_repeat1] = "_exp_tuple_repeat1",
  [aux_sym__exp_unboxed_sum_repeat1] = "_exp_unboxed_sum_repeat1",
  [aux_sym_exp_list_repeat1] = "exp_list_repeat1",
  [aux_sym_exp_list_comprehension_repeat1] = "exp_list_comprehension_repeat1",
  [aux_sym_exp_field_repeat1] = "exp_field_repeat1",
  [aux_sym_exp_lambda_repeat1] = "exp_lambda_repeat1",
  [aux_sym__let_decls_repeat1] = "_let_decls_repeat1",
  [aux_sym__let_decls_repeat2] = "_let_decls_repeat2",
  [aux_sym_exp_if_guard_repeat1] = "exp_if_guard_repeat1",
  [aux_sym_guards_repeat1] = "guards_repeat1",
  [aux_sym_alts_repeat1] = "alts_repeat1",
  [aux_sym_alts_repeat2] = "alts_repeat2",
  [aux_sym_rec_repeat1] = "rec_repeat1",
  [aux_sym_rec_repeat2] = "rec_repeat2",
  [aux_sym_exp_record_repeat1] = "exp_record_repeat1",
  [aux_sym_exp_projection_selector_repeat1] = "exp_projection_selector_repeat1",
  [aux_sym_pat_fields_repeat1] = "pat_fields_repeat1",
  [aux_sym_pat_tuple_repeat1] = "pat_tuple_repeat1",
  [aux_sym__pat_unboxed_sum_repeat1] = "_pat_unboxed_sum_repeat1",
  [aux_sym_import_con_names_repeat1] = "import_con_names_repeat1",
  [aux_sym_import_list_repeat1] = "import_list_repeat1",
  [aux_sym_export_names_repeat1] = "export_names_repeat1",
  [aux_sym_exports_repeat1] = "exports_repeat1",
  [aux_sym__module_repeat1] = "_module_repeat1",
  [aux_sym_field_repeat1] = "field_repeat1",
  [aux_sym_data_constructor_repeat1] = "data_constructor_repeat1",
  [aux_sym_record_fields_repeat1] = "record_fields_repeat1",
  [aux_sym_constructors_repeat1] = "constructors_repeat1",
  [aux_sym_deriving_repeat1] = "deriving_repeat1",
  [aux_sym__adt_rhs_repeat1] = "_adt_rhs_repeat1",
  [aux_sym__gadt_rhs_repeat1] = "_gadt_rhs_repeat1",
  [aux_sym__gadt_rhs_repeat2] = "_gadt_rhs_repeat2",
  [aux_sym_fundeps_repeat1] = "fundeps_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_class_body_repeat2] = "class_body_repeat2",
  [aux_sym_decl_instance_repeat1] = "decl_instance_repeat1",
  [aux_sym_decl_instance_repeat2] = "decl_instance_repeat2",
  [aux_sym_fixity_repeat1] = "fixity_repeat1",
  [aux_sym_signature_repeat1] = "signature_repeat1",
  [aux_sym__pattern_arrow_repeat1] = "_pattern_arrow_repeat1",
  [aux_sym__pattern_arrow_repeat2] = "_pattern_arrow_repeat2",
  [aux_sym_decl_default_repeat1] = "decl_default_repeat1",
  [alias_sym_all_names] = "all_names",
  [alias_sym_class_head] = "class_head",
  [alias_sym_class_name] = "class_name",
  [alias_sym_exp_apply] = "exp_apply",
  [alias_sym_import_package] = "import_package",
  [alias_sym_instance_head] = "instance_head",
  [alias_sym_module] = "module",
  [alias_sym_pat_literal] = "pat_literal",
  [alias_sym_patterns] = "patterns",
  [alias_sym_quoter] = "quoter",
  [alias_sym_type] = "type",
  [alias_sym_wildcard] = "wildcard",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__varid] = sym__varid,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [sym_float] = sym_float,
  [sym_char] = sym_char,
  [sym_string] = sym_string,
  [sym__integer_literal] = sym__integer_literal,
  [sym__binary_literal] = sym__binary_literal,
  [sym__octal_literal] = sym__octal_literal,
  [sym__hex_literal] = sym__hex_literal,
  [anon_sym_LPAREN_POUND] = anon_sym_LPAREN_POUND,
  [anon_sym_LPAREN_POUND_LF] = anon_sym_LPAREN_POUND_LF,
  [anon_sym_] = anon_sym_,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_2] = anon_sym_2,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_3] = anon_sym_3,
  [anon_sym_LT_DASH] = anon_sym_LT_DASH,
  [anon_sym_4] = anon_sym_4,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [sym__immediate_dot] = sym__immediate_dot,
  [sym_pragma] = sym_pragma,
  [sym__immediate_varid] = sym_variable,
  [sym_label] = sym_label,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [sym_implicit_parid] = sym_implicit_parid,
  [sym__conid] = sym__conid,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_forall] = anon_sym_forall,
  [anon_sym_5] = anon_sym_5,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_6] = anon_sym_6,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_family] = anon_sym_family,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_instance] = anon_sym_instance,
  [anon_sym_representational] = anon_sym_representational,
  [anon_sym_nominal] = anon_sym_nominal,
  [anon_sym_phantom] = anon_sym_phantom,
  [anon_sym__] = anon_sym__,
  [anon_sym_role] = anon_sym_role,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_thengroupby] = anon_sym_thengroupby,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_thengroupusing] = anon_sym_thengroupusing,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_SQUOTE_SQUOTE] = anon_sym_SQUOTE_SQUOTE,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_rec] = anon_sym_rec,
  [anon_sym_mdo] = anon_sym_mdo,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_AT2] = anon_sym_AT,
  [anon_sym_pattern] = anon_sym_pattern,
  [anon_sym_hiding] = anon_sym_hiding,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_qualified] = anon_sym_qualified,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_via] = anon_sym_via,
  [anon_sym_stock] = anon_sym_stock,
  [anon_sym_newtype] = anon_sym_newtype,
  [anon_sym_anyclass] = anon_sym_anyclass,
  [anon_sym_deriving] = anon_sym_deriving,
  [anon_sym_data] = anon_sym_data,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_infixl] = anon_sym_infixl,
  [anon_sym_infixr] = anon_sym_infixr,
  [anon_sym_infix] = anon_sym_infix,
  [anon_sym_ccall] = anon_sym_ccall,
  [anon_sym_stdcall] = anon_sym_stdcall,
  [anon_sym_cplusplus] = anon_sym_cplusplus,
  [anon_sym_jvm] = anon_sym_jvm,
  [anon_sym_dotnet] = anon_sym_dotnet,
  [anon_sym_prim] = anon_sym_prim,
  [anon_sym_capi] = anon_sym_capi,
  [anon_sym_unsafe] = anon_sym_unsafe,
  [anon_sym_safe] = anon_sym_safe,
  [anon_sym_interruptible] = anon_sym_interruptible,
  [anon_sym_foreign] = anon_sym_foreign,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_7] = anon_sym_7,
  [anon_sym_PIPE_RBRACK] = anon_sym_PIPE_RBRACK,
  [anon_sym_8] = anon_sym_8,
  [aux_sym__token1] = aux_sym__token1,
  [sym__layout_semicolon] = sym__layout_semicolon,
  [sym__layout_start] = sym__layout_start,
  [sym__layout_end] = sym__layout_end,
  [sym__dot] = sym__dot,
  [sym__arith_dotdot] = sym__arith_dotdot,
  [sym_where] = sym_where,
  [sym__splice_dollar] = sym__splice_dollar,
  [sym__varsym] = sym__varsym,
  [sym__consym] = sym__consym,
  [sym__tyconsym] = sym__tyconsym,
  [sym_comment] = sym_comment,
  [sym_cpp] = sym_cpp,
  [sym_comma] = sym_comma,
  [sym_quasiquote_start] = sym_quasiquote_start,
  [sym_quasiquote_bar] = sym_quasiquote_bar,
  [sym_quasiquote_body] = sym_quasiquote_body,
  [sym__strict] = sym__strict,
  [sym__lazy] = sym__lazy,
  [sym__unboxed_close] = sym__unboxed_close,
  [sym_empty_file] = sym_empty_file,
  [sym_haskell] = sym_haskell,
  [sym__topdecl] = sym__topdecl,
  [sym_integer] = sym_integer,
  [sym__literal] = sym__literal,
  [sym__unboxed_open] = sym__unboxed_open,
  [sym__carrow] = sym__carrow,
  [sym__arrow] = sym__arrow,
  [sym__larrow] = sym__larrow,
  [sym__colon2] = sym__colon2,
  [sym_variable] = sym_variable,
  [sym__immediate_variable] = sym__immediate_variable,
  [sym_qualified_variable] = sym_qualified_variable,
  [sym_operator] = sym_operator,
  [sym__minus] = sym__minus,
  [sym_qualified_operator] = sym_qualified_operator,
  [sym_varop] = sym_varop,
  [sym__qvarop] = sym__qvarop,
  [sym__qvarop_nominus] = sym__qvarop_nominus,
  [sym_constructor] = sym_constructor,
  [sym_qualified_constructor] = sym_qualified_constructor,
  [sym_constructor_operator] = sym_constructor_operator,
  [sym_qualified_constructor_operator] = sym_qualified_constructor_operator,
  [sym__qcon] = sym__qcon,
  [sym__qop] = sym__qop,
  [sym_con_unit] = sym_con_unit,
  [sym_con_list] = sym_con_list,
  [sym_con_tuple] = sym_con_tuple,
  [sym_literal] = sym_literal,
  [sym_qualified_type] = sym_qualified_type,
  [sym__type_operator] = sym__type_operator,
  [sym_qualified_type_operator] = sym_qualified_type_operator,
  [sym__qualified_type_operator] = sym__qualified_type_operator,
  [sym__ticked_tycon] = sym__ticked_tycon,
  [sym__ticked_qtycon] = sym__ticked_tycon,
  [sym__qtyconops] = sym__qtyconops,
  [sym__promoted_tyconop] = sym__promoted_tyconop,
  [sym__qtyconop] = sym__qtyconop,
  [sym_tycon_arrow] = sym_tycon_arrow,
  [sym_type_literal] = sym_type_literal,
  [sym__promoted_tycon] = sym__promoted_tyconop,
  [sym__name] = sym__name,
  [sym_type_variable] = sym_type_variable,
  [sym_annotated_type_variable] = sym_annotated_type_variable,
  [sym__forall_kw] = sym__forall_kw,
  [sym__forall_dot] = sym__forall_dot,
  [sym__forall] = sym__forall,
  [sym_forall] = sym_forall,
  [sym_type_parens] = sym_type_parens,
  [sym_type_list] = sym_type_list,
  [sym__type_tuple] = sym__type_tuple,
  [sym_type_tuple] = sym_type_tuple,
  [sym__type_sum] = sym__type_sum,
  [sym__type_promotable_literal] = sym__type_promotable_literal,
  [sym__type_promoted_literal] = sym__promoted_tyconop,
  [sym__type_literal] = sym__type_literal,
  [sym_strict_type] = sym_strict_type,
  [sym_lazy_type] = sym_lazy_type,
  [sym_type_name] = sym_type_name,
  [sym_type_star] = sym_type_star,
  [sym_type_unboxed_tuple] = sym_type_unboxed_tuple,
  [sym_type_unboxed_sum] = sym_type_unboxed_sum,
  [sym__atype] = sym__atype,
  [sym_type_apply] = sym_type_apply,
  [sym__btype] = sym__btype,
  [sym_implicit_param] = sym_implicit_param,
  [sym_type_infix] = sym_type_infix,
  [sym__type_infix] = sym__type_infix,
  [sym_constraint] = sym_constraint,
  [sym__quantified_constraint] = sym_forall,
  [sym__constraint_context] = sym_context,
  [sym__constraint] = sym__constraint,
  [sym__context_constraints] = sym__context_constraints,
  [sym__context] = sym__context,
  [sym_context] = sym_context,
  [sym__type_quantifiers] = sym_forall,
  [sym__type_context] = sym_context,
  [sym_modifier] = sym_modifier,
  [sym__fun_arrow] = sym__fun_arrow,
  [sym__type_fun] = sym__type_fun,
  [sym__type] = sym__type,
  [sym__type_or_implicit] = sym__type_or_implicit,
  [sym__type_annotation] = sym__type_annotation,
  [sym__simpletype_infix] = sym_type_infix,
  [sym__simpletype] = sym__simpletype,
  [sym_decl_type] = sym_decl_type,
  [sym_tyfam_head] = sym_tyfam_head,
  [sym_tyfam_pat] = sym_tyfam_pat,
  [sym_tyfam_eq] = sym_tyfam_eq,
  [sym_tyfam_result_type] = sym_tyfam_result_type,
  [sym_tyfam_injectivity] = sym_tyfam_injectivity,
  [sym__tyfam_inj] = sym__tyfam_inj,
  [sym_decl_tyfam] = sym_decl_tyfam,
  [sym_decl_tyinst] = sym_decl_tyinst,
  [sym_type_role] = sym_type_role,
  [sym_decl_role] = sym_decl_role,
  [sym_exp_parens] = sym_exp_parens,
  [sym__exp_tuple] = sym__exp_tuple,
  [sym_exp_tuple] = sym_exp_tuple,
  [sym_exp_unboxed_tuple] = sym_exp_unboxed_tuple,
  [sym__exp_unboxed_sum] = sym__exp_unboxed_sum,
  [sym_exp_unboxed_sum] = sym_exp_unboxed_sum,
  [sym_exp_list] = sym_exp_list,
  [sym_bind_pattern] = sym_bind_pattern,
  [sym_exp_arithmetic_sequence] = sym_exp_arithmetic_sequence,
  [sym_transform] = sym_transform,
  [sym_qual] = sym_qual,
  [sym_exp_list_comprehension] = sym_exp_list_comprehension,
  [sym_exp_section_left] = sym_exp_section_left,
  [sym_exp_section_right] = sym_exp_section_right,
  [sym_exp_th_quoted_name] = sym_exp_th_quoted_name,
  [sym_exp_field] = sym_exp_field,
  [sym_exp_type_application] = sym_exp_type_application,
  [sym_exp_lambda] = sym_exp_lambda,
  [sym_exp_in] = sym_exp_in,
  [sym_let] = sym_let,
  [sym__let_decls] = sym_decls,
  [sym_exp_let] = sym_exp_let,
  [sym_exp_let_in] = sym_exp_let_in,
  [sym_exp_cond] = sym_exp_cond,
  [sym_exp_if_guard] = sym_exp_if_guard,
  [sym_pattern_guard] = sym_pattern_guard,
  [sym_guard] = sym_guard,
  [sym_guards] = sym_guards,
  [sym_gdpat] = sym_gdpat,
  [sym__alt_variants] = sym__alt_variants,
  [sym_alt] = sym_alt,
  [sym_alts] = sym_alts,
  [sym_exp_case] = sym_exp_case,
  [sym_exp_lambda_case] = sym_exp_lambda_case,
  [sym_rec] = sym_rec,
  [sym_stmt] = sym_stmt,
  [sym__do_keyword] = sym__do_keyword,
  [sym_do_module] = sym_do_module,
  [sym_exp_do] = sym_exp_do,
  [sym_exp_negation] = sym_exp_negation,
  [sym_exp_record] = sym_exp_record,
  [sym_exp_name] = sym_exp_name,
  [sym_exp_projection_selector] = sym_exp_projection_selector,
  [sym__aexp_projection] = sym__aexp_projection,
  [sym_exp_projection] = sym_exp_projection,
  [sym__aexp] = sym__aexp,
  [sym__exp_apply] = sym__exp_apply,
  [sym__fexp] = sym__fexp,
  [sym__lexp] = sym__lexp,
  [sym_exp_infix] = sym_exp_infix,
  [sym__exp_infix] = sym__exp_infix,
  [sym__exp] = sym__exp,
  [sym_pat_field] = sym_pat_field,
  [sym_pat_fields] = sym_pat_fields,
  [sym_pat_as] = sym_pat_as,
  [sym_pat_parens] = sym_pat_parens,
  [sym_pat_view] = sym_pat_view,
  [sym_pat_tuple] = sym_pat_tuple,
  [sym_pat_unboxed_tuple] = sym_pat_unboxed_tuple,
  [sym__pat_unboxed_sum] = sym__pat_unboxed_sum,
  [sym_pat_unboxed_sum] = sym_pat_unboxed_sum,
  [sym_pat_list] = sym_pat_list,
  [sym_pat_strict] = sym_pat_strict,
  [sym_pat_irrefutable] = sym_pat_irrefutable,
  [sym_pat_negation] = sym_pat_negation,
  [sym_pat_name] = sym_pat_name,
  [sym__pat_constructor] = sym__pat_constructor,
  [sym_pat_wildcard] = sym_pat_wildcard,
  [sym_pat_record] = sym_pat_record,
  [sym__apat] = sym__apat,
  [sym_pat_apply] = sym_pat_apply,
  [sym__lpat] = sym__lpat,
  [sym_pat_infix] = sym_pat_infix,
  [sym__pat] = sym__pat,
  [sym_pat_typed] = sym_pat_typed,
  [sym__typed_pat] = sym__typed_pat,
  [sym__nested_pat] = sym__nested_pat,
  [sym__import_name] = sym__import_name,
  [sym_namespace] = sym_namespace,
  [sym_import_con_names] = sym_import_con_names,
  [sym_import_item] = sym_import_item,
  [sym_import_list] = sym_import_list,
  [sym_decl_import] = sym_decl_import,
  [sym__modid] = sym__modid,
  [aux_sym__qualifying_module] = aux_sym__qualifying_module,
  [sym_qualified_module] = sym_qualified_module,
  [sym__qmodid] = sym__qmodid,
  [sym_export_names] = sym_export_names,
  [sym_export] = sym_export,
  [sym_exports] = sym_exports,
  [sym__module] = sym__module,
  [sym_field] = sym_field,
  [sym_data_constructor] = sym_data_constructor,
  [sym_data_constructor_infix] = sym_data_constructor_infix,
  [sym__record_field] = sym__record_field,
  [sym_record_fields] = sym_record_fields,
  [sym_data_constructor_record] = sym_data_constructor_record,
  [sym_constructors] = sym_constructors,
  [sym_via] = sym_via,
  [sym_deriving_strategy] = sym_deriving_strategy,
  [sym_deriving] = sym_deriving,
  [sym__adt_rhs] = sym__adt_rhs,
  [sym__gadt_fun] = sym__type_fun,
  [sym__gadt_sig] = sym__gadt_sig,
  [sym__gadt_constr_type] = sym__gadt_constr_type,
  [sym_gadt_constructor] = sym_gadt_constructor,
  [sym__gadt_rhs] = sym__gadt_rhs,
  [sym__adt] = sym__adt,
  [sym_decl_adt] = sym_decl_adt,
  [sym_newtype_constructor] = sym_newtype_constructor,
  [sym__newtype] = sym__newtype,
  [sym__context_newtype] = sym__context_newtype,
  [sym_decl_newtype] = sym_decl_newtype,
  [sym_decl_datafam] = sym_decl_datafam,
  [sym__datainst] = sym__datainst,
  [sym_decl_datainst] = sym_decl_datainst,
  [sym_default_signature] = sym_default_signature,
  [sym_class_datafam] = sym_decl_datafam,
  [sym_class_tyfam] = sym_decl_tyfam,
  [sym__cdecl] = sym__cdecl,
  [sym_fundep] = sym_fundep,
  [sym_fundeps] = sym_fundeps,
  [sym_class_body] = sym_class_body,
  [sym_decl_class] = sym_decl_class,
  [sym_inst_datainst] = sym_inst_datainst,
  [sym_inst_tyinst] = sym_inst_tyinst,
  [sym__idecl] = sym__idecl,
  [sym__instance] = sym__instance,
  [sym_decl_instance] = sym_decl_instance,
  [sym_decl_deriving] = sym_decl_deriving,
  [sym__funpat_infix] = sym__funpat_infix,
  [sym__funpat] = sym_function,
  [sym__fun_name] = sym__fun_name,
  [sym_guard_equation] = sym_guard_equation,
  [aux_sym__fun_guards] = aux_sym__fun_guards,
  [sym__funrhs] = sym__funrhs,
  [aux_sym__fun_patterns] = aux_sym__fun_patterns,
  [sym__funvar] = sym__funvar,
  [sym__funlhs] = sym__funlhs,
  [sym_function] = sym_function,
  [sym_fixity] = sym_fixity,
  [sym_signature] = sym_signature,
  [sym__gendecl] = sym__gendecl,
  [sym__decl_fun] = sym__decl_fun,
  [sym__decl] = sym__decl,
  [sym_decls] = sym_decls,
  [sym_calling_convention] = sym_calling_convention,
  [sym_safety] = sym_safety,
  [sym_impent] = sym_impent,
  [sym_expent] = sym_expent,
  [sym__foreign_pre] = sym__foreign_pre,
  [sym_decl_foreign_import] = sym_decl_foreign_import,
  [sym_decl_foreign_export] = sym_decl_foreign_export,
  [sym__decl_foreign] = sym__decl_foreign,
  [sym__pattern_type] = sym_signature,
  [sym__pattern_equals] = sym_tyfam_eq,
  [sym__pattern_decl] = sym__pattern_decl,
  [sym__pattern_arrow] = sym_tyfam_eq,
  [sym_decl_pattern] = sym_decl_pattern,
  [sym_decl_default] = sym_decl_default,
  [sym__splice_exp] = sym__splice_exp,
  [sym_splice] = sym_splice,
  [sym_top_splice] = sym_top_splice,
  [sym_quasiquote] = sym_quasiquote,
  [aux_sym_haskell_repeat1] = aux_sym_haskell_repeat1,
  [aux_sym_con_tuple_repeat1] = aux_sym_con_tuple_repeat1,
  [aux_sym__forall_repeat1] = aux_sym__forall_repeat1,
  [aux_sym_type_list_repeat1] = aux_sym_type_list_repeat1,
  [aux_sym__type_sum_repeat1] = aux_sym__type_sum_repeat1,
  [aux_sym_type_apply_repeat1] = aux_sym_type_apply_repeat1,
  [aux_sym__context_constraints_repeat1] = aux_sym__context_constraints_repeat1,
  [aux_sym_tyfam_injectivity_repeat1] = aux_sym_tyfam_injectivity_repeat1,
  [aux_sym_decl_tyfam_repeat1] = aux_sym_decl_tyfam_repeat1,
  [aux_sym_decl_tyfam_repeat2] = aux_sym_decl_tyfam_repeat2,
  [aux_sym_decl_role_repeat1] = aux_sym_decl_role_repeat1,
  [aux_sym__exp_tuple_repeat1] = aux_sym__exp_tuple_repeat1,
  [aux_sym__exp_unboxed_sum_repeat1] = aux_sym__exp_unboxed_sum_repeat1,
  [aux_sym_exp_list_repeat1] = aux_sym_exp_list_repeat1,
  [aux_sym_exp_list_comprehension_repeat1] = aux_sym_exp_list_comprehension_repeat1,
  [aux_sym_exp_field_repeat1] = aux_sym_exp_field_repeat1,
  [aux_sym_exp_lambda_repeat1] = aux_sym_exp_lambda_repeat1,
  [aux_sym__let_decls_repeat1] = aux_sym__let_decls_repeat1,
  [aux_sym__let_decls_repeat2] = aux_sym__let_decls_repeat2,
  [aux_sym_exp_if_guard_repeat1] = aux_sym_exp_if_guard_repeat1,
  [aux_sym_guards_repeat1] = aux_sym_guards_repeat1,
  [aux_sym_alts_repeat1] = aux_sym_alts_repeat1,
  [aux_sym_alts_repeat2] = aux_sym_alts_repeat2,
  [aux_sym_rec_repeat1] = aux_sym_rec_repeat1,
  [aux_sym_rec_repeat2] = aux_sym_rec_repeat2,
  [aux_sym_exp_record_repeat1] = aux_sym_exp_record_repeat1,
  [aux_sym_exp_projection_selector_repeat1] = aux_sym_exp_projection_selector_repeat1,
  [aux_sym_pat_fields_repeat1] = aux_sym_pat_fields_repeat1,
  [aux_sym_pat_tuple_repeat1] = aux_sym_pat_tuple_repeat1,
  [aux_sym__pat_unboxed_sum_repeat1] = aux_sym__pat_unboxed_sum_repeat1,
  [aux_sym_import_con_names_repeat1] = aux_sym_import_con_names_repeat1,
  [aux_sym_import_list_repeat1] = aux_sym_import_list_repeat1,
  [aux_sym_export_names_repeat1] = aux_sym_export_names_repeat1,
  [aux_sym_exports_repeat1] = aux_sym_exports_repeat1,
  [aux_sym__module_repeat1] = aux_sym__module_repeat1,
  [aux_sym_field_repeat1] = aux_sym_field_repeat1,
  [aux_sym_data_constructor_repeat1] = aux_sym_data_constructor_repeat1,
  [aux_sym_record_fields_repeat1] = aux_sym_record_fields_repeat1,
  [aux_sym_constructors_repeat1] = aux_sym_constructors_repeat1,
  [aux_sym_deriving_repeat1] = aux_sym_deriving_repeat1,
  [aux_sym__adt_rhs_repeat1] = aux_sym__adt_rhs_repeat1,
  [aux_sym__gadt_rhs_repeat1] = aux_sym__gadt_rhs_repeat1,
  [aux_sym__gadt_rhs_repeat2] = aux_sym__gadt_rhs_repeat2,
  [aux_sym_fundeps_repeat1] = aux_sym_fundeps_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_class_body_repeat2] = aux_sym_class_body_repeat2,
  [aux_sym_decl_instance_repeat1] = aux_sym_decl_instance_repeat1,
  [aux_sym_decl_instance_repeat2] = aux_sym_decl_instance_repeat2,
  [aux_sym_fixity_repeat1] = aux_sym_fixity_repeat1,
  [aux_sym_signature_repeat1] = aux_sym_signature_repeat1,
  [aux_sym__pattern_arrow_repeat1] = aux_sym__pattern_arrow_repeat1,
  [aux_sym__pattern_arrow_repeat2] = aux_sym__pattern_arrow_repeat2,
  [aux_sym_decl_default_repeat1] = aux_sym_decl_default_repeat1,
  [alias_sym_all_names] = alias_sym_all_names,
  [alias_sym_class_head] = alias_sym_class_head,
  [alias_sym_class_name] = alias_sym_class_name,
  [alias_sym_exp_apply] = alias_sym_exp_apply,
  [alias_sym_import_package] = alias_sym_import_package,
  [alias_sym_instance_head] = alias_sym_instance_head,
  [alias_sym_module] = alias_sym_module,
  [alias_sym_pat_literal] = alias_sym_pat_literal,
  [alias_sym_patterns] = alias_sym_patterns,
  [alias_sym_quoter] = alias_sym_quoter,
  [alias_sym_type] = alias_sym_type,
  [alias_sym_wildcard] = alias_sym_wildcard,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__varid] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_char] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym__integer_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__octal_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__hex_literal] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LPAREN_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_POUND_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_3] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_4] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [sym__immediate_dot] = {
    .visible = false,
    .named = true,
  },
  [sym_pragma] = {
    .visible = true,
    .named = true,
  },
  [sym__immediate_varid] = {
    .visible = true,
    .named = true,
  },
  [sym_label] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_implicit_parid] = {
    .visible = true,
    .named = true,
  },
  [sym__conid] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_forall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_5] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_6] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_family] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instance] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_representational] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nominal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_phantom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_role] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thengroupby] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_thengroupusing] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mdo] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pattern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hiding] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_qualified] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_via] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stock] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_newtype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_anyclass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_deriving] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_data] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infixl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infixr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_infix] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ccall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_cplusplus] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_jvm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dotnet] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_prim] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_capi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_safe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interruptible] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreign] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_7] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_8] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__token1] = {
    .visible = false,
    .named = false,
  },
  [sym__layout_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__layout_start] = {
    .visible = false,
    .named = true,
  },
  [sym__layout_end] = {
    .visible = false,
    .named = true,
  },
  [sym__dot] = {
    .visible = false,
    .named = true,
  },
  [sym__arith_dotdot] = {
    .visible = false,
    .named = true,
  },
  [sym_where] = {
    .visible = true,
    .named = true,
  },
  [sym__splice_dollar] = {
    .visible = false,
    .named = true,
  },
  [sym__varsym] = {
    .visible = false,
    .named = true,
  },
  [sym__consym] = {
    .visible = false,
    .named = true,
  },
  [sym__tyconsym] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_cpp] = {
    .visible = true,
    .named = true,
  },
  [sym_comma] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote_start] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote_bar] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote_body] = {
    .visible = true,
    .named = true,
  },
  [sym__strict] = {
    .visible = false,
    .named = true,
  },
  [sym__lazy] = {
    .visible = false,
    .named = true,
  },
  [sym__unboxed_close] = {
    .visible = false,
    .named = true,
  },
  [sym_empty_file] = {
    .visible = true,
    .named = true,
  },
  [sym_haskell] = {
    .visible = true,
    .named = true,
  },
  [sym__topdecl] = {
    .visible = false,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym__unboxed_open] = {
    .visible = false,
    .named = true,
  },
  [sym__carrow] = {
    .visible = false,
    .named = true,
  },
  [sym__arrow] = {
    .visible = false,
    .named = true,
  },
  [sym__larrow] = {
    .visible = false,
    .named = true,
  },
  [sym__colon2] = {
    .visible = false,
    .named = true,
  },
  [sym_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__immediate_variable] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__minus] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_varop] = {
    .visible = true,
    .named = true,
  },
  [sym__qvarop] = {
    .visible = false,
    .named = true,
  },
  [sym__qvarop_nominus] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_constructor_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__qcon] = {
    .visible = false,
    .named = true,
  },
  [sym__qop] = {
    .visible = false,
    .named = true,
  },
  [sym_con_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_con_list] = {
    .visible = true,
    .named = true,
  },
  [sym_con_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym__type_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_qualified_type_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__qualified_type_operator] = {
    .visible = false,
    .named = true,
  },
  [sym__ticked_tycon] = {
    .visible = true,
    .named = true,
  },
  [sym__ticked_qtycon] = {
    .visible = true,
    .named = true,
  },
  [sym__qtyconops] = {
    .visible = false,
    .named = true,
  },
  [sym__promoted_tyconop] = {
    .visible = true,
    .named = true,
  },
  [sym__qtyconop] = {
    .visible = false,
    .named = true,
  },
  [sym_tycon_arrow] = {
    .visible = true,
    .named = true,
  },
  [sym_type_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__promoted_tycon] = {
    .visible = true,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym_type_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_annotated_type_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__forall_kw] = {
    .visible = false,
    .named = true,
  },
  [sym__forall_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__forall] = {
    .visible = true,
    .named = true,
  },
  [sym_forall] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_type_list] = {
    .visible = true,
    .named = true,
  },
  [sym__type_tuple] = {
    .visible = false,
    .named = true,
  },
  [sym_type_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym__type_sum] = {
    .visible = false,
    .named = true,
  },
  [sym__type_promotable_literal] = {
    .visible = false,
    .named = true,
  },
  [sym__type_promoted_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__type_literal] = {
    .visible = false,
    .named = true,
  },
  [sym_strict_type] = {
    .visible = true,
    .named = true,
  },
  [sym_lazy_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_star] = {
    .visible = true,
    .named = true,
  },
  [sym_type_unboxed_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_type_unboxed_sum] = {
    .visible = true,
    .named = true,
  },
  [sym__atype] = {
    .visible = false,
    .named = true,
  },
  [sym_type_apply] = {
    .visible = true,
    .named = true,
  },
  [sym__btype] = {
    .visible = false,
    .named = true,
  },
  [sym_implicit_param] = {
    .visible = true,
    .named = true,
  },
  [sym_type_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__type_infix] = {
    .visible = false,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym__quantified_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym__constraint_context] = {
    .visible = true,
    .named = true,
  },
  [sym__constraint] = {
    .visible = false,
    .named = true,
  },
  [sym__context_constraints] = {
    .visible = false,
    .named = true,
  },
  [sym__context] = {
    .visible = false,
    .named = true,
  },
  [sym_context] = {
    .visible = true,
    .named = true,
  },
  [sym__type_quantifiers] = {
    .visible = true,
    .named = true,
  },
  [sym__type_context] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym__fun_arrow] = {
    .visible = false,
    .named = true,
  },
  [sym__type_fun] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym__type_or_implicit] = {
    .visible = false,
    .named = true,
  },
  [sym__type_annotation] = {
    .visible = false,
    .named = true,
  },
  [sym__simpletype_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__simpletype] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tyfam_head] = {
    .visible = true,
    .named = true,
  },
  [sym_tyfam_pat] = {
    .visible = true,
    .named = true,
  },
  [sym_tyfam_eq] = {
    .visible = true,
    .named = true,
  },
  [sym_tyfam_result_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tyfam_injectivity] = {
    .visible = true,
    .named = true,
  },
  [sym__tyfam_inj] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_tyfam] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_tyinst] = {
    .visible = true,
    .named = true,
  },
  [sym_type_role] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_role] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_tuple] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_unboxed_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_unboxed_sum] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_unboxed_sum] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_list] = {
    .visible = true,
    .named = true,
  },
  [sym_bind_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_arithmetic_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_transform] = {
    .visible = true,
    .named = true,
  },
  [sym_qual] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_section_left] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_section_right] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_th_quoted_name] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_field] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_type_application] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_in] = {
    .visible = true,
    .named = true,
  },
  [sym_let] = {
    .visible = true,
    .named = true,
  },
  [sym__let_decls] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_let] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_let_in] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_cond] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_if_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_guards] = {
    .visible = true,
    .named = true,
  },
  [sym_gdpat] = {
    .visible = true,
    .named = true,
  },
  [sym__alt_variants] = {
    .visible = false,
    .named = true,
  },
  [sym_alt] = {
    .visible = true,
    .named = true,
  },
  [sym_alts] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_case] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_lambda_case] = {
    .visible = true,
    .named = true,
  },
  [sym_rec] = {
    .visible = true,
    .named = true,
  },
  [sym_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__do_keyword] = {
    .visible = false,
    .named = true,
  },
  [sym_do_module] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_do] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_record] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_name] = {
    .visible = true,
    .named = true,
  },
  [sym_exp_projection_selector] = {
    .visible = true,
    .named = true,
  },
  [sym__aexp_projection] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_projection] = {
    .visible = true,
    .named = true,
  },
  [sym__aexp] = {
    .visible = false,
    .named = true,
  },
  [sym__exp_apply] = {
    .visible = false,
    .named = true,
  },
  [sym__fexp] = {
    .visible = false,
    .named = true,
  },
  [sym__lexp] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__exp_infix] = {
    .visible = false,
    .named = true,
  },
  [sym__exp] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_field] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_as] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_view] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_unboxed_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_unboxed_sum] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_unboxed_sum] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_list] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_strict] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_irrefutable] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_negation] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_name] = {
    .visible = true,
    .named = true,
  },
  [sym__pat_constructor] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym_pat_record] = {
    .visible = true,
    .named = true,
  },
  [sym__apat] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_apply] = {
    .visible = true,
    .named = true,
  },
  [sym__lpat] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__pat] = {
    .visible = false,
    .named = true,
  },
  [sym_pat_typed] = {
    .visible = true,
    .named = true,
  },
  [sym__typed_pat] = {
    .visible = false,
    .named = true,
  },
  [sym__nested_pat] = {
    .visible = false,
    .named = true,
  },
  [sym__import_name] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace] = {
    .visible = true,
    .named = true,
  },
  [sym_import_con_names] = {
    .visible = true,
    .named = true,
  },
  [sym_import_item] = {
    .visible = true,
    .named = true,
  },
  [sym_import_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_import] = {
    .visible = true,
    .named = true,
  },
  [sym__modid] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__qualifying_module] = {
    .visible = false,
    .named = false,
  },
  [sym_qualified_module] = {
    .visible = true,
    .named = true,
  },
  [sym__qmodid] = {
    .visible = false,
    .named = true,
  },
  [sym_export_names] = {
    .visible = true,
    .named = true,
  },
  [sym_export] = {
    .visible = true,
    .named = true,
  },
  [sym_exports] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_field] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__record_field] = {
    .visible = false,
    .named = true,
  },
  [sym_record_fields] = {
    .visible = true,
    .named = true,
  },
  [sym_data_constructor_record] = {
    .visible = true,
    .named = true,
  },
  [sym_constructors] = {
    .visible = true,
    .named = true,
  },
  [sym_via] = {
    .visible = true,
    .named = true,
  },
  [sym_deriving_strategy] = {
    .visible = true,
    .named = true,
  },
  [sym_deriving] = {
    .visible = true,
    .named = true,
  },
  [sym__adt_rhs] = {
    .visible = false,
    .named = true,
  },
  [sym__gadt_fun] = {
    .visible = true,
    .named = true,
  },
  [sym__gadt_sig] = {
    .visible = false,
    .named = true,
  },
  [sym__gadt_constr_type] = {
    .visible = false,
    .named = true,
  },
  [sym_gadt_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym__gadt_rhs] = {
    .visible = false,
    .named = true,
  },
  [sym__adt] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_adt] = {
    .visible = true,
    .named = true,
  },
  [sym_newtype_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym__newtype] = {
    .visible = false,
    .named = true,
  },
  [sym__context_newtype] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_newtype] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_datafam] = {
    .visible = true,
    .named = true,
  },
  [sym__datainst] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_datainst] = {
    .visible = true,
    .named = true,
  },
  [sym_default_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_class_datafam] = {
    .visible = true,
    .named = true,
  },
  [sym_class_tyfam] = {
    .visible = true,
    .named = true,
  },
  [sym__cdecl] = {
    .visible = false,
    .named = true,
  },
  [sym_fundep] = {
    .visible = true,
    .named = true,
  },
  [sym_fundeps] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_class] = {
    .visible = true,
    .named = true,
  },
  [sym_inst_datainst] = {
    .visible = true,
    .named = true,
  },
  [sym_inst_tyinst] = {
    .visible = true,
    .named = true,
  },
  [sym__idecl] = {
    .visible = false,
    .named = true,
  },
  [sym__instance] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_instance] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_deriving] = {
    .visible = true,
    .named = true,
  },
  [sym__funpat_infix] = {
    .visible = true,
    .named = true,
  },
  [sym__funpat] = {
    .visible = true,
    .named = true,
  },
  [sym__fun_name] = {
    .visible = false,
    .named = true,
  },
  [sym_guard_equation] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__fun_guards] = {
    .visible = false,
    .named = false,
  },
  [sym__funrhs] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__fun_patterns] = {
    .visible = false,
    .named = false,
  },
  [sym__funvar] = {
    .visible = false,
    .named = true,
  },
  [sym__funlhs] = {
    .visible = false,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_fixity] = {
    .visible = true,
    .named = true,
  },
  [sym_signature] = {
    .visible = true,
    .named = true,
  },
  [sym__gendecl] = {
    .visible = false,
    .named = true,
  },
  [sym__decl_fun] = {
    .visible = false,
    .named = true,
  },
  [sym__decl] = {
    .visible = false,
    .named = true,
  },
  [sym_decls] = {
    .visible = true,
    .named = true,
  },
  [sym_calling_convention] = {
    .visible = true,
    .named = true,
  },
  [sym_safety] = {
    .visible = true,
    .named = true,
  },
  [sym_impent] = {
    .visible = true,
    .named = true,
  },
  [sym_expent] = {
    .visible = true,
    .named = true,
  },
  [sym__foreign_pre] = {
    .visible = false,
    .named = true,
  },
  [sym_decl_foreign_import] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_foreign_export] = {
    .visible = true,
    .named = true,
  },
  [sym__decl_foreign] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_type] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_equals] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_decl] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_arrow] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_default] = {
    .visible = true,
    .named = true,
  },
  [sym__splice_exp] = {
    .visible = false,
    .named = true,
  },
  [sym_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_top_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_haskell_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_con_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__forall_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_sum_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_apply_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__context_constraints_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tyfam_injectivity_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_tyfam_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_tyfam_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_role_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exp_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__exp_unboxed_sum_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_list_comprehension_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_field_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_lambda_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__let_decls_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__let_decls_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_if_guard_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_guards_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alts_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_alts_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rec_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rec_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_record_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exp_projection_selector_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pat_fields_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pat_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pat_unboxed_sum_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_con_names_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_names_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_data_constructor_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_fields_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_constructors_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_deriving_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__adt_rhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__gadt_rhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__gadt_rhs_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_fundeps_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_instance_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_instance_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_fixity_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_signature_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pattern_arrow_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pattern_arrow_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_default_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_all_names] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_class_head] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_class_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_exp_apply] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_package] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_instance_head] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_module] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pat_literal] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_patterns] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_quoter] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_wildcard] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_class = 1,
  field_con = 2,
  field_else = 3,
  field_field = 4,
  field_fields = 5,
  field_from = 6,
  field_if = 7,
  field_infix = 8,
  field_left = 9,
  field_lhs = 10,
  field_module = 11,
  field_name = 12,
  field_op = 13,
  field_pat = 14,
  field_pattern = 15,
  field_patterns = 16,
  field_rhs = 17,
  field_right = 18,
  field_step = 19,
  field_subfield = 20,
  field_then = 21,
  field_to = 22,
  field_type = 23,
  field_var = 24,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_class] = "class",
  [field_con] = "con",
  [field_else] = "else",
  [field_field] = "field",
  [field_fields] = "fields",
  [field_from] = "from",
  [field_if] = "if",
  [field_infix] = "infix",
  [field_left] = "left",
  [field_lhs] = "lhs",
  [field_module] = "module",
  [field_name] = "name",
  [field_op] = "op",
  [field_pat] = "pat",
  [field_pattern] = "pattern",
  [field_patterns] = "patterns",
  [field_rhs] = "rhs",
  [field_right] = "right",
  [field_step] = "step",
  [field_subfield] = "subfield",
  [field_then] = "then",
  [field_to] = "to",
  [field_type] = "type",
  [field_var] = "var",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [6] = {.index = 1, .length = 1},
  [7] = {.index = 2, .length = 4},
  [8] = {.index = 6, .length = 3},
  [9] = {.index = 9, .length = 1},
  [10] = {.index = 10, .length = 2},
  [12] = {.index = 0, .length = 1},
  [14] = {.index = 12, .length = 1},
  [16] = {.index = 13, .length = 1},
  [17] = {.index = 14, .length = 2},
  [18] = {.index = 16, .length = 3},
  [19] = {.index = 19, .length = 1},
  [21] = {.index = 20, .length = 1},
  [22] = {.index = 21, .length = 3},
  [23] = {.index = 24, .length = 2},
  [24] = {.index = 26, .length = 2},
  [25] = {.index = 28, .length = 3},
  [26] = {.index = 31, .length = 2},
  [27] = {.index = 33, .length = 5},
  [28] = {.index = 38, .length = 3},
  [29] = {.index = 41, .length = 1},
  [30] = {.index = 42, .length = 2},
  [34] = {.index = 44, .length = 1},
  [35] = {.index = 45, .length = 1},
  [37] = {.index = 46, .length = 2},
  [38] = {.index = 48, .length = 1},
  [39] = {.index = 49, .length = 2},
  [40] = {.index = 51, .length = 1},
  [41] = {.index = 52, .length = 5},
  [42] = {.index = 57, .length = 2},
  [43] = {.index = 59, .length = 1},
  [45] = {.index = 60, .length = 1},
  [46] = {.index = 61, .length = 3},
  [47] = {.index = 64, .length = 2},
  [49] = {.index = 66, .length = 5},
  [50] = {.index = 71, .length = 2},
  [51] = {.index = 73, .length = 2},
  [52] = {.index = 75, .length = 2},
  [53] = {.index = 77, .length = 1},
  [55] = {.index = 78, .length = 1},
  [56] = {.index = 79, .length = 2},
  [58] = {.index = 81, .length = 3},
  [59] = {.index = 84, .length = 2},
  [61] = {.index = 86, .length = 1},
  [62] = {.index = 86, .length = 1},
  [63] = {.index = 87, .length = 2},
  [64] = {.index = 89, .length = 1},
  [65] = {.index = 90, .length = 2},
  [66] = {.index = 92, .length = 2},
  [67] = {.index = 94, .length = 7},
  [68] = {.index = 101, .length = 3},
  [69] = {.index = 104, .length = 4},
  [70] = {.index = 108, .length = 2},
  [71] = {.index = 110, .length = 1},
  [72] = {.index = 110, .length = 1},
  [74] = {.index = 111, .length = 3},
  [75] = {.index = 114, .length = 3},
  [76] = {.index = 117, .length = 1},
  [77] = {.index = 118, .length = 2},
  [78] = {.index = 120, .length = 2},
  [79] = {.index = 122, .length = 4},
  [80] = {.index = 126, .length = 6},
  [81] = {.index = 132, .length = 4},
  [82] = {.index = 136, .length = 3},
  [83] = {.index = 139, .length = 6},
  [84] = {.index = 145, .length = 2},
  [85] = {.index = 147, .length = 6},
  [86] = {.index = 153, .length = 6},
  [88] = {.index = 159, .length = 2},
  [89] = {.index = 161, .length = 2},
  [90] = {.index = 163, .length = 1},
  [91] = {.index = 164, .length = 4},
  [92] = {.index = 168, .length = 1},
  [93] = {.index = 169, .length = 6},
  [94] = {.index = 175, .length = 2},
  [95] = {.index = 177, .length = 4},
  [96] = {.index = 181, .length = 2},
  [97] = {.index = 183, .length = 5},
  [98] = {.index = 188, .length = 6},
  [99] = {.index = 194, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_module, 0, .inherited = true},
  [2] =
    {field_infix, 0},
    {field_lhs, 0, .inherited = true},
    {field_op, 0, .inherited = true},
    {field_rhs, 0, .inherited = true},
  [6] =
    {field_pattern, 0, .inherited = true},
    {field_rhs, 0, .inherited = true},
    {field_type, 0, .inherited = true},
  [9] =
    {field_name, 0, .inherited = true},
  [10] =
    {field_name, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
  [12] =
    {field_class, 0},
  [13] =
    {field_type, 1, .inherited = true},
  [14] =
    {field_lhs, 1, .inherited = true},
    {field_rhs, 1, .inherited = true},
  [16] =
    {field_lhs, 1, .inherited = true},
    {field_rhs, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [19] =
    {field_name, 1, .inherited = true},
  [20] =
    {field_type, 0, .inherited = true},
  [21] =
    {field_name, 0},
    {field_type, 1},
    {field_type, 1, .inherited = true},
  [24] =
    {field_con, 0},
    {field_fields, 1},
  [26] =
    {field_pattern, 0},
    {field_type, 1, .inherited = true},
  [28] =
    {field_pattern, 0},
    {field_rhs, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [31] =
    {field_name, 0, .inherited = true},
    {field_patterns, 1},
  [33] =
    {field_infix, 0, .inherited = true},
    {field_name, 0, .inherited = true},
    {field_patterns, 0, .inherited = true},
    {field_rhs, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [38] =
    {field_name, 0},
    {field_name, 1},
    {field_name, 2},
  [41] =
    {field_name, 2, .inherited = true},
  [42] =
    {field_name, 1, .inherited = true},
    {field_type, 2, .inherited = true},
  [44] =
    {field_module, 1},
  [45] =
    {field_type, 2, .inherited = true},
  [46] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [48] =
    {field_name, 1},
  [49] =
    {field_pat, 2},
    {field_var, 0},
  [51] =
    {field_type, 1},
  [52] =
    {field_lhs, 1},
    {field_name, 0},
    {field_name, 1, .inherited = true},
    {field_type, 2},
    {field_type, 2, .inherited = true},
  [57] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [59] =
    {field_field, 2},
  [60] =
    {field_field, 0},
  [61] =
    {field_lhs, 0},
    {field_op, 1},
    {field_rhs, 2},
  [64] =
    {field_rhs, 1},
    {field_type, 1, .inherited = true},
  [66] =
    {field_name, 0},
    {field_name, 1},
    {field_name, 2},
    {field_type, 3},
    {field_type, 3, .inherited = true},
  [71] =
    {field_type, 0, .inherited = true},
    {field_type, 2, .inherited = true},
  [73] =
    {field_type, 1, .inherited = true},
    {field_type, 2, .inherited = true},
  [75] =
    {field_from, 1},
    {field_type, 1, .inherited = true},
  [77] =
    {field_type, 3, .inherited = true},
  [78] =
    {field_name, 3, .inherited = true},
  [79] =
    {field_name, 2, .inherited = true},
    {field_type, 3, .inherited = true},
  [81] =
    {field_left, 0},
    {field_op, 1},
    {field_right, 2},
  [84] =
    {field_lhs, 0},
    {field_rhs, 2},
  [86] =
    {field_class, 1},
  [87] =
    {field_field, 0},
    {field_subfield, 1, .inherited = true},
  [89] =
    {field_field, 1},
  [90] =
    {field_field, 2},
    {field_field, 3, .inherited = true},
  [92] =
    {field_field, 0, .inherited = true},
    {field_field, 1, .inherited = true},
  [94] =
    {field_lhs, 3},
    {field_name, 0},
    {field_name, 1},
    {field_name, 2},
    {field_name, 3, .inherited = true},
    {field_type, 4},
    {field_type, 4, .inherited = true},
  [101] =
    {field_type, 0, .inherited = true},
    {field_type, 2, .inherited = true},
    {field_type, 3, .inherited = true},
  [104] =
    {field_from, 1},
    {field_to, 3},
    {field_type, 1, .inherited = true},
    {field_type, 3, .inherited = true},
  [108] =
    {field_name, 3, .inherited = true},
    {field_type, 4, .inherited = true},
  [110] =
    {field_class, 2},
  [111] =
    {field_name, 1},
    {field_name, 2},
    {field_name, 3},
  [114] =
    {field_field, 0},
    {field_field, 1},
    {field_field, 2},
  [117] =
    {field_subfield, 1},
  [118] =
    {field_field, 0},
    {field_type, 2, .inherited = true},
  [120] =
    {field_subfield, 0, .inherited = true},
    {field_subfield, 1, .inherited = true},
  [122] =
    {field_from, 1},
    {field_step, 3},
    {field_type, 1, .inherited = true},
    {field_type, 3, .inherited = true},
  [126] =
    {field_else, 5},
    {field_if, 1},
    {field_then, 3},
    {field_type, 1, .inherited = true},
    {field_type, 3, .inherited = true},
    {field_type, 5, .inherited = true},
  [132] =
    {field_field, 0},
    {field_field, 1},
    {field_field, 2},
    {field_subfield, 3, .inherited = true},
  [136] =
    {field_field, 0},
    {field_subfield, 1, .inherited = true},
    {field_type, 3, .inherited = true},
  [139] =
    {field_from, 1},
    {field_step, 3},
    {field_to, 5},
    {field_type, 1, .inherited = true},
    {field_type, 3, .inherited = true},
    {field_type, 5, .inherited = true},
  [145] =
    {field_type, 1, .inherited = true},
    {field_type, 3, .inherited = true},
  [147] =
    {field_else, 6},
    {field_if, 1},
    {field_then, 4},
    {field_type, 1, .inherited = true},
    {field_type, 4, .inherited = true},
    {field_type, 6, .inherited = true},
  [153] =
    {field_else, 6},
    {field_if, 1},
    {field_then, 3},
    {field_type, 1, .inherited = true},
    {field_type, 3, .inherited = true},
    {field_type, 6, .inherited = true},
  [159] =
    {field_class, 2},
    {field_class, 3, .inherited = true},
  [161] =
    {field_class, 0, .inherited = true},
    {field_class, 1, .inherited = true},
  [163] =
    {field_class, 3},
  [164] =
    {field_field, 0},
    {field_field, 1},
    {field_field, 2},
    {field_type, 4, .inherited = true},
  [168] =
    {field_op, 1},
  [169] =
    {field_else, 7},
    {field_if, 1},
    {field_then, 4},
    {field_type, 1, .inherited = true},
    {field_type, 4, .inherited = true},
    {field_type, 7, .inherited = true},
  [175] =
    {field_rhs, 1, .inherited = true},
    {field_type, 1, .inherited = true},
  [177] =
    {field_lhs, 0},
    {field_rhs, 2},
    {field_rhs, 5, .inherited = true},
    {field_type, 5, .inherited = true},
  [181] =
    {field_class, 3},
    {field_class, 4, .inherited = true},
  [183] =
    {field_field, 0},
    {field_field, 1},
    {field_field, 2},
    {field_subfield, 3, .inherited = true},
    {field_type, 5, .inherited = true},
  [188] =
    {field_lhs, 0},
    {field_rhs, 2},
    {field_rhs, 5, .inherited = true},
    {field_rhs, 6, .inherited = true},
    {field_type, 5, .inherited = true},
    {field_type, 6, .inherited = true},
  [194] =
    {field_rhs, 0, .inherited = true},
    {field_rhs, 1, .inherited = true},
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [0] = alias_sym_module,
  },
  [3] = {
    [0] = sym_pat_name,
  },
  [4] = {
    [0] = alias_sym_pat_literal,
  },
  [5] = {
    [0] = alias_sym_exp_apply,
  },
  [11] = {
    [0] = sym_operator,
  },
  [12] = {
    [0] = alias_sym_type,
  },
  [13] = {
    [0] = alias_sym_type,
  },
  [14] = {
    [0] = alias_sym_class_name,
  },
  [15] = {
    [1] = alias_sym_instance_head,
  },
  [20] = {
    [1] = alias_sym_class_head,
  },
  [26] = {
    [1] = alias_sym_patterns,
  },
  [31] = {
    [1] = alias_sym_type,
  },
  [32] = {
    [2] = alias_sym_instance_head,
  },
  [33] = {
    [1] = alias_sym_import_package,
  },
  [36] = {
    [2] = alias_sym_class_head,
  },
  [44] = {
    [0] = alias_sym_wildcard,
  },
  [48] = {
    [1] = alias_sym_quoter,
  },
  [54] = {
    [2] = alias_sym_type,
  },
  [57] = {
    [3] = alias_sym_instance_head,
  },
  [60] = {
    [2] = alias_sym_import_package,
  },
  [61] = {
    [1] = alias_sym_type,
  },
  [71] = {
    [2] = alias_sym_type,
  },
  [73] = {
    [0] = sym_decl_tyinst,
  },
  [87] = {
    [1] = alias_sym_all_names,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_constructor, 3,
    sym_constructor,
    alias_sym_module,
    alias_sym_type,
  sym__qcon, 2,
    sym__qcon,
    sym_pat_name,
  sym_literal, 2,
    sym_literal,
    alias_sym_pat_literal,
  sym_type_name, 2,
    sym_type_name,
    alias_sym_class_name,
  sym_constraint, 3,
    sym_constraint,
    alias_sym_class_head,
    alias_sym_instance_head,
  sym__exp_apply, 2,
    sym__exp_apply,
    alias_sym_exp_apply,
  sym_inst_tyinst, 2,
    sym_inst_tyinst,
    sym_decl_tyinst,
  aux_sym__fun_patterns, 2,
    aux_sym__fun_patterns,
    alias_sym_patterns,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 14,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 17,
  [20] = 17,
  [21] = 18,
  [22] = 17,
  [23] = 17,
  [24] = 17,
  [25] = 17,
  [26] = 17,
  [27] = 17,
  [28] = 17,
  [29] = 17,
  [30] = 17,
  [31] = 17,
  [32] = 17,
  [33] = 17,
  [34] = 17,
  [35] = 17,
  [36] = 17,
  [37] = 17,
  [38] = 17,
  [39] = 17,
  [40] = 17,
  [41] = 18,
  [42] = 17,
  [43] = 17,
  [44] = 17,
  [45] = 45,
  [46] = 45,
  [47] = 47,
  [48] = 45,
  [49] = 45,
  [50] = 45,
  [51] = 45,
  [52] = 45,
  [53] = 45,
  [54] = 54,
  [55] = 47,
  [56] = 47,
  [57] = 45,
  [58] = 45,
  [59] = 45,
  [60] = 45,
  [61] = 47,
  [62] = 54,
  [63] = 45,
  [64] = 45,
  [65] = 45,
  [66] = 45,
  [67] = 45,
  [68] = 45,
  [69] = 45,
  [70] = 45,
  [71] = 45,
  [72] = 45,
  [73] = 45,
  [74] = 45,
  [75] = 45,
  [76] = 45,
  [77] = 45,
  [78] = 45,
  [79] = 47,
  [80] = 47,
  [81] = 45,
  [82] = 45,
  [83] = 45,
  [84] = 45,
  [85] = 45,
  [86] = 54,
  [87] = 45,
  [88] = 45,
  [89] = 45,
  [90] = 45,
  [91] = 45,
  [92] = 45,
  [93] = 45,
  [94] = 45,
  [95] = 95,
  [96] = 95,
  [97] = 95,
  [98] = 95,
  [99] = 95,
  [100] = 95,
  [101] = 95,
  [102] = 95,
  [103] = 95,
  [104] = 95,
  [105] = 95,
  [106] = 95,
  [107] = 95,
  [108] = 95,
  [109] = 95,
  [110] = 95,
  [111] = 95,
  [112] = 95,
  [113] = 95,
  [114] = 95,
  [115] = 95,
  [116] = 95,
  [117] = 95,
  [118] = 95,
  [119] = 95,
  [120] = 95,
  [121] = 95,
  [122] = 95,
  [123] = 123,
  [124] = 124,
  [125] = 124,
  [126] = 124,
  [127] = 124,
  [128] = 123,
  [129] = 123,
  [130] = 124,
  [131] = 131,
  [132] = 123,
  [133] = 124,
  [134] = 123,
  [135] = 124,
  [136] = 124,
  [137] = 123,
  [138] = 124,
  [139] = 123,
  [140] = 123,
  [141] = 123,
  [142] = 123,
  [143] = 124,
  [144] = 123,
  [145] = 124,
  [146] = 124,
  [147] = 123,
  [148] = 124,
  [149] = 124,
  [150] = 124,
  [151] = 123,
  [152] = 124,
  [153] = 124,
  [154] = 123,
  [155] = 124,
  [156] = 123,
  [157] = 123,
  [158] = 124,
  [159] = 124,
  [160] = 124,
  [161] = 124,
  [162] = 123,
  [163] = 124,
  [164] = 124,
  [165] = 124,
  [166] = 124,
  [167] = 124,
  [168] = 123,
  [169] = 124,
  [170] = 123,
  [171] = 124,
  [172] = 123,
  [173] = 123,
  [174] = 124,
  [175] = 124,
  [176] = 123,
  [177] = 124,
  [178] = 123,
  [179] = 124,
  [180] = 124,
  [181] = 123,
  [182] = 124,
  [183] = 123,
  [184] = 123,
  [185] = 123,
  [186] = 124,
  [187] = 123,
  [188] = 124,
  [189] = 123,
  [190] = 124,
  [191] = 123,
  [192] = 131,
  [193] = 123,
  [194] = 124,
  [195] = 123,
  [196] = 124,
  [197] = 124,
  [198] = 123,
  [199] = 123,
  [200] = 123,
  [201] = 124,
  [202] = 123,
  [203] = 123,
  [204] = 123,
  [205] = 124,
  [206] = 123,
  [207] = 123,
  [208] = 208,
  [209] = 123,
  [210] = 123,
  [211] = 123,
  [212] = 124,
  [213] = 123,
  [214] = 124,
  [215] = 123,
  [216] = 124,
  [217] = 123,
  [218] = 218,
  [219] = 219,
  [220] = 218,
  [221] = 221,
  [222] = 222,
  [223] = 219,
  [224] = 218,
  [225] = 221,
  [226] = 218,
  [227] = 218,
  [228] = 218,
  [229] = 219,
  [230] = 222,
  [231] = 221,
  [232] = 222,
  [233] = 233,
  [234] = 221,
  [235] = 222,
  [236] = 236,
  [237] = 221,
  [238] = 219,
  [239] = 233,
  [240] = 233,
  [241] = 221,
  [242] = 236,
  [243] = 233,
  [244] = 236,
  [245] = 218,
  [246] = 236,
  [247] = 222,
  [248] = 219,
  [249] = 219,
  [250] = 221,
  [251] = 222,
  [252] = 233,
  [253] = 218,
  [254] = 219,
  [255] = 233,
  [256] = 221,
  [257] = 222,
  [258] = 221,
  [259] = 221,
  [260] = 218,
  [261] = 233,
  [262] = 233,
  [263] = 236,
  [264] = 222,
  [265] = 219,
  [266] = 218,
  [267] = 218,
  [268] = 218,
  [269] = 221,
  [270] = 219,
  [271] = 222,
  [272] = 233,
  [273] = 221,
  [274] = 233,
  [275] = 219,
  [276] = 221,
  [277] = 221,
  [278] = 221,
  [279] = 219,
  [280] = 233,
  [281] = 233,
  [282] = 221,
  [283] = 221,
  [284] = 236,
  [285] = 218,
  [286] = 222,
  [287] = 233,
  [288] = 219,
  [289] = 218,
  [290] = 233,
  [291] = 219,
  [292] = 233,
  [293] = 222,
  [294] = 222,
  [295] = 219,
  [296] = 222,
  [297] = 218,
  [298] = 222,
  [299] = 233,
  [300] = 300,
  [301] = 218,
  [302] = 221,
  [303] = 222,
  [304] = 218,
  [305] = 222,
  [306] = 219,
  [307] = 218,
  [308] = 218,
  [309] = 219,
  [310] = 222,
  [311] = 311,
  [312] = 221,
  [313] = 218,
  [314] = 219,
  [315] = 236,
  [316] = 236,
  [317] = 218,
  [318] = 222,
  [319] = 233,
  [320] = 218,
  [321] = 300,
  [322] = 219,
  [323] = 311,
  [324] = 222,
  [325] = 222,
  [326] = 233,
  [327] = 221,
  [328] = 219,
  [329] = 219,
  [330] = 233,
  [331] = 221,
  [332] = 221,
  [333] = 233,
  [334] = 219,
  [335] = 236,
  [336] = 236,
  [337] = 233,
  [338] = 219,
  [339] = 221,
  [340] = 233,
  [341] = 219,
  [342] = 222,
  [343] = 219,
  [344] = 222,
  [345] = 222,
  [346] = 222,
  [347] = 218,
  [348] = 222,
  [349] = 221,
  [350] = 236,
  [351] = 233,
  [352] = 222,
  [353] = 218,
  [354] = 236,
  [355] = 218,
  [356] = 219,
  [357] = 219,
  [358] = 219,
  [359] = 359,
  [360] = 221,
  [361] = 222,
  [362] = 233,
  [363] = 219,
  [364] = 221,
  [365] = 222,
  [366] = 236,
  [367] = 236,
  [368] = 218,
  [369] = 218,
  [370] = 233,
  [371] = 371,
  [372] = 221,
  [373] = 218,
  [374] = 233,
  [375] = 218,
  [376] = 233,
  [377] = 218,
  [378] = 219,
  [379] = 222,
  [380] = 218,
  [381] = 222,
  [382] = 218,
  [383] = 233,
  [384] = 233,
  [385] = 221,
  [386] = 219,
  [387] = 233,
  [388] = 219,
  [389] = 219,
  [390] = 221,
  [391] = 219,
  [392] = 236,
  [393] = 219,
  [394] = 222,
  [395] = 218,
  [396] = 222,
  [397] = 233,
  [398] = 221,
  [399] = 221,
  [400] = 400,
  [401] = 222,
  [402] = 222,
  [403] = 219,
  [404] = 222,
  [405] = 218,
  [406] = 222,
  [407] = 221,
  [408] = 218,
  [409] = 222,
  [410] = 222,
  [411] = 219,
  [412] = 233,
  [413] = 219,
  [414] = 221,
  [415] = 359,
  [416] = 236,
  [417] = 236,
  [418] = 219,
  [419] = 233,
  [420] = 222,
  [421] = 218,
  [422] = 222,
  [423] = 236,
  [424] = 218,
  [425] = 219,
  [426] = 221,
  [427] = 233,
  [428] = 222,
  [429] = 371,
  [430] = 233,
  [431] = 400,
  [432] = 221,
  [433] = 219,
  [434] = 221,
  [435] = 233,
  [436] = 221,
  [437] = 233,
  [438] = 218,
  [439] = 219,
  [440] = 222,
  [441] = 233,
  [442] = 221,
  [443] = 233,
  [444] = 221,
  [445] = 233,
  [446] = 233,
  [447] = 221,
  [448] = 236,
  [449] = 221,
  [450] = 218,
  [451] = 219,
  [452] = 218,
  [453] = 222,
  [454] = 221,
  [455] = 219,
  [456] = 236,
  [457] = 222,
  [458] = 222,
  [459] = 236,
  [460] = 218,
  [461] = 236,
  [462] = 236,
  [463] = 236,
  [464] = 221,
  [465] = 219,
  [466] = 221,
  [467] = 233,
  [468] = 233,
  [469] = 218,
  [470] = 221,
  [471] = 233,
  [472] = 233,
  [473] = 236,
  [474] = 219,
  [475] = 236,
  [476] = 236,
  [477] = 218,
  [478] = 219,
  [479] = 218,
  [480] = 222,
  [481] = 236,
  [482] = 218,
  [483] = 221,
  [484] = 218,
  [485] = 233,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 490,
  [492] = 490,
  [493] = 490,
  [494] = 494,
  [495] = 494,
  [496] = 494,
  [497] = 490,
  [498] = 490,
  [499] = 494,
  [500] = 494,
  [501] = 494,
  [502] = 494,
  [503] = 490,
  [504] = 494,
  [505] = 490,
  [506] = 494,
  [507] = 494,
  [508] = 494,
  [509] = 490,
  [510] = 490,
  [511] = 490,
  [512] = 494,
  [513] = 494,
  [514] = 490,
  [515] = 490,
  [516] = 490,
  [517] = 494,
  [518] = 494,
  [519] = 494,
  [520] = 490,
  [521] = 494,
  [522] = 494,
  [523] = 490,
  [524] = 490,
  [525] = 490,
  [526] = 494,
  [527] = 494,
  [528] = 490,
  [529] = 490,
  [530] = 490,
  [531] = 494,
  [532] = 494,
  [533] = 494,
  [534] = 494,
  [535] = 490,
  [536] = 494,
  [537] = 490,
  [538] = 490,
  [539] = 490,
  [540] = 494,
  [541] = 490,
  [542] = 494,
  [543] = 490,
  [544] = 494,
  [545] = 490,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 548,
  [551] = 549,
  [552] = 549,
  [553] = 549,
  [554] = 554,
  [555] = 555,
  [556] = 556,
  [557] = 556,
  [558] = 556,
  [559] = 556,
  [560] = 556,
  [561] = 556,
  [562] = 556,
  [563] = 556,
  [564] = 556,
  [565] = 556,
  [566] = 556,
  [567] = 556,
  [568] = 556,
  [569] = 556,
  [570] = 556,
  [571] = 556,
  [572] = 556,
  [573] = 556,
  [574] = 556,
  [575] = 556,
  [576] = 556,
  [577] = 556,
  [578] = 556,
  [579] = 556,
  [580] = 556,
  [581] = 556,
  [582] = 556,
  [583] = 556,
  [584] = 556,
  [585] = 556,
  [586] = 556,
  [587] = 556,
  [588] = 556,
  [589] = 556,
  [590] = 556,
  [591] = 556,
  [592] = 556,
  [593] = 556,
  [594] = 556,
  [595] = 556,
  [596] = 556,
  [597] = 556,
  [598] = 556,
  [599] = 556,
  [600] = 556,
  [601] = 556,
  [602] = 602,
  [603] = 603,
  [604] = 603,
  [605] = 602,
  [606] = 606,
  [607] = 606,
  [608] = 606,
  [609] = 606,
  [610] = 606,
  [611] = 606,
  [612] = 606,
  [613] = 606,
  [614] = 606,
  [615] = 606,
  [616] = 606,
  [617] = 606,
  [618] = 606,
  [619] = 606,
  [620] = 606,
  [621] = 606,
  [622] = 606,
  [623] = 602,
  [624] = 606,
  [625] = 606,
  [626] = 606,
  [627] = 606,
  [628] = 606,
  [629] = 606,
  [630] = 606,
  [631] = 606,
  [632] = 606,
  [633] = 606,
  [634] = 606,
  [635] = 606,
  [636] = 606,
  [637] = 606,
  [638] = 606,
  [639] = 606,
  [640] = 606,
  [641] = 606,
  [642] = 606,
  [643] = 606,
  [644] = 606,
  [645] = 606,
  [646] = 606,
  [647] = 606,
  [648] = 606,
  [649] = 606,
  [650] = 606,
  [651] = 606,
  [652] = 606,
  [653] = 606,
  [654] = 606,
  [655] = 606,
  [656] = 606,
  [657] = 606,
  [658] = 606,
  [659] = 606,
  [660] = 606,
  [661] = 606,
  [662] = 606,
  [663] = 606,
  [664] = 606,
  [665] = 606,
  [666] = 606,
  [667] = 606,
  [668] = 606,
  [669] = 606,
  [670] = 606,
  [671] = 606,
  [672] = 606,
  [673] = 606,
  [674] = 606,
  [675] = 606,
  [676] = 606,
  [677] = 606,
  [678] = 606,
  [679] = 606,
  [680] = 606,
  [681] = 606,
  [682] = 606,
  [683] = 606,
  [684] = 606,
  [685] = 606,
  [686] = 606,
  [687] = 606,
  [688] = 606,
  [689] = 606,
  [690] = 606,
  [691] = 606,
  [692] = 606,
  [693] = 606,
  [694] = 606,
  [695] = 603,
  [696] = 606,
  [697] = 606,
  [698] = 606,
  [699] = 606,
  [700] = 606,
  [701] = 606,
  [702] = 606,
  [703] = 606,
  [704] = 606,
  [705] = 606,
  [706] = 606,
  [707] = 606,
  [708] = 606,
  [709] = 606,
  [710] = 606,
  [711] = 606,
  [712] = 606,
  [713] = 606,
  [714] = 606,
  [715] = 606,
  [716] = 606,
  [717] = 606,
  [718] = 606,
  [719] = 606,
  [720] = 606,
  [721] = 606,
  [722] = 606,
  [723] = 606,
  [724] = 606,
  [725] = 606,
  [726] = 606,
  [727] = 606,
  [728] = 606,
  [729] = 606,
  [730] = 606,
  [731] = 606,
  [732] = 606,
  [733] = 606,
  [734] = 606,
  [735] = 606,
  [736] = 606,
  [737] = 606,
  [738] = 606,
  [739] = 606,
  [740] = 606,
  [741] = 606,
  [742] = 606,
  [743] = 606,
  [744] = 606,
  [745] = 606,
  [746] = 746,
  [747] = 746,
  [748] = 746,
  [749] = 746,
  [750] = 746,
  [751] = 746,
  [752] = 752,
  [753] = 746,
  [754] = 746,
  [755] = 746,
  [756] = 746,
  [757] = 746,
  [758] = 758,
  [759] = 746,
  [760] = 746,
  [761] = 746,
  [762] = 746,
  [763] = 603,
  [764] = 752,
  [765] = 746,
  [766] = 746,
  [767] = 603,
  [768] = 602,
  [769] = 746,
  [770] = 746,
  [771] = 746,
  [772] = 752,
  [773] = 746,
  [774] = 746,
  [775] = 746,
  [776] = 746,
  [777] = 746,
  [778] = 746,
  [779] = 746,
  [780] = 746,
  [781] = 746,
  [782] = 746,
  [783] = 746,
  [784] = 746,
  [785] = 746,
  [786] = 746,
  [787] = 746,
  [788] = 746,
  [789] = 752,
  [790] = 746,
  [791] = 746,
  [792] = 746,
  [793] = 602,
  [794] = 746,
  [795] = 746,
  [796] = 746,
  [797] = 746,
  [798] = 746,
  [799] = 746,
  [800] = 746,
  [801] = 603,
  [802] = 602,
  [803] = 803,
  [804] = 803,
  [805] = 805,
  [806] = 805,
  [807] = 805,
  [808] = 803,
  [809] = 805,
  [810] = 810,
  [811] = 805,
  [812] = 803,
  [813] = 805,
  [814] = 805,
  [815] = 803,
  [816] = 805,
  [817] = 805,
  [818] = 805,
  [819] = 805,
  [820] = 803,
  [821] = 803,
  [822] = 803,
  [823] = 805,
  [824] = 805,
  [825] = 803,
  [826] = 805,
  [827] = 803,
  [828] = 603,
  [829] = 805,
  [830] = 805,
  [831] = 803,
  [832] = 803,
  [833] = 805,
  [834] = 805,
  [835] = 805,
  [836] = 805,
  [837] = 803,
  [838] = 805,
  [839] = 805,
  [840] = 805,
  [841] = 805,
  [842] = 803,
  [843] = 805,
  [844] = 805,
  [845] = 805,
  [846] = 805,
  [847] = 805,
  [848] = 805,
  [849] = 805,
  [850] = 805,
  [851] = 805,
  [852] = 805,
  [853] = 805,
  [854] = 805,
  [855] = 805,
  [856] = 805,
  [857] = 803,
  [858] = 803,
  [859] = 803,
  [860] = 805,
  [861] = 805,
  [862] = 803,
  [863] = 803,
  [864] = 805,
  [865] = 602,
  [866] = 805,
  [867] = 803,
  [868] = 602,
  [869] = 805,
  [870] = 603,
  [871] = 602,
  [872] = 803,
  [873] = 603,
  [874] = 805,
  [875] = 603,
  [876] = 805,
  [877] = 805,
  [878] = 805,
  [879] = 602,
  [880] = 805,
  [881] = 803,
  [882] = 603,
  [883] = 805,
  [884] = 805,
  [885] = 810,
  [886] = 805,
  [887] = 602,
  [888] = 805,
  [889] = 805,
  [890] = 803,
  [891] = 891,
  [892] = 602,
  [893] = 891,
  [894] = 602,
  [895] = 891,
  [896] = 602,
  [897] = 891,
  [898] = 898,
  [899] = 891,
  [900] = 891,
  [901] = 603,
  [902] = 891,
  [903] = 891,
  [904] = 891,
  [905] = 891,
  [906] = 891,
  [907] = 891,
  [908] = 891,
  [909] = 891,
  [910] = 891,
  [911] = 891,
  [912] = 891,
  [913] = 891,
  [914] = 891,
  [915] = 891,
  [916] = 602,
  [917] = 603,
  [918] = 891,
  [919] = 891,
  [920] = 891,
  [921] = 891,
  [922] = 602,
  [923] = 898,
  [924] = 603,
  [925] = 891,
  [926] = 891,
  [927] = 891,
  [928] = 891,
  [929] = 891,
  [930] = 891,
  [931] = 891,
  [932] = 891,
  [933] = 891,
  [934] = 891,
  [935] = 603,
  [936] = 891,
  [937] = 602,
  [938] = 891,
  [939] = 891,
  [940] = 891,
  [941] = 891,
  [942] = 891,
  [943] = 603,
  [944] = 891,
  [945] = 891,
  [946] = 946,
  [947] = 603,
  [948] = 603,
  [949] = 602,
  [950] = 602,
  [951] = 891,
  [952] = 603,
  [953] = 891,
  [954] = 891,
  [955] = 891,
  [956] = 603,
  [957] = 602,
  [958] = 603,
  [959] = 959,
  [960] = 602,
  [961] = 961,
  [962] = 961,
  [963] = 602,
  [964] = 603,
  [965] = 965,
  [966] = 965,
  [967] = 967,
  [968] = 965,
  [969] = 965,
  [970] = 970,
  [971] = 965,
  [972] = 965,
  [973] = 973,
  [974] = 974,
  [975] = 974,
  [976] = 974,
  [977] = 973,
  [978] = 967,
  [979] = 970,
  [980] = 965,
  [981] = 981,
  [982] = 981,
  [983] = 970,
  [984] = 965,
  [985] = 973,
  [986] = 981,
  [987] = 965,
  [988] = 967,
  [989] = 973,
  [990] = 967,
  [991] = 974,
  [992] = 965,
  [993] = 965,
  [994] = 965,
  [995] = 970,
  [996] = 981,
  [997] = 970,
  [998] = 981,
  [999] = 965,
  [1000] = 974,
  [1001] = 965,
  [1002] = 967,
  [1003] = 974,
  [1004] = 965,
  [1005] = 965,
  [1006] = 973,
  [1007] = 967,
  [1008] = 965,
  [1009] = 981,
  [1010] = 970,
  [1011] = 974,
  [1012] = 965,
  [1013] = 970,
  [1014] = 981,
  [1015] = 974,
  [1016] = 965,
  [1017] = 967,
  [1018] = 973,
  [1019] = 965,
  [1020] = 965,
  [1021] = 973,
  [1022] = 965,
  [1023] = 965,
  [1024] = 965,
  [1025] = 965,
  [1026] = 970,
  [1027] = 973,
  [1028] = 965,
  [1029] = 967,
  [1030] = 965,
  [1031] = 981,
  [1032] = 970,
  [1033] = 974,
  [1034] = 965,
  [1035] = 970,
  [1036] = 974,
  [1037] = 981,
  [1038] = 965,
  [1039] = 967,
  [1040] = 981,
  [1041] = 970,
  [1042] = 965,
  [1043] = 973,
  [1044] = 967,
  [1045] = 967,
  [1046] = 965,
  [1047] = 973,
  [1048] = 973,
  [1049] = 967,
  [1050] = 965,
  [1051] = 981,
  [1052] = 973,
  [1053] = 973,
  [1054] = 965,
  [1055] = 965,
  [1056] = 965,
  [1057] = 965,
  [1058] = 965,
  [1059] = 965,
  [1060] = 965,
  [1061] = 974,
  [1062] = 970,
  [1063] = 981,
  [1064] = 965,
  [1065] = 974,
  [1066] = 974,
  [1067] = 981,
  [1068] = 970,
  [1069] = 967,
  [1070] = 965,
  [1071] = 974,
  [1072] = 981,
  [1073] = 967,
  [1074] = 973,
  [1075] = 965,
  [1076] = 965,
  [1077] = 970,
  [1078] = 981,
  [1079] = 965,
  [1080] = 965,
  [1081] = 965,
  [1082] = 970,
  [1083] = 965,
  [1084] = 965,
  [1085] = 965,
  [1086] = 967,
  [1087] = 974,
  [1088] = 974,
  [1089] = 965,
  [1090] = 965,
  [1091] = 974,
  [1092] = 981,
  [1093] = 970,
  [1094] = 965,
  [1095] = 973,
  [1096] = 970,
  [1097] = 981,
  [1098] = 965,
  [1099] = 981,
  [1100] = 970,
  [1101] = 965,
  [1102] = 965,
  [1103] = 967,
  [1104] = 965,
  [1105] = 967,
  [1106] = 973,
  [1107] = 967,
  [1108] = 973,
  [1109] = 973,
  [1110] = 974,
  [1111] = 965,
  [1112] = 974,
  [1113] = 965,
  [1114] = 973,
  [1115] = 965,
  [1116] = 965,
  [1117] = 965,
  [1118] = 974,
  [1119] = 965,
  [1120] = 965,
  [1121] = 973,
  [1122] = 974,
  [1123] = 967,
  [1124] = 965,
  [1125] = 967,
  [1126] = 981,
  [1127] = 981,
  [1128] = 970,
  [1129] = 965,
  [1130] = 981,
  [1131] = 970,
  [1132] = 965,
  [1133] = 970,
  [1134] = 970,
  [1135] = 974,
  [1136] = 970,
  [1137] = 965,
  [1138] = 967,
  [1139] = 973,
  [1140] = 981,
  [1141] = 970,
  [1142] = 965,
  [1143] = 981,
  [1144] = 974,
  [1145] = 981,
  [1146] = 970,
  [1147] = 981,
  [1148] = 965,
  [1149] = 967,
  [1150] = 965,
  [1151] = 973,
  [1152] = 965,
  [1153] = 965,
  [1154] = 974,
  [1155] = 973,
  [1156] = 974,
  [1157] = 970,
  [1158] = 965,
  [1159] = 981,
  [1160] = 970,
  [1161] = 967,
  [1162] = 973,
  [1163] = 965,
  [1164] = 967,
  [1165] = 973,
  [1166] = 965,
  [1167] = 965,
  [1168] = 965,
  [1169] = 965,
  [1170] = 967,
  [1171] = 973,
  [1172] = 965,
  [1173] = 965,
  [1174] = 965,
  [1175] = 965,
  [1176] = 974,
  [1177] = 967,
  [1178] = 974,
  [1179] = 965,
  [1180] = 965,
  [1181] = 973,
  [1182] = 967,
  [1183] = 981,
  [1184] = 970,
  [1185] = 965,
  [1186] = 973,
  [1187] = 967,
  [1188] = 981,
  [1189] = 970,
  [1190] = 965,
  [1191] = 965,
  [1192] = 981,
  [1193] = 967,
  [1194] = 973,
  [1195] = 981,
  [1196] = 967,
  [1197] = 965,
  [1198] = 974,
  [1199] = 973,
  [1200] = 970,
  [1201] = 981,
  [1202] = 965,
  [1203] = 965,
  [1204] = 974,
  [1205] = 965,
  [1206] = 970,
  [1207] = 965,
  [1208] = 965,
  [1209] = 981,
  [1210] = 970,
  [1211] = 965,
  [1212] = 974,
  [1213] = 974,
  [1214] = 981,
  [1215] = 965,
  [1216] = 970,
  [1217] = 967,
  [1218] = 981,
  [1219] = 981,
  [1220] = 965,
  [1221] = 970,
  [1222] = 974,
  [1223] = 965,
  [1224] = 974,
  [1225] = 965,
  [1226] = 974,
  [1227] = 965,
  [1228] = 965,
  [1229] = 965,
  [1230] = 974,
  [1231] = 967,
  [1232] = 965,
  [1233] = 965,
  [1234] = 973,
  [1235] = 967,
  [1236] = 965,
  [1237] = 973,
  [1238] = 965,
  [1239] = 965,
  [1240] = 981,
  [1241] = 970,
  [1242] = 973,
  [1243] = 967,
  [1244] = 967,
  [1245] = 970,
  [1246] = 965,
  [1247] = 981,
  [1248] = 973,
  [1249] = 974,
  [1250] = 965,
  [1251] = 965,
  [1252] = 965,
  [1253] = 965,
  [1254] = 970,
  [1255] = 981,
  [1256] = 973,
  [1257] = 974,
  [1258] = 965,
  [1259] = 974,
  [1260] = 965,
  [1261] = 965,
  [1262] = 965,
  [1263] = 965,
  [1264] = 965,
  [1265] = 981,
  [1266] = 970,
  [1267] = 974,
  [1268] = 974,
  [1269] = 974,
  [1270] = 981,
  [1271] = 967,
  [1272] = 970,
  [1273] = 967,
  [1274] = 973,
  [1275] = 973,
  [1276] = 973,
  [1277] = 967,
  [1278] = 973,
  [1279] = 973,
  [1280] = 967,
  [1281] = 967,
  [1282] = 981,
  [1283] = 603,
  [1284] = 970,
  [1285] = 967,
  [1286] = 965,
  [1287] = 970,
  [1288] = 981,
  [1289] = 970,
  [1290] = 981,
  [1291] = 981,
  [1292] = 973,
  [1293] = 973,
  [1294] = 974,
  [1295] = 967,
  [1296] = 974,
  [1297] = 965,
  [1298] = 967,
  [1299] = 965,
  [1300] = 973,
  [1301] = 974,
  [1302] = 965,
  [1303] = 602,
  [1304] = 965,
  [1305] = 974,
  [1306] = 981,
  [1307] = 970,
  [1308] = 967,
  [1309] = 973,
  [1310] = 970,
  [1311] = 981,
  [1312] = 974,
  [1313] = 970,
  [1314] = 967,
  [1315] = 973,
  [1316] = 970,
  [1317] = 973,
  [1318] = 967,
  [1319] = 1319,
  [1320] = 1320,
  [1321] = 1321,
  [1322] = 1322,
  [1323] = 1323,
  [1324] = 1319,
  [1325] = 1325,
  [1326] = 1323,
  [1327] = 1327,
  [1328] = 1320,
  [1329] = 1329,
  [1330] = 1323,
  [1331] = 1323,
  [1332] = 1323,
  [1333] = 1320,
  [1334] = 1323,
  [1335] = 1335,
  [1336] = 1323,
  [1337] = 1323,
  [1338] = 1323,
  [1339] = 1323,
  [1340] = 1323,
  [1341] = 1323,
  [1342] = 1323,
  [1343] = 1323,
  [1344] = 1323,
  [1345] = 1320,
  [1346] = 1323,
  [1347] = 1323,
  [1348] = 1323,
  [1349] = 1327,
  [1350] = 1323,
  [1351] = 1319,
  [1352] = 1322,
  [1353] = 1321,
  [1354] = 1323,
  [1355] = 1329,
  [1356] = 1323,
  [1357] = 1320,
  [1358] = 1325,
  [1359] = 1323,
  [1360] = 1323,
  [1361] = 1361,
  [1362] = 1323,
  [1363] = 1361,
  [1364] = 1323,
  [1365] = 1325,
  [1366] = 1361,
  [1367] = 1323,
  [1368] = 1361,
  [1369] = 1325,
  [1370] = 1323,
  [1371] = 1329,
  [1372] = 1372,
  [1373] = 1321,
  [1374] = 1322,
  [1375] = 1329,
  [1376] = 1319,
  [1377] = 1327,
  [1378] = 1321,
  [1379] = 1361,
  [1380] = 1322,
  [1381] = 1319,
  [1382] = 1327,
  [1383] = 1323,
  [1384] = 1384,
  [1385] = 1361,
  [1386] = 1323,
  [1387] = 1361,
  [1388] = 1320,
  [1389] = 1323,
  [1390] = 1361,
  [1391] = 1323,
  [1392] = 1323,
  [1393] = 1320,
  [1394] = 1323,
  [1395] = 1361,
  [1396] = 1323,
  [1397] = 1361,
  [1398] = 1323,
  [1399] = 1361,
  [1400] = 1400,
  [1401] = 1323,
  [1402] = 1361,
  [1403] = 1320,
  [1404] = 1320,
  [1405] = 1323,
  [1406] = 1327,
  [1407] = 1319,
  [1408] = 1322,
  [1409] = 1320,
  [1410] = 1321,
  [1411] = 1327,
  [1412] = 1320,
  [1413] = 1329,
  [1414] = 1325,
  [1415] = 1361,
  [1416] = 1416,
  [1417] = 1323,
  [1418] = 1361,
  [1419] = 1323,
  [1420] = 1361,
  [1421] = 1323,
  [1422] = 1361,
  [1423] = 1323,
  [1424] = 1361,
  [1425] = 1323,
  [1426] = 1361,
  [1427] = 1323,
  [1428] = 1361,
  [1429] = 1320,
  [1430] = 1323,
  [1431] = 1361,
  [1432] = 1325,
  [1433] = 1329,
  [1434] = 1320,
  [1435] = 1321,
  [1436] = 1322,
  [1437] = 1319,
  [1438] = 1327,
  [1439] = 1361,
  [1440] = 1320,
  [1441] = 1361,
  [1442] = 1327,
  [1443] = 1320,
  [1444] = 1319,
  [1445] = 1322,
  [1446] = 1321,
  [1447] = 1372,
  [1448] = 1329,
  [1449] = 1320,
  [1450] = 1320,
  [1451] = 1325,
  [1452] = 1323,
  [1453] = 1325,
  [1454] = 1325,
  [1455] = 1361,
  [1456] = 1456,
  [1457] = 1320,
  [1458] = 1325,
  [1459] = 1329,
  [1460] = 1320,
  [1461] = 1321,
  [1462] = 1456,
  [1463] = 1320,
  [1464] = 1322,
  [1465] = 1319,
  [1466] = 1327,
  [1467] = 1320,
  [1468] = 1320,
  [1469] = 1320,
  [1470] = 1327,
  [1471] = 1319,
  [1472] = 1322,
  [1473] = 1320,
  [1474] = 1321,
  [1475] = 1475,
  [1476] = 1372,
  [1477] = 1329,
  [1478] = 1325,
  [1479] = 1320,
  [1480] = 1323,
  [1481] = 1320,
  [1482] = 1320,
  [1483] = 1483,
  [1484] = 1327,
  [1485] = 1319,
  [1486] = 1322,
  [1487] = 1321,
  [1488] = 1372,
  [1489] = 1329,
  [1490] = 1325,
  [1491] = 1329,
  [1492] = 1321,
  [1493] = 1322,
  [1494] = 1319,
  [1495] = 1325,
  [1496] = 1320,
  [1497] = 1327,
  [1498] = 1320,
  [1499] = 1327,
  [1500] = 1329,
  [1501] = 1320,
  [1502] = 1400,
  [1503] = 1320,
  [1504] = 1372,
  [1505] = 1505,
  [1506] = 1320,
  [1507] = 1322,
  [1508] = 1325,
  [1509] = 1320,
  [1510] = 1329,
  [1511] = 1372,
  [1512] = 1321,
  [1513] = 1320,
  [1514] = 1320,
  [1515] = 1329,
  [1516] = 1322,
  [1517] = 1325,
  [1518] = 1319,
  [1519] = 1327,
  [1520] = 1320,
  [1521] = 1335,
  [1522] = 1372,
  [1523] = 1320,
  [1524] = 1505,
  [1525] = 1320,
  [1526] = 1329,
  [1527] = 1372,
  [1528] = 1321,
  [1529] = 1322,
  [1530] = 1319,
  [1531] = 1327,
  [1532] = 1320,
  [1533] = 1533,
  [1534] = 1320,
  [1535] = 1319,
  [1536] = 1322,
  [1537] = 1320,
  [1538] = 1320,
  [1539] = 1321,
  [1540] = 1456,
  [1541] = 1327,
  [1542] = 1319,
  [1543] = 1322,
  [1544] = 1321,
  [1545] = 1372,
  [1546] = 1335,
  [1547] = 1329,
  [1548] = 1320,
  [1549] = 1325,
  [1550] = 1325,
  [1551] = 1325,
  [1552] = 1329,
  [1553] = 1321,
  [1554] = 1320,
  [1555] = 1322,
  [1556] = 1556,
  [1557] = 1327,
  [1558] = 1319,
  [1559] = 1319,
  [1560] = 1505,
  [1561] = 1327,
  [1562] = 1562,
  [1563] = 1321,
  [1564] = 1372,
  [1565] = 1320,
  [1566] = 1475,
  [1567] = 1505,
  [1568] = 1320,
  [1569] = 1320,
  [1570] = 1320,
  [1571] = 1533,
  [1572] = 1320,
  [1573] = 1320,
  [1574] = 1335,
  [1575] = 1329,
  [1576] = 1475,
  [1577] = 1322,
  [1578] = 1475,
  [1579] = 1320,
  [1580] = 1319,
  [1581] = 1320,
  [1582] = 1533,
  [1583] = 1335,
  [1584] = 1325,
  [1585] = 1329,
  [1586] = 1372,
  [1587] = 1320,
  [1588] = 1321,
  [1589] = 1589,
  [1590] = 1590,
  [1591] = 1505,
  [1592] = 1322,
  [1593] = 1320,
  [1594] = 1320,
  [1595] = 1595,
  [1596] = 1319,
  [1597] = 1327,
  [1598] = 1320,
  [1599] = 1327,
  [1600] = 1329,
  [1601] = 1325,
  [1602] = 1533,
  [1603] = 1533,
  [1604] = 1505,
  [1605] = 1384,
  [1606] = 1335,
  [1607] = 1505,
  [1608] = 1335,
  [1609] = 1533,
  [1610] = 1327,
  [1611] = 1319,
  [1612] = 1533,
  [1613] = 1505,
  [1614] = 1335,
  [1615] = 1615,
  [1616] = 1456,
  [1617] = 1322,
  [1618] = 1321,
  [1619] = 1456,
  [1620] = 1372,
  [1621] = 1329,
  [1622] = 1319,
  [1623] = 1322,
  [1624] = 1325,
  [1625] = 1335,
  [1626] = 1533,
  [1627] = 1320,
  [1628] = 1505,
  [1629] = 1327,
  [1630] = 1320,
  [1631] = 1556,
  [1632] = 1335,
  [1633] = 1319,
  [1634] = 1322,
  [1635] = 1505,
  [1636] = 1321,
  [1637] = 1335,
  [1638] = 1533,
  [1639] = 1320,
  [1640] = 1505,
  [1641] = 1320,
  [1642] = 1335,
  [1643] = 1533,
  [1644] = 1505,
  [1645] = 1505,
  [1646] = 1320,
  [1647] = 1475,
  [1648] = 1533,
  [1649] = 1321,
  [1650] = 1533,
  [1651] = 1320,
  [1652] = 1335,
  [1653] = 1335,
  [1654] = 1533,
  [1655] = 1321,
  [1656] = 1505,
  [1657] = 1657,
  [1658] = 1335,
  [1659] = 1533,
  [1660] = 1505,
  [1661] = 1505,
  [1662] = 1384,
  [1663] = 1335,
  [1664] = 1320,
  [1665] = 1533,
  [1666] = 1533,
  [1667] = 1505,
  [1668] = 1335,
  [1669] = 1335,
  [1670] = 1533,
  [1671] = 1372,
  [1672] = 1505,
  [1673] = 1533,
  [1674] = 1329,
  [1675] = 1505,
  [1676] = 1327,
  [1677] = 1322,
  [1678] = 1321,
  [1679] = 1335,
  [1680] = 1533,
  [1681] = 1533,
  [1682] = 1372,
  [1683] = 1320,
  [1684] = 1320,
  [1685] = 1505,
  [1686] = 1335,
  [1687] = 1335,
  [1688] = 1533,
  [1689] = 1329,
  [1690] = 1320,
  [1691] = 1325,
  [1692] = 1505,
  [1693] = 1325,
  [1694] = 1335,
  [1695] = 1533,
  [1696] = 1505,
  [1697] = 1505,
  [1698] = 1335,
  [1699] = 1533,
  [1700] = 1700,
  [1701] = 1700,
  [1702] = 1702,
  [1703] = 1702,
  [1704] = 1700,
  [1705] = 1702,
  [1706] = 1700,
  [1707] = 1700,
  [1708] = 1708,
  [1709] = 1702,
  [1710] = 1700,
  [1711] = 1702,
  [1712] = 1702,
  [1713] = 1700,
  [1714] = 1702,
  [1715] = 1700,
  [1716] = 1700,
  [1717] = 1702,
  [1718] = 1702,
  [1719] = 1700,
  [1720] = 1702,
  [1721] = 1721,
  [1722] = 1700,
  [1723] = 1700,
  [1724] = 1702,
  [1725] = 1700,
  [1726] = 1702,
  [1727] = 1700,
  [1728] = 1702,
  [1729] = 1702,
  [1730] = 1708,
  [1731] = 1702,
  [1732] = 1700,
  [1733] = 1702,
  [1734] = 1700,
  [1735] = 1700,
  [1736] = 1708,
  [1737] = 1702,
  [1738] = 1702,
  [1739] = 1700,
  [1740] = 1702,
  [1741] = 1700,
  [1742] = 1708,
  [1743] = 1700,
  [1744] = 1702,
  [1745] = 1700,
  [1746] = 1702,
  [1747] = 1700,
  [1748] = 1702,
  [1749] = 1700,
  [1750] = 1702,
  [1751] = 1702,
  [1752] = 1700,
  [1753] = 1702,
  [1754] = 1700,
  [1755] = 1700,
  [1756] = 1700,
  [1757] = 1702,
  [1758] = 1702,
  [1759] = 1700,
  [1760] = 1702,
  [1761] = 1702,
  [1762] = 1700,
  [1763] = 1702,
  [1764] = 1700,
  [1765] = 1700,
  [1766] = 1702,
  [1767] = 1700,
  [1768] = 1702,
  [1769] = 1700,
  [1770] = 1700,
  [1771] = 1702,
  [1772] = 1700,
  [1773] = 1708,
  [1774] = 1702,
  [1775] = 1702,
  [1776] = 1700,
  [1777] = 1702,
  [1778] = 1700,
  [1779] = 1702,
  [1780] = 1708,
  [1781] = 1708,
  [1782] = 1700,
  [1783] = 1702,
  [1784] = 1700,
  [1785] = 1700,
  [1786] = 1702,
  [1787] = 1702,
  [1788] = 1700,
  [1789] = 1702,
  [1790] = 1708,
  [1791] = 1700,
  [1792] = 1702,
  [1793] = 1700,
  [1794] = 1702,
  [1795] = 1700,
  [1796] = 1702,
  [1797] = 1700,
  [1798] = 1702,
  [1799] = 1700,
  [1800] = 1708,
  [1801] = 1708,
  [1802] = 1708,
  [1803] = 1702,
  [1804] = 1708,
  [1805] = 1708,
  [1806] = 1806,
  [1807] = 1806,
  [1808] = 1808,
  [1809] = 1806,
  [1810] = 1808,
  [1811] = 1806,
  [1812] = 1806,
  [1813] = 1806,
  [1814] = 1808,
  [1815] = 1808,
  [1816] = 1806,
  [1817] = 1806,
  [1818] = 1806,
  [1819] = 1806,
  [1820] = 1806,
  [1821] = 1808,
  [1822] = 1806,
  [1823] = 1808,
  [1824] = 1806,
  [1825] = 1806,
  [1826] = 1806,
  [1827] = 1806,
  [1828] = 1808,
  [1829] = 1808,
  [1830] = 1806,
  [1831] = 1806,
  [1832] = 1806,
  [1833] = 1806,
  [1834] = 1808,
  [1835] = 1806,
  [1836] = 1806,
  [1837] = 1806,
  [1838] = 1806,
  [1839] = 1806,
  [1840] = 1808,
  [1841] = 1806,
  [1842] = 1806,
  [1843] = 1806,
  [1844] = 1806,
  [1845] = 1806,
  [1846] = 1808,
  [1847] = 1806,
  [1848] = 1806,
  [1849] = 1806,
  [1850] = 1808,
  [1851] = 1806,
  [1852] = 1806,
  [1853] = 1806,
  [1854] = 1808,
  [1855] = 1806,
  [1856] = 1806,
  [1857] = 1806,
  [1858] = 1808,
  [1859] = 1806,
  [1860] = 1808,
  [1861] = 1806,
  [1862] = 1806,
  [1863] = 1806,
  [1864] = 1806,
  [1865] = 1806,
  [1866] = 1806,
  [1867] = 1808,
  [1868] = 1808,
  [1869] = 1806,
  [1870] = 1806,
  [1871] = 1808,
  [1872] = 1806,
  [1873] = 1806,
  [1874] = 1806,
  [1875] = 1806,
  [1876] = 1808,
  [1877] = 1806,
  [1878] = 1806,
  [1879] = 1806,
  [1880] = 1806,
  [1881] = 1806,
  [1882] = 1806,
  [1883] = 1806,
  [1884] = 1806,
  [1885] = 1808,
  [1886] = 1808,
  [1887] = 1806,
  [1888] = 1808,
  [1889] = 1806,
  [1890] = 1806,
  [1891] = 1806,
  [1892] = 1806,
  [1893] = 1806,
  [1894] = 1808,
  [1895] = 1806,
  [1896] = 1808,
  [1897] = 1806,
  [1898] = 1806,
  [1899] = 1808,
  [1900] = 1806,
  [1901] = 1808,
  [1902] = 1806,
  [1903] = 1806,
  [1904] = 1806,
  [1905] = 1806,
  [1906] = 1808,
  [1907] = 1808,
  [1908] = 1806,
  [1909] = 1806,
  [1910] = 1808,
  [1911] = 1806,
  [1912] = 1808,
  [1913] = 1806,
  [1914] = 1806,
  [1915] = 1806,
  [1916] = 1806,
  [1917] = 1806,
  [1918] = 1806,
  [1919] = 1806,
  [1920] = 1806,
  [1921] = 1808,
  [1922] = 1806,
  [1923] = 1808,
  [1924] = 1806,
  [1925] = 1806,
  [1926] = 1806,
  [1927] = 1806,
  [1928] = 1806,
  [1929] = 1806,
  [1930] = 1808,
  [1931] = 1808,
  [1932] = 1806,
  [1933] = 1806,
  [1934] = 1806,
  [1935] = 1806,
  [1936] = 1808,
  [1937] = 1806,
  [1938] = 1806,
  [1939] = 1806,
  [1940] = 1806,
  [1941] = 1806,
  [1942] = 1806,
  [1943] = 1808,
  [1944] = 1806,
  [1945] = 1806,
  [1946] = 1808,
  [1947] = 1808,
  [1948] = 1806,
  [1949] = 1808,
  [1950] = 1806,
  [1951] = 1806,
  [1952] = 1806,
  [1953] = 1806,
  [1954] = 1808,
  [1955] = 1806,
  [1956] = 1808,
  [1957] = 1806,
  [1958] = 1806,
  [1959] = 1808,
  [1960] = 1808,
  [1961] = 1806,
  [1962] = 1806,
  [1963] = 1806,
  [1964] = 1808,
  [1965] = 1806,
  [1966] = 1806,
  [1967] = 1808,
  [1968] = 1808,
  [1969] = 1806,
  [1970] = 1806,
  [1971] = 1806,
  [1972] = 1806,
  [1973] = 1806,
  [1974] = 1806,
  [1975] = 1975,
  [1976] = 1975,
  [1977] = 1977,
  [1978] = 1977,
  [1979] = 1977,
  [1980] = 1977,
  [1981] = 1977,
  [1982] = 1977,
  [1983] = 1977,
  [1984] = 1977,
  [1985] = 1977,
  [1986] = 1977,
  [1987] = 1977,
  [1988] = 1977,
  [1989] = 1977,
  [1990] = 1977,
  [1991] = 1977,
  [1992] = 1975,
  [1993] = 1977,
  [1994] = 1977,
  [1995] = 1977,
  [1996] = 1977,
  [1997] = 1977,
  [1998] = 1977,
  [1999] = 1977,
  [2000] = 1977,
  [2001] = 2001,
  [2002] = 2002,
  [2003] = 2003,
  [2004] = 2004,
  [2005] = 2004,
  [2006] = 2004,
  [2007] = 2007,
  [2008] = 2007,
  [2009] = 2003,
  [2010] = 2002,
  [2011] = 2001,
  [2012] = 2003,
  [2013] = 2002,
  [2014] = 2007,
  [2015] = 2001,
  [2016] = 2016,
  [2017] = 2017,
  [2018] = 2018,
  [2019] = 2019,
  [2020] = 2019,
  [2021] = 2018,
  [2022] = 2019,
  [2023] = 2023,
  [2024] = 2019,
  [2025] = 2025,
  [2026] = 2025,
  [2027] = 2027,
  [2028] = 2019,
  [2029] = 2029,
  [2030] = 2029,
  [2031] = 2029,
  [2032] = 2027,
  [2033] = 2018,
  [2034] = 2027,
  [2035] = 2025,
  [2036] = 2036,
  [2037] = 2037,
  [2038] = 2038,
  [2039] = 2036,
  [2040] = 2040,
  [2041] = 2041,
  [2042] = 2042,
  [2043] = 2043,
  [2044] = 2044,
  [2045] = 2040,
  [2046] = 2044,
  [2047] = 2047,
  [2048] = 2038,
  [2049] = 2041,
  [2050] = 2043,
  [2051] = 2040,
  [2052] = 2044,
  [2053] = 2053,
  [2054] = 2036,
  [2055] = 2043,
  [2056] = 2038,
  [2057] = 2057,
  [2058] = 2058,
  [2059] = 2059,
  [2060] = 2036,
  [2061] = 2040,
  [2062] = 2038,
  [2063] = 2041,
  [2064] = 2053,
  [2065] = 2065,
  [2066] = 2043,
  [2067] = 2044,
  [2068] = 2038,
  [2069] = 2040,
  [2070] = 2044,
  [2071] = 2043,
  [2072] = 2036,
  [2073] = 2053,
  [2074] = 2074,
  [2075] = 2075,
  [2076] = 2076,
  [2077] = 2076,
  [2078] = 2078,
  [2079] = 2076,
  [2080] = 2042,
  [2081] = 2065,
  [2082] = 2059,
  [2083] = 2037,
  [2084] = 2084,
  [2085] = 2085,
  [2086] = 2084,
  [2087] = 2087,
  [2088] = 2059,
  [2089] = 2037,
  [2090] = 2087,
  [2091] = 2085,
  [2092] = 2084,
  [2093] = 2087,
  [2094] = 2042,
  [2095] = 2065,
  [2096] = 2096,
  [2097] = 2096,
  [2098] = 2096,
  [2099] = 2099,
  [2100] = 2096,
  [2101] = 2096,
  [2102] = 2102,
  [2103] = 2096,
  [2104] = 2096,
  [2105] = 2099,
  [2106] = 2096,
  [2107] = 2107,
  [2108] = 2096,
  [2109] = 2096,
  [2110] = 2096,
  [2111] = 2096,
  [2112] = 2107,
  [2113] = 2096,
  [2114] = 2096,
  [2115] = 2115,
  [2116] = 2116,
  [2117] = 2096,
  [2118] = 2096,
  [2119] = 2096,
  [2120] = 2096,
  [2121] = 2096,
  [2122] = 2096,
  [2123] = 2102,
  [2124] = 2096,
  [2125] = 2096,
  [2126] = 2126,
  [2127] = 2096,
  [2128] = 2096,
  [2129] = 2096,
  [2130] = 2096,
  [2131] = 2096,
  [2132] = 2096,
  [2133] = 2096,
  [2134] = 2115,
  [2135] = 2096,
  [2136] = 2096,
  [2137] = 2096,
  [2138] = 2096,
  [2139] = 2096,
  [2140] = 2096,
  [2141] = 2096,
  [2142] = 2096,
  [2143] = 2096,
  [2144] = 2107,
  [2145] = 2096,
  [2146] = 2096,
  [2147] = 2096,
  [2148] = 2096,
  [2149] = 2126,
  [2150] = 2096,
  [2151] = 2096,
  [2152] = 2102,
  [2153] = 2096,
  [2154] = 2096,
  [2155] = 2096,
  [2156] = 2096,
  [2157] = 2096,
  [2158] = 2096,
  [2159] = 2096,
  [2160] = 2096,
  [2161] = 2096,
  [2162] = 2096,
  [2163] = 2096,
  [2164] = 2096,
  [2165] = 2096,
  [2166] = 2096,
  [2167] = 2096,
  [2168] = 2096,
  [2169] = 2096,
  [2170] = 2096,
  [2171] = 2096,
  [2172] = 2096,
  [2173] = 2096,
  [2174] = 2096,
  [2175] = 2096,
  [2176] = 2096,
  [2177] = 2096,
  [2178] = 2096,
  [2179] = 2096,
  [2180] = 2096,
  [2181] = 2096,
  [2182] = 2096,
  [2183] = 2096,
  [2184] = 2096,
  [2185] = 2096,
  [2186] = 2096,
  [2187] = 2096,
  [2188] = 2096,
  [2189] = 2096,
  [2190] = 2096,
  [2191] = 2096,
  [2192] = 2096,
  [2193] = 2116,
  [2194] = 2096,
  [2195] = 2116,
  [2196] = 2096,
  [2197] = 2096,
  [2198] = 2096,
  [2199] = 2096,
  [2200] = 2096,
  [2201] = 2096,
  [2202] = 2096,
  [2203] = 2096,
  [2204] = 2096,
  [2205] = 2096,
  [2206] = 2096,
  [2207] = 2096,
  [2208] = 2096,
  [2209] = 2096,
  [2210] = 2096,
  [2211] = 2096,
  [2212] = 2096,
  [2213] = 2096,
  [2214] = 2096,
  [2215] = 2096,
  [2216] = 2096,
  [2217] = 2115,
  [2218] = 2096,
  [2219] = 2096,
  [2220] = 2099,
  [2221] = 2096,
  [2222] = 2096,
  [2223] = 2096,
  [2224] = 2126,
  [2225] = 2096,
  [2226] = 2096,
  [2227] = 2096,
  [2228] = 2228,
  [2229] = 2228,
  [2230] = 2228,
  [2231] = 2228,
  [2232] = 2228,
  [2233] = 2228,
  [2234] = 2228,
  [2235] = 2228,
  [2236] = 2228,
  [2237] = 2228,
  [2238] = 2228,
  [2239] = 2228,
  [2240] = 2228,
  [2241] = 2228,
  [2242] = 2228,
  [2243] = 2228,
  [2244] = 2228,
  [2245] = 2228,
  [2246] = 2228,
  [2247] = 2228,
  [2248] = 2228,
  [2249] = 2228,
  [2250] = 2250,
  [2251] = 2228,
  [2252] = 2252,
  [2253] = 2228,
  [2254] = 2228,
  [2255] = 2228,
  [2256] = 2228,
  [2257] = 2228,
  [2258] = 2228,
  [2259] = 2228,
  [2260] = 2228,
  [2261] = 2228,
  [2262] = 2228,
  [2263] = 2228,
  [2264] = 2228,
  [2265] = 2228,
  [2266] = 2228,
  [2267] = 2228,
  [2268] = 2228,
  [2269] = 2228,
  [2270] = 2228,
  [2271] = 2228,
  [2272] = 2228,
  [2273] = 2228,
  [2274] = 2228,
  [2275] = 2228,
  [2276] = 2228,
  [2277] = 2228,
  [2278] = 2228,
  [2279] = 2037,
  [2280] = 2228,
  [2281] = 2228,
  [2282] = 2228,
  [2283] = 2228,
  [2284] = 2228,
  [2285] = 2228,
  [2286] = 2228,
  [2287] = 2228,
  [2288] = 2228,
  [2289] = 2228,
  [2290] = 2228,
  [2291] = 2291,
  [2292] = 2228,
  [2293] = 2228,
  [2294] = 2294,
  [2295] = 2042,
  [2296] = 2228,
  [2297] = 2228,
  [2298] = 2228,
  [2299] = 2228,
  [2300] = 2228,
  [2301] = 2228,
  [2302] = 2228,
  [2303] = 2228,
  [2304] = 2228,
  [2305] = 2228,
  [2306] = 2228,
  [2307] = 2228,
  [2308] = 2228,
  [2309] = 2065,
  [2310] = 2291,
  [2311] = 2228,
  [2312] = 2228,
  [2313] = 2228,
  [2314] = 2228,
  [2315] = 2228,
  [2316] = 2228,
  [2317] = 2228,
  [2318] = 2228,
  [2319] = 2228,
  [2320] = 2228,
  [2321] = 2228,
  [2322] = 2228,
  [2323] = 2228,
  [2324] = 2228,
  [2325] = 2228,
  [2326] = 2228,
  [2327] = 2228,
  [2328] = 2228,
  [2329] = 2037,
  [2330] = 2059,
  [2331] = 2228,
  [2332] = 2228,
  [2333] = 2228,
  [2334] = 2228,
  [2335] = 2228,
  [2336] = 2228,
  [2337] = 2228,
  [2338] = 2228,
  [2339] = 2228,
  [2340] = 2228,
  [2341] = 2228,
  [2342] = 2065,
  [2343] = 2228,
  [2344] = 2228,
  [2345] = 2042,
  [2346] = 2228,
  [2347] = 2228,
  [2348] = 2294,
  [2349] = 2228,
  [2350] = 2228,
  [2351] = 2059,
  [2352] = 2228,
  [2353] = 2228,
  [2354] = 2228,
  [2355] = 2228,
  [2356] = 2356,
  [2357] = 2356,
  [2358] = 2358,
  [2359] = 2356,
  [2360] = 2356,
  [2361] = 2361,
  [2362] = 2362,
  [2363] = 2037,
  [2364] = 2364,
  [2365] = 2356,
  [2366] = 2356,
  [2367] = 2362,
  [2368] = 2368,
  [2369] = 2356,
  [2370] = 2370,
  [2371] = 2356,
  [2372] = 2356,
  [2373] = 2356,
  [2374] = 2362,
  [2375] = 2375,
  [2376] = 2042,
  [2377] = 2356,
  [2378] = 2065,
  [2379] = 2356,
  [2380] = 2370,
  [2381] = 2356,
  [2382] = 2382,
  [2383] = 2356,
  [2384] = 2356,
  [2385] = 2042,
  [2386] = 2358,
  [2387] = 2065,
  [2388] = 2358,
  [2389] = 2059,
  [2390] = 2361,
  [2391] = 2356,
  [2392] = 2037,
  [2393] = 2356,
  [2394] = 2059,
  [2395] = 2356,
  [2396] = 2396,
  [2397] = 2370,
  [2398] = 2356,
  [2399] = 2356,
  [2400] = 2356,
  [2401] = 2356,
  [2402] = 2356,
  [2403] = 2042,
  [2404] = 2356,
  [2405] = 2356,
  [2406] = 2037,
  [2407] = 2356,
  [2408] = 2356,
  [2409] = 2065,
  [2410] = 2037,
  [2411] = 2042,
  [2412] = 2042,
  [2413] = 2065,
  [2414] = 2356,
  [2415] = 2356,
  [2416] = 2356,
  [2417] = 2356,
  [2418] = 2042,
  [2419] = 2375,
  [2420] = 2356,
  [2421] = 2356,
  [2422] = 2065,
  [2423] = 2065,
  [2424] = 2356,
  [2425] = 2059,
  [2426] = 2356,
  [2427] = 2059,
  [2428] = 2364,
  [2429] = 2356,
  [2430] = 2356,
  [2431] = 2037,
  [2432] = 2356,
  [2433] = 2059,
  [2434] = 2356,
  [2435] = 2356,
  [2436] = 2356,
  [2437] = 2059,
  [2438] = 2356,
  [2439] = 2356,
  [2440] = 2356,
  [2441] = 2356,
  [2442] = 2037,
  [2443] = 2037,
  [2444] = 2065,
  [2445] = 2375,
  [2446] = 2059,
  [2447] = 2065,
  [2448] = 2042,
  [2449] = 2059,
  [2450] = 2037,
  [2451] = 2059,
  [2452] = 2037,
  [2453] = 2059,
  [2454] = 2059,
  [2455] = 2059,
  [2456] = 2042,
  [2457] = 2059,
  [2458] = 2042,
  [2459] = 2065,
  [2460] = 2042,
  [2461] = 2042,
  [2462] = 2037,
  [2463] = 2065,
  [2464] = 2037,
  [2465] = 2042,
  [2466] = 2037,
  [2467] = 2042,
  [2468] = 2037,
  [2469] = 2059,
  [2470] = 2065,
  [2471] = 2065,
  [2472] = 2037,
  [2473] = 2065,
  [2474] = 2042,
  [2475] = 2065,
  [2476] = 2065,
  [2477] = 2042,
  [2478] = 2059,
  [2479] = 2037,
  [2480] = 2059,
  [2481] = 2065,
  [2482] = 2059,
  [2483] = 2042,
  [2484] = 2059,
  [2485] = 2065,
  [2486] = 2037,
  [2487] = 2059,
  [2488] = 2488,
  [2489] = 2042,
  [2490] = 2042,
  [2491] = 2042,
  [2492] = 2037,
  [2493] = 2037,
  [2494] = 2488,
  [2495] = 2065,
  [2496] = 2059,
  [2497] = 2065,
  [2498] = 2037,
  [2499] = 2042,
  [2500] = 2065,
  [2501] = 2037,
  [2502] = 2502,
  [2503] = 2503,
  [2504] = 2502,
  [2505] = 2503,
  [2506] = 2502,
  [2507] = 2502,
  [2508] = 2508,
  [2509] = 2509,
  [2510] = 2509,
  [2511] = 2503,
  [2512] = 2503,
  [2513] = 2503,
  [2514] = 2503,
  [2515] = 2502,
  [2516] = 2503,
  [2517] = 2509,
  [2518] = 2503,
  [2519] = 2509,
  [2520] = 2502,
  [2521] = 2502,
  [2522] = 2509,
  [2523] = 2509,
  [2524] = 2502,
  [2525] = 2502,
  [2526] = 2503,
  [2527] = 2503,
  [2528] = 2509,
  [2529] = 2529,
  [2530] = 2502,
  [2531] = 2531,
  [2532] = 2502,
  [2533] = 2509,
  [2534] = 2503,
  [2535] = 2503,
  [2536] = 2502,
  [2537] = 2509,
  [2538] = 2502,
  [2539] = 2509,
  [2540] = 2508,
  [2541] = 2503,
  [2542] = 2509,
  [2543] = 2502,
  [2544] = 2503,
  [2545] = 2503,
  [2546] = 2508,
  [2547] = 2503,
  [2548] = 2509,
  [2549] = 2503,
  [2550] = 2502,
  [2551] = 2509,
  [2552] = 2042,
  [2553] = 2509,
  [2554] = 2531,
  [2555] = 2502,
  [2556] = 2065,
  [2557] = 2042,
  [2558] = 2065,
  [2559] = 2529,
  [2560] = 2503,
  [2561] = 2503,
  [2562] = 2502,
  [2563] = 2503,
  [2564] = 2509,
  [2565] = 2502,
  [2566] = 2509,
  [2567] = 2502,
  [2568] = 2509,
  [2569] = 2509,
  [2570] = 2502,
  [2571] = 2503,
  [2572] = 2502,
  [2573] = 2509,
  [2574] = 2574,
  [2575] = 2502,
  [2576] = 2502,
  [2577] = 2531,
  [2578] = 2503,
  [2579] = 2579,
  [2580] = 2059,
  [2581] = 2502,
  [2582] = 2509,
  [2583] = 2502,
  [2584] = 2503,
  [2585] = 2509,
  [2586] = 2509,
  [2587] = 2509,
  [2588] = 2503,
  [2589] = 2502,
  [2590] = 2509,
  [2591] = 2591,
  [2592] = 2574,
  [2593] = 2503,
  [2594] = 2503,
  [2595] = 2503,
  [2596] = 2596,
  [2597] = 2503,
  [2598] = 2502,
  [2599] = 2509,
  [2600] = 2509,
  [2601] = 2503,
  [2602] = 2502,
  [2603] = 2503,
  [2604] = 2604,
  [2605] = 2503,
  [2606] = 2579,
  [2607] = 2502,
  [2608] = 2502,
  [2609] = 2509,
  [2610] = 2502,
  [2611] = 2065,
  [2612] = 2509,
  [2613] = 2503,
  [2614] = 2509,
  [2615] = 2509,
  [2616] = 2059,
  [2617] = 2502,
  [2618] = 2509,
  [2619] = 2503,
  [2620] = 2509,
  [2621] = 2042,
  [2622] = 2059,
  [2623] = 2503,
  [2624] = 2509,
  [2625] = 2502,
  [2626] = 2509,
  [2627] = 2037,
  [2628] = 2502,
  [2629] = 2509,
  [2630] = 2503,
  [2631] = 2503,
  [2632] = 2503,
  [2633] = 2502,
  [2634] = 2502,
  [2635] = 2509,
  [2636] = 2503,
  [2637] = 2509,
  [2638] = 2503,
  [2639] = 2509,
  [2640] = 2503,
  [2641] = 2037,
  [2642] = 2502,
  [2643] = 2509,
  [2644] = 2503,
  [2645] = 2509,
  [2646] = 2502,
  [2647] = 2591,
  [2648] = 2502,
  [2649] = 2503,
  [2650] = 2502,
  [2651] = 2509,
  [2652] = 2037,
  [2653] = 2502,
  [2654] = 2509,
  [2655] = 2502,
  [2656] = 2502,
  [2657] = 2509,
  [2658] = 2591,
  [2659] = 2502,
  [2660] = 2604,
  [2661] = 2596,
  [2662] = 2502,
  [2663] = 2509,
  [2664] = 2664,
  [2665] = 2665,
  [2666] = 2503,
  [2667] = 2664,
  [2668] = 2509,
  [2669] = 2503,
  [2670] = 2503,
  [2671] = 2671,
  [2672] = 2672,
  [2673] = 2672,
  [2674] = 2674,
  [2675] = 2675,
  [2676] = 2065,
  [2677] = 2065,
  [2678] = 2065,
  [2679] = 2042,
  [2680] = 2037,
  [2681] = 2037,
  [2682] = 2059,
  [2683] = 2672,
  [2684] = 2684,
  [2685] = 2037,
  [2686] = 2672,
  [2687] = 2059,
  [2688] = 2059,
  [2689] = 2672,
  [2690] = 2672,
  [2691] = 2672,
  [2692] = 2065,
  [2693] = 2059,
  [2694] = 2672,
  [2695] = 2672,
  [2696] = 2672,
  [2697] = 2684,
  [2698] = 2674,
  [2699] = 2042,
  [2700] = 2065,
  [2701] = 2701,
  [2702] = 2037,
  [2703] = 2703,
  [2704] = 2672,
  [2705] = 2701,
  [2706] = 2703,
  [2707] = 2672,
  [2708] = 2684,
  [2709] = 2672,
  [2710] = 2037,
  [2711] = 2672,
  [2712] = 2059,
  [2713] = 2042,
  [2714] = 2037,
  [2715] = 2042,
  [2716] = 2672,
  [2717] = 2672,
  [2718] = 2701,
  [2719] = 2672,
  [2720] = 2671,
  [2721] = 2042,
  [2722] = 2703,
  [2723] = 2065,
  [2724] = 2675,
  [2725] = 2671,
  [2726] = 2042,
  [2727] = 2672,
  [2728] = 2672,
  [2729] = 2672,
  [2730] = 2672,
  [2731] = 2672,
  [2732] = 2672,
  [2733] = 2037,
  [2734] = 2059,
  [2735] = 2037,
  [2736] = 2042,
  [2737] = 2059,
  [2738] = 2065,
  [2739] = 2739,
  [2740] = 2037,
  [2741] = 2741,
  [2742] = 2042,
  [2743] = 2743,
  [2744] = 2065,
  [2745] = 2037,
  [2746] = 2059,
  [2747] = 2059,
  [2748] = 2065,
  [2749] = 2042,
  [2750] = 2059,
  [2751] = 2059,
  [2752] = 2065,
  [2753] = 2042,
  [2754] = 2042,
  [2755] = 2059,
  [2756] = 2065,
  [2757] = 2037,
  [2758] = 2065,
  [2759] = 2042,
  [2760] = 2065,
  [2761] = 2042,
  [2762] = 2037,
  [2763] = 2037,
  [2764] = 2764,
  [2765] = 2037,
  [2766] = 2766,
  [2767] = 2042,
  [2768] = 2059,
  [2769] = 2766,
  [2770] = 2770,
  [2771] = 2059,
  [2772] = 2770,
  [2773] = 2037,
  [2774] = 2065,
  [2775] = 2065,
  [2776] = 2766,
  [2777] = 2766,
  [2778] = 2778,
  [2779] = 2778,
  [2780] = 2042,
  [2781] = 2766,
  [2782] = 2766,
  [2783] = 2783,
  [2784] = 2059,
  [2785] = 2037,
  [2786] = 2059,
  [2787] = 2065,
  [2788] = 2059,
  [2789] = 2764,
  [2790] = 2764,
  [2791] = 2791,
  [2792] = 2059,
  [2793] = 2793,
  [2794] = 2793,
  [2795] = 2795,
  [2796] = 2783,
  [2797] = 2059,
  [2798] = 2798,
  [2799] = 2042,
  [2800] = 2793,
  [2801] = 2795,
  [2802] = 2042,
  [2803] = 2037,
  [2804] = 2798,
  [2805] = 2059,
  [2806] = 2806,
  [2807] = 2806,
  [2808] = 2798,
  [2809] = 2791,
  [2810] = 2065,
  [2811] = 2795,
  [2812] = 2791,
  [2813] = 2783,
  [2814] = 2806,
  [2815] = 2815,
  [2816] = 2059,
  [2817] = 2817,
  [2818] = 2059,
  [2819] = 2815,
  [2820] = 2820,
  [2821] = 2820,
  [2822] = 2822,
  [2823] = 2823,
  [2824] = 2823,
  [2825] = 2764,
  [2826] = 2826,
  [2827] = 2059,
  [2828] = 2828,
  [2829] = 2829,
  [2830] = 2817,
  [2831] = 2822,
  [2832] = 2828,
  [2833] = 2833,
  [2834] = 2834,
  [2835] = 2833,
  [2836] = 2833,
  [2837] = 2833,
  [2838] = 2833,
  [2839] = 2839,
  [2840] = 2059,
  [2841] = 2826,
  [2842] = 2833,
  [2843] = 2059,
  [2844] = 2833,
  [2845] = 2833,
  [2846] = 2833,
  [2847] = 2833,
  [2848] = 2037,
  [2849] = 2839,
  [2850] = 2764,
  [2851] = 2833,
  [2852] = 2833,
  [2853] = 2833,
  [2854] = 2764,
  [2855] = 2833,
  [2856] = 2833,
  [2857] = 2833,
  [2858] = 2065,
  [2859] = 2042,
  [2860] = 2833,
  [2861] = 2834,
  [2862] = 2839,
  [2863] = 2833,
  [2864] = 2833,
  [2865] = 2829,
  [2866] = 2059,
  [2867] = 2823,
  [2868] = 2833,
  [2869] = 2833,
  [2870] = 2764,
  [2871] = 2834,
  [2872] = 2042,
  [2873] = 2833,
  [2874] = 2833,
  [2875] = 2833,
  [2876] = 2833,
  [2877] = 2833,
  [2878] = 2833,
  [2879] = 2833,
  [2880] = 2880,
  [2881] = 2764,
  [2882] = 2880,
  [2883] = 2833,
  [2884] = 2833,
  [2885] = 2880,
  [2886] = 2764,
  [2887] = 2833,
  [2888] = 2833,
  [2889] = 2833,
  [2890] = 2826,
  [2891] = 2829,
  [2892] = 2833,
  [2893] = 2833,
  [2894] = 2833,
  [2895] = 2828,
  [2896] = 2833,
  [2897] = 2833,
  [2898] = 2833,
  [2899] = 2037,
  [2900] = 2833,
  [2901] = 2833,
  [2902] = 2833,
  [2903] = 2833,
  [2904] = 2833,
  [2905] = 2833,
  [2906] = 2833,
  [2907] = 2065,
  [2908] = 2908,
  [2909] = 2909,
  [2910] = 2910,
  [2911] = 2911,
  [2912] = 2908,
  [2913] = 2908,
  [2914] = 2911,
  [2915] = 2909,
  [2916] = 2916,
  [2917] = 2910,
  [2918] = 2909,
  [2919] = 2909,
  [2920] = 2916,
  [2921] = 2909,
  [2922] = 2910,
  [2923] = 2909,
  [2924] = 2909,
  [2925] = 2911,
  [2926] = 2908,
  [2927] = 2916,
  [2928] = 2829,
  [2929] = 2910,
  [2930] = 2908,
  [2931] = 2909,
  [2932] = 2910,
  [2933] = 2916,
  [2934] = 2910,
  [2935] = 2908,
  [2936] = 2911,
  [2937] = 2911,
  [2938] = 2910,
  [2939] = 2911,
  [2940] = 2909,
  [2941] = 2908,
  [2942] = 2916,
  [2943] = 2911,
  [2944] = 2910,
  [2945] = 2916,
  [2946] = 2908,
  [2947] = 2911,
  [2948] = 2910,
  [2949] = 2911,
  [2950] = 2916,
  [2951] = 2916,
  [2952] = 2908,
  [2953] = 2953,
  [2954] = 2908,
  [2955] = 2908,
  [2956] = 2916,
  [2957] = 2908,
  [2958] = 2916,
  [2959] = 2911,
  [2960] = 2910,
  [2961] = 2909,
  [2962] = 2916,
  [2963] = 2911,
  [2964] = 2910,
  [2965] = 2916,
  [2966] = 2037,
  [2967] = 2908,
  [2968] = 2909,
  [2969] = 2059,
  [2970] = 2910,
  [2971] = 2953,
  [2972] = 2911,
  [2973] = 2910,
  [2974] = 2916,
  [2975] = 2908,
  [2976] = 2911,
  [2977] = 2910,
  [2978] = 2909,
  [2979] = 2909,
  [2980] = 2910,
  [2981] = 2911,
  [2982] = 2909,
  [2983] = 2909,
  [2984] = 2909,
  [2985] = 2908,
  [2986] = 2916,
  [2987] = 2909,
  [2988] = 2911,
  [2989] = 2909,
  [2990] = 2908,
  [2991] = 2037,
  [2992] = 2916,
  [2993] = 2909,
  [2994] = 2910,
  [2995] = 2916,
  [2996] = 2911,
  [2997] = 2764,
  [2998] = 2998,
  [2999] = 2909,
  [3000] = 2910,
  [3001] = 2908,
  [3002] = 2911,
  [3003] = 2911,
  [3004] = 2910,
  [3005] = 2909,
  [3006] = 2908,
  [3007] = 2916,
  [3008] = 2909,
  [3009] = 2910,
  [3010] = 2911,
  [3011] = 2908,
  [3012] = 2764,
  [3013] = 2916,
  [3014] = 2916,
  [3015] = 2916,
  [3016] = 2908,
  [3017] = 2911,
  [3018] = 2909,
  [3019] = 2910,
  [3020] = 2909,
  [3021] = 2908,
  [3022] = 2910,
  [3023] = 2911,
  [3024] = 2910,
  [3025] = 2911,
  [3026] = 2908,
  [3027] = 2916,
  [3028] = 2916,
  [3029] = 2908,
  [3030] = 2909,
  [3031] = 2909,
  [3032] = 2909,
  [3033] = 2911,
  [3034] = 2910,
  [3035] = 2909,
  [3036] = 2910,
  [3037] = 2911,
  [3038] = 2909,
  [3039] = 2916,
  [3040] = 2908,
  [3041] = 3041,
  [3042] = 3042,
  [3043] = 3043,
  [3044] = 2911,
  [3045] = 2910,
  [3046] = 2911,
  [3047] = 2910,
  [3048] = 2909,
  [3049] = 2908,
  [3050] = 2916,
  [3051] = 2916,
  [3052] = 2908,
  [3053] = 2908,
  [3054] = 2916,
  [3055] = 2916,
  [3056] = 2908,
  [3057] = 3057,
  [3058] = 2909,
  [3059] = 3059,
  [3060] = 2916,
  [3061] = 2911,
  [3062] = 2908,
  [3063] = 2916,
  [3064] = 2910,
  [3065] = 2910,
  [3066] = 2911,
  [3067] = 2911,
  [3068] = 2916,
  [3069] = 2908,
  [3070] = 2916,
  [3071] = 3071,
  [3072] = 3072,
  [3073] = 3073,
  [3074] = 3074,
  [3075] = 2910,
  [3076] = 2911,
  [3077] = 2911,
  [3078] = 2916,
  [3079] = 2910,
  [3080] = 2911,
  [3081] = 2908,
  [3082] = 2909,
  [3083] = 2910,
  [3084] = 2910,
  [3085] = 2909,
  [3086] = 2911,
  [3087] = 2908,
  [3088] = 2911,
  [3089] = 2908,
  [3090] = 2916,
  [3091] = 3059,
  [3092] = 3041,
  [3093] = 3074,
  [3094] = 2909,
  [3095] = 2909,
  [3096] = 3042,
  [3097] = 2910,
  [3098] = 3043,
  [3099] = 2910,
  [3100] = 3073,
  [3101] = 3071,
  [3102] = 2911,
  [3103] = 2908,
  [3104] = 2916,
  [3105] = 2909,
  [3106] = 2909,
  [3107] = 3057,
  [3108] = 2909,
  [3109] = 2909,
  [3110] = 2910,
  [3111] = 2916,
  [3112] = 2908,
  [3113] = 3043,
  [3114] = 3042,
  [3115] = 3041,
  [3116] = 2910,
  [3117] = 2910,
  [3118] = 2911,
  [3119] = 2911,
  [3120] = 2908,
  [3121] = 2916,
  [3122] = 2916,
  [3123] = 2998,
  [3124] = 2908,
  [3125] = 2911,
  [3126] = 2908,
  [3127] = 2953,
  [3128] = 2910,
  [3129] = 2911,
  [3130] = 2910,
  [3131] = 2916,
  [3132] = 2909,
  [3133] = 2910,
  [3134] = 3059,
  [3135] = 3071,
  [3136] = 2909,
  [3137] = 2910,
  [3138] = 2911,
  [3139] = 2909,
  [3140] = 2908,
  [3141] = 2911,
  [3142] = 2916,
  [3143] = 2998,
  [3144] = 2953,
  [3145] = 2916,
  [3146] = 2908,
  [3147] = 3073,
  [3148] = 3074,
  [3149] = 2911,
  [3150] = 2910,
  [3151] = 2908,
  [3152] = 2908,
  [3153] = 2916,
  [3154] = 2059,
  [3155] = 2916,
  [3156] = 3057,
  [3157] = 2909,
  [3158] = 2909,
  [3159] = 2909,
  [3160] = 2826,
  [3161] = 2916,
  [3162] = 2910,
  [3163] = 2911,
  [3164] = 2916,
  [3165] = 2908,
  [3166] = 2911,
  [3167] = 3072,
  [3168] = 2908,
  [3169] = 2908,
  [3170] = 2764,
  [3171] = 2916,
  [3172] = 2910,
  [3173] = 2910,
  [3174] = 2911,
  [3175] = 2916,
  [3176] = 2909,
  [3177] = 2910,
  [3178] = 2911,
  [3179] = 2908,
  [3180] = 2037,
  [3181] = 2826,
  [3182] = 2829,
  [3183] = 3072,
  [3184] = 3184,
  [3185] = 3072,
  [3186] = 3186,
  [3187] = 2826,
  [3188] = 2826,
  [3189] = 2037,
  [3190] = 2829,
  [3191] = 3191,
  [3192] = 3191,
  [3193] = 3072,
  [3194] = 3191,
  [3195] = 3191,
  [3196] = 2826,
  [3197] = 2826,
  [3198] = 2829,
  [3199] = 2037,
  [3200] = 3200,
  [3201] = 2829,
  [3202] = 2764,
  [3203] = 3203,
  [3204] = 3200,
  [3205] = 3191,
  [3206] = 3200,
  [3207] = 3191,
  [3208] = 3208,
  [3209] = 2829,
  [3210] = 3210,
  [3211] = 3210,
  [3212] = 3212,
  [3213] = 3213,
  [3214] = 3210,
  [3215] = 3215,
  [3216] = 3210,
  [3217] = 3217,
  [3218] = 3218,
  [3219] = 3219,
  [3220] = 2829,
  [3221] = 3219,
  [3222] = 3222,
  [3223] = 3218,
  [3224] = 3212,
  [3225] = 2829,
  [3226] = 2826,
  [3227] = 3218,
  [3228] = 2037,
  [3229] = 3218,
  [3230] = 3210,
  [3231] = 3072,
  [3232] = 3213,
  [3233] = 3233,
  [3234] = 3234,
  [3235] = 2826,
  [3236] = 3218,
  [3237] = 3218,
  [3238] = 3210,
  [3239] = 2037,
  [3240] = 3210,
  [3241] = 2829,
  [3242] = 2826,
  [3243] = 3218,
  [3244] = 3222,
  [3245] = 3218,
  [3246] = 3234,
  [3247] = 3213,
  [3248] = 3234,
  [3249] = 3212,
  [3250] = 3210,
  [3251] = 3210,
  [3252] = 3072,
  [3253] = 3072,
  [3254] = 3218,
  [3255] = 2037,
  [3256] = 3233,
  [3257] = 3222,
  [3258] = 3233,
  [3259] = 3210,
  [3260] = 3210,
  [3261] = 3210,
  [3262] = 3218,
  [3263] = 2037,
  [3264] = 3218,
  [3265] = 3210,
  [3266] = 3218,
  [3267] = 3218,
  [3268] = 3072,
  [3269] = 3269,
  [3270] = 3270,
  [3271] = 3271,
  [3272] = 3272,
  [3273] = 3273,
  [3274] = 3274,
  [3275] = 3272,
  [3276] = 3276,
  [3277] = 3277,
  [3278] = 3276,
  [3279] = 3269,
  [3280] = 3272,
  [3281] = 3281,
  [3282] = 3274,
  [3283] = 3283,
  [3284] = 3277,
  [3285] = 3273,
  [3286] = 3286,
  [3287] = 3271,
  [3288] = 3269,
  [3289] = 3281,
  [3290] = 3270,
  [3291] = 3281,
  [3292] = 3292,
  [3293] = 3283,
  [3294] = 3283,
  [3295] = 3292,
  [3296] = 3296,
  [3297] = 3297,
  [3298] = 3297,
  [3299] = 3296,
  [3300] = 3286,
  [3301] = 3270,
  [3302] = 3302,
  [3303] = 3277,
  [3304] = 3304,
  [3305] = 2829,
  [3306] = 3286,
  [3307] = 3307,
  [3308] = 3304,
  [3309] = 3302,
  [3310] = 2826,
  [3311] = 3292,
  [3312] = 2037,
  [3313] = 3302,
  [3314] = 3276,
  [3315] = 3274,
  [3316] = 3296,
  [3317] = 3072,
  [3318] = 3304,
  [3319] = 3297,
  [3320] = 3273,
  [3321] = 3271,
  [3322] = 3322,
  [3323] = 3322,
  [3324] = 3324,
  [3325] = 3322,
  [3326] = 3322,
  [3327] = 3322,
  [3328] = 3322,
  [3329] = 3329,
  [3330] = 3330,
  [3331] = 3322,
  [3332] = 3322,
  [3333] = 3333,
  [3334] = 3322,
  [3335] = 3322,
  [3336] = 3322,
  [3337] = 3322,
  [3338] = 3338,
  [3339] = 3329,
  [3340] = 3329,
  [3341] = 3329,
  [3342] = 3329,
  [3343] = 3329,
  [3344] = 3330,
  [3345] = 3329,
  [3346] = 3329,
  [3347] = 3322,
  [3348] = 3322,
  [3349] = 3322,
  [3350] = 3350,
  [3351] = 3329,
  [3352] = 3330,
  [3353] = 3322,
  [3354] = 3329,
  [3355] = 3329,
  [3356] = 3322,
  [3357] = 3324,
  [3358] = 3338,
  [3359] = 3322,
  [3360] = 3322,
  [3361] = 3322,
  [3362] = 3322,
  [3363] = 3322,
  [3364] = 3322,
  [3365] = 3329,
  [3366] = 3338,
  [3367] = 3367,
  [3368] = 3367,
  [3369] = 3322,
  [3370] = 3322,
  [3371] = 3322,
  [3372] = 3372,
  [3373] = 3322,
  [3374] = 3322,
  [3375] = 3329,
  [3376] = 3329,
  [3377] = 3330,
  [3378] = 3322,
  [3379] = 3322,
  [3380] = 3322,
  [3381] = 3322,
  [3382] = 3382,
  [3383] = 3322,
  [3384] = 3372,
  [3385] = 3322,
  [3386] = 3322,
  [3387] = 3329,
  [3388] = 3322,
  [3389] = 3329,
  [3390] = 3322,
  [3391] = 3329,
  [3392] = 3322,
  [3393] = 3322,
  [3394] = 3372,
  [3395] = 3322,
  [3396] = 3324,
  [3397] = 3329,
  [3398] = 3322,
  [3399] = 3322,
  [3400] = 3338,
  [3401] = 3322,
  [3402] = 3338,
  [3403] = 3329,
  [3404] = 3322,
  [3405] = 3329,
  [3406] = 3322,
  [3407] = 3324,
  [3408] = 3322,
  [3409] = 3329,
  [3410] = 3322,
  [3411] = 3329,
  [3412] = 3330,
  [3413] = 3372,
  [3414] = 3330,
  [3415] = 3329,
  [3416] = 3367,
  [3417] = 3322,
  [3418] = 3338,
  [3419] = 2826,
  [3420] = 3420,
  [3421] = 3421,
  [3422] = 3422,
  [3423] = 3423,
  [3424] = 3423,
  [3425] = 3425,
  [3426] = 3426,
  [3427] = 3427,
  [3428] = 3425,
  [3429] = 3425,
  [3430] = 3425,
  [3431] = 3425,
  [3432] = 3425,
  [3433] = 3425,
  [3434] = 3426,
  [3435] = 3435,
  [3436] = 3425,
  [3437] = 3427,
  [3438] = 3425,
  [3439] = 3425,
  [3440] = 3425,
  [3441] = 3425,
  [3442] = 3425,
  [3443] = 3443,
  [3444] = 3427,
  [3445] = 3445,
  [3446] = 3446,
  [3447] = 3446,
  [3448] = 3445,
  [3449] = 3425,
  [3450] = 3425,
  [3451] = 3425,
  [3452] = 3425,
  [3453] = 3453,
  [3454] = 3454,
  [3455] = 3425,
  [3456] = 3456,
  [3457] = 3425,
  [3458] = 3425,
  [3459] = 3435,
  [3460] = 3435,
  [3461] = 3425,
  [3462] = 3425,
  [3463] = 3425,
  [3464] = 2065,
  [3465] = 2042,
  [3466] = 3443,
  [3467] = 3443,
  [3468] = 3468,
  [3469] = 3469,
  [3470] = 3470,
  [3471] = 3471,
  [3472] = 3470,
  [3473] = 3471,
  [3474] = 3469,
  [3475] = 3471,
  [3476] = 3468,
  [3477] = 3470,
  [3478] = 3468,
  [3479] = 3479,
  [3480] = 3479,
  [3481] = 3481,
  [3482] = 3482,
  [3483] = 3483,
  [3484] = 3483,
  [3485] = 3485,
  [3486] = 3486,
  [3487] = 3486,
  [3488] = 3488,
  [3489] = 3489,
  [3490] = 3479,
  [3491] = 3491,
  [3492] = 3488,
  [3493] = 3493,
  [3494] = 3485,
  [3495] = 3495,
  [3496] = 3483,
  [3497] = 3479,
  [3498] = 3485,
  [3499] = 3483,
  [3500] = 3485,
  [3501] = 3479,
  [3502] = 3479,
  [3503] = 3488,
  [3504] = 3486,
  [3505] = 3505,
  [3506] = 3479,
  [3507] = 3483,
  [3508] = 3485,
  [3509] = 3488,
  [3510] = 3505,
  [3511] = 3511,
  [3512] = 3485,
  [3513] = 3483,
  [3514] = 3514,
  [3515] = 3479,
  [3516] = 3483,
  [3517] = 3483,
  [3518] = 3479,
  [3519] = 3485,
  [3520] = 3483,
  [3521] = 3485,
  [3522] = 3479,
  [3523] = 3485,
  [3524] = 3505,
  [3525] = 3488,
  [3526] = 3486,
  [3527] = 3483,
  [3528] = 3483,
  [3529] = 3485,
  [3530] = 3483,
  [3531] = 3485,
  [3532] = 3485,
  [3533] = 3481,
  [3534] = 3479,
  [3535] = 3493,
  [3536] = 3491,
  [3537] = 3479,
  [3538] = 3483,
  [3539] = 3485,
  [3540] = 3486,
  [3541] = 3495,
  [3542] = 3479,
  [3543] = 3543,
  [3544] = 3479,
  [3545] = 3483,
  [3546] = 3546,
  [3547] = 3547,
  [3548] = 3488,
  [3549] = 3549,
  [3550] = 3505,
  [3551] = 3486,
  [3552] = 3488,
  [3553] = 3491,
  [3554] = 3469,
  [3555] = 3493,
  [3556] = 3486,
  [3557] = 3488,
  [3558] = 3485,
  [3559] = 3483,
  [3560] = 3488,
  [3561] = 3491,
  [3562] = 3562,
  [3563] = 3485,
  [3564] = 3483,
  [3565] = 3486,
  [3566] = 3485,
  [3567] = 3486,
  [3568] = 3488,
  [3569] = 3485,
  [3570] = 3483,
  [3571] = 3485,
  [3572] = 3483,
  [3573] = 3485,
  [3574] = 3483,
  [3575] = 3479,
  [3576] = 3576,
  [3577] = 3577,
  [3578] = 3483,
  [3579] = 3479,
  [3580] = 3483,
  [3581] = 3483,
  [3582] = 3485,
  [3583] = 3485,
  [3584] = 3505,
  [3585] = 3483,
  [3586] = 3486,
  [3587] = 3483,
  [3588] = 3485,
  [3589] = 3505,
  [3590] = 3479,
  [3591] = 3591,
  [3592] = 3485,
  [3593] = 3493,
  [3594] = 3491,
  [3595] = 3549,
  [3596] = 3505,
  [3597] = 3597,
  [3598] = 3488,
  [3599] = 3486,
  [3600] = 3600,
  [3601] = 3489,
  [3602] = 3576,
  [3603] = 3485,
  [3604] = 3493,
  [3605] = 3605,
  [3606] = 3606,
  [3607] = 3491,
  [3608] = 3608,
  [3609] = 3591,
  [3610] = 3491,
  [3611] = 3493,
  [3612] = 3486,
  [3613] = 3488,
  [3614] = 3483,
  [3615] = 3485,
  [3616] = 3488,
  [3617] = 3577,
  [3618] = 3505,
  [3619] = 3514,
  [3620] = 3479,
  [3621] = 3486,
  [3622] = 3485,
  [3623] = 3488,
  [3624] = 3485,
  [3625] = 3483,
  [3626] = 3488,
  [3627] = 3486,
  [3628] = 3608,
  [3629] = 3493,
  [3630] = 3486,
  [3631] = 3488,
  [3632] = 3632,
  [3633] = 3483,
  [3634] = 3483,
  [3635] = 3483,
  [3636] = 3485,
  [3637] = 3479,
  [3638] = 3505,
  [3639] = 3479,
  [3640] = 3479,
  [3641] = 3488,
  [3642] = 3486,
  [3643] = 3483,
  [3644] = 3485,
  [3645] = 3483,
  [3646] = 3479,
  [3647] = 3546,
  [3648] = 3485,
  [3649] = 3488,
  [3650] = 3485,
  [3651] = 3482,
  [3652] = 3486,
  [3653] = 3483,
  [3654] = 3483,
  [3655] = 3485,
  [3656] = 3597,
  [3657] = 3486,
  [3658] = 3485,
  [3659] = 3485,
  [3660] = 3483,
  [3661] = 3562,
  [3662] = 3606,
  [3663] = 3488,
  [3664] = 3486,
  [3665] = 3488,
  [3666] = 3485,
  [3667] = 3483,
  [3668] = 3668,
  [3669] = 3479,
  [3670] = 3486,
  [3671] = 3483,
  [3672] = 3486,
  [3673] = 3668,
  [3674] = 3483,
  [3675] = 3485,
  [3676] = 3485,
  [3677] = 3677,
  [3678] = 3488,
  [3679] = 3505,
  [3680] = 3488,
  [3681] = 3486,
  [3682] = 3479,
  [3683] = 3505,
  [3684] = 3479,
  [3685] = 3511,
  [3686] = 3479,
  [3687] = 3483,
  [3688] = 3483,
  [3689] = 3491,
  [3690] = 3493,
  [3691] = 3479,
  [3692] = 3692,
  [3693] = 3483,
  [3694] = 3485,
  [3695] = 3483,
  [3696] = 3486,
  [3697] = 3483,
  [3698] = 3485,
  [3699] = 3677,
  [3700] = 3485,
  [3701] = 3547,
  [3702] = 3485,
  [3703] = 3677,
  [3704] = 3488,
  [3705] = 3705,
  [3706] = 3483,
  [3707] = 3486,
  [3708] = 3543,
  [3709] = 3485,
  [3710] = 3488,
  [3711] = 3486,
  [3712] = 3486,
  [3713] = 3488,
  [3714] = 3486,
  [3715] = 3485,
  [3716] = 3488,
  [3717] = 3488,
  [3718] = 3505,
  [3719] = 3486,
  [3720] = 3483,
  [3721] = 3505,
  [3722] = 3483,
  [3723] = 3488,
  [3724] = 3485,
  [3725] = 3483,
  [3726] = 3491,
  [3727] = 3493,
  [3728] = 3485,
  [3729] = 3485,
  [3730] = 3493,
  [3731] = 3479,
  [3732] = 3491,
  [3733] = 3562,
  [3734] = 3734,
  [3735] = 3735,
  [3736] = 3471,
  [3737] = 3737,
  [3738] = 3738,
  [3739] = 3739,
  [3740] = 3740,
  [3741] = 3470,
  [3742] = 3742,
  [3743] = 3743,
  [3744] = 3744,
  [3745] = 3745,
  [3746] = 3746,
  [3747] = 3747,
  [3748] = 3748,
  [3749] = 3749,
  [3750] = 3750,
  [3751] = 3751,
  [3752] = 3752,
  [3753] = 3753,
  [3754] = 3754,
  [3755] = 3468,
  [3756] = 3756,
  [3757] = 3757,
  [3758] = 3758,
  [3759] = 3692,
  [3760] = 3760,
  [3761] = 3761,
  [3762] = 3762,
  [3763] = 3763,
  [3764] = 3764,
  [3765] = 3765,
  [3766] = 3766,
  [3767] = 3767,
  [3768] = 3768,
  [3769] = 3495,
  [3770] = 3770,
  [3771] = 3771,
  [3772] = 3772,
  [3773] = 3773,
  [3774] = 3774,
  [3775] = 3775,
  [3776] = 3776,
  [3777] = 3600,
  [3778] = 3778,
  [3779] = 3779,
  [3780] = 3632,
  [3781] = 3781,
  [3782] = 3782,
  [3783] = 3783,
  [3784] = 3784,
  [3785] = 3785,
  [3786] = 3705,
  [3787] = 3787,
  [3788] = 3788,
  [3789] = 3752,
  [3790] = 3481,
  [3791] = 3747,
  [3792] = 3788,
  [3793] = 3737,
  [3794] = 3735,
  [3795] = 3677,
  [3796] = 3784,
  [3797] = 3776,
  [3798] = 3751,
  [3799] = 3799,
  [3800] = 3762,
  [3801] = 3801,
  [3802] = 3783,
  [3803] = 3787,
  [3804] = 3750,
  [3805] = 3775,
  [3806] = 3738,
  [3807] = 3774,
  [3808] = 3754,
  [3809] = 3809,
  [3810] = 3744,
  [3811] = 3481,
  [3812] = 3782,
  [3813] = 3813,
  [3814] = 3734,
  [3815] = 3748,
  [3816] = 3740,
  [3817] = 3817,
  [3818] = 3471,
  [3819] = 3562,
  [3820] = 3468,
  [3821] = 3817,
  [3822] = 3739,
  [3823] = 3470,
  [3824] = 3824,
  [3825] = 3825,
  [3826] = 3749,
  [3827] = 3773,
  [3828] = 3756,
  [3829] = 3829,
  [3830] = 3753,
  [3831] = 3742,
  [3832] = 3832,
  [3833] = 3757,
  [3834] = 3778,
  [3835] = 3760,
  [3836] = 3758,
  [3837] = 3771,
  [3838] = 3743,
  [3839] = 3761,
  [3840] = 3781,
  [3841] = 3746,
  [3842] = 3745,
  [3843] = 3843,
  [3844] = 3785,
  [3845] = 3481,
  [3846] = 3768,
  [3847] = 3763,
  [3848] = 3772,
  [3849] = 3770,
  [3850] = 3767,
  [3851] = 3766,
  [3852] = 3765,
  [3853] = 3853,
  [3854] = 3779,
  [3855] = 3764,
  [3856] = 3511,
  [3857] = 3471,
  [3858] = 3832,
  [3859] = 3543,
  [3860] = 3468,
  [3861] = 3692,
  [3862] = 3470,
  [3863] = 3471,
  [3864] = 3829,
  [3865] = 3608,
  [3866] = 3470,
  [3867] = 3514,
  [3868] = 3824,
  [3869] = 3843,
  [3870] = 3606,
  [3871] = 3632,
  [3872] = 3546,
  [3873] = 3600,
  [3874] = 3468,
  [3875] = 3547,
  [3876] = 3562,
  [3877] = 3468,
  [3878] = 3853,
  [3879] = 3591,
  [3880] = 3470,
  [3881] = 3668,
  [3882] = 3468,
  [3883] = 3825,
  [3884] = 3677,
  [3885] = 3471,
  [3886] = 3799,
  [3887] = 3471,
  [3888] = 3470,
  [3889] = 3482,
  [3890] = 3481,
  [3891] = 3705,
  [3892] = 3468,
  [3893] = 3577,
  [3894] = 3489,
  [3895] = 3470,
  [3896] = 3817,
  [3897] = 3813,
  [3898] = 3809,
  [3899] = 3576,
  [3900] = 3471,
  [3901] = 3549,
  [3902] = 3481,
  [3903] = 3801,
  [3904] = 3597,
  [3905] = 3744,
  [3906] = 3470,
  [3907] = 3668,
  [3908] = 3908,
  [3909] = 3739,
  [3910] = 3738,
  [3911] = 3817,
  [3912] = 3470,
  [3913] = 3742,
  [3914] = 3737,
  [3915] = 3677,
  [3916] = 3750,
  [3917] = 3677,
  [3918] = 3471,
  [3919] = 3776,
  [3920] = 3705,
  [3921] = 3752,
  [3922] = 3787,
  [3923] = 3677,
  [3924] = 3562,
  [3925] = 3754,
  [3926] = 3562,
  [3927] = 3600,
  [3928] = 3705,
  [3929] = 3606,
  [3930] = 3743,
  [3931] = 3692,
  [3932] = 3775,
  [3933] = 3692,
  [3934] = 3773,
  [3935] = 3771,
  [3936] = 3514,
  [3937] = 3817,
  [3938] = 3778,
  [3939] = 3747,
  [3940] = 3734,
  [3941] = 3748,
  [3942] = 3482,
  [3943] = 3468,
  [3944] = 3468,
  [3945] = 3760,
  [3946] = 3600,
  [3947] = 3546,
  [3948] = 3576,
  [3949] = 3489,
  [3950] = 3817,
  [3951] = 3766,
  [3952] = 3562,
  [3953] = 3788,
  [3954] = 3784,
  [3955] = 3753,
  [3956] = 3783,
  [3957] = 3562,
  [3958] = 3764,
  [3959] = 3677,
  [3960] = 3481,
  [3961] = 3762,
  [3962] = 3751,
  [3963] = 3468,
  [3964] = 3782,
  [3965] = 3774,
  [3966] = 3785,
  [3967] = 3779,
  [3968] = 3468,
  [3969] = 3471,
  [3970] = 3756,
  [3971] = 3470,
  [3972] = 3632,
  [3973] = 3749,
  [3974] = 3735,
  [3975] = 3549,
  [3976] = 3470,
  [3977] = 3471,
  [3978] = 3471,
  [3979] = 3692,
  [3980] = 3511,
  [3981] = 3562,
  [3982] = 3543,
  [3983] = 3705,
  [3984] = 3740,
  [3985] = 3745,
  [3986] = 3746,
  [3987] = 3468,
  [3988] = 3781,
  [3989] = 3471,
  [3990] = 3817,
  [3991] = 3471,
  [3992] = 3772,
  [3993] = 3470,
  [3994] = 3770,
  [3995] = 3768,
  [3996] = 3767,
  [3997] = 3765,
  [3998] = 3763,
  [3999] = 3632,
  [4000] = 3817,
  [4001] = 3761,
  [4002] = 3758,
  [4003] = 3757,
  [4004] = 3547,
  [4005] = 3597,
  [4006] = 3608,
  [4007] = 3468,
  [4008] = 3677,
  [4009] = 3600,
  [4010] = 3481,
  [4011] = 3591,
  [4012] = 3470,
  [4013] = 3908,
  [4014] = 3577,
  [4015] = 3817,
  [4016] = 3774,
  [4017] = 3740,
  [4018] = 3760,
  [4019] = 3735,
  [4020] = 3468,
  [4021] = 3785,
  [4022] = 3775,
  [4023] = 3600,
  [4024] = 3773,
  [4025] = 3562,
  [4026] = 3771,
  [4027] = 3758,
  [4028] = 3562,
  [4029] = 3734,
  [4030] = 3748,
  [4031] = 3750,
  [4032] = 3668,
  [4033] = 3742,
  [4034] = 3766,
  [4035] = 3738,
  [4036] = 3739,
  [4037] = 3757,
  [4038] = 3778,
  [4039] = 3739,
  [4040] = 3747,
  [4041] = 3776,
  [4042] = 3677,
  [4043] = 3779,
  [4044] = 3756,
  [4045] = 3737,
  [4046] = 3737,
  [4047] = 3481,
  [4048] = 3764,
  [4049] = 3743,
  [4050] = 3752,
  [4051] = 3677,
  [4052] = 3739,
  [4053] = 3743,
  [4054] = 3742,
  [4055] = 3743,
  [4056] = 3744,
  [4057] = 3753,
  [4058] = 4058,
  [4059] = 3747,
  [4060] = 3749,
  [4061] = 3744,
  [4062] = 3562,
  [4063] = 3788,
  [4064] = 3832,
  [4065] = 3752,
  [4066] = 3747,
  [4067] = 3744,
  [4068] = 3547,
  [4069] = 3754,
  [4070] = 3761,
  [4071] = 3482,
  [4072] = 3817,
  [4073] = 3829,
  [4074] = 3471,
  [4075] = 3606,
  [4076] = 3606,
  [4077] = 3482,
  [4078] = 3677,
  [4079] = 4079,
  [4080] = 3785,
  [4081] = 3562,
  [4082] = 3824,
  [4083] = 3785,
  [4084] = 3742,
  [4085] = 3481,
  [4086] = 3751,
  [4087] = 3762,
  [4088] = 3817,
  [4089] = 3470,
  [4090] = 3787,
  [4091] = 3762,
  [4092] = 3784,
  [4093] = 3746,
  [4094] = 3774,
  [4095] = 4095,
  [4096] = 3813,
  [4097] = 3576,
  [4098] = 3774,
  [4099] = 3783,
  [4100] = 3825,
  [4101] = 3782,
  [4102] = 3779,
  [4103] = 3754,
  [4104] = 3735,
  [4105] = 3809,
  [4106] = 3514,
  [4107] = 3843,
  [4108] = 3770,
  [4109] = 3764,
  [4110] = 3547,
  [4111] = 3597,
  [4112] = 3766,
  [4113] = 3749,
  [4114] = 3549,
  [4115] = 3760,
  [4116] = 3783,
  [4117] = 3784,
  [4118] = 3511,
  [4119] = 3762,
  [4120] = 3788,
  [4121] = 3677,
  [4122] = 3748,
  [4123] = 3734,
  [4124] = 3543,
  [4125] = 4125,
  [4126] = 3740,
  [4127] = 3546,
  [4128] = 3763,
  [4129] = 4129,
  [4130] = 3597,
  [4131] = 3751,
  [4132] = 3782,
  [4133] = 3753,
  [4134] = 3760,
  [4135] = 3549,
  [4136] = 3781,
  [4137] = 3738,
  [4138] = 3778,
  [4139] = 3546,
  [4140] = 3908,
  [4141] = 3489,
  [4142] = 3514,
  [4143] = 3772,
  [4144] = 3677,
  [4145] = 3817,
  [4146] = 3608,
  [4147] = 3770,
  [4148] = 3608,
  [4149] = 3768,
  [4150] = 3668,
  [4151] = 3705,
  [4152] = 3746,
  [4153] = 3745,
  [4154] = 3562,
  [4155] = 3776,
  [4156] = 3734,
  [4157] = 3781,
  [4158] = 3632,
  [4159] = 3750,
  [4160] = 3765,
  [4161] = 3751,
  [4162] = 4095,
  [4163] = 3745,
  [4164] = 3746,
  [4165] = 3577,
  [4166] = 3740,
  [4167] = 3692,
  [4168] = 3745,
  [4169] = 3799,
  [4170] = 3748,
  [4171] = 3787,
  [4172] = 3591,
  [4173] = 3756,
  [4174] = 3737,
  [4175] = 4058,
  [4176] = 3757,
  [4177] = 3758,
  [4178] = 3853,
  [4179] = 3738,
  [4180] = 3771,
  [4181] = 3577,
  [4182] = 3591,
  [4183] = 3765,
  [4184] = 3576,
  [4185] = 3761,
  [4186] = 3773,
  [4187] = 3778,
  [4188] = 3562,
  [4189] = 3775,
  [4190] = 3489,
  [4191] = 3801,
  [4192] = 3677,
  [4193] = 3543,
  [4194] = 3817,
  [4195] = 3767,
  [4196] = 3817,
  [4197] = 4129,
  [4198] = 3763,
  [4199] = 3767,
  [4200] = 4079,
  [4201] = 3768,
  [4202] = 3772,
  [4203] = 3832,
  [4204] = 4095,
  [4205] = 3843,
  [4206] = 3734,
  [4207] = 3825,
  [4208] = 3748,
  [4209] = 3600,
  [4210] = 3543,
  [4211] = 3576,
  [4212] = 3470,
  [4213] = 3705,
  [4214] = 4129,
  [4215] = 3470,
  [4216] = 3600,
  [4217] = 3752,
  [4218] = 3813,
  [4219] = 3705,
  [4220] = 3813,
  [4221] = 3632,
  [4222] = 3692,
  [4223] = 3468,
  [4224] = 3774,
  [4225] = 3668,
  [4226] = 3606,
  [4227] = 3482,
  [4228] = 3468,
  [4229] = 3546,
  [4230] = 3632,
  [4231] = 3785,
  [4232] = 3468,
  [4233] = 3471,
  [4234] = 3489,
  [4235] = 3740,
  [4236] = 3600,
  [4237] = 3750,
  [4238] = 3577,
  [4239] = 3591,
  [4240] = 3608,
  [4241] = 3597,
  [4242] = 3908,
  [4243] = 3692,
  [4244] = 3547,
  [4245] = 3471,
  [4246] = 3745,
  [4247] = 3824,
  [4248] = 3825,
  [4249] = 3799,
  [4250] = 3746,
  [4251] = 3481,
  [4252] = 3908,
  [4253] = 3481,
  [4254] = 3600,
  [4255] = 3705,
  [4256] = 3705,
  [4257] = 3471,
  [4258] = 3751,
  [4259] = 3747,
  [4260] = 3809,
  [4261] = 3692,
  [4262] = 3468,
  [4263] = 3481,
  [4264] = 3908,
  [4265] = 3471,
  [4266] = 3470,
  [4267] = 3753,
  [4268] = 3470,
  [4269] = 3744,
  [4270] = 3760,
  [4271] = 3743,
  [4272] = 3468,
  [4273] = 4273,
  [4274] = 3829,
  [4275] = 4079,
  [4276] = 3762,
  [4277] = 3742,
  [4278] = 3692,
  [4279] = 3470,
  [4280] = 3549,
  [4281] = 3764,
  [4282] = 3766,
  [4283] = 3801,
  [4284] = 4058,
  [4285] = 3470,
  [4286] = 3692,
  [4287] = 3770,
  [4288] = 3471,
  [4289] = 3771,
  [4290] = 3801,
  [4291] = 3773,
  [4292] = 3562,
  [4293] = 3632,
  [4294] = 3739,
  [4295] = 3853,
  [4296] = 3738,
  [4297] = 3775,
  [4298] = 3787,
  [4299] = 3468,
  [4300] = 3776,
  [4301] = 3754,
  [4302] = 3692,
  [4303] = 3853,
  [4304] = 3600,
  [4305] = 3677,
  [4306] = 3705,
  [4307] = 3600,
  [4308] = 3471,
  [4309] = 3470,
  [4310] = 3788,
  [4311] = 3705,
  [4312] = 3749,
  [4313] = 3756,
  [4314] = 3784,
  [4315] = 3832,
  [4316] = 3757,
  [4317] = 3468,
  [4318] = 3783,
  [4319] = 3471,
  [4320] = 3737,
  [4321] = 3778,
  [4322] = 3470,
  [4323] = 3758,
  [4324] = 3782,
  [4325] = 3514,
  [4326] = 3761,
  [4327] = 3779,
  [4328] = 3763,
  [4329] = 3735,
  [4330] = 3809,
  [4331] = 3765,
  [4332] = 3511,
  [4333] = 4273,
  [4334] = 3470,
  [4335] = 3471,
  [4336] = 3843,
  [4337] = 3829,
  [4338] = 3781,
  [4339] = 3468,
  [4340] = 3767,
  [4341] = 3824,
  [4342] = 3471,
  [4343] = 3632,
  [4344] = 3632,
  [4345] = 3799,
  [4346] = 3468,
  [4347] = 3772,
  [4348] = 3768,
  [4349] = 3763,
  [4350] = 3757,
  [4351] = 3705,
  [4352] = 3749,
  [4353] = 3734,
  [4354] = 3756,
  [4355] = 3481,
  [4356] = 3757,
  [4357] = 3758,
  [4358] = 3470,
  [4359] = 3734,
  [4360] = 3761,
  [4361] = 3692,
  [4362] = 3748,
  [4363] = 4129,
  [4364] = 3737,
  [4365] = 3763,
  [4366] = 3765,
  [4367] = 3767,
  [4368] = 3768,
  [4369] = 3770,
  [4370] = 3772,
  [4371] = 3781,
  [4372] = 3785,
  [4373] = 3754,
  [4374] = 3740,
  [4375] = 3735,
  [4376] = 3779,
  [4377] = 3782,
  [4378] = 3799,
  [4379] = 3783,
  [4380] = 3784,
  [4381] = 3788,
  [4382] = 3801,
  [4383] = 3562,
  [4384] = 3843,
  [4385] = 3753,
  [4386] = 3600,
  [4387] = 3748,
  [4388] = 3908,
  [4389] = 3776,
  [4390] = 4125,
  [4391] = 3576,
  [4392] = 3787,
  [4393] = 3775,
  [4394] = 3773,
  [4395] = 3771,
  [4396] = 3489,
  [4397] = 3853,
  [4398] = 3809,
  [4399] = 3766,
  [4400] = 3471,
  [4401] = 3549,
  [4402] = 3632,
  [4403] = 3813,
  [4404] = 4058,
  [4405] = 4079,
  [4406] = 3705,
  [4407] = 3546,
  [4408] = 3824,
  [4409] = 3785,
  [4410] = 3829,
  [4411] = 3481,
  [4412] = 3832,
  [4413] = 3737,
  [4414] = 3511,
  [4415] = 3750,
  [4416] = 3677,
  [4417] = 3692,
  [4418] = 3632,
  [4419] = 3549,
  [4420] = 3778,
  [4421] = 3740,
  [4422] = 3738,
  [4423] = 4095,
  [4424] = 3543,
  [4425] = 3632,
  [4426] = 3739,
  [4427] = 3825,
  [4428] = 3705,
  [4429] = 3547,
  [4430] = 3764,
  [4431] = 4095,
  [4432] = 3692,
  [4433] = 3752,
  [4434] = 3600,
  [4435] = 3562,
  [4436] = 3677,
  [4437] = 4079,
  [4438] = 4058,
  [4439] = 3742,
  [4440] = 3489,
  [4441] = 3511,
  [4442] = 3743,
  [4443] = 3576,
  [4444] = 3744,
  [4445] = 3747,
  [4446] = 3514,
  [4447] = 3632,
  [4448] = 3762,
  [4449] = 3774,
  [4450] = 3481,
  [4451] = 3543,
  [4452] = 3600,
  [4453] = 3749,
  [4454] = 3514,
  [4455] = 3752,
  [4456] = 3597,
  [4457] = 3750,
  [4458] = 3577,
  [4459] = 3745,
  [4460] = 3608,
  [4461] = 3746,
  [4462] = 3753,
  [4463] = 3754,
  [4464] = 3705,
  [4465] = 3600,
  [4466] = 3576,
  [4467] = 3756,
  [4468] = 3562,
  [4469] = 3758,
  [4470] = 3562,
  [4471] = 3489,
  [4472] = 3761,
  [4473] = 3763,
  [4474] = 3591,
  [4475] = 3765,
  [4476] = 3767,
  [4477] = 3768,
  [4478] = 3770,
  [4479] = 3772,
  [4480] = 3781,
  [4481] = 3735,
  [4482] = 3779,
  [4483] = 3782,
  [4484] = 3783,
  [4485] = 3784,
  [4486] = 3577,
  [4487] = 3788,
  [4488] = 3776,
  [4489] = 3787,
  [4490] = 3546,
  [4491] = 3543,
  [4492] = 3775,
  [4493] = 3773,
  [4494] = 3771,
  [4495] = 3766,
  [4496] = 3764,
  [4497] = 3547,
  [4498] = 3471,
  [4499] = 3597,
  [4500] = 3608,
  [4501] = 3692,
  [4502] = 3677,
  [4503] = 3591,
  [4504] = 3577,
  [4505] = 3546,
  [4506] = 3668,
  [4507] = 3778,
  [4508] = 3606,
  [4509] = 3482,
  [4510] = 3737,
  [4511] = 3692,
  [4512] = 3738,
  [4513] = 3482,
  [4514] = 3606,
  [4515] = 3546,
  [4516] = 3577,
  [4517] = 3591,
  [4518] = 3705,
  [4519] = 3608,
  [4520] = 3597,
  [4521] = 3547,
  [4522] = 3482,
  [4523] = 3739,
  [4524] = 3742,
  [4525] = 3606,
  [4526] = 3543,
  [4527] = 3608,
  [4528] = 3743,
  [4529] = 3744,
  [4530] = 3705,
  [4531] = 3692,
  [4532] = 4095,
  [4533] = 3668,
  [4534] = 3668,
  [4535] = 3471,
  [4536] = 4079,
  [4537] = 3747,
  [4538] = 3734,
  [4539] = 4058,
  [4540] = 3705,
  [4541] = 3746,
  [4542] = 3745,
  [4543] = 3632,
  [4544] = 3748,
  [4545] = 3908,
  [4546] = 3470,
  [4547] = 3511,
  [4548] = 3692,
  [4549] = 3470,
  [4550] = 3774,
  [4551] = 3543,
  [4552] = 3471,
  [4553] = 3762,
  [4554] = 3747,
  [4555] = 3744,
  [4556] = 3677,
  [4557] = 3743,
  [4558] = 3511,
  [4559] = 3742,
  [4560] = 3481,
  [4561] = 3739,
  [4562] = 3470,
  [4563] = 3470,
  [4564] = 3764,
  [4565] = 3766,
  [4566] = 3762,
  [4567] = 3774,
  [4568] = 3738,
  [4569] = 3771,
  [4570] = 3773,
  [4571] = 3775,
  [4572] = 3549,
  [4573] = 3481,
  [4574] = 3632,
  [4575] = 3785,
  [4576] = 3787,
  [4577] = 3481,
  [4578] = 3776,
  [4579] = 3576,
  [4580] = 3489,
  [4581] = 3468,
  [4582] = 3549,
  [4583] = 3788,
  [4584] = 3784,
  [4585] = 3783,
  [4586] = 4273,
  [4587] = 3782,
  [4588] = 4129,
  [4589] = 3779,
  [4590] = 3740,
  [4591] = 4058,
  [4592] = 3745,
  [4593] = 3514,
  [4594] = 3735,
  [4595] = 3632,
  [4596] = 3468,
  [4597] = 3778,
  [4598] = 3746,
  [4599] = 3781,
  [4600] = 3600,
  [4601] = 3772,
  [4602] = 3778,
  [4603] = 3751,
  [4604] = 3738,
  [4605] = 3770,
  [4606] = 3768,
  [4607] = 3767,
  [4608] = 3765,
  [4609] = 3763,
  [4610] = 3761,
  [4611] = 3468,
  [4612] = 3758,
  [4613] = 3757,
  [4614] = 3756,
  [4615] = 3549,
  [4616] = 3751,
  [4617] = 3739,
  [4618] = 3742,
  [4619] = 3743,
  [4620] = 3744,
  [4621] = 3597,
  [4622] = 3747,
  [4623] = 3677,
  [4624] = 4079,
  [4625] = 3470,
  [4626] = 3754,
  [4627] = 3753,
  [4628] = 3471,
  [4629] = 3481,
  [4630] = 3543,
  [4631] = 3514,
  [4632] = 3471,
  [4633] = 3750,
  [4634] = 3668,
  [4635] = 3606,
  [4636] = 3482,
  [4637] = 3546,
  [4638] = 3562,
  [4639] = 3760,
  [4640] = 3577,
  [4641] = 3591,
  [4642] = 3751,
  [4643] = 3608,
  [4644] = 3597,
  [4645] = 3677,
  [4646] = 3762,
  [4647] = 3774,
  [4648] = 3760,
  [4649] = 3489,
  [4650] = 3752,
  [4651] = 3470,
  [4652] = 3547,
  [4653] = 3760,
  [4654] = 3576,
  [4655] = 3668,
  [4656] = 3606,
  [4657] = 3482,
  [4658] = 3562,
  [4659] = 3468,
  [4660] = 4095,
  [4661] = 3471,
  [4662] = 3511,
  [4663] = 3752,
  [4664] = 3677,
  [4665] = 3514,
  [4666] = 3600,
  [4667] = 3745,
  [4668] = 3746,
  [4669] = 3750,
  [4670] = 3546,
  [4671] = 3577,
  [4672] = 3562,
  [4673] = 3753,
  [4674] = 3908,
  [4675] = 4079,
  [4676] = 3591,
  [4677] = 4058,
  [4678] = 3754,
  [4679] = 3608,
  [4680] = 3481,
  [4681] = 3597,
  [4682] = 3600,
  [4683] = 3705,
  [4684] = 3749,
  [4685] = 3756,
  [4686] = 3757,
  [4687] = 3758,
  [4688] = 3761,
  [4689] = 3765,
  [4690] = 3767,
  [4691] = 3746,
  [4692] = 3768,
  [4693] = 3770,
  [4694] = 3772,
  [4695] = 3781,
  [4696] = 3547,
  [4697] = 3735,
  [4698] = 3779,
  [4699] = 3782,
  [4700] = 3745,
  [4701] = 3783,
  [4702] = 3784,
  [4703] = 3788,
  [4704] = 3760,
  [4705] = 3776,
  [4706] = 3511,
  [4707] = 3787,
  [4708] = 3775,
  [4709] = 3773,
  [4710] = 3771,
  [4711] = 3692,
  [4712] = 3766,
  [4713] = 3481,
  [4714] = 3764,
  [4715] = 3774,
  [4716] = 3471,
  [4717] = 3751,
  [4718] = 3762,
  [4719] = 3591,
  [4720] = 3468,
  [4721] = 3562,
  [4722] = 3740,
  [4723] = 4095,
  [4724] = 3514,
  [4725] = 3677,
  [4726] = 3751,
  [4727] = 3511,
  [4728] = 3760,
  [4729] = 3547,
  [4730] = 3668,
  [4731] = 3606,
  [4732] = 3482,
  [4733] = 3470,
  [4734] = 3546,
  [4735] = 3577,
  [4736] = 3747,
  [4737] = 3744,
  [4738] = 3591,
  [4739] = 3608,
  [4740] = 3597,
  [4741] = 3547,
  [4742] = 3748,
  [4743] = 3734,
  [4744] = 3737,
  [4745] = 3743,
  [4746] = 3734,
  [4747] = 3742,
  [4748] = 4129,
  [4749] = 3600,
  [4750] = 3739,
  [4751] = 3748,
  [4752] = 3785,
  [4753] = 3738,
  [4754] = 3778,
  [4755] = 3785,
  [4756] = 3549,
  [4757] = 3543,
  [4758] = 3740,
  [4759] = 3543,
  [4760] = 3562,
  [4761] = 3514,
  [4762] = 3489,
  [4763] = 3576,
  [4764] = 3778,
  [4765] = 3738,
  [4766] = 3739,
  [4767] = 3742,
  [4768] = 3743,
  [4769] = 3744,
  [4770] = 3747,
  [4771] = 3547,
  [4772] = 3481,
  [4773] = 3762,
  [4774] = 3774,
  [4775] = 3468,
  [4776] = 3740,
  [4777] = 3468,
  [4778] = 3752,
  [4779] = 3785,
  [4780] = 3748,
  [4781] = 3597,
  [4782] = 3632,
  [4783] = 3734,
  [4784] = 3546,
  [4785] = 3737,
  [4786] = 3608,
  [4787] = 3750,
  [4788] = 3745,
  [4789] = 3746,
  [4790] = 3677,
  [4791] = 3514,
  [4792] = 3753,
  [4793] = 3591,
  [4794] = 3754,
  [4795] = 3549,
  [4796] = 3482,
  [4797] = 3606,
  [4798] = 3749,
  [4799] = 3577,
  [4800] = 3547,
  [4801] = 3546,
  [4802] = 3760,
  [4803] = 3756,
  [4804] = 3757,
  [4805] = 3758,
  [4806] = 3600,
  [4807] = 3761,
  [4808] = 3763,
  [4809] = 3765,
  [4810] = 3481,
  [4811] = 3514,
  [4812] = 3767,
  [4813] = 3668,
  [4814] = 3908,
  [4815] = 3768,
  [4816] = 3482,
  [4817] = 3668,
  [4818] = 3543,
  [4819] = 3606,
  [4820] = 3751,
  [4821] = 3770,
  [4822] = 3772,
  [4823] = 3781,
  [4824] = 3549,
  [4825] = 3576,
  [4826] = 3489,
  [4827] = 3692,
  [4828] = 3705,
  [4829] = 3576,
  [4830] = 3511,
  [4831] = 3468,
  [4832] = 3481,
  [4833] = 3549,
  [4834] = 3597,
  [4835] = 3764,
  [4836] = 3735,
  [4837] = 3766,
  [4838] = 3908,
  [4839] = 3779,
  [4840] = 3489,
  [4841] = 3489,
  [4842] = 3608,
  [4843] = 3668,
  [4844] = 3771,
  [4845] = 3576,
  [4846] = 3591,
  [4847] = 3782,
  [4848] = 3783,
  [4849] = 3773,
  [4850] = 3775,
  [4851] = 3787,
  [4852] = 3776,
  [4853] = 3784,
  [4854] = 3737,
  [4855] = 3749,
  [4856] = 3606,
  [4857] = 3482,
  [4858] = 3788,
  [4859] = 3577,
  [4860] = 3774,
  [4861] = 3549,
  [4862] = 3813,
  [4863] = 4129,
  [4864] = 3740,
  [4865] = 3745,
  [4866] = 3511,
  [4867] = 3746,
  [4868] = 3824,
  [4869] = 3776,
  [4870] = 3829,
  [4871] = 3801,
  [4872] = 3787,
  [4873] = 3775,
  [4874] = 3832,
  [4875] = 3799,
  [4876] = 3773,
  [4877] = 3744,
  [4878] = 4129,
  [4879] = 3747,
  [4880] = 3746,
  [4881] = 3745,
  [4882] = 3771,
  [4883] = 3751,
  [4884] = 3740,
  [4885] = 3843,
  [4886] = 3785,
  [4887] = 3774,
  [4888] = 3762,
  [4889] = 3760,
  [4890] = 3766,
  [4891] = 3785,
  [4892] = 3743,
  [4893] = 3774,
  [4894] = 3748,
  [4895] = 3762,
  [4896] = 3764,
  [4897] = 3788,
  [4898] = 3762,
  [4899] = 3784,
  [4900] = 3762,
  [4901] = 3734,
  [4902] = 3600,
  [4903] = 3744,
  [4904] = 3843,
  [4905] = 3783,
  [4906] = 3774,
  [4907] = 3782,
  [4908] = 3799,
  [4909] = 3779,
  [4910] = 3748,
  [4911] = 3734,
  [4912] = 3692,
  [4913] = 3511,
  [4914] = 4058,
  [4915] = 3752,
  [4916] = 3853,
  [4917] = 3743,
  [4918] = 3742,
  [4919] = 4079,
  [4920] = 3739,
  [4921] = 3747,
  [4922] = 3738,
  [4923] = 3737,
  [4924] = 3778,
  [4925] = 3549,
  [4926] = 3751,
  [4927] = 3825,
  [4928] = 3744,
  [4929] = 3743,
  [4930] = 3705,
  [4931] = 3750,
  [4932] = 3742,
  [4933] = 3739,
  [4934] = 3735,
  [4935] = 4095,
  [4936] = 3511,
  [4937] = 3511,
  [4938] = 3489,
  [4939] = 3576,
  [4940] = 3481,
  [4941] = 3514,
  [4942] = 3753,
  [4943] = 3751,
  [4944] = 4058,
  [4945] = 3745,
  [4946] = 3801,
  [4947] = 3754,
  [4948] = 4079,
  [4949] = 3481,
  [4950] = 3778,
  [4951] = 3737,
  [4952] = 3738,
  [4953] = 3739,
  [4954] = 3746,
  [4955] = 3756,
  [4956] = 3760,
  [4957] = 3757,
  [4958] = 3758,
  [4959] = 3752,
  [4960] = 3761,
  [4961] = 3742,
  [4962] = 3668,
  [4963] = 3743,
  [4964] = 3744,
  [4965] = 3763,
  [4966] = 3765,
  [4967] = 3767,
  [4968] = 3768,
  [4969] = 3770,
  [4970] = 3772,
  [4971] = 3749,
  [4972] = 3514,
  [4973] = 4095,
  [4974] = 3760,
  [4975] = 4129,
  [4976] = 3511,
  [4977] = 3781,
  [4978] = 3543,
  [4979] = 3543,
  [4980] = 3738,
  [4981] = 3606,
  [4982] = 3737,
  [4983] = 3778,
  [4984] = 3809,
  [4985] = 3813,
  [4986] = 3781,
  [4987] = 3772,
  [4988] = 3760,
  [4989] = 3677,
  [4990] = 3734,
  [4991] = 3748,
  [4992] = 3762,
  [4993] = 3770,
  [4994] = 3768,
  [4995] = 3774,
  [4996] = 3750,
  [4997] = 3735,
  [4998] = 3576,
  [4999] = 3779,
  [5000] = 3785,
  [5001] = 3562,
  [5002] = 3482,
  [5003] = 3751,
  [5004] = 3782,
  [5005] = 3751,
  [5006] = 3677,
  [5007] = 3783,
  [5008] = 3760,
  [5009] = 3547,
  [5010] = 3832,
  [5011] = 3546,
  [5012] = 3784,
  [5013] = 3788,
  [5014] = 3829,
  [5015] = 3824,
  [5016] = 3577,
  [5017] = 3591,
  [5018] = 4125,
  [5019] = 3767,
  [5020] = 3562,
  [5021] = 3632,
  [5022] = 3597,
  [5023] = 3608,
  [5024] = 3489,
  [5025] = 3813,
  [5026] = 3765,
  [5027] = 3809,
  [5028] = 3576,
  [5029] = 3591,
  [5030] = 3824,
  [5031] = 3577,
  [5032] = 3547,
  [5033] = 3511,
  [5034] = 3489,
  [5035] = 3668,
  [5036] = 3776,
  [5037] = 3801,
  [5038] = 3787,
  [5039] = 3799,
  [5040] = 3775,
  [5041] = 3543,
  [5042] = 3773,
  [5043] = 3771,
  [5044] = 3763,
  [5045] = 4095,
  [5046] = 3597,
  [5047] = 3632,
  [5048] = 3608,
  [5049] = 3546,
  [5050] = 3606,
  [5051] = 3482,
  [5052] = 3766,
  [5053] = 3843,
  [5054] = 3764,
  [5055] = 3608,
  [5056] = 3740,
  [5057] = 3597,
  [5058] = 3853,
  [5059] = 3745,
  [5060] = 3746,
  [5061] = 3547,
  [5062] = 3668,
  [5063] = 3546,
  [5064] = 3747,
  [5065] = 3606,
  [5066] = 3577,
  [5067] = 3543,
  [5068] = 3591,
  [5069] = 3482,
  [5070] = 3825,
  [5071] = 3705,
  [5072] = 3482,
  [5073] = 3608,
  [5074] = 3597,
  [5075] = 3546,
  [5076] = 3632,
  [5077] = 3481,
  [5078] = 3606,
  [5079] = 3549,
  [5080] = 3547,
  [5081] = 3677,
  [5082] = 3577,
  [5083] = 3514,
  [5084] = 3591,
  [5085] = 3549,
  [5086] = 4095,
  [5087] = 3829,
  [5088] = 3562,
  [5089] = 3668,
  [5090] = 3749,
  [5091] = 3591,
  [5092] = 3577,
  [5093] = 3514,
  [5094] = 3608,
  [5095] = 3514,
  [5096] = 3546,
  [5097] = 3692,
  [5098] = 3597,
  [5099] = 3482,
  [5100] = 4079,
  [5101] = 4058,
  [5102] = 4129,
  [5103] = 3761,
  [5104] = 3481,
  [5105] = 3677,
  [5106] = 3764,
  [5107] = 3766,
  [5108] = 3606,
  [5109] = 3853,
  [5110] = 3549,
  [5111] = 3825,
  [5112] = 3764,
  [5113] = 3771,
  [5114] = 3773,
  [5115] = 3775,
  [5116] = 3766,
  [5117] = 3787,
  [5118] = 3776,
  [5119] = 3771,
  [5120] = 3773,
  [5121] = 3775,
  [5122] = 3787,
  [5123] = 3776,
  [5124] = 3668,
  [5125] = 3489,
  [5126] = 3788,
  [5127] = 3784,
  [5128] = 3677,
  [5129] = 3576,
  [5130] = 3788,
  [5131] = 3784,
  [5132] = 3783,
  [5133] = 3783,
  [5134] = 3782,
  [5135] = 3668,
  [5136] = 3779,
  [5137] = 3782,
  [5138] = 3735,
  [5139] = 3481,
  [5140] = 3779,
  [5141] = 3562,
  [5142] = 4079,
  [5143] = 3781,
  [5144] = 3853,
  [5145] = 3772,
  [5146] = 3770,
  [5147] = 3832,
  [5148] = 3735,
  [5149] = 3768,
  [5150] = 3767,
  [5151] = 3471,
  [5152] = 3765,
  [5153] = 3763,
  [5154] = 3606,
  [5155] = 3843,
  [5156] = 3758,
  [5157] = 3482,
  [5158] = 3761,
  [5159] = 3825,
  [5160] = 3758,
  [5161] = 3757,
  [5162] = 3756,
  [5163] = 3750,
  [5164] = 3514,
  [5165] = 3757,
  [5166] = 3746,
  [5167] = 3745,
  [5168] = 3756,
  [5169] = 3576,
  [5170] = 3489,
  [5171] = 3781,
  [5172] = 4058,
  [5173] = 3740,
  [5174] = 3754,
  [5175] = 3546,
  [5176] = 3753,
  [5177] = 3577,
  [5178] = 3591,
  [5179] = 3772,
  [5180] = 3770,
  [5181] = 3768,
  [5182] = 3750,
  [5183] = 3799,
  [5184] = 3608,
  [5185] = 3597,
  [5186] = 3767,
  [5187] = 3752,
  [5188] = 3801,
  [5189] = 3765,
  [5190] = 3547,
  [5191] = 3763,
  [5192] = 3549,
  [5193] = 4058,
  [5194] = 3752,
  [5195] = 4079,
  [5196] = 3742,
  [5197] = 3750,
  [5198] = 3547,
  [5199] = 3468,
  [5200] = 3597,
  [5201] = 3749,
  [5202] = 3809,
  [5203] = 3813,
  [5204] = 3608,
  [5205] = 3739,
  [5206] = 3738,
  [5207] = 4095,
  [5208] = 3753,
  [5209] = 3754,
  [5210] = 3824,
  [5211] = 3746,
  [5212] = 3829,
  [5213] = 3745,
  [5214] = 3591,
  [5215] = 3832,
  [5216] = 3562,
  [5217] = 3543,
  [5218] = 3481,
  [5219] = 3562,
  [5220] = 3761,
  [5221] = 3754,
  [5222] = 3577,
  [5223] = 3753,
  [5224] = 3511,
  [5225] = 3749,
  [5226] = 3758,
  [5227] = 3764,
  [5228] = 3766,
  [5229] = 3489,
  [5230] = 3753,
  [5231] = 3757,
  [5232] = 3771,
  [5233] = 3773,
  [5234] = 3775,
  [5235] = 3787,
  [5236] = 3776,
  [5237] = 3756,
  [5238] = 3785,
  [5239] = 3778,
  [5240] = 3737,
  [5241] = 3738,
  [5242] = 3760,
  [5243] = 3788,
  [5244] = 3784,
  [5245] = 3756,
  [5246] = 3783,
  [5247] = 3782,
  [5248] = 3757,
  [5249] = 3779,
  [5250] = 3774,
  [5251] = 3677,
  [5252] = 3735,
  [5253] = 3758,
  [5254] = 3762,
  [5255] = 3576,
  [5256] = 3739,
  [5257] = 3742,
  [5258] = 3748,
  [5259] = 3471,
  [5260] = 3743,
  [5261] = 3744,
  [5262] = 3761,
  [5263] = 3747,
  [5264] = 3734,
  [5265] = 3734,
  [5266] = 3748,
  [5267] = 3747,
  [5268] = 3781,
  [5269] = 3754,
  [5270] = 3772,
  [5271] = 3770,
  [5272] = 3768,
  [5273] = 3767,
  [5274] = 3763,
  [5275] = 3765,
  [5276] = 3763,
  [5277] = 3761,
  [5278] = 3744,
  [5279] = 3758,
  [5280] = 3757,
  [5281] = 3756,
  [5282] = 3743,
  [5283] = 3762,
  [5284] = 3774,
  [5285] = 3785,
  [5286] = 3742,
  [5287] = 3749,
  [5288] = 3765,
  [5289] = 4095,
  [5290] = 3543,
  [5291] = 3754,
  [5292] = 3753,
  [5293] = 3785,
  [5294] = 3562,
  [5295] = 3737,
  [5296] = 3767,
  [5297] = 3768,
  [5298] = 3770,
  [5299] = 3739,
  [5300] = 3746,
  [5301] = 3740,
  [5302] = 3772,
  [5303] = 3745,
  [5304] = 3746,
  [5305] = 3745,
  [5306] = 3470,
  [5307] = 3781,
  [5308] = 3751,
  [5309] = 3546,
  [5310] = 3747,
  [5311] = 3809,
  [5312] = 3547,
  [5313] = 3737,
  [5314] = 3752,
  [5315] = 3677,
  [5316] = 3774,
  [5317] = 3734,
  [5318] = 3748,
  [5319] = 3747,
  [5320] = 3760,
  [5321] = 3744,
  [5322] = 3743,
  [5323] = 3753,
  [5324] = 3742,
  [5325] = 3739,
  [5326] = 3738,
  [5327] = 3778,
  [5328] = 3738,
  [5329] = 3549,
  [5330] = 3785,
  [5331] = 3749,
  [5332] = 3705,
  [5333] = 3737,
  [5334] = 3489,
  [5335] = 3740,
  [5336] = 3576,
  [5337] = 3778,
  [5338] = 3762,
  [5339] = 3751,
  [5340] = 3778,
  [5341] = 3543,
  [5342] = 4079,
  [5343] = 3760,
  [5344] = 3482,
  [5345] = 3481,
  [5346] = 3735,
  [5347] = 3746,
  [5348] = 4058,
  [5349] = 3740,
  [5350] = 3754,
  [5351] = 3734,
  [5352] = 3748,
  [5353] = 3606,
  [5354] = 3778,
  [5355] = 3782,
  [5356] = 3783,
  [5357] = 3468,
  [5358] = 3745,
  [5359] = 3748,
  [5360] = 3749,
  [5361] = 3734,
  [5362] = 3785,
  [5363] = 3750,
  [5364] = 3737,
  [5365] = 3562,
  [5366] = 3764,
  [5367] = 3766,
  [5368] = 3740,
  [5369] = 3751,
  [5370] = 3600,
  [5371] = 3514,
  [5372] = 3771,
  [5373] = 3677,
  [5374] = 3773,
  [5375] = 3775,
  [5376] = 3832,
  [5377] = 3787,
  [5378] = 3784,
  [5379] = 3829,
  [5380] = 3824,
  [5381] = 3776,
  [5382] = 3750,
  [5383] = 3785,
  [5384] = 3788,
  [5385] = 3747,
  [5386] = 3813,
  [5387] = 3809,
  [5388] = 3774,
  [5389] = 3744,
  [5390] = 3788,
  [5391] = 3784,
  [5392] = 3783,
  [5393] = 3782,
  [5394] = 3801,
  [5395] = 3743,
  [5396] = 3799,
  [5397] = 3762,
  [5398] = 3738,
  [5399] = 3779,
  [5400] = 3749,
  [5401] = 3668,
  [5402] = 3779,
  [5403] = 3735,
  [5404] = 3776,
  [5405] = 3470,
  [5406] = 3787,
  [5407] = 3843,
  [5408] = 3775,
  [5409] = 3752,
  [5410] = 3773,
  [5411] = 3771,
  [5412] = 3853,
  [5413] = 3740,
  [5414] = 3576,
  [5415] = 3756,
  [5416] = 3742,
  [5417] = 3781,
  [5418] = 3772,
  [5419] = 3825,
  [5420] = 3489,
  [5421] = 3770,
  [5422] = 3752,
  [5423] = 3768,
  [5424] = 3514,
  [5425] = 3767,
  [5426] = 3765,
  [5427] = 3760,
  [5428] = 3763,
  [5429] = 3757,
  [5430] = 4129,
  [5431] = 3543,
  [5432] = 3739,
  [5433] = 3751,
  [5434] = 3748,
  [5435] = 3758,
  [5436] = 3692,
  [5437] = 3734,
  [5438] = 3764,
  [5439] = 3766,
  [5440] = 3747,
  [5441] = 3744,
  [5442] = 3771,
  [5443] = 3773,
  [5444] = 3775,
  [5445] = 3787,
  [5446] = 3776,
  [5447] = 3743,
  [5448] = 3742,
  [5449] = 3788,
  [5450] = 3784,
  [5451] = 3783,
  [5452] = 3782,
  [5453] = 3668,
  [5454] = 3779,
  [5455] = 3739,
  [5456] = 3735,
  [5457] = 3738,
  [5458] = 3737,
  [5459] = 3781,
  [5460] = 3772,
  [5461] = 3770,
  [5462] = 3768,
  [5463] = 3767,
  [5464] = 3765,
  [5465] = 3763,
  [5466] = 3606,
  [5467] = 3482,
  [5468] = 3761,
  [5469] = 3778,
  [5470] = 3758,
  [5471] = 3757,
  [5472] = 3756,
  [5473] = 3547,
  [5474] = 3600,
  [5475] = 3766,
  [5476] = 3764,
  [5477] = 3752,
  [5478] = 3754,
  [5479] = 3546,
  [5480] = 3753,
  [5481] = 3549,
  [5482] = 3577,
  [5483] = 3591,
  [5484] = 3481,
  [5485] = 3597,
  [5486] = 3761,
  [5487] = 3750,
  [5488] = 3608,
  [5489] = 3546,
  [5490] = 3766,
  [5491] = 3600,
  [5492] = 3843,
  [5493] = 3785,
  [5494] = 3597,
  [5495] = 3774,
  [5496] = 3853,
  [5497] = 3832,
  [5498] = 3843,
  [5499] = 3489,
  [5500] = 3799,
  [5501] = 3801,
  [5502] = 3809,
  [5503] = 3813,
  [5504] = 3591,
  [5505] = 3824,
  [5506] = 3829,
  [5507] = 3832,
  [5508] = 3482,
  [5509] = 3606,
  [5510] = 3829,
  [5511] = 3762,
  [5512] = 3749,
  [5513] = 3751,
  [5514] = 3824,
  [5515] = 3577,
  [5516] = 3809,
  [5517] = 3799,
  [5518] = 3801,
  [5519] = 3668,
  [5520] = 3853,
  [5521] = 3809,
  [5522] = 3562,
  [5523] = 3760,
  [5524] = 3809,
  [5525] = 3813,
  [5526] = 3824,
  [5527] = 3778,
  [5528] = 3749,
  [5529] = 3705,
  [5530] = 3829,
  [5531] = 3737,
  [5532] = 3750,
  [5533] = 3825,
  [5534] = 3832,
  [5535] = 3481,
  [5536] = 3481,
  [5537] = 3787,
  [5538] = 3801,
  [5539] = 3829,
  [5540] = 3753,
  [5541] = 3825,
  [5542] = 3692,
  [5543] = 3705,
  [5544] = 3745,
  [5545] = 3746,
  [5546] = 3825,
  [5547] = 3562,
  [5548] = 3853,
  [5549] = 3843,
  [5550] = 3738,
  [5551] = 3470,
  [5552] = 3677,
  [5553] = 3843,
  [5554] = 3608,
  [5555] = 3799,
  [5556] = 3692,
  [5557] = 3468,
  [5558] = 3576,
  [5559] = 3668,
  [5560] = 3801,
  [5561] = 3809,
  [5562] = 3853,
  [5563] = 3514,
  [5564] = 3813,
  [5565] = 3824,
  [5566] = 3829,
  [5567] = 3482,
  [5568] = 3832,
  [5569] = 3853,
  [5570] = 3546,
  [5571] = 3843,
  [5572] = 3471,
  [5573] = 3543,
  [5574] = 3825,
  [5575] = 3749,
  [5576] = 3577,
  [5577] = 3597,
  [5578] = 3764,
  [5579] = 3853,
  [5580] = 3771,
  [5581] = 3767,
  [5582] = 3591,
  [5583] = 3825,
  [5584] = 3773,
  [5585] = 3775,
  [5586] = 3776,
  [5587] = 3752,
  [5588] = 3788,
  [5589] = 3853,
  [5590] = 3784,
  [5591] = 3783,
  [5592] = 3843,
  [5593] = 3782,
  [5594] = 3677,
  [5595] = 3779,
  [5596] = 3825,
  [5597] = 3547,
  [5598] = 3799,
  [5599] = 3549,
  [5600] = 3735,
  [5601] = 3801,
  [5602] = 3489,
  [5603] = 3799,
  [5604] = 3778,
  [5605] = 3801,
  [5606] = 3781,
  [5607] = 3751,
  [5608] = 3608,
  [5609] = 3737,
  [5610] = 3738,
  [5611] = 3772,
  [5612] = 3739,
  [5613] = 3742,
  [5614] = 3743,
  [5615] = 3809,
  [5616] = 3813,
  [5617] = 3770,
  [5618] = 3744,
  [5619] = 3809,
  [5620] = 3768,
  [5621] = 3813,
  [5622] = 3606,
  [5623] = 3824,
  [5624] = 3799,
  [5625] = 3740,
  [5626] = 3825,
  [5627] = 3775,
  [5628] = 3747,
  [5629] = 3734,
  [5630] = 3824,
  [5631] = 3748,
  [5632] = 3765,
  [5633] = 3829,
  [5634] = 3843,
  [5635] = 3832,
  [5636] = 3763,
  [5637] = 3547,
  [5638] = 3752,
  [5639] = 3576,
  [5640] = 3752,
  [5641] = 3600,
  [5642] = 3754,
  [5643] = 3762,
  [5644] = 3774,
  [5645] = 3785,
  [5646] = 3761,
  [5647] = 3758,
  [5648] = 3757,
  [5649] = 3756,
  [5650] = 3750,
  [5651] = 3754,
  [5652] = 3753,
  [5653] = 3740,
  [5654] = 3750,
  [5655] = 3745,
  [5656] = 3746,
  [5657] = 3832,
  [5658] = 3705,
  [5659] = 3471,
  [5660] = 3829,
  [5661] = 3824,
  [5662] = 3470,
  [5663] = 3692,
  [5664] = 3813,
  [5665] = 3468,
  [5666] = 3809,
  [5667] = 3764,
  [5668] = 3766,
  [5669] = 3511,
  [5670] = 3753,
  [5671] = 3543,
  [5672] = 3801,
  [5673] = 3799,
  [5674] = 3632,
  [5675] = 3754,
  [5676] = 3760,
  [5677] = 3771,
  [5678] = 3773,
  [5679] = 3832,
  [5680] = 3813,
  [5681] = 3600,
  [5682] = 3787,
  [5683] = 3739,
  [5684] = 3742,
  [5685] = 3825,
  [5686] = 3751,
  [5687] = 3514,
  [5688] = 3776,
  [5689] = 3756,
  [5690] = 3757,
  [5691] = 3799,
  [5692] = 3843,
  [5693] = 3758,
  [5694] = 3853,
  [5695] = 3743,
  [5696] = 3756,
  [5697] = 3761,
  [5698] = 3757,
  [5699] = 3758,
  [5700] = 3746,
  [5701] = 3745,
  [5702] = 3740,
  [5703] = 3763,
  [5704] = 3765,
  [5705] = 3767,
  [5706] = 3761,
  [5707] = 3768,
  [5708] = 3770,
  [5709] = 3772,
  [5710] = 3549,
  [5711] = 3781,
  [5712] = 3801,
  [5713] = 3785,
  [5714] = 3763,
  [5715] = 3765,
  [5716] = 3767,
  [5717] = 3744,
  [5718] = 3774,
  [5719] = 3762,
  [5720] = 3768,
  [5721] = 3788,
  [5722] = 3770,
  [5723] = 3772,
  [5724] = 3735,
  [5725] = 3781,
  [5726] = 3747,
  [5727] = 3779,
  [5728] = 3734,
  [5729] = 3832,
  [5730] = 3782,
  [5731] = 3783,
  [5732] = 3784,
  [5733] = 3788,
  [5734] = 3784,
  [5735] = 3783,
  [5736] = 3782,
  [5737] = 3748,
  [5738] = 3734,
  [5739] = 3829,
  [5740] = 3779,
  [5741] = 3748,
  [5742] = 3776,
  [5743] = 3824,
  [5744] = 3787,
  [5745] = 3775,
  [5746] = 3773,
  [5747] = 3771,
  [5748] = 3747,
  [5749] = 3511,
  [5750] = 3766,
  [5751] = 3764,
  [5752] = 3735,
  [5753] = 3744,
  [5754] = 3760,
  [5755] = 3743,
  [5756] = 3742,
  [5757] = 3739,
  [5758] = 3738,
  [5759] = 3737,
  [5760] = 3813,
  [5761] = 3778,
  [5762] = 3668,
  [5763] = 3468,
  [5764] = 3829,
  [5765] = 3832,
  [5766] = 3760,
  [5767] = 3749,
  [5768] = 3751,
  [5769] = 3737,
  [5770] = 3734,
  [5771] = 3748,
  [5772] = 3785,
  [5773] = 3740,
  [5774] = 3778,
  [5775] = 3738,
  [5776] = 3739,
  [5777] = 3742,
  [5778] = 3743,
  [5779] = 3744,
  [5780] = 3747,
  [5781] = 3762,
  [5782] = 3774,
  [5783] = 3745,
  [5784] = 3746,
  [5785] = 3751,
  [5786] = 3752,
  [5787] = 3705,
  [5788] = 3481,
  [5789] = 3471,
  [5790] = 3753,
  [5791] = 3754,
  [5792] = 3692,
  [5793] = 3600,
  [5794] = 3470,
  [5795] = 3756,
  [5796] = 3757,
  [5797] = 3758,
  [5798] = 3760,
  [5799] = 3813,
  [5800] = 3761,
  [5801] = 3750,
  [5802] = 3763,
  [5803] = 3765,
  [5804] = 3767,
  [5805] = 3809,
  [5806] = 3768,
  [5807] = 3770,
  [5808] = 3772,
  [5809] = 3562,
  [5810] = 3735,
  [5811] = 4125,
  [5812] = 3779,
  [5813] = 3782,
  [5814] = 3783,
  [5815] = 3784,
  [5816] = 3788,
  [5817] = 3677,
  [5818] = 3746,
  [5819] = 3776,
  [5820] = 3801,
  [5821] = 3787,
  [5822] = 3778,
  [5823] = 3775,
  [5824] = 3773,
  [5825] = 3737,
  [5826] = 3799,
  [5827] = 3771,
  [5828] = 3745,
  [5829] = 3738,
  [5830] = 3482,
  [5831] = 3766,
  [5832] = 3764,
  [5833] = 3740,
  [5834] = 3781,
  [5835] = 3514,
  [5836] = 3739,
  [5837] = 3751,
  [5838] = 3547,
  [5839] = 3549,
  [5840] = 3742,
  [5841] = 3597,
  [5842] = 3514,
  [5843] = 3608,
  [5844] = 3591,
  [5845] = 3743,
  [5846] = 3577,
  [5847] = 3489,
  [5848] = 3744,
  [5849] = 3576,
  [5850] = 3843,
  [5851] = 3747,
  [5852] = 3546,
  [5853] = 3606,
  [5854] = 3668,
  [5855] = 3471,
  [5856] = 5856,
  [5857] = 3543,
  [5858] = 3734,
  [5859] = 3748,
  [5860] = 3470,
  [5861] = 3853,
  [5862] = 3600,
  [5863] = 3468,
  [5864] = 3543,
  [5865] = 3471,
  [5866] = 3470,
  [5867] = 3471,
  [5868] = 3470,
  [5869] = 3677,
  [5870] = 3562,
  [5871] = 3481,
  [5872] = 3825,
  [5873] = 3468,
  [5874] = 3468,
  [5875] = 3853,
  [5876] = 3692,
  [5877] = 3705,
  [5878] = 3576,
  [5879] = 3762,
  [5880] = 3600,
  [5881] = 3785,
  [5882] = 3774,
  [5883] = 3785,
  [5884] = 3489,
  [5885] = 3774,
  [5886] = 3853,
  [5887] = 3740,
  [5888] = 3843,
  [5889] = 3762,
  [5890] = 3549,
  [5891] = 3760,
  [5892] = 3745,
  [5893] = 3468,
  [5894] = 3468,
  [5895] = 3746,
  [5896] = 3825,
  [5897] = 3470,
  [5898] = 3471,
  [5899] = 3824,
  [5900] = 3470,
  [5901] = 3471,
  [5902] = 3606,
  [5903] = 3482,
  [5904] = 3600,
  [5905] = 3546,
  [5906] = 3577,
  [5907] = 3591,
  [5908] = 3608,
  [5909] = 3843,
  [5910] = 3692,
  [5911] = 3597,
  [5912] = 3547,
  [5913] = 3705,
  [5914] = 3799,
  [5915] = 3801,
  [5916] = 3748,
  [5917] = 3734,
  [5918] = 3825,
  [5919] = 3799,
  [5920] = 3801,
  [5921] = 3747,
  [5922] = 3809,
  [5923] = 3744,
  [5924] = 3743,
  [5925] = 3742,
  [5926] = 3739,
  [5927] = 3824,
  [5928] = 3813,
  [5929] = 3832,
  [5930] = 3829,
  [5931] = 3705,
  [5932] = 3692,
  [5933] = 3600,
  [5934] = 3738,
  [5935] = 3737,
  [5936] = 3778,
  [5937] = 3600,
  [5938] = 4125,
  [5939] = 3832,
  [5940] = 3705,
  [5941] = 3705,
  [5942] = 3829,
  [5943] = 3824,
  [5944] = 3692,
  [5945] = 3813,
  [5946] = 3809,
  [5947] = 3692,
  [5948] = 3760,
  [5949] = 3785,
  [5950] = 3785,
  [5951] = 3774,
  [5952] = 3740,
  [5953] = 3740,
  [5954] = 3774,
  [5955] = 3745,
  [5956] = 3762,
  [5957] = 3746,
  [5958] = 3745,
  [5959] = 3746,
  [5960] = 3762,
  [5961] = 3600,
  [5962] = 4125,
  [5963] = 3692,
  [5964] = 3748,
  [5965] = 4125,
  [5966] = 3748,
  [5967] = 3734,
  [5968] = 3705,
  [5969] = 3705,
  [5970] = 3549,
  [5971] = 3489,
  [5972] = 3778,
  [5973] = 3737,
  [5974] = 3576,
  [5975] = 3747,
  [5976] = 3738,
  [5977] = 5977,
  [5978] = 3739,
  [5979] = 3742,
  [5980] = 3743,
  [5981] = 3744,
  [5982] = 3747,
  [5983] = 3549,
  [5984] = 3489,
  [5985] = 3576,
  [5986] = 3734,
  [5987] = 3748,
  [5988] = 3734,
  [5989] = 4125,
  [5990] = 3762,
  [5991] = 3774,
  [5992] = 3785,
  [5993] = 3747,
  [5994] = 3514,
  [5995] = 3705,
  [5996] = 3740,
  [5997] = 3744,
  [5998] = 3745,
  [5999] = 3746,
  [6000] = 3543,
  [6001] = 3692,
  [6002] = 3743,
  [6003] = 3514,
  [6004] = 3742,
  [6005] = 3705,
  [6006] = 3576,
  [6007] = 3543,
  [6008] = 3692,
  [6009] = 3744,
  [6010] = 3743,
  [6011] = 3739,
  [6012] = 6012,
  [6013] = 3738,
  [6014] = 3737,
  [6015] = 4125,
  [6016] = 3742,
  [6017] = 3470,
  [6018] = 3600,
  [6019] = 3600,
  [6020] = 3778,
  [6021] = 3739,
  [6022] = 3760,
  [6023] = 3738,
  [6024] = 3746,
  [6025] = 3471,
  [6026] = 3745,
  [6027] = 3737,
  [6028] = 3471,
  [6029] = 3740,
  [6030] = 3489,
  [6031] = 3778,
  [6032] = 3785,
  [6033] = 3470,
  [6034] = 3774,
  [6035] = 3762,
  [6036] = 3748,
  [6037] = 3470,
  [6038] = 3468,
  [6039] = 3734,
  [6040] = 3677,
  [6041] = 3747,
  [6042] = 3562,
  [6043] = 3744,
  [6044] = 6012,
  [6045] = 3743,
  [6046] = 3677,
  [6047] = 4125,
  [6048] = 3751,
  [6049] = 3562,
  [6050] = 3742,
  [6051] = 3739,
  [6052] = 3738,
  [6053] = 3481,
  [6054] = 3737,
  [6055] = 3778,
  [6056] = 3705,
  [6057] = 3668,
  [6058] = 3606,
  [6059] = 3482,
  [6060] = 3546,
  [6061] = 3692,
  [6062] = 3481,
  [6063] = 3746,
  [6064] = 3745,
  [6065] = 3577,
  [6066] = 3740,
  [6067] = 3591,
  [6068] = 3785,
  [6069] = 3774,
  [6070] = 3762,
  [6071] = 3600,
  [6072] = 3608,
  [6073] = 3600,
  [6074] = 3748,
  [6075] = 3734,
  [6076] = 3747,
  [6077] = 3471,
  [6078] = 3597,
  [6079] = 3468,
  [6080] = 3468,
  [6081] = 3549,
  [6082] = 3744,
  [6083] = 3743,
  [6084] = 3742,
  [6085] = 3739,
  [6086] = 3738,
  [6087] = 3737,
  [6088] = 3778,
  [6089] = 3481,
  [6090] = 3481,
  [6091] = 3547,
  [6092] = 3668,
  [6093] = 3562,
  [6094] = 3606,
  [6095] = 3677,
  [6096] = 3760,
  [6097] = 3562,
  [6098] = 3668,
  [6099] = 3677,
  [6100] = 3606,
  [6101] = 3468,
  [6102] = 3481,
  [6103] = 3482,
  [6104] = 3470,
  [6105] = 3471,
  [6106] = 3482,
  [6107] = 3546,
  [6108] = 3562,
  [6109] = 3546,
  [6110] = 3751,
  [6111] = 3677,
  [6112] = 3577,
  [6113] = 3468,
  [6114] = 3591,
  [6115] = 3740,
  [6116] = 3577,
  [6117] = 3608,
  [6118] = 3470,
  [6119] = 3760,
  [6120] = 3751,
  [6121] = 3470,
  [6122] = 3543,
  [6123] = 3591,
  [6124] = 3608,
  [6125] = 3597,
  [6126] = 3597,
  [6127] = 3471,
  [6128] = 3471,
  [6129] = 3760,
  [6130] = 3668,
  [6131] = 3606,
  [6132] = 3482,
  [6133] = 3546,
  [6134] = 3547,
  [6135] = 3576,
  [6136] = 3489,
  [6137] = 3577,
  [6138] = 3471,
  [6139] = 3547,
  [6140] = 3543,
  [6141] = 3591,
  [6142] = 3705,
  [6143] = 3832,
  [6144] = 3829,
  [6145] = 3824,
  [6146] = 3514,
  [6147] = 3470,
  [6148] = 3597,
  [6149] = 3692,
  [6150] = 3600,
  [6151] = 3760,
  [6152] = 3549,
  [6153] = 3468,
  [6154] = 3751,
  [6155] = 3547,
  [6156] = 3668,
  [6157] = 3600,
  [6158] = 3813,
  [6159] = 3751,
  [6160] = 3606,
  [6161] = 3809,
  [6162] = 3482,
  [6163] = 3543,
  [6164] = 3608,
  [6165] = 3576,
  [6166] = 3489,
  [6167] = 3577,
  [6168] = 3692,
  [6169] = 3591,
  [6170] = 3608,
  [6171] = 3514,
  [6172] = 3597,
  [6173] = 3549,
  [6174] = 3547,
  [6175] = 3705,
  [6176] = 3546,
  [6177] = 3481,
  [6178] = 3692,
  [6179] = 3801,
  [6180] = 3799,
  [6181] = 4125,
  [6182] = 3470,
  [6183] = 3514,
  [6184] = 3471,
  [6185] = 3543,
  [6186] = 3668,
  [6187] = 3606,
  [6188] = 3482,
  [6189] = 3546,
  [6190] = 3576,
  [6191] = 3562,
  [6192] = 3778,
  [6193] = 3737,
  [6194] = 3738,
  [6195] = 3489,
  [6196] = 3577,
  [6197] = 3739,
  [6198] = 3742,
  [6199] = 3743,
  [6200] = 3744,
  [6201] = 3843,
  [6202] = 3747,
  [6203] = 3734,
  [6204] = 3853,
  [6205] = 3591,
  [6206] = 3608,
  [6207] = 3748,
  [6208] = 3597,
  [6209] = 3677,
  [6210] = 3705,
  [6211] = 3762,
  [6212] = 3774,
  [6213] = 3785,
  [6214] = 3692,
  [6215] = 3825,
  [6216] = 3468,
  [6217] = 3549,
  [6218] = 3547,
  [6219] = 3470,
  [6220] = 3471,
  [6221] = 3600,
  [6222] = 3705,
  [6223] = 3468,
  [6224] = 3692,
  [6225] = 3751,
  [6226] = 3600,
  [6227] = 5977,
  [6228] = 3745,
  [6229] = 3746,
  [6230] = 3514,
  [6231] = 3468,
  [6232] = 3576,
  [6233] = 3744,
  [6234] = 3549,
  [6235] = 3748,
  [6236] = 3734,
  [6237] = 3591,
  [6238] = 3471,
  [6239] = 3591,
  [6240] = 3747,
  [6241] = 3744,
  [6242] = 3576,
  [6243] = 3489,
  [6244] = 3743,
  [6245] = 3742,
  [6246] = 3739,
  [6247] = 3576,
  [6248] = 3481,
  [6249] = 3608,
  [6250] = 3600,
  [6251] = 3751,
  [6252] = 3468,
  [6253] = 4125,
  [6254] = 3562,
  [6255] = 3597,
  [6256] = 3514,
  [6257] = 3774,
  [6258] = 3481,
  [6259] = 3547,
  [6260] = 3543,
  [6261] = 3577,
  [6262] = 3591,
  [6263] = 3778,
  [6264] = 3760,
  [6265] = 3738,
  [6266] = 3737,
  [6267] = 3737,
  [6268] = 3470,
  [6269] = 3468,
  [6270] = 3549,
  [6271] = 3778,
  [6272] = 3762,
  [6273] = 3562,
  [6274] = 5856,
  [6275] = 3751,
  [6276] = 3705,
  [6277] = 3760,
  [6278] = 3481,
  [6279] = 3738,
  [6280] = 3668,
  [6281] = 3739,
  [6282] = 3742,
  [6283] = 3743,
  [6284] = 3744,
  [6285] = 3747,
  [6286] = 3734,
  [6287] = 3748,
  [6288] = 3606,
  [6289] = 3577,
  [6290] = 3677,
  [6291] = 3562,
  [6292] = 3597,
  [6293] = 3743,
  [6294] = 3677,
  [6295] = 3748,
  [6296] = 3547,
  [6297] = 3751,
  [6298] = 3482,
  [6299] = 3692,
  [6300] = 3762,
  [6301] = 3774,
  [6302] = 3785,
  [6303] = 3600,
  [6304] = 3747,
  [6305] = 3608,
  [6306] = 3778,
  [6307] = 4125,
  [6308] = 3468,
  [6309] = 3737,
  [6310] = 3597,
  [6311] = 3514,
  [6312] = 3738,
  [6313] = 3739,
  [6314] = 3547,
  [6315] = 3742,
  [6316] = 3734,
  [6317] = 5977,
  [6318] = 3549,
  [6319] = 3734,
  [6320] = 3546,
  [6321] = 4125,
  [6322] = 3471,
  [6323] = 3743,
  [6324] = 3549,
  [6325] = 3744,
  [6326] = 3546,
  [6327] = 3577,
  [6328] = 4125,
  [6329] = 3471,
  [6330] = 3576,
  [6331] = 4125,
  [6332] = 3489,
  [6333] = 3576,
  [6334] = 3747,
  [6335] = 3577,
  [6336] = 3591,
  [6337] = 3734,
  [6338] = 3748,
  [6339] = 3514,
  [6340] = 3762,
  [6341] = 3489,
  [6342] = 3774,
  [6343] = 3740,
  [6344] = 3543,
  [6345] = 3576,
  [6346] = 3489,
  [6347] = 3745,
  [6348] = 3785,
  [6349] = 3742,
  [6350] = 3746,
  [6351] = 3481,
  [6352] = 3470,
  [6353] = 3760,
  [6354] = 3740,
  [6355] = 3748,
  [6356] = 3739,
  [6357] = 3745,
  [6358] = 3608,
  [6359] = 3738,
  [6360] = 3597,
  [6361] = 3481,
  [6362] = 3600,
  [6363] = 4125,
  [6364] = 3547,
  [6365] = 3482,
  [6366] = 3600,
  [6367] = 3562,
  [6368] = 3746,
  [6369] = 3489,
  [6370] = 3606,
  [6371] = 3762,
  [6372] = 3677,
  [6373] = 3778,
  [6374] = 3737,
  [6375] = 3740,
  [6376] = 3738,
  [6377] = 3677,
  [6378] = 6378,
  [6379] = 3774,
  [6380] = 3547,
  [6381] = 3785,
  [6382] = 3739,
  [6383] = 3742,
  [6384] = 3743,
  [6385] = 3744,
  [6386] = 3737,
  [6387] = 3740,
  [6388] = 3745,
  [6389] = 3745,
  [6390] = 3747,
  [6391] = 3734,
  [6392] = 3748,
  [6393] = 4125,
  [6394] = 3468,
  [6395] = 3482,
  [6396] = 3677,
  [6397] = 3746,
  [6398] = 4125,
  [6399] = 3606,
  [6400] = 3746,
  [6401] = 3746,
  [6402] = 3745,
  [6403] = 3705,
  [6404] = 3546,
  [6405] = 3762,
  [6406] = 3774,
  [6407] = 3785,
  [6408] = 3751,
  [6409] = 3562,
  [6410] = 3547,
  [6411] = 3785,
  [6412] = 3562,
  [6413] = 3546,
  [6414] = 3470,
  [6415] = 3740,
  [6416] = 3514,
  [6417] = 6378,
  [6418] = 3778,
  [6419] = 3471,
  [6420] = 3481,
  [6421] = 3489,
  [6422] = 3668,
  [6423] = 3760,
  [6424] = 3740,
  [6425] = 3745,
  [6426] = 3746,
  [6427] = 3778,
  [6428] = 3738,
  [6429] = 3739,
  [6430] = 3547,
  [6431] = 3746,
  [6432] = 3745,
  [6433] = 3543,
  [6434] = 3742,
  [6435] = 3760,
  [6436] = 3774,
  [6437] = 3778,
  [6438] = 3743,
  [6439] = 3762,
  [6440] = 3692,
  [6441] = 3785,
  [6442] = 3549,
  [6443] = 3481,
  [6444] = 3744,
  [6445] = 3747,
  [6446] = 3744,
  [6447] = 3482,
  [6448] = 3606,
  [6449] = 3743,
  [6450] = 3742,
  [6451] = 3739,
  [6452] = 3747,
  [6453] = 3677,
  [6454] = 3751,
  [6455] = 3547,
  [6456] = 3760,
  [6457] = 3549,
  [6458] = 3738,
  [6459] = 3562,
  [6460] = 3785,
  [6461] = 3677,
  [6462] = 3597,
  [6463] = 3740,
  [6464] = 3778,
  [6465] = 3608,
  [6466] = 3668,
  [6467] = 3591,
  [6468] = 3549,
  [6469] = 3514,
  [6470] = 3577,
  [6471] = 3577,
  [6472] = 3737,
  [6473] = 3738,
  [6474] = 3746,
  [6475] = 3745,
  [6476] = 3705,
  [6477] = 3543,
  [6478] = 3470,
  [6479] = 3597,
  [6480] = 3692,
  [6481] = 3514,
  [6482] = 3489,
  [6483] = 3562,
  [6484] = 3576,
  [6485] = 3546,
  [6486] = 3751,
  [6487] = 3739,
  [6488] = 3742,
  [6489] = 3482,
  [6490] = 3608,
  [6491] = 3774,
  [6492] = 3762,
  [6493] = 3760,
  [6494] = 3762,
  [6495] = 3543,
  [6496] = 3549,
  [6497] = 3543,
  [6498] = 3747,
  [6499] = 3606,
  [6500] = 3744,
  [6501] = 3668,
  [6502] = 3774,
  [6503] = 3471,
  [6504] = 3668,
  [6505] = 3743,
  [6506] = 3481,
  [6507] = 3744,
  [6508] = 3546,
  [6509] = 3745,
  [6510] = 3482,
  [6511] = 3468,
  [6512] = 3743,
  [6513] = 3746,
  [6514] = 3742,
  [6515] = 3606,
  [6516] = 3739,
  [6517] = 3677,
  [6518] = 3543,
  [6519] = 3751,
  [6520] = 3677,
  [6521] = 3738,
  [6522] = 3576,
  [6523] = 3597,
  [6524] = 3778,
  [6525] = 3606,
  [6526] = 3760,
  [6527] = 3705,
  [6528] = 3489,
  [6529] = 3482,
  [6530] = 3705,
  [6531] = 3668,
  [6532] = 3740,
  [6533] = 3546,
  [6534] = 3785,
  [6535] = 3774,
  [6536] = 3577,
  [6537] = 3470,
  [6538] = 3747,
  [6539] = 3748,
  [6540] = 3668,
  [6541] = 3734,
  [6542] = 4125,
  [6543] = 3737,
  [6544] = 3608,
  [6545] = 3740,
  [6546] = 3591,
  [6547] = 3785,
  [6548] = 3600,
  [6549] = 3591,
  [6550] = 3748,
  [6551] = 3734,
  [6552] = 3734,
  [6553] = 3748,
  [6554] = 3514,
  [6555] = 3737,
  [6556] = 3751,
  [6557] = 3562,
  [6558] = 3692,
  [6559] = 3549,
  [6560] = 3760,
  [6561] = 3668,
  [6562] = 3606,
  [6563] = 3597,
  [6564] = 3514,
  [6565] = 3608,
  [6566] = 3737,
  [6567] = 3482,
  [6568] = 3762,
  [6569] = 3481,
  [6570] = 3751,
  [6571] = 3547,
  [6572] = 3692,
  [6573] = 3668,
  [6574] = 3591,
  [6575] = 3608,
  [6576] = 3597,
  [6577] = 3543,
  [6578] = 3608,
  [6579] = 3543,
  [6580] = 3514,
  [6581] = 3577,
  [6582] = 3546,
  [6583] = 3577,
  [6584] = 3489,
  [6585] = 3591,
  [6586] = 3606,
  [6587] = 3482,
  [6588] = 3576,
  [6589] = 3546,
  [6590] = 3482,
  [6591] = 3606,
  [6592] = 3745,
  [6593] = 3746,
  [6594] = 3785,
  [6595] = 4125,
  [6596] = 3549,
  [6597] = 3481,
  [6598] = 3762,
  [6599] = 3774,
  [6600] = 3785,
  [6601] = 3597,
  [6602] = 3737,
  [6603] = 3546,
  [6604] = 3547,
  [6605] = 3471,
  [6606] = 3748,
  [6607] = 3546,
  [6608] = 3482,
  [6609] = 3734,
  [6610] = 3740,
  [6611] = 3740,
  [6612] = 3734,
  [6613] = 3748,
  [6614] = 3748,
  [6615] = 3668,
  [6616] = 3514,
  [6617] = 3737,
  [6618] = 3734,
  [6619] = 3747,
  [6620] = 3744,
  [6621] = 3774,
  [6622] = 3745,
  [6623] = 3743,
  [6624] = 3742,
  [6625] = 3746,
  [6626] = 3739,
  [6627] = 3751,
  [6628] = 3549,
  [6629] = 3734,
  [6630] = 3748,
  [6631] = 3677,
  [6632] = 3677,
  [6633] = 3608,
  [6634] = 3600,
  [6635] = 4125,
  [6636] = 3785,
  [6637] = 3577,
  [6638] = 3606,
  [6639] = 3482,
  [6640] = 3481,
  [6641] = 3762,
  [6642] = 3740,
  [6643] = 3737,
  [6644] = 4125,
  [6645] = 3668,
  [6646] = 3547,
  [6647] = 3481,
  [6648] = 3543,
  [6649] = 3760,
  [6650] = 3549,
  [6651] = 3481,
  [6652] = 3785,
  [6653] = 3600,
  [6654] = 3562,
  [6655] = 5856,
  [6656] = 3738,
  [6657] = 3737,
  [6658] = 3778,
  [6659] = 3778,
  [6660] = 3489,
  [6661] = 3576,
  [6662] = 3591,
  [6663] = 3738,
  [6664] = 3739,
  [6665] = 3677,
  [6666] = 3742,
  [6667] = 3743,
  [6668] = 3577,
  [6669] = 3576,
  [6670] = 3546,
  [6671] = 3760,
  [6672] = 3562,
  [6673] = 3547,
  [6674] = 3744,
  [6675] = 3608,
  [6676] = 3546,
  [6677] = 3482,
  [6678] = 3747,
  [6679] = 3597,
  [6680] = 3740,
  [6681] = 3608,
  [6682] = 3591,
  [6683] = 3489,
  [6684] = 3577,
  [6685] = 3577,
  [6686] = 3591,
  [6687] = 3762,
  [6688] = 3471,
  [6689] = 4125,
  [6690] = 3774,
  [6691] = 3597,
  [6692] = 3606,
  [6693] = 3606,
  [6694] = 3608,
  [6695] = 3747,
  [6696] = 3608,
  [6697] = 3489,
  [6698] = 3751,
  [6699] = 3597,
  [6700] = 3576,
  [6701] = 3751,
  [6702] = 3692,
  [6703] = 3549,
  [6704] = 3470,
  [6705] = 3744,
  [6706] = 4125,
  [6707] = 3668,
  [6708] = 3760,
  [6709] = 3547,
  [6710] = 3591,
  [6711] = 3668,
  [6712] = 3778,
  [6713] = 3743,
  [6714] = 3470,
  [6715] = 3705,
  [6716] = 6378,
  [6717] = 3738,
  [6718] = 3742,
  [6719] = 3481,
  [6720] = 3739,
  [6721] = 3739,
  [6722] = 3745,
  [6723] = 3562,
  [6724] = 3742,
  [6725] = 3562,
  [6726] = 3591,
  [6727] = 3746,
  [6728] = 3577,
  [6729] = 3514,
  [6730] = 3760,
  [6731] = 3751,
  [6732] = 3743,
  [6733] = 3744,
  [6734] = 3747,
  [6735] = 3692,
  [6736] = 3751,
  [6737] = 3543,
  [6738] = 3760,
  [6739] = 3677,
  [6740] = 3705,
  [6741] = 3677,
  [6742] = 3514,
  [6743] = 3762,
  [6744] = 3668,
  [6745] = 3546,
  [6746] = 3514,
  [6747] = 3774,
  [6748] = 3778,
  [6749] = 3737,
  [6750] = 3738,
  [6751] = 3745,
  [6752] = 3739,
  [6753] = 3742,
  [6754] = 3743,
  [6755] = 3744,
  [6756] = 3747,
  [6757] = 3734,
  [6758] = 3748,
  [6759] = 3482,
  [6760] = 3762,
  [6761] = 3774,
  [6762] = 3785,
  [6763] = 3549,
  [6764] = 3746,
  [6765] = 3778,
  [6766] = 3606,
  [6767] = 3562,
  [6768] = 3543,
  [6769] = 3740,
  [6770] = 3471,
  [6771] = 3745,
  [6772] = 3746,
  [6773] = 3489,
  [6774] = 3470,
  [6775] = 3597,
  [6776] = 3738,
  [6777] = 3576,
  [6778] = 3468,
  [6779] = 3543,
  [6780] = 3468,
  [6781] = 3600,
  [6782] = 3692,
  [6783] = 3468,
  [6784] = 3547,
  [6785] = 3514,
  [6786] = 3705,
  [6787] = 3543,
  [6788] = 3576,
  [6789] = 3489,
  [6790] = 3705,
  [6791] = 6791,
  [6792] = 6791,
  [6793] = 6791,
  [6794] = 6791,
  [6795] = 6791,
  [6796] = 3562,
  [6797] = 6791,
  [6798] = 3692,
  [6799] = 3760,
  [6800] = 6791,
  [6801] = 6791,
  [6802] = 6791,
  [6803] = 6791,
  [6804] = 6791,
  [6805] = 6791,
  [6806] = 6791,
  [6807] = 6791,
  [6808] = 6791,
  [6809] = 6791,
  [6810] = 6791,
  [6811] = 6791,
  [6812] = 6791,
  [6813] = 6791,
  [6814] = 6791,
  [6815] = 6791,
  [6816] = 6791,
  [6817] = 3705,
  [6818] = 6791,
  [6819] = 6791,
  [6820] = 3692,
  [6821] = 6791,
  [6822] = 6791,
  [6823] = 6791,
  [6824] = 6791,
  [6825] = 6791,
  [6826] = 6791,
  [6827] = 6791,
  [6828] = 6791,
  [6829] = 6791,
  [6830] = 6791,
  [6831] = 6791,
  [6832] = 6791,
  [6833] = 3543,
  [6834] = 6791,
  [6835] = 6791,
  [6836] = 6791,
  [6837] = 6791,
  [6838] = 3470,
  [6839] = 6791,
  [6840] = 6791,
  [6841] = 6791,
  [6842] = 6791,
  [6843] = 3705,
  [6844] = 6791,
  [6845] = 3514,
  [6846] = 6791,
  [6847] = 6791,
  [6848] = 6791,
  [6849] = 3471,
  [6850] = 4125,
  [6851] = 3543,
  [6852] = 6791,
  [6853] = 6791,
  [6854] = 6791,
  [6855] = 3470,
  [6856] = 3668,
  [6857] = 4125,
  [6858] = 3468,
  [6859] = 3606,
  [6860] = 3482,
  [6861] = 3546,
  [6862] = 3576,
  [6863] = 6791,
  [6864] = 6791,
  [6865] = 6791,
  [6866] = 3489,
  [6867] = 3577,
  [6868] = 3692,
  [6869] = 6791,
  [6870] = 3751,
  [6871] = 6791,
  [6872] = 3591,
  [6873] = 6791,
  [6874] = 3608,
  [6875] = 3597,
  [6876] = 3514,
  [6877] = 6791,
  [6878] = 6791,
  [6879] = 3468,
  [6880] = 3549,
  [6881] = 6791,
  [6882] = 3760,
  [6883] = 3547,
  [6884] = 6791,
  [6885] = 6791,
  [6886] = 3600,
  [6887] = 6791,
  [6888] = 6791,
  [6889] = 6791,
  [6890] = 6791,
  [6891] = 3751,
  [6892] = 3760,
  [6893] = 3547,
  [6894] = 6791,
  [6895] = 3597,
  [6896] = 3608,
  [6897] = 3591,
  [6898] = 6791,
  [6899] = 3677,
  [6900] = 6791,
  [6901] = 3577,
  [6902] = 3546,
  [6903] = 6791,
  [6904] = 6791,
  [6905] = 3600,
  [6906] = 6791,
  [6907] = 3482,
  [6908] = 3606,
  [6909] = 6791,
  [6910] = 3668,
  [6911] = 3470,
  [6912] = 3751,
  [6913] = 6791,
  [6914] = 3547,
  [6915] = 3597,
  [6916] = 6791,
  [6917] = 3608,
  [6918] = 6791,
  [6919] = 6791,
  [6920] = 6791,
  [6921] = 6791,
  [6922] = 3591,
  [6923] = 6791,
  [6924] = 3546,
  [6925] = 3751,
  [6926] = 6791,
  [6927] = 6791,
  [6928] = 3577,
  [6929] = 3576,
  [6930] = 3489,
  [6931] = 3549,
  [6932] = 6791,
  [6933] = 3470,
  [6934] = 3600,
  [6935] = 6791,
  [6936] = 3600,
  [6937] = 3482,
  [6938] = 6791,
  [6939] = 3606,
  [6940] = 6791,
  [6941] = 3668,
  [6942] = 3471,
  [6943] = 3468,
  [6944] = 3468,
  [6945] = 3543,
  [6946] = 3692,
  [6947] = 3692,
  [6948] = 3737,
  [6949] = 6791,
  [6950] = 6791,
  [6951] = 3471,
  [6952] = 6791,
  [6953] = 3705,
  [6954] = 3734,
  [6955] = 3748,
  [6956] = 3785,
  [6957] = 6791,
  [6958] = 3471,
  [6959] = 3740,
  [6960] = 3778,
  [6961] = 6791,
  [6962] = 6791,
  [6963] = 3514,
  [6964] = 3737,
  [6965] = 3562,
  [6966] = 6791,
  [6967] = 6791,
  [6968] = 3738,
  [6969] = 3737,
  [6970] = 6791,
  [6971] = 3471,
  [6972] = 3468,
  [6973] = 3468,
  [6974] = 6791,
  [6975] = 3481,
  [6976] = 3734,
  [6977] = 3748,
  [6978] = 3785,
  [6979] = 6791,
  [6980] = 3740,
  [6981] = 6791,
  [6982] = 3600,
  [6983] = 3489,
  [6984] = 3576,
  [6985] = 3778,
  [6986] = 3738,
  [6987] = 3739,
  [6988] = 3742,
  [6989] = 3470,
  [6990] = 3743,
  [6991] = 3471,
  [6992] = 3744,
  [6993] = 3747,
  [6994] = 3600,
  [6995] = 3470,
  [6996] = 6791,
  [6997] = 3705,
  [6998] = 3739,
  [6999] = 6791,
  [7000] = 6791,
  [7001] = 3762,
  [7002] = 3742,
  [7003] = 3743,
  [7004] = 3774,
  [7005] = 3481,
  [7006] = 3744,
  [7007] = 6791,
  [7008] = 3745,
  [7009] = 3746,
  [7010] = 3747,
  [7011] = 3734,
  [7012] = 6791,
  [7013] = 6791,
  [7014] = 6791,
  [7015] = 3748,
  [7016] = 3746,
  [7017] = 3677,
  [7018] = 6791,
  [7019] = 3745,
  [7020] = 6791,
  [7021] = 6791,
  [7022] = 3562,
  [7023] = 4125,
  [7024] = 3677,
  [7025] = 3774,
  [7026] = 3762,
  [7027] = 3762,
  [7028] = 3774,
  [7029] = 3468,
  [7030] = 5977,
  [7031] = 3785,
  [7032] = 3747,
  [7033] = 3549,
  [7034] = 3744,
  [7035] = 3481,
  [7036] = 6791,
  [7037] = 3468,
  [7038] = 3743,
  [7039] = 3742,
  [7040] = 3739,
  [7041] = 3692,
  [7042] = 6791,
  [7043] = 6791,
  [7044] = 3746,
  [7045] = 3745,
  [7046] = 3705,
  [7047] = 3740,
  [7048] = 3778,
  [7049] = 6791,
  [7050] = 3738,
  [7051] = 6791,
  [7052] = 7052,
  [7053] = 3608,
  [7054] = 3748,
  [7055] = 3471,
  [7056] = 3546,
  [7057] = 6378,
  [7058] = 3482,
  [7059] = 3762,
  [7060] = 3774,
  [7061] = 3785,
  [7062] = 3468,
  [7063] = 5856,
  [7064] = 3562,
  [7065] = 7052,
  [7066] = 3778,
  [7067] = 3760,
  [7068] = 3785,
  [7069] = 3748,
  [7070] = 3740,
  [7071] = 3734,
  [7072] = 7052,
  [7073] = 3734,
  [7074] = 3737,
  [7075] = 3606,
  [7076] = 3737,
  [7077] = 3470,
  [7078] = 3600,
  [7079] = 7079,
  [7080] = 3514,
  [7081] = 3778,
  [7082] = 4125,
  [7083] = 3562,
  [7084] = 3738,
  [7085] = 3668,
  [7086] = 3738,
  [7087] = 3740,
  [7088] = 3471,
  [7089] = 3677,
  [7090] = 3760,
  [7091] = 3468,
  [7092] = 3739,
  [7093] = 3742,
  [7094] = 3549,
  [7095] = 3743,
  [7096] = 3543,
  [7097] = 5856,
  [7098] = 3740,
  [7099] = 3606,
  [7100] = 3482,
  [7101] = 3744,
  [7102] = 3747,
  [7103] = 3562,
  [7104] = 3745,
  [7105] = 3746,
  [7106] = 3600,
  [7107] = 3668,
  [7108] = 3471,
  [7109] = 3546,
  [7110] = 3705,
  [7111] = 3576,
  [7112] = 3751,
  [7113] = 3762,
  [7114] = 3468,
  [7115] = 3774,
  [7116] = 3489,
  [7117] = 3489,
  [7118] = 3577,
  [7119] = 3751,
  [7120] = 3591,
  [7121] = 3576,
  [7122] = 3481,
  [7123] = 3608,
  [7124] = 3606,
  [7125] = 3760,
  [7126] = 3482,
  [7127] = 3597,
  [7128] = 3760,
  [7129] = 3547,
  [7130] = 3692,
  [7131] = 3470,
  [7132] = 3546,
  [7133] = 3549,
  [7134] = 3547,
  [7135] = 3468,
  [7136] = 3549,
  [7137] = 3549,
  [7138] = 3543,
  [7139] = 3668,
  [7140] = 3514,
  [7141] = 3481,
  [7142] = 3677,
  [7143] = 3705,
  [7144] = 3745,
  [7145] = 3746,
  [7146] = 3489,
  [7147] = 3549,
  [7148] = 3481,
  [7149] = 3471,
  [7150] = 3746,
  [7151] = 3576,
  [7152] = 3577,
  [7153] = 3677,
  [7154] = 3468,
  [7155] = 3692,
  [7156] = 3745,
  [7157] = 3489,
  [7158] = 3606,
  [7159] = 3482,
  [7160] = 7052,
  [7161] = 3576,
  [7162] = 3677,
  [7163] = 3481,
  [7164] = 3785,
  [7165] = 3600,
  [7166] = 4125,
  [7167] = 3543,
  [7168] = 3547,
  [7169] = 3762,
  [7170] = 3597,
  [7171] = 3597,
  [7172] = 3591,
  [7173] = 3600,
  [7174] = 3747,
  [7175] = 3744,
  [7176] = 3470,
  [7177] = 3743,
  [7178] = 3742,
  [7179] = 3739,
  [7180] = 3739,
  [7181] = 3608,
  [7182] = 3514,
  [7183] = 3471,
  [7184] = 3778,
  [7185] = 3742,
  [7186] = 3737,
  [7187] = 3738,
  [7188] = 3778,
  [7189] = 3738,
  [7190] = 3739,
  [7191] = 3742,
  [7192] = 3743,
  [7193] = 3739,
  [7194] = 3743,
  [7195] = 3744,
  [7196] = 3742,
  [7197] = 3743,
  [7198] = 3514,
  [7199] = 3744,
  [7200] = 3747,
  [7201] = 3546,
  [7202] = 3738,
  [7203] = 3778,
  [7204] = 3547,
  [7205] = 3746,
  [7206] = 3577,
  [7207] = 3470,
  [7208] = 3745,
  [7209] = 3762,
  [7210] = 3774,
  [7211] = 3744,
  [7212] = 3591,
  [7213] = 3747,
  [7214] = 7052,
  [7215] = 3734,
  [7216] = 3774,
  [7217] = 3762,
  [7218] = 3597,
  [7219] = 3747,
  [7220] = 3747,
  [7221] = 3744,
  [7222] = 3743,
  [7223] = 3468,
  [7224] = 3745,
  [7225] = 3742,
  [7226] = 3608,
  [7227] = 3748,
  [7228] = 3597,
  [7229] = 3739,
  [7230] = 3746,
  [7231] = 3608,
  [7232] = 3738,
  [7233] = 3774,
  [7234] = 3778,
  [7235] = 3547,
  [7236] = 3608,
  [7237] = 3514,
  [7238] = 7052,
  [7239] = 3597,
  [7240] = 3760,
  [7241] = 3591,
  [7242] = 3577,
  [7243] = 3762,
  [7244] = 3774,
  [7245] = 3751,
  [7246] = 3489,
  [7247] = 3785,
  [7248] = 3692,
  [7249] = 3546,
  [7250] = 3591,
  [7251] = 3543,
  [7252] = 3482,
  [7253] = 3577,
  [7254] = 3606,
  [7255] = 3546,
  [7256] = 4125,
  [7257] = 3482,
  [7258] = 3692,
  [7259] = 3692,
  [7260] = 3740,
  [7261] = 3751,
  [7262] = 3740,
  [7263] = 3576,
  [7264] = 3677,
  [7265] = 3748,
  [7266] = 3481,
  [7267] = 3549,
  [7268] = 4125,
  [7269] = 3468,
  [7270] = 3668,
  [7271] = 3562,
  [7272] = 3606,
  [7273] = 3734,
  [7274] = 3543,
  [7275] = 3543,
  [7276] = 3705,
  [7277] = 3547,
  [7278] = 3745,
  [7279] = 3471,
  [7280] = 3705,
  [7281] = 3577,
  [7282] = 3668,
  [7283] = 3751,
  [7284] = 3600,
  [7285] = 3591,
  [7286] = 3746,
  [7287] = 3470,
  [7288] = 3751,
  [7289] = 3600,
  [7290] = 3785,
  [7291] = 3740,
  [7292] = 3470,
  [7293] = 3514,
  [7294] = 4125,
  [7295] = 3705,
  [7296] = 3468,
  [7297] = 3470,
  [7298] = 3785,
  [7299] = 3692,
  [7300] = 3748,
  [7301] = 3734,
  [7302] = 3760,
  [7303] = 3705,
  [7304] = 3737,
  [7305] = 3576,
  [7306] = 3748,
  [7307] = 3562,
  [7308] = 3734,
  [7309] = 3600,
  [7310] = 3668,
  [7311] = 3489,
  [7312] = 3481,
  [7313] = 3705,
  [7314] = 3692,
  [7315] = 3737,
  [7316] = 3471,
  [7317] = 3677,
  [7318] = 3562,
  [7319] = 3737,
  [7320] = 3774,
  [7321] = 3576,
  [7322] = 3739,
  [7323] = 3742,
  [7324] = 3743,
  [7325] = 3744,
  [7326] = 3543,
  [7327] = 3482,
  [7328] = 3677,
  [7329] = 3738,
  [7330] = 3591,
  [7331] = 3778,
  [7332] = 3577,
  [7333] = 3747,
  [7334] = 3740,
  [7335] = 3668,
  [7336] = 3668,
  [7337] = 3546,
  [7338] = 3562,
  [7339] = 3546,
  [7340] = 3576,
  [7341] = 3785,
  [7342] = 3746,
  [7343] = 3742,
  [7344] = 3468,
  [7345] = 3760,
  [7346] = 3774,
  [7347] = 3591,
  [7348] = 3740,
  [7349] = 3762,
  [7350] = 3774,
  [7351] = 3743,
  [7352] = 3597,
  [7353] = 3668,
  [7354] = 3600,
  [7355] = 3562,
  [7356] = 3608,
  [7357] = 7357,
  [7358] = 3751,
  [7359] = 3577,
  [7360] = 3514,
  [7361] = 4125,
  [7362] = 3746,
  [7363] = 3762,
  [7364] = 3745,
  [7365] = 3748,
  [7366] = 3608,
  [7367] = 3489,
  [7368] = 3734,
  [7369] = 3577,
  [7370] = 3597,
  [7371] = 3747,
  [7372] = 3692,
  [7373] = 3744,
  [7374] = 3468,
  [7375] = 3785,
  [7376] = 3547,
  [7377] = 3668,
  [7378] = 3677,
  [7379] = 3762,
  [7380] = 3739,
  [7381] = 3549,
  [7382] = 7357,
  [7383] = 3514,
  [7384] = 3547,
  [7385] = 3514,
  [7386] = 3745,
  [7387] = 3760,
  [7388] = 7388,
  [7389] = 3470,
  [7390] = 3746,
  [7391] = 3677,
  [7392] = 3740,
  [7393] = 3549,
  [7394] = 3740,
  [7395] = 3514,
  [7396] = 3746,
  [7397] = 3745,
  [7398] = 3738,
  [7399] = 3740,
  [7400] = 3760,
  [7401] = 3743,
  [7402] = 3677,
  [7403] = 3778,
  [7404] = 3597,
  [7405] = 3785,
  [7406] = 3745,
  [7407] = 3742,
  [7408] = 3591,
  [7409] = 3481,
  [7410] = 3543,
  [7411] = 3746,
  [7412] = 3740,
  [7413] = 3608,
  [7414] = 3482,
  [7415] = 3747,
  [7416] = 3543,
  [7417] = 3606,
  [7418] = 3608,
  [7419] = 3785,
  [7420] = 3774,
  [7421] = 3762,
  [7422] = 3705,
  [7423] = 3747,
  [7424] = 3762,
  [7425] = 3734,
  [7426] = 3597,
  [7427] = 3546,
  [7428] = 3744,
  [7429] = 3760,
  [7430] = 3739,
  [7431] = 5856,
  [7432] = 3591,
  [7433] = 3743,
  [7434] = 3562,
  [7435] = 3785,
  [7436] = 3737,
  [7437] = 3751,
  [7438] = 4125,
  [7439] = 3785,
  [7440] = 3608,
  [7441] = 3606,
  [7442] = 3742,
  [7443] = 3748,
  [7444] = 3734,
  [7445] = 3747,
  [7446] = 3751,
  [7447] = 3744,
  [7448] = 3743,
  [7449] = 3742,
  [7450] = 3739,
  [7451] = 3577,
  [7452] = 3591,
  [7453] = 3549,
  [7454] = 3471,
  [7455] = 3562,
  [7456] = 3597,
  [7457] = 3760,
  [7458] = 3748,
  [7459] = 3734,
  [7460] = 3737,
  [7461] = 3739,
  [7462] = 3577,
  [7463] = 3774,
  [7464] = 3738,
  [7465] = 3737,
  [7466] = 3778,
  [7467] = 3514,
  [7468] = 3549,
  [7469] = 3482,
  [7470] = 3737,
  [7471] = 3471,
  [7472] = 3762,
  [7473] = 7357,
  [7474] = 4125,
  [7475] = 3543,
  [7476] = 3748,
  [7477] = 3489,
  [7478] = 3738,
  [7479] = 5856,
  [7480] = 3774,
  [7481] = 3546,
  [7482] = 3543,
  [7483] = 3734,
  [7484] = 3576,
  [7485] = 3745,
  [7486] = 3760,
  [7487] = 5856,
  [7488] = 3606,
  [7489] = 3481,
  [7490] = 3547,
  [7491] = 3489,
  [7492] = 3481,
  [7493] = 3549,
  [7494] = 3774,
  [7495] = 4125,
  [7496] = 3482,
  [7497] = 3677,
  [7498] = 3543,
  [7499] = 3677,
  [7500] = 3778,
  [7501] = 3514,
  [7502] = 3738,
  [7503] = 3481,
  [7504] = 3547,
  [7505] = 3482,
  [7506] = 7357,
  [7507] = 3738,
  [7508] = 3606,
  [7509] = 3597,
  [7510] = 3606,
  [7511] = 5856,
  [7512] = 3482,
  [7513] = 3608,
  [7514] = 3591,
  [7515] = 3748,
  [7516] = 3577,
  [7517] = 3762,
  [7518] = 3778,
  [7519] = 3549,
  [7520] = 3562,
  [7521] = 3737,
  [7522] = 3738,
  [7523] = 3606,
  [7524] = 3778,
  [7525] = 3778,
  [7526] = 3470,
  [7527] = 3489,
  [7528] = 3546,
  [7529] = 3546,
  [7530] = 3577,
  [7531] = 3546,
  [7532] = 3481,
  [7533] = 3482,
  [7534] = 3576,
  [7535] = 3692,
  [7536] = 3606,
  [7537] = 5856,
  [7538] = 7357,
  [7539] = 3739,
  [7540] = 3668,
  [7541] = 3543,
  [7542] = 3562,
  [7543] = 3576,
  [7544] = 3748,
  [7545] = 3489,
  [7546] = 4125,
  [7547] = 3742,
  [7548] = 3743,
  [7549] = 3576,
  [7550] = 3677,
  [7551] = 3744,
  [7552] = 3481,
  [7553] = 3739,
  [7554] = 3751,
  [7555] = 3751,
  [7556] = 3576,
  [7557] = 3489,
  [7558] = 3489,
  [7559] = 3751,
  [7560] = 4125,
  [7561] = 5856,
  [7562] = 3547,
  [7563] = 3742,
  [7564] = 3737,
  [7565] = 3668,
  [7566] = 7357,
  [7567] = 3600,
  [7568] = 3744,
  [7569] = 3481,
  [7570] = 3743,
  [7571] = 3591,
  [7572] = 3549,
  [7573] = 3734,
  [7574] = 3705,
  [7575] = 3748,
  [7576] = 3745,
  [7577] = 3737,
  [7578] = 3746,
  [7579] = 3547,
  [7580] = 3608,
  [7581] = 3745,
  [7582] = 3785,
  [7583] = 3734,
  [7584] = 3597,
  [7585] = 3740,
  [7586] = 3744,
  [7587] = 3747,
  [7588] = 3562,
  [7589] = 3760,
  [7590] = 3668,
  [7591] = 3747,
  [7592] = 4125,
  [7593] = 3547,
  [7594] = 3514,
  [7595] = 3746,
  [7596] = 3692,
  [7597] = 5856,
  [7598] = 3760,
  [7599] = 3591,
  [7600] = 3514,
  [7601] = 7601,
  [7602] = 3546,
  [7603] = 3482,
  [7604] = 3746,
  [7605] = 3606,
  [7606] = 3745,
  [7607] = 3577,
  [7608] = 3751,
  [7609] = 3740,
  [7610] = 3470,
  [7611] = 3597,
  [7612] = 3668,
  [7613] = 3549,
  [7614] = 3470,
  [7615] = 3468,
  [7616] = 4125,
  [7617] = 3549,
  [7618] = 5856,
  [7619] = 3692,
  [7620] = 3470,
  [7621] = 5856,
  [7622] = 3785,
  [7623] = 3737,
  [7624] = 3774,
  [7625] = 7625,
  [7626] = 3608,
  [7627] = 3745,
  [7628] = 3468,
  [7629] = 3746,
  [7630] = 3481,
  [7631] = 3762,
  [7632] = 3471,
  [7633] = 3600,
  [7634] = 3748,
  [7635] = 3734,
  [7636] = 3747,
  [7637] = 3744,
  [7638] = 3743,
  [7639] = 3742,
  [7640] = 3739,
  [7641] = 3489,
  [7642] = 3576,
  [7643] = 3738,
  [7644] = 3597,
  [7645] = 3737,
  [7646] = 5856,
  [7647] = 4125,
  [7648] = 3471,
  [7649] = 3778,
  [7650] = 3608,
  [7651] = 5856,
  [7652] = 3734,
  [7653] = 3748,
  [7654] = 3562,
  [7655] = 7625,
  [7656] = 3677,
  [7657] = 3468,
  [7658] = 3677,
  [7659] = 3591,
  [7660] = 3751,
  [7661] = 3471,
  [7662] = 7662,
  [7663] = 7625,
  [7664] = 3577,
  [7665] = 3547,
  [7666] = 3774,
  [7667] = 3600,
  [7668] = 3760,
  [7669] = 3576,
  [7670] = 3546,
  [7671] = 5856,
  [7672] = 5856,
  [7673] = 3543,
  [7674] = 3489,
  [7675] = 3482,
  [7676] = 3606,
  [7677] = 3481,
  [7678] = 3747,
  [7679] = 3744,
  [7680] = 3743,
  [7681] = 3705,
  [7682] = 3514,
  [7683] = 3547,
  [7684] = 3705,
  [7685] = 3742,
  [7686] = 3739,
  [7687] = 3738,
  [7688] = 3785,
  [7689] = 3778,
  [7690] = 5856,
  [7691] = 3762,
  [7692] = 3562,
  [7693] = 3740,
  [7694] = 5856,
  [7695] = 3543,
  [7696] = 3668,
  [7697] = 3591,
  [7698] = 7698,
  [7699] = 7699,
  [7700] = 7698,
  [7701] = 7698,
  [7702] = 7698,
  [7703] = 7703,
  [7704] = 3746,
  [7705] = 3745,
  [7706] = 3740,
  [7707] = 7698,
  [7708] = 7698,
  [7709] = 3668,
  [7710] = 7710,
  [7711] = 7699,
  [7712] = 7699,
  [7713] = 3546,
  [7714] = 5856,
  [7715] = 7699,
  [7716] = 3577,
  [7717] = 7662,
  [7718] = 3778,
  [7719] = 7699,
  [7720] = 3737,
  [7721] = 3738,
  [7722] = 7698,
  [7723] = 7698,
  [7724] = 7698,
  [7725] = 7725,
  [7726] = 7726,
  [7727] = 3471,
  [7728] = 4125,
  [7729] = 3785,
  [7730] = 3591,
  [7731] = 3774,
  [7732] = 3762,
  [7733] = 7698,
  [7734] = 7698,
  [7735] = 7698,
  [7736] = 7699,
  [7737] = 3739,
  [7738] = 3742,
  [7739] = 3743,
  [7740] = 3744,
  [7741] = 7698,
  [7742] = 7698,
  [7743] = 3677,
  [7744] = 3543,
  [7745] = 3748,
  [7746] = 3734,
  [7747] = 7699,
  [7748] = 3747,
  [7749] = 3747,
  [7750] = 3744,
  [7751] = 3734,
  [7752] = 3748,
  [7753] = 3743,
  [7754] = 7698,
  [7755] = 3742,
  [7756] = 7699,
  [7757] = 7698,
  [7758] = 7698,
  [7759] = 7698,
  [7760] = 7699,
  [7761] = 3739,
  [7762] = 3738,
  [7763] = 3737,
  [7764] = 3778,
  [7765] = 7698,
  [7766] = 7698,
  [7767] = 3608,
  [7768] = 3740,
  [7769] = 7698,
  [7770] = 7698,
  [7771] = 7698,
  [7772] = 5856,
  [7773] = 3762,
  [7774] = 3562,
  [7775] = 7698,
  [7776] = 3774,
  [7777] = 3481,
  [7778] = 3760,
  [7779] = 7710,
  [7780] = 3677,
  [7781] = 5856,
  [7782] = 7698,
  [7783] = 3785,
  [7784] = 7698,
  [7785] = 7601,
  [7786] = 7786,
  [7787] = 3562,
  [7788] = 7698,
  [7789] = 7698,
  [7790] = 7699,
  [7791] = 7698,
  [7792] = 7699,
  [7793] = 3597,
  [7794] = 7698,
  [7795] = 7710,
  [7796] = 3514,
  [7797] = 7699,
  [7798] = 7698,
  [7799] = 7699,
  [7800] = 7698,
  [7801] = 7698,
  [7802] = 3677,
  [7803] = 7662,
  [7804] = 7699,
  [7805] = 7698,
  [7806] = 7698,
  [7807] = 5856,
  [7808] = 3543,
  [7809] = 5977,
  [7810] = 7810,
  [7811] = 7811,
  [7812] = 7601,
  [7813] = 7699,
  [7814] = 3576,
  [7815] = 3547,
  [7816] = 7699,
  [7817] = 7699,
  [7818] = 3745,
  [7819] = 3470,
  [7820] = 7820,
  [7821] = 7699,
  [7822] = 7698,
  [7823] = 3576,
  [7824] = 3489,
  [7825] = 7699,
  [7826] = 7698,
  [7827] = 5856,
  [7828] = 3746,
  [7829] = 7698,
  [7830] = 7698,
  [7831] = 3514,
  [7832] = 3547,
  [7833] = 7698,
  [7834] = 3562,
  [7835] = 3481,
  [7836] = 3468,
  [7837] = 7698,
  [7838] = 7786,
  [7839] = 3549,
  [7840] = 7698,
  [7841] = 7698,
  [7842] = 7698,
  [7843] = 7698,
  [7844] = 3482,
  [7845] = 7699,
  [7846] = 7786,
  [7847] = 7699,
  [7848] = 3606,
  [7849] = 3481,
  [7850] = 3482,
  [7851] = 3751,
  [7852] = 7699,
  [7853] = 3751,
  [7854] = 3668,
  [7855] = 7699,
  [7856] = 3489,
  [7857] = 7857,
  [7858] = 7698,
  [7859] = 7859,
  [7860] = 4125,
  [7861] = 3597,
  [7862] = 7862,
  [7863] = 3760,
  [7864] = 3470,
  [7865] = 3471,
  [7866] = 3608,
  [7867] = 3468,
  [7868] = 3546,
  [7869] = 4125,
  [7870] = 7699,
  [7871] = 7699,
  [7872] = 3549,
  [7873] = 3577,
  [7874] = 3606,
  [7875] = 7875,
  [7876] = 5977,
  [7877] = 7877,
  [7878] = 3577,
  [7879] = 7726,
  [7880] = 3549,
  [7881] = 7881,
  [7882] = 3481,
  [7883] = 3591,
  [7884] = 3482,
  [7885] = 3562,
  [7886] = 3470,
  [7887] = 3606,
  [7888] = 3481,
  [7889] = 3471,
  [7890] = 7890,
  [7891] = 7820,
  [7892] = 7892,
  [7893] = 3600,
  [7894] = 7894,
  [7895] = 5856,
  [7896] = 7820,
  [7897] = 7897,
  [7898] = 7898,
  [7899] = 7899,
  [7900] = 7900,
  [7901] = 7901,
  [7902] = 7902,
  [7903] = 7903,
  [7904] = 7904,
  [7905] = 3471,
  [7906] = 3471,
  [7907] = 3470,
  [7908] = 5856,
  [7909] = 3608,
  [7910] = 3692,
  [7911] = 7726,
  [7912] = 7912,
  [7913] = 7913,
  [7914] = 3514,
  [7915] = 3705,
  [7916] = 3468,
  [7917] = 3547,
  [7918] = 7918,
  [7919] = 3468,
  [7920] = 3562,
  [7921] = 3677,
  [7922] = 3481,
  [7923] = 3677,
  [7924] = 3511,
  [7925] = 3668,
  [7926] = 3543,
  [7927] = 3597,
  [7928] = 3600,
  [7929] = 3576,
  [7930] = 7601,
  [7931] = 3692,
  [7932] = 7932,
  [7933] = 3489,
  [7934] = 7934,
  [7935] = 3470,
  [7936] = 6378,
  [7937] = 3705,
  [7938] = 3468,
  [7939] = 3468,
  [7940] = 5856,
  [7941] = 3546,
  [7942] = 7079,
  [7943] = 7601,
  [7944] = 7892,
  [7945] = 7899,
  [7946] = 7900,
  [7947] = 7901,
  [7948] = 7902,
  [7949] = 3606,
  [7950] = 7881,
  [7951] = 6378,
  [7952] = 3482,
  [7953] = 7903,
  [7954] = 7934,
  [7955] = 7904,
  [7956] = 3514,
  [7957] = 3468,
  [7958] = 7912,
  [7959] = 7875,
  [7960] = 7932,
  [7961] = 3547,
  [7962] = 7894,
  [7963] = 7897,
  [7964] = 3470,
  [7965] = 7890,
  [7966] = 7877,
  [7967] = 3549,
  [7968] = 5856,
  [7969] = 3597,
  [7970] = 3778,
  [7971] = 7913,
  [7972] = 3543,
  [7973] = 3737,
  [7974] = 3738,
  [7975] = 3739,
  [7976] = 3600,
  [7977] = 3742,
  [7978] = 3668,
  [7979] = 3743,
  [7980] = 3747,
  [7981] = 3734,
  [7982] = 3748,
  [7983] = 3762,
  [7984] = 3774,
  [7985] = 3785,
  [7986] = 3608,
  [7987] = 3468,
  [7988] = 3740,
  [7989] = 3745,
  [7990] = 3746,
  [7991] = 3591,
  [7992] = 3481,
  [7993] = 3471,
  [7994] = 3577,
  [7995] = 3489,
  [7996] = 3546,
  [7997] = 3576,
  [7998] = 7877,
  [7999] = 3546,
  [8000] = 3577,
  [8001] = 3482,
  [8002] = 3591,
  [8003] = 3606,
  [8004] = 7918,
  [8005] = 7897,
  [8006] = 3668,
  [8007] = 3543,
  [8008] = 7894,
  [8009] = 3543,
  [8010] = 3744,
  [8011] = 3470,
  [8012] = 5856,
  [8013] = 3481,
  [8014] = 7875,
  [8015] = 3549,
  [8016] = 3760,
  [8017] = 3471,
  [8018] = 7662,
  [8019] = 3547,
  [8020] = 3471,
  [8021] = 7903,
  [8022] = 3470,
  [8023] = 7601,
  [8024] = 7881,
  [8025] = 3705,
  [8026] = 3576,
  [8027] = 3489,
  [8028] = 3608,
  [8029] = 3751,
  [8030] = 3514,
  [8031] = 3692,
  [8032] = 7890,
  [8033] = 7892,
  [8034] = 7899,
  [8035] = 7900,
  [8036] = 7901,
  [8037] = 7902,
  [8038] = 3543,
  [8039] = 3549,
  [8040] = 7934,
  [8041] = 3471,
  [8042] = 7904,
  [8043] = 5856,
  [8044] = 7912,
  [8045] = 3562,
  [8046] = 3468,
  [8047] = 3677,
  [8048] = 3511,
  [8049] = 3597,
  [8050] = 7601,
  [8051] = 3677,
  [8052] = 3562,
  [8053] = 3562,
  [8054] = 3677,
  [8055] = 3468,
  [8056] = 3705,
  [8057] = 7913,
  [8058] = 3547,
  [8059] = 3692,
  [8060] = 3737,
  [8061] = 3470,
  [8062] = 3600,
  [8063] = 3734,
  [8064] = 3748,
  [8065] = 3785,
  [8066] = 3740,
  [8067] = 3668,
  [8068] = 7918,
  [8069] = 7726,
  [8070] = 7820,
  [8071] = 3600,
  [8072] = 3489,
  [8073] = 3481,
  [8074] = 3692,
  [8075] = 3705,
  [8076] = 3778,
  [8077] = 3606,
  [8078] = 3482,
  [8079] = 3600,
  [8080] = 3738,
  [8081] = 3468,
  [8082] = 3739,
  [8083] = 3742,
  [8084] = 3743,
  [8085] = 3744,
  [8086] = 3546,
  [8087] = 3747,
  [8088] = 3576,
  [8089] = 3577,
  [8090] = 3576,
  [8091] = 3762,
  [8092] = 3591,
  [8093] = 3774,
  [8094] = 3745,
  [8095] = 3746,
  [8096] = 3471,
  [8097] = 3471,
  [8098] = 3576,
  [8099] = 3608,
  [8100] = 3514,
  [8101] = 7601,
  [8102] = 3489,
  [8103] = 3549,
  [8104] = 3597,
  [8105] = 3468,
  [8106] = 3514,
  [8107] = 3468,
  [8108] = 3489,
  [8109] = 5856,
  [8110] = 3470,
  [8111] = 3543,
  [8112] = 7601,
  [8113] = 5856,
  [8114] = 7932,
  [8115] = 3549,
  [8116] = 3471,
  [8117] = 3468,
  [8118] = 5856,
  [8119] = 7079,
  [8120] = 3668,
  [8121] = 3606,
  [8122] = 3482,
  [8123] = 3597,
  [8124] = 3546,
  [8125] = 3577,
  [8126] = 3591,
  [8127] = 3608,
  [8128] = 3597,
  [8129] = 3547,
  [8130] = 3470,
  [8131] = 3608,
  [8132] = 3591,
  [8133] = 3470,
  [8134] = 3471,
  [8135] = 3577,
  [8136] = 3468,
  [8137] = 3471,
  [8138] = 3470,
  [8139] = 7079,
  [8140] = 3546,
  [8141] = 3705,
  [8142] = 3760,
  [8143] = 3514,
  [8144] = 3482,
  [8145] = 3692,
  [8146] = 3468,
  [8147] = 3606,
  [8148] = 3751,
  [8149] = 3511,
  [8150] = 3668,
  [8151] = 3547,
  [8152] = 3470,
  [8153] = 3737,
  [8154] = 3739,
  [8155] = 3471,
  [8156] = 3591,
  [8157] = 7726,
  [8158] = 3608,
  [8159] = 3668,
  [8160] = 3606,
  [8161] = 3482,
  [8162] = 3546,
  [8163] = 3470,
  [8164] = 3577,
  [8165] = 7881,
  [8166] = 7903,
  [8167] = 7875,
  [8168] = 3591,
  [8169] = 3547,
  [8170] = 3608,
  [8171] = 3597,
  [8172] = 7894,
  [8173] = 7897,
  [8174] = 7820,
  [8175] = 3597,
  [8176] = 7877,
  [8177] = 3608,
  [8178] = 3481,
  [8179] = 3547,
  [8180] = 3591,
  [8181] = 3481,
  [8182] = 7820,
  [8183] = 3577,
  [8184] = 3734,
  [8185] = 3748,
  [8186] = 3546,
  [8187] = 7726,
  [8188] = 3577,
  [8189] = 3606,
  [8190] = 3482,
  [8191] = 3468,
  [8192] = 3785,
  [8193] = 3751,
  [8194] = 3482,
  [8195] = 3606,
  [8196] = 3740,
  [8197] = 3692,
  [8198] = 3597,
  [8199] = 3481,
  [8200] = 3668,
  [8201] = 3546,
  [8202] = 7892,
  [8203] = 7079,
  [8204] = 3677,
  [8205] = 3482,
  [8206] = 7601,
  [8207] = 7899,
  [8208] = 3562,
  [8209] = 3562,
  [8210] = 3705,
  [8211] = 7662,
  [8212] = 3606,
  [8213] = 7079,
  [8214] = 3760,
  [8215] = 8215,
  [8216] = 7900,
  [8217] = 3668,
  [8218] = 3543,
  [8219] = 3549,
  [8220] = 3468,
  [8221] = 3677,
  [8222] = 7913,
  [8223] = 8223,
  [8224] = 3562,
  [8225] = 3677,
  [8226] = 3481,
  [8227] = 3489,
  [8228] = 3562,
  [8229] = 7901,
  [8230] = 3576,
  [8231] = 3468,
  [8232] = 3470,
  [8233] = 3562,
  [8234] = 7902,
  [8235] = 3692,
  [8236] = 3576,
  [8237] = 3489,
  [8238] = 5856,
  [8239] = 5856,
  [8240] = 3468,
  [8241] = 3705,
  [8242] = 3549,
  [8243] = 3778,
  [8244] = 3543,
  [8245] = 3511,
  [8246] = 3738,
  [8247] = 3577,
  [8248] = 3546,
  [8249] = 3739,
  [8250] = 3742,
  [8251] = 3743,
  [8252] = 3744,
  [8253] = 3747,
  [8254] = 3677,
  [8255] = 3751,
  [8256] = 3481,
  [8257] = 3677,
  [8258] = 3562,
  [8259] = 3576,
  [8260] = 3762,
  [8261] = 5856,
  [8262] = 3760,
  [8263] = 3489,
  [8264] = 3547,
  [8265] = 3562,
  [8266] = 3489,
  [8267] = 3470,
  [8268] = 3576,
  [8269] = 3751,
  [8270] = 3677,
  [8271] = 3677,
  [8272] = 7934,
  [8273] = 7904,
  [8274] = 3740,
  [8275] = 3785,
  [8276] = 3549,
  [8277] = 7726,
  [8278] = 3774,
  [8279] = 3514,
  [8280] = 7820,
  [8281] = 3748,
  [8282] = 3471,
  [8283] = 3734,
  [8284] = 3481,
  [8285] = 3468,
  [8286] = 3481,
  [8287] = 7601,
  [8288] = 3562,
  [8289] = 7912,
  [8290] = 3600,
  [8291] = 3760,
  [8292] = 3751,
  [8293] = 8223,
  [8294] = 3677,
  [8295] = 3737,
  [8296] = 3514,
  [8297] = 3549,
  [8298] = 3471,
  [8299] = 3760,
  [8300] = 5856,
  [8301] = 7601,
  [8302] = 3543,
  [8303] = 3481,
  [8304] = 8215,
  [8305] = 7726,
  [8306] = 3481,
  [8307] = 3677,
  [8308] = 7918,
  [8309] = 3547,
  [8310] = 5856,
  [8311] = 3746,
  [8312] = 7662,
  [8313] = 3514,
  [8314] = 5856,
  [8315] = 3591,
  [8316] = 3745,
  [8317] = 3600,
  [8318] = 3470,
  [8319] = 3543,
  [8320] = 3668,
  [8321] = 3606,
  [8322] = 3482,
  [8323] = 3546,
  [8324] = 7726,
  [8325] = 3577,
  [8326] = 3608,
  [8327] = 7662,
  [8328] = 3549,
  [8329] = 3562,
  [8330] = 3692,
  [8331] = 3591,
  [8332] = 3489,
  [8333] = 3608,
  [8334] = 3576,
  [8335] = 3470,
  [8336] = 3597,
  [8337] = 3547,
  [8338] = 3597,
  [8339] = 3514,
  [8340] = 3600,
  [8341] = 3774,
  [8342] = 3762,
  [8343] = 3600,
  [8344] = 3705,
  [8345] = 3668,
  [8346] = 3468,
  [8347] = 3746,
  [8348] = 3745,
  [8349] = 3746,
  [8350] = 3778,
  [8351] = 3745,
  [8352] = 3742,
  [8353] = 3740,
  [8354] = 3745,
  [8355] = 3740,
  [8356] = 3746,
  [8357] = 3471,
  [8358] = 3471,
  [8359] = 3747,
  [8360] = 3785,
  [8361] = 7890,
  [8362] = 3471,
  [8363] = 3774,
  [8364] = 7932,
  [8365] = 3744,
  [8366] = 3785,
  [8367] = 3762,
  [8368] = 3743,
  [8369] = 3748,
  [8370] = 3734,
  [8371] = 3747,
  [8372] = 3744,
  [8373] = 3743,
  [8374] = 3742,
  [8375] = 3739,
  [8376] = 3778,
  [8377] = 3737,
  [8378] = 3738,
  [8379] = 3738,
  [8380] = 3737,
  [8381] = 3778,
  [8382] = 3774,
  [8383] = 7820,
  [8384] = 3739,
  [8385] = 3742,
  [8386] = 7820,
  [8387] = 3743,
  [8388] = 3744,
  [8389] = 3762,
  [8390] = 3543,
  [8391] = 3514,
  [8392] = 3747,
  [8393] = 3734,
  [8394] = 3748,
  [8395] = 3738,
  [8396] = 3692,
  [8397] = 3470,
  [8398] = 3705,
  [8399] = 5856,
  [8400] = 3747,
  [8401] = 3597,
  [8402] = 3738,
  [8403] = 3739,
  [8404] = 3740,
  [8405] = 7897,
  [8406] = 3543,
  [8407] = 3742,
  [8408] = 7894,
  [8409] = 3743,
  [8410] = 3744,
  [8411] = 3747,
  [8412] = 7900,
  [8413] = 3745,
  [8414] = 7881,
  [8415] = 3785,
  [8416] = 3762,
  [8417] = 3774,
  [8418] = 3762,
  [8419] = 3778,
  [8420] = 3778,
  [8421] = 7903,
  [8422] = 3774,
  [8423] = 3746,
  [8424] = 3738,
  [8425] = 7918,
  [8426] = 3745,
  [8427] = 3705,
  [8428] = 3746,
  [8429] = 7932,
  [8430] = 7875,
  [8431] = 3562,
  [8432] = 3489,
  [8433] = 3748,
  [8434] = 3511,
  [8435] = 3468,
  [8436] = 3739,
  [8437] = 3742,
  [8438] = 3743,
  [8439] = 3744,
  [8440] = 3747,
  [8441] = 3734,
  [8442] = 7877,
  [8443] = 3744,
  [8444] = 3743,
  [8445] = 3742,
  [8446] = 3739,
  [8447] = 3677,
  [8448] = 3543,
  [8449] = 3562,
  [8450] = 7912,
  [8451] = 7894,
  [8452] = 3543,
  [8453] = 3514,
  [8454] = 3738,
  [8455] = 3737,
  [8456] = 3778,
  [8457] = 3547,
  [8458] = 3677,
  [8459] = 3762,
  [8460] = 3774,
  [8461] = 3549,
  [8462] = 7897,
  [8463] = 7875,
  [8464] = 3608,
  [8465] = 7918,
  [8466] = 7903,
  [8467] = 3597,
  [8468] = 7881,
  [8469] = 7913,
  [8470] = 7892,
  [8471] = 3576,
  [8472] = 3591,
  [8473] = 3577,
  [8474] = 3546,
  [8475] = 7899,
  [8476] = 3482,
  [8477] = 3606,
  [8478] = 3576,
  [8479] = 7890,
  [8480] = 7892,
  [8481] = 7899,
  [8482] = 7900,
  [8483] = 3668,
  [8484] = 3591,
  [8485] = 7877,
  [8486] = 7901,
  [8487] = 7901,
  [8488] = 7902,
  [8489] = 7904,
  [8490] = 7934,
  [8491] = 3745,
  [8492] = 3746,
  [8493] = 7902,
  [8494] = 3468,
  [8495] = 3470,
  [8496] = 7934,
  [8497] = 3576,
  [8498] = 7904,
  [8499] = 3489,
  [8500] = 7934,
  [8501] = 7904,
  [8502] = 3511,
  [8503] = 3562,
  [8504] = 3489,
  [8505] = 7902,
  [8506] = 7901,
  [8507] = 3576,
  [8508] = 7913,
  [8509] = 3489,
  [8510] = 3600,
  [8511] = 7900,
  [8512] = 7899,
  [8513] = 7892,
  [8514] = 3576,
  [8515] = 7726,
  [8516] = 3692,
  [8517] = 7890,
  [8518] = 7912,
  [8519] = 7912,
  [8520] = 3677,
  [8521] = 3600,
  [8522] = 8223,
  [8523] = 8215,
  [8524] = 3547,
  [8525] = 3549,
  [8526] = 3597,
  [8527] = 7877,
  [8528] = 3608,
  [8529] = 3591,
  [8530] = 3577,
  [8531] = 3489,
  [8532] = 3514,
  [8533] = 3549,
  [8534] = 7881,
  [8535] = 7820,
  [8536] = 7932,
  [8537] = 3576,
  [8538] = 3549,
  [8539] = 3546,
  [8540] = 3482,
  [8541] = 3606,
  [8542] = 3668,
  [8543] = 7903,
  [8544] = 7918,
  [8545] = 3677,
  [8546] = 3692,
  [8547] = 3471,
  [8548] = 3562,
  [8549] = 3677,
  [8550] = 7875,
  [8551] = 3705,
  [8552] = 3597,
  [8553] = 7601,
  [8554] = 3514,
  [8555] = 7894,
  [8556] = 3608,
  [8557] = 3668,
  [8558] = 3547,
  [8559] = 3591,
  [8560] = 7897,
  [8561] = 7904,
  [8562] = 3751,
  [8563] = 3489,
  [8564] = 3577,
  [8565] = 3514,
  [8566] = 3737,
  [8567] = 3608,
  [8568] = 7913,
  [8569] = 7877,
  [8570] = 3606,
  [8571] = 3600,
  [8572] = 3481,
  [8573] = 3591,
  [8574] = 3546,
  [8575] = 5856,
  [8576] = 3577,
  [8577] = 3549,
  [8578] = 3547,
  [8579] = 3692,
  [8580] = 3546,
  [8581] = 3482,
  [8582] = 3606,
  [8583] = 3760,
  [8584] = 3482,
  [8585] = 3751,
  [8586] = 3482,
  [8587] = 3606,
  [8588] = 7932,
  [8589] = 3543,
  [8590] = 3760,
  [8591] = 3668,
  [8592] = 3600,
  [8593] = 7918,
  [8594] = 3481,
  [8595] = 3668,
  [8596] = 3546,
  [8597] = 3481,
  [8598] = 3577,
  [8599] = 7820,
  [8600] = 3511,
  [8601] = 3751,
  [8602] = 3549,
  [8603] = 3668,
  [8604] = 7881,
  [8605] = 7726,
  [8606] = 7902,
  [8607] = 3734,
  [8608] = 3511,
  [8609] = 7726,
  [8610] = 3489,
  [8611] = 7901,
  [8612] = 7662,
  [8613] = 3576,
  [8614] = 3705,
  [8615] = 3543,
  [8616] = 3740,
  [8617] = 3606,
  [8618] = 3748,
  [8619] = 3785,
  [8620] = 3482,
  [8621] = 3562,
  [8622] = 3608,
  [8623] = 7913,
  [8624] = 3597,
  [8625] = 7897,
  [8626] = 3748,
  [8627] = 7900,
  [8628] = 3734,
  [8629] = 3737,
  [8630] = 7899,
  [8631] = 3543,
  [8632] = 7892,
  [8633] = 3547,
  [8634] = 7890,
  [8635] = 7894,
  [8636] = 7820,
  [8637] = 7875,
  [8638] = 7890,
  [8639] = 7903,
  [8640] = 3778,
  [8641] = 7875,
  [8642] = 3746,
  [8643] = 3740,
  [8644] = 7662,
  [8645] = 7913,
  [8646] = 3745,
  [8647] = 3760,
  [8648] = 7881,
  [8649] = 3546,
  [8650] = 3514,
  [8651] = 5856,
  [8652] = 3549,
  [8653] = 3547,
  [8654] = 7877,
  [8655] = 7902,
  [8656] = 3546,
  [8657] = 3577,
  [8658] = 3481,
  [8659] = 3470,
  [8660] = 3785,
  [8661] = 3591,
  [8662] = 3511,
  [8663] = 7932,
  [8664] = 3514,
  [8665] = 3514,
  [8666] = 3608,
  [8667] = 3608,
  [8668] = 3471,
  [8669] = 7903,
  [8670] = 3597,
  [8671] = 7934,
  [8672] = 3562,
  [8673] = 3774,
  [8674] = 3762,
  [8675] = 3748,
  [8676] = 3747,
  [8677] = 3734,
  [8678] = 7918,
  [8679] = 3751,
  [8680] = 3547,
  [8681] = 7912,
  [8682] = 3591,
  [8683] = 3705,
  [8684] = 7904,
  [8685] = 3543,
  [8686] = 3744,
  [8687] = 3577,
  [8688] = 7934,
  [8689] = 3760,
  [8690] = 3546,
  [8691] = 3743,
  [8692] = 3543,
  [8693] = 3514,
  [8694] = 7900,
  [8695] = 7894,
  [8696] = 3481,
  [8697] = 3668,
  [8698] = 3606,
  [8699] = 7901,
  [8700] = 3482,
  [8701] = 3692,
  [8702] = 3740,
  [8703] = 3576,
  [8704] = 3489,
  [8705] = 7899,
  [8706] = 3785,
  [8707] = 3577,
  [8708] = 3470,
  [8709] = 3597,
  [8710] = 3742,
  [8711] = 3739,
  [8712] = 3591,
  [8713] = 3608,
  [8714] = 3470,
  [8715] = 7892,
  [8716] = 3481,
  [8717] = 3597,
  [8718] = 3471,
  [8719] = 3471,
  [8720] = 7890,
  [8721] = 3737,
  [8722] = 7932,
  [8723] = 3549,
  [8724] = 7897,
  [8725] = 3668,
  [8726] = 3547,
  [8727] = 3738,
  [8728] = 3606,
  [8729] = 3482,
  [8730] = 3677,
  [8731] = 7912,
  [8732] = 3745,
  [8733] = 3747,
  [8734] = 3489,
  [8735] = 5856,
  [8736] = 3577,
  [8737] = 3591,
  [8738] = 3576,
  [8739] = 3751,
  [8740] = 3608,
  [8741] = 3597,
  [8742] = 3549,
  [8743] = 7881,
  [8744] = 3546,
  [8745] = 3546,
  [8746] = 3562,
  [8747] = 3482,
  [8748] = 3547,
  [8749] = 3737,
  [8750] = 7903,
  [8751] = 3606,
  [8752] = 3577,
  [8753] = 7875,
  [8754] = 3591,
  [8755] = 3737,
  [8756] = 3668,
  [8757] = 3677,
  [8758] = 3734,
  [8759] = 7662,
  [8760] = 3677,
  [8761] = 3748,
  [8762] = 3514,
  [8763] = 3734,
  [8764] = 3748,
  [8765] = 3785,
  [8766] = 3562,
  [8767] = 3547,
  [8768] = 3608,
  [8769] = 7894,
  [8770] = 7897,
  [8771] = 3597,
  [8772] = 7877,
  [8773] = 3740,
  [8774] = 7662,
  [8775] = 3751,
  [8776] = 3549,
  [8777] = 3597,
  [8778] = 3608,
  [8779] = 3748,
  [8780] = 7662,
  [8781] = 3591,
  [8782] = 3543,
  [8783] = 3778,
  [8784] = 3738,
  [8785] = 3577,
  [8786] = 7662,
  [8787] = 3739,
  [8788] = 3742,
  [8789] = 3743,
  [8790] = 3489,
  [8791] = 3744,
  [8792] = 3576,
  [8793] = 3514,
  [8794] = 3747,
  [8795] = 3760,
  [8796] = 7662,
  [8797] = 7662,
  [8798] = 3546,
  [8799] = 3762,
  [8800] = 3774,
  [8801] = 7890,
  [8802] = 3482,
  [8803] = 3547,
  [8804] = 7899,
  [8805] = 3606,
  [8806] = 7900,
  [8807] = 3482,
  [8808] = 3668,
  [8809] = 3745,
  [8810] = 3746,
  [8811] = 3606,
  [8812] = 3549,
  [8813] = 3760,
  [8814] = 3597,
  [8815] = 7901,
  [8816] = 3608,
  [8817] = 7902,
  [8818] = 3543,
  [8819] = 3785,
  [8820] = 3543,
  [8821] = 3591,
  [8822] = 3514,
  [8823] = 3543,
  [8824] = 3577,
  [8825] = 3481,
  [8826] = 3751,
  [8827] = 3546,
  [8828] = 7912,
  [8829] = 3489,
  [8830] = 3743,
  [8831] = 3576,
  [8832] = 7918,
  [8833] = 3482,
  [8834] = 7904,
  [8835] = 3606,
  [8836] = 3740,
  [8837] = 7892,
  [8838] = 3778,
  [8839] = 7934,
  [8840] = 3668,
  [8841] = 3668,
  [8842] = 7904,
  [8843] = 3668,
  [8844] = 3738,
  [8845] = 3739,
  [8846] = 3511,
  [8847] = 3742,
  [8848] = 7662,
  [8849] = 3514,
  [8850] = 3606,
  [8851] = 3743,
  [8852] = 3482,
  [8853] = 7932,
  [8854] = 7912,
  [8855] = 3760,
  [8856] = 3511,
  [8857] = 3546,
  [8858] = 3577,
  [8859] = 3744,
  [8860] = 3591,
  [8861] = 3668,
  [8862] = 7934,
  [8863] = 3547,
  [8864] = 3608,
  [8865] = 3597,
  [8866] = 7902,
  [8867] = 7901,
  [8868] = 3547,
  [8869] = 3778,
  [8870] = 7913,
  [8871] = 7900,
  [8872] = 3740,
  [8873] = 7899,
  [8874] = 7892,
  [8875] = 3737,
  [8876] = 7890,
  [8877] = 3738,
  [8878] = 5856,
  [8879] = 3562,
  [8880] = 3481,
  [8881] = 3737,
  [8882] = 3668,
  [8883] = 3705,
  [8884] = 3549,
  [8885] = 3762,
  [8886] = 3774,
  [8887] = 3692,
  [8888] = 3739,
  [8889] = 3734,
  [8890] = 3748,
  [8891] = 7877,
  [8892] = 7881,
  [8893] = 3470,
  [8894] = 7903,
  [8895] = 3481,
  [8896] = 3785,
  [8897] = 7913,
  [8898] = 3543,
  [8899] = 3742,
  [8900] = 7918,
  [8901] = 3744,
  [8902] = 3747,
  [8903] = 7875,
  [8904] = 3740,
  [8905] = 7932,
  [8906] = 7897,
  [8907] = 3549,
  [8908] = 3468,
  [8909] = 7894,
  [8910] = 3543,
  [8911] = 7894,
  [8912] = 3785,
  [8913] = 7897,
  [8914] = 7875,
  [8915] = 7820,
  [8916] = 7918,
  [8917] = 3489,
  [8918] = 3489,
  [8919] = 3576,
  [8920] = 7662,
  [8921] = 3481,
  [8922] = 7932,
  [8923] = 3576,
  [8924] = 7903,
  [8925] = 3746,
  [8926] = 7881,
  [8927] = 7662,
  [8928] = 3576,
  [8929] = 3514,
  [8930] = 3677,
  [8931] = 3606,
  [8932] = 3482,
  [8933] = 3677,
  [8934] = 3600,
  [8935] = 3762,
  [8936] = 3774,
  [8937] = 3471,
  [8938] = 3489,
  [8939] = 7662,
  [8940] = 3511,
  [8941] = 3547,
  [8942] = 3514,
  [8943] = 7890,
  [8944] = 3597,
  [8945] = 3745,
  [8946] = 7892,
  [8947] = 3608,
  [8948] = 3514,
  [8949] = 3746,
  [8950] = 3549,
  [8951] = 7877,
  [8952] = 3576,
  [8953] = 3562,
  [8954] = 3489,
  [8955] = 3481,
  [8956] = 7900,
  [8957] = 3778,
  [8958] = 3760,
  [8959] = 7913,
  [8960] = 3547,
  [8961] = 3738,
  [8962] = 3543,
  [8963] = 3739,
  [8964] = 3597,
  [8965] = 3734,
  [8966] = 3608,
  [8967] = 3751,
  [8968] = 3591,
  [8969] = 7899,
  [8970] = 3742,
  [8971] = 3743,
  [8972] = 3549,
  [8973] = 3591,
  [8974] = 3577,
  [8975] = 3744,
  [8976] = 3747,
  [8977] = 3546,
  [8978] = 3546,
  [8979] = 7726,
  [8980] = 3482,
  [8981] = 3606,
  [8982] = 3762,
  [8983] = 7912,
  [8984] = 3774,
  [8985] = 7901,
  [8986] = 7902,
  [8987] = 7904,
  [8988] = 3746,
  [8989] = 3745,
  [8990] = 7934,
  [8991] = 3577,
  [8992] = 8992,
  [8993] = 8992,
  [8994] = 3514,
  [8995] = 3577,
  [8996] = 3591,
  [8997] = 8992,
  [8998] = 8992,
  [8999] = 3546,
  [9000] = 3608,
  [9001] = 8992,
  [9002] = 3597,
  [9003] = 3482,
  [9004] = 3606,
  [9005] = 8992,
  [9006] = 7932,
  [9007] = 3547,
  [9008] = 8992,
  [9009] = 8992,
  [9010] = 8992,
  [9011] = 8992,
  [9012] = 3668,
  [9013] = 8992,
  [9014] = 7662,
  [9015] = 8992,
  [9016] = 7877,
  [9017] = 7897,
  [9018] = 8992,
  [9019] = 9019,
  [9020] = 8992,
  [9021] = 3547,
  [9022] = 8992,
  [9023] = 8992,
  [9024] = 8992,
  [9025] = 8992,
  [9026] = 3597,
  [9027] = 3762,
  [9028] = 8992,
  [9029] = 8992,
  [9030] = 3608,
  [9031] = 8992,
  [9032] = 8992,
  [9033] = 8992,
  [9034] = 8992,
  [9035] = 3677,
  [9036] = 8992,
  [9037] = 8992,
  [9038] = 8992,
  [9039] = 8992,
  [9040] = 3591,
  [9041] = 8992,
  [9042] = 8992,
  [9043] = 3577,
  [9044] = 7894,
  [9045] = 3562,
  [9046] = 8992,
  [9047] = 3546,
  [9048] = 8992,
  [9049] = 8992,
  [9050] = 8992,
  [9051] = 8992,
  [9052] = 7875,
  [9053] = 7662,
  [9054] = 8992,
  [9055] = 8992,
  [9056] = 8992,
  [9057] = 3489,
  [9058] = 3774,
  [9059] = 8992,
  [9060] = 8992,
  [9061] = 8992,
  [9062] = 8992,
  [9063] = 7662,
  [9064] = 7918,
  [9065] = 7662,
  [9066] = 8992,
  [9067] = 8992,
  [9068] = 8992,
  [9069] = 3737,
  [9070] = 8992,
  [9071] = 8992,
  [9072] = 9019,
  [9073] = 8992,
  [9074] = 7903,
  [9075] = 8992,
  [9076] = 3482,
  [9077] = 7881,
  [9078] = 8992,
  [9079] = 3468,
  [9080] = 3606,
  [9081] = 3470,
  [9082] = 7662,
  [9083] = 8992,
  [9084] = 8992,
  [9085] = 8992,
  [9086] = 7601,
  [9087] = 3734,
  [9088] = 7601,
  [9089] = 8992,
  [9090] = 3748,
  [9091] = 8992,
  [9092] = 8992,
  [9093] = 3785,
  [9094] = 8992,
  [9095] = 7890,
  [9096] = 8992,
  [9097] = 3740,
  [9098] = 7899,
  [9099] = 8992,
  [9100] = 8992,
  [9101] = 8992,
  [9102] = 8992,
  [9103] = 7900,
  [9104] = 8992,
  [9105] = 8992,
  [9106] = 3511,
  [9107] = 7913,
  [9108] = 8992,
  [9109] = 8992,
  [9110] = 7662,
  [9111] = 7901,
  [9112] = 9019,
  [9113] = 8992,
  [9114] = 3549,
  [9115] = 8992,
  [9116] = 9019,
  [9117] = 7662,
  [9118] = 7902,
  [9119] = 8992,
  [9120] = 3514,
  [9121] = 9019,
  [9122] = 8992,
  [9123] = 8992,
  [9124] = 8992,
  [9125] = 3576,
  [9126] = 8992,
  [9127] = 8992,
  [9128] = 7662,
  [9129] = 9019,
  [9130] = 3543,
  [9131] = 8992,
  [9132] = 8992,
  [9133] = 8992,
  [9134] = 3778,
  [9135] = 9019,
  [9136] = 8992,
  [9137] = 8992,
  [9138] = 7934,
  [9139] = 3471,
  [9140] = 7904,
  [9141] = 8992,
  [9142] = 3738,
  [9143] = 8992,
  [9144] = 8992,
  [9145] = 7912,
  [9146] = 8992,
  [9147] = 8992,
  [9148] = 8992,
  [9149] = 8992,
  [9150] = 9019,
  [9151] = 8992,
  [9152] = 7892,
  [9153] = 8992,
  [9154] = 8992,
  [9155] = 8992,
  [9156] = 8992,
  [9157] = 3481,
  [9158] = 3739,
  [9159] = 8992,
  [9160] = 8992,
  [9161] = 3543,
  [9162] = 8992,
  [9163] = 9019,
  [9164] = 3668,
  [9165] = 3549,
  [9166] = 3742,
  [9167] = 3743,
  [9168] = 3744,
  [9169] = 3745,
  [9170] = 8992,
  [9171] = 8992,
  [9172] = 8992,
  [9173] = 8992,
  [9174] = 8992,
  [9175] = 3747,
  [9176] = 8992,
  [9177] = 8992,
  [9178] = 8992,
  [9179] = 8992,
  [9180] = 8992,
  [9181] = 8992,
  [9182] = 8992,
  [9183] = 8992,
  [9184] = 8992,
  [9185] = 3760,
  [9186] = 9019,
  [9187] = 8992,
  [9188] = 8992,
  [9189] = 9019,
  [9190] = 8992,
  [9191] = 9019,
  [9192] = 7859,
  [9193] = 8992,
  [9194] = 7662,
  [9195] = 8992,
  [9196] = 8992,
  [9197] = 8992,
  [9198] = 8992,
  [9199] = 7662,
  [9200] = 9019,
  [9201] = 7662,
  [9202] = 7662,
  [9203] = 9019,
  [9204] = 8992,
  [9205] = 8992,
  [9206] = 7662,
  [9207] = 3751,
  [9208] = 7662,
  [9209] = 8992,
  [9210] = 8992,
  [9211] = 8992,
  [9212] = 7662,
  [9213] = 3746,
  [9214] = 3576,
  [9215] = 8992,
  [9216] = 8992,
  [9217] = 3489,
  [9218] = 9218,
  [9219] = 7662,
  [9220] = 7662,
  [9221] = 3481,
  [9222] = 3481,
  [9223] = 7726,
  [9224] = 3470,
  [9225] = 7820,
  [9226] = 3470,
  [9227] = 7662,
  [9228] = 9228,
  [9229] = 3481,
  [9230] = 7726,
  [9231] = 3468,
  [9232] = 7820,
  [9233] = 3677,
  [9234] = 5856,
  [9235] = 3471,
  [9236] = 7662,
  [9237] = 5856,
  [9238] = 3562,
  [9239] = 9239,
  [9240] = 3471,
  [9241] = 7662,
  [9242] = 9242,
  [9243] = 3468,
  [9244] = 9019,
  [9245] = 3562,
  [9246] = 7902,
  [9247] = 7901,
  [9248] = 7932,
  [9249] = 7913,
  [9250] = 7934,
  [9251] = 3668,
  [9252] = 3577,
  [9253] = 3543,
  [9254] = 3606,
  [9255] = 3597,
  [9256] = 3668,
  [9257] = 9019,
  [9258] = 7904,
  [9259] = 9019,
  [9260] = 3692,
  [9261] = 3482,
  [9262] = 9262,
  [9263] = 9263,
  [9264] = 3514,
  [9265] = 7900,
  [9266] = 7900,
  [9267] = 3549,
  [9268] = 9268,
  [9269] = 9019,
  [9270] = 3606,
  [9271] = 7912,
  [9272] = 9019,
  [9273] = 9019,
  [9274] = 3482,
  [9275] = 3677,
  [9276] = 3591,
  [9277] = 9277,
  [9278] = 7899,
  [9279] = 7918,
  [9280] = 9019,
  [9281] = 9019,
  [9282] = 3705,
  [9283] = 3511,
  [9284] = 3600,
  [9285] = 7892,
  [9286] = 7894,
  [9287] = 7890,
  [9288] = 7897,
  [9289] = 3677,
  [9290] = 9019,
  [9291] = 9291,
  [9292] = 7912,
  [9293] = 9019,
  [9294] = 3606,
  [9295] = 9019,
  [9296] = 3489,
  [9297] = 7662,
  [9298] = 3576,
  [9299] = 7875,
  [9300] = 7881,
  [9301] = 3668,
  [9302] = 9019,
  [9303] = 9242,
  [9304] = 7903,
  [9305] = 9019,
  [9306] = 7875,
  [9307] = 9019,
  [9308] = 9019,
  [9309] = 9019,
  [9310] = 3546,
  [9311] = 9019,
  [9312] = 9019,
  [9313] = 3577,
  [9314] = 9019,
  [9315] = 3482,
  [9316] = 9019,
  [9317] = 3591,
  [9318] = 3511,
  [9319] = 3514,
  [9320] = 3591,
  [9321] = 3511,
  [9322] = 9019,
  [9323] = 3543,
  [9324] = 3608,
  [9325] = 7894,
  [9326] = 9019,
  [9327] = 7897,
  [9328] = 9019,
  [9329] = 7662,
  [9330] = 9019,
  [9331] = 9019,
  [9332] = 9263,
  [9333] = 9333,
  [9334] = 3546,
  [9335] = 3597,
  [9336] = 7877,
  [9337] = 3576,
  [9338] = 9218,
  [9339] = 9019,
  [9340] = 7890,
  [9341] = 3547,
  [9342] = 3549,
  [9343] = 3549,
  [9344] = 7899,
  [9345] = 3608,
  [9346] = 3547,
  [9347] = 3489,
  [9348] = 3547,
  [9349] = 3514,
  [9350] = 3577,
  [9351] = 7913,
  [9352] = 3597,
  [9353] = 3546,
  [9354] = 9019,
  [9355] = 3632,
  [9356] = 7877,
  [9357] = 3608,
  [9358] = 9358,
  [9359] = 9359,
  [9360] = 9019,
  [9361] = 9019,
  [9362] = 7934,
  [9363] = 7904,
  [9364] = 7881,
  [9365] = 3489,
  [9366] = 3576,
  [9367] = 7918,
  [9368] = 9019,
  [9369] = 7932,
  [9370] = 7902,
  [9371] = 7903,
  [9372] = 7901,
  [9373] = 9019,
  [9374] = 3562,
  [9375] = 3543,
  [9376] = 7892,
  [9377] = 9019,
  [9378] = 3511,
  [9379] = 3742,
  [9380] = 3740,
  [9381] = 3745,
  [9382] = 3753,
  [9383] = 3751,
  [9384] = 9333,
  [9385] = 3754,
  [9386] = 3774,
  [9387] = 7703,
  [9388] = 3746,
  [9389] = 3756,
  [9390] = 3757,
  [9391] = 3758,
  [9392] = 3762,
  [9393] = 3761,
  [9394] = 3468,
  [9395] = 3763,
  [9396] = 3765,
  [9397] = 3767,
  [9398] = 3747,
  [9399] = 3768,
  [9400] = 3750,
  [9401] = 3770,
  [9402] = 3744,
  [9403] = 3772,
  [9404] = 3743,
  [9405] = 3781,
  [9406] = 9406,
  [9407] = 3692,
  [9408] = 3752,
  [9409] = 3766,
  [9410] = 3760,
  [9411] = 3783,
  [9412] = 9412,
  [9413] = 3735,
  [9414] = 3739,
  [9415] = 9333,
  [9416] = 3779,
  [9417] = 3782,
  [9418] = 3737,
  [9419] = 3784,
  [9420] = 3738,
  [9421] = 3778,
  [9422] = 3749,
  [9423] = 7725,
  [9424] = 3705,
  [9425] = 3788,
  [9426] = 7857,
  [9427] = 3734,
  [9428] = 3748,
  [9429] = 9358,
  [9430] = 3776,
  [9431] = 3787,
  [9432] = 3775,
  [9433] = 9268,
  [9434] = 3773,
  [9435] = 3771,
  [9436] = 3600,
  [9437] = 3764,
  [9438] = 3785,
  [9439] = 9268,
  [9440] = 3632,
  [9441] = 3765,
  [9442] = 9218,
  [9443] = 3749,
  [9444] = 3825,
  [9445] = 3750,
  [9446] = 7859,
  [9447] = 3746,
  [9448] = 3745,
  [9449] = 9449,
  [9450] = 9228,
  [9451] = 9451,
  [9452] = 7703,
  [9453] = 3737,
  [9454] = 9239,
  [9455] = 9455,
  [9456] = 3784,
  [9457] = 3481,
  [9458] = 3471,
  [9459] = 9218,
  [9460] = 3774,
  [9461] = 3762,
  [9462] = 9462,
  [9463] = 9463,
  [9464] = 3734,
  [9465] = 3760,
  [9466] = 9466,
  [9467] = 9467,
  [9468] = 3764,
  [9469] = 3783,
  [9470] = 3782,
  [9471] = 3766,
  [9472] = 3853,
  [9473] = 3843,
  [9474] = 3747,
  [9475] = 3779,
  [9476] = 3744,
  [9477] = 3743,
  [9478] = 3735,
  [9479] = 3748,
  [9480] = 3470,
  [9481] = 3752,
  [9482] = 3785,
  [9483] = 3781,
  [9484] = 3772,
  [9485] = 9218,
  [9486] = 3770,
  [9487] = 3771,
  [9488] = 3773,
  [9489] = 3768,
  [9490] = 3742,
  [9491] = 3767,
  [9492] = 3751,
  [9493] = 3468,
  [9494] = 3799,
  [9495] = 3739,
  [9496] = 3740,
  [9497] = 3763,
  [9498] = 3801,
  [9499] = 3761,
  [9500] = 3775,
  [9501] = 3809,
  [9502] = 3813,
  [9503] = 3738,
  [9504] = 3758,
  [9505] = 3757,
  [9506] = 3824,
  [9507] = 3829,
  [9508] = 3832,
  [9509] = 3756,
  [9510] = 5856,
  [9511] = 3787,
  [9512] = 3754,
  [9513] = 3788,
  [9514] = 3776,
  [9515] = 3753,
  [9516] = 3778,
  [9517] = 3824,
  [9518] = 3705,
  [9519] = 3825,
  [9520] = 9268,
  [9521] = 9521,
  [9522] = 9522,
  [9523] = 9523,
  [9524] = 9524,
  [9525] = 3677,
  [9526] = 9526,
  [9527] = 9527,
  [9528] = 3853,
  [9529] = 9529,
  [9530] = 9263,
  [9531] = 9531,
  [9532] = 3668,
  [9533] = 9533,
  [9534] = 9534,
  [9535] = 3562,
  [9536] = 3843,
  [9537] = 3471,
  [9538] = 9218,
  [9539] = 9539,
  [9540] = 3606,
  [9541] = 9541,
  [9542] = 3813,
  [9543] = 3468,
  [9544] = 9358,
  [9545] = 9218,
  [9546] = 3799,
  [9547] = 3600,
  [9548] = 3801,
  [9549] = 3511,
  [9550] = 9550,
  [9551] = 3482,
  [9552] = 3829,
  [9553] = 9553,
  [9554] = 9554,
  [9555] = 9333,
  [9556] = 3832,
  [9557] = 3546,
  [9558] = 9268,
  [9559] = 3577,
  [9560] = 3632,
  [9561] = 3543,
  [9562] = 9562,
  [9563] = 9449,
  [9564] = 3809,
  [9565] = 9333,
  [9566] = 9263,
  [9567] = 9567,
  [9568] = 3514,
  [9569] = 9569,
  [9570] = 3591,
  [9571] = 9218,
  [9572] = 9277,
  [9573] = 3547,
  [9574] = 9218,
  [9575] = 3692,
  [9576] = 3549,
  [9577] = 3470,
  [9578] = 3608,
  [9579] = 9218,
  [9580] = 3597,
  [9581] = 3489,
  [9582] = 9582,
  [9583] = 9527,
  [9584] = 3576,
  [9585] = 9218,
  [9586] = 3606,
  [9587] = 3763,
  [9588] = 9541,
  [9589] = 9589,
  [9590] = 3743,
  [9591] = 3742,
  [9592] = 3739,
  [9593] = 3481,
  [9594] = 3738,
  [9595] = 3778,
  [9596] = 9218,
  [9597] = 9218,
  [9598] = 3751,
  [9599] = 3740,
  [9600] = 9589,
  [9601] = 3543,
  [9602] = 9554,
  [9603] = 9553,
  [9604] = 3785,
  [9605] = 9358,
  [9606] = 3547,
  [9607] = 9589,
  [9608] = 3705,
  [9609] = 3748,
  [9610] = 3597,
  [9611] = 3608,
  [9612] = 3591,
  [9613] = 3577,
  [9614] = 3546,
  [9615] = 9615,
  [9616] = 3482,
  [9617] = 3734,
  [9618] = 3737,
  [9619] = 3470,
  [9620] = 3668,
  [9621] = 3908,
  [9622] = 3744,
  [9623] = 3747,
  [9624] = 9333,
  [9625] = 9333,
  [9626] = 9589,
  [9627] = 3752,
  [9628] = 3750,
  [9629] = 9263,
  [9630] = 3511,
  [9631] = 9534,
  [9632] = 3762,
  [9633] = 9268,
  [9634] = 9218,
  [9635] = 3692,
  [9636] = 3562,
  [9637] = 3774,
  [9638] = 3600,
  [9639] = 3632,
  [9640] = 3753,
  [9641] = 3754,
  [9642] = 3756,
  [9643] = 3757,
  [9644] = 9582,
  [9645] = 3749,
  [9646] = 3758,
  [9647] = 9531,
  [9648] = 9533,
  [9649] = 3761,
  [9650] = 9524,
  [9651] = 9539,
  [9652] = 9526,
  [9653] = 9589,
  [9654] = 9521,
  [9655] = 9218,
  [9656] = 3549,
  [9657] = 9529,
  [9658] = 9589,
  [9659] = 3765,
  [9660] = 9333,
  [9661] = 3481,
  [9662] = 3767,
  [9663] = 3768,
  [9664] = 3745,
  [9665] = 3770,
  [9666] = 3772,
  [9667] = 3746,
  [9668] = 9333,
  [9669] = 3781,
  [9670] = 9333,
  [9671] = 3908,
  [9672] = 9218,
  [9673] = 3600,
  [9674] = 9589,
  [9675] = 9589,
  [9676] = 9527,
  [9677] = 9523,
  [9678] = 3677,
  [9679] = 3632,
  [9680] = 3735,
  [9681] = 9277,
  [9682] = 3514,
  [9683] = 3692,
  [9684] = 9522,
  [9685] = 9567,
  [9686] = 9268,
  [9687] = 9268,
  [9688] = 9333,
  [9689] = 3779,
  [9690] = 3471,
  [9691] = 9358,
  [9692] = 3782,
  [9693] = 3489,
  [9694] = 9589,
  [9695] = 3783,
  [9696] = 3784,
  [9697] = 3576,
  [9698] = 9218,
  [9699] = 3788,
  [9700] = 9268,
  [9701] = 3776,
  [9702] = 3468,
  [9703] = 3705,
  [9704] = 3787,
  [9705] = 9562,
  [9706] = 9268,
  [9707] = 9268,
  [9708] = 3775,
  [9709] = 3773,
  [9710] = 3771,
  [9711] = 3766,
  [9712] = 9589,
  [9713] = 9218,
  [9714] = 9569,
  [9715] = 3764,
  [9716] = 3760,
  [9717] = 9717,
  [9718] = 3783,
  [9719] = 9717,
  [9720] = 3668,
  [9721] = 9218,
  [9722] = 3737,
  [9723] = 3547,
  [9724] = 3785,
  [9725] = 9717,
  [9726] = 9717,
  [9727] = 9727,
  [9728] = 9717,
  [9729] = 3734,
  [9730] = 9727,
  [9731] = 3748,
  [9732] = 3832,
  [9733] = 3829,
  [9734] = 9727,
  [9735] = 9717,
  [9736] = 3824,
  [9737] = 9268,
  [9738] = 4095,
  [9739] = 3813,
  [9740] = 3606,
  [9741] = 9727,
  [9742] = 3482,
  [9743] = 9727,
  [9744] = 3809,
  [9745] = 3749,
  [9746] = 9727,
  [9747] = 9727,
  [9748] = 4079,
  [9749] = 9717,
  [9750] = 3801,
  [9751] = 3546,
  [9752] = 9727,
  [9753] = 9717,
  [9754] = 9727,
  [9755] = 9727,
  [9756] = 3799,
  [9757] = 3577,
  [9758] = 4058,
  [9759] = 4095,
  [9760] = 9727,
  [9761] = 9717,
  [9762] = 3591,
  [9763] = 9717,
  [9764] = 9717,
  [9765] = 9717,
  [9766] = 3817,
  [9767] = 9727,
  [9768] = 3740,
  [9769] = 9727,
  [9770] = 3764,
  [9771] = 3608,
  [9772] = 3843,
  [9773] = 9717,
  [9774] = 3597,
  [9775] = 3766,
  [9776] = 4079,
  [9777] = 9268,
  [9778] = 9727,
  [9779] = 4058,
  [9780] = 9717,
  [9781] = 3677,
  [9782] = 3853,
  [9783] = 3771,
  [9784] = 3817,
  [9785] = 3825,
  [9786] = 3773,
  [9787] = 9727,
  [9788] = 3705,
  [9789] = 3775,
  [9790] = 3692,
  [9791] = 9791,
  [9792] = 9268,
  [9793] = 3778,
  [9794] = 3737,
  [9795] = 3562,
  [9796] = 3738,
  [9797] = 9727,
  [9798] = 3744,
  [9799] = 3600,
  [9800] = 9727,
  [9801] = 3739,
  [9802] = 3787,
  [9803] = 3742,
  [9804] = 9717,
  [9805] = 3776,
  [9806] = 3743,
  [9807] = 9717,
  [9808] = 9727,
  [9809] = 3788,
  [9810] = 3747,
  [9811] = 9717,
  [9812] = 3734,
  [9813] = 3784,
  [9814] = 3748,
  [9815] = 4129,
  [9816] = 9717,
  [9817] = 3762,
  [9818] = 3774,
  [9819] = 3785,
  [9820] = 9727,
  [9821] = 9717,
  [9822] = 3783,
  [9823] = 3782,
  [9824] = 3468,
  [9825] = 9727,
  [9826] = 9717,
  [9827] = 3740,
  [9828] = 9717,
  [9829] = 9717,
  [9830] = 3745,
  [9831] = 3746,
  [9832] = 9717,
  [9833] = 3514,
  [9834] = 9717,
  [9835] = 3779,
  [9836] = 9333,
  [9837] = 9717,
  [9838] = 9727,
  [9839] = 3751,
  [9840] = 3778,
  [9841] = 9727,
  [9842] = 3738,
  [9843] = 9333,
  [9844] = 3735,
  [9845] = 9268,
  [9846] = 3762,
  [9847] = 9717,
  [9848] = 9727,
  [9849] = 9218,
  [9850] = 3739,
  [9851] = 3742,
  [9852] = 3743,
  [9853] = 3744,
  [9854] = 9727,
  [9855] = 3781,
  [9856] = 9727,
  [9857] = 9717,
  [9858] = 3772,
  [9859] = 9727,
  [9860] = 3747,
  [9861] = 9727,
  [9862] = 3770,
  [9863] = 3768,
  [9864] = 9727,
  [9865] = 3774,
  [9866] = 9727,
  [9867] = 9333,
  [9868] = 3760,
  [9869] = 9717,
  [9870] = 3767,
  [9871] = 3745,
  [9872] = 9333,
  [9873] = 3746,
  [9874] = 3765,
  [9875] = 3763,
  [9876] = 4129,
  [9877] = 3511,
  [9878] = 9333,
  [9879] = 9717,
  [9880] = 9717,
  [9881] = 9268,
  [9882] = 9717,
  [9883] = 3761,
  [9884] = 9717,
  [9885] = 9727,
  [9886] = 9727,
  [9887] = 3751,
  [9888] = 3758,
  [9889] = 9727,
  [9890] = 3757,
  [9891] = 3756,
  [9892] = 3754,
  [9893] = 9268,
  [9894] = 9717,
  [9895] = 9727,
  [9896] = 3753,
  [9897] = 9727,
  [9898] = 3549,
  [9899] = 3468,
  [9900] = 9277,
  [9901] = 3489,
  [9902] = 3576,
  [9903] = 9727,
  [9904] = 9717,
  [9905] = 9727,
  [9906] = 3750,
  [9907] = 3749,
  [9908] = 9727,
  [9909] = 9268,
  [9910] = 9727,
  [9911] = 9263,
  [9912] = 3752,
  [9913] = 9717,
  [9914] = 9727,
  [9915] = 9717,
  [9916] = 9727,
  [9917] = 3764,
  [9918] = 3766,
  [9919] = 9717,
  [9920] = 9727,
  [9921] = 9727,
  [9922] = 9717,
  [9923] = 3908,
  [9924] = 3771,
  [9925] = 3773,
  [9926] = 3760,
  [9927] = 3775,
  [9928] = 3787,
  [9929] = 9717,
  [9930] = 9717,
  [9931] = 3776,
  [9932] = 3788,
  [9933] = 3767,
  [9934] = 3752,
  [9935] = 3784,
  [9936] = 9717,
  [9937] = 3782,
  [9938] = 3632,
  [9939] = 9717,
  [9940] = 9263,
  [9941] = 3471,
  [9942] = 3779,
  [9943] = 3750,
  [9944] = 3470,
  [9945] = 9945,
  [9946] = 3735,
  [9947] = 9717,
  [9948] = 9717,
  [9949] = 9358,
  [9950] = 9218,
  [9951] = 3753,
  [9952] = 3781,
  [9953] = 3754,
  [9954] = 9333,
  [9955] = 3756,
  [9956] = 9727,
  [9957] = 3772,
  [9958] = 3543,
  [9959] = 3757,
  [9960] = 3770,
  [9961] = 3758,
  [9962] = 3768,
  [9963] = 9727,
  [9964] = 9727,
  [9965] = 9449,
  [9966] = 9717,
  [9967] = 3765,
  [9968] = 3761,
  [9969] = 3763,
  [9970] = 9218,
  [9971] = 9333,
  [9972] = 9717,
  [9973] = 9727,
  [9974] = 3705,
  [9975] = 9975,
  [9976] = 9582,
  [9977] = 9975,
  [9978] = 3481,
  [9979] = 9979,
  [9980] = 9975,
  [9981] = 9975,
  [9982] = 3843,
  [9983] = 9358,
  [9984] = 3692,
  [9985] = 9975,
  [9986] = 9562,
  [9987] = 9975,
  [9988] = 9975,
  [9989] = 9975,
  [9990] = 9975,
  [9991] = 9975,
  [9992] = 3853,
  [9993] = 9277,
  [9994] = 9975,
  [9995] = 3752,
  [9996] = 3668,
  [9997] = 3606,
  [9998] = 3482,
  [9999] = 3546,
  [10000] = 3801,
  [10001] = 3577,
  [10002] = 3591,
  [10003] = 3608,
  [10004] = 3597,
  [10005] = 3547,
  [10006] = 9975,
  [10007] = 3562,
  [10008] = 3825,
  [10009] = 3677,
  [10010] = 9975,
  [10011] = 3750,
  [10012] = 9554,
  [10013] = 9553,
  [10014] = 3908,
  [10015] = 9569,
  [10016] = 9263,
  [10017] = 9534,
  [10018] = 3753,
  [10019] = 9975,
  [10020] = 3754,
  [10021] = 9533,
  [10022] = 3749,
  [10023] = 3756,
  [10024] = 3757,
  [10025] = 3468,
  [10026] = 9975,
  [10027] = 3761,
  [10028] = 3809,
  [10029] = 3600,
  [10030] = 3813,
  [10031] = 3632,
  [10032] = 3763,
  [10033] = 3765,
  [10034] = 3767,
  [10035] = 9449,
  [10036] = 9522,
  [10037] = 3768,
  [10038] = 9521,
  [10039] = 3770,
  [10040] = 3772,
  [10041] = 3781,
  [10042] = 3735,
  [10043] = 9526,
  [10044] = 3471,
  [10045] = 3779,
  [10046] = 9524,
  [10047] = 3782,
  [10048] = 3783,
  [10049] = 3784,
  [10050] = 9975,
  [10051] = 3788,
  [10052] = 3824,
  [10053] = 9975,
  [10054] = 3776,
  [10055] = 3787,
  [10056] = 3775,
  [10057] = 3705,
  [10058] = 3773,
  [10059] = 3771,
  [10060] = 9975,
  [10061] = 3758,
  [10062] = 10062,
  [10063] = 9218,
  [10064] = 3766,
  [10065] = 3764,
  [10066] = 3692,
  [10067] = 9263,
  [10068] = 3829,
  [10069] = 9975,
  [10070] = 9975,
  [10071] = 9975,
  [10072] = 9975,
  [10073] = 9975,
  [10074] = 9975,
  [10075] = 9975,
  [10076] = 3832,
  [10077] = 9975,
  [10078] = 10078,
  [10079] = 9975,
  [10080] = 9975,
  [10081] = 9975,
  [10082] = 9975,
  [10083] = 9975,
  [10084] = 9975,
  [10085] = 9268,
  [10086] = 9975,
  [10087] = 9975,
  [10088] = 9277,
  [10089] = 3514,
  [10090] = 9975,
  [10091] = 3799,
  [10092] = 9358,
  [10093] = 10078,
  [10094] = 9975,
  [10095] = 9268,
  [10096] = 9333,
  [10097] = 3705,
  [10098] = 9550,
  [10099] = 9975,
  [10100] = 4129,
  [10101] = 3825,
  [10102] = 9333,
  [10103] = 3468,
  [10104] = 3471,
  [10105] = 3471,
  [10106] = 3632,
  [10107] = 3692,
  [10108] = 9975,
  [10109] = 9975,
  [10110] = 9975,
  [10111] = 9975,
  [10112] = 9975,
  [10113] = 3817,
  [10114] = 4058,
  [10115] = 4079,
  [10116] = 9975,
  [10117] = 10117,
  [10118] = 3470,
  [10119] = 3908,
  [10120] = 3751,
  [10121] = 3853,
  [10122] = 9975,
  [10123] = 9277,
  [10124] = 3760,
  [10125] = 9975,
  [10126] = 4095,
  [10127] = 9975,
  [10128] = 3470,
  [10129] = 9975,
  [10130] = 3843,
  [10131] = 9975,
  [10132] = 9975,
  [10133] = 9975,
  [10134] = 9975,
  [10135] = 9975,
  [10136] = 9218,
  [10137] = 9975,
  [10138] = 9975,
  [10139] = 9975,
  [10140] = 3481,
  [10141] = 9975,
  [10142] = 3632,
  [10143] = 9975,
  [10144] = 9975,
  [10145] = 9541,
  [10146] = 9975,
  [10147] = 9539,
  [10148] = 9975,
  [10149] = 9975,
  [10150] = 9975,
  [10151] = 9975,
  [10152] = 3600,
  [10153] = 9531,
  [10154] = 9975,
  [10155] = 9975,
  [10156] = 3468,
  [10157] = 9975,
  [10158] = 9529,
  [10159] = 9975,
  [10160] = 9975,
  [10161] = 9975,
  [10162] = 9975,
  [10163] = 9523,
  [10164] = 3471,
  [10165] = 9975,
  [10166] = 3470,
  [10167] = 3543,
  [10168] = 9975,
  [10169] = 9975,
  [10170] = 3468,
  [10171] = 3471,
  [10172] = 9975,
  [10173] = 9975,
  [10174] = 9263,
  [10175] = 9358,
  [10176] = 3468,
  [10177] = 9975,
  [10178] = 3908,
  [10179] = 3632,
  [10180] = 9975,
  [10181] = 9975,
  [10182] = 9975,
  [10183] = 3470,
  [10184] = 3576,
  [10185] = 3799,
  [10186] = 9975,
  [10187] = 3470,
  [10188] = 3489,
  [10189] = 9975,
  [10190] = 9975,
  [10191] = 9263,
  [10192] = 3471,
  [10193] = 9975,
  [10194] = 3549,
  [10195] = 9975,
  [10196] = 3801,
  [10197] = 9975,
  [10198] = 9975,
  [10199] = 9975,
  [10200] = 9268,
  [10201] = 9975,
  [10202] = 9975,
  [10203] = 9975,
  [10204] = 9975,
  [10205] = 3632,
  [10206] = 9975,
  [10207] = 9975,
  [10208] = 3470,
  [10209] = 9975,
  [10210] = 3705,
  [10211] = 3471,
  [10212] = 9975,
  [10213] = 9975,
  [10214] = 10214,
  [10215] = 9263,
  [10216] = 3692,
  [10217] = 9567,
  [10218] = 9975,
  [10219] = 9975,
  [10220] = 9975,
  [10221] = 3600,
  [10222] = 3481,
  [10223] = 3705,
  [10224] = 9975,
  [10225] = 3692,
  [10226] = 9975,
  [10227] = 9975,
  [10228] = 9975,
  [10229] = 3809,
  [10230] = 3470,
  [10231] = 3813,
  [10232] = 9975,
  [10233] = 3778,
  [10234] = 10117,
  [10235] = 9333,
  [10236] = 3737,
  [10237] = 3738,
  [10238] = 3739,
  [10239] = 3742,
  [10240] = 3743,
  [10241] = 3744,
  [10242] = 3747,
  [10243] = 3734,
  [10244] = 10244,
  [10245] = 9975,
  [10246] = 3748,
  [10247] = 3908,
  [10248] = 3762,
  [10249] = 3774,
  [10250] = 3785,
  [10251] = 9975,
  [10252] = 9975,
  [10253] = 9358,
  [10254] = 9277,
  [10255] = 3740,
  [10256] = 9975,
  [10257] = 3745,
  [10258] = 3746,
  [10259] = 9975,
  [10260] = 9975,
  [10261] = 3908,
  [10262] = 9975,
  [10263] = 9975,
  [10264] = 3824,
  [10265] = 3600,
  [10266] = 9975,
  [10267] = 3829,
  [10268] = 10244,
  [10269] = 10269,
  [10270] = 3468,
  [10271] = 3511,
  [10272] = 9975,
  [10273] = 9975,
  [10274] = 9263,
  [10275] = 3832,
  [10276] = 9975,
  [10277] = 9975,
  [10278] = 9975,
  [10279] = 9975,
  [10280] = 9333,
  [10281] = 9263,
  [10282] = 3600,
  [10283] = 9975,
  [10284] = 9975,
  [10285] = 10285,
  [10286] = 9975,
  [10287] = 9975,
  [10288] = 9975,
  [10289] = 10214,
  [10290] = 3468,
  [10291] = 9975,
  [10292] = 9975,
  [10293] = 9358,
  [10294] = 3471,
  [10295] = 9975,
  [10296] = 3468,
  [10297] = 9975,
  [10298] = 9975,
  [10299] = 9975,
  [10300] = 10285,
  [10301] = 10244,
  [10302] = 9263,
  [10303] = 3481,
  [10304] = 9975,
  [10305] = 9975,
  [10306] = 3470,
  [10307] = 9975,
  [10308] = 9975,
  [10309] = 3481,
  [10310] = 9975,
  [10311] = 9541,
  [10312] = 9539,
  [10313] = 9975,
  [10314] = 9449,
  [10315] = 9975,
  [10316] = 9268,
  [10317] = 9975,
  [10318] = 9531,
  [10319] = 3489,
  [10320] = 3549,
  [10321] = 3787,
  [10322] = 9526,
  [10323] = 9521,
  [10324] = 3600,
  [10325] = 3489,
  [10326] = 3760,
  [10327] = 3760,
  [10328] = 3576,
  [10329] = 3577,
  [10330] = 10117,
  [10331] = 3784,
  [10332] = 3481,
  [10333] = 3751,
  [10334] = 3514,
  [10335] = 9358,
  [10336] = 3760,
  [10337] = 9333,
  [10338] = 9358,
  [10339] = 3783,
  [10340] = 3751,
  [10341] = 3764,
  [10342] = 9550,
  [10343] = 3692,
  [10344] = 3776,
  [10345] = 10285,
  [10346] = 3771,
  [10347] = 3751,
  [10348] = 9533,
  [10349] = 3766,
  [10350] = 3562,
  [10351] = 9534,
  [10352] = 3782,
  [10353] = 3632,
  [10354] = 3773,
  [10355] = 3705,
  [10356] = 3775,
  [10357] = 3547,
  [10358] = 3779,
  [10359] = 3543,
  [10360] = 4079,
  [10361] = 3735,
  [10362] = 3549,
  [10363] = 3511,
  [10364] = 3677,
  [10365] = 9263,
  [10366] = 3468,
  [10367] = 10062,
  [10368] = 3668,
  [10369] = 9582,
  [10370] = 3471,
  [10371] = 4058,
  [10372] = 3547,
  [10373] = 3632,
  [10374] = 3597,
  [10375] = 3600,
  [10376] = 3576,
  [10377] = 3817,
  [10378] = 3597,
  [10379] = 3489,
  [10380] = 3608,
  [10381] = 3668,
  [10382] = 9333,
  [10383] = 3608,
  [10384] = 4095,
  [10385] = 3600,
  [10386] = 3591,
  [10387] = 3788,
  [10388] = 3606,
  [10389] = 3577,
  [10390] = 3482,
  [10391] = 9263,
  [10392] = 9569,
  [10393] = 3546,
  [10394] = 3549,
  [10395] = 9562,
  [10396] = 3705,
  [10397] = 9524,
  [10398] = 3591,
  [10399] = 3482,
  [10400] = 3606,
  [10401] = 3543,
  [10402] = 9268,
  [10403] = 3470,
  [10404] = 3546,
  [10405] = 3577,
  [10406] = 3632,
  [10407] = 3546,
  [10408] = 3668,
  [10409] = 3692,
  [10410] = 3591,
  [10411] = 3482,
  [10412] = 3606,
  [10413] = 3692,
  [10414] = 3608,
  [10415] = 3597,
  [10416] = 10416,
  [10417] = 3705,
  [10418] = 3511,
  [10419] = 3908,
  [10420] = 3547,
  [10421] = 3543,
  [10422] = 3764,
  [10423] = 3468,
  [10424] = 3668,
  [10425] = 3760,
  [10426] = 3632,
  [10427] = 3766,
  [10428] = 9263,
  [10429] = 9277,
  [10430] = 3771,
  [10431] = 3773,
  [10432] = 3775,
  [10433] = 3787,
  [10434] = 3543,
  [10435] = 3514,
  [10436] = 3468,
  [10437] = 3737,
  [10438] = 3734,
  [10439] = 3748,
  [10440] = 3776,
  [10441] = 3562,
  [10442] = 3785,
  [10443] = 3543,
  [10444] = 3740,
  [10445] = 3632,
  [10446] = 9358,
  [10447] = 3742,
  [10448] = 3547,
  [10449] = 3511,
  [10450] = 3677,
  [10451] = 3597,
  [10452] = 3608,
  [10453] = 3778,
  [10454] = 3738,
  [10455] = 3481,
  [10456] = 3751,
  [10457] = 3591,
  [10458] = 3788,
  [10459] = 3784,
  [10460] = 3783,
  [10461] = 3739,
  [10462] = 3782,
  [10463] = 3577,
  [10464] = 3737,
  [10465] = 3562,
  [10466] = 3779,
  [10467] = 3781,
  [10468] = 3743,
  [10469] = 3735,
  [10470] = 9358,
  [10471] = 3546,
  [10472] = 3744,
  [10473] = 3747,
  [10474] = 3781,
  [10475] = 3762,
  [10476] = 3772,
  [10477] = 3770,
  [10478] = 3768,
  [10479] = 3482,
  [10480] = 3767,
  [10481] = 3765,
  [10482] = 3763,
  [10483] = 3606,
  [10484] = 3774,
  [10485] = 3470,
  [10486] = 3770,
  [10487] = 3761,
  [10488] = 3768,
  [10489] = 3668,
  [10490] = 3745,
  [10491] = 3746,
  [10492] = 3758,
  [10493] = 3734,
  [10494] = 3576,
  [10495] = 3547,
  [10496] = 3757,
  [10497] = 3756,
  [10498] = 3748,
  [10499] = 4129,
  [10500] = 3576,
  [10501] = 3597,
  [10502] = 3489,
  [10503] = 3608,
  [10504] = 3767,
  [10505] = 3471,
  [10506] = 3765,
  [10507] = 9554,
  [10508] = 3549,
  [10509] = 3591,
  [10510] = 9268,
  [10511] = 3751,
  [10512] = 3577,
  [10513] = 3754,
  [10514] = 9553,
  [10515] = 3763,
  [10516] = 3546,
  [10517] = 9522,
  [10518] = 3511,
  [10519] = 3600,
  [10520] = 3600,
  [10521] = 3761,
  [10522] = 3482,
  [10523] = 3606,
  [10524] = 3758,
  [10525] = 3600,
  [10526] = 3489,
  [10527] = 3785,
  [10528] = 3543,
  [10529] = 3757,
  [10530] = 9567,
  [10531] = 3668,
  [10532] = 3756,
  [10533] = 3749,
  [10534] = 3740,
  [10535] = 3772,
  [10536] = 10078,
  [10537] = 3753,
  [10538] = 3511,
  [10539] = 3468,
  [10540] = 9358,
  [10541] = 3468,
  [10542] = 3817,
  [10543] = 4058,
  [10544] = 4079,
  [10545] = 3470,
  [10546] = 3668,
  [10547] = 3705,
  [10548] = 3908,
  [10549] = 3692,
  [10550] = 3692,
  [10551] = 3754,
  [10552] = 3549,
  [10553] = 10214,
  [10554] = 3750,
  [10555] = 3752,
  [10556] = 3677,
  [10557] = 3760,
  [10558] = 3753,
  [10559] = 4095,
  [10560] = 4129,
  [10561] = 3738,
  [10562] = 3705,
  [10563] = 3750,
  [10564] = 3489,
  [10565] = 9522,
  [10566] = 10566,
  [10567] = 3482,
  [10568] = 3562,
  [10569] = 3576,
  [10570] = 3471,
  [10571] = 3752,
  [10572] = 3606,
  [10573] = 3482,
  [10574] = 3606,
  [10575] = 3546,
  [10576] = 3576,
  [10577] = 3489,
  [10578] = 3481,
  [10579] = 3577,
  [10580] = 3591,
  [10581] = 3608,
  [10582] = 10062,
  [10583] = 3597,
  [10584] = 3752,
  [10585] = 3549,
  [10586] = 3562,
  [10587] = 3468,
  [10588] = 3471,
  [10589] = 3817,
  [10590] = 3547,
  [10591] = 4058,
  [10592] = 3908,
  [10593] = 3752,
  [10594] = 4079,
  [10595] = 3778,
  [10596] = 3757,
  [10597] = 3562,
  [10598] = 3750,
  [10599] = 3739,
  [10600] = 3742,
  [10601] = 3743,
  [10602] = 3744,
  [10603] = 3747,
  [10604] = 3677,
  [10605] = 9263,
  [10606] = 4095,
  [10607] = 4095,
  [10608] = 3546,
  [10609] = 3750,
  [10610] = 3576,
  [10611] = 3600,
  [10612] = 3608,
  [10613] = 9263,
  [10614] = 3470,
  [10615] = 3762,
  [10616] = 3774,
  [10617] = 3692,
  [10618] = 9567,
  [10619] = 3754,
  [10620] = 3705,
  [10621] = 3591,
  [10622] = 4079,
  [10623] = 4058,
  [10624] = 3668,
  [10625] = 9569,
  [10626] = 3817,
  [10627] = 3549,
  [10628] = 3705,
  [10629] = 3745,
  [10630] = 3746,
  [10631] = 9541,
  [10632] = 9539,
  [10633] = 3753,
  [10634] = 9562,
  [10635] = 3481,
  [10636] = 9531,
  [10637] = 3754,
  [10638] = 9529,
  [10639] = 3606,
  [10640] = 3677,
  [10641] = 3514,
  [10642] = 3482,
  [10643] = 4129,
  [10644] = 4129,
  [10645] = 3749,
  [10646] = 3756,
  [10647] = 9523,
  [10648] = 3758,
  [10649] = 3749,
  [10650] = 3761,
  [10651] = 3692,
  [10652] = 9358,
  [10653] = 3543,
  [10654] = 3756,
  [10655] = 3757,
  [10656] = 3763,
  [10657] = 3562,
  [10658] = 3546,
  [10659] = 3758,
  [10660] = 3577,
  [10661] = 3591,
  [10662] = 3765,
  [10663] = 4095,
  [10664] = 3632,
  [10665] = 3705,
  [10666] = 3908,
  [10667] = 9449,
  [10668] = 3514,
  [10669] = 3767,
  [10670] = 3514,
  [10671] = 3632,
  [10672] = 3562,
  [10673] = 3677,
  [10674] = 9277,
  [10675] = 4079,
  [10676] = 3761,
  [10677] = 3608,
  [10678] = 3768,
  [10679] = 3770,
  [10680] = 3597,
  [10681] = 4058,
  [10682] = 3817,
  [10683] = 3677,
  [10684] = 3511,
  [10685] = 3753,
  [10686] = 3547,
  [10687] = 3829,
  [10688] = 9263,
  [10689] = 3763,
  [10690] = 3481,
  [10691] = 3772,
  [10692] = 3765,
  [10693] = 3767,
  [10694] = 3768,
  [10695] = 3770,
  [10696] = 3772,
  [10697] = 3781,
  [10698] = 3781,
  [10699] = 3514,
  [10700] = 9541,
  [10701] = 9539,
  [10702] = 3677,
  [10703] = 3468,
  [10704] = 9554,
  [10705] = 3735,
  [10706] = 9531,
  [10707] = 9529,
  [10708] = 3779,
  [10709] = 9523,
  [10710] = 9358,
  [10711] = 3782,
  [10712] = 3470,
  [10713] = 3783,
  [10714] = 3779,
  [10715] = 3511,
  [10716] = 3784,
  [10717] = 3788,
  [10718] = 10718,
  [10719] = 3735,
  [10720] = 3782,
  [10721] = 3778,
  [10722] = 3776,
  [10723] = 3737,
  [10724] = 3632,
  [10725] = 9553,
  [10726] = 3738,
  [10727] = 3547,
  [10728] = 3787,
  [10729] = 3775,
  [10730] = 3773,
  [10731] = 3549,
  [10732] = 3692,
  [10733] = 3784,
  [10734] = 3739,
  [10735] = 3766,
  [10736] = 3788,
  [10737] = 3764,
  [10738] = 3742,
  [10739] = 3743,
  [10740] = 9521,
  [10741] = 9526,
  [10742] = 3744,
  [10743] = 3747,
  [10744] = 3734,
  [10745] = 3746,
  [10746] = 3740,
  [10747] = 3748,
  [10748] = 3577,
  [10749] = 3489,
  [10750] = 3832,
  [10751] = 3824,
  [10752] = 3813,
  [10753] = 3576,
  [10754] = 3809,
  [10755] = 3762,
  [10756] = 3471,
  [10757] = 3776,
  [10758] = 3801,
  [10759] = 3799,
  [10760] = 3774,
  [10761] = 3785,
  [10762] = 3785,
  [10763] = 3470,
  [10764] = 3774,
  [10765] = 3843,
  [10766] = 3853,
  [10767] = 3762,
  [10768] = 3825,
  [10769] = 3787,
  [10770] = 3778,
  [10771] = 3737,
  [10772] = 3738,
  [10773] = 3775,
  [10774] = 3514,
  [10775] = 9533,
  [10776] = 3773,
  [10777] = 9524,
  [10778] = 3771,
  [10779] = 3740,
  [10780] = 3745,
  [10781] = 3739,
  [10782] = 9534,
  [10783] = 3742,
  [10784] = 3743,
  [10785] = 3744,
  [10786] = 3748,
  [10787] = 3734,
  [10788] = 3747,
  [10789] = 3746,
  [10790] = 3734,
  [10791] = 3471,
  [10792] = 3748,
  [10793] = 3747,
  [10794] = 3766,
  [10795] = 3764,
  [10796] = 3511,
  [10797] = 3744,
  [10798] = 3743,
  [10799] = 3742,
  [10800] = 3739,
  [10801] = 9582,
  [10802] = 3738,
  [10803] = 3737,
  [10804] = 3778,
  [10805] = 3771,
  [10806] = 3471,
  [10807] = 3762,
  [10808] = 3774,
  [10809] = 3785,
  [10810] = 3481,
  [10811] = 3749,
  [10812] = 9277,
  [10813] = 3752,
  [10814] = 3750,
  [10815] = 3753,
  [10816] = 3754,
  [10817] = 3470,
  [10818] = 3600,
  [10819] = 3749,
  [10820] = 3756,
  [10821] = 3757,
  [10822] = 3740,
  [10823] = 3543,
  [10824] = 3745,
  [10825] = 3746,
  [10826] = 3597,
  [10827] = 3908,
  [10828] = 3908,
  [10829] = 3758,
  [10830] = 3761,
  [10831] = 3779,
  [10832] = 3763,
  [10833] = 3765,
  [10834] = 9263,
  [10835] = 3767,
  [10836] = 3768,
  [10837] = 3770,
  [10838] = 3514,
  [10839] = 3772,
  [10840] = 3764,
  [10841] = 3766,
  [10842] = 3745,
  [10843] = 3781,
  [10844] = 3735,
  [10845] = 3783,
  [10846] = 3771,
  [10847] = 3773,
  [10848] = 4129,
  [10849] = 3775,
  [10850] = 3787,
  [10851] = 3776,
  [10852] = 3782,
  [10853] = 9277,
  [10854] = 3788,
  [10855] = 3784,
  [10856] = 3783,
  [10857] = 9358,
  [10858] = 3809,
  [10859] = 3813,
  [10860] = 3824,
  [10861] = 3801,
  [10862] = 3470,
  [10863] = 3799,
  [10864] = 3481,
  [10865] = 3829,
  [10866] = 3832,
  [10867] = 3547,
  [10868] = 3549,
  [10869] = 3597,
  [10870] = 3471,
  [10871] = 3471,
  [10872] = 3543,
  [10873] = 9524,
  [10874] = 9526,
  [10875] = 9521,
  [10876] = 3608,
  [10877] = 3764,
  [10878] = 3766,
  [10879] = 3591,
  [10880] = 3751,
  [10881] = 3843,
  [10882] = 4129,
  [10883] = 9522,
  [10884] = 3577,
  [10885] = 3771,
  [10886] = 3773,
  [10887] = 10887,
  [10888] = 3775,
  [10889] = 3787,
  [10890] = 3489,
  [10891] = 3668,
  [10892] = 3776,
  [10893] = 3853,
  [10894] = 3576,
  [10895] = 3546,
  [10896] = 9523,
  [10897] = 3482,
  [10898] = 3562,
  [10899] = 3543,
  [10900] = 3825,
  [10901] = 3606,
  [10902] = 3606,
  [10903] = 3788,
  [10904] = 3482,
  [10905] = 3784,
  [10906] = 3677,
  [10907] = 3783,
  [10908] = 3749,
  [10909] = 9529,
  [10910] = 3782,
  [10911] = 3832,
  [10912] = 9531,
  [10913] = 3597,
  [10914] = 3760,
  [10915] = 3481,
  [10916] = 3668,
  [10917] = 3546,
  [10918] = 4129,
  [10919] = 3577,
  [10920] = 3779,
  [10921] = 9539,
  [10922] = 9541,
  [10923] = 3591,
  [10924] = 3829,
  [10925] = 3677,
  [10926] = 3608,
  [10927] = 3824,
  [10928] = 3576,
  [10929] = 3470,
  [10930] = 3597,
  [10931] = 3547,
  [10932] = 3489,
  [10933] = 3562,
  [10934] = 3562,
  [10935] = 9449,
  [10936] = 3746,
  [10937] = 3735,
  [10938] = 9533,
  [10939] = 9534,
  [10940] = 3745,
  [10941] = 3677,
  [10942] = 3817,
  [10943] = 3813,
  [10944] = 4079,
  [10945] = 9333,
  [10946] = 3809,
  [10947] = 3781,
  [10948] = 3778,
  [10949] = 3772,
  [10950] = 3770,
  [10951] = 3737,
  [10952] = 3768,
  [10953] = 3547,
  [10954] = 3767,
  [10955] = 3765,
  [10956] = 3763,
  [10957] = 3787,
  [10958] = 3832,
  [10959] = 3738,
  [10960] = 4129,
  [10961] = 3760,
  [10962] = 4095,
  [10963] = 3829,
  [10964] = 3824,
  [10965] = 3774,
  [10966] = 3468,
  [10967] = 3747,
  [10968] = 3608,
  [10969] = 3762,
  [10970] = 3511,
  [10971] = 9553,
  [10972] = 3752,
  [10973] = 3750,
  [10974] = 3751,
  [10975] = 3813,
  [10976] = 3753,
  [10977] = 3801,
  [10978] = 3761,
  [10979] = 3809,
  [10980] = 3747,
  [10981] = 3591,
  [10982] = 3549,
  [10983] = 3743,
  [10984] = 9554,
  [10985] = 3742,
  [10986] = 3577,
  [10987] = 3739,
  [10988] = 3799,
  [10989] = 3749,
  [10990] = 3738,
  [10991] = 3778,
  [10992] = 3801,
  [10993] = 3739,
  [10994] = 4058,
  [10995] = 10995,
  [10996] = 3742,
  [10997] = 3754,
  [10998] = 3758,
  [10999] = 3549,
  [11000] = 3546,
  [11001] = 9550,
  [11002] = 3743,
  [11003] = 3757,
  [11004] = 3756,
  [11005] = 3482,
  [11006] = 9529,
  [11007] = 3606,
  [11008] = 3799,
  [11009] = 3744,
  [11010] = 3747,
  [11011] = 3734,
  [11012] = 3748,
  [11013] = 10887,
  [11014] = 3749,
  [11015] = 3754,
  [11016] = 3756,
  [11017] = 3668,
  [11018] = 3757,
  [11019] = 3760,
  [11020] = 3543,
  [11021] = 3753,
  [11022] = 3514,
  [11023] = 3752,
  [11024] = 3746,
  [11025] = 3758,
  [11026] = 3489,
  [11027] = 3843,
  [11028] = 9562,
  [11029] = 9569,
  [11030] = 4095,
  [11031] = 3576,
  [11032] = 3761,
  [11033] = 3745,
  [11034] = 3750,
  [11035] = 3763,
  [11036] = 3750,
  [11037] = 3765,
  [11038] = 3817,
  [11039] = 4058,
  [11040] = 3767,
  [11041] = 3740,
  [11042] = 3753,
  [11043] = 3754,
  [11044] = 3770,
  [11045] = 4079,
  [11046] = 3772,
  [11047] = 4079,
  [11048] = 9582,
  [11049] = 3752,
  [11050] = 4058,
  [11051] = 3817,
  [11052] = 3843,
  [11053] = 3756,
  [11054] = 3757,
  [11055] = 3744,
  [11056] = 3785,
  [11057] = 3774,
  [11058] = 3853,
  [11059] = 9263,
  [11060] = 3781,
  [11061] = 3762,
  [11062] = 3758,
  [11063] = 3762,
  [11064] = 3761,
  [11065] = 3763,
  [11066] = 3735,
  [11067] = 3774,
  [11068] = 3779,
  [11069] = 3748,
  [11070] = 3785,
  [11071] = 3756,
  [11072] = 3782,
  [11073] = 3783,
  [11074] = 3481,
  [11075] = 3784,
  [11076] = 3765,
  [11077] = 3788,
  [11078] = 3734,
  [11079] = 10062,
  [11080] = 3767,
  [11081] = 3768,
  [11082] = 4129,
  [11083] = 3744,
  [11084] = 3776,
  [11085] = 11085,
  [11086] = 3770,
  [11087] = 3772,
  [11088] = 3775,
  [11089] = 3773,
  [11090] = 3771,
  [11091] = 9358,
  [11092] = 3781,
  [11093] = 3766,
  [11094] = 3764,
  [11095] = 3743,
  [11096] = 3740,
  [11097] = 3853,
  [11098] = 3742,
  [11099] = 3739,
  [11100] = 3738,
  [11101] = 3825,
  [11102] = 3735,
  [11103] = 3740,
  [11104] = 3737,
  [11105] = 3778,
  [11106] = 3745,
  [11107] = 3562,
  [11108] = 3543,
  [11109] = 3779,
  [11110] = 3785,
  [11111] = 3782,
  [11112] = 3783,
  [11113] = 3705,
  [11114] = 10995,
  [11115] = 3784,
  [11116] = 3788,
  [11117] = 3746,
  [11118] = 3547,
  [11119] = 3751,
  [11120] = 4095,
  [11121] = 3776,
  [11122] = 4095,
  [11123] = 3748,
  [11124] = 3734,
  [11125] = 3787,
  [11126] = 3775,
  [11127] = 3773,
  [11128] = 3751,
  [11129] = 3771,
  [11130] = 3825,
  [11131] = 9268,
  [11132] = 3668,
  [11133] = 3514,
  [11134] = 3597,
  [11135] = 3737,
  [11136] = 3608,
  [11137] = 3768,
  [11138] = 9449,
  [11139] = 3766,
  [11140] = 3677,
  [11141] = 3764,
  [11142] = 3591,
  [11143] = 3577,
  [11144] = 3546,
  [11145] = 3606,
  [11146] = 3632,
  [11147] = 3514,
  [11148] = 3668,
  [11149] = 4079,
  [11150] = 3817,
  [11151] = 3764,
  [11152] = 4058,
  [11153] = 3817,
  [11154] = 3760,
  [11155] = 3766,
  [11156] = 4058,
  [11157] = 3543,
  [11158] = 3771,
  [11159] = 3511,
  [11160] = 3514,
  [11161] = 9333,
  [11162] = 3773,
  [11163] = 3751,
  [11164] = 9358,
  [11165] = 3775,
  [11166] = 3787,
  [11167] = 3776,
  [11168] = 4079,
  [11169] = 3760,
  [11170] = 3547,
  [11171] = 3677,
  [11172] = 4129,
  [11173] = 3597,
  [11174] = 3608,
  [11175] = 11175,
  [11176] = 3591,
  [11177] = 3482,
  [11178] = 3749,
  [11179] = 3746,
  [11180] = 3745,
  [11181] = 3577,
  [11182] = 3740,
  [11183] = 3825,
  [11184] = 3788,
  [11185] = 3775,
  [11186] = 3546,
  [11187] = 3783,
  [11188] = 3482,
  [11189] = 3606,
  [11190] = 3668,
  [11191] = 3782,
  [11192] = 3825,
  [11193] = 11193,
  [11194] = 3746,
  [11195] = 9449,
  [11196] = 3745,
  [11197] = 3740,
  [11198] = 3779,
  [11199] = 4095,
  [11200] = 3735,
  [11201] = 3785,
  [11202] = 3514,
  [11203] = 3785,
  [11204] = 3774,
  [11205] = 3468,
  [11206] = 3549,
  [11207] = 3762,
  [11208] = 3748,
  [11209] = 3781,
  [11210] = 3764,
  [11211] = 3766,
  [11212] = 3772,
  [11213] = 3784,
  [11214] = 3768,
  [11215] = 3771,
  [11216] = 3773,
  [11217] = 3734,
  [11218] = 3767,
  [11219] = 3774,
  [11220] = 3762,
  [11221] = 3765,
  [11222] = 3787,
  [11223] = 3776,
  [11224] = 3746,
  [11225] = 3853,
  [11226] = 3745,
  [11227] = 3734,
  [11228] = 3763,
  [11229] = 3761,
  [11230] = 3747,
  [11231] = 3744,
  [11232] = 3743,
  [11233] = 10718,
  [11234] = 3606,
  [11235] = 3482,
  [11236] = 3489,
  [11237] = 3788,
  [11238] = 3784,
  [11239] = 3783,
  [11240] = 3758,
  [11241] = 10718,
  [11242] = 3782,
  [11243] = 3779,
  [11244] = 3576,
  [11245] = 3735,
  [11246] = 3757,
  [11247] = 3742,
  [11248] = 10995,
  [11249] = 3774,
  [11250] = 3739,
  [11251] = 3576,
  [11252] = 3738,
  [11253] = 3762,
  [11254] = 3843,
  [11255] = 3737,
  [11256] = 3778,
  [11257] = 3546,
  [11258] = 3749,
  [11259] = 3562,
  [11260] = 3577,
  [11261] = 3511,
  [11262] = 3677,
  [11263] = 3591,
  [11264] = 3781,
  [11265] = 3772,
  [11266] = 3770,
  [11267] = 3489,
  [11268] = 3768,
  [11269] = 3767,
  [11270] = 3765,
  [11271] = 3763,
  [11272] = 3853,
  [11273] = 3562,
  [11274] = 3751,
  [11275] = 3747,
  [11276] = 3761,
  [11277] = 3744,
  [11278] = 10995,
  [11279] = 3843,
  [11280] = 3743,
  [11281] = 3742,
  [11282] = 3549,
  [11283] = 3799,
  [11284] = 3739,
  [11285] = 3600,
  [11286] = 3738,
  [11287] = 3801,
  [11288] = 3481,
  [11289] = 3758,
  [11290] = 3757,
  [11291] = 3778,
  [11292] = 3756,
  [11293] = 3760,
  [11294] = 3511,
  [11295] = 3754,
  [11296] = 3753,
  [11297] = 3608,
  [11298] = 3600,
  [11299] = 3597,
  [11300] = 3813,
  [11301] = 3511,
  [11302] = 3748,
  [11303] = 3734,
  [11304] = 3747,
  [11305] = 3750,
  [11306] = 3752,
  [11307] = 3481,
  [11308] = 3770,
  [11309] = 9523,
  [11310] = 9268,
  [11311] = 3754,
  [11312] = 3744,
  [11313] = 3547,
  [11314] = 3753,
  [11315] = 3778,
  [11316] = 3737,
  [11317] = 3738,
  [11318] = 3600,
  [11319] = 3692,
  [11320] = 9358,
  [11321] = 3824,
  [11322] = 11193,
  [11323] = 3829,
  [11324] = 3764,
  [11325] = 3692,
  [11326] = 3766,
  [11327] = 3752,
  [11328] = 3576,
  [11329] = 3751,
  [11330] = 3739,
  [11331] = 9567,
  [11332] = 3489,
  [11333] = 3742,
  [11334] = 3743,
  [11335] = 3832,
  [11336] = 3744,
  [11337] = 3514,
  [11338] = 3750,
  [11339] = 3760,
  [11340] = 3747,
  [11341] = 9449,
  [11342] = 3705,
  [11343] = 3801,
  [11344] = 3771,
  [11345] = 3748,
  [11346] = 3750,
  [11347] = 3740,
  [11348] = 3758,
  [11349] = 3543,
  [11350] = 3514,
  [11351] = 3746,
  [11352] = 3549,
  [11353] = 3773,
  [11354] = 3785,
  [11355] = 3752,
  [11356] = 3764,
  [11357] = 3775,
  [11358] = 3787,
  [11359] = 3766,
  [11360] = 3743,
  [11361] = 3748,
  [11362] = 3734,
  [11363] = 3762,
  [11364] = 3771,
  [11365] = 3773,
  [11366] = 3774,
  [11367] = 3753,
  [11368] = 3785,
  [11369] = 3775,
  [11370] = 9449,
  [11371] = 3787,
  [11372] = 3776,
  [11373] = 3754,
  [11374] = 3737,
  [11375] = 3776,
  [11376] = 3547,
  [11377] = 3809,
  [11378] = 3788,
  [11379] = 3784,
  [11380] = 3783,
  [11381] = 3782,
  [11382] = 3749,
  [11383] = 3597,
  [11384] = 3756,
  [11385] = 3757,
  [11386] = 3608,
  [11387] = 3758,
  [11388] = 3742,
  [11389] = 3761,
  [11390] = 3779,
  [11391] = 3735,
  [11392] = 3591,
  [11393] = 3562,
  [11394] = 4129,
  [11395] = 3763,
  [11396] = 3745,
  [11397] = 3767,
  [11398] = 3577,
  [11399] = 3768,
  [11400] = 3765,
  [11401] = 3781,
  [11402] = 3739,
  [11403] = 3772,
  [11404] = 3774,
  [11405] = 3762,
  [11406] = 3747,
  [11407] = 10995,
  [11408] = 3772,
  [11409] = 3781,
  [11410] = 3770,
  [11411] = 3768,
  [11412] = 3482,
  [11413] = 3744,
  [11414] = 3735,
  [11415] = 3740,
  [11416] = 3606,
  [11417] = 3779,
  [11418] = 3767,
  [11419] = 3765,
  [11420] = 3668,
  [11421] = 3743,
  [11422] = 3788,
  [11423] = 3763,
  [11424] = 3761,
  [11425] = 3784,
  [11426] = 3783,
  [11427] = 3782,
  [11428] = 3779,
  [11429] = 3757,
  [11430] = 3756,
  [11431] = 3749,
  [11432] = 3742,
  [11433] = 3745,
  [11434] = 3782,
  [11435] = 3783,
  [11436] = 3784,
  [11437] = 3788,
  [11438] = 3735,
  [11439] = 3754,
  [11440] = 3746,
  [11441] = 3776,
  [11442] = 3787,
  [11443] = 3739,
  [11444] = 3775,
  [11445] = 3773,
  [11446] = 3771,
  [11447] = 3766,
  [11448] = 3764,
  [11449] = 3781,
  [11450] = 3772,
  [11451] = 3817,
  [11452] = 4058,
  [11453] = 4079,
  [11454] = 3738,
  [11455] = 3753,
  [11456] = 3778,
  [11457] = 3799,
  [11458] = 3770,
  [11459] = 3768,
  [11460] = 3767,
  [11461] = 3677,
  [11462] = 3765,
  [11463] = 3763,
  [11464] = 3750,
  [11465] = 3761,
  [11466] = 3632,
  [11467] = 3758,
  [11468] = 3757,
  [11469] = 4095,
  [11470] = 3752,
  [11471] = 3770,
  [11472] = 3546,
  [11473] = 11175,
  [11474] = 3756,
  [11475] = 3511,
  [11476] = 3549,
  [11477] = 3692,
  [11478] = 3760,
  [11479] = 3737,
  [11480] = 3632,
  [11481] = 3754,
  [11482] = 3753,
  [11483] = 3740,
  [11484] = 3813,
  [11485] = 3750,
  [11486] = 3489,
  [11487] = 3511,
  [11488] = 3752,
  [11489] = 3576,
  [11490] = 3705,
  [11491] = 3778,
  [11492] = 11085,
  [11493] = 3785,
  [11494] = 3824,
  [11495] = 3829,
  [11496] = 3748,
  [11497] = 3809,
  [11498] = 3734,
  [11499] = 3737,
  [11500] = 3832,
  [11501] = 3751,
  [11502] = 3749,
  [11503] = 3543,
  [11504] = 3738,
  [11505] = 9554,
  [11506] = 3778,
  [11507] = 3742,
  [11508] = 10062,
  [11509] = 11509,
  [11510] = 3739,
  [11511] = 9531,
  [11512] = 3762,
  [11513] = 3843,
  [11514] = 3738,
  [11515] = 9529,
  [11516] = 3781,
  [11517] = 3772,
  [11518] = 11509,
  [11519] = 11519,
  [11520] = 3489,
  [11521] = 3770,
  [11522] = 3768,
  [11523] = 3576,
  [11524] = 3767,
  [11525] = 3765,
  [11526] = 3763,
  [11527] = 3774,
  [11528] = 3778,
  [11529] = 9449,
  [11530] = 11509,
  [11531] = 3747,
  [11532] = 3562,
  [11533] = 9539,
  [11534] = 3750,
  [11535] = 9541,
  [11536] = 3760,
  [11537] = 3549,
  [11538] = 3744,
  [11539] = 11509,
  [11540] = 11509,
  [11541] = 3482,
  [11542] = 3606,
  [11543] = 3743,
  [11544] = 3761,
  [11545] = 3577,
  [11546] = 3766,
  [11547] = 3745,
  [11548] = 3799,
  [11549] = 9268,
  [11550] = 3746,
  [11551] = 3600,
  [11552] = 3591,
  [11553] = 11509,
  [11554] = 11509,
  [11555] = 3801,
  [11556] = 9523,
  [11557] = 3608,
  [11558] = 9567,
  [11559] = 3758,
  [11560] = 9449,
  [11561] = 3745,
  [11562] = 3853,
  [11563] = 3597,
  [11564] = 3757,
  [11565] = 3668,
  [11566] = 3758,
  [11567] = 3677,
  [11568] = 3738,
  [11569] = 3740,
  [11570] = 3825,
  [11571] = 3547,
  [11572] = 3756,
  [11573] = 3853,
  [11574] = 9531,
  [11575] = 3668,
  [11576] = 3754,
  [11577] = 3749,
  [11578] = 9529,
  [11579] = 3853,
  [11580] = 9333,
  [11581] = 3763,
  [11582] = 3785,
  [11583] = 3778,
  [11584] = 3765,
  [11585] = 3739,
  [11586] = 3606,
  [11587] = 3748,
  [11588] = 9550,
  [11589] = 3753,
  [11590] = 3734,
  [11591] = 11509,
  [11592] = 3757,
  [11593] = 3843,
  [11594] = 11509,
  [11595] = 3482,
  [11596] = 3767,
  [11597] = 3756,
  [11598] = 9358,
  [11599] = 7601,
  [11600] = 3809,
  [11601] = 3546,
  [11602] = 3843,
  [11603] = 9567,
  [11604] = 3737,
  [11605] = 3742,
  [11606] = 3825,
  [11607] = 3735,
  [11608] = 11509,
  [11609] = 3825,
  [11610] = 3813,
  [11611] = 3799,
  [11612] = 3801,
  [11613] = 3764,
  [11614] = 9218,
  [11615] = 3809,
  [11616] = 3577,
  [11617] = 3824,
  [11618] = 3591,
  [11619] = 3543,
  [11620] = 3471,
  [11621] = 3750,
  [11622] = 9523,
  [11623] = 3752,
  [11624] = 9523,
  [11625] = 3824,
  [11626] = 11509,
  [11627] = 3825,
  [11628] = 3829,
  [11629] = 3832,
  [11630] = 3481,
  [11631] = 11509,
  [11632] = 3779,
  [11633] = 3749,
  [11634] = 3743,
  [11635] = 3829,
  [11636] = 9449,
  [11637] = 3770,
  [11638] = 9567,
  [11639] = 9524,
  [11640] = 11509,
  [11641] = 3608,
  [11642] = 9526,
  [11643] = 3761,
  [11644] = 3832,
  [11645] = 3752,
  [11646] = 9522,
  [11647] = 11509,
  [11648] = 3597,
  [11649] = 11509,
  [11650] = 3752,
  [11651] = 3750,
  [11652] = 9567,
  [11653] = 3799,
  [11654] = 3801,
  [11655] = 3813,
  [11656] = 9533,
  [11657] = 9534,
  [11658] = 3744,
  [11659] = 9524,
  [11660] = 9526,
  [11661] = 9521,
  [11662] = 3832,
  [11663] = 11509,
  [11664] = 3782,
  [11665] = 3547,
  [11666] = 3481,
  [11667] = 3829,
  [11668] = 9522,
  [11669] = 9529,
  [11670] = 3824,
  [11671] = 3783,
  [11672] = 3784,
  [11673] = 9550,
  [11674] = 3788,
  [11675] = 9531,
  [11676] = 3809,
  [11677] = 3753,
  [11678] = 3813,
  [11679] = 3809,
  [11680] = 11509,
  [11681] = 3813,
  [11682] = 11509,
  [11683] = 9449,
  [11684] = 11509,
  [11685] = 9553,
  [11686] = 3751,
  [11687] = 9539,
  [11688] = 9541,
  [11689] = 3853,
  [11690] = 9521,
  [11691] = 3829,
  [11692] = 3468,
  [11693] = 11509,
  [11694] = 9523,
  [11695] = 3843,
  [11696] = 3771,
  [11697] = 9449,
  [11698] = 3832,
  [11699] = 9539,
  [11700] = 3705,
  [11701] = 3773,
  [11702] = 9541,
  [11703] = 3751,
  [11704] = 3562,
  [11705] = 3801,
  [11706] = 11509,
  [11707] = 3514,
  [11708] = 9533,
  [11709] = 9534,
  [11710] = 3768,
  [11711] = 3799,
  [11712] = 11509,
  [11713] = 3677,
  [11714] = 3775,
  [11715] = 3787,
  [11716] = 3770,
  [11717] = 9562,
  [11718] = 9569,
  [11719] = 3692,
  [11720] = 9524,
  [11721] = 9526,
  [11722] = 3754,
  [11723] = 9521,
  [11724] = 9522,
  [11725] = 9541,
  [11726] = 3754,
  [11727] = 3776,
  [11728] = 9529,
  [11729] = 3772,
  [11730] = 3787,
  [11731] = 3775,
  [11732] = 9531,
  [11733] = 3776,
  [11734] = 3773,
  [11735] = 9533,
  [11736] = 3771,
  [11737] = 3799,
  [11738] = 3749,
  [11739] = 9534,
  [11740] = 3760,
  [11741] = 3824,
  [11742] = 3781,
  [11743] = 11509,
  [11744] = 3468,
  [11745] = 11509,
  [11746] = 3756,
  [11747] = 3801,
  [11748] = 3757,
  [11749] = 3751,
  [11750] = 9553,
  [11751] = 3470,
  [11752] = 10062,
  [11753] = 3843,
  [11754] = 3762,
  [11755] = 9554,
  [11756] = 11509,
  [11757] = 9553,
  [11758] = 3774,
  [11759] = 9554,
  [11760] = 9582,
  [11761] = 10062,
  [11762] = 11762,
  [11763] = 3832,
  [11764] = 3758,
  [11765] = 9524,
  [11766] = 3747,
  [11767] = 3829,
  [11768] = 11519,
  [11769] = 3766,
  [11770] = 11509,
  [11771] = 11771,
  [11772] = 3511,
  [11773] = 9529,
  [11774] = 3824,
  [11775] = 3853,
  [11776] = 9524,
  [11777] = 9526,
  [11778] = 3761,
  [11779] = 9521,
  [11780] = 11509,
  [11781] = 9526,
  [11782] = 9522,
  [11783] = 9521,
  [11784] = 3763,
  [11785] = 3764,
  [11786] = 3760,
  [11787] = 3765,
  [11788] = 11085,
  [11789] = 10718,
  [11790] = 11509,
  [11791] = 9522,
  [11792] = 9533,
  [11793] = 9539,
  [11794] = 3767,
  [11795] = 11509,
  [11796] = 3768,
  [11797] = 9534,
  [11798] = 11509,
  [11799] = 3737,
  [11800] = 3809,
  [11801] = 11509,
  [11802] = 3813,
  [11803] = 3813,
  [11804] = 3809,
  [11805] = 9553,
  [11806] = 9554,
  [11807] = 11509,
  [11808] = 9562,
  [11809] = 3781,
  [11810] = 9569,
  [11811] = 9218,
  [11812] = 3751,
  [11813] = 9562,
  [11814] = 3760,
  [11815] = 9569,
  [11816] = 11509,
  [11817] = 3514,
  [11818] = 9567,
  [11819] = 9533,
  [11820] = 11509,
  [11821] = 11519,
  [11822] = 9582,
  [11823] = 11771,
  [11824] = 9550,
  [11825] = 9534,
  [11826] = 3801,
  [11827] = 3799,
  [11828] = 9562,
  [11829] = 9569,
  [11830] = 3735,
  [11831] = 11509,
  [11832] = 3824,
  [11833] = 3829,
  [11834] = 11509,
  [11835] = 3832,
  [11836] = 3734,
  [11837] = 3748,
  [11838] = 10062,
  [11839] = 11509,
  [11840] = 3829,
  [11841] = 11509,
  [11842] = 3824,
  [11843] = 9582,
  [11844] = 11771,
  [11845] = 3740,
  [11846] = 3832,
  [11847] = 3832,
  [11848] = 3600,
  [11849] = 3829,
  [11850] = 9449,
  [11851] = 11509,
  [11852] = 3813,
  [11853] = 3735,
  [11854] = 3809,
  [11855] = 11193,
  [11856] = 3843,
  [11857] = 3779,
  [11858] = 3632,
  [11859] = 3825,
  [11860] = 9449,
  [11861] = 3549,
  [11862] = 3824,
  [11863] = 3782,
  [11864] = 3801,
  [11865] = 11175,
  [11866] = 3813,
  [11867] = 3779,
  [11868] = 3809,
  [11869] = 3799,
  [11870] = 9541,
  [11871] = 3782,
  [11872] = 11771,
  [11873] = 9539,
  [11874] = 3843,
  [11875] = 3576,
  [11876] = 9531,
  [11877] = 3746,
  [11878] = 3799,
  [11879] = 3745,
  [11880] = 11509,
  [11881] = 9569,
  [11882] = 3740,
  [11883] = 9562,
  [11884] = 3783,
  [11885] = 3788,
  [11886] = 11509,
  [11887] = 3489,
  [11888] = 10887,
  [11889] = 3853,
  [11890] = 9449,
  [11891] = 3801,
  [11892] = 3772,
  [11893] = 3543,
  [11894] = 9550,
  [11895] = 3783,
  [11896] = 3784,
  [11897] = 3753,
  [11898] = 3853,
  [11899] = 3843,
  [11900] = 9218,
  [11901] = 11509,
  [11902] = 11771,
  [11903] = 9582,
  [11904] = 3746,
  [11905] = 9523,
  [11906] = 3825,
  [11907] = 3853,
  [11908] = 3825,
  [11909] = 3788,
  [11910] = 3785,
  [11911] = 9582,
  [11912] = 11509,
  [11913] = 3546,
  [11914] = 3737,
  [11915] = 3774,
  [11916] = 3762,
  [11917] = 3511,
  [11918] = 3738,
  [11919] = 3764,
  [11920] = 11509,
  [11921] = 3766,
  [11922] = 9553,
  [11923] = 9554,
  [11924] = 3784,
  [11925] = 3739,
  [11926] = 3742,
  [11927] = 10062,
  [11928] = 3785,
  [11929] = 3743,
  [11930] = 3744,
  [11931] = 3747,
  [11932] = 11509,
  [11933] = 3734,
  [11934] = 3771,
  [11935] = 11771,
  [11936] = 11509,
  [11937] = 3825,
  [11938] = 3776,
  [11939] = 3748,
  [11940] = 3773,
  [11941] = 3775,
  [11942] = 3787,
  [11943] = 3734,
  [11944] = 9539,
  [11945] = 9268,
  [11946] = 9554,
  [11947] = 9522,
  [11948] = 9531,
  [11949] = 9550,
  [11950] = 11950,
  [11951] = 3773,
  [11952] = 3775,
  [11953] = 3813,
  [11954] = 3809,
  [11955] = 3825,
  [11956] = 3787,
  [11957] = 11957,
  [11958] = 3776,
  [11959] = 11957,
  [11960] = 9541,
  [11961] = 9523,
  [11962] = 3824,
  [11963] = 9541,
  [11964] = 9531,
  [11965] = 9567,
  [11966] = 9569,
  [11967] = 9562,
  [11968] = 11957,
  [11969] = 3832,
  [11970] = 3766,
  [11971] = 3829,
  [11972] = 9539,
  [11973] = 3764,
  [11974] = 3788,
  [11975] = 11957,
  [11976] = 9539,
  [11977] = 3784,
  [11978] = 3783,
  [11979] = 3843,
  [11980] = 9554,
  [11981] = 9553,
  [11982] = 9553,
  [11983] = 9541,
  [11984] = 9523,
  [11985] = 9521,
  [11986] = 9539,
  [11987] = 9553,
  [11988] = 9541,
  [11989] = 3779,
  [11990] = 9526,
  [11991] = 9539,
  [11992] = 3843,
  [11993] = 3832,
  [11994] = 3735,
  [11995] = 9218,
  [11996] = 9541,
  [11997] = 9533,
  [11998] = 9539,
  [11999] = 9534,
  [12000] = 9524,
  [12001] = 9531,
  [12002] = 9562,
  [12003] = 9569,
  [12004] = 9531,
  [12005] = 9562,
  [12006] = 9569,
  [12007] = 9529,
  [12008] = 9550,
  [12009] = 11957,
  [12010] = 11957,
  [12011] = 9567,
  [12012] = 3751,
  [12013] = 11957,
  [12014] = 9524,
  [12015] = 7601,
  [12016] = 9526,
  [12017] = 9534,
  [12018] = 9554,
  [12019] = 11957,
  [12020] = 9523,
  [12021] = 11175,
  [12022] = 12022,
  [12023] = 9529,
  [12024] = 7726,
  [12025] = 7820,
  [12026] = 9533,
  [12027] = 9449,
  [12028] = 9569,
  [12029] = 3781,
  [12030] = 3772,
  [12031] = 3770,
  [12032] = 3768,
  [12033] = 3767,
  [12034] = 9541,
  [12035] = 3765,
  [12036] = 9529,
  [12037] = 9554,
  [12038] = 9582,
  [12039] = 3763,
  [12040] = 12040,
  [12041] = 9553,
  [12042] = 9522,
  [12043] = 9521,
  [12044] = 9553,
  [12045] = 3761,
  [12046] = 9526,
  [12047] = 9554,
  [12048] = 9524,
  [12049] = 3758,
  [12050] = 3757,
  [12051] = 3756,
  [12052] = 9533,
  [12053] = 9582,
  [12054] = 11957,
  [12055] = 3853,
  [12056] = 9218,
  [12057] = 9531,
  [12058] = 9529,
  [12059] = 9554,
  [12060] = 3471,
  [12061] = 9523,
  [12062] = 9562,
  [12063] = 3754,
  [12064] = 9553,
  [12065] = 9449,
  [12066] = 9521,
  [12067] = 3753,
  [12068] = 9449,
  [12069] = 9523,
  [12070] = 9534,
  [12071] = 9569,
  [12072] = 9533,
  [12073] = 3829,
  [12074] = 9562,
  [12075] = 9569,
  [12076] = 11957,
  [12077] = 9534,
  [12078] = 9582,
  [12079] = 10887,
  [12080] = 9533,
  [12081] = 11957,
  [12082] = 3801,
  [12083] = 11957,
  [12084] = 10062,
  [12085] = 3782,
  [12086] = 9562,
  [12087] = 11957,
  [12088] = 9522,
  [12089] = 12089,
  [12090] = 3801,
  [12091] = 10062,
  [12092] = 9582,
  [12093] = 3799,
  [12094] = 9521,
  [12095] = 9526,
  [12096] = 3748,
  [12097] = 9524,
  [12098] = 9534,
  [12099] = 3750,
  [12100] = 9533,
  [12101] = 3801,
  [12102] = 3825,
  [12103] = 11950,
  [12104] = 3853,
  [12105] = 3809,
  [12106] = 9522,
  [12107] = 11957,
  [12108] = 9567,
  [12109] = 9582,
  [12110] = 3752,
  [12111] = 12111,
  [12112] = 9582,
  [12113] = 9522,
  [12114] = 3468,
  [12115] = 11957,
  [12116] = 3481,
  [12117] = 3749,
  [12118] = 9567,
  [12119] = 9218,
  [12120] = 9529,
  [12121] = 11957,
  [12122] = 9524,
  [12123] = 9521,
  [12124] = 9541,
  [12125] = 9526,
  [12126] = 9539,
  [12127] = 11957,
  [12128] = 11957,
  [12129] = 12129,
  [12130] = 9526,
  [12131] = 9521,
  [12132] = 9524,
  [12133] = 11957,
  [12134] = 12134,
  [12135] = 12135,
  [12136] = 9522,
  [12137] = 9582,
  [12138] = 9531,
  [12139] = 3799,
  [12140] = 9529,
  [12141] = 9524,
  [12142] = 9523,
  [12143] = 3677,
  [12144] = 3825,
  [12145] = 9522,
  [12146] = 3824,
  [12147] = 9529,
  [12148] = 9569,
  [12149] = 9521,
  [12150] = 9526,
  [12151] = 9562,
  [12152] = 11957,
  [12153] = 9533,
  [12154] = 9531,
  [12155] = 3760,
  [12156] = 9534,
  [12157] = 12157,
  [12158] = 7601,
  [12159] = 9526,
  [12160] = 9521,
  [12161] = 9567,
  [12162] = 9524,
  [12163] = 3799,
  [12164] = 9541,
  [12165] = 9553,
  [12166] = 11085,
  [12167] = 11193,
  [12168] = 9218,
  [12169] = 3778,
  [12170] = 9533,
  [12171] = 9550,
  [12172] = 9534,
  [12173] = 3737,
  [12174] = 11957,
  [12175] = 3562,
  [12176] = 9582,
  [12177] = 11957,
  [12178] = 9539,
  [12179] = 3762,
  [12180] = 9567,
  [12181] = 12134,
  [12182] = 3746,
  [12183] = 9218,
  [12184] = 11957,
  [12185] = 3745,
  [12186] = 12040,
  [12187] = 3738,
  [12188] = 3832,
  [12189] = 11957,
  [12190] = 3739,
  [12191] = 12040,
  [12192] = 9567,
  [12193] = 12089,
  [12194] = 3740,
  [12195] = 12135,
  [12196] = 9554,
  [12197] = 10062,
  [12198] = 9531,
  [12199] = 12022,
  [12200] = 9529,
  [12201] = 3843,
  [12202] = 9523,
  [12203] = 9218,
  [12204] = 3829,
  [12205] = 9569,
  [12206] = 3742,
  [12207] = 3743,
  [12208] = 9554,
  [12209] = 11957,
  [12210] = 9567,
  [12211] = 9553,
  [12212] = 11957,
  [12213] = 3809,
  [12214] = 3785,
  [12215] = 3744,
  [12216] = 3470,
  [12217] = 9523,
  [12218] = 9562,
  [12219] = 3813,
  [12220] = 3747,
  [12221] = 9534,
  [12222] = 3774,
  [12223] = 3771,
  [12224] = 9550,
  [12225] = 3853,
  [12226] = 11957,
  [12227] = 3813,
  [12228] = 9333,
  [12229] = 3824,
  [12230] = 11957,
  [12231] = 9522,
  [12232] = 12232,
  [12233] = 9562,
  [12234] = 12234,
  [12235] = 12234,
  [12236] = 7726,
  [12237] = 3546,
  [12238] = 9582,
  [12239] = 12232,
  [12240] = 9333,
  [12241] = 9522,
  [12242] = 12232,
  [12243] = 9218,
  [12244] = 12232,
  [12245] = 9539,
  [12246] = 9541,
  [12247] = 3751,
  [12248] = 12248,
  [12249] = 3481,
  [12250] = 3562,
  [12251] = 11175,
  [12252] = 12234,
  [12253] = 7892,
  [12254] = 12254,
  [12255] = 7890,
  [12256] = 7900,
  [12257] = 12232,
  [12258] = 9554,
  [12259] = 9523,
  [12260] = 12232,
  [12261] = 3591,
  [12262] = 12232,
  [12263] = 12263,
  [12264] = 7932,
  [12265] = 12265,
  [12266] = 12089,
  [12267] = 11085,
  [12268] = 3514,
  [12269] = 3482,
  [12270] = 9333,
  [12271] = 9449,
  [12272] = 12232,
  [12273] = 12234,
  [12274] = 12232,
  [12275] = 12234,
  [12276] = 12276,
  [12277] = 12234,
  [12278] = 12278,
  [12279] = 9531,
  [12280] = 12232,
  [12281] = 3606,
  [12282] = 12234,
  [12283] = 7894,
  [12284] = 12284,
  [12285] = 3608,
  [12286] = 7901,
  [12287] = 12234,
  [12288] = 9553,
  [12289] = 7897,
  [12290] = 3677,
  [12291] = 12232,
  [12292] = 9529,
  [12293] = 9218,
  [12294] = 3597,
  [12295] = 12234,
  [12296] = 9524,
  [12297] = 9526,
  [12298] = 9521,
  [12299] = 7902,
  [12300] = 9553,
  [12301] = 9333,
  [12302] = 10062,
  [12303] = 3751,
  [12304] = 12232,
  [12305] = 12234,
  [12306] = 10887,
  [12307] = 9521,
  [12308] = 12234,
  [12309] = 9554,
  [12310] = 12232,
  [12311] = 12234,
  [12312] = 9333,
  [12313] = 9534,
  [12314] = 3468,
  [12315] = 7899,
  [12316] = 12232,
  [12317] = 9268,
  [12318] = 3751,
  [12319] = 9526,
  [12320] = 12234,
  [12321] = 9567,
  [12322] = 3547,
  [12323] = 9533,
  [12324] = 12234,
  [12325] = 12325,
  [12326] = 9533,
  [12327] = 9534,
  [12328] = 12234,
  [12329] = 9567,
  [12330] = 9541,
  [12331] = 12234,
  [12332] = 9539,
  [12333] = 3760,
  [12334] = 12232,
  [12335] = 12234,
  [12336] = 12232,
  [12337] = 3760,
  [12338] = 3668,
  [12339] = 9333,
  [12340] = 9268,
  [12341] = 9218,
  [12342] = 12234,
  [12343] = 12343,
  [12344] = 7913,
  [12345] = 10718,
  [12346] = 7912,
  [12347] = 12234,
  [12348] = 12234,
  [12349] = 9553,
  [12350] = 9554,
  [12351] = 9531,
  [12352] = 9529,
  [12353] = 9218,
  [12354] = 12234,
  [12355] = 12355,
  [12356] = 12232,
  [12357] = 12232,
  [12358] = 3471,
  [12359] = 12232,
  [12360] = 12234,
  [12361] = 12232,
  [12362] = 12362,
  [12363] = 12234,
  [12364] = 9268,
  [12365] = 7820,
  [12366] = 12232,
  [12367] = 12134,
  [12368] = 12232,
  [12369] = 11193,
  [12370] = 12248,
  [12371] = 9218,
  [12372] = 3468,
  [12373] = 12234,
  [12374] = 12232,
  [12375] = 12234,
  [12376] = 12234,
  [12377] = 12254,
  [12378] = 11085,
  [12379] = 12276,
  [12380] = 7877,
  [12381] = 12381,
  [12382] = 12232,
  [12383] = 12232,
  [12384] = 12232,
  [12385] = 9522,
  [12386] = 7904,
  [12387] = 9218,
  [12388] = 3576,
  [12389] = 12234,
  [12390] = 7918,
  [12391] = 7934,
  [12392] = 12232,
  [12393] = 3489,
  [12394] = 12234,
  [12395] = 9524,
  [12396] = 9521,
  [12397] = 3825,
  [12398] = 3577,
  [12399] = 9523,
  [12400] = 9569,
  [12401] = 12232,
  [12402] = 12232,
  [12403] = 12232,
  [12404] = 12232,
  [12405] = 12248,
  [12406] = 12234,
  [12407] = 9526,
  [12408] = 12232,
  [12409] = 12234,
  [12410] = 9524,
  [12411] = 3543,
  [12412] = 9562,
  [12413] = 12284,
  [12414] = 9567,
  [12415] = 12232,
  [12416] = 9562,
  [12417] = 12234,
  [12418] = 12234,
  [12419] = 12232,
  [12420] = 12232,
  [12421] = 12362,
  [12422] = 9268,
  [12423] = 12232,
  [12424] = 9569,
  [12425] = 9218,
  [12426] = 9582,
  [12427] = 9569,
  [12428] = 3468,
  [12429] = 9541,
  [12430] = 12232,
  [12431] = 3549,
  [12432] = 12432,
  [12433] = 3853,
  [12434] = 9539,
  [12435] = 9567,
  [12436] = 3843,
  [12437] = 12232,
  [12438] = 12381,
  [12439] = 12234,
  [12440] = 10887,
  [12441] = 12232,
  [12442] = 12234,
  [12443] = 10718,
  [12444] = 9531,
  [12445] = 9529,
  [12446] = 9333,
  [12447] = 12232,
  [12448] = 12232,
  [12449] = 9533,
  [12450] = 12022,
  [12451] = 11193,
  [12452] = 9268,
  [12453] = 12254,
  [12454] = 7726,
  [12455] = 9523,
  [12456] = 12276,
  [12457] = 12234,
  [12458] = 12232,
  [12459] = 11950,
  [12460] = 7820,
  [12461] = 12135,
  [12462] = 12234,
  [12463] = 12234,
  [12464] = 12234,
  [12465] = 12381,
  [12466] = 3468,
  [12467] = 3799,
  [12468] = 12232,
  [12469] = 3801,
  [12470] = 3511,
  [12471] = 3832,
  [12472] = 7875,
  [12473] = 12234,
  [12474] = 12362,
  [12475] = 12234,
  [12476] = 12234,
  [12477] = 9534,
  [12478] = 7881,
  [12479] = 3760,
  [12480] = 12234,
  [12481] = 12232,
  [12482] = 12263,
  [12483] = 3470,
  [12484] = 3809,
  [12485] = 3813,
  [12486] = 7903,
  [12487] = 7601,
  [12488] = 12234,
  [12489] = 9582,
  [12490] = 12234,
  [12491] = 12263,
  [12492] = 12232,
  [12493] = 9522,
  [12494] = 3829,
  [12495] = 12234,
  [12496] = 12232,
  [12497] = 3824,
  [12498] = 11175,
  [12499] = 12234,
  [12500] = 12500,
  [12501] = 12500,
  [12502] = 9533,
  [12503] = 12500,
  [12504] = 12504,
  [12505] = 12500,
  [12506] = 12506,
  [12507] = 12507,
  [12508] = 12507,
  [12509] = 12509,
  [12510] = 7820,
  [12511] = 12278,
  [12512] = 12500,
  [12513] = 3468,
  [12514] = 12514,
  [12515] = 9534,
  [12516] = 7726,
  [12517] = 3591,
  [12518] = 7894,
  [12519] = 12519,
  [12520] = 7897,
  [12521] = 7900,
  [12522] = 3470,
  [12523] = 12500,
  [12524] = 9333,
  [12525] = 12500,
  [12526] = 9268,
  [12527] = 12527,
  [12528] = 12500,
  [12529] = 3468,
  [12530] = 12504,
  [12531] = 3471,
  [12532] = 12532,
  [12533] = 7877,
  [12534] = 12500,
  [12535] = 12500,
  [12536] = 7875,
  [12537] = 12500,
  [12538] = 12500,
  [12539] = 3468,
  [12540] = 3471,
  [12541] = 3481,
  [12542] = 3468,
  [12543] = 9333,
  [12544] = 7601,
  [12545] = 12500,
  [12546] = 12506,
  [12547] = 9333,
  [12548] = 9333,
  [12549] = 12500,
  [12550] = 12500,
  [12551] = 12551,
  [12552] = 12500,
  [12553] = 12506,
  [12554] = 7877,
  [12555] = 12555,
  [12556] = 12500,
  [12557] = 12500,
  [12558] = 12500,
  [12559] = 7912,
  [12560] = 7875,
  [12561] = 7903,
  [12562] = 3470,
  [12563] = 12500,
  [12564] = 12506,
  [12565] = 12506,
  [12566] = 12566,
  [12567] = 12500,
  [12568] = 7899,
  [12569] = 12500,
  [12570] = 3470,
  [12571] = 12500,
  [12572] = 3514,
  [12573] = 7912,
  [12574] = 7881,
  [12575] = 12509,
  [12576] = 3471,
  [12577] = 12514,
  [12578] = 9522,
  [12579] = 12500,
  [12580] = 3470,
  [12581] = 12500,
  [12582] = 12500,
  [12583] = 12551,
  [12584] = 12500,
  [12585] = 12566,
  [12586] = 12500,
  [12587] = 3471,
  [12588] = 12506,
  [12589] = 12500,
  [12590] = 12506,
  [12591] = 12500,
  [12592] = 12278,
  [12593] = 7892,
  [12594] = 7601,
  [12595] = 3597,
  [12596] = 12596,
  [12597] = 12500,
  [12598] = 12500,
  [12599] = 9521,
  [12600] = 9333,
  [12601] = 9526,
  [12602] = 7918,
  [12603] = 9524,
  [12604] = 12500,
  [12605] = 12509,
  [12606] = 7890,
  [12607] = 3608,
  [12608] = 7913,
  [12609] = 3576,
  [12610] = 3751,
  [12611] = 3489,
  [12612] = 12514,
  [12613] = 9553,
  [12614] = 9554,
  [12615] = 7902,
  [12616] = 7894,
  [12617] = 12506,
  [12618] = 12500,
  [12619] = 12619,
  [12620] = 9218,
  [12621] = 9333,
  [12622] = 12506,
  [12623] = 7897,
  [12624] = 7932,
  [12625] = 12500,
  [12626] = 3577,
  [12627] = 7901,
  [12628] = 12500,
  [12629] = 12596,
  [12630] = 3546,
  [12631] = 12500,
  [12632] = 9268,
  [12633] = 12555,
  [12634] = 12634,
  [12635] = 12500,
  [12636] = 7900,
  [12637] = 12566,
  [12638] = 9268,
  [12639] = 12506,
  [12640] = 12500,
  [12641] = 12500,
  [12642] = 7901,
  [12643] = 3549,
  [12644] = 7918,
  [12645] = 9268,
  [12646] = 12506,
  [12647] = 7903,
  [12648] = 9562,
  [12649] = 12500,
  [12650] = 9569,
  [12651] = 12500,
  [12652] = 3482,
  [12653] = 3606,
  [12654] = 3468,
  [12655] = 12500,
  [12656] = 7881,
  [12657] = 12500,
  [12658] = 3468,
  [12659] = 7913,
  [12660] = 9268,
  [12661] = 12500,
  [12662] = 12500,
  [12663] = 7904,
  [12664] = 3562,
  [12665] = 12500,
  [12666] = 9333,
  [12667] = 3468,
  [12668] = 3543,
  [12669] = 7934,
  [12670] = 12500,
  [12671] = 12500,
  [12672] = 12506,
  [12673] = 9268,
  [12674] = 9218,
  [12675] = 7601,
  [12676] = 12500,
  [12677] = 12500,
  [12678] = 3668,
  [12679] = 3677,
  [12680] = 3760,
  [12681] = 12500,
  [12682] = 12500,
  [12683] = 12683,
  [12684] = 7904,
  [12685] = 12500,
  [12686] = 3470,
  [12687] = 12687,
  [12688] = 12500,
  [12689] = 3547,
  [12690] = 7934,
  [12691] = 9541,
  [12692] = 9567,
  [12693] = 9539,
  [12694] = 9531,
  [12695] = 7890,
  [12696] = 9529,
  [12697] = 7892,
  [12698] = 12500,
  [12699] = 12500,
  [12700] = 7899,
  [12701] = 12500,
  [12702] = 9523,
  [12703] = 12506,
  [12704] = 12527,
  [12705] = 12500,
  [12706] = 9268,
  [12707] = 12532,
  [12708] = 9582,
  [12709] = 12709,
  [12710] = 12683,
  [12711] = 12506,
  [12712] = 12500,
  [12713] = 12500,
  [12714] = 12500,
  [12715] = 12519,
  [12716] = 12500,
  [12717] = 3471,
  [12718] = 3511,
  [12719] = 12500,
  [12720] = 7601,
  [12721] = 12721,
  [12722] = 12500,
  [12723] = 7601,
  [12724] = 7902,
  [12725] = 7932,
  [12726] = 12500,
  [12727] = 7890,
  [12728] = 12728,
  [12729] = 3481,
  [12730] = 3677,
  [12731] = 12731,
  [12732] = 12732,
  [12733] = 12731,
  [12734] = 12731,
  [12735] = 7726,
  [12736] = 12731,
  [12737] = 12737,
  [12738] = 3468,
  [12739] = 12739,
  [12740] = 12731,
  [12741] = 12731,
  [12742] = 12731,
  [12743] = 12743,
  [12744] = 12744,
  [12745] = 12745,
  [12746] = 12731,
  [12747] = 12747,
  [12748] = 12731,
  [12749] = 12596,
  [12750] = 12728,
  [12751] = 12731,
  [12752] = 7918,
  [12753] = 7934,
  [12754] = 7932,
  [12755] = 12731,
  [12756] = 3562,
  [12757] = 12728,
  [12758] = 12758,
  [12759] = 12683,
  [12760] = 12731,
  [12761] = 12731,
  [12762] = 12762,
  [12763] = 12731,
  [12764] = 9218,
  [12765] = 3543,
  [12766] = 12758,
  [12767] = 12767,
  [12768] = 12731,
  [12769] = 3471,
  [12770] = 9277,
  [12771] = 12731,
  [12772] = 12758,
  [12773] = 12731,
  [12774] = 12744,
  [12775] = 12731,
  [12776] = 12504,
  [12777] = 12731,
  [12778] = 12731,
  [12779] = 12731,
  [12780] = 12758,
  [12781] = 7913,
  [12782] = 7820,
  [12783] = 12744,
  [12784] = 12731,
  [12785] = 12278,
  [12786] = 12731,
  [12787] = 12731,
  [12788] = 3470,
  [12789] = 12731,
  [12790] = 12731,
  [12791] = 12791,
  [12792] = 12792,
  [12793] = 12731,
  [12794] = 12731,
  [12795] = 12731,
  [12796] = 12796,
  [12797] = 12731,
  [12798] = 3562,
  [12799] = 12731,
  [12800] = 12800,
  [12801] = 12758,
  [12802] = 3481,
  [12803] = 7912,
  [12804] = 12804,
  [12805] = 12731,
  [12806] = 3470,
  [12807] = 12744,
  [12808] = 3677,
  [12809] = 12758,
  [12810] = 12810,
  [12811] = 12811,
  [12812] = 12634,
  [12813] = 12731,
  [12814] = 12758,
  [12815] = 12731,
  [12816] = 12731,
  [12817] = 12532,
  [12818] = 12758,
  [12819] = 12731,
  [12820] = 12731,
  [12821] = 12731,
  [12822] = 12822,
  [12823] = 12758,
  [12824] = 12758,
  [12825] = 12811,
  [12826] = 12731,
  [12827] = 12744,
  [12828] = 3677,
  [12829] = 7904,
  [12830] = 12830,
  [12831] = 12731,
  [12832] = 12619,
  [12833] = 12731,
  [12834] = 12834,
  [12835] = 12835,
  [12836] = 12731,
  [12837] = 12758,
  [12838] = 3562,
  [12839] = 3471,
  [12840] = 12758,
  [12841] = 12731,
  [12842] = 12551,
  [12843] = 12731,
  [12844] = 12844,
  [12845] = 12432,
  [12846] = 12731,
  [12847] = 9333,
  [12848] = 12731,
  [12849] = 12747,
  [12850] = 12758,
  [12851] = 12731,
  [12852] = 12758,
  [12853] = 12527,
  [12854] = 12758,
  [12855] = 12835,
  [12856] = 12758,
  [12857] = 12744,
  [12858] = 12325,
  [12859] = 12731,
  [12860] = 12758,
  [12861] = 12861,
  [12862] = 12758,
  [12863] = 12758,
  [12864] = 12864,
  [12865] = 3600,
  [12866] = 12731,
  [12867] = 12758,
  [12868] = 12731,
  [12869] = 12758,
  [12870] = 12758,
  [12871] = 12731,
  [12872] = 12758,
  [12873] = 7820,
  [12874] = 7726,
  [12875] = 7601,
  [12876] = 3760,
  [12877] = 3514,
  [12878] = 12810,
  [12879] = 12731,
  [12880] = 12758,
  [12881] = 12881,
  [12882] = 12619,
  [12883] = 12731,
  [12884] = 3668,
  [12885] = 3468,
  [12886] = 12758,
  [12887] = 12758,
  [12888] = 12758,
  [12889] = 12731,
  [12890] = 12890,
  [12891] = 12891,
  [12892] = 12731,
  [12893] = 12891,
  [12894] = 12634,
  [12895] = 12731,
  [12896] = 12822,
  [12897] = 3468,
  [12898] = 12731,
  [12899] = 12731,
  [12900] = 9268,
  [12901] = 12901,
  [12902] = 12902,
  [12903] = 12747,
  [12904] = 12758,
  [12905] = 12728,
  [12906] = 7726,
  [12907] = 12744,
  [12908] = 7902,
  [12909] = 3606,
  [12910] = 7901,
  [12911] = 3482,
  [12912] = 12731,
  [12913] = 12731,
  [12914] = 12731,
  [12915] = 12758,
  [12916] = 12731,
  [12917] = 12325,
  [12918] = 12731,
  [12919] = 12731,
  [12920] = 3576,
  [12921] = 12731,
  [12922] = 12731,
  [12923] = 12731,
  [12924] = 12737,
  [12925] = 3489,
  [12926] = 12758,
  [12927] = 3549,
  [12928] = 12758,
  [12929] = 12744,
  [12930] = 12758,
  [12931] = 12744,
  [12932] = 12758,
  [12933] = 12731,
  [12934] = 12731,
  [12935] = 12739,
  [12936] = 3562,
  [12937] = 12758,
  [12938] = 12758,
  [12939] = 7900,
  [12940] = 3481,
  [12941] = 12731,
  [12942] = 12881,
  [12943] = 7899,
  [12944] = 7892,
  [12945] = 12731,
  [12946] = 12728,
  [12947] = 3546,
  [12948] = 12948,
  [12949] = 12758,
  [12950] = 12731,
  [12951] = 12758,
  [12952] = 12731,
  [12953] = 12731,
  [12954] = 12731,
  [12955] = 12747,
  [12956] = 7601,
  [12957] = 12731,
  [12958] = 12731,
  [12959] = 12747,
  [12960] = 12731,
  [12961] = 12961,
  [12962] = 12731,
  [12963] = 3481,
  [12964] = 12731,
  [12965] = 12731,
  [12966] = 12767,
  [12967] = 12731,
  [12968] = 12861,
  [12969] = 12731,
  [12970] = 12731,
  [12971] = 12731,
  [12972] = 9218,
  [12973] = 12731,
  [12974] = 12731,
  [12975] = 12731,
  [12976] = 12744,
  [12977] = 12731,
  [12978] = 12758,
  [12979] = 12731,
  [12980] = 7881,
  [12981] = 7903,
  [12982] = 12744,
  [12983] = 12731,
  [12984] = 12731,
  [12985] = 12731,
  [12986] = 12732,
  [12987] = 12731,
  [12988] = 12731,
  [12989] = 12731,
  [12990] = 12731,
  [12991] = 12731,
  [12992] = 12743,
  [12993] = 12634,
  [12994] = 12901,
  [12995] = 12758,
  [12996] = 12902,
  [12997] = 12731,
  [12998] = 12758,
  [12999] = 12731,
  [13000] = 12745,
  [13001] = 12800,
  [13002] = 12731,
  [13003] = 12731,
  [13004] = 12731,
  [13005] = 9333,
  [13006] = 12731,
  [13007] = 12758,
  [13008] = 12758,
  [13009] = 12835,
  [13010] = 12901,
  [13011] = 12731,
  [13012] = 12902,
  [13013] = 12731,
  [13014] = 7875,
  [13015] = 12744,
  [13016] = 3481,
  [13017] = 12731,
  [13018] = 9218,
  [13019] = 12731,
  [13020] = 12731,
  [13021] = 3471,
  [13022] = 3577,
  [13023] = 12834,
  [13024] = 12731,
  [13025] = 3677,
  [13026] = 7877,
  [13027] = 12731,
  [13028] = 12731,
  [13029] = 7820,
  [13030] = 12758,
  [13031] = 12731,
  [13032] = 7601,
  [13033] = 12619,
  [13034] = 12731,
  [13035] = 7726,
  [13036] = 12890,
  [13037] = 12731,
  [13038] = 12731,
  [13039] = 3470,
  [13040] = 12731,
  [13041] = 12731,
  [13042] = 13042,
  [13043] = 3591,
  [13044] = 3547,
  [13045] = 12731,
  [13046] = 12731,
  [13047] = 12791,
  [13048] = 12731,
  [13049] = 12731,
  [13050] = 12731,
  [13051] = 12758,
  [13052] = 12732,
  [13053] = 13053,
  [13054] = 9268,
  [13055] = 12731,
  [13056] = 12731,
  [13057] = 12743,
  [13058] = 3608,
  [13059] = 13059,
  [13060] = 3511,
  [13061] = 12731,
  [13062] = 12731,
  [13063] = 12519,
  [13064] = 12731,
  [13065] = 12745,
  [13066] = 13066,
  [13067] = 12731,
  [13068] = 12731,
  [13069] = 12731,
  [13070] = 12744,
  [13071] = 12792,
  [13072] = 13072,
  [13073] = 12804,
  [13074] = 13066,
  [13075] = 3677,
  [13076] = 12961,
  [13077] = 7894,
  [13078] = 12758,
  [13079] = 12744,
  [13080] = 7820,
  [13081] = 3751,
  [13082] = 12731,
  [13083] = 12555,
  [13084] = 7897,
  [13085] = 12731,
  [13086] = 3562,
  [13087] = 12731,
  [13088] = 12758,
  [13089] = 3597,
  [13090] = 12731,
  [13091] = 12731,
  [13092] = 13092,
  [13093] = 13093,
  [13094] = 7726,
  [13095] = 7820,
  [13096] = 12731,
  [13097] = 13066,
  [13098] = 12731,
  [13099] = 3511,
  [13100] = 7913,
  [13101] = 7902,
  [13102] = 7901,
  [13103] = 7820,
  [13104] = 13104,
  [13105] = 3576,
  [13106] = 13106,
  [13107] = 13107,
  [13108] = 3597,
  [13109] = 3489,
  [13110] = 9531,
  [13111] = 13107,
  [13112] = 13106,
  [13113] = 13106,
  [13114] = 7934,
  [13115] = 7904,
  [13116] = 3470,
  [13117] = 7894,
  [13118] = 7900,
  [13119] = 13119,
  [13120] = 13120,
  [13121] = 7912,
  [13122] = 7877,
  [13123] = 9268,
  [13124] = 13059,
  [13125] = 3549,
  [13126] = 7912,
  [13127] = 3481,
  [13128] = 3470,
  [13129] = 12278,
  [13130] = 3562,
  [13131] = 13120,
  [13132] = 3576,
  [13133] = 13133,
  [13134] = 3489,
  [13135] = 13135,
  [13136] = 13136,
  [13137] = 3547,
  [13138] = 12619,
  [13139] = 12890,
  [13140] = 13140,
  [13141] = 3668,
  [13142] = 7932,
  [13143] = 3489,
  [13144] = 3576,
  [13145] = 7904,
  [13146] = 13146,
  [13147] = 7899,
  [13148] = 7892,
  [13149] = 13149,
  [13150] = 7890,
  [13151] = 3608,
  [13152] = 7932,
  [13153] = 12634,
  [13154] = 7934,
  [13155] = 3677,
  [13156] = 9277,
  [13157] = 13157,
  [13158] = 12739,
  [13159] = 7918,
  [13160] = 3549,
  [13161] = 3471,
  [13162] = 13162,
  [13163] = 3591,
  [13164] = 7881,
  [13165] = 13165,
  [13166] = 9523,
  [13167] = 7902,
  [13168] = 7903,
  [13169] = 13140,
  [13170] = 3547,
  [13171] = 3481,
  [13172] = 13172,
  [13173] = 3549,
  [13174] = 13174,
  [13175] = 13072,
  [13176] = 7875,
  [13177] = 9268,
  [13178] = 3597,
  [13179] = 7820,
  [13180] = 12278,
  [13181] = 3608,
  [13182] = 3543,
  [13183] = 3591,
  [13184] = 7901,
  [13185] = 3597,
  [13186] = 3577,
  [13187] = 3577,
  [13188] = 12278,
  [13189] = 13172,
  [13190] = 7894,
  [13191] = 7897,
  [13192] = 3546,
  [13193] = 3546,
  [13194] = 7913,
  [13195] = 3482,
  [13196] = 3562,
  [13197] = 3606,
  [13198] = 3668,
  [13199] = 7877,
  [13200] = 7918,
  [13201] = 3482,
  [13202] = 3549,
  [13203] = 13172,
  [13204] = 3606,
  [13205] = 7875,
  [13206] = 13206,
  [13207] = 3489,
  [13208] = 3576,
  [13209] = 13209,
  [13210] = 13210,
  [13211] = 7726,
  [13212] = 12811,
  [13213] = 13213,
  [13214] = 13214,
  [13215] = 3543,
  [13216] = 12890,
  [13217] = 13217,
  [13218] = 3576,
  [13219] = 13219,
  [13220] = 3514,
  [13221] = 13221,
  [13222] = 9333,
  [13223] = 3668,
  [13224] = 13224,
  [13225] = 12792,
  [13226] = 9567,
  [13227] = 7877,
  [13228] = 3481,
  [13229] = 7913,
  [13230] = 7932,
  [13231] = 13119,
  [13232] = 3547,
  [13233] = 7897,
  [13234] = 3597,
  [13235] = 3608,
  [13236] = 7894,
  [13237] = 12737,
  [13238] = 7875,
  [13239] = 3543,
  [13240] = 13224,
  [13241] = 13241,
  [13242] = 3481,
  [13243] = 7918,
  [13244] = 3543,
  [13245] = 12762,
  [13246] = 7918,
  [13247] = 7820,
  [13248] = 7918,
  [13249] = 7932,
  [13250] = 13162,
  [13251] = 3543,
  [13252] = 7877,
  [13253] = 13241,
  [13254] = 7726,
  [13255] = 3489,
  [13256] = 13256,
  [13257] = 13165,
  [13258] = 7726,
  [13259] = 3668,
  [13260] = 7897,
  [13261] = 7894,
  [13262] = 7903,
  [13263] = 3608,
  [13264] = 13224,
  [13265] = 13241,
  [13266] = 7881,
  [13267] = 12278,
  [13268] = 13268,
  [13269] = 12325,
  [13270] = 7899,
  [13271] = 7601,
  [13272] = 3677,
  [13273] = 13157,
  [13274] = 3511,
  [13275] = 3468,
  [13276] = 7912,
  [13277] = 3606,
  [13278] = 13165,
  [13279] = 13279,
  [13280] = 9529,
  [13281] = 3482,
  [13282] = 3591,
  [13283] = 3577,
  [13284] = 3546,
  [13285] = 13174,
  [13286] = 3577,
  [13287] = 7877,
  [13288] = 13288,
  [13289] = 3591,
  [13290] = 3514,
  [13291] = 7875,
  [13292] = 7890,
  [13293] = 7892,
  [13294] = 3608,
  [13295] = 3468,
  [13296] = 7904,
  [13297] = 3597,
  [13298] = 7899,
  [13299] = 7934,
  [13300] = 3514,
  [13301] = 12961,
  [13302] = 3549,
  [13303] = 12890,
  [13304] = 7900,
  [13305] = 7913,
  [13306] = 7903,
  [13307] = 3547,
  [13308] = 9541,
  [13309] = 3546,
  [13310] = 13310,
  [13311] = 12881,
  [13312] = 13210,
  [13313] = 13209,
  [13314] = 7881,
  [13315] = 9539,
  [13316] = 7901,
  [13317] = 9268,
  [13318] = 12432,
  [13319] = 7892,
  [13320] = 3562,
  [13321] = 7902,
  [13322] = 3514,
  [13323] = 12834,
  [13324] = 7890,
  [13325] = 3482,
  [13326] = 3606,
  [13327] = 13210,
  [13328] = 3511,
  [13329] = 7902,
  [13330] = 12861,
  [13331] = 7934,
  [13332] = 7890,
  [13333] = 3705,
  [13334] = 7892,
  [13335] = 7899,
  [13336] = 7901,
  [13337] = 13221,
  [13338] = 3514,
  [13339] = 7897,
  [13340] = 7900,
  [13341] = 12767,
  [13342] = 7903,
  [13343] = 13268,
  [13344] = 7900,
  [13345] = 7894,
  [13346] = 7904,
  [13347] = 7900,
  [13348] = 13256,
  [13349] = 13053,
  [13350] = 3668,
  [13351] = 9268,
  [13352] = 7899,
  [13353] = 12891,
  [13354] = 7892,
  [13355] = 7897,
  [13356] = 3511,
  [13357] = 7901,
  [13358] = 7902,
  [13359] = 3677,
  [13360] = 3606,
  [13361] = 7890,
  [13362] = 3692,
  [13363] = 9333,
  [13364] = 3482,
  [13365] = 13310,
  [13366] = 12791,
  [13367] = 13206,
  [13368] = 7934,
  [13369] = 7904,
  [13370] = 3547,
  [13371] = 7881,
  [13372] = 12810,
  [13373] = 7903,
  [13374] = 12278,
  [13375] = 7912,
  [13376] = 3546,
  [13377] = 7913,
  [13378] = 3511,
  [13379] = 3577,
  [13380] = 7875,
  [13381] = 13217,
  [13382] = 7912,
  [13383] = 3591,
  [13384] = 7932,
  [13385] = 13209,
  [13386] = 7881,
  [13387] = 13136,
  [13388] = 13219,
  [13389] = 13389,
  [13390] = 13390,
  [13391] = 13390,
  [13392] = 13392,
  [13393] = 3511,
  [13394] = 3511,
  [13395] = 13390,
  [13396] = 13206,
  [13397] = 13390,
  [13398] = 13398,
  [13399] = 13256,
  [13400] = 3751,
  [13401] = 13401,
  [13402] = 9523,
  [13403] = 13219,
  [13404] = 13390,
  [13405] = 13405,
  [13406] = 13406,
  [13407] = 3471,
  [13408] = 13217,
  [13409] = 13409,
  [13410] = 13405,
  [13411] = 13390,
  [13412] = 13390,
  [13413] = 13413,
  [13414] = 13405,
  [13415] = 13119,
  [13416] = 3543,
  [13417] = 13390,
  [13418] = 3576,
  [13419] = 3489,
  [13420] = 3549,
  [13421] = 13390,
  [13422] = 3692,
  [13423] = 3600,
  [13424] = 3705,
  [13425] = 9541,
  [13426] = 13268,
  [13427] = 13390,
  [13428] = 9539,
  [13429] = 9531,
  [13430] = 9529,
  [13431] = 9523,
  [13432] = 13405,
  [13433] = 13390,
  [13434] = 3668,
  [13435] = 13390,
  [13436] = 3606,
  [13437] = 13390,
  [13438] = 13390,
  [13439] = 3546,
  [13440] = 13440,
  [13441] = 3577,
  [13442] = 3591,
  [13443] = 3608,
  [13444] = 3597,
  [13445] = 3547,
  [13446] = 3746,
  [13447] = 13447,
  [13448] = 3745,
  [13449] = 13390,
  [13450] = 3740,
  [13451] = 3785,
  [13452] = 3774,
  [13453] = 13390,
  [13454] = 3762,
  [13455] = 3748,
  [13456] = 3734,
  [13457] = 3747,
  [13458] = 3744,
  [13459] = 13390,
  [13460] = 3743,
  [13461] = 3742,
  [13462] = 13390,
  [13463] = 3739,
  [13464] = 3738,
  [13465] = 3737,
  [13466] = 13466,
  [13467] = 13390,
  [13468] = 13390,
  [13469] = 3778,
  [13470] = 3482,
  [13471] = 13390,
  [13472] = 13174,
  [13473] = 9567,
  [13474] = 13053,
  [13475] = 3514,
  [13476] = 13405,
  [13477] = 13390,
  [13478] = 13157,
  [13479] = 13405,
  [13480] = 13405,
  [13481] = 13390,
  [13482] = 13390,
  [13483] = 13390,
  [13484] = 13310,
  [13485] = 13390,
  [13486] = 13405,
  [13487] = 9541,
  [13488] = 9539,
  [13489] = 13390,
  [13490] = 13390,
  [13491] = 13491,
  [13492] = 13390,
  [13493] = 13405,
  [13494] = 13390,
  [13495] = 13135,
  [13496] = 13213,
  [13497] = 13390,
  [13498] = 13390,
  [13499] = 13390,
  [13500] = 13390,
  [13501] = 13501,
  [13502] = 13390,
  [13503] = 13390,
  [13504] = 13405,
  [13505] = 13505,
  [13506] = 13390,
  [13507] = 13507,
  [13508] = 13390,
  [13509] = 13509,
  [13510] = 13390,
  [13511] = 9531,
  [13512] = 13512,
  [13513] = 13513,
  [13514] = 13514,
  [13515] = 13405,
  [13516] = 13390,
  [13517] = 13390,
  [13518] = 3692,
  [13519] = 13390,
  [13520] = 3705,
  [13521] = 9541,
  [13522] = 9529,
  [13523] = 13390,
  [13524] = 13390,
  [13525] = 9539,
  [13526] = 9531,
  [13527] = 9529,
  [13528] = 13528,
  [13529] = 13390,
  [13530] = 9523,
  [13531] = 13390,
  [13532] = 3514,
  [13533] = 13390,
  [13534] = 13107,
  [13535] = 13390,
  [13536] = 13390,
  [13537] = 3514,
  [13538] = 13146,
  [13539] = 13390,
  [13540] = 13390,
  [13541] = 13390,
  [13542] = 13390,
  [13543] = 13149,
  [13544] = 13544,
  [13545] = 13390,
  [13546] = 13546,
  [13547] = 13547,
  [13548] = 13390,
  [13549] = 13390,
  [13550] = 13550,
  [13551] = 13390,
  [13552] = 3692,
  [13553] = 13553,
  [13554] = 13554,
  [13555] = 13555,
  [13556] = 13556,
  [13557] = 13405,
  [13558] = 13558,
  [13559] = 13405,
  [13560] = 13405,
  [13561] = 13561,
  [13562] = 13136,
  [13563] = 3600,
  [13564] = 13390,
  [13565] = 13405,
  [13566] = 13390,
  [13567] = 13120,
  [13568] = 3514,
  [13569] = 13514,
  [13570] = 13401,
  [13571] = 13390,
  [13572] = 3705,
  [13573] = 13405,
  [13574] = 13413,
  [13575] = 13392,
  [13576] = 13406,
  [13577] = 13398,
  [13578] = 13390,
  [13579] = 13390,
  [13580] = 13440,
  [13581] = 13447,
  [13582] = 13390,
  [13583] = 13583,
  [13584] = 3547,
  [13585] = 3597,
  [13586] = 13586,
  [13587] = 13583,
  [13588] = 13390,
  [13589] = 13589,
  [13590] = 3511,
  [13591] = 13591,
  [13592] = 13592,
  [13593] = 3608,
  [13594] = 3591,
  [13595] = 13595,
  [13596] = 13405,
  [13597] = 13597,
  [13598] = 3546,
  [13599] = 3482,
  [13600] = 13586,
  [13601] = 13601,
  [13602] = 13390,
  [13603] = 3606,
  [13604] = 13512,
  [13605] = 13405,
  [13606] = 3668,
  [13607] = 13607,
  [13608] = 3549,
  [13609] = 3489,
  [13610] = 3576,
  [13611] = 3577,
  [13612] = 3600,
  [13613] = 13390,
  [13614] = 3543,
  [13615] = 3470,
  [13616] = 3547,
  [13617] = 13288,
  [13618] = 3597,
  [13619] = 3608,
  [13620] = 13390,
  [13621] = 13553,
  [13622] = 12278,
  [13623] = 13554,
  [13624] = 3591,
  [13625] = 3577,
  [13626] = 13561,
  [13627] = 13390,
  [13628] = 3546,
  [13629] = 3482,
  [13630] = 13405,
  [13631] = 3606,
  [13632] = 3668,
  [13633] = 13633,
  [13634] = 13390,
  [13635] = 13635,
  [13636] = 3547,
  [13637] = 13637,
  [13638] = 3549,
  [13639] = 13639,
  [13640] = 13640,
  [13641] = 3597,
  [13642] = 13642,
  [13643] = 13643,
  [13644] = 13390,
  [13645] = 9541,
  [13646] = 13646,
  [13647] = 3608,
  [13648] = 3591,
  [13649] = 3577,
  [13650] = 13589,
  [13651] = 3489,
  [13652] = 3576,
  [13653] = 13390,
  [13654] = 13654,
  [13655] = 3546,
  [13656] = 13656,
  [13657] = 13554,
  [13658] = 9539,
  [13659] = 13390,
  [13660] = 3482,
  [13661] = 3606,
  [13662] = 3668,
  [13663] = 13663,
  [13664] = 13405,
  [13665] = 13221,
  [13666] = 3549,
  [13667] = 7912,
  [13668] = 3751,
  [13669] = 7904,
  [13670] = 7934,
  [13671] = 13390,
  [13672] = 3489,
  [13673] = 3576,
  [13674] = 7902,
  [13675] = 13675,
  [13676] = 13405,
  [13677] = 13595,
  [13678] = 7901,
  [13679] = 3543,
  [13680] = 3471,
  [13681] = 13597,
  [13682] = 7900,
  [13683] = 13390,
  [13684] = 7899,
  [13685] = 7892,
  [13686] = 7890,
  [13687] = 13558,
  [13688] = 7913,
  [13689] = 13689,
  [13690] = 7903,
  [13691] = 13554,
  [13692] = 13512,
  [13693] = 7918,
  [13694] = 13405,
  [13695] = 13390,
  [13696] = 13696,
  [13697] = 7875,
  [13698] = 13390,
  [13699] = 13405,
  [13700] = 3543,
  [13701] = 7894,
  [13702] = 7897,
  [13703] = 7932,
  [13704] = 13556,
  [13705] = 13555,
  [13706] = 7877,
  [13707] = 7913,
  [13708] = 13390,
  [13709] = 7912,
  [13710] = 3468,
  [13711] = 7904,
  [13712] = 13712,
  [13713] = 7934,
  [13714] = 13405,
  [13715] = 7881,
  [13716] = 7902,
  [13717] = 13390,
  [13718] = 7901,
  [13719] = 13214,
  [13720] = 7932,
  [13721] = 13162,
  [13722] = 7900,
  [13723] = 13723,
  [13724] = 7899,
  [13725] = 13390,
  [13726] = 13390,
  [13727] = 13554,
  [13728] = 7892,
  [13729] = 7890,
  [13730] = 3677,
  [13731] = 13390,
  [13732] = 3562,
  [13733] = 7881,
  [13734] = 7903,
  [13735] = 7918,
  [13736] = 7875,
  [13737] = 13390,
  [13738] = 13390,
  [13739] = 13739,
  [13740] = 7894,
  [13741] = 7897,
  [13742] = 7932,
  [13743] = 7877,
  [13744] = 3481,
  [13745] = 13053,
  [13746] = 13288,
  [13747] = 13747,
  [13748] = 13405,
  [13749] = 13390,
  [13750] = 7820,
  [13751] = 3471,
  [13752] = 12890,
  [13753] = 13405,
  [13754] = 13405,
  [13755] = 13755,
  [13756] = 3470,
  [13757] = 3468,
  [13758] = 13405,
  [13759] = 13759,
  [13760] = 13759,
  [13761] = 13405,
  [13762] = 13389,
  [13763] = 13390,
  [13764] = 7877,
  [13765] = 13390,
  [13766] = 13390,
  [13767] = 13389,
  [13768] = 13768,
  [13769] = 12325,
  [13770] = 13390,
  [13771] = 13768,
  [13772] = 3543,
  [13773] = 7726,
  [13774] = 7918,
  [13775] = 13775,
  [13776] = 13776,
  [13777] = 13553,
  [13778] = 13554,
  [13779] = 13779,
  [13780] = 12791,
  [13781] = 13781,
  [13782] = 13390,
  [13783] = 13390,
  [13784] = 13784,
  [13785] = 13785,
  [13786] = 13219,
  [13787] = 13466,
  [13788] = 13405,
  [13789] = 13789,
  [13790] = 13790,
  [13791] = 13214,
  [13792] = 13390,
  [13793] = 13793,
  [13794] = 13794,
  [13795] = 13795,
  [13796] = 13796,
  [13797] = 13796,
  [13798] = 13798,
  [13799] = 13799,
  [13800] = 13800,
  [13801] = 13405,
  [13802] = 13390,
  [13803] = 13601,
  [13804] = 13592,
  [13805] = 13591,
  [13806] = 7913,
  [13807] = 13405,
  [13808] = 13390,
  [13809] = 13390,
  [13810] = 13390,
  [13811] = 13811,
  [13812] = 13589,
  [13813] = 13813,
  [13814] = 13814,
  [13815] = 13776,
  [13816] = 13689,
  [13817] = 13775,
  [13818] = 13390,
  [13819] = 13635,
  [13820] = 13820,
  [13821] = 13821,
  [13822] = 13288,
  [13823] = 13823,
  [13824] = 13637,
  [13825] = 13639,
  [13826] = 13390,
  [13827] = 7897,
  [13828] = 13405,
  [13829] = 13829,
  [13830] = 7894,
  [13831] = 9523,
  [13832] = 12278,
  [13833] = 13833,
  [13834] = 13405,
  [13835] = 3481,
  [13836] = 13390,
  [13837] = 13837,
  [13838] = 13759,
  [13839] = 13389,
  [13840] = 13800,
  [13841] = 13390,
  [13842] = 13390,
  [13843] = 9567,
  [13844] = 13796,
  [13845] = 13390,
  [13846] = 13513,
  [13847] = 13640,
  [13848] = 13550,
  [13849] = 13776,
  [13850] = 13781,
  [13851] = 13390,
  [13852] = 13642,
  [13853] = 13405,
  [13854] = 13781,
  [13855] = 13491,
  [13856] = 13390,
  [13857] = 13405,
  [13858] = 13405,
  [13859] = 13859,
  [13860] = 13643,
  [13861] = 7875,
  [13862] = 13390,
  [13863] = 13646,
  [13864] = 13053,
  [13865] = 13865,
  [13866] = 13790,
  [13867] = 13405,
  [13868] = 13654,
  [13869] = 13793,
  [13870] = 13794,
  [13871] = 13409,
  [13872] = 13546,
  [13873] = 13795,
  [13874] = 13405,
  [13875] = 13405,
  [13876] = 13390,
  [13877] = 13544,
  [13878] = 13878,
  [13879] = 7903,
  [13880] = 13390,
  [13881] = 13798,
  [13882] = 13799,
  [13883] = 13883,
  [13884] = 13800,
  [13885] = 13885,
  [13886] = 13775,
  [13887] = 12325,
  [13888] = 13390,
  [13889] = 7881,
  [13890] = 13890,
  [13891] = 13789,
  [13892] = 13601,
  [13893] = 13663,
  [13894] = 7890,
  [13895] = 7892,
  [13896] = 13592,
  [13897] = 13591,
  [13898] = 7899,
  [13899] = 13790,
  [13900] = 13789,
  [13901] = 13390,
  [13902] = 13390,
  [13903] = 13689,
  [13904] = 12278,
  [13905] = 13390,
  [13906] = 13820,
  [13907] = 13501,
  [13908] = 13390,
  [13909] = 13505,
  [13910] = 7900,
  [13911] = 13390,
  [13912] = 7901,
  [13913] = 7902,
  [13914] = 13390,
  [13915] = 13405,
  [13916] = 13799,
  [13917] = 13507,
  [13918] = 13747,
  [13919] = 13759,
  [13920] = 7934,
  [13921] = 7904,
  [13922] = 13390,
  [13923] = 13390,
  [13924] = 13390,
  [13925] = 13390,
  [13926] = 13776,
  [13927] = 13390,
  [13928] = 7912,
  [13929] = 13929,
  [13930] = 13930,
  [13931] = 13793,
  [13932] = 13798,
  [13933] = 13794,
  [13934] = 13934,
  [13935] = 13390,
  [13936] = 13390,
  [13937] = 13405,
  [13938] = 13795,
  [13939] = 13390,
  [13940] = 13390,
  [13941] = 13941,
  [13942] = 13390,
  [13943] = 13390,
  [13944] = 13944,
  [13945] = 13759,
  [13946] = 13390,
  [13947] = 13389,
  [13948] = 13390,
  [13949] = 13509,
  [13950] = 13405,
  [13951] = 13390,
  [13952] = 13547,
  [13953] = 13390,
  [13954] = 13823,
  [13955] = 13390,
  [13956] = 13776,
  [13957] = 13957,
  [13958] = 13214,
  [13959] = 13390,
  [13960] = 13390,
  [13961] = 13219,
  [13962] = 13405,
  [13963] = 13390,
  [13964] = 13795,
  [13965] = 13795,
  [13966] = 13390,
  [13967] = 13390,
  [13968] = 13820,
  [13969] = 13405,
  [13970] = 9529,
  [13971] = 9531,
  [13972] = 13633,
  [13973] = 13390,
  [13974] = 12881,
  [13975] = 13390,
  [13976] = 13405,
  [13977] = 13390,
  [13978] = 12891,
  [13979] = 13696,
  [13980] = 13390,
  [13981] = 13528,
  [13982] = 13982,
  [13983] = 13983,
  [13984] = 13747,
  [13985] = 13982,
  [13986] = 3489,
  [13987] = 13987,
  [13988] = 13982,
  [13989] = 13989,
  [13990] = 13990,
  [13991] = 3549,
  [13992] = 13982,
  [13993] = 13993,
  [13994] = 3468,
  [13995] = 13982,
  [13996] = 13982,
  [13997] = 3668,
  [13998] = 3606,
  [13999] = 13987,
  [14000] = 3482,
  [14001] = 13990,
  [14002] = 13993,
  [14003] = 13982,
  [14004] = 13982,
  [14005] = 13982,
  [14006] = 3677,
  [14007] = 13993,
  [14008] = 13214,
  [14009] = 3546,
  [14010] = 13990,
  [14011] = 13982,
  [14012] = 3562,
  [14013] = 3577,
  [14014] = 14014,
  [14015] = 13982,
  [14016] = 3591,
  [14017] = 3576,
  [14018] = 3597,
  [14019] = 13993,
  [14020] = 12881,
  [14021] = 13982,
  [14022] = 12891,
  [14023] = 3547,
  [14024] = 3514,
  [14025] = 13987,
  [14026] = 13987,
  [14027] = 14027,
  [14028] = 3746,
  [14029] = 9523,
  [14030] = 13993,
  [14031] = 3745,
  [14032] = 13982,
  [14033] = 3774,
  [14034] = 3762,
  [14035] = 3747,
  [14036] = 3744,
  [14037] = 13993,
  [14038] = 3743,
  [14039] = 3742,
  [14040] = 3739,
  [14041] = 3738,
  [14042] = 13993,
  [14043] = 3778,
  [14044] = 3608,
  [14045] = 3740,
  [14046] = 13982,
  [14047] = 13982,
  [14048] = 3785,
  [14049] = 3748,
  [14050] = 3734,
  [14051] = 13104,
  [14052] = 13993,
  [14053] = 3737,
  [14054] = 13104,
  [14055] = 14055,
  [14056] = 13993,
  [14057] = 3751,
  [14058] = 13982,
  [14059] = 13987,
  [14060] = 3760,
  [14061] = 13982,
  [14062] = 13993,
  [14063] = 13982,
  [14064] = 13990,
  [14065] = 13990,
  [14066] = 3470,
  [14067] = 13982,
  [14068] = 13696,
  [14069] = 13982,
  [14070] = 14014,
  [14071] = 13982,
  [14072] = 13987,
  [14073] = 13633,
  [14074] = 13993,
  [14075] = 13982,
  [14076] = 14076,
  [14077] = 3471,
  [14078] = 12890,
  [14079] = 12791,
  [14080] = 9333,
  [14081] = 13982,
  [14082] = 13993,
  [14083] = 13829,
  [14084] = 13993,
  [14085] = 13990,
  [14086] = 13833,
  [14087] = 13837,
  [14088] = 13993,
  [14089] = 13982,
  [14090] = 13982,
  [14091] = 13982,
  [14092] = 13982,
  [14093] = 9550,
  [14094] = 13982,
  [14095] = 12551,
  [14096] = 13982,
  [14097] = 9541,
  [14098] = 9539,
  [14099] = 13982,
  [14100] = 14014,
  [14101] = 9531,
  [14102] = 13993,
  [14103] = 9529,
  [14104] = 14104,
  [14105] = 13987,
  [14106] = 13982,
  [14107] = 13982,
  [14108] = 9523,
  [14109] = 13982,
  [14110] = 9541,
  [14111] = 14111,
  [14112] = 14112,
  [14113] = 14113,
  [14114] = 13982,
  [14115] = 13987,
  [14116] = 9539,
  [14117] = 3760,
  [14118] = 13987,
  [14119] = 9567,
  [14120] = 3514,
  [14121] = 14121,
  [14122] = 13982,
  [14123] = 13993,
  [14124] = 13663,
  [14125] = 13982,
  [14126] = 13982,
  [14127] = 13982,
  [14128] = 13987,
  [14129] = 9531,
  [14130] = 14130,
  [14131] = 13993,
  [14132] = 9529,
  [14133] = 9523,
  [14134] = 3692,
  [14135] = 3705,
  [14136] = 13654,
  [14137] = 3547,
  [14138] = 3751,
  [14139] = 3597,
  [14140] = 13990,
  [14141] = 13982,
  [14142] = 3608,
  [14143] = 13982,
  [14144] = 13993,
  [14145] = 3591,
  [14146] = 13982,
  [14147] = 3577,
  [14148] = 13646,
  [14149] = 13837,
  [14150] = 13993,
  [14151] = 13643,
  [14152] = 13993,
  [14153] = 13982,
  [14154] = 3546,
  [14155] = 13642,
  [14156] = 9567,
  [14157] = 13833,
  [14158] = 13829,
  [14159] = 13640,
  [14160] = 13993,
  [14161] = 13982,
  [14162] = 13639,
  [14163] = 14163,
  [14164] = 13637,
  [14165] = 13987,
  [14166] = 13987,
  [14167] = 13993,
  [14168] = 13982,
  [14169] = 3482,
  [14170] = 3606,
  [14171] = 3668,
  [14172] = 13635,
  [14173] = 13982,
  [14174] = 14174,
  [14175] = 14175,
  [14176] = 13288,
  [14177] = 13993,
  [14178] = 3549,
  [14179] = 3742,
  [14180] = 3489,
  [14181] = 13982,
  [14182] = 8215,
  [14183] = 13814,
  [14184] = 3576,
  [14185] = 9541,
  [14186] = 13813,
  [14187] = 9539,
  [14188] = 13811,
  [14189] = 9531,
  [14190] = 9412,
  [14191] = 9529,
  [14192] = 9523,
  [14193] = 13993,
  [14194] = 13785,
  [14195] = 13982,
  [14196] = 8223,
  [14197] = 13990,
  [14198] = 13993,
  [14199] = 13784,
  [14200] = 13990,
  [14201] = 13982,
  [14202] = 13982,
  [14203] = 13993,
  [14204] = 13990,
  [14205] = 13987,
  [14206] = 14014,
  [14207] = 13990,
  [14208] = 13987,
  [14209] = 14014,
  [14210] = 9567,
  [14211] = 7932,
  [14212] = 13982,
  [14213] = 13982,
  [14214] = 14214,
  [14215] = 14014,
  [14216] = 14216,
  [14217] = 13982,
  [14218] = 14218,
  [14219] = 3778,
  [14220] = 14220,
  [14221] = 3737,
  [14222] = 14222,
  [14223] = 3738,
  [14224] = 13929,
  [14225] = 3739,
  [14226] = 13982,
  [14227] = 13982,
  [14228] = 3743,
  [14229] = 3744,
  [14230] = 7918,
  [14231] = 14231,
  [14232] = 3747,
  [14233] = 3734,
  [14234] = 13982,
  [14235] = 3748,
  [14236] = 3762,
  [14237] = 13982,
  [14238] = 3774,
  [14239] = 14014,
  [14240] = 13987,
  [14241] = 3785,
  [14242] = 13993,
  [14243] = 13990,
  [14244] = 12278,
  [14245] = 13982,
  [14246] = 14216,
  [14247] = 13987,
  [14248] = 13597,
  [14249] = 13990,
  [14250] = 3740,
  [14251] = 13595,
  [14252] = 3745,
  [14253] = 3746,
  [14254] = 3543,
  [14255] = 13982,
  [14256] = 13982,
  [14257] = 14257,
  [14258] = 13837,
  [14259] = 14259,
  [14260] = 14113,
  [14261] = 13993,
  [14262] = 13993,
  [14263] = 14263,
  [14264] = 13586,
  [14265] = 13982,
  [14266] = 3751,
  [14267] = 13583,
  [14268] = 13982,
  [14269] = 13987,
  [14270] = 3746,
  [14271] = 7857,
  [14272] = 13982,
  [14273] = 3745,
  [14274] = 13447,
  [14275] = 13440,
  [14276] = 8215,
  [14277] = 3760,
  [14278] = 14278,
  [14279] = 14279,
  [14280] = 8223,
  [14281] = 13982,
  [14282] = 14282,
  [14283] = 13219,
  [14284] = 12519,
  [14285] = 3740,
  [14286] = 14286,
  [14287] = 13785,
  [14288] = 13784,
  [14289] = 13398,
  [14290] = 13406,
  [14291] = 13987,
  [14292] = 13982,
  [14293] = 13982,
  [14294] = 14294,
  [14295] = 13987,
  [14296] = 13409,
  [14297] = 13990,
  [14298] = 3785,
  [14299] = 14299,
  [14300] = 13987,
  [14301] = 13656,
  [14302] = 7877,
  [14303] = 13987,
  [14304] = 13392,
  [14305] = 13413,
  [14306] = 13993,
  [14307] = 3774,
  [14308] = 13982,
  [14309] = 14309,
  [14310] = 13987,
  [14311] = 3762,
  [14312] = 13982,
  [14313] = 13987,
  [14314] = 7725,
  [14315] = 13982,
  [14316] = 3748,
  [14317] = 14317,
  [14318] = 3734,
  [14319] = 3747,
  [14320] = 3744,
  [14321] = 7897,
  [14322] = 7894,
  [14323] = 14323,
  [14324] = 3743,
  [14325] = 13401,
  [14326] = 3742,
  [14327] = 3739,
  [14328] = 13755,
  [14329] = 9406,
  [14330] = 3738,
  [14331] = 3737,
  [14332] = 13514,
  [14333] = 14333,
  [14334] = 13993,
  [14335] = 13990,
  [14336] = 12683,
  [14337] = 13982,
  [14338] = 3778,
  [14339] = 13466,
  [14340] = 13833,
  [14341] = 13829,
  [14342] = 3705,
  [14343] = 13987,
  [14344] = 14344,
  [14345] = 13990,
  [14346] = 13982,
  [14347] = 14347,
  [14348] = 13982,
  [14349] = 13987,
  [14350] = 3600,
  [14351] = 13561,
  [14352] = 13993,
  [14353] = 14055,
  [14354] = 13558,
  [14355] = 13982,
  [14356] = 13982,
  [14357] = 13987,
  [14358] = 13556,
  [14359] = 13982,
  [14360] = 13555,
  [14361] = 14286,
  [14362] = 13993,
  [14363] = 13983,
  [14364] = 13982,
  [14365] = 13513,
  [14366] = 13550,
  [14367] = 13993,
  [14368] = 14347,
  [14369] = 13982,
  [14370] = 13987,
  [14371] = 9523,
  [14372] = 13547,
  [14373] = 3692,
  [14374] = 9541,
  [14375] = 13987,
  [14376] = 14278,
  [14377] = 14377,
  [14378] = 13982,
  [14379] = 7875,
  [14380] = 13982,
  [14381] = 13546,
  [14382] = 14175,
  [14383] = 14174,
  [14384] = 9539,
  [14385] = 13982,
  [14386] = 13982,
  [14387] = 13987,
  [14388] = 14388,
  [14389] = 13990,
  [14390] = 14282,
  [14391] = 13987,
  [14392] = 14392,
  [14393] = 13544,
  [14394] = 13982,
  [14395] = 13987,
  [14396] = 14396,
  [14397] = 13982,
  [14398] = 14398,
  [14399] = 14399,
  [14400] = 14299,
  [14401] = 14401,
  [14402] = 9567,
  [14403] = 3677,
  [14404] = 7934,
  [14405] = 7903,
  [14406] = 7881,
  [14407] = 13528,
  [14408] = 14014,
  [14409] = 13982,
  [14410] = 3562,
  [14411] = 13990,
  [14412] = 13993,
  [14413] = 14014,
  [14414] = 13934,
  [14415] = 13814,
  [14416] = 7890,
  [14417] = 7892,
  [14418] = 7899,
  [14419] = 13990,
  [14420] = 13813,
  [14421] = 7900,
  [14422] = 14422,
  [14423] = 14014,
  [14424] = 13811,
  [14425] = 13982,
  [14426] = 13982,
  [14427] = 14427,
  [14428] = 7901,
  [14429] = 13987,
  [14430] = 14430,
  [14431] = 13219,
  [14432] = 14432,
  [14433] = 7902,
  [14434] = 13509,
  [14435] = 14014,
  [14436] = 13982,
  [14437] = 14347,
  [14438] = 7904,
  [14439] = 14231,
  [14440] = 7912,
  [14441] = 14347,
  [14442] = 13507,
  [14443] = 13120,
  [14444] = 13993,
  [14445] = 13987,
  [14446] = 7859,
  [14447] = 13982,
  [14448] = 13505,
  [14449] = 13501,
  [14450] = 8223,
  [14451] = 13987,
  [14452] = 13982,
  [14453] = 8215,
  [14454] = 14454,
  [14455] = 14222,
  [14456] = 13990,
  [14457] = 14457,
  [14458] = 14130,
  [14459] = 13987,
  [14460] = 13982,
  [14461] = 3760,
  [14462] = 12891,
  [14463] = 13982,
  [14464] = 13982,
  [14465] = 13934,
  [14466] = 14466,
  [14467] = 14347,
  [14468] = 14218,
  [14469] = 13982,
  [14470] = 13990,
  [14471] = 13993,
  [14472] = 13982,
  [14473] = 3481,
  [14474] = 13987,
  [14475] = 9531,
  [14476] = 9529,
  [14477] = 3751,
  [14478] = 13982,
  [14479] = 13785,
  [14480] = 14430,
  [14481] = 13982,
  [14482] = 13982,
  [14483] = 3751,
  [14484] = 13993,
  [14485] = 13987,
  [14486] = 14218,
  [14487] = 14347,
  [14488] = 14488,
  [14489] = 13990,
  [14490] = 13990,
  [14491] = 14377,
  [14492] = 13982,
  [14493] = 14392,
  [14494] = 14027,
  [14495] = 13987,
  [14496] = 13993,
  [14497] = 13982,
  [14498] = 13982,
  [14499] = 13491,
  [14500] = 13755,
  [14501] = 9333,
  [14502] = 14396,
  [14503] = 13982,
  [14504] = 13982,
  [14505] = 13982,
  [14506] = 13987,
  [14507] = 14399,
  [14508] = 13990,
  [14509] = 14347,
  [14510] = 13987,
  [14511] = 13982,
  [14512] = 14014,
  [14513] = 13982,
  [14514] = 14347,
  [14515] = 13993,
  [14516] = 3600,
  [14517] = 13982,
  [14518] = 3514,
  [14519] = 13466,
  [14520] = 14299,
  [14521] = 14347,
  [14522] = 13982,
  [14523] = 13993,
  [14524] = 13934,
  [14525] = 3547,
  [14526] = 13784,
  [14527] = 3549,
  [14528] = 3597,
  [14529] = 3608,
  [14530] = 13987,
  [14531] = 3591,
  [14532] = 13982,
  [14533] = 3577,
  [14534] = 3489,
  [14535] = 3543,
  [14536] = 14214,
  [14537] = 14220,
  [14538] = 13982,
  [14539] = 3576,
  [14540] = 14427,
  [14541] = 12881,
  [14542] = 3546,
  [14543] = 13987,
  [14544] = 12791,
  [14545] = 3482,
  [14546] = 13755,
  [14547] = 13219,
  [14548] = 13811,
  [14549] = 3606,
  [14550] = 14550,
  [14551] = 3668,
  [14552] = 3543,
  [14553] = 14279,
  [14554] = 13990,
  [14555] = 13982,
  [14556] = 13466,
  [14557] = 14347,
  [14558] = 7913,
  [14559] = 14559,
  [14560] = 13987,
  [14561] = 13162,
  [14562] = 13813,
  [14563] = 13990,
  [14564] = 13987,
  [14565] = 13993,
  [14566] = 13993,
  [14567] = 13982,
  [14568] = 9541,
  [14569] = 13993,
  [14570] = 9539,
  [14571] = 14571,
  [14572] = 13814,
  [14573] = 3677,
  [14574] = 13982,
  [14575] = 14422,
  [14576] = 13409,
  [14577] = 9529,
  [14578] = 3562,
  [14579] = 3471,
  [14580] = 3470,
  [14581] = 9541,
  [14582] = 9531,
  [14583] = 3481,
  [14584] = 9539,
  [14585] = 13982,
  [14586] = 3751,
  [14587] = 13409,
  [14588] = 14014,
  [14589] = 3468,
  [14590] = 13990,
  [14591] = 9531,
  [14592] = 9529,
  [14593] = 13987,
  [14594] = 13987,
  [14595] = 13982,
  [14596] = 14550,
  [14597] = 9567,
  [14598] = 14422,
  [14599] = 14457,
  [14600] = 14014,
  [14601] = 13982,
  [14602] = 14347,
  [14603] = 13993,
  [14604] = 13990,
  [14605] = 9523,
  [14606] = 14606,
  [14607] = 14607,
  [14608] = 14606,
  [14609] = 14609,
  [14610] = 14610,
  [14611] = 14607,
  [14612] = 14612,
  [14613] = 14613,
  [14614] = 14613,
  [14615] = 14615,
  [14616] = 14616,
  [14617] = 14617,
  [14618] = 14607,
  [14619] = 14619,
  [14620] = 14620,
  [14621] = 14609,
  [14622] = 14622,
  [14623] = 14623,
  [14624] = 14617,
  [14625] = 3481,
  [14626] = 9567,
  [14627] = 14623,
  [14628] = 14628,
  [14629] = 14610,
  [14630] = 14610,
  [14631] = 14609,
  [14632] = 3562,
  [14633] = 14619,
  [14634] = 3677,
  [14635] = 14635,
  [14636] = 14610,
  [14637] = 14607,
  [14638] = 14628,
  [14639] = 14623,
  [14640] = 14640,
  [14641] = 14628,
  [14642] = 14488,
  [14643] = 14643,
  [14644] = 14263,
  [14645] = 14607,
  [14646] = 14623,
  [14647] = 14617,
  [14648] = 3577,
  [14649] = 14607,
  [14650] = 3543,
  [14651] = 14651,
  [14652] = 3668,
  [14653] = 14619,
  [14654] = 3606,
  [14655] = 3482,
  [14656] = 3546,
  [14657] = 3576,
  [14658] = 3489,
  [14659] = 14659,
  [14660] = 14617,
  [14661] = 14606,
  [14662] = 9539,
  [14663] = 14615,
  [14664] = 14607,
  [14665] = 3591,
  [14666] = 14613,
  [14667] = 3608,
  [14668] = 14613,
  [14669] = 3597,
  [14670] = 3549,
  [14671] = 14615,
  [14672] = 3547,
  [14673] = 14673,
  [14674] = 14607,
  [14675] = 14675,
  [14676] = 14617,
  [14677] = 9412,
  [14678] = 14606,
  [14679] = 14606,
  [14680] = 14615,
  [14681] = 14659,
  [14682] = 14682,
  [14683] = 14607,
  [14684] = 14607,
  [14685] = 14685,
  [14686] = 14643,
  [14687] = 14615,
  [14688] = 14610,
  [14689] = 14610,
  [14690] = 9531,
  [14691] = 14613,
  [14692] = 14620,
  [14693] = 13162,
  [14694] = 14615,
  [14695] = 14617,
  [14696] = 14696,
  [14697] = 14697,
  [14698] = 14613,
  [14699] = 14699,
  [14700] = 9523,
  [14701] = 9529,
  [14702] = 14607,
  [14703] = 9531,
  [14704] = 9531,
  [14705] = 9541,
  [14706] = 14706,
  [14707] = 3514,
  [14708] = 14615,
  [14709] = 14606,
  [14710] = 14613,
  [14711] = 14711,
  [14712] = 14712,
  [14713] = 14613,
  [14714] = 13219,
  [14715] = 14609,
  [14716] = 14607,
  [14717] = 14697,
  [14718] = 14706,
  [14719] = 14606,
  [14720] = 14619,
  [14721] = 14606,
  [14722] = 14607,
  [14723] = 14623,
  [14724] = 14607,
  [14725] = 14609,
  [14726] = 14617,
  [14727] = 14607,
  [14728] = 14728,
  [14729] = 14613,
  [14730] = 14730,
  [14731] = 9523,
  [14732] = 14606,
  [14733] = 14609,
  [14734] = 7725,
  [14735] = 14263,
  [14736] = 14607,
  [14737] = 14737,
  [14738] = 14738,
  [14739] = 14613,
  [14740] = 14615,
  [14741] = 14615,
  [14742] = 14742,
  [14743] = 9529,
  [14744] = 14619,
  [14745] = 14696,
  [14746] = 14746,
  [14747] = 14607,
  [14748] = 14623,
  [14749] = 14607,
  [14750] = 14750,
  [14751] = 14751,
  [14752] = 9539,
  [14753] = 14610,
  [14754] = 9541,
  [14755] = 9406,
  [14756] = 14130,
  [14757] = 14757,
  [14758] = 14758,
  [14759] = 3751,
  [14760] = 14760,
  [14761] = 14607,
  [14762] = 14617,
  [14763] = 14610,
  [14764] = 7859,
  [14765] = 14607,
  [14766] = 7857,
  [14767] = 14610,
  [14768] = 14768,
  [14769] = 14769,
  [14770] = 14174,
  [14771] = 14771,
  [14772] = 14772,
  [14773] = 14175,
  [14774] = 14774,
  [14775] = 14775,
  [14776] = 14607,
  [14777] = 14777,
  [14778] = 14607,
  [14779] = 13120,
  [14780] = 14623,
  [14781] = 14617,
  [14782] = 14742,
  [14783] = 9523,
  [14784] = 14607,
  [14785] = 14610,
  [14786] = 14610,
  [14787] = 14643,
  [14788] = 14788,
  [14789] = 14606,
  [14790] = 14619,
  [14791] = 14610,
  [14792] = 14792,
  [14793] = 14793,
  [14794] = 14613,
  [14795] = 14607,
  [14796] = 14615,
  [14797] = 14615,
  [14798] = 14619,
  [14799] = 14617,
  [14800] = 14800,
  [14801] = 14623,
  [14802] = 14613,
  [14803] = 14607,
  [14804] = 14804,
  [14805] = 3760,
  [14806] = 14623,
  [14807] = 14612,
  [14808] = 14808,
  [14809] = 14809,
  [14810] = 14610,
  [14811] = 14610,
  [14812] = 14606,
  [14813] = 14813,
  [14814] = 13104,
  [14815] = 14606,
  [14816] = 14607,
  [14817] = 14817,
  [14818] = 9539,
  [14819] = 9541,
  [14820] = 14607,
  [14821] = 14607,
  [14822] = 14742,
  [14823] = 14823,
  [14824] = 14617,
  [14825] = 13983,
  [14826] = 14607,
  [14827] = 14827,
  [14828] = 14828,
  [14829] = 14643,
  [14830] = 14830,
  [14831] = 14606,
  [14832] = 14617,
  [14833] = 14777,
  [14834] = 14609,
  [14835] = 14216,
  [14836] = 14607,
  [14837] = 14623,
  [14838] = 14838,
  [14839] = 14839,
  [14840] = 14615,
  [14841] = 14615,
  [14842] = 14609,
  [14843] = 14843,
  [14844] = 14606,
  [14845] = 14845,
  [14846] = 14613,
  [14847] = 14839,
  [14848] = 14286,
  [14849] = 14613,
  [14850] = 14615,
  [14851] = 14617,
  [14852] = 14659,
  [14853] = 14607,
  [14854] = 14607,
  [14855] = 14742,
  [14856] = 9333,
  [14857] = 14609,
  [14858] = 14617,
  [14859] = 14613,
  [14860] = 14606,
  [14861] = 14231,
  [14862] = 14609,
  [14863] = 14377,
  [14864] = 14606,
  [14865] = 14607,
  [14866] = 14610,
  [14867] = 14488,
  [14868] = 14607,
  [14869] = 7725,
  [14870] = 7857,
  [14871] = 14673,
  [14872] = 14606,
  [14873] = 14607,
  [14874] = 14609,
  [14875] = 9567,
  [14876] = 14876,
  [14877] = 14607,
  [14878] = 14620,
  [14879] = 14879,
  [14880] = 14615,
  [14881] = 8223,
  [14882] = 8215,
  [14883] = 13837,
  [14884] = 14606,
  [14885] = 14607,
  [14886] = 14607,
  [14887] = 14887,
  [14888] = 9541,
  [14889] = 14635,
  [14890] = 14610,
  [14891] = 9539,
  [14892] = 14309,
  [14893] = 14610,
  [14894] = 14610,
  [14895] = 14113,
  [14896] = 14613,
  [14897] = 14615,
  [14898] = 14760,
  [14899] = 14615,
  [14900] = 14278,
  [14901] = 14606,
  [14902] = 14617,
  [14903] = 14615,
  [14904] = 14904,
  [14905] = 14613,
  [14906] = 14635,
  [14907] = 14610,
  [14908] = 14617,
  [14909] = 9550,
  [14910] = 14613,
  [14911] = 14643,
  [14912] = 14615,
  [14913] = 14607,
  [14914] = 14617,
  [14915] = 14607,
  [14916] = 14606,
  [14917] = 14917,
  [14918] = 14918,
  [14919] = 14919,
  [14920] = 14617,
  [14921] = 14623,
  [14922] = 14610,
  [14923] = 14923,
  [14924] = 14615,
  [14925] = 14659,
  [14926] = 14606,
  [14927] = 14927,
  [14928] = 14613,
  [14929] = 14613,
  [14930] = 7857,
  [14931] = 13607,
  [14932] = 14607,
  [14933] = 9531,
  [14934] = 9529,
  [14935] = 14282,
  [14936] = 14623,
  [14937] = 14619,
  [14938] = 9567,
  [14939] = 14606,
  [14940] = 3778,
  [14941] = 14613,
  [14942] = 14623,
  [14943] = 14607,
  [14944] = 14610,
  [14945] = 3737,
  [14946] = 3738,
  [14947] = 3739,
  [14948] = 3742,
  [14949] = 14610,
  [14950] = 14950,
  [14951] = 3743,
  [14952] = 3744,
  [14953] = 14606,
  [14954] = 14607,
  [14955] = 14651,
  [14956] = 3747,
  [14957] = 14617,
  [14958] = 3734,
  [14959] = 14606,
  [14960] = 14617,
  [14961] = 14961,
  [14962] = 14615,
  [14963] = 14610,
  [14964] = 14615,
  [14965] = 3748,
  [14966] = 14609,
  [14967] = 14613,
  [14968] = 14607,
  [14969] = 14613,
  [14970] = 13162,
  [14971] = 14615,
  [14972] = 14972,
  [14973] = 14973,
  [14974] = 3762,
  [14975] = 3774,
  [14976] = 3785,
  [14977] = 14607,
  [14978] = 14617,
  [14979] = 13219,
  [14980] = 14980,
  [14981] = 13833,
  [14982] = 14617,
  [14983] = 14607,
  [14984] = 14606,
  [14985] = 14838,
  [14986] = 14610,
  [14987] = 13829,
  [14988] = 14772,
  [14989] = 3740,
  [14990] = 14990,
  [14991] = 3745,
  [14992] = 3746,
  [14993] = 14993,
  [14994] = 14675,
  [14995] = 14613,
  [14996] = 14607,
  [14997] = 9567,
  [14998] = 14615,
  [14999] = 14830,
  [15000] = 15000,
  [15001] = 14607,
  [15002] = 7725,
  [15003] = 15003,
  [15004] = 14742,
  [15005] = 14623,
  [15006] = 14610,
  [15007] = 14607,
  [15008] = 15008,
  [15009] = 14607,
  [15010] = 14610,
  [15011] = 14828,
  [15012] = 15012,
  [15013] = 15013,
  [15014] = 14609,
  [15015] = 14696,
  [15016] = 14617,
  [15017] = 14609,
  [15018] = 14623,
  [15019] = 14697,
  [15020] = 14615,
  [15021] = 14613,
  [15022] = 14613,
  [15023] = 14706,
  [15024] = 14617,
  [15025] = 14606,
  [15026] = 14613,
  [15027] = 14615,
  [15028] = 14617,
  [15029] = 13675,
  [15030] = 9539,
  [15031] = 14617,
  [15032] = 14606,
  [15033] = 14768,
  [15034] = 14973,
  [15035] = 14738,
  [15036] = 15036,
  [15037] = 14673,
  [15038] = 14610,
  [15039] = 14750,
  [15040] = 14757,
  [15041] = 14768,
  [15042] = 14617,
  [15043] = 14623,
  [15044] = 14615,
  [15045] = 14772,
  [15046] = 14607,
  [15047] = 14055,
  [15048] = 14613,
  [15049] = 15049,
  [15050] = 15050,
  [15051] = 15051,
  [15052] = 14607,
  [15053] = 14777,
  [15054] = 14607,
  [15055] = 15055,
  [15056] = 14961,
  [15057] = 9412,
  [15058] = 14606,
  [15059] = 14606,
  [15060] = 14623,
  [15061] = 13120,
  [15062] = 14607,
  [15063] = 15036,
  [15064] = 15064,
  [15065] = 14839,
  [15066] = 14711,
  [15067] = 3751,
  [15068] = 3760,
  [15069] = 14623,
  [15070] = 14788,
  [15071] = 14609,
  [15072] = 14610,
  [15073] = 14615,
  [15074] = 14613,
  [15075] = 14607,
  [15076] = 13162,
  [15077] = 14606,
  [15078] = 14613,
  [15079] = 9268,
  [15080] = 14607,
  [15081] = 14609,
  [15082] = 14615,
  [15083] = 14607,
  [15084] = 15064,
  [15085] = 14606,
  [15086] = 14309,
  [15087] = 14432,
  [15088] = 15088,
  [15089] = 15089,
  [15090] = 14793,
  [15091] = 14800,
  [15092] = 14607,
  [15093] = 14804,
  [15094] = 14808,
  [15095] = 14623,
  [15096] = 14607,
  [15097] = 14613,
  [15098] = 14615,
  [15099] = 14607,
  [15100] = 14817,
  [15101] = 14617,
  [15102] = 15102,
  [15103] = 14607,
  [15104] = 14623,
  [15105] = 14617,
  [15106] = 9531,
  [15107] = 14609,
  [15108] = 14607,
  [15109] = 14828,
  [15110] = 14610,
  [15111] = 15111,
  [15112] = 14607,
  [15113] = 13957,
  [15114] = 14830,
  [15115] = 14838,
  [15116] = 14607,
  [15117] = 15117,
  [15118] = 15118,
  [15119] = 14333,
  [15120] = 14607,
  [15121] = 14392,
  [15122] = 14610,
  [15123] = 14623,
  [15124] = 14609,
  [15125] = 14610,
  [15126] = 15117,
  [15127] = 14623,
  [15128] = 14076,
  [15129] = 14609,
  [15130] = 14651,
  [15131] = 14607,
  [15132] = 14396,
  [15133] = 15102,
  [15134] = 14607,
  [15135] = 14399,
  [15136] = 9541,
  [15137] = 15137,
  [15138] = 15089,
  [15139] = 14607,
  [15140] = 9539,
  [15141] = 14606,
  [15142] = 14607,
  [15143] = 14617,
  [15144] = 14620,
  [15145] = 9531,
  [15146] = 14623,
  [15147] = 14613,
  [15148] = 14615,
  [15149] = 14617,
  [15150] = 14607,
  [15151] = 14623,
  [15152] = 14823,
  [15153] = 14610,
  [15154] = 14607,
  [15155] = 14466,
  [15156] = 14607,
  [15157] = 13878,
  [15158] = 14635,
  [15159] = 14615,
  [15160] = 14488,
  [15161] = 14607,
  [15162] = 14607,
  [15163] = 14613,
  [15164] = 13934,
  [15165] = 15165,
  [15166] = 14610,
  [15167] = 13120,
  [15168] = 14623,
  [15169] = 14609,
  [15170] = 9523,
  [15171] = 9529,
  [15172] = 9541,
  [15173] = 14606,
  [15174] = 14623,
  [15175] = 15175,
  [15176] = 14918,
  [15177] = 13814,
  [15178] = 14917,
  [15179] = 14606,
  [15180] = 15180,
  [15181] = 13813,
  [15182] = 9539,
  [15183] = 3739,
  [15184] = 13811,
  [15185] = 14712,
  [15186] = 14813,
  [15187] = 14606,
  [15188] = 14427,
  [15189] = 14613,
  [15190] = 14615,
  [15191] = 14610,
  [15192] = 14617,
  [15193] = 9541,
  [15194] = 15194,
  [15195] = 14607,
  [15196] = 14609,
  [15197] = 8215,
  [15198] = 14609,
  [15199] = 14623,
  [15200] = 14610,
  [15201] = 14617,
  [15202] = 14623,
  [15203] = 14758,
  [15204] = 13120,
  [15205] = 15205,
  [15206] = 15206,
  [15207] = 14607,
  [15208] = 14432,
  [15209] = 14879,
  [15210] = 14623,
  [15211] = 14607,
  [15212] = 14788,
  [15213] = 14615,
  [15214] = 14607,
  [15215] = 14613,
  [15216] = 14606,
  [15217] = 9531,
  [15218] = 15218,
  [15219] = 14623,
  [15220] = 3746,
  [15221] = 3745,
  [15222] = 8223,
  [15223] = 3740,
  [15224] = 14606,
  [15225] = 9529,
  [15226] = 3785,
  [15227] = 3774,
  [15228] = 3762,
  [15229] = 14613,
  [15230] = 14607,
  [15231] = 14606,
  [15232] = 14615,
  [15233] = 15233,
  [15234] = 3734,
  [15235] = 3747,
  [15236] = 14613,
  [15237] = 14617,
  [15238] = 14610,
  [15239] = 14617,
  [15240] = 14607,
  [15241] = 3744,
  [15242] = 14623,
  [15243] = 14615,
  [15244] = 3743,
  [15245] = 14610,
  [15246] = 3742,
  [15247] = 9523,
  [15248] = 14793,
  [15249] = 15249,
  [15250] = 14623,
  [15251] = 14607,
  [15252] = 13120,
  [15253] = 14623,
  [15254] = 14615,
  [15255] = 3748,
  [15256] = 14617,
  [15257] = 3737,
  [15258] = 3778,
  [15259] = 14617,
  [15260] = 3738,
  [15261] = 14607,
  [15262] = 14617,
  [15263] = 14607,
  [15264] = 14401,
  [15265] = 15265,
  [15266] = 14609,
  [15267] = 14607,
  [15268] = 14607,
  [15269] = 14607,
  [15270] = 15270,
  [15271] = 14623,
  [15272] = 14615,
  [15273] = 14607,
  [15274] = 7859,
  [15275] = 14615,
  [15276] = 14613,
  [15277] = 14607,
  [15278] = 14607,
  [15279] = 14737,
  [15280] = 14613,
  [15281] = 14738,
  [15282] = 14607,
  [15283] = 14817,
  [15284] = 14606,
  [15285] = 14606,
  [15286] = 14606,
  [15287] = 14610,
  [15288] = 14610,
  [15289] = 14607,
  [15290] = 15290,
  [15291] = 14606,
  [15292] = 14950,
  [15293] = 14620,
  [15294] = 13162,
  [15295] = 14607,
  [15296] = 14659,
  [15297] = 14623,
  [15298] = 14607,
  [15299] = 14613,
  [15300] = 14623,
  [15301] = 14263,
  [15302] = 14613,
  [15303] = 14615,
  [15304] = 14607,
  [15305] = 14615,
  [15306] = 9406,
  [15307] = 3481,
  [15308] = 14432,
  [15309] = 14609,
  [15310] = 14623,
  [15311] = 13755,
  [15312] = 14617,
  [15313] = 14615,
  [15314] = 14279,
  [15315] = 14607,
  [15316] = 14609,
  [15317] = 14635,
  [15318] = 14610,
  [15319] = 14623,
  [15320] = 14607,
  [15321] = 14607,
  [15322] = 14757,
  [15323] = 3562,
  [15324] = 14768,
  [15325] = 14617,
  [15326] = 14607,
  [15327] = 3677,
  [15328] = 14808,
  [15329] = 14610,
  [15330] = 13466,
  [15331] = 14027,
  [15332] = 9406,
  [15333] = 14617,
  [15334] = 14607,
  [15335] = 14607,
  [15336] = 14623,
  [15337] = 15337,
  [15338] = 14457,
  [15339] = 14607,
  [15340] = 14607,
  [15341] = 15290,
  [15342] = 14804,
  [15343] = 9567,
  [15344] = 14617,
  [15345] = 9567,
  [15346] = 14750,
  [15347] = 14607,
  [15348] = 15348,
  [15349] = 14609,
  [15350] = 14615,
  [15351] = 14610,
  [15352] = 14623,
  [15353] = 14609,
  [15354] = 14617,
  [15355] = 14623,
  [15356] = 14623,
  [15357] = 14613,
  [15358] = 14613,
  [15359] = 14800,
  [15360] = 14606,
  [15361] = 14623,
  [15362] = 14768,
  [15363] = 14746,
  [15364] = 14607,
  [15365] = 13162,
  [15366] = 14793,
  [15367] = 14675,
  [15368] = 3543,
  [15369] = 14617,
  [15370] = 14623,
  [15371] = 14606,
  [15372] = 14607,
  [15373] = 14609,
  [15374] = 14775,
  [15375] = 13409,
  [15376] = 14607,
  [15377] = 14613,
  [15378] = 14769,
  [15379] = 14615,
  [15380] = 14606,
  [15381] = 15381,
  [15382] = 14619,
  [15383] = 14990,
  [15384] = 14623,
  [15385] = 14615,
  [15386] = 14607,
  [15387] = 14613,
  [15388] = 14607,
  [15389] = 14613,
  [15390] = 14635,
  [15391] = 14711,
  [15392] = 14610,
  [15393] = 14610,
  [15394] = 14615,
  [15395] = 14623,
  [15396] = 3576,
  [15397] = 14607,
  [15398] = 3489,
  [15399] = 14606,
  [15400] = 9412,
  [15401] = 3549,
  [15402] = 7859,
  [15403] = 14793,
  [15404] = 3577,
  [15405] = 14607,
  [15406] = 3514,
  [15407] = 14617,
  [15408] = 14607,
  [15409] = 3547,
  [15410] = 13785,
  [15411] = 13784,
  [15412] = 3597,
  [15413] = 14610,
  [15414] = 14792,
  [15415] = 3608,
  [15416] = 14214,
  [15417] = 14607,
  [15418] = 3591,
  [15419] = 14220,
  [15420] = 3546,
  [15421] = 14607,
  [15422] = 14609,
  [15423] = 3482,
  [15424] = 3606,
  [15425] = 14607,
  [15426] = 3668,
  [15427] = 14972,
  [15428] = 14617,
  [15429] = 15429,
  [15430] = 15430,
  [15431] = 3468,
  [15432] = 15432,
  [15433] = 14263,
  [15434] = 15434,
  [15435] = 15435,
  [15436] = 15436,
  [15437] = 15437,
  [15438] = 3600,
  [15439] = 15439,
  [15440] = 3692,
  [15441] = 3705,
  [15442] = 3705,
  [15443] = 15443,
  [15444] = 15429,
  [15445] = 3692,
  [15446] = 15443,
  [15447] = 3470,
  [15448] = 15448,
  [15449] = 15449,
  [15450] = 3471,
  [15451] = 15443,
  [15452] = 14699,
  [15453] = 15429,
  [15454] = 15448,
  [15455] = 15449,
  [15456] = 15456,
  [15457] = 15457,
  [15458] = 15458,
  [15459] = 15457,
  [15460] = 15460,
  [15461] = 15448,
  [15462] = 15462,
  [15463] = 15449,
  [15464] = 15460,
  [15465] = 15465,
  [15466] = 15462,
  [15467] = 15465,
  [15468] = 15468,
  [15469] = 12961,
  [15470] = 15470,
  [15471] = 15471,
  [15472] = 15468,
  [15473] = 15470,
  [15474] = 15471,
  [15475] = 15429,
  [15476] = 15476,
  [15477] = 15477,
  [15478] = 15476,
  [15479] = 15456,
  [15480] = 15480,
  [15481] = 15481,
  [15482] = 15482,
  [15483] = 15483,
  [15484] = 15484,
  [15485] = 15485,
  [15486] = 15486,
  [15487] = 15481,
  [15488] = 15488,
  [15489] = 15458,
  [15490] = 15490,
  [15491] = 15482,
  [15492] = 15484,
  [15493] = 15485,
  [15494] = 15486,
  [15495] = 15495,
  [15496] = 15496,
  [15497] = 15497,
  [15498] = 15495,
  [15499] = 15488,
  [15500] = 15432,
  [15501] = 15501,
  [15502] = 15490,
  [15503] = 15490,
  [15504] = 15434,
  [15505] = 15435,
  [15506] = 15436,
  [15507] = 15495,
  [15508] = 15488,
  [15509] = 15497,
  [15510] = 15437,
  [15511] = 15486,
  [15512] = 15485,
  [15513] = 15432,
  [15514] = 15439,
  [15515] = 15484,
  [15516] = 15516,
  [15517] = 15517,
  [15518] = 15518,
  [15519] = 15482,
  [15520] = 15481,
  [15521] = 15437,
  [15522] = 15434,
  [15523] = 15435,
  [15524] = 15477,
  [15525] = 15436,
  [15526] = 15443,
  [15527] = 15476,
  [15528] = 15429,
  [15529] = 15529,
  [15530] = 15530,
  [15531] = 15437,
  [15532] = 15532,
  [15533] = 15439,
  [15534] = 15534,
  [15535] = 15471,
  [15536] = 15470,
  [15537] = 15468,
  [15538] = 15465,
  [15539] = 15462,
  [15540] = 15540,
  [15541] = 15477,
  [15542] = 15460,
  [15543] = 15543,
  [15544] = 15544,
  [15545] = 15545,
  [15546] = 15457,
  [15547] = 15547,
  [15548] = 15548,
  [15549] = 15549,
  [15550] = 15550,
  [15551] = 15457,
  [15552] = 15552,
  [15553] = 15553,
  [15554] = 15554,
  [15555] = 15460,
  [15556] = 15462,
  [15557] = 15465,
  [15558] = 15558,
  [15559] = 15003,
  [15560] = 15560,
  [15561] = 14640,
  [15562] = 15470,
  [15563] = 15563,
  [15564] = 14769,
  [15565] = 15565,
  [15566] = 15566,
  [15567] = 9567,
  [15568] = 15476,
  [15569] = 15457,
  [15570] = 15477,
  [15571] = 15571,
  [15572] = 15572,
  [15573] = 15573,
  [15574] = 15430,
  [15575] = 15575,
  [15576] = 14775,
  [15577] = 15577,
  [15578] = 15578,
  [15579] = 15449,
  [15580] = 15481,
  [15581] = 15448,
  [15582] = 15582,
  [15583] = 15484,
  [15584] = 15485,
  [15585] = 14622,
  [15586] = 15488,
  [15587] = 15587,
  [15588] = 15490,
  [15589] = 15589,
  [15590] = 15590,
  [15591] = 15591,
  [15592] = 15592,
  [15593] = 15495,
  [15594] = 15594,
  [15595] = 15497,
  [15596] = 15013,
  [15597] = 15597,
  [15598] = 15432,
  [15599] = 15429,
  [15600] = 9529,
  [15601] = 15443,
  [15602] = 15434,
  [15603] = 15435,
  [15604] = 15604,
  [15605] = 15605,
  [15606] = 15460,
  [15607] = 15437,
  [15608] = 15439,
  [15609] = 15609,
  [15610] = 12739,
  [15611] = 15439,
  [15612] = 15612,
  [15613] = 15613,
  [15614] = 15443,
  [15615] = 15462,
  [15616] = 15429,
  [15617] = 15468,
  [15618] = 15436,
  [15619] = 15435,
  [15620] = 15434,
  [15621] = 15465,
  [15622] = 14813,
  [15623] = 15443,
  [15624] = 15432,
  [15625] = 15429,
  [15626] = 15448,
  [15627] = 15497,
  [15628] = 15449,
  [15629] = 15468,
  [15630] = 15495,
  [15631] = 15456,
  [15632] = 15632,
  [15633] = 15470,
  [15634] = 15490,
  [15635] = 15458,
  [15636] = 15488,
  [15637] = 15471,
  [15638] = 15486,
  [15639] = 15639,
  [15640] = 15457,
  [15641] = 15457,
  [15642] = 15485,
  [15643] = 15484,
  [15644] = 15460,
  [15645] = 15462,
  [15646] = 15465,
  [15647] = 15468,
  [15648] = 15470,
  [15649] = 15471,
  [15650] = 15460,
  [15651] = 15462,
  [15652] = 15465,
  [15653] = 15482,
  [15654] = 15481,
  [15655] = 15655,
  [15656] = 15656,
  [15657] = 15470,
  [15658] = 15476,
  [15659] = 15477,
  [15660] = 15660,
  [15661] = 15476,
  [15662] = 15480,
  [15663] = 15476,
  [15664] = 15483,
  [15665] = 15477,
  [15666] = 12792,
  [15667] = 15477,
  [15668] = 15477,
  [15669] = 15476,
  [15670] = 15481,
  [15671] = 14612,
  [15672] = 15482,
  [15673] = 15484,
  [15674] = 15485,
  [15675] = 15481,
  [15676] = 15486,
  [15677] = 15488,
  [15678] = 15484,
  [15679] = 15485,
  [15680] = 15490,
  [15681] = 15488,
  [15682] = 15495,
  [15683] = 15490,
  [15684] = 15497,
  [15685] = 15685,
  [15686] = 15432,
  [15687] = 15471,
  [15688] = 15495,
  [15689] = 15517,
  [15690] = 15497,
  [15691] = 15470,
  [15692] = 15518,
  [15693] = 15432,
  [15694] = 15694,
  [15695] = 15435,
  [15696] = 15465,
  [15697] = 15434,
  [15698] = 15435,
  [15699] = 15462,
  [15700] = 15700,
  [15701] = 15436,
  [15702] = 15437,
  [15703] = 15460,
  [15704] = 15530,
  [15705] = 15437,
  [15706] = 15439,
  [15707] = 15439,
  [15708] = 15708,
  [15709] = 15534,
  [15710] = 15540,
  [15711] = 15560,
  [15712] = 15543,
  [15713] = 15544,
  [15714] = 15545,
  [15715] = 15457,
  [15716] = 15716,
  [15717] = 15717,
  [15718] = 15443,
  [15719] = 15547,
  [15720] = 15429,
  [15721] = 15721,
  [15722] = 15722,
  [15723] = 15549,
  [15724] = 15724,
  [15725] = 15725,
  [15726] = 15726,
  [15727] = 15550,
  [15728] = 15728,
  [15729] = 15554,
  [15730] = 15730,
  [15731] = 15594,
  [15732] = 15563,
  [15733] = 15480,
  [15734] = 15734,
  [15735] = 15565,
  [15736] = 15457,
  [15737] = 15566,
  [15738] = 15738,
  [15739] = 15739,
  [15740] = 15740,
  [15741] = 15571,
  [15742] = 15572,
  [15743] = 15434,
  [15744] = 15744,
  [15745] = 15460,
  [15746] = 15462,
  [15747] = 15465,
  [15748] = 15488,
  [15749] = 15749,
  [15750] = 15750,
  [15751] = 15751,
  [15752] = 15470,
  [15753] = 15575,
  [15754] = 15449,
  [15755] = 15577,
  [15756] = 15578,
  [15757] = 15582,
  [15758] = 15476,
  [15759] = 15759,
  [15760] = 15477,
  [15761] = 15761,
  [15762] = 15587,
  [15763] = 15448,
  [15764] = 15764,
  [15765] = 15765,
  [15766] = 15766,
  [15767] = 15589,
  [15768] = 15591,
  [15769] = 15592,
  [15770] = 15481,
  [15771] = 15573,
  [15772] = 15772,
  [15773] = 15484,
  [15774] = 15485,
  [15775] = 15597,
  [15776] = 15488,
  [15777] = 15605,
  [15778] = 15490,
  [15779] = 15443,
  [15780] = 15780,
  [15781] = 15781,
  [15782] = 15483,
  [15783] = 15495,
  [15784] = 15429,
  [15785] = 15497,
  [15786] = 15429,
  [15787] = 15448,
  [15788] = 15432,
  [15789] = 15449,
  [15790] = 15458,
  [15791] = 15791,
  [15792] = 15434,
  [15793] = 15435,
  [15794] = 15443,
  [15795] = 15795,
  [15796] = 15457,
  [15797] = 15437,
  [15798] = 15460,
  [15799] = 14488,
  [15800] = 15462,
  [15801] = 15439,
  [15802] = 15465,
  [15803] = 15468,
  [15804] = 15470,
  [15805] = 15471,
  [15806] = 15439,
  [15807] = 15476,
  [15808] = 15808,
  [15809] = 15437,
  [15810] = 15436,
  [15811] = 15477,
  [15812] = 15812,
  [15813] = 15443,
  [15814] = 15435,
  [15815] = 15429,
  [15816] = 15639,
  [15817] = 15481,
  [15818] = 15482,
  [15819] = 15819,
  [15820] = 15820,
  [15821] = 15821,
  [15822] = 15434,
  [15823] = 15823,
  [15824] = 15481,
  [15825] = 15432,
  [15826] = 15826,
  [15827] = 15484,
  [15828] = 15497,
  [15829] = 15485,
  [15830] = 15486,
  [15831] = 15457,
  [15832] = 14333,
  [15833] = 15482,
  [15834] = 15834,
  [15835] = 15488,
  [15836] = 15836,
  [15837] = 15837,
  [15838] = 15838,
  [15839] = 15490,
  [15840] = 15460,
  [15841] = 15462,
  [15842] = 15465,
  [15843] = 15495,
  [15844] = 15844,
  [15845] = 15845,
  [15846] = 15846,
  [15847] = 15470,
  [15848] = 15848,
  [15849] = 15495,
  [15850] = 15497,
  [15851] = 15851,
  [15852] = 15432,
  [15853] = 15476,
  [15854] = 9523,
  [15855] = 15477,
  [15856] = 15856,
  [15857] = 15434,
  [15858] = 15055,
  [15859] = 15435,
  [15860] = 15436,
  [15861] = 15437,
  [15862] = 15439,
  [15863] = 15863,
  [15864] = 15490,
  [15865] = 15481,
  [15866] = 15549,
  [15867] = 15867,
  [15868] = 15484,
  [15869] = 15485,
  [15870] = 15870,
  [15871] = 15488,
  [15872] = 15484,
  [15873] = 15490,
  [15874] = 15566,
  [15875] = 15575,
  [15876] = 15591,
  [15877] = 15877,
  [15878] = 15495,
  [15879] = 15443,
  [15880] = 15497,
  [15881] = 15429,
  [15882] = 15485,
  [15883] = 15432,
  [15884] = 15448,
  [15885] = 15449,
  [15886] = 15486,
  [15887] = 15434,
  [15888] = 15435,
  [15889] = 15485,
  [15890] = 15457,
  [15891] = 15484,
  [15892] = 15437,
  [15893] = 15893,
  [15894] = 15482,
  [15895] = 15481,
  [15896] = 15439,
  [15897] = 15486,
  [15898] = 15460,
  [15899] = 15462,
  [15900] = 15465,
  [15901] = 15468,
  [15902] = 15477,
  [15903] = 14760,
  [15904] = 15476,
  [15905] = 15470,
  [15906] = 15471,
  [15907] = 15476,
  [15908] = 15443,
  [15909] = 15477,
  [15910] = 15429,
  [15911] = 15911,
  [15912] = 15488,
  [15913] = 15481,
  [15914] = 15111,
  [15915] = 15915,
  [15916] = 15916,
  [15917] = 15471,
  [15918] = 15918,
  [15919] = 15470,
  [15920] = 15482,
  [15921] = 15921,
  [15922] = 15922,
  [15923] = 15468,
  [15924] = 15484,
  [15925] = 15925,
  [15926] = 15457,
  [15927] = 15465,
  [15928] = 15485,
  [15929] = 14076,
  [15930] = 15930,
  [15931] = 15486,
  [15932] = 15932,
  [15933] = 15488,
  [15934] = 15490,
  [15935] = 15460,
  [15936] = 15462,
  [15937] = 15465,
  [15938] = 15462,
  [15939] = 15939,
  [15940] = 15495,
  [15941] = 15941,
  [15942] = 15470,
  [15943] = 15497,
  [15944] = 15460,
  [15945] = 15432,
  [15946] = 15490,
  [15947] = 15434,
  [15948] = 15476,
  [15949] = 15949,
  [15950] = 15477,
  [15951] = 15951,
  [15952] = 15458,
  [15953] = 15436,
  [15954] = 15437,
  [15955] = 15955,
  [15956] = 15956,
  [15957] = 15439,
  [15958] = 15549,
  [15959] = 15435,
  [15960] = 15481,
  [15961] = 3468,
  [15962] = 15443,
  [15963] = 15484,
  [15964] = 15485,
  [15965] = 15429,
  [15966] = 15488,
  [15967] = 15448,
  [15968] = 15490,
  [15969] = 15449,
  [15970] = 15458,
  [15971] = 15971,
  [15972] = 15457,
  [15973] = 15495,
  [15974] = 15457,
  [15975] = 15497,
  [15976] = 15976,
  [15977] = 15460,
  [15978] = 15432,
  [15979] = 15462,
  [15980] = 15465,
  [15981] = 15468,
  [15982] = 15434,
  [15983] = 15435,
  [15984] = 15470,
  [15985] = 15985,
  [15986] = 15986,
  [15987] = 15437,
  [15988] = 14927,
  [15989] = 15449,
  [15990] = 15448,
  [15991] = 15439,
  [15992] = 15471,
  [15993] = 15993,
  [15994] = 15994,
  [15995] = 15476,
  [15996] = 13607,
  [15997] = 15997,
  [15998] = 15998,
  [15999] = 15477,
  [16000] = 15429,
  [16001] = 15495,
  [16002] = 15443,
  [16003] = 15443,
  [16004] = 15497,
  [16005] = 15429,
  [16006] = 16006,
  [16007] = 15481,
  [16008] = 15482,
  [16009] = 15484,
  [16010] = 15485,
  [16011] = 15486,
  [16012] = 14950,
  [16013] = 15439,
  [16014] = 15437,
  [16015] = 15436,
  [16016] = 15435,
  [16017] = 15434,
  [16018] = 15432,
  [16019] = 15488,
  [16020] = 15432,
  [16021] = 15457,
  [16022] = 15490,
  [16023] = 16023,
  [16024] = 15575,
  [16025] = 15495,
  [16026] = 15497,
  [16027] = 16027,
  [16028] = 15432,
  [16029] = 15434,
  [16030] = 15460,
  [16031] = 15462,
  [16032] = 15465,
  [16033] = 15497,
  [16034] = 15435,
  [16035] = 16035,
  [16036] = 16036,
  [16037] = 15470,
  [16038] = 15437,
  [16039] = 15495,
  [16040] = 15439,
  [16041] = 16041,
  [16042] = 13162,
  [16043] = 15476,
  [16044] = 13120,
  [16045] = 15477,
  [16046] = 16046,
  [16047] = 15443,
  [16048] = 15490,
  [16049] = 16049,
  [16050] = 16050,
  [16051] = 15429,
  [16052] = 15448,
  [16053] = 15488,
  [16054] = 15449,
  [16055] = 15481,
  [16056] = 15486,
  [16057] = 16057,
  [16058] = 15484,
  [16059] = 15485,
  [16060] = 9529,
  [16061] = 15488,
  [16062] = 9523,
  [16063] = 15490,
  [16064] = 16064,
  [16065] = 15458,
  [16066] = 15485,
  [16067] = 15484,
  [16068] = 15495,
  [16069] = 16069,
  [16070] = 15497,
  [16071] = 15457,
  [16072] = 15517,
  [16073] = 15432,
  [16074] = 14466,
  [16075] = 15482,
  [16076] = 15481,
  [16077] = 15434,
  [16078] = 15435,
  [16079] = 15460,
  [16080] = 14827,
  [16081] = 14972,
  [16082] = 15437,
  [16083] = 15462,
  [16084] = 14973,
  [16085] = 16085,
  [16086] = 15439,
  [16087] = 15477,
  [16088] = 16088,
  [16089] = 15465,
  [16090] = 15468,
  [16091] = 15476,
  [16092] = 15470,
  [16093] = 15471,
  [16094] = 15476,
  [16095] = 16095,
  [16096] = 15471,
  [16097] = 15470,
  [16098] = 15443,
  [16099] = 16099,
  [16100] = 15429,
  [16101] = 16101,
  [16102] = 15468,
  [16103] = 15477,
  [16104] = 15205,
  [16105] = 15436,
  [16106] = 15465,
  [16107] = 15481,
  [16108] = 15462,
  [16109] = 15482,
  [16110] = 16110,
  [16111] = 15460,
  [16112] = 15484,
  [16113] = 16113,
  [16114] = 15485,
  [16115] = 15486,
  [16116] = 15457,
  [16117] = 16117,
  [16118] = 16118,
  [16119] = 16119,
  [16120] = 16120,
  [16121] = 15488,
  [16122] = 15490,
  [16123] = 16123,
  [16124] = 16124,
  [16125] = 15460,
  [16126] = 15462,
  [16127] = 15465,
  [16128] = 15495,
  [16129] = 16129,
  [16130] = 15497,
  [16131] = 15432,
  [16132] = 15470,
  [16133] = 15434,
  [16134] = 15435,
  [16135] = 15436,
  [16136] = 15437,
  [16137] = 15439,
  [16138] = 15476,
  [16139] = 16139,
  [16140] = 15477,
  [16141] = 16141,
  [16142] = 16142,
  [16143] = 15457,
  [16144] = 16144,
  [16145] = 15518,
  [16146] = 15443,
  [16147] = 15429,
  [16148] = 16148,
  [16149] = 15448,
  [16150] = 15481,
  [16151] = 15449,
  [16152] = 16152,
  [16153] = 15484,
  [16154] = 15485,
  [16155] = 15457,
  [16156] = 15488,
  [16157] = 15460,
  [16158] = 15490,
  [16159] = 16159,
  [16160] = 16160,
  [16161] = 15488,
  [16162] = 15462,
  [16163] = 15495,
  [16164] = 15458,
  [16165] = 15497,
  [16166] = 15449,
  [16167] = 15465,
  [16168] = 15432,
  [16169] = 15468,
  [16170] = 15448,
  [16171] = 15470,
  [16172] = 15434,
  [16173] = 15435,
  [16174] = 16174,
  [16175] = 15471,
  [16176] = 16176,
  [16177] = 15437,
  [16178] = 15429,
  [16179] = 13675,
  [16180] = 15443,
  [16181] = 15439,
  [16182] = 16182,
  [16183] = 15476,
  [16184] = 15477,
  [16185] = 15481,
  [16186] = 15482,
  [16187] = 16187,
  [16188] = 15484,
  [16189] = 15485,
  [16190] = 15486,
  [16191] = 15488,
  [16192] = 15435,
  [16193] = 15443,
  [16194] = 15490,
  [16195] = 15429,
  [16196] = 16196,
  [16197] = 15495,
  [16198] = 15436,
  [16199] = 16199,
  [16200] = 16200,
  [16201] = 15439,
  [16202] = 15497,
  [16203] = 15437,
  [16204] = 15436,
  [16205] = 16205,
  [16206] = 16206,
  [16207] = 15435,
  [16208] = 14401,
  [16209] = 15432,
  [16210] = 15175,
  [16211] = 15457,
  [16212] = 15434,
  [16213] = 15434,
  [16214] = 16214,
  [16215] = 15435,
  [16216] = 15436,
  [16217] = 15437,
  [16218] = 15439,
  [16219] = 15530,
  [16220] = 15460,
  [16221] = 15462,
  [16222] = 15465,
  [16223] = 15432,
  [16224] = 14876,
  [16225] = 13162,
  [16226] = 14845,
  [16227] = 15470,
  [16228] = 13120,
  [16229] = 15497,
  [16230] = 16230,
  [16231] = 15180,
  [16232] = 16232,
  [16233] = 15476,
  [16234] = 9541,
  [16235] = 15477,
  [16236] = 9539,
  [16237] = 15443,
  [16238] = 15495,
  [16239] = 14961,
  [16240] = 15437,
  [16241] = 16241,
  [16242] = 15429,
  [16243] = 15448,
  [16244] = 15490,
  [16245] = 15481,
  [16246] = 15449,
  [16247] = 3760,
  [16248] = 15484,
  [16249] = 15485,
  [16250] = 9531,
  [16251] = 15488,
  [16252] = 9529,
  [16253] = 15490,
  [16254] = 15458,
  [16255] = 15457,
  [16256] = 16256,
  [16257] = 16257,
  [16258] = 15495,
  [16259] = 15462,
  [16260] = 15497,
  [16261] = 15465,
  [16262] = 15468,
  [16263] = 15432,
  [16264] = 15486,
  [16265] = 15485,
  [16266] = 15484,
  [16267] = 15434,
  [16268] = 15435,
  [16269] = 16257,
  [16270] = 15482,
  [16271] = 16256,
  [16272] = 15437,
  [16273] = 15481,
  [16274] = 15470,
  [16275] = 15036,
  [16276] = 15439,
  [16277] = 15471,
  [16278] = 16278,
  [16279] = 15434,
  [16280] = 15476,
  [16281] = 15477,
  [16282] = 15476,
  [16283] = 15477,
  [16284] = 15612,
  [16285] = 15481,
  [16286] = 15482,
  [16287] = 15471,
  [16288] = 15443,
  [16289] = 15470,
  [16290] = 15429,
  [16291] = 15180,
  [16292] = 15468,
  [16293] = 15484,
  [16294] = 15465,
  [16295] = 16214,
  [16296] = 15175,
  [16297] = 15485,
  [16298] = 14432,
  [16299] = 15462,
  [16300] = 15486,
  [16301] = 15460,
  [16302] = 15488,
  [16303] = 15490,
  [16304] = 16241,
  [16305] = 16305,
  [16306] = 15457,
  [16307] = 16278,
  [16308] = 16308,
  [16309] = 16176,
  [16310] = 16124,
  [16311] = 15495,
  [16312] = 15870,
  [16313] = 15497,
  [16314] = 16314,
  [16315] = 15460,
  [16316] = 15462,
  [16317] = 15465,
  [16318] = 15432,
  [16319] = 16174,
  [16320] = 15612,
  [16321] = 15434,
  [16322] = 15470,
  [16323] = 15435,
  [16324] = 15436,
  [16325] = 15437,
  [16326] = 15439,
  [16327] = 16327,
  [16328] = 15476,
  [16329] = 15457,
  [16330] = 15477,
  [16331] = 15443,
  [16332] = 15429,
  [16333] = 15460,
  [16334] = 16148,
  [16335] = 16152,
  [16336] = 15448,
  [16337] = 13120,
  [16338] = 15439,
  [16339] = 14927,
  [16340] = 15481,
  [16341] = 15449,
  [16342] = 15458,
  [16343] = 15484,
  [16344] = 15485,
  [16345] = 16345,
  [16346] = 15488,
  [16347] = 15534,
  [16348] = 15490,
  [16349] = 15457,
  [16350] = 16206,
  [16351] = 13957,
  [16352] = 15497,
  [16353] = 15495,
  [16354] = 16205,
  [16355] = 15497,
  [16356] = 15460,
  [16357] = 15462,
  [16358] = 15432,
  [16359] = 16142,
  [16360] = 16200,
  [16361] = 15449,
  [16362] = 15434,
  [16363] = 15435,
  [16364] = 16305,
  [16365] = 15448,
  [16366] = 16139,
  [16367] = 15437,
  [16368] = 16278,
  [16369] = 16308,
  [16370] = 16199,
  [16371] = 15439,
  [16372] = 16124,
  [16373] = 15117,
  [16374] = 15468,
  [16375] = 15470,
  [16376] = 15429,
  [16377] = 16123,
  [16378] = 15471,
  [16379] = 15443,
  [16380] = 15102,
  [16381] = 15089,
  [16382] = 16120,
  [16383] = 15443,
  [16384] = 15465,
  [16385] = 15429,
  [16386] = 16119,
  [16387] = 16118,
  [16388] = 15870,
  [16389] = 15476,
  [16390] = 16110,
  [16391] = 15612,
  [16392] = 15477,
  [16393] = 13162,
  [16394] = 15481,
  [16395] = 15482,
  [16396] = 16064,
  [16397] = 16057,
  [16398] = 16196,
  [16399] = 15540,
  [16400] = 15484,
  [16401] = 15457,
  [16402] = 15560,
  [16403] = 16046,
  [16404] = 15485,
  [16405] = 15486,
  [16406] = 15488,
  [16407] = 16407,
  [16408] = 16408,
  [16409] = 15490,
  [16410] = 15460,
  [16411] = 15462,
  [16412] = 15465,
  [16413] = 15462,
  [16414] = 15439,
  [16415] = 16041,
  [16416] = 15460,
  [16417] = 15470,
  [16418] = 15429,
  [16419] = 13878,
  [16420] = 15443,
  [16421] = 15462,
  [16422] = 15460,
  [16423] = 15476,
  [16424] = 15437,
  [16425] = 15477,
  [16426] = 14111,
  [16427] = 15429,
  [16428] = 15495,
  [16429] = 15436,
  [16430] = 15435,
  [16431] = 15434,
  [16432] = 15443,
  [16433] = 15462,
  [16434] = 15064,
  [16435] = 15481,
  [16436] = 15460,
  [16437] = 15429,
  [16438] = 15484,
  [16439] = 15485,
  [16440] = 15497,
  [16441] = 15488,
  [16442] = 15443,
  [16443] = 15490,
  [16444] = 15462,
  [16445] = 15460,
  [16446] = 15290,
  [16447] = 15432,
  [16448] = 15495,
  [16449] = 15429,
  [16450] = 15497,
  [16451] = 15432,
  [16452] = 15443,
  [16453] = 15432,
  [16454] = 15497,
  [16455] = 15462,
  [16456] = 15495,
  [16457] = 15434,
  [16458] = 15435,
  [16459] = 15460,
  [16460] = 15985,
  [16461] = 15429,
  [16462] = 15437,
  [16463] = 15443,
  [16464] = 15434,
  [16465] = 15490,
  [16466] = 15439,
  [16467] = 15976,
  [16468] = 15462,
  [16469] = 15460,
  [16470] = 15429,
  [16471] = 15488,
  [16472] = 15435,
  [16473] = 15486,
  [16474] = 15485,
  [16475] = 15484,
  [16476] = 15443,
  [16477] = 15482,
  [16478] = 15443,
  [16479] = 15481,
  [16480] = 15429,
  [16481] = 15971,
  [16482] = 15465,
  [16483] = 15462,
  [16484] = 15460,
  [16485] = 15429,
  [16486] = 15477,
  [16487] = 14918,
  [16488] = 15476,
  [16489] = 15437,
  [16490] = 15443,
  [16491] = 15439,
  [16492] = 15462,
  [16493] = 15471,
  [16494] = 15460,
  [16495] = 15429,
  [16496] = 15457,
  [16497] = 15470,
  [16498] = 14917,
  [16499] = 15348,
  [16500] = 15443,
  [16501] = 15462,
  [16502] = 15460,
  [16503] = 15429,
  [16504] = 15443,
  [16505] = 15460,
  [16506] = 15462,
  [16507] = 15465,
  [16508] = 15468,
  [16509] = 15462,
  [16510] = 15460,
  [16511] = 15337,
  [16512] = 15470,
  [16513] = 15429,
  [16514] = 15448,
  [16515] = 15443,
  [16516] = 15436,
  [16517] = 15462,
  [16518] = 15476,
  [16519] = 15460,
  [16520] = 15477,
  [16521] = 15429,
  [16522] = 15443,
  [16523] = 15462,
  [16524] = 15111,
  [16525] = 15429,
  [16526] = 15460,
  [16527] = 15462,
  [16528] = 15460,
  [16529] = 15429,
  [16530] = 15481,
  [16531] = 15443,
  [16532] = 15462,
  [16533] = 15484,
  [16534] = 15485,
  [16535] = 15460,
  [16536] = 15488,
  [16537] = 15429,
  [16538] = 15490,
  [16539] = 15448,
  [16540] = 15443,
  [16541] = 15449,
  [16542] = 15462,
  [16543] = 15495,
  [16544] = 15460,
  [16545] = 15497,
  [16546] = 15429,
  [16547] = 15458,
  [16548] = 15432,
  [16549] = 15443,
  [16550] = 15462,
  [16551] = 15457,
  [16552] = 15434,
  [16553] = 15435,
  [16554] = 15460,
  [16555] = 15429,
  [16556] = 15443,
  [16557] = 15437,
  [16558] = 15462,
  [16559] = 15460,
  [16560] = 15429,
  [16561] = 15439,
  [16562] = 15443,
  [16563] = 15457,
  [16564] = 15462,
  [16565] = 15460,
  [16566] = 15429,
  [16567] = 15443,
  [16568] = 15443,
  [16569] = 15462,
  [16570] = 15460,
  [16571] = 14879,
  [16572] = 15055,
  [16573] = 15443,
  [16574] = 15429,
  [16575] = 15429,
  [16576] = 15443,
  [16577] = 15449,
  [16578] = 15460,
  [16579] = 15837,
  [16580] = 15462,
  [16581] = 15436,
  [16582] = 15460,
  [16583] = 15462,
  [16584] = 15429,
  [16585] = 15443,
  [16586] = 15465,
  [16587] = 15462,
  [16588] = 15460,
  [16589] = 15468,
  [16590] = 15429,
  [16591] = 15457,
  [16592] = 15808,
  [16593] = 15470,
  [16594] = 15429,
  [16595] = 15443,
  [16596] = 15471,
  [16597] = 15462,
  [16598] = 15460,
  [16599] = 15429,
  [16600] = 15460,
  [16601] = 15462,
  [16602] = 15465,
  [16603] = 15443,
  [16604] = 15443,
  [16605] = 12792,
  [16606] = 15795,
  [16607] = 15470,
  [16608] = 15462,
  [16609] = 15460,
  [16610] = 15476,
  [16611] = 15429,
  [16612] = 15443,
  [16613] = 15476,
  [16614] = 15477,
  [16615] = 15477,
  [16616] = 7859,
  [16617] = 15462,
  [16618] = 15460,
  [16619] = 15780,
  [16620] = 15429,
  [16621] = 15772,
  [16622] = 15443,
  [16623] = 15462,
  [16624] = 15460,
  [16625] = 15481,
  [16626] = 15439,
  [16627] = 15481,
  [16628] = 15484,
  [16629] = 15485,
  [16630] = 15482,
  [16631] = 15488,
  [16632] = 15429,
  [16633] = 15490,
  [16634] = 15443,
  [16635] = 15484,
  [16636] = 15437,
  [16637] = 15497,
  [16638] = 15495,
  [16639] = 15495,
  [16640] = 15497,
  [16641] = 15013,
  [16642] = 15485,
  [16643] = 15432,
  [16644] = 15435,
  [16645] = 15434,
  [16646] = 15477,
  [16647] = 15434,
  [16648] = 15435,
  [16649] = 15432,
  [16650] = 15744,
  [16651] = 15476,
  [16652] = 15437,
  [16653] = 15740,
  [16654] = 15497,
  [16655] = 15734,
  [16656] = 15439,
  [16657] = 15462,
  [16658] = 15460,
  [16659] = 15486,
  [16660] = 15429,
  [16661] = 15495,
  [16662] = 15716,
  [16663] = 9406,
  [16664] = 15443,
  [16665] = 15497,
  [16666] = 15490,
  [16667] = 12961,
  [16668] = 15443,
  [16669] = 15495,
  [16670] = 15429,
  [16671] = 15488,
  [16672] = 15490,
  [16673] = 15477,
  [16674] = 15708,
  [16675] = 15486,
  [16676] = 15485,
  [16677] = 15484,
  [16678] = 15476,
  [16679] = 15482,
  [16680] = 15481,
  [16681] = 15462,
  [16682] = 15460,
  [16683] = 14990,
  [16684] = 16684,
  [16685] = 15495,
  [16686] = 15457,
  [16687] = 9242,
  [16688] = 15003,
  [16689] = 15429,
  [16690] = 15497,
  [16691] = 15443,
  [16692] = 15497,
  [16693] = 15495,
  [16694] = 15432,
  [16695] = 15460,
  [16696] = 15462,
  [16697] = 15465,
  [16698] = 15477,
  [16699] = 15476,
  [16700] = 15477,
  [16701] = 15655,
  [16702] = 15470,
  [16703] = 15476,
  [16704] = 15462,
  [16705] = 15460,
  [16706] = 15434,
  [16707] = 15435,
  [16708] = 15476,
  [16709] = 15436,
  [16710] = 15477,
  [16711] = 15429,
  [16712] = 15437,
  [16713] = 15471,
  [16714] = 15470,
  [16715] = 15443,
  [16716] = 15468,
  [16717] = 15439,
  [16718] = 15465,
  [16719] = 15497,
  [16720] = 15481,
  [16721] = 13104,
  [16722] = 15495,
  [16723] = 15484,
  [16724] = 15485,
  [16725] = 15477,
  [16726] = 15488,
  [16727] = 15476,
  [16728] = 15490,
  [16729] = 15462,
  [16730] = 15460,
  [16731] = 15462,
  [16732] = 7388,
  [16733] = 15495,
  [16734] = 15543,
  [16735] = 15497,
  [16736] = 16308,
  [16737] = 15488,
  [16738] = 15432,
  [16739] = 15460,
  [16740] = 15429,
  [16741] = 15443,
  [16742] = 15434,
  [16743] = 15435,
  [16744] = 15497,
  [16745] = 15495,
  [16746] = 9523,
  [16747] = 15437,
  [16748] = 15477,
  [16749] = 15457,
  [16750] = 15476,
  [16751] = 15439,
  [16752] = 15462,
  [16753] = 15460,
  [16754] = 16182,
  [16755] = 15443,
  [16756] = 15013,
  [16757] = 15429,
  [16758] = 15429,
  [16759] = 15449,
  [16760] = 15448,
  [16761] = 15429,
  [16762] = 14990,
  [16763] = 15443,
  [16764] = 15443,
  [16765] = 15429,
  [16766] = 14622,
  [16767] = 15497,
  [16768] = 15495,
  [16769] = 15477,
  [16770] = 15443,
  [16771] = 15055,
  [16772] = 15111,
  [16773] = 15476,
  [16774] = 15462,
  [16775] = 15460,
  [16776] = 15003,
  [16777] = 16278,
  [16778] = 15449,
  [16779] = 15458,
  [16780] = 15429,
  [16781] = 15457,
  [16782] = 15443,
  [16783] = 15439,
  [16784] = 15497,
  [16785] = 15495,
  [16786] = 15457,
  [16787] = 15477,
  [16788] = 15476,
  [16789] = 15462,
  [16790] = 15460,
  [16791] = 15462,
  [16792] = 15465,
  [16793] = 15437,
  [16794] = 15460,
  [16795] = 15436,
  [16796] = 15532,
  [16797] = 15470,
  [16798] = 16187,
  [16799] = 15435,
  [16800] = 15429,
  [16801] = 15443,
  [16802] = 15460,
  [16803] = 15476,
  [16804] = 15434,
  [16805] = 15477,
  [16806] = 12739,
  [16807] = 15497,
  [16808] = 15290,
  [16809] = 15501,
  [16810] = 15604,
  [16811] = 15496,
  [16812] = 15495,
  [16813] = 15544,
  [16814] = 15432,
  [16815] = 15481,
  [16816] = 15477,
  [16817] = 15476,
  [16818] = 15484,
  [16819] = 15485,
  [16820] = 15462,
  [16821] = 15488,
  [16822] = 15460,
  [16823] = 15490,
  [16824] = 15462,
  [16825] = 15465,
  [16826] = 15497,
  [16827] = 15468,
  [16828] = 15495,
  [16829] = 15470,
  [16830] = 15497,
  [16831] = 15495,
  [16832] = 15429,
  [16833] = 15432,
  [16834] = 15471,
  [16835] = 15443,
  [16836] = 9228,
  [16837] = 15434,
  [16838] = 15435,
  [16839] = 15490,
  [16840] = 15497,
  [16841] = 15488,
  [16842] = 15437,
  [16843] = 15495,
  [16844] = 15486,
  [16845] = 15485,
  [16846] = 15439,
  [16847] = 15484,
  [16848] = 15477,
  [16849] = 15476,
  [16850] = 15462,
  [16851] = 15482,
  [16852] = 16852,
  [16853] = 15481,
  [16854] = 15460,
  [16855] = 16144,
  [16856] = 15477,
  [16857] = 9412,
  [16858] = 15443,
  [16859] = 15476,
  [16860] = 15429,
  [16861] = 15476,
  [16862] = 16862,
  [16863] = 15429,
  [16864] = 15477,
  [16865] = 15443,
  [16866] = 15471,
  [16867] = 15470,
  [16868] = 15468,
  [16869] = 15465,
  [16870] = 15497,
  [16871] = 15462,
  [16872] = 15495,
  [16873] = 15460,
  [16874] = 16141,
  [16875] = 15477,
  [16876] = 15457,
  [16877] = 15476,
  [16878] = 15462,
  [16879] = 15460,
  [16880] = 15481,
  [16881] = 15482,
  [16882] = 15448,
  [16883] = 15484,
  [16884] = 15485,
  [16885] = 15460,
  [16886] = 15462,
  [16887] = 15465,
  [16888] = 15429,
  [16889] = 14699,
  [16890] = 15486,
  [16891] = 15457,
  [16892] = 15470,
  [16893] = 15443,
  [16894] = 15175,
  [16895] = 15497,
  [16896] = 15495,
  [16897] = 16897,
  [16898] = 15476,
  [16899] = 15477,
  [16900] = 15477,
  [16901] = 15476,
  [16902] = 15462,
  [16903] = 15460,
  [16904] = 15545,
  [16905] = 15180,
  [16906] = 14401,
  [16907] = 15488,
  [16908] = 15449,
  [16909] = 15448,
  [16910] = 15481,
  [16911] = 15429,
  [16912] = 15490,
  [16913] = 15484,
  [16914] = 15485,
  [16915] = 15443,
  [16916] = 15488,
  [16917] = 15497,
  [16918] = 15490,
  [16919] = 15495,
  [16920] = 15495,
  [16921] = 15477,
  [16922] = 15429,
  [16923] = 15495,
  [16924] = 15476,
  [16925] = 15497,
  [16926] = 15462,
  [16927] = 15460,
  [16928] = 15432,
  [16929] = 15205,
  [16930] = 15443,
  [16931] = 14466,
  [16932] = 15434,
  [16933] = 15435,
  [16934] = 14076,
  [16935] = 16935,
  [16936] = 16936,
  [16937] = 15437,
  [16938] = 15700,
  [16939] = 14333,
  [16940] = 15722,
  [16941] = 15439,
  [16942] = 15724,
  [16943] = 15725,
  [16944] = 15547,
  [16945] = 15497,
  [16946] = 15726,
  [16947] = 15728,
  [16948] = 16129,
  [16949] = 15429,
  [16950] = 15432,
  [16951] = 15730,
  [16952] = 14699,
  [16953] = 15443,
  [16954] = 15443,
  [16955] = 15429,
  [16956] = 15497,
  [16957] = 16957,
  [16958] = 15495,
  [16959] = 16959,
  [16960] = 15613,
  [16961] = 15435,
  [16962] = 15477,
  [16963] = 16963,
  [16964] = 15439,
  [16965] = 15738,
  [16966] = 15476,
  [16967] = 15739,
  [16968] = 15437,
  [16969] = 15462,
  [16970] = 15460,
  [16971] = 15457,
  [16972] = 15749,
  [16973] = 16973,
  [16974] = 15750,
  [16975] = 15436,
  [16976] = 15437,
  [16977] = 15439,
  [16978] = 15429,
  [16979] = 15443,
  [16980] = 15460,
  [16981] = 15462,
  [16982] = 15465,
  [16983] = 15436,
  [16984] = 15497,
  [16985] = 15751,
  [16986] = 15759,
  [16987] = 15470,
  [16988] = 15495,
  [16989] = 15435,
  [16990] = 16117,
  [16991] = 15477,
  [16992] = 15476,
  [16993] = 15476,
  [16994] = 15761,
  [16995] = 15477,
  [16996] = 15764,
  [16997] = 15462,
  [16998] = 15434,
  [16999] = 15765,
  [17000] = 15766,
  [17001] = 15781,
  [17002] = 15460,
  [17003] = 16113,
  [17004] = 15432,
  [17005] = 15481,
  [17006] = 17006,
  [17007] = 17007,
  [17008] = 15484,
  [17009] = 15485,
  [17010] = 15429,
  [17011] = 15488,
  [17012] = 15443,
  [17013] = 15490,
  [17014] = 15443,
  [17015] = 15497,
  [17016] = 17016,
  [17017] = 15495,
  [17018] = 15495,
  [17019] = 15434,
  [17020] = 15497,
  [17021] = 15497,
  [17022] = 15477,
  [17023] = 15432,
  [17024] = 17024,
  [17025] = 15457,
  [17026] = 15791,
  [17027] = 15434,
  [17028] = 15435,
  [17029] = 15495,
  [17030] = 17030,
  [17031] = 17031,
  [17032] = 15437,
  [17033] = 15476,
  [17034] = 15462,
  [17035] = 15490,
  [17036] = 15439,
  [17037] = 15460,
  [17038] = 15488,
  [17039] = 15548,
  [17040] = 15448,
  [17041] = 17041,
  [17042] = 17042,
  [17043] = 15486,
  [17044] = 15485,
  [17045] = 15484,
  [17046] = 15429,
  [17047] = 15449,
  [17048] = 15443,
  [17049] = 15482,
  [17050] = 15429,
  [17051] = 15481,
  [17052] = 15443,
  [17053] = 15458,
  [17054] = 17054,
  [17055] = 15497,
  [17056] = 15495,
  [17057] = 15477,
  [17058] = 15812,
  [17059] = 15476,
  [17060] = 17060,
  [17061] = 15609,
  [17062] = 17062,
  [17063] = 15477,
  [17064] = 15476,
  [17065] = 15462,
  [17066] = 15457,
  [17067] = 17067,
  [17068] = 15460,
  [17069] = 15457,
  [17070] = 17070,
  [17071] = 15429,
  [17072] = 15443,
  [17073] = 15497,
  [17074] = 15460,
  [17075] = 15462,
  [17076] = 15465,
  [17077] = 15495,
  [17078] = 15477,
  [17079] = 15476,
  [17080] = 15462,
  [17081] = 15470,
  [17082] = 15460,
  [17083] = 15460,
  [17084] = 15462,
  [17085] = 15429,
  [17086] = 15443,
  [17087] = 15476,
  [17088] = 15477,
  [17089] = 15819,
  [17090] = 15465,
  [17091] = 15497,
  [17092] = 15495,
  [17093] = 17093,
  [17094] = 15468,
  [17095] = 15477,
  [17096] = 15476,
  [17097] = 15471,
  [17098] = 15481,
  [17099] = 15470,
  [17100] = 15462,
  [17101] = 15484,
  [17102] = 15485,
  [17103] = 15460,
  [17104] = 15488,
  [17105] = 17105,
  [17106] = 15490,
  [17107] = 15470,
  [17108] = 17108,
  [17109] = 15495,
  [17110] = 15471,
  [17111] = 15497,
  [17112] = 15468,
  [17113] = 15429,
  [17114] = 15432,
  [17115] = 15443,
  [17116] = 15465,
  [17117] = 15497,
  [17118] = 15434,
  [17119] = 15435,
  [17120] = 15462,
  [17121] = 15820,
  [17122] = 15605,
  [17123] = 15437,
  [17124] = 15821,
  [17125] = 15495,
  [17126] = 15823,
  [17127] = 15439,
  [17128] = 15460,
  [17129] = 15721,
  [17130] = 15429,
  [17131] = 15477,
  [17132] = 17132,
  [17133] = 15476,
  [17134] = 15462,
  [17135] = 15460,
  [17136] = 15476,
  [17137] = 15443,
  [17138] = 17138,
  [17139] = 15429,
  [17140] = 15449,
  [17141] = 15477,
  [17142] = 15429,
  [17143] = 15597,
  [17144] = 15443,
  [17145] = 15481,
  [17146] = 15497,
  [17147] = 15495,
  [17148] = 15639,
  [17149] = 15834,
  [17150] = 15482,
  [17151] = 15205,
  [17152] = 15457,
  [17153] = 15844,
  [17154] = 15495,
  [17155] = 15477,
  [17156] = 15476,
  [17157] = 15462,
  [17158] = 15460,
  [17159] = 15484,
  [17160] = 15460,
  [17161] = 15462,
  [17162] = 15465,
  [17163] = 14622,
  [17164] = 15845,
  [17165] = 17165,
  [17166] = 15485,
  [17167] = 15470,
  [17168] = 17168,
  [17169] = 15429,
  [17170] = 15486,
  [17171] = 15443,
  [17172] = 15476,
  [17173] = 15477,
  [17174] = 15448,
  [17175] = 15497,
  [17176] = 15495,
  [17177] = 17177,
  [17178] = 15846,
  [17179] = 17179,
  [17180] = 13104,
  [17181] = 15481,
  [17182] = 15477,
  [17183] = 15476,
  [17184] = 15484,
  [17185] = 15485,
  [17186] = 15462,
  [17187] = 15488,
  [17188] = 15460,
  [17189] = 15490,
  [17190] = 15488,
  [17191] = 16101,
  [17192] = 15495,
  [17193] = 15490,
  [17194] = 15497,
  [17195] = 15429,
  [17196] = 15443,
  [17197] = 15432,
  [17198] = 15497,
  [17199] = 15429,
  [17200] = 15856,
  [17201] = 15434,
  [17202] = 15435,
  [17203] = 15495,
  [17204] = 17204,
  [17205] = 17205,
  [17206] = 15437,
  [17207] = 17207,
  [17208] = 15443,
  [17209] = 15495,
  [17210] = 15439,
  [17211] = 15550,
  [17212] = 17212,
  [17213] = 15477,
  [17214] = 15476,
  [17215] = 17215,
  [17216] = 15462,
  [17217] = 14990,
  [17218] = 15460,
  [17219] = 15443,
  [17220] = 15497,
  [17221] = 15429,
  [17222] = 15429,
  [17223] = 17223,
  [17224] = 15443,
  [17225] = 15877,
  [17226] = 15432,
  [17227] = 17227,
  [17228] = 15497,
  [17229] = 15495,
  [17230] = 17230,
  [17231] = 15477,
  [17232] = 15476,
  [17233] = 15460,
  [17234] = 15462,
  [17235] = 15462,
  [17236] = 15460,
  [17237] = 16088,
  [17238] = 15476,
  [17239] = 15477,
  [17240] = 15434,
  [17241] = 15435,
  [17242] = 15439,
  [17243] = 15436,
  [17244] = 15429,
  [17245] = 15495,
  [17246] = 15437,
  [17247] = 15497,
  [17248] = 15437,
  [17249] = 15436,
  [17250] = 15443,
  [17251] = 15435,
  [17252] = 15429,
  [17253] = 17253,
  [17254] = 15434,
  [17255] = 15443,
  [17256] = 15592,
  [17257] = 15432,
  [17258] = 15497,
  [17259] = 15495,
  [17260] = 15477,
  [17261] = 15476,
  [17262] = 15462,
  [17263] = 15460,
  [17264] = 15460,
  [17265] = 15462,
  [17266] = 15554,
  [17267] = 16305,
  [17268] = 15429,
  [17269] = 15476,
  [17270] = 15477,
  [17271] = 15497,
  [17272] = 15443,
  [17273] = 9567,
  [17274] = 15497,
  [17275] = 15495,
  [17276] = 15495,
  [17277] = 15443,
  [17278] = 15497,
  [17279] = 15549,
  [17280] = 15477,
  [17281] = 15443,
  [17282] = 15476,
  [17283] = 15429,
  [17284] = 17284,
  [17285] = 15490,
  [17286] = 15462,
  [17287] = 15488,
  [17288] = 15460,
  [17289] = 16085,
  [17290] = 15429,
  [17291] = 17291,
  [17292] = 15429,
  [17293] = 15443,
  [17294] = 15448,
  [17295] = 15460,
  [17296] = 15462,
  [17297] = 15497,
  [17298] = 15495,
  [17299] = 15449,
  [17300] = 15476,
  [17301] = 15477,
  [17302] = 15486,
  [17303] = 15458,
  [17304] = 15485,
  [17305] = 15477,
  [17306] = 15476,
  [17307] = 15495,
  [17308] = 15462,
  [17309] = 15497,
  [17310] = 15484,
  [17311] = 15460,
  [17312] = 15443,
  [17313] = 15482,
  [17314] = 15429,
  [17315] = 15481,
  [17316] = 15591,
  [17317] = 15429,
  [17318] = 15457,
  [17319] = 15477,
  [17320] = 17320,
  [17321] = 15443,
  [17322] = 15497,
  [17323] = 15495,
  [17324] = 17324,
  [17325] = 15477,
  [17326] = 15460,
  [17327] = 15462,
  [17328] = 15476,
  [17329] = 15462,
  [17330] = 15460,
  [17331] = 15476,
  [17332] = 15477,
  [17333] = 15476,
  [17334] = 15460,
  [17335] = 15429,
  [17336] = 15443,
  [17337] = 15462,
  [17338] = 15495,
  [17339] = 15497,
  [17340] = 15497,
  [17341] = 15495,
  [17342] = 15439,
  [17343] = 15443,
  [17344] = 15477,
  [17345] = 15429,
  [17346] = 15471,
  [17347] = 15476,
  [17348] = 15470,
  [17349] = 17349,
  [17350] = 15468,
  [17351] = 15465,
  [17352] = 15462,
  [17353] = 15460,
  [17354] = 15594,
  [17355] = 15468,
  [17356] = 15470,
  [17357] = 15460,
  [17358] = 15462,
  [17359] = 15471,
  [17360] = 15429,
  [17361] = 15443,
  [17362] = 15476,
  [17363] = 15477,
  [17364] = 15497,
  [17365] = 15495,
  [17366] = 15477,
  [17367] = 15476,
  [17368] = 15462,
  [17369] = 15495,
  [17370] = 15460,
  [17371] = 15497,
  [17372] = 15462,
  [17373] = 16050,
  [17374] = 15443,
  [17375] = 15460,
  [17376] = 15429,
  [17377] = 15476,
  [17378] = 15477,
  [17379] = 15465,
  [17380] = 17380,
  [17381] = 15429,
  [17382] = 15911,
  [17383] = 15481,
  [17384] = 15443,
  [17385] = 15482,
  [17386] = 15497,
  [17387] = 15495,
  [17388] = 15460,
  [17389] = 15462,
  [17390] = 15484,
  [17391] = 15477,
  [17392] = 15476,
  [17393] = 15476,
  [17394] = 15477,
  [17395] = 17395,
  [17396] = 15462,
  [17397] = 15460,
  [17398] = 15485,
  [17399] = 15486,
  [17400] = 15495,
  [17401] = 16036,
  [17402] = 15497,
  [17403] = 15429,
  [17404] = 15457,
  [17405] = 15443,
  [17406] = 15488,
  [17407] = 15429,
  [17408] = 15590,
  [17409] = 15443,
  [17410] = 15497,
  [17411] = 15495,
  [17412] = 15290,
  [17413] = 17413,
  [17414] = 15490,
  [17415] = 15477,
  [17416] = 15476,
  [17417] = 15462,
  [17418] = 15460,
  [17419] = 15460,
  [17420] = 15462,
  [17421] = 15495,
  [17422] = 15429,
  [17423] = 15497,
  [17424] = 15476,
  [17425] = 15477,
  [17426] = 15449,
  [17427] = 15443,
  [17428] = 15448,
  [17429] = 15497,
  [17430] = 15495,
  [17431] = 15495,
  [17432] = 15432,
  [17433] = 15497,
  [17434] = 17434,
  [17435] = 15477,
  [17436] = 15443,
  [17437] = 15429,
  [17438] = 15429,
  [17439] = 15476,
  [17440] = 15462,
  [17441] = 15443,
  [17442] = 15460,
  [17443] = 15429,
  [17444] = 17444,
  [17445] = 15435,
  [17446] = 15443,
  [17447] = 15436,
  [17448] = 15497,
  [17449] = 15495,
  [17450] = 15460,
  [17451] = 15462,
  [17452] = 15437,
  [17453] = 16035,
  [17454] = 15477,
  [17455] = 15476,
  [17456] = 15477,
  [17457] = 15476,
  [17458] = 15462,
  [17459] = 14401,
  [17460] = 15460,
  [17461] = 15439,
  [17462] = 15495,
  [17463] = 16049,
  [17464] = 15497,
  [17465] = 14466,
  [17466] = 17466,
  [17467] = 15443,
  [17468] = 15429,
  [17469] = 15429,
  [17470] = 15443,
  [17471] = 15497,
  [17472] = 14076,
  [17473] = 15495,
  [17474] = 15477,
  [17475] = 15476,
  [17476] = 15462,
  [17477] = 15460,
  [17478] = 13120,
  [17479] = 15443,
  [17480] = 17480,
  [17481] = 15460,
  [17482] = 15462,
  [17483] = 15429,
  [17484] = 15429,
  [17485] = 15443,
  [17486] = 15476,
  [17487] = 15477,
  [17488] = 17488,
  [17489] = 15497,
  [17490] = 15495,
  [17491] = 15477,
  [17492] = 15476,
  [17493] = 15495,
  [17494] = 15462,
  [17495] = 15497,
  [17496] = 15439,
  [17497] = 14333,
  [17498] = 15443,
  [17499] = 15437,
  [17500] = 15429,
  [17501] = 15922,
  [17502] = 15460,
  [17503] = 15436,
  [17504] = 15435,
  [17505] = 15434,
  [17506] = 15448,
  [17507] = 15449,
  [17508] = 15429,
  [17509] = 15443,
  [17510] = 15497,
  [17511] = 15495,
  [17512] = 15460,
  [17513] = 15462,
  [17514] = 15457,
  [17515] = 15477,
  [17516] = 15476,
  [17517] = 15476,
  [17518] = 15477,
  [17519] = 15915,
  [17520] = 15462,
  [17521] = 15432,
  [17522] = 15460,
  [17523] = 17523,
  [17524] = 15495,
  [17525] = 15429,
  [17526] = 15497,
  [17527] = 15443,
  [17528] = 15497,
  [17529] = 15443,
  [17530] = 15497,
  [17531] = 15429,
  [17532] = 15495,
  [17533] = 17533,
  [17534] = 15495,
  [17535] = 15434,
  [17536] = 15477,
  [17537] = 15490,
  [17538] = 15476,
  [17539] = 15462,
  [17540] = 15460,
  [17541] = 15460,
  [17542] = 15462,
  [17543] = 15460,
  [17544] = 15462,
  [17545] = 17545,
  [17546] = 15429,
  [17547] = 15443,
  [17548] = 15476,
  [17549] = 15477,
  [17550] = 15465,
  [17551] = 15497,
  [17552] = 15495,
  [17553] = 13162,
  [17554] = 15468,
  [17555] = 15495,
  [17556] = 15477,
  [17557] = 15497,
  [17558] = 15488,
  [17559] = 15476,
  [17560] = 15443,
  [17561] = 15486,
  [17562] = 15429,
  [17563] = 15462,
  [17564] = 15460,
  [17565] = 15485,
  [17566] = 15916,
  [17567] = 15484,
  [17568] = 15918,
  [17569] = 15470,
  [17570] = 15563,
  [17571] = 15471,
  [17572] = 15429,
  [17573] = 15443,
  [17574] = 15460,
  [17575] = 15462,
  [17576] = 15497,
  [17577] = 15495,
  [17578] = 15477,
  [17579] = 15476,
  [17580] = 15477,
  [17581] = 15476,
  [17582] = 15462,
  [17583] = 15482,
  [17584] = 15460,
  [17585] = 17585,
  [17586] = 15495,
  [17587] = 15477,
  [17588] = 15497,
  [17589] = 15481,
  [17590] = 16023,
  [17591] = 15443,
  [17592] = 15429,
  [17593] = 15429,
  [17594] = 15921,
  [17595] = 15589,
  [17596] = 7857,
  [17597] = 15443,
  [17598] = 15477,
  [17599] = 15476,
  [17600] = 15497,
  [17601] = 15495,
  [17602] = 15481,
  [17603] = 15482,
  [17604] = 15477,
  [17605] = 15460,
  [17606] = 15462,
  [17607] = 15476,
  [17608] = 15462,
  [17609] = 15460,
  [17610] = 15476,
  [17611] = 15477,
  [17612] = 15484,
  [17613] = 15565,
  [17614] = 15485,
  [17615] = 15486,
  [17616] = 15429,
  [17617] = 15495,
  [17618] = 15443,
  [17619] = 15497,
  [17620] = 15488,
  [17621] = 15497,
  [17622] = 15443,
  [17623] = 15471,
  [17624] = 15429,
  [17625] = 15470,
  [17626] = 15468,
  [17627] = 15465,
  [17628] = 15495,
  [17629] = 15476,
  [17630] = 15462,
  [17631] = 15477,
  [17632] = 15476,
  [17633] = 15462,
  [17634] = 15460,
  [17635] = 15566,
  [17636] = 15460,
  [17637] = 15462,
  [17638] = 15490,
  [17639] = 15495,
  [17640] = 15429,
  [17641] = 15476,
  [17642] = 15477,
  [17643] = 15443,
  [17644] = 15497,
  [17645] = 15460,
  [17646] = 15497,
  [17647] = 15495,
  [17648] = 15495,
  [17649] = 15477,
  [17650] = 15497,
  [17651] = 15476,
  [17652] = 15462,
  [17653] = 15443,
  [17654] = 15460,
  [17655] = 15429,
  [17656] = 17656,
  [17657] = 15587,
  [17658] = 15432,
  [17659] = 15434,
  [17660] = 15435,
  [17661] = 15457,
  [17662] = 17662,
  [17663] = 15429,
  [17664] = 15436,
  [17665] = 15443,
  [17666] = 15437,
  [17667] = 15460,
  [17668] = 15462,
  [17669] = 15497,
  [17670] = 15495,
  [17671] = 15439,
  [17672] = 15476,
  [17673] = 15477,
  [17674] = 15582,
  [17675] = 15477,
  [17676] = 15476,
  [17677] = 15462,
  [17678] = 15460,
  [17679] = 15495,
  [17680] = 15571,
  [17681] = 15497,
  [17682] = 15429,
  [17683] = 15443,
  [17684] = 15443,
  [17685] = 15443,
  [17686] = 15429,
  [17687] = 15578,
  [17688] = 15941,
  [17689] = 7725,
  [17690] = 7859,
  [17691] = 15497,
  [17692] = 15449,
  [17693] = 15495,
  [17694] = 15572,
  [17695] = 15477,
  [17696] = 15476,
  [17697] = 15462,
  [17698] = 15460,
  [17699] = 15462,
  [17700] = 15460,
  [17701] = 15429,
  [17702] = 15448,
  [17703] = 15476,
  [17704] = 15477,
  [17705] = 15949,
  [17706] = 15449,
  [17707] = 15448,
  [17708] = 15429,
  [17709] = 15443,
  [17710] = 15495,
  [17711] = 15497,
  [17712] = 15497,
  [17713] = 15495,
  [17714] = 15477,
  [17715] = 15443,
  [17716] = 15429,
  [17717] = 15429,
  [17718] = 15577,
  [17719] = 15476,
  [17720] = 15443,
  [17721] = 15951,
  [17722] = 15462,
  [17723] = 15460,
  [17724] = 15457,
  [17725] = 17725,
  [17726] = 15443,
  [17727] = 15497,
  [17728] = 15495,
  [17729] = 15460,
  [17730] = 15462,
  [17731] = 15997,
  [17732] = 15477,
  [17733] = 15476,
  [17734] = 15476,
  [17735] = 15477,
  [17736] = 17736,
  [17737] = 15462,
  [17738] = 15460,
  [17739] = 15462,
  [17740] = 15573,
  [17741] = 15495,
  [17742] = 15465,
  [17743] = 15497,
  [17744] = 15429,
  [17745] = 15468,
  [17746] = 15443,
  [17747] = 15443,
  [17748] = 15429,
  [17749] = 15497,
  [17750] = 15439,
  [17751] = 15495,
  [17752] = 17752,
  [17753] = 15437,
  [17754] = 15956,
  [17755] = 15460,
  [17756] = 15471,
  [17757] = 15477,
  [17758] = 15476,
  [17759] = 15462,
  [17760] = 15460,
  [17761] = 15462,
  [17762] = 15460,
  [17763] = 15476,
  [17764] = 15429,
  [17765] = 15476,
  [17766] = 15477,
  [17767] = 17767,
  [17768] = 15477,
  [17769] = 15436,
  [17770] = 15443,
  [17771] = 15497,
  [17772] = 15495,
  [17773] = 15495,
  [17774] = 15497,
  [17775] = 15435,
  [17776] = 15434,
  [17777] = 15443,
  [17778] = 15481,
  [17779] = 15429,
  [17780] = 15432,
  [17781] = 15477,
  [17782] = 17782,
  [17783] = 15497,
  [17784] = 15476,
  [17785] = 15462,
  [17786] = 15460,
  [17787] = 17787,
  [17788] = 15482,
  [17789] = 15484,
  [17790] = 15460,
  [17791] = 15462,
  [17792] = 15476,
  [17793] = 15477,
  [17794] = 17794,
  [17795] = 15470,
  [17796] = 15495,
  [17797] = 15497,
  [17798] = 15495,
  [17799] = 15443,
  [17800] = 15429,
  [17801] = 15575,
  [17802] = 15490,
  [17803] = 15460,
  [17804] = 15462,
  [17805] = 15476,
  [17806] = 15477,
  [17807] = 15488,
  [17808] = 15495,
  [17809] = 15497,
  [17810] = 15486,
  [17811] = 15443,
  [17812] = 15485,
  [17813] = 15429,
  [17814] = 17814,
  [17815] = 17815,
  [17816] = 15055,
  [17817] = 3751,
  [17818] = 17815,
  [17819] = 3760,
  [17820] = 3778,
  [17821] = 3737,
  [17822] = 3738,
  [17823] = 3739,
  [17824] = 3742,
  [17825] = 3743,
  [17826] = 3744,
  [17827] = 3734,
  [17828] = 17828,
  [17829] = 17828,
  [17830] = 3748,
  [17831] = 17828,
  [17832] = 3762,
  [17833] = 3774,
  [17834] = 3785,
  [17835] = 3740,
  [17836] = 15795,
  [17837] = 17837,
  [17838] = 17838,
  [17839] = 3745,
  [17840] = 3746,
  [17841] = 17815,
  [17842] = 3747,
  [17843] = 17838,
  [17844] = 3745,
  [17845] = 15780,
  [17846] = 3740,
  [17847] = 17815,
  [17848] = 15772,
  [17849] = 3785,
  [17850] = 3774,
  [17851] = 3762,
  [17852] = 3748,
  [17853] = 17838,
  [17854] = 17854,
  [17855] = 3734,
  [17856] = 3747,
  [17857] = 17857,
  [17858] = 17828,
  [17859] = 3746,
  [17860] = 17860,
  [17861] = 3743,
  [17862] = 3742,
  [17863] = 3739,
  [17864] = 3738,
  [17865] = 17828,
  [17866] = 3737,
  [17867] = 3778,
  [17868] = 3744,
  [17869] = 3751,
  [17870] = 3760,
  [17871] = 3547,
  [17872] = 17838,
  [17873] = 3549,
  [17874] = 3597,
  [17875] = 3608,
  [17876] = 17815,
  [17877] = 17877,
  [17878] = 17877,
  [17879] = 3591,
  [17880] = 17877,
  [17881] = 3577,
  [17882] = 17815,
  [17883] = 17877,
  [17884] = 3489,
  [17885] = 17877,
  [17886] = 3576,
  [17887] = 17828,
  [17888] = 17877,
  [17889] = 17838,
  [17890] = 3546,
  [17891] = 15290,
  [17892] = 8215,
  [17893] = 17893,
  [17894] = 17877,
  [17895] = 3482,
  [17896] = 8223,
  [17897] = 17877,
  [17898] = 3606,
  [17899] = 17877,
  [17900] = 17877,
  [17901] = 17838,
  [17902] = 3668,
  [17903] = 17877,
  [17904] = 17904,
  [17905] = 17815,
  [17906] = 17828,
  [17907] = 17877,
  [17908] = 17877,
  [17909] = 17877,
  [17910] = 3514,
  [17911] = 17877,
  [17912] = 17912,
  [17913] = 17877,
  [17914] = 17914,
  [17915] = 17877,
  [17916] = 17828,
  [17917] = 3677,
  [17918] = 17815,
  [17919] = 17877,
  [17920] = 17815,
  [17921] = 15744,
  [17922] = 17877,
  [17923] = 17815,
  [17924] = 3562,
  [17925] = 17877,
  [17926] = 15740,
  [17927] = 17877,
  [17928] = 17928,
  [17929] = 17912,
  [17930] = 17838,
  [17931] = 17877,
  [17932] = 17877,
  [17933] = 17877,
  [17934] = 17815,
  [17935] = 17838,
  [17936] = 17936,
  [17937] = 17937,
  [17938] = 15734,
  [17939] = 17877,
  [17940] = 14990,
  [17941] = 17912,
  [17942] = 17942,
  [17943] = 17937,
  [17944] = 17877,
  [17945] = 17828,
  [17946] = 17946,
  [17947] = 17937,
  [17948] = 17877,
  [17949] = 17937,
  [17950] = 17838,
  [17951] = 17838,
  [17952] = 17877,
  [17953] = 17937,
  [17954] = 17828,
  [17955] = 17877,
  [17956] = 17937,
  [17957] = 17877,
  [17958] = 15716,
  [17959] = 17838,
  [17960] = 17937,
  [17961] = 17928,
  [17962] = 17877,
  [17963] = 17815,
  [17964] = 17937,
  [17965] = 17965,
  [17966] = 17877,
  [17967] = 17838,
  [17968] = 17937,
  [17969] = 17815,
  [17970] = 17877,
  [17971] = 17937,
  [17972] = 17877,
  [17973] = 17912,
  [17974] = 17828,
  [17975] = 17928,
  [17976] = 17937,
  [17977] = 17877,
  [17978] = 17838,
  [17979] = 14640,
  [17980] = 17937,
  [17981] = 17981,
  [17982] = 17838,
  [17983] = 17877,
  [17984] = 17937,
  [17985] = 17877,
  [17986] = 17937,
  [17987] = 17987,
  [17988] = 17838,
  [17989] = 17815,
  [17990] = 17877,
  [17991] = 17937,
  [17992] = 17815,
  [17993] = 17987,
  [17994] = 17877,
  [17995] = 17937,
  [17996] = 17987,
  [17997] = 17815,
  [17998] = 17828,
  [17999] = 17877,
  [18000] = 17893,
  [18001] = 17937,
  [18002] = 17987,
  [18003] = 17828,
  [18004] = 17877,
  [18005] = 17937,
  [18006] = 17987,
  [18007] = 17877,
  [18008] = 17937,
  [18009] = 17815,
  [18010] = 17987,
  [18011] = 17877,
  [18012] = 17937,
  [18013] = 17838,
  [18014] = 17928,
  [18015] = 17860,
  [18016] = 18016,
  [18017] = 17838,
  [18018] = 18018,
  [18019] = 17987,
  [18020] = 17877,
  [18021] = 17815,
  [18022] = 18022,
  [18023] = 17937,
  [18024] = 17904,
  [18025] = 18016,
  [18026] = 18026,
  [18027] = 18018,
  [18028] = 17815,
  [18029] = 17987,
  [18030] = 17877,
  [18031] = 17857,
  [18032] = 17828,
  [18033] = 17937,
  [18034] = 17904,
  [18035] = 17857,
  [18036] = 18036,
  [18037] = 17828,
  [18038] = 17828,
  [18039] = 17937,
  [18040] = 17857,
  [18041] = 18041,
  [18042] = 17828,
  [18043] = 17828,
  [18044] = 15655,
  [18045] = 17860,
  [18046] = 17838,
  [18047] = 15111,
  [18048] = 15337,
  [18049] = 17965,
  [18050] = 17815,
  [18051] = 17893,
  [18052] = 15013,
  [18053] = 17815,
  [18054] = 17838,
  [18055] = 17838,
  [18056] = 17928,
  [18057] = 18057,
  [18058] = 17815,
  [18059] = 15708,
  [18060] = 17838,
  [18061] = 17828,
  [18062] = 17928,
  [18063] = 14622,
  [18064] = 17928,
  [18065] = 18065,
  [18066] = 17838,
  [18067] = 15003,
  [18068] = 17828,
  [18069] = 17857,
  [18070] = 17854,
  [18071] = 17828,
  [18072] = 15971,
  [18073] = 18073,
  [18074] = 14640,
  [18075] = 17838,
  [18076] = 17828,
  [18077] = 18077,
  [18078] = 15976,
  [18079] = 17815,
  [18080] = 15985,
  [18081] = 15532,
  [18082] = 17815,
  [18083] = 14111,
  [18084] = 15501,
  [18085] = 15604,
  [18086] = 15496,
  [18087] = 17815,
  [18088] = 17912,
  [18089] = 17877,
  [18090] = 17828,
  [18091] = 16041,
  [18092] = 16046,
  [18093] = 17828,
  [18094] = 17838,
  [18095] = 17857,
  [18096] = 17838,
  [18097] = 17965,
  [18098] = 17928,
  [18099] = 17815,
  [18100] = 17857,
  [18101] = 17815,
  [18102] = 17928,
  [18103] = 17987,
  [18104] = 17838,
  [18105] = 18105,
  [18106] = 17815,
  [18107] = 17857,
  [18108] = 17815,
  [18109] = 17838,
  [18110] = 17828,
  [18111] = 17857,
  [18112] = 18036,
  [18113] = 16064,
  [18114] = 14699,
  [18115] = 17857,
  [18116] = 18041,
  [18117] = 17828,
  [18118] = 17828,
  [18119] = 17828,
  [18120] = 17857,
  [18121] = 16057,
  [18122] = 17860,
  [18123] = 16123,
  [18124] = 16110,
  [18125] = 17815,
  [18126] = 17893,
  [18127] = 17815,
  [18128] = 17928,
  [18129] = 16118,
  [18130] = 16119,
  [18131] = 16935,
  [18132] = 16936,
  [18133] = 17838,
  [18134] = 17838,
  [18135] = 18036,
  [18136] = 16120,
  [18137] = 17815,
  [18138] = 17838,
  [18139] = 18139,
  [18140] = 17981,
  [18141] = 18141,
  [18142] = 17914,
  [18143] = 16957,
  [18144] = 17828,
  [18145] = 17838,
  [18146] = 18022,
  [18147] = 16959,
  [18148] = 17828,
  [18149] = 17928,
  [18150] = 17828,
  [18151] = 17981,
  [18152] = 17914,
  [18153] = 17815,
  [18154] = 18154,
  [18155] = 17857,
  [18156] = 17981,
  [18157] = 17914,
  [18158] = 16139,
  [18159] = 16142,
  [18160] = 17815,
  [18161] = 18161,
  [18162] = 17838,
  [18163] = 17828,
  [18164] = 17912,
  [18165] = 17016,
  [18166] = 17815,
  [18167] = 17981,
  [18168] = 17914,
  [18169] = 17024,
  [18170] = 16148,
  [18171] = 17030,
  [18172] = 17838,
  [18173] = 17838,
  [18174] = 17031,
  [18175] = 17981,
  [18176] = 17914,
  [18177] = 17828,
  [18178] = 16152,
  [18179] = 18179,
  [18180] = 17928,
  [18181] = 17815,
  [18182] = 17981,
  [18183] = 17914,
  [18184] = 16174,
  [18185] = 14377,
  [18186] = 18186,
  [18187] = 17981,
  [18188] = 17914,
  [18189] = 17928,
  [18190] = 16176,
  [18191] = 17838,
  [18192] = 18192,
  [18193] = 18193,
  [18194] = 17062,
  [18195] = 17815,
  [18196] = 17981,
  [18197] = 17828,
  [18198] = 18198,
  [18199] = 17914,
  [18200] = 15175,
  [18201] = 17132,
  [18202] = 17838,
  [18203] = 18041,
  [18204] = 17981,
  [18205] = 17928,
  [18206] = 17828,
  [18207] = 17914,
  [18208] = 17828,
  [18209] = 17815,
  [18210] = 17815,
  [18211] = 16214,
  [18212] = 17981,
  [18213] = 17914,
  [18214] = 17179,
  [18215] = 18215,
  [18216] = 17838,
  [18217] = 17860,
  [18218] = 17204,
  [18219] = 17838,
  [18220] = 17838,
  [18221] = 17981,
  [18222] = 17205,
  [18223] = 17914,
  [18224] = 17815,
  [18225] = 17860,
  [18226] = 17207,
  [18227] = 17857,
  [18228] = 17060,
  [18229] = 17857,
  [18230] = 18230,
  [18231] = 17981,
  [18232] = 18232,
  [18233] = 17828,
  [18234] = 17914,
  [18235] = 17828,
  [18236] = 17212,
  [18237] = 17828,
  [18238] = 17928,
  [18239] = 17893,
  [18240] = 17981,
  [18241] = 18241,
  [18242] = 17914,
  [18243] = 17912,
  [18244] = 17227,
  [18245] = 17912,
  [18246] = 17815,
  [18247] = 9541,
  [18248] = 17828,
  [18249] = 17838,
  [18250] = 17253,
  [18251] = 18251,
  [18252] = 17981,
  [18253] = 17815,
  [18254] = 17914,
  [18255] = 17893,
  [18256] = 17838,
  [18257] = 17928,
  [18258] = 18258,
  [18259] = 17838,
  [18260] = 18260,
  [18261] = 17981,
  [18262] = 17857,
  [18263] = 17914,
  [18264] = 17828,
  [18265] = 17815,
  [18266] = 15180,
  [18267] = 18041,
  [18268] = 17981,
  [18269] = 18269,
  [18270] = 18270,
  [18271] = 17914,
  [18272] = 14231,
  [18273] = 17828,
  [18274] = 17893,
  [18275] = 17981,
  [18276] = 17914,
  [18277] = 18277,
  [18278] = 17838,
  [18279] = 17395,
  [18280] = 17857,
  [18281] = 18281,
  [18282] = 17815,
  [18283] = 16256,
  [18284] = 17828,
  [18285] = 17981,
  [18286] = 17838,
  [18287] = 17914,
  [18288] = 17928,
  [18289] = 18289,
  [18290] = 18041,
  [18291] = 17828,
  [18292] = 17981,
  [18293] = 17828,
  [18294] = 17815,
  [18295] = 17914,
  [18296] = 17656,
  [18297] = 17815,
  [18298] = 17981,
  [18299] = 18299,
  [18300] = 17914,
  [18301] = 17838,
  [18302] = 18302,
  [18303] = 17857,
  [18304] = 17860,
  [18305] = 17860,
  [18306] = 18306,
  [18307] = 17838,
  [18308] = 17857,
  [18309] = 17981,
  [18310] = 17914,
  [18311] = 17815,
  [18312] = 17838,
  [18313] = 9539,
  [18314] = 17893,
  [18315] = 16206,
  [18316] = 16257,
  [18317] = 17981,
  [18318] = 17912,
  [18319] = 17914,
  [18320] = 17828,
  [18321] = 17912,
  [18322] = 17828,
  [18323] = 17767,
  [18324] = 17981,
  [18325] = 17914,
  [18326] = 17838,
  [18327] = 17928,
  [18328] = 17828,
  [18329] = 17815,
  [18330] = 17981,
  [18331] = 17782,
  [18332] = 17914,
  [18333] = 18333,
  [18334] = 17794,
  [18335] = 17838,
  [18336] = 17838,
  [18337] = 16241,
  [18338] = 17787,
  [18339] = 14401,
  [18340] = 17815,
  [18341] = 17981,
  [18342] = 17815,
  [18343] = 18343,
  [18344] = 17914,
  [18345] = 18345,
  [18346] = 16205,
  [18347] = 17725,
  [18348] = 17857,
  [18349] = 16200,
  [18350] = 17981,
  [18351] = 17828,
  [18352] = 17914,
  [18353] = 17838,
  [18354] = 18354,
  [18355] = 16199,
  [18356] = 16196,
  [18357] = 17838,
  [18358] = 18358,
  [18359] = 16187,
  [18360] = 18360,
  [18361] = 17828,
  [18362] = 9531,
  [18363] = 17838,
  [18364] = 17981,
  [18365] = 17838,
  [18366] = 18041,
  [18367] = 17914,
  [18368] = 17828,
  [18369] = 17815,
  [18370] = 17828,
  [18371] = 17928,
  [18372] = 17585,
  [18373] = 17928,
  [18374] = 17981,
  [18375] = 17914,
  [18376] = 17815,
  [18377] = 17860,
  [18378] = 18378,
  [18379] = 17815,
  [18380] = 17828,
  [18381] = 17860,
  [18382] = 17893,
  [18383] = 17981,
  [18384] = 17815,
  [18385] = 17914,
  [18386] = 17912,
  [18387] = 17857,
  [18388] = 17838,
  [18389] = 17828,
  [18390] = 17981,
  [18391] = 17828,
  [18392] = 17914,
  [18393] = 17815,
  [18394] = 17838,
  [18395] = 18395,
  [18396] = 17838,
  [18397] = 17928,
  [18398] = 17815,
  [18399] = 17857,
  [18400] = 17981,
  [18401] = 17914,
  [18402] = 17815,
  [18403] = 18403,
  [18404] = 17981,
  [18405] = 17828,
  [18406] = 17914,
  [18407] = 16144,
  [18408] = 16141,
  [18409] = 17828,
  [18410] = 17168,
  [18411] = 17007,
  [18412] = 17981,
  [18413] = 17914,
  [18414] = 17838,
  [18415] = 18415,
  [18416] = 17815,
  [18417] = 18041,
  [18418] = 17928,
  [18419] = 17828,
  [18420] = 17815,
  [18421] = 17815,
  [18422] = 17981,
  [18423] = 17838,
  [18424] = 17914,
  [18425] = 17168,
  [18426] = 17928,
  [18427] = 17815,
  [18428] = 17860,
  [18429] = 16129,
  [18430] = 16897,
  [18431] = 17893,
  [18432] = 17981,
  [18433] = 17838,
  [18434] = 18434,
  [18435] = 17914,
  [18436] = 17857,
  [18437] = 17912,
  [18438] = 17828,
  [18439] = 17838,
  [18440] = 16117,
  [18441] = 16113,
  [18442] = 17857,
  [18443] = 17981,
  [18444] = 17828,
  [18445] = 17914,
  [18446] = 17828,
  [18447] = 17838,
  [18448] = 17815,
  [18449] = 17928,
  [18450] = 17815,
  [18451] = 17981,
  [18452] = 17838,
  [18453] = 15205,
  [18454] = 17914,
  [18455] = 18455,
  [18456] = 17815,
  [18457] = 16101,
  [18458] = 16088,
  [18459] = 16085,
  [18460] = 14466,
  [18461] = 18461,
  [18462] = 16050,
  [18463] = 17857,
  [18464] = 17815,
  [18465] = 17981,
  [18466] = 17914,
  [18467] = 17828,
  [18468] = 16049,
  [18469] = 16036,
  [18470] = 18470,
  [18471] = 18041,
  [18472] = 17928,
  [18473] = 17828,
  [18474] = 17838,
  [18475] = 16035,
  [18476] = 18476,
  [18477] = 17893,
  [18478] = 17981,
  [18479] = 17838,
  [18480] = 17914,
  [18481] = 17838,
  [18482] = 17838,
  [18483] = 17860,
  [18484] = 16182,
  [18485] = 17815,
  [18486] = 17857,
  [18487] = 17860,
  [18488] = 17928,
  [18489] = 17815,
  [18490] = 17893,
  [18491] = 17981,
  [18492] = 17914,
  [18493] = 17828,
  [18494] = 18494,
  [18495] = 16314,
  [18496] = 17828,
  [18497] = 18497,
  [18498] = 17912,
  [18499] = 17857,
  [18500] = 18500,
  [18501] = 17981,
  [18502] = 17815,
  [18503] = 17914,
  [18504] = 17828,
  [18505] = 18018,
  [18506] = 15916,
  [18507] = 16023,
  [18508] = 17912,
  [18509] = 17838,
  [18510] = 17838,
  [18511] = 17928,
  [18512] = 17815,
  [18513] = 17838,
  [18514] = 17815,
  [18515] = 18515,
  [18516] = 17828,
  [18517] = 17828,
  [18518] = 17981,
  [18519] = 17914,
  [18520] = 17857,
  [18521] = 15997,
  [18522] = 18522,
  [18523] = 18523,
  [18524] = 17857,
  [18525] = 17828,
  [18526] = 17815,
  [18527] = 18041,
  [18528] = 17828,
  [18529] = 17981,
  [18530] = 17828,
  [18531] = 18531,
  [18532] = 17914,
  [18533] = 18533,
  [18534] = 17838,
  [18535] = 17928,
  [18536] = 17814,
  [18537] = 18537,
  [18538] = 17815,
  [18539] = 17838,
  [18540] = 17928,
  [18541] = 15956,
  [18542] = 17860,
  [18543] = 17815,
  [18544] = 18544,
  [18545] = 17815,
  [18546] = 15951,
  [18547] = 15949,
  [18548] = 17893,
  [18549] = 17912,
  [18550] = 17838,
  [18551] = 17857,
  [18552] = 17981,
  [18553] = 17893,
  [18554] = 17828,
  [18555] = 17914,
  [18556] = 15941,
  [18557] = 14076,
  [18558] = 17828,
  [18559] = 17828,
  [18560] = 18560,
  [18561] = 17860,
  [18562] = 17838,
  [18563] = 17928,
  [18564] = 17893,
  [18565] = 17828,
  [18566] = 15922,
  [18567] = 18567,
  [18568] = 17838,
  [18569] = 15921,
  [18570] = 17815,
  [18571] = 15918,
  [18572] = 17815,
  [18573] = 15877,
  [18574] = 15915,
  [18575] = 15911,
  [18576] = 17814,
  [18577] = 17912,
  [18578] = 15856,
  [18579] = 17815,
  [18580] = 18230,
  [18581] = 18581,
  [18582] = 17860,
  [18583] = 17828,
  [18584] = 18584,
  [18585] = 15846,
  [18586] = 15845,
  [18587] = 15844,
  [18588] = 17838,
  [18589] = 17893,
  [18590] = 17857,
  [18591] = 17838,
  [18592] = 18592,
  [18593] = 15834,
  [18594] = 17928,
  [18595] = 18041,
  [18596] = 17828,
  [18597] = 17838,
  [18598] = 17981,
  [18599] = 17914,
  [18600] = 17815,
  [18601] = 17815,
  [18602] = 17893,
  [18603] = 17828,
  [18604] = 14333,
  [18605] = 17815,
  [18606] = 17838,
  [18607] = 18607,
  [18608] = 17828,
  [18609] = 17815,
  [18610] = 17838,
  [18611] = 18611,
  [18612] = 17828,
  [18613] = 15721,
  [18614] = 18614,
  [18615] = 17857,
  [18616] = 17912,
  [18617] = 15823,
  [18618] = 17828,
  [18619] = 17860,
  [18620] = 17815,
  [18621] = 9567,
  [18622] = 17838,
  [18623] = 17828,
  [18624] = 17828,
  [18625] = 17815,
  [18626] = 17838,
  [18627] = 17838,
  [18628] = 17860,
  [18629] = 17828,
  [18630] = 17815,
  [18631] = 15820,
  [18632] = 15819,
  [18633] = 17815,
  [18634] = 17838,
  [18635] = 9523,
  [18636] = 17828,
  [18637] = 17828,
  [18638] = 18057,
  [18639] = 17815,
  [18640] = 17838,
  [18641] = 17828,
  [18642] = 17828,
  [18643] = 17857,
  [18644] = 17828,
  [18645] = 15812,
  [18646] = 18041,
  [18647] = 17815,
  [18648] = 17838,
  [18649] = 17828,
  [18650] = 17838,
  [18651] = 17815,
  [18652] = 17838,
  [18653] = 18653,
  [18654] = 17928,
  [18655] = 17838,
  [18656] = 17893,
  [18657] = 17828,
  [18658] = 17815,
  [18659] = 17815,
  [18660] = 17815,
  [18661] = 17838,
  [18662] = 17815,
  [18663] = 15791,
  [18664] = 17828,
  [18665] = 15932,
  [18666] = 17815,
  [18667] = 17928,
  [18668] = 17838,
  [18669] = 17828,
  [18670] = 17828,
  [18671] = 15781,
  [18672] = 17838,
  [18673] = 17815,
  [18674] = 14640,
  [18675] = 17838,
  [18676] = 17838,
  [18677] = 17857,
  [18678] = 17912,
  [18679] = 17857,
  [18680] = 17828,
  [18681] = 17815,
  [18682] = 17928,
  [18683] = 17815,
  [18684] = 17838,
  [18685] = 17838,
  [18686] = 17828,
  [18687] = 17828,
  [18688] = 17815,
  [18689] = 17857,
  [18690] = 17815,
  [18691] = 17838,
  [18692] = 17928,
  [18693] = 17828,
  [18694] = 15766,
  [18695] = 17815,
  [18696] = 18696,
  [18697] = 17815,
  [18698] = 17838,
  [18699] = 17828,
  [18700] = 15765,
  [18701] = 15764,
  [18702] = 17828,
  [18703] = 17815,
  [18704] = 17838,
  [18705] = 17838,
  [18706] = 17838,
  [18707] = 18707,
  [18708] = 18708,
  [18709] = 17828,
  [18710] = 15761,
  [18711] = 15759,
  [18712] = 17815,
  [18713] = 17838,
  [18714] = 17838,
  [18715] = 15751,
  [18716] = 15867,
  [18717] = 17815,
  [18718] = 17828,
  [18719] = 17828,
  [18720] = 15863,
  [18721] = 17815,
  [18722] = 17838,
  [18723] = 17928,
  [18724] = 15750,
  [18725] = 18725,
  [18726] = 15749,
  [18727] = 15739,
  [18728] = 17828,
  [18729] = 17828,
  [18730] = 18730,
  [18731] = 15730,
  [18732] = 18732,
  [18733] = 17815,
  [18734] = 17838,
  [18735] = 9523,
  [18736] = 17815,
  [18737] = 15728,
  [18738] = 17828,
  [18739] = 18739,
  [18740] = 15738,
  [18741] = 17815,
  [18742] = 17838,
  [18743] = 17815,
  [18744] = 17838,
  [18745] = 15725,
  [18746] = 17815,
  [18747] = 15724,
  [18748] = 18193,
  [18749] = 17828,
  [18750] = 15722,
  [18751] = 17838,
  [18752] = 17815,
  [18753] = 18753,
  [18754] = 17838,
  [18755] = 15700,
  [18756] = 17928,
  [18757] = 17828,
  [18758] = 17828,
  [18759] = 18759,
  [18760] = 17815,
  [18761] = 17815,
  [18762] = 17838,
  [18763] = 17815,
  [18764] = 17928,
  [18765] = 17912,
  [18766] = 17828,
  [18767] = 17815,
  [18768] = 18768,
  [18769] = 17838,
  [18770] = 18770,
  [18771] = 17838,
  [18772] = 9541,
  [18773] = 17828,
  [18774] = 17815,
  [18775] = 17815,
  [18776] = 17928,
  [18777] = 18777,
  [18778] = 17838,
  [18779] = 18779,
  [18780] = 9539,
  [18781] = 17857,
  [18782] = 17838,
  [18783] = 17838,
  [18784] = 17857,
  [18785] = 17828,
  [18786] = 17828,
  [18787] = 17893,
  [18788] = 18788,
  [18789] = 17815,
  [18790] = 17838,
  [18791] = 17857,
  [18792] = 17828,
  [18793] = 15821,
  [18794] = 18794,
  [18795] = 17828,
  [18796] = 17828,
  [18797] = 17860,
  [18798] = 18022,
  [18799] = 17815,
  [18800] = 17838,
  [18801] = 17838,
  [18802] = 18041,
  [18803] = 17828,
  [18804] = 17815,
  [18805] = 15726,
  [18806] = 17828,
  [18807] = 17828,
  [18808] = 17857,
  [18809] = 17857,
  [18810] = 17838,
  [18811] = 17815,
  [18812] = 17838,
  [18813] = 17928,
  [18814] = 17838,
  [18815] = 17828,
  [18816] = 17815,
  [18817] = 17828,
  [18818] = 18818,
  [18819] = 18819,
  [18820] = 17912,
  [18821] = 17815,
  [18822] = 17838,
  [18823] = 18026,
  [18824] = 17828,
  [18825] = 17860,
  [18826] = 14640,
  [18827] = 17857,
  [18828] = 17828,
  [18829] = 17838,
  [18830] = 17828,
  [18831] = 17893,
  [18832] = 17815,
  [18833] = 17815,
  [18834] = 17860,
  [18835] = 17857,
  [18836] = 17838,
  [18837] = 17815,
  [18838] = 9531,
  [18839] = 9529,
  [18840] = 17828,
  [18841] = 17928,
  [18842] = 17838,
  [18843] = 17815,
  [18844] = 17828,
  [18845] = 17838,
  [18846] = 17912,
  [18847] = 8215,
  [18848] = 17912,
  [18849] = 17828,
  [18850] = 18850,
  [18851] = 17893,
  [18852] = 17815,
  [18853] = 8223,
  [18854] = 17815,
  [18855] = 17838,
  [18856] = 17838,
  [18857] = 17838,
  [18858] = 17838,
  [18859] = 17893,
  [18860] = 17928,
  [18861] = 17828,
  [18862] = 17815,
  [18863] = 17928,
  [18864] = 18016,
  [18865] = 17815,
  [18866] = 9529,
  [18867] = 17815,
  [18868] = 17838,
  [18869] = 18869,
  [18870] = 17893,
  [18871] = 17928,
  [18872] = 17815,
  [18873] = 17828,
  [18874] = 17857,
  [18875] = 17860,
  [18876] = 17828,
  [18877] = 17828,
  [18878] = 17860,
  [18879] = 17815,
  [18880] = 17838,
  [18881] = 15337,
  [18882] = 17828,
  [18883] = 17828,
  [18884] = 17857,
  [18885] = 17815,
  [18886] = 17838,
  [18887] = 17838,
  [18888] = 18888,
  [18889] = 17828,
  [18890] = 17828,
  [18891] = 17815,
  [18892] = 17838,
  [18893] = 17928,
  [18894] = 17857,
  [18895] = 17828,
  [18896] = 17838,
  [18897] = 17912,
  [18898] = 17838,
  [18899] = 17815,
  [18900] = 17828,
  [18901] = 17815,
  [18902] = 17828,
  [18903] = 17815,
  [18904] = 17928,
  [18905] = 17857,
  [18906] = 17838,
  [18907] = 18041,
  [18908] = 18908,
  [18909] = 18909,
  [18910] = 18910,
  [18911] = 18911,
  [18912] = 18912,
  [18913] = 18913,
  [18914] = 18914,
  [18915] = 18915,
  [18916] = 18916,
  [18917] = 18917,
  [18918] = 18918,
  [18919] = 18919,
  [18920] = 18919,
  [18921] = 18919,
  [18922] = 18916,
  [18923] = 18923,
  [18924] = 18923,
  [18925] = 18925,
  [18926] = 18926,
  [18927] = 18925,
  [18928] = 18928,
  [18929] = 18929,
  [18930] = 18909,
  [18931] = 18931,
  [18932] = 18910,
  [18933] = 18916,
  [18934] = 18934,
  [18935] = 18913,
  [18936] = 18914,
  [18937] = 18915,
  [18938] = 18918,
  [18939] = 18939,
  [18940] = 18918,
  [18941] = 18941,
  [18942] = 18919,
  [18943] = 18915,
  [18944] = 18916,
  [18945] = 18914,
  [18946] = 18913,
  [18947] = 18947,
  [18948] = 18909,
  [18949] = 18925,
  [18950] = 18931,
  [18951] = 18909,
  [18952] = 18909,
  [18953] = 18931,
  [18954] = 18910,
  [18955] = 18931,
  [18956] = 18913,
  [18957] = 18914,
  [18958] = 18915,
  [18959] = 18910,
  [18960] = 18939,
  [18961] = 18918,
  [18962] = 18919,
  [18963] = 18916,
  [18964] = 18964,
  [18965] = 18918,
  [18966] = 18966,
  [18967] = 18947,
  [18968] = 18913,
  [18969] = 18928,
  [18970] = 18914,
  [18971] = 18915,
  [18972] = 18915,
  [18973] = 18910,
  [18974] = 18909,
  [18975] = 18909,
  [18976] = 18931,
  [18977] = 18910,
  [18978] = 18908,
  [18979] = 18918,
  [18980] = 18916,
  [18981] = 18913,
  [18982] = 18914,
  [18983] = 18915,
  [18984] = 18908,
  [18985] = 18911,
  [18986] = 18914,
  [18987] = 18918,
  [18988] = 18913,
  [18989] = 18989,
  [18990] = 18919,
  [18991] = 18926,
  [18992] = 18916,
  [18993] = 18912,
  [18994] = 18947,
  [18995] = 18908,
  [18996] = 18923,
  [18997] = 18919,
  [18998] = 18912,
  [18999] = 18916,
  [19000] = 18916,
  [19001] = 18966,
  [19002] = 18919,
  [19003] = 18911,
  [19004] = 18909,
  [19005] = 18931,
  [19006] = 18910,
  [19007] = 19007,
  [19008] = 18923,
  [19009] = 18925,
  [19010] = 18913,
  [19011] = 18914,
  [19012] = 18915,
  [19013] = 18141,
  [19014] = 18926,
  [19015] = 18912,
  [19016] = 18918,
  [19017] = 18964,
  [19018] = 18928,
  [19019] = 18919,
  [19020] = 18916,
  [19021] = 18916,
  [19022] = 19022,
  [19023] = 18918,
  [19024] = 18915,
  [19025] = 18919,
  [19026] = 18914,
  [19027] = 18913,
  [19028] = 18910,
  [19029] = 18931,
  [19030] = 18909,
  [19031] = 18926,
  [19032] = 18918,
  [19033] = 18909,
  [19034] = 18931,
  [19035] = 18910,
  [19036] = 18910,
  [19037] = 18947,
  [19038] = 18915,
  [19039] = 18913,
  [19040] = 18914,
  [19041] = 18915,
  [19042] = 18914,
  [19043] = 18910,
  [19044] = 18913,
  [19045] = 18918,
  [19046] = 18931,
  [19047] = 18939,
  [19048] = 18919,
  [19049] = 18909,
  [19050] = 18916,
  [19051] = 18910,
  [19052] = 19052,
  [19053] = 7725,
  [19054] = 18939,
  [19055] = 18931,
  [19056] = 18909,
  [19057] = 18934,
  [19058] = 18939,
  [19059] = 18909,
  [19060] = 19007,
  [19061] = 18931,
  [19062] = 18909,
  [19063] = 18931,
  [19064] = 18910,
  [19065] = 19065,
  [19066] = 18911,
  [19067] = 18908,
  [19068] = 18913,
  [19069] = 18914,
  [19070] = 18915,
  [19071] = 18947,
  [19072] = 18989,
  [19073] = 18915,
  [19074] = 18918,
  [19075] = 18911,
  [19076] = 19076,
  [19077] = 18919,
  [19078] = 19007,
  [19079] = 18916,
  [19080] = 18928,
  [19081] = 18928,
  [19082] = 19052,
  [19083] = 18917,
  [19084] = 18917,
  [19085] = 18947,
  [19086] = 18928,
  [19087] = 18916,
  [19088] = 18934,
  [19089] = 18908,
  [19090] = 18913,
  [19091] = 18909,
  [19092] = 18931,
  [19093] = 18910,
  [19094] = 18919,
  [19095] = 18911,
  [19096] = 18911,
  [19097] = 18913,
  [19098] = 18914,
  [19099] = 18915,
  [19100] = 18939,
  [19101] = 19052,
  [19102] = 18918,
  [19103] = 18918,
  [19104] = 18989,
  [19105] = 18914,
  [19106] = 18919,
  [19107] = 18909,
  [19108] = 18916,
  [19109] = 7862,
  [19110] = 18925,
  [19111] = 18931,
  [19112] = 18918,
  [19113] = 18910,
  [19114] = 18908,
  [19115] = 18915,
  [19116] = 18912,
  [19117] = 19007,
  [19118] = 18964,
  [19119] = 18914,
  [19120] = 18909,
  [19121] = 18931,
  [19122] = 18910,
  [19123] = 18913,
  [19124] = 18916,
  [19125] = 18919,
  [19126] = 18913,
  [19127] = 18914,
  [19128] = 18915,
  [19129] = 18923,
  [19130] = 18925,
  [19131] = 19131,
  [19132] = 18918,
  [19133] = 18910,
  [19134] = 18931,
  [19135] = 18919,
  [19136] = 18909,
  [19137] = 18916,
  [19138] = 18926,
  [19139] = 18966,
  [19140] = 18912,
  [19141] = 18908,
  [19142] = 18918,
  [19143] = 18923,
  [19144] = 18913,
  [19145] = 18915,
  [19146] = 18926,
  [19147] = 18989,
  [19148] = 18925,
  [19149] = 18909,
  [19150] = 18931,
  [19151] = 18910,
  [19152] = 18923,
  [19153] = 18914,
  [19154] = 18913,
  [19155] = 18913,
  [19156] = 18914,
  [19157] = 18915,
  [19158] = 18914,
  [19159] = 18947,
  [19160] = 18919,
  [19161] = 18918,
  [19162] = 18915,
  [19163] = 18916,
  [19164] = 18919,
  [19165] = 18916,
  [19166] = 18916,
  [19167] = 18910,
  [19168] = 18912,
  [19169] = 18931,
  [19170] = 18909,
  [19171] = 18919,
  [19172] = 18916,
  [19173] = 18918,
  [19174] = 13983,
  [19175] = 18919,
  [19176] = 18939,
  [19177] = 18918,
  [19178] = 18909,
  [19179] = 18931,
  [19180] = 18910,
  [19181] = 18917,
  [19182] = 18919,
  [19183] = 18923,
  [19184] = 18913,
  [19185] = 18914,
  [19186] = 18915,
  [19187] = 18915,
  [19188] = 18926,
  [19189] = 18923,
  [19190] = 18918,
  [19191] = 18928,
  [19192] = 18914,
  [19193] = 18919,
  [19194] = 18913,
  [19195] = 18916,
  [19196] = 18925,
  [19197] = 18925,
  [19198] = 18916,
  [19199] = 18931,
  [19200] = 18919,
  [19201] = 18911,
  [19202] = 18941,
  [19203] = 18910,
  [19204] = 18908,
  [19205] = 18931,
  [19206] = 18909,
  [19207] = 18931,
  [19208] = 18910,
  [19209] = 18909,
  [19210] = 18911,
  [19211] = 18916,
  [19212] = 18913,
  [19213] = 18914,
  [19214] = 18915,
  [19215] = 19215,
  [19216] = 18912,
  [19217] = 18918,
  [19218] = 18928,
  [19219] = 18908,
  [19220] = 18919,
  [19221] = 18912,
  [19222] = 18916,
  [19223] = 18916,
  [19224] = 18926,
  [19225] = 18919,
  [19226] = 18926,
  [19227] = 18923,
  [19228] = 18925,
  [19229] = 18192,
  [19230] = 18928,
  [19231] = 18909,
  [19232] = 18931,
  [19233] = 18910,
  [19234] = 18918,
  [19235] = 18926,
  [19236] = 18916,
  [19237] = 18919,
  [19238] = 18919,
  [19239] = 18934,
  [19240] = 19007,
  [19241] = 18918,
  [19242] = 18918,
  [19243] = 18939,
  [19244] = 18915,
  [19245] = 18914,
  [19246] = 18909,
  [19247] = 18931,
  [19248] = 18910,
  [19249] = 18913,
  [19250] = 18911,
  [19251] = 18908,
  [19252] = 18910,
  [19253] = 18919,
  [19254] = 18918,
  [19255] = 18989,
  [19256] = 18931,
  [19257] = 18915,
  [19258] = 18914,
  [19259] = 18909,
  [19260] = 18939,
  [19261] = 18909,
  [19262] = 18931,
  [19263] = 18910,
  [19264] = 19052,
  [19265] = 18913,
  [19266] = 7857,
  [19267] = 18909,
  [19268] = 18919,
  [19269] = 18915,
  [19270] = 18947,
  [19271] = 18914,
  [19272] = 18931,
  [19273] = 18913,
  [19274] = 18947,
  [19275] = 18910,
  [19276] = 18909,
  [19277] = 18931,
  [19278] = 18910,
  [19279] = 18909,
  [19280] = 18915,
  [19281] = 18910,
  [19282] = 18916,
  [19283] = 18919,
  [19284] = 18931,
  [19285] = 18909,
  [19286] = 18919,
  [19287] = 18931,
  [19288] = 18939,
  [19289] = 19289,
  [19290] = 18918,
  [19291] = 18909,
  [19292] = 18931,
  [19293] = 18910,
  [19294] = 18910,
  [19295] = 19295,
  [19296] = 18915,
  [19297] = 18914,
  [19298] = 18919,
  [19299] = 18913,
  [19300] = 18947,
  [19301] = 18966,
  [19302] = 18917,
  [19303] = 18914,
  [19304] = 18964,
  [19305] = 18910,
  [19306] = 18909,
  [19307] = 18931,
  [19308] = 18910,
  [19309] = 18931,
  [19310] = 18909,
  [19311] = 18928,
  [19312] = 18913,
  [19313] = 18919,
  [19314] = 18964,
  [19315] = 18928,
  [19316] = 18914,
  [19317] = 18915,
  [19318] = 18910,
  [19319] = 19319,
  [19320] = 18966,
  [19321] = 18909,
  [19322] = 18931,
  [19323] = 18910,
  [19324] = 18918,
  [19325] = 18913,
  [19326] = 18918,
  [19327] = 18923,
  [19328] = 18919,
  [19329] = 18919,
  [19330] = 18912,
  [19331] = 18909,
  [19332] = 18918,
  [19333] = 18947,
  [19334] = 18926,
  [19335] = 18909,
  [19336] = 18931,
  [19337] = 18910,
  [19338] = 18915,
  [19339] = 18914,
  [19340] = 18908,
  [19341] = 18913,
  [19342] = 18911,
  [19343] = 18925,
  [19344] = 19052,
  [19345] = 18910,
  [19346] = 18931,
  [19347] = 18909,
  [19348] = 18931,
  [19349] = 18910,
  [19350] = 18909,
  [19351] = 18914,
  [19352] = 18919,
  [19353] = 18916,
  [19354] = 18939,
  [19355] = 18934,
  [19356] = 18912,
  [19357] = 18947,
  [19358] = 18966,
  [19359] = 18909,
  [19360] = 18931,
  [19361] = 18910,
  [19362] = 18913,
  [19363] = 18939,
  [19364] = 19052,
  [19365] = 18964,
  [19366] = 18934,
  [19367] = 18916,
  [19368] = 18911,
  [19369] = 18912,
  [19370] = 18919,
  [19371] = 18909,
  [19372] = 18931,
  [19373] = 18910,
  [19374] = 18908,
  [19375] = 18918,
  [19376] = 18916,
  [19377] = 18910,
  [19378] = 18915,
  [19379] = 18909,
  [19380] = 18919,
  [19381] = 18923,
  [19382] = 18914,
  [19383] = 18909,
  [19384] = 18931,
  [19385] = 18910,
  [19386] = 18913,
  [19387] = 18925,
  [19388] = 18931,
  [19389] = 18910,
  [19390] = 18928,
  [19391] = 18926,
  [19392] = 18917,
  [19393] = 18931,
  [19394] = 18931,
  [19395] = 18909,
  [19396] = 18931,
  [19397] = 18910,
  [19398] = 18909,
  [19399] = 18910,
  [19400] = 18915,
  [19401] = 19052,
  [19402] = 18928,
  [19403] = 18964,
  [19404] = 18918,
  [19405] = 18918,
  [19406] = 18939,
  [19407] = 18909,
  [19408] = 18931,
  [19409] = 18910,
  [19410] = 18934,
  [19411] = 18916,
  [19412] = 18966,
  [19413] = 18919,
  [19414] = 18915,
  [19415] = 18914,
  [19416] = 18989,
  [19417] = 18913,
  [19418] = 18939,
  [19419] = 18909,
  [19420] = 18931,
  [19421] = 18910,
  [19422] = 18918,
  [19423] = 18947,
  [19424] = 18909,
  [19425] = 18931,
  [19426] = 18908,
  [19427] = 18915,
  [19428] = 18911,
  [19429] = 18914,
  [19430] = 18913,
  [19431] = 18909,
  [19432] = 18931,
  [19433] = 18910,
  [19434] = 18910,
  [19435] = 18910,
  [19436] = 18931,
  [19437] = 18910,
  [19438] = 19007,
  [19439] = 18909,
  [19440] = 18931,
  [19441] = 18909,
  [19442] = 18926,
  [19443] = 18909,
  [19444] = 18931,
  [19445] = 18910,
  [19446] = 19446,
  [19447] = 18939,
  [19448] = 18947,
  [19449] = 18913,
  [19450] = 18947,
  [19451] = 18913,
  [19452] = 18914,
  [19453] = 18915,
  [19454] = 18919,
  [19455] = 18909,
  [19456] = 18931,
  [19457] = 18910,
  [19458] = 18915,
  [19459] = 18916,
  [19460] = 18918,
  [19461] = 18928,
  [19462] = 18928,
  [19463] = 18916,
  [19464] = 18926,
  [19465] = 18917,
  [19466] = 18919,
  [19467] = 18909,
  [19468] = 18931,
  [19469] = 18910,
  [19470] = 18941,
  [19471] = 18908,
  [19472] = 18911,
  [19473] = 18918,
  [19474] = 18925,
  [19475] = 18923,
  [19476] = 18926,
  [19477] = 18919,
  [19478] = 18915,
  [19479] = 18909,
  [19480] = 18931,
  [19481] = 18910,
  [19482] = 18914,
  [19483] = 18913,
  [19484] = 18925,
  [19485] = 18923,
  [19486] = 18910,
  [19487] = 18917,
  [19488] = 18912,
  [19489] = 18912,
  [19490] = 18931,
  [19491] = 18909,
  [19492] = 18931,
  [19493] = 18910,
  [19494] = 18909,
  [19495] = 18916,
  [19496] = 18919,
  [19497] = 18914,
  [19498] = 18912,
  [19499] = 18923,
  [19500] = 18925,
  [19501] = 18919,
  [19502] = 18916,
  [19503] = 18909,
  [19504] = 18931,
  [19505] = 18910,
  [19506] = 18925,
  [19507] = 18926,
  [19508] = 18912,
  [19509] = 18923,
  [19510] = 18916,
  [19511] = 19511,
  [19512] = 18919,
  [19513] = 18916,
  [19514] = 18919,
  [19515] = 18909,
  [19516] = 18931,
  [19517] = 18910,
  [19518] = 18918,
  [19519] = 18918,
  [19520] = 18915,
  [19521] = 18911,
  [19522] = 18919,
  [19523] = 18914,
  [19524] = 18923,
  [19525] = 18913,
  [19526] = 18909,
  [19527] = 18909,
  [19528] = 18931,
  [19529] = 18910,
  [19530] = 18915,
  [19531] = 18947,
  [19532] = 18914,
  [19533] = 18913,
  [19534] = 18989,
  [19535] = 18925,
  [19536] = 19536,
  [19537] = 18908,
  [19538] = 19538,
  [19539] = 18910,
  [19540] = 18910,
  [19541] = 19541,
  [19542] = 19542,
  [19543] = 18931,
  [19544] = 18931,
  [19545] = 18909,
  [19546] = 18941,
  [19547] = 18911,
  [19548] = 19548,
  [19549] = 18909,
  [19550] = 18916,
  [19551] = 19007,
  [19552] = 18908,
  [19553] = 18926,
  [19554] = 18939,
  [19555] = 18911,
  [19556] = 18911,
  [19557] = 18908,
  [19558] = 18909,
  [19559] = 18912,
  [19560] = 18918,
  [19561] = 18909,
  [19562] = 19562,
  [19563] = 18989,
  [19564] = 18916,
  [19565] = 18931,
  [19566] = 18915,
  [19567] = 18914,
  [19568] = 18913,
  [19569] = 18915,
  [19570] = 18947,
  [19571] = 19571,
  [19572] = 19572,
  [19573] = 19573,
  [19574] = 18918,
  [19575] = 18910,
  [19576] = 19576,
  [19577] = 18928,
  [19578] = 18913,
  [19579] = 19579,
  [19580] = 18908,
  [19581] = 18911,
  [19582] = 18928,
  [19583] = 18915,
  [19584] = 18913,
  [19585] = 18914,
  [19586] = 18913,
  [19587] = 19076,
  [19588] = 18966,
  [19589] = 18928,
  [19590] = 19590,
  [19591] = 19591,
  [19592] = 18914,
  [19593] = 18915,
  [19594] = 18964,
  [19595] = 18912,
  [19596] = 18910,
  [19597] = 18910,
  [19598] = 18931,
  [19599] = 18931,
  [19600] = 18916,
  [19601] = 18909,
  [19602] = 19007,
  [19603] = 18918,
  [19604] = 18909,
  [19605] = 18919,
  [19606] = 18919,
  [19607] = 18923,
  [19608] = 19052,
  [19609] = 19609,
  [19610] = 18939,
  [19611] = 19611,
  [19612] = 18925,
  [19613] = 18916,
  [19614] = 19614,
  [19615] = 18934,
  [19616] = 18912,
  [19617] = 18926,
  [19618] = 19007,
  [19619] = 18916,
  [19620] = 19538,
  [19621] = 18909,
  [19622] = 18934,
  [19623] = 19541,
  [19624] = 18919,
  [19625] = 18918,
  [19626] = 19007,
  [19627] = 18917,
  [19628] = 18939,
  [19629] = 18931,
  [19630] = 18918,
  [19631] = 18989,
  [19632] = 18908,
  [19633] = 18911,
  [19634] = 19007,
  [19635] = 18910,
  [19636] = 19052,
  [19637] = 18916,
  [19638] = 18914,
  [19639] = 18913,
  [19640] = 18915,
  [19641] = 18947,
  [19642] = 19562,
  [19643] = 18914,
  [19644] = 18913,
  [19645] = 18913,
  [19646] = 18910,
  [19647] = 18912,
  [19648] = 18931,
  [19649] = 18909,
  [19650] = 19571,
  [19651] = 19572,
  [19652] = 18910,
  [19653] = 18916,
  [19654] = 18931,
  [19655] = 18919,
  [19656] = 19579,
  [19657] = 19657,
  [19658] = 18909,
  [19659] = 18923,
  [19660] = 18911,
  [19661] = 18914,
  [19662] = 18909,
  [19663] = 19076,
  [19664] = 18931,
  [19665] = 19591,
  [19666] = 18939,
  [19667] = 18908,
  [19668] = 18925,
  [19669] = 18910,
  [19670] = 18915,
  [19671] = 18918,
  [19672] = 18989,
  [19673] = 19541,
  [19674] = 18916,
  [19675] = 18919,
  [19676] = 18941,
  [19677] = 18916,
  [19678] = 18916,
  [19679] = 18964,
  [19680] = 18966,
  [19681] = 18926,
  [19682] = 18928,
  [19683] = 18947,
  [19684] = 18919,
  [19685] = 19562,
  [19686] = 18913,
  [19687] = 18931,
  [19688] = 18918,
  [19689] = 18914,
  [19690] = 18918,
  [19691] = 18915,
  [19692] = 18908,
  [19693] = 18915,
  [19694] = 18914,
  [19695] = 19579,
  [19696] = 18913,
  [19697] = 18911,
  [19698] = 18947,
  [19699] = 18919,
  [19700] = 18918,
  [19701] = 18923,
  [19702] = 18925,
  [19703] = 18926,
  [19704] = 19541,
  [19705] = 18915,
  [19706] = 18912,
  [19707] = 18966,
  [19708] = 18914,
  [19709] = 18964,
  [19710] = 18918,
  [19711] = 18910,
  [19712] = 18910,
  [19713] = 18931,
  [19714] = 18909,
  [19715] = 18931,
  [19716] = 19562,
  [19717] = 18909,
  [19718] = 18909,
  [19719] = 19052,
  [19720] = 18939,
  [19721] = 18917,
  [19722] = 18966,
  [19723] = 18934,
  [19724] = 18919,
  [19725] = 18923,
  [19726] = 18925,
  [19727] = 18931,
  [19728] = 18910,
  [19729] = 18926,
  [19730] = 19541,
  [19731] = 18928,
  [19732] = 18913,
  [19733] = 18925,
  [19734] = 18928,
  [19735] = 18917,
  [19736] = 18923,
  [19737] = 18914,
  [19738] = 18916,
  [19739] = 18919,
  [19740] = 18918,
  [19741] = 18915,
  [19742] = 19742,
  [19743] = 18916,
  [19744] = 18919,
  [19745] = 18915,
  [19746] = 18914,
  [19747] = 18913,
  [19748] = 18947,
  [19749] = 18918,
  [19750] = 18989,
  [19751] = 18908,
  [19752] = 18918,
  [19753] = 18912,
  [19754] = 19541,
  [19755] = 18919,
  [19756] = 19756,
  [19757] = 18911,
  [19758] = 19007,
  [19759] = 18916,
  [19760] = 18915,
  [19761] = 18910,
  [19762] = 18931,
  [19763] = 18909,
  [19764] = 18914,
  [19765] = 18913,
  [19766] = 18926,
  [19767] = 18910,
  [19768] = 18939,
  [19769] = 18912,
  [19770] = 18931,
  [19771] = 18926,
  [19772] = 18916,
  [19773] = 18928,
  [19774] = 18909,
  [19775] = 18919,
  [19776] = 19541,
  [19777] = 18934,
  [19778] = 19778,
  [19779] = 18923,
  [19780] = 18939,
  [19781] = 19007,
  [19782] = 18925,
  [19783] = 19052,
  [19784] = 18918,
  [19785] = 18941,
  [19786] = 18909,
  [19787] = 18911,
  [19788] = 18931,
  [19789] = 18908,
  [19790] = 19790,
  [19791] = 18916,
  [19792] = 18926,
  [19793] = 14130,
  [19794] = 18989,
  [19795] = 18910,
  [19796] = 18919,
  [19797] = 19797,
  [19798] = 19541,
  [19799] = 18909,
  [19800] = 18918,
  [19801] = 18918,
  [19802] = 18908,
  [19803] = 18911,
  [19804] = 18915,
  [19805] = 18914,
  [19806] = 18913,
  [19807] = 18913,
  [19808] = 18914,
  [19809] = 18947,
  [19810] = 18915,
  [19811] = 18914,
  [19812] = 18913,
  [19813] = 18928,
  [19814] = 18915,
  [19815] = 18912,
  [19816] = 18916,
  [19817] = 18919,
  [19818] = 18910,
  [19819] = 18931,
  [19820] = 19541,
  [19821] = 18909,
  [19822] = 18919,
  [19823] = 18964,
  [19824] = 18923,
  [19825] = 19825,
  [19826] = 18910,
  [19827] = 18931,
  [19828] = 18909,
  [19829] = 18931,
  [19830] = 18925,
  [19831] = 19831,
  [19832] = 19052,
  [19833] = 18939,
  [19834] = 18910,
  [19835] = 18934,
  [19836] = 18915,
  [19837] = 18964,
  [19838] = 19541,
  [19839] = 18913,
  [19840] = 18916,
  [19841] = 18926,
  [19842] = 18914,
  [19843] = 18928,
  [19844] = 18917,
  [19845] = 18916,
  [19846] = 18913,
  [19847] = 18919,
  [19848] = 18966,
  [19849] = 18939,
  [19850] = 18989,
  [19851] = 19052,
  [19852] = 18908,
  [19853] = 18911,
  [19854] = 18918,
  [19855] = 19007,
  [19856] = 19541,
  [19857] = 18947,
  [19858] = 18918,
  [19859] = 18915,
  [19860] = 18914,
  [19861] = 18915,
  [19862] = 18914,
  [19863] = 18913,
  [19864] = 18913,
  [19865] = 18909,
  [19866] = 18947,
  [19867] = 18912,
  [19868] = 18931,
  [19869] = 18916,
  [19870] = 18909,
  [19871] = 18910,
  [19872] = 18931,
  [19873] = 18919,
  [19874] = 19541,
  [19875] = 18909,
  [19876] = 18910,
  [19877] = 18923,
  [19878] = 18910,
  [19879] = 18925,
  [19880] = 18931,
  [19881] = 18989,
  [19882] = 18909,
  [19883] = 18941,
  [19884] = 18913,
  [19885] = 18910,
  [19886] = 18914,
  [19887] = 18915,
  [19888] = 18939,
  [19889] = 18947,
  [19890] = 18913,
  [19891] = 18926,
  [19892] = 19541,
  [19893] = 18918,
  [19894] = 18916,
  [19895] = 18966,
  [19896] = 18964,
  [19897] = 18966,
  [19898] = 19898,
  [19899] = 18918,
  [19900] = 18919,
  [19901] = 18928,
  [19902] = 18914,
  [19903] = 18947,
  [19904] = 18915,
  [19905] = 18914,
  [19906] = 18913,
  [19907] = 18918,
  [19908] = 18947,
  [19909] = 19541,
  [19910] = 18915,
  [19911] = 18913,
  [19912] = 18914,
  [19913] = 18915,
  [19914] = 18908,
  [19915] = 18919,
  [19916] = 18966,
  [19917] = 18911,
  [19918] = 19918,
  [19919] = 18964,
  [19920] = 18918,
  [19921] = 18915,
  [19922] = 18910,
  [19923] = 18931,
  [19924] = 18914,
  [19925] = 18909,
  [19926] = 19541,
  [19927] = 18913,
  [19928] = 18916,
  [19929] = 18964,
  [19930] = 18912,
  [19931] = 19052,
  [19932] = 18939,
  [19933] = 18910,
  [19934] = 18934,
  [19935] = 18931,
  [19936] = 18947,
  [19937] = 18916,
  [19938] = 18919,
  [19939] = 18923,
  [19940] = 18925,
  [19941] = 18909,
  [19942] = 18910,
  [19943] = 19541,
  [19944] = 19052,
  [19945] = 18926,
  [19946] = 18918,
  [19947] = 18928,
  [19948] = 18917,
  [19949] = 18931,
  [19950] = 18909,
  [19951] = 18925,
  [19952] = 18918,
  [19953] = 18923,
  [19954] = 18919,
  [19955] = 18989,
  [19956] = 18908,
  [19957] = 18911,
  [19958] = 18931,
  [19959] = 18915,
  [19960] = 19541,
  [19961] = 18910,
  [19962] = 19007,
  [19963] = 18916,
  [19964] = 18914,
  [19965] = 18913,
  [19966] = 18918,
  [19967] = 18919,
  [19968] = 18919,
  [19969] = 18926,
  [19970] = 18916,
  [19971] = 18918,
  [19972] = 18914,
  [19973] = 18912,
  [19974] = 18910,
  [19975] = 18915,
  [19976] = 19976,
  [19977] = 19541,
  [19978] = 18918,
  [19979] = 18931,
  [19980] = 18916,
  [19981] = 18909,
  [19982] = 18915,
  [19983] = 19579,
  [19984] = 18923,
  [19985] = 18914,
  [19986] = 18912,
  [19987] = 18912,
  [19988] = 18925,
  [19989] = 18939,
  [19990] = 18913,
  [19991] = 18941,
  [19992] = 18910,
  [19993] = 18931,
  [19994] = 19541,
  [19995] = 18909,
  [19996] = 18919,
  [19997] = 18916,
  [19998] = 18911,
  [19999] = 18926,
  [20000] = 20000,
  [20001] = 18919,
  [20002] = 18908,
  [20003] = 18928,
  [20004] = 18939,
  [20005] = 20005,
  [20006] = 18925,
  [20007] = 20007,
  [20008] = 18934,
  [20009] = 18916,
  [20010] = 18916,
  [20011] = 19541,
  [20012] = 18919,
  [20013] = 18909,
  [20014] = 18918,
  [20015] = 18918,
  [20016] = 18923,
  [20017] = 9467,
  [20018] = 18931,
  [20019] = 18931,
  [20020] = 18915,
  [20021] = 18910,
  [20022] = 18914,
  [20023] = 18908,
  [20024] = 18913,
  [20025] = 18911,
  [20026] = 18915,
  [20027] = 18914,
  [20028] = 19541,
  [20029] = 18913,
  [20030] = 20030,
  [20031] = 20031,
  [20032] = 18947,
  [20033] = 18913,
  [20034] = 18928,
  [20035] = 18910,
  [20036] = 18931,
  [20037] = 18909,
  [20038] = 20038,
  [20039] = 18919,
  [20040] = 18966,
  [20041] = 18939,
  [20042] = 18964,
  [20043] = 18914,
  [20044] = 18916,
  [20045] = 19541,
  [20046] = 20046,
  [20047] = 18912,
  [20048] = 18915,
  [20049] = 18910,
  [20050] = 18931,
  [20051] = 18925,
  [20052] = 18909,
  [20053] = 18909,
  [20054] = 19052,
  [20055] = 19052,
  [20056] = 18939,
  [20057] = 18912,
  [20058] = 18934,
  [20059] = 18919,
  [20060] = 20060,
  [20061] = 19541,
  [20062] = 18916,
  [20063] = 18916,
  [20064] = 18916,
  [20065] = 18919,
  [20066] = 18923,
  [20067] = 18928,
  [20068] = 18917,
  [20069] = 18925,
  [20070] = 20070,
  [20071] = 18919,
  [20072] = 18928,
  [20073] = 18918,
  [20074] = 18926,
  [20075] = 19541,
  [20076] = 18917,
  [20077] = 20077,
  [20078] = 18989,
  [20079] = 18908,
  [20080] = 18911,
  [20081] = 18915,
  [20082] = 18919,
  [20083] = 19446,
  [20084] = 19065,
  [20085] = 19007,
  [20086] = 18914,
  [20087] = 18913,
  [20088] = 18909,
  [20089] = 19541,
  [20090] = 18910,
  [20091] = 18931,
  [20092] = 18931,
  [20093] = 18910,
  [20094] = 18947,
  [20095] = 18923,
  [20096] = 18919,
  [20097] = 18918,
  [20098] = 18915,
  [20099] = 19831,
  [20100] = 20100,
  [20101] = 20101,
  [20102] = 18909,
  [20103] = 19541,
  [20104] = 18931,
  [20105] = 18914,
  [20106] = 18912,
  [20107] = 18913,
  [20108] = 18916,
  [20109] = 18923,
  [20110] = 18964,
  [20111] = 18919,
  [20112] = 18923,
  [20113] = 18910,
  [20114] = 18925,
  [20115] = 18916,
  [20116] = 18913,
  [20117] = 19541,
  [20118] = 18919,
  [20119] = 18910,
  [20120] = 18914,
  [20121] = 18941,
  [20122] = 18918,
  [20123] = 18931,
  [20124] = 18909,
  [20125] = 18915,
  [20126] = 18966,
  [20127] = 18939,
  [20128] = 18926,
  [20129] = 18918,
  [20130] = 18915,
  [20131] = 19541,
  [20132] = 18914,
  [20133] = 18913,
  [20134] = 18947,
  [20135] = 20135,
  [20136] = 20005,
  [20137] = 18928,
  [20138] = 18919,
  [20139] = 20007,
  [20140] = 18910,
  [20141] = 18918,
  [20142] = 18931,
  [20143] = 18909,
  [20144] = 18913,
  [20145] = 19541,
  [20146] = 18916,
  [20147] = 18989,
  [20148] = 18915,
  [20149] = 18914,
  [20150] = 18913,
  [20151] = 20030,
  [20152] = 20031,
  [20153] = 18947,
  [20154] = 18914,
  [20155] = 18908,
  [20156] = 18915,
  [20157] = 18911,
  [20158] = 19007,
  [20159] = 19541,
  [20160] = 18911,
  [20161] = 18918,
  [20162] = 18966,
  [20163] = 18908,
  [20164] = 18964,
  [20165] = 18941,
  [20166] = 20166,
  [20167] = 18911,
  [20168] = 18916,
  [20169] = 19007,
  [20170] = 18910,
  [20171] = 18919,
  [20172] = 18908,
  [20173] = 19541,
  [20174] = 18918,
  [20175] = 18989,
  [20176] = 18931,
  [20177] = 18909,
  [20178] = 18915,
  [20179] = 18926,
  [20180] = 19052,
  [20181] = 18939,
  [20182] = 18914,
  [20183] = 18934,
  [20184] = 18913,
  [20185] = 18909,
  [20186] = 20186,
  [20187] = 19541,
  [20188] = 18931,
  [20189] = 18910,
  [20190] = 18931,
  [20191] = 18909,
  [20192] = 18928,
  [20193] = 20193,
  [20194] = 20194,
  [20195] = 18917,
  [20196] = 18912,
  [20197] = 20070,
  [20198] = 18913,
  [20199] = 18914,
  [20200] = 18915,
  [20201] = 19541,
  [20202] = 18918,
  [20203] = 18917,
  [20204] = 18916,
  [20205] = 18916,
  [20206] = 18919,
  [20207] = 18923,
  [20208] = 18926,
  [20209] = 18989,
  [20210] = 18925,
  [20211] = 18908,
  [20212] = 18911,
  [20213] = 18919,
  [20214] = 18928,
  [20215] = 19541,
  [20216] = 18918,
  [20217] = 18926,
  [20218] = 19446,
  [20219] = 19065,
  [20220] = 19007,
  [20221] = 18925,
  [20222] = 18915,
  [20223] = 18916,
  [20224] = 18915,
  [20225] = 18914,
  [20226] = 18913,
  [20227] = 20227,
  [20228] = 18910,
  [20229] = 19541,
  [20230] = 18931,
  [20231] = 18909,
  [20232] = 18919,
  [20233] = 19831,
  [20234] = 18909,
  [20235] = 18918,
  [20236] = 18934,
  [20237] = 18912,
  [20238] = 18915,
  [20239] = 18914,
  [20240] = 18916,
  [20241] = 18931,
  [20242] = 18913,
  [20243] = 19541,
  [20244] = 18939,
  [20245] = 18910,
  [20246] = 18919,
  [20247] = 18923,
  [20248] = 18947,
  [20249] = 19052,
  [20250] = 18910,
  [20251] = 18925,
  [20252] = 18931,
  [20253] = 18909,
  [20254] = 18916,
  [20255] = 18913,
  [20256] = 18919,
  [20257] = 19541,
  [20258] = 18914,
  [20259] = 18941,
  [20260] = 18918,
  [20261] = 18916,
  [20262] = 18939,
  [20263] = 20263,
  [20264] = 18912,
  [20265] = 18926,
  [20266] = 18915,
  [20267] = 18918,
  [20268] = 18928,
  [20269] = 18966,
  [20270] = 18914,
  [20271] = 19541,
  [20272] = 18913,
  [20273] = 20135,
  [20274] = 20005,
  [20275] = 20007,
  [20276] = 18919,
  [20277] = 18910,
  [20278] = 18918,
  [20279] = 18947,
  [20280] = 18931,
  [20281] = 18909,
  [20282] = 18915,
  [20283] = 18916,
  [20284] = 18914,
  [20285] = 19541,
  [20286] = 20286,
  [20287] = 18913,
  [20288] = 20030,
  [20289] = 20031,
  [20290] = 18947,
  [20291] = 18909,
  [20292] = 18908,
  [20293] = 18911,
  [20294] = 18912,
  [20295] = 18966,
  [20296] = 18911,
  [20297] = 18931,
  [20298] = 18964,
  [20299] = 19541,
  [20300] = 18916,
  [20301] = 18908,
  [20302] = 18910,
  [20303] = 18910,
  [20304] = 18931,
  [20305] = 18909,
  [20306] = 20135,
  [20307] = 18966,
  [20308] = 20005,
  [20309] = 18916,
  [20310] = 19052,
  [20311] = 18919,
  [20312] = 18939,
  [20313] = 19541,
  [20314] = 18910,
  [20315] = 18918,
  [20316] = 20316,
  [20317] = 18934,
  [20318] = 18909,
  [20319] = 18915,
  [20320] = 18914,
  [20321] = 18928,
  [20322] = 18917,
  [20323] = 18912,
  [20324] = 20070,
  [20325] = 18913,
  [20326] = 18916,
  [20327] = 19541,
  [20328] = 18931,
  [20329] = 18910,
  [20330] = 18910,
  [20331] = 18919,
  [20332] = 18923,
  [20333] = 18925,
  [20334] = 18931,
  [20335] = 18926,
  [20336] = 18909,
  [20337] = 18964,
  [20338] = 18928,
  [20339] = 18913,
  [20340] = 20340,
  [20341] = 19541,
  [20342] = 18914,
  [20343] = 18915,
  [20344] = 20344,
  [20345] = 18918,
  [20346] = 18915,
  [20347] = 20347,
  [20348] = 18914,
  [20349] = 18913,
  [20350] = 18916,
  [20351] = 18913,
  [20352] = 18910,
  [20353] = 18918,
  [20354] = 18931,
  [20355] = 19541,
  [20356] = 18925,
  [20357] = 18909,
  [20358] = 18916,
  [20359] = 20359,
  [20360] = 18919,
  [20361] = 18939,
  [20362] = 18919,
  [20363] = 18918,
  [20364] = 18916,
  [20365] = 18989,
  [20366] = 20366,
  [20367] = 18915,
  [20368] = 19541,
  [20369] = 18914,
  [20370] = 18913,
  [20371] = 19657,
  [20372] = 18908,
  [20373] = 18911,
  [20374] = 18910,
  [20375] = 18931,
  [20376] = 20007,
  [20377] = 18939,
  [20378] = 19446,
  [20379] = 20379,
  [20380] = 19541,
  [20381] = 19065,
  [20382] = 18928,
  [20383] = 19052,
  [20384] = 19541,
  [20385] = 18909,
  [20386] = 20386,
  [20387] = 18929,
  [20388] = 19541,
  [20389] = 18909,
  [20390] = 18931,
  [20391] = 19572,
  [20392] = 19541,
  [20393] = 20393,
  [20394] = 19131,
  [20395] = 18910,
  [20396] = 19541,
  [20397] = 3481,
  [20398] = 19007,
  [20399] = 14286,
  [20400] = 19541,
  [20401] = 18908,
  [20402] = 19609,
  [20403] = 18911,
  [20404] = 19541,
  [20405] = 19571,
  [20406] = 18909,
  [20407] = 18931,
  [20408] = 19541,
  [20409] = 18910,
  [20410] = 19756,
  [20411] = 20411,
  [20412] = 19541,
  [20413] = 18947,
  [20414] = 18964,
  [20415] = 18913,
  [20416] = 19541,
  [20417] = 18914,
  [20418] = 19831,
  [20419] = 18913,
  [20420] = 19541,
  [20421] = 18912,
  [20422] = 18914,
  [20423] = 19579,
  [20424] = 19541,
  [20425] = 18916,
  [20426] = 18912,
  [20427] = 18915,
  [20428] = 19541,
  [20429] = 18947,
  [20430] = 18919,
  [20431] = 20431,
  [20432] = 19541,
  [20433] = 18916,
  [20434] = 18923,
  [20435] = 20060,
  [20436] = 19541,
  [20437] = 18919,
  [20438] = 18923,
  [20439] = 18925,
  [20440] = 19541,
  [20441] = 18925,
  [20442] = 18919,
  [20443] = 18914,
  [20444] = 19541,
  [20445] = 18941,
  [20446] = 18918,
  [20447] = 18926,
  [20448] = 19541,
  [20449] = 18913,
  [20450] = 18914,
  [20451] = 18926,
  [20452] = 19541,
  [20453] = 18915,
  [20454] = 19590,
  [20455] = 20135,
  [20456] = 19541,
  [20457] = 18918,
  [20458] = 20005,
  [20459] = 18926,
  [20460] = 19541,
  [20461] = 18918,
  [20462] = 18918,
  [20463] = 18915,
  [20464] = 19541,
  [20465] = 18915,
  [20466] = 20007,
  [20467] = 18914,
  [20468] = 19541,
  [20469] = 18914,
  [20470] = 18918,
  [20471] = 18913,
  [20472] = 19541,
  [20473] = 18918,
  [20474] = 18915,
  [20475] = 18947,
  [20476] = 19541,
  [20477] = 18915,
  [20478] = 18914,
  [20479] = 18913,
  [20480] = 19541,
  [20481] = 18914,
  [20482] = 20030,
  [20483] = 18913,
  [20484] = 19541,
  [20485] = 20031,
  [20486] = 18947,
  [20487] = 18947,
  [20488] = 19541,
  [20489] = 18919,
  [20490] = 18910,
  [20491] = 18931,
  [20492] = 19541,
  [20493] = 18910,
  [20494] = 18931,
  [20495] = 18909,
  [20496] = 19541,
  [20497] = 18966,
  [20498] = 18909,
  [20499] = 18964,
  [20500] = 19541,
  [20501] = 18916,
  [20502] = 18915,
  [20503] = 18910,
  [20504] = 19541,
  [20505] = 18931,
  [20506] = 18909,
  [20507] = 18918,
  [20508] = 19541,
  [20509] = 18926,
  [20510] = 19052,
  [20511] = 20030,
  [20512] = 19541,
  [20513] = 18939,
  [20514] = 18939,
  [20515] = 20031,
  [20516] = 19541,
  [20517] = 18947,
  [20518] = 20340,
  [20519] = 18918,
  [20520] = 19541,
  [20521] = 18934,
  [20522] = 18909,
  [20523] = 18925,
  [20524] = 19541,
  [20525] = 18923,
  [20526] = 18919,
  [20527] = 18916,
  [20528] = 19541,
  [20529] = 18916,
  [20530] = 18928,
  [20531] = 18928,
  [20532] = 19541,
  [20533] = 20533,
  [20534] = 18917,
  [20535] = 18912,
  [20536] = 19541,
  [20537] = 20537,
  [20538] = 18931,
  [20539] = 18919,
  [20540] = 19541,
  [20541] = 20541,
  [20542] = 20070,
  [20543] = 18966,
  [20544] = 19541,
  [20545] = 18931,
  [20546] = 18910,
  [20547] = 18918,
  [20548] = 19541,
  [20549] = 18908,
  [20550] = 18911,
  [20551] = 18923,
  [20552] = 19541,
  [20553] = 18964,
  [20554] = 18914,
  [20555] = 18915,
  [20556] = 19541,
  [20557] = 18914,
  [20558] = 18913,
  [20559] = 18910,
  [20560] = 19541,
  [20561] = 18911,
  [20562] = 18908,
  [20563] = 18909,
  [20564] = 19541,
  [20565] = 18912,
  [20566] = 18915,
  [20567] = 18916,
  [20568] = 19541,
  [20569] = 18915,
  [20570] = 18928,
  [20571] = 18919,
  [20572] = 19541,
  [20573] = 18910,
  [20574] = 20340,
  [20575] = 18923,
  [20576] = 19541,
  [20577] = 18925,
  [20578] = 20344,
  [20579] = 18931,
  [20580] = 19541,
  [20581] = 19562,
  [20582] = 18926,
  [20583] = 18909,
  [20584] = 19541,
  [20585] = 18926,
  [20586] = 20347,
  [20587] = 18918,
  [20588] = 19541,
  [20589] = 18916,
  [20590] = 18919,
  [20591] = 18916,
  [20592] = 19541,
  [20593] = 18913,
  [20594] = 18939,
  [20595] = 18918,
  [20596] = 19541,
  [20597] = 19052,
  [20598] = 18915,
  [20599] = 20359,
  [20600] = 19541,
  [20601] = 18947,
  [20602] = 18914,
  [20603] = 18913,
  [20604] = 19541,
  [20605] = 18989,
  [20606] = 18910,
  [20607] = 19052,
  [20608] = 19541,
  [20609] = 18919,
  [20610] = 18909,
  [20611] = 18918,
  [20612] = 19541,
  [20613] = 18910,
  [20614] = 19657,
  [20615] = 18931,
  [20616] = 19541,
  [20617] = 19611,
  [20618] = 18908,
  [20619] = 19052,
  [20620] = 19541,
  [20621] = 18911,
  [20622] = 18909,
  [20623] = 18939,
  [20624] = 19541,
  [20625] = 20359,
  [20626] = 18909,
  [20627] = 18931,
  [20628] = 19541,
  [20629] = 19446,
  [20630] = 18931,
  [20631] = 19215,
  [20632] = 19541,
  [20633] = 19065,
  [20634] = 3543,
  [20635] = 18910,
  [20636] = 19541,
  [20637] = 18929,
  [20638] = 18939,
  [20639] = 18915,
  [20640] = 19541,
  [20641] = 19131,
  [20642] = 18914,
  [20643] = 18913,
  [20644] = 19541,
  [20645] = 19007,
  [20646] = 18910,
  [20647] = 18964,
  [20648] = 19541,
  [20649] = 19609,
  [20650] = 18947,
  [20651] = 18928,
  [20652] = 19541,
  [20653] = 18913,
  [20654] = 18913,
  [20655] = 19541,
  [20656] = 18914,
  [20657] = 18915,
  [20658] = 19541,
  [20659] = 19756,
  [20660] = 7703,
  [20661] = 19541,
  [20662] = 18910,
  [20663] = 18931,
  [20664] = 19541,
  [20665] = 19831,
  [20666] = 18918,
  [20667] = 19541,
  [20668] = 18908,
  [20669] = 18911,
  [20670] = 19541,
  [20671] = 18909,
  [20672] = 19579,
  [20673] = 19541,
  [20674] = 18926,
  [20675] = 18912,
  [20676] = 19541,
  [20677] = 18913,
  [20678] = 18916,
  [20679] = 19541,
  [20680] = 18914,
  [20681] = 20060,
  [20682] = 19541,
  [20683] = 18919,
  [20684] = 18923,
  [20685] = 19541,
  [20686] = 18925,
  [20687] = 18923,
  [20688] = 19541,
  [20689] = 18925,
  [20690] = 18919,
  [20691] = 19541,
  [20692] = 18923,
  [20693] = 18912,
  [20694] = 19541,
  [20695] = 18941,
  [20696] = 18919,
  [20697] = 19541,
  [20698] = 18916,
  [20699] = 18934,
  [20700] = 19541,
  [20701] = 18916,
  [20702] = 18915,
  [20703] = 19541,
  [20704] = 18926,
  [20705] = 18964,
  [20706] = 19541,
  [20707] = 18919,
  [20708] = 18923,
  [20709] = 19541,
  [20710] = 18925,
  [20711] = 20711,
  [20712] = 19541,
  [20713] = 20135,
  [20714] = 20005,
  [20715] = 19541,
  [20716] = 18916,
  [20717] = 18926,
  [20718] = 19541,
  [20719] = 18918,
  [20720] = 18919,
  [20721] = 19541,
  [20722] = 18916,
  [20723] = 18916,
  [20724] = 20007,
  [20725] = 18919,
  [20726] = 18912,
  [20727] = 20537,
  [20728] = 18918,
  [20729] = 18918,
  [20730] = 18917,
  [20731] = 20411,
  [20732] = 18918,
  [20733] = 19591,
  [20734] = 18939,
  [20735] = 18915,
  [20736] = 18914,
  [20737] = 18913,
  [20738] = 18931,
  [20739] = 18915,
  [20740] = 18909,
  [20741] = 20537,
  [20742] = 18914,
  [20743] = 18910,
  [20744] = 18913,
  [20745] = 20411,
  [20746] = 20030,
  [20747] = 18931,
  [20748] = 18909,
  [20749] = 20344,
  [20750] = 20031,
  [20751] = 18909,
  [20752] = 20537,
  [20753] = 18947,
  [20754] = 18931,
  [20755] = 18915,
  [20756] = 20411,
  [20757] = 18910,
  [20758] = 18914,
  [20759] = 18913,
  [20760] = 20537,
  [20761] = 18913,
  [20762] = 18914,
  [20763] = 20411,
  [20764] = 18916,
  [20765] = 18947,
  [20766] = 18915,
  [20767] = 20537,
  [20768] = 18966,
  [20769] = 18919,
  [20770] = 20411,
  [20771] = 18918,
  [20772] = 18964,
  [20773] = 18918,
  [20774] = 20537,
  [20775] = 18916,
  [20776] = 18915,
  [20777] = 20411,
  [20778] = 18914,
  [20779] = 18964,
  [20780] = 18913,
  [20781] = 20537,
  [20782] = 18910,
  [20783] = 18919,
  [20784] = 20411,
  [20785] = 18916,
  [20786] = 18931,
  [20787] = 18910,
  [20788] = 20537,
  [20789] = 18931,
  [20790] = 18909,
  [20791] = 20411,
  [20792] = 19007,
  [20793] = 18910,
  [20794] = 18911,
  [20795] = 20537,
  [20796] = 18928,
  [20797] = 20411,
  [20798] = 18939,
  [20799] = 20533,
  [20800] = 18908,
  [20801] = 20537,
  [20802] = 18989,
  [20803] = 20411,
  [20804] = 18934,
  [20805] = 18931,
  [20806] = 20347,
  [20807] = 20537,
  [20808] = 18909,
  [20809] = 20411,
  [20810] = 18916,
  [20811] = 18909,
  [20812] = 18919,
  [20813] = 20537,
  [20814] = 18909,
  [20815] = 20411,
  [20816] = 18918,
  [20817] = 19052,
  [20818] = 18931,
  [20819] = 20537,
  [20820] = 18939,
  [20821] = 20411,
  [20822] = 18910,
  [20823] = 18915,
  [20824] = 18914,
  [20825] = 20537,
  [20826] = 18913,
  [20827] = 20411,
  [20828] = 18913,
  [20829] = 18934,
  [20830] = 18914,
  [20831] = 20537,
  [20832] = 18910,
  [20833] = 20411,
  [20834] = 18931,
  [20835] = 18909,
  [20836] = 18915,
  [20837] = 20537,
  [20838] = 19052,
  [20839] = 20411,
  [20840] = 18917,
  [20841] = 18939,
  [20842] = 18928,
  [20843] = 20537,
  [20844] = 18928,
  [20845] = 20411,
  [20846] = 18918,
  [20847] = 19541,
  [20848] = 18919,
  [20849] = 20537,
  [20850] = 18934,
  [20851] = 20411,
  [20852] = 18916,
  [20853] = 20533,
  [20854] = 18928,
  [20855] = 20537,
  [20856] = 18917,
  [20857] = 20411,
  [20858] = 18916,
  [20859] = 18917,
  [20860] = 18919,
  [20861] = 20537,
  [20862] = 18912,
  [20863] = 20411,
  [20864] = 18931,
  [20865] = 18918,
  [20866] = 19052,
  [20867] = 20537,
  [20868] = 18915,
  [20869] = 20411,
  [20870] = 18914,
  [20871] = 20871,
  [20872] = 18913,
  [20873] = 20537,
  [20874] = 20070,
  [20875] = 20411,
  [20876] = 18910,
  [20877] = 20537,
  [20878] = 20070,
  [20879] = 18931,
  [20880] = 20537,
  [20881] = 18909,
  [20882] = 18909,
  [20883] = 20537,
  [20884] = 18909,
  [20885] = 18931,
  [20886] = 20537,
  [20887] = 18931,
  [20888] = 18910,
  [20889] = 20537,
  [20890] = 18910,
  [20891] = 18925,
  [20892] = 20537,
  [20893] = 18916,
  [20894] = 18919,
  [20895] = 20537,
  [20896] = 18964,
  [20897] = 18918,
  [20898] = 20537,
  [20899] = 18914,
  [20900] = 18915,
  [20901] = 20537,
  [20902] = 18913,
  [20903] = 18915,
  [20904] = 20537,
  [20905] = 20905,
  [20906] = 18914,
  [20907] = 20537,
  [20908] = 18928,
  [20909] = 18913,
  [20910] = 20537,
  [20911] = 18989,
  [20912] = 18910,
  [20913] = 20537,
  [20914] = 18931,
  [20915] = 18909,
  [20916] = 20537,
  [20917] = 19538,
  [20918] = 18919,
  [20919] = 20537,
  [20920] = 18966,
  [20921] = 18916,
  [20922] = 20537,
  [20923] = 18908,
  [20924] = 18911,
  [20925] = 20537,
  [20926] = 19007,
  [20927] = 18916,
  [20928] = 20537,
  [20929] = 18919,
  [20930] = 18909,
  [20931] = 20537,
  [20932] = 18918,
  [20933] = 18931,
  [20934] = 20537,
  [20935] = 18910,
  [20936] = 18915,
  [20937] = 20537,
  [20938] = 18914,
  [20939] = 18913,
  [20940] = 20537,
  [20941] = 20941,
  [20942] = 18913,
  [20943] = 20537,
  [20944] = 18914,
  [20945] = 18910,
  [20946] = 18931,
  [20947] = 18909,
  [20948] = 18947,
  [20949] = 18913,
  [20950] = 18914,
  [20951] = 18915,
  [20952] = 18915,
  [20953] = 18918,
  [20954] = 18919,
  [20955] = 18918,
  [20956] = 18916,
  [20957] = 18916,
  [20958] = 18919,
  [20959] = 18918,
  [20960] = 18912,
  [20961] = 18915,
  [20962] = 18914,
  [20963] = 18913,
  [20964] = 18909,
  [20965] = 18931,
  [20966] = 18910,
  [20967] = 18931,
  [20968] = 18909,
  [20969] = 18910,
  [20970] = 18926,
  [20971] = 18918,
  [20972] = 18925,
  [20973] = 18908,
  [20974] = 18914,
  [20975] = 18923,
  [20976] = 18919,
  [20977] = 18916,
  [20978] = 18919,
  [20979] = 18911,
  [20980] = 18918,
  [20981] = 18919,
  [20982] = 18913,
  [20983] = 18918,
  [20984] = 18915,
  [20985] = 18914,
  [20986] = 18913,
  [20987] = 18915,
  [20988] = 18916,
  [20989] = 18910,
};

static inline bool sym__varid_character_set_1(int32_t c) {
  return (c < 8458
    ? (c < 7296
      ? (c < 891
        ? (c < 445
          ? (c < 223
            ? (c < 181
              ? (c >= '_' && c <= 'z')
              : c <= 181)
            : (c <= 246 || (c >= 248 && c <= 442)))
          : (c <= 447 || (c < 881
            ? (c < 661
              ? (c >= 454 && c <= 659)
              : c <= 687)
            : (c <= 883 || c == 887))))
        : (c <= 893 || (c < 1376
          ? (c < 1016
            ? (c < 940
              ? c == 912
              : c <= 1013)
            : (c <= 1153 || (c >= 1163 && c <= 1327)))
          : (c <= 1416 || (c < 4349
            ? (c >= 4304 && c <= 4346)
            : (c <= 4351 || (c >= 5112 && c <= 5117)))))))
      : (c <= 7304 || (c < 8118
        ? (c < 7968
          ? (c < 7545
            ? (c < 7531
              ? (c >= 7424 && c <= 7467)
              : c <= 7543)
            : (c <= 7578 || (c >= 7681 && c <= 7957)))
          : (c <= 8005 || (c < 8032
            ? (c >= 8016 && c <= 8023)
            : (c <= 8061 || (c >= 8064 && c <= 8116)))))
        : (c <= 8119 || (c < 8150
          ? (c < 8134
            ? (c < 8130
              ? c == 8126
              : c <= 8132)
            : (c <= 8135 || (c >= 8144 && c <= 8147)))
          : (c <= 8151 || (c < 8178
            ? (c >= 8160 && c <= 8167)
            : (c <= 8180 || (c >= 8182 && c <= 8183)))))))))
    : (c <= 8467 || (c < 42897
      ? (c < 11507
        ? (c < 8526
          ? (c < 8508
            ? (c < 8505
              ? (c >= 8495 && c <= 8500)
              : c <= 8505)
            : (c <= 8509 || (c >= 8518 && c <= 8521)))
          : (c <= 8526 || (c < 11393
            ? (c < 11312
              ? c == 8580
              : c <= 11387)
            : (c <= 11492 || (c >= 11500 && c <= 11502)))))
        : (c <= 11507 || (c < 42625
          ? (c < 11565
            ? (c < 11559
              ? (c >= 11520 && c <= 11557)
              : c <= 11559)
            : (c <= 11565 || (c >= 42561 && c <= 42605)))
          : (c <= 42651 || (c < 42865
            ? (c >= 42787 && c <= 42863)
            : (c <= 42887 || (c >= 42892 && c <= 42894)))))))
      : (c <= 42954 || (c < 64256
        ? (c < 43002
          ? (c < 42965
            ? (c < 42963
              ? c == 42961
              : c <= 42963)
            : (c <= 42969 || c == 42998))
          : (c <= 43002 || (c < 43872
            ? (c >= 43824 && c <= 43866)
            : (c <= 43880 || (c >= 43888 && c <= 43967)))))
        : (c <= 64262 || (c < 66967
          ? (c < 66600
            ? (c < 65345
              ? (c >= 64275 && c <= 64279)
              : c <= 65370)
            : (c <= 66639 || (c >= 66776 && c <= 66811)))
          : (c <= 66977 || (c < 66995
            ? (c >= 66979 && c <= 66993)
            : (c <= 67001 || (c >= 67003 && c <= 67004)))))))))));
}

static inline bool sym__varid_character_set_2(int32_t c) {
  return (c < 8458
    ? (c < 5112
      ? (c < 887
        ? (c < 248
          ? (c < 181
            ? (c < 'a'
              ? c == '_'
              : c <= 'z')
            : (c <= 181 || (c >= 223 && c <= 246)))
          : (c <= 442 || (c < 661
            ? (c < 454
              ? (c >= 445 && c <= 447)
              : c <= 659)
            : (c <= 687 || (c >= 881 && c <= 883)))))
        : (c <= 887 || (c < 1163
          ? (c < 940
            ? (c < 912
              ? (c >= 891 && c <= 893)
              : c <= 912)
            : (c <= 1013 || (c >= 1016 && c <= 1153)))
          : (c <= 1327 || (c < 4304
            ? (c >= 1376 && c <= 1416)
            : (c <= 4346 || (c >= 4349 && c <= 4351)))))))
      : (c <= 5117 || (c < 8118
        ? (c < 7681
          ? (c < 7531
            ? (c < 7424
              ? (c >= 7296 && c <= 7304)
              : c <= 7467)
            : (c <= 7543 || (c >= 7545 && c <= 7578)))
          : (c <= 7957 || (c < 8032
            ? (c < 8016
              ? (c >= 7968 && c <= 8005)
              : c <= 8023)
            : (c <= 8061 || (c >= 8064 && c <= 8116)))))
        : (c <= 8119 || (c < 8150
          ? (c < 8134
            ? (c < 8130
              ? c == 8126
              : c <= 8132)
            : (c <= 8135 || (c >= 8144 && c <= 8147)))
          : (c <= 8151 || (c < 8178
            ? (c >= 8160 && c <= 8167)
            : (c <= 8180 || (c >= 8182 && c <= 8183)))))))))
    : (c <= 8467 || (c < 42897
      ? (c < 11507
        ? (c < 8526
          ? (c < 8508
            ? (c < 8505
              ? (c >= 8495 && c <= 8500)
              : c <= 8505)
            : (c <= 8509 || (c >= 8518 && c <= 8521)))
          : (c <= 8526 || (c < 11393
            ? (c < 11312
              ? c == 8580
              : c <= 11387)
            : (c <= 11492 || (c >= 11500 && c <= 11502)))))
        : (c <= 11507 || (c < 42625
          ? (c < 11565
            ? (c < 11559
              ? (c >= 11520 && c <= 11557)
              : c <= 11559)
            : (c <= 11565 || (c >= 42561 && c <= 42605)))
          : (c <= 42651 || (c < 42865
            ? (c >= 42787 && c <= 42863)
            : (c <= 42887 || (c >= 42892 && c <= 42894)))))))
      : (c <= 42954 || (c < 64256
        ? (c < 43002
          ? (c < 42965
            ? (c < 42963
              ? c == 42961
              : c <= 42963)
            : (c <= 42969 || c == 42998))
          : (c <= 43002 || (c < 43872
            ? (c >= 43824 && c <= 43866)
            : (c <= 43880 || (c >= 43888 && c <= 43967)))))
        : (c <= 64262 || (c < 66967
          ? (c < 66600
            ? (c < 65345
              ? (c >= 64275 && c <= 64279)
              : c <= 65370)
            : (c <= 66639 || (c >= 66776 && c <= 66811)))
          : (c <= 66977 || (c < 66995
            ? (c >= 66979 && c <= 66993)
            : (c <= 67001 || (c >= 67003 && c <= 67004)))))))))));
}

static inline bool sym__immediate_varid_character_set_1(int32_t c) {
  return (c < 7749
    ? (c < 987
      ? (c < 424
        ? (c < 326
          ? (c < 285
            ? (c < 265
              ? (c < 248
                ? (c < 181
                  ? (c < 'a'
                    ? c == '_'
                    : c <= 'z')
                  : (c <= 181 || (c >= 223 && c <= 246)))
                : (c <= 255 || (c < 261
                  ? (c < 259
                    ? c == 257
                    : c <= 259)
                  : (c <= 261 || c == 263))))
              : (c <= 265 || (c < 275
                ? (c < 271
                  ? (c < 269
                    ? c == 267
                    : c <= 269)
                  : (c <= 271 || c == 273))
                : (c <= 275 || (c < 281
                  ? (c < 279
                    ? c == 277
                    : c <= 279)
                  : (c <= 281 || c == 283))))))
            : (c <= 285 || (c < 305
              ? (c < 295
                ? (c < 291
                  ? (c < 289
                    ? c == 287
                    : c <= 289)
                  : (c <= 291 || c == 293))
                : (c <= 295 || (c < 301
                  ? (c < 299
                    ? c == 297
                    : c <= 299)
                  : (c <= 301 || c == 303))))
              : (c <= 305 || (c < 316
                ? (c < 311
                  ? (c < 309
                    ? c == 307
                    : c <= 309)
                  : (c <= 312 || c == 314))
                : (c <= 316 || (c < 322
                  ? (c < 320
                    ? c == 318
                    : c <= 320)
                  : (c <= 322 || c == 324))))))))
          : (c <= 326 || (c < 367
            ? (c < 347
              ? (c < 337
                ? (c < 333
                  ? (c < 331
                    ? (c >= 328 && c <= 329)
                    : c <= 331)
                  : (c <= 333 || c == 335))
                : (c <= 337 || (c < 343
                  ? (c < 341
                    ? c == 339
                    : c <= 341)
                  : (c <= 343 || c == 345))))
              : (c <= 347 || (c < 357
                ? (c < 353
                  ? (c < 351
                    ? c == 349
                    : c <= 351)
                  : (c <= 353 || c == 355))
                : (c <= 357 || (c < 363
                  ? (c < 361
                    ? c == 359
                    : c <= 361)
                  : (c <= 363 || c == 365))))))
            : (c <= 367 || (c < 392
              ? (c < 378
                ? (c < 373
                  ? (c < 371
                    ? c == 369
                    : c <= 371)
                  : (c <= 373 || c == 375))
                : (c <= 378 || (c < 387
                  ? (c < 382
                    ? c == 380
                    : c <= 384)
                  : (c <= 387 || c == 389))))
              : (c <= 392 || (c < 414
                ? (c < 405
                  ? (c < 402
                    ? (c >= 396 && c <= 397)
                    : c <= 402)
                  : (c <= 405 || (c >= 409 && c <= 411)))
                : (c <= 414 || (c < 419
                  ? c == 417
                  : (c <= 419 || c == 421))))))))))
        : (c <= 424 || (c < 523
          ? (c < 481
            ? (c < 460
              ? (c < 438
                ? (c < 432
                  ? (c < 429
                    ? (c >= 426 && c <= 427)
                    : c <= 429)
                  : (c <= 432 || c == 436))
                : (c <= 438 || (c < 454
                  ? (c < 445
                    ? (c >= 441 && c <= 442)
                    : c <= 447)
                  : (c <= 454 || c == 457))))
              : (c <= 460 || (c < 470
                ? (c < 466
                  ? (c < 464
                    ? c == 462
                    : c <= 464)
                  : (c <= 466 || c == 468))
                : (c <= 470 || (c < 476
                  ? (c < 474
                    ? c == 472
                    : c <= 474)
                  : (c <= 477 || c == 479))))))
            : (c <= 481 || (c < 505
              ? (c < 491
                ? (c < 487
                  ? (c < 485
                    ? c == 483
                    : c <= 485)
                  : (c <= 487 || c == 489))
                : (c <= 491 || (c < 499
                  ? (c < 495
                    ? c == 493
                    : c <= 496)
                  : (c <= 499 || c == 501))))
              : (c <= 505 || (c < 515
                ? (c < 511
                  ? (c < 509
                    ? c == 507
                    : c <= 509)
                  : (c <= 511 || c == 513))
                : (c <= 515 || (c < 519
                  ? c == 517
                  : (c <= 519 || c == 521))))))))
          : (c <= 523 || (c < 563
            ? (c < 543
              ? (c < 533
                ? (c < 529
                  ? (c < 527
                    ? c == 525
                    : c <= 527)
                  : (c <= 529 || c == 531))
                : (c <= 533 || (c < 539
                  ? (c < 537
                    ? c == 535
                    : c <= 537)
                  : (c <= 539 || c == 541))))
              : (c <= 543 || (c < 553
                ? (c < 549
                  ? (c < 547
                    ? c == 545
                    : c <= 547)
                  : (c <= 549 || c == 551))
                : (c <= 553 || (c < 559
                  ? (c < 557
                    ? c == 555
                    : c <= 557)
                  : (c <= 559 || c == 561))))))
            : (c <= 569 || (c < 881
              ? (c < 585
                ? (c < 578
                  ? (c < 575
                    ? c == 572
                    : c <= 576)
                  : (c <= 578 || c == 583))
                : (c <= 585 || (c < 591
                  ? (c < 589
                    ? c == 587
                    : c <= 589)
                  : (c <= 659 || (c >= 661 && c <= 687)))))
              : (c <= 881 || (c < 940
                ? (c < 891
                  ? (c < 887
                    ? c == 883
                    : c <= 887)
                  : (c <= 893 || c == 912))
                : (c <= 974 || (c < 981
                  ? (c >= 976 && c <= 977)
                  : (c <= 983 || c == 985))))))))))))
      : (c <= 987 || (c < 1257
        ? (c < 1177
          ? (c < 1131
            ? (c < 1007
              ? (c < 997
                ? (c < 993
                  ? (c < 991
                    ? c == 989
                    : c <= 991)
                  : (c <= 993 || c == 995))
                : (c <= 997 || (c < 1003
                  ? (c < 1001
                    ? c == 999
                    : c <= 1001)
                  : (c <= 1003 || c == 1005))))
              : (c <= 1011 || (c < 1121
                ? (c < 1019
                  ? (c < 1016
                    ? c == 1013
                    : c <= 1016)
                  : (c <= 1020 || (c >= 1072 && c <= 1119)))
                : (c <= 1121 || (c < 1127
                  ? (c < 1125
                    ? c == 1123
                    : c <= 1125)
                  : (c <= 1127 || c == 1129))))))
            : (c <= 1131 || (c < 1151
              ? (c < 1141
                ? (c < 1137
                  ? (c < 1135
                    ? c == 1133
                    : c <= 1135)
                  : (c <= 1137 || c == 1139))
                : (c <= 1141 || (c < 1147
                  ? (c < 1145
                    ? c == 1143
                    : c <= 1145)
                  : (c <= 1147 || c == 1149))))
              : (c <= 1151 || (c < 1169
                ? (c < 1165
                  ? (c < 1163
                    ? c == 1153
                    : c <= 1163)
                  : (c <= 1165 || c == 1167))
                : (c <= 1169 || (c < 1173
                  ? c == 1171
                  : (c <= 1173 || c == 1175))))))))
          : (c <= 1177 || (c < 1218
            ? (c < 1197
              ? (c < 1187
                ? (c < 1183
                  ? (c < 1181
                    ? c == 1179
                    : c <= 1181)
                  : (c <= 1183 || c == 1185))
                : (c <= 1187 || (c < 1193
                  ? (c < 1191
                    ? c == 1189
                    : c <= 1191)
                  : (c <= 1193 || c == 1195))))
              : (c <= 1197 || (c < 1207
                ? (c < 1203
                  ? (c < 1201
                    ? c == 1199
                    : c <= 1201)
                  : (c <= 1203 || c == 1205))
                : (c <= 1207 || (c < 1213
                  ? (c < 1211
                    ? c == 1209
                    : c <= 1211)
                  : (c <= 1213 || c == 1215))))))
            : (c <= 1218 || (c < 1239
              ? (c < 1228
                ? (c < 1224
                  ? (c < 1222
                    ? c == 1220
                    : c <= 1222)
                  : (c <= 1224 || c == 1226))
                : (c <= 1228 || (c < 1235
                  ? (c < 1233
                    ? (c >= 1230 && c <= 1231)
                    : c <= 1233)
                  : (c <= 1235 || c == 1237))))
              : (c <= 1239 || (c < 1249
                ? (c < 1245
                  ? (c < 1243
                    ? c == 1241
                    : c <= 1243)
                  : (c <= 1245 || c == 1247))
                : (c <= 1249 || (c < 1253
                  ? c == 1251
                  : (c <= 1253 || c == 1255))))))))))
        : (c <= 1257 || (c < 5112
          ? (c < 1297
            ? (c < 1277
              ? (c < 1267
                ? (c < 1263
                  ? (c < 1261
                    ? c == 1259
                    : c <= 1261)
                  : (c <= 1263 || c == 1265))
                : (c <= 1267 || (c < 1273
                  ? (c < 1271
                    ? c == 1269
                    : c <= 1271)
                  : (c <= 1273 || c == 1275))))
              : (c <= 1277 || (c < 1287
                ? (c < 1283
                  ? (c < 1281
                    ? c == 1279
                    : c <= 1281)
                  : (c <= 1283 || c == 1285))
                : (c <= 1287 || (c < 1293
                  ? (c < 1291
                    ? c == 1289
                    : c <= 1291)
                  : (c <= 1293 || c == 1295))))))
            : (c <= 1297 || (c < 1317
              ? (c < 1307
                ? (c < 1303
                  ? (c < 1301
                    ? c == 1299
                    : c <= 1301)
                  : (c <= 1303 || c == 1305))
                : (c <= 1307 || (c < 1313
                  ? (c < 1311
                    ? c == 1309
                    : c <= 1311)
                  : (c <= 1313 || c == 1315))))
              : (c <= 1317 || (c < 1327
                ? (c < 1323
                  ? (c < 1321
                    ? c == 1319
                    : c <= 1321)
                  : (c <= 1323 || c == 1325))
                : (c <= 1327 || (c < 4304
                  ? (c >= 1376 && c <= 1416)
                  : (c <= 4346 || (c >= 4349 && c <= 4351)))))))))
          : (c <= 5117 || (c < 7711
            ? (c < 7691
              ? (c < 7681
                ? (c < 7531
                  ? (c < 7424
                    ? (c >= 7296 && c <= 7304)
                    : c <= 7467)
                  : (c <= 7543 || (c >= 7545 && c <= 7578)))
                : (c <= 7681 || (c < 7687
                  ? (c < 7685
                    ? c == 7683
                    : c <= 7685)
                  : (c <= 7687 || c == 7689))))
              : (c <= 7691 || (c < 7701
                ? (c < 7697
                  ? (c < 7695
                    ? c == 7693
                    : c <= 7695)
                  : (c <= 7697 || c == 7699))
                : (c <= 7701 || (c < 7707
                  ? (c < 7705
                    ? c == 7703
                    : c <= 7705)
                  : (c <= 7707 || c == 7709))))))
            : (c <= 7711 || (c < 7731
              ? (c < 7721
                ? (c < 7717
                  ? (c < 7715
                    ? c == 7713
                    : c <= 7715)
                  : (c <= 7717 || c == 7719))
                : (c <= 7721 || (c < 7727
                  ? (c < 7725
                    ? c == 7723
                    : c <= 7725)
                  : (c <= 7727 || c == 7729))))
              : (c <= 7731 || (c < 7741
                ? (c < 7737
                  ? (c < 7735
                    ? c == 7733
                    : c <= 7735)
                  : (c <= 7737 || c == 7739))
                : (c <= 7741 || (c < 7745
                  ? c == 7743
                  : (c <= 7745 || c == 7747))))))))))))))
    : (c <= 7749 || (c < 11447
      ? (c < 7913
        ? (c < 7827
          ? (c < 7789
            ? (c < 7769
              ? (c < 7759
                ? (c < 7755
                  ? (c < 7753
                    ? c == 7751
                    : c <= 7753)
                  : (c <= 7755 || c == 7757))
                : (c <= 7759 || (c < 7765
                  ? (c < 7763
                    ? c == 7761
                    : c <= 7763)
                  : (c <= 7765 || c == 7767))))
              : (c <= 7769 || (c < 7779
                ? (c < 7775
                  ? (c < 7773
                    ? c == 7771
                    : c <= 7773)
                  : (c <= 7775 || c == 7777))
                : (c <= 7779 || (c < 7785
                  ? (c < 7783
                    ? c == 7781
                    : c <= 7783)
                  : (c <= 7785 || c == 7787))))))
            : (c <= 7789 || (c < 7809
              ? (c < 7799
                ? (c < 7795
                  ? (c < 7793
                    ? c == 7791
                    : c <= 7793)
                  : (c <= 7795 || c == 7797))
                : (c <= 7799 || (c < 7805
                  ? (c < 7803
                    ? c == 7801
                    : c <= 7803)
                  : (c <= 7805 || c == 7807))))
              : (c <= 7809 || (c < 7819
                ? (c < 7815
                  ? (c < 7813
                    ? c == 7811
                    : c <= 7813)
                  : (c <= 7815 || c == 7817))
                : (c <= 7819 || (c < 7823
                  ? c == 7821
                  : (c <= 7823 || c == 7825))))))))
          : (c <= 7827 || (c < 7875
            ? (c < 7855
              ? (c < 7845
                ? (c < 7841
                  ? (c < 7839
                    ? (c >= 7829 && c <= 7837)
                    : c <= 7839)
                  : (c <= 7841 || c == 7843))
                : (c <= 7845 || (c < 7851
                  ? (c < 7849
                    ? c == 7847
                    : c <= 7849)
                  : (c <= 7851 || c == 7853))))
              : (c <= 7855 || (c < 7865
                ? (c < 7861
                  ? (c < 7859
                    ? c == 7857
                    : c <= 7859)
                  : (c <= 7861 || c == 7863))
                : (c <= 7865 || (c < 7871
                  ? (c < 7869
                    ? c == 7867
                    : c <= 7869)
                  : (c <= 7871 || c == 7873))))))
            : (c <= 7875 || (c < 7895
              ? (c < 7885
                ? (c < 7881
                  ? (c < 7879
                    ? c == 7877
                    : c <= 7879)
                  : (c <= 7881 || c == 7883))
                : (c <= 7885 || (c < 7891
                  ? (c < 7889
                    ? c == 7887
                    : c <= 7889)
                  : (c <= 7891 || c == 7893))))
              : (c <= 7895 || (c < 7905
                ? (c < 7901
                  ? (c < 7899
                    ? c == 7897
                    : c <= 7899)
                  : (c <= 7901 || c == 7903))
                : (c <= 7905 || (c < 7909
                  ? c == 7907
                  : (c <= 7909 || c == 7911))))))))))
        : (c <= 7913 || (c < 8518
          ? (c < 8080
            ? (c < 7933
              ? (c < 7923
                ? (c < 7919
                  ? (c < 7917
                    ? c == 7915
                    : c <= 7917)
                  : (c <= 7919 || c == 7921))
                : (c <= 7923 || (c < 7929
                  ? (c < 7927
                    ? c == 7925
                    : c <= 7927)
                  : (c <= 7929 || c == 7931))))
              : (c <= 7933 || (c < 8000
                ? (c < 7968
                  ? (c < 7952
                    ? (c >= 7935 && c <= 7943)
                    : c <= 7957)
                  : (c <= 7975 || (c >= 7984 && c <= 7991)))
                : (c <= 8005 || (c < 8048
                  ? (c < 8032
                    ? (c >= 8016 && c <= 8023)
                    : c <= 8039)
                  : (c <= 8061 || (c >= 8064 && c <= 8071)))))))
            : (c <= 8087 || (c < 8178
              ? (c < 8130
                ? (c < 8118
                  ? (c < 8112
                    ? (c >= 8096 && c <= 8103)
                    : c <= 8116)
                  : (c <= 8119 || c == 8126))
                : (c <= 8132 || (c < 8150
                  ? (c < 8144
                    ? (c >= 8134 && c <= 8135)
                    : c <= 8147)
                  : (c <= 8151 || (c >= 8160 && c <= 8167)))))
              : (c <= 8180 || (c < 8495
                ? (c < 8462
                  ? (c < 8458
                    ? (c >= 8182 && c <= 8183)
                    : c <= 8458)
                  : (c <= 8463 || c == 8467))
                : (c <= 8495 || (c < 8505
                  ? c == 8500
                  : (c <= 8505 || (c >= 8508 && c <= 8509)))))))))
          : (c <= 8521 || (c < 11409
            ? (c < 11379
              ? (c < 11365
                ? (c < 11312
                  ? (c < 8580
                    ? c == 8526
                    : c <= 8580)
                  : (c <= 11359 || c == 11361))
                : (c <= 11366 || (c < 11372
                  ? (c < 11370
                    ? c == 11368
                    : c <= 11370)
                  : (c <= 11372 || c == 11377))))
              : (c <= 11380 || (c < 11399
                ? (c < 11395
                  ? (c < 11393
                    ? (c >= 11382 && c <= 11387)
                    : c <= 11393)
                  : (c <= 11395 || c == 11397))
                : (c <= 11399 || (c < 11405
                  ? (c < 11403
                    ? c == 11401
                    : c <= 11403)
                  : (c <= 11405 || c == 11407))))))
            : (c <= 11409 || (c < 11429
              ? (c < 11419
                ? (c < 11415
                  ? (c < 11413
                    ? c == 11411
                    : c <= 11413)
                  : (c <= 11415 || c == 11417))
                : (c <= 11419 || (c < 11425
                  ? (c < 11423
                    ? c == 11421
                    : c <= 11423)
                  : (c <= 11425 || c == 11427))))
              : (c <= 11429 || (c < 11439
                ? (c < 11435
                  ? (c < 11433
                    ? c == 11431
                    : c <= 11433)
                  : (c <= 11435 || c == 11437))
                : (c <= 11439 || (c < 11443
                  ? c == 11441
                  : (c <= 11443 || c == 11445))))))))))))
      : (c <= 11447 || (c < 42813
        ? (c < 42581
          ? (c < 11487
            ? (c < 11467
              ? (c < 11457
                ? (c < 11453
                  ? (c < 11451
                    ? c == 11449
                    : c <= 11451)
                  : (c <= 11453 || c == 11455))
                : (c <= 11457 || (c < 11463
                  ? (c < 11461
                    ? c == 11459
                    : c <= 11461)
                  : (c <= 11463 || c == 11465))))
              : (c <= 11467 || (c < 11477
                ? (c < 11473
                  ? (c < 11471
                    ? c == 11469
                    : c <= 11471)
                  : (c <= 11473 || c == 11475))
                : (c <= 11477 || (c < 11483
                  ? (c < 11481
                    ? c == 11479
                    : c <= 11481)
                  : (c <= 11483 || c == 11485))))))
            : (c <= 11487 || (c < 42563
              ? (c < 11507
                ? (c < 11500
                  ? (c < 11491
                    ? c == 11489
                    : c <= 11492)
                  : (c <= 11500 || c == 11502))
                : (c <= 11507 || (c < 11565
                  ? (c < 11559
                    ? (c >= 11520 && c <= 11557)
                    : c <= 11559)
                  : (c <= 11565 || c == 42561))))
              : (c <= 42563 || (c < 42573
                ? (c < 42569
                  ? (c < 42567
                    ? c == 42565
                    : c <= 42567)
                  : (c <= 42569 || c == 42571))
                : (c <= 42573 || (c < 42577
                  ? c == 42575
                  : (c <= 42577 || c == 42579))))))))
          : (c <= 42581 || (c < 42639
            ? (c < 42601
              ? (c < 42591
                ? (c < 42587
                  ? (c < 42585
                    ? c == 42583
                    : c <= 42585)
                  : (c <= 42587 || c == 42589))
                : (c <= 42591 || (c < 42597
                  ? (c < 42595
                    ? c == 42593
                    : c <= 42595)
                  : (c <= 42597 || c == 42599))))
              : (c <= 42601 || (c < 42629
                ? (c < 42625
                  ? (c < 42605
                    ? c == 42603
                    : c <= 42605)
                  : (c <= 42625 || c == 42627))
                : (c <= 42629 || (c < 42635
                  ? (c < 42633
                    ? c == 42631
                    : c <= 42633)
                  : (c <= 42635 || c == 42637))))))
            : (c <= 42639 || (c < 42793
              ? (c < 42649
                ? (c < 42645
                  ? (c < 42643
                    ? c == 42641
                    : c <= 42643)
                  : (c <= 42645 || c == 42647))
                : (c <= 42649 || (c < 42789
                  ? (c < 42787
                    ? c == 42651
                    : c <= 42787)
                  : (c <= 42789 || c == 42791))))
              : (c <= 42793 || (c < 42805
                ? (c < 42799
                  ? (c < 42797
                    ? c == 42795
                    : c <= 42797)
                  : (c <= 42801 || c == 42803))
                : (c <= 42805 || (c < 42809
                  ? c == 42807
                  : (c <= 42809 || c == 42811))))))))))
        : (c <= 42813 || (c < 42905
          ? (c < 42853
            ? (c < 42833
              ? (c < 42823
                ? (c < 42819
                  ? (c < 42817
                    ? c == 42815
                    : c <= 42817)
                  : (c <= 42819 || c == 42821))
                : (c <= 42823 || (c < 42829
                  ? (c < 42827
                    ? c == 42825
                    : c <= 42827)
                  : (c <= 42829 || c == 42831))))
              : (c <= 42833 || (c < 42843
                ? (c < 42839
                  ? (c < 42837
                    ? c == 42835
                    : c <= 42837)
                  : (c <= 42839 || c == 42841))
                : (c <= 42843 || (c < 42849
                  ? (c < 42847
                    ? c == 42845
                    : c <= 42847)
                  : (c <= 42849 || c == 42851))))))
            : (c <= 42853 || (c < 42881
              ? (c < 42863
                ? (c < 42859
                  ? (c < 42857
                    ? c == 42855
                    : c <= 42857)
                  : (c <= 42859 || c == 42861))
                : (c <= 42863 || (c < 42876
                  ? (c < 42874
                    ? (c >= 42865 && c <= 42872)
                    : c <= 42874)
                  : (c <= 42876 || c == 42879))))
              : (c <= 42881 || (c < 42894
                ? (c < 42887
                  ? (c < 42885
                    ? c == 42883
                    : c <= 42885)
                  : (c <= 42887 || c == 42892))
                : (c <= 42894 || (c < 42899
                  ? c == 42897
                  : (c <= 42901 || c == 42903))))))))
          : (c <= 42905 || (c < 42961
            ? (c < 42933
              ? (c < 42915
                ? (c < 42911
                  ? (c < 42909
                    ? c == 42907
                    : c <= 42909)
                  : (c <= 42911 || c == 42913))
                : (c <= 42915 || (c < 42921
                  ? (c < 42919
                    ? c == 42917
                    : c <= 42919)
                  : (c <= 42921 || c == 42927))))
              : (c <= 42933 || (c < 42943
                ? (c < 42939
                  ? (c < 42937
                    ? c == 42935
                    : c <= 42937)
                  : (c <= 42939 || c == 42941))
                : (c <= 42943 || (c < 42952
                  ? (c < 42947
                    ? c == 42945
                    : c <= 42947)
                  : (c <= 42952 || c == 42954))))))
            : (c <= 42961 || (c < 64256
              ? (c < 42998
                ? (c < 42967
                  ? (c < 42965
                    ? c == 42963
                    : c <= 42965)
                  : (c <= 42967 || c == 42969))
                : (c <= 42998 || (c < 43872
                  ? (c < 43824
                    ? c == 43002
                    : c <= 43866)
                  : (c <= 43880 || (c >= 43888 && c <= 43967)))))
              : (c <= 64262 || (c < 66967
                ? (c < 66600
                  ? (c < 65345
                    ? (c >= 64275 && c <= 64279)
                    : c <= 65370)
                  : (c <= 66639 || (c >= 66776 && c <= 66811)))
                : (c <= 66977 || (c < 66995
                  ? (c >= 66979 && c <= 66993)
                  : (c <= 67001 || (c >= 67003 && c <= 67004)))))))))))))))));
}

static inline bool sym__conid_character_set_1(int32_t c) {
  return (c < 7738
    ? (c < 931
      ? (c < 422
        ? (c < 327
          ? (c < 288
            ? (c < 268
              ? (c < 258
                ? (c < 216
                  ? (c < 192
                    ? (c >= 'A' && c <= 'Z')
                    : c <= 214)
                  : (c <= 222 || c == 256))
                : (c <= 258 || (c < 264
                  ? (c < 262
                    ? c == 260
                    : c <= 262)
                  : (c <= 264 || c == 266))))
              : (c <= 268 || (c < 278
                ? (c < 274
                  ? (c < 272
                    ? c == 270
                    : c <= 272)
                  : (c <= 274 || c == 276))
                : (c <= 278 || (c < 284
                  ? (c < 282
                    ? c == 280
                    : c <= 282)
                  : (c <= 284 || c == 286))))))
            : (c <= 288 || (c < 308
              ? (c < 298
                ? (c < 294
                  ? (c < 292
                    ? c == 290
                    : c <= 292)
                  : (c <= 294 || c == 296))
                : (c <= 298 || (c < 304
                  ? (c < 302
                    ? c == 300
                    : c <= 302)
                  : (c <= 304 || c == 306))))
              : (c <= 308 || (c < 319
                ? (c < 315
                  ? (c < 313
                    ? c == 310
                    : c <= 313)
                  : (c <= 315 || c == 317))
                : (c <= 319 || (c < 323
                  ? c == 321
                  : (c <= 323 || c == 325))))))))
          : (c <= 327 || (c < 366
            ? (c < 348
              ? (c < 338
                ? (c < 334
                  ? (c < 332
                    ? c == 330
                    : c <= 332)
                  : (c <= 334 || c == 336))
                : (c <= 338 || (c < 344
                  ? (c < 342
                    ? c == 340
                    : c <= 342)
                  : (c <= 344 || c == 346))))
              : (c <= 348 || (c < 358
                ? (c < 354
                  ? (c < 352
                    ? c == 350
                    : c <= 352)
                  : (c <= 354 || c == 356))
                : (c <= 358 || (c < 362
                  ? c == 360
                  : (c <= 362 || c == 364))))))
            : (c <= 366 || (c < 390
              ? (c < 376
                ? (c < 372
                  ? (c < 370
                    ? c == 368
                    : c <= 370)
                  : (c <= 372 || c == 374))
                : (c <= 377 || (c < 385
                  ? (c < 381
                    ? c == 379
                    : c <= 381)
                  : (c <= 386 || c == 388))))
              : (c <= 391 || (c < 412
                ? (c < 403
                  ? (c < 398
                    ? (c >= 393 && c <= 395)
                    : c <= 401)
                  : (c <= 404 || (c >= 406 && c <= 408)))
                : (c <= 413 || (c < 418
                  ? (c >= 415 && c <= 416)
                  : (c <= 418 || c == 420))))))))))
        : (c <= 423 || (c < 522
          ? (c < 480
            ? (c < 458
              ? (c < 437
                ? (c < 430
                  ? (c < 428
                    ? c == 425
                    : c <= 428)
                  : (c <= 431 || (c >= 433 && c <= 435)))
                : (c <= 437 || (c < 452
                  ? (c < 444
                    ? (c >= 439 && c <= 440)
                    : c <= 444)
                  : (c <= 453 || (c >= 455 && c <= 456)))))
              : (c <= 459 || (c < 469
                ? (c < 465
                  ? (c < 463
                    ? c == 461
                    : c <= 463)
                  : (c <= 465 || c == 467))
                : (c <= 469 || (c < 475
                  ? (c < 473
                    ? c == 471
                    : c <= 473)
                  : (c <= 475 || c == 478))))))
            : (c <= 480 || (c < 502
              ? (c < 490
                ? (c < 486
                  ? (c < 484
                    ? c == 482
                    : c <= 484)
                  : (c <= 486 || c == 488))
                : (c <= 490 || (c < 497
                  ? (c < 494
                    ? c == 492
                    : c <= 494)
                  : (c <= 498 || c == 500))))
              : (c <= 504 || (c < 514
                ? (c < 510
                  ? (c < 508
                    ? c == 506
                    : c <= 508)
                  : (c <= 510 || c == 512))
                : (c <= 514 || (c < 518
                  ? c == 516
                  : (c <= 518 || c == 520))))))))
          : (c <= 522 || (c < 560
            ? (c < 542
              ? (c < 532
                ? (c < 528
                  ? (c < 526
                    ? c == 524
                    : c <= 526)
                  : (c <= 528 || c == 530))
                : (c <= 532 || (c < 538
                  ? (c < 536
                    ? c == 534
                    : c <= 536)
                  : (c <= 538 || c == 540))))
              : (c <= 542 || (c < 552
                ? (c < 548
                  ? (c < 546
                    ? c == 544
                    : c <= 546)
                  : (c <= 548 || c == 550))
                : (c <= 552 || (c < 556
                  ? c == 554
                  : (c <= 556 || c == 558))))))
            : (c <= 560 || (c < 880
              ? (c < 579
                ? (c < 573
                  ? (c < 570
                    ? c == 562
                    : c <= 571)
                  : (c <= 574 || c == 577))
                : (c <= 582 || (c < 588
                  ? (c < 586
                    ? c == 584
                    : c <= 586)
                  : (c <= 588 || c == 590))))
              : (c <= 880 || (c < 904
                ? (c < 895
                  ? (c < 886
                    ? c == 882
                    : c <= 886)
                  : (c <= 895 || c == 902))
                : (c <= 906 || (c < 910
                  ? c == 908
                  : (c <= 911 || (c >= 913 && c <= 929)))))))))))))
      : (c <= 939 || (c < 1246
        ? (c < 1168
          ? (c < 1122
            ? (c < 998
              ? (c < 988
                ? (c < 984
                  ? (c < 978
                    ? c == 975
                    : c <= 980)
                  : (c <= 984 || c == 986))
                : (c <= 988 || (c < 994
                  ? (c < 992
                    ? c == 990
                    : c <= 992)
                  : (c <= 994 || c == 996))))
              : (c <= 998 || (c < 1012
                ? (c < 1004
                  ? (c < 1002
                    ? c == 1000
                    : c <= 1002)
                  : (c <= 1004 || c == 1006))
                : (c <= 1012 || (c < 1021
                  ? (c < 1017
                    ? c == 1015
                    : c <= 1018)
                  : (c <= 1071 || c == 1120))))))
            : (c <= 1122 || (c < 1142
              ? (c < 1132
                ? (c < 1128
                  ? (c < 1126
                    ? c == 1124
                    : c <= 1126)
                  : (c <= 1128 || c == 1130))
                : (c <= 1132 || (c < 1138
                  ? (c < 1136
                    ? c == 1134
                    : c <= 1136)
                  : (c <= 1138 || c == 1140))))
              : (c <= 1142 || (c < 1152
                ? (c < 1148
                  ? (c < 1146
                    ? c == 1144
                    : c <= 1146)
                  : (c <= 1148 || c == 1150))
                : (c <= 1152 || (c < 1164
                  ? c == 1162
                  : (c <= 1164 || c == 1166))))))))
          : (c <= 1168 || (c < 1206
            ? (c < 1188
              ? (c < 1178
                ? (c < 1174
                  ? (c < 1172
                    ? c == 1170
                    : c <= 1172)
                  : (c <= 1174 || c == 1176))
                : (c <= 1178 || (c < 1184
                  ? (c < 1182
                    ? c == 1180
                    : c <= 1182)
                  : (c <= 1184 || c == 1186))))
              : (c <= 1188 || (c < 1198
                ? (c < 1194
                  ? (c < 1192
                    ? c == 1190
                    : c <= 1192)
                  : (c <= 1194 || c == 1196))
                : (c <= 1198 || (c < 1202
                  ? c == 1200
                  : (c <= 1202 || c == 1204))))))
            : (c <= 1206 || (c < 1227
              ? (c < 1216
                ? (c < 1212
                  ? (c < 1210
                    ? c == 1208
                    : c <= 1210)
                  : (c <= 1212 || c == 1214))
                : (c <= 1217 || (c < 1223
                  ? (c < 1221
                    ? c == 1219
                    : c <= 1221)
                  : (c <= 1223 || c == 1225))))
              : (c <= 1227 || (c < 1238
                ? (c < 1234
                  ? (c < 1232
                    ? c == 1229
                    : c <= 1232)
                  : (c <= 1234 || c == 1236))
                : (c <= 1238 || (c < 1242
                  ? c == 1240
                  : (c <= 1242 || c == 1244))))))))))
        : (c <= 1246 || (c < 1324
          ? (c < 1286
            ? (c < 1266
              ? (c < 1256
                ? (c < 1252
                  ? (c < 1250
                    ? c == 1248
                    : c <= 1250)
                  : (c <= 1252 || c == 1254))
                : (c <= 1256 || (c < 1262
                  ? (c < 1260
                    ? c == 1258
                    : c <= 1260)
                  : (c <= 1262 || c == 1264))))
              : (c <= 1266 || (c < 1276
                ? (c < 1272
                  ? (c < 1270
                    ? c == 1268
                    : c <= 1270)
                  : (c <= 1272 || c == 1274))
                : (c <= 1276 || (c < 1282
                  ? (c < 1280
                    ? c == 1278
                    : c <= 1280)
                  : (c <= 1282 || c == 1284))))))
            : (c <= 1286 || (c < 1306
              ? (c < 1296
                ? (c < 1292
                  ? (c < 1290
                    ? c == 1288
                    : c <= 1290)
                  : (c <= 1292 || c == 1294))
                : (c <= 1296 || (c < 1302
                  ? (c < 1300
                    ? c == 1298
                    : c <= 1300)
                  : (c <= 1302 || c == 1304))))
              : (c <= 1306 || (c < 1316
                ? (c < 1312
                  ? (c < 1310
                    ? c == 1308
                    : c <= 1310)
                  : (c <= 1312 || c == 1314))
                : (c <= 1316 || (c < 1320
                  ? c == 1318
                  : (c <= 1320 || c == 1322))))))))
          : (c <= 1324 || (c < 7700
            ? (c < 7682
              ? (c < 4301
                ? (c < 4256
                  ? (c < 1329
                    ? c == 1326
                    : c <= 1366)
                  : (c <= 4293 || c == 4295))
                : (c <= 4301 || (c < 7357
                  ? (c < 7312
                    ? (c >= 5024 && c <= 5109)
                    : c <= 7354)
                  : (c <= 7359 || c == 7680))))
              : (c <= 7682 || (c < 7692
                ? (c < 7688
                  ? (c < 7686
                    ? c == 7684
                    : c <= 7686)
                  : (c <= 7688 || c == 7690))
                : (c <= 7692 || (c < 7696
                  ? c == 7694
                  : (c <= 7696 || c == 7698))))))
            : (c <= 7700 || (c < 7720
              ? (c < 7710
                ? (c < 7706
                  ? (c < 7704
                    ? c == 7702
                    : c <= 7704)
                  : (c <= 7706 || c == 7708))
                : (c <= 7710 || (c < 7716
                  ? (c < 7714
                    ? c == 7712
                    : c <= 7714)
                  : (c <= 7716 || c == 7718))))
              : (c <= 7720 || (c < 7730
                ? (c < 7726
                  ? (c < 7724
                    ? c == 7722
                    : c <= 7724)
                  : (c <= 7726 || c == 7728))
                : (c <= 7730 || (c < 7734
                  ? c == 7732
                  : (c <= 7734 || c == 7736))))))))))))))
    : (c <= 7738 || (c < 11428
      ? (c < 7900
        ? (c < 7816
          ? (c < 7778
            ? (c < 7758
              ? (c < 7748
                ? (c < 7744
                  ? (c < 7742
                    ? c == 7740
                    : c <= 7742)
                  : (c <= 7744 || c == 7746))
                : (c <= 7748 || (c < 7754
                  ? (c < 7752
                    ? c == 7750
                    : c <= 7752)
                  : (c <= 7754 || c == 7756))))
              : (c <= 7758 || (c < 7768
                ? (c < 7764
                  ? (c < 7762
                    ? c == 7760
                    : c <= 7762)
                  : (c <= 7764 || c == 7766))
                : (c <= 7768 || (c < 7774
                  ? (c < 7772
                    ? c == 7770
                    : c <= 7772)
                  : (c <= 7774 || c == 7776))))))
            : (c <= 7778 || (c < 7798
              ? (c < 7788
                ? (c < 7784
                  ? (c < 7782
                    ? c == 7780
                    : c <= 7782)
                  : (c <= 7784 || c == 7786))
                : (c <= 7788 || (c < 7794
                  ? (c < 7792
                    ? c == 7790
                    : c <= 7792)
                  : (c <= 7794 || c == 7796))))
              : (c <= 7798 || (c < 7808
                ? (c < 7804
                  ? (c < 7802
                    ? c == 7800
                    : c <= 7802)
                  : (c <= 7804 || c == 7806))
                : (c <= 7808 || (c < 7812
                  ? c == 7810
                  : (c <= 7812 || c == 7814))))))))
          : (c <= 7816 || (c < 7862
            ? (c < 7844
              ? (c < 7826
                ? (c < 7822
                  ? (c < 7820
                    ? c == 7818
                    : c <= 7820)
                  : (c <= 7822 || c == 7824))
                : (c <= 7826 || (c < 7840
                  ? (c < 7838
                    ? c == 7828
                    : c <= 7838)
                  : (c <= 7840 || c == 7842))))
              : (c <= 7844 || (c < 7854
                ? (c < 7850
                  ? (c < 7848
                    ? c == 7846
                    : c <= 7848)
                  : (c <= 7850 || c == 7852))
                : (c <= 7854 || (c < 7858
                  ? c == 7856
                  : (c <= 7858 || c == 7860))))))
            : (c <= 7862 || (c < 7882
              ? (c < 7872
                ? (c < 7868
                  ? (c < 7866
                    ? c == 7864
                    : c <= 7866)
                  : (c <= 7868 || c == 7870))
                : (c <= 7872 || (c < 7878
                  ? (c < 7876
                    ? c == 7874
                    : c <= 7876)
                  : (c <= 7878 || c == 7880))))
              : (c <= 7882 || (c < 7892
                ? (c < 7888
                  ? (c < 7886
                    ? c == 7884
                    : c <= 7886)
                  : (c <= 7888 || c == 7890))
                : (c <= 7892 || (c < 7896
                  ? c == 7894
                  : (c <= 7896 || c == 7898))))))))))
        : (c <= 7900 || (c < 8464
          ? (c < 7976
            ? (c < 7920
              ? (c < 7910
                ? (c < 7906
                  ? (c < 7904
                    ? c == 7902
                    : c <= 7904)
                  : (c <= 7906 || c == 7908))
                : (c <= 7910 || (c < 7916
                  ? (c < 7914
                    ? c == 7912
                    : c <= 7914)
                  : (c <= 7916 || c == 7918))))
              : (c <= 7920 || (c < 7930
                ? (c < 7926
                  ? (c < 7924
                    ? c == 7922
                    : c <= 7924)
                  : (c <= 7926 || c == 7928))
                : (c <= 7930 || (c < 7944
                  ? (c < 7934
                    ? c == 7932
                    : c <= 7934)
                  : (c <= 7951 || (c >= 7960 && c <= 7965)))))))
            : (c <= 7983 || (c < 8104
              ? (c < 8029
                ? (c < 8025
                  ? (c < 8008
                    ? (c >= 7992 && c <= 7999)
                    : c <= 8013)
                  : (c <= 8025 || c == 8027))
                : (c <= 8029 || (c < 8072
                  ? (c < 8040
                    ? c == 8031
                    : c <= 8047)
                  : (c <= 8079 || (c >= 8088 && c <= 8095)))))
              : (c <= 8111 || (c < 8184
                ? (c < 8152
                  ? (c < 8136
                    ? (c >= 8120 && c <= 8124)
                    : c <= 8140)
                  : (c <= 8155 || (c >= 8168 && c <= 8172)))
                : (c <= 8188 || (c < 8455
                  ? c == 8450
                  : (c <= 8455 || (c >= 8459 && c <= 8461)))))))))
          : (c <= 8466 || (c < 11381
            ? (c < 8579
              ? (c < 8488
                ? (c < 8484
                  ? (c < 8473
                    ? c == 8469
                    : c <= 8477)
                  : (c <= 8484 || c == 8486))
                : (c <= 8488 || (c < 8510
                  ? (c < 8496
                    ? (c >= 8490 && c <= 8493)
                    : c <= 8499)
                  : (c <= 8511 || c == 8517))))
              : (c <= 8579 || (c < 11369
                ? (c < 11362
                  ? (c < 11360
                    ? (c >= 11264 && c <= 11311)
                    : c <= 11360)
                  : (c <= 11364 || c == 11367))
                : (c <= 11369 || (c < 11373
                  ? c == 11371
                  : (c <= 11376 || c == 11378))))))
            : (c <= 11381 || (c < 11410
              ? (c < 11400
                ? (c < 11396
                  ? (c < 11394
                    ? (c >= 11390 && c <= 11392)
                    : c <= 11394)
                  : (c <= 11396 || c == 11398))
                : (c <= 11400 || (c < 11406
                  ? (c < 11404
                    ? c == 11402
                    : c <= 11404)
                  : (c <= 11406 || c == 11408))))
              : (c <= 11410 || (c < 11420
                ? (c < 11416
                  ? (c < 11414
                    ? c == 11412
                    : c <= 11414)
                  : (c <= 11416 || c == 11418))
                : (c <= 11420 || (c < 11424
                  ? c == 11422
                  : (c <= 11424 || c == 11426))))))))))))
      : (c <= 11428 || (c < 42796
        ? (c < 42568
          ? (c < 11468
            ? (c < 11448
              ? (c < 11438
                ? (c < 11434
                  ? (c < 11432
                    ? c == 11430
                    : c <= 11432)
                  : (c <= 11434 || c == 11436))
                : (c <= 11438 || (c < 11444
                  ? (c < 11442
                    ? c == 11440
                    : c <= 11442)
                  : (c <= 11444 || c == 11446))))
              : (c <= 11448 || (c < 11458
                ? (c < 11454
                  ? (c < 11452
                    ? c == 11450
                    : c <= 11452)
                  : (c <= 11454 || c == 11456))
                : (c <= 11458 || (c < 11464
                  ? (c < 11462
                    ? c == 11460
                    : c <= 11462)
                  : (c <= 11464 || c == 11466))))))
            : (c <= 11468 || (c < 11488
              ? (c < 11478
                ? (c < 11474
                  ? (c < 11472
                    ? c == 11470
                    : c <= 11472)
                  : (c <= 11474 || c == 11476))
                : (c <= 11478 || (c < 11484
                  ? (c < 11482
                    ? c == 11480
                    : c <= 11482)
                  : (c <= 11484 || c == 11486))))
              : (c <= 11488 || (c < 42560
                ? (c < 11501
                  ? (c < 11499
                    ? c == 11490
                    : c <= 11499)
                  : (c <= 11501 || c == 11506))
                : (c <= 42560 || (c < 42564
                  ? c == 42562
                  : (c <= 42564 || c == 42566))))))))
          : (c <= 42568 || (c < 42624
            ? (c < 42588
              ? (c < 42578
                ? (c < 42574
                  ? (c < 42572
                    ? c == 42570
                    : c <= 42572)
                  : (c <= 42574 || c == 42576))
                : (c <= 42578 || (c < 42584
                  ? (c < 42582
                    ? c == 42580
                    : c <= 42582)
                  : (c <= 42584 || c == 42586))))
              : (c <= 42588 || (c < 42598
                ? (c < 42594
                  ? (c < 42592
                    ? c == 42590
                    : c <= 42592)
                  : (c <= 42594 || c == 42596))
                : (c <= 42598 || (c < 42602
                  ? c == 42600
                  : (c <= 42602 || c == 42604))))))
            : (c <= 42624 || (c < 42644
              ? (c < 42634
                ? (c < 42630
                  ? (c < 42628
                    ? c == 42626
                    : c <= 42628)
                  : (c <= 42630 || c == 42632))
                : (c <= 42634 || (c < 42640
                  ? (c < 42638
                    ? c == 42636
                    : c <= 42638)
                  : (c <= 42640 || c == 42642))))
              : (c <= 42644 || (c < 42788
                ? (c < 42650
                  ? (c < 42648
                    ? c == 42646
                    : c <= 42648)
                  : (c <= 42650 || c == 42786))
                : (c <= 42788 || (c < 42792
                  ? c == 42790
                  : (c <= 42792 || c == 42794))))))))))
        : (c <= 42796 || (c < 42884
          ? (c < 42836
            ? (c < 42818
              ? (c < 42808
                ? (c < 42804
                  ? (c < 42802
                    ? c == 42798
                    : c <= 42802)
                  : (c <= 42804 || c == 42806))
                : (c <= 42808 || (c < 42814
                  ? (c < 42812
                    ? c == 42810
                    : c <= 42812)
                  : (c <= 42814 || c == 42816))))
              : (c <= 42818 || (c < 42828
                ? (c < 42824
                  ? (c < 42822
                    ? c == 42820
                    : c <= 42822)
                  : (c <= 42824 || c == 42826))
                : (c <= 42828 || (c < 42832
                  ? c == 42830
                  : (c <= 42832 || c == 42834))))))
            : (c <= 42836 || (c < 42856
              ? (c < 42846
                ? (c < 42842
                  ? (c < 42840
                    ? c == 42838
                    : c <= 42840)
                  : (c <= 42842 || c == 42844))
                : (c <= 42846 || (c < 42852
                  ? (c < 42850
                    ? c == 42848
                    : c <= 42850)
                  : (c <= 42852 || c == 42854))))
              : (c <= 42856 || (c < 42875
                ? (c < 42862
                  ? (c < 42860
                    ? c == 42858
                    : c <= 42860)
                  : (c <= 42862 || c == 42873))
                : (c <= 42875 || (c < 42880
                  ? (c >= 42877 && c <= 42878)
                  : (c <= 42880 || c == 42882))))))))
          : (c <= 42884 || (c < 42936
            ? (c < 42910
              ? (c < 42898
                ? (c < 42893
                  ? (c < 42891
                    ? c == 42886
                    : c <= 42891)
                  : (c <= 42893 || c == 42896))
                : (c <= 42898 || (c < 42906
                  ? (c < 42904
                    ? c == 42902
                    : c <= 42904)
                  : (c <= 42906 || c == 42908))))
              : (c <= 42910 || (c < 42920
                ? (c < 42916
                  ? (c < 42914
                    ? c == 42912
                    : c <= 42914)
                  : (c <= 42916 || c == 42918))
                : (c <= 42920 || (c < 42928
                  ? (c >= 42922 && c <= 42926)
                  : (c <= 42932 || c == 42934))))))
            : (c <= 42936 || (c < 42968
              ? (c < 42946
                ? (c < 42942
                  ? (c < 42940
                    ? c == 42938
                    : c <= 42940)
                  : (c <= 42942 || c == 42944))
                : (c <= 42946 || (c < 42960
                  ? (c < 42953
                    ? (c >= 42948 && c <= 42951)
                    : c <= 42953)
                  : (c <= 42960 || c == 42966))))
              : (c <= 42968 || (c < 66928
                ? (c < 66560
                  ? (c < 65313
                    ? c == 42997
                    : c <= 65338)
                  : (c <= 66599 || (c >= 66736 && c <= 66771)))
                : (c <= 66938 || (c < 66956
                  ? (c >= 66940 && c <= 66954)
                  : (c <= 66962 || (c >= 66964 && c <= 66965)))))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(56);
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(46)
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '#') ADVANCE(44);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '*') ADVANCE(130);
      if (lookahead == '-') ADVANCE(112);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(57);
      if (lookahead == '<') ADVANCE(14);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '?') ADVANCE(45);
      if (lookahead == '@') ADVANCE(143);
      if (lookahead == '[') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(142);
      if (lookahead == ']') ADVANCE(121);
      if (lookahead == '`') ADVANCE(116);
      if (lookahead == 't') ADVANCE(106);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == 8592) ADVANCE(97);
      if (lookahead == 8594) ADVANCE(95);
      if (lookahead == 8658) ADVANCE(93);
      if (lookahead == 8704) ADVANCE(125);
      if (lookahead == 8759) ADVANCE(99);
      if (lookahead == 9733) ADVANCE(131);
      if (lookahead == 10214) ADVANCE(144);
      if (lookahead == 10215) ADVANCE(146);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(76);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(119);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(108);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(1)
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '\'') ADVANCE(21);
      if (lookahead == '(') ADVANCE(113);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '-') ADVANCE(19);
      if (lookahead == '.') ADVANCE(126);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(57);
      if (lookahead == '=') ADVANCE(133);
      if (lookahead == '[') ADVANCE(120);
      if (lookahead == '{') ADVANCE(15);
      if (lookahead == '|') ADVANCE(22);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == 8594) ADVANCE(95);
      if (lookahead == 8759) ADVANCE(99);
      if (lookahead == 10215) ADVANCE(146);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(76);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(119);
      if (sym__varid_character_set_2(lookahead)) ADVANCE(108);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(2)
      if (lookahead == '{') ADVANCE(15);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(2)
      if (lookahead == '{') ADVANCE(15);
      if (sym__immediate_varid_character_set_1(lookahead)) ADVANCE(110);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(20);
      if (lookahead == '"') ADVANCE(70);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == '^') ADVANCE(9);
      if (lookahead != 0) ADVANCE(8);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(20);
      if (lookahead == '^') ADVANCE(9);
      if (lookahead != 0) ADVANCE(8);
      END_STATE();
    case 6:
      if (lookahead == '\n') ADVANCE(92);
      if (lookahead == ' ') ADVANCE(91);
      END_STATE();
    case 7:
      if (lookahead == ' ') ADVANCE(23);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(70);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 10:
      if (lookahead == '#') ADVANCE(11);
      END_STATE();
    case 11:
      if (lookahead == '#') ADVANCE(16);
      if (lookahead != 0) ADVANCE(11);
      END_STATE();
    case 12:
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(12);
      END_STATE();
    case 13:
      if (lookahead == '\'') ADVANCE(66);
      END_STATE();
    case 14:
      if (lookahead == '-') ADVANCE(98);
      END_STATE();
    case 15:
      if (lookahead == '-') ADVANCE(10);
      END_STATE();
    case 16:
      if (lookahead == '-') ADVANCE(34);
      if (lookahead != 0) ADVANCE(11);
      END_STATE();
    case 17:
      if (lookahead == '.') ADVANCE(137);
      END_STATE();
    case 18:
      if (lookahead == ':') ADVANCE(100);
      END_STATE();
    case 19:
      if (lookahead == '>') ADVANCE(96);
      END_STATE();
    case 20:
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(20);
      END_STATE();
    case 21:
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(13);
      END_STATE();
    case 22:
      if (lookahead == ']') ADVANCE(145);
      END_STATE();
    case 23:
      if (lookahead == 'b') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(31);
      END_STATE();
    case 24:
      if (lookahead == 'g') ADVANCE(30);
      END_STATE();
    case 25:
      if (lookahead == 'g') ADVANCE(139);
      END_STATE();
    case 26:
      if (lookahead == 'i') ADVANCE(27);
      END_STATE();
    case 27:
      if (lookahead == 'n') ADVANCE(25);
      END_STATE();
    case 28:
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 29:
      if (lookahead == 'p') ADVANCE(7);
      END_STATE();
    case 30:
      if (lookahead == 'r') ADVANCE(28);
      END_STATE();
    case 31:
      if (lookahead == 's') ADVANCE(26);
      END_STATE();
    case 32:
      if (lookahead == 'u') ADVANCE(29);
      END_STATE();
    case 33:
      if (lookahead == 'y') ADVANCE(138);
      END_STATE();
    case 34:
      if (lookahead == '}') ADVANCE(102);
      if (lookahead != 0) ADVANCE(11);
      END_STATE();
    case 35:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(60);
      END_STATE();
    case 36:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(89);
      END_STATE();
    case 37:
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(81);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(84);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(59);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(60);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(88);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(89);
      END_STATE();
    case 44:
      if (sym__immediate_varid_character_set_1(lookahead)) ADVANCE(111);
      END_STATE();
    case 45:
      if (sym__immediate_varid_character_set_1(lookahead)) ADVANCE(117);
      END_STATE();
    case 46:
      if (eof) ADVANCE(56);
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(46)
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '#') ADVANCE(44);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '*') ADVANCE(130);
      if (lookahead == '-') ADVANCE(112);
      if (lookahead == '.') ADVANCE(127);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(57);
      if (lookahead == '<') ADVANCE(14);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '?') ADVANCE(45);
      if (lookahead == '@') ADVANCE(141);
      if (lookahead == '[') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(142);
      if (lookahead == ']') ADVANCE(121);
      if (lookahead == '`') ADVANCE(116);
      if (lookahead == 't') ADVANCE(106);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == 8592) ADVANCE(97);
      if (lookahead == 8594) ADVANCE(95);
      if (lookahead == 8658) ADVANCE(93);
      if (lookahead == 8704) ADVANCE(125);
      if (lookahead == 8759) ADVANCE(99);
      if (lookahead == 9733) ADVANCE(131);
      if (lookahead == 10214) ADVANCE(144);
      if (lookahead == 10215) ADVANCE(146);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(76);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(119);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(108);
      END_STATE();
    case 47:
      if (eof) ADVANCE(56);
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(47)
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '#') ADVANCE(44);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '-') ADVANCE(112);
      if (lookahead == '.') ADVANCE(126);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(57);
      if (lookahead == '<') ADVANCE(14);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '?') ADVANCE(45);
      if (lookahead == '@') ADVANCE(141);
      if (lookahead == '[') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(142);
      if (lookahead == ']') ADVANCE(121);
      if (lookahead == '`') ADVANCE(116);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == 8592) ADVANCE(97);
      if (lookahead == 8594) ADVANCE(95);
      if (lookahead == 8658) ADVANCE(93);
      if (lookahead == 8759) ADVANCE(99);
      if (lookahead == 10214) ADVANCE(144);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(76);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(119);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(108);
      END_STATE();
    case 48:
      if (eof) ADVANCE(56);
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(49)
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(124);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '*') ADVANCE(130);
      if (lookahead == '-') ADVANCE(112);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(57);
      if (lookahead == '<') ADVANCE(14);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '?') ADVANCE(45);
      if (lookahead == '@') ADVANCE(143);
      if (lookahead == '[') ADVANCE(120);
      if (lookahead == ']') ADVANCE(121);
      if (lookahead == '`') ADVANCE(116);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == 8592) ADVANCE(97);
      if (lookahead == 8594) ADVANCE(95);
      if (lookahead == 8658) ADVANCE(93);
      if (lookahead == 8704) ADVANCE(125);
      if (lookahead == 8759) ADVANCE(99);
      if (lookahead == 9733) ADVANCE(131);
      if (lookahead == 10214) ADVANCE(144);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(76);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(119);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(108);
      END_STATE();
    case 49:
      if (eof) ADVANCE(56);
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(49)
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(124);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '*') ADVANCE(130);
      if (lookahead == '-') ADVANCE(112);
      if (lookahead == '.') ADVANCE(17);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(57);
      if (lookahead == '<') ADVANCE(14);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '?') ADVANCE(45);
      if (lookahead == '[') ADVANCE(120);
      if (lookahead == ']') ADVANCE(121);
      if (lookahead == '`') ADVANCE(116);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == 8592) ADVANCE(97);
      if (lookahead == 8594) ADVANCE(95);
      if (lookahead == 8658) ADVANCE(93);
      if (lookahead == 8704) ADVANCE(125);
      if (lookahead == 8759) ADVANCE(99);
      if (lookahead == 9733) ADVANCE(131);
      if (lookahead == 10214) ADVANCE(144);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(76);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(119);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(108);
      END_STATE();
    case 50:
      if (eof) ADVANCE(56);
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(50)
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '#') ADVANCE(44);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(122);
      if (lookahead == '(') ADVANCE(113);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '-') ADVANCE(112);
      if (lookahead == '.') ADVANCE(17);
      if (lookahead == '0') ADVANCE(77);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(57);
      if (lookahead == '<') ADVANCE(14);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '?') ADVANCE(45);
      if (lookahead == ']') ADVANCE(121);
      if (lookahead == '`') ADVANCE(116);
      if (lookahead == '{') ADVANCE(15);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == 8592) ADVANCE(97);
      if (lookahead == 8594) ADVANCE(95);
      if (lookahead == 8658) ADVANCE(93);
      if (lookahead == 8759) ADVANCE(99);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(78);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(119);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(108);
      END_STATE();
    case 51:
      if (eof) ADVANCE(56);
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(52)
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '#') ADVANCE(44);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '-') ADVANCE(112);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(57);
      if (lookahead == '<') ADVANCE(14);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '?') ADVANCE(45);
      if (lookahead == '@') ADVANCE(141);
      if (lookahead == '[') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(142);
      if (lookahead == ']') ADVANCE(121);
      if (lookahead == '`') ADVANCE(116);
      if (lookahead == 't') ADVANCE(106);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == 8592) ADVANCE(97);
      if (lookahead == 8594) ADVANCE(95);
      if (lookahead == 8658) ADVANCE(93);
      if (lookahead == 8759) ADVANCE(99);
      if (lookahead == 10214) ADVANCE(144);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(76);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(119);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(108);
      END_STATE();
    case 52:
      if (eof) ADVANCE(56);
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(52)
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '#') ADVANCE(44);
      if (lookahead == '%') ADVANCE(132);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '-') ADVANCE(112);
      if (lookahead == '.') ADVANCE(17);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(57);
      if (lookahead == '<') ADVANCE(14);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '?') ADVANCE(45);
      if (lookahead == '@') ADVANCE(141);
      if (lookahead == '[') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(142);
      if (lookahead == ']') ADVANCE(121);
      if (lookahead == '`') ADVANCE(116);
      if (lookahead == 't') ADVANCE(106);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == 8592) ADVANCE(97);
      if (lookahead == 8594) ADVANCE(95);
      if (lookahead == 8658) ADVANCE(93);
      if (lookahead == 8759) ADVANCE(99);
      if (lookahead == 10214) ADVANCE(144);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(76);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(119);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(108);
      END_STATE();
    case 53:
      if (eof) ADVANCE(56);
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(55)
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '#') ADVANCE(44);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '-') ADVANCE(112);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(57);
      if (lookahead == '<') ADVANCE(14);
      if (lookahead == '=') ADVANCE(133);
      if (lookahead == '?') ADVANCE(45);
      if (lookahead == '@') ADVANCE(143);
      if (lookahead == '[') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(142);
      if (lookahead == ']') ADVANCE(121);
      if (lookahead == '`') ADVANCE(116);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == 8592) ADVANCE(97);
      if (lookahead == 8594) ADVANCE(95);
      if (lookahead == 8759) ADVANCE(99);
      if (lookahead == 10214) ADVANCE(144);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(76);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(119);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(108);
      END_STATE();
    case 54:
      if (eof) ADVANCE(56);
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(55)
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '#') ADVANCE(44);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '-') ADVANCE(112);
      if (lookahead == '.') ADVANCE(101);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(57);
      if (lookahead == '<') ADVANCE(14);
      if (lookahead == '=') ADVANCE(133);
      if (lookahead == '?') ADVANCE(45);
      if (lookahead == '@') ADVANCE(141);
      if (lookahead == '[') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(142);
      if (lookahead == ']') ADVANCE(121);
      if (lookahead == '`') ADVANCE(116);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == 8592) ADVANCE(97);
      if (lookahead == 8594) ADVANCE(95);
      if (lookahead == 8759) ADVANCE(99);
      if (lookahead == 10214) ADVANCE(144);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(76);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(119);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(108);
      END_STATE();
    case 55:
      if (eof) ADVANCE(56);
      if (lookahead == '\n') ADVANCE(147);
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(55)
      if (lookahead == '"') ADVANCE(8);
      if (lookahead == '#') ADVANCE(44);
      if (lookahead == '\'') ADVANCE(123);
      if (lookahead == '(') ADVANCE(114);
      if (lookahead == ')') ADVANCE(115);
      if (lookahead == '-') ADVANCE(112);
      if (lookahead == '.') ADVANCE(17);
      if (lookahead == '0') ADVANCE(75);
      if (lookahead == ':') ADVANCE(18);
      if (lookahead == ';') ADVANCE(57);
      if (lookahead == '<') ADVANCE(14);
      if (lookahead == '=') ADVANCE(133);
      if (lookahead == '?') ADVANCE(45);
      if (lookahead == '@') ADVANCE(141);
      if (lookahead == '[') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(142);
      if (lookahead == ']') ADVANCE(121);
      if (lookahead == '`') ADVANCE(116);
      if (lookahead == '{') ADVANCE(135);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(136);
      if (lookahead == 8592) ADVANCE(97);
      if (lookahead == 8594) ADVANCE(95);
      if (lookahead == 8759) ADVANCE(99);
      if (lookahead == 10214) ADVANCE(144);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(76);
      if (sym__conid_character_set_1(lookahead)) ADVANCE(119);
      if (sym__varid_character_set_1(lookahead)) ADVANCE(108);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '#') ADVANCE(61);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(59);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '#') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(60);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '#') ADVANCE(58);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_char);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '#') ADVANCE(67);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(12);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '#') ADVANCE(62);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '#') ADVANCE(63);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(12);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '#') ADVANCE(64);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_char);
      if (lookahead == '\'') ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != ' ') ADVANCE(12);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_string);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '"') ADVANCE(73);
      if (lookahead == '#') ADVANCE(71);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '"') ADVANCE(73);
      if (lookahead == '#') ADVANCE(69);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '"') ADVANCE(73);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(8);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '#') ADVANCE(68);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_string);
      if (lookahead == '#') ADVANCE(72);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym__integer_literal);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(79);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(37);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(35);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(38);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(79);
      if (lookahead == '.') ADVANCE(39);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(76);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(79);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(37);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(38);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(78);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym__integer_literal);
      if (lookahead == '#') ADVANCE(74);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym__binary_literal);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym__binary_literal);
      if (lookahead == '#') ADVANCE(82);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(81);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym__binary_literal);
      if (lookahead == '#') ADVANCE(80);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym__octal_literal);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym__octal_literal);
      if (lookahead == '#') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(84);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym__octal_literal);
      if (lookahead == '#') ADVANCE(83);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym__hex_literal);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym__hex_literal);
      if (lookahead == '#') ADVANCE(90);
      if (lookahead == '.') ADVANCE(42);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(87);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym__hex_literal);
      if (lookahead == '#') ADVANCE(90);
      if (lookahead == 'P' ||
          lookahead == 'p') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(88);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym__hex_literal);
      if (lookahead == '#') ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(89);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym__hex_literal);
      if (lookahead == '#') ADVANCE(86);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_LPAREN_POUND);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_LPAREN_POUND_LF);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_2);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_3);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_LT_DASH);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_4);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym__immediate_dot);
      if (lookahead == '.') ADVANCE(137);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_pragma);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym__varid);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == ' ') ADVANCE(24);
      if (lookahead == '#') ADVANCE(103);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(108);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == '#') ADVANCE(103);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'd') ||
          ('f' <= lookahead && lookahead <= 'z')) ADVANCE(108);
      if (lookahead == 'e') ADVANCE(107);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == '#') ADVANCE(103);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'g') ||
          ('i' <= lookahead && lookahead <= 'z')) ADVANCE(108);
      if (lookahead == 'h') ADVANCE(105);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == '#') ADVANCE(103);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'm') ||
          ('o' <= lookahead && lookahead <= 'z')) ADVANCE(108);
      if (lookahead == 'n') ADVANCE(104);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym__varid);
      if (lookahead == '#') ADVANCE(103);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(108);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym__immediate_varid);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym__immediate_varid);
      if (lookahead == '#') ADVANCE(109);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(110);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_label);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(111);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(96);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '#') ADVANCE(6);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_implicit_parid);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(117);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym__conid);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym__conid);
      if (lookahead == '#') ADVANCE(118);
      if (lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(119);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(140);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead != 0) ADVANCE(13);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\\') ADVANCE(12);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(13);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_5);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(137);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == ']') ADVANCE(145);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_6);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(94);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '-') ADVANCE(10);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_thengroupby);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_thengroupusing);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_SQUOTE_SQUOTE);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_AT2);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_7);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACK);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_8);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym__token1);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 5760 ||
          (8192 <= lookahead && lookahead <= 8202) ||
          lookahead == 8239 ||
          lookahead == 8287 ||
          lookahead == 12288) SKIP(0)
      if (lookahead == '_') ADVANCE(1);
      if (lookahead == 'a') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'h') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'j') ADVANCE(9);
      if (lookahead == 'l') ADVANCE(10);
      if (lookahead == 'm') ADVANCE(11);
      if (lookahead == 'n') ADVANCE(12);
      if (lookahead == 'o') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(14);
      if (lookahead == 'q') ADVANCE(15);
      if (lookahead == 'r') ADVANCE(16);
      if (lookahead == 's') ADVANCE(17);
      if (lookahead == 't') ADVANCE(18);
      if (lookahead == 'u') ADVANCE(19);
      if (lookahead == 'v') ADVANCE(20);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2:
      if (lookahead == 'n') ADVANCE(21);
      if (lookahead == 's') ADVANCE(22);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(23);
      if (lookahead == 'c') ADVANCE(24);
      if (lookahead == 'l') ADVANCE(25);
      if (lookahead == 'p') ADVANCE(26);
      END_STATE();
    case 4:
      if (lookahead == 'a') ADVANCE(27);
      if (lookahead == 'e') ADVANCE(28);
      if (lookahead == 'o') ADVANCE(29);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(30);
      if (lookahead == 'x') ADVANCE(31);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(32);
      if (lookahead == 'o') ADVANCE(33);
      END_STATE();
    case 7:
      if (lookahead == 'i') ADVANCE(34);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(35);
      if (lookahead == 'm') ADVANCE(36);
      if (lookahead == 'n') ADVANCE(37);
      END_STATE();
    case 9:
      if (lookahead == 'v') ADVANCE(38);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(39);
      END_STATE();
    case 11:
      if (lookahead == 'd') ADVANCE(40);
      if (lookahead == 'o') ADVANCE(41);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(42);
      if (lookahead == 'o') ADVANCE(43);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(44);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(45);
      if (lookahead == 'h') ADVANCE(46);
      if (lookahead == 'r') ADVANCE(47);
      END_STATE();
    case 15:
      if (lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(49);
      if (lookahead == 'o') ADVANCE(50);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(51);
      if (lookahead == 't') ADVANCE(52);
      END_STATE();
    case 18:
      if (lookahead == 'h') ADVANCE(53);
      if (lookahead == 'y') ADVANCE(54);
      END_STATE();
    case 19:
      if (lookahead == 'n') ADVANCE(55);
      if (lookahead == 's') ADVANCE(56);
      END_STATE();
    case 20:
      if (lookahead == 'i') ADVANCE(57);
      END_STATE();
    case 21:
      if (lookahead == 'y') ADVANCE(58);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_as);
      END_STATE();
    case 23:
      if (lookahead == 'p') ADVANCE(59);
      if (lookahead == 's') ADVANCE(60);
      END_STATE();
    case 24:
      if (lookahead == 'a') ADVANCE(61);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(62);
      END_STATE();
    case 26:
      if (lookahead == 'l') ADVANCE(63);
      END_STATE();
    case 27:
      if (lookahead == 't') ADVANCE(64);
      END_STATE();
    case 28:
      if (lookahead == 'f') ADVANCE(65);
      if (lookahead == 'r') ADVANCE(66);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 't') ADVANCE(67);
      END_STATE();
    case 30:
      if (lookahead == 's') ADVANCE(68);
      END_STATE();
    case 31:
      if (lookahead == 'p') ADVANCE(69);
      END_STATE();
    case 32:
      if (lookahead == 'm') ADVANCE(70);
      END_STATE();
    case 33:
      if (lookahead == 'r') ADVANCE(71);
      END_STATE();
    case 34:
      if (lookahead == 'd') ADVANCE(72);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 36:
      if (lookahead == 'p') ADVANCE(73);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'f') ADVANCE(74);
      if (lookahead == 's') ADVANCE(75);
      if (lookahead == 't') ADVANCE(76);
      END_STATE();
    case 38:
      if (lookahead == 'm') ADVANCE(77);
      END_STATE();
    case 39:
      if (lookahead == 't') ADVANCE(78);
      END_STATE();
    case 40:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 41:
      if (lookahead == 'd') ADVANCE(80);
      END_STATE();
    case 42:
      if (lookahead == 'w') ADVANCE(81);
      END_STATE();
    case 43:
      if (lookahead == 'm') ADVANCE(82);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 45:
      if (lookahead == 't') ADVANCE(83);
      END_STATE();
    case 46:
      if (lookahead == 'a') ADVANCE(84);
      END_STATE();
    case 47:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 48:
      if (lookahead == 'a') ADVANCE(86);
      END_STATE();
    case 49:
      if (lookahead == 'c') ADVANCE(87);
      if (lookahead == 'p') ADVANCE(88);
      END_STATE();
    case 50:
      if (lookahead == 'l') ADVANCE(89);
      END_STATE();
    case 51:
      if (lookahead == 'f') ADVANCE(90);
      END_STATE();
    case 52:
      if (lookahead == 'd') ADVANCE(91);
      if (lookahead == 'o') ADVANCE(92);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(93);
      END_STATE();
    case 54:
      if (lookahead == 'p') ADVANCE(94);
      END_STATE();
    case 55:
      if (lookahead == 's') ADVANCE(95);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(97);
      END_STATE();
    case 58:
      if (lookahead == 'c') ADVANCE(98);
      END_STATE();
    case 59:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(100);
      END_STATE();
    case 61:
      if (lookahead == 'l') ADVANCE(101);
      END_STATE();
    case 62:
      if (lookahead == 's') ADVANCE(102);
      END_STATE();
    case 63:
      if (lookahead == 'u') ADVANCE(103);
      END_STATE();
    case 64:
      if (lookahead == 'a') ADVANCE(104);
      END_STATE();
    case 65:
      if (lookahead == 'a') ADVANCE(105);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(106);
      END_STATE();
    case 67:
      if (lookahead == 'n') ADVANCE(107);
      END_STATE();
    case 68:
      if (lookahead == 'e') ADVANCE(108);
      END_STATE();
    case 69:
      if (lookahead == 'o') ADVANCE(109);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(110);
      END_STATE();
    case 71:
      if (lookahead == 'a') ADVANCE(111);
      if (lookahead == 'e') ADVANCE(112);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(113);
      END_STATE();
    case 73:
      if (lookahead == 'o') ADVANCE(114);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(115);
      END_STATE();
    case 75:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 76:
      if (lookahead == 'e') ADVANCE(117);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_jvm);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_mdo);
      END_STATE();
    case 80:
      if (lookahead == 'u') ADVANCE(118);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 82:
      if (lookahead == 'i') ADVANCE(120);
      END_STATE();
    case 83:
      if (lookahead == 't') ADVANCE(121);
      END_STATE();
    case 84:
      if (lookahead == 'n') ADVANCE(122);
      END_STATE();
    case 85:
      if (lookahead == 'm') ADVANCE(123);
      END_STATE();
    case 86:
      if (lookahead == 'l') ADVANCE(124);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_rec);
      END_STATE();
    case 88:
      if (lookahead == 'r') ADVANCE(125);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 90:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 91:
      if (lookahead == 'c') ADVANCE(128);
      END_STATE();
    case 92:
      if (lookahead == 'c') ADVANCE(129);
      END_STATE();
    case 93:
      if (lookahead == 'n') ADVANCE(130);
      END_STATE();
    case 94:
      if (lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 95:
      if (lookahead == 'a') ADVANCE(132);
      END_STATE();
    case 96:
      if (lookahead == 'n') ADVANCE(133);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_via);
      END_STATE();
    case 98:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_capi);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 101:
      if (lookahead == 'l') ADVANCE(135);
      END_STATE();
    case 102:
      if (lookahead == 's') ADVANCE(136);
      END_STATE();
    case 103:
      if (lookahead == 's') ADVANCE(137);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_data);
      END_STATE();
    case 105:
      if (lookahead == 'u') ADVANCE(138);
      END_STATE();
    case 106:
      if (lookahead == 'v') ADVANCE(139);
      END_STATE();
    case 107:
      if (lookahead == 'e') ADVANCE(140);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 109:
      if (lookahead == 'r') ADVANCE(141);
      END_STATE();
    case 110:
      if (lookahead == 'l') ADVANCE(142);
      END_STATE();
    case 111:
      if (lookahead == 'l') ADVANCE(143);
      END_STATE();
    case 112:
      if (lookahead == 'i') ADVANCE(144);
      END_STATE();
    case 113:
      if (lookahead == 'n') ADVANCE(145);
      END_STATE();
    case 114:
      if (lookahead == 'r') ADVANCE(146);
      END_STATE();
    case 115:
      if (lookahead == 'x') ADVANCE(147);
      END_STATE();
    case 116:
      if (lookahead == 'a') ADVANCE(148);
      END_STATE();
    case 117:
      if (lookahead == 'r') ADVANCE(149);
      END_STATE();
    case 118:
      if (lookahead == 'l') ADVANCE(150);
      END_STATE();
    case 119:
      if (lookahead == 'y') ADVANCE(151);
      END_STATE();
    case 120:
      if (lookahead == 'n') ADVANCE(152);
      END_STATE();
    case 121:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 122:
      if (lookahead == 't') ADVANCE(154);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_prim);
      END_STATE();
    case 124:
      if (lookahead == 'i') ADVANCE(155);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_role);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_safe);
      END_STATE();
    case 128:
      if (lookahead == 'a') ADVANCE(157);
      END_STATE();
    case 129:
      if (lookahead == 'k') ADVANCE(158);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 132:
      if (lookahead == 'f') ADVANCE(159);
      END_STATE();
    case 133:
      if (lookahead == 'g') ADVANCE(160);
      END_STATE();
    case 134:
      if (lookahead == 'a') ADVANCE(161);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_ccall);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 137:
      if (lookahead == 'p') ADVANCE(162);
      END_STATE();
    case 138:
      if (lookahead == 'l') ADVANCE(163);
      END_STATE();
    case 139:
      if (lookahead == 'i') ADVANCE(164);
      END_STATE();
    case 140:
      if (lookahead == 't') ADVANCE(165);
      END_STATE();
    case 141:
      if (lookahead == 't') ADVANCE(166);
      END_STATE();
    case 142:
      if (lookahead == 'y') ADVANCE(167);
      END_STATE();
    case 143:
      if (lookahead == 'l') ADVANCE(168);
      END_STATE();
    case 144:
      if (lookahead == 'g') ADVANCE(169);
      END_STATE();
    case 145:
      if (lookahead == 'g') ADVANCE(170);
      END_STATE();
    case 146:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_infix);
      if (lookahead == 'l') ADVANCE(172);
      if (lookahead == 'r') ADVANCE(173);
      END_STATE();
    case 148:
      if (lookahead == 'n') ADVANCE(174);
      END_STATE();
    case 149:
      if (lookahead == 'r') ADVANCE(175);
      END_STATE();
    case 150:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 151:
      if (lookahead == 'p') ADVANCE(177);
      END_STATE();
    case 152:
      if (lookahead == 'a') ADVANCE(178);
      END_STATE();
    case 153:
      if (lookahead == 'r') ADVANCE(179);
      END_STATE();
    case 154:
      if (lookahead == 'o') ADVANCE(180);
      END_STATE();
    case 155:
      if (lookahead == 'f') ADVANCE(181);
      END_STATE();
    case 156:
      if (lookahead == 's') ADVANCE(182);
      END_STATE();
    case 157:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_stock);
      END_STATE();
    case 159:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 161:
      if (lookahead == 's') ADVANCE(185);
      END_STATE();
    case 162:
      if (lookahead == 'l') ADVANCE(186);
      END_STATE();
    case 163:
      if (lookahead == 't') ADVANCE(187);
      END_STATE();
    case 164:
      if (lookahead == 'n') ADVANCE(188);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_dotnet);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_family);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_forall);
      END_STATE();
    case 169:
      if (lookahead == 'n') ADVANCE(189);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_hiding);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_infixl);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_infixr);
      END_STATE();
    case 174:
      if (lookahead == 'c') ADVANCE(190);
      END_STATE();
    case 175:
      if (lookahead == 'u') ADVANCE(191);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 177:
      if (lookahead == 'e') ADVANCE(192);
      END_STATE();
    case 178:
      if (lookahead == 'l') ADVANCE(193);
      END_STATE();
    case 179:
      if (lookahead == 'n') ADVANCE(194);
      END_STATE();
    case 180:
      if (lookahead == 'm') ADVANCE(195);
      END_STATE();
    case 181:
      if (lookahead == 'i') ADVANCE(196);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(197);
      END_STATE();
    case 183:
      if (lookahead == 'l') ADVANCE(198);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 185:
      if (lookahead == 's') ADVANCE(199);
      END_STATE();
    case 186:
      if (lookahead == 'u') ADVANCE(200);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 188:
      if (lookahead == 'g') ADVANCE(201);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_foreign);
      END_STATE();
    case 190:
      if (lookahead == 'e') ADVANCE(202);
      END_STATE();
    case 191:
      if (lookahead == 'p') ADVANCE(203);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_newtype);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_nominal);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_pattern);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_phantom);
      END_STATE();
    case 196:
      if (lookahead == 'e') ADVANCE(204);
      END_STATE();
    case 197:
      if (lookahead == 'n') ADVANCE(205);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_stdcall);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_anyclass);
      END_STATE();
    case 200:
      if (lookahead == 's') ADVANCE(206);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_deriving);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_instance);
      END_STATE();
    case 203:
      if (lookahead == 't') ADVANCE(207);
      END_STATE();
    case 204:
      if (lookahead == 'd') ADVANCE(208);
      END_STATE();
    case 205:
      if (lookahead == 't') ADVANCE(209);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_cplusplus);
      END_STATE();
    case 207:
      if (lookahead == 'i') ADVANCE(210);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_qualified);
      END_STATE();
    case 209:
      if (lookahead == 'a') ADVANCE(211);
      END_STATE();
    case 210:
      if (lookahead == 'b') ADVANCE(212);
      END_STATE();
    case 211:
      if (lookahead == 't') ADVANCE(213);
      END_STATE();
    case 212:
      if (lookahead == 'l') ADVANCE(214);
      END_STATE();
    case 213:
      if (lookahead == 'i') ADVANCE(215);
      END_STATE();
    case 214:
      if (lookahead == 'e') ADVANCE(216);
      END_STATE();
    case 215:
      if (lookahead == 'o') ADVANCE(217);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_interruptible);
      END_STATE();
    case 217:
      if (lookahead == 'n') ADVANCE(218);
      END_STATE();
    case 218:
      if (lookahead == 'a') ADVANCE(219);
      END_STATE();
    case 219:
      if (lookahead == 'l') ADVANCE(220);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_representational);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 47, .external_lex_state = 2},
  [2] = {.lex_state = 47, .external_lex_state = 3},
  [3] = {.lex_state = 47, .external_lex_state = 3},
  [4] = {.lex_state = 47, .external_lex_state = 3},
  [5] = {.lex_state = 47, .external_lex_state = 4},
  [6] = {.lex_state = 47, .external_lex_state = 4},
  [7] = {.lex_state = 47, .external_lex_state = 3},
  [8] = {.lex_state = 47, .external_lex_state = 3},
  [9] = {.lex_state = 47, .external_lex_state = 4},
  [10] = {.lex_state = 47, .external_lex_state = 3},
  [11] = {.lex_state = 47, .external_lex_state = 4},
  [12] = {.lex_state = 47, .external_lex_state = 3},
  [13] = {.lex_state = 47, .external_lex_state = 4},
  [14] = {.lex_state = 47, .external_lex_state = 3},
  [15] = {.lex_state = 47, .external_lex_state = 3},
  [16] = {.lex_state = 47, .external_lex_state = 3},
  [17] = {.lex_state = 47, .external_lex_state = 5},
  [18] = {.lex_state = 47, .external_lex_state = 5},
  [19] = {.lex_state = 47, .external_lex_state = 5},
  [20] = {.lex_state = 47, .external_lex_state = 5},
  [21] = {.lex_state = 47, .external_lex_state = 5},
  [22] = {.lex_state = 47, .external_lex_state = 5},
  [23] = {.lex_state = 47, .external_lex_state = 5},
  [24] = {.lex_state = 47, .external_lex_state = 5},
  [25] = {.lex_state = 47, .external_lex_state = 5},
  [26] = {.lex_state = 47, .external_lex_state = 5},
  [27] = {.lex_state = 47, .external_lex_state = 5},
  [28] = {.lex_state = 47, .external_lex_state = 5},
  [29] = {.lex_state = 47, .external_lex_state = 5},
  [30] = {.lex_state = 47, .external_lex_state = 5},
  [31] = {.lex_state = 47, .external_lex_state = 5},
  [32] = {.lex_state = 47, .external_lex_state = 5},
  [33] = {.lex_state = 47, .external_lex_state = 5},
  [34] = {.lex_state = 47, .external_lex_state = 5},
  [35] = {.lex_state = 47, .external_lex_state = 5},
  [36] = {.lex_state = 47, .external_lex_state = 5},
  [37] = {.lex_state = 47, .external_lex_state = 5},
  [38] = {.lex_state = 47, .external_lex_state = 5},
  [39] = {.lex_state = 47, .external_lex_state = 5},
  [40] = {.lex_state = 47, .external_lex_state = 5},
  [41] = {.lex_state = 47, .external_lex_state = 5},
  [42] = {.lex_state = 47, .external_lex_state = 5},
  [43] = {.lex_state = 47, .external_lex_state = 5},
  [44] = {.lex_state = 47, .external_lex_state = 5},
  [45] = {.lex_state = 47, .external_lex_state = 5},
  [46] = {.lex_state = 47, .external_lex_state = 5},
  [47] = {.lex_state = 47, .external_lex_state = 5},
  [48] = {.lex_state = 47, .external_lex_state = 5},
  [49] = {.lex_state = 47, .external_lex_state = 5},
  [50] = {.lex_state = 47, .external_lex_state = 5},
  [51] = {.lex_state = 47, .external_lex_state = 5},
  [52] = {.lex_state = 47, .external_lex_state = 5},
  [53] = {.lex_state = 47, .external_lex_state = 5},
  [54] = {.lex_state = 47, .external_lex_state = 5},
  [55] = {.lex_state = 47, .external_lex_state = 5},
  [56] = {.lex_state = 47, .external_lex_state = 5},
  [57] = {.lex_state = 47, .external_lex_state = 5},
  [58] = {.lex_state = 47, .external_lex_state = 5},
  [59] = {.lex_state = 47, .external_lex_state = 5},
  [60] = {.lex_state = 47, .external_lex_state = 5},
  [61] = {.lex_state = 47, .external_lex_state = 5},
  [62] = {.lex_state = 47, .external_lex_state = 5},
  [63] = {.lex_state = 47, .external_lex_state = 5},
  [64] = {.lex_state = 47, .external_lex_state = 5},
  [65] = {.lex_state = 47, .external_lex_state = 5},
  [66] = {.lex_state = 47, .external_lex_state = 5},
  [67] = {.lex_state = 47, .external_lex_state = 5},
  [68] = {.lex_state = 47, .external_lex_state = 5},
  [69] = {.lex_state = 47, .external_lex_state = 5},
  [70] = {.lex_state = 47, .external_lex_state = 5},
  [71] = {.lex_state = 47, .external_lex_state = 5},
  [72] = {.lex_state = 47, .external_lex_state = 5},
  [73] = {.lex_state = 47, .external_lex_state = 5},
  [74] = {.lex_state = 47, .external_lex_state = 5},
  [75] = {.lex_state = 47, .external_lex_state = 5},
  [76] = {.lex_state = 47, .external_lex_state = 5},
  [77] = {.lex_state = 47, .external_lex_state = 5},
  [78] = {.lex_state = 47, .external_lex_state = 5},
  [79] = {.lex_state = 47, .external_lex_state = 5},
  [80] = {.lex_state = 47, .external_lex_state = 5},
  [81] = {.lex_state = 47, .external_lex_state = 5},
  [82] = {.lex_state = 47, .external_lex_state = 5},
  [83] = {.lex_state = 47, .external_lex_state = 5},
  [84] = {.lex_state = 47, .external_lex_state = 5},
  [85] = {.lex_state = 47, .external_lex_state = 5},
  [86] = {.lex_state = 47, .external_lex_state = 5},
  [87] = {.lex_state = 47, .external_lex_state = 5},
  [88] = {.lex_state = 47, .external_lex_state = 5},
  [89] = {.lex_state = 47, .external_lex_state = 5},
  [90] = {.lex_state = 47, .external_lex_state = 5},
  [91] = {.lex_state = 47, .external_lex_state = 5},
  [92] = {.lex_state = 47, .external_lex_state = 5},
  [93] = {.lex_state = 47, .external_lex_state = 5},
  [94] = {.lex_state = 47, .external_lex_state = 5},
  [95] = {.lex_state = 47, .external_lex_state = 6},
  [96] = {.lex_state = 47, .external_lex_state = 6},
  [97] = {.lex_state = 47, .external_lex_state = 6},
  [98] = {.lex_state = 47, .external_lex_state = 6},
  [99] = {.lex_state = 47, .external_lex_state = 6},
  [100] = {.lex_state = 47, .external_lex_state = 6},
  [101] = {.lex_state = 47, .external_lex_state = 6},
  [102] = {.lex_state = 47, .external_lex_state = 6},
  [103] = {.lex_state = 47, .external_lex_state = 6},
  [104] = {.lex_state = 47, .external_lex_state = 6},
  [105] = {.lex_state = 47, .external_lex_state = 6},
  [106] = {.lex_state = 47, .external_lex_state = 6},
  [107] = {.lex_state = 47, .external_lex_state = 6},
  [108] = {.lex_state = 47, .external_lex_state = 6},
  [109] = {.lex_state = 47, .external_lex_state = 6},
  [110] = {.lex_state = 47, .external_lex_state = 6},
  [111] = {.lex_state = 47, .external_lex_state = 6},
  [112] = {.lex_state = 47, .external_lex_state = 6},
  [113] = {.lex_state = 47, .external_lex_state = 6},
  [114] = {.lex_state = 47, .external_lex_state = 6},
  [115] = {.lex_state = 47, .external_lex_state = 6},
  [116] = {.lex_state = 47, .external_lex_state = 6},
  [117] = {.lex_state = 47, .external_lex_state = 6},
  [118] = {.lex_state = 47, .external_lex_state = 6},
  [119] = {.lex_state = 47, .external_lex_state = 6},
  [120] = {.lex_state = 47, .external_lex_state = 6},
  [121] = {.lex_state = 47, .external_lex_state = 6},
  [122] = {.lex_state = 47, .external_lex_state = 6},
  [123] = {.lex_state = 47, .external_lex_state = 3},
  [124] = {.lex_state = 51, .external_lex_state = 3},
  [125] = {.lex_state = 51, .external_lex_state = 3},
  [126] = {.lex_state = 51, .external_lex_state = 3},
  [127] = {.lex_state = 51, .external_lex_state = 3},
  [128] = {.lex_state = 47, .external_lex_state = 3},
  [129] = {.lex_state = 47, .external_lex_state = 3},
  [130] = {.lex_state = 51, .external_lex_state = 3},
  [131] = {.lex_state = 47, .external_lex_state = 3},
  [132] = {.lex_state = 47, .external_lex_state = 3},
  [133] = {.lex_state = 51, .external_lex_state = 3},
  [134] = {.lex_state = 47, .external_lex_state = 3},
  [135] = {.lex_state = 51, .external_lex_state = 3},
  [136] = {.lex_state = 51, .external_lex_state = 3},
  [137] = {.lex_state = 47, .external_lex_state = 3},
  [138] = {.lex_state = 51, .external_lex_state = 3},
  [139] = {.lex_state = 47, .external_lex_state = 3},
  [140] = {.lex_state = 47, .external_lex_state = 3},
  [141] = {.lex_state = 47, .external_lex_state = 3},
  [142] = {.lex_state = 47, .external_lex_state = 3},
  [143] = {.lex_state = 51, .external_lex_state = 3},
  [144] = {.lex_state = 47, .external_lex_state = 3},
  [145] = {.lex_state = 51, .external_lex_state = 3},
  [146] = {.lex_state = 51, .external_lex_state = 3},
  [147] = {.lex_state = 47, .external_lex_state = 3},
  [148] = {.lex_state = 51, .external_lex_state = 3},
  [149] = {.lex_state = 51, .external_lex_state = 3},
  [150] = {.lex_state = 51, .external_lex_state = 3},
  [151] = {.lex_state = 47, .external_lex_state = 3},
  [152] = {.lex_state = 51, .external_lex_state = 3},
  [153] = {.lex_state = 51, .external_lex_state = 3},
  [154] = {.lex_state = 47, .external_lex_state = 3},
  [155] = {.lex_state = 51, .external_lex_state = 3},
  [156] = {.lex_state = 47, .external_lex_state = 3},
  [157] = {.lex_state = 47, .external_lex_state = 3},
  [158] = {.lex_state = 51, .external_lex_state = 3},
  [159] = {.lex_state = 51, .external_lex_state = 3},
  [160] = {.lex_state = 51, .external_lex_state = 3},
  [161] = {.lex_state = 51, .external_lex_state = 3},
  [162] = {.lex_state = 47, .external_lex_state = 3},
  [163] = {.lex_state = 51, .external_lex_state = 3},
  [164] = {.lex_state = 51, .external_lex_state = 3},
  [165] = {.lex_state = 51, .external_lex_state = 3},
  [166] = {.lex_state = 51, .external_lex_state = 3},
  [167] = {.lex_state = 51, .external_lex_state = 3},
  [168] = {.lex_state = 47, .external_lex_state = 3},
  [169] = {.lex_state = 51, .external_lex_state = 3},
  [170] = {.lex_state = 47, .external_lex_state = 3},
  [171] = {.lex_state = 51, .external_lex_state = 3},
  [172] = {.lex_state = 47, .external_lex_state = 3},
  [173] = {.lex_state = 47, .external_lex_state = 3},
  [174] = {.lex_state = 51, .external_lex_state = 3},
  [175] = {.lex_state = 51, .external_lex_state = 3},
  [176] = {.lex_state = 47, .external_lex_state = 3},
  [177] = {.lex_state = 51, .external_lex_state = 3},
  [178] = {.lex_state = 47, .external_lex_state = 3},
  [179] = {.lex_state = 51, .external_lex_state = 3},
  [180] = {.lex_state = 51, .external_lex_state = 3},
  [181] = {.lex_state = 47, .external_lex_state = 3},
  [182] = {.lex_state = 51, .external_lex_state = 3},
  [183] = {.lex_state = 47, .external_lex_state = 3},
  [184] = {.lex_state = 47, .external_lex_state = 3},
  [185] = {.lex_state = 47, .external_lex_state = 3},
  [186] = {.lex_state = 51, .external_lex_state = 3},
  [187] = {.lex_state = 47, .external_lex_state = 3},
  [188] = {.lex_state = 51, .external_lex_state = 3},
  [189] = {.lex_state = 47, .external_lex_state = 3},
  [190] = {.lex_state = 51, .external_lex_state = 3},
  [191] = {.lex_state = 47, .external_lex_state = 3},
  [192] = {.lex_state = 47, .external_lex_state = 3},
  [193] = {.lex_state = 47, .external_lex_state = 3},
  [194] = {.lex_state = 51, .external_lex_state = 3},
  [195] = {.lex_state = 47, .external_lex_state = 3},
  [196] = {.lex_state = 51, .external_lex_state = 3},
  [197] = {.lex_state = 51, .external_lex_state = 3},
  [198] = {.lex_state = 47, .external_lex_state = 3},
  [199] = {.lex_state = 47, .external_lex_state = 3},
  [200] = {.lex_state = 47, .external_lex_state = 3},
  [201] = {.lex_state = 51, .external_lex_state = 3},
  [202] = {.lex_state = 47, .external_lex_state = 3},
  [203] = {.lex_state = 47, .external_lex_state = 3},
  [204] = {.lex_state = 47, .external_lex_state = 3},
  [205] = {.lex_state = 51, .external_lex_state = 3},
  [206] = {.lex_state = 47, .external_lex_state = 3},
  [207] = {.lex_state = 47, .external_lex_state = 3},
  [208] = {.lex_state = 51, .external_lex_state = 3},
  [209] = {.lex_state = 47, .external_lex_state = 3},
  [210] = {.lex_state = 47, .external_lex_state = 3},
  [211] = {.lex_state = 47, .external_lex_state = 3},
  [212] = {.lex_state = 51, .external_lex_state = 3},
  [213] = {.lex_state = 47, .external_lex_state = 3},
  [214] = {.lex_state = 51, .external_lex_state = 3},
  [215] = {.lex_state = 47, .external_lex_state = 3},
  [216] = {.lex_state = 51, .external_lex_state = 3},
  [217] = {.lex_state = 47, .external_lex_state = 3},
  [218] = {.lex_state = 47, .external_lex_state = 4},
  [219] = {.lex_state = 47, .external_lex_state = 3},
  [220] = {.lex_state = 47, .external_lex_state = 4},
  [221] = {.lex_state = 47, .external_lex_state = 3},
  [222] = {.lex_state = 47, .external_lex_state = 4},
  [223] = {.lex_state = 47, .external_lex_state = 3},
  [224] = {.lex_state = 47, .external_lex_state = 4},
  [225] = {.lex_state = 47, .external_lex_state = 3},
  [226] = {.lex_state = 47, .external_lex_state = 4},
  [227] = {.lex_state = 47, .external_lex_state = 4},
  [228] = {.lex_state = 47, .external_lex_state = 4},
  [229] = {.lex_state = 47, .external_lex_state = 3},
  [230] = {.lex_state = 47, .external_lex_state = 4},
  [231] = {.lex_state = 47, .external_lex_state = 3},
  [232] = {.lex_state = 47, .external_lex_state = 4},
  [233] = {.lex_state = 47, .external_lex_state = 4},
  [234] = {.lex_state = 47, .external_lex_state = 3},
  [235] = {.lex_state = 47, .external_lex_state = 4},
  [236] = {.lex_state = 47, .external_lex_state = 7},
  [237] = {.lex_state = 47, .external_lex_state = 3},
  [238] = {.lex_state = 47, .external_lex_state = 3},
  [239] = {.lex_state = 47, .external_lex_state = 4},
  [240] = {.lex_state = 47, .external_lex_state = 4},
  [241] = {.lex_state = 47, .external_lex_state = 3},
  [242] = {.lex_state = 47, .external_lex_state = 7},
  [243] = {.lex_state = 47, .external_lex_state = 4},
  [244] = {.lex_state = 47, .external_lex_state = 7},
  [245] = {.lex_state = 47, .external_lex_state = 4},
  [246] = {.lex_state = 47, .external_lex_state = 7},
  [247] = {.lex_state = 47, .external_lex_state = 4},
  [248] = {.lex_state = 47, .external_lex_state = 3},
  [249] = {.lex_state = 47, .external_lex_state = 3},
  [250] = {.lex_state = 47, .external_lex_state = 3},
  [251] = {.lex_state = 47, .external_lex_state = 4},
  [252] = {.lex_state = 47, .external_lex_state = 4},
  [253] = {.lex_state = 47, .external_lex_state = 4},
  [254] = {.lex_state = 47, .external_lex_state = 3},
  [255] = {.lex_state = 47, .external_lex_state = 4},
  [256] = {.lex_state = 47, .external_lex_state = 3},
  [257] = {.lex_state = 47, .external_lex_state = 4},
  [258] = {.lex_state = 47, .external_lex_state = 3},
  [259] = {.lex_state = 47, .external_lex_state = 3},
  [260] = {.lex_state = 47, .external_lex_state = 4},
  [261] = {.lex_state = 47, .external_lex_state = 4},
  [262] = {.lex_state = 47, .external_lex_state = 4},
  [263] = {.lex_state = 47, .external_lex_state = 7},
  [264] = {.lex_state = 47, .external_lex_state = 4},
  [265] = {.lex_state = 47, .external_lex_state = 3},
  [266] = {.lex_state = 47, .external_lex_state = 4},
  [267] = {.lex_state = 47, .external_lex_state = 4},
  [268] = {.lex_state = 47, .external_lex_state = 4},
  [269] = {.lex_state = 47, .external_lex_state = 3},
  [270] = {.lex_state = 47, .external_lex_state = 3},
  [271] = {.lex_state = 47, .external_lex_state = 4},
  [272] = {.lex_state = 47, .external_lex_state = 4},
  [273] = {.lex_state = 47, .external_lex_state = 3},
  [274] = {.lex_state = 47, .external_lex_state = 4},
  [275] = {.lex_state = 47, .external_lex_state = 3},
  [276] = {.lex_state = 47, .external_lex_state = 3},
  [277] = {.lex_state = 47, .external_lex_state = 3},
  [278] = {.lex_state = 47, .external_lex_state = 3},
  [279] = {.lex_state = 47, .external_lex_state = 3},
  [280] = {.lex_state = 47, .external_lex_state = 4},
  [281] = {.lex_state = 47, .external_lex_state = 4},
  [282] = {.lex_state = 47, .external_lex_state = 3},
  [283] = {.lex_state = 47, .external_lex_state = 3},
  [284] = {.lex_state = 47, .external_lex_state = 7},
  [285] = {.lex_state = 47, .external_lex_state = 4},
  [286] = {.lex_state = 47, .external_lex_state = 4},
  [287] = {.lex_state = 47, .external_lex_state = 4},
  [288] = {.lex_state = 47, .external_lex_state = 3},
  [289] = {.lex_state = 47, .external_lex_state = 4},
  [290] = {.lex_state = 47, .external_lex_state = 4},
  [291] = {.lex_state = 47, .external_lex_state = 3},
  [292] = {.lex_state = 47, .external_lex_state = 4},
  [293] = {.lex_state = 47, .external_lex_state = 4},
  [294] = {.lex_state = 47, .external_lex_state = 4},
  [295] = {.lex_state = 47, .external_lex_state = 3},
  [296] = {.lex_state = 47, .external_lex_state = 4},
  [297] = {.lex_state = 47, .external_lex_state = 4},
  [298] = {.lex_state = 47, .external_lex_state = 4},
  [299] = {.lex_state = 47, .external_lex_state = 4},
  [300] = {.lex_state = 47, .external_lex_state = 3},
  [301] = {.lex_state = 47, .external_lex_state = 4},
  [302] = {.lex_state = 47, .external_lex_state = 3},
  [303] = {.lex_state = 47, .external_lex_state = 4},
  [304] = {.lex_state = 47, .external_lex_state = 4},
  [305] = {.lex_state = 47, .external_lex_state = 4},
  [306] = {.lex_state = 47, .external_lex_state = 3},
  [307] = {.lex_state = 47, .external_lex_state = 4},
  [308] = {.lex_state = 47, .external_lex_state = 4},
  [309] = {.lex_state = 47, .external_lex_state = 3},
  [310] = {.lex_state = 47, .external_lex_state = 4},
  [311] = {.lex_state = 47, .external_lex_state = 4},
  [312] = {.lex_state = 47, .external_lex_state = 3},
  [313] = {.lex_state = 47, .external_lex_state = 4},
  [314] = {.lex_state = 47, .external_lex_state = 3},
  [315] = {.lex_state = 47, .external_lex_state = 7},
  [316] = {.lex_state = 47, .external_lex_state = 7},
  [317] = {.lex_state = 47, .external_lex_state = 4},
  [318] = {.lex_state = 47, .external_lex_state = 4},
  [319] = {.lex_state = 47, .external_lex_state = 4},
  [320] = {.lex_state = 47, .external_lex_state = 4},
  [321] = {.lex_state = 47, .external_lex_state = 3},
  [322] = {.lex_state = 47, .external_lex_state = 3},
  [323] = {.lex_state = 47, .external_lex_state = 4},
  [324] = {.lex_state = 47, .external_lex_state = 4},
  [325] = {.lex_state = 47, .external_lex_state = 4},
  [326] = {.lex_state = 47, .external_lex_state = 4},
  [327] = {.lex_state = 47, .external_lex_state = 3},
  [328] = {.lex_state = 47, .external_lex_state = 3},
  [329] = {.lex_state = 47, .external_lex_state = 3},
  [330] = {.lex_state = 47, .external_lex_state = 4},
  [331] = {.lex_state = 47, .external_lex_state = 3},
  [332] = {.lex_state = 47, .external_lex_state = 3},
  [333] = {.lex_state = 47, .external_lex_state = 4},
  [334] = {.lex_state = 47, .external_lex_state = 3},
  [335] = {.lex_state = 47, .external_lex_state = 7},
  [336] = {.lex_state = 47, .external_lex_state = 7},
  [337] = {.lex_state = 47, .external_lex_state = 4},
  [338] = {.lex_state = 47, .external_lex_state = 3},
  [339] = {.lex_state = 47, .external_lex_state = 3},
  [340] = {.lex_state = 47, .external_lex_state = 4},
  [341] = {.lex_state = 47, .external_lex_state = 3},
  [342] = {.lex_state = 47, .external_lex_state = 4},
  [343] = {.lex_state = 47, .external_lex_state = 3},
  [344] = {.lex_state = 47, .external_lex_state = 4},
  [345] = {.lex_state = 47, .external_lex_state = 4},
  [346] = {.lex_state = 47, .external_lex_state = 4},
  [347] = {.lex_state = 47, .external_lex_state = 4},
  [348] = {.lex_state = 47, .external_lex_state = 4},
  [349] = {.lex_state = 47, .external_lex_state = 3},
  [350] = {.lex_state = 47, .external_lex_state = 7},
  [351] = {.lex_state = 47, .external_lex_state = 4},
  [352] = {.lex_state = 47, .external_lex_state = 4},
  [353] = {.lex_state = 47, .external_lex_state = 4},
  [354] = {.lex_state = 47, .external_lex_state = 7},
  [355] = {.lex_state = 47, .external_lex_state = 4},
  [356] = {.lex_state = 47, .external_lex_state = 3},
  [357] = {.lex_state = 47, .external_lex_state = 3},
  [358] = {.lex_state = 47, .external_lex_state = 3},
  [359] = {.lex_state = 47, .external_lex_state = 3},
  [360] = {.lex_state = 47, .external_lex_state = 3},
  [361] = {.lex_state = 47, .external_lex_state = 4},
  [362] = {.lex_state = 47, .external_lex_state = 4},
  [363] = {.lex_state = 47, .external_lex_state = 3},
  [364] = {.lex_state = 47, .external_lex_state = 3},
  [365] = {.lex_state = 47, .external_lex_state = 4},
  [366] = {.lex_state = 47, .external_lex_state = 7},
  [367] = {.lex_state = 47, .external_lex_state = 7},
  [368] = {.lex_state = 47, .external_lex_state = 4},
  [369] = {.lex_state = 47, .external_lex_state = 4},
  [370] = {.lex_state = 47, .external_lex_state = 4},
  [371] = {.lex_state = 47, .external_lex_state = 4},
  [372] = {.lex_state = 47, .external_lex_state = 3},
  [373] = {.lex_state = 47, .external_lex_state = 4},
  [374] = {.lex_state = 47, .external_lex_state = 4},
  [375] = {.lex_state = 47, .external_lex_state = 4},
  [376] = {.lex_state = 47, .external_lex_state = 4},
  [377] = {.lex_state = 47, .external_lex_state = 4},
  [378] = {.lex_state = 47, .external_lex_state = 3},
  [379] = {.lex_state = 47, .external_lex_state = 4},
  [380] = {.lex_state = 47, .external_lex_state = 4},
  [381] = {.lex_state = 47, .external_lex_state = 4},
  [382] = {.lex_state = 47, .external_lex_state = 4},
  [383] = {.lex_state = 47, .external_lex_state = 4},
  [384] = {.lex_state = 47, .external_lex_state = 4},
  [385] = {.lex_state = 47, .external_lex_state = 3},
  [386] = {.lex_state = 47, .external_lex_state = 3},
  [387] = {.lex_state = 47, .external_lex_state = 4},
  [388] = {.lex_state = 47, .external_lex_state = 3},
  [389] = {.lex_state = 47, .external_lex_state = 3},
  [390] = {.lex_state = 47, .external_lex_state = 3},
  [391] = {.lex_state = 47, .external_lex_state = 3},
  [392] = {.lex_state = 47, .external_lex_state = 7},
  [393] = {.lex_state = 47, .external_lex_state = 3},
  [394] = {.lex_state = 47, .external_lex_state = 4},
  [395] = {.lex_state = 47, .external_lex_state = 4},
  [396] = {.lex_state = 47, .external_lex_state = 4},
  [397] = {.lex_state = 47, .external_lex_state = 4},
  [398] = {.lex_state = 47, .external_lex_state = 3},
  [399] = {.lex_state = 47, .external_lex_state = 3},
  [400] = {.lex_state = 47, .external_lex_state = 4},
  [401] = {.lex_state = 47, .external_lex_state = 4},
  [402] = {.lex_state = 47, .external_lex_state = 4},
  [403] = {.lex_state = 47, .external_lex_state = 3},
  [404] = {.lex_state = 47, .external_lex_state = 4},
  [405] = {.lex_state = 47, .external_lex_state = 4},
  [406] = {.lex_state = 47, .external_lex_state = 4},
  [407] = {.lex_state = 47, .external_lex_state = 3},
  [408] = {.lex_state = 47, .external_lex_state = 4},
  [409] = {.lex_state = 47, .external_lex_state = 4},
  [410] = {.lex_state = 47, .external_lex_state = 4},
  [411] = {.lex_state = 47, .external_lex_state = 3},
  [412] = {.lex_state = 47, .external_lex_state = 4},
  [413] = {.lex_state = 47, .external_lex_state = 3},
  [414] = {.lex_state = 47, .external_lex_state = 3},
  [415] = {.lex_state = 47, .external_lex_state = 3},
  [416] = {.lex_state = 47, .external_lex_state = 7},
  [417] = {.lex_state = 47, .external_lex_state = 7},
  [418] = {.lex_state = 47, .external_lex_state = 3},
  [419] = {.lex_state = 47, .external_lex_state = 4},
  [420] = {.lex_state = 47, .external_lex_state = 4},
  [421] = {.lex_state = 47, .external_lex_state = 4},
  [422] = {.lex_state = 47, .external_lex_state = 4},
  [423] = {.lex_state = 47, .external_lex_state = 7},
  [424] = {.lex_state = 47, .external_lex_state = 4},
  [425] = {.lex_state = 47, .external_lex_state = 3},
  [426] = {.lex_state = 47, .external_lex_state = 3},
  [427] = {.lex_state = 47, .external_lex_state = 4},
  [428] = {.lex_state = 47, .external_lex_state = 4},
  [429] = {.lex_state = 47, .external_lex_state = 4},
  [430] = {.lex_state = 47, .external_lex_state = 4},
  [431] = {.lex_state = 47, .external_lex_state = 4},
  [432] = {.lex_state = 47, .external_lex_state = 3},
  [433] = {.lex_state = 47, .external_lex_state = 3},
  [434] = {.lex_state = 47, .external_lex_state = 3},
  [435] = {.lex_state = 47, .external_lex_state = 4},
  [436] = {.lex_state = 47, .external_lex_state = 3},
  [437] = {.lex_state = 47, .external_lex_state = 4},
  [438] = {.lex_state = 47, .external_lex_state = 4},
  [439] = {.lex_state = 47, .external_lex_state = 3},
  [440] = {.lex_state = 47, .external_lex_state = 4},
  [441] = {.lex_state = 47, .external_lex_state = 4},
  [442] = {.lex_state = 47, .external_lex_state = 3},
  [443] = {.lex_state = 47, .external_lex_state = 4},
  [444] = {.lex_state = 47, .external_lex_state = 3},
  [445] = {.lex_state = 47, .external_lex_state = 4},
  [446] = {.lex_state = 47, .external_lex_state = 4},
  [447] = {.lex_state = 47, .external_lex_state = 3},
  [448] = {.lex_state = 47, .external_lex_state = 7},
  [449] = {.lex_state = 47, .external_lex_state = 3},
  [450] = {.lex_state = 47, .external_lex_state = 4},
  [451] = {.lex_state = 47, .external_lex_state = 3},
  [452] = {.lex_state = 47, .external_lex_state = 4},
  [453] = {.lex_state = 47, .external_lex_state = 4},
  [454] = {.lex_state = 47, .external_lex_state = 3},
  [455] = {.lex_state = 47, .external_lex_state = 3},
  [456] = {.lex_state = 47, .external_lex_state = 7},
  [457] = {.lex_state = 47, .external_lex_state = 4},
  [458] = {.lex_state = 47, .external_lex_state = 4},
  [459] = {.lex_state = 47, .external_lex_state = 7},
  [460] = {.lex_state = 47, .external_lex_state = 4},
  [461] = {.lex_state = 47, .external_lex_state = 7},
  [462] = {.lex_state = 47, .external_lex_state = 7},
  [463] = {.lex_state = 47, .external_lex_state = 7},
  [464] = {.lex_state = 47, .external_lex_state = 3},
  [465] = {.lex_state = 47, .external_lex_state = 3},
  [466] = {.lex_state = 47, .external_lex_state = 3},
  [467] = {.lex_state = 47, .external_lex_state = 4},
  [468] = {.lex_state = 47, .external_lex_state = 4},
  [469] = {.lex_state = 47, .external_lex_state = 4},
  [470] = {.lex_state = 47, .external_lex_state = 3},
  [471] = {.lex_state = 47, .external_lex_state = 4},
  [472] = {.lex_state = 47, .external_lex_state = 4},
  [473] = {.lex_state = 47, .external_lex_state = 7},
  [474] = {.lex_state = 47, .external_lex_state = 3},
  [475] = {.lex_state = 47, .external_lex_state = 7},
  [476] = {.lex_state = 47, .external_lex_state = 7},
  [477] = {.lex_state = 47, .external_lex_state = 4},
  [478] = {.lex_state = 47, .external_lex_state = 3},
  [479] = {.lex_state = 47, .external_lex_state = 4},
  [480] = {.lex_state = 47, .external_lex_state = 4},
  [481] = {.lex_state = 47, .external_lex_state = 7},
  [482] = {.lex_state = 47, .external_lex_state = 4},
  [483] = {.lex_state = 47, .external_lex_state = 3},
  [484] = {.lex_state = 47, .external_lex_state = 4},
  [485] = {.lex_state = 47, .external_lex_state = 4},
  [486] = {.lex_state = 47, .external_lex_state = 3},
  [487] = {.lex_state = 47, .external_lex_state = 3},
  [488] = {.lex_state = 47, .external_lex_state = 7},
  [489] = {.lex_state = 47, .external_lex_state = 7},
  [490] = {.lex_state = 47, .external_lex_state = 3},
  [491] = {.lex_state = 47, .external_lex_state = 3},
  [492] = {.lex_state = 47, .external_lex_state = 3},
  [493] = {.lex_state = 47, .external_lex_state = 3},
  [494] = {.lex_state = 47, .external_lex_state = 3},
  [495] = {.lex_state = 47, .external_lex_state = 3},
  [496] = {.lex_state = 47, .external_lex_state = 3},
  [497] = {.lex_state = 47, .external_lex_state = 3},
  [498] = {.lex_state = 47, .external_lex_state = 3},
  [499] = {.lex_state = 47, .external_lex_state = 3},
  [500] = {.lex_state = 47, .external_lex_state = 3},
  [501] = {.lex_state = 47, .external_lex_state = 3},
  [502] = {.lex_state = 47, .external_lex_state = 3},
  [503] = {.lex_state = 47, .external_lex_state = 3},
  [504] = {.lex_state = 47, .external_lex_state = 3},
  [505] = {.lex_state = 47, .external_lex_state = 3},
  [506] = {.lex_state = 47, .external_lex_state = 3},
  [507] = {.lex_state = 47, .external_lex_state = 3},
  [508] = {.lex_state = 47, .external_lex_state = 3},
  [509] = {.lex_state = 47, .external_lex_state = 3},
  [510] = {.lex_state = 47, .external_lex_state = 3},
  [511] = {.lex_state = 47, .external_lex_state = 3},
  [512] = {.lex_state = 47, .external_lex_state = 3},
  [513] = {.lex_state = 47, .external_lex_state = 3},
  [514] = {.lex_state = 47, .external_lex_state = 3},
  [515] = {.lex_state = 47, .external_lex_state = 3},
  [516] = {.lex_state = 47, .external_lex_state = 3},
  [517] = {.lex_state = 47, .external_lex_state = 3},
  [518] = {.lex_state = 47, .external_lex_state = 3},
  [519] = {.lex_state = 47, .external_lex_state = 3},
  [520] = {.lex_state = 47, .external_lex_state = 3},
  [521] = {.lex_state = 47, .external_lex_state = 3},
  [522] = {.lex_state = 47, .external_lex_state = 3},
  [523] = {.lex_state = 47, .external_lex_state = 3},
  [524] = {.lex_state = 47, .external_lex_state = 3},
  [525] = {.lex_state = 47, .external_lex_state = 3},
  [526] = {.lex_state = 47, .external_lex_state = 3},
  [527] = {.lex_state = 47, .external_lex_state = 3},
  [528] = {.lex_state = 47, .external_lex_state = 3},
  [529] = {.lex_state = 47, .external_lex_state = 3},
  [530] = {.lex_state = 47, .external_lex_state = 3},
  [531] = {.lex_state = 47, .external_lex_state = 3},
  [532] = {.lex_state = 47, .external_lex_state = 3},
  [533] = {.lex_state = 47, .external_lex_state = 3},
  [534] = {.lex_state = 47, .external_lex_state = 3},
  [535] = {.lex_state = 47, .external_lex_state = 3},
  [536] = {.lex_state = 47, .external_lex_state = 3},
  [537] = {.lex_state = 47, .external_lex_state = 3},
  [538] = {.lex_state = 47, .external_lex_state = 3},
  [539] = {.lex_state = 47, .external_lex_state = 3},
  [540] = {.lex_state = 47, .external_lex_state = 3},
  [541] = {.lex_state = 47, .external_lex_state = 3},
  [542] = {.lex_state = 47, .external_lex_state = 3},
  [543] = {.lex_state = 47, .external_lex_state = 3},
  [544] = {.lex_state = 47, .external_lex_state = 3},
  [545] = {.lex_state = 47, .external_lex_state = 3},
  [546] = {.lex_state = 47, .external_lex_state = 3},
  [547] = {.lex_state = 47, .external_lex_state = 3},
  [548] = {.lex_state = 47, .external_lex_state = 3},
  [549] = {.lex_state = 47, .external_lex_state = 3},
  [550] = {.lex_state = 47, .external_lex_state = 3},
  [551] = {.lex_state = 47, .external_lex_state = 3},
  [552] = {.lex_state = 47, .external_lex_state = 3},
  [553] = {.lex_state = 47, .external_lex_state = 3},
  [554] = {.lex_state = 47, .external_lex_state = 3},
  [555] = {.lex_state = 47, .external_lex_state = 3},
  [556] = {.lex_state = 47, .external_lex_state = 8},
  [557] = {.lex_state = 47, .external_lex_state = 8},
  [558] = {.lex_state = 47, .external_lex_state = 8},
  [559] = {.lex_state = 47, .external_lex_state = 8},
  [560] = {.lex_state = 47, .external_lex_state = 8},
  [561] = {.lex_state = 47, .external_lex_state = 8},
  [562] = {.lex_state = 47, .external_lex_state = 8},
  [563] = {.lex_state = 47, .external_lex_state = 8},
  [564] = {.lex_state = 47, .external_lex_state = 8},
  [565] = {.lex_state = 47, .external_lex_state = 8},
  [566] = {.lex_state = 47, .external_lex_state = 8},
  [567] = {.lex_state = 47, .external_lex_state = 8},
  [568] = {.lex_state = 47, .external_lex_state = 8},
  [569] = {.lex_state = 47, .external_lex_state = 8},
  [570] = {.lex_state = 47, .external_lex_state = 8},
  [571] = {.lex_state = 47, .external_lex_state = 8},
  [572] = {.lex_state = 47, .external_lex_state = 8},
  [573] = {.lex_state = 47, .external_lex_state = 8},
  [574] = {.lex_state = 47, .external_lex_state = 8},
  [575] = {.lex_state = 47, .external_lex_state = 8},
  [576] = {.lex_state = 47, .external_lex_state = 8},
  [577] = {.lex_state = 47, .external_lex_state = 8},
  [578] = {.lex_state = 47, .external_lex_state = 8},
  [579] = {.lex_state = 47, .external_lex_state = 8},
  [580] = {.lex_state = 47, .external_lex_state = 8},
  [581] = {.lex_state = 47, .external_lex_state = 8},
  [582] = {.lex_state = 47, .external_lex_state = 8},
  [583] = {.lex_state = 47, .external_lex_state = 8},
  [584] = {.lex_state = 47, .external_lex_state = 8},
  [585] = {.lex_state = 47, .external_lex_state = 8},
  [586] = {.lex_state = 47, .external_lex_state = 8},
  [587] = {.lex_state = 47, .external_lex_state = 8},
  [588] = {.lex_state = 47, .external_lex_state = 8},
  [589] = {.lex_state = 47, .external_lex_state = 8},
  [590] = {.lex_state = 47, .external_lex_state = 8},
  [591] = {.lex_state = 47, .external_lex_state = 8},
  [592] = {.lex_state = 47, .external_lex_state = 8},
  [593] = {.lex_state = 47, .external_lex_state = 8},
  [594] = {.lex_state = 47, .external_lex_state = 8},
  [595] = {.lex_state = 47, .external_lex_state = 8},
  [596] = {.lex_state = 47, .external_lex_state = 8},
  [597] = {.lex_state = 47, .external_lex_state = 8},
  [598] = {.lex_state = 47, .external_lex_state = 8},
  [599] = {.lex_state = 47, .external_lex_state = 8},
  [600] = {.lex_state = 47, .external_lex_state = 8},
  [601] = {.lex_state = 47, .external_lex_state = 8},
  [602] = {.lex_state = 47, .external_lex_state = 9},
  [603] = {.lex_state = 47, .external_lex_state = 9},
  [604] = {.lex_state = 47, .external_lex_state = 10},
  [605] = {.lex_state = 47, .external_lex_state = 10},
  [606] = {.lex_state = 47, .external_lex_state = 10},
  [607] = {.lex_state = 47, .external_lex_state = 10},
  [608] = {.lex_state = 47, .external_lex_state = 10},
  [609] = {.lex_state = 47, .external_lex_state = 10},
  [610] = {.lex_state = 47, .external_lex_state = 10},
  [611] = {.lex_state = 47, .external_lex_state = 10},
  [612] = {.lex_state = 47, .external_lex_state = 10},
  [613] = {.lex_state = 47, .external_lex_state = 10},
  [614] = {.lex_state = 47, .external_lex_state = 10},
  [615] = {.lex_state = 47, .external_lex_state = 10},
  [616] = {.lex_state = 47, .external_lex_state = 10},
  [617] = {.lex_state = 47, .external_lex_state = 10},
  [618] = {.lex_state = 47, .external_lex_state = 10},
  [619] = {.lex_state = 47, .external_lex_state = 10},
  [620] = {.lex_state = 47, .external_lex_state = 10},
  [621] = {.lex_state = 47, .external_lex_state = 10},
  [622] = {.lex_state = 47, .external_lex_state = 10},
  [623] = {.lex_state = 47, .external_lex_state = 11},
  [624] = {.lex_state = 47, .external_lex_state = 10},
  [625] = {.lex_state = 47, .external_lex_state = 10},
  [626] = {.lex_state = 47, .external_lex_state = 10},
  [627] = {.lex_state = 47, .external_lex_state = 10},
  [628] = {.lex_state = 47, .external_lex_state = 10},
  [629] = {.lex_state = 47, .external_lex_state = 10},
  [630] = {.lex_state = 47, .external_lex_state = 10},
  [631] = {.lex_state = 47, .external_lex_state = 10},
  [632] = {.lex_state = 47, .external_lex_state = 10},
  [633] = {.lex_state = 47, .external_lex_state = 10},
  [634] = {.lex_state = 47, .external_lex_state = 10},
  [635] = {.lex_state = 47, .external_lex_state = 10},
  [636] = {.lex_state = 47, .external_lex_state = 10},
  [637] = {.lex_state = 47, .external_lex_state = 10},
  [638] = {.lex_state = 47, .external_lex_state = 10},
  [639] = {.lex_state = 47, .external_lex_state = 10},
  [640] = {.lex_state = 47, .external_lex_state = 10},
  [641] = {.lex_state = 47, .external_lex_state = 10},
  [642] = {.lex_state = 47, .external_lex_state = 10},
  [643] = {.lex_state = 47, .external_lex_state = 10},
  [644] = {.lex_state = 47, .external_lex_state = 10},
  [645] = {.lex_state = 47, .external_lex_state = 10},
  [646] = {.lex_state = 47, .external_lex_state = 10},
  [647] = {.lex_state = 47, .external_lex_state = 10},
  [648] = {.lex_state = 47, .external_lex_state = 10},
  [649] = {.lex_state = 47, .external_lex_state = 10},
  [650] = {.lex_state = 47, .external_lex_state = 10},
  [651] = {.lex_state = 47, .external_lex_state = 10},
  [652] = {.lex_state = 47, .external_lex_state = 10},
  [653] = {.lex_state = 47, .external_lex_state = 10},
  [654] = {.lex_state = 47, .external_lex_state = 10},
  [655] = {.lex_state = 47, .external_lex_state = 10},
  [656] = {.lex_state = 47, .external_lex_state = 10},
  [657] = {.lex_state = 47, .external_lex_state = 10},
  [658] = {.lex_state = 47, .external_lex_state = 10},
  [659] = {.lex_state = 47, .external_lex_state = 10},
  [660] = {.lex_state = 47, .external_lex_state = 10},
  [661] = {.lex_state = 47, .external_lex_state = 10},
  [662] = {.lex_state = 47, .external_lex_state = 10},
  [663] = {.lex_state = 47, .external_lex_state = 10},
  [664] = {.lex_state = 47, .external_lex_state = 10},
  [665] = {.lex_state = 47, .external_lex_state = 10},
  [666] = {.lex_state = 47, .external_lex_state = 10},
  [667] = {.lex_state = 47, .external_lex_state = 10},
  [668] = {.lex_state = 47, .external_lex_state = 10},
  [669] = {.lex_state = 47, .external_lex_state = 10},
  [670] = {.lex_state = 47, .external_lex_state = 10},
  [671] = {.lex_state = 47, .external_lex_state = 10},
  [672] = {.lex_state = 47, .external_lex_state = 10},
  [673] = {.lex_state = 47, .external_lex_state = 10},
  [674] = {.lex_state = 47, .external_lex_state = 10},
  [675] = {.lex_state = 47, .external_lex_state = 10},
  [676] = {.lex_state = 47, .external_lex_state = 10},
  [677] = {.lex_state = 47, .external_lex_state = 10},
  [678] = {.lex_state = 47, .external_lex_state = 10},
  [679] = {.lex_state = 47, .external_lex_state = 10},
  [680] = {.lex_state = 47, .external_lex_state = 10},
  [681] = {.lex_state = 47, .external_lex_state = 10},
  [682] = {.lex_state = 47, .external_lex_state = 10},
  [683] = {.lex_state = 47, .external_lex_state = 10},
  [684] = {.lex_state = 47, .external_lex_state = 10},
  [685] = {.lex_state = 47, .external_lex_state = 10},
  [686] = {.lex_state = 47, .external_lex_state = 10},
  [687] = {.lex_state = 47, .external_lex_state = 10},
  [688] = {.lex_state = 47, .external_lex_state = 10},
  [689] = {.lex_state = 47, .external_lex_state = 10},
  [690] = {.lex_state = 47, .external_lex_state = 10},
  [691] = {.lex_state = 47, .external_lex_state = 10},
  [692] = {.lex_state = 47, .external_lex_state = 10},
  [693] = {.lex_state = 47, .external_lex_state = 10},
  [694] = {.lex_state = 47, .external_lex_state = 10},
  [695] = {.lex_state = 47, .external_lex_state = 11},
  [696] = {.lex_state = 47, .external_lex_state = 10},
  [697] = {.lex_state = 47, .external_lex_state = 10},
  [698] = {.lex_state = 47, .external_lex_state = 10},
  [699] = {.lex_state = 47, .external_lex_state = 10},
  [700] = {.lex_state = 47, .external_lex_state = 10},
  [701] = {.lex_state = 47, .external_lex_state = 10},
  [702] = {.lex_state = 47, .external_lex_state = 10},
  [703] = {.lex_state = 47, .external_lex_state = 10},
  [704] = {.lex_state = 47, .external_lex_state = 10},
  [705] = {.lex_state = 47, .external_lex_state = 10},
  [706] = {.lex_state = 47, .external_lex_state = 10},
  [707] = {.lex_state = 47, .external_lex_state = 10},
  [708] = {.lex_state = 47, .external_lex_state = 10},
  [709] = {.lex_state = 47, .external_lex_state = 10},
  [710] = {.lex_state = 47, .external_lex_state = 10},
  [711] = {.lex_state = 47, .external_lex_state = 10},
  [712] = {.lex_state = 47, .external_lex_state = 10},
  [713] = {.lex_state = 47, .external_lex_state = 10},
  [714] = {.lex_state = 47, .external_lex_state = 10},
  [715] = {.lex_state = 47, .external_lex_state = 10},
  [716] = {.lex_state = 47, .external_lex_state = 10},
  [717] = {.lex_state = 47, .external_lex_state = 10},
  [718] = {.lex_state = 47, .external_lex_state = 10},
  [719] = {.lex_state = 47, .external_lex_state = 10},
  [720] = {.lex_state = 47, .external_lex_state = 10},
  [721] = {.lex_state = 47, .external_lex_state = 10},
  [722] = {.lex_state = 47, .external_lex_state = 10},
  [723] = {.lex_state = 47, .external_lex_state = 10},
  [724] = {.lex_state = 47, .external_lex_state = 10},
  [725] = {.lex_state = 47, .external_lex_state = 10},
  [726] = {.lex_state = 47, .external_lex_state = 10},
  [727] = {.lex_state = 47, .external_lex_state = 10},
  [728] = {.lex_state = 47, .external_lex_state = 10},
  [729] = {.lex_state = 47, .external_lex_state = 10},
  [730] = {.lex_state = 47, .external_lex_state = 10},
  [731] = {.lex_state = 47, .external_lex_state = 10},
  [732] = {.lex_state = 47, .external_lex_state = 10},
  [733] = {.lex_state = 47, .external_lex_state = 10},
  [734] = {.lex_state = 47, .external_lex_state = 10},
  [735] = {.lex_state = 47, .external_lex_state = 10},
  [736] = {.lex_state = 47, .external_lex_state = 10},
  [737] = {.lex_state = 47, .external_lex_state = 10},
  [738] = {.lex_state = 47, .external_lex_state = 10},
  [739] = {.lex_state = 47, .external_lex_state = 10},
  [740] = {.lex_state = 47, .external_lex_state = 10},
  [741] = {.lex_state = 47, .external_lex_state = 10},
  [742] = {.lex_state = 47, .external_lex_state = 10},
  [743] = {.lex_state = 47, .external_lex_state = 10},
  [744] = {.lex_state = 47, .external_lex_state = 10},
  [745] = {.lex_state = 47, .external_lex_state = 10},
  [746] = {.lex_state = 47, .external_lex_state = 12},
  [747] = {.lex_state = 47, .external_lex_state = 12},
  [748] = {.lex_state = 47, .external_lex_state = 12},
  [749] = {.lex_state = 47, .external_lex_state = 12},
  [750] = {.lex_state = 47, .external_lex_state = 12},
  [751] = {.lex_state = 47, .external_lex_state = 12},
  [752] = {.lex_state = 48, .external_lex_state = 13},
  [753] = {.lex_state = 47, .external_lex_state = 12},
  [754] = {.lex_state = 47, .external_lex_state = 12},
  [755] = {.lex_state = 47, .external_lex_state = 12},
  [756] = {.lex_state = 47, .external_lex_state = 12},
  [757] = {.lex_state = 47, .external_lex_state = 12},
  [758] = {.lex_state = 48, .external_lex_state = 13},
  [759] = {.lex_state = 47, .external_lex_state = 12},
  [760] = {.lex_state = 47, .external_lex_state = 12},
  [761] = {.lex_state = 47, .external_lex_state = 12},
  [762] = {.lex_state = 47, .external_lex_state = 12},
  [763] = {.lex_state = 54, .external_lex_state = 14},
  [764] = {.lex_state = 48, .external_lex_state = 13},
  [765] = {.lex_state = 47, .external_lex_state = 12},
  [766] = {.lex_state = 47, .external_lex_state = 12},
  [767] = {.lex_state = 47, .external_lex_state = 8},
  [768] = {.lex_state = 47, .external_lex_state = 8},
  [769] = {.lex_state = 47, .external_lex_state = 12},
  [770] = {.lex_state = 47, .external_lex_state = 12},
  [771] = {.lex_state = 47, .external_lex_state = 12},
  [772] = {.lex_state = 48, .external_lex_state = 13},
  [773] = {.lex_state = 47, .external_lex_state = 12},
  [774] = {.lex_state = 47, .external_lex_state = 12},
  [775] = {.lex_state = 47, .external_lex_state = 12},
  [776] = {.lex_state = 47, .external_lex_state = 12},
  [777] = {.lex_state = 47, .external_lex_state = 12},
  [778] = {.lex_state = 47, .external_lex_state = 12},
  [779] = {.lex_state = 47, .external_lex_state = 12},
  [780] = {.lex_state = 47, .external_lex_state = 12},
  [781] = {.lex_state = 47, .external_lex_state = 12},
  [782] = {.lex_state = 47, .external_lex_state = 12},
  [783] = {.lex_state = 47, .external_lex_state = 12},
  [784] = {.lex_state = 47, .external_lex_state = 12},
  [785] = {.lex_state = 47, .external_lex_state = 12},
  [786] = {.lex_state = 47, .external_lex_state = 12},
  [787] = {.lex_state = 47, .external_lex_state = 12},
  [788] = {.lex_state = 47, .external_lex_state = 12},
  [789] = {.lex_state = 48, .external_lex_state = 13},
  [790] = {.lex_state = 47, .external_lex_state = 12},
  [791] = {.lex_state = 47, .external_lex_state = 12},
  [792] = {.lex_state = 47, .external_lex_state = 12},
  [793] = {.lex_state = 54, .external_lex_state = 14},
  [794] = {.lex_state = 47, .external_lex_state = 12},
  [795] = {.lex_state = 47, .external_lex_state = 12},
  [796] = {.lex_state = 47, .external_lex_state = 12},
  [797] = {.lex_state = 47, .external_lex_state = 12},
  [798] = {.lex_state = 47, .external_lex_state = 12},
  [799] = {.lex_state = 47, .external_lex_state = 12},
  [800] = {.lex_state = 47, .external_lex_state = 12},
  [801] = {.lex_state = 47, .external_lex_state = 15},
  [802] = {.lex_state = 47, .external_lex_state = 15},
  [803] = {.lex_state = 47, .external_lex_state = 16},
  [804] = {.lex_state = 47, .external_lex_state = 16},
  [805] = {.lex_state = 48, .external_lex_state = 13},
  [806] = {.lex_state = 48, .external_lex_state = 13},
  [807] = {.lex_state = 48, .external_lex_state = 13},
  [808] = {.lex_state = 47, .external_lex_state = 16},
  [809] = {.lex_state = 48, .external_lex_state = 13},
  [810] = {.lex_state = 48, .external_lex_state = 13},
  [811] = {.lex_state = 48, .external_lex_state = 13},
  [812] = {.lex_state = 47, .external_lex_state = 16},
  [813] = {.lex_state = 48, .external_lex_state = 13},
  [814] = {.lex_state = 48, .external_lex_state = 13},
  [815] = {.lex_state = 47, .external_lex_state = 16},
  [816] = {.lex_state = 48, .external_lex_state = 13},
  [817] = {.lex_state = 48, .external_lex_state = 13},
  [818] = {.lex_state = 48, .external_lex_state = 13},
  [819] = {.lex_state = 48, .external_lex_state = 13},
  [820] = {.lex_state = 47, .external_lex_state = 16},
  [821] = {.lex_state = 47, .external_lex_state = 16},
  [822] = {.lex_state = 47, .external_lex_state = 16},
  [823] = {.lex_state = 48, .external_lex_state = 13},
  [824] = {.lex_state = 48, .external_lex_state = 13},
  [825] = {.lex_state = 47, .external_lex_state = 16},
  [826] = {.lex_state = 48, .external_lex_state = 13},
  [827] = {.lex_state = 47, .external_lex_state = 16},
  [828] = {.lex_state = 47, .external_lex_state = 17},
  [829] = {.lex_state = 48, .external_lex_state = 13},
  [830] = {.lex_state = 48, .external_lex_state = 13},
  [831] = {.lex_state = 47, .external_lex_state = 16},
  [832] = {.lex_state = 47, .external_lex_state = 16},
  [833] = {.lex_state = 48, .external_lex_state = 13},
  [834] = {.lex_state = 48, .external_lex_state = 13},
  [835] = {.lex_state = 48, .external_lex_state = 13},
  [836] = {.lex_state = 48, .external_lex_state = 13},
  [837] = {.lex_state = 47, .external_lex_state = 16},
  [838] = {.lex_state = 48, .external_lex_state = 13},
  [839] = {.lex_state = 48, .external_lex_state = 13},
  [840] = {.lex_state = 48, .external_lex_state = 13},
  [841] = {.lex_state = 48, .external_lex_state = 13},
  [842] = {.lex_state = 47, .external_lex_state = 16},
  [843] = {.lex_state = 48, .external_lex_state = 13},
  [844] = {.lex_state = 48, .external_lex_state = 13},
  [845] = {.lex_state = 48, .external_lex_state = 13},
  [846] = {.lex_state = 48, .external_lex_state = 13},
  [847] = {.lex_state = 48, .external_lex_state = 13},
  [848] = {.lex_state = 48, .external_lex_state = 13},
  [849] = {.lex_state = 48, .external_lex_state = 13},
  [850] = {.lex_state = 48, .external_lex_state = 13},
  [851] = {.lex_state = 48, .external_lex_state = 13},
  [852] = {.lex_state = 48, .external_lex_state = 13},
  [853] = {.lex_state = 48, .external_lex_state = 13},
  [854] = {.lex_state = 48, .external_lex_state = 13},
  [855] = {.lex_state = 48, .external_lex_state = 13},
  [856] = {.lex_state = 48, .external_lex_state = 13},
  [857] = {.lex_state = 47, .external_lex_state = 16},
  [858] = {.lex_state = 47, .external_lex_state = 16},
  [859] = {.lex_state = 47, .external_lex_state = 16},
  [860] = {.lex_state = 48, .external_lex_state = 13},
  [861] = {.lex_state = 48, .external_lex_state = 13},
  [862] = {.lex_state = 47, .external_lex_state = 16},
  [863] = {.lex_state = 47, .external_lex_state = 16},
  [864] = {.lex_state = 48, .external_lex_state = 13},
  [865] = {.lex_state = 47, .external_lex_state = 18},
  [866] = {.lex_state = 48, .external_lex_state = 13},
  [867] = {.lex_state = 47, .external_lex_state = 16},
  [868] = {.lex_state = 47, .external_lex_state = 19},
  [869] = {.lex_state = 48, .external_lex_state = 13},
  [870] = {.lex_state = 47, .external_lex_state = 20},
  [871] = {.lex_state = 47, .external_lex_state = 20},
  [872] = {.lex_state = 47, .external_lex_state = 16},
  [873] = {.lex_state = 47, .external_lex_state = 18},
  [874] = {.lex_state = 48, .external_lex_state = 13},
  [875] = {.lex_state = 47, .external_lex_state = 21},
  [876] = {.lex_state = 48, .external_lex_state = 13},
  [877] = {.lex_state = 48, .external_lex_state = 13},
  [878] = {.lex_state = 48, .external_lex_state = 13},
  [879] = {.lex_state = 47, .external_lex_state = 21},
  [880] = {.lex_state = 48, .external_lex_state = 13},
  [881] = {.lex_state = 47, .external_lex_state = 16},
  [882] = {.lex_state = 47, .external_lex_state = 19},
  [883] = {.lex_state = 48, .external_lex_state = 13},
  [884] = {.lex_state = 48, .external_lex_state = 13},
  [885] = {.lex_state = 48, .external_lex_state = 13},
  [886] = {.lex_state = 48, .external_lex_state = 13},
  [887] = {.lex_state = 47, .external_lex_state = 17},
  [888] = {.lex_state = 48, .external_lex_state = 13},
  [889] = {.lex_state = 48, .external_lex_state = 13},
  [890] = {.lex_state = 47, .external_lex_state = 16},
  [891] = {.lex_state = 47, .external_lex_state = 22},
  [892] = {.lex_state = 47, .external_lex_state = 23},
  [893] = {.lex_state = 47, .external_lex_state = 22},
  [894] = {.lex_state = 47, .external_lex_state = 24},
  [895] = {.lex_state = 47, .external_lex_state = 22},
  [896] = {.lex_state = 47, .external_lex_state = 25},
  [897] = {.lex_state = 47, .external_lex_state = 22},
  [898] = {.lex_state = 48, .external_lex_state = 13},
  [899] = {.lex_state = 47, .external_lex_state = 22},
  [900] = {.lex_state = 47, .external_lex_state = 22},
  [901] = {.lex_state = 47, .external_lex_state = 26},
  [902] = {.lex_state = 47, .external_lex_state = 22},
  [903] = {.lex_state = 47, .external_lex_state = 22},
  [904] = {.lex_state = 47, .external_lex_state = 22},
  [905] = {.lex_state = 47, .external_lex_state = 22},
  [906] = {.lex_state = 47, .external_lex_state = 22},
  [907] = {.lex_state = 47, .external_lex_state = 22},
  [908] = {.lex_state = 47, .external_lex_state = 22},
  [909] = {.lex_state = 47, .external_lex_state = 22},
  [910] = {.lex_state = 47, .external_lex_state = 22},
  [911] = {.lex_state = 47, .external_lex_state = 22},
  [912] = {.lex_state = 47, .external_lex_state = 22},
  [913] = {.lex_state = 47, .external_lex_state = 22},
  [914] = {.lex_state = 47, .external_lex_state = 22},
  [915] = {.lex_state = 47, .external_lex_state = 22},
  [916] = {.lex_state = 47, .external_lex_state = 26},
  [917] = {.lex_state = 47, .external_lex_state = 27},
  [918] = {.lex_state = 47, .external_lex_state = 22},
  [919] = {.lex_state = 47, .external_lex_state = 22},
  [920] = {.lex_state = 47, .external_lex_state = 22},
  [921] = {.lex_state = 47, .external_lex_state = 22},
  [922] = {.lex_state = 47, .external_lex_state = 28},
  [923] = {.lex_state = 48, .external_lex_state = 13},
  [924] = {.lex_state = 47, .external_lex_state = 24},
  [925] = {.lex_state = 47, .external_lex_state = 22},
  [926] = {.lex_state = 47, .external_lex_state = 22},
  [927] = {.lex_state = 47, .external_lex_state = 22},
  [928] = {.lex_state = 47, .external_lex_state = 22},
  [929] = {.lex_state = 47, .external_lex_state = 22},
  [930] = {.lex_state = 47, .external_lex_state = 22},
  [931] = {.lex_state = 47, .external_lex_state = 22},
  [932] = {.lex_state = 47, .external_lex_state = 22},
  [933] = {.lex_state = 47, .external_lex_state = 22},
  [934] = {.lex_state = 47, .external_lex_state = 22},
  [935] = {.lex_state = 47, .external_lex_state = 28},
  [936] = {.lex_state = 47, .external_lex_state = 22},
  [937] = {.lex_state = 54, .external_lex_state = 29},
  [938] = {.lex_state = 47, .external_lex_state = 22},
  [939] = {.lex_state = 47, .external_lex_state = 22},
  [940] = {.lex_state = 47, .external_lex_state = 22},
  [941] = {.lex_state = 47, .external_lex_state = 22},
  [942] = {.lex_state = 47, .external_lex_state = 22},
  [943] = {.lex_state = 47, .external_lex_state = 30},
  [944] = {.lex_state = 47, .external_lex_state = 22},
  [945] = {.lex_state = 47, .external_lex_state = 22},
  [946] = {.lex_state = 47, .external_lex_state = 22},
  [947] = {.lex_state = 47, .external_lex_state = 23},
  [948] = {.lex_state = 47, .external_lex_state = 25},
  [949] = {.lex_state = 47, .external_lex_state = 27},
  [950] = {.lex_state = 47, .external_lex_state = 30},
  [951] = {.lex_state = 47, .external_lex_state = 22},
  [952] = {.lex_state = 54, .external_lex_state = 29},
  [953] = {.lex_state = 47, .external_lex_state = 22},
  [954] = {.lex_state = 47, .external_lex_state = 22},
  [955] = {.lex_state = 47, .external_lex_state = 22},
  [956] = {.lex_state = 47, .external_lex_state = 31},
  [957] = {.lex_state = 47, .external_lex_state = 32},
  [958] = {.lex_state = 47, .external_lex_state = 33},
  [959] = {.lex_state = 47, .external_lex_state = 34},
  [960] = {.lex_state = 47, .external_lex_state = 33},
  [961] = {.lex_state = 47, .external_lex_state = 22},
  [962] = {.lex_state = 47, .external_lex_state = 35},
  [963] = {.lex_state = 47, .external_lex_state = 31},
  [964] = {.lex_state = 47, .external_lex_state = 32},
  [965] = {.lex_state = 48, .external_lex_state = 13},
  [966] = {.lex_state = 48, .external_lex_state = 13},
  [967] = {.lex_state = 47, .external_lex_state = 36},
  [968] = {.lex_state = 48, .external_lex_state = 13},
  [969] = {.lex_state = 48, .external_lex_state = 13},
  [970] = {.lex_state = 47, .external_lex_state = 36},
  [971] = {.lex_state = 48, .external_lex_state = 13},
  [972] = {.lex_state = 48, .external_lex_state = 13},
  [973] = {.lex_state = 47, .external_lex_state = 36},
  [974] = {.lex_state = 47, .external_lex_state = 36},
  [975] = {.lex_state = 47, .external_lex_state = 36},
  [976] = {.lex_state = 47, .external_lex_state = 36},
  [977] = {.lex_state = 47, .external_lex_state = 36},
  [978] = {.lex_state = 47, .external_lex_state = 36},
  [979] = {.lex_state = 47, .external_lex_state = 36},
  [980] = {.lex_state = 48, .external_lex_state = 13},
  [981] = {.lex_state = 47, .external_lex_state = 36},
  [982] = {.lex_state = 47, .external_lex_state = 36},
  [983] = {.lex_state = 47, .external_lex_state = 36},
  [984] = {.lex_state = 48, .external_lex_state = 13},
  [985] = {.lex_state = 47, .external_lex_state = 36},
  [986] = {.lex_state = 47, .external_lex_state = 36},
  [987] = {.lex_state = 48, .external_lex_state = 13},
  [988] = {.lex_state = 47, .external_lex_state = 36},
  [989] = {.lex_state = 47, .external_lex_state = 36},
  [990] = {.lex_state = 47, .external_lex_state = 36},
  [991] = {.lex_state = 47, .external_lex_state = 36},
  [992] = {.lex_state = 48, .external_lex_state = 13},
  [993] = {.lex_state = 48, .external_lex_state = 13},
  [994] = {.lex_state = 48, .external_lex_state = 13},
  [995] = {.lex_state = 47, .external_lex_state = 36},
  [996] = {.lex_state = 47, .external_lex_state = 36},
  [997] = {.lex_state = 47, .external_lex_state = 36},
  [998] = {.lex_state = 47, .external_lex_state = 36},
  [999] = {.lex_state = 48, .external_lex_state = 13},
  [1000] = {.lex_state = 47, .external_lex_state = 36},
  [1001] = {.lex_state = 48, .external_lex_state = 13},
  [1002] = {.lex_state = 47, .external_lex_state = 36},
  [1003] = {.lex_state = 47, .external_lex_state = 36},
  [1004] = {.lex_state = 48, .external_lex_state = 13},
  [1005] = {.lex_state = 48, .external_lex_state = 13},
  [1006] = {.lex_state = 47, .external_lex_state = 36},
  [1007] = {.lex_state = 47, .external_lex_state = 36},
  [1008] = {.lex_state = 48, .external_lex_state = 13},
  [1009] = {.lex_state = 47, .external_lex_state = 36},
  [1010] = {.lex_state = 47, .external_lex_state = 36},
  [1011] = {.lex_state = 47, .external_lex_state = 36},
  [1012] = {.lex_state = 48, .external_lex_state = 13},
  [1013] = {.lex_state = 47, .external_lex_state = 36},
  [1014] = {.lex_state = 47, .external_lex_state = 36},
  [1015] = {.lex_state = 47, .external_lex_state = 36},
  [1016] = {.lex_state = 48, .external_lex_state = 13},
  [1017] = {.lex_state = 47, .external_lex_state = 36},
  [1018] = {.lex_state = 47, .external_lex_state = 36},
  [1019] = {.lex_state = 48, .external_lex_state = 13},
  [1020] = {.lex_state = 48, .external_lex_state = 13},
  [1021] = {.lex_state = 47, .external_lex_state = 36},
  [1022] = {.lex_state = 48, .external_lex_state = 13},
  [1023] = {.lex_state = 48, .external_lex_state = 13},
  [1024] = {.lex_state = 48, .external_lex_state = 13},
  [1025] = {.lex_state = 48, .external_lex_state = 13},
  [1026] = {.lex_state = 47, .external_lex_state = 36},
  [1027] = {.lex_state = 47, .external_lex_state = 36},
  [1028] = {.lex_state = 48, .external_lex_state = 13},
  [1029] = {.lex_state = 47, .external_lex_state = 36},
  [1030] = {.lex_state = 48, .external_lex_state = 13},
  [1031] = {.lex_state = 47, .external_lex_state = 36},
  [1032] = {.lex_state = 47, .external_lex_state = 36},
  [1033] = {.lex_state = 47, .external_lex_state = 36},
  [1034] = {.lex_state = 48, .external_lex_state = 13},
  [1035] = {.lex_state = 47, .external_lex_state = 36},
  [1036] = {.lex_state = 47, .external_lex_state = 36},
  [1037] = {.lex_state = 47, .external_lex_state = 36},
  [1038] = {.lex_state = 48, .external_lex_state = 13},
  [1039] = {.lex_state = 47, .external_lex_state = 36},
  [1040] = {.lex_state = 47, .external_lex_state = 36},
  [1041] = {.lex_state = 47, .external_lex_state = 36},
  [1042] = {.lex_state = 48, .external_lex_state = 13},
  [1043] = {.lex_state = 47, .external_lex_state = 36},
  [1044] = {.lex_state = 47, .external_lex_state = 36},
  [1045] = {.lex_state = 47, .external_lex_state = 36},
  [1046] = {.lex_state = 48, .external_lex_state = 13},
  [1047] = {.lex_state = 47, .external_lex_state = 36},
  [1048] = {.lex_state = 47, .external_lex_state = 36},
  [1049] = {.lex_state = 47, .external_lex_state = 36},
  [1050] = {.lex_state = 48, .external_lex_state = 13},
  [1051] = {.lex_state = 47, .external_lex_state = 36},
  [1052] = {.lex_state = 47, .external_lex_state = 36},
  [1053] = {.lex_state = 47, .external_lex_state = 36},
  [1054] = {.lex_state = 48, .external_lex_state = 13},
  [1055] = {.lex_state = 48, .external_lex_state = 13},
  [1056] = {.lex_state = 48, .external_lex_state = 13},
  [1057] = {.lex_state = 48, .external_lex_state = 13},
  [1058] = {.lex_state = 48, .external_lex_state = 13},
  [1059] = {.lex_state = 48, .external_lex_state = 13},
  [1060] = {.lex_state = 48, .external_lex_state = 13},
  [1061] = {.lex_state = 47, .external_lex_state = 36},
  [1062] = {.lex_state = 47, .external_lex_state = 36},
  [1063] = {.lex_state = 47, .external_lex_state = 36},
  [1064] = {.lex_state = 48, .external_lex_state = 13},
  [1065] = {.lex_state = 47, .external_lex_state = 36},
  [1066] = {.lex_state = 47, .external_lex_state = 36},
  [1067] = {.lex_state = 47, .external_lex_state = 36},
  [1068] = {.lex_state = 47, .external_lex_state = 36},
  [1069] = {.lex_state = 47, .external_lex_state = 36},
  [1070] = {.lex_state = 48, .external_lex_state = 13},
  [1071] = {.lex_state = 47, .external_lex_state = 36},
  [1072] = {.lex_state = 47, .external_lex_state = 36},
  [1073] = {.lex_state = 47, .external_lex_state = 36},
  [1074] = {.lex_state = 47, .external_lex_state = 36},
  [1075] = {.lex_state = 48, .external_lex_state = 13},
  [1076] = {.lex_state = 48, .external_lex_state = 13},
  [1077] = {.lex_state = 47, .external_lex_state = 36},
  [1078] = {.lex_state = 47, .external_lex_state = 36},
  [1079] = {.lex_state = 48, .external_lex_state = 13},
  [1080] = {.lex_state = 48, .external_lex_state = 13},
  [1081] = {.lex_state = 48, .external_lex_state = 13},
  [1082] = {.lex_state = 47, .external_lex_state = 36},
  [1083] = {.lex_state = 48, .external_lex_state = 13},
  [1084] = {.lex_state = 48, .external_lex_state = 13},
  [1085] = {.lex_state = 48, .external_lex_state = 13},
  [1086] = {.lex_state = 47, .external_lex_state = 36},
  [1087] = {.lex_state = 47, .external_lex_state = 36},
  [1088] = {.lex_state = 47, .external_lex_state = 36},
  [1089] = {.lex_state = 48, .external_lex_state = 13},
  [1090] = {.lex_state = 48, .external_lex_state = 13},
  [1091] = {.lex_state = 47, .external_lex_state = 36},
  [1092] = {.lex_state = 47, .external_lex_state = 36},
  [1093] = {.lex_state = 47, .external_lex_state = 36},
  [1094] = {.lex_state = 48, .external_lex_state = 13},
  [1095] = {.lex_state = 47, .external_lex_state = 36},
  [1096] = {.lex_state = 47, .external_lex_state = 36},
  [1097] = {.lex_state = 47, .external_lex_state = 36},
  [1098] = {.lex_state = 48, .external_lex_state = 13},
  [1099] = {.lex_state = 47, .external_lex_state = 36},
  [1100] = {.lex_state = 47, .external_lex_state = 36},
  [1101] = {.lex_state = 48, .external_lex_state = 13},
  [1102] = {.lex_state = 48, .external_lex_state = 13},
  [1103] = {.lex_state = 47, .external_lex_state = 36},
  [1104] = {.lex_state = 48, .external_lex_state = 13},
  [1105] = {.lex_state = 47, .external_lex_state = 36},
  [1106] = {.lex_state = 47, .external_lex_state = 36},
  [1107] = {.lex_state = 47, .external_lex_state = 36},
  [1108] = {.lex_state = 47, .external_lex_state = 36},
  [1109] = {.lex_state = 47, .external_lex_state = 36},
  [1110] = {.lex_state = 47, .external_lex_state = 36},
  [1111] = {.lex_state = 48, .external_lex_state = 13},
  [1112] = {.lex_state = 47, .external_lex_state = 36},
  [1113] = {.lex_state = 48, .external_lex_state = 13},
  [1114] = {.lex_state = 47, .external_lex_state = 36},
  [1115] = {.lex_state = 48, .external_lex_state = 13},
  [1116] = {.lex_state = 48, .external_lex_state = 13},
  [1117] = {.lex_state = 48, .external_lex_state = 13},
  [1118] = {.lex_state = 47, .external_lex_state = 36},
  [1119] = {.lex_state = 48, .external_lex_state = 13},
  [1120] = {.lex_state = 48, .external_lex_state = 13},
  [1121] = {.lex_state = 47, .external_lex_state = 36},
  [1122] = {.lex_state = 47, .external_lex_state = 36},
  [1123] = {.lex_state = 47, .external_lex_state = 36},
  [1124] = {.lex_state = 48, .external_lex_state = 13},
  [1125] = {.lex_state = 47, .external_lex_state = 36},
  [1126] = {.lex_state = 47, .external_lex_state = 36},
  [1127] = {.lex_state = 47, .external_lex_state = 36},
  [1128] = {.lex_state = 47, .external_lex_state = 36},
  [1129] = {.lex_state = 48, .external_lex_state = 13},
  [1130] = {.lex_state = 47, .external_lex_state = 36},
  [1131] = {.lex_state = 47, .external_lex_state = 36},
  [1132] = {.lex_state = 48, .external_lex_state = 13},
  [1133] = {.lex_state = 47, .external_lex_state = 36},
  [1134] = {.lex_state = 47, .external_lex_state = 36},
  [1135] = {.lex_state = 47, .external_lex_state = 36},
  [1136] = {.lex_state = 47, .external_lex_state = 36},
  [1137] = {.lex_state = 48, .external_lex_state = 13},
  [1138] = {.lex_state = 47, .external_lex_state = 36},
  [1139] = {.lex_state = 47, .external_lex_state = 36},
  [1140] = {.lex_state = 47, .external_lex_state = 36},
  [1141] = {.lex_state = 47, .external_lex_state = 36},
  [1142] = {.lex_state = 48, .external_lex_state = 13},
  [1143] = {.lex_state = 47, .external_lex_state = 36},
  [1144] = {.lex_state = 47, .external_lex_state = 36},
  [1145] = {.lex_state = 47, .external_lex_state = 36},
  [1146] = {.lex_state = 47, .external_lex_state = 36},
  [1147] = {.lex_state = 47, .external_lex_state = 36},
  [1148] = {.lex_state = 48, .external_lex_state = 13},
  [1149] = {.lex_state = 47, .external_lex_state = 36},
  [1150] = {.lex_state = 48, .external_lex_state = 13},
  [1151] = {.lex_state = 47, .external_lex_state = 36},
  [1152] = {.lex_state = 48, .external_lex_state = 13},
  [1153] = {.lex_state = 48, .external_lex_state = 13},
  [1154] = {.lex_state = 47, .external_lex_state = 36},
  [1155] = {.lex_state = 47, .external_lex_state = 36},
  [1156] = {.lex_state = 47, .external_lex_state = 36},
  [1157] = {.lex_state = 47, .external_lex_state = 36},
  [1158] = {.lex_state = 48, .external_lex_state = 13},
  [1159] = {.lex_state = 47, .external_lex_state = 36},
  [1160] = {.lex_state = 47, .external_lex_state = 36},
  [1161] = {.lex_state = 47, .external_lex_state = 36},
  [1162] = {.lex_state = 47, .external_lex_state = 36},
  [1163] = {.lex_state = 48, .external_lex_state = 13},
  [1164] = {.lex_state = 47, .external_lex_state = 36},
  [1165] = {.lex_state = 47, .external_lex_state = 36},
  [1166] = {.lex_state = 48, .external_lex_state = 13},
  [1167] = {.lex_state = 48, .external_lex_state = 13},
  [1168] = {.lex_state = 48, .external_lex_state = 13},
  [1169] = {.lex_state = 48, .external_lex_state = 13},
  [1170] = {.lex_state = 47, .external_lex_state = 36},
  [1171] = {.lex_state = 47, .external_lex_state = 36},
  [1172] = {.lex_state = 48, .external_lex_state = 13},
  [1173] = {.lex_state = 48, .external_lex_state = 13},
  [1174] = {.lex_state = 48, .external_lex_state = 13},
  [1175] = {.lex_state = 48, .external_lex_state = 13},
  [1176] = {.lex_state = 47, .external_lex_state = 36},
  [1177] = {.lex_state = 47, .external_lex_state = 36},
  [1178] = {.lex_state = 47, .external_lex_state = 36},
  [1179] = {.lex_state = 48, .external_lex_state = 13},
  [1180] = {.lex_state = 48, .external_lex_state = 13},
  [1181] = {.lex_state = 47, .external_lex_state = 36},
  [1182] = {.lex_state = 47, .external_lex_state = 36},
  [1183] = {.lex_state = 47, .external_lex_state = 36},
  [1184] = {.lex_state = 47, .external_lex_state = 36},
  [1185] = {.lex_state = 48, .external_lex_state = 13},
  [1186] = {.lex_state = 47, .external_lex_state = 36},
  [1187] = {.lex_state = 47, .external_lex_state = 36},
  [1188] = {.lex_state = 47, .external_lex_state = 36},
  [1189] = {.lex_state = 47, .external_lex_state = 36},
  [1190] = {.lex_state = 48, .external_lex_state = 13},
  [1191] = {.lex_state = 48, .external_lex_state = 13},
  [1192] = {.lex_state = 47, .external_lex_state = 36},
  [1193] = {.lex_state = 47, .external_lex_state = 36},
  [1194] = {.lex_state = 47, .external_lex_state = 36},
  [1195] = {.lex_state = 47, .external_lex_state = 36},
  [1196] = {.lex_state = 47, .external_lex_state = 36},
  [1197] = {.lex_state = 48, .external_lex_state = 13},
  [1198] = {.lex_state = 47, .external_lex_state = 36},
  [1199] = {.lex_state = 47, .external_lex_state = 36},
  [1200] = {.lex_state = 47, .external_lex_state = 36},
  [1201] = {.lex_state = 47, .external_lex_state = 36},
  [1202] = {.lex_state = 48, .external_lex_state = 13},
  [1203] = {.lex_state = 48, .external_lex_state = 13},
  [1204] = {.lex_state = 47, .external_lex_state = 36},
  [1205] = {.lex_state = 48, .external_lex_state = 13},
  [1206] = {.lex_state = 47, .external_lex_state = 36},
  [1207] = {.lex_state = 48, .external_lex_state = 13},
  [1208] = {.lex_state = 48, .external_lex_state = 13},
  [1209] = {.lex_state = 47, .external_lex_state = 36},
  [1210] = {.lex_state = 47, .external_lex_state = 36},
  [1211] = {.lex_state = 48, .external_lex_state = 13},
  [1212] = {.lex_state = 47, .external_lex_state = 36},
  [1213] = {.lex_state = 47, .external_lex_state = 36},
  [1214] = {.lex_state = 47, .external_lex_state = 36},
  [1215] = {.lex_state = 48, .external_lex_state = 13},
  [1216] = {.lex_state = 47, .external_lex_state = 36},
  [1217] = {.lex_state = 47, .external_lex_state = 36},
  [1218] = {.lex_state = 47, .external_lex_state = 36},
  [1219] = {.lex_state = 47, .external_lex_state = 36},
  [1220] = {.lex_state = 48, .external_lex_state = 13},
  [1221] = {.lex_state = 47, .external_lex_state = 36},
  [1222] = {.lex_state = 47, .external_lex_state = 36},
  [1223] = {.lex_state = 48, .external_lex_state = 13},
  [1224] = {.lex_state = 47, .external_lex_state = 36},
  [1225] = {.lex_state = 48, .external_lex_state = 13},
  [1226] = {.lex_state = 47, .external_lex_state = 36},
  [1227] = {.lex_state = 48, .external_lex_state = 13},
  [1228] = {.lex_state = 48, .external_lex_state = 13},
  [1229] = {.lex_state = 48, .external_lex_state = 13},
  [1230] = {.lex_state = 47, .external_lex_state = 36},
  [1231] = {.lex_state = 47, .external_lex_state = 36},
  [1232] = {.lex_state = 48, .external_lex_state = 13},
  [1233] = {.lex_state = 48, .external_lex_state = 13},
  [1234] = {.lex_state = 47, .external_lex_state = 36},
  [1235] = {.lex_state = 47, .external_lex_state = 36},
  [1236] = {.lex_state = 48, .external_lex_state = 13},
  [1237] = {.lex_state = 47, .external_lex_state = 36},
  [1238] = {.lex_state = 48, .external_lex_state = 13},
  [1239] = {.lex_state = 48, .external_lex_state = 13},
  [1240] = {.lex_state = 47, .external_lex_state = 36},
  [1241] = {.lex_state = 47, .external_lex_state = 36},
  [1242] = {.lex_state = 47, .external_lex_state = 36},
  [1243] = {.lex_state = 47, .external_lex_state = 36},
  [1244] = {.lex_state = 47, .external_lex_state = 36},
  [1245] = {.lex_state = 47, .external_lex_state = 36},
  [1246] = {.lex_state = 48, .external_lex_state = 13},
  [1247] = {.lex_state = 47, .external_lex_state = 36},
  [1248] = {.lex_state = 47, .external_lex_state = 36},
  [1249] = {.lex_state = 47, .external_lex_state = 36},
  [1250] = {.lex_state = 48, .external_lex_state = 13},
  [1251] = {.lex_state = 48, .external_lex_state = 13},
  [1252] = {.lex_state = 48, .external_lex_state = 13},
  [1253] = {.lex_state = 48, .external_lex_state = 13},
  [1254] = {.lex_state = 47, .external_lex_state = 36},
  [1255] = {.lex_state = 47, .external_lex_state = 36},
  [1256] = {.lex_state = 47, .external_lex_state = 36},
  [1257] = {.lex_state = 47, .external_lex_state = 36},
  [1258] = {.lex_state = 48, .external_lex_state = 13},
  [1259] = {.lex_state = 47, .external_lex_state = 36},
  [1260] = {.lex_state = 48, .external_lex_state = 13},
  [1261] = {.lex_state = 48, .external_lex_state = 13},
  [1262] = {.lex_state = 48, .external_lex_state = 13},
  [1263] = {.lex_state = 48, .external_lex_state = 13},
  [1264] = {.lex_state = 48, .external_lex_state = 13},
  [1265] = {.lex_state = 47, .external_lex_state = 36},
  [1266] = {.lex_state = 47, .external_lex_state = 36},
  [1267] = {.lex_state = 47, .external_lex_state = 36},
  [1268] = {.lex_state = 47, .external_lex_state = 36},
  [1269] = {.lex_state = 47, .external_lex_state = 36},
  [1270] = {.lex_state = 47, .external_lex_state = 36},
  [1271] = {.lex_state = 47, .external_lex_state = 36},
  [1272] = {.lex_state = 47, .external_lex_state = 36},
  [1273] = {.lex_state = 47, .external_lex_state = 36},
  [1274] = {.lex_state = 47, .external_lex_state = 36},
  [1275] = {.lex_state = 47, .external_lex_state = 36},
  [1276] = {.lex_state = 47, .external_lex_state = 36},
  [1277] = {.lex_state = 47, .external_lex_state = 36},
  [1278] = {.lex_state = 47, .external_lex_state = 36},
  [1279] = {.lex_state = 47, .external_lex_state = 36},
  [1280] = {.lex_state = 47, .external_lex_state = 36},
  [1281] = {.lex_state = 47, .external_lex_state = 36},
  [1282] = {.lex_state = 47, .external_lex_state = 36},
  [1283] = {.lex_state = 47, .external_lex_state = 37},
  [1284] = {.lex_state = 47, .external_lex_state = 36},
  [1285] = {.lex_state = 47, .external_lex_state = 36},
  [1286] = {.lex_state = 48, .external_lex_state = 13},
  [1287] = {.lex_state = 47, .external_lex_state = 36},
  [1288] = {.lex_state = 47, .external_lex_state = 36},
  [1289] = {.lex_state = 47, .external_lex_state = 36},
  [1290] = {.lex_state = 47, .external_lex_state = 36},
  [1291] = {.lex_state = 47, .external_lex_state = 36},
  [1292] = {.lex_state = 47, .external_lex_state = 36},
  [1293] = {.lex_state = 47, .external_lex_state = 36},
  [1294] = {.lex_state = 47, .external_lex_state = 36},
  [1295] = {.lex_state = 47, .external_lex_state = 36},
  [1296] = {.lex_state = 47, .external_lex_state = 36},
  [1297] = {.lex_state = 48, .external_lex_state = 13},
  [1298] = {.lex_state = 47, .external_lex_state = 36},
  [1299] = {.lex_state = 48, .external_lex_state = 13},
  [1300] = {.lex_state = 47, .external_lex_state = 36},
  [1301] = {.lex_state = 47, .external_lex_state = 36},
  [1302] = {.lex_state = 48, .external_lex_state = 13},
  [1303] = {.lex_state = 47, .external_lex_state = 37},
  [1304] = {.lex_state = 48, .external_lex_state = 13},
  [1305] = {.lex_state = 47, .external_lex_state = 36},
  [1306] = {.lex_state = 47, .external_lex_state = 36},
  [1307] = {.lex_state = 47, .external_lex_state = 36},
  [1308] = {.lex_state = 47, .external_lex_state = 36},
  [1309] = {.lex_state = 47, .external_lex_state = 36},
  [1310] = {.lex_state = 47, .external_lex_state = 36},
  [1311] = {.lex_state = 47, .external_lex_state = 36},
  [1312] = {.lex_state = 47, .external_lex_state = 36},
  [1313] = {.lex_state = 47, .external_lex_state = 36},
  [1314] = {.lex_state = 47, .external_lex_state = 36},
  [1315] = {.lex_state = 47, .external_lex_state = 36},
  [1316] = {.lex_state = 47, .external_lex_state = 36},
  [1317] = {.lex_state = 47, .external_lex_state = 36},
  [1318] = {.lex_state = 47, .external_lex_state = 36},
  [1319] = {.lex_state = 47, .external_lex_state = 36},
  [1320] = {.lex_state = 47, .external_lex_state = 36},
  [1321] = {.lex_state = 47, .external_lex_state = 36},
  [1322] = {.lex_state = 47, .external_lex_state = 36},
  [1323] = {.lex_state = 47, .external_lex_state = 36},
  [1324] = {.lex_state = 47, .external_lex_state = 36},
  [1325] = {.lex_state = 47, .external_lex_state = 36},
  [1326] = {.lex_state = 47, .external_lex_state = 36},
  [1327] = {.lex_state = 47, .external_lex_state = 36},
  [1328] = {.lex_state = 47, .external_lex_state = 36},
  [1329] = {.lex_state = 47, .external_lex_state = 36},
  [1330] = {.lex_state = 47, .external_lex_state = 36},
  [1331] = {.lex_state = 47, .external_lex_state = 36},
  [1332] = {.lex_state = 47, .external_lex_state = 36},
  [1333] = {.lex_state = 47, .external_lex_state = 36},
  [1334] = {.lex_state = 47, .external_lex_state = 36},
  [1335] = {.lex_state = 47, .external_lex_state = 36},
  [1336] = {.lex_state = 47, .external_lex_state = 36},
  [1337] = {.lex_state = 47, .external_lex_state = 36},
  [1338] = {.lex_state = 47, .external_lex_state = 36},
  [1339] = {.lex_state = 47, .external_lex_state = 36},
  [1340] = {.lex_state = 47, .external_lex_state = 36},
  [1341] = {.lex_state = 47, .external_lex_state = 36},
  [1342] = {.lex_state = 47, .external_lex_state = 36},
  [1343] = {.lex_state = 47, .external_lex_state = 36},
  [1344] = {.lex_state = 47, .external_lex_state = 36},
  [1345] = {.lex_state = 47, .external_lex_state = 36},
  [1346] = {.lex_state = 47, .external_lex_state = 36},
  [1347] = {.lex_state = 47, .external_lex_state = 36},
  [1348] = {.lex_state = 47, .external_lex_state = 36},
  [1349] = {.lex_state = 47, .external_lex_state = 36},
  [1350] = {.lex_state = 47, .external_lex_state = 36},
  [1351] = {.lex_state = 47, .external_lex_state = 36},
  [1352] = {.lex_state = 47, .external_lex_state = 36},
  [1353] = {.lex_state = 47, .external_lex_state = 36},
  [1354] = {.lex_state = 47, .external_lex_state = 36},
  [1355] = {.lex_state = 47, .external_lex_state = 36},
  [1356] = {.lex_state = 47, .external_lex_state = 36},
  [1357] = {.lex_state = 47, .external_lex_state = 36},
  [1358] = {.lex_state = 47, .external_lex_state = 36},
  [1359] = {.lex_state = 47, .external_lex_state = 36},
  [1360] = {.lex_state = 47, .external_lex_state = 36},
  [1361] = {.lex_state = 47, .external_lex_state = 36},
  [1362] = {.lex_state = 47, .external_lex_state = 36},
  [1363] = {.lex_state = 47, .external_lex_state = 36},
  [1364] = {.lex_state = 47, .external_lex_state = 36},
  [1365] = {.lex_state = 47, .external_lex_state = 36},
  [1366] = {.lex_state = 47, .external_lex_state = 36},
  [1367] = {.lex_state = 47, .external_lex_state = 36},
  [1368] = {.lex_state = 47, .external_lex_state = 36},
  [1369] = {.lex_state = 47, .external_lex_state = 36},
  [1370] = {.lex_state = 47, .external_lex_state = 36},
  [1371] = {.lex_state = 47, .external_lex_state = 36},
  [1372] = {.lex_state = 47, .external_lex_state = 36},
  [1373] = {.lex_state = 47, .external_lex_state = 36},
  [1374] = {.lex_state = 47, .external_lex_state = 36},
  [1375] = {.lex_state = 47, .external_lex_state = 36},
  [1376] = {.lex_state = 47, .external_lex_state = 36},
  [1377] = {.lex_state = 47, .external_lex_state = 36},
  [1378] = {.lex_state = 47, .external_lex_state = 36},
  [1379] = {.lex_state = 47, .external_lex_state = 36},
  [1380] = {.lex_state = 47, .external_lex_state = 36},
  [1381] = {.lex_state = 47, .external_lex_state = 36},
  [1382] = {.lex_state = 47, .external_lex_state = 36},
  [1383] = {.lex_state = 47, .external_lex_state = 36},
  [1384] = {.lex_state = 47, .external_lex_state = 36},
  [1385] = {.lex_state = 47, .external_lex_state = 36},
  [1386] = {.lex_state = 47, .external_lex_state = 36},
  [1387] = {.lex_state = 47, .external_lex_state = 36},
  [1388] = {.lex_state = 47, .external_lex_state = 36},
  [1389] = {.lex_state = 47, .external_lex_state = 36},
  [1390] = {.lex_state = 47, .external_lex_state = 36},
  [1391] = {.lex_state = 47, .external_lex_state = 36},
  [1392] = {.lex_state = 47, .external_lex_state = 36},
  [1393] = {.lex_state = 47, .external_lex_state = 36},
  [1394] = {.lex_state = 47, .external_lex_state = 36},
  [1395] = {.lex_state = 47, .external_lex_state = 36},
  [1396] = {.lex_state = 47, .external_lex_state = 36},
  [1397] = {.lex_state = 47, .external_lex_state = 36},
  [1398] = {.lex_state = 47, .external_lex_state = 36},
  [1399] = {.lex_state = 47, .external_lex_state = 36},
  [1400] = {.lex_state = 47, .external_lex_state = 3},
  [1401] = {.lex_state = 47, .external_lex_state = 36},
  [1402] = {.lex_state = 47, .external_lex_state = 36},
  [1403] = {.lex_state = 47, .external_lex_state = 36},
  [1404] = {.lex_state = 47, .external_lex_state = 36},
  [1405] = {.lex_state = 47, .external_lex_state = 36},
  [1406] = {.lex_state = 47, .external_lex_state = 36},
  [1407] = {.lex_state = 47, .external_lex_state = 36},
  [1408] = {.lex_state = 47, .external_lex_state = 36},
  [1409] = {.lex_state = 47, .external_lex_state = 36},
  [1410] = {.lex_state = 47, .external_lex_state = 36},
  [1411] = {.lex_state = 47, .external_lex_state = 36},
  [1412] = {.lex_state = 47, .external_lex_state = 36},
  [1413] = {.lex_state = 47, .external_lex_state = 36},
  [1414] = {.lex_state = 47, .external_lex_state = 36},
  [1415] = {.lex_state = 47, .external_lex_state = 36},
  [1416] = {.lex_state = 47, .external_lex_state = 36},
  [1417] = {.lex_state = 47, .external_lex_state = 36},
  [1418] = {.lex_state = 47, .external_lex_state = 36},
  [1419] = {.lex_state = 47, .external_lex_state = 36},
  [1420] = {.lex_state = 47, .external_lex_state = 36},
  [1421] = {.lex_state = 47, .external_lex_state = 36},
  [1422] = {.lex_state = 47, .external_lex_state = 36},
  [1423] = {.lex_state = 47, .external_lex_state = 36},
  [1424] = {.lex_state = 47, .external_lex_state = 36},
  [1425] = {.lex_state = 47, .external_lex_state = 36},
  [1426] = {.lex_state = 47, .external_lex_state = 36},
  [1427] = {.lex_state = 47, .external_lex_state = 36},
  [1428] = {.lex_state = 47, .external_lex_state = 36},
  [1429] = {.lex_state = 47, .external_lex_state = 36},
  [1430] = {.lex_state = 47, .external_lex_state = 36},
  [1431] = {.lex_state = 47, .external_lex_state = 36},
  [1432] = {.lex_state = 47, .external_lex_state = 36},
  [1433] = {.lex_state = 47, .external_lex_state = 36},
  [1434] = {.lex_state = 47, .external_lex_state = 36},
  [1435] = {.lex_state = 47, .external_lex_state = 36},
  [1436] = {.lex_state = 47, .external_lex_state = 36},
  [1437] = {.lex_state = 47, .external_lex_state = 36},
  [1438] = {.lex_state = 47, .external_lex_state = 36},
  [1439] = {.lex_state = 47, .external_lex_state = 36},
  [1440] = {.lex_state = 47, .external_lex_state = 36},
  [1441] = {.lex_state = 47, .external_lex_state = 36},
  [1442] = {.lex_state = 47, .external_lex_state = 36},
  [1443] = {.lex_state = 47, .external_lex_state = 36},
  [1444] = {.lex_state = 47, .external_lex_state = 36},
  [1445] = {.lex_state = 47, .external_lex_state = 36},
  [1446] = {.lex_state = 47, .external_lex_state = 36},
  [1447] = {.lex_state = 47, .external_lex_state = 36},
  [1448] = {.lex_state = 47, .external_lex_state = 36},
  [1449] = {.lex_state = 47, .external_lex_state = 36},
  [1450] = {.lex_state = 47, .external_lex_state = 36},
  [1451] = {.lex_state = 47, .external_lex_state = 36},
  [1452] = {.lex_state = 47, .external_lex_state = 36},
  [1453] = {.lex_state = 47, .external_lex_state = 36},
  [1454] = {.lex_state = 47, .external_lex_state = 36},
  [1455] = {.lex_state = 47, .external_lex_state = 36},
  [1456] = {.lex_state = 47, .external_lex_state = 36},
  [1457] = {.lex_state = 47, .external_lex_state = 36},
  [1458] = {.lex_state = 47, .external_lex_state = 36},
  [1459] = {.lex_state = 47, .external_lex_state = 36},
  [1460] = {.lex_state = 47, .external_lex_state = 36},
  [1461] = {.lex_state = 47, .external_lex_state = 36},
  [1462] = {.lex_state = 47, .external_lex_state = 36},
  [1463] = {.lex_state = 47, .external_lex_state = 36},
  [1464] = {.lex_state = 47, .external_lex_state = 36},
  [1465] = {.lex_state = 47, .external_lex_state = 36},
  [1466] = {.lex_state = 47, .external_lex_state = 36},
  [1467] = {.lex_state = 47, .external_lex_state = 36},
  [1468] = {.lex_state = 47, .external_lex_state = 36},
  [1469] = {.lex_state = 47, .external_lex_state = 36},
  [1470] = {.lex_state = 47, .external_lex_state = 36},
  [1471] = {.lex_state = 47, .external_lex_state = 36},
  [1472] = {.lex_state = 47, .external_lex_state = 36},
  [1473] = {.lex_state = 47, .external_lex_state = 36},
  [1474] = {.lex_state = 47, .external_lex_state = 36},
  [1475] = {.lex_state = 47, .external_lex_state = 36},
  [1476] = {.lex_state = 47, .external_lex_state = 36},
  [1477] = {.lex_state = 47, .external_lex_state = 36},
  [1478] = {.lex_state = 47, .external_lex_state = 36},
  [1479] = {.lex_state = 47, .external_lex_state = 36},
  [1480] = {.lex_state = 47, .external_lex_state = 36},
  [1481] = {.lex_state = 47, .external_lex_state = 36},
  [1482] = {.lex_state = 47, .external_lex_state = 36},
  [1483] = {.lex_state = 47, .external_lex_state = 36},
  [1484] = {.lex_state = 47, .external_lex_state = 36},
  [1485] = {.lex_state = 47, .external_lex_state = 36},
  [1486] = {.lex_state = 47, .external_lex_state = 36},
  [1487] = {.lex_state = 47, .external_lex_state = 36},
  [1488] = {.lex_state = 47, .external_lex_state = 36},
  [1489] = {.lex_state = 47, .external_lex_state = 36},
  [1490] = {.lex_state = 47, .external_lex_state = 36},
  [1491] = {.lex_state = 47, .external_lex_state = 36},
  [1492] = {.lex_state = 47, .external_lex_state = 36},
  [1493] = {.lex_state = 47, .external_lex_state = 36},
  [1494] = {.lex_state = 47, .external_lex_state = 36},
  [1495] = {.lex_state = 47, .external_lex_state = 36},
  [1496] = {.lex_state = 47, .external_lex_state = 36},
  [1497] = {.lex_state = 47, .external_lex_state = 36},
  [1498] = {.lex_state = 47, .external_lex_state = 36},
  [1499] = {.lex_state = 47, .external_lex_state = 36},
  [1500] = {.lex_state = 47, .external_lex_state = 36},
  [1501] = {.lex_state = 47, .external_lex_state = 36},
  [1502] = {.lex_state = 47, .external_lex_state = 3},
  [1503] = {.lex_state = 47, .external_lex_state = 36},
  [1504] = {.lex_state = 47, .external_lex_state = 36},
  [1505] = {.lex_state = 47, .external_lex_state = 36},
  [1506] = {.lex_state = 47, .external_lex_state = 36},
  [1507] = {.lex_state = 47, .external_lex_state = 36},
  [1508] = {.lex_state = 47, .external_lex_state = 36},
  [1509] = {.lex_state = 47, .external_lex_state = 36},
  [1510] = {.lex_state = 47, .external_lex_state = 36},
  [1511] = {.lex_state = 47, .external_lex_state = 36},
  [1512] = {.lex_state = 47, .external_lex_state = 36},
  [1513] = {.lex_state = 47, .external_lex_state = 36},
  [1514] = {.lex_state = 47, .external_lex_state = 36},
  [1515] = {.lex_state = 47, .external_lex_state = 36},
  [1516] = {.lex_state = 47, .external_lex_state = 36},
  [1517] = {.lex_state = 47, .external_lex_state = 36},
  [1518] = {.lex_state = 47, .external_lex_state = 36},
  [1519] = {.lex_state = 47, .external_lex_state = 36},
  [1520] = {.lex_state = 47, .external_lex_state = 36},
  [1521] = {.lex_state = 47, .external_lex_state = 36},
  [1522] = {.lex_state = 47, .external_lex_state = 36},
  [1523] = {.lex_state = 47, .external_lex_state = 36},
  [1524] = {.lex_state = 47, .external_lex_state = 36},
  [1525] = {.lex_state = 47, .external_lex_state = 36},
  [1526] = {.lex_state = 47, .external_lex_state = 36},
  [1527] = {.lex_state = 47, .external_lex_state = 36},
  [1528] = {.lex_state = 47, .external_lex_state = 36},
  [1529] = {.lex_state = 47, .external_lex_state = 36},
  [1530] = {.lex_state = 47, .external_lex_state = 36},
  [1531] = {.lex_state = 47, .external_lex_state = 36},
  [1532] = {.lex_state = 47, .external_lex_state = 36},
  [1533] = {.lex_state = 47, .external_lex_state = 36},
  [1534] = {.lex_state = 47, .external_lex_state = 36},
  [1535] = {.lex_state = 47, .external_lex_state = 36},
  [1536] = {.lex_state = 47, .external_lex_state = 36},
  [1537] = {.lex_state = 47, .external_lex_state = 36},
  [1538] = {.lex_state = 47, .external_lex_state = 36},
  [1539] = {.lex_state = 47, .external_lex_state = 36},
  [1540] = {.lex_state = 47, .external_lex_state = 36},
  [1541] = {.lex_state = 47, .external_lex_state = 36},
  [1542] = {.lex_state = 47, .external_lex_state = 36},
  [1543] = {.lex_state = 47, .external_lex_state = 36},
  [1544] = {.lex_state = 47, .external_lex_state = 36},
  [1545] = {.lex_state = 47, .external_lex_state = 36},
  [1546] = {.lex_state = 47, .external_lex_state = 36},
  [1547] = {.lex_state = 47, .external_lex_state = 36},
  [1548] = {.lex_state = 47, .external_lex_state = 36},
  [1549] = {.lex_state = 47, .external_lex_state = 36},
  [1550] = {.lex_state = 47, .external_lex_state = 36},
  [1551] = {.lex_state = 47, .external_lex_state = 36},
  [1552] = {.lex_state = 47, .external_lex_state = 36},
  [1553] = {.lex_state = 47, .external_lex_state = 36},
  [1554] = {.lex_state = 47, .external_lex_state = 36},
  [1555] = {.lex_state = 47, .external_lex_state = 36},
  [1556] = {.lex_state = 47, .external_lex_state = 36},
  [1557] = {.lex_state = 47, .external_lex_state = 36},
  [1558] = {.lex_state = 47, .external_lex_state = 36},
  [1559] = {.lex_state = 47, .external_lex_state = 36},
  [1560] = {.lex_state = 47, .external_lex_state = 36},
  [1561] = {.lex_state = 47, .external_lex_state = 36},
  [1562] = {.lex_state = 47, .external_lex_state = 36},
  [1563] = {.lex_state = 47, .external_lex_state = 36},
  [1564] = {.lex_state = 47, .external_lex_state = 36},
  [1565] = {.lex_state = 47, .external_lex_state = 36},
  [1566] = {.lex_state = 47, .external_lex_state = 36},
  [1567] = {.lex_state = 47, .external_lex_state = 36},
  [1568] = {.lex_state = 47, .external_lex_state = 36},
  [1569] = {.lex_state = 47, .external_lex_state = 36},
  [1570] = {.lex_state = 47, .external_lex_state = 36},
  [1571] = {.lex_state = 47, .external_lex_state = 36},
  [1572] = {.lex_state = 47, .external_lex_state = 36},
  [1573] = {.lex_state = 47, .external_lex_state = 36},
  [1574] = {.lex_state = 47, .external_lex_state = 36},
  [1575] = {.lex_state = 47, .external_lex_state = 36},
  [1576] = {.lex_state = 47, .external_lex_state = 36},
  [1577] = {.lex_state = 47, .external_lex_state = 36},
  [1578] = {.lex_state = 47, .external_lex_state = 36},
  [1579] = {.lex_state = 47, .external_lex_state = 36},
  [1580] = {.lex_state = 47, .external_lex_state = 36},
  [1581] = {.lex_state = 47, .external_lex_state = 36},
  [1582] = {.lex_state = 47, .external_lex_state = 36},
  [1583] = {.lex_state = 47, .external_lex_state = 36},
  [1584] = {.lex_state = 47, .external_lex_state = 36},
  [1585] = {.lex_state = 47, .external_lex_state = 36},
  [1586] = {.lex_state = 47, .external_lex_state = 36},
  [1587] = {.lex_state = 47, .external_lex_state = 36},
  [1588] = {.lex_state = 47, .external_lex_state = 36},
  [1589] = {.lex_state = 47, .external_lex_state = 36},
  [1590] = {.lex_state = 47, .external_lex_state = 36},
  [1591] = {.lex_state = 47, .external_lex_state = 36},
  [1592] = {.lex_state = 47, .external_lex_state = 36},
  [1593] = {.lex_state = 47, .external_lex_state = 36},
  [1594] = {.lex_state = 47, .external_lex_state = 36},
  [1595] = {.lex_state = 47, .external_lex_state = 36},
  [1596] = {.lex_state = 47, .external_lex_state = 36},
  [1597] = {.lex_state = 47, .external_lex_state = 36},
  [1598] = {.lex_state = 47, .external_lex_state = 36},
  [1599] = {.lex_state = 47, .external_lex_state = 36},
  [1600] = {.lex_state = 47, .external_lex_state = 36},
  [1601] = {.lex_state = 47, .external_lex_state = 36},
  [1602] = {.lex_state = 47, .external_lex_state = 36},
  [1603] = {.lex_state = 47, .external_lex_state = 36},
  [1604] = {.lex_state = 47, .external_lex_state = 36},
  [1605] = {.lex_state = 47, .external_lex_state = 36},
  [1606] = {.lex_state = 47, .external_lex_state = 36},
  [1607] = {.lex_state = 47, .external_lex_state = 36},
  [1608] = {.lex_state = 47, .external_lex_state = 36},
  [1609] = {.lex_state = 47, .external_lex_state = 36},
  [1610] = {.lex_state = 47, .external_lex_state = 36},
  [1611] = {.lex_state = 47, .external_lex_state = 36},
  [1612] = {.lex_state = 47, .external_lex_state = 36},
  [1613] = {.lex_state = 47, .external_lex_state = 36},
  [1614] = {.lex_state = 47, .external_lex_state = 36},
  [1615] = {.lex_state = 47, .external_lex_state = 36},
  [1616] = {.lex_state = 47, .external_lex_state = 36},
  [1617] = {.lex_state = 47, .external_lex_state = 36},
  [1618] = {.lex_state = 47, .external_lex_state = 36},
  [1619] = {.lex_state = 47, .external_lex_state = 36},
  [1620] = {.lex_state = 47, .external_lex_state = 36},
  [1621] = {.lex_state = 47, .external_lex_state = 36},
  [1622] = {.lex_state = 47, .external_lex_state = 36},
  [1623] = {.lex_state = 47, .external_lex_state = 36},
  [1624] = {.lex_state = 47, .external_lex_state = 36},
  [1625] = {.lex_state = 47, .external_lex_state = 36},
  [1626] = {.lex_state = 47, .external_lex_state = 36},
  [1627] = {.lex_state = 47, .external_lex_state = 36},
  [1628] = {.lex_state = 47, .external_lex_state = 36},
  [1629] = {.lex_state = 47, .external_lex_state = 36},
  [1630] = {.lex_state = 47, .external_lex_state = 36},
  [1631] = {.lex_state = 47, .external_lex_state = 36},
  [1632] = {.lex_state = 47, .external_lex_state = 36},
  [1633] = {.lex_state = 47, .external_lex_state = 36},
  [1634] = {.lex_state = 47, .external_lex_state = 36},
  [1635] = {.lex_state = 47, .external_lex_state = 36},
  [1636] = {.lex_state = 47, .external_lex_state = 36},
  [1637] = {.lex_state = 47, .external_lex_state = 36},
  [1638] = {.lex_state = 47, .external_lex_state = 36},
  [1639] = {.lex_state = 47, .external_lex_state = 36},
  [1640] = {.lex_state = 47, .external_lex_state = 36},
  [1641] = {.lex_state = 47, .external_lex_state = 36},
  [1642] = {.lex_state = 47, .external_lex_state = 36},
  [1643] = {.lex_state = 47, .external_lex_state = 36},
  [1644] = {.lex_state = 47, .external_lex_state = 36},
  [1645] = {.lex_state = 47, .external_lex_state = 36},
  [1646] = {.lex_state = 47, .external_lex_state = 36},
  [1647] = {.lex_state = 47, .external_lex_state = 36},
  [1648] = {.lex_state = 47, .external_lex_state = 36},
  [1649] = {.lex_state = 47, .external_lex_state = 36},
  [1650] = {.lex_state = 47, .external_lex_state = 36},
  [1651] = {.lex_state = 47, .external_lex_state = 36},
  [1652] = {.lex_state = 47, .external_lex_state = 36},
  [1653] = {.lex_state = 47, .external_lex_state = 36},
  [1654] = {.lex_state = 47, .external_lex_state = 36},
  [1655] = {.lex_state = 47, .external_lex_state = 36},
  [1656] = {.lex_state = 47, .external_lex_state = 36},
  [1657] = {.lex_state = 47, .external_lex_state = 36},
  [1658] = {.lex_state = 47, .external_lex_state = 36},
  [1659] = {.lex_state = 47, .external_lex_state = 36},
  [1660] = {.lex_state = 47, .external_lex_state = 36},
  [1661] = {.lex_state = 47, .external_lex_state = 36},
  [1662] = {.lex_state = 47, .external_lex_state = 36},
  [1663] = {.lex_state = 47, .external_lex_state = 36},
  [1664] = {.lex_state = 47, .external_lex_state = 36},
  [1665] = {.lex_state = 47, .external_lex_state = 36},
  [1666] = {.lex_state = 47, .external_lex_state = 36},
  [1667] = {.lex_state = 47, .external_lex_state = 36},
  [1668] = {.lex_state = 47, .external_lex_state = 36},
  [1669] = {.lex_state = 47, .external_lex_state = 36},
  [1670] = {.lex_state = 47, .external_lex_state = 36},
  [1671] = {.lex_state = 47, .external_lex_state = 36},
  [1672] = {.lex_state = 47, .external_lex_state = 36},
  [1673] = {.lex_state = 47, .external_lex_state = 36},
  [1674] = {.lex_state = 47, .external_lex_state = 36},
  [1675] = {.lex_state = 47, .external_lex_state = 36},
  [1676] = {.lex_state = 47, .external_lex_state = 36},
  [1677] = {.lex_state = 47, .external_lex_state = 36},
  [1678] = {.lex_state = 47, .external_lex_state = 36},
  [1679] = {.lex_state = 47, .external_lex_state = 36},
  [1680] = {.lex_state = 47, .external_lex_state = 36},
  [1681] = {.lex_state = 47, .external_lex_state = 36},
  [1682] = {.lex_state = 47, .external_lex_state = 36},
  [1683] = {.lex_state = 47, .external_lex_state = 36},
  [1684] = {.lex_state = 47, .external_lex_state = 36},
  [1685] = {.lex_state = 47, .external_lex_state = 36},
  [1686] = {.lex_state = 47, .external_lex_state = 36},
  [1687] = {.lex_state = 47, .external_lex_state = 36},
  [1688] = {.lex_state = 47, .external_lex_state = 36},
  [1689] = {.lex_state = 47, .external_lex_state = 36},
  [1690] = {.lex_state = 47, .external_lex_state = 36},
  [1691] = {.lex_state = 47, .external_lex_state = 36},
  [1692] = {.lex_state = 47, .external_lex_state = 36},
  [1693] = {.lex_state = 47, .external_lex_state = 36},
  [1694] = {.lex_state = 47, .external_lex_state = 36},
  [1695] = {.lex_state = 47, .external_lex_state = 36},
  [1696] = {.lex_state = 47, .external_lex_state = 36},
  [1697] = {.lex_state = 47, .external_lex_state = 36},
  [1698] = {.lex_state = 47, .external_lex_state = 36},
  [1699] = {.lex_state = 47, .external_lex_state = 36},
  [1700] = {.lex_state = 47, .external_lex_state = 36},
  [1701] = {.lex_state = 47, .external_lex_state = 36},
  [1702] = {.lex_state = 47, .external_lex_state = 36},
  [1703] = {.lex_state = 47, .external_lex_state = 36},
  [1704] = {.lex_state = 47, .external_lex_state = 36},
  [1705] = {.lex_state = 47, .external_lex_state = 36},
  [1706] = {.lex_state = 47, .external_lex_state = 36},
  [1707] = {.lex_state = 47, .external_lex_state = 36},
  [1708] = {.lex_state = 47, .external_lex_state = 3},
  [1709] = {.lex_state = 47, .external_lex_state = 36},
  [1710] = {.lex_state = 47, .external_lex_state = 36},
  [1711] = {.lex_state = 47, .external_lex_state = 36},
  [1712] = {.lex_state = 47, .external_lex_state = 36},
  [1713] = {.lex_state = 47, .external_lex_state = 36},
  [1714] = {.lex_state = 47, .external_lex_state = 36},
  [1715] = {.lex_state = 47, .external_lex_state = 36},
  [1716] = {.lex_state = 47, .external_lex_state = 36},
  [1717] = {.lex_state = 47, .external_lex_state = 36},
  [1718] = {.lex_state = 47, .external_lex_state = 36},
  [1719] = {.lex_state = 47, .external_lex_state = 36},
  [1720] = {.lex_state = 47, .external_lex_state = 36},
  [1721] = {.lex_state = 47, .external_lex_state = 36},
  [1722] = {.lex_state = 47, .external_lex_state = 36},
  [1723] = {.lex_state = 47, .external_lex_state = 36},
  [1724] = {.lex_state = 47, .external_lex_state = 36},
  [1725] = {.lex_state = 47, .external_lex_state = 36},
  [1726] = {.lex_state = 47, .external_lex_state = 36},
  [1727] = {.lex_state = 47, .external_lex_state = 36},
  [1728] = {.lex_state = 47, .external_lex_state = 36},
  [1729] = {.lex_state = 47, .external_lex_state = 36},
  [1730] = {.lex_state = 47, .external_lex_state = 3},
  [1731] = {.lex_state = 47, .external_lex_state = 36},
  [1732] = {.lex_state = 47, .external_lex_state = 36},
  [1733] = {.lex_state = 47, .external_lex_state = 36},
  [1734] = {.lex_state = 47, .external_lex_state = 36},
  [1735] = {.lex_state = 47, .external_lex_state = 36},
  [1736] = {.lex_state = 47, .external_lex_state = 3},
  [1737] = {.lex_state = 47, .external_lex_state = 36},
  [1738] = {.lex_state = 47, .external_lex_state = 36},
  [1739] = {.lex_state = 47, .external_lex_state = 36},
  [1740] = {.lex_state = 47, .external_lex_state = 36},
  [1741] = {.lex_state = 47, .external_lex_state = 36},
  [1742] = {.lex_state = 47, .external_lex_state = 3},
  [1743] = {.lex_state = 47, .external_lex_state = 36},
  [1744] = {.lex_state = 47, .external_lex_state = 36},
  [1745] = {.lex_state = 47, .external_lex_state = 36},
  [1746] = {.lex_state = 47, .external_lex_state = 36},
  [1747] = {.lex_state = 47, .external_lex_state = 36},
  [1748] = {.lex_state = 47, .external_lex_state = 36},
  [1749] = {.lex_state = 47, .external_lex_state = 36},
  [1750] = {.lex_state = 47, .external_lex_state = 36},
  [1751] = {.lex_state = 47, .external_lex_state = 36},
  [1752] = {.lex_state = 47, .external_lex_state = 36},
  [1753] = {.lex_state = 47, .external_lex_state = 36},
  [1754] = {.lex_state = 47, .external_lex_state = 36},
  [1755] = {.lex_state = 47, .external_lex_state = 36},
  [1756] = {.lex_state = 47, .external_lex_state = 36},
  [1757] = {.lex_state = 47, .external_lex_state = 36},
  [1758] = {.lex_state = 47, .external_lex_state = 36},
  [1759] = {.lex_state = 47, .external_lex_state = 36},
  [1760] = {.lex_state = 47, .external_lex_state = 36},
  [1761] = {.lex_state = 47, .external_lex_state = 36},
  [1762] = {.lex_state = 47, .external_lex_state = 36},
  [1763] = {.lex_state = 47, .external_lex_state = 36},
  [1764] = {.lex_state = 47, .external_lex_state = 36},
  [1765] = {.lex_state = 47, .external_lex_state = 36},
  [1766] = {.lex_state = 47, .external_lex_state = 36},
  [1767] = {.lex_state = 47, .external_lex_state = 36},
  [1768] = {.lex_state = 47, .external_lex_state = 36},
  [1769] = {.lex_state = 47, .external_lex_state = 36},
  [1770] = {.lex_state = 47, .external_lex_state = 36},
  [1771] = {.lex_state = 47, .external_lex_state = 36},
  [1772] = {.lex_state = 47, .external_lex_state = 36},
  [1773] = {.lex_state = 47, .external_lex_state = 3},
  [1774] = {.lex_state = 47, .external_lex_state = 36},
  [1775] = {.lex_state = 47, .external_lex_state = 36},
  [1776] = {.lex_state = 47, .external_lex_state = 36},
  [1777] = {.lex_state = 47, .external_lex_state = 36},
  [1778] = {.lex_state = 47, .external_lex_state = 36},
  [1779] = {.lex_state = 47, .external_lex_state = 36},
  [1780] = {.lex_state = 47, .external_lex_state = 3},
  [1781] = {.lex_state = 47, .external_lex_state = 3},
  [1782] = {.lex_state = 47, .external_lex_state = 36},
  [1783] = {.lex_state = 47, .external_lex_state = 36},
  [1784] = {.lex_state = 47, .external_lex_state = 36},
  [1785] = {.lex_state = 47, .external_lex_state = 36},
  [1786] = {.lex_state = 47, .external_lex_state = 36},
  [1787] = {.lex_state = 47, .external_lex_state = 36},
  [1788] = {.lex_state = 47, .external_lex_state = 36},
  [1789] = {.lex_state = 47, .external_lex_state = 36},
  [1790] = {.lex_state = 47, .external_lex_state = 3},
  [1791] = {.lex_state = 47, .external_lex_state = 36},
  [1792] = {.lex_state = 47, .external_lex_state = 36},
  [1793] = {.lex_state = 47, .external_lex_state = 36},
  [1794] = {.lex_state = 47, .external_lex_state = 36},
  [1795] = {.lex_state = 47, .external_lex_state = 36},
  [1796] = {.lex_state = 47, .external_lex_state = 36},
  [1797] = {.lex_state = 47, .external_lex_state = 36},
  [1798] = {.lex_state = 47, .external_lex_state = 36},
  [1799] = {.lex_state = 47, .external_lex_state = 36},
  [1800] = {.lex_state = 47, .external_lex_state = 3},
  [1801] = {.lex_state = 47, .external_lex_state = 3},
  [1802] = {.lex_state = 47, .external_lex_state = 3},
  [1803] = {.lex_state = 47, .external_lex_state = 36},
  [1804] = {.lex_state = 47, .external_lex_state = 3},
  [1805] = {.lex_state = 47, .external_lex_state = 3},
  [1806] = {.lex_state = 48, .external_lex_state = 13},
  [1807] = {.lex_state = 48, .external_lex_state = 13},
  [1808] = {.lex_state = 47, .external_lex_state = 36},
  [1809] = {.lex_state = 48, .external_lex_state = 13},
  [1810] = {.lex_state = 47, .external_lex_state = 36},
  [1811] = {.lex_state = 48, .external_lex_state = 13},
  [1812] = {.lex_state = 48, .external_lex_state = 13},
  [1813] = {.lex_state = 48, .external_lex_state = 13},
  [1814] = {.lex_state = 47, .external_lex_state = 36},
  [1815] = {.lex_state = 47, .external_lex_state = 36},
  [1816] = {.lex_state = 48, .external_lex_state = 13},
  [1817] = {.lex_state = 48, .external_lex_state = 13},
  [1818] = {.lex_state = 48, .external_lex_state = 13},
  [1819] = {.lex_state = 48, .external_lex_state = 13},
  [1820] = {.lex_state = 48, .external_lex_state = 13},
  [1821] = {.lex_state = 47, .external_lex_state = 36},
  [1822] = {.lex_state = 48, .external_lex_state = 13},
  [1823] = {.lex_state = 47, .external_lex_state = 36},
  [1824] = {.lex_state = 48, .external_lex_state = 13},
  [1825] = {.lex_state = 48, .external_lex_state = 13},
  [1826] = {.lex_state = 48, .external_lex_state = 13},
  [1827] = {.lex_state = 48, .external_lex_state = 13},
  [1828] = {.lex_state = 47, .external_lex_state = 36},
  [1829] = {.lex_state = 47, .external_lex_state = 36},
  [1830] = {.lex_state = 48, .external_lex_state = 13},
  [1831] = {.lex_state = 48, .external_lex_state = 13},
  [1832] = {.lex_state = 48, .external_lex_state = 13},
  [1833] = {.lex_state = 48, .external_lex_state = 13},
  [1834] = {.lex_state = 47, .external_lex_state = 36},
  [1835] = {.lex_state = 48, .external_lex_state = 13},
  [1836] = {.lex_state = 48, .external_lex_state = 13},
  [1837] = {.lex_state = 48, .external_lex_state = 13},
  [1838] = {.lex_state = 48, .external_lex_state = 13},
  [1839] = {.lex_state = 48, .external_lex_state = 13},
  [1840] = {.lex_state = 47, .external_lex_state = 36},
  [1841] = {.lex_state = 48, .external_lex_state = 13},
  [1842] = {.lex_state = 48, .external_lex_state = 13},
  [1843] = {.lex_state = 48, .external_lex_state = 13},
  [1844] = {.lex_state = 48, .external_lex_state = 13},
  [1845] = {.lex_state = 48, .external_lex_state = 13},
  [1846] = {.lex_state = 47, .external_lex_state = 36},
  [1847] = {.lex_state = 48, .external_lex_state = 13},
  [1848] = {.lex_state = 48, .external_lex_state = 13},
  [1849] = {.lex_state = 48, .external_lex_state = 13},
  [1850] = {.lex_state = 47, .external_lex_state = 36},
  [1851] = {.lex_state = 48, .external_lex_state = 13},
  [1852] = {.lex_state = 48, .external_lex_state = 13},
  [1853] = {.lex_state = 48, .external_lex_state = 13},
  [1854] = {.lex_state = 47, .external_lex_state = 36},
  [1855] = {.lex_state = 48, .external_lex_state = 13},
  [1856] = {.lex_state = 48, .external_lex_state = 13},
  [1857] = {.lex_state = 48, .external_lex_state = 13},
  [1858] = {.lex_state = 47, .external_lex_state = 36},
  [1859] = {.lex_state = 48, .external_lex_state = 13},
  [1860] = {.lex_state = 47, .external_lex_state = 36},
  [1861] = {.lex_state = 48, .external_lex_state = 13},
  [1862] = {.lex_state = 48, .external_lex_state = 13},
  [1863] = {.lex_state = 48, .external_lex_state = 13},
  [1864] = {.lex_state = 48, .external_lex_state = 13},
  [1865] = {.lex_state = 48, .external_lex_state = 13},
  [1866] = {.lex_state = 48, .external_lex_state = 13},
  [1867] = {.lex_state = 47, .external_lex_state = 36},
  [1868] = {.lex_state = 47, .external_lex_state = 36},
  [1869] = {.lex_state = 48, .external_lex_state = 13},
  [1870] = {.lex_state = 48, .external_lex_state = 13},
  [1871] = {.lex_state = 47, .external_lex_state = 36},
  [1872] = {.lex_state = 48, .external_lex_state = 13},
  [1873] = {.lex_state = 48, .external_lex_state = 13},
  [1874] = {.lex_state = 48, .external_lex_state = 13},
  [1875] = {.lex_state = 48, .external_lex_state = 13},
  [1876] = {.lex_state = 47, .external_lex_state = 36},
  [1877] = {.lex_state = 48, .external_lex_state = 13},
  [1878] = {.lex_state = 48, .external_lex_state = 13},
  [1879] = {.lex_state = 48, .external_lex_state = 13},
  [1880] = {.lex_state = 48, .external_lex_state = 13},
  [1881] = {.lex_state = 48, .external_lex_state = 13},
  [1882] = {.lex_state = 48, .external_lex_state = 13},
  [1883] = {.lex_state = 48, .external_lex_state = 13},
  [1884] = {.lex_state = 48, .external_lex_state = 13},
  [1885] = {.lex_state = 47, .external_lex_state = 36},
  [1886] = {.lex_state = 47, .external_lex_state = 36},
  [1887] = {.lex_state = 48, .external_lex_state = 13},
  [1888] = {.lex_state = 47, .external_lex_state = 36},
  [1889] = {.lex_state = 48, .external_lex_state = 13},
  [1890] = {.lex_state = 48, .external_lex_state = 13},
  [1891] = {.lex_state = 48, .external_lex_state = 13},
  [1892] = {.lex_state = 48, .external_lex_state = 13},
  [1893] = {.lex_state = 48, .external_lex_state = 13},
  [1894] = {.lex_state = 47, .external_lex_state = 36},
  [1895] = {.lex_state = 48, .external_lex_state = 13},
  [1896] = {.lex_state = 47, .external_lex_state = 36},
  [1897] = {.lex_state = 48, .external_lex_state = 13},
  [1898] = {.lex_state = 48, .external_lex_state = 13},
  [1899] = {.lex_state = 47, .external_lex_state = 36},
  [1900] = {.lex_state = 48, .external_lex_state = 13},
  [1901] = {.lex_state = 47, .external_lex_state = 36},
  [1902] = {.lex_state = 48, .external_lex_state = 13},
  [1903] = {.lex_state = 48, .external_lex_state = 13},
  [1904] = {.lex_state = 48, .external_lex_state = 13},
  [1905] = {.lex_state = 48, .external_lex_state = 13},
  [1906] = {.lex_state = 47, .external_lex_state = 36},
  [1907] = {.lex_state = 47, .external_lex_state = 36},
  [1908] = {.lex_state = 48, .external_lex_state = 13},
  [1909] = {.lex_state = 48, .external_lex_state = 13},
  [1910] = {.lex_state = 47, .external_lex_state = 36},
  [1911] = {.lex_state = 48, .external_lex_state = 13},
  [1912] = {.lex_state = 47, .external_lex_state = 36},
  [1913] = {.lex_state = 48, .external_lex_state = 13},
  [1914] = {.lex_state = 48, .external_lex_state = 13},
  [1915] = {.lex_state = 48, .external_lex_state = 13},
  [1916] = {.lex_state = 48, .external_lex_state = 13},
  [1917] = {.lex_state = 48, .external_lex_state = 13},
  [1918] = {.lex_state = 48, .external_lex_state = 13},
  [1919] = {.lex_state = 48, .external_lex_state = 13},
  [1920] = {.lex_state = 48, .external_lex_state = 13},
  [1921] = {.lex_state = 47, .external_lex_state = 36},
  [1922] = {.lex_state = 48, .external_lex_state = 13},
  [1923] = {.lex_state = 47, .external_lex_state = 36},
  [1924] = {.lex_state = 48, .external_lex_state = 13},
  [1925] = {.lex_state = 48, .external_lex_state = 13},
  [1926] = {.lex_state = 48, .external_lex_state = 13},
  [1927] = {.lex_state = 48, .external_lex_state = 13},
  [1928] = {.lex_state = 48, .external_lex_state = 13},
  [1929] = {.lex_state = 48, .external_lex_state = 13},
  [1930] = {.lex_state = 47, .external_lex_state = 36},
  [1931] = {.lex_state = 47, .external_lex_state = 36},
  [1932] = {.lex_state = 48, .external_lex_state = 13},
  [1933] = {.lex_state = 48, .external_lex_state = 13},
  [1934] = {.lex_state = 48, .external_lex_state = 13},
  [1935] = {.lex_state = 48, .external_lex_state = 13},
  [1936] = {.lex_state = 47, .external_lex_state = 36},
  [1937] = {.lex_state = 48, .external_lex_state = 13},
  [1938] = {.lex_state = 48, .external_lex_state = 13},
  [1939] = {.lex_state = 48, .external_lex_state = 13},
  [1940] = {.lex_state = 48, .external_lex_state = 13},
  [1941] = {.lex_state = 48, .external_lex_state = 13},
  [1942] = {.lex_state = 48, .external_lex_state = 13},
  [1943] = {.lex_state = 47, .external_lex_state = 36},
  [1944] = {.lex_state = 48, .external_lex_state = 13},
  [1945] = {.lex_state = 48, .external_lex_state = 13},
  [1946] = {.lex_state = 47, .external_lex_state = 36},
  [1947] = {.lex_state = 47, .external_lex_state = 36},
  [1948] = {.lex_state = 48, .external_lex_state = 13},
  [1949] = {.lex_state = 47, .external_lex_state = 36},
  [1950] = {.lex_state = 48, .external_lex_state = 13},
  [1951] = {.lex_state = 48, .external_lex_state = 13},
  [1952] = {.lex_state = 48, .external_lex_state = 13},
  [1953] = {.lex_state = 48, .external_lex_state = 13},
  [1954] = {.lex_state = 47, .external_lex_state = 36},
  [1955] = {.lex_state = 48, .external_lex_state = 13},
  [1956] = {.lex_state = 47, .external_lex_state = 36},
  [1957] = {.lex_state = 48, .external_lex_state = 13},
  [1958] = {.lex_state = 48, .external_lex_state = 13},
  [1959] = {.lex_state = 47, .external_lex_state = 36},
  [1960] = {.lex_state = 47, .external_lex_state = 36},
  [1961] = {.lex_state = 48, .external_lex_state = 13},
  [1962] = {.lex_state = 48, .external_lex_state = 13},
  [1963] = {.lex_state = 48, .external_lex_state = 13},
  [1964] = {.lex_state = 47, .external_lex_state = 36},
  [1965] = {.lex_state = 48, .external_lex_state = 13},
  [1966] = {.lex_state = 48, .external_lex_state = 13},
  [1967] = {.lex_state = 47, .external_lex_state = 36},
  [1968] = {.lex_state = 47, .external_lex_state = 36},
  [1969] = {.lex_state = 48, .external_lex_state = 13},
  [1970] = {.lex_state = 48, .external_lex_state = 13},
  [1971] = {.lex_state = 48, .external_lex_state = 13},
  [1972] = {.lex_state = 48, .external_lex_state = 13},
  [1973] = {.lex_state = 48, .external_lex_state = 13},
  [1974] = {.lex_state = 48, .external_lex_state = 13},
  [1975] = {.lex_state = 47, .external_lex_state = 3},
  [1976] = {.lex_state = 47, .external_lex_state = 3},
  [1977] = {.lex_state = 47, .external_lex_state = 36},
  [1978] = {.lex_state = 47, .external_lex_state = 36},
  [1979] = {.lex_state = 47, .external_lex_state = 36},
  [1980] = {.lex_state = 47, .external_lex_state = 36},
  [1981] = {.lex_state = 47, .external_lex_state = 36},
  [1982] = {.lex_state = 47, .external_lex_state = 36},
  [1983] = {.lex_state = 47, .external_lex_state = 36},
  [1984] = {.lex_state = 47, .external_lex_state = 36},
  [1985] = {.lex_state = 47, .external_lex_state = 36},
  [1986] = {.lex_state = 47, .external_lex_state = 36},
  [1987] = {.lex_state = 47, .external_lex_state = 36},
  [1988] = {.lex_state = 47, .external_lex_state = 36},
  [1989] = {.lex_state = 47, .external_lex_state = 36},
  [1990] = {.lex_state = 47, .external_lex_state = 36},
  [1991] = {.lex_state = 47, .external_lex_state = 36},
  [1992] = {.lex_state = 47, .external_lex_state = 3},
  [1993] = {.lex_state = 47, .external_lex_state = 36},
  [1994] = {.lex_state = 47, .external_lex_state = 36},
  [1995] = {.lex_state = 47, .external_lex_state = 36},
  [1996] = {.lex_state = 47, .external_lex_state = 36},
  [1997] = {.lex_state = 47, .external_lex_state = 36},
  [1998] = {.lex_state = 47, .external_lex_state = 36},
  [1999] = {.lex_state = 47, .external_lex_state = 36},
  [2000] = {.lex_state = 47, .external_lex_state = 36},
  [2001] = {.lex_state = 47, .external_lex_state = 4},
  [2002] = {.lex_state = 47, .external_lex_state = 3},
  [2003] = {.lex_state = 47, .external_lex_state = 4},
  [2004] = {.lex_state = 47, .external_lex_state = 3},
  [2005] = {.lex_state = 47, .external_lex_state = 3},
  [2006] = {.lex_state = 47, .external_lex_state = 3},
  [2007] = {.lex_state = 47, .external_lex_state = 4},
  [2008] = {.lex_state = 47, .external_lex_state = 4},
  [2009] = {.lex_state = 47, .external_lex_state = 4},
  [2010] = {.lex_state = 47, .external_lex_state = 3},
  [2011] = {.lex_state = 47, .external_lex_state = 4},
  [2012] = {.lex_state = 47, .external_lex_state = 4},
  [2013] = {.lex_state = 47, .external_lex_state = 3},
  [2014] = {.lex_state = 47, .external_lex_state = 4},
  [2015] = {.lex_state = 47, .external_lex_state = 4},
  [2016] = {.lex_state = 47, .external_lex_state = 3},
  [2017] = {.lex_state = 47, .external_lex_state = 3},
  [2018] = {.lex_state = 47, .external_lex_state = 38},
  [2019] = {.lex_state = 47, .external_lex_state = 3},
  [2020] = {.lex_state = 47, .external_lex_state = 3},
  [2021] = {.lex_state = 47, .external_lex_state = 38},
  [2022] = {.lex_state = 47, .external_lex_state = 3},
  [2023] = {.lex_state = 47, .external_lex_state = 3},
  [2024] = {.lex_state = 47, .external_lex_state = 3},
  [2025] = {.lex_state = 47, .external_lex_state = 3},
  [2026] = {.lex_state = 47, .external_lex_state = 3},
  [2027] = {.lex_state = 47, .external_lex_state = 38},
  [2028] = {.lex_state = 47, .external_lex_state = 3},
  [2029] = {.lex_state = 47, .external_lex_state = 38},
  [2030] = {.lex_state = 47, .external_lex_state = 38},
  [2031] = {.lex_state = 47, .external_lex_state = 38},
  [2032] = {.lex_state = 47, .external_lex_state = 38},
  [2033] = {.lex_state = 47, .external_lex_state = 38},
  [2034] = {.lex_state = 47, .external_lex_state = 38},
  [2035] = {.lex_state = 47, .external_lex_state = 3},
  [2036] = {.lex_state = 47, .external_lex_state = 3},
  [2037] = {.lex_state = 48, .external_lex_state = 39},
  [2038] = {.lex_state = 47, .external_lex_state = 4},
  [2039] = {.lex_state = 47, .external_lex_state = 3},
  [2040] = {.lex_state = 47, .external_lex_state = 4},
  [2041] = {.lex_state = 47, .external_lex_state = 3},
  [2042] = {.lex_state = 48, .external_lex_state = 39},
  [2043] = {.lex_state = 47, .external_lex_state = 4},
  [2044] = {.lex_state = 47, .external_lex_state = 3},
  [2045] = {.lex_state = 47, .external_lex_state = 4},
  [2046] = {.lex_state = 47, .external_lex_state = 3},
  [2047] = {.lex_state = 47, .external_lex_state = 40},
  [2048] = {.lex_state = 47, .external_lex_state = 4},
  [2049] = {.lex_state = 47, .external_lex_state = 3},
  [2050] = {.lex_state = 47, .external_lex_state = 4},
  [2051] = {.lex_state = 47, .external_lex_state = 4},
  [2052] = {.lex_state = 47, .external_lex_state = 3},
  [2053] = {.lex_state = 47, .external_lex_state = 3},
  [2054] = {.lex_state = 47, .external_lex_state = 3},
  [2055] = {.lex_state = 47, .external_lex_state = 4},
  [2056] = {.lex_state = 47, .external_lex_state = 4},
  [2057] = {.lex_state = 47, .external_lex_state = 3},
  [2058] = {.lex_state = 47, .external_lex_state = 40},
  [2059] = {.lex_state = 48, .external_lex_state = 39},
  [2060] = {.lex_state = 47, .external_lex_state = 3},
  [2061] = {.lex_state = 47, .external_lex_state = 4},
  [2062] = {.lex_state = 47, .external_lex_state = 4},
  [2063] = {.lex_state = 47, .external_lex_state = 3},
  [2064] = {.lex_state = 47, .external_lex_state = 3},
  [2065] = {.lex_state = 48, .external_lex_state = 39},
  [2066] = {.lex_state = 47, .external_lex_state = 4},
  [2067] = {.lex_state = 47, .external_lex_state = 3},
  [2068] = {.lex_state = 47, .external_lex_state = 4},
  [2069] = {.lex_state = 47, .external_lex_state = 4},
  [2070] = {.lex_state = 47, .external_lex_state = 3},
  [2071] = {.lex_state = 47, .external_lex_state = 4},
  [2072] = {.lex_state = 47, .external_lex_state = 3},
  [2073] = {.lex_state = 47, .external_lex_state = 3},
  [2074] = {.lex_state = 47, .external_lex_state = 40},
  [2075] = {.lex_state = 47, .external_lex_state = 3},
  [2076] = {.lex_state = 47, .external_lex_state = 3},
  [2077] = {.lex_state = 47, .external_lex_state = 3},
  [2078] = {.lex_state = 47, .external_lex_state = 3},
  [2079] = {.lex_state = 47, .external_lex_state = 3},
  [2080] = {.lex_state = 48, .external_lex_state = 41},
  [2081] = {.lex_state = 48, .external_lex_state = 41},
  [2082] = {.lex_state = 48, .external_lex_state = 41},
  [2083] = {.lex_state = 48, .external_lex_state = 41},
  [2084] = {.lex_state = 47, .external_lex_state = 3},
  [2085] = {.lex_state = 48, .external_lex_state = 3},
  [2086] = {.lex_state = 47, .external_lex_state = 3},
  [2087] = {.lex_state = 48, .external_lex_state = 3},
  [2088] = {.lex_state = 48, .external_lex_state = 42},
  [2089] = {.lex_state = 48, .external_lex_state = 42},
  [2090] = {.lex_state = 48, .external_lex_state = 3},
  [2091] = {.lex_state = 48, .external_lex_state = 3},
  [2092] = {.lex_state = 47, .external_lex_state = 3},
  [2093] = {.lex_state = 48, .external_lex_state = 3},
  [2094] = {.lex_state = 48, .external_lex_state = 42},
  [2095] = {.lex_state = 48, .external_lex_state = 42},
  [2096] = {.lex_state = 48, .external_lex_state = 43},
  [2097] = {.lex_state = 48, .external_lex_state = 43},
  [2098] = {.lex_state = 48, .external_lex_state = 43},
  [2099] = {.lex_state = 47, .external_lex_state = 4},
  [2100] = {.lex_state = 48, .external_lex_state = 43},
  [2101] = {.lex_state = 48, .external_lex_state = 43},
  [2102] = {.lex_state = 47, .external_lex_state = 3},
  [2103] = {.lex_state = 48, .external_lex_state = 43},
  [2104] = {.lex_state = 48, .external_lex_state = 43},
  [2105] = {.lex_state = 47, .external_lex_state = 4},
  [2106] = {.lex_state = 48, .external_lex_state = 43},
  [2107] = {.lex_state = 47, .external_lex_state = 4},
  [2108] = {.lex_state = 48, .external_lex_state = 43},
  [2109] = {.lex_state = 48, .external_lex_state = 43},
  [2110] = {.lex_state = 48, .external_lex_state = 43},
  [2111] = {.lex_state = 48, .external_lex_state = 43},
  [2112] = {.lex_state = 47, .external_lex_state = 4},
  [2113] = {.lex_state = 48, .external_lex_state = 43},
  [2114] = {.lex_state = 48, .external_lex_state = 43},
  [2115] = {.lex_state = 47, .external_lex_state = 3},
  [2116] = {.lex_state = 48, .external_lex_state = 3},
  [2117] = {.lex_state = 48, .external_lex_state = 43},
  [2118] = {.lex_state = 48, .external_lex_state = 43},
  [2119] = {.lex_state = 48, .external_lex_state = 43},
  [2120] = {.lex_state = 48, .external_lex_state = 43},
  [2121] = {.lex_state = 48, .external_lex_state = 43},
  [2122] = {.lex_state = 48, .external_lex_state = 43},
  [2123] = {.lex_state = 47, .external_lex_state = 3},
  [2124] = {.lex_state = 48, .external_lex_state = 43},
  [2125] = {.lex_state = 48, .external_lex_state = 43},
  [2126] = {.lex_state = 47, .external_lex_state = 4},
  [2127] = {.lex_state = 48, .external_lex_state = 43},
  [2128] = {.lex_state = 48, .external_lex_state = 43},
  [2129] = {.lex_state = 48, .external_lex_state = 43},
  [2130] = {.lex_state = 48, .external_lex_state = 43},
  [2131] = {.lex_state = 48, .external_lex_state = 43},
  [2132] = {.lex_state = 48, .external_lex_state = 43},
  [2133] = {.lex_state = 48, .external_lex_state = 43},
  [2134] = {.lex_state = 47, .external_lex_state = 3},
  [2135] = {.lex_state = 48, .external_lex_state = 43},
  [2136] = {.lex_state = 48, .external_lex_state = 43},
  [2137] = {.lex_state = 48, .external_lex_state = 43},
  [2138] = {.lex_state = 48, .external_lex_state = 43},
  [2139] = {.lex_state = 48, .external_lex_state = 43},
  [2140] = {.lex_state = 48, .external_lex_state = 43},
  [2141] = {.lex_state = 48, .external_lex_state = 43},
  [2142] = {.lex_state = 48, .external_lex_state = 43},
  [2143] = {.lex_state = 48, .external_lex_state = 43},
  [2144] = {.lex_state = 47, .external_lex_state = 4},
  [2145] = {.lex_state = 48, .external_lex_state = 43},
  [2146] = {.lex_state = 48, .external_lex_state = 43},
  [2147] = {.lex_state = 48, .external_lex_state = 43},
  [2148] = {.lex_state = 48, .external_lex_state = 43},
  [2149] = {.lex_state = 47, .external_lex_state = 4},
  [2150] = {.lex_state = 48, .external_lex_state = 43},
  [2151] = {.lex_state = 48, .external_lex_state = 43},
  [2152] = {.lex_state = 47, .external_lex_state = 3},
  [2153] = {.lex_state = 48, .external_lex_state = 43},
  [2154] = {.lex_state = 48, .external_lex_state = 43},
  [2155] = {.lex_state = 48, .external_lex_state = 43},
  [2156] = {.lex_state = 48, .external_lex_state = 43},
  [2157] = {.lex_state = 48, .external_lex_state = 43},
  [2158] = {.lex_state = 48, .external_lex_state = 43},
  [2159] = {.lex_state = 48, .external_lex_state = 43},
  [2160] = {.lex_state = 48, .external_lex_state = 43},
  [2161] = {.lex_state = 48, .external_lex_state = 43},
  [2162] = {.lex_state = 48, .external_lex_state = 43},
  [2163] = {.lex_state = 48, .external_lex_state = 43},
  [2164] = {.lex_state = 48, .external_lex_state = 43},
  [2165] = {.lex_state = 48, .external_lex_state = 43},
  [2166] = {.lex_state = 48, .external_lex_state = 43},
  [2167] = {.lex_state = 48, .external_lex_state = 43},
  [2168] = {.lex_state = 48, .external_lex_state = 43},
  [2169] = {.lex_state = 48, .external_lex_state = 43},
  [2170] = {.lex_state = 48, .external_lex_state = 43},
  [2171] = {.lex_state = 48, .external_lex_state = 43},
  [2172] = {.lex_state = 48, .external_lex_state = 43},
  [2173] = {.lex_state = 48, .external_lex_state = 43},
  [2174] = {.lex_state = 48, .external_lex_state = 43},
  [2175] = {.lex_state = 48, .external_lex_state = 43},
  [2176] = {.lex_state = 48, .external_lex_state = 43},
  [2177] = {.lex_state = 48, .external_lex_state = 43},
  [2178] = {.lex_state = 48, .external_lex_state = 43},
  [2179] = {.lex_state = 48, .external_lex_state = 43},
  [2180] = {.lex_state = 48, .external_lex_state = 43},
  [2181] = {.lex_state = 48, .external_lex_state = 43},
  [2182] = {.lex_state = 48, .external_lex_state = 43},
  [2183] = {.lex_state = 48, .external_lex_state = 43},
  [2184] = {.lex_state = 48, .external_lex_state = 43},
  [2185] = {.lex_state = 48, .external_lex_state = 43},
  [2186] = {.lex_state = 48, .external_lex_state = 43},
  [2187] = {.lex_state = 48, .external_lex_state = 43},
  [2188] = {.lex_state = 48, .external_lex_state = 43},
  [2189] = {.lex_state = 48, .external_lex_state = 43},
  [2190] = {.lex_state = 48, .external_lex_state = 43},
  [2191] = {.lex_state = 48, .external_lex_state = 43},
  [2192] = {.lex_state = 48, .external_lex_state = 43},
  [2193] = {.lex_state = 48, .external_lex_state = 3},
  [2194] = {.lex_state = 48, .external_lex_state = 43},
  [2195] = {.lex_state = 48, .external_lex_state = 3},
  [2196] = {.lex_state = 48, .external_lex_state = 43},
  [2197] = {.lex_state = 48, .external_lex_state = 43},
  [2198] = {.lex_state = 48, .external_lex_state = 43},
  [2199] = {.lex_state = 48, .external_lex_state = 43},
  [2200] = {.lex_state = 48, .external_lex_state = 43},
  [2201] = {.lex_state = 48, .external_lex_state = 43},
  [2202] = {.lex_state = 48, .external_lex_state = 43},
  [2203] = {.lex_state = 48, .external_lex_state = 43},
  [2204] = {.lex_state = 48, .external_lex_state = 43},
  [2205] = {.lex_state = 48, .external_lex_state = 43},
  [2206] = {.lex_state = 48, .external_lex_state = 43},
  [2207] = {.lex_state = 48, .external_lex_state = 43},
  [2208] = {.lex_state = 48, .external_lex_state = 43},
  [2209] = {.lex_state = 48, .external_lex_state = 43},
  [2210] = {.lex_state = 48, .external_lex_state = 43},
  [2211] = {.lex_state = 48, .external_lex_state = 43},
  [2212] = {.lex_state = 48, .external_lex_state = 43},
  [2213] = {.lex_state = 48, .external_lex_state = 43},
  [2214] = {.lex_state = 48, .external_lex_state = 43},
  [2215] = {.lex_state = 48, .external_lex_state = 43},
  [2216] = {.lex_state = 48, .external_lex_state = 43},
  [2217] = {.lex_state = 47, .external_lex_state = 3},
  [2218] = {.lex_state = 48, .external_lex_state = 43},
  [2219] = {.lex_state = 48, .external_lex_state = 43},
  [2220] = {.lex_state = 47, .external_lex_state = 4},
  [2221] = {.lex_state = 48, .external_lex_state = 43},
  [2222] = {.lex_state = 48, .external_lex_state = 43},
  [2223] = {.lex_state = 48, .external_lex_state = 43},
  [2224] = {.lex_state = 47, .external_lex_state = 4},
  [2225] = {.lex_state = 48, .external_lex_state = 43},
  [2226] = {.lex_state = 48, .external_lex_state = 43},
  [2227] = {.lex_state = 48, .external_lex_state = 43},
  [2228] = {.lex_state = 48, .external_lex_state = 36},
  [2229] = {.lex_state = 48, .external_lex_state = 36},
  [2230] = {.lex_state = 48, .external_lex_state = 36},
  [2231] = {.lex_state = 48, .external_lex_state = 36},
  [2232] = {.lex_state = 48, .external_lex_state = 36},
  [2233] = {.lex_state = 48, .external_lex_state = 36},
  [2234] = {.lex_state = 48, .external_lex_state = 36},
  [2235] = {.lex_state = 48, .external_lex_state = 36},
  [2236] = {.lex_state = 48, .external_lex_state = 36},
  [2237] = {.lex_state = 48, .external_lex_state = 36},
  [2238] = {.lex_state = 48, .external_lex_state = 36},
  [2239] = {.lex_state = 48, .external_lex_state = 36},
  [2240] = {.lex_state = 48, .external_lex_state = 36},
  [2241] = {.lex_state = 48, .external_lex_state = 36},
  [2242] = {.lex_state = 48, .external_lex_state = 36},
  [2243] = {.lex_state = 48, .external_lex_state = 36},
  [2244] = {.lex_state = 48, .external_lex_state = 36},
  [2245] = {.lex_state = 48, .external_lex_state = 36},
  [2246] = {.lex_state = 48, .external_lex_state = 36},
  [2247] = {.lex_state = 48, .external_lex_state = 36},
  [2248] = {.lex_state = 48, .external_lex_state = 36},
  [2249] = {.lex_state = 48, .external_lex_state = 36},
  [2250] = {.lex_state = 47, .external_lex_state = 3},
  [2251] = {.lex_state = 48, .external_lex_state = 36},
  [2252] = {.lex_state = 47, .external_lex_state = 3},
  [2253] = {.lex_state = 48, .external_lex_state = 36},
  [2254] = {.lex_state = 48, .external_lex_state = 36},
  [2255] = {.lex_state = 48, .external_lex_state = 36},
  [2256] = {.lex_state = 48, .external_lex_state = 36},
  [2257] = {.lex_state = 48, .external_lex_state = 36},
  [2258] = {.lex_state = 48, .external_lex_state = 36},
  [2259] = {.lex_state = 48, .external_lex_state = 36},
  [2260] = {.lex_state = 48, .external_lex_state = 36},
  [2261] = {.lex_state = 48, .external_lex_state = 36},
  [2262] = {.lex_state = 48, .external_lex_state = 36},
  [2263] = {.lex_state = 48, .external_lex_state = 36},
  [2264] = {.lex_state = 48, .external_lex_state = 36},
  [2265] = {.lex_state = 48, .external_lex_state = 36},
  [2266] = {.lex_state = 48, .external_lex_state = 36},
  [2267] = {.lex_state = 48, .external_lex_state = 36},
  [2268] = {.lex_state = 48, .external_lex_state = 36},
  [2269] = {.lex_state = 48, .external_lex_state = 36},
  [2270] = {.lex_state = 48, .external_lex_state = 36},
  [2271] = {.lex_state = 48, .external_lex_state = 36},
  [2272] = {.lex_state = 48, .external_lex_state = 36},
  [2273] = {.lex_state = 48, .external_lex_state = 36},
  [2274] = {.lex_state = 48, .external_lex_state = 36},
  [2275] = {.lex_state = 48, .external_lex_state = 36},
  [2276] = {.lex_state = 48, .external_lex_state = 36},
  [2277] = {.lex_state = 48, .external_lex_state = 36},
  [2278] = {.lex_state = 48, .external_lex_state = 36},
  [2279] = {.lex_state = 48, .external_lex_state = 44},
  [2280] = {.lex_state = 48, .external_lex_state = 36},
  [2281] = {.lex_state = 48, .external_lex_state = 36},
  [2282] = {.lex_state = 48, .external_lex_state = 36},
  [2283] = {.lex_state = 48, .external_lex_state = 36},
  [2284] = {.lex_state = 48, .external_lex_state = 36},
  [2285] = {.lex_state = 48, .external_lex_state = 36},
  [2286] = {.lex_state = 48, .external_lex_state = 36},
  [2287] = {.lex_state = 48, .external_lex_state = 36},
  [2288] = {.lex_state = 48, .external_lex_state = 36},
  [2289] = {.lex_state = 48, .external_lex_state = 36},
  [2290] = {.lex_state = 48, .external_lex_state = 36},
  [2291] = {.lex_state = 48, .external_lex_state = 3},
  [2292] = {.lex_state = 48, .external_lex_state = 36},
  [2293] = {.lex_state = 48, .external_lex_state = 36},
  [2294] = {.lex_state = 48, .external_lex_state = 3},
  [2295] = {.lex_state = 48, .external_lex_state = 44},
  [2296] = {.lex_state = 48, .external_lex_state = 36},
  [2297] = {.lex_state = 48, .external_lex_state = 36},
  [2298] = {.lex_state = 48, .external_lex_state = 36},
  [2299] = {.lex_state = 48, .external_lex_state = 36},
  [2300] = {.lex_state = 48, .external_lex_state = 36},
  [2301] = {.lex_state = 48, .external_lex_state = 36},
  [2302] = {.lex_state = 48, .external_lex_state = 36},
  [2303] = {.lex_state = 48, .external_lex_state = 36},
  [2304] = {.lex_state = 48, .external_lex_state = 36},
  [2305] = {.lex_state = 48, .external_lex_state = 36},
  [2306] = {.lex_state = 48, .external_lex_state = 36},
  [2307] = {.lex_state = 48, .external_lex_state = 36},
  [2308] = {.lex_state = 48, .external_lex_state = 36},
  [2309] = {.lex_state = 48, .external_lex_state = 44},
  [2310] = {.lex_state = 48, .external_lex_state = 3},
  [2311] = {.lex_state = 48, .external_lex_state = 36},
  [2312] = {.lex_state = 48, .external_lex_state = 36},
  [2313] = {.lex_state = 48, .external_lex_state = 36},
  [2314] = {.lex_state = 48, .external_lex_state = 36},
  [2315] = {.lex_state = 48, .external_lex_state = 36},
  [2316] = {.lex_state = 48, .external_lex_state = 36},
  [2317] = {.lex_state = 48, .external_lex_state = 36},
  [2318] = {.lex_state = 48, .external_lex_state = 36},
  [2319] = {.lex_state = 48, .external_lex_state = 36},
  [2320] = {.lex_state = 48, .external_lex_state = 36},
  [2321] = {.lex_state = 48, .external_lex_state = 36},
  [2322] = {.lex_state = 48, .external_lex_state = 36},
  [2323] = {.lex_state = 48, .external_lex_state = 36},
  [2324] = {.lex_state = 48, .external_lex_state = 36},
  [2325] = {.lex_state = 48, .external_lex_state = 36},
  [2326] = {.lex_state = 48, .external_lex_state = 36},
  [2327] = {.lex_state = 48, .external_lex_state = 36},
  [2328] = {.lex_state = 48, .external_lex_state = 36},
  [2329] = {.lex_state = 48, .external_lex_state = 45},
  [2330] = {.lex_state = 48, .external_lex_state = 45},
  [2331] = {.lex_state = 48, .external_lex_state = 36},
  [2332] = {.lex_state = 48, .external_lex_state = 36},
  [2333] = {.lex_state = 48, .external_lex_state = 36},
  [2334] = {.lex_state = 48, .external_lex_state = 36},
  [2335] = {.lex_state = 48, .external_lex_state = 36},
  [2336] = {.lex_state = 48, .external_lex_state = 36},
  [2337] = {.lex_state = 48, .external_lex_state = 36},
  [2338] = {.lex_state = 48, .external_lex_state = 36},
  [2339] = {.lex_state = 48, .external_lex_state = 36},
  [2340] = {.lex_state = 48, .external_lex_state = 36},
  [2341] = {.lex_state = 48, .external_lex_state = 36},
  [2342] = {.lex_state = 48, .external_lex_state = 45},
  [2343] = {.lex_state = 48, .external_lex_state = 36},
  [2344] = {.lex_state = 48, .external_lex_state = 36},
  [2345] = {.lex_state = 48, .external_lex_state = 45},
  [2346] = {.lex_state = 48, .external_lex_state = 36},
  [2347] = {.lex_state = 48, .external_lex_state = 36},
  [2348] = {.lex_state = 48, .external_lex_state = 3},
  [2349] = {.lex_state = 48, .external_lex_state = 36},
  [2350] = {.lex_state = 48, .external_lex_state = 36},
  [2351] = {.lex_state = 48, .external_lex_state = 44},
  [2352] = {.lex_state = 48, .external_lex_state = 36},
  [2353] = {.lex_state = 48, .external_lex_state = 36},
  [2354] = {.lex_state = 48, .external_lex_state = 36},
  [2355] = {.lex_state = 48, .external_lex_state = 36},
  [2356] = {.lex_state = 48, .external_lex_state = 36},
  [2357] = {.lex_state = 48, .external_lex_state = 36},
  [2358] = {.lex_state = 48, .external_lex_state = 36},
  [2359] = {.lex_state = 48, .external_lex_state = 36},
  [2360] = {.lex_state = 48, .external_lex_state = 36},
  [2361] = {.lex_state = 48, .external_lex_state = 36},
  [2362] = {.lex_state = 48, .external_lex_state = 36},
  [2363] = {.lex_state = 48, .external_lex_state = 46},
  [2364] = {.lex_state = 48, .external_lex_state = 36},
  [2365] = {.lex_state = 48, .external_lex_state = 36},
  [2366] = {.lex_state = 48, .external_lex_state = 36},
  [2367] = {.lex_state = 48, .external_lex_state = 36},
  [2368] = {.lex_state = 48, .external_lex_state = 36},
  [2369] = {.lex_state = 48, .external_lex_state = 36},
  [2370] = {.lex_state = 48, .external_lex_state = 36},
  [2371] = {.lex_state = 48, .external_lex_state = 36},
  [2372] = {.lex_state = 48, .external_lex_state = 36},
  [2373] = {.lex_state = 48, .external_lex_state = 36},
  [2374] = {.lex_state = 48, .external_lex_state = 36},
  [2375] = {.lex_state = 48, .external_lex_state = 47},
  [2376] = {.lex_state = 48, .external_lex_state = 48},
  [2377] = {.lex_state = 48, .external_lex_state = 36},
  [2378] = {.lex_state = 48, .external_lex_state = 48},
  [2379] = {.lex_state = 48, .external_lex_state = 36},
  [2380] = {.lex_state = 48, .external_lex_state = 36},
  [2381] = {.lex_state = 48, .external_lex_state = 36},
  [2382] = {.lex_state = 48, .external_lex_state = 36},
  [2383] = {.lex_state = 48, .external_lex_state = 36},
  [2384] = {.lex_state = 48, .external_lex_state = 36},
  [2385] = {.lex_state = 48, .external_lex_state = 49},
  [2386] = {.lex_state = 48, .external_lex_state = 36},
  [2387] = {.lex_state = 48, .external_lex_state = 49},
  [2388] = {.lex_state = 48, .external_lex_state = 36},
  [2389] = {.lex_state = 48, .external_lex_state = 48},
  [2390] = {.lex_state = 48, .external_lex_state = 36},
  [2391] = {.lex_state = 48, .external_lex_state = 36},
  [2392] = {.lex_state = 48, .external_lex_state = 50},
  [2393] = {.lex_state = 48, .external_lex_state = 36},
  [2394] = {.lex_state = 48, .external_lex_state = 46},
  [2395] = {.lex_state = 48, .external_lex_state = 36},
  [2396] = {.lex_state = 48, .external_lex_state = 36},
  [2397] = {.lex_state = 48, .external_lex_state = 36},
  [2398] = {.lex_state = 48, .external_lex_state = 36},
  [2399] = {.lex_state = 48, .external_lex_state = 36},
  [2400] = {.lex_state = 48, .external_lex_state = 36},
  [2401] = {.lex_state = 48, .external_lex_state = 36},
  [2402] = {.lex_state = 48, .external_lex_state = 36},
  [2403] = {.lex_state = 48, .external_lex_state = 51},
  [2404] = {.lex_state = 48, .external_lex_state = 36},
  [2405] = {.lex_state = 48, .external_lex_state = 36},
  [2406] = {.lex_state = 48, .external_lex_state = 52},
  [2407] = {.lex_state = 48, .external_lex_state = 36},
  [2408] = {.lex_state = 48, .external_lex_state = 36},
  [2409] = {.lex_state = 48, .external_lex_state = 51},
  [2410] = {.lex_state = 48, .external_lex_state = 48},
  [2411] = {.lex_state = 48, .external_lex_state = 46},
  [2412] = {.lex_state = 48, .external_lex_state = 52},
  [2413] = {.lex_state = 48, .external_lex_state = 52},
  [2414] = {.lex_state = 48, .external_lex_state = 36},
  [2415] = {.lex_state = 48, .external_lex_state = 36},
  [2416] = {.lex_state = 48, .external_lex_state = 36},
  [2417] = {.lex_state = 48, .external_lex_state = 36},
  [2418] = {.lex_state = 48, .external_lex_state = 50},
  [2419] = {.lex_state = 48, .external_lex_state = 53},
  [2420] = {.lex_state = 48, .external_lex_state = 36},
  [2421] = {.lex_state = 48, .external_lex_state = 36},
  [2422] = {.lex_state = 48, .external_lex_state = 46},
  [2423] = {.lex_state = 48, .external_lex_state = 50},
  [2424] = {.lex_state = 48, .external_lex_state = 36},
  [2425] = {.lex_state = 48, .external_lex_state = 50},
  [2426] = {.lex_state = 48, .external_lex_state = 36},
  [2427] = {.lex_state = 48, .external_lex_state = 49},
  [2428] = {.lex_state = 48, .external_lex_state = 36},
  [2429] = {.lex_state = 48, .external_lex_state = 36},
  [2430] = {.lex_state = 48, .external_lex_state = 36},
  [2431] = {.lex_state = 48, .external_lex_state = 49},
  [2432] = {.lex_state = 48, .external_lex_state = 36},
  [2433] = {.lex_state = 48, .external_lex_state = 51},
  [2434] = {.lex_state = 48, .external_lex_state = 36},
  [2435] = {.lex_state = 48, .external_lex_state = 36},
  [2436] = {.lex_state = 48, .external_lex_state = 36},
  [2437] = {.lex_state = 48, .external_lex_state = 52},
  [2438] = {.lex_state = 48, .external_lex_state = 36},
  [2439] = {.lex_state = 48, .external_lex_state = 36},
  [2440] = {.lex_state = 48, .external_lex_state = 36},
  [2441] = {.lex_state = 48, .external_lex_state = 36},
  [2442] = {.lex_state = 48, .external_lex_state = 51},
  [2443] = {.lex_state = 48, .external_lex_state = 54},
  [2444] = {.lex_state = 48, .external_lex_state = 55},
  [2445] = {.lex_state = 48, .external_lex_state = 56},
  [2446] = {.lex_state = 48, .external_lex_state = 57},
  [2447] = {.lex_state = 48, .external_lex_state = 58},
  [2448] = {.lex_state = 48, .external_lex_state = 58},
  [2449] = {.lex_state = 48, .external_lex_state = 59},
  [2450] = {.lex_state = 48, .external_lex_state = 60},
  [2451] = {.lex_state = 48, .external_lex_state = 61},
  [2452] = {.lex_state = 48, .external_lex_state = 62},
  [2453] = {.lex_state = 48, .external_lex_state = 60},
  [2454] = {.lex_state = 48, .external_lex_state = 58},
  [2455] = {.lex_state = 48, .external_lex_state = 55},
  [2456] = {.lex_state = 48, .external_lex_state = 54},
  [2457] = {.lex_state = 48, .external_lex_state = 62},
  [2458] = {.lex_state = 48, .external_lex_state = 55},
  [2459] = {.lex_state = 48, .external_lex_state = 63},
  [2460] = {.lex_state = 48, .external_lex_state = 63},
  [2461] = {.lex_state = 48, .external_lex_state = 59},
  [2462] = {.lex_state = 48, .external_lex_state = 63},
  [2463] = {.lex_state = 48, .external_lex_state = 57},
  [2464] = {.lex_state = 48, .external_lex_state = 55},
  [2465] = {.lex_state = 48, .external_lex_state = 57},
  [2466] = {.lex_state = 48, .external_lex_state = 61},
  [2467] = {.lex_state = 48, .external_lex_state = 61},
  [2468] = {.lex_state = 48, .external_lex_state = 57},
  [2469] = {.lex_state = 48, .external_lex_state = 63},
  [2470] = {.lex_state = 48, .external_lex_state = 59},
  [2471] = {.lex_state = 48, .external_lex_state = 61},
  [2472] = {.lex_state = 48, .external_lex_state = 58},
  [2473] = {.lex_state = 48, .external_lex_state = 60},
  [2474] = {.lex_state = 48, .external_lex_state = 60},
  [2475] = {.lex_state = 48, .external_lex_state = 54},
  [2476] = {.lex_state = 48, .external_lex_state = 62},
  [2477] = {.lex_state = 48, .external_lex_state = 62},
  [2478] = {.lex_state = 48, .external_lex_state = 54},
  [2479] = {.lex_state = 48, .external_lex_state = 59},
  [2480] = {.lex_state = 48, .external_lex_state = 64},
  [2481] = {.lex_state = 48, .external_lex_state = 65},
  [2482] = {.lex_state = 48, .external_lex_state = 66},
  [2483] = {.lex_state = 48, .external_lex_state = 65},
  [2484] = {.lex_state = 48, .external_lex_state = 67},
  [2485] = {.lex_state = 48, .external_lex_state = 67},
  [2486] = {.lex_state = 48, .external_lex_state = 64},
  [2487] = {.lex_state = 48, .external_lex_state = 68},
  [2488] = {.lex_state = 48, .external_lex_state = 3},
  [2489] = {.lex_state = 48, .external_lex_state = 68},
  [2490] = {.lex_state = 48, .external_lex_state = 66},
  [2491] = {.lex_state = 48, .external_lex_state = 64},
  [2492] = {.lex_state = 48, .external_lex_state = 66},
  [2493] = {.lex_state = 48, .external_lex_state = 67},
  [2494] = {.lex_state = 48, .external_lex_state = 3},
  [2495] = {.lex_state = 48, .external_lex_state = 66},
  [2496] = {.lex_state = 48, .external_lex_state = 65},
  [2497] = {.lex_state = 48, .external_lex_state = 68},
  [2498] = {.lex_state = 48, .external_lex_state = 65},
  [2499] = {.lex_state = 48, .external_lex_state = 67},
  [2500] = {.lex_state = 48, .external_lex_state = 64},
  [2501] = {.lex_state = 48, .external_lex_state = 68},
  [2502] = {.lex_state = 48, .external_lex_state = 36},
  [2503] = {.lex_state = 48, .external_lex_state = 36},
  [2504] = {.lex_state = 48, .external_lex_state = 36},
  [2505] = {.lex_state = 48, .external_lex_state = 36},
  [2506] = {.lex_state = 48, .external_lex_state = 36},
  [2507] = {.lex_state = 48, .external_lex_state = 36},
  [2508] = {.lex_state = 48, .external_lex_state = 3},
  [2509] = {.lex_state = 48, .external_lex_state = 36},
  [2510] = {.lex_state = 48, .external_lex_state = 36},
  [2511] = {.lex_state = 48, .external_lex_state = 36},
  [2512] = {.lex_state = 48, .external_lex_state = 36},
  [2513] = {.lex_state = 48, .external_lex_state = 36},
  [2514] = {.lex_state = 48, .external_lex_state = 36},
  [2515] = {.lex_state = 48, .external_lex_state = 36},
  [2516] = {.lex_state = 48, .external_lex_state = 36},
  [2517] = {.lex_state = 48, .external_lex_state = 36},
  [2518] = {.lex_state = 48, .external_lex_state = 36},
  [2519] = {.lex_state = 48, .external_lex_state = 36},
  [2520] = {.lex_state = 48, .external_lex_state = 36},
  [2521] = {.lex_state = 48, .external_lex_state = 36},
  [2522] = {.lex_state = 48, .external_lex_state = 36},
  [2523] = {.lex_state = 48, .external_lex_state = 36},
  [2524] = {.lex_state = 48, .external_lex_state = 36},
  [2525] = {.lex_state = 48, .external_lex_state = 36},
  [2526] = {.lex_state = 48, .external_lex_state = 36},
  [2527] = {.lex_state = 48, .external_lex_state = 36},
  [2528] = {.lex_state = 48, .external_lex_state = 36},
  [2529] = {.lex_state = 48, .external_lex_state = 36},
  [2530] = {.lex_state = 48, .external_lex_state = 36},
  [2531] = {.lex_state = 48, .external_lex_state = 3},
  [2532] = {.lex_state = 48, .external_lex_state = 36},
  [2533] = {.lex_state = 48, .external_lex_state = 36},
  [2534] = {.lex_state = 48, .external_lex_state = 36},
  [2535] = {.lex_state = 48, .external_lex_state = 36},
  [2536] = {.lex_state = 48, .external_lex_state = 36},
  [2537] = {.lex_state = 48, .external_lex_state = 36},
  [2538] = {.lex_state = 48, .external_lex_state = 36},
  [2539] = {.lex_state = 48, .external_lex_state = 36},
  [2540] = {.lex_state = 48, .external_lex_state = 3},
  [2541] = {.lex_state = 48, .external_lex_state = 36},
  [2542] = {.lex_state = 48, .external_lex_state = 36},
  [2543] = {.lex_state = 48, .external_lex_state = 36},
  [2544] = {.lex_state = 48, .external_lex_state = 36},
  [2545] = {.lex_state = 48, .external_lex_state = 36},
  [2546] = {.lex_state = 48, .external_lex_state = 3},
  [2547] = {.lex_state = 48, .external_lex_state = 36},
  [2548] = {.lex_state = 48, .external_lex_state = 36},
  [2549] = {.lex_state = 48, .external_lex_state = 36},
  [2550] = {.lex_state = 48, .external_lex_state = 36},
  [2551] = {.lex_state = 48, .external_lex_state = 36},
  [2552] = {.lex_state = 48, .external_lex_state = 69},
  [2553] = {.lex_state = 48, .external_lex_state = 36},
  [2554] = {.lex_state = 48, .external_lex_state = 3},
  [2555] = {.lex_state = 48, .external_lex_state = 36},
  [2556] = {.lex_state = 48, .external_lex_state = 69},
  [2557] = {.lex_state = 48, .external_lex_state = 70},
  [2558] = {.lex_state = 48, .external_lex_state = 70},
  [2559] = {.lex_state = 48, .external_lex_state = 36},
  [2560] = {.lex_state = 48, .external_lex_state = 36},
  [2561] = {.lex_state = 48, .external_lex_state = 36},
  [2562] = {.lex_state = 48, .external_lex_state = 36},
  [2563] = {.lex_state = 48, .external_lex_state = 36},
  [2564] = {.lex_state = 48, .external_lex_state = 36},
  [2565] = {.lex_state = 48, .external_lex_state = 36},
  [2566] = {.lex_state = 48, .external_lex_state = 36},
  [2567] = {.lex_state = 48, .external_lex_state = 36},
  [2568] = {.lex_state = 48, .external_lex_state = 36},
  [2569] = {.lex_state = 48, .external_lex_state = 36},
  [2570] = {.lex_state = 48, .external_lex_state = 36},
  [2571] = {.lex_state = 48, .external_lex_state = 36},
  [2572] = {.lex_state = 48, .external_lex_state = 36},
  [2573] = {.lex_state = 48, .external_lex_state = 36},
  [2574] = {.lex_state = 48, .external_lex_state = 36},
  [2575] = {.lex_state = 48, .external_lex_state = 36},
  [2576] = {.lex_state = 48, .external_lex_state = 36},
  [2577] = {.lex_state = 48, .external_lex_state = 3},
  [2578] = {.lex_state = 48, .external_lex_state = 36},
  [2579] = {.lex_state = 48, .external_lex_state = 36},
  [2580] = {.lex_state = 48, .external_lex_state = 71},
  [2581] = {.lex_state = 48, .external_lex_state = 36},
  [2582] = {.lex_state = 48, .external_lex_state = 36},
  [2583] = {.lex_state = 48, .external_lex_state = 36},
  [2584] = {.lex_state = 48, .external_lex_state = 36},
  [2585] = {.lex_state = 48, .external_lex_state = 36},
  [2586] = {.lex_state = 48, .external_lex_state = 36},
  [2587] = {.lex_state = 48, .external_lex_state = 36},
  [2588] = {.lex_state = 48, .external_lex_state = 36},
  [2589] = {.lex_state = 48, .external_lex_state = 36},
  [2590] = {.lex_state = 48, .external_lex_state = 36},
  [2591] = {.lex_state = 48, .external_lex_state = 36},
  [2592] = {.lex_state = 48, .external_lex_state = 36},
  [2593] = {.lex_state = 48, .external_lex_state = 36},
  [2594] = {.lex_state = 48, .external_lex_state = 36},
  [2595] = {.lex_state = 48, .external_lex_state = 36},
  [2596] = {.lex_state = 47, .external_lex_state = 36},
  [2597] = {.lex_state = 48, .external_lex_state = 36},
  [2598] = {.lex_state = 48, .external_lex_state = 36},
  [2599] = {.lex_state = 48, .external_lex_state = 36},
  [2600] = {.lex_state = 48, .external_lex_state = 36},
  [2601] = {.lex_state = 48, .external_lex_state = 36},
  [2602] = {.lex_state = 48, .external_lex_state = 36},
  [2603] = {.lex_state = 48, .external_lex_state = 36},
  [2604] = {.lex_state = 48, .external_lex_state = 36},
  [2605] = {.lex_state = 48, .external_lex_state = 36},
  [2606] = {.lex_state = 48, .external_lex_state = 36},
  [2607] = {.lex_state = 48, .external_lex_state = 36},
  [2608] = {.lex_state = 48, .external_lex_state = 36},
  [2609] = {.lex_state = 48, .external_lex_state = 36},
  [2610] = {.lex_state = 48, .external_lex_state = 36},
  [2611] = {.lex_state = 48, .external_lex_state = 71},
  [2612] = {.lex_state = 48, .external_lex_state = 36},
  [2613] = {.lex_state = 48, .external_lex_state = 36},
  [2614] = {.lex_state = 48, .external_lex_state = 36},
  [2615] = {.lex_state = 48, .external_lex_state = 36},
  [2616] = {.lex_state = 48, .external_lex_state = 69},
  [2617] = {.lex_state = 48, .external_lex_state = 36},
  [2618] = {.lex_state = 48, .external_lex_state = 36},
  [2619] = {.lex_state = 48, .external_lex_state = 36},
  [2620] = {.lex_state = 48, .external_lex_state = 36},
  [2621] = {.lex_state = 48, .external_lex_state = 71},
  [2622] = {.lex_state = 48, .external_lex_state = 70},
  [2623] = {.lex_state = 48, .external_lex_state = 36},
  [2624] = {.lex_state = 48, .external_lex_state = 36},
  [2625] = {.lex_state = 48, .external_lex_state = 36},
  [2626] = {.lex_state = 48, .external_lex_state = 36},
  [2627] = {.lex_state = 48, .external_lex_state = 69},
  [2628] = {.lex_state = 48, .external_lex_state = 36},
  [2629] = {.lex_state = 48, .external_lex_state = 36},
  [2630] = {.lex_state = 48, .external_lex_state = 36},
  [2631] = {.lex_state = 48, .external_lex_state = 36},
  [2632] = {.lex_state = 48, .external_lex_state = 36},
  [2633] = {.lex_state = 48, .external_lex_state = 36},
  [2634] = {.lex_state = 48, .external_lex_state = 36},
  [2635] = {.lex_state = 48, .external_lex_state = 36},
  [2636] = {.lex_state = 48, .external_lex_state = 36},
  [2637] = {.lex_state = 48, .external_lex_state = 36},
  [2638] = {.lex_state = 48, .external_lex_state = 36},
  [2639] = {.lex_state = 48, .external_lex_state = 36},
  [2640] = {.lex_state = 48, .external_lex_state = 36},
  [2641] = {.lex_state = 48, .external_lex_state = 70},
  [2642] = {.lex_state = 48, .external_lex_state = 36},
  [2643] = {.lex_state = 48, .external_lex_state = 36},
  [2644] = {.lex_state = 48, .external_lex_state = 36},
  [2645] = {.lex_state = 48, .external_lex_state = 36},
  [2646] = {.lex_state = 48, .external_lex_state = 36},
  [2647] = {.lex_state = 48, .external_lex_state = 36},
  [2648] = {.lex_state = 48, .external_lex_state = 36},
  [2649] = {.lex_state = 48, .external_lex_state = 36},
  [2650] = {.lex_state = 48, .external_lex_state = 36},
  [2651] = {.lex_state = 48, .external_lex_state = 36},
  [2652] = {.lex_state = 48, .external_lex_state = 71},
  [2653] = {.lex_state = 48, .external_lex_state = 36},
  [2654] = {.lex_state = 48, .external_lex_state = 36},
  [2655] = {.lex_state = 48, .external_lex_state = 36},
  [2656] = {.lex_state = 48, .external_lex_state = 36},
  [2657] = {.lex_state = 48, .external_lex_state = 36},
  [2658] = {.lex_state = 48, .external_lex_state = 36},
  [2659] = {.lex_state = 48, .external_lex_state = 36},
  [2660] = {.lex_state = 48, .external_lex_state = 36},
  [2661] = {.lex_state = 47, .external_lex_state = 36},
  [2662] = {.lex_state = 48, .external_lex_state = 36},
  [2663] = {.lex_state = 48, .external_lex_state = 36},
  [2664] = {.lex_state = 48, .external_lex_state = 36},
  [2665] = {.lex_state = 48, .external_lex_state = 36},
  [2666] = {.lex_state = 48, .external_lex_state = 36},
  [2667] = {.lex_state = 48, .external_lex_state = 36},
  [2668] = {.lex_state = 48, .external_lex_state = 36},
  [2669] = {.lex_state = 48, .external_lex_state = 36},
  [2670] = {.lex_state = 48, .external_lex_state = 36},
  [2671] = {.lex_state = 48, .external_lex_state = 36},
  [2672] = {.lex_state = 47, .external_lex_state = 36},
  [2673] = {.lex_state = 47, .external_lex_state = 36},
  [2674] = {.lex_state = 48, .external_lex_state = 36},
  [2675] = {.lex_state = 48, .external_lex_state = 36},
  [2676] = {.lex_state = 48, .external_lex_state = 72},
  [2677] = {.lex_state = 48, .external_lex_state = 73},
  [2678] = {.lex_state = 48, .external_lex_state = 74},
  [2679] = {.lex_state = 48, .external_lex_state = 74},
  [2680] = {.lex_state = 48, .external_lex_state = 75},
  [2681] = {.lex_state = 48, .external_lex_state = 76},
  [2682] = {.lex_state = 48, .external_lex_state = 72},
  [2683] = {.lex_state = 47, .external_lex_state = 36},
  [2684] = {.lex_state = 48, .external_lex_state = 36},
  [2685] = {.lex_state = 48, .external_lex_state = 74},
  [2686] = {.lex_state = 47, .external_lex_state = 36},
  [2687] = {.lex_state = 48, .external_lex_state = 74},
  [2688] = {.lex_state = 48, .external_lex_state = 73},
  [2689] = {.lex_state = 47, .external_lex_state = 36},
  [2690] = {.lex_state = 47, .external_lex_state = 36},
  [2691] = {.lex_state = 47, .external_lex_state = 36},
  [2692] = {.lex_state = 48, .external_lex_state = 75},
  [2693] = {.lex_state = 48, .external_lex_state = 76},
  [2694] = {.lex_state = 47, .external_lex_state = 36},
  [2695] = {.lex_state = 47, .external_lex_state = 36},
  [2696] = {.lex_state = 47, .external_lex_state = 36},
  [2697] = {.lex_state = 48, .external_lex_state = 36},
  [2698] = {.lex_state = 48, .external_lex_state = 36},
  [2699] = {.lex_state = 48, .external_lex_state = 76},
  [2700] = {.lex_state = 48, .external_lex_state = 76},
  [2701] = {.lex_state = 48, .external_lex_state = 36},
  [2702] = {.lex_state = 48, .external_lex_state = 73},
  [2703] = {.lex_state = 48, .external_lex_state = 36},
  [2704] = {.lex_state = 47, .external_lex_state = 36},
  [2705] = {.lex_state = 48, .external_lex_state = 36},
  [2706] = {.lex_state = 48, .external_lex_state = 36},
  [2707] = {.lex_state = 47, .external_lex_state = 36},
  [2708] = {.lex_state = 48, .external_lex_state = 36},
  [2709] = {.lex_state = 47, .external_lex_state = 36},
  [2710] = {.lex_state = 48, .external_lex_state = 77},
  [2711] = {.lex_state = 47, .external_lex_state = 36},
  [2712] = {.lex_state = 48, .external_lex_state = 77},
  [2713] = {.lex_state = 48, .external_lex_state = 72},
  [2714] = {.lex_state = 48, .external_lex_state = 72},
  [2715] = {.lex_state = 48, .external_lex_state = 75},
  [2716] = {.lex_state = 47, .external_lex_state = 36},
  [2717] = {.lex_state = 47, .external_lex_state = 36},
  [2718] = {.lex_state = 48, .external_lex_state = 36},
  [2719] = {.lex_state = 47, .external_lex_state = 36},
  [2720] = {.lex_state = 48, .external_lex_state = 36},
  [2721] = {.lex_state = 48, .external_lex_state = 73},
  [2722] = {.lex_state = 48, .external_lex_state = 36},
  [2723] = {.lex_state = 48, .external_lex_state = 77},
  [2724] = {.lex_state = 48, .external_lex_state = 36},
  [2725] = {.lex_state = 48, .external_lex_state = 36},
  [2726] = {.lex_state = 48, .external_lex_state = 77},
  [2727] = {.lex_state = 47, .external_lex_state = 36},
  [2728] = {.lex_state = 47, .external_lex_state = 36},
  [2729] = {.lex_state = 47, .external_lex_state = 36},
  [2730] = {.lex_state = 47, .external_lex_state = 36},
  [2731] = {.lex_state = 47, .external_lex_state = 36},
  [2732] = {.lex_state = 47, .external_lex_state = 36},
  [2733] = {.lex_state = 48, .external_lex_state = 13},
  [2734] = {.lex_state = 48, .external_lex_state = 78},
  [2735] = {.lex_state = 48, .external_lex_state = 79},
  [2736] = {.lex_state = 48, .external_lex_state = 80},
  [2737] = {.lex_state = 48, .external_lex_state = 81},
  [2738] = {.lex_state = 48, .external_lex_state = 13},
  [2739] = {.lex_state = 48, .external_lex_state = 36},
  [2740] = {.lex_state = 48, .external_lex_state = 82},
  [2741] = {.lex_state = 48, .external_lex_state = 36},
  [2742] = {.lex_state = 48, .external_lex_state = 13},
  [2743] = {.lex_state = 48, .external_lex_state = 36},
  [2744] = {.lex_state = 48, .external_lex_state = 79},
  [2745] = {.lex_state = 48, .external_lex_state = 83},
  [2746] = {.lex_state = 48, .external_lex_state = 13},
  [2747] = {.lex_state = 48, .external_lex_state = 83},
  [2748] = {.lex_state = 48, .external_lex_state = 80},
  [2749] = {.lex_state = 48, .external_lex_state = 83},
  [2750] = {.lex_state = 48, .external_lex_state = 79},
  [2751] = {.lex_state = 48, .external_lex_state = 82},
  [2752] = {.lex_state = 48, .external_lex_state = 81},
  [2753] = {.lex_state = 48, .external_lex_state = 81},
  [2754] = {.lex_state = 48, .external_lex_state = 79},
  [2755] = {.lex_state = 48, .external_lex_state = 80},
  [2756] = {.lex_state = 48, .external_lex_state = 83},
  [2757] = {.lex_state = 48, .external_lex_state = 80},
  [2758] = {.lex_state = 48, .external_lex_state = 82},
  [2759] = {.lex_state = 48, .external_lex_state = 82},
  [2760] = {.lex_state = 48, .external_lex_state = 78},
  [2761] = {.lex_state = 48, .external_lex_state = 78},
  [2762] = {.lex_state = 48, .external_lex_state = 78},
  [2763] = {.lex_state = 48, .external_lex_state = 81},
  [2764] = {.lex_state = 47, .external_lex_state = 84},
  [2765] = {.lex_state = 48, .external_lex_state = 85},
  [2766] = {.lex_state = 48, .external_lex_state = 36},
  [2767] = {.lex_state = 48, .external_lex_state = 85},
  [2768] = {.lex_state = 48, .external_lex_state = 85},
  [2769] = {.lex_state = 48, .external_lex_state = 36},
  [2770] = {.lex_state = 48, .external_lex_state = 3},
  [2771] = {.lex_state = 48, .external_lex_state = 86},
  [2772] = {.lex_state = 48, .external_lex_state = 3},
  [2773] = {.lex_state = 48, .external_lex_state = 86},
  [2774] = {.lex_state = 48, .external_lex_state = 85},
  [2775] = {.lex_state = 48, .external_lex_state = 86},
  [2776] = {.lex_state = 48, .external_lex_state = 36},
  [2777] = {.lex_state = 48, .external_lex_state = 36},
  [2778] = {.lex_state = 48, .external_lex_state = 3},
  [2779] = {.lex_state = 48, .external_lex_state = 3},
  [2780] = {.lex_state = 48, .external_lex_state = 86},
  [2781] = {.lex_state = 48, .external_lex_state = 36},
  [2782] = {.lex_state = 48, .external_lex_state = 36},
  [2783] = {.lex_state = 48, .external_lex_state = 36},
  [2784] = {.lex_state = 48, .external_lex_state = 75},
  [2785] = {.lex_state = 48, .external_lex_state = 87},
  [2786] = {.lex_state = 48, .external_lex_state = 77},
  [2787] = {.lex_state = 48, .external_lex_state = 87},
  [2788] = {.lex_state = 48, .external_lex_state = 88},
  [2789] = {.lex_state = 47, .external_lex_state = 89},
  [2790] = {.lex_state = 47, .external_lex_state = 90},
  [2791] = {.lex_state = 48, .external_lex_state = 3},
  [2792] = {.lex_state = 48, .external_lex_state = 73},
  [2793] = {.lex_state = 48, .external_lex_state = 3},
  [2794] = {.lex_state = 48, .external_lex_state = 3},
  [2795] = {.lex_state = 48, .external_lex_state = 3},
  [2796] = {.lex_state = 48, .external_lex_state = 36},
  [2797] = {.lex_state = 48, .external_lex_state = 13},
  [2798] = {.lex_state = 48, .external_lex_state = 36},
  [2799] = {.lex_state = 48, .external_lex_state = 88},
  [2800] = {.lex_state = 48, .external_lex_state = 3},
  [2801] = {.lex_state = 48, .external_lex_state = 3},
  [2802] = {.lex_state = 48, .external_lex_state = 87},
  [2803] = {.lex_state = 48, .external_lex_state = 88},
  [2804] = {.lex_state = 48, .external_lex_state = 36},
  [2805] = {.lex_state = 48, .external_lex_state = 87},
  [2806] = {.lex_state = 48, .external_lex_state = 3},
  [2807] = {.lex_state = 48, .external_lex_state = 3},
  [2808] = {.lex_state = 48, .external_lex_state = 36},
  [2809] = {.lex_state = 48, .external_lex_state = 3},
  [2810] = {.lex_state = 48, .external_lex_state = 88},
  [2811] = {.lex_state = 48, .external_lex_state = 3},
  [2812] = {.lex_state = 48, .external_lex_state = 3},
  [2813] = {.lex_state = 48, .external_lex_state = 36},
  [2814] = {.lex_state = 48, .external_lex_state = 3},
  [2815] = {.lex_state = 48, .external_lex_state = 3},
  [2816] = {.lex_state = 48, .external_lex_state = 80},
  [2817] = {.lex_state = 48, .external_lex_state = 3},
  [2818] = {.lex_state = 48, .external_lex_state = 54},
  [2819] = {.lex_state = 48, .external_lex_state = 3},
  [2820] = {.lex_state = 48, .external_lex_state = 3},
  [2821] = {.lex_state = 48, .external_lex_state = 3},
  [2822] = {.lex_state = 48, .external_lex_state = 3},
  [2823] = {.lex_state = 48, .external_lex_state = 91},
  [2824] = {.lex_state = 48, .external_lex_state = 92},
  [2825] = {.lex_state = 47, .external_lex_state = 93},
  [2826] = {.lex_state = 47, .external_lex_state = 84},
  [2827] = {.lex_state = 48, .external_lex_state = 59},
  [2828] = {.lex_state = 48, .external_lex_state = 91},
  [2829] = {.lex_state = 47, .external_lex_state = 84},
  [2830] = {.lex_state = 48, .external_lex_state = 3},
  [2831] = {.lex_state = 48, .external_lex_state = 3},
  [2832] = {.lex_state = 48, .external_lex_state = 92},
  [2833] = {.lex_state = 47, .external_lex_state = 3},
  [2834] = {.lex_state = 47, .external_lex_state = 3},
  [2835] = {.lex_state = 47, .external_lex_state = 3},
  [2836] = {.lex_state = 47, .external_lex_state = 3},
  [2837] = {.lex_state = 47, .external_lex_state = 3},
  [2838] = {.lex_state = 47, .external_lex_state = 3},
  [2839] = {.lex_state = 47, .external_lex_state = 3},
  [2840] = {.lex_state = 48, .external_lex_state = 81},
  [2841] = {.lex_state = 47, .external_lex_state = 89},
  [2842] = {.lex_state = 47, .external_lex_state = 3},
  [2843] = {.lex_state = 48, .external_lex_state = 64},
  [2844] = {.lex_state = 47, .external_lex_state = 3},
  [2845] = {.lex_state = 47, .external_lex_state = 3},
  [2846] = {.lex_state = 47, .external_lex_state = 3},
  [2847] = {.lex_state = 47, .external_lex_state = 3},
  [2848] = {.lex_state = 48, .external_lex_state = 94},
  [2849] = {.lex_state = 47, .external_lex_state = 3},
  [2850] = {.lex_state = 47, .external_lex_state = 95},
  [2851] = {.lex_state = 47, .external_lex_state = 3},
  [2852] = {.lex_state = 47, .external_lex_state = 3},
  [2853] = {.lex_state = 47, .external_lex_state = 3},
  [2854] = {.lex_state = 47, .external_lex_state = 96},
  [2855] = {.lex_state = 47, .external_lex_state = 3},
  [2856] = {.lex_state = 47, .external_lex_state = 3},
  [2857] = {.lex_state = 47, .external_lex_state = 3},
  [2858] = {.lex_state = 48, .external_lex_state = 97},
  [2859] = {.lex_state = 48, .external_lex_state = 97},
  [2860] = {.lex_state = 47, .external_lex_state = 3},
  [2861] = {.lex_state = 47, .external_lex_state = 3},
  [2862] = {.lex_state = 47, .external_lex_state = 3},
  [2863] = {.lex_state = 47, .external_lex_state = 3},
  [2864] = {.lex_state = 47, .external_lex_state = 3},
  [2865] = {.lex_state = 47, .external_lex_state = 89},
  [2866] = {.lex_state = 48, .external_lex_state = 83},
  [2867] = {.lex_state = 48, .external_lex_state = 98},
  [2868] = {.lex_state = 47, .external_lex_state = 3},
  [2869] = {.lex_state = 47, .external_lex_state = 3},
  [2870] = {.lex_state = 47, .external_lex_state = 99},
  [2871] = {.lex_state = 47, .external_lex_state = 3},
  [2872] = {.lex_state = 48, .external_lex_state = 94},
  [2873] = {.lex_state = 47, .external_lex_state = 3},
  [2874] = {.lex_state = 47, .external_lex_state = 3},
  [2875] = {.lex_state = 47, .external_lex_state = 3},
  [2876] = {.lex_state = 47, .external_lex_state = 3},
  [2877] = {.lex_state = 47, .external_lex_state = 3},
  [2878] = {.lex_state = 47, .external_lex_state = 3},
  [2879] = {.lex_state = 47, .external_lex_state = 3},
  [2880] = {.lex_state = 48, .external_lex_state = 36},
  [2881] = {.lex_state = 47, .external_lex_state = 100},
  [2882] = {.lex_state = 48, .external_lex_state = 36},
  [2883] = {.lex_state = 47, .external_lex_state = 3},
  [2884] = {.lex_state = 47, .external_lex_state = 3},
  [2885] = {.lex_state = 48, .external_lex_state = 36},
  [2886] = {.lex_state = 47, .external_lex_state = 101},
  [2887] = {.lex_state = 47, .external_lex_state = 3},
  [2888] = {.lex_state = 47, .external_lex_state = 3},
  [2889] = {.lex_state = 47, .external_lex_state = 3},
  [2890] = {.lex_state = 47, .external_lex_state = 90},
  [2891] = {.lex_state = 47, .external_lex_state = 90},
  [2892] = {.lex_state = 47, .external_lex_state = 3},
  [2893] = {.lex_state = 47, .external_lex_state = 3},
  [2894] = {.lex_state = 47, .external_lex_state = 3},
  [2895] = {.lex_state = 48, .external_lex_state = 98},
  [2896] = {.lex_state = 47, .external_lex_state = 3},
  [2897] = {.lex_state = 47, .external_lex_state = 3},
  [2898] = {.lex_state = 47, .external_lex_state = 3},
  [2899] = {.lex_state = 48, .external_lex_state = 97},
  [2900] = {.lex_state = 47, .external_lex_state = 3},
  [2901] = {.lex_state = 47, .external_lex_state = 3},
  [2902] = {.lex_state = 47, .external_lex_state = 3},
  [2903] = {.lex_state = 47, .external_lex_state = 3},
  [2904] = {.lex_state = 47, .external_lex_state = 3},
  [2905] = {.lex_state = 47, .external_lex_state = 3},
  [2906] = {.lex_state = 47, .external_lex_state = 3},
  [2907] = {.lex_state = 48, .external_lex_state = 94},
  [2908] = {.lex_state = 47, .external_lex_state = 4},
  [2909] = {.lex_state = 47, .external_lex_state = 4},
  [2910] = {.lex_state = 47, .external_lex_state = 4},
  [2911] = {.lex_state = 47, .external_lex_state = 3},
  [2912] = {.lex_state = 47, .external_lex_state = 4},
  [2913] = {.lex_state = 47, .external_lex_state = 4},
  [2914] = {.lex_state = 47, .external_lex_state = 3},
  [2915] = {.lex_state = 47, .external_lex_state = 4},
  [2916] = {.lex_state = 47, .external_lex_state = 3},
  [2917] = {.lex_state = 47, .external_lex_state = 4},
  [2918] = {.lex_state = 47, .external_lex_state = 4},
  [2919] = {.lex_state = 47, .external_lex_state = 4},
  [2920] = {.lex_state = 47, .external_lex_state = 3},
  [2921] = {.lex_state = 47, .external_lex_state = 4},
  [2922] = {.lex_state = 47, .external_lex_state = 4},
  [2923] = {.lex_state = 47, .external_lex_state = 4},
  [2924] = {.lex_state = 47, .external_lex_state = 4},
  [2925] = {.lex_state = 47, .external_lex_state = 3},
  [2926] = {.lex_state = 47, .external_lex_state = 4},
  [2927] = {.lex_state = 47, .external_lex_state = 3},
  [2928] = {.lex_state = 47, .external_lex_state = 93},
  [2929] = {.lex_state = 47, .external_lex_state = 4},
  [2930] = {.lex_state = 47, .external_lex_state = 4},
  [2931] = {.lex_state = 47, .external_lex_state = 4},
  [2932] = {.lex_state = 47, .external_lex_state = 4},
  [2933] = {.lex_state = 47, .external_lex_state = 3},
  [2934] = {.lex_state = 47, .external_lex_state = 4},
  [2935] = {.lex_state = 47, .external_lex_state = 4},
  [2936] = {.lex_state = 47, .external_lex_state = 3},
  [2937] = {.lex_state = 47, .external_lex_state = 3},
  [2938] = {.lex_state = 47, .external_lex_state = 4},
  [2939] = {.lex_state = 47, .external_lex_state = 3},
  [2940] = {.lex_state = 47, .external_lex_state = 4},
  [2941] = {.lex_state = 47, .external_lex_state = 4},
  [2942] = {.lex_state = 47, .external_lex_state = 3},
  [2943] = {.lex_state = 47, .external_lex_state = 3},
  [2944] = {.lex_state = 47, .external_lex_state = 4},
  [2945] = {.lex_state = 47, .external_lex_state = 3},
  [2946] = {.lex_state = 47, .external_lex_state = 4},
  [2947] = {.lex_state = 47, .external_lex_state = 3},
  [2948] = {.lex_state = 47, .external_lex_state = 4},
  [2949] = {.lex_state = 47, .external_lex_state = 3},
  [2950] = {.lex_state = 47, .external_lex_state = 3},
  [2951] = {.lex_state = 47, .external_lex_state = 3},
  [2952] = {.lex_state = 47, .external_lex_state = 4},
  [2953] = {.lex_state = 48, .external_lex_state = 36},
  [2954] = {.lex_state = 47, .external_lex_state = 4},
  [2955] = {.lex_state = 47, .external_lex_state = 4},
  [2956] = {.lex_state = 47, .external_lex_state = 3},
  [2957] = {.lex_state = 47, .external_lex_state = 4},
  [2958] = {.lex_state = 47, .external_lex_state = 3},
  [2959] = {.lex_state = 47, .external_lex_state = 3},
  [2960] = {.lex_state = 47, .external_lex_state = 4},
  [2961] = {.lex_state = 47, .external_lex_state = 4},
  [2962] = {.lex_state = 47, .external_lex_state = 3},
  [2963] = {.lex_state = 47, .external_lex_state = 3},
  [2964] = {.lex_state = 47, .external_lex_state = 4},
  [2965] = {.lex_state = 47, .external_lex_state = 3},
  [2966] = {.lex_state = 48, .external_lex_state = 102},
  [2967] = {.lex_state = 47, .external_lex_state = 4},
  [2968] = {.lex_state = 47, .external_lex_state = 4},
  [2969] = {.lex_state = 48, .external_lex_state = 39},
  [2970] = {.lex_state = 47, .external_lex_state = 4},
  [2971] = {.lex_state = 48, .external_lex_state = 36},
  [2972] = {.lex_state = 47, .external_lex_state = 3},
  [2973] = {.lex_state = 47, .external_lex_state = 4},
  [2974] = {.lex_state = 47, .external_lex_state = 3},
  [2975] = {.lex_state = 47, .external_lex_state = 4},
  [2976] = {.lex_state = 47, .external_lex_state = 3},
  [2977] = {.lex_state = 47, .external_lex_state = 4},
  [2978] = {.lex_state = 47, .external_lex_state = 4},
  [2979] = {.lex_state = 47, .external_lex_state = 4},
  [2980] = {.lex_state = 47, .external_lex_state = 4},
  [2981] = {.lex_state = 47, .external_lex_state = 3},
  [2982] = {.lex_state = 47, .external_lex_state = 4},
  [2983] = {.lex_state = 47, .external_lex_state = 4},
  [2984] = {.lex_state = 47, .external_lex_state = 4},
  [2985] = {.lex_state = 47, .external_lex_state = 4},
  [2986] = {.lex_state = 47, .external_lex_state = 3},
  [2987] = {.lex_state = 47, .external_lex_state = 4},
  [2988] = {.lex_state = 47, .external_lex_state = 3},
  [2989] = {.lex_state = 47, .external_lex_state = 4},
  [2990] = {.lex_state = 47, .external_lex_state = 4},
  [2991] = {.lex_state = 48, .external_lex_state = 103},
  [2992] = {.lex_state = 47, .external_lex_state = 3},
  [2993] = {.lex_state = 47, .external_lex_state = 4},
  [2994] = {.lex_state = 47, .external_lex_state = 4},
  [2995] = {.lex_state = 47, .external_lex_state = 3},
  [2996] = {.lex_state = 47, .external_lex_state = 3},
  [2997] = {.lex_state = 47, .external_lex_state = 104},
  [2998] = {.lex_state = 48, .external_lex_state = 3},
  [2999] = {.lex_state = 47, .external_lex_state = 4},
  [3000] = {.lex_state = 47, .external_lex_state = 4},
  [3001] = {.lex_state = 47, .external_lex_state = 4},
  [3002] = {.lex_state = 47, .external_lex_state = 3},
  [3003] = {.lex_state = 47, .external_lex_state = 3},
  [3004] = {.lex_state = 47, .external_lex_state = 4},
  [3005] = {.lex_state = 47, .external_lex_state = 4},
  [3006] = {.lex_state = 47, .external_lex_state = 4},
  [3007] = {.lex_state = 47, .external_lex_state = 3},
  [3008] = {.lex_state = 47, .external_lex_state = 4},
  [3009] = {.lex_state = 47, .external_lex_state = 4},
  [3010] = {.lex_state = 47, .external_lex_state = 3},
  [3011] = {.lex_state = 47, .external_lex_state = 4},
  [3012] = {.lex_state = 47, .external_lex_state = 105},
  [3013] = {.lex_state = 47, .external_lex_state = 3},
  [3014] = {.lex_state = 47, .external_lex_state = 3},
  [3015] = {.lex_state = 47, .external_lex_state = 3},
  [3016] = {.lex_state = 47, .external_lex_state = 4},
  [3017] = {.lex_state = 47, .external_lex_state = 3},
  [3018] = {.lex_state = 47, .external_lex_state = 4},
  [3019] = {.lex_state = 47, .external_lex_state = 4},
  [3020] = {.lex_state = 47, .external_lex_state = 4},
  [3021] = {.lex_state = 47, .external_lex_state = 4},
  [3022] = {.lex_state = 47, .external_lex_state = 4},
  [3023] = {.lex_state = 47, .external_lex_state = 3},
  [3024] = {.lex_state = 47, .external_lex_state = 4},
  [3025] = {.lex_state = 47, .external_lex_state = 3},
  [3026] = {.lex_state = 47, .external_lex_state = 4},
  [3027] = {.lex_state = 47, .external_lex_state = 3},
  [3028] = {.lex_state = 47, .external_lex_state = 3},
  [3029] = {.lex_state = 47, .external_lex_state = 4},
  [3030] = {.lex_state = 47, .external_lex_state = 4},
  [3031] = {.lex_state = 47, .external_lex_state = 4},
  [3032] = {.lex_state = 47, .external_lex_state = 4},
  [3033] = {.lex_state = 47, .external_lex_state = 3},
  [3034] = {.lex_state = 47, .external_lex_state = 4},
  [3035] = {.lex_state = 47, .external_lex_state = 4},
  [3036] = {.lex_state = 47, .external_lex_state = 4},
  [3037] = {.lex_state = 47, .external_lex_state = 3},
  [3038] = {.lex_state = 47, .external_lex_state = 4},
  [3039] = {.lex_state = 47, .external_lex_state = 3},
  [3040] = {.lex_state = 47, .external_lex_state = 4},
  [3041] = {.lex_state = 47, .external_lex_state = 3},
  [3042] = {.lex_state = 47, .external_lex_state = 4},
  [3043] = {.lex_state = 47, .external_lex_state = 4},
  [3044] = {.lex_state = 47, .external_lex_state = 3},
  [3045] = {.lex_state = 47, .external_lex_state = 4},
  [3046] = {.lex_state = 47, .external_lex_state = 3},
  [3047] = {.lex_state = 47, .external_lex_state = 4},
  [3048] = {.lex_state = 47, .external_lex_state = 4},
  [3049] = {.lex_state = 47, .external_lex_state = 4},
  [3050] = {.lex_state = 47, .external_lex_state = 3},
  [3051] = {.lex_state = 47, .external_lex_state = 3},
  [3052] = {.lex_state = 47, .external_lex_state = 4},
  [3053] = {.lex_state = 47, .external_lex_state = 4},
  [3054] = {.lex_state = 47, .external_lex_state = 3},
  [3055] = {.lex_state = 47, .external_lex_state = 3},
  [3056] = {.lex_state = 47, .external_lex_state = 4},
  [3057] = {.lex_state = 47, .external_lex_state = 4},
  [3058] = {.lex_state = 47, .external_lex_state = 4},
  [3059] = {.lex_state = 48, .external_lex_state = 3},
  [3060] = {.lex_state = 47, .external_lex_state = 3},
  [3061] = {.lex_state = 47, .external_lex_state = 3},
  [3062] = {.lex_state = 47, .external_lex_state = 4},
  [3063] = {.lex_state = 47, .external_lex_state = 3},
  [3064] = {.lex_state = 47, .external_lex_state = 4},
  [3065] = {.lex_state = 47, .external_lex_state = 4},
  [3066] = {.lex_state = 47, .external_lex_state = 3},
  [3067] = {.lex_state = 47, .external_lex_state = 3},
  [3068] = {.lex_state = 47, .external_lex_state = 3},
  [3069] = {.lex_state = 47, .external_lex_state = 4},
  [3070] = {.lex_state = 47, .external_lex_state = 3},
  [3071] = {.lex_state = 47, .external_lex_state = 3},
  [3072] = {.lex_state = 48, .external_lex_state = 103},
  [3073] = {.lex_state = 47, .external_lex_state = 4},
  [3074] = {.lex_state = 47, .external_lex_state = 4},
  [3075] = {.lex_state = 47, .external_lex_state = 4},
  [3076] = {.lex_state = 47, .external_lex_state = 3},
  [3077] = {.lex_state = 47, .external_lex_state = 3},
  [3078] = {.lex_state = 47, .external_lex_state = 3},
  [3079] = {.lex_state = 47, .external_lex_state = 4},
  [3080] = {.lex_state = 47, .external_lex_state = 3},
  [3081] = {.lex_state = 47, .external_lex_state = 4},
  [3082] = {.lex_state = 47, .external_lex_state = 4},
  [3083] = {.lex_state = 47, .external_lex_state = 4},
  [3084] = {.lex_state = 47, .external_lex_state = 4},
  [3085] = {.lex_state = 47, .external_lex_state = 4},
  [3086] = {.lex_state = 47, .external_lex_state = 3},
  [3087] = {.lex_state = 47, .external_lex_state = 4},
  [3088] = {.lex_state = 47, .external_lex_state = 3},
  [3089] = {.lex_state = 47, .external_lex_state = 4},
  [3090] = {.lex_state = 47, .external_lex_state = 3},
  [3091] = {.lex_state = 48, .external_lex_state = 3},
  [3092] = {.lex_state = 47, .external_lex_state = 3},
  [3093] = {.lex_state = 47, .external_lex_state = 4},
  [3094] = {.lex_state = 47, .external_lex_state = 4},
  [3095] = {.lex_state = 47, .external_lex_state = 4},
  [3096] = {.lex_state = 47, .external_lex_state = 4},
  [3097] = {.lex_state = 47, .external_lex_state = 4},
  [3098] = {.lex_state = 47, .external_lex_state = 4},
  [3099] = {.lex_state = 47, .external_lex_state = 4},
  [3100] = {.lex_state = 47, .external_lex_state = 4},
  [3101] = {.lex_state = 47, .external_lex_state = 3},
  [3102] = {.lex_state = 47, .external_lex_state = 3},
  [3103] = {.lex_state = 47, .external_lex_state = 4},
  [3104] = {.lex_state = 47, .external_lex_state = 3},
  [3105] = {.lex_state = 47, .external_lex_state = 4},
  [3106] = {.lex_state = 47, .external_lex_state = 4},
  [3107] = {.lex_state = 47, .external_lex_state = 4},
  [3108] = {.lex_state = 47, .external_lex_state = 4},
  [3109] = {.lex_state = 47, .external_lex_state = 4},
  [3110] = {.lex_state = 47, .external_lex_state = 4},
  [3111] = {.lex_state = 47, .external_lex_state = 3},
  [3112] = {.lex_state = 47, .external_lex_state = 4},
  [3113] = {.lex_state = 47, .external_lex_state = 4},
  [3114] = {.lex_state = 47, .external_lex_state = 4},
  [3115] = {.lex_state = 47, .external_lex_state = 3},
  [3116] = {.lex_state = 47, .external_lex_state = 4},
  [3117] = {.lex_state = 47, .external_lex_state = 4},
  [3118] = {.lex_state = 47, .external_lex_state = 3},
  [3119] = {.lex_state = 47, .external_lex_state = 3},
  [3120] = {.lex_state = 47, .external_lex_state = 4},
  [3121] = {.lex_state = 47, .external_lex_state = 3},
  [3122] = {.lex_state = 47, .external_lex_state = 3},
  [3123] = {.lex_state = 48, .external_lex_state = 3},
  [3124] = {.lex_state = 47, .external_lex_state = 4},
  [3125] = {.lex_state = 47, .external_lex_state = 3},
  [3126] = {.lex_state = 47, .external_lex_state = 4},
  [3127] = {.lex_state = 48, .external_lex_state = 36},
  [3128] = {.lex_state = 47, .external_lex_state = 4},
  [3129] = {.lex_state = 47, .external_lex_state = 3},
  [3130] = {.lex_state = 47, .external_lex_state = 4},
  [3131] = {.lex_state = 47, .external_lex_state = 3},
  [3132] = {.lex_state = 47, .external_lex_state = 4},
  [3133] = {.lex_state = 47, .external_lex_state = 4},
  [3134] = {.lex_state = 48, .external_lex_state = 3},
  [3135] = {.lex_state = 47, .external_lex_state = 3},
  [3136] = {.lex_state = 47, .external_lex_state = 4},
  [3137] = {.lex_state = 47, .external_lex_state = 4},
  [3138] = {.lex_state = 47, .external_lex_state = 3},
  [3139] = {.lex_state = 47, .external_lex_state = 4},
  [3140] = {.lex_state = 47, .external_lex_state = 4},
  [3141] = {.lex_state = 47, .external_lex_state = 3},
  [3142] = {.lex_state = 47, .external_lex_state = 3},
  [3143] = {.lex_state = 48, .external_lex_state = 3},
  [3144] = {.lex_state = 48, .external_lex_state = 36},
  [3145] = {.lex_state = 47, .external_lex_state = 3},
  [3146] = {.lex_state = 47, .external_lex_state = 4},
  [3147] = {.lex_state = 47, .external_lex_state = 4},
  [3148] = {.lex_state = 47, .external_lex_state = 4},
  [3149] = {.lex_state = 47, .external_lex_state = 3},
  [3150] = {.lex_state = 47, .external_lex_state = 4},
  [3151] = {.lex_state = 47, .external_lex_state = 4},
  [3152] = {.lex_state = 47, .external_lex_state = 4},
  [3153] = {.lex_state = 47, .external_lex_state = 3},
  [3154] = {.lex_state = 48, .external_lex_state = 13},
  [3155] = {.lex_state = 47, .external_lex_state = 3},
  [3156] = {.lex_state = 47, .external_lex_state = 4},
  [3157] = {.lex_state = 47, .external_lex_state = 4},
  [3158] = {.lex_state = 47, .external_lex_state = 4},
  [3159] = {.lex_state = 47, .external_lex_state = 4},
  [3160] = {.lex_state = 47, .external_lex_state = 93},
  [3161] = {.lex_state = 47, .external_lex_state = 3},
  [3162] = {.lex_state = 47, .external_lex_state = 4},
  [3163] = {.lex_state = 47, .external_lex_state = 3},
  [3164] = {.lex_state = 47, .external_lex_state = 3},
  [3165] = {.lex_state = 47, .external_lex_state = 4},
  [3166] = {.lex_state = 47, .external_lex_state = 3},
  [3167] = {.lex_state = 48, .external_lex_state = 102},
  [3168] = {.lex_state = 47, .external_lex_state = 4},
  [3169] = {.lex_state = 47, .external_lex_state = 4},
  [3170] = {.lex_state = 47, .external_lex_state = 106},
  [3171] = {.lex_state = 47, .external_lex_state = 3},
  [3172] = {.lex_state = 47, .external_lex_state = 4},
  [3173] = {.lex_state = 47, .external_lex_state = 4},
  [3174] = {.lex_state = 47, .external_lex_state = 3},
  [3175] = {.lex_state = 47, .external_lex_state = 3},
  [3176] = {.lex_state = 47, .external_lex_state = 4},
  [3177] = {.lex_state = 47, .external_lex_state = 4},
  [3178] = {.lex_state = 47, .external_lex_state = 3},
  [3179] = {.lex_state = 47, .external_lex_state = 4},
  [3180] = {.lex_state = 48, .external_lex_state = 107},
  [3181] = {.lex_state = 47, .external_lex_state = 99},
  [3182] = {.lex_state = 47, .external_lex_state = 95},
  [3183] = {.lex_state = 48, .external_lex_state = 107},
  [3184] = {.lex_state = 47, .external_lex_state = 3},
  [3185] = {.lex_state = 48, .external_lex_state = 108},
  [3186] = {.lex_state = 47, .external_lex_state = 3},
  [3187] = {.lex_state = 47, .external_lex_state = 100},
  [3188] = {.lex_state = 47, .external_lex_state = 95},
  [3189] = {.lex_state = 48, .external_lex_state = 108},
  [3190] = {.lex_state = 47, .external_lex_state = 96},
  [3191] = {.lex_state = 48, .external_lex_state = 36},
  [3192] = {.lex_state = 48, .external_lex_state = 36},
  [3193] = {.lex_state = 48, .external_lex_state = 109},
  [3194] = {.lex_state = 48, .external_lex_state = 36},
  [3195] = {.lex_state = 48, .external_lex_state = 36},
  [3196] = {.lex_state = 47, .external_lex_state = 101},
  [3197] = {.lex_state = 47, .external_lex_state = 96},
  [3198] = {.lex_state = 47, .external_lex_state = 100},
  [3199] = {.lex_state = 48, .external_lex_state = 109},
  [3200] = {.lex_state = 48, .external_lex_state = 36},
  [3201] = {.lex_state = 47, .external_lex_state = 99},
  [3202] = {.lex_state = 47, .external_lex_state = 110},
  [3203] = {.lex_state = 47, .external_lex_state = 3},
  [3204] = {.lex_state = 48, .external_lex_state = 36},
  [3205] = {.lex_state = 48, .external_lex_state = 36},
  [3206] = {.lex_state = 48, .external_lex_state = 36},
  [3207] = {.lex_state = 48, .external_lex_state = 36},
  [3208] = {.lex_state = 47, .external_lex_state = 3},
  [3209] = {.lex_state = 47, .external_lex_state = 101},
  [3210] = {.lex_state = 47, .external_lex_state = 3},
  [3211] = {.lex_state = 47, .external_lex_state = 3},
  [3212] = {.lex_state = 48, .external_lex_state = 36},
  [3213] = {.lex_state = 48, .external_lex_state = 36},
  [3214] = {.lex_state = 47, .external_lex_state = 3},
  [3215] = {.lex_state = 47, .external_lex_state = 3},
  [3216] = {.lex_state = 47, .external_lex_state = 3},
  [3217] = {.lex_state = 48, .external_lex_state = 111},
  [3218] = {.lex_state = 47, .external_lex_state = 3},
  [3219] = {.lex_state = 48, .external_lex_state = 36},
  [3220] = {.lex_state = 47, .external_lex_state = 106},
  [3221] = {.lex_state = 48, .external_lex_state = 36},
  [3222] = {.lex_state = 47, .external_lex_state = 3},
  [3223] = {.lex_state = 47, .external_lex_state = 3},
  [3224] = {.lex_state = 48, .external_lex_state = 36},
  [3225] = {.lex_state = 47, .external_lex_state = 105},
  [3226] = {.lex_state = 47, .external_lex_state = 104},
  [3227] = {.lex_state = 47, .external_lex_state = 3},
  [3228] = {.lex_state = 48, .external_lex_state = 112},
  [3229] = {.lex_state = 47, .external_lex_state = 3},
  [3230] = {.lex_state = 47, .external_lex_state = 3},
  [3231] = {.lex_state = 48, .external_lex_state = 113},
  [3232] = {.lex_state = 48, .external_lex_state = 36},
  [3233] = {.lex_state = 47, .external_lex_state = 3},
  [3234] = {.lex_state = 48, .external_lex_state = 36},
  [3235] = {.lex_state = 47, .external_lex_state = 105},
  [3236] = {.lex_state = 47, .external_lex_state = 3},
  [3237] = {.lex_state = 47, .external_lex_state = 3},
  [3238] = {.lex_state = 47, .external_lex_state = 3},
  [3239] = {.lex_state = 48, .external_lex_state = 113},
  [3240] = {.lex_state = 47, .external_lex_state = 3},
  [3241] = {.lex_state = 47, .external_lex_state = 104},
  [3242] = {.lex_state = 47, .external_lex_state = 106},
  [3243] = {.lex_state = 47, .external_lex_state = 3},
  [3244] = {.lex_state = 47, .external_lex_state = 3},
  [3245] = {.lex_state = 47, .external_lex_state = 3},
  [3246] = {.lex_state = 48, .external_lex_state = 36},
  [3247] = {.lex_state = 48, .external_lex_state = 36},
  [3248] = {.lex_state = 48, .external_lex_state = 36},
  [3249] = {.lex_state = 48, .external_lex_state = 36},
  [3250] = {.lex_state = 47, .external_lex_state = 3},
  [3251] = {.lex_state = 47, .external_lex_state = 3},
  [3252] = {.lex_state = 48, .external_lex_state = 112},
  [3253] = {.lex_state = 48, .external_lex_state = 114},
  [3254] = {.lex_state = 47, .external_lex_state = 3},
  [3255] = {.lex_state = 48, .external_lex_state = 114},
  [3256] = {.lex_state = 47, .external_lex_state = 3},
  [3257] = {.lex_state = 47, .external_lex_state = 3},
  [3258] = {.lex_state = 47, .external_lex_state = 3},
  [3259] = {.lex_state = 47, .external_lex_state = 3},
  [3260] = {.lex_state = 47, .external_lex_state = 3},
  [3261] = {.lex_state = 47, .external_lex_state = 3},
  [3262] = {.lex_state = 47, .external_lex_state = 3},
  [3263] = {.lex_state = 48, .external_lex_state = 36},
  [3264] = {.lex_state = 47, .external_lex_state = 3},
  [3265] = {.lex_state = 47, .external_lex_state = 3},
  [3266] = {.lex_state = 47, .external_lex_state = 3},
  [3267] = {.lex_state = 47, .external_lex_state = 3},
  [3268] = {.lex_state = 48, .external_lex_state = 36},
  [3269] = {.lex_state = 48, .external_lex_state = 115},
  [3270] = {.lex_state = 48, .external_lex_state = 115},
  [3271] = {.lex_state = 48, .external_lex_state = 36},
  [3272] = {.lex_state = 48, .external_lex_state = 115},
  [3273] = {.lex_state = 48, .external_lex_state = 115},
  [3274] = {.lex_state = 48, .external_lex_state = 115},
  [3275] = {.lex_state = 48, .external_lex_state = 115},
  [3276] = {.lex_state = 48, .external_lex_state = 36},
  [3277] = {.lex_state = 48, .external_lex_state = 36},
  [3278] = {.lex_state = 48, .external_lex_state = 36},
  [3279] = {.lex_state = 48, .external_lex_state = 115},
  [3280] = {.lex_state = 48, .external_lex_state = 115},
  [3281] = {.lex_state = 48, .external_lex_state = 36},
  [3282] = {.lex_state = 48, .external_lex_state = 115},
  [3283] = {.lex_state = 48, .external_lex_state = 115},
  [3284] = {.lex_state = 48, .external_lex_state = 36},
  [3285] = {.lex_state = 48, .external_lex_state = 115},
  [3286] = {.lex_state = 48, .external_lex_state = 115},
  [3287] = {.lex_state = 48, .external_lex_state = 36},
  [3288] = {.lex_state = 48, .external_lex_state = 115},
  [3289] = {.lex_state = 48, .external_lex_state = 36},
  [3290] = {.lex_state = 48, .external_lex_state = 115},
  [3291] = {.lex_state = 48, .external_lex_state = 36},
  [3292] = {.lex_state = 48, .external_lex_state = 36},
  [3293] = {.lex_state = 48, .external_lex_state = 115},
  [3294] = {.lex_state = 48, .external_lex_state = 115},
  [3295] = {.lex_state = 48, .external_lex_state = 36},
  [3296] = {.lex_state = 48, .external_lex_state = 115},
  [3297] = {.lex_state = 48, .external_lex_state = 36},
  [3298] = {.lex_state = 48, .external_lex_state = 36},
  [3299] = {.lex_state = 48, .external_lex_state = 115},
  [3300] = {.lex_state = 48, .external_lex_state = 115},
  [3301] = {.lex_state = 48, .external_lex_state = 115},
  [3302] = {.lex_state = 48, .external_lex_state = 115},
  [3303] = {.lex_state = 48, .external_lex_state = 36},
  [3304] = {.lex_state = 48, .external_lex_state = 115},
  [3305] = {.lex_state = 47, .external_lex_state = 110},
  [3306] = {.lex_state = 48, .external_lex_state = 115},
  [3307] = {.lex_state = 48, .external_lex_state = 39},
  [3308] = {.lex_state = 48, .external_lex_state = 115},
  [3309] = {.lex_state = 48, .external_lex_state = 115},
  [3310] = {.lex_state = 47, .external_lex_state = 110},
  [3311] = {.lex_state = 48, .external_lex_state = 36},
  [3312] = {.lex_state = 48, .external_lex_state = 22},
  [3313] = {.lex_state = 48, .external_lex_state = 115},
  [3314] = {.lex_state = 48, .external_lex_state = 36},
  [3315] = {.lex_state = 48, .external_lex_state = 115},
  [3316] = {.lex_state = 48, .external_lex_state = 115},
  [3317] = {.lex_state = 48, .external_lex_state = 22},
  [3318] = {.lex_state = 48, .external_lex_state = 115},
  [3319] = {.lex_state = 48, .external_lex_state = 36},
  [3320] = {.lex_state = 48, .external_lex_state = 115},
  [3321] = {.lex_state = 48, .external_lex_state = 36},
  [3322] = {.lex_state = 48, .external_lex_state = 36},
  [3323] = {.lex_state = 48, .external_lex_state = 36},
  [3324] = {.lex_state = 48, .external_lex_state = 36},
  [3325] = {.lex_state = 48, .external_lex_state = 36},
  [3326] = {.lex_state = 48, .external_lex_state = 36},
  [3327] = {.lex_state = 48, .external_lex_state = 36},
  [3328] = {.lex_state = 48, .external_lex_state = 36},
  [3329] = {.lex_state = 47, .external_lex_state = 3},
  [3330] = {.lex_state = 48, .external_lex_state = 36},
  [3331] = {.lex_state = 48, .external_lex_state = 36},
  [3332] = {.lex_state = 48, .external_lex_state = 36},
  [3333] = {.lex_state = 48, .external_lex_state = 36},
  [3334] = {.lex_state = 48, .external_lex_state = 36},
  [3335] = {.lex_state = 48, .external_lex_state = 36},
  [3336] = {.lex_state = 48, .external_lex_state = 36},
  [3337] = {.lex_state = 48, .external_lex_state = 36},
  [3338] = {.lex_state = 48, .external_lex_state = 36},
  [3339] = {.lex_state = 47, .external_lex_state = 3},
  [3340] = {.lex_state = 47, .external_lex_state = 3},
  [3341] = {.lex_state = 47, .external_lex_state = 3},
  [3342] = {.lex_state = 47, .external_lex_state = 3},
  [3343] = {.lex_state = 47, .external_lex_state = 3},
  [3344] = {.lex_state = 48, .external_lex_state = 36},
  [3345] = {.lex_state = 47, .external_lex_state = 3},
  [3346] = {.lex_state = 47, .external_lex_state = 3},
  [3347] = {.lex_state = 48, .external_lex_state = 36},
  [3348] = {.lex_state = 48, .external_lex_state = 36},
  [3349] = {.lex_state = 48, .external_lex_state = 36},
  [3350] = {.lex_state = 48, .external_lex_state = 36},
  [3351] = {.lex_state = 47, .external_lex_state = 3},
  [3352] = {.lex_state = 48, .external_lex_state = 36},
  [3353] = {.lex_state = 48, .external_lex_state = 36},
  [3354] = {.lex_state = 47, .external_lex_state = 3},
  [3355] = {.lex_state = 47, .external_lex_state = 3},
  [3356] = {.lex_state = 48, .external_lex_state = 36},
  [3357] = {.lex_state = 48, .external_lex_state = 36},
  [3358] = {.lex_state = 48, .external_lex_state = 36},
  [3359] = {.lex_state = 48, .external_lex_state = 36},
  [3360] = {.lex_state = 48, .external_lex_state = 36},
  [3361] = {.lex_state = 48, .external_lex_state = 36},
  [3362] = {.lex_state = 48, .external_lex_state = 36},
  [3363] = {.lex_state = 48, .external_lex_state = 36},
  [3364] = {.lex_state = 48, .external_lex_state = 36},
  [3365] = {.lex_state = 47, .external_lex_state = 3},
  [3366] = {.lex_state = 48, .external_lex_state = 36},
  [3367] = {.lex_state = 48, .external_lex_state = 36},
  [3368] = {.lex_state = 48, .external_lex_state = 36},
  [3369] = {.lex_state = 48, .external_lex_state = 36},
  [3370] = {.lex_state = 48, .external_lex_state = 36},
  [3371] = {.lex_state = 48, .external_lex_state = 36},
  [3372] = {.lex_state = 48, .external_lex_state = 36},
  [3373] = {.lex_state = 48, .external_lex_state = 36},
  [3374] = {.lex_state = 48, .external_lex_state = 36},
  [3375] = {.lex_state = 47, .external_lex_state = 3},
  [3376] = {.lex_state = 47, .external_lex_state = 3},
  [3377] = {.lex_state = 48, .external_lex_state = 36},
  [3378] = {.lex_state = 48, .external_lex_state = 36},
  [3379] = {.lex_state = 48, .external_lex_state = 36},
  [3380] = {.lex_state = 48, .external_lex_state = 36},
  [3381] = {.lex_state = 48, .external_lex_state = 36},
  [3382] = {.lex_state = 48, .external_lex_state = 36},
  [3383] = {.lex_state = 48, .external_lex_state = 36},
  [3384] = {.lex_state = 48, .external_lex_state = 36},
  [3385] = {.lex_state = 48, .external_lex_state = 36},
  [3386] = {.lex_state = 48, .external_lex_state = 36},
  [3387] = {.lex_state = 47, .external_lex_state = 3},
  [3388] = {.lex_state = 48, .external_lex_state = 36},
  [3389] = {.lex_state = 47, .external_lex_state = 3},
  [3390] = {.lex_state = 48, .external_lex_state = 36},
  [3391] = {.lex_state = 47, .external_lex_state = 3},
  [3392] = {.lex_state = 48, .external_lex_state = 36},
  [3393] = {.lex_state = 48, .external_lex_state = 36},
  [3394] = {.lex_state = 48, .external_lex_state = 36},
  [3395] = {.lex_state = 48, .external_lex_state = 36},
  [3396] = {.lex_state = 48, .external_lex_state = 36},
  [3397] = {.lex_state = 47, .external_lex_state = 3},
  [3398] = {.lex_state = 48, .external_lex_state = 36},
  [3399] = {.lex_state = 48, .external_lex_state = 36},
  [3400] = {.lex_state = 48, .external_lex_state = 36},
  [3401] = {.lex_state = 48, .external_lex_state = 36},
  [3402] = {.lex_state = 48, .external_lex_state = 36},
  [3403] = {.lex_state = 47, .external_lex_state = 3},
  [3404] = {.lex_state = 48, .external_lex_state = 36},
  [3405] = {.lex_state = 47, .external_lex_state = 3},
  [3406] = {.lex_state = 48, .external_lex_state = 36},
  [3407] = {.lex_state = 48, .external_lex_state = 36},
  [3408] = {.lex_state = 48, .external_lex_state = 36},
  [3409] = {.lex_state = 47, .external_lex_state = 3},
  [3410] = {.lex_state = 48, .external_lex_state = 36},
  [3411] = {.lex_state = 47, .external_lex_state = 3},
  [3412] = {.lex_state = 48, .external_lex_state = 36},
  [3413] = {.lex_state = 48, .external_lex_state = 36},
  [3414] = {.lex_state = 48, .external_lex_state = 36},
  [3415] = {.lex_state = 47, .external_lex_state = 3},
  [3416] = {.lex_state = 48, .external_lex_state = 36},
  [3417] = {.lex_state = 48, .external_lex_state = 36},
  [3418] = {.lex_state = 48, .external_lex_state = 36},
  [3419] = {.lex_state = 47, .external_lex_state = 3},
  [3420] = {.lex_state = 47, .external_lex_state = 98},
  [3421] = {.lex_state = 47, .external_lex_state = 98},
  [3422] = {.lex_state = 47, .external_lex_state = 98},
  [3423] = {.lex_state = 48, .external_lex_state = 36},
  [3424] = {.lex_state = 48, .external_lex_state = 36},
  [3425] = {.lex_state = 47, .external_lex_state = 3},
  [3426] = {.lex_state = 48, .external_lex_state = 36},
  [3427] = {.lex_state = 48, .external_lex_state = 36},
  [3428] = {.lex_state = 47, .external_lex_state = 3},
  [3429] = {.lex_state = 47, .external_lex_state = 3},
  [3430] = {.lex_state = 47, .external_lex_state = 3},
  [3431] = {.lex_state = 47, .external_lex_state = 3},
  [3432] = {.lex_state = 47, .external_lex_state = 3},
  [3433] = {.lex_state = 47, .external_lex_state = 3},
  [3434] = {.lex_state = 48, .external_lex_state = 36},
  [3435] = {.lex_state = 48, .external_lex_state = 36},
  [3436] = {.lex_state = 47, .external_lex_state = 3},
  [3437] = {.lex_state = 48, .external_lex_state = 36},
  [3438] = {.lex_state = 47, .external_lex_state = 3},
  [3439] = {.lex_state = 47, .external_lex_state = 3},
  [3440] = {.lex_state = 47, .external_lex_state = 3},
  [3441] = {.lex_state = 47, .external_lex_state = 3},
  [3442] = {.lex_state = 47, .external_lex_state = 3},
  [3443] = {.lex_state = 48, .external_lex_state = 36},
  [3444] = {.lex_state = 48, .external_lex_state = 36},
  [3445] = {.lex_state = 48, .external_lex_state = 36},
  [3446] = {.lex_state = 48, .external_lex_state = 36},
  [3447] = {.lex_state = 48, .external_lex_state = 36},
  [3448] = {.lex_state = 48, .external_lex_state = 36},
  [3449] = {.lex_state = 47, .external_lex_state = 3},
  [3450] = {.lex_state = 47, .external_lex_state = 3},
  [3451] = {.lex_state = 47, .external_lex_state = 3},
  [3452] = {.lex_state = 47, .external_lex_state = 3},
  [3453] = {.lex_state = 48, .external_lex_state = 36},
  [3454] = {.lex_state = 48, .external_lex_state = 36},
  [3455] = {.lex_state = 47, .external_lex_state = 3},
  [3456] = {.lex_state = 48, .external_lex_state = 36},
  [3457] = {.lex_state = 47, .external_lex_state = 3},
  [3458] = {.lex_state = 47, .external_lex_state = 3},
  [3459] = {.lex_state = 48, .external_lex_state = 36},
  [3460] = {.lex_state = 48, .external_lex_state = 36},
  [3461] = {.lex_state = 47, .external_lex_state = 3},
  [3462] = {.lex_state = 47, .external_lex_state = 3},
  [3463] = {.lex_state = 47, .external_lex_state = 3},
  [3464] = {.lex_state = 48, .external_lex_state = 36},
  [3465] = {.lex_state = 48, .external_lex_state = 36},
  [3466] = {.lex_state = 48, .external_lex_state = 36},
  [3467] = {.lex_state = 48, .external_lex_state = 36},
  [3468] = {.lex_state = 54, .external_lex_state = 116},
  [3469] = {.lex_state = 53, .external_lex_state = 117},
  [3470] = {.lex_state = 54, .external_lex_state = 118},
  [3471] = {.lex_state = 54, .external_lex_state = 119},
  [3472] = {.lex_state = 54, .external_lex_state = 116},
  [3473] = {.lex_state = 54, .external_lex_state = 116},
  [3474] = {.lex_state = 53, .external_lex_state = 120},
  [3475] = {.lex_state = 54, .external_lex_state = 118},
  [3476] = {.lex_state = 54, .external_lex_state = 119},
  [3477] = {.lex_state = 54, .external_lex_state = 119},
  [3478] = {.lex_state = 54, .external_lex_state = 118},
  [3479] = {.lex_state = 47, .external_lex_state = 3},
  [3480] = {.lex_state = 47, .external_lex_state = 3},
  [3481] = {.lex_state = 54, .external_lex_state = 10},
  [3482] = {.lex_state = 54, .external_lex_state = 10},
  [3483] = {.lex_state = 48, .external_lex_state = 36},
  [3484] = {.lex_state = 48, .external_lex_state = 36},
  [3485] = {.lex_state = 48, .external_lex_state = 36},
  [3486] = {.lex_state = 47, .external_lex_state = 3},
  [3487] = {.lex_state = 47, .external_lex_state = 3},
  [3488] = {.lex_state = 47, .external_lex_state = 3},
  [3489] = {.lex_state = 54, .external_lex_state = 10},
  [3490] = {.lex_state = 47, .external_lex_state = 3},
  [3491] = {.lex_state = 48, .external_lex_state = 36},
  [3492] = {.lex_state = 47, .external_lex_state = 3},
  [3493] = {.lex_state = 48, .external_lex_state = 36},
  [3494] = {.lex_state = 48, .external_lex_state = 36},
  [3495] = {.lex_state = 54, .external_lex_state = 120},
  [3496] = {.lex_state = 48, .external_lex_state = 36},
  [3497] = {.lex_state = 47, .external_lex_state = 3},
  [3498] = {.lex_state = 48, .external_lex_state = 36},
  [3499] = {.lex_state = 48, .external_lex_state = 36},
  [3500] = {.lex_state = 48, .external_lex_state = 36},
  [3501] = {.lex_state = 47, .external_lex_state = 3},
  [3502] = {.lex_state = 47, .external_lex_state = 3},
  [3503] = {.lex_state = 47, .external_lex_state = 3},
  [3504] = {.lex_state = 47, .external_lex_state = 3},
  [3505] = {.lex_state = 47, .external_lex_state = 3},
  [3506] = {.lex_state = 47, .external_lex_state = 3},
  [3507] = {.lex_state = 48, .external_lex_state = 36},
  [3508] = {.lex_state = 48, .external_lex_state = 36},
  [3509] = {.lex_state = 47, .external_lex_state = 3},
  [3510] = {.lex_state = 47, .external_lex_state = 3},
  [3511] = {.lex_state = 54, .external_lex_state = 10},
  [3512] = {.lex_state = 48, .external_lex_state = 36},
  [3513] = {.lex_state = 48, .external_lex_state = 36},
  [3514] = {.lex_state = 54, .external_lex_state = 9},
  [3515] = {.lex_state = 47, .external_lex_state = 3},
  [3516] = {.lex_state = 48, .external_lex_state = 36},
  [3517] = {.lex_state = 48, .external_lex_state = 36},
  [3518] = {.lex_state = 47, .external_lex_state = 3},
  [3519] = {.lex_state = 48, .external_lex_state = 36},
  [3520] = {.lex_state = 48, .external_lex_state = 36},
  [3521] = {.lex_state = 48, .external_lex_state = 36},
  [3522] = {.lex_state = 47, .external_lex_state = 3},
  [3523] = {.lex_state = 48, .external_lex_state = 36},
  [3524] = {.lex_state = 47, .external_lex_state = 3},
  [3525] = {.lex_state = 47, .external_lex_state = 3},
  [3526] = {.lex_state = 47, .external_lex_state = 3},
  [3527] = {.lex_state = 48, .external_lex_state = 36},
  [3528] = {.lex_state = 48, .external_lex_state = 36},
  [3529] = {.lex_state = 48, .external_lex_state = 36},
  [3530] = {.lex_state = 48, .external_lex_state = 36},
  [3531] = {.lex_state = 48, .external_lex_state = 36},
  [3532] = {.lex_state = 48, .external_lex_state = 36},
  [3533] = {.lex_state = 54, .external_lex_state = 9},
  [3534] = {.lex_state = 47, .external_lex_state = 3},
  [3535] = {.lex_state = 48, .external_lex_state = 36},
  [3536] = {.lex_state = 48, .external_lex_state = 36},
  [3537] = {.lex_state = 47, .external_lex_state = 3},
  [3538] = {.lex_state = 48, .external_lex_state = 36},
  [3539] = {.lex_state = 48, .external_lex_state = 36},
  [3540] = {.lex_state = 47, .external_lex_state = 3},
  [3541] = {.lex_state = 54, .external_lex_state = 117},
  [3542] = {.lex_state = 47, .external_lex_state = 3},
  [3543] = {.lex_state = 54, .external_lex_state = 10},
  [3544] = {.lex_state = 47, .external_lex_state = 3},
  [3545] = {.lex_state = 48, .external_lex_state = 36},
  [3546] = {.lex_state = 54, .external_lex_state = 10},
  [3547] = {.lex_state = 54, .external_lex_state = 9},
  [3548] = {.lex_state = 47, .external_lex_state = 3},
  [3549] = {.lex_state = 54, .external_lex_state = 10},
  [3550] = {.lex_state = 47, .external_lex_state = 3},
  [3551] = {.lex_state = 47, .external_lex_state = 3},
  [3552] = {.lex_state = 47, .external_lex_state = 3},
  [3553] = {.lex_state = 48, .external_lex_state = 36},
  [3554] = {.lex_state = 53, .external_lex_state = 121},
  [3555] = {.lex_state = 48, .external_lex_state = 36},
  [3556] = {.lex_state = 47, .external_lex_state = 3},
  [3557] = {.lex_state = 47, .external_lex_state = 3},
  [3558] = {.lex_state = 48, .external_lex_state = 36},
  [3559] = {.lex_state = 48, .external_lex_state = 36},
  [3560] = {.lex_state = 47, .external_lex_state = 3},
  [3561] = {.lex_state = 48, .external_lex_state = 36},
  [3562] = {.lex_state = 54, .external_lex_state = 10},
  [3563] = {.lex_state = 48, .external_lex_state = 36},
  [3564] = {.lex_state = 48, .external_lex_state = 36},
  [3565] = {.lex_state = 47, .external_lex_state = 3},
  [3566] = {.lex_state = 48, .external_lex_state = 36},
  [3567] = {.lex_state = 47, .external_lex_state = 3},
  [3568] = {.lex_state = 47, .external_lex_state = 3},
  [3569] = {.lex_state = 48, .external_lex_state = 36},
  [3570] = {.lex_state = 48, .external_lex_state = 36},
  [3571] = {.lex_state = 48, .external_lex_state = 36},
  [3572] = {.lex_state = 48, .external_lex_state = 36},
  [3573] = {.lex_state = 48, .external_lex_state = 36},
  [3574] = {.lex_state = 48, .external_lex_state = 36},
  [3575] = {.lex_state = 47, .external_lex_state = 3},
  [3576] = {.lex_state = 54, .external_lex_state = 10},
  [3577] = {.lex_state = 54, .external_lex_state = 10},
  [3578] = {.lex_state = 48, .external_lex_state = 36},
  [3579] = {.lex_state = 47, .external_lex_state = 3},
  [3580] = {.lex_state = 48, .external_lex_state = 36},
  [3581] = {.lex_state = 48, .external_lex_state = 36},
  [3582] = {.lex_state = 48, .external_lex_state = 36},
  [3583] = {.lex_state = 48, .external_lex_state = 36},
  [3584] = {.lex_state = 47, .external_lex_state = 3},
  [3585] = {.lex_state = 48, .external_lex_state = 36},
  [3586] = {.lex_state = 47, .external_lex_state = 3},
  [3587] = {.lex_state = 48, .external_lex_state = 36},
  [3588] = {.lex_state = 48, .external_lex_state = 36},
  [3589] = {.lex_state = 47, .external_lex_state = 3},
  [3590] = {.lex_state = 47, .external_lex_state = 3},
  [3591] = {.lex_state = 54, .external_lex_state = 10},
  [3592] = {.lex_state = 48, .external_lex_state = 36},
  [3593] = {.lex_state = 48, .external_lex_state = 36},
  [3594] = {.lex_state = 48, .external_lex_state = 36},
  [3595] = {.lex_state = 54, .external_lex_state = 9},
  [3596] = {.lex_state = 47, .external_lex_state = 3},
  [3597] = {.lex_state = 54, .external_lex_state = 9},
  [3598] = {.lex_state = 47, .external_lex_state = 3},
  [3599] = {.lex_state = 47, .external_lex_state = 3},
  [3600] = {.lex_state = 54, .external_lex_state = 116},
  [3601] = {.lex_state = 54, .external_lex_state = 9},
  [3602] = {.lex_state = 54, .external_lex_state = 9},
  [3603] = {.lex_state = 48, .external_lex_state = 36},
  [3604] = {.lex_state = 48, .external_lex_state = 36},
  [3605] = {.lex_state = 48, .external_lex_state = 36},
  [3606] = {.lex_state = 54, .external_lex_state = 10},
  [3607] = {.lex_state = 48, .external_lex_state = 36},
  [3608] = {.lex_state = 54, .external_lex_state = 9},
  [3609] = {.lex_state = 54, .external_lex_state = 9},
  [3610] = {.lex_state = 48, .external_lex_state = 36},
  [3611] = {.lex_state = 48, .external_lex_state = 36},
  [3612] = {.lex_state = 47, .external_lex_state = 3},
  [3613] = {.lex_state = 47, .external_lex_state = 3},
  [3614] = {.lex_state = 48, .external_lex_state = 36},
  [3615] = {.lex_state = 48, .external_lex_state = 36},
  [3616] = {.lex_state = 47, .external_lex_state = 3},
  [3617] = {.lex_state = 54, .external_lex_state = 9},
  [3618] = {.lex_state = 47, .external_lex_state = 3},
  [3619] = {.lex_state = 54, .external_lex_state = 10},
  [3620] = {.lex_state = 47, .external_lex_state = 3},
  [3621] = {.lex_state = 47, .external_lex_state = 3},
  [3622] = {.lex_state = 48, .external_lex_state = 36},
  [3623] = {.lex_state = 47, .external_lex_state = 3},
  [3624] = {.lex_state = 48, .external_lex_state = 36},
  [3625] = {.lex_state = 48, .external_lex_state = 36},
  [3626] = {.lex_state = 47, .external_lex_state = 3},
  [3627] = {.lex_state = 47, .external_lex_state = 3},
  [3628] = {.lex_state = 54, .external_lex_state = 10},
  [3629] = {.lex_state = 48, .external_lex_state = 36},
  [3630] = {.lex_state = 47, .external_lex_state = 3},
  [3631] = {.lex_state = 47, .external_lex_state = 3},
  [3632] = {.lex_state = 47, .external_lex_state = 122},
  [3633] = {.lex_state = 48, .external_lex_state = 36},
  [3634] = {.lex_state = 48, .external_lex_state = 36},
  [3635] = {.lex_state = 48, .external_lex_state = 36},
  [3636] = {.lex_state = 48, .external_lex_state = 36},
  [3637] = {.lex_state = 47, .external_lex_state = 3},
  [3638] = {.lex_state = 47, .external_lex_state = 3},
  [3639] = {.lex_state = 47, .external_lex_state = 3},
  [3640] = {.lex_state = 47, .external_lex_state = 3},
  [3641] = {.lex_state = 47, .external_lex_state = 3},
  [3642] = {.lex_state = 47, .external_lex_state = 3},
  [3643] = {.lex_state = 48, .external_lex_state = 36},
  [3644] = {.lex_state = 48, .external_lex_state = 36},
  [3645] = {.lex_state = 48, .external_lex_state = 36},
  [3646] = {.lex_state = 47, .external_lex_state = 3},
  [3647] = {.lex_state = 54, .external_lex_state = 9},
  [3648] = {.lex_state = 48, .external_lex_state = 36},
  [3649] = {.lex_state = 47, .external_lex_state = 3},
  [3650] = {.lex_state = 48, .external_lex_state = 36},
  [3651] = {.lex_state = 54, .external_lex_state = 9},
  [3652] = {.lex_state = 47, .external_lex_state = 3},
  [3653] = {.lex_state = 48, .external_lex_state = 36},
  [3654] = {.lex_state = 48, .external_lex_state = 36},
  [3655] = {.lex_state = 48, .external_lex_state = 36},
  [3656] = {.lex_state = 54, .external_lex_state = 10},
  [3657] = {.lex_state = 47, .external_lex_state = 3},
  [3658] = {.lex_state = 48, .external_lex_state = 36},
  [3659] = {.lex_state = 48, .external_lex_state = 36},
  [3660] = {.lex_state = 48, .external_lex_state = 36},
  [3661] = {.lex_state = 54, .external_lex_state = 5},
  [3662] = {.lex_state = 54, .external_lex_state = 9},
  [3663] = {.lex_state = 47, .external_lex_state = 3},
  [3664] = {.lex_state = 47, .external_lex_state = 3},
  [3665] = {.lex_state = 47, .external_lex_state = 3},
  [3666] = {.lex_state = 48, .external_lex_state = 36},
  [3667] = {.lex_state = 48, .external_lex_state = 36},
  [3668] = {.lex_state = 54, .external_lex_state = 9},
  [3669] = {.lex_state = 47, .external_lex_state = 3},
  [3670] = {.lex_state = 47, .external_lex_state = 3},
  [3671] = {.lex_state = 48, .external_lex_state = 36},
  [3672] = {.lex_state = 47, .external_lex_state = 3},
  [3673] = {.lex_state = 54, .external_lex_state = 10},
  [3674] = {.lex_state = 48, .external_lex_state = 36},
  [3675] = {.lex_state = 48, .external_lex_state = 36},
  [3676] = {.lex_state = 48, .external_lex_state = 36},
  [3677] = {.lex_state = 54, .external_lex_state = 10},
  [3678] = {.lex_state = 47, .external_lex_state = 3},
  [3679] = {.lex_state = 47, .external_lex_state = 3},
  [3680] = {.lex_state = 47, .external_lex_state = 3},
  [3681] = {.lex_state = 47, .external_lex_state = 3},
  [3682] = {.lex_state = 47, .external_lex_state = 3},
  [3683] = {.lex_state = 47, .external_lex_state = 3},
  [3684] = {.lex_state = 47, .external_lex_state = 3},
  [3685] = {.lex_state = 54, .external_lex_state = 9},
  [3686] = {.lex_state = 47, .external_lex_state = 3},
  [3687] = {.lex_state = 48, .external_lex_state = 36},
  [3688] = {.lex_state = 48, .external_lex_state = 36},
  [3689] = {.lex_state = 48, .external_lex_state = 36},
  [3690] = {.lex_state = 48, .external_lex_state = 36},
  [3691] = {.lex_state = 47, .external_lex_state = 3},
  [3692] = {.lex_state = 54, .external_lex_state = 116},
  [3693] = {.lex_state = 48, .external_lex_state = 36},
  [3694] = {.lex_state = 48, .external_lex_state = 36},
  [3695] = {.lex_state = 48, .external_lex_state = 36},
  [3696] = {.lex_state = 47, .external_lex_state = 3},
  [3697] = {.lex_state = 48, .external_lex_state = 36},
  [3698] = {.lex_state = 48, .external_lex_state = 36},
  [3699] = {.lex_state = 54, .external_lex_state = 9},
  [3700] = {.lex_state = 48, .external_lex_state = 36},
  [3701] = {.lex_state = 54, .external_lex_state = 10},
  [3702] = {.lex_state = 48, .external_lex_state = 36},
  [3703] = {.lex_state = 54, .external_lex_state = 5},
  [3704] = {.lex_state = 47, .external_lex_state = 3},
  [3705] = {.lex_state = 54, .external_lex_state = 116},
  [3706] = {.lex_state = 48, .external_lex_state = 36},
  [3707] = {.lex_state = 47, .external_lex_state = 3},
  [3708] = {.lex_state = 54, .external_lex_state = 9},
  [3709] = {.lex_state = 48, .external_lex_state = 36},
  [3710] = {.lex_state = 47, .external_lex_state = 3},
  [3711] = {.lex_state = 47, .external_lex_state = 3},
  [3712] = {.lex_state = 47, .external_lex_state = 3},
  [3713] = {.lex_state = 47, .external_lex_state = 3},
  [3714] = {.lex_state = 47, .external_lex_state = 3},
  [3715] = {.lex_state = 48, .external_lex_state = 36},
  [3716] = {.lex_state = 47, .external_lex_state = 3},
  [3717] = {.lex_state = 47, .external_lex_state = 3},
  [3718] = {.lex_state = 47, .external_lex_state = 3},
  [3719] = {.lex_state = 47, .external_lex_state = 3},
  [3720] = {.lex_state = 48, .external_lex_state = 36},
  [3721] = {.lex_state = 47, .external_lex_state = 3},
  [3722] = {.lex_state = 48, .external_lex_state = 36},
  [3723] = {.lex_state = 47, .external_lex_state = 3},
  [3724] = {.lex_state = 48, .external_lex_state = 36},
  [3725] = {.lex_state = 48, .external_lex_state = 36},
  [3726] = {.lex_state = 48, .external_lex_state = 36},
  [3727] = {.lex_state = 48, .external_lex_state = 36},
  [3728] = {.lex_state = 48, .external_lex_state = 36},
  [3729] = {.lex_state = 48, .external_lex_state = 36},
  [3730] = {.lex_state = 48, .external_lex_state = 36},
  [3731] = {.lex_state = 47, .external_lex_state = 3},
  [3732] = {.lex_state = 48, .external_lex_state = 36},
  [3733] = {.lex_state = 54, .external_lex_state = 9},
  [3734] = {.lex_state = 54, .external_lex_state = 9},
  [3735] = {.lex_state = 54, .external_lex_state = 9},
  [3736] = {.lex_state = 54, .external_lex_state = 123},
  [3737] = {.lex_state = 54, .external_lex_state = 9},
  [3738] = {.lex_state = 54, .external_lex_state = 9},
  [3739] = {.lex_state = 54, .external_lex_state = 9},
  [3740] = {.lex_state = 54, .external_lex_state = 9},
  [3741] = {.lex_state = 54, .external_lex_state = 123},
  [3742] = {.lex_state = 54, .external_lex_state = 9},
  [3743] = {.lex_state = 54, .external_lex_state = 9},
  [3744] = {.lex_state = 54, .external_lex_state = 9},
  [3745] = {.lex_state = 54, .external_lex_state = 9},
  [3746] = {.lex_state = 54, .external_lex_state = 9},
  [3747] = {.lex_state = 54, .external_lex_state = 9},
  [3748] = {.lex_state = 54, .external_lex_state = 9},
  [3749] = {.lex_state = 54, .external_lex_state = 9},
  [3750] = {.lex_state = 54, .external_lex_state = 9},
  [3751] = {.lex_state = 54, .external_lex_state = 9},
  [3752] = {.lex_state = 54, .external_lex_state = 9},
  [3753] = {.lex_state = 54, .external_lex_state = 9},
  [3754] = {.lex_state = 54, .external_lex_state = 9},
  [3755] = {.lex_state = 54, .external_lex_state = 123},
  [3756] = {.lex_state = 54, .external_lex_state = 9},
  [3757] = {.lex_state = 54, .external_lex_state = 9},
  [3758] = {.lex_state = 54, .external_lex_state = 9},
  [3759] = {.lex_state = 54, .external_lex_state = 119},
  [3760] = {.lex_state = 54, .external_lex_state = 9},
  [3761] = {.lex_state = 54, .external_lex_state = 9},
  [3762] = {.lex_state = 54, .external_lex_state = 9},
  [3763] = {.lex_state = 54, .external_lex_state = 9},
  [3764] = {.lex_state = 54, .external_lex_state = 9},
  [3765] = {.lex_state = 54, .external_lex_state = 9},
  [3766] = {.lex_state = 54, .external_lex_state = 9},
  [3767] = {.lex_state = 54, .external_lex_state = 9},
  [3768] = {.lex_state = 54, .external_lex_state = 9},
  [3769] = {.lex_state = 54, .external_lex_state = 121},
  [3770] = {.lex_state = 54, .external_lex_state = 9},
  [3771] = {.lex_state = 54, .external_lex_state = 9},
  [3772] = {.lex_state = 54, .external_lex_state = 9},
  [3773] = {.lex_state = 54, .external_lex_state = 9},
  [3774] = {.lex_state = 54, .external_lex_state = 9},
  [3775] = {.lex_state = 54, .external_lex_state = 9},
  [3776] = {.lex_state = 54, .external_lex_state = 9},
  [3777] = {.lex_state = 54, .external_lex_state = 119},
  [3778] = {.lex_state = 54, .external_lex_state = 9},
  [3779] = {.lex_state = 54, .external_lex_state = 9},
  [3780] = {.lex_state = 47, .external_lex_state = 124},
  [3781] = {.lex_state = 54, .external_lex_state = 9},
  [3782] = {.lex_state = 54, .external_lex_state = 9},
  [3783] = {.lex_state = 54, .external_lex_state = 9},
  [3784] = {.lex_state = 54, .external_lex_state = 9},
  [3785] = {.lex_state = 54, .external_lex_state = 9},
  [3786] = {.lex_state = 54, .external_lex_state = 119},
  [3787] = {.lex_state = 54, .external_lex_state = 9},
  [3788] = {.lex_state = 54, .external_lex_state = 9},
  [3789] = {.lex_state = 54, .external_lex_state = 10},
  [3790] = {.lex_state = 53, .external_lex_state = 117},
  [3791] = {.lex_state = 54, .external_lex_state = 10},
  [3792] = {.lex_state = 54, .external_lex_state = 10},
  [3793] = {.lex_state = 54, .external_lex_state = 10},
  [3794] = {.lex_state = 54, .external_lex_state = 10},
  [3795] = {.lex_state = 54, .external_lex_state = 125},
  [3796] = {.lex_state = 54, .external_lex_state = 10},
  [3797] = {.lex_state = 54, .external_lex_state = 10},
  [3798] = {.lex_state = 54, .external_lex_state = 10},
  [3799] = {.lex_state = 47, .external_lex_state = 9},
  [3800] = {.lex_state = 54, .external_lex_state = 10},
  [3801] = {.lex_state = 47, .external_lex_state = 9},
  [3802] = {.lex_state = 54, .external_lex_state = 10},
  [3803] = {.lex_state = 54, .external_lex_state = 10},
  [3804] = {.lex_state = 54, .external_lex_state = 10},
  [3805] = {.lex_state = 54, .external_lex_state = 10},
  [3806] = {.lex_state = 54, .external_lex_state = 10},
  [3807] = {.lex_state = 54, .external_lex_state = 10},
  [3808] = {.lex_state = 54, .external_lex_state = 10},
  [3809] = {.lex_state = 47, .external_lex_state = 9},
  [3810] = {.lex_state = 54, .external_lex_state = 10},
  [3811] = {.lex_state = 53, .external_lex_state = 120},
  [3812] = {.lex_state = 54, .external_lex_state = 10},
  [3813] = {.lex_state = 47, .external_lex_state = 9},
  [3814] = {.lex_state = 54, .external_lex_state = 10},
  [3815] = {.lex_state = 54, .external_lex_state = 10},
  [3816] = {.lex_state = 54, .external_lex_state = 10},
  [3817] = {.lex_state = 54, .external_lex_state = 5},
  [3818] = {.lex_state = 54, .external_lex_state = 126},
  [3819] = {.lex_state = 54, .external_lex_state = 125},
  [3820] = {.lex_state = 54, .external_lex_state = 126},
  [3821] = {.lex_state = 54, .external_lex_state = 125},
  [3822] = {.lex_state = 54, .external_lex_state = 10},
  [3823] = {.lex_state = 54, .external_lex_state = 126},
  [3824] = {.lex_state = 47, .external_lex_state = 9},
  [3825] = {.lex_state = 47, .external_lex_state = 9},
  [3826] = {.lex_state = 54, .external_lex_state = 10},
  [3827] = {.lex_state = 54, .external_lex_state = 10},
  [3828] = {.lex_state = 54, .external_lex_state = 10},
  [3829] = {.lex_state = 47, .external_lex_state = 9},
  [3830] = {.lex_state = 54, .external_lex_state = 10},
  [3831] = {.lex_state = 54, .external_lex_state = 10},
  [3832] = {.lex_state = 47, .external_lex_state = 9},
  [3833] = {.lex_state = 54, .external_lex_state = 10},
  [3834] = {.lex_state = 54, .external_lex_state = 10},
  [3835] = {.lex_state = 54, .external_lex_state = 10},
  [3836] = {.lex_state = 54, .external_lex_state = 10},
  [3837] = {.lex_state = 54, .external_lex_state = 10},
  [3838] = {.lex_state = 54, .external_lex_state = 10},
  [3839] = {.lex_state = 54, .external_lex_state = 10},
  [3840] = {.lex_state = 54, .external_lex_state = 10},
  [3841] = {.lex_state = 54, .external_lex_state = 10},
  [3842] = {.lex_state = 54, .external_lex_state = 10},
  [3843] = {.lex_state = 47, .external_lex_state = 9},
  [3844] = {.lex_state = 54, .external_lex_state = 10},
  [3845] = {.lex_state = 53, .external_lex_state = 8},
  [3846] = {.lex_state = 54, .external_lex_state = 10},
  [3847] = {.lex_state = 54, .external_lex_state = 10},
  [3848] = {.lex_state = 54, .external_lex_state = 10},
  [3849] = {.lex_state = 54, .external_lex_state = 10},
  [3850] = {.lex_state = 54, .external_lex_state = 10},
  [3851] = {.lex_state = 54, .external_lex_state = 10},
  [3852] = {.lex_state = 54, .external_lex_state = 10},
  [3853] = {.lex_state = 47, .external_lex_state = 9},
  [3854] = {.lex_state = 54, .external_lex_state = 10},
  [3855] = {.lex_state = 54, .external_lex_state = 10},
  [3856] = {.lex_state = 54, .external_lex_state = 8},
  [3857] = {.lex_state = 54, .external_lex_state = 127},
  [3858] = {.lex_state = 47, .external_lex_state = 10},
  [3859] = {.lex_state = 54, .external_lex_state = 8},
  [3860] = {.lex_state = 54, .external_lex_state = 128},
  [3861] = {.lex_state = 54, .external_lex_state = 127},
  [3862] = {.lex_state = 54, .external_lex_state = 129},
  [3863] = {.lex_state = 54, .external_lex_state = 128},
  [3864] = {.lex_state = 47, .external_lex_state = 10},
  [3865] = {.lex_state = 54, .external_lex_state = 8},
  [3866] = {.lex_state = 54, .external_lex_state = 130},
  [3867] = {.lex_state = 54, .external_lex_state = 8},
  [3868] = {.lex_state = 47, .external_lex_state = 10},
  [3869] = {.lex_state = 47, .external_lex_state = 10},
  [3870] = {.lex_state = 54, .external_lex_state = 8},
  [3871] = {.lex_state = 47, .external_lex_state = 131},
  [3872] = {.lex_state = 54, .external_lex_state = 8},
  [3873] = {.lex_state = 54, .external_lex_state = 127},
  [3874] = {.lex_state = 54, .external_lex_state = 129},
  [3875] = {.lex_state = 54, .external_lex_state = 8},
  [3876] = {.lex_state = 54, .external_lex_state = 8},
  [3877] = {.lex_state = 54, .external_lex_state = 132},
  [3878] = {.lex_state = 47, .external_lex_state = 10},
  [3879] = {.lex_state = 54, .external_lex_state = 8},
  [3880] = {.lex_state = 54, .external_lex_state = 127},
  [3881] = {.lex_state = 54, .external_lex_state = 8},
  [3882] = {.lex_state = 54, .external_lex_state = 130},
  [3883] = {.lex_state = 47, .external_lex_state = 10},
  [3884] = {.lex_state = 54, .external_lex_state = 8},
  [3885] = {.lex_state = 54, .external_lex_state = 132},
  [3886] = {.lex_state = 47, .external_lex_state = 10},
  [3887] = {.lex_state = 54, .external_lex_state = 130},
  [3888] = {.lex_state = 54, .external_lex_state = 128},
  [3889] = {.lex_state = 54, .external_lex_state = 8},
  [3890] = {.lex_state = 54, .external_lex_state = 8},
  [3891] = {.lex_state = 54, .external_lex_state = 127},
  [3892] = {.lex_state = 54, .external_lex_state = 127},
  [3893] = {.lex_state = 54, .external_lex_state = 8},
  [3894] = {.lex_state = 54, .external_lex_state = 8},
  [3895] = {.lex_state = 54, .external_lex_state = 132},
  [3896] = {.lex_state = 54, .external_lex_state = 5},
  [3897] = {.lex_state = 47, .external_lex_state = 10},
  [3898] = {.lex_state = 47, .external_lex_state = 10},
  [3899] = {.lex_state = 54, .external_lex_state = 8},
  [3900] = {.lex_state = 54, .external_lex_state = 129},
  [3901] = {.lex_state = 54, .external_lex_state = 8},
  [3902] = {.lex_state = 53, .external_lex_state = 121},
  [3903] = {.lex_state = 47, .external_lex_state = 10},
  [3904] = {.lex_state = 54, .external_lex_state = 8},
  [3905] = {.lex_state = 54, .external_lex_state = 11},
  [3906] = {.lex_state = 54, .external_lex_state = 133},
  [3907] = {.lex_state = 54, .external_lex_state = 11},
  [3908] = {.lex_state = 53, .external_lex_state = 8},
  [3909] = {.lex_state = 54, .external_lex_state = 11},
  [3910] = {.lex_state = 54, .external_lex_state = 11},
  [3911] = {.lex_state = 54, .external_lex_state = 134},
  [3912] = {.lex_state = 54, .external_lex_state = 135},
  [3913] = {.lex_state = 54, .external_lex_state = 11},
  [3914] = {.lex_state = 54, .external_lex_state = 11},
  [3915] = {.lex_state = 54, .external_lex_state = 11},
  [3916] = {.lex_state = 54, .external_lex_state = 11},
  [3917] = {.lex_state = 54, .external_lex_state = 136},
  [3918] = {.lex_state = 54, .external_lex_state = 137},
  [3919] = {.lex_state = 54, .external_lex_state = 11},
  [3920] = {.lex_state = 54, .external_lex_state = 133},
  [3921] = {.lex_state = 54, .external_lex_state = 11},
  [3922] = {.lex_state = 54, .external_lex_state = 11},
  [3923] = {.lex_state = 54, .external_lex_state = 138},
  [3924] = {.lex_state = 54, .external_lex_state = 11},
  [3925] = {.lex_state = 54, .external_lex_state = 11},
  [3926] = {.lex_state = 54, .external_lex_state = 138},
  [3927] = {.lex_state = 48, .external_lex_state = 111},
  [3928] = {.lex_state = 48, .external_lex_state = 111},
  [3929] = {.lex_state = 54, .external_lex_state = 11},
  [3930] = {.lex_state = 54, .external_lex_state = 11},
  [3931] = {.lex_state = 54, .external_lex_state = 133},
  [3932] = {.lex_state = 54, .external_lex_state = 11},
  [3933] = {.lex_state = 48, .external_lex_state = 111},
  [3934] = {.lex_state = 54, .external_lex_state = 11},
  [3935] = {.lex_state = 54, .external_lex_state = 11},
  [3936] = {.lex_state = 54, .external_lex_state = 11},
  [3937] = {.lex_state = 54, .external_lex_state = 138},
  [3938] = {.lex_state = 54, .external_lex_state = 11},
  [3939] = {.lex_state = 54, .external_lex_state = 11},
  [3940] = {.lex_state = 54, .external_lex_state = 11},
  [3941] = {.lex_state = 54, .external_lex_state = 11},
  [3942] = {.lex_state = 54, .external_lex_state = 11},
  [3943] = {.lex_state = 54, .external_lex_state = 139},
  [3944] = {.lex_state = 54, .external_lex_state = 140},
  [3945] = {.lex_state = 54, .external_lex_state = 11},
  [3946] = {.lex_state = 54, .external_lex_state = 133},
  [3947] = {.lex_state = 54, .external_lex_state = 11},
  [3948] = {.lex_state = 54, .external_lex_state = 11},
  [3949] = {.lex_state = 54, .external_lex_state = 11},
  [3950] = {.lex_state = 54, .external_lex_state = 136},
  [3951] = {.lex_state = 54, .external_lex_state = 11},
  [3952] = {.lex_state = 54, .external_lex_state = 141},
  [3953] = {.lex_state = 54, .external_lex_state = 11},
  [3954] = {.lex_state = 54, .external_lex_state = 11},
  [3955] = {.lex_state = 54, .external_lex_state = 11},
  [3956] = {.lex_state = 54, .external_lex_state = 11},
  [3957] = {.lex_state = 54, .external_lex_state = 136},
  [3958] = {.lex_state = 54, .external_lex_state = 11},
  [3959] = {.lex_state = 54, .external_lex_state = 141},
  [3960] = {.lex_state = 53, .external_lex_state = 14},
  [3961] = {.lex_state = 54, .external_lex_state = 11},
  [3962] = {.lex_state = 54, .external_lex_state = 11},
  [3963] = {.lex_state = 48, .external_lex_state = 111},
  [3964] = {.lex_state = 54, .external_lex_state = 11},
  [3965] = {.lex_state = 54, .external_lex_state = 11},
  [3966] = {.lex_state = 54, .external_lex_state = 11},
  [3967] = {.lex_state = 54, .external_lex_state = 11},
  [3968] = {.lex_state = 54, .external_lex_state = 135},
  [3969] = {.lex_state = 54, .external_lex_state = 135},
  [3970] = {.lex_state = 54, .external_lex_state = 11},
  [3971] = {.lex_state = 48, .external_lex_state = 111},
  [3972] = {.lex_state = 54, .external_lex_state = 142},
  [3973] = {.lex_state = 54, .external_lex_state = 11},
  [3974] = {.lex_state = 54, .external_lex_state = 11},
  [3975] = {.lex_state = 54, .external_lex_state = 11},
  [3976] = {.lex_state = 54, .external_lex_state = 137},
  [3977] = {.lex_state = 54, .external_lex_state = 139},
  [3978] = {.lex_state = 54, .external_lex_state = 133},
  [3979] = {.lex_state = 54, .external_lex_state = 126},
  [3980] = {.lex_state = 54, .external_lex_state = 11},
  [3981] = {.lex_state = 54, .external_lex_state = 134},
  [3982] = {.lex_state = 54, .external_lex_state = 11},
  [3983] = {.lex_state = 54, .external_lex_state = 126},
  [3984] = {.lex_state = 54, .external_lex_state = 11},
  [3985] = {.lex_state = 54, .external_lex_state = 11},
  [3986] = {.lex_state = 54, .external_lex_state = 11},
  [3987] = {.lex_state = 54, .external_lex_state = 137},
  [3988] = {.lex_state = 54, .external_lex_state = 11},
  [3989] = {.lex_state = 54, .external_lex_state = 140},
  [3990] = {.lex_state = 54, .external_lex_state = 141},
  [3991] = {.lex_state = 48, .external_lex_state = 111},
  [3992] = {.lex_state = 54, .external_lex_state = 11},
  [3993] = {.lex_state = 54, .external_lex_state = 140},
  [3994] = {.lex_state = 54, .external_lex_state = 11},
  [3995] = {.lex_state = 54, .external_lex_state = 11},
  [3996] = {.lex_state = 54, .external_lex_state = 11},
  [3997] = {.lex_state = 54, .external_lex_state = 11},
  [3998] = {.lex_state = 54, .external_lex_state = 11},
  [3999] = {.lex_state = 47, .external_lex_state = 143},
  [4000] = {.lex_state = 54, .external_lex_state = 136},
  [4001] = {.lex_state = 54, .external_lex_state = 11},
  [4002] = {.lex_state = 54, .external_lex_state = 11},
  [4003] = {.lex_state = 54, .external_lex_state = 11},
  [4004] = {.lex_state = 54, .external_lex_state = 11},
  [4005] = {.lex_state = 54, .external_lex_state = 11},
  [4006] = {.lex_state = 54, .external_lex_state = 11},
  [4007] = {.lex_state = 54, .external_lex_state = 133},
  [4008] = {.lex_state = 54, .external_lex_state = 134},
  [4009] = {.lex_state = 54, .external_lex_state = 126},
  [4010] = {.lex_state = 54, .external_lex_state = 11},
  [4011] = {.lex_state = 54, .external_lex_state = 11},
  [4012] = {.lex_state = 54, .external_lex_state = 139},
  [4013] = {.lex_state = 53, .external_lex_state = 14},
  [4014] = {.lex_state = 54, .external_lex_state = 11},
  [4015] = {.lex_state = 54, .external_lex_state = 144},
  [4016] = {.lex_state = 48, .external_lex_state = 39},
  [4017] = {.lex_state = 48, .external_lex_state = 39},
  [4018] = {.lex_state = 54, .external_lex_state = 8},
  [4019] = {.lex_state = 54, .external_lex_state = 14},
  [4020] = {.lex_state = 54, .external_lex_state = 145},
  [4021] = {.lex_state = 54, .external_lex_state = 8},
  [4022] = {.lex_state = 54, .external_lex_state = 14},
  [4023] = {.lex_state = 54, .external_lex_state = 145},
  [4024] = {.lex_state = 54, .external_lex_state = 14},
  [4025] = {.lex_state = 54, .external_lex_state = 144},
  [4026] = {.lex_state = 54, .external_lex_state = 14},
  [4027] = {.lex_state = 54, .external_lex_state = 14},
  [4028] = {.lex_state = 54, .external_lex_state = 110},
  [4029] = {.lex_state = 54, .external_lex_state = 14},
  [4030] = {.lex_state = 54, .external_lex_state = 14},
  [4031] = {.lex_state = 54, .external_lex_state = 8},
  [4032] = {.lex_state = 54, .external_lex_state = 14},
  [4033] = {.lex_state = 54, .external_lex_state = 8},
  [4034] = {.lex_state = 54, .external_lex_state = 14},
  [4035] = {.lex_state = 54, .external_lex_state = 14},
  [4036] = {.lex_state = 54, .external_lex_state = 8},
  [4037] = {.lex_state = 54, .external_lex_state = 14},
  [4038] = {.lex_state = 54, .external_lex_state = 14},
  [4039] = {.lex_state = 48, .external_lex_state = 39},
  [4040] = {.lex_state = 48, .external_lex_state = 39},
  [4041] = {.lex_state = 54, .external_lex_state = 8},
  [4042] = {.lex_state = 54, .external_lex_state = 144},
  [4043] = {.lex_state = 54, .external_lex_state = 14},
  [4044] = {.lex_state = 54, .external_lex_state = 14},
  [4045] = {.lex_state = 54, .external_lex_state = 14},
  [4046] = {.lex_state = 48, .external_lex_state = 39},
  [4047] = {.lex_state = 48, .external_lex_state = 39},
  [4048] = {.lex_state = 54, .external_lex_state = 14},
  [4049] = {.lex_state = 48, .external_lex_state = 39},
  [4050] = {.lex_state = 54, .external_lex_state = 8},
  [4051] = {.lex_state = 54, .external_lex_state = 110},
  [4052] = {.lex_state = 54, .external_lex_state = 14},
  [4053] = {.lex_state = 54, .external_lex_state = 8},
  [4054] = {.lex_state = 54, .external_lex_state = 14},
  [4055] = {.lex_state = 54, .external_lex_state = 14},
  [4056] = {.lex_state = 54, .external_lex_state = 14},
  [4057] = {.lex_state = 54, .external_lex_state = 8},
  [4058] = {.lex_state = 54, .external_lex_state = 14},
  [4059] = {.lex_state = 54, .external_lex_state = 14},
  [4060] = {.lex_state = 54, .external_lex_state = 14},
  [4061] = {.lex_state = 54, .external_lex_state = 8},
  [4062] = {.lex_state = 48, .external_lex_state = 39},
  [4063] = {.lex_state = 54, .external_lex_state = 8},
  [4064] = {.lex_state = 47, .external_lex_state = 11},
  [4065] = {.lex_state = 54, .external_lex_state = 14},
  [4066] = {.lex_state = 54, .external_lex_state = 8},
  [4067] = {.lex_state = 48, .external_lex_state = 39},
  [4068] = {.lex_state = 48, .external_lex_state = 39},
  [4069] = {.lex_state = 54, .external_lex_state = 8},
  [4070] = {.lex_state = 54, .external_lex_state = 14},
  [4071] = {.lex_state = 48, .external_lex_state = 39},
  [4072] = {.lex_state = 54, .external_lex_state = 5},
  [4073] = {.lex_state = 47, .external_lex_state = 11},
  [4074] = {.lex_state = 54, .external_lex_state = 145},
  [4075] = {.lex_state = 48, .external_lex_state = 39},
  [4076] = {.lex_state = 54, .external_lex_state = 14},
  [4077] = {.lex_state = 54, .external_lex_state = 14},
  [4078] = {.lex_state = 48, .external_lex_state = 39},
  [4079] = {.lex_state = 54, .external_lex_state = 14},
  [4080] = {.lex_state = 54, .external_lex_state = 14},
  [4081] = {.lex_state = 54, .external_lex_state = 14},
  [4082] = {.lex_state = 47, .external_lex_state = 11},
  [4083] = {.lex_state = 48, .external_lex_state = 39},
  [4084] = {.lex_state = 48, .external_lex_state = 39},
  [4085] = {.lex_state = 54, .external_lex_state = 14},
  [4086] = {.lex_state = 54, .external_lex_state = 14},
  [4087] = {.lex_state = 54, .external_lex_state = 8},
  [4088] = {.lex_state = 54, .external_lex_state = 110},
  [4089] = {.lex_state = 54, .external_lex_state = 145},
  [4090] = {.lex_state = 54, .external_lex_state = 14},
  [4091] = {.lex_state = 54, .external_lex_state = 14},
  [4092] = {.lex_state = 54, .external_lex_state = 8},
  [4093] = {.lex_state = 48, .external_lex_state = 39},
  [4094] = {.lex_state = 54, .external_lex_state = 14},
  [4095] = {.lex_state = 54, .external_lex_state = 14},
  [4096] = {.lex_state = 47, .external_lex_state = 11},
  [4097] = {.lex_state = 54, .external_lex_state = 14},
  [4098] = {.lex_state = 54, .external_lex_state = 8},
  [4099] = {.lex_state = 54, .external_lex_state = 8},
  [4100] = {.lex_state = 47, .external_lex_state = 11},
  [4101] = {.lex_state = 54, .external_lex_state = 8},
  [4102] = {.lex_state = 54, .external_lex_state = 8},
  [4103] = {.lex_state = 54, .external_lex_state = 14},
  [4104] = {.lex_state = 54, .external_lex_state = 8},
  [4105] = {.lex_state = 47, .external_lex_state = 11},
  [4106] = {.lex_state = 48, .external_lex_state = 39},
  [4107] = {.lex_state = 47, .external_lex_state = 11},
  [4108] = {.lex_state = 54, .external_lex_state = 8},
  [4109] = {.lex_state = 54, .external_lex_state = 8},
  [4110] = {.lex_state = 54, .external_lex_state = 14},
  [4111] = {.lex_state = 48, .external_lex_state = 39},
  [4112] = {.lex_state = 54, .external_lex_state = 8},
  [4113] = {.lex_state = 54, .external_lex_state = 8},
  [4114] = {.lex_state = 54, .external_lex_state = 14},
  [4115] = {.lex_state = 54, .external_lex_state = 14},
  [4116] = {.lex_state = 54, .external_lex_state = 14},
  [4117] = {.lex_state = 54, .external_lex_state = 14},
  [4118] = {.lex_state = 54, .external_lex_state = 14},
  [4119] = {.lex_state = 48, .external_lex_state = 39},
  [4120] = {.lex_state = 54, .external_lex_state = 14},
  [4121] = {.lex_state = 54, .external_lex_state = 14},
  [4122] = {.lex_state = 54, .external_lex_state = 8},
  [4123] = {.lex_state = 54, .external_lex_state = 8},
  [4124] = {.lex_state = 48, .external_lex_state = 39},
  [4125] = {.lex_state = 48, .external_lex_state = 39},
  [4126] = {.lex_state = 54, .external_lex_state = 14},
  [4127] = {.lex_state = 54, .external_lex_state = 14},
  [4128] = {.lex_state = 54, .external_lex_state = 14},
  [4129] = {.lex_state = 54, .external_lex_state = 8},
  [4130] = {.lex_state = 54, .external_lex_state = 14},
  [4131] = {.lex_state = 54, .external_lex_state = 8},
  [4132] = {.lex_state = 54, .external_lex_state = 14},
  [4133] = {.lex_state = 54, .external_lex_state = 14},
  [4134] = {.lex_state = 48, .external_lex_state = 39},
  [4135] = {.lex_state = 48, .external_lex_state = 39},
  [4136] = {.lex_state = 54, .external_lex_state = 14},
  [4137] = {.lex_state = 54, .external_lex_state = 8},
  [4138] = {.lex_state = 54, .external_lex_state = 8},
  [4139] = {.lex_state = 48, .external_lex_state = 39},
  [4140] = {.lex_state = 53, .external_lex_state = 8},
  [4141] = {.lex_state = 54, .external_lex_state = 14},
  [4142] = {.lex_state = 54, .external_lex_state = 14},
  [4143] = {.lex_state = 54, .external_lex_state = 14},
  [4144] = {.lex_state = 54, .external_lex_state = 90},
  [4145] = {.lex_state = 54, .external_lex_state = 146},
  [4146] = {.lex_state = 54, .external_lex_state = 14},
  [4147] = {.lex_state = 54, .external_lex_state = 14},
  [4148] = {.lex_state = 48, .external_lex_state = 39},
  [4149] = {.lex_state = 54, .external_lex_state = 14},
  [4150] = {.lex_state = 48, .external_lex_state = 39},
  [4151] = {.lex_state = 54, .external_lex_state = 145},
  [4152] = {.lex_state = 54, .external_lex_state = 14},
  [4153] = {.lex_state = 54, .external_lex_state = 14},
  [4154] = {.lex_state = 54, .external_lex_state = 146},
  [4155] = {.lex_state = 54, .external_lex_state = 14},
  [4156] = {.lex_state = 48, .external_lex_state = 39},
  [4157] = {.lex_state = 54, .external_lex_state = 8},
  [4158] = {.lex_state = 47, .external_lex_state = 147},
  [4159] = {.lex_state = 54, .external_lex_state = 14},
  [4160] = {.lex_state = 54, .external_lex_state = 14},
  [4161] = {.lex_state = 48, .external_lex_state = 39},
  [4162] = {.lex_state = 54, .external_lex_state = 8},
  [4163] = {.lex_state = 48, .external_lex_state = 39},
  [4164] = {.lex_state = 54, .external_lex_state = 8},
  [4165] = {.lex_state = 54, .external_lex_state = 14},
  [4166] = {.lex_state = 54, .external_lex_state = 8},
  [4167] = {.lex_state = 54, .external_lex_state = 145},
  [4168] = {.lex_state = 54, .external_lex_state = 8},
  [4169] = {.lex_state = 47, .external_lex_state = 11},
  [4170] = {.lex_state = 48, .external_lex_state = 39},
  [4171] = {.lex_state = 54, .external_lex_state = 8},
  [4172] = {.lex_state = 54, .external_lex_state = 14},
  [4173] = {.lex_state = 54, .external_lex_state = 8},
  [4174] = {.lex_state = 54, .external_lex_state = 8},
  [4175] = {.lex_state = 54, .external_lex_state = 8},
  [4176] = {.lex_state = 54, .external_lex_state = 8},
  [4177] = {.lex_state = 54, .external_lex_state = 8},
  [4178] = {.lex_state = 47, .external_lex_state = 11},
  [4179] = {.lex_state = 48, .external_lex_state = 39},
  [4180] = {.lex_state = 54, .external_lex_state = 8},
  [4181] = {.lex_state = 48, .external_lex_state = 39},
  [4182] = {.lex_state = 48, .external_lex_state = 39},
  [4183] = {.lex_state = 54, .external_lex_state = 8},
  [4184] = {.lex_state = 48, .external_lex_state = 39},
  [4185] = {.lex_state = 54, .external_lex_state = 8},
  [4186] = {.lex_state = 54, .external_lex_state = 8},
  [4187] = {.lex_state = 48, .external_lex_state = 39},
  [4188] = {.lex_state = 54, .external_lex_state = 90},
  [4189] = {.lex_state = 54, .external_lex_state = 8},
  [4190] = {.lex_state = 48, .external_lex_state = 39},
  [4191] = {.lex_state = 47, .external_lex_state = 11},
  [4192] = {.lex_state = 54, .external_lex_state = 146},
  [4193] = {.lex_state = 54, .external_lex_state = 14},
  [4194] = {.lex_state = 54, .external_lex_state = 146},
  [4195] = {.lex_state = 54, .external_lex_state = 8},
  [4196] = {.lex_state = 54, .external_lex_state = 90},
  [4197] = {.lex_state = 54, .external_lex_state = 14},
  [4198] = {.lex_state = 54, .external_lex_state = 8},
  [4199] = {.lex_state = 54, .external_lex_state = 14},
  [4200] = {.lex_state = 54, .external_lex_state = 8},
  [4201] = {.lex_state = 54, .external_lex_state = 8},
  [4202] = {.lex_state = 54, .external_lex_state = 8},
  [4203] = {.lex_state = 47, .external_lex_state = 8},
  [4204] = {.lex_state = 54, .external_lex_state = 8},
  [4205] = {.lex_state = 47, .external_lex_state = 8},
  [4206] = {.lex_state = 54, .external_lex_state = 15},
  [4207] = {.lex_state = 54, .external_lex_state = 14},
  [4208] = {.lex_state = 54, .external_lex_state = 15},
  [4209] = {.lex_state = 54, .external_lex_state = 148},
  [4210] = {.lex_state = 54, .external_lex_state = 15},
  [4211] = {.lex_state = 54, .external_lex_state = 15},
  [4212] = {.lex_state = 54, .external_lex_state = 149},
  [4213] = {.lex_state = 48, .external_lex_state = 150},
  [4214] = {.lex_state = 54, .external_lex_state = 8},
  [4215] = {.lex_state = 54, .external_lex_state = 148},
  [4216] = {.lex_state = 54, .external_lex_state = 151},
  [4217] = {.lex_state = 54, .external_lex_state = 15},
  [4218] = {.lex_state = 47, .external_lex_state = 8},
  [4219] = {.lex_state = 54, .external_lex_state = 148},
  [4220] = {.lex_state = 54, .external_lex_state = 14},
  [4221] = {.lex_state = 47, .external_lex_state = 152},
  [4222] = {.lex_state = 54, .external_lex_state = 148},
  [4223] = {.lex_state = 54, .external_lex_state = 148},
  [4224] = {.lex_state = 54, .external_lex_state = 15},
  [4225] = {.lex_state = 54, .external_lex_state = 15},
  [4226] = {.lex_state = 54, .external_lex_state = 15},
  [4227] = {.lex_state = 54, .external_lex_state = 15},
  [4228] = {.lex_state = 54, .external_lex_state = 153},
  [4229] = {.lex_state = 54, .external_lex_state = 15},
  [4230] = {.lex_state = 47, .external_lex_state = 154},
  [4231] = {.lex_state = 54, .external_lex_state = 15},
  [4232] = {.lex_state = 54, .external_lex_state = 155},
  [4233] = {.lex_state = 54, .external_lex_state = 148},
  [4234] = {.lex_state = 54, .external_lex_state = 15},
  [4235] = {.lex_state = 54, .external_lex_state = 15},
  [4236] = {.lex_state = 54, .external_lex_state = 156},
  [4237] = {.lex_state = 54, .external_lex_state = 15},
  [4238] = {.lex_state = 54, .external_lex_state = 15},
  [4239] = {.lex_state = 54, .external_lex_state = 15},
  [4240] = {.lex_state = 54, .external_lex_state = 15},
  [4241] = {.lex_state = 54, .external_lex_state = 15},
  [4242] = {.lex_state = 53, .external_lex_state = 33},
  [4243] = {.lex_state = 48, .external_lex_state = 150},
  [4244] = {.lex_state = 54, .external_lex_state = 15},
  [4245] = {.lex_state = 54, .external_lex_state = 149},
  [4246] = {.lex_state = 54, .external_lex_state = 15},
  [4247] = {.lex_state = 47, .external_lex_state = 8},
  [4248] = {.lex_state = 47, .external_lex_state = 8},
  [4249] = {.lex_state = 47, .external_lex_state = 8},
  [4250] = {.lex_state = 54, .external_lex_state = 15},
  [4251] = {.lex_state = 54, .external_lex_state = 15},
  [4252] = {.lex_state = 53, .external_lex_state = 18},
  [4253] = {.lex_state = 53, .external_lex_state = 33},
  [4254] = {.lex_state = 54, .external_lex_state = 157},
  [4255] = {.lex_state = 54, .external_lex_state = 156},
  [4256] = {.lex_state = 54, .external_lex_state = 151},
  [4257] = {.lex_state = 54, .external_lex_state = 151},
  [4258] = {.lex_state = 54, .external_lex_state = 15},
  [4259] = {.lex_state = 54, .external_lex_state = 15},
  [4260] = {.lex_state = 54, .external_lex_state = 14},
  [4261] = {.lex_state = 54, .external_lex_state = 151},
  [4262] = {.lex_state = 54, .external_lex_state = 156},
  [4263] = {.lex_state = 53, .external_lex_state = 18},
  [4264] = {.lex_state = 53, .external_lex_state = 18},
  [4265] = {.lex_state = 54, .external_lex_state = 156},
  [4266] = {.lex_state = 54, .external_lex_state = 158},
  [4267] = {.lex_state = 54, .external_lex_state = 15},
  [4268] = {.lex_state = 54, .external_lex_state = 156},
  [4269] = {.lex_state = 54, .external_lex_state = 15},
  [4270] = {.lex_state = 54, .external_lex_state = 15},
  [4271] = {.lex_state = 54, .external_lex_state = 15},
  [4272] = {.lex_state = 54, .external_lex_state = 149},
  [4273] = {.lex_state = 54, .external_lex_state = 134},
  [4274] = {.lex_state = 47, .external_lex_state = 8},
  [4275] = {.lex_state = 54, .external_lex_state = 8},
  [4276] = {.lex_state = 54, .external_lex_state = 15},
  [4277] = {.lex_state = 54, .external_lex_state = 15},
  [4278] = {.lex_state = 54, .external_lex_state = 158},
  [4279] = {.lex_state = 48, .external_lex_state = 150},
  [4280] = {.lex_state = 54, .external_lex_state = 15},
  [4281] = {.lex_state = 54, .external_lex_state = 15},
  [4282] = {.lex_state = 54, .external_lex_state = 15},
  [4283] = {.lex_state = 47, .external_lex_state = 8},
  [4284] = {.lex_state = 54, .external_lex_state = 8},
  [4285] = {.lex_state = 54, .external_lex_state = 153},
  [4286] = {.lex_state = 54, .external_lex_state = 156},
  [4287] = {.lex_state = 54, .external_lex_state = 15},
  [4288] = {.lex_state = 48, .external_lex_state = 150},
  [4289] = {.lex_state = 54, .external_lex_state = 15},
  [4290] = {.lex_state = 54, .external_lex_state = 14},
  [4291] = {.lex_state = 54, .external_lex_state = 15},
  [4292] = {.lex_state = 54, .external_lex_state = 15},
  [4293] = {.lex_state = 47, .external_lex_state = 159},
  [4294] = {.lex_state = 54, .external_lex_state = 15},
  [4295] = {.lex_state = 47, .external_lex_state = 8},
  [4296] = {.lex_state = 54, .external_lex_state = 15},
  [4297] = {.lex_state = 54, .external_lex_state = 15},
  [4298] = {.lex_state = 54, .external_lex_state = 15},
  [4299] = {.lex_state = 54, .external_lex_state = 151},
  [4300] = {.lex_state = 54, .external_lex_state = 15},
  [4301] = {.lex_state = 54, .external_lex_state = 15},
  [4302] = {.lex_state = 54, .external_lex_state = 157},
  [4303] = {.lex_state = 54, .external_lex_state = 14},
  [4304] = {.lex_state = 54, .external_lex_state = 158},
  [4305] = {.lex_state = 54, .external_lex_state = 15},
  [4306] = {.lex_state = 54, .external_lex_state = 158},
  [4307] = {.lex_state = 48, .external_lex_state = 150},
  [4308] = {.lex_state = 54, .external_lex_state = 153},
  [4309] = {.lex_state = 54, .external_lex_state = 151},
  [4310] = {.lex_state = 54, .external_lex_state = 15},
  [4311] = {.lex_state = 54, .external_lex_state = 157},
  [4312] = {.lex_state = 54, .external_lex_state = 15},
  [4313] = {.lex_state = 54, .external_lex_state = 15},
  [4314] = {.lex_state = 54, .external_lex_state = 15},
  [4315] = {.lex_state = 54, .external_lex_state = 14},
  [4316] = {.lex_state = 54, .external_lex_state = 15},
  [4317] = {.lex_state = 48, .external_lex_state = 150},
  [4318] = {.lex_state = 54, .external_lex_state = 15},
  [4319] = {.lex_state = 54, .external_lex_state = 157},
  [4320] = {.lex_state = 54, .external_lex_state = 15},
  [4321] = {.lex_state = 54, .external_lex_state = 15},
  [4322] = {.lex_state = 54, .external_lex_state = 155},
  [4323] = {.lex_state = 54, .external_lex_state = 15},
  [4324] = {.lex_state = 54, .external_lex_state = 15},
  [4325] = {.lex_state = 54, .external_lex_state = 15},
  [4326] = {.lex_state = 54, .external_lex_state = 15},
  [4327] = {.lex_state = 54, .external_lex_state = 15},
  [4328] = {.lex_state = 54, .external_lex_state = 15},
  [4329] = {.lex_state = 54, .external_lex_state = 15},
  [4330] = {.lex_state = 47, .external_lex_state = 8},
  [4331] = {.lex_state = 54, .external_lex_state = 15},
  [4332] = {.lex_state = 54, .external_lex_state = 15},
  [4333] = {.lex_state = 54, .external_lex_state = 141},
  [4334] = {.lex_state = 54, .external_lex_state = 157},
  [4335] = {.lex_state = 54, .external_lex_state = 155},
  [4336] = {.lex_state = 54, .external_lex_state = 14},
  [4337] = {.lex_state = 54, .external_lex_state = 14},
  [4338] = {.lex_state = 54, .external_lex_state = 15},
  [4339] = {.lex_state = 54, .external_lex_state = 157},
  [4340] = {.lex_state = 54, .external_lex_state = 15},
  [4341] = {.lex_state = 54, .external_lex_state = 14},
  [4342] = {.lex_state = 54, .external_lex_state = 158},
  [4343] = {.lex_state = 47, .external_lex_state = 160},
  [4344] = {.lex_state = 47, .external_lex_state = 161},
  [4345] = {.lex_state = 54, .external_lex_state = 14},
  [4346] = {.lex_state = 54, .external_lex_state = 158},
  [4347] = {.lex_state = 54, .external_lex_state = 15},
  [4348] = {.lex_state = 54, .external_lex_state = 15},
  [4349] = {.lex_state = 54, .external_lex_state = 20},
  [4350] = {.lex_state = 54, .external_lex_state = 17},
  [4351] = {.lex_state = 54, .external_lex_state = 162},
  [4352] = {.lex_state = 54, .external_lex_state = 18},
  [4353] = {.lex_state = 54, .external_lex_state = 18},
  [4354] = {.lex_state = 54, .external_lex_state = 18},
  [4355] = {.lex_state = 54, .external_lex_state = 18},
  [4356] = {.lex_state = 54, .external_lex_state = 18},
  [4357] = {.lex_state = 54, .external_lex_state = 18},
  [4358] = {.lex_state = 54, .external_lex_state = 163},
  [4359] = {.lex_state = 54, .external_lex_state = 17},
  [4360] = {.lex_state = 54, .external_lex_state = 18},
  [4361] = {.lex_state = 54, .external_lex_state = 162},
  [4362] = {.lex_state = 54, .external_lex_state = 17},
  [4363] = {.lex_state = 54, .external_lex_state = 18},
  [4364] = {.lex_state = 54, .external_lex_state = 18},
  [4365] = {.lex_state = 54, .external_lex_state = 18},
  [4366] = {.lex_state = 54, .external_lex_state = 18},
  [4367] = {.lex_state = 54, .external_lex_state = 18},
  [4368] = {.lex_state = 54, .external_lex_state = 18},
  [4369] = {.lex_state = 54, .external_lex_state = 18},
  [4370] = {.lex_state = 54, .external_lex_state = 18},
  [4371] = {.lex_state = 54, .external_lex_state = 18},
  [4372] = {.lex_state = 54, .external_lex_state = 17},
  [4373] = {.lex_state = 54, .external_lex_state = 18},
  [4374] = {.lex_state = 54, .external_lex_state = 17},
  [4375] = {.lex_state = 54, .external_lex_state = 18},
  [4376] = {.lex_state = 54, .external_lex_state = 18},
  [4377] = {.lex_state = 54, .external_lex_state = 18},
  [4378] = {.lex_state = 47, .external_lex_state = 15},
  [4379] = {.lex_state = 54, .external_lex_state = 18},
  [4380] = {.lex_state = 54, .external_lex_state = 18},
  [4381] = {.lex_state = 54, .external_lex_state = 18},
  [4382] = {.lex_state = 47, .external_lex_state = 15},
  [4383] = {.lex_state = 54, .external_lex_state = 17},
  [4384] = {.lex_state = 47, .external_lex_state = 15},
  [4385] = {.lex_state = 54, .external_lex_state = 18},
  [4386] = {.lex_state = 54, .external_lex_state = 164},
  [4387] = {.lex_state = 54, .external_lex_state = 18},
  [4388] = {.lex_state = 53, .external_lex_state = 30},
  [4389] = {.lex_state = 54, .external_lex_state = 18},
  [4390] = {.lex_state = 48, .external_lex_state = 41},
  [4391] = {.lex_state = 54, .external_lex_state = 17},
  [4392] = {.lex_state = 54, .external_lex_state = 18},
  [4393] = {.lex_state = 54, .external_lex_state = 18},
  [4394] = {.lex_state = 54, .external_lex_state = 18},
  [4395] = {.lex_state = 54, .external_lex_state = 18},
  [4396] = {.lex_state = 54, .external_lex_state = 17},
  [4397] = {.lex_state = 47, .external_lex_state = 15},
  [4398] = {.lex_state = 47, .external_lex_state = 15},
  [4399] = {.lex_state = 54, .external_lex_state = 18},
  [4400] = {.lex_state = 54, .external_lex_state = 163},
  [4401] = {.lex_state = 54, .external_lex_state = 18},
  [4402] = {.lex_state = 47, .external_lex_state = 165},
  [4403] = {.lex_state = 47, .external_lex_state = 15},
  [4404] = {.lex_state = 54, .external_lex_state = 18},
  [4405] = {.lex_state = 54, .external_lex_state = 18},
  [4406] = {.lex_state = 54, .external_lex_state = 166},
  [4407] = {.lex_state = 54, .external_lex_state = 23},
  [4408] = {.lex_state = 47, .external_lex_state = 15},
  [4409] = {.lex_state = 54, .external_lex_state = 18},
  [4410] = {.lex_state = 47, .external_lex_state = 15},
  [4411] = {.lex_state = 48, .external_lex_state = 41},
  [4412] = {.lex_state = 47, .external_lex_state = 15},
  [4413] = {.lex_state = 54, .external_lex_state = 17},
  [4414] = {.lex_state = 54, .external_lex_state = 28},
  [4415] = {.lex_state = 54, .external_lex_state = 18},
  [4416] = {.lex_state = 54, .external_lex_state = 17},
  [4417] = {.lex_state = 54, .external_lex_state = 166},
  [4418] = {.lex_state = 54, .external_lex_state = 167},
  [4419] = {.lex_state = 54, .external_lex_state = 17},
  [4420] = {.lex_state = 54, .external_lex_state = 17},
  [4421] = {.lex_state = 54, .external_lex_state = 18},
  [4422] = {.lex_state = 54, .external_lex_state = 17},
  [4423] = {.lex_state = 54, .external_lex_state = 28},
  [4424] = {.lex_state = 54, .external_lex_state = 19},
  [4425] = {.lex_state = 47, .external_lex_state = 168},
  [4426] = {.lex_state = 54, .external_lex_state = 17},
  [4427] = {.lex_state = 47, .external_lex_state = 15},
  [4428] = {.lex_state = 54, .external_lex_state = 169},
  [4429] = {.lex_state = 54, .external_lex_state = 17},
  [4430] = {.lex_state = 54, .external_lex_state = 18},
  [4431] = {.lex_state = 54, .external_lex_state = 18},
  [4432] = {.lex_state = 54, .external_lex_state = 169},
  [4433] = {.lex_state = 54, .external_lex_state = 18},
  [4434] = {.lex_state = 54, .external_lex_state = 162},
  [4435] = {.lex_state = 48, .external_lex_state = 41},
  [4436] = {.lex_state = 48, .external_lex_state = 41},
  [4437] = {.lex_state = 54, .external_lex_state = 28},
  [4438] = {.lex_state = 54, .external_lex_state = 28},
  [4439] = {.lex_state = 54, .external_lex_state = 17},
  [4440] = {.lex_state = 54, .external_lex_state = 18},
  [4441] = {.lex_state = 54, .external_lex_state = 33},
  [4442] = {.lex_state = 54, .external_lex_state = 17},
  [4443] = {.lex_state = 54, .external_lex_state = 18},
  [4444] = {.lex_state = 54, .external_lex_state = 17},
  [4445] = {.lex_state = 54, .external_lex_state = 17},
  [4446] = {.lex_state = 54, .external_lex_state = 33},
  [4447] = {.lex_state = 47, .external_lex_state = 170},
  [4448] = {.lex_state = 54, .external_lex_state = 17},
  [4449] = {.lex_state = 54, .external_lex_state = 17},
  [4450] = {.lex_state = 53, .external_lex_state = 30},
  [4451] = {.lex_state = 54, .external_lex_state = 17},
  [4452] = {.lex_state = 54, .external_lex_state = 166},
  [4453] = {.lex_state = 54, .external_lex_state = 17},
  [4454] = {.lex_state = 48, .external_lex_state = 41},
  [4455] = {.lex_state = 54, .external_lex_state = 17},
  [4456] = {.lex_state = 54, .external_lex_state = 17},
  [4457] = {.lex_state = 54, .external_lex_state = 17},
  [4458] = {.lex_state = 54, .external_lex_state = 23},
  [4459] = {.lex_state = 54, .external_lex_state = 17},
  [4460] = {.lex_state = 54, .external_lex_state = 17},
  [4461] = {.lex_state = 54, .external_lex_state = 17},
  [4462] = {.lex_state = 54, .external_lex_state = 17},
  [4463] = {.lex_state = 54, .external_lex_state = 17},
  [4464] = {.lex_state = 54, .external_lex_state = 155},
  [4465] = {.lex_state = 54, .external_lex_state = 169},
  [4466] = {.lex_state = 54, .external_lex_state = 23},
  [4467] = {.lex_state = 54, .external_lex_state = 17},
  [4468] = {.lex_state = 54, .external_lex_state = 18},
  [4469] = {.lex_state = 54, .external_lex_state = 17},
  [4470] = {.lex_state = 54, .external_lex_state = 23},
  [4471] = {.lex_state = 54, .external_lex_state = 23},
  [4472] = {.lex_state = 54, .external_lex_state = 17},
  [4473] = {.lex_state = 54, .external_lex_state = 17},
  [4474] = {.lex_state = 54, .external_lex_state = 17},
  [4475] = {.lex_state = 54, .external_lex_state = 17},
  [4476] = {.lex_state = 54, .external_lex_state = 17},
  [4477] = {.lex_state = 54, .external_lex_state = 17},
  [4478] = {.lex_state = 54, .external_lex_state = 17},
  [4479] = {.lex_state = 54, .external_lex_state = 17},
  [4480] = {.lex_state = 54, .external_lex_state = 17},
  [4481] = {.lex_state = 54, .external_lex_state = 17},
  [4482] = {.lex_state = 54, .external_lex_state = 17},
  [4483] = {.lex_state = 54, .external_lex_state = 17},
  [4484] = {.lex_state = 54, .external_lex_state = 17},
  [4485] = {.lex_state = 54, .external_lex_state = 17},
  [4486] = {.lex_state = 54, .external_lex_state = 17},
  [4487] = {.lex_state = 54, .external_lex_state = 17},
  [4488] = {.lex_state = 54, .external_lex_state = 17},
  [4489] = {.lex_state = 54, .external_lex_state = 17},
  [4490] = {.lex_state = 54, .external_lex_state = 17},
  [4491] = {.lex_state = 54, .external_lex_state = 23},
  [4492] = {.lex_state = 54, .external_lex_state = 17},
  [4493] = {.lex_state = 54, .external_lex_state = 17},
  [4494] = {.lex_state = 54, .external_lex_state = 17},
  [4495] = {.lex_state = 54, .external_lex_state = 17},
  [4496] = {.lex_state = 54, .external_lex_state = 17},
  [4497] = {.lex_state = 54, .external_lex_state = 33},
  [4498] = {.lex_state = 54, .external_lex_state = 166},
  [4499] = {.lex_state = 54, .external_lex_state = 33},
  [4500] = {.lex_state = 54, .external_lex_state = 33},
  [4501] = {.lex_state = 54, .external_lex_state = 155},
  [4502] = {.lex_state = 54, .external_lex_state = 18},
  [4503] = {.lex_state = 54, .external_lex_state = 33},
  [4504] = {.lex_state = 54, .external_lex_state = 33},
  [4505] = {.lex_state = 54, .external_lex_state = 33},
  [4506] = {.lex_state = 54, .external_lex_state = 28},
  [4507] = {.lex_state = 54, .external_lex_state = 19},
  [4508] = {.lex_state = 54, .external_lex_state = 28},
  [4509] = {.lex_state = 54, .external_lex_state = 28},
  [4510] = {.lex_state = 54, .external_lex_state = 19},
  [4511] = {.lex_state = 54, .external_lex_state = 164},
  [4512] = {.lex_state = 54, .external_lex_state = 19},
  [4513] = {.lex_state = 54, .external_lex_state = 17},
  [4514] = {.lex_state = 54, .external_lex_state = 17},
  [4515] = {.lex_state = 54, .external_lex_state = 28},
  [4516] = {.lex_state = 54, .external_lex_state = 28},
  [4517] = {.lex_state = 54, .external_lex_state = 28},
  [4518] = {.lex_state = 54, .external_lex_state = 164},
  [4519] = {.lex_state = 54, .external_lex_state = 28},
  [4520] = {.lex_state = 54, .external_lex_state = 28},
  [4521] = {.lex_state = 54, .external_lex_state = 28},
  [4522] = {.lex_state = 54, .external_lex_state = 33},
  [4523] = {.lex_state = 54, .external_lex_state = 19},
  [4524] = {.lex_state = 54, .external_lex_state = 19},
  [4525] = {.lex_state = 54, .external_lex_state = 33},
  [4526] = {.lex_state = 54, .external_lex_state = 18},
  [4527] = {.lex_state = 54, .external_lex_state = 23},
  [4528] = {.lex_state = 54, .external_lex_state = 19},
  [4529] = {.lex_state = 54, .external_lex_state = 19},
  [4530] = {.lex_state = 54, .external_lex_state = 171},
  [4531] = {.lex_state = 54, .external_lex_state = 171},
  [4532] = {.lex_state = 54, .external_lex_state = 18},
  [4533] = {.lex_state = 54, .external_lex_state = 17},
  [4534] = {.lex_state = 54, .external_lex_state = 33},
  [4535] = {.lex_state = 54, .external_lex_state = 169},
  [4536] = {.lex_state = 54, .external_lex_state = 18},
  [4537] = {.lex_state = 54, .external_lex_state = 19},
  [4538] = {.lex_state = 54, .external_lex_state = 19},
  [4539] = {.lex_state = 54, .external_lex_state = 18},
  [4540] = {.lex_state = 54, .external_lex_state = 149},
  [4541] = {.lex_state = 48, .external_lex_state = 41},
  [4542] = {.lex_state = 48, .external_lex_state = 41},
  [4543] = {.lex_state = 47, .external_lex_state = 172},
  [4544] = {.lex_state = 54, .external_lex_state = 19},
  [4545] = {.lex_state = 53, .external_lex_state = 8},
  [4546] = {.lex_state = 54, .external_lex_state = 166},
  [4547] = {.lex_state = 54, .external_lex_state = 18},
  [4548] = {.lex_state = 54, .external_lex_state = 149},
  [4549] = {.lex_state = 54, .external_lex_state = 173},
  [4550] = {.lex_state = 48, .external_lex_state = 41},
  [4551] = {.lex_state = 48, .external_lex_state = 41},
  [4552] = {.lex_state = 54, .external_lex_state = 171},
  [4553] = {.lex_state = 48, .external_lex_state = 41},
  [4554] = {.lex_state = 48, .external_lex_state = 41},
  [4555] = {.lex_state = 48, .external_lex_state = 41},
  [4556] = {.lex_state = 54, .external_lex_state = 23},
  [4557] = {.lex_state = 48, .external_lex_state = 41},
  [4558] = {.lex_state = 54, .external_lex_state = 21},
  [4559] = {.lex_state = 48, .external_lex_state = 41},
  [4560] = {.lex_state = 53, .external_lex_state = 10},
  [4561] = {.lex_state = 48, .external_lex_state = 41},
  [4562] = {.lex_state = 54, .external_lex_state = 171},
  [4563] = {.lex_state = 54, .external_lex_state = 169},
  [4564] = {.lex_state = 54, .external_lex_state = 19},
  [4565] = {.lex_state = 54, .external_lex_state = 19},
  [4566] = {.lex_state = 54, .external_lex_state = 19},
  [4567] = {.lex_state = 54, .external_lex_state = 19},
  [4568] = {.lex_state = 48, .external_lex_state = 41},
  [4569] = {.lex_state = 54, .external_lex_state = 19},
  [4570] = {.lex_state = 54, .external_lex_state = 19},
  [4571] = {.lex_state = 54, .external_lex_state = 19},
  [4572] = {.lex_state = 54, .external_lex_state = 23},
  [4573] = {.lex_state = 54, .external_lex_state = 23},
  [4574] = {.lex_state = 47, .external_lex_state = 174},
  [4575] = {.lex_state = 54, .external_lex_state = 19},
  [4576] = {.lex_state = 54, .external_lex_state = 19},
  [4577] = {.lex_state = 54, .external_lex_state = 21},
  [4578] = {.lex_state = 54, .external_lex_state = 19},
  [4579] = {.lex_state = 48, .external_lex_state = 41},
  [4580] = {.lex_state = 48, .external_lex_state = 41},
  [4581] = {.lex_state = 48, .external_lex_state = 175},
  [4582] = {.lex_state = 48, .external_lex_state = 41},
  [4583] = {.lex_state = 54, .external_lex_state = 19},
  [4584] = {.lex_state = 54, .external_lex_state = 19},
  [4585] = {.lex_state = 54, .external_lex_state = 19},
  [4586] = {.lex_state = 54, .external_lex_state = 90},
  [4587] = {.lex_state = 54, .external_lex_state = 19},
  [4588] = {.lex_state = 54, .external_lex_state = 18},
  [4589] = {.lex_state = 54, .external_lex_state = 19},
  [4590] = {.lex_state = 54, .external_lex_state = 19},
  [4591] = {.lex_state = 54, .external_lex_state = 23},
  [4592] = {.lex_state = 54, .external_lex_state = 19},
  [4593] = {.lex_state = 54, .external_lex_state = 23},
  [4594] = {.lex_state = 54, .external_lex_state = 19},
  [4595] = {.lex_state = 47, .external_lex_state = 176},
  [4596] = {.lex_state = 54, .external_lex_state = 171},
  [4597] = {.lex_state = 48, .external_lex_state = 41},
  [4598] = {.lex_state = 54, .external_lex_state = 19},
  [4599] = {.lex_state = 54, .external_lex_state = 19},
  [4600] = {.lex_state = 54, .external_lex_state = 149},
  [4601] = {.lex_state = 54, .external_lex_state = 19},
  [4602] = {.lex_state = 54, .external_lex_state = 18},
  [4603] = {.lex_state = 48, .external_lex_state = 41},
  [4604] = {.lex_state = 54, .external_lex_state = 18},
  [4605] = {.lex_state = 54, .external_lex_state = 19},
  [4606] = {.lex_state = 54, .external_lex_state = 19},
  [4607] = {.lex_state = 54, .external_lex_state = 19},
  [4608] = {.lex_state = 54, .external_lex_state = 19},
  [4609] = {.lex_state = 54, .external_lex_state = 19},
  [4610] = {.lex_state = 54, .external_lex_state = 19},
  [4611] = {.lex_state = 54, .external_lex_state = 173},
  [4612] = {.lex_state = 54, .external_lex_state = 19},
  [4613] = {.lex_state = 54, .external_lex_state = 19},
  [4614] = {.lex_state = 54, .external_lex_state = 19},
  [4615] = {.lex_state = 54, .external_lex_state = 28},
  [4616] = {.lex_state = 54, .external_lex_state = 19},
  [4617] = {.lex_state = 54, .external_lex_state = 18},
  [4618] = {.lex_state = 54, .external_lex_state = 18},
  [4619] = {.lex_state = 54, .external_lex_state = 18},
  [4620] = {.lex_state = 54, .external_lex_state = 18},
  [4621] = {.lex_state = 54, .external_lex_state = 23},
  [4622] = {.lex_state = 54, .external_lex_state = 18},
  [4623] = {.lex_state = 54, .external_lex_state = 28},
  [4624] = {.lex_state = 54, .external_lex_state = 23},
  [4625] = {.lex_state = 48, .external_lex_state = 175},
  [4626] = {.lex_state = 54, .external_lex_state = 19},
  [4627] = {.lex_state = 54, .external_lex_state = 19},
  [4628] = {.lex_state = 48, .external_lex_state = 175},
  [4629] = {.lex_state = 54, .external_lex_state = 20},
  [4630] = {.lex_state = 54, .external_lex_state = 33},
  [4631] = {.lex_state = 54, .external_lex_state = 28},
  [4632] = {.lex_state = 54, .external_lex_state = 173},
  [4633] = {.lex_state = 54, .external_lex_state = 19},
  [4634] = {.lex_state = 48, .external_lex_state = 41},
  [4635] = {.lex_state = 48, .external_lex_state = 41},
  [4636] = {.lex_state = 48, .external_lex_state = 41},
  [4637] = {.lex_state = 48, .external_lex_state = 41},
  [4638] = {.lex_state = 54, .external_lex_state = 21},
  [4639] = {.lex_state = 54, .external_lex_state = 19},
  [4640] = {.lex_state = 48, .external_lex_state = 41},
  [4641] = {.lex_state = 48, .external_lex_state = 41},
  [4642] = {.lex_state = 54, .external_lex_state = 21},
  [4643] = {.lex_state = 48, .external_lex_state = 41},
  [4644] = {.lex_state = 48, .external_lex_state = 41},
  [4645] = {.lex_state = 54, .external_lex_state = 21},
  [4646] = {.lex_state = 54, .external_lex_state = 18},
  [4647] = {.lex_state = 54, .external_lex_state = 18},
  [4648] = {.lex_state = 48, .external_lex_state = 41},
  [4649] = {.lex_state = 54, .external_lex_state = 28},
  [4650] = {.lex_state = 54, .external_lex_state = 19},
  [4651] = {.lex_state = 54, .external_lex_state = 164},
  [4652] = {.lex_state = 48, .external_lex_state = 41},
  [4653] = {.lex_state = 54, .external_lex_state = 21},
  [4654] = {.lex_state = 54, .external_lex_state = 28},
  [4655] = {.lex_state = 54, .external_lex_state = 21},
  [4656] = {.lex_state = 54, .external_lex_state = 21},
  [4657] = {.lex_state = 54, .external_lex_state = 21},
  [4658] = {.lex_state = 54, .external_lex_state = 28},
  [4659] = {.lex_state = 54, .external_lex_state = 166},
  [4660] = {.lex_state = 54, .external_lex_state = 33},
  [4661] = {.lex_state = 54, .external_lex_state = 164},
  [4662] = {.lex_state = 54, .external_lex_state = 19},
  [4663] = {.lex_state = 54, .external_lex_state = 20},
  [4664] = {.lex_state = 54, .external_lex_state = 33},
  [4665] = {.lex_state = 54, .external_lex_state = 19},
  [4666] = {.lex_state = 54, .external_lex_state = 155},
  [4667] = {.lex_state = 54, .external_lex_state = 18},
  [4668] = {.lex_state = 54, .external_lex_state = 18},
  [4669] = {.lex_state = 54, .external_lex_state = 20},
  [4670] = {.lex_state = 54, .external_lex_state = 21},
  [4671] = {.lex_state = 54, .external_lex_state = 21},
  [4672] = {.lex_state = 54, .external_lex_state = 33},
  [4673] = {.lex_state = 54, .external_lex_state = 20},
  [4674] = {.lex_state = 53, .external_lex_state = 10},
  [4675] = {.lex_state = 54, .external_lex_state = 33},
  [4676] = {.lex_state = 54, .external_lex_state = 21},
  [4677] = {.lex_state = 54, .external_lex_state = 33},
  [4678] = {.lex_state = 54, .external_lex_state = 20},
  [4679] = {.lex_state = 54, .external_lex_state = 21},
  [4680] = {.lex_state = 54, .external_lex_state = 17},
  [4681] = {.lex_state = 54, .external_lex_state = 21},
  [4682] = {.lex_state = 54, .external_lex_state = 171},
  [4683] = {.lex_state = 54, .external_lex_state = 173},
  [4684] = {.lex_state = 54, .external_lex_state = 20},
  [4685] = {.lex_state = 54, .external_lex_state = 20},
  [4686] = {.lex_state = 54, .external_lex_state = 20},
  [4687] = {.lex_state = 54, .external_lex_state = 20},
  [4688] = {.lex_state = 54, .external_lex_state = 20},
  [4689] = {.lex_state = 54, .external_lex_state = 20},
  [4690] = {.lex_state = 54, .external_lex_state = 20},
  [4691] = {.lex_state = 54, .external_lex_state = 20},
  [4692] = {.lex_state = 54, .external_lex_state = 20},
  [4693] = {.lex_state = 54, .external_lex_state = 20},
  [4694] = {.lex_state = 54, .external_lex_state = 20},
  [4695] = {.lex_state = 54, .external_lex_state = 20},
  [4696] = {.lex_state = 54, .external_lex_state = 21},
  [4697] = {.lex_state = 54, .external_lex_state = 20},
  [4698] = {.lex_state = 54, .external_lex_state = 20},
  [4699] = {.lex_state = 54, .external_lex_state = 20},
  [4700] = {.lex_state = 54, .external_lex_state = 20},
  [4701] = {.lex_state = 54, .external_lex_state = 20},
  [4702] = {.lex_state = 54, .external_lex_state = 20},
  [4703] = {.lex_state = 54, .external_lex_state = 20},
  [4704] = {.lex_state = 54, .external_lex_state = 17},
  [4705] = {.lex_state = 54, .external_lex_state = 20},
  [4706] = {.lex_state = 54, .external_lex_state = 20},
  [4707] = {.lex_state = 54, .external_lex_state = 20},
  [4708] = {.lex_state = 54, .external_lex_state = 20},
  [4709] = {.lex_state = 54, .external_lex_state = 20},
  [4710] = {.lex_state = 54, .external_lex_state = 20},
  [4711] = {.lex_state = 54, .external_lex_state = 173},
  [4712] = {.lex_state = 54, .external_lex_state = 20},
  [4713] = {.lex_state = 54, .external_lex_state = 19},
  [4714] = {.lex_state = 54, .external_lex_state = 20},
  [4715] = {.lex_state = 54, .external_lex_state = 20},
  [4716] = {.lex_state = 54, .external_lex_state = 162},
  [4717] = {.lex_state = 54, .external_lex_state = 17},
  [4718] = {.lex_state = 54, .external_lex_state = 20},
  [4719] = {.lex_state = 54, .external_lex_state = 23},
  [4720] = {.lex_state = 54, .external_lex_state = 164},
  [4721] = {.lex_state = 54, .external_lex_state = 20},
  [4722] = {.lex_state = 48, .external_lex_state = 41},
  [4723] = {.lex_state = 54, .external_lex_state = 23},
  [4724] = {.lex_state = 54, .external_lex_state = 18},
  [4725] = {.lex_state = 54, .external_lex_state = 20},
  [4726] = {.lex_state = 54, .external_lex_state = 20},
  [4727] = {.lex_state = 54, .external_lex_state = 23},
  [4728] = {.lex_state = 54, .external_lex_state = 20},
  [4729] = {.lex_state = 54, .external_lex_state = 23},
  [4730] = {.lex_state = 54, .external_lex_state = 20},
  [4731] = {.lex_state = 54, .external_lex_state = 20},
  [4732] = {.lex_state = 54, .external_lex_state = 20},
  [4733] = {.lex_state = 54, .external_lex_state = 162},
  [4734] = {.lex_state = 54, .external_lex_state = 20},
  [4735] = {.lex_state = 54, .external_lex_state = 20},
  [4736] = {.lex_state = 54, .external_lex_state = 20},
  [4737] = {.lex_state = 54, .external_lex_state = 20},
  [4738] = {.lex_state = 54, .external_lex_state = 20},
  [4739] = {.lex_state = 54, .external_lex_state = 20},
  [4740] = {.lex_state = 54, .external_lex_state = 20},
  [4741] = {.lex_state = 54, .external_lex_state = 20},
  [4742] = {.lex_state = 48, .external_lex_state = 41},
  [4743] = {.lex_state = 48, .external_lex_state = 41},
  [4744] = {.lex_state = 54, .external_lex_state = 21},
  [4745] = {.lex_state = 54, .external_lex_state = 20},
  [4746] = {.lex_state = 54, .external_lex_state = 21},
  [4747] = {.lex_state = 54, .external_lex_state = 20},
  [4748] = {.lex_state = 54, .external_lex_state = 33},
  [4749] = {.lex_state = 48, .external_lex_state = 175},
  [4750] = {.lex_state = 54, .external_lex_state = 20},
  [4751] = {.lex_state = 54, .external_lex_state = 21},
  [4752] = {.lex_state = 54, .external_lex_state = 21},
  [4753] = {.lex_state = 54, .external_lex_state = 20},
  [4754] = {.lex_state = 54, .external_lex_state = 20},
  [4755] = {.lex_state = 48, .external_lex_state = 41},
  [4756] = {.lex_state = 54, .external_lex_state = 20},
  [4757] = {.lex_state = 54, .external_lex_state = 21},
  [4758] = {.lex_state = 54, .external_lex_state = 21},
  [4759] = {.lex_state = 54, .external_lex_state = 28},
  [4760] = {.lex_state = 54, .external_lex_state = 19},
  [4761] = {.lex_state = 54, .external_lex_state = 21},
  [4762] = {.lex_state = 54, .external_lex_state = 20},
  [4763] = {.lex_state = 54, .external_lex_state = 20},
  [4764] = {.lex_state = 54, .external_lex_state = 21},
  [4765] = {.lex_state = 54, .external_lex_state = 21},
  [4766] = {.lex_state = 54, .external_lex_state = 21},
  [4767] = {.lex_state = 54, .external_lex_state = 21},
  [4768] = {.lex_state = 54, .external_lex_state = 21},
  [4769] = {.lex_state = 54, .external_lex_state = 21},
  [4770] = {.lex_state = 54, .external_lex_state = 21},
  [4771] = {.lex_state = 54, .external_lex_state = 19},
  [4772] = {.lex_state = 53, .external_lex_state = 37},
  [4773] = {.lex_state = 54, .external_lex_state = 21},
  [4774] = {.lex_state = 54, .external_lex_state = 21},
  [4775] = {.lex_state = 54, .external_lex_state = 169},
  [4776] = {.lex_state = 54, .external_lex_state = 20},
  [4777] = {.lex_state = 54, .external_lex_state = 163},
  [4778] = {.lex_state = 54, .external_lex_state = 21},
  [4779] = {.lex_state = 54, .external_lex_state = 20},
  [4780] = {.lex_state = 54, .external_lex_state = 20},
  [4781] = {.lex_state = 54, .external_lex_state = 19},
  [4782] = {.lex_state = 47, .external_lex_state = 177},
  [4783] = {.lex_state = 54, .external_lex_state = 20},
  [4784] = {.lex_state = 54, .external_lex_state = 18},
  [4785] = {.lex_state = 54, .external_lex_state = 20},
  [4786] = {.lex_state = 54, .external_lex_state = 19},
  [4787] = {.lex_state = 54, .external_lex_state = 21},
  [4788] = {.lex_state = 54, .external_lex_state = 21},
  [4789] = {.lex_state = 54, .external_lex_state = 21},
  [4790] = {.lex_state = 54, .external_lex_state = 19},
  [4791] = {.lex_state = 54, .external_lex_state = 17},
  [4792] = {.lex_state = 54, .external_lex_state = 21},
  [4793] = {.lex_state = 54, .external_lex_state = 19},
  [4794] = {.lex_state = 54, .external_lex_state = 21},
  [4795] = {.lex_state = 54, .external_lex_state = 33},
  [4796] = {.lex_state = 54, .external_lex_state = 23},
  [4797] = {.lex_state = 54, .external_lex_state = 23},
  [4798] = {.lex_state = 54, .external_lex_state = 21},
  [4799] = {.lex_state = 54, .external_lex_state = 19},
  [4800] = {.lex_state = 54, .external_lex_state = 18},
  [4801] = {.lex_state = 54, .external_lex_state = 19},
  [4802] = {.lex_state = 54, .external_lex_state = 18},
  [4803] = {.lex_state = 54, .external_lex_state = 21},
  [4804] = {.lex_state = 54, .external_lex_state = 21},
  [4805] = {.lex_state = 54, .external_lex_state = 21},
  [4806] = {.lex_state = 54, .external_lex_state = 173},
  [4807] = {.lex_state = 54, .external_lex_state = 21},
  [4808] = {.lex_state = 54, .external_lex_state = 21},
  [4809] = {.lex_state = 54, .external_lex_state = 21},
  [4810] = {.lex_state = 54, .external_lex_state = 28},
  [4811] = {.lex_state = 54, .external_lex_state = 20},
  [4812] = {.lex_state = 54, .external_lex_state = 21},
  [4813] = {.lex_state = 54, .external_lex_state = 23},
  [4814] = {.lex_state = 53, .external_lex_state = 37},
  [4815] = {.lex_state = 54, .external_lex_state = 21},
  [4816] = {.lex_state = 54, .external_lex_state = 19},
  [4817] = {.lex_state = 54, .external_lex_state = 18},
  [4818] = {.lex_state = 54, .external_lex_state = 20},
  [4819] = {.lex_state = 54, .external_lex_state = 19},
  [4820] = {.lex_state = 54, .external_lex_state = 18},
  [4821] = {.lex_state = 54, .external_lex_state = 21},
  [4822] = {.lex_state = 54, .external_lex_state = 21},
  [4823] = {.lex_state = 54, .external_lex_state = 21},
  [4824] = {.lex_state = 54, .external_lex_state = 21},
  [4825] = {.lex_state = 54, .external_lex_state = 19},
  [4826] = {.lex_state = 54, .external_lex_state = 19},
  [4827] = {.lex_state = 48, .external_lex_state = 175},
  [4828] = {.lex_state = 48, .external_lex_state = 175},
  [4829] = {.lex_state = 54, .external_lex_state = 21},
  [4830] = {.lex_state = 54, .external_lex_state = 17},
  [4831] = {.lex_state = 54, .external_lex_state = 162},
  [4832] = {.lex_state = 54, .external_lex_state = 33},
  [4833] = {.lex_state = 54, .external_lex_state = 19},
  [4834] = {.lex_state = 54, .external_lex_state = 18},
  [4835] = {.lex_state = 54, .external_lex_state = 21},
  [4836] = {.lex_state = 54, .external_lex_state = 21},
  [4837] = {.lex_state = 54, .external_lex_state = 21},
  [4838] = {.lex_state = 53, .external_lex_state = 30},
  [4839] = {.lex_state = 54, .external_lex_state = 21},
  [4840] = {.lex_state = 54, .external_lex_state = 21},
  [4841] = {.lex_state = 54, .external_lex_state = 33},
  [4842] = {.lex_state = 54, .external_lex_state = 18},
  [4843] = {.lex_state = 54, .external_lex_state = 19},
  [4844] = {.lex_state = 54, .external_lex_state = 21},
  [4845] = {.lex_state = 54, .external_lex_state = 33},
  [4846] = {.lex_state = 54, .external_lex_state = 18},
  [4847] = {.lex_state = 54, .external_lex_state = 21},
  [4848] = {.lex_state = 54, .external_lex_state = 21},
  [4849] = {.lex_state = 54, .external_lex_state = 21},
  [4850] = {.lex_state = 54, .external_lex_state = 21},
  [4851] = {.lex_state = 54, .external_lex_state = 21},
  [4852] = {.lex_state = 54, .external_lex_state = 21},
  [4853] = {.lex_state = 54, .external_lex_state = 21},
  [4854] = {.lex_state = 48, .external_lex_state = 41},
  [4855] = {.lex_state = 54, .external_lex_state = 19},
  [4856] = {.lex_state = 54, .external_lex_state = 18},
  [4857] = {.lex_state = 54, .external_lex_state = 18},
  [4858] = {.lex_state = 54, .external_lex_state = 21},
  [4859] = {.lex_state = 54, .external_lex_state = 18},
  [4860] = {.lex_state = 54, .external_lex_state = 27},
  [4861] = {.lex_state = 54, .external_lex_state = 37},
  [4862] = {.lex_state = 47, .external_lex_state = 21},
  [4863] = {.lex_state = 54, .external_lex_state = 30},
  [4864] = {.lex_state = 54, .external_lex_state = 30},
  [4865] = {.lex_state = 54, .external_lex_state = 30},
  [4866] = {.lex_state = 54, .external_lex_state = 24},
  [4867] = {.lex_state = 54, .external_lex_state = 30},
  [4868] = {.lex_state = 47, .external_lex_state = 21},
  [4869] = {.lex_state = 54, .external_lex_state = 29},
  [4870] = {.lex_state = 47, .external_lex_state = 21},
  [4871] = {.lex_state = 47, .external_lex_state = 21},
  [4872] = {.lex_state = 54, .external_lex_state = 29},
  [4873] = {.lex_state = 54, .external_lex_state = 29},
  [4874] = {.lex_state = 47, .external_lex_state = 21},
  [4875] = {.lex_state = 47, .external_lex_state = 21},
  [4876] = {.lex_state = 54, .external_lex_state = 29},
  [4877] = {.lex_state = 54, .external_lex_state = 25},
  [4878] = {.lex_state = 54, .external_lex_state = 37},
  [4879] = {.lex_state = 54, .external_lex_state = 25},
  [4880] = {.lex_state = 48, .external_lex_state = 42},
  [4881] = {.lex_state = 48, .external_lex_state = 42},
  [4882] = {.lex_state = 54, .external_lex_state = 29},
  [4883] = {.lex_state = 54, .external_lex_state = 28},
  [4884] = {.lex_state = 48, .external_lex_state = 42},
  [4885] = {.lex_state = 47, .external_lex_state = 18},
  [4886] = {.lex_state = 48, .external_lex_state = 42},
  [4887] = {.lex_state = 48, .external_lex_state = 42},
  [4888] = {.lex_state = 48, .external_lex_state = 42},
  [4889] = {.lex_state = 54, .external_lex_state = 28},
  [4890] = {.lex_state = 54, .external_lex_state = 29},
  [4891] = {.lex_state = 54, .external_lex_state = 30},
  [4892] = {.lex_state = 54, .external_lex_state = 25},
  [4893] = {.lex_state = 54, .external_lex_state = 30},
  [4894] = {.lex_state = 48, .external_lex_state = 42},
  [4895] = {.lex_state = 54, .external_lex_state = 30},
  [4896] = {.lex_state = 54, .external_lex_state = 29},
  [4897] = {.lex_state = 54, .external_lex_state = 29},
  [4898] = {.lex_state = 54, .external_lex_state = 25},
  [4899] = {.lex_state = 54, .external_lex_state = 29},
  [4900] = {.lex_state = 54, .external_lex_state = 27},
  [4901] = {.lex_state = 48, .external_lex_state = 42},
  [4902] = {.lex_state = 54, .external_lex_state = 178},
  [4903] = {.lex_state = 48, .external_lex_state = 42},
  [4904] = {.lex_state = 47, .external_lex_state = 21},
  [4905] = {.lex_state = 54, .external_lex_state = 29},
  [4906] = {.lex_state = 54, .external_lex_state = 25},
  [4907] = {.lex_state = 54, .external_lex_state = 29},
  [4908] = {.lex_state = 47, .external_lex_state = 18},
  [4909] = {.lex_state = 54, .external_lex_state = 29},
  [4910] = {.lex_state = 54, .external_lex_state = 30},
  [4911] = {.lex_state = 54, .external_lex_state = 30},
  [4912] = {.lex_state = 54, .external_lex_state = 178},
  [4913] = {.lex_state = 54, .external_lex_state = 37},
  [4914] = {.lex_state = 54, .external_lex_state = 30},
  [4915] = {.lex_state = 54, .external_lex_state = 30},
  [4916] = {.lex_state = 47, .external_lex_state = 21},
  [4917] = {.lex_state = 48, .external_lex_state = 42},
  [4918] = {.lex_state = 48, .external_lex_state = 42},
  [4919] = {.lex_state = 54, .external_lex_state = 30},
  [4920] = {.lex_state = 48, .external_lex_state = 42},
  [4921] = {.lex_state = 54, .external_lex_state = 30},
  [4922] = {.lex_state = 48, .external_lex_state = 42},
  [4923] = {.lex_state = 48, .external_lex_state = 42},
  [4924] = {.lex_state = 48, .external_lex_state = 42},
  [4925] = {.lex_state = 48, .external_lex_state = 42},
  [4926] = {.lex_state = 54, .external_lex_state = 25},
  [4927] = {.lex_state = 47, .external_lex_state = 21},
  [4928] = {.lex_state = 54, .external_lex_state = 30},
  [4929] = {.lex_state = 54, .external_lex_state = 30},
  [4930] = {.lex_state = 54, .external_lex_state = 178},
  [4931] = {.lex_state = 54, .external_lex_state = 30},
  [4932] = {.lex_state = 54, .external_lex_state = 30},
  [4933] = {.lex_state = 54, .external_lex_state = 30},
  [4934] = {.lex_state = 54, .external_lex_state = 29},
  [4935] = {.lex_state = 54, .external_lex_state = 30},
  [4936] = {.lex_state = 54, .external_lex_state = 26},
  [4937] = {.lex_state = 54, .external_lex_state = 27},
  [4938] = {.lex_state = 48, .external_lex_state = 42},
  [4939] = {.lex_state = 48, .external_lex_state = 42},
  [4940] = {.lex_state = 54, .external_lex_state = 30},
  [4941] = {.lex_state = 54, .external_lex_state = 26},
  [4942] = {.lex_state = 54, .external_lex_state = 30},
  [4943] = {.lex_state = 54, .external_lex_state = 26},
  [4944] = {.lex_state = 54, .external_lex_state = 37},
  [4945] = {.lex_state = 54, .external_lex_state = 25},
  [4946] = {.lex_state = 47, .external_lex_state = 18},
  [4947] = {.lex_state = 54, .external_lex_state = 30},
  [4948] = {.lex_state = 54, .external_lex_state = 37},
  [4949] = {.lex_state = 54, .external_lex_state = 25},
  [4950] = {.lex_state = 54, .external_lex_state = 26},
  [4951] = {.lex_state = 54, .external_lex_state = 26},
  [4952] = {.lex_state = 54, .external_lex_state = 26},
  [4953] = {.lex_state = 54, .external_lex_state = 26},
  [4954] = {.lex_state = 54, .external_lex_state = 25},
  [4955] = {.lex_state = 54, .external_lex_state = 30},
  [4956] = {.lex_state = 54, .external_lex_state = 25},
  [4957] = {.lex_state = 54, .external_lex_state = 30},
  [4958] = {.lex_state = 54, .external_lex_state = 30},
  [4959] = {.lex_state = 54, .external_lex_state = 23},
  [4960] = {.lex_state = 54, .external_lex_state = 30},
  [4961] = {.lex_state = 54, .external_lex_state = 26},
  [4962] = {.lex_state = 48, .external_lex_state = 42},
  [4963] = {.lex_state = 54, .external_lex_state = 26},
  [4964] = {.lex_state = 54, .external_lex_state = 26},
  [4965] = {.lex_state = 54, .external_lex_state = 30},
  [4966] = {.lex_state = 54, .external_lex_state = 30},
  [4967] = {.lex_state = 54, .external_lex_state = 30},
  [4968] = {.lex_state = 54, .external_lex_state = 30},
  [4969] = {.lex_state = 54, .external_lex_state = 30},
  [4970] = {.lex_state = 54, .external_lex_state = 30},
  [4971] = {.lex_state = 54, .external_lex_state = 29},
  [4972] = {.lex_state = 48, .external_lex_state = 42},
  [4973] = {.lex_state = 54, .external_lex_state = 37},
  [4974] = {.lex_state = 54, .external_lex_state = 26},
  [4975] = {.lex_state = 54, .external_lex_state = 8},
  [4976] = {.lex_state = 54, .external_lex_state = 25},
  [4977] = {.lex_state = 54, .external_lex_state = 30},
  [4978] = {.lex_state = 48, .external_lex_state = 42},
  [4979] = {.lex_state = 54, .external_lex_state = 30},
  [4980] = {.lex_state = 54, .external_lex_state = 30},
  [4981] = {.lex_state = 48, .external_lex_state = 42},
  [4982] = {.lex_state = 54, .external_lex_state = 30},
  [4983] = {.lex_state = 54, .external_lex_state = 30},
  [4984] = {.lex_state = 47, .external_lex_state = 18},
  [4985] = {.lex_state = 47, .external_lex_state = 18},
  [4986] = {.lex_state = 54, .external_lex_state = 29},
  [4987] = {.lex_state = 54, .external_lex_state = 29},
  [4988] = {.lex_state = 54, .external_lex_state = 23},
  [4989] = {.lex_state = 54, .external_lex_state = 26},
  [4990] = {.lex_state = 54, .external_lex_state = 26},
  [4991] = {.lex_state = 54, .external_lex_state = 26},
  [4992] = {.lex_state = 54, .external_lex_state = 26},
  [4993] = {.lex_state = 54, .external_lex_state = 29},
  [4994] = {.lex_state = 54, .external_lex_state = 29},
  [4995] = {.lex_state = 54, .external_lex_state = 26},
  [4996] = {.lex_state = 54, .external_lex_state = 23},
  [4997] = {.lex_state = 54, .external_lex_state = 30},
  [4998] = {.lex_state = 54, .external_lex_state = 29},
  [4999] = {.lex_state = 54, .external_lex_state = 30},
  [5000] = {.lex_state = 54, .external_lex_state = 26},
  [5001] = {.lex_state = 54, .external_lex_state = 30},
  [5002] = {.lex_state = 48, .external_lex_state = 42},
  [5003] = {.lex_state = 48, .external_lex_state = 42},
  [5004] = {.lex_state = 54, .external_lex_state = 30},
  [5005] = {.lex_state = 54, .external_lex_state = 23},
  [5006] = {.lex_state = 54, .external_lex_state = 30},
  [5007] = {.lex_state = 54, .external_lex_state = 30},
  [5008] = {.lex_state = 48, .external_lex_state = 42},
  [5009] = {.lex_state = 54, .external_lex_state = 26},
  [5010] = {.lex_state = 47, .external_lex_state = 20},
  [5011] = {.lex_state = 48, .external_lex_state = 42},
  [5012] = {.lex_state = 54, .external_lex_state = 30},
  [5013] = {.lex_state = 54, .external_lex_state = 30},
  [5014] = {.lex_state = 47, .external_lex_state = 20},
  [5015] = {.lex_state = 47, .external_lex_state = 20},
  [5016] = {.lex_state = 48, .external_lex_state = 42},
  [5017] = {.lex_state = 48, .external_lex_state = 42},
  [5018] = {.lex_state = 48, .external_lex_state = 42},
  [5019] = {.lex_state = 54, .external_lex_state = 29},
  [5020] = {.lex_state = 54, .external_lex_state = 37},
  [5021] = {.lex_state = 47, .external_lex_state = 179},
  [5022] = {.lex_state = 54, .external_lex_state = 26},
  [5023] = {.lex_state = 54, .external_lex_state = 26},
  [5024] = {.lex_state = 54, .external_lex_state = 29},
  [5025] = {.lex_state = 47, .external_lex_state = 20},
  [5026] = {.lex_state = 54, .external_lex_state = 29},
  [5027] = {.lex_state = 47, .external_lex_state = 20},
  [5028] = {.lex_state = 54, .external_lex_state = 30},
  [5029] = {.lex_state = 54, .external_lex_state = 26},
  [5030] = {.lex_state = 47, .external_lex_state = 18},
  [5031] = {.lex_state = 54, .external_lex_state = 26},
  [5032] = {.lex_state = 54, .external_lex_state = 37},
  [5033] = {.lex_state = 54, .external_lex_state = 29},
  [5034] = {.lex_state = 54, .external_lex_state = 30},
  [5035] = {.lex_state = 54, .external_lex_state = 29},
  [5036] = {.lex_state = 54, .external_lex_state = 30},
  [5037] = {.lex_state = 47, .external_lex_state = 20},
  [5038] = {.lex_state = 54, .external_lex_state = 30},
  [5039] = {.lex_state = 47, .external_lex_state = 20},
  [5040] = {.lex_state = 54, .external_lex_state = 30},
  [5041] = {.lex_state = 54, .external_lex_state = 37},
  [5042] = {.lex_state = 54, .external_lex_state = 30},
  [5043] = {.lex_state = 54, .external_lex_state = 30},
  [5044] = {.lex_state = 54, .external_lex_state = 29},
  [5045] = {.lex_state = 54, .external_lex_state = 9},
  [5046] = {.lex_state = 54, .external_lex_state = 37},
  [5047] = {.lex_state = 47, .external_lex_state = 180},
  [5048] = {.lex_state = 48, .external_lex_state = 42},
  [5049] = {.lex_state = 54, .external_lex_state = 26},
  [5050] = {.lex_state = 54, .external_lex_state = 29},
  [5051] = {.lex_state = 54, .external_lex_state = 29},
  [5052] = {.lex_state = 54, .external_lex_state = 30},
  [5053] = {.lex_state = 47, .external_lex_state = 20},
  [5054] = {.lex_state = 54, .external_lex_state = 30},
  [5055] = {.lex_state = 54, .external_lex_state = 37},
  [5056] = {.lex_state = 54, .external_lex_state = 26},
  [5057] = {.lex_state = 48, .external_lex_state = 42},
  [5058] = {.lex_state = 47, .external_lex_state = 20},
  [5059] = {.lex_state = 54, .external_lex_state = 26},
  [5060] = {.lex_state = 54, .external_lex_state = 26},
  [5061] = {.lex_state = 48, .external_lex_state = 42},
  [5062] = {.lex_state = 54, .external_lex_state = 25},
  [5063] = {.lex_state = 54, .external_lex_state = 29},
  [5064] = {.lex_state = 54, .external_lex_state = 26},
  [5065] = {.lex_state = 54, .external_lex_state = 25},
  [5066] = {.lex_state = 54, .external_lex_state = 29},
  [5067] = {.lex_state = 54, .external_lex_state = 26},
  [5068] = {.lex_state = 54, .external_lex_state = 29},
  [5069] = {.lex_state = 54, .external_lex_state = 26},
  [5070] = {.lex_state = 47, .external_lex_state = 20},
  [5071] = {.lex_state = 54, .external_lex_state = 153},
  [5072] = {.lex_state = 54, .external_lex_state = 25},
  [5073] = {.lex_state = 54, .external_lex_state = 29},
  [5074] = {.lex_state = 54, .external_lex_state = 29},
  [5075] = {.lex_state = 54, .external_lex_state = 25},
  [5076] = {.lex_state = 47, .external_lex_state = 181},
  [5077] = {.lex_state = 54, .external_lex_state = 29},
  [5078] = {.lex_state = 54, .external_lex_state = 26},
  [5079] = {.lex_state = 54, .external_lex_state = 24},
  [5080] = {.lex_state = 54, .external_lex_state = 29},
  [5081] = {.lex_state = 54, .external_lex_state = 27},
  [5082] = {.lex_state = 54, .external_lex_state = 25},
  [5083] = {.lex_state = 54, .external_lex_state = 25},
  [5084] = {.lex_state = 54, .external_lex_state = 37},
  [5085] = {.lex_state = 54, .external_lex_state = 30},
  [5086] = {.lex_state = 54, .external_lex_state = 8},
  [5087] = {.lex_state = 47, .external_lex_state = 18},
  [5088] = {.lex_state = 54, .external_lex_state = 27},
  [5089] = {.lex_state = 54, .external_lex_state = 26},
  [5090] = {.lex_state = 54, .external_lex_state = 30},
  [5091] = {.lex_state = 54, .external_lex_state = 25},
  [5092] = {.lex_state = 54, .external_lex_state = 37},
  [5093] = {.lex_state = 54, .external_lex_state = 37},
  [5094] = {.lex_state = 54, .external_lex_state = 25},
  [5095] = {.lex_state = 54, .external_lex_state = 27},
  [5096] = {.lex_state = 54, .external_lex_state = 37},
  [5097] = {.lex_state = 54, .external_lex_state = 153},
  [5098] = {.lex_state = 54, .external_lex_state = 25},
  [5099] = {.lex_state = 54, .external_lex_state = 37},
  [5100] = {.lex_state = 54, .external_lex_state = 9},
  [5101] = {.lex_state = 54, .external_lex_state = 9},
  [5102] = {.lex_state = 54, .external_lex_state = 10},
  [5103] = {.lex_state = 54, .external_lex_state = 29},
  [5104] = {.lex_state = 54, .external_lex_state = 24},
  [5105] = {.lex_state = 54, .external_lex_state = 37},
  [5106] = {.lex_state = 54, .external_lex_state = 28},
  [5107] = {.lex_state = 54, .external_lex_state = 28},
  [5108] = {.lex_state = 54, .external_lex_state = 37},
  [5109] = {.lex_state = 47, .external_lex_state = 18},
  [5110] = {.lex_state = 54, .external_lex_state = 29},
  [5111] = {.lex_state = 47, .external_lex_state = 19},
  [5112] = {.lex_state = 54, .external_lex_state = 26},
  [5113] = {.lex_state = 54, .external_lex_state = 28},
  [5114] = {.lex_state = 54, .external_lex_state = 28},
  [5115] = {.lex_state = 54, .external_lex_state = 28},
  [5116] = {.lex_state = 54, .external_lex_state = 26},
  [5117] = {.lex_state = 54, .external_lex_state = 28},
  [5118] = {.lex_state = 54, .external_lex_state = 28},
  [5119] = {.lex_state = 54, .external_lex_state = 26},
  [5120] = {.lex_state = 54, .external_lex_state = 26},
  [5121] = {.lex_state = 54, .external_lex_state = 26},
  [5122] = {.lex_state = 54, .external_lex_state = 26},
  [5123] = {.lex_state = 54, .external_lex_state = 26},
  [5124] = {.lex_state = 54, .external_lex_state = 37},
  [5125] = {.lex_state = 54, .external_lex_state = 24},
  [5126] = {.lex_state = 54, .external_lex_state = 26},
  [5127] = {.lex_state = 54, .external_lex_state = 26},
  [5128] = {.lex_state = 48, .external_lex_state = 42},
  [5129] = {.lex_state = 54, .external_lex_state = 24},
  [5130] = {.lex_state = 54, .external_lex_state = 28},
  [5131] = {.lex_state = 54, .external_lex_state = 28},
  [5132] = {.lex_state = 54, .external_lex_state = 26},
  [5133] = {.lex_state = 54, .external_lex_state = 28},
  [5134] = {.lex_state = 54, .external_lex_state = 28},
  [5135] = {.lex_state = 54, .external_lex_state = 24},
  [5136] = {.lex_state = 54, .external_lex_state = 28},
  [5137] = {.lex_state = 54, .external_lex_state = 26},
  [5138] = {.lex_state = 54, .external_lex_state = 28},
  [5139] = {.lex_state = 54, .external_lex_state = 37},
  [5140] = {.lex_state = 54, .external_lex_state = 26},
  [5141] = {.lex_state = 48, .external_lex_state = 42},
  [5142] = {.lex_state = 54, .external_lex_state = 8},
  [5143] = {.lex_state = 54, .external_lex_state = 28},
  [5144] = {.lex_state = 47, .external_lex_state = 19},
  [5145] = {.lex_state = 54, .external_lex_state = 28},
  [5146] = {.lex_state = 54, .external_lex_state = 28},
  [5147] = {.lex_state = 47, .external_lex_state = 18},
  [5148] = {.lex_state = 54, .external_lex_state = 26},
  [5149] = {.lex_state = 54, .external_lex_state = 28},
  [5150] = {.lex_state = 54, .external_lex_state = 28},
  [5151] = {.lex_state = 54, .external_lex_state = 182},
  [5152] = {.lex_state = 54, .external_lex_state = 28},
  [5153] = {.lex_state = 54, .external_lex_state = 28},
  [5154] = {.lex_state = 54, .external_lex_state = 24},
  [5155] = {.lex_state = 47, .external_lex_state = 19},
  [5156] = {.lex_state = 54, .external_lex_state = 29},
  [5157] = {.lex_state = 54, .external_lex_state = 24},
  [5158] = {.lex_state = 54, .external_lex_state = 28},
  [5159] = {.lex_state = 47, .external_lex_state = 18},
  [5160] = {.lex_state = 54, .external_lex_state = 28},
  [5161] = {.lex_state = 54, .external_lex_state = 28},
  [5162] = {.lex_state = 54, .external_lex_state = 28},
  [5163] = {.lex_state = 54, .external_lex_state = 25},
  [5164] = {.lex_state = 54, .external_lex_state = 30},
  [5165] = {.lex_state = 54, .external_lex_state = 29},
  [5166] = {.lex_state = 54, .external_lex_state = 24},
  [5167] = {.lex_state = 54, .external_lex_state = 24},
  [5168] = {.lex_state = 54, .external_lex_state = 29},
  [5169] = {.lex_state = 54, .external_lex_state = 26},
  [5170] = {.lex_state = 54, .external_lex_state = 26},
  [5171] = {.lex_state = 54, .external_lex_state = 26},
  [5172] = {.lex_state = 54, .external_lex_state = 8},
  [5173] = {.lex_state = 54, .external_lex_state = 24},
  [5174] = {.lex_state = 54, .external_lex_state = 28},
  [5175] = {.lex_state = 54, .external_lex_state = 24},
  [5176] = {.lex_state = 54, .external_lex_state = 28},
  [5177] = {.lex_state = 54, .external_lex_state = 24},
  [5178] = {.lex_state = 54, .external_lex_state = 24},
  [5179] = {.lex_state = 54, .external_lex_state = 26},
  [5180] = {.lex_state = 54, .external_lex_state = 26},
  [5181] = {.lex_state = 54, .external_lex_state = 26},
  [5182] = {.lex_state = 54, .external_lex_state = 28},
  [5183] = {.lex_state = 47, .external_lex_state = 19},
  [5184] = {.lex_state = 54, .external_lex_state = 24},
  [5185] = {.lex_state = 54, .external_lex_state = 24},
  [5186] = {.lex_state = 54, .external_lex_state = 26},
  [5187] = {.lex_state = 54, .external_lex_state = 28},
  [5188] = {.lex_state = 47, .external_lex_state = 19},
  [5189] = {.lex_state = 54, .external_lex_state = 26},
  [5190] = {.lex_state = 54, .external_lex_state = 24},
  [5191] = {.lex_state = 54, .external_lex_state = 26},
  [5192] = {.lex_state = 54, .external_lex_state = 26},
  [5193] = {.lex_state = 54, .external_lex_state = 10},
  [5194] = {.lex_state = 54, .external_lex_state = 24},
  [5195] = {.lex_state = 54, .external_lex_state = 10},
  [5196] = {.lex_state = 54, .external_lex_state = 25},
  [5197] = {.lex_state = 54, .external_lex_state = 24},
  [5198] = {.lex_state = 54, .external_lex_state = 27},
  [5199] = {.lex_state = 54, .external_lex_state = 178},
  [5200] = {.lex_state = 54, .external_lex_state = 27},
  [5201] = {.lex_state = 54, .external_lex_state = 28},
  [5202] = {.lex_state = 47, .external_lex_state = 19},
  [5203] = {.lex_state = 47, .external_lex_state = 19},
  [5204] = {.lex_state = 54, .external_lex_state = 27},
  [5205] = {.lex_state = 54, .external_lex_state = 25},
  [5206] = {.lex_state = 54, .external_lex_state = 25},
  [5207] = {.lex_state = 54, .external_lex_state = 10},
  [5208] = {.lex_state = 54, .external_lex_state = 24},
  [5209] = {.lex_state = 54, .external_lex_state = 24},
  [5210] = {.lex_state = 47, .external_lex_state = 19},
  [5211] = {.lex_state = 54, .external_lex_state = 28},
  [5212] = {.lex_state = 47, .external_lex_state = 19},
  [5213] = {.lex_state = 54, .external_lex_state = 28},
  [5214] = {.lex_state = 54, .external_lex_state = 27},
  [5215] = {.lex_state = 47, .external_lex_state = 19},
  [5216] = {.lex_state = 54, .external_lex_state = 25},
  [5217] = {.lex_state = 54, .external_lex_state = 29},
  [5218] = {.lex_state = 48, .external_lex_state = 42},
  [5219] = {.lex_state = 54, .external_lex_state = 26},
  [5220] = {.lex_state = 54, .external_lex_state = 26},
  [5221] = {.lex_state = 54, .external_lex_state = 29},
  [5222] = {.lex_state = 54, .external_lex_state = 27},
  [5223] = {.lex_state = 54, .external_lex_state = 29},
  [5224] = {.lex_state = 54, .external_lex_state = 30},
  [5225] = {.lex_state = 54, .external_lex_state = 23},
  [5226] = {.lex_state = 54, .external_lex_state = 26},
  [5227] = {.lex_state = 54, .external_lex_state = 25},
  [5228] = {.lex_state = 54, .external_lex_state = 25},
  [5229] = {.lex_state = 54, .external_lex_state = 37},
  [5230] = {.lex_state = 54, .external_lex_state = 23},
  [5231] = {.lex_state = 54, .external_lex_state = 26},
  [5232] = {.lex_state = 54, .external_lex_state = 25},
  [5233] = {.lex_state = 54, .external_lex_state = 25},
  [5234] = {.lex_state = 54, .external_lex_state = 25},
  [5235] = {.lex_state = 54, .external_lex_state = 25},
  [5236] = {.lex_state = 54, .external_lex_state = 25},
  [5237] = {.lex_state = 54, .external_lex_state = 26},
  [5238] = {.lex_state = 54, .external_lex_state = 24},
  [5239] = {.lex_state = 54, .external_lex_state = 23},
  [5240] = {.lex_state = 54, .external_lex_state = 23},
  [5241] = {.lex_state = 54, .external_lex_state = 23},
  [5242] = {.lex_state = 54, .external_lex_state = 29},
  [5243] = {.lex_state = 54, .external_lex_state = 25},
  [5244] = {.lex_state = 54, .external_lex_state = 25},
  [5245] = {.lex_state = 54, .external_lex_state = 24},
  [5246] = {.lex_state = 54, .external_lex_state = 25},
  [5247] = {.lex_state = 54, .external_lex_state = 25},
  [5248] = {.lex_state = 54, .external_lex_state = 24},
  [5249] = {.lex_state = 54, .external_lex_state = 25},
  [5250] = {.lex_state = 54, .external_lex_state = 24},
  [5251] = {.lex_state = 54, .external_lex_state = 25},
  [5252] = {.lex_state = 54, .external_lex_state = 25},
  [5253] = {.lex_state = 54, .external_lex_state = 24},
  [5254] = {.lex_state = 54, .external_lex_state = 24},
  [5255] = {.lex_state = 54, .external_lex_state = 37},
  [5256] = {.lex_state = 54, .external_lex_state = 23},
  [5257] = {.lex_state = 54, .external_lex_state = 23},
  [5258] = {.lex_state = 54, .external_lex_state = 24},
  [5259] = {.lex_state = 54, .external_lex_state = 178},
  [5260] = {.lex_state = 54, .external_lex_state = 23},
  [5261] = {.lex_state = 54, .external_lex_state = 23},
  [5262] = {.lex_state = 54, .external_lex_state = 24},
  [5263] = {.lex_state = 54, .external_lex_state = 23},
  [5264] = {.lex_state = 54, .external_lex_state = 24},
  [5265] = {.lex_state = 54, .external_lex_state = 23},
  [5266] = {.lex_state = 54, .external_lex_state = 23},
  [5267] = {.lex_state = 54, .external_lex_state = 24},
  [5268] = {.lex_state = 54, .external_lex_state = 25},
  [5269] = {.lex_state = 54, .external_lex_state = 26},
  [5270] = {.lex_state = 54, .external_lex_state = 25},
  [5271] = {.lex_state = 54, .external_lex_state = 25},
  [5272] = {.lex_state = 54, .external_lex_state = 25},
  [5273] = {.lex_state = 54, .external_lex_state = 25},
  [5274] = {.lex_state = 54, .external_lex_state = 24},
  [5275] = {.lex_state = 54, .external_lex_state = 25},
  [5276] = {.lex_state = 54, .external_lex_state = 25},
  [5277] = {.lex_state = 54, .external_lex_state = 25},
  [5278] = {.lex_state = 54, .external_lex_state = 24},
  [5279] = {.lex_state = 54, .external_lex_state = 25},
  [5280] = {.lex_state = 54, .external_lex_state = 25},
  [5281] = {.lex_state = 54, .external_lex_state = 25},
  [5282] = {.lex_state = 54, .external_lex_state = 24},
  [5283] = {.lex_state = 54, .external_lex_state = 23},
  [5284] = {.lex_state = 54, .external_lex_state = 23},
  [5285] = {.lex_state = 54, .external_lex_state = 23},
  [5286] = {.lex_state = 54, .external_lex_state = 24},
  [5287] = {.lex_state = 54, .external_lex_state = 26},
  [5288] = {.lex_state = 54, .external_lex_state = 24},
  [5289] = {.lex_state = 54, .external_lex_state = 30},
  [5290] = {.lex_state = 54, .external_lex_state = 25},
  [5291] = {.lex_state = 54, .external_lex_state = 25},
  [5292] = {.lex_state = 54, .external_lex_state = 25},
  [5293] = {.lex_state = 54, .external_lex_state = 27},
  [5294] = {.lex_state = 54, .external_lex_state = 29},
  [5295] = {.lex_state = 54, .external_lex_state = 28},
  [5296] = {.lex_state = 54, .external_lex_state = 24},
  [5297] = {.lex_state = 54, .external_lex_state = 24},
  [5298] = {.lex_state = 54, .external_lex_state = 24},
  [5299] = {.lex_state = 54, .external_lex_state = 24},
  [5300] = {.lex_state = 54, .external_lex_state = 27},
  [5301] = {.lex_state = 54, .external_lex_state = 23},
  [5302] = {.lex_state = 54, .external_lex_state = 24},
  [5303] = {.lex_state = 54, .external_lex_state = 23},
  [5304] = {.lex_state = 54, .external_lex_state = 23},
  [5305] = {.lex_state = 54, .external_lex_state = 27},
  [5306] = {.lex_state = 54, .external_lex_state = 178},
  [5307] = {.lex_state = 54, .external_lex_state = 24},
  [5308] = {.lex_state = 54, .external_lex_state = 29},
  [5309] = {.lex_state = 54, .external_lex_state = 27},
  [5310] = {.lex_state = 48, .external_lex_state = 42},
  [5311] = {.lex_state = 47, .external_lex_state = 21},
  [5312] = {.lex_state = 54, .external_lex_state = 25},
  [5313] = {.lex_state = 54, .external_lex_state = 25},
  [5314] = {.lex_state = 54, .external_lex_state = 25},
  [5315] = {.lex_state = 54, .external_lex_state = 29},
  [5316] = {.lex_state = 54, .external_lex_state = 28},
  [5317] = {.lex_state = 54, .external_lex_state = 25},
  [5318] = {.lex_state = 54, .external_lex_state = 25},
  [5319] = {.lex_state = 54, .external_lex_state = 27},
  [5320] = {.lex_state = 54, .external_lex_state = 24},
  [5321] = {.lex_state = 54, .external_lex_state = 27},
  [5322] = {.lex_state = 54, .external_lex_state = 27},
  [5323] = {.lex_state = 54, .external_lex_state = 26},
  [5324] = {.lex_state = 54, .external_lex_state = 27},
  [5325] = {.lex_state = 54, .external_lex_state = 27},
  [5326] = {.lex_state = 54, .external_lex_state = 27},
  [5327] = {.lex_state = 54, .external_lex_state = 27},
  [5328] = {.lex_state = 54, .external_lex_state = 24},
  [5329] = {.lex_state = 54, .external_lex_state = 27},
  [5330] = {.lex_state = 54, .external_lex_state = 25},
  [5331] = {.lex_state = 54, .external_lex_state = 24},
  [5332] = {.lex_state = 54, .external_lex_state = 182},
  [5333] = {.lex_state = 54, .external_lex_state = 24},
  [5334] = {.lex_state = 54, .external_lex_state = 27},
  [5335] = {.lex_state = 54, .external_lex_state = 25},
  [5336] = {.lex_state = 54, .external_lex_state = 27},
  [5337] = {.lex_state = 54, .external_lex_state = 24},
  [5338] = {.lex_state = 54, .external_lex_state = 28},
  [5339] = {.lex_state = 54, .external_lex_state = 27},
  [5340] = {.lex_state = 54, .external_lex_state = 25},
  [5341] = {.lex_state = 54, .external_lex_state = 24},
  [5342] = {.lex_state = 54, .external_lex_state = 30},
  [5343] = {.lex_state = 54, .external_lex_state = 27},
  [5344] = {.lex_state = 54, .external_lex_state = 27},
  [5345] = {.lex_state = 54, .external_lex_state = 26},
  [5346] = {.lex_state = 54, .external_lex_state = 24},
  [5347] = {.lex_state = 54, .external_lex_state = 29},
  [5348] = {.lex_state = 54, .external_lex_state = 30},
  [5349] = {.lex_state = 54, .external_lex_state = 27},
  [5350] = {.lex_state = 54, .external_lex_state = 23},
  [5351] = {.lex_state = 54, .external_lex_state = 28},
  [5352] = {.lex_state = 54, .external_lex_state = 28},
  [5353] = {.lex_state = 54, .external_lex_state = 27},
  [5354] = {.lex_state = 54, .external_lex_state = 28},
  [5355] = {.lex_state = 54, .external_lex_state = 24},
  [5356] = {.lex_state = 54, .external_lex_state = 24},
  [5357] = {.lex_state = 54, .external_lex_state = 182},
  [5358] = {.lex_state = 54, .external_lex_state = 29},
  [5359] = {.lex_state = 54, .external_lex_state = 27},
  [5360] = {.lex_state = 54, .external_lex_state = 25},
  [5361] = {.lex_state = 54, .external_lex_state = 27},
  [5362] = {.lex_state = 54, .external_lex_state = 28},
  [5363] = {.lex_state = 54, .external_lex_state = 29},
  [5364] = {.lex_state = 54, .external_lex_state = 27},
  [5365] = {.lex_state = 54, .external_lex_state = 24},
  [5366] = {.lex_state = 54, .external_lex_state = 23},
  [5367] = {.lex_state = 54, .external_lex_state = 23},
  [5368] = {.lex_state = 54, .external_lex_state = 29},
  [5369] = {.lex_state = 54, .external_lex_state = 24},
  [5370] = {.lex_state = 54, .external_lex_state = 182},
  [5371] = {.lex_state = 54, .external_lex_state = 29},
  [5372] = {.lex_state = 54, .external_lex_state = 23},
  [5373] = {.lex_state = 54, .external_lex_state = 24},
  [5374] = {.lex_state = 54, .external_lex_state = 23},
  [5375] = {.lex_state = 54, .external_lex_state = 23},
  [5376] = {.lex_state = 47, .external_lex_state = 17},
  [5377] = {.lex_state = 54, .external_lex_state = 23},
  [5378] = {.lex_state = 54, .external_lex_state = 24},
  [5379] = {.lex_state = 47, .external_lex_state = 17},
  [5380] = {.lex_state = 47, .external_lex_state = 17},
  [5381] = {.lex_state = 54, .external_lex_state = 23},
  [5382] = {.lex_state = 54, .external_lex_state = 26},
  [5383] = {.lex_state = 54, .external_lex_state = 29},
  [5384] = {.lex_state = 54, .external_lex_state = 24},
  [5385] = {.lex_state = 54, .external_lex_state = 28},
  [5386] = {.lex_state = 47, .external_lex_state = 17},
  [5387] = {.lex_state = 47, .external_lex_state = 17},
  [5388] = {.lex_state = 54, .external_lex_state = 29},
  [5389] = {.lex_state = 54, .external_lex_state = 28},
  [5390] = {.lex_state = 54, .external_lex_state = 23},
  [5391] = {.lex_state = 54, .external_lex_state = 23},
  [5392] = {.lex_state = 54, .external_lex_state = 23},
  [5393] = {.lex_state = 54, .external_lex_state = 23},
  [5394] = {.lex_state = 47, .external_lex_state = 17},
  [5395] = {.lex_state = 54, .external_lex_state = 28},
  [5396] = {.lex_state = 47, .external_lex_state = 17},
  [5397] = {.lex_state = 54, .external_lex_state = 29},
  [5398] = {.lex_state = 54, .external_lex_state = 28},
  [5399] = {.lex_state = 54, .external_lex_state = 23},
  [5400] = {.lex_state = 54, .external_lex_state = 27},
  [5401] = {.lex_state = 54, .external_lex_state = 27},
  [5402] = {.lex_state = 54, .external_lex_state = 24},
  [5403] = {.lex_state = 54, .external_lex_state = 23},
  [5404] = {.lex_state = 54, .external_lex_state = 24},
  [5405] = {.lex_state = 54, .external_lex_state = 182},
  [5406] = {.lex_state = 54, .external_lex_state = 24},
  [5407] = {.lex_state = 47, .external_lex_state = 17},
  [5408] = {.lex_state = 54, .external_lex_state = 24},
  [5409] = {.lex_state = 54, .external_lex_state = 29},
  [5410] = {.lex_state = 54, .external_lex_state = 24},
  [5411] = {.lex_state = 54, .external_lex_state = 24},
  [5412] = {.lex_state = 47, .external_lex_state = 17},
  [5413] = {.lex_state = 54, .external_lex_state = 28},
  [5414] = {.lex_state = 54, .external_lex_state = 25},
  [5415] = {.lex_state = 54, .external_lex_state = 23},
  [5416] = {.lex_state = 54, .external_lex_state = 28},
  [5417] = {.lex_state = 54, .external_lex_state = 23},
  [5418] = {.lex_state = 54, .external_lex_state = 23},
  [5419] = {.lex_state = 47, .external_lex_state = 17},
  [5420] = {.lex_state = 54, .external_lex_state = 25},
  [5421] = {.lex_state = 54, .external_lex_state = 23},
  [5422] = {.lex_state = 54, .external_lex_state = 26},
  [5423] = {.lex_state = 54, .external_lex_state = 23},
  [5424] = {.lex_state = 54, .external_lex_state = 24},
  [5425] = {.lex_state = 54, .external_lex_state = 23},
  [5426] = {.lex_state = 54, .external_lex_state = 23},
  [5427] = {.lex_state = 54, .external_lex_state = 30},
  [5428] = {.lex_state = 54, .external_lex_state = 23},
  [5429] = {.lex_state = 54, .external_lex_state = 23},
  [5430] = {.lex_state = 54, .external_lex_state = 30},
  [5431] = {.lex_state = 54, .external_lex_state = 27},
  [5432] = {.lex_state = 54, .external_lex_state = 28},
  [5433] = {.lex_state = 54, .external_lex_state = 30},
  [5434] = {.lex_state = 54, .external_lex_state = 29},
  [5435] = {.lex_state = 54, .external_lex_state = 23},
  [5436] = {.lex_state = 54, .external_lex_state = 182},
  [5437] = {.lex_state = 54, .external_lex_state = 29},
  [5438] = {.lex_state = 54, .external_lex_state = 27},
  [5439] = {.lex_state = 54, .external_lex_state = 27},
  [5440] = {.lex_state = 54, .external_lex_state = 29},
  [5441] = {.lex_state = 54, .external_lex_state = 29},
  [5442] = {.lex_state = 54, .external_lex_state = 27},
  [5443] = {.lex_state = 54, .external_lex_state = 27},
  [5444] = {.lex_state = 54, .external_lex_state = 27},
  [5445] = {.lex_state = 54, .external_lex_state = 27},
  [5446] = {.lex_state = 54, .external_lex_state = 27},
  [5447] = {.lex_state = 54, .external_lex_state = 29},
  [5448] = {.lex_state = 54, .external_lex_state = 29},
  [5449] = {.lex_state = 54, .external_lex_state = 27},
  [5450] = {.lex_state = 54, .external_lex_state = 27},
  [5451] = {.lex_state = 54, .external_lex_state = 27},
  [5452] = {.lex_state = 54, .external_lex_state = 27},
  [5453] = {.lex_state = 54, .external_lex_state = 30},
  [5454] = {.lex_state = 54, .external_lex_state = 27},
  [5455] = {.lex_state = 54, .external_lex_state = 29},
  [5456] = {.lex_state = 54, .external_lex_state = 27},
  [5457] = {.lex_state = 54, .external_lex_state = 29},
  [5458] = {.lex_state = 54, .external_lex_state = 29},
  [5459] = {.lex_state = 54, .external_lex_state = 27},
  [5460] = {.lex_state = 54, .external_lex_state = 27},
  [5461] = {.lex_state = 54, .external_lex_state = 27},
  [5462] = {.lex_state = 54, .external_lex_state = 27},
  [5463] = {.lex_state = 54, .external_lex_state = 27},
  [5464] = {.lex_state = 54, .external_lex_state = 27},
  [5465] = {.lex_state = 54, .external_lex_state = 27},
  [5466] = {.lex_state = 54, .external_lex_state = 30},
  [5467] = {.lex_state = 54, .external_lex_state = 30},
  [5468] = {.lex_state = 54, .external_lex_state = 27},
  [5469] = {.lex_state = 54, .external_lex_state = 29},
  [5470] = {.lex_state = 54, .external_lex_state = 27},
  [5471] = {.lex_state = 54, .external_lex_state = 27},
  [5472] = {.lex_state = 54, .external_lex_state = 27},
  [5473] = {.lex_state = 54, .external_lex_state = 30},
  [5474] = {.lex_state = 54, .external_lex_state = 153},
  [5475] = {.lex_state = 54, .external_lex_state = 24},
  [5476] = {.lex_state = 54, .external_lex_state = 24},
  [5477] = {.lex_state = 54, .external_lex_state = 27},
  [5478] = {.lex_state = 54, .external_lex_state = 27},
  [5479] = {.lex_state = 54, .external_lex_state = 30},
  [5480] = {.lex_state = 54, .external_lex_state = 27},
  [5481] = {.lex_state = 54, .external_lex_state = 25},
  [5482] = {.lex_state = 54, .external_lex_state = 30},
  [5483] = {.lex_state = 54, .external_lex_state = 30},
  [5484] = {.lex_state = 54, .external_lex_state = 27},
  [5485] = {.lex_state = 54, .external_lex_state = 30},
  [5486] = {.lex_state = 54, .external_lex_state = 23},
  [5487] = {.lex_state = 54, .external_lex_state = 27},
  [5488] = {.lex_state = 54, .external_lex_state = 30},
  [5489] = {.lex_state = 54, .external_lex_state = 31},
  [5490] = {.lex_state = 54, .external_lex_state = 33},
  [5491] = {.lex_state = 48, .external_lex_state = 183},
  [5492] = {.lex_state = 47, .external_lex_state = 23},
  [5493] = {.lex_state = 54, .external_lex_state = 31},
  [5494] = {.lex_state = 54, .external_lex_state = 32},
  [5495] = {.lex_state = 54, .external_lex_state = 31},
  [5496] = {.lex_state = 47, .external_lex_state = 27},
  [5497] = {.lex_state = 47, .external_lex_state = 24},
  [5498] = {.lex_state = 47, .external_lex_state = 27},
  [5499] = {.lex_state = 54, .external_lex_state = 31},
  [5500] = {.lex_state = 47, .external_lex_state = 27},
  [5501] = {.lex_state = 47, .external_lex_state = 27},
  [5502] = {.lex_state = 47, .external_lex_state = 27},
  [5503] = {.lex_state = 47, .external_lex_state = 27},
  [5504] = {.lex_state = 54, .external_lex_state = 31},
  [5505] = {.lex_state = 47, .external_lex_state = 27},
  [5506] = {.lex_state = 47, .external_lex_state = 27},
  [5507] = {.lex_state = 47, .external_lex_state = 27},
  [5508] = {.lex_state = 54, .external_lex_state = 31},
  [5509] = {.lex_state = 54, .external_lex_state = 31},
  [5510] = {.lex_state = 47, .external_lex_state = 24},
  [5511] = {.lex_state = 54, .external_lex_state = 31},
  [5512] = {.lex_state = 54, .external_lex_state = 32},
  [5513] = {.lex_state = 54, .external_lex_state = 33},
  [5514] = {.lex_state = 47, .external_lex_state = 24},
  [5515] = {.lex_state = 54, .external_lex_state = 31},
  [5516] = {.lex_state = 54, .external_lex_state = 29},
  [5517] = {.lex_state = 47, .external_lex_state = 23},
  [5518] = {.lex_state = 47, .external_lex_state = 23},
  [5519] = {.lex_state = 54, .external_lex_state = 31},
  [5520] = {.lex_state = 47, .external_lex_state = 23},
  [5521] = {.lex_state = 47, .external_lex_state = 24},
  [5522] = {.lex_state = 54, .external_lex_state = 31},
  [5523] = {.lex_state = 54, .external_lex_state = 33},
  [5524] = {.lex_state = 47, .external_lex_state = 23},
  [5525] = {.lex_state = 47, .external_lex_state = 23},
  [5526] = {.lex_state = 47, .external_lex_state = 23},
  [5527] = {.lex_state = 54, .external_lex_state = 31},
  [5528] = {.lex_state = 54, .external_lex_state = 31},
  [5529] = {.lex_state = 54, .external_lex_state = 163},
  [5530] = {.lex_state = 47, .external_lex_state = 23},
  [5531] = {.lex_state = 54, .external_lex_state = 31},
  [5532] = {.lex_state = 54, .external_lex_state = 31},
  [5533] = {.lex_state = 47, .external_lex_state = 26},
  [5534] = {.lex_state = 47, .external_lex_state = 23},
  [5535] = {.lex_state = 54, .external_lex_state = 31},
  [5536] = {.lex_state = 54, .external_lex_state = 32},
  [5537] = {.lex_state = 54, .external_lex_state = 33},
  [5538] = {.lex_state = 47, .external_lex_state = 24},
  [5539] = {.lex_state = 47, .external_lex_state = 26},
  [5540] = {.lex_state = 54, .external_lex_state = 31},
  [5541] = {.lex_state = 54, .external_lex_state = 29},
  [5542] = {.lex_state = 48, .external_lex_state = 183},
  [5543] = {.lex_state = 48, .external_lex_state = 183},
  [5544] = {.lex_state = 54, .external_lex_state = 31},
  [5545] = {.lex_state = 54, .external_lex_state = 31},
  [5546] = {.lex_state = 47, .external_lex_state = 25},
  [5547] = {.lex_state = 54, .external_lex_state = 32},
  [5548] = {.lex_state = 47, .external_lex_state = 25},
  [5549] = {.lex_state = 47, .external_lex_state = 25},
  [5550] = {.lex_state = 54, .external_lex_state = 31},
  [5551] = {.lex_state = 48, .external_lex_state = 183},
  [5552] = {.lex_state = 54, .external_lex_state = 32},
  [5553] = {.lex_state = 47, .external_lex_state = 24},
  [5554] = {.lex_state = 54, .external_lex_state = 31},
  [5555] = {.lex_state = 47, .external_lex_state = 25},
  [5556] = {.lex_state = 54, .external_lex_state = 163},
  [5557] = {.lex_state = 48, .external_lex_state = 183},
  [5558] = {.lex_state = 54, .external_lex_state = 31},
  [5559] = {.lex_state = 54, .external_lex_state = 32},
  [5560] = {.lex_state = 47, .external_lex_state = 25},
  [5561] = {.lex_state = 47, .external_lex_state = 25},
  [5562] = {.lex_state = 47, .external_lex_state = 26},
  [5563] = {.lex_state = 54, .external_lex_state = 31},
  [5564] = {.lex_state = 47, .external_lex_state = 25},
  [5565] = {.lex_state = 47, .external_lex_state = 25},
  [5566] = {.lex_state = 47, .external_lex_state = 25},
  [5567] = {.lex_state = 54, .external_lex_state = 32},
  [5568] = {.lex_state = 47, .external_lex_state = 25},
  [5569] = {.lex_state = 47, .external_lex_state = 24},
  [5570] = {.lex_state = 54, .external_lex_state = 32},
  [5571] = {.lex_state = 47, .external_lex_state = 26},
  [5572] = {.lex_state = 48, .external_lex_state = 183},
  [5573] = {.lex_state = 54, .external_lex_state = 31},
  [5574] = {.lex_state = 47, .external_lex_state = 24},
  [5575] = {.lex_state = 54, .external_lex_state = 33},
  [5576] = {.lex_state = 54, .external_lex_state = 32},
  [5577] = {.lex_state = 54, .external_lex_state = 31},
  [5578] = {.lex_state = 54, .external_lex_state = 33},
  [5579] = {.lex_state = 54, .external_lex_state = 29},
  [5580] = {.lex_state = 54, .external_lex_state = 33},
  [5581] = {.lex_state = 54, .external_lex_state = 33},
  [5582] = {.lex_state = 54, .external_lex_state = 32},
  [5583] = {.lex_state = 47, .external_lex_state = 28},
  [5584] = {.lex_state = 54, .external_lex_state = 33},
  [5585] = {.lex_state = 54, .external_lex_state = 33},
  [5586] = {.lex_state = 54, .external_lex_state = 33},
  [5587] = {.lex_state = 54, .external_lex_state = 33},
  [5588] = {.lex_state = 54, .external_lex_state = 33},
  [5589] = {.lex_state = 47, .external_lex_state = 28},
  [5590] = {.lex_state = 54, .external_lex_state = 33},
  [5591] = {.lex_state = 54, .external_lex_state = 33},
  [5592] = {.lex_state = 47, .external_lex_state = 28},
  [5593] = {.lex_state = 54, .external_lex_state = 33},
  [5594] = {.lex_state = 54, .external_lex_state = 31},
  [5595] = {.lex_state = 54, .external_lex_state = 33},
  [5596] = {.lex_state = 47, .external_lex_state = 23},
  [5597] = {.lex_state = 54, .external_lex_state = 31},
  [5598] = {.lex_state = 47, .external_lex_state = 26},
  [5599] = {.lex_state = 54, .external_lex_state = 32},
  [5600] = {.lex_state = 54, .external_lex_state = 33},
  [5601] = {.lex_state = 47, .external_lex_state = 26},
  [5602] = {.lex_state = 54, .external_lex_state = 32},
  [5603] = {.lex_state = 47, .external_lex_state = 28},
  [5604] = {.lex_state = 54, .external_lex_state = 33},
  [5605] = {.lex_state = 47, .external_lex_state = 28},
  [5606] = {.lex_state = 54, .external_lex_state = 33},
  [5607] = {.lex_state = 54, .external_lex_state = 31},
  [5608] = {.lex_state = 54, .external_lex_state = 32},
  [5609] = {.lex_state = 54, .external_lex_state = 33},
  [5610] = {.lex_state = 54, .external_lex_state = 33},
  [5611] = {.lex_state = 54, .external_lex_state = 33},
  [5612] = {.lex_state = 54, .external_lex_state = 33},
  [5613] = {.lex_state = 54, .external_lex_state = 33},
  [5614] = {.lex_state = 54, .external_lex_state = 33},
  [5615] = {.lex_state = 47, .external_lex_state = 26},
  [5616] = {.lex_state = 47, .external_lex_state = 26},
  [5617] = {.lex_state = 54, .external_lex_state = 33},
  [5618] = {.lex_state = 54, .external_lex_state = 33},
  [5619] = {.lex_state = 47, .external_lex_state = 28},
  [5620] = {.lex_state = 54, .external_lex_state = 33},
  [5621] = {.lex_state = 47, .external_lex_state = 28},
  [5622] = {.lex_state = 54, .external_lex_state = 32},
  [5623] = {.lex_state = 47, .external_lex_state = 26},
  [5624] = {.lex_state = 47, .external_lex_state = 24},
  [5625] = {.lex_state = 54, .external_lex_state = 31},
  [5626] = {.lex_state = 47, .external_lex_state = 27},
  [5627] = {.lex_state = 54, .external_lex_state = 31},
  [5628] = {.lex_state = 54, .external_lex_state = 33},
  [5629] = {.lex_state = 54, .external_lex_state = 33},
  [5630] = {.lex_state = 47, .external_lex_state = 28},
  [5631] = {.lex_state = 54, .external_lex_state = 33},
  [5632] = {.lex_state = 54, .external_lex_state = 33},
  [5633] = {.lex_state = 47, .external_lex_state = 28},
  [5634] = {.lex_state = 54, .external_lex_state = 29},
  [5635] = {.lex_state = 47, .external_lex_state = 28},
  [5636] = {.lex_state = 54, .external_lex_state = 33},
  [5637] = {.lex_state = 54, .external_lex_state = 32},
  [5638] = {.lex_state = 54, .external_lex_state = 32},
  [5639] = {.lex_state = 54, .external_lex_state = 32},
  [5640] = {.lex_state = 54, .external_lex_state = 31},
  [5641] = {.lex_state = 54, .external_lex_state = 163},
  [5642] = {.lex_state = 54, .external_lex_state = 31},
  [5643] = {.lex_state = 54, .external_lex_state = 33},
  [5644] = {.lex_state = 54, .external_lex_state = 33},
  [5645] = {.lex_state = 54, .external_lex_state = 33},
  [5646] = {.lex_state = 54, .external_lex_state = 33},
  [5647] = {.lex_state = 54, .external_lex_state = 33},
  [5648] = {.lex_state = 54, .external_lex_state = 33},
  [5649] = {.lex_state = 54, .external_lex_state = 33},
  [5650] = {.lex_state = 54, .external_lex_state = 32},
  [5651] = {.lex_state = 54, .external_lex_state = 33},
  [5652] = {.lex_state = 54, .external_lex_state = 33},
  [5653] = {.lex_state = 54, .external_lex_state = 33},
  [5654] = {.lex_state = 54, .external_lex_state = 33},
  [5655] = {.lex_state = 54, .external_lex_state = 33},
  [5656] = {.lex_state = 54, .external_lex_state = 33},
  [5657] = {.lex_state = 47, .external_lex_state = 30},
  [5658] = {.lex_state = 48, .external_lex_state = 184},
  [5659] = {.lex_state = 48, .external_lex_state = 184},
  [5660] = {.lex_state = 47, .external_lex_state = 30},
  [5661] = {.lex_state = 47, .external_lex_state = 30},
  [5662] = {.lex_state = 48, .external_lex_state = 184},
  [5663] = {.lex_state = 48, .external_lex_state = 184},
  [5664] = {.lex_state = 47, .external_lex_state = 30},
  [5665] = {.lex_state = 48, .external_lex_state = 184},
  [5666] = {.lex_state = 47, .external_lex_state = 30},
  [5667] = {.lex_state = 54, .external_lex_state = 31},
  [5668] = {.lex_state = 54, .external_lex_state = 31},
  [5669] = {.lex_state = 54, .external_lex_state = 31},
  [5670] = {.lex_state = 54, .external_lex_state = 32},
  [5671] = {.lex_state = 54, .external_lex_state = 32},
  [5672] = {.lex_state = 47, .external_lex_state = 30},
  [5673] = {.lex_state = 47, .external_lex_state = 30},
  [5674] = {.lex_state = 47, .external_lex_state = 185},
  [5675] = {.lex_state = 54, .external_lex_state = 32},
  [5676] = {.lex_state = 54, .external_lex_state = 32},
  [5677] = {.lex_state = 54, .external_lex_state = 31},
  [5678] = {.lex_state = 54, .external_lex_state = 31},
  [5679] = {.lex_state = 47, .external_lex_state = 26},
  [5680] = {.lex_state = 47, .external_lex_state = 24},
  [5681] = {.lex_state = 48, .external_lex_state = 184},
  [5682] = {.lex_state = 54, .external_lex_state = 31},
  [5683] = {.lex_state = 54, .external_lex_state = 31},
  [5684] = {.lex_state = 54, .external_lex_state = 31},
  [5685] = {.lex_state = 47, .external_lex_state = 30},
  [5686] = {.lex_state = 54, .external_lex_state = 32},
  [5687] = {.lex_state = 54, .external_lex_state = 32},
  [5688] = {.lex_state = 54, .external_lex_state = 31},
  [5689] = {.lex_state = 54, .external_lex_state = 32},
  [5690] = {.lex_state = 54, .external_lex_state = 32},
  [5691] = {.lex_state = 54, .external_lex_state = 29},
  [5692] = {.lex_state = 47, .external_lex_state = 30},
  [5693] = {.lex_state = 54, .external_lex_state = 32},
  [5694] = {.lex_state = 47, .external_lex_state = 30},
  [5695] = {.lex_state = 54, .external_lex_state = 31},
  [5696] = {.lex_state = 54, .external_lex_state = 31},
  [5697] = {.lex_state = 54, .external_lex_state = 32},
  [5698] = {.lex_state = 54, .external_lex_state = 31},
  [5699] = {.lex_state = 54, .external_lex_state = 31},
  [5700] = {.lex_state = 54, .external_lex_state = 32},
  [5701] = {.lex_state = 54, .external_lex_state = 32},
  [5702] = {.lex_state = 54, .external_lex_state = 32},
  [5703] = {.lex_state = 54, .external_lex_state = 32},
  [5704] = {.lex_state = 54, .external_lex_state = 32},
  [5705] = {.lex_state = 54, .external_lex_state = 32},
  [5706] = {.lex_state = 54, .external_lex_state = 31},
  [5707] = {.lex_state = 54, .external_lex_state = 32},
  [5708] = {.lex_state = 54, .external_lex_state = 32},
  [5709] = {.lex_state = 54, .external_lex_state = 32},
  [5710] = {.lex_state = 54, .external_lex_state = 31},
  [5711] = {.lex_state = 54, .external_lex_state = 32},
  [5712] = {.lex_state = 54, .external_lex_state = 29},
  [5713] = {.lex_state = 54, .external_lex_state = 32},
  [5714] = {.lex_state = 54, .external_lex_state = 31},
  [5715] = {.lex_state = 54, .external_lex_state = 31},
  [5716] = {.lex_state = 54, .external_lex_state = 31},
  [5717] = {.lex_state = 54, .external_lex_state = 31},
  [5718] = {.lex_state = 54, .external_lex_state = 32},
  [5719] = {.lex_state = 54, .external_lex_state = 32},
  [5720] = {.lex_state = 54, .external_lex_state = 31},
  [5721] = {.lex_state = 54, .external_lex_state = 31},
  [5722] = {.lex_state = 54, .external_lex_state = 31},
  [5723] = {.lex_state = 54, .external_lex_state = 31},
  [5724] = {.lex_state = 54, .external_lex_state = 32},
  [5725] = {.lex_state = 54, .external_lex_state = 31},
  [5726] = {.lex_state = 54, .external_lex_state = 31},
  [5727] = {.lex_state = 54, .external_lex_state = 32},
  [5728] = {.lex_state = 54, .external_lex_state = 31},
  [5729] = {.lex_state = 54, .external_lex_state = 29},
  [5730] = {.lex_state = 54, .external_lex_state = 32},
  [5731] = {.lex_state = 54, .external_lex_state = 32},
  [5732] = {.lex_state = 54, .external_lex_state = 32},
  [5733] = {.lex_state = 54, .external_lex_state = 32},
  [5734] = {.lex_state = 54, .external_lex_state = 31},
  [5735] = {.lex_state = 54, .external_lex_state = 31},
  [5736] = {.lex_state = 54, .external_lex_state = 31},
  [5737] = {.lex_state = 54, .external_lex_state = 32},
  [5738] = {.lex_state = 54, .external_lex_state = 32},
  [5739] = {.lex_state = 54, .external_lex_state = 29},
  [5740] = {.lex_state = 54, .external_lex_state = 31},
  [5741] = {.lex_state = 54, .external_lex_state = 31},
  [5742] = {.lex_state = 54, .external_lex_state = 32},
  [5743] = {.lex_state = 54, .external_lex_state = 29},
  [5744] = {.lex_state = 54, .external_lex_state = 32},
  [5745] = {.lex_state = 54, .external_lex_state = 32},
  [5746] = {.lex_state = 54, .external_lex_state = 32},
  [5747] = {.lex_state = 54, .external_lex_state = 32},
  [5748] = {.lex_state = 54, .external_lex_state = 32},
  [5749] = {.lex_state = 54, .external_lex_state = 32},
  [5750] = {.lex_state = 54, .external_lex_state = 32},
  [5751] = {.lex_state = 54, .external_lex_state = 32},
  [5752] = {.lex_state = 54, .external_lex_state = 31},
  [5753] = {.lex_state = 54, .external_lex_state = 32},
  [5754] = {.lex_state = 54, .external_lex_state = 31},
  [5755] = {.lex_state = 54, .external_lex_state = 32},
  [5756] = {.lex_state = 54, .external_lex_state = 32},
  [5757] = {.lex_state = 54, .external_lex_state = 32},
  [5758] = {.lex_state = 54, .external_lex_state = 32},
  [5759] = {.lex_state = 54, .external_lex_state = 32},
  [5760] = {.lex_state = 54, .external_lex_state = 29},
  [5761] = {.lex_state = 54, .external_lex_state = 32},
  [5762] = {.lex_state = 48, .external_lex_state = 45},
  [5763] = {.lex_state = 48, .external_lex_state = 186},
  [5764] = {.lex_state = 47, .external_lex_state = 32},
  [5765] = {.lex_state = 47, .external_lex_state = 32},
  [5766] = {.lex_state = 48, .external_lex_state = 45},
  [5767] = {.lex_state = 54, .external_lex_state = 37},
  [5768] = {.lex_state = 48, .external_lex_state = 45},
  [5769] = {.lex_state = 48, .external_lex_state = 45},
  [5770] = {.lex_state = 48, .external_lex_state = 45},
  [5771] = {.lex_state = 48, .external_lex_state = 45},
  [5772] = {.lex_state = 48, .external_lex_state = 45},
  [5773] = {.lex_state = 48, .external_lex_state = 45},
  [5774] = {.lex_state = 48, .external_lex_state = 45},
  [5775] = {.lex_state = 48, .external_lex_state = 45},
  [5776] = {.lex_state = 48, .external_lex_state = 45},
  [5777] = {.lex_state = 48, .external_lex_state = 45},
  [5778] = {.lex_state = 48, .external_lex_state = 45},
  [5779] = {.lex_state = 48, .external_lex_state = 45},
  [5780] = {.lex_state = 48, .external_lex_state = 45},
  [5781] = {.lex_state = 48, .external_lex_state = 45},
  [5782] = {.lex_state = 48, .external_lex_state = 45},
  [5783] = {.lex_state = 48, .external_lex_state = 45},
  [5784] = {.lex_state = 48, .external_lex_state = 45},
  [5785] = {.lex_state = 48, .external_lex_state = 44},
  [5786] = {.lex_state = 54, .external_lex_state = 37},
  [5787] = {.lex_state = 48, .external_lex_state = 186},
  [5788] = {.lex_state = 48, .external_lex_state = 45},
  [5789] = {.lex_state = 48, .external_lex_state = 187},
  [5790] = {.lex_state = 54, .external_lex_state = 37},
  [5791] = {.lex_state = 54, .external_lex_state = 37},
  [5792] = {.lex_state = 48, .external_lex_state = 186},
  [5793] = {.lex_state = 48, .external_lex_state = 186},
  [5794] = {.lex_state = 48, .external_lex_state = 187},
  [5795] = {.lex_state = 54, .external_lex_state = 37},
  [5796] = {.lex_state = 54, .external_lex_state = 37},
  [5797] = {.lex_state = 54, .external_lex_state = 37},
  [5798] = {.lex_state = 54, .external_lex_state = 37},
  [5799] = {.lex_state = 47, .external_lex_state = 32},
  [5800] = {.lex_state = 54, .external_lex_state = 37},
  [5801] = {.lex_state = 54, .external_lex_state = 37},
  [5802] = {.lex_state = 54, .external_lex_state = 37},
  [5803] = {.lex_state = 54, .external_lex_state = 37},
  [5804] = {.lex_state = 54, .external_lex_state = 37},
  [5805] = {.lex_state = 47, .external_lex_state = 32},
  [5806] = {.lex_state = 54, .external_lex_state = 37},
  [5807] = {.lex_state = 54, .external_lex_state = 37},
  [5808] = {.lex_state = 54, .external_lex_state = 37},
  [5809] = {.lex_state = 48, .external_lex_state = 45},
  [5810] = {.lex_state = 54, .external_lex_state = 37},
  [5811] = {.lex_state = 48, .external_lex_state = 45},
  [5812] = {.lex_state = 54, .external_lex_state = 37},
  [5813] = {.lex_state = 54, .external_lex_state = 37},
  [5814] = {.lex_state = 54, .external_lex_state = 37},
  [5815] = {.lex_state = 54, .external_lex_state = 37},
  [5816] = {.lex_state = 54, .external_lex_state = 37},
  [5817] = {.lex_state = 48, .external_lex_state = 45},
  [5818] = {.lex_state = 54, .external_lex_state = 37},
  [5819] = {.lex_state = 54, .external_lex_state = 37},
  [5820] = {.lex_state = 47, .external_lex_state = 32},
  [5821] = {.lex_state = 54, .external_lex_state = 37},
  [5822] = {.lex_state = 48, .external_lex_state = 44},
  [5823] = {.lex_state = 54, .external_lex_state = 37},
  [5824] = {.lex_state = 54, .external_lex_state = 37},
  [5825] = {.lex_state = 48, .external_lex_state = 44},
  [5826] = {.lex_state = 47, .external_lex_state = 32},
  [5827] = {.lex_state = 54, .external_lex_state = 37},
  [5828] = {.lex_state = 54, .external_lex_state = 37},
  [5829] = {.lex_state = 48, .external_lex_state = 44},
  [5830] = {.lex_state = 48, .external_lex_state = 44},
  [5831] = {.lex_state = 54, .external_lex_state = 37},
  [5832] = {.lex_state = 54, .external_lex_state = 37},
  [5833] = {.lex_state = 54, .external_lex_state = 37},
  [5834] = {.lex_state = 54, .external_lex_state = 37},
  [5835] = {.lex_state = 48, .external_lex_state = 45},
  [5836] = {.lex_state = 48, .external_lex_state = 44},
  [5837] = {.lex_state = 54, .external_lex_state = 37},
  [5838] = {.lex_state = 48, .external_lex_state = 44},
  [5839] = {.lex_state = 48, .external_lex_state = 44},
  [5840] = {.lex_state = 48, .external_lex_state = 44},
  [5841] = {.lex_state = 48, .external_lex_state = 44},
  [5842] = {.lex_state = 48, .external_lex_state = 44},
  [5843] = {.lex_state = 48, .external_lex_state = 44},
  [5844] = {.lex_state = 48, .external_lex_state = 44},
  [5845] = {.lex_state = 48, .external_lex_state = 44},
  [5846] = {.lex_state = 48, .external_lex_state = 44},
  [5847] = {.lex_state = 48, .external_lex_state = 44},
  [5848] = {.lex_state = 48, .external_lex_state = 44},
  [5849] = {.lex_state = 48, .external_lex_state = 44},
  [5850] = {.lex_state = 47, .external_lex_state = 32},
  [5851] = {.lex_state = 48, .external_lex_state = 44},
  [5852] = {.lex_state = 48, .external_lex_state = 44},
  [5853] = {.lex_state = 48, .external_lex_state = 44},
  [5854] = {.lex_state = 48, .external_lex_state = 44},
  [5855] = {.lex_state = 48, .external_lex_state = 186},
  [5856] = {.lex_state = 50, .external_lex_state = 188},
  [5857] = {.lex_state = 48, .external_lex_state = 44},
  [5858] = {.lex_state = 48, .external_lex_state = 44},
  [5859] = {.lex_state = 48, .external_lex_state = 44},
  [5860] = {.lex_state = 48, .external_lex_state = 186},
  [5861] = {.lex_state = 47, .external_lex_state = 32},
  [5862] = {.lex_state = 48, .external_lex_state = 187},
  [5863] = {.lex_state = 48, .external_lex_state = 187},
  [5864] = {.lex_state = 48, .external_lex_state = 45},
  [5865] = {.lex_state = 48, .external_lex_state = 189},
  [5866] = {.lex_state = 48, .external_lex_state = 189},
  [5867] = {.lex_state = 48, .external_lex_state = 190},
  [5868] = {.lex_state = 48, .external_lex_state = 190},
  [5869] = {.lex_state = 48, .external_lex_state = 44},
  [5870] = {.lex_state = 48, .external_lex_state = 44},
  [5871] = {.lex_state = 48, .external_lex_state = 44},
  [5872] = {.lex_state = 47, .external_lex_state = 33},
  [5873] = {.lex_state = 48, .external_lex_state = 189},
  [5874] = {.lex_state = 48, .external_lex_state = 190},
  [5875] = {.lex_state = 47, .external_lex_state = 31},
  [5876] = {.lex_state = 48, .external_lex_state = 187},
  [5877] = {.lex_state = 48, .external_lex_state = 187},
  [5878] = {.lex_state = 48, .external_lex_state = 45},
  [5879] = {.lex_state = 48, .external_lex_state = 44},
  [5880] = {.lex_state = 48, .external_lex_state = 191},
  [5881] = {.lex_state = 54, .external_lex_state = 37},
  [5882] = {.lex_state = 48, .external_lex_state = 44},
  [5883] = {.lex_state = 48, .external_lex_state = 44},
  [5884] = {.lex_state = 48, .external_lex_state = 45},
  [5885] = {.lex_state = 54, .external_lex_state = 37},
  [5886] = {.lex_state = 47, .external_lex_state = 33},
  [5887] = {.lex_state = 48, .external_lex_state = 44},
  [5888] = {.lex_state = 47, .external_lex_state = 33},
  [5889] = {.lex_state = 54, .external_lex_state = 37},
  [5890] = {.lex_state = 48, .external_lex_state = 45},
  [5891] = {.lex_state = 48, .external_lex_state = 44},
  [5892] = {.lex_state = 48, .external_lex_state = 44},
  [5893] = {.lex_state = 48, .external_lex_state = 191},
  [5894] = {.lex_state = 48, .external_lex_state = 192},
  [5895] = {.lex_state = 48, .external_lex_state = 44},
  [5896] = {.lex_state = 47, .external_lex_state = 32},
  [5897] = {.lex_state = 48, .external_lex_state = 191},
  [5898] = {.lex_state = 48, .external_lex_state = 191},
  [5899] = {.lex_state = 47, .external_lex_state = 32},
  [5900] = {.lex_state = 48, .external_lex_state = 192},
  [5901] = {.lex_state = 48, .external_lex_state = 192},
  [5902] = {.lex_state = 48, .external_lex_state = 45},
  [5903] = {.lex_state = 48, .external_lex_state = 45},
  [5904] = {.lex_state = 48, .external_lex_state = 192},
  [5905] = {.lex_state = 48, .external_lex_state = 45},
  [5906] = {.lex_state = 48, .external_lex_state = 45},
  [5907] = {.lex_state = 48, .external_lex_state = 45},
  [5908] = {.lex_state = 48, .external_lex_state = 45},
  [5909] = {.lex_state = 47, .external_lex_state = 31},
  [5910] = {.lex_state = 48, .external_lex_state = 191},
  [5911] = {.lex_state = 48, .external_lex_state = 45},
  [5912] = {.lex_state = 48, .external_lex_state = 45},
  [5913] = {.lex_state = 48, .external_lex_state = 191},
  [5914] = {.lex_state = 47, .external_lex_state = 31},
  [5915] = {.lex_state = 47, .external_lex_state = 31},
  [5916] = {.lex_state = 54, .external_lex_state = 37},
  [5917] = {.lex_state = 54, .external_lex_state = 37},
  [5918] = {.lex_state = 47, .external_lex_state = 31},
  [5919] = {.lex_state = 47, .external_lex_state = 33},
  [5920] = {.lex_state = 47, .external_lex_state = 33},
  [5921] = {.lex_state = 54, .external_lex_state = 37},
  [5922] = {.lex_state = 47, .external_lex_state = 31},
  [5923] = {.lex_state = 54, .external_lex_state = 37},
  [5924] = {.lex_state = 54, .external_lex_state = 37},
  [5925] = {.lex_state = 54, .external_lex_state = 37},
  [5926] = {.lex_state = 54, .external_lex_state = 37},
  [5927] = {.lex_state = 47, .external_lex_state = 31},
  [5928] = {.lex_state = 47, .external_lex_state = 31},
  [5929] = {.lex_state = 47, .external_lex_state = 31},
  [5930] = {.lex_state = 47, .external_lex_state = 31},
  [5931] = {.lex_state = 48, .external_lex_state = 189},
  [5932] = {.lex_state = 48, .external_lex_state = 189},
  [5933] = {.lex_state = 48, .external_lex_state = 189},
  [5934] = {.lex_state = 54, .external_lex_state = 37},
  [5935] = {.lex_state = 54, .external_lex_state = 37},
  [5936] = {.lex_state = 54, .external_lex_state = 37},
  [5937] = {.lex_state = 48, .external_lex_state = 190},
  [5938] = {.lex_state = 48, .external_lex_state = 44},
  [5939] = {.lex_state = 47, .external_lex_state = 33},
  [5940] = {.lex_state = 48, .external_lex_state = 192},
  [5941] = {.lex_state = 48, .external_lex_state = 190},
  [5942] = {.lex_state = 47, .external_lex_state = 33},
  [5943] = {.lex_state = 47, .external_lex_state = 33},
  [5944] = {.lex_state = 48, .external_lex_state = 190},
  [5945] = {.lex_state = 47, .external_lex_state = 33},
  [5946] = {.lex_state = 47, .external_lex_state = 33},
  [5947] = {.lex_state = 48, .external_lex_state = 192},
  [5948] = {.lex_state = 48, .external_lex_state = 52},
  [5949] = {.lex_state = 48, .external_lex_state = 50},
  [5950] = {.lex_state = 48, .external_lex_state = 52},
  [5951] = {.lex_state = 48, .external_lex_state = 52},
  [5952] = {.lex_state = 48, .external_lex_state = 50},
  [5953] = {.lex_state = 48, .external_lex_state = 52},
  [5954] = {.lex_state = 48, .external_lex_state = 50},
  [5955] = {.lex_state = 48, .external_lex_state = 52},
  [5956] = {.lex_state = 48, .external_lex_state = 52},
  [5957] = {.lex_state = 48, .external_lex_state = 52},
  [5958] = {.lex_state = 48, .external_lex_state = 50},
  [5959] = {.lex_state = 48, .external_lex_state = 50},
  [5960] = {.lex_state = 48, .external_lex_state = 50},
  [5961] = {.lex_state = 48, .external_lex_state = 193},
  [5962] = {.lex_state = 48, .external_lex_state = 50},
  [5963] = {.lex_state = 48, .external_lex_state = 193},
  [5964] = {.lex_state = 48, .external_lex_state = 50},
  [5965] = {.lex_state = 48, .external_lex_state = 46},
  [5966] = {.lex_state = 48, .external_lex_state = 52},
  [5967] = {.lex_state = 48, .external_lex_state = 52},
  [5968] = {.lex_state = 48, .external_lex_state = 194},
  [5969] = {.lex_state = 48, .external_lex_state = 193},
  [5970] = {.lex_state = 48, .external_lex_state = 50},
  [5971] = {.lex_state = 48, .external_lex_state = 50},
  [5972] = {.lex_state = 48, .external_lex_state = 51},
  [5973] = {.lex_state = 48, .external_lex_state = 51},
  [5974] = {.lex_state = 48, .external_lex_state = 50},
  [5975] = {.lex_state = 48, .external_lex_state = 52},
  [5976] = {.lex_state = 48, .external_lex_state = 51},
  [5977] = {.lex_state = 48, .external_lex_state = 194},
  [5978] = {.lex_state = 48, .external_lex_state = 51},
  [5979] = {.lex_state = 48, .external_lex_state = 51},
  [5980] = {.lex_state = 48, .external_lex_state = 51},
  [5981] = {.lex_state = 48, .external_lex_state = 51},
  [5982] = {.lex_state = 48, .external_lex_state = 51},
  [5983] = {.lex_state = 48, .external_lex_state = 46},
  [5984] = {.lex_state = 48, .external_lex_state = 46},
  [5985] = {.lex_state = 48, .external_lex_state = 46},
  [5986] = {.lex_state = 48, .external_lex_state = 51},
  [5987] = {.lex_state = 48, .external_lex_state = 51},
  [5988] = {.lex_state = 48, .external_lex_state = 50},
  [5989] = {.lex_state = 48, .external_lex_state = 52},
  [5990] = {.lex_state = 48, .external_lex_state = 51},
  [5991] = {.lex_state = 48, .external_lex_state = 51},
  [5992] = {.lex_state = 48, .external_lex_state = 51},
  [5993] = {.lex_state = 48, .external_lex_state = 50},
  [5994] = {.lex_state = 48, .external_lex_state = 50},
  [5995] = {.lex_state = 48, .external_lex_state = 195},
  [5996] = {.lex_state = 48, .external_lex_state = 51},
  [5997] = {.lex_state = 48, .external_lex_state = 50},
  [5998] = {.lex_state = 48, .external_lex_state = 51},
  [5999] = {.lex_state = 48, .external_lex_state = 51},
  [6000] = {.lex_state = 48, .external_lex_state = 50},
  [6001] = {.lex_state = 48, .external_lex_state = 195},
  [6002] = {.lex_state = 48, .external_lex_state = 50},
  [6003] = {.lex_state = 48, .external_lex_state = 46},
  [6004] = {.lex_state = 48, .external_lex_state = 50},
  [6005] = {.lex_state = 48, .external_lex_state = 196},
  [6006] = {.lex_state = 48, .external_lex_state = 48},
  [6007] = {.lex_state = 48, .external_lex_state = 46},
  [6008] = {.lex_state = 48, .external_lex_state = 196},
  [6009] = {.lex_state = 48, .external_lex_state = 52},
  [6010] = {.lex_state = 48, .external_lex_state = 52},
  [6011] = {.lex_state = 48, .external_lex_state = 50},
  [6012] = {.lex_state = 48, .external_lex_state = 13},
  [6013] = {.lex_state = 48, .external_lex_state = 50},
  [6014] = {.lex_state = 48, .external_lex_state = 50},
  [6015] = {.lex_state = 48, .external_lex_state = 51},
  [6016] = {.lex_state = 48, .external_lex_state = 52},
  [6017] = {.lex_state = 48, .external_lex_state = 194},
  [6018] = {.lex_state = 48, .external_lex_state = 195},
  [6019] = {.lex_state = 48, .external_lex_state = 196},
  [6020] = {.lex_state = 48, .external_lex_state = 50},
  [6021] = {.lex_state = 48, .external_lex_state = 52},
  [6022] = {.lex_state = 48, .external_lex_state = 49},
  [6023] = {.lex_state = 48, .external_lex_state = 52},
  [6024] = {.lex_state = 48, .external_lex_state = 46},
  [6025] = {.lex_state = 48, .external_lex_state = 194},
  [6026] = {.lex_state = 48, .external_lex_state = 46},
  [6027] = {.lex_state = 48, .external_lex_state = 52},
  [6028] = {.lex_state = 48, .external_lex_state = 193},
  [6029] = {.lex_state = 48, .external_lex_state = 46},
  [6030] = {.lex_state = 48, .external_lex_state = 48},
  [6031] = {.lex_state = 48, .external_lex_state = 52},
  [6032] = {.lex_state = 48, .external_lex_state = 46},
  [6033] = {.lex_state = 48, .external_lex_state = 193},
  [6034] = {.lex_state = 48, .external_lex_state = 46},
  [6035] = {.lex_state = 48, .external_lex_state = 46},
  [6036] = {.lex_state = 48, .external_lex_state = 46},
  [6037] = {.lex_state = 48, .external_lex_state = 196},
  [6038] = {.lex_state = 48, .external_lex_state = 193},
  [6039] = {.lex_state = 48, .external_lex_state = 46},
  [6040] = {.lex_state = 48, .external_lex_state = 50},
  [6041] = {.lex_state = 48, .external_lex_state = 46},
  [6042] = {.lex_state = 48, .external_lex_state = 50},
  [6043] = {.lex_state = 48, .external_lex_state = 46},
  [6044] = {.lex_state = 48, .external_lex_state = 13},
  [6045] = {.lex_state = 48, .external_lex_state = 46},
  [6046] = {.lex_state = 48, .external_lex_state = 46},
  [6047] = {.lex_state = 48, .external_lex_state = 49},
  [6048] = {.lex_state = 48, .external_lex_state = 49},
  [6049] = {.lex_state = 48, .external_lex_state = 46},
  [6050] = {.lex_state = 48, .external_lex_state = 46},
  [6051] = {.lex_state = 48, .external_lex_state = 46},
  [6052] = {.lex_state = 48, .external_lex_state = 46},
  [6053] = {.lex_state = 48, .external_lex_state = 50},
  [6054] = {.lex_state = 48, .external_lex_state = 46},
  [6055] = {.lex_state = 48, .external_lex_state = 46},
  [6056] = {.lex_state = 48, .external_lex_state = 197},
  [6057] = {.lex_state = 48, .external_lex_state = 46},
  [6058] = {.lex_state = 48, .external_lex_state = 46},
  [6059] = {.lex_state = 48, .external_lex_state = 46},
  [6060] = {.lex_state = 48, .external_lex_state = 46},
  [6061] = {.lex_state = 48, .external_lex_state = 197},
  [6062] = {.lex_state = 48, .external_lex_state = 46},
  [6063] = {.lex_state = 48, .external_lex_state = 48},
  [6064] = {.lex_state = 48, .external_lex_state = 48},
  [6065] = {.lex_state = 48, .external_lex_state = 46},
  [6066] = {.lex_state = 48, .external_lex_state = 48},
  [6067] = {.lex_state = 48, .external_lex_state = 46},
  [6068] = {.lex_state = 48, .external_lex_state = 48},
  [6069] = {.lex_state = 48, .external_lex_state = 48},
  [6070] = {.lex_state = 48, .external_lex_state = 48},
  [6071] = {.lex_state = 48, .external_lex_state = 197},
  [6072] = {.lex_state = 48, .external_lex_state = 46},
  [6073] = {.lex_state = 48, .external_lex_state = 194},
  [6074] = {.lex_state = 48, .external_lex_state = 48},
  [6075] = {.lex_state = 48, .external_lex_state = 48},
  [6076] = {.lex_state = 48, .external_lex_state = 48},
  [6077] = {.lex_state = 48, .external_lex_state = 196},
  [6078] = {.lex_state = 48, .external_lex_state = 46},
  [6079] = {.lex_state = 48, .external_lex_state = 198},
  [6080] = {.lex_state = 48, .external_lex_state = 199},
  [6081] = {.lex_state = 48, .external_lex_state = 48},
  [6082] = {.lex_state = 48, .external_lex_state = 48},
  [6083] = {.lex_state = 48, .external_lex_state = 48},
  [6084] = {.lex_state = 48, .external_lex_state = 48},
  [6085] = {.lex_state = 48, .external_lex_state = 48},
  [6086] = {.lex_state = 48, .external_lex_state = 48},
  [6087] = {.lex_state = 48, .external_lex_state = 48},
  [6088] = {.lex_state = 48, .external_lex_state = 48},
  [6089] = {.lex_state = 48, .external_lex_state = 52},
  [6090] = {.lex_state = 48, .external_lex_state = 51},
  [6091] = {.lex_state = 48, .external_lex_state = 46},
  [6092] = {.lex_state = 48, .external_lex_state = 50},
  [6093] = {.lex_state = 48, .external_lex_state = 52},
  [6094] = {.lex_state = 48, .external_lex_state = 50},
  [6095] = {.lex_state = 48, .external_lex_state = 52},
  [6096] = {.lex_state = 48, .external_lex_state = 51},
  [6097] = {.lex_state = 48, .external_lex_state = 51},
  [6098] = {.lex_state = 48, .external_lex_state = 48},
  [6099] = {.lex_state = 48, .external_lex_state = 51},
  [6100] = {.lex_state = 48, .external_lex_state = 48},
  [6101] = {.lex_state = 48, .external_lex_state = 200},
  [6102] = {.lex_state = 48, .external_lex_state = 49},
  [6103] = {.lex_state = 48, .external_lex_state = 48},
  [6104] = {.lex_state = 48, .external_lex_state = 198},
  [6105] = {.lex_state = 48, .external_lex_state = 198},
  [6106] = {.lex_state = 48, .external_lex_state = 50},
  [6107] = {.lex_state = 48, .external_lex_state = 50},
  [6108] = {.lex_state = 48, .external_lex_state = 49},
  [6109] = {.lex_state = 48, .external_lex_state = 48},
  [6110] = {.lex_state = 48, .external_lex_state = 50},
  [6111] = {.lex_state = 48, .external_lex_state = 49},
  [6112] = {.lex_state = 48, .external_lex_state = 50},
  [6113] = {.lex_state = 48, .external_lex_state = 197},
  [6114] = {.lex_state = 48, .external_lex_state = 50},
  [6115] = {.lex_state = 48, .external_lex_state = 49},
  [6116] = {.lex_state = 48, .external_lex_state = 48},
  [6117] = {.lex_state = 48, .external_lex_state = 50},
  [6118] = {.lex_state = 48, .external_lex_state = 195},
  [6119] = {.lex_state = 48, .external_lex_state = 50},
  [6120] = {.lex_state = 48, .external_lex_state = 46},
  [6121] = {.lex_state = 48, .external_lex_state = 199},
  [6122] = {.lex_state = 48, .external_lex_state = 52},
  [6123] = {.lex_state = 48, .external_lex_state = 48},
  [6124] = {.lex_state = 48, .external_lex_state = 48},
  [6125] = {.lex_state = 48, .external_lex_state = 48},
  [6126] = {.lex_state = 48, .external_lex_state = 50},
  [6127] = {.lex_state = 48, .external_lex_state = 199},
  [6128] = {.lex_state = 48, .external_lex_state = 195},
  [6129] = {.lex_state = 48, .external_lex_state = 46},
  [6130] = {.lex_state = 48, .external_lex_state = 52},
  [6131] = {.lex_state = 48, .external_lex_state = 52},
  [6132] = {.lex_state = 48, .external_lex_state = 52},
  [6133] = {.lex_state = 48, .external_lex_state = 52},
  [6134] = {.lex_state = 48, .external_lex_state = 48},
  [6135] = {.lex_state = 48, .external_lex_state = 52},
  [6136] = {.lex_state = 48, .external_lex_state = 52},
  [6137] = {.lex_state = 48, .external_lex_state = 52},
  [6138] = {.lex_state = 48, .external_lex_state = 201},
  [6139] = {.lex_state = 48, .external_lex_state = 50},
  [6140] = {.lex_state = 48, .external_lex_state = 51},
  [6141] = {.lex_state = 48, .external_lex_state = 52},
  [6142] = {.lex_state = 48, .external_lex_state = 200},
  [6143] = {.lex_state = 47, .external_lex_state = 37},
  [6144] = {.lex_state = 47, .external_lex_state = 37},
  [6145] = {.lex_state = 47, .external_lex_state = 37},
  [6146] = {.lex_state = 48, .external_lex_state = 52},
  [6147] = {.lex_state = 48, .external_lex_state = 201},
  [6148] = {.lex_state = 48, .external_lex_state = 52},
  [6149] = {.lex_state = 48, .external_lex_state = 200},
  [6150] = {.lex_state = 48, .external_lex_state = 200},
  [6151] = {.lex_state = 48, .external_lex_state = 48},
  [6152] = {.lex_state = 48, .external_lex_state = 52},
  [6153] = {.lex_state = 48, .external_lex_state = 201},
  [6154] = {.lex_state = 48, .external_lex_state = 48},
  [6155] = {.lex_state = 48, .external_lex_state = 52},
  [6156] = {.lex_state = 48, .external_lex_state = 51},
  [6157] = {.lex_state = 48, .external_lex_state = 198},
  [6158] = {.lex_state = 47, .external_lex_state = 37},
  [6159] = {.lex_state = 48, .external_lex_state = 51},
  [6160] = {.lex_state = 48, .external_lex_state = 51},
  [6161] = {.lex_state = 47, .external_lex_state = 37},
  [6162] = {.lex_state = 48, .external_lex_state = 51},
  [6163] = {.lex_state = 48, .external_lex_state = 48},
  [6164] = {.lex_state = 48, .external_lex_state = 52},
  [6165] = {.lex_state = 48, .external_lex_state = 51},
  [6166] = {.lex_state = 48, .external_lex_state = 51},
  [6167] = {.lex_state = 48, .external_lex_state = 51},
  [6168] = {.lex_state = 48, .external_lex_state = 198},
  [6169] = {.lex_state = 48, .external_lex_state = 51},
  [6170] = {.lex_state = 48, .external_lex_state = 51},
  [6171] = {.lex_state = 48, .external_lex_state = 51},
  [6172] = {.lex_state = 48, .external_lex_state = 51},
  [6173] = {.lex_state = 48, .external_lex_state = 51},
  [6174] = {.lex_state = 48, .external_lex_state = 51},
  [6175] = {.lex_state = 48, .external_lex_state = 198},
  [6176] = {.lex_state = 48, .external_lex_state = 51},
  [6177] = {.lex_state = 48, .external_lex_state = 48},
  [6178] = {.lex_state = 48, .external_lex_state = 194},
  [6179] = {.lex_state = 47, .external_lex_state = 37},
  [6180] = {.lex_state = 47, .external_lex_state = 37},
  [6181] = {.lex_state = 48, .external_lex_state = 48},
  [6182] = {.lex_state = 48, .external_lex_state = 200},
  [6183] = {.lex_state = 48, .external_lex_state = 49},
  [6184] = {.lex_state = 48, .external_lex_state = 200},
  [6185] = {.lex_state = 48, .external_lex_state = 49},
  [6186] = {.lex_state = 48, .external_lex_state = 49},
  [6187] = {.lex_state = 48, .external_lex_state = 49},
  [6188] = {.lex_state = 48, .external_lex_state = 49},
  [6189] = {.lex_state = 48, .external_lex_state = 49},
  [6190] = {.lex_state = 48, .external_lex_state = 49},
  [6191] = {.lex_state = 48, .external_lex_state = 48},
  [6192] = {.lex_state = 48, .external_lex_state = 49},
  [6193] = {.lex_state = 48, .external_lex_state = 49},
  [6194] = {.lex_state = 48, .external_lex_state = 49},
  [6195] = {.lex_state = 48, .external_lex_state = 49},
  [6196] = {.lex_state = 48, .external_lex_state = 49},
  [6197] = {.lex_state = 48, .external_lex_state = 49},
  [6198] = {.lex_state = 48, .external_lex_state = 49},
  [6199] = {.lex_state = 48, .external_lex_state = 49},
  [6200] = {.lex_state = 48, .external_lex_state = 49},
  [6201] = {.lex_state = 47, .external_lex_state = 37},
  [6202] = {.lex_state = 48, .external_lex_state = 49},
  [6203] = {.lex_state = 48, .external_lex_state = 49},
  [6204] = {.lex_state = 47, .external_lex_state = 37},
  [6205] = {.lex_state = 48, .external_lex_state = 49},
  [6206] = {.lex_state = 48, .external_lex_state = 49},
  [6207] = {.lex_state = 48, .external_lex_state = 49},
  [6208] = {.lex_state = 48, .external_lex_state = 49},
  [6209] = {.lex_state = 48, .external_lex_state = 48},
  [6210] = {.lex_state = 48, .external_lex_state = 201},
  [6211] = {.lex_state = 48, .external_lex_state = 49},
  [6212] = {.lex_state = 48, .external_lex_state = 49},
  [6213] = {.lex_state = 48, .external_lex_state = 49},
  [6214] = {.lex_state = 48, .external_lex_state = 201},
  [6215] = {.lex_state = 47, .external_lex_state = 37},
  [6216] = {.lex_state = 48, .external_lex_state = 196},
  [6217] = {.lex_state = 48, .external_lex_state = 49},
  [6218] = {.lex_state = 48, .external_lex_state = 49},
  [6219] = {.lex_state = 48, .external_lex_state = 197},
  [6220] = {.lex_state = 48, .external_lex_state = 197},
  [6221] = {.lex_state = 48, .external_lex_state = 201},
  [6222] = {.lex_state = 48, .external_lex_state = 199},
  [6223] = {.lex_state = 48, .external_lex_state = 195},
  [6224] = {.lex_state = 48, .external_lex_state = 199},
  [6225] = {.lex_state = 48, .external_lex_state = 52},
  [6226] = {.lex_state = 48, .external_lex_state = 199},
  [6227] = {.lex_state = 48, .external_lex_state = 193},
  [6228] = {.lex_state = 48, .external_lex_state = 49},
  [6229] = {.lex_state = 48, .external_lex_state = 49},
  [6230] = {.lex_state = 48, .external_lex_state = 48},
  [6231] = {.lex_state = 48, .external_lex_state = 194},
  [6232] = {.lex_state = 48, .external_lex_state = 61},
  [6233] = {.lex_state = 48, .external_lex_state = 55},
  [6234] = {.lex_state = 48, .external_lex_state = 63},
  [6235] = {.lex_state = 48, .external_lex_state = 63},
  [6236] = {.lex_state = 48, .external_lex_state = 63},
  [6237] = {.lex_state = 48, .external_lex_state = 60},
  [6238] = {.lex_state = 48, .external_lex_state = 202},
  [6239] = {.lex_state = 48, .external_lex_state = 54},
  [6240] = {.lex_state = 48, .external_lex_state = 63},
  [6241] = {.lex_state = 48, .external_lex_state = 63},
  [6242] = {.lex_state = 48, .external_lex_state = 57},
  [6243] = {.lex_state = 48, .external_lex_state = 60},
  [6244] = {.lex_state = 48, .external_lex_state = 63},
  [6245] = {.lex_state = 48, .external_lex_state = 63},
  [6246] = {.lex_state = 48, .external_lex_state = 63},
  [6247] = {.lex_state = 48, .external_lex_state = 60},
  [6248] = {.lex_state = 48, .external_lex_state = 60},
  [6249] = {.lex_state = 48, .external_lex_state = 60},
  [6250] = {.lex_state = 48, .external_lex_state = 203},
  [6251] = {.lex_state = 48, .external_lex_state = 59},
  [6252] = {.lex_state = 48, .external_lex_state = 204},
  [6253] = {.lex_state = 48, .external_lex_state = 60},
  [6254] = {.lex_state = 48, .external_lex_state = 60},
  [6255] = {.lex_state = 48, .external_lex_state = 60},
  [6256] = {.lex_state = 48, .external_lex_state = 57},
  [6257] = {.lex_state = 48, .external_lex_state = 63},
  [6258] = {.lex_state = 48, .external_lex_state = 55},
  [6259] = {.lex_state = 48, .external_lex_state = 60},
  [6260] = {.lex_state = 48, .external_lex_state = 63},
  [6261] = {.lex_state = 48, .external_lex_state = 59},
  [6262] = {.lex_state = 48, .external_lex_state = 59},
  [6263] = {.lex_state = 48, .external_lex_state = 58},
  [6264] = {.lex_state = 48, .external_lex_state = 57},
  [6265] = {.lex_state = 48, .external_lex_state = 63},
  [6266] = {.lex_state = 48, .external_lex_state = 58},
  [6267] = {.lex_state = 48, .external_lex_state = 63},
  [6268] = {.lex_state = 48, .external_lex_state = 203},
  [6269] = {.lex_state = 48, .external_lex_state = 205},
  [6270] = {.lex_state = 48, .external_lex_state = 60},
  [6271] = {.lex_state = 48, .external_lex_state = 63},
  [6272] = {.lex_state = 48, .external_lex_state = 63},
  [6273] = {.lex_state = 48, .external_lex_state = 61},
  [6274] = {.lex_state = 50, .external_lex_state = 206},
  [6275] = {.lex_state = 48, .external_lex_state = 57},
  [6276] = {.lex_state = 48, .external_lex_state = 204},
  [6277] = {.lex_state = 48, .external_lex_state = 59},
  [6278] = {.lex_state = 48, .external_lex_state = 58},
  [6279] = {.lex_state = 48, .external_lex_state = 58},
  [6280] = {.lex_state = 48, .external_lex_state = 62},
  [6281] = {.lex_state = 48, .external_lex_state = 58},
  [6282] = {.lex_state = 48, .external_lex_state = 58},
  [6283] = {.lex_state = 48, .external_lex_state = 58},
  [6284] = {.lex_state = 48, .external_lex_state = 58},
  [6285] = {.lex_state = 48, .external_lex_state = 58},
  [6286] = {.lex_state = 48, .external_lex_state = 58},
  [6287] = {.lex_state = 48, .external_lex_state = 58},
  [6288] = {.lex_state = 48, .external_lex_state = 62},
  [6289] = {.lex_state = 48, .external_lex_state = 54},
  [6290] = {.lex_state = 48, .external_lex_state = 60},
  [6291] = {.lex_state = 48, .external_lex_state = 55},
  [6292] = {.lex_state = 48, .external_lex_state = 54},
  [6293] = {.lex_state = 48, .external_lex_state = 55},
  [6294] = {.lex_state = 48, .external_lex_state = 55},
  [6295] = {.lex_state = 48, .external_lex_state = 54},
  [6296] = {.lex_state = 48, .external_lex_state = 63},
  [6297] = {.lex_state = 48, .external_lex_state = 58},
  [6298] = {.lex_state = 48, .external_lex_state = 62},
  [6299] = {.lex_state = 48, .external_lex_state = 204},
  [6300] = {.lex_state = 48, .external_lex_state = 58},
  [6301] = {.lex_state = 48, .external_lex_state = 58},
  [6302] = {.lex_state = 48, .external_lex_state = 58},
  [6303] = {.lex_state = 48, .external_lex_state = 207},
  [6304] = {.lex_state = 48, .external_lex_state = 55},
  [6305] = {.lex_state = 48, .external_lex_state = 59},
  [6306] = {.lex_state = 48, .external_lex_state = 57},
  [6307] = {.lex_state = 48, .external_lex_state = 58},
  [6308] = {.lex_state = 48, .external_lex_state = 202},
  [6309] = {.lex_state = 48, .external_lex_state = 57},
  [6310] = {.lex_state = 48, .external_lex_state = 59},
  [6311] = {.lex_state = 48, .external_lex_state = 63},
  [6312] = {.lex_state = 48, .external_lex_state = 57},
  [6313] = {.lex_state = 48, .external_lex_state = 57},
  [6314] = {.lex_state = 48, .external_lex_state = 57},
  [6315] = {.lex_state = 48, .external_lex_state = 57},
  [6316] = {.lex_state = 48, .external_lex_state = 54},
  [6317] = {.lex_state = 48, .external_lex_state = 203},
  [6318] = {.lex_state = 48, .external_lex_state = 54},
  [6319] = {.lex_state = 48, .external_lex_state = 55},
  [6320] = {.lex_state = 48, .external_lex_state = 62},
  [6321] = {.lex_state = 48, .external_lex_state = 62},
  [6322] = {.lex_state = 48, .external_lex_state = 203},
  [6323] = {.lex_state = 48, .external_lex_state = 57},
  [6324] = {.lex_state = 48, .external_lex_state = 59},
  [6325] = {.lex_state = 48, .external_lex_state = 57},
  [6326] = {.lex_state = 48, .external_lex_state = 54},
  [6327] = {.lex_state = 48, .external_lex_state = 62},
  [6328] = {.lex_state = 48, .external_lex_state = 59},
  [6329] = {.lex_state = 48, .external_lex_state = 205},
  [6330] = {.lex_state = 48, .external_lex_state = 62},
  [6331] = {.lex_state = 48, .external_lex_state = 55},
  [6332] = {.lex_state = 48, .external_lex_state = 59},
  [6333] = {.lex_state = 48, .external_lex_state = 59},
  [6334] = {.lex_state = 48, .external_lex_state = 57},
  [6335] = {.lex_state = 48, .external_lex_state = 63},
  [6336] = {.lex_state = 48, .external_lex_state = 62},
  [6337] = {.lex_state = 48, .external_lex_state = 57},
  [6338] = {.lex_state = 48, .external_lex_state = 57},
  [6339] = {.lex_state = 48, .external_lex_state = 54},
  [6340] = {.lex_state = 48, .external_lex_state = 57},
  [6341] = {.lex_state = 48, .external_lex_state = 54},
  [6342] = {.lex_state = 48, .external_lex_state = 57},
  [6343] = {.lex_state = 48, .external_lex_state = 58},
  [6344] = {.lex_state = 48, .external_lex_state = 60},
  [6345] = {.lex_state = 48, .external_lex_state = 54},
  [6346] = {.lex_state = 48, .external_lex_state = 62},
  [6347] = {.lex_state = 48, .external_lex_state = 58},
  [6348] = {.lex_state = 48, .external_lex_state = 57},
  [6349] = {.lex_state = 48, .external_lex_state = 55},
  [6350] = {.lex_state = 48, .external_lex_state = 58},
  [6351] = {.lex_state = 48, .external_lex_state = 63},
  [6352] = {.lex_state = 48, .external_lex_state = 205},
  [6353] = {.lex_state = 48, .external_lex_state = 54},
  [6354] = {.lex_state = 48, .external_lex_state = 63},
  [6355] = {.lex_state = 48, .external_lex_state = 55},
  [6356] = {.lex_state = 48, .external_lex_state = 55},
  [6357] = {.lex_state = 48, .external_lex_state = 63},
  [6358] = {.lex_state = 48, .external_lex_state = 62},
  [6359] = {.lex_state = 48, .external_lex_state = 55},
  [6360] = {.lex_state = 48, .external_lex_state = 62},
  [6361] = {.lex_state = 48, .external_lex_state = 54},
  [6362] = {.lex_state = 48, .external_lex_state = 204},
  [6363] = {.lex_state = 48, .external_lex_state = 61},
  [6364] = {.lex_state = 48, .external_lex_state = 62},
  [6365] = {.lex_state = 48, .external_lex_state = 59},
  [6366] = {.lex_state = 48, .external_lex_state = 205},
  [6367] = {.lex_state = 48, .external_lex_state = 62},
  [6368] = {.lex_state = 48, .external_lex_state = 63},
  [6369] = {.lex_state = 48, .external_lex_state = 57},
  [6370] = {.lex_state = 48, .external_lex_state = 59},
  [6371] = {.lex_state = 48, .external_lex_state = 55},
  [6372] = {.lex_state = 48, .external_lex_state = 59},
  [6373] = {.lex_state = 48, .external_lex_state = 59},
  [6374] = {.lex_state = 48, .external_lex_state = 59},
  [6375] = {.lex_state = 48, .external_lex_state = 57},
  [6376] = {.lex_state = 48, .external_lex_state = 59},
  [6377] = {.lex_state = 48, .external_lex_state = 54},
  [6378] = {.lex_state = 48, .external_lex_state = 54},
  [6379] = {.lex_state = 48, .external_lex_state = 55},
  [6380] = {.lex_state = 48, .external_lex_state = 59},
  [6381] = {.lex_state = 48, .external_lex_state = 55},
  [6382] = {.lex_state = 48, .external_lex_state = 59},
  [6383] = {.lex_state = 48, .external_lex_state = 59},
  [6384] = {.lex_state = 48, .external_lex_state = 59},
  [6385] = {.lex_state = 48, .external_lex_state = 59},
  [6386] = {.lex_state = 48, .external_lex_state = 55},
  [6387] = {.lex_state = 48, .external_lex_state = 55},
  [6388] = {.lex_state = 48, .external_lex_state = 55},
  [6389] = {.lex_state = 48, .external_lex_state = 57},
  [6390] = {.lex_state = 48, .external_lex_state = 59},
  [6391] = {.lex_state = 48, .external_lex_state = 59},
  [6392] = {.lex_state = 48, .external_lex_state = 59},
  [6393] = {.lex_state = 48, .external_lex_state = 63},
  [6394] = {.lex_state = 48, .external_lex_state = 203},
  [6395] = {.lex_state = 48, .external_lex_state = 54},
  [6396] = {.lex_state = 48, .external_lex_state = 61},
  [6397] = {.lex_state = 48, .external_lex_state = 61},
  [6398] = {.lex_state = 48, .external_lex_state = 54},
  [6399] = {.lex_state = 48, .external_lex_state = 54},
  [6400] = {.lex_state = 48, .external_lex_state = 57},
  [6401] = {.lex_state = 48, .external_lex_state = 55},
  [6402] = {.lex_state = 48, .external_lex_state = 61},
  [6403] = {.lex_state = 48, .external_lex_state = 203},
  [6404] = {.lex_state = 48, .external_lex_state = 59},
  [6405] = {.lex_state = 48, .external_lex_state = 59},
  [6406] = {.lex_state = 48, .external_lex_state = 59},
  [6407] = {.lex_state = 48, .external_lex_state = 59},
  [6408] = {.lex_state = 48, .external_lex_state = 63},
  [6409] = {.lex_state = 48, .external_lex_state = 59},
  [6410] = {.lex_state = 48, .external_lex_state = 54},
  [6411] = {.lex_state = 48, .external_lex_state = 54},
  [6412] = {.lex_state = 48, .external_lex_state = 54},
  [6413] = {.lex_state = 48, .external_lex_state = 63},
  [6414] = {.lex_state = 48, .external_lex_state = 204},
  [6415] = {.lex_state = 48, .external_lex_state = 61},
  [6416] = {.lex_state = 48, .external_lex_state = 55},
  [6417] = {.lex_state = 48, .external_lex_state = 59},
  [6418] = {.lex_state = 48, .external_lex_state = 55},
  [6419] = {.lex_state = 48, .external_lex_state = 204},
  [6420] = {.lex_state = 48, .external_lex_state = 57},
  [6421] = {.lex_state = 48, .external_lex_state = 63},
  [6422] = {.lex_state = 48, .external_lex_state = 59},
  [6423] = {.lex_state = 48, .external_lex_state = 62},
  [6424] = {.lex_state = 48, .external_lex_state = 59},
  [6425] = {.lex_state = 48, .external_lex_state = 59},
  [6426] = {.lex_state = 48, .external_lex_state = 59},
  [6427] = {.lex_state = 48, .external_lex_state = 54},
  [6428] = {.lex_state = 48, .external_lex_state = 54},
  [6429] = {.lex_state = 48, .external_lex_state = 54},
  [6430] = {.lex_state = 48, .external_lex_state = 55},
  [6431] = {.lex_state = 48, .external_lex_state = 62},
  [6432] = {.lex_state = 48, .external_lex_state = 62},
  [6433] = {.lex_state = 48, .external_lex_state = 59},
  [6434] = {.lex_state = 48, .external_lex_state = 54},
  [6435] = {.lex_state = 48, .external_lex_state = 58},
  [6436] = {.lex_state = 48, .external_lex_state = 62},
  [6437] = {.lex_state = 48, .external_lex_state = 61},
  [6438] = {.lex_state = 48, .external_lex_state = 54},
  [6439] = {.lex_state = 48, .external_lex_state = 62},
  [6440] = {.lex_state = 48, .external_lex_state = 203},
  [6441] = {.lex_state = 48, .external_lex_state = 63},
  [6442] = {.lex_state = 48, .external_lex_state = 61},
  [6443] = {.lex_state = 48, .external_lex_state = 59},
  [6444] = {.lex_state = 48, .external_lex_state = 54},
  [6445] = {.lex_state = 48, .external_lex_state = 62},
  [6446] = {.lex_state = 48, .external_lex_state = 62},
  [6447] = {.lex_state = 48, .external_lex_state = 63},
  [6448] = {.lex_state = 48, .external_lex_state = 63},
  [6449] = {.lex_state = 48, .external_lex_state = 62},
  [6450] = {.lex_state = 48, .external_lex_state = 62},
  [6451] = {.lex_state = 48, .external_lex_state = 62},
  [6452] = {.lex_state = 48, .external_lex_state = 54},
  [6453] = {.lex_state = 48, .external_lex_state = 62},
  [6454] = {.lex_state = 48, .external_lex_state = 54},
  [6455] = {.lex_state = 48, .external_lex_state = 58},
  [6456] = {.lex_state = 48, .external_lex_state = 63},
  [6457] = {.lex_state = 48, .external_lex_state = 58},
  [6458] = {.lex_state = 48, .external_lex_state = 62},
  [6459] = {.lex_state = 48, .external_lex_state = 63},
  [6460] = {.lex_state = 48, .external_lex_state = 61},
  [6461] = {.lex_state = 48, .external_lex_state = 57},
  [6462] = {.lex_state = 48, .external_lex_state = 58},
  [6463] = {.lex_state = 48, .external_lex_state = 54},
  [6464] = {.lex_state = 48, .external_lex_state = 62},
  [6465] = {.lex_state = 48, .external_lex_state = 58},
  [6466] = {.lex_state = 48, .external_lex_state = 63},
  [6467] = {.lex_state = 48, .external_lex_state = 58},
  [6468] = {.lex_state = 48, .external_lex_state = 57},
  [6469] = {.lex_state = 48, .external_lex_state = 59},
  [6470] = {.lex_state = 48, .external_lex_state = 60},
  [6471] = {.lex_state = 48, .external_lex_state = 58},
  [6472] = {.lex_state = 48, .external_lex_state = 61},
  [6473] = {.lex_state = 48, .external_lex_state = 61},
  [6474] = {.lex_state = 48, .external_lex_state = 60},
  [6475] = {.lex_state = 48, .external_lex_state = 60},
  [6476] = {.lex_state = 48, .external_lex_state = 202},
  [6477] = {.lex_state = 48, .external_lex_state = 61},
  [6478] = {.lex_state = 48, .external_lex_state = 207},
  [6479] = {.lex_state = 48, .external_lex_state = 63},
  [6480] = {.lex_state = 48, .external_lex_state = 202},
  [6481] = {.lex_state = 48, .external_lex_state = 61},
  [6482] = {.lex_state = 48, .external_lex_state = 58},
  [6483] = {.lex_state = 48, .external_lex_state = 57},
  [6484] = {.lex_state = 48, .external_lex_state = 58},
  [6485] = {.lex_state = 48, .external_lex_state = 58},
  [6486] = {.lex_state = 48, .external_lex_state = 62},
  [6487] = {.lex_state = 48, .external_lex_state = 61},
  [6488] = {.lex_state = 48, .external_lex_state = 61},
  [6489] = {.lex_state = 48, .external_lex_state = 58},
  [6490] = {.lex_state = 48, .external_lex_state = 54},
  [6491] = {.lex_state = 48, .external_lex_state = 60},
  [6492] = {.lex_state = 48, .external_lex_state = 54},
  [6493] = {.lex_state = 48, .external_lex_state = 61},
  [6494] = {.lex_state = 48, .external_lex_state = 60},
  [6495] = {.lex_state = 48, .external_lex_state = 55},
  [6496] = {.lex_state = 48, .external_lex_state = 62},
  [6497] = {.lex_state = 48, .external_lex_state = 54},
  [6498] = {.lex_state = 48, .external_lex_state = 60},
  [6499] = {.lex_state = 48, .external_lex_state = 58},
  [6500] = {.lex_state = 48, .external_lex_state = 60},
  [6501] = {.lex_state = 48, .external_lex_state = 58},
  [6502] = {.lex_state = 48, .external_lex_state = 54},
  [6503] = {.lex_state = 48, .external_lex_state = 207},
  [6504] = {.lex_state = 48, .external_lex_state = 57},
  [6505] = {.lex_state = 48, .external_lex_state = 61},
  [6506] = {.lex_state = 48, .external_lex_state = 62},
  [6507] = {.lex_state = 48, .external_lex_state = 61},
  [6508] = {.lex_state = 48, .external_lex_state = 60},
  [6509] = {.lex_state = 48, .external_lex_state = 54},
  [6510] = {.lex_state = 48, .external_lex_state = 60},
  [6511] = {.lex_state = 48, .external_lex_state = 207},
  [6512] = {.lex_state = 48, .external_lex_state = 60},
  [6513] = {.lex_state = 48, .external_lex_state = 54},
  [6514] = {.lex_state = 48, .external_lex_state = 60},
  [6515] = {.lex_state = 48, .external_lex_state = 60},
  [6516] = {.lex_state = 48, .external_lex_state = 60},
  [6517] = {.lex_state = 48, .external_lex_state = 58},
  [6518] = {.lex_state = 48, .external_lex_state = 58},
  [6519] = {.lex_state = 48, .external_lex_state = 61},
  [6520] = {.lex_state = 48, .external_lex_state = 63},
  [6521] = {.lex_state = 48, .external_lex_state = 60},
  [6522] = {.lex_state = 48, .external_lex_state = 63},
  [6523] = {.lex_state = 48, .external_lex_state = 57},
  [6524] = {.lex_state = 48, .external_lex_state = 60},
  [6525] = {.lex_state = 48, .external_lex_state = 57},
  [6526] = {.lex_state = 48, .external_lex_state = 55},
  [6527] = {.lex_state = 48, .external_lex_state = 207},
  [6528] = {.lex_state = 48, .external_lex_state = 61},
  [6529] = {.lex_state = 48, .external_lex_state = 57},
  [6530] = {.lex_state = 48, .external_lex_state = 205},
  [6531] = {.lex_state = 48, .external_lex_state = 60},
  [6532] = {.lex_state = 48, .external_lex_state = 62},
  [6533] = {.lex_state = 48, .external_lex_state = 57},
  [6534] = {.lex_state = 48, .external_lex_state = 62},
  [6535] = {.lex_state = 48, .external_lex_state = 61},
  [6536] = {.lex_state = 48, .external_lex_state = 57},
  [6537] = {.lex_state = 48, .external_lex_state = 202},
  [6538] = {.lex_state = 48, .external_lex_state = 61},
  [6539] = {.lex_state = 48, .external_lex_state = 62},
  [6540] = {.lex_state = 48, .external_lex_state = 55},
  [6541] = {.lex_state = 48, .external_lex_state = 62},
  [6542] = {.lex_state = 48, .external_lex_state = 57},
  [6543] = {.lex_state = 48, .external_lex_state = 62},
  [6544] = {.lex_state = 48, .external_lex_state = 63},
  [6545] = {.lex_state = 48, .external_lex_state = 60},
  [6546] = {.lex_state = 48, .external_lex_state = 63},
  [6547] = {.lex_state = 48, .external_lex_state = 60},
  [6548] = {.lex_state = 48, .external_lex_state = 202},
  [6549] = {.lex_state = 48, .external_lex_state = 57},
  [6550] = {.lex_state = 48, .external_lex_state = 60},
  [6551] = {.lex_state = 48, .external_lex_state = 60},
  [6552] = {.lex_state = 48, .external_lex_state = 61},
  [6553] = {.lex_state = 48, .external_lex_state = 61},
  [6554] = {.lex_state = 48, .external_lex_state = 62},
  [6555] = {.lex_state = 48, .external_lex_state = 54},
  [6556] = {.lex_state = 48, .external_lex_state = 55},
  [6557] = {.lex_state = 48, .external_lex_state = 58},
  [6558] = {.lex_state = 48, .external_lex_state = 207},
  [6559] = {.lex_state = 48, .external_lex_state = 55},
  [6560] = {.lex_state = 48, .external_lex_state = 60},
  [6561] = {.lex_state = 48, .external_lex_state = 61},
  [6562] = {.lex_state = 48, .external_lex_state = 61},
  [6563] = {.lex_state = 48, .external_lex_state = 55},
  [6564] = {.lex_state = 48, .external_lex_state = 58},
  [6565] = {.lex_state = 48, .external_lex_state = 55},
  [6566] = {.lex_state = 48, .external_lex_state = 60},
  [6567] = {.lex_state = 48, .external_lex_state = 61},
  [6568] = {.lex_state = 48, .external_lex_state = 61},
  [6569] = {.lex_state = 48, .external_lex_state = 61},
  [6570] = {.lex_state = 48, .external_lex_state = 60},
  [6571] = {.lex_state = 48, .external_lex_state = 61},
  [6572] = {.lex_state = 48, .external_lex_state = 205},
  [6573] = {.lex_state = 48, .external_lex_state = 54},
  [6574] = {.lex_state = 48, .external_lex_state = 55},
  [6575] = {.lex_state = 48, .external_lex_state = 57},
  [6576] = {.lex_state = 48, .external_lex_state = 61},
  [6577] = {.lex_state = 48, .external_lex_state = 57},
  [6578] = {.lex_state = 48, .external_lex_state = 61},
  [6579] = {.lex_state = 48, .external_lex_state = 62},
  [6580] = {.lex_state = 48, .external_lex_state = 60},
  [6581] = {.lex_state = 48, .external_lex_state = 55},
  [6582] = {.lex_state = 48, .external_lex_state = 61},
  [6583] = {.lex_state = 48, .external_lex_state = 61},
  [6584] = {.lex_state = 48, .external_lex_state = 55},
  [6585] = {.lex_state = 48, .external_lex_state = 61},
  [6586] = {.lex_state = 48, .external_lex_state = 55},
  [6587] = {.lex_state = 48, .external_lex_state = 55},
  [6588] = {.lex_state = 48, .external_lex_state = 55},
  [6589] = {.lex_state = 48, .external_lex_state = 55},
  [6590] = {.lex_state = 48, .external_lex_state = 65},
  [6591] = {.lex_state = 48, .external_lex_state = 68},
  [6592] = {.lex_state = 48, .external_lex_state = 64},
  [6593] = {.lex_state = 48, .external_lex_state = 64},
  [6594] = {.lex_state = 48, .external_lex_state = 67},
  [6595] = {.lex_state = 48, .external_lex_state = 64},
  [6596] = {.lex_state = 48, .external_lex_state = 65},
  [6597] = {.lex_state = 48, .external_lex_state = 66},
  [6598] = {.lex_state = 48, .external_lex_state = 66},
  [6599] = {.lex_state = 48, .external_lex_state = 66},
  [6600] = {.lex_state = 48, .external_lex_state = 66},
  [6601] = {.lex_state = 48, .external_lex_state = 66},
  [6602] = {.lex_state = 48, .external_lex_state = 64},
  [6603] = {.lex_state = 48, .external_lex_state = 65},
  [6604] = {.lex_state = 48, .external_lex_state = 66},
  [6605] = {.lex_state = 48, .external_lex_state = 208},
  [6606] = {.lex_state = 48, .external_lex_state = 67},
  [6607] = {.lex_state = 48, .external_lex_state = 68},
  [6608] = {.lex_state = 48, .external_lex_state = 68},
  [6609] = {.lex_state = 48, .external_lex_state = 67},
  [6610] = {.lex_state = 48, .external_lex_state = 67},
  [6611] = {.lex_state = 48, .external_lex_state = 66},
  [6612] = {.lex_state = 48, .external_lex_state = 64},
  [6613] = {.lex_state = 48, .external_lex_state = 64},
  [6614] = {.lex_state = 48, .external_lex_state = 66},
  [6615] = {.lex_state = 48, .external_lex_state = 64},
  [6616] = {.lex_state = 48, .external_lex_state = 67},
  [6617] = {.lex_state = 48, .external_lex_state = 65},
  [6618] = {.lex_state = 48, .external_lex_state = 66},
  [6619] = {.lex_state = 48, .external_lex_state = 66},
  [6620] = {.lex_state = 48, .external_lex_state = 66},
  [6621] = {.lex_state = 48, .external_lex_state = 65},
  [6622] = {.lex_state = 48, .external_lex_state = 66},
  [6623] = {.lex_state = 48, .external_lex_state = 66},
  [6624] = {.lex_state = 48, .external_lex_state = 66},
  [6625] = {.lex_state = 48, .external_lex_state = 66},
  [6626] = {.lex_state = 48, .external_lex_state = 66},
  [6627] = {.lex_state = 48, .external_lex_state = 66},
  [6628] = {.lex_state = 48, .external_lex_state = 68},
  [6629] = {.lex_state = 48, .external_lex_state = 65},
  [6630] = {.lex_state = 48, .external_lex_state = 65},
  [6631] = {.lex_state = 48, .external_lex_state = 66},
  [6632] = {.lex_state = 48, .external_lex_state = 65},
  [6633] = {.lex_state = 48, .external_lex_state = 66},
  [6634] = {.lex_state = 48, .external_lex_state = 209},
  [6635] = {.lex_state = 48, .external_lex_state = 68},
  [6636] = {.lex_state = 48, .external_lex_state = 65},
  [6637] = {.lex_state = 48, .external_lex_state = 68},
  [6638] = {.lex_state = 48, .external_lex_state = 64},
  [6639] = {.lex_state = 48, .external_lex_state = 64},
  [6640] = {.lex_state = 48, .external_lex_state = 65},
  [6641] = {.lex_state = 48, .external_lex_state = 64},
  [6642] = {.lex_state = 48, .external_lex_state = 65},
  [6643] = {.lex_state = 48, .external_lex_state = 67},
  [6644] = {.lex_state = 48, .external_lex_state = 67},
  [6645] = {.lex_state = 48, .external_lex_state = 68},
  [6646] = {.lex_state = 48, .external_lex_state = 65},
  [6647] = {.lex_state = 48, .external_lex_state = 67},
  [6648] = {.lex_state = 48, .external_lex_state = 64},
  [6649] = {.lex_state = 48, .external_lex_state = 66},
  [6650] = {.lex_state = 48, .external_lex_state = 67},
  [6651] = {.lex_state = 48, .external_lex_state = 68},
  [6652] = {.lex_state = 48, .external_lex_state = 64},
  [6653] = {.lex_state = 48, .external_lex_state = 208},
  [6654] = {.lex_state = 48, .external_lex_state = 66},
  [6655] = {.lex_state = 50, .external_lex_state = 210},
  [6656] = {.lex_state = 48, .external_lex_state = 66},
  [6657] = {.lex_state = 48, .external_lex_state = 66},
  [6658] = {.lex_state = 48, .external_lex_state = 65},
  [6659] = {.lex_state = 48, .external_lex_state = 66},
  [6660] = {.lex_state = 48, .external_lex_state = 67},
  [6661] = {.lex_state = 48, .external_lex_state = 67},
  [6662] = {.lex_state = 48, .external_lex_state = 66},
  [6663] = {.lex_state = 48, .external_lex_state = 65},
  [6664] = {.lex_state = 48, .external_lex_state = 65},
  [6665] = {.lex_state = 48, .external_lex_state = 68},
  [6666] = {.lex_state = 48, .external_lex_state = 65},
  [6667] = {.lex_state = 48, .external_lex_state = 65},
  [6668] = {.lex_state = 48, .external_lex_state = 66},
  [6669] = {.lex_state = 48, .external_lex_state = 64},
  [6670] = {.lex_state = 48, .external_lex_state = 66},
  [6671] = {.lex_state = 48, .external_lex_state = 67},
  [6672] = {.lex_state = 48, .external_lex_state = 68},
  [6673] = {.lex_state = 48, .external_lex_state = 67},
  [6674] = {.lex_state = 48, .external_lex_state = 65},
  [6675] = {.lex_state = 48, .external_lex_state = 68},
  [6676] = {.lex_state = 48, .external_lex_state = 64},
  [6677] = {.lex_state = 48, .external_lex_state = 66},
  [6678] = {.lex_state = 48, .external_lex_state = 65},
  [6679] = {.lex_state = 48, .external_lex_state = 65},
  [6680] = {.lex_state = 48, .external_lex_state = 64},
  [6681] = {.lex_state = 48, .external_lex_state = 65},
  [6682] = {.lex_state = 48, .external_lex_state = 65},
  [6683] = {.lex_state = 48, .external_lex_state = 64},
  [6684] = {.lex_state = 48, .external_lex_state = 65},
  [6685] = {.lex_state = 48, .external_lex_state = 64},
  [6686] = {.lex_state = 48, .external_lex_state = 64},
  [6687] = {.lex_state = 48, .external_lex_state = 65},
  [6688] = {.lex_state = 48, .external_lex_state = 209},
  [6689] = {.lex_state = 48, .external_lex_state = 65},
  [6690] = {.lex_state = 48, .external_lex_state = 64},
  [6691] = {.lex_state = 48, .external_lex_state = 67},
  [6692] = {.lex_state = 48, .external_lex_state = 65},
  [6693] = {.lex_state = 48, .external_lex_state = 66},
  [6694] = {.lex_state = 48, .external_lex_state = 67},
  [6695] = {.lex_state = 48, .external_lex_state = 64},
  [6696] = {.lex_state = 48, .external_lex_state = 64},
  [6697] = {.lex_state = 48, .external_lex_state = 65},
  [6698] = {.lex_state = 48, .external_lex_state = 65},
  [6699] = {.lex_state = 48, .external_lex_state = 64},
  [6700] = {.lex_state = 48, .external_lex_state = 65},
  [6701] = {.lex_state = 48, .external_lex_state = 67},
  [6702] = {.lex_state = 48, .external_lex_state = 209},
  [6703] = {.lex_state = 48, .external_lex_state = 64},
  [6704] = {.lex_state = 48, .external_lex_state = 208},
  [6705] = {.lex_state = 48, .external_lex_state = 64},
  [6706] = {.lex_state = 48, .external_lex_state = 66},
  [6707] = {.lex_state = 48, .external_lex_state = 65},
  [6708] = {.lex_state = 48, .external_lex_state = 68},
  [6709] = {.lex_state = 48, .external_lex_state = 64},
  [6710] = {.lex_state = 48, .external_lex_state = 68},
  [6711] = {.lex_state = 48, .external_lex_state = 66},
  [6712] = {.lex_state = 48, .external_lex_state = 67},
  [6713] = {.lex_state = 48, .external_lex_state = 64},
  [6714] = {.lex_state = 48, .external_lex_state = 209},
  [6715] = {.lex_state = 48, .external_lex_state = 209},
  [6716] = {.lex_state = 48, .external_lex_state = 64},
  [6717] = {.lex_state = 48, .external_lex_state = 67},
  [6718] = {.lex_state = 48, .external_lex_state = 64},
  [6719] = {.lex_state = 48, .external_lex_state = 64},
  [6720] = {.lex_state = 48, .external_lex_state = 67},
  [6721] = {.lex_state = 48, .external_lex_state = 64},
  [6722] = {.lex_state = 48, .external_lex_state = 65},
  [6723] = {.lex_state = 48, .external_lex_state = 65},
  [6724] = {.lex_state = 48, .external_lex_state = 67},
  [6725] = {.lex_state = 48, .external_lex_state = 67},
  [6726] = {.lex_state = 48, .external_lex_state = 67},
  [6727] = {.lex_state = 48, .external_lex_state = 65},
  [6728] = {.lex_state = 48, .external_lex_state = 67},
  [6729] = {.lex_state = 48, .external_lex_state = 66},
  [6730] = {.lex_state = 48, .external_lex_state = 64},
  [6731] = {.lex_state = 48, .external_lex_state = 68},
  [6732] = {.lex_state = 48, .external_lex_state = 67},
  [6733] = {.lex_state = 48, .external_lex_state = 67},
  [6734] = {.lex_state = 48, .external_lex_state = 67},
  [6735] = {.lex_state = 48, .external_lex_state = 208},
  [6736] = {.lex_state = 48, .external_lex_state = 64},
  [6737] = {.lex_state = 48, .external_lex_state = 66},
  [6738] = {.lex_state = 48, .external_lex_state = 65},
  [6739] = {.lex_state = 48, .external_lex_state = 67},
  [6740] = {.lex_state = 48, .external_lex_state = 208},
  [6741] = {.lex_state = 48, .external_lex_state = 64},
  [6742] = {.lex_state = 48, .external_lex_state = 64},
  [6743] = {.lex_state = 48, .external_lex_state = 67},
  [6744] = {.lex_state = 48, .external_lex_state = 67},
  [6745] = {.lex_state = 48, .external_lex_state = 67},
  [6746] = {.lex_state = 48, .external_lex_state = 68},
  [6747] = {.lex_state = 48, .external_lex_state = 67},
  [6748] = {.lex_state = 48, .external_lex_state = 68},
  [6749] = {.lex_state = 48, .external_lex_state = 68},
  [6750] = {.lex_state = 48, .external_lex_state = 68},
  [6751] = {.lex_state = 48, .external_lex_state = 67},
  [6752] = {.lex_state = 48, .external_lex_state = 68},
  [6753] = {.lex_state = 48, .external_lex_state = 68},
  [6754] = {.lex_state = 48, .external_lex_state = 68},
  [6755] = {.lex_state = 48, .external_lex_state = 68},
  [6756] = {.lex_state = 48, .external_lex_state = 68},
  [6757] = {.lex_state = 48, .external_lex_state = 68},
  [6758] = {.lex_state = 48, .external_lex_state = 68},
  [6759] = {.lex_state = 48, .external_lex_state = 67},
  [6760] = {.lex_state = 48, .external_lex_state = 68},
  [6761] = {.lex_state = 48, .external_lex_state = 68},
  [6762] = {.lex_state = 48, .external_lex_state = 68},
  [6763] = {.lex_state = 48, .external_lex_state = 66},
  [6764] = {.lex_state = 48, .external_lex_state = 67},
  [6765] = {.lex_state = 48, .external_lex_state = 64},
  [6766] = {.lex_state = 48, .external_lex_state = 67},
  [6767] = {.lex_state = 48, .external_lex_state = 64},
  [6768] = {.lex_state = 48, .external_lex_state = 67},
  [6769] = {.lex_state = 48, .external_lex_state = 68},
  [6770] = {.lex_state = 48, .external_lex_state = 211},
  [6771] = {.lex_state = 48, .external_lex_state = 68},
  [6772] = {.lex_state = 48, .external_lex_state = 68},
  [6773] = {.lex_state = 48, .external_lex_state = 66},
  [6774] = {.lex_state = 48, .external_lex_state = 211},
  [6775] = {.lex_state = 48, .external_lex_state = 68},
  [6776] = {.lex_state = 48, .external_lex_state = 64},
  [6777] = {.lex_state = 48, .external_lex_state = 66},
  [6778] = {.lex_state = 48, .external_lex_state = 209},
  [6779] = {.lex_state = 48, .external_lex_state = 68},
  [6780] = {.lex_state = 48, .external_lex_state = 208},
  [6781] = {.lex_state = 48, .external_lex_state = 211},
  [6782] = {.lex_state = 48, .external_lex_state = 211},
  [6783] = {.lex_state = 48, .external_lex_state = 211},
  [6784] = {.lex_state = 48, .external_lex_state = 68},
  [6785] = {.lex_state = 48, .external_lex_state = 65},
  [6786] = {.lex_state = 48, .external_lex_state = 211},
  [6787] = {.lex_state = 48, .external_lex_state = 65},
  [6788] = {.lex_state = 48, .external_lex_state = 68},
  [6789] = {.lex_state = 48, .external_lex_state = 68},
  [6790] = {.lex_state = 48, .external_lex_state = 212},
  [6791] = {.lex_state = 48, .external_lex_state = 13},
  [6792] = {.lex_state = 48, .external_lex_state = 13},
  [6793] = {.lex_state = 48, .external_lex_state = 13},
  [6794] = {.lex_state = 48, .external_lex_state = 13},
  [6795] = {.lex_state = 48, .external_lex_state = 13},
  [6796] = {.lex_state = 48, .external_lex_state = 69},
  [6797] = {.lex_state = 48, .external_lex_state = 13},
  [6798] = {.lex_state = 48, .external_lex_state = 213},
  [6799] = {.lex_state = 48, .external_lex_state = 71},
  [6800] = {.lex_state = 48, .external_lex_state = 13},
  [6801] = {.lex_state = 48, .external_lex_state = 13},
  [6802] = {.lex_state = 48, .external_lex_state = 13},
  [6803] = {.lex_state = 48, .external_lex_state = 13},
  [6804] = {.lex_state = 48, .external_lex_state = 13},
  [6805] = {.lex_state = 48, .external_lex_state = 13},
  [6806] = {.lex_state = 48, .external_lex_state = 13},
  [6807] = {.lex_state = 48, .external_lex_state = 13},
  [6808] = {.lex_state = 48, .external_lex_state = 13},
  [6809] = {.lex_state = 48, .external_lex_state = 13},
  [6810] = {.lex_state = 48, .external_lex_state = 13},
  [6811] = {.lex_state = 48, .external_lex_state = 13},
  [6812] = {.lex_state = 48, .external_lex_state = 13},
  [6813] = {.lex_state = 48, .external_lex_state = 13},
  [6814] = {.lex_state = 48, .external_lex_state = 13},
  [6815] = {.lex_state = 48, .external_lex_state = 13},
  [6816] = {.lex_state = 48, .external_lex_state = 13},
  [6817] = {.lex_state = 48, .external_lex_state = 213},
  [6818] = {.lex_state = 48, .external_lex_state = 13},
  [6819] = {.lex_state = 48, .external_lex_state = 13},
  [6820] = {.lex_state = 48, .external_lex_state = 212},
  [6821] = {.lex_state = 48, .external_lex_state = 13},
  [6822] = {.lex_state = 48, .external_lex_state = 13},
  [6823] = {.lex_state = 48, .external_lex_state = 13},
  [6824] = {.lex_state = 48, .external_lex_state = 13},
  [6825] = {.lex_state = 48, .external_lex_state = 13},
  [6826] = {.lex_state = 48, .external_lex_state = 13},
  [6827] = {.lex_state = 48, .external_lex_state = 13},
  [6828] = {.lex_state = 48, .external_lex_state = 13},
  [6829] = {.lex_state = 48, .external_lex_state = 13},
  [6830] = {.lex_state = 48, .external_lex_state = 13},
  [6831] = {.lex_state = 48, .external_lex_state = 13},
  [6832] = {.lex_state = 48, .external_lex_state = 13},
  [6833] = {.lex_state = 48, .external_lex_state = 69},
  [6834] = {.lex_state = 48, .external_lex_state = 13},
  [6835] = {.lex_state = 48, .external_lex_state = 13},
  [6836] = {.lex_state = 48, .external_lex_state = 13},
  [6837] = {.lex_state = 48, .external_lex_state = 13},
  [6838] = {.lex_state = 48, .external_lex_state = 213},
  [6839] = {.lex_state = 48, .external_lex_state = 13},
  [6840] = {.lex_state = 48, .external_lex_state = 13},
  [6841] = {.lex_state = 48, .external_lex_state = 13},
  [6842] = {.lex_state = 48, .external_lex_state = 13},
  [6843] = {.lex_state = 48, .external_lex_state = 214},
  [6844] = {.lex_state = 48, .external_lex_state = 13},
  [6845] = {.lex_state = 48, .external_lex_state = 71},
  [6846] = {.lex_state = 48, .external_lex_state = 13},
  [6847] = {.lex_state = 48, .external_lex_state = 13},
  [6848] = {.lex_state = 48, .external_lex_state = 13},
  [6849] = {.lex_state = 48, .external_lex_state = 214},
  [6850] = {.lex_state = 48, .external_lex_state = 71},
  [6851] = {.lex_state = 48, .external_lex_state = 71},
  [6852] = {.lex_state = 48, .external_lex_state = 13},
  [6853] = {.lex_state = 48, .external_lex_state = 13},
  [6854] = {.lex_state = 48, .external_lex_state = 13},
  [6855] = {.lex_state = 48, .external_lex_state = 215},
  [6856] = {.lex_state = 48, .external_lex_state = 71},
  [6857] = {.lex_state = 48, .external_lex_state = 69},
  [6858] = {.lex_state = 48, .external_lex_state = 53},
  [6859] = {.lex_state = 48, .external_lex_state = 71},
  [6860] = {.lex_state = 48, .external_lex_state = 71},
  [6861] = {.lex_state = 48, .external_lex_state = 71},
  [6862] = {.lex_state = 48, .external_lex_state = 71},
  [6863] = {.lex_state = 48, .external_lex_state = 13},
  [6864] = {.lex_state = 48, .external_lex_state = 13},
  [6865] = {.lex_state = 48, .external_lex_state = 13},
  [6866] = {.lex_state = 48, .external_lex_state = 71},
  [6867] = {.lex_state = 48, .external_lex_state = 71},
  [6868] = {.lex_state = 48, .external_lex_state = 214},
  [6869] = {.lex_state = 48, .external_lex_state = 13},
  [6870] = {.lex_state = 48, .external_lex_state = 70},
  [6871] = {.lex_state = 48, .external_lex_state = 13},
  [6872] = {.lex_state = 48, .external_lex_state = 71},
  [6873] = {.lex_state = 48, .external_lex_state = 13},
  [6874] = {.lex_state = 48, .external_lex_state = 71},
  [6875] = {.lex_state = 48, .external_lex_state = 71},
  [6876] = {.lex_state = 48, .external_lex_state = 69},
  [6877] = {.lex_state = 48, .external_lex_state = 13},
  [6878] = {.lex_state = 48, .external_lex_state = 13},
  [6879] = {.lex_state = 48, .external_lex_state = 213},
  [6880] = {.lex_state = 48, .external_lex_state = 71},
  [6881] = {.lex_state = 48, .external_lex_state = 13},
  [6882] = {.lex_state = 48, .external_lex_state = 70},
  [6883] = {.lex_state = 48, .external_lex_state = 71},
  [6884] = {.lex_state = 48, .external_lex_state = 13},
  [6885] = {.lex_state = 48, .external_lex_state = 13},
  [6886] = {.lex_state = 48, .external_lex_state = 213},
  [6887] = {.lex_state = 48, .external_lex_state = 13},
  [6888] = {.lex_state = 48, .external_lex_state = 13},
  [6889] = {.lex_state = 48, .external_lex_state = 13},
  [6890] = {.lex_state = 48, .external_lex_state = 13},
  [6891] = {.lex_state = 48, .external_lex_state = 69},
  [6892] = {.lex_state = 48, .external_lex_state = 69},
  [6893] = {.lex_state = 48, .external_lex_state = 69},
  [6894] = {.lex_state = 48, .external_lex_state = 13},
  [6895] = {.lex_state = 48, .external_lex_state = 69},
  [6896] = {.lex_state = 48, .external_lex_state = 69},
  [6897] = {.lex_state = 48, .external_lex_state = 69},
  [6898] = {.lex_state = 48, .external_lex_state = 13},
  [6899] = {.lex_state = 48, .external_lex_state = 70},
  [6900] = {.lex_state = 48, .external_lex_state = 13},
  [6901] = {.lex_state = 48, .external_lex_state = 69},
  [6902] = {.lex_state = 48, .external_lex_state = 69},
  [6903] = {.lex_state = 48, .external_lex_state = 13},
  [6904] = {.lex_state = 48, .external_lex_state = 13},
  [6905] = {.lex_state = 48, .external_lex_state = 214},
  [6906] = {.lex_state = 48, .external_lex_state = 13},
  [6907] = {.lex_state = 48, .external_lex_state = 69},
  [6908] = {.lex_state = 48, .external_lex_state = 69},
  [6909] = {.lex_state = 48, .external_lex_state = 13},
  [6910] = {.lex_state = 48, .external_lex_state = 69},
  [6911] = {.lex_state = 48, .external_lex_state = 214},
  [6912] = {.lex_state = 48, .external_lex_state = 71},
  [6913] = {.lex_state = 48, .external_lex_state = 13},
  [6914] = {.lex_state = 48, .external_lex_state = 70},
  [6915] = {.lex_state = 48, .external_lex_state = 70},
  [6916] = {.lex_state = 48, .external_lex_state = 13},
  [6917] = {.lex_state = 48, .external_lex_state = 70},
  [6918] = {.lex_state = 48, .external_lex_state = 13},
  [6919] = {.lex_state = 48, .external_lex_state = 13},
  [6920] = {.lex_state = 48, .external_lex_state = 13},
  [6921] = {.lex_state = 48, .external_lex_state = 13},
  [6922] = {.lex_state = 48, .external_lex_state = 70},
  [6923] = {.lex_state = 48, .external_lex_state = 13},
  [6924] = {.lex_state = 48, .external_lex_state = 70},
  [6925] = {.lex_state = 48, .external_lex_state = 13},
  [6926] = {.lex_state = 48, .external_lex_state = 13},
  [6927] = {.lex_state = 48, .external_lex_state = 13},
  [6928] = {.lex_state = 48, .external_lex_state = 70},
  [6929] = {.lex_state = 48, .external_lex_state = 70},
  [6930] = {.lex_state = 48, .external_lex_state = 70},
  [6931] = {.lex_state = 48, .external_lex_state = 69},
  [6932] = {.lex_state = 48, .external_lex_state = 13},
  [6933] = {.lex_state = 48, .external_lex_state = 216},
  [6934] = {.lex_state = 48, .external_lex_state = 215},
  [6935] = {.lex_state = 48, .external_lex_state = 13},
  [6936] = {.lex_state = 48, .external_lex_state = 216},
  [6937] = {.lex_state = 48, .external_lex_state = 70},
  [6938] = {.lex_state = 48, .external_lex_state = 13},
  [6939] = {.lex_state = 48, .external_lex_state = 70},
  [6940] = {.lex_state = 48, .external_lex_state = 13},
  [6941] = {.lex_state = 48, .external_lex_state = 70},
  [6942] = {.lex_state = 48, .external_lex_state = 213},
  [6943] = {.lex_state = 48, .external_lex_state = 217},
  [6944] = {.lex_state = 48, .external_lex_state = 215},
  [6945] = {.lex_state = 48, .external_lex_state = 70},
  [6946] = {.lex_state = 48, .external_lex_state = 216},
  [6947] = {.lex_state = 48, .external_lex_state = 215},
  [6948] = {.lex_state = 48, .external_lex_state = 70},
  [6949] = {.lex_state = 48, .external_lex_state = 13},
  [6950] = {.lex_state = 48, .external_lex_state = 13},
  [6951] = {.lex_state = 48, .external_lex_state = 212},
  [6952] = {.lex_state = 48, .external_lex_state = 13},
  [6953] = {.lex_state = 48, .external_lex_state = 216},
  [6954] = {.lex_state = 48, .external_lex_state = 70},
  [6955] = {.lex_state = 48, .external_lex_state = 70},
  [6956] = {.lex_state = 48, .external_lex_state = 70},
  [6957] = {.lex_state = 48, .external_lex_state = 13},
  [6958] = {.lex_state = 48, .external_lex_state = 216},
  [6959] = {.lex_state = 48, .external_lex_state = 70},
  [6960] = {.lex_state = 48, .external_lex_state = 71},
  [6961] = {.lex_state = 48, .external_lex_state = 13},
  [6962] = {.lex_state = 48, .external_lex_state = 13},
  [6963] = {.lex_state = 48, .external_lex_state = 70},
  [6964] = {.lex_state = 48, .external_lex_state = 71},
  [6965] = {.lex_state = 48, .external_lex_state = 70},
  [6966] = {.lex_state = 48, .external_lex_state = 13},
  [6967] = {.lex_state = 48, .external_lex_state = 13},
  [6968] = {.lex_state = 48, .external_lex_state = 71},
  [6969] = {.lex_state = 48, .external_lex_state = 69},
  [6970] = {.lex_state = 48, .external_lex_state = 13},
  [6971] = {.lex_state = 48, .external_lex_state = 215},
  [6972] = {.lex_state = 48, .external_lex_state = 212},
  [6973] = {.lex_state = 48, .external_lex_state = 47},
  [6974] = {.lex_state = 48, .external_lex_state = 13},
  [6975] = {.lex_state = 48, .external_lex_state = 69},
  [6976] = {.lex_state = 48, .external_lex_state = 69},
  [6977] = {.lex_state = 48, .external_lex_state = 69},
  [6978] = {.lex_state = 48, .external_lex_state = 69},
  [6979] = {.lex_state = 48, .external_lex_state = 13},
  [6980] = {.lex_state = 48, .external_lex_state = 69},
  [6981] = {.lex_state = 48, .external_lex_state = 13},
  [6982] = {.lex_state = 48, .external_lex_state = 217},
  [6983] = {.lex_state = 48, .external_lex_state = 69},
  [6984] = {.lex_state = 48, .external_lex_state = 69},
  [6985] = {.lex_state = 48, .external_lex_state = 70},
  [6986] = {.lex_state = 48, .external_lex_state = 70},
  [6987] = {.lex_state = 48, .external_lex_state = 70},
  [6988] = {.lex_state = 48, .external_lex_state = 70},
  [6989] = {.lex_state = 48, .external_lex_state = 217},
  [6990] = {.lex_state = 48, .external_lex_state = 70},
  [6991] = {.lex_state = 48, .external_lex_state = 217},
  [6992] = {.lex_state = 48, .external_lex_state = 70},
  [6993] = {.lex_state = 48, .external_lex_state = 70},
  [6994] = {.lex_state = 48, .external_lex_state = 212},
  [6995] = {.lex_state = 48, .external_lex_state = 212},
  [6996] = {.lex_state = 48, .external_lex_state = 13},
  [6997] = {.lex_state = 48, .external_lex_state = 217},
  [6998] = {.lex_state = 48, .external_lex_state = 71},
  [6999] = {.lex_state = 48, .external_lex_state = 13},
  [7000] = {.lex_state = 48, .external_lex_state = 13},
  [7001] = {.lex_state = 48, .external_lex_state = 70},
  [7002] = {.lex_state = 48, .external_lex_state = 71},
  [7003] = {.lex_state = 48, .external_lex_state = 71},
  [7004] = {.lex_state = 48, .external_lex_state = 70},
  [7005] = {.lex_state = 48, .external_lex_state = 70},
  [7006] = {.lex_state = 48, .external_lex_state = 71},
  [7007] = {.lex_state = 48, .external_lex_state = 13},
  [7008] = {.lex_state = 48, .external_lex_state = 70},
  [7009] = {.lex_state = 48, .external_lex_state = 70},
  [7010] = {.lex_state = 48, .external_lex_state = 71},
  [7011] = {.lex_state = 48, .external_lex_state = 71},
  [7012] = {.lex_state = 48, .external_lex_state = 13},
  [7013] = {.lex_state = 48, .external_lex_state = 13},
  [7014] = {.lex_state = 48, .external_lex_state = 13},
  [7015] = {.lex_state = 48, .external_lex_state = 71},
  [7016] = {.lex_state = 48, .external_lex_state = 69},
  [7017] = {.lex_state = 48, .external_lex_state = 71},
  [7018] = {.lex_state = 48, .external_lex_state = 13},
  [7019] = {.lex_state = 48, .external_lex_state = 69},
  [7020] = {.lex_state = 48, .external_lex_state = 13},
  [7021] = {.lex_state = 48, .external_lex_state = 13},
  [7022] = {.lex_state = 48, .external_lex_state = 71},
  [7023] = {.lex_state = 48, .external_lex_state = 70},
  [7024] = {.lex_state = 48, .external_lex_state = 69},
  [7025] = {.lex_state = 48, .external_lex_state = 69},
  [7026] = {.lex_state = 48, .external_lex_state = 69},
  [7027] = {.lex_state = 48, .external_lex_state = 71},
  [7028] = {.lex_state = 48, .external_lex_state = 71},
  [7029] = {.lex_state = 48, .external_lex_state = 216},
  [7030] = {.lex_state = 48, .external_lex_state = 218},
  [7031] = {.lex_state = 48, .external_lex_state = 71},
  [7032] = {.lex_state = 48, .external_lex_state = 69},
  [7033] = {.lex_state = 48, .external_lex_state = 70},
  [7034] = {.lex_state = 48, .external_lex_state = 69},
  [7035] = {.lex_state = 48, .external_lex_state = 71},
  [7036] = {.lex_state = 48, .external_lex_state = 13},
  [7037] = {.lex_state = 48, .external_lex_state = 214},
  [7038] = {.lex_state = 48, .external_lex_state = 69},
  [7039] = {.lex_state = 48, .external_lex_state = 69},
  [7040] = {.lex_state = 48, .external_lex_state = 69},
  [7041] = {.lex_state = 48, .external_lex_state = 217},
  [7042] = {.lex_state = 48, .external_lex_state = 13},
  [7043] = {.lex_state = 48, .external_lex_state = 13},
  [7044] = {.lex_state = 48, .external_lex_state = 71},
  [7045] = {.lex_state = 48, .external_lex_state = 71},
  [7046] = {.lex_state = 48, .external_lex_state = 215},
  [7047] = {.lex_state = 48, .external_lex_state = 71},
  [7048] = {.lex_state = 48, .external_lex_state = 69},
  [7049] = {.lex_state = 48, .external_lex_state = 13},
  [7050] = {.lex_state = 48, .external_lex_state = 69},
  [7051] = {.lex_state = 48, .external_lex_state = 13},
  [7052] = {.lex_state = 48, .external_lex_state = 121},
  [7053] = {.lex_state = 48, .external_lex_state = 74},
  [7054] = {.lex_state = 48, .external_lex_state = 77},
  [7055] = {.lex_state = 48, .external_lex_state = 219},
  [7056] = {.lex_state = 48, .external_lex_state = 74},
  [7057] = {.lex_state = 48, .external_lex_state = 13},
  [7058] = {.lex_state = 48, .external_lex_state = 74},
  [7059] = {.lex_state = 48, .external_lex_state = 73},
  [7060] = {.lex_state = 48, .external_lex_state = 73},
  [7061] = {.lex_state = 48, .external_lex_state = 75},
  [7062] = {.lex_state = 48, .external_lex_state = 220},
  [7063] = {.lex_state = 50, .external_lex_state = 221},
  [7064] = {.lex_state = 48, .external_lex_state = 75},
  [7065] = {.lex_state = 48, .external_lex_state = 121},
  [7066] = {.lex_state = 48, .external_lex_state = 73},
  [7067] = {.lex_state = 48, .external_lex_state = 75},
  [7068] = {.lex_state = 48, .external_lex_state = 77},
  [7069] = {.lex_state = 48, .external_lex_state = 75},
  [7070] = {.lex_state = 48, .external_lex_state = 75},
  [7071] = {.lex_state = 48, .external_lex_state = 75},
  [7072] = {.lex_state = 48, .external_lex_state = 121},
  [7073] = {.lex_state = 48, .external_lex_state = 77},
  [7074] = {.lex_state = 48, .external_lex_state = 75},
  [7075] = {.lex_state = 48, .external_lex_state = 74},
  [7076] = {.lex_state = 48, .external_lex_state = 77},
  [7077] = {.lex_state = 48, .external_lex_state = 219},
  [7078] = {.lex_state = 48, .external_lex_state = 220},
  [7079] = {.lex_state = 48, .external_lex_state = 13},
  [7080] = {.lex_state = 48, .external_lex_state = 72},
  [7081] = {.lex_state = 48, .external_lex_state = 75},
  [7082] = {.lex_state = 48, .external_lex_state = 74},
  [7083] = {.lex_state = 48, .external_lex_state = 72},
  [7084] = {.lex_state = 48, .external_lex_state = 73},
  [7085] = {.lex_state = 48, .external_lex_state = 73},
  [7086] = {.lex_state = 48, .external_lex_state = 75},
  [7087] = {.lex_state = 48, .external_lex_state = 73},
  [7088] = {.lex_state = 48, .external_lex_state = 222},
  [7089] = {.lex_state = 48, .external_lex_state = 75},
  [7090] = {.lex_state = 48, .external_lex_state = 73},
  [7091] = {.lex_state = 48, .external_lex_state = 56},
  [7092] = {.lex_state = 48, .external_lex_state = 75},
  [7093] = {.lex_state = 48, .external_lex_state = 75},
  [7094] = {.lex_state = 48, .external_lex_state = 75},
  [7095] = {.lex_state = 48, .external_lex_state = 75},
  [7096] = {.lex_state = 48, .external_lex_state = 73},
  [7097] = {.lex_state = 50, .external_lex_state = 223},
  [7098] = {.lex_state = 48, .external_lex_state = 77},
  [7099] = {.lex_state = 48, .external_lex_state = 73},
  [7100] = {.lex_state = 48, .external_lex_state = 73},
  [7101] = {.lex_state = 48, .external_lex_state = 75},
  [7102] = {.lex_state = 48, .external_lex_state = 75},
  [7103] = {.lex_state = 48, .external_lex_state = 73},
  [7104] = {.lex_state = 48, .external_lex_state = 73},
  [7105] = {.lex_state = 48, .external_lex_state = 73},
  [7106] = {.lex_state = 48, .external_lex_state = 224},
  [7107] = {.lex_state = 48, .external_lex_state = 76},
  [7108] = {.lex_state = 48, .external_lex_state = 225},
  [7109] = {.lex_state = 48, .external_lex_state = 73},
  [7110] = {.lex_state = 48, .external_lex_state = 225},
  [7111] = {.lex_state = 48, .external_lex_state = 72},
  [7112] = {.lex_state = 48, .external_lex_state = 76},
  [7113] = {.lex_state = 48, .external_lex_state = 75},
  [7114] = {.lex_state = 48, .external_lex_state = 222},
  [7115] = {.lex_state = 48, .external_lex_state = 75},
  [7116] = {.lex_state = 48, .external_lex_state = 72},
  [7117] = {.lex_state = 48, .external_lex_state = 75},
  [7118] = {.lex_state = 48, .external_lex_state = 73},
  [7119] = {.lex_state = 48, .external_lex_state = 72},
  [7120] = {.lex_state = 48, .external_lex_state = 73},
  [7121] = {.lex_state = 48, .external_lex_state = 75},
  [7122] = {.lex_state = 48, .external_lex_state = 77},
  [7123] = {.lex_state = 48, .external_lex_state = 73},
  [7124] = {.lex_state = 48, .external_lex_state = 76},
  [7125] = {.lex_state = 48, .external_lex_state = 72},
  [7126] = {.lex_state = 48, .external_lex_state = 76},
  [7127] = {.lex_state = 48, .external_lex_state = 73},
  [7128] = {.lex_state = 48, .external_lex_state = 76},
  [7129] = {.lex_state = 48, .external_lex_state = 74},
  [7130] = {.lex_state = 48, .external_lex_state = 225},
  [7131] = {.lex_state = 48, .external_lex_state = 220},
  [7132] = {.lex_state = 48, .external_lex_state = 76},
  [7133] = {.lex_state = 48, .external_lex_state = 72},
  [7134] = {.lex_state = 48, .external_lex_state = 73},
  [7135] = {.lex_state = 48, .external_lex_state = 225},
  [7136] = {.lex_state = 48, .external_lex_state = 74},
  [7137] = {.lex_state = 48, .external_lex_state = 73},
  [7138] = {.lex_state = 48, .external_lex_state = 76},
  [7139] = {.lex_state = 48, .external_lex_state = 72},
  [7140] = {.lex_state = 48, .external_lex_state = 74},
  [7141] = {.lex_state = 48, .external_lex_state = 74},
  [7142] = {.lex_state = 48, .external_lex_state = 73},
  [7143] = {.lex_state = 48, .external_lex_state = 218},
  [7144] = {.lex_state = 48, .external_lex_state = 75},
  [7145] = {.lex_state = 48, .external_lex_state = 75},
  [7146] = {.lex_state = 48, .external_lex_state = 74},
  [7147] = {.lex_state = 48, .external_lex_state = 76},
  [7148] = {.lex_state = 48, .external_lex_state = 73},
  [7149] = {.lex_state = 48, .external_lex_state = 220},
  [7150] = {.lex_state = 48, .external_lex_state = 72},
  [7151] = {.lex_state = 48, .external_lex_state = 74},
  [7152] = {.lex_state = 48, .external_lex_state = 76},
  [7153] = {.lex_state = 48, .external_lex_state = 72},
  [7154] = {.lex_state = 48, .external_lex_state = 224},
  [7155] = {.lex_state = 48, .external_lex_state = 222},
  [7156] = {.lex_state = 48, .external_lex_state = 72},
  [7157] = {.lex_state = 48, .external_lex_state = 73},
  [7158] = {.lex_state = 48, .external_lex_state = 72},
  [7159] = {.lex_state = 48, .external_lex_state = 72},
  [7160] = {.lex_state = 48, .external_lex_state = 121},
  [7161] = {.lex_state = 48, .external_lex_state = 73},
  [7162] = {.lex_state = 48, .external_lex_state = 76},
  [7163] = {.lex_state = 48, .external_lex_state = 76},
  [7164] = {.lex_state = 48, .external_lex_state = 73},
  [7165] = {.lex_state = 48, .external_lex_state = 225},
  [7166] = {.lex_state = 48, .external_lex_state = 76},
  [7167] = {.lex_state = 48, .external_lex_state = 77},
  [7168] = {.lex_state = 48, .external_lex_state = 77},
  [7169] = {.lex_state = 48, .external_lex_state = 72},
  [7170] = {.lex_state = 48, .external_lex_state = 74},
  [7171] = {.lex_state = 48, .external_lex_state = 77},
  [7172] = {.lex_state = 48, .external_lex_state = 76},
  [7173] = {.lex_state = 48, .external_lex_state = 226},
  [7174] = {.lex_state = 48, .external_lex_state = 72},
  [7175] = {.lex_state = 48, .external_lex_state = 72},
  [7176] = {.lex_state = 48, .external_lex_state = 224},
  [7177] = {.lex_state = 48, .external_lex_state = 72},
  [7178] = {.lex_state = 48, .external_lex_state = 72},
  [7179] = {.lex_state = 48, .external_lex_state = 72},
  [7180] = {.lex_state = 48, .external_lex_state = 73},
  [7181] = {.lex_state = 48, .external_lex_state = 77},
  [7182] = {.lex_state = 48, .external_lex_state = 76},
  [7183] = {.lex_state = 48, .external_lex_state = 224},
  [7184] = {.lex_state = 48, .external_lex_state = 74},
  [7185] = {.lex_state = 48, .external_lex_state = 73},
  [7186] = {.lex_state = 48, .external_lex_state = 74},
  [7187] = {.lex_state = 48, .external_lex_state = 74},
  [7188] = {.lex_state = 48, .external_lex_state = 77},
  [7189] = {.lex_state = 48, .external_lex_state = 77},
  [7190] = {.lex_state = 48, .external_lex_state = 74},
  [7191] = {.lex_state = 48, .external_lex_state = 74},
  [7192] = {.lex_state = 48, .external_lex_state = 73},
  [7193] = {.lex_state = 48, .external_lex_state = 77},
  [7194] = {.lex_state = 48, .external_lex_state = 74},
  [7195] = {.lex_state = 48, .external_lex_state = 73},
  [7196] = {.lex_state = 48, .external_lex_state = 77},
  [7197] = {.lex_state = 48, .external_lex_state = 77},
  [7198] = {.lex_state = 48, .external_lex_state = 73},
  [7199] = {.lex_state = 48, .external_lex_state = 77},
  [7200] = {.lex_state = 48, .external_lex_state = 77},
  [7201] = {.lex_state = 48, .external_lex_state = 72},
  [7202] = {.lex_state = 48, .external_lex_state = 72},
  [7203] = {.lex_state = 48, .external_lex_state = 72},
  [7204] = {.lex_state = 48, .external_lex_state = 75},
  [7205] = {.lex_state = 48, .external_lex_state = 76},
  [7206] = {.lex_state = 48, .external_lex_state = 72},
  [7207] = {.lex_state = 48, .external_lex_state = 218},
  [7208] = {.lex_state = 48, .external_lex_state = 76},
  [7209] = {.lex_state = 48, .external_lex_state = 77},
  [7210] = {.lex_state = 48, .external_lex_state = 77},
  [7211] = {.lex_state = 48, .external_lex_state = 74},
  [7212] = {.lex_state = 48, .external_lex_state = 72},
  [7213] = {.lex_state = 48, .external_lex_state = 74},
  [7214] = {.lex_state = 48, .external_lex_state = 121},
  [7215] = {.lex_state = 48, .external_lex_state = 74},
  [7216] = {.lex_state = 48, .external_lex_state = 76},
  [7217] = {.lex_state = 48, .external_lex_state = 76},
  [7218] = {.lex_state = 48, .external_lex_state = 75},
  [7219] = {.lex_state = 48, .external_lex_state = 76},
  [7220] = {.lex_state = 48, .external_lex_state = 73},
  [7221] = {.lex_state = 48, .external_lex_state = 76},
  [7222] = {.lex_state = 48, .external_lex_state = 76},
  [7223] = {.lex_state = 48, .external_lex_state = 219},
  [7224] = {.lex_state = 48, .external_lex_state = 77},
  [7225] = {.lex_state = 48, .external_lex_state = 76},
  [7226] = {.lex_state = 48, .external_lex_state = 72},
  [7227] = {.lex_state = 48, .external_lex_state = 74},
  [7228] = {.lex_state = 48, .external_lex_state = 72},
  [7229] = {.lex_state = 48, .external_lex_state = 76},
  [7230] = {.lex_state = 48, .external_lex_state = 77},
  [7231] = {.lex_state = 48, .external_lex_state = 75},
  [7232] = {.lex_state = 48, .external_lex_state = 76},
  [7233] = {.lex_state = 48, .external_lex_state = 72},
  [7234] = {.lex_state = 48, .external_lex_state = 76},
  [7235] = {.lex_state = 48, .external_lex_state = 72},
  [7236] = {.lex_state = 48, .external_lex_state = 76},
  [7237] = {.lex_state = 48, .external_lex_state = 77},
  [7238] = {.lex_state = 48, .external_lex_state = 121},
  [7239] = {.lex_state = 48, .external_lex_state = 76},
  [7240] = {.lex_state = 48, .external_lex_state = 74},
  [7241] = {.lex_state = 48, .external_lex_state = 75},
  [7242] = {.lex_state = 48, .external_lex_state = 75},
  [7243] = {.lex_state = 48, .external_lex_state = 74},
  [7244] = {.lex_state = 48, .external_lex_state = 74},
  [7245] = {.lex_state = 48, .external_lex_state = 75},
  [7246] = {.lex_state = 48, .external_lex_state = 76},
  [7247] = {.lex_state = 48, .external_lex_state = 74},
  [7248] = {.lex_state = 48, .external_lex_state = 218},
  [7249] = {.lex_state = 48, .external_lex_state = 75},
  [7250] = {.lex_state = 48, .external_lex_state = 77},
  [7251] = {.lex_state = 48, .external_lex_state = 74},
  [7252] = {.lex_state = 48, .external_lex_state = 75},
  [7253] = {.lex_state = 48, .external_lex_state = 77},
  [7254] = {.lex_state = 48, .external_lex_state = 75},
  [7255] = {.lex_state = 48, .external_lex_state = 77},
  [7256] = {.lex_state = 48, .external_lex_state = 73},
  [7257] = {.lex_state = 48, .external_lex_state = 77},
  [7258] = {.lex_state = 48, .external_lex_state = 226},
  [7259] = {.lex_state = 48, .external_lex_state = 220},
  [7260] = {.lex_state = 48, .external_lex_state = 72},
  [7261] = {.lex_state = 48, .external_lex_state = 74},
  [7262] = {.lex_state = 48, .external_lex_state = 74},
  [7263] = {.lex_state = 48, .external_lex_state = 76},
  [7264] = {.lex_state = 48, .external_lex_state = 74},
  [7265] = {.lex_state = 48, .external_lex_state = 73},
  [7266] = {.lex_state = 48, .external_lex_state = 72},
  [7267] = {.lex_state = 48, .external_lex_state = 77},
  [7268] = {.lex_state = 48, .external_lex_state = 72},
  [7269] = {.lex_state = 48, .external_lex_state = 226},
  [7270] = {.lex_state = 48, .external_lex_state = 75},
  [7271] = {.lex_state = 48, .external_lex_state = 74},
  [7272] = {.lex_state = 48, .external_lex_state = 77},
  [7273] = {.lex_state = 48, .external_lex_state = 73},
  [7274] = {.lex_state = 48, .external_lex_state = 72},
  [7275] = {.lex_state = 48, .external_lex_state = 75},
  [7276] = {.lex_state = 48, .external_lex_state = 224},
  [7277] = {.lex_state = 48, .external_lex_state = 76},
  [7278] = {.lex_state = 48, .external_lex_state = 74},
  [7279] = {.lex_state = 48, .external_lex_state = 226},
  [7280] = {.lex_state = 48, .external_lex_state = 226},
  [7281] = {.lex_state = 48, .external_lex_state = 74},
  [7282] = {.lex_state = 48, .external_lex_state = 74},
  [7283] = {.lex_state = 48, .external_lex_state = 73},
  [7284] = {.lex_state = 48, .external_lex_state = 222},
  [7285] = {.lex_state = 48, .external_lex_state = 74},
  [7286] = {.lex_state = 48, .external_lex_state = 74},
  [7287] = {.lex_state = 48, .external_lex_state = 225},
  [7288] = {.lex_state = 48, .external_lex_state = 77},
  [7289] = {.lex_state = 48, .external_lex_state = 219},
  [7290] = {.lex_state = 48, .external_lex_state = 72},
  [7291] = {.lex_state = 48, .external_lex_state = 76},
  [7292] = {.lex_state = 48, .external_lex_state = 226},
  [7293] = {.lex_state = 48, .external_lex_state = 75},
  [7294] = {.lex_state = 48, .external_lex_state = 77},
  [7295] = {.lex_state = 48, .external_lex_state = 222},
  [7296] = {.lex_state = 48, .external_lex_state = 218},
  [7297] = {.lex_state = 48, .external_lex_state = 222},
  [7298] = {.lex_state = 48, .external_lex_state = 76},
  [7299] = {.lex_state = 48, .external_lex_state = 219},
  [7300] = {.lex_state = 48, .external_lex_state = 72},
  [7301] = {.lex_state = 48, .external_lex_state = 72},
  [7302] = {.lex_state = 48, .external_lex_state = 77},
  [7303] = {.lex_state = 48, .external_lex_state = 219},
  [7304] = {.lex_state = 48, .external_lex_state = 73},
  [7305] = {.lex_state = 48, .external_lex_state = 77},
  [7306] = {.lex_state = 48, .external_lex_state = 76},
  [7307] = {.lex_state = 48, .external_lex_state = 76},
  [7308] = {.lex_state = 48, .external_lex_state = 76},
  [7309] = {.lex_state = 48, .external_lex_state = 218},
  [7310] = {.lex_state = 48, .external_lex_state = 77},
  [7311] = {.lex_state = 48, .external_lex_state = 77},
  [7312] = {.lex_state = 48, .external_lex_state = 75},
  [7313] = {.lex_state = 48, .external_lex_state = 220},
  [7314] = {.lex_state = 48, .external_lex_state = 224},
  [7315] = {.lex_state = 48, .external_lex_state = 76},
  [7316] = {.lex_state = 48, .external_lex_state = 218},
  [7317] = {.lex_state = 48, .external_lex_state = 77},
  [7318] = {.lex_state = 48, .external_lex_state = 77},
  [7319] = {.lex_state = 48, .external_lex_state = 72},
  [7320] = {.lex_state = 48, .external_lex_state = 81},
  [7321] = {.lex_state = 48, .external_lex_state = 80},
  [7322] = {.lex_state = 48, .external_lex_state = 80},
  [7323] = {.lex_state = 48, .external_lex_state = 80},
  [7324] = {.lex_state = 48, .external_lex_state = 80},
  [7325] = {.lex_state = 48, .external_lex_state = 80},
  [7326] = {.lex_state = 48, .external_lex_state = 79},
  [7327] = {.lex_state = 48, .external_lex_state = 78},
  [7328] = {.lex_state = 48, .external_lex_state = 13},
  [7329] = {.lex_state = 48, .external_lex_state = 80},
  [7330] = {.lex_state = 48, .external_lex_state = 80},
  [7331] = {.lex_state = 48, .external_lex_state = 80},
  [7332] = {.lex_state = 48, .external_lex_state = 83},
  [7333] = {.lex_state = 48, .external_lex_state = 80},
  [7334] = {.lex_state = 48, .external_lex_state = 82},
  [7335] = {.lex_state = 48, .external_lex_state = 78},
  [7336] = {.lex_state = 48, .external_lex_state = 83},
  [7337] = {.lex_state = 48, .external_lex_state = 78},
  [7338] = {.lex_state = 48, .external_lex_state = 13},
  [7339] = {.lex_state = 48, .external_lex_state = 83},
  [7340] = {.lex_state = 48, .external_lex_state = 83},
  [7341] = {.lex_state = 48, .external_lex_state = 78},
  [7342] = {.lex_state = 48, .external_lex_state = 81},
  [7343] = {.lex_state = 48, .external_lex_state = 82},
  [7344] = {.lex_state = 48, .external_lex_state = 227},
  [7345] = {.lex_state = 48, .external_lex_state = 83},
  [7346] = {.lex_state = 48, .external_lex_state = 78},
  [7347] = {.lex_state = 48, .external_lex_state = 83},
  [7348] = {.lex_state = 48, .external_lex_state = 79},
  [7349] = {.lex_state = 48, .external_lex_state = 80},
  [7350] = {.lex_state = 48, .external_lex_state = 80},
  [7351] = {.lex_state = 48, .external_lex_state = 82},
  [7352] = {.lex_state = 48, .external_lex_state = 81},
  [7353] = {.lex_state = 48, .external_lex_state = 79},
  [7354] = {.lex_state = 48, .external_lex_state = 227},
  [7355] = {.lex_state = 48, .external_lex_state = 83},
  [7356] = {.lex_state = 48, .external_lex_state = 81},
  [7357] = {.lex_state = 47, .external_lex_state = 121},
  [7358] = {.lex_state = 48, .external_lex_state = 80},
  [7359] = {.lex_state = 48, .external_lex_state = 80},
  [7360] = {.lex_state = 48, .external_lex_state = 82},
  [7361] = {.lex_state = 48, .external_lex_state = 79},
  [7362] = {.lex_state = 48, .external_lex_state = 13},
  [7363] = {.lex_state = 48, .external_lex_state = 78},
  [7364] = {.lex_state = 48, .external_lex_state = 13},
  [7365] = {.lex_state = 48, .external_lex_state = 78},
  [7366] = {.lex_state = 48, .external_lex_state = 83},
  [7367] = {.lex_state = 48, .external_lex_state = 83},
  [7368] = {.lex_state = 48, .external_lex_state = 78},
  [7369] = {.lex_state = 48, .external_lex_state = 78},
  [7370] = {.lex_state = 48, .external_lex_state = 83},
  [7371] = {.lex_state = 48, .external_lex_state = 78},
  [7372] = {.lex_state = 48, .external_lex_state = 228},
  [7373] = {.lex_state = 48, .external_lex_state = 78},
  [7374] = {.lex_state = 48, .external_lex_state = 228},
  [7375] = {.lex_state = 48, .external_lex_state = 79},
  [7376] = {.lex_state = 48, .external_lex_state = 83},
  [7377] = {.lex_state = 48, .external_lex_state = 13},
  [7378] = {.lex_state = 48, .external_lex_state = 80},
  [7379] = {.lex_state = 48, .external_lex_state = 81},
  [7380] = {.lex_state = 48, .external_lex_state = 82},
  [7381] = {.lex_state = 48, .external_lex_state = 82},
  [7382] = {.lex_state = 47, .external_lex_state = 121},
  [7383] = {.lex_state = 48, .external_lex_state = 81},
  [7384] = {.lex_state = 48, .external_lex_state = 81},
  [7385] = {.lex_state = 48, .external_lex_state = 79},
  [7386] = {.lex_state = 48, .external_lex_state = 80},
  [7387] = {.lex_state = 48, .external_lex_state = 13},
  [7388] = {.lex_state = 47, .external_lex_state = 22},
  [7389] = {.lex_state = 48, .external_lex_state = 227},
  [7390] = {.lex_state = 48, .external_lex_state = 80},
  [7391] = {.lex_state = 48, .external_lex_state = 79},
  [7392] = {.lex_state = 48, .external_lex_state = 13},
  [7393] = {.lex_state = 48, .external_lex_state = 80},
  [7394] = {.lex_state = 48, .external_lex_state = 78},
  [7395] = {.lex_state = 48, .external_lex_state = 83},
  [7396] = {.lex_state = 48, .external_lex_state = 83},
  [7397] = {.lex_state = 48, .external_lex_state = 83},
  [7398] = {.lex_state = 48, .external_lex_state = 82},
  [7399] = {.lex_state = 48, .external_lex_state = 83},
  [7400] = {.lex_state = 48, .external_lex_state = 80},
  [7401] = {.lex_state = 48, .external_lex_state = 78},
  [7402] = {.lex_state = 48, .external_lex_state = 83},
  [7403] = {.lex_state = 48, .external_lex_state = 82},
  [7404] = {.lex_state = 48, .external_lex_state = 13},
  [7405] = {.lex_state = 48, .external_lex_state = 81},
  [7406] = {.lex_state = 48, .external_lex_state = 78},
  [7407] = {.lex_state = 48, .external_lex_state = 78},
  [7408] = {.lex_state = 48, .external_lex_state = 78},
  [7409] = {.lex_state = 48, .external_lex_state = 79},
  [7410] = {.lex_state = 48, .external_lex_state = 80},
  [7411] = {.lex_state = 48, .external_lex_state = 78},
  [7412] = {.lex_state = 48, .external_lex_state = 81},
  [7413] = {.lex_state = 48, .external_lex_state = 80},
  [7414] = {.lex_state = 48, .external_lex_state = 83},
  [7415] = {.lex_state = 48, .external_lex_state = 82},
  [7416] = {.lex_state = 48, .external_lex_state = 82},
  [7417] = {.lex_state = 48, .external_lex_state = 83},
  [7418] = {.lex_state = 48, .external_lex_state = 13},
  [7419] = {.lex_state = 48, .external_lex_state = 83},
  [7420] = {.lex_state = 48, .external_lex_state = 83},
  [7421] = {.lex_state = 48, .external_lex_state = 83},
  [7422] = {.lex_state = 48, .external_lex_state = 228},
  [7423] = {.lex_state = 48, .external_lex_state = 81},
  [7424] = {.lex_state = 48, .external_lex_state = 79},
  [7425] = {.lex_state = 48, .external_lex_state = 79},
  [7426] = {.lex_state = 48, .external_lex_state = 80},
  [7427] = {.lex_state = 48, .external_lex_state = 80},
  [7428] = {.lex_state = 48, .external_lex_state = 81},
  [7429] = {.lex_state = 48, .external_lex_state = 81},
  [7430] = {.lex_state = 48, .external_lex_state = 78},
  [7431] = {.lex_state = 50, .external_lex_state = 229},
  [7432] = {.lex_state = 48, .external_lex_state = 81},
  [7433] = {.lex_state = 48, .external_lex_state = 81},
  [7434] = {.lex_state = 48, .external_lex_state = 80},
  [7435] = {.lex_state = 48, .external_lex_state = 82},
  [7436] = {.lex_state = 48, .external_lex_state = 81},
  [7437] = {.lex_state = 48, .external_lex_state = 81},
  [7438] = {.lex_state = 48, .external_lex_state = 82},
  [7439] = {.lex_state = 48, .external_lex_state = 13},
  [7440] = {.lex_state = 48, .external_lex_state = 78},
  [7441] = {.lex_state = 48, .external_lex_state = 79},
  [7442] = {.lex_state = 48, .external_lex_state = 81},
  [7443] = {.lex_state = 48, .external_lex_state = 83},
  [7444] = {.lex_state = 48, .external_lex_state = 83},
  [7445] = {.lex_state = 48, .external_lex_state = 83},
  [7446] = {.lex_state = 48, .external_lex_state = 82},
  [7447] = {.lex_state = 48, .external_lex_state = 83},
  [7448] = {.lex_state = 48, .external_lex_state = 83},
  [7449] = {.lex_state = 48, .external_lex_state = 83},
  [7450] = {.lex_state = 48, .external_lex_state = 83},
  [7451] = {.lex_state = 48, .external_lex_state = 81},
  [7452] = {.lex_state = 48, .external_lex_state = 13},
  [7453] = {.lex_state = 48, .external_lex_state = 81},
  [7454] = {.lex_state = 48, .external_lex_state = 228},
  [7455] = {.lex_state = 48, .external_lex_state = 79},
  [7456] = {.lex_state = 48, .external_lex_state = 78},
  [7457] = {.lex_state = 48, .external_lex_state = 82},
  [7458] = {.lex_state = 48, .external_lex_state = 82},
  [7459] = {.lex_state = 48, .external_lex_state = 82},
  [7460] = {.lex_state = 48, .external_lex_state = 82},
  [7461] = {.lex_state = 48, .external_lex_state = 81},
  [7462] = {.lex_state = 48, .external_lex_state = 13},
  [7463] = {.lex_state = 48, .external_lex_state = 79},
  [7464] = {.lex_state = 48, .external_lex_state = 83},
  [7465] = {.lex_state = 48, .external_lex_state = 83},
  [7466] = {.lex_state = 48, .external_lex_state = 83},
  [7467] = {.lex_state = 48, .external_lex_state = 80},
  [7468] = {.lex_state = 48, .external_lex_state = 13},
  [7469] = {.lex_state = 48, .external_lex_state = 79},
  [7470] = {.lex_state = 48, .external_lex_state = 79},
  [7471] = {.lex_state = 48, .external_lex_state = 227},
  [7472] = {.lex_state = 48, .external_lex_state = 82},
  [7473] = {.lex_state = 47, .external_lex_state = 121},
  [7474] = {.lex_state = 48, .external_lex_state = 83},
  [7475] = {.lex_state = 48, .external_lex_state = 81},
  [7476] = {.lex_state = 48, .external_lex_state = 13},
  [7477] = {.lex_state = 48, .external_lex_state = 81},
  [7478] = {.lex_state = 48, .external_lex_state = 78},
  [7479] = {.lex_state = 50, .external_lex_state = 230},
  [7480] = {.lex_state = 48, .external_lex_state = 82},
  [7481] = {.lex_state = 48, .external_lex_state = 81},
  [7482] = {.lex_state = 48, .external_lex_state = 13},
  [7483] = {.lex_state = 48, .external_lex_state = 13},
  [7484] = {.lex_state = 48, .external_lex_state = 81},
  [7485] = {.lex_state = 48, .external_lex_state = 81},
  [7486] = {.lex_state = 48, .external_lex_state = 78},
  [7487] = {.lex_state = 50, .external_lex_state = 231},
  [7488] = {.lex_state = 48, .external_lex_state = 13},
  [7489] = {.lex_state = 48, .external_lex_state = 13},
  [7490] = {.lex_state = 48, .external_lex_state = 82},
  [7491] = {.lex_state = 48, .external_lex_state = 80},
  [7492] = {.lex_state = 48, .external_lex_state = 83},
  [7493] = {.lex_state = 48, .external_lex_state = 79},
  [7494] = {.lex_state = 48, .external_lex_state = 13},
  [7495] = {.lex_state = 48, .external_lex_state = 80},
  [7496] = {.lex_state = 48, .external_lex_state = 13},
  [7497] = {.lex_state = 48, .external_lex_state = 78},
  [7498] = {.lex_state = 48, .external_lex_state = 78},
  [7499] = {.lex_state = 48, .external_lex_state = 81},
  [7500] = {.lex_state = 48, .external_lex_state = 13},
  [7501] = {.lex_state = 48, .external_lex_state = 78},
  [7502] = {.lex_state = 48, .external_lex_state = 13},
  [7503] = {.lex_state = 48, .external_lex_state = 81},
  [7504] = {.lex_state = 48, .external_lex_state = 80},
  [7505] = {.lex_state = 48, .external_lex_state = 80},
  [7506] = {.lex_state = 47, .external_lex_state = 121},
  [7507] = {.lex_state = 48, .external_lex_state = 81},
  [7508] = {.lex_state = 48, .external_lex_state = 80},
  [7509] = {.lex_state = 48, .external_lex_state = 82},
  [7510] = {.lex_state = 48, .external_lex_state = 78},
  [7511] = {.lex_state = 50, .external_lex_state = 232},
  [7512] = {.lex_state = 48, .external_lex_state = 81},
  [7513] = {.lex_state = 48, .external_lex_state = 82},
  [7514] = {.lex_state = 48, .external_lex_state = 82},
  [7515] = {.lex_state = 48, .external_lex_state = 79},
  [7516] = {.lex_state = 48, .external_lex_state = 82},
  [7517] = {.lex_state = 48, .external_lex_state = 13},
  [7518] = {.lex_state = 48, .external_lex_state = 79},
  [7519] = {.lex_state = 48, .external_lex_state = 83},
  [7520] = {.lex_state = 48, .external_lex_state = 78},
  [7521] = {.lex_state = 48, .external_lex_state = 78},
  [7522] = {.lex_state = 48, .external_lex_state = 79},
  [7523] = {.lex_state = 48, .external_lex_state = 81},
  [7524] = {.lex_state = 48, .external_lex_state = 81},
  [7525] = {.lex_state = 48, .external_lex_state = 78},
  [7526] = {.lex_state = 48, .external_lex_state = 228},
  [7527] = {.lex_state = 48, .external_lex_state = 82},
  [7528] = {.lex_state = 48, .external_lex_state = 13},
  [7529] = {.lex_state = 48, .external_lex_state = 79},
  [7530] = {.lex_state = 48, .external_lex_state = 79},
  [7531] = {.lex_state = 48, .external_lex_state = 82},
  [7532] = {.lex_state = 48, .external_lex_state = 80},
  [7533] = {.lex_state = 48, .external_lex_state = 82},
  [7534] = {.lex_state = 48, .external_lex_state = 82},
  [7535] = {.lex_state = 48, .external_lex_state = 227},
  [7536] = {.lex_state = 48, .external_lex_state = 82},
  [7537] = {.lex_state = 50, .external_lex_state = 233},
  [7538] = {.lex_state = 47, .external_lex_state = 121},
  [7539] = {.lex_state = 48, .external_lex_state = 13},
  [7540] = {.lex_state = 48, .external_lex_state = 82},
  [7541] = {.lex_state = 48, .external_lex_state = 83},
  [7542] = {.lex_state = 48, .external_lex_state = 81},
  [7543] = {.lex_state = 48, .external_lex_state = 79},
  [7544] = {.lex_state = 48, .external_lex_state = 81},
  [7545] = {.lex_state = 48, .external_lex_state = 79},
  [7546] = {.lex_state = 48, .external_lex_state = 81},
  [7547] = {.lex_state = 48, .external_lex_state = 13},
  [7548] = {.lex_state = 48, .external_lex_state = 13},
  [7549] = {.lex_state = 48, .external_lex_state = 13},
  [7550] = {.lex_state = 48, .external_lex_state = 82},
  [7551] = {.lex_state = 48, .external_lex_state = 13},
  [7552] = {.lex_state = 48, .external_lex_state = 82},
  [7553] = {.lex_state = 48, .external_lex_state = 79},
  [7554] = {.lex_state = 48, .external_lex_state = 78},
  [7555] = {.lex_state = 48, .external_lex_state = 79},
  [7556] = {.lex_state = 48, .external_lex_state = 78},
  [7557] = {.lex_state = 48, .external_lex_state = 13},
  [7558] = {.lex_state = 48, .external_lex_state = 78},
  [7559] = {.lex_state = 48, .external_lex_state = 83},
  [7560] = {.lex_state = 48, .external_lex_state = 78},
  [7561] = {.lex_state = 50, .external_lex_state = 234},
  [7562] = {.lex_state = 48, .external_lex_state = 78},
  [7563] = {.lex_state = 48, .external_lex_state = 79},
  [7564] = {.lex_state = 48, .external_lex_state = 80},
  [7565] = {.lex_state = 48, .external_lex_state = 81},
  [7566] = {.lex_state = 47, .external_lex_state = 121},
  [7567] = {.lex_state = 48, .external_lex_state = 228},
  [7568] = {.lex_state = 48, .external_lex_state = 82},
  [7569] = {.lex_state = 48, .external_lex_state = 78},
  [7570] = {.lex_state = 48, .external_lex_state = 79},
  [7571] = {.lex_state = 48, .external_lex_state = 79},
  [7572] = {.lex_state = 48, .external_lex_state = 78},
  [7573] = {.lex_state = 48, .external_lex_state = 80},
  [7574] = {.lex_state = 48, .external_lex_state = 227},
  [7575] = {.lex_state = 48, .external_lex_state = 80},
  [7576] = {.lex_state = 48, .external_lex_state = 82},
  [7577] = {.lex_state = 48, .external_lex_state = 13},
  [7578] = {.lex_state = 48, .external_lex_state = 79},
  [7579] = {.lex_state = 48, .external_lex_state = 13},
  [7580] = {.lex_state = 48, .external_lex_state = 79},
  [7581] = {.lex_state = 48, .external_lex_state = 79},
  [7582] = {.lex_state = 48, .external_lex_state = 80},
  [7583] = {.lex_state = 48, .external_lex_state = 81},
  [7584] = {.lex_state = 48, .external_lex_state = 79},
  [7585] = {.lex_state = 48, .external_lex_state = 80},
  [7586] = {.lex_state = 48, .external_lex_state = 79},
  [7587] = {.lex_state = 48, .external_lex_state = 13},
  [7588] = {.lex_state = 48, .external_lex_state = 82},
  [7589] = {.lex_state = 48, .external_lex_state = 79},
  [7590] = {.lex_state = 48, .external_lex_state = 80},
  [7591] = {.lex_state = 48, .external_lex_state = 79},
  [7592] = {.lex_state = 48, .external_lex_state = 13},
  [7593] = {.lex_state = 48, .external_lex_state = 79},
  [7594] = {.lex_state = 48, .external_lex_state = 13},
  [7595] = {.lex_state = 48, .external_lex_state = 82},
  [7596] = {.lex_state = 48, .external_lex_state = 235},
  [7597] = {.lex_state = 50, .external_lex_state = 236},
  [7598] = {.lex_state = 48, .external_lex_state = 85},
  [7599] = {.lex_state = 48, .external_lex_state = 86},
  [7600] = {.lex_state = 48, .external_lex_state = 86},
  [7601] = {.lex_state = 47, .external_lex_state = 84},
  [7602] = {.lex_state = 48, .external_lex_state = 86},
  [7603] = {.lex_state = 48, .external_lex_state = 86},
  [7604] = {.lex_state = 48, .external_lex_state = 86},
  [7605] = {.lex_state = 48, .external_lex_state = 86},
  [7606] = {.lex_state = 48, .external_lex_state = 86},
  [7607] = {.lex_state = 48, .external_lex_state = 86},
  [7608] = {.lex_state = 48, .external_lex_state = 86},
  [7609] = {.lex_state = 48, .external_lex_state = 86},
  [7610] = {.lex_state = 48, .external_lex_state = 235},
  [7611] = {.lex_state = 48, .external_lex_state = 85},
  [7612] = {.lex_state = 48, .external_lex_state = 86},
  [7613] = {.lex_state = 48, .external_lex_state = 85},
  [7614] = {.lex_state = 47, .external_lex_state = 237},
  [7615] = {.lex_state = 47, .external_lex_state = 237},
  [7616] = {.lex_state = 48, .external_lex_state = 85},
  [7617] = {.lex_state = 48, .external_lex_state = 86},
  [7618] = {.lex_state = 50, .external_lex_state = 238},
  [7619] = {.lex_state = 48, .external_lex_state = 239},
  [7620] = {.lex_state = 48, .external_lex_state = 239},
  [7621] = {.lex_state = 50, .external_lex_state = 240},
  [7622] = {.lex_state = 48, .external_lex_state = 86},
  [7623] = {.lex_state = 48, .external_lex_state = 85},
  [7624] = {.lex_state = 48, .external_lex_state = 86},
  [7625] = {.lex_state = 47, .external_lex_state = 237},
  [7626] = {.lex_state = 48, .external_lex_state = 86},
  [7627] = {.lex_state = 48, .external_lex_state = 85},
  [7628] = {.lex_state = 48, .external_lex_state = 235},
  [7629] = {.lex_state = 48, .external_lex_state = 85},
  [7630] = {.lex_state = 48, .external_lex_state = 86},
  [7631] = {.lex_state = 48, .external_lex_state = 86},
  [7632] = {.lex_state = 48, .external_lex_state = 235},
  [7633] = {.lex_state = 48, .external_lex_state = 239},
  [7634] = {.lex_state = 48, .external_lex_state = 86},
  [7635] = {.lex_state = 48, .external_lex_state = 86},
  [7636] = {.lex_state = 48, .external_lex_state = 86},
  [7637] = {.lex_state = 48, .external_lex_state = 86},
  [7638] = {.lex_state = 48, .external_lex_state = 86},
  [7639] = {.lex_state = 48, .external_lex_state = 86},
  [7640] = {.lex_state = 48, .external_lex_state = 86},
  [7641] = {.lex_state = 48, .external_lex_state = 86},
  [7642] = {.lex_state = 48, .external_lex_state = 86},
  [7643] = {.lex_state = 48, .external_lex_state = 86},
  [7644] = {.lex_state = 48, .external_lex_state = 86},
  [7645] = {.lex_state = 48, .external_lex_state = 86},
  [7646] = {.lex_state = 50, .external_lex_state = 241},
  [7647] = {.lex_state = 48, .external_lex_state = 86},
  [7648] = {.lex_state = 48, .external_lex_state = 239},
  [7649] = {.lex_state = 48, .external_lex_state = 86},
  [7650] = {.lex_state = 48, .external_lex_state = 85},
  [7651] = {.lex_state = 50, .external_lex_state = 242},
  [7652] = {.lex_state = 48, .external_lex_state = 85},
  [7653] = {.lex_state = 48, .external_lex_state = 85},
  [7654] = {.lex_state = 48, .external_lex_state = 85},
  [7655] = {.lex_state = 47, .external_lex_state = 237},
  [7656] = {.lex_state = 48, .external_lex_state = 86},
  [7657] = {.lex_state = 48, .external_lex_state = 239},
  [7658] = {.lex_state = 48, .external_lex_state = 85},
  [7659] = {.lex_state = 48, .external_lex_state = 85},
  [7660] = {.lex_state = 48, .external_lex_state = 85},
  [7661] = {.lex_state = 47, .external_lex_state = 237},
  [7662] = {.lex_state = 47, .external_lex_state = 243},
  [7663] = {.lex_state = 47, .external_lex_state = 237},
  [7664] = {.lex_state = 48, .external_lex_state = 85},
  [7665] = {.lex_state = 48, .external_lex_state = 86},
  [7666] = {.lex_state = 48, .external_lex_state = 85},
  [7667] = {.lex_state = 48, .external_lex_state = 235},
  [7668] = {.lex_state = 48, .external_lex_state = 86},
  [7669] = {.lex_state = 48, .external_lex_state = 85},
  [7670] = {.lex_state = 48, .external_lex_state = 85},
  [7671] = {.lex_state = 50, .external_lex_state = 244},
  [7672] = {.lex_state = 50, .external_lex_state = 245},
  [7673] = {.lex_state = 48, .external_lex_state = 85},
  [7674] = {.lex_state = 48, .external_lex_state = 85},
  [7675] = {.lex_state = 48, .external_lex_state = 85},
  [7676] = {.lex_state = 48, .external_lex_state = 85},
  [7677] = {.lex_state = 48, .external_lex_state = 85},
  [7678] = {.lex_state = 48, .external_lex_state = 85},
  [7679] = {.lex_state = 48, .external_lex_state = 85},
  [7680] = {.lex_state = 48, .external_lex_state = 85},
  [7681] = {.lex_state = 48, .external_lex_state = 235},
  [7682] = {.lex_state = 48, .external_lex_state = 85},
  [7683] = {.lex_state = 48, .external_lex_state = 85},
  [7684] = {.lex_state = 48, .external_lex_state = 239},
  [7685] = {.lex_state = 48, .external_lex_state = 85},
  [7686] = {.lex_state = 48, .external_lex_state = 85},
  [7687] = {.lex_state = 48, .external_lex_state = 85},
  [7688] = {.lex_state = 48, .external_lex_state = 85},
  [7689] = {.lex_state = 48, .external_lex_state = 85},
  [7690] = {.lex_state = 50, .external_lex_state = 246},
  [7691] = {.lex_state = 48, .external_lex_state = 85},
  [7692] = {.lex_state = 48, .external_lex_state = 86},
  [7693] = {.lex_state = 48, .external_lex_state = 85},
  [7694] = {.lex_state = 50, .external_lex_state = 247},
  [7695] = {.lex_state = 48, .external_lex_state = 86},
  [7696] = {.lex_state = 48, .external_lex_state = 85},
  [7697] = {.lex_state = 48, .external_lex_state = 88},
  [7698] = {.lex_state = 47, .external_lex_state = 36},
  [7699] = {.lex_state = 47, .external_lex_state = 36},
  [7700] = {.lex_state = 47, .external_lex_state = 36},
  [7701] = {.lex_state = 47, .external_lex_state = 36},
  [7702] = {.lex_state = 47, .external_lex_state = 36},
  [7703] = {.lex_state = 47, .external_lex_state = 36},
  [7704] = {.lex_state = 48, .external_lex_state = 87},
  [7705] = {.lex_state = 48, .external_lex_state = 87},
  [7706] = {.lex_state = 48, .external_lex_state = 87},
  [7707] = {.lex_state = 47, .external_lex_state = 36},
  [7708] = {.lex_state = 47, .external_lex_state = 36},
  [7709] = {.lex_state = 48, .external_lex_state = 87},
  [7710] = {.lex_state = 47, .external_lex_state = 36},
  [7711] = {.lex_state = 47, .external_lex_state = 36},
  [7712] = {.lex_state = 47, .external_lex_state = 36},
  [7713] = {.lex_state = 48, .external_lex_state = 87},
  [7714] = {.lex_state = 50, .external_lex_state = 248},
  [7715] = {.lex_state = 47, .external_lex_state = 36},
  [7716] = {.lex_state = 48, .external_lex_state = 87},
  [7717] = {.lex_state = 47, .external_lex_state = 249},
  [7718] = {.lex_state = 48, .external_lex_state = 88},
  [7719] = {.lex_state = 47, .external_lex_state = 36},
  [7720] = {.lex_state = 48, .external_lex_state = 88},
  [7721] = {.lex_state = 48, .external_lex_state = 88},
  [7722] = {.lex_state = 47, .external_lex_state = 36},
  [7723] = {.lex_state = 47, .external_lex_state = 36},
  [7724] = {.lex_state = 47, .external_lex_state = 36},
  [7725] = {.lex_state = 47, .external_lex_state = 36},
  [7726] = {.lex_state = 48, .external_lex_state = 84},
  [7727] = {.lex_state = 47, .external_lex_state = 250},
  [7728] = {.lex_state = 48, .external_lex_state = 75},
  [7729] = {.lex_state = 48, .external_lex_state = 87},
  [7730] = {.lex_state = 48, .external_lex_state = 87},
  [7731] = {.lex_state = 48, .external_lex_state = 87},
  [7732] = {.lex_state = 48, .external_lex_state = 87},
  [7733] = {.lex_state = 47, .external_lex_state = 36},
  [7734] = {.lex_state = 47, .external_lex_state = 36},
  [7735] = {.lex_state = 47, .external_lex_state = 36},
  [7736] = {.lex_state = 47, .external_lex_state = 36},
  [7737] = {.lex_state = 48, .external_lex_state = 88},
  [7738] = {.lex_state = 48, .external_lex_state = 88},
  [7739] = {.lex_state = 48, .external_lex_state = 88},
  [7740] = {.lex_state = 48, .external_lex_state = 88},
  [7741] = {.lex_state = 47, .external_lex_state = 36},
  [7742] = {.lex_state = 47, .external_lex_state = 36},
  [7743] = {.lex_state = 48, .external_lex_state = 87},
  [7744] = {.lex_state = 48, .external_lex_state = 87},
  [7745] = {.lex_state = 48, .external_lex_state = 87},
  [7746] = {.lex_state = 48, .external_lex_state = 87},
  [7747] = {.lex_state = 47, .external_lex_state = 36},
  [7748] = {.lex_state = 48, .external_lex_state = 87},
  [7749] = {.lex_state = 48, .external_lex_state = 88},
  [7750] = {.lex_state = 48, .external_lex_state = 87},
  [7751] = {.lex_state = 48, .external_lex_state = 88},
  [7752] = {.lex_state = 48, .external_lex_state = 88},
  [7753] = {.lex_state = 48, .external_lex_state = 87},
  [7754] = {.lex_state = 47, .external_lex_state = 36},
  [7755] = {.lex_state = 48, .external_lex_state = 87},
  [7756] = {.lex_state = 47, .external_lex_state = 36},
  [7757] = {.lex_state = 47, .external_lex_state = 36},
  [7758] = {.lex_state = 47, .external_lex_state = 36},
  [7759] = {.lex_state = 47, .external_lex_state = 36},
  [7760] = {.lex_state = 47, .external_lex_state = 36},
  [7761] = {.lex_state = 48, .external_lex_state = 87},
  [7762] = {.lex_state = 48, .external_lex_state = 87},
  [7763] = {.lex_state = 48, .external_lex_state = 87},
  [7764] = {.lex_state = 48, .external_lex_state = 87},
  [7765] = {.lex_state = 47, .external_lex_state = 36},
  [7766] = {.lex_state = 47, .external_lex_state = 36},
  [7767] = {.lex_state = 48, .external_lex_state = 87},
  [7768] = {.lex_state = 48, .external_lex_state = 88},
  [7769] = {.lex_state = 47, .external_lex_state = 36},
  [7770] = {.lex_state = 47, .external_lex_state = 36},
  [7771] = {.lex_state = 47, .external_lex_state = 36},
  [7772] = {.lex_state = 50, .external_lex_state = 251},
  [7773] = {.lex_state = 48, .external_lex_state = 88},
  [7774] = {.lex_state = 48, .external_lex_state = 87},
  [7775] = {.lex_state = 47, .external_lex_state = 36},
  [7776] = {.lex_state = 48, .external_lex_state = 88},
  [7777] = {.lex_state = 48, .external_lex_state = 87},
  [7778] = {.lex_state = 48, .external_lex_state = 87},
  [7779] = {.lex_state = 47, .external_lex_state = 36},
  [7780] = {.lex_state = 47, .external_lex_state = 84},
  [7781] = {.lex_state = 50, .external_lex_state = 252},
  [7782] = {.lex_state = 47, .external_lex_state = 36},
  [7783] = {.lex_state = 48, .external_lex_state = 88},
  [7784] = {.lex_state = 47, .external_lex_state = 36},
  [7785] = {.lex_state = 47, .external_lex_state = 90},
  [7786] = {.lex_state = 47, .external_lex_state = 84},
  [7787] = {.lex_state = 48, .external_lex_state = 88},
  [7788] = {.lex_state = 47, .external_lex_state = 36},
  [7789] = {.lex_state = 47, .external_lex_state = 36},
  [7790] = {.lex_state = 47, .external_lex_state = 36},
  [7791] = {.lex_state = 47, .external_lex_state = 36},
  [7792] = {.lex_state = 47, .external_lex_state = 36},
  [7793] = {.lex_state = 48, .external_lex_state = 87},
  [7794] = {.lex_state = 47, .external_lex_state = 36},
  [7795] = {.lex_state = 47, .external_lex_state = 36},
  [7796] = {.lex_state = 48, .external_lex_state = 88},
  [7797] = {.lex_state = 47, .external_lex_state = 36},
  [7798] = {.lex_state = 47, .external_lex_state = 36},
  [7799] = {.lex_state = 47, .external_lex_state = 36},
  [7800] = {.lex_state = 47, .external_lex_state = 36},
  [7801] = {.lex_state = 47, .external_lex_state = 36},
  [7802] = {.lex_state = 48, .external_lex_state = 88},
  [7803] = {.lex_state = 47, .external_lex_state = 249},
  [7804] = {.lex_state = 47, .external_lex_state = 36},
  [7805] = {.lex_state = 47, .external_lex_state = 36},
  [7806] = {.lex_state = 47, .external_lex_state = 36},
  [7807] = {.lex_state = 50, .external_lex_state = 253},
  [7808] = {.lex_state = 48, .external_lex_state = 88},
  [7809] = {.lex_state = 48, .external_lex_state = 254},
  [7810] = {.lex_state = 47, .external_lex_state = 36},
  [7811] = {.lex_state = 47, .external_lex_state = 36},
  [7812] = {.lex_state = 47, .external_lex_state = 89},
  [7813] = {.lex_state = 47, .external_lex_state = 36},
  [7814] = {.lex_state = 48, .external_lex_state = 88},
  [7815] = {.lex_state = 48, .external_lex_state = 87},
  [7816] = {.lex_state = 47, .external_lex_state = 36},
  [7817] = {.lex_state = 47, .external_lex_state = 36},
  [7818] = {.lex_state = 48, .external_lex_state = 88},
  [7819] = {.lex_state = 47, .external_lex_state = 250},
  [7820] = {.lex_state = 47, .external_lex_state = 84},
  [7821] = {.lex_state = 47, .external_lex_state = 36},
  [7822] = {.lex_state = 47, .external_lex_state = 36},
  [7823] = {.lex_state = 48, .external_lex_state = 87},
  [7824] = {.lex_state = 48, .external_lex_state = 87},
  [7825] = {.lex_state = 47, .external_lex_state = 36},
  [7826] = {.lex_state = 47, .external_lex_state = 36},
  [7827] = {.lex_state = 50, .external_lex_state = 255},
  [7828] = {.lex_state = 48, .external_lex_state = 88},
  [7829] = {.lex_state = 47, .external_lex_state = 36},
  [7830] = {.lex_state = 47, .external_lex_state = 36},
  [7831] = {.lex_state = 48, .external_lex_state = 87},
  [7832] = {.lex_state = 48, .external_lex_state = 88},
  [7833] = {.lex_state = 47, .external_lex_state = 36},
  [7834] = {.lex_state = 47, .external_lex_state = 84},
  [7835] = {.lex_state = 48, .external_lex_state = 88},
  [7836] = {.lex_state = 47, .external_lex_state = 250},
  [7837] = {.lex_state = 47, .external_lex_state = 36},
  [7838] = {.lex_state = 47, .external_lex_state = 84},
  [7839] = {.lex_state = 48, .external_lex_state = 87},
  [7840] = {.lex_state = 47, .external_lex_state = 36},
  [7841] = {.lex_state = 47, .external_lex_state = 36},
  [7842] = {.lex_state = 47, .external_lex_state = 36},
  [7843] = {.lex_state = 47, .external_lex_state = 36},
  [7844] = {.lex_state = 48, .external_lex_state = 87},
  [7845] = {.lex_state = 47, .external_lex_state = 36},
  [7846] = {.lex_state = 47, .external_lex_state = 84},
  [7847] = {.lex_state = 47, .external_lex_state = 36},
  [7848] = {.lex_state = 48, .external_lex_state = 88},
  [7849] = {.lex_state = 48, .external_lex_state = 84},
  [7850] = {.lex_state = 48, .external_lex_state = 88},
  [7851] = {.lex_state = 48, .external_lex_state = 87},
  [7852] = {.lex_state = 47, .external_lex_state = 36},
  [7853] = {.lex_state = 48, .external_lex_state = 88},
  [7854] = {.lex_state = 48, .external_lex_state = 88},
  [7855] = {.lex_state = 47, .external_lex_state = 36},
  [7856] = {.lex_state = 48, .external_lex_state = 88},
  [7857] = {.lex_state = 47, .external_lex_state = 36},
  [7858] = {.lex_state = 47, .external_lex_state = 36},
  [7859] = {.lex_state = 47, .external_lex_state = 36},
  [7860] = {.lex_state = 48, .external_lex_state = 88},
  [7861] = {.lex_state = 48, .external_lex_state = 88},
  [7862] = {.lex_state = 47, .external_lex_state = 36},
  [7863] = {.lex_state = 48, .external_lex_state = 88},
  [7864] = {.lex_state = 48, .external_lex_state = 256},
  [7865] = {.lex_state = 48, .external_lex_state = 256},
  [7866] = {.lex_state = 48, .external_lex_state = 88},
  [7867] = {.lex_state = 48, .external_lex_state = 256},
  [7868] = {.lex_state = 48, .external_lex_state = 88},
  [7869] = {.lex_state = 48, .external_lex_state = 87},
  [7870] = {.lex_state = 47, .external_lex_state = 36},
  [7871] = {.lex_state = 47, .external_lex_state = 36},
  [7872] = {.lex_state = 48, .external_lex_state = 88},
  [7873] = {.lex_state = 48, .external_lex_state = 88},
  [7874] = {.lex_state = 48, .external_lex_state = 87},
  [7875] = {.lex_state = 47, .external_lex_state = 84},
  [7876] = {.lex_state = 48, .external_lex_state = 257},
  [7877] = {.lex_state = 47, .external_lex_state = 84},
  [7878] = {.lex_state = 47, .external_lex_state = 84},
  [7879] = {.lex_state = 48, .external_lex_state = 89},
  [7880] = {.lex_state = 47, .external_lex_state = 84},
  [7881] = {.lex_state = 47, .external_lex_state = 84},
  [7882] = {.lex_state = 48, .external_lex_state = 89},
  [7883] = {.lex_state = 47, .external_lex_state = 84},
  [7884] = {.lex_state = 47, .external_lex_state = 84},
  [7885] = {.lex_state = 48, .external_lex_state = 98},
  [7886] = {.lex_state = 48, .external_lex_state = 258},
  [7887] = {.lex_state = 47, .external_lex_state = 84},
  [7888] = {.lex_state = 48, .external_lex_state = 98},
  [7889] = {.lex_state = 47, .external_lex_state = 259},
  [7890] = {.lex_state = 47, .external_lex_state = 84},
  [7891] = {.lex_state = 47, .external_lex_state = 90},
  [7892] = {.lex_state = 47, .external_lex_state = 84},
  [7893] = {.lex_state = 48, .external_lex_state = 260},
  [7894] = {.lex_state = 47, .external_lex_state = 84},
  [7895] = {.lex_state = 50, .external_lex_state = 261},
  [7896] = {.lex_state = 47, .external_lex_state = 89},
  [7897] = {.lex_state = 47, .external_lex_state = 84},
  [7898] = {.lex_state = 47, .external_lex_state = 36},
  [7899] = {.lex_state = 47, .external_lex_state = 84},
  [7900] = {.lex_state = 47, .external_lex_state = 84},
  [7901] = {.lex_state = 47, .external_lex_state = 84},
  [7902] = {.lex_state = 47, .external_lex_state = 84},
  [7903] = {.lex_state = 47, .external_lex_state = 84},
  [7904] = {.lex_state = 47, .external_lex_state = 84},
  [7905] = {.lex_state = 48, .external_lex_state = 258},
  [7906] = {.lex_state = 48, .external_lex_state = 260},
  [7907] = {.lex_state = 48, .external_lex_state = 260},
  [7908] = {.lex_state = 50, .external_lex_state = 262},
  [7909] = {.lex_state = 47, .external_lex_state = 84},
  [7910] = {.lex_state = 48, .external_lex_state = 260},
  [7911] = {.lex_state = 48, .external_lex_state = 90},
  [7912] = {.lex_state = 47, .external_lex_state = 84},
  [7913] = {.lex_state = 47, .external_lex_state = 84},
  [7914] = {.lex_state = 47, .external_lex_state = 84},
  [7915] = {.lex_state = 48, .external_lex_state = 260},
  [7916] = {.lex_state = 48, .external_lex_state = 254},
  [7917] = {.lex_state = 47, .external_lex_state = 84},
  [7918] = {.lex_state = 47, .external_lex_state = 84},
  [7919] = {.lex_state = 48, .external_lex_state = 260},
  [7920] = {.lex_state = 47, .external_lex_state = 89},
  [7921] = {.lex_state = 48, .external_lex_state = 98},
  [7922] = {.lex_state = 48, .external_lex_state = 90},
  [7923] = {.lex_state = 47, .external_lex_state = 89},
  [7924] = {.lex_state = 47, .external_lex_state = 84},
  [7925] = {.lex_state = 47, .external_lex_state = 84},
  [7926] = {.lex_state = 47, .external_lex_state = 84},
  [7927] = {.lex_state = 47, .external_lex_state = 84},
  [7928] = {.lex_state = 48, .external_lex_state = 258},
  [7929] = {.lex_state = 47, .external_lex_state = 84},
  [7930] = {.lex_state = 47, .external_lex_state = 93},
  [7931] = {.lex_state = 48, .external_lex_state = 258},
  [7932] = {.lex_state = 47, .external_lex_state = 84},
  [7933] = {.lex_state = 47, .external_lex_state = 84},
  [7934] = {.lex_state = 47, .external_lex_state = 84},
  [7935] = {.lex_state = 47, .external_lex_state = 259},
  [7936] = {.lex_state = 48, .external_lex_state = 112},
  [7937] = {.lex_state = 48, .external_lex_state = 258},
  [7938] = {.lex_state = 47, .external_lex_state = 259},
  [7939] = {.lex_state = 48, .external_lex_state = 258},
  [7940] = {.lex_state = 50, .external_lex_state = 263},
  [7941] = {.lex_state = 47, .external_lex_state = 84},
  [7942] = {.lex_state = 48, .external_lex_state = 39},
  [7943] = {.lex_state = 47, .external_lex_state = 101},
  [7944] = {.lex_state = 47, .external_lex_state = 90},
  [7945] = {.lex_state = 47, .external_lex_state = 90},
  [7946] = {.lex_state = 47, .external_lex_state = 90},
  [7947] = {.lex_state = 47, .external_lex_state = 90},
  [7948] = {.lex_state = 47, .external_lex_state = 90},
  [7949] = {.lex_state = 48, .external_lex_state = 98},
  [7950] = {.lex_state = 47, .external_lex_state = 90},
  [7951] = {.lex_state = 48, .external_lex_state = 36},
  [7952] = {.lex_state = 48, .external_lex_state = 98},
  [7953] = {.lex_state = 47, .external_lex_state = 90},
  [7954] = {.lex_state = 47, .external_lex_state = 90},
  [7955] = {.lex_state = 47, .external_lex_state = 90},
  [7956] = {.lex_state = 48, .external_lex_state = 94},
  [7957] = {.lex_state = 47, .external_lex_state = 264},
  [7958] = {.lex_state = 47, .external_lex_state = 90},
  [7959] = {.lex_state = 47, .external_lex_state = 90},
  [7960] = {.lex_state = 47, .external_lex_state = 89},
  [7961] = {.lex_state = 48, .external_lex_state = 94},
  [7962] = {.lex_state = 47, .external_lex_state = 90},
  [7963] = {.lex_state = 47, .external_lex_state = 90},
  [7964] = {.lex_state = 47, .external_lex_state = 265},
  [7965] = {.lex_state = 47, .external_lex_state = 90},
  [7966] = {.lex_state = 47, .external_lex_state = 90},
  [7967] = {.lex_state = 48, .external_lex_state = 94},
  [7968] = {.lex_state = 50, .external_lex_state = 266},
  [7969] = {.lex_state = 48, .external_lex_state = 94},
  [7970] = {.lex_state = 48, .external_lex_state = 94},
  [7971] = {.lex_state = 47, .external_lex_state = 89},
  [7972] = {.lex_state = 48, .external_lex_state = 98},
  [7973] = {.lex_state = 48, .external_lex_state = 94},
  [7974] = {.lex_state = 48, .external_lex_state = 94},
  [7975] = {.lex_state = 48, .external_lex_state = 94},
  [7976] = {.lex_state = 48, .external_lex_state = 267},
  [7977] = {.lex_state = 48, .external_lex_state = 94},
  [7978] = {.lex_state = 48, .external_lex_state = 98},
  [7979] = {.lex_state = 48, .external_lex_state = 94},
  [7980] = {.lex_state = 48, .external_lex_state = 94},
  [7981] = {.lex_state = 48, .external_lex_state = 94},
  [7982] = {.lex_state = 48, .external_lex_state = 94},
  [7983] = {.lex_state = 48, .external_lex_state = 94},
  [7984] = {.lex_state = 48, .external_lex_state = 94},
  [7985] = {.lex_state = 48, .external_lex_state = 94},
  [7986] = {.lex_state = 48, .external_lex_state = 94},
  [7987] = {.lex_state = 47, .external_lex_state = 265},
  [7988] = {.lex_state = 48, .external_lex_state = 94},
  [7989] = {.lex_state = 48, .external_lex_state = 94},
  [7990] = {.lex_state = 48, .external_lex_state = 94},
  [7991] = {.lex_state = 48, .external_lex_state = 94},
  [7992] = {.lex_state = 48, .external_lex_state = 93},
  [7993] = {.lex_state = 47, .external_lex_state = 264},
  [7994] = {.lex_state = 48, .external_lex_state = 94},
  [7995] = {.lex_state = 48, .external_lex_state = 94},
  [7996] = {.lex_state = 48, .external_lex_state = 98},
  [7997] = {.lex_state = 48, .external_lex_state = 94},
  [7998] = {.lex_state = 47, .external_lex_state = 89},
  [7999] = {.lex_state = 48, .external_lex_state = 94},
  [8000] = {.lex_state = 48, .external_lex_state = 98},
  [8001] = {.lex_state = 48, .external_lex_state = 94},
  [8002] = {.lex_state = 48, .external_lex_state = 98},
  [8003] = {.lex_state = 48, .external_lex_state = 94},
  [8004] = {.lex_state = 47, .external_lex_state = 89},
  [8005] = {.lex_state = 47, .external_lex_state = 89},
  [8006] = {.lex_state = 48, .external_lex_state = 94},
  [8007] = {.lex_state = 47, .external_lex_state = 90},
  [8008] = {.lex_state = 47, .external_lex_state = 89},
  [8009] = {.lex_state = 48, .external_lex_state = 94},
  [8010] = {.lex_state = 48, .external_lex_state = 94},
  [8011] = {.lex_state = 47, .external_lex_state = 264},
  [8012] = {.lex_state = 50, .external_lex_state = 268},
  [8013] = {.lex_state = 48, .external_lex_state = 97},
  [8014] = {.lex_state = 47, .external_lex_state = 89},
  [8015] = {.lex_state = 47, .external_lex_state = 89},
  [8016] = {.lex_state = 48, .external_lex_state = 97},
  [8017] = {.lex_state = 47, .external_lex_state = 265},
  [8018] = {.lex_state = 47, .external_lex_state = 269},
  [8019] = {.lex_state = 48, .external_lex_state = 98},
  [8020] = {.lex_state = 48, .external_lex_state = 270},
  [8021] = {.lex_state = 47, .external_lex_state = 89},
  [8022] = {.lex_state = 48, .external_lex_state = 270},
  [8023] = {.lex_state = 47, .external_lex_state = 99},
  [8024] = {.lex_state = 47, .external_lex_state = 89},
  [8025] = {.lex_state = 48, .external_lex_state = 271},
  [8026] = {.lex_state = 48, .external_lex_state = 98},
  [8027] = {.lex_state = 48, .external_lex_state = 98},
  [8028] = {.lex_state = 48, .external_lex_state = 98},
  [8029] = {.lex_state = 48, .external_lex_state = 97},
  [8030] = {.lex_state = 48, .external_lex_state = 97},
  [8031] = {.lex_state = 48, .external_lex_state = 271},
  [8032] = {.lex_state = 47, .external_lex_state = 89},
  [8033] = {.lex_state = 47, .external_lex_state = 89},
  [8034] = {.lex_state = 47, .external_lex_state = 89},
  [8035] = {.lex_state = 47, .external_lex_state = 89},
  [8036] = {.lex_state = 47, .external_lex_state = 89},
  [8037] = {.lex_state = 47, .external_lex_state = 89},
  [8038] = {.lex_state = 47, .external_lex_state = 89},
  [8039] = {.lex_state = 48, .external_lex_state = 98},
  [8040] = {.lex_state = 47, .external_lex_state = 89},
  [8041] = {.lex_state = 47, .external_lex_state = 272},
  [8042] = {.lex_state = 47, .external_lex_state = 89},
  [8043] = {.lex_state = 50, .external_lex_state = 273},
  [8044] = {.lex_state = 47, .external_lex_state = 89},
  [8045] = {.lex_state = 48, .external_lex_state = 97},
  [8046] = {.lex_state = 47, .external_lex_state = 274},
  [8047] = {.lex_state = 48, .external_lex_state = 97},
  [8048] = {.lex_state = 47, .external_lex_state = 89},
  [8049] = {.lex_state = 48, .external_lex_state = 98},
  [8050] = {.lex_state = 47, .external_lex_state = 96},
  [8051] = {.lex_state = 48, .external_lex_state = 94},
  [8052] = {.lex_state = 47, .external_lex_state = 93},
  [8053] = {.lex_state = 48, .external_lex_state = 94},
  [8054] = {.lex_state = 47, .external_lex_state = 93},
  [8055] = {.lex_state = 48, .external_lex_state = 257},
  [8056] = {.lex_state = 48, .external_lex_state = 275},
  [8057] = {.lex_state = 47, .external_lex_state = 90},
  [8058] = {.lex_state = 47, .external_lex_state = 90},
  [8059] = {.lex_state = 48, .external_lex_state = 275},
  [8060] = {.lex_state = 48, .external_lex_state = 97},
  [8061] = {.lex_state = 47, .external_lex_state = 272},
  [8062] = {.lex_state = 48, .external_lex_state = 270},
  [8063] = {.lex_state = 48, .external_lex_state = 97},
  [8064] = {.lex_state = 48, .external_lex_state = 97},
  [8065] = {.lex_state = 48, .external_lex_state = 97},
  [8066] = {.lex_state = 48, .external_lex_state = 97},
  [8067] = {.lex_state = 47, .external_lex_state = 90},
  [8068] = {.lex_state = 47, .external_lex_state = 90},
  [8069] = {.lex_state = 48, .external_lex_state = 93},
  [8070] = {.lex_state = 47, .external_lex_state = 93},
  [8071] = {.lex_state = 48, .external_lex_state = 271},
  [8072] = {.lex_state = 47, .external_lex_state = 89},
  [8073] = {.lex_state = 48, .external_lex_state = 94},
  [8074] = {.lex_state = 48, .external_lex_state = 270},
  [8075] = {.lex_state = 48, .external_lex_state = 270},
  [8076] = {.lex_state = 48, .external_lex_state = 97},
  [8077] = {.lex_state = 47, .external_lex_state = 90},
  [8078] = {.lex_state = 47, .external_lex_state = 90},
  [8079] = {.lex_state = 48, .external_lex_state = 275},
  [8080] = {.lex_state = 48, .external_lex_state = 97},
  [8081] = {.lex_state = 48, .external_lex_state = 270},
  [8082] = {.lex_state = 48, .external_lex_state = 97},
  [8083] = {.lex_state = 48, .external_lex_state = 97},
  [8084] = {.lex_state = 48, .external_lex_state = 97},
  [8085] = {.lex_state = 48, .external_lex_state = 97},
  [8086] = {.lex_state = 47, .external_lex_state = 90},
  [8087] = {.lex_state = 48, .external_lex_state = 97},
  [8088] = {.lex_state = 47, .external_lex_state = 89},
  [8089] = {.lex_state = 47, .external_lex_state = 90},
  [8090] = {.lex_state = 47, .external_lex_state = 90},
  [8091] = {.lex_state = 48, .external_lex_state = 97},
  [8092] = {.lex_state = 47, .external_lex_state = 90},
  [8093] = {.lex_state = 48, .external_lex_state = 97},
  [8094] = {.lex_state = 48, .external_lex_state = 97},
  [8095] = {.lex_state = 48, .external_lex_state = 97},
  [8096] = {.lex_state = 47, .external_lex_state = 274},
  [8097] = {.lex_state = 48, .external_lex_state = 267},
  [8098] = {.lex_state = 48, .external_lex_state = 97},
  [8099] = {.lex_state = 47, .external_lex_state = 90},
  [8100] = {.lex_state = 48, .external_lex_state = 98},
  [8101] = {.lex_state = 47, .external_lex_state = 100},
  [8102] = {.lex_state = 48, .external_lex_state = 97},
  [8103] = {.lex_state = 48, .external_lex_state = 97},
  [8104] = {.lex_state = 47, .external_lex_state = 90},
  [8105] = {.lex_state = 48, .external_lex_state = 271},
  [8106] = {.lex_state = 47, .external_lex_state = 89},
  [8107] = {.lex_state = 48, .external_lex_state = 267},
  [8108] = {.lex_state = 47, .external_lex_state = 90},
  [8109] = {.lex_state = 50, .external_lex_state = 276},
  [8110] = {.lex_state = 47, .external_lex_state = 274},
  [8111] = {.lex_state = 48, .external_lex_state = 97},
  [8112] = {.lex_state = 47, .external_lex_state = 95},
  [8113] = {.lex_state = 50, .external_lex_state = 277},
  [8114] = {.lex_state = 47, .external_lex_state = 90},
  [8115] = {.lex_state = 47, .external_lex_state = 90},
  [8116] = {.lex_state = 47, .external_lex_state = 278},
  [8117] = {.lex_state = 47, .external_lex_state = 278},
  [8118] = {.lex_state = 50, .external_lex_state = 279},
  [8119] = {.lex_state = 48, .external_lex_state = 39},
  [8120] = {.lex_state = 48, .external_lex_state = 97},
  [8121] = {.lex_state = 48, .external_lex_state = 97},
  [8122] = {.lex_state = 48, .external_lex_state = 97},
  [8123] = {.lex_state = 47, .external_lex_state = 89},
  [8124] = {.lex_state = 48, .external_lex_state = 97},
  [8125] = {.lex_state = 48, .external_lex_state = 97},
  [8126] = {.lex_state = 48, .external_lex_state = 97},
  [8127] = {.lex_state = 48, .external_lex_state = 97},
  [8128] = {.lex_state = 48, .external_lex_state = 97},
  [8129] = {.lex_state = 48, .external_lex_state = 97},
  [8130] = {.lex_state = 48, .external_lex_state = 267},
  [8131] = {.lex_state = 47, .external_lex_state = 89},
  [8132] = {.lex_state = 47, .external_lex_state = 89},
  [8133] = {.lex_state = 48, .external_lex_state = 275},
  [8134] = {.lex_state = 48, .external_lex_state = 275},
  [8135] = {.lex_state = 47, .external_lex_state = 89},
  [8136] = {.lex_state = 47, .external_lex_state = 272},
  [8137] = {.lex_state = 48, .external_lex_state = 271},
  [8138] = {.lex_state = 47, .external_lex_state = 278},
  [8139] = {.lex_state = 48, .external_lex_state = 39},
  [8140] = {.lex_state = 47, .external_lex_state = 89},
  [8141] = {.lex_state = 48, .external_lex_state = 267},
  [8142] = {.lex_state = 48, .external_lex_state = 94},
  [8143] = {.lex_state = 47, .external_lex_state = 90},
  [8144] = {.lex_state = 47, .external_lex_state = 89},
  [8145] = {.lex_state = 48, .external_lex_state = 267},
  [8146] = {.lex_state = 48, .external_lex_state = 275},
  [8147] = {.lex_state = 47, .external_lex_state = 89},
  [8148] = {.lex_state = 48, .external_lex_state = 94},
  [8149] = {.lex_state = 47, .external_lex_state = 90},
  [8150] = {.lex_state = 47, .external_lex_state = 89},
  [8151] = {.lex_state = 47, .external_lex_state = 89},
  [8152] = {.lex_state = 48, .external_lex_state = 271},
  [8153] = {.lex_state = 48, .external_lex_state = 103},
  [8154] = {.lex_state = 48, .external_lex_state = 102},
  [8155] = {.lex_state = 48, .external_lex_state = 280},
  [8156] = {.lex_state = 48, .external_lex_state = 91},
  [8157] = {.lex_state = 48, .external_lex_state = 96},
  [8158] = {.lex_state = 48, .external_lex_state = 91},
  [8159] = {.lex_state = 48, .external_lex_state = 92},
  [8160] = {.lex_state = 48, .external_lex_state = 92},
  [8161] = {.lex_state = 48, .external_lex_state = 92},
  [8162] = {.lex_state = 48, .external_lex_state = 92},
  [8163] = {.lex_state = 48, .external_lex_state = 280},
  [8164] = {.lex_state = 48, .external_lex_state = 92},
  [8165] = {.lex_state = 47, .external_lex_state = 93},
  [8166] = {.lex_state = 47, .external_lex_state = 93},
  [8167] = {.lex_state = 47, .external_lex_state = 93},
  [8168] = {.lex_state = 48, .external_lex_state = 92},
  [8169] = {.lex_state = 47, .external_lex_state = 93},
  [8170] = {.lex_state = 48, .external_lex_state = 92},
  [8171] = {.lex_state = 48, .external_lex_state = 92},
  [8172] = {.lex_state = 47, .external_lex_state = 93},
  [8173] = {.lex_state = 47, .external_lex_state = 93},
  [8174] = {.lex_state = 47, .external_lex_state = 99},
  [8175] = {.lex_state = 47, .external_lex_state = 93},
  [8176] = {.lex_state = 47, .external_lex_state = 93},
  [8177] = {.lex_state = 47, .external_lex_state = 93},
  [8178] = {.lex_state = 48, .external_lex_state = 96},
  [8179] = {.lex_state = 48, .external_lex_state = 92},
  [8180] = {.lex_state = 47, .external_lex_state = 93},
  [8181] = {.lex_state = 48, .external_lex_state = 101},
  [8182] = {.lex_state = 47, .external_lex_state = 101},
  [8183] = {.lex_state = 47, .external_lex_state = 93},
  [8184] = {.lex_state = 48, .external_lex_state = 103},
  [8185] = {.lex_state = 48, .external_lex_state = 103},
  [8186] = {.lex_state = 47, .external_lex_state = 93},
  [8187] = {.lex_state = 48, .external_lex_state = 101},
  [8188] = {.lex_state = 48, .external_lex_state = 102},
  [8189] = {.lex_state = 48, .external_lex_state = 102},
  [8190] = {.lex_state = 48, .external_lex_state = 102},
  [8191] = {.lex_state = 48, .external_lex_state = 280},
  [8192] = {.lex_state = 48, .external_lex_state = 103},
  [8193] = {.lex_state = 48, .external_lex_state = 102},
  [8194] = {.lex_state = 47, .external_lex_state = 93},
  [8195] = {.lex_state = 47, .external_lex_state = 93},
  [8196] = {.lex_state = 48, .external_lex_state = 103},
  [8197] = {.lex_state = 48, .external_lex_state = 280},
  [8198] = {.lex_state = 48, .external_lex_state = 91},
  [8199] = {.lex_state = 48, .external_lex_state = 103},
  [8200] = {.lex_state = 47, .external_lex_state = 93},
  [8201] = {.lex_state = 48, .external_lex_state = 91},
  [8202] = {.lex_state = 47, .external_lex_state = 93},
  [8203] = {.lex_state = 48, .external_lex_state = 39},
  [8204] = {.lex_state = 48, .external_lex_state = 102},
  [8205] = {.lex_state = 48, .external_lex_state = 91},
  [8206] = {.lex_state = 47, .external_lex_state = 106},
  [8207] = {.lex_state = 47, .external_lex_state = 93},
  [8208] = {.lex_state = 48, .external_lex_state = 102},
  [8209] = {.lex_state = 48, .external_lex_state = 103},
  [8210] = {.lex_state = 48, .external_lex_state = 280},
  [8211] = {.lex_state = 0, .external_lex_state = 281},
  [8212] = {.lex_state = 48, .external_lex_state = 91},
  [8213] = {.lex_state = 48, .external_lex_state = 39},
  [8214] = {.lex_state = 48, .external_lex_state = 102},
  [8215] = {.lex_state = 48, .external_lex_state = 91},
  [8216] = {.lex_state = 47, .external_lex_state = 93},
  [8217] = {.lex_state = 48, .external_lex_state = 91},
  [8218] = {.lex_state = 48, .external_lex_state = 91},
  [8219] = {.lex_state = 48, .external_lex_state = 102},
  [8220] = {.lex_state = 47, .external_lex_state = 282},
  [8221] = {.lex_state = 48, .external_lex_state = 92},
  [8222] = {.lex_state = 47, .external_lex_state = 93},
  [8223] = {.lex_state = 48, .external_lex_state = 91},
  [8224] = {.lex_state = 48, .external_lex_state = 92},
  [8225] = {.lex_state = 47, .external_lex_state = 99},
  [8226] = {.lex_state = 48, .external_lex_state = 95},
  [8227] = {.lex_state = 48, .external_lex_state = 102},
  [8228] = {.lex_state = 47, .external_lex_state = 99},
  [8229] = {.lex_state = 47, .external_lex_state = 93},
  [8230] = {.lex_state = 48, .external_lex_state = 102},
  [8231] = {.lex_state = 48, .external_lex_state = 283},
  [8232] = {.lex_state = 47, .external_lex_state = 284},
  [8233] = {.lex_state = 47, .external_lex_state = 100},
  [8234] = {.lex_state = 47, .external_lex_state = 93},
  [8235] = {.lex_state = 48, .external_lex_state = 283},
  [8236] = {.lex_state = 48, .external_lex_state = 92},
  [8237] = {.lex_state = 48, .external_lex_state = 92},
  [8238] = {.lex_state = 50, .external_lex_state = 285},
  [8239] = {.lex_state = 50, .external_lex_state = 286},
  [8240] = {.lex_state = 48, .external_lex_state = 287},
  [8241] = {.lex_state = 48, .external_lex_state = 283},
  [8242] = {.lex_state = 48, .external_lex_state = 92},
  [8243] = {.lex_state = 48, .external_lex_state = 103},
  [8244] = {.lex_state = 48, .external_lex_state = 103},
  [8245] = {.lex_state = 47, .external_lex_state = 93},
  [8246] = {.lex_state = 48, .external_lex_state = 103},
  [8247] = {.lex_state = 48, .external_lex_state = 91},
  [8248] = {.lex_state = 48, .external_lex_state = 102},
  [8249] = {.lex_state = 48, .external_lex_state = 103},
  [8250] = {.lex_state = 48, .external_lex_state = 103},
  [8251] = {.lex_state = 48, .external_lex_state = 103},
  [8252] = {.lex_state = 48, .external_lex_state = 103},
  [8253] = {.lex_state = 48, .external_lex_state = 103},
  [8254] = {.lex_state = 47, .external_lex_state = 100},
  [8255] = {.lex_state = 48, .external_lex_state = 103},
  [8256] = {.lex_state = 48, .external_lex_state = 102},
  [8257] = {.lex_state = 48, .external_lex_state = 91},
  [8258] = {.lex_state = 48, .external_lex_state = 91},
  [8259] = {.lex_state = 48, .external_lex_state = 103},
  [8260] = {.lex_state = 48, .external_lex_state = 103},
  [8261] = {.lex_state = 50, .external_lex_state = 288},
  [8262] = {.lex_state = 48, .external_lex_state = 92},
  [8263] = {.lex_state = 48, .external_lex_state = 103},
  [8264] = {.lex_state = 48, .external_lex_state = 102},
  [8265] = {.lex_state = 47, .external_lex_state = 101},
  [8266] = {.lex_state = 48, .external_lex_state = 91},
  [8267] = {.lex_state = 47, .external_lex_state = 282},
  [8268] = {.lex_state = 48, .external_lex_state = 91},
  [8269] = {.lex_state = 48, .external_lex_state = 92},
  [8270] = {.lex_state = 48, .external_lex_state = 103},
  [8271] = {.lex_state = 47, .external_lex_state = 101},
  [8272] = {.lex_state = 47, .external_lex_state = 93},
  [8273] = {.lex_state = 47, .external_lex_state = 93},
  [8274] = {.lex_state = 48, .external_lex_state = 102},
  [8275] = {.lex_state = 48, .external_lex_state = 102},
  [8276] = {.lex_state = 48, .external_lex_state = 91},
  [8277] = {.lex_state = 48, .external_lex_state = 95},
  [8278] = {.lex_state = 48, .external_lex_state = 103},
  [8279] = {.lex_state = 48, .external_lex_state = 92},
  [8280] = {.lex_state = 47, .external_lex_state = 96},
  [8281] = {.lex_state = 48, .external_lex_state = 102},
  [8282] = {.lex_state = 47, .external_lex_state = 284},
  [8283] = {.lex_state = 48, .external_lex_state = 102},
  [8284] = {.lex_state = 48, .external_lex_state = 91},
  [8285] = {.lex_state = 47, .external_lex_state = 289},
  [8286] = {.lex_state = 48, .external_lex_state = 92},
  [8287] = {.lex_state = 47, .external_lex_state = 104},
  [8288] = {.lex_state = 47, .external_lex_state = 96},
  [8289] = {.lex_state = 47, .external_lex_state = 93},
  [8290] = {.lex_state = 48, .external_lex_state = 280},
  [8291] = {.lex_state = 48, .external_lex_state = 103},
  [8292] = {.lex_state = 48, .external_lex_state = 91},
  [8293] = {.lex_state = 48, .external_lex_state = 92},
  [8294] = {.lex_state = 47, .external_lex_state = 96},
  [8295] = {.lex_state = 48, .external_lex_state = 102},
  [8296] = {.lex_state = 48, .external_lex_state = 102},
  [8297] = {.lex_state = 48, .external_lex_state = 103},
  [8298] = {.lex_state = 47, .external_lex_state = 282},
  [8299] = {.lex_state = 48, .external_lex_state = 91},
  [8300] = {.lex_state = 50, .external_lex_state = 290},
  [8301] = {.lex_state = 47, .external_lex_state = 105},
  [8302] = {.lex_state = 48, .external_lex_state = 102},
  [8303] = {.lex_state = 48, .external_lex_state = 100},
  [8304] = {.lex_state = 48, .external_lex_state = 92},
  [8305] = {.lex_state = 48, .external_lex_state = 99},
  [8306] = {.lex_state = 48, .external_lex_state = 99},
  [8307] = {.lex_state = 47, .external_lex_state = 95},
  [8308] = {.lex_state = 47, .external_lex_state = 93},
  [8309] = {.lex_state = 48, .external_lex_state = 91},
  [8310] = {.lex_state = 50, .external_lex_state = 291},
  [8311] = {.lex_state = 48, .external_lex_state = 102},
  [8312] = {.lex_state = 51, .external_lex_state = 292},
  [8313] = {.lex_state = 48, .external_lex_state = 103},
  [8314] = {.lex_state = 50, .external_lex_state = 293},
  [8315] = {.lex_state = 48, .external_lex_state = 102},
  [8316] = {.lex_state = 48, .external_lex_state = 102},
  [8317] = {.lex_state = 48, .external_lex_state = 283},
  [8318] = {.lex_state = 48, .external_lex_state = 287},
  [8319] = {.lex_state = 47, .external_lex_state = 93},
  [8320] = {.lex_state = 48, .external_lex_state = 103},
  [8321] = {.lex_state = 48, .external_lex_state = 103},
  [8322] = {.lex_state = 48, .external_lex_state = 103},
  [8323] = {.lex_state = 48, .external_lex_state = 103},
  [8324] = {.lex_state = 48, .external_lex_state = 100},
  [8325] = {.lex_state = 48, .external_lex_state = 103},
  [8326] = {.lex_state = 48, .external_lex_state = 102},
  [8327] = {.lex_state = 51, .external_lex_state = 292},
  [8328] = {.lex_state = 47, .external_lex_state = 93},
  [8329] = {.lex_state = 47, .external_lex_state = 95},
  [8330] = {.lex_state = 48, .external_lex_state = 287},
  [8331] = {.lex_state = 48, .external_lex_state = 103},
  [8332] = {.lex_state = 47, .external_lex_state = 93},
  [8333] = {.lex_state = 48, .external_lex_state = 103},
  [8334] = {.lex_state = 47, .external_lex_state = 93},
  [8335] = {.lex_state = 47, .external_lex_state = 289},
  [8336] = {.lex_state = 48, .external_lex_state = 103},
  [8337] = {.lex_state = 48, .external_lex_state = 103},
  [8338] = {.lex_state = 48, .external_lex_state = 102},
  [8339] = {.lex_state = 47, .external_lex_state = 93},
  [8340] = {.lex_state = 48, .external_lex_state = 256},
  [8341] = {.lex_state = 48, .external_lex_state = 102},
  [8342] = {.lex_state = 48, .external_lex_state = 102},
  [8343] = {.lex_state = 48, .external_lex_state = 287},
  [8344] = {.lex_state = 48, .external_lex_state = 287},
  [8345] = {.lex_state = 48, .external_lex_state = 102},
  [8346] = {.lex_state = 47, .external_lex_state = 284},
  [8347] = {.lex_state = 48, .external_lex_state = 92},
  [8348] = {.lex_state = 48, .external_lex_state = 92},
  [8349] = {.lex_state = 48, .external_lex_state = 91},
  [8350] = {.lex_state = 48, .external_lex_state = 102},
  [8351] = {.lex_state = 48, .external_lex_state = 91},
  [8352] = {.lex_state = 48, .external_lex_state = 102},
  [8353] = {.lex_state = 48, .external_lex_state = 92},
  [8354] = {.lex_state = 48, .external_lex_state = 103},
  [8355] = {.lex_state = 48, .external_lex_state = 91},
  [8356] = {.lex_state = 48, .external_lex_state = 103},
  [8357] = {.lex_state = 47, .external_lex_state = 289},
  [8358] = {.lex_state = 48, .external_lex_state = 283},
  [8359] = {.lex_state = 48, .external_lex_state = 102},
  [8360] = {.lex_state = 48, .external_lex_state = 91},
  [8361] = {.lex_state = 47, .external_lex_state = 93},
  [8362] = {.lex_state = 48, .external_lex_state = 287},
  [8363] = {.lex_state = 48, .external_lex_state = 91},
  [8364] = {.lex_state = 47, .external_lex_state = 93},
  [8365] = {.lex_state = 48, .external_lex_state = 102},
  [8366] = {.lex_state = 48, .external_lex_state = 92},
  [8367] = {.lex_state = 48, .external_lex_state = 91},
  [8368] = {.lex_state = 48, .external_lex_state = 102},
  [8369] = {.lex_state = 48, .external_lex_state = 91},
  [8370] = {.lex_state = 48, .external_lex_state = 91},
  [8371] = {.lex_state = 48, .external_lex_state = 91},
  [8372] = {.lex_state = 48, .external_lex_state = 91},
  [8373] = {.lex_state = 48, .external_lex_state = 91},
  [8374] = {.lex_state = 48, .external_lex_state = 91},
  [8375] = {.lex_state = 48, .external_lex_state = 91},
  [8376] = {.lex_state = 48, .external_lex_state = 92},
  [8377] = {.lex_state = 48, .external_lex_state = 92},
  [8378] = {.lex_state = 48, .external_lex_state = 92},
  [8379] = {.lex_state = 48, .external_lex_state = 91},
  [8380] = {.lex_state = 48, .external_lex_state = 91},
  [8381] = {.lex_state = 48, .external_lex_state = 91},
  [8382] = {.lex_state = 48, .external_lex_state = 92},
  [8383] = {.lex_state = 47, .external_lex_state = 95},
  [8384] = {.lex_state = 48, .external_lex_state = 92},
  [8385] = {.lex_state = 48, .external_lex_state = 92},
  [8386] = {.lex_state = 47, .external_lex_state = 100},
  [8387] = {.lex_state = 48, .external_lex_state = 92},
  [8388] = {.lex_state = 48, .external_lex_state = 92},
  [8389] = {.lex_state = 48, .external_lex_state = 92},
  [8390] = {.lex_state = 48, .external_lex_state = 92},
  [8391] = {.lex_state = 48, .external_lex_state = 91},
  [8392] = {.lex_state = 48, .external_lex_state = 92},
  [8393] = {.lex_state = 48, .external_lex_state = 92},
  [8394] = {.lex_state = 48, .external_lex_state = 92},
  [8395] = {.lex_state = 48, .external_lex_state = 102},
  [8396] = {.lex_state = 48, .external_lex_state = 256},
  [8397] = {.lex_state = 48, .external_lex_state = 283},
  [8398] = {.lex_state = 48, .external_lex_state = 256},
  [8399] = {.lex_state = 50, .external_lex_state = 294},
  [8400] = {.lex_state = 48, .external_lex_state = 98},
  [8401] = {.lex_state = 47, .external_lex_state = 101},
  [8402] = {.lex_state = 48, .external_lex_state = 108},
  [8403] = {.lex_state = 48, .external_lex_state = 108},
  [8404] = {.lex_state = 48, .external_lex_state = 98},
  [8405] = {.lex_state = 47, .external_lex_state = 95},
  [8406] = {.lex_state = 47, .external_lex_state = 100},
  [8407] = {.lex_state = 48, .external_lex_state = 108},
  [8408] = {.lex_state = 47, .external_lex_state = 95},
  [8409] = {.lex_state = 48, .external_lex_state = 108},
  [8410] = {.lex_state = 48, .external_lex_state = 108},
  [8411] = {.lex_state = 48, .external_lex_state = 108},
  [8412] = {.lex_state = 47, .external_lex_state = 100},
  [8413] = {.lex_state = 48, .external_lex_state = 98},
  [8414] = {.lex_state = 47, .external_lex_state = 100},
  [8415] = {.lex_state = 48, .external_lex_state = 98},
  [8416] = {.lex_state = 48, .external_lex_state = 108},
  [8417] = {.lex_state = 48, .external_lex_state = 98},
  [8418] = {.lex_state = 48, .external_lex_state = 98},
  [8419] = {.lex_state = 48, .external_lex_state = 107},
  [8420] = {.lex_state = 48, .external_lex_state = 108},
  [8421] = {.lex_state = 47, .external_lex_state = 100},
  [8422] = {.lex_state = 48, .external_lex_state = 108},
  [8423] = {.lex_state = 48, .external_lex_state = 98},
  [8424] = {.lex_state = 48, .external_lex_state = 107},
  [8425] = {.lex_state = 47, .external_lex_state = 100},
  [8426] = {.lex_state = 48, .external_lex_state = 108},
  [8427] = {.lex_state = 48, .external_lex_state = 295},
  [8428] = {.lex_state = 48, .external_lex_state = 108},
  [8429] = {.lex_state = 47, .external_lex_state = 95},
  [8430] = {.lex_state = 47, .external_lex_state = 100},
  [8431] = {.lex_state = 48, .external_lex_state = 108},
  [8432] = {.lex_state = 47, .external_lex_state = 95},
  [8433] = {.lex_state = 48, .external_lex_state = 98},
  [8434] = {.lex_state = 47, .external_lex_state = 96},
  [8435] = {.lex_state = 48, .external_lex_state = 296},
  [8436] = {.lex_state = 48, .external_lex_state = 107},
  [8437] = {.lex_state = 48, .external_lex_state = 107},
  [8438] = {.lex_state = 48, .external_lex_state = 107},
  [8439] = {.lex_state = 48, .external_lex_state = 107},
  [8440] = {.lex_state = 48, .external_lex_state = 107},
  [8441] = {.lex_state = 48, .external_lex_state = 98},
  [8442] = {.lex_state = 47, .external_lex_state = 95},
  [8443] = {.lex_state = 48, .external_lex_state = 98},
  [8444] = {.lex_state = 48, .external_lex_state = 98},
  [8445] = {.lex_state = 48, .external_lex_state = 98},
  [8446] = {.lex_state = 48, .external_lex_state = 98},
  [8447] = {.lex_state = 48, .external_lex_state = 107},
  [8448] = {.lex_state = 47, .external_lex_state = 99},
  [8449] = {.lex_state = 48, .external_lex_state = 107},
  [8450] = {.lex_state = 47, .external_lex_state = 101},
  [8451] = {.lex_state = 47, .external_lex_state = 100},
  [8452] = {.lex_state = 47, .external_lex_state = 101},
  [8453] = {.lex_state = 48, .external_lex_state = 109},
  [8454] = {.lex_state = 48, .external_lex_state = 98},
  [8455] = {.lex_state = 48, .external_lex_state = 98},
  [8456] = {.lex_state = 48, .external_lex_state = 98},
  [8457] = {.lex_state = 48, .external_lex_state = 108},
  [8458] = {.lex_state = 48, .external_lex_state = 108},
  [8459] = {.lex_state = 48, .external_lex_state = 107},
  [8460] = {.lex_state = 48, .external_lex_state = 107},
  [8461] = {.lex_state = 48, .external_lex_state = 107},
  [8462] = {.lex_state = 47, .external_lex_state = 100},
  [8463] = {.lex_state = 47, .external_lex_state = 95},
  [8464] = {.lex_state = 48, .external_lex_state = 108},
  [8465] = {.lex_state = 47, .external_lex_state = 95},
  [8466] = {.lex_state = 47, .external_lex_state = 95},
  [8467] = {.lex_state = 48, .external_lex_state = 108},
  [8468] = {.lex_state = 47, .external_lex_state = 95},
  [8469] = {.lex_state = 47, .external_lex_state = 100},
  [8470] = {.lex_state = 47, .external_lex_state = 100},
  [8471] = {.lex_state = 48, .external_lex_state = 107},
  [8472] = {.lex_state = 48, .external_lex_state = 108},
  [8473] = {.lex_state = 48, .external_lex_state = 108},
  [8474] = {.lex_state = 48, .external_lex_state = 108},
  [8475] = {.lex_state = 47, .external_lex_state = 100},
  [8476] = {.lex_state = 48, .external_lex_state = 108},
  [8477] = {.lex_state = 48, .external_lex_state = 108},
  [8478] = {.lex_state = 47, .external_lex_state = 100},
  [8479] = {.lex_state = 47, .external_lex_state = 95},
  [8480] = {.lex_state = 47, .external_lex_state = 95},
  [8481] = {.lex_state = 47, .external_lex_state = 95},
  [8482] = {.lex_state = 47, .external_lex_state = 95},
  [8483] = {.lex_state = 48, .external_lex_state = 108},
  [8484] = {.lex_state = 47, .external_lex_state = 99},
  [8485] = {.lex_state = 47, .external_lex_state = 99},
  [8486] = {.lex_state = 47, .external_lex_state = 95},
  [8487] = {.lex_state = 47, .external_lex_state = 100},
  [8488] = {.lex_state = 47, .external_lex_state = 95},
  [8489] = {.lex_state = 47, .external_lex_state = 101},
  [8490] = {.lex_state = 47, .external_lex_state = 101},
  [8491] = {.lex_state = 48, .external_lex_state = 107},
  [8492] = {.lex_state = 48, .external_lex_state = 107},
  [8493] = {.lex_state = 47, .external_lex_state = 100},
  [8494] = {.lex_state = 48, .external_lex_state = 295},
  [8495] = {.lex_state = 48, .external_lex_state = 257},
  [8496] = {.lex_state = 47, .external_lex_state = 100},
  [8497] = {.lex_state = 47, .external_lex_state = 101},
  [8498] = {.lex_state = 47, .external_lex_state = 100},
  [8499] = {.lex_state = 48, .external_lex_state = 107},
  [8500] = {.lex_state = 47, .external_lex_state = 95},
  [8501] = {.lex_state = 47, .external_lex_state = 95},
  [8502] = {.lex_state = 47, .external_lex_state = 99},
  [8503] = {.lex_state = 47, .external_lex_state = 104},
  [8504] = {.lex_state = 47, .external_lex_state = 101},
  [8505] = {.lex_state = 47, .external_lex_state = 101},
  [8506] = {.lex_state = 47, .external_lex_state = 101},
  [8507] = {.lex_state = 47, .external_lex_state = 99},
  [8508] = {.lex_state = 47, .external_lex_state = 95},
  [8509] = {.lex_state = 47, .external_lex_state = 99},
  [8510] = {.lex_state = 48, .external_lex_state = 296},
  [8511] = {.lex_state = 47, .external_lex_state = 101},
  [8512] = {.lex_state = 47, .external_lex_state = 101},
  [8513] = {.lex_state = 47, .external_lex_state = 101},
  [8514] = {.lex_state = 47, .external_lex_state = 95},
  [8515] = {.lex_state = 48, .external_lex_state = 104},
  [8516] = {.lex_state = 48, .external_lex_state = 295},
  [8517] = {.lex_state = 47, .external_lex_state = 101},
  [8518] = {.lex_state = 47, .external_lex_state = 100},
  [8519] = {.lex_state = 47, .external_lex_state = 95},
  [8520] = {.lex_state = 47, .external_lex_state = 104},
  [8521] = {.lex_state = 48, .external_lex_state = 254},
  [8522] = {.lex_state = 48, .external_lex_state = 98},
  [8523] = {.lex_state = 48, .external_lex_state = 98},
  [8524] = {.lex_state = 48, .external_lex_state = 109},
  [8525] = {.lex_state = 48, .external_lex_state = 108},
  [8526] = {.lex_state = 48, .external_lex_state = 109},
  [8527] = {.lex_state = 47, .external_lex_state = 100},
  [8528] = {.lex_state = 48, .external_lex_state = 109},
  [8529] = {.lex_state = 48, .external_lex_state = 109},
  [8530] = {.lex_state = 48, .external_lex_state = 109},
  [8531] = {.lex_state = 48, .external_lex_state = 108},
  [8532] = {.lex_state = 48, .external_lex_state = 108},
  [8533] = {.lex_state = 47, .external_lex_state = 99},
  [8534] = {.lex_state = 47, .external_lex_state = 101},
  [8535] = {.lex_state = 47, .external_lex_state = 105},
  [8536] = {.lex_state = 47, .external_lex_state = 99},
  [8537] = {.lex_state = 48, .external_lex_state = 108},
  [8538] = {.lex_state = 47, .external_lex_state = 101},
  [8539] = {.lex_state = 48, .external_lex_state = 109},
  [8540] = {.lex_state = 48, .external_lex_state = 109},
  [8541] = {.lex_state = 48, .external_lex_state = 109},
  [8542] = {.lex_state = 48, .external_lex_state = 109},
  [8543] = {.lex_state = 47, .external_lex_state = 101},
  [8544] = {.lex_state = 47, .external_lex_state = 99},
  [8545] = {.lex_state = 47, .external_lex_state = 105},
  [8546] = {.lex_state = 48, .external_lex_state = 254},
  [8547] = {.lex_state = 48, .external_lex_state = 257},
  [8548] = {.lex_state = 47, .external_lex_state = 105},
  [8549] = {.lex_state = 47, .external_lex_state = 106},
  [8550] = {.lex_state = 47, .external_lex_state = 101},
  [8551] = {.lex_state = 48, .external_lex_state = 254},
  [8552] = {.lex_state = 48, .external_lex_state = 107},
  [8553] = {.lex_state = 47, .external_lex_state = 110},
  [8554] = {.lex_state = 48, .external_lex_state = 107},
  [8555] = {.lex_state = 47, .external_lex_state = 101},
  [8556] = {.lex_state = 48, .external_lex_state = 107},
  [8557] = {.lex_state = 47, .external_lex_state = 99},
  [8558] = {.lex_state = 47, .external_lex_state = 101},
  [8559] = {.lex_state = 48, .external_lex_state = 107},
  [8560] = {.lex_state = 47, .external_lex_state = 101},
  [8561] = {.lex_state = 47, .external_lex_state = 96},
  [8562] = {.lex_state = 48, .external_lex_state = 108},
  [8563] = {.lex_state = 47, .external_lex_state = 100},
  [8564] = {.lex_state = 48, .external_lex_state = 107},
  [8565] = {.lex_state = 47, .external_lex_state = 101},
  [8566] = {.lex_state = 48, .external_lex_state = 107},
  [8567] = {.lex_state = 47, .external_lex_state = 101},
  [8568] = {.lex_state = 47, .external_lex_state = 99},
  [8569] = {.lex_state = 47, .external_lex_state = 101},
  [8570] = {.lex_state = 47, .external_lex_state = 99},
  [8571] = {.lex_state = 48, .external_lex_state = 257},
  [8572] = {.lex_state = 48, .external_lex_state = 109},
  [8573] = {.lex_state = 47, .external_lex_state = 101},
  [8574] = {.lex_state = 48, .external_lex_state = 107},
  [8575] = {.lex_state = 50, .external_lex_state = 297},
  [8576] = {.lex_state = 47, .external_lex_state = 101},
  [8577] = {.lex_state = 47, .external_lex_state = 100},
  [8578] = {.lex_state = 48, .external_lex_state = 107},
  [8579] = {.lex_state = 48, .external_lex_state = 257},
  [8580] = {.lex_state = 47, .external_lex_state = 101},
  [8581] = {.lex_state = 48, .external_lex_state = 107},
  [8582] = {.lex_state = 48, .external_lex_state = 107},
  [8583] = {.lex_state = 48, .external_lex_state = 98},
  [8584] = {.lex_state = 47, .external_lex_state = 99},
  [8585] = {.lex_state = 48, .external_lex_state = 98},
  [8586] = {.lex_state = 47, .external_lex_state = 101},
  [8587] = {.lex_state = 47, .external_lex_state = 101},
  [8588] = {.lex_state = 47, .external_lex_state = 101},
  [8589] = {.lex_state = 48, .external_lex_state = 108},
  [8590] = {.lex_state = 48, .external_lex_state = 108},
  [8591] = {.lex_state = 48, .external_lex_state = 107},
  [8592] = {.lex_state = 48, .external_lex_state = 295},
  [8593] = {.lex_state = 47, .external_lex_state = 101},
  [8594] = {.lex_state = 48, .external_lex_state = 107},
  [8595] = {.lex_state = 47, .external_lex_state = 101},
  [8596] = {.lex_state = 47, .external_lex_state = 99},
  [8597] = {.lex_state = 48, .external_lex_state = 106},
  [8598] = {.lex_state = 47, .external_lex_state = 99},
  [8599] = {.lex_state = 47, .external_lex_state = 104},
  [8600] = {.lex_state = 47, .external_lex_state = 101},
  [8601] = {.lex_state = 48, .external_lex_state = 107},
  [8602] = {.lex_state = 48, .external_lex_state = 109},
  [8603] = {.lex_state = 47, .external_lex_state = 95},
  [8604] = {.lex_state = 47, .external_lex_state = 99},
  [8605] = {.lex_state = 48, .external_lex_state = 106},
  [8606] = {.lex_state = 47, .external_lex_state = 96},
  [8607] = {.lex_state = 48, .external_lex_state = 107},
  [8608] = {.lex_state = 47, .external_lex_state = 100},
  [8609] = {.lex_state = 48, .external_lex_state = 105},
  [8610] = {.lex_state = 48, .external_lex_state = 109},
  [8611] = {.lex_state = 47, .external_lex_state = 96},
  [8612] = {.lex_state = 47, .external_lex_state = 298},
  [8613] = {.lex_state = 48, .external_lex_state = 109},
  [8614] = {.lex_state = 48, .external_lex_state = 296},
  [8615] = {.lex_state = 47, .external_lex_state = 95},
  [8616] = {.lex_state = 48, .external_lex_state = 108},
  [8617] = {.lex_state = 47, .external_lex_state = 95},
  [8618] = {.lex_state = 48, .external_lex_state = 107},
  [8619] = {.lex_state = 48, .external_lex_state = 108},
  [8620] = {.lex_state = 47, .external_lex_state = 95},
  [8621] = {.lex_state = 47, .external_lex_state = 106},
  [8622] = {.lex_state = 47, .external_lex_state = 99},
  [8623] = {.lex_state = 47, .external_lex_state = 96},
  [8624] = {.lex_state = 47, .external_lex_state = 99},
  [8625] = {.lex_state = 47, .external_lex_state = 99},
  [8626] = {.lex_state = 48, .external_lex_state = 108},
  [8627] = {.lex_state = 47, .external_lex_state = 96},
  [8628] = {.lex_state = 48, .external_lex_state = 108},
  [8629] = {.lex_state = 48, .external_lex_state = 108},
  [8630] = {.lex_state = 47, .external_lex_state = 96},
  [8631] = {.lex_state = 48, .external_lex_state = 107},
  [8632] = {.lex_state = 47, .external_lex_state = 96},
  [8633] = {.lex_state = 47, .external_lex_state = 99},
  [8634] = {.lex_state = 47, .external_lex_state = 96},
  [8635] = {.lex_state = 47, .external_lex_state = 99},
  [8636] = {.lex_state = 47, .external_lex_state = 106},
  [8637] = {.lex_state = 47, .external_lex_state = 99},
  [8638] = {.lex_state = 47, .external_lex_state = 100},
  [8639] = {.lex_state = 47, .external_lex_state = 99},
  [8640] = {.lex_state = 48, .external_lex_state = 109},
  [8641] = {.lex_state = 47, .external_lex_state = 96},
  [8642] = {.lex_state = 48, .external_lex_state = 109},
  [8643] = {.lex_state = 48, .external_lex_state = 109},
  [8644] = {.lex_state = 47, .external_lex_state = 298},
  [8645] = {.lex_state = 47, .external_lex_state = 101},
  [8646] = {.lex_state = 48, .external_lex_state = 109},
  [8647] = {.lex_state = 48, .external_lex_state = 107},
  [8648] = {.lex_state = 47, .external_lex_state = 96},
  [8649] = {.lex_state = 47, .external_lex_state = 95},
  [8650] = {.lex_state = 47, .external_lex_state = 95},
  [8651] = {.lex_state = 50, .external_lex_state = 299},
  [8652] = {.lex_state = 47, .external_lex_state = 95},
  [8653] = {.lex_state = 47, .external_lex_state = 100},
  [8654] = {.lex_state = 47, .external_lex_state = 96},
  [8655] = {.lex_state = 47, .external_lex_state = 99},
  [8656] = {.lex_state = 47, .external_lex_state = 96},
  [8657] = {.lex_state = 47, .external_lex_state = 95},
  [8658] = {.lex_state = 48, .external_lex_state = 108},
  [8659] = {.lex_state = 48, .external_lex_state = 296},
  [8660] = {.lex_state = 48, .external_lex_state = 109},
  [8661] = {.lex_state = 47, .external_lex_state = 95},
  [8662] = {.lex_state = 47, .external_lex_state = 95},
  [8663] = {.lex_state = 47, .external_lex_state = 100},
  [8664] = {.lex_state = 47, .external_lex_state = 99},
  [8665] = {.lex_state = 47, .external_lex_state = 96},
  [8666] = {.lex_state = 47, .external_lex_state = 95},
  [8667] = {.lex_state = 47, .external_lex_state = 100},
  [8668] = {.lex_state = 48, .external_lex_state = 295},
  [8669] = {.lex_state = 47, .external_lex_state = 96},
  [8670] = {.lex_state = 47, .external_lex_state = 95},
  [8671] = {.lex_state = 47, .external_lex_state = 96},
  [8672] = {.lex_state = 48, .external_lex_state = 109},
  [8673] = {.lex_state = 48, .external_lex_state = 109},
  [8674] = {.lex_state = 48, .external_lex_state = 109},
  [8675] = {.lex_state = 48, .external_lex_state = 109},
  [8676] = {.lex_state = 48, .external_lex_state = 109},
  [8677] = {.lex_state = 48, .external_lex_state = 109},
  [8678] = {.lex_state = 47, .external_lex_state = 96},
  [8679] = {.lex_state = 48, .external_lex_state = 109},
  [8680] = {.lex_state = 47, .external_lex_state = 95},
  [8681] = {.lex_state = 47, .external_lex_state = 99},
  [8682] = {.lex_state = 47, .external_lex_state = 100},
  [8683] = {.lex_state = 48, .external_lex_state = 257},
  [8684] = {.lex_state = 47, .external_lex_state = 99},
  [8685] = {.lex_state = 48, .external_lex_state = 109},
  [8686] = {.lex_state = 48, .external_lex_state = 109},
  [8687] = {.lex_state = 47, .external_lex_state = 100},
  [8688] = {.lex_state = 47, .external_lex_state = 99},
  [8689] = {.lex_state = 48, .external_lex_state = 109},
  [8690] = {.lex_state = 47, .external_lex_state = 100},
  [8691] = {.lex_state = 48, .external_lex_state = 109},
  [8692] = {.lex_state = 47, .external_lex_state = 96},
  [8693] = {.lex_state = 47, .external_lex_state = 100},
  [8694] = {.lex_state = 47, .external_lex_state = 99},
  [8695] = {.lex_state = 47, .external_lex_state = 96},
  [8696] = {.lex_state = 48, .external_lex_state = 104},
  [8697] = {.lex_state = 47, .external_lex_state = 96},
  [8698] = {.lex_state = 47, .external_lex_state = 96},
  [8699] = {.lex_state = 47, .external_lex_state = 99},
  [8700] = {.lex_state = 47, .external_lex_state = 96},
  [8701] = {.lex_state = 48, .external_lex_state = 296},
  [8702] = {.lex_state = 48, .external_lex_state = 107},
  [8703] = {.lex_state = 47, .external_lex_state = 96},
  [8704] = {.lex_state = 47, .external_lex_state = 96},
  [8705] = {.lex_state = 47, .external_lex_state = 99},
  [8706] = {.lex_state = 48, .external_lex_state = 107},
  [8707] = {.lex_state = 47, .external_lex_state = 96},
  [8708] = {.lex_state = 48, .external_lex_state = 254},
  [8709] = {.lex_state = 47, .external_lex_state = 100},
  [8710] = {.lex_state = 48, .external_lex_state = 109},
  [8711] = {.lex_state = 48, .external_lex_state = 109},
  [8712] = {.lex_state = 47, .external_lex_state = 96},
  [8713] = {.lex_state = 47, .external_lex_state = 96},
  [8714] = {.lex_state = 48, .external_lex_state = 295},
  [8715] = {.lex_state = 47, .external_lex_state = 99},
  [8716] = {.lex_state = 48, .external_lex_state = 105},
  [8717] = {.lex_state = 47, .external_lex_state = 96},
  [8718] = {.lex_state = 48, .external_lex_state = 296},
  [8719] = {.lex_state = 48, .external_lex_state = 254},
  [8720] = {.lex_state = 47, .external_lex_state = 99},
  [8721] = {.lex_state = 48, .external_lex_state = 109},
  [8722] = {.lex_state = 47, .external_lex_state = 96},
  [8723] = {.lex_state = 47, .external_lex_state = 96},
  [8724] = {.lex_state = 47, .external_lex_state = 96},
  [8725] = {.lex_state = 47, .external_lex_state = 100},
  [8726] = {.lex_state = 47, .external_lex_state = 96},
  [8727] = {.lex_state = 48, .external_lex_state = 109},
  [8728] = {.lex_state = 47, .external_lex_state = 100},
  [8729] = {.lex_state = 47, .external_lex_state = 100},
  [8730] = {.lex_state = 48, .external_lex_state = 109},
  [8731] = {.lex_state = 47, .external_lex_state = 96},
  [8732] = {.lex_state = 48, .external_lex_state = 114},
  [8733] = {.lex_state = 48, .external_lex_state = 114},
  [8734] = {.lex_state = 47, .external_lex_state = 104},
  [8735] = {.lex_state = 50, .external_lex_state = 300},
  [8736] = {.lex_state = 47, .external_lex_state = 104},
  [8737] = {.lex_state = 47, .external_lex_state = 104},
  [8738] = {.lex_state = 47, .external_lex_state = 104},
  [8739] = {.lex_state = 48, .external_lex_state = 36},
  [8740] = {.lex_state = 47, .external_lex_state = 104},
  [8741] = {.lex_state = 47, .external_lex_state = 104},
  [8742] = {.lex_state = 47, .external_lex_state = 104},
  [8743] = {.lex_state = 47, .external_lex_state = 105},
  [8744] = {.lex_state = 48, .external_lex_state = 36},
  [8745] = {.lex_state = 47, .external_lex_state = 104},
  [8746] = {.lex_state = 48, .external_lex_state = 114},
  [8747] = {.lex_state = 47, .external_lex_state = 104},
  [8748] = {.lex_state = 47, .external_lex_state = 104},
  [8749] = {.lex_state = 48, .external_lex_state = 112},
  [8750] = {.lex_state = 47, .external_lex_state = 105},
  [8751] = {.lex_state = 47, .external_lex_state = 104},
  [8752] = {.lex_state = 48, .external_lex_state = 36},
  [8753] = {.lex_state = 47, .external_lex_state = 105},
  [8754] = {.lex_state = 48, .external_lex_state = 36},
  [8755] = {.lex_state = 48, .external_lex_state = 114},
  [8756] = {.lex_state = 47, .external_lex_state = 104},
  [8757] = {.lex_state = 48, .external_lex_state = 112},
  [8758] = {.lex_state = 48, .external_lex_state = 112},
  [8759] = {.lex_state = 47, .external_lex_state = 301},
  [8760] = {.lex_state = 48, .external_lex_state = 114},
  [8761] = {.lex_state = 48, .external_lex_state = 112},
  [8762] = {.lex_state = 47, .external_lex_state = 106},
  [8763] = {.lex_state = 48, .external_lex_state = 114},
  [8764] = {.lex_state = 48, .external_lex_state = 114},
  [8765] = {.lex_state = 48, .external_lex_state = 112},
  [8766] = {.lex_state = 48, .external_lex_state = 112},
  [8767] = {.lex_state = 47, .external_lex_state = 106},
  [8768] = {.lex_state = 48, .external_lex_state = 36},
  [8769] = {.lex_state = 47, .external_lex_state = 105},
  [8770] = {.lex_state = 47, .external_lex_state = 105},
  [8771] = {.lex_state = 48, .external_lex_state = 36},
  [8772] = {.lex_state = 47, .external_lex_state = 105},
  [8773] = {.lex_state = 48, .external_lex_state = 112},
  [8774] = {.lex_state = 47, .external_lex_state = 302},
  [8775] = {.lex_state = 48, .external_lex_state = 112},
  [8776] = {.lex_state = 47, .external_lex_state = 106},
  [8777] = {.lex_state = 47, .external_lex_state = 106},
  [8778] = {.lex_state = 47, .external_lex_state = 106},
  [8779] = {.lex_state = 48, .external_lex_state = 36},
  [8780] = {.lex_state = 47, .external_lex_state = 301},
  [8781] = {.lex_state = 47, .external_lex_state = 106},
  [8782] = {.lex_state = 47, .external_lex_state = 104},
  [8783] = {.lex_state = 48, .external_lex_state = 112},
  [8784] = {.lex_state = 48, .external_lex_state = 112},
  [8785] = {.lex_state = 47, .external_lex_state = 106},
  [8786] = {.lex_state = 47, .external_lex_state = 303},
  [8787] = {.lex_state = 48, .external_lex_state = 112},
  [8788] = {.lex_state = 48, .external_lex_state = 112},
  [8789] = {.lex_state = 48, .external_lex_state = 112},
  [8790] = {.lex_state = 47, .external_lex_state = 106},
  [8791] = {.lex_state = 48, .external_lex_state = 112},
  [8792] = {.lex_state = 47, .external_lex_state = 106},
  [8793] = {.lex_state = 48, .external_lex_state = 112},
  [8794] = {.lex_state = 48, .external_lex_state = 112},
  [8795] = {.lex_state = 48, .external_lex_state = 112},
  [8796] = {.lex_state = 47, .external_lex_state = 304},
  [8797] = {.lex_state = 47, .external_lex_state = 305},
  [8798] = {.lex_state = 47, .external_lex_state = 106},
  [8799] = {.lex_state = 48, .external_lex_state = 112},
  [8800] = {.lex_state = 48, .external_lex_state = 112},
  [8801] = {.lex_state = 47, .external_lex_state = 105},
  [8802] = {.lex_state = 47, .external_lex_state = 106},
  [8803] = {.lex_state = 48, .external_lex_state = 113},
  [8804] = {.lex_state = 47, .external_lex_state = 105},
  [8805] = {.lex_state = 47, .external_lex_state = 106},
  [8806] = {.lex_state = 47, .external_lex_state = 105},
  [8807] = {.lex_state = 48, .external_lex_state = 36},
  [8808] = {.lex_state = 47, .external_lex_state = 106},
  [8809] = {.lex_state = 48, .external_lex_state = 112},
  [8810] = {.lex_state = 48, .external_lex_state = 112},
  [8811] = {.lex_state = 48, .external_lex_state = 36},
  [8812] = {.lex_state = 47, .external_lex_state = 105},
  [8813] = {.lex_state = 48, .external_lex_state = 113},
  [8814] = {.lex_state = 48, .external_lex_state = 113},
  [8815] = {.lex_state = 47, .external_lex_state = 105},
  [8816] = {.lex_state = 48, .external_lex_state = 113},
  [8817] = {.lex_state = 47, .external_lex_state = 105},
  [8818] = {.lex_state = 47, .external_lex_state = 106},
  [8819] = {.lex_state = 48, .external_lex_state = 114},
  [8820] = {.lex_state = 48, .external_lex_state = 113},
  [8821] = {.lex_state = 48, .external_lex_state = 113},
  [8822] = {.lex_state = 47, .external_lex_state = 104},
  [8823] = {.lex_state = 48, .external_lex_state = 36},
  [8824] = {.lex_state = 48, .external_lex_state = 113},
  [8825] = {.lex_state = 48, .external_lex_state = 112},
  [8826] = {.lex_state = 48, .external_lex_state = 113},
  [8827] = {.lex_state = 48, .external_lex_state = 113},
  [8828] = {.lex_state = 47, .external_lex_state = 106},
  [8829] = {.lex_state = 47, .external_lex_state = 105},
  [8830] = {.lex_state = 48, .external_lex_state = 36},
  [8831] = {.lex_state = 47, .external_lex_state = 105},
  [8832] = {.lex_state = 47, .external_lex_state = 105},
  [8833] = {.lex_state = 48, .external_lex_state = 113},
  [8834] = {.lex_state = 47, .external_lex_state = 106},
  [8835] = {.lex_state = 48, .external_lex_state = 113},
  [8836] = {.lex_state = 48, .external_lex_state = 114},
  [8837] = {.lex_state = 47, .external_lex_state = 105},
  [8838] = {.lex_state = 48, .external_lex_state = 114},
  [8839] = {.lex_state = 47, .external_lex_state = 105},
  [8840] = {.lex_state = 47, .external_lex_state = 105},
  [8841] = {.lex_state = 48, .external_lex_state = 113},
  [8842] = {.lex_state = 47, .external_lex_state = 105},
  [8843] = {.lex_state = 48, .external_lex_state = 36},
  [8844] = {.lex_state = 48, .external_lex_state = 114},
  [8845] = {.lex_state = 48, .external_lex_state = 114},
  [8846] = {.lex_state = 47, .external_lex_state = 105},
  [8847] = {.lex_state = 48, .external_lex_state = 114},
  [8848] = {.lex_state = 47, .external_lex_state = 303},
  [8849] = {.lex_state = 48, .external_lex_state = 36},
  [8850] = {.lex_state = 47, .external_lex_state = 105},
  [8851] = {.lex_state = 48, .external_lex_state = 114},
  [8852] = {.lex_state = 47, .external_lex_state = 105},
  [8853] = {.lex_state = 47, .external_lex_state = 105},
  [8854] = {.lex_state = 47, .external_lex_state = 105},
  [8855] = {.lex_state = 48, .external_lex_state = 36},
  [8856] = {.lex_state = 47, .external_lex_state = 104},
  [8857] = {.lex_state = 47, .external_lex_state = 105},
  [8858] = {.lex_state = 47, .external_lex_state = 105},
  [8859] = {.lex_state = 48, .external_lex_state = 114},
  [8860] = {.lex_state = 47, .external_lex_state = 105},
  [8861] = {.lex_state = 48, .external_lex_state = 112},
  [8862] = {.lex_state = 47, .external_lex_state = 106},
  [8863] = {.lex_state = 48, .external_lex_state = 36},
  [8864] = {.lex_state = 47, .external_lex_state = 105},
  [8865] = {.lex_state = 47, .external_lex_state = 105},
  [8866] = {.lex_state = 47, .external_lex_state = 106},
  [8867] = {.lex_state = 47, .external_lex_state = 106},
  [8868] = {.lex_state = 47, .external_lex_state = 105},
  [8869] = {.lex_state = 48, .external_lex_state = 36},
  [8870] = {.lex_state = 47, .external_lex_state = 106},
  [8871] = {.lex_state = 47, .external_lex_state = 106},
  [8872] = {.lex_state = 48, .external_lex_state = 36},
  [8873] = {.lex_state = 47, .external_lex_state = 106},
  [8874] = {.lex_state = 47, .external_lex_state = 106},
  [8875] = {.lex_state = 48, .external_lex_state = 36},
  [8876] = {.lex_state = 47, .external_lex_state = 106},
  [8877] = {.lex_state = 48, .external_lex_state = 36},
  [8878] = {.lex_state = 50, .external_lex_state = 306},
  [8879] = {.lex_state = 48, .external_lex_state = 36},
  [8880] = {.lex_state = 48, .external_lex_state = 110},
  [8881] = {.lex_state = 48, .external_lex_state = 113},
  [8882] = {.lex_state = 48, .external_lex_state = 114},
  [8883] = {.lex_state = 48, .external_lex_state = 307},
  [8884] = {.lex_state = 48, .external_lex_state = 36},
  [8885] = {.lex_state = 48, .external_lex_state = 114},
  [8886] = {.lex_state = 48, .external_lex_state = 114},
  [8887] = {.lex_state = 48, .external_lex_state = 307},
  [8888] = {.lex_state = 48, .external_lex_state = 36},
  [8889] = {.lex_state = 48, .external_lex_state = 113},
  [8890] = {.lex_state = 48, .external_lex_state = 113},
  [8891] = {.lex_state = 47, .external_lex_state = 104},
  [8892] = {.lex_state = 47, .external_lex_state = 106},
  [8893] = {.lex_state = 48, .external_lex_state = 307},
  [8894] = {.lex_state = 47, .external_lex_state = 106},
  [8895] = {.lex_state = 48, .external_lex_state = 114},
  [8896] = {.lex_state = 48, .external_lex_state = 113},
  [8897] = {.lex_state = 47, .external_lex_state = 105},
  [8898] = {.lex_state = 48, .external_lex_state = 112},
  [8899] = {.lex_state = 48, .external_lex_state = 36},
  [8900] = {.lex_state = 47, .external_lex_state = 106},
  [8901] = {.lex_state = 48, .external_lex_state = 36},
  [8902] = {.lex_state = 48, .external_lex_state = 36},
  [8903] = {.lex_state = 47, .external_lex_state = 106},
  [8904] = {.lex_state = 48, .external_lex_state = 113},
  [8905] = {.lex_state = 47, .external_lex_state = 104},
  [8906] = {.lex_state = 47, .external_lex_state = 104},
  [8907] = {.lex_state = 48, .external_lex_state = 114},
  [8908] = {.lex_state = 48, .external_lex_state = 307},
  [8909] = {.lex_state = 47, .external_lex_state = 106},
  [8910] = {.lex_state = 47, .external_lex_state = 105},
  [8911] = {.lex_state = 47, .external_lex_state = 104},
  [8912] = {.lex_state = 48, .external_lex_state = 36},
  [8913] = {.lex_state = 47, .external_lex_state = 106},
  [8914] = {.lex_state = 47, .external_lex_state = 104},
  [8915] = {.lex_state = 47, .external_lex_state = 110},
  [8916] = {.lex_state = 47, .external_lex_state = 104},
  [8917] = {.lex_state = 48, .external_lex_state = 36},
  [8918] = {.lex_state = 48, .external_lex_state = 114},
  [8919] = {.lex_state = 48, .external_lex_state = 114},
  [8920] = {.lex_state = 47, .external_lex_state = 304},
  [8921] = {.lex_state = 48, .external_lex_state = 113},
  [8922] = {.lex_state = 47, .external_lex_state = 106},
  [8923] = {.lex_state = 48, .external_lex_state = 36},
  [8924] = {.lex_state = 47, .external_lex_state = 104},
  [8925] = {.lex_state = 48, .external_lex_state = 114},
  [8926] = {.lex_state = 47, .external_lex_state = 104},
  [8927] = {.lex_state = 47, .external_lex_state = 305},
  [8928] = {.lex_state = 48, .external_lex_state = 112},
  [8929] = {.lex_state = 48, .external_lex_state = 113},
  [8930] = {.lex_state = 48, .external_lex_state = 113},
  [8931] = {.lex_state = 48, .external_lex_state = 114},
  [8932] = {.lex_state = 48, .external_lex_state = 114},
  [8933] = {.lex_state = 48, .external_lex_state = 36},
  [8934] = {.lex_state = 48, .external_lex_state = 307},
  [8935] = {.lex_state = 48, .external_lex_state = 36},
  [8936] = {.lex_state = 48, .external_lex_state = 36},
  [8937] = {.lex_state = 48, .external_lex_state = 307},
  [8938] = {.lex_state = 48, .external_lex_state = 112},
  [8939] = {.lex_state = 47, .external_lex_state = 302},
  [8940] = {.lex_state = 47, .external_lex_state = 106},
  [8941] = {.lex_state = 48, .external_lex_state = 114},
  [8942] = {.lex_state = 48, .external_lex_state = 114},
  [8943] = {.lex_state = 47, .external_lex_state = 104},
  [8944] = {.lex_state = 48, .external_lex_state = 114},
  [8945] = {.lex_state = 48, .external_lex_state = 36},
  [8946] = {.lex_state = 47, .external_lex_state = 104},
  [8947] = {.lex_state = 48, .external_lex_state = 114},
  [8948] = {.lex_state = 47, .external_lex_state = 105},
  [8949] = {.lex_state = 48, .external_lex_state = 36},
  [8950] = {.lex_state = 48, .external_lex_state = 112},
  [8951] = {.lex_state = 47, .external_lex_state = 106},
  [8952] = {.lex_state = 48, .external_lex_state = 113},
  [8953] = {.lex_state = 48, .external_lex_state = 113},
  [8954] = {.lex_state = 48, .external_lex_state = 113},
  [8955] = {.lex_state = 48, .external_lex_state = 36},
  [8956] = {.lex_state = 47, .external_lex_state = 104},
  [8957] = {.lex_state = 48, .external_lex_state = 113},
  [8958] = {.lex_state = 48, .external_lex_state = 114},
  [8959] = {.lex_state = 47, .external_lex_state = 104},
  [8960] = {.lex_state = 48, .external_lex_state = 112},
  [8961] = {.lex_state = 48, .external_lex_state = 113},
  [8962] = {.lex_state = 48, .external_lex_state = 114},
  [8963] = {.lex_state = 48, .external_lex_state = 113},
  [8964] = {.lex_state = 48, .external_lex_state = 112},
  [8965] = {.lex_state = 48, .external_lex_state = 36},
  [8966] = {.lex_state = 48, .external_lex_state = 112},
  [8967] = {.lex_state = 48, .external_lex_state = 114},
  [8968] = {.lex_state = 48, .external_lex_state = 114},
  [8969] = {.lex_state = 47, .external_lex_state = 104},
  [8970] = {.lex_state = 48, .external_lex_state = 113},
  [8971] = {.lex_state = 48, .external_lex_state = 113},
  [8972] = {.lex_state = 48, .external_lex_state = 113},
  [8973] = {.lex_state = 48, .external_lex_state = 112},
  [8974] = {.lex_state = 48, .external_lex_state = 112},
  [8975] = {.lex_state = 48, .external_lex_state = 113},
  [8976] = {.lex_state = 48, .external_lex_state = 113},
  [8977] = {.lex_state = 48, .external_lex_state = 112},
  [8978] = {.lex_state = 48, .external_lex_state = 114},
  [8979] = {.lex_state = 48, .external_lex_state = 110},
  [8980] = {.lex_state = 48, .external_lex_state = 112},
  [8981] = {.lex_state = 48, .external_lex_state = 112},
  [8982] = {.lex_state = 48, .external_lex_state = 113},
  [8983] = {.lex_state = 47, .external_lex_state = 104},
  [8984] = {.lex_state = 48, .external_lex_state = 113},
  [8985] = {.lex_state = 47, .external_lex_state = 104},
  [8986] = {.lex_state = 47, .external_lex_state = 104},
  [8987] = {.lex_state = 47, .external_lex_state = 104},
  [8988] = {.lex_state = 48, .external_lex_state = 113},
  [8989] = {.lex_state = 48, .external_lex_state = 113},
  [8990] = {.lex_state = 47, .external_lex_state = 104},
  [8991] = {.lex_state = 48, .external_lex_state = 114},
  [8992] = {.lex_state = 1, .external_lex_state = 308},
  [8993] = {.lex_state = 1, .external_lex_state = 308},
  [8994] = {.lex_state = 48, .external_lex_state = 22},
  [8995] = {.lex_state = 47, .external_lex_state = 110},
  [8996] = {.lex_state = 47, .external_lex_state = 110},
  [8997] = {.lex_state = 1, .external_lex_state = 308},
  [8998] = {.lex_state = 1, .external_lex_state = 308},
  [8999] = {.lex_state = 47, .external_lex_state = 110},
  [9000] = {.lex_state = 47, .external_lex_state = 110},
  [9001] = {.lex_state = 1, .external_lex_state = 308},
  [9002] = {.lex_state = 47, .external_lex_state = 110},
  [9003] = {.lex_state = 47, .external_lex_state = 110},
  [9004] = {.lex_state = 47, .external_lex_state = 110},
  [9005] = {.lex_state = 1, .external_lex_state = 308},
  [9006] = {.lex_state = 47, .external_lex_state = 110},
  [9007] = {.lex_state = 47, .external_lex_state = 110},
  [9008] = {.lex_state = 1, .external_lex_state = 308},
  [9009] = {.lex_state = 1, .external_lex_state = 308},
  [9010] = {.lex_state = 1, .external_lex_state = 308},
  [9011] = {.lex_state = 1, .external_lex_state = 308},
  [9012] = {.lex_state = 47, .external_lex_state = 110},
  [9013] = {.lex_state = 1, .external_lex_state = 308},
  [9014] = {.lex_state = 51, .external_lex_state = 309},
  [9015] = {.lex_state = 1, .external_lex_state = 308},
  [9016] = {.lex_state = 47, .external_lex_state = 110},
  [9017] = {.lex_state = 47, .external_lex_state = 110},
  [9018] = {.lex_state = 1, .external_lex_state = 308},
  [9019] = {.lex_state = 0, .external_lex_state = 281},
  [9020] = {.lex_state = 1, .external_lex_state = 308},
  [9021] = {.lex_state = 48, .external_lex_state = 22},
  [9022] = {.lex_state = 1, .external_lex_state = 308},
  [9023] = {.lex_state = 1, .external_lex_state = 308},
  [9024] = {.lex_state = 1, .external_lex_state = 308},
  [9025] = {.lex_state = 1, .external_lex_state = 308},
  [9026] = {.lex_state = 48, .external_lex_state = 22},
  [9027] = {.lex_state = 48, .external_lex_state = 22},
  [9028] = {.lex_state = 1, .external_lex_state = 308},
  [9029] = {.lex_state = 1, .external_lex_state = 308},
  [9030] = {.lex_state = 48, .external_lex_state = 22},
  [9031] = {.lex_state = 1, .external_lex_state = 308},
  [9032] = {.lex_state = 1, .external_lex_state = 308},
  [9033] = {.lex_state = 1, .external_lex_state = 308},
  [9034] = {.lex_state = 1, .external_lex_state = 308},
  [9035] = {.lex_state = 48, .external_lex_state = 22},
  [9036] = {.lex_state = 1, .external_lex_state = 308},
  [9037] = {.lex_state = 1, .external_lex_state = 308},
  [9038] = {.lex_state = 1, .external_lex_state = 308},
  [9039] = {.lex_state = 1, .external_lex_state = 308},
  [9040] = {.lex_state = 48, .external_lex_state = 22},
  [9041] = {.lex_state = 1, .external_lex_state = 308},
  [9042] = {.lex_state = 1, .external_lex_state = 308},
  [9043] = {.lex_state = 48, .external_lex_state = 22},
  [9044] = {.lex_state = 47, .external_lex_state = 110},
  [9045] = {.lex_state = 48, .external_lex_state = 22},
  [9046] = {.lex_state = 1, .external_lex_state = 308},
  [9047] = {.lex_state = 48, .external_lex_state = 22},
  [9048] = {.lex_state = 1, .external_lex_state = 308},
  [9049] = {.lex_state = 1, .external_lex_state = 308},
  [9050] = {.lex_state = 1, .external_lex_state = 308},
  [9051] = {.lex_state = 1, .external_lex_state = 308},
  [9052] = {.lex_state = 47, .external_lex_state = 110},
  [9053] = {.lex_state = 0, .external_lex_state = 310},
  [9054] = {.lex_state = 1, .external_lex_state = 308},
  [9055] = {.lex_state = 1, .external_lex_state = 308},
  [9056] = {.lex_state = 1, .external_lex_state = 308},
  [9057] = {.lex_state = 47, .external_lex_state = 110},
  [9058] = {.lex_state = 48, .external_lex_state = 22},
  [9059] = {.lex_state = 1, .external_lex_state = 308},
  [9060] = {.lex_state = 1, .external_lex_state = 308},
  [9061] = {.lex_state = 1, .external_lex_state = 308},
  [9062] = {.lex_state = 1, .external_lex_state = 308},
  [9063] = {.lex_state = 0, .external_lex_state = 281},
  [9064] = {.lex_state = 47, .external_lex_state = 110},
  [9065] = {.lex_state = 0, .external_lex_state = 311},
  [9066] = {.lex_state = 1, .external_lex_state = 308},
  [9067] = {.lex_state = 1, .external_lex_state = 308},
  [9068] = {.lex_state = 1, .external_lex_state = 308},
  [9069] = {.lex_state = 48, .external_lex_state = 22},
  [9070] = {.lex_state = 1, .external_lex_state = 308},
  [9071] = {.lex_state = 1, .external_lex_state = 308},
  [9072] = {.lex_state = 0, .external_lex_state = 281},
  [9073] = {.lex_state = 1, .external_lex_state = 308},
  [9074] = {.lex_state = 47, .external_lex_state = 110},
  [9075] = {.lex_state = 1, .external_lex_state = 308},
  [9076] = {.lex_state = 48, .external_lex_state = 22},
  [9077] = {.lex_state = 47, .external_lex_state = 110},
  [9078] = {.lex_state = 1, .external_lex_state = 308},
  [9079] = {.lex_state = 47, .external_lex_state = 312},
  [9080] = {.lex_state = 48, .external_lex_state = 22},
  [9081] = {.lex_state = 47, .external_lex_state = 312},
  [9082] = {.lex_state = 47, .external_lex_state = 313},
  [9083] = {.lex_state = 1, .external_lex_state = 308},
  [9084] = {.lex_state = 1, .external_lex_state = 308},
  [9085] = {.lex_state = 1, .external_lex_state = 308},
  [9086] = {.lex_state = 47, .external_lex_state = 3},
  [9087] = {.lex_state = 48, .external_lex_state = 22},
  [9088] = {.lex_state = 47, .external_lex_state = 98},
  [9089] = {.lex_state = 1, .external_lex_state = 308},
  [9090] = {.lex_state = 48, .external_lex_state = 22},
  [9091] = {.lex_state = 1, .external_lex_state = 308},
  [9092] = {.lex_state = 1, .external_lex_state = 308},
  [9093] = {.lex_state = 48, .external_lex_state = 22},
  [9094] = {.lex_state = 1, .external_lex_state = 308},
  [9095] = {.lex_state = 47, .external_lex_state = 110},
  [9096] = {.lex_state = 1, .external_lex_state = 308},
  [9097] = {.lex_state = 48, .external_lex_state = 22},
  [9098] = {.lex_state = 47, .external_lex_state = 110},
  [9099] = {.lex_state = 1, .external_lex_state = 308},
  [9100] = {.lex_state = 1, .external_lex_state = 308},
  [9101] = {.lex_state = 1, .external_lex_state = 308},
  [9102] = {.lex_state = 1, .external_lex_state = 308},
  [9103] = {.lex_state = 47, .external_lex_state = 110},
  [9104] = {.lex_state = 1, .external_lex_state = 308},
  [9105] = {.lex_state = 1, .external_lex_state = 308},
  [9106] = {.lex_state = 47, .external_lex_state = 110},
  [9107] = {.lex_state = 47, .external_lex_state = 110},
  [9108] = {.lex_state = 1, .external_lex_state = 308},
  [9109] = {.lex_state = 1, .external_lex_state = 308},
  [9110] = {.lex_state = 47, .external_lex_state = 314},
  [9111] = {.lex_state = 47, .external_lex_state = 110},
  [9112] = {.lex_state = 0, .external_lex_state = 281},
  [9113] = {.lex_state = 1, .external_lex_state = 308},
  [9114] = {.lex_state = 48, .external_lex_state = 22},
  [9115] = {.lex_state = 1, .external_lex_state = 308},
  [9116] = {.lex_state = 0, .external_lex_state = 281},
  [9117] = {.lex_state = 47, .external_lex_state = 315},
  [9118] = {.lex_state = 47, .external_lex_state = 110},
  [9119] = {.lex_state = 1, .external_lex_state = 308},
  [9120] = {.lex_state = 47, .external_lex_state = 110},
  [9121] = {.lex_state = 0, .external_lex_state = 281},
  [9122] = {.lex_state = 1, .external_lex_state = 308},
  [9123] = {.lex_state = 1, .external_lex_state = 308},
  [9124] = {.lex_state = 1, .external_lex_state = 308},
  [9125] = {.lex_state = 47, .external_lex_state = 110},
  [9126] = {.lex_state = 1, .external_lex_state = 308},
  [9127] = {.lex_state = 1, .external_lex_state = 308},
  [9128] = {.lex_state = 47, .external_lex_state = 316},
  [9129] = {.lex_state = 0, .external_lex_state = 281},
  [9130] = {.lex_state = 48, .external_lex_state = 22},
  [9131] = {.lex_state = 1, .external_lex_state = 308},
  [9132] = {.lex_state = 1, .external_lex_state = 308},
  [9133] = {.lex_state = 1, .external_lex_state = 308},
  [9134] = {.lex_state = 48, .external_lex_state = 22},
  [9135] = {.lex_state = 0, .external_lex_state = 281},
  [9136] = {.lex_state = 1, .external_lex_state = 308},
  [9137] = {.lex_state = 1, .external_lex_state = 308},
  [9138] = {.lex_state = 47, .external_lex_state = 110},
  [9139] = {.lex_state = 47, .external_lex_state = 312},
  [9140] = {.lex_state = 47, .external_lex_state = 110},
  [9141] = {.lex_state = 1, .external_lex_state = 308},
  [9142] = {.lex_state = 48, .external_lex_state = 22},
  [9143] = {.lex_state = 1, .external_lex_state = 308},
  [9144] = {.lex_state = 1, .external_lex_state = 308},
  [9145] = {.lex_state = 47, .external_lex_state = 110},
  [9146] = {.lex_state = 1, .external_lex_state = 308},
  [9147] = {.lex_state = 1, .external_lex_state = 308},
  [9148] = {.lex_state = 1, .external_lex_state = 308},
  [9149] = {.lex_state = 1, .external_lex_state = 308},
  [9150] = {.lex_state = 0, .external_lex_state = 281},
  [9151] = {.lex_state = 1, .external_lex_state = 308},
  [9152] = {.lex_state = 47, .external_lex_state = 110},
  [9153] = {.lex_state = 1, .external_lex_state = 308},
  [9154] = {.lex_state = 1, .external_lex_state = 308},
  [9155] = {.lex_state = 1, .external_lex_state = 308},
  [9156] = {.lex_state = 1, .external_lex_state = 308},
  [9157] = {.lex_state = 48, .external_lex_state = 22},
  [9158] = {.lex_state = 48, .external_lex_state = 22},
  [9159] = {.lex_state = 1, .external_lex_state = 308},
  [9160] = {.lex_state = 1, .external_lex_state = 308},
  [9161] = {.lex_state = 47, .external_lex_state = 110},
  [9162] = {.lex_state = 1, .external_lex_state = 308},
  [9163] = {.lex_state = 0, .external_lex_state = 281},
  [9164] = {.lex_state = 48, .external_lex_state = 22},
  [9165] = {.lex_state = 47, .external_lex_state = 110},
  [9166] = {.lex_state = 48, .external_lex_state = 22},
  [9167] = {.lex_state = 48, .external_lex_state = 22},
  [9168] = {.lex_state = 48, .external_lex_state = 22},
  [9169] = {.lex_state = 48, .external_lex_state = 22},
  [9170] = {.lex_state = 1, .external_lex_state = 308},
  [9171] = {.lex_state = 1, .external_lex_state = 308},
  [9172] = {.lex_state = 1, .external_lex_state = 308},
  [9173] = {.lex_state = 1, .external_lex_state = 308},
  [9174] = {.lex_state = 1, .external_lex_state = 308},
  [9175] = {.lex_state = 48, .external_lex_state = 22},
  [9176] = {.lex_state = 1, .external_lex_state = 308},
  [9177] = {.lex_state = 1, .external_lex_state = 308},
  [9178] = {.lex_state = 1, .external_lex_state = 308},
  [9179] = {.lex_state = 1, .external_lex_state = 308},
  [9180] = {.lex_state = 1, .external_lex_state = 308},
  [9181] = {.lex_state = 1, .external_lex_state = 308},
  [9182] = {.lex_state = 1, .external_lex_state = 308},
  [9183] = {.lex_state = 1, .external_lex_state = 308},
  [9184] = {.lex_state = 1, .external_lex_state = 308},
  [9185] = {.lex_state = 48, .external_lex_state = 22},
  [9186] = {.lex_state = 0, .external_lex_state = 281},
  [9187] = {.lex_state = 1, .external_lex_state = 308},
  [9188] = {.lex_state = 1, .external_lex_state = 308},
  [9189] = {.lex_state = 0, .external_lex_state = 281},
  [9190] = {.lex_state = 1, .external_lex_state = 308},
  [9191] = {.lex_state = 0, .external_lex_state = 281},
  [9192] = {.lex_state = 48, .external_lex_state = 3},
  [9193] = {.lex_state = 1, .external_lex_state = 308},
  [9194] = {.lex_state = 47, .external_lex_state = 317},
  [9195] = {.lex_state = 1, .external_lex_state = 308},
  [9196] = {.lex_state = 1, .external_lex_state = 308},
  [9197] = {.lex_state = 1, .external_lex_state = 308},
  [9198] = {.lex_state = 1, .external_lex_state = 308},
  [9199] = {.lex_state = 0, .external_lex_state = 311},
  [9200] = {.lex_state = 0, .external_lex_state = 281},
  [9201] = {.lex_state = 47, .external_lex_state = 316},
  [9202] = {.lex_state = 51, .external_lex_state = 309},
  [9203] = {.lex_state = 0, .external_lex_state = 281},
  [9204] = {.lex_state = 1, .external_lex_state = 308},
  [9205] = {.lex_state = 1, .external_lex_state = 308},
  [9206] = {.lex_state = 0, .external_lex_state = 310},
  [9207] = {.lex_state = 48, .external_lex_state = 22},
  [9208] = {.lex_state = 47, .external_lex_state = 315},
  [9209] = {.lex_state = 1, .external_lex_state = 308},
  [9210] = {.lex_state = 1, .external_lex_state = 308},
  [9211] = {.lex_state = 1, .external_lex_state = 308},
  [9212] = {.lex_state = 47, .external_lex_state = 317},
  [9213] = {.lex_state = 48, .external_lex_state = 22},
  [9214] = {.lex_state = 48, .external_lex_state = 22},
  [9215] = {.lex_state = 1, .external_lex_state = 308},
  [9216] = {.lex_state = 1, .external_lex_state = 308},
  [9217] = {.lex_state = 48, .external_lex_state = 22},
  [9218] = {.lex_state = 47, .external_lex_state = 243},
  [9219] = {.lex_state = 0, .external_lex_state = 318},
  [9220] = {.lex_state = 0, .external_lex_state = 319},
  [9221] = {.lex_state = 48, .external_lex_state = 3},
  [9222] = {.lex_state = 48, .external_lex_state = 249},
  [9223] = {.lex_state = 48, .external_lex_state = 98},
  [9224] = {.lex_state = 48, .external_lex_state = 320},
  [9225] = {.lex_state = 47, .external_lex_state = 98},
  [9226] = {.lex_state = 48, .external_lex_state = 321},
  [9227] = {.lex_state = 0, .external_lex_state = 322},
  [9228] = {.lex_state = 48, .external_lex_state = 3},
  [9229] = {.lex_state = 48, .external_lex_state = 243},
  [9230] = {.lex_state = 48, .external_lex_state = 3},
  [9231] = {.lex_state = 48, .external_lex_state = 320},
  [9232] = {.lex_state = 47, .external_lex_state = 3},
  [9233] = {.lex_state = 47, .external_lex_state = 3},
  [9234] = {.lex_state = 50, .external_lex_state = 323},
  [9235] = {.lex_state = 48, .external_lex_state = 320},
  [9236] = {.lex_state = 0, .external_lex_state = 318},
  [9237] = {.lex_state = 50, .external_lex_state = 324},
  [9238] = {.lex_state = 47, .external_lex_state = 3},
  [9239] = {.lex_state = 48, .external_lex_state = 3},
  [9240] = {.lex_state = 48, .external_lex_state = 321},
  [9241] = {.lex_state = 0, .external_lex_state = 319},
  [9242] = {.lex_state = 48, .external_lex_state = 3},
  [9243] = {.lex_state = 48, .external_lex_state = 321},
  [9244] = {.lex_state = 0, .external_lex_state = 281},
  [9245] = {.lex_state = 48, .external_lex_state = 249},
  [9246] = {.lex_state = 47, .external_lex_state = 98},
  [9247] = {.lex_state = 47, .external_lex_state = 98},
  [9248] = {.lex_state = 47, .external_lex_state = 3},
  [9249] = {.lex_state = 47, .external_lex_state = 3},
  [9250] = {.lex_state = 47, .external_lex_state = 98},
  [9251] = {.lex_state = 48, .external_lex_state = 249},
  [9252] = {.lex_state = 48, .external_lex_state = 243},
  [9253] = {.lex_state = 48, .external_lex_state = 243},
  [9254] = {.lex_state = 48, .external_lex_state = 243},
  [9255] = {.lex_state = 48, .external_lex_state = 243},
  [9256] = {.lex_state = 47, .external_lex_state = 3},
  [9257] = {.lex_state = 0, .external_lex_state = 281},
  [9258] = {.lex_state = 47, .external_lex_state = 98},
  [9259] = {.lex_state = 0, .external_lex_state = 281},
  [9260] = {.lex_state = 48, .external_lex_state = 320},
  [9261] = {.lex_state = 48, .external_lex_state = 243},
  [9262] = {.lex_state = 47, .external_lex_state = 98},
  [9263] = {.lex_state = 47, .external_lex_state = 243},
  [9264] = {.lex_state = 48, .external_lex_state = 249},
  [9265] = {.lex_state = 47, .external_lex_state = 3},
  [9266] = {.lex_state = 47, .external_lex_state = 98},
  [9267] = {.lex_state = 47, .external_lex_state = 3},
  [9268] = {.lex_state = 47, .external_lex_state = 243},
  [9269] = {.lex_state = 0, .external_lex_state = 281},
  [9270] = {.lex_state = 48, .external_lex_state = 249},
  [9271] = {.lex_state = 47, .external_lex_state = 3},
  [9272] = {.lex_state = 0, .external_lex_state = 281},
  [9273] = {.lex_state = 0, .external_lex_state = 281},
  [9274] = {.lex_state = 48, .external_lex_state = 249},
  [9275] = {.lex_state = 48, .external_lex_state = 249},
  [9276] = {.lex_state = 47, .external_lex_state = 3},
  [9277] = {.lex_state = 47, .external_lex_state = 243},
  [9278] = {.lex_state = 47, .external_lex_state = 98},
  [9279] = {.lex_state = 47, .external_lex_state = 98},
  [9280] = {.lex_state = 0, .external_lex_state = 281},
  [9281] = {.lex_state = 0, .external_lex_state = 281},
  [9282] = {.lex_state = 48, .external_lex_state = 320},
  [9283] = {.lex_state = 48, .external_lex_state = 243},
  [9284] = {.lex_state = 48, .external_lex_state = 320},
  [9285] = {.lex_state = 47, .external_lex_state = 98},
  [9286] = {.lex_state = 47, .external_lex_state = 3},
  [9287] = {.lex_state = 47, .external_lex_state = 98},
  [9288] = {.lex_state = 47, .external_lex_state = 3},
  [9289] = {.lex_state = 48, .external_lex_state = 243},
  [9290] = {.lex_state = 0, .external_lex_state = 281},
  [9291] = {.lex_state = 47, .external_lex_state = 98},
  [9292] = {.lex_state = 47, .external_lex_state = 98},
  [9293] = {.lex_state = 0, .external_lex_state = 281},
  [9294] = {.lex_state = 47, .external_lex_state = 3},
  [9295] = {.lex_state = 0, .external_lex_state = 281},
  [9296] = {.lex_state = 47, .external_lex_state = 3},
  [9297] = {.lex_state = 0, .external_lex_state = 325},
  [9298] = {.lex_state = 47, .external_lex_state = 3},
  [9299] = {.lex_state = 47, .external_lex_state = 3},
  [9300] = {.lex_state = 47, .external_lex_state = 98},
  [9301] = {.lex_state = 48, .external_lex_state = 243},
  [9302] = {.lex_state = 0, .external_lex_state = 281},
  [9303] = {.lex_state = 48, .external_lex_state = 36},
  [9304] = {.lex_state = 47, .external_lex_state = 98},
  [9305] = {.lex_state = 0, .external_lex_state = 281},
  [9306] = {.lex_state = 47, .external_lex_state = 98},
  [9307] = {.lex_state = 0, .external_lex_state = 281},
  [9308] = {.lex_state = 0, .external_lex_state = 281},
  [9309] = {.lex_state = 0, .external_lex_state = 281},
  [9310] = {.lex_state = 48, .external_lex_state = 249},
  [9311] = {.lex_state = 0, .external_lex_state = 281},
  [9312] = {.lex_state = 0, .external_lex_state = 281},
  [9313] = {.lex_state = 48, .external_lex_state = 249},
  [9314] = {.lex_state = 0, .external_lex_state = 281},
  [9315] = {.lex_state = 47, .external_lex_state = 3},
  [9316] = {.lex_state = 0, .external_lex_state = 281},
  [9317] = {.lex_state = 48, .external_lex_state = 243},
  [9318] = {.lex_state = 47, .external_lex_state = 98},
  [9319] = {.lex_state = 47, .external_lex_state = 3},
  [9320] = {.lex_state = 48, .external_lex_state = 249},
  [9321] = {.lex_state = 47, .external_lex_state = 3},
  [9322] = {.lex_state = 0, .external_lex_state = 281},
  [9323] = {.lex_state = 47, .external_lex_state = 3},
  [9324] = {.lex_state = 48, .external_lex_state = 249},
  [9325] = {.lex_state = 47, .external_lex_state = 98},
  [9326] = {.lex_state = 0, .external_lex_state = 281},
  [9327] = {.lex_state = 47, .external_lex_state = 98},
  [9328] = {.lex_state = 0, .external_lex_state = 281},
  [9329] = {.lex_state = 0, .external_lex_state = 325},
  [9330] = {.lex_state = 0, .external_lex_state = 281},
  [9331] = {.lex_state = 0, .external_lex_state = 281},
  [9332] = {.lex_state = 47, .external_lex_state = 243},
  [9333] = {.lex_state = 47, .external_lex_state = 243},
  [9334] = {.lex_state = 47, .external_lex_state = 3},
  [9335] = {.lex_state = 48, .external_lex_state = 249},
  [9336] = {.lex_state = 47, .external_lex_state = 98},
  [9337] = {.lex_state = 48, .external_lex_state = 243},
  [9338] = {.lex_state = 47, .external_lex_state = 249},
  [9339] = {.lex_state = 0, .external_lex_state = 281},
  [9340] = {.lex_state = 47, .external_lex_state = 3},
  [9341] = {.lex_state = 47, .external_lex_state = 3},
  [9342] = {.lex_state = 48, .external_lex_state = 243},
  [9343] = {.lex_state = 48, .external_lex_state = 249},
  [9344] = {.lex_state = 47, .external_lex_state = 3},
  [9345] = {.lex_state = 48, .external_lex_state = 243},
  [9346] = {.lex_state = 48, .external_lex_state = 243},
  [9347] = {.lex_state = 48, .external_lex_state = 243},
  [9348] = {.lex_state = 48, .external_lex_state = 249},
  [9349] = {.lex_state = 48, .external_lex_state = 243},
  [9350] = {.lex_state = 47, .external_lex_state = 3},
  [9351] = {.lex_state = 47, .external_lex_state = 98},
  [9352] = {.lex_state = 47, .external_lex_state = 3},
  [9353] = {.lex_state = 48, .external_lex_state = 243},
  [9354] = {.lex_state = 0, .external_lex_state = 281},
  [9355] = {.lex_state = 47, .external_lex_state = 326},
  [9356] = {.lex_state = 47, .external_lex_state = 3},
  [9357] = {.lex_state = 47, .external_lex_state = 3},
  [9358] = {.lex_state = 47, .external_lex_state = 326},
  [9359] = {.lex_state = 48, .external_lex_state = 36},
  [9360] = {.lex_state = 0, .external_lex_state = 281},
  [9361] = {.lex_state = 0, .external_lex_state = 281},
  [9362] = {.lex_state = 47, .external_lex_state = 3},
  [9363] = {.lex_state = 47, .external_lex_state = 3},
  [9364] = {.lex_state = 47, .external_lex_state = 3},
  [9365] = {.lex_state = 48, .external_lex_state = 249},
  [9366] = {.lex_state = 48, .external_lex_state = 249},
  [9367] = {.lex_state = 47, .external_lex_state = 3},
  [9368] = {.lex_state = 0, .external_lex_state = 281},
  [9369] = {.lex_state = 47, .external_lex_state = 98},
  [9370] = {.lex_state = 47, .external_lex_state = 3},
  [9371] = {.lex_state = 47, .external_lex_state = 3},
  [9372] = {.lex_state = 47, .external_lex_state = 3},
  [9373] = {.lex_state = 0, .external_lex_state = 281},
  [9374] = {.lex_state = 48, .external_lex_state = 243},
  [9375] = {.lex_state = 48, .external_lex_state = 249},
  [9376] = {.lex_state = 47, .external_lex_state = 3},
  [9377] = {.lex_state = 0, .external_lex_state = 281},
  [9378] = {.lex_state = 48, .external_lex_state = 249},
  [9379] = {.lex_state = 48, .external_lex_state = 243},
  [9380] = {.lex_state = 48, .external_lex_state = 243},
  [9381] = {.lex_state = 48, .external_lex_state = 243},
  [9382] = {.lex_state = 48, .external_lex_state = 243},
  [9383] = {.lex_state = 48, .external_lex_state = 243},
  [9384] = {.lex_state = 47, .external_lex_state = 308},
  [9385] = {.lex_state = 48, .external_lex_state = 243},
  [9386] = {.lex_state = 48, .external_lex_state = 243},
  [9387] = {.lex_state = 47, .external_lex_state = 3},
  [9388] = {.lex_state = 48, .external_lex_state = 243},
  [9389] = {.lex_state = 48, .external_lex_state = 243},
  [9390] = {.lex_state = 48, .external_lex_state = 243},
  [9391] = {.lex_state = 48, .external_lex_state = 243},
  [9392] = {.lex_state = 48, .external_lex_state = 243},
  [9393] = {.lex_state = 48, .external_lex_state = 243},
  [9394] = {.lex_state = 48, .external_lex_state = 36},
  [9395] = {.lex_state = 48, .external_lex_state = 243},
  [9396] = {.lex_state = 48, .external_lex_state = 243},
  [9397] = {.lex_state = 48, .external_lex_state = 243},
  [9398] = {.lex_state = 48, .external_lex_state = 243},
  [9399] = {.lex_state = 48, .external_lex_state = 243},
  [9400] = {.lex_state = 48, .external_lex_state = 243},
  [9401] = {.lex_state = 48, .external_lex_state = 243},
  [9402] = {.lex_state = 48, .external_lex_state = 243},
  [9403] = {.lex_state = 48, .external_lex_state = 243},
  [9404] = {.lex_state = 48, .external_lex_state = 243},
  [9405] = {.lex_state = 48, .external_lex_state = 243},
  [9406] = {.lex_state = 47, .external_lex_state = 3},
  [9407] = {.lex_state = 48, .external_lex_state = 321},
  [9408] = {.lex_state = 48, .external_lex_state = 243},
  [9409] = {.lex_state = 48, .external_lex_state = 243},
  [9410] = {.lex_state = 48, .external_lex_state = 243},
  [9411] = {.lex_state = 48, .external_lex_state = 243},
  [9412] = {.lex_state = 47, .external_lex_state = 3},
  [9413] = {.lex_state = 48, .external_lex_state = 243},
  [9414] = {.lex_state = 48, .external_lex_state = 243},
  [9415] = {.lex_state = 47, .external_lex_state = 249},
  [9416] = {.lex_state = 48, .external_lex_state = 243},
  [9417] = {.lex_state = 48, .external_lex_state = 243},
  [9418] = {.lex_state = 48, .external_lex_state = 243},
  [9419] = {.lex_state = 48, .external_lex_state = 243},
  [9420] = {.lex_state = 48, .external_lex_state = 243},
  [9421] = {.lex_state = 48, .external_lex_state = 243},
  [9422] = {.lex_state = 48, .external_lex_state = 243},
  [9423] = {.lex_state = 47, .external_lex_state = 3},
  [9424] = {.lex_state = 48, .external_lex_state = 321},
  [9425] = {.lex_state = 48, .external_lex_state = 243},
  [9426] = {.lex_state = 47, .external_lex_state = 3},
  [9427] = {.lex_state = 48, .external_lex_state = 243},
  [9428] = {.lex_state = 48, .external_lex_state = 243},
  [9429] = {.lex_state = 47, .external_lex_state = 327},
  [9430] = {.lex_state = 48, .external_lex_state = 243},
  [9431] = {.lex_state = 48, .external_lex_state = 243},
  [9432] = {.lex_state = 48, .external_lex_state = 243},
  [9433] = {.lex_state = 47, .external_lex_state = 308},
  [9434] = {.lex_state = 48, .external_lex_state = 243},
  [9435] = {.lex_state = 48, .external_lex_state = 243},
  [9436] = {.lex_state = 48, .external_lex_state = 321},
  [9437] = {.lex_state = 48, .external_lex_state = 243},
  [9438] = {.lex_state = 48, .external_lex_state = 243},
  [9439] = {.lex_state = 47, .external_lex_state = 249},
  [9440] = {.lex_state = 47, .external_lex_state = 327},
  [9441] = {.lex_state = 48, .external_lex_state = 249},
  [9442] = {.lex_state = 47, .external_lex_state = 308},
  [9443] = {.lex_state = 48, .external_lex_state = 249},
  [9444] = {.lex_state = 47, .external_lex_state = 243},
  [9445] = {.lex_state = 48, .external_lex_state = 249},
  [9446] = {.lex_state = 48, .external_lex_state = 36},
  [9447] = {.lex_state = 48, .external_lex_state = 249},
  [9448] = {.lex_state = 48, .external_lex_state = 249},
  [9449] = {.lex_state = 47, .external_lex_state = 243},
  [9450] = {.lex_state = 48, .external_lex_state = 36},
  [9451] = {.lex_state = 0, .external_lex_state = 281},
  [9452] = {.lex_state = 48, .external_lex_state = 36},
  [9453] = {.lex_state = 48, .external_lex_state = 249},
  [9454] = {.lex_state = 48, .external_lex_state = 36},
  [9455] = {.lex_state = 0, .external_lex_state = 281},
  [9456] = {.lex_state = 48, .external_lex_state = 249},
  [9457] = {.lex_state = 48, .external_lex_state = 281},
  [9458] = {.lex_state = 51, .external_lex_state = 328},
  [9459] = {.lex_state = 47, .external_lex_state = 298},
  [9460] = {.lex_state = 48, .external_lex_state = 249},
  [9461] = {.lex_state = 48, .external_lex_state = 249},
  [9462] = {.lex_state = 48, .external_lex_state = 36},
  [9463] = {.lex_state = 48, .external_lex_state = 36},
  [9464] = {.lex_state = 48, .external_lex_state = 249},
  [9465] = {.lex_state = 48, .external_lex_state = 249},
  [9466] = {.lex_state = 48, .external_lex_state = 36},
  [9467] = {.lex_state = 48, .external_lex_state = 36},
  [9468] = {.lex_state = 48, .external_lex_state = 249},
  [9469] = {.lex_state = 48, .external_lex_state = 249},
  [9470] = {.lex_state = 48, .external_lex_state = 249},
  [9471] = {.lex_state = 48, .external_lex_state = 249},
  [9472] = {.lex_state = 47, .external_lex_state = 243},
  [9473] = {.lex_state = 47, .external_lex_state = 243},
  [9474] = {.lex_state = 48, .external_lex_state = 249},
  [9475] = {.lex_state = 48, .external_lex_state = 249},
  [9476] = {.lex_state = 48, .external_lex_state = 249},
  [9477] = {.lex_state = 48, .external_lex_state = 249},
  [9478] = {.lex_state = 48, .external_lex_state = 249},
  [9479] = {.lex_state = 48, .external_lex_state = 249},
  [9480] = {.lex_state = 51, .external_lex_state = 328},
  [9481] = {.lex_state = 48, .external_lex_state = 249},
  [9482] = {.lex_state = 48, .external_lex_state = 249},
  [9483] = {.lex_state = 48, .external_lex_state = 249},
  [9484] = {.lex_state = 48, .external_lex_state = 249},
  [9485] = {.lex_state = 47, .external_lex_state = 269},
  [9486] = {.lex_state = 48, .external_lex_state = 249},
  [9487] = {.lex_state = 48, .external_lex_state = 249},
  [9488] = {.lex_state = 48, .external_lex_state = 249},
  [9489] = {.lex_state = 48, .external_lex_state = 249},
  [9490] = {.lex_state = 48, .external_lex_state = 249},
  [9491] = {.lex_state = 48, .external_lex_state = 249},
  [9492] = {.lex_state = 48, .external_lex_state = 249},
  [9493] = {.lex_state = 51, .external_lex_state = 328},
  [9494] = {.lex_state = 47, .external_lex_state = 243},
  [9495] = {.lex_state = 48, .external_lex_state = 249},
  [9496] = {.lex_state = 48, .external_lex_state = 249},
  [9497] = {.lex_state = 48, .external_lex_state = 249},
  [9498] = {.lex_state = 47, .external_lex_state = 243},
  [9499] = {.lex_state = 48, .external_lex_state = 249},
  [9500] = {.lex_state = 48, .external_lex_state = 249},
  [9501] = {.lex_state = 47, .external_lex_state = 243},
  [9502] = {.lex_state = 47, .external_lex_state = 243},
  [9503] = {.lex_state = 48, .external_lex_state = 249},
  [9504] = {.lex_state = 48, .external_lex_state = 249},
  [9505] = {.lex_state = 48, .external_lex_state = 249},
  [9506] = {.lex_state = 47, .external_lex_state = 243},
  [9507] = {.lex_state = 47, .external_lex_state = 243},
  [9508] = {.lex_state = 47, .external_lex_state = 243},
  [9509] = {.lex_state = 48, .external_lex_state = 249},
  [9510] = {.lex_state = 50, .external_lex_state = 188},
  [9511] = {.lex_state = 48, .external_lex_state = 249},
  [9512] = {.lex_state = 48, .external_lex_state = 249},
  [9513] = {.lex_state = 48, .external_lex_state = 249},
  [9514] = {.lex_state = 48, .external_lex_state = 249},
  [9515] = {.lex_state = 48, .external_lex_state = 249},
  [9516] = {.lex_state = 48, .external_lex_state = 249},
  [9517] = {.lex_state = 47, .external_lex_state = 249},
  [9518] = {.lex_state = 51, .external_lex_state = 329},
  [9519] = {.lex_state = 47, .external_lex_state = 249},
  [9520] = {.lex_state = 47, .external_lex_state = 269},
  [9521] = {.lex_state = 47, .external_lex_state = 243},
  [9522] = {.lex_state = 47, .external_lex_state = 243},
  [9523] = {.lex_state = 47, .external_lex_state = 243},
  [9524] = {.lex_state = 47, .external_lex_state = 243},
  [9525] = {.lex_state = 51, .external_lex_state = 281},
  [9526] = {.lex_state = 47, .external_lex_state = 243},
  [9527] = {.lex_state = 0, .external_lex_state = 318},
  [9528] = {.lex_state = 47, .external_lex_state = 249},
  [9529] = {.lex_state = 47, .external_lex_state = 243},
  [9530] = {.lex_state = 47, .external_lex_state = 269},
  [9531] = {.lex_state = 47, .external_lex_state = 243},
  [9532] = {.lex_state = 51, .external_lex_state = 281},
  [9533] = {.lex_state = 47, .external_lex_state = 243},
  [9534] = {.lex_state = 47, .external_lex_state = 243},
  [9535] = {.lex_state = 51, .external_lex_state = 281},
  [9536] = {.lex_state = 47, .external_lex_state = 249},
  [9537] = {.lex_state = 51, .external_lex_state = 329},
  [9538] = {.lex_state = 47, .external_lex_state = 303},
  [9539] = {.lex_state = 47, .external_lex_state = 243},
  [9540] = {.lex_state = 51, .external_lex_state = 281},
  [9541] = {.lex_state = 47, .external_lex_state = 243},
  [9542] = {.lex_state = 47, .external_lex_state = 249},
  [9543] = {.lex_state = 51, .external_lex_state = 329},
  [9544] = {.lex_state = 47, .external_lex_state = 330},
  [9545] = {.lex_state = 47, .external_lex_state = 305},
  [9546] = {.lex_state = 47, .external_lex_state = 249},
  [9547] = {.lex_state = 51, .external_lex_state = 329},
  [9548] = {.lex_state = 47, .external_lex_state = 249},
  [9549] = {.lex_state = 51, .external_lex_state = 281},
  [9550] = {.lex_state = 47, .external_lex_state = 243},
  [9551] = {.lex_state = 51, .external_lex_state = 281},
  [9552] = {.lex_state = 47, .external_lex_state = 249},
  [9553] = {.lex_state = 47, .external_lex_state = 243},
  [9554] = {.lex_state = 47, .external_lex_state = 243},
  [9555] = {.lex_state = 47, .external_lex_state = 269},
  [9556] = {.lex_state = 47, .external_lex_state = 249},
  [9557] = {.lex_state = 51, .external_lex_state = 281},
  [9558] = {.lex_state = 47, .external_lex_state = 298},
  [9559] = {.lex_state = 51, .external_lex_state = 281},
  [9560] = {.lex_state = 47, .external_lex_state = 330},
  [9561] = {.lex_state = 51, .external_lex_state = 281},
  [9562] = {.lex_state = 47, .external_lex_state = 243},
  [9563] = {.lex_state = 47, .external_lex_state = 249},
  [9564] = {.lex_state = 47, .external_lex_state = 249},
  [9565] = {.lex_state = 47, .external_lex_state = 298},
  [9566] = {.lex_state = 47, .external_lex_state = 269},
  [9567] = {.lex_state = 47, .external_lex_state = 243},
  [9568] = {.lex_state = 51, .external_lex_state = 281},
  [9569] = {.lex_state = 47, .external_lex_state = 243},
  [9570] = {.lex_state = 51, .external_lex_state = 281},
  [9571] = {.lex_state = 0, .external_lex_state = 281},
  [9572] = {.lex_state = 47, .external_lex_state = 269},
  [9573] = {.lex_state = 51, .external_lex_state = 281},
  [9574] = {.lex_state = 47, .external_lex_state = 304},
  [9575] = {.lex_state = 51, .external_lex_state = 329},
  [9576] = {.lex_state = 51, .external_lex_state = 281},
  [9577] = {.lex_state = 51, .external_lex_state = 329},
  [9578] = {.lex_state = 51, .external_lex_state = 281},
  [9579] = {.lex_state = 47, .external_lex_state = 301},
  [9580] = {.lex_state = 51, .external_lex_state = 281},
  [9581] = {.lex_state = 51, .external_lex_state = 281},
  [9582] = {.lex_state = 47, .external_lex_state = 243},
  [9583] = {.lex_state = 0, .external_lex_state = 322},
  [9584] = {.lex_state = 51, .external_lex_state = 281},
  [9585] = {.lex_state = 51, .external_lex_state = 292},
  [9586] = {.lex_state = 51, .external_lex_state = 269},
  [9587] = {.lex_state = 51, .external_lex_state = 269},
  [9588] = {.lex_state = 47, .external_lex_state = 249},
  [9589] = {.lex_state = 50, .external_lex_state = 188},
  [9590] = {.lex_state = 51, .external_lex_state = 269},
  [9591] = {.lex_state = 51, .external_lex_state = 269},
  [9592] = {.lex_state = 51, .external_lex_state = 269},
  [9593] = {.lex_state = 48, .external_lex_state = 292},
  [9594] = {.lex_state = 51, .external_lex_state = 269},
  [9595] = {.lex_state = 51, .external_lex_state = 269},
  [9596] = {.lex_state = 0, .external_lex_state = 310},
  [9597] = {.lex_state = 47, .external_lex_state = 317},
  [9598] = {.lex_state = 51, .external_lex_state = 269},
  [9599] = {.lex_state = 51, .external_lex_state = 269},
  [9600] = {.lex_state = 50, .external_lex_state = 188},
  [9601] = {.lex_state = 51, .external_lex_state = 269},
  [9602] = {.lex_state = 47, .external_lex_state = 249},
  [9603] = {.lex_state = 47, .external_lex_state = 249},
  [9604] = {.lex_state = 51, .external_lex_state = 269},
  [9605] = {.lex_state = 0, .external_lex_state = 331},
  [9606] = {.lex_state = 51, .external_lex_state = 269},
  [9607] = {.lex_state = 50, .external_lex_state = 188},
  [9608] = {.lex_state = 51, .external_lex_state = 332},
  [9609] = {.lex_state = 51, .external_lex_state = 269},
  [9610] = {.lex_state = 51, .external_lex_state = 269},
  [9611] = {.lex_state = 51, .external_lex_state = 269},
  [9612] = {.lex_state = 51, .external_lex_state = 269},
  [9613] = {.lex_state = 51, .external_lex_state = 269},
  [9614] = {.lex_state = 51, .external_lex_state = 269},
  [9615] = {.lex_state = 50, .external_lex_state = 188},
  [9616] = {.lex_state = 51, .external_lex_state = 269},
  [9617] = {.lex_state = 51, .external_lex_state = 269},
  [9618] = {.lex_state = 51, .external_lex_state = 269},
  [9619] = {.lex_state = 51, .external_lex_state = 332},
  [9620] = {.lex_state = 51, .external_lex_state = 269},
  [9621] = {.lex_state = 48, .external_lex_state = 281},
  [9622] = {.lex_state = 51, .external_lex_state = 269},
  [9623] = {.lex_state = 51, .external_lex_state = 269},
  [9624] = {.lex_state = 0, .external_lex_state = 281},
  [9625] = {.lex_state = 47, .external_lex_state = 303},
  [9626] = {.lex_state = 50, .external_lex_state = 188},
  [9627] = {.lex_state = 51, .external_lex_state = 269},
  [9628] = {.lex_state = 51, .external_lex_state = 269},
  [9629] = {.lex_state = 51, .external_lex_state = 292},
  [9630] = {.lex_state = 51, .external_lex_state = 269},
  [9631] = {.lex_state = 47, .external_lex_state = 249},
  [9632] = {.lex_state = 51, .external_lex_state = 269},
  [9633] = {.lex_state = 51, .external_lex_state = 292},
  [9634] = {.lex_state = 47, .external_lex_state = 313},
  [9635] = {.lex_state = 51, .external_lex_state = 332},
  [9636] = {.lex_state = 51, .external_lex_state = 269},
  [9637] = {.lex_state = 51, .external_lex_state = 269},
  [9638] = {.lex_state = 51, .external_lex_state = 328},
  [9639] = {.lex_state = 51, .external_lex_state = 333},
  [9640] = {.lex_state = 51, .external_lex_state = 269},
  [9641] = {.lex_state = 51, .external_lex_state = 269},
  [9642] = {.lex_state = 51, .external_lex_state = 269},
  [9643] = {.lex_state = 51, .external_lex_state = 269},
  [9644] = {.lex_state = 47, .external_lex_state = 249},
  [9645] = {.lex_state = 51, .external_lex_state = 269},
  [9646] = {.lex_state = 51, .external_lex_state = 269},
  [9647] = {.lex_state = 47, .external_lex_state = 249},
  [9648] = {.lex_state = 47, .external_lex_state = 249},
  [9649] = {.lex_state = 51, .external_lex_state = 269},
  [9650] = {.lex_state = 47, .external_lex_state = 249},
  [9651] = {.lex_state = 47, .external_lex_state = 249},
  [9652] = {.lex_state = 47, .external_lex_state = 249},
  [9653] = {.lex_state = 50, .external_lex_state = 188},
  [9654] = {.lex_state = 47, .external_lex_state = 249},
  [9655] = {.lex_state = 51, .external_lex_state = 309},
  [9656] = {.lex_state = 51, .external_lex_state = 269},
  [9657] = {.lex_state = 47, .external_lex_state = 249},
  [9658] = {.lex_state = 50, .external_lex_state = 188},
  [9659] = {.lex_state = 51, .external_lex_state = 269},
  [9660] = {.lex_state = 51, .external_lex_state = 292},
  [9661] = {.lex_state = 51, .external_lex_state = 269},
  [9662] = {.lex_state = 51, .external_lex_state = 269},
  [9663] = {.lex_state = 51, .external_lex_state = 269},
  [9664] = {.lex_state = 51, .external_lex_state = 269},
  [9665] = {.lex_state = 51, .external_lex_state = 269},
  [9666] = {.lex_state = 51, .external_lex_state = 269},
  [9667] = {.lex_state = 51, .external_lex_state = 269},
  [9668] = {.lex_state = 47, .external_lex_state = 301},
  [9669] = {.lex_state = 51, .external_lex_state = 269},
  [9670] = {.lex_state = 47, .external_lex_state = 305},
  [9671] = {.lex_state = 48, .external_lex_state = 292},
  [9672] = {.lex_state = 47, .external_lex_state = 314},
  [9673] = {.lex_state = 51, .external_lex_state = 332},
  [9674] = {.lex_state = 50, .external_lex_state = 188},
  [9675] = {.lex_state = 50, .external_lex_state = 188},
  [9676] = {.lex_state = 0, .external_lex_state = 249},
  [9677] = {.lex_state = 47, .external_lex_state = 249},
  [9678] = {.lex_state = 51, .external_lex_state = 269},
  [9679] = {.lex_state = 0, .external_lex_state = 331},
  [9680] = {.lex_state = 51, .external_lex_state = 269},
  [9681] = {.lex_state = 51, .external_lex_state = 292},
  [9682] = {.lex_state = 51, .external_lex_state = 269},
  [9683] = {.lex_state = 51, .external_lex_state = 328},
  [9684] = {.lex_state = 47, .external_lex_state = 249},
  [9685] = {.lex_state = 47, .external_lex_state = 249},
  [9686] = {.lex_state = 0, .external_lex_state = 281},
  [9687] = {.lex_state = 47, .external_lex_state = 303},
  [9688] = {.lex_state = 47, .external_lex_state = 304},
  [9689] = {.lex_state = 51, .external_lex_state = 269},
  [9690] = {.lex_state = 51, .external_lex_state = 332},
  [9691] = {.lex_state = 51, .external_lex_state = 333},
  [9692] = {.lex_state = 51, .external_lex_state = 269},
  [9693] = {.lex_state = 51, .external_lex_state = 269},
  [9694] = {.lex_state = 50, .external_lex_state = 188},
  [9695] = {.lex_state = 51, .external_lex_state = 269},
  [9696] = {.lex_state = 51, .external_lex_state = 269},
  [9697] = {.lex_state = 51, .external_lex_state = 269},
  [9698] = {.lex_state = 0, .external_lex_state = 311},
  [9699] = {.lex_state = 51, .external_lex_state = 269},
  [9700] = {.lex_state = 47, .external_lex_state = 305},
  [9701] = {.lex_state = 51, .external_lex_state = 269},
  [9702] = {.lex_state = 51, .external_lex_state = 332},
  [9703] = {.lex_state = 51, .external_lex_state = 328},
  [9704] = {.lex_state = 51, .external_lex_state = 269},
  [9705] = {.lex_state = 47, .external_lex_state = 249},
  [9706] = {.lex_state = 47, .external_lex_state = 304},
  [9707] = {.lex_state = 47, .external_lex_state = 301},
  [9708] = {.lex_state = 51, .external_lex_state = 269},
  [9709] = {.lex_state = 51, .external_lex_state = 269},
  [9710] = {.lex_state = 51, .external_lex_state = 269},
  [9711] = {.lex_state = 51, .external_lex_state = 269},
  [9712] = {.lex_state = 50, .external_lex_state = 188},
  [9713] = {.lex_state = 47, .external_lex_state = 316},
  [9714] = {.lex_state = 47, .external_lex_state = 249},
  [9715] = {.lex_state = 51, .external_lex_state = 269},
  [9716] = {.lex_state = 51, .external_lex_state = 269},
  [9717] = {.lex_state = 0, .external_lex_state = 249},
  [9718] = {.lex_state = 51, .external_lex_state = 281},
  [9719] = {.lex_state = 0, .external_lex_state = 249},
  [9720] = {.lex_state = 51, .external_lex_state = 292},
  [9721] = {.lex_state = 47, .external_lex_state = 302},
  [9722] = {.lex_state = 51, .external_lex_state = 292},
  [9723] = {.lex_state = 51, .external_lex_state = 292},
  [9724] = {.lex_state = 51, .external_lex_state = 292},
  [9725] = {.lex_state = 0, .external_lex_state = 249},
  [9726] = {.lex_state = 0, .external_lex_state = 249},
  [9727] = {.lex_state = 0, .external_lex_state = 249},
  [9728] = {.lex_state = 0, .external_lex_state = 249},
  [9729] = {.lex_state = 51, .external_lex_state = 292},
  [9730] = {.lex_state = 0, .external_lex_state = 249},
  [9731] = {.lex_state = 51, .external_lex_state = 292},
  [9732] = {.lex_state = 47, .external_lex_state = 269},
  [9733] = {.lex_state = 47, .external_lex_state = 269},
  [9734] = {.lex_state = 0, .external_lex_state = 249},
  [9735] = {.lex_state = 0, .external_lex_state = 249},
  [9736] = {.lex_state = 47, .external_lex_state = 269},
  [9737] = {.lex_state = 0, .external_lex_state = 310},
  [9738] = {.lex_state = 51, .external_lex_state = 292},
  [9739] = {.lex_state = 47, .external_lex_state = 269},
  [9740] = {.lex_state = 51, .external_lex_state = 292},
  [9741] = {.lex_state = 0, .external_lex_state = 249},
  [9742] = {.lex_state = 51, .external_lex_state = 292},
  [9743] = {.lex_state = 0, .external_lex_state = 249},
  [9744] = {.lex_state = 47, .external_lex_state = 269},
  [9745] = {.lex_state = 51, .external_lex_state = 281},
  [9746] = {.lex_state = 0, .external_lex_state = 249},
  [9747] = {.lex_state = 0, .external_lex_state = 249},
  [9748] = {.lex_state = 51, .external_lex_state = 292},
  [9749] = {.lex_state = 0, .external_lex_state = 249},
  [9750] = {.lex_state = 47, .external_lex_state = 269},
  [9751] = {.lex_state = 51, .external_lex_state = 292},
  [9752] = {.lex_state = 0, .external_lex_state = 249},
  [9753] = {.lex_state = 0, .external_lex_state = 249},
  [9754] = {.lex_state = 0, .external_lex_state = 249},
  [9755] = {.lex_state = 0, .external_lex_state = 249},
  [9756] = {.lex_state = 47, .external_lex_state = 269},
  [9757] = {.lex_state = 51, .external_lex_state = 292},
  [9758] = {.lex_state = 51, .external_lex_state = 292},
  [9759] = {.lex_state = 51, .external_lex_state = 281},
  [9760] = {.lex_state = 0, .external_lex_state = 249},
  [9761] = {.lex_state = 0, .external_lex_state = 249},
  [9762] = {.lex_state = 51, .external_lex_state = 292},
  [9763] = {.lex_state = 0, .external_lex_state = 249},
  [9764] = {.lex_state = 0, .external_lex_state = 249},
  [9765] = {.lex_state = 0, .external_lex_state = 249},
  [9766] = {.lex_state = 51, .external_lex_state = 292},
  [9767] = {.lex_state = 0, .external_lex_state = 249},
  [9768] = {.lex_state = 51, .external_lex_state = 292},
  [9769] = {.lex_state = 0, .external_lex_state = 249},
  [9770] = {.lex_state = 51, .external_lex_state = 292},
  [9771] = {.lex_state = 51, .external_lex_state = 292},
  [9772] = {.lex_state = 47, .external_lex_state = 269},
  [9773] = {.lex_state = 0, .external_lex_state = 249},
  [9774] = {.lex_state = 51, .external_lex_state = 292},
  [9775] = {.lex_state = 51, .external_lex_state = 292},
  [9776] = {.lex_state = 51, .external_lex_state = 281},
  [9777] = {.lex_state = 0, .external_lex_state = 311},
  [9778] = {.lex_state = 0, .external_lex_state = 249},
  [9779] = {.lex_state = 51, .external_lex_state = 281},
  [9780] = {.lex_state = 0, .external_lex_state = 249},
  [9781] = {.lex_state = 51, .external_lex_state = 292},
  [9782] = {.lex_state = 47, .external_lex_state = 269},
  [9783] = {.lex_state = 51, .external_lex_state = 292},
  [9784] = {.lex_state = 51, .external_lex_state = 281},
  [9785] = {.lex_state = 47, .external_lex_state = 269},
  [9786] = {.lex_state = 51, .external_lex_state = 292},
  [9787] = {.lex_state = 0, .external_lex_state = 249},
  [9788] = {.lex_state = 48, .external_lex_state = 334},
  [9789] = {.lex_state = 51, .external_lex_state = 292},
  [9790] = {.lex_state = 48, .external_lex_state = 334},
  [9791] = {.lex_state = 50, .external_lex_state = 335},
  [9792] = {.lex_state = 51, .external_lex_state = 309},
  [9793] = {.lex_state = 51, .external_lex_state = 292},
  [9794] = {.lex_state = 51, .external_lex_state = 281},
  [9795] = {.lex_state = 51, .external_lex_state = 292},
  [9796] = {.lex_state = 51, .external_lex_state = 292},
  [9797] = {.lex_state = 0, .external_lex_state = 249},
  [9798] = {.lex_state = 51, .external_lex_state = 292},
  [9799] = {.lex_state = 48, .external_lex_state = 334},
  [9800] = {.lex_state = 0, .external_lex_state = 249},
  [9801] = {.lex_state = 51, .external_lex_state = 292},
  [9802] = {.lex_state = 51, .external_lex_state = 292},
  [9803] = {.lex_state = 51, .external_lex_state = 292},
  [9804] = {.lex_state = 0, .external_lex_state = 249},
  [9805] = {.lex_state = 51, .external_lex_state = 292},
  [9806] = {.lex_state = 51, .external_lex_state = 292},
  [9807] = {.lex_state = 0, .external_lex_state = 249},
  [9808] = {.lex_state = 0, .external_lex_state = 249},
  [9809] = {.lex_state = 51, .external_lex_state = 292},
  [9810] = {.lex_state = 51, .external_lex_state = 292},
  [9811] = {.lex_state = 0, .external_lex_state = 249},
  [9812] = {.lex_state = 51, .external_lex_state = 281},
  [9813] = {.lex_state = 51, .external_lex_state = 292},
  [9814] = {.lex_state = 51, .external_lex_state = 281},
  [9815] = {.lex_state = 51, .external_lex_state = 281},
  [9816] = {.lex_state = 0, .external_lex_state = 249},
  [9817] = {.lex_state = 51, .external_lex_state = 292},
  [9818] = {.lex_state = 51, .external_lex_state = 292},
  [9819] = {.lex_state = 51, .external_lex_state = 281},
  [9820] = {.lex_state = 0, .external_lex_state = 249},
  [9821] = {.lex_state = 0, .external_lex_state = 249},
  [9822] = {.lex_state = 51, .external_lex_state = 292},
  [9823] = {.lex_state = 51, .external_lex_state = 292},
  [9824] = {.lex_state = 48, .external_lex_state = 334},
  [9825] = {.lex_state = 0, .external_lex_state = 249},
  [9826] = {.lex_state = 0, .external_lex_state = 249},
  [9827] = {.lex_state = 51, .external_lex_state = 281},
  [9828] = {.lex_state = 0, .external_lex_state = 249},
  [9829] = {.lex_state = 0, .external_lex_state = 249},
  [9830] = {.lex_state = 51, .external_lex_state = 292},
  [9831] = {.lex_state = 51, .external_lex_state = 292},
  [9832] = {.lex_state = 0, .external_lex_state = 249},
  [9833] = {.lex_state = 51, .external_lex_state = 292},
  [9834] = {.lex_state = 0, .external_lex_state = 249},
  [9835] = {.lex_state = 51, .external_lex_state = 292},
  [9836] = {.lex_state = 0, .external_lex_state = 311},
  [9837] = {.lex_state = 0, .external_lex_state = 249},
  [9838] = {.lex_state = 0, .external_lex_state = 249},
  [9839] = {.lex_state = 51, .external_lex_state = 281},
  [9840] = {.lex_state = 51, .external_lex_state = 281},
  [9841] = {.lex_state = 0, .external_lex_state = 249},
  [9842] = {.lex_state = 51, .external_lex_state = 281},
  [9843] = {.lex_state = 0, .external_lex_state = 310},
  [9844] = {.lex_state = 51, .external_lex_state = 292},
  [9845] = {.lex_state = 47, .external_lex_state = 313},
  [9846] = {.lex_state = 51, .external_lex_state = 281},
  [9847] = {.lex_state = 0, .external_lex_state = 249},
  [9848] = {.lex_state = 0, .external_lex_state = 249},
  [9849] = {.lex_state = 0, .external_lex_state = 318},
  [9850] = {.lex_state = 51, .external_lex_state = 281},
  [9851] = {.lex_state = 51, .external_lex_state = 281},
  [9852] = {.lex_state = 51, .external_lex_state = 281},
  [9853] = {.lex_state = 51, .external_lex_state = 281},
  [9854] = {.lex_state = 0, .external_lex_state = 249},
  [9855] = {.lex_state = 51, .external_lex_state = 292},
  [9856] = {.lex_state = 0, .external_lex_state = 249},
  [9857] = {.lex_state = 0, .external_lex_state = 249},
  [9858] = {.lex_state = 51, .external_lex_state = 292},
  [9859] = {.lex_state = 0, .external_lex_state = 249},
  [9860] = {.lex_state = 51, .external_lex_state = 281},
  [9861] = {.lex_state = 0, .external_lex_state = 249},
  [9862] = {.lex_state = 51, .external_lex_state = 292},
  [9863] = {.lex_state = 51, .external_lex_state = 292},
  [9864] = {.lex_state = 0, .external_lex_state = 249},
  [9865] = {.lex_state = 51, .external_lex_state = 281},
  [9866] = {.lex_state = 0, .external_lex_state = 249},
  [9867] = {.lex_state = 47, .external_lex_state = 313},
  [9868] = {.lex_state = 51, .external_lex_state = 281},
  [9869] = {.lex_state = 0, .external_lex_state = 249},
  [9870] = {.lex_state = 51, .external_lex_state = 292},
  [9871] = {.lex_state = 51, .external_lex_state = 281},
  [9872] = {.lex_state = 47, .external_lex_state = 316},
  [9873] = {.lex_state = 51, .external_lex_state = 281},
  [9874] = {.lex_state = 51, .external_lex_state = 292},
  [9875] = {.lex_state = 51, .external_lex_state = 292},
  [9876] = {.lex_state = 51, .external_lex_state = 292},
  [9877] = {.lex_state = 51, .external_lex_state = 292},
  [9878] = {.lex_state = 51, .external_lex_state = 309},
  [9879] = {.lex_state = 0, .external_lex_state = 249},
  [9880] = {.lex_state = 0, .external_lex_state = 249},
  [9881] = {.lex_state = 47, .external_lex_state = 317},
  [9882] = {.lex_state = 0, .external_lex_state = 249},
  [9883] = {.lex_state = 51, .external_lex_state = 292},
  [9884] = {.lex_state = 0, .external_lex_state = 249},
  [9885] = {.lex_state = 0, .external_lex_state = 249},
  [9886] = {.lex_state = 0, .external_lex_state = 249},
  [9887] = {.lex_state = 51, .external_lex_state = 292},
  [9888] = {.lex_state = 51, .external_lex_state = 292},
  [9889] = {.lex_state = 0, .external_lex_state = 249},
  [9890] = {.lex_state = 51, .external_lex_state = 292},
  [9891] = {.lex_state = 51, .external_lex_state = 292},
  [9892] = {.lex_state = 51, .external_lex_state = 292},
  [9893] = {.lex_state = 47, .external_lex_state = 316},
  [9894] = {.lex_state = 0, .external_lex_state = 249},
  [9895] = {.lex_state = 0, .external_lex_state = 249},
  [9896] = {.lex_state = 51, .external_lex_state = 292},
  [9897] = {.lex_state = 0, .external_lex_state = 249},
  [9898] = {.lex_state = 51, .external_lex_state = 292},
  [9899] = {.lex_state = 50, .external_lex_state = 336},
  [9900] = {.lex_state = 47, .external_lex_state = 298},
  [9901] = {.lex_state = 51, .external_lex_state = 292},
  [9902] = {.lex_state = 51, .external_lex_state = 292},
  [9903] = {.lex_state = 0, .external_lex_state = 249},
  [9904] = {.lex_state = 0, .external_lex_state = 249},
  [9905] = {.lex_state = 0, .external_lex_state = 249},
  [9906] = {.lex_state = 51, .external_lex_state = 292},
  [9907] = {.lex_state = 51, .external_lex_state = 292},
  [9908] = {.lex_state = 0, .external_lex_state = 249},
  [9909] = {.lex_state = 47, .external_lex_state = 314},
  [9910] = {.lex_state = 0, .external_lex_state = 249},
  [9911] = {.lex_state = 47, .external_lex_state = 298},
  [9912] = {.lex_state = 51, .external_lex_state = 292},
  [9913] = {.lex_state = 0, .external_lex_state = 249},
  [9914] = {.lex_state = 0, .external_lex_state = 249},
  [9915] = {.lex_state = 0, .external_lex_state = 249},
  [9916] = {.lex_state = 0, .external_lex_state = 249},
  [9917] = {.lex_state = 51, .external_lex_state = 281},
  [9918] = {.lex_state = 51, .external_lex_state = 281},
  [9919] = {.lex_state = 0, .external_lex_state = 249},
  [9920] = {.lex_state = 0, .external_lex_state = 249},
  [9921] = {.lex_state = 0, .external_lex_state = 249},
  [9922] = {.lex_state = 0, .external_lex_state = 249},
  [9923] = {.lex_state = 48, .external_lex_state = 281},
  [9924] = {.lex_state = 51, .external_lex_state = 281},
  [9925] = {.lex_state = 51, .external_lex_state = 281},
  [9926] = {.lex_state = 51, .external_lex_state = 292},
  [9927] = {.lex_state = 51, .external_lex_state = 281},
  [9928] = {.lex_state = 51, .external_lex_state = 281},
  [9929] = {.lex_state = 0, .external_lex_state = 249},
  [9930] = {.lex_state = 0, .external_lex_state = 249},
  [9931] = {.lex_state = 51, .external_lex_state = 281},
  [9932] = {.lex_state = 51, .external_lex_state = 281},
  [9933] = {.lex_state = 51, .external_lex_state = 281},
  [9934] = {.lex_state = 51, .external_lex_state = 281},
  [9935] = {.lex_state = 51, .external_lex_state = 281},
  [9936] = {.lex_state = 0, .external_lex_state = 249},
  [9937] = {.lex_state = 51, .external_lex_state = 281},
  [9938] = {.lex_state = 47, .external_lex_state = 337},
  [9939] = {.lex_state = 0, .external_lex_state = 249},
  [9940] = {.lex_state = 47, .external_lex_state = 298},
  [9941] = {.lex_state = 48, .external_lex_state = 334},
  [9942] = {.lex_state = 51, .external_lex_state = 281},
  [9943] = {.lex_state = 51, .external_lex_state = 281},
  [9944] = {.lex_state = 48, .external_lex_state = 334},
  [9945] = {.lex_state = 0, .external_lex_state = 210},
  [9946] = {.lex_state = 51, .external_lex_state = 281},
  [9947] = {.lex_state = 0, .external_lex_state = 249},
  [9948] = {.lex_state = 0, .external_lex_state = 249},
  [9949] = {.lex_state = 47, .external_lex_state = 337},
  [9950] = {.lex_state = 0, .external_lex_state = 319},
  [9951] = {.lex_state = 51, .external_lex_state = 281},
  [9952] = {.lex_state = 51, .external_lex_state = 281},
  [9953] = {.lex_state = 51, .external_lex_state = 281},
  [9954] = {.lex_state = 47, .external_lex_state = 317},
  [9955] = {.lex_state = 51, .external_lex_state = 281},
  [9956] = {.lex_state = 0, .external_lex_state = 249},
  [9957] = {.lex_state = 51, .external_lex_state = 281},
  [9958] = {.lex_state = 51, .external_lex_state = 292},
  [9959] = {.lex_state = 51, .external_lex_state = 281},
  [9960] = {.lex_state = 51, .external_lex_state = 281},
  [9961] = {.lex_state = 51, .external_lex_state = 281},
  [9962] = {.lex_state = 51, .external_lex_state = 281},
  [9963] = {.lex_state = 0, .external_lex_state = 249},
  [9964] = {.lex_state = 0, .external_lex_state = 249},
  [9965] = {.lex_state = 47, .external_lex_state = 269},
  [9966] = {.lex_state = 0, .external_lex_state = 249},
  [9967] = {.lex_state = 51, .external_lex_state = 281},
  [9968] = {.lex_state = 51, .external_lex_state = 281},
  [9969] = {.lex_state = 51, .external_lex_state = 281},
  [9970] = {.lex_state = 0, .external_lex_state = 322},
  [9971] = {.lex_state = 47, .external_lex_state = 314},
  [9972] = {.lex_state = 0, .external_lex_state = 249},
  [9973] = {.lex_state = 0, .external_lex_state = 249},
  [9974] = {.lex_state = 51, .external_lex_state = 338},
  [9975] = {.lex_state = 50, .external_lex_state = 308},
  [9976] = {.lex_state = 47, .external_lex_state = 269},
  [9977] = {.lex_state = 50, .external_lex_state = 308},
  [9978] = {.lex_state = 48, .external_lex_state = 298},
  [9979] = {.lex_state = 50, .external_lex_state = 308},
  [9980] = {.lex_state = 50, .external_lex_state = 308},
  [9981] = {.lex_state = 50, .external_lex_state = 308},
  [9982] = {.lex_state = 0, .external_lex_state = 281},
  [9983] = {.lex_state = 47, .external_lex_state = 339},
  [9984] = {.lex_state = 51, .external_lex_state = 338},
  [9985] = {.lex_state = 50, .external_lex_state = 308},
  [9986] = {.lex_state = 47, .external_lex_state = 269},
  [9987] = {.lex_state = 50, .external_lex_state = 308},
  [9988] = {.lex_state = 50, .external_lex_state = 308},
  [9989] = {.lex_state = 50, .external_lex_state = 308},
  [9990] = {.lex_state = 50, .external_lex_state = 308},
  [9991] = {.lex_state = 50, .external_lex_state = 308},
  [9992] = {.lex_state = 0, .external_lex_state = 281},
  [9993] = {.lex_state = 47, .external_lex_state = 304},
  [9994] = {.lex_state = 50, .external_lex_state = 308},
  [9995] = {.lex_state = 48, .external_lex_state = 298},
  [9996] = {.lex_state = 48, .external_lex_state = 298},
  [9997] = {.lex_state = 48, .external_lex_state = 298},
  [9998] = {.lex_state = 48, .external_lex_state = 298},
  [9999] = {.lex_state = 48, .external_lex_state = 298},
  [10000] = {.lex_state = 0, .external_lex_state = 281},
  [10001] = {.lex_state = 48, .external_lex_state = 298},
  [10002] = {.lex_state = 48, .external_lex_state = 298},
  [10003] = {.lex_state = 48, .external_lex_state = 298},
  [10004] = {.lex_state = 48, .external_lex_state = 298},
  [10005] = {.lex_state = 48, .external_lex_state = 298},
  [10006] = {.lex_state = 50, .external_lex_state = 308},
  [10007] = {.lex_state = 48, .external_lex_state = 298},
  [10008] = {.lex_state = 0, .external_lex_state = 281},
  [10009] = {.lex_state = 48, .external_lex_state = 298},
  [10010] = {.lex_state = 50, .external_lex_state = 308},
  [10011] = {.lex_state = 48, .external_lex_state = 298},
  [10012] = {.lex_state = 47, .external_lex_state = 269},
  [10013] = {.lex_state = 47, .external_lex_state = 269},
  [10014] = {.lex_state = 48, .external_lex_state = 314},
  [10015] = {.lex_state = 47, .external_lex_state = 269},
  [10016] = {.lex_state = 47, .external_lex_state = 301},
  [10017] = {.lex_state = 47, .external_lex_state = 269},
  [10018] = {.lex_state = 48, .external_lex_state = 298},
  [10019] = {.lex_state = 50, .external_lex_state = 308},
  [10020] = {.lex_state = 48, .external_lex_state = 298},
  [10021] = {.lex_state = 47, .external_lex_state = 269},
  [10022] = {.lex_state = 48, .external_lex_state = 298},
  [10023] = {.lex_state = 48, .external_lex_state = 298},
  [10024] = {.lex_state = 48, .external_lex_state = 298},
  [10025] = {.lex_state = 51, .external_lex_state = 338},
  [10026] = {.lex_state = 50, .external_lex_state = 308},
  [10027] = {.lex_state = 48, .external_lex_state = 298},
  [10028] = {.lex_state = 0, .external_lex_state = 281},
  [10029] = {.lex_state = 51, .external_lex_state = 338},
  [10030] = {.lex_state = 0, .external_lex_state = 281},
  [10031] = {.lex_state = 47, .external_lex_state = 340},
  [10032] = {.lex_state = 48, .external_lex_state = 298},
  [10033] = {.lex_state = 48, .external_lex_state = 298},
  [10034] = {.lex_state = 48, .external_lex_state = 298},
  [10035] = {.lex_state = 51, .external_lex_state = 292},
  [10036] = {.lex_state = 47, .external_lex_state = 269},
  [10037] = {.lex_state = 48, .external_lex_state = 298},
  [10038] = {.lex_state = 47, .external_lex_state = 269},
  [10039] = {.lex_state = 48, .external_lex_state = 298},
  [10040] = {.lex_state = 48, .external_lex_state = 298},
  [10041] = {.lex_state = 48, .external_lex_state = 298},
  [10042] = {.lex_state = 48, .external_lex_state = 298},
  [10043] = {.lex_state = 47, .external_lex_state = 269},
  [10044] = {.lex_state = 51, .external_lex_state = 341},
  [10045] = {.lex_state = 48, .external_lex_state = 298},
  [10046] = {.lex_state = 47, .external_lex_state = 269},
  [10047] = {.lex_state = 48, .external_lex_state = 298},
  [10048] = {.lex_state = 48, .external_lex_state = 298},
  [10049] = {.lex_state = 48, .external_lex_state = 298},
  [10050] = {.lex_state = 50, .external_lex_state = 308},
  [10051] = {.lex_state = 48, .external_lex_state = 298},
  [10052] = {.lex_state = 0, .external_lex_state = 281},
  [10053] = {.lex_state = 50, .external_lex_state = 308},
  [10054] = {.lex_state = 48, .external_lex_state = 298},
  [10055] = {.lex_state = 48, .external_lex_state = 298},
  [10056] = {.lex_state = 48, .external_lex_state = 298},
  [10057] = {.lex_state = 51, .external_lex_state = 342},
  [10058] = {.lex_state = 48, .external_lex_state = 298},
  [10059] = {.lex_state = 48, .external_lex_state = 298},
  [10060] = {.lex_state = 50, .external_lex_state = 308},
  [10061] = {.lex_state = 48, .external_lex_state = 298},
  [10062] = {.lex_state = 0, .external_lex_state = 343},
  [10063] = {.lex_state = 0, .external_lex_state = 325},
  [10064] = {.lex_state = 48, .external_lex_state = 298},
  [10065] = {.lex_state = 48, .external_lex_state = 298},
  [10066] = {.lex_state = 51, .external_lex_state = 342},
  [10067] = {.lex_state = 47, .external_lex_state = 303},
  [10068] = {.lex_state = 0, .external_lex_state = 281},
  [10069] = {.lex_state = 50, .external_lex_state = 308},
  [10070] = {.lex_state = 50, .external_lex_state = 308},
  [10071] = {.lex_state = 50, .external_lex_state = 308},
  [10072] = {.lex_state = 50, .external_lex_state = 308},
  [10073] = {.lex_state = 50, .external_lex_state = 308},
  [10074] = {.lex_state = 50, .external_lex_state = 308},
  [10075] = {.lex_state = 50, .external_lex_state = 308},
  [10076] = {.lex_state = 0, .external_lex_state = 281},
  [10077] = {.lex_state = 50, .external_lex_state = 308},
  [10078] = {.lex_state = 47, .external_lex_state = 344},
  [10079] = {.lex_state = 50, .external_lex_state = 308},
  [10080] = {.lex_state = 50, .external_lex_state = 308},
  [10081] = {.lex_state = 50, .external_lex_state = 308},
  [10082] = {.lex_state = 50, .external_lex_state = 308},
  [10083] = {.lex_state = 50, .external_lex_state = 308},
  [10084] = {.lex_state = 50, .external_lex_state = 308},
  [10085] = {.lex_state = 0, .external_lex_state = 322},
  [10086] = {.lex_state = 50, .external_lex_state = 308},
  [10087] = {.lex_state = 50, .external_lex_state = 308},
  [10088] = {.lex_state = 47, .external_lex_state = 303},
  [10089] = {.lex_state = 48, .external_lex_state = 298},
  [10090] = {.lex_state = 50, .external_lex_state = 308},
  [10091] = {.lex_state = 0, .external_lex_state = 281},
  [10092] = {.lex_state = 47, .external_lex_state = 340},
  [10093] = {.lex_state = 47, .external_lex_state = 345},
  [10094] = {.lex_state = 50, .external_lex_state = 308},
  [10095] = {.lex_state = 47, .external_lex_state = 302},
  [10096] = {.lex_state = 47, .external_lex_state = 302},
  [10097] = {.lex_state = 48, .external_lex_state = 346},
  [10098] = {.lex_state = 47, .external_lex_state = 269},
  [10099] = {.lex_state = 50, .external_lex_state = 308},
  [10100] = {.lex_state = 51, .external_lex_state = 281},
  [10101] = {.lex_state = 51, .external_lex_state = 292},
  [10102] = {.lex_state = 0, .external_lex_state = 322},
  [10103] = {.lex_state = 48, .external_lex_state = 346},
  [10104] = {.lex_state = 51, .external_lex_state = 347},
  [10105] = {.lex_state = 51, .external_lex_state = 348},
  [10106] = {.lex_state = 47, .external_lex_state = 349},
  [10107] = {.lex_state = 48, .external_lex_state = 346},
  [10108] = {.lex_state = 50, .external_lex_state = 308},
  [10109] = {.lex_state = 50, .external_lex_state = 308},
  [10110] = {.lex_state = 50, .external_lex_state = 308},
  [10111] = {.lex_state = 50, .external_lex_state = 308},
  [10112] = {.lex_state = 50, .external_lex_state = 308},
  [10113] = {.lex_state = 51, .external_lex_state = 281},
  [10114] = {.lex_state = 51, .external_lex_state = 281},
  [10115] = {.lex_state = 51, .external_lex_state = 281},
  [10116] = {.lex_state = 50, .external_lex_state = 308},
  [10117] = {.lex_state = 47, .external_lex_state = 344},
  [10118] = {.lex_state = 51, .external_lex_state = 348},
  [10119] = {.lex_state = 48, .external_lex_state = 302},
  [10120] = {.lex_state = 48, .external_lex_state = 298},
  [10121] = {.lex_state = 51, .external_lex_state = 292},
  [10122] = {.lex_state = 50, .external_lex_state = 308},
  [10123] = {.lex_state = 47, .external_lex_state = 301},
  [10124] = {.lex_state = 48, .external_lex_state = 298},
  [10125] = {.lex_state = 50, .external_lex_state = 308},
  [10126] = {.lex_state = 51, .external_lex_state = 281},
  [10127] = {.lex_state = 50, .external_lex_state = 308},
  [10128] = {.lex_state = 51, .external_lex_state = 347},
  [10129] = {.lex_state = 50, .external_lex_state = 308},
  [10130] = {.lex_state = 51, .external_lex_state = 292},
  [10131] = {.lex_state = 50, .external_lex_state = 308},
  [10132] = {.lex_state = 50, .external_lex_state = 308},
  [10133] = {.lex_state = 50, .external_lex_state = 308},
  [10134] = {.lex_state = 50, .external_lex_state = 308},
  [10135] = {.lex_state = 50, .external_lex_state = 308},
  [10136] = {.lex_state = 47, .external_lex_state = 315},
  [10137] = {.lex_state = 50, .external_lex_state = 308},
  [10138] = {.lex_state = 50, .external_lex_state = 308},
  [10139] = {.lex_state = 50, .external_lex_state = 308},
  [10140] = {.lex_state = 48, .external_lex_state = 318},
  [10141] = {.lex_state = 50, .external_lex_state = 308},
  [10142] = {.lex_state = 47, .external_lex_state = 350},
  [10143] = {.lex_state = 50, .external_lex_state = 308},
  [10144] = {.lex_state = 50, .external_lex_state = 308},
  [10145] = {.lex_state = 47, .external_lex_state = 269},
  [10146] = {.lex_state = 50, .external_lex_state = 308},
  [10147] = {.lex_state = 47, .external_lex_state = 269},
  [10148] = {.lex_state = 50, .external_lex_state = 308},
  [10149] = {.lex_state = 50, .external_lex_state = 308},
  [10150] = {.lex_state = 50, .external_lex_state = 308},
  [10151] = {.lex_state = 50, .external_lex_state = 308},
  [10152] = {.lex_state = 48, .external_lex_state = 346},
  [10153] = {.lex_state = 47, .external_lex_state = 269},
  [10154] = {.lex_state = 50, .external_lex_state = 308},
  [10155] = {.lex_state = 50, .external_lex_state = 308},
  [10156] = {.lex_state = 51, .external_lex_state = 342},
  [10157] = {.lex_state = 50, .external_lex_state = 308},
  [10158] = {.lex_state = 47, .external_lex_state = 269},
  [10159] = {.lex_state = 50, .external_lex_state = 308},
  [10160] = {.lex_state = 50, .external_lex_state = 308},
  [10161] = {.lex_state = 50, .external_lex_state = 308},
  [10162] = {.lex_state = 50, .external_lex_state = 308},
  [10163] = {.lex_state = 47, .external_lex_state = 269},
  [10164] = {.lex_state = 51, .external_lex_state = 342},
  [10165] = {.lex_state = 50, .external_lex_state = 308},
  [10166] = {.lex_state = 48, .external_lex_state = 351},
  [10167] = {.lex_state = 48, .external_lex_state = 298},
  [10168] = {.lex_state = 50, .external_lex_state = 308},
  [10169] = {.lex_state = 50, .external_lex_state = 308},
  [10170] = {.lex_state = 51, .external_lex_state = 347},
  [10171] = {.lex_state = 51, .external_lex_state = 338},
  [10172] = {.lex_state = 50, .external_lex_state = 308},
  [10173] = {.lex_state = 50, .external_lex_state = 308},
  [10174] = {.lex_state = 51, .external_lex_state = 292},
  [10175] = {.lex_state = 47, .external_lex_state = 350},
  [10176] = {.lex_state = 48, .external_lex_state = 351},
  [10177] = {.lex_state = 50, .external_lex_state = 308},
  [10178] = {.lex_state = 48, .external_lex_state = 302},
  [10179] = {.lex_state = 47, .external_lex_state = 352},
  [10180] = {.lex_state = 50, .external_lex_state = 308},
  [10181] = {.lex_state = 50, .external_lex_state = 308},
  [10182] = {.lex_state = 50, .external_lex_state = 308},
  [10183] = {.lex_state = 51, .external_lex_state = 338},
  [10184] = {.lex_state = 48, .external_lex_state = 298},
  [10185] = {.lex_state = 51, .external_lex_state = 292},
  [10186] = {.lex_state = 50, .external_lex_state = 308},
  [10187] = {.lex_state = 51, .external_lex_state = 353},
  [10188] = {.lex_state = 48, .external_lex_state = 298},
  [10189] = {.lex_state = 50, .external_lex_state = 308},
  [10190] = {.lex_state = 50, .external_lex_state = 308},
  [10191] = {.lex_state = 47, .external_lex_state = 304},
  [10192] = {.lex_state = 48, .external_lex_state = 351},
  [10193] = {.lex_state = 50, .external_lex_state = 308},
  [10194] = {.lex_state = 48, .external_lex_state = 298},
  [10195] = {.lex_state = 50, .external_lex_state = 308},
  [10196] = {.lex_state = 51, .external_lex_state = 292},
  [10197] = {.lex_state = 50, .external_lex_state = 308},
  [10198] = {.lex_state = 50, .external_lex_state = 308},
  [10199] = {.lex_state = 50, .external_lex_state = 308},
  [10200] = {.lex_state = 0, .external_lex_state = 319},
  [10201] = {.lex_state = 50, .external_lex_state = 308},
  [10202] = {.lex_state = 50, .external_lex_state = 308},
  [10203] = {.lex_state = 50, .external_lex_state = 308},
  [10204] = {.lex_state = 50, .external_lex_state = 308},
  [10205] = {.lex_state = 47, .external_lex_state = 339},
  [10206] = {.lex_state = 50, .external_lex_state = 308},
  [10207] = {.lex_state = 50, .external_lex_state = 308},
  [10208] = {.lex_state = 51, .external_lex_state = 342},
  [10209] = {.lex_state = 50, .external_lex_state = 308},
  [10210] = {.lex_state = 48, .external_lex_state = 351},
  [10211] = {.lex_state = 51, .external_lex_state = 353},
  [10212] = {.lex_state = 50, .external_lex_state = 308},
  [10213] = {.lex_state = 50, .external_lex_state = 308},
  [10214] = {.lex_state = 47, .external_lex_state = 344},
  [10215] = {.lex_state = 47, .external_lex_state = 304},
  [10216] = {.lex_state = 48, .external_lex_state = 351},
  [10217] = {.lex_state = 47, .external_lex_state = 269},
  [10218] = {.lex_state = 50, .external_lex_state = 308},
  [10219] = {.lex_state = 50, .external_lex_state = 308},
  [10220] = {.lex_state = 50, .external_lex_state = 308},
  [10221] = {.lex_state = 51, .external_lex_state = 342},
  [10222] = {.lex_state = 48, .external_lex_state = 314},
  [10223] = {.lex_state = 51, .external_lex_state = 353},
  [10224] = {.lex_state = 50, .external_lex_state = 308},
  [10225] = {.lex_state = 51, .external_lex_state = 353},
  [10226] = {.lex_state = 50, .external_lex_state = 308},
  [10227] = {.lex_state = 50, .external_lex_state = 308},
  [10228] = {.lex_state = 50, .external_lex_state = 308},
  [10229] = {.lex_state = 51, .external_lex_state = 292},
  [10230] = {.lex_state = 51, .external_lex_state = 341},
  [10231] = {.lex_state = 51, .external_lex_state = 292},
  [10232] = {.lex_state = 50, .external_lex_state = 308},
  [10233] = {.lex_state = 48, .external_lex_state = 298},
  [10234] = {.lex_state = 47, .external_lex_state = 345},
  [10235] = {.lex_state = 0, .external_lex_state = 318},
  [10236] = {.lex_state = 48, .external_lex_state = 298},
  [10237] = {.lex_state = 48, .external_lex_state = 298},
  [10238] = {.lex_state = 48, .external_lex_state = 298},
  [10239] = {.lex_state = 48, .external_lex_state = 298},
  [10240] = {.lex_state = 48, .external_lex_state = 298},
  [10241] = {.lex_state = 48, .external_lex_state = 298},
  [10242] = {.lex_state = 48, .external_lex_state = 298},
  [10243] = {.lex_state = 48, .external_lex_state = 298},
  [10244] = {.lex_state = 47, .external_lex_state = 249},
  [10245] = {.lex_state = 50, .external_lex_state = 308},
  [10246] = {.lex_state = 48, .external_lex_state = 298},
  [10247] = {.lex_state = 48, .external_lex_state = 318},
  [10248] = {.lex_state = 48, .external_lex_state = 298},
  [10249] = {.lex_state = 48, .external_lex_state = 298},
  [10250] = {.lex_state = 48, .external_lex_state = 298},
  [10251] = {.lex_state = 50, .external_lex_state = 308},
  [10252] = {.lex_state = 50, .external_lex_state = 308},
  [10253] = {.lex_state = 47, .external_lex_state = 349},
  [10254] = {.lex_state = 47, .external_lex_state = 302},
  [10255] = {.lex_state = 48, .external_lex_state = 298},
  [10256] = {.lex_state = 50, .external_lex_state = 308},
  [10257] = {.lex_state = 48, .external_lex_state = 298},
  [10258] = {.lex_state = 48, .external_lex_state = 298},
  [10259] = {.lex_state = 50, .external_lex_state = 308},
  [10260] = {.lex_state = 50, .external_lex_state = 308},
  [10261] = {.lex_state = 48, .external_lex_state = 313},
  [10262] = {.lex_state = 50, .external_lex_state = 308},
  [10263] = {.lex_state = 50, .external_lex_state = 308},
  [10264] = {.lex_state = 51, .external_lex_state = 292},
  [10265] = {.lex_state = 51, .external_lex_state = 353},
  [10266] = {.lex_state = 50, .external_lex_state = 308},
  [10267] = {.lex_state = 51, .external_lex_state = 292},
  [10268] = {.lex_state = 47, .external_lex_state = 249},
  [10269] = {.lex_state = 50, .external_lex_state = 308},
  [10270] = {.lex_state = 51, .external_lex_state = 353},
  [10271] = {.lex_state = 48, .external_lex_state = 298},
  [10272] = {.lex_state = 50, .external_lex_state = 308},
  [10273] = {.lex_state = 50, .external_lex_state = 308},
  [10274] = {.lex_state = 47, .external_lex_state = 302},
  [10275] = {.lex_state = 51, .external_lex_state = 292},
  [10276] = {.lex_state = 50, .external_lex_state = 308},
  [10277] = {.lex_state = 50, .external_lex_state = 308},
  [10278] = {.lex_state = 50, .external_lex_state = 308},
  [10279] = {.lex_state = 50, .external_lex_state = 308},
  [10280] = {.lex_state = 0, .external_lex_state = 319},
  [10281] = {.lex_state = 47, .external_lex_state = 303},
  [10282] = {.lex_state = 48, .external_lex_state = 351},
  [10283] = {.lex_state = 50, .external_lex_state = 308},
  [10284] = {.lex_state = 50, .external_lex_state = 308},
  [10285] = {.lex_state = 47, .external_lex_state = 344},
  [10286] = {.lex_state = 50, .external_lex_state = 308},
  [10287] = {.lex_state = 50, .external_lex_state = 308},
  [10288] = {.lex_state = 50, .external_lex_state = 308},
  [10289] = {.lex_state = 47, .external_lex_state = 345},
  [10290] = {.lex_state = 51, .external_lex_state = 348},
  [10291] = {.lex_state = 50, .external_lex_state = 308},
  [10292] = {.lex_state = 50, .external_lex_state = 308},
  [10293] = {.lex_state = 47, .external_lex_state = 352},
  [10294] = {.lex_state = 48, .external_lex_state = 346},
  [10295] = {.lex_state = 50, .external_lex_state = 308},
  [10296] = {.lex_state = 51, .external_lex_state = 341},
  [10297] = {.lex_state = 50, .external_lex_state = 308},
  [10298] = {.lex_state = 50, .external_lex_state = 308},
  [10299] = {.lex_state = 50, .external_lex_state = 308},
  [10300] = {.lex_state = 47, .external_lex_state = 345},
  [10301] = {.lex_state = 47, .external_lex_state = 249},
  [10302] = {.lex_state = 47, .external_lex_state = 301},
  [10303] = {.lex_state = 48, .external_lex_state = 313},
  [10304] = {.lex_state = 50, .external_lex_state = 308},
  [10305] = {.lex_state = 50, .external_lex_state = 308},
  [10306] = {.lex_state = 48, .external_lex_state = 346},
  [10307] = {.lex_state = 50, .external_lex_state = 308},
  [10308] = {.lex_state = 50, .external_lex_state = 308},
  [10309] = {.lex_state = 48, .external_lex_state = 302},
  [10310] = {.lex_state = 50, .external_lex_state = 308},
  [10311] = {.lex_state = 47, .external_lex_state = 308},
  [10312] = {.lex_state = 47, .external_lex_state = 308},
  [10313] = {.lex_state = 50, .external_lex_state = 308},
  [10314] = {.lex_state = 0, .external_lex_state = 281},
  [10315] = {.lex_state = 50, .external_lex_state = 308},
  [10316] = {.lex_state = 0, .external_lex_state = 318},
  [10317] = {.lex_state = 50, .external_lex_state = 308},
  [10318] = {.lex_state = 47, .external_lex_state = 308},
  [10319] = {.lex_state = 51, .external_lex_state = 318},
  [10320] = {.lex_state = 51, .external_lex_state = 302},
  [10321] = {.lex_state = 48, .external_lex_state = 303},
  [10322] = {.lex_state = 0, .external_lex_state = 281},
  [10323] = {.lex_state = 0, .external_lex_state = 281},
  [10324] = {.lex_state = 48, .external_lex_state = 354},
  [10325] = {.lex_state = 51, .external_lex_state = 313},
  [10326] = {.lex_state = 51, .external_lex_state = 302},
  [10327] = {.lex_state = 48, .external_lex_state = 305},
  [10328] = {.lex_state = 51, .external_lex_state = 313},
  [10329] = {.lex_state = 51, .external_lex_state = 302},
  [10330] = {.lex_state = 47, .external_lex_state = 355},
  [10331] = {.lex_state = 48, .external_lex_state = 303},
  [10332] = {.lex_state = 51, .external_lex_state = 304},
  [10333] = {.lex_state = 51, .external_lex_state = 301},
  [10334] = {.lex_state = 51, .external_lex_state = 301},
  [10335] = {.lex_state = 47, .external_lex_state = 356},
  [10336] = {.lex_state = 51, .external_lex_state = 301},
  [10337] = {.lex_state = 0, .external_lex_state = 325},
  [10338] = {.lex_state = 0, .external_lex_state = 357},
  [10339] = {.lex_state = 48, .external_lex_state = 303},
  [10340] = {.lex_state = 48, .external_lex_state = 305},
  [10341] = {.lex_state = 48, .external_lex_state = 303},
  [10342] = {.lex_state = 51, .external_lex_state = 292},
  [10343] = {.lex_state = 48, .external_lex_state = 354},
  [10344] = {.lex_state = 48, .external_lex_state = 303},
  [10345] = {.lex_state = 47, .external_lex_state = 355},
  [10346] = {.lex_state = 48, .external_lex_state = 303},
  [10347] = {.lex_state = 51, .external_lex_state = 302},
  [10348] = {.lex_state = 51, .external_lex_state = 292},
  [10349] = {.lex_state = 48, .external_lex_state = 303},
  [10350] = {.lex_state = 48, .external_lex_state = 305},
  [10351] = {.lex_state = 51, .external_lex_state = 292},
  [10352] = {.lex_state = 48, .external_lex_state = 303},
  [10353] = {.lex_state = 47, .external_lex_state = 358},
  [10354] = {.lex_state = 48, .external_lex_state = 303},
  [10355] = {.lex_state = 48, .external_lex_state = 354},
  [10356] = {.lex_state = 48, .external_lex_state = 303},
  [10357] = {.lex_state = 48, .external_lex_state = 303},
  [10358] = {.lex_state = 48, .external_lex_state = 303},
  [10359] = {.lex_state = 51, .external_lex_state = 302},
  [10360] = {.lex_state = 51, .external_lex_state = 313},
  [10361] = {.lex_state = 48, .external_lex_state = 303},
  [10362] = {.lex_state = 51, .external_lex_state = 313},
  [10363] = {.lex_state = 48, .external_lex_state = 305},
  [10364] = {.lex_state = 48, .external_lex_state = 305},
  [10365] = {.lex_state = 47, .external_lex_state = 317},
  [10366] = {.lex_state = 51, .external_lex_state = 359},
  [10367] = {.lex_state = 0, .external_lex_state = 360},
  [10368] = {.lex_state = 51, .external_lex_state = 302},
  [10369] = {.lex_state = 0, .external_lex_state = 281},
  [10370] = {.lex_state = 51, .external_lex_state = 361},
  [10371] = {.lex_state = 51, .external_lex_state = 313},
  [10372] = {.lex_state = 51, .external_lex_state = 304},
  [10373] = {.lex_state = 47, .external_lex_state = 356},
  [10374] = {.lex_state = 48, .external_lex_state = 303},
  [10375] = {.lex_state = 51, .external_lex_state = 362},
  [10376] = {.lex_state = 51, .external_lex_state = 314},
  [10377] = {.lex_state = 51, .external_lex_state = 313},
  [10378] = {.lex_state = 51, .external_lex_state = 304},
  [10379] = {.lex_state = 51, .external_lex_state = 314},
  [10380] = {.lex_state = 51, .external_lex_state = 304},
  [10381] = {.lex_state = 51, .external_lex_state = 313},
  [10382] = {.lex_state = 47, .external_lex_state = 315},
  [10383] = {.lex_state = 48, .external_lex_state = 303},
  [10384] = {.lex_state = 51, .external_lex_state = 313},
  [10385] = {.lex_state = 51, .external_lex_state = 359},
  [10386] = {.lex_state = 51, .external_lex_state = 304},
  [10387] = {.lex_state = 48, .external_lex_state = 303},
  [10388] = {.lex_state = 51, .external_lex_state = 302},
  [10389] = {.lex_state = 51, .external_lex_state = 304},
  [10390] = {.lex_state = 51, .external_lex_state = 302},
  [10391] = {.lex_state = 47, .external_lex_state = 313},
  [10392] = {.lex_state = 0, .external_lex_state = 281},
  [10393] = {.lex_state = 51, .external_lex_state = 304},
  [10394] = {.lex_state = 51, .external_lex_state = 314},
  [10395] = {.lex_state = 0, .external_lex_state = 281},
  [10396] = {.lex_state = 51, .external_lex_state = 347},
  [10397] = {.lex_state = 0, .external_lex_state = 281},
  [10398] = {.lex_state = 48, .external_lex_state = 303},
  [10399] = {.lex_state = 51, .external_lex_state = 304},
  [10400] = {.lex_state = 51, .external_lex_state = 304},
  [10401] = {.lex_state = 51, .external_lex_state = 314},
  [10402] = {.lex_state = 47, .external_lex_state = 315},
  [10403] = {.lex_state = 51, .external_lex_state = 361},
  [10404] = {.lex_state = 51, .external_lex_state = 302},
  [10405] = {.lex_state = 48, .external_lex_state = 303},
  [10406] = {.lex_state = 47, .external_lex_state = 363},
  [10407] = {.lex_state = 48, .external_lex_state = 303},
  [10408] = {.lex_state = 51, .external_lex_state = 304},
  [10409] = {.lex_state = 51, .external_lex_state = 347},
  [10410] = {.lex_state = 51, .external_lex_state = 302},
  [10411] = {.lex_state = 48, .external_lex_state = 303},
  [10412] = {.lex_state = 48, .external_lex_state = 303},
  [10413] = {.lex_state = 51, .external_lex_state = 362},
  [10414] = {.lex_state = 51, .external_lex_state = 302},
  [10415] = {.lex_state = 51, .external_lex_state = 302},
  [10416] = {.lex_state = 0, .external_lex_state = 188},
  [10417] = {.lex_state = 51, .external_lex_state = 362},
  [10418] = {.lex_state = 51, .external_lex_state = 304},
  [10419] = {.lex_state = 48, .external_lex_state = 315},
  [10420] = {.lex_state = 51, .external_lex_state = 302},
  [10421] = {.lex_state = 51, .external_lex_state = 318},
  [10422] = {.lex_state = 51, .external_lex_state = 301},
  [10423] = {.lex_state = 51, .external_lex_state = 364},
  [10424] = {.lex_state = 48, .external_lex_state = 303},
  [10425] = {.lex_state = 48, .external_lex_state = 303},
  [10426] = {.lex_state = 0, .external_lex_state = 357},
  [10427] = {.lex_state = 51, .external_lex_state = 301},
  [10428] = {.lex_state = 47, .external_lex_state = 314},
  [10429] = {.lex_state = 47, .external_lex_state = 313},
  [10430] = {.lex_state = 51, .external_lex_state = 301},
  [10431] = {.lex_state = 51, .external_lex_state = 301},
  [10432] = {.lex_state = 51, .external_lex_state = 301},
  [10433] = {.lex_state = 51, .external_lex_state = 301},
  [10434] = {.lex_state = 48, .external_lex_state = 303},
  [10435] = {.lex_state = 48, .external_lex_state = 303},
  [10436] = {.lex_state = 51, .external_lex_state = 365},
  [10437] = {.lex_state = 51, .external_lex_state = 301},
  [10438] = {.lex_state = 51, .external_lex_state = 301},
  [10439] = {.lex_state = 51, .external_lex_state = 301},
  [10440] = {.lex_state = 51, .external_lex_state = 301},
  [10441] = {.lex_state = 51, .external_lex_state = 313},
  [10442] = {.lex_state = 51, .external_lex_state = 301},
  [10443] = {.lex_state = 51, .external_lex_state = 301},
  [10444] = {.lex_state = 51, .external_lex_state = 301},
  [10445] = {.lex_state = 47, .external_lex_state = 366},
  [10446] = {.lex_state = 47, .external_lex_state = 366},
  [10447] = {.lex_state = 51, .external_lex_state = 301},
  [10448] = {.lex_state = 51, .external_lex_state = 301},
  [10449] = {.lex_state = 48, .external_lex_state = 303},
  [10450] = {.lex_state = 51, .external_lex_state = 301},
  [10451] = {.lex_state = 51, .external_lex_state = 301},
  [10452] = {.lex_state = 51, .external_lex_state = 301},
  [10453] = {.lex_state = 51, .external_lex_state = 301},
  [10454] = {.lex_state = 51, .external_lex_state = 301},
  [10455] = {.lex_state = 48, .external_lex_state = 305},
  [10456] = {.lex_state = 48, .external_lex_state = 303},
  [10457] = {.lex_state = 51, .external_lex_state = 301},
  [10458] = {.lex_state = 51, .external_lex_state = 301},
  [10459] = {.lex_state = 51, .external_lex_state = 301},
  [10460] = {.lex_state = 51, .external_lex_state = 301},
  [10461] = {.lex_state = 51, .external_lex_state = 301},
  [10462] = {.lex_state = 51, .external_lex_state = 301},
  [10463] = {.lex_state = 51, .external_lex_state = 301},
  [10464] = {.lex_state = 48, .external_lex_state = 303},
  [10465] = {.lex_state = 51, .external_lex_state = 301},
  [10466] = {.lex_state = 51, .external_lex_state = 301},
  [10467] = {.lex_state = 48, .external_lex_state = 303},
  [10468] = {.lex_state = 51, .external_lex_state = 301},
  [10469] = {.lex_state = 51, .external_lex_state = 301},
  [10470] = {.lex_state = 0, .external_lex_state = 367},
  [10471] = {.lex_state = 51, .external_lex_state = 301},
  [10472] = {.lex_state = 51, .external_lex_state = 301},
  [10473] = {.lex_state = 51, .external_lex_state = 301},
  [10474] = {.lex_state = 51, .external_lex_state = 301},
  [10475] = {.lex_state = 51, .external_lex_state = 301},
  [10476] = {.lex_state = 51, .external_lex_state = 301},
  [10477] = {.lex_state = 51, .external_lex_state = 301},
  [10478] = {.lex_state = 51, .external_lex_state = 301},
  [10479] = {.lex_state = 51, .external_lex_state = 301},
  [10480] = {.lex_state = 51, .external_lex_state = 301},
  [10481] = {.lex_state = 51, .external_lex_state = 301},
  [10482] = {.lex_state = 51, .external_lex_state = 301},
  [10483] = {.lex_state = 51, .external_lex_state = 301},
  [10484] = {.lex_state = 51, .external_lex_state = 301},
  [10485] = {.lex_state = 51, .external_lex_state = 368},
  [10486] = {.lex_state = 48, .external_lex_state = 303},
  [10487] = {.lex_state = 51, .external_lex_state = 301},
  [10488] = {.lex_state = 48, .external_lex_state = 303},
  [10489] = {.lex_state = 51, .external_lex_state = 301},
  [10490] = {.lex_state = 51, .external_lex_state = 301},
  [10491] = {.lex_state = 51, .external_lex_state = 301},
  [10492] = {.lex_state = 51, .external_lex_state = 301},
  [10493] = {.lex_state = 48, .external_lex_state = 303},
  [10494] = {.lex_state = 51, .external_lex_state = 301},
  [10495] = {.lex_state = 48, .external_lex_state = 305},
  [10496] = {.lex_state = 51, .external_lex_state = 301},
  [10497] = {.lex_state = 51, .external_lex_state = 301},
  [10498] = {.lex_state = 48, .external_lex_state = 303},
  [10499] = {.lex_state = 51, .external_lex_state = 318},
  [10500] = {.lex_state = 51, .external_lex_state = 302},
  [10501] = {.lex_state = 48, .external_lex_state = 305},
  [10502] = {.lex_state = 51, .external_lex_state = 301},
  [10503] = {.lex_state = 48, .external_lex_state = 305},
  [10504] = {.lex_state = 48, .external_lex_state = 303},
  [10505] = {.lex_state = 51, .external_lex_state = 368},
  [10506] = {.lex_state = 48, .external_lex_state = 303},
  [10507] = {.lex_state = 51, .external_lex_state = 292},
  [10508] = {.lex_state = 51, .external_lex_state = 301},
  [10509] = {.lex_state = 48, .external_lex_state = 305},
  [10510] = {.lex_state = 0, .external_lex_state = 325},
  [10511] = {.lex_state = 51, .external_lex_state = 304},
  [10512] = {.lex_state = 48, .external_lex_state = 305},
  [10513] = {.lex_state = 51, .external_lex_state = 301},
  [10514] = {.lex_state = 51, .external_lex_state = 292},
  [10515] = {.lex_state = 48, .external_lex_state = 303},
  [10516] = {.lex_state = 48, .external_lex_state = 305},
  [10517] = {.lex_state = 0, .external_lex_state = 281},
  [10518] = {.lex_state = 51, .external_lex_state = 314},
  [10519] = {.lex_state = 51, .external_lex_state = 341},
  [10520] = {.lex_state = 51, .external_lex_state = 361},
  [10521] = {.lex_state = 48, .external_lex_state = 303},
  [10522] = {.lex_state = 48, .external_lex_state = 305},
  [10523] = {.lex_state = 48, .external_lex_state = 305},
  [10524] = {.lex_state = 48, .external_lex_state = 303},
  [10525] = {.lex_state = 51, .external_lex_state = 347},
  [10526] = {.lex_state = 51, .external_lex_state = 302},
  [10527] = {.lex_state = 48, .external_lex_state = 303},
  [10528] = {.lex_state = 51, .external_lex_state = 313},
  [10529] = {.lex_state = 48, .external_lex_state = 303},
  [10530] = {.lex_state = 0, .external_lex_state = 281},
  [10531] = {.lex_state = 48, .external_lex_state = 305},
  [10532] = {.lex_state = 48, .external_lex_state = 303},
  [10533] = {.lex_state = 48, .external_lex_state = 303},
  [10534] = {.lex_state = 48, .external_lex_state = 303},
  [10535] = {.lex_state = 48, .external_lex_state = 303},
  [10536] = {.lex_state = 47, .external_lex_state = 355},
  [10537] = {.lex_state = 51, .external_lex_state = 301},
  [10538] = {.lex_state = 51, .external_lex_state = 302},
  [10539] = {.lex_state = 51, .external_lex_state = 361},
  [10540] = {.lex_state = 51, .external_lex_state = 369},
  [10541] = {.lex_state = 51, .external_lex_state = 368},
  [10542] = {.lex_state = 51, .external_lex_state = 318},
  [10543] = {.lex_state = 51, .external_lex_state = 318},
  [10544] = {.lex_state = 51, .external_lex_state = 318},
  [10545] = {.lex_state = 51, .external_lex_state = 364},
  [10546] = {.lex_state = 51, .external_lex_state = 314},
  [10547] = {.lex_state = 51, .external_lex_state = 341},
  [10548] = {.lex_state = 48, .external_lex_state = 249},
  [10549] = {.lex_state = 51, .external_lex_state = 359},
  [10550] = {.lex_state = 51, .external_lex_state = 341},
  [10551] = {.lex_state = 48, .external_lex_state = 303},
  [10552] = {.lex_state = 51, .external_lex_state = 304},
  [10553] = {.lex_state = 47, .external_lex_state = 355},
  [10554] = {.lex_state = 51, .external_lex_state = 301},
  [10555] = {.lex_state = 51, .external_lex_state = 301},
  [10556] = {.lex_state = 48, .external_lex_state = 303},
  [10557] = {.lex_state = 51, .external_lex_state = 304},
  [10558] = {.lex_state = 48, .external_lex_state = 303},
  [10559] = {.lex_state = 51, .external_lex_state = 318},
  [10560] = {.lex_state = 51, .external_lex_state = 302},
  [10561] = {.lex_state = 48, .external_lex_state = 303},
  [10562] = {.lex_state = 51, .external_lex_state = 359},
  [10563] = {.lex_state = 48, .external_lex_state = 303},
  [10564] = {.lex_state = 51, .external_lex_state = 304},
  [10565] = {.lex_state = 51, .external_lex_state = 292},
  [10566] = {.lex_state = 50, .external_lex_state = 308},
  [10567] = {.lex_state = 51, .external_lex_state = 313},
  [10568] = {.lex_state = 48, .external_lex_state = 303},
  [10569] = {.lex_state = 51, .external_lex_state = 304},
  [10570] = {.lex_state = 51, .external_lex_state = 364},
  [10571] = {.lex_state = 48, .external_lex_state = 303},
  [10572] = {.lex_state = 51, .external_lex_state = 314},
  [10573] = {.lex_state = 51, .external_lex_state = 314},
  [10574] = {.lex_state = 51, .external_lex_state = 313},
  [10575] = {.lex_state = 51, .external_lex_state = 314},
  [10576] = {.lex_state = 48, .external_lex_state = 303},
  [10577] = {.lex_state = 48, .external_lex_state = 303},
  [10578] = {.lex_state = 51, .external_lex_state = 301},
  [10579] = {.lex_state = 51, .external_lex_state = 314},
  [10580] = {.lex_state = 51, .external_lex_state = 314},
  [10581] = {.lex_state = 51, .external_lex_state = 314},
  [10582] = {.lex_state = 47, .external_lex_state = 243},
  [10583] = {.lex_state = 51, .external_lex_state = 314},
  [10584] = {.lex_state = 51, .external_lex_state = 304},
  [10585] = {.lex_state = 48, .external_lex_state = 303},
  [10586] = {.lex_state = 51, .external_lex_state = 318},
  [10587] = {.lex_state = 48, .external_lex_state = 354},
  [10588] = {.lex_state = 51, .external_lex_state = 362},
  [10589] = {.lex_state = 51, .external_lex_state = 302},
  [10590] = {.lex_state = 51, .external_lex_state = 314},
  [10591] = {.lex_state = 51, .external_lex_state = 302},
  [10592] = {.lex_state = 48, .external_lex_state = 315},
  [10593] = {.lex_state = 51, .external_lex_state = 302},
  [10594] = {.lex_state = 51, .external_lex_state = 302},
  [10595] = {.lex_state = 48, .external_lex_state = 303},
  [10596] = {.lex_state = 51, .external_lex_state = 304},
  [10597] = {.lex_state = 51, .external_lex_state = 304},
  [10598] = {.lex_state = 51, .external_lex_state = 302},
  [10599] = {.lex_state = 48, .external_lex_state = 303},
  [10600] = {.lex_state = 48, .external_lex_state = 303},
  [10601] = {.lex_state = 48, .external_lex_state = 303},
  [10602] = {.lex_state = 48, .external_lex_state = 303},
  [10603] = {.lex_state = 48, .external_lex_state = 303},
  [10604] = {.lex_state = 51, .external_lex_state = 318},
  [10605] = {.lex_state = 47, .external_lex_state = 313},
  [10606] = {.lex_state = 51, .external_lex_state = 302},
  [10607] = {.lex_state = 51, .external_lex_state = 302},
  [10608] = {.lex_state = 51, .external_lex_state = 313},
  [10609] = {.lex_state = 51, .external_lex_state = 304},
  [10610] = {.lex_state = 51, .external_lex_state = 318},
  [10611] = {.lex_state = 51, .external_lex_state = 368},
  [10612] = {.lex_state = 51, .external_lex_state = 313},
  [10613] = {.lex_state = 47, .external_lex_state = 314},
  [10614] = {.lex_state = 51, .external_lex_state = 362},
  [10615] = {.lex_state = 48, .external_lex_state = 303},
  [10616] = {.lex_state = 48, .external_lex_state = 303},
  [10617] = {.lex_state = 51, .external_lex_state = 361},
  [10618] = {.lex_state = 51, .external_lex_state = 292},
  [10619] = {.lex_state = 51, .external_lex_state = 302},
  [10620] = {.lex_state = 51, .external_lex_state = 364},
  [10621] = {.lex_state = 51, .external_lex_state = 313},
  [10622] = {.lex_state = 51, .external_lex_state = 302},
  [10623] = {.lex_state = 51, .external_lex_state = 302},
  [10624] = {.lex_state = 51, .external_lex_state = 318},
  [10625] = {.lex_state = 51, .external_lex_state = 292},
  [10626] = {.lex_state = 51, .external_lex_state = 302},
  [10627] = {.lex_state = 51, .external_lex_state = 318},
  [10628] = {.lex_state = 51, .external_lex_state = 361},
  [10629] = {.lex_state = 48, .external_lex_state = 303},
  [10630] = {.lex_state = 48, .external_lex_state = 303},
  [10631] = {.lex_state = 51, .external_lex_state = 292},
  [10632] = {.lex_state = 51, .external_lex_state = 292},
  [10633] = {.lex_state = 51, .external_lex_state = 304},
  [10634] = {.lex_state = 51, .external_lex_state = 292},
  [10635] = {.lex_state = 48, .external_lex_state = 315},
  [10636] = {.lex_state = 51, .external_lex_state = 292},
  [10637] = {.lex_state = 51, .external_lex_state = 304},
  [10638] = {.lex_state = 51, .external_lex_state = 292},
  [10639] = {.lex_state = 51, .external_lex_state = 318},
  [10640] = {.lex_state = 51, .external_lex_state = 313},
  [10641] = {.lex_state = 51, .external_lex_state = 313},
  [10642] = {.lex_state = 51, .external_lex_state = 318},
  [10643] = {.lex_state = 51, .external_lex_state = 302},
  [10644] = {.lex_state = 51, .external_lex_state = 313},
  [10645] = {.lex_state = 51, .external_lex_state = 304},
  [10646] = {.lex_state = 51, .external_lex_state = 304},
  [10647] = {.lex_state = 51, .external_lex_state = 292},
  [10648] = {.lex_state = 51, .external_lex_state = 304},
  [10649] = {.lex_state = 51, .external_lex_state = 301},
  [10650] = {.lex_state = 51, .external_lex_state = 304},
  [10651] = {.lex_state = 51, .external_lex_state = 368},
  [10652] = {.lex_state = 47, .external_lex_state = 370},
  [10653] = {.lex_state = 51, .external_lex_state = 304},
  [10654] = {.lex_state = 51, .external_lex_state = 302},
  [10655] = {.lex_state = 51, .external_lex_state = 302},
  [10656] = {.lex_state = 51, .external_lex_state = 304},
  [10657] = {.lex_state = 51, .external_lex_state = 302},
  [10658] = {.lex_state = 51, .external_lex_state = 318},
  [10659] = {.lex_state = 51, .external_lex_state = 302},
  [10660] = {.lex_state = 51, .external_lex_state = 318},
  [10661] = {.lex_state = 51, .external_lex_state = 318},
  [10662] = {.lex_state = 51, .external_lex_state = 304},
  [10663] = {.lex_state = 51, .external_lex_state = 314},
  [10664] = {.lex_state = 47, .external_lex_state = 370},
  [10665] = {.lex_state = 51, .external_lex_state = 368},
  [10666] = {.lex_state = 48, .external_lex_state = 325},
  [10667] = {.lex_state = 47, .external_lex_state = 298},
  [10668] = {.lex_state = 48, .external_lex_state = 305},
  [10669] = {.lex_state = 51, .external_lex_state = 304},
  [10670] = {.lex_state = 51, .external_lex_state = 302},
  [10671] = {.lex_state = 51, .external_lex_state = 369},
  [10672] = {.lex_state = 51, .external_lex_state = 314},
  [10673] = {.lex_state = 51, .external_lex_state = 304},
  [10674] = {.lex_state = 47, .external_lex_state = 315},
  [10675] = {.lex_state = 51, .external_lex_state = 314},
  [10676] = {.lex_state = 51, .external_lex_state = 302},
  [10677] = {.lex_state = 51, .external_lex_state = 318},
  [10678] = {.lex_state = 51, .external_lex_state = 304},
  [10679] = {.lex_state = 51, .external_lex_state = 304},
  [10680] = {.lex_state = 51, .external_lex_state = 318},
  [10681] = {.lex_state = 51, .external_lex_state = 314},
  [10682] = {.lex_state = 51, .external_lex_state = 314},
  [10683] = {.lex_state = 51, .external_lex_state = 302},
  [10684] = {.lex_state = 51, .external_lex_state = 301},
  [10685] = {.lex_state = 51, .external_lex_state = 302},
  [10686] = {.lex_state = 51, .external_lex_state = 318},
  [10687] = {.lex_state = 47, .external_lex_state = 298},
  [10688] = {.lex_state = 47, .external_lex_state = 317},
  [10689] = {.lex_state = 51, .external_lex_state = 302},
  [10690] = {.lex_state = 48, .external_lex_state = 325},
  [10691] = {.lex_state = 51, .external_lex_state = 304},
  [10692] = {.lex_state = 51, .external_lex_state = 302},
  [10693] = {.lex_state = 51, .external_lex_state = 302},
  [10694] = {.lex_state = 51, .external_lex_state = 302},
  [10695] = {.lex_state = 51, .external_lex_state = 302},
  [10696] = {.lex_state = 51, .external_lex_state = 302},
  [10697] = {.lex_state = 51, .external_lex_state = 302},
  [10698] = {.lex_state = 51, .external_lex_state = 304},
  [10699] = {.lex_state = 51, .external_lex_state = 314},
  [10700] = {.lex_state = 0, .external_lex_state = 281},
  [10701] = {.lex_state = 0, .external_lex_state = 281},
  [10702] = {.lex_state = 51, .external_lex_state = 314},
  [10703] = {.lex_state = 51, .external_lex_state = 362},
  [10704] = {.lex_state = 0, .external_lex_state = 281},
  [10705] = {.lex_state = 51, .external_lex_state = 302},
  [10706] = {.lex_state = 0, .external_lex_state = 281},
  [10707] = {.lex_state = 0, .external_lex_state = 281},
  [10708] = {.lex_state = 51, .external_lex_state = 302},
  [10709] = {.lex_state = 0, .external_lex_state = 281},
  [10710] = {.lex_state = 47, .external_lex_state = 358},
  [10711] = {.lex_state = 51, .external_lex_state = 302},
  [10712] = {.lex_state = 51, .external_lex_state = 359},
  [10713] = {.lex_state = 51, .external_lex_state = 302},
  [10714] = {.lex_state = 51, .external_lex_state = 304},
  [10715] = {.lex_state = 51, .external_lex_state = 318},
  [10716] = {.lex_state = 51, .external_lex_state = 302},
  [10717] = {.lex_state = 51, .external_lex_state = 302},
  [10718] = {.lex_state = 1, .external_lex_state = 308},
  [10719] = {.lex_state = 51, .external_lex_state = 304},
  [10720] = {.lex_state = 51, .external_lex_state = 304},
  [10721] = {.lex_state = 48, .external_lex_state = 305},
  [10722] = {.lex_state = 51, .external_lex_state = 302},
  [10723] = {.lex_state = 48, .external_lex_state = 305},
  [10724] = {.lex_state = 0, .external_lex_state = 367},
  [10725] = {.lex_state = 0, .external_lex_state = 281},
  [10726] = {.lex_state = 48, .external_lex_state = 305},
  [10727] = {.lex_state = 51, .external_lex_state = 313},
  [10728] = {.lex_state = 51, .external_lex_state = 302},
  [10729] = {.lex_state = 51, .external_lex_state = 302},
  [10730] = {.lex_state = 51, .external_lex_state = 302},
  [10731] = {.lex_state = 48, .external_lex_state = 305},
  [10732] = {.lex_state = 51, .external_lex_state = 364},
  [10733] = {.lex_state = 51, .external_lex_state = 304},
  [10734] = {.lex_state = 48, .external_lex_state = 305},
  [10735] = {.lex_state = 51, .external_lex_state = 302},
  [10736] = {.lex_state = 51, .external_lex_state = 304},
  [10737] = {.lex_state = 51, .external_lex_state = 302},
  [10738] = {.lex_state = 48, .external_lex_state = 305},
  [10739] = {.lex_state = 48, .external_lex_state = 305},
  [10740] = {.lex_state = 51, .external_lex_state = 292},
  [10741] = {.lex_state = 51, .external_lex_state = 292},
  [10742] = {.lex_state = 48, .external_lex_state = 305},
  [10743] = {.lex_state = 48, .external_lex_state = 305},
  [10744] = {.lex_state = 48, .external_lex_state = 305},
  [10745] = {.lex_state = 51, .external_lex_state = 304},
  [10746] = {.lex_state = 51, .external_lex_state = 304},
  [10747] = {.lex_state = 48, .external_lex_state = 305},
  [10748] = {.lex_state = 51, .external_lex_state = 313},
  [10749] = {.lex_state = 48, .external_lex_state = 305},
  [10750] = {.lex_state = 47, .external_lex_state = 298},
  [10751] = {.lex_state = 47, .external_lex_state = 298},
  [10752] = {.lex_state = 47, .external_lex_state = 298},
  [10753] = {.lex_state = 48, .external_lex_state = 305},
  [10754] = {.lex_state = 47, .external_lex_state = 298},
  [10755] = {.lex_state = 48, .external_lex_state = 305},
  [10756] = {.lex_state = 48, .external_lex_state = 354},
  [10757] = {.lex_state = 51, .external_lex_state = 304},
  [10758] = {.lex_state = 47, .external_lex_state = 298},
  [10759] = {.lex_state = 47, .external_lex_state = 298},
  [10760] = {.lex_state = 48, .external_lex_state = 305},
  [10761] = {.lex_state = 51, .external_lex_state = 304},
  [10762] = {.lex_state = 48, .external_lex_state = 305},
  [10763] = {.lex_state = 48, .external_lex_state = 354},
  [10764] = {.lex_state = 51, .external_lex_state = 304},
  [10765] = {.lex_state = 47, .external_lex_state = 298},
  [10766] = {.lex_state = 47, .external_lex_state = 298},
  [10767] = {.lex_state = 51, .external_lex_state = 304},
  [10768] = {.lex_state = 47, .external_lex_state = 298},
  [10769] = {.lex_state = 51, .external_lex_state = 304},
  [10770] = {.lex_state = 51, .external_lex_state = 302},
  [10771] = {.lex_state = 51, .external_lex_state = 302},
  [10772] = {.lex_state = 51, .external_lex_state = 302},
  [10773] = {.lex_state = 51, .external_lex_state = 304},
  [10774] = {.lex_state = 51, .external_lex_state = 318},
  [10775] = {.lex_state = 0, .external_lex_state = 281},
  [10776] = {.lex_state = 51, .external_lex_state = 304},
  [10777] = {.lex_state = 51, .external_lex_state = 292},
  [10778] = {.lex_state = 51, .external_lex_state = 304},
  [10779] = {.lex_state = 48, .external_lex_state = 305},
  [10780] = {.lex_state = 48, .external_lex_state = 305},
  [10781] = {.lex_state = 51, .external_lex_state = 302},
  [10782] = {.lex_state = 0, .external_lex_state = 281},
  [10783] = {.lex_state = 51, .external_lex_state = 302},
  [10784] = {.lex_state = 51, .external_lex_state = 302},
  [10785] = {.lex_state = 51, .external_lex_state = 302},
  [10786] = {.lex_state = 51, .external_lex_state = 304},
  [10787] = {.lex_state = 51, .external_lex_state = 304},
  [10788] = {.lex_state = 51, .external_lex_state = 302},
  [10789] = {.lex_state = 48, .external_lex_state = 305},
  [10790] = {.lex_state = 51, .external_lex_state = 302},
  [10791] = {.lex_state = 51, .external_lex_state = 359},
  [10792] = {.lex_state = 51, .external_lex_state = 302},
  [10793] = {.lex_state = 51, .external_lex_state = 304},
  [10794] = {.lex_state = 51, .external_lex_state = 304},
  [10795] = {.lex_state = 51, .external_lex_state = 304},
  [10796] = {.lex_state = 51, .external_lex_state = 313},
  [10797] = {.lex_state = 51, .external_lex_state = 304},
  [10798] = {.lex_state = 51, .external_lex_state = 304},
  [10799] = {.lex_state = 51, .external_lex_state = 304},
  [10800] = {.lex_state = 51, .external_lex_state = 304},
  [10801] = {.lex_state = 51, .external_lex_state = 292},
  [10802] = {.lex_state = 51, .external_lex_state = 304},
  [10803] = {.lex_state = 51, .external_lex_state = 304},
  [10804] = {.lex_state = 51, .external_lex_state = 304},
  [10805] = {.lex_state = 51, .external_lex_state = 302},
  [10806] = {.lex_state = 51, .external_lex_state = 365},
  [10807] = {.lex_state = 51, .external_lex_state = 302},
  [10808] = {.lex_state = 51, .external_lex_state = 302},
  [10809] = {.lex_state = 51, .external_lex_state = 302},
  [10810] = {.lex_state = 48, .external_lex_state = 303},
  [10811] = {.lex_state = 51, .external_lex_state = 302},
  [10812] = {.lex_state = 47, .external_lex_state = 317},
  [10813] = {.lex_state = 48, .external_lex_state = 305},
  [10814] = {.lex_state = 48, .external_lex_state = 305},
  [10815] = {.lex_state = 48, .external_lex_state = 305},
  [10816] = {.lex_state = 48, .external_lex_state = 305},
  [10817] = {.lex_state = 51, .external_lex_state = 365},
  [10818] = {.lex_state = 51, .external_lex_state = 364},
  [10819] = {.lex_state = 48, .external_lex_state = 305},
  [10820] = {.lex_state = 48, .external_lex_state = 305},
  [10821] = {.lex_state = 48, .external_lex_state = 305},
  [10822] = {.lex_state = 51, .external_lex_state = 302},
  [10823] = {.lex_state = 48, .external_lex_state = 305},
  [10824] = {.lex_state = 51, .external_lex_state = 302},
  [10825] = {.lex_state = 51, .external_lex_state = 302},
  [10826] = {.lex_state = 51, .external_lex_state = 313},
  [10827] = {.lex_state = 48, .external_lex_state = 243},
  [10828] = {.lex_state = 48, .external_lex_state = 281},
  [10829] = {.lex_state = 48, .external_lex_state = 305},
  [10830] = {.lex_state = 48, .external_lex_state = 305},
  [10831] = {.lex_state = 48, .external_lex_state = 305},
  [10832] = {.lex_state = 48, .external_lex_state = 305},
  [10833] = {.lex_state = 48, .external_lex_state = 305},
  [10834] = {.lex_state = 47, .external_lex_state = 315},
  [10835] = {.lex_state = 48, .external_lex_state = 305},
  [10836] = {.lex_state = 48, .external_lex_state = 305},
  [10837] = {.lex_state = 48, .external_lex_state = 305},
  [10838] = {.lex_state = 51, .external_lex_state = 304},
  [10839] = {.lex_state = 48, .external_lex_state = 305},
  [10840] = {.lex_state = 48, .external_lex_state = 305},
  [10841] = {.lex_state = 48, .external_lex_state = 305},
  [10842] = {.lex_state = 51, .external_lex_state = 304},
  [10843] = {.lex_state = 48, .external_lex_state = 305},
  [10844] = {.lex_state = 48, .external_lex_state = 305},
  [10845] = {.lex_state = 51, .external_lex_state = 304},
  [10846] = {.lex_state = 48, .external_lex_state = 305},
  [10847] = {.lex_state = 48, .external_lex_state = 305},
  [10848] = {.lex_state = 51, .external_lex_state = 314},
  [10849] = {.lex_state = 48, .external_lex_state = 305},
  [10850] = {.lex_state = 48, .external_lex_state = 305},
  [10851] = {.lex_state = 48, .external_lex_state = 305},
  [10852] = {.lex_state = 48, .external_lex_state = 305},
  [10853] = {.lex_state = 47, .external_lex_state = 314},
  [10854] = {.lex_state = 48, .external_lex_state = 305},
  [10855] = {.lex_state = 48, .external_lex_state = 305},
  [10856] = {.lex_state = 48, .external_lex_state = 305},
  [10857] = {.lex_state = 47, .external_lex_state = 363},
  [10858] = {.lex_state = 47, .external_lex_state = 305},
  [10859] = {.lex_state = 47, .external_lex_state = 305},
  [10860] = {.lex_state = 47, .external_lex_state = 305},
  [10861] = {.lex_state = 47, .external_lex_state = 305},
  [10862] = {.lex_state = 51, .external_lex_state = 371},
  [10863] = {.lex_state = 47, .external_lex_state = 305},
  [10864] = {.lex_state = 51, .external_lex_state = 317},
  [10865] = {.lex_state = 47, .external_lex_state = 305},
  [10866] = {.lex_state = 47, .external_lex_state = 305},
  [10867] = {.lex_state = 51, .external_lex_state = 325},
  [10868] = {.lex_state = 51, .external_lex_state = 309},
  [10869] = {.lex_state = 51, .external_lex_state = 325},
  [10870] = {.lex_state = 51, .external_lex_state = 371},
  [10871] = {.lex_state = 51, .external_lex_state = 372},
  [10872] = {.lex_state = 51, .external_lex_state = 325},
  [10873] = {.lex_state = 47, .external_lex_state = 298},
  [10874] = {.lex_state = 47, .external_lex_state = 298},
  [10875] = {.lex_state = 47, .external_lex_state = 298},
  [10876] = {.lex_state = 51, .external_lex_state = 325},
  [10877] = {.lex_state = 51, .external_lex_state = 309},
  [10878] = {.lex_state = 51, .external_lex_state = 309},
  [10879] = {.lex_state = 51, .external_lex_state = 325},
  [10880] = {.lex_state = 51, .external_lex_state = 314},
  [10881] = {.lex_state = 47, .external_lex_state = 305},
  [10882] = {.lex_state = 51, .external_lex_state = 281},
  [10883] = {.lex_state = 47, .external_lex_state = 298},
  [10884] = {.lex_state = 51, .external_lex_state = 325},
  [10885] = {.lex_state = 51, .external_lex_state = 309},
  [10886] = {.lex_state = 51, .external_lex_state = 309},
  [10887] = {.lex_state = 50, .external_lex_state = 345},
  [10888] = {.lex_state = 51, .external_lex_state = 309},
  [10889] = {.lex_state = 51, .external_lex_state = 309},
  [10890] = {.lex_state = 51, .external_lex_state = 309},
  [10891] = {.lex_state = 48, .external_lex_state = 316},
  [10892] = {.lex_state = 51, .external_lex_state = 309},
  [10893] = {.lex_state = 47, .external_lex_state = 305},
  [10894] = {.lex_state = 51, .external_lex_state = 309},
  [10895] = {.lex_state = 51, .external_lex_state = 325},
  [10896] = {.lex_state = 47, .external_lex_state = 298},
  [10897] = {.lex_state = 51, .external_lex_state = 325},
  [10898] = {.lex_state = 51, .external_lex_state = 325},
  [10899] = {.lex_state = 51, .external_lex_state = 310},
  [10900] = {.lex_state = 47, .external_lex_state = 305},
  [10901] = {.lex_state = 51, .external_lex_state = 325},
  [10902] = {.lex_state = 48, .external_lex_state = 316},
  [10903] = {.lex_state = 51, .external_lex_state = 309},
  [10904] = {.lex_state = 48, .external_lex_state = 316},
  [10905] = {.lex_state = 51, .external_lex_state = 309},
  [10906] = {.lex_state = 51, .external_lex_state = 325},
  [10907] = {.lex_state = 51, .external_lex_state = 309},
  [10908] = {.lex_state = 51, .external_lex_state = 315},
  [10909] = {.lex_state = 47, .external_lex_state = 298},
  [10910] = {.lex_state = 51, .external_lex_state = 309},
  [10911] = {.lex_state = 47, .external_lex_state = 304},
  [10912] = {.lex_state = 47, .external_lex_state = 298},
  [10913] = {.lex_state = 51, .external_lex_state = 315},
  [10914] = {.lex_state = 51, .external_lex_state = 314},
  [10915] = {.lex_state = 48, .external_lex_state = 316},
  [10916] = {.lex_state = 51, .external_lex_state = 325},
  [10917] = {.lex_state = 48, .external_lex_state = 316},
  [10918] = {.lex_state = 51, .external_lex_state = 243},
  [10919] = {.lex_state = 48, .external_lex_state = 316},
  [10920] = {.lex_state = 51, .external_lex_state = 309},
  [10921] = {.lex_state = 47, .external_lex_state = 298},
  [10922] = {.lex_state = 47, .external_lex_state = 298},
  [10923] = {.lex_state = 48, .external_lex_state = 316},
  [10924] = {.lex_state = 47, .external_lex_state = 304},
  [10925] = {.lex_state = 51, .external_lex_state = 315},
  [10926] = {.lex_state = 48, .external_lex_state = 316},
  [10927] = {.lex_state = 47, .external_lex_state = 304},
  [10928] = {.lex_state = 51, .external_lex_state = 315},
  [10929] = {.lex_state = 51, .external_lex_state = 372},
  [10930] = {.lex_state = 48, .external_lex_state = 316},
  [10931] = {.lex_state = 48, .external_lex_state = 316},
  [10932] = {.lex_state = 51, .external_lex_state = 315},
  [10933] = {.lex_state = 51, .external_lex_state = 315},
  [10934] = {.lex_state = 48, .external_lex_state = 316},
  [10935] = {.lex_state = 47, .external_lex_state = 301},
  [10936] = {.lex_state = 51, .external_lex_state = 311},
  [10937] = {.lex_state = 51, .external_lex_state = 309},
  [10938] = {.lex_state = 47, .external_lex_state = 298},
  [10939] = {.lex_state = 47, .external_lex_state = 298},
  [10940] = {.lex_state = 51, .external_lex_state = 311},
  [10941] = {.lex_state = 48, .external_lex_state = 316},
  [10942] = {.lex_state = 51, .external_lex_state = 325},
  [10943] = {.lex_state = 47, .external_lex_state = 304},
  [10944] = {.lex_state = 51, .external_lex_state = 325},
  [10945] = {.lex_state = 47, .external_lex_state = 345},
  [10946] = {.lex_state = 47, .external_lex_state = 304},
  [10947] = {.lex_state = 51, .external_lex_state = 309},
  [10948] = {.lex_state = 51, .external_lex_state = 310},
  [10949] = {.lex_state = 51, .external_lex_state = 309},
  [10950] = {.lex_state = 51, .external_lex_state = 309},
  [10951] = {.lex_state = 51, .external_lex_state = 310},
  [10952] = {.lex_state = 51, .external_lex_state = 309},
  [10953] = {.lex_state = 51, .external_lex_state = 315},
  [10954] = {.lex_state = 51, .external_lex_state = 309},
  [10955] = {.lex_state = 51, .external_lex_state = 309},
  [10956] = {.lex_state = 51, .external_lex_state = 309},
  [10957] = {.lex_state = 51, .external_lex_state = 311},
  [10958] = {.lex_state = 47, .external_lex_state = 302},
  [10959] = {.lex_state = 51, .external_lex_state = 310},
  [10960] = {.lex_state = 51, .external_lex_state = 325},
  [10961] = {.lex_state = 51, .external_lex_state = 315},
  [10962] = {.lex_state = 51, .external_lex_state = 325},
  [10963] = {.lex_state = 47, .external_lex_state = 302},
  [10964] = {.lex_state = 47, .external_lex_state = 302},
  [10965] = {.lex_state = 51, .external_lex_state = 311},
  [10966] = {.lex_state = 51, .external_lex_state = 371},
  [10967] = {.lex_state = 51, .external_lex_state = 309},
  [10968] = {.lex_state = 51, .external_lex_state = 315},
  [10969] = {.lex_state = 51, .external_lex_state = 311},
  [10970] = {.lex_state = 51, .external_lex_state = 310},
  [10971] = {.lex_state = 47, .external_lex_state = 298},
  [10972] = {.lex_state = 51, .external_lex_state = 311},
  [10973] = {.lex_state = 51, .external_lex_state = 311},
  [10974] = {.lex_state = 51, .external_lex_state = 310},
  [10975] = {.lex_state = 47, .external_lex_state = 302},
  [10976] = {.lex_state = 51, .external_lex_state = 311},
  [10977] = {.lex_state = 47, .external_lex_state = 304},
  [10978] = {.lex_state = 51, .external_lex_state = 309},
  [10979] = {.lex_state = 47, .external_lex_state = 302},
  [10980] = {.lex_state = 51, .external_lex_state = 311},
  [10981] = {.lex_state = 51, .external_lex_state = 315},
  [10982] = {.lex_state = 51, .external_lex_state = 315},
  [10983] = {.lex_state = 51, .external_lex_state = 311},
  [10984] = {.lex_state = 47, .external_lex_state = 298},
  [10985] = {.lex_state = 51, .external_lex_state = 311},
  [10986] = {.lex_state = 51, .external_lex_state = 315},
  [10987] = {.lex_state = 51, .external_lex_state = 311},
  [10988] = {.lex_state = 47, .external_lex_state = 304},
  [10989] = {.lex_state = 51, .external_lex_state = 313},
  [10990] = {.lex_state = 51, .external_lex_state = 311},
  [10991] = {.lex_state = 51, .external_lex_state = 311},
  [10992] = {.lex_state = 47, .external_lex_state = 302},
  [10993] = {.lex_state = 51, .external_lex_state = 310},
  [10994] = {.lex_state = 51, .external_lex_state = 325},
  [10995] = {.lex_state = 50, .external_lex_state = 249},
  [10996] = {.lex_state = 51, .external_lex_state = 310},
  [10997] = {.lex_state = 51, .external_lex_state = 311},
  [10998] = {.lex_state = 51, .external_lex_state = 309},
  [10999] = {.lex_state = 51, .external_lex_state = 311},
  [11000] = {.lex_state = 51, .external_lex_state = 315},
  [11001] = {.lex_state = 47, .external_lex_state = 298},
  [11002] = {.lex_state = 51, .external_lex_state = 310},
  [11003] = {.lex_state = 51, .external_lex_state = 309},
  [11004] = {.lex_state = 51, .external_lex_state = 309},
  [11005] = {.lex_state = 51, .external_lex_state = 315},
  [11006] = {.lex_state = 47, .external_lex_state = 308},
  [11007] = {.lex_state = 51, .external_lex_state = 315},
  [11008] = {.lex_state = 47, .external_lex_state = 302},
  [11009] = {.lex_state = 51, .external_lex_state = 310},
  [11010] = {.lex_state = 51, .external_lex_state = 310},
  [11011] = {.lex_state = 51, .external_lex_state = 310},
  [11012] = {.lex_state = 51, .external_lex_state = 310},
  [11013] = {.lex_state = 50, .external_lex_state = 344},
  [11014] = {.lex_state = 51, .external_lex_state = 311},
  [11015] = {.lex_state = 51, .external_lex_state = 309},
  [11016] = {.lex_state = 51, .external_lex_state = 311},
  [11017] = {.lex_state = 51, .external_lex_state = 315},
  [11018] = {.lex_state = 51, .external_lex_state = 311},
  [11019] = {.lex_state = 51, .external_lex_state = 310},
  [11020] = {.lex_state = 51, .external_lex_state = 309},
  [11021] = {.lex_state = 51, .external_lex_state = 309},
  [11022] = {.lex_state = 51, .external_lex_state = 310},
  [11023] = {.lex_state = 51, .external_lex_state = 313},
  [11024] = {.lex_state = 51, .external_lex_state = 309},
  [11025] = {.lex_state = 51, .external_lex_state = 311},
  [11026] = {.lex_state = 51, .external_lex_state = 311},
  [11027] = {.lex_state = 47, .external_lex_state = 302},
  [11028] = {.lex_state = 47, .external_lex_state = 298},
  [11029] = {.lex_state = 47, .external_lex_state = 298},
  [11030] = {.lex_state = 51, .external_lex_state = 315},
  [11031] = {.lex_state = 51, .external_lex_state = 311},
  [11032] = {.lex_state = 51, .external_lex_state = 311},
  [11033] = {.lex_state = 51, .external_lex_state = 309},
  [11034] = {.lex_state = 51, .external_lex_state = 313},
  [11035] = {.lex_state = 51, .external_lex_state = 311},
  [11036] = {.lex_state = 51, .external_lex_state = 309},
  [11037] = {.lex_state = 51, .external_lex_state = 311},
  [11038] = {.lex_state = 51, .external_lex_state = 281},
  [11039] = {.lex_state = 51, .external_lex_state = 281},
  [11040] = {.lex_state = 51, .external_lex_state = 311},
  [11041] = {.lex_state = 51, .external_lex_state = 309},
  [11042] = {.lex_state = 51, .external_lex_state = 313},
  [11043] = {.lex_state = 51, .external_lex_state = 313},
  [11044] = {.lex_state = 51, .external_lex_state = 311},
  [11045] = {.lex_state = 51, .external_lex_state = 281},
  [11046] = {.lex_state = 51, .external_lex_state = 311},
  [11047] = {.lex_state = 51, .external_lex_state = 315},
  [11048] = {.lex_state = 47, .external_lex_state = 298},
  [11049] = {.lex_state = 51, .external_lex_state = 309},
  [11050] = {.lex_state = 51, .external_lex_state = 315},
  [11051] = {.lex_state = 51, .external_lex_state = 315},
  [11052] = {.lex_state = 47, .external_lex_state = 304},
  [11053] = {.lex_state = 51, .external_lex_state = 313},
  [11054] = {.lex_state = 51, .external_lex_state = 313},
  [11055] = {.lex_state = 51, .external_lex_state = 311},
  [11056] = {.lex_state = 51, .external_lex_state = 309},
  [11057] = {.lex_state = 51, .external_lex_state = 309},
  [11058] = {.lex_state = 47, .external_lex_state = 304},
  [11059] = {.lex_state = 47, .external_lex_state = 302},
  [11060] = {.lex_state = 51, .external_lex_state = 311},
  [11061] = {.lex_state = 51, .external_lex_state = 310},
  [11062] = {.lex_state = 51, .external_lex_state = 313},
  [11063] = {.lex_state = 51, .external_lex_state = 309},
  [11064] = {.lex_state = 51, .external_lex_state = 313},
  [11065] = {.lex_state = 51, .external_lex_state = 313},
  [11066] = {.lex_state = 51, .external_lex_state = 311},
  [11067] = {.lex_state = 51, .external_lex_state = 310},
  [11068] = {.lex_state = 51, .external_lex_state = 311},
  [11069] = {.lex_state = 51, .external_lex_state = 309},
  [11070] = {.lex_state = 51, .external_lex_state = 310},
  [11071] = {.lex_state = 51, .external_lex_state = 314},
  [11072] = {.lex_state = 51, .external_lex_state = 311},
  [11073] = {.lex_state = 51, .external_lex_state = 311},
  [11074] = {.lex_state = 51, .external_lex_state = 311},
  [11075] = {.lex_state = 51, .external_lex_state = 311},
  [11076] = {.lex_state = 51, .external_lex_state = 313},
  [11077] = {.lex_state = 51, .external_lex_state = 311},
  [11078] = {.lex_state = 51, .external_lex_state = 309},
  [11079] = {.lex_state = 47, .external_lex_state = 373},
  [11080] = {.lex_state = 51, .external_lex_state = 313},
  [11081] = {.lex_state = 51, .external_lex_state = 313},
  [11082] = {.lex_state = 51, .external_lex_state = 315},
  [11083] = {.lex_state = 51, .external_lex_state = 309},
  [11084] = {.lex_state = 51, .external_lex_state = 311},
  [11085] = {.lex_state = 50, .external_lex_state = 344},
  [11086] = {.lex_state = 51, .external_lex_state = 313},
  [11087] = {.lex_state = 51, .external_lex_state = 313},
  [11088] = {.lex_state = 51, .external_lex_state = 311},
  [11089] = {.lex_state = 51, .external_lex_state = 311},
  [11090] = {.lex_state = 51, .external_lex_state = 311},
  [11091] = {.lex_state = 0, .external_lex_state = 374},
  [11092] = {.lex_state = 51, .external_lex_state = 313},
  [11093] = {.lex_state = 51, .external_lex_state = 311},
  [11094] = {.lex_state = 51, .external_lex_state = 311},
  [11095] = {.lex_state = 51, .external_lex_state = 309},
  [11096] = {.lex_state = 51, .external_lex_state = 311},
  [11097] = {.lex_state = 47, .external_lex_state = 302},
  [11098] = {.lex_state = 51, .external_lex_state = 309},
  [11099] = {.lex_state = 51, .external_lex_state = 309},
  [11100] = {.lex_state = 51, .external_lex_state = 309},
  [11101] = {.lex_state = 47, .external_lex_state = 304},
  [11102] = {.lex_state = 51, .external_lex_state = 313},
  [11103] = {.lex_state = 51, .external_lex_state = 310},
  [11104] = {.lex_state = 51, .external_lex_state = 309},
  [11105] = {.lex_state = 51, .external_lex_state = 309},
  [11106] = {.lex_state = 51, .external_lex_state = 310},
  [11107] = {.lex_state = 51, .external_lex_state = 317},
  [11108] = {.lex_state = 51, .external_lex_state = 315},
  [11109] = {.lex_state = 51, .external_lex_state = 313},
  [11110] = {.lex_state = 51, .external_lex_state = 311},
  [11111] = {.lex_state = 51, .external_lex_state = 313},
  [11112] = {.lex_state = 51, .external_lex_state = 313},
  [11113] = {.lex_state = 51, .external_lex_state = 372},
  [11114] = {.lex_state = 50, .external_lex_state = 249},
  [11115] = {.lex_state = 51, .external_lex_state = 313},
  [11116] = {.lex_state = 51, .external_lex_state = 313},
  [11117] = {.lex_state = 51, .external_lex_state = 310},
  [11118] = {.lex_state = 51, .external_lex_state = 310},
  [11119] = {.lex_state = 51, .external_lex_state = 315},
  [11120] = {.lex_state = 51, .external_lex_state = 281},
  [11121] = {.lex_state = 51, .external_lex_state = 313},
  [11122] = {.lex_state = 51, .external_lex_state = 249},
  [11123] = {.lex_state = 51, .external_lex_state = 311},
  [11124] = {.lex_state = 51, .external_lex_state = 311},
  [11125] = {.lex_state = 51, .external_lex_state = 313},
  [11126] = {.lex_state = 51, .external_lex_state = 313},
  [11127] = {.lex_state = 51, .external_lex_state = 313},
  [11128] = {.lex_state = 51, .external_lex_state = 317},
  [11129] = {.lex_state = 51, .external_lex_state = 313},
  [11130] = {.lex_state = 47, .external_lex_state = 302},
  [11131] = {.lex_state = 47, .external_lex_state = 344},
  [11132] = {.lex_state = 51, .external_lex_state = 317},
  [11133] = {.lex_state = 51, .external_lex_state = 315},
  [11134] = {.lex_state = 51, .external_lex_state = 310},
  [11135] = {.lex_state = 51, .external_lex_state = 311},
  [11136] = {.lex_state = 51, .external_lex_state = 310},
  [11137] = {.lex_state = 51, .external_lex_state = 311},
  [11138] = {.lex_state = 47, .external_lex_state = 305},
  [11139] = {.lex_state = 51, .external_lex_state = 313},
  [11140] = {.lex_state = 51, .external_lex_state = 317},
  [11141] = {.lex_state = 51, .external_lex_state = 313},
  [11142] = {.lex_state = 51, .external_lex_state = 310},
  [11143] = {.lex_state = 51, .external_lex_state = 310},
  [11144] = {.lex_state = 51, .external_lex_state = 310},
  [11145] = {.lex_state = 51, .external_lex_state = 310},
  [11146] = {.lex_state = 0, .external_lex_state = 374},
  [11147] = {.lex_state = 51, .external_lex_state = 311},
  [11148] = {.lex_state = 51, .external_lex_state = 310},
  [11149] = {.lex_state = 51, .external_lex_state = 249},
  [11150] = {.lex_state = 51, .external_lex_state = 243},
  [11151] = {.lex_state = 51, .external_lex_state = 314},
  [11152] = {.lex_state = 51, .external_lex_state = 249},
  [11153] = {.lex_state = 51, .external_lex_state = 249},
  [11154] = {.lex_state = 51, .external_lex_state = 317},
  [11155] = {.lex_state = 51, .external_lex_state = 314},
  [11156] = {.lex_state = 51, .external_lex_state = 243},
  [11157] = {.lex_state = 51, .external_lex_state = 311},
  [11158] = {.lex_state = 51, .external_lex_state = 314},
  [11159] = {.lex_state = 48, .external_lex_state = 316},
  [11160] = {.lex_state = 51, .external_lex_state = 309},
  [11161] = {.lex_state = 47, .external_lex_state = 344},
  [11162] = {.lex_state = 51, .external_lex_state = 314},
  [11163] = {.lex_state = 51, .external_lex_state = 309},
  [11164] = {.lex_state = 0, .external_lex_state = 375},
  [11165] = {.lex_state = 51, .external_lex_state = 314},
  [11166] = {.lex_state = 51, .external_lex_state = 314},
  [11167] = {.lex_state = 51, .external_lex_state = 314},
  [11168] = {.lex_state = 51, .external_lex_state = 243},
  [11169] = {.lex_state = 51, .external_lex_state = 309},
  [11170] = {.lex_state = 51, .external_lex_state = 309},
  [11171] = {.lex_state = 51, .external_lex_state = 310},
  [11172] = {.lex_state = 51, .external_lex_state = 249},
  [11173] = {.lex_state = 51, .external_lex_state = 309},
  [11174] = {.lex_state = 51, .external_lex_state = 309},
  [11175] = {.lex_state = 50, .external_lex_state = 344},
  [11176] = {.lex_state = 51, .external_lex_state = 309},
  [11177] = {.lex_state = 51, .external_lex_state = 310},
  [11178] = {.lex_state = 51, .external_lex_state = 309},
  [11179] = {.lex_state = 51, .external_lex_state = 315},
  [11180] = {.lex_state = 51, .external_lex_state = 315},
  [11181] = {.lex_state = 51, .external_lex_state = 309},
  [11182] = {.lex_state = 51, .external_lex_state = 315},
  [11183] = {.lex_state = 47, .external_lex_state = 303},
  [11184] = {.lex_state = 51, .external_lex_state = 314},
  [11185] = {.lex_state = 51, .external_lex_state = 310},
  [11186] = {.lex_state = 51, .external_lex_state = 309},
  [11187] = {.lex_state = 51, .external_lex_state = 314},
  [11188] = {.lex_state = 51, .external_lex_state = 309},
  [11189] = {.lex_state = 51, .external_lex_state = 309},
  [11190] = {.lex_state = 51, .external_lex_state = 309},
  [11191] = {.lex_state = 51, .external_lex_state = 314},
  [11192] = {.lex_state = 47, .external_lex_state = 301},
  [11193] = {.lex_state = 50, .external_lex_state = 345},
  [11194] = {.lex_state = 51, .external_lex_state = 313},
  [11195] = {.lex_state = 47, .external_lex_state = 304},
  [11196] = {.lex_state = 51, .external_lex_state = 313},
  [11197] = {.lex_state = 51, .external_lex_state = 313},
  [11198] = {.lex_state = 51, .external_lex_state = 314},
  [11199] = {.lex_state = 51, .external_lex_state = 243},
  [11200] = {.lex_state = 51, .external_lex_state = 314},
  [11201] = {.lex_state = 51, .external_lex_state = 313},
  [11202] = {.lex_state = 48, .external_lex_state = 316},
  [11203] = {.lex_state = 51, .external_lex_state = 315},
  [11204] = {.lex_state = 51, .external_lex_state = 313},
  [11205] = {.lex_state = 51, .external_lex_state = 372},
  [11206] = {.lex_state = 51, .external_lex_state = 317},
  [11207] = {.lex_state = 51, .external_lex_state = 313},
  [11208] = {.lex_state = 51, .external_lex_state = 313},
  [11209] = {.lex_state = 51, .external_lex_state = 314},
  [11210] = {.lex_state = 51, .external_lex_state = 310},
  [11211] = {.lex_state = 51, .external_lex_state = 310},
  [11212] = {.lex_state = 51, .external_lex_state = 314},
  [11213] = {.lex_state = 51, .external_lex_state = 314},
  [11214] = {.lex_state = 51, .external_lex_state = 314},
  [11215] = {.lex_state = 51, .external_lex_state = 310},
  [11216] = {.lex_state = 51, .external_lex_state = 310},
  [11217] = {.lex_state = 51, .external_lex_state = 314},
  [11218] = {.lex_state = 51, .external_lex_state = 314},
  [11219] = {.lex_state = 51, .external_lex_state = 315},
  [11220] = {.lex_state = 51, .external_lex_state = 315},
  [11221] = {.lex_state = 51, .external_lex_state = 314},
  [11222] = {.lex_state = 51, .external_lex_state = 310},
  [11223] = {.lex_state = 51, .external_lex_state = 310},
  [11224] = {.lex_state = 51, .external_lex_state = 317},
  [11225] = {.lex_state = 47, .external_lex_state = 303},
  [11226] = {.lex_state = 51, .external_lex_state = 317},
  [11227] = {.lex_state = 51, .external_lex_state = 313},
  [11228] = {.lex_state = 51, .external_lex_state = 314},
  [11229] = {.lex_state = 51, .external_lex_state = 314},
  [11230] = {.lex_state = 51, .external_lex_state = 313},
  [11231] = {.lex_state = 51, .external_lex_state = 313},
  [11232] = {.lex_state = 51, .external_lex_state = 313},
  [11233] = {.lex_state = 50, .external_lex_state = 345},
  [11234] = {.lex_state = 51, .external_lex_state = 317},
  [11235] = {.lex_state = 51, .external_lex_state = 317},
  [11236] = {.lex_state = 51, .external_lex_state = 317},
  [11237] = {.lex_state = 51, .external_lex_state = 310},
  [11238] = {.lex_state = 51, .external_lex_state = 310},
  [11239] = {.lex_state = 51, .external_lex_state = 310},
  [11240] = {.lex_state = 51, .external_lex_state = 314},
  [11241] = {.lex_state = 50, .external_lex_state = 344},
  [11242] = {.lex_state = 51, .external_lex_state = 310},
  [11243] = {.lex_state = 51, .external_lex_state = 310},
  [11244] = {.lex_state = 51, .external_lex_state = 317},
  [11245] = {.lex_state = 51, .external_lex_state = 310},
  [11246] = {.lex_state = 51, .external_lex_state = 314},
  [11247] = {.lex_state = 51, .external_lex_state = 313},
  [11248] = {.lex_state = 50, .external_lex_state = 249},
  [11249] = {.lex_state = 51, .external_lex_state = 317},
  [11250] = {.lex_state = 51, .external_lex_state = 313},
  [11251] = {.lex_state = 51, .external_lex_state = 325},
  [11252] = {.lex_state = 51, .external_lex_state = 313},
  [11253] = {.lex_state = 51, .external_lex_state = 317},
  [11254] = {.lex_state = 47, .external_lex_state = 303},
  [11255] = {.lex_state = 51, .external_lex_state = 313},
  [11256] = {.lex_state = 51, .external_lex_state = 313},
  [11257] = {.lex_state = 51, .external_lex_state = 317},
  [11258] = {.lex_state = 51, .external_lex_state = 314},
  [11259] = {.lex_state = 51, .external_lex_state = 310},
  [11260] = {.lex_state = 51, .external_lex_state = 317},
  [11261] = {.lex_state = 51, .external_lex_state = 311},
  [11262] = {.lex_state = 51, .external_lex_state = 309},
  [11263] = {.lex_state = 51, .external_lex_state = 317},
  [11264] = {.lex_state = 51, .external_lex_state = 310},
  [11265] = {.lex_state = 51, .external_lex_state = 310},
  [11266] = {.lex_state = 51, .external_lex_state = 310},
  [11267] = {.lex_state = 51, .external_lex_state = 325},
  [11268] = {.lex_state = 51, .external_lex_state = 310},
  [11269] = {.lex_state = 51, .external_lex_state = 310},
  [11270] = {.lex_state = 51, .external_lex_state = 310},
  [11271] = {.lex_state = 51, .external_lex_state = 310},
  [11272] = {.lex_state = 47, .external_lex_state = 301},
  [11273] = {.lex_state = 51, .external_lex_state = 309},
  [11274] = {.lex_state = 51, .external_lex_state = 313},
  [11275] = {.lex_state = 51, .external_lex_state = 317},
  [11276] = {.lex_state = 51, .external_lex_state = 310},
  [11277] = {.lex_state = 51, .external_lex_state = 317},
  [11278] = {.lex_state = 50, .external_lex_state = 249},
  [11279] = {.lex_state = 47, .external_lex_state = 301},
  [11280] = {.lex_state = 51, .external_lex_state = 317},
  [11281] = {.lex_state = 51, .external_lex_state = 317},
  [11282] = {.lex_state = 51, .external_lex_state = 325},
  [11283] = {.lex_state = 47, .external_lex_state = 301},
  [11284] = {.lex_state = 51, .external_lex_state = 317},
  [11285] = {.lex_state = 51, .external_lex_state = 348},
  [11286] = {.lex_state = 51, .external_lex_state = 317},
  [11287] = {.lex_state = 47, .external_lex_state = 301},
  [11288] = {.lex_state = 51, .external_lex_state = 310},
  [11289] = {.lex_state = 51, .external_lex_state = 310},
  [11290] = {.lex_state = 51, .external_lex_state = 310},
  [11291] = {.lex_state = 51, .external_lex_state = 317},
  [11292] = {.lex_state = 51, .external_lex_state = 310},
  [11293] = {.lex_state = 51, .external_lex_state = 313},
  [11294] = {.lex_state = 51, .external_lex_state = 317},
  [11295] = {.lex_state = 51, .external_lex_state = 314},
  [11296] = {.lex_state = 51, .external_lex_state = 314},
  [11297] = {.lex_state = 51, .external_lex_state = 317},
  [11298] = {.lex_state = 51, .external_lex_state = 371},
  [11299] = {.lex_state = 51, .external_lex_state = 317},
  [11300] = {.lex_state = 47, .external_lex_state = 301},
  [11301] = {.lex_state = 51, .external_lex_state = 315},
  [11302] = {.lex_state = 51, .external_lex_state = 315},
  [11303] = {.lex_state = 51, .external_lex_state = 315},
  [11304] = {.lex_state = 51, .external_lex_state = 315},
  [11305] = {.lex_state = 51, .external_lex_state = 314},
  [11306] = {.lex_state = 51, .external_lex_state = 314},
  [11307] = {.lex_state = 51, .external_lex_state = 309},
  [11308] = {.lex_state = 51, .external_lex_state = 314},
  [11309] = {.lex_state = 47, .external_lex_state = 308},
  [11310] = {.lex_state = 47, .external_lex_state = 345},
  [11311] = {.lex_state = 51, .external_lex_state = 310},
  [11312] = {.lex_state = 51, .external_lex_state = 315},
  [11313] = {.lex_state = 51, .external_lex_state = 317},
  [11314] = {.lex_state = 51, .external_lex_state = 310},
  [11315] = {.lex_state = 51, .external_lex_state = 314},
  [11316] = {.lex_state = 51, .external_lex_state = 314},
  [11317] = {.lex_state = 51, .external_lex_state = 314},
  [11318] = {.lex_state = 51, .external_lex_state = 372},
  [11319] = {.lex_state = 51, .external_lex_state = 372},
  [11320] = {.lex_state = 0, .external_lex_state = 376},
  [11321] = {.lex_state = 47, .external_lex_state = 301},
  [11322] = {.lex_state = 50, .external_lex_state = 344},
  [11323] = {.lex_state = 47, .external_lex_state = 301},
  [11324] = {.lex_state = 48, .external_lex_state = 316},
  [11325] = {.lex_state = 51, .external_lex_state = 348},
  [11326] = {.lex_state = 48, .external_lex_state = 316},
  [11327] = {.lex_state = 51, .external_lex_state = 315},
  [11328] = {.lex_state = 51, .external_lex_state = 310},
  [11329] = {.lex_state = 48, .external_lex_state = 316},
  [11330] = {.lex_state = 51, .external_lex_state = 314},
  [11331] = {.lex_state = 47, .external_lex_state = 298},
  [11332] = {.lex_state = 51, .external_lex_state = 310},
  [11333] = {.lex_state = 51, .external_lex_state = 314},
  [11334] = {.lex_state = 51, .external_lex_state = 314},
  [11335] = {.lex_state = 47, .external_lex_state = 301},
  [11336] = {.lex_state = 51, .external_lex_state = 314},
  [11337] = {.lex_state = 51, .external_lex_state = 317},
  [11338] = {.lex_state = 51, .external_lex_state = 310},
  [11339] = {.lex_state = 48, .external_lex_state = 316},
  [11340] = {.lex_state = 51, .external_lex_state = 314},
  [11341] = {.lex_state = 47, .external_lex_state = 303},
  [11342] = {.lex_state = 51, .external_lex_state = 348},
  [11343] = {.lex_state = 47, .external_lex_state = 303},
  [11344] = {.lex_state = 48, .external_lex_state = 316},
  [11345] = {.lex_state = 51, .external_lex_state = 314},
  [11346] = {.lex_state = 51, .external_lex_state = 315},
  [11347] = {.lex_state = 51, .external_lex_state = 317},
  [11348] = {.lex_state = 51, .external_lex_state = 317},
  [11349] = {.lex_state = 51, .external_lex_state = 317},
  [11350] = {.lex_state = 51, .external_lex_state = 325},
  [11351] = {.lex_state = 48, .external_lex_state = 316},
  [11352] = {.lex_state = 51, .external_lex_state = 310},
  [11353] = {.lex_state = 48, .external_lex_state = 316},
  [11354] = {.lex_state = 51, .external_lex_state = 317},
  [11355] = {.lex_state = 51, .external_lex_state = 310},
  [11356] = {.lex_state = 51, .external_lex_state = 317},
  [11357] = {.lex_state = 48, .external_lex_state = 316},
  [11358] = {.lex_state = 48, .external_lex_state = 316},
  [11359] = {.lex_state = 51, .external_lex_state = 317},
  [11360] = {.lex_state = 51, .external_lex_state = 315},
  [11361] = {.lex_state = 51, .external_lex_state = 317},
  [11362] = {.lex_state = 51, .external_lex_state = 317},
  [11363] = {.lex_state = 51, .external_lex_state = 314},
  [11364] = {.lex_state = 51, .external_lex_state = 317},
  [11365] = {.lex_state = 51, .external_lex_state = 317},
  [11366] = {.lex_state = 51, .external_lex_state = 314},
  [11367] = {.lex_state = 51, .external_lex_state = 315},
  [11368] = {.lex_state = 51, .external_lex_state = 314},
  [11369] = {.lex_state = 51, .external_lex_state = 317},
  [11370] = {.lex_state = 47, .external_lex_state = 302},
  [11371] = {.lex_state = 51, .external_lex_state = 317},
  [11372] = {.lex_state = 51, .external_lex_state = 317},
  [11373] = {.lex_state = 51, .external_lex_state = 315},
  [11374] = {.lex_state = 51, .external_lex_state = 317},
  [11375] = {.lex_state = 48, .external_lex_state = 316},
  [11376] = {.lex_state = 51, .external_lex_state = 311},
  [11377] = {.lex_state = 47, .external_lex_state = 301},
  [11378] = {.lex_state = 51, .external_lex_state = 317},
  [11379] = {.lex_state = 51, .external_lex_state = 317},
  [11380] = {.lex_state = 51, .external_lex_state = 317},
  [11381] = {.lex_state = 51, .external_lex_state = 317},
  [11382] = {.lex_state = 51, .external_lex_state = 310},
  [11383] = {.lex_state = 51, .external_lex_state = 311},
  [11384] = {.lex_state = 51, .external_lex_state = 315},
  [11385] = {.lex_state = 51, .external_lex_state = 315},
  [11386] = {.lex_state = 51, .external_lex_state = 311},
  [11387] = {.lex_state = 51, .external_lex_state = 315},
  [11388] = {.lex_state = 51, .external_lex_state = 315},
  [11389] = {.lex_state = 51, .external_lex_state = 315},
  [11390] = {.lex_state = 51, .external_lex_state = 317},
  [11391] = {.lex_state = 51, .external_lex_state = 317},
  [11392] = {.lex_state = 51, .external_lex_state = 311},
  [11393] = {.lex_state = 51, .external_lex_state = 311},
  [11394] = {.lex_state = 51, .external_lex_state = 315},
  [11395] = {.lex_state = 51, .external_lex_state = 315},
  [11396] = {.lex_state = 48, .external_lex_state = 316},
  [11397] = {.lex_state = 51, .external_lex_state = 315},
  [11398] = {.lex_state = 51, .external_lex_state = 311},
  [11399] = {.lex_state = 51, .external_lex_state = 315},
  [11400] = {.lex_state = 51, .external_lex_state = 315},
  [11401] = {.lex_state = 51, .external_lex_state = 317},
  [11402] = {.lex_state = 51, .external_lex_state = 315},
  [11403] = {.lex_state = 51, .external_lex_state = 315},
  [11404] = {.lex_state = 48, .external_lex_state = 316},
  [11405] = {.lex_state = 48, .external_lex_state = 316},
  [11406] = {.lex_state = 48, .external_lex_state = 316},
  [11407] = {.lex_state = 50, .external_lex_state = 249},
  [11408] = {.lex_state = 51, .external_lex_state = 317},
  [11409] = {.lex_state = 51, .external_lex_state = 315},
  [11410] = {.lex_state = 51, .external_lex_state = 317},
  [11411] = {.lex_state = 51, .external_lex_state = 317},
  [11412] = {.lex_state = 51, .external_lex_state = 311},
  [11413] = {.lex_state = 48, .external_lex_state = 316},
  [11414] = {.lex_state = 51, .external_lex_state = 315},
  [11415] = {.lex_state = 51, .external_lex_state = 314},
  [11416] = {.lex_state = 51, .external_lex_state = 311},
  [11417] = {.lex_state = 51, .external_lex_state = 315},
  [11418] = {.lex_state = 51, .external_lex_state = 317},
  [11419] = {.lex_state = 51, .external_lex_state = 317},
  [11420] = {.lex_state = 51, .external_lex_state = 311},
  [11421] = {.lex_state = 48, .external_lex_state = 316},
  [11422] = {.lex_state = 48, .external_lex_state = 316},
  [11423] = {.lex_state = 51, .external_lex_state = 317},
  [11424] = {.lex_state = 51, .external_lex_state = 317},
  [11425] = {.lex_state = 48, .external_lex_state = 316},
  [11426] = {.lex_state = 48, .external_lex_state = 316},
  [11427] = {.lex_state = 48, .external_lex_state = 316},
  [11428] = {.lex_state = 48, .external_lex_state = 316},
  [11429] = {.lex_state = 51, .external_lex_state = 317},
  [11430] = {.lex_state = 51, .external_lex_state = 317},
  [11431] = {.lex_state = 51, .external_lex_state = 317},
  [11432] = {.lex_state = 48, .external_lex_state = 316},
  [11433] = {.lex_state = 51, .external_lex_state = 314},
  [11434] = {.lex_state = 51, .external_lex_state = 315},
  [11435] = {.lex_state = 51, .external_lex_state = 315},
  [11436] = {.lex_state = 51, .external_lex_state = 315},
  [11437] = {.lex_state = 51, .external_lex_state = 315},
  [11438] = {.lex_state = 48, .external_lex_state = 316},
  [11439] = {.lex_state = 51, .external_lex_state = 317},
  [11440] = {.lex_state = 51, .external_lex_state = 314},
  [11441] = {.lex_state = 51, .external_lex_state = 315},
  [11442] = {.lex_state = 51, .external_lex_state = 315},
  [11443] = {.lex_state = 48, .external_lex_state = 316},
  [11444] = {.lex_state = 51, .external_lex_state = 315},
  [11445] = {.lex_state = 51, .external_lex_state = 315},
  [11446] = {.lex_state = 51, .external_lex_state = 315},
  [11447] = {.lex_state = 51, .external_lex_state = 315},
  [11448] = {.lex_state = 51, .external_lex_state = 315},
  [11449] = {.lex_state = 48, .external_lex_state = 316},
  [11450] = {.lex_state = 48, .external_lex_state = 316},
  [11451] = {.lex_state = 51, .external_lex_state = 315},
  [11452] = {.lex_state = 51, .external_lex_state = 315},
  [11453] = {.lex_state = 51, .external_lex_state = 315},
  [11454] = {.lex_state = 48, .external_lex_state = 316},
  [11455] = {.lex_state = 51, .external_lex_state = 317},
  [11456] = {.lex_state = 48, .external_lex_state = 316},
  [11457] = {.lex_state = 47, .external_lex_state = 303},
  [11458] = {.lex_state = 48, .external_lex_state = 316},
  [11459] = {.lex_state = 48, .external_lex_state = 316},
  [11460] = {.lex_state = 48, .external_lex_state = 316},
  [11461] = {.lex_state = 51, .external_lex_state = 311},
  [11462] = {.lex_state = 48, .external_lex_state = 316},
  [11463] = {.lex_state = 48, .external_lex_state = 316},
  [11464] = {.lex_state = 51, .external_lex_state = 317},
  [11465] = {.lex_state = 48, .external_lex_state = 316},
  [11466] = {.lex_state = 0, .external_lex_state = 375},
  [11467] = {.lex_state = 48, .external_lex_state = 316},
  [11468] = {.lex_state = 48, .external_lex_state = 316},
  [11469] = {.lex_state = 51, .external_lex_state = 315},
  [11470] = {.lex_state = 51, .external_lex_state = 317},
  [11471] = {.lex_state = 51, .external_lex_state = 315},
  [11472] = {.lex_state = 51, .external_lex_state = 311},
  [11473] = {.lex_state = 50, .external_lex_state = 345},
  [11474] = {.lex_state = 48, .external_lex_state = 316},
  [11475] = {.lex_state = 51, .external_lex_state = 309},
  [11476] = {.lex_state = 48, .external_lex_state = 316},
  [11477] = {.lex_state = 51, .external_lex_state = 371},
  [11478] = {.lex_state = 51, .external_lex_state = 311},
  [11479] = {.lex_state = 51, .external_lex_state = 315},
  [11480] = {.lex_state = 0, .external_lex_state = 376},
  [11481] = {.lex_state = 48, .external_lex_state = 316},
  [11482] = {.lex_state = 48, .external_lex_state = 316},
  [11483] = {.lex_state = 48, .external_lex_state = 316},
  [11484] = {.lex_state = 47, .external_lex_state = 303},
  [11485] = {.lex_state = 48, .external_lex_state = 316},
  [11486] = {.lex_state = 48, .external_lex_state = 316},
  [11487] = {.lex_state = 51, .external_lex_state = 325},
  [11488] = {.lex_state = 48, .external_lex_state = 316},
  [11489] = {.lex_state = 48, .external_lex_state = 316},
  [11490] = {.lex_state = 51, .external_lex_state = 371},
  [11491] = {.lex_state = 51, .external_lex_state = 315},
  [11492] = {.lex_state = 50, .external_lex_state = 345},
  [11493] = {.lex_state = 48, .external_lex_state = 316},
  [11494] = {.lex_state = 47, .external_lex_state = 303},
  [11495] = {.lex_state = 47, .external_lex_state = 303},
  [11496] = {.lex_state = 48, .external_lex_state = 316},
  [11497] = {.lex_state = 47, .external_lex_state = 303},
  [11498] = {.lex_state = 48, .external_lex_state = 316},
  [11499] = {.lex_state = 48, .external_lex_state = 316},
  [11500] = {.lex_state = 47, .external_lex_state = 303},
  [11501] = {.lex_state = 51, .external_lex_state = 311},
  [11502] = {.lex_state = 48, .external_lex_state = 316},
  [11503] = {.lex_state = 48, .external_lex_state = 316},
  [11504] = {.lex_state = 51, .external_lex_state = 315},
  [11505] = {.lex_state = 47, .external_lex_state = 305},
  [11506] = {.lex_state = 51, .external_lex_state = 318},
  [11507] = {.lex_state = 51, .external_lex_state = 319},
  [11508] = {.lex_state = 0, .external_lex_state = 377},
  [11509] = {.lex_state = 0, .external_lex_state = 249},
  [11510] = {.lex_state = 51, .external_lex_state = 319},
  [11511] = {.lex_state = 47, .external_lex_state = 302},
  [11512] = {.lex_state = 51, .external_lex_state = 319},
  [11513] = {.lex_state = 51, .external_lex_state = 309},
  [11514] = {.lex_state = 51, .external_lex_state = 319},
  [11515] = {.lex_state = 47, .external_lex_state = 302},
  [11516] = {.lex_state = 51, .external_lex_state = 318},
  [11517] = {.lex_state = 51, .external_lex_state = 318},
  [11518] = {.lex_state = 0, .external_lex_state = 249},
  [11519] = {.lex_state = 50, .external_lex_state = 308},
  [11520] = {.lex_state = 51, .external_lex_state = 319},
  [11521] = {.lex_state = 51, .external_lex_state = 318},
  [11522] = {.lex_state = 51, .external_lex_state = 318},
  [11523] = {.lex_state = 51, .external_lex_state = 319},
  [11524] = {.lex_state = 51, .external_lex_state = 318},
  [11525] = {.lex_state = 51, .external_lex_state = 318},
  [11526] = {.lex_state = 51, .external_lex_state = 318},
  [11527] = {.lex_state = 51, .external_lex_state = 319},
  [11528] = {.lex_state = 51, .external_lex_state = 319},
  [11529] = {.lex_state = 0, .external_lex_state = 310},
  [11530] = {.lex_state = 0, .external_lex_state = 249},
  [11531] = {.lex_state = 51, .external_lex_state = 319},
  [11532] = {.lex_state = 51, .external_lex_state = 322},
  [11533] = {.lex_state = 47, .external_lex_state = 304},
  [11534] = {.lex_state = 51, .external_lex_state = 322},
  [11535] = {.lex_state = 47, .external_lex_state = 304},
  [11536] = {.lex_state = 51, .external_lex_state = 322},
  [11537] = {.lex_state = 51, .external_lex_state = 319},
  [11538] = {.lex_state = 51, .external_lex_state = 319},
  [11539] = {.lex_state = 0, .external_lex_state = 249},
  [11540] = {.lex_state = 0, .external_lex_state = 249},
  [11541] = {.lex_state = 51, .external_lex_state = 322},
  [11542] = {.lex_state = 51, .external_lex_state = 322},
  [11543] = {.lex_state = 51, .external_lex_state = 319},
  [11544] = {.lex_state = 51, .external_lex_state = 318},
  [11545] = {.lex_state = 51, .external_lex_state = 322},
  [11546] = {.lex_state = 51, .external_lex_state = 322},
  [11547] = {.lex_state = 51, .external_lex_state = 319},
  [11548] = {.lex_state = 51, .external_lex_state = 309},
  [11549] = {.lex_state = 47, .external_lex_state = 355},
  [11550] = {.lex_state = 51, .external_lex_state = 319},
  [11551] = {.lex_state = 47, .external_lex_state = 336},
  [11552] = {.lex_state = 51, .external_lex_state = 322},
  [11553] = {.lex_state = 0, .external_lex_state = 249},
  [11554] = {.lex_state = 0, .external_lex_state = 249},
  [11555] = {.lex_state = 51, .external_lex_state = 309},
  [11556] = {.lex_state = 47, .external_lex_state = 302},
  [11557] = {.lex_state = 51, .external_lex_state = 322},
  [11558] = {.lex_state = 47, .external_lex_state = 301},
  [11559] = {.lex_state = 51, .external_lex_state = 318},
  [11560] = {.lex_state = 47, .external_lex_state = 316},
  [11561] = {.lex_state = 51, .external_lex_state = 322},
  [11562] = {.lex_state = 51, .external_lex_state = 309},
  [11563] = {.lex_state = 51, .external_lex_state = 322},
  [11564] = {.lex_state = 51, .external_lex_state = 318},
  [11565] = {.lex_state = 51, .external_lex_state = 322},
  [11566] = {.lex_state = 51, .external_lex_state = 322},
  [11567] = {.lex_state = 51, .external_lex_state = 322},
  [11568] = {.lex_state = 51, .external_lex_state = 322},
  [11569] = {.lex_state = 51, .external_lex_state = 319},
  [11570] = {.lex_state = 47, .external_lex_state = 316},
  [11571] = {.lex_state = 51, .external_lex_state = 322},
  [11572] = {.lex_state = 51, .external_lex_state = 318},
  [11573] = {.lex_state = 0, .external_lex_state = 311},
  [11574] = {.lex_state = 47, .external_lex_state = 304},
  [11575] = {.lex_state = 51, .external_lex_state = 319},
  [11576] = {.lex_state = 51, .external_lex_state = 318},
  [11577] = {.lex_state = 51, .external_lex_state = 318},
  [11578] = {.lex_state = 47, .external_lex_state = 304},
  [11579] = {.lex_state = 47, .external_lex_state = 316},
  [11580] = {.lex_state = 47, .external_lex_state = 355},
  [11581] = {.lex_state = 51, .external_lex_state = 322},
  [11582] = {.lex_state = 51, .external_lex_state = 319},
  [11583] = {.lex_state = 51, .external_lex_state = 322},
  [11584] = {.lex_state = 51, .external_lex_state = 322},
  [11585] = {.lex_state = 51, .external_lex_state = 322},
  [11586] = {.lex_state = 51, .external_lex_state = 319},
  [11587] = {.lex_state = 51, .external_lex_state = 319},
  [11588] = {.lex_state = 47, .external_lex_state = 304},
  [11589] = {.lex_state = 51, .external_lex_state = 318},
  [11590] = {.lex_state = 51, .external_lex_state = 319},
  [11591] = {.lex_state = 0, .external_lex_state = 249},
  [11592] = {.lex_state = 51, .external_lex_state = 322},
  [11593] = {.lex_state = 47, .external_lex_state = 316},
  [11594] = {.lex_state = 0, .external_lex_state = 249},
  [11595] = {.lex_state = 51, .external_lex_state = 319},
  [11596] = {.lex_state = 51, .external_lex_state = 322},
  [11597] = {.lex_state = 51, .external_lex_state = 322},
  [11598] = {.lex_state = 0, .external_lex_state = 378},
  [11599] = {.lex_state = 0, .external_lex_state = 343},
  [11600] = {.lex_state = 51, .external_lex_state = 309},
  [11601] = {.lex_state = 51, .external_lex_state = 319},
  [11602] = {.lex_state = 0, .external_lex_state = 311},
  [11603] = {.lex_state = 47, .external_lex_state = 302},
  [11604] = {.lex_state = 51, .external_lex_state = 319},
  [11605] = {.lex_state = 51, .external_lex_state = 322},
  [11606] = {.lex_state = 51, .external_lex_state = 309},
  [11607] = {.lex_state = 51, .external_lex_state = 318},
  [11608] = {.lex_state = 0, .external_lex_state = 249},
  [11609] = {.lex_state = 0, .external_lex_state = 311},
  [11610] = {.lex_state = 51, .external_lex_state = 309},
  [11611] = {.lex_state = 47, .external_lex_state = 316},
  [11612] = {.lex_state = 47, .external_lex_state = 316},
  [11613] = {.lex_state = 51, .external_lex_state = 322},
  [11614] = {.lex_state = 47, .external_lex_state = 344},
  [11615] = {.lex_state = 47, .external_lex_state = 316},
  [11616] = {.lex_state = 51, .external_lex_state = 319},
  [11617] = {.lex_state = 51, .external_lex_state = 309},
  [11618] = {.lex_state = 51, .external_lex_state = 319},
  [11619] = {.lex_state = 51, .external_lex_state = 319},
  [11620] = {.lex_state = 0, .external_lex_state = 379},
  [11621] = {.lex_state = 51, .external_lex_state = 318},
  [11622] = {.lex_state = 47, .external_lex_state = 305},
  [11623] = {.lex_state = 51, .external_lex_state = 322},
  [11624] = {.lex_state = 47, .external_lex_state = 304},
  [11625] = {.lex_state = 47, .external_lex_state = 316},
  [11626] = {.lex_state = 0, .external_lex_state = 249},
  [11627] = {.lex_state = 47, .external_lex_state = 317},
  [11628] = {.lex_state = 47, .external_lex_state = 316},
  [11629] = {.lex_state = 47, .external_lex_state = 316},
  [11630] = {.lex_state = 51, .external_lex_state = 322},
  [11631] = {.lex_state = 0, .external_lex_state = 249},
  [11632] = {.lex_state = 51, .external_lex_state = 318},
  [11633] = {.lex_state = 51, .external_lex_state = 319},
  [11634] = {.lex_state = 51, .external_lex_state = 322},
  [11635] = {.lex_state = 51, .external_lex_state = 309},
  [11636] = {.lex_state = 47, .external_lex_state = 317},
  [11637] = {.lex_state = 51, .external_lex_state = 319},
  [11638] = {.lex_state = 47, .external_lex_state = 303},
  [11639] = {.lex_state = 47, .external_lex_state = 305},
  [11640] = {.lex_state = 0, .external_lex_state = 249},
  [11641] = {.lex_state = 51, .external_lex_state = 319},
  [11642] = {.lex_state = 47, .external_lex_state = 305},
  [11643] = {.lex_state = 51, .external_lex_state = 322},
  [11644] = {.lex_state = 51, .external_lex_state = 309},
  [11645] = {.lex_state = 51, .external_lex_state = 318},
  [11646] = {.lex_state = 47, .external_lex_state = 305},
  [11647] = {.lex_state = 0, .external_lex_state = 249},
  [11648] = {.lex_state = 51, .external_lex_state = 319},
  [11649] = {.lex_state = 0, .external_lex_state = 249},
  [11650] = {.lex_state = 51, .external_lex_state = 319},
  [11651] = {.lex_state = 51, .external_lex_state = 319},
  [11652] = {.lex_state = 47, .external_lex_state = 305},
  [11653] = {.lex_state = 0, .external_lex_state = 311},
  [11654] = {.lex_state = 0, .external_lex_state = 311},
  [11655] = {.lex_state = 47, .external_lex_state = 316},
  [11656] = {.lex_state = 47, .external_lex_state = 305},
  [11657] = {.lex_state = 47, .external_lex_state = 305},
  [11658] = {.lex_state = 51, .external_lex_state = 322},
  [11659] = {.lex_state = 47, .external_lex_state = 303},
  [11660] = {.lex_state = 47, .external_lex_state = 303},
  [11661] = {.lex_state = 47, .external_lex_state = 303},
  [11662] = {.lex_state = 47, .external_lex_state = 315},
  [11663] = {.lex_state = 0, .external_lex_state = 249},
  [11664] = {.lex_state = 51, .external_lex_state = 318},
  [11665] = {.lex_state = 51, .external_lex_state = 319},
  [11666] = {.lex_state = 51, .external_lex_state = 319},
  [11667] = {.lex_state = 47, .external_lex_state = 315},
  [11668] = {.lex_state = 47, .external_lex_state = 303},
  [11669] = {.lex_state = 47, .external_lex_state = 305},
  [11670] = {.lex_state = 47, .external_lex_state = 315},
  [11671] = {.lex_state = 51, .external_lex_state = 318},
  [11672] = {.lex_state = 51, .external_lex_state = 318},
  [11673] = {.lex_state = 47, .external_lex_state = 301},
  [11674] = {.lex_state = 51, .external_lex_state = 318},
  [11675] = {.lex_state = 47, .external_lex_state = 305},
  [11676] = {.lex_state = 0, .external_lex_state = 311},
  [11677] = {.lex_state = 51, .external_lex_state = 319},
  [11678] = {.lex_state = 47, .external_lex_state = 315},
  [11679] = {.lex_state = 47, .external_lex_state = 315},
  [11680] = {.lex_state = 0, .external_lex_state = 249},
  [11681] = {.lex_state = 0, .external_lex_state = 311},
  [11682] = {.lex_state = 0, .external_lex_state = 249},
  [11683] = {.lex_state = 47, .external_lex_state = 315},
  [11684] = {.lex_state = 0, .external_lex_state = 249},
  [11685] = {.lex_state = 47, .external_lex_state = 305},
  [11686] = {.lex_state = 51, .external_lex_state = 322},
  [11687] = {.lex_state = 47, .external_lex_state = 302},
  [11688] = {.lex_state = 47, .external_lex_state = 302},
  [11689] = {.lex_state = 47, .external_lex_state = 317},
  [11690] = {.lex_state = 47, .external_lex_state = 305},
  [11691] = {.lex_state = 0, .external_lex_state = 311},
  [11692] = {.lex_state = 0, .external_lex_state = 379},
  [11693] = {.lex_state = 0, .external_lex_state = 249},
  [11694] = {.lex_state = 47, .external_lex_state = 303},
  [11695] = {.lex_state = 47, .external_lex_state = 317},
  [11696] = {.lex_state = 51, .external_lex_state = 322},
  [11697] = {.lex_state = 51, .external_lex_state = 309},
  [11698] = {.lex_state = 0, .external_lex_state = 311},
  [11699] = {.lex_state = 47, .external_lex_state = 305},
  [11700] = {.lex_state = 51, .external_lex_state = 365},
  [11701] = {.lex_state = 51, .external_lex_state = 322},
  [11702] = {.lex_state = 47, .external_lex_state = 305},
  [11703] = {.lex_state = 1, .external_lex_state = 308},
  [11704] = {.lex_state = 51, .external_lex_state = 319},
  [11705] = {.lex_state = 47, .external_lex_state = 315},
  [11706] = {.lex_state = 0, .external_lex_state = 249},
  [11707] = {.lex_state = 51, .external_lex_state = 322},
  [11708] = {.lex_state = 47, .external_lex_state = 303},
  [11709] = {.lex_state = 47, .external_lex_state = 303},
  [11710] = {.lex_state = 51, .external_lex_state = 322},
  [11711] = {.lex_state = 47, .external_lex_state = 315},
  [11712] = {.lex_state = 0, .external_lex_state = 249},
  [11713] = {.lex_state = 51, .external_lex_state = 319},
  [11714] = {.lex_state = 51, .external_lex_state = 322},
  [11715] = {.lex_state = 51, .external_lex_state = 322},
  [11716] = {.lex_state = 51, .external_lex_state = 322},
  [11717] = {.lex_state = 47, .external_lex_state = 305},
  [11718] = {.lex_state = 47, .external_lex_state = 305},
  [11719] = {.lex_state = 51, .external_lex_state = 365},
  [11720] = {.lex_state = 47, .external_lex_state = 301},
  [11721] = {.lex_state = 47, .external_lex_state = 301},
  [11722] = {.lex_state = 51, .external_lex_state = 322},
  [11723] = {.lex_state = 47, .external_lex_state = 301},
  [11724] = {.lex_state = 47, .external_lex_state = 301},
  [11725] = {.lex_state = 47, .external_lex_state = 303},
  [11726] = {.lex_state = 51, .external_lex_state = 319},
  [11727] = {.lex_state = 51, .external_lex_state = 318},
  [11728] = {.lex_state = 47, .external_lex_state = 303},
  [11729] = {.lex_state = 51, .external_lex_state = 322},
  [11730] = {.lex_state = 51, .external_lex_state = 318},
  [11731] = {.lex_state = 51, .external_lex_state = 318},
  [11732] = {.lex_state = 47, .external_lex_state = 303},
  [11733] = {.lex_state = 51, .external_lex_state = 322},
  [11734] = {.lex_state = 51, .external_lex_state = 318},
  [11735] = {.lex_state = 47, .external_lex_state = 301},
  [11736] = {.lex_state = 51, .external_lex_state = 318},
  [11737] = {.lex_state = 47, .external_lex_state = 317},
  [11738] = {.lex_state = 51, .external_lex_state = 322},
  [11739] = {.lex_state = 47, .external_lex_state = 301},
  [11740] = {.lex_state = 51, .external_lex_state = 319},
  [11741] = {.lex_state = 0, .external_lex_state = 311},
  [11742] = {.lex_state = 51, .external_lex_state = 322},
  [11743] = {.lex_state = 0, .external_lex_state = 249},
  [11744] = {.lex_state = 50, .external_lex_state = 380},
  [11745] = {.lex_state = 0, .external_lex_state = 249},
  [11746] = {.lex_state = 51, .external_lex_state = 319},
  [11747] = {.lex_state = 47, .external_lex_state = 317},
  [11748] = {.lex_state = 51, .external_lex_state = 319},
  [11749] = {.lex_state = 51, .external_lex_state = 319},
  [11750] = {.lex_state = 47, .external_lex_state = 303},
  [11751] = {.lex_state = 0, .external_lex_state = 379},
  [11752] = {.lex_state = 47, .external_lex_state = 381},
  [11753] = {.lex_state = 47, .external_lex_state = 315},
  [11754] = {.lex_state = 51, .external_lex_state = 322},
  [11755] = {.lex_state = 47, .external_lex_state = 303},
  [11756] = {.lex_state = 0, .external_lex_state = 249},
  [11757] = {.lex_state = 47, .external_lex_state = 301},
  [11758] = {.lex_state = 51, .external_lex_state = 322},
  [11759] = {.lex_state = 47, .external_lex_state = 301},
  [11760] = {.lex_state = 47, .external_lex_state = 305},
  [11761] = {.lex_state = 47, .external_lex_state = 382},
  [11762] = {.lex_state = 47, .external_lex_state = 383},
  [11763] = {.lex_state = 47, .external_lex_state = 314},
  [11764] = {.lex_state = 51, .external_lex_state = 319},
  [11765] = {.lex_state = 47, .external_lex_state = 302},
  [11766] = {.lex_state = 51, .external_lex_state = 322},
  [11767] = {.lex_state = 47, .external_lex_state = 314},
  [11768] = {.lex_state = 50, .external_lex_state = 308},
  [11769] = {.lex_state = 51, .external_lex_state = 318},
  [11770] = {.lex_state = 0, .external_lex_state = 249},
  [11771] = {.lex_state = 50, .external_lex_state = 188},
  [11772] = {.lex_state = 51, .external_lex_state = 319},
  [11773] = {.lex_state = 47, .external_lex_state = 301},
  [11774] = {.lex_state = 47, .external_lex_state = 314},
  [11775] = {.lex_state = 47, .external_lex_state = 315},
  [11776] = {.lex_state = 47, .external_lex_state = 304},
  [11777] = {.lex_state = 47, .external_lex_state = 304},
  [11778] = {.lex_state = 51, .external_lex_state = 319},
  [11779] = {.lex_state = 47, .external_lex_state = 304},
  [11780] = {.lex_state = 0, .external_lex_state = 249},
  [11781] = {.lex_state = 47, .external_lex_state = 302},
  [11782] = {.lex_state = 47, .external_lex_state = 304},
  [11783] = {.lex_state = 47, .external_lex_state = 302},
  [11784] = {.lex_state = 51, .external_lex_state = 319},
  [11785] = {.lex_state = 51, .external_lex_state = 318},
  [11786] = {.lex_state = 51, .external_lex_state = 318},
  [11787] = {.lex_state = 51, .external_lex_state = 319},
  [11788] = {.lex_state = 50, .external_lex_state = 355},
  [11789] = {.lex_state = 50, .external_lex_state = 355},
  [11790] = {.lex_state = 0, .external_lex_state = 249},
  [11791] = {.lex_state = 47, .external_lex_state = 302},
  [11792] = {.lex_state = 47, .external_lex_state = 304},
  [11793] = {.lex_state = 47, .external_lex_state = 303},
  [11794] = {.lex_state = 51, .external_lex_state = 319},
  [11795] = {.lex_state = 0, .external_lex_state = 249},
  [11796] = {.lex_state = 51, .external_lex_state = 319},
  [11797] = {.lex_state = 47, .external_lex_state = 304},
  [11798] = {.lex_state = 0, .external_lex_state = 249},
  [11799] = {.lex_state = 51, .external_lex_state = 322},
  [11800] = {.lex_state = 47, .external_lex_state = 317},
  [11801] = {.lex_state = 0, .external_lex_state = 249},
  [11802] = {.lex_state = 47, .external_lex_state = 317},
  [11803] = {.lex_state = 47, .external_lex_state = 314},
  [11804] = {.lex_state = 47, .external_lex_state = 314},
  [11805] = {.lex_state = 47, .external_lex_state = 304},
  [11806] = {.lex_state = 47, .external_lex_state = 304},
  [11807] = {.lex_state = 0, .external_lex_state = 249},
  [11808] = {.lex_state = 47, .external_lex_state = 301},
  [11809] = {.lex_state = 51, .external_lex_state = 319},
  [11810] = {.lex_state = 47, .external_lex_state = 301},
  [11811] = {.lex_state = 47, .external_lex_state = 345},
  [11812] = {.lex_state = 51, .external_lex_state = 318},
  [11813] = {.lex_state = 47, .external_lex_state = 304},
  [11814] = {.lex_state = 1, .external_lex_state = 308},
  [11815] = {.lex_state = 47, .external_lex_state = 304},
  [11816] = {.lex_state = 0, .external_lex_state = 249},
  [11817] = {.lex_state = 51, .external_lex_state = 319},
  [11818] = {.lex_state = 47, .external_lex_state = 304},
  [11819] = {.lex_state = 47, .external_lex_state = 302},
  [11820] = {.lex_state = 0, .external_lex_state = 249},
  [11821] = {.lex_state = 50, .external_lex_state = 308},
  [11822] = {.lex_state = 47, .external_lex_state = 304},
  [11823] = {.lex_state = 50, .external_lex_state = 188},
  [11824] = {.lex_state = 47, .external_lex_state = 302},
  [11825] = {.lex_state = 47, .external_lex_state = 302},
  [11826] = {.lex_state = 47, .external_lex_state = 314},
  [11827] = {.lex_state = 47, .external_lex_state = 314},
  [11828] = {.lex_state = 47, .external_lex_state = 303},
  [11829] = {.lex_state = 47, .external_lex_state = 303},
  [11830] = {.lex_state = 51, .external_lex_state = 319},
  [11831] = {.lex_state = 0, .external_lex_state = 249},
  [11832] = {.lex_state = 47, .external_lex_state = 317},
  [11833] = {.lex_state = 47, .external_lex_state = 317},
  [11834] = {.lex_state = 0, .external_lex_state = 249},
  [11835] = {.lex_state = 0, .external_lex_state = 310},
  [11836] = {.lex_state = 51, .external_lex_state = 322},
  [11837] = {.lex_state = 51, .external_lex_state = 322},
  [11838] = {.lex_state = 0, .external_lex_state = 384},
  [11839] = {.lex_state = 0, .external_lex_state = 249},
  [11840] = {.lex_state = 0, .external_lex_state = 310},
  [11841] = {.lex_state = 0, .external_lex_state = 249},
  [11842] = {.lex_state = 0, .external_lex_state = 310},
  [11843] = {.lex_state = 47, .external_lex_state = 301},
  [11844] = {.lex_state = 50, .external_lex_state = 188},
  [11845] = {.lex_state = 51, .external_lex_state = 322},
  [11846] = {.lex_state = 47, .external_lex_state = 313},
  [11847] = {.lex_state = 47, .external_lex_state = 317},
  [11848] = {.lex_state = 51, .external_lex_state = 365},
  [11849] = {.lex_state = 47, .external_lex_state = 313},
  [11850] = {.lex_state = 0, .external_lex_state = 311},
  [11851] = {.lex_state = 0, .external_lex_state = 249},
  [11852] = {.lex_state = 0, .external_lex_state = 310},
  [11853] = {.lex_state = 51, .external_lex_state = 322},
  [11854] = {.lex_state = 0, .external_lex_state = 310},
  [11855] = {.lex_state = 50, .external_lex_state = 355},
  [11856] = {.lex_state = 47, .external_lex_state = 314},
  [11857] = {.lex_state = 51, .external_lex_state = 319},
  [11858] = {.lex_state = 0, .external_lex_state = 378},
  [11859] = {.lex_state = 47, .external_lex_state = 315},
  [11860] = {.lex_state = 47, .external_lex_state = 313},
  [11861] = {.lex_state = 51, .external_lex_state = 322},
  [11862] = {.lex_state = 47, .external_lex_state = 313},
  [11863] = {.lex_state = 51, .external_lex_state = 319},
  [11864] = {.lex_state = 0, .external_lex_state = 310},
  [11865] = {.lex_state = 50, .external_lex_state = 355},
  [11866] = {.lex_state = 47, .external_lex_state = 313},
  [11867] = {.lex_state = 51, .external_lex_state = 322},
  [11868] = {.lex_state = 47, .external_lex_state = 313},
  [11869] = {.lex_state = 0, .external_lex_state = 310},
  [11870] = {.lex_state = 47, .external_lex_state = 301},
  [11871] = {.lex_state = 51, .external_lex_state = 322},
  [11872] = {.lex_state = 50, .external_lex_state = 188},
  [11873] = {.lex_state = 47, .external_lex_state = 301},
  [11874] = {.lex_state = 0, .external_lex_state = 310},
  [11875] = {.lex_state = 51, .external_lex_state = 322},
  [11876] = {.lex_state = 47, .external_lex_state = 301},
  [11877] = {.lex_state = 51, .external_lex_state = 322},
  [11878] = {.lex_state = 47, .external_lex_state = 313},
  [11879] = {.lex_state = 51, .external_lex_state = 318},
  [11880] = {.lex_state = 0, .external_lex_state = 249},
  [11881] = {.lex_state = 47, .external_lex_state = 302},
  [11882] = {.lex_state = 51, .external_lex_state = 318},
  [11883] = {.lex_state = 47, .external_lex_state = 302},
  [11884] = {.lex_state = 51, .external_lex_state = 319},
  [11885] = {.lex_state = 51, .external_lex_state = 322},
  [11886] = {.lex_state = 0, .external_lex_state = 249},
  [11887] = {.lex_state = 51, .external_lex_state = 322},
  [11888] = {.lex_state = 50, .external_lex_state = 355},
  [11889] = {.lex_state = 47, .external_lex_state = 314},
  [11890] = {.lex_state = 47, .external_lex_state = 314},
  [11891] = {.lex_state = 47, .external_lex_state = 313},
  [11892] = {.lex_state = 51, .external_lex_state = 319},
  [11893] = {.lex_state = 51, .external_lex_state = 322},
  [11894] = {.lex_state = 47, .external_lex_state = 303},
  [11895] = {.lex_state = 51, .external_lex_state = 322},
  [11896] = {.lex_state = 51, .external_lex_state = 319},
  [11897] = {.lex_state = 51, .external_lex_state = 322},
  [11898] = {.lex_state = 0, .external_lex_state = 310},
  [11899] = {.lex_state = 47, .external_lex_state = 313},
  [11900] = {.lex_state = 47, .external_lex_state = 385},
  [11901] = {.lex_state = 0, .external_lex_state = 249},
  [11902] = {.lex_state = 50, .external_lex_state = 188},
  [11903] = {.lex_state = 47, .external_lex_state = 303},
  [11904] = {.lex_state = 51, .external_lex_state = 318},
  [11905] = {.lex_state = 47, .external_lex_state = 301},
  [11906] = {.lex_state = 47, .external_lex_state = 314},
  [11907] = {.lex_state = 47, .external_lex_state = 313},
  [11908] = {.lex_state = 0, .external_lex_state = 310},
  [11909] = {.lex_state = 51, .external_lex_state = 319},
  [11910] = {.lex_state = 51, .external_lex_state = 318},
  [11911] = {.lex_state = 47, .external_lex_state = 302},
  [11912] = {.lex_state = 0, .external_lex_state = 249},
  [11913] = {.lex_state = 51, .external_lex_state = 322},
  [11914] = {.lex_state = 51, .external_lex_state = 318},
  [11915] = {.lex_state = 51, .external_lex_state = 318},
  [11916] = {.lex_state = 51, .external_lex_state = 318},
  [11917] = {.lex_state = 51, .external_lex_state = 322},
  [11918] = {.lex_state = 51, .external_lex_state = 318},
  [11919] = {.lex_state = 51, .external_lex_state = 319},
  [11920] = {.lex_state = 0, .external_lex_state = 249},
  [11921] = {.lex_state = 51, .external_lex_state = 319},
  [11922] = {.lex_state = 47, .external_lex_state = 302},
  [11923] = {.lex_state = 47, .external_lex_state = 302},
  [11924] = {.lex_state = 51, .external_lex_state = 322},
  [11925] = {.lex_state = 51, .external_lex_state = 318},
  [11926] = {.lex_state = 51, .external_lex_state = 318},
  [11927] = {.lex_state = 0, .external_lex_state = 386},
  [11928] = {.lex_state = 51, .external_lex_state = 322},
  [11929] = {.lex_state = 51, .external_lex_state = 318},
  [11930] = {.lex_state = 51, .external_lex_state = 318},
  [11931] = {.lex_state = 51, .external_lex_state = 318},
  [11932] = {.lex_state = 0, .external_lex_state = 249},
  [11933] = {.lex_state = 51, .external_lex_state = 318},
  [11934] = {.lex_state = 51, .external_lex_state = 319},
  [11935] = {.lex_state = 50, .external_lex_state = 188},
  [11936] = {.lex_state = 0, .external_lex_state = 249},
  [11937] = {.lex_state = 47, .external_lex_state = 313},
  [11938] = {.lex_state = 51, .external_lex_state = 319},
  [11939] = {.lex_state = 51, .external_lex_state = 318},
  [11940] = {.lex_state = 51, .external_lex_state = 319},
  [11941] = {.lex_state = 51, .external_lex_state = 319},
  [11942] = {.lex_state = 51, .external_lex_state = 319},
  [11943] = {.lex_state = 51, .external_lex_state = 325},
  [11944] = {.lex_state = 47, .external_lex_state = 313},
  [11945] = {.lex_state = 47, .external_lex_state = 385},
  [11946] = {.lex_state = 47, .external_lex_state = 313},
  [11947] = {.lex_state = 0, .external_lex_state = 311},
  [11948] = {.lex_state = 51, .external_lex_state = 309},
  [11949] = {.lex_state = 47, .external_lex_state = 315},
  [11950] = {.lex_state = 47, .external_lex_state = 345},
  [11951] = {.lex_state = 51, .external_lex_state = 325},
  [11952] = {.lex_state = 51, .external_lex_state = 325},
  [11953] = {.lex_state = 0, .external_lex_state = 319},
  [11954] = {.lex_state = 0, .external_lex_state = 319},
  [11955] = {.lex_state = 0, .external_lex_state = 322},
  [11956] = {.lex_state = 51, .external_lex_state = 325},
  [11957] = {.lex_state = 50, .external_lex_state = 308},
  [11958] = {.lex_state = 51, .external_lex_state = 325},
  [11959] = {.lex_state = 50, .external_lex_state = 308},
  [11960] = {.lex_state = 47, .external_lex_state = 314},
  [11961] = {.lex_state = 47, .external_lex_state = 317},
  [11962] = {.lex_state = 0, .external_lex_state = 319},
  [11963] = {.lex_state = 47, .external_lex_state = 316},
  [11964] = {.lex_state = 47, .external_lex_state = 317},
  [11965] = {.lex_state = 47, .external_lex_state = 313},
  [11966] = {.lex_state = 0, .external_lex_state = 310},
  [11967] = {.lex_state = 0, .external_lex_state = 310},
  [11968] = {.lex_state = 50, .external_lex_state = 308},
  [11969] = {.lex_state = 0, .external_lex_state = 322},
  [11970] = {.lex_state = 51, .external_lex_state = 325},
  [11971] = {.lex_state = 0, .external_lex_state = 319},
  [11972] = {.lex_state = 47, .external_lex_state = 316},
  [11973] = {.lex_state = 51, .external_lex_state = 325},
  [11974] = {.lex_state = 51, .external_lex_state = 325},
  [11975] = {.lex_state = 50, .external_lex_state = 308},
  [11976] = {.lex_state = 0, .external_lex_state = 311},
  [11977] = {.lex_state = 51, .external_lex_state = 325},
  [11978] = {.lex_state = 51, .external_lex_state = 325},
  [11979] = {.lex_state = 0, .external_lex_state = 322},
  [11980] = {.lex_state = 47, .external_lex_state = 316},
  [11981] = {.lex_state = 47, .external_lex_state = 316},
  [11982] = {.lex_state = 47, .external_lex_state = 313},
  [11983] = {.lex_state = 0, .external_lex_state = 311},
  [11984] = {.lex_state = 51, .external_lex_state = 309},
  [11985] = {.lex_state = 0, .external_lex_state = 311},
  [11986] = {.lex_state = 47, .external_lex_state = 317},
  [11987] = {.lex_state = 47, .external_lex_state = 317},
  [11988] = {.lex_state = 47, .external_lex_state = 317},
  [11989] = {.lex_state = 51, .external_lex_state = 325},
  [11990] = {.lex_state = 0, .external_lex_state = 311},
  [11991] = {.lex_state = 47, .external_lex_state = 314},
  [11992] = {.lex_state = 0, .external_lex_state = 318},
  [11993] = {.lex_state = 0, .external_lex_state = 319},
  [11994] = {.lex_state = 51, .external_lex_state = 325},
  [11995] = {.lex_state = 47, .external_lex_state = 387},
  [11996] = {.lex_state = 47, .external_lex_state = 315},
  [11997] = {.lex_state = 0, .external_lex_state = 311},
  [11998] = {.lex_state = 47, .external_lex_state = 315},
  [11999] = {.lex_state = 0, .external_lex_state = 311},
  [12000] = {.lex_state = 0, .external_lex_state = 311},
  [12001] = {.lex_state = 47, .external_lex_state = 316},
  [12002] = {.lex_state = 47, .external_lex_state = 314},
  [12003] = {.lex_state = 47, .external_lex_state = 314},
  [12004] = {.lex_state = 47, .external_lex_state = 315},
  [12005] = {.lex_state = 47, .external_lex_state = 316},
  [12006] = {.lex_state = 47, .external_lex_state = 316},
  [12007] = {.lex_state = 47, .external_lex_state = 315},
  [12008] = {.lex_state = 47, .external_lex_state = 313},
  [12009] = {.lex_state = 50, .external_lex_state = 308},
  [12010] = {.lex_state = 50, .external_lex_state = 308},
  [12011] = {.lex_state = 47, .external_lex_state = 317},
  [12012] = {.lex_state = 51, .external_lex_state = 325},
  [12013] = {.lex_state = 50, .external_lex_state = 308},
  [12014] = {.lex_state = 47, .external_lex_state = 315},
  [12015] = {.lex_state = 47, .external_lex_state = 243},
  [12016] = {.lex_state = 47, .external_lex_state = 315},
  [12017] = {.lex_state = 47, .external_lex_state = 316},
  [12018] = {.lex_state = 47, .external_lex_state = 317},
  [12019] = {.lex_state = 50, .external_lex_state = 308},
  [12020] = {.lex_state = 47, .external_lex_state = 315},
  [12021] = {.lex_state = 50, .external_lex_state = 308},
  [12022] = {.lex_state = 47, .external_lex_state = 345},
  [12023] = {.lex_state = 0, .external_lex_state = 311},
  [12024] = {.lex_state = 0, .external_lex_state = 343},
  [12025] = {.lex_state = 0, .external_lex_state = 343},
  [12026] = {.lex_state = 47, .external_lex_state = 316},
  [12027] = {.lex_state = 0, .external_lex_state = 318},
  [12028] = {.lex_state = 47, .external_lex_state = 317},
  [12029] = {.lex_state = 51, .external_lex_state = 325},
  [12030] = {.lex_state = 51, .external_lex_state = 325},
  [12031] = {.lex_state = 51, .external_lex_state = 325},
  [12032] = {.lex_state = 51, .external_lex_state = 325},
  [12033] = {.lex_state = 51, .external_lex_state = 325},
  [12034] = {.lex_state = 51, .external_lex_state = 309},
  [12035] = {.lex_state = 51, .external_lex_state = 325},
  [12036] = {.lex_state = 47, .external_lex_state = 317},
  [12037] = {.lex_state = 0, .external_lex_state = 310},
  [12038] = {.lex_state = 47, .external_lex_state = 316},
  [12039] = {.lex_state = 51, .external_lex_state = 325},
  [12040] = {.lex_state = 0, .external_lex_state = 188},
  [12041] = {.lex_state = 0, .external_lex_state = 310},
  [12042] = {.lex_state = 47, .external_lex_state = 316},
  [12043] = {.lex_state = 47, .external_lex_state = 316},
  [12044] = {.lex_state = 0, .external_lex_state = 311},
  [12045] = {.lex_state = 51, .external_lex_state = 325},
  [12046] = {.lex_state = 47, .external_lex_state = 316},
  [12047] = {.lex_state = 0, .external_lex_state = 311},
  [12048] = {.lex_state = 47, .external_lex_state = 316},
  [12049] = {.lex_state = 51, .external_lex_state = 325},
  [12050] = {.lex_state = 51, .external_lex_state = 325},
  [12051] = {.lex_state = 51, .external_lex_state = 325},
  [12052] = {.lex_state = 47, .external_lex_state = 313},
  [12053] = {.lex_state = 0, .external_lex_state = 310},
  [12054] = {.lex_state = 50, .external_lex_state = 308},
  [12055] = {.lex_state = 0, .external_lex_state = 318},
  [12056] = {.lex_state = 47, .external_lex_state = 388},
  [12057] = {.lex_state = 0, .external_lex_state = 311},
  [12058] = {.lex_state = 47, .external_lex_state = 316},
  [12059] = {.lex_state = 47, .external_lex_state = 314},
  [12060] = {.lex_state = 0, .external_lex_state = 389},
  [12061] = {.lex_state = 47, .external_lex_state = 316},
  [12062] = {.lex_state = 47, .external_lex_state = 313},
  [12063] = {.lex_state = 51, .external_lex_state = 325},
  [12064] = {.lex_state = 47, .external_lex_state = 314},
  [12065] = {.lex_state = 0, .external_lex_state = 319},
  [12066] = {.lex_state = 47, .external_lex_state = 315},
  [12067] = {.lex_state = 51, .external_lex_state = 325},
  [12068] = {.lex_state = 0, .external_lex_state = 322},
  [12069] = {.lex_state = 0, .external_lex_state = 311},
  [12070] = {.lex_state = 0, .external_lex_state = 310},
  [12071] = {.lex_state = 47, .external_lex_state = 313},
  [12072] = {.lex_state = 0, .external_lex_state = 310},
  [12073] = {.lex_state = 0, .external_lex_state = 322},
  [12074] = {.lex_state = 0, .external_lex_state = 311},
  [12075] = {.lex_state = 0, .external_lex_state = 311},
  [12076] = {.lex_state = 50, .external_lex_state = 308},
  [12077] = {.lex_state = 47, .external_lex_state = 314},
  [12078] = {.lex_state = 47, .external_lex_state = 315},
  [12079] = {.lex_state = 50, .external_lex_state = 308},
  [12080] = {.lex_state = 47, .external_lex_state = 314},
  [12081] = {.lex_state = 50, .external_lex_state = 308},
  [12082] = {.lex_state = 0, .external_lex_state = 322},
  [12083] = {.lex_state = 50, .external_lex_state = 308},
  [12084] = {.lex_state = 0, .external_lex_state = 390},
  [12085] = {.lex_state = 51, .external_lex_state = 325},
  [12086] = {.lex_state = 47, .external_lex_state = 317},
  [12087] = {.lex_state = 50, .external_lex_state = 308},
  [12088] = {.lex_state = 47, .external_lex_state = 313},
  [12089] = {.lex_state = 0, .external_lex_state = 344},
  [12090] = {.lex_state = 0, .external_lex_state = 319},
  [12091] = {.lex_state = 0, .external_lex_state = 391},
  [12092] = {.lex_state = 47, .external_lex_state = 313},
  [12093] = {.lex_state = 0, .external_lex_state = 318},
  [12094] = {.lex_state = 47, .external_lex_state = 313},
  [12095] = {.lex_state = 47, .external_lex_state = 313},
  [12096] = {.lex_state = 51, .external_lex_state = 325},
  [12097] = {.lex_state = 47, .external_lex_state = 313},
  [12098] = {.lex_state = 47, .external_lex_state = 317},
  [12099] = {.lex_state = 51, .external_lex_state = 325},
  [12100] = {.lex_state = 47, .external_lex_state = 317},
  [12101] = {.lex_state = 0, .external_lex_state = 318},
  [12102] = {.lex_state = 0, .external_lex_state = 318},
  [12103] = {.lex_state = 47, .external_lex_state = 344},
  [12104] = {.lex_state = 0, .external_lex_state = 322},
  [12105] = {.lex_state = 0, .external_lex_state = 322},
  [12106] = {.lex_state = 47, .external_lex_state = 315},
  [12107] = {.lex_state = 50, .external_lex_state = 308},
  [12108] = {.lex_state = 47, .external_lex_state = 314},
  [12109] = {.lex_state = 0, .external_lex_state = 311},
  [12110] = {.lex_state = 51, .external_lex_state = 325},
  [12111] = {.lex_state = 0, .external_lex_state = 188},
  [12112] = {.lex_state = 47, .external_lex_state = 314},
  [12113] = {.lex_state = 47, .external_lex_state = 314},
  [12114] = {.lex_state = 0, .external_lex_state = 389},
  [12115] = {.lex_state = 50, .external_lex_state = 308},
  [12116] = {.lex_state = 0, .external_lex_state = 343},
  [12117] = {.lex_state = 51, .external_lex_state = 325},
  [12118] = {.lex_state = 47, .external_lex_state = 316},
  [12119] = {.lex_state = 51, .external_lex_state = 392},
  [12120] = {.lex_state = 51, .external_lex_state = 309},
  [12121] = {.lex_state = 50, .external_lex_state = 308},
  [12122] = {.lex_state = 51, .external_lex_state = 309},
  [12123] = {.lex_state = 47, .external_lex_state = 314},
  [12124] = {.lex_state = 0, .external_lex_state = 310},
  [12125] = {.lex_state = 47, .external_lex_state = 314},
  [12126] = {.lex_state = 0, .external_lex_state = 310},
  [12127] = {.lex_state = 50, .external_lex_state = 308},
  [12128] = {.lex_state = 50, .external_lex_state = 308},
  [12129] = {.lex_state = 0, .external_lex_state = 210},
  [12130] = {.lex_state = 51, .external_lex_state = 309},
  [12131] = {.lex_state = 51, .external_lex_state = 309},
  [12132] = {.lex_state = 47, .external_lex_state = 314},
  [12133] = {.lex_state = 50, .external_lex_state = 308},
  [12134] = {.lex_state = 47, .external_lex_state = 344},
  [12135] = {.lex_state = 47, .external_lex_state = 345},
  [12136] = {.lex_state = 51, .external_lex_state = 309},
  [12137] = {.lex_state = 47, .external_lex_state = 317},
  [12138] = {.lex_state = 0, .external_lex_state = 310},
  [12139] = {.lex_state = 0, .external_lex_state = 319},
  [12140] = {.lex_state = 0, .external_lex_state = 310},
  [12141] = {.lex_state = 47, .external_lex_state = 317},
  [12142] = {.lex_state = 0, .external_lex_state = 310},
  [12143] = {.lex_state = 0, .external_lex_state = 343},
  [12144] = {.lex_state = 0, .external_lex_state = 319},
  [12145] = {.lex_state = 0, .external_lex_state = 310},
  [12146] = {.lex_state = 0, .external_lex_state = 322},
  [12147] = {.lex_state = 47, .external_lex_state = 314},
  [12148] = {.lex_state = 47, .external_lex_state = 315},
  [12149] = {.lex_state = 0, .external_lex_state = 310},
  [12150] = {.lex_state = 47, .external_lex_state = 317},
  [12151] = {.lex_state = 47, .external_lex_state = 315},
  [12152] = {.lex_state = 50, .external_lex_state = 308},
  [12153] = {.lex_state = 51, .external_lex_state = 309},
  [12154] = {.lex_state = 47, .external_lex_state = 314},
  [12155] = {.lex_state = 51, .external_lex_state = 325},
  [12156] = {.lex_state = 51, .external_lex_state = 309},
  [12157] = {.lex_state = 47, .external_lex_state = 343},
  [12158] = {.lex_state = 0, .external_lex_state = 360},
  [12159] = {.lex_state = 0, .external_lex_state = 310},
  [12160] = {.lex_state = 47, .external_lex_state = 317},
  [12161] = {.lex_state = 0, .external_lex_state = 311},
  [12162] = {.lex_state = 0, .external_lex_state = 310},
  [12163] = {.lex_state = 0, .external_lex_state = 322},
  [12164] = {.lex_state = 47, .external_lex_state = 313},
  [12165] = {.lex_state = 51, .external_lex_state = 309},
  [12166] = {.lex_state = 50, .external_lex_state = 308},
  [12167] = {.lex_state = 50, .external_lex_state = 308},
  [12168] = {.lex_state = 47, .external_lex_state = 355},
  [12169] = {.lex_state = 51, .external_lex_state = 325},
  [12170] = {.lex_state = 47, .external_lex_state = 315},
  [12171] = {.lex_state = 47, .external_lex_state = 314},
  [12172] = {.lex_state = 47, .external_lex_state = 315},
  [12173] = {.lex_state = 51, .external_lex_state = 325},
  [12174] = {.lex_state = 50, .external_lex_state = 308},
  [12175] = {.lex_state = 0, .external_lex_state = 343},
  [12176] = {.lex_state = 51, .external_lex_state = 309},
  [12177] = {.lex_state = 50, .external_lex_state = 308},
  [12178] = {.lex_state = 51, .external_lex_state = 309},
  [12179] = {.lex_state = 51, .external_lex_state = 325},
  [12180] = {.lex_state = 0, .external_lex_state = 310},
  [12181] = {.lex_state = 47, .external_lex_state = 345},
  [12182] = {.lex_state = 51, .external_lex_state = 325},
  [12183] = {.lex_state = 47, .external_lex_state = 393},
  [12184] = {.lex_state = 50, .external_lex_state = 308},
  [12185] = {.lex_state = 51, .external_lex_state = 325},
  [12186] = {.lex_state = 0, .external_lex_state = 188},
  [12187] = {.lex_state = 51, .external_lex_state = 325},
  [12188] = {.lex_state = 0, .external_lex_state = 318},
  [12189] = {.lex_state = 50, .external_lex_state = 308},
  [12190] = {.lex_state = 51, .external_lex_state = 325},
  [12191] = {.lex_state = 0, .external_lex_state = 188},
  [12192] = {.lex_state = 47, .external_lex_state = 315},
  [12193] = {.lex_state = 0, .external_lex_state = 345},
  [12194] = {.lex_state = 51, .external_lex_state = 325},
  [12195] = {.lex_state = 47, .external_lex_state = 344},
  [12196] = {.lex_state = 47, .external_lex_state = 315},
  [12197] = {.lex_state = 0, .external_lex_state = 394},
  [12198] = {.lex_state = 47, .external_lex_state = 313},
  [12199] = {.lex_state = 47, .external_lex_state = 344},
  [12200] = {.lex_state = 47, .external_lex_state = 313},
  [12201] = {.lex_state = 0, .external_lex_state = 319},
  [12202] = {.lex_state = 47, .external_lex_state = 314},
  [12203] = {.lex_state = 47, .external_lex_state = 395},
  [12204] = {.lex_state = 0, .external_lex_state = 318},
  [12205] = {.lex_state = 51, .external_lex_state = 309},
  [12206] = {.lex_state = 51, .external_lex_state = 325},
  [12207] = {.lex_state = 51, .external_lex_state = 325},
  [12208] = {.lex_state = 51, .external_lex_state = 309},
  [12209] = {.lex_state = 50, .external_lex_state = 308},
  [12210] = {.lex_state = 51, .external_lex_state = 309},
  [12211] = {.lex_state = 47, .external_lex_state = 315},
  [12212] = {.lex_state = 50, .external_lex_state = 308},
  [12213] = {.lex_state = 0, .external_lex_state = 318},
  [12214] = {.lex_state = 51, .external_lex_state = 325},
  [12215] = {.lex_state = 51, .external_lex_state = 325},
  [12216] = {.lex_state = 0, .external_lex_state = 389},
  [12217] = {.lex_state = 47, .external_lex_state = 313},
  [12218] = {.lex_state = 51, .external_lex_state = 309},
  [12219] = {.lex_state = 0, .external_lex_state = 318},
  [12220] = {.lex_state = 51, .external_lex_state = 325},
  [12221] = {.lex_state = 47, .external_lex_state = 313},
  [12222] = {.lex_state = 51, .external_lex_state = 325},
  [12223] = {.lex_state = 51, .external_lex_state = 325},
  [12224] = {.lex_state = 47, .external_lex_state = 317},
  [12225] = {.lex_state = 0, .external_lex_state = 319},
  [12226] = {.lex_state = 50, .external_lex_state = 308},
  [12227] = {.lex_state = 0, .external_lex_state = 322},
  [12228] = {.lex_state = 47, .external_lex_state = 385},
  [12229] = {.lex_state = 0, .external_lex_state = 318},
  [12230] = {.lex_state = 50, .external_lex_state = 308},
  [12231] = {.lex_state = 47, .external_lex_state = 317},
  [12232] = {.lex_state = 50, .external_lex_state = 308},
  [12233] = {.lex_state = 0, .external_lex_state = 319},
  [12234] = {.lex_state = 50, .external_lex_state = 308},
  [12235] = {.lex_state = 50, .external_lex_state = 308},
  [12236] = {.lex_state = 0, .external_lex_state = 360},
  [12237] = {.lex_state = 0, .external_lex_state = 343},
  [12238] = {.lex_state = 0, .external_lex_state = 322},
  [12239] = {.lex_state = 50, .external_lex_state = 308},
  [12240] = {.lex_state = 47, .external_lex_state = 395},
  [12241] = {.lex_state = 0, .external_lex_state = 319},
  [12242] = {.lex_state = 50, .external_lex_state = 308},
  [12243] = {.lex_state = 51, .external_lex_state = 396},
  [12244] = {.lex_state = 50, .external_lex_state = 308},
  [12245] = {.lex_state = 0, .external_lex_state = 322},
  [12246] = {.lex_state = 0, .external_lex_state = 322},
  [12247] = {.lex_state = 50, .external_lex_state = 345},
  [12248] = {.lex_state = 50, .external_lex_state = 308},
  [12249] = {.lex_state = 0, .external_lex_state = 360},
  [12250] = {.lex_state = 0, .external_lex_state = 360},
  [12251] = {.lex_state = 50, .external_lex_state = 397},
  [12252] = {.lex_state = 50, .external_lex_state = 308},
  [12253] = {.lex_state = 0, .external_lex_state = 343},
  [12254] = {.lex_state = 50, .external_lex_state = 308},
  [12255] = {.lex_state = 0, .external_lex_state = 343},
  [12256] = {.lex_state = 0, .external_lex_state = 343},
  [12257] = {.lex_state = 50, .external_lex_state = 308},
  [12258] = {.lex_state = 0, .external_lex_state = 322},
  [12259] = {.lex_state = 0, .external_lex_state = 322},
  [12260] = {.lex_state = 50, .external_lex_state = 308},
  [12261] = {.lex_state = 0, .external_lex_state = 343},
  [12262] = {.lex_state = 50, .external_lex_state = 308},
  [12263] = {.lex_state = 50, .external_lex_state = 308},
  [12264] = {.lex_state = 0, .external_lex_state = 343},
  [12265] = {.lex_state = 0, .external_lex_state = 188},
  [12266] = {.lex_state = 0, .external_lex_state = 355},
  [12267] = {.lex_state = 50, .external_lex_state = 397},
  [12268] = {.lex_state = 0, .external_lex_state = 343},
  [12269] = {.lex_state = 0, .external_lex_state = 343},
  [12270] = {.lex_state = 47, .external_lex_state = 388},
  [12271] = {.lex_state = 0, .external_lex_state = 325},
  [12272] = {.lex_state = 50, .external_lex_state = 308},
  [12273] = {.lex_state = 50, .external_lex_state = 308},
  [12274] = {.lex_state = 50, .external_lex_state = 308},
  [12275] = {.lex_state = 50, .external_lex_state = 308},
  [12276] = {.lex_state = 50, .external_lex_state = 308},
  [12277] = {.lex_state = 50, .external_lex_state = 308},
  [12278] = {.lex_state = 0, .external_lex_state = 343},
  [12279] = {.lex_state = 0, .external_lex_state = 322},
  [12280] = {.lex_state = 50, .external_lex_state = 308},
  [12281] = {.lex_state = 0, .external_lex_state = 343},
  [12282] = {.lex_state = 50, .external_lex_state = 308},
  [12283] = {.lex_state = 0, .external_lex_state = 343},
  [12284] = {.lex_state = 0, .external_lex_state = 249},
  [12285] = {.lex_state = 0, .external_lex_state = 343},
  [12286] = {.lex_state = 0, .external_lex_state = 343},
  [12287] = {.lex_state = 50, .external_lex_state = 308},
  [12288] = {.lex_state = 0, .external_lex_state = 318},
  [12289] = {.lex_state = 0, .external_lex_state = 343},
  [12290] = {.lex_state = 0, .external_lex_state = 360},
  [12291] = {.lex_state = 50, .external_lex_state = 308},
  [12292] = {.lex_state = 0, .external_lex_state = 322},
  [12293] = {.lex_state = 47, .external_lex_state = 398},
  [12294] = {.lex_state = 0, .external_lex_state = 343},
  [12295] = {.lex_state = 50, .external_lex_state = 308},
  [12296] = {.lex_state = 0, .external_lex_state = 319},
  [12297] = {.lex_state = 0, .external_lex_state = 319},
  [12298] = {.lex_state = 0, .external_lex_state = 319},
  [12299] = {.lex_state = 0, .external_lex_state = 343},
  [12300] = {.lex_state = 0, .external_lex_state = 322},
  [12301] = {.lex_state = 51, .external_lex_state = 392},
  [12302] = {.lex_state = 0, .external_lex_state = 249},
  [12303] = {.lex_state = 50, .external_lex_state = 399},
  [12304] = {.lex_state = 50, .external_lex_state = 308},
  [12305] = {.lex_state = 50, .external_lex_state = 308},
  [12306] = {.lex_state = 50, .external_lex_state = 397},
  [12307] = {.lex_state = 0, .external_lex_state = 322},
  [12308] = {.lex_state = 50, .external_lex_state = 308},
  [12309] = {.lex_state = 0, .external_lex_state = 318},
  [12310] = {.lex_state = 50, .external_lex_state = 308},
  [12311] = {.lex_state = 50, .external_lex_state = 308},
  [12312] = {.lex_state = 47, .external_lex_state = 400},
  [12313] = {.lex_state = 0, .external_lex_state = 318},
  [12314] = {.lex_state = 50, .external_lex_state = 344},
  [12315] = {.lex_state = 0, .external_lex_state = 343},
  [12316] = {.lex_state = 50, .external_lex_state = 308},
  [12317] = {.lex_state = 47, .external_lex_state = 395},
  [12318] = {.lex_state = 50, .external_lex_state = 344},
  [12319] = {.lex_state = 0, .external_lex_state = 322},
  [12320] = {.lex_state = 50, .external_lex_state = 308},
  [12321] = {.lex_state = 0, .external_lex_state = 319},
  [12322] = {.lex_state = 0, .external_lex_state = 343},
  [12323] = {.lex_state = 0, .external_lex_state = 319},
  [12324] = {.lex_state = 50, .external_lex_state = 308},
  [12325] = {.lex_state = 47, .external_lex_state = 249},
  [12326] = {.lex_state = 0, .external_lex_state = 318},
  [12327] = {.lex_state = 0, .external_lex_state = 319},
  [12328] = {.lex_state = 50, .external_lex_state = 308},
  [12329] = {.lex_state = 0, .external_lex_state = 322},
  [12330] = {.lex_state = 0, .external_lex_state = 319},
  [12331] = {.lex_state = 50, .external_lex_state = 308},
  [12332] = {.lex_state = 0, .external_lex_state = 319},
  [12333] = {.lex_state = 50, .external_lex_state = 344},
  [12334] = {.lex_state = 50, .external_lex_state = 308},
  [12335] = {.lex_state = 50, .external_lex_state = 308},
  [12336] = {.lex_state = 50, .external_lex_state = 308},
  [12337] = {.lex_state = 50, .external_lex_state = 399},
  [12338] = {.lex_state = 0, .external_lex_state = 343},
  [12339] = {.lex_state = 47, .external_lex_state = 393},
  [12340] = {.lex_state = 51, .external_lex_state = 392},
  [12341] = {.lex_state = 47, .external_lex_state = 399},
  [12342] = {.lex_state = 50, .external_lex_state = 308},
  [12343] = {.lex_state = 50, .external_lex_state = 308},
  [12344] = {.lex_state = 0, .external_lex_state = 343},
  [12345] = {.lex_state = 50, .external_lex_state = 397},
  [12346] = {.lex_state = 0, .external_lex_state = 343},
  [12347] = {.lex_state = 50, .external_lex_state = 308},
  [12348] = {.lex_state = 50, .external_lex_state = 308},
  [12349] = {.lex_state = 0, .external_lex_state = 319},
  [12350] = {.lex_state = 0, .external_lex_state = 319},
  [12351] = {.lex_state = 0, .external_lex_state = 319},
  [12352] = {.lex_state = 0, .external_lex_state = 319},
  [12353] = {.lex_state = 0, .external_lex_state = 335},
  [12354] = {.lex_state = 50, .external_lex_state = 308},
  [12355] = {.lex_state = 50, .external_lex_state = 308},
  [12356] = {.lex_state = 50, .external_lex_state = 308},
  [12357] = {.lex_state = 50, .external_lex_state = 308},
  [12358] = {.lex_state = 47, .external_lex_state = 401},
  [12359] = {.lex_state = 50, .external_lex_state = 308},
  [12360] = {.lex_state = 50, .external_lex_state = 308},
  [12361] = {.lex_state = 50, .external_lex_state = 308},
  [12362] = {.lex_state = 50, .external_lex_state = 308},
  [12363] = {.lex_state = 50, .external_lex_state = 308},
  [12364] = {.lex_state = 47, .external_lex_state = 388},
  [12365] = {.lex_state = 0, .external_lex_state = 360},
  [12366] = {.lex_state = 50, .external_lex_state = 308},
  [12367] = {.lex_state = 47, .external_lex_state = 355},
  [12368] = {.lex_state = 50, .external_lex_state = 308},
  [12369] = {.lex_state = 50, .external_lex_state = 399},
  [12370] = {.lex_state = 50, .external_lex_state = 308},
  [12371] = {.lex_state = 47, .external_lex_state = 402},
  [12372] = {.lex_state = 50, .external_lex_state = 345},
  [12373] = {.lex_state = 50, .external_lex_state = 308},
  [12374] = {.lex_state = 50, .external_lex_state = 308},
  [12375] = {.lex_state = 50, .external_lex_state = 308},
  [12376] = {.lex_state = 50, .external_lex_state = 308},
  [12377] = {.lex_state = 50, .external_lex_state = 308},
  [12378] = {.lex_state = 50, .external_lex_state = 399},
  [12379] = {.lex_state = 50, .external_lex_state = 308},
  [12380] = {.lex_state = 0, .external_lex_state = 343},
  [12381] = {.lex_state = 50, .external_lex_state = 308},
  [12382] = {.lex_state = 50, .external_lex_state = 308},
  [12383] = {.lex_state = 50, .external_lex_state = 308},
  [12384] = {.lex_state = 50, .external_lex_state = 308},
  [12385] = {.lex_state = 0, .external_lex_state = 318},
  [12386] = {.lex_state = 0, .external_lex_state = 343},
  [12387] = {.lex_state = 47, .external_lex_state = 397},
  [12388] = {.lex_state = 0, .external_lex_state = 343},
  [12389] = {.lex_state = 50, .external_lex_state = 308},
  [12390] = {.lex_state = 0, .external_lex_state = 343},
  [12391] = {.lex_state = 0, .external_lex_state = 343},
  [12392] = {.lex_state = 50, .external_lex_state = 308},
  [12393] = {.lex_state = 0, .external_lex_state = 343},
  [12394] = {.lex_state = 50, .external_lex_state = 308},
  [12395] = {.lex_state = 0, .external_lex_state = 322},
  [12396] = {.lex_state = 0, .external_lex_state = 318},
  [12397] = {.lex_state = 0, .external_lex_state = 325},
  [12398] = {.lex_state = 0, .external_lex_state = 343},
  [12399] = {.lex_state = 0, .external_lex_state = 319},
  [12400] = {.lex_state = 0, .external_lex_state = 319},
  [12401] = {.lex_state = 50, .external_lex_state = 308},
  [12402] = {.lex_state = 50, .external_lex_state = 308},
  [12403] = {.lex_state = 50, .external_lex_state = 308},
  [12404] = {.lex_state = 50, .external_lex_state = 308},
  [12405] = {.lex_state = 50, .external_lex_state = 308},
  [12406] = {.lex_state = 50, .external_lex_state = 308},
  [12407] = {.lex_state = 0, .external_lex_state = 318},
  [12408] = {.lex_state = 50, .external_lex_state = 308},
  [12409] = {.lex_state = 50, .external_lex_state = 308},
  [12410] = {.lex_state = 0, .external_lex_state = 318},
  [12411] = {.lex_state = 0, .external_lex_state = 343},
  [12412] = {.lex_state = 0, .external_lex_state = 318},
  [12413] = {.lex_state = 0, .external_lex_state = 249},
  [12414] = {.lex_state = 0, .external_lex_state = 318},
  [12415] = {.lex_state = 50, .external_lex_state = 308},
  [12416] = {.lex_state = 0, .external_lex_state = 322},
  [12417] = {.lex_state = 50, .external_lex_state = 308},
  [12418] = {.lex_state = 50, .external_lex_state = 308},
  [12419] = {.lex_state = 50, .external_lex_state = 308},
  [12420] = {.lex_state = 50, .external_lex_state = 308},
  [12421] = {.lex_state = 50, .external_lex_state = 308},
  [12422] = {.lex_state = 47, .external_lex_state = 387},
  [12423] = {.lex_state = 50, .external_lex_state = 308},
  [12424] = {.lex_state = 0, .external_lex_state = 318},
  [12425] = {.lex_state = 47, .external_lex_state = 403},
  [12426] = {.lex_state = 0, .external_lex_state = 319},
  [12427] = {.lex_state = 0, .external_lex_state = 322},
  [12428] = {.lex_state = 50, .external_lex_state = 404},
  [12429] = {.lex_state = 0, .external_lex_state = 318},
  [12430] = {.lex_state = 50, .external_lex_state = 308},
  [12431] = {.lex_state = 0, .external_lex_state = 343},
  [12432] = {.lex_state = 47, .external_lex_state = 405},
  [12433] = {.lex_state = 0, .external_lex_state = 325},
  [12434] = {.lex_state = 0, .external_lex_state = 318},
  [12435] = {.lex_state = 47, .external_lex_state = 308},
  [12436] = {.lex_state = 0, .external_lex_state = 325},
  [12437] = {.lex_state = 50, .external_lex_state = 308},
  [12438] = {.lex_state = 50, .external_lex_state = 308},
  [12439] = {.lex_state = 50, .external_lex_state = 308},
  [12440] = {.lex_state = 50, .external_lex_state = 399},
  [12441] = {.lex_state = 50, .external_lex_state = 308},
  [12442] = {.lex_state = 50, .external_lex_state = 308},
  [12443] = {.lex_state = 50, .external_lex_state = 399},
  [12444] = {.lex_state = 0, .external_lex_state = 318},
  [12445] = {.lex_state = 0, .external_lex_state = 318},
  [12446] = {.lex_state = 47, .external_lex_state = 387},
  [12447] = {.lex_state = 50, .external_lex_state = 308},
  [12448] = {.lex_state = 50, .external_lex_state = 308},
  [12449] = {.lex_state = 0, .external_lex_state = 322},
  [12450] = {.lex_state = 47, .external_lex_state = 355},
  [12451] = {.lex_state = 50, .external_lex_state = 397},
  [12452] = {.lex_state = 47, .external_lex_state = 393},
  [12453] = {.lex_state = 50, .external_lex_state = 308},
  [12454] = {.lex_state = 48, .external_lex_state = 243},
  [12455] = {.lex_state = 0, .external_lex_state = 318},
  [12456] = {.lex_state = 50, .external_lex_state = 308},
  [12457] = {.lex_state = 50, .external_lex_state = 308},
  [12458] = {.lex_state = 50, .external_lex_state = 308},
  [12459] = {.lex_state = 47, .external_lex_state = 355},
  [12460] = {.lex_state = 47, .external_lex_state = 243},
  [12461] = {.lex_state = 47, .external_lex_state = 355},
  [12462] = {.lex_state = 50, .external_lex_state = 308},
  [12463] = {.lex_state = 50, .external_lex_state = 308},
  [12464] = {.lex_state = 50, .external_lex_state = 308},
  [12465] = {.lex_state = 50, .external_lex_state = 308},
  [12466] = {.lex_state = 47, .external_lex_state = 401},
  [12467] = {.lex_state = 0, .external_lex_state = 325},
  [12468] = {.lex_state = 50, .external_lex_state = 308},
  [12469] = {.lex_state = 0, .external_lex_state = 325},
  [12470] = {.lex_state = 0, .external_lex_state = 343},
  [12471] = {.lex_state = 0, .external_lex_state = 325},
  [12472] = {.lex_state = 0, .external_lex_state = 343},
  [12473] = {.lex_state = 50, .external_lex_state = 308},
  [12474] = {.lex_state = 50, .external_lex_state = 308},
  [12475] = {.lex_state = 50, .external_lex_state = 308},
  [12476] = {.lex_state = 50, .external_lex_state = 308},
  [12477] = {.lex_state = 0, .external_lex_state = 322},
  [12478] = {.lex_state = 0, .external_lex_state = 343},
  [12479] = {.lex_state = 50, .external_lex_state = 345},
  [12480] = {.lex_state = 50, .external_lex_state = 308},
  [12481] = {.lex_state = 50, .external_lex_state = 308},
  [12482] = {.lex_state = 50, .external_lex_state = 308},
  [12483] = {.lex_state = 47, .external_lex_state = 401},
  [12484] = {.lex_state = 0, .external_lex_state = 325},
  [12485] = {.lex_state = 0, .external_lex_state = 325},
  [12486] = {.lex_state = 0, .external_lex_state = 343},
  [12487] = {.lex_state = 47, .external_lex_state = 373},
  [12488] = {.lex_state = 50, .external_lex_state = 308},
  [12489] = {.lex_state = 0, .external_lex_state = 318},
  [12490] = {.lex_state = 50, .external_lex_state = 308},
  [12491] = {.lex_state = 50, .external_lex_state = 308},
  [12492] = {.lex_state = 50, .external_lex_state = 308},
  [12493] = {.lex_state = 0, .external_lex_state = 322},
  [12494] = {.lex_state = 0, .external_lex_state = 325},
  [12495] = {.lex_state = 50, .external_lex_state = 308},
  [12496] = {.lex_state = 50, .external_lex_state = 308},
  [12497] = {.lex_state = 0, .external_lex_state = 325},
  [12498] = {.lex_state = 50, .external_lex_state = 399},
  [12499] = {.lex_state = 50, .external_lex_state = 308},
  [12500] = {.lex_state = 47, .external_lex_state = 308},
  [12501] = {.lex_state = 47, .external_lex_state = 308},
  [12502] = {.lex_state = 0, .external_lex_state = 325},
  [12503] = {.lex_state = 47, .external_lex_state = 308},
  [12504] = {.lex_state = 47, .external_lex_state = 387},
  [12505] = {.lex_state = 47, .external_lex_state = 308},
  [12506] = {.lex_state = 51, .external_lex_state = 392},
  [12507] = {.lex_state = 50, .external_lex_state = 308},
  [12508] = {.lex_state = 50, .external_lex_state = 308},
  [12509] = {.lex_state = 47, .external_lex_state = 308},
  [12510] = {.lex_state = 47, .external_lex_state = 373},
  [12511] = {.lex_state = 0, .external_lex_state = 360},
  [12512] = {.lex_state = 47, .external_lex_state = 308},
  [12513] = {.lex_state = 50, .external_lex_state = 355},
  [12514] = {.lex_state = 47, .external_lex_state = 308},
  [12515] = {.lex_state = 0, .external_lex_state = 325},
  [12516] = {.lex_state = 48, .external_lex_state = 373},
  [12517] = {.lex_state = 0, .external_lex_state = 360},
  [12518] = {.lex_state = 0, .external_lex_state = 360},
  [12519] = {.lex_state = 0, .external_lex_state = 344},
  [12520] = {.lex_state = 0, .external_lex_state = 360},
  [12521] = {.lex_state = 0, .external_lex_state = 360},
  [12522] = {.lex_state = 0, .external_lex_state = 406},
  [12523] = {.lex_state = 47, .external_lex_state = 308},
  [12524] = {.lex_state = 47, .external_lex_state = 397},
  [12525] = {.lex_state = 47, .external_lex_state = 308},
  [12526] = {.lex_state = 51, .external_lex_state = 396},
  [12527] = {.lex_state = 47, .external_lex_state = 397},
  [12528] = {.lex_state = 47, .external_lex_state = 308},
  [12529] = {.lex_state = 50, .external_lex_state = 308},
  [12530] = {.lex_state = 47, .external_lex_state = 393},
  [12531] = {.lex_state = 0, .external_lex_state = 406},
  [12532] = {.lex_state = 47, .external_lex_state = 397},
  [12533] = {.lex_state = 47, .external_lex_state = 243},
  [12534] = {.lex_state = 47, .external_lex_state = 308},
  [12535] = {.lex_state = 47, .external_lex_state = 308},
  [12536] = {.lex_state = 47, .external_lex_state = 243},
  [12537] = {.lex_state = 47, .external_lex_state = 308},
  [12538] = {.lex_state = 47, .external_lex_state = 308},
  [12539] = {.lex_state = 47, .external_lex_state = 407},
  [12540] = {.lex_state = 0, .external_lex_state = 408},
  [12541] = {.lex_state = 48, .external_lex_state = 373},
  [12542] = {.lex_state = 47, .external_lex_state = 409},
  [12543] = {.lex_state = 0, .external_lex_state = 335},
  [12544] = {.lex_state = 0, .external_lex_state = 377},
  [12545] = {.lex_state = 47, .external_lex_state = 308},
  [12546] = {.lex_state = 51, .external_lex_state = 392},
  [12547] = {.lex_state = 47, .external_lex_state = 402},
  [12548] = {.lex_state = 47, .external_lex_state = 403},
  [12549] = {.lex_state = 47, .external_lex_state = 308},
  [12550] = {.lex_state = 47, .external_lex_state = 308},
  [12551] = {.lex_state = 0, .external_lex_state = 344},
  [12552] = {.lex_state = 47, .external_lex_state = 308},
  [12553] = {.lex_state = 51, .external_lex_state = 392},
  [12554] = {.lex_state = 0, .external_lex_state = 360},
  [12555] = {.lex_state = 47, .external_lex_state = 399},
  [12556] = {.lex_state = 47, .external_lex_state = 308},
  [12557] = {.lex_state = 47, .external_lex_state = 308},
  [12558] = {.lex_state = 47, .external_lex_state = 308},
  [12559] = {.lex_state = 0, .external_lex_state = 360},
  [12560] = {.lex_state = 0, .external_lex_state = 360},
  [12561] = {.lex_state = 47, .external_lex_state = 243},
  [12562] = {.lex_state = 0, .external_lex_state = 410},
  [12563] = {.lex_state = 47, .external_lex_state = 308},
  [12564] = {.lex_state = 51, .external_lex_state = 392},
  [12565] = {.lex_state = 51, .external_lex_state = 392},
  [12566] = {.lex_state = 50, .external_lex_state = 308},
  [12567] = {.lex_state = 47, .external_lex_state = 308},
  [12568] = {.lex_state = 0, .external_lex_state = 360},
  [12569] = {.lex_state = 47, .external_lex_state = 308},
  [12570] = {.lex_state = 0, .external_lex_state = 408},
  [12571] = {.lex_state = 47, .external_lex_state = 308},
  [12572] = {.lex_state = 0, .external_lex_state = 360},
  [12573] = {.lex_state = 47, .external_lex_state = 243},
  [12574] = {.lex_state = 47, .external_lex_state = 243},
  [12575] = {.lex_state = 47, .external_lex_state = 308},
  [12576] = {.lex_state = 0, .external_lex_state = 410},
  [12577] = {.lex_state = 47, .external_lex_state = 308},
  [12578] = {.lex_state = 0, .external_lex_state = 325},
  [12579] = {.lex_state = 47, .external_lex_state = 308},
  [12580] = {.lex_state = 47, .external_lex_state = 407},
  [12581] = {.lex_state = 47, .external_lex_state = 308},
  [12582] = {.lex_state = 47, .external_lex_state = 308},
  [12583] = {.lex_state = 0, .external_lex_state = 345},
  [12584] = {.lex_state = 47, .external_lex_state = 308},
  [12585] = {.lex_state = 50, .external_lex_state = 308},
  [12586] = {.lex_state = 47, .external_lex_state = 308},
  [12587] = {.lex_state = 47, .external_lex_state = 407},
  [12588] = {.lex_state = 51, .external_lex_state = 392},
  [12589] = {.lex_state = 47, .external_lex_state = 308},
  [12590] = {.lex_state = 51, .external_lex_state = 392},
  [12591] = {.lex_state = 47, .external_lex_state = 308},
  [12592] = {.lex_state = 47, .external_lex_state = 243},
  [12593] = {.lex_state = 0, .external_lex_state = 360},
  [12594] = {.lex_state = 47, .external_lex_state = 382},
  [12595] = {.lex_state = 0, .external_lex_state = 360},
  [12596] = {.lex_state = 47, .external_lex_state = 399},
  [12597] = {.lex_state = 47, .external_lex_state = 308},
  [12598] = {.lex_state = 47, .external_lex_state = 308},
  [12599] = {.lex_state = 0, .external_lex_state = 325},
  [12600] = {.lex_state = 51, .external_lex_state = 396},
  [12601] = {.lex_state = 0, .external_lex_state = 325},
  [12602] = {.lex_state = 47, .external_lex_state = 243},
  [12603] = {.lex_state = 0, .external_lex_state = 325},
  [12604] = {.lex_state = 47, .external_lex_state = 308},
  [12605] = {.lex_state = 47, .external_lex_state = 308},
  [12606] = {.lex_state = 0, .external_lex_state = 360},
  [12607] = {.lex_state = 0, .external_lex_state = 360},
  [12608] = {.lex_state = 0, .external_lex_state = 360},
  [12609] = {.lex_state = 0, .external_lex_state = 360},
  [12610] = {.lex_state = 50, .external_lex_state = 355},
  [12611] = {.lex_state = 0, .external_lex_state = 360},
  [12612] = {.lex_state = 47, .external_lex_state = 308},
  [12613] = {.lex_state = 0, .external_lex_state = 325},
  [12614] = {.lex_state = 0, .external_lex_state = 325},
  [12615] = {.lex_state = 47, .external_lex_state = 243},
  [12616] = {.lex_state = 47, .external_lex_state = 243},
  [12617] = {.lex_state = 51, .external_lex_state = 392},
  [12618] = {.lex_state = 47, .external_lex_state = 308},
  [12619] = {.lex_state = 47, .external_lex_state = 385},
  [12620] = {.lex_state = 47, .external_lex_state = 411},
  [12621] = {.lex_state = 47, .external_lex_state = 398},
  [12622] = {.lex_state = 51, .external_lex_state = 392},
  [12623] = {.lex_state = 47, .external_lex_state = 243},
  [12624] = {.lex_state = 47, .external_lex_state = 243},
  [12625] = {.lex_state = 47, .external_lex_state = 308},
  [12626] = {.lex_state = 0, .external_lex_state = 360},
  [12627] = {.lex_state = 0, .external_lex_state = 360},
  [12628] = {.lex_state = 47, .external_lex_state = 308},
  [12629] = {.lex_state = 47, .external_lex_state = 397},
  [12630] = {.lex_state = 0, .external_lex_state = 360},
  [12631] = {.lex_state = 47, .external_lex_state = 308},
  [12632] = {.lex_state = 47, .external_lex_state = 399},
  [12633] = {.lex_state = 47, .external_lex_state = 397},
  [12634] = {.lex_state = 47, .external_lex_state = 385},
  [12635] = {.lex_state = 47, .external_lex_state = 308},
  [12636] = {.lex_state = 47, .external_lex_state = 243},
  [12637] = {.lex_state = 50, .external_lex_state = 308},
  [12638] = {.lex_state = 47, .external_lex_state = 397},
  [12639] = {.lex_state = 51, .external_lex_state = 392},
  [12640] = {.lex_state = 47, .external_lex_state = 308},
  [12641] = {.lex_state = 47, .external_lex_state = 308},
  [12642] = {.lex_state = 47, .external_lex_state = 243},
  [12643] = {.lex_state = 0, .external_lex_state = 360},
  [12644] = {.lex_state = 0, .external_lex_state = 360},
  [12645] = {.lex_state = 47, .external_lex_state = 402},
  [12646] = {.lex_state = 51, .external_lex_state = 392},
  [12647] = {.lex_state = 0, .external_lex_state = 360},
  [12648] = {.lex_state = 0, .external_lex_state = 325},
  [12649] = {.lex_state = 47, .external_lex_state = 308},
  [12650] = {.lex_state = 0, .external_lex_state = 325},
  [12651] = {.lex_state = 47, .external_lex_state = 308},
  [12652] = {.lex_state = 0, .external_lex_state = 360},
  [12653] = {.lex_state = 0, .external_lex_state = 360},
  [12654] = {.lex_state = 0, .external_lex_state = 406},
  [12655] = {.lex_state = 47, .external_lex_state = 308},
  [12656] = {.lex_state = 0, .external_lex_state = 360},
  [12657] = {.lex_state = 47, .external_lex_state = 308},
  [12658] = {.lex_state = 0, .external_lex_state = 410},
  [12659] = {.lex_state = 47, .external_lex_state = 243},
  [12660] = {.lex_state = 47, .external_lex_state = 403},
  [12661] = {.lex_state = 47, .external_lex_state = 308},
  [12662] = {.lex_state = 47, .external_lex_state = 308},
  [12663] = {.lex_state = 0, .external_lex_state = 360},
  [12664] = {.lex_state = 47, .external_lex_state = 373},
  [12665] = {.lex_state = 47, .external_lex_state = 308},
  [12666] = {.lex_state = 47, .external_lex_state = 399},
  [12667] = {.lex_state = 0, .external_lex_state = 408},
  [12668] = {.lex_state = 0, .external_lex_state = 360},
  [12669] = {.lex_state = 0, .external_lex_state = 360},
  [12670] = {.lex_state = 47, .external_lex_state = 308},
  [12671] = {.lex_state = 47, .external_lex_state = 308},
  [12672] = {.lex_state = 51, .external_lex_state = 392},
  [12673] = {.lex_state = 0, .external_lex_state = 335},
  [12674] = {.lex_state = 47, .external_lex_state = 412},
  [12675] = {.lex_state = 0, .external_lex_state = 386},
  [12676] = {.lex_state = 47, .external_lex_state = 308},
  [12677] = {.lex_state = 47, .external_lex_state = 308},
  [12678] = {.lex_state = 0, .external_lex_state = 360},
  [12679] = {.lex_state = 47, .external_lex_state = 373},
  [12680] = {.lex_state = 50, .external_lex_state = 355},
  [12681] = {.lex_state = 47, .external_lex_state = 308},
  [12682] = {.lex_state = 47, .external_lex_state = 308},
  [12683] = {.lex_state = 0, .external_lex_state = 345},
  [12684] = {.lex_state = 47, .external_lex_state = 243},
  [12685] = {.lex_state = 47, .external_lex_state = 308},
  [12686] = {.lex_state = 47, .external_lex_state = 409},
  [12687] = {.lex_state = 0, .external_lex_state = 413},
  [12688] = {.lex_state = 47, .external_lex_state = 308},
  [12689] = {.lex_state = 0, .external_lex_state = 360},
  [12690] = {.lex_state = 47, .external_lex_state = 243},
  [12691] = {.lex_state = 0, .external_lex_state = 325},
  [12692] = {.lex_state = 0, .external_lex_state = 325},
  [12693] = {.lex_state = 0, .external_lex_state = 325},
  [12694] = {.lex_state = 0, .external_lex_state = 325},
  [12695] = {.lex_state = 47, .external_lex_state = 243},
  [12696] = {.lex_state = 0, .external_lex_state = 325},
  [12697] = {.lex_state = 47, .external_lex_state = 243},
  [12698] = {.lex_state = 47, .external_lex_state = 308},
  [12699] = {.lex_state = 47, .external_lex_state = 308},
  [12700] = {.lex_state = 47, .external_lex_state = 243},
  [12701] = {.lex_state = 47, .external_lex_state = 308},
  [12702] = {.lex_state = 0, .external_lex_state = 325},
  [12703] = {.lex_state = 51, .external_lex_state = 392},
  [12704] = {.lex_state = 47, .external_lex_state = 399},
  [12705] = {.lex_state = 47, .external_lex_state = 308},
  [12706] = {.lex_state = 47, .external_lex_state = 398},
  [12707] = {.lex_state = 47, .external_lex_state = 399},
  [12708] = {.lex_state = 0, .external_lex_state = 325},
  [12709] = {.lex_state = 50, .external_lex_state = 308},
  [12710] = {.lex_state = 0, .external_lex_state = 344},
  [12711] = {.lex_state = 51, .external_lex_state = 392},
  [12712] = {.lex_state = 47, .external_lex_state = 308},
  [12713] = {.lex_state = 47, .external_lex_state = 308},
  [12714] = {.lex_state = 47, .external_lex_state = 308},
  [12715] = {.lex_state = 0, .external_lex_state = 345},
  [12716] = {.lex_state = 47, .external_lex_state = 308},
  [12717] = {.lex_state = 47, .external_lex_state = 409},
  [12718] = {.lex_state = 0, .external_lex_state = 360},
  [12719] = {.lex_state = 47, .external_lex_state = 308},
  [12720] = {.lex_state = 47, .external_lex_state = 381},
  [12721] = {.lex_state = 0, .external_lex_state = 413},
  [12722] = {.lex_state = 47, .external_lex_state = 308},
  [12723] = {.lex_state = 0, .external_lex_state = 384},
  [12724] = {.lex_state = 0, .external_lex_state = 360},
  [12725] = {.lex_state = 0, .external_lex_state = 360},
  [12726] = {.lex_state = 47, .external_lex_state = 308},
  [12727] = {.lex_state = 47, .external_lex_state = 373},
  [12728] = {.lex_state = 0, .external_lex_state = 249},
  [12729] = {.lex_state = 0, .external_lex_state = 386},
  [12730] = {.lex_state = 47, .external_lex_state = 382},
  [12731] = {.lex_state = 47, .external_lex_state = 414},
  [12732] = {.lex_state = 0, .external_lex_state = 355},
  [12733] = {.lex_state = 47, .external_lex_state = 414},
  [12734] = {.lex_state = 47, .external_lex_state = 414},
  [12735] = {.lex_state = 0, .external_lex_state = 386},
  [12736] = {.lex_state = 47, .external_lex_state = 414},
  [12737] = {.lex_state = 0, .external_lex_state = 344},
  [12738] = {.lex_state = 0, .external_lex_state = 415},
  [12739] = {.lex_state = 50, .external_lex_state = 380},
  [12740] = {.lex_state = 47, .external_lex_state = 414},
  [12741] = {.lex_state = 47, .external_lex_state = 414},
  [12742] = {.lex_state = 47, .external_lex_state = 414},
  [12743] = {.lex_state = 50, .external_lex_state = 308},
  [12744] = {.lex_state = 47, .external_lex_state = 412},
  [12745] = {.lex_state = 50, .external_lex_state = 308},
  [12746] = {.lex_state = 47, .external_lex_state = 414},
  [12747] = {.lex_state = 0, .external_lex_state = 249},
  [12748] = {.lex_state = 47, .external_lex_state = 414},
  [12749] = {.lex_state = 47, .external_lex_state = 308},
  [12750] = {.lex_state = 0, .external_lex_state = 249},
  [12751] = {.lex_state = 47, .external_lex_state = 414},
  [12752] = {.lex_state = 47, .external_lex_state = 373},
  [12753] = {.lex_state = 47, .external_lex_state = 373},
  [12754] = {.lex_state = 47, .external_lex_state = 373},
  [12755] = {.lex_state = 47, .external_lex_state = 414},
  [12756] = {.lex_state = 47, .external_lex_state = 382},
  [12757] = {.lex_state = 0, .external_lex_state = 249},
  [12758] = {.lex_state = 47, .external_lex_state = 308},
  [12759] = {.lex_state = 0, .external_lex_state = 355},
  [12760] = {.lex_state = 47, .external_lex_state = 414},
  [12761] = {.lex_state = 47, .external_lex_state = 414},
  [12762] = {.lex_state = 0, .external_lex_state = 344},
  [12763] = {.lex_state = 47, .external_lex_state = 414},
  [12764] = {.lex_state = 0, .external_lex_state = 416},
  [12765] = {.lex_state = 47, .external_lex_state = 373},
  [12766] = {.lex_state = 47, .external_lex_state = 308},
  [12767] = {.lex_state = 50, .external_lex_state = 399},
  [12768] = {.lex_state = 47, .external_lex_state = 414},
  [12769] = {.lex_state = 0, .external_lex_state = 417},
  [12770] = {.lex_state = 47, .external_lex_state = 393},
  [12771] = {.lex_state = 47, .external_lex_state = 414},
  [12772] = {.lex_state = 47, .external_lex_state = 308},
  [12773] = {.lex_state = 47, .external_lex_state = 414},
  [12774] = {.lex_state = 47, .external_lex_state = 412},
  [12775] = {.lex_state = 47, .external_lex_state = 414},
  [12776] = {.lex_state = 47, .external_lex_state = 402},
  [12777] = {.lex_state = 47, .external_lex_state = 414},
  [12778] = {.lex_state = 47, .external_lex_state = 414},
  [12779] = {.lex_state = 47, .external_lex_state = 414},
  [12780] = {.lex_state = 47, .external_lex_state = 308},
  [12781] = {.lex_state = 47, .external_lex_state = 373},
  [12782] = {.lex_state = 47, .external_lex_state = 381},
  [12783] = {.lex_state = 47, .external_lex_state = 412},
  [12784] = {.lex_state = 47, .external_lex_state = 414},
  [12785] = {.lex_state = 47, .external_lex_state = 373},
  [12786] = {.lex_state = 47, .external_lex_state = 414},
  [12787] = {.lex_state = 47, .external_lex_state = 414},
  [12788] = {.lex_state = 0, .external_lex_state = 417},
  [12789] = {.lex_state = 47, .external_lex_state = 414},
  [12790] = {.lex_state = 47, .external_lex_state = 414},
  [12791] = {.lex_state = 47, .external_lex_state = 345},
  [12792] = {.lex_state = 50, .external_lex_state = 404},
  [12793] = {.lex_state = 47, .external_lex_state = 414},
  [12794] = {.lex_state = 47, .external_lex_state = 414},
  [12795] = {.lex_state = 47, .external_lex_state = 414},
  [12796] = {.lex_state = 47, .external_lex_state = 308},
  [12797] = {.lex_state = 47, .external_lex_state = 414},
  [12798] = {.lex_state = 0, .external_lex_state = 386},
  [12799] = {.lex_state = 47, .external_lex_state = 414},
  [12800] = {.lex_state = 50, .external_lex_state = 308},
  [12801] = {.lex_state = 47, .external_lex_state = 308},
  [12802] = {.lex_state = 48, .external_lex_state = 381},
  [12803] = {.lex_state = 47, .external_lex_state = 373},
  [12804] = {.lex_state = 50, .external_lex_state = 308},
  [12805] = {.lex_state = 47, .external_lex_state = 414},
  [12806] = {.lex_state = 0, .external_lex_state = 415},
  [12807] = {.lex_state = 47, .external_lex_state = 412},
  [12808] = {.lex_state = 0, .external_lex_state = 386},
  [12809] = {.lex_state = 47, .external_lex_state = 308},
  [12810] = {.lex_state = 50, .external_lex_state = 399},
  [12811] = {.lex_state = 47, .external_lex_state = 418},
  [12812] = {.lex_state = 47, .external_lex_state = 388},
  [12813] = {.lex_state = 47, .external_lex_state = 414},
  [12814] = {.lex_state = 47, .external_lex_state = 308},
  [12815] = {.lex_state = 47, .external_lex_state = 414},
  [12816] = {.lex_state = 47, .external_lex_state = 414},
  [12817] = {.lex_state = 47, .external_lex_state = 308},
  [12818] = {.lex_state = 47, .external_lex_state = 308},
  [12819] = {.lex_state = 47, .external_lex_state = 414},
  [12820] = {.lex_state = 47, .external_lex_state = 414},
  [12821] = {.lex_state = 47, .external_lex_state = 414},
  [12822] = {.lex_state = 47, .external_lex_state = 400},
  [12823] = {.lex_state = 47, .external_lex_state = 308},
  [12824] = {.lex_state = 47, .external_lex_state = 308},
  [12825] = {.lex_state = 47, .external_lex_state = 419},
  [12826] = {.lex_state = 47, .external_lex_state = 414},
  [12827] = {.lex_state = 47, .external_lex_state = 412},
  [12828] = {.lex_state = 0, .external_lex_state = 377},
  [12829] = {.lex_state = 47, .external_lex_state = 373},
  [12830] = {.lex_state = 0, .external_lex_state = 413},
  [12831] = {.lex_state = 47, .external_lex_state = 414},
  [12832] = {.lex_state = 47, .external_lex_state = 387},
  [12833] = {.lex_state = 47, .external_lex_state = 414},
  [12834] = {.lex_state = 50, .external_lex_state = 399},
  [12835] = {.lex_state = 50, .external_lex_state = 308},
  [12836] = {.lex_state = 47, .external_lex_state = 414},
  [12837] = {.lex_state = 47, .external_lex_state = 308},
  [12838] = {.lex_state = 0, .external_lex_state = 377},
  [12839] = {.lex_state = 0, .external_lex_state = 415},
  [12840] = {.lex_state = 47, .external_lex_state = 308},
  [12841] = {.lex_state = 47, .external_lex_state = 414},
  [12842] = {.lex_state = 0, .external_lex_state = 355},
  [12843] = {.lex_state = 47, .external_lex_state = 414},
  [12844] = {.lex_state = 50, .external_lex_state = 308},
  [12845] = {.lex_state = 47, .external_lex_state = 420},
  [12846] = {.lex_state = 47, .external_lex_state = 414},
  [12847] = {.lex_state = 47, .external_lex_state = 412},
  [12848] = {.lex_state = 47, .external_lex_state = 414},
  [12849] = {.lex_state = 0, .external_lex_state = 249},
  [12850] = {.lex_state = 47, .external_lex_state = 308},
  [12851] = {.lex_state = 47, .external_lex_state = 414},
  [12852] = {.lex_state = 47, .external_lex_state = 308},
  [12853] = {.lex_state = 47, .external_lex_state = 308},
  [12854] = {.lex_state = 47, .external_lex_state = 308},
  [12855] = {.lex_state = 50, .external_lex_state = 308},
  [12856] = {.lex_state = 47, .external_lex_state = 308},
  [12857] = {.lex_state = 47, .external_lex_state = 412},
  [12858] = {.lex_state = 47, .external_lex_state = 343},
  [12859] = {.lex_state = 47, .external_lex_state = 414},
  [12860] = {.lex_state = 47, .external_lex_state = 308},
  [12861] = {.lex_state = 50, .external_lex_state = 399},
  [12862] = {.lex_state = 47, .external_lex_state = 308},
  [12863] = {.lex_state = 47, .external_lex_state = 308},
  [12864] = {.lex_state = 50, .external_lex_state = 308},
  [12865] = {.lex_state = 47, .external_lex_state = 380},
  [12866] = {.lex_state = 47, .external_lex_state = 414},
  [12867] = {.lex_state = 47, .external_lex_state = 308},
  [12868] = {.lex_state = 47, .external_lex_state = 414},
  [12869] = {.lex_state = 47, .external_lex_state = 308},
  [12870] = {.lex_state = 47, .external_lex_state = 308},
  [12871] = {.lex_state = 47, .external_lex_state = 414},
  [12872] = {.lex_state = 47, .external_lex_state = 308},
  [12873] = {.lex_state = 0, .external_lex_state = 386},
  [12874] = {.lex_state = 0, .external_lex_state = 377},
  [12875] = {.lex_state = 0, .external_lex_state = 391},
  [12876] = {.lex_state = 50, .external_lex_state = 397},
  [12877] = {.lex_state = 47, .external_lex_state = 373},
  [12878] = {.lex_state = 50, .external_lex_state = 397},
  [12879] = {.lex_state = 47, .external_lex_state = 414},
  [12880] = {.lex_state = 47, .external_lex_state = 308},
  [12881] = {.lex_state = 47, .external_lex_state = 344},
  [12882] = {.lex_state = 47, .external_lex_state = 393},
  [12883] = {.lex_state = 47, .external_lex_state = 414},
  [12884] = {.lex_state = 47, .external_lex_state = 373},
  [12885] = {.lex_state = 0, .external_lex_state = 421},
  [12886] = {.lex_state = 47, .external_lex_state = 308},
  [12887] = {.lex_state = 47, .external_lex_state = 308},
  [12888] = {.lex_state = 47, .external_lex_state = 308},
  [12889] = {.lex_state = 47, .external_lex_state = 414},
  [12890] = {.lex_state = 47, .external_lex_state = 418},
  [12891] = {.lex_state = 47, .external_lex_state = 344},
  [12892] = {.lex_state = 47, .external_lex_state = 414},
  [12893] = {.lex_state = 47, .external_lex_state = 345},
  [12894] = {.lex_state = 47, .external_lex_state = 387},
  [12895] = {.lex_state = 47, .external_lex_state = 414},
  [12896] = {.lex_state = 47, .external_lex_state = 400},
  [12897] = {.lex_state = 0, .external_lex_state = 417},
  [12898] = {.lex_state = 47, .external_lex_state = 414},
  [12899] = {.lex_state = 47, .external_lex_state = 414},
  [12900] = {.lex_state = 47, .external_lex_state = 411},
  [12901] = {.lex_state = 47, .external_lex_state = 308},
  [12902] = {.lex_state = 47, .external_lex_state = 308},
  [12903] = {.lex_state = 0, .external_lex_state = 249},
  [12904] = {.lex_state = 47, .external_lex_state = 308},
  [12905] = {.lex_state = 0, .external_lex_state = 249},
  [12906] = {.lex_state = 0, .external_lex_state = 384},
  [12907] = {.lex_state = 47, .external_lex_state = 412},
  [12908] = {.lex_state = 47, .external_lex_state = 373},
  [12909] = {.lex_state = 47, .external_lex_state = 373},
  [12910] = {.lex_state = 47, .external_lex_state = 373},
  [12911] = {.lex_state = 47, .external_lex_state = 373},
  [12912] = {.lex_state = 47, .external_lex_state = 414},
  [12913] = {.lex_state = 47, .external_lex_state = 414},
  [12914] = {.lex_state = 47, .external_lex_state = 414},
  [12915] = {.lex_state = 47, .external_lex_state = 308},
  [12916] = {.lex_state = 47, .external_lex_state = 414},
  [12917] = {.lex_state = 0, .external_lex_state = 210},
  [12918] = {.lex_state = 47, .external_lex_state = 414},
  [12919] = {.lex_state = 47, .external_lex_state = 414},
  [12920] = {.lex_state = 47, .external_lex_state = 373},
  [12921] = {.lex_state = 47, .external_lex_state = 414},
  [12922] = {.lex_state = 47, .external_lex_state = 414},
  [12923] = {.lex_state = 47, .external_lex_state = 414},
  [12924] = {.lex_state = 0, .external_lex_state = 345},
  [12925] = {.lex_state = 47, .external_lex_state = 373},
  [12926] = {.lex_state = 47, .external_lex_state = 308},
  [12927] = {.lex_state = 47, .external_lex_state = 373},
  [12928] = {.lex_state = 47, .external_lex_state = 308},
  [12929] = {.lex_state = 47, .external_lex_state = 412},
  [12930] = {.lex_state = 47, .external_lex_state = 308},
  [12931] = {.lex_state = 47, .external_lex_state = 412},
  [12932] = {.lex_state = 47, .external_lex_state = 308},
  [12933] = {.lex_state = 47, .external_lex_state = 414},
  [12934] = {.lex_state = 47, .external_lex_state = 414},
  [12935] = {.lex_state = 50, .external_lex_state = 404},
  [12936] = {.lex_state = 0, .external_lex_state = 384},
  [12937] = {.lex_state = 47, .external_lex_state = 308},
  [12938] = {.lex_state = 47, .external_lex_state = 308},
  [12939] = {.lex_state = 47, .external_lex_state = 373},
  [12940] = {.lex_state = 48, .external_lex_state = 382},
  [12941] = {.lex_state = 47, .external_lex_state = 414},
  [12942] = {.lex_state = 47, .external_lex_state = 345},
  [12943] = {.lex_state = 47, .external_lex_state = 373},
  [12944] = {.lex_state = 47, .external_lex_state = 373},
  [12945] = {.lex_state = 47, .external_lex_state = 414},
  [12946] = {.lex_state = 0, .external_lex_state = 249},
  [12947] = {.lex_state = 47, .external_lex_state = 373},
  [12948] = {.lex_state = 0, .external_lex_state = 210},
  [12949] = {.lex_state = 47, .external_lex_state = 308},
  [12950] = {.lex_state = 47, .external_lex_state = 414},
  [12951] = {.lex_state = 47, .external_lex_state = 308},
  [12952] = {.lex_state = 47, .external_lex_state = 414},
  [12953] = {.lex_state = 47, .external_lex_state = 414},
  [12954] = {.lex_state = 47, .external_lex_state = 414},
  [12955] = {.lex_state = 0, .external_lex_state = 249},
  [12956] = {.lex_state = 0, .external_lex_state = 394},
  [12957] = {.lex_state = 47, .external_lex_state = 414},
  [12958] = {.lex_state = 47, .external_lex_state = 414},
  [12959] = {.lex_state = 0, .external_lex_state = 249},
  [12960] = {.lex_state = 47, .external_lex_state = 414},
  [12961] = {.lex_state = 50, .external_lex_state = 404},
  [12962] = {.lex_state = 47, .external_lex_state = 414},
  [12963] = {.lex_state = 0, .external_lex_state = 384},
  [12964] = {.lex_state = 47, .external_lex_state = 414},
  [12965] = {.lex_state = 47, .external_lex_state = 414},
  [12966] = {.lex_state = 50, .external_lex_state = 397},
  [12967] = {.lex_state = 47, .external_lex_state = 414},
  [12968] = {.lex_state = 50, .external_lex_state = 397},
  [12969] = {.lex_state = 47, .external_lex_state = 414},
  [12970] = {.lex_state = 47, .external_lex_state = 414},
  [12971] = {.lex_state = 47, .external_lex_state = 414},
  [12972] = {.lex_state = 47, .external_lex_state = 400},
  [12973] = {.lex_state = 47, .external_lex_state = 414},
  [12974] = {.lex_state = 47, .external_lex_state = 414},
  [12975] = {.lex_state = 47, .external_lex_state = 414},
  [12976] = {.lex_state = 47, .external_lex_state = 412},
  [12977] = {.lex_state = 47, .external_lex_state = 414},
  [12978] = {.lex_state = 47, .external_lex_state = 308},
  [12979] = {.lex_state = 47, .external_lex_state = 414},
  [12980] = {.lex_state = 47, .external_lex_state = 373},
  [12981] = {.lex_state = 47, .external_lex_state = 373},
  [12982] = {.lex_state = 47, .external_lex_state = 412},
  [12983] = {.lex_state = 47, .external_lex_state = 414},
  [12984] = {.lex_state = 47, .external_lex_state = 414},
  [12985] = {.lex_state = 47, .external_lex_state = 414},
  [12986] = {.lex_state = 0, .external_lex_state = 355},
  [12987] = {.lex_state = 47, .external_lex_state = 414},
  [12988] = {.lex_state = 47, .external_lex_state = 414},
  [12989] = {.lex_state = 47, .external_lex_state = 414},
  [12990] = {.lex_state = 47, .external_lex_state = 414},
  [12991] = {.lex_state = 47, .external_lex_state = 414},
  [12992] = {.lex_state = 50, .external_lex_state = 308},
  [12993] = {.lex_state = 47, .external_lex_state = 393},
  [12994] = {.lex_state = 47, .external_lex_state = 308},
  [12995] = {.lex_state = 47, .external_lex_state = 308},
  [12996] = {.lex_state = 47, .external_lex_state = 308},
  [12997] = {.lex_state = 47, .external_lex_state = 414},
  [12998] = {.lex_state = 47, .external_lex_state = 308},
  [12999] = {.lex_state = 47, .external_lex_state = 414},
  [13000] = {.lex_state = 50, .external_lex_state = 308},
  [13001] = {.lex_state = 50, .external_lex_state = 308},
  [13002] = {.lex_state = 47, .external_lex_state = 414},
  [13003] = {.lex_state = 47, .external_lex_state = 414},
  [13004] = {.lex_state = 47, .external_lex_state = 414},
  [13005] = {.lex_state = 47, .external_lex_state = 411},
  [13006] = {.lex_state = 47, .external_lex_state = 414},
  [13007] = {.lex_state = 47, .external_lex_state = 308},
  [13008] = {.lex_state = 47, .external_lex_state = 308},
  [13009] = {.lex_state = 50, .external_lex_state = 308},
  [13010] = {.lex_state = 47, .external_lex_state = 308},
  [13011] = {.lex_state = 47, .external_lex_state = 414},
  [13012] = {.lex_state = 47, .external_lex_state = 308},
  [13013] = {.lex_state = 47, .external_lex_state = 414},
  [13014] = {.lex_state = 47, .external_lex_state = 373},
  [13015] = {.lex_state = 47, .external_lex_state = 412},
  [13016] = {.lex_state = 0, .external_lex_state = 377},
  [13017] = {.lex_state = 47, .external_lex_state = 414},
  [13018] = {.lex_state = 47, .external_lex_state = 422},
  [13019] = {.lex_state = 47, .external_lex_state = 414},
  [13020] = {.lex_state = 47, .external_lex_state = 414},
  [13021] = {.lex_state = 0, .external_lex_state = 421},
  [13022] = {.lex_state = 47, .external_lex_state = 373},
  [13023] = {.lex_state = 50, .external_lex_state = 397},
  [13024] = {.lex_state = 47, .external_lex_state = 414},
  [13025] = {.lex_state = 0, .external_lex_state = 384},
  [13026] = {.lex_state = 47, .external_lex_state = 373},
  [13027] = {.lex_state = 47, .external_lex_state = 414},
  [13028] = {.lex_state = 47, .external_lex_state = 414},
  [13029] = {.lex_state = 0, .external_lex_state = 377},
  [13030] = {.lex_state = 47, .external_lex_state = 308},
  [13031] = {.lex_state = 47, .external_lex_state = 414},
  [13032] = {.lex_state = 0, .external_lex_state = 390},
  [13033] = {.lex_state = 47, .external_lex_state = 388},
  [13034] = {.lex_state = 47, .external_lex_state = 414},
  [13035] = {.lex_state = 48, .external_lex_state = 381},
  [13036] = {.lex_state = 47, .external_lex_state = 419},
  [13037] = {.lex_state = 47, .external_lex_state = 414},
  [13038] = {.lex_state = 47, .external_lex_state = 414},
  [13039] = {.lex_state = 0, .external_lex_state = 421},
  [13040] = {.lex_state = 47, .external_lex_state = 414},
  [13041] = {.lex_state = 47, .external_lex_state = 414},
  [13042] = {.lex_state = 1, .external_lex_state = 308},
  [13043] = {.lex_state = 47, .external_lex_state = 373},
  [13044] = {.lex_state = 47, .external_lex_state = 373},
  [13045] = {.lex_state = 47, .external_lex_state = 414},
  [13046] = {.lex_state = 47, .external_lex_state = 414},
  [13047] = {.lex_state = 47, .external_lex_state = 344},
  [13048] = {.lex_state = 47, .external_lex_state = 414},
  [13049] = {.lex_state = 47, .external_lex_state = 414},
  [13050] = {.lex_state = 47, .external_lex_state = 414},
  [13051] = {.lex_state = 47, .external_lex_state = 308},
  [13052] = {.lex_state = 0, .external_lex_state = 355},
  [13053] = {.lex_state = 0, .external_lex_state = 335},
  [13054] = {.lex_state = 47, .external_lex_state = 412},
  [13055] = {.lex_state = 47, .external_lex_state = 414},
  [13056] = {.lex_state = 47, .external_lex_state = 414},
  [13057] = {.lex_state = 50, .external_lex_state = 308},
  [13058] = {.lex_state = 47, .external_lex_state = 373},
  [13059] = {.lex_state = 47, .external_lex_state = 393},
  [13060] = {.lex_state = 47, .external_lex_state = 373},
  [13061] = {.lex_state = 47, .external_lex_state = 414},
  [13062] = {.lex_state = 47, .external_lex_state = 414},
  [13063] = {.lex_state = 0, .external_lex_state = 355},
  [13064] = {.lex_state = 47, .external_lex_state = 414},
  [13065] = {.lex_state = 50, .external_lex_state = 308},
  [13066] = {.lex_state = 50, .external_lex_state = 308},
  [13067] = {.lex_state = 47, .external_lex_state = 414},
  [13068] = {.lex_state = 47, .external_lex_state = 414},
  [13069] = {.lex_state = 47, .external_lex_state = 414},
  [13070] = {.lex_state = 47, .external_lex_state = 412},
  [13071] = {.lex_state = 50, .external_lex_state = 380},
  [13072] = {.lex_state = 0, .external_lex_state = 344},
  [13073] = {.lex_state = 50, .external_lex_state = 308},
  [13074] = {.lex_state = 50, .external_lex_state = 308},
  [13075] = {.lex_state = 47, .external_lex_state = 381},
  [13076] = {.lex_state = 50, .external_lex_state = 380},
  [13077] = {.lex_state = 47, .external_lex_state = 373},
  [13078] = {.lex_state = 47, .external_lex_state = 308},
  [13079] = {.lex_state = 47, .external_lex_state = 412},
  [13080] = {.lex_state = 0, .external_lex_state = 384},
  [13081] = {.lex_state = 50, .external_lex_state = 397},
  [13082] = {.lex_state = 47, .external_lex_state = 414},
  [13083] = {.lex_state = 47, .external_lex_state = 308},
  [13084] = {.lex_state = 47, .external_lex_state = 373},
  [13085] = {.lex_state = 47, .external_lex_state = 414},
  [13086] = {.lex_state = 47, .external_lex_state = 381},
  [13087] = {.lex_state = 47, .external_lex_state = 414},
  [13088] = {.lex_state = 47, .external_lex_state = 308},
  [13089] = {.lex_state = 47, .external_lex_state = 373},
  [13090] = {.lex_state = 47, .external_lex_state = 414},
  [13091] = {.lex_state = 47, .external_lex_state = 414},
  [13092] = {.lex_state = 0, .external_lex_state = 210},
  [13093] = {.lex_state = 50, .external_lex_state = 308},
  [13094] = {.lex_state = 48, .external_lex_state = 382},
  [13095] = {.lex_state = 47, .external_lex_state = 382},
  [13096] = {.lex_state = 47, .external_lex_state = 414},
  [13097] = {.lex_state = 50, .external_lex_state = 308},
  [13098] = {.lex_state = 47, .external_lex_state = 414},
  [13099] = {.lex_state = 0, .external_lex_state = 377},
  [13100] = {.lex_state = 47, .external_lex_state = 381},
  [13101] = {.lex_state = 47, .external_lex_state = 382},
  [13102] = {.lex_state = 47, .external_lex_state = 382},
  [13103] = {.lex_state = 0, .external_lex_state = 394},
  [13104] = {.lex_state = 47, .external_lex_state = 249},
  [13105] = {.lex_state = 0, .external_lex_state = 377},
  [13106] = {.lex_state = 47, .external_lex_state = 336},
  [13107] = {.lex_state = 50, .external_lex_state = 397},
  [13108] = {.lex_state = 0, .external_lex_state = 386},
  [13109] = {.lex_state = 0, .external_lex_state = 377},
  [13110] = {.lex_state = 51, .external_lex_state = 392},
  [13111] = {.lex_state = 50, .external_lex_state = 399},
  [13112] = {.lex_state = 47, .external_lex_state = 336},
  [13113] = {.lex_state = 47, .external_lex_state = 336},
  [13114] = {.lex_state = 47, .external_lex_state = 382},
  [13115] = {.lex_state = 47, .external_lex_state = 382},
  [13116] = {.lex_state = 47, .external_lex_state = 380},
  [13117] = {.lex_state = 0, .external_lex_state = 386},
  [13118] = {.lex_state = 47, .external_lex_state = 382},
  [13119] = {.lex_state = 0, .external_lex_state = 345},
  [13120] = {.lex_state = 0, .external_lex_state = 308},
  [13121] = {.lex_state = 0, .external_lex_state = 386},
  [13122] = {.lex_state = 0, .external_lex_state = 386},
  [13123] = {.lex_state = 0, .external_lex_state = 335},
  [13124] = {.lex_state = 47, .external_lex_state = 402},
  [13125] = {.lex_state = 47, .external_lex_state = 382},
  [13126] = {.lex_state = 47, .external_lex_state = 382},
  [13127] = {.lex_state = 0, .external_lex_state = 390},
  [13128] = {.lex_state = 47, .external_lex_state = 336},
  [13129] = {.lex_state = 47, .external_lex_state = 382},
  [13130] = {.lex_state = 0, .external_lex_state = 391},
  [13131] = {.lex_state = 47, .external_lex_state = 383},
  [13132] = {.lex_state = 0, .external_lex_state = 386},
  [13133] = {.lex_state = 0, .external_lex_state = 188},
  [13134] = {.lex_state = 0, .external_lex_state = 386},
  [13135] = {.lex_state = 0, .external_lex_state = 399},
  [13136] = {.lex_state = 47, .external_lex_state = 380},
  [13137] = {.lex_state = 0, .external_lex_state = 386},
  [13138] = {.lex_state = 47, .external_lex_state = 402},
  [13139] = {.lex_state = 47, .external_lex_state = 345},
  [13140] = {.lex_state = 0, .external_lex_state = 188},
  [13141] = {.lex_state = 0, .external_lex_state = 386},
  [13142] = {.lex_state = 47, .external_lex_state = 381},
  [13143] = {.lex_state = 47, .external_lex_state = 382},
  [13144] = {.lex_state = 47, .external_lex_state = 382},
  [13145] = {.lex_state = 0, .external_lex_state = 386},
  [13146] = {.lex_state = 0, .external_lex_state = 399},
  [13147] = {.lex_state = 47, .external_lex_state = 382},
  [13148] = {.lex_state = 47, .external_lex_state = 382},
  [13149] = {.lex_state = 0, .external_lex_state = 399},
  [13150] = {.lex_state = 47, .external_lex_state = 382},
  [13151] = {.lex_state = 0, .external_lex_state = 386},
  [13152] = {.lex_state = 0, .external_lex_state = 377},
  [13153] = {.lex_state = 47, .external_lex_state = 402},
  [13154] = {.lex_state = 0, .external_lex_state = 386},
  [13155] = {.lex_state = 0, .external_lex_state = 391},
  [13156] = {.lex_state = 47, .external_lex_state = 402},
  [13157] = {.lex_state = 50, .external_lex_state = 397},
  [13158] = {.lex_state = 50, .external_lex_state = 336},
  [13159] = {.lex_state = 47, .external_lex_state = 381},
  [13160] = {.lex_state = 0, .external_lex_state = 386},
  [13161] = {.lex_state = 47, .external_lex_state = 380},
  [13162] = {.lex_state = 0, .external_lex_state = 308},
  [13163] = {.lex_state = 0, .external_lex_state = 386},
  [13164] = {.lex_state = 47, .external_lex_state = 382},
  [13165] = {.lex_state = 50, .external_lex_state = 423},
  [13166] = {.lex_state = 51, .external_lex_state = 392},
  [13167] = {.lex_state = 0, .external_lex_state = 386},
  [13168] = {.lex_state = 47, .external_lex_state = 382},
  [13169] = {.lex_state = 0, .external_lex_state = 188},
  [13170] = {.lex_state = 0, .external_lex_state = 384},
  [13171] = {.lex_state = 0, .external_lex_state = 391},
  [13172] = {.lex_state = 0, .external_lex_state = 308},
  [13173] = {.lex_state = 0, .external_lex_state = 377},
  [13174] = {.lex_state = 50, .external_lex_state = 397},
  [13175] = {.lex_state = 0, .external_lex_state = 355},
  [13176] = {.lex_state = 47, .external_lex_state = 382},
  [13177] = {.lex_state = 0, .external_lex_state = 416},
  [13178] = {.lex_state = 0, .external_lex_state = 384},
  [13179] = {.lex_state = 0, .external_lex_state = 390},
  [13180] = {.lex_state = 47, .external_lex_state = 381},
  [13181] = {.lex_state = 0, .external_lex_state = 384},
  [13182] = {.lex_state = 0, .external_lex_state = 377},
  [13183] = {.lex_state = 0, .external_lex_state = 384},
  [13184] = {.lex_state = 0, .external_lex_state = 386},
  [13185] = {.lex_state = 0, .external_lex_state = 377},
  [13186] = {.lex_state = 0, .external_lex_state = 384},
  [13187] = {.lex_state = 0, .external_lex_state = 386},
  [13188] = {.lex_state = 0, .external_lex_state = 386},
  [13189] = {.lex_state = 0, .external_lex_state = 308},
  [13190] = {.lex_state = 47, .external_lex_state = 382},
  [13191] = {.lex_state = 47, .external_lex_state = 382},
  [13192] = {.lex_state = 0, .external_lex_state = 384},
  [13193] = {.lex_state = 0, .external_lex_state = 386},
  [13194] = {.lex_state = 0, .external_lex_state = 386},
  [13195] = {.lex_state = 0, .external_lex_state = 384},
  [13196] = {.lex_state = 0, .external_lex_state = 394},
  [13197] = {.lex_state = 0, .external_lex_state = 384},
  [13198] = {.lex_state = 0, .external_lex_state = 384},
  [13199] = {.lex_state = 47, .external_lex_state = 382},
  [13200] = {.lex_state = 0, .external_lex_state = 377},
  [13201] = {.lex_state = 0, .external_lex_state = 386},
  [13202] = {.lex_state = 0, .external_lex_state = 384},
  [13203] = {.lex_state = 0, .external_lex_state = 308},
  [13204] = {.lex_state = 0, .external_lex_state = 386},
  [13205] = {.lex_state = 0, .external_lex_state = 386},
  [13206] = {.lex_state = 50, .external_lex_state = 397},
  [13207] = {.lex_state = 0, .external_lex_state = 384},
  [13208] = {.lex_state = 0, .external_lex_state = 384},
  [13209] = {.lex_state = 50, .external_lex_state = 423},
  [13210] = {.lex_state = 50, .external_lex_state = 308},
  [13211] = {.lex_state = 0, .external_lex_state = 391},
  [13212] = {.lex_state = 47, .external_lex_state = 424},
  [13213] = {.lex_state = 0, .external_lex_state = 399},
  [13214] = {.lex_state = 47, .external_lex_state = 420},
  [13215] = {.lex_state = 47, .external_lex_state = 382},
  [13216] = {.lex_state = 47, .external_lex_state = 344},
  [13217] = {.lex_state = 0, .external_lex_state = 397},
  [13218] = {.lex_state = 47, .external_lex_state = 381},
  [13219] = {.lex_state = 47, .external_lex_state = 393},
  [13220] = {.lex_state = 47, .external_lex_state = 382},
  [13221] = {.lex_state = 47, .external_lex_state = 345},
  [13222] = {.lex_state = 0, .external_lex_state = 416},
  [13223] = {.lex_state = 47, .external_lex_state = 381},
  [13224] = {.lex_state = 50, .external_lex_state = 308},
  [13225] = {.lex_state = 50, .external_lex_state = 336},
  [13226] = {.lex_state = 51, .external_lex_state = 392},
  [13227] = {.lex_state = 0, .external_lex_state = 384},
  [13228] = {.lex_state = 51, .external_lex_state = 335},
  [13229] = {.lex_state = 47, .external_lex_state = 382},
  [13230] = {.lex_state = 0, .external_lex_state = 384},
  [13231] = {.lex_state = 0, .external_lex_state = 344},
  [13232] = {.lex_state = 47, .external_lex_state = 381},
  [13233] = {.lex_state = 0, .external_lex_state = 384},
  [13234] = {.lex_state = 47, .external_lex_state = 381},
  [13235] = {.lex_state = 47, .external_lex_state = 381},
  [13236] = {.lex_state = 0, .external_lex_state = 384},
  [13237] = {.lex_state = 0, .external_lex_state = 355},
  [13238] = {.lex_state = 0, .external_lex_state = 384},
  [13239] = {.lex_state = 0, .external_lex_state = 384},
  [13240] = {.lex_state = 50, .external_lex_state = 308},
  [13241] = {.lex_state = 50, .external_lex_state = 423},
  [13242] = {.lex_state = 0, .external_lex_state = 394},
  [13243] = {.lex_state = 0, .external_lex_state = 386},
  [13244] = {.lex_state = 0, .external_lex_state = 386},
  [13245] = {.lex_state = 0, .external_lex_state = 355},
  [13246] = {.lex_state = 0, .external_lex_state = 384},
  [13247] = {.lex_state = 0, .external_lex_state = 391},
  [13248] = {.lex_state = 47, .external_lex_state = 382},
  [13249] = {.lex_state = 47, .external_lex_state = 382},
  [13250] = {.lex_state = 47, .external_lex_state = 383},
  [13251] = {.lex_state = 47, .external_lex_state = 381},
  [13252] = {.lex_state = 47, .external_lex_state = 381},
  [13253] = {.lex_state = 50, .external_lex_state = 423},
  [13254] = {.lex_state = 0, .external_lex_state = 394},
  [13255] = {.lex_state = 47, .external_lex_state = 381},
  [13256] = {.lex_state = 47, .external_lex_state = 387},
  [13257] = {.lex_state = 50, .external_lex_state = 423},
  [13258] = {.lex_state = 0, .external_lex_state = 390},
  [13259] = {.lex_state = 47, .external_lex_state = 382},
  [13260] = {.lex_state = 47, .external_lex_state = 381},
  [13261] = {.lex_state = 47, .external_lex_state = 381},
  [13262] = {.lex_state = 0, .external_lex_state = 384},
  [13263] = {.lex_state = 0, .external_lex_state = 377},
  [13264] = {.lex_state = 50, .external_lex_state = 308},
  [13265] = {.lex_state = 50, .external_lex_state = 423},
  [13266] = {.lex_state = 0, .external_lex_state = 384},
  [13267] = {.lex_state = 0, .external_lex_state = 384},
  [13268] = {.lex_state = 47, .external_lex_state = 397},
  [13269] = {.lex_state = 47, .external_lex_state = 308},
  [13270] = {.lex_state = 0, .external_lex_state = 386},
  [13271] = {.lex_state = 0, .external_lex_state = 249},
  [13272] = {.lex_state = 0, .external_lex_state = 390},
  [13273] = {.lex_state = 50, .external_lex_state = 399},
  [13274] = {.lex_state = 0, .external_lex_state = 386},
  [13275] = {.lex_state = 50, .external_lex_state = 399},
  [13276] = {.lex_state = 0, .external_lex_state = 377},
  [13277] = {.lex_state = 47, .external_lex_state = 382},
  [13278] = {.lex_state = 50, .external_lex_state = 423},
  [13279] = {.lex_state = 50, .external_lex_state = 308},
  [13280] = {.lex_state = 51, .external_lex_state = 392},
  [13281] = {.lex_state = 47, .external_lex_state = 382},
  [13282] = {.lex_state = 47, .external_lex_state = 381},
  [13283] = {.lex_state = 47, .external_lex_state = 381},
  [13284] = {.lex_state = 47, .external_lex_state = 382},
  [13285] = {.lex_state = 50, .external_lex_state = 399},
  [13286] = {.lex_state = 47, .external_lex_state = 382},
  [13287] = {.lex_state = 0, .external_lex_state = 377},
  [13288] = {.lex_state = 47, .external_lex_state = 420},
  [13289] = {.lex_state = 47, .external_lex_state = 382},
  [13290] = {.lex_state = 0, .external_lex_state = 386},
  [13291] = {.lex_state = 47, .external_lex_state = 381},
  [13292] = {.lex_state = 0, .external_lex_state = 384},
  [13293] = {.lex_state = 0, .external_lex_state = 384},
  [13294] = {.lex_state = 47, .external_lex_state = 382},
  [13295] = {.lex_state = 50, .external_lex_state = 397},
  [13296] = {.lex_state = 0, .external_lex_state = 377},
  [13297] = {.lex_state = 47, .external_lex_state = 382},
  [13298] = {.lex_state = 0, .external_lex_state = 384},
  [13299] = {.lex_state = 0, .external_lex_state = 377},
  [13300] = {.lex_state = 0, .external_lex_state = 377},
  [13301] = {.lex_state = 50, .external_lex_state = 336},
  [13302] = {.lex_state = 47, .external_lex_state = 381},
  [13303] = {.lex_state = 47, .external_lex_state = 424},
  [13304] = {.lex_state = 0, .external_lex_state = 384},
  [13305] = {.lex_state = 0, .external_lex_state = 384},
  [13306] = {.lex_state = 47, .external_lex_state = 381},
  [13307] = {.lex_state = 47, .external_lex_state = 382},
  [13308] = {.lex_state = 51, .external_lex_state = 392},
  [13309] = {.lex_state = 47, .external_lex_state = 381},
  [13310] = {.lex_state = 47, .external_lex_state = 404},
  [13311] = {.lex_state = 47, .external_lex_state = 355},
  [13312] = {.lex_state = 50, .external_lex_state = 308},
  [13313] = {.lex_state = 50, .external_lex_state = 423},
  [13314] = {.lex_state = 47, .external_lex_state = 381},
  [13315] = {.lex_state = 51, .external_lex_state = 392},
  [13316] = {.lex_state = 0, .external_lex_state = 384},
  [13317] = {.lex_state = 47, .external_lex_state = 422},
  [13318] = {.lex_state = 47, .external_lex_state = 425},
  [13319] = {.lex_state = 0, .external_lex_state = 386},
  [13320] = {.lex_state = 0, .external_lex_state = 390},
  [13321] = {.lex_state = 0, .external_lex_state = 384},
  [13322] = {.lex_state = 47, .external_lex_state = 381},
  [13323] = {.lex_state = 50, .external_lex_state = 308},
  [13324] = {.lex_state = 0, .external_lex_state = 386},
  [13325] = {.lex_state = 47, .external_lex_state = 381},
  [13326] = {.lex_state = 47, .external_lex_state = 381},
  [13327] = {.lex_state = 50, .external_lex_state = 308},
  [13328] = {.lex_state = 47, .external_lex_state = 382},
  [13329] = {.lex_state = 0, .external_lex_state = 377},
  [13330] = {.lex_state = 50, .external_lex_state = 308},
  [13331] = {.lex_state = 0, .external_lex_state = 384},
  [13332] = {.lex_state = 47, .external_lex_state = 381},
  [13333] = {.lex_state = 47, .external_lex_state = 380},
  [13334] = {.lex_state = 47, .external_lex_state = 381},
  [13335] = {.lex_state = 47, .external_lex_state = 381},
  [13336] = {.lex_state = 0, .external_lex_state = 377},
  [13337] = {.lex_state = 47, .external_lex_state = 344},
  [13338] = {.lex_state = 0, .external_lex_state = 384},
  [13339] = {.lex_state = 0, .external_lex_state = 377},
  [13340] = {.lex_state = 0, .external_lex_state = 386},
  [13341] = {.lex_state = 50, .external_lex_state = 308},
  [13342] = {.lex_state = 0, .external_lex_state = 386},
  [13343] = {.lex_state = 47, .external_lex_state = 399},
  [13344] = {.lex_state = 0, .external_lex_state = 377},
  [13345] = {.lex_state = 0, .external_lex_state = 377},
  [13346] = {.lex_state = 0, .external_lex_state = 384},
  [13347] = {.lex_state = 47, .external_lex_state = 381},
  [13348] = {.lex_state = 47, .external_lex_state = 393},
  [13349] = {.lex_state = 47, .external_lex_state = 412},
  [13350] = {.lex_state = 0, .external_lex_state = 377},
  [13351] = {.lex_state = 47, .external_lex_state = 400},
  [13352] = {.lex_state = 0, .external_lex_state = 377},
  [13353] = {.lex_state = 47, .external_lex_state = 355},
  [13354] = {.lex_state = 0, .external_lex_state = 377},
  [13355] = {.lex_state = 0, .external_lex_state = 386},
  [13356] = {.lex_state = 0, .external_lex_state = 384},
  [13357] = {.lex_state = 47, .external_lex_state = 381},
  [13358] = {.lex_state = 47, .external_lex_state = 381},
  [13359] = {.lex_state = 0, .external_lex_state = 394},
  [13360] = {.lex_state = 0, .external_lex_state = 377},
  [13361] = {.lex_state = 0, .external_lex_state = 377},
  [13362] = {.lex_state = 47, .external_lex_state = 380},
  [13363] = {.lex_state = 47, .external_lex_state = 422},
  [13364] = {.lex_state = 0, .external_lex_state = 377},
  [13365] = {.lex_state = 47, .external_lex_state = 380},
  [13366] = {.lex_state = 47, .external_lex_state = 355},
  [13367] = {.lex_state = 50, .external_lex_state = 399},
  [13368] = {.lex_state = 47, .external_lex_state = 381},
  [13369] = {.lex_state = 47, .external_lex_state = 381},
  [13370] = {.lex_state = 0, .external_lex_state = 377},
  [13371] = {.lex_state = 0, .external_lex_state = 377},
  [13372] = {.lex_state = 50, .external_lex_state = 308},
  [13373] = {.lex_state = 0, .external_lex_state = 377},
  [13374] = {.lex_state = 0, .external_lex_state = 377},
  [13375] = {.lex_state = 47, .external_lex_state = 381},
  [13376] = {.lex_state = 0, .external_lex_state = 377},
  [13377] = {.lex_state = 0, .external_lex_state = 377},
  [13378] = {.lex_state = 47, .external_lex_state = 381},
  [13379] = {.lex_state = 0, .external_lex_state = 377},
  [13380] = {.lex_state = 0, .external_lex_state = 377},
  [13381] = {.lex_state = 0, .external_lex_state = 399},
  [13382] = {.lex_state = 0, .external_lex_state = 384},
  [13383] = {.lex_state = 0, .external_lex_state = 377},
  [13384] = {.lex_state = 0, .external_lex_state = 386},
  [13385] = {.lex_state = 50, .external_lex_state = 423},
  [13386] = {.lex_state = 0, .external_lex_state = 386},
  [13387] = {.lex_state = 47, .external_lex_state = 404},
  [13388] = {.lex_state = 47, .external_lex_state = 387},
  [13389] = {.lex_state = 47, .external_lex_state = 400},
  [13390] = {.lex_state = 47, .external_lex_state = 308},
  [13391] = {.lex_state = 47, .external_lex_state = 308},
  [13392] = {.lex_state = 47, .external_lex_state = 397},
  [13393] = {.lex_state = 0, .external_lex_state = 391},
  [13394] = {.lex_state = 0, .external_lex_state = 394},
  [13395] = {.lex_state = 47, .external_lex_state = 308},
  [13396] = {.lex_state = 50, .external_lex_state = 308},
  [13397] = {.lex_state = 47, .external_lex_state = 308},
  [13398] = {.lex_state = 47, .external_lex_state = 426},
  [13399] = {.lex_state = 47, .external_lex_state = 402},
  [13400] = {.lex_state = 47, .external_lex_state = 419},
  [13401] = {.lex_state = 47, .external_lex_state = 397},
  [13402] = {.lex_state = 0, .external_lex_state = 335},
  [13403] = {.lex_state = 47, .external_lex_state = 402},
  [13404] = {.lex_state = 47, .external_lex_state = 308},
  [13405] = {.lex_state = 51, .external_lex_state = 392},
  [13406] = {.lex_state = 47, .external_lex_state = 426},
  [13407] = {.lex_state = 47, .external_lex_state = 336},
  [13408] = {.lex_state = 0, .external_lex_state = 308},
  [13409] = {.lex_state = 0, .external_lex_state = 344},
  [13410] = {.lex_state = 51, .external_lex_state = 392},
  [13411] = {.lex_state = 47, .external_lex_state = 308},
  [13412] = {.lex_state = 47, .external_lex_state = 308},
  [13413] = {.lex_state = 47, .external_lex_state = 397},
  [13414] = {.lex_state = 51, .external_lex_state = 392},
  [13415] = {.lex_state = 0, .external_lex_state = 355},
  [13416] = {.lex_state = 0, .external_lex_state = 390},
  [13417] = {.lex_state = 47, .external_lex_state = 308},
  [13418] = {.lex_state = 0, .external_lex_state = 390},
  [13419] = {.lex_state = 0, .external_lex_state = 390},
  [13420] = {.lex_state = 0, .external_lex_state = 390},
  [13421] = {.lex_state = 47, .external_lex_state = 308},
  [13422] = {.lex_state = 47, .external_lex_state = 427},
  [13423] = {.lex_state = 47, .external_lex_state = 427},
  [13424] = {.lex_state = 47, .external_lex_state = 427},
  [13425] = {.lex_state = 47, .external_lex_state = 385},
  [13426] = {.lex_state = 47, .external_lex_state = 308},
  [13427] = {.lex_state = 47, .external_lex_state = 308},
  [13428] = {.lex_state = 47, .external_lex_state = 385},
  [13429] = {.lex_state = 47, .external_lex_state = 385},
  [13430] = {.lex_state = 47, .external_lex_state = 385},
  [13431] = {.lex_state = 47, .external_lex_state = 385},
  [13432] = {.lex_state = 51, .external_lex_state = 392},
  [13433] = {.lex_state = 47, .external_lex_state = 308},
  [13434] = {.lex_state = 0, .external_lex_state = 390},
  [13435] = {.lex_state = 47, .external_lex_state = 308},
  [13436] = {.lex_state = 0, .external_lex_state = 390},
  [13437] = {.lex_state = 47, .external_lex_state = 308},
  [13438] = {.lex_state = 47, .external_lex_state = 308},
  [13439] = {.lex_state = 0, .external_lex_state = 390},
  [13440] = {.lex_state = 47, .external_lex_state = 397},
  [13441] = {.lex_state = 0, .external_lex_state = 390},
  [13442] = {.lex_state = 0, .external_lex_state = 390},
  [13443] = {.lex_state = 0, .external_lex_state = 390},
  [13444] = {.lex_state = 0, .external_lex_state = 390},
  [13445] = {.lex_state = 0, .external_lex_state = 390},
  [13446] = {.lex_state = 47, .external_lex_state = 399},
  [13447] = {.lex_state = 47, .external_lex_state = 397},
  [13448] = {.lex_state = 47, .external_lex_state = 399},
  [13449] = {.lex_state = 47, .external_lex_state = 308},
  [13450] = {.lex_state = 47, .external_lex_state = 399},
  [13451] = {.lex_state = 47, .external_lex_state = 399},
  [13452] = {.lex_state = 47, .external_lex_state = 399},
  [13453] = {.lex_state = 47, .external_lex_state = 308},
  [13454] = {.lex_state = 47, .external_lex_state = 399},
  [13455] = {.lex_state = 47, .external_lex_state = 399},
  [13456] = {.lex_state = 47, .external_lex_state = 399},
  [13457] = {.lex_state = 47, .external_lex_state = 399},
  [13458] = {.lex_state = 47, .external_lex_state = 399},
  [13459] = {.lex_state = 47, .external_lex_state = 308},
  [13460] = {.lex_state = 47, .external_lex_state = 399},
  [13461] = {.lex_state = 47, .external_lex_state = 399},
  [13462] = {.lex_state = 47, .external_lex_state = 308},
  [13463] = {.lex_state = 47, .external_lex_state = 399},
  [13464] = {.lex_state = 47, .external_lex_state = 399},
  [13465] = {.lex_state = 47, .external_lex_state = 399},
  [13466] = {.lex_state = 0, .external_lex_state = 344},
  [13467] = {.lex_state = 47, .external_lex_state = 308},
  [13468] = {.lex_state = 47, .external_lex_state = 308},
  [13469] = {.lex_state = 47, .external_lex_state = 399},
  [13470] = {.lex_state = 0, .external_lex_state = 390},
  [13471] = {.lex_state = 47, .external_lex_state = 308},
  [13472] = {.lex_state = 50, .external_lex_state = 308},
  [13473] = {.lex_state = 47, .external_lex_state = 385},
  [13474] = {.lex_state = 47, .external_lex_state = 422},
  [13475] = {.lex_state = 0, .external_lex_state = 390},
  [13476] = {.lex_state = 51, .external_lex_state = 392},
  [13477] = {.lex_state = 47, .external_lex_state = 308},
  [13478] = {.lex_state = 50, .external_lex_state = 308},
  [13479] = {.lex_state = 51, .external_lex_state = 392},
  [13480] = {.lex_state = 51, .external_lex_state = 392},
  [13481] = {.lex_state = 47, .external_lex_state = 308},
  [13482] = {.lex_state = 47, .external_lex_state = 308},
  [13483] = {.lex_state = 47, .external_lex_state = 308},
  [13484] = {.lex_state = 47, .external_lex_state = 336},
  [13485] = {.lex_state = 47, .external_lex_state = 308},
  [13486] = {.lex_state = 51, .external_lex_state = 392},
  [13487] = {.lex_state = 47, .external_lex_state = 345},
  [13488] = {.lex_state = 47, .external_lex_state = 345},
  [13489] = {.lex_state = 47, .external_lex_state = 308},
  [13490] = {.lex_state = 47, .external_lex_state = 308},
  [13491] = {.lex_state = 47, .external_lex_state = 399},
  [13492] = {.lex_state = 47, .external_lex_state = 308},
  [13493] = {.lex_state = 51, .external_lex_state = 392},
  [13494] = {.lex_state = 47, .external_lex_state = 308},
  [13495] = {.lex_state = 0, .external_lex_state = 308},
  [13496] = {.lex_state = 0, .external_lex_state = 308},
  [13497] = {.lex_state = 47, .external_lex_state = 308},
  [13498] = {.lex_state = 47, .external_lex_state = 308},
  [13499] = {.lex_state = 47, .external_lex_state = 308},
  [13500] = {.lex_state = 47, .external_lex_state = 308},
  [13501] = {.lex_state = 47, .external_lex_state = 399},
  [13502] = {.lex_state = 47, .external_lex_state = 308},
  [13503] = {.lex_state = 47, .external_lex_state = 308},
  [13504] = {.lex_state = 51, .external_lex_state = 392},
  [13505] = {.lex_state = 47, .external_lex_state = 399},
  [13506] = {.lex_state = 47, .external_lex_state = 308},
  [13507] = {.lex_state = 47, .external_lex_state = 428},
  [13508] = {.lex_state = 47, .external_lex_state = 308},
  [13509] = {.lex_state = 50, .external_lex_state = 399},
  [13510] = {.lex_state = 47, .external_lex_state = 308},
  [13511] = {.lex_state = 47, .external_lex_state = 345},
  [13512] = {.lex_state = 47, .external_lex_state = 308},
  [13513] = {.lex_state = 47, .external_lex_state = 428},
  [13514] = {.lex_state = 0, .external_lex_state = 419},
  [13515] = {.lex_state = 51, .external_lex_state = 392},
  [13516] = {.lex_state = 47, .external_lex_state = 308},
  [13517] = {.lex_state = 47, .external_lex_state = 308},
  [13518] = {.lex_state = 47, .external_lex_state = 336},
  [13519] = {.lex_state = 47, .external_lex_state = 308},
  [13520] = {.lex_state = 47, .external_lex_state = 336},
  [13521] = {.lex_state = 47, .external_lex_state = 344},
  [13522] = {.lex_state = 47, .external_lex_state = 345},
  [13523] = {.lex_state = 47, .external_lex_state = 308},
  [13524] = {.lex_state = 47, .external_lex_state = 308},
  [13525] = {.lex_state = 47, .external_lex_state = 344},
  [13526] = {.lex_state = 47, .external_lex_state = 344},
  [13527] = {.lex_state = 47, .external_lex_state = 344},
  [13528] = {.lex_state = 0, .external_lex_state = 418},
  [13529] = {.lex_state = 47, .external_lex_state = 308},
  [13530] = {.lex_state = 47, .external_lex_state = 344},
  [13531] = {.lex_state = 47, .external_lex_state = 308},
  [13532] = {.lex_state = 0, .external_lex_state = 391},
  [13533] = {.lex_state = 47, .external_lex_state = 308},
  [13534] = {.lex_state = 50, .external_lex_state = 308},
  [13535] = {.lex_state = 47, .external_lex_state = 308},
  [13536] = {.lex_state = 47, .external_lex_state = 308},
  [13537] = {.lex_state = 0, .external_lex_state = 394},
  [13538] = {.lex_state = 0, .external_lex_state = 308},
  [13539] = {.lex_state = 47, .external_lex_state = 308},
  [13540] = {.lex_state = 47, .external_lex_state = 308},
  [13541] = {.lex_state = 47, .external_lex_state = 308},
  [13542] = {.lex_state = 47, .external_lex_state = 308},
  [13543] = {.lex_state = 0, .external_lex_state = 308},
  [13544] = {.lex_state = 47, .external_lex_state = 399},
  [13545] = {.lex_state = 47, .external_lex_state = 308},
  [13546] = {.lex_state = 47, .external_lex_state = 399},
  [13547] = {.lex_state = 47, .external_lex_state = 428},
  [13548] = {.lex_state = 47, .external_lex_state = 308},
  [13549] = {.lex_state = 47, .external_lex_state = 308},
  [13550] = {.lex_state = 47, .external_lex_state = 428},
  [13551] = {.lex_state = 47, .external_lex_state = 308},
  [13552] = {.lex_state = 47, .external_lex_state = 429},
  [13553] = {.lex_state = 50, .external_lex_state = 308},
  [13554] = {.lex_state = 0, .external_lex_state = 188},
  [13555] = {.lex_state = 50, .external_lex_state = 399},
  [13556] = {.lex_state = 50, .external_lex_state = 399},
  [13557] = {.lex_state = 51, .external_lex_state = 392},
  [13558] = {.lex_state = 50, .external_lex_state = 399},
  [13559] = {.lex_state = 51, .external_lex_state = 392},
  [13560] = {.lex_state = 51, .external_lex_state = 392},
  [13561] = {.lex_state = 47, .external_lex_state = 399},
  [13562] = {.lex_state = 47, .external_lex_state = 336},
  [13563] = {.lex_state = 47, .external_lex_state = 429},
  [13564] = {.lex_state = 47, .external_lex_state = 308},
  [13565] = {.lex_state = 51, .external_lex_state = 392},
  [13566] = {.lex_state = 47, .external_lex_state = 308},
  [13567] = {.lex_state = 0, .external_lex_state = 335},
  [13568] = {.lex_state = 47, .external_lex_state = 399},
  [13569] = {.lex_state = 0, .external_lex_state = 418},
  [13570] = {.lex_state = 47, .external_lex_state = 399},
  [13571] = {.lex_state = 47, .external_lex_state = 308},
  [13572] = {.lex_state = 47, .external_lex_state = 429},
  [13573] = {.lex_state = 51, .external_lex_state = 392},
  [13574] = {.lex_state = 47, .external_lex_state = 399},
  [13575] = {.lex_state = 47, .external_lex_state = 399},
  [13576] = {.lex_state = 47, .external_lex_state = 428},
  [13577] = {.lex_state = 47, .external_lex_state = 428},
  [13578] = {.lex_state = 47, .external_lex_state = 308},
  [13579] = {.lex_state = 47, .external_lex_state = 308},
  [13580] = {.lex_state = 47, .external_lex_state = 399},
  [13581] = {.lex_state = 47, .external_lex_state = 399},
  [13582] = {.lex_state = 47, .external_lex_state = 308},
  [13583] = {.lex_state = 50, .external_lex_state = 399},
  [13584] = {.lex_state = 0, .external_lex_state = 391},
  [13585] = {.lex_state = 0, .external_lex_state = 391},
  [13586] = {.lex_state = 50, .external_lex_state = 399},
  [13587] = {.lex_state = 50, .external_lex_state = 397},
  [13588] = {.lex_state = 47, .external_lex_state = 308},
  [13589] = {.lex_state = 47, .external_lex_state = 308},
  [13590] = {.lex_state = 0, .external_lex_state = 390},
  [13591] = {.lex_state = 0, .external_lex_state = 308},
  [13592] = {.lex_state = 0, .external_lex_state = 308},
  [13593] = {.lex_state = 0, .external_lex_state = 391},
  [13594] = {.lex_state = 0, .external_lex_state = 391},
  [13595] = {.lex_state = 47, .external_lex_state = 399},
  [13596] = {.lex_state = 51, .external_lex_state = 392},
  [13597] = {.lex_state = 47, .external_lex_state = 399},
  [13598] = {.lex_state = 0, .external_lex_state = 391},
  [13599] = {.lex_state = 0, .external_lex_state = 391},
  [13600] = {.lex_state = 50, .external_lex_state = 397},
  [13601] = {.lex_state = 0, .external_lex_state = 308},
  [13602] = {.lex_state = 47, .external_lex_state = 308},
  [13603] = {.lex_state = 0, .external_lex_state = 391},
  [13604] = {.lex_state = 47, .external_lex_state = 308},
  [13605] = {.lex_state = 51, .external_lex_state = 392},
  [13606] = {.lex_state = 0, .external_lex_state = 391},
  [13607] = {.lex_state = 47, .external_lex_state = 430},
  [13608] = {.lex_state = 0, .external_lex_state = 391},
  [13609] = {.lex_state = 0, .external_lex_state = 391},
  [13610] = {.lex_state = 0, .external_lex_state = 391},
  [13611] = {.lex_state = 0, .external_lex_state = 391},
  [13612] = {.lex_state = 47, .external_lex_state = 404},
  [13613] = {.lex_state = 47, .external_lex_state = 308},
  [13614] = {.lex_state = 0, .external_lex_state = 391},
  [13615] = {.lex_state = 47, .external_lex_state = 427},
  [13616] = {.lex_state = 0, .external_lex_state = 394},
  [13617] = {.lex_state = 47, .external_lex_state = 431},
  [13618] = {.lex_state = 0, .external_lex_state = 394},
  [13619] = {.lex_state = 0, .external_lex_state = 394},
  [13620] = {.lex_state = 47, .external_lex_state = 308},
  [13621] = {.lex_state = 50, .external_lex_state = 308},
  [13622] = {.lex_state = 0, .external_lex_state = 391},
  [13623] = {.lex_state = 0, .external_lex_state = 188},
  [13624] = {.lex_state = 0, .external_lex_state = 394},
  [13625] = {.lex_state = 0, .external_lex_state = 394},
  [13626] = {.lex_state = 47, .external_lex_state = 397},
  [13627] = {.lex_state = 47, .external_lex_state = 308},
  [13628] = {.lex_state = 0, .external_lex_state = 394},
  [13629] = {.lex_state = 0, .external_lex_state = 394},
  [13630] = {.lex_state = 51, .external_lex_state = 392},
  [13631] = {.lex_state = 0, .external_lex_state = 394},
  [13632] = {.lex_state = 0, .external_lex_state = 394},
  [13633] = {.lex_state = 47, .external_lex_state = 399},
  [13634] = {.lex_state = 47, .external_lex_state = 308},
  [13635] = {.lex_state = 0, .external_lex_state = 418},
  [13636] = {.lex_state = 47, .external_lex_state = 399},
  [13637] = {.lex_state = 47, .external_lex_state = 399},
  [13638] = {.lex_state = 0, .external_lex_state = 394},
  [13639] = {.lex_state = 47, .external_lex_state = 399},
  [13640] = {.lex_state = 47, .external_lex_state = 399},
  [13641] = {.lex_state = 47, .external_lex_state = 399},
  [13642] = {.lex_state = 47, .external_lex_state = 399},
  [13643] = {.lex_state = 47, .external_lex_state = 428},
  [13644] = {.lex_state = 47, .external_lex_state = 308},
  [13645] = {.lex_state = 0, .external_lex_state = 335},
  [13646] = {.lex_state = 47, .external_lex_state = 399},
  [13647] = {.lex_state = 47, .external_lex_state = 399},
  [13648] = {.lex_state = 47, .external_lex_state = 399},
  [13649] = {.lex_state = 47, .external_lex_state = 399},
  [13650] = {.lex_state = 47, .external_lex_state = 308},
  [13651] = {.lex_state = 0, .external_lex_state = 394},
  [13652] = {.lex_state = 0, .external_lex_state = 394},
  [13653] = {.lex_state = 47, .external_lex_state = 308},
  [13654] = {.lex_state = 47, .external_lex_state = 399},
  [13655] = {.lex_state = 47, .external_lex_state = 399},
  [13656] = {.lex_state = 0, .external_lex_state = 432},
  [13657] = {.lex_state = 0, .external_lex_state = 188},
  [13658] = {.lex_state = 0, .external_lex_state = 335},
  [13659] = {.lex_state = 47, .external_lex_state = 308},
  [13660] = {.lex_state = 47, .external_lex_state = 399},
  [13661] = {.lex_state = 47, .external_lex_state = 399},
  [13662] = {.lex_state = 47, .external_lex_state = 399},
  [13663] = {.lex_state = 50, .external_lex_state = 399},
  [13664] = {.lex_state = 51, .external_lex_state = 392},
  [13665] = {.lex_state = 47, .external_lex_state = 355},
  [13666] = {.lex_state = 47, .external_lex_state = 399},
  [13667] = {.lex_state = 0, .external_lex_state = 394},
  [13668] = {.lex_state = 47, .external_lex_state = 418},
  [13669] = {.lex_state = 0, .external_lex_state = 394},
  [13670] = {.lex_state = 0, .external_lex_state = 394},
  [13671] = {.lex_state = 47, .external_lex_state = 308},
  [13672] = {.lex_state = 47, .external_lex_state = 399},
  [13673] = {.lex_state = 47, .external_lex_state = 399},
  [13674] = {.lex_state = 0, .external_lex_state = 394},
  [13675] = {.lex_state = 47, .external_lex_state = 430},
  [13676] = {.lex_state = 51, .external_lex_state = 392},
  [13677] = {.lex_state = 47, .external_lex_state = 397},
  [13678] = {.lex_state = 0, .external_lex_state = 394},
  [13679] = {.lex_state = 0, .external_lex_state = 394},
  [13680] = {.lex_state = 47, .external_lex_state = 427},
  [13681] = {.lex_state = 47, .external_lex_state = 397},
  [13682] = {.lex_state = 0, .external_lex_state = 394},
  [13683] = {.lex_state = 47, .external_lex_state = 308},
  [13684] = {.lex_state = 0, .external_lex_state = 394},
  [13685] = {.lex_state = 0, .external_lex_state = 394},
  [13686] = {.lex_state = 0, .external_lex_state = 394},
  [13687] = {.lex_state = 50, .external_lex_state = 397},
  [13688] = {.lex_state = 0, .external_lex_state = 394},
  [13689] = {.lex_state = 0, .external_lex_state = 308},
  [13690] = {.lex_state = 0, .external_lex_state = 394},
  [13691] = {.lex_state = 0, .external_lex_state = 188},
  [13692] = {.lex_state = 47, .external_lex_state = 308},
  [13693] = {.lex_state = 0, .external_lex_state = 394},
  [13694] = {.lex_state = 51, .external_lex_state = 392},
  [13695] = {.lex_state = 47, .external_lex_state = 308},
  [13696] = {.lex_state = 47, .external_lex_state = 393},
  [13697] = {.lex_state = 0, .external_lex_state = 394},
  [13698] = {.lex_state = 47, .external_lex_state = 308},
  [13699] = {.lex_state = 51, .external_lex_state = 392},
  [13700] = {.lex_state = 47, .external_lex_state = 399},
  [13701] = {.lex_state = 0, .external_lex_state = 394},
  [13702] = {.lex_state = 0, .external_lex_state = 394},
  [13703] = {.lex_state = 0, .external_lex_state = 394},
  [13704] = {.lex_state = 50, .external_lex_state = 397},
  [13705] = {.lex_state = 50, .external_lex_state = 397},
  [13706] = {.lex_state = 0, .external_lex_state = 394},
  [13707] = {.lex_state = 0, .external_lex_state = 391},
  [13708] = {.lex_state = 47, .external_lex_state = 308},
  [13709] = {.lex_state = 0, .external_lex_state = 391},
  [13710] = {.lex_state = 47, .external_lex_state = 427},
  [13711] = {.lex_state = 0, .external_lex_state = 391},
  [13712] = {.lex_state = 0, .external_lex_state = 249},
  [13713] = {.lex_state = 0, .external_lex_state = 391},
  [13714] = {.lex_state = 51, .external_lex_state = 392},
  [13715] = {.lex_state = 0, .external_lex_state = 394},
  [13716] = {.lex_state = 0, .external_lex_state = 391},
  [13717] = {.lex_state = 47, .external_lex_state = 308},
  [13718] = {.lex_state = 0, .external_lex_state = 391},
  [13719] = {.lex_state = 47, .external_lex_state = 431},
  [13720] = {.lex_state = 0, .external_lex_state = 391},
  [13721] = {.lex_state = 0, .external_lex_state = 335},
  [13722] = {.lex_state = 0, .external_lex_state = 391},
  [13723] = {.lex_state = 0, .external_lex_state = 308},
  [13724] = {.lex_state = 0, .external_lex_state = 391},
  [13725] = {.lex_state = 47, .external_lex_state = 308},
  [13726] = {.lex_state = 47, .external_lex_state = 308},
  [13727] = {.lex_state = 0, .external_lex_state = 188},
  [13728] = {.lex_state = 0, .external_lex_state = 391},
  [13729] = {.lex_state = 0, .external_lex_state = 391},
  [13730] = {.lex_state = 47, .external_lex_state = 399},
  [13731] = {.lex_state = 47, .external_lex_state = 308},
  [13732] = {.lex_state = 47, .external_lex_state = 399},
  [13733] = {.lex_state = 0, .external_lex_state = 391},
  [13734] = {.lex_state = 0, .external_lex_state = 391},
  [13735] = {.lex_state = 0, .external_lex_state = 391},
  [13736] = {.lex_state = 0, .external_lex_state = 391},
  [13737] = {.lex_state = 47, .external_lex_state = 308},
  [13738] = {.lex_state = 47, .external_lex_state = 308},
  [13739] = {.lex_state = 0, .external_lex_state = 413},
  [13740] = {.lex_state = 0, .external_lex_state = 391},
  [13741] = {.lex_state = 0, .external_lex_state = 391},
  [13742] = {.lex_state = 0, .external_lex_state = 390},
  [13743] = {.lex_state = 0, .external_lex_state = 391},
  [13744] = {.lex_state = 47, .external_lex_state = 399},
  [13745] = {.lex_state = 0, .external_lex_state = 308},
  [13746] = {.lex_state = 0, .external_lex_state = 433},
  [13747] = {.lex_state = 47, .external_lex_state = 399},
  [13748] = {.lex_state = 51, .external_lex_state = 392},
  [13749] = {.lex_state = 47, .external_lex_state = 308},
  [13750] = {.lex_state = 0, .external_lex_state = 249},
  [13751] = {.lex_state = 47, .external_lex_state = 429},
  [13752] = {.lex_state = 47, .external_lex_state = 355},
  [13753] = {.lex_state = 51, .external_lex_state = 392},
  [13754] = {.lex_state = 51, .external_lex_state = 392},
  [13755] = {.lex_state = 47, .external_lex_state = 434},
  [13756] = {.lex_state = 47, .external_lex_state = 429},
  [13757] = {.lex_state = 47, .external_lex_state = 429},
  [13758] = {.lex_state = 51, .external_lex_state = 392},
  [13759] = {.lex_state = 47, .external_lex_state = 400},
  [13760] = {.lex_state = 47, .external_lex_state = 400},
  [13761] = {.lex_state = 51, .external_lex_state = 392},
  [13762] = {.lex_state = 47, .external_lex_state = 400},
  [13763] = {.lex_state = 47, .external_lex_state = 308},
  [13764] = {.lex_state = 0, .external_lex_state = 390},
  [13765] = {.lex_state = 47, .external_lex_state = 308},
  [13766] = {.lex_state = 47, .external_lex_state = 308},
  [13767] = {.lex_state = 47, .external_lex_state = 400},
  [13768] = {.lex_state = 47, .external_lex_state = 308},
  [13769] = {.lex_state = 0, .external_lex_state = 188},
  [13770] = {.lex_state = 47, .external_lex_state = 308},
  [13771] = {.lex_state = 47, .external_lex_state = 308},
  [13772] = {.lex_state = 47, .external_lex_state = 308},
  [13773] = {.lex_state = 0, .external_lex_state = 249},
  [13774] = {.lex_state = 0, .external_lex_state = 390},
  [13775] = {.lex_state = 0, .external_lex_state = 335},
  [13776] = {.lex_state = 0, .external_lex_state = 335},
  [13777] = {.lex_state = 50, .external_lex_state = 308},
  [13778] = {.lex_state = 0, .external_lex_state = 188},
  [13779] = {.lex_state = 0, .external_lex_state = 249},
  [13780] = {.lex_state = 0, .external_lex_state = 308},
  [13781] = {.lex_state = 47, .external_lex_state = 308},
  [13782] = {.lex_state = 47, .external_lex_state = 308},
  [13783] = {.lex_state = 47, .external_lex_state = 308},
  [13784] = {.lex_state = 47, .external_lex_state = 434},
  [13785] = {.lex_state = 47, .external_lex_state = 434},
  [13786] = {.lex_state = 0, .external_lex_state = 345},
  [13787] = {.lex_state = 0, .external_lex_state = 345},
  [13788] = {.lex_state = 51, .external_lex_state = 392},
  [13789] = {.lex_state = 0, .external_lex_state = 308},
  [13790] = {.lex_state = 0, .external_lex_state = 308},
  [13791] = {.lex_state = 0, .external_lex_state = 432},
  [13792] = {.lex_state = 47, .external_lex_state = 308},
  [13793] = {.lex_state = 50, .external_lex_state = 308},
  [13794] = {.lex_state = 50, .external_lex_state = 308},
  [13795] = {.lex_state = 0, .external_lex_state = 335},
  [13796] = {.lex_state = 0, .external_lex_state = 308},
  [13797] = {.lex_state = 0, .external_lex_state = 308},
  [13798] = {.lex_state = 0, .external_lex_state = 308},
  [13799] = {.lex_state = 0, .external_lex_state = 308},
  [13800] = {.lex_state = 50, .external_lex_state = 308},
  [13801] = {.lex_state = 51, .external_lex_state = 392},
  [13802] = {.lex_state = 47, .external_lex_state = 308},
  [13803] = {.lex_state = 0, .external_lex_state = 308},
  [13804] = {.lex_state = 0, .external_lex_state = 308},
  [13805] = {.lex_state = 0, .external_lex_state = 308},
  [13806] = {.lex_state = 0, .external_lex_state = 390},
  [13807] = {.lex_state = 51, .external_lex_state = 392},
  [13808] = {.lex_state = 47, .external_lex_state = 308},
  [13809] = {.lex_state = 47, .external_lex_state = 308},
  [13810] = {.lex_state = 47, .external_lex_state = 308},
  [13811] = {.lex_state = 47, .external_lex_state = 434},
  [13812] = {.lex_state = 47, .external_lex_state = 308},
  [13813] = {.lex_state = 47, .external_lex_state = 434},
  [13814] = {.lex_state = 47, .external_lex_state = 434},
  [13815] = {.lex_state = 0, .external_lex_state = 335},
  [13816] = {.lex_state = 0, .external_lex_state = 308},
  [13817] = {.lex_state = 0, .external_lex_state = 335},
  [13818] = {.lex_state = 47, .external_lex_state = 308},
  [13819] = {.lex_state = 0, .external_lex_state = 419},
  [13820] = {.lex_state = 0, .external_lex_state = 335},
  [13821] = {.lex_state = 0, .external_lex_state = 343},
  [13822] = {.lex_state = 0, .external_lex_state = 432},
  [13823] = {.lex_state = 47, .external_lex_state = 400},
  [13824] = {.lex_state = 47, .external_lex_state = 397},
  [13825] = {.lex_state = 47, .external_lex_state = 397},
  [13826] = {.lex_state = 47, .external_lex_state = 308},
  [13827] = {.lex_state = 0, .external_lex_state = 390},
  [13828] = {.lex_state = 51, .external_lex_state = 392},
  [13829] = {.lex_state = 47, .external_lex_state = 434},
  [13830] = {.lex_state = 0, .external_lex_state = 390},
  [13831] = {.lex_state = 47, .external_lex_state = 345},
  [13832] = {.lex_state = 0, .external_lex_state = 394},
  [13833] = {.lex_state = 47, .external_lex_state = 434},
  [13834] = {.lex_state = 51, .external_lex_state = 392},
  [13835] = {.lex_state = 47, .external_lex_state = 308},
  [13836] = {.lex_state = 47, .external_lex_state = 308},
  [13837] = {.lex_state = 47, .external_lex_state = 434},
  [13838] = {.lex_state = 47, .external_lex_state = 400},
  [13839] = {.lex_state = 47, .external_lex_state = 400},
  [13840] = {.lex_state = 50, .external_lex_state = 308},
  [13841] = {.lex_state = 47, .external_lex_state = 308},
  [13842] = {.lex_state = 47, .external_lex_state = 308},
  [13843] = {.lex_state = 0, .external_lex_state = 335},
  [13844] = {.lex_state = 0, .external_lex_state = 308},
  [13845] = {.lex_state = 47, .external_lex_state = 308},
  [13846] = {.lex_state = 47, .external_lex_state = 426},
  [13847] = {.lex_state = 47, .external_lex_state = 397},
  [13848] = {.lex_state = 47, .external_lex_state = 426},
  [13849] = {.lex_state = 0, .external_lex_state = 335},
  [13850] = {.lex_state = 47, .external_lex_state = 308},
  [13851] = {.lex_state = 47, .external_lex_state = 308},
  [13852] = {.lex_state = 47, .external_lex_state = 397},
  [13853] = {.lex_state = 51, .external_lex_state = 392},
  [13854] = {.lex_state = 47, .external_lex_state = 308},
  [13855] = {.lex_state = 47, .external_lex_state = 397},
  [13856] = {.lex_state = 47, .external_lex_state = 308},
  [13857] = {.lex_state = 51, .external_lex_state = 392},
  [13858] = {.lex_state = 51, .external_lex_state = 392},
  [13859] = {.lex_state = 50, .external_lex_state = 308},
  [13860] = {.lex_state = 47, .external_lex_state = 426},
  [13861] = {.lex_state = 0, .external_lex_state = 390},
  [13862] = {.lex_state = 47, .external_lex_state = 308},
  [13863] = {.lex_state = 47, .external_lex_state = 397},
  [13864] = {.lex_state = 0, .external_lex_state = 416},
  [13865] = {.lex_state = 50, .external_lex_state = 308},
  [13866] = {.lex_state = 0, .external_lex_state = 308},
  [13867] = {.lex_state = 51, .external_lex_state = 392},
  [13868] = {.lex_state = 47, .external_lex_state = 397},
  [13869] = {.lex_state = 50, .external_lex_state = 308},
  [13870] = {.lex_state = 50, .external_lex_state = 308},
  [13871] = {.lex_state = 0, .external_lex_state = 345},
  [13872] = {.lex_state = 47, .external_lex_state = 397},
  [13873] = {.lex_state = 0, .external_lex_state = 335},
  [13874] = {.lex_state = 51, .external_lex_state = 392},
  [13875] = {.lex_state = 51, .external_lex_state = 392},
  [13876] = {.lex_state = 47, .external_lex_state = 308},
  [13877] = {.lex_state = 47, .external_lex_state = 397},
  [13878] = {.lex_state = 47, .external_lex_state = 430},
  [13879] = {.lex_state = 0, .external_lex_state = 390},
  [13880] = {.lex_state = 47, .external_lex_state = 308},
  [13881] = {.lex_state = 0, .external_lex_state = 308},
  [13882] = {.lex_state = 0, .external_lex_state = 308},
  [13883] = {.lex_state = 47, .external_lex_state = 308},
  [13884] = {.lex_state = 50, .external_lex_state = 308},
  [13885] = {.lex_state = 50, .external_lex_state = 308},
  [13886] = {.lex_state = 0, .external_lex_state = 335},
  [13887] = {.lex_state = 0, .external_lex_state = 413},
  [13888] = {.lex_state = 47, .external_lex_state = 308},
  [13889] = {.lex_state = 0, .external_lex_state = 390},
  [13890] = {.lex_state = 0, .external_lex_state = 308},
  [13891] = {.lex_state = 0, .external_lex_state = 308},
  [13892] = {.lex_state = 0, .external_lex_state = 308},
  [13893] = {.lex_state = 50, .external_lex_state = 397},
  [13894] = {.lex_state = 0, .external_lex_state = 390},
  [13895] = {.lex_state = 0, .external_lex_state = 390},
  [13896] = {.lex_state = 0, .external_lex_state = 308},
  [13897] = {.lex_state = 0, .external_lex_state = 308},
  [13898] = {.lex_state = 0, .external_lex_state = 390},
  [13899] = {.lex_state = 0, .external_lex_state = 308},
  [13900] = {.lex_state = 0, .external_lex_state = 308},
  [13901] = {.lex_state = 47, .external_lex_state = 308},
  [13902] = {.lex_state = 47, .external_lex_state = 308},
  [13903] = {.lex_state = 0, .external_lex_state = 308},
  [13904] = {.lex_state = 0, .external_lex_state = 390},
  [13905] = {.lex_state = 47, .external_lex_state = 308},
  [13906] = {.lex_state = 0, .external_lex_state = 335},
  [13907] = {.lex_state = 47, .external_lex_state = 397},
  [13908] = {.lex_state = 47, .external_lex_state = 308},
  [13909] = {.lex_state = 47, .external_lex_state = 397},
  [13910] = {.lex_state = 0, .external_lex_state = 390},
  [13911] = {.lex_state = 47, .external_lex_state = 308},
  [13912] = {.lex_state = 0, .external_lex_state = 390},
  [13913] = {.lex_state = 0, .external_lex_state = 390},
  [13914] = {.lex_state = 47, .external_lex_state = 308},
  [13915] = {.lex_state = 51, .external_lex_state = 392},
  [13916] = {.lex_state = 0, .external_lex_state = 308},
  [13917] = {.lex_state = 47, .external_lex_state = 426},
  [13918] = {.lex_state = 47, .external_lex_state = 397},
  [13919] = {.lex_state = 47, .external_lex_state = 400},
  [13920] = {.lex_state = 0, .external_lex_state = 390},
  [13921] = {.lex_state = 0, .external_lex_state = 390},
  [13922] = {.lex_state = 47, .external_lex_state = 308},
  [13923] = {.lex_state = 47, .external_lex_state = 308},
  [13924] = {.lex_state = 47, .external_lex_state = 308},
  [13925] = {.lex_state = 47, .external_lex_state = 308},
  [13926] = {.lex_state = 0, .external_lex_state = 335},
  [13927] = {.lex_state = 47, .external_lex_state = 308},
  [13928] = {.lex_state = 0, .external_lex_state = 390},
  [13929] = {.lex_state = 0, .external_lex_state = 399},
  [13930] = {.lex_state = 50, .external_lex_state = 308},
  [13931] = {.lex_state = 50, .external_lex_state = 308},
  [13932] = {.lex_state = 0, .external_lex_state = 308},
  [13933] = {.lex_state = 50, .external_lex_state = 308},
  [13934] = {.lex_state = 47, .external_lex_state = 385},
  [13935] = {.lex_state = 47, .external_lex_state = 308},
  [13936] = {.lex_state = 47, .external_lex_state = 308},
  [13937] = {.lex_state = 51, .external_lex_state = 392},
  [13938] = {.lex_state = 0, .external_lex_state = 335},
  [13939] = {.lex_state = 47, .external_lex_state = 308},
  [13940] = {.lex_state = 47, .external_lex_state = 308},
  [13941] = {.lex_state = 50, .external_lex_state = 308},
  [13942] = {.lex_state = 47, .external_lex_state = 308},
  [13943] = {.lex_state = 47, .external_lex_state = 308},
  [13944] = {.lex_state = 50, .external_lex_state = 308},
  [13945] = {.lex_state = 47, .external_lex_state = 400},
  [13946] = {.lex_state = 47, .external_lex_state = 308},
  [13947] = {.lex_state = 47, .external_lex_state = 400},
  [13948] = {.lex_state = 47, .external_lex_state = 308},
  [13949] = {.lex_state = 50, .external_lex_state = 397},
  [13950] = {.lex_state = 51, .external_lex_state = 392},
  [13951] = {.lex_state = 47, .external_lex_state = 308},
  [13952] = {.lex_state = 47, .external_lex_state = 426},
  [13953] = {.lex_state = 47, .external_lex_state = 308},
  [13954] = {.lex_state = 47, .external_lex_state = 400},
  [13955] = {.lex_state = 47, .external_lex_state = 308},
  [13956] = {.lex_state = 0, .external_lex_state = 335},
  [13957] = {.lex_state = 47, .external_lex_state = 430},
  [13958] = {.lex_state = 0, .external_lex_state = 433},
  [13959] = {.lex_state = 47, .external_lex_state = 308},
  [13960] = {.lex_state = 47, .external_lex_state = 308},
  [13961] = {.lex_state = 0, .external_lex_state = 344},
  [13962] = {.lex_state = 51, .external_lex_state = 392},
  [13963] = {.lex_state = 47, .external_lex_state = 308},
  [13964] = {.lex_state = 0, .external_lex_state = 335},
  [13965] = {.lex_state = 0, .external_lex_state = 335},
  [13966] = {.lex_state = 47, .external_lex_state = 308},
  [13967] = {.lex_state = 47, .external_lex_state = 308},
  [13968] = {.lex_state = 0, .external_lex_state = 335},
  [13969] = {.lex_state = 51, .external_lex_state = 392},
  [13970] = {.lex_state = 0, .external_lex_state = 335},
  [13971] = {.lex_state = 0, .external_lex_state = 335},
  [13972] = {.lex_state = 47, .external_lex_state = 397},
  [13973] = {.lex_state = 47, .external_lex_state = 308},
  [13974] = {.lex_state = 0, .external_lex_state = 308},
  [13975] = {.lex_state = 47, .external_lex_state = 308},
  [13976] = {.lex_state = 51, .external_lex_state = 392},
  [13977] = {.lex_state = 47, .external_lex_state = 308},
  [13978] = {.lex_state = 0, .external_lex_state = 308},
  [13979] = {.lex_state = 47, .external_lex_state = 387},
  [13980] = {.lex_state = 47, .external_lex_state = 308},
  [13981] = {.lex_state = 0, .external_lex_state = 419},
  [13982] = {.lex_state = 47, .external_lex_state = 412},
  [13983] = {.lex_state = 0, .external_lex_state = 344},
  [13984] = {.lex_state = 47, .external_lex_state = 308},
  [13985] = {.lex_state = 47, .external_lex_state = 412},
  [13986] = {.lex_state = 47, .external_lex_state = 308},
  [13987] = {.lex_state = 47, .external_lex_state = 412},
  [13988] = {.lex_state = 47, .external_lex_state = 412},
  [13989] = {.lex_state = 51, .external_lex_state = 335},
  [13990] = {.lex_state = 47, .external_lex_state = 412},
  [13991] = {.lex_state = 47, .external_lex_state = 308},
  [13992] = {.lex_state = 47, .external_lex_state = 412},
  [13993] = {.lex_state = 47, .external_lex_state = 308},
  [13994] = {.lex_state = 50, .external_lex_state = 435},
  [13995] = {.lex_state = 47, .external_lex_state = 412},
  [13996] = {.lex_state = 47, .external_lex_state = 412},
  [13997] = {.lex_state = 47, .external_lex_state = 308},
  [13998] = {.lex_state = 47, .external_lex_state = 308},
  [13999] = {.lex_state = 47, .external_lex_state = 412},
  [14000] = {.lex_state = 47, .external_lex_state = 308},
  [14001] = {.lex_state = 47, .external_lex_state = 412},
  [14002] = {.lex_state = 47, .external_lex_state = 308},
  [14003] = {.lex_state = 47, .external_lex_state = 412},
  [14004] = {.lex_state = 47, .external_lex_state = 412},
  [14005] = {.lex_state = 47, .external_lex_state = 412},
  [14006] = {.lex_state = 47, .external_lex_state = 308},
  [14007] = {.lex_state = 47, .external_lex_state = 308},
  [14008] = {.lex_state = 0, .external_lex_state = 436},
  [14009] = {.lex_state = 47, .external_lex_state = 308},
  [14010] = {.lex_state = 47, .external_lex_state = 412},
  [14011] = {.lex_state = 47, .external_lex_state = 412},
  [14012] = {.lex_state = 47, .external_lex_state = 308},
  [14013] = {.lex_state = 47, .external_lex_state = 308},
  [14014] = {.lex_state = 0, .external_lex_state = 335},
  [14015] = {.lex_state = 47, .external_lex_state = 412},
  [14016] = {.lex_state = 47, .external_lex_state = 308},
  [14017] = {.lex_state = 47, .external_lex_state = 308},
  [14018] = {.lex_state = 47, .external_lex_state = 308},
  [14019] = {.lex_state = 47, .external_lex_state = 308},
  [14020] = {.lex_state = 0, .external_lex_state = 399},
  [14021] = {.lex_state = 47, .external_lex_state = 412},
  [14022] = {.lex_state = 0, .external_lex_state = 399},
  [14023] = {.lex_state = 47, .external_lex_state = 308},
  [14024] = {.lex_state = 47, .external_lex_state = 308},
  [14025] = {.lex_state = 47, .external_lex_state = 412},
  [14026] = {.lex_state = 47, .external_lex_state = 412},
  [14027] = {.lex_state = 0, .external_lex_state = 433},
  [14028] = {.lex_state = 47, .external_lex_state = 426},
  [14029] = {.lex_state = 47, .external_lex_state = 355},
  [14030] = {.lex_state = 47, .external_lex_state = 308},
  [14031] = {.lex_state = 47, .external_lex_state = 426},
  [14032] = {.lex_state = 47, .external_lex_state = 412},
  [14033] = {.lex_state = 47, .external_lex_state = 426},
  [14034] = {.lex_state = 47, .external_lex_state = 426},
  [14035] = {.lex_state = 47, .external_lex_state = 426},
  [14036] = {.lex_state = 47, .external_lex_state = 426},
  [14037] = {.lex_state = 47, .external_lex_state = 308},
  [14038] = {.lex_state = 47, .external_lex_state = 426},
  [14039] = {.lex_state = 47, .external_lex_state = 426},
  [14040] = {.lex_state = 47, .external_lex_state = 426},
  [14041] = {.lex_state = 47, .external_lex_state = 426},
  [14042] = {.lex_state = 47, .external_lex_state = 308},
  [14043] = {.lex_state = 47, .external_lex_state = 426},
  [14044] = {.lex_state = 47, .external_lex_state = 308},
  [14045] = {.lex_state = 47, .external_lex_state = 426},
  [14046] = {.lex_state = 47, .external_lex_state = 412},
  [14047] = {.lex_state = 47, .external_lex_state = 412},
  [14048] = {.lex_state = 47, .external_lex_state = 426},
  [14049] = {.lex_state = 47, .external_lex_state = 426},
  [14050] = {.lex_state = 47, .external_lex_state = 426},
  [14051] = {.lex_state = 0, .external_lex_state = 210},
  [14052] = {.lex_state = 47, .external_lex_state = 308},
  [14053] = {.lex_state = 47, .external_lex_state = 426},
  [14054] = {.lex_state = 47, .external_lex_state = 343},
  [14055] = {.lex_state = 47, .external_lex_state = 426},
  [14056] = {.lex_state = 47, .external_lex_state = 308},
  [14057] = {.lex_state = 47, .external_lex_state = 426},
  [14058] = {.lex_state = 47, .external_lex_state = 412},
  [14059] = {.lex_state = 47, .external_lex_state = 412},
  [14060] = {.lex_state = 47, .external_lex_state = 426},
  [14061] = {.lex_state = 47, .external_lex_state = 412},
  [14062] = {.lex_state = 47, .external_lex_state = 308},
  [14063] = {.lex_state = 47, .external_lex_state = 412},
  [14064] = {.lex_state = 47, .external_lex_state = 412},
  [14065] = {.lex_state = 47, .external_lex_state = 412},
  [14066] = {.lex_state = 47, .external_lex_state = 404},
  [14067] = {.lex_state = 47, .external_lex_state = 412},
  [14068] = {.lex_state = 47, .external_lex_state = 402},
  [14069] = {.lex_state = 47, .external_lex_state = 412},
  [14070] = {.lex_state = 0, .external_lex_state = 335},
  [14071] = {.lex_state = 47, .external_lex_state = 412},
  [14072] = {.lex_state = 47, .external_lex_state = 412},
  [14073] = {.lex_state = 47, .external_lex_state = 308},
  [14074] = {.lex_state = 47, .external_lex_state = 308},
  [14075] = {.lex_state = 47, .external_lex_state = 412},
  [14076] = {.lex_state = 0, .external_lex_state = 335},
  [14077] = {.lex_state = 47, .external_lex_state = 404},
  [14078] = {.lex_state = 47, .external_lex_state = 308},
  [14079] = {.lex_state = 0, .external_lex_state = 399},
  [14080] = {.lex_state = 47, .external_lex_state = 428},
  [14081] = {.lex_state = 47, .external_lex_state = 412},
  [14082] = {.lex_state = 47, .external_lex_state = 308},
  [14083] = {.lex_state = 0, .external_lex_state = 437},
  [14084] = {.lex_state = 47, .external_lex_state = 308},
  [14085] = {.lex_state = 47, .external_lex_state = 412},
  [14086] = {.lex_state = 0, .external_lex_state = 437},
  [14087] = {.lex_state = 0, .external_lex_state = 437},
  [14088] = {.lex_state = 47, .external_lex_state = 308},
  [14089] = {.lex_state = 47, .external_lex_state = 412},
  [14090] = {.lex_state = 47, .external_lex_state = 412},
  [14091] = {.lex_state = 47, .external_lex_state = 412},
  [14092] = {.lex_state = 47, .external_lex_state = 412},
  [14093] = {.lex_state = 47, .external_lex_state = 393},
  [14094] = {.lex_state = 47, .external_lex_state = 412},
  [14095] = {.lex_state = 0, .external_lex_state = 308},
  [14096] = {.lex_state = 47, .external_lex_state = 412},
  [14097] = {.lex_state = 47, .external_lex_state = 395},
  [14098] = {.lex_state = 47, .external_lex_state = 395},
  [14099] = {.lex_state = 47, .external_lex_state = 412},
  [14100] = {.lex_state = 0, .external_lex_state = 335},
  [14101] = {.lex_state = 47, .external_lex_state = 395},
  [14102] = {.lex_state = 47, .external_lex_state = 308},
  [14103] = {.lex_state = 47, .external_lex_state = 395},
  [14104] = {.lex_state = 50, .external_lex_state = 435},
  [14105] = {.lex_state = 47, .external_lex_state = 412},
  [14106] = {.lex_state = 47, .external_lex_state = 412},
  [14107] = {.lex_state = 47, .external_lex_state = 412},
  [14108] = {.lex_state = 47, .external_lex_state = 395},
  [14109] = {.lex_state = 47, .external_lex_state = 412},
  [14110] = {.lex_state = 47, .external_lex_state = 393},
  [14111] = {.lex_state = 0, .external_lex_state = 335},
  [14112] = {.lex_state = 51, .external_lex_state = 335},
  [14113] = {.lex_state = 0, .external_lex_state = 419},
  [14114] = {.lex_state = 47, .external_lex_state = 412},
  [14115] = {.lex_state = 47, .external_lex_state = 412},
  [14116] = {.lex_state = 47, .external_lex_state = 393},
  [14117] = {.lex_state = 47, .external_lex_state = 387},
  [14118] = {.lex_state = 47, .external_lex_state = 412},
  [14119] = {.lex_state = 47, .external_lex_state = 387},
  [14120] = {.lex_state = 47, .external_lex_state = 426},
  [14121] = {.lex_state = 0, .external_lex_state = 335},
  [14122] = {.lex_state = 47, .external_lex_state = 412},
  [14123] = {.lex_state = 47, .external_lex_state = 308},
  [14124] = {.lex_state = 50, .external_lex_state = 308},
  [14125] = {.lex_state = 47, .external_lex_state = 412},
  [14126] = {.lex_state = 47, .external_lex_state = 412},
  [14127] = {.lex_state = 47, .external_lex_state = 412},
  [14128] = {.lex_state = 47, .external_lex_state = 412},
  [14129] = {.lex_state = 47, .external_lex_state = 393},
  [14130] = {.lex_state = 0, .external_lex_state = 344},
  [14131] = {.lex_state = 47, .external_lex_state = 308},
  [14132] = {.lex_state = 47, .external_lex_state = 393},
  [14133] = {.lex_state = 47, .external_lex_state = 393},
  [14134] = {.lex_state = 47, .external_lex_state = 404},
  [14135] = {.lex_state = 47, .external_lex_state = 404},
  [14136] = {.lex_state = 47, .external_lex_state = 308},
  [14137] = {.lex_state = 47, .external_lex_state = 426},
  [14138] = {.lex_state = 47, .external_lex_state = 387},
  [14139] = {.lex_state = 47, .external_lex_state = 426},
  [14140] = {.lex_state = 47, .external_lex_state = 412},
  [14141] = {.lex_state = 47, .external_lex_state = 412},
  [14142] = {.lex_state = 47, .external_lex_state = 426},
  [14143] = {.lex_state = 47, .external_lex_state = 412},
  [14144] = {.lex_state = 47, .external_lex_state = 308},
  [14145] = {.lex_state = 47, .external_lex_state = 426},
  [14146] = {.lex_state = 47, .external_lex_state = 412},
  [14147] = {.lex_state = 47, .external_lex_state = 426},
  [14148] = {.lex_state = 47, .external_lex_state = 308},
  [14149] = {.lex_state = 0, .external_lex_state = 438},
  [14150] = {.lex_state = 47, .external_lex_state = 308},
  [14151] = {.lex_state = 47, .external_lex_state = 400},
  [14152] = {.lex_state = 47, .external_lex_state = 308},
  [14153] = {.lex_state = 47, .external_lex_state = 412},
  [14154] = {.lex_state = 47, .external_lex_state = 426},
  [14155] = {.lex_state = 47, .external_lex_state = 308},
  [14156] = {.lex_state = 47, .external_lex_state = 395},
  [14157] = {.lex_state = 0, .external_lex_state = 438},
  [14158] = {.lex_state = 0, .external_lex_state = 438},
  [14159] = {.lex_state = 47, .external_lex_state = 308},
  [14160] = {.lex_state = 47, .external_lex_state = 308},
  [14161] = {.lex_state = 47, .external_lex_state = 412},
  [14162] = {.lex_state = 47, .external_lex_state = 308},
  [14163] = {.lex_state = 47, .external_lex_state = 422},
  [14164] = {.lex_state = 47, .external_lex_state = 308},
  [14165] = {.lex_state = 47, .external_lex_state = 412},
  [14166] = {.lex_state = 47, .external_lex_state = 412},
  [14167] = {.lex_state = 47, .external_lex_state = 308},
  [14168] = {.lex_state = 47, .external_lex_state = 412},
  [14169] = {.lex_state = 47, .external_lex_state = 426},
  [14170] = {.lex_state = 47, .external_lex_state = 426},
  [14171] = {.lex_state = 47, .external_lex_state = 426},
  [14172] = {.lex_state = 0, .external_lex_state = 424},
  [14173] = {.lex_state = 47, .external_lex_state = 412},
  [14174] = {.lex_state = 47, .external_lex_state = 428},
  [14175] = {.lex_state = 47, .external_lex_state = 428},
  [14176] = {.lex_state = 0, .external_lex_state = 436},
  [14177] = {.lex_state = 47, .external_lex_state = 308},
  [14178] = {.lex_state = 47, .external_lex_state = 426},
  [14179] = {.lex_state = 47, .external_lex_state = 308},
  [14180] = {.lex_state = 47, .external_lex_state = 426},
  [14181] = {.lex_state = 47, .external_lex_state = 412},
  [14182] = {.lex_state = 47, .external_lex_state = 428},
  [14183] = {.lex_state = 0, .external_lex_state = 438},
  [14184] = {.lex_state = 47, .external_lex_state = 426},
  [14185] = {.lex_state = 47, .external_lex_state = 388},
  [14186] = {.lex_state = 0, .external_lex_state = 438},
  [14187] = {.lex_state = 47, .external_lex_state = 388},
  [14188] = {.lex_state = 0, .external_lex_state = 438},
  [14189] = {.lex_state = 47, .external_lex_state = 388},
  [14190] = {.lex_state = 47, .external_lex_state = 434},
  [14191] = {.lex_state = 47, .external_lex_state = 388},
  [14192] = {.lex_state = 47, .external_lex_state = 388},
  [14193] = {.lex_state = 47, .external_lex_state = 308},
  [14194] = {.lex_state = 0, .external_lex_state = 437},
  [14195] = {.lex_state = 47, .external_lex_state = 412},
  [14196] = {.lex_state = 47, .external_lex_state = 428},
  [14197] = {.lex_state = 47, .external_lex_state = 412},
  [14198] = {.lex_state = 47, .external_lex_state = 308},
  [14199] = {.lex_state = 0, .external_lex_state = 437},
  [14200] = {.lex_state = 47, .external_lex_state = 412},
  [14201] = {.lex_state = 47, .external_lex_state = 412},
  [14202] = {.lex_state = 47, .external_lex_state = 412},
  [14203] = {.lex_state = 47, .external_lex_state = 308},
  [14204] = {.lex_state = 47, .external_lex_state = 412},
  [14205] = {.lex_state = 47, .external_lex_state = 412},
  [14206] = {.lex_state = 0, .external_lex_state = 335},
  [14207] = {.lex_state = 47, .external_lex_state = 412},
  [14208] = {.lex_state = 47, .external_lex_state = 412},
  [14209] = {.lex_state = 0, .external_lex_state = 335},
  [14210] = {.lex_state = 47, .external_lex_state = 393},
  [14211] = {.lex_state = 0, .external_lex_state = 249},
  [14212] = {.lex_state = 47, .external_lex_state = 412},
  [14213] = {.lex_state = 47, .external_lex_state = 412},
  [14214] = {.lex_state = 0, .external_lex_state = 345},
  [14215] = {.lex_state = 0, .external_lex_state = 335},
  [14216] = {.lex_state = 47, .external_lex_state = 428},
  [14217] = {.lex_state = 47, .external_lex_state = 412},
  [14218] = {.lex_state = 47, .external_lex_state = 403},
  [14219] = {.lex_state = 47, .external_lex_state = 308},
  [14220] = {.lex_state = 0, .external_lex_state = 433},
  [14221] = {.lex_state = 47, .external_lex_state = 308},
  [14222] = {.lex_state = 0, .external_lex_state = 335},
  [14223] = {.lex_state = 47, .external_lex_state = 308},
  [14224] = {.lex_state = 0, .external_lex_state = 308},
  [14225] = {.lex_state = 47, .external_lex_state = 308},
  [14226] = {.lex_state = 47, .external_lex_state = 412},
  [14227] = {.lex_state = 47, .external_lex_state = 412},
  [14228] = {.lex_state = 47, .external_lex_state = 308},
  [14229] = {.lex_state = 47, .external_lex_state = 308},
  [14230] = {.lex_state = 0, .external_lex_state = 249},
  [14231] = {.lex_state = 47, .external_lex_state = 426},
  [14232] = {.lex_state = 47, .external_lex_state = 308},
  [14233] = {.lex_state = 47, .external_lex_state = 308},
  [14234] = {.lex_state = 47, .external_lex_state = 412},
  [14235] = {.lex_state = 47, .external_lex_state = 308},
  [14236] = {.lex_state = 47, .external_lex_state = 308},
  [14237] = {.lex_state = 47, .external_lex_state = 412},
  [14238] = {.lex_state = 47, .external_lex_state = 308},
  [14239] = {.lex_state = 0, .external_lex_state = 335},
  [14240] = {.lex_state = 47, .external_lex_state = 412},
  [14241] = {.lex_state = 47, .external_lex_state = 308},
  [14242] = {.lex_state = 47, .external_lex_state = 308},
  [14243] = {.lex_state = 47, .external_lex_state = 412},
  [14244] = {.lex_state = 0, .external_lex_state = 249},
  [14245] = {.lex_state = 47, .external_lex_state = 412},
  [14246] = {.lex_state = 47, .external_lex_state = 426},
  [14247] = {.lex_state = 47, .external_lex_state = 412},
  [14248] = {.lex_state = 47, .external_lex_state = 308},
  [14249] = {.lex_state = 47, .external_lex_state = 412},
  [14250] = {.lex_state = 47, .external_lex_state = 308},
  [14251] = {.lex_state = 47, .external_lex_state = 308},
  [14252] = {.lex_state = 47, .external_lex_state = 308},
  [14253] = {.lex_state = 47, .external_lex_state = 308},
  [14254] = {.lex_state = 47, .external_lex_state = 426},
  [14255] = {.lex_state = 47, .external_lex_state = 412},
  [14256] = {.lex_state = 47, .external_lex_state = 412},
  [14257] = {.lex_state = 51, .external_lex_state = 335},
  [14258] = {.lex_state = 47, .external_lex_state = 439},
  [14259] = {.lex_state = 51, .external_lex_state = 335},
  [14260] = {.lex_state = 0, .external_lex_state = 418},
  [14261] = {.lex_state = 47, .external_lex_state = 308},
  [14262] = {.lex_state = 47, .external_lex_state = 308},
  [14263] = {.lex_state = 47, .external_lex_state = 395},
  [14264] = {.lex_state = 50, .external_lex_state = 308},
  [14265] = {.lex_state = 47, .external_lex_state = 412},
  [14266] = {.lex_state = 47, .external_lex_state = 393},
  [14267] = {.lex_state = 50, .external_lex_state = 308},
  [14268] = {.lex_state = 47, .external_lex_state = 412},
  [14269] = {.lex_state = 47, .external_lex_state = 412},
  [14270] = {.lex_state = 47, .external_lex_state = 428},
  [14271] = {.lex_state = 47, .external_lex_state = 434},
  [14272] = {.lex_state = 47, .external_lex_state = 412},
  [14273] = {.lex_state = 47, .external_lex_state = 428},
  [14274] = {.lex_state = 47, .external_lex_state = 308},
  [14275] = {.lex_state = 47, .external_lex_state = 308},
  [14276] = {.lex_state = 47, .external_lex_state = 426},
  [14277] = {.lex_state = 47, .external_lex_state = 393},
  [14278] = {.lex_state = 47, .external_lex_state = 428},
  [14279] = {.lex_state = 0, .external_lex_state = 433},
  [14280] = {.lex_state = 47, .external_lex_state = 426},
  [14281] = {.lex_state = 47, .external_lex_state = 412},
  [14282] = {.lex_state = 47, .external_lex_state = 428},
  [14283] = {.lex_state = 0, .external_lex_state = 399},
  [14284] = {.lex_state = 0, .external_lex_state = 308},
  [14285] = {.lex_state = 47, .external_lex_state = 428},
  [14286] = {.lex_state = 0, .external_lex_state = 345},
  [14287] = {.lex_state = 0, .external_lex_state = 438},
  [14288] = {.lex_state = 0, .external_lex_state = 438},
  [14289] = {.lex_state = 47, .external_lex_state = 400},
  [14290] = {.lex_state = 47, .external_lex_state = 400},
  [14291] = {.lex_state = 47, .external_lex_state = 412},
  [14292] = {.lex_state = 47, .external_lex_state = 412},
  [14293] = {.lex_state = 47, .external_lex_state = 412},
  [14294] = {.lex_state = 50, .external_lex_state = 308},
  [14295] = {.lex_state = 47, .external_lex_state = 412},
  [14296] = {.lex_state = 0, .external_lex_state = 399},
  [14297] = {.lex_state = 47, .external_lex_state = 412},
  [14298] = {.lex_state = 47, .external_lex_state = 428},
  [14299] = {.lex_state = 47, .external_lex_state = 403},
  [14300] = {.lex_state = 47, .external_lex_state = 412},
  [14301] = {.lex_state = 0, .external_lex_state = 436},
  [14302] = {.lex_state = 0, .external_lex_state = 249},
  [14303] = {.lex_state = 47, .external_lex_state = 412},
  [14304] = {.lex_state = 47, .external_lex_state = 308},
  [14305] = {.lex_state = 47, .external_lex_state = 308},
  [14306] = {.lex_state = 47, .external_lex_state = 308},
  [14307] = {.lex_state = 47, .external_lex_state = 428},
  [14308] = {.lex_state = 47, .external_lex_state = 412},
  [14309] = {.lex_state = 47, .external_lex_state = 403},
  [14310] = {.lex_state = 47, .external_lex_state = 412},
  [14311] = {.lex_state = 47, .external_lex_state = 428},
  [14312] = {.lex_state = 47, .external_lex_state = 412},
  [14313] = {.lex_state = 47, .external_lex_state = 412},
  [14314] = {.lex_state = 47, .external_lex_state = 434},
  [14315] = {.lex_state = 47, .external_lex_state = 412},
  [14316] = {.lex_state = 47, .external_lex_state = 428},
  [14317] = {.lex_state = 50, .external_lex_state = 435},
  [14318] = {.lex_state = 47, .external_lex_state = 428},
  [14319] = {.lex_state = 47, .external_lex_state = 428},
  [14320] = {.lex_state = 47, .external_lex_state = 428},
  [14321] = {.lex_state = 0, .external_lex_state = 249},
  [14322] = {.lex_state = 0, .external_lex_state = 249},
  [14323] = {.lex_state = 0, .external_lex_state = 335},
  [14324] = {.lex_state = 47, .external_lex_state = 428},
  [14325] = {.lex_state = 47, .external_lex_state = 308},
  [14326] = {.lex_state = 47, .external_lex_state = 428},
  [14327] = {.lex_state = 47, .external_lex_state = 428},
  [14328] = {.lex_state = 0, .external_lex_state = 438},
  [14329] = {.lex_state = 47, .external_lex_state = 434},
  [14330] = {.lex_state = 47, .external_lex_state = 428},
  [14331] = {.lex_state = 47, .external_lex_state = 428},
  [14332] = {.lex_state = 0, .external_lex_state = 424},
  [14333] = {.lex_state = 0, .external_lex_state = 335},
  [14334] = {.lex_state = 47, .external_lex_state = 308},
  [14335] = {.lex_state = 47, .external_lex_state = 412},
  [14336] = {.lex_state = 0, .external_lex_state = 308},
  [14337] = {.lex_state = 47, .external_lex_state = 412},
  [14338] = {.lex_state = 47, .external_lex_state = 428},
  [14339] = {.lex_state = 0, .external_lex_state = 399},
  [14340] = {.lex_state = 47, .external_lex_state = 439},
  [14341] = {.lex_state = 47, .external_lex_state = 439},
  [14342] = {.lex_state = 47, .external_lex_state = 440},
  [14343] = {.lex_state = 47, .external_lex_state = 412},
  [14344] = {.lex_state = 0, .external_lex_state = 308},
  [14345] = {.lex_state = 47, .external_lex_state = 412},
  [14346] = {.lex_state = 47, .external_lex_state = 412},
  [14347] = {.lex_state = 0, .external_lex_state = 308},
  [14348] = {.lex_state = 47, .external_lex_state = 412},
  [14349] = {.lex_state = 47, .external_lex_state = 412},
  [14350] = {.lex_state = 47, .external_lex_state = 440},
  [14351] = {.lex_state = 47, .external_lex_state = 308},
  [14352] = {.lex_state = 47, .external_lex_state = 308},
  [14353] = {.lex_state = 47, .external_lex_state = 428},
  [14354] = {.lex_state = 50, .external_lex_state = 308},
  [14355] = {.lex_state = 47, .external_lex_state = 412},
  [14356] = {.lex_state = 47, .external_lex_state = 412},
  [14357] = {.lex_state = 47, .external_lex_state = 412},
  [14358] = {.lex_state = 50, .external_lex_state = 308},
  [14359] = {.lex_state = 47, .external_lex_state = 412},
  [14360] = {.lex_state = 50, .external_lex_state = 308},
  [14361] = {.lex_state = 0, .external_lex_state = 344},
  [14362] = {.lex_state = 47, .external_lex_state = 308},
  [14363] = {.lex_state = 0, .external_lex_state = 345},
  [14364] = {.lex_state = 47, .external_lex_state = 412},
  [14365] = {.lex_state = 47, .external_lex_state = 400},
  [14366] = {.lex_state = 47, .external_lex_state = 400},
  [14367] = {.lex_state = 47, .external_lex_state = 308},
  [14368] = {.lex_state = 0, .external_lex_state = 308},
  [14369] = {.lex_state = 47, .external_lex_state = 412},
  [14370] = {.lex_state = 47, .external_lex_state = 412},
  [14371] = {.lex_state = 47, .external_lex_state = 412},
  [14372] = {.lex_state = 47, .external_lex_state = 400},
  [14373] = {.lex_state = 47, .external_lex_state = 440},
  [14374] = {.lex_state = 47, .external_lex_state = 412},
  [14375] = {.lex_state = 47, .external_lex_state = 412},
  [14376] = {.lex_state = 47, .external_lex_state = 426},
  [14377] = {.lex_state = 47, .external_lex_state = 426},
  [14378] = {.lex_state = 47, .external_lex_state = 412},
  [14379] = {.lex_state = 0, .external_lex_state = 249},
  [14380] = {.lex_state = 47, .external_lex_state = 412},
  [14381] = {.lex_state = 47, .external_lex_state = 308},
  [14382] = {.lex_state = 47, .external_lex_state = 426},
  [14383] = {.lex_state = 47, .external_lex_state = 426},
  [14384] = {.lex_state = 47, .external_lex_state = 412},
  [14385] = {.lex_state = 47, .external_lex_state = 412},
  [14386] = {.lex_state = 47, .external_lex_state = 412},
  [14387] = {.lex_state = 47, .external_lex_state = 412},
  [14388] = {.lex_state = 0, .external_lex_state = 335},
  [14389] = {.lex_state = 47, .external_lex_state = 412},
  [14390] = {.lex_state = 47, .external_lex_state = 426},
  [14391] = {.lex_state = 47, .external_lex_state = 412},
  [14392] = {.lex_state = 0, .external_lex_state = 432},
  [14393] = {.lex_state = 47, .external_lex_state = 308},
  [14394] = {.lex_state = 47, .external_lex_state = 412},
  [14395] = {.lex_state = 47, .external_lex_state = 412},
  [14396] = {.lex_state = 0, .external_lex_state = 432},
  [14397] = {.lex_state = 47, .external_lex_state = 412},
  [14398] = {.lex_state = 47, .external_lex_state = 308},
  [14399] = {.lex_state = 47, .external_lex_state = 393},
  [14400] = {.lex_state = 47, .external_lex_state = 403},
  [14401] = {.lex_state = 0, .external_lex_state = 335},
  [14402] = {.lex_state = 47, .external_lex_state = 388},
  [14403] = {.lex_state = 47, .external_lex_state = 426},
  [14404] = {.lex_state = 0, .external_lex_state = 249},
  [14405] = {.lex_state = 0, .external_lex_state = 249},
  [14406] = {.lex_state = 0, .external_lex_state = 249},
  [14407] = {.lex_state = 0, .external_lex_state = 424},
  [14408] = {.lex_state = 0, .external_lex_state = 335},
  [14409] = {.lex_state = 47, .external_lex_state = 412},
  [14410] = {.lex_state = 47, .external_lex_state = 426},
  [14411] = {.lex_state = 47, .external_lex_state = 412},
  [14412] = {.lex_state = 47, .external_lex_state = 308},
  [14413] = {.lex_state = 0, .external_lex_state = 335},
  [14414] = {.lex_state = 47, .external_lex_state = 388},
  [14415] = {.lex_state = 47, .external_lex_state = 439},
  [14416] = {.lex_state = 0, .external_lex_state = 249},
  [14417] = {.lex_state = 0, .external_lex_state = 249},
  [14418] = {.lex_state = 0, .external_lex_state = 249},
  [14419] = {.lex_state = 47, .external_lex_state = 412},
  [14420] = {.lex_state = 47, .external_lex_state = 439},
  [14421] = {.lex_state = 0, .external_lex_state = 249},
  [14422] = {.lex_state = 0, .external_lex_state = 308},
  [14423] = {.lex_state = 0, .external_lex_state = 335},
  [14424] = {.lex_state = 47, .external_lex_state = 439},
  [14425] = {.lex_state = 47, .external_lex_state = 412},
  [14426] = {.lex_state = 47, .external_lex_state = 412},
  [14427] = {.lex_state = 0, .external_lex_state = 344},
  [14428] = {.lex_state = 0, .external_lex_state = 249},
  [14429] = {.lex_state = 47, .external_lex_state = 412},
  [14430] = {.lex_state = 0, .external_lex_state = 335},
  [14431] = {.lex_state = 0, .external_lex_state = 355},
  [14432] = {.lex_state = 47, .external_lex_state = 434},
  [14433] = {.lex_state = 0, .external_lex_state = 249},
  [14434] = {.lex_state = 50, .external_lex_state = 308},
  [14435] = {.lex_state = 0, .external_lex_state = 335},
  [14436] = {.lex_state = 47, .external_lex_state = 412},
  [14437] = {.lex_state = 0, .external_lex_state = 308},
  [14438] = {.lex_state = 0, .external_lex_state = 249},
  [14439] = {.lex_state = 47, .external_lex_state = 428},
  [14440] = {.lex_state = 0, .external_lex_state = 249},
  [14441] = {.lex_state = 0, .external_lex_state = 308},
  [14442] = {.lex_state = 47, .external_lex_state = 400},
  [14443] = {.lex_state = 47, .external_lex_state = 412},
  [14444] = {.lex_state = 47, .external_lex_state = 308},
  [14445] = {.lex_state = 47, .external_lex_state = 412},
  [14446] = {.lex_state = 47, .external_lex_state = 434},
  [14447] = {.lex_state = 47, .external_lex_state = 412},
  [14448] = {.lex_state = 47, .external_lex_state = 308},
  [14449] = {.lex_state = 47, .external_lex_state = 308},
  [14450] = {.lex_state = 0, .external_lex_state = 399},
  [14451] = {.lex_state = 47, .external_lex_state = 412},
  [14452] = {.lex_state = 47, .external_lex_state = 412},
  [14453] = {.lex_state = 0, .external_lex_state = 399},
  [14454] = {.lex_state = 47, .external_lex_state = 308},
  [14455] = {.lex_state = 0, .external_lex_state = 335},
  [14456] = {.lex_state = 47, .external_lex_state = 412},
  [14457] = {.lex_state = 0, .external_lex_state = 433},
  [14458] = {.lex_state = 0, .external_lex_state = 345},
  [14459] = {.lex_state = 47, .external_lex_state = 412},
  [14460] = {.lex_state = 47, .external_lex_state = 412},
  [14461] = {.lex_state = 47, .external_lex_state = 428},
  [14462] = {.lex_state = 0, .external_lex_state = 397},
  [14463] = {.lex_state = 47, .external_lex_state = 412},
  [14464] = {.lex_state = 47, .external_lex_state = 412},
  [14465] = {.lex_state = 47, .external_lex_state = 393},
  [14466] = {.lex_state = 0, .external_lex_state = 335},
  [14467] = {.lex_state = 0, .external_lex_state = 308},
  [14468] = {.lex_state = 47, .external_lex_state = 403},
  [14469] = {.lex_state = 47, .external_lex_state = 412},
  [14470] = {.lex_state = 47, .external_lex_state = 412},
  [14471] = {.lex_state = 47, .external_lex_state = 308},
  [14472] = {.lex_state = 47, .external_lex_state = 412},
  [14473] = {.lex_state = 47, .external_lex_state = 426},
  [14474] = {.lex_state = 47, .external_lex_state = 412},
  [14475] = {.lex_state = 47, .external_lex_state = 412},
  [14476] = {.lex_state = 47, .external_lex_state = 412},
  [14477] = {.lex_state = 47, .external_lex_state = 424},
  [14478] = {.lex_state = 47, .external_lex_state = 412},
  [14479] = {.lex_state = 47, .external_lex_state = 439},
  [14480] = {.lex_state = 0, .external_lex_state = 335},
  [14481] = {.lex_state = 47, .external_lex_state = 412},
  [14482] = {.lex_state = 47, .external_lex_state = 412},
  [14483] = {.lex_state = 47, .external_lex_state = 428},
  [14484] = {.lex_state = 47, .external_lex_state = 308},
  [14485] = {.lex_state = 47, .external_lex_state = 412},
  [14486] = {.lex_state = 47, .external_lex_state = 403},
  [14487] = {.lex_state = 0, .external_lex_state = 308},
  [14488] = {.lex_state = 47, .external_lex_state = 434},
  [14489] = {.lex_state = 47, .external_lex_state = 412},
  [14490] = {.lex_state = 47, .external_lex_state = 412},
  [14491] = {.lex_state = 47, .external_lex_state = 428},
  [14492] = {.lex_state = 47, .external_lex_state = 412},
  [14493] = {.lex_state = 0, .external_lex_state = 433},
  [14494] = {.lex_state = 0, .external_lex_state = 432},
  [14495] = {.lex_state = 47, .external_lex_state = 412},
  [14496] = {.lex_state = 47, .external_lex_state = 308},
  [14497] = {.lex_state = 47, .external_lex_state = 412},
  [14498] = {.lex_state = 47, .external_lex_state = 412},
  [14499] = {.lex_state = 47, .external_lex_state = 308},
  [14500] = {.lex_state = 0, .external_lex_state = 437},
  [14501] = {.lex_state = 47, .external_lex_state = 426},
  [14502] = {.lex_state = 0, .external_lex_state = 433},
  [14503] = {.lex_state = 47, .external_lex_state = 412},
  [14504] = {.lex_state = 47, .external_lex_state = 412},
  [14505] = {.lex_state = 47, .external_lex_state = 412},
  [14506] = {.lex_state = 47, .external_lex_state = 412},
  [14507] = {.lex_state = 47, .external_lex_state = 387},
  [14508] = {.lex_state = 47, .external_lex_state = 412},
  [14509] = {.lex_state = 0, .external_lex_state = 308},
  [14510] = {.lex_state = 47, .external_lex_state = 412},
  [14511] = {.lex_state = 47, .external_lex_state = 412},
  [14512] = {.lex_state = 0, .external_lex_state = 335},
  [14513] = {.lex_state = 47, .external_lex_state = 412},
  [14514] = {.lex_state = 0, .external_lex_state = 308},
  [14515] = {.lex_state = 47, .external_lex_state = 308},
  [14516] = {.lex_state = 50, .external_lex_state = 435},
  [14517] = {.lex_state = 47, .external_lex_state = 412},
  [14518] = {.lex_state = 47, .external_lex_state = 428},
  [14519] = {.lex_state = 0, .external_lex_state = 397},
  [14520] = {.lex_state = 47, .external_lex_state = 403},
  [14521] = {.lex_state = 0, .external_lex_state = 308},
  [14522] = {.lex_state = 47, .external_lex_state = 412},
  [14523] = {.lex_state = 47, .external_lex_state = 308},
  [14524] = {.lex_state = 47, .external_lex_state = 387},
  [14525] = {.lex_state = 47, .external_lex_state = 428},
  [14526] = {.lex_state = 47, .external_lex_state = 439},
  [14527] = {.lex_state = 47, .external_lex_state = 428},
  [14528] = {.lex_state = 47, .external_lex_state = 428},
  [14529] = {.lex_state = 47, .external_lex_state = 428},
  [14530] = {.lex_state = 47, .external_lex_state = 412},
  [14531] = {.lex_state = 47, .external_lex_state = 428},
  [14532] = {.lex_state = 47, .external_lex_state = 412},
  [14533] = {.lex_state = 47, .external_lex_state = 428},
  [14534] = {.lex_state = 47, .external_lex_state = 428},
  [14535] = {.lex_state = 51, .external_lex_state = 335},
  [14536] = {.lex_state = 0, .external_lex_state = 344},
  [14537] = {.lex_state = 0, .external_lex_state = 432},
  [14538] = {.lex_state = 47, .external_lex_state = 412},
  [14539] = {.lex_state = 47, .external_lex_state = 428},
  [14540] = {.lex_state = 0, .external_lex_state = 345},
  [14541] = {.lex_state = 0, .external_lex_state = 397},
  [14542] = {.lex_state = 47, .external_lex_state = 428},
  [14543] = {.lex_state = 47, .external_lex_state = 412},
  [14544] = {.lex_state = 0, .external_lex_state = 397},
  [14545] = {.lex_state = 47, .external_lex_state = 428},
  [14546] = {.lex_state = 47, .external_lex_state = 439},
  [14547] = {.lex_state = 0, .external_lex_state = 397},
  [14548] = {.lex_state = 0, .external_lex_state = 437},
  [14549] = {.lex_state = 47, .external_lex_state = 428},
  [14550] = {.lex_state = 47, .external_lex_state = 308},
  [14551] = {.lex_state = 47, .external_lex_state = 428},
  [14552] = {.lex_state = 47, .external_lex_state = 428},
  [14553] = {.lex_state = 0, .external_lex_state = 432},
  [14554] = {.lex_state = 47, .external_lex_state = 412},
  [14555] = {.lex_state = 47, .external_lex_state = 412},
  [14556] = {.lex_state = 0, .external_lex_state = 355},
  [14557] = {.lex_state = 0, .external_lex_state = 308},
  [14558] = {.lex_state = 0, .external_lex_state = 249},
  [14559] = {.lex_state = 51, .external_lex_state = 335},
  [14560] = {.lex_state = 47, .external_lex_state = 412},
  [14561] = {.lex_state = 47, .external_lex_state = 412},
  [14562] = {.lex_state = 0, .external_lex_state = 437},
  [14563] = {.lex_state = 47, .external_lex_state = 412},
  [14564] = {.lex_state = 47, .external_lex_state = 412},
  [14565] = {.lex_state = 47, .external_lex_state = 308},
  [14566] = {.lex_state = 47, .external_lex_state = 308},
  [14567] = {.lex_state = 47, .external_lex_state = 412},
  [14568] = {.lex_state = 47, .external_lex_state = 355},
  [14569] = {.lex_state = 47, .external_lex_state = 308},
  [14570] = {.lex_state = 47, .external_lex_state = 355},
  [14571] = {.lex_state = 50, .external_lex_state = 308},
  [14572] = {.lex_state = 0, .external_lex_state = 437},
  [14573] = {.lex_state = 47, .external_lex_state = 428},
  [14574] = {.lex_state = 47, .external_lex_state = 412},
  [14575] = {.lex_state = 0, .external_lex_state = 308},
  [14576] = {.lex_state = 0, .external_lex_state = 397},
  [14577] = {.lex_state = 47, .external_lex_state = 355},
  [14578] = {.lex_state = 47, .external_lex_state = 428},
  [14579] = {.lex_state = 47, .external_lex_state = 440},
  [14580] = {.lex_state = 47, .external_lex_state = 440},
  [14581] = {.lex_state = 47, .external_lex_state = 387},
  [14582] = {.lex_state = 47, .external_lex_state = 355},
  [14583] = {.lex_state = 47, .external_lex_state = 428},
  [14584] = {.lex_state = 47, .external_lex_state = 387},
  [14585] = {.lex_state = 47, .external_lex_state = 412},
  [14586] = {.lex_state = 0, .external_lex_state = 188},
  [14587] = {.lex_state = 0, .external_lex_state = 355},
  [14588] = {.lex_state = 0, .external_lex_state = 335},
  [14589] = {.lex_state = 47, .external_lex_state = 440},
  [14590] = {.lex_state = 47, .external_lex_state = 412},
  [14591] = {.lex_state = 47, .external_lex_state = 387},
  [14592] = {.lex_state = 47, .external_lex_state = 387},
  [14593] = {.lex_state = 47, .external_lex_state = 412},
  [14594] = {.lex_state = 47, .external_lex_state = 412},
  [14595] = {.lex_state = 47, .external_lex_state = 412},
  [14596] = {.lex_state = 47, .external_lex_state = 308},
  [14597] = {.lex_state = 47, .external_lex_state = 412},
  [14598] = {.lex_state = 0, .external_lex_state = 308},
  [14599] = {.lex_state = 0, .external_lex_state = 432},
  [14600] = {.lex_state = 0, .external_lex_state = 335},
  [14601] = {.lex_state = 47, .external_lex_state = 412},
  [14602] = {.lex_state = 0, .external_lex_state = 308},
  [14603] = {.lex_state = 47, .external_lex_state = 308},
  [14604] = {.lex_state = 47, .external_lex_state = 412},
  [14605] = {.lex_state = 47, .external_lex_state = 387},
  [14606] = {.lex_state = 0, .external_lex_state = 399},
  [14607] = {.lex_state = 0, .external_lex_state = 308},
  [14608] = {.lex_state = 0, .external_lex_state = 399},
  [14609] = {.lex_state = 0, .external_lex_state = 308},
  [14610] = {.lex_state = 0, .external_lex_state = 308},
  [14611] = {.lex_state = 0, .external_lex_state = 308},
  [14612] = {.lex_state = 0, .external_lex_state = 345},
  [14613] = {.lex_state = 0, .external_lex_state = 399},
  [14614] = {.lex_state = 0, .external_lex_state = 399},
  [14615] = {.lex_state = 0, .external_lex_state = 399},
  [14616] = {.lex_state = 50, .external_lex_state = 335},
  [14617] = {.lex_state = 0, .external_lex_state = 399},
  [14618] = {.lex_state = 0, .external_lex_state = 308},
  [14619] = {.lex_state = 0, .external_lex_state = 308},
  [14620] = {.lex_state = 0, .external_lex_state = 308},
  [14621] = {.lex_state = 0, .external_lex_state = 308},
  [14622] = {.lex_state = 47, .external_lex_state = 403},
  [14623] = {.lex_state = 51, .external_lex_state = 396},
  [14624] = {.lex_state = 0, .external_lex_state = 399},
  [14625] = {.lex_state = 47, .external_lex_state = 400},
  [14626] = {.lex_state = 51, .external_lex_state = 396},
  [14627] = {.lex_state = 51, .external_lex_state = 396},
  [14628] = {.lex_state = 0, .external_lex_state = 413},
  [14629] = {.lex_state = 0, .external_lex_state = 308},
  [14630] = {.lex_state = 0, .external_lex_state = 308},
  [14631] = {.lex_state = 0, .external_lex_state = 308},
  [14632] = {.lex_state = 47, .external_lex_state = 400},
  [14633] = {.lex_state = 0, .external_lex_state = 308},
  [14634] = {.lex_state = 47, .external_lex_state = 400},
  [14635] = {.lex_state = 50, .external_lex_state = 308},
  [14636] = {.lex_state = 0, .external_lex_state = 308},
  [14637] = {.lex_state = 0, .external_lex_state = 308},
  [14638] = {.lex_state = 0, .external_lex_state = 413},
  [14639] = {.lex_state = 51, .external_lex_state = 396},
  [14640] = {.lex_state = 0, .external_lex_state = 335},
  [14641] = {.lex_state = 0, .external_lex_state = 413},
  [14642] = {.lex_state = 0, .external_lex_state = 437},
  [14643] = {.lex_state = 47, .external_lex_state = 308},
  [14644] = {.lex_state = 0, .external_lex_state = 344},
  [14645] = {.lex_state = 0, .external_lex_state = 308},
  [14646] = {.lex_state = 51, .external_lex_state = 396},
  [14647] = {.lex_state = 0, .external_lex_state = 399},
  [14648] = {.lex_state = 47, .external_lex_state = 400},
  [14649] = {.lex_state = 0, .external_lex_state = 308},
  [14650] = {.lex_state = 47, .external_lex_state = 400},
  [14651] = {.lex_state = 47, .external_lex_state = 308},
  [14652] = {.lex_state = 47, .external_lex_state = 400},
  [14653] = {.lex_state = 0, .external_lex_state = 308},
  [14654] = {.lex_state = 47, .external_lex_state = 400},
  [14655] = {.lex_state = 47, .external_lex_state = 400},
  [14656] = {.lex_state = 47, .external_lex_state = 400},
  [14657] = {.lex_state = 47, .external_lex_state = 400},
  [14658] = {.lex_state = 47, .external_lex_state = 400},
  [14659] = {.lex_state = 47, .external_lex_state = 308},
  [14660] = {.lex_state = 0, .external_lex_state = 399},
  [14661] = {.lex_state = 0, .external_lex_state = 399},
  [14662] = {.lex_state = 47, .external_lex_state = 398},
  [14663] = {.lex_state = 0, .external_lex_state = 399},
  [14664] = {.lex_state = 0, .external_lex_state = 308},
  [14665] = {.lex_state = 47, .external_lex_state = 400},
  [14666] = {.lex_state = 0, .external_lex_state = 399},
  [14667] = {.lex_state = 47, .external_lex_state = 400},
  [14668] = {.lex_state = 0, .external_lex_state = 399},
  [14669] = {.lex_state = 47, .external_lex_state = 400},
  [14670] = {.lex_state = 47, .external_lex_state = 400},
  [14671] = {.lex_state = 0, .external_lex_state = 399},
  [14672] = {.lex_state = 47, .external_lex_state = 400},
  [14673] = {.lex_state = 0, .external_lex_state = 308},
  [14674] = {.lex_state = 0, .external_lex_state = 308},
  [14675] = {.lex_state = 50, .external_lex_state = 308},
  [14676] = {.lex_state = 0, .external_lex_state = 399},
  [14677] = {.lex_state = 0, .external_lex_state = 437},
  [14678] = {.lex_state = 0, .external_lex_state = 399},
  [14679] = {.lex_state = 0, .external_lex_state = 399},
  [14680] = {.lex_state = 0, .external_lex_state = 399},
  [14681] = {.lex_state = 47, .external_lex_state = 308},
  [14682] = {.lex_state = 0, .external_lex_state = 399},
  [14683] = {.lex_state = 0, .external_lex_state = 308},
  [14684] = {.lex_state = 0, .external_lex_state = 308},
  [14685] = {.lex_state = 0, .external_lex_state = 355},
  [14686] = {.lex_state = 47, .external_lex_state = 308},
  [14687] = {.lex_state = 0, .external_lex_state = 399},
  [14688] = {.lex_state = 0, .external_lex_state = 308},
  [14689] = {.lex_state = 0, .external_lex_state = 308},
  [14690] = {.lex_state = 47, .external_lex_state = 397},
  [14691] = {.lex_state = 0, .external_lex_state = 399},
  [14692] = {.lex_state = 0, .external_lex_state = 308},
  [14693] = {.lex_state = 0, .external_lex_state = 344},
  [14694] = {.lex_state = 0, .external_lex_state = 399},
  [14695] = {.lex_state = 0, .external_lex_state = 399},
  [14696] = {.lex_state = 50, .external_lex_state = 308},
  [14697] = {.lex_state = 50, .external_lex_state = 308},
  [14698] = {.lex_state = 0, .external_lex_state = 399},
  [14699] = {.lex_state = 47, .external_lex_state = 403},
  [14700] = {.lex_state = 47, .external_lex_state = 398},
  [14701] = {.lex_state = 47, .external_lex_state = 398},
  [14702] = {.lex_state = 0, .external_lex_state = 308},
  [14703] = {.lex_state = 47, .external_lex_state = 398},
  [14704] = {.lex_state = 47, .external_lex_state = 403},
  [14705] = {.lex_state = 47, .external_lex_state = 398},
  [14706] = {.lex_state = 0, .external_lex_state = 399},
  [14707] = {.lex_state = 47, .external_lex_state = 400},
  [14708] = {.lex_state = 0, .external_lex_state = 399},
  [14709] = {.lex_state = 0, .external_lex_state = 399},
  [14710] = {.lex_state = 0, .external_lex_state = 399},
  [14711] = {.lex_state = 47, .external_lex_state = 397},
  [14712] = {.lex_state = 0, .external_lex_state = 399},
  [14713] = {.lex_state = 0, .external_lex_state = 399},
  [14714] = {.lex_state = 0, .external_lex_state = 308},
  [14715] = {.lex_state = 0, .external_lex_state = 308},
  [14716] = {.lex_state = 0, .external_lex_state = 308},
  [14717] = {.lex_state = 50, .external_lex_state = 308},
  [14718] = {.lex_state = 0, .external_lex_state = 399},
  [14719] = {.lex_state = 0, .external_lex_state = 399},
  [14720] = {.lex_state = 0, .external_lex_state = 308},
  [14721] = {.lex_state = 0, .external_lex_state = 399},
  [14722] = {.lex_state = 0, .external_lex_state = 308},
  [14723] = {.lex_state = 51, .external_lex_state = 396},
  [14724] = {.lex_state = 0, .external_lex_state = 308},
  [14725] = {.lex_state = 0, .external_lex_state = 308},
  [14726] = {.lex_state = 0, .external_lex_state = 399},
  [14727] = {.lex_state = 0, .external_lex_state = 308},
  [14728] = {.lex_state = 0, .external_lex_state = 397},
  [14729] = {.lex_state = 0, .external_lex_state = 399},
  [14730] = {.lex_state = 47, .external_lex_state = 425},
  [14731] = {.lex_state = 47, .external_lex_state = 403},
  [14732] = {.lex_state = 0, .external_lex_state = 399},
  [14733] = {.lex_state = 0, .external_lex_state = 308},
  [14734] = {.lex_state = 0, .external_lex_state = 437},
  [14735] = {.lex_state = 47, .external_lex_state = 398},
  [14736] = {.lex_state = 0, .external_lex_state = 308},
  [14737] = {.lex_state = 0, .external_lex_state = 308},
  [14738] = {.lex_state = 0, .external_lex_state = 399},
  [14739] = {.lex_state = 0, .external_lex_state = 399},
  [14740] = {.lex_state = 0, .external_lex_state = 399},
  [14741] = {.lex_state = 0, .external_lex_state = 399},
  [14742] = {.lex_state = 47, .external_lex_state = 308},
  [14743] = {.lex_state = 47, .external_lex_state = 403},
  [14744] = {.lex_state = 0, .external_lex_state = 308},
  [14745] = {.lex_state = 50, .external_lex_state = 308},
  [14746] = {.lex_state = 50, .external_lex_state = 308},
  [14747] = {.lex_state = 0, .external_lex_state = 308},
  [14748] = {.lex_state = 51, .external_lex_state = 396},
  [14749] = {.lex_state = 0, .external_lex_state = 308},
  [14750] = {.lex_state = 0, .external_lex_state = 399},
  [14751] = {.lex_state = 50, .external_lex_state = 335},
  [14752] = {.lex_state = 47, .external_lex_state = 403},
  [14753] = {.lex_state = 0, .external_lex_state = 308},
  [14754] = {.lex_state = 47, .external_lex_state = 403},
  [14755] = {.lex_state = 0, .external_lex_state = 437},
  [14756] = {.lex_state = 0, .external_lex_state = 355},
  [14757] = {.lex_state = 47, .external_lex_state = 308},
  [14758] = {.lex_state = 0, .external_lex_state = 399},
  [14759] = {.lex_state = 47, .external_lex_state = 400},
  [14760] = {.lex_state = 0, .external_lex_state = 345},
  [14761] = {.lex_state = 0, .external_lex_state = 308},
  [14762] = {.lex_state = 0, .external_lex_state = 399},
  [14763] = {.lex_state = 0, .external_lex_state = 308},
  [14764] = {.lex_state = 0, .external_lex_state = 437},
  [14765] = {.lex_state = 0, .external_lex_state = 308},
  [14766] = {.lex_state = 0, .external_lex_state = 437},
  [14767] = {.lex_state = 0, .external_lex_state = 308},
  [14768] = {.lex_state = 0, .external_lex_state = 399},
  [14769] = {.lex_state = 0, .external_lex_state = 344},
  [14770] = {.lex_state = 47, .external_lex_state = 400},
  [14771] = {.lex_state = 0, .external_lex_state = 397},
  [14772] = {.lex_state = 0, .external_lex_state = 399},
  [14773] = {.lex_state = 47, .external_lex_state = 400},
  [14774] = {.lex_state = 0, .external_lex_state = 399},
  [14775] = {.lex_state = 0, .external_lex_state = 344},
  [14776] = {.lex_state = 0, .external_lex_state = 308},
  [14777] = {.lex_state = 0, .external_lex_state = 399},
  [14778] = {.lex_state = 0, .external_lex_state = 308},
  [14779] = {.lex_state = 0, .external_lex_state = 344},
  [14780] = {.lex_state = 51, .external_lex_state = 396},
  [14781] = {.lex_state = 0, .external_lex_state = 399},
  [14782] = {.lex_state = 47, .external_lex_state = 308},
  [14783] = {.lex_state = 47, .external_lex_state = 422},
  [14784] = {.lex_state = 0, .external_lex_state = 308},
  [14785] = {.lex_state = 0, .external_lex_state = 308},
  [14786] = {.lex_state = 0, .external_lex_state = 308},
  [14787] = {.lex_state = 47, .external_lex_state = 308},
  [14788] = {.lex_state = 0, .external_lex_state = 399},
  [14789] = {.lex_state = 0, .external_lex_state = 399},
  [14790] = {.lex_state = 0, .external_lex_state = 308},
  [14791] = {.lex_state = 0, .external_lex_state = 308},
  [14792] = {.lex_state = 0, .external_lex_state = 399},
  [14793] = {.lex_state = 0, .external_lex_state = 399},
  [14794] = {.lex_state = 0, .external_lex_state = 399},
  [14795] = {.lex_state = 0, .external_lex_state = 308},
  [14796] = {.lex_state = 0, .external_lex_state = 399},
  [14797] = {.lex_state = 0, .external_lex_state = 399},
  [14798] = {.lex_state = 0, .external_lex_state = 308},
  [14799] = {.lex_state = 0, .external_lex_state = 399},
  [14800] = {.lex_state = 0, .external_lex_state = 399},
  [14801] = {.lex_state = 51, .external_lex_state = 396},
  [14802] = {.lex_state = 0, .external_lex_state = 399},
  [14803] = {.lex_state = 0, .external_lex_state = 308},
  [14804] = {.lex_state = 0, .external_lex_state = 399},
  [14805] = {.lex_state = 47, .external_lex_state = 400},
  [14806] = {.lex_state = 51, .external_lex_state = 396},
  [14807] = {.lex_state = 0, .external_lex_state = 344},
  [14808] = {.lex_state = 0, .external_lex_state = 399},
  [14809] = {.lex_state = 0, .external_lex_state = 335},
  [14810] = {.lex_state = 0, .external_lex_state = 308},
  [14811] = {.lex_state = 0, .external_lex_state = 308},
  [14812] = {.lex_state = 0, .external_lex_state = 399},
  [14813] = {.lex_state = 0, .external_lex_state = 344},
  [14814] = {.lex_state = 47, .external_lex_state = 308},
  [14815] = {.lex_state = 0, .external_lex_state = 399},
  [14816] = {.lex_state = 0, .external_lex_state = 308},
  [14817] = {.lex_state = 0, .external_lex_state = 399},
  [14818] = {.lex_state = 47, .external_lex_state = 397},
  [14819] = {.lex_state = 47, .external_lex_state = 397},
  [14820] = {.lex_state = 0, .external_lex_state = 308},
  [14821] = {.lex_state = 0, .external_lex_state = 308},
  [14822] = {.lex_state = 47, .external_lex_state = 308},
  [14823] = {.lex_state = 0, .external_lex_state = 308},
  [14824] = {.lex_state = 0, .external_lex_state = 399},
  [14825] = {.lex_state = 0, .external_lex_state = 355},
  [14826] = {.lex_state = 0, .external_lex_state = 308},
  [14827] = {.lex_state = 0, .external_lex_state = 344},
  [14828] = {.lex_state = 0, .external_lex_state = 399},
  [14829] = {.lex_state = 47, .external_lex_state = 308},
  [14830] = {.lex_state = 0, .external_lex_state = 399},
  [14831] = {.lex_state = 0, .external_lex_state = 399},
  [14832] = {.lex_state = 0, .external_lex_state = 399},
  [14833] = {.lex_state = 0, .external_lex_state = 399},
  [14834] = {.lex_state = 0, .external_lex_state = 308},
  [14835] = {.lex_state = 47, .external_lex_state = 400},
  [14836] = {.lex_state = 0, .external_lex_state = 308},
  [14837] = {.lex_state = 51, .external_lex_state = 396},
  [14838] = {.lex_state = 0, .external_lex_state = 399},
  [14839] = {.lex_state = 0, .external_lex_state = 399},
  [14840] = {.lex_state = 0, .external_lex_state = 399},
  [14841] = {.lex_state = 0, .external_lex_state = 399},
  [14842] = {.lex_state = 0, .external_lex_state = 308},
  [14843] = {.lex_state = 0, .external_lex_state = 399},
  [14844] = {.lex_state = 0, .external_lex_state = 399},
  [14845] = {.lex_state = 0, .external_lex_state = 335},
  [14846] = {.lex_state = 0, .external_lex_state = 399},
  [14847] = {.lex_state = 0, .external_lex_state = 399},
  [14848] = {.lex_state = 0, .external_lex_state = 355},
  [14849] = {.lex_state = 0, .external_lex_state = 399},
  [14850] = {.lex_state = 0, .external_lex_state = 399},
  [14851] = {.lex_state = 0, .external_lex_state = 399},
  [14852] = {.lex_state = 47, .external_lex_state = 308},
  [14853] = {.lex_state = 0, .external_lex_state = 308},
  [14854] = {.lex_state = 0, .external_lex_state = 308},
  [14855] = {.lex_state = 47, .external_lex_state = 308},
  [14856] = {.lex_state = 0, .external_lex_state = 343},
  [14857] = {.lex_state = 0, .external_lex_state = 308},
  [14858] = {.lex_state = 0, .external_lex_state = 399},
  [14859] = {.lex_state = 0, .external_lex_state = 399},
  [14860] = {.lex_state = 0, .external_lex_state = 399},
  [14861] = {.lex_state = 47, .external_lex_state = 400},
  [14862] = {.lex_state = 0, .external_lex_state = 308},
  [14863] = {.lex_state = 47, .external_lex_state = 400},
  [14864] = {.lex_state = 0, .external_lex_state = 399},
  [14865] = {.lex_state = 0, .external_lex_state = 308},
  [14866] = {.lex_state = 0, .external_lex_state = 308},
  [14867] = {.lex_state = 47, .external_lex_state = 439},
  [14868] = {.lex_state = 0, .external_lex_state = 308},
  [14869] = {.lex_state = 0, .external_lex_state = 438},
  [14870] = {.lex_state = 0, .external_lex_state = 438},
  [14871] = {.lex_state = 0, .external_lex_state = 308},
  [14872] = {.lex_state = 0, .external_lex_state = 399},
  [14873] = {.lex_state = 0, .external_lex_state = 308},
  [14874] = {.lex_state = 0, .external_lex_state = 308},
  [14875] = {.lex_state = 0, .external_lex_state = 344},
  [14876] = {.lex_state = 0, .external_lex_state = 344},
  [14877] = {.lex_state = 0, .external_lex_state = 308},
  [14878] = {.lex_state = 0, .external_lex_state = 308},
  [14879] = {.lex_state = 47, .external_lex_state = 397},
  [14880] = {.lex_state = 0, .external_lex_state = 399},
  [14881] = {.lex_state = 47, .external_lex_state = 400},
  [14882] = {.lex_state = 47, .external_lex_state = 400},
  [14883] = {.lex_state = 0, .external_lex_state = 335},
  [14884] = {.lex_state = 0, .external_lex_state = 399},
  [14885] = {.lex_state = 0, .external_lex_state = 308},
  [14886] = {.lex_state = 0, .external_lex_state = 308},
  [14887] = {.lex_state = 0, .external_lex_state = 399},
  [14888] = {.lex_state = 47, .external_lex_state = 422},
  [14889] = {.lex_state = 50, .external_lex_state = 308},
  [14890] = {.lex_state = 0, .external_lex_state = 308},
  [14891] = {.lex_state = 47, .external_lex_state = 422},
  [14892] = {.lex_state = 47, .external_lex_state = 411},
  [14893] = {.lex_state = 0, .external_lex_state = 308},
  [14894] = {.lex_state = 0, .external_lex_state = 308},
  [14895] = {.lex_state = 0, .external_lex_state = 424},
  [14896] = {.lex_state = 0, .external_lex_state = 399},
  [14897] = {.lex_state = 0, .external_lex_state = 399},
  [14898] = {.lex_state = 0, .external_lex_state = 344},
  [14899] = {.lex_state = 0, .external_lex_state = 399},
  [14900] = {.lex_state = 47, .external_lex_state = 400},
  [14901] = {.lex_state = 0, .external_lex_state = 399},
  [14902] = {.lex_state = 0, .external_lex_state = 399},
  [14903] = {.lex_state = 0, .external_lex_state = 399},
  [14904] = {.lex_state = 0, .external_lex_state = 335},
  [14905] = {.lex_state = 0, .external_lex_state = 399},
  [14906] = {.lex_state = 50, .external_lex_state = 308},
  [14907] = {.lex_state = 0, .external_lex_state = 308},
  [14908] = {.lex_state = 0, .external_lex_state = 399},
  [14909] = {.lex_state = 47, .external_lex_state = 402},
  [14910] = {.lex_state = 0, .external_lex_state = 399},
  [14911] = {.lex_state = 47, .external_lex_state = 308},
  [14912] = {.lex_state = 0, .external_lex_state = 399},
  [14913] = {.lex_state = 0, .external_lex_state = 308},
  [14914] = {.lex_state = 0, .external_lex_state = 399},
  [14915] = {.lex_state = 0, .external_lex_state = 308},
  [14916] = {.lex_state = 0, .external_lex_state = 399},
  [14917] = {.lex_state = 47, .external_lex_state = 397},
  [14918] = {.lex_state = 47, .external_lex_state = 397},
  [14919] = {.lex_state = 0, .external_lex_state = 335},
  [14920] = {.lex_state = 0, .external_lex_state = 399},
  [14921] = {.lex_state = 51, .external_lex_state = 396},
  [14922] = {.lex_state = 0, .external_lex_state = 308},
  [14923] = {.lex_state = 0, .external_lex_state = 335},
  [14924] = {.lex_state = 0, .external_lex_state = 399},
  [14925] = {.lex_state = 47, .external_lex_state = 308},
  [14926] = {.lex_state = 0, .external_lex_state = 399},
  [14927] = {.lex_state = 47, .external_lex_state = 403},
  [14928] = {.lex_state = 0, .external_lex_state = 399},
  [14929] = {.lex_state = 0, .external_lex_state = 399},
  [14930] = {.lex_state = 47, .external_lex_state = 439},
  [14931] = {.lex_state = 47, .external_lex_state = 403},
  [14932] = {.lex_state = 0, .external_lex_state = 308},
  [14933] = {.lex_state = 47, .external_lex_state = 422},
  [14934] = {.lex_state = 47, .external_lex_state = 422},
  [14935] = {.lex_state = 47, .external_lex_state = 400},
  [14936] = {.lex_state = 51, .external_lex_state = 396},
  [14937] = {.lex_state = 0, .external_lex_state = 308},
  [14938] = {.lex_state = 47, .external_lex_state = 398},
  [14939] = {.lex_state = 0, .external_lex_state = 399},
  [14940] = {.lex_state = 47, .external_lex_state = 400},
  [14941] = {.lex_state = 0, .external_lex_state = 399},
  [14942] = {.lex_state = 51, .external_lex_state = 396},
  [14943] = {.lex_state = 0, .external_lex_state = 308},
  [14944] = {.lex_state = 0, .external_lex_state = 308},
  [14945] = {.lex_state = 47, .external_lex_state = 400},
  [14946] = {.lex_state = 47, .external_lex_state = 400},
  [14947] = {.lex_state = 47, .external_lex_state = 400},
  [14948] = {.lex_state = 47, .external_lex_state = 400},
  [14949] = {.lex_state = 0, .external_lex_state = 308},
  [14950] = {.lex_state = 47, .external_lex_state = 399},
  [14951] = {.lex_state = 47, .external_lex_state = 400},
  [14952] = {.lex_state = 47, .external_lex_state = 400},
  [14953] = {.lex_state = 0, .external_lex_state = 399},
  [14954] = {.lex_state = 0, .external_lex_state = 308},
  [14955] = {.lex_state = 47, .external_lex_state = 308},
  [14956] = {.lex_state = 47, .external_lex_state = 400},
  [14957] = {.lex_state = 0, .external_lex_state = 399},
  [14958] = {.lex_state = 47, .external_lex_state = 400},
  [14959] = {.lex_state = 0, .external_lex_state = 399},
  [14960] = {.lex_state = 0, .external_lex_state = 399},
  [14961] = {.lex_state = 47, .external_lex_state = 397},
  [14962] = {.lex_state = 0, .external_lex_state = 399},
  [14963] = {.lex_state = 0, .external_lex_state = 308},
  [14964] = {.lex_state = 0, .external_lex_state = 399},
  [14965] = {.lex_state = 47, .external_lex_state = 400},
  [14966] = {.lex_state = 0, .external_lex_state = 308},
  [14967] = {.lex_state = 0, .external_lex_state = 399},
  [14968] = {.lex_state = 0, .external_lex_state = 308},
  [14969] = {.lex_state = 0, .external_lex_state = 399},
  [14970] = {.lex_state = 0, .external_lex_state = 345},
  [14971] = {.lex_state = 0, .external_lex_state = 399},
  [14972] = {.lex_state = 47, .external_lex_state = 399},
  [14973] = {.lex_state = 47, .external_lex_state = 399},
  [14974] = {.lex_state = 47, .external_lex_state = 400},
  [14975] = {.lex_state = 47, .external_lex_state = 400},
  [14976] = {.lex_state = 47, .external_lex_state = 400},
  [14977] = {.lex_state = 0, .external_lex_state = 308},
  [14978] = {.lex_state = 0, .external_lex_state = 399},
  [14979] = {.lex_state = 0, .external_lex_state = 335},
  [14980] = {.lex_state = 50, .external_lex_state = 335},
  [14981] = {.lex_state = 0, .external_lex_state = 335},
  [14982] = {.lex_state = 0, .external_lex_state = 399},
  [14983] = {.lex_state = 0, .external_lex_state = 308},
  [14984] = {.lex_state = 0, .external_lex_state = 399},
  [14985] = {.lex_state = 0, .external_lex_state = 399},
  [14986] = {.lex_state = 0, .external_lex_state = 308},
  [14987] = {.lex_state = 0, .external_lex_state = 335},
  [14988] = {.lex_state = 0, .external_lex_state = 399},
  [14989] = {.lex_state = 47, .external_lex_state = 400},
  [14990] = {.lex_state = 0, .external_lex_state = 345},
  [14991] = {.lex_state = 47, .external_lex_state = 400},
  [14992] = {.lex_state = 47, .external_lex_state = 400},
  [14993] = {.lex_state = 47, .external_lex_state = 411},
  [14994] = {.lex_state = 50, .external_lex_state = 308},
  [14995] = {.lex_state = 0, .external_lex_state = 399},
  [14996] = {.lex_state = 0, .external_lex_state = 308},
  [14997] = {.lex_state = 47, .external_lex_state = 402},
  [14998] = {.lex_state = 0, .external_lex_state = 399},
  [14999] = {.lex_state = 0, .external_lex_state = 399},
  [15000] = {.lex_state = 0, .external_lex_state = 335},
  [15001] = {.lex_state = 0, .external_lex_state = 308},
  [15002] = {.lex_state = 47, .external_lex_state = 439},
  [15003] = {.lex_state = 47, .external_lex_state = 403},
  [15004] = {.lex_state = 47, .external_lex_state = 308},
  [15005] = {.lex_state = 51, .external_lex_state = 396},
  [15006] = {.lex_state = 0, .external_lex_state = 308},
  [15007] = {.lex_state = 0, .external_lex_state = 308},
  [15008] = {.lex_state = 50, .external_lex_state = 335},
  [15009] = {.lex_state = 0, .external_lex_state = 308},
  [15010] = {.lex_state = 0, .external_lex_state = 308},
  [15011] = {.lex_state = 0, .external_lex_state = 399},
  [15012] = {.lex_state = 0, .external_lex_state = 399},
  [15013] = {.lex_state = 47, .external_lex_state = 403},
  [15014] = {.lex_state = 0, .external_lex_state = 308},
  [15015] = {.lex_state = 50, .external_lex_state = 308},
  [15016] = {.lex_state = 0, .external_lex_state = 399},
  [15017] = {.lex_state = 0, .external_lex_state = 308},
  [15018] = {.lex_state = 51, .external_lex_state = 396},
  [15019] = {.lex_state = 50, .external_lex_state = 308},
  [15020] = {.lex_state = 0, .external_lex_state = 399},
  [15021] = {.lex_state = 0, .external_lex_state = 399},
  [15022] = {.lex_state = 0, .external_lex_state = 399},
  [15023] = {.lex_state = 0, .external_lex_state = 399},
  [15024] = {.lex_state = 0, .external_lex_state = 399},
  [15025] = {.lex_state = 0, .external_lex_state = 399},
  [15026] = {.lex_state = 0, .external_lex_state = 399},
  [15027] = {.lex_state = 0, .external_lex_state = 399},
  [15028] = {.lex_state = 0, .external_lex_state = 399},
  [15029] = {.lex_state = 47, .external_lex_state = 403},
  [15030] = {.lex_state = 47, .external_lex_state = 399},
  [15031] = {.lex_state = 0, .external_lex_state = 399},
  [15032] = {.lex_state = 0, .external_lex_state = 399},
  [15033] = {.lex_state = 0, .external_lex_state = 399},
  [15034] = {.lex_state = 47, .external_lex_state = 397},
  [15035] = {.lex_state = 0, .external_lex_state = 399},
  [15036] = {.lex_state = 47, .external_lex_state = 397},
  [15037] = {.lex_state = 0, .external_lex_state = 308},
  [15038] = {.lex_state = 0, .external_lex_state = 308},
  [15039] = {.lex_state = 0, .external_lex_state = 399},
  [15040] = {.lex_state = 47, .external_lex_state = 308},
  [15041] = {.lex_state = 0, .external_lex_state = 399},
  [15042] = {.lex_state = 0, .external_lex_state = 399},
  [15043] = {.lex_state = 51, .external_lex_state = 396},
  [15044] = {.lex_state = 0, .external_lex_state = 399},
  [15045] = {.lex_state = 0, .external_lex_state = 399},
  [15046] = {.lex_state = 0, .external_lex_state = 308},
  [15047] = {.lex_state = 47, .external_lex_state = 400},
  [15048] = {.lex_state = 0, .external_lex_state = 399},
  [15049] = {.lex_state = 0, .external_lex_state = 355},
  [15050] = {.lex_state = 0, .external_lex_state = 399},
  [15051] = {.lex_state = 0, .external_lex_state = 399},
  [15052] = {.lex_state = 0, .external_lex_state = 308},
  [15053] = {.lex_state = 0, .external_lex_state = 399},
  [15054] = {.lex_state = 0, .external_lex_state = 308},
  [15055] = {.lex_state = 47, .external_lex_state = 403},
  [15056] = {.lex_state = 47, .external_lex_state = 399},
  [15057] = {.lex_state = 47, .external_lex_state = 439},
  [15058] = {.lex_state = 0, .external_lex_state = 399},
  [15059] = {.lex_state = 0, .external_lex_state = 399},
  [15060] = {.lex_state = 51, .external_lex_state = 396},
  [15061] = {.lex_state = 0, .external_lex_state = 416},
  [15062] = {.lex_state = 0, .external_lex_state = 308},
  [15063] = {.lex_state = 47, .external_lex_state = 399},
  [15064] = {.lex_state = 47, .external_lex_state = 399},
  [15065] = {.lex_state = 0, .external_lex_state = 399},
  [15066] = {.lex_state = 47, .external_lex_state = 308},
  [15067] = {.lex_state = 47, .external_lex_state = 402},
  [15068] = {.lex_state = 47, .external_lex_state = 402},
  [15069] = {.lex_state = 51, .external_lex_state = 396},
  [15070] = {.lex_state = 0, .external_lex_state = 399},
  [15071] = {.lex_state = 0, .external_lex_state = 308},
  [15072] = {.lex_state = 0, .external_lex_state = 308},
  [15073] = {.lex_state = 0, .external_lex_state = 399},
  [15074] = {.lex_state = 0, .external_lex_state = 399},
  [15075] = {.lex_state = 0, .external_lex_state = 308},
  [15076] = {.lex_state = 47, .external_lex_state = 422},
  [15077] = {.lex_state = 0, .external_lex_state = 399},
  [15078] = {.lex_state = 0, .external_lex_state = 399},
  [15079] = {.lex_state = 0, .external_lex_state = 343},
  [15080] = {.lex_state = 0, .external_lex_state = 308},
  [15081] = {.lex_state = 0, .external_lex_state = 308},
  [15082] = {.lex_state = 0, .external_lex_state = 399},
  [15083] = {.lex_state = 0, .external_lex_state = 308},
  [15084] = {.lex_state = 47, .external_lex_state = 397},
  [15085] = {.lex_state = 0, .external_lex_state = 399},
  [15086] = {.lex_state = 0, .external_lex_state = 399},
  [15087] = {.lex_state = 47, .external_lex_state = 439},
  [15088] = {.lex_state = 51, .external_lex_state = 335},
  [15089] = {.lex_state = 47, .external_lex_state = 397},
  [15090] = {.lex_state = 0, .external_lex_state = 399},
  [15091] = {.lex_state = 0, .external_lex_state = 399},
  [15092] = {.lex_state = 0, .external_lex_state = 308},
  [15093] = {.lex_state = 0, .external_lex_state = 399},
  [15094] = {.lex_state = 0, .external_lex_state = 399},
  [15095] = {.lex_state = 51, .external_lex_state = 396},
  [15096] = {.lex_state = 0, .external_lex_state = 308},
  [15097] = {.lex_state = 0, .external_lex_state = 399},
  [15098] = {.lex_state = 0, .external_lex_state = 399},
  [15099] = {.lex_state = 0, .external_lex_state = 308},
  [15100] = {.lex_state = 0, .external_lex_state = 399},
  [15101] = {.lex_state = 0, .external_lex_state = 399},
  [15102] = {.lex_state = 47, .external_lex_state = 397},
  [15103] = {.lex_state = 0, .external_lex_state = 308},
  [15104] = {.lex_state = 51, .external_lex_state = 396},
  [15105] = {.lex_state = 0, .external_lex_state = 399},
  [15106] = {.lex_state = 47, .external_lex_state = 399},
  [15107] = {.lex_state = 0, .external_lex_state = 308},
  [15108] = {.lex_state = 0, .external_lex_state = 308},
  [15109] = {.lex_state = 0, .external_lex_state = 399},
  [15110] = {.lex_state = 0, .external_lex_state = 308},
  [15111] = {.lex_state = 47, .external_lex_state = 403},
  [15112] = {.lex_state = 0, .external_lex_state = 308},
  [15113] = {.lex_state = 47, .external_lex_state = 403},
  [15114] = {.lex_state = 0, .external_lex_state = 399},
  [15115] = {.lex_state = 0, .external_lex_state = 399},
  [15116] = {.lex_state = 0, .external_lex_state = 308},
  [15117] = {.lex_state = 47, .external_lex_state = 397},
  [15118] = {.lex_state = 0, .external_lex_state = 399},
  [15119] = {.lex_state = 47, .external_lex_state = 403},
  [15120] = {.lex_state = 0, .external_lex_state = 308},
  [15121] = {.lex_state = 0, .external_lex_state = 436},
  [15122] = {.lex_state = 0, .external_lex_state = 308},
  [15123] = {.lex_state = 51, .external_lex_state = 396},
  [15124] = {.lex_state = 0, .external_lex_state = 308},
  [15125] = {.lex_state = 0, .external_lex_state = 308},
  [15126] = {.lex_state = 47, .external_lex_state = 399},
  [15127] = {.lex_state = 51, .external_lex_state = 396},
  [15128] = {.lex_state = 47, .external_lex_state = 403},
  [15129] = {.lex_state = 0, .external_lex_state = 308},
  [15130] = {.lex_state = 47, .external_lex_state = 308},
  [15131] = {.lex_state = 0, .external_lex_state = 308},
  [15132] = {.lex_state = 0, .external_lex_state = 436},
  [15133] = {.lex_state = 47, .external_lex_state = 399},
  [15134] = {.lex_state = 0, .external_lex_state = 308},
  [15135] = {.lex_state = 47, .external_lex_state = 402},
  [15136] = {.lex_state = 47, .external_lex_state = 399},
  [15137] = {.lex_state = 0, .external_lex_state = 399},
  [15138] = {.lex_state = 47, .external_lex_state = 399},
  [15139] = {.lex_state = 0, .external_lex_state = 308},
  [15140] = {.lex_state = 51, .external_lex_state = 396},
  [15141] = {.lex_state = 0, .external_lex_state = 399},
  [15142] = {.lex_state = 0, .external_lex_state = 308},
  [15143] = {.lex_state = 0, .external_lex_state = 399},
  [15144] = {.lex_state = 0, .external_lex_state = 308},
  [15145] = {.lex_state = 47, .external_lex_state = 402},
  [15146] = {.lex_state = 51, .external_lex_state = 396},
  [15147] = {.lex_state = 0, .external_lex_state = 399},
  [15148] = {.lex_state = 0, .external_lex_state = 399},
  [15149] = {.lex_state = 0, .external_lex_state = 399},
  [15150] = {.lex_state = 0, .external_lex_state = 308},
  [15151] = {.lex_state = 51, .external_lex_state = 396},
  [15152] = {.lex_state = 0, .external_lex_state = 308},
  [15153] = {.lex_state = 0, .external_lex_state = 308},
  [15154] = {.lex_state = 0, .external_lex_state = 308},
  [15155] = {.lex_state = 47, .external_lex_state = 403},
  [15156] = {.lex_state = 0, .external_lex_state = 308},
  [15157] = {.lex_state = 47, .external_lex_state = 403},
  [15158] = {.lex_state = 50, .external_lex_state = 308},
  [15159] = {.lex_state = 0, .external_lex_state = 399},
  [15160] = {.lex_state = 0, .external_lex_state = 438},
  [15161] = {.lex_state = 0, .external_lex_state = 308},
  [15162] = {.lex_state = 0, .external_lex_state = 308},
  [15163] = {.lex_state = 0, .external_lex_state = 399},
  [15164] = {.lex_state = 47, .external_lex_state = 402},
  [15165] = {.lex_state = 0, .external_lex_state = 399},
  [15166] = {.lex_state = 0, .external_lex_state = 308},
  [15167] = {.lex_state = 47, .external_lex_state = 400},
  [15168] = {.lex_state = 51, .external_lex_state = 396},
  [15169] = {.lex_state = 0, .external_lex_state = 308},
  [15170] = {.lex_state = 47, .external_lex_state = 402},
  [15171] = {.lex_state = 47, .external_lex_state = 402},
  [15172] = {.lex_state = 47, .external_lex_state = 402},
  [15173] = {.lex_state = 0, .external_lex_state = 399},
  [15174] = {.lex_state = 51, .external_lex_state = 396},
  [15175] = {.lex_state = 47, .external_lex_state = 403},
  [15176] = {.lex_state = 47, .external_lex_state = 399},
  [15177] = {.lex_state = 0, .external_lex_state = 335},
  [15178] = {.lex_state = 47, .external_lex_state = 399},
  [15179] = {.lex_state = 0, .external_lex_state = 399},
  [15180] = {.lex_state = 47, .external_lex_state = 403},
  [15181] = {.lex_state = 0, .external_lex_state = 335},
  [15182] = {.lex_state = 47, .external_lex_state = 402},
  [15183] = {.lex_state = 47, .external_lex_state = 397},
  [15184] = {.lex_state = 0, .external_lex_state = 335},
  [15185] = {.lex_state = 0, .external_lex_state = 397},
  [15186] = {.lex_state = 0, .external_lex_state = 345},
  [15187] = {.lex_state = 0, .external_lex_state = 399},
  [15188] = {.lex_state = 0, .external_lex_state = 355},
  [15189] = {.lex_state = 0, .external_lex_state = 399},
  [15190] = {.lex_state = 0, .external_lex_state = 399},
  [15191] = {.lex_state = 0, .external_lex_state = 308},
  [15192] = {.lex_state = 0, .external_lex_state = 399},
  [15193] = {.lex_state = 51, .external_lex_state = 396},
  [15194] = {.lex_state = 50, .external_lex_state = 335},
  [15195] = {.lex_state = 0, .external_lex_state = 308},
  [15196] = {.lex_state = 0, .external_lex_state = 308},
  [15197] = {.lex_state = 0, .external_lex_state = 308},
  [15198] = {.lex_state = 0, .external_lex_state = 308},
  [15199] = {.lex_state = 51, .external_lex_state = 396},
  [15200] = {.lex_state = 0, .external_lex_state = 308},
  [15201] = {.lex_state = 0, .external_lex_state = 399},
  [15202] = {.lex_state = 51, .external_lex_state = 396},
  [15203] = {.lex_state = 0, .external_lex_state = 399},
  [15204] = {.lex_state = 47, .external_lex_state = 422},
  [15205] = {.lex_state = 47, .external_lex_state = 403},
  [15206] = {.lex_state = 50, .external_lex_state = 335},
  [15207] = {.lex_state = 0, .external_lex_state = 308},
  [15208] = {.lex_state = 0, .external_lex_state = 438},
  [15209] = {.lex_state = 47, .external_lex_state = 399},
  [15210] = {.lex_state = 51, .external_lex_state = 396},
  [15211] = {.lex_state = 0, .external_lex_state = 308},
  [15212] = {.lex_state = 0, .external_lex_state = 399},
  [15213] = {.lex_state = 0, .external_lex_state = 399},
  [15214] = {.lex_state = 0, .external_lex_state = 308},
  [15215] = {.lex_state = 0, .external_lex_state = 399},
  [15216] = {.lex_state = 0, .external_lex_state = 399},
  [15217] = {.lex_state = 51, .external_lex_state = 396},
  [15218] = {.lex_state = 0, .external_lex_state = 335},
  [15219] = {.lex_state = 51, .external_lex_state = 396},
  [15220] = {.lex_state = 47, .external_lex_state = 397},
  [15221] = {.lex_state = 47, .external_lex_state = 397},
  [15222] = {.lex_state = 0, .external_lex_state = 308},
  [15223] = {.lex_state = 47, .external_lex_state = 397},
  [15224] = {.lex_state = 0, .external_lex_state = 399},
  [15225] = {.lex_state = 51, .external_lex_state = 396},
  [15226] = {.lex_state = 47, .external_lex_state = 397},
  [15227] = {.lex_state = 47, .external_lex_state = 397},
  [15228] = {.lex_state = 47, .external_lex_state = 397},
  [15229] = {.lex_state = 0, .external_lex_state = 399},
  [15230] = {.lex_state = 0, .external_lex_state = 308},
  [15231] = {.lex_state = 0, .external_lex_state = 399},
  [15232] = {.lex_state = 0, .external_lex_state = 399},
  [15233] = {.lex_state = 0, .external_lex_state = 413},
  [15234] = {.lex_state = 47, .external_lex_state = 397},
  [15235] = {.lex_state = 47, .external_lex_state = 397},
  [15236] = {.lex_state = 0, .external_lex_state = 399},
  [15237] = {.lex_state = 0, .external_lex_state = 399},
  [15238] = {.lex_state = 0, .external_lex_state = 308},
  [15239] = {.lex_state = 0, .external_lex_state = 399},
  [15240] = {.lex_state = 0, .external_lex_state = 308},
  [15241] = {.lex_state = 47, .external_lex_state = 397},
  [15242] = {.lex_state = 51, .external_lex_state = 396},
  [15243] = {.lex_state = 0, .external_lex_state = 399},
  [15244] = {.lex_state = 47, .external_lex_state = 397},
  [15245] = {.lex_state = 0, .external_lex_state = 308},
  [15246] = {.lex_state = 47, .external_lex_state = 397},
  [15247] = {.lex_state = 51, .external_lex_state = 396},
  [15248] = {.lex_state = 0, .external_lex_state = 399},
  [15249] = {.lex_state = 50, .external_lex_state = 335},
  [15250] = {.lex_state = 51, .external_lex_state = 396},
  [15251] = {.lex_state = 0, .external_lex_state = 308},
  [15252] = {.lex_state = 0, .external_lex_state = 345},
  [15253] = {.lex_state = 51, .external_lex_state = 396},
  [15254] = {.lex_state = 0, .external_lex_state = 399},
  [15255] = {.lex_state = 47, .external_lex_state = 397},
  [15256] = {.lex_state = 0, .external_lex_state = 399},
  [15257] = {.lex_state = 47, .external_lex_state = 397},
  [15258] = {.lex_state = 47, .external_lex_state = 397},
  [15259] = {.lex_state = 0, .external_lex_state = 399},
  [15260] = {.lex_state = 47, .external_lex_state = 397},
  [15261] = {.lex_state = 0, .external_lex_state = 308},
  [15262] = {.lex_state = 0, .external_lex_state = 399},
  [15263] = {.lex_state = 0, .external_lex_state = 308},
  [15264] = {.lex_state = 47, .external_lex_state = 403},
  [15265] = {.lex_state = 47, .external_lex_state = 411},
  [15266] = {.lex_state = 0, .external_lex_state = 308},
  [15267] = {.lex_state = 0, .external_lex_state = 308},
  [15268] = {.lex_state = 0, .external_lex_state = 308},
  [15269] = {.lex_state = 0, .external_lex_state = 308},
  [15270] = {.lex_state = 50, .external_lex_state = 335},
  [15271] = {.lex_state = 51, .external_lex_state = 396},
  [15272] = {.lex_state = 0, .external_lex_state = 399},
  [15273] = {.lex_state = 0, .external_lex_state = 308},
  [15274] = {.lex_state = 47, .external_lex_state = 439},
  [15275] = {.lex_state = 0, .external_lex_state = 399},
  [15276] = {.lex_state = 0, .external_lex_state = 399},
  [15277] = {.lex_state = 0, .external_lex_state = 308},
  [15278] = {.lex_state = 0, .external_lex_state = 308},
  [15279] = {.lex_state = 0, .external_lex_state = 308},
  [15280] = {.lex_state = 0, .external_lex_state = 399},
  [15281] = {.lex_state = 0, .external_lex_state = 399},
  [15282] = {.lex_state = 0, .external_lex_state = 308},
  [15283] = {.lex_state = 0, .external_lex_state = 399},
  [15284] = {.lex_state = 0, .external_lex_state = 399},
  [15285] = {.lex_state = 0, .external_lex_state = 399},
  [15286] = {.lex_state = 0, .external_lex_state = 399},
  [15287] = {.lex_state = 0, .external_lex_state = 308},
  [15288] = {.lex_state = 0, .external_lex_state = 308},
  [15289] = {.lex_state = 0, .external_lex_state = 308},
  [15290] = {.lex_state = 0, .external_lex_state = 344},
  [15291] = {.lex_state = 0, .external_lex_state = 399},
  [15292] = {.lex_state = 47, .external_lex_state = 397},
  [15293] = {.lex_state = 0, .external_lex_state = 308},
  [15294] = {.lex_state = 0, .external_lex_state = 416},
  [15295] = {.lex_state = 0, .external_lex_state = 308},
  [15296] = {.lex_state = 47, .external_lex_state = 308},
  [15297] = {.lex_state = 51, .external_lex_state = 396},
  [15298] = {.lex_state = 0, .external_lex_state = 308},
  [15299] = {.lex_state = 0, .external_lex_state = 399},
  [15300] = {.lex_state = 51, .external_lex_state = 396},
  [15301] = {.lex_state = 0, .external_lex_state = 345},
  [15302] = {.lex_state = 0, .external_lex_state = 399},
  [15303] = {.lex_state = 0, .external_lex_state = 399},
  [15304] = {.lex_state = 0, .external_lex_state = 308},
  [15305] = {.lex_state = 0, .external_lex_state = 399},
  [15306] = {.lex_state = 47, .external_lex_state = 439},
  [15307] = {.lex_state = 47, .external_lex_state = 397},
  [15308] = {.lex_state = 0, .external_lex_state = 437},
  [15309] = {.lex_state = 0, .external_lex_state = 308},
  [15310] = {.lex_state = 51, .external_lex_state = 396},
  [15311] = {.lex_state = 0, .external_lex_state = 335},
  [15312] = {.lex_state = 0, .external_lex_state = 399},
  [15313] = {.lex_state = 0, .external_lex_state = 399},
  [15314] = {.lex_state = 0, .external_lex_state = 436},
  [15315] = {.lex_state = 0, .external_lex_state = 308},
  [15316] = {.lex_state = 0, .external_lex_state = 308},
  [15317] = {.lex_state = 50, .external_lex_state = 308},
  [15318] = {.lex_state = 0, .external_lex_state = 308},
  [15319] = {.lex_state = 51, .external_lex_state = 396},
  [15320] = {.lex_state = 0, .external_lex_state = 308},
  [15321] = {.lex_state = 0, .external_lex_state = 308},
  [15322] = {.lex_state = 47, .external_lex_state = 308},
  [15323] = {.lex_state = 47, .external_lex_state = 397},
  [15324] = {.lex_state = 0, .external_lex_state = 399},
  [15325] = {.lex_state = 0, .external_lex_state = 399},
  [15326] = {.lex_state = 0, .external_lex_state = 308},
  [15327] = {.lex_state = 47, .external_lex_state = 397},
  [15328] = {.lex_state = 0, .external_lex_state = 399},
  [15329] = {.lex_state = 0, .external_lex_state = 308},
  [15330] = {.lex_state = 0, .external_lex_state = 308},
  [15331] = {.lex_state = 0, .external_lex_state = 436},
  [15332] = {.lex_state = 0, .external_lex_state = 438},
  [15333] = {.lex_state = 0, .external_lex_state = 399},
  [15334] = {.lex_state = 0, .external_lex_state = 308},
  [15335] = {.lex_state = 0, .external_lex_state = 308},
  [15336] = {.lex_state = 51, .external_lex_state = 396},
  [15337] = {.lex_state = 0, .external_lex_state = 335},
  [15338] = {.lex_state = 0, .external_lex_state = 436},
  [15339] = {.lex_state = 0, .external_lex_state = 308},
  [15340] = {.lex_state = 0, .external_lex_state = 308},
  [15341] = {.lex_state = 0, .external_lex_state = 345},
  [15342] = {.lex_state = 0, .external_lex_state = 399},
  [15343] = {.lex_state = 47, .external_lex_state = 422},
  [15344] = {.lex_state = 0, .external_lex_state = 399},
  [15345] = {.lex_state = 0, .external_lex_state = 345},
  [15346] = {.lex_state = 0, .external_lex_state = 399},
  [15347] = {.lex_state = 0, .external_lex_state = 308},
  [15348] = {.lex_state = 0, .external_lex_state = 335},
  [15349] = {.lex_state = 0, .external_lex_state = 308},
  [15350] = {.lex_state = 0, .external_lex_state = 399},
  [15351] = {.lex_state = 0, .external_lex_state = 308},
  [15352] = {.lex_state = 51, .external_lex_state = 396},
  [15353] = {.lex_state = 0, .external_lex_state = 308},
  [15354] = {.lex_state = 0, .external_lex_state = 399},
  [15355] = {.lex_state = 51, .external_lex_state = 396},
  [15356] = {.lex_state = 51, .external_lex_state = 396},
  [15357] = {.lex_state = 0, .external_lex_state = 399},
  [15358] = {.lex_state = 0, .external_lex_state = 399},
  [15359] = {.lex_state = 0, .external_lex_state = 399},
  [15360] = {.lex_state = 0, .external_lex_state = 399},
  [15361] = {.lex_state = 51, .external_lex_state = 396},
  [15362] = {.lex_state = 0, .external_lex_state = 399},
  [15363] = {.lex_state = 50, .external_lex_state = 308},
  [15364] = {.lex_state = 0, .external_lex_state = 308},
  [15365] = {.lex_state = 47, .external_lex_state = 400},
  [15366] = {.lex_state = 0, .external_lex_state = 399},
  [15367] = {.lex_state = 50, .external_lex_state = 308},
  [15368] = {.lex_state = 47, .external_lex_state = 397},
  [15369] = {.lex_state = 0, .external_lex_state = 399},
  [15370] = {.lex_state = 51, .external_lex_state = 396},
  [15371] = {.lex_state = 0, .external_lex_state = 399},
  [15372] = {.lex_state = 0, .external_lex_state = 308},
  [15373] = {.lex_state = 0, .external_lex_state = 308},
  [15374] = {.lex_state = 0, .external_lex_state = 345},
  [15375] = {.lex_state = 0, .external_lex_state = 308},
  [15376] = {.lex_state = 0, .external_lex_state = 308},
  [15377] = {.lex_state = 0, .external_lex_state = 399},
  [15378] = {.lex_state = 0, .external_lex_state = 345},
  [15379] = {.lex_state = 0, .external_lex_state = 399},
  [15380] = {.lex_state = 0, .external_lex_state = 399},
  [15381] = {.lex_state = 0, .external_lex_state = 399},
  [15382] = {.lex_state = 0, .external_lex_state = 308},
  [15383] = {.lex_state = 0, .external_lex_state = 344},
  [15384] = {.lex_state = 51, .external_lex_state = 396},
  [15385] = {.lex_state = 0, .external_lex_state = 399},
  [15386] = {.lex_state = 0, .external_lex_state = 308},
  [15387] = {.lex_state = 0, .external_lex_state = 399},
  [15388] = {.lex_state = 0, .external_lex_state = 308},
  [15389] = {.lex_state = 0, .external_lex_state = 399},
  [15390] = {.lex_state = 50, .external_lex_state = 308},
  [15391] = {.lex_state = 47, .external_lex_state = 399},
  [15392] = {.lex_state = 0, .external_lex_state = 308},
  [15393] = {.lex_state = 0, .external_lex_state = 308},
  [15394] = {.lex_state = 0, .external_lex_state = 399},
  [15395] = {.lex_state = 51, .external_lex_state = 396},
  [15396] = {.lex_state = 47, .external_lex_state = 397},
  [15397] = {.lex_state = 0, .external_lex_state = 308},
  [15398] = {.lex_state = 47, .external_lex_state = 397},
  [15399] = {.lex_state = 0, .external_lex_state = 399},
  [15400] = {.lex_state = 0, .external_lex_state = 438},
  [15401] = {.lex_state = 47, .external_lex_state = 397},
  [15402] = {.lex_state = 0, .external_lex_state = 438},
  [15403] = {.lex_state = 0, .external_lex_state = 399},
  [15404] = {.lex_state = 47, .external_lex_state = 397},
  [15405] = {.lex_state = 0, .external_lex_state = 308},
  [15406] = {.lex_state = 47, .external_lex_state = 397},
  [15407] = {.lex_state = 0, .external_lex_state = 399},
  [15408] = {.lex_state = 0, .external_lex_state = 308},
  [15409] = {.lex_state = 47, .external_lex_state = 397},
  [15410] = {.lex_state = 0, .external_lex_state = 335},
  [15411] = {.lex_state = 0, .external_lex_state = 335},
  [15412] = {.lex_state = 47, .external_lex_state = 397},
  [15413] = {.lex_state = 0, .external_lex_state = 308},
  [15414] = {.lex_state = 0, .external_lex_state = 399},
  [15415] = {.lex_state = 47, .external_lex_state = 397},
  [15416] = {.lex_state = 0, .external_lex_state = 355},
  [15417] = {.lex_state = 0, .external_lex_state = 308},
  [15418] = {.lex_state = 47, .external_lex_state = 397},
  [15419] = {.lex_state = 0, .external_lex_state = 436},
  [15420] = {.lex_state = 47, .external_lex_state = 397},
  [15421] = {.lex_state = 0, .external_lex_state = 308},
  [15422] = {.lex_state = 0, .external_lex_state = 308},
  [15423] = {.lex_state = 47, .external_lex_state = 397},
  [15424] = {.lex_state = 47, .external_lex_state = 397},
  [15425] = {.lex_state = 0, .external_lex_state = 308},
  [15426] = {.lex_state = 47, .external_lex_state = 397},
  [15427] = {.lex_state = 47, .external_lex_state = 397},
  [15428] = {.lex_state = 0, .external_lex_state = 399},
  [15429] = {.lex_state = 1, .external_lex_state = 441},
  [15430] = {.lex_state = 0, .external_lex_state = 308},
  [15431] = {.lex_state = 50, .external_lex_state = 335},
  [15432] = {.lex_state = 0, .external_lex_state = 308},
  [15433] = {.lex_state = 0, .external_lex_state = 355},
  [15434] = {.lex_state = 0, .external_lex_state = 308},
  [15435] = {.lex_state = 0, .external_lex_state = 335},
  [15436] = {.lex_state = 0, .external_lex_state = 335},
  [15437] = {.lex_state = 0, .external_lex_state = 335},
  [15438] = {.lex_state = 0, .external_lex_state = 379},
  [15439] = {.lex_state = 0, .external_lex_state = 308},
  [15440] = {.lex_state = 0, .external_lex_state = 379},
  [15441] = {.lex_state = 0, .external_lex_state = 379},
  [15442] = {.lex_state = 0, .external_lex_state = 435},
  [15443] = {.lex_state = 1, .external_lex_state = 441},
  [15444] = {.lex_state = 1, .external_lex_state = 441},
  [15445] = {.lex_state = 0, .external_lex_state = 435},
  [15446] = {.lex_state = 1, .external_lex_state = 441},
  [15447] = {.lex_state = 0, .external_lex_state = 435},
  [15448] = {.lex_state = 0, .external_lex_state = 335},
  [15449] = {.lex_state = 0, .external_lex_state = 335},
  [15450] = {.lex_state = 0, .external_lex_state = 435},
  [15451] = {.lex_state = 1, .external_lex_state = 441},
  [15452] = {.lex_state = 0, .external_lex_state = 397},
  [15453] = {.lex_state = 1, .external_lex_state = 441},
  [15454] = {.lex_state = 0, .external_lex_state = 335},
  [15455] = {.lex_state = 0, .external_lex_state = 335},
  [15456] = {.lex_state = 0, .external_lex_state = 308},
  [15457] = {.lex_state = 0, .external_lex_state = 416},
  [15458] = {.lex_state = 0, .external_lex_state = 308},
  [15459] = {.lex_state = 0, .external_lex_state = 416},
  [15460] = {.lex_state = 1, .external_lex_state = 441},
  [15461] = {.lex_state = 0, .external_lex_state = 335},
  [15462] = {.lex_state = 0, .external_lex_state = 335},
  [15463] = {.lex_state = 0, .external_lex_state = 335},
  [15464] = {.lex_state = 1, .external_lex_state = 441},
  [15465] = {.lex_state = 51, .external_lex_state = 308},
  [15466] = {.lex_state = 0, .external_lex_state = 335},
  [15467] = {.lex_state = 51, .external_lex_state = 308},
  [15468] = {.lex_state = 0, .external_lex_state = 335},
  [15469] = {.lex_state = 0, .external_lex_state = 435},
  [15470] = {.lex_state = 0, .external_lex_state = 335},
  [15471] = {.lex_state = 0, .external_lex_state = 335},
  [15472] = {.lex_state = 0, .external_lex_state = 335},
  [15473] = {.lex_state = 0, .external_lex_state = 335},
  [15474] = {.lex_state = 0, .external_lex_state = 335},
  [15475] = {.lex_state = 1, .external_lex_state = 441},
  [15476] = {.lex_state = 0, .external_lex_state = 335},
  [15477] = {.lex_state = 0, .external_lex_state = 335},
  [15478] = {.lex_state = 0, .external_lex_state = 335},
  [15479] = {.lex_state = 0, .external_lex_state = 308},
  [15480] = {.lex_state = 0, .external_lex_state = 308},
  [15481] = {.lex_state = 0, .external_lex_state = 416},
  [15482] = {.lex_state = 0, .external_lex_state = 416},
  [15483] = {.lex_state = 0, .external_lex_state = 335},
  [15484] = {.lex_state = 0, .external_lex_state = 308},
  [15485] = {.lex_state = 0, .external_lex_state = 335},
  [15486] = {.lex_state = 0, .external_lex_state = 335},
  [15487] = {.lex_state = 0, .external_lex_state = 416},
  [15488] = {.lex_state = 51, .external_lex_state = 308},
  [15489] = {.lex_state = 0, .external_lex_state = 308},
  [15490] = {.lex_state = 0, .external_lex_state = 335},
  [15491] = {.lex_state = 0, .external_lex_state = 416},
  [15492] = {.lex_state = 0, .external_lex_state = 308},
  [15493] = {.lex_state = 0, .external_lex_state = 335},
  [15494] = {.lex_state = 0, .external_lex_state = 335},
  [15495] = {.lex_state = 0, .external_lex_state = 335},
  [15496] = {.lex_state = 0, .external_lex_state = 397},
  [15497] = {.lex_state = 0, .external_lex_state = 416},
  [15498] = {.lex_state = 0, .external_lex_state = 335},
  [15499] = {.lex_state = 51, .external_lex_state = 308},
  [15500] = {.lex_state = 0, .external_lex_state = 308},
  [15501] = {.lex_state = 0, .external_lex_state = 397},
  [15502] = {.lex_state = 0, .external_lex_state = 335},
  [15503] = {.lex_state = 0, .external_lex_state = 335},
  [15504] = {.lex_state = 0, .external_lex_state = 308},
  [15505] = {.lex_state = 0, .external_lex_state = 335},
  [15506] = {.lex_state = 0, .external_lex_state = 335},
  [15507] = {.lex_state = 0, .external_lex_state = 335},
  [15508] = {.lex_state = 51, .external_lex_state = 308},
  [15509] = {.lex_state = 0, .external_lex_state = 416},
  [15510] = {.lex_state = 0, .external_lex_state = 335},
  [15511] = {.lex_state = 0, .external_lex_state = 335},
  [15512] = {.lex_state = 0, .external_lex_state = 335},
  [15513] = {.lex_state = 0, .external_lex_state = 308},
  [15514] = {.lex_state = 0, .external_lex_state = 308},
  [15515] = {.lex_state = 0, .external_lex_state = 308},
  [15516] = {.lex_state = 50, .external_lex_state = 355},
  [15517] = {.lex_state = 0, .external_lex_state = 335},
  [15518] = {.lex_state = 0, .external_lex_state = 335},
  [15519] = {.lex_state = 0, .external_lex_state = 416},
  [15520] = {.lex_state = 0, .external_lex_state = 416},
  [15521] = {.lex_state = 0, .external_lex_state = 335},
  [15522] = {.lex_state = 0, .external_lex_state = 308},
  [15523] = {.lex_state = 0, .external_lex_state = 335},
  [15524] = {.lex_state = 0, .external_lex_state = 335},
  [15525] = {.lex_state = 0, .external_lex_state = 335},
  [15526] = {.lex_state = 1, .external_lex_state = 441},
  [15527] = {.lex_state = 0, .external_lex_state = 335},
  [15528] = {.lex_state = 1, .external_lex_state = 441},
  [15529] = {.lex_state = 50, .external_lex_state = 308},
  [15530] = {.lex_state = 0, .external_lex_state = 308},
  [15531] = {.lex_state = 0, .external_lex_state = 335},
  [15532] = {.lex_state = 0, .external_lex_state = 397},
  [15533] = {.lex_state = 0, .external_lex_state = 308},
  [15534] = {.lex_state = 0, .external_lex_state = 308},
  [15535] = {.lex_state = 0, .external_lex_state = 335},
  [15536] = {.lex_state = 0, .external_lex_state = 335},
  [15537] = {.lex_state = 0, .external_lex_state = 335},
  [15538] = {.lex_state = 51, .external_lex_state = 308},
  [15539] = {.lex_state = 0, .external_lex_state = 335},
  [15540] = {.lex_state = 0, .external_lex_state = 335},
  [15541] = {.lex_state = 0, .external_lex_state = 335},
  [15542] = {.lex_state = 1, .external_lex_state = 441},
  [15543] = {.lex_state = 0, .external_lex_state = 308},
  [15544] = {.lex_state = 0, .external_lex_state = 335},
  [15545] = {.lex_state = 0, .external_lex_state = 308},
  [15546] = {.lex_state = 0, .external_lex_state = 416},
  [15547] = {.lex_state = 47, .external_lex_state = 308},
  [15548] = {.lex_state = 0, .external_lex_state = 308},
  [15549] = {.lex_state = 0, .external_lex_state = 308},
  [15550] = {.lex_state = 0, .external_lex_state = 308},
  [15551] = {.lex_state = 0, .external_lex_state = 416},
  [15552] = {.lex_state = 47, .external_lex_state = 422},
  [15553] = {.lex_state = 47, .external_lex_state = 422},
  [15554] = {.lex_state = 0, .external_lex_state = 308},
  [15555] = {.lex_state = 1, .external_lex_state = 441},
  [15556] = {.lex_state = 0, .external_lex_state = 335},
  [15557] = {.lex_state = 51, .external_lex_state = 308},
  [15558] = {.lex_state = 50, .external_lex_state = 308},
  [15559] = {.lex_state = 0, .external_lex_state = 397},
  [15560] = {.lex_state = 0, .external_lex_state = 335},
  [15561] = {.lex_state = 47, .external_lex_state = 412},
  [15562] = {.lex_state = 0, .external_lex_state = 335},
  [15563] = {.lex_state = 0, .external_lex_state = 335},
  [15564] = {.lex_state = 0, .external_lex_state = 355},
  [15565] = {.lex_state = 0, .external_lex_state = 308},
  [15566] = {.lex_state = 0, .external_lex_state = 335},
  [15567] = {.lex_state = 0, .external_lex_state = 355},
  [15568] = {.lex_state = 0, .external_lex_state = 335},
  [15569] = {.lex_state = 0, .external_lex_state = 416},
  [15570] = {.lex_state = 0, .external_lex_state = 335},
  [15571] = {.lex_state = 0, .external_lex_state = 335},
  [15572] = {.lex_state = 0, .external_lex_state = 335},
  [15573] = {.lex_state = 0, .external_lex_state = 308},
  [15574] = {.lex_state = 0, .external_lex_state = 308},
  [15575] = {.lex_state = 0, .external_lex_state = 308},
  [15576] = {.lex_state = 0, .external_lex_state = 355},
  [15577] = {.lex_state = 0, .external_lex_state = 308},
  [15578] = {.lex_state = 0, .external_lex_state = 308},
  [15579] = {.lex_state = 0, .external_lex_state = 335},
  [15580] = {.lex_state = 0, .external_lex_state = 416},
  [15581] = {.lex_state = 0, .external_lex_state = 335},
  [15582] = {.lex_state = 47, .external_lex_state = 308},
  [15583] = {.lex_state = 0, .external_lex_state = 308},
  [15584] = {.lex_state = 0, .external_lex_state = 335},
  [15585] = {.lex_state = 0, .external_lex_state = 397},
  [15586] = {.lex_state = 51, .external_lex_state = 308},
  [15587] = {.lex_state = 0, .external_lex_state = 308},
  [15588] = {.lex_state = 0, .external_lex_state = 335},
  [15589] = {.lex_state = 0, .external_lex_state = 308},
  [15590] = {.lex_state = 0, .external_lex_state = 308},
  [15591] = {.lex_state = 0, .external_lex_state = 335},
  [15592] = {.lex_state = 0, .external_lex_state = 335},
  [15593] = {.lex_state = 0, .external_lex_state = 335},
  [15594] = {.lex_state = 0, .external_lex_state = 308},
  [15595] = {.lex_state = 0, .external_lex_state = 416},
  [15596] = {.lex_state = 0, .external_lex_state = 397},
  [15597] = {.lex_state = 0, .external_lex_state = 308},
  [15598] = {.lex_state = 0, .external_lex_state = 308},
  [15599] = {.lex_state = 1, .external_lex_state = 441},
  [15600] = {.lex_state = 0, .external_lex_state = 397},
  [15601] = {.lex_state = 1, .external_lex_state = 441},
  [15602] = {.lex_state = 0, .external_lex_state = 308},
  [15603] = {.lex_state = 0, .external_lex_state = 335},
  [15604] = {.lex_state = 0, .external_lex_state = 397},
  [15605] = {.lex_state = 0, .external_lex_state = 308},
  [15606] = {.lex_state = 1, .external_lex_state = 441},
  [15607] = {.lex_state = 0, .external_lex_state = 335},
  [15608] = {.lex_state = 0, .external_lex_state = 308},
  [15609] = {.lex_state = 0, .external_lex_state = 308},
  [15610] = {.lex_state = 0, .external_lex_state = 435},
  [15611] = {.lex_state = 0, .external_lex_state = 308},
  [15612] = {.lex_state = 0, .external_lex_state = 308},
  [15613] = {.lex_state = 0, .external_lex_state = 308},
  [15614] = {.lex_state = 1, .external_lex_state = 441},
  [15615] = {.lex_state = 0, .external_lex_state = 335},
  [15616] = {.lex_state = 1, .external_lex_state = 441},
  [15617] = {.lex_state = 0, .external_lex_state = 335},
  [15618] = {.lex_state = 0, .external_lex_state = 335},
  [15619] = {.lex_state = 0, .external_lex_state = 335},
  [15620] = {.lex_state = 0, .external_lex_state = 308},
  [15621] = {.lex_state = 51, .external_lex_state = 308},
  [15622] = {.lex_state = 0, .external_lex_state = 355},
  [15623] = {.lex_state = 1, .external_lex_state = 441},
  [15624] = {.lex_state = 0, .external_lex_state = 308},
  [15625] = {.lex_state = 1, .external_lex_state = 441},
  [15626] = {.lex_state = 0, .external_lex_state = 335},
  [15627] = {.lex_state = 0, .external_lex_state = 416},
  [15628] = {.lex_state = 0, .external_lex_state = 335},
  [15629] = {.lex_state = 0, .external_lex_state = 335},
  [15630] = {.lex_state = 0, .external_lex_state = 335},
  [15631] = {.lex_state = 0, .external_lex_state = 308},
  [15632] = {.lex_state = 0, .external_lex_state = 335},
  [15633] = {.lex_state = 0, .external_lex_state = 335},
  [15634] = {.lex_state = 0, .external_lex_state = 335},
  [15635] = {.lex_state = 0, .external_lex_state = 308},
  [15636] = {.lex_state = 51, .external_lex_state = 308},
  [15637] = {.lex_state = 0, .external_lex_state = 335},
  [15638] = {.lex_state = 0, .external_lex_state = 335},
  [15639] = {.lex_state = 0, .external_lex_state = 308},
  [15640] = {.lex_state = 0, .external_lex_state = 416},
  [15641] = {.lex_state = 0, .external_lex_state = 416},
  [15642] = {.lex_state = 0, .external_lex_state = 335},
  [15643] = {.lex_state = 0, .external_lex_state = 308},
  [15644] = {.lex_state = 1, .external_lex_state = 441},
  [15645] = {.lex_state = 0, .external_lex_state = 335},
  [15646] = {.lex_state = 51, .external_lex_state = 308},
  [15647] = {.lex_state = 0, .external_lex_state = 335},
  [15648] = {.lex_state = 0, .external_lex_state = 335},
  [15649] = {.lex_state = 0, .external_lex_state = 335},
  [15650] = {.lex_state = 1, .external_lex_state = 441},
  [15651] = {.lex_state = 0, .external_lex_state = 335},
  [15652] = {.lex_state = 51, .external_lex_state = 308},
  [15653] = {.lex_state = 0, .external_lex_state = 416},
  [15654] = {.lex_state = 0, .external_lex_state = 416},
  [15655] = {.lex_state = 0, .external_lex_state = 397},
  [15656] = {.lex_state = 0, .external_lex_state = 335},
  [15657] = {.lex_state = 0, .external_lex_state = 335},
  [15658] = {.lex_state = 0, .external_lex_state = 335},
  [15659] = {.lex_state = 0, .external_lex_state = 335},
  [15660] = {.lex_state = 0, .external_lex_state = 335},
  [15661] = {.lex_state = 0, .external_lex_state = 335},
  [15662] = {.lex_state = 0, .external_lex_state = 308},
  [15663] = {.lex_state = 0, .external_lex_state = 335},
  [15664] = {.lex_state = 0, .external_lex_state = 335},
  [15665] = {.lex_state = 0, .external_lex_state = 335},
  [15666] = {.lex_state = 50, .external_lex_state = 442},
  [15667] = {.lex_state = 0, .external_lex_state = 335},
  [15668] = {.lex_state = 0, .external_lex_state = 335},
  [15669] = {.lex_state = 0, .external_lex_state = 335},
  [15670] = {.lex_state = 0, .external_lex_state = 416},
  [15671] = {.lex_state = 0, .external_lex_state = 355},
  [15672] = {.lex_state = 0, .external_lex_state = 416},
  [15673] = {.lex_state = 0, .external_lex_state = 308},
  [15674] = {.lex_state = 0, .external_lex_state = 335},
  [15675] = {.lex_state = 0, .external_lex_state = 416},
  [15676] = {.lex_state = 0, .external_lex_state = 335},
  [15677] = {.lex_state = 51, .external_lex_state = 308},
  [15678] = {.lex_state = 0, .external_lex_state = 308},
  [15679] = {.lex_state = 0, .external_lex_state = 335},
  [15680] = {.lex_state = 0, .external_lex_state = 335},
  [15681] = {.lex_state = 51, .external_lex_state = 308},
  [15682] = {.lex_state = 0, .external_lex_state = 335},
  [15683] = {.lex_state = 0, .external_lex_state = 335},
  [15684] = {.lex_state = 0, .external_lex_state = 416},
  [15685] = {.lex_state = 0, .external_lex_state = 308},
  [15686] = {.lex_state = 0, .external_lex_state = 308},
  [15687] = {.lex_state = 0, .external_lex_state = 335},
  [15688] = {.lex_state = 0, .external_lex_state = 335},
  [15689] = {.lex_state = 0, .external_lex_state = 335},
  [15690] = {.lex_state = 0, .external_lex_state = 416},
  [15691] = {.lex_state = 0, .external_lex_state = 335},
  [15692] = {.lex_state = 0, .external_lex_state = 335},
  [15693] = {.lex_state = 0, .external_lex_state = 308},
  [15694] = {.lex_state = 0, .external_lex_state = 308},
  [15695] = {.lex_state = 0, .external_lex_state = 335},
  [15696] = {.lex_state = 51, .external_lex_state = 308},
  [15697] = {.lex_state = 0, .external_lex_state = 308},
  [15698] = {.lex_state = 0, .external_lex_state = 335},
  [15699] = {.lex_state = 0, .external_lex_state = 335},
  [15700] = {.lex_state = 0, .external_lex_state = 399},
  [15701] = {.lex_state = 0, .external_lex_state = 335},
  [15702] = {.lex_state = 0, .external_lex_state = 335},
  [15703] = {.lex_state = 1, .external_lex_state = 441},
  [15704] = {.lex_state = 0, .external_lex_state = 308},
  [15705] = {.lex_state = 0, .external_lex_state = 335},
  [15706] = {.lex_state = 0, .external_lex_state = 308},
  [15707] = {.lex_state = 0, .external_lex_state = 308},
  [15708] = {.lex_state = 0, .external_lex_state = 397},
  [15709] = {.lex_state = 0, .external_lex_state = 308},
  [15710] = {.lex_state = 0, .external_lex_state = 335},
  [15711] = {.lex_state = 0, .external_lex_state = 335},
  [15712] = {.lex_state = 0, .external_lex_state = 308},
  [15713] = {.lex_state = 0, .external_lex_state = 335},
  [15714] = {.lex_state = 0, .external_lex_state = 308},
  [15715] = {.lex_state = 0, .external_lex_state = 416},
  [15716] = {.lex_state = 0, .external_lex_state = 397},
  [15717] = {.lex_state = 0, .external_lex_state = 436},
  [15718] = {.lex_state = 1, .external_lex_state = 441},
  [15719] = {.lex_state = 47, .external_lex_state = 308},
  [15720] = {.lex_state = 1, .external_lex_state = 441},
  [15721] = {.lex_state = 0, .external_lex_state = 399},
  [15722] = {.lex_state = 0, .external_lex_state = 399},
  [15723] = {.lex_state = 0, .external_lex_state = 308},
  [15724] = {.lex_state = 0, .external_lex_state = 399},
  [15725] = {.lex_state = 0, .external_lex_state = 399},
  [15726] = {.lex_state = 0, .external_lex_state = 399},
  [15727] = {.lex_state = 0, .external_lex_state = 308},
  [15728] = {.lex_state = 0, .external_lex_state = 399},
  [15729] = {.lex_state = 0, .external_lex_state = 308},
  [15730] = {.lex_state = 0, .external_lex_state = 399},
  [15731] = {.lex_state = 0, .external_lex_state = 308},
  [15732] = {.lex_state = 0, .external_lex_state = 335},
  [15733] = {.lex_state = 0, .external_lex_state = 308},
  [15734] = {.lex_state = 0, .external_lex_state = 397},
  [15735] = {.lex_state = 0, .external_lex_state = 308},
  [15736] = {.lex_state = 0, .external_lex_state = 416},
  [15737] = {.lex_state = 0, .external_lex_state = 335},
  [15738] = {.lex_state = 0, .external_lex_state = 399},
  [15739] = {.lex_state = 0, .external_lex_state = 399},
  [15740] = {.lex_state = 0, .external_lex_state = 397},
  [15741] = {.lex_state = 0, .external_lex_state = 335},
  [15742] = {.lex_state = 0, .external_lex_state = 335},
  [15743] = {.lex_state = 0, .external_lex_state = 308},
  [15744] = {.lex_state = 0, .external_lex_state = 397},
  [15745] = {.lex_state = 1, .external_lex_state = 441},
  [15746] = {.lex_state = 0, .external_lex_state = 335},
  [15747] = {.lex_state = 51, .external_lex_state = 308},
  [15748] = {.lex_state = 51, .external_lex_state = 308},
  [15749] = {.lex_state = 0, .external_lex_state = 399},
  [15750] = {.lex_state = 0, .external_lex_state = 399},
  [15751] = {.lex_state = 0, .external_lex_state = 399},
  [15752] = {.lex_state = 0, .external_lex_state = 335},
  [15753] = {.lex_state = 0, .external_lex_state = 308},
  [15754] = {.lex_state = 0, .external_lex_state = 335},
  [15755] = {.lex_state = 0, .external_lex_state = 308},
  [15756] = {.lex_state = 0, .external_lex_state = 308},
  [15757] = {.lex_state = 47, .external_lex_state = 308},
  [15758] = {.lex_state = 0, .external_lex_state = 335},
  [15759] = {.lex_state = 0, .external_lex_state = 399},
  [15760] = {.lex_state = 0, .external_lex_state = 335},
  [15761] = {.lex_state = 0, .external_lex_state = 399},
  [15762] = {.lex_state = 0, .external_lex_state = 308},
  [15763] = {.lex_state = 0, .external_lex_state = 335},
  [15764] = {.lex_state = 0, .external_lex_state = 399},
  [15765] = {.lex_state = 0, .external_lex_state = 399},
  [15766] = {.lex_state = 0, .external_lex_state = 399},
  [15767] = {.lex_state = 0, .external_lex_state = 308},
  [15768] = {.lex_state = 0, .external_lex_state = 335},
  [15769] = {.lex_state = 0, .external_lex_state = 335},
  [15770] = {.lex_state = 0, .external_lex_state = 416},
  [15771] = {.lex_state = 0, .external_lex_state = 308},
  [15772] = {.lex_state = 0, .external_lex_state = 397},
  [15773] = {.lex_state = 0, .external_lex_state = 308},
  [15774] = {.lex_state = 0, .external_lex_state = 335},
  [15775] = {.lex_state = 0, .external_lex_state = 308},
  [15776] = {.lex_state = 51, .external_lex_state = 308},
  [15777] = {.lex_state = 0, .external_lex_state = 308},
  [15778] = {.lex_state = 0, .external_lex_state = 335},
  [15779] = {.lex_state = 1, .external_lex_state = 441},
  [15780] = {.lex_state = 0, .external_lex_state = 397},
  [15781] = {.lex_state = 0, .external_lex_state = 399},
  [15782] = {.lex_state = 0, .external_lex_state = 335},
  [15783] = {.lex_state = 0, .external_lex_state = 335},
  [15784] = {.lex_state = 1, .external_lex_state = 441},
  [15785] = {.lex_state = 0, .external_lex_state = 416},
  [15786] = {.lex_state = 1, .external_lex_state = 441},
  [15787] = {.lex_state = 0, .external_lex_state = 335},
  [15788] = {.lex_state = 0, .external_lex_state = 308},
  [15789] = {.lex_state = 0, .external_lex_state = 335},
  [15790] = {.lex_state = 0, .external_lex_state = 308},
  [15791] = {.lex_state = 0, .external_lex_state = 399},
  [15792] = {.lex_state = 0, .external_lex_state = 308},
  [15793] = {.lex_state = 0, .external_lex_state = 335},
  [15794] = {.lex_state = 1, .external_lex_state = 441},
  [15795] = {.lex_state = 0, .external_lex_state = 397},
  [15796] = {.lex_state = 0, .external_lex_state = 416},
  [15797] = {.lex_state = 0, .external_lex_state = 335},
  [15798] = {.lex_state = 1, .external_lex_state = 441},
  [15799] = {.lex_state = 0, .external_lex_state = 335},
  [15800] = {.lex_state = 0, .external_lex_state = 335},
  [15801] = {.lex_state = 0, .external_lex_state = 308},
  [15802] = {.lex_state = 51, .external_lex_state = 308},
  [15803] = {.lex_state = 0, .external_lex_state = 335},
  [15804] = {.lex_state = 0, .external_lex_state = 335},
  [15805] = {.lex_state = 0, .external_lex_state = 335},
  [15806] = {.lex_state = 0, .external_lex_state = 308},
  [15807] = {.lex_state = 0, .external_lex_state = 335},
  [15808] = {.lex_state = 0, .external_lex_state = 397},
  [15809] = {.lex_state = 0, .external_lex_state = 335},
  [15810] = {.lex_state = 0, .external_lex_state = 335},
  [15811] = {.lex_state = 0, .external_lex_state = 335},
  [15812] = {.lex_state = 0, .external_lex_state = 399},
  [15813] = {.lex_state = 1, .external_lex_state = 441},
  [15814] = {.lex_state = 0, .external_lex_state = 335},
  [15815] = {.lex_state = 1, .external_lex_state = 441},
  [15816] = {.lex_state = 0, .external_lex_state = 308},
  [15817] = {.lex_state = 0, .external_lex_state = 416},
  [15818] = {.lex_state = 0, .external_lex_state = 416},
  [15819] = {.lex_state = 0, .external_lex_state = 399},
  [15820] = {.lex_state = 0, .external_lex_state = 399},
  [15821] = {.lex_state = 0, .external_lex_state = 399},
  [15822] = {.lex_state = 0, .external_lex_state = 308},
  [15823] = {.lex_state = 0, .external_lex_state = 399},
  [15824] = {.lex_state = 0, .external_lex_state = 416},
  [15825] = {.lex_state = 0, .external_lex_state = 308},
  [15826] = {.lex_state = 47, .external_lex_state = 422},
  [15827] = {.lex_state = 0, .external_lex_state = 308},
  [15828] = {.lex_state = 0, .external_lex_state = 416},
  [15829] = {.lex_state = 0, .external_lex_state = 335},
  [15830] = {.lex_state = 0, .external_lex_state = 335},
  [15831] = {.lex_state = 0, .external_lex_state = 416},
  [15832] = {.lex_state = 0, .external_lex_state = 399},
  [15833] = {.lex_state = 0, .external_lex_state = 416},
  [15834] = {.lex_state = 0, .external_lex_state = 399},
  [15835] = {.lex_state = 51, .external_lex_state = 308},
  [15836] = {.lex_state = 47, .external_lex_state = 422},
  [15837] = {.lex_state = 0, .external_lex_state = 416},
  [15838] = {.lex_state = 47, .external_lex_state = 422},
  [15839] = {.lex_state = 0, .external_lex_state = 335},
  [15840] = {.lex_state = 1, .external_lex_state = 441},
  [15841] = {.lex_state = 0, .external_lex_state = 335},
  [15842] = {.lex_state = 51, .external_lex_state = 308},
  [15843] = {.lex_state = 0, .external_lex_state = 335},
  [15844] = {.lex_state = 0, .external_lex_state = 399},
  [15845] = {.lex_state = 0, .external_lex_state = 399},
  [15846] = {.lex_state = 0, .external_lex_state = 399},
  [15847] = {.lex_state = 0, .external_lex_state = 335},
  [15848] = {.lex_state = 47, .external_lex_state = 422},
  [15849] = {.lex_state = 0, .external_lex_state = 335},
  [15850] = {.lex_state = 0, .external_lex_state = 416},
  [15851] = {.lex_state = 0, .external_lex_state = 335},
  [15852] = {.lex_state = 0, .external_lex_state = 308},
  [15853] = {.lex_state = 0, .external_lex_state = 335},
  [15854] = {.lex_state = 0, .external_lex_state = 397},
  [15855] = {.lex_state = 0, .external_lex_state = 335},
  [15856] = {.lex_state = 0, .external_lex_state = 399},
  [15857] = {.lex_state = 0, .external_lex_state = 308},
  [15858] = {.lex_state = 0, .external_lex_state = 397},
  [15859] = {.lex_state = 0, .external_lex_state = 335},
  [15860] = {.lex_state = 0, .external_lex_state = 335},
  [15861] = {.lex_state = 0, .external_lex_state = 335},
  [15862] = {.lex_state = 0, .external_lex_state = 308},
  [15863] = {.lex_state = 0, .external_lex_state = 399},
  [15864] = {.lex_state = 0, .external_lex_state = 335},
  [15865] = {.lex_state = 0, .external_lex_state = 416},
  [15866] = {.lex_state = 0, .external_lex_state = 308},
  [15867] = {.lex_state = 0, .external_lex_state = 399},
  [15868] = {.lex_state = 0, .external_lex_state = 308},
  [15869] = {.lex_state = 0, .external_lex_state = 335},
  [15870] = {.lex_state = 0, .external_lex_state = 308},
  [15871] = {.lex_state = 51, .external_lex_state = 308},
  [15872] = {.lex_state = 0, .external_lex_state = 308},
  [15873] = {.lex_state = 0, .external_lex_state = 335},
  [15874] = {.lex_state = 0, .external_lex_state = 335},
  [15875] = {.lex_state = 0, .external_lex_state = 308},
  [15876] = {.lex_state = 0, .external_lex_state = 335},
  [15877] = {.lex_state = 0, .external_lex_state = 399},
  [15878] = {.lex_state = 0, .external_lex_state = 335},
  [15879] = {.lex_state = 1, .external_lex_state = 441},
  [15880] = {.lex_state = 0, .external_lex_state = 416},
  [15881] = {.lex_state = 1, .external_lex_state = 441},
  [15882] = {.lex_state = 0, .external_lex_state = 335},
  [15883] = {.lex_state = 0, .external_lex_state = 308},
  [15884] = {.lex_state = 0, .external_lex_state = 335},
  [15885] = {.lex_state = 0, .external_lex_state = 335},
  [15886] = {.lex_state = 0, .external_lex_state = 335},
  [15887] = {.lex_state = 0, .external_lex_state = 308},
  [15888] = {.lex_state = 0, .external_lex_state = 335},
  [15889] = {.lex_state = 0, .external_lex_state = 335},
  [15890] = {.lex_state = 0, .external_lex_state = 416},
  [15891] = {.lex_state = 0, .external_lex_state = 308},
  [15892] = {.lex_state = 0, .external_lex_state = 335},
  [15893] = {.lex_state = 0, .external_lex_state = 335},
  [15894] = {.lex_state = 0, .external_lex_state = 416},
  [15895] = {.lex_state = 0, .external_lex_state = 416},
  [15896] = {.lex_state = 0, .external_lex_state = 308},
  [15897] = {.lex_state = 0, .external_lex_state = 335},
  [15898] = {.lex_state = 1, .external_lex_state = 441},
  [15899] = {.lex_state = 0, .external_lex_state = 335},
  [15900] = {.lex_state = 51, .external_lex_state = 308},
  [15901] = {.lex_state = 0, .external_lex_state = 335},
  [15902] = {.lex_state = 0, .external_lex_state = 335},
  [15903] = {.lex_state = 0, .external_lex_state = 355},
  [15904] = {.lex_state = 0, .external_lex_state = 335},
  [15905] = {.lex_state = 0, .external_lex_state = 335},
  [15906] = {.lex_state = 0, .external_lex_state = 335},
  [15907] = {.lex_state = 0, .external_lex_state = 335},
  [15908] = {.lex_state = 1, .external_lex_state = 441},
  [15909] = {.lex_state = 0, .external_lex_state = 335},
  [15910] = {.lex_state = 1, .external_lex_state = 441},
  [15911] = {.lex_state = 0, .external_lex_state = 399},
  [15912] = {.lex_state = 51, .external_lex_state = 308},
  [15913] = {.lex_state = 0, .external_lex_state = 416},
  [15914] = {.lex_state = 0, .external_lex_state = 397},
  [15915] = {.lex_state = 0, .external_lex_state = 399},
  [15916] = {.lex_state = 0, .external_lex_state = 399},
  [15917] = {.lex_state = 0, .external_lex_state = 335},
  [15918] = {.lex_state = 0, .external_lex_state = 399},
  [15919] = {.lex_state = 0, .external_lex_state = 335},
  [15920] = {.lex_state = 0, .external_lex_state = 416},
  [15921] = {.lex_state = 0, .external_lex_state = 399},
  [15922] = {.lex_state = 0, .external_lex_state = 399},
  [15923] = {.lex_state = 0, .external_lex_state = 335},
  [15924] = {.lex_state = 0, .external_lex_state = 308},
  [15925] = {.lex_state = 0, .external_lex_state = 335},
  [15926] = {.lex_state = 0, .external_lex_state = 416},
  [15927] = {.lex_state = 51, .external_lex_state = 308},
  [15928] = {.lex_state = 0, .external_lex_state = 335},
  [15929] = {.lex_state = 0, .external_lex_state = 399},
  [15930] = {.lex_state = 0, .external_lex_state = 335},
  [15931] = {.lex_state = 0, .external_lex_state = 335},
  [15932] = {.lex_state = 0, .external_lex_state = 335},
  [15933] = {.lex_state = 51, .external_lex_state = 308},
  [15934] = {.lex_state = 0, .external_lex_state = 335},
  [15935] = {.lex_state = 1, .external_lex_state = 441},
  [15936] = {.lex_state = 0, .external_lex_state = 335},
  [15937] = {.lex_state = 51, .external_lex_state = 308},
  [15938] = {.lex_state = 0, .external_lex_state = 335},
  [15939] = {.lex_state = 0, .external_lex_state = 335},
  [15940] = {.lex_state = 0, .external_lex_state = 335},
  [15941] = {.lex_state = 0, .external_lex_state = 399},
  [15942] = {.lex_state = 0, .external_lex_state = 335},
  [15943] = {.lex_state = 0, .external_lex_state = 416},
  [15944] = {.lex_state = 1, .external_lex_state = 441},
  [15945] = {.lex_state = 0, .external_lex_state = 308},
  [15946] = {.lex_state = 0, .external_lex_state = 335},
  [15947] = {.lex_state = 0, .external_lex_state = 308},
  [15948] = {.lex_state = 0, .external_lex_state = 335},
  [15949] = {.lex_state = 0, .external_lex_state = 399},
  [15950] = {.lex_state = 0, .external_lex_state = 335},
  [15951] = {.lex_state = 0, .external_lex_state = 399},
  [15952] = {.lex_state = 0, .external_lex_state = 308},
  [15953] = {.lex_state = 0, .external_lex_state = 335},
  [15954] = {.lex_state = 0, .external_lex_state = 335},
  [15955] = {.lex_state = 0, .external_lex_state = 335},
  [15956] = {.lex_state = 0, .external_lex_state = 399},
  [15957] = {.lex_state = 0, .external_lex_state = 308},
  [15958] = {.lex_state = 0, .external_lex_state = 308},
  [15959] = {.lex_state = 0, .external_lex_state = 335},
  [15960] = {.lex_state = 0, .external_lex_state = 416},
  [15961] = {.lex_state = 50, .external_lex_state = 442},
  [15962] = {.lex_state = 1, .external_lex_state = 441},
  [15963] = {.lex_state = 0, .external_lex_state = 308},
  [15964] = {.lex_state = 0, .external_lex_state = 335},
  [15965] = {.lex_state = 1, .external_lex_state = 441},
  [15966] = {.lex_state = 51, .external_lex_state = 308},
  [15967] = {.lex_state = 0, .external_lex_state = 335},
  [15968] = {.lex_state = 0, .external_lex_state = 335},
  [15969] = {.lex_state = 0, .external_lex_state = 335},
  [15970] = {.lex_state = 0, .external_lex_state = 308},
  [15971] = {.lex_state = 0, .external_lex_state = 397},
  [15972] = {.lex_state = 0, .external_lex_state = 416},
  [15973] = {.lex_state = 0, .external_lex_state = 335},
  [15974] = {.lex_state = 0, .external_lex_state = 416},
  [15975] = {.lex_state = 0, .external_lex_state = 416},
  [15976] = {.lex_state = 0, .external_lex_state = 397},
  [15977] = {.lex_state = 1, .external_lex_state = 441},
  [15978] = {.lex_state = 0, .external_lex_state = 308},
  [15979] = {.lex_state = 0, .external_lex_state = 335},
  [15980] = {.lex_state = 51, .external_lex_state = 308},
  [15981] = {.lex_state = 0, .external_lex_state = 335},
  [15982] = {.lex_state = 0, .external_lex_state = 308},
  [15983] = {.lex_state = 0, .external_lex_state = 335},
  [15984] = {.lex_state = 0, .external_lex_state = 335},
  [15985] = {.lex_state = 0, .external_lex_state = 397},
  [15986] = {.lex_state = 0, .external_lex_state = 335},
  [15987] = {.lex_state = 0, .external_lex_state = 335},
  [15988] = {.lex_state = 0, .external_lex_state = 399},
  [15989] = {.lex_state = 0, .external_lex_state = 335},
  [15990] = {.lex_state = 0, .external_lex_state = 335},
  [15991] = {.lex_state = 0, .external_lex_state = 308},
  [15992] = {.lex_state = 0, .external_lex_state = 335},
  [15993] = {.lex_state = 0, .external_lex_state = 335},
  [15994] = {.lex_state = 0, .external_lex_state = 308},
  [15995] = {.lex_state = 0, .external_lex_state = 335},
  [15996] = {.lex_state = 47, .external_lex_state = 443},
  [15997] = {.lex_state = 0, .external_lex_state = 399},
  [15998] = {.lex_state = 0, .external_lex_state = 335},
  [15999] = {.lex_state = 0, .external_lex_state = 335},
  [16000] = {.lex_state = 1, .external_lex_state = 441},
  [16001] = {.lex_state = 0, .external_lex_state = 335},
  [16002] = {.lex_state = 1, .external_lex_state = 441},
  [16003] = {.lex_state = 1, .external_lex_state = 441},
  [16004] = {.lex_state = 0, .external_lex_state = 416},
  [16005] = {.lex_state = 1, .external_lex_state = 441},
  [16006] = {.lex_state = 47, .external_lex_state = 422},
  [16007] = {.lex_state = 0, .external_lex_state = 416},
  [16008] = {.lex_state = 0, .external_lex_state = 416},
  [16009] = {.lex_state = 0, .external_lex_state = 308},
  [16010] = {.lex_state = 0, .external_lex_state = 335},
  [16011] = {.lex_state = 0, .external_lex_state = 335},
  [16012] = {.lex_state = 47, .external_lex_state = 308},
  [16013] = {.lex_state = 0, .external_lex_state = 308},
  [16014] = {.lex_state = 0, .external_lex_state = 335},
  [16015] = {.lex_state = 0, .external_lex_state = 335},
  [16016] = {.lex_state = 0, .external_lex_state = 335},
  [16017] = {.lex_state = 0, .external_lex_state = 308},
  [16018] = {.lex_state = 0, .external_lex_state = 308},
  [16019] = {.lex_state = 51, .external_lex_state = 308},
  [16020] = {.lex_state = 0, .external_lex_state = 308},
  [16021] = {.lex_state = 0, .external_lex_state = 416},
  [16022] = {.lex_state = 0, .external_lex_state = 335},
  [16023] = {.lex_state = 0, .external_lex_state = 399},
  [16024] = {.lex_state = 0, .external_lex_state = 308},
  [16025] = {.lex_state = 0, .external_lex_state = 335},
  [16026] = {.lex_state = 0, .external_lex_state = 416},
  [16027] = {.lex_state = 0, .external_lex_state = 308},
  [16028] = {.lex_state = 0, .external_lex_state = 308},
  [16029] = {.lex_state = 0, .external_lex_state = 308},
  [16030] = {.lex_state = 1, .external_lex_state = 441},
  [16031] = {.lex_state = 0, .external_lex_state = 335},
  [16032] = {.lex_state = 51, .external_lex_state = 308},
  [16033] = {.lex_state = 0, .external_lex_state = 416},
  [16034] = {.lex_state = 0, .external_lex_state = 335},
  [16035] = {.lex_state = 0, .external_lex_state = 399},
  [16036] = {.lex_state = 0, .external_lex_state = 399},
  [16037] = {.lex_state = 0, .external_lex_state = 335},
  [16038] = {.lex_state = 0, .external_lex_state = 335},
  [16039] = {.lex_state = 0, .external_lex_state = 335},
  [16040] = {.lex_state = 0, .external_lex_state = 308},
  [16041] = {.lex_state = 0, .external_lex_state = 397},
  [16042] = {.lex_state = 0, .external_lex_state = 355},
  [16043] = {.lex_state = 0, .external_lex_state = 335},
  [16044] = {.lex_state = 0, .external_lex_state = 355},
  [16045] = {.lex_state = 0, .external_lex_state = 335},
  [16046] = {.lex_state = 0, .external_lex_state = 397},
  [16047] = {.lex_state = 1, .external_lex_state = 441},
  [16048] = {.lex_state = 0, .external_lex_state = 335},
  [16049] = {.lex_state = 0, .external_lex_state = 399},
  [16050] = {.lex_state = 0, .external_lex_state = 399},
  [16051] = {.lex_state = 1, .external_lex_state = 441},
  [16052] = {.lex_state = 0, .external_lex_state = 335},
  [16053] = {.lex_state = 51, .external_lex_state = 308},
  [16054] = {.lex_state = 0, .external_lex_state = 335},
  [16055] = {.lex_state = 0, .external_lex_state = 416},
  [16056] = {.lex_state = 0, .external_lex_state = 335},
  [16057] = {.lex_state = 0, .external_lex_state = 397},
  [16058] = {.lex_state = 0, .external_lex_state = 308},
  [16059] = {.lex_state = 0, .external_lex_state = 335},
  [16060] = {.lex_state = 0, .external_lex_state = 399},
  [16061] = {.lex_state = 51, .external_lex_state = 308},
  [16062] = {.lex_state = 0, .external_lex_state = 399},
  [16063] = {.lex_state = 0, .external_lex_state = 335},
  [16064] = {.lex_state = 0, .external_lex_state = 397},
  [16065] = {.lex_state = 0, .external_lex_state = 308},
  [16066] = {.lex_state = 0, .external_lex_state = 335},
  [16067] = {.lex_state = 0, .external_lex_state = 308},
  [16068] = {.lex_state = 0, .external_lex_state = 335},
  [16069] = {.lex_state = 50, .external_lex_state = 308},
  [16070] = {.lex_state = 0, .external_lex_state = 416},
  [16071] = {.lex_state = 0, .external_lex_state = 416},
  [16072] = {.lex_state = 0, .external_lex_state = 335},
  [16073] = {.lex_state = 0, .external_lex_state = 308},
  [16074] = {.lex_state = 0, .external_lex_state = 399},
  [16075] = {.lex_state = 0, .external_lex_state = 416},
  [16076] = {.lex_state = 0, .external_lex_state = 416},
  [16077] = {.lex_state = 0, .external_lex_state = 308},
  [16078] = {.lex_state = 0, .external_lex_state = 335},
  [16079] = {.lex_state = 1, .external_lex_state = 441},
  [16080] = {.lex_state = 0, .external_lex_state = 355},
  [16081] = {.lex_state = 47, .external_lex_state = 308},
  [16082] = {.lex_state = 0, .external_lex_state = 335},
  [16083] = {.lex_state = 0, .external_lex_state = 335},
  [16084] = {.lex_state = 47, .external_lex_state = 308},
  [16085] = {.lex_state = 0, .external_lex_state = 399},
  [16086] = {.lex_state = 0, .external_lex_state = 308},
  [16087] = {.lex_state = 0, .external_lex_state = 335},
  [16088] = {.lex_state = 0, .external_lex_state = 399},
  [16089] = {.lex_state = 51, .external_lex_state = 308},
  [16090] = {.lex_state = 0, .external_lex_state = 335},
  [16091] = {.lex_state = 0, .external_lex_state = 335},
  [16092] = {.lex_state = 0, .external_lex_state = 335},
  [16093] = {.lex_state = 0, .external_lex_state = 335},
  [16094] = {.lex_state = 0, .external_lex_state = 335},
  [16095] = {.lex_state = 0, .external_lex_state = 335},
  [16096] = {.lex_state = 0, .external_lex_state = 335},
  [16097] = {.lex_state = 0, .external_lex_state = 335},
  [16098] = {.lex_state = 1, .external_lex_state = 441},
  [16099] = {.lex_state = 0, .external_lex_state = 436},
  [16100] = {.lex_state = 1, .external_lex_state = 441},
  [16101] = {.lex_state = 0, .external_lex_state = 399},
  [16102] = {.lex_state = 0, .external_lex_state = 335},
  [16103] = {.lex_state = 0, .external_lex_state = 335},
  [16104] = {.lex_state = 47, .external_lex_state = 411},
  [16105] = {.lex_state = 0, .external_lex_state = 335},
  [16106] = {.lex_state = 51, .external_lex_state = 308},
  [16107] = {.lex_state = 0, .external_lex_state = 416},
  [16108] = {.lex_state = 0, .external_lex_state = 335},
  [16109] = {.lex_state = 0, .external_lex_state = 416},
  [16110] = {.lex_state = 0, .external_lex_state = 397},
  [16111] = {.lex_state = 1, .external_lex_state = 441},
  [16112] = {.lex_state = 0, .external_lex_state = 308},
  [16113] = {.lex_state = 0, .external_lex_state = 399},
  [16114] = {.lex_state = 0, .external_lex_state = 335},
  [16115] = {.lex_state = 0, .external_lex_state = 335},
  [16116] = {.lex_state = 0, .external_lex_state = 416},
  [16117] = {.lex_state = 0, .external_lex_state = 399},
  [16118] = {.lex_state = 0, .external_lex_state = 397},
  [16119] = {.lex_state = 0, .external_lex_state = 397},
  [16120] = {.lex_state = 0, .external_lex_state = 397},
  [16121] = {.lex_state = 51, .external_lex_state = 308},
  [16122] = {.lex_state = 0, .external_lex_state = 335},
  [16123] = {.lex_state = 0, .external_lex_state = 397},
  [16124] = {.lex_state = 0, .external_lex_state = 343},
  [16125] = {.lex_state = 1, .external_lex_state = 441},
  [16126] = {.lex_state = 0, .external_lex_state = 335},
  [16127] = {.lex_state = 51, .external_lex_state = 308},
  [16128] = {.lex_state = 0, .external_lex_state = 335},
  [16129] = {.lex_state = 0, .external_lex_state = 399},
  [16130] = {.lex_state = 0, .external_lex_state = 416},
  [16131] = {.lex_state = 0, .external_lex_state = 308},
  [16132] = {.lex_state = 0, .external_lex_state = 335},
  [16133] = {.lex_state = 0, .external_lex_state = 308},
  [16134] = {.lex_state = 0, .external_lex_state = 335},
  [16135] = {.lex_state = 0, .external_lex_state = 335},
  [16136] = {.lex_state = 0, .external_lex_state = 335},
  [16137] = {.lex_state = 0, .external_lex_state = 308},
  [16138] = {.lex_state = 0, .external_lex_state = 335},
  [16139] = {.lex_state = 0, .external_lex_state = 397},
  [16140] = {.lex_state = 0, .external_lex_state = 335},
  [16141] = {.lex_state = 0, .external_lex_state = 399},
  [16142] = {.lex_state = 0, .external_lex_state = 397},
  [16143] = {.lex_state = 0, .external_lex_state = 416},
  [16144] = {.lex_state = 0, .external_lex_state = 399},
  [16145] = {.lex_state = 0, .external_lex_state = 335},
  [16146] = {.lex_state = 1, .external_lex_state = 441},
  [16147] = {.lex_state = 1, .external_lex_state = 441},
  [16148] = {.lex_state = 0, .external_lex_state = 397},
  [16149] = {.lex_state = 0, .external_lex_state = 335},
  [16150] = {.lex_state = 0, .external_lex_state = 416},
  [16151] = {.lex_state = 0, .external_lex_state = 335},
  [16152] = {.lex_state = 0, .external_lex_state = 397},
  [16153] = {.lex_state = 0, .external_lex_state = 308},
  [16154] = {.lex_state = 0, .external_lex_state = 335},
  [16155] = {.lex_state = 0, .external_lex_state = 416},
  [16156] = {.lex_state = 51, .external_lex_state = 308},
  [16157] = {.lex_state = 1, .external_lex_state = 441},
  [16158] = {.lex_state = 0, .external_lex_state = 335},
  [16159] = {.lex_state = 50, .external_lex_state = 308},
  [16160] = {.lex_state = 50, .external_lex_state = 308},
  [16161] = {.lex_state = 51, .external_lex_state = 308},
  [16162] = {.lex_state = 0, .external_lex_state = 335},
  [16163] = {.lex_state = 0, .external_lex_state = 335},
  [16164] = {.lex_state = 0, .external_lex_state = 308},
  [16165] = {.lex_state = 0, .external_lex_state = 416},
  [16166] = {.lex_state = 0, .external_lex_state = 335},
  [16167] = {.lex_state = 51, .external_lex_state = 308},
  [16168] = {.lex_state = 0, .external_lex_state = 308},
  [16169] = {.lex_state = 0, .external_lex_state = 335},
  [16170] = {.lex_state = 0, .external_lex_state = 335},
  [16171] = {.lex_state = 0, .external_lex_state = 335},
  [16172] = {.lex_state = 0, .external_lex_state = 308},
  [16173] = {.lex_state = 0, .external_lex_state = 335},
  [16174] = {.lex_state = 0, .external_lex_state = 397},
  [16175] = {.lex_state = 0, .external_lex_state = 335},
  [16176] = {.lex_state = 0, .external_lex_state = 397},
  [16177] = {.lex_state = 0, .external_lex_state = 335},
  [16178] = {.lex_state = 1, .external_lex_state = 441},
  [16179] = {.lex_state = 47, .external_lex_state = 443},
  [16180] = {.lex_state = 1, .external_lex_state = 441},
  [16181] = {.lex_state = 0, .external_lex_state = 308},
  [16182] = {.lex_state = 0, .external_lex_state = 399},
  [16183] = {.lex_state = 0, .external_lex_state = 335},
  [16184] = {.lex_state = 0, .external_lex_state = 335},
  [16185] = {.lex_state = 0, .external_lex_state = 416},
  [16186] = {.lex_state = 0, .external_lex_state = 416},
  [16187] = {.lex_state = 0, .external_lex_state = 399},
  [16188] = {.lex_state = 0, .external_lex_state = 308},
  [16189] = {.lex_state = 0, .external_lex_state = 335},
  [16190] = {.lex_state = 0, .external_lex_state = 335},
  [16191] = {.lex_state = 51, .external_lex_state = 308},
  [16192] = {.lex_state = 0, .external_lex_state = 335},
  [16193] = {.lex_state = 1, .external_lex_state = 441},
  [16194] = {.lex_state = 0, .external_lex_state = 335},
  [16195] = {.lex_state = 1, .external_lex_state = 441},
  [16196] = {.lex_state = 0, .external_lex_state = 399},
  [16197] = {.lex_state = 0, .external_lex_state = 335},
  [16198] = {.lex_state = 0, .external_lex_state = 335},
  [16199] = {.lex_state = 0, .external_lex_state = 399},
  [16200] = {.lex_state = 0, .external_lex_state = 399},
  [16201] = {.lex_state = 0, .external_lex_state = 308},
  [16202] = {.lex_state = 0, .external_lex_state = 416},
  [16203] = {.lex_state = 0, .external_lex_state = 335},
  [16204] = {.lex_state = 0, .external_lex_state = 335},
  [16205] = {.lex_state = 0, .external_lex_state = 399},
  [16206] = {.lex_state = 0, .external_lex_state = 399},
  [16207] = {.lex_state = 0, .external_lex_state = 335},
  [16208] = {.lex_state = 0, .external_lex_state = 399},
  [16209] = {.lex_state = 0, .external_lex_state = 308},
  [16210] = {.lex_state = 0, .external_lex_state = 397},
  [16211] = {.lex_state = 0, .external_lex_state = 416},
  [16212] = {.lex_state = 0, .external_lex_state = 308},
  [16213] = {.lex_state = 0, .external_lex_state = 308},
  [16214] = {.lex_state = 0, .external_lex_state = 397},
  [16215] = {.lex_state = 0, .external_lex_state = 335},
  [16216] = {.lex_state = 0, .external_lex_state = 335},
  [16217] = {.lex_state = 0, .external_lex_state = 335},
  [16218] = {.lex_state = 0, .external_lex_state = 308},
  [16219] = {.lex_state = 0, .external_lex_state = 308},
  [16220] = {.lex_state = 1, .external_lex_state = 441},
  [16221] = {.lex_state = 0, .external_lex_state = 335},
  [16222] = {.lex_state = 51, .external_lex_state = 308},
  [16223] = {.lex_state = 0, .external_lex_state = 308},
  [16224] = {.lex_state = 0, .external_lex_state = 355},
  [16225] = {.lex_state = 0, .external_lex_state = 399},
  [16226] = {.lex_state = 0, .external_lex_state = 416},
  [16227] = {.lex_state = 0, .external_lex_state = 335},
  [16228] = {.lex_state = 0, .external_lex_state = 399},
  [16229] = {.lex_state = 0, .external_lex_state = 416},
  [16230] = {.lex_state = 51, .external_lex_state = 308},
  [16231] = {.lex_state = 0, .external_lex_state = 397},
  [16232] = {.lex_state = 0, .external_lex_state = 335},
  [16233] = {.lex_state = 0, .external_lex_state = 335},
  [16234] = {.lex_state = 47, .external_lex_state = 411},
  [16235] = {.lex_state = 0, .external_lex_state = 335},
  [16236] = {.lex_state = 47, .external_lex_state = 411},
  [16237] = {.lex_state = 1, .external_lex_state = 441},
  [16238] = {.lex_state = 0, .external_lex_state = 335},
  [16239] = {.lex_state = 47, .external_lex_state = 308},
  [16240] = {.lex_state = 0, .external_lex_state = 335},
  [16241] = {.lex_state = 0, .external_lex_state = 399},
  [16242] = {.lex_state = 1, .external_lex_state = 441},
  [16243] = {.lex_state = 0, .external_lex_state = 335},
  [16244] = {.lex_state = 0, .external_lex_state = 335},
  [16245] = {.lex_state = 0, .external_lex_state = 416},
  [16246] = {.lex_state = 0, .external_lex_state = 335},
  [16247] = {.lex_state = 0, .external_lex_state = 188},
  [16248] = {.lex_state = 0, .external_lex_state = 308},
  [16249] = {.lex_state = 0, .external_lex_state = 335},
  [16250] = {.lex_state = 47, .external_lex_state = 411},
  [16251] = {.lex_state = 51, .external_lex_state = 308},
  [16252] = {.lex_state = 47, .external_lex_state = 411},
  [16253] = {.lex_state = 0, .external_lex_state = 335},
  [16254] = {.lex_state = 0, .external_lex_state = 308},
  [16255] = {.lex_state = 0, .external_lex_state = 416},
  [16256] = {.lex_state = 0, .external_lex_state = 397},
  [16257] = {.lex_state = 0, .external_lex_state = 399},
  [16258] = {.lex_state = 0, .external_lex_state = 335},
  [16259] = {.lex_state = 0, .external_lex_state = 335},
  [16260] = {.lex_state = 0, .external_lex_state = 416},
  [16261] = {.lex_state = 51, .external_lex_state = 308},
  [16262] = {.lex_state = 0, .external_lex_state = 335},
  [16263] = {.lex_state = 0, .external_lex_state = 308},
  [16264] = {.lex_state = 0, .external_lex_state = 335},
  [16265] = {.lex_state = 0, .external_lex_state = 335},
  [16266] = {.lex_state = 0, .external_lex_state = 308},
  [16267] = {.lex_state = 0, .external_lex_state = 308},
  [16268] = {.lex_state = 0, .external_lex_state = 335},
  [16269] = {.lex_state = 0, .external_lex_state = 397},
  [16270] = {.lex_state = 0, .external_lex_state = 416},
  [16271] = {.lex_state = 0, .external_lex_state = 399},
  [16272] = {.lex_state = 0, .external_lex_state = 335},
  [16273] = {.lex_state = 0, .external_lex_state = 416},
  [16274] = {.lex_state = 0, .external_lex_state = 335},
  [16275] = {.lex_state = 47, .external_lex_state = 308},
  [16276] = {.lex_state = 0, .external_lex_state = 308},
  [16277] = {.lex_state = 0, .external_lex_state = 335},
  [16278] = {.lex_state = 47, .external_lex_state = 308},
  [16279] = {.lex_state = 0, .external_lex_state = 308},
  [16280] = {.lex_state = 0, .external_lex_state = 335},
  [16281] = {.lex_state = 0, .external_lex_state = 335},
  [16282] = {.lex_state = 0, .external_lex_state = 335},
  [16283] = {.lex_state = 0, .external_lex_state = 335},
  [16284] = {.lex_state = 0, .external_lex_state = 308},
  [16285] = {.lex_state = 0, .external_lex_state = 416},
  [16286] = {.lex_state = 0, .external_lex_state = 416},
  [16287] = {.lex_state = 0, .external_lex_state = 335},
  [16288] = {.lex_state = 1, .external_lex_state = 441},
  [16289] = {.lex_state = 0, .external_lex_state = 335},
  [16290] = {.lex_state = 1, .external_lex_state = 441},
  [16291] = {.lex_state = 47, .external_lex_state = 411},
  [16292] = {.lex_state = 0, .external_lex_state = 335},
  [16293] = {.lex_state = 0, .external_lex_state = 308},
  [16294] = {.lex_state = 51, .external_lex_state = 308},
  [16295] = {.lex_state = 0, .external_lex_state = 399},
  [16296] = {.lex_state = 47, .external_lex_state = 411},
  [16297] = {.lex_state = 0, .external_lex_state = 335},
  [16298] = {.lex_state = 0, .external_lex_state = 335},
  [16299] = {.lex_state = 0, .external_lex_state = 335},
  [16300] = {.lex_state = 0, .external_lex_state = 335},
  [16301] = {.lex_state = 1, .external_lex_state = 441},
  [16302] = {.lex_state = 51, .external_lex_state = 308},
  [16303] = {.lex_state = 0, .external_lex_state = 335},
  [16304] = {.lex_state = 0, .external_lex_state = 397},
  [16305] = {.lex_state = 0, .external_lex_state = 308},
  [16306] = {.lex_state = 0, .external_lex_state = 416},
  [16307] = {.lex_state = 47, .external_lex_state = 308},
  [16308] = {.lex_state = 47, .external_lex_state = 308},
  [16309] = {.lex_state = 0, .external_lex_state = 399},
  [16310] = {.lex_state = 0, .external_lex_state = 343},
  [16311] = {.lex_state = 0, .external_lex_state = 335},
  [16312] = {.lex_state = 0, .external_lex_state = 308},
  [16313] = {.lex_state = 0, .external_lex_state = 416},
  [16314] = {.lex_state = 0, .external_lex_state = 335},
  [16315] = {.lex_state = 1, .external_lex_state = 441},
  [16316] = {.lex_state = 0, .external_lex_state = 335},
  [16317] = {.lex_state = 51, .external_lex_state = 308},
  [16318] = {.lex_state = 0, .external_lex_state = 308},
  [16319] = {.lex_state = 0, .external_lex_state = 399},
  [16320] = {.lex_state = 0, .external_lex_state = 308},
  [16321] = {.lex_state = 0, .external_lex_state = 308},
  [16322] = {.lex_state = 0, .external_lex_state = 335},
  [16323] = {.lex_state = 0, .external_lex_state = 335},
  [16324] = {.lex_state = 0, .external_lex_state = 335},
  [16325] = {.lex_state = 0, .external_lex_state = 335},
  [16326] = {.lex_state = 0, .external_lex_state = 308},
  [16327] = {.lex_state = 47, .external_lex_state = 422},
  [16328] = {.lex_state = 0, .external_lex_state = 335},
  [16329] = {.lex_state = 0, .external_lex_state = 416},
  [16330] = {.lex_state = 0, .external_lex_state = 335},
  [16331] = {.lex_state = 1, .external_lex_state = 441},
  [16332] = {.lex_state = 1, .external_lex_state = 441},
  [16333] = {.lex_state = 1, .external_lex_state = 441},
  [16334] = {.lex_state = 0, .external_lex_state = 399},
  [16335] = {.lex_state = 0, .external_lex_state = 399},
  [16336] = {.lex_state = 0, .external_lex_state = 335},
  [16337] = {.lex_state = 0, .external_lex_state = 413},
  [16338] = {.lex_state = 0, .external_lex_state = 308},
  [16339] = {.lex_state = 47, .external_lex_state = 411},
  [16340] = {.lex_state = 0, .external_lex_state = 416},
  [16341] = {.lex_state = 0, .external_lex_state = 335},
  [16342] = {.lex_state = 0, .external_lex_state = 308},
  [16343] = {.lex_state = 0, .external_lex_state = 308},
  [16344] = {.lex_state = 0, .external_lex_state = 335},
  [16345] = {.lex_state = 0, .external_lex_state = 308},
  [16346] = {.lex_state = 51, .external_lex_state = 308},
  [16347] = {.lex_state = 0, .external_lex_state = 308},
  [16348] = {.lex_state = 0, .external_lex_state = 335},
  [16349] = {.lex_state = 0, .external_lex_state = 416},
  [16350] = {.lex_state = 0, .external_lex_state = 397},
  [16351] = {.lex_state = 47, .external_lex_state = 443},
  [16352] = {.lex_state = 0, .external_lex_state = 416},
  [16353] = {.lex_state = 0, .external_lex_state = 335},
  [16354] = {.lex_state = 0, .external_lex_state = 397},
  [16355] = {.lex_state = 0, .external_lex_state = 416},
  [16356] = {.lex_state = 1, .external_lex_state = 441},
  [16357] = {.lex_state = 0, .external_lex_state = 335},
  [16358] = {.lex_state = 0, .external_lex_state = 308},
  [16359] = {.lex_state = 0, .external_lex_state = 399},
  [16360] = {.lex_state = 0, .external_lex_state = 397},
  [16361] = {.lex_state = 0, .external_lex_state = 335},
  [16362] = {.lex_state = 0, .external_lex_state = 308},
  [16363] = {.lex_state = 0, .external_lex_state = 335},
  [16364] = {.lex_state = 0, .external_lex_state = 308},
  [16365] = {.lex_state = 0, .external_lex_state = 335},
  [16366] = {.lex_state = 0, .external_lex_state = 399},
  [16367] = {.lex_state = 0, .external_lex_state = 335},
  [16368] = {.lex_state = 47, .external_lex_state = 308},
  [16369] = {.lex_state = 47, .external_lex_state = 308},
  [16370] = {.lex_state = 0, .external_lex_state = 397},
  [16371] = {.lex_state = 0, .external_lex_state = 308},
  [16372] = {.lex_state = 0, .external_lex_state = 343},
  [16373] = {.lex_state = 47, .external_lex_state = 308},
  [16374] = {.lex_state = 0, .external_lex_state = 335},
  [16375] = {.lex_state = 0, .external_lex_state = 335},
  [16376] = {.lex_state = 1, .external_lex_state = 441},
  [16377] = {.lex_state = 0, .external_lex_state = 399},
  [16378] = {.lex_state = 0, .external_lex_state = 335},
  [16379] = {.lex_state = 1, .external_lex_state = 441},
  [16380] = {.lex_state = 47, .external_lex_state = 308},
  [16381] = {.lex_state = 47, .external_lex_state = 308},
  [16382] = {.lex_state = 0, .external_lex_state = 399},
  [16383] = {.lex_state = 1, .external_lex_state = 441},
  [16384] = {.lex_state = 51, .external_lex_state = 308},
  [16385] = {.lex_state = 1, .external_lex_state = 441},
  [16386] = {.lex_state = 0, .external_lex_state = 399},
  [16387] = {.lex_state = 0, .external_lex_state = 399},
  [16388] = {.lex_state = 0, .external_lex_state = 308},
  [16389] = {.lex_state = 0, .external_lex_state = 335},
  [16390] = {.lex_state = 0, .external_lex_state = 399},
  [16391] = {.lex_state = 0, .external_lex_state = 308},
  [16392] = {.lex_state = 0, .external_lex_state = 335},
  [16393] = {.lex_state = 0, .external_lex_state = 413},
  [16394] = {.lex_state = 0, .external_lex_state = 416},
  [16395] = {.lex_state = 0, .external_lex_state = 416},
  [16396] = {.lex_state = 0, .external_lex_state = 399},
  [16397] = {.lex_state = 0, .external_lex_state = 399},
  [16398] = {.lex_state = 0, .external_lex_state = 397},
  [16399] = {.lex_state = 0, .external_lex_state = 335},
  [16400] = {.lex_state = 0, .external_lex_state = 308},
  [16401] = {.lex_state = 0, .external_lex_state = 416},
  [16402] = {.lex_state = 0, .external_lex_state = 335},
  [16403] = {.lex_state = 0, .external_lex_state = 399},
  [16404] = {.lex_state = 0, .external_lex_state = 335},
  [16405] = {.lex_state = 0, .external_lex_state = 335},
  [16406] = {.lex_state = 51, .external_lex_state = 308},
  [16407] = {.lex_state = 0, .external_lex_state = 308},
  [16408] = {.lex_state = 0, .external_lex_state = 335},
  [16409] = {.lex_state = 0, .external_lex_state = 335},
  [16410] = {.lex_state = 1, .external_lex_state = 441},
  [16411] = {.lex_state = 0, .external_lex_state = 335},
  [16412] = {.lex_state = 51, .external_lex_state = 308},
  [16413] = {.lex_state = 0, .external_lex_state = 335},
  [16414] = {.lex_state = 0, .external_lex_state = 308},
  [16415] = {.lex_state = 0, .external_lex_state = 399},
  [16416] = {.lex_state = 1, .external_lex_state = 441},
  [16417] = {.lex_state = 0, .external_lex_state = 335},
  [16418] = {.lex_state = 1, .external_lex_state = 441},
  [16419] = {.lex_state = 47, .external_lex_state = 443},
  [16420] = {.lex_state = 1, .external_lex_state = 441},
  [16421] = {.lex_state = 0, .external_lex_state = 335},
  [16422] = {.lex_state = 1, .external_lex_state = 441},
  [16423] = {.lex_state = 0, .external_lex_state = 335},
  [16424] = {.lex_state = 0, .external_lex_state = 335},
  [16425] = {.lex_state = 0, .external_lex_state = 335},
  [16426] = {.lex_state = 0, .external_lex_state = 399},
  [16427] = {.lex_state = 1, .external_lex_state = 441},
  [16428] = {.lex_state = 0, .external_lex_state = 335},
  [16429] = {.lex_state = 0, .external_lex_state = 335},
  [16430] = {.lex_state = 0, .external_lex_state = 335},
  [16431] = {.lex_state = 0, .external_lex_state = 308},
  [16432] = {.lex_state = 1, .external_lex_state = 441},
  [16433] = {.lex_state = 0, .external_lex_state = 335},
  [16434] = {.lex_state = 47, .external_lex_state = 308},
  [16435] = {.lex_state = 0, .external_lex_state = 416},
  [16436] = {.lex_state = 1, .external_lex_state = 441},
  [16437] = {.lex_state = 1, .external_lex_state = 441},
  [16438] = {.lex_state = 0, .external_lex_state = 308},
  [16439] = {.lex_state = 0, .external_lex_state = 335},
  [16440] = {.lex_state = 0, .external_lex_state = 416},
  [16441] = {.lex_state = 51, .external_lex_state = 308},
  [16442] = {.lex_state = 1, .external_lex_state = 441},
  [16443] = {.lex_state = 0, .external_lex_state = 335},
  [16444] = {.lex_state = 0, .external_lex_state = 335},
  [16445] = {.lex_state = 1, .external_lex_state = 441},
  [16446] = {.lex_state = 0, .external_lex_state = 397},
  [16447] = {.lex_state = 0, .external_lex_state = 308},
  [16448] = {.lex_state = 0, .external_lex_state = 335},
  [16449] = {.lex_state = 1, .external_lex_state = 441},
  [16450] = {.lex_state = 0, .external_lex_state = 416},
  [16451] = {.lex_state = 0, .external_lex_state = 308},
  [16452] = {.lex_state = 1, .external_lex_state = 441},
  [16453] = {.lex_state = 0, .external_lex_state = 308},
  [16454] = {.lex_state = 0, .external_lex_state = 416},
  [16455] = {.lex_state = 0, .external_lex_state = 335},
  [16456] = {.lex_state = 0, .external_lex_state = 335},
  [16457] = {.lex_state = 0, .external_lex_state = 308},
  [16458] = {.lex_state = 0, .external_lex_state = 335},
  [16459] = {.lex_state = 1, .external_lex_state = 441},
  [16460] = {.lex_state = 0, .external_lex_state = 399},
  [16461] = {.lex_state = 1, .external_lex_state = 441},
  [16462] = {.lex_state = 0, .external_lex_state = 335},
  [16463] = {.lex_state = 1, .external_lex_state = 441},
  [16464] = {.lex_state = 0, .external_lex_state = 308},
  [16465] = {.lex_state = 0, .external_lex_state = 335},
  [16466] = {.lex_state = 0, .external_lex_state = 308},
  [16467] = {.lex_state = 0, .external_lex_state = 399},
  [16468] = {.lex_state = 0, .external_lex_state = 335},
  [16469] = {.lex_state = 1, .external_lex_state = 441},
  [16470] = {.lex_state = 1, .external_lex_state = 441},
  [16471] = {.lex_state = 51, .external_lex_state = 308},
  [16472] = {.lex_state = 0, .external_lex_state = 335},
  [16473] = {.lex_state = 0, .external_lex_state = 335},
  [16474] = {.lex_state = 0, .external_lex_state = 335},
  [16475] = {.lex_state = 0, .external_lex_state = 308},
  [16476] = {.lex_state = 1, .external_lex_state = 441},
  [16477] = {.lex_state = 0, .external_lex_state = 416},
  [16478] = {.lex_state = 1, .external_lex_state = 441},
  [16479] = {.lex_state = 0, .external_lex_state = 416},
  [16480] = {.lex_state = 1, .external_lex_state = 441},
  [16481] = {.lex_state = 0, .external_lex_state = 399},
  [16482] = {.lex_state = 51, .external_lex_state = 308},
  [16483] = {.lex_state = 0, .external_lex_state = 335},
  [16484] = {.lex_state = 1, .external_lex_state = 441},
  [16485] = {.lex_state = 1, .external_lex_state = 441},
  [16486] = {.lex_state = 0, .external_lex_state = 335},
  [16487] = {.lex_state = 47, .external_lex_state = 308},
  [16488] = {.lex_state = 0, .external_lex_state = 335},
  [16489] = {.lex_state = 0, .external_lex_state = 335},
  [16490] = {.lex_state = 1, .external_lex_state = 441},
  [16491] = {.lex_state = 0, .external_lex_state = 308},
  [16492] = {.lex_state = 0, .external_lex_state = 335},
  [16493] = {.lex_state = 0, .external_lex_state = 335},
  [16494] = {.lex_state = 1, .external_lex_state = 441},
  [16495] = {.lex_state = 1, .external_lex_state = 441},
  [16496] = {.lex_state = 0, .external_lex_state = 416},
  [16497] = {.lex_state = 0, .external_lex_state = 335},
  [16498] = {.lex_state = 47, .external_lex_state = 308},
  [16499] = {.lex_state = 0, .external_lex_state = 416},
  [16500] = {.lex_state = 1, .external_lex_state = 441},
  [16501] = {.lex_state = 0, .external_lex_state = 335},
  [16502] = {.lex_state = 1, .external_lex_state = 441},
  [16503] = {.lex_state = 1, .external_lex_state = 441},
  [16504] = {.lex_state = 1, .external_lex_state = 441},
  [16505] = {.lex_state = 1, .external_lex_state = 441},
  [16506] = {.lex_state = 0, .external_lex_state = 335},
  [16507] = {.lex_state = 51, .external_lex_state = 308},
  [16508] = {.lex_state = 0, .external_lex_state = 335},
  [16509] = {.lex_state = 0, .external_lex_state = 335},
  [16510] = {.lex_state = 1, .external_lex_state = 441},
  [16511] = {.lex_state = 47, .external_lex_state = 412},
  [16512] = {.lex_state = 0, .external_lex_state = 335},
  [16513] = {.lex_state = 1, .external_lex_state = 441},
  [16514] = {.lex_state = 0, .external_lex_state = 335},
  [16515] = {.lex_state = 1, .external_lex_state = 441},
  [16516] = {.lex_state = 0, .external_lex_state = 335},
  [16517] = {.lex_state = 0, .external_lex_state = 335},
  [16518] = {.lex_state = 0, .external_lex_state = 335},
  [16519] = {.lex_state = 1, .external_lex_state = 441},
  [16520] = {.lex_state = 0, .external_lex_state = 335},
  [16521] = {.lex_state = 1, .external_lex_state = 441},
  [16522] = {.lex_state = 1, .external_lex_state = 441},
  [16523] = {.lex_state = 0, .external_lex_state = 335},
  [16524] = {.lex_state = 47, .external_lex_state = 411},
  [16525] = {.lex_state = 1, .external_lex_state = 441},
  [16526] = {.lex_state = 1, .external_lex_state = 441},
  [16527] = {.lex_state = 0, .external_lex_state = 335},
  [16528] = {.lex_state = 1, .external_lex_state = 441},
  [16529] = {.lex_state = 1, .external_lex_state = 441},
  [16530] = {.lex_state = 0, .external_lex_state = 416},
  [16531] = {.lex_state = 1, .external_lex_state = 441},
  [16532] = {.lex_state = 0, .external_lex_state = 335},
  [16533] = {.lex_state = 0, .external_lex_state = 308},
  [16534] = {.lex_state = 0, .external_lex_state = 335},
  [16535] = {.lex_state = 1, .external_lex_state = 441},
  [16536] = {.lex_state = 51, .external_lex_state = 308},
  [16537] = {.lex_state = 1, .external_lex_state = 441},
  [16538] = {.lex_state = 0, .external_lex_state = 335},
  [16539] = {.lex_state = 0, .external_lex_state = 335},
  [16540] = {.lex_state = 1, .external_lex_state = 441},
  [16541] = {.lex_state = 0, .external_lex_state = 335},
  [16542] = {.lex_state = 0, .external_lex_state = 335},
  [16543] = {.lex_state = 0, .external_lex_state = 335},
  [16544] = {.lex_state = 1, .external_lex_state = 441},
  [16545] = {.lex_state = 0, .external_lex_state = 416},
  [16546] = {.lex_state = 1, .external_lex_state = 441},
  [16547] = {.lex_state = 0, .external_lex_state = 308},
  [16548] = {.lex_state = 0, .external_lex_state = 308},
  [16549] = {.lex_state = 1, .external_lex_state = 441},
  [16550] = {.lex_state = 0, .external_lex_state = 335},
  [16551] = {.lex_state = 0, .external_lex_state = 416},
  [16552] = {.lex_state = 0, .external_lex_state = 308},
  [16553] = {.lex_state = 0, .external_lex_state = 335},
  [16554] = {.lex_state = 1, .external_lex_state = 441},
  [16555] = {.lex_state = 1, .external_lex_state = 441},
  [16556] = {.lex_state = 1, .external_lex_state = 441},
  [16557] = {.lex_state = 0, .external_lex_state = 335},
  [16558] = {.lex_state = 0, .external_lex_state = 335},
  [16559] = {.lex_state = 1, .external_lex_state = 441},
  [16560] = {.lex_state = 1, .external_lex_state = 441},
  [16561] = {.lex_state = 0, .external_lex_state = 308},
  [16562] = {.lex_state = 1, .external_lex_state = 441},
  [16563] = {.lex_state = 0, .external_lex_state = 416},
  [16564] = {.lex_state = 0, .external_lex_state = 335},
  [16565] = {.lex_state = 1, .external_lex_state = 441},
  [16566] = {.lex_state = 1, .external_lex_state = 441},
  [16567] = {.lex_state = 1, .external_lex_state = 441},
  [16568] = {.lex_state = 1, .external_lex_state = 441},
  [16569] = {.lex_state = 0, .external_lex_state = 335},
  [16570] = {.lex_state = 1, .external_lex_state = 441},
  [16571] = {.lex_state = 47, .external_lex_state = 308},
  [16572] = {.lex_state = 47, .external_lex_state = 411},
  [16573] = {.lex_state = 1, .external_lex_state = 441},
  [16574] = {.lex_state = 1, .external_lex_state = 441},
  [16575] = {.lex_state = 1, .external_lex_state = 441},
  [16576] = {.lex_state = 1, .external_lex_state = 441},
  [16577] = {.lex_state = 0, .external_lex_state = 335},
  [16578] = {.lex_state = 1, .external_lex_state = 441},
  [16579] = {.lex_state = 0, .external_lex_state = 335},
  [16580] = {.lex_state = 0, .external_lex_state = 335},
  [16581] = {.lex_state = 0, .external_lex_state = 335},
  [16582] = {.lex_state = 1, .external_lex_state = 441},
  [16583] = {.lex_state = 0, .external_lex_state = 335},
  [16584] = {.lex_state = 1, .external_lex_state = 441},
  [16585] = {.lex_state = 1, .external_lex_state = 441},
  [16586] = {.lex_state = 51, .external_lex_state = 308},
  [16587] = {.lex_state = 0, .external_lex_state = 335},
  [16588] = {.lex_state = 1, .external_lex_state = 441},
  [16589] = {.lex_state = 0, .external_lex_state = 335},
  [16590] = {.lex_state = 1, .external_lex_state = 441},
  [16591] = {.lex_state = 0, .external_lex_state = 416},
  [16592] = {.lex_state = 0, .external_lex_state = 399},
  [16593] = {.lex_state = 0, .external_lex_state = 335},
  [16594] = {.lex_state = 1, .external_lex_state = 441},
  [16595] = {.lex_state = 1, .external_lex_state = 441},
  [16596] = {.lex_state = 0, .external_lex_state = 335},
  [16597] = {.lex_state = 0, .external_lex_state = 335},
  [16598] = {.lex_state = 1, .external_lex_state = 441},
  [16599] = {.lex_state = 1, .external_lex_state = 441},
  [16600] = {.lex_state = 1, .external_lex_state = 441},
  [16601] = {.lex_state = 0, .external_lex_state = 335},
  [16602] = {.lex_state = 51, .external_lex_state = 308},
  [16603] = {.lex_state = 1, .external_lex_state = 441},
  [16604] = {.lex_state = 1, .external_lex_state = 441},
  [16605] = {.lex_state = 0, .external_lex_state = 435},
  [16606] = {.lex_state = 0, .external_lex_state = 399},
  [16607] = {.lex_state = 0, .external_lex_state = 335},
  [16608] = {.lex_state = 0, .external_lex_state = 335},
  [16609] = {.lex_state = 1, .external_lex_state = 441},
  [16610] = {.lex_state = 0, .external_lex_state = 335},
  [16611] = {.lex_state = 1, .external_lex_state = 441},
  [16612] = {.lex_state = 1, .external_lex_state = 441},
  [16613] = {.lex_state = 0, .external_lex_state = 335},
  [16614] = {.lex_state = 0, .external_lex_state = 335},
  [16615] = {.lex_state = 0, .external_lex_state = 335},
  [16616] = {.lex_state = 50, .external_lex_state = 308},
  [16617] = {.lex_state = 0, .external_lex_state = 335},
  [16618] = {.lex_state = 1, .external_lex_state = 441},
  [16619] = {.lex_state = 0, .external_lex_state = 399},
  [16620] = {.lex_state = 1, .external_lex_state = 441},
  [16621] = {.lex_state = 0, .external_lex_state = 399},
  [16622] = {.lex_state = 1, .external_lex_state = 441},
  [16623] = {.lex_state = 0, .external_lex_state = 335},
  [16624] = {.lex_state = 1, .external_lex_state = 441},
  [16625] = {.lex_state = 0, .external_lex_state = 416},
  [16626] = {.lex_state = 0, .external_lex_state = 308},
  [16627] = {.lex_state = 0, .external_lex_state = 416},
  [16628] = {.lex_state = 0, .external_lex_state = 308},
  [16629] = {.lex_state = 0, .external_lex_state = 335},
  [16630] = {.lex_state = 0, .external_lex_state = 416},
  [16631] = {.lex_state = 51, .external_lex_state = 308},
  [16632] = {.lex_state = 1, .external_lex_state = 441},
  [16633] = {.lex_state = 0, .external_lex_state = 335},
  [16634] = {.lex_state = 1, .external_lex_state = 441},
  [16635] = {.lex_state = 0, .external_lex_state = 308},
  [16636] = {.lex_state = 0, .external_lex_state = 335},
  [16637] = {.lex_state = 0, .external_lex_state = 416},
  [16638] = {.lex_state = 0, .external_lex_state = 335},
  [16639] = {.lex_state = 0, .external_lex_state = 335},
  [16640] = {.lex_state = 0, .external_lex_state = 416},
  [16641] = {.lex_state = 0, .external_lex_state = 399},
  [16642] = {.lex_state = 0, .external_lex_state = 335},
  [16643] = {.lex_state = 0, .external_lex_state = 308},
  [16644] = {.lex_state = 0, .external_lex_state = 335},
  [16645] = {.lex_state = 0, .external_lex_state = 308},
  [16646] = {.lex_state = 0, .external_lex_state = 335},
  [16647] = {.lex_state = 0, .external_lex_state = 308},
  [16648] = {.lex_state = 0, .external_lex_state = 335},
  [16649] = {.lex_state = 0, .external_lex_state = 308},
  [16650] = {.lex_state = 0, .external_lex_state = 399},
  [16651] = {.lex_state = 0, .external_lex_state = 335},
  [16652] = {.lex_state = 0, .external_lex_state = 335},
  [16653] = {.lex_state = 0, .external_lex_state = 399},
  [16654] = {.lex_state = 0, .external_lex_state = 416},
  [16655] = {.lex_state = 0, .external_lex_state = 399},
  [16656] = {.lex_state = 0, .external_lex_state = 308},
  [16657] = {.lex_state = 0, .external_lex_state = 335},
  [16658] = {.lex_state = 1, .external_lex_state = 441},
  [16659] = {.lex_state = 0, .external_lex_state = 335},
  [16660] = {.lex_state = 1, .external_lex_state = 441},
  [16661] = {.lex_state = 0, .external_lex_state = 335},
  [16662] = {.lex_state = 0, .external_lex_state = 399},
  [16663] = {.lex_state = 0, .external_lex_state = 335},
  [16664] = {.lex_state = 1, .external_lex_state = 441},
  [16665] = {.lex_state = 0, .external_lex_state = 416},
  [16666] = {.lex_state = 0, .external_lex_state = 335},
  [16667] = {.lex_state = 50, .external_lex_state = 442},
  [16668] = {.lex_state = 1, .external_lex_state = 441},
  [16669] = {.lex_state = 0, .external_lex_state = 335},
  [16670] = {.lex_state = 1, .external_lex_state = 441},
  [16671] = {.lex_state = 51, .external_lex_state = 308},
  [16672] = {.lex_state = 0, .external_lex_state = 335},
  [16673] = {.lex_state = 0, .external_lex_state = 335},
  [16674] = {.lex_state = 0, .external_lex_state = 399},
  [16675] = {.lex_state = 0, .external_lex_state = 335},
  [16676] = {.lex_state = 0, .external_lex_state = 335},
  [16677] = {.lex_state = 0, .external_lex_state = 308},
  [16678] = {.lex_state = 0, .external_lex_state = 335},
  [16679] = {.lex_state = 0, .external_lex_state = 416},
  [16680] = {.lex_state = 0, .external_lex_state = 416},
  [16681] = {.lex_state = 0, .external_lex_state = 335},
  [16682] = {.lex_state = 1, .external_lex_state = 441},
  [16683] = {.lex_state = 0, .external_lex_state = 397},
  [16684] = {.lex_state = 0, .external_lex_state = 335},
  [16685] = {.lex_state = 0, .external_lex_state = 335},
  [16686] = {.lex_state = 0, .external_lex_state = 416},
  [16687] = {.lex_state = 50, .external_lex_state = 308},
  [16688] = {.lex_state = 0, .external_lex_state = 399},
  [16689] = {.lex_state = 1, .external_lex_state = 441},
  [16690] = {.lex_state = 0, .external_lex_state = 416},
  [16691] = {.lex_state = 1, .external_lex_state = 441},
  [16692] = {.lex_state = 0, .external_lex_state = 416},
  [16693] = {.lex_state = 0, .external_lex_state = 335},
  [16694] = {.lex_state = 0, .external_lex_state = 308},
  [16695] = {.lex_state = 1, .external_lex_state = 441},
  [16696] = {.lex_state = 0, .external_lex_state = 335},
  [16697] = {.lex_state = 51, .external_lex_state = 308},
  [16698] = {.lex_state = 0, .external_lex_state = 335},
  [16699] = {.lex_state = 0, .external_lex_state = 335},
  [16700] = {.lex_state = 0, .external_lex_state = 335},
  [16701] = {.lex_state = 0, .external_lex_state = 399},
  [16702] = {.lex_state = 0, .external_lex_state = 335},
  [16703] = {.lex_state = 0, .external_lex_state = 335},
  [16704] = {.lex_state = 0, .external_lex_state = 335},
  [16705] = {.lex_state = 1, .external_lex_state = 441},
  [16706] = {.lex_state = 0, .external_lex_state = 308},
  [16707] = {.lex_state = 0, .external_lex_state = 335},
  [16708] = {.lex_state = 0, .external_lex_state = 335},
  [16709] = {.lex_state = 0, .external_lex_state = 335},
  [16710] = {.lex_state = 0, .external_lex_state = 335},
  [16711] = {.lex_state = 1, .external_lex_state = 441},
  [16712] = {.lex_state = 0, .external_lex_state = 335},
  [16713] = {.lex_state = 0, .external_lex_state = 335},
  [16714] = {.lex_state = 0, .external_lex_state = 335},
  [16715] = {.lex_state = 1, .external_lex_state = 441},
  [16716] = {.lex_state = 0, .external_lex_state = 335},
  [16717] = {.lex_state = 0, .external_lex_state = 308},
  [16718] = {.lex_state = 51, .external_lex_state = 308},
  [16719] = {.lex_state = 0, .external_lex_state = 416},
  [16720] = {.lex_state = 0, .external_lex_state = 416},
  [16721] = {.lex_state = 0, .external_lex_state = 188},
  [16722] = {.lex_state = 0, .external_lex_state = 335},
  [16723] = {.lex_state = 0, .external_lex_state = 308},
  [16724] = {.lex_state = 0, .external_lex_state = 335},
  [16725] = {.lex_state = 0, .external_lex_state = 335},
  [16726] = {.lex_state = 51, .external_lex_state = 308},
  [16727] = {.lex_state = 0, .external_lex_state = 335},
  [16728] = {.lex_state = 0, .external_lex_state = 335},
  [16729] = {.lex_state = 0, .external_lex_state = 335},
  [16730] = {.lex_state = 1, .external_lex_state = 441},
  [16731] = {.lex_state = 0, .external_lex_state = 335},
  [16732] = {.lex_state = 0, .external_lex_state = 335},
  [16733] = {.lex_state = 0, .external_lex_state = 335},
  [16734] = {.lex_state = 0, .external_lex_state = 308},
  [16735] = {.lex_state = 0, .external_lex_state = 416},
  [16736] = {.lex_state = 47, .external_lex_state = 308},
  [16737] = {.lex_state = 51, .external_lex_state = 308},
  [16738] = {.lex_state = 0, .external_lex_state = 308},
  [16739] = {.lex_state = 1, .external_lex_state = 441},
  [16740] = {.lex_state = 1, .external_lex_state = 441},
  [16741] = {.lex_state = 1, .external_lex_state = 441},
  [16742] = {.lex_state = 0, .external_lex_state = 308},
  [16743] = {.lex_state = 0, .external_lex_state = 335},
  [16744] = {.lex_state = 0, .external_lex_state = 416},
  [16745] = {.lex_state = 0, .external_lex_state = 335},
  [16746] = {.lex_state = 47, .external_lex_state = 411},
  [16747] = {.lex_state = 0, .external_lex_state = 335},
  [16748] = {.lex_state = 0, .external_lex_state = 335},
  [16749] = {.lex_state = 0, .external_lex_state = 416},
  [16750] = {.lex_state = 0, .external_lex_state = 335},
  [16751] = {.lex_state = 0, .external_lex_state = 308},
  [16752] = {.lex_state = 0, .external_lex_state = 335},
  [16753] = {.lex_state = 1, .external_lex_state = 441},
  [16754] = {.lex_state = 0, .external_lex_state = 397},
  [16755] = {.lex_state = 1, .external_lex_state = 441},
  [16756] = {.lex_state = 47, .external_lex_state = 411},
  [16757] = {.lex_state = 1, .external_lex_state = 441},
  [16758] = {.lex_state = 1, .external_lex_state = 441},
  [16759] = {.lex_state = 0, .external_lex_state = 335},
  [16760] = {.lex_state = 0, .external_lex_state = 335},
  [16761] = {.lex_state = 1, .external_lex_state = 441},
  [16762] = {.lex_state = 0, .external_lex_state = 355},
  [16763] = {.lex_state = 1, .external_lex_state = 441},
  [16764] = {.lex_state = 1, .external_lex_state = 441},
  [16765] = {.lex_state = 1, .external_lex_state = 441},
  [16766] = {.lex_state = 47, .external_lex_state = 411},
  [16767] = {.lex_state = 0, .external_lex_state = 416},
  [16768] = {.lex_state = 0, .external_lex_state = 335},
  [16769] = {.lex_state = 0, .external_lex_state = 335},
  [16770] = {.lex_state = 1, .external_lex_state = 441},
  [16771] = {.lex_state = 0, .external_lex_state = 399},
  [16772] = {.lex_state = 0, .external_lex_state = 399},
  [16773] = {.lex_state = 0, .external_lex_state = 335},
  [16774] = {.lex_state = 0, .external_lex_state = 335},
  [16775] = {.lex_state = 1, .external_lex_state = 441},
  [16776] = {.lex_state = 47, .external_lex_state = 411},
  [16777] = {.lex_state = 47, .external_lex_state = 308},
  [16778] = {.lex_state = 0, .external_lex_state = 335},
  [16779] = {.lex_state = 0, .external_lex_state = 308},
  [16780] = {.lex_state = 1, .external_lex_state = 441},
  [16781] = {.lex_state = 0, .external_lex_state = 416},
  [16782] = {.lex_state = 1, .external_lex_state = 441},
  [16783] = {.lex_state = 0, .external_lex_state = 308},
  [16784] = {.lex_state = 0, .external_lex_state = 416},
  [16785] = {.lex_state = 0, .external_lex_state = 335},
  [16786] = {.lex_state = 0, .external_lex_state = 416},
  [16787] = {.lex_state = 0, .external_lex_state = 335},
  [16788] = {.lex_state = 0, .external_lex_state = 335},
  [16789] = {.lex_state = 0, .external_lex_state = 335},
  [16790] = {.lex_state = 1, .external_lex_state = 441},
  [16791] = {.lex_state = 0, .external_lex_state = 335},
  [16792] = {.lex_state = 51, .external_lex_state = 308},
  [16793] = {.lex_state = 0, .external_lex_state = 335},
  [16794] = {.lex_state = 1, .external_lex_state = 441},
  [16795] = {.lex_state = 0, .external_lex_state = 335},
  [16796] = {.lex_state = 0, .external_lex_state = 399},
  [16797] = {.lex_state = 0, .external_lex_state = 335},
  [16798] = {.lex_state = 0, .external_lex_state = 397},
  [16799] = {.lex_state = 0, .external_lex_state = 335},
  [16800] = {.lex_state = 1, .external_lex_state = 441},
  [16801] = {.lex_state = 1, .external_lex_state = 441},
  [16802] = {.lex_state = 1, .external_lex_state = 441},
  [16803] = {.lex_state = 0, .external_lex_state = 335},
  [16804] = {.lex_state = 0, .external_lex_state = 308},
  [16805] = {.lex_state = 0, .external_lex_state = 335},
  [16806] = {.lex_state = 50, .external_lex_state = 442},
  [16807] = {.lex_state = 0, .external_lex_state = 416},
  [16808] = {.lex_state = 0, .external_lex_state = 355},
  [16809] = {.lex_state = 0, .external_lex_state = 399},
  [16810] = {.lex_state = 0, .external_lex_state = 399},
  [16811] = {.lex_state = 0, .external_lex_state = 399},
  [16812] = {.lex_state = 0, .external_lex_state = 335},
  [16813] = {.lex_state = 0, .external_lex_state = 335},
  [16814] = {.lex_state = 0, .external_lex_state = 308},
  [16815] = {.lex_state = 0, .external_lex_state = 416},
  [16816] = {.lex_state = 0, .external_lex_state = 335},
  [16817] = {.lex_state = 0, .external_lex_state = 335},
  [16818] = {.lex_state = 0, .external_lex_state = 308},
  [16819] = {.lex_state = 0, .external_lex_state = 335},
  [16820] = {.lex_state = 0, .external_lex_state = 335},
  [16821] = {.lex_state = 51, .external_lex_state = 308},
  [16822] = {.lex_state = 1, .external_lex_state = 441},
  [16823] = {.lex_state = 0, .external_lex_state = 335},
  [16824] = {.lex_state = 0, .external_lex_state = 335},
  [16825] = {.lex_state = 51, .external_lex_state = 308},
  [16826] = {.lex_state = 0, .external_lex_state = 416},
  [16827] = {.lex_state = 0, .external_lex_state = 335},
  [16828] = {.lex_state = 0, .external_lex_state = 335},
  [16829] = {.lex_state = 0, .external_lex_state = 335},
  [16830] = {.lex_state = 0, .external_lex_state = 416},
  [16831] = {.lex_state = 0, .external_lex_state = 335},
  [16832] = {.lex_state = 1, .external_lex_state = 441},
  [16833] = {.lex_state = 0, .external_lex_state = 308},
  [16834] = {.lex_state = 0, .external_lex_state = 335},
  [16835] = {.lex_state = 1, .external_lex_state = 441},
  [16836] = {.lex_state = 50, .external_lex_state = 308},
  [16837] = {.lex_state = 0, .external_lex_state = 308},
  [16838] = {.lex_state = 0, .external_lex_state = 335},
  [16839] = {.lex_state = 0, .external_lex_state = 335},
  [16840] = {.lex_state = 0, .external_lex_state = 416},
  [16841] = {.lex_state = 51, .external_lex_state = 308},
  [16842] = {.lex_state = 0, .external_lex_state = 335},
  [16843] = {.lex_state = 0, .external_lex_state = 335},
  [16844] = {.lex_state = 0, .external_lex_state = 335},
  [16845] = {.lex_state = 0, .external_lex_state = 335},
  [16846] = {.lex_state = 0, .external_lex_state = 308},
  [16847] = {.lex_state = 0, .external_lex_state = 308},
  [16848] = {.lex_state = 0, .external_lex_state = 335},
  [16849] = {.lex_state = 0, .external_lex_state = 335},
  [16850] = {.lex_state = 0, .external_lex_state = 335},
  [16851] = {.lex_state = 0, .external_lex_state = 416},
  [16852] = {.lex_state = 0, .external_lex_state = 399},
  [16853] = {.lex_state = 0, .external_lex_state = 416},
  [16854] = {.lex_state = 1, .external_lex_state = 441},
  [16855] = {.lex_state = 0, .external_lex_state = 397},
  [16856] = {.lex_state = 0, .external_lex_state = 335},
  [16857] = {.lex_state = 0, .external_lex_state = 335},
  [16858] = {.lex_state = 1, .external_lex_state = 441},
  [16859] = {.lex_state = 0, .external_lex_state = 335},
  [16860] = {.lex_state = 1, .external_lex_state = 441},
  [16861] = {.lex_state = 0, .external_lex_state = 335},
  [16862] = {.lex_state = 0, .external_lex_state = 335},
  [16863] = {.lex_state = 1, .external_lex_state = 441},
  [16864] = {.lex_state = 0, .external_lex_state = 335},
  [16865] = {.lex_state = 1, .external_lex_state = 441},
  [16866] = {.lex_state = 0, .external_lex_state = 335},
  [16867] = {.lex_state = 0, .external_lex_state = 335},
  [16868] = {.lex_state = 0, .external_lex_state = 335},
  [16869] = {.lex_state = 51, .external_lex_state = 308},
  [16870] = {.lex_state = 0, .external_lex_state = 416},
  [16871] = {.lex_state = 0, .external_lex_state = 335},
  [16872] = {.lex_state = 0, .external_lex_state = 335},
  [16873] = {.lex_state = 1, .external_lex_state = 441},
  [16874] = {.lex_state = 0, .external_lex_state = 397},
  [16875] = {.lex_state = 0, .external_lex_state = 335},
  [16876] = {.lex_state = 0, .external_lex_state = 416},
  [16877] = {.lex_state = 0, .external_lex_state = 335},
  [16878] = {.lex_state = 0, .external_lex_state = 335},
  [16879] = {.lex_state = 1, .external_lex_state = 441},
  [16880] = {.lex_state = 0, .external_lex_state = 416},
  [16881] = {.lex_state = 0, .external_lex_state = 416},
  [16882] = {.lex_state = 0, .external_lex_state = 335},
  [16883] = {.lex_state = 0, .external_lex_state = 308},
  [16884] = {.lex_state = 0, .external_lex_state = 335},
  [16885] = {.lex_state = 1, .external_lex_state = 441},
  [16886] = {.lex_state = 0, .external_lex_state = 335},
  [16887] = {.lex_state = 51, .external_lex_state = 308},
  [16888] = {.lex_state = 1, .external_lex_state = 441},
  [16889] = {.lex_state = 47, .external_lex_state = 411},
  [16890] = {.lex_state = 0, .external_lex_state = 335},
  [16891] = {.lex_state = 0, .external_lex_state = 416},
  [16892] = {.lex_state = 0, .external_lex_state = 335},
  [16893] = {.lex_state = 1, .external_lex_state = 441},
  [16894] = {.lex_state = 0, .external_lex_state = 399},
  [16895] = {.lex_state = 0, .external_lex_state = 416},
  [16896] = {.lex_state = 0, .external_lex_state = 335},
  [16897] = {.lex_state = 0, .external_lex_state = 399},
  [16898] = {.lex_state = 0, .external_lex_state = 335},
  [16899] = {.lex_state = 0, .external_lex_state = 335},
  [16900] = {.lex_state = 0, .external_lex_state = 335},
  [16901] = {.lex_state = 0, .external_lex_state = 335},
  [16902] = {.lex_state = 0, .external_lex_state = 335},
  [16903] = {.lex_state = 1, .external_lex_state = 441},
  [16904] = {.lex_state = 0, .external_lex_state = 308},
  [16905] = {.lex_state = 0, .external_lex_state = 399},
  [16906] = {.lex_state = 0, .external_lex_state = 397},
  [16907] = {.lex_state = 51, .external_lex_state = 308},
  [16908] = {.lex_state = 0, .external_lex_state = 335},
  [16909] = {.lex_state = 0, .external_lex_state = 335},
  [16910] = {.lex_state = 0, .external_lex_state = 416},
  [16911] = {.lex_state = 1, .external_lex_state = 441},
  [16912] = {.lex_state = 0, .external_lex_state = 335},
  [16913] = {.lex_state = 0, .external_lex_state = 308},
  [16914] = {.lex_state = 0, .external_lex_state = 335},
  [16915] = {.lex_state = 1, .external_lex_state = 441},
  [16916] = {.lex_state = 51, .external_lex_state = 308},
  [16917] = {.lex_state = 0, .external_lex_state = 416},
  [16918] = {.lex_state = 0, .external_lex_state = 335},
  [16919] = {.lex_state = 0, .external_lex_state = 335},
  [16920] = {.lex_state = 0, .external_lex_state = 335},
  [16921] = {.lex_state = 0, .external_lex_state = 335},
  [16922] = {.lex_state = 1, .external_lex_state = 441},
  [16923] = {.lex_state = 0, .external_lex_state = 335},
  [16924] = {.lex_state = 0, .external_lex_state = 335},
  [16925] = {.lex_state = 0, .external_lex_state = 416},
  [16926] = {.lex_state = 0, .external_lex_state = 335},
  [16927] = {.lex_state = 1, .external_lex_state = 441},
  [16928] = {.lex_state = 0, .external_lex_state = 308},
  [16929] = {.lex_state = 0, .external_lex_state = 399},
  [16930] = {.lex_state = 1, .external_lex_state = 441},
  [16931] = {.lex_state = 0, .external_lex_state = 397},
  [16932] = {.lex_state = 0, .external_lex_state = 308},
  [16933] = {.lex_state = 0, .external_lex_state = 335},
  [16934] = {.lex_state = 0, .external_lex_state = 397},
  [16935] = {.lex_state = 0, .external_lex_state = 399},
  [16936] = {.lex_state = 0, .external_lex_state = 399},
  [16937] = {.lex_state = 0, .external_lex_state = 335},
  [16938] = {.lex_state = 0, .external_lex_state = 397},
  [16939] = {.lex_state = 0, .external_lex_state = 397},
  [16940] = {.lex_state = 0, .external_lex_state = 397},
  [16941] = {.lex_state = 0, .external_lex_state = 308},
  [16942] = {.lex_state = 0, .external_lex_state = 397},
  [16943] = {.lex_state = 0, .external_lex_state = 397},
  [16944] = {.lex_state = 47, .external_lex_state = 308},
  [16945] = {.lex_state = 0, .external_lex_state = 416},
  [16946] = {.lex_state = 0, .external_lex_state = 397},
  [16947] = {.lex_state = 0, .external_lex_state = 397},
  [16948] = {.lex_state = 0, .external_lex_state = 397},
  [16949] = {.lex_state = 1, .external_lex_state = 441},
  [16950] = {.lex_state = 0, .external_lex_state = 308},
  [16951] = {.lex_state = 0, .external_lex_state = 397},
  [16952] = {.lex_state = 0, .external_lex_state = 399},
  [16953] = {.lex_state = 1, .external_lex_state = 441},
  [16954] = {.lex_state = 1, .external_lex_state = 441},
  [16955] = {.lex_state = 1, .external_lex_state = 441},
  [16956] = {.lex_state = 0, .external_lex_state = 416},
  [16957] = {.lex_state = 0, .external_lex_state = 399},
  [16958] = {.lex_state = 0, .external_lex_state = 335},
  [16959] = {.lex_state = 0, .external_lex_state = 399},
  [16960] = {.lex_state = 0, .external_lex_state = 308},
  [16961] = {.lex_state = 0, .external_lex_state = 335},
  [16962] = {.lex_state = 0, .external_lex_state = 335},
  [16963] = {.lex_state = 0, .external_lex_state = 308},
  [16964] = {.lex_state = 0, .external_lex_state = 308},
  [16965] = {.lex_state = 0, .external_lex_state = 397},
  [16966] = {.lex_state = 0, .external_lex_state = 335},
  [16967] = {.lex_state = 0, .external_lex_state = 397},
  [16968] = {.lex_state = 0, .external_lex_state = 335},
  [16969] = {.lex_state = 0, .external_lex_state = 335},
  [16970] = {.lex_state = 1, .external_lex_state = 441},
  [16971] = {.lex_state = 0, .external_lex_state = 416},
  [16972] = {.lex_state = 0, .external_lex_state = 397},
  [16973] = {.lex_state = 0, .external_lex_state = 399},
  [16974] = {.lex_state = 0, .external_lex_state = 397},
  [16975] = {.lex_state = 0, .external_lex_state = 335},
  [16976] = {.lex_state = 0, .external_lex_state = 335},
  [16977] = {.lex_state = 0, .external_lex_state = 308},
  [16978] = {.lex_state = 1, .external_lex_state = 441},
  [16979] = {.lex_state = 1, .external_lex_state = 441},
  [16980] = {.lex_state = 1, .external_lex_state = 441},
  [16981] = {.lex_state = 0, .external_lex_state = 335},
  [16982] = {.lex_state = 51, .external_lex_state = 308},
  [16983] = {.lex_state = 0, .external_lex_state = 335},
  [16984] = {.lex_state = 0, .external_lex_state = 416},
  [16985] = {.lex_state = 0, .external_lex_state = 397},
  [16986] = {.lex_state = 0, .external_lex_state = 397},
  [16987] = {.lex_state = 0, .external_lex_state = 335},
  [16988] = {.lex_state = 0, .external_lex_state = 335},
  [16989] = {.lex_state = 0, .external_lex_state = 335},
  [16990] = {.lex_state = 0, .external_lex_state = 397},
  [16991] = {.lex_state = 0, .external_lex_state = 335},
  [16992] = {.lex_state = 0, .external_lex_state = 335},
  [16993] = {.lex_state = 0, .external_lex_state = 335},
  [16994] = {.lex_state = 0, .external_lex_state = 397},
  [16995] = {.lex_state = 0, .external_lex_state = 335},
  [16996] = {.lex_state = 0, .external_lex_state = 397},
  [16997] = {.lex_state = 0, .external_lex_state = 335},
  [16998] = {.lex_state = 0, .external_lex_state = 308},
  [16999] = {.lex_state = 0, .external_lex_state = 397},
  [17000] = {.lex_state = 0, .external_lex_state = 397},
  [17001] = {.lex_state = 0, .external_lex_state = 397},
  [17002] = {.lex_state = 1, .external_lex_state = 441},
  [17003] = {.lex_state = 0, .external_lex_state = 397},
  [17004] = {.lex_state = 0, .external_lex_state = 308},
  [17005] = {.lex_state = 0, .external_lex_state = 416},
  [17006] = {.lex_state = 0, .external_lex_state = 335},
  [17007] = {.lex_state = 0, .external_lex_state = 399},
  [17008] = {.lex_state = 0, .external_lex_state = 308},
  [17009] = {.lex_state = 0, .external_lex_state = 335},
  [17010] = {.lex_state = 1, .external_lex_state = 441},
  [17011] = {.lex_state = 51, .external_lex_state = 308},
  [17012] = {.lex_state = 1, .external_lex_state = 441},
  [17013] = {.lex_state = 0, .external_lex_state = 335},
  [17014] = {.lex_state = 1, .external_lex_state = 441},
  [17015] = {.lex_state = 0, .external_lex_state = 416},
  [17016] = {.lex_state = 0, .external_lex_state = 399},
  [17017] = {.lex_state = 0, .external_lex_state = 335},
  [17018] = {.lex_state = 0, .external_lex_state = 335},
  [17019] = {.lex_state = 0, .external_lex_state = 308},
  [17020] = {.lex_state = 0, .external_lex_state = 416},
  [17021] = {.lex_state = 0, .external_lex_state = 416},
  [17022] = {.lex_state = 0, .external_lex_state = 335},
  [17023] = {.lex_state = 0, .external_lex_state = 308},
  [17024] = {.lex_state = 0, .external_lex_state = 399},
  [17025] = {.lex_state = 0, .external_lex_state = 416},
  [17026] = {.lex_state = 0, .external_lex_state = 397},
  [17027] = {.lex_state = 0, .external_lex_state = 308},
  [17028] = {.lex_state = 0, .external_lex_state = 335},
  [17029] = {.lex_state = 0, .external_lex_state = 335},
  [17030] = {.lex_state = 0, .external_lex_state = 399},
  [17031] = {.lex_state = 0, .external_lex_state = 399},
  [17032] = {.lex_state = 0, .external_lex_state = 335},
  [17033] = {.lex_state = 0, .external_lex_state = 335},
  [17034] = {.lex_state = 0, .external_lex_state = 335},
  [17035] = {.lex_state = 0, .external_lex_state = 335},
  [17036] = {.lex_state = 0, .external_lex_state = 308},
  [17037] = {.lex_state = 1, .external_lex_state = 441},
  [17038] = {.lex_state = 51, .external_lex_state = 308},
  [17039] = {.lex_state = 0, .external_lex_state = 308},
  [17040] = {.lex_state = 0, .external_lex_state = 335},
  [17041] = {.lex_state = 0, .external_lex_state = 399},
  [17042] = {.lex_state = 0, .external_lex_state = 335},
  [17043] = {.lex_state = 0, .external_lex_state = 335},
  [17044] = {.lex_state = 0, .external_lex_state = 335},
  [17045] = {.lex_state = 0, .external_lex_state = 308},
  [17046] = {.lex_state = 1, .external_lex_state = 441},
  [17047] = {.lex_state = 0, .external_lex_state = 335},
  [17048] = {.lex_state = 1, .external_lex_state = 441},
  [17049] = {.lex_state = 0, .external_lex_state = 416},
  [17050] = {.lex_state = 1, .external_lex_state = 441},
  [17051] = {.lex_state = 0, .external_lex_state = 416},
  [17052] = {.lex_state = 1, .external_lex_state = 441},
  [17053] = {.lex_state = 0, .external_lex_state = 308},
  [17054] = {.lex_state = 0, .external_lex_state = 335},
  [17055] = {.lex_state = 0, .external_lex_state = 416},
  [17056] = {.lex_state = 0, .external_lex_state = 335},
  [17057] = {.lex_state = 0, .external_lex_state = 335},
  [17058] = {.lex_state = 0, .external_lex_state = 397},
  [17059] = {.lex_state = 0, .external_lex_state = 335},
  [17060] = {.lex_state = 0, .external_lex_state = 399},
  [17061] = {.lex_state = 0, .external_lex_state = 308},
  [17062] = {.lex_state = 0, .external_lex_state = 399},
  [17063] = {.lex_state = 0, .external_lex_state = 335},
  [17064] = {.lex_state = 0, .external_lex_state = 335},
  [17065] = {.lex_state = 0, .external_lex_state = 335},
  [17066] = {.lex_state = 0, .external_lex_state = 416},
  [17067] = {.lex_state = 0, .external_lex_state = 335},
  [17068] = {.lex_state = 1, .external_lex_state = 441},
  [17069] = {.lex_state = 0, .external_lex_state = 416},
  [17070] = {.lex_state = 0, .external_lex_state = 308},
  [17071] = {.lex_state = 1, .external_lex_state = 441},
  [17072] = {.lex_state = 1, .external_lex_state = 441},
  [17073] = {.lex_state = 0, .external_lex_state = 416},
  [17074] = {.lex_state = 1, .external_lex_state = 441},
  [17075] = {.lex_state = 0, .external_lex_state = 335},
  [17076] = {.lex_state = 51, .external_lex_state = 308},
  [17077] = {.lex_state = 0, .external_lex_state = 335},
  [17078] = {.lex_state = 0, .external_lex_state = 335},
  [17079] = {.lex_state = 0, .external_lex_state = 335},
  [17080] = {.lex_state = 0, .external_lex_state = 335},
  [17081] = {.lex_state = 0, .external_lex_state = 335},
  [17082] = {.lex_state = 1, .external_lex_state = 441},
  [17083] = {.lex_state = 1, .external_lex_state = 441},
  [17084] = {.lex_state = 0, .external_lex_state = 335},
  [17085] = {.lex_state = 1, .external_lex_state = 441},
  [17086] = {.lex_state = 1, .external_lex_state = 441},
  [17087] = {.lex_state = 0, .external_lex_state = 335},
  [17088] = {.lex_state = 0, .external_lex_state = 335},
  [17089] = {.lex_state = 0, .external_lex_state = 397},
  [17090] = {.lex_state = 51, .external_lex_state = 308},
  [17091] = {.lex_state = 0, .external_lex_state = 416},
  [17092] = {.lex_state = 0, .external_lex_state = 335},
  [17093] = {.lex_state = 0, .external_lex_state = 335},
  [17094] = {.lex_state = 0, .external_lex_state = 335},
  [17095] = {.lex_state = 0, .external_lex_state = 335},
  [17096] = {.lex_state = 0, .external_lex_state = 335},
  [17097] = {.lex_state = 0, .external_lex_state = 335},
  [17098] = {.lex_state = 0, .external_lex_state = 416},
  [17099] = {.lex_state = 0, .external_lex_state = 335},
  [17100] = {.lex_state = 0, .external_lex_state = 335},
  [17101] = {.lex_state = 0, .external_lex_state = 308},
  [17102] = {.lex_state = 0, .external_lex_state = 335},
  [17103] = {.lex_state = 1, .external_lex_state = 441},
  [17104] = {.lex_state = 51, .external_lex_state = 308},
  [17105] = {.lex_state = 0, .external_lex_state = 335},
  [17106] = {.lex_state = 0, .external_lex_state = 335},
  [17107] = {.lex_state = 0, .external_lex_state = 335},
  [17108] = {.lex_state = 0, .external_lex_state = 335},
  [17109] = {.lex_state = 0, .external_lex_state = 335},
  [17110] = {.lex_state = 0, .external_lex_state = 335},
  [17111] = {.lex_state = 0, .external_lex_state = 416},
  [17112] = {.lex_state = 0, .external_lex_state = 335},
  [17113] = {.lex_state = 1, .external_lex_state = 441},
  [17114] = {.lex_state = 0, .external_lex_state = 308},
  [17115] = {.lex_state = 1, .external_lex_state = 441},
  [17116] = {.lex_state = 51, .external_lex_state = 308},
  [17117] = {.lex_state = 0, .external_lex_state = 416},
  [17118] = {.lex_state = 0, .external_lex_state = 308},
  [17119] = {.lex_state = 0, .external_lex_state = 335},
  [17120] = {.lex_state = 0, .external_lex_state = 335},
  [17121] = {.lex_state = 0, .external_lex_state = 397},
  [17122] = {.lex_state = 0, .external_lex_state = 308},
  [17123] = {.lex_state = 0, .external_lex_state = 335},
  [17124] = {.lex_state = 0, .external_lex_state = 397},
  [17125] = {.lex_state = 0, .external_lex_state = 335},
  [17126] = {.lex_state = 0, .external_lex_state = 397},
  [17127] = {.lex_state = 0, .external_lex_state = 308},
  [17128] = {.lex_state = 1, .external_lex_state = 441},
  [17129] = {.lex_state = 0, .external_lex_state = 397},
  [17130] = {.lex_state = 1, .external_lex_state = 441},
  [17131] = {.lex_state = 0, .external_lex_state = 335},
  [17132] = {.lex_state = 0, .external_lex_state = 399},
  [17133] = {.lex_state = 0, .external_lex_state = 335},
  [17134] = {.lex_state = 0, .external_lex_state = 335},
  [17135] = {.lex_state = 1, .external_lex_state = 441},
  [17136] = {.lex_state = 0, .external_lex_state = 335},
  [17137] = {.lex_state = 1, .external_lex_state = 441},
  [17138] = {.lex_state = 0, .external_lex_state = 335},
  [17139] = {.lex_state = 1, .external_lex_state = 441},
  [17140] = {.lex_state = 0, .external_lex_state = 335},
  [17141] = {.lex_state = 0, .external_lex_state = 335},
  [17142] = {.lex_state = 1, .external_lex_state = 441},
  [17143] = {.lex_state = 0, .external_lex_state = 308},
  [17144] = {.lex_state = 1, .external_lex_state = 441},
  [17145] = {.lex_state = 0, .external_lex_state = 416},
  [17146] = {.lex_state = 0, .external_lex_state = 416},
  [17147] = {.lex_state = 0, .external_lex_state = 335},
  [17148] = {.lex_state = 0, .external_lex_state = 308},
  [17149] = {.lex_state = 0, .external_lex_state = 397},
  [17150] = {.lex_state = 0, .external_lex_state = 416},
  [17151] = {.lex_state = 0, .external_lex_state = 397},
  [17152] = {.lex_state = 0, .external_lex_state = 416},
  [17153] = {.lex_state = 0, .external_lex_state = 397},
  [17154] = {.lex_state = 0, .external_lex_state = 335},
  [17155] = {.lex_state = 0, .external_lex_state = 335},
  [17156] = {.lex_state = 0, .external_lex_state = 335},
  [17157] = {.lex_state = 0, .external_lex_state = 335},
  [17158] = {.lex_state = 1, .external_lex_state = 441},
  [17159] = {.lex_state = 0, .external_lex_state = 308},
  [17160] = {.lex_state = 1, .external_lex_state = 441},
  [17161] = {.lex_state = 0, .external_lex_state = 335},
  [17162] = {.lex_state = 51, .external_lex_state = 308},
  [17163] = {.lex_state = 0, .external_lex_state = 399},
  [17164] = {.lex_state = 0, .external_lex_state = 397},
  [17165] = {.lex_state = 0, .external_lex_state = 308},
  [17166] = {.lex_state = 0, .external_lex_state = 335},
  [17167] = {.lex_state = 0, .external_lex_state = 335},
  [17168] = {.lex_state = 0, .external_lex_state = 399},
  [17169] = {.lex_state = 1, .external_lex_state = 441},
  [17170] = {.lex_state = 0, .external_lex_state = 335},
  [17171] = {.lex_state = 1, .external_lex_state = 441},
  [17172] = {.lex_state = 0, .external_lex_state = 335},
  [17173] = {.lex_state = 0, .external_lex_state = 335},
  [17174] = {.lex_state = 0, .external_lex_state = 335},
  [17175] = {.lex_state = 0, .external_lex_state = 416},
  [17176] = {.lex_state = 0, .external_lex_state = 335},
  [17177] = {.lex_state = 0, .external_lex_state = 399},
  [17178] = {.lex_state = 0, .external_lex_state = 397},
  [17179] = {.lex_state = 0, .external_lex_state = 399},
  [17180] = {.lex_state = 0, .external_lex_state = 413},
  [17181] = {.lex_state = 0, .external_lex_state = 416},
  [17182] = {.lex_state = 0, .external_lex_state = 335},
  [17183] = {.lex_state = 0, .external_lex_state = 335},
  [17184] = {.lex_state = 0, .external_lex_state = 308},
  [17185] = {.lex_state = 0, .external_lex_state = 335},
  [17186] = {.lex_state = 0, .external_lex_state = 335},
  [17187] = {.lex_state = 51, .external_lex_state = 308},
  [17188] = {.lex_state = 1, .external_lex_state = 441},
  [17189] = {.lex_state = 0, .external_lex_state = 335},
  [17190] = {.lex_state = 51, .external_lex_state = 308},
  [17191] = {.lex_state = 0, .external_lex_state = 397},
  [17192] = {.lex_state = 0, .external_lex_state = 335},
  [17193] = {.lex_state = 0, .external_lex_state = 335},
  [17194] = {.lex_state = 0, .external_lex_state = 416},
  [17195] = {.lex_state = 1, .external_lex_state = 441},
  [17196] = {.lex_state = 1, .external_lex_state = 441},
  [17197] = {.lex_state = 0, .external_lex_state = 308},
  [17198] = {.lex_state = 0, .external_lex_state = 416},
  [17199] = {.lex_state = 1, .external_lex_state = 441},
  [17200] = {.lex_state = 0, .external_lex_state = 397},
  [17201] = {.lex_state = 0, .external_lex_state = 308},
  [17202] = {.lex_state = 0, .external_lex_state = 335},
  [17203] = {.lex_state = 0, .external_lex_state = 335},
  [17204] = {.lex_state = 0, .external_lex_state = 399},
  [17205] = {.lex_state = 0, .external_lex_state = 399},
  [17206] = {.lex_state = 0, .external_lex_state = 335},
  [17207] = {.lex_state = 0, .external_lex_state = 399},
  [17208] = {.lex_state = 1, .external_lex_state = 441},
  [17209] = {.lex_state = 0, .external_lex_state = 335},
  [17210] = {.lex_state = 0, .external_lex_state = 308},
  [17211] = {.lex_state = 0, .external_lex_state = 308},
  [17212] = {.lex_state = 0, .external_lex_state = 399},
  [17213] = {.lex_state = 0, .external_lex_state = 335},
  [17214] = {.lex_state = 0, .external_lex_state = 335},
  [17215] = {.lex_state = 0, .external_lex_state = 308},
  [17216] = {.lex_state = 0, .external_lex_state = 335},
  [17217] = {.lex_state = 0, .external_lex_state = 399},
  [17218] = {.lex_state = 1, .external_lex_state = 441},
  [17219] = {.lex_state = 1, .external_lex_state = 441},
  [17220] = {.lex_state = 0, .external_lex_state = 416},
  [17221] = {.lex_state = 1, .external_lex_state = 441},
  [17222] = {.lex_state = 1, .external_lex_state = 441},
  [17223] = {.lex_state = 0, .external_lex_state = 399},
  [17224] = {.lex_state = 1, .external_lex_state = 441},
  [17225] = {.lex_state = 0, .external_lex_state = 397},
  [17226] = {.lex_state = 0, .external_lex_state = 308},
  [17227] = {.lex_state = 0, .external_lex_state = 399},
  [17228] = {.lex_state = 0, .external_lex_state = 416},
  [17229] = {.lex_state = 0, .external_lex_state = 335},
  [17230] = {.lex_state = 0, .external_lex_state = 335},
  [17231] = {.lex_state = 0, .external_lex_state = 335},
  [17232] = {.lex_state = 0, .external_lex_state = 335},
  [17233] = {.lex_state = 1, .external_lex_state = 441},
  [17234] = {.lex_state = 0, .external_lex_state = 335},
  [17235] = {.lex_state = 0, .external_lex_state = 335},
  [17236] = {.lex_state = 1, .external_lex_state = 441},
  [17237] = {.lex_state = 0, .external_lex_state = 397},
  [17238] = {.lex_state = 0, .external_lex_state = 335},
  [17239] = {.lex_state = 0, .external_lex_state = 335},
  [17240] = {.lex_state = 0, .external_lex_state = 308},
  [17241] = {.lex_state = 0, .external_lex_state = 335},
  [17242] = {.lex_state = 0, .external_lex_state = 308},
  [17243] = {.lex_state = 0, .external_lex_state = 335},
  [17244] = {.lex_state = 1, .external_lex_state = 441},
  [17245] = {.lex_state = 0, .external_lex_state = 335},
  [17246] = {.lex_state = 0, .external_lex_state = 335},
  [17247] = {.lex_state = 0, .external_lex_state = 416},
  [17248] = {.lex_state = 0, .external_lex_state = 335},
  [17249] = {.lex_state = 0, .external_lex_state = 335},
  [17250] = {.lex_state = 1, .external_lex_state = 441},
  [17251] = {.lex_state = 0, .external_lex_state = 335},
  [17252] = {.lex_state = 1, .external_lex_state = 441},
  [17253] = {.lex_state = 0, .external_lex_state = 399},
  [17254] = {.lex_state = 0, .external_lex_state = 308},
  [17255] = {.lex_state = 1, .external_lex_state = 441},
  [17256] = {.lex_state = 0, .external_lex_state = 335},
  [17257] = {.lex_state = 0, .external_lex_state = 308},
  [17258] = {.lex_state = 0, .external_lex_state = 416},
  [17259] = {.lex_state = 0, .external_lex_state = 335},
  [17260] = {.lex_state = 0, .external_lex_state = 335},
  [17261] = {.lex_state = 0, .external_lex_state = 335},
  [17262] = {.lex_state = 0, .external_lex_state = 335},
  [17263] = {.lex_state = 1, .external_lex_state = 441},
  [17264] = {.lex_state = 1, .external_lex_state = 441},
  [17265] = {.lex_state = 0, .external_lex_state = 335},
  [17266] = {.lex_state = 0, .external_lex_state = 308},
  [17267] = {.lex_state = 0, .external_lex_state = 308},
  [17268] = {.lex_state = 1, .external_lex_state = 441},
  [17269] = {.lex_state = 0, .external_lex_state = 335},
  [17270] = {.lex_state = 0, .external_lex_state = 335},
  [17271] = {.lex_state = 0, .external_lex_state = 416},
  [17272] = {.lex_state = 1, .external_lex_state = 441},
  [17273] = {.lex_state = 0, .external_lex_state = 399},
  [17274] = {.lex_state = 0, .external_lex_state = 416},
  [17275] = {.lex_state = 0, .external_lex_state = 335},
  [17276] = {.lex_state = 0, .external_lex_state = 335},
  [17277] = {.lex_state = 1, .external_lex_state = 441},
  [17278] = {.lex_state = 0, .external_lex_state = 416},
  [17279] = {.lex_state = 0, .external_lex_state = 308},
  [17280] = {.lex_state = 0, .external_lex_state = 335},
  [17281] = {.lex_state = 1, .external_lex_state = 441},
  [17282] = {.lex_state = 0, .external_lex_state = 335},
  [17283] = {.lex_state = 1, .external_lex_state = 441},
  [17284] = {.lex_state = 0, .external_lex_state = 335},
  [17285] = {.lex_state = 0, .external_lex_state = 335},
  [17286] = {.lex_state = 0, .external_lex_state = 335},
  [17287] = {.lex_state = 51, .external_lex_state = 308},
  [17288] = {.lex_state = 1, .external_lex_state = 441},
  [17289] = {.lex_state = 0, .external_lex_state = 397},
  [17290] = {.lex_state = 1, .external_lex_state = 441},
  [17291] = {.lex_state = 0, .external_lex_state = 399},
  [17292] = {.lex_state = 1, .external_lex_state = 441},
  [17293] = {.lex_state = 1, .external_lex_state = 441},
  [17294] = {.lex_state = 0, .external_lex_state = 335},
  [17295] = {.lex_state = 1, .external_lex_state = 441},
  [17296] = {.lex_state = 0, .external_lex_state = 335},
  [17297] = {.lex_state = 0, .external_lex_state = 416},
  [17298] = {.lex_state = 0, .external_lex_state = 335},
  [17299] = {.lex_state = 0, .external_lex_state = 335},
  [17300] = {.lex_state = 0, .external_lex_state = 335},
  [17301] = {.lex_state = 0, .external_lex_state = 335},
  [17302] = {.lex_state = 0, .external_lex_state = 335},
  [17303] = {.lex_state = 0, .external_lex_state = 308},
  [17304] = {.lex_state = 0, .external_lex_state = 335},
  [17305] = {.lex_state = 0, .external_lex_state = 335},
  [17306] = {.lex_state = 0, .external_lex_state = 335},
  [17307] = {.lex_state = 0, .external_lex_state = 335},
  [17308] = {.lex_state = 0, .external_lex_state = 335},
  [17309] = {.lex_state = 0, .external_lex_state = 416},
  [17310] = {.lex_state = 0, .external_lex_state = 308},
  [17311] = {.lex_state = 1, .external_lex_state = 441},
  [17312] = {.lex_state = 1, .external_lex_state = 441},
  [17313] = {.lex_state = 0, .external_lex_state = 416},
  [17314] = {.lex_state = 1, .external_lex_state = 441},
  [17315] = {.lex_state = 0, .external_lex_state = 416},
  [17316] = {.lex_state = 0, .external_lex_state = 335},
  [17317] = {.lex_state = 1, .external_lex_state = 441},
  [17318] = {.lex_state = 0, .external_lex_state = 416},
  [17319] = {.lex_state = 0, .external_lex_state = 335},
  [17320] = {.lex_state = 47, .external_lex_state = 308},
  [17321] = {.lex_state = 1, .external_lex_state = 441},
  [17322] = {.lex_state = 0, .external_lex_state = 416},
  [17323] = {.lex_state = 0, .external_lex_state = 335},
  [17324] = {.lex_state = 0, .external_lex_state = 308},
  [17325] = {.lex_state = 0, .external_lex_state = 335},
  [17326] = {.lex_state = 1, .external_lex_state = 441},
  [17327] = {.lex_state = 0, .external_lex_state = 335},
  [17328] = {.lex_state = 0, .external_lex_state = 335},
  [17329] = {.lex_state = 0, .external_lex_state = 335},
  [17330] = {.lex_state = 1, .external_lex_state = 441},
  [17331] = {.lex_state = 0, .external_lex_state = 335},
  [17332] = {.lex_state = 0, .external_lex_state = 335},
  [17333] = {.lex_state = 0, .external_lex_state = 335},
  [17334] = {.lex_state = 1, .external_lex_state = 441},
  [17335] = {.lex_state = 1, .external_lex_state = 441},
  [17336] = {.lex_state = 1, .external_lex_state = 441},
  [17337] = {.lex_state = 0, .external_lex_state = 335},
  [17338] = {.lex_state = 0, .external_lex_state = 335},
  [17339] = {.lex_state = 0, .external_lex_state = 416},
  [17340] = {.lex_state = 0, .external_lex_state = 416},
  [17341] = {.lex_state = 0, .external_lex_state = 335},
  [17342] = {.lex_state = 0, .external_lex_state = 308},
  [17343] = {.lex_state = 1, .external_lex_state = 441},
  [17344] = {.lex_state = 0, .external_lex_state = 335},
  [17345] = {.lex_state = 1, .external_lex_state = 441},
  [17346] = {.lex_state = 0, .external_lex_state = 335},
  [17347] = {.lex_state = 0, .external_lex_state = 335},
  [17348] = {.lex_state = 0, .external_lex_state = 335},
  [17349] = {.lex_state = 0, .external_lex_state = 308},
  [17350] = {.lex_state = 0, .external_lex_state = 335},
  [17351] = {.lex_state = 51, .external_lex_state = 308},
  [17352] = {.lex_state = 0, .external_lex_state = 335},
  [17353] = {.lex_state = 1, .external_lex_state = 441},
  [17354] = {.lex_state = 0, .external_lex_state = 308},
  [17355] = {.lex_state = 0, .external_lex_state = 335},
  [17356] = {.lex_state = 0, .external_lex_state = 335},
  [17357] = {.lex_state = 1, .external_lex_state = 441},
  [17358] = {.lex_state = 0, .external_lex_state = 335},
  [17359] = {.lex_state = 0, .external_lex_state = 335},
  [17360] = {.lex_state = 1, .external_lex_state = 441},
  [17361] = {.lex_state = 1, .external_lex_state = 441},
  [17362] = {.lex_state = 0, .external_lex_state = 335},
  [17363] = {.lex_state = 0, .external_lex_state = 335},
  [17364] = {.lex_state = 0, .external_lex_state = 416},
  [17365] = {.lex_state = 0, .external_lex_state = 335},
  [17366] = {.lex_state = 0, .external_lex_state = 335},
  [17367] = {.lex_state = 0, .external_lex_state = 335},
  [17368] = {.lex_state = 0, .external_lex_state = 335},
  [17369] = {.lex_state = 0, .external_lex_state = 335},
  [17370] = {.lex_state = 1, .external_lex_state = 441},
  [17371] = {.lex_state = 0, .external_lex_state = 416},
  [17372] = {.lex_state = 0, .external_lex_state = 335},
  [17373] = {.lex_state = 0, .external_lex_state = 397},
  [17374] = {.lex_state = 1, .external_lex_state = 441},
  [17375] = {.lex_state = 1, .external_lex_state = 441},
  [17376] = {.lex_state = 1, .external_lex_state = 441},
  [17377] = {.lex_state = 0, .external_lex_state = 335},
  [17378] = {.lex_state = 0, .external_lex_state = 335},
  [17379] = {.lex_state = 51, .external_lex_state = 308},
  [17380] = {.lex_state = 0, .external_lex_state = 399},
  [17381] = {.lex_state = 1, .external_lex_state = 441},
  [17382] = {.lex_state = 0, .external_lex_state = 397},
  [17383] = {.lex_state = 0, .external_lex_state = 416},
  [17384] = {.lex_state = 1, .external_lex_state = 441},
  [17385] = {.lex_state = 0, .external_lex_state = 416},
  [17386] = {.lex_state = 0, .external_lex_state = 416},
  [17387] = {.lex_state = 0, .external_lex_state = 335},
  [17388] = {.lex_state = 1, .external_lex_state = 441},
  [17389] = {.lex_state = 0, .external_lex_state = 335},
  [17390] = {.lex_state = 0, .external_lex_state = 308},
  [17391] = {.lex_state = 0, .external_lex_state = 335},
  [17392] = {.lex_state = 0, .external_lex_state = 335},
  [17393] = {.lex_state = 0, .external_lex_state = 335},
  [17394] = {.lex_state = 0, .external_lex_state = 335},
  [17395] = {.lex_state = 0, .external_lex_state = 399},
  [17396] = {.lex_state = 0, .external_lex_state = 335},
  [17397] = {.lex_state = 1, .external_lex_state = 441},
  [17398] = {.lex_state = 0, .external_lex_state = 335},
  [17399] = {.lex_state = 0, .external_lex_state = 335},
  [17400] = {.lex_state = 0, .external_lex_state = 335},
  [17401] = {.lex_state = 0, .external_lex_state = 397},
  [17402] = {.lex_state = 0, .external_lex_state = 416},
  [17403] = {.lex_state = 1, .external_lex_state = 441},
  [17404] = {.lex_state = 0, .external_lex_state = 416},
  [17405] = {.lex_state = 1, .external_lex_state = 441},
  [17406] = {.lex_state = 51, .external_lex_state = 308},
  [17407] = {.lex_state = 1, .external_lex_state = 441},
  [17408] = {.lex_state = 0, .external_lex_state = 308},
  [17409] = {.lex_state = 1, .external_lex_state = 441},
  [17410] = {.lex_state = 0, .external_lex_state = 416},
  [17411] = {.lex_state = 0, .external_lex_state = 335},
  [17412] = {.lex_state = 0, .external_lex_state = 399},
  [17413] = {.lex_state = 0, .external_lex_state = 308},
  [17414] = {.lex_state = 0, .external_lex_state = 335},
  [17415] = {.lex_state = 0, .external_lex_state = 335},
  [17416] = {.lex_state = 0, .external_lex_state = 335},
  [17417] = {.lex_state = 0, .external_lex_state = 335},
  [17418] = {.lex_state = 1, .external_lex_state = 441},
  [17419] = {.lex_state = 1, .external_lex_state = 441},
  [17420] = {.lex_state = 0, .external_lex_state = 335},
  [17421] = {.lex_state = 0, .external_lex_state = 335},
  [17422] = {.lex_state = 1, .external_lex_state = 441},
  [17423] = {.lex_state = 0, .external_lex_state = 416},
  [17424] = {.lex_state = 0, .external_lex_state = 335},
  [17425] = {.lex_state = 0, .external_lex_state = 335},
  [17426] = {.lex_state = 0, .external_lex_state = 335},
  [17427] = {.lex_state = 1, .external_lex_state = 441},
  [17428] = {.lex_state = 0, .external_lex_state = 335},
  [17429] = {.lex_state = 0, .external_lex_state = 416},
  [17430] = {.lex_state = 0, .external_lex_state = 335},
  [17431] = {.lex_state = 0, .external_lex_state = 335},
  [17432] = {.lex_state = 0, .external_lex_state = 308},
  [17433] = {.lex_state = 0, .external_lex_state = 416},
  [17434] = {.lex_state = 0, .external_lex_state = 335},
  [17435] = {.lex_state = 0, .external_lex_state = 335},
  [17436] = {.lex_state = 1, .external_lex_state = 441},
  [17437] = {.lex_state = 1, .external_lex_state = 441},
  [17438] = {.lex_state = 1, .external_lex_state = 441},
  [17439] = {.lex_state = 0, .external_lex_state = 335},
  [17440] = {.lex_state = 0, .external_lex_state = 335},
  [17441] = {.lex_state = 1, .external_lex_state = 441},
  [17442] = {.lex_state = 1, .external_lex_state = 441},
  [17443] = {.lex_state = 1, .external_lex_state = 441},
  [17444] = {.lex_state = 0, .external_lex_state = 335},
  [17445] = {.lex_state = 0, .external_lex_state = 335},
  [17446] = {.lex_state = 1, .external_lex_state = 441},
  [17447] = {.lex_state = 0, .external_lex_state = 335},
  [17448] = {.lex_state = 0, .external_lex_state = 416},
  [17449] = {.lex_state = 0, .external_lex_state = 335},
  [17450] = {.lex_state = 1, .external_lex_state = 441},
  [17451] = {.lex_state = 0, .external_lex_state = 335},
  [17452] = {.lex_state = 0, .external_lex_state = 335},
  [17453] = {.lex_state = 0, .external_lex_state = 397},
  [17454] = {.lex_state = 0, .external_lex_state = 335},
  [17455] = {.lex_state = 0, .external_lex_state = 335},
  [17456] = {.lex_state = 0, .external_lex_state = 335},
  [17457] = {.lex_state = 0, .external_lex_state = 335},
  [17458] = {.lex_state = 0, .external_lex_state = 335},
  [17459] = {.lex_state = 47, .external_lex_state = 411},
  [17460] = {.lex_state = 1, .external_lex_state = 441},
  [17461] = {.lex_state = 0, .external_lex_state = 308},
  [17462] = {.lex_state = 0, .external_lex_state = 335},
  [17463] = {.lex_state = 0, .external_lex_state = 397},
  [17464] = {.lex_state = 0, .external_lex_state = 416},
  [17465] = {.lex_state = 47, .external_lex_state = 411},
  [17466] = {.lex_state = 0, .external_lex_state = 335},
  [17467] = {.lex_state = 1, .external_lex_state = 441},
  [17468] = {.lex_state = 1, .external_lex_state = 441},
  [17469] = {.lex_state = 1, .external_lex_state = 441},
  [17470] = {.lex_state = 1, .external_lex_state = 441},
  [17471] = {.lex_state = 0, .external_lex_state = 416},
  [17472] = {.lex_state = 47, .external_lex_state = 411},
  [17473] = {.lex_state = 0, .external_lex_state = 335},
  [17474] = {.lex_state = 0, .external_lex_state = 335},
  [17475] = {.lex_state = 0, .external_lex_state = 335},
  [17476] = {.lex_state = 0, .external_lex_state = 335},
  [17477] = {.lex_state = 1, .external_lex_state = 441},
  [17478] = {.lex_state = 0, .external_lex_state = 397},
  [17479] = {.lex_state = 1, .external_lex_state = 441},
  [17480] = {.lex_state = 0, .external_lex_state = 308},
  [17481] = {.lex_state = 1, .external_lex_state = 441},
  [17482] = {.lex_state = 0, .external_lex_state = 335},
  [17483] = {.lex_state = 1, .external_lex_state = 441},
  [17484] = {.lex_state = 1, .external_lex_state = 441},
  [17485] = {.lex_state = 1, .external_lex_state = 441},
  [17486] = {.lex_state = 0, .external_lex_state = 335},
  [17487] = {.lex_state = 0, .external_lex_state = 335},
  [17488] = {.lex_state = 0, .external_lex_state = 308},
  [17489] = {.lex_state = 0, .external_lex_state = 416},
  [17490] = {.lex_state = 0, .external_lex_state = 335},
  [17491] = {.lex_state = 0, .external_lex_state = 335},
  [17492] = {.lex_state = 0, .external_lex_state = 335},
  [17493] = {.lex_state = 0, .external_lex_state = 335},
  [17494] = {.lex_state = 0, .external_lex_state = 335},
  [17495] = {.lex_state = 0, .external_lex_state = 416},
  [17496] = {.lex_state = 0, .external_lex_state = 308},
  [17497] = {.lex_state = 47, .external_lex_state = 411},
  [17498] = {.lex_state = 1, .external_lex_state = 441},
  [17499] = {.lex_state = 0, .external_lex_state = 335},
  [17500] = {.lex_state = 1, .external_lex_state = 441},
  [17501] = {.lex_state = 0, .external_lex_state = 397},
  [17502] = {.lex_state = 1, .external_lex_state = 441},
  [17503] = {.lex_state = 0, .external_lex_state = 335},
  [17504] = {.lex_state = 0, .external_lex_state = 335},
  [17505] = {.lex_state = 0, .external_lex_state = 308},
  [17506] = {.lex_state = 0, .external_lex_state = 335},
  [17507] = {.lex_state = 0, .external_lex_state = 335},
  [17508] = {.lex_state = 1, .external_lex_state = 441},
  [17509] = {.lex_state = 1, .external_lex_state = 441},
  [17510] = {.lex_state = 0, .external_lex_state = 416},
  [17511] = {.lex_state = 0, .external_lex_state = 335},
  [17512] = {.lex_state = 1, .external_lex_state = 441},
  [17513] = {.lex_state = 0, .external_lex_state = 335},
  [17514] = {.lex_state = 0, .external_lex_state = 416},
  [17515] = {.lex_state = 0, .external_lex_state = 335},
  [17516] = {.lex_state = 0, .external_lex_state = 335},
  [17517] = {.lex_state = 0, .external_lex_state = 335},
  [17518] = {.lex_state = 0, .external_lex_state = 335},
  [17519] = {.lex_state = 0, .external_lex_state = 397},
  [17520] = {.lex_state = 0, .external_lex_state = 335},
  [17521] = {.lex_state = 0, .external_lex_state = 308},
  [17522] = {.lex_state = 1, .external_lex_state = 441},
  [17523] = {.lex_state = 0, .external_lex_state = 335},
  [17524] = {.lex_state = 0, .external_lex_state = 335},
  [17525] = {.lex_state = 1, .external_lex_state = 441},
  [17526] = {.lex_state = 0, .external_lex_state = 416},
  [17527] = {.lex_state = 1, .external_lex_state = 441},
  [17528] = {.lex_state = 0, .external_lex_state = 416},
  [17529] = {.lex_state = 1, .external_lex_state = 441},
  [17530] = {.lex_state = 0, .external_lex_state = 416},
  [17531] = {.lex_state = 1, .external_lex_state = 441},
  [17532] = {.lex_state = 0, .external_lex_state = 335},
  [17533] = {.lex_state = 0, .external_lex_state = 335},
  [17534] = {.lex_state = 0, .external_lex_state = 335},
  [17535] = {.lex_state = 0, .external_lex_state = 308},
  [17536] = {.lex_state = 0, .external_lex_state = 335},
  [17537] = {.lex_state = 0, .external_lex_state = 335},
  [17538] = {.lex_state = 0, .external_lex_state = 335},
  [17539] = {.lex_state = 0, .external_lex_state = 335},
  [17540] = {.lex_state = 1, .external_lex_state = 441},
  [17541] = {.lex_state = 1, .external_lex_state = 441},
  [17542] = {.lex_state = 0, .external_lex_state = 335},
  [17543] = {.lex_state = 1, .external_lex_state = 441},
  [17544] = {.lex_state = 0, .external_lex_state = 335},
  [17545] = {.lex_state = 0, .external_lex_state = 335},
  [17546] = {.lex_state = 1, .external_lex_state = 441},
  [17547] = {.lex_state = 1, .external_lex_state = 441},
  [17548] = {.lex_state = 0, .external_lex_state = 335},
  [17549] = {.lex_state = 0, .external_lex_state = 335},
  [17550] = {.lex_state = 51, .external_lex_state = 308},
  [17551] = {.lex_state = 0, .external_lex_state = 416},
  [17552] = {.lex_state = 0, .external_lex_state = 335},
  [17553] = {.lex_state = 0, .external_lex_state = 397},
  [17554] = {.lex_state = 0, .external_lex_state = 335},
  [17555] = {.lex_state = 0, .external_lex_state = 335},
  [17556] = {.lex_state = 0, .external_lex_state = 335},
  [17557] = {.lex_state = 0, .external_lex_state = 416},
  [17558] = {.lex_state = 51, .external_lex_state = 308},
  [17559] = {.lex_state = 0, .external_lex_state = 335},
  [17560] = {.lex_state = 1, .external_lex_state = 441},
  [17561] = {.lex_state = 0, .external_lex_state = 335},
  [17562] = {.lex_state = 1, .external_lex_state = 441},
  [17563] = {.lex_state = 0, .external_lex_state = 335},
  [17564] = {.lex_state = 1, .external_lex_state = 441},
  [17565] = {.lex_state = 0, .external_lex_state = 335},
  [17566] = {.lex_state = 0, .external_lex_state = 397},
  [17567] = {.lex_state = 0, .external_lex_state = 308},
  [17568] = {.lex_state = 0, .external_lex_state = 397},
  [17569] = {.lex_state = 0, .external_lex_state = 335},
  [17570] = {.lex_state = 0, .external_lex_state = 335},
  [17571] = {.lex_state = 0, .external_lex_state = 335},
  [17572] = {.lex_state = 1, .external_lex_state = 441},
  [17573] = {.lex_state = 1, .external_lex_state = 441},
  [17574] = {.lex_state = 1, .external_lex_state = 441},
  [17575] = {.lex_state = 0, .external_lex_state = 335},
  [17576] = {.lex_state = 0, .external_lex_state = 416},
  [17577] = {.lex_state = 0, .external_lex_state = 335},
  [17578] = {.lex_state = 0, .external_lex_state = 335},
  [17579] = {.lex_state = 0, .external_lex_state = 335},
  [17580] = {.lex_state = 0, .external_lex_state = 335},
  [17581] = {.lex_state = 0, .external_lex_state = 335},
  [17582] = {.lex_state = 0, .external_lex_state = 335},
  [17583] = {.lex_state = 0, .external_lex_state = 416},
  [17584] = {.lex_state = 1, .external_lex_state = 441},
  [17585] = {.lex_state = 0, .external_lex_state = 399},
  [17586] = {.lex_state = 0, .external_lex_state = 335},
  [17587] = {.lex_state = 0, .external_lex_state = 335},
  [17588] = {.lex_state = 0, .external_lex_state = 416},
  [17589] = {.lex_state = 0, .external_lex_state = 416},
  [17590] = {.lex_state = 0, .external_lex_state = 397},
  [17591] = {.lex_state = 1, .external_lex_state = 441},
  [17592] = {.lex_state = 1, .external_lex_state = 441},
  [17593] = {.lex_state = 1, .external_lex_state = 441},
  [17594] = {.lex_state = 0, .external_lex_state = 397},
  [17595] = {.lex_state = 0, .external_lex_state = 308},
  [17596] = {.lex_state = 0, .external_lex_state = 335},
  [17597] = {.lex_state = 1, .external_lex_state = 441},
  [17598] = {.lex_state = 0, .external_lex_state = 335},
  [17599] = {.lex_state = 0, .external_lex_state = 335},
  [17600] = {.lex_state = 0, .external_lex_state = 416},
  [17601] = {.lex_state = 0, .external_lex_state = 335},
  [17602] = {.lex_state = 0, .external_lex_state = 416},
  [17603] = {.lex_state = 0, .external_lex_state = 416},
  [17604] = {.lex_state = 0, .external_lex_state = 335},
  [17605] = {.lex_state = 1, .external_lex_state = 441},
  [17606] = {.lex_state = 0, .external_lex_state = 335},
  [17607] = {.lex_state = 0, .external_lex_state = 335},
  [17608] = {.lex_state = 0, .external_lex_state = 335},
  [17609] = {.lex_state = 1, .external_lex_state = 441},
  [17610] = {.lex_state = 0, .external_lex_state = 335},
  [17611] = {.lex_state = 0, .external_lex_state = 335},
  [17612] = {.lex_state = 0, .external_lex_state = 308},
  [17613] = {.lex_state = 0, .external_lex_state = 308},
  [17614] = {.lex_state = 0, .external_lex_state = 335},
  [17615] = {.lex_state = 0, .external_lex_state = 335},
  [17616] = {.lex_state = 1, .external_lex_state = 441},
  [17617] = {.lex_state = 0, .external_lex_state = 335},
  [17618] = {.lex_state = 1, .external_lex_state = 441},
  [17619] = {.lex_state = 0, .external_lex_state = 416},
  [17620] = {.lex_state = 51, .external_lex_state = 308},
  [17621] = {.lex_state = 0, .external_lex_state = 416},
  [17622] = {.lex_state = 1, .external_lex_state = 441},
  [17623] = {.lex_state = 0, .external_lex_state = 335},
  [17624] = {.lex_state = 1, .external_lex_state = 441},
  [17625] = {.lex_state = 0, .external_lex_state = 335},
  [17626] = {.lex_state = 0, .external_lex_state = 335},
  [17627] = {.lex_state = 51, .external_lex_state = 308},
  [17628] = {.lex_state = 0, .external_lex_state = 335},
  [17629] = {.lex_state = 0, .external_lex_state = 335},
  [17630] = {.lex_state = 0, .external_lex_state = 335},
  [17631] = {.lex_state = 0, .external_lex_state = 335},
  [17632] = {.lex_state = 0, .external_lex_state = 335},
  [17633] = {.lex_state = 0, .external_lex_state = 335},
  [17634] = {.lex_state = 1, .external_lex_state = 441},
  [17635] = {.lex_state = 0, .external_lex_state = 335},
  [17636] = {.lex_state = 1, .external_lex_state = 441},
  [17637] = {.lex_state = 0, .external_lex_state = 335},
  [17638] = {.lex_state = 0, .external_lex_state = 335},
  [17639] = {.lex_state = 0, .external_lex_state = 335},
  [17640] = {.lex_state = 1, .external_lex_state = 441},
  [17641] = {.lex_state = 0, .external_lex_state = 335},
  [17642] = {.lex_state = 0, .external_lex_state = 335},
  [17643] = {.lex_state = 1, .external_lex_state = 441},
  [17644] = {.lex_state = 0, .external_lex_state = 416},
  [17645] = {.lex_state = 1, .external_lex_state = 441},
  [17646] = {.lex_state = 0, .external_lex_state = 416},
  [17647] = {.lex_state = 0, .external_lex_state = 335},
  [17648] = {.lex_state = 0, .external_lex_state = 335},
  [17649] = {.lex_state = 0, .external_lex_state = 335},
  [17650] = {.lex_state = 0, .external_lex_state = 416},
  [17651] = {.lex_state = 0, .external_lex_state = 335},
  [17652] = {.lex_state = 0, .external_lex_state = 335},
  [17653] = {.lex_state = 1, .external_lex_state = 441},
  [17654] = {.lex_state = 1, .external_lex_state = 441},
  [17655] = {.lex_state = 1, .external_lex_state = 441},
  [17656] = {.lex_state = 0, .external_lex_state = 399},
  [17657] = {.lex_state = 0, .external_lex_state = 308},
  [17658] = {.lex_state = 0, .external_lex_state = 308},
  [17659] = {.lex_state = 0, .external_lex_state = 308},
  [17660] = {.lex_state = 0, .external_lex_state = 335},
  [17661] = {.lex_state = 0, .external_lex_state = 416},
  [17662] = {.lex_state = 0, .external_lex_state = 308},
  [17663] = {.lex_state = 1, .external_lex_state = 441},
  [17664] = {.lex_state = 0, .external_lex_state = 335},
  [17665] = {.lex_state = 1, .external_lex_state = 441},
  [17666] = {.lex_state = 0, .external_lex_state = 335},
  [17667] = {.lex_state = 1, .external_lex_state = 441},
  [17668] = {.lex_state = 0, .external_lex_state = 335},
  [17669] = {.lex_state = 0, .external_lex_state = 416},
  [17670] = {.lex_state = 0, .external_lex_state = 335},
  [17671] = {.lex_state = 0, .external_lex_state = 308},
  [17672] = {.lex_state = 0, .external_lex_state = 335},
  [17673] = {.lex_state = 0, .external_lex_state = 335},
  [17674] = {.lex_state = 47, .external_lex_state = 308},
  [17675] = {.lex_state = 0, .external_lex_state = 335},
  [17676] = {.lex_state = 0, .external_lex_state = 335},
  [17677] = {.lex_state = 0, .external_lex_state = 335},
  [17678] = {.lex_state = 1, .external_lex_state = 441},
  [17679] = {.lex_state = 0, .external_lex_state = 335},
  [17680] = {.lex_state = 0, .external_lex_state = 335},
  [17681] = {.lex_state = 0, .external_lex_state = 416},
  [17682] = {.lex_state = 1, .external_lex_state = 441},
  [17683] = {.lex_state = 1, .external_lex_state = 441},
  [17684] = {.lex_state = 1, .external_lex_state = 441},
  [17685] = {.lex_state = 1, .external_lex_state = 441},
  [17686] = {.lex_state = 1, .external_lex_state = 441},
  [17687] = {.lex_state = 0, .external_lex_state = 308},
  [17688] = {.lex_state = 0, .external_lex_state = 397},
  [17689] = {.lex_state = 0, .external_lex_state = 335},
  [17690] = {.lex_state = 0, .external_lex_state = 335},
  [17691] = {.lex_state = 0, .external_lex_state = 416},
  [17692] = {.lex_state = 0, .external_lex_state = 335},
  [17693] = {.lex_state = 0, .external_lex_state = 335},
  [17694] = {.lex_state = 0, .external_lex_state = 335},
  [17695] = {.lex_state = 0, .external_lex_state = 335},
  [17696] = {.lex_state = 0, .external_lex_state = 335},
  [17697] = {.lex_state = 0, .external_lex_state = 335},
  [17698] = {.lex_state = 1, .external_lex_state = 441},
  [17699] = {.lex_state = 0, .external_lex_state = 335},
  [17700] = {.lex_state = 1, .external_lex_state = 441},
  [17701] = {.lex_state = 1, .external_lex_state = 441},
  [17702] = {.lex_state = 0, .external_lex_state = 335},
  [17703] = {.lex_state = 0, .external_lex_state = 335},
  [17704] = {.lex_state = 0, .external_lex_state = 335},
  [17705] = {.lex_state = 0, .external_lex_state = 397},
  [17706] = {.lex_state = 0, .external_lex_state = 335},
  [17707] = {.lex_state = 0, .external_lex_state = 335},
  [17708] = {.lex_state = 1, .external_lex_state = 441},
  [17709] = {.lex_state = 1, .external_lex_state = 441},
  [17710] = {.lex_state = 0, .external_lex_state = 335},
  [17711] = {.lex_state = 0, .external_lex_state = 416},
  [17712] = {.lex_state = 0, .external_lex_state = 416},
  [17713] = {.lex_state = 0, .external_lex_state = 335},
  [17714] = {.lex_state = 0, .external_lex_state = 335},
  [17715] = {.lex_state = 1, .external_lex_state = 441},
  [17716] = {.lex_state = 1, .external_lex_state = 441},
  [17717] = {.lex_state = 1, .external_lex_state = 441},
  [17718] = {.lex_state = 0, .external_lex_state = 308},
  [17719] = {.lex_state = 0, .external_lex_state = 335},
  [17720] = {.lex_state = 1, .external_lex_state = 441},
  [17721] = {.lex_state = 0, .external_lex_state = 397},
  [17722] = {.lex_state = 0, .external_lex_state = 335},
  [17723] = {.lex_state = 1, .external_lex_state = 441},
  [17724] = {.lex_state = 0, .external_lex_state = 416},
  [17725] = {.lex_state = 0, .external_lex_state = 399},
  [17726] = {.lex_state = 1, .external_lex_state = 441},
  [17727] = {.lex_state = 0, .external_lex_state = 416},
  [17728] = {.lex_state = 0, .external_lex_state = 335},
  [17729] = {.lex_state = 1, .external_lex_state = 441},
  [17730] = {.lex_state = 0, .external_lex_state = 335},
  [17731] = {.lex_state = 0, .external_lex_state = 397},
  [17732] = {.lex_state = 0, .external_lex_state = 335},
  [17733] = {.lex_state = 0, .external_lex_state = 335},
  [17734] = {.lex_state = 0, .external_lex_state = 335},
  [17735] = {.lex_state = 0, .external_lex_state = 335},
  [17736] = {.lex_state = 0, .external_lex_state = 308},
  [17737] = {.lex_state = 0, .external_lex_state = 335},
  [17738] = {.lex_state = 1, .external_lex_state = 441},
  [17739] = {.lex_state = 0, .external_lex_state = 335},
  [17740] = {.lex_state = 0, .external_lex_state = 308},
  [17741] = {.lex_state = 0, .external_lex_state = 335},
  [17742] = {.lex_state = 51, .external_lex_state = 308},
  [17743] = {.lex_state = 0, .external_lex_state = 416},
  [17744] = {.lex_state = 1, .external_lex_state = 441},
  [17745] = {.lex_state = 0, .external_lex_state = 335},
  [17746] = {.lex_state = 1, .external_lex_state = 441},
  [17747] = {.lex_state = 1, .external_lex_state = 441},
  [17748] = {.lex_state = 1, .external_lex_state = 441},
  [17749] = {.lex_state = 0, .external_lex_state = 416},
  [17750] = {.lex_state = 0, .external_lex_state = 308},
  [17751] = {.lex_state = 0, .external_lex_state = 335},
  [17752] = {.lex_state = 0, .external_lex_state = 399},
  [17753] = {.lex_state = 0, .external_lex_state = 335},
  [17754] = {.lex_state = 0, .external_lex_state = 397},
  [17755] = {.lex_state = 1, .external_lex_state = 441},
  [17756] = {.lex_state = 0, .external_lex_state = 335},
  [17757] = {.lex_state = 0, .external_lex_state = 335},
  [17758] = {.lex_state = 0, .external_lex_state = 335},
  [17759] = {.lex_state = 0, .external_lex_state = 335},
  [17760] = {.lex_state = 1, .external_lex_state = 441},
  [17761] = {.lex_state = 0, .external_lex_state = 335},
  [17762] = {.lex_state = 1, .external_lex_state = 441},
  [17763] = {.lex_state = 0, .external_lex_state = 335},
  [17764] = {.lex_state = 1, .external_lex_state = 441},
  [17765] = {.lex_state = 0, .external_lex_state = 335},
  [17766] = {.lex_state = 0, .external_lex_state = 335},
  [17767] = {.lex_state = 0, .external_lex_state = 399},
  [17768] = {.lex_state = 0, .external_lex_state = 335},
  [17769] = {.lex_state = 0, .external_lex_state = 335},
  [17770] = {.lex_state = 1, .external_lex_state = 441},
  [17771] = {.lex_state = 0, .external_lex_state = 416},
  [17772] = {.lex_state = 0, .external_lex_state = 335},
  [17773] = {.lex_state = 0, .external_lex_state = 335},
  [17774] = {.lex_state = 0, .external_lex_state = 416},
  [17775] = {.lex_state = 0, .external_lex_state = 335},
  [17776] = {.lex_state = 0, .external_lex_state = 308},
  [17777] = {.lex_state = 1, .external_lex_state = 441},
  [17778] = {.lex_state = 0, .external_lex_state = 416},
  [17779] = {.lex_state = 1, .external_lex_state = 441},
  [17780] = {.lex_state = 0, .external_lex_state = 308},
  [17781] = {.lex_state = 0, .external_lex_state = 335},
  [17782] = {.lex_state = 0, .external_lex_state = 399},
  [17783] = {.lex_state = 0, .external_lex_state = 416},
  [17784] = {.lex_state = 0, .external_lex_state = 335},
  [17785] = {.lex_state = 0, .external_lex_state = 335},
  [17786] = {.lex_state = 1, .external_lex_state = 441},
  [17787] = {.lex_state = 0, .external_lex_state = 399},
  [17788] = {.lex_state = 0, .external_lex_state = 416},
  [17789] = {.lex_state = 0, .external_lex_state = 308},
  [17790] = {.lex_state = 1, .external_lex_state = 441},
  [17791] = {.lex_state = 0, .external_lex_state = 335},
  [17792] = {.lex_state = 0, .external_lex_state = 335},
  [17793] = {.lex_state = 0, .external_lex_state = 335},
  [17794] = {.lex_state = 0, .external_lex_state = 399},
  [17795] = {.lex_state = 0, .external_lex_state = 335},
  [17796] = {.lex_state = 0, .external_lex_state = 335},
  [17797] = {.lex_state = 0, .external_lex_state = 416},
  [17798] = {.lex_state = 0, .external_lex_state = 335},
  [17799] = {.lex_state = 1, .external_lex_state = 441},
  [17800] = {.lex_state = 1, .external_lex_state = 441},
  [17801] = {.lex_state = 0, .external_lex_state = 308},
  [17802] = {.lex_state = 0, .external_lex_state = 335},
  [17803] = {.lex_state = 1, .external_lex_state = 441},
  [17804] = {.lex_state = 0, .external_lex_state = 335},
  [17805] = {.lex_state = 0, .external_lex_state = 335},
  [17806] = {.lex_state = 0, .external_lex_state = 335},
  [17807] = {.lex_state = 51, .external_lex_state = 308},
  [17808] = {.lex_state = 0, .external_lex_state = 335},
  [17809] = {.lex_state = 0, .external_lex_state = 416},
  [17810] = {.lex_state = 0, .external_lex_state = 335},
  [17811] = {.lex_state = 1, .external_lex_state = 441},
  [17812] = {.lex_state = 0, .external_lex_state = 335},
  [17813] = {.lex_state = 1, .external_lex_state = 441},
  [17814] = {.lex_state = 0, .external_lex_state = 436},
  [17815] = {.lex_state = 1, .external_lex_state = 308},
  [17816] = {.lex_state = 0, .external_lex_state = 308},
  [17817] = {.lex_state = 0, .external_lex_state = 343},
  [17818] = {.lex_state = 1, .external_lex_state = 308},
  [17819] = {.lex_state = 0, .external_lex_state = 343},
  [17820] = {.lex_state = 0, .external_lex_state = 343},
  [17821] = {.lex_state = 0, .external_lex_state = 343},
  [17822] = {.lex_state = 0, .external_lex_state = 343},
  [17823] = {.lex_state = 0, .external_lex_state = 343},
  [17824] = {.lex_state = 0, .external_lex_state = 343},
  [17825] = {.lex_state = 0, .external_lex_state = 343},
  [17826] = {.lex_state = 0, .external_lex_state = 343},
  [17827] = {.lex_state = 0, .external_lex_state = 343},
  [17828] = {.lex_state = 1, .external_lex_state = 308},
  [17829] = {.lex_state = 1, .external_lex_state = 308},
  [17830] = {.lex_state = 0, .external_lex_state = 343},
  [17831] = {.lex_state = 1, .external_lex_state = 308},
  [17832] = {.lex_state = 0, .external_lex_state = 343},
  [17833] = {.lex_state = 0, .external_lex_state = 343},
  [17834] = {.lex_state = 0, .external_lex_state = 343},
  [17835] = {.lex_state = 0, .external_lex_state = 343},
  [17836] = {.lex_state = 0, .external_lex_state = 308},
  [17837] = {.lex_state = 0, .external_lex_state = 335},
  [17838] = {.lex_state = 1, .external_lex_state = 308},
  [17839] = {.lex_state = 0, .external_lex_state = 343},
  [17840] = {.lex_state = 0, .external_lex_state = 343},
  [17841] = {.lex_state = 1, .external_lex_state = 308},
  [17842] = {.lex_state = 0, .external_lex_state = 343},
  [17843] = {.lex_state = 1, .external_lex_state = 308},
  [17844] = {.lex_state = 0, .external_lex_state = 335},
  [17845] = {.lex_state = 0, .external_lex_state = 308},
  [17846] = {.lex_state = 0, .external_lex_state = 335},
  [17847] = {.lex_state = 1, .external_lex_state = 308},
  [17848] = {.lex_state = 0, .external_lex_state = 308},
  [17849] = {.lex_state = 0, .external_lex_state = 335},
  [17850] = {.lex_state = 0, .external_lex_state = 335},
  [17851] = {.lex_state = 0, .external_lex_state = 335},
  [17852] = {.lex_state = 0, .external_lex_state = 335},
  [17853] = {.lex_state = 1, .external_lex_state = 308},
  [17854] = {.lex_state = 0, .external_lex_state = 308},
  [17855] = {.lex_state = 0, .external_lex_state = 335},
  [17856] = {.lex_state = 0, .external_lex_state = 335},
  [17857] = {.lex_state = 0, .external_lex_state = 335},
  [17858] = {.lex_state = 1, .external_lex_state = 308},
  [17859] = {.lex_state = 0, .external_lex_state = 335},
  [17860] = {.lex_state = 47, .external_lex_state = 308},
  [17861] = {.lex_state = 0, .external_lex_state = 335},
  [17862] = {.lex_state = 0, .external_lex_state = 335},
  [17863] = {.lex_state = 0, .external_lex_state = 335},
  [17864] = {.lex_state = 0, .external_lex_state = 335},
  [17865] = {.lex_state = 1, .external_lex_state = 308},
  [17866] = {.lex_state = 0, .external_lex_state = 335},
  [17867] = {.lex_state = 0, .external_lex_state = 335},
  [17868] = {.lex_state = 0, .external_lex_state = 335},
  [17869] = {.lex_state = 0, .external_lex_state = 335},
  [17870] = {.lex_state = 0, .external_lex_state = 335},
  [17871] = {.lex_state = 0, .external_lex_state = 335},
  [17872] = {.lex_state = 1, .external_lex_state = 308},
  [17873] = {.lex_state = 0, .external_lex_state = 335},
  [17874] = {.lex_state = 0, .external_lex_state = 335},
  [17875] = {.lex_state = 0, .external_lex_state = 335},
  [17876] = {.lex_state = 1, .external_lex_state = 308},
  [17877] = {.lex_state = 0, .external_lex_state = 336},
  [17878] = {.lex_state = 0, .external_lex_state = 336},
  [17879] = {.lex_state = 0, .external_lex_state = 335},
  [17880] = {.lex_state = 0, .external_lex_state = 336},
  [17881] = {.lex_state = 0, .external_lex_state = 335},
  [17882] = {.lex_state = 1, .external_lex_state = 308},
  [17883] = {.lex_state = 0, .external_lex_state = 336},
  [17884] = {.lex_state = 0, .external_lex_state = 335},
  [17885] = {.lex_state = 0, .external_lex_state = 336},
  [17886] = {.lex_state = 0, .external_lex_state = 335},
  [17887] = {.lex_state = 1, .external_lex_state = 308},
  [17888] = {.lex_state = 0, .external_lex_state = 336},
  [17889] = {.lex_state = 1, .external_lex_state = 308},
  [17890] = {.lex_state = 0, .external_lex_state = 335},
  [17891] = {.lex_state = 0, .external_lex_state = 308},
  [17892] = {.lex_state = 0, .external_lex_state = 335},
  [17893] = {.lex_state = 47, .external_lex_state = 308},
  [17894] = {.lex_state = 0, .external_lex_state = 336},
  [17895] = {.lex_state = 0, .external_lex_state = 335},
  [17896] = {.lex_state = 0, .external_lex_state = 335},
  [17897] = {.lex_state = 0, .external_lex_state = 336},
  [17898] = {.lex_state = 0, .external_lex_state = 335},
  [17899] = {.lex_state = 0, .external_lex_state = 336},
  [17900] = {.lex_state = 0, .external_lex_state = 336},
  [17901] = {.lex_state = 1, .external_lex_state = 308},
  [17902] = {.lex_state = 0, .external_lex_state = 335},
  [17903] = {.lex_state = 0, .external_lex_state = 336},
  [17904] = {.lex_state = 47, .external_lex_state = 308},
  [17905] = {.lex_state = 1, .external_lex_state = 308},
  [17906] = {.lex_state = 1, .external_lex_state = 308},
  [17907] = {.lex_state = 0, .external_lex_state = 336},
  [17908] = {.lex_state = 0, .external_lex_state = 336},
  [17909] = {.lex_state = 0, .external_lex_state = 336},
  [17910] = {.lex_state = 0, .external_lex_state = 335},
  [17911] = {.lex_state = 0, .external_lex_state = 336},
  [17912] = {.lex_state = 47, .external_lex_state = 443},
  [17913] = {.lex_state = 0, .external_lex_state = 336},
  [17914] = {.lex_state = 0, .external_lex_state = 436},
  [17915] = {.lex_state = 0, .external_lex_state = 336},
  [17916] = {.lex_state = 1, .external_lex_state = 308},
  [17917] = {.lex_state = 0, .external_lex_state = 335},
  [17918] = {.lex_state = 1, .external_lex_state = 308},
  [17919] = {.lex_state = 0, .external_lex_state = 336},
  [17920] = {.lex_state = 1, .external_lex_state = 308},
  [17921] = {.lex_state = 0, .external_lex_state = 308},
  [17922] = {.lex_state = 0, .external_lex_state = 336},
  [17923] = {.lex_state = 1, .external_lex_state = 308},
  [17924] = {.lex_state = 0, .external_lex_state = 335},
  [17925] = {.lex_state = 0, .external_lex_state = 336},
  [17926] = {.lex_state = 0, .external_lex_state = 308},
  [17927] = {.lex_state = 0, .external_lex_state = 336},
  [17928] = {.lex_state = 3, .external_lex_state = 308},
  [17929] = {.lex_state = 47, .external_lex_state = 443},
  [17930] = {.lex_state = 1, .external_lex_state = 308},
  [17931] = {.lex_state = 0, .external_lex_state = 336},
  [17932] = {.lex_state = 0, .external_lex_state = 336},
  [17933] = {.lex_state = 0, .external_lex_state = 336},
  [17934] = {.lex_state = 1, .external_lex_state = 308},
  [17935] = {.lex_state = 1, .external_lex_state = 308},
  [17936] = {.lex_state = 0, .external_lex_state = 335},
  [17937] = {.lex_state = 47, .external_lex_state = 308},
  [17938] = {.lex_state = 0, .external_lex_state = 308},
  [17939] = {.lex_state = 0, .external_lex_state = 336},
  [17940] = {.lex_state = 0, .external_lex_state = 308},
  [17941] = {.lex_state = 47, .external_lex_state = 443},
  [17942] = {.lex_state = 47, .external_lex_state = 400},
  [17943] = {.lex_state = 47, .external_lex_state = 308},
  [17944] = {.lex_state = 0, .external_lex_state = 336},
  [17945] = {.lex_state = 1, .external_lex_state = 308},
  [17946] = {.lex_state = 47, .external_lex_state = 400},
  [17947] = {.lex_state = 47, .external_lex_state = 308},
  [17948] = {.lex_state = 0, .external_lex_state = 336},
  [17949] = {.lex_state = 47, .external_lex_state = 308},
  [17950] = {.lex_state = 1, .external_lex_state = 308},
  [17951] = {.lex_state = 1, .external_lex_state = 308},
  [17952] = {.lex_state = 0, .external_lex_state = 336},
  [17953] = {.lex_state = 47, .external_lex_state = 308},
  [17954] = {.lex_state = 1, .external_lex_state = 308},
  [17955] = {.lex_state = 0, .external_lex_state = 336},
  [17956] = {.lex_state = 47, .external_lex_state = 308},
  [17957] = {.lex_state = 0, .external_lex_state = 336},
  [17958] = {.lex_state = 0, .external_lex_state = 308},
  [17959] = {.lex_state = 1, .external_lex_state = 308},
  [17960] = {.lex_state = 47, .external_lex_state = 308},
  [17961] = {.lex_state = 3, .external_lex_state = 308},
  [17962] = {.lex_state = 0, .external_lex_state = 336},
  [17963] = {.lex_state = 1, .external_lex_state = 308},
  [17964] = {.lex_state = 47, .external_lex_state = 308},
  [17965] = {.lex_state = 47, .external_lex_state = 308},
  [17966] = {.lex_state = 0, .external_lex_state = 336},
  [17967] = {.lex_state = 1, .external_lex_state = 308},
  [17968] = {.lex_state = 47, .external_lex_state = 308},
  [17969] = {.lex_state = 1, .external_lex_state = 308},
  [17970] = {.lex_state = 0, .external_lex_state = 336},
  [17971] = {.lex_state = 47, .external_lex_state = 308},
  [17972] = {.lex_state = 0, .external_lex_state = 336},
  [17973] = {.lex_state = 47, .external_lex_state = 443},
  [17974] = {.lex_state = 1, .external_lex_state = 308},
  [17975] = {.lex_state = 3, .external_lex_state = 308},
  [17976] = {.lex_state = 47, .external_lex_state = 308},
  [17977] = {.lex_state = 0, .external_lex_state = 336},
  [17978] = {.lex_state = 1, .external_lex_state = 308},
  [17979] = {.lex_state = 0, .external_lex_state = 416},
  [17980] = {.lex_state = 47, .external_lex_state = 308},
  [17981] = {.lex_state = 3, .external_lex_state = 308},
  [17982] = {.lex_state = 1, .external_lex_state = 308},
  [17983] = {.lex_state = 0, .external_lex_state = 336},
  [17984] = {.lex_state = 47, .external_lex_state = 308},
  [17985] = {.lex_state = 0, .external_lex_state = 336},
  [17986] = {.lex_state = 47, .external_lex_state = 308},
  [17987] = {.lex_state = 47, .external_lex_state = 308},
  [17988] = {.lex_state = 1, .external_lex_state = 308},
  [17989] = {.lex_state = 1, .external_lex_state = 308},
  [17990] = {.lex_state = 0, .external_lex_state = 336},
  [17991] = {.lex_state = 47, .external_lex_state = 308},
  [17992] = {.lex_state = 1, .external_lex_state = 308},
  [17993] = {.lex_state = 47, .external_lex_state = 308},
  [17994] = {.lex_state = 0, .external_lex_state = 336},
  [17995] = {.lex_state = 47, .external_lex_state = 308},
  [17996] = {.lex_state = 47, .external_lex_state = 308},
  [17997] = {.lex_state = 1, .external_lex_state = 308},
  [17998] = {.lex_state = 1, .external_lex_state = 308},
  [17999] = {.lex_state = 0, .external_lex_state = 336},
  [18000] = {.lex_state = 47, .external_lex_state = 308},
  [18001] = {.lex_state = 47, .external_lex_state = 308},
  [18002] = {.lex_state = 47, .external_lex_state = 308},
  [18003] = {.lex_state = 1, .external_lex_state = 308},
  [18004] = {.lex_state = 0, .external_lex_state = 336},
  [18005] = {.lex_state = 47, .external_lex_state = 308},
  [18006] = {.lex_state = 47, .external_lex_state = 308},
  [18007] = {.lex_state = 0, .external_lex_state = 336},
  [18008] = {.lex_state = 47, .external_lex_state = 308},
  [18009] = {.lex_state = 1, .external_lex_state = 308},
  [18010] = {.lex_state = 47, .external_lex_state = 308},
  [18011] = {.lex_state = 0, .external_lex_state = 336},
  [18012] = {.lex_state = 47, .external_lex_state = 308},
  [18013] = {.lex_state = 1, .external_lex_state = 308},
  [18014] = {.lex_state = 3, .external_lex_state = 308},
  [18015] = {.lex_state = 47, .external_lex_state = 308},
  [18016] = {.lex_state = 0, .external_lex_state = 308},
  [18017] = {.lex_state = 1, .external_lex_state = 308},
  [18018] = {.lex_state = 47, .external_lex_state = 308},
  [18019] = {.lex_state = 47, .external_lex_state = 308},
  [18020] = {.lex_state = 0, .external_lex_state = 336},
  [18021] = {.lex_state = 1, .external_lex_state = 308},
  [18022] = {.lex_state = 0, .external_lex_state = 355},
  [18023] = {.lex_state = 47, .external_lex_state = 308},
  [18024] = {.lex_state = 47, .external_lex_state = 308},
  [18025] = {.lex_state = 0, .external_lex_state = 308},
  [18026] = {.lex_state = 0, .external_lex_state = 343},
  [18027] = {.lex_state = 47, .external_lex_state = 308},
  [18028] = {.lex_state = 1, .external_lex_state = 308},
  [18029] = {.lex_state = 47, .external_lex_state = 308},
  [18030] = {.lex_state = 0, .external_lex_state = 336},
  [18031] = {.lex_state = 0, .external_lex_state = 335},
  [18032] = {.lex_state = 1, .external_lex_state = 308},
  [18033] = {.lex_state = 47, .external_lex_state = 308},
  [18034] = {.lex_state = 47, .external_lex_state = 308},
  [18035] = {.lex_state = 0, .external_lex_state = 335},
  [18036] = {.lex_state = 0, .external_lex_state = 308},
  [18037] = {.lex_state = 1, .external_lex_state = 308},
  [18038] = {.lex_state = 1, .external_lex_state = 308},
  [18039] = {.lex_state = 47, .external_lex_state = 308},
  [18040] = {.lex_state = 0, .external_lex_state = 335},
  [18041] = {.lex_state = 0, .external_lex_state = 336},
  [18042] = {.lex_state = 1, .external_lex_state = 308},
  [18043] = {.lex_state = 1, .external_lex_state = 308},
  [18044] = {.lex_state = 0, .external_lex_state = 308},
  [18045] = {.lex_state = 47, .external_lex_state = 308},
  [18046] = {.lex_state = 1, .external_lex_state = 308},
  [18047] = {.lex_state = 0, .external_lex_state = 308},
  [18048] = {.lex_state = 47, .external_lex_state = 422},
  [18049] = {.lex_state = 47, .external_lex_state = 308},
  [18050] = {.lex_state = 1, .external_lex_state = 308},
  [18051] = {.lex_state = 47, .external_lex_state = 308},
  [18052] = {.lex_state = 0, .external_lex_state = 308},
  [18053] = {.lex_state = 1, .external_lex_state = 308},
  [18054] = {.lex_state = 1, .external_lex_state = 308},
  [18055] = {.lex_state = 1, .external_lex_state = 308},
  [18056] = {.lex_state = 3, .external_lex_state = 308},
  [18057] = {.lex_state = 0, .external_lex_state = 308},
  [18058] = {.lex_state = 1, .external_lex_state = 308},
  [18059] = {.lex_state = 0, .external_lex_state = 308},
  [18060] = {.lex_state = 1, .external_lex_state = 308},
  [18061] = {.lex_state = 1, .external_lex_state = 308},
  [18062] = {.lex_state = 3, .external_lex_state = 308},
  [18063] = {.lex_state = 0, .external_lex_state = 308},
  [18064] = {.lex_state = 3, .external_lex_state = 308},
  [18065] = {.lex_state = 0, .external_lex_state = 308},
  [18066] = {.lex_state = 1, .external_lex_state = 308},
  [18067] = {.lex_state = 0, .external_lex_state = 308},
  [18068] = {.lex_state = 1, .external_lex_state = 308},
  [18069] = {.lex_state = 0, .external_lex_state = 335},
  [18070] = {.lex_state = 0, .external_lex_state = 308},
  [18071] = {.lex_state = 1, .external_lex_state = 308},
  [18072] = {.lex_state = 0, .external_lex_state = 308},
  [18073] = {.lex_state = 47, .external_lex_state = 308},
  [18074] = {.lex_state = 47, .external_lex_state = 400},
  [18075] = {.lex_state = 1, .external_lex_state = 308},
  [18076] = {.lex_state = 1, .external_lex_state = 308},
  [18077] = {.lex_state = 0, .external_lex_state = 436},
  [18078] = {.lex_state = 0, .external_lex_state = 308},
  [18079] = {.lex_state = 1, .external_lex_state = 308},
  [18080] = {.lex_state = 0, .external_lex_state = 308},
  [18081] = {.lex_state = 0, .external_lex_state = 308},
  [18082] = {.lex_state = 1, .external_lex_state = 308},
  [18083] = {.lex_state = 0, .external_lex_state = 308},
  [18084] = {.lex_state = 0, .external_lex_state = 308},
  [18085] = {.lex_state = 0, .external_lex_state = 308},
  [18086] = {.lex_state = 0, .external_lex_state = 308},
  [18087] = {.lex_state = 1, .external_lex_state = 308},
  [18088] = {.lex_state = 47, .external_lex_state = 443},
  [18089] = {.lex_state = 0, .external_lex_state = 336},
  [18090] = {.lex_state = 1, .external_lex_state = 308},
  [18091] = {.lex_state = 0, .external_lex_state = 308},
  [18092] = {.lex_state = 0, .external_lex_state = 308},
  [18093] = {.lex_state = 1, .external_lex_state = 308},
  [18094] = {.lex_state = 1, .external_lex_state = 308},
  [18095] = {.lex_state = 0, .external_lex_state = 335},
  [18096] = {.lex_state = 1, .external_lex_state = 308},
  [18097] = {.lex_state = 47, .external_lex_state = 308},
  [18098] = {.lex_state = 3, .external_lex_state = 308},
  [18099] = {.lex_state = 1, .external_lex_state = 308},
  [18100] = {.lex_state = 0, .external_lex_state = 335},
  [18101] = {.lex_state = 1, .external_lex_state = 308},
  [18102] = {.lex_state = 3, .external_lex_state = 308},
  [18103] = {.lex_state = 47, .external_lex_state = 308},
  [18104] = {.lex_state = 1, .external_lex_state = 308},
  [18105] = {.lex_state = 0, .external_lex_state = 308},
  [18106] = {.lex_state = 1, .external_lex_state = 308},
  [18107] = {.lex_state = 0, .external_lex_state = 335},
  [18108] = {.lex_state = 1, .external_lex_state = 308},
  [18109] = {.lex_state = 1, .external_lex_state = 308},
  [18110] = {.lex_state = 1, .external_lex_state = 308},
  [18111] = {.lex_state = 0, .external_lex_state = 335},
  [18112] = {.lex_state = 0, .external_lex_state = 308},
  [18113] = {.lex_state = 0, .external_lex_state = 308},
  [18114] = {.lex_state = 0, .external_lex_state = 308},
  [18115] = {.lex_state = 0, .external_lex_state = 335},
  [18116] = {.lex_state = 0, .external_lex_state = 336},
  [18117] = {.lex_state = 1, .external_lex_state = 308},
  [18118] = {.lex_state = 1, .external_lex_state = 308},
  [18119] = {.lex_state = 1, .external_lex_state = 308},
  [18120] = {.lex_state = 0, .external_lex_state = 335},
  [18121] = {.lex_state = 0, .external_lex_state = 308},
  [18122] = {.lex_state = 47, .external_lex_state = 308},
  [18123] = {.lex_state = 0, .external_lex_state = 308},
  [18124] = {.lex_state = 0, .external_lex_state = 308},
  [18125] = {.lex_state = 1, .external_lex_state = 308},
  [18126] = {.lex_state = 47, .external_lex_state = 308},
  [18127] = {.lex_state = 1, .external_lex_state = 308},
  [18128] = {.lex_state = 3, .external_lex_state = 308},
  [18129] = {.lex_state = 0, .external_lex_state = 308},
  [18130] = {.lex_state = 0, .external_lex_state = 308},
  [18131] = {.lex_state = 0, .external_lex_state = 308},
  [18132] = {.lex_state = 0, .external_lex_state = 308},
  [18133] = {.lex_state = 1, .external_lex_state = 308},
  [18134] = {.lex_state = 1, .external_lex_state = 308},
  [18135] = {.lex_state = 0, .external_lex_state = 308},
  [18136] = {.lex_state = 0, .external_lex_state = 308},
  [18137] = {.lex_state = 1, .external_lex_state = 308},
  [18138] = {.lex_state = 1, .external_lex_state = 308},
  [18139] = {.lex_state = 0, .external_lex_state = 335},
  [18140] = {.lex_state = 3, .external_lex_state = 308},
  [18141] = {.lex_state = 0, .external_lex_state = 335},
  [18142] = {.lex_state = 0, .external_lex_state = 436},
  [18143] = {.lex_state = 0, .external_lex_state = 308},
  [18144] = {.lex_state = 1, .external_lex_state = 308},
  [18145] = {.lex_state = 1, .external_lex_state = 308},
  [18146] = {.lex_state = 0, .external_lex_state = 355},
  [18147] = {.lex_state = 0, .external_lex_state = 308},
  [18148] = {.lex_state = 1, .external_lex_state = 308},
  [18149] = {.lex_state = 3, .external_lex_state = 308},
  [18150] = {.lex_state = 1, .external_lex_state = 308},
  [18151] = {.lex_state = 3, .external_lex_state = 308},
  [18152] = {.lex_state = 0, .external_lex_state = 436},
  [18153] = {.lex_state = 1, .external_lex_state = 308},
  [18154] = {.lex_state = 0, .external_lex_state = 335},
  [18155] = {.lex_state = 0, .external_lex_state = 335},
  [18156] = {.lex_state = 3, .external_lex_state = 308},
  [18157] = {.lex_state = 0, .external_lex_state = 436},
  [18158] = {.lex_state = 0, .external_lex_state = 308},
  [18159] = {.lex_state = 0, .external_lex_state = 308},
  [18160] = {.lex_state = 1, .external_lex_state = 308},
  [18161] = {.lex_state = 0, .external_lex_state = 335},
  [18162] = {.lex_state = 1, .external_lex_state = 308},
  [18163] = {.lex_state = 1, .external_lex_state = 308},
  [18164] = {.lex_state = 47, .external_lex_state = 443},
  [18165] = {.lex_state = 0, .external_lex_state = 308},
  [18166] = {.lex_state = 1, .external_lex_state = 308},
  [18167] = {.lex_state = 3, .external_lex_state = 308},
  [18168] = {.lex_state = 0, .external_lex_state = 436},
  [18169] = {.lex_state = 0, .external_lex_state = 308},
  [18170] = {.lex_state = 0, .external_lex_state = 308},
  [18171] = {.lex_state = 0, .external_lex_state = 308},
  [18172] = {.lex_state = 1, .external_lex_state = 308},
  [18173] = {.lex_state = 1, .external_lex_state = 308},
  [18174] = {.lex_state = 0, .external_lex_state = 308},
  [18175] = {.lex_state = 3, .external_lex_state = 308},
  [18176] = {.lex_state = 0, .external_lex_state = 436},
  [18177] = {.lex_state = 1, .external_lex_state = 308},
  [18178] = {.lex_state = 0, .external_lex_state = 308},
  [18179] = {.lex_state = 0, .external_lex_state = 335},
  [18180] = {.lex_state = 3, .external_lex_state = 308},
  [18181] = {.lex_state = 1, .external_lex_state = 308},
  [18182] = {.lex_state = 3, .external_lex_state = 308},
  [18183] = {.lex_state = 0, .external_lex_state = 436},
  [18184] = {.lex_state = 0, .external_lex_state = 308},
  [18185] = {.lex_state = 0, .external_lex_state = 308},
  [18186] = {.lex_state = 0, .external_lex_state = 335},
  [18187] = {.lex_state = 3, .external_lex_state = 308},
  [18188] = {.lex_state = 0, .external_lex_state = 436},
  [18189] = {.lex_state = 3, .external_lex_state = 308},
  [18190] = {.lex_state = 0, .external_lex_state = 308},
  [18191] = {.lex_state = 1, .external_lex_state = 308},
  [18192] = {.lex_state = 0, .external_lex_state = 335},
  [18193] = {.lex_state = 0, .external_lex_state = 416},
  [18194] = {.lex_state = 0, .external_lex_state = 308},
  [18195] = {.lex_state = 1, .external_lex_state = 308},
  [18196] = {.lex_state = 3, .external_lex_state = 308},
  [18197] = {.lex_state = 1, .external_lex_state = 308},
  [18198] = {.lex_state = 47, .external_lex_state = 422},
  [18199] = {.lex_state = 0, .external_lex_state = 436},
  [18200] = {.lex_state = 0, .external_lex_state = 308},
  [18201] = {.lex_state = 0, .external_lex_state = 308},
  [18202] = {.lex_state = 1, .external_lex_state = 308},
  [18203] = {.lex_state = 0, .external_lex_state = 336},
  [18204] = {.lex_state = 3, .external_lex_state = 308},
  [18205] = {.lex_state = 3, .external_lex_state = 308},
  [18206] = {.lex_state = 1, .external_lex_state = 308},
  [18207] = {.lex_state = 0, .external_lex_state = 436},
  [18208] = {.lex_state = 1, .external_lex_state = 308},
  [18209] = {.lex_state = 1, .external_lex_state = 308},
  [18210] = {.lex_state = 1, .external_lex_state = 308},
  [18211] = {.lex_state = 0, .external_lex_state = 308},
  [18212] = {.lex_state = 3, .external_lex_state = 308},
  [18213] = {.lex_state = 0, .external_lex_state = 436},
  [18214] = {.lex_state = 0, .external_lex_state = 308},
  [18215] = {.lex_state = 0, .external_lex_state = 335},
  [18216] = {.lex_state = 1, .external_lex_state = 308},
  [18217] = {.lex_state = 47, .external_lex_state = 308},
  [18218] = {.lex_state = 0, .external_lex_state = 308},
  [18219] = {.lex_state = 1, .external_lex_state = 308},
  [18220] = {.lex_state = 1, .external_lex_state = 308},
  [18221] = {.lex_state = 3, .external_lex_state = 308},
  [18222] = {.lex_state = 0, .external_lex_state = 308},
  [18223] = {.lex_state = 0, .external_lex_state = 436},
  [18224] = {.lex_state = 1, .external_lex_state = 308},
  [18225] = {.lex_state = 47, .external_lex_state = 308},
  [18226] = {.lex_state = 0, .external_lex_state = 308},
  [18227] = {.lex_state = 0, .external_lex_state = 335},
  [18228] = {.lex_state = 0, .external_lex_state = 308},
  [18229] = {.lex_state = 0, .external_lex_state = 335},
  [18230] = {.lex_state = 0, .external_lex_state = 436},
  [18231] = {.lex_state = 3, .external_lex_state = 308},
  [18232] = {.lex_state = 0, .external_lex_state = 335},
  [18233] = {.lex_state = 1, .external_lex_state = 308},
  [18234] = {.lex_state = 0, .external_lex_state = 436},
  [18235] = {.lex_state = 1, .external_lex_state = 308},
  [18236] = {.lex_state = 0, .external_lex_state = 308},
  [18237] = {.lex_state = 1, .external_lex_state = 308},
  [18238] = {.lex_state = 3, .external_lex_state = 308},
  [18239] = {.lex_state = 47, .external_lex_state = 308},
  [18240] = {.lex_state = 3, .external_lex_state = 308},
  [18241] = {.lex_state = 0, .external_lex_state = 335},
  [18242] = {.lex_state = 0, .external_lex_state = 436},
  [18243] = {.lex_state = 47, .external_lex_state = 443},
  [18244] = {.lex_state = 0, .external_lex_state = 308},
  [18245] = {.lex_state = 47, .external_lex_state = 443},
  [18246] = {.lex_state = 1, .external_lex_state = 308},
  [18247] = {.lex_state = 47, .external_lex_state = 400},
  [18248] = {.lex_state = 1, .external_lex_state = 308},
  [18249] = {.lex_state = 1, .external_lex_state = 308},
  [18250] = {.lex_state = 0, .external_lex_state = 308},
  [18251] = {.lex_state = 0, .external_lex_state = 336},
  [18252] = {.lex_state = 3, .external_lex_state = 308},
  [18253] = {.lex_state = 1, .external_lex_state = 308},
  [18254] = {.lex_state = 0, .external_lex_state = 436},
  [18255] = {.lex_state = 47, .external_lex_state = 308},
  [18256] = {.lex_state = 1, .external_lex_state = 308},
  [18257] = {.lex_state = 3, .external_lex_state = 308},
  [18258] = {.lex_state = 0, .external_lex_state = 335},
  [18259] = {.lex_state = 1, .external_lex_state = 308},
  [18260] = {.lex_state = 0, .external_lex_state = 335},
  [18261] = {.lex_state = 3, .external_lex_state = 308},
  [18262] = {.lex_state = 0, .external_lex_state = 335},
  [18263] = {.lex_state = 0, .external_lex_state = 436},
  [18264] = {.lex_state = 1, .external_lex_state = 308},
  [18265] = {.lex_state = 1, .external_lex_state = 308},
  [18266] = {.lex_state = 0, .external_lex_state = 308},
  [18267] = {.lex_state = 0, .external_lex_state = 336},
  [18268] = {.lex_state = 3, .external_lex_state = 308},
  [18269] = {.lex_state = 47, .external_lex_state = 400},
  [18270] = {.lex_state = 0, .external_lex_state = 335},
  [18271] = {.lex_state = 0, .external_lex_state = 436},
  [18272] = {.lex_state = 0, .external_lex_state = 308},
  [18273] = {.lex_state = 1, .external_lex_state = 308},
  [18274] = {.lex_state = 47, .external_lex_state = 308},
  [18275] = {.lex_state = 3, .external_lex_state = 308},
  [18276] = {.lex_state = 0, .external_lex_state = 436},
  [18277] = {.lex_state = 0, .external_lex_state = 335},
  [18278] = {.lex_state = 1, .external_lex_state = 308},
  [18279] = {.lex_state = 0, .external_lex_state = 308},
  [18280] = {.lex_state = 0, .external_lex_state = 335},
  [18281] = {.lex_state = 3, .external_lex_state = 308},
  [18282] = {.lex_state = 1, .external_lex_state = 308},
  [18283] = {.lex_state = 0, .external_lex_state = 308},
  [18284] = {.lex_state = 1, .external_lex_state = 308},
  [18285] = {.lex_state = 3, .external_lex_state = 308},
  [18286] = {.lex_state = 1, .external_lex_state = 308},
  [18287] = {.lex_state = 0, .external_lex_state = 436},
  [18288] = {.lex_state = 3, .external_lex_state = 308},
  [18289] = {.lex_state = 0, .external_lex_state = 335},
  [18290] = {.lex_state = 0, .external_lex_state = 336},
  [18291] = {.lex_state = 1, .external_lex_state = 308},
  [18292] = {.lex_state = 3, .external_lex_state = 308},
  [18293] = {.lex_state = 1, .external_lex_state = 308},
  [18294] = {.lex_state = 1, .external_lex_state = 308},
  [18295] = {.lex_state = 0, .external_lex_state = 436},
  [18296] = {.lex_state = 0, .external_lex_state = 308},
  [18297] = {.lex_state = 1, .external_lex_state = 308},
  [18298] = {.lex_state = 3, .external_lex_state = 308},
  [18299] = {.lex_state = 0, .external_lex_state = 335},
  [18300] = {.lex_state = 0, .external_lex_state = 436},
  [18301] = {.lex_state = 1, .external_lex_state = 308},
  [18302] = {.lex_state = 0, .external_lex_state = 335},
  [18303] = {.lex_state = 0, .external_lex_state = 335},
  [18304] = {.lex_state = 47, .external_lex_state = 308},
  [18305] = {.lex_state = 47, .external_lex_state = 308},
  [18306] = {.lex_state = 0, .external_lex_state = 335},
  [18307] = {.lex_state = 1, .external_lex_state = 308},
  [18308] = {.lex_state = 0, .external_lex_state = 335},
  [18309] = {.lex_state = 3, .external_lex_state = 308},
  [18310] = {.lex_state = 0, .external_lex_state = 436},
  [18311] = {.lex_state = 1, .external_lex_state = 308},
  [18312] = {.lex_state = 1, .external_lex_state = 308},
  [18313] = {.lex_state = 47, .external_lex_state = 400},
  [18314] = {.lex_state = 47, .external_lex_state = 308},
  [18315] = {.lex_state = 0, .external_lex_state = 308},
  [18316] = {.lex_state = 0, .external_lex_state = 308},
  [18317] = {.lex_state = 3, .external_lex_state = 308},
  [18318] = {.lex_state = 47, .external_lex_state = 443},
  [18319] = {.lex_state = 0, .external_lex_state = 436},
  [18320] = {.lex_state = 1, .external_lex_state = 308},
  [18321] = {.lex_state = 47, .external_lex_state = 443},
  [18322] = {.lex_state = 1, .external_lex_state = 308},
  [18323] = {.lex_state = 0, .external_lex_state = 308},
  [18324] = {.lex_state = 3, .external_lex_state = 308},
  [18325] = {.lex_state = 0, .external_lex_state = 436},
  [18326] = {.lex_state = 1, .external_lex_state = 308},
  [18327] = {.lex_state = 3, .external_lex_state = 308},
  [18328] = {.lex_state = 1, .external_lex_state = 308},
  [18329] = {.lex_state = 1, .external_lex_state = 308},
  [18330] = {.lex_state = 3, .external_lex_state = 308},
  [18331] = {.lex_state = 0, .external_lex_state = 308},
  [18332] = {.lex_state = 0, .external_lex_state = 436},
  [18333] = {.lex_state = 0, .external_lex_state = 335},
  [18334] = {.lex_state = 0, .external_lex_state = 308},
  [18335] = {.lex_state = 1, .external_lex_state = 308},
  [18336] = {.lex_state = 1, .external_lex_state = 308},
  [18337] = {.lex_state = 0, .external_lex_state = 308},
  [18338] = {.lex_state = 0, .external_lex_state = 308},
  [18339] = {.lex_state = 0, .external_lex_state = 308},
  [18340] = {.lex_state = 1, .external_lex_state = 308},
  [18341] = {.lex_state = 3, .external_lex_state = 308},
  [18342] = {.lex_state = 1, .external_lex_state = 308},
  [18343] = {.lex_state = 0, .external_lex_state = 308},
  [18344] = {.lex_state = 0, .external_lex_state = 436},
  [18345] = {.lex_state = 0, .external_lex_state = 335},
  [18346] = {.lex_state = 0, .external_lex_state = 308},
  [18347] = {.lex_state = 0, .external_lex_state = 308},
  [18348] = {.lex_state = 0, .external_lex_state = 335},
  [18349] = {.lex_state = 0, .external_lex_state = 308},
  [18350] = {.lex_state = 3, .external_lex_state = 308},
  [18351] = {.lex_state = 1, .external_lex_state = 308},
  [18352] = {.lex_state = 0, .external_lex_state = 436},
  [18353] = {.lex_state = 1, .external_lex_state = 308},
  [18354] = {.lex_state = 0, .external_lex_state = 335},
  [18355] = {.lex_state = 0, .external_lex_state = 308},
  [18356] = {.lex_state = 0, .external_lex_state = 308},
  [18357] = {.lex_state = 1, .external_lex_state = 308},
  [18358] = {.lex_state = 0, .external_lex_state = 336},
  [18359] = {.lex_state = 0, .external_lex_state = 308},
  [18360] = {.lex_state = 0, .external_lex_state = 335},
  [18361] = {.lex_state = 1, .external_lex_state = 308},
  [18362] = {.lex_state = 47, .external_lex_state = 400},
  [18363] = {.lex_state = 1, .external_lex_state = 308},
  [18364] = {.lex_state = 3, .external_lex_state = 308},
  [18365] = {.lex_state = 1, .external_lex_state = 308},
  [18366] = {.lex_state = 0, .external_lex_state = 336},
  [18367] = {.lex_state = 0, .external_lex_state = 436},
  [18368] = {.lex_state = 1, .external_lex_state = 308},
  [18369] = {.lex_state = 1, .external_lex_state = 308},
  [18370] = {.lex_state = 1, .external_lex_state = 308},
  [18371] = {.lex_state = 3, .external_lex_state = 308},
  [18372] = {.lex_state = 0, .external_lex_state = 308},
  [18373] = {.lex_state = 3, .external_lex_state = 308},
  [18374] = {.lex_state = 3, .external_lex_state = 308},
  [18375] = {.lex_state = 0, .external_lex_state = 436},
  [18376] = {.lex_state = 1, .external_lex_state = 308},
  [18377] = {.lex_state = 47, .external_lex_state = 308},
  [18378] = {.lex_state = 47, .external_lex_state = 422},
  [18379] = {.lex_state = 1, .external_lex_state = 308},
  [18380] = {.lex_state = 1, .external_lex_state = 308},
  [18381] = {.lex_state = 47, .external_lex_state = 308},
  [18382] = {.lex_state = 47, .external_lex_state = 308},
  [18383] = {.lex_state = 3, .external_lex_state = 308},
  [18384] = {.lex_state = 1, .external_lex_state = 308},
  [18385] = {.lex_state = 0, .external_lex_state = 436},
  [18386] = {.lex_state = 47, .external_lex_state = 443},
  [18387] = {.lex_state = 0, .external_lex_state = 335},
  [18388] = {.lex_state = 1, .external_lex_state = 308},
  [18389] = {.lex_state = 1, .external_lex_state = 308},
  [18390] = {.lex_state = 3, .external_lex_state = 308},
  [18391] = {.lex_state = 1, .external_lex_state = 308},
  [18392] = {.lex_state = 0, .external_lex_state = 436},
  [18393] = {.lex_state = 1, .external_lex_state = 308},
  [18394] = {.lex_state = 1, .external_lex_state = 308},
  [18395] = {.lex_state = 0, .external_lex_state = 335},
  [18396] = {.lex_state = 1, .external_lex_state = 308},
  [18397] = {.lex_state = 3, .external_lex_state = 308},
  [18398] = {.lex_state = 1, .external_lex_state = 308},
  [18399] = {.lex_state = 0, .external_lex_state = 335},
  [18400] = {.lex_state = 3, .external_lex_state = 308},
  [18401] = {.lex_state = 0, .external_lex_state = 436},
  [18402] = {.lex_state = 1, .external_lex_state = 308},
  [18403] = {.lex_state = 0, .external_lex_state = 335},
  [18404] = {.lex_state = 3, .external_lex_state = 308},
  [18405] = {.lex_state = 1, .external_lex_state = 308},
  [18406] = {.lex_state = 0, .external_lex_state = 436},
  [18407] = {.lex_state = 0, .external_lex_state = 308},
  [18408] = {.lex_state = 0, .external_lex_state = 308},
  [18409] = {.lex_state = 1, .external_lex_state = 308},
  [18410] = {.lex_state = 0, .external_lex_state = 308},
  [18411] = {.lex_state = 0, .external_lex_state = 308},
  [18412] = {.lex_state = 3, .external_lex_state = 308},
  [18413] = {.lex_state = 0, .external_lex_state = 436},
  [18414] = {.lex_state = 1, .external_lex_state = 308},
  [18415] = {.lex_state = 0, .external_lex_state = 308},
  [18416] = {.lex_state = 1, .external_lex_state = 308},
  [18417] = {.lex_state = 0, .external_lex_state = 336},
  [18418] = {.lex_state = 3, .external_lex_state = 308},
  [18419] = {.lex_state = 1, .external_lex_state = 308},
  [18420] = {.lex_state = 1, .external_lex_state = 308},
  [18421] = {.lex_state = 1, .external_lex_state = 308},
  [18422] = {.lex_state = 3, .external_lex_state = 308},
  [18423] = {.lex_state = 1, .external_lex_state = 308},
  [18424] = {.lex_state = 0, .external_lex_state = 436},
  [18425] = {.lex_state = 0, .external_lex_state = 335},
  [18426] = {.lex_state = 3, .external_lex_state = 308},
  [18427] = {.lex_state = 1, .external_lex_state = 308},
  [18428] = {.lex_state = 47, .external_lex_state = 308},
  [18429] = {.lex_state = 0, .external_lex_state = 308},
  [18430] = {.lex_state = 0, .external_lex_state = 308},
  [18431] = {.lex_state = 47, .external_lex_state = 308},
  [18432] = {.lex_state = 3, .external_lex_state = 308},
  [18433] = {.lex_state = 1, .external_lex_state = 308},
  [18434] = {.lex_state = 47, .external_lex_state = 308},
  [18435] = {.lex_state = 0, .external_lex_state = 436},
  [18436] = {.lex_state = 0, .external_lex_state = 335},
  [18437] = {.lex_state = 47, .external_lex_state = 443},
  [18438] = {.lex_state = 1, .external_lex_state = 308},
  [18439] = {.lex_state = 1, .external_lex_state = 308},
  [18440] = {.lex_state = 0, .external_lex_state = 308},
  [18441] = {.lex_state = 0, .external_lex_state = 308},
  [18442] = {.lex_state = 0, .external_lex_state = 335},
  [18443] = {.lex_state = 3, .external_lex_state = 308},
  [18444] = {.lex_state = 1, .external_lex_state = 308},
  [18445] = {.lex_state = 0, .external_lex_state = 436},
  [18446] = {.lex_state = 1, .external_lex_state = 308},
  [18447] = {.lex_state = 1, .external_lex_state = 308},
  [18448] = {.lex_state = 1, .external_lex_state = 308},
  [18449] = {.lex_state = 3, .external_lex_state = 308},
  [18450] = {.lex_state = 1, .external_lex_state = 308},
  [18451] = {.lex_state = 3, .external_lex_state = 308},
  [18452] = {.lex_state = 1, .external_lex_state = 308},
  [18453] = {.lex_state = 0, .external_lex_state = 308},
  [18454] = {.lex_state = 0, .external_lex_state = 436},
  [18455] = {.lex_state = 50, .external_lex_state = 308},
  [18456] = {.lex_state = 1, .external_lex_state = 308},
  [18457] = {.lex_state = 0, .external_lex_state = 308},
  [18458] = {.lex_state = 0, .external_lex_state = 308},
  [18459] = {.lex_state = 0, .external_lex_state = 308},
  [18460] = {.lex_state = 0, .external_lex_state = 308},
  [18461] = {.lex_state = 50, .external_lex_state = 308},
  [18462] = {.lex_state = 0, .external_lex_state = 308},
  [18463] = {.lex_state = 0, .external_lex_state = 335},
  [18464] = {.lex_state = 1, .external_lex_state = 308},
  [18465] = {.lex_state = 3, .external_lex_state = 308},
  [18466] = {.lex_state = 0, .external_lex_state = 436},
  [18467] = {.lex_state = 1, .external_lex_state = 308},
  [18468] = {.lex_state = 0, .external_lex_state = 308},
  [18469] = {.lex_state = 0, .external_lex_state = 308},
  [18470] = {.lex_state = 3, .external_lex_state = 308},
  [18471] = {.lex_state = 0, .external_lex_state = 336},
  [18472] = {.lex_state = 3, .external_lex_state = 308},
  [18473] = {.lex_state = 1, .external_lex_state = 308},
  [18474] = {.lex_state = 1, .external_lex_state = 308},
  [18475] = {.lex_state = 0, .external_lex_state = 308},
  [18476] = {.lex_state = 0, .external_lex_state = 308},
  [18477] = {.lex_state = 47, .external_lex_state = 308},
  [18478] = {.lex_state = 3, .external_lex_state = 308},
  [18479] = {.lex_state = 1, .external_lex_state = 308},
  [18480] = {.lex_state = 0, .external_lex_state = 436},
  [18481] = {.lex_state = 1, .external_lex_state = 308},
  [18482] = {.lex_state = 1, .external_lex_state = 308},
  [18483] = {.lex_state = 47, .external_lex_state = 308},
  [18484] = {.lex_state = 0, .external_lex_state = 308},
  [18485] = {.lex_state = 1, .external_lex_state = 308},
  [18486] = {.lex_state = 0, .external_lex_state = 335},
  [18487] = {.lex_state = 47, .external_lex_state = 308},
  [18488] = {.lex_state = 3, .external_lex_state = 308},
  [18489] = {.lex_state = 1, .external_lex_state = 308},
  [18490] = {.lex_state = 47, .external_lex_state = 308},
  [18491] = {.lex_state = 3, .external_lex_state = 308},
  [18492] = {.lex_state = 0, .external_lex_state = 436},
  [18493] = {.lex_state = 1, .external_lex_state = 308},
  [18494] = {.lex_state = 51, .external_lex_state = 308},
  [18495] = {.lex_state = 0, .external_lex_state = 416},
  [18496] = {.lex_state = 1, .external_lex_state = 308},
  [18497] = {.lex_state = 0, .external_lex_state = 335},
  [18498] = {.lex_state = 47, .external_lex_state = 443},
  [18499] = {.lex_state = 0, .external_lex_state = 335},
  [18500] = {.lex_state = 0, .external_lex_state = 335},
  [18501] = {.lex_state = 3, .external_lex_state = 308},
  [18502] = {.lex_state = 1, .external_lex_state = 308},
  [18503] = {.lex_state = 0, .external_lex_state = 436},
  [18504] = {.lex_state = 1, .external_lex_state = 308},
  [18505] = {.lex_state = 47, .external_lex_state = 308},
  [18506] = {.lex_state = 0, .external_lex_state = 308},
  [18507] = {.lex_state = 0, .external_lex_state = 308},
  [18508] = {.lex_state = 47, .external_lex_state = 443},
  [18509] = {.lex_state = 1, .external_lex_state = 308},
  [18510] = {.lex_state = 1, .external_lex_state = 308},
  [18511] = {.lex_state = 3, .external_lex_state = 308},
  [18512] = {.lex_state = 1, .external_lex_state = 308},
  [18513] = {.lex_state = 1, .external_lex_state = 308},
  [18514] = {.lex_state = 1, .external_lex_state = 308},
  [18515] = {.lex_state = 0, .external_lex_state = 335},
  [18516] = {.lex_state = 1, .external_lex_state = 308},
  [18517] = {.lex_state = 1, .external_lex_state = 308},
  [18518] = {.lex_state = 3, .external_lex_state = 308},
  [18519] = {.lex_state = 0, .external_lex_state = 436},
  [18520] = {.lex_state = 0, .external_lex_state = 335},
  [18521] = {.lex_state = 0, .external_lex_state = 308},
  [18522] = {.lex_state = 50, .external_lex_state = 308},
  [18523] = {.lex_state = 0, .external_lex_state = 335},
  [18524] = {.lex_state = 0, .external_lex_state = 335},
  [18525] = {.lex_state = 1, .external_lex_state = 308},
  [18526] = {.lex_state = 1, .external_lex_state = 308},
  [18527] = {.lex_state = 0, .external_lex_state = 336},
  [18528] = {.lex_state = 1, .external_lex_state = 308},
  [18529] = {.lex_state = 3, .external_lex_state = 308},
  [18530] = {.lex_state = 1, .external_lex_state = 308},
  [18531] = {.lex_state = 0, .external_lex_state = 335},
  [18532] = {.lex_state = 0, .external_lex_state = 436},
  [18533] = {.lex_state = 0, .external_lex_state = 308},
  [18534] = {.lex_state = 1, .external_lex_state = 308},
  [18535] = {.lex_state = 3, .external_lex_state = 308},
  [18536] = {.lex_state = 0, .external_lex_state = 436},
  [18537] = {.lex_state = 0, .external_lex_state = 308},
  [18538] = {.lex_state = 1, .external_lex_state = 308},
  [18539] = {.lex_state = 1, .external_lex_state = 308},
  [18540] = {.lex_state = 3, .external_lex_state = 308},
  [18541] = {.lex_state = 0, .external_lex_state = 308},
  [18542] = {.lex_state = 47, .external_lex_state = 308},
  [18543] = {.lex_state = 1, .external_lex_state = 308},
  [18544] = {.lex_state = 47, .external_lex_state = 422},
  [18545] = {.lex_state = 1, .external_lex_state = 308},
  [18546] = {.lex_state = 0, .external_lex_state = 308},
  [18547] = {.lex_state = 0, .external_lex_state = 308},
  [18548] = {.lex_state = 47, .external_lex_state = 308},
  [18549] = {.lex_state = 47, .external_lex_state = 443},
  [18550] = {.lex_state = 1, .external_lex_state = 308},
  [18551] = {.lex_state = 0, .external_lex_state = 335},
  [18552] = {.lex_state = 3, .external_lex_state = 308},
  [18553] = {.lex_state = 47, .external_lex_state = 308},
  [18554] = {.lex_state = 1, .external_lex_state = 308},
  [18555] = {.lex_state = 0, .external_lex_state = 436},
  [18556] = {.lex_state = 0, .external_lex_state = 308},
  [18557] = {.lex_state = 0, .external_lex_state = 308},
  [18558] = {.lex_state = 1, .external_lex_state = 308},
  [18559] = {.lex_state = 1, .external_lex_state = 308},
  [18560] = {.lex_state = 0, .external_lex_state = 308},
  [18561] = {.lex_state = 47, .external_lex_state = 308},
  [18562] = {.lex_state = 1, .external_lex_state = 308},
  [18563] = {.lex_state = 3, .external_lex_state = 308},
  [18564] = {.lex_state = 47, .external_lex_state = 308},
  [18565] = {.lex_state = 1, .external_lex_state = 308},
  [18566] = {.lex_state = 0, .external_lex_state = 308},
  [18567] = {.lex_state = 0, .external_lex_state = 308},
  [18568] = {.lex_state = 1, .external_lex_state = 308},
  [18569] = {.lex_state = 0, .external_lex_state = 308},
  [18570] = {.lex_state = 1, .external_lex_state = 308},
  [18571] = {.lex_state = 0, .external_lex_state = 308},
  [18572] = {.lex_state = 1, .external_lex_state = 308},
  [18573] = {.lex_state = 0, .external_lex_state = 308},
  [18574] = {.lex_state = 0, .external_lex_state = 308},
  [18575] = {.lex_state = 0, .external_lex_state = 308},
  [18576] = {.lex_state = 0, .external_lex_state = 436},
  [18577] = {.lex_state = 47, .external_lex_state = 443},
  [18578] = {.lex_state = 0, .external_lex_state = 308},
  [18579] = {.lex_state = 1, .external_lex_state = 308},
  [18580] = {.lex_state = 0, .external_lex_state = 436},
  [18581] = {.lex_state = 0, .external_lex_state = 335},
  [18582] = {.lex_state = 47, .external_lex_state = 308},
  [18583] = {.lex_state = 1, .external_lex_state = 308},
  [18584] = {.lex_state = 0, .external_lex_state = 335},
  [18585] = {.lex_state = 0, .external_lex_state = 308},
  [18586] = {.lex_state = 0, .external_lex_state = 308},
  [18587] = {.lex_state = 0, .external_lex_state = 308},
  [18588] = {.lex_state = 1, .external_lex_state = 308},
  [18589] = {.lex_state = 47, .external_lex_state = 308},
  [18590] = {.lex_state = 0, .external_lex_state = 335},
  [18591] = {.lex_state = 1, .external_lex_state = 308},
  [18592] = {.lex_state = 0, .external_lex_state = 335},
  [18593] = {.lex_state = 0, .external_lex_state = 308},
  [18594] = {.lex_state = 3, .external_lex_state = 308},
  [18595] = {.lex_state = 0, .external_lex_state = 336},
  [18596] = {.lex_state = 1, .external_lex_state = 308},
  [18597] = {.lex_state = 1, .external_lex_state = 308},
  [18598] = {.lex_state = 3, .external_lex_state = 308},
  [18599] = {.lex_state = 0, .external_lex_state = 436},
  [18600] = {.lex_state = 1, .external_lex_state = 308},
  [18601] = {.lex_state = 1, .external_lex_state = 308},
  [18602] = {.lex_state = 47, .external_lex_state = 308},
  [18603] = {.lex_state = 1, .external_lex_state = 308},
  [18604] = {.lex_state = 0, .external_lex_state = 308},
  [18605] = {.lex_state = 1, .external_lex_state = 308},
  [18606] = {.lex_state = 1, .external_lex_state = 308},
  [18607] = {.lex_state = 0, .external_lex_state = 308},
  [18608] = {.lex_state = 1, .external_lex_state = 308},
  [18609] = {.lex_state = 1, .external_lex_state = 308},
  [18610] = {.lex_state = 1, .external_lex_state = 308},
  [18611] = {.lex_state = 0, .external_lex_state = 335},
  [18612] = {.lex_state = 1, .external_lex_state = 308},
  [18613] = {.lex_state = 0, .external_lex_state = 308},
  [18614] = {.lex_state = 0, .external_lex_state = 335},
  [18615] = {.lex_state = 0, .external_lex_state = 335},
  [18616] = {.lex_state = 47, .external_lex_state = 443},
  [18617] = {.lex_state = 0, .external_lex_state = 308},
  [18618] = {.lex_state = 1, .external_lex_state = 308},
  [18619] = {.lex_state = 47, .external_lex_state = 308},
  [18620] = {.lex_state = 1, .external_lex_state = 308},
  [18621] = {.lex_state = 0, .external_lex_state = 416},
  [18622] = {.lex_state = 1, .external_lex_state = 308},
  [18623] = {.lex_state = 1, .external_lex_state = 308},
  [18624] = {.lex_state = 1, .external_lex_state = 308},
  [18625] = {.lex_state = 1, .external_lex_state = 308},
  [18626] = {.lex_state = 1, .external_lex_state = 308},
  [18627] = {.lex_state = 1, .external_lex_state = 308},
  [18628] = {.lex_state = 47, .external_lex_state = 308},
  [18629] = {.lex_state = 1, .external_lex_state = 308},
  [18630] = {.lex_state = 1, .external_lex_state = 308},
  [18631] = {.lex_state = 0, .external_lex_state = 308},
  [18632] = {.lex_state = 0, .external_lex_state = 308},
  [18633] = {.lex_state = 1, .external_lex_state = 308},
  [18634] = {.lex_state = 1, .external_lex_state = 308},
  [18635] = {.lex_state = 0, .external_lex_state = 416},
  [18636] = {.lex_state = 1, .external_lex_state = 308},
  [18637] = {.lex_state = 1, .external_lex_state = 308},
  [18638] = {.lex_state = 0, .external_lex_state = 308},
  [18639] = {.lex_state = 1, .external_lex_state = 308},
  [18640] = {.lex_state = 1, .external_lex_state = 308},
  [18641] = {.lex_state = 1, .external_lex_state = 308},
  [18642] = {.lex_state = 1, .external_lex_state = 308},
  [18643] = {.lex_state = 0, .external_lex_state = 335},
  [18644] = {.lex_state = 1, .external_lex_state = 308},
  [18645] = {.lex_state = 0, .external_lex_state = 308},
  [18646] = {.lex_state = 0, .external_lex_state = 336},
  [18647] = {.lex_state = 1, .external_lex_state = 308},
  [18648] = {.lex_state = 1, .external_lex_state = 308},
  [18649] = {.lex_state = 1, .external_lex_state = 308},
  [18650] = {.lex_state = 1, .external_lex_state = 308},
  [18651] = {.lex_state = 1, .external_lex_state = 308},
  [18652] = {.lex_state = 1, .external_lex_state = 308},
  [18653] = {.lex_state = 0, .external_lex_state = 308},
  [18654] = {.lex_state = 3, .external_lex_state = 308},
  [18655] = {.lex_state = 1, .external_lex_state = 308},
  [18656] = {.lex_state = 47, .external_lex_state = 308},
  [18657] = {.lex_state = 1, .external_lex_state = 308},
  [18658] = {.lex_state = 1, .external_lex_state = 308},
  [18659] = {.lex_state = 1, .external_lex_state = 308},
  [18660] = {.lex_state = 1, .external_lex_state = 308},
  [18661] = {.lex_state = 1, .external_lex_state = 308},
  [18662] = {.lex_state = 1, .external_lex_state = 308},
  [18663] = {.lex_state = 0, .external_lex_state = 308},
  [18664] = {.lex_state = 1, .external_lex_state = 308},
  [18665] = {.lex_state = 0, .external_lex_state = 416},
  [18666] = {.lex_state = 1, .external_lex_state = 308},
  [18667] = {.lex_state = 3, .external_lex_state = 308},
  [18668] = {.lex_state = 1, .external_lex_state = 308},
  [18669] = {.lex_state = 1, .external_lex_state = 308},
  [18670] = {.lex_state = 1, .external_lex_state = 308},
  [18671] = {.lex_state = 0, .external_lex_state = 308},
  [18672] = {.lex_state = 1, .external_lex_state = 308},
  [18673] = {.lex_state = 1, .external_lex_state = 308},
  [18674] = {.lex_state = 0, .external_lex_state = 308},
  [18675] = {.lex_state = 1, .external_lex_state = 308},
  [18676] = {.lex_state = 1, .external_lex_state = 308},
  [18677] = {.lex_state = 0, .external_lex_state = 335},
  [18678] = {.lex_state = 47, .external_lex_state = 443},
  [18679] = {.lex_state = 0, .external_lex_state = 335},
  [18680] = {.lex_state = 1, .external_lex_state = 308},
  [18681] = {.lex_state = 1, .external_lex_state = 308},
  [18682] = {.lex_state = 3, .external_lex_state = 308},
  [18683] = {.lex_state = 1, .external_lex_state = 308},
  [18684] = {.lex_state = 1, .external_lex_state = 308},
  [18685] = {.lex_state = 1, .external_lex_state = 308},
  [18686] = {.lex_state = 1, .external_lex_state = 308},
  [18687] = {.lex_state = 1, .external_lex_state = 308},
  [18688] = {.lex_state = 1, .external_lex_state = 308},
  [18689] = {.lex_state = 0, .external_lex_state = 335},
  [18690] = {.lex_state = 1, .external_lex_state = 308},
  [18691] = {.lex_state = 1, .external_lex_state = 308},
  [18692] = {.lex_state = 3, .external_lex_state = 308},
  [18693] = {.lex_state = 1, .external_lex_state = 308},
  [18694] = {.lex_state = 0, .external_lex_state = 308},
  [18695] = {.lex_state = 1, .external_lex_state = 308},
  [18696] = {.lex_state = 0, .external_lex_state = 335},
  [18697] = {.lex_state = 1, .external_lex_state = 308},
  [18698] = {.lex_state = 1, .external_lex_state = 308},
  [18699] = {.lex_state = 1, .external_lex_state = 308},
  [18700] = {.lex_state = 0, .external_lex_state = 308},
  [18701] = {.lex_state = 0, .external_lex_state = 308},
  [18702] = {.lex_state = 1, .external_lex_state = 308},
  [18703] = {.lex_state = 1, .external_lex_state = 308},
  [18704] = {.lex_state = 1, .external_lex_state = 308},
  [18705] = {.lex_state = 1, .external_lex_state = 308},
  [18706] = {.lex_state = 1, .external_lex_state = 308},
  [18707] = {.lex_state = 0, .external_lex_state = 335},
  [18708] = {.lex_state = 0, .external_lex_state = 335},
  [18709] = {.lex_state = 1, .external_lex_state = 308},
  [18710] = {.lex_state = 0, .external_lex_state = 308},
  [18711] = {.lex_state = 0, .external_lex_state = 308},
  [18712] = {.lex_state = 1, .external_lex_state = 308},
  [18713] = {.lex_state = 1, .external_lex_state = 308},
  [18714] = {.lex_state = 1, .external_lex_state = 308},
  [18715] = {.lex_state = 0, .external_lex_state = 308},
  [18716] = {.lex_state = 0, .external_lex_state = 308},
  [18717] = {.lex_state = 1, .external_lex_state = 308},
  [18718] = {.lex_state = 1, .external_lex_state = 308},
  [18719] = {.lex_state = 1, .external_lex_state = 308},
  [18720] = {.lex_state = 0, .external_lex_state = 308},
  [18721] = {.lex_state = 1, .external_lex_state = 308},
  [18722] = {.lex_state = 1, .external_lex_state = 308},
  [18723] = {.lex_state = 3, .external_lex_state = 308},
  [18724] = {.lex_state = 0, .external_lex_state = 308},
  [18725] = {.lex_state = 0, .external_lex_state = 335},
  [18726] = {.lex_state = 0, .external_lex_state = 308},
  [18727] = {.lex_state = 0, .external_lex_state = 308},
  [18728] = {.lex_state = 1, .external_lex_state = 308},
  [18729] = {.lex_state = 1, .external_lex_state = 308},
  [18730] = {.lex_state = 0, .external_lex_state = 335},
  [18731] = {.lex_state = 0, .external_lex_state = 308},
  [18732] = {.lex_state = 0, .external_lex_state = 335},
  [18733] = {.lex_state = 1, .external_lex_state = 308},
  [18734] = {.lex_state = 1, .external_lex_state = 308},
  [18735] = {.lex_state = 47, .external_lex_state = 400},
  [18736] = {.lex_state = 1, .external_lex_state = 308},
  [18737] = {.lex_state = 0, .external_lex_state = 308},
  [18738] = {.lex_state = 1, .external_lex_state = 308},
  [18739] = {.lex_state = 0, .external_lex_state = 335},
  [18740] = {.lex_state = 0, .external_lex_state = 308},
  [18741] = {.lex_state = 1, .external_lex_state = 308},
  [18742] = {.lex_state = 1, .external_lex_state = 308},
  [18743] = {.lex_state = 1, .external_lex_state = 308},
  [18744] = {.lex_state = 1, .external_lex_state = 308},
  [18745] = {.lex_state = 0, .external_lex_state = 308},
  [18746] = {.lex_state = 1, .external_lex_state = 308},
  [18747] = {.lex_state = 0, .external_lex_state = 308},
  [18748] = {.lex_state = 0, .external_lex_state = 335},
  [18749] = {.lex_state = 1, .external_lex_state = 308},
  [18750] = {.lex_state = 0, .external_lex_state = 308},
  [18751] = {.lex_state = 1, .external_lex_state = 308},
  [18752] = {.lex_state = 1, .external_lex_state = 308},
  [18753] = {.lex_state = 0, .external_lex_state = 335},
  [18754] = {.lex_state = 1, .external_lex_state = 308},
  [18755] = {.lex_state = 0, .external_lex_state = 308},
  [18756] = {.lex_state = 3, .external_lex_state = 308},
  [18757] = {.lex_state = 1, .external_lex_state = 308},
  [18758] = {.lex_state = 1, .external_lex_state = 308},
  [18759] = {.lex_state = 0, .external_lex_state = 335},
  [18760] = {.lex_state = 1, .external_lex_state = 308},
  [18761] = {.lex_state = 1, .external_lex_state = 308},
  [18762] = {.lex_state = 1, .external_lex_state = 308},
  [18763] = {.lex_state = 1, .external_lex_state = 308},
  [18764] = {.lex_state = 3, .external_lex_state = 308},
  [18765] = {.lex_state = 47, .external_lex_state = 443},
  [18766] = {.lex_state = 1, .external_lex_state = 308},
  [18767] = {.lex_state = 1, .external_lex_state = 308},
  [18768] = {.lex_state = 0, .external_lex_state = 308},
  [18769] = {.lex_state = 1, .external_lex_state = 308},
  [18770] = {.lex_state = 0, .external_lex_state = 335},
  [18771] = {.lex_state = 1, .external_lex_state = 308},
  [18772] = {.lex_state = 0, .external_lex_state = 416},
  [18773] = {.lex_state = 1, .external_lex_state = 308},
  [18774] = {.lex_state = 1, .external_lex_state = 308},
  [18775] = {.lex_state = 1, .external_lex_state = 308},
  [18776] = {.lex_state = 3, .external_lex_state = 308},
  [18777] = {.lex_state = 0, .external_lex_state = 335},
  [18778] = {.lex_state = 1, .external_lex_state = 308},
  [18779] = {.lex_state = 0, .external_lex_state = 335},
  [18780] = {.lex_state = 0, .external_lex_state = 416},
  [18781] = {.lex_state = 0, .external_lex_state = 335},
  [18782] = {.lex_state = 1, .external_lex_state = 308},
  [18783] = {.lex_state = 1, .external_lex_state = 308},
  [18784] = {.lex_state = 0, .external_lex_state = 335},
  [18785] = {.lex_state = 1, .external_lex_state = 308},
  [18786] = {.lex_state = 1, .external_lex_state = 308},
  [18787] = {.lex_state = 47, .external_lex_state = 308},
  [18788] = {.lex_state = 0, .external_lex_state = 335},
  [18789] = {.lex_state = 1, .external_lex_state = 308},
  [18790] = {.lex_state = 1, .external_lex_state = 308},
  [18791] = {.lex_state = 0, .external_lex_state = 335},
  [18792] = {.lex_state = 1, .external_lex_state = 308},
  [18793] = {.lex_state = 0, .external_lex_state = 308},
  [18794] = {.lex_state = 0, .external_lex_state = 335},
  [18795] = {.lex_state = 1, .external_lex_state = 308},
  [18796] = {.lex_state = 1, .external_lex_state = 308},
  [18797] = {.lex_state = 47, .external_lex_state = 308},
  [18798] = {.lex_state = 0, .external_lex_state = 355},
  [18799] = {.lex_state = 1, .external_lex_state = 308},
  [18800] = {.lex_state = 1, .external_lex_state = 308},
  [18801] = {.lex_state = 1, .external_lex_state = 308},
  [18802] = {.lex_state = 0, .external_lex_state = 336},
  [18803] = {.lex_state = 1, .external_lex_state = 308},
  [18804] = {.lex_state = 1, .external_lex_state = 308},
  [18805] = {.lex_state = 0, .external_lex_state = 308},
  [18806] = {.lex_state = 1, .external_lex_state = 308},
  [18807] = {.lex_state = 1, .external_lex_state = 308},
  [18808] = {.lex_state = 0, .external_lex_state = 335},
  [18809] = {.lex_state = 0, .external_lex_state = 335},
  [18810] = {.lex_state = 1, .external_lex_state = 308},
  [18811] = {.lex_state = 1, .external_lex_state = 308},
  [18812] = {.lex_state = 1, .external_lex_state = 308},
  [18813] = {.lex_state = 3, .external_lex_state = 308},
  [18814] = {.lex_state = 1, .external_lex_state = 308},
  [18815] = {.lex_state = 1, .external_lex_state = 308},
  [18816] = {.lex_state = 1, .external_lex_state = 308},
  [18817] = {.lex_state = 1, .external_lex_state = 308},
  [18818] = {.lex_state = 0, .external_lex_state = 335},
  [18819] = {.lex_state = 0, .external_lex_state = 335},
  [18820] = {.lex_state = 47, .external_lex_state = 443},
  [18821] = {.lex_state = 1, .external_lex_state = 308},
  [18822] = {.lex_state = 1, .external_lex_state = 308},
  [18823] = {.lex_state = 0, .external_lex_state = 343},
  [18824] = {.lex_state = 1, .external_lex_state = 308},
  [18825] = {.lex_state = 47, .external_lex_state = 308},
  [18826] = {.lex_state = 47, .external_lex_state = 422},
  [18827] = {.lex_state = 0, .external_lex_state = 335},
  [18828] = {.lex_state = 1, .external_lex_state = 308},
  [18829] = {.lex_state = 1, .external_lex_state = 308},
  [18830] = {.lex_state = 1, .external_lex_state = 308},
  [18831] = {.lex_state = 47, .external_lex_state = 308},
  [18832] = {.lex_state = 1, .external_lex_state = 308},
  [18833] = {.lex_state = 1, .external_lex_state = 308},
  [18834] = {.lex_state = 47, .external_lex_state = 308},
  [18835] = {.lex_state = 0, .external_lex_state = 335},
  [18836] = {.lex_state = 1, .external_lex_state = 308},
  [18837] = {.lex_state = 1, .external_lex_state = 308},
  [18838] = {.lex_state = 0, .external_lex_state = 416},
  [18839] = {.lex_state = 0, .external_lex_state = 416},
  [18840] = {.lex_state = 1, .external_lex_state = 308},
  [18841] = {.lex_state = 3, .external_lex_state = 308},
  [18842] = {.lex_state = 1, .external_lex_state = 308},
  [18843] = {.lex_state = 1, .external_lex_state = 308},
  [18844] = {.lex_state = 1, .external_lex_state = 308},
  [18845] = {.lex_state = 1, .external_lex_state = 308},
  [18846] = {.lex_state = 47, .external_lex_state = 443},
  [18847] = {.lex_state = 0, .external_lex_state = 343},
  [18848] = {.lex_state = 47, .external_lex_state = 443},
  [18849] = {.lex_state = 1, .external_lex_state = 308},
  [18850] = {.lex_state = 0, .external_lex_state = 335},
  [18851] = {.lex_state = 47, .external_lex_state = 308},
  [18852] = {.lex_state = 1, .external_lex_state = 308},
  [18853] = {.lex_state = 0, .external_lex_state = 343},
  [18854] = {.lex_state = 1, .external_lex_state = 308},
  [18855] = {.lex_state = 1, .external_lex_state = 308},
  [18856] = {.lex_state = 1, .external_lex_state = 308},
  [18857] = {.lex_state = 1, .external_lex_state = 308},
  [18858] = {.lex_state = 1, .external_lex_state = 308},
  [18859] = {.lex_state = 47, .external_lex_state = 308},
  [18860] = {.lex_state = 3, .external_lex_state = 308},
  [18861] = {.lex_state = 1, .external_lex_state = 308},
  [18862] = {.lex_state = 1, .external_lex_state = 308},
  [18863] = {.lex_state = 3, .external_lex_state = 308},
  [18864] = {.lex_state = 0, .external_lex_state = 308},
  [18865] = {.lex_state = 1, .external_lex_state = 308},
  [18866] = {.lex_state = 47, .external_lex_state = 400},
  [18867] = {.lex_state = 1, .external_lex_state = 308},
  [18868] = {.lex_state = 1, .external_lex_state = 308},
  [18869] = {.lex_state = 0, .external_lex_state = 308},
  [18870] = {.lex_state = 47, .external_lex_state = 308},
  [18871] = {.lex_state = 3, .external_lex_state = 308},
  [18872] = {.lex_state = 1, .external_lex_state = 308},
  [18873] = {.lex_state = 1, .external_lex_state = 308},
  [18874] = {.lex_state = 0, .external_lex_state = 335},
  [18875] = {.lex_state = 47, .external_lex_state = 308},
  [18876] = {.lex_state = 1, .external_lex_state = 308},
  [18877] = {.lex_state = 1, .external_lex_state = 308},
  [18878] = {.lex_state = 47, .external_lex_state = 308},
  [18879] = {.lex_state = 1, .external_lex_state = 308},
  [18880] = {.lex_state = 1, .external_lex_state = 308},
  [18881] = {.lex_state = 0, .external_lex_state = 416},
  [18882] = {.lex_state = 1, .external_lex_state = 308},
  [18883] = {.lex_state = 1, .external_lex_state = 308},
  [18884] = {.lex_state = 0, .external_lex_state = 335},
  [18885] = {.lex_state = 1, .external_lex_state = 308},
  [18886] = {.lex_state = 1, .external_lex_state = 308},
  [18887] = {.lex_state = 1, .external_lex_state = 308},
  [18888] = {.lex_state = 0, .external_lex_state = 335},
  [18889] = {.lex_state = 1, .external_lex_state = 308},
  [18890] = {.lex_state = 1, .external_lex_state = 308},
  [18891] = {.lex_state = 1, .external_lex_state = 308},
  [18892] = {.lex_state = 1, .external_lex_state = 308},
  [18893] = {.lex_state = 3, .external_lex_state = 308},
  [18894] = {.lex_state = 0, .external_lex_state = 335},
  [18895] = {.lex_state = 1, .external_lex_state = 308},
  [18896] = {.lex_state = 1, .external_lex_state = 308},
  [18897] = {.lex_state = 47, .external_lex_state = 443},
  [18898] = {.lex_state = 1, .external_lex_state = 308},
  [18899] = {.lex_state = 1, .external_lex_state = 308},
  [18900] = {.lex_state = 1, .external_lex_state = 308},
  [18901] = {.lex_state = 1, .external_lex_state = 308},
  [18902] = {.lex_state = 1, .external_lex_state = 308},
  [18903] = {.lex_state = 1, .external_lex_state = 308},
  [18904] = {.lex_state = 3, .external_lex_state = 308},
  [18905] = {.lex_state = 0, .external_lex_state = 335},
  [18906] = {.lex_state = 1, .external_lex_state = 308},
  [18907] = {.lex_state = 0, .external_lex_state = 336},
  [18908] = {.lex_state = 0, .external_lex_state = 308},
  [18909] = {.lex_state = 0, .external_lex_state = 308},
  [18910] = {.lex_state = 0, .external_lex_state = 308},
  [18911] = {.lex_state = 0, .external_lex_state = 308},
  [18912] = {.lex_state = 0, .external_lex_state = 308},
  [18913] = {.lex_state = 0, .external_lex_state = 308},
  [18914] = {.lex_state = 0, .external_lex_state = 308},
  [18915] = {.lex_state = 0, .external_lex_state = 308},
  [18916] = {.lex_state = 0, .external_lex_state = 308},
  [18917] = {.lex_state = 47, .external_lex_state = 308},
  [18918] = {.lex_state = 0, .external_lex_state = 444},
  [18919] = {.lex_state = 0, .external_lex_state = 308},
  [18920] = {.lex_state = 0, .external_lex_state = 308},
  [18921] = {.lex_state = 0, .external_lex_state = 308},
  [18922] = {.lex_state = 0, .external_lex_state = 308},
  [18923] = {.lex_state = 0, .external_lex_state = 308},
  [18924] = {.lex_state = 0, .external_lex_state = 308},
  [18925] = {.lex_state = 0, .external_lex_state = 308},
  [18926] = {.lex_state = 0, .external_lex_state = 308},
  [18927] = {.lex_state = 0, .external_lex_state = 308},
  [18928] = {.lex_state = 0, .external_lex_state = 308},
  [18929] = {.lex_state = 0, .external_lex_state = 308},
  [18930] = {.lex_state = 0, .external_lex_state = 308},
  [18931] = {.lex_state = 0, .external_lex_state = 308},
  [18932] = {.lex_state = 0, .external_lex_state = 308},
  [18933] = {.lex_state = 0, .external_lex_state = 308},
  [18934] = {.lex_state = 47, .external_lex_state = 308},
  [18935] = {.lex_state = 0, .external_lex_state = 308},
  [18936] = {.lex_state = 0, .external_lex_state = 308},
  [18937] = {.lex_state = 0, .external_lex_state = 308},
  [18938] = {.lex_state = 0, .external_lex_state = 444},
  [18939] = {.lex_state = 0, .external_lex_state = 444},
  [18940] = {.lex_state = 0, .external_lex_state = 444},
  [18941] = {.lex_state = 0, .external_lex_state = 308},
  [18942] = {.lex_state = 0, .external_lex_state = 308},
  [18943] = {.lex_state = 0, .external_lex_state = 308},
  [18944] = {.lex_state = 0, .external_lex_state = 308},
  [18945] = {.lex_state = 0, .external_lex_state = 308},
  [18946] = {.lex_state = 0, .external_lex_state = 308},
  [18947] = {.lex_state = 0, .external_lex_state = 308},
  [18948] = {.lex_state = 0, .external_lex_state = 308},
  [18949] = {.lex_state = 0, .external_lex_state = 308},
  [18950] = {.lex_state = 0, .external_lex_state = 308},
  [18951] = {.lex_state = 0, .external_lex_state = 308},
  [18952] = {.lex_state = 0, .external_lex_state = 308},
  [18953] = {.lex_state = 0, .external_lex_state = 308},
  [18954] = {.lex_state = 0, .external_lex_state = 308},
  [18955] = {.lex_state = 0, .external_lex_state = 308},
  [18956] = {.lex_state = 0, .external_lex_state = 308},
  [18957] = {.lex_state = 0, .external_lex_state = 308},
  [18958] = {.lex_state = 0, .external_lex_state = 308},
  [18959] = {.lex_state = 0, .external_lex_state = 308},
  [18960] = {.lex_state = 0, .external_lex_state = 444},
  [18961] = {.lex_state = 0, .external_lex_state = 444},
  [18962] = {.lex_state = 0, .external_lex_state = 308},
  [18963] = {.lex_state = 0, .external_lex_state = 308},
  [18964] = {.lex_state = 0, .external_lex_state = 308},
  [18965] = {.lex_state = 0, .external_lex_state = 444},
  [18966] = {.lex_state = 0, .external_lex_state = 308},
  [18967] = {.lex_state = 0, .external_lex_state = 308},
  [18968] = {.lex_state = 0, .external_lex_state = 308},
  [18969] = {.lex_state = 0, .external_lex_state = 308},
  [18970] = {.lex_state = 0, .external_lex_state = 308},
  [18971] = {.lex_state = 0, .external_lex_state = 308},
  [18972] = {.lex_state = 0, .external_lex_state = 308},
  [18973] = {.lex_state = 0, .external_lex_state = 308},
  [18974] = {.lex_state = 0, .external_lex_state = 308},
  [18975] = {.lex_state = 0, .external_lex_state = 308},
  [18976] = {.lex_state = 0, .external_lex_state = 308},
  [18977] = {.lex_state = 0, .external_lex_state = 308},
  [18978] = {.lex_state = 0, .external_lex_state = 308},
  [18979] = {.lex_state = 0, .external_lex_state = 444},
  [18980] = {.lex_state = 0, .external_lex_state = 308},
  [18981] = {.lex_state = 0, .external_lex_state = 308},
  [18982] = {.lex_state = 0, .external_lex_state = 308},
  [18983] = {.lex_state = 0, .external_lex_state = 308},
  [18984] = {.lex_state = 0, .external_lex_state = 308},
  [18985] = {.lex_state = 0, .external_lex_state = 308},
  [18986] = {.lex_state = 0, .external_lex_state = 308},
  [18987] = {.lex_state = 0, .external_lex_state = 444},
  [18988] = {.lex_state = 0, .external_lex_state = 308},
  [18989] = {.lex_state = 47, .external_lex_state = 308},
  [18990] = {.lex_state = 0, .external_lex_state = 308},
  [18991] = {.lex_state = 0, .external_lex_state = 308},
  [18992] = {.lex_state = 0, .external_lex_state = 308},
  [18993] = {.lex_state = 0, .external_lex_state = 308},
  [18994] = {.lex_state = 0, .external_lex_state = 308},
  [18995] = {.lex_state = 0, .external_lex_state = 308},
  [18996] = {.lex_state = 0, .external_lex_state = 308},
  [18997] = {.lex_state = 0, .external_lex_state = 308},
  [18998] = {.lex_state = 0, .external_lex_state = 308},
  [18999] = {.lex_state = 0, .external_lex_state = 308},
  [19000] = {.lex_state = 0, .external_lex_state = 308},
  [19001] = {.lex_state = 0, .external_lex_state = 308},
  [19002] = {.lex_state = 0, .external_lex_state = 308},
  [19003] = {.lex_state = 0, .external_lex_state = 308},
  [19004] = {.lex_state = 0, .external_lex_state = 308},
  [19005] = {.lex_state = 0, .external_lex_state = 308},
  [19006] = {.lex_state = 0, .external_lex_state = 308},
  [19007] = {.lex_state = 47, .external_lex_state = 308},
  [19008] = {.lex_state = 0, .external_lex_state = 308},
  [19009] = {.lex_state = 0, .external_lex_state = 308},
  [19010] = {.lex_state = 0, .external_lex_state = 308},
  [19011] = {.lex_state = 0, .external_lex_state = 308},
  [19012] = {.lex_state = 0, .external_lex_state = 308},
  [19013] = {.lex_state = 0, .external_lex_state = 308},
  [19014] = {.lex_state = 0, .external_lex_state = 308},
  [19015] = {.lex_state = 0, .external_lex_state = 308},
  [19016] = {.lex_state = 0, .external_lex_state = 444},
  [19017] = {.lex_state = 0, .external_lex_state = 308},
  [19018] = {.lex_state = 0, .external_lex_state = 308},
  [19019] = {.lex_state = 0, .external_lex_state = 308},
  [19020] = {.lex_state = 0, .external_lex_state = 308},
  [19021] = {.lex_state = 0, .external_lex_state = 308},
  [19022] = {.lex_state = 0, .external_lex_state = 308},
  [19023] = {.lex_state = 0, .external_lex_state = 444},
  [19024] = {.lex_state = 0, .external_lex_state = 308},
  [19025] = {.lex_state = 0, .external_lex_state = 308},
  [19026] = {.lex_state = 0, .external_lex_state = 308},
  [19027] = {.lex_state = 0, .external_lex_state = 308},
  [19028] = {.lex_state = 0, .external_lex_state = 308},
  [19029] = {.lex_state = 0, .external_lex_state = 308},
  [19030] = {.lex_state = 0, .external_lex_state = 308},
  [19031] = {.lex_state = 0, .external_lex_state = 308},
  [19032] = {.lex_state = 0, .external_lex_state = 444},
  [19033] = {.lex_state = 0, .external_lex_state = 308},
  [19034] = {.lex_state = 0, .external_lex_state = 308},
  [19035] = {.lex_state = 0, .external_lex_state = 308},
  [19036] = {.lex_state = 0, .external_lex_state = 308},
  [19037] = {.lex_state = 0, .external_lex_state = 308},
  [19038] = {.lex_state = 0, .external_lex_state = 308},
  [19039] = {.lex_state = 0, .external_lex_state = 308},
  [19040] = {.lex_state = 0, .external_lex_state = 308},
  [19041] = {.lex_state = 0, .external_lex_state = 308},
  [19042] = {.lex_state = 0, .external_lex_state = 308},
  [19043] = {.lex_state = 0, .external_lex_state = 308},
  [19044] = {.lex_state = 0, .external_lex_state = 308},
  [19045] = {.lex_state = 0, .external_lex_state = 444},
  [19046] = {.lex_state = 0, .external_lex_state = 308},
  [19047] = {.lex_state = 0, .external_lex_state = 444},
  [19048] = {.lex_state = 0, .external_lex_state = 308},
  [19049] = {.lex_state = 0, .external_lex_state = 308},
  [19050] = {.lex_state = 0, .external_lex_state = 308},
  [19051] = {.lex_state = 0, .external_lex_state = 308},
  [19052] = {.lex_state = 0, .external_lex_state = 444},
  [19053] = {.lex_state = 0, .external_lex_state = 308},
  [19054] = {.lex_state = 0, .external_lex_state = 444},
  [19055] = {.lex_state = 0, .external_lex_state = 308},
  [19056] = {.lex_state = 0, .external_lex_state = 308},
  [19057] = {.lex_state = 47, .external_lex_state = 308},
  [19058] = {.lex_state = 0, .external_lex_state = 444},
  [19059] = {.lex_state = 0, .external_lex_state = 308},
  [19060] = {.lex_state = 47, .external_lex_state = 308},
  [19061] = {.lex_state = 0, .external_lex_state = 308},
  [19062] = {.lex_state = 0, .external_lex_state = 308},
  [19063] = {.lex_state = 0, .external_lex_state = 308},
  [19064] = {.lex_state = 0, .external_lex_state = 308},
  [19065] = {.lex_state = 0, .external_lex_state = 308},
  [19066] = {.lex_state = 0, .external_lex_state = 308},
  [19067] = {.lex_state = 0, .external_lex_state = 308},
  [19068] = {.lex_state = 0, .external_lex_state = 308},
  [19069] = {.lex_state = 0, .external_lex_state = 308},
  [19070] = {.lex_state = 0, .external_lex_state = 308},
  [19071] = {.lex_state = 0, .external_lex_state = 308},
  [19072] = {.lex_state = 47, .external_lex_state = 308},
  [19073] = {.lex_state = 0, .external_lex_state = 308},
  [19074] = {.lex_state = 0, .external_lex_state = 444},
  [19075] = {.lex_state = 0, .external_lex_state = 308},
  [19076] = {.lex_state = 0, .external_lex_state = 308},
  [19077] = {.lex_state = 0, .external_lex_state = 308},
  [19078] = {.lex_state = 47, .external_lex_state = 308},
  [19079] = {.lex_state = 0, .external_lex_state = 308},
  [19080] = {.lex_state = 0, .external_lex_state = 308},
  [19081] = {.lex_state = 0, .external_lex_state = 308},
  [19082] = {.lex_state = 0, .external_lex_state = 444},
  [19083] = {.lex_state = 47, .external_lex_state = 308},
  [19084] = {.lex_state = 47, .external_lex_state = 308},
  [19085] = {.lex_state = 0, .external_lex_state = 308},
  [19086] = {.lex_state = 0, .external_lex_state = 308},
  [19087] = {.lex_state = 0, .external_lex_state = 308},
  [19088] = {.lex_state = 47, .external_lex_state = 308},
  [19089] = {.lex_state = 0, .external_lex_state = 308},
  [19090] = {.lex_state = 0, .external_lex_state = 308},
  [19091] = {.lex_state = 0, .external_lex_state = 308},
  [19092] = {.lex_state = 0, .external_lex_state = 308},
  [19093] = {.lex_state = 0, .external_lex_state = 308},
  [19094] = {.lex_state = 0, .external_lex_state = 308},
  [19095] = {.lex_state = 0, .external_lex_state = 308},
  [19096] = {.lex_state = 0, .external_lex_state = 308},
  [19097] = {.lex_state = 0, .external_lex_state = 308},
  [19098] = {.lex_state = 0, .external_lex_state = 308},
  [19099] = {.lex_state = 0, .external_lex_state = 308},
  [19100] = {.lex_state = 0, .external_lex_state = 444},
  [19101] = {.lex_state = 0, .external_lex_state = 444},
  [19102] = {.lex_state = 0, .external_lex_state = 444},
  [19103] = {.lex_state = 0, .external_lex_state = 444},
  [19104] = {.lex_state = 47, .external_lex_state = 308},
  [19105] = {.lex_state = 0, .external_lex_state = 308},
  [19106] = {.lex_state = 0, .external_lex_state = 308},
  [19107] = {.lex_state = 0, .external_lex_state = 308},
  [19108] = {.lex_state = 0, .external_lex_state = 308},
  [19109] = {.lex_state = 0, .external_lex_state = 308},
  [19110] = {.lex_state = 0, .external_lex_state = 308},
  [19111] = {.lex_state = 0, .external_lex_state = 308},
  [19112] = {.lex_state = 0, .external_lex_state = 444},
  [19113] = {.lex_state = 0, .external_lex_state = 308},
  [19114] = {.lex_state = 0, .external_lex_state = 308},
  [19115] = {.lex_state = 0, .external_lex_state = 308},
  [19116] = {.lex_state = 0, .external_lex_state = 308},
  [19117] = {.lex_state = 47, .external_lex_state = 308},
  [19118] = {.lex_state = 0, .external_lex_state = 308},
  [19119] = {.lex_state = 0, .external_lex_state = 308},
  [19120] = {.lex_state = 0, .external_lex_state = 308},
  [19121] = {.lex_state = 0, .external_lex_state = 308},
  [19122] = {.lex_state = 0, .external_lex_state = 308},
  [19123] = {.lex_state = 0, .external_lex_state = 308},
  [19124] = {.lex_state = 0, .external_lex_state = 308},
  [19125] = {.lex_state = 0, .external_lex_state = 308},
  [19126] = {.lex_state = 0, .external_lex_state = 308},
  [19127] = {.lex_state = 0, .external_lex_state = 308},
  [19128] = {.lex_state = 0, .external_lex_state = 308},
  [19129] = {.lex_state = 0, .external_lex_state = 308},
  [19130] = {.lex_state = 0, .external_lex_state = 308},
  [19131] = {.lex_state = 0, .external_lex_state = 308},
  [19132] = {.lex_state = 0, .external_lex_state = 444},
  [19133] = {.lex_state = 0, .external_lex_state = 308},
  [19134] = {.lex_state = 0, .external_lex_state = 308},
  [19135] = {.lex_state = 0, .external_lex_state = 308},
  [19136] = {.lex_state = 0, .external_lex_state = 308},
  [19137] = {.lex_state = 0, .external_lex_state = 308},
  [19138] = {.lex_state = 0, .external_lex_state = 308},
  [19139] = {.lex_state = 0, .external_lex_state = 308},
  [19140] = {.lex_state = 0, .external_lex_state = 308},
  [19141] = {.lex_state = 0, .external_lex_state = 308},
  [19142] = {.lex_state = 0, .external_lex_state = 444},
  [19143] = {.lex_state = 0, .external_lex_state = 308},
  [19144] = {.lex_state = 0, .external_lex_state = 308},
  [19145] = {.lex_state = 0, .external_lex_state = 308},
  [19146] = {.lex_state = 0, .external_lex_state = 308},
  [19147] = {.lex_state = 47, .external_lex_state = 308},
  [19148] = {.lex_state = 0, .external_lex_state = 308},
  [19149] = {.lex_state = 0, .external_lex_state = 308},
  [19150] = {.lex_state = 0, .external_lex_state = 308},
  [19151] = {.lex_state = 0, .external_lex_state = 308},
  [19152] = {.lex_state = 0, .external_lex_state = 308},
  [19153] = {.lex_state = 0, .external_lex_state = 308},
  [19154] = {.lex_state = 0, .external_lex_state = 308},
  [19155] = {.lex_state = 0, .external_lex_state = 308},
  [19156] = {.lex_state = 0, .external_lex_state = 308},
  [19157] = {.lex_state = 0, .external_lex_state = 308},
  [19158] = {.lex_state = 0, .external_lex_state = 308},
  [19159] = {.lex_state = 0, .external_lex_state = 308},
  [19160] = {.lex_state = 0, .external_lex_state = 308},
  [19161] = {.lex_state = 0, .external_lex_state = 444},
  [19162] = {.lex_state = 0, .external_lex_state = 308},
  [19163] = {.lex_state = 0, .external_lex_state = 308},
  [19164] = {.lex_state = 0, .external_lex_state = 308},
  [19165] = {.lex_state = 0, .external_lex_state = 308},
  [19166] = {.lex_state = 0, .external_lex_state = 308},
  [19167] = {.lex_state = 0, .external_lex_state = 308},
  [19168] = {.lex_state = 0, .external_lex_state = 308},
  [19169] = {.lex_state = 0, .external_lex_state = 308},
  [19170] = {.lex_state = 0, .external_lex_state = 308},
  [19171] = {.lex_state = 0, .external_lex_state = 308},
  [19172] = {.lex_state = 0, .external_lex_state = 308},
  [19173] = {.lex_state = 0, .external_lex_state = 444},
  [19174] = {.lex_state = 0, .external_lex_state = 308},
  [19175] = {.lex_state = 0, .external_lex_state = 308},
  [19176] = {.lex_state = 0, .external_lex_state = 444},
  [19177] = {.lex_state = 0, .external_lex_state = 444},
  [19178] = {.lex_state = 0, .external_lex_state = 308},
  [19179] = {.lex_state = 0, .external_lex_state = 308},
  [19180] = {.lex_state = 0, .external_lex_state = 308},
  [19181] = {.lex_state = 47, .external_lex_state = 308},
  [19182] = {.lex_state = 0, .external_lex_state = 308},
  [19183] = {.lex_state = 0, .external_lex_state = 308},
  [19184] = {.lex_state = 0, .external_lex_state = 308},
  [19185] = {.lex_state = 0, .external_lex_state = 308},
  [19186] = {.lex_state = 0, .external_lex_state = 308},
  [19187] = {.lex_state = 0, .external_lex_state = 308},
  [19188] = {.lex_state = 0, .external_lex_state = 308},
  [19189] = {.lex_state = 0, .external_lex_state = 308},
  [19190] = {.lex_state = 0, .external_lex_state = 444},
  [19191] = {.lex_state = 0, .external_lex_state = 308},
  [19192] = {.lex_state = 0, .external_lex_state = 308},
  [19193] = {.lex_state = 0, .external_lex_state = 308},
  [19194] = {.lex_state = 0, .external_lex_state = 308},
  [19195] = {.lex_state = 0, .external_lex_state = 308},
  [19196] = {.lex_state = 0, .external_lex_state = 308},
  [19197] = {.lex_state = 0, .external_lex_state = 308},
  [19198] = {.lex_state = 0, .external_lex_state = 308},
  [19199] = {.lex_state = 0, .external_lex_state = 308},
  [19200] = {.lex_state = 0, .external_lex_state = 308},
  [19201] = {.lex_state = 0, .external_lex_state = 308},
  [19202] = {.lex_state = 0, .external_lex_state = 308},
  [19203] = {.lex_state = 0, .external_lex_state = 308},
  [19204] = {.lex_state = 0, .external_lex_state = 308},
  [19205] = {.lex_state = 0, .external_lex_state = 308},
  [19206] = {.lex_state = 0, .external_lex_state = 308},
  [19207] = {.lex_state = 0, .external_lex_state = 308},
  [19208] = {.lex_state = 0, .external_lex_state = 308},
  [19209] = {.lex_state = 0, .external_lex_state = 308},
  [19210] = {.lex_state = 0, .external_lex_state = 308},
  [19211] = {.lex_state = 0, .external_lex_state = 308},
  [19212] = {.lex_state = 0, .external_lex_state = 308},
  [19213] = {.lex_state = 0, .external_lex_state = 308},
  [19214] = {.lex_state = 0, .external_lex_state = 308},
  [19215] = {.lex_state = 0, .external_lex_state = 308},
  [19216] = {.lex_state = 0, .external_lex_state = 308},
  [19217] = {.lex_state = 0, .external_lex_state = 444},
  [19218] = {.lex_state = 0, .external_lex_state = 308},
  [19219] = {.lex_state = 0, .external_lex_state = 308},
  [19220] = {.lex_state = 0, .external_lex_state = 308},
  [19221] = {.lex_state = 0, .external_lex_state = 308},
  [19222] = {.lex_state = 0, .external_lex_state = 308},
  [19223] = {.lex_state = 0, .external_lex_state = 308},
  [19224] = {.lex_state = 0, .external_lex_state = 308},
  [19225] = {.lex_state = 0, .external_lex_state = 308},
  [19226] = {.lex_state = 0, .external_lex_state = 308},
  [19227] = {.lex_state = 0, .external_lex_state = 308},
  [19228] = {.lex_state = 0, .external_lex_state = 308},
  [19229] = {.lex_state = 0, .external_lex_state = 308},
  [19230] = {.lex_state = 0, .external_lex_state = 308},
  [19231] = {.lex_state = 0, .external_lex_state = 308},
  [19232] = {.lex_state = 0, .external_lex_state = 308},
  [19233] = {.lex_state = 0, .external_lex_state = 308},
  [19234] = {.lex_state = 0, .external_lex_state = 444},
  [19235] = {.lex_state = 0, .external_lex_state = 308},
  [19236] = {.lex_state = 0, .external_lex_state = 308},
  [19237] = {.lex_state = 0, .external_lex_state = 308},
  [19238] = {.lex_state = 0, .external_lex_state = 308},
  [19239] = {.lex_state = 47, .external_lex_state = 308},
  [19240] = {.lex_state = 47, .external_lex_state = 308},
  [19241] = {.lex_state = 0, .external_lex_state = 444},
  [19242] = {.lex_state = 0, .external_lex_state = 444},
  [19243] = {.lex_state = 0, .external_lex_state = 444},
  [19244] = {.lex_state = 0, .external_lex_state = 308},
  [19245] = {.lex_state = 0, .external_lex_state = 308},
  [19246] = {.lex_state = 0, .external_lex_state = 308},
  [19247] = {.lex_state = 0, .external_lex_state = 308},
  [19248] = {.lex_state = 0, .external_lex_state = 308},
  [19249] = {.lex_state = 0, .external_lex_state = 308},
  [19250] = {.lex_state = 0, .external_lex_state = 308},
  [19251] = {.lex_state = 0, .external_lex_state = 308},
  [19252] = {.lex_state = 0, .external_lex_state = 308},
  [19253] = {.lex_state = 0, .external_lex_state = 308},
  [19254] = {.lex_state = 0, .external_lex_state = 444},
  [19255] = {.lex_state = 47, .external_lex_state = 308},
  [19256] = {.lex_state = 0, .external_lex_state = 308},
  [19257] = {.lex_state = 0, .external_lex_state = 308},
  [19258] = {.lex_state = 0, .external_lex_state = 308},
  [19259] = {.lex_state = 0, .external_lex_state = 308},
  [19260] = {.lex_state = 0, .external_lex_state = 444},
  [19261] = {.lex_state = 0, .external_lex_state = 308},
  [19262] = {.lex_state = 0, .external_lex_state = 308},
  [19263] = {.lex_state = 0, .external_lex_state = 308},
  [19264] = {.lex_state = 0, .external_lex_state = 444},
  [19265] = {.lex_state = 0, .external_lex_state = 308},
  [19266] = {.lex_state = 0, .external_lex_state = 308},
  [19267] = {.lex_state = 0, .external_lex_state = 308},
  [19268] = {.lex_state = 0, .external_lex_state = 308},
  [19269] = {.lex_state = 0, .external_lex_state = 308},
  [19270] = {.lex_state = 0, .external_lex_state = 308},
  [19271] = {.lex_state = 0, .external_lex_state = 308},
  [19272] = {.lex_state = 0, .external_lex_state = 308},
  [19273] = {.lex_state = 0, .external_lex_state = 308},
  [19274] = {.lex_state = 0, .external_lex_state = 308},
  [19275] = {.lex_state = 0, .external_lex_state = 308},
  [19276] = {.lex_state = 0, .external_lex_state = 308},
  [19277] = {.lex_state = 0, .external_lex_state = 308},
  [19278] = {.lex_state = 0, .external_lex_state = 308},
  [19279] = {.lex_state = 0, .external_lex_state = 308},
  [19280] = {.lex_state = 0, .external_lex_state = 308},
  [19281] = {.lex_state = 0, .external_lex_state = 308},
  [19282] = {.lex_state = 0, .external_lex_state = 308},
  [19283] = {.lex_state = 0, .external_lex_state = 308},
  [19284] = {.lex_state = 0, .external_lex_state = 308},
  [19285] = {.lex_state = 0, .external_lex_state = 308},
  [19286] = {.lex_state = 0, .external_lex_state = 308},
  [19287] = {.lex_state = 0, .external_lex_state = 308},
  [19288] = {.lex_state = 0, .external_lex_state = 444},
  [19289] = {.lex_state = 0, .external_lex_state = 308},
  [19290] = {.lex_state = 0, .external_lex_state = 444},
  [19291] = {.lex_state = 0, .external_lex_state = 308},
  [19292] = {.lex_state = 0, .external_lex_state = 308},
  [19293] = {.lex_state = 0, .external_lex_state = 308},
  [19294] = {.lex_state = 0, .external_lex_state = 308},
  [19295] = {.lex_state = 0, .external_lex_state = 308},
  [19296] = {.lex_state = 0, .external_lex_state = 308},
  [19297] = {.lex_state = 0, .external_lex_state = 308},
  [19298] = {.lex_state = 0, .external_lex_state = 308},
  [19299] = {.lex_state = 0, .external_lex_state = 308},
  [19300] = {.lex_state = 0, .external_lex_state = 308},
  [19301] = {.lex_state = 0, .external_lex_state = 308},
  [19302] = {.lex_state = 47, .external_lex_state = 308},
  [19303] = {.lex_state = 0, .external_lex_state = 308},
  [19304] = {.lex_state = 0, .external_lex_state = 308},
  [19305] = {.lex_state = 0, .external_lex_state = 308},
  [19306] = {.lex_state = 0, .external_lex_state = 308},
  [19307] = {.lex_state = 0, .external_lex_state = 308},
  [19308] = {.lex_state = 0, .external_lex_state = 308},
  [19309] = {.lex_state = 0, .external_lex_state = 308},
  [19310] = {.lex_state = 0, .external_lex_state = 308},
  [19311] = {.lex_state = 0, .external_lex_state = 308},
  [19312] = {.lex_state = 0, .external_lex_state = 308},
  [19313] = {.lex_state = 0, .external_lex_state = 308},
  [19314] = {.lex_state = 0, .external_lex_state = 308},
  [19315] = {.lex_state = 0, .external_lex_state = 308},
  [19316] = {.lex_state = 0, .external_lex_state = 308},
  [19317] = {.lex_state = 0, .external_lex_state = 308},
  [19318] = {.lex_state = 0, .external_lex_state = 308},
  [19319] = {.lex_state = 0, .external_lex_state = 308},
  [19320] = {.lex_state = 0, .external_lex_state = 308},
  [19321] = {.lex_state = 0, .external_lex_state = 308},
  [19322] = {.lex_state = 0, .external_lex_state = 308},
  [19323] = {.lex_state = 0, .external_lex_state = 308},
  [19324] = {.lex_state = 0, .external_lex_state = 444},
  [19325] = {.lex_state = 0, .external_lex_state = 308},
  [19326] = {.lex_state = 0, .external_lex_state = 444},
  [19327] = {.lex_state = 0, .external_lex_state = 308},
  [19328] = {.lex_state = 0, .external_lex_state = 308},
  [19329] = {.lex_state = 0, .external_lex_state = 308},
  [19330] = {.lex_state = 0, .external_lex_state = 308},
  [19331] = {.lex_state = 0, .external_lex_state = 308},
  [19332] = {.lex_state = 0, .external_lex_state = 444},
  [19333] = {.lex_state = 0, .external_lex_state = 308},
  [19334] = {.lex_state = 0, .external_lex_state = 308},
  [19335] = {.lex_state = 0, .external_lex_state = 308},
  [19336] = {.lex_state = 0, .external_lex_state = 308},
  [19337] = {.lex_state = 0, .external_lex_state = 308},
  [19338] = {.lex_state = 0, .external_lex_state = 308},
  [19339] = {.lex_state = 0, .external_lex_state = 308},
  [19340] = {.lex_state = 0, .external_lex_state = 308},
  [19341] = {.lex_state = 0, .external_lex_state = 308},
  [19342] = {.lex_state = 0, .external_lex_state = 308},
  [19343] = {.lex_state = 0, .external_lex_state = 308},
  [19344] = {.lex_state = 0, .external_lex_state = 444},
  [19345] = {.lex_state = 0, .external_lex_state = 308},
  [19346] = {.lex_state = 0, .external_lex_state = 308},
  [19347] = {.lex_state = 0, .external_lex_state = 308},
  [19348] = {.lex_state = 0, .external_lex_state = 308},
  [19349] = {.lex_state = 0, .external_lex_state = 308},
  [19350] = {.lex_state = 0, .external_lex_state = 308},
  [19351] = {.lex_state = 0, .external_lex_state = 308},
  [19352] = {.lex_state = 0, .external_lex_state = 308},
  [19353] = {.lex_state = 0, .external_lex_state = 308},
  [19354] = {.lex_state = 0, .external_lex_state = 444},
  [19355] = {.lex_state = 47, .external_lex_state = 308},
  [19356] = {.lex_state = 0, .external_lex_state = 308},
  [19357] = {.lex_state = 0, .external_lex_state = 308},
  [19358] = {.lex_state = 0, .external_lex_state = 308},
  [19359] = {.lex_state = 0, .external_lex_state = 308},
  [19360] = {.lex_state = 0, .external_lex_state = 308},
  [19361] = {.lex_state = 0, .external_lex_state = 308},
  [19362] = {.lex_state = 0, .external_lex_state = 308},
  [19363] = {.lex_state = 0, .external_lex_state = 444},
  [19364] = {.lex_state = 0, .external_lex_state = 444},
  [19365] = {.lex_state = 0, .external_lex_state = 308},
  [19366] = {.lex_state = 47, .external_lex_state = 308},
  [19367] = {.lex_state = 0, .external_lex_state = 308},
  [19368] = {.lex_state = 0, .external_lex_state = 308},
  [19369] = {.lex_state = 0, .external_lex_state = 308},
  [19370] = {.lex_state = 0, .external_lex_state = 308},
  [19371] = {.lex_state = 0, .external_lex_state = 308},
  [19372] = {.lex_state = 0, .external_lex_state = 308},
  [19373] = {.lex_state = 0, .external_lex_state = 308},
  [19374] = {.lex_state = 0, .external_lex_state = 308},
  [19375] = {.lex_state = 0, .external_lex_state = 444},
  [19376] = {.lex_state = 0, .external_lex_state = 308},
  [19377] = {.lex_state = 0, .external_lex_state = 308},
  [19378] = {.lex_state = 0, .external_lex_state = 308},
  [19379] = {.lex_state = 0, .external_lex_state = 308},
  [19380] = {.lex_state = 0, .external_lex_state = 308},
  [19381] = {.lex_state = 0, .external_lex_state = 308},
  [19382] = {.lex_state = 0, .external_lex_state = 308},
  [19383] = {.lex_state = 0, .external_lex_state = 308},
  [19384] = {.lex_state = 0, .external_lex_state = 308},
  [19385] = {.lex_state = 0, .external_lex_state = 308},
  [19386] = {.lex_state = 0, .external_lex_state = 308},
  [19387] = {.lex_state = 0, .external_lex_state = 308},
  [19388] = {.lex_state = 0, .external_lex_state = 308},
  [19389] = {.lex_state = 0, .external_lex_state = 308},
  [19390] = {.lex_state = 0, .external_lex_state = 308},
  [19391] = {.lex_state = 0, .external_lex_state = 308},
  [19392] = {.lex_state = 47, .external_lex_state = 308},
  [19393] = {.lex_state = 0, .external_lex_state = 308},
  [19394] = {.lex_state = 0, .external_lex_state = 308},
  [19395] = {.lex_state = 0, .external_lex_state = 308},
  [19396] = {.lex_state = 0, .external_lex_state = 308},
  [19397] = {.lex_state = 0, .external_lex_state = 308},
  [19398] = {.lex_state = 0, .external_lex_state = 308},
  [19399] = {.lex_state = 0, .external_lex_state = 308},
  [19400] = {.lex_state = 0, .external_lex_state = 308},
  [19401] = {.lex_state = 0, .external_lex_state = 444},
  [19402] = {.lex_state = 0, .external_lex_state = 308},
  [19403] = {.lex_state = 0, .external_lex_state = 308},
  [19404] = {.lex_state = 0, .external_lex_state = 444},
  [19405] = {.lex_state = 0, .external_lex_state = 444},
  [19406] = {.lex_state = 0, .external_lex_state = 444},
  [19407] = {.lex_state = 0, .external_lex_state = 308},
  [19408] = {.lex_state = 0, .external_lex_state = 308},
  [19409] = {.lex_state = 0, .external_lex_state = 308},
  [19410] = {.lex_state = 47, .external_lex_state = 308},
  [19411] = {.lex_state = 0, .external_lex_state = 308},
  [19412] = {.lex_state = 0, .external_lex_state = 308},
  [19413] = {.lex_state = 0, .external_lex_state = 308},
  [19414] = {.lex_state = 0, .external_lex_state = 308},
  [19415] = {.lex_state = 0, .external_lex_state = 308},
  [19416] = {.lex_state = 47, .external_lex_state = 308},
  [19417] = {.lex_state = 0, .external_lex_state = 308},
  [19418] = {.lex_state = 0, .external_lex_state = 444},
  [19419] = {.lex_state = 0, .external_lex_state = 308},
  [19420] = {.lex_state = 0, .external_lex_state = 308},
  [19421] = {.lex_state = 0, .external_lex_state = 308},
  [19422] = {.lex_state = 0, .external_lex_state = 444},
  [19423] = {.lex_state = 0, .external_lex_state = 308},
  [19424] = {.lex_state = 0, .external_lex_state = 308},
  [19425] = {.lex_state = 0, .external_lex_state = 308},
  [19426] = {.lex_state = 0, .external_lex_state = 308},
  [19427] = {.lex_state = 0, .external_lex_state = 308},
  [19428] = {.lex_state = 0, .external_lex_state = 308},
  [19429] = {.lex_state = 0, .external_lex_state = 308},
  [19430] = {.lex_state = 0, .external_lex_state = 308},
  [19431] = {.lex_state = 0, .external_lex_state = 308},
  [19432] = {.lex_state = 0, .external_lex_state = 308},
  [19433] = {.lex_state = 0, .external_lex_state = 308},
  [19434] = {.lex_state = 0, .external_lex_state = 308},
  [19435] = {.lex_state = 0, .external_lex_state = 308},
  [19436] = {.lex_state = 0, .external_lex_state = 308},
  [19437] = {.lex_state = 0, .external_lex_state = 308},
  [19438] = {.lex_state = 47, .external_lex_state = 308},
  [19439] = {.lex_state = 0, .external_lex_state = 308},
  [19440] = {.lex_state = 0, .external_lex_state = 308},
  [19441] = {.lex_state = 0, .external_lex_state = 308},
  [19442] = {.lex_state = 0, .external_lex_state = 308},
  [19443] = {.lex_state = 0, .external_lex_state = 308},
  [19444] = {.lex_state = 0, .external_lex_state = 308},
  [19445] = {.lex_state = 0, .external_lex_state = 308},
  [19446] = {.lex_state = 0, .external_lex_state = 308},
  [19447] = {.lex_state = 0, .external_lex_state = 444},
  [19448] = {.lex_state = 0, .external_lex_state = 308},
  [19449] = {.lex_state = 0, .external_lex_state = 308},
  [19450] = {.lex_state = 0, .external_lex_state = 308},
  [19451] = {.lex_state = 0, .external_lex_state = 308},
  [19452] = {.lex_state = 0, .external_lex_state = 308},
  [19453] = {.lex_state = 0, .external_lex_state = 308},
  [19454] = {.lex_state = 0, .external_lex_state = 308},
  [19455] = {.lex_state = 0, .external_lex_state = 308},
  [19456] = {.lex_state = 0, .external_lex_state = 308},
  [19457] = {.lex_state = 0, .external_lex_state = 308},
  [19458] = {.lex_state = 0, .external_lex_state = 308},
  [19459] = {.lex_state = 0, .external_lex_state = 308},
  [19460] = {.lex_state = 0, .external_lex_state = 444},
  [19461] = {.lex_state = 0, .external_lex_state = 308},
  [19462] = {.lex_state = 0, .external_lex_state = 308},
  [19463] = {.lex_state = 0, .external_lex_state = 308},
  [19464] = {.lex_state = 0, .external_lex_state = 308},
  [19465] = {.lex_state = 47, .external_lex_state = 308},
  [19466] = {.lex_state = 0, .external_lex_state = 308},
  [19467] = {.lex_state = 0, .external_lex_state = 308},
  [19468] = {.lex_state = 0, .external_lex_state = 308},
  [19469] = {.lex_state = 0, .external_lex_state = 308},
  [19470] = {.lex_state = 0, .external_lex_state = 308},
  [19471] = {.lex_state = 0, .external_lex_state = 308},
  [19472] = {.lex_state = 0, .external_lex_state = 308},
  [19473] = {.lex_state = 0, .external_lex_state = 444},
  [19474] = {.lex_state = 0, .external_lex_state = 308},
  [19475] = {.lex_state = 0, .external_lex_state = 308},
  [19476] = {.lex_state = 0, .external_lex_state = 308},
  [19477] = {.lex_state = 0, .external_lex_state = 308},
  [19478] = {.lex_state = 0, .external_lex_state = 308},
  [19479] = {.lex_state = 0, .external_lex_state = 308},
  [19480] = {.lex_state = 0, .external_lex_state = 308},
  [19481] = {.lex_state = 0, .external_lex_state = 308},
  [19482] = {.lex_state = 0, .external_lex_state = 308},
  [19483] = {.lex_state = 0, .external_lex_state = 308},
  [19484] = {.lex_state = 0, .external_lex_state = 308},
  [19485] = {.lex_state = 0, .external_lex_state = 308},
  [19486] = {.lex_state = 0, .external_lex_state = 308},
  [19487] = {.lex_state = 47, .external_lex_state = 308},
  [19488] = {.lex_state = 0, .external_lex_state = 308},
  [19489] = {.lex_state = 0, .external_lex_state = 308},
  [19490] = {.lex_state = 0, .external_lex_state = 308},
  [19491] = {.lex_state = 0, .external_lex_state = 308},
  [19492] = {.lex_state = 0, .external_lex_state = 308},
  [19493] = {.lex_state = 0, .external_lex_state = 308},
  [19494] = {.lex_state = 0, .external_lex_state = 308},
  [19495] = {.lex_state = 0, .external_lex_state = 308},
  [19496] = {.lex_state = 0, .external_lex_state = 308},
  [19497] = {.lex_state = 0, .external_lex_state = 308},
  [19498] = {.lex_state = 0, .external_lex_state = 308},
  [19499] = {.lex_state = 0, .external_lex_state = 308},
  [19500] = {.lex_state = 0, .external_lex_state = 308},
  [19501] = {.lex_state = 0, .external_lex_state = 308},
  [19502] = {.lex_state = 0, .external_lex_state = 308},
  [19503] = {.lex_state = 0, .external_lex_state = 308},
  [19504] = {.lex_state = 0, .external_lex_state = 308},
  [19505] = {.lex_state = 0, .external_lex_state = 308},
  [19506] = {.lex_state = 0, .external_lex_state = 308},
  [19507] = {.lex_state = 0, .external_lex_state = 308},
  [19508] = {.lex_state = 0, .external_lex_state = 308},
  [19509] = {.lex_state = 0, .external_lex_state = 308},
  [19510] = {.lex_state = 0, .external_lex_state = 308},
  [19511] = {.lex_state = 0, .external_lex_state = 308},
  [19512] = {.lex_state = 0, .external_lex_state = 308},
  [19513] = {.lex_state = 0, .external_lex_state = 308},
  [19514] = {.lex_state = 0, .external_lex_state = 308},
  [19515] = {.lex_state = 0, .external_lex_state = 308},
  [19516] = {.lex_state = 0, .external_lex_state = 308},
  [19517] = {.lex_state = 0, .external_lex_state = 308},
  [19518] = {.lex_state = 0, .external_lex_state = 444},
  [19519] = {.lex_state = 0, .external_lex_state = 444},
  [19520] = {.lex_state = 0, .external_lex_state = 308},
  [19521] = {.lex_state = 0, .external_lex_state = 308},
  [19522] = {.lex_state = 0, .external_lex_state = 308},
  [19523] = {.lex_state = 0, .external_lex_state = 308},
  [19524] = {.lex_state = 0, .external_lex_state = 308},
  [19525] = {.lex_state = 0, .external_lex_state = 308},
  [19526] = {.lex_state = 0, .external_lex_state = 308},
  [19527] = {.lex_state = 0, .external_lex_state = 308},
  [19528] = {.lex_state = 0, .external_lex_state = 308},
  [19529] = {.lex_state = 0, .external_lex_state = 308},
  [19530] = {.lex_state = 0, .external_lex_state = 308},
  [19531] = {.lex_state = 0, .external_lex_state = 308},
  [19532] = {.lex_state = 0, .external_lex_state = 308},
  [19533] = {.lex_state = 0, .external_lex_state = 308},
  [19534] = {.lex_state = 47, .external_lex_state = 308},
  [19535] = {.lex_state = 0, .external_lex_state = 308},
  [19536] = {.lex_state = 0, .external_lex_state = 355},
  [19537] = {.lex_state = 0, .external_lex_state = 308},
  [19538] = {.lex_state = 50, .external_lex_state = 308},
  [19539] = {.lex_state = 0, .external_lex_state = 308},
  [19540] = {.lex_state = 0, .external_lex_state = 308},
  [19541] = {.lex_state = 0, .external_lex_state = 414},
  [19542] = {.lex_state = 0, .external_lex_state = 308},
  [19543] = {.lex_state = 0, .external_lex_state = 308},
  [19544] = {.lex_state = 0, .external_lex_state = 308},
  [19545] = {.lex_state = 0, .external_lex_state = 308},
  [19546] = {.lex_state = 0, .external_lex_state = 308},
  [19547] = {.lex_state = 0, .external_lex_state = 308},
  [19548] = {.lex_state = 0, .external_lex_state = 308},
  [19549] = {.lex_state = 0, .external_lex_state = 308},
  [19550] = {.lex_state = 0, .external_lex_state = 308},
  [19551] = {.lex_state = 47, .external_lex_state = 308},
  [19552] = {.lex_state = 0, .external_lex_state = 308},
  [19553] = {.lex_state = 0, .external_lex_state = 308},
  [19554] = {.lex_state = 0, .external_lex_state = 444},
  [19555] = {.lex_state = 0, .external_lex_state = 308},
  [19556] = {.lex_state = 0, .external_lex_state = 308},
  [19557] = {.lex_state = 0, .external_lex_state = 308},
  [19558] = {.lex_state = 0, .external_lex_state = 308},
  [19559] = {.lex_state = 0, .external_lex_state = 308},
  [19560] = {.lex_state = 0, .external_lex_state = 444},
  [19561] = {.lex_state = 0, .external_lex_state = 308},
  [19562] = {.lex_state = 0, .external_lex_state = 308},
  [19563] = {.lex_state = 47, .external_lex_state = 308},
  [19564] = {.lex_state = 0, .external_lex_state = 308},
  [19565] = {.lex_state = 0, .external_lex_state = 308},
  [19566] = {.lex_state = 0, .external_lex_state = 308},
  [19567] = {.lex_state = 0, .external_lex_state = 308},
  [19568] = {.lex_state = 0, .external_lex_state = 308},
  [19569] = {.lex_state = 0, .external_lex_state = 308},
  [19570] = {.lex_state = 0, .external_lex_state = 308},
  [19571] = {.lex_state = 0, .external_lex_state = 308},
  [19572] = {.lex_state = 50, .external_lex_state = 308},
  [19573] = {.lex_state = 0, .external_lex_state = 308},
  [19574] = {.lex_state = 0, .external_lex_state = 444},
  [19575] = {.lex_state = 0, .external_lex_state = 308},
  [19576] = {.lex_state = 0, .external_lex_state = 308},
  [19577] = {.lex_state = 0, .external_lex_state = 308},
  [19578] = {.lex_state = 0, .external_lex_state = 308},
  [19579] = {.lex_state = 0, .external_lex_state = 308},
  [19580] = {.lex_state = 0, .external_lex_state = 308},
  [19581] = {.lex_state = 0, .external_lex_state = 308},
  [19582] = {.lex_state = 0, .external_lex_state = 308},
  [19583] = {.lex_state = 0, .external_lex_state = 308},
  [19584] = {.lex_state = 0, .external_lex_state = 308},
  [19585] = {.lex_state = 0, .external_lex_state = 308},
  [19586] = {.lex_state = 0, .external_lex_state = 308},
  [19587] = {.lex_state = 0, .external_lex_state = 308},
  [19588] = {.lex_state = 0, .external_lex_state = 308},
  [19589] = {.lex_state = 0, .external_lex_state = 308},
  [19590] = {.lex_state = 0, .external_lex_state = 308},
  [19591] = {.lex_state = 0, .external_lex_state = 308},
  [19592] = {.lex_state = 0, .external_lex_state = 308},
  [19593] = {.lex_state = 0, .external_lex_state = 308},
  [19594] = {.lex_state = 0, .external_lex_state = 308},
  [19595] = {.lex_state = 0, .external_lex_state = 308},
  [19596] = {.lex_state = 0, .external_lex_state = 308},
  [19597] = {.lex_state = 0, .external_lex_state = 308},
  [19598] = {.lex_state = 0, .external_lex_state = 308},
  [19599] = {.lex_state = 0, .external_lex_state = 308},
  [19600] = {.lex_state = 0, .external_lex_state = 308},
  [19601] = {.lex_state = 0, .external_lex_state = 308},
  [19602] = {.lex_state = 47, .external_lex_state = 308},
  [19603] = {.lex_state = 0, .external_lex_state = 444},
  [19604] = {.lex_state = 0, .external_lex_state = 308},
  [19605] = {.lex_state = 0, .external_lex_state = 308},
  [19606] = {.lex_state = 0, .external_lex_state = 308},
  [19607] = {.lex_state = 0, .external_lex_state = 308},
  [19608] = {.lex_state = 0, .external_lex_state = 444},
  [19609] = {.lex_state = 0, .external_lex_state = 308},
  [19610] = {.lex_state = 0, .external_lex_state = 444},
  [19611] = {.lex_state = 0, .external_lex_state = 308},
  [19612] = {.lex_state = 0, .external_lex_state = 308},
  [19613] = {.lex_state = 0, .external_lex_state = 308},
  [19614] = {.lex_state = 47, .external_lex_state = 443},
  [19615] = {.lex_state = 47, .external_lex_state = 308},
  [19616] = {.lex_state = 0, .external_lex_state = 308},
  [19617] = {.lex_state = 0, .external_lex_state = 308},
  [19618] = {.lex_state = 47, .external_lex_state = 308},
  [19619] = {.lex_state = 0, .external_lex_state = 308},
  [19620] = {.lex_state = 50, .external_lex_state = 308},
  [19621] = {.lex_state = 0, .external_lex_state = 308},
  [19622] = {.lex_state = 47, .external_lex_state = 308},
  [19623] = {.lex_state = 0, .external_lex_state = 414},
  [19624] = {.lex_state = 0, .external_lex_state = 308},
  [19625] = {.lex_state = 0, .external_lex_state = 444},
  [19626] = {.lex_state = 47, .external_lex_state = 308},
  [19627] = {.lex_state = 47, .external_lex_state = 308},
  [19628] = {.lex_state = 0, .external_lex_state = 444},
  [19629] = {.lex_state = 0, .external_lex_state = 308},
  [19630] = {.lex_state = 0, .external_lex_state = 444},
  [19631] = {.lex_state = 47, .external_lex_state = 308},
  [19632] = {.lex_state = 0, .external_lex_state = 308},
  [19633] = {.lex_state = 0, .external_lex_state = 308},
  [19634] = {.lex_state = 47, .external_lex_state = 308},
  [19635] = {.lex_state = 0, .external_lex_state = 308},
  [19636] = {.lex_state = 0, .external_lex_state = 444},
  [19637] = {.lex_state = 0, .external_lex_state = 308},
  [19638] = {.lex_state = 0, .external_lex_state = 308},
  [19639] = {.lex_state = 0, .external_lex_state = 308},
  [19640] = {.lex_state = 0, .external_lex_state = 308},
  [19641] = {.lex_state = 0, .external_lex_state = 308},
  [19642] = {.lex_state = 0, .external_lex_state = 308},
  [19643] = {.lex_state = 0, .external_lex_state = 308},
  [19644] = {.lex_state = 0, .external_lex_state = 308},
  [19645] = {.lex_state = 0, .external_lex_state = 308},
  [19646] = {.lex_state = 0, .external_lex_state = 308},
  [19647] = {.lex_state = 0, .external_lex_state = 308},
  [19648] = {.lex_state = 0, .external_lex_state = 308},
  [19649] = {.lex_state = 0, .external_lex_state = 308},
  [19650] = {.lex_state = 0, .external_lex_state = 308},
  [19651] = {.lex_state = 50, .external_lex_state = 308},
  [19652] = {.lex_state = 0, .external_lex_state = 308},
  [19653] = {.lex_state = 0, .external_lex_state = 308},
  [19654] = {.lex_state = 0, .external_lex_state = 308},
  [19655] = {.lex_state = 0, .external_lex_state = 308},
  [19656] = {.lex_state = 0, .external_lex_state = 308},
  [19657] = {.lex_state = 0, .external_lex_state = 308},
  [19658] = {.lex_state = 0, .external_lex_state = 308},
  [19659] = {.lex_state = 0, .external_lex_state = 308},
  [19660] = {.lex_state = 0, .external_lex_state = 308},
  [19661] = {.lex_state = 0, .external_lex_state = 308},
  [19662] = {.lex_state = 0, .external_lex_state = 308},
  [19663] = {.lex_state = 0, .external_lex_state = 308},
  [19664] = {.lex_state = 0, .external_lex_state = 308},
  [19665] = {.lex_state = 0, .external_lex_state = 308},
  [19666] = {.lex_state = 0, .external_lex_state = 444},
  [19667] = {.lex_state = 0, .external_lex_state = 308},
  [19668] = {.lex_state = 0, .external_lex_state = 308},
  [19669] = {.lex_state = 0, .external_lex_state = 308},
  [19670] = {.lex_state = 0, .external_lex_state = 308},
  [19671] = {.lex_state = 0, .external_lex_state = 444},
  [19672] = {.lex_state = 47, .external_lex_state = 308},
  [19673] = {.lex_state = 0, .external_lex_state = 414},
  [19674] = {.lex_state = 0, .external_lex_state = 308},
  [19675] = {.lex_state = 0, .external_lex_state = 308},
  [19676] = {.lex_state = 0, .external_lex_state = 308},
  [19677] = {.lex_state = 0, .external_lex_state = 308},
  [19678] = {.lex_state = 0, .external_lex_state = 308},
  [19679] = {.lex_state = 0, .external_lex_state = 308},
  [19680] = {.lex_state = 0, .external_lex_state = 308},
  [19681] = {.lex_state = 0, .external_lex_state = 308},
  [19682] = {.lex_state = 0, .external_lex_state = 308},
  [19683] = {.lex_state = 0, .external_lex_state = 308},
  [19684] = {.lex_state = 0, .external_lex_state = 308},
  [19685] = {.lex_state = 0, .external_lex_state = 308},
  [19686] = {.lex_state = 0, .external_lex_state = 308},
  [19687] = {.lex_state = 0, .external_lex_state = 308},
  [19688] = {.lex_state = 0, .external_lex_state = 444},
  [19689] = {.lex_state = 0, .external_lex_state = 308},
  [19690] = {.lex_state = 0, .external_lex_state = 444},
  [19691] = {.lex_state = 0, .external_lex_state = 308},
  [19692] = {.lex_state = 0, .external_lex_state = 308},
  [19693] = {.lex_state = 0, .external_lex_state = 308},
  [19694] = {.lex_state = 0, .external_lex_state = 308},
  [19695] = {.lex_state = 0, .external_lex_state = 308},
  [19696] = {.lex_state = 0, .external_lex_state = 308},
  [19697] = {.lex_state = 0, .external_lex_state = 308},
  [19698] = {.lex_state = 0, .external_lex_state = 308},
  [19699] = {.lex_state = 0, .external_lex_state = 308},
  [19700] = {.lex_state = 0, .external_lex_state = 444},
  [19701] = {.lex_state = 0, .external_lex_state = 308},
  [19702] = {.lex_state = 0, .external_lex_state = 308},
  [19703] = {.lex_state = 0, .external_lex_state = 308},
  [19704] = {.lex_state = 0, .external_lex_state = 414},
  [19705] = {.lex_state = 0, .external_lex_state = 308},
  [19706] = {.lex_state = 0, .external_lex_state = 308},
  [19707] = {.lex_state = 0, .external_lex_state = 308},
  [19708] = {.lex_state = 0, .external_lex_state = 308},
  [19709] = {.lex_state = 0, .external_lex_state = 308},
  [19710] = {.lex_state = 0, .external_lex_state = 444},
  [19711] = {.lex_state = 0, .external_lex_state = 308},
  [19712] = {.lex_state = 0, .external_lex_state = 308},
  [19713] = {.lex_state = 0, .external_lex_state = 308},
  [19714] = {.lex_state = 0, .external_lex_state = 308},
  [19715] = {.lex_state = 0, .external_lex_state = 308},
  [19716] = {.lex_state = 0, .external_lex_state = 308},
  [19717] = {.lex_state = 0, .external_lex_state = 308},
  [19718] = {.lex_state = 0, .external_lex_state = 308},
  [19719] = {.lex_state = 0, .external_lex_state = 444},
  [19720] = {.lex_state = 0, .external_lex_state = 444},
  [19721] = {.lex_state = 47, .external_lex_state = 308},
  [19722] = {.lex_state = 0, .external_lex_state = 308},
  [19723] = {.lex_state = 47, .external_lex_state = 308},
  [19724] = {.lex_state = 0, .external_lex_state = 308},
  [19725] = {.lex_state = 0, .external_lex_state = 308},
  [19726] = {.lex_state = 0, .external_lex_state = 308},
  [19727] = {.lex_state = 0, .external_lex_state = 308},
  [19728] = {.lex_state = 0, .external_lex_state = 308},
  [19729] = {.lex_state = 0, .external_lex_state = 308},
  [19730] = {.lex_state = 0, .external_lex_state = 414},
  [19731] = {.lex_state = 0, .external_lex_state = 308},
  [19732] = {.lex_state = 0, .external_lex_state = 308},
  [19733] = {.lex_state = 0, .external_lex_state = 308},
  [19734] = {.lex_state = 0, .external_lex_state = 308},
  [19735] = {.lex_state = 47, .external_lex_state = 308},
  [19736] = {.lex_state = 0, .external_lex_state = 308},
  [19737] = {.lex_state = 0, .external_lex_state = 308},
  [19738] = {.lex_state = 0, .external_lex_state = 308},
  [19739] = {.lex_state = 0, .external_lex_state = 308},
  [19740] = {.lex_state = 0, .external_lex_state = 444},
  [19741] = {.lex_state = 0, .external_lex_state = 308},
  [19742] = {.lex_state = 47, .external_lex_state = 308},
  [19743] = {.lex_state = 0, .external_lex_state = 308},
  [19744] = {.lex_state = 0, .external_lex_state = 308},
  [19745] = {.lex_state = 0, .external_lex_state = 308},
  [19746] = {.lex_state = 0, .external_lex_state = 308},
  [19747] = {.lex_state = 0, .external_lex_state = 308},
  [19748] = {.lex_state = 0, .external_lex_state = 308},
  [19749] = {.lex_state = 0, .external_lex_state = 444},
  [19750] = {.lex_state = 47, .external_lex_state = 308},
  [19751] = {.lex_state = 0, .external_lex_state = 308},
  [19752] = {.lex_state = 0, .external_lex_state = 444},
  [19753] = {.lex_state = 0, .external_lex_state = 308},
  [19754] = {.lex_state = 0, .external_lex_state = 414},
  [19755] = {.lex_state = 0, .external_lex_state = 308},
  [19756] = {.lex_state = 0, .external_lex_state = 308},
  [19757] = {.lex_state = 0, .external_lex_state = 308},
  [19758] = {.lex_state = 47, .external_lex_state = 308},
  [19759] = {.lex_state = 0, .external_lex_state = 308},
  [19760] = {.lex_state = 0, .external_lex_state = 308},
  [19761] = {.lex_state = 0, .external_lex_state = 308},
  [19762] = {.lex_state = 0, .external_lex_state = 308},
  [19763] = {.lex_state = 0, .external_lex_state = 308},
  [19764] = {.lex_state = 0, .external_lex_state = 308},
  [19765] = {.lex_state = 0, .external_lex_state = 308},
  [19766] = {.lex_state = 0, .external_lex_state = 308},
  [19767] = {.lex_state = 0, .external_lex_state = 308},
  [19768] = {.lex_state = 0, .external_lex_state = 444},
  [19769] = {.lex_state = 0, .external_lex_state = 308},
  [19770] = {.lex_state = 0, .external_lex_state = 308},
  [19771] = {.lex_state = 0, .external_lex_state = 308},
  [19772] = {.lex_state = 0, .external_lex_state = 308},
  [19773] = {.lex_state = 0, .external_lex_state = 308},
  [19774] = {.lex_state = 0, .external_lex_state = 308},
  [19775] = {.lex_state = 0, .external_lex_state = 308},
  [19776] = {.lex_state = 0, .external_lex_state = 414},
  [19777] = {.lex_state = 47, .external_lex_state = 308},
  [19778] = {.lex_state = 0, .external_lex_state = 308},
  [19779] = {.lex_state = 0, .external_lex_state = 308},
  [19780] = {.lex_state = 0, .external_lex_state = 444},
  [19781] = {.lex_state = 47, .external_lex_state = 308},
  [19782] = {.lex_state = 0, .external_lex_state = 308},
  [19783] = {.lex_state = 0, .external_lex_state = 444},
  [19784] = {.lex_state = 0, .external_lex_state = 444},
  [19785] = {.lex_state = 0, .external_lex_state = 308},
  [19786] = {.lex_state = 0, .external_lex_state = 308},
  [19787] = {.lex_state = 0, .external_lex_state = 308},
  [19788] = {.lex_state = 0, .external_lex_state = 308},
  [19789] = {.lex_state = 0, .external_lex_state = 308},
  [19790] = {.lex_state = 0, .external_lex_state = 308},
  [19791] = {.lex_state = 0, .external_lex_state = 308},
  [19792] = {.lex_state = 0, .external_lex_state = 308},
  [19793] = {.lex_state = 0, .external_lex_state = 308},
  [19794] = {.lex_state = 47, .external_lex_state = 308},
  [19795] = {.lex_state = 0, .external_lex_state = 308},
  [19796] = {.lex_state = 0, .external_lex_state = 308},
  [19797] = {.lex_state = 0, .external_lex_state = 308},
  [19798] = {.lex_state = 0, .external_lex_state = 414},
  [19799] = {.lex_state = 0, .external_lex_state = 308},
  [19800] = {.lex_state = 0, .external_lex_state = 444},
  [19801] = {.lex_state = 0, .external_lex_state = 444},
  [19802] = {.lex_state = 0, .external_lex_state = 308},
  [19803] = {.lex_state = 0, .external_lex_state = 308},
  [19804] = {.lex_state = 0, .external_lex_state = 308},
  [19805] = {.lex_state = 0, .external_lex_state = 308},
  [19806] = {.lex_state = 0, .external_lex_state = 308},
  [19807] = {.lex_state = 0, .external_lex_state = 308},
  [19808] = {.lex_state = 0, .external_lex_state = 308},
  [19809] = {.lex_state = 0, .external_lex_state = 308},
  [19810] = {.lex_state = 0, .external_lex_state = 308},
  [19811] = {.lex_state = 0, .external_lex_state = 308},
  [19812] = {.lex_state = 0, .external_lex_state = 308},
  [19813] = {.lex_state = 0, .external_lex_state = 308},
  [19814] = {.lex_state = 0, .external_lex_state = 308},
  [19815] = {.lex_state = 0, .external_lex_state = 308},
  [19816] = {.lex_state = 0, .external_lex_state = 308},
  [19817] = {.lex_state = 0, .external_lex_state = 308},
  [19818] = {.lex_state = 0, .external_lex_state = 308},
  [19819] = {.lex_state = 0, .external_lex_state = 308},
  [19820] = {.lex_state = 0, .external_lex_state = 414},
  [19821] = {.lex_state = 0, .external_lex_state = 308},
  [19822] = {.lex_state = 0, .external_lex_state = 308},
  [19823] = {.lex_state = 0, .external_lex_state = 308},
  [19824] = {.lex_state = 0, .external_lex_state = 308},
  [19825] = {.lex_state = 47, .external_lex_state = 443},
  [19826] = {.lex_state = 0, .external_lex_state = 308},
  [19827] = {.lex_state = 0, .external_lex_state = 308},
  [19828] = {.lex_state = 0, .external_lex_state = 308},
  [19829] = {.lex_state = 0, .external_lex_state = 308},
  [19830] = {.lex_state = 0, .external_lex_state = 308},
  [19831] = {.lex_state = 0, .external_lex_state = 308},
  [19832] = {.lex_state = 0, .external_lex_state = 444},
  [19833] = {.lex_state = 0, .external_lex_state = 444},
  [19834] = {.lex_state = 0, .external_lex_state = 308},
  [19835] = {.lex_state = 47, .external_lex_state = 308},
  [19836] = {.lex_state = 0, .external_lex_state = 308},
  [19837] = {.lex_state = 0, .external_lex_state = 308},
  [19838] = {.lex_state = 0, .external_lex_state = 414},
  [19839] = {.lex_state = 0, .external_lex_state = 308},
  [19840] = {.lex_state = 0, .external_lex_state = 308},
  [19841] = {.lex_state = 0, .external_lex_state = 308},
  [19842] = {.lex_state = 0, .external_lex_state = 308},
  [19843] = {.lex_state = 0, .external_lex_state = 308},
  [19844] = {.lex_state = 47, .external_lex_state = 308},
  [19845] = {.lex_state = 0, .external_lex_state = 308},
  [19846] = {.lex_state = 0, .external_lex_state = 308},
  [19847] = {.lex_state = 0, .external_lex_state = 308},
  [19848] = {.lex_state = 0, .external_lex_state = 308},
  [19849] = {.lex_state = 0, .external_lex_state = 444},
  [19850] = {.lex_state = 47, .external_lex_state = 308},
  [19851] = {.lex_state = 0, .external_lex_state = 444},
  [19852] = {.lex_state = 0, .external_lex_state = 308},
  [19853] = {.lex_state = 0, .external_lex_state = 308},
  [19854] = {.lex_state = 0, .external_lex_state = 444},
  [19855] = {.lex_state = 47, .external_lex_state = 308},
  [19856] = {.lex_state = 0, .external_lex_state = 414},
  [19857] = {.lex_state = 0, .external_lex_state = 308},
  [19858] = {.lex_state = 0, .external_lex_state = 444},
  [19859] = {.lex_state = 0, .external_lex_state = 308},
  [19860] = {.lex_state = 0, .external_lex_state = 308},
  [19861] = {.lex_state = 0, .external_lex_state = 308},
  [19862] = {.lex_state = 0, .external_lex_state = 308},
  [19863] = {.lex_state = 0, .external_lex_state = 308},
  [19864] = {.lex_state = 0, .external_lex_state = 308},
  [19865] = {.lex_state = 0, .external_lex_state = 308},
  [19866] = {.lex_state = 0, .external_lex_state = 308},
  [19867] = {.lex_state = 0, .external_lex_state = 308},
  [19868] = {.lex_state = 0, .external_lex_state = 308},
  [19869] = {.lex_state = 0, .external_lex_state = 308},
  [19870] = {.lex_state = 0, .external_lex_state = 308},
  [19871] = {.lex_state = 0, .external_lex_state = 308},
  [19872] = {.lex_state = 0, .external_lex_state = 308},
  [19873] = {.lex_state = 0, .external_lex_state = 308},
  [19874] = {.lex_state = 0, .external_lex_state = 414},
  [19875] = {.lex_state = 0, .external_lex_state = 308},
  [19876] = {.lex_state = 0, .external_lex_state = 308},
  [19877] = {.lex_state = 0, .external_lex_state = 308},
  [19878] = {.lex_state = 0, .external_lex_state = 308},
  [19879] = {.lex_state = 0, .external_lex_state = 308},
  [19880] = {.lex_state = 0, .external_lex_state = 308},
  [19881] = {.lex_state = 47, .external_lex_state = 308},
  [19882] = {.lex_state = 0, .external_lex_state = 308},
  [19883] = {.lex_state = 0, .external_lex_state = 308},
  [19884] = {.lex_state = 0, .external_lex_state = 308},
  [19885] = {.lex_state = 0, .external_lex_state = 308},
  [19886] = {.lex_state = 0, .external_lex_state = 308},
  [19887] = {.lex_state = 0, .external_lex_state = 308},
  [19888] = {.lex_state = 0, .external_lex_state = 444},
  [19889] = {.lex_state = 0, .external_lex_state = 308},
  [19890] = {.lex_state = 0, .external_lex_state = 308},
  [19891] = {.lex_state = 0, .external_lex_state = 308},
  [19892] = {.lex_state = 0, .external_lex_state = 414},
  [19893] = {.lex_state = 0, .external_lex_state = 444},
  [19894] = {.lex_state = 0, .external_lex_state = 308},
  [19895] = {.lex_state = 0, .external_lex_state = 308},
  [19896] = {.lex_state = 0, .external_lex_state = 308},
  [19897] = {.lex_state = 0, .external_lex_state = 308},
  [19898] = {.lex_state = 0, .external_lex_state = 308},
  [19899] = {.lex_state = 0, .external_lex_state = 444},
  [19900] = {.lex_state = 0, .external_lex_state = 308},
  [19901] = {.lex_state = 0, .external_lex_state = 308},
  [19902] = {.lex_state = 0, .external_lex_state = 308},
  [19903] = {.lex_state = 0, .external_lex_state = 308},
  [19904] = {.lex_state = 0, .external_lex_state = 308},
  [19905] = {.lex_state = 0, .external_lex_state = 308},
  [19906] = {.lex_state = 0, .external_lex_state = 308},
  [19907] = {.lex_state = 0, .external_lex_state = 444},
  [19908] = {.lex_state = 0, .external_lex_state = 308},
  [19909] = {.lex_state = 0, .external_lex_state = 414},
  [19910] = {.lex_state = 0, .external_lex_state = 308},
  [19911] = {.lex_state = 0, .external_lex_state = 308},
  [19912] = {.lex_state = 0, .external_lex_state = 308},
  [19913] = {.lex_state = 0, .external_lex_state = 308},
  [19914] = {.lex_state = 0, .external_lex_state = 308},
  [19915] = {.lex_state = 0, .external_lex_state = 308},
  [19916] = {.lex_state = 0, .external_lex_state = 308},
  [19917] = {.lex_state = 0, .external_lex_state = 308},
  [19918] = {.lex_state = 0, .external_lex_state = 355},
  [19919] = {.lex_state = 0, .external_lex_state = 308},
  [19920] = {.lex_state = 0, .external_lex_state = 444},
  [19921] = {.lex_state = 0, .external_lex_state = 308},
  [19922] = {.lex_state = 0, .external_lex_state = 308},
  [19923] = {.lex_state = 0, .external_lex_state = 308},
  [19924] = {.lex_state = 0, .external_lex_state = 308},
  [19925] = {.lex_state = 0, .external_lex_state = 308},
  [19926] = {.lex_state = 0, .external_lex_state = 414},
  [19927] = {.lex_state = 0, .external_lex_state = 308},
  [19928] = {.lex_state = 0, .external_lex_state = 308},
  [19929] = {.lex_state = 0, .external_lex_state = 308},
  [19930] = {.lex_state = 0, .external_lex_state = 308},
  [19931] = {.lex_state = 0, .external_lex_state = 444},
  [19932] = {.lex_state = 0, .external_lex_state = 444},
  [19933] = {.lex_state = 0, .external_lex_state = 308},
  [19934] = {.lex_state = 47, .external_lex_state = 308},
  [19935] = {.lex_state = 0, .external_lex_state = 308},
  [19936] = {.lex_state = 0, .external_lex_state = 308},
  [19937] = {.lex_state = 0, .external_lex_state = 308},
  [19938] = {.lex_state = 0, .external_lex_state = 308},
  [19939] = {.lex_state = 0, .external_lex_state = 308},
  [19940] = {.lex_state = 0, .external_lex_state = 308},
  [19941] = {.lex_state = 0, .external_lex_state = 308},
  [19942] = {.lex_state = 0, .external_lex_state = 308},
  [19943] = {.lex_state = 0, .external_lex_state = 414},
  [19944] = {.lex_state = 0, .external_lex_state = 444},
  [19945] = {.lex_state = 0, .external_lex_state = 308},
  [19946] = {.lex_state = 0, .external_lex_state = 444},
  [19947] = {.lex_state = 0, .external_lex_state = 308},
  [19948] = {.lex_state = 47, .external_lex_state = 308},
  [19949] = {.lex_state = 0, .external_lex_state = 308},
  [19950] = {.lex_state = 0, .external_lex_state = 308},
  [19951] = {.lex_state = 0, .external_lex_state = 308},
  [19952] = {.lex_state = 0, .external_lex_state = 444},
  [19953] = {.lex_state = 0, .external_lex_state = 308},
  [19954] = {.lex_state = 0, .external_lex_state = 308},
  [19955] = {.lex_state = 47, .external_lex_state = 308},
  [19956] = {.lex_state = 0, .external_lex_state = 308},
  [19957] = {.lex_state = 0, .external_lex_state = 308},
  [19958] = {.lex_state = 0, .external_lex_state = 308},
  [19959] = {.lex_state = 0, .external_lex_state = 308},
  [19960] = {.lex_state = 0, .external_lex_state = 414},
  [19961] = {.lex_state = 0, .external_lex_state = 308},
  [19962] = {.lex_state = 47, .external_lex_state = 308},
  [19963] = {.lex_state = 0, .external_lex_state = 308},
  [19964] = {.lex_state = 0, .external_lex_state = 308},
  [19965] = {.lex_state = 0, .external_lex_state = 308},
  [19966] = {.lex_state = 0, .external_lex_state = 444},
  [19967] = {.lex_state = 0, .external_lex_state = 308},
  [19968] = {.lex_state = 0, .external_lex_state = 308},
  [19969] = {.lex_state = 0, .external_lex_state = 308},
  [19970] = {.lex_state = 0, .external_lex_state = 308},
  [19971] = {.lex_state = 0, .external_lex_state = 444},
  [19972] = {.lex_state = 0, .external_lex_state = 308},
  [19973] = {.lex_state = 0, .external_lex_state = 308},
  [19974] = {.lex_state = 0, .external_lex_state = 308},
  [19975] = {.lex_state = 0, .external_lex_state = 308},
  [19976] = {.lex_state = 47, .external_lex_state = 443},
  [19977] = {.lex_state = 0, .external_lex_state = 414},
  [19978] = {.lex_state = 0, .external_lex_state = 444},
  [19979] = {.lex_state = 0, .external_lex_state = 308},
  [19980] = {.lex_state = 0, .external_lex_state = 308},
  [19981] = {.lex_state = 0, .external_lex_state = 308},
  [19982] = {.lex_state = 0, .external_lex_state = 308},
  [19983] = {.lex_state = 0, .external_lex_state = 308},
  [19984] = {.lex_state = 0, .external_lex_state = 308},
  [19985] = {.lex_state = 0, .external_lex_state = 308},
  [19986] = {.lex_state = 0, .external_lex_state = 308},
  [19987] = {.lex_state = 0, .external_lex_state = 308},
  [19988] = {.lex_state = 0, .external_lex_state = 308},
  [19989] = {.lex_state = 0, .external_lex_state = 444},
  [19990] = {.lex_state = 0, .external_lex_state = 308},
  [19991] = {.lex_state = 0, .external_lex_state = 308},
  [19992] = {.lex_state = 0, .external_lex_state = 308},
  [19993] = {.lex_state = 0, .external_lex_state = 308},
  [19994] = {.lex_state = 0, .external_lex_state = 414},
  [19995] = {.lex_state = 0, .external_lex_state = 308},
  [19996] = {.lex_state = 0, .external_lex_state = 308},
  [19997] = {.lex_state = 0, .external_lex_state = 308},
  [19998] = {.lex_state = 0, .external_lex_state = 308},
  [19999] = {.lex_state = 0, .external_lex_state = 308},
  [20000] = {.lex_state = 0, .external_lex_state = 308},
  [20001] = {.lex_state = 0, .external_lex_state = 308},
  [20002] = {.lex_state = 0, .external_lex_state = 308},
  [20003] = {.lex_state = 0, .external_lex_state = 308},
  [20004] = {.lex_state = 0, .external_lex_state = 444},
  [20005] = {.lex_state = 0, .external_lex_state = 308},
  [20006] = {.lex_state = 0, .external_lex_state = 308},
  [20007] = {.lex_state = 0, .external_lex_state = 308},
  [20008] = {.lex_state = 47, .external_lex_state = 308},
  [20009] = {.lex_state = 0, .external_lex_state = 308},
  [20010] = {.lex_state = 0, .external_lex_state = 308},
  [20011] = {.lex_state = 0, .external_lex_state = 414},
  [20012] = {.lex_state = 0, .external_lex_state = 308},
  [20013] = {.lex_state = 0, .external_lex_state = 308},
  [20014] = {.lex_state = 0, .external_lex_state = 444},
  [20015] = {.lex_state = 0, .external_lex_state = 444},
  [20016] = {.lex_state = 0, .external_lex_state = 308},
  [20017] = {.lex_state = 0, .external_lex_state = 308},
  [20018] = {.lex_state = 0, .external_lex_state = 308},
  [20019] = {.lex_state = 0, .external_lex_state = 308},
  [20020] = {.lex_state = 0, .external_lex_state = 308},
  [20021] = {.lex_state = 0, .external_lex_state = 308},
  [20022] = {.lex_state = 0, .external_lex_state = 308},
  [20023] = {.lex_state = 0, .external_lex_state = 308},
  [20024] = {.lex_state = 0, .external_lex_state = 308},
  [20025] = {.lex_state = 0, .external_lex_state = 308},
  [20026] = {.lex_state = 0, .external_lex_state = 308},
  [20027] = {.lex_state = 0, .external_lex_state = 308},
  [20028] = {.lex_state = 0, .external_lex_state = 414},
  [20029] = {.lex_state = 0, .external_lex_state = 308},
  [20030] = {.lex_state = 0, .external_lex_state = 308},
  [20031] = {.lex_state = 0, .external_lex_state = 308},
  [20032] = {.lex_state = 0, .external_lex_state = 308},
  [20033] = {.lex_state = 0, .external_lex_state = 308},
  [20034] = {.lex_state = 0, .external_lex_state = 308},
  [20035] = {.lex_state = 0, .external_lex_state = 308},
  [20036] = {.lex_state = 0, .external_lex_state = 308},
  [20037] = {.lex_state = 0, .external_lex_state = 308},
  [20038] = {.lex_state = 0, .external_lex_state = 308},
  [20039] = {.lex_state = 0, .external_lex_state = 308},
  [20040] = {.lex_state = 0, .external_lex_state = 308},
  [20041] = {.lex_state = 0, .external_lex_state = 444},
  [20042] = {.lex_state = 0, .external_lex_state = 308},
  [20043] = {.lex_state = 0, .external_lex_state = 308},
  [20044] = {.lex_state = 0, .external_lex_state = 308},
  [20045] = {.lex_state = 0, .external_lex_state = 414},
  [20046] = {.lex_state = 0, .external_lex_state = 308},
  [20047] = {.lex_state = 0, .external_lex_state = 308},
  [20048] = {.lex_state = 0, .external_lex_state = 308},
  [20049] = {.lex_state = 0, .external_lex_state = 308},
  [20050] = {.lex_state = 0, .external_lex_state = 308},
  [20051] = {.lex_state = 0, .external_lex_state = 308},
  [20052] = {.lex_state = 0, .external_lex_state = 308},
  [20053] = {.lex_state = 0, .external_lex_state = 308},
  [20054] = {.lex_state = 0, .external_lex_state = 444},
  [20055] = {.lex_state = 0, .external_lex_state = 444},
  [20056] = {.lex_state = 0, .external_lex_state = 444},
  [20057] = {.lex_state = 0, .external_lex_state = 308},
  [20058] = {.lex_state = 47, .external_lex_state = 308},
  [20059] = {.lex_state = 0, .external_lex_state = 308},
  [20060] = {.lex_state = 0, .external_lex_state = 308},
  [20061] = {.lex_state = 0, .external_lex_state = 414},
  [20062] = {.lex_state = 0, .external_lex_state = 308},
  [20063] = {.lex_state = 0, .external_lex_state = 308},
  [20064] = {.lex_state = 0, .external_lex_state = 308},
  [20065] = {.lex_state = 0, .external_lex_state = 308},
  [20066] = {.lex_state = 0, .external_lex_state = 308},
  [20067] = {.lex_state = 0, .external_lex_state = 308},
  [20068] = {.lex_state = 47, .external_lex_state = 308},
  [20069] = {.lex_state = 0, .external_lex_state = 308},
  [20070] = {.lex_state = 0, .external_lex_state = 336},
  [20071] = {.lex_state = 0, .external_lex_state = 308},
  [20072] = {.lex_state = 0, .external_lex_state = 308},
  [20073] = {.lex_state = 0, .external_lex_state = 444},
  [20074] = {.lex_state = 0, .external_lex_state = 308},
  [20075] = {.lex_state = 0, .external_lex_state = 414},
  [20076] = {.lex_state = 47, .external_lex_state = 308},
  [20077] = {.lex_state = 0, .external_lex_state = 355},
  [20078] = {.lex_state = 47, .external_lex_state = 308},
  [20079] = {.lex_state = 0, .external_lex_state = 308},
  [20080] = {.lex_state = 0, .external_lex_state = 308},
  [20081] = {.lex_state = 0, .external_lex_state = 308},
  [20082] = {.lex_state = 0, .external_lex_state = 308},
  [20083] = {.lex_state = 0, .external_lex_state = 308},
  [20084] = {.lex_state = 0, .external_lex_state = 308},
  [20085] = {.lex_state = 47, .external_lex_state = 308},
  [20086] = {.lex_state = 0, .external_lex_state = 308},
  [20087] = {.lex_state = 0, .external_lex_state = 308},
  [20088] = {.lex_state = 0, .external_lex_state = 308},
  [20089] = {.lex_state = 0, .external_lex_state = 414},
  [20090] = {.lex_state = 0, .external_lex_state = 308},
  [20091] = {.lex_state = 0, .external_lex_state = 308},
  [20092] = {.lex_state = 0, .external_lex_state = 308},
  [20093] = {.lex_state = 0, .external_lex_state = 308},
  [20094] = {.lex_state = 0, .external_lex_state = 308},
  [20095] = {.lex_state = 0, .external_lex_state = 308},
  [20096] = {.lex_state = 0, .external_lex_state = 308},
  [20097] = {.lex_state = 0, .external_lex_state = 444},
  [20098] = {.lex_state = 0, .external_lex_state = 308},
  [20099] = {.lex_state = 0, .external_lex_state = 308},
  [20100] = {.lex_state = 0, .external_lex_state = 308},
  [20101] = {.lex_state = 0, .external_lex_state = 308},
  [20102] = {.lex_state = 0, .external_lex_state = 308},
  [20103] = {.lex_state = 0, .external_lex_state = 414},
  [20104] = {.lex_state = 0, .external_lex_state = 308},
  [20105] = {.lex_state = 0, .external_lex_state = 308},
  [20106] = {.lex_state = 0, .external_lex_state = 308},
  [20107] = {.lex_state = 0, .external_lex_state = 308},
  [20108] = {.lex_state = 0, .external_lex_state = 308},
  [20109] = {.lex_state = 0, .external_lex_state = 308},
  [20110] = {.lex_state = 0, .external_lex_state = 308},
  [20111] = {.lex_state = 0, .external_lex_state = 308},
  [20112] = {.lex_state = 0, .external_lex_state = 308},
  [20113] = {.lex_state = 0, .external_lex_state = 308},
  [20114] = {.lex_state = 0, .external_lex_state = 308},
  [20115] = {.lex_state = 0, .external_lex_state = 308},
  [20116] = {.lex_state = 0, .external_lex_state = 308},
  [20117] = {.lex_state = 0, .external_lex_state = 414},
  [20118] = {.lex_state = 0, .external_lex_state = 308},
  [20119] = {.lex_state = 0, .external_lex_state = 308},
  [20120] = {.lex_state = 0, .external_lex_state = 308},
  [20121] = {.lex_state = 0, .external_lex_state = 308},
  [20122] = {.lex_state = 0, .external_lex_state = 444},
  [20123] = {.lex_state = 0, .external_lex_state = 308},
  [20124] = {.lex_state = 0, .external_lex_state = 308},
  [20125] = {.lex_state = 0, .external_lex_state = 308},
  [20126] = {.lex_state = 0, .external_lex_state = 308},
  [20127] = {.lex_state = 0, .external_lex_state = 444},
  [20128] = {.lex_state = 0, .external_lex_state = 308},
  [20129] = {.lex_state = 0, .external_lex_state = 444},
  [20130] = {.lex_state = 0, .external_lex_state = 308},
  [20131] = {.lex_state = 0, .external_lex_state = 414},
  [20132] = {.lex_state = 0, .external_lex_state = 308},
  [20133] = {.lex_state = 0, .external_lex_state = 308},
  [20134] = {.lex_state = 0, .external_lex_state = 308},
  [20135] = {.lex_state = 0, .external_lex_state = 308},
  [20136] = {.lex_state = 0, .external_lex_state = 308},
  [20137] = {.lex_state = 0, .external_lex_state = 308},
  [20138] = {.lex_state = 0, .external_lex_state = 308},
  [20139] = {.lex_state = 0, .external_lex_state = 308},
  [20140] = {.lex_state = 0, .external_lex_state = 308},
  [20141] = {.lex_state = 0, .external_lex_state = 444},
  [20142] = {.lex_state = 0, .external_lex_state = 308},
  [20143] = {.lex_state = 0, .external_lex_state = 308},
  [20144] = {.lex_state = 0, .external_lex_state = 308},
  [20145] = {.lex_state = 0, .external_lex_state = 414},
  [20146] = {.lex_state = 0, .external_lex_state = 308},
  [20147] = {.lex_state = 47, .external_lex_state = 308},
  [20148] = {.lex_state = 0, .external_lex_state = 308},
  [20149] = {.lex_state = 0, .external_lex_state = 308},
  [20150] = {.lex_state = 0, .external_lex_state = 308},
  [20151] = {.lex_state = 0, .external_lex_state = 308},
  [20152] = {.lex_state = 0, .external_lex_state = 308},
  [20153] = {.lex_state = 0, .external_lex_state = 308},
  [20154] = {.lex_state = 0, .external_lex_state = 308},
  [20155] = {.lex_state = 0, .external_lex_state = 308},
  [20156] = {.lex_state = 0, .external_lex_state = 308},
  [20157] = {.lex_state = 0, .external_lex_state = 308},
  [20158] = {.lex_state = 47, .external_lex_state = 308},
  [20159] = {.lex_state = 0, .external_lex_state = 414},
  [20160] = {.lex_state = 0, .external_lex_state = 308},
  [20161] = {.lex_state = 0, .external_lex_state = 444},
  [20162] = {.lex_state = 0, .external_lex_state = 308},
  [20163] = {.lex_state = 0, .external_lex_state = 308},
  [20164] = {.lex_state = 0, .external_lex_state = 308},
  [20165] = {.lex_state = 0, .external_lex_state = 308},
  [20166] = {.lex_state = 0, .external_lex_state = 308},
  [20167] = {.lex_state = 0, .external_lex_state = 308},
  [20168] = {.lex_state = 0, .external_lex_state = 308},
  [20169] = {.lex_state = 47, .external_lex_state = 308},
  [20170] = {.lex_state = 0, .external_lex_state = 308},
  [20171] = {.lex_state = 0, .external_lex_state = 308},
  [20172] = {.lex_state = 0, .external_lex_state = 308},
  [20173] = {.lex_state = 0, .external_lex_state = 414},
  [20174] = {.lex_state = 0, .external_lex_state = 444},
  [20175] = {.lex_state = 47, .external_lex_state = 308},
  [20176] = {.lex_state = 0, .external_lex_state = 308},
  [20177] = {.lex_state = 0, .external_lex_state = 308},
  [20178] = {.lex_state = 0, .external_lex_state = 308},
  [20179] = {.lex_state = 0, .external_lex_state = 308},
  [20180] = {.lex_state = 0, .external_lex_state = 444},
  [20181] = {.lex_state = 0, .external_lex_state = 444},
  [20182] = {.lex_state = 0, .external_lex_state = 308},
  [20183] = {.lex_state = 47, .external_lex_state = 308},
  [20184] = {.lex_state = 0, .external_lex_state = 308},
  [20185] = {.lex_state = 0, .external_lex_state = 308},
  [20186] = {.lex_state = 0, .external_lex_state = 308},
  [20187] = {.lex_state = 0, .external_lex_state = 414},
  [20188] = {.lex_state = 0, .external_lex_state = 308},
  [20189] = {.lex_state = 0, .external_lex_state = 308},
  [20190] = {.lex_state = 0, .external_lex_state = 308},
  [20191] = {.lex_state = 0, .external_lex_state = 308},
  [20192] = {.lex_state = 0, .external_lex_state = 308},
  [20193] = {.lex_state = 0, .external_lex_state = 308},
  [20194] = {.lex_state = 0, .external_lex_state = 308},
  [20195] = {.lex_state = 47, .external_lex_state = 308},
  [20196] = {.lex_state = 0, .external_lex_state = 308},
  [20197] = {.lex_state = 0, .external_lex_state = 336},
  [20198] = {.lex_state = 0, .external_lex_state = 308},
  [20199] = {.lex_state = 0, .external_lex_state = 308},
  [20200] = {.lex_state = 0, .external_lex_state = 308},
  [20201] = {.lex_state = 0, .external_lex_state = 414},
  [20202] = {.lex_state = 0, .external_lex_state = 444},
  [20203] = {.lex_state = 47, .external_lex_state = 308},
  [20204] = {.lex_state = 0, .external_lex_state = 308},
  [20205] = {.lex_state = 0, .external_lex_state = 308},
  [20206] = {.lex_state = 0, .external_lex_state = 308},
  [20207] = {.lex_state = 0, .external_lex_state = 308},
  [20208] = {.lex_state = 0, .external_lex_state = 308},
  [20209] = {.lex_state = 47, .external_lex_state = 308},
  [20210] = {.lex_state = 0, .external_lex_state = 308},
  [20211] = {.lex_state = 0, .external_lex_state = 308},
  [20212] = {.lex_state = 0, .external_lex_state = 308},
  [20213] = {.lex_state = 0, .external_lex_state = 308},
  [20214] = {.lex_state = 0, .external_lex_state = 308},
  [20215] = {.lex_state = 0, .external_lex_state = 414},
  [20216] = {.lex_state = 0, .external_lex_state = 444},
  [20217] = {.lex_state = 0, .external_lex_state = 308},
  [20218] = {.lex_state = 0, .external_lex_state = 308},
  [20219] = {.lex_state = 0, .external_lex_state = 308},
  [20220] = {.lex_state = 47, .external_lex_state = 308},
  [20221] = {.lex_state = 0, .external_lex_state = 308},
  [20222] = {.lex_state = 0, .external_lex_state = 308},
  [20223] = {.lex_state = 0, .external_lex_state = 308},
  [20224] = {.lex_state = 0, .external_lex_state = 308},
  [20225] = {.lex_state = 0, .external_lex_state = 308},
  [20226] = {.lex_state = 0, .external_lex_state = 308},
  [20227] = {.lex_state = 0, .external_lex_state = 308},
  [20228] = {.lex_state = 0, .external_lex_state = 308},
  [20229] = {.lex_state = 0, .external_lex_state = 414},
  [20230] = {.lex_state = 0, .external_lex_state = 308},
  [20231] = {.lex_state = 0, .external_lex_state = 308},
  [20232] = {.lex_state = 0, .external_lex_state = 308},
  [20233] = {.lex_state = 0, .external_lex_state = 308},
  [20234] = {.lex_state = 0, .external_lex_state = 308},
  [20235] = {.lex_state = 0, .external_lex_state = 444},
  [20236] = {.lex_state = 47, .external_lex_state = 308},
  [20237] = {.lex_state = 0, .external_lex_state = 308},
  [20238] = {.lex_state = 0, .external_lex_state = 308},
  [20239] = {.lex_state = 0, .external_lex_state = 308},
  [20240] = {.lex_state = 0, .external_lex_state = 308},
  [20241] = {.lex_state = 0, .external_lex_state = 308},
  [20242] = {.lex_state = 0, .external_lex_state = 308},
  [20243] = {.lex_state = 0, .external_lex_state = 414},
  [20244] = {.lex_state = 0, .external_lex_state = 444},
  [20245] = {.lex_state = 0, .external_lex_state = 308},
  [20246] = {.lex_state = 0, .external_lex_state = 308},
  [20247] = {.lex_state = 0, .external_lex_state = 308},
  [20248] = {.lex_state = 0, .external_lex_state = 308},
  [20249] = {.lex_state = 0, .external_lex_state = 444},
  [20250] = {.lex_state = 0, .external_lex_state = 308},
  [20251] = {.lex_state = 0, .external_lex_state = 308},
  [20252] = {.lex_state = 0, .external_lex_state = 308},
  [20253] = {.lex_state = 0, .external_lex_state = 308},
  [20254] = {.lex_state = 0, .external_lex_state = 308},
  [20255] = {.lex_state = 0, .external_lex_state = 308},
  [20256] = {.lex_state = 0, .external_lex_state = 308},
  [20257] = {.lex_state = 0, .external_lex_state = 414},
  [20258] = {.lex_state = 0, .external_lex_state = 308},
  [20259] = {.lex_state = 0, .external_lex_state = 308},
  [20260] = {.lex_state = 0, .external_lex_state = 444},
  [20261] = {.lex_state = 0, .external_lex_state = 308},
  [20262] = {.lex_state = 0, .external_lex_state = 444},
  [20263] = {.lex_state = 0, .external_lex_state = 308},
  [20264] = {.lex_state = 0, .external_lex_state = 308},
  [20265] = {.lex_state = 0, .external_lex_state = 308},
  [20266] = {.lex_state = 0, .external_lex_state = 308},
  [20267] = {.lex_state = 0, .external_lex_state = 444},
  [20268] = {.lex_state = 0, .external_lex_state = 308},
  [20269] = {.lex_state = 0, .external_lex_state = 308},
  [20270] = {.lex_state = 0, .external_lex_state = 308},
  [20271] = {.lex_state = 0, .external_lex_state = 414},
  [20272] = {.lex_state = 0, .external_lex_state = 308},
  [20273] = {.lex_state = 0, .external_lex_state = 308},
  [20274] = {.lex_state = 0, .external_lex_state = 308},
  [20275] = {.lex_state = 0, .external_lex_state = 308},
  [20276] = {.lex_state = 0, .external_lex_state = 308},
  [20277] = {.lex_state = 0, .external_lex_state = 308},
  [20278] = {.lex_state = 0, .external_lex_state = 444},
  [20279] = {.lex_state = 0, .external_lex_state = 308},
  [20280] = {.lex_state = 0, .external_lex_state = 308},
  [20281] = {.lex_state = 0, .external_lex_state = 308},
  [20282] = {.lex_state = 0, .external_lex_state = 308},
  [20283] = {.lex_state = 0, .external_lex_state = 308},
  [20284] = {.lex_state = 0, .external_lex_state = 308},
  [20285] = {.lex_state = 0, .external_lex_state = 414},
  [20286] = {.lex_state = 0, .external_lex_state = 308},
  [20287] = {.lex_state = 0, .external_lex_state = 308},
  [20288] = {.lex_state = 0, .external_lex_state = 308},
  [20289] = {.lex_state = 0, .external_lex_state = 308},
  [20290] = {.lex_state = 0, .external_lex_state = 308},
  [20291] = {.lex_state = 0, .external_lex_state = 308},
  [20292] = {.lex_state = 0, .external_lex_state = 308},
  [20293] = {.lex_state = 0, .external_lex_state = 308},
  [20294] = {.lex_state = 0, .external_lex_state = 308},
  [20295] = {.lex_state = 0, .external_lex_state = 308},
  [20296] = {.lex_state = 0, .external_lex_state = 308},
  [20297] = {.lex_state = 0, .external_lex_state = 308},
  [20298] = {.lex_state = 0, .external_lex_state = 308},
  [20299] = {.lex_state = 0, .external_lex_state = 414},
  [20300] = {.lex_state = 0, .external_lex_state = 308},
  [20301] = {.lex_state = 0, .external_lex_state = 308},
  [20302] = {.lex_state = 0, .external_lex_state = 308},
  [20303] = {.lex_state = 0, .external_lex_state = 308},
  [20304] = {.lex_state = 0, .external_lex_state = 308},
  [20305] = {.lex_state = 0, .external_lex_state = 308},
  [20306] = {.lex_state = 0, .external_lex_state = 308},
  [20307] = {.lex_state = 0, .external_lex_state = 308},
  [20308] = {.lex_state = 0, .external_lex_state = 308},
  [20309] = {.lex_state = 0, .external_lex_state = 308},
  [20310] = {.lex_state = 0, .external_lex_state = 444},
  [20311] = {.lex_state = 0, .external_lex_state = 308},
  [20312] = {.lex_state = 0, .external_lex_state = 444},
  [20313] = {.lex_state = 0, .external_lex_state = 414},
  [20314] = {.lex_state = 0, .external_lex_state = 308},
  [20315] = {.lex_state = 0, .external_lex_state = 444},
  [20316] = {.lex_state = 0, .external_lex_state = 355},
  [20317] = {.lex_state = 47, .external_lex_state = 308},
  [20318] = {.lex_state = 0, .external_lex_state = 308},
  [20319] = {.lex_state = 0, .external_lex_state = 308},
  [20320] = {.lex_state = 0, .external_lex_state = 308},
  [20321] = {.lex_state = 0, .external_lex_state = 308},
  [20322] = {.lex_state = 47, .external_lex_state = 308},
  [20323] = {.lex_state = 0, .external_lex_state = 308},
  [20324] = {.lex_state = 0, .external_lex_state = 336},
  [20325] = {.lex_state = 0, .external_lex_state = 308},
  [20326] = {.lex_state = 0, .external_lex_state = 308},
  [20327] = {.lex_state = 0, .external_lex_state = 414},
  [20328] = {.lex_state = 0, .external_lex_state = 308},
  [20329] = {.lex_state = 0, .external_lex_state = 308},
  [20330] = {.lex_state = 0, .external_lex_state = 308},
  [20331] = {.lex_state = 0, .external_lex_state = 308},
  [20332] = {.lex_state = 0, .external_lex_state = 308},
  [20333] = {.lex_state = 0, .external_lex_state = 308},
  [20334] = {.lex_state = 0, .external_lex_state = 308},
  [20335] = {.lex_state = 0, .external_lex_state = 308},
  [20336] = {.lex_state = 0, .external_lex_state = 308},
  [20337] = {.lex_state = 0, .external_lex_state = 308},
  [20338] = {.lex_state = 0, .external_lex_state = 308},
  [20339] = {.lex_state = 0, .external_lex_state = 308},
  [20340] = {.lex_state = 0, .external_lex_state = 308},
  [20341] = {.lex_state = 0, .external_lex_state = 414},
  [20342] = {.lex_state = 0, .external_lex_state = 308},
  [20343] = {.lex_state = 0, .external_lex_state = 308},
  [20344] = {.lex_state = 0, .external_lex_state = 308},
  [20345] = {.lex_state = 0, .external_lex_state = 444},
  [20346] = {.lex_state = 0, .external_lex_state = 308},
  [20347] = {.lex_state = 0, .external_lex_state = 308},
  [20348] = {.lex_state = 0, .external_lex_state = 308},
  [20349] = {.lex_state = 0, .external_lex_state = 308},
  [20350] = {.lex_state = 0, .external_lex_state = 308},
  [20351] = {.lex_state = 0, .external_lex_state = 308},
  [20352] = {.lex_state = 0, .external_lex_state = 308},
  [20353] = {.lex_state = 0, .external_lex_state = 444},
  [20354] = {.lex_state = 0, .external_lex_state = 308},
  [20355] = {.lex_state = 0, .external_lex_state = 414},
  [20356] = {.lex_state = 0, .external_lex_state = 308},
  [20357] = {.lex_state = 0, .external_lex_state = 308},
  [20358] = {.lex_state = 0, .external_lex_state = 308},
  [20359] = {.lex_state = 0, .external_lex_state = 308},
  [20360] = {.lex_state = 0, .external_lex_state = 308},
  [20361] = {.lex_state = 0, .external_lex_state = 444},
  [20362] = {.lex_state = 0, .external_lex_state = 308},
  [20363] = {.lex_state = 0, .external_lex_state = 444},
  [20364] = {.lex_state = 0, .external_lex_state = 308},
  [20365] = {.lex_state = 47, .external_lex_state = 308},
  [20366] = {.lex_state = 0, .external_lex_state = 308},
  [20367] = {.lex_state = 0, .external_lex_state = 308},
  [20368] = {.lex_state = 0, .external_lex_state = 414},
  [20369] = {.lex_state = 0, .external_lex_state = 308},
  [20370] = {.lex_state = 0, .external_lex_state = 308},
  [20371] = {.lex_state = 0, .external_lex_state = 308},
  [20372] = {.lex_state = 0, .external_lex_state = 308},
  [20373] = {.lex_state = 0, .external_lex_state = 308},
  [20374] = {.lex_state = 0, .external_lex_state = 308},
  [20375] = {.lex_state = 0, .external_lex_state = 308},
  [20376] = {.lex_state = 0, .external_lex_state = 308},
  [20377] = {.lex_state = 0, .external_lex_state = 444},
  [20378] = {.lex_state = 0, .external_lex_state = 308},
  [20379] = {.lex_state = 0, .external_lex_state = 355},
  [20380] = {.lex_state = 0, .external_lex_state = 414},
  [20381] = {.lex_state = 0, .external_lex_state = 308},
  [20382] = {.lex_state = 0, .external_lex_state = 308},
  [20383] = {.lex_state = 0, .external_lex_state = 444},
  [20384] = {.lex_state = 0, .external_lex_state = 414},
  [20385] = {.lex_state = 0, .external_lex_state = 308},
  [20386] = {.lex_state = 0, .external_lex_state = 308},
  [20387] = {.lex_state = 0, .external_lex_state = 308},
  [20388] = {.lex_state = 0, .external_lex_state = 414},
  [20389] = {.lex_state = 0, .external_lex_state = 308},
  [20390] = {.lex_state = 0, .external_lex_state = 308},
  [20391] = {.lex_state = 50, .external_lex_state = 308},
  [20392] = {.lex_state = 0, .external_lex_state = 414},
  [20393] = {.lex_state = 0, .external_lex_state = 308},
  [20394] = {.lex_state = 0, .external_lex_state = 308},
  [20395] = {.lex_state = 0, .external_lex_state = 308},
  [20396] = {.lex_state = 0, .external_lex_state = 414},
  [20397] = {.lex_state = 0, .external_lex_state = 414},
  [20398] = {.lex_state = 47, .external_lex_state = 308},
  [20399] = {.lex_state = 0, .external_lex_state = 308},
  [20400] = {.lex_state = 0, .external_lex_state = 414},
  [20401] = {.lex_state = 0, .external_lex_state = 308},
  [20402] = {.lex_state = 0, .external_lex_state = 308},
  [20403] = {.lex_state = 0, .external_lex_state = 308},
  [20404] = {.lex_state = 0, .external_lex_state = 414},
  [20405] = {.lex_state = 0, .external_lex_state = 308},
  [20406] = {.lex_state = 0, .external_lex_state = 308},
  [20407] = {.lex_state = 0, .external_lex_state = 308},
  [20408] = {.lex_state = 0, .external_lex_state = 414},
  [20409] = {.lex_state = 0, .external_lex_state = 308},
  [20410] = {.lex_state = 0, .external_lex_state = 308},
  [20411] = {.lex_state = 47, .external_lex_state = 308},
  [20412] = {.lex_state = 0, .external_lex_state = 414},
  [20413] = {.lex_state = 0, .external_lex_state = 308},
  [20414] = {.lex_state = 0, .external_lex_state = 308},
  [20415] = {.lex_state = 0, .external_lex_state = 308},
  [20416] = {.lex_state = 0, .external_lex_state = 414},
  [20417] = {.lex_state = 0, .external_lex_state = 308},
  [20418] = {.lex_state = 0, .external_lex_state = 308},
  [20419] = {.lex_state = 0, .external_lex_state = 308},
  [20420] = {.lex_state = 0, .external_lex_state = 414},
  [20421] = {.lex_state = 0, .external_lex_state = 308},
  [20422] = {.lex_state = 0, .external_lex_state = 308},
  [20423] = {.lex_state = 0, .external_lex_state = 308},
  [20424] = {.lex_state = 0, .external_lex_state = 414},
  [20425] = {.lex_state = 0, .external_lex_state = 308},
  [20426] = {.lex_state = 0, .external_lex_state = 308},
  [20427] = {.lex_state = 0, .external_lex_state = 308},
  [20428] = {.lex_state = 0, .external_lex_state = 414},
  [20429] = {.lex_state = 0, .external_lex_state = 308},
  [20430] = {.lex_state = 0, .external_lex_state = 308},
  [20431] = {.lex_state = 47, .external_lex_state = 443},
  [20432] = {.lex_state = 0, .external_lex_state = 414},
  [20433] = {.lex_state = 0, .external_lex_state = 308},
  [20434] = {.lex_state = 0, .external_lex_state = 308},
  [20435] = {.lex_state = 0, .external_lex_state = 308},
  [20436] = {.lex_state = 0, .external_lex_state = 414},
  [20437] = {.lex_state = 0, .external_lex_state = 308},
  [20438] = {.lex_state = 0, .external_lex_state = 308},
  [20439] = {.lex_state = 0, .external_lex_state = 308},
  [20440] = {.lex_state = 0, .external_lex_state = 414},
  [20441] = {.lex_state = 0, .external_lex_state = 308},
  [20442] = {.lex_state = 0, .external_lex_state = 308},
  [20443] = {.lex_state = 0, .external_lex_state = 308},
  [20444] = {.lex_state = 0, .external_lex_state = 414},
  [20445] = {.lex_state = 0, .external_lex_state = 308},
  [20446] = {.lex_state = 0, .external_lex_state = 444},
  [20447] = {.lex_state = 0, .external_lex_state = 308},
  [20448] = {.lex_state = 0, .external_lex_state = 414},
  [20449] = {.lex_state = 0, .external_lex_state = 308},
  [20450] = {.lex_state = 0, .external_lex_state = 308},
  [20451] = {.lex_state = 0, .external_lex_state = 308},
  [20452] = {.lex_state = 0, .external_lex_state = 414},
  [20453] = {.lex_state = 0, .external_lex_state = 308},
  [20454] = {.lex_state = 0, .external_lex_state = 308},
  [20455] = {.lex_state = 0, .external_lex_state = 308},
  [20456] = {.lex_state = 0, .external_lex_state = 414},
  [20457] = {.lex_state = 0, .external_lex_state = 444},
  [20458] = {.lex_state = 0, .external_lex_state = 308},
  [20459] = {.lex_state = 0, .external_lex_state = 308},
  [20460] = {.lex_state = 0, .external_lex_state = 414},
  [20461] = {.lex_state = 0, .external_lex_state = 444},
  [20462] = {.lex_state = 0, .external_lex_state = 444},
  [20463] = {.lex_state = 0, .external_lex_state = 308},
  [20464] = {.lex_state = 0, .external_lex_state = 414},
  [20465] = {.lex_state = 0, .external_lex_state = 308},
  [20466] = {.lex_state = 0, .external_lex_state = 308},
  [20467] = {.lex_state = 0, .external_lex_state = 308},
  [20468] = {.lex_state = 0, .external_lex_state = 414},
  [20469] = {.lex_state = 0, .external_lex_state = 308},
  [20470] = {.lex_state = 0, .external_lex_state = 444},
  [20471] = {.lex_state = 0, .external_lex_state = 308},
  [20472] = {.lex_state = 0, .external_lex_state = 414},
  [20473] = {.lex_state = 0, .external_lex_state = 444},
  [20474] = {.lex_state = 0, .external_lex_state = 308},
  [20475] = {.lex_state = 0, .external_lex_state = 308},
  [20476] = {.lex_state = 0, .external_lex_state = 414},
  [20477] = {.lex_state = 0, .external_lex_state = 308},
  [20478] = {.lex_state = 0, .external_lex_state = 308},
  [20479] = {.lex_state = 0, .external_lex_state = 308},
  [20480] = {.lex_state = 0, .external_lex_state = 414},
  [20481] = {.lex_state = 0, .external_lex_state = 308},
  [20482] = {.lex_state = 0, .external_lex_state = 308},
  [20483] = {.lex_state = 0, .external_lex_state = 308},
  [20484] = {.lex_state = 0, .external_lex_state = 414},
  [20485] = {.lex_state = 0, .external_lex_state = 308},
  [20486] = {.lex_state = 0, .external_lex_state = 308},
  [20487] = {.lex_state = 0, .external_lex_state = 308},
  [20488] = {.lex_state = 0, .external_lex_state = 414},
  [20489] = {.lex_state = 0, .external_lex_state = 308},
  [20490] = {.lex_state = 0, .external_lex_state = 308},
  [20491] = {.lex_state = 0, .external_lex_state = 308},
  [20492] = {.lex_state = 0, .external_lex_state = 414},
  [20493] = {.lex_state = 0, .external_lex_state = 308},
  [20494] = {.lex_state = 0, .external_lex_state = 308},
  [20495] = {.lex_state = 0, .external_lex_state = 308},
  [20496] = {.lex_state = 0, .external_lex_state = 414},
  [20497] = {.lex_state = 0, .external_lex_state = 308},
  [20498] = {.lex_state = 0, .external_lex_state = 308},
  [20499] = {.lex_state = 0, .external_lex_state = 308},
  [20500] = {.lex_state = 0, .external_lex_state = 414},
  [20501] = {.lex_state = 0, .external_lex_state = 308},
  [20502] = {.lex_state = 0, .external_lex_state = 308},
  [20503] = {.lex_state = 0, .external_lex_state = 308},
  [20504] = {.lex_state = 0, .external_lex_state = 414},
  [20505] = {.lex_state = 0, .external_lex_state = 308},
  [20506] = {.lex_state = 0, .external_lex_state = 308},
  [20507] = {.lex_state = 0, .external_lex_state = 444},
  [20508] = {.lex_state = 0, .external_lex_state = 414},
  [20509] = {.lex_state = 0, .external_lex_state = 308},
  [20510] = {.lex_state = 0, .external_lex_state = 444},
  [20511] = {.lex_state = 0, .external_lex_state = 308},
  [20512] = {.lex_state = 0, .external_lex_state = 414},
  [20513] = {.lex_state = 0, .external_lex_state = 444},
  [20514] = {.lex_state = 0, .external_lex_state = 444},
  [20515] = {.lex_state = 0, .external_lex_state = 308},
  [20516] = {.lex_state = 0, .external_lex_state = 414},
  [20517] = {.lex_state = 0, .external_lex_state = 308},
  [20518] = {.lex_state = 0, .external_lex_state = 308},
  [20519] = {.lex_state = 0, .external_lex_state = 444},
  [20520] = {.lex_state = 0, .external_lex_state = 414},
  [20521] = {.lex_state = 47, .external_lex_state = 308},
  [20522] = {.lex_state = 0, .external_lex_state = 308},
  [20523] = {.lex_state = 0, .external_lex_state = 308},
  [20524] = {.lex_state = 0, .external_lex_state = 414},
  [20525] = {.lex_state = 0, .external_lex_state = 308},
  [20526] = {.lex_state = 0, .external_lex_state = 308},
  [20527] = {.lex_state = 0, .external_lex_state = 308},
  [20528] = {.lex_state = 0, .external_lex_state = 414},
  [20529] = {.lex_state = 0, .external_lex_state = 308},
  [20530] = {.lex_state = 0, .external_lex_state = 308},
  [20531] = {.lex_state = 0, .external_lex_state = 308},
  [20532] = {.lex_state = 0, .external_lex_state = 414},
  [20533] = {.lex_state = 0, .external_lex_state = 308},
  [20534] = {.lex_state = 47, .external_lex_state = 308},
  [20535] = {.lex_state = 0, .external_lex_state = 308},
  [20536] = {.lex_state = 0, .external_lex_state = 414},
  [20537] = {.lex_state = 0, .external_lex_state = 308},
  [20538] = {.lex_state = 0, .external_lex_state = 308},
  [20539] = {.lex_state = 0, .external_lex_state = 308},
  [20540] = {.lex_state = 0, .external_lex_state = 414},
  [20541] = {.lex_state = 0, .external_lex_state = 308},
  [20542] = {.lex_state = 0, .external_lex_state = 336},
  [20543] = {.lex_state = 0, .external_lex_state = 308},
  [20544] = {.lex_state = 0, .external_lex_state = 414},
  [20545] = {.lex_state = 0, .external_lex_state = 308},
  [20546] = {.lex_state = 0, .external_lex_state = 308},
  [20547] = {.lex_state = 0, .external_lex_state = 444},
  [20548] = {.lex_state = 0, .external_lex_state = 414},
  [20549] = {.lex_state = 0, .external_lex_state = 308},
  [20550] = {.lex_state = 0, .external_lex_state = 308},
  [20551] = {.lex_state = 0, .external_lex_state = 308},
  [20552] = {.lex_state = 0, .external_lex_state = 414},
  [20553] = {.lex_state = 0, .external_lex_state = 308},
  [20554] = {.lex_state = 0, .external_lex_state = 308},
  [20555] = {.lex_state = 0, .external_lex_state = 308},
  [20556] = {.lex_state = 0, .external_lex_state = 414},
  [20557] = {.lex_state = 0, .external_lex_state = 308},
  [20558] = {.lex_state = 0, .external_lex_state = 308},
  [20559] = {.lex_state = 0, .external_lex_state = 308},
  [20560] = {.lex_state = 0, .external_lex_state = 414},
  [20561] = {.lex_state = 0, .external_lex_state = 308},
  [20562] = {.lex_state = 0, .external_lex_state = 308},
  [20563] = {.lex_state = 0, .external_lex_state = 308},
  [20564] = {.lex_state = 0, .external_lex_state = 414},
  [20565] = {.lex_state = 0, .external_lex_state = 308},
  [20566] = {.lex_state = 0, .external_lex_state = 308},
  [20567] = {.lex_state = 0, .external_lex_state = 308},
  [20568] = {.lex_state = 0, .external_lex_state = 414},
  [20569] = {.lex_state = 0, .external_lex_state = 308},
  [20570] = {.lex_state = 0, .external_lex_state = 308},
  [20571] = {.lex_state = 0, .external_lex_state = 308},
  [20572] = {.lex_state = 0, .external_lex_state = 414},
  [20573] = {.lex_state = 0, .external_lex_state = 308},
  [20574] = {.lex_state = 0, .external_lex_state = 308},
  [20575] = {.lex_state = 0, .external_lex_state = 308},
  [20576] = {.lex_state = 0, .external_lex_state = 414},
  [20577] = {.lex_state = 0, .external_lex_state = 308},
  [20578] = {.lex_state = 0, .external_lex_state = 308},
  [20579] = {.lex_state = 0, .external_lex_state = 308},
  [20580] = {.lex_state = 0, .external_lex_state = 414},
  [20581] = {.lex_state = 0, .external_lex_state = 308},
  [20582] = {.lex_state = 0, .external_lex_state = 308},
  [20583] = {.lex_state = 0, .external_lex_state = 308},
  [20584] = {.lex_state = 0, .external_lex_state = 414},
  [20585] = {.lex_state = 0, .external_lex_state = 308},
  [20586] = {.lex_state = 0, .external_lex_state = 308},
  [20587] = {.lex_state = 0, .external_lex_state = 444},
  [20588] = {.lex_state = 0, .external_lex_state = 414},
  [20589] = {.lex_state = 0, .external_lex_state = 308},
  [20590] = {.lex_state = 0, .external_lex_state = 308},
  [20591] = {.lex_state = 0, .external_lex_state = 308},
  [20592] = {.lex_state = 0, .external_lex_state = 414},
  [20593] = {.lex_state = 0, .external_lex_state = 308},
  [20594] = {.lex_state = 0, .external_lex_state = 444},
  [20595] = {.lex_state = 0, .external_lex_state = 444},
  [20596] = {.lex_state = 0, .external_lex_state = 414},
  [20597] = {.lex_state = 0, .external_lex_state = 444},
  [20598] = {.lex_state = 0, .external_lex_state = 308},
  [20599] = {.lex_state = 0, .external_lex_state = 308},
  [20600] = {.lex_state = 0, .external_lex_state = 414},
  [20601] = {.lex_state = 0, .external_lex_state = 308},
  [20602] = {.lex_state = 0, .external_lex_state = 308},
  [20603] = {.lex_state = 0, .external_lex_state = 308},
  [20604] = {.lex_state = 0, .external_lex_state = 414},
  [20605] = {.lex_state = 47, .external_lex_state = 308},
  [20606] = {.lex_state = 0, .external_lex_state = 308},
  [20607] = {.lex_state = 0, .external_lex_state = 444},
  [20608] = {.lex_state = 0, .external_lex_state = 414},
  [20609] = {.lex_state = 0, .external_lex_state = 308},
  [20610] = {.lex_state = 0, .external_lex_state = 308},
  [20611] = {.lex_state = 0, .external_lex_state = 444},
  [20612] = {.lex_state = 0, .external_lex_state = 414},
  [20613] = {.lex_state = 0, .external_lex_state = 308},
  [20614] = {.lex_state = 0, .external_lex_state = 308},
  [20615] = {.lex_state = 0, .external_lex_state = 308},
  [20616] = {.lex_state = 0, .external_lex_state = 414},
  [20617] = {.lex_state = 0, .external_lex_state = 308},
  [20618] = {.lex_state = 0, .external_lex_state = 308},
  [20619] = {.lex_state = 0, .external_lex_state = 444},
  [20620] = {.lex_state = 0, .external_lex_state = 414},
  [20621] = {.lex_state = 0, .external_lex_state = 308},
  [20622] = {.lex_state = 0, .external_lex_state = 308},
  [20623] = {.lex_state = 0, .external_lex_state = 444},
  [20624] = {.lex_state = 0, .external_lex_state = 414},
  [20625] = {.lex_state = 0, .external_lex_state = 308},
  [20626] = {.lex_state = 0, .external_lex_state = 308},
  [20627] = {.lex_state = 0, .external_lex_state = 308},
  [20628] = {.lex_state = 0, .external_lex_state = 414},
  [20629] = {.lex_state = 0, .external_lex_state = 308},
  [20630] = {.lex_state = 0, .external_lex_state = 308},
  [20631] = {.lex_state = 0, .external_lex_state = 308},
  [20632] = {.lex_state = 0, .external_lex_state = 414},
  [20633] = {.lex_state = 0, .external_lex_state = 308},
  [20634] = {.lex_state = 0, .external_lex_state = 414},
  [20635] = {.lex_state = 0, .external_lex_state = 308},
  [20636] = {.lex_state = 0, .external_lex_state = 414},
  [20637] = {.lex_state = 0, .external_lex_state = 308},
  [20638] = {.lex_state = 0, .external_lex_state = 444},
  [20639] = {.lex_state = 0, .external_lex_state = 308},
  [20640] = {.lex_state = 0, .external_lex_state = 414},
  [20641] = {.lex_state = 0, .external_lex_state = 308},
  [20642] = {.lex_state = 0, .external_lex_state = 308},
  [20643] = {.lex_state = 0, .external_lex_state = 308},
  [20644] = {.lex_state = 0, .external_lex_state = 414},
  [20645] = {.lex_state = 47, .external_lex_state = 308},
  [20646] = {.lex_state = 0, .external_lex_state = 308},
  [20647] = {.lex_state = 0, .external_lex_state = 308},
  [20648] = {.lex_state = 0, .external_lex_state = 414},
  [20649] = {.lex_state = 0, .external_lex_state = 308},
  [20650] = {.lex_state = 0, .external_lex_state = 308},
  [20651] = {.lex_state = 0, .external_lex_state = 308},
  [20652] = {.lex_state = 0, .external_lex_state = 414},
  [20653] = {.lex_state = 0, .external_lex_state = 308},
  [20654] = {.lex_state = 0, .external_lex_state = 308},
  [20655] = {.lex_state = 0, .external_lex_state = 414},
  [20656] = {.lex_state = 0, .external_lex_state = 308},
  [20657] = {.lex_state = 0, .external_lex_state = 308},
  [20658] = {.lex_state = 0, .external_lex_state = 414},
  [20659] = {.lex_state = 0, .external_lex_state = 308},
  [20660] = {.lex_state = 0, .external_lex_state = 308},
  [20661] = {.lex_state = 0, .external_lex_state = 414},
  [20662] = {.lex_state = 0, .external_lex_state = 308},
  [20663] = {.lex_state = 0, .external_lex_state = 308},
  [20664] = {.lex_state = 0, .external_lex_state = 414},
  [20665] = {.lex_state = 0, .external_lex_state = 308},
  [20666] = {.lex_state = 0, .external_lex_state = 444},
  [20667] = {.lex_state = 0, .external_lex_state = 414},
  [20668] = {.lex_state = 0, .external_lex_state = 308},
  [20669] = {.lex_state = 0, .external_lex_state = 308},
  [20670] = {.lex_state = 0, .external_lex_state = 414},
  [20671] = {.lex_state = 0, .external_lex_state = 308},
  [20672] = {.lex_state = 0, .external_lex_state = 308},
  [20673] = {.lex_state = 0, .external_lex_state = 414},
  [20674] = {.lex_state = 0, .external_lex_state = 308},
  [20675] = {.lex_state = 0, .external_lex_state = 308},
  [20676] = {.lex_state = 0, .external_lex_state = 414},
  [20677] = {.lex_state = 0, .external_lex_state = 308},
  [20678] = {.lex_state = 0, .external_lex_state = 308},
  [20679] = {.lex_state = 0, .external_lex_state = 414},
  [20680] = {.lex_state = 0, .external_lex_state = 308},
  [20681] = {.lex_state = 0, .external_lex_state = 308},
  [20682] = {.lex_state = 0, .external_lex_state = 414},
  [20683] = {.lex_state = 0, .external_lex_state = 308},
  [20684] = {.lex_state = 0, .external_lex_state = 308},
  [20685] = {.lex_state = 0, .external_lex_state = 414},
  [20686] = {.lex_state = 0, .external_lex_state = 308},
  [20687] = {.lex_state = 0, .external_lex_state = 308},
  [20688] = {.lex_state = 0, .external_lex_state = 414},
  [20689] = {.lex_state = 0, .external_lex_state = 308},
  [20690] = {.lex_state = 0, .external_lex_state = 308},
  [20691] = {.lex_state = 0, .external_lex_state = 414},
  [20692] = {.lex_state = 0, .external_lex_state = 308},
  [20693] = {.lex_state = 0, .external_lex_state = 308},
  [20694] = {.lex_state = 0, .external_lex_state = 414},
  [20695] = {.lex_state = 0, .external_lex_state = 308},
  [20696] = {.lex_state = 0, .external_lex_state = 308},
  [20697] = {.lex_state = 0, .external_lex_state = 414},
  [20698] = {.lex_state = 0, .external_lex_state = 308},
  [20699] = {.lex_state = 47, .external_lex_state = 308},
  [20700] = {.lex_state = 0, .external_lex_state = 414},
  [20701] = {.lex_state = 0, .external_lex_state = 308},
  [20702] = {.lex_state = 0, .external_lex_state = 308},
  [20703] = {.lex_state = 0, .external_lex_state = 414},
  [20704] = {.lex_state = 0, .external_lex_state = 308},
  [20705] = {.lex_state = 0, .external_lex_state = 308},
  [20706] = {.lex_state = 0, .external_lex_state = 414},
  [20707] = {.lex_state = 0, .external_lex_state = 308},
  [20708] = {.lex_state = 0, .external_lex_state = 308},
  [20709] = {.lex_state = 0, .external_lex_state = 414},
  [20710] = {.lex_state = 0, .external_lex_state = 308},
  [20711] = {.lex_state = 47, .external_lex_state = 443},
  [20712] = {.lex_state = 0, .external_lex_state = 414},
  [20713] = {.lex_state = 0, .external_lex_state = 308},
  [20714] = {.lex_state = 0, .external_lex_state = 308},
  [20715] = {.lex_state = 0, .external_lex_state = 414},
  [20716] = {.lex_state = 0, .external_lex_state = 308},
  [20717] = {.lex_state = 0, .external_lex_state = 308},
  [20718] = {.lex_state = 0, .external_lex_state = 414},
  [20719] = {.lex_state = 0, .external_lex_state = 444},
  [20720] = {.lex_state = 0, .external_lex_state = 308},
  [20721] = {.lex_state = 0, .external_lex_state = 414},
  [20722] = {.lex_state = 0, .external_lex_state = 308},
  [20723] = {.lex_state = 0, .external_lex_state = 308},
  [20724] = {.lex_state = 0, .external_lex_state = 308},
  [20725] = {.lex_state = 0, .external_lex_state = 308},
  [20726] = {.lex_state = 0, .external_lex_state = 308},
  [20727] = {.lex_state = 0, .external_lex_state = 308},
  [20728] = {.lex_state = 0, .external_lex_state = 444},
  [20729] = {.lex_state = 0, .external_lex_state = 444},
  [20730] = {.lex_state = 47, .external_lex_state = 308},
  [20731] = {.lex_state = 47, .external_lex_state = 308},
  [20732] = {.lex_state = 0, .external_lex_state = 444},
  [20733] = {.lex_state = 0, .external_lex_state = 308},
  [20734] = {.lex_state = 0, .external_lex_state = 444},
  [20735] = {.lex_state = 0, .external_lex_state = 308},
  [20736] = {.lex_state = 0, .external_lex_state = 308},
  [20737] = {.lex_state = 0, .external_lex_state = 308},
  [20738] = {.lex_state = 0, .external_lex_state = 308},
  [20739] = {.lex_state = 0, .external_lex_state = 308},
  [20740] = {.lex_state = 0, .external_lex_state = 308},
  [20741] = {.lex_state = 0, .external_lex_state = 308},
  [20742] = {.lex_state = 0, .external_lex_state = 308},
  [20743] = {.lex_state = 0, .external_lex_state = 308},
  [20744] = {.lex_state = 0, .external_lex_state = 308},
  [20745] = {.lex_state = 47, .external_lex_state = 308},
  [20746] = {.lex_state = 0, .external_lex_state = 308},
  [20747] = {.lex_state = 0, .external_lex_state = 308},
  [20748] = {.lex_state = 0, .external_lex_state = 308},
  [20749] = {.lex_state = 0, .external_lex_state = 308},
  [20750] = {.lex_state = 0, .external_lex_state = 308},
  [20751] = {.lex_state = 0, .external_lex_state = 308},
  [20752] = {.lex_state = 0, .external_lex_state = 308},
  [20753] = {.lex_state = 0, .external_lex_state = 308},
  [20754] = {.lex_state = 0, .external_lex_state = 308},
  [20755] = {.lex_state = 0, .external_lex_state = 308},
  [20756] = {.lex_state = 47, .external_lex_state = 308},
  [20757] = {.lex_state = 0, .external_lex_state = 308},
  [20758] = {.lex_state = 0, .external_lex_state = 308},
  [20759] = {.lex_state = 0, .external_lex_state = 308},
  [20760] = {.lex_state = 0, .external_lex_state = 308},
  [20761] = {.lex_state = 0, .external_lex_state = 308},
  [20762] = {.lex_state = 0, .external_lex_state = 308},
  [20763] = {.lex_state = 47, .external_lex_state = 308},
  [20764] = {.lex_state = 0, .external_lex_state = 308},
  [20765] = {.lex_state = 0, .external_lex_state = 308},
  [20766] = {.lex_state = 0, .external_lex_state = 308},
  [20767] = {.lex_state = 0, .external_lex_state = 308},
  [20768] = {.lex_state = 0, .external_lex_state = 308},
  [20769] = {.lex_state = 0, .external_lex_state = 308},
  [20770] = {.lex_state = 47, .external_lex_state = 308},
  [20771] = {.lex_state = 0, .external_lex_state = 444},
  [20772] = {.lex_state = 0, .external_lex_state = 308},
  [20773] = {.lex_state = 0, .external_lex_state = 444},
  [20774] = {.lex_state = 0, .external_lex_state = 308},
  [20775] = {.lex_state = 0, .external_lex_state = 308},
  [20776] = {.lex_state = 0, .external_lex_state = 308},
  [20777] = {.lex_state = 47, .external_lex_state = 308},
  [20778] = {.lex_state = 0, .external_lex_state = 308},
  [20779] = {.lex_state = 0, .external_lex_state = 308},
  [20780] = {.lex_state = 0, .external_lex_state = 308},
  [20781] = {.lex_state = 0, .external_lex_state = 308},
  [20782] = {.lex_state = 0, .external_lex_state = 308},
  [20783] = {.lex_state = 0, .external_lex_state = 308},
  [20784] = {.lex_state = 47, .external_lex_state = 308},
  [20785] = {.lex_state = 0, .external_lex_state = 308},
  [20786] = {.lex_state = 0, .external_lex_state = 308},
  [20787] = {.lex_state = 0, .external_lex_state = 308},
  [20788] = {.lex_state = 0, .external_lex_state = 308},
  [20789] = {.lex_state = 0, .external_lex_state = 308},
  [20790] = {.lex_state = 0, .external_lex_state = 308},
  [20791] = {.lex_state = 47, .external_lex_state = 308},
  [20792] = {.lex_state = 47, .external_lex_state = 308},
  [20793] = {.lex_state = 0, .external_lex_state = 308},
  [20794] = {.lex_state = 0, .external_lex_state = 308},
  [20795] = {.lex_state = 0, .external_lex_state = 308},
  [20796] = {.lex_state = 0, .external_lex_state = 308},
  [20797] = {.lex_state = 47, .external_lex_state = 308},
  [20798] = {.lex_state = 0, .external_lex_state = 444},
  [20799] = {.lex_state = 0, .external_lex_state = 308},
  [20800] = {.lex_state = 0, .external_lex_state = 308},
  [20801] = {.lex_state = 0, .external_lex_state = 308},
  [20802] = {.lex_state = 47, .external_lex_state = 308},
  [20803] = {.lex_state = 47, .external_lex_state = 308},
  [20804] = {.lex_state = 47, .external_lex_state = 308},
  [20805] = {.lex_state = 0, .external_lex_state = 308},
  [20806] = {.lex_state = 0, .external_lex_state = 308},
  [20807] = {.lex_state = 0, .external_lex_state = 308},
  [20808] = {.lex_state = 0, .external_lex_state = 308},
  [20809] = {.lex_state = 47, .external_lex_state = 308},
  [20810] = {.lex_state = 0, .external_lex_state = 308},
  [20811] = {.lex_state = 0, .external_lex_state = 308},
  [20812] = {.lex_state = 0, .external_lex_state = 308},
  [20813] = {.lex_state = 0, .external_lex_state = 308},
  [20814] = {.lex_state = 0, .external_lex_state = 308},
  [20815] = {.lex_state = 47, .external_lex_state = 308},
  [20816] = {.lex_state = 0, .external_lex_state = 444},
  [20817] = {.lex_state = 0, .external_lex_state = 444},
  [20818] = {.lex_state = 0, .external_lex_state = 308},
  [20819] = {.lex_state = 0, .external_lex_state = 308},
  [20820] = {.lex_state = 0, .external_lex_state = 444},
  [20821] = {.lex_state = 47, .external_lex_state = 308},
  [20822] = {.lex_state = 0, .external_lex_state = 308},
  [20823] = {.lex_state = 0, .external_lex_state = 308},
  [20824] = {.lex_state = 0, .external_lex_state = 308},
  [20825] = {.lex_state = 0, .external_lex_state = 308},
  [20826] = {.lex_state = 0, .external_lex_state = 308},
  [20827] = {.lex_state = 47, .external_lex_state = 308},
  [20828] = {.lex_state = 0, .external_lex_state = 308},
  [20829] = {.lex_state = 47, .external_lex_state = 308},
  [20830] = {.lex_state = 0, .external_lex_state = 308},
  [20831] = {.lex_state = 0, .external_lex_state = 308},
  [20832] = {.lex_state = 0, .external_lex_state = 308},
  [20833] = {.lex_state = 47, .external_lex_state = 308},
  [20834] = {.lex_state = 0, .external_lex_state = 308},
  [20835] = {.lex_state = 0, .external_lex_state = 308},
  [20836] = {.lex_state = 0, .external_lex_state = 308},
  [20837] = {.lex_state = 0, .external_lex_state = 308},
  [20838] = {.lex_state = 0, .external_lex_state = 444},
  [20839] = {.lex_state = 47, .external_lex_state = 308},
  [20840] = {.lex_state = 47, .external_lex_state = 308},
  [20841] = {.lex_state = 0, .external_lex_state = 444},
  [20842] = {.lex_state = 0, .external_lex_state = 308},
  [20843] = {.lex_state = 0, .external_lex_state = 308},
  [20844] = {.lex_state = 0, .external_lex_state = 308},
  [20845] = {.lex_state = 47, .external_lex_state = 308},
  [20846] = {.lex_state = 0, .external_lex_state = 444},
  [20847] = {.lex_state = 0, .external_lex_state = 414},
  [20848] = {.lex_state = 0, .external_lex_state = 308},
  [20849] = {.lex_state = 0, .external_lex_state = 308},
  [20850] = {.lex_state = 47, .external_lex_state = 308},
  [20851] = {.lex_state = 47, .external_lex_state = 308},
  [20852] = {.lex_state = 0, .external_lex_state = 308},
  [20853] = {.lex_state = 0, .external_lex_state = 308},
  [20854] = {.lex_state = 0, .external_lex_state = 308},
  [20855] = {.lex_state = 0, .external_lex_state = 308},
  [20856] = {.lex_state = 47, .external_lex_state = 308},
  [20857] = {.lex_state = 47, .external_lex_state = 308},
  [20858] = {.lex_state = 0, .external_lex_state = 308},
  [20859] = {.lex_state = 47, .external_lex_state = 308},
  [20860] = {.lex_state = 0, .external_lex_state = 308},
  [20861] = {.lex_state = 0, .external_lex_state = 308},
  [20862] = {.lex_state = 0, .external_lex_state = 308},
  [20863] = {.lex_state = 47, .external_lex_state = 308},
  [20864] = {.lex_state = 0, .external_lex_state = 308},
  [20865] = {.lex_state = 0, .external_lex_state = 444},
  [20866] = {.lex_state = 0, .external_lex_state = 444},
  [20867] = {.lex_state = 0, .external_lex_state = 308},
  [20868] = {.lex_state = 0, .external_lex_state = 308},
  [20869] = {.lex_state = 47, .external_lex_state = 308},
  [20870] = {.lex_state = 0, .external_lex_state = 308},
  [20871] = {.lex_state = 0, .external_lex_state = 308},
  [20872] = {.lex_state = 0, .external_lex_state = 308},
  [20873] = {.lex_state = 0, .external_lex_state = 308},
  [20874] = {.lex_state = 0, .external_lex_state = 336},
  [20875] = {.lex_state = 47, .external_lex_state = 308},
  [20876] = {.lex_state = 0, .external_lex_state = 308},
  [20877] = {.lex_state = 0, .external_lex_state = 308},
  [20878] = {.lex_state = 0, .external_lex_state = 336},
  [20879] = {.lex_state = 0, .external_lex_state = 308},
  [20880] = {.lex_state = 0, .external_lex_state = 308},
  [20881] = {.lex_state = 0, .external_lex_state = 308},
  [20882] = {.lex_state = 0, .external_lex_state = 308},
  [20883] = {.lex_state = 0, .external_lex_state = 308},
  [20884] = {.lex_state = 0, .external_lex_state = 308},
  [20885] = {.lex_state = 0, .external_lex_state = 308},
  [20886] = {.lex_state = 0, .external_lex_state = 308},
  [20887] = {.lex_state = 0, .external_lex_state = 308},
  [20888] = {.lex_state = 0, .external_lex_state = 308},
  [20889] = {.lex_state = 0, .external_lex_state = 308},
  [20890] = {.lex_state = 0, .external_lex_state = 308},
  [20891] = {.lex_state = 0, .external_lex_state = 308},
  [20892] = {.lex_state = 0, .external_lex_state = 308},
  [20893] = {.lex_state = 0, .external_lex_state = 308},
  [20894] = {.lex_state = 0, .external_lex_state = 308},
  [20895] = {.lex_state = 0, .external_lex_state = 308},
  [20896] = {.lex_state = 0, .external_lex_state = 308},
  [20897] = {.lex_state = 0, .external_lex_state = 444},
  [20898] = {.lex_state = 0, .external_lex_state = 308},
  [20899] = {.lex_state = 0, .external_lex_state = 308},
  [20900] = {.lex_state = 0, .external_lex_state = 308},
  [20901] = {.lex_state = 0, .external_lex_state = 308},
  [20902] = {.lex_state = 0, .external_lex_state = 308},
  [20903] = {.lex_state = 0, .external_lex_state = 308},
  [20904] = {.lex_state = 0, .external_lex_state = 308},
  [20905] = {.lex_state = 0, .external_lex_state = 308},
  [20906] = {.lex_state = 0, .external_lex_state = 308},
  [20907] = {.lex_state = 0, .external_lex_state = 308},
  [20908] = {.lex_state = 0, .external_lex_state = 308},
  [20909] = {.lex_state = 0, .external_lex_state = 308},
  [20910] = {.lex_state = 0, .external_lex_state = 308},
  [20911] = {.lex_state = 47, .external_lex_state = 308},
  [20912] = {.lex_state = 0, .external_lex_state = 308},
  [20913] = {.lex_state = 0, .external_lex_state = 308},
  [20914] = {.lex_state = 0, .external_lex_state = 308},
  [20915] = {.lex_state = 0, .external_lex_state = 308},
  [20916] = {.lex_state = 0, .external_lex_state = 308},
  [20917] = {.lex_state = 50, .external_lex_state = 308},
  [20918] = {.lex_state = 0, .external_lex_state = 308},
  [20919] = {.lex_state = 0, .external_lex_state = 308},
  [20920] = {.lex_state = 0, .external_lex_state = 308},
  [20921] = {.lex_state = 0, .external_lex_state = 308},
  [20922] = {.lex_state = 0, .external_lex_state = 308},
  [20923] = {.lex_state = 0, .external_lex_state = 308},
  [20924] = {.lex_state = 0, .external_lex_state = 308},
  [20925] = {.lex_state = 0, .external_lex_state = 308},
  [20926] = {.lex_state = 47, .external_lex_state = 308},
  [20927] = {.lex_state = 0, .external_lex_state = 308},
  [20928] = {.lex_state = 0, .external_lex_state = 308},
  [20929] = {.lex_state = 0, .external_lex_state = 308},
  [20930] = {.lex_state = 0, .external_lex_state = 308},
  [20931] = {.lex_state = 0, .external_lex_state = 308},
  [20932] = {.lex_state = 0, .external_lex_state = 444},
  [20933] = {.lex_state = 0, .external_lex_state = 308},
  [20934] = {.lex_state = 0, .external_lex_state = 308},
  [20935] = {.lex_state = 0, .external_lex_state = 308},
  [20936] = {.lex_state = 0, .external_lex_state = 308},
  [20937] = {.lex_state = 0, .external_lex_state = 308},
  [20938] = {.lex_state = 0, .external_lex_state = 308},
  [20939] = {.lex_state = 0, .external_lex_state = 308},
  [20940] = {.lex_state = 0, .external_lex_state = 308},
  [20941] = {.lex_state = 0, .external_lex_state = 308},
  [20942] = {.lex_state = 0, .external_lex_state = 308},
  [20943] = {.lex_state = 0, .external_lex_state = 308},
  [20944] = {.lex_state = 0, .external_lex_state = 308},
  [20945] = {.lex_state = 0, .external_lex_state = 308},
  [20946] = {.lex_state = 0, .external_lex_state = 308},
  [20947] = {.lex_state = 0, .external_lex_state = 308},
  [20948] = {.lex_state = 0, .external_lex_state = 308},
  [20949] = {.lex_state = 0, .external_lex_state = 308},
  [20950] = {.lex_state = 0, .external_lex_state = 308},
  [20951] = {.lex_state = 0, .external_lex_state = 308},
  [20952] = {.lex_state = 0, .external_lex_state = 308},
  [20953] = {.lex_state = 0, .external_lex_state = 444},
  [20954] = {.lex_state = 0, .external_lex_state = 308},
  [20955] = {.lex_state = 0, .external_lex_state = 444},
  [20956] = {.lex_state = 0, .external_lex_state = 308},
  [20957] = {.lex_state = 0, .external_lex_state = 308},
  [20958] = {.lex_state = 0, .external_lex_state = 308},
  [20959] = {.lex_state = 0, .external_lex_state = 444},
  [20960] = {.lex_state = 0, .external_lex_state = 308},
  [20961] = {.lex_state = 0, .external_lex_state = 308},
  [20962] = {.lex_state = 0, .external_lex_state = 308},
  [20963] = {.lex_state = 0, .external_lex_state = 308},
  [20964] = {.lex_state = 0, .external_lex_state = 308},
  [20965] = {.lex_state = 0, .external_lex_state = 308},
  [20966] = {.lex_state = 0, .external_lex_state = 308},
  [20967] = {.lex_state = 0, .external_lex_state = 308},
  [20968] = {.lex_state = 0, .external_lex_state = 308},
  [20969] = {.lex_state = 0, .external_lex_state = 308},
  [20970] = {.lex_state = 0, .external_lex_state = 308},
  [20971] = {.lex_state = 0, .external_lex_state = 444},
  [20972] = {.lex_state = 0, .external_lex_state = 308},
  [20973] = {.lex_state = 0, .external_lex_state = 308},
  [20974] = {.lex_state = 0, .external_lex_state = 308},
  [20975] = {.lex_state = 0, .external_lex_state = 308},
  [20976] = {.lex_state = 0, .external_lex_state = 308},
  [20977] = {.lex_state = 0, .external_lex_state = 308},
  [20978] = {.lex_state = 0, .external_lex_state = 308},
  [20979] = {.lex_state = 0, .external_lex_state = 308},
  [20980] = {.lex_state = 0, .external_lex_state = 444},
  [20981] = {.lex_state = 0, .external_lex_state = 308},
  [20982] = {.lex_state = 0, .external_lex_state = 308},
  [20983] = {.lex_state = 0, .external_lex_state = 444},
  [20984] = {.lex_state = 0, .external_lex_state = 308},
  [20985] = {.lex_state = 0, .external_lex_state = 308},
  [20986] = {.lex_state = 0, .external_lex_state = 308},
  [20987] = {.lex_state = 0, .external_lex_state = 308},
  [20988] = {.lex_state = 0, .external_lex_state = 308},
  [20989] = {.lex_state = 0, .external_lex_state = 308},
};

enum {
  ts_external_token__layout_semicolon = 0,
  ts_external_token__layout_start = 1,
  ts_external_token__layout_end = 2,
  ts_external_token__dot = 3,
  ts_external_token__arith_dotdot = 4,
  ts_external_token_where = 5,
  ts_external_token__splice_dollar = 6,
  ts_external_token__varsym = 7,
  ts_external_token__consym = 8,
  ts_external_token__tyconsym = 9,
  ts_external_token_comment = 10,
  ts_external_token_cpp = 11,
  ts_external_token_comma = 12,
  ts_external_token_quasiquote_start = 13,
  ts_external_token_quasiquote_bar = 14,
  ts_external_token_quasiquote_body = 15,
  ts_external_token__strict = 16,
  ts_external_token__lazy = 17,
  ts_external_token__unboxed_close = 18,
  ts_external_token_PIPE = 19,
  ts_external_token_in = 20,
  ts_external_token__token1 = 21,
  ts_external_token_empty_file = 22,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__layout_semicolon] = sym__layout_semicolon,
  [ts_external_token__layout_start] = sym__layout_start,
  [ts_external_token__layout_end] = sym__layout_end,
  [ts_external_token__dot] = sym__dot,
  [ts_external_token__arith_dotdot] = sym__arith_dotdot,
  [ts_external_token_where] = sym_where,
  [ts_external_token__splice_dollar] = sym__splice_dollar,
  [ts_external_token__varsym] = sym__varsym,
  [ts_external_token__consym] = sym__consym,
  [ts_external_token__tyconsym] = sym__tyconsym,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token_cpp] = sym_cpp,
  [ts_external_token_comma] = sym_comma,
  [ts_external_token_quasiquote_start] = sym_quasiquote_start,
  [ts_external_token_quasiquote_bar] = sym_quasiquote_bar,
  [ts_external_token_quasiquote_body] = sym_quasiquote_body,
  [ts_external_token__strict] = sym__strict,
  [ts_external_token__lazy] = sym__lazy,
  [ts_external_token__unboxed_close] = sym__unboxed_close,
  [ts_external_token_PIPE] = anon_sym_PIPE,
  [ts_external_token_in] = anon_sym_in,
  [ts_external_token__token1] = aux_sym__token1,
  [ts_external_token_empty_file] = sym_empty_file,
};

static const bool ts_external_scanner_states[445][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_quasiquote_bar] = true,
    [ts_external_token_quasiquote_body] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
    [ts_external_token_empty_file] = true,
  },
  [2] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
    [ts_external_token_empty_file] = true,
  },
  [3] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [4] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [5] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [6] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [7] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [8] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [9] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [10] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [11] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [12] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [13] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [14] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [15] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [16] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [17] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [18] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [19] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [20] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [21] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [22] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [23] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [24] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [25] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [26] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [27] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [28] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [29] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [30] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [31] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [32] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [33] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [34] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [35] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [36] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [37] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [38] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [39] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [40] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [41] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [42] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [43] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [44] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [45] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [46] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [47] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [48] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [49] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [50] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [51] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [52] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [53] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [54] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [55] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [56] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [57] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [58] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [59] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [60] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [61] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [62] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [63] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [64] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [65] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [66] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [67] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [68] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [69] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [70] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [71] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [72] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [73] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [74] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [75] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [76] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [77] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [78] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [79] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [80] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [81] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [82] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [83] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [84] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [85] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [86] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [87] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [88] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [89] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [90] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [91] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [92] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [93] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [94] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [95] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [96] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [97] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [98] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [99] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [100] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [101] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [102] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [103] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [104] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [105] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [106] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [107] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [108] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [109] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [110] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [111] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [112] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [113] = {
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [114] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [115] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [116] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [117] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [118] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [119] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [120] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [121] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [122] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [123] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [124] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [125] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [126] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [127] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [128] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [129] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [130] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [131] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [132] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [133] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [134] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [135] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [136] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [137] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [138] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [139] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [140] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [141] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [142] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [143] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [144] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [145] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [146] = {
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [147] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [148] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [149] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [150] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [151] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [152] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [153] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [154] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [155] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [156] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [157] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [158] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [159] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [160] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [161] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [162] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [163] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [164] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [165] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [166] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [167] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [168] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [169] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [170] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [171] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [172] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [173] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [174] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [175] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [176] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [177] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [178] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [179] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [180] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [181] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [182] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [183] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [184] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [185] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [186] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [187] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [188] = {
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [189] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [190] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [191] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [192] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [193] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [194] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [195] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [196] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [197] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [198] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [199] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [200] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [201] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [202] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [203] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [204] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [205] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [206] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [207] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [208] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [209] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [210] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [211] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [212] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [213] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [214] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [215] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [216] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [217] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [218] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [219] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [220] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [221] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [222] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [223] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [224] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [225] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [226] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [227] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [228] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [229] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [230] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [231] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [232] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [233] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [234] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [235] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [236] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [237] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [238] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [239] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [240] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [241] = {
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [242] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [243] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [244] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [245] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [246] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [247] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [248] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [249] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [250] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [251] = {
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [252] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [253] = {
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [254] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [255] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [256] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [257] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [258] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [259] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [260] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [261] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [262] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [263] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [264] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [265] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [266] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [267] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [268] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [269] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [270] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [271] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [272] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [273] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [274] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [275] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [276] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [277] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [278] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [279] = {
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [280] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [281] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [282] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [283] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [284] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [285] = {
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [286] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [287] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [288] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [289] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [290] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [291] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [292] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [293] = {
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [294] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [295] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [296] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [297] = {
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [298] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [299] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [300] = {
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [301] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [302] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [303] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [304] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [305] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [306] = {
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [307] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__token1] = true,
  },
  [308] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [309] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [310] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [311] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [312] = {
    [ts_external_token__dot] = true,
    [ts_external_token__splice_dollar] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_start] = true,
    [ts_external_token__strict] = true,
    [ts_external_token__lazy] = true,
    [ts_external_token__token1] = true,
  },
  [313] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [314] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [315] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [316] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [317] = {
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [318] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [319] = {
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [320] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [321] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [322] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [323] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [324] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__consym] = true,
    [ts_external_token__tyconsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [325] = {
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [326] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [327] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [328] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [329] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [330] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [331] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [332] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [333] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [334] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [335] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [336] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [337] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [338] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [339] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [340] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [341] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [342] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [343] = {
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [344] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [345] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [346] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [347] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [348] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [349] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [350] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [351] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [352] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [353] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [354] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [355] = {
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [356] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [357] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [358] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [359] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [360] = {
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [361] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [362] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [363] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [364] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [365] = {
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [366] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [367] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [368] = {
    [ts_external_token__dot] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [369] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [370] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [371] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [372] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [373] = {
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [374] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [375] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [376] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [377] = {
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [378] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [379] = {
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [380] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [381] = {
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [382] = {
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [383] = {
    [ts_external_token__varsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [384] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [385] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [386] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [387] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [388] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [389] = {
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [390] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [391] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [392] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [393] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [394] = {
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [395] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [396] = {
    [ts_external_token__arith_dotdot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [397] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [398] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [399] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [400] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [401] = {
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [402] = {
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [403] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [404] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [405] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [406] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [407] = {
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [408] = {
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [409] = {
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [410] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [411] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [412] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [413] = {
    [ts_external_token__varsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [414] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_bar] = true,
    [ts_external_token__token1] = true,
  },
  [415] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [416] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
  [417] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [418] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [419] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [420] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [421] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__consym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [422] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [423] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [424] = {
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [425] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [426] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [427] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [428] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [429] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [430] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [431] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [432] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [433] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [434] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [435] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [436] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [437] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [438] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token__token1] = true,
  },
  [439] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_comma] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [440] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_PIPE] = true,
    [ts_external_token__token1] = true,
  },
  [441] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_quasiquote_body] = true,
    [ts_external_token__token1] = true,
  },
  [442] = {
    [ts_external_token__dot] = true,
    [ts_external_token_where] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__token1] = true,
  },
  [443] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token_in] = true,
    [ts_external_token__token1] = true,
  },
  [444] = {
    [ts_external_token_comment] = true,
    [ts_external_token_cpp] = true,
    [ts_external_token__unboxed_close] = true,
    [ts_external_token__token1] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__varid] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_char] = ACTIONS(1),
    [sym_string] = ACTIONS(1),
    [sym__integer_literal] = ACTIONS(1),
    [sym__binary_literal] = ACTIONS(1),
    [sym__octal_literal] = ACTIONS(1),
    [sym__hex_literal] = ACTIONS(1),
    [anon_sym_LPAREN_POUND] = ACTIONS(1),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1),
    [anon_sym_] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_2] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_3] = ACTIONS(1),
    [anon_sym_LT_DASH] = ACTIONS(1),
    [anon_sym_4] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [sym__immediate_dot] = ACTIONS(1),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [sym_implicit_parid] = ACTIONS(1),
    [sym__conid] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_forall] = ACTIONS(1),
    [anon_sym_5] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_6] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_family] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_instance] = ACTIONS(1),
    [anon_sym_representational] = ACTIONS(1),
    [anon_sym_nominal] = ACTIONS(1),
    [anon_sym_phantom] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_role] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_thengroupby] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_thengroupusing] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_rec] = ACTIONS(1),
    [anon_sym_mdo] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_AT2] = ACTIONS(1),
    [anon_sym_pattern] = ACTIONS(1),
    [anon_sym_hiding] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_qualified] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_via] = ACTIONS(1),
    [anon_sym_stock] = ACTIONS(1),
    [anon_sym_newtype] = ACTIONS(1),
    [anon_sym_anyclass] = ACTIONS(1),
    [anon_sym_deriving] = ACTIONS(1),
    [anon_sym_data] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_infixl] = ACTIONS(1),
    [anon_sym_infixr] = ACTIONS(1),
    [anon_sym_infix] = ACTIONS(1),
    [anon_sym_ccall] = ACTIONS(1),
    [anon_sym_stdcall] = ACTIONS(1),
    [anon_sym_cplusplus] = ACTIONS(1),
    [anon_sym_jvm] = ACTIONS(1),
    [anon_sym_dotnet] = ACTIONS(1),
    [anon_sym_prim] = ACTIONS(1),
    [anon_sym_capi] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_safe] = ACTIONS(1),
    [anon_sym_interruptible] = ACTIONS(1),
    [anon_sym_foreign] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_7] = ACTIONS(1),
    [anon_sym_PIPE_RBRACK] = ACTIONS(1),
    [anon_sym_8] = ACTIONS(1),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1),
    [sym__layout_start] = ACTIONS(1),
    [sym__layout_end] = ACTIONS(1),
    [sym__dot] = ACTIONS(1),
    [sym__arith_dotdot] = ACTIONS(1),
    [sym_where] = ACTIONS(1),
    [sym__splice_dollar] = ACTIONS(1),
    [sym__varsym] = ACTIONS(1),
    [sym__consym] = ACTIONS(1),
    [sym__tyconsym] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1),
    [sym_quasiquote_start] = ACTIONS(1),
    [sym_quasiquote_bar] = ACTIONS(1),
    [sym_quasiquote_body] = ACTIONS(1),
    [sym__strict] = ACTIONS(1),
    [sym__lazy] = ACTIONS(1),
    [sym__unboxed_close] = ACTIONS(1),
    [sym_empty_file] = ACTIONS(1),
  },
  [1] = {
    [sym_haskell] = STATE(20905),
    [sym__topdecl] = STATE(14728),
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(107),
    [sym_variable] = STATE(3469),
    [sym_qualified_variable] = STATE(5710),
    [sym_constructor] = STATE(3863),
    [sym_qualified_constructor] = STATE(3959),
    [sym__qcon] = STATE(3990),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4591),
    [sym_decl_type] = STATE(14728),
    [sym_decl_tyfam] = STATE(14728),
    [sym_decl_tyinst] = STATE(14728),
    [sym_decl_role] = STATE(14728),
    [sym_exp_parens] = STATE(5640),
    [sym_exp_tuple] = STATE(5640),
    [sym_exp_unboxed_tuple] = STATE(5640),
    [sym_exp_unboxed_sum] = STATE(5640),
    [sym_exp_list] = STATE(5640),
    [sym_exp_arithmetic_sequence] = STATE(5640),
    [sym_exp_list_comprehension] = STATE(5640),
    [sym_exp_section_left] = STATE(5640),
    [sym_exp_section_right] = STATE(5640),
    [sym_exp_th_quoted_name] = STATE(5640),
    [sym_exp_type_application] = STATE(956),
    [sym_exp_lambda] = STATE(9583),
    [sym_exp_let] = STATE(17912),
    [sym_exp_let_in] = STATE(9583),
    [sym_exp_cond] = STATE(9583),
    [sym_exp_if_guard] = STATE(9583),
    [sym_exp_case] = STATE(9583),
    [sym_exp_lambda_case] = STATE(956),
    [sym__do_keyword] = STATE(17914),
    [sym_do_module] = STATE(17914),
    [sym_exp_do] = STATE(956),
    [sym_exp_negation] = STATE(9583),
    [sym_exp_record] = STATE(5640),
    [sym_exp_name] = STATE(5640),
    [sym_exp_projection_selector] = STATE(5640),
    [sym__aexp_projection] = STATE(5640),
    [sym_exp_projection] = STATE(5640),
    [sym__aexp] = STATE(956),
    [sym__exp_apply] = STATE(12238),
    [sym__fexp] = STATE(9583),
    [sym__lexp] = STATE(9583),
    [sym_exp_infix] = STATE(9583),
    [sym__exp_infix] = STATE(9583),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13759),
    [sym__typed_pat] = STATE(13759),
    [sym_decl_import] = STATE(14728),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12651),
    [sym__module] = STATE(20871),
    [sym_decl_adt] = STATE(14728),
    [sym_decl_newtype] = STATE(14728),
    [sym_decl_datafam] = STATE(14728),
    [sym_decl_datainst] = STATE(14728),
    [sym_decl_class] = STATE(14728),
    [sym__instance] = STATE(14612),
    [sym_decl_instance] = STATE(14728),
    [sym_decl_deriving] = STATE(14728),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(15452),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13767),
    [sym_function] = STATE(14728),
    [sym_fixity] = STATE(14728),
    [sym_signature] = STATE(14728),
    [sym__gendecl] = STATE(14728),
    [sym__decl_fun] = STATE(14728),
    [sym__decl] = STATE(14728),
    [sym_decl_foreign_import] = STATE(14728),
    [sym_decl_foreign_export] = STATE(14728),
    [sym__decl_foreign] = STATE(14728),
    [sym_decl_pattern] = STATE(14728),
    [sym_decl_default] = STATE(14728),
    [sym_splice] = STATE(4624),
    [sym_top_splice] = STATE(14728),
    [sym_quasiquote] = STATE(4624),
    [sym__varid] = ACTIONS(5),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(13),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(13),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [sym_implicit_parid] = ACTIONS(21),
    [sym__conid] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_instance] = ACTIONS(31),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(35),
    [anon_sym_AT] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_pattern] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_module] = ACTIONS(53),
    [anon_sym_newtype] = ACTIONS(55),
    [anon_sym_deriving] = ACTIONS(57),
    [anon_sym_data] = ACTIONS(59),
    [anon_sym_default] = ACTIONS(61),
    [anon_sym_class] = ACTIONS(63),
    [anon_sym_infixl] = ACTIONS(65),
    [anon_sym_infixr] = ACTIONS(65),
    [anon_sym_infix] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(67),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
    [sym_empty_file] = ACTIONS(79),
  },
  [2] = {
    [sym__topdecl] = STATE(16407),
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(103),
    [sym_variable] = STATE(3554),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(4196),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(5101),
    [sym_decl_type] = STATE(16407),
    [sym_decl_tyfam] = STATE(16407),
    [sym_decl_tyinst] = STATE(16407),
    [sym_decl_role] = STATE(16407),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9676),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9676),
    [sym_exp_cond] = STATE(9676),
    [sym_exp_if_guard] = STATE(9676),
    [sym_exp_case] = STATE(9676),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9676),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9676),
    [sym__lexp] = STATE(9676),
    [sym_exp_infix] = STATE(9676),
    [sym__exp_infix] = STATE(9676),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym_decl_import] = STATE(16407),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12505),
    [sym_decl_adt] = STATE(16407),
    [sym_decl_newtype] = STATE(16407),
    [sym_decl_datafam] = STATE(16407),
    [sym_decl_datainst] = STATE(16407),
    [sym_decl_class] = STATE(16407),
    [sym__instance] = STATE(15671),
    [sym_decl_instance] = STATE(16407),
    [sym_decl_deriving] = STATE(16407),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(16407),
    [sym_fixity] = STATE(16407),
    [sym_signature] = STATE(16407),
    [sym__gendecl] = STATE(16407),
    [sym__decl_fun] = STATE(16407),
    [sym__decl] = STATE(16407),
    [sym_decl_foreign_import] = STATE(16407),
    [sym_decl_foreign_export] = STATE(16407),
    [sym__decl_foreign] = STATE(16407),
    [sym_decl_pattern] = STATE(16407),
    [sym_decl_default] = STATE(16407),
    [sym_splice] = STATE(5100),
    [sym_top_splice] = STATE(16407),
    [sym_quasiquote] = STATE(5100),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(91),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(91),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(97),
    [sym_implicit_parid] = ACTIONS(99),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(109),
    [anon_sym_instance] = ACTIONS(111),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_pattern] = ACTIONS(125),
    [anon_sym_import] = ACTIONS(127),
    [anon_sym_newtype] = ACTIONS(129),
    [anon_sym_deriving] = ACTIONS(131),
    [anon_sym_data] = ACTIONS(133),
    [anon_sym_default] = ACTIONS(135),
    [anon_sym_class] = ACTIONS(137),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_foreign] = ACTIONS(141),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [3] = {
    [sym__topdecl] = STATE(17662),
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(103),
    [sym_variable] = STATE(3554),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(4196),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(5101),
    [sym_decl_type] = STATE(17662),
    [sym_decl_tyfam] = STATE(17662),
    [sym_decl_tyinst] = STATE(17662),
    [sym_decl_role] = STATE(17662),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9676),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9676),
    [sym_exp_cond] = STATE(9676),
    [sym_exp_if_guard] = STATE(9676),
    [sym_exp_case] = STATE(9676),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9676),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9676),
    [sym__lexp] = STATE(9676),
    [sym_exp_infix] = STATE(9676),
    [sym__exp_infix] = STATE(9676),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym_decl_import] = STATE(17662),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12505),
    [sym_decl_adt] = STATE(17662),
    [sym_decl_newtype] = STATE(17662),
    [sym_decl_datafam] = STATE(17662),
    [sym_decl_datainst] = STATE(17662),
    [sym_decl_class] = STATE(17662),
    [sym__instance] = STATE(15671),
    [sym_decl_instance] = STATE(17662),
    [sym_decl_deriving] = STATE(17662),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(17662),
    [sym_fixity] = STATE(17662),
    [sym_signature] = STATE(17662),
    [sym__gendecl] = STATE(17662),
    [sym__decl_fun] = STATE(17662),
    [sym__decl] = STATE(17662),
    [sym_decl_foreign_import] = STATE(17662),
    [sym_decl_foreign_export] = STATE(17662),
    [sym__decl_foreign] = STATE(17662),
    [sym_decl_pattern] = STATE(17662),
    [sym_decl_default] = STATE(17662),
    [sym_splice] = STATE(5100),
    [sym_top_splice] = STATE(17662),
    [sym_quasiquote] = STATE(5100),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(149),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(91),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(91),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(97),
    [sym_implicit_parid] = ACTIONS(99),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(151),
    [anon_sym_instance] = ACTIONS(111),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_pattern] = ACTIONS(125),
    [anon_sym_import] = ACTIONS(127),
    [anon_sym_newtype] = ACTIONS(129),
    [anon_sym_deriving] = ACTIONS(131),
    [anon_sym_data] = ACTIONS(133),
    [anon_sym_default] = ACTIONS(135),
    [anon_sym_class] = ACTIONS(137),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_foreign] = ACTIONS(141),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [4] = {
    [sym__topdecl] = STATE(18415),
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(103),
    [sym_variable] = STATE(3554),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(4196),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(5101),
    [sym_decl_type] = STATE(18415),
    [sym_decl_tyfam] = STATE(18415),
    [sym_decl_tyinst] = STATE(18415),
    [sym_decl_role] = STATE(18415),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9676),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9676),
    [sym_exp_cond] = STATE(9676),
    [sym_exp_if_guard] = STATE(9676),
    [sym_exp_case] = STATE(9676),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9676),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9676),
    [sym__lexp] = STATE(9676),
    [sym_exp_infix] = STATE(9676),
    [sym__exp_infix] = STATE(9676),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym_decl_import] = STATE(18415),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12505),
    [sym_decl_adt] = STATE(18415),
    [sym_decl_newtype] = STATE(18415),
    [sym_decl_datafam] = STATE(18415),
    [sym_decl_datainst] = STATE(18415),
    [sym_decl_class] = STATE(18415),
    [sym__instance] = STATE(15671),
    [sym_decl_instance] = STATE(18415),
    [sym_decl_deriving] = STATE(18415),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18415),
    [sym_fixity] = STATE(18415),
    [sym_signature] = STATE(18415),
    [sym__gendecl] = STATE(18415),
    [sym__decl_fun] = STATE(18415),
    [sym__decl] = STATE(18415),
    [sym_decl_foreign_import] = STATE(18415),
    [sym_decl_foreign_export] = STATE(18415),
    [sym__decl_foreign] = STATE(18415),
    [sym_decl_pattern] = STATE(18415),
    [sym_decl_default] = STATE(18415),
    [sym_splice] = STATE(5100),
    [sym_top_splice] = STATE(18415),
    [sym_quasiquote] = STATE(5100),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(91),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(91),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(97),
    [sym_implicit_parid] = ACTIONS(99),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(153),
    [anon_sym_instance] = ACTIONS(111),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_pattern] = ACTIONS(125),
    [anon_sym_import] = ACTIONS(127),
    [anon_sym_newtype] = ACTIONS(129),
    [anon_sym_deriving] = ACTIONS(131),
    [anon_sym_data] = ACTIONS(133),
    [anon_sym_default] = ACTIONS(135),
    [anon_sym_class] = ACTIONS(137),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_foreign] = ACTIONS(141),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [5] = {
    [sym__topdecl] = STATE(16592),
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(114),
    [sym_variable] = STATE(3474),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3900),
    [sym_qualified_constructor] = STATE(4008),
    [sym__qcon] = STATE(3911),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(4438),
    [sym_decl_type] = STATE(16592),
    [sym_decl_tyfam] = STATE(16592),
    [sym_decl_tyinst] = STATE(16592),
    [sym_decl_role] = STATE(16592),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9527),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9527),
    [sym_exp_cond] = STATE(9527),
    [sym_exp_if_guard] = STATE(9527),
    [sym_exp_case] = STATE(9527),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9527),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9527),
    [sym__lexp] = STATE(9527),
    [sym_exp_infix] = STATE(9527),
    [sym__exp_infix] = STATE(9527),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym_decl_import] = STATE(16592),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12597),
    [sym_decl_adt] = STATE(16592),
    [sym_decl_newtype] = STATE(16592),
    [sym_decl_datafam] = STATE(16592),
    [sym_decl_datainst] = STATE(16592),
    [sym_decl_class] = STATE(16592),
    [sym__instance] = STATE(14807),
    [sym_decl_instance] = STATE(16592),
    [sym_decl_deriving] = STATE(16592),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(16592),
    [sym_fixity] = STATE(16592),
    [sym_signature] = STATE(16592),
    [sym__gendecl] = STATE(16592),
    [sym__decl_fun] = STATE(16592),
    [sym__decl] = STATE(16592),
    [sym_decl_foreign_import] = STATE(16592),
    [sym_decl_foreign_export] = STATE(16592),
    [sym__decl_foreign] = STATE(16592),
    [sym_decl_pattern] = STATE(16592),
    [sym_decl_default] = STATE(16592),
    [sym_splice] = STATE(4437),
    [sym_top_splice] = STATE(16592),
    [sym_quasiquote] = STATE(4437),
    [sym__varid] = ACTIONS(155),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(163),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(163),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(169),
    [sym_implicit_parid] = ACTIONS(171),
    [sym__conid] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_type] = ACTIONS(179),
    [anon_sym_instance] = ACTIONS(181),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_pattern] = ACTIONS(195),
    [anon_sym_import] = ACTIONS(197),
    [anon_sym_newtype] = ACTIONS(199),
    [anon_sym_deriving] = ACTIONS(201),
    [anon_sym_data] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_class] = ACTIONS(207),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_foreign] = ACTIONS(211),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(215),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [6] = {
    [sym__topdecl] = STATE(15051),
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(114),
    [sym_variable] = STATE(3474),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3900),
    [sym_qualified_constructor] = STATE(4008),
    [sym__qcon] = STATE(3911),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(4438),
    [sym_decl_type] = STATE(15051),
    [sym_decl_tyfam] = STATE(15051),
    [sym_decl_tyinst] = STATE(15051),
    [sym_decl_role] = STATE(15051),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9527),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9527),
    [sym_exp_cond] = STATE(9527),
    [sym_exp_if_guard] = STATE(9527),
    [sym_exp_case] = STATE(9527),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9527),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9527),
    [sym__lexp] = STATE(9527),
    [sym_exp_infix] = STATE(9527),
    [sym__exp_infix] = STATE(9527),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym_decl_import] = STATE(15051),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12597),
    [sym_decl_adt] = STATE(15051),
    [sym_decl_newtype] = STATE(15051),
    [sym_decl_datafam] = STATE(15051),
    [sym_decl_datainst] = STATE(15051),
    [sym_decl_class] = STATE(15051),
    [sym__instance] = STATE(14807),
    [sym_decl_instance] = STATE(15051),
    [sym_decl_deriving] = STATE(15051),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15051),
    [sym_fixity] = STATE(15051),
    [sym_signature] = STATE(15051),
    [sym__gendecl] = STATE(15051),
    [sym__decl_fun] = STATE(15051),
    [sym__decl] = STATE(15051),
    [sym_decl_foreign_import] = STATE(15051),
    [sym_decl_foreign_export] = STATE(15051),
    [sym__decl_foreign] = STATE(15051),
    [sym_decl_pattern] = STATE(15051),
    [sym_decl_default] = STATE(15051),
    [sym_splice] = STATE(4437),
    [sym_top_splice] = STATE(15051),
    [sym_quasiquote] = STATE(4437),
    [sym__varid] = ACTIONS(155),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(163),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(163),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(169),
    [sym_implicit_parid] = ACTIONS(171),
    [sym__conid] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_type] = ACTIONS(179),
    [anon_sym_instance] = ACTIONS(181),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_pattern] = ACTIONS(195),
    [anon_sym_import] = ACTIONS(197),
    [anon_sym_newtype] = ACTIONS(199),
    [anon_sym_deriving] = ACTIONS(201),
    [anon_sym_data] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_class] = ACTIONS(207),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_foreign] = ACTIONS(211),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(109),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [7] = {
    [sym__topdecl] = STATE(18415),
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(103),
    [sym_variable] = STATE(3554),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(4196),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(5101),
    [sym_decl_type] = STATE(18415),
    [sym_decl_tyfam] = STATE(18415),
    [sym_decl_tyinst] = STATE(18415),
    [sym_decl_role] = STATE(18415),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9676),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9676),
    [sym_exp_cond] = STATE(9676),
    [sym_exp_if_guard] = STATE(9676),
    [sym_exp_case] = STATE(9676),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9676),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9676),
    [sym__lexp] = STATE(9676),
    [sym_exp_infix] = STATE(9676),
    [sym__exp_infix] = STATE(9676),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym_decl_import] = STATE(18415),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12505),
    [sym_decl_adt] = STATE(18415),
    [sym_decl_newtype] = STATE(18415),
    [sym_decl_datafam] = STATE(18415),
    [sym_decl_datainst] = STATE(18415),
    [sym_decl_class] = STATE(18415),
    [sym__instance] = STATE(15671),
    [sym_decl_instance] = STATE(18415),
    [sym_decl_deriving] = STATE(18415),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18415),
    [sym_fixity] = STATE(18415),
    [sym_signature] = STATE(18415),
    [sym__gendecl] = STATE(18415),
    [sym__decl_fun] = STATE(18415),
    [sym__decl] = STATE(18415),
    [sym_decl_foreign_import] = STATE(18415),
    [sym_decl_foreign_export] = STATE(18415),
    [sym__decl_foreign] = STATE(18415),
    [sym_decl_pattern] = STATE(18415),
    [sym_decl_default] = STATE(18415),
    [sym_splice] = STATE(5100),
    [sym_top_splice] = STATE(18415),
    [sym_quasiquote] = STATE(5100),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(91),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(91),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(97),
    [sym_implicit_parid] = ACTIONS(99),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(215),
    [anon_sym_instance] = ACTIONS(111),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_pattern] = ACTIONS(125),
    [anon_sym_import] = ACTIONS(127),
    [anon_sym_newtype] = ACTIONS(129),
    [anon_sym_deriving] = ACTIONS(131),
    [anon_sym_data] = ACTIONS(133),
    [anon_sym_default] = ACTIONS(135),
    [anon_sym_class] = ACTIONS(137),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_foreign] = ACTIONS(141),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [8] = {
    [sym__topdecl] = STATE(15808),
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(107),
    [sym_variable] = STATE(3469),
    [sym_qualified_variable] = STATE(5710),
    [sym_constructor] = STATE(3863),
    [sym_qualified_constructor] = STATE(3959),
    [sym__qcon] = STATE(3990),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4591),
    [sym_decl_type] = STATE(15808),
    [sym_decl_tyfam] = STATE(15808),
    [sym_decl_tyinst] = STATE(15808),
    [sym_decl_role] = STATE(15808),
    [sym_exp_parens] = STATE(5640),
    [sym_exp_tuple] = STATE(5640),
    [sym_exp_unboxed_tuple] = STATE(5640),
    [sym_exp_unboxed_sum] = STATE(5640),
    [sym_exp_list] = STATE(5640),
    [sym_exp_arithmetic_sequence] = STATE(5640),
    [sym_exp_list_comprehension] = STATE(5640),
    [sym_exp_section_left] = STATE(5640),
    [sym_exp_section_right] = STATE(5640),
    [sym_exp_th_quoted_name] = STATE(5640),
    [sym_exp_type_application] = STATE(956),
    [sym_exp_lambda] = STATE(9583),
    [sym_exp_let] = STATE(17912),
    [sym_exp_let_in] = STATE(9583),
    [sym_exp_cond] = STATE(9583),
    [sym_exp_if_guard] = STATE(9583),
    [sym_exp_case] = STATE(9583),
    [sym_exp_lambda_case] = STATE(956),
    [sym__do_keyword] = STATE(17914),
    [sym_do_module] = STATE(17914),
    [sym_exp_do] = STATE(956),
    [sym_exp_negation] = STATE(9583),
    [sym_exp_record] = STATE(5640),
    [sym_exp_name] = STATE(5640),
    [sym_exp_projection_selector] = STATE(5640),
    [sym__aexp_projection] = STATE(5640),
    [sym_exp_projection] = STATE(5640),
    [sym__aexp] = STATE(956),
    [sym__exp_apply] = STATE(12238),
    [sym__fexp] = STATE(9583),
    [sym__lexp] = STATE(9583),
    [sym_exp_infix] = STATE(9583),
    [sym__exp_infix] = STATE(9583),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13759),
    [sym__typed_pat] = STATE(13759),
    [sym_decl_import] = STATE(15808),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12651),
    [sym_decl_adt] = STATE(15808),
    [sym_decl_newtype] = STATE(15808),
    [sym_decl_datafam] = STATE(15808),
    [sym_decl_datainst] = STATE(15808),
    [sym_decl_class] = STATE(15808),
    [sym__instance] = STATE(14612),
    [sym_decl_instance] = STATE(15808),
    [sym_decl_deriving] = STATE(15808),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(15452),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13767),
    [sym_function] = STATE(15808),
    [sym_fixity] = STATE(15808),
    [sym_signature] = STATE(15808),
    [sym__gendecl] = STATE(15808),
    [sym__decl_fun] = STATE(15808),
    [sym__decl] = STATE(15808),
    [sym_decl_foreign_import] = STATE(15808),
    [sym_decl_foreign_export] = STATE(15808),
    [sym__decl_foreign] = STATE(15808),
    [sym_decl_pattern] = STATE(15808),
    [sym_decl_default] = STATE(15808),
    [sym_splice] = STATE(4624),
    [sym_top_splice] = STATE(15808),
    [sym_quasiquote] = STATE(4624),
    [ts_builtin_sym_end] = ACTIONS(221),
    [sym__varid] = ACTIONS(5),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(13),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(13),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [sym_implicit_parid] = ACTIONS(21),
    [sym__conid] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_instance] = ACTIONS(31),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(35),
    [anon_sym_AT] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_pattern] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_newtype] = ACTIONS(55),
    [anon_sym_deriving] = ACTIONS(57),
    [anon_sym_data] = ACTIONS(59),
    [anon_sym_default] = ACTIONS(61),
    [anon_sym_class] = ACTIONS(63),
    [anon_sym_infixl] = ACTIONS(65),
    [anon_sym_infixr] = ACTIONS(65),
    [anon_sym_infix] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(67),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [9] = {
    [sym__topdecl] = STATE(16592),
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(114),
    [sym_variable] = STATE(3474),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3900),
    [sym_qualified_constructor] = STATE(4008),
    [sym__qcon] = STATE(3911),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(4438),
    [sym_decl_type] = STATE(16592),
    [sym_decl_tyfam] = STATE(16592),
    [sym_decl_tyinst] = STATE(16592),
    [sym_decl_role] = STATE(16592),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9527),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9527),
    [sym_exp_cond] = STATE(9527),
    [sym_exp_if_guard] = STATE(9527),
    [sym_exp_case] = STATE(9527),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9527),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9527),
    [sym__lexp] = STATE(9527),
    [sym_exp_infix] = STATE(9527),
    [sym__exp_infix] = STATE(9527),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym_decl_import] = STATE(16592),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12597),
    [sym_decl_adt] = STATE(16592),
    [sym_decl_newtype] = STATE(16592),
    [sym_decl_datafam] = STATE(16592),
    [sym_decl_datainst] = STATE(16592),
    [sym_decl_class] = STATE(16592),
    [sym__instance] = STATE(14807),
    [sym_decl_instance] = STATE(16592),
    [sym_decl_deriving] = STATE(16592),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(16592),
    [sym_fixity] = STATE(16592),
    [sym_signature] = STATE(16592),
    [sym__gendecl] = STATE(16592),
    [sym__decl_fun] = STATE(16592),
    [sym__decl] = STATE(16592),
    [sym_decl_foreign_import] = STATE(16592),
    [sym_decl_foreign_export] = STATE(16592),
    [sym__decl_foreign] = STATE(16592),
    [sym_decl_pattern] = STATE(16592),
    [sym_decl_default] = STATE(16592),
    [sym_splice] = STATE(4437),
    [sym_top_splice] = STATE(16592),
    [sym_quasiquote] = STATE(4437),
    [sym__varid] = ACTIONS(155),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(163),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(163),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(169),
    [sym_implicit_parid] = ACTIONS(171),
    [sym__conid] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_type] = ACTIONS(179),
    [anon_sym_instance] = ACTIONS(181),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_pattern] = ACTIONS(195),
    [anon_sym_import] = ACTIONS(197),
    [anon_sym_newtype] = ACTIONS(199),
    [anon_sym_deriving] = ACTIONS(201),
    [anon_sym_data] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_class] = ACTIONS(207),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_foreign] = ACTIONS(211),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(223),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [10] = {
    [sym__topdecl] = STATE(15808),
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(107),
    [sym_variable] = STATE(3469),
    [sym_qualified_variable] = STATE(5710),
    [sym_constructor] = STATE(3863),
    [sym_qualified_constructor] = STATE(3959),
    [sym__qcon] = STATE(3990),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4591),
    [sym_decl_type] = STATE(15808),
    [sym_decl_tyfam] = STATE(15808),
    [sym_decl_tyinst] = STATE(15808),
    [sym_decl_role] = STATE(15808),
    [sym_exp_parens] = STATE(5640),
    [sym_exp_tuple] = STATE(5640),
    [sym_exp_unboxed_tuple] = STATE(5640),
    [sym_exp_unboxed_sum] = STATE(5640),
    [sym_exp_list] = STATE(5640),
    [sym_exp_arithmetic_sequence] = STATE(5640),
    [sym_exp_list_comprehension] = STATE(5640),
    [sym_exp_section_left] = STATE(5640),
    [sym_exp_section_right] = STATE(5640),
    [sym_exp_th_quoted_name] = STATE(5640),
    [sym_exp_type_application] = STATE(956),
    [sym_exp_lambda] = STATE(9583),
    [sym_exp_let] = STATE(17912),
    [sym_exp_let_in] = STATE(9583),
    [sym_exp_cond] = STATE(9583),
    [sym_exp_if_guard] = STATE(9583),
    [sym_exp_case] = STATE(9583),
    [sym_exp_lambda_case] = STATE(956),
    [sym__do_keyword] = STATE(17914),
    [sym_do_module] = STATE(17914),
    [sym_exp_do] = STATE(956),
    [sym_exp_negation] = STATE(9583),
    [sym_exp_record] = STATE(5640),
    [sym_exp_name] = STATE(5640),
    [sym_exp_projection_selector] = STATE(5640),
    [sym__aexp_projection] = STATE(5640),
    [sym_exp_projection] = STATE(5640),
    [sym__aexp] = STATE(956),
    [sym__exp_apply] = STATE(12238),
    [sym__fexp] = STATE(9583),
    [sym__lexp] = STATE(9583),
    [sym_exp_infix] = STATE(9583),
    [sym__exp_infix] = STATE(9583),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13759),
    [sym__typed_pat] = STATE(13759),
    [sym_decl_import] = STATE(15808),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12651),
    [sym_decl_adt] = STATE(15808),
    [sym_decl_newtype] = STATE(15808),
    [sym_decl_datafam] = STATE(15808),
    [sym_decl_datainst] = STATE(15808),
    [sym_decl_class] = STATE(15808),
    [sym__instance] = STATE(14612),
    [sym_decl_instance] = STATE(15808),
    [sym_decl_deriving] = STATE(15808),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(15452),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13767),
    [sym_function] = STATE(15808),
    [sym_fixity] = STATE(15808),
    [sym_signature] = STATE(15808),
    [sym__gendecl] = STATE(15808),
    [sym__decl_fun] = STATE(15808),
    [sym__decl] = STATE(15808),
    [sym_decl_foreign_import] = STATE(15808),
    [sym_decl_foreign_export] = STATE(15808),
    [sym__decl_foreign] = STATE(15808),
    [sym_decl_pattern] = STATE(15808),
    [sym_decl_default] = STATE(15808),
    [sym_splice] = STATE(4624),
    [sym_top_splice] = STATE(15808),
    [sym_quasiquote] = STATE(4624),
    [ts_builtin_sym_end] = ACTIONS(225),
    [sym__varid] = ACTIONS(5),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(13),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(13),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [sym_implicit_parid] = ACTIONS(21),
    [sym__conid] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_instance] = ACTIONS(31),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(35),
    [anon_sym_AT] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_pattern] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_newtype] = ACTIONS(55),
    [anon_sym_deriving] = ACTIONS(57),
    [anon_sym_data] = ACTIONS(59),
    [anon_sym_default] = ACTIONS(61),
    [anon_sym_class] = ACTIONS(63),
    [anon_sym_infixl] = ACTIONS(65),
    [anon_sym_infixr] = ACTIONS(65),
    [anon_sym_infix] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(67),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [11] = {
    [sym__topdecl] = STATE(16592),
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(114),
    [sym_variable] = STATE(3474),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3900),
    [sym_qualified_constructor] = STATE(4008),
    [sym__qcon] = STATE(3911),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(4438),
    [sym_decl_type] = STATE(16592),
    [sym_decl_tyfam] = STATE(16592),
    [sym_decl_tyinst] = STATE(16592),
    [sym_decl_role] = STATE(16592),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9527),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9527),
    [sym_exp_cond] = STATE(9527),
    [sym_exp_if_guard] = STATE(9527),
    [sym_exp_case] = STATE(9527),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9527),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9527),
    [sym__lexp] = STATE(9527),
    [sym_exp_infix] = STATE(9527),
    [sym__exp_infix] = STATE(9527),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym_decl_import] = STATE(16592),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12597),
    [sym_decl_adt] = STATE(16592),
    [sym_decl_newtype] = STATE(16592),
    [sym_decl_datafam] = STATE(16592),
    [sym_decl_datainst] = STATE(16592),
    [sym_decl_class] = STATE(16592),
    [sym__instance] = STATE(14807),
    [sym_decl_instance] = STATE(16592),
    [sym_decl_deriving] = STATE(16592),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(16592),
    [sym_fixity] = STATE(16592),
    [sym_signature] = STATE(16592),
    [sym__gendecl] = STATE(16592),
    [sym__decl_fun] = STATE(16592),
    [sym__decl] = STATE(16592),
    [sym_decl_foreign_import] = STATE(16592),
    [sym_decl_foreign_export] = STATE(16592),
    [sym__decl_foreign] = STATE(16592),
    [sym_decl_pattern] = STATE(16592),
    [sym_decl_default] = STATE(16592),
    [sym_splice] = STATE(4437),
    [sym_top_splice] = STATE(16592),
    [sym_quasiquote] = STATE(4437),
    [sym__varid] = ACTIONS(155),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(163),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(163),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(169),
    [sym_implicit_parid] = ACTIONS(171),
    [sym__conid] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_type] = ACTIONS(179),
    [anon_sym_instance] = ACTIONS(181),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_pattern] = ACTIONS(195),
    [anon_sym_import] = ACTIONS(197),
    [anon_sym_newtype] = ACTIONS(199),
    [anon_sym_deriving] = ACTIONS(201),
    [anon_sym_data] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_class] = ACTIONS(207),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_foreign] = ACTIONS(211),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(153),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [12] = {
    [sym__topdecl] = STATE(18415),
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(103),
    [sym_variable] = STATE(3554),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(4196),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(5101),
    [sym_decl_type] = STATE(18415),
    [sym_decl_tyfam] = STATE(18415),
    [sym_decl_tyinst] = STATE(18415),
    [sym_decl_role] = STATE(18415),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9676),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9676),
    [sym_exp_cond] = STATE(9676),
    [sym_exp_if_guard] = STATE(9676),
    [sym_exp_case] = STATE(9676),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9676),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9676),
    [sym__lexp] = STATE(9676),
    [sym_exp_infix] = STATE(9676),
    [sym__exp_infix] = STATE(9676),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym_decl_import] = STATE(18415),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12505),
    [sym_decl_adt] = STATE(18415),
    [sym_decl_newtype] = STATE(18415),
    [sym_decl_datafam] = STATE(18415),
    [sym_decl_datainst] = STATE(18415),
    [sym_decl_class] = STATE(18415),
    [sym__instance] = STATE(15671),
    [sym_decl_instance] = STATE(18415),
    [sym_decl_deriving] = STATE(18415),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18415),
    [sym_fixity] = STATE(18415),
    [sym_signature] = STATE(18415),
    [sym__gendecl] = STATE(18415),
    [sym__decl_fun] = STATE(18415),
    [sym__decl] = STATE(18415),
    [sym_decl_foreign_import] = STATE(18415),
    [sym_decl_foreign_export] = STATE(18415),
    [sym__decl_foreign] = STATE(18415),
    [sym_decl_pattern] = STATE(18415),
    [sym_decl_default] = STATE(18415),
    [sym_splice] = STATE(5100),
    [sym_top_splice] = STATE(18415),
    [sym_quasiquote] = STATE(5100),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(91),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(91),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(97),
    [sym_implicit_parid] = ACTIONS(99),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_RBRACE] = ACTIONS(223),
    [anon_sym_instance] = ACTIONS(111),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_pattern] = ACTIONS(125),
    [anon_sym_import] = ACTIONS(127),
    [anon_sym_newtype] = ACTIONS(129),
    [anon_sym_deriving] = ACTIONS(131),
    [anon_sym_data] = ACTIONS(133),
    [anon_sym_default] = ACTIONS(135),
    [anon_sym_class] = ACTIONS(137),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_foreign] = ACTIONS(141),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [13] = {
    [sym__topdecl] = STATE(14774),
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(114),
    [sym_variable] = STATE(3474),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3900),
    [sym_qualified_constructor] = STATE(4008),
    [sym__qcon] = STATE(3911),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(4438),
    [sym_decl_type] = STATE(14774),
    [sym_decl_tyfam] = STATE(14774),
    [sym_decl_tyinst] = STATE(14774),
    [sym_decl_role] = STATE(14774),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9527),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9527),
    [sym_exp_cond] = STATE(9527),
    [sym_exp_if_guard] = STATE(9527),
    [sym_exp_case] = STATE(9527),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9527),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9527),
    [sym__lexp] = STATE(9527),
    [sym_exp_infix] = STATE(9527),
    [sym__exp_infix] = STATE(9527),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym_decl_import] = STATE(14774),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12597),
    [sym_decl_adt] = STATE(14774),
    [sym_decl_newtype] = STATE(14774),
    [sym_decl_datafam] = STATE(14774),
    [sym_decl_datainst] = STATE(14774),
    [sym_decl_class] = STATE(14774),
    [sym__instance] = STATE(14807),
    [sym_decl_instance] = STATE(14774),
    [sym_decl_deriving] = STATE(14774),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(14774),
    [sym_fixity] = STATE(14774),
    [sym_signature] = STATE(14774),
    [sym__gendecl] = STATE(14774),
    [sym__decl_fun] = STATE(14774),
    [sym__decl] = STATE(14774),
    [sym_decl_foreign_import] = STATE(14774),
    [sym_decl_foreign_export] = STATE(14774),
    [sym__decl_foreign] = STATE(14774),
    [sym_decl_pattern] = STATE(14774),
    [sym_decl_default] = STATE(14774),
    [sym_splice] = STATE(4437),
    [sym_top_splice] = STATE(14774),
    [sym_quasiquote] = STATE(4437),
    [sym__varid] = ACTIONS(155),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(163),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(163),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(169),
    [sym_implicit_parid] = ACTIONS(171),
    [sym__conid] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_type] = ACTIONS(179),
    [anon_sym_instance] = ACTIONS(181),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_pattern] = ACTIONS(195),
    [anon_sym_import] = ACTIONS(197),
    [anon_sym_newtype] = ACTIONS(199),
    [anon_sym_deriving] = ACTIONS(201),
    [anon_sym_data] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_class] = ACTIONS(207),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_foreign] = ACTIONS(211),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(151),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [14] = {
    [sym__topdecl] = STATE(16592),
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(114),
    [sym_variable] = STATE(3474),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3900),
    [sym_qualified_constructor] = STATE(4008),
    [sym__qcon] = STATE(3911),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(4438),
    [sym_decl_type] = STATE(16592),
    [sym_decl_tyfam] = STATE(16592),
    [sym_decl_tyinst] = STATE(16592),
    [sym_decl_role] = STATE(16592),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9527),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9527),
    [sym_exp_cond] = STATE(9527),
    [sym_exp_if_guard] = STATE(9527),
    [sym_exp_case] = STATE(9527),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9527),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9527),
    [sym__lexp] = STATE(9527),
    [sym_exp_infix] = STATE(9527),
    [sym__exp_infix] = STATE(9527),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym_decl_import] = STATE(16592),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12597),
    [sym_decl_adt] = STATE(16592),
    [sym_decl_newtype] = STATE(16592),
    [sym_decl_datafam] = STATE(16592),
    [sym_decl_datainst] = STATE(16592),
    [sym_decl_class] = STATE(16592),
    [sym__instance] = STATE(14807),
    [sym_decl_instance] = STATE(16592),
    [sym_decl_deriving] = STATE(16592),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(16592),
    [sym_fixity] = STATE(16592),
    [sym_signature] = STATE(16592),
    [sym__gendecl] = STATE(16592),
    [sym__decl_fun] = STATE(16592),
    [sym__decl] = STATE(16592),
    [sym_decl_foreign_import] = STATE(16592),
    [sym_decl_foreign_export] = STATE(16592),
    [sym__decl_foreign] = STATE(16592),
    [sym_decl_pattern] = STATE(16592),
    [sym_decl_default] = STATE(16592),
    [sym_splice] = STATE(4437),
    [sym_top_splice] = STATE(16592),
    [sym_quasiquote] = STATE(4437),
    [sym__varid] = ACTIONS(155),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(163),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(163),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(167),
    [anon_sym_LPAREN] = ACTIONS(169),
    [sym_implicit_parid] = ACTIONS(171),
    [sym__conid] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_type] = ACTIONS(179),
    [anon_sym_instance] = ACTIONS(181),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_pattern] = ACTIONS(195),
    [anon_sym_import] = ACTIONS(197),
    [anon_sym_newtype] = ACTIONS(199),
    [anon_sym_deriving] = ACTIONS(201),
    [anon_sym_data] = ACTIONS(203),
    [anon_sym_default] = ACTIONS(205),
    [anon_sym_class] = ACTIONS(207),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_foreign] = ACTIONS(211),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [15] = {
    [sym__topdecl] = STATE(15808),
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(107),
    [sym_variable] = STATE(3469),
    [sym_qualified_variable] = STATE(5710),
    [sym_constructor] = STATE(3863),
    [sym_qualified_constructor] = STATE(3959),
    [sym__qcon] = STATE(3990),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4591),
    [sym_decl_type] = STATE(15808),
    [sym_decl_tyfam] = STATE(15808),
    [sym_decl_tyinst] = STATE(15808),
    [sym_decl_role] = STATE(15808),
    [sym_exp_parens] = STATE(5640),
    [sym_exp_tuple] = STATE(5640),
    [sym_exp_unboxed_tuple] = STATE(5640),
    [sym_exp_unboxed_sum] = STATE(5640),
    [sym_exp_list] = STATE(5640),
    [sym_exp_arithmetic_sequence] = STATE(5640),
    [sym_exp_list_comprehension] = STATE(5640),
    [sym_exp_section_left] = STATE(5640),
    [sym_exp_section_right] = STATE(5640),
    [sym_exp_th_quoted_name] = STATE(5640),
    [sym_exp_type_application] = STATE(956),
    [sym_exp_lambda] = STATE(9583),
    [sym_exp_let] = STATE(17912),
    [sym_exp_let_in] = STATE(9583),
    [sym_exp_cond] = STATE(9583),
    [sym_exp_if_guard] = STATE(9583),
    [sym_exp_case] = STATE(9583),
    [sym_exp_lambda_case] = STATE(956),
    [sym__do_keyword] = STATE(17914),
    [sym_do_module] = STATE(17914),
    [sym_exp_do] = STATE(956),
    [sym_exp_negation] = STATE(9583),
    [sym_exp_record] = STATE(5640),
    [sym_exp_name] = STATE(5640),
    [sym_exp_projection_selector] = STATE(5640),
    [sym__aexp_projection] = STATE(5640),
    [sym_exp_projection] = STATE(5640),
    [sym__aexp] = STATE(956),
    [sym__exp_apply] = STATE(12238),
    [sym__fexp] = STATE(9583),
    [sym__lexp] = STATE(9583),
    [sym_exp_infix] = STATE(9583),
    [sym__exp_infix] = STATE(9583),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13759),
    [sym__typed_pat] = STATE(13759),
    [sym_decl_import] = STATE(15808),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12651),
    [sym_decl_adt] = STATE(15808),
    [sym_decl_newtype] = STATE(15808),
    [sym_decl_datafam] = STATE(15808),
    [sym_decl_datainst] = STATE(15808),
    [sym_decl_class] = STATE(15808),
    [sym__instance] = STATE(14612),
    [sym_decl_instance] = STATE(15808),
    [sym_decl_deriving] = STATE(15808),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(15452),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13767),
    [sym_function] = STATE(15808),
    [sym_fixity] = STATE(15808),
    [sym_signature] = STATE(15808),
    [sym__gendecl] = STATE(15808),
    [sym__decl_fun] = STATE(15808),
    [sym__decl] = STATE(15808),
    [sym_decl_foreign_import] = STATE(15808),
    [sym_decl_foreign_export] = STATE(15808),
    [sym__decl_foreign] = STATE(15808),
    [sym_decl_pattern] = STATE(15808),
    [sym_decl_default] = STATE(15808),
    [sym_splice] = STATE(4624),
    [sym_top_splice] = STATE(15808),
    [sym_quasiquote] = STATE(4624),
    [sym__varid] = ACTIONS(5),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(13),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(13),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [sym_implicit_parid] = ACTIONS(21),
    [sym__conid] = ACTIONS(23),
    [anon_sym_LBRACK] = ACTIONS(25),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_type] = ACTIONS(29),
    [anon_sym_instance] = ACTIONS(31),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(35),
    [anon_sym_AT] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_pattern] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_newtype] = ACTIONS(55),
    [anon_sym_deriving] = ACTIONS(57),
    [anon_sym_data] = ACTIONS(59),
    [anon_sym_default] = ACTIONS(61),
    [anon_sym_class] = ACTIONS(63),
    [anon_sym_infixl] = ACTIONS(65),
    [anon_sym_infixr] = ACTIONS(65),
    [anon_sym_infix] = ACTIONS(65),
    [anon_sym_foreign] = ACTIONS(67),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [16] = {
    [sym__topdecl] = STATE(18415),
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(103),
    [sym_variable] = STATE(3554),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(4196),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(5101),
    [sym_decl_type] = STATE(18415),
    [sym_decl_tyfam] = STATE(18415),
    [sym_decl_tyinst] = STATE(18415),
    [sym_decl_role] = STATE(18415),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9676),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9676),
    [sym_exp_cond] = STATE(9676),
    [sym_exp_if_guard] = STATE(9676),
    [sym_exp_case] = STATE(9676),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9676),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9676),
    [sym__lexp] = STATE(9676),
    [sym_exp_infix] = STATE(9676),
    [sym__exp_infix] = STATE(9676),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym_decl_import] = STATE(18415),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12505),
    [sym_decl_adt] = STATE(18415),
    [sym_decl_newtype] = STATE(18415),
    [sym_decl_datafam] = STATE(18415),
    [sym_decl_datainst] = STATE(18415),
    [sym_decl_class] = STATE(18415),
    [sym__instance] = STATE(15671),
    [sym_decl_instance] = STATE(18415),
    [sym_decl_deriving] = STATE(18415),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18415),
    [sym_fixity] = STATE(18415),
    [sym_signature] = STATE(18415),
    [sym__gendecl] = STATE(18415),
    [sym__decl_fun] = STATE(18415),
    [sym__decl] = STATE(18415),
    [sym_decl_foreign_import] = STATE(18415),
    [sym_decl_foreign_export] = STATE(18415),
    [sym__decl_foreign] = STATE(18415),
    [sym_decl_pattern] = STATE(18415),
    [sym_decl_default] = STATE(18415),
    [sym_splice] = STATE(5100),
    [sym_top_splice] = STATE(18415),
    [sym_quasiquote] = STATE(5100),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(91),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(91),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(97),
    [sym_implicit_parid] = ACTIONS(99),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_type] = ACTIONS(107),
    [anon_sym_instance] = ACTIONS(111),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_pattern] = ACTIONS(125),
    [anon_sym_import] = ACTIONS(127),
    [anon_sym_newtype] = ACTIONS(129),
    [anon_sym_deriving] = ACTIONS(131),
    [anon_sym_data] = ACTIONS(133),
    [anon_sym_default] = ACTIONS(135),
    [anon_sym_class] = ACTIONS(137),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_foreign] = ACTIONS(141),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [17] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7855),
    [sym__minus] = STATE(19001),
    [sym_qualified_operator] = STATE(7833),
    [sym__qvarop_nominus] = STATE(1705),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1404),
    [sym_qualified_constructor_operator] = STATE(1404),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19218),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9189),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9189),
    [sym_exp_cond] = STATE(9189),
    [sym_exp_if_guard] = STATE(9189),
    [sym_exp_case] = STATE(9189),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9189),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9189),
    [sym__lexp] = STATE(9189),
    [sym_exp_infix] = STATE(9189),
    [sym__exp_infix] = STATE(9189),
    [sym__exp] = STATE(14209),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15787),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15787),
    [sym__typed_pat] = STATE(15787),
    [sym__nested_pat] = STATE(15787),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(929),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(243),
    [anon_sym_BQUOTE] = ACTIONS(245),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(253),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(277),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [18] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7779),
    [sym__minus] = STATE(20853),
    [sym_qualified_operator] = STATE(7833),
    [sym__qvarop_nominus] = STATE(1705),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1525),
    [sym_qualified_constructor_operator] = STATE(1525),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19218),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9189),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9189),
    [sym_exp_cond] = STATE(9189),
    [sym_exp_if_guard] = STATE(9189),
    [sym_exp_case] = STATE(9189),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9189),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9189),
    [sym__lexp] = STATE(9189),
    [sym_exp_infix] = STATE(9189),
    [sym__exp_infix] = STATE(9189),
    [sym__exp] = STATE(14209),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15461),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15461),
    [sym__typed_pat] = STATE(15461),
    [sym__nested_pat] = STATE(15461),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(939),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(285),
    [anon_sym_BQUOTE] = ACTIONS(245),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(253),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(287),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [19] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7747),
    [sym__minus] = STATE(19722),
    [sym_qualified_operator] = STATE(7758),
    [sym__qvarop_nominus] = STATE(1718),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1513),
    [sym_qualified_constructor_operator] = STATE(1513),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19843),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9191),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9191),
    [sym_exp_cond] = STATE(9191),
    [sym_exp_if_guard] = STATE(9191),
    [sym_exp_case] = STATE(9191),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9191),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9191),
    [sym__lexp] = STATE(9191),
    [sym_exp_infix] = STATE(9191),
    [sym__exp_infix] = STATE(9191),
    [sym__exp] = STATE(14408),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15454),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15454),
    [sym__typed_pat] = STATE(15454),
    [sym__nested_pat] = STATE(15454),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(918),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(289),
    [anon_sym_BQUOTE] = ACTIONS(291),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(293),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(295),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [20] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7817),
    [sym__minus] = STATE(19320),
    [sym_qualified_operator] = STATE(7723),
    [sym__qvarop_nominus] = STATE(1750),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1449),
    [sym_qualified_constructor_operator] = STATE(1449),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20192),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9135),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9135),
    [sym_exp_cond] = STATE(9135),
    [sym_exp_if_guard] = STATE(9135),
    [sym_exp_case] = STATE(9135),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9135),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9135),
    [sym__lexp] = STATE(9135),
    [sym_exp_infix] = STATE(9135),
    [sym__exp_infix] = STATE(9135),
    [sym__exp] = STATE(14014),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15787),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15787),
    [sym__typed_pat] = STATE(15787),
    [sym__nested_pat] = STATE(15787),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(893),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(297),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(303),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [21] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7710),
    [sym__minus] = STATE(20799),
    [sym_qualified_operator] = STATE(7822),
    [sym__qvarop_nominus] = STATE(1803),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1409),
    [sym_qualified_constructor_operator] = STATE(1409),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20796),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9112),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9112),
    [sym_exp_cond] = STATE(9112),
    [sym_exp_if_guard] = STATE(9112),
    [sym_exp_case] = STATE(9112),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9112),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9112),
    [sym__lexp] = STATE(9112),
    [sym_exp_infix] = STATE(9112),
    [sym__exp_infix] = STATE(9112),
    [sym__exp] = STATE(14588),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15461),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15461),
    [sym__typed_pat] = STATE(15461),
    [sym__nested_pat] = STATE(15461),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(891),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(305),
    [anon_sym_BQUOTE] = ACTIONS(307),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(309),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(311),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [22] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7719),
    [sym__minus] = STATE(20295),
    [sym_qualified_operator] = STATE(7801),
    [sym__qvarop_nominus] = STATE(1737),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1565),
    [sym_qualified_constructor_operator] = STATE(1565),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20067),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9150),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9150),
    [sym_exp_cond] = STATE(9150),
    [sym_exp_if_guard] = STATE(9150),
    [sym_exp_case] = STATE(9150),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9150),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9150),
    [sym__lexp] = STATE(9150),
    [sym_exp_infix] = STATE(9150),
    [sym__exp_infix] = STATE(9150),
    [sym__exp] = STATE(14100),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15884),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15884),
    [sym__typed_pat] = STATE(15884),
    [sym__nested_pat] = STATE(15884),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(951),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_BQUOTE] = ACTIONS(315),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(317),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(319),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [23] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7790),
    [sym__minus] = STATE(20497),
    [sym_qualified_operator] = STATE(7741),
    [sym__qvarop_nominus] = STATE(1760),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1412),
    [sym_qualified_constructor_operator] = STATE(1412),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20321),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9121),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9121),
    [sym_exp_cond] = STATE(9121),
    [sym_exp_if_guard] = STATE(9121),
    [sym_exp_case] = STATE(9121),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9121),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9121),
    [sym__lexp] = STATE(9121),
    [sym_exp_infix] = STATE(9121),
    [sym__exp_infix] = STATE(9121),
    [sym__exp] = STATE(14215),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15454),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15454),
    [sym__typed_pat] = STATE(15454),
    [sym__nested_pat] = STATE(15454),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(925),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(327),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [24] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7797),
    [sym__minus] = STATE(19412),
    [sym_qualified_operator] = STATE(7708),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1570),
    [sym_qualified_constructor_operator] = STATE(1570),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19734),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9186),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9186),
    [sym_exp_cond] = STATE(9186),
    [sym_exp_if_guard] = STATE(9186),
    [sym_exp_case] = STATE(9186),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9186),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9186),
    [sym__lexp] = STATE(9186),
    [sym_exp_infix] = STATE(9186),
    [sym__exp_infix] = STATE(9186),
    [sym__exp] = STATE(14070),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16336),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16336),
    [sym__typed_pat] = STATE(16336),
    [sym__nested_pat] = STATE(16336),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(933),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(335),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [25] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7756),
    [sym__minus] = STATE(19707),
    [sym_qualified_operator] = STATE(7794),
    [sym__qvarop_nominus] = STATE(1774),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1467),
    [sym_qualified_constructor_operator] = STATE(1467),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20531),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9072),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9072),
    [sym_exp_cond] = STATE(9072),
    [sym_exp_if_guard] = STATE(9072),
    [sym_exp_case] = STATE(9072),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9072),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9072),
    [sym__lexp] = STATE(9072),
    [sym_exp_infix] = STATE(9072),
    [sym__exp_infix] = STATE(9072),
    [sym__exp] = STATE(14423),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15787),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15787),
    [sym__typed_pat] = STATE(15787),
    [sym__nested_pat] = STATE(15787),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(940),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(337),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(341),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(343),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [26] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7804),
    [sym__minus] = STATE(19358),
    [sym_qualified_operator] = STATE(7723),
    [sym__qvarop_nominus] = STATE(1750),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1569),
    [sym_qualified_constructor_operator] = STATE(1569),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20192),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9135),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9135),
    [sym_exp_cond] = STATE(9135),
    [sym_exp_if_guard] = STATE(9135),
    [sym_exp_case] = STATE(9135),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9135),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9135),
    [sym__lexp] = STATE(9135),
    [sym_exp_infix] = STATE(9135),
    [sym__exp_infix] = STATE(9135),
    [sym__exp] = STATE(14014),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17702),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17702),
    [sym__typed_pat] = STATE(17702),
    [sym__nested_pat] = STATE(17702),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(926),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(347),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [27] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7792),
    [sym__minus] = STATE(19680),
    [sym_qualified_operator] = STATE(7708),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1403),
    [sym_qualified_constructor_operator] = STATE(1403),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19734),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9186),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9186),
    [sym_exp_cond] = STATE(9186),
    [sym_exp_if_guard] = STATE(9186),
    [sym_exp_case] = STATE(9186),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9186),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9186),
    [sym__lexp] = STATE(9186),
    [sym_exp_infix] = STATE(9186),
    [sym__exp_infix] = STATE(9186),
    [sym__exp] = STATE(14070),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17702),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17702),
    [sym__typed_pat] = STATE(17702),
    [sym__nested_pat] = STATE(17702),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(927),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(351),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [28] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7699),
    [sym__minus] = STATE(20269),
    [sym_qualified_operator] = STATE(7708),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1573),
    [sym_qualified_constructor_operator] = STATE(1573),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19734),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9186),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9186),
    [sym_exp_cond] = STATE(9186),
    [sym_exp_if_guard] = STATE(9186),
    [sym_exp_case] = STATE(9186),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9186),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9186),
    [sym__lexp] = STATE(9186),
    [sym_exp_infix] = STATE(9186),
    [sym__exp_infix] = STATE(9186),
    [sym__exp] = STATE(14070),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15884),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15884),
    [sym__typed_pat] = STATE(15884),
    [sym__nested_pat] = STATE(15884),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(897),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(355),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [29] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7813),
    [sym__minus] = STATE(20543),
    [sym_qualified_operator] = STATE(7806),
    [sym__qvarop_nominus] = STATE(1787),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1506),
    [sym_qualified_constructor_operator] = STATE(1506),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20844),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9019),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9019),
    [sym_exp_cond] = STATE(9019),
    [sym_exp_if_guard] = STATE(9019),
    [sym_exp_case] = STATE(9019),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9019),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9019),
    [sym__lexp] = STATE(9019),
    [sym_exp_infix] = STATE(9019),
    [sym__exp_infix] = STATE(9019),
    [sym__exp] = STATE(14600),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15461),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15461),
    [sym__typed_pat] = STATE(15461),
    [sym__nested_pat] = STATE(15461),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(915),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(357),
    [anon_sym_BQUOTE] = ACTIONS(359),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(363),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [30] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7715),
    [sym__minus] = STATE(19848),
    [sym_qualified_operator] = STATE(7708),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1501),
    [sym_qualified_constructor_operator] = STATE(1501),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19734),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9186),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9186),
    [sym_exp_cond] = STATE(9186),
    [sym_exp_if_guard] = STATE(9186),
    [sym_exp_case] = STATE(9186),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9186),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9186),
    [sym__lexp] = STATE(9186),
    [sym_exp_infix] = STATE(9186),
    [sym__exp_infix] = STATE(9186),
    [sym__exp] = STATE(14070),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15454),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15454),
    [sym__typed_pat] = STATE(15454),
    [sym__nested_pat] = STATE(15454),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(931),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(367),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [31] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7871),
    [sym__minus] = STATE(18966),
    [sym_qualified_operator] = STATE(7771),
    [sym__qvarop_nominus] = STATE(1724),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1509),
    [sym_qualified_constructor_operator] = STATE(1509),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19461),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9116),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9116),
    [sym_exp_cond] = STATE(9116),
    [sym_exp_if_guard] = STATE(9116),
    [sym_exp_case] = STATE(9116),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9116),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9116),
    [sym__lexp] = STATE(9116),
    [sym_exp_infix] = STATE(9116),
    [sym__exp_infix] = STATE(9116),
    [sym__exp] = STATE(14435),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15787),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15787),
    [sym__typed_pat] = STATE(15787),
    [sym__nested_pat] = STATE(15787),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(895),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(373),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(375),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [32] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7712),
    [sym__minus] = STATE(19895),
    [sym_qualified_operator] = STATE(7733),
    [sym__qvarop_nominus] = STATE(1720),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1627),
    [sym_qualified_constructor_operator] = STATE(1627),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20072),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9129),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9129),
    [sym_exp_cond] = STATE(9129),
    [sym_exp_if_guard] = STATE(9129),
    [sym_exp_case] = STATE(9129),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9129),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9129),
    [sym__lexp] = STATE(9129),
    [sym_exp_infix] = STATE(9129),
    [sym__exp_infix] = STATE(9129),
    [sym__exp] = STATE(14206),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16336),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16336),
    [sym__typed_pat] = STATE(16336),
    [sym__nested_pat] = STATE(16336),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(933),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(335),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [33] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7825),
    [sym__minus] = STATE(20040),
    [sym_qualified_operator] = STATE(7723),
    [sym__qvarop_nominus] = STATE(1750),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1641),
    [sym_qualified_constructor_operator] = STATE(1641),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20192),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9135),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9135),
    [sym_exp_cond] = STATE(9135),
    [sym_exp_if_guard] = STATE(9135),
    [sym_exp_case] = STATE(9135),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9135),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9135),
    [sym__lexp] = STATE(9135),
    [sym_exp_infix] = STATE(9135),
    [sym__exp_infix] = STATE(9135),
    [sym__exp] = STATE(14014),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15884),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15884),
    [sym__typed_pat] = STATE(15884),
    [sym__nested_pat] = STATE(15884),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(951),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(319),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [34] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7760),
    [sym__minus] = STATE(19897),
    [sym_qualified_operator] = STATE(7771),
    [sym__qvarop_nominus] = STATE(1724),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1473),
    [sym_qualified_constructor_operator] = STATE(1473),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19461),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9116),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9116),
    [sym_exp_cond] = STATE(9116),
    [sym_exp_if_guard] = STATE(9116),
    [sym_exp_case] = STATE(9116),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9116),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9116),
    [sym__lexp] = STATE(9116),
    [sym_exp_infix] = STATE(9116),
    [sym__exp_infix] = STATE(9116),
    [sym__exp] = STATE(14435),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15461),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15461),
    [sym__typed_pat] = STATE(15461),
    [sym__nested_pat] = STATE(15461),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(932),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(381),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(373),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(383),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [35] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7736),
    [sym__minus] = STATE(20126),
    [sym_qualified_operator] = STATE(7708),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1482),
    [sym_qualified_constructor_operator] = STATE(1482),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19734),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9186),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9186),
    [sym_exp_cond] = STATE(9186),
    [sym_exp_if_guard] = STATE(9186),
    [sym_exp_case] = STATE(9186),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9186),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9186),
    [sym__lexp] = STATE(9186),
    [sym_exp_infix] = STATE(9186),
    [sym__exp_infix] = STATE(9186),
    [sym__exp] = STATE(14070),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15461),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15461),
    [sym__typed_pat] = STATE(15461),
    [sym__nested_pat] = STATE(15461),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(911),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(385),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [36] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7847),
    [sym__minus] = STATE(20920),
    [sym_qualified_operator] = STATE(7723),
    [sym__qvarop_nominus] = STATE(1750),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1594),
    [sym_qualified_constructor_operator] = STATE(1594),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20192),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9135),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9135),
    [sym_exp_cond] = STATE(9135),
    [sym_exp_if_guard] = STATE(9135),
    [sym_exp_case] = STATE(9135),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9135),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9135),
    [sym__lexp] = STATE(9135),
    [sym_exp_infix] = STATE(9135),
    [sym__exp_infix] = STATE(9135),
    [sym__exp] = STATE(14014),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16336),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16336),
    [sym__typed_pat] = STATE(16336),
    [sym__nested_pat] = STATE(16336),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(902),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(391),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [37] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7821),
    [sym__minus] = STATE(19301),
    [sym_qualified_operator] = STATE(7858),
    [sym__qvarop_nominus] = STATE(1703),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1333),
    [sym_qualified_constructor_operator] = STATE(1333),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19081),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9203),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9203),
    [sym_exp_cond] = STATE(9203),
    [sym_exp_if_guard] = STATE(9203),
    [sym_exp_case] = STATE(9203),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9203),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9203),
    [sym__lexp] = STATE(9203),
    [sym_exp_infix] = STATE(9203),
    [sym__exp_infix] = STATE(9203),
    [sym__exp] = STATE(14413),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16336),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16336),
    [sym__typed_pat] = STATE(16336),
    [sym__nested_pat] = STATE(16336),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(902),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(393),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(395),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(391),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [38] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7816),
    [sym__minus] = STATE(19916),
    [sym_qualified_operator] = STATE(7788),
    [sym__qvarop_nominus] = STATE(1731),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1664),
    [sym_qualified_constructor_operator] = STATE(1664),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19947),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9163),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9163),
    [sym_exp_cond] = STATE(9163),
    [sym_exp_if_guard] = STATE(9163),
    [sym_exp_case] = STATE(9163),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9163),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9163),
    [sym__lexp] = STATE(9163),
    [sym_exp_infix] = STATE(9163),
    [sym__exp_infix] = STATE(9163),
    [sym__exp] = STATE(14239),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15454),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15454),
    [sym__typed_pat] = STATE(15454),
    [sym__nested_pat] = STATE(15454),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(931),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_BQUOTE] = ACTIONS(397),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(367),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [39] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7711),
    [sym__minus] = STATE(20162),
    [sym_qualified_operator] = STATE(7723),
    [sym__qvarop_nominus] = STATE(1750),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1538),
    [sym_qualified_constructor_operator] = STATE(1538),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20192),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9135),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9135),
    [sym_exp_cond] = STATE(9135),
    [sym_exp_if_guard] = STATE(9135),
    [sym_exp_case] = STATE(9135),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9135),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9135),
    [sym__lexp] = STATE(9135),
    [sym_exp_infix] = STATE(9135),
    [sym__exp_infix] = STATE(9135),
    [sym__exp] = STATE(14014),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15454),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15454),
    [sym__typed_pat] = STATE(15454),
    [sym__nested_pat] = STATE(15454),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(940),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(337),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(343),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [40] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7845),
    [sym__minus] = STATE(20307),
    [sym_qualified_operator] = STATE(7788),
    [sym__qvarop_nominus] = STATE(1731),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1664),
    [sym_qualified_constructor_operator] = STATE(1664),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19947),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9163),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9163),
    [sym_exp_cond] = STATE(9163),
    [sym_exp_if_guard] = STATE(9163),
    [sym_exp_case] = STATE(9163),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9163),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9163),
    [sym__lexp] = STATE(9163),
    [sym_exp_infix] = STATE(9163),
    [sym__exp_infix] = STATE(9163),
    [sym__exp] = STATE(14239),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15787),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15787),
    [sym__typed_pat] = STATE(15787),
    [sym__nested_pat] = STATE(15787),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(931),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_BQUOTE] = ACTIONS(397),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(367),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [41] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7795),
    [sym__minus] = STATE(20533),
    [sym_qualified_operator] = STATE(7723),
    [sym__qvarop_nominus] = STATE(1750),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1463),
    [sym_qualified_constructor_operator] = STATE(1463),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20192),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9135),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9135),
    [sym_exp_cond] = STATE(9135),
    [sym_exp_if_guard] = STATE(9135),
    [sym_exp_case] = STATE(9135),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9135),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9135),
    [sym__lexp] = STATE(9135),
    [sym_exp_infix] = STATE(9135),
    [sym__exp_infix] = STATE(9135),
    [sym__exp] = STATE(14014),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15461),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15461),
    [sym__typed_pat] = STATE(15461),
    [sym__nested_pat] = STATE(15461),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(903),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(403),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [42] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7852),
    [sym__minus] = STATE(19139),
    [sym_qualified_operator] = STATE(7708),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1457),
    [sym_qualified_constructor_operator] = STATE(1457),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19734),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9186),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9186),
    [sym_exp_cond] = STATE(9186),
    [sym_exp_if_guard] = STATE(9186),
    [sym_exp_case] = STATE(9186),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9186),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9186),
    [sym__lexp] = STATE(9186),
    [sym_exp_infix] = STATE(9186),
    [sym__exp_infix] = STATE(9186),
    [sym__exp] = STATE(14070),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15787),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15787),
    [sym__typed_pat] = STATE(15787),
    [sym__nested_pat] = STATE(15787),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(953),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(407),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [43] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7799),
    [sym__minus] = STATE(19588),
    [sym_qualified_operator] = STATE(7791),
    [sym__qvarop_nominus] = STATE(1758),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1345),
    [sym_qualified_constructor_operator] = STATE(1345),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19390),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9200),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9200),
    [sym_exp_cond] = STATE(9200),
    [sym_exp_if_guard] = STATE(9200),
    [sym_exp_case] = STATE(9200),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9200),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9200),
    [sym__lexp] = STATE(9200),
    [sym_exp_infix] = STATE(9200),
    [sym__exp_infix] = STATE(9200),
    [sym__exp] = STATE(14512),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15884),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15884),
    [sym__typed_pat] = STATE(15884),
    [sym__nested_pat] = STATE(15884),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(897),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(355),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [44] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(113),
    [sym_variable] = STATE(4545),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7870),
    [sym__minus] = STATE(20768),
    [sym_qualified_operator] = STATE(7794),
    [sym__qvarop_nominus] = STATE(1774),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(1467),
    [sym_qualified_constructor_operator] = STATE(1467),
    [sym__qcon] = STATE(4072),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(5172),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20531),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9072),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9072),
    [sym_exp_cond] = STATE(9072),
    [sym_exp_if_guard] = STATE(9072),
    [sym_exp_case] = STATE(9072),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9072),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9072),
    [sym__lexp] = STATE(9072),
    [sym_exp_infix] = STATE(9072),
    [sym__exp_infix] = STATE(9072),
    [sym__exp] = STATE(14423),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15454),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15454),
    [sym__typed_pat] = STATE(15454),
    [sym__nested_pat] = STATE(15454),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10268),
    [sym_splice] = STATE(5142),
    [sym_quasiquote] = STATE(5142),
    [aux_sym_con_tuple_repeat1] = STATE(940),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(235),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(235),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(241),
    [anon_sym_RPAREN] = ACTIONS(337),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(341),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(343),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [45] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20896),
    [sym__minus] = STATE(20896),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(18955),
    [sym_qualified_constructor_operator] = STATE(18955),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17707),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17707),
    [sym__typed_pat] = STATE(17707),
    [sym__nested_pat] = STATE(17707),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16886),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(419),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(427),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [46] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19709),
    [sym__minus] = STATE(19709),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19687),
    [sym_qualified_constructor_operator] = STATE(19687),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15884),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15884),
    [sym__typed_pat] = STATE(15884),
    [sym__nested_pat] = STATE(15884),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16731),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(431),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [47] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19579),
    [sym__minus] = STATE(19579),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20050),
    [sym_qualified_constructor_operator] = STATE(20050),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15461),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15461),
    [sym__typed_pat] = STATE(15461),
    [sym__nested_pat] = STATE(15461),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15615),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(385),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [48] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19403),
    [sym__minus] = STATE(19403),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19046),
    [sym_qualified_constructor_operator] = STATE(19046),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16514),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16514),
    [sym__typed_pat] = STATE(16514),
    [sym__nested_pat] = STATE(16514),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(17791),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(435),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(437),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [49] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19823),
    [sym__minus] = STATE(19823),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20176),
    [sym_qualified_constructor_operator] = STATE(20176),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16243),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16243),
    [sym__typed_pat] = STATE(16243),
    [sym__nested_pat] = STATE(16243),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(17372),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(439),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(441),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [50] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20499),
    [sym__minus] = STATE(20499),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20176),
    [sym_qualified_constructor_operator] = STATE(20176),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15787),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15787),
    [sym__typed_pat] = STATE(15787),
    [sym__nested_pat] = STATE(15787),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15899),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(443),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [51] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20337),
    [sym__minus] = STATE(20337),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19762),
    [sym_qualified_constructor_operator] = STATE(19762),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17506),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17506),
    [sym__typed_pat] = STATE(17506),
    [sym__nested_pat] = STATE(17506),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16696),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(447),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(449),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [52] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19594),
    [sym__minus] = STATE(19594),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19388),
    [sym_qualified_constructor_operator] = STATE(19388),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16539),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16539),
    [sym__typed_pat] = STATE(16539),
    [sym__nested_pat] = STATE(16539),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16299),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(451),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(453),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [53] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20647),
    [sym__minus] = STATE(20647),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19256),
    [sym_qualified_constructor_operator] = STATE(19256),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15581),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15581),
    [sym__typed_pat] = STATE(15581),
    [sym__nested_pat] = STATE(15581),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16542),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(455),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(457),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [54] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20499),
    [sym__minus] = STATE(20499),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19650),
    [sym_qualified_constructor_operator] = STATE(20176),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15787),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15787),
    [sym__typed_pat] = STATE(15787),
    [sym__nested_pat] = STATE(15787),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15899),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(443),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [55] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19656),
    [sym__minus] = STATE(19656),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20050),
    [sym_qualified_constructor_operator] = STATE(20050),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15461),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15461),
    [sym__typed_pat] = STATE(15461),
    [sym__nested_pat] = STATE(15461),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15615),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(385),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [56] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19695),
    [sym__minus] = STATE(19695),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20050),
    [sym_qualified_constructor_operator] = STATE(20050),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15461),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15461),
    [sym__typed_pat] = STATE(15461),
    [sym__nested_pat] = STATE(15461),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15615),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(385),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [57] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20553),
    [sym__minus] = STATE(20553),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20050),
    [sym_qualified_constructor_operator] = STATE(20050),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15461),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15461),
    [sym__typed_pat] = STATE(15461),
    [sym__nested_pat] = STATE(15461),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15615),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(385),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [58] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19679),
    [sym__minus] = STATE(19679),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19309),
    [sym_qualified_constructor_operator] = STATE(19309),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16365),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16365),
    [sym__typed_pat] = STATE(16365),
    [sym__nested_pat] = STATE(16365),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16789),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(459),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [59] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(18964),
    [sym__minus] = STATE(18964),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20104),
    [sym_qualified_constructor_operator] = STATE(20104),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16760),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16760),
    [sym__typed_pat] = STATE(16760),
    [sym__nested_pat] = STATE(16760),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(17575),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(463),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(465),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [60] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19365),
    [sym__minus] = STATE(19365),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20104),
    [sym_qualified_constructor_operator] = STATE(20104),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17702),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17702),
    [sym__typed_pat] = STATE(17702),
    [sym__nested_pat] = STATE(17702),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(17544),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(467),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(469),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [61] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19983),
    [sym__minus] = STATE(19983),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20050),
    [sym_qualified_constructor_operator] = STATE(20050),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15461),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15461),
    [sym__typed_pat] = STATE(15461),
    [sym__nested_pat] = STATE(15461),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15615),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(385),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [62] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20499),
    [sym__minus] = STATE(20499),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19571),
    [sym_qualified_constructor_operator] = STATE(20176),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15787),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15787),
    [sym__typed_pat] = STATE(15787),
    [sym__nested_pat] = STATE(15787),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15899),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(443),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [63] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20499),
    [sym__minus] = STATE(20499),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20885),
    [sym_qualified_constructor_operator] = STATE(20885),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15787),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15787),
    [sym__typed_pat] = STATE(15787),
    [sym__nested_pat] = STATE(15787),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15899),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(443),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [64] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19314),
    [sym__minus] = STATE(19314),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20615),
    [sym_qualified_constructor_operator] = STATE(20615),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17294),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17294),
    [sym__typed_pat] = STATE(17294),
    [sym__nested_pat] = STATE(17294),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15936),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(471),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(473),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [65] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20779),
    [sym__minus] = STATE(20779),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20304),
    [sym_qualified_constructor_operator] = STATE(20304),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15626),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15626),
    [sym__typed_pat] = STATE(15626),
    [sym__nested_pat] = STATE(15626),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15800),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(475),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(477),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [66] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20414),
    [sym__minus] = STATE(20414),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19309),
    [sym_qualified_constructor_operator] = STATE(19309),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15763),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15763),
    [sym__typed_pat] = STATE(15763),
    [sym__nested_pat] = STATE(15763),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16550),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(479),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(481),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [67] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19017),
    [sym__minus] = STATE(19017),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19425),
    [sym_qualified_constructor_operator] = STATE(19425),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17040),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17040),
    [sym__typed_pat] = STATE(17040),
    [sym__nested_pat] = STATE(17040),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15841),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(483),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(485),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [68] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19896),
    [sym__minus] = STATE(19896),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19247),
    [sym_qualified_constructor_operator] = STATE(19247),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16170),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16170),
    [sym__typed_pat] = STATE(16170),
    [sym__nested_pat] = STATE(16170),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16774),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(487),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(489),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [69] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19837),
    [sym__minus] = STATE(19837),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19762),
    [sym_qualified_constructor_operator] = STATE(19762),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16336),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16336),
    [sym__typed_pat] = STATE(16336),
    [sym__nested_pat] = STATE(16336),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16506),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(491),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(493),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [70] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20298),
    [sym__minus] = STATE(20298),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20050),
    [sym_qualified_constructor_operator] = STATE(20050),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15967),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15967),
    [sym__typed_pat] = STATE(15967),
    [sym__nested_pat] = STATE(15967),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15979),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(495),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(497),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [71] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19314),
    [sym__minus] = STATE(19314),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19565),
    [sym_qualified_constructor_operator] = STATE(19565),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17294),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17294),
    [sym__typed_pat] = STATE(17294),
    [sym__nested_pat] = STATE(17294),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15936),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(471),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(473),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [72] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20553),
    [sym__minus] = STATE(20553),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20805),
    [sym_qualified_constructor_operator] = STATE(20805),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15461),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15461),
    [sym__typed_pat] = STATE(15461),
    [sym__nested_pat] = STATE(15461),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15615),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(385),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [73] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19304),
    [sym__minus] = STATE(19304),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19284),
    [sym_qualified_constructor_operator] = STATE(19284),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16882),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16882),
    [sym__typed_pat] = STATE(16882),
    [sym__nested_pat] = STATE(16882),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15699),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(499),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(501),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [74] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19304),
    [sym__minus] = STATE(19304),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(18955),
    [sym_qualified_constructor_operator] = STATE(18955),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16882),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16882),
    [sym__typed_pat] = STATE(16882),
    [sym__nested_pat] = STATE(16882),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15699),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(499),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(501),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [75] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19919),
    [sym__minus] = STATE(19919),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19029),
    [sym_qualified_constructor_operator] = STATE(19029),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16149),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16149),
    [sym__typed_pat] = STATE(16149),
    [sym__nested_pat] = STATE(16149),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16583),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(503),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(505),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [76] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20110),
    [sym__minus] = STATE(20110),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19055),
    [sym_qualified_constructor_operator] = STATE(19055),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15990),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15990),
    [sym__typed_pat] = STATE(15990),
    [sym__nested_pat] = STATE(15990),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16704),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(507),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(509),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [77] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19896),
    [sym__minus] = STATE(19896),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19256),
    [sym_qualified_constructor_operator] = STATE(19256),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16170),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16170),
    [sym__typed_pat] = STATE(16170),
    [sym__nested_pat] = STATE(16170),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16774),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(487),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(489),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [78] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19118),
    [sym__minus] = STATE(19118),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19046),
    [sym_qualified_constructor_operator] = STATE(19046),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17428),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17428),
    [sym__typed_pat] = STATE(17428),
    [sym__nested_pat] = STATE(17428),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15746),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(511),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [79] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20423),
    [sym__minus] = STATE(20423),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19046),
    [sym_qualified_constructor_operator] = STATE(19046),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17428),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17428),
    [sym__typed_pat] = STATE(17428),
    [sym__nested_pat] = STATE(17428),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15746),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(511),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [80] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20672),
    [sym__minus] = STATE(20672),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19046),
    [sym_qualified_constructor_operator] = STATE(19046),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17428),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17428),
    [sym__typed_pat] = STATE(17428),
    [sym__nested_pat] = STATE(17428),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15746),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(511),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [81] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19679),
    [sym__minus] = STATE(19679),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19232),
    [sym_qualified_constructor_operator] = STATE(19232),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16365),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16365),
    [sym__typed_pat] = STATE(16365),
    [sym__nested_pat] = STATE(16365),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16789),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(459),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(461),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [82] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20042),
    [sym__minus] = STATE(20042),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19029),
    [sym_qualified_constructor_operator] = STATE(19029),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15454),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15454),
    [sym__typed_pat] = STATE(15454),
    [sym__nested_pat] = STATE(15454),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16259),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(513),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(515),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [83] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19709),
    [sym__minus] = STATE(19709),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19388),
    [sym_qualified_constructor_operator] = STATE(19388),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15884),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15884),
    [sym__typed_pat] = STATE(15884),
    [sym__nested_pat] = STATE(15884),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16731),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(429),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(431),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [84] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20705),
    [sym__minus] = STATE(20705),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20786),
    [sym_qualified_constructor_operator] = STATE(20786),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17174),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17174),
    [sym__typed_pat] = STATE(17174),
    [sym__nested_pat] = STATE(17174),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(17358),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(517),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(519),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [85] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20042),
    [sym__minus] = STATE(20042),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19199),
    [sym_qualified_constructor_operator] = STATE(19199),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15454),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15454),
    [sym__typed_pat] = STATE(15454),
    [sym__nested_pat] = STATE(15454),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16259),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(513),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(515),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [86] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20499),
    [sym__minus] = STATE(20499),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20405),
    [sym_qualified_constructor_operator] = STATE(20176),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15787),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15787),
    [sym__typed_pat] = STATE(15787),
    [sym__nested_pat] = STATE(15787),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15899),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(443),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [87] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19365),
    [sym__minus] = STATE(19365),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20018),
    [sym_qualified_constructor_operator] = STATE(20018),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17702),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17702),
    [sym__typed_pat] = STATE(17702),
    [sym__nested_pat] = STATE(17702),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(17544),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(467),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(469),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [88] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19837),
    [sym__minus] = STATE(19837),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19880),
    [sym_qualified_constructor_operator] = STATE(19880),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16336),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16336),
    [sym__typed_pat] = STATE(16336),
    [sym__nested_pat] = STATE(16336),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16506),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(491),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(493),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [89] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19118),
    [sym__minus] = STATE(19118),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20630),
    [sym_qualified_constructor_operator] = STATE(20630),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17428),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17428),
    [sym__typed_pat] = STATE(17428),
    [sym__nested_pat] = STATE(17428),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15746),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(511),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [90] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20772),
    [sym__minus] = STATE(20772),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19055),
    [sym_qualified_constructor_operator] = STATE(19055),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15448),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15448),
    [sym__typed_pat] = STATE(15448),
    [sym__nested_pat] = STATE(15448),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16532),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(521),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(523),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [91] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20110),
    [sym__minus] = STATE(20110),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19292),
    [sym_qualified_constructor_operator] = STATE(19292),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15990),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15990),
    [sym__typed_pat] = STATE(15990),
    [sym__nested_pat] = STATE(15990),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16704),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(507),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(509),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [92] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19017),
    [sym__minus] = STATE(19017),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20786),
    [sym_qualified_constructor_operator] = STATE(20786),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17040),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17040),
    [sym__typed_pat] = STATE(17040),
    [sym__nested_pat] = STATE(17040),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(15841),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(483),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(485),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [93] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19929),
    [sym__minus] = STATE(19929),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(20615),
    [sym_qualified_constructor_operator] = STATE(20615),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16909),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16909),
    [sym__typed_pat] = STATE(16909),
    [sym__nested_pat] = STATE(16909),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(17389),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(525),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(527),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [94] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20164),
    [sym__minus] = STATE(20164),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym_constructor_operator] = STATE(19923),
    [sym_qualified_constructor_operator] = STATE(19923),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16052),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16052),
    [sym__typed_pat] = STATE(16052),
    [sym__nested_pat] = STATE(16052),
    [sym__modid] = STATE(20542),
    [aux_sym__qualifying_module] = STATE(12157),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [aux_sym_con_tuple_repeat1] = STATE(16083),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(415),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RPAREN] = ACTIONS(529),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [95] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20181),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12807),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14085),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20180),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14085),
    [sym__typed_pat] = STATE(14085),
    [sym__nested_pat] = STATE(14085),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(15890),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(583),
  },
  [96] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19354),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12931),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14085),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20180),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14085),
    [sym__typed_pat] = STATE(14085),
    [sym__nested_pat] = STATE(14085),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(16563),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(585),
  },
  [97] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19720),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12744),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14204),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20310),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14204),
    [sym__typed_pat] = STATE(14204),
    [sym__nested_pat] = STATE(14204),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(16255),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(587),
  },
  [98] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19720),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12744),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14590),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20817),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14590),
    [sym__typed_pat] = STATE(14590),
    [sym__nested_pat] = STATE(14590),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(16255),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(589),
  },
  [99] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19833),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12783),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14590),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20817),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14590),
    [sym__typed_pat] = STATE(14590),
    [sym__nested_pat] = STATE(14590),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(16155),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(591),
  },
  [100] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20181),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12807),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14590),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20817),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14590),
    [sym__typed_pat] = STATE(14590),
    [sym__nested_pat] = STATE(14590),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(15890),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(593),
  },
  [101] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19932),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12929),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14204),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20310),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14204),
    [sym__typed_pat] = STATE(14204),
    [sym__nested_pat] = STATE(14204),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(16071),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(595),
  },
  [102] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19720),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12744),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14197),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20866),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14197),
    [sym__typed_pat] = STATE(14197),
    [sym__nested_pat] = STATE(14197),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(16255),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(597),
  },
  [103] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20181),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12807),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14489),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20619),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14489),
    [sym__typed_pat] = STATE(14489),
    [sym__nested_pat] = STATE(14489),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(15890),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(599),
  },
  [104] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20004),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12982),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14389),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19608),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14389),
    [sym__typed_pat] = STATE(14389),
    [sym__nested_pat] = STATE(14389),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(17404),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(601),
  },
  [105] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19406),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12976),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14489),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20619),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14489),
    [sym__typed_pat] = STATE(14489),
    [sym__nested_pat] = STATE(14489),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(17025),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(603),
  },
  [106] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20056),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12827),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14085),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20180),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14085),
    [sym__typed_pat] = STATE(14085),
    [sym__nested_pat] = STATE(14085),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(15974),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(605),
  },
  [107] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20623),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12774),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14489),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20619),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14489),
    [sym__typed_pat] = STATE(14489),
    [sym__nested_pat] = STATE(14489),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(15551),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(607),
  },
  [108] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20312),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12857),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14590),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20817),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14590),
    [sym__typed_pat] = STATE(14590),
    [sym__nested_pat] = STATE(14590),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(15796),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(609),
  },
  [109] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19260),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12907),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14204),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20310),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14204),
    [sym__typed_pat] = STATE(14204),
    [sym__nested_pat] = STATE(14204),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(17069),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(611),
  },
  [110] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20820),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(13015),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14489),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20619),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14489),
    [sym__typed_pat] = STATE(14489),
    [sym__nested_pat] = STATE(14489),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(15459),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(613),
  },
  [111] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20181),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12807),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14197),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20866),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14197),
    [sym__typed_pat] = STATE(14197),
    [sym__nested_pat] = STATE(14197),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(15890),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(615),
  },
  [112] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19406),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12976),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14204),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20310),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14204),
    [sym__typed_pat] = STATE(14204),
    [sym__nested_pat] = STATE(14204),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(17025),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(617),
  },
  [113] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20513),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(13070),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14590),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20817),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14590),
    [sym__typed_pat] = STATE(14590),
    [sym__nested_pat] = STATE(14590),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(15640),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(619),
  },
  [114] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19260),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12907),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14489),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20619),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14489),
    [sym__typed_pat] = STATE(14489),
    [sym__nested_pat] = STATE(14489),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(17069),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(621),
  },
  [115] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19720),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12744),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14489),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20619),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14489),
    [sym__typed_pat] = STATE(14489),
    [sym__nested_pat] = STATE(14489),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(16255),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(623),
  },
  [116] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19054),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(13079),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14389),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19608),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14389),
    [sym__typed_pat] = STATE(14389),
    [sym__nested_pat] = STATE(14389),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(16786),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(625),
  },
  [117] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20513),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(13070),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14204),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20310),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14204),
    [sym__typed_pat] = STATE(14204),
    [sym__nested_pat] = STATE(14204),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(15640),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(627),
  },
  [118] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19720),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12744),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14085),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20180),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14085),
    [sym__typed_pat] = STATE(14085),
    [sym__nested_pat] = STATE(14085),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(16255),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(629),
  },
  [119] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19932),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12929),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14590),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20817),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14590),
    [sym__typed_pat] = STATE(14590),
    [sym__nested_pat] = STATE(14590),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(16071),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(631),
  },
  [120] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20181),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12807),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14204),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20310),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14204),
    [sym__typed_pat] = STATE(14204),
    [sym__nested_pat] = STATE(14204),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(15890),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(633),
  },
  [121] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19720),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12744),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14389),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19608),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14389),
    [sym__typed_pat] = STATE(14389),
    [sym__nested_pat] = STATE(14389),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(16255),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(635),
  },
  [122] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(106),
    [sym_variable] = STATE(4264),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(4000),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4539),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20181),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(12807),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14389),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19608),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14389),
    [sym__typed_pat] = STATE(14389),
    [sym__nested_pat] = STATE(14389),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12722),
    [sym_splice] = STATE(4536),
    [sym_quasiquote] = STATE(4536),
    [aux_sym__exp_tuple_repeat1] = STATE(15890),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(541),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(541),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(545),
    [anon_sym_LPAREN] = ACTIONS(547),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(551),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(555),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(637),
  },
  [123] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15963),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(641),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(659),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [124] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16244),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [125] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15864),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [126] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16465),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [127] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15634),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [128] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16266),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(693),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(695),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [129] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16058),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(697),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(699),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [130] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16048),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [131] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15548),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(701),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [132] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(17390),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(705),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(707),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [133] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15503),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [134] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15583),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(709),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(711),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [135] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16666),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [136] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15490),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [137] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15673),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(713),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(715),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [138] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15588),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [139] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16009),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(717),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(719),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [140] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16153),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(721),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(723),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [141] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16818),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(725),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(727),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [142] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16067),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(729),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(731),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [143] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16839),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [144] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16475),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(733),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(735),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [145] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15683),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [146] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(17035),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [147] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16293),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(737),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(739),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [148] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15778),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [149] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(17285),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [150] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15873),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [151] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(17310),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(741),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(743),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [152] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15968),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [153] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(17537),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [154] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16400),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(745),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(747),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [155] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16063),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [156] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15891),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(749),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [157] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15868),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(753),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(755),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [158] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(17802),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [159] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16158),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [160] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(17638),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [161] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16253),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [162] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16248),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(757),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(759),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [163] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16348),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [164] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16443),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [165] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16538),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [166] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(17414),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [167] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16633),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [168] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15492),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(761),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(763),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [169] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16728),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [170] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(17184),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(765),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [171] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(17193),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [172] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15643),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(769),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(771),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [173] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15827),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(773),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(775),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [174] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16823),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [175] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16918),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [176] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15773),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(777),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(779),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [177] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(17013),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [178] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16677),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(781),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(783),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [179] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(17106),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [180] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16912),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [181] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16913),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(785),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(787),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [182] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(17189),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [183] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16343),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(789),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(791),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [184] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16438),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(793),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [185] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16635),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(797),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [186] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16672),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [187] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(17612),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(801),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(803),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [188] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16409),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [189] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15924),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(805),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(807),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [190] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16303),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [191] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15515),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(809),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(811),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [192] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(17039),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(813),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(815),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [193] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16188),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(817),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(819),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [194] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16194),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [195] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15678),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(821),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(823),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [196] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16122),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [197] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15502),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [198] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(17101),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(825),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(827),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [199] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16533),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(829),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(831),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [200] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(17567),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(833),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(835),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [201] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15946),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [202] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(17045),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(837),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [203] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16847),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(841),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(843),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [204] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16883),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(845),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(847),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [205] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(16022),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [206] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16723),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(849),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(851),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [207] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16112),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(853),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(855),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [208] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(18592),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [209] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(16628),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [210] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15484),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(863),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [211] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(17159),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(865),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(867),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [212] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15934),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [213] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(17008),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(869),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(871),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [214] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15839),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [215] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(17789),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(873),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(875),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [216] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_bind_pattern] = STATE(18299),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_transform] = STATE(18299),
    [sym_qual] = STATE(15680),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_let] = STATE(18299),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18306),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16312),
    [sym__typed_pat] = STATE(16312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_thengroupby] = ACTIONS(685),
    [anon_sym_thengroupusing] = ACTIONS(687),
    [anon_sym_then] = ACTIONS(689),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [217] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(15872),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [anon_sym_SEMI] = ACTIONS(877),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(879),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [218] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14858),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(791),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [219] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [220] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15024),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(867),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [221] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(911),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [222] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(913),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [223] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(913),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [224] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15239),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(879),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [225] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(915),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [226] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14617),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(851),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [227] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15143),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(751),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [228] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15105),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(743),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [229] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(917),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [230] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(917),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [231] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(919),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [232] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(921),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [233] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(923),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [234] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [235] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(925),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [236] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14200),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19944),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14200),
    [sym__typed_pat] = STATE(14200),
    [sym__nested_pat] = STATE(14200),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(937),
  },
  [237] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [238] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(925),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [239] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(939),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [240] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(941),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [241] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [242] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14456),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19783),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14456),
    [sym__typed_pat] = STATE(14456),
    [sym__nested_pat] = STATE(14456),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(943),
  },
  [243] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(911),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [244] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14010),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20055),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14010),
    [sym__typed_pat] = STATE(14010),
    [sym__nested_pat] = STATE(14010),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(945),
  },
  [245] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15312),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(711),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [246] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14249),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20054),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14249),
    [sym__typed_pat] = STATE(14249),
    [sym__nested_pat] = STATE(14249),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(947),
  },
  [247] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(949),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [248] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(951),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [249] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(949),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [250] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(953),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [251] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(951),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [252] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(953),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [253] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14824),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(739),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [254] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(955),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [255] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(957),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [256] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(959),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [257] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(955),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [258] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(961),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [259] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(963),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [260] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14920),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(839),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [261] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(965),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [262] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(959),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [263] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14197),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20866),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14197),
    [sym__typed_pat] = STATE(14197),
    [sym__nested_pat] = STATE(14197),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(967),
  },
  [264] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(969),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [265] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(969),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [266] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14676),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(859),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [267] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15407),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(875),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [268] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14902),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(871),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [269] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(965),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [270] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(971),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [271] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(971),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [272] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(973),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [273] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [274] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(975),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [275] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(977),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [276] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(979),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [277] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(957),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [278] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(981),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [279] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(983),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [280] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(981),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [281] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(985),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [282] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(985),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [283] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(987),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [284] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14297),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19931),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14297),
    [sym__typed_pat] = STATE(14297),
    [sym__nested_pat] = STATE(14297),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(989),
  },
  [285] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14726),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(843),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [286] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(991),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [287] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(987),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [288] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(993),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [289] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15354),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(847),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [290] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(979),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [291] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(995),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [292] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(997),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [293] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(995),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [294] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(983),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [295] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(999),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [296] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(999),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [297] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15101),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(659),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [298] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(977),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [299] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(961),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [300] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1001),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [301] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15016),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(831),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [302] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [303] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1003),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [304] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15028),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(731),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [305] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1005),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [306] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1005),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [307] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15428),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(863),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [308] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14957),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(827),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [309] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1003),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [310] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1007),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [311] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1001),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [312] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1009),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [313] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15262),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(835),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [314] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(991),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [315] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14065),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20607),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14065),
    [sym__typed_pat] = STATE(14065),
    [sym__nested_pat] = STATE(14065),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1011),
  },
  [316] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14243),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19264),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14243),
    [sym__typed_pat] = STATE(14243),
    [sym__nested_pat] = STATE(14243),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1013),
  },
  [317] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14960),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(855),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [318] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1015),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [319] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1017),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [320] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15325),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(719),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [321] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1019),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [322] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1007),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [323] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1019),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [324] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1021),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [325] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1023),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [326] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1025),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [327] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1017),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [328] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [329] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1015),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [330] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1009),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [331] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1025),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [332] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1029),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [333] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1031),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [334] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1023),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [335] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14345),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19851),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14345),
    [sym__typed_pat] = STATE(14345),
    [sym__nested_pat] = STATE(14345),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1033),
  },
  [336] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(13990),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20838),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(13990),
    [sym__typed_pat] = STATE(13990),
    [sym__nested_pat] = STATE(13990),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1035),
  },
  [337] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1029),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [338] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1021),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [339] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1031),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [340] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1037),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [341] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1039),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [342] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1039),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [343] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1041),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [344] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1041),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [345] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1027),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [346] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(993),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [347] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15201),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(775),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [348] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1043),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [349] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1045),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [350] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14490),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19719),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14490),
    [sym__typed_pat] = STATE(14490),
    [sym__nested_pat] = STATE(14490),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1047),
  },
  [351] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1045),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [352] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1049),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [353] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14978),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(723),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [354] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14604),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19101),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14604),
    [sym__typed_pat] = STATE(14604),
    [sym__nested_pat] = STATE(14604),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1051),
  },
  [355] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15333),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(807),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [356] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1053),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [357] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1049),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [358] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1043),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [359] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1055),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [360] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1057),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [361] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1053),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [362] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1057),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [363] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1059),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [364] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [365] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1059),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [366] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14204),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20310),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14204),
    [sym__typed_pat] = STATE(14204),
    [sym__nested_pat] = STATE(14204),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1061),
  },
  [367] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14411),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20510),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14411),
    [sym__typed_pat] = STATE(14411),
    [sym__nested_pat] = STATE(14411),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1063),
  },
  [368] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15237),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(823),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [369] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15149),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(755),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [370] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1065),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [371] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1055),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [372] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1067),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [373] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15259),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(799),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [374] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1069),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [375] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14799),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(795),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [376] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1067),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [377] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15031),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(699),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [378] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1071),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [379] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1071),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [380] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14762),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(707),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [381] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1073),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [382] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14624),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(819),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [383] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1075),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [384] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1077),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [385] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1079),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [386] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1081),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [387] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1079),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [388] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1083),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [389] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1073),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [390] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1077),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [391] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1085),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [392] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14563),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19832),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14563),
    [sym__typed_pat] = STATE(14563),
    [sym__nested_pat] = STATE(14563),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1087),
  },
  [393] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1089),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [394] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1081),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [395] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14908),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(695),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [396] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1085),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [397] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1091),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [398] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1069),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [399] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [400] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15203),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(815),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [401] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(909),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [402] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1093),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [403] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1095),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [404] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1097),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [405] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14647),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(783),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [406] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1095),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [407] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1091),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [408] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15369),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(811),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [409] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1083),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [410] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1099),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [411] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [412] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(919),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [413] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1099),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [414] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1075),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [415] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1101),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [416] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14001),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19052),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14001),
    [sym__typed_pat] = STATE(14001),
    [sym__nested_pat] = STATE(14001),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1103),
  },
  [417] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14064),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20597),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14064),
    [sym__typed_pat] = STATE(14064),
    [sym__nested_pat] = STATE(14064),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1105),
  },
  [418] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1097),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [419] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1107),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [420] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1089),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [421] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14851),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(803),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [422] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1109),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [423] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14470),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19082),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14470),
    [sym__typed_pat] = STATE(14470),
    [sym__nested_pat] = STATE(14470),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1111),
  },
  [424] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14660),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(763),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [425] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1109),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [426] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1107),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [427] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(915),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [428] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1113),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [429] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1101),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [430] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1115),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [431] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14758),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(703),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [432] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [433] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1113),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [434] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1119),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [435] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1117),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [436] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1115),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [437] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1119),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [438] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14982),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(715),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [439] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1121),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [440] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1121),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [441] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1123),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [442] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1123),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [443] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1125),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [444] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1127),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [445] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1129),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [446] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1127),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [447] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1125),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [448] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14419),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19636),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14419),
    [sym__typed_pat] = STATE(14419),
    [sym__nested_pat] = STATE(14419),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1131),
  },
  [449] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1037),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [450] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15192),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(779),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [451] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1133),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [452] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14914),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(759),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [453] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1133),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [454] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1129),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [455] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1135),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [456] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14489),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20619),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14489),
    [sym__typed_pat] = STATE(14489),
    [sym__nested_pat] = STATE(14489),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1137),
  },
  [457] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1135),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [458] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1139),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [459] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14389),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19608),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14389),
    [sym__typed_pat] = STATE(14389),
    [sym__nested_pat] = STATE(14389),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1141),
  },
  [460] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15256),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(771),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [461] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14207),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19344),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14207),
    [sym__typed_pat] = STATE(14207),
    [sym__nested_pat] = STATE(14207),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1143),
  },
  [462] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14085),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20180),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14085),
    [sym__typed_pat] = STATE(14085),
    [sym__nested_pat] = STATE(14085),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1145),
  },
  [463] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14590),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20817),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14590),
    [sym__typed_pat] = STATE(14590),
    [sym__nested_pat] = STATE(14590),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1147),
  },
  [464] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1149),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [465] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1139),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [466] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1151),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [467] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1151),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [468] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1149),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [469] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15344),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(767),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [470] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1153),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [471] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1153),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [472] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(963),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [473] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14140),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20383),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14140),
    [sym__typed_pat] = STATE(14140),
    [sym__nested_pat] = STATE(14140),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1155),
  },
  [474] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(921),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [475] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14508),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19364),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14508),
    [sym__typed_pat] = STATE(14508),
    [sym__nested_pat] = STATE(14508),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1157),
  },
  [476] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14335),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(19401),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14335),
    [sym__typed_pat] = STATE(14335),
    [sym__nested_pat] = STATE(14335),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1159),
  },
  [477] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(15042),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(747),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [478] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1161),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [479] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14832),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(787),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [480] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1161),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [481] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(14554),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym__pat_unboxed_sum] = STATE(20249),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(14554),
    [sym__typed_pat] = STATE(14554),
    [sym__nested_pat] = STATE(14554),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [aux_sym__pat_unboxed_sum_repeat1] = STATE(15553),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
    [sym__unboxed_close] = ACTIONS(1163),
  },
  [482] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14781),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(735),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [483] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_RBRACE] = ACTIONS(1165),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [484] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(14695),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(727),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [485] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(1165),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [486] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(109),
    [sym_variable] = STATE(4242),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(3885),
    [sym_qualified_constructor] = STATE(3923),
    [sym__qcon] = STATE(3937),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(4677),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_bind_pattern] = STATE(15863),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_let] = STATE(15863),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym_rec] = STATE(15863),
    [sym_stmt] = STATE(17041),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(15867),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(15870),
    [sym__typed_pat] = STATE(15870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12625),
    [sym_splice] = STATE(4675),
    [sym_quasiquote] = STATE(4675),
    [sym__varid] = ACTIONS(881),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(889),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(889),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(893),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_rec] = ACTIONS(901),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [487] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(120),
    [sym_variable] = STATE(4674),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(4088),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(5193),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_bind_pattern] = STATE(18720),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_let] = STATE(18720),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym_rec] = STATE(18720),
    [sym_stmt] = STATE(18768),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18716),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(13745),
    [sym__pat] = STATE(13745),
    [sym_pat_typed] = STATE(16388),
    [sym__typed_pat] = STATE(16388),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12569),
    [sym_splice] = STATE(5195),
    [sym_quasiquote] = STATE(5195),
    [sym__varid] = ACTIONS(639),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(649),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(649),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(651),
    [anon_sym_LPAREN] = ACTIONS(653),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(657),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(663),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_rec] = ACTIONS(665),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [488] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(116),
    [sym_variable] = STATE(4838),
    [sym_qualified_variable] = STATE(5085),
    [sym_constructor] = STATE(3969),
    [sym_qualified_constructor] = STATE(4192),
    [sym__qcon] = STATE(4145),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(4914),
    [sym_exp_parens] = STATE(4915),
    [sym_exp_tuple] = STATE(4915),
    [sym_exp_unboxed_tuple] = STATE(4915),
    [sym_exp_unboxed_sum] = STATE(4915),
    [sym_exp_list] = STATE(4915),
    [sym_exp_arithmetic_sequence] = STATE(4915),
    [sym_exp_list_comprehension] = STATE(4915),
    [sym_exp_section_left] = STATE(4915),
    [sym_exp_section_right] = STATE(4915),
    [sym_exp_th_quoted_name] = STATE(4915),
    [sym_exp_type_application] = STATE(943),
    [sym_exp_lambda] = STATE(9117),
    [sym_exp_let] = STATE(18386),
    [sym_exp_let_in] = STATE(9117),
    [sym_exp_cond] = STATE(9117),
    [sym_exp_if_guard] = STATE(9117),
    [sym_exp_case] = STATE(9117),
    [sym_exp_lambda_case] = STATE(943),
    [sym__do_keyword] = STATE(18435),
    [sym_do_module] = STATE(18435),
    [sym_exp_do] = STATE(943),
    [sym_exp_negation] = STATE(9117),
    [sym_exp_record] = STATE(4915),
    [sym_exp_name] = STATE(4915),
    [sym_exp_projection_selector] = STATE(4915),
    [sym__aexp_projection] = STATE(4915),
    [sym_exp_projection] = STATE(4915),
    [sym__aexp] = STATE(943),
    [sym__exp_apply] = STATE(12078),
    [sym__fexp] = STATE(9117),
    [sym__lexp] = STATE(9117),
    [sym_exp_infix] = STATE(9117),
    [sym__exp_infix] = STATE(9117),
    [sym__exp] = STATE(14163),
    [sym_pat_as] = STATE(11761),
    [sym_pat_parens] = STATE(11761),
    [sym_pat_view] = STATE(18198),
    [sym_pat_tuple] = STATE(11761),
    [sym_pat_unboxed_tuple] = STATE(11761),
    [sym_pat_unboxed_sum] = STATE(11761),
    [sym_pat_list] = STATE(11761),
    [sym_pat_strict] = STATE(11761),
    [sym_pat_irrefutable] = STATE(11761),
    [sym_pat_negation] = STATE(11761),
    [sym_pat_name] = STATE(11761),
    [sym__pat_constructor] = STATE(2881),
    [sym_pat_wildcard] = STATE(11761),
    [sym_pat_record] = STATE(11761),
    [sym__apat] = STATE(11761),
    [sym_pat_apply] = STATE(11761),
    [sym__lpat] = STATE(11761),
    [sym_pat_infix] = STATE(13474),
    [sym__pat] = STATE(13474),
    [sym_pat_typed] = STATE(18198),
    [sym__typed_pat] = STATE(18198),
    [sym__nested_pat] = STATE(18198),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12698),
    [sym_splice] = STATE(4919),
    [sym_quasiquote] = STATE(4919),
    [sym__varid] = ACTIONS(1167),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(1175),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1175),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1179),
    [anon_sym_LPAREN] = ACTIONS(1181),
    [sym_implicit_parid] = ACTIONS(1177),
    [sym__conid] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1185),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1189),
    [anon_sym__] = ACTIONS(1192),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_mdo] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
    [sym__strict] = ACTIONS(1212),
    [sym__lazy] = ACTIONS(1214),
    [sym__unboxed_close] = ACTIONS(1189),
  },
  [489] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(122),
    [sym_variable] = STATE(4388),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3969),
    [sym_qualified_constructor] = STATE(4192),
    [sym__qcon] = STATE(4194),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(5348),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16320),
    [sym_pat_as] = STATE(11761),
    [sym_pat_parens] = STATE(11761),
    [sym_pat_view] = STATE(18198),
    [sym_pat_tuple] = STATE(11761),
    [sym_pat_unboxed_tuple] = STATE(11761),
    [sym_pat_unboxed_sum] = STATE(11761),
    [sym_pat_list] = STATE(11761),
    [sym_pat_strict] = STATE(11761),
    [sym_pat_irrefutable] = STATE(11761),
    [sym_pat_negation] = STATE(11761),
    [sym_pat_name] = STATE(11761),
    [sym__pat_constructor] = STATE(2881),
    [sym_pat_wildcard] = STATE(11761),
    [sym_pat_record] = STATE(11761),
    [sym__apat] = STATE(11761),
    [sym_pat_apply] = STATE(11761),
    [sym__lpat] = STATE(11761),
    [sym_pat_infix] = STATE(13474),
    [sym__pat] = STATE(13474),
    [sym_pat_typed] = STATE(18198),
    [sym__typed_pat] = STATE(18198),
    [sym__nested_pat] = STATE(18198),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12581),
    [sym_splice] = STATE(5342),
    [sym_quasiquote] = STATE(5342),
    [sym__varid] = ACTIONS(1167),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(1216),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1216),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_LPAREN] = ACTIONS(1220),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1224),
    [anon_sym__] = ACTIONS(1192),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
    [sym__strict] = ACTIONS(1212),
    [sym__lazy] = ACTIONS(1214),
    [sym__unboxed_close] = ACTIONS(1224),
  },
  [490] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12711),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15455),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15455),
    [sym__typed_pat] = STATE(15455),
    [sym__nested_pat] = STATE(15455),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [491] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12564),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15789),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15789),
    [sym__typed_pat] = STATE(15789),
    [sym__nested_pat] = STATE(15789),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1268),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [492] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12564),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15455),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15455),
    [sym__typed_pat] = STATE(15455),
    [sym__nested_pat] = STATE(15455),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1268),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [493] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12617),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15789),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15789),
    [sym__typed_pat] = STATE(15789),
    [sym__nested_pat] = STATE(15789),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1270),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [494] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15455),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15455),
    [sym__typed_pat] = STATE(15455),
    [sym__nested_pat] = STATE(15455),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1274),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [495] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17426),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17426),
    [sym__typed_pat] = STATE(17426),
    [sym__nested_pat] = STATE(17426),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1276),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [496] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17299),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17299),
    [sym__typed_pat] = STATE(17299),
    [sym__nested_pat] = STATE(17299),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1278),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [497] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12590),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15463),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15463),
    [sym__typed_pat] = STATE(15463),
    [sym__nested_pat] = STATE(15463),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1280),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [498] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12646),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15885),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15885),
    [sym__typed_pat] = STATE(15885),
    [sym__nested_pat] = STATE(15885),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [499] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15754),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15754),
    [sym__typed_pat] = STATE(15754),
    [sym__nested_pat] = STATE(15754),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1284),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [500] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17140),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17140),
    [sym__typed_pat] = STATE(17140),
    [sym__nested_pat] = STATE(17140),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1286),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [501] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17507),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17507),
    [sym__typed_pat] = STATE(17507),
    [sym__nested_pat] = STATE(17507),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1288),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [502] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16246),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16246),
    [sym__typed_pat] = STATE(16246),
    [sym__nested_pat] = STATE(16246),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1290),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [503] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12703),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15885),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15885),
    [sym__typed_pat] = STATE(15885),
    [sym__nested_pat] = STATE(15885),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [504] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16577),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16577),
    [sym__typed_pat] = STATE(16577),
    [sym__nested_pat] = STATE(16577),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1294),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [505] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12565),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16341),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16341),
    [sym__typed_pat] = STATE(16341),
    [sym__nested_pat] = STATE(16341),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [506] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15989),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15989),
    [sym__typed_pat] = STATE(15989),
    [sym__nested_pat] = STATE(15989),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1298),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [507] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15885),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15885),
    [sym__typed_pat] = STATE(15885),
    [sym__nested_pat] = STATE(15885),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1300),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [508] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16908),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16908),
    [sym__typed_pat] = STATE(16908),
    [sym__nested_pat] = STATE(16908),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1302),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [509] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12553),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15463),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15463),
    [sym__typed_pat] = STATE(15463),
    [sym__nested_pat] = STATE(15463),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [510] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12622),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15463),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15463),
    [sym__typed_pat] = STATE(15463),
    [sym__nested_pat] = STATE(15463),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1306),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [511] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12506),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15885),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15885),
    [sym__typed_pat] = STATE(15885),
    [sym__nested_pat] = STATE(15885),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [512] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16341),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16341),
    [sym__typed_pat] = STATE(16341),
    [sym__nested_pat] = STATE(16341),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1308),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [513] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15789),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15789),
    [sym__typed_pat] = STATE(15789),
    [sym__nested_pat] = STATE(15789),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1310),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [514] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12506),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17706),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17706),
    [sym__typed_pat] = STATE(17706),
    [sym__nested_pat] = STATE(17706),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [515] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12546),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16341),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16341),
    [sym__typed_pat] = STATE(16341),
    [sym__nested_pat] = STATE(16341),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1314),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [516] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12506),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16341),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16341),
    [sym__typed_pat] = STATE(16341),
    [sym__nested_pat] = STATE(16341),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1314),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [517] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17706),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17706),
    [sym__typed_pat] = STATE(17706),
    [sym__nested_pat] = STATE(17706),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1316),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [518] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16361),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16361),
    [sym__typed_pat] = STATE(16361),
    [sym__nested_pat] = STATE(16361),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1318),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [519] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15463),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15463),
    [sym__typed_pat] = STATE(15463),
    [sym__nested_pat] = STATE(15463),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [520] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12506),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15455),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15455),
    [sym__typed_pat] = STATE(15455),
    [sym__nested_pat] = STATE(15455),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1270),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [521] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16541),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16541),
    [sym__typed_pat] = STATE(16541),
    [sym__nested_pat] = STATE(16541),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1322),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [522] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16054),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16054),
    [sym__typed_pat] = STATE(16054),
    [sym__nested_pat] = STATE(16054),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [523] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12565),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15885),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15885),
    [sym__typed_pat] = STATE(15885),
    [sym__nested_pat] = STATE(15885),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [524] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12617),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15455),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15455),
    [sym__typed_pat] = STATE(15455),
    [sym__nested_pat] = STATE(15455),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1270),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [525] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12565),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15455),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15455),
    [sym__typed_pat] = STATE(15455),
    [sym__nested_pat] = STATE(15455),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1268),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [526] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17047),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17047),
    [sym__typed_pat] = STATE(17047),
    [sym__nested_pat] = STATE(17047),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1326),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [527] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17692),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17692),
    [sym__typed_pat] = STATE(17692),
    [sym__nested_pat] = STATE(17692),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1328),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [528] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12565),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15789),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15789),
    [sym__typed_pat] = STATE(15789),
    [sym__nested_pat] = STATE(15789),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1330),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [529] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12565),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15463),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15463),
    [sym__typed_pat] = STATE(15463),
    [sym__nested_pat] = STATE(15463),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [530] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12553),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15789),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15789),
    [sym__typed_pat] = STATE(15789),
    [sym__nested_pat] = STATE(15789),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1334),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [531] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15449),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15449),
    [sym__typed_pat] = STATE(15449),
    [sym__nested_pat] = STATE(15449),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1336),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [532] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15579),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15579),
    [sym__typed_pat] = STATE(15579),
    [sym__nested_pat] = STATE(15579),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1338),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [533] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16778),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16778),
    [sym__typed_pat] = STATE(16778),
    [sym__nested_pat] = STATE(16778),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1340),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [534] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16166),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16166),
    [sym__typed_pat] = STATE(16166),
    [sym__nested_pat] = STATE(16166),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1342),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [535] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12565),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(17706),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(17706),
    [sym__typed_pat] = STATE(17706),
    [sym__nested_pat] = STATE(17706),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [536] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15969),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15969),
    [sym__typed_pat] = STATE(15969),
    [sym__nested_pat] = STATE(15969),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1346),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [537] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12622),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15789),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15789),
    [sym__typed_pat] = STATE(15789),
    [sym__nested_pat] = STATE(15789),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1348),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [538] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12506),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15463),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15463),
    [sym__typed_pat] = STATE(15463),
    [sym__nested_pat] = STATE(15463),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [539] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12588),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16341),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16341),
    [sym__typed_pat] = STATE(16341),
    [sym__nested_pat] = STATE(16341),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [540] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16151),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16151),
    [sym__typed_pat] = STATE(16151),
    [sym__nested_pat] = STATE(16151),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1350),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [541] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12639),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15463),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15463),
    [sym__typed_pat] = STATE(15463),
    [sym__nested_pat] = STATE(15463),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [542] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(16759),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(16759),
    [sym__typed_pat] = STATE(16759),
    [sym__nested_pat] = STATE(16759),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1354),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [543] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12506),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15789),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15789),
    [sym__typed_pat] = STATE(15789),
    [sym__nested_pat] = STATE(15789),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1276),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [544] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15628),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15628),
    [sym__typed_pat] = STATE(15628),
    [sym__nested_pat] = STATE(15628),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_RBRACK] = ACTIONS(1356),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [545] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(108),
    [sym_variable] = STATE(4013),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3736),
    [sym_qualified_constructor] = STATE(3795),
    [sym__qcon] = STATE(3821),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4058),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(12672),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15455),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15455),
    [sym__typed_pat] = STATE(15455),
    [sym__nested_pat] = STATE(15455),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12552),
    [sym_splice] = STATE(4079),
    [sym_quasiquote] = STATE(4079),
    [sym__varid] = ACTIONS(1226),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1234),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1234),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1238),
    [anon_sym_LPAREN] = ACTIONS(1240),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1358),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [546] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(18614),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(18614),
    [sym__typed_pat] = STATE(18614),
    [sym__nested_pat] = STATE(18614),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [547] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(18708),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(18708),
    [sym__typed_pat] = STATE(18708),
    [sym__nested_pat] = STATE(18708),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [548] = {
    [sym_integer] = STATE(4913),
    [sym__literal] = STATE(4913),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4814),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3989),
    [sym_qualified_constructor] = STATE(4042),
    [sym__qcon] = STATE(4015),
    [sym_con_unit] = STATE(4913),
    [sym_con_list] = STATE(4913),
    [sym_con_tuple] = STATE(4913),
    [sym_literal] = STATE(4944),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16284),
    [sym_pat_as] = STATE(11508),
    [sym_pat_parens] = STATE(11508),
    [sym_pat_view] = STATE(18665),
    [sym_pat_tuple] = STATE(11508),
    [sym_pat_unboxed_tuple] = STATE(11508),
    [sym_pat_unboxed_sum] = STATE(11508),
    [sym_pat_list] = STATE(11508),
    [sym_pat_strict] = STATE(11508),
    [sym_pat_irrefutable] = STATE(11508),
    [sym_pat_negation] = STATE(11508),
    [sym_pat_name] = STATE(11508),
    [sym__pat_constructor] = STATE(2850),
    [sym_pat_wildcard] = STATE(11508),
    [sym_pat_record] = STATE(11508),
    [sym__apat] = STATE(11508),
    [sym_pat_apply] = STATE(11508),
    [sym__lpat] = STATE(11508),
    [sym_pat_infix] = STATE(13864),
    [sym__pat] = STATE(13864),
    [sym_pat_typed] = STATE(18665),
    [sym__typed_pat] = STATE(18665),
    [sym__nested_pat] = STATE(18665),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12589),
    [sym_splice] = STATE(4948),
    [sym_quasiquote] = STATE(4948),
    [sym__varid] = ACTIONS(1360),
    [sym_float] = ACTIONS(1362),
    [sym_char] = ACTIONS(1362),
    [sym_string] = ACTIONS(1362),
    [sym__integer_literal] = ACTIONS(1364),
    [sym__binary_literal] = ACTIONS(1366),
    [sym__octal_literal] = ACTIONS(1366),
    [sym__hex_literal] = ACTIONS(1366),
    [anon_sym_LPAREN_POUND] = ACTIONS(1368),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1368),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1376),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(1378),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(1380),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1384),
    [sym__strict] = ACTIONS(1386),
    [sym__lazy] = ACTIONS(1388),
  },
  [549] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15337),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15337),
    [sym__typed_pat] = STATE(15337),
    [sym__nested_pat] = STATE(15337),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [550] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(100),
    [sym_variable] = STATE(4140),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3896),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4284),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(15612),
    [sym_pat_as] = STATE(10367),
    [sym_pat_parens] = STATE(10367),
    [sym_pat_view] = STATE(15932),
    [sym_pat_tuple] = STATE(10367),
    [sym_pat_unboxed_tuple] = STATE(10367),
    [sym_pat_unboxed_sum] = STATE(10367),
    [sym_pat_list] = STATE(10367),
    [sym_pat_strict] = STATE(10367),
    [sym_pat_irrefutable] = STATE(10367),
    [sym_pat_negation] = STATE(10367),
    [sym_pat_name] = STATE(10367),
    [sym__pat_constructor] = STATE(2789),
    [sym_pat_wildcard] = STATE(10367),
    [sym_pat_record] = STATE(10367),
    [sym__apat] = STATE(10367),
    [sym_pat_apply] = STATE(10367),
    [sym__lpat] = STATE(10367),
    [sym_pat_infix] = STATE(13053),
    [sym__pat] = STATE(13053),
    [sym_pat_typed] = STATE(15932),
    [sym__typed_pat] = STATE(15932),
    [sym__nested_pat] = STATE(15932),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12579),
    [sym_splice] = STATE(4275),
    [sym_quasiquote] = STATE(4275),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(413),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(413),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_LPAREN] = ACTIONS(417),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(421),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [551] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(95),
    [sym_variable] = STATE(4252),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3887),
    [sym_qualified_constructor] = STATE(3917),
    [sym__qcon] = STATE(3950),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4404),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16391),
    [sym_pat_as] = STATE(11079),
    [sym_pat_parens] = STATE(11079),
    [sym_pat_view] = STATE(16511),
    [sym_pat_tuple] = STATE(11079),
    [sym_pat_unboxed_tuple] = STATE(11079),
    [sym_pat_unboxed_sum] = STATE(11079),
    [sym_pat_list] = STATE(11079),
    [sym_pat_strict] = STATE(11079),
    [sym_pat_irrefutable] = STATE(11079),
    [sym_pat_negation] = STATE(11079),
    [sym_pat_name] = STATE(11079),
    [sym__pat_constructor] = STATE(2825),
    [sym_pat_wildcard] = STATE(11079),
    [sym_pat_record] = STATE(11079),
    [sym__apat] = STATE(11079),
    [sym_pat_apply] = STATE(11079),
    [sym__lpat] = STATE(11079),
    [sym_pat_infix] = STATE(13349),
    [sym__pat] = STATE(13349),
    [sym_pat_typed] = STATE(16511),
    [sym__typed_pat] = STATE(16511),
    [sym__nested_pat] = STATE(16511),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12501),
    [sym_splice] = STATE(4405),
    [sym_quasiquote] = STATE(4405),
    [sym__varid] = ACTIONS(533),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(927),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(927),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_LPAREN] = ACTIONS(931),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(933),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
  },
  [552] = {
    [sym_integer] = STATE(4913),
    [sym__literal] = STATE(4913),
    [sym__unboxed_open] = STATE(111),
    [sym_variable] = STATE(4814),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3989),
    [sym_qualified_constructor] = STATE(4042),
    [sym__qcon] = STATE(4015),
    [sym_con_unit] = STATE(4913),
    [sym_con_list] = STATE(4913),
    [sym_con_tuple] = STATE(4913),
    [sym_literal] = STATE(4944),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16284),
    [sym_pat_as] = STATE(11508),
    [sym_pat_parens] = STATE(11508),
    [sym_pat_view] = STATE(18881),
    [sym_pat_tuple] = STATE(11508),
    [sym_pat_unboxed_tuple] = STATE(11508),
    [sym_pat_unboxed_sum] = STATE(11508),
    [sym_pat_list] = STATE(11508),
    [sym_pat_strict] = STATE(11508),
    [sym_pat_irrefutable] = STATE(11508),
    [sym_pat_negation] = STATE(11508),
    [sym_pat_name] = STATE(11508),
    [sym__pat_constructor] = STATE(2850),
    [sym_pat_wildcard] = STATE(11508),
    [sym_pat_record] = STATE(11508),
    [sym__apat] = STATE(11508),
    [sym_pat_apply] = STATE(11508),
    [sym__lpat] = STATE(11508),
    [sym_pat_infix] = STATE(13864),
    [sym__pat] = STATE(13864),
    [sym_pat_typed] = STATE(18881),
    [sym__typed_pat] = STATE(18881),
    [sym__nested_pat] = STATE(18881),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12589),
    [sym_splice] = STATE(4948),
    [sym_quasiquote] = STATE(4948),
    [sym__varid] = ACTIONS(1360),
    [sym_float] = ACTIONS(1362),
    [sym_char] = ACTIONS(1362),
    [sym_string] = ACTIONS(1362),
    [sym__integer_literal] = ACTIONS(1364),
    [sym__binary_literal] = ACTIONS(1366),
    [sym__octal_literal] = ACTIONS(1366),
    [sym__hex_literal] = ACTIONS(1366),
    [anon_sym_LPAREN_POUND] = ACTIONS(1368),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1368),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1370),
    [anon_sym_LPAREN] = ACTIONS(1372),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1374),
    [anon_sym_LBRACK] = ACTIONS(1376),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(1378),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(1380),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1384),
    [sym__strict] = ACTIONS(1386),
    [sym__lazy] = ACTIONS(1388),
  },
  [553] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(122),
    [sym_variable] = STATE(4388),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3969),
    [sym_qualified_constructor] = STATE(4192),
    [sym__qcon] = STATE(4194),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(5348),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(16320),
    [sym_pat_as] = STATE(11761),
    [sym_pat_parens] = STATE(11761),
    [sym_pat_view] = STATE(18048),
    [sym_pat_tuple] = STATE(11761),
    [sym_pat_unboxed_tuple] = STATE(11761),
    [sym_pat_unboxed_sum] = STATE(11761),
    [sym_pat_list] = STATE(11761),
    [sym_pat_strict] = STATE(11761),
    [sym_pat_irrefutable] = STATE(11761),
    [sym_pat_negation] = STATE(11761),
    [sym_pat_name] = STATE(11761),
    [sym__pat_constructor] = STATE(2881),
    [sym_pat_wildcard] = STATE(11761),
    [sym_pat_record] = STATE(11761),
    [sym__apat] = STATE(11761),
    [sym_pat_apply] = STATE(11761),
    [sym__lpat] = STATE(11761),
    [sym_pat_infix] = STATE(13474),
    [sym__pat] = STATE(13474),
    [sym_pat_typed] = STATE(18048),
    [sym__typed_pat] = STATE(18048),
    [sym__nested_pat] = STATE(18048),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12581),
    [sym_splice] = STATE(5342),
    [sym_quasiquote] = STATE(5342),
    [sym__varid] = ACTIONS(1167),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(1216),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1216),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_LPAREN] = ACTIONS(1220),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1183),
    [anon_sym_LBRACK] = ACTIONS(1222),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym__] = ACTIONS(1192),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
    [sym__strict] = ACTIONS(1212),
    [sym__lazy] = ACTIONS(1214),
  },
  [554] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9451),
    [sym_let] = STATE(15000),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9451),
    [sym_exp_cond] = STATE(9451),
    [sym_exp_if_guard] = STATE(9451),
    [sym_pattern_guard] = STATE(15000),
    [sym_guard] = STATE(14323),
    [sym_exp_case] = STATE(9451),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9451),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9451),
    [sym__lexp] = STATE(9451),
    [sym_exp_infix] = STATE(9451),
    [sym__exp_infix] = STATE(9451),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(15694),
    [sym__pat] = STATE(15694),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [555] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(117),
    [sym_variable] = STATE(3908),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3475),
    [sym_qualified_constructor] = STATE(3703),
    [sym__qcon] = STATE(3817),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4175),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9451),
    [sym_let] = STATE(15000),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9451),
    [sym_exp_cond] = STATE(9451),
    [sym_exp_if_guard] = STATE(9451),
    [sym_pattern_guard] = STATE(15000),
    [sym_guard] = STATE(14904),
    [sym_exp_case] = STATE(9451),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9451),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9451),
    [sym__lexp] = STATE(9451),
    [sym_exp_infix] = STATE(9451),
    [sym__exp_infix] = STATE(9451),
    [sym_pat_as] = STATE(10062),
    [sym_pat_parens] = STATE(10062),
    [sym_pat_tuple] = STATE(10062),
    [sym_pat_unboxed_tuple] = STATE(10062),
    [sym_pat_unboxed_sum] = STATE(10062),
    [sym_pat_list] = STATE(10062),
    [sym_pat_strict] = STATE(10062),
    [sym_pat_irrefutable] = STATE(10062),
    [sym_pat_negation] = STATE(10062),
    [sym_pat_name] = STATE(10062),
    [sym__pat_constructor] = STATE(2764),
    [sym_pat_wildcard] = STATE(10062),
    [sym_pat_record] = STATE(10062),
    [sym__apat] = STATE(10062),
    [sym_pat_apply] = STATE(10062),
    [sym__lpat] = STATE(10062),
    [sym_pat_infix] = STATE(15694),
    [sym__pat] = STATE(15694),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12584),
    [sym_splice] = STATE(4200),
    [sym_quasiquote] = STATE(4200),
    [sym__varid] = ACTIONS(227),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(677),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(677),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(679),
    [anon_sym_LPAREN] = ACTIONS(681),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(683),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [556] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7826),
    [sym__minus] = STATE(20968),
    [sym_qualified_operator] = STATE(7826),
    [sym__qvarop_nominus] = STATE(1766),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1443),
    [sym_qualified_constructor_operator] = STATE(1443),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20137),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9273),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9273),
    [sym_exp_cond] = STATE(9273),
    [sym_exp_if_guard] = STATE(9273),
    [sym_exp_case] = STATE(9273),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9273),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9273),
    [sym__lexp] = STATE(9273),
    [sym_exp_infix] = STATE(9273),
    [sym__exp_infix] = STATE(9273),
    [sym__exp] = STATE(18155),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(944),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [anon_sym_BQUOTE] = ACTIONS(1400),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1406),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1408),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [557] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7800),
    [sym__minus] = STATE(20305),
    [sym_qualified_operator] = STATE(7800),
    [sym__qvarop_nominus] = STATE(1748),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1460),
    [sym_qualified_constructor_operator] = STATE(1460),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19901),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9244),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9244),
    [sym_exp_cond] = STATE(9244),
    [sym_exp_if_guard] = STATE(9244),
    [sym_exp_case] = STATE(9244),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9244),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9244),
    [sym__lexp] = STATE(9244),
    [sym_exp_infix] = STATE(9244),
    [sym__exp_infix] = STATE(9244),
    [sym__exp] = STATE(18308),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(911),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(385),
    [anon_sym_BQUOTE] = ACTIONS(1410),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1412),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(387),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [558] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7702),
    [sym__minus] = STATE(19310),
    [sym_qualified_operator] = STATE(7702),
    [sym__qvarop_nominus] = STATE(1796),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1581),
    [sym_qualified_constructor_operator] = STATE(1581),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19230),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9257),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9257),
    [sym_exp_cond] = STATE(9257),
    [sym_exp_if_guard] = STATE(9257),
    [sym_exp_case] = STATE(9257),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9257),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9257),
    [sym__lexp] = STATE(9257),
    [sym_exp_infix] = STATE(9257),
    [sym__exp_infix] = STATE(9257),
    [sym__exp] = STATE(18835),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(920),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1414),
    [anon_sym_BQUOTE] = ACTIONS(1416),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1418),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1420),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [559] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7842),
    [sym__minus] = STATE(19285),
    [sym_qualified_operator] = STATE(7842),
    [sym__qvarop_nominus] = STATE(1729),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1468),
    [sym_qualified_constructor_operator] = STATE(1468),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19086),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9368),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9368),
    [sym_exp_cond] = STATE(9368),
    [sym_exp_if_guard] = STATE(9368),
    [sym_exp_case] = STATE(9368),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9368),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9368),
    [sym__lexp] = STATE(9368),
    [sym_exp_infix] = STATE(9368),
    [sym__exp_infix] = STATE(9368),
    [sym__exp] = STATE(18486),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(913),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1424),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1426),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1428),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [560] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7789),
    [sym__minus] = STATE(20835),
    [sym_qualified_operator] = STATE(7789),
    [sym__qvarop_nominus] = STATE(1771),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1496),
    [sym_qualified_constructor_operator] = STATE(1496),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19773),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9328),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9328),
    [sym_exp_cond] = STATE(9328),
    [sym_exp_if_guard] = STATE(9328),
    [sym_exp_case] = STATE(9328),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9328),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9328),
    [sym__lexp] = STATE(9328),
    [sym_exp_infix] = STATE(9328),
    [sym__exp_infix] = STATE(9328),
    [sym__exp] = STATE(18387),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(939),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(285),
    [anon_sym_BQUOTE] = ACTIONS(1430),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1432),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(287),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [561] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7829),
    [sym__minus] = STATE(19526),
    [sym_qualified_operator] = STATE(7829),
    [sym__qvarop_nominus] = STATE(1763),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1434),
    [sym_qualified_constructor_operator] = STATE(1434),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20268),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9281),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9281),
    [sym_exp_cond] = STATE(9281),
    [sym_exp_if_guard] = STATE(9281),
    [sym_exp_case] = STATE(9281),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9281),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9281),
    [sym__lexp] = STATE(9281),
    [sym_exp_infix] = STATE(9281),
    [sym__exp_infix] = STATE(9281),
    [sym__exp] = STATE(18115),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(938),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [anon_sym_BQUOTE] = ACTIONS(1436),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1438),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1440),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [562] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7801),
    [sym__minus] = STATE(19331),
    [sym_qualified_operator] = STATE(7801),
    [sym__qvarop_nominus] = STATE(1737),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1440),
    [sym_qualified_constructor_operator] = STATE(1440),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20067),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9150),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9150),
    [sym_exp_cond] = STATE(9150),
    [sym_exp_if_guard] = STATE(9150),
    [sym_exp_case] = STATE(9150),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9150),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9150),
    [sym__lexp] = STATE(9150),
    [sym_exp_infix] = STATE(9150),
    [sym__exp_infix] = STATE(9150),
    [sym__exp] = STATE(18280),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(951),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(313),
    [anon_sym_BQUOTE] = ACTIONS(315),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(317),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(319),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [563] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7841),
    [sym__minus] = STATE(20253),
    [sym_qualified_operator] = STATE(7841),
    [sym__qvarop_nominus] = STATE(1717),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1690),
    [sym_qualified_constructor_operator] = STATE(1690),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20854),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9331),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9331),
    [sym_exp_cond] = STATE(9331),
    [sym_exp_if_guard] = STATE(9331),
    [sym_exp_case] = STATE(9331),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9331),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9331),
    [sym__lexp] = STATE(9331),
    [sym_exp_infix] = STATE(9331),
    [sym__exp_infix] = STATE(9331),
    [sym__exp] = STATE(18303),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(927),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(349),
    [anon_sym_BQUOTE] = ACTIONS(1442),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1444),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(351),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [564] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7806),
    [sym__minus] = STATE(20740),
    [sym_qualified_operator] = STATE(7806),
    [sym__qvarop_nominus] = STATE(1787),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1523),
    [sym_qualified_constructor_operator] = STATE(1523),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20844),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9019),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9019),
    [sym_exp_cond] = STATE(9019),
    [sym_exp_if_guard] = STATE(9019),
    [sym_exp_case] = STATE(9019),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9019),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9019),
    [sym__lexp] = STATE(9019),
    [sym_exp_infix] = STATE(9019),
    [sym__exp_infix] = STATE(9019),
    [sym__exp] = STATE(18095),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(906),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(359),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(361),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1448),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [565] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7784),
    [sym__minus] = STATE(19279),
    [sym_qualified_operator] = STATE(7784),
    [sym__qvarop_nominus] = STATE(1702),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1393),
    [sym_qualified_constructor_operator] = STATE(1393),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19582),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9330),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9330),
    [sym_exp_cond] = STATE(9330),
    [sym_exp_if_guard] = STATE(9330),
    [sym_exp_case] = STATE(9330),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9330),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9330),
    [sym__lexp] = STATE(9330),
    [sym_exp_infix] = STATE(9330),
    [sym__exp_infix] = STATE(9330),
    [sym__exp] = STATE(18348),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(926),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_BQUOTE] = ACTIONS(1450),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1452),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(347),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [566] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7735),
    [sym__minus] = STATE(20882),
    [sym_qualified_operator] = STATE(7735),
    [sym__qvarop_nominus] = STATE(1757),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1388),
    [sym_qualified_constructor_operator] = STATE(1388),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20530),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9293),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9293),
    [sym_exp_cond] = STATE(9293),
    [sym_exp_if_guard] = STATE(9293),
    [sym_exp_case] = STATE(9293),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9293),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9293),
    [sym__lexp] = STATE(9293),
    [sym_exp_infix] = STATE(9293),
    [sym__exp_infix] = STATE(9293),
    [sym__exp] = STATE(18035),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(899),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1454),
    [anon_sym_BQUOTE] = ACTIONS(1456),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1458),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1460),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [567] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7700),
    [sym__minus] = STATE(19561),
    [sym_qualified_operator] = STATE(7700),
    [sym__qvarop_nominus] = STATE(1746),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1320),
    [sym_qualified_constructor_operator] = STATE(1320),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20338),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9322),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9322),
    [sym_exp_cond] = STATE(9322),
    [sym_exp_if_guard] = STATE(9322),
    [sym_exp_case] = STATE(9322),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9322),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9322),
    [sym__lexp] = STATE(9322),
    [sym_exp_infix] = STATE(9322),
    [sym__exp_infix] = STATE(9322),
    [sym__exp] = STATE(18520),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(903),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(1462),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1464),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(403),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [568] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7837),
    [sym__minus] = STATE(20563),
    [sym_qualified_operator] = STATE(7837),
    [sym__qvarop_nominus] = STATE(1714),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1683),
    [sym_qualified_constructor_operator] = STATE(1683),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20842),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9316),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9316),
    [sym_exp_cond] = STATE(9316),
    [sym_exp_if_guard] = STATE(9316),
    [sym_exp_case] = STATE(9316),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9316),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9316),
    [sym__lexp] = STATE(9316),
    [sym_exp_infix] = STATE(9316),
    [sym__exp_infix] = STATE(9316),
    [sym__exp] = STATE(18677),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(891),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(305),
    [anon_sym_BQUOTE] = ACTIONS(1466),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1468),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(311),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [569] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7708),
    [sym__minus] = STATE(19604),
    [sym_qualified_operator] = STATE(7708),
    [sym__qvarop_nominus] = STATE(1711),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1457),
    [sym_qualified_constructor_operator] = STATE(1457),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19734),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9186),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9186),
    [sym_exp_cond] = STATE(9186),
    [sym_exp_if_guard] = STATE(9186),
    [sym_exp_case] = STATE(9186),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9186),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9186),
    [sym__lexp] = STATE(9186),
    [sym_exp_infix] = STATE(9186),
    [sym__exp_infix] = STATE(9186),
    [sym__exp] = STATE(18229),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(953),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(331),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(407),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [570] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7707),
    [sym__minus] = STATE(19941),
    [sym_qualified_operator] = STATE(7707),
    [sym__qvarop_nominus] = STATE(1783),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1537),
    [sym_qualified_constructor_operator] = STATE(1537),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19315),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9280),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9280),
    [sym_exp_cond] = STATE(9280),
    [sym_exp_if_guard] = STATE(9280),
    [sym_exp_case] = STATE(9280),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9280),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9280),
    [sym__lexp] = STATE(9280),
    [sym_exp_infix] = STATE(9280),
    [sym__exp_infix] = STATE(9280),
    [sym__exp] = STATE(18679),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(904),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [anon_sym_BQUOTE] = ACTIONS(1472),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1474),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1476),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [571] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7733),
    [sym__minus] = STATE(19621),
    [sym_qualified_operator] = STATE(7733),
    [sym__qvarop_nominus] = STATE(1720),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1627),
    [sym_qualified_constructor_operator] = STATE(1627),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20072),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9129),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9129),
    [sym_exp_cond] = STATE(9129),
    [sym_exp_if_guard] = STATE(9129),
    [sym_exp_case] = STATE(9129),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9129),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9129),
    [sym__lexp] = STATE(9129),
    [sym_exp_infix] = STATE(9129),
    [sym__exp_infix] = STATE(9129),
    [sym__exp] = STATE(18399),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(933),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(329),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(335),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [572] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7840),
    [sym__minus] = STATE(19439),
    [sym_qualified_operator] = STATE(7840),
    [sym__qvarop_nominus] = STATE(1726),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1469),
    [sym_qualified_constructor_operator] = STATE(1469),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(18928),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9361),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9361),
    [sym_exp_cond] = STATE(9361),
    [sym_exp_if_guard] = STATE(9361),
    [sym_exp_case] = STATE(9361),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9361),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9361),
    [sym__lexp] = STATE(9361),
    [sym_exp_infix] = STATE(9361),
    [sym__exp_infix] = STATE(9361),
    [sym__exp] = STATE(18100),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(908),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [anon_sym_BQUOTE] = ACTIONS(1480),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1482),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1484),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [573] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7766),
    [sym__minus] = STATE(20291),
    [sym_qualified_operator] = STATE(7766),
    [sym__qvarop_nominus] = STATE(1709),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1479),
    [sym_qualified_constructor_operator] = STATE(1479),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19731),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9295),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9295),
    [sym_exp_cond] = STATE(9295),
    [sym_exp_if_guard] = STATE(9295),
    [sym_exp_case] = STATE(9295),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9295),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9295),
    [sym__lexp] = STATE(9295),
    [sym_exp_infix] = STATE(9295),
    [sym__exp_infix] = STATE(9295),
    [sym__exp] = STATE(18442),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(941),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1486),
    [anon_sym_BQUOTE] = ACTIONS(1488),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1490),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1492),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [574] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7769),
    [sym__minus] = STATE(19350),
    [sym_qualified_operator] = STATE(7769),
    [sym__qvarop_nominus] = STATE(1794),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1572),
    [sym_qualified_constructor_operator] = STATE(1572),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19018),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9339),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9339),
    [sym_exp_cond] = STATE(9339),
    [sym_exp_if_guard] = STATE(9339),
    [sym_exp_case] = STATE(9339),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9339),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9339),
    [sym__lexp] = STATE(9339),
    [sym_exp_infix] = STATE(9339),
    [sym__exp_infix] = STATE(9339),
    [sym__exp] = STATE(18894),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(919),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1494),
    [anon_sym_BQUOTE] = ACTIONS(1496),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1498),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1500),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [575] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7833),
    [sym__minus] = STATE(19763),
    [sym_qualified_operator] = STATE(7833),
    [sym__qvarop_nominus] = STATE(1705),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1498),
    [sym_qualified_constructor_operator] = STATE(1498),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19218),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9189),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9189),
    [sym_exp_cond] = STATE(9189),
    [sym_exp_if_guard] = STATE(9189),
    [sym_exp_case] = STATE(9189),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9189),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9189),
    [sym__lexp] = STATE(9189),
    [sym_exp_infix] = STATE(9189),
    [sym__exp_infix] = STATE(9189),
    [sym__exp] = STATE(17857),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(929),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(243),
    [anon_sym_BQUOTE] = ACTIONS(245),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(253),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(277),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [576] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7798),
    [sym__minus] = STATE(19170),
    [sym_qualified_operator] = STATE(7798),
    [sym__qvarop_nominus] = STATE(1733),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1639),
    [sym_qualified_constructor_operator] = STATE(1639),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19311),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9373),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9373),
    [sym_exp_cond] = STATE(9373),
    [sym_exp_if_guard] = STATE(9373),
    [sym_exp_case] = STATE(9373),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9373),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9373),
    [sym__lexp] = STATE(9373),
    [sym_exp_infix] = STATE(9373),
    [sym__exp_infix] = STATE(9373),
    [sym__exp] = STATE(18791),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(934),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1502),
    [anon_sym_BQUOTE] = ACTIONS(1504),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1506),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1508),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [577] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7791),
    [sym__minus] = STATE(20610),
    [sym_qualified_operator] = STATE(7791),
    [sym__qvarop_nominus] = STATE(1758),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1345),
    [sym_qualified_constructor_operator] = STATE(1345),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19390),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9200),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9200),
    [sym_exp_cond] = STATE(9200),
    [sym_exp_if_guard] = STATE(9200),
    [sym_exp_case] = STATE(9200),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9200),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9200),
    [sym__lexp] = STATE(9200),
    [sym_exp_infix] = STATE(9200),
    [sym__exp_infix] = STATE(9200),
    [sym__exp] = STATE(18784),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(897),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(411),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(355),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [578] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7754),
    [sym__minus] = STATE(19424),
    [sym_qualified_operator] = STATE(7754),
    [sym__qvarop_nominus] = STATE(1744),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1598),
    [sym_qualified_constructor_operator] = STATE(1598),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20034),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9326),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9326),
    [sym_exp_cond] = STATE(9326),
    [sym_exp_if_guard] = STATE(9326),
    [sym_exp_case] = STATE(9326),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9326),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9326),
    [sym__lexp] = STATE(9326),
    [sym_exp_infix] = STATE(9326),
    [sym__exp_infix] = STATE(9326),
    [sym__exp] = STATE(18643),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(910),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1510),
    [anon_sym_BQUOTE] = ACTIONS(1512),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1514),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1516),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [579] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7698),
    [sym__minus] = STATE(20522),
    [sym_qualified_operator] = STATE(7698),
    [sym__qvarop_nominus] = STATE(1753),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1328),
    [sym_qualified_constructor_operator] = STATE(1328),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20651),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9302),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9302),
    [sym_exp_cond] = STATE(9302),
    [sym_exp_if_guard] = STATE(9302),
    [sym_exp_case] = STATE(9302),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9302),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9302),
    [sym__lexp] = STATE(9302),
    [sym_exp_infix] = STATE(9302),
    [sym__exp_infix] = STATE(9302),
    [sym__exp] = STATE(18040),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(942),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1518),
    [anon_sym_BQUOTE] = ACTIONS(1520),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1522),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1524),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [580] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7782),
    [sym__minus] = STATE(19149),
    [sym_qualified_operator] = STATE(7782),
    [sym__qvarop_nominus] = STATE(1798),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1593),
    [sym_qualified_constructor_operator] = STATE(1593),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19402),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9272),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9272),
    [sym_exp_cond] = STATE(9272),
    [sym_exp_if_guard] = STATE(9272),
    [sym_exp_case] = STATE(9272),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9272),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9272),
    [sym__lexp] = STATE(9272),
    [sym_exp_infix] = STATE(9272),
    [sym__exp_infix] = STATE(9272),
    [sym__exp] = STATE(18689),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(945),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1526),
    [anon_sym_BQUOTE] = ACTIONS(1528),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1530),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1532),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [581] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7757),
    [sym__minus] = STATE(20037),
    [sym_qualified_operator] = STATE(7757),
    [sym__qvarop_nominus] = STATE(1777),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1514),
    [sym_qualified_constructor_operator] = STATE(1514),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19577),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9311),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9311),
    [sym_exp_cond] = STATE(9311),
    [sym_exp_if_guard] = STATE(9311),
    [sym_exp_case] = STATE(9311),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9311),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9311),
    [sym__lexp] = STATE(9311),
    [sym_exp_infix] = STATE(9311),
    [sym__exp_infix] = STATE(9311),
    [sym__exp] = STATE(18551),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(900),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1534),
    [anon_sym_BQUOTE] = ACTIONS(1536),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1538),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1540),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [582] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7770),
    [sym__minus] = STATE(18951),
    [sym_qualified_operator] = STATE(7770),
    [sym__qvarop_nominus] = STATE(1738),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1684),
    [sym_qualified_constructor_operator] = STATE(1684),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19589),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9377),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9377),
    [sym_exp_cond] = STATE(9377),
    [sym_exp_if_guard] = STATE(9377),
    [sym_exp_case] = STATE(9377),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9377),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9377),
    [sym__lexp] = STATE(9377),
    [sym_exp_infix] = STATE(9377),
    [sym__exp_infix] = STATE(9377),
    [sym__exp] = STATE(18884),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(928),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [anon_sym_BQUOTE] = ACTIONS(1544),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1546),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1548),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [583] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7822),
    [sym__minus] = STATE(20506),
    [sym_qualified_operator] = STATE(7822),
    [sym__qvarop_nominus] = STATE(1803),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1520),
    [sym_qualified_constructor_operator] = STATE(1520),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20796),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9112),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9112),
    [sym_exp_cond] = STATE(9112),
    [sym_exp_if_guard] = STATE(9112),
    [sym_exp_case] = STATE(9112),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9112),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9112),
    [sym__lexp] = STATE(9112),
    [sym_exp_infix] = STATE(9112),
    [sym__exp_infix] = STATE(9112),
    [sym__exp] = STATE(18808),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(914),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1550),
    [anon_sym_BQUOTE] = ACTIONS(307),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(309),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1552),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [584] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7765),
    [sym__minus] = STATE(19267),
    [sym_qualified_operator] = STATE(7765),
    [sym__qvarop_nominus] = STATE(1740),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1646),
    [sym_qualified_constructor_operator] = STATE(1646),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19813),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9360),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9360),
    [sym_exp_cond] = STATE(9360),
    [sym_exp_if_guard] = STATE(9360),
    [sym_exp_case] = STATE(9360),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9360),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9360),
    [sym__lexp] = STATE(9360),
    [sym_exp_infix] = STATE(9360),
    [sym__exp_infix] = STATE(9360),
    [sym__exp] = STATE(18809),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(936),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1554),
    [anon_sym_BQUOTE] = ACTIONS(1556),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1558),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1560),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [585] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7794),
    [sym__minus] = STATE(20052),
    [sym_qualified_operator] = STATE(7794),
    [sym__qvarop_nominus] = STATE(1774),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1587),
    [sym_qualified_constructor_operator] = STATE(1587),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20531),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9072),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9072),
    [sym_exp_cond] = STATE(9072),
    [sym_exp_if_guard] = STATE(9072),
    [sym_exp_case] = STATE(9072),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9072),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9072),
    [sym__lexp] = STATE(9072),
    [sym_exp_infix] = STATE(9072),
    [sym__exp_infix] = STATE(9072),
    [sym__exp] = STATE(18031),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(940),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(337),
    [anon_sym_BQUOTE] = ACTIONS(339),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(341),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(343),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [586] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7741),
    [sym__minus] = STATE(19925),
    [sym_qualified_operator] = STATE(7741),
    [sym__qvarop_nominus] = STATE(1760),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1481),
    [sym_qualified_constructor_operator] = STATE(1481),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20321),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9121),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9121),
    [sym_exp_cond] = STATE(9121),
    [sym_exp_if_guard] = STATE(9121),
    [sym_exp_case] = STATE(9121),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9121),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9121),
    [sym__lexp] = STATE(9121),
    [sym_exp_infix] = STATE(9121),
    [sym__exp_infix] = STATE(9121),
    [sym__exp] = STATE(18111),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(925),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(325),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(327),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [587] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7701),
    [sym__minus] = STATE(19875),
    [sym_qualified_operator] = STATE(7701),
    [sym__qvarop_nominus] = STATE(1786),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1548),
    [sym_qualified_constructor_operator] = STATE(1548),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19191),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9269),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9269),
    [sym_exp_cond] = STATE(9269),
    [sym_exp_if_guard] = STATE(9269),
    [sym_exp_case] = STATE(9269),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9269),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9269),
    [sym__lexp] = STATE(9269),
    [sym_exp_infix] = STATE(9269),
    [sym__exp_infix] = STATE(9269),
    [sym__exp] = STATE(18781),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(905),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1562),
    [anon_sym_BQUOTE] = ACTIONS(1564),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1566),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1568),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [588] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7858),
    [sym__minus] = STATE(20814),
    [sym_qualified_operator] = STATE(7858),
    [sym__qvarop_nominus] = STATE(1703),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1651),
    [sym_qualified_constructor_operator] = STATE(1651),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19081),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9203),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9203),
    [sym_exp_cond] = STATE(9203),
    [sym_exp_if_guard] = STATE(9203),
    [sym_exp_case] = STATE(9203),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9203),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9203),
    [sym__lexp] = STATE(9203),
    [sym_exp_infix] = STATE(9203),
    [sym__exp_infix] = STATE(9203),
    [sym__exp] = STATE(18905),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(902),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(393),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(395),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(391),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [589] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7830),
    [sym__minus] = STATE(20947),
    [sym_qualified_operator] = STATE(7830),
    [sym__qvarop_nominus] = STATE(1768),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1450),
    [sym_qualified_constructor_operator] = STATE(1450),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20003),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9354),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9354),
    [sym_exp_cond] = STATE(9354),
    [sym_exp_if_guard] = STATE(9354),
    [sym_exp_case] = STATE(9354),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9354),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9354),
    [sym__lexp] = STATE(9354),
    [sym_exp_infix] = STATE(9354),
    [sym__exp_infix] = STATE(9354),
    [sym__exp] = STATE(18227),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(954),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1570),
    [anon_sym_BQUOTE] = ACTIONS(1572),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1574),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1576),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [590] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7843),
    [sym__minus] = STATE(20964),
    [sym_qualified_operator] = STATE(7843),
    [sym__qvarop_nominus] = STATE(1761),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1429),
    [sym_qualified_constructor_operator] = STATE(1429),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20382),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9290),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9290),
    [sym_exp_cond] = STATE(9290),
    [sym_exp_if_guard] = STATE(9290),
    [sym_exp_case] = STATE(9290),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9290),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9290),
    [sym__lexp] = STATE(9290),
    [sym_exp_infix] = STATE(9290),
    [sym__exp_infix] = STATE(9290),
    [sym__exp] = STATE(18069),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(907),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1578),
    [anon_sym_BQUOTE] = ACTIONS(1580),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1582),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1584),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [591] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7775),
    [sym__minus] = STATE(20053),
    [sym_qualified_operator] = STATE(7775),
    [sym__qvarop_nominus] = STATE(1775),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1503),
    [sym_qualified_constructor_operator] = STATE(1503),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19682),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9314),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9314),
    [sym_exp_cond] = STATE(9314),
    [sym_exp_if_guard] = STATE(9314),
    [sym_exp_case] = STATE(9314),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9314),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9314),
    [sym__lexp] = STATE(9314),
    [sym_exp_infix] = STATE(9314),
    [sym__exp_infix] = STATE(9314),
    [sym__exp] = STATE(18499),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(921),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1586),
    [anon_sym_BQUOTE] = ACTIONS(1588),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1590),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1592),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [592] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7758),
    [sym__minus] = STATE(19107),
    [sym_qualified_operator] = STATE(7758),
    [sym__qvarop_nominus] = STATE(1718),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1513),
    [sym_qualified_constructor_operator] = STATE(1513),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19843),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9191),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9191),
    [sym_exp_cond] = STATE(9191),
    [sym_exp_if_guard] = STATE(9191),
    [sym_exp_case] = STATE(9191),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9191),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9191),
    [sym__lexp] = STATE(9191),
    [sym_exp_infix] = STATE(9191),
    [sym__exp_infix] = STATE(9191),
    [sym__exp] = STATE(18590),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(918),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(289),
    [anon_sym_BQUOTE] = ACTIONS(291),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(293),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(295),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [593] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7771),
    [sym__minus] = STATE(20234),
    [sym_qualified_operator] = STATE(7771),
    [sym__qvarop_nominus] = STATE(1724),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1509),
    [sym_qualified_constructor_operator] = STATE(1509),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19461),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9116),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9116),
    [sym_exp_cond] = STATE(9116),
    [sym_exp_if_guard] = STATE(9116),
    [sym_exp_case] = STATE(9116),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9116),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9116),
    [sym__lexp] = STATE(9116),
    [sym_exp_infix] = STATE(9116),
    [sym__exp_infix] = STATE(9116),
    [sym__exp] = STATE(18436),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(895),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(369),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(373),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(375),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [594] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7759),
    [sym__minus] = STATE(20389),
    [sym_qualified_operator] = STATE(7759),
    [sym__qvarop_nominus] = STATE(1751),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1357),
    [sym_qualified_constructor_operator] = STATE(1357),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20908),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9309),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9309),
    [sym_exp_cond] = STATE(9309),
    [sym_exp_if_guard] = STATE(9309),
    [sym_exp_case] = STATE(9309),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9309),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9309),
    [sym__lexp] = STATE(9309),
    [sym_exp_infix] = STATE(9309),
    [sym__exp_infix] = STATE(9309),
    [sym__exp] = STATE(18107),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(909),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1594),
    [anon_sym_BQUOTE] = ACTIONS(1596),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1598),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1600),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [595] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7724),
    [sym__minus] = STATE(19995),
    [sym_qualified_operator] = STATE(7724),
    [sym__qvarop_nominus] = STATE(1779),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1532),
    [sym_qualified_constructor_operator] = STATE(1532),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19462),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9308),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9308),
    [sym_exp_cond] = STATE(9308),
    [sym_exp_if_guard] = STATE(9308),
    [sym_exp_case] = STATE(9308),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9308),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9308),
    [sym__lexp] = STATE(9308),
    [sym_exp_infix] = STATE(9308),
    [sym__exp_infix] = STATE(9308),
    [sym__exp] = STATE(18615),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(912),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1602),
    [anon_sym_BQUOTE] = ACTIONS(1604),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1606),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1608),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [596] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7723),
    [sym__minus] = STATE(20808),
    [sym_qualified_operator] = STATE(7723),
    [sym__qvarop_nominus] = STATE(1750),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1579),
    [sym_qualified_constructor_operator] = STATE(1579),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20192),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9135),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9135),
    [sym_exp_cond] = STATE(9135),
    [sym_exp_if_guard] = STATE(9135),
    [sym_exp_case] = STATE(9135),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9135),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9135),
    [sym__lexp] = STATE(9135),
    [sym_exp_infix] = STATE(9135),
    [sym__exp_infix] = STATE(9135),
    [sym__exp] = STATE(18120),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(893),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(297),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(301),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(303),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [597] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7734),
    [sym__minus] = STATE(19379),
    [sym_qualified_operator] = STATE(7734),
    [sym__qvarop_nominus] = STATE(1712),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1630),
    [sym_qualified_constructor_operator] = STATE(1630),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20214),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9307),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9307),
    [sym_exp_cond] = STATE(9307),
    [sym_exp_if_guard] = STATE(9307),
    [sym_exp_case] = STATE(9307),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9307),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9307),
    [sym__lexp] = STATE(9307),
    [sym_exp_infix] = STATE(9307),
    [sym__exp_infix] = STATE(9307),
    [sym__exp] = STATE(18524),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(955),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1610),
    [anon_sym_BQUOTE] = ACTIONS(1612),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1614),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1616),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [598] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7742),
    [sym__minus] = STATE(19494),
    [sym_qualified_operator] = STATE(7742),
    [sym__qvarop_nominus] = STATE(1792),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1568),
    [sym_qualified_constructor_operator] = STATE(1568),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(18969),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9305),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9305),
    [sym_exp_cond] = STATE(9305),
    [sym_exp_if_guard] = STATE(9305),
    [sym_exp_case] = STATE(9305),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9305),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9305),
    [sym__lexp] = STATE(9305),
    [sym_exp_infix] = STATE(9305),
    [sym__exp_infix] = STATE(9305),
    [sym__exp] = STATE(18874),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(930),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1618),
    [anon_sym_BQUOTE] = ACTIONS(1620),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1624),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [599] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7788),
    [sym__minus] = STATE(19558),
    [sym_qualified_operator] = STATE(7788),
    [sym__qvarop_nominus] = STATE(1731),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1664),
    [sym_qualified_constructor_operator] = STATE(1664),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19947),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9163),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9163),
    [sym_exp_cond] = STATE(9163),
    [sym_exp_if_guard] = STATE(9163),
    [sym_exp_case] = STATE(9163),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9163),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9163),
    [sym__lexp] = STATE(9163),
    [sym_exp_infix] = STATE(9163),
    [sym__exp_infix] = STATE(9163),
    [sym__exp] = STATE(18463),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(931),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_BQUOTE] = ACTIONS(397),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(399),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(367),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [600] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7722),
    [sym__minus] = STATE(19717),
    [sym_qualified_operator] = STATE(7722),
    [sym__qvarop_nominus] = STATE(1789),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1554),
    [sym_qualified_constructor_operator] = STATE(1554),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(19080),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9259),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9259),
    [sym_exp_cond] = STATE(9259),
    [sym_exp_if_guard] = STATE(9259),
    [sym_exp_case] = STATE(9259),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9259),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9259),
    [sym__lexp] = STATE(9259),
    [sym_exp_infix] = STATE(9259),
    [sym__exp_infix] = STATE(9259),
    [sym__exp] = STATE(18827),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(932),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(381),
    [anon_sym_BQUOTE] = ACTIONS(1626),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1628),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(383),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [601] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_operator] = STATE(7805),
    [sym__minus] = STATE(20177),
    [sym_qualified_operator] = STATE(7805),
    [sym__qvarop_nominus] = STATE(1728),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym_constructor_operator] = STATE(1534),
    [sym_qualified_constructor_operator] = STATE(1534),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym__exp_tuple] = STATE(20570),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9312),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9312),
    [sym_exp_cond] = STATE(9312),
    [sym_exp_if_guard] = STATE(9312),
    [sym_exp_case] = STATE(9312),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9312),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9312),
    [sym__lexp] = STATE(9312),
    [sym_exp_infix] = STATE(9312),
    [sym__exp_infix] = STATE(9312),
    [sym__exp] = STATE(18262),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10244),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(915),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(357),
    [anon_sym_BQUOTE] = ACTIONS(1630),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_DOT] = ACTIONS(1632),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(273),
    [sym__consym] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(363),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [602] = {
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = STATE(3595),
    [sym_qualified_variable] = STATE(3595),
    [sym_constructor] = STATE(3473),
    [sym_qualified_constructor] = STATE(3699),
    [sym__qcon] = STATE(3595),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(3752),
    [sym_exp_parens] = STATE(3752),
    [sym_exp_tuple] = STATE(3752),
    [sym_exp_unboxed_tuple] = STATE(3752),
    [sym_exp_unboxed_sum] = STATE(3752),
    [sym_exp_list] = STATE(3752),
    [sym_exp_arithmetic_sequence] = STATE(3752),
    [sym_exp_list_comprehension] = STATE(3752),
    [sym_exp_section_left] = STATE(3752),
    [sym_exp_section_right] = STATE(3752),
    [sym_exp_th_quoted_name] = STATE(3752),
    [sym_exp_type_application] = STATE(602),
    [sym_exp_lambda] = STATE(9562),
    [sym_exp_let] = STATE(17973),
    [sym_exp_let_in] = STATE(9562),
    [sym_exp_cond] = STATE(9562),
    [sym_exp_case] = STATE(9562),
    [sym_exp_lambda_case] = STATE(602),
    [sym__do_keyword] = STATE(18310),
    [sym_do_module] = STATE(18310),
    [sym_exp_do] = STATE(602),
    [sym_exp_record] = STATE(3752),
    [sym_exp_name] = STATE(3752),
    [sym_exp_projection_selector] = STATE(3752),
    [sym__aexp_projection] = STATE(3752),
    [sym_exp_projection] = STATE(3752),
    [sym__aexp] = STATE(602),
    [sym__exp_apply] = STATE(9562),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12563),
    [sym_splice] = STATE(3752),
    [sym_quasiquote] = STATE(3752),
    [sym__varid] = ACTIONS(1634),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(1638),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1638),
    [anon_sym_2] = ACTIONS(1636),
    [anon_sym_DASH_GT] = ACTIONS(1636),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_LPAREN] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1636),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(1640),
    [sym__conid] = ACTIONS(1646),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_RBRACK] = ACTIONS(1636),
    [anon_sym_SQUOTE] = ACTIONS(1651),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(1653),
    [anon_sym_RBRACE] = ACTIONS(1636),
    [anon_sym_using] = ACTIONS(1642),
    [anon_sym_then] = ACTIONS(1642),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1655),
    [anon_sym_AT] = ACTIONS(1657),
    [anon_sym_BSLASH] = ACTIONS(1659),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_else] = ACTIONS(1642),
    [anon_sym_case] = ACTIONS(1663),
    [anon_sym_of] = ACTIONS(1642),
    [anon_sym_mdo] = ACTIONS(1665),
    [anon_sym_do] = ACTIONS(1665),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
  },
  [603] = {
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = STATE(3595),
    [sym_qualified_variable] = STATE(3595),
    [sym_constructor] = STATE(3473),
    [sym_qualified_constructor] = STATE(3699),
    [sym__qcon] = STATE(3595),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(3752),
    [sym_exp_parens] = STATE(3752),
    [sym_exp_tuple] = STATE(3752),
    [sym_exp_unboxed_tuple] = STATE(3752),
    [sym_exp_unboxed_sum] = STATE(3752),
    [sym_exp_list] = STATE(3752),
    [sym_exp_arithmetic_sequence] = STATE(3752),
    [sym_exp_list_comprehension] = STATE(3752),
    [sym_exp_section_left] = STATE(3752),
    [sym_exp_section_right] = STATE(3752),
    [sym_exp_th_quoted_name] = STATE(3752),
    [sym_exp_type_application] = STATE(602),
    [sym_exp_lambda] = STATE(9562),
    [sym_exp_let] = STATE(17973),
    [sym_exp_let_in] = STATE(9562),
    [sym_exp_cond] = STATE(9562),
    [sym_exp_case] = STATE(9562),
    [sym_exp_lambda_case] = STATE(602),
    [sym__do_keyword] = STATE(18310),
    [sym_do_module] = STATE(18310),
    [sym_exp_do] = STATE(602),
    [sym_exp_record] = STATE(3752),
    [sym_exp_name] = STATE(3752),
    [sym_exp_projection_selector] = STATE(3752),
    [sym__aexp_projection] = STATE(3752),
    [sym_exp_projection] = STATE(3752),
    [sym__aexp] = STATE(602),
    [sym__exp_apply] = STATE(9562),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12563),
    [sym_splice] = STATE(3752),
    [sym_quasiquote] = STATE(3752),
    [sym__varid] = ACTIONS(1634),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(1638),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1638),
    [anon_sym_2] = ACTIONS(1667),
    [anon_sym_DASH_GT] = ACTIONS(1667),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1644),
    [anon_sym_RPAREN] = ACTIONS(1667),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(1640),
    [sym__conid] = ACTIONS(1673),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_RBRACK] = ACTIONS(1667),
    [anon_sym_SQUOTE] = ACTIONS(1651),
    [anon_sym_PIPE] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(1653),
    [anon_sym_RBRACE] = ACTIONS(1667),
    [anon_sym_using] = ACTIONS(1670),
    [anon_sym_then] = ACTIONS(1670),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1655),
    [anon_sym_AT] = ACTIONS(1657),
    [anon_sym_BSLASH] = ACTIONS(1659),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1661),
    [anon_sym_else] = ACTIONS(1670),
    [anon_sym_case] = ACTIONS(1663),
    [anon_sym_of] = ACTIONS(1670),
    [anon_sym_mdo] = ACTIONS(1665),
    [anon_sym_do] = ACTIONS(1665),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
  },
  [604] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(605),
    [sym_exp_lambda] = STATE(9705),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9705),
    [sym_exp_cond] = STATE(9705),
    [sym_exp_case] = STATE(9705),
    [sym_exp_lambda_case] = STATE(605),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(605),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(605),
    [sym__exp_apply] = STATE(9705),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [anon_sym_2] = ACTIONS(1667),
    [anon_sym_DASH_GT] = ACTIONS(1667),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1667),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(1667),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_LBRACE] = ACTIONS(1689),
    [anon_sym_RBRACE] = ACTIONS(1667),
    [anon_sym_using] = ACTIONS(1670),
    [anon_sym_then] = ACTIONS(1670),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1691),
    [anon_sym_else] = ACTIONS(1670),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_of] = ACTIONS(1670),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [605] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(605),
    [sym_exp_lambda] = STATE(9705),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9705),
    [sym_exp_cond] = STATE(9705),
    [sym_exp_case] = STATE(9705),
    [sym_exp_lambda_case] = STATE(605),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(605),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(605),
    [sym__exp_apply] = STATE(9705),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [anon_sym_2] = ACTIONS(1636),
    [anon_sym_DASH_GT] = ACTIONS(1636),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1636),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1693),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(1636),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_LBRACE] = ACTIONS(1689),
    [anon_sym_RBRACE] = ACTIONS(1636),
    [anon_sym_using] = ACTIONS(1642),
    [anon_sym_then] = ACTIONS(1642),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1691),
    [anon_sym_else] = ACTIONS(1642),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_of] = ACTIONS(1642),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [606] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20930),
    [sym__minus] = STATE(20930),
    [sym_qualified_operator] = STATE(20930),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20887),
    [sym_qualified_constructor_operator] = STATE(20887),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20395),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [607] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20185),
    [sym__minus] = STATE(20185),
    [sym_qualified_operator] = STATE(20185),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19762),
    [sym_qualified_constructor_operator] = STATE(19762),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19635),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [608] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19870),
    [sym__minus] = STATE(19870),
    [sym_qualified_operator] = STATE(19870),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20019),
    [sym_qualified_constructor_operator] = STATE(20019),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18959),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [609] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20406),
    [sym__minus] = STATE(20406),
    [sym_qualified_operator] = STATE(20406),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20407),
    [sym_qualified_constructor_operator] = STATE(20407),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19399),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [610] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(18952),
    [sym__minus] = STATE(18952),
    [sym_qualified_operator] = STATE(18952),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(18953),
    [sym_qualified_constructor_operator] = STATE(18953),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19051),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [611] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19662),
    [sym__minus] = STATE(19662),
    [sym_qualified_operator] = STATE(19662),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19664),
    [sym_qualified_constructor_operator] = STATE(19664),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19377),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [612] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(18930),
    [sym__minus] = STATE(18930),
    [sym_qualified_operator] = STATE(18930),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(18931),
    [sym_qualified_constructor_operator] = STATE(18931),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19133),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [613] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(18974),
    [sym__minus] = STATE(18974),
    [sym_qualified_operator] = STATE(18974),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19949),
    [sym_qualified_constructor_operator] = STATE(19949),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19203),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [614] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20177),
    [sym__minus] = STATE(20177),
    [sym_qualified_operator] = STATE(20177),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19827),
    [sym_qualified_constructor_operator] = STATE(19827),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20503),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [615] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19056),
    [sym__minus] = STATE(19056),
    [sym_qualified_operator] = STATE(19056),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19134),
    [sym_qualified_constructor_operator] = STATE(19134),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19252),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [616] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(18948),
    [sym__minus] = STATE(18948),
    [sym_qualified_operator] = STATE(18948),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19029),
    [sym_qualified_constructor_operator] = STATE(19029),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20606),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [617] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20088),
    [sym__minus] = STATE(20088),
    [sym_qualified_operator] = STATE(20088),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20092),
    [sym_qualified_constructor_operator] = STATE(20092),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19113),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [618] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19136),
    [sym__minus] = STATE(19136),
    [sym_qualified_operator] = STATE(19136),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19205),
    [sym_qualified_constructor_operator] = STATE(19205),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19305),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [619] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19209),
    [sym__minus] = STATE(19209),
    [sym_qualified_operator] = STATE(19209),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19346),
    [sym_qualified_constructor_operator] = STATE(19346),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19345),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [620] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19882),
    [sym__minus] = STATE(19882),
    [sym_qualified_operator] = STATE(19882),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19654),
    [sym_qualified_constructor_operator] = STATE(19654),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20250),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [621] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19259),
    [sym__minus] = STATE(19259),
    [sym_qualified_operator] = STATE(19259),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19394),
    [sym_qualified_constructor_operator] = STATE(19394),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19389),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [622] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19604),
    [sym__minus] = STATE(19604),
    [sym_qualified_operator] = STATE(19604),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20630),
    [sym_qualified_constructor_operator] = STATE(20630),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19669),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [623] = {
    [sym_integer] = STATE(3980),
    [sym__literal] = STATE(3980),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = STATE(3975),
    [sym_qualified_variable] = STATE(3975),
    [sym_constructor] = STATE(3857),
    [sym_qualified_constructor] = STATE(3915),
    [sym__qcon] = STATE(3975),
    [sym_con_unit] = STATE(3980),
    [sym_con_list] = STATE(3980),
    [sym_con_tuple] = STATE(3980),
    [sym_literal] = STATE(3921),
    [sym_exp_parens] = STATE(3921),
    [sym_exp_tuple] = STATE(3921),
    [sym_exp_unboxed_tuple] = STATE(3921),
    [sym_exp_unboxed_sum] = STATE(3921),
    [sym_exp_list] = STATE(3921),
    [sym_exp_arithmetic_sequence] = STATE(3921),
    [sym_exp_list_comprehension] = STATE(3921),
    [sym_exp_section_left] = STATE(3921),
    [sym_exp_section_right] = STATE(3921),
    [sym_exp_th_quoted_name] = STATE(3921),
    [sym_exp_type_application] = STATE(623),
    [sym_exp_lambda] = STATE(9986),
    [sym_exp_let] = STATE(18820),
    [sym_exp_let_in] = STATE(9986),
    [sym_exp_cond] = STATE(9986),
    [sym_exp_case] = STATE(9986),
    [sym_exp_lambda_case] = STATE(623),
    [sym__do_keyword] = STATE(18344),
    [sym_do_module] = STATE(18344),
    [sym_exp_do] = STATE(623),
    [sym_exp_record] = STATE(3921),
    [sym_exp_name] = STATE(3921),
    [sym_exp_projection_selector] = STATE(3921),
    [sym__aexp_projection] = STATE(3921),
    [sym_exp_projection] = STATE(3921),
    [sym__aexp] = STATE(623),
    [sym__exp_apply] = STATE(9986),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12582),
    [sym_splice] = STATE(3921),
    [sym_quasiquote] = STATE(3921),
    [sym__varid] = ACTIONS(1700),
    [sym_float] = ACTIONS(1702),
    [sym_char] = ACTIONS(1702),
    [sym_string] = ACTIONS(1702),
    [sym__integer_literal] = ACTIONS(1704),
    [sym__binary_literal] = ACTIONS(1706),
    [sym__octal_literal] = ACTIONS(1706),
    [sym__hex_literal] = ACTIONS(1706),
    [anon_sym_LPAREN_POUND] = ACTIONS(1708),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1708),
    [anon_sym_2] = ACTIONS(1636),
    [anon_sym_DASH_GT] = ACTIONS(1636),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1710),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_LPAREN] = ACTIONS(1712),
    [anon_sym_RPAREN] = ACTIONS(1636),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(1710),
    [sym__conid] = ACTIONS(1714),
    [anon_sym_LBRACK] = ACTIONS(1717),
    [anon_sym_RBRACK] = ACTIONS(1636),
    [anon_sym_SQUOTE] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_EQ] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(1721),
    [anon_sym_RBRACE] = ACTIONS(1636),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(1725),
    [anon_sym_BSLASH] = ACTIONS(1727),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1729),
    [anon_sym_case] = ACTIONS(1731),
    [anon_sym_mdo] = ACTIONS(1733),
    [anon_sym_do] = ACTIONS(1733),
    [anon_sym_7] = ACTIONS(1735),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1737),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1636),
    [sym_quasiquote_start] = ACTIONS(1739),
  },
  [624] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19558),
    [sym__minus] = STATE(19558),
    [sym_qualified_operator] = STATE(19558),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19111),
    [sym_qualified_constructor_operator] = STATE(19111),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20888),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [625] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20622),
    [sym__minus] = STATE(20622),
    [sym_qualified_operator] = STATE(20622),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20176),
    [sym_qualified_constructor_operator] = STATE(20176),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19885),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [626] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19875),
    [sym__minus] = STATE(19875),
    [sym_qualified_operator] = STATE(19875),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19440),
    [sym_qualified_constructor_operator] = STATE(19440),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19437),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [627] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19398),
    [sym__minus] = STATE(19398),
    [sym_qualified_operator] = STATE(19398),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19490),
    [sym_qualified_constructor_operator] = STATE(19490),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19486),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [628] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20498),
    [sym__minus] = STATE(20498),
    [sym_qualified_operator] = STATE(20498),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20494),
    [sym_qualified_constructor_operator] = STATE(20494),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20093),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [629] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20357),
    [sym__minus] = STATE(20357),
    [sym_qualified_operator] = STATE(20357),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20354),
    [sym_qualified_constructor_operator] = STATE(20354),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20409),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [630] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19279),
    [sym__minus] = STATE(19279),
    [sym_qualified_operator] = STATE(19279),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20252),
    [sym_qualified_constructor_operator] = STATE(20252),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20635),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [631] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19527),
    [sym__minus] = STATE(19527),
    [sym_qualified_operator] = STATE(19527),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19528),
    [sym_qualified_constructor_operator] = STATE(19528),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19529),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [632] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19941),
    [sym__minus] = STATE(19941),
    [sym_qualified_operator] = STATE(19941),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19543),
    [sym_qualified_constructor_operator] = STATE(19543),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19539),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [633] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20124),
    [sym__minus] = STATE(20124),
    [sym_qualified_operator] = STATE(20124),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19687),
    [sym_qualified_constructor_operator] = STATE(19687),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20782),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [634] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(18909),
    [sym__minus] = STATE(18909),
    [sym_qualified_operator] = STATE(18909),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19199),
    [sym_qualified_constructor_operator] = STATE(19199),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20302),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [635] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19515),
    [sym__minus] = STATE(19515),
    [sym_qualified_operator] = STATE(19515),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19516),
    [sym_qualified_constructor_operator] = STATE(19516),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19517),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [636] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19995),
    [sym__minus] = STATE(19995),
    [sym_qualified_operator] = STATE(19995),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19598),
    [sym_qualified_constructor_operator] = STATE(19598),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19596),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [637] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20610),
    [sym__minus] = STATE(20610),
    [sym_qualified_operator] = STATE(20610),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20123),
    [sym_qualified_constructor_operator] = STATE(20123),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20613),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [638] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19503),
    [sym__minus] = STATE(19503),
    [sym_qualified_operator] = STATE(19503),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19504),
    [sym_qualified_constructor_operator] = STATE(19504),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19505),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [639] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19491),
    [sym__minus] = STATE(19491),
    [sym_qualified_operator] = STATE(19491),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19492),
    [sym_qualified_constructor_operator] = STATE(19492),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19493),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [640] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20814),
    [sym__minus] = STATE(20814),
    [sym_qualified_operator] = STATE(20814),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19979),
    [sym_qualified_constructor_operator] = STATE(19979),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20493),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [641] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19441),
    [sym__minus] = STATE(19441),
    [sym_qualified_operator] = STATE(19441),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19648),
    [sym_qualified_constructor_operator] = STATE(19648),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19646),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [642] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20037),
    [sym__minus] = STATE(20037),
    [sym_qualified_operator] = STATE(20037),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19715),
    [sym_qualified_constructor_operator] = STATE(19715),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19711),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [643] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20053),
    [sym__minus] = STATE(20053),
    [sym_qualified_operator] = STATE(20053),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19770),
    [sym_qualified_constructor_operator] = STATE(19770),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19767),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [644] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20740),
    [sym__minus] = STATE(20740),
    [sym_qualified_operator] = STATE(20740),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19713),
    [sym_qualified_constructor_operator] = STATE(19713),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19834),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [645] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19479),
    [sym__minus] = STATE(19479),
    [sym_qualified_operator] = STATE(19479),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19480),
    [sym_qualified_constructor_operator] = STATE(19480),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19481),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [646] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19981),
    [sym__minus] = STATE(19981),
    [sym_qualified_operator] = STATE(19981),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19388),
    [sym_qualified_constructor_operator] = STATE(19388),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20352),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [647] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19335),
    [sym__minus] = STATE(19335),
    [sym_qualified_operator] = STATE(19335),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19360),
    [sym_qualified_constructor_operator] = STATE(19360),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19323),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [648] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19763),
    [sym__minus] = STATE(19763),
    [sym_qualified_operator] = STATE(19763),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19544),
    [sym_qualified_constructor_operator] = STATE(19544),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20119),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [649] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19545),
    [sym__minus] = STATE(19545),
    [sym_qualified_operator] = STATE(19545),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19819),
    [sym_qualified_constructor_operator] = STATE(19819),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19818),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [650] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19467),
    [sym__minus] = STATE(19467),
    [sym_qualified_operator] = STATE(19467),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19468),
    [sym_qualified_constructor_operator] = STATE(19468),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19469),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [651] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19455),
    [sym__minus] = STATE(19455),
    [sym_qualified_operator] = STATE(19455),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19456),
    [sym_qualified_constructor_operator] = STATE(19456),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19457),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [652] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19443),
    [sym__minus] = STATE(19443),
    [sym_qualified_operator] = STATE(19443),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19444),
    [sym_qualified_constructor_operator] = STATE(19444),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19445),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [653] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20884),
    [sym__minus] = STATE(20884),
    [sym_qualified_operator] = STATE(20884),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19923),
    [sym_qualified_constructor_operator] = STATE(19923),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19294),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [654] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19658),
    [sym__minus] = STATE(19658),
    [sym_qualified_operator] = STATE(19658),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19436),
    [sym_qualified_constructor_operator] = STATE(19436),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19974),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [655] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19431),
    [sym__minus] = STATE(19431),
    [sym_qualified_operator] = STATE(19431),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19432),
    [sym_qualified_constructor_operator] = STATE(19432),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19433),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [656] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19601),
    [sym__minus] = STATE(19601),
    [sym_qualified_operator] = STATE(19601),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19872),
    [sym_qualified_constructor_operator] = STATE(19872),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19871),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [657] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19549),
    [sym__minus] = STATE(19549),
    [sym_qualified_operator] = STATE(19549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19284),
    [sym_qualified_constructor_operator] = STATE(19284),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19878),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [658] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19649),
    [sym__minus] = STATE(19649),
    [sym_qualified_operator] = STATE(19649),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19935),
    [sym_qualified_constructor_operator] = STATE(19935),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19933),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [659] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19419),
    [sym__minus] = STATE(19419),
    [sym_qualified_operator] = STATE(19419),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19420),
    [sym_qualified_constructor_operator] = STATE(19420),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19421),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [660] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19407),
    [sym__minus] = STATE(19407),
    [sym_qualified_operator] = STATE(19407),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19408),
    [sym_qualified_constructor_operator] = STATE(19408),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19409),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [661] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20291),
    [sym__minus] = STATE(20291),
    [sym_qualified_operator] = STATE(20291),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19169),
    [sym_qualified_constructor_operator] = STATE(19169),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19761),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [662] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19395),
    [sym__minus] = STATE(19395),
    [sym_qualified_operator] = STATE(19395),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19055),
    [sym_qualified_constructor_operator] = STATE(19055),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19397),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [663] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19004),
    [sym__minus] = STATE(19004),
    [sym_qualified_operator] = STATE(19004),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19005),
    [sym_qualified_constructor_operator] = STATE(19005),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18932),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [664] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19049),
    [sym__minus] = STATE(19049),
    [sym_qualified_operator] = STATE(19049),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(18950),
    [sym_qualified_constructor_operator] = STATE(18950),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19652),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [665] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19383),
    [sym__minus] = STATE(19383),
    [sym_qualified_operator] = STATE(19383),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19256),
    [sym_qualified_constructor_operator] = STATE(19256),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19385),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [666] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20052),
    [sym__minus] = STATE(20052),
    [sym_qualified_operator] = STATE(20052),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19599),
    [sym_qualified_constructor_operator] = STATE(19599),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20303),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [667] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19799),
    [sym__minus] = STATE(19799),
    [sym_qualified_operator] = STATE(19799),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20050),
    [sym_qualified_constructor_operator] = STATE(20050),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19028),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [668] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19371),
    [sym__minus] = STATE(19371),
    [sym_qualified_operator] = STATE(19371),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19309),
    [sym_qualified_constructor_operator] = STATE(19309),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19373),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [669] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19379),
    [sym__minus] = STATE(19379),
    [sym_qualified_operator] = STATE(19379),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19061),
    [sym_qualified_constructor_operator] = STATE(19061),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19540),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [670] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19149),
    [sym__minus] = STATE(19149),
    [sym_qualified_operator] = STATE(19149),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19396),
    [sym_qualified_constructor_operator] = STATE(19396),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19361),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [671] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19059),
    [sym__minus] = STATE(19059),
    [sym_qualified_operator] = STATE(19059),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19272),
    [sym_qualified_constructor_operator] = STATE(19272),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19435),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [672] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19359),
    [sym__minus] = STATE(19359),
    [sym_qualified_operator] = STATE(19359),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19384),
    [sym_qualified_constructor_operator] = STATE(19384),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19349),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [673] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19347),
    [sym__minus] = STATE(19347),
    [sym_qualified_operator] = STATE(19347),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19372),
    [sym_qualified_constructor_operator] = STATE(19372),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19337),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [674] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19718),
    [sym__minus] = STATE(19718),
    [sym_qualified_operator] = STATE(19718),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19425),
    [sym_qualified_constructor_operator] = STATE(19425),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19281),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [675] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19120),
    [sym__minus] = STATE(19120),
    [sym_qualified_operator] = STATE(19120),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19150),
    [sym_qualified_constructor_operator] = STATE(19150),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19064),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [676] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19321),
    [sym__minus] = STATE(19321),
    [sym_qualified_operator] = STATE(19321),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19348),
    [sym_qualified_constructor_operator] = STATE(19348),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19308),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [677] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19786),
    [sym__minus] = STATE(19786),
    [sym_qualified_operator] = STATE(19786),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19565),
    [sym_qualified_constructor_operator] = STATE(19565),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19167),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [678] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19331),
    [sym__minus] = STATE(19331),
    [sym_qualified_operator] = STATE(19331),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20738),
    [sym_qualified_constructor_operator] = STATE(20738),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19318),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [679] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19717),
    [sym__minus] = STATE(19717),
    [sym_qualified_operator] = STATE(19717),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19993),
    [sym_qualified_constructor_operator] = STATE(19993),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19992),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [680] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19033),
    [sym__minus] = STATE(19033),
    [sym_qualified_operator] = STATE(19033),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19034),
    [sym_qualified_constructor_operator] = STATE(19034),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18954),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [681] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19865),
    [sym__minus] = STATE(19865),
    [sym_qualified_operator] = STATE(19865),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19629),
    [sym_qualified_constructor_operator] = STATE(19629),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19043),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [682] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19306),
    [sym__minus] = STATE(19306),
    [sym_qualified_operator] = STATE(19306),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19336),
    [sym_qualified_constructor_operator] = STATE(19336),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19293),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [683] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19774),
    [sym__minus] = STATE(19774),
    [sym_qualified_operator] = STATE(19774),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20036),
    [sym_qualified_constructor_operator] = STATE(20036),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20035),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [684] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19950),
    [sym__minus] = STATE(19950),
    [sym_qualified_operator] = STATE(19950),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19727),
    [sym_qualified_constructor_operator] = STATE(19727),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19036),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [685] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20563),
    [sym__minus] = STATE(20563),
    [sym_qualified_operator] = STATE(20563),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20545),
    [sym_qualified_constructor_operator] = STATE(20545),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20559),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [686] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19276),
    [sym__minus] = STATE(19276),
    [sym_qualified_operator] = STATE(19276),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19307),
    [sym_qualified_constructor_operator] = STATE(19307),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19263),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [687] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19030),
    [sym__minus] = STATE(19030),
    [sym_qualified_operator] = STATE(19030),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20885),
    [sym_qualified_constructor_operator] = STATE(20885),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19597),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [688] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19821),
    [sym__minus] = STATE(19821),
    [sym_qualified_operator] = STATE(19821),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20091),
    [sym_qualified_constructor_operator] = STATE(20091),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20090),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [689] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19062),
    [sym__minus] = STATE(19062),
    [sym_qualified_operator] = STATE(19062),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19063),
    [sym_qualified_constructor_operator] = STATE(19063),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18977),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [690] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20013),
    [sym__minus] = STATE(20013),
    [sym_qualified_operator] = STATE(20013),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19788),
    [sym_qualified_constructor_operator] = STATE(19788),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18973),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [691] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19494),
    [sym__minus] = STATE(19494),
    [sym_qualified_operator] = STATE(19494),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19092),
    [sym_qualified_constructor_operator] = STATE(19092),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19006),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [692] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20947),
    [sym__minus] = STATE(20947),
    [sym_qualified_operator] = STATE(20947),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20142),
    [sym_qualified_constructor_operator] = STATE(20142),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20140),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [693] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19261),
    [sym__minus] = STATE(19261),
    [sym_qualified_operator] = STATE(19261),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19292),
    [sym_qualified_constructor_operator] = STATE(19292),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19248),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [694] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19925),
    [sym__minus] = STATE(19925),
    [sym_qualified_operator] = STATE(19925),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19287),
    [sym_qualified_constructor_operator] = STATE(19287),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20170),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [695] = {
    [sym_integer] = STATE(3980),
    [sym__literal] = STATE(3980),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = STATE(3975),
    [sym_qualified_variable] = STATE(3975),
    [sym_constructor] = STATE(3857),
    [sym_qualified_constructor] = STATE(3915),
    [sym__qcon] = STATE(3975),
    [sym_con_unit] = STATE(3980),
    [sym_con_list] = STATE(3980),
    [sym_con_tuple] = STATE(3980),
    [sym_literal] = STATE(3921),
    [sym_exp_parens] = STATE(3921),
    [sym_exp_tuple] = STATE(3921),
    [sym_exp_unboxed_tuple] = STATE(3921),
    [sym_exp_unboxed_sum] = STATE(3921),
    [sym_exp_list] = STATE(3921),
    [sym_exp_arithmetic_sequence] = STATE(3921),
    [sym_exp_list_comprehension] = STATE(3921),
    [sym_exp_section_left] = STATE(3921),
    [sym_exp_section_right] = STATE(3921),
    [sym_exp_th_quoted_name] = STATE(3921),
    [sym_exp_type_application] = STATE(623),
    [sym_exp_lambda] = STATE(9986),
    [sym_exp_let] = STATE(18820),
    [sym_exp_let_in] = STATE(9986),
    [sym_exp_cond] = STATE(9986),
    [sym_exp_case] = STATE(9986),
    [sym_exp_lambda_case] = STATE(623),
    [sym__do_keyword] = STATE(18344),
    [sym_do_module] = STATE(18344),
    [sym_exp_do] = STATE(623),
    [sym_exp_record] = STATE(3921),
    [sym_exp_name] = STATE(3921),
    [sym_exp_projection_selector] = STATE(3921),
    [sym__aexp_projection] = STATE(3921),
    [sym_exp_projection] = STATE(3921),
    [sym__aexp] = STATE(623),
    [sym__exp_apply] = STATE(9986),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12582),
    [sym_splice] = STATE(3921),
    [sym_quasiquote] = STATE(3921),
    [sym__varid] = ACTIONS(1700),
    [sym_float] = ACTIONS(1702),
    [sym_char] = ACTIONS(1702),
    [sym_string] = ACTIONS(1702),
    [sym__integer_literal] = ACTIONS(1704),
    [sym__binary_literal] = ACTIONS(1706),
    [sym__octal_literal] = ACTIONS(1706),
    [sym__hex_literal] = ACTIONS(1706),
    [anon_sym_LPAREN_POUND] = ACTIONS(1708),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1708),
    [anon_sym_2] = ACTIONS(1667),
    [anon_sym_DASH_GT] = ACTIONS(1667),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1710),
    [anon_sym_DASH] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1712),
    [anon_sym_RPAREN] = ACTIONS(1667),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(1710),
    [sym__conid] = ACTIONS(1741),
    [anon_sym_LBRACK] = ACTIONS(1717),
    [anon_sym_RBRACK] = ACTIONS(1667),
    [anon_sym_SQUOTE] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(1721),
    [anon_sym_RBRACE] = ACTIONS(1667),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(1725),
    [anon_sym_BSLASH] = ACTIONS(1727),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1729),
    [anon_sym_case] = ACTIONS(1731),
    [anon_sym_mdo] = ACTIONS(1733),
    [anon_sym_do] = ACTIONS(1733),
    [anon_sym_7] = ACTIONS(1735),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1737),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1667),
    [sym_quasiquote_start] = ACTIONS(1739),
  },
  [696] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19246),
    [sym__minus] = STATE(19246),
    [sym_qualified_operator] = STATE(19246),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19277),
    [sym_qualified_constructor_operator] = STATE(19277),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19233),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [697] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20253),
    [sym__minus] = STATE(20253),
    [sym_qualified_operator] = STATE(20253),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19868),
    [sym_qualified_constructor_operator] = STATE(19868),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19275),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [698] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20968),
    [sym__minus] = STATE(20968),
    [sym_qualified_operator] = STATE(20968),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20190),
    [sym_qualified_constructor_operator] = STATE(20190),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20189),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [699] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20808),
    [sym__minus] = STATE(20808),
    [sym_qualified_operator] = STATE(20808),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20297),
    [sym_qualified_constructor_operator] = STATE(20297),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19712),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [700] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19526),
    [sym__minus] = STATE(19526),
    [sym_qualified_operator] = STATE(19526),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20230),
    [sym_qualified_constructor_operator] = STATE(20230),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20228),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [701] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20102),
    [sym__minus] = STATE(20102),
    [sym_qualified_operator] = STATE(20102),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19880),
    [sym_qualified_constructor_operator] = STATE(19880),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19434),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [702] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19231),
    [sym__minus] = STATE(19231),
    [sym_qualified_operator] = STATE(19231),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19262),
    [sym_qualified_constructor_operator] = STATE(19262),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19208),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [703] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19206),
    [sym__minus] = STATE(19206),
    [sym_qualified_operator] = STATE(19206),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19247),
    [sym_qualified_constructor_operator] = STATE(19247),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19180),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [704] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20964),
    [sym__minus] = STATE(20964),
    [sym_qualified_operator] = STATE(20964),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20280),
    [sym_qualified_constructor_operator] = STATE(20280),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20277),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [705] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19621),
    [sym__minus] = STATE(19621),
    [sym_qualified_operator] = STATE(19621),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19958),
    [sym_qualified_constructor_operator] = STATE(19958),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19575),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [706] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19107),
    [sym__minus] = STATE(19107),
    [sym_qualified_operator] = STATE(19107),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19393),
    [sym_qualified_constructor_operator] = STATE(19393),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19942),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [707] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20234),
    [sym__minus] = STATE(20234),
    [sym_qualified_operator] = STATE(20234),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20188),
    [sym_qualified_constructor_operator] = STATE(20188),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19728),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [708] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20318),
    [sym__minus] = STATE(20318),
    [sym_qualified_operator] = STATE(20318),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(18955),
    [sym_qualified_constructor_operator] = STATE(18955),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19795),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [709] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19439),
    [sym__minus] = STATE(19439),
    [sym_qualified_operator] = STATE(19439),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20241),
    [sym_qualified_constructor_operator] = STATE(20241),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19876),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [710] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19291),
    [sym__minus] = STATE(19291),
    [sym_qualified_operator] = STATE(19291),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19322),
    [sym_qualified_constructor_operator] = STATE(19322),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19278),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [711] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19285),
    [sym__minus] = STATE(19285),
    [sym_qualified_operator] = STATE(19285),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20328),
    [sym_qualified_constructor_operator] = STATE(20328),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19961),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [712] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20882),
    [sym__minus] = STATE(20882),
    [sym_qualified_operator] = STATE(20882),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20334),
    [sym_qualified_constructor_operator] = STATE(20334),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20330),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [713] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19170),
    [sym__minus] = STATE(19170),
    [sym_qualified_operator] = STATE(19170),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20390),
    [sym_qualified_constructor_operator] = STATE(20390),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20021),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [714] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20143),
    [sym__minus] = STATE(20143),
    [sym_qualified_operator] = STATE(20143),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20375),
    [sym_qualified_constructor_operator] = STATE(20375),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20374),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [715] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(18951),
    [sym__minus] = STATE(18951),
    [sym_qualified_operator] = STATE(18951),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20538),
    [sym_qualified_constructor_operator] = STATE(20538),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20113),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [716] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20626),
    [sym__minus] = STATE(20626),
    [sym_qualified_operator] = STATE(20626),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20627),
    [sym_qualified_constructor_operator] = STATE(20627),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20314),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [717] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20191),
    [sym__minus] = STATE(20191),
    [sym_qualified_operator] = STATE(20191),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20491),
    [sym_qualified_constructor_operator] = STATE(20491),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20490),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [718] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20751),
    [sym__minus] = STATE(20751),
    [sym_qualified_operator] = STATE(20751),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20754),
    [sym_qualified_constructor_operator] = STATE(20754),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20245),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [719] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19714),
    [sym__minus] = STATE(19714),
    [sym_qualified_operator] = STATE(19714),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20304),
    [sym_qualified_constructor_operator] = STATE(20304),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19826),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [720] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20811),
    [sym__minus] = STATE(20811),
    [sym_qualified_operator] = STATE(20811),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20818),
    [sym_qualified_constructor_operator] = STATE(20818),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20329),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [721] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19178),
    [sym__minus] = STATE(19178),
    [sym_qualified_operator] = STATE(19178),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19232),
    [sym_qualified_constructor_operator] = STATE(19232),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19151),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [722] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20305),
    [sym__minus] = STATE(20305),
    [sym_qualified_operator] = STATE(20305),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20805),
    [sym_qualified_constructor_operator] = STATE(20805),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20793),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [723] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19267),
    [sym__minus] = STATE(19267),
    [sym_qualified_operator] = STATE(19267),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20933),
    [sym_qualified_constructor_operator] = STATE(20933),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20546),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [724] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19424),
    [sym__minus] = STATE(19424),
    [sym_qualified_operator] = STATE(19424),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20965),
    [sym_qualified_constructor_operator] = STATE(20965),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20646),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [725] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19310),
    [sym__minus] = STATE(19310),
    [sym_qualified_operator] = STATE(19310),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19207),
    [sym_qualified_constructor_operator] = STATE(19207),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19122),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [726] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19561),
    [sym__minus] = STATE(19561),
    [sym_qualified_operator] = STATE(19561),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20864),
    [sym_qualified_constructor_operator] = STATE(20864),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20757),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [727] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19350),
    [sym__minus] = STATE(19350),
    [sym_qualified_operator] = STATE(19350),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19179),
    [sym_qualified_constructor_operator] = STATE(19179),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19093),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [728] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20231),
    [sym__minus] = STATE(20231),
    [sym_qualified_operator] = STATE(20231),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20579),
    [sym_qualified_constructor_operator] = STATE(20579),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20573),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [729] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(18975),
    [sym__minus] = STATE(18975),
    [sym_qualified_operator] = STATE(18975),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(18976),
    [sym_qualified_constructor_operator] = STATE(18976),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18910),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [730] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20915),
    [sym__minus] = STATE(20915),
    [sym_qualified_operator] = STATE(20915),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20786),
    [sym_qualified_constructor_operator] = STATE(20786),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20822),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [731] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20881),
    [sym__minus] = STATE(20881),
    [sym_qualified_operator] = STATE(20881),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20615),
    [sym_qualified_constructor_operator] = STATE(20615),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20890),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [732] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20835),
    [sym__minus] = STATE(20835),
    [sym_qualified_operator] = STATE(20835),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20967),
    [sym_qualified_constructor_operator] = STATE(20967),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20935),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [733] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20790),
    [sym__minus] = STATE(20790),
    [sym_qualified_operator] = STATE(20790),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20946),
    [sym_qualified_constructor_operator] = STATE(20946),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20969),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [734] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19828),
    [sym__minus] = STATE(19828),
    [sym_qualified_operator] = STATE(19828),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19829),
    [sym_qualified_constructor_operator] = STATE(19829),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20049),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [735] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20748),
    [sym__minus] = STATE(20748),
    [sym_qualified_operator] = STATE(20748),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20914),
    [sym_qualified_constructor_operator] = STATE(20914),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20989),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [736] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20506),
    [sym__minus] = STATE(20506),
    [sym_qualified_operator] = STATE(20506),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20505),
    [sym_qualified_constructor_operator] = STATE(20505),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19922),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [737] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20522),
    [sym__minus] = STATE(20522),
    [sym_qualified_operator] = STATE(20522),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20663),
    [sym_qualified_constructor_operator] = STATE(20663),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20662),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [738] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20671),
    [sym__minus] = STATE(20671),
    [sym_qualified_operator] = STATE(20671),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20018),
    [sym_qualified_constructor_operator] = STATE(20018),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20966),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [739] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20583),
    [sym__minus] = STATE(20583),
    [sym_qualified_operator] = STATE(20583),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20104),
    [sym_qualified_constructor_operator] = STATE(20104),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20945),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [740] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20281),
    [sym__minus] = STATE(20281),
    [sym_qualified_operator] = STATE(20281),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19046),
    [sym_qualified_constructor_operator] = STATE(19046),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20743),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [741] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(19091),
    [sym__minus] = STATE(19091),
    [sym_qualified_operator] = STATE(19091),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(19121),
    [sym_qualified_constructor_operator] = STATE(19121),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19035),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [742] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20336),
    [sym__minus] = STATE(20336),
    [sym_qualified_operator] = STATE(20336),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20747),
    [sym_qualified_constructor_operator] = STATE(20747),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20787),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [743] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20495),
    [sym__minus] = STATE(20495),
    [sym_qualified_operator] = STATE(20495),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20879),
    [sym_qualified_constructor_operator] = STATE(20879),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20912),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [744] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20389),
    [sym__minus] = STATE(20389),
    [sym_qualified_operator] = STATE(20389),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20789),
    [sym_qualified_constructor_operator] = STATE(20789),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20832),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [745] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_operator] = STATE(20385),
    [sym__minus] = STATE(20385),
    [sym_qualified_operator] = STATE(20385),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym_constructor_operator] = STATE(20834),
    [sym_qualified_constructor_operator] = STATE(20834),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20876),
    [sym__modid] = STATE(20874),
    [aux_sym__qualifying_module] = STATE(10301),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1696),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym__varsym] = ACTIONS(423),
    [sym__consym] = ACTIONS(425),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [746] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20638),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(13999),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15546),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1759),
  },
  [747] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19610),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14343),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16349),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1761),
  },
  [748] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19243),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14357),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(17066),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1763),
  },
  [749] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19720),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14059),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16255),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1765),
  },
  [750] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19260),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14105),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(17069),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1767),
  },
  [751] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19447),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14506),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16496),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1769),
  },
  [752] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20479),
    [sym_constructor] = STATE(7030),
    [sym_constructor_operator] = STATE(20724),
    [sym_qualified_constructor_operator] = STATE(20417),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20724),
    [sym_qualified_type_operator] = STATE(20417),
    [sym__qualified_type_operator] = STATE(20417),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6044),
    [sym_annotated_type_variable] = STATE(7079),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__simpletype_infix] = STATE(13780),
    [sym__simpletype] = STATE(20482),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1781),
    [anon_sym_DASH_GT] = ACTIONS(1781),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_RPAREN] = ACTIONS(1785),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(1805),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [753] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19100),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14375),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16749),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1811),
  },
  [754] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20361),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14128),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15736),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1813),
  },
  [755] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19833),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14118),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16155),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1815),
  },
  [756] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19554),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14474),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16401),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1817),
  },
  [757] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19780),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14594),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(17318),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1819),
  },
  [758] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19696),
    [sym_constructor] = STATE(7030),
    [sym_constructor_operator] = STATE(20466),
    [sym_qualified_constructor_operator] = STATE(19694),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20466),
    [sym_qualified_type_operator] = STATE(19694),
    [sym__qualified_type_operator] = STATE(19694),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6012),
    [sym_annotated_type_variable] = STATE(7079),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19904),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15986),
    [sym__constraint_context] = STATE(15986),
    [sym__constraint] = STATE(15986),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16094),
    [sym__type_context] = STATE(16094),
    [sym__type_fun] = STATE(16094),
    [sym__type] = STATE(16094),
    [sym__type_or_implicit] = STATE(16094),
    [sym__simpletype_infix] = STATE(13780),
    [sym__simpletype] = STATE(20511),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17337),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1821),
    [anon_sym_DASH_GT] = ACTIONS(1821),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_RPAREN] = ACTIONS(1823),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1827),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [759] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19354),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14026),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16563),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1829),
  },
  [760] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19628),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14560),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16329),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1831),
  },
  [761] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20623),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14564),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15551),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1833),
  },
  [762] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20820),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14269),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15459),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1835),
  },
  [763] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(793),
    [sym_exp_lambda] = STATE(10634),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(10634),
    [sym_exp_cond] = STATE(10634),
    [sym_exp_case] = STATE(10634),
    [sym_exp_lambda_case] = STATE(793),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(793),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(793),
    [sym__exp_apply] = STATE(10634),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [anon_sym_2] = ACTIONS(1667),
    [anon_sym_DASH_GT] = ACTIONS(1667),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1667),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_PIPE] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1667),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1851),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1667),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [764] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19696),
    [sym_constructor] = STATE(7030),
    [sym_constructor_operator] = STATE(20466),
    [sym_qualified_constructor_operator] = STATE(19694),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20466),
    [sym_qualified_type_operator] = STATE(19694),
    [sym__qualified_type_operator] = STATE(19694),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6012),
    [sym_annotated_type_variable] = STATE(7079),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19904),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16094),
    [sym__type_context] = STATE(16094),
    [sym__type_fun] = STATE(16094),
    [sym__type] = STATE(16094),
    [sym__type_or_implicit] = STATE(16094),
    [sym__simpletype_infix] = STATE(13780),
    [sym__simpletype] = STATE(20511),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17337),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1821),
    [anon_sym_DASH_GT] = ACTIONS(1821),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_RPAREN] = ACTIONS(1823),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(1825),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1827),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [765] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20841),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14025),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15457),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1853),
  },
  [766] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19666),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14429),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16306),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1855),
  },
  [767] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(768),
    [sym_exp_lambda] = STATE(10395),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10395),
    [sym_exp_cond] = STATE(10395),
    [sym_exp_case] = STATE(10395),
    [sym_exp_lambda_case] = STATE(768),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(768),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(768),
    [sym__exp_apply] = STATE(10395),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [anon_sym_2] = ACTIONS(1667),
    [anon_sym_DASH_GT] = ACTIONS(1667),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1667),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_RBRACK] = ACTIONS(1667),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_EQ] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(1861),
    [anon_sym_RBRACE] = ACTIONS(1667),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1863),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1667),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [768] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(768),
    [sym_exp_lambda] = STATE(10395),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10395),
    [sym_exp_cond] = STATE(10395),
    [sym_exp_case] = STATE(10395),
    [sym_exp_lambda_case] = STATE(768),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(768),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(768),
    [sym__exp_apply] = STATE(10395),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [anon_sym_2] = ACTIONS(1636),
    [anon_sym_DASH_GT] = ACTIONS(1636),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(1636),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_RBRACK] = ACTIONS(1636),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_EQ] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(1861),
    [anon_sym_RBRACE] = ACTIONS(1636),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1863),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1636),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [769] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19363),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14510),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16551),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1868),
  },
  [770] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20312),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14165),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15796),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1870),
  },
  [771] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20798),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14445),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(17661),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1872),
  },
  [772] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20479),
    [sym_constructor] = STATE(7030),
    [sym_constructor_operator] = STATE(20376),
    [sym_qualified_constructor_operator] = STATE(20417),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20376),
    [sym_qualified_type_operator] = STATE(20417),
    [sym__qualified_type_operator] = STATE(20417),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6044),
    [sym_annotated_type_variable] = STATE(7079),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__simpletype_infix] = STATE(13780),
    [sym__simpletype] = STATE(20746),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1781),
    [anon_sym_DASH_GT] = ACTIONS(1781),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_RPAREN] = ACTIONS(1785),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(1874),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [773] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19288),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14543),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16591),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1876),
  },
  [774] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20262),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14166),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15831),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1878),
  },
  [775] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19047),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14395),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16971),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1880),
  },
  [776] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19406),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14387),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(17025),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1882),
  },
  [777] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19418),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14313),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(17152),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1884),
  },
  [778] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20594),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14115),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15569),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1886),
  },
  [779] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20181),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14303),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15890),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1888),
  },
  [780] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19849),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14485),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16143),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1890),
  },
  [781] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19058),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14530),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16781),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1892),
  },
  [782] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20244),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14310),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(17514),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1894),
  },
  [783] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19768),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14349),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16211),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1896),
  },
  [784] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20514),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14072),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15641),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1898),
  },
  [785] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(18960),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14451),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16876),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1900),
  },
  [786] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20734),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14495),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(17724),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1902),
  },
  [787] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20041),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14391),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15972),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1904),
  },
  [788] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20127),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14205),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15926),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1906),
  },
  [789] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20479),
    [sym_constructor] = STATE(7030),
    [sym_constructor_operator] = STATE(20275),
    [sym_qualified_constructor_operator] = STATE(20417),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20275),
    [sym_qualified_type_operator] = STATE(20417),
    [sym__qualified_type_operator] = STATE(20417),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6044),
    [sym_annotated_type_variable] = STATE(7079),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__simpletype_infix] = STATE(13780),
    [sym__simpletype] = STATE(20151),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1781),
    [anon_sym_DASH_GT] = ACTIONS(1781),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_RPAREN] = ACTIONS(1785),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(1908),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [790] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20513),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14370),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15640),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1910),
  },
  [791] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(18939),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14240),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16891),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1912),
  },
  [792] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20377),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14300),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15715),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1914),
  },
  [793] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(793),
    [sym_exp_lambda] = STATE(10634),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(10634),
    [sym_exp_cond] = STATE(10634),
    [sym_exp_case] = STATE(10634),
    [sym_exp_lambda_case] = STATE(793),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(793),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(793),
    [sym__exp_apply] = STATE(10634),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [anon_sym_2] = ACTIONS(1636),
    [anon_sym_DASH_GT] = ACTIONS(1636),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(1916),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1636),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(1849),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1851),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1636),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [794] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19989),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14247),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16021),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1919),
  },
  [795] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19932),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14459),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16071),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1921),
  },
  [796] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20004),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14208),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(17404),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1923),
  },
  [797] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19054),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14291),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16786),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1925),
  },
  [798] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19176),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14593),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16686),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1927),
  },
  [799] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(20056),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(13987),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(15974),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1929),
  },
  [800] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym__exp_unboxed_sum] = STATE(19888),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8939),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8939),
    [sym_exp_cond] = STATE(8939),
    [sym_exp_if_guard] = STATE(8939),
    [sym_exp_case] = STATE(8939),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8939),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8939),
    [sym__lexp] = STATE(8939),
    [sym_exp_infix] = STATE(8939),
    [sym__exp_infix] = STATE(8939),
    [sym__exp] = STATE(14295),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [aux_sym__exp_tuple_repeat1] = STATE(16116),
    [aux_sym__exp_unboxed_sum_repeat1] = STATE(15552),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1757),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(575),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1931),
  },
  [801] = {
    [sym_integer] = STATE(4332),
    [sym__literal] = STATE(4332),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(4280),
    [sym_qualified_variable] = STATE(4280),
    [sym_constructor] = STATE(4074),
    [sym_qualified_constructor] = STATE(4305),
    [sym__qcon] = STATE(4280),
    [sym_con_unit] = STATE(4332),
    [sym_con_list] = STATE(4332),
    [sym_con_tuple] = STATE(4332),
    [sym_literal] = STATE(4217),
    [sym_exp_parens] = STATE(4217),
    [sym_exp_tuple] = STATE(4217),
    [sym_exp_unboxed_tuple] = STATE(4217),
    [sym_exp_unboxed_sum] = STATE(4217),
    [sym_exp_list] = STATE(4217),
    [sym_exp_arithmetic_sequence] = STATE(4217),
    [sym_exp_list_comprehension] = STATE(4217),
    [sym_exp_section_left] = STATE(4217),
    [sym_exp_section_right] = STATE(4217),
    [sym_exp_th_quoted_name] = STATE(4217),
    [sym_exp_type_application] = STATE(802),
    [sym_exp_lambda] = STATE(11028),
    [sym_exp_let] = STATE(18577),
    [sym_exp_let_in] = STATE(11028),
    [sym_exp_cond] = STATE(11028),
    [sym_exp_case] = STATE(11028),
    [sym_exp_lambda_case] = STATE(802),
    [sym__do_keyword] = STATE(18152),
    [sym_do_module] = STATE(18152),
    [sym_exp_do] = STATE(802),
    [sym_exp_record] = STATE(4217),
    [sym_exp_name] = STATE(4217),
    [sym_exp_projection_selector] = STATE(4217),
    [sym__aexp_projection] = STATE(4217),
    [sym_exp_projection] = STATE(4217),
    [sym__aexp] = STATE(802),
    [sym__exp_apply] = STATE(11028),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12567),
    [sym_splice] = STATE(4217),
    [sym_quasiquote] = STATE(4217),
    [sym__varid] = ACTIONS(1933),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(1935),
    [sym_char] = ACTIONS(1935),
    [sym_string] = ACTIONS(1935),
    [sym__integer_literal] = ACTIONS(1937),
    [sym__binary_literal] = ACTIONS(1939),
    [sym__octal_literal] = ACTIONS(1939),
    [sym__hex_literal] = ACTIONS(1939),
    [anon_sym_LPAREN_POUND] = ACTIONS(1941),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1941),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(1943),
    [sym__conid] = ACTIONS(1947),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1953),
    [anon_sym_PIPE] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(1959),
    [anon_sym_BSLASH] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(1670),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1963),
    [anon_sym_case] = ACTIONS(1965),
    [anon_sym_mdo] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_7] = ACTIONS(1969),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1667),
    [sym__layout_end] = ACTIONS(1667),
    [sym_where] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(1971),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1973),
  },
  [802] = {
    [sym_integer] = STATE(4332),
    [sym__literal] = STATE(4332),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(4280),
    [sym_qualified_variable] = STATE(4280),
    [sym_constructor] = STATE(4074),
    [sym_qualified_constructor] = STATE(4305),
    [sym__qcon] = STATE(4280),
    [sym_con_unit] = STATE(4332),
    [sym_con_list] = STATE(4332),
    [sym_con_tuple] = STATE(4332),
    [sym_literal] = STATE(4217),
    [sym_exp_parens] = STATE(4217),
    [sym_exp_tuple] = STATE(4217),
    [sym_exp_unboxed_tuple] = STATE(4217),
    [sym_exp_unboxed_sum] = STATE(4217),
    [sym_exp_list] = STATE(4217),
    [sym_exp_arithmetic_sequence] = STATE(4217),
    [sym_exp_list_comprehension] = STATE(4217),
    [sym_exp_section_left] = STATE(4217),
    [sym_exp_section_right] = STATE(4217),
    [sym_exp_th_quoted_name] = STATE(4217),
    [sym_exp_type_application] = STATE(802),
    [sym_exp_lambda] = STATE(11028),
    [sym_exp_let] = STATE(18577),
    [sym_exp_let_in] = STATE(11028),
    [sym_exp_cond] = STATE(11028),
    [sym_exp_case] = STATE(11028),
    [sym_exp_lambda_case] = STATE(802),
    [sym__do_keyword] = STATE(18152),
    [sym_do_module] = STATE(18152),
    [sym_exp_do] = STATE(802),
    [sym_exp_record] = STATE(4217),
    [sym_exp_name] = STATE(4217),
    [sym_exp_projection_selector] = STATE(4217),
    [sym__aexp_projection] = STATE(4217),
    [sym_exp_projection] = STATE(4217),
    [sym__aexp] = STATE(802),
    [sym__exp_apply] = STATE(11028),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12567),
    [sym_splice] = STATE(4217),
    [sym_quasiquote] = STATE(4217),
    [sym__varid] = ACTIONS(1933),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(1935),
    [sym_char] = ACTIONS(1935),
    [sym_string] = ACTIONS(1935),
    [sym__integer_literal] = ACTIONS(1937),
    [sym__binary_literal] = ACTIONS(1939),
    [sym__octal_literal] = ACTIONS(1939),
    [sym__hex_literal] = ACTIONS(1939),
    [anon_sym_LPAREN_POUND] = ACTIONS(1941),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1941),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(1943),
    [sym__conid] = ACTIONS(1975),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1953),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(1955),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(1959),
    [anon_sym_BSLASH] = ACTIONS(1961),
    [anon_sym_in] = ACTIONS(1642),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1963),
    [anon_sym_case] = ACTIONS(1965),
    [anon_sym_mdo] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_7] = ACTIONS(1969),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1636),
    [sym__layout_end] = ACTIONS(1636),
    [sym_where] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(1971),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1973),
  },
  [803] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(16164),
    [sym_gdpat] = STATE(10016),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17980),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10016),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [804] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(16065),
    [sym_gdpat] = STATE(10428),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17949),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10428),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [805] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20479),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20417),
    [sym_qualified_constructor_operator] = STATE(20417),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20417),
    [sym_qualified_type_operator] = STATE(20417),
    [sym__qualified_type_operator] = STATE(20417),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6824),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1781),
    [anon_sym_DASH_GT] = ACTIONS(1781),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1785),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [806] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20133),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20132),
    [sym_qualified_constructor_operator] = STATE(20132),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20132),
    [sym_qualified_type_operator] = STATE(20132),
    [sym__qualified_type_operator] = STATE(20132),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6809),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20224),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17492),
    [sym__type_context] = STATE(17492),
    [sym__type_fun] = STATE(17492),
    [sym__type] = STATE(17492),
    [sym__type_or_implicit] = STATE(17492),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17065),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1986),
    [anon_sym_DASH_GT] = ACTIONS(1986),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1988),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(1990),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1992),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [807] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19312),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19316),
    [sym_qualified_constructor_operator] = STATE(19316),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19316),
    [sym_qualified_type_operator] = STATE(19316),
    [sym__qualified_type_operator] = STATE(19316),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6890),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1994),
    [anon_sym_DASH_GT] = ACTIONS(1994),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1785),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(1996),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [808] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(17303),
    [sym_gdpat] = STATE(9911),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17943),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(9911),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [809] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19299),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19297),
    [sym_qualified_constructor_operator] = STATE(19297),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19297),
    [sym_qualified_type_operator] = STATE(19297),
    [sym__qualified_type_operator] = STATE(19297),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6841),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19296),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17079),
    [sym__type_context] = STATE(17079),
    [sym__type_fun] = STATE(17079),
    [sym__type] = STATE(17079),
    [sym__type_or_implicit] = STATE(17079),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16587),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1998),
    [anon_sym_DASH_GT] = ACTIONS(1998),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2000),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2002),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2004),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [810] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19696),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19694),
    [sym_qualified_constructor_operator] = STATE(19694),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19694),
    [sym_qualified_type_operator] = STATE(19694),
    [sym__qualified_type_operator] = STATE(19694),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6847),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15986),
    [sym__constraint_context] = STATE(15986),
    [sym__constraint] = STATE(15986),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1821),
    [anon_sym_DASH_GT] = ACTIONS(1821),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1785),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2006),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [811] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19807),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19808),
    [sym_qualified_constructor_operator] = STATE(19808),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19808),
    [sym_qualified_type_operator] = STATE(19808),
    [sym__qualified_type_operator] = STATE(19808),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6918),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19814),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17331),
    [sym__type_context] = STATE(17331),
    [sym__type_fun] = STATE(17331),
    [sym__type] = STATE(17331),
    [sym__type_or_implicit] = STATE(17331),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17722),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2008),
    [anon_sym_DASH_GT] = ACTIONS(2008),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2010),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2012),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2014),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [812] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(15489),
    [sym_gdpat] = STATE(10391),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18039),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10391),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [813] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20902),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20899),
    [sym_qualified_constructor_operator] = STATE(20899),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20899),
    [sym_qualified_type_operator] = STATE(20899),
    [sym__qualified_type_operator] = STATE(20899),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6894),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20766),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17672),
    [sym__type_context] = STATE(17672),
    [sym__type_fun] = STATE(17672),
    [sym__type] = STATE(17672),
    [sym__type_or_implicit] = STATE(17672),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17476),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2016),
    [anon_sym_DASH_GT] = ACTIONS(2016),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2018),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2020),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2022),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [814] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19184),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19185),
    [sym_qualified_constructor_operator] = STATE(19185),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19185),
    [sym_qualified_type_operator] = STATE(19185),
    [sym__qualified_type_operator] = STATE(19185),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6837),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19186),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16678),
    [sym__type_context] = STATE(16678),
    [sym__type_fun] = STATE(16678),
    [sym__type] = STATE(16678),
    [sym__type_or_implicit] = STATE(16678),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16421),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2024),
    [anon_sym_DASH_GT] = ACTIONS(2024),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2026),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2030),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [815] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(15952),
    [sym_gdpat] = STATE(11059),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18005),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(11059),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [816] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19212),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19213),
    [sym_qualified_constructor_operator] = STATE(19213),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19213),
    [sym_qualified_type_operator] = STATE(19213),
    [sym__qualified_type_operator] = STATE(19213),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6840),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19214),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16651),
    [sym__type_context] = STATE(16651),
    [sym__type_fun] = STATE(16651),
    [sym__type] = STATE(16651),
    [sym__type_or_implicit] = STATE(16651),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16413),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2032),
    [anon_sym_DASH_GT] = ACTIONS(2032),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2034),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2036),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2038),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [817] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20242),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20239),
    [sym_qualified_constructor_operator] = STATE(20239),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20239),
    [sym_qualified_type_operator] = STATE(20239),
    [sym__qualified_type_operator] = STATE(20239),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6814),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20238),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15853),
    [sym__type_context] = STATE(15853),
    [sym__type_fun] = STATE(15853),
    [sym__type] = STATE(15853),
    [sym__type_or_implicit] = STATE(15853),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17265),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2040),
    [anon_sym_DASH_GT] = ACTIONS(2040),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2042),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2044),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2046),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [818] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19645),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19661),
    [sym_qualified_constructor_operator] = STATE(19661),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19661),
    [sym_qualified_type_operator] = STATE(19661),
    [sym__qualified_type_operator] = STATE(19661),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6794),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19670),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17269),
    [sym__type_context] = STATE(17269),
    [sym__type_fun] = STATE(17269),
    [sym__type] = STATE(17269),
    [sym__type_or_implicit] = STATE(17269),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17759),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2048),
    [anon_sym_DASH_GT] = ACTIONS(2048),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2052),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2054),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [819] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20339),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20342),
    [sym_qualified_constructor_operator] = STATE(20342),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20342),
    [sym_qualified_type_operator] = STATE(20342),
    [sym__qualified_type_operator] = STATE(20342),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6900),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19705),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17282),
    [sym__type_context] = STATE(17282),
    [sym__type_fun] = STATE(17282),
    [sym__type] = STATE(17282),
    [sym__type_or_implicit] = STATE(17282),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16729),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2056),
    [anon_sym_DASH_GT] = ACTIONS(2056),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2058),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2060),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2062),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [820] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(15790),
    [sym_gdpat] = STATE(9263),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17964),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(9263),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [821] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(17303),
    [sym_gdpat] = STATE(9940),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17937),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(9940),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [822] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(16065),
    [sym_gdpat] = STATE(10613),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17995),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10613),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [823] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20986),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20985),
    [sym_qualified_constructor_operator] = STATE(20985),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20985),
    [sym_qualified_type_operator] = STATE(20985),
    [sym__qualified_type_operator] = STATE(20985),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6865),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20952),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17765),
    [sym__type_context] = STATE(17765),
    [sym__type_fun] = STATE(17765),
    [sym__type] = STATE(17765),
    [sym__type_or_implicit] = STATE(17765),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17417),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2064),
    [anon_sym_DASH_GT] = ACTIONS(2064),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2066),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2068),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2070),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [824] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20949),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20950),
    [sym_qualified_constructor_operator] = STATE(20950),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20950),
    [sym_qualified_type_operator] = STATE(20950),
    [sym__qualified_type_operator] = STATE(20950),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6816),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20502),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17629),
    [sym__type_context] = STATE(17629),
    [sym__type_fun] = STATE(17629),
    [sym__type] = STATE(17629),
    [sym__type_or_implicit] = STATE(17629),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15938),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2072),
    [anon_sym_DASH_GT] = ACTIONS(2072),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2074),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2076),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2078),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [825] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(15635),
    [sym_gdpat] = STATE(10174),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17986),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10174),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [826] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20339),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20342),
    [sym_qualified_constructor_operator] = STATE(20342),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20342),
    [sym_qualified_type_operator] = STATE(20342),
    [sym__qualified_type_operator] = STATE(20342),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6900),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2056),
    [anon_sym_DASH_GT] = ACTIONS(2056),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1785),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2060),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [827] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(15790),
    [sym_gdpat] = STATE(9332),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18012),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(9332),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [828] = {
    [sym_integer] = STATE(4830),
    [sym__literal] = STATE(4830),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = STATE(4419),
    [sym_qualified_variable] = STATE(4419),
    [sym_constructor] = STATE(4257),
    [sym_qualified_constructor] = STATE(4416),
    [sym__qcon] = STATE(4419),
    [sym_con_unit] = STATE(4830),
    [sym_con_list] = STATE(4830),
    [sym_con_tuple] = STATE(4830),
    [sym_literal] = STATE(4455),
    [sym_exp_parens] = STATE(4455),
    [sym_exp_tuple] = STATE(4455),
    [sym_exp_unboxed_tuple] = STATE(4455),
    [sym_exp_unboxed_sum] = STATE(4455),
    [sym_exp_list] = STATE(4455),
    [sym_exp_arithmetic_sequence] = STATE(4455),
    [sym_exp_list_comprehension] = STATE(4455),
    [sym_exp_section_left] = STATE(4455),
    [sym_exp_section_right] = STATE(4455),
    [sym_exp_th_quoted_name] = STATE(4455),
    [sym_exp_type_application] = STATE(887),
    [sym_exp_lambda] = STATE(11828),
    [sym_exp_let] = STATE(18318),
    [sym_exp_let_in] = STATE(11828),
    [sym_exp_cond] = STATE(11828),
    [sym_exp_case] = STATE(11828),
    [sym_exp_lambda_case] = STATE(887),
    [sym__do_keyword] = STATE(18263),
    [sym_do_module] = STATE(18263),
    [sym_exp_do] = STATE(887),
    [sym_exp_record] = STATE(4455),
    [sym_exp_name] = STATE(4455),
    [sym_exp_projection_selector] = STATE(4455),
    [sym__aexp_projection] = STATE(4455),
    [sym_exp_projection] = STATE(4455),
    [sym__aexp] = STATE(887),
    [sym__exp_apply] = STATE(11828),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12635),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(2080),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(2082),
    [sym_char] = ACTIONS(2082),
    [sym_string] = ACTIONS(2082),
    [sym__integer_literal] = ACTIONS(2084),
    [sym__binary_literal] = ACTIONS(2086),
    [sym__octal_literal] = ACTIONS(2086),
    [sym__hex_literal] = ACTIONS(2086),
    [anon_sym_LPAREN_POUND] = ACTIONS(2088),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2088),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2090),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(2090),
    [sym__conid] = ACTIONS(2094),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_PIPE] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(2102),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_BSLASH] = ACTIONS(2108),
    [anon_sym_in] = ACTIONS(1670),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2110),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_mdo] = ACTIONS(2114),
    [anon_sym_do] = ACTIONS(2114),
    [anon_sym_7] = ACTIONS(2116),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1667),
    [sym_where] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(2118),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2120),
  },
  [829] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19483),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19482),
    [sym_qualified_constructor_operator] = STATE(19482),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19482),
    [sym_qualified_type_operator] = STATE(19482),
    [sym__qualified_type_operator] = STATE(19482),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6853),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19478),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17183),
    [sym__type_context] = STATE(17183),
    [sym__type_fun] = STATE(17183),
    [sym__type] = STATE(17183),
    [sym__type_or_implicit] = STATE(17183),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16617),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2122),
    [anon_sym_DASH_GT] = ACTIONS(2122),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2124),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2128),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [830] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19578),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19592),
    [sym_qualified_constructor_operator] = STATE(19592),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19592),
    [sym_qualified_type_operator] = STATE(19592),
    [sym__qualified_type_operator] = STATE(19592),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6898),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19593),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17238),
    [sym__type_context] = STATE(17238),
    [sym__type_fun] = STATE(17238),
    [sym__type] = STATE(17238),
    [sym__type_or_implicit] = STATE(17238),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17785),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2130),
    [anon_sym_DASH_GT] = ACTIONS(2130),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2132),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2134),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2136),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [831] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(15635),
    [sym_gdpat] = STATE(9629),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18023),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(9629),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [832] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(16547),
    [sym_gdpat] = STATE(10281),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17956),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10281),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [833] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20872),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20870),
    [sym_qualified_constructor_operator] = STATE(20870),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20870),
    [sym_qualified_type_operator] = STATE(20870),
    [sym__qualified_type_operator] = STATE(20870),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6935),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20936),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17758),
    [sym__type_context] = STATE(17758),
    [sym__type_fun] = STATE(17758),
    [sym__type] = STATE(17758),
    [sym__type_or_implicit] = STATE(17758),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17329),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2138),
    [anon_sym_DASH_GT] = ACTIONS(2138),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2140),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2142),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2144),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [834] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20087),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20086),
    [sym_qualified_constructor_operator] = STATE(20086),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20086),
    [sym_qualified_type_operator] = STATE(20086),
    [sym__qualified_type_operator] = STATE(20086),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6835),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20178),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17475),
    [sym__type_context] = STATE(17475),
    [sym__type_fun] = STATE(17475),
    [sym__type] = STATE(17475),
    [sym__type_or_implicit] = STATE(17475),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17034),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2146),
    [anon_sym_DASH_GT] = ACTIONS(2146),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2148),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2150),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2152),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [835] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19325),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19303),
    [sym_qualified_constructor_operator] = STATE(19303),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19303),
    [sym_qualified_type_operator] = STATE(19303),
    [sym__qualified_type_operator] = STATE(19303),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6811),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19836),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17333),
    [sym__type_context] = STATE(17333),
    [sym__type_fun] = STATE(17333),
    [sym__type] = STATE(17333),
    [sym__type_or_implicit] = STATE(17333),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15556),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2154),
    [anon_sym_DASH_GT] = ACTIONS(2154),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2156),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2158),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2160),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [836] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19568),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19567),
    [sym_qualified_constructor_operator] = STATE(19567),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19567),
    [sym_qualified_type_operator] = STATE(19567),
    [sym__qualified_type_operator] = STATE(19567),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6828),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19804),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16183),
    [sym__type_context] = STATE(16183),
    [sym__type_fun] = STATE(16183),
    [sym__type] = STATE(16183),
    [sym__type_or_implicit] = STATE(16183),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17542),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2162),
    [anon_sym_DASH_GT] = ACTIONS(2162),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2164),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2168),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [837] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(16779),
    [sym_gdpat] = STATE(10688),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17968),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10688),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [838] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20184),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20182),
    [sym_qualified_constructor_operator] = STATE(20182),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20182),
    [sym_qualified_type_operator] = STATE(20182),
    [sym__qualified_type_operator] = STATE(20182),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6966),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20222),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17516),
    [sym__type_context] = STATE(17516),
    [sym__type_fun] = STATE(17516),
    [sym__type] = STATE(17516),
    [sym__type_or_implicit] = STATE(17516),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17080),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2172),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2174),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2176),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [839] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19533),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19532),
    [sym_qualified_constructor_operator] = STATE(19532),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19532),
    [sym_qualified_type_operator] = STATE(19532),
    [sym__qualified_type_operator] = STATE(19532),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6863),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19530),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17214),
    [sym__type_context] = STATE(17214),
    [sym__type_fun] = STATE(17214),
    [sym__type] = STATE(17214),
    [sym__type_or_implicit] = STATE(17214),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16623),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2178),
    [anon_sym_DASH_GT] = ACTIONS(2178),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2180),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2182),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2184),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [840] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20287),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20284),
    [sym_qualified_constructor_operator] = STATE(20284),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20284),
    [sym_qualified_type_operator] = STATE(20284),
    [sym__qualified_type_operator] = STATE(20284),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6887),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2186),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1785),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2188),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [841] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19451),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19452),
    [sym_qualified_constructor_operator] = STATE(19452),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19452),
    [sym_qualified_type_operator] = STATE(19452),
    [sym__qualified_type_operator] = STATE(19452),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6802),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2190),
    [anon_sym_DASH_GT] = ACTIONS(2190),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1785),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2192),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [842] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(15489),
    [sym_gdpat] = STATE(10605),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17984),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10605),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [843] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20780),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20778),
    [sym_qualified_constructor_operator] = STATE(20778),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20778),
    [sym_qualified_type_operator] = STATE(20778),
    [sym__qualified_type_operator] = STATE(20778),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6932),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20868),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17719),
    [sym__type_context] = STATE(17719),
    [sym__type_fun] = STATE(17719),
    [sym__type] = STATE(17719),
    [sym__type_or_implicit] = STATE(17719),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17308),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2194),
    [anon_sym_DASH_GT] = ACTIONS(2194),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2196),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2200),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [844] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19451),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19452),
    [sym_qualified_constructor_operator] = STATE(19452),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19452),
    [sym_qualified_type_operator] = STATE(19452),
    [sym__qualified_type_operator] = STATE(19452),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6802),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19162),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16699),
    [sym__type_context] = STATE(16699),
    [sym__type_fun] = STATE(16699),
    [sym__type] = STATE(16699),
    [sym__type_or_implicit] = STATE(16699),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16031),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2190),
    [anon_sym_DASH_GT] = ACTIONS(2190),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2202),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2192),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2204),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [845] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20116),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20120),
    [sym_qualified_constructor_operator] = STATE(20120),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20120),
    [sym_qualified_type_operator] = STATE(20120),
    [sym__qualified_type_operator] = STATE(20120),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6996),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20125),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17455),
    [sym__type_context] = STATE(17455),
    [sym__type_fun] = STATE(17455),
    [sym__type] = STATE(17455),
    [sym__type_or_implicit] = STATE(17455),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17633),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2206),
    [anon_sym_DASH_GT] = ACTIONS(2206),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2212),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [846] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19155),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19156),
    [sym_qualified_constructor_operator] = STATE(19156),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19156),
    [sym_qualified_type_operator] = STATE(19156),
    [sym__qualified_type_operator] = STATE(19156),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6921),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19157),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16703),
    [sym__type_context] = STATE(16703),
    [sym__type_fun] = STATE(16703),
    [sym__type] = STATE(16703),
    [sym__type_or_implicit] = STATE(16703),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16433),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2216),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2220),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [847] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19249),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19245),
    [sym_qualified_constructor_operator] = STATE(19245),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19245),
    [sym_qualified_type_operator] = STATE(19245),
    [sym__qualified_type_operator] = STATE(19245),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6916),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19244),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17064),
    [sym__type_context] = STATE(17064),
    [sym__type_fun] = STATE(17064),
    [sym__type] = STATE(17064),
    [sym__type_or_implicit] = STATE(17064),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16580),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2222),
    [anon_sym_DASH_GT] = ACTIONS(2222),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2224),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2228),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [848] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19362),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19497),
    [sym_qualified_constructor_operator] = STATE(19497),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19497),
    [sym_qualified_type_operator] = STATE(19497),
    [sym__qualified_type_operator] = STATE(19497),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6801),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1785),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [849] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20107),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20105),
    [sym_qualified_constructor_operator] = STATE(20105),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20105),
    [sym_qualified_type_operator] = STATE(20105),
    [sym__qualified_type_operator] = STATE(20105),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6826),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20098),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15948),
    [sym__type_context] = STATE(15948),
    [sym__type_fun] = STATE(15948),
    [sym__type] = STATE(15948),
    [sym__type_or_implicit] = STATE(15948),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17296),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2236),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2240),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [850] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20483),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20481),
    [sym_qualified_constructor_operator] = STATE(20481),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20481),
    [sym_qualified_type_operator] = STATE(20481),
    [sym__qualified_type_operator] = STATE(20481),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7014),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19269),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16610),
    [sym__type_context] = STATE(16610),
    [sym__type_fun] = STATE(16610),
    [sym__type] = STATE(16610),
    [sym__type_or_implicit] = STATE(16610),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17120),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2244),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2248),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [851] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20349),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20348),
    [sym_qualified_constructor_operator] = STATE(20348),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20348),
    [sym_qualified_type_operator] = STATE(20348),
    [sym__qualified_type_operator] = STATE(20348),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6813),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20346),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15758),
    [sym__type_context] = STATE(15758),
    [sym__type_fun] = STATE(15758),
    [sym__type] = STATE(15758),
    [sym__type_or_implicit] = STATE(15758),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17234),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2252),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2256),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [852] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20483),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20481),
    [sym_qualified_constructor_operator] = STATE(20481),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20481),
    [sym_qualified_type_operator] = STATE(20481),
    [sym__qualified_type_operator] = STATE(20481),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7014),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1785),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [853] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19312),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19316),
    [sym_qualified_constructor_operator] = STATE(19316),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19316),
    [sym_qualified_type_operator] = STATE(19316),
    [sym__qualified_type_operator] = STATE(19316),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6890),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19317),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17087),
    [sym__type_context] = STATE(17087),
    [sym__type_fun] = STATE(17087),
    [sym__type] = STATE(17087),
    [sym__type_or_implicit] = STATE(17087),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17761),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1994),
    [anon_sym_DASH_GT] = ACTIONS(1994),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2258),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(1996),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2260),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [854] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19123),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19119),
    [sym_qualified_constructor_operator] = STATE(19119),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19119),
    [sym_qualified_type_operator] = STATE(19119),
    [sym__qualified_type_operator] = STATE(19119),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6957),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19115),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16992),
    [sym__type_context] = STATE(16992),
    [sym__type_fun] = STATE(16992),
    [sym__type] = STATE(16992),
    [sym__type_or_implicit] = STATE(16992),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16564),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2262),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2264),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2268),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [855] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19696),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19694),
    [sym_qualified_constructor_operator] = STATE(19694),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19694),
    [sym_qualified_type_operator] = STATE(19694),
    [sym__qualified_type_operator] = STATE(19694),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6847),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19904),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16094),
    [sym__type_context] = STATE(16094),
    [sym__type_fun] = STATE(16094),
    [sym__type] = STATE(16094),
    [sym__type_or_implicit] = STATE(16094),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17337),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1821),
    [anon_sym_DASH_GT] = ACTIONS(1821),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1823),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2006),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1827),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [856] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20287),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20284),
    [sym_qualified_constructor_operator] = STATE(20284),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20284),
    [sym_qualified_type_operator] = STATE(20284),
    [sym__qualified_type_operator] = STATE(20284),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6887),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19691),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16282),
    [sym__type_context] = STATE(16282),
    [sym__type_fun] = STATE(16282),
    [sym__type] = STATE(16282),
    [sym__type_or_implicit] = STATE(16282),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16221),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2186),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2270),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2188),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2272),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [857] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(17053),
    [sym_gdpat] = STATE(10215),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17960),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10215),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [858] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(16779),
    [sym_gdpat] = STATE(10365),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17953),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10365),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [859] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(16547),
    [sym_gdpat] = STATE(10067),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17971),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10067),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [860] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20415),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20422),
    [sym_qualified_constructor_operator] = STATE(20422),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20422),
    [sym_qualified_type_operator] = STATE(20422),
    [sym__qualified_type_operator] = STATE(20422),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7018),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1785),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [861] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20415),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20422),
    [sym_qualified_constructor_operator] = STATE(20422),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20422),
    [sym_qualified_type_operator] = STATE(20422),
    [sym__qualified_type_operator] = STATE(20422),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7018),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19859),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17347),
    [sym__type_context] = STATE(17347),
    [sym__type_fun] = STATE(17347),
    [sym__type] = STATE(17347),
    [sym__type_or_implicit] = STATE(17347),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16850),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2278),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2280),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [862] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(16164),
    [sym_gdpat] = STATE(10302),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17991),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10302),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [863] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(15458),
    [sym_gdpat] = STATE(9566),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18033),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(9566),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [864] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20255),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20258),
    [sym_qualified_constructor_operator] = STATE(20258),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20258),
    [sym_qualified_type_operator] = STATE(20258),
    [sym__qualified_type_operator] = STATE(20258),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7007),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20266),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17517),
    [sym__type_context] = STATE(17517),
    [sym__type_fun] = STATE(17517),
    [sym__type] = STATE(17517),
    [sym__type_or_implicit] = STATE(17517),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17582),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2284),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2288),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [865] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(865),
    [sym_exp_lambda] = STATE(11883),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(11883),
    [sym_exp_cond] = STATE(11883),
    [sym_exp_case] = STATE(11883),
    [sym_exp_lambda_case] = STATE(865),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(865),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(865),
    [sym__exp_apply] = STATE(11883),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [anon_sym_2] = ACTIONS(1636),
    [anon_sym_DASH_GT] = ACTIONS(1636),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(2290),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2295),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1636),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1636),
  },
  [866] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19068),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19069),
    [sym_qualified_constructor_operator] = STATE(19069),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19069),
    [sym_qualified_type_operator] = STATE(19069),
    [sym__qualified_type_operator] = STATE(19069),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6904),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19070),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16773),
    [sym__type_context] = STATE(16773),
    [sym__type_fun] = STATE(16773),
    [sym__type] = STATE(16773),
    [sym__type_or_implicit] = STATE(16773),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16468),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2297),
    [anon_sym_DASH_GT] = ACTIONS(2297),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2299),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2301),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2303),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [867] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(17053),
    [sym_gdpat] = STATE(10191),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17947),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10191),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [868] = {
    [sym_integer] = STATE(4662),
    [sym__literal] = STATE(4662),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = STATE(4833),
    [sym_qualified_variable] = STATE(4833),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4790),
    [sym__qcon] = STATE(4833),
    [sym_con_unit] = STATE(4662),
    [sym_con_list] = STATE(4662),
    [sym_con_tuple] = STATE(4662),
    [sym_literal] = STATE(4650),
    [sym_exp_parens] = STATE(4650),
    [sym_exp_tuple] = STATE(4650),
    [sym_exp_unboxed_tuple] = STATE(4650),
    [sym_exp_unboxed_sum] = STATE(4650),
    [sym_exp_list] = STATE(4650),
    [sym_exp_arithmetic_sequence] = STATE(4650),
    [sym_exp_list_comprehension] = STATE(4650),
    [sym_exp_section_left] = STATE(4650),
    [sym_exp_section_right] = STATE(4650),
    [sym_exp_th_quoted_name] = STATE(4650),
    [sym_exp_type_application] = STATE(868),
    [sym_exp_lambda] = STATE(11808),
    [sym_exp_let] = STATE(18846),
    [sym_exp_let_in] = STATE(11808),
    [sym_exp_cond] = STATE(11808),
    [sym_exp_case] = STATE(11808),
    [sym_exp_lambda_case] = STATE(868),
    [sym__do_keyword] = STATE(18352),
    [sym_do_module] = STATE(18352),
    [sym_exp_do] = STATE(868),
    [sym_exp_record] = STATE(4650),
    [sym_exp_name] = STATE(4650),
    [sym_exp_projection_selector] = STATE(4650),
    [sym__aexp_projection] = STATE(4650),
    [sym_exp_projection] = STATE(4650),
    [sym__aexp] = STATE(868),
    [sym__exp_apply] = STATE(11808),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12534),
    [sym_splice] = STATE(4650),
    [sym_quasiquote] = STATE(4650),
    [ts_builtin_sym_end] = ACTIONS(1636),
    [sym__varid] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(2307),
    [sym_char] = ACTIONS(2307),
    [sym_string] = ACTIONS(2307),
    [sym__integer_literal] = ACTIONS(2309),
    [sym__binary_literal] = ACTIONS(2311),
    [sym__octal_literal] = ACTIONS(2311),
    [sym__hex_literal] = ACTIONS(2311),
    [anon_sym_LPAREN_POUND] = ACTIONS(2313),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2313),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2315),
    [sym__conid] = ACTIONS(2319),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(2326),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_BSLASH] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_mdo] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_7] = ACTIONS(2340),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1636),
    [sym_where] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(2342),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2344),
  },
  [869] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19027),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19026),
    [sym_qualified_constructor_operator] = STATE(19026),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19026),
    [sym_qualified_type_operator] = STATE(19026),
    [sym__qualified_type_operator] = STATE(19026),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6869),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2346),
    [anon_sym_DASH_GT] = ACTIONS(2346),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1785),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [870] = {
    [sym_integer] = STATE(4706),
    [sym__literal] = STATE(4706),
    [sym__unboxed_open] = STATE(756),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4233),
    [sym_qualified_constructor] = STATE(4725),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4706),
    [sym_con_list] = STATE(4706),
    [sym_con_tuple] = STATE(4706),
    [sym_literal] = STATE(4663),
    [sym_exp_parens] = STATE(4663),
    [sym_exp_tuple] = STATE(4663),
    [sym_exp_unboxed_tuple] = STATE(4663),
    [sym_exp_unboxed_sum] = STATE(4663),
    [sym_exp_list] = STATE(4663),
    [sym_exp_arithmetic_sequence] = STATE(4663),
    [sym_exp_list_comprehension] = STATE(4663),
    [sym_exp_section_left] = STATE(4663),
    [sym_exp_section_right] = STATE(4663),
    [sym_exp_th_quoted_name] = STATE(4663),
    [sym_exp_type_application] = STATE(871),
    [sym_exp_lambda] = STATE(11813),
    [sym_exp_let] = STATE(18848),
    [sym_exp_let_in] = STATE(11813),
    [sym_exp_cond] = STATE(11813),
    [sym_exp_case] = STATE(11813),
    [sym_exp_lambda_case] = STATE(871),
    [sym__do_keyword] = STATE(18207),
    [sym_do_module] = STATE(18207),
    [sym_exp_do] = STATE(871),
    [sym_exp_record] = STATE(4663),
    [sym_exp_name] = STATE(4663),
    [sym_exp_projection_selector] = STATE(4663),
    [sym__aexp_projection] = STATE(4663),
    [sym_exp_projection] = STATE(4663),
    [sym__aexp] = STATE(871),
    [sym__exp_apply] = STATE(11813),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12713),
    [sym_splice] = STATE(4663),
    [sym_quasiquote] = STATE(4663),
    [sym__varid] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(2352),
    [sym_char] = ACTIONS(2352),
    [sym_string] = ACTIONS(2352),
    [sym__integer_literal] = ACTIONS(2354),
    [sym__binary_literal] = ACTIONS(2356),
    [sym__octal_literal] = ACTIONS(2356),
    [sym__hex_literal] = ACTIONS(2356),
    [anon_sym_LPAREN_POUND] = ACTIONS(2358),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2358),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(2360),
    [sym__conid] = ACTIONS(2364),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_PIPE] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(2376),
    [anon_sym_BSLASH] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_mdo] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_7] = ACTIONS(2386),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1667),
    [sym__layout_end] = ACTIONS(1667),
    [sym_where] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(2388),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2390),
  },
  [871] = {
    [sym_integer] = STATE(4706),
    [sym__literal] = STATE(4706),
    [sym__unboxed_open] = STATE(756),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4233),
    [sym_qualified_constructor] = STATE(4725),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4706),
    [sym_con_list] = STATE(4706),
    [sym_con_tuple] = STATE(4706),
    [sym_literal] = STATE(4663),
    [sym_exp_parens] = STATE(4663),
    [sym_exp_tuple] = STATE(4663),
    [sym_exp_unboxed_tuple] = STATE(4663),
    [sym_exp_unboxed_sum] = STATE(4663),
    [sym_exp_list] = STATE(4663),
    [sym_exp_arithmetic_sequence] = STATE(4663),
    [sym_exp_list_comprehension] = STATE(4663),
    [sym_exp_section_left] = STATE(4663),
    [sym_exp_section_right] = STATE(4663),
    [sym_exp_th_quoted_name] = STATE(4663),
    [sym_exp_type_application] = STATE(871),
    [sym_exp_lambda] = STATE(11813),
    [sym_exp_let] = STATE(18848),
    [sym_exp_let_in] = STATE(11813),
    [sym_exp_cond] = STATE(11813),
    [sym_exp_case] = STATE(11813),
    [sym_exp_lambda_case] = STATE(871),
    [sym__do_keyword] = STATE(18207),
    [sym_do_module] = STATE(18207),
    [sym_exp_do] = STATE(871),
    [sym_exp_record] = STATE(4663),
    [sym_exp_name] = STATE(4663),
    [sym_exp_projection_selector] = STATE(4663),
    [sym__aexp_projection] = STATE(4663),
    [sym_exp_projection] = STATE(4663),
    [sym__aexp] = STATE(871),
    [sym__exp_apply] = STATE(11813),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12713),
    [sym_splice] = STATE(4663),
    [sym_quasiquote] = STATE(4663),
    [sym__varid] = ACTIONS(2350),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(2352),
    [sym_char] = ACTIONS(2352),
    [sym_string] = ACTIONS(2352),
    [sym__integer_literal] = ACTIONS(2354),
    [sym__binary_literal] = ACTIONS(2356),
    [sym__octal_literal] = ACTIONS(2356),
    [sym__hex_literal] = ACTIONS(2356),
    [anon_sym_LPAREN_POUND] = ACTIONS(2358),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2358),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2360),
    [sym__conid] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(2372),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(2376),
    [anon_sym_BSLASH] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_mdo] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_7] = ACTIONS(2386),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1636),
    [sym__layout_end] = ACTIONS(1636),
    [sym_where] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(2388),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2390),
  },
  [872] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(15970),
    [sym_gdpat] = STATE(10834),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18001),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10834),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [873] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(865),
    [sym_exp_lambda] = STATE(11883),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(11883),
    [sym_exp_cond] = STATE(11883),
    [sym_exp_case] = STATE(11883),
    [sym_exp_lambda_case] = STATE(865),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(865),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(865),
    [sym__exp_apply] = STATE(11883),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [anon_sym_2] = ACTIONS(1667),
    [anon_sym_DASH_GT] = ACTIONS(1667),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(2395),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_PIPE] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2295),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1667),
    [sym_quasiquote_start] = ACTIONS(577),
    [sym__unboxed_close] = ACTIONS(1667),
  },
  [874] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19010),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19011),
    [sym_qualified_constructor_operator] = STATE(19011),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19011),
    [sym_qualified_type_operator] = STATE(19011),
    [sym__qualified_type_operator] = STATE(19011),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6981),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19012),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16817),
    [sym__type_context] = STATE(16817),
    [sym__type_fun] = STATE(16817),
    [sym__type] = STATE(16817),
    [sym__type_or_implicit] = STATE(16817),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16492),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2399),
    [anon_sym_DASH_GT] = ACTIONS(2399),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2401),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2403),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2405),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [875] = {
    [sym_integer] = STATE(4558),
    [sym__literal] = STATE(4558),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = STATE(4824),
    [sym_qualified_variable] = STATE(4824),
    [sym_constructor] = STATE(4319),
    [sym_qualified_constructor] = STATE(4645),
    [sym__qcon] = STATE(4824),
    [sym_con_unit] = STATE(4558),
    [sym_con_list] = STATE(4558),
    [sym_con_tuple] = STATE(4558),
    [sym_literal] = STATE(4778),
    [sym_exp_parens] = STATE(4778),
    [sym_exp_tuple] = STATE(4778),
    [sym_exp_unboxed_tuple] = STATE(4778),
    [sym_exp_unboxed_sum] = STATE(4778),
    [sym_exp_list] = STATE(4778),
    [sym_exp_arithmetic_sequence] = STATE(4778),
    [sym_exp_list_comprehension] = STATE(4778),
    [sym_exp_section_left] = STATE(4778),
    [sym_exp_section_right] = STATE(4778),
    [sym_exp_th_quoted_name] = STATE(4778),
    [sym_exp_type_application] = STATE(879),
    [sym_exp_lambda] = STATE(11717),
    [sym_exp_let] = STATE(18765),
    [sym_exp_let_in] = STATE(11717),
    [sym_exp_cond] = STATE(11717),
    [sym_exp_case] = STATE(11717),
    [sym_exp_lambda_case] = STATE(879),
    [sym__do_keyword] = STATE(18183),
    [sym_do_module] = STATE(18183),
    [sym_exp_do] = STATE(879),
    [sym_exp_record] = STATE(4778),
    [sym_exp_name] = STATE(4778),
    [sym_exp_projection_selector] = STATE(4778),
    [sym__aexp_projection] = STATE(4778),
    [sym_exp_projection] = STATE(4778),
    [sym__aexp] = STATE(879),
    [sym__exp_apply] = STATE(11717),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12688),
    [sym_splice] = STATE(4778),
    [sym_quasiquote] = STATE(4778),
    [sym__varid] = ACTIONS(2407),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(2409),
    [sym_char] = ACTIONS(2409),
    [sym_string] = ACTIONS(2409),
    [sym__integer_literal] = ACTIONS(2411),
    [sym__binary_literal] = ACTIONS(2413),
    [sym__octal_literal] = ACTIONS(2413),
    [sym__hex_literal] = ACTIONS(2413),
    [anon_sym_LPAREN_POUND] = ACTIONS(2415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2415),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(2417),
    [sym__conid] = ACTIONS(2421),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_LBRACE] = ACTIONS(2429),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2431),
    [anon_sym_AT] = ACTIONS(2433),
    [anon_sym_BSLASH] = ACTIONS(2435),
    [anon_sym_in] = ACTIONS(1670),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2437),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_mdo] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_7] = ACTIONS(2443),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1667),
    [sym__layout_end] = ACTIONS(1667),
    [sym_where] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(2445),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2447),
  },
  [876] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20272),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20270),
    [sym_qualified_constructor_operator] = STATE(20270),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20270),
    [sym_qualified_type_operator] = STATE(20270),
    [sym__qualified_type_operator] = STATE(20270),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6844),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20367),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17559),
    [sym__type_context] = STATE(17559),
    [sym__type_fun] = STATE(17559),
    [sym__type] = STATE(17559),
    [sym__type_or_implicit] = STATE(17559),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17134),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2449),
    [anon_sym_DASH_GT] = ACTIONS(2449),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2451),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2455),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [877] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19027),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19026),
    [sym_qualified_constructor_operator] = STATE(19026),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19026),
    [sym_qualified_type_operator] = STATE(19026),
    [sym__qualified_type_operator] = STATE(19026),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6869),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19024),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16803),
    [sym__type_context] = STATE(16803),
    [sym__type_fun] = STATE(16803),
    [sym__type] = STATE(16803),
    [sym__type_or_implicit] = STATE(16803),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17668),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2346),
    [anon_sym_DASH_GT] = ACTIONS(2346),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2457),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2459),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [878] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20325),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20320),
    [sym_qualified_constructor_operator] = STATE(20320),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20320),
    [sym_qualified_type_operator] = STATE(20320),
    [sym__qualified_type_operator] = STATE(20320),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7042),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20463),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17581),
    [sym__type_context] = STATE(17581),
    [sym__type_fun] = STATE(17581),
    [sym__type] = STATE(17581),
    [sym__type_or_implicit] = STATE(17581),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17157),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2461),
    [anon_sym_DASH_GT] = ACTIONS(2461),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2463),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2465),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2467),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [879] = {
    [sym_integer] = STATE(4558),
    [sym__literal] = STATE(4558),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = STATE(4824),
    [sym_qualified_variable] = STATE(4824),
    [sym_constructor] = STATE(4319),
    [sym_qualified_constructor] = STATE(4645),
    [sym__qcon] = STATE(4824),
    [sym_con_unit] = STATE(4558),
    [sym_con_list] = STATE(4558),
    [sym_con_tuple] = STATE(4558),
    [sym_literal] = STATE(4778),
    [sym_exp_parens] = STATE(4778),
    [sym_exp_tuple] = STATE(4778),
    [sym_exp_unboxed_tuple] = STATE(4778),
    [sym_exp_unboxed_sum] = STATE(4778),
    [sym_exp_list] = STATE(4778),
    [sym_exp_arithmetic_sequence] = STATE(4778),
    [sym_exp_list_comprehension] = STATE(4778),
    [sym_exp_section_left] = STATE(4778),
    [sym_exp_section_right] = STATE(4778),
    [sym_exp_th_quoted_name] = STATE(4778),
    [sym_exp_type_application] = STATE(879),
    [sym_exp_lambda] = STATE(11717),
    [sym_exp_let] = STATE(18765),
    [sym_exp_let_in] = STATE(11717),
    [sym_exp_cond] = STATE(11717),
    [sym_exp_case] = STATE(11717),
    [sym_exp_lambda_case] = STATE(879),
    [sym__do_keyword] = STATE(18183),
    [sym_do_module] = STATE(18183),
    [sym_exp_do] = STATE(879),
    [sym_exp_record] = STATE(4778),
    [sym_exp_name] = STATE(4778),
    [sym_exp_projection_selector] = STATE(4778),
    [sym__aexp_projection] = STATE(4778),
    [sym_exp_projection] = STATE(4778),
    [sym__aexp] = STATE(879),
    [sym__exp_apply] = STATE(11717),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12688),
    [sym_splice] = STATE(4778),
    [sym_quasiquote] = STATE(4778),
    [sym__varid] = ACTIONS(2407),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(2409),
    [sym_char] = ACTIONS(2409),
    [sym_string] = ACTIONS(2409),
    [sym__integer_literal] = ACTIONS(2411),
    [sym__binary_literal] = ACTIONS(2413),
    [sym__octal_literal] = ACTIONS(2413),
    [sym__hex_literal] = ACTIONS(2413),
    [anon_sym_LPAREN_POUND] = ACTIONS(2415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2415),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2417),
    [sym__conid] = ACTIONS(2469),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_LBRACE] = ACTIONS(2429),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2431),
    [anon_sym_AT] = ACTIONS(2433),
    [anon_sym_BSLASH] = ACTIONS(2435),
    [anon_sym_in] = ACTIONS(1642),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2437),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_mdo] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_7] = ACTIONS(2443),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1636),
    [sym__layout_end] = ACTIONS(1636),
    [sym_where] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(2445),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2447),
  },
  [880] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19362),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19497),
    [sym_qualified_constructor_operator] = STATE(19497),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19497),
    [sym_qualified_type_operator] = STATE(19497),
    [sym__qualified_type_operator] = STATE(19497),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6801),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19910),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17377),
    [sym__type_context] = STATE(17377),
    [sym__type_fun] = STATE(17377),
    [sym__type] = STATE(17377),
    [sym__type_or_implicit] = STATE(17377),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16108),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2472),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2474),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [881] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(15458),
    [sym_gdpat] = STATE(9530),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17976),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(9530),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [882] = {
    [sym_integer] = STATE(4662),
    [sym__literal] = STATE(4662),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = STATE(4833),
    [sym_qualified_variable] = STATE(4833),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4790),
    [sym__qcon] = STATE(4833),
    [sym_con_unit] = STATE(4662),
    [sym_con_list] = STATE(4662),
    [sym_con_tuple] = STATE(4662),
    [sym_literal] = STATE(4650),
    [sym_exp_parens] = STATE(4650),
    [sym_exp_tuple] = STATE(4650),
    [sym_exp_unboxed_tuple] = STATE(4650),
    [sym_exp_unboxed_sum] = STATE(4650),
    [sym_exp_list] = STATE(4650),
    [sym_exp_arithmetic_sequence] = STATE(4650),
    [sym_exp_list_comprehension] = STATE(4650),
    [sym_exp_section_left] = STATE(4650),
    [sym_exp_section_right] = STATE(4650),
    [sym_exp_th_quoted_name] = STATE(4650),
    [sym_exp_type_application] = STATE(868),
    [sym_exp_lambda] = STATE(11808),
    [sym_exp_let] = STATE(18846),
    [sym_exp_let_in] = STATE(11808),
    [sym_exp_cond] = STATE(11808),
    [sym_exp_case] = STATE(11808),
    [sym_exp_lambda_case] = STATE(868),
    [sym__do_keyword] = STATE(18352),
    [sym_do_module] = STATE(18352),
    [sym_exp_do] = STATE(868),
    [sym_exp_record] = STATE(4650),
    [sym_exp_name] = STATE(4650),
    [sym_exp_projection_selector] = STATE(4650),
    [sym__aexp_projection] = STATE(4650),
    [sym_exp_projection] = STATE(4650),
    [sym__aexp] = STATE(868),
    [sym__exp_apply] = STATE(11808),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12534),
    [sym_splice] = STATE(4650),
    [sym_quasiquote] = STATE(4650),
    [ts_builtin_sym_end] = ACTIONS(1667),
    [sym__varid] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(2307),
    [sym_char] = ACTIONS(2307),
    [sym_string] = ACTIONS(2307),
    [sym__integer_literal] = ACTIONS(2309),
    [sym__binary_literal] = ACTIONS(2311),
    [sym__octal_literal] = ACTIONS(2311),
    [sym__hex_literal] = ACTIONS(2311),
    [anon_sym_LPAREN_POUND] = ACTIONS(2313),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2313),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(2315),
    [sym__conid] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_PIPE] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(2326),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_BSLASH] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2334),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_mdo] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_7] = ACTIONS(2340),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1667),
    [sym_where] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(2342),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2344),
  },
  [883] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(18956),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18957),
    [sym_qualified_constructor_operator] = STATE(18957),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18957),
    [sym_qualified_type_operator] = STATE(18957),
    [sym__qualified_type_operator] = STATE(18957),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6938),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18958),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16877),
    [sym__type_context] = STATE(16877),
    [sym__type_fun] = STATE(16877),
    [sym__type] = STATE(16877),
    [sym__type_or_implicit] = STATE(16877),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16509),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2480),
    [anon_sym_DASH_GT] = ACTIONS(2480),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2482),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2486),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [884] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19864),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19860),
    [sym_qualified_constructor_operator] = STATE(19860),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19860),
    [sym_qualified_type_operator] = STATE(19860),
    [sym__qualified_type_operator] = STATE(19860),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6961),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19982),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17392),
    [sym__type_context] = STATE(17392),
    [sym__type_fun] = STATE(17392),
    [sym__type] = STATE(17392),
    [sym__type_or_implicit] = STATE(17392),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16902),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2488),
    [anon_sym_DASH_GT] = ACTIONS(2488),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2490),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2494),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [885] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19696),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19694),
    [sym_qualified_constructor_operator] = STATE(19694),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19694),
    [sym_qualified_type_operator] = STATE(19694),
    [sym__qualified_type_operator] = STATE(19694),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6847),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19904),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15986),
    [sym__constraint_context] = STATE(15986),
    [sym__constraint] = STATE(15986),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16094),
    [sym__type_context] = STATE(16094),
    [sym__type_fun] = STATE(16094),
    [sym__type] = STATE(16094),
    [sym__type_or_implicit] = STATE(16094),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17337),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1821),
    [anon_sym_DASH_GT] = ACTIONS(1821),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(1823),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2006),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1827),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [886] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19265),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19258),
    [sym_qualified_constructor_operator] = STATE(19258),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19258),
    [sym_qualified_type_operator] = STATE(19258),
    [sym__qualified_type_operator] = STATE(19258),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6852),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19257),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16613),
    [sym__type_context] = STATE(16613),
    [sym__type_fun] = STATE(16613),
    [sym__type] = STATE(16613),
    [sym__type_or_implicit] = STATE(16613),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17606),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2496),
    [anon_sym_DASH_GT] = ACTIONS(2496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2498),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2502),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [887] = {
    [sym_integer] = STATE(4830),
    [sym__literal] = STATE(4830),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = STATE(4419),
    [sym_qualified_variable] = STATE(4419),
    [sym_constructor] = STATE(4257),
    [sym_qualified_constructor] = STATE(4416),
    [sym__qcon] = STATE(4419),
    [sym_con_unit] = STATE(4830),
    [sym_con_list] = STATE(4830),
    [sym_con_tuple] = STATE(4830),
    [sym_literal] = STATE(4455),
    [sym_exp_parens] = STATE(4455),
    [sym_exp_tuple] = STATE(4455),
    [sym_exp_unboxed_tuple] = STATE(4455),
    [sym_exp_unboxed_sum] = STATE(4455),
    [sym_exp_list] = STATE(4455),
    [sym_exp_arithmetic_sequence] = STATE(4455),
    [sym_exp_list_comprehension] = STATE(4455),
    [sym_exp_section_left] = STATE(4455),
    [sym_exp_section_right] = STATE(4455),
    [sym_exp_th_quoted_name] = STATE(4455),
    [sym_exp_type_application] = STATE(887),
    [sym_exp_lambda] = STATE(11828),
    [sym_exp_let] = STATE(18318),
    [sym_exp_let_in] = STATE(11828),
    [sym_exp_cond] = STATE(11828),
    [sym_exp_case] = STATE(11828),
    [sym_exp_lambda_case] = STATE(887),
    [sym__do_keyword] = STATE(18263),
    [sym_do_module] = STATE(18263),
    [sym_exp_do] = STATE(887),
    [sym_exp_record] = STATE(4455),
    [sym_exp_name] = STATE(4455),
    [sym_exp_projection_selector] = STATE(4455),
    [sym__aexp_projection] = STATE(4455),
    [sym_exp_projection] = STATE(4455),
    [sym__aexp] = STATE(887),
    [sym__exp_apply] = STATE(11828),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12635),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(2080),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(2082),
    [sym_char] = ACTIONS(2082),
    [sym_string] = ACTIONS(2082),
    [sym__integer_literal] = ACTIONS(2084),
    [sym__binary_literal] = ACTIONS(2086),
    [sym__octal_literal] = ACTIONS(2086),
    [sym__hex_literal] = ACTIONS(2086),
    [anon_sym_LPAREN_POUND] = ACTIONS(2088),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2088),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2090),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2090),
    [sym__conid] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(2102),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_BSLASH] = ACTIONS(2108),
    [anon_sym_in] = ACTIONS(1642),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2110),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_mdo] = ACTIONS(2114),
    [anon_sym_do] = ACTIONS(2114),
    [anon_sym_7] = ACTIONS(2116),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1636),
    [sym_where] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(2118),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2120),
  },
  [888] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20677),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20680),
    [sym_qualified_constructor_operator] = STATE(20680),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20680),
    [sym_qualified_type_operator] = STATE(20680),
    [sym__qualified_type_operator] = STATE(20680),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7021),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20427),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(17579),
    [sym__type_context] = STATE(17579),
    [sym__type_fun] = STATE(17579),
    [sym__type] = STATE(17579),
    [sym__type_or_implicit] = STATE(17579),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17539),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2507),
    [anon_sym_DASH_GT] = ACTIONS(2507),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2509),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2511),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2513),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [889] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(18981),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18982),
    [sym_qualified_constructor_operator] = STATE(18982),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18982),
    [sym_qualified_type_operator] = STATE(18982),
    [sym__qualified_type_operator] = STATE(18982),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6999),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18983),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15656),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15660),
    [sym__constraint_context] = STATE(15660),
    [sym__constraint] = STATE(15660),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(16849),
    [sym__type_context] = STATE(16849),
    [sym__type_fun] = STATE(16849),
    [sym__type] = STATE(16849),
    [sym__type_or_implicit] = STATE(16849),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16501),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2515),
    [anon_sym_DASH_GT] = ACTIONS(2515),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [anon_sym_RPAREN] = ACTIONS(2517),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2521),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [890] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_guards] = STATE(15952),
    [sym_gdpat] = STATE(10274),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18008),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [aux_sym_exp_if_guard_repeat1] = STATE(10274),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_PIPE] = ACTIONS(1980),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [891] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2525),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [892] = {
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = STATE(4572),
    [sym_qualified_variable] = STATE(4572),
    [sym_constructor] = STATE(4245),
    [sym_qualified_constructor] = STATE(4556),
    [sym__qcon] = STATE(4572),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4959),
    [sym_exp_parens] = STATE(4959),
    [sym_exp_tuple] = STATE(4959),
    [sym_exp_unboxed_tuple] = STATE(4959),
    [sym_exp_unboxed_sum] = STATE(4959),
    [sym_exp_list] = STATE(4959),
    [sym_exp_arithmetic_sequence] = STATE(4959),
    [sym_exp_list_comprehension] = STATE(4959),
    [sym_exp_section_left] = STATE(4959),
    [sym_exp_section_right] = STATE(4959),
    [sym_exp_th_quoted_name] = STATE(4959),
    [sym_exp_type_application] = STATE(892),
    [sym_exp_lambda] = STATE(12062),
    [sym_exp_let] = STATE(18678),
    [sym_exp_let_in] = STATE(12062),
    [sym_exp_cond] = STATE(12062),
    [sym_exp_case] = STATE(12062),
    [sym_exp_lambda_case] = STATE(892),
    [sym__do_keyword] = STATE(18401),
    [sym_do_module] = STATE(18401),
    [sym_exp_do] = STATE(892),
    [sym_exp_record] = STATE(4959),
    [sym_exp_name] = STATE(4959),
    [sym_exp_projection_selector] = STATE(4959),
    [sym__aexp_projection] = STATE(4959),
    [sym_exp_projection] = STATE(4959),
    [sym__aexp] = STATE(892),
    [sym__exp_apply] = STATE(12062),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12712),
    [sym_splice] = STATE(4959),
    [sym_quasiquote] = STATE(4959),
    [ts_builtin_sym_end] = ACTIONS(1636),
    [sym__varid] = ACTIONS(2529),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2531),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2531),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2533),
    [sym__conid] = ACTIONS(2537),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(2544),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [anon_sym_BSLASH] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_mdo] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(71),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
  },
  [893] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2558),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [894] = {
    [sym_integer] = STATE(4866),
    [sym__literal] = STATE(4866),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = STATE(5079),
    [sym_qualified_variable] = STATE(5079),
    [sym_constructor] = STATE(4498),
    [sym_qualified_constructor] = STATE(5373),
    [sym__qcon] = STATE(5079),
    [sym_con_unit] = STATE(4866),
    [sym_con_list] = STATE(4866),
    [sym_con_tuple] = STATE(4866),
    [sym_literal] = STATE(5194),
    [sym_exp_parens] = STATE(5194),
    [sym_exp_tuple] = STATE(5194),
    [sym_exp_unboxed_tuple] = STATE(5194),
    [sym_exp_unboxed_sum] = STATE(5194),
    [sym_exp_list] = STATE(5194),
    [sym_exp_arithmetic_sequence] = STATE(5194),
    [sym_exp_list_comprehension] = STATE(5194),
    [sym_exp_section_left] = STATE(5194),
    [sym_exp_section_right] = STATE(5194),
    [sym_exp_th_quoted_name] = STATE(5194),
    [sym_exp_type_application] = STATE(894),
    [sym_exp_lambda] = STATE(11967),
    [sym_exp_let] = STATE(18498),
    [sym_exp_let_in] = STATE(11967),
    [sym_exp_cond] = STATE(11967),
    [sym_exp_case] = STATE(11967),
    [sym_exp_lambda_case] = STATE(894),
    [sym__do_keyword] = STATE(18413),
    [sym_do_module] = STATE(18413),
    [sym_exp_do] = STATE(894),
    [sym_exp_record] = STATE(5194),
    [sym_exp_name] = STATE(5194),
    [sym_exp_projection_selector] = STATE(5194),
    [sym__aexp_projection] = STATE(5194),
    [sym_exp_projection] = STATE(5194),
    [sym__aexp] = STATE(894),
    [sym__exp_apply] = STATE(11967),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12556),
    [sym_splice] = STATE(5194),
    [sym_quasiquote] = STATE(5194),
    [ts_builtin_sym_end] = ACTIONS(1636),
    [sym__varid] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(2562),
    [sym_char] = ACTIONS(2562),
    [sym_string] = ACTIONS(2562),
    [sym__integer_literal] = ACTIONS(2564),
    [sym__binary_literal] = ACTIONS(2566),
    [sym__octal_literal] = ACTIONS(2566),
    [sym__hex_literal] = ACTIONS(2566),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(2574),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_LBRACE] = ACTIONS(2581),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2583),
    [anon_sym_AT] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_7] = ACTIONS(2595),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1636),
    [sym_where] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(2597),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2599),
  },
  [895] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2601),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [896] = {
    [sym_integer] = STATE(4976),
    [sym__literal] = STATE(4976),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = STATE(5481),
    [sym_qualified_variable] = STATE(5481),
    [sym_constructor] = STATE(4552),
    [sym_qualified_constructor] = STATE(5251),
    [sym__qcon] = STATE(5481),
    [sym_con_unit] = STATE(4976),
    [sym_con_list] = STATE(4976),
    [sym_con_tuple] = STATE(4976),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(896),
    [sym_exp_lambda] = STATE(12086),
    [sym_exp_let] = STATE(18616),
    [sym_exp_let_in] = STATE(12086),
    [sym_exp_cond] = STATE(12086),
    [sym_exp_case] = STATE(12086),
    [sym_exp_lambda_case] = STATE(896),
    [sym__do_keyword] = STATE(18242),
    [sym_do_module] = STATE(18242),
    [sym_exp_do] = STATE(896),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(896),
    [sym__exp_apply] = STATE(12086),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12657),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2603),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(2605),
    [sym_char] = ACTIONS(2605),
    [sym_string] = ACTIONS(2605),
    [sym__integer_literal] = ACTIONS(2607),
    [sym__binary_literal] = ACTIONS(2609),
    [sym__octal_literal] = ACTIONS(2609),
    [sym__hex_literal] = ACTIONS(2609),
    [anon_sym_LPAREN_POUND] = ACTIONS(2611),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2611),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2613),
    [sym__conid] = ACTIONS(2617),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_RBRACE] = ACTIONS(1636),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_mdo] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_7] = ACTIONS(2638),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(2640),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2642),
  },
  [897] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2644),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [898] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19806),
    [sym_constructor] = STATE(7030),
    [sym_constructor_operator] = STATE(20007),
    [sym_qualified_constructor_operator] = STATE(19805),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20007),
    [sym_qualified_type_operator] = STATE(19805),
    [sym__qualified_type_operator] = STATE(19805),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6044),
    [sym_annotated_type_variable] = STATE(7079),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20020),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15995),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15995),
    [sym__type_context] = STATE(15995),
    [sym__type_fun] = STATE(15995),
    [sym__type] = STATE(15995),
    [sym__type_or_implicit] = STATE(15995),
    [sym__simpletype_infix] = STATE(13780),
    [sym__simpletype] = STATE(20511),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17084),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_RPAREN] = ACTIONS(2650),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2654),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [899] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2656),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [900] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2658),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [901] = {
    [sym_integer] = STATE(4936),
    [sym__literal] = STATE(4936),
    [sym__unboxed_open] = STATE(780),
    [sym_variable] = STATE(5192),
    [sym_qualified_variable] = STATE(5192),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4989),
    [sym__qcon] = STATE(5192),
    [sym_con_unit] = STATE(4936),
    [sym_con_list] = STATE(4936),
    [sym_con_tuple] = STATE(4936),
    [sym_literal] = STATE(5422),
    [sym_exp_parens] = STATE(5422),
    [sym_exp_tuple] = STATE(5422),
    [sym_exp_unboxed_tuple] = STATE(5422),
    [sym_exp_unboxed_sum] = STATE(5422),
    [sym_exp_list] = STATE(5422),
    [sym_exp_arithmetic_sequence] = STATE(5422),
    [sym_exp_list_comprehension] = STATE(5422),
    [sym_exp_section_left] = STATE(5422),
    [sym_exp_section_right] = STATE(5422),
    [sym_exp_th_quoted_name] = STATE(5422),
    [sym_exp_type_application] = STATE(916),
    [sym_exp_lambda] = STATE(12005),
    [sym_exp_let] = STATE(18508),
    [sym_exp_let_in] = STATE(12005),
    [sym_exp_cond] = STATE(12005),
    [sym_exp_case] = STATE(12005),
    [sym_exp_lambda_case] = STATE(916),
    [sym__do_keyword] = STATE(18325),
    [sym_do_module] = STATE(18325),
    [sym_exp_do] = STATE(916),
    [sym_exp_record] = STATE(5422),
    [sym_exp_name] = STATE(5422),
    [sym_exp_projection_selector] = STATE(5422),
    [sym__aexp_projection] = STATE(5422),
    [sym_exp_projection] = STATE(5422),
    [sym__aexp] = STATE(916),
    [sym__exp_apply] = STATE(12005),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12676),
    [sym_splice] = STATE(5422),
    [sym_quasiquote] = STATE(5422),
    [sym__varid] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(2662),
    [sym_char] = ACTIONS(2662),
    [sym_string] = ACTIONS(2662),
    [sym__integer_literal] = ACTIONS(2664),
    [sym__binary_literal] = ACTIONS(2666),
    [sym__octal_literal] = ACTIONS(2666),
    [sym__hex_literal] = ACTIONS(2666),
    [anon_sym_LPAREN_POUND] = ACTIONS(2668),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2668),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(2670),
    [sym__conid] = ACTIONS(2674),
    [anon_sym_LBRACK] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [anon_sym_LBRACE] = ACTIONS(2682),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2686),
    [anon_sym_BSLASH] = ACTIONS(2688),
    [anon_sym_in] = ACTIONS(1670),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_mdo] = ACTIONS(2694),
    [anon_sym_do] = ACTIONS(2694),
    [anon_sym_7] = ACTIONS(2696),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1667),
    [sym_where] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(2698),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2700),
  },
  [902] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2702),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [903] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2704),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [904] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2706),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [905] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2708),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [906] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2710),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [907] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2712),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [908] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2714),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [909] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2716),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [910] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2718),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [911] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2720),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [912] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2722),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [913] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2724),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [914] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2726),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [915] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2728),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [916] = {
    [sym_integer] = STATE(4936),
    [sym__literal] = STATE(4936),
    [sym__unboxed_open] = STATE(780),
    [sym_variable] = STATE(5192),
    [sym_qualified_variable] = STATE(5192),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4989),
    [sym__qcon] = STATE(5192),
    [sym_con_unit] = STATE(4936),
    [sym_con_list] = STATE(4936),
    [sym_con_tuple] = STATE(4936),
    [sym_literal] = STATE(5422),
    [sym_exp_parens] = STATE(5422),
    [sym_exp_tuple] = STATE(5422),
    [sym_exp_unboxed_tuple] = STATE(5422),
    [sym_exp_unboxed_sum] = STATE(5422),
    [sym_exp_list] = STATE(5422),
    [sym_exp_arithmetic_sequence] = STATE(5422),
    [sym_exp_list_comprehension] = STATE(5422),
    [sym_exp_section_left] = STATE(5422),
    [sym_exp_section_right] = STATE(5422),
    [sym_exp_th_quoted_name] = STATE(5422),
    [sym_exp_type_application] = STATE(916),
    [sym_exp_lambda] = STATE(12005),
    [sym_exp_let] = STATE(18508),
    [sym_exp_let_in] = STATE(12005),
    [sym_exp_cond] = STATE(12005),
    [sym_exp_case] = STATE(12005),
    [sym_exp_lambda_case] = STATE(916),
    [sym__do_keyword] = STATE(18325),
    [sym_do_module] = STATE(18325),
    [sym_exp_do] = STATE(916),
    [sym_exp_record] = STATE(5422),
    [sym_exp_name] = STATE(5422),
    [sym_exp_projection_selector] = STATE(5422),
    [sym__aexp_projection] = STATE(5422),
    [sym_exp_projection] = STATE(5422),
    [sym__aexp] = STATE(916),
    [sym__exp_apply] = STATE(12005),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12676),
    [sym_splice] = STATE(5422),
    [sym_quasiquote] = STATE(5422),
    [sym__varid] = ACTIONS(2660),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(2662),
    [sym_char] = ACTIONS(2662),
    [sym_string] = ACTIONS(2662),
    [sym__integer_literal] = ACTIONS(2664),
    [sym__binary_literal] = ACTIONS(2666),
    [sym__octal_literal] = ACTIONS(2666),
    [sym__hex_literal] = ACTIONS(2666),
    [anon_sym_LPAREN_POUND] = ACTIONS(2668),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2668),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2670),
    [sym__conid] = ACTIONS(2730),
    [anon_sym_LBRACK] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [anon_sym_LBRACE] = ACTIONS(2682),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2686),
    [anon_sym_BSLASH] = ACTIONS(2688),
    [anon_sym_in] = ACTIONS(1642),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2690),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_mdo] = ACTIONS(2694),
    [anon_sym_do] = ACTIONS(2694),
    [anon_sym_7] = ACTIONS(2696),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1636),
    [sym_where] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(2698),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2700),
  },
  [917] = {
    [sym_integer] = STATE(4937),
    [sym__literal] = STATE(4937),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = STATE(5329),
    [sym_qualified_variable] = STATE(5329),
    [sym_constructor] = STATE(4661),
    [sym_qualified_constructor] = STATE(5081),
    [sym__qcon] = STATE(5329),
    [sym_con_unit] = STATE(4937),
    [sym_con_list] = STATE(4937),
    [sym_con_tuple] = STATE(4937),
    [sym_literal] = STATE(5477),
    [sym_exp_parens] = STATE(5477),
    [sym_exp_tuple] = STATE(5477),
    [sym_exp_unboxed_tuple] = STATE(5477),
    [sym_exp_unboxed_sum] = STATE(5477),
    [sym_exp_list] = STATE(5477),
    [sym_exp_arithmetic_sequence] = STATE(5477),
    [sym_exp_list_comprehension] = STATE(5477),
    [sym_exp_section_left] = STATE(5477),
    [sym_exp_section_right] = STATE(5477),
    [sym_exp_th_quoted_name] = STATE(5477),
    [sym_exp_type_application] = STATE(949),
    [sym_exp_lambda] = STATE(12074),
    [sym_exp_let] = STATE(17941),
    [sym_exp_let_in] = STATE(12074),
    [sym_exp_cond] = STATE(12074),
    [sym_exp_case] = STATE(12074),
    [sym_exp_lambda_case] = STATE(949),
    [sym__do_keyword] = STATE(18276),
    [sym_do_module] = STATE(18276),
    [sym_exp_do] = STATE(949),
    [sym_exp_record] = STATE(5477),
    [sym_exp_name] = STATE(5477),
    [sym_exp_projection_selector] = STATE(5477),
    [sym__aexp_projection] = STATE(5477),
    [sym_exp_projection] = STATE(5477),
    [sym__aexp] = STATE(949),
    [sym__exp_apply] = STATE(12074),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12628),
    [sym_splice] = STATE(5477),
    [sym_quasiquote] = STATE(5477),
    [sym__varid] = ACTIONS(2733),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(2735),
    [sym_char] = ACTIONS(2735),
    [sym_string] = ACTIONS(2735),
    [sym__integer_literal] = ACTIONS(2737),
    [sym__binary_literal] = ACTIONS(2739),
    [sym__octal_literal] = ACTIONS(2739),
    [sym__hex_literal] = ACTIONS(2739),
    [anon_sym_LPAREN_POUND] = ACTIONS(2741),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2741),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(2745),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(2743),
    [sym__conid] = ACTIONS(2747),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2755),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2759),
    [anon_sym_BSLASH] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2763),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_mdo] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_7] = ACTIONS(2769),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1667),
    [sym__layout_end] = ACTIONS(1667),
    [sym_where] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(2771),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2773),
  },
  [918] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2775),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [919] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2777),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [920] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2779),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [921] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2781),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [922] = {
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(783),
    [sym_variable] = STATE(4615),
    [sym_qualified_variable] = STATE(4615),
    [sym_constructor] = STATE(4335),
    [sym_qualified_constructor] = STATE(4623),
    [sym__qcon] = STATE(4615),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(5187),
    [sym_exp_parens] = STATE(5187),
    [sym_exp_tuple] = STATE(5187),
    [sym_exp_unboxed_tuple] = STATE(5187),
    [sym_exp_unboxed_sum] = STATE(5187),
    [sym_exp_list] = STATE(5187),
    [sym_exp_arithmetic_sequence] = STATE(5187),
    [sym_exp_list_comprehension] = STATE(5187),
    [sym_exp_section_left] = STATE(5187),
    [sym_exp_section_right] = STATE(5187),
    [sym_exp_th_quoted_name] = STATE(5187),
    [sym_exp_type_application] = STATE(922),
    [sym_exp_lambda] = STATE(12002),
    [sym_exp_let] = STATE(18897),
    [sym_exp_let_in] = STATE(12002),
    [sym_exp_cond] = STATE(12002),
    [sym_exp_case] = STATE(12002),
    [sym_exp_lambda_case] = STATE(922),
    [sym__do_keyword] = STATE(18223),
    [sym_do_module] = STATE(18223),
    [sym_exp_do] = STATE(922),
    [sym_exp_record] = STATE(5187),
    [sym_exp_name] = STATE(5187),
    [sym_exp_projection_selector] = STATE(5187),
    [sym__aexp_projection] = STATE(5187),
    [sym_exp_projection] = STATE(5187),
    [sym__aexp] = STATE(922),
    [sym__exp_apply] = STATE(12002),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12699),
    [sym_splice] = STATE(5187),
    [sym_quasiquote] = STATE(5187),
    [sym__varid] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(2785),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2785),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2787),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2787),
    [sym__conid] = ACTIONS(2791),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2796),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(2798),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_BSLASH] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2806),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_mdo] = ACTIONS(2810),
    [anon_sym_do] = ACTIONS(2810),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1636),
    [sym__layout_end] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(217),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
  },
  [923] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19806),
    [sym_constructor] = STATE(7030),
    [sym_constructor_operator] = STATE(20139),
    [sym_qualified_constructor_operator] = STATE(19805),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20139),
    [sym_qualified_type_operator] = STATE(19805),
    [sym__qualified_type_operator] = STATE(19805),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6044),
    [sym_annotated_type_variable] = STATE(7079),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20020),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15995),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15995),
    [sym__type_context] = STATE(15995),
    [sym__type_fun] = STATE(15995),
    [sym__type] = STATE(15995),
    [sym__type_or_implicit] = STATE(15995),
    [sym__simpletype_infix] = STATE(13780),
    [sym__simpletype] = STATE(20030),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17084),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(2648),
    [anon_sym_RPAREN] = ACTIONS(2650),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2812),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2654),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [924] = {
    [sym_integer] = STATE(4866),
    [sym__literal] = STATE(4866),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = STATE(5079),
    [sym_qualified_variable] = STATE(5079),
    [sym_constructor] = STATE(4498),
    [sym_qualified_constructor] = STATE(5373),
    [sym__qcon] = STATE(5079),
    [sym_con_unit] = STATE(4866),
    [sym_con_list] = STATE(4866),
    [sym_con_tuple] = STATE(4866),
    [sym_literal] = STATE(5194),
    [sym_exp_parens] = STATE(5194),
    [sym_exp_tuple] = STATE(5194),
    [sym_exp_unboxed_tuple] = STATE(5194),
    [sym_exp_unboxed_sum] = STATE(5194),
    [sym_exp_list] = STATE(5194),
    [sym_exp_arithmetic_sequence] = STATE(5194),
    [sym_exp_list_comprehension] = STATE(5194),
    [sym_exp_section_left] = STATE(5194),
    [sym_exp_section_right] = STATE(5194),
    [sym_exp_th_quoted_name] = STATE(5194),
    [sym_exp_type_application] = STATE(894),
    [sym_exp_lambda] = STATE(11967),
    [sym_exp_let] = STATE(18498),
    [sym_exp_let_in] = STATE(11967),
    [sym_exp_cond] = STATE(11967),
    [sym_exp_case] = STATE(11967),
    [sym_exp_lambda_case] = STATE(894),
    [sym__do_keyword] = STATE(18413),
    [sym_do_module] = STATE(18413),
    [sym_exp_do] = STATE(894),
    [sym_exp_record] = STATE(5194),
    [sym_exp_name] = STATE(5194),
    [sym_exp_projection_selector] = STATE(5194),
    [sym__aexp_projection] = STATE(5194),
    [sym_exp_projection] = STATE(5194),
    [sym__aexp] = STATE(894),
    [sym__exp_apply] = STATE(11967),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12556),
    [sym_splice] = STATE(5194),
    [sym_quasiquote] = STATE(5194),
    [ts_builtin_sym_end] = ACTIONS(1667),
    [sym__varid] = ACTIONS(2560),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(2562),
    [sym_char] = ACTIONS(2562),
    [sym_string] = ACTIONS(2562),
    [sym__integer_literal] = ACTIONS(2564),
    [sym__binary_literal] = ACTIONS(2566),
    [sym__octal_literal] = ACTIONS(2566),
    [sym__hex_literal] = ACTIONS(2566),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(2814),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_LBRACE] = ACTIONS(2581),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2583),
    [anon_sym_AT] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_7] = ACTIONS(2595),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1667),
    [sym_where] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(2597),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2599),
  },
  [925] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2818),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [926] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2820),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [927] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2822),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [928] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2824),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [929] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2826),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [930] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2828),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [931] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2830),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [932] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2832),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [933] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2834),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [934] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2836),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [935] = {
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(783),
    [sym_variable] = STATE(4615),
    [sym_qualified_variable] = STATE(4615),
    [sym_constructor] = STATE(4335),
    [sym_qualified_constructor] = STATE(4623),
    [sym__qcon] = STATE(4615),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(5187),
    [sym_exp_parens] = STATE(5187),
    [sym_exp_tuple] = STATE(5187),
    [sym_exp_unboxed_tuple] = STATE(5187),
    [sym_exp_unboxed_sum] = STATE(5187),
    [sym_exp_list] = STATE(5187),
    [sym_exp_arithmetic_sequence] = STATE(5187),
    [sym_exp_list_comprehension] = STATE(5187),
    [sym_exp_section_left] = STATE(5187),
    [sym_exp_section_right] = STATE(5187),
    [sym_exp_th_quoted_name] = STATE(5187),
    [sym_exp_type_application] = STATE(922),
    [sym_exp_lambda] = STATE(12002),
    [sym_exp_let] = STATE(18897),
    [sym_exp_let_in] = STATE(12002),
    [sym_exp_cond] = STATE(12002),
    [sym_exp_case] = STATE(12002),
    [sym_exp_lambda_case] = STATE(922),
    [sym__do_keyword] = STATE(18223),
    [sym_do_module] = STATE(18223),
    [sym_exp_do] = STATE(922),
    [sym_exp_record] = STATE(5187),
    [sym_exp_name] = STATE(5187),
    [sym_exp_projection_selector] = STATE(5187),
    [sym__aexp_projection] = STATE(5187),
    [sym_exp_projection] = STATE(5187),
    [sym__aexp] = STATE(922),
    [sym__exp_apply] = STATE(12002),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12699),
    [sym_splice] = STATE(5187),
    [sym_quasiquote] = STATE(5187),
    [sym__varid] = ACTIONS(2783),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(2785),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2785),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2787),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(2787),
    [sym__conid] = ACTIONS(2838),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2796),
    [anon_sym_PIPE] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(2798),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_BSLASH] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2806),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_mdo] = ACTIONS(2810),
    [anon_sym_do] = ACTIONS(2810),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1667),
    [sym__layout_end] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(217),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
  },
  [936] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2842),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [937] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(937),
    [sym_exp_lambda] = STATE(12218),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(12218),
    [sym_exp_cond] = STATE(12218),
    [sym_exp_case] = STATE(12218),
    [sym_exp_lambda_case] = STATE(937),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(937),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(937),
    [sym__exp_apply] = STATE(12218),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(2858),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_RBRACK] = ACTIONS(1636),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_DOT_DOT] = ACTIONS(1636),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1636),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [938] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [939] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2887),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [940] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [941] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2891),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [942] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2893),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [943] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(797),
    [sym_variable] = STATE(5085),
    [sym_qualified_variable] = STATE(5085),
    [sym_constructor] = STATE(4716),
    [sym_qualified_constructor] = STATE(5006),
    [sym__qcon] = STATE(5085),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(4915),
    [sym_exp_parens] = STATE(4915),
    [sym_exp_tuple] = STATE(4915),
    [sym_exp_unboxed_tuple] = STATE(4915),
    [sym_exp_unboxed_sum] = STATE(4915),
    [sym_exp_list] = STATE(4915),
    [sym_exp_arithmetic_sequence] = STATE(4915),
    [sym_exp_list_comprehension] = STATE(4915),
    [sym_exp_section_left] = STATE(4915),
    [sym_exp_section_right] = STATE(4915),
    [sym_exp_th_quoted_name] = STATE(4915),
    [sym_exp_type_application] = STATE(950),
    [sym_exp_lambda] = STATE(12151),
    [sym_exp_let] = STATE(18386),
    [sym_exp_let_in] = STATE(12151),
    [sym_exp_cond] = STATE(12151),
    [sym_exp_case] = STATE(12151),
    [sym_exp_lambda_case] = STATE(950),
    [sym__do_keyword] = STATE(18435),
    [sym_do_module] = STATE(18435),
    [sym_exp_do] = STATE(950),
    [sym_exp_record] = STATE(4915),
    [sym_exp_name] = STATE(4915),
    [sym_exp_projection_selector] = STATE(4915),
    [sym__aexp_projection] = STATE(4915),
    [sym_exp_projection] = STATE(4915),
    [sym__aexp] = STATE(950),
    [sym__exp_apply] = STATE(12151),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12549),
    [sym_splice] = STATE(4915),
    [sym_quasiquote] = STATE(4915),
    [sym__varid] = ACTIONS(2895),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(2897),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2897),
    [anon_sym_2] = ACTIONS(1667),
    [anon_sym_DASH_GT] = ACTIONS(1667),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1670),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(1177),
    [sym__conid] = ACTIONS(2901),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2909),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_mdo] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
    [sym__unboxed_close] = ACTIONS(1667),
  },
  [944] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2911),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [945] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [946] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15925),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym__exp_tuple_repeat1] = STATE(15930),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2915),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2917),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [947] = {
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = STATE(4572),
    [sym_qualified_variable] = STATE(4572),
    [sym_constructor] = STATE(4245),
    [sym_qualified_constructor] = STATE(4556),
    [sym__qcon] = STATE(4572),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4959),
    [sym_exp_parens] = STATE(4959),
    [sym_exp_tuple] = STATE(4959),
    [sym_exp_unboxed_tuple] = STATE(4959),
    [sym_exp_unboxed_sum] = STATE(4959),
    [sym_exp_list] = STATE(4959),
    [sym_exp_arithmetic_sequence] = STATE(4959),
    [sym_exp_list_comprehension] = STATE(4959),
    [sym_exp_section_left] = STATE(4959),
    [sym_exp_section_right] = STATE(4959),
    [sym_exp_th_quoted_name] = STATE(4959),
    [sym_exp_type_application] = STATE(892),
    [sym_exp_lambda] = STATE(12062),
    [sym_exp_let] = STATE(18678),
    [sym_exp_let_in] = STATE(12062),
    [sym_exp_cond] = STATE(12062),
    [sym_exp_case] = STATE(12062),
    [sym_exp_lambda_case] = STATE(892),
    [sym__do_keyword] = STATE(18401),
    [sym_do_module] = STATE(18401),
    [sym_exp_do] = STATE(892),
    [sym_exp_record] = STATE(4959),
    [sym_exp_name] = STATE(4959),
    [sym_exp_projection_selector] = STATE(4959),
    [sym__aexp_projection] = STATE(4959),
    [sym_exp_projection] = STATE(4959),
    [sym__aexp] = STATE(892),
    [sym__exp_apply] = STATE(12062),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12712),
    [sym_splice] = STATE(4959),
    [sym_quasiquote] = STATE(4959),
    [ts_builtin_sym_end] = ACTIONS(1667),
    [sym__varid] = ACTIONS(2529),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2531),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2531),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(2533),
    [sym__conid] = ACTIONS(2919),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_PIPE] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(2544),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [anon_sym_BSLASH] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2552),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_mdo] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(71),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
  },
  [948] = {
    [sym_integer] = STATE(4976),
    [sym__literal] = STATE(4976),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = STATE(5481),
    [sym_qualified_variable] = STATE(5481),
    [sym_constructor] = STATE(4552),
    [sym_qualified_constructor] = STATE(5251),
    [sym__qcon] = STATE(5481),
    [sym_con_unit] = STATE(4976),
    [sym_con_list] = STATE(4976),
    [sym_con_tuple] = STATE(4976),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(896),
    [sym_exp_lambda] = STATE(12086),
    [sym_exp_let] = STATE(18616),
    [sym_exp_let_in] = STATE(12086),
    [sym_exp_cond] = STATE(12086),
    [sym_exp_case] = STATE(12086),
    [sym_exp_lambda_case] = STATE(896),
    [sym__do_keyword] = STATE(18242),
    [sym_do_module] = STATE(18242),
    [sym_exp_do] = STATE(896),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(896),
    [sym__exp_apply] = STATE(12086),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12657),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2603),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(2605),
    [sym_char] = ACTIONS(2605),
    [sym_string] = ACTIONS(2605),
    [sym__integer_literal] = ACTIONS(2607),
    [sym__binary_literal] = ACTIONS(2609),
    [sym__octal_literal] = ACTIONS(2609),
    [sym__hex_literal] = ACTIONS(2609),
    [anon_sym_LPAREN_POUND] = ACTIONS(2611),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2611),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(2613),
    [sym__conid] = ACTIONS(2923),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_PIPE] = ACTIONS(1667),
    [anon_sym_LBRACE] = ACTIONS(2624),
    [anon_sym_RBRACE] = ACTIONS(1667),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2632),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_mdo] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_7] = ACTIONS(2638),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(2640),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2642),
  },
  [949] = {
    [sym_integer] = STATE(4937),
    [sym__literal] = STATE(4937),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = STATE(5329),
    [sym_qualified_variable] = STATE(5329),
    [sym_constructor] = STATE(4661),
    [sym_qualified_constructor] = STATE(5081),
    [sym__qcon] = STATE(5329),
    [sym_con_unit] = STATE(4937),
    [sym_con_list] = STATE(4937),
    [sym_con_tuple] = STATE(4937),
    [sym_literal] = STATE(5477),
    [sym_exp_parens] = STATE(5477),
    [sym_exp_tuple] = STATE(5477),
    [sym_exp_unboxed_tuple] = STATE(5477),
    [sym_exp_unboxed_sum] = STATE(5477),
    [sym_exp_list] = STATE(5477),
    [sym_exp_arithmetic_sequence] = STATE(5477),
    [sym_exp_list_comprehension] = STATE(5477),
    [sym_exp_section_left] = STATE(5477),
    [sym_exp_section_right] = STATE(5477),
    [sym_exp_th_quoted_name] = STATE(5477),
    [sym_exp_type_application] = STATE(949),
    [sym_exp_lambda] = STATE(12074),
    [sym_exp_let] = STATE(17941),
    [sym_exp_let_in] = STATE(12074),
    [sym_exp_cond] = STATE(12074),
    [sym_exp_case] = STATE(12074),
    [sym_exp_lambda_case] = STATE(949),
    [sym__do_keyword] = STATE(18276),
    [sym_do_module] = STATE(18276),
    [sym_exp_do] = STATE(949),
    [sym_exp_record] = STATE(5477),
    [sym_exp_name] = STATE(5477),
    [sym_exp_projection_selector] = STATE(5477),
    [sym__aexp_projection] = STATE(5477),
    [sym_exp_projection] = STATE(5477),
    [sym__aexp] = STATE(949),
    [sym__exp_apply] = STATE(12074),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12628),
    [sym_splice] = STATE(5477),
    [sym_quasiquote] = STATE(5477),
    [sym__varid] = ACTIONS(2733),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(2735),
    [sym_char] = ACTIONS(2735),
    [sym_string] = ACTIONS(2735),
    [sym__integer_literal] = ACTIONS(2737),
    [sym__binary_literal] = ACTIONS(2739),
    [sym__octal_literal] = ACTIONS(2739),
    [sym__hex_literal] = ACTIONS(2739),
    [anon_sym_LPAREN_POUND] = ACTIONS(2741),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2741),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(2745),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2743),
    [sym__conid] = ACTIONS(2927),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2755),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2759),
    [anon_sym_BSLASH] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2763),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_mdo] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_7] = ACTIONS(2769),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1636),
    [sym__layout_end] = ACTIONS(1636),
    [sym_where] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(2771),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2773),
  },
  [950] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(797),
    [sym_variable] = STATE(5085),
    [sym_qualified_variable] = STATE(5085),
    [sym_constructor] = STATE(4716),
    [sym_qualified_constructor] = STATE(5006),
    [sym__qcon] = STATE(5085),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(4915),
    [sym_exp_parens] = STATE(4915),
    [sym_exp_tuple] = STATE(4915),
    [sym_exp_unboxed_tuple] = STATE(4915),
    [sym_exp_unboxed_sum] = STATE(4915),
    [sym_exp_list] = STATE(4915),
    [sym_exp_arithmetic_sequence] = STATE(4915),
    [sym_exp_list_comprehension] = STATE(4915),
    [sym_exp_section_left] = STATE(4915),
    [sym_exp_section_right] = STATE(4915),
    [sym_exp_th_quoted_name] = STATE(4915),
    [sym_exp_type_application] = STATE(950),
    [sym_exp_lambda] = STATE(12151),
    [sym_exp_let] = STATE(18386),
    [sym_exp_let_in] = STATE(12151),
    [sym_exp_cond] = STATE(12151),
    [sym_exp_case] = STATE(12151),
    [sym_exp_lambda_case] = STATE(950),
    [sym__do_keyword] = STATE(18435),
    [sym_do_module] = STATE(18435),
    [sym_exp_do] = STATE(950),
    [sym_exp_record] = STATE(4915),
    [sym_exp_name] = STATE(4915),
    [sym_exp_projection_selector] = STATE(4915),
    [sym__aexp_projection] = STATE(4915),
    [sym_exp_projection] = STATE(4915),
    [sym__aexp] = STATE(950),
    [sym__exp_apply] = STATE(12151),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12549),
    [sym_splice] = STATE(4915),
    [sym_quasiquote] = STATE(4915),
    [sym__varid] = ACTIONS(2895),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(2897),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2897),
    [anon_sym_2] = ACTIONS(1636),
    [anon_sym_DASH_GT] = ACTIONS(1636),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(1642),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(1177),
    [sym__conid] = ACTIONS(2930),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(1636),
    [anon_sym_LBRACE] = ACTIONS(2907),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2909),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_mdo] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
    [sym__unboxed_close] = ACTIONS(1636),
  },
  [951] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2933),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [952] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(937),
    [sym_exp_lambda] = STATE(12218),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(12218),
    [sym_exp_cond] = STATE(12218),
    [sym_exp_case] = STATE(12218),
    [sym_exp_lambda_case] = STATE(937),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(937),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(937),
    [sym__exp_apply] = STATE(12218),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(2935),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_RBRACK] = ACTIONS(1667),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_LBRACE] = ACTIONS(2865),
    [anon_sym_DOT_DOT] = ACTIONS(1667),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2873),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1667),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [953] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2939),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [954] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2941),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [955] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(15632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [aux_sym_con_tuple_repeat1] = STATE(7388),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(2943),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2527),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [956] = {
    [sym_integer] = STATE(5669),
    [sym__literal] = STATE(5669),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = STATE(5710),
    [sym_qualified_variable] = STATE(5710),
    [sym_constructor] = STATE(5151),
    [sym_qualified_constructor] = STATE(5594),
    [sym__qcon] = STATE(5710),
    [sym_con_unit] = STATE(5669),
    [sym_con_list] = STATE(5669),
    [sym_con_tuple] = STATE(5669),
    [sym_literal] = STATE(5640),
    [sym_exp_parens] = STATE(5640),
    [sym_exp_tuple] = STATE(5640),
    [sym_exp_unboxed_tuple] = STATE(5640),
    [sym_exp_unboxed_sum] = STATE(5640),
    [sym_exp_list] = STATE(5640),
    [sym_exp_arithmetic_sequence] = STATE(5640),
    [sym_exp_list_comprehension] = STATE(5640),
    [sym_exp_section_left] = STATE(5640),
    [sym_exp_section_right] = STATE(5640),
    [sym_exp_th_quoted_name] = STATE(5640),
    [sym_exp_type_application] = STATE(963),
    [sym_exp_lambda] = STATE(12416),
    [sym_exp_let] = STATE(17912),
    [sym_exp_let_in] = STATE(12416),
    [sym_exp_cond] = STATE(12416),
    [sym_exp_case] = STATE(12416),
    [sym_exp_lambda_case] = STATE(963),
    [sym__do_keyword] = STATE(17914),
    [sym_do_module] = STATE(17914),
    [sym_exp_do] = STATE(963),
    [sym_exp_record] = STATE(5640),
    [sym_exp_name] = STATE(5640),
    [sym_exp_projection_selector] = STATE(5640),
    [sym__aexp_projection] = STATE(5640),
    [sym_exp_projection] = STATE(5640),
    [sym__aexp] = STATE(963),
    [sym__exp_apply] = STATE(12416),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12604),
    [sym_splice] = STATE(5640),
    [sym_quasiquote] = STATE(5640),
    [ts_builtin_sym_end] = ACTIONS(1667),
    [sym__varid] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(2947),
    [sym_char] = ACTIONS(2947),
    [sym_string] = ACTIONS(2947),
    [sym__integer_literal] = ACTIONS(2949),
    [sym__binary_literal] = ACTIONS(2951),
    [sym__octal_literal] = ACTIONS(2951),
    [sym__hex_literal] = ACTIONS(2951),
    [anon_sym_LPAREN_POUND] = ACTIONS(2953),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2953),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(35),
    [anon_sym_AT] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2965),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_7] = ACTIONS(2967),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(2969),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2971),
  },
  [957] = {
    [sym_integer] = STATE(5749),
    [sym__literal] = STATE(5749),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = STATE(5599),
    [sym_qualified_variable] = STATE(5599),
    [sym_constructor] = STATE(5259),
    [sym_qualified_constructor] = STATE(5552),
    [sym__qcon] = STATE(5599),
    [sym_con_unit] = STATE(5749),
    [sym_con_list] = STATE(5749),
    [sym_con_tuple] = STATE(5749),
    [sym_literal] = STATE(5638),
    [sym_exp_parens] = STATE(5638),
    [sym_exp_tuple] = STATE(5638),
    [sym_exp_unboxed_tuple] = STATE(5638),
    [sym_exp_unboxed_sum] = STATE(5638),
    [sym_exp_list] = STATE(5638),
    [sym_exp_arithmetic_sequence] = STATE(5638),
    [sym_exp_list_comprehension] = STATE(5638),
    [sym_exp_section_left] = STATE(5638),
    [sym_exp_section_right] = STATE(5638),
    [sym_exp_th_quoted_name] = STATE(5638),
    [sym_exp_type_application] = STATE(957),
    [sym_exp_lambda] = STATE(12233),
    [sym_exp_let] = STATE(18245),
    [sym_exp_let_in] = STATE(12233),
    [sym_exp_cond] = STATE(12233),
    [sym_exp_case] = STATE(12233),
    [sym_exp_lambda_case] = STATE(957),
    [sym__do_keyword] = STATE(18319),
    [sym_do_module] = STATE(18319),
    [sym_exp_do] = STATE(957),
    [sym_exp_record] = STATE(5638),
    [sym_exp_name] = STATE(5638),
    [sym_exp_projection_selector] = STATE(5638),
    [sym__aexp_projection] = STATE(5638),
    [sym_exp_projection] = STATE(5638),
    [sym__aexp] = STATE(957),
    [sym__exp_apply] = STATE(12233),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12705),
    [sym_splice] = STATE(5638),
    [sym_quasiquote] = STATE(5638),
    [sym__varid] = ACTIONS(2973),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(2975),
    [sym_char] = ACTIONS(2975),
    [sym_string] = ACTIONS(2975),
    [sym__integer_literal] = ACTIONS(2977),
    [sym__binary_literal] = ACTIONS(2979),
    [sym__octal_literal] = ACTIONS(2979),
    [sym__hex_literal] = ACTIONS(2979),
    [anon_sym_LPAREN_POUND] = ACTIONS(2981),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2981),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(2983),
    [sym__conid] = ACTIONS(2987),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(2994),
    [anon_sym_RBRACE] = ACTIONS(1636),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2998),
    [anon_sym_BSLASH] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3004),
    [anon_sym_mdo] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_7] = ACTIONS(3008),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(3010),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3012),
  },
  [958] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(750),
    [sym_variable] = STATE(4795),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(4308),
    [sym_qualified_constructor] = STATE(4664),
    [sym__qcon] = STATE(4795),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(5587),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(960),
    [sym_exp_lambda] = STATE(12412),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(12412),
    [sym_exp_cond] = STATE(12412),
    [sym_exp_case] = STATE(12412),
    [sym_exp_lambda_case] = STATE(960),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(960),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(960),
    [sym__exp_apply] = STATE(12412),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12545),
    [sym_splice] = STATE(5587),
    [sym_quasiquote] = STATE(5587),
    [sym__varid] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(3016),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3016),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(3026),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3028),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1667),
    [sym__layout_end] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(905),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
  },
  [959] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(797),
    [sym_variable] = STATE(5085),
    [sym_qualified_variable] = STATE(5085),
    [sym_constructor] = STATE(4716),
    [sym_qualified_constructor] = STATE(5006),
    [sym__qcon] = STATE(5085),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(4915),
    [sym_exp_parens] = STATE(4915),
    [sym_exp_tuple] = STATE(4915),
    [sym_exp_unboxed_tuple] = STATE(4915),
    [sym_exp_unboxed_sum] = STATE(4915),
    [sym_exp_list] = STATE(4915),
    [sym_exp_arithmetic_sequence] = STATE(4915),
    [sym_exp_list_comprehension] = STATE(4915),
    [sym_exp_section_left] = STATE(4915),
    [sym_exp_section_right] = STATE(4915),
    [sym_exp_th_quoted_name] = STATE(4915),
    [sym_exp_type_application] = STATE(943),
    [sym_exp_lambda] = STATE(9117),
    [sym_exp_let] = STATE(18386),
    [sym_exp_let_in] = STATE(9117),
    [sym_exp_cond] = STATE(9117),
    [sym_exp_if_guard] = STATE(9117),
    [sym_exp_case] = STATE(9117),
    [sym_exp_lambda_case] = STATE(943),
    [sym__do_keyword] = STATE(18435),
    [sym_do_module] = STATE(18435),
    [sym_exp_do] = STATE(943),
    [sym_exp_negation] = STATE(9117),
    [sym_exp_record] = STATE(4915),
    [sym_exp_name] = STATE(4915),
    [sym_exp_projection_selector] = STATE(4915),
    [sym__aexp_projection] = STATE(4915),
    [sym_exp_projection] = STATE(4915),
    [sym__aexp] = STATE(943),
    [sym__exp_apply] = STATE(12078),
    [sym__fexp] = STATE(9117),
    [sym__lexp] = STATE(9117),
    [sym_exp_infix] = STATE(9117),
    [sym__exp_infix] = STATE(9117),
    [sym__exp] = STATE(18378),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12549),
    [sym_splice] = STATE(4915),
    [sym_quasiquote] = STATE(4915),
    [sym__varid] = ACTIONS(2895),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(2897),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2897),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [sym_implicit_parid] = ACTIONS(1177),
    [sym__conid] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_PIPE] = ACTIONS(3034),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_mdo] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
    [sym__unboxed_close] = ACTIONS(3034),
  },
  [960] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(750),
    [sym_variable] = STATE(4795),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(4308),
    [sym_qualified_constructor] = STATE(4664),
    [sym__qcon] = STATE(4795),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(5587),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(960),
    [sym_exp_lambda] = STATE(12412),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(12412),
    [sym_exp_cond] = STATE(12412),
    [sym_exp_case] = STATE(12412),
    [sym_exp_lambda_case] = STATE(960),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(960),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(960),
    [sym__exp_apply] = STATE(12412),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12545),
    [sym_splice] = STATE(5587),
    [sym_quasiquote] = STATE(5587),
    [sym__varid] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(3016),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3016),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(3036),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(3026),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3028),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1636),
    [sym__layout_end] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(905),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
  },
  [961] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18748),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3039),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [962] = {
    [sym_integer] = STATE(4913),
    [sym__literal] = STATE(4913),
    [sym__unboxed_open] = STATE(747),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4400),
    [sym_qualified_constructor] = STATE(5105),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(4913),
    [sym_con_list] = STATE(4913),
    [sym_con_tuple] = STATE(4913),
    [sym_literal] = STATE(5786),
    [sym_exp_parens] = STATE(5786),
    [sym_exp_tuple] = STATE(5786),
    [sym_exp_unboxed_tuple] = STATE(5786),
    [sym_exp_unboxed_sum] = STATE(5786),
    [sym_exp_list] = STATE(5786),
    [sym_exp_arithmetic_sequence] = STATE(5786),
    [sym_exp_list_comprehension] = STATE(5786),
    [sym_exp_section_left] = STATE(5786),
    [sym_exp_section_right] = STATE(5786),
    [sym_exp_th_quoted_name] = STATE(5786),
    [sym_exp_type_application] = STATE(1283),
    [sym_exp_lambda] = STATE(9329),
    [sym_exp_let] = STATE(18321),
    [sym_exp_let_in] = STATE(9329),
    [sym_exp_cond] = STATE(9329),
    [sym_exp_if_guard] = STATE(9329),
    [sym_exp_case] = STATE(9329),
    [sym_exp_lambda_case] = STATE(1283),
    [sym__do_keyword] = STATE(18454),
    [sym_do_module] = STATE(18454),
    [sym_exp_do] = STATE(1283),
    [sym_exp_negation] = STATE(9329),
    [sym_exp_record] = STATE(5786),
    [sym_exp_name] = STATE(5786),
    [sym_exp_projection_selector] = STATE(5786),
    [sym__aexp_projection] = STATE(5786),
    [sym_exp_projection] = STATE(5786),
    [sym__aexp] = STATE(1283),
    [sym__exp_apply] = STATE(12708),
    [sym__fexp] = STATE(9329),
    [sym__lexp] = STATE(9329),
    [sym_exp_infix] = STATE(9329),
    [sym__exp_infix] = STATE(9329),
    [sym__exp] = STATE(18193),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12665),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym__varid] = ACTIONS(3041),
    [sym_float] = ACTIONS(1362),
    [sym_char] = ACTIONS(1362),
    [sym_string] = ACTIONS(1362),
    [sym__integer_literal] = ACTIONS(1364),
    [sym__binary_literal] = ACTIONS(1366),
    [sym__octal_literal] = ACTIONS(1366),
    [sym__hex_literal] = ACTIONS(1366),
    [anon_sym_LPAREN_POUND] = ACTIONS(3043),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3043),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [sym_implicit_parid] = ACTIONS(3045),
    [sym__conid] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3057),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_BSLASH] = ACTIONS(3061),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_mdo] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_7] = ACTIONS(1380),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3039),
    [sym_quasiquote_start] = ACTIONS(1384),
    [sym__unboxed_close] = ACTIONS(3039),
  },
  [963] = {
    [sym_integer] = STATE(5669),
    [sym__literal] = STATE(5669),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = STATE(5710),
    [sym_qualified_variable] = STATE(5710),
    [sym_constructor] = STATE(5151),
    [sym_qualified_constructor] = STATE(5594),
    [sym__qcon] = STATE(5710),
    [sym_con_unit] = STATE(5669),
    [sym_con_list] = STATE(5669),
    [sym_con_tuple] = STATE(5669),
    [sym_literal] = STATE(5640),
    [sym_exp_parens] = STATE(5640),
    [sym_exp_tuple] = STATE(5640),
    [sym_exp_unboxed_tuple] = STATE(5640),
    [sym_exp_unboxed_sum] = STATE(5640),
    [sym_exp_list] = STATE(5640),
    [sym_exp_arithmetic_sequence] = STATE(5640),
    [sym_exp_list_comprehension] = STATE(5640),
    [sym_exp_section_left] = STATE(5640),
    [sym_exp_section_right] = STATE(5640),
    [sym_exp_th_quoted_name] = STATE(5640),
    [sym_exp_type_application] = STATE(963),
    [sym_exp_lambda] = STATE(12416),
    [sym_exp_let] = STATE(17912),
    [sym_exp_let_in] = STATE(12416),
    [sym_exp_cond] = STATE(12416),
    [sym_exp_case] = STATE(12416),
    [sym_exp_lambda_case] = STATE(963),
    [sym__do_keyword] = STATE(17914),
    [sym_do_module] = STATE(17914),
    [sym_exp_do] = STATE(963),
    [sym_exp_record] = STATE(5640),
    [sym_exp_name] = STATE(5640),
    [sym_exp_projection_selector] = STATE(5640),
    [sym__aexp_projection] = STATE(5640),
    [sym_exp_projection] = STATE(5640),
    [sym__aexp] = STATE(963),
    [sym__exp_apply] = STATE(12416),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12604),
    [sym_splice] = STATE(5640),
    [sym_quasiquote] = STATE(5640),
    [ts_builtin_sym_end] = ACTIONS(1636),
    [sym__varid] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(1636),
    [sym_float] = ACTIONS(2947),
    [sym_char] = ACTIONS(2947),
    [sym_string] = ACTIONS(2947),
    [sym__integer_literal] = ACTIONS(2949),
    [sym__binary_literal] = ACTIONS(2951),
    [sym__octal_literal] = ACTIONS(2951),
    [sym__hex_literal] = ACTIONS(2951),
    [anon_sym_LPAREN_POUND] = ACTIONS(2953),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2953),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(35),
    [anon_sym_AT] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(2965),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_7] = ACTIONS(2967),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(1636),
    [sym__splice_dollar] = ACTIONS(2969),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2971),
  },
  [964] = {
    [sym_integer] = STATE(5749),
    [sym__literal] = STATE(5749),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = STATE(5599),
    [sym_qualified_variable] = STATE(5599),
    [sym_constructor] = STATE(5259),
    [sym_qualified_constructor] = STATE(5552),
    [sym__qcon] = STATE(5599),
    [sym_con_unit] = STATE(5749),
    [sym_con_list] = STATE(5749),
    [sym_con_tuple] = STATE(5749),
    [sym_literal] = STATE(5638),
    [sym_exp_parens] = STATE(5638),
    [sym_exp_tuple] = STATE(5638),
    [sym_exp_unboxed_tuple] = STATE(5638),
    [sym_exp_unboxed_sum] = STATE(5638),
    [sym_exp_list] = STATE(5638),
    [sym_exp_arithmetic_sequence] = STATE(5638),
    [sym_exp_list_comprehension] = STATE(5638),
    [sym_exp_section_left] = STATE(5638),
    [sym_exp_section_right] = STATE(5638),
    [sym_exp_th_quoted_name] = STATE(5638),
    [sym_exp_type_application] = STATE(957),
    [sym_exp_lambda] = STATE(12233),
    [sym_exp_let] = STATE(18245),
    [sym_exp_let_in] = STATE(12233),
    [sym_exp_cond] = STATE(12233),
    [sym_exp_case] = STATE(12233),
    [sym_exp_lambda_case] = STATE(957),
    [sym__do_keyword] = STATE(18319),
    [sym_do_module] = STATE(18319),
    [sym_exp_do] = STATE(957),
    [sym_exp_record] = STATE(5638),
    [sym_exp_name] = STATE(5638),
    [sym_exp_projection_selector] = STATE(5638),
    [sym__aexp_projection] = STATE(5638),
    [sym_exp_projection] = STATE(5638),
    [sym__aexp] = STATE(957),
    [sym__exp_apply] = STATE(12233),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12705),
    [sym_splice] = STATE(5638),
    [sym_quasiquote] = STATE(5638),
    [sym__varid] = ACTIONS(2973),
    [anon_sym_SEMI] = ACTIONS(1667),
    [sym_float] = ACTIONS(2975),
    [sym_char] = ACTIONS(2975),
    [sym_string] = ACTIONS(2975),
    [sym__integer_literal] = ACTIONS(2977),
    [sym__binary_literal] = ACTIONS(2979),
    [sym__octal_literal] = ACTIONS(2979),
    [sym__hex_literal] = ACTIONS(2979),
    [anon_sym_LPAREN_POUND] = ACTIONS(2981),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2981),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(2983),
    [sym__conid] = ACTIONS(3072),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [anon_sym_LBRACE] = ACTIONS(2994),
    [anon_sym_RBRACE] = ACTIONS(1667),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2998),
    [anon_sym_BSLASH] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_case] = ACTIONS(3004),
    [anon_sym_mdo] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_7] = ACTIONS(3008),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(1667),
    [sym__splice_dollar] = ACTIONS(3010),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3012),
  },
  [965] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20150),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20149),
    [sym_qualified_constructor_operator] = STATE(20149),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20149),
    [sym_qualified_type_operator] = STATE(20149),
    [sym__qualified_type_operator] = STATE(20149),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6903),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20474),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15658),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15658),
    [sym__type_context] = STATE(15658),
    [sym__type_fun] = STATE(15658),
    [sym__type] = STATE(15658),
    [sym__type_or_implicit] = STATE(15658),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16162),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3076),
    [anon_sym_DASH_GT] = ACTIONS(3076),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1446),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3080),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3082),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [966] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20982),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20974),
    [sym_qualified_constructor_operator] = STATE(20974),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20974),
    [sym_qualified_type_operator] = STATE(20974),
    [sym__qualified_type_operator] = STATE(20974),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6830),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20900),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17734),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17734),
    [sym__type_context] = STATE(17734),
    [sym__type_fun] = STATE(17734),
    [sym__type] = STATE(17734),
    [sym__type_or_implicit] = STATE(17734),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17440),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3084),
    [anon_sym_DASH_GT] = ACTIONS(3084),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1578),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3088),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [967] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20621),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3090),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [968] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20024),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20022),
    [sym_qualified_constructor_operator] = STATE(20022),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20022),
    [sym_qualified_type_operator] = STATE(20022),
    [sym__qualified_type_operator] = STATE(20022),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6885),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20282),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15807),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15807),
    [sym__type_context] = STATE(15807),
    [sym__type_fun] = STATE(15807),
    [sym__type] = STATE(15807),
    [sym__type_or_implicit] = STATE(15807),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16357),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3092),
    [anon_sym_DASH_GT] = ACTIONS(3092),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(337),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3094),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3096),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [969] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19863),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19862),
    [sym_qualified_constructor_operator] = STATE(19862),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19862),
    [sym_qualified_type_operator] = STATE(19862),
    [sym__qualified_type_operator] = STATE(19862),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6832),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19861),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16138),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16138),
    [sym__type_context] = STATE(16138),
    [sym__type_fun] = STATE(16138),
    [sym__type] = STATE(16138),
    [sym__type_or_implicit] = STATE(16138),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17420),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3098),
    [anon_sym_DASH_GT] = ACTIONS(3098),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3100),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3102),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3104),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [970] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19659),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3106),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [971] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19451),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19452),
    [sym_qualified_constructor_operator] = STATE(19452),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19452),
    [sym_qualified_type_operator] = STATE(19452),
    [sym__qualified_type_operator] = STATE(19452),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6802),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19162),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16699),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16699),
    [sym__type_context] = STATE(16699),
    [sym__type_fun] = STATE(16699),
    [sym__type] = STATE(16699),
    [sym__type_or_implicit] = STATE(16699),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16031),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2190),
    [anon_sym_DASH_GT] = ACTIONS(2190),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3108),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2192),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2204),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [972] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20415),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20422),
    [sym_qualified_constructor_operator] = STATE(20422),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20422),
    [sym_qualified_type_operator] = STATE(20422),
    [sym__qualified_type_operator] = STATE(20422),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7018),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19859),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17347),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17347),
    [sym__type_context] = STATE(17347),
    [sym__type_fun] = STATE(17347),
    [sym__type] = STATE(17347),
    [sym__type_or_implicit] = STATE(17347),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16850),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3110),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2280),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [973] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3112),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [974] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13559),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [975] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13515),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [976] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13788),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1268),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [977] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19789),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3118),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [978] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19787),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3120),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [979] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19736),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3122),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [980] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20339),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20342),
    [sym_qualified_constructor_operator] = STATE(20342),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20342),
    [sym_qualified_type_operator] = STATE(20342),
    [sym__qualified_type_operator] = STATE(20342),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6900),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19705),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17282),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17282),
    [sym__type_context] = STATE(17282),
    [sym__type_fun] = STATE(17282),
    [sym__type] = STATE(17282),
    [sym__type_or_implicit] = STATE(17282),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16729),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2056),
    [anon_sym_DASH_GT] = ACTIONS(2056),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3124),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2060),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2062),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [981] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19733),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3126),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [982] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19940),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [983] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19939),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3130),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [984] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19273),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19271),
    [sym_qualified_constructor_operator] = STATE(19271),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19271),
    [sym_qualified_type_operator] = STATE(19271),
    [sym__qualified_type_operator] = STATE(19271),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6825),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19693),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16280),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16280),
    [sym__type_context] = STATE(16280),
    [sym__type_fun] = STATE(16280),
    [sym__type] = STATE(16280),
    [sym__type_or_implicit] = STATE(16280),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17739),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3132),
    [anon_sym_DASH_GT] = ACTIONS(3132),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3134),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3136),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3138),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [985] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20002),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3140),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [986] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19988),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3142),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [987] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19027),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19026),
    [sym_qualified_constructor_operator] = STATE(19026),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19026),
    [sym_qualified_type_operator] = STATE(19026),
    [sym__qualified_type_operator] = STATE(19026),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6869),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15661),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2346),
    [anon_sym_DASH_GT] = ACTIONS(2346),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [988] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19917),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3146),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [989] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19914),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3148),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [990] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19998),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3150),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [991] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13605),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [992] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19584),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19708),
    [sym_qualified_constructor_operator] = STATE(19708),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19708),
    [sym_qualified_type_operator] = STATE(19708),
    [sym__qualified_type_operator] = STATE(19708),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6923),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19760),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17306),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17306),
    [sym__type_context] = STATE(17306),
    [sym__type_fun] = STATE(17306),
    [sym__type] = STATE(17306),
    [sym__type_or_implicit] = STATE(17306),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16752),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3152),
    [anon_sym_DASH_GT] = ACTIONS(3152),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3154),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3156),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3158),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [993] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19911),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19912),
    [sym_qualified_constructor_operator] = STATE(19912),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19912),
    [sym_qualified_type_operator] = STATE(19912),
    [sym__qualified_type_operator] = STATE(19912),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6792),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19913),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16091),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16091),
    [sym__type_context] = STATE(16091),
    [sym__type_fun] = STATE(16091),
    [sym__type] = STATE(16091),
    [sym__type_or_implicit] = STATE(16091),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16316),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3160),
    [anon_sym_DASH_GT] = ACTIONS(3160),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(345),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3162),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3164),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [994] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20272),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20270),
    [sym_qualified_constructor_operator] = STATE(20270),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20270),
    [sym_qualified_type_operator] = STATE(20270),
    [sym__qualified_type_operator] = STATE(20270),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6844),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20367),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17559),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17559),
    [sym__type_context] = STATE(17559),
    [sym__type_fun] = STATE(17559),
    [sym__type] = STATE(17559),
    [sym__type_or_implicit] = STATE(17559),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17134),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2449),
    [anon_sym_DASH_GT] = ACTIONS(2449),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3166),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2455),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [995] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19953),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3168),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [996] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20069),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3170),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [997] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20066),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3172),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [998] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19951),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3174),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [999] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20780),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20778),
    [sym_qualified_constructor_operator] = STATE(20778),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20778),
    [sym_qualified_type_operator] = STATE(20778),
    [sym__qualified_type_operator] = STATE(20778),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6932),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20868),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17719),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17719),
    [sym__type_context] = STATE(17719),
    [sym__type_fun] = STATE(17719),
    [sym__type] = STATE(17719),
    [sym__type_or_implicit] = STATE(17719),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17308),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2194),
    [anon_sym_DASH_GT] = ACTIONS(2194),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3176),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2200),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1000] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13560),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1314),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1001] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19747),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19746),
    [sym_qualified_constructor_operator] = STATE(19746),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19746),
    [sym_qualified_type_operator] = STATE(19746),
    [sym__qualified_type_operator] = STATE(19746),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6834),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19745),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16233),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16233),
    [sym__type_context] = STATE(16233),
    [sym__type_fun] = STATE(16233),
    [sym__type] = STATE(16233),
    [sym__type_or_implicit] = STATE(16233),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15899),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3178),
    [anon_sym_DASH_GT] = ACTIONS(3178),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(443),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3180),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1002] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20025),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3182),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1003] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13573),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1348),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1004] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20325),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20320),
    [sym_qualified_constructor_operator] = STATE(20320),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20320),
    [sym_qualified_type_operator] = STATE(20320),
    [sym__qualified_type_operator] = STATE(20320),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7042),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20463),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17581),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17581),
    [sym__type_context] = STATE(17581),
    [sym__type_fun] = STATE(17581),
    [sym__type] = STATE(17581),
    [sym__type_or_implicit] = STATE(17581),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17157),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2461),
    [anon_sym_DASH_GT] = ACTIONS(2461),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3184),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2465),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2467),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1005] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19696),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19694),
    [sym_qualified_constructor_operator] = STATE(19694),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19694),
    [sym_qualified_type_operator] = STATE(19694),
    [sym__qualified_type_operator] = STATE(19694),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6847),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19904),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16094),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16094),
    [sym__type_context] = STATE(16094),
    [sym__type_fun] = STATE(16094),
    [sym__type] = STATE(16094),
    [sym__type_or_implicit] = STATE(16094),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17337),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1821),
    [anon_sym_DASH_GT] = ACTIONS(1821),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3186),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2006),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1827),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1006] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19557),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3188),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1007] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19556),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3190),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1008] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19765),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19764),
    [sym_qualified_constructor_operator] = STATE(19764),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19764),
    [sym_qualified_type_operator] = STATE(19764),
    [sym__qualified_type_operator] = STATE(19764),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6881),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19810),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17328),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17328),
    [sym__type_context] = STATE(17328),
    [sym__type_fun] = STATE(17328),
    [sym__type] = STATE(17328),
    [sym__type_or_implicit] = STATE(17328),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16820),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3192),
    [anon_sym_DASH_GT] = ACTIONS(3192),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1562),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3194),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3196),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1009] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19830),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3198),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1010] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19824),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3200),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1011] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13664),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1012] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20872),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20870),
    [sym_qualified_constructor_operator] = STATE(20870),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20870),
    [sym_qualified_type_operator] = STATE(20870),
    [sym__qualified_type_operator] = STATE(20870),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6935),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20936),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17758),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17758),
    [sym__type_context] = STATE(17758),
    [sym__type_fun] = STATE(17758),
    [sym__type] = STATE(17758),
    [sym__type_or_implicit] = STATE(17758),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17329),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2138),
    [anon_sym_DASH_GT] = ACTIONS(2138),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2142),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2144),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1013] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19475),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3206),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1014] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19474),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3208),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1015] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13694),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3210),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1016] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19812),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19811),
    [sym_qualified_constructor_operator] = STATE(19811),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19811),
    [sym_qualified_type_operator] = STATE(19811),
    [sym__qualified_type_operator] = STATE(19811),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6940),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19921),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17367),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17367),
    [sym__type_context] = STATE(17367),
    [sym__type_fun] = STATE(17367),
    [sym__type] = STATE(17367),
    [sym__type_or_implicit] = STATE(17367),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16878),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3212),
    [anon_sym_DASH_GT] = ACTIONS(3212),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3216),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1017] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19803),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3218),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1018] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19802),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3220),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1019] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20287),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20284),
    [sym_qualified_constructor_operator] = STATE(20284),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20284),
    [sym_qualified_type_operator] = STATE(20284),
    [sym__qualified_type_operator] = STATE(20284),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6887),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19691),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16282),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16282),
    [sym__type_context] = STATE(16282),
    [sym__type_fun] = STATE(16282),
    [sym__type] = STATE(16282),
    [sym__type_or_implicit] = STATE(16282),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16221),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2186),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3222),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2188),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2272),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1020] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19927),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19924),
    [sym_qualified_constructor_operator] = STATE(19924),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19924),
    [sym_qualified_type_operator] = STATE(19924),
    [sym__qualified_type_operator] = STATE(19924),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6967),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20026),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17416),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17416),
    [sym__type_context] = STATE(17416),
    [sym__type_fun] = STATE(17416),
    [sym__type] = STATE(17416),
    [sym__type_or_implicit] = STATE(17416),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16926),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3224),
    [anon_sym_DASH_GT] = ACTIONS(3224),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1602),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3226),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3228),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1021] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20023),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3230),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1022] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20184),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20182),
    [sym_qualified_constructor_operator] = STATE(20182),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20182),
    [sym_qualified_type_operator] = STATE(20182),
    [sym__qualified_type_operator] = STATE(20182),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6966),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20222),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17516),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17516),
    [sym__type_context] = STATE(17516),
    [sym__type_fun] = STATE(17516),
    [sym__type] = STATE(17516),
    [sym__type_or_implicit] = STATE(17516),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17080),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2170),
    [anon_sym_DASH_GT] = ACTIONS(2170),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3232),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2174),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2176),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1023] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20144),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20154),
    [sym_qualified_constructor_operator] = STATE(20154),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20154),
    [sym_qualified_type_operator] = STATE(20154),
    [sym__qualified_type_operator] = STATE(20154),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6793),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20156),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15904),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15904),
    [sym__type_context] = STATE(15904),
    [sym__type_fun] = STATE(15904),
    [sym__type] = STATE(15904),
    [sym__type_or_implicit] = STATE(15904),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16411),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3234),
    [anon_sym_DASH_GT] = ACTIONS(3234),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(353),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3238),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1024] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20986),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20985),
    [sym_qualified_constructor_operator] = STATE(20985),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20985),
    [sym_qualified_type_operator] = STATE(20985),
    [sym__qualified_type_operator] = STATE(20985),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6865),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20952),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17765),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17765),
    [sym__type_context] = STATE(17765),
    [sym__type_fun] = STATE(17765),
    [sym__type] = STATE(17765),
    [sym__type_or_implicit] = STATE(17765),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17417),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2064),
    [anon_sym_DASH_GT] = ACTIONS(2064),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3240),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2068),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2070),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1025] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19586),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19585),
    [sym_qualified_constructor_operator] = STATE(19585),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19585),
    [sym_qualified_type_operator] = STATE(19585),
    [sym__qualified_type_operator] = STATE(19585),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6877),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19569),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17232),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17232),
    [sym__type_context] = STATE(17232),
    [sym__type_fun] = STATE(17232),
    [sym__type] = STATE(17232),
    [sym__type_or_implicit] = STATE(17232),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16657),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3242),
    [anon_sym_DASH_GT] = ACTIONS(3242),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(381),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3244),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3246),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1026] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19984),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3248),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1027] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20618),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3250),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1028] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19990),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19985),
    [sym_qualified_constructor_operator] = STATE(19985),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19985),
    [sym_qualified_type_operator] = STATE(19985),
    [sym__qualified_type_operator] = STATE(19985),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6979),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20081),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17439),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17439),
    [sym__type_context] = STATE(17439),
    [sym__type_fun] = STATE(17439),
    [sym__type] = STATE(17439),
    [sym__type_or_implicit] = STATE(17439),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16969),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3252),
    [anon_sym_DASH_GT] = ACTIONS(3252),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1534),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3254),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3256),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1029] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19633),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3258),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1030] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19639),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19638),
    [sym_qualified_constructor_operator] = STATE(19638),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19638),
    [sym_qualified_type_operator] = STATE(19638),
    [sym__qualified_type_operator] = STATE(19638),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6836),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19583),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16328),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16328),
    [sym__type_context] = STATE(16328),
    [sym__type_fun] = STATE(16328),
    [sym__type] = STATE(16328),
    [sym__type_or_implicit] = STATE(16328),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17451),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3260),
    [anon_sym_DASH_GT] = ACTIONS(3260),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3262),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3266),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1031] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19535),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3268),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1032] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19524),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3270),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1033] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13596),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1034] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20029),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20027),
    [sym_qualified_constructor_operator] = STATE(20027),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20027),
    [sym_qualified_type_operator] = STATE(20027),
    [sym__qualified_type_operator] = STATE(20027),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7051),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20130),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17457),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17457),
    [sym__type_context] = STATE(17457),
    [sym__type_fun] = STATE(17457),
    [sym__type] = STATE(17457),
    [sym__type_or_implicit] = STATE(17457),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16997),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3274),
    [anon_sym_DASH_GT] = ACTIONS(3274),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1586),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3276),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3278),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1035] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20684),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3280),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1036] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13962),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1037] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20689),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3282),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1038] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20902),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20899),
    [sym_qualified_constructor_operator] = STATE(20899),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20899),
    [sym_qualified_type_operator] = STATE(20899),
    [sym__qualified_type_operator] = STATE(20899),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6894),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20766),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17672),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17672),
    [sym__type_context] = STATE(17672),
    [sym__type_fun] = STATE(17672),
    [sym__type] = STATE(17672),
    [sym__type_or_implicit] = STATE(17672),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17476),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2016),
    [anon_sym_DASH_GT] = ACTIONS(2016),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3284),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2020),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2022),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1039] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19428),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3286),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1040] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19726),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3288),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1041] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3290),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1042] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20226),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20225),
    [sym_qualified_constructor_operator] = STATE(20225),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20225),
    [sym_qualified_type_operator] = STATE(20225),
    [sym__qualified_type_operator] = STATE(20225),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6888),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20319),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17538),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17538),
    [sym__type_context] = STATE(17538),
    [sym__type_fun] = STATE(17538),
    [sym__type] = STATE(17538),
    [sym__type_or_implicit] = STATE(17538),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17100),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(285),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3294),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3296),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1043] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19426),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3298),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1044] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20167),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3300),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1045] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19697),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3302),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1046] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20677),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20680),
    [sym_qualified_constructor_operator] = STATE(20680),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20680),
    [sym_qualified_type_operator] = STATE(20680),
    [sym__qualified_type_operator] = STATE(20680),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7021),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20427),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17579),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17579),
    [sym__type_context] = STATE(17579),
    [sym__type_fun] = STATE(17579),
    [sym__type] = STATE(17579),
    [sym__type_or_implicit] = STATE(17579),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17539),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2507),
    [anon_sym_DASH_GT] = ACTIONS(2507),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3304),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2511),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2513),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1047] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19692),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3306),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1048] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19251),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3308),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1049] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19250),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3310),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1050] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20370),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20369),
    [sym_qualified_constructor_operator] = STATE(20369),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20369),
    [sym_qualified_type_operator] = STATE(20369),
    [sym__qualified_type_operator] = STATE(20369),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6970),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20555),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17607),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17607),
    [sym__type_context] = STATE(17607),
    [sym__type_fun] = STATE(17607),
    [sym__type] = STATE(17607),
    [sym__type_or_implicit] = STATE(17607),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17186),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3312),
    [anon_sym_DASH_GT] = ACTIONS(3312),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3314),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3316),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3318),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1051] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19668),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3320),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1052] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20163),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3322),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1053] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20079),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3324),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1054] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20133),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20132),
    [sym_qualified_constructor_operator] = STATE(20132),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20132),
    [sym_qualified_type_operator] = STATE(20132),
    [sym__qualified_type_operator] = STATE(20132),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6809),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20224),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17492),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17492),
    [sym__type_context] = STATE(17492),
    [sym__type_fun] = STATE(17492),
    [sym__type] = STATE(17492),
    [sym__type_or_implicit] = STATE(17492),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17065),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1986),
    [anon_sym_DASH_GT] = ACTIONS(1986),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3326),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(1990),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1992),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1055] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20415),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20422),
    [sym_qualified_constructor_operator] = STATE(20422),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20422),
    [sym_qualified_type_operator] = STATE(20422),
    [sym__qualified_type_operator] = STATE(20422),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7018),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15661),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2274),
    [anon_sym_DASH_GT] = ACTIONS(2274),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2276),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1056] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19249),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19245),
    [sym_qualified_constructor_operator] = STATE(19245),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19245),
    [sym_qualified_type_operator] = STATE(19245),
    [sym__qualified_type_operator] = STATE(19245),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6916),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19244),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17064),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17064),
    [sym__type_context] = STATE(17064),
    [sym__type_fun] = STATE(17064),
    [sym__type] = STATE(17064),
    [sym__type_or_implicit] = STATE(17064),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16580),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2222),
    [anon_sym_DASH_GT] = ACTIONS(2222),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3328),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2228),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1057] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20449),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20450),
    [sym_qualified_constructor_operator] = STATE(20450),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20450),
    [sym_qualified_type_operator] = STATE(20450),
    [sym__qualified_type_operator] = STATE(20450),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6808),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20453),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15669),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15669),
    [sym__type_context] = STATE(15669),
    [sym__type_fun] = STATE(15669),
    [sym__type] = STATE(15669),
    [sym__type_or_implicit] = STATE(15669),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16601),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3330),
    [anon_sym_DASH_GT] = ACTIONS(3330),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(389),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3332),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3334),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1058] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19525),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19523),
    [sym_qualified_constructor_operator] = STATE(19523),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19523),
    [sym_qualified_type_operator] = STATE(19523),
    [sym__qualified_type_operator] = STATE(19523),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6846),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19520),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16423),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16423),
    [sym__type_context] = STATE(16423),
    [sym__type_fun] = STATE(16423),
    [sym__type] = STATE(16423),
    [sym__type_or_implicit] = STATE(16423),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17482),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(349),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3338),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3340),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1059] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20351),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20469),
    [sym_qualified_constructor_operator] = STATE(20469),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20469),
    [sym_qualified_type_operator] = STATE(20469),
    [sym__qualified_type_operator] = STATE(20469),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7043),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20639),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17632),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17632),
    [sym__type_context] = STATE(17632),
    [sym__type_fun] = STATE(17632),
    [sym__type] = STATE(17632),
    [sym__type_or_implicit] = STATE(17632),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17216),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3342),
    [anon_sym_DASH_GT] = ACTIONS(3342),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3344),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3346),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3348),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1060] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19430),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19429),
    [sym_qualified_constructor_operator] = STATE(19429),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19429),
    [sym_qualified_type_operator] = STATE(19429),
    [sym__qualified_type_operator] = STATE(19429),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6805),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19427),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17156),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17156),
    [sym__type_context] = STATE(17156),
    [sym__type_fun] = STATE(17156),
    [sym__type] = STATE(17156),
    [sym__type_or_implicit] = STATE(17156),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16608),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3350),
    [anon_sym_DASH_GT] = ACTIONS(3350),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3354),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3356),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1061] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13630),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1062] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19143),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3360),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1063] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19196),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3362),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1064] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19451),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19452),
    [sym_qualified_constructor_operator] = STATE(19452),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19452),
    [sym_qualified_type_operator] = STATE(19452),
    [sym__qualified_type_operator] = STATE(19452),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6802),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15661),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2190),
    [anon_sym_DASH_GT] = ACTIONS(2190),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2192),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1065] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13753),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3364),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1066] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13754),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3366),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1067] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19612),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3368),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1068] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19607),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3370),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1069] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20080),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3372),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1070] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20558),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20557),
    [sym_qualified_constructor_operator] = STATE(20557),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20557),
    [sym_qualified_type_operator] = STATE(20557),
    [sym__qualified_type_operator] = STATE(20557),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6839),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20735),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17651),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17651),
    [sym__type_context] = STATE(17651),
    [sym__type_fun] = STATE(17651),
    [sym__type] = STATE(17651),
    [sym__type_or_implicit] = STATE(17651),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17235),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3374),
    [anon_sym_DASH_GT] = ACTIONS(3374),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3376),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3378),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3380),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1071] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13504),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1072] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20221),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3382),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1073] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19581),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3384),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1074] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19580),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3386),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1075] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20339),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20342),
    [sym_qualified_constructor_operator] = STATE(20342),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20342),
    [sym_qualified_type_operator] = STATE(20342),
    [sym__qualified_type_operator] = STATE(20342),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6900),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15661),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2056),
    [anon_sym_DASH_GT] = ACTIONS(2056),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2060),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1076] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19890),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19902),
    [sym_qualified_constructor_operator] = STATE(19902),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19902),
    [sym_qualified_type_operator] = STATE(19902),
    [sym__qualified_type_operator] = STATE(19902),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6822),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18972),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16861),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16861),
    [sym__type_context] = STATE(16861),
    [sym__type_fun] = STATE(16861),
    [sym__type] = STATE(16861),
    [sym__type_or_implicit] = STATE(16861),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16871),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3388),
    [anon_sym_DASH_GT] = ACTIONS(3388),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3392),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3394),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1077] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20207),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3396),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1078] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20210),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3398),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1079] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19386),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19382),
    [sym_qualified_constructor_operator] = STATE(19382),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19382),
    [sym_qualified_type_operator] = STATE(19382),
    [sym__qualified_type_operator] = STATE(19382),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6803),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19378),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17133),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17133),
    [sym__type_context] = STATE(17133),
    [sym__type_fun] = STATE(17133),
    [sym__type] = STATE(17133),
    [sym__type_or_implicit] = STATE(17133),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16083),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(3400),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(529),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1080] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20643),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20642),
    [sym_qualified_constructor_operator] = STATE(20642),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20642),
    [sym_qualified_type_operator] = STATE(20642),
    [sym__qualified_type_operator] = STATE(20642),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6831),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20776),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17676),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17676),
    [sym__type_context] = STATE(17676),
    [sym__type_fun] = STATE(17676),
    [sym__type] = STATE(17676),
    [sym__type_or_implicit] = STATE(17676),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17262),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3404),
    [anon_sym_DASH_GT] = ACTIONS(3404),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3406),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3408),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3410),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1081] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19362),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19497),
    [sym_qualified_constructor_operator] = STATE(19497),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19497),
    [sym_qualified_type_operator] = STATE(19497),
    [sym__qualified_type_operator] = STATE(19497),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6801),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15661),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1082] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20109),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3412),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1083] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(18988),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18986),
    [sym_qualified_constructor_operator] = STATE(18986),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18986),
    [sym_qualified_type_operator] = STATE(18986),
    [sym__qualified_type_operator] = STATE(18986),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6823),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19566),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16389),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16389),
    [sym__type_context] = STATE(16389),
    [sym__type_fun] = STATE(16389),
    [sym__type] = STATE(16389),
    [sym__type_or_implicit] = STATE(16389),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17630),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3414),
    [anon_sym_DASH_GT] = ACTIONS(3414),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(297),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3416),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3418),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1084] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19417),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19415),
    [sym_qualified_constructor_operator] = STATE(19415),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19415),
    [sym_qualified_type_operator] = STATE(19415),
    [sym__qualified_type_operator] = STATE(19415),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6848),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19414),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16518),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16518),
    [sym__type_context] = STATE(16518),
    [sym__type_fun] = STATE(16518),
    [sym__type] = STATE(16518),
    [sym__type_or_implicit] = STATE(16518),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17513),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3420),
    [anon_sym_DASH_GT] = ACTIONS(3420),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(329),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3422),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3424),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1085] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19312),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19316),
    [sym_qualified_constructor_operator] = STATE(19316),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19316),
    [sym_qualified_type_operator] = STATE(19316),
    [sym__qualified_type_operator] = STATE(19316),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6890),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15661),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1994),
    [anon_sym_DASH_GT] = ACTIONS(1994),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(1996),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1086] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20296),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3426),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1087] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13676),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3428),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1088] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13565),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1089] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20087),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20086),
    [sym_qualified_constructor_operator] = STATE(20086),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20086),
    [sym_qualified_type_operator] = STATE(20086),
    [sym__qualified_type_operator] = STATE(20086),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6835),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20178),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17475),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17475),
    [sym__type_context] = STATE(17475),
    [sym__type_fun] = STATE(17475),
    [sym__type] = STATE(17475),
    [sym__type_or_implicit] = STATE(17475),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17034),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2146),
    [anon_sym_DASH_GT] = ACTIONS(2146),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3430),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2150),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2152),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1090] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20737),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20736),
    [sym_qualified_constructor_operator] = STATE(20736),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20736),
    [sym_qualified_type_operator] = STATE(20736),
    [sym__qualified_type_operator] = STATE(20736),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6950),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20823),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17696),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17696),
    [sym__type_context] = STATE(17696),
    [sym__type_fun] = STATE(17696),
    [sym__type] = STATE(17696),
    [sym__type_or_implicit] = STATE(17696),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17286),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3432),
    [anon_sym_DASH_GT] = ACTIONS(3432),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3434),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3436),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3438),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1091] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13493),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3440),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1092] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19500),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3442),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1093] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19499),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3444),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1094] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20255),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20258),
    [sym_qualified_constructor_operator] = STATE(20258),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20258),
    [sym_qualified_type_operator] = STATE(20258),
    [sym__qualified_type_operator] = STATE(20258),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7007),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20266),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17517),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17517),
    [sym__type_context] = STATE(17517),
    [sym__type_fun] = STATE(17517),
    [sym__type] = STATE(17517),
    [sym__type_or_implicit] = STATE(17517),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17582),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2282),
    [anon_sym_DASH_GT] = ACTIONS(2282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3446),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2288),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1095] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20301),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3448),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1096] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20112),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3450),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1097] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20114),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3452),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1098] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20471),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20467),
    [sym_qualified_constructor_operator] = STATE(20467),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20467),
    [sym_qualified_type_operator] = STATE(20467),
    [sym__qualified_type_operator] = STATE(20467),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6807),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20465),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15663),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15663),
    [sym__type_context] = STATE(15663),
    [sym__type_fun] = STATE(15663),
    [sym__type] = STATE(15663),
    [sym__type_or_implicit] = STATE(15663),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17161),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3454),
    [anon_sym_DASH_GT] = ACTIONS(3454),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3456),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3458),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3460),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1099] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19197),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3462),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1100] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19189),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3464),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1101] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19341),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19339),
    [sym_qualified_constructor_operator] = STATE(19339),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19339),
    [sym_qualified_type_operator] = STATE(19339),
    [sym__qualified_type_operator] = STATE(19339),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6821),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19338),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17096),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17096),
    [sym__type_context] = STATE(17096),
    [sym__type_fun] = STATE(17096),
    [sym__type] = STATE(17096),
    [sym__type_or_implicit] = STATE(17096),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16597),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3466),
    [anon_sym_DASH_GT] = ACTIONS(3466),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1618),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3468),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3470),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1102] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19864),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19860),
    [sym_qualified_constructor_operator] = STATE(19860),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19860),
    [sym_qualified_type_operator] = STATE(19860),
    [sym__qualified_type_operator] = STATE(19860),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6961),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19982),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17392),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17392),
    [sym__type_context] = STATE(17392),
    [sym__type_fun] = STATE(17392),
    [sym__type] = STATE(17392),
    [sym__type_or_implicit] = STATE(17392),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16902),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2488),
    [anon_sym_DASH_GT] = ACTIONS(2488),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3472),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2494),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1103] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19957),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3474),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1104] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20116),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20120),
    [sym_qualified_constructor_operator] = STATE(20120),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20120),
    [sym_qualified_type_operator] = STATE(20120),
    [sym__qualified_type_operator] = STATE(20120),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6996),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20125),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17455),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17455),
    [sym__type_context] = STATE(17455),
    [sym__type_fun] = STATE(17455),
    [sym__type] = STATE(17455),
    [sym__type_or_implicit] = STATE(17455),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17633),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2206),
    [anon_sym_DASH_GT] = ACTIONS(2206),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3476),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2212),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1105] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19075),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3478),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1106] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19956),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3480),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1107] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19472),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3482),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1108] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19471),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3484),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1109] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19114),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3486),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1110] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13937),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1276),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1111] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20826),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20824),
    [sym_qualified_constructor_operator] = STATE(20824),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20824),
    [sym_qualified_type_operator] = STATE(20824),
    [sym__qualified_type_operator] = STATE(20824),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6949),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20903),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17733),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17733),
    [sym__type_context] = STATE(17733),
    [sym__type_fun] = STATE(17733),
    [sym__type] = STATE(17733),
    [sym__type_or_implicit] = STATE(17733),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15615),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3488),
    [anon_sym_DASH_GT] = ACTIONS(3488),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(385),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3490),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1112] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13761),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1270),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1113] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19194),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19192),
    [sym_qualified_constructor_operator] = STATE(19192),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19192),
    [sym_qualified_type_operator] = STATE(19192),
    [sym__qualified_type_operator] = STATE(19192),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6818),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19187),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17033),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17033),
    [sym__type_context] = STATE(17033),
    [sym__type_fun] = STATE(17033),
    [sym__type] = STATE(17033),
    [sym__type_or_implicit] = STATE(17033),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16569),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3492),
    [anon_sym_DASH_GT] = ACTIONS(3492),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1494),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3494),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3496),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1114] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19067),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3498),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1115] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19806),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19805),
    [sym_qualified_constructor_operator] = STATE(19805),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19805),
    [sym_qualified_type_operator] = STATE(19805),
    [sym__qualified_type_operator] = STATE(19805),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6871),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20020),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15995),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15995),
    [sym__type_context] = STATE(15995),
    [sym__type_fun] = STATE(15995),
    [sym__type] = STATE(15995),
    [sym__type_or_implicit] = STATE(15995),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17084),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2646),
    [anon_sym_DASH_GT] = ACTIONS(2646),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(2650),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3500),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2654),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1116] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19362),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19497),
    [sym_qualified_constructor_operator] = STATE(19497),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19497),
    [sym_qualified_type_operator] = STATE(19497),
    [sym__qualified_type_operator] = STATE(19497),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6801),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19910),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17377),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17377),
    [sym__type_context] = STATE(17377),
    [sym__type_fun] = STATE(17377),
    [sym__type] = STATE(17377),
    [sym__type_or_implicit] = STATE(17377),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16108),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2230),
    [anon_sym_DASH_GT] = ACTIONS(2230),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3502),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2232),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2474),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1117] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20909),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20906),
    [sym_qualified_constructor_operator] = STATE(20906),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20906),
    [sym_qualified_type_operator] = STATE(20906),
    [sym__qualified_type_operator] = STATE(20906),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6864),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20961),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17784),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17784),
    [sym__type_context] = STATE(17784),
    [sym__type_fun] = STATE(17784),
    [sym__type] = STATE(17784),
    [sym__type_or_implicit] = STATE(17784),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17352),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3504),
    [anon_sym_DASH_GT] = ACTIONS(3504),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1570),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3506),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3508),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1118] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13476),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3510),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1119] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19044),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19042),
    [sym_qualified_constructor_operator] = STATE(19042),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19042),
    [sym_qualified_type_operator] = STATE(19042),
    [sym__qualified_type_operator] = STATE(19042),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7012),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19038),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16966),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16966),
    [sym__type_context] = STATE(16966),
    [sym__type_fun] = STATE(16966),
    [sym__type] = STATE(16966),
    [sym__type_or_implicit] = STATE(16966),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16558),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3512),
    [anon_sym_DASH_GT] = ACTIONS(3512),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1414),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3514),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3516),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1120] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19154),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19153),
    [sym_qualified_constructor_operator] = STATE(19153),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19153),
    [sym_qualified_type_operator] = STATE(19153),
    [sym__qualified_type_operator] = STATE(19153),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6854),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19145),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16708),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16708),
    [sym__type_context] = STATE(16708),
    [sym__type_fun] = STATE(16708),
    [sym__type] = STATE(16708),
    [sym__type_or_implicit] = STATE(16708),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17637),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3518),
    [anon_sym_DASH_GT] = ACTIONS(3518),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(369),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3520),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3522),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1121] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20292),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3524),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1122] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13714),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3526),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1123] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19066),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3528),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1124] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20939),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20938),
    [sym_qualified_constructor_operator] = STATE(20938),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20938),
    [sym_qualified_type_operator] = STATE(20938),
    [sym__qualified_type_operator] = STATE(20938),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6926),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20984),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17805),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17805),
    [sym__type_context] = STATE(17805),
    [sym__type_fun] = STATE(17805),
    [sym__type] = STATE(17805),
    [sym__type_or_implicit] = STATE(17805),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17368),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3530),
    [anon_sym_DASH_GT] = ACTIONS(3530),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3532),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3534),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1125] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20293),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3536),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1126] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20441),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3538),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1127] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20523),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3540),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1128] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20438),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3542),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1129] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20287),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20284),
    [sym_qualified_constructor_operator] = STATE(20284),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20284),
    [sym_qualified_type_operator] = STATE(20284),
    [sym__qualified_type_operator] = STATE(20284),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6887),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15661),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2186),
    [anon_sym_DASH_GT] = ACTIONS(2186),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2188),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1130] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19387),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3544),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1131] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19381),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3546),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1132] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(18913),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18914),
    [sym_qualified_constructor_operator] = STATE(18914),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18914),
    [sym_qualified_type_operator] = STATE(18914),
    [sym__qualified_type_operator] = STATE(18914),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7013),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18915),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16924),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16924),
    [sym__type_context] = STATE(16924),
    [sym__type_fun] = STATE(16924),
    [sym__type] = STATE(16924),
    [sym__type_or_implicit] = STATE(16924),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16527),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3548),
    [anon_sym_DASH_GT] = ACTIONS(3548),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3550),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3552),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3554),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1133] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20525),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3556),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1134] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20332),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3558),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1135] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13480),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1136] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18996),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3560),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1137] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20963),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20962),
    [sym_qualified_constructor_operator] = STATE(20962),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20962),
    [sym_qualified_type_operator] = STATE(20962),
    [sym__qualified_type_operator] = STATE(20962),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6804),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20987),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17792),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17792),
    [sym__type_context] = STATE(17792),
    [sym__type_fun] = STATE(17792),
    [sym__type] = STATE(17792),
    [sym__type_or_implicit] = STATE(17792),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17396),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3562),
    [anon_sym_DASH_GT] = ACTIONS(3562),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3564),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3566),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1138] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19342),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3568),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1139] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19340),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3570),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1140] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18949),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3572),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1141] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20095),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3574),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1142] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19644),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19643),
    [sym_qualified_constructor_operator] = STATE(19643),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19643),
    [sym_qualified_type_operator] = STATE(19643),
    [sym__qualified_type_operator] = STATE(19643),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6906),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19640),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17261),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17261),
    [sym__type_context] = STATE(17261),
    [sym__type_fun] = STATE(17261),
    [sym__type] = STATE(17261),
    [sym__type_or_implicit] = STATE(17261),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16681),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3576),
    [anon_sym_DASH_GT] = ACTIONS(3576),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3578),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3580),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3582),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1143] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20051),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3584),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1144] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13807),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3586),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1145] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18927),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3588),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1146] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18924),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3590),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1147] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20333),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3592),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1148] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19533),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19532),
    [sym_qualified_constructor_operator] = STATE(19532),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19532),
    [sym_qualified_type_operator] = STATE(19532),
    [sym__qualified_type_operator] = STATE(19532),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6863),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19530),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17214),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17214),
    [sym__type_context] = STATE(17214),
    [sym__type_fun] = STATE(17214),
    [sym__type] = STATE(17214),
    [sym__type_or_implicit] = STATE(17214),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16623),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2178),
    [anon_sym_DASH_GT] = ACTIONS(2178),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3594),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2182),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2184),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1149] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20561),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3596),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1150] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20942),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20944),
    [sym_qualified_constructor_operator] = STATE(20944),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20944),
    [sym_qualified_type_operator] = STATE(20944),
    [sym__qualified_type_operator] = STATE(20944),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6842),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20836),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17703),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17703),
    [sym__type_context] = STATE(17703),
    [sym__type_fun] = STATE(17703),
    [sym__type] = STATE(17703),
    [sym__type_or_implicit] = STATE(17703),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17458),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3598),
    [anon_sym_DASH_GT] = ACTIONS(3598),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1454),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3600),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3602),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1151] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20562),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3604),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1152] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(18946),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18945),
    [sym_qualified_constructor_operator] = STATE(18945),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18945),
    [sym_qualified_type_operator] = STATE(18945),
    [sym__qualified_type_operator] = STATE(18945),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6873),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18943),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16898),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16898),
    [sym__type_context] = STATE(16898),
    [sym__type_fun] = STATE(16898),
    [sym__type] = STATE(16898),
    [sym__type_or_implicit] = STATE(16898),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17699),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3606),
    [anon_sym_DASH_GT] = ACTIONS(3606),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3608),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3610),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1153] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19686),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19689),
    [sym_qualified_constructor_operator] = STATE(19689),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19689),
    [sym_qualified_type_operator] = STATE(19689),
    [sym__qualified_type_operator] = STATE(19689),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6791),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19453),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16488),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16488),
    [sym__type_context] = STATE(16488),
    [sym__type_fun] = STATE(16488),
    [sym__type] = STATE(16488),
    [sym__type_or_implicit] = STATE(16488),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16126),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3612),
    [anon_sym_DASH_GT] = ACTIONS(3612),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3614),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3616),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3618),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1154] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13748),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3620),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1155] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19751),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3622),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1156] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13486),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3624),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1157] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19509),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3626),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1158] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19807),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19808),
    [sym_qualified_constructor_operator] = STATE(19808),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19808),
    [sym_qualified_type_operator] = STATE(19808),
    [sym__qualified_type_operator] = STATE(19808),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6918),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19814),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17331),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17331),
    [sym__type_context] = STATE(17331),
    [sym__type_fun] = STATE(17331),
    [sym__type] = STATE(17331),
    [sym__type_or_implicit] = STATE(17331),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17722),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2008),
    [anon_sym_DASH_GT] = ACTIONS(2008),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3628),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2012),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2014),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1159] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19228),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3630),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1160] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19227),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3632),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1161] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19096),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3634),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1162] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19141),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3636),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1163] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19645),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19661),
    [sym_qualified_constructor_operator] = STATE(19661),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19661),
    [sym_qualified_type_operator] = STATE(19661),
    [sym__qualified_type_operator] = STATE(19661),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6794),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19670),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17269),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17269),
    [sym__type_context] = STATE(17269),
    [sym__type_fun] = STATE(17269),
    [sym__type] = STATE(17269),
    [sym__type_or_implicit] = STATE(17269),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17759),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2048),
    [anon_sym_DASH_GT] = ACTIONS(2048),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3638),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2052),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2054),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1164] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19210),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3640),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1165] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19204),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3642),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1166] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19483),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19482),
    [sym_qualified_constructor_operator] = STATE(19482),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19482),
    [sym_qualified_type_operator] = STATE(19482),
    [sym__qualified_type_operator] = STATE(19482),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6853),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19478),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17183),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17183),
    [sym__type_context] = STATE(17183),
    [sym__type_fun] = STATE(17183),
    [sym__type] = STATE(17183),
    [sym__type_or_implicit] = STATE(17183),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16617),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2122),
    [anon_sym_DASH_GT] = ACTIONS(2122),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3644),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2126),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2128),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1167] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20603),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20602),
    [sym_qualified_constructor_operator] = STATE(20602),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20602),
    [sym_qualified_type_operator] = STATE(20602),
    [sym__qualified_type_operator] = STATE(20602),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6800),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20598),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15568),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15568),
    [sym__type_context] = STATE(15568),
    [sym__type_fun] = STATE(15568),
    [sym__type] = STATE(15568),
    [sym__type_or_implicit] = STATE(15568),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17075),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3646),
    [anon_sym_DASH_GT] = ACTIONS(3646),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1610),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3648),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3650),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1168] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19578),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19592),
    [sym_qualified_constructor_operator] = STATE(19592),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19592),
    [sym_qualified_type_operator] = STATE(19592),
    [sym__qualified_type_operator] = STATE(19592),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6898),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19593),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17238),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17238),
    [sym__type_context] = STATE(17238),
    [sym__type_fun] = STATE(17238),
    [sym__type] = STATE(17238),
    [sym__type_or_implicit] = STATE(17238),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17785),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2130),
    [anon_sym_DASH_GT] = ACTIONS(2130),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3652),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2134),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2136),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1169] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(18935),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18936),
    [sym_qualified_constructor_operator] = STATE(18936),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18936),
    [sym_qualified_type_operator] = STATE(18936),
    [sym__qualified_type_operator] = STATE(18936),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7049),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18937),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16901),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16901),
    [sym__type_context] = STATE(16901),
    [sym__type_fun] = STATE(16901),
    [sym__type] = STATE(16901),
    [sym__type_or_implicit] = STATE(16901),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16517),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3654),
    [anon_sym_DASH_GT] = ACTIONS(3654),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3656),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3658),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3660),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1170] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19757),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3662),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1171] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20401),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3664),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1172] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19299),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19297),
    [sym_qualified_constructor_operator] = STATE(19297),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19297),
    [sym_qualified_type_operator] = STATE(19297),
    [sym__qualified_type_operator] = STATE(19297),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6841),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19296),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17079),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17079),
    [sym__type_context] = STATE(17079),
    [sym__type_fun] = STATE(17079),
    [sym__type] = STATE(17079),
    [sym__type_or_implicit] = STATE(17079),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16587),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1998),
    [anon_sym_DASH_GT] = ACTIONS(1998),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3666),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2002),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2004),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1173] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20828),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20830),
    [sym_qualified_constructor_operator] = STATE(20830),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20830),
    [sym_qualified_type_operator] = STATE(20830),
    [sym__qualified_type_operator] = STATE(20830),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6974),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20702),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17641),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17641),
    [sym__type_context] = STATE(17641),
    [sym__type_fun] = STATE(17641),
    [sym__type] = STATE(17641),
    [sym__type_or_implicit] = STATE(17641),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17494),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3668),
    [anon_sym_DASH_GT] = ACTIONS(3668),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1518),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3670),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3672),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1174] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19090),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19105),
    [sym_qualified_constructor_operator] = STATE(19105),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19105),
    [sym_qualified_type_operator] = STATE(19105),
    [sym__qualified_type_operator] = STATE(19105),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6889),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19073),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16993),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16993),
    [sym__type_context] = STATE(16993),
    [sym__type_fun] = STATE(16993),
    [sym__type] = STATE(16993),
    [sym__type_or_implicit] = STATE(16993),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17730),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3674),
    [anon_sym_DASH_GT] = ACTIONS(3674),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1422),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3676),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3678),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1175] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20419),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20443),
    [sym_qualified_constructor_operator] = STATE(20443),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20443),
    [sym_qualified_type_operator] = STATE(20443),
    [sym__qualified_type_operator] = STATE(20443),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6819),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19400),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17136),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17136),
    [sym__type_context] = STATE(17136),
    [sym__type_fun] = STATE(17136),
    [sym__type] = STATE(17136),
    [sym__type_or_implicit] = STATE(17136),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16523),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3680),
    [anon_sym_DASH_GT] = ACTIONS(3680),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(313),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3682),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3684),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1176] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13758),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1306),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1177] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20403),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3686),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1178] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13414),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1179] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20653),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20656),
    [sym_qualified_constructor_operator] = STATE(20656),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20656),
    [sym_qualified_type_operator] = STATE(20656),
    [sym__qualified_type_operator] = STATE(20656),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6795),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20657),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15527),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15527),
    [sym__type_context] = STATE(15527),
    [sym__type_fun] = STATE(15527),
    [sym__type] = STATE(15527),
    [sym__type_or_implicit] = STATE(15527),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16791),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3688),
    [anon_sym_DASH_GT] = ACTIONS(3688),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(243),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3690),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3692),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1180] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19312),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19316),
    [sym_qualified_constructor_operator] = STATE(19316),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19316),
    [sym_qualified_type_operator] = STATE(19316),
    [sym__qualified_type_operator] = STATE(19316),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6890),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19317),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17087),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17087),
    [sym__type_context] = STATE(17087),
    [sym__type_fun] = STATE(17087),
    [sym__type] = STATE(17087),
    [sym__type_or_implicit] = STATE(17087),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17761),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1994),
    [anon_sym_DASH_GT] = ACTIONS(1994),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3694),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(1996),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2260),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1181] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18995),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3696),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1182] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19003),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3698),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1183] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19506),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3700),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1184] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19183),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3702),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1185] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20759),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20762),
    [sym_qualified_constructor_operator] = STATE(20762),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20762),
    [sym_qualified_type_operator] = STATE(20762),
    [sym__qualified_type_operator] = STATE(20762),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7036),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20566),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17610),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17610),
    [sym__type_context] = STATE(17610),
    [sym__type_fun] = STATE(17610),
    [sym__type] = STATE(17610),
    [sym__type_or_implicit] = STATE(17610),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17520),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3704),
    [anon_sym_DASH_GT] = ACTIONS(3704),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1594),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3706),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3708),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1186] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20211),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3710),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1187] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20212),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3712),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1188] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19130),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3714),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1189] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19129),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3716),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1190] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19027),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19026),
    [sym_qualified_constructor_operator] = STATE(19026),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19026),
    [sym_qualified_type_operator] = STATE(19026),
    [sym__qualified_type_operator] = STATE(19026),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6869),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19024),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16803),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16803),
    [sym__type_context] = STATE(16803),
    [sym__type_fun] = STATE(16803),
    [sym__type] = STATE(16803),
    [sym__type_or_implicit] = STATE(16803),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17668),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2346),
    [anon_sym_DASH_GT] = ACTIONS(2346),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3718),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2348),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2459),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1191] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20744),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20742),
    [sym_qualified_constructor_operator] = STATE(20742),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20742),
    [sym_qualified_type_operator] = STATE(20742),
    [sym__qualified_type_operator] = STATE(20742),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6909),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20739),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15478),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15478),
    [sym__type_context] = STATE(15478),
    [sym__type_fun] = STATE(15478),
    [sym__type] = STATE(15478),
    [sym__type_or_implicit] = STATE(15478),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15645),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3720),
    [anon_sym_DASH_GT] = ACTIONS(3720),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1550),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3722),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3724),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1192] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19110),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3726),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1193] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19095),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3728),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1194] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19089),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3730),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1195] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19879),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3732),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1196] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19660),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3734),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1197] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19265),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19258),
    [sym_qualified_constructor_operator] = STATE(19258),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19258),
    [sym_qualified_type_operator] = STATE(19258),
    [sym__qualified_type_operator] = STATE(19258),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6852),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19257),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16613),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16613),
    [sym__type_context] = STATE(16613),
    [sym__type_fun] = STATE(16613),
    [sym__type] = STATE(16613),
    [sym__type_or_implicit] = STATE(16613),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17606),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2496),
    [anon_sym_DASH_GT] = ACTIONS(2496),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3736),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2502),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1198] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13857),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3738),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1199] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19667),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3740),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1200] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20247),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3742),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1201] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20251),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3744),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1202] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20654),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20554),
    [sym_qualified_constructor_operator] = STATE(20554),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20554),
    [sym_qualified_type_operator] = STATE(20554),
    [sym__qualified_type_operator] = STATE(20554),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7020),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20343),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17548),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17548),
    [sym__type_context] = STATE(17548),
    [sym__type_fun] = STATE(17548),
    [sym__type] = STATE(17548),
    [sym__type_or_implicit] = STATE(17548),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17563),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3746),
    [anon_sym_DASH_GT] = ACTIONS(3746),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3748),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3750),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3752),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1203] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19144),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19158),
    [sym_qualified_constructor_operator] = STATE(19158),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19158),
    [sym_qualified_type_operator] = STATE(19158),
    [sym__qualified_type_operator] = STATE(19158),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6806),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18971),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16859),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16859),
    [sym__type_context] = STATE(16859),
    [sym__type_fun] = STATE(16859),
    [sym__type] = STATE(16859),
    [sym__type_or_implicit] = STATE(16859),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15746),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3754),
    [anon_sym_DASH_GT] = ACTIONS(3754),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3756),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(511),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1204] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13410),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3758),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1205] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19123),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19119),
    [sym_qualified_constructor_operator] = STATE(19119),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19119),
    [sym_qualified_type_operator] = STATE(19119),
    [sym__qualified_type_operator] = STATE(19119),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6957),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19115),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16992),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16992),
    [sym__type_context] = STATE(16992),
    [sym__type_fun] = STATE(16992),
    [sym__type] = STATE(16992),
    [sym__type_or_implicit] = STATE(16992),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16564),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2262),
    [anon_sym_DASH_GT] = ACTIONS(2262),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3760),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2268),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1206] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19779),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3762),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1207] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19449),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19351),
    [sym_qualified_constructor_operator] = STATE(19351),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19351),
    [sym_qualified_type_operator] = STATE(19351),
    [sym__qualified_type_operator] = STATE(19351),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6927),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19458),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17172),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17172),
    [sym__type_context] = STATE(17172),
    [sym__type_fun] = STATE(17172),
    [sym__type] = STATE(17172),
    [sym__type_or_implicit] = STATE(17172),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17804),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3764),
    [anon_sym_DASH_GT] = ACTIONS(3764),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1502),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3766),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3768),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1208] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20198),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20199),
    [sym_qualified_constructor_operator] = STATE(20199),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20199),
    [sym_qualified_type_operator] = STATE(20199),
    [sym__qualified_type_operator] = STATE(20199),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7000),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20200),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17486),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17486),
    [sym__type_context] = STATE(17486),
    [sym__type_fun] = STATE(17486),
    [sym__type] = STATE(17486),
    [sym__type_or_implicit] = STATE(17486),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17608),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3770),
    [anon_sym_DASH_GT] = ACTIONS(3770),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(357),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3772),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3774),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1209] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20686),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3776),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1210] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20687),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3778),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1211] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19039),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19040),
    [sym_qualified_constructor_operator] = STATE(19040),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19040),
    [sym_qualified_type_operator] = STATE(19040),
    [sym__qualified_type_operator] = STATE(19040),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6920),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19041),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16788),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16788),
    [sym__type_context] = STATE(16788),
    [sym__type_fun] = STATE(16788),
    [sym__type] = STATE(16788),
    [sym__type_or_implicit] = STATE(16788),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16483),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3780),
    [anon_sym_DASH_GT] = ACTIONS(3780),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1526),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3782),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3784),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1212] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13801),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3786),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1213] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13874),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1330),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1214] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19782),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3788),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1215] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20033),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20043),
    [sym_qualified_constructor_operator] = STATE(20043),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20043),
    [sym_qualified_type_operator] = STATE(20043),
    [sym__qualified_type_operator] = STATE(20043),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6962),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20048),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17424),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17424),
    [sym__type_context] = STATE(17424),
    [sym__type_fun] = STATE(17424),
    [sym__type] = STATE(17424),
    [sym__type_or_implicit] = STATE(17424),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17652),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3790),
    [anon_sym_DASH_GT] = ACTIONS(3790),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3794),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1216] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20434),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3796),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1217] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20979),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3798),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1218] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19009),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3800),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1219] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20439),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3802),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1220] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19839),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19972),
    [sym_qualified_constructor_operator] = STATE(19972),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19972),
    [sym_qualified_type_operator] = STATE(19972),
    [sym__qualified_type_operator] = STATE(19972),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6952),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19975),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17393),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17393),
    [sym__type_context] = STATE(17393),
    [sym__type_fun] = STATE(17393),
    [sym__type] = STATE(17393),
    [sym__type_or_implicit] = STATE(17393),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17677),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3804),
    [anon_sym_DASH_GT] = ACTIONS(3804),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1510),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3806),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3808),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1221] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19008),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3810),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1222] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13858),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1358),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1223] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19097),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19098),
    [sym_qualified_constructor_operator] = STATE(19098),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19098),
    [sym_qualified_type_operator] = STATE(19098),
    [sym__qualified_type_operator] = STATE(19098),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6884),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19099),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16750),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16750),
    [sym__type_context] = STATE(16750),
    [sym__type_fun] = STATE(16750),
    [sym__type] = STATE(16750),
    [sym__type_or_implicit] = STATE(16750),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16455),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3812),
    [anon_sym_DASH_GT] = ACTIONS(3812),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3814),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3816),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3818),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1224] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13875),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3820),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1225] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19884),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19886),
    [sym_qualified_constructor_operator] = STATE(19886),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19886),
    [sym_qualified_type_operator] = STATE(19886),
    [sym__qualified_type_operator] = STATE(19886),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6919),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19887),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17362),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17362),
    [sym__type_context] = STATE(17362),
    [sym__type_fun] = STATE(17362),
    [sym__type] = STATE(17362),
    [sym__type_or_implicit] = STATE(17362),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17697),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3822),
    [anon_sym_DASH_GT] = ACTIONS(3822),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1554),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3826),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1226] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13557),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1280),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1227] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19126),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19127),
    [sym_qualified_constructor_operator] = STATE(19127),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19127),
    [sym_qualified_type_operator] = STATE(19127),
    [sym__qualified_type_operator] = STATE(19127),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6829),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19128),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16727),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16727),
    [sym__type_context] = STATE(16727),
    [sym__type_fun] = STATE(16727),
    [sym__type] = STATE(16727),
    [sym__type_or_implicit] = STATE(16727),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16444),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3828),
    [anon_sym_DASH_GT] = ACTIONS(3828),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3830),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3834),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1228] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19965),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19964),
    [sym_qualified_constructor_operator] = STATE(19964),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19964),
    [sym_qualified_type_operator] = STATE(19964),
    [sym__qualified_type_operator] = STATE(19964),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6827),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19959),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16043),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16043),
    [sym__type_context] = STATE(16043),
    [sym__type_fun] = STATE(16043),
    [sym__type] = STATE(16043),
    [sym__type_or_implicit] = STATE(16043),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17327),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3836),
    [anon_sym_DASH_GT] = ACTIONS(3836),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(305),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3838),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3840),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1229] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20593),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20478),
    [sym_qualified_constructor_operator] = STATE(20478),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20478),
    [sym_qualified_type_operator] = STATE(20478),
    [sym__qualified_type_operator] = STATE(20478),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6815),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20951),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17763),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17763),
    [sym__type_context] = STATE(17763),
    [sym__type_fun] = STATE(17763),
    [sym__type] = STATE(17763),
    [sym__type_or_implicit] = STATE(17763),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15539),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3842),
    [anon_sym_DASH_GT] = ACTIONS(3842),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(365),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3844),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3846),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1230] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13699),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1231] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18985),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3848),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1232] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19906),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19905),
    [sym_qualified_constructor_operator] = STATE(19905),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19905),
    [sym_qualified_type_operator] = STATE(19905),
    [sym__qualified_type_operator] = STATE(19905),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6878),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20148),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15907),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15907),
    [sym__type_context] = STATE(15907),
    [sym__type_fun] = STATE(15907),
    [sym__type] = STATE(15907),
    [sym__type_or_implicit] = STATE(15907),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16824),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3850),
    [anon_sym_DASH_GT] = ACTIONS(3850),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(321),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3852),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3854),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1233] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(18956),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18957),
    [sym_qualified_constructor_operator] = STATE(18957),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18957),
    [sym_qualified_type_operator] = STATE(18957),
    [sym__qualified_type_operator] = STATE(18957),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6938),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18958),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16877),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16877),
    [sym__type_context] = STATE(16877),
    [sym__type_fun] = STATE(16877),
    [sym__type] = STATE(16877),
    [sym__type_or_implicit] = STATE(16877),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16509),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2480),
    [anon_sym_DASH_GT] = ACTIONS(2480),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3856),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2486),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1234] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19537),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3858),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1235] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19555),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3860),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1236] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(18981),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18982),
    [sym_qualified_constructor_operator] = STATE(18982),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18982),
    [sym_qualified_type_operator] = STATE(18982),
    [sym__qualified_type_operator] = STATE(18982),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6999),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18983),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16849),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16849),
    [sym__type_context] = STATE(16849),
    [sym__type_fun] = STATE(16849),
    [sym__type] = STATE(16849),
    [sym__type_or_implicit] = STATE(16849),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16501),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2515),
    [anon_sym_DASH_GT] = ACTIONS(2515),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3862),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2519),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2521),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1237] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18984),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3864),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1238] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19010),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19011),
    [sym_qualified_constructor_operator] = STATE(19011),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19011),
    [sym_qualified_type_operator] = STATE(19011),
    [sym__qualified_type_operator] = STATE(19011),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6981),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19012),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16817),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16817),
    [sym__type_context] = STATE(16817),
    [sym__type_fun] = STATE(16817),
    [sym__type] = STATE(16817),
    [sym__type_or_implicit] = STATE(16817),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16492),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2399),
    [anon_sym_DASH_GT] = ACTIONS(2399),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3866),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2403),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2405),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1239] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19068),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19069),
    [sym_qualified_constructor_operator] = STATE(19069),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19069),
    [sym_qualified_type_operator] = STATE(19069),
    [sym__qualified_type_operator] = STATE(19069),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6904),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19070),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16773),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16773),
    [sym__type_context] = STATE(16773),
    [sym__type_fun] = STATE(16773),
    [sym__type] = STATE(16773),
    [sym__type_or_implicit] = STATE(16773),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16468),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2297),
    [anon_sym_DASH_GT] = ACTIONS(2297),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3868),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2301),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2303),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1240] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20006),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3870),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1241] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20016),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3872),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1242] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18908),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3874),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1243] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20160),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3876),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1244] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19521),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3878),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1245] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19701),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3880),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1246] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19155),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19156),
    [sym_qualified_constructor_operator] = STATE(19156),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19156),
    [sym_qualified_type_operator] = STATE(19156),
    [sym__qualified_type_operator] = STATE(19156),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6921),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19157),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16703),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16703),
    [sym__type_context] = STATE(16703),
    [sym__type_fun] = STATE(16703),
    [sym__type] = STATE(16703),
    [sym__type_or_implicit] = STATE(16703),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16433),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3882),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2220),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1247] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19702),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3884),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1248] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20172),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3886),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1249] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13915),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3888),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1250] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19184),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19185),
    [sym_qualified_constructor_operator] = STATE(19185),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19185),
    [sym_qualified_type_operator] = STATE(19185),
    [sym__qualified_type_operator] = STATE(19185),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6837),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19186),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16678),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16678),
    [sym__type_context] = STATE(16678),
    [sym__type_fun] = STATE(16678),
    [sym__type] = STATE(16678),
    [sym__type_or_implicit] = STATE(16678),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16421),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2024),
    [anon_sym_DASH_GT] = ACTIONS(2024),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3890),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2030),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1251] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20483),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20481),
    [sym_qualified_constructor_operator] = STATE(20481),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20481),
    [sym_qualified_type_operator] = STATE(20481),
    [sym__qualified_type_operator] = STATE(20481),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7014),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19269),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16610),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16610),
    [sym__type_context] = STATE(16610),
    [sym__type_fun] = STATE(16610),
    [sym__type] = STATE(16610),
    [sym__type_or_implicit] = STATE(16610),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17120),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3892),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2248),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1252] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19212),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19213),
    [sym_qualified_constructor_operator] = STATE(19213),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19213),
    [sym_qualified_type_operator] = STATE(19213),
    [sym__qualified_type_operator] = STATE(19213),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6840),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19214),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16651),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16651),
    [sym__type_context] = STATE(16651),
    [sym__type_fun] = STATE(16651),
    [sym__type] = STATE(16651),
    [sym__type_or_implicit] = STATE(16651),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16413),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2032),
    [anon_sym_DASH_GT] = ACTIONS(2032),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3894),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2036),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2038),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1253] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19732),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19737),
    [sym_qualified_constructor_operator] = STATE(19737),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19737),
    [sym_qualified_type_operator] = STATE(19737),
    [sym__qualified_type_operator] = STATE(19737),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6913),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19741),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17300),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17300),
    [sym__type_context] = STATE(17300),
    [sym__type_fun] = STATE(17300),
    [sym__type] = STATE(17300),
    [sym__type_or_implicit] = STATE(17300),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17737),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3896),
    [anon_sym_DASH_GT] = ACTIONS(3896),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3898),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3900),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1254] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19485),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3902),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1255] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19484),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3904),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1256] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20973),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3906),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1257] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13828),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3908),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1258] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20483),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20481),
    [sym_qualified_constructor_operator] = STATE(20481),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20481),
    [sym_qualified_type_operator] = STATE(20481),
    [sym__qualified_type_operator] = STATE(20481),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7014),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15661),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2242),
    [anon_sym_DASH_GT] = ACTIONS(2242),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2246),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1259] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13479),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3910),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1260] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19325),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19303),
    [sym_qualified_constructor_operator] = STATE(19303),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19303),
    [sym_qualified_type_operator] = STATE(19303),
    [sym__qualified_type_operator] = STATE(19303),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6811),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19836),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17333),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17333),
    [sym__type_context] = STATE(17333),
    [sym__type_fun] = STATE(17333),
    [sym__type] = STATE(17333),
    [sym__type_or_implicit] = STATE(17333),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15556),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2154),
    [anon_sym_DASH_GT] = ACTIONS(2154),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3912),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2158),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2160),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1261] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20949),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20950),
    [sym_qualified_constructor_operator] = STATE(20950),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20950),
    [sym_qualified_type_operator] = STATE(20950),
    [sym__qualified_type_operator] = STATE(20950),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6816),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20502),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17629),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17629),
    [sym__type_context] = STATE(17629),
    [sym__type_fun] = STATE(17629),
    [sym__type] = STATE(17629),
    [sym__type_or_implicit] = STATE(17629),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15938),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2072),
    [anon_sym_DASH_GT] = ACTIONS(2072),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3914),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2076),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2078),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1262] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20479),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20417),
    [sym_qualified_constructor_operator] = STATE(20417),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20417),
    [sym_qualified_type_operator] = STATE(20417),
    [sym__qualified_type_operator] = STATE(20417),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6824),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15661),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15661),
    [sym__type_context] = STATE(15661),
    [sym__type_fun] = STATE(15661),
    [sym__type] = STATE(15661),
    [sym__type_or_implicit] = STATE(15661),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(1781),
    [anon_sym_DASH_GT] = ACTIONS(1781),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1263] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19846),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19842),
    [sym_qualified_constructor_operator] = STATE(19842),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19842),
    [sym_qualified_type_operator] = STATE(19842),
    [sym__qualified_type_operator] = STATE(19842),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6812),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20569),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17599),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17599),
    [sym__type_context] = STATE(17599),
    [sym__type_fun] = STATE(17599),
    [sym__type] = STATE(17599),
    [sym__type_or_implicit] = STATE(17599),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15466),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3916),
    [anon_sym_DASH_GT] = ACTIONS(3916),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(289),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3918),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3920),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1264] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20107),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20105),
    [sym_qualified_constructor_operator] = STATE(20105),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20105),
    [sym_qualified_type_operator] = STATE(20105),
    [sym__qualified_type_operator] = STATE(20105),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6826),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20098),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15948),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15948),
    [sym__type_context] = STATE(15948),
    [sym__type_fun] = STATE(15948),
    [sym__type] = STATE(15948),
    [sym__type_or_implicit] = STATE(15948),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17296),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2234),
    [anon_sym_DASH_GT] = ACTIONS(2234),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3922),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2238),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2240),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1265] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18925),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3924),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1266] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18923),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3926),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1267] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13405),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1268] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13834),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3930),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1269] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13976),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1270] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20891),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3932),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1271] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19547),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3934),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1272] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20692),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3936),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1273] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20794),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3938),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1274] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20800),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3940),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1275] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19552),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3942),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1276] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20155),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3944),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1277] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20373),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3946),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1278] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20372),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3948),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1279] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19374),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3950),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1280] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19368),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3952),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1281] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20157),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3954),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1282] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20710),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3956),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1283] = {
    [sym_integer] = STATE(4913),
    [sym__literal] = STATE(4913),
    [sym__unboxed_open] = STATE(747),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4400),
    [sym_qualified_constructor] = STATE(5105),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(4913),
    [sym_con_list] = STATE(4913),
    [sym_con_tuple] = STATE(4913),
    [sym_literal] = STATE(5786),
    [sym_exp_parens] = STATE(5786),
    [sym_exp_tuple] = STATE(5786),
    [sym_exp_unboxed_tuple] = STATE(5786),
    [sym_exp_unboxed_sum] = STATE(5786),
    [sym_exp_list] = STATE(5786),
    [sym_exp_arithmetic_sequence] = STATE(5786),
    [sym_exp_list_comprehension] = STATE(5786),
    [sym_exp_section_left] = STATE(5786),
    [sym_exp_section_right] = STATE(5786),
    [sym_exp_th_quoted_name] = STATE(5786),
    [sym_exp_type_application] = STATE(1303),
    [sym_exp_lambda] = STATE(12648),
    [sym_exp_let] = STATE(18321),
    [sym_exp_let_in] = STATE(12648),
    [sym_exp_cond] = STATE(12648),
    [sym_exp_case] = STATE(12648),
    [sym_exp_lambda_case] = STATE(1303),
    [sym__do_keyword] = STATE(18454),
    [sym_do_module] = STATE(18454),
    [sym_exp_do] = STATE(1303),
    [sym_exp_record] = STATE(5786),
    [sym_exp_name] = STATE(5786),
    [sym_exp_projection_selector] = STATE(5786),
    [sym__aexp_projection] = STATE(5786),
    [sym_exp_projection] = STATE(5786),
    [sym__aexp] = STATE(1303),
    [sym__exp_apply] = STATE(12648),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12665),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym__varid] = ACTIONS(3041),
    [sym_float] = ACTIONS(1362),
    [sym_char] = ACTIONS(1362),
    [sym_string] = ACTIONS(1362),
    [sym__integer_literal] = ACTIONS(1364),
    [sym__binary_literal] = ACTIONS(1366),
    [sym__octal_literal] = ACTIONS(1366),
    [sym__hex_literal] = ACTIONS(1366),
    [anon_sym_LPAREN_POUND] = ACTIONS(3043),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3043),
    [anon_sym_4] = ACTIONS(1667),
    [anon_sym_COLON_COLON] = ACTIONS(1667),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(1667),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_implicit_parid] = ACTIONS(3045),
    [sym__conid] = ACTIONS(3958),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3057),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_BSLASH] = ACTIONS(3061),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3964),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_mdo] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_7] = ACTIONS(1380),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1382),
    [sym__varsym] = ACTIONS(1667),
    [sym__consym] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1667),
    [sym_quasiquote_start] = ACTIONS(1384),
    [sym__unboxed_close] = ACTIONS(1667),
  },
  [1284] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20708),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3966),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1285] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20669),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3968),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1286] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20349),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20348),
    [sym_qualified_constructor_operator] = STATE(20348),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20348),
    [sym_qualified_type_operator] = STATE(20348),
    [sym__qualified_type_operator] = STATE(20348),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6813),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20346),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15758),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15758),
    [sym__type_context] = STATE(15758),
    [sym__type_fun] = STATE(15758),
    [sym__type] = STATE(15758),
    [sym__type_or_implicit] = STATE(15758),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17234),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2250),
    [anon_sym_DASH_GT] = ACTIONS(2250),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3970),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2256),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1287] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19327),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3972),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1288] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19343),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3974),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1289] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20551),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3976),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1290] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19148),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3978),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1291] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20356),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3980),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1292] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20668),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3982),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1293] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19852),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3984),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1294] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13867),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3986),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1295] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19853),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(3988),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1296] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13950),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(3990),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1297] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(18968),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18970),
    [sym_qualified_constructor_operator] = STATE(18970),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18970),
    [sym_qualified_type_operator] = STATE(18970),
    [sym__qualified_type_operator] = STATE(18970),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6810),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19280),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17059),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17059),
    [sym__type_context] = STATE(17059),
    [sym__type_fun] = STATE(17059),
    [sym__type] = STATE(17059),
    [sym__type_or_implicit] = STATE(17059),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15651),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(3992),
    [anon_sym_DASH_GT] = ACTIONS(3992),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3994),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(3996),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3998),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1298] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18911),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4000),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1299] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20242),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20239),
    [sym_qualified_constructor_operator] = STATE(20239),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20239),
    [sym_qualified_type_operator] = STATE(20239),
    [sym__qualified_type_operator] = STATE(20239),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6814),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20238),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15853),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15853),
    [sym__type_context] = STATE(15853),
    [sym__type_fun] = STATE(15853),
    [sym__type] = STATE(15853),
    [sym__type_or_implicit] = STATE(15853),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17265),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2040),
    [anon_sym_DASH_GT] = ACTIONS(2040),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(4002),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2044),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2046),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1300] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18978),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4004),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1301] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13969),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(1334),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1302] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(19568),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19567),
    [sym_qualified_constructor_operator] = STATE(19567),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19567),
    [sym_qualified_type_operator] = STATE(19567),
    [sym__qualified_type_operator] = STATE(19567),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6828),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19804),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16183),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16183),
    [sym__type_context] = STATE(16183),
    [sym__type_fun] = STATE(16183),
    [sym__type] = STATE(16183),
    [sym__type_or_implicit] = STATE(16183),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17542),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(2162),
    [anon_sym_DASH_GT] = ACTIONS(2162),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(4006),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2168),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1303] = {
    [sym_integer] = STATE(4913),
    [sym__literal] = STATE(4913),
    [sym__unboxed_open] = STATE(747),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4400),
    [sym_qualified_constructor] = STATE(5105),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(4913),
    [sym_con_list] = STATE(4913),
    [sym_con_tuple] = STATE(4913),
    [sym_literal] = STATE(5786),
    [sym_exp_parens] = STATE(5786),
    [sym_exp_tuple] = STATE(5786),
    [sym_exp_unboxed_tuple] = STATE(5786),
    [sym_exp_unboxed_sum] = STATE(5786),
    [sym_exp_list] = STATE(5786),
    [sym_exp_arithmetic_sequence] = STATE(5786),
    [sym_exp_list_comprehension] = STATE(5786),
    [sym_exp_section_left] = STATE(5786),
    [sym_exp_section_right] = STATE(5786),
    [sym_exp_th_quoted_name] = STATE(5786),
    [sym_exp_type_application] = STATE(1303),
    [sym_exp_lambda] = STATE(12648),
    [sym_exp_let] = STATE(18321),
    [sym_exp_let_in] = STATE(12648),
    [sym_exp_cond] = STATE(12648),
    [sym_exp_case] = STATE(12648),
    [sym_exp_lambda_case] = STATE(1303),
    [sym__do_keyword] = STATE(18454),
    [sym_do_module] = STATE(18454),
    [sym_exp_do] = STATE(1303),
    [sym_exp_record] = STATE(5786),
    [sym_exp_name] = STATE(5786),
    [sym_exp_projection_selector] = STATE(5786),
    [sym__aexp_projection] = STATE(5786),
    [sym_exp_projection] = STATE(5786),
    [sym__aexp] = STATE(1303),
    [sym__exp_apply] = STATE(12648),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12665),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym__varid] = ACTIONS(3041),
    [sym_float] = ACTIONS(1362),
    [sym_char] = ACTIONS(1362),
    [sym_string] = ACTIONS(1362),
    [sym__integer_literal] = ACTIONS(1364),
    [sym__binary_literal] = ACTIONS(1366),
    [sym__octal_literal] = ACTIONS(1366),
    [sym__hex_literal] = ACTIONS(1366),
    [anon_sym_LPAREN_POUND] = ACTIONS(3043),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3043),
    [anon_sym_4] = ACTIONS(1636),
    [anon_sym_COLON_COLON] = ACTIONS(1636),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(1636),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [anon_sym_BQUOTE] = ACTIONS(1636),
    [sym_implicit_parid] = ACTIONS(3045),
    [sym__conid] = ACTIONS(4008),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3057),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_BSLASH] = ACTIONS(3061),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3964),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_mdo] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_7] = ACTIONS(1380),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1382),
    [sym__varsym] = ACTIONS(1636),
    [sym__consym] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1636),
    [sym_quasiquote_start] = ACTIONS(1384),
    [sym__unboxed_close] = ACTIONS(1636),
  },
  [1304] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym__arrow] = STATE(20761),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20758),
    [sym_qualified_constructor_operator] = STATE(20758),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20758),
    [sym_qualified_type_operator] = STATE(20758),
    [sym__qualified_type_operator] = STATE(20758),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(6797),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20755),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15476),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15476),
    [sym__type_context] = STATE(15476),
    [sym__type_fun] = STATE(15476),
    [sym__type] = STATE(15476),
    [sym__type_or_implicit] = STATE(15476),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16981),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [anon_sym_2] = ACTIONS(4011),
    [anon_sym_DASH_GT] = ACTIONS(4011),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1486),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4013),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4015),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1305] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13432),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(4017),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1306] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20577),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4019),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1307] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20575),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4021),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1308] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20550),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4023),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1309] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20549),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4025),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1310] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19877),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4027),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1311] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20972),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4029),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1312] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8327),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8327),
    [sym_exp_cond] = STATE(8327),
    [sym_exp_if_guard] = STATE(8327),
    [sym_exp_case] = STATE(8327),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8327),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8327),
    [sym__lexp] = STATE(8327),
    [sym_exp_infix] = STATE(8327),
    [sym__exp_infix] = STATE(8327),
    [sym__exp] = STATE(13853),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_RBRACK] = ACTIONS(4031),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1313] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20975),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4033),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1314] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20924),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4035),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1315] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20923),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4037),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1316] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19152),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4039),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1317] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19219),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4041),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1318] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19201),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_RBRACK] = ACTIONS(4043),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1319] = {
    [sym_integer] = STATE(4866),
    [sym__literal] = STATE(4866),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = STATE(5079),
    [sym_qualified_variable] = STATE(5079),
    [sym_constructor] = STATE(4498),
    [sym_qualified_constructor] = STATE(5373),
    [sym__qcon] = STATE(5079),
    [sym_con_unit] = STATE(4866),
    [sym_con_list] = STATE(4866),
    [sym_con_tuple] = STATE(4866),
    [sym_literal] = STATE(5194),
    [sym_exp_parens] = STATE(5194),
    [sym_exp_tuple] = STATE(5194),
    [sym_exp_unboxed_tuple] = STATE(5194),
    [sym_exp_unboxed_sum] = STATE(5194),
    [sym_exp_list] = STATE(5194),
    [sym_exp_arithmetic_sequence] = STATE(5194),
    [sym_exp_list_comprehension] = STATE(5194),
    [sym_exp_section_left] = STATE(5194),
    [sym_exp_section_right] = STATE(5194),
    [sym_exp_th_quoted_name] = STATE(5194),
    [sym_exp_type_application] = STATE(924),
    [sym_exp_lambda] = STATE(9206),
    [sym_exp_let] = STATE(18498),
    [sym_exp_let_in] = STATE(9206),
    [sym_exp_cond] = STATE(9206),
    [sym_exp_if_guard] = STATE(9206),
    [sym_exp_case] = STATE(9206),
    [sym_exp_lambda_case] = STATE(924),
    [sym__do_keyword] = STATE(18413),
    [sym_do_module] = STATE(18413),
    [sym_exp_do] = STATE(924),
    [sym_exp_negation] = STATE(9206),
    [sym_exp_record] = STATE(5194),
    [sym_exp_name] = STATE(5194),
    [sym_exp_projection_selector] = STATE(5194),
    [sym__aexp_projection] = STATE(5194),
    [sym_exp_projection] = STATE(5194),
    [sym__aexp] = STATE(924),
    [sym__exp_apply] = STATE(12053),
    [sym__fexp] = STATE(9206),
    [sym__lexp] = STATE(9206),
    [sym_exp_infix] = STATE(9206),
    [sym__exp_infix] = STATE(9206),
    [sym__exp] = STATE(12159),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12556),
    [sym_splice] = STATE(5194),
    [sym_quasiquote] = STATE(5194),
    [sym__varid] = ACTIONS(2560),
    [sym_float] = ACTIONS(2562),
    [sym_char] = ACTIONS(2562),
    [sym_string] = ACTIONS(2562),
    [sym__integer_literal] = ACTIONS(2564),
    [sym__binary_literal] = ACTIONS(2566),
    [sym__octal_literal] = ACTIONS(2566),
    [sym__hex_literal] = ACTIONS(2566),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4047),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2583),
    [anon_sym_AT] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4049),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_7] = ACTIONS(2595),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2599),
  },
  [1320] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9922),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9922),
    [sym_exp_cond] = STATE(9922),
    [sym_exp_if_guard] = STATE(9922),
    [sym_exp_case] = STATE(9922),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9922),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9922),
    [sym__lexp] = STATE(9922),
    [sym_exp_infix] = STATE(9922),
    [sym__exp_infix] = STATE(9922),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4051),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1321] = {
    [sym_integer] = STATE(4830),
    [sym__literal] = STATE(4830),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = STATE(4419),
    [sym_qualified_variable] = STATE(4419),
    [sym_constructor] = STATE(4257),
    [sym_qualified_constructor] = STATE(4416),
    [sym__qcon] = STATE(4419),
    [sym_con_unit] = STATE(4830),
    [sym_con_list] = STATE(4830),
    [sym_con_tuple] = STATE(4830),
    [sym_literal] = STATE(4455),
    [sym_exp_parens] = STATE(4455),
    [sym_exp_tuple] = STATE(4455),
    [sym_exp_unboxed_tuple] = STATE(4455),
    [sym_exp_unboxed_sum] = STATE(4455),
    [sym_exp_list] = STATE(4455),
    [sym_exp_arithmetic_sequence] = STATE(4455),
    [sym_exp_list_comprehension] = STATE(4455),
    [sym_exp_section_left] = STATE(4455),
    [sym_exp_section_right] = STATE(4455),
    [sym_exp_th_quoted_name] = STATE(4455),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(8786),
    [sym_exp_let] = STATE(18318),
    [sym_exp_let_in] = STATE(8786),
    [sym_exp_cond] = STATE(8786),
    [sym_exp_if_guard] = STATE(8786),
    [sym_exp_case] = STATE(8786),
    [sym_exp_lambda_case] = STATE(828),
    [sym__do_keyword] = STATE(18263),
    [sym_do_module] = STATE(18263),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(8786),
    [sym_exp_record] = STATE(4455),
    [sym_exp_name] = STATE(4455),
    [sym_exp_projection_selector] = STATE(4455),
    [sym__aexp_projection] = STATE(4455),
    [sym_exp_projection] = STATE(4455),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(11903),
    [sym__fexp] = STATE(8786),
    [sym__lexp] = STATE(8786),
    [sym_exp_infix] = STATE(8786),
    [sym__exp_infix] = STATE(8786),
    [sym__exp] = STATE(11668),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12635),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(2080),
    [sym_float] = ACTIONS(2082),
    [sym_char] = ACTIONS(2082),
    [sym_string] = ACTIONS(2082),
    [sym__integer_literal] = ACTIONS(2084),
    [sym__binary_literal] = ACTIONS(2086),
    [sym__octal_literal] = ACTIONS(2086),
    [sym__hex_literal] = ACTIONS(2086),
    [anon_sym_LPAREN_POUND] = ACTIONS(2088),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2088),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2090),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [sym_implicit_parid] = ACTIONS(2090),
    [sym__conid] = ACTIONS(4055),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_BSLASH] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4057),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_mdo] = ACTIONS(2114),
    [anon_sym_do] = ACTIONS(2114),
    [anon_sym_7] = ACTIONS(2116),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2120),
  },
  [1322] = {
    [sym_integer] = STATE(4830),
    [sym__literal] = STATE(4830),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = STATE(4419),
    [sym_qualified_variable] = STATE(4419),
    [sym_constructor] = STATE(4257),
    [sym_qualified_constructor] = STATE(4416),
    [sym__qcon] = STATE(4419),
    [sym_con_unit] = STATE(4830),
    [sym_con_list] = STATE(4830),
    [sym_con_tuple] = STATE(4830),
    [sym_literal] = STATE(4455),
    [sym_exp_parens] = STATE(4455),
    [sym_exp_tuple] = STATE(4455),
    [sym_exp_unboxed_tuple] = STATE(4455),
    [sym_exp_unboxed_sum] = STATE(4455),
    [sym_exp_list] = STATE(4455),
    [sym_exp_arithmetic_sequence] = STATE(4455),
    [sym_exp_list_comprehension] = STATE(4455),
    [sym_exp_section_left] = STATE(4455),
    [sym_exp_section_right] = STATE(4455),
    [sym_exp_th_quoted_name] = STATE(4455),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(8786),
    [sym_exp_let] = STATE(18318),
    [sym_exp_let_in] = STATE(8786),
    [sym_exp_cond] = STATE(8786),
    [sym_exp_if_guard] = STATE(8786),
    [sym_exp_case] = STATE(8786),
    [sym_exp_lambda_case] = STATE(828),
    [sym__do_keyword] = STATE(18263),
    [sym_do_module] = STATE(18263),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(8786),
    [sym_exp_record] = STATE(4455),
    [sym_exp_name] = STATE(4455),
    [sym_exp_projection_selector] = STATE(4455),
    [sym__aexp_projection] = STATE(4455),
    [sym_exp_projection] = STATE(4455),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(11903),
    [sym__fexp] = STATE(8786),
    [sym__lexp] = STATE(8786),
    [sym_exp_infix] = STATE(8786),
    [sym__exp_infix] = STATE(8786),
    [sym__exp] = STATE(11661),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12635),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(2080),
    [sym_float] = ACTIONS(2082),
    [sym_char] = ACTIONS(2082),
    [sym_string] = ACTIONS(2082),
    [sym__integer_literal] = ACTIONS(2084),
    [sym__binary_literal] = ACTIONS(2086),
    [sym__octal_literal] = ACTIONS(2086),
    [sym__hex_literal] = ACTIONS(2086),
    [anon_sym_LPAREN_POUND] = ACTIONS(2088),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2088),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2090),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [sym_implicit_parid] = ACTIONS(2090),
    [sym__conid] = ACTIONS(4055),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_BSLASH] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4057),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_mdo] = ACTIONS(2114),
    [anon_sym_do] = ACTIONS(2114),
    [anon_sym_7] = ACTIONS(2116),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2120),
  },
  [1323] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15060),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1324] = {
    [sym_integer] = STATE(4830),
    [sym__literal] = STATE(4830),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = STATE(4419),
    [sym_qualified_variable] = STATE(4419),
    [sym_constructor] = STATE(4257),
    [sym_qualified_constructor] = STATE(4416),
    [sym__qcon] = STATE(4419),
    [sym_con_unit] = STATE(4830),
    [sym_con_list] = STATE(4830),
    [sym_con_tuple] = STATE(4830),
    [sym_literal] = STATE(4455),
    [sym_exp_parens] = STATE(4455),
    [sym_exp_tuple] = STATE(4455),
    [sym_exp_unboxed_tuple] = STATE(4455),
    [sym_exp_unboxed_sum] = STATE(4455),
    [sym_exp_list] = STATE(4455),
    [sym_exp_arithmetic_sequence] = STATE(4455),
    [sym_exp_list_comprehension] = STATE(4455),
    [sym_exp_section_left] = STATE(4455),
    [sym_exp_section_right] = STATE(4455),
    [sym_exp_th_quoted_name] = STATE(4455),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(8786),
    [sym_exp_let] = STATE(18318),
    [sym_exp_let_in] = STATE(8786),
    [sym_exp_cond] = STATE(8786),
    [sym_exp_if_guard] = STATE(8786),
    [sym_exp_case] = STATE(8786),
    [sym_exp_lambda_case] = STATE(828),
    [sym__do_keyword] = STATE(18263),
    [sym_do_module] = STATE(18263),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(8786),
    [sym_exp_record] = STATE(4455),
    [sym_exp_name] = STATE(4455),
    [sym_exp_projection_selector] = STATE(4455),
    [sym__aexp_projection] = STATE(4455),
    [sym_exp_projection] = STATE(4455),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(11903),
    [sym__fexp] = STATE(8786),
    [sym__lexp] = STATE(8786),
    [sym_exp_infix] = STATE(8786),
    [sym__exp_infix] = STATE(8786),
    [sym__exp] = STATE(11660),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12635),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(2080),
    [sym_float] = ACTIONS(2082),
    [sym_char] = ACTIONS(2082),
    [sym_string] = ACTIONS(2082),
    [sym__integer_literal] = ACTIONS(2084),
    [sym__binary_literal] = ACTIONS(2086),
    [sym__octal_literal] = ACTIONS(2086),
    [sym__hex_literal] = ACTIONS(2086),
    [anon_sym_LPAREN_POUND] = ACTIONS(2088),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2088),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2090),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [sym_implicit_parid] = ACTIONS(2090),
    [sym__conid] = ACTIONS(4055),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_BSLASH] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4057),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_mdo] = ACTIONS(2114),
    [anon_sym_do] = ACTIONS(2114),
    [anon_sym_7] = ACTIONS(2116),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2120),
  },
  [1325] = {
    [sym_integer] = STATE(4830),
    [sym__literal] = STATE(4830),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = STATE(4419),
    [sym_qualified_variable] = STATE(4419),
    [sym_constructor] = STATE(4257),
    [sym_qualified_constructor] = STATE(4416),
    [sym__qcon] = STATE(4419),
    [sym_con_unit] = STATE(4830),
    [sym_con_list] = STATE(4830),
    [sym_con_tuple] = STATE(4830),
    [sym_literal] = STATE(4455),
    [sym_exp_parens] = STATE(4455),
    [sym_exp_tuple] = STATE(4455),
    [sym_exp_unboxed_tuple] = STATE(4455),
    [sym_exp_unboxed_sum] = STATE(4455),
    [sym_exp_list] = STATE(4455),
    [sym_exp_arithmetic_sequence] = STATE(4455),
    [sym_exp_list_comprehension] = STATE(4455),
    [sym_exp_section_left] = STATE(4455),
    [sym_exp_section_right] = STATE(4455),
    [sym_exp_th_quoted_name] = STATE(4455),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(8786),
    [sym_exp_let] = STATE(18318),
    [sym_exp_let_in] = STATE(8786),
    [sym_exp_cond] = STATE(8786),
    [sym_exp_if_guard] = STATE(8786),
    [sym_exp_case] = STATE(8786),
    [sym_exp_lambda_case] = STATE(828),
    [sym__do_keyword] = STATE(18263),
    [sym_do_module] = STATE(18263),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(8786),
    [sym_exp_record] = STATE(4455),
    [sym_exp_name] = STATE(4455),
    [sym_exp_projection_selector] = STATE(4455),
    [sym__aexp_projection] = STATE(4455),
    [sym_exp_projection] = STATE(4455),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(11903),
    [sym__fexp] = STATE(8786),
    [sym__lexp] = STATE(8786),
    [sym_exp_infix] = STATE(8786),
    [sym__exp_infix] = STATE(8786),
    [sym__exp] = STATE(11755),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12635),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(2080),
    [sym_float] = ACTIONS(2082),
    [sym_char] = ACTIONS(2082),
    [sym_string] = ACTIONS(2082),
    [sym__integer_literal] = ACTIONS(2084),
    [sym__binary_literal] = ACTIONS(2086),
    [sym__octal_literal] = ACTIONS(2086),
    [sym__hex_literal] = ACTIONS(2086),
    [anon_sym_LPAREN_POUND] = ACTIONS(2088),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2088),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2090),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [sym_implicit_parid] = ACTIONS(2090),
    [sym__conid] = ACTIONS(4055),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_BSLASH] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4057),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_mdo] = ACTIONS(2114),
    [anon_sym_do] = ACTIONS(2114),
    [anon_sym_7] = ACTIONS(2116),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2120),
  },
  [1326] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15069),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1327] = {
    [sym_integer] = STATE(4830),
    [sym__literal] = STATE(4830),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = STATE(4419),
    [sym_qualified_variable] = STATE(4419),
    [sym_constructor] = STATE(4257),
    [sym_qualified_constructor] = STATE(4416),
    [sym__qcon] = STATE(4419),
    [sym_con_unit] = STATE(4830),
    [sym_con_list] = STATE(4830),
    [sym_con_tuple] = STATE(4830),
    [sym_literal] = STATE(4455),
    [sym_exp_parens] = STATE(4455),
    [sym_exp_tuple] = STATE(4455),
    [sym_exp_unboxed_tuple] = STATE(4455),
    [sym_exp_unboxed_sum] = STATE(4455),
    [sym_exp_list] = STATE(4455),
    [sym_exp_arithmetic_sequence] = STATE(4455),
    [sym_exp_list_comprehension] = STATE(4455),
    [sym_exp_section_left] = STATE(4455),
    [sym_exp_section_right] = STATE(4455),
    [sym_exp_th_quoted_name] = STATE(4455),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(8786),
    [sym_exp_let] = STATE(18318),
    [sym_exp_let_in] = STATE(8786),
    [sym_exp_cond] = STATE(8786),
    [sym_exp_if_guard] = STATE(8786),
    [sym_exp_case] = STATE(8786),
    [sym_exp_lambda_case] = STATE(828),
    [sym__do_keyword] = STATE(18263),
    [sym_do_module] = STATE(18263),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(8786),
    [sym_exp_record] = STATE(4455),
    [sym_exp_name] = STATE(4455),
    [sym_exp_projection_selector] = STATE(4455),
    [sym__aexp_projection] = STATE(4455),
    [sym_exp_projection] = STATE(4455),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(11903),
    [sym__fexp] = STATE(8786),
    [sym__lexp] = STATE(8786),
    [sym_exp_infix] = STATE(8786),
    [sym__exp_infix] = STATE(8786),
    [sym__exp] = STATE(11659),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12635),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(2080),
    [sym_float] = ACTIONS(2082),
    [sym_char] = ACTIONS(2082),
    [sym_string] = ACTIONS(2082),
    [sym__integer_literal] = ACTIONS(2084),
    [sym__binary_literal] = ACTIONS(2086),
    [sym__octal_literal] = ACTIONS(2086),
    [sym__hex_literal] = ACTIONS(2086),
    [anon_sym_LPAREN_POUND] = ACTIONS(2088),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2088),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2090),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [sym_implicit_parid] = ACTIONS(2090),
    [sym__conid] = ACTIONS(4055),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_BSLASH] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4057),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_mdo] = ACTIONS(2114),
    [anon_sym_do] = ACTIONS(2114),
    [anon_sym_7] = ACTIONS(2116),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2120),
  },
  [1328] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9966),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9966),
    [sym_exp_cond] = STATE(9966),
    [sym_exp_if_guard] = STATE(9966),
    [sym_exp_case] = STATE(9966),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9966),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9966),
    [sym__lexp] = STATE(9966),
    [sym_exp_infix] = STATE(9966),
    [sym__exp_infix] = STATE(9966),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4065),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1329] = {
    [sym_integer] = STATE(4830),
    [sym__literal] = STATE(4830),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = STATE(4419),
    [sym_qualified_variable] = STATE(4419),
    [sym_constructor] = STATE(4257),
    [sym_qualified_constructor] = STATE(4416),
    [sym__qcon] = STATE(4419),
    [sym_con_unit] = STATE(4830),
    [sym_con_list] = STATE(4830),
    [sym_con_tuple] = STATE(4830),
    [sym_literal] = STATE(4455),
    [sym_exp_parens] = STATE(4455),
    [sym_exp_tuple] = STATE(4455),
    [sym_exp_unboxed_tuple] = STATE(4455),
    [sym_exp_unboxed_sum] = STATE(4455),
    [sym_exp_list] = STATE(4455),
    [sym_exp_arithmetic_sequence] = STATE(4455),
    [sym_exp_list_comprehension] = STATE(4455),
    [sym_exp_section_left] = STATE(4455),
    [sym_exp_section_right] = STATE(4455),
    [sym_exp_th_quoted_name] = STATE(4455),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(8786),
    [sym_exp_let] = STATE(18318),
    [sym_exp_let_in] = STATE(8786),
    [sym_exp_cond] = STATE(8786),
    [sym_exp_if_guard] = STATE(8786),
    [sym_exp_case] = STATE(8786),
    [sym_exp_lambda_case] = STATE(828),
    [sym__do_keyword] = STATE(18263),
    [sym_do_module] = STATE(18263),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(8786),
    [sym_exp_record] = STATE(4455),
    [sym_exp_name] = STATE(4455),
    [sym_exp_projection_selector] = STATE(4455),
    [sym__aexp_projection] = STATE(4455),
    [sym_exp_projection] = STATE(4455),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(11903),
    [sym__fexp] = STATE(8786),
    [sym__lexp] = STATE(8786),
    [sym_exp_infix] = STATE(8786),
    [sym__exp_infix] = STATE(8786),
    [sym__exp] = STATE(11709),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12635),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(2080),
    [sym_float] = ACTIONS(2082),
    [sym_char] = ACTIONS(2082),
    [sym_string] = ACTIONS(2082),
    [sym__integer_literal] = ACTIONS(2084),
    [sym__binary_literal] = ACTIONS(2086),
    [sym__octal_literal] = ACTIONS(2086),
    [sym__hex_literal] = ACTIONS(2086),
    [anon_sym_LPAREN_POUND] = ACTIONS(2088),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2088),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2090),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [sym_implicit_parid] = ACTIONS(2090),
    [sym__conid] = ACTIONS(4055),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_BSLASH] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4057),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_mdo] = ACTIONS(2114),
    [anon_sym_do] = ACTIONS(2114),
    [anon_sym_7] = ACTIONS(2116),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2120),
  },
  [1330] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15104),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1331] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15123),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1332] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15146),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1333] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9807),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9807),
    [sym_exp_cond] = STATE(9807),
    [sym_exp_if_guard] = STATE(9807),
    [sym_exp_case] = STATE(9807),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9807),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9807),
    [sym__lexp] = STATE(9807),
    [sym_exp_infix] = STATE(9807),
    [sym__exp_infix] = STATE(9807),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4067),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1334] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15151),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1335] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20699),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1336] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15168),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1337] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15199),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1338] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15202),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1339] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15210),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1340] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15219),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1341] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15242),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1342] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15250),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1343] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15271),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1344] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15297),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1345] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9832),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9832),
    [sym_exp_cond] = STATE(9832),
    [sym_exp_if_guard] = STATE(9832),
    [sym_exp_case] = STATE(9832),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9832),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9832),
    [sym__lexp] = STATE(9832),
    [sym_exp_infix] = STATE(9832),
    [sym__exp_infix] = STATE(9832),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4069),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1346] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15300),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1347] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15319),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1348] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15336),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1349] = {
    [sym_integer] = STATE(4937),
    [sym__literal] = STATE(4937),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = STATE(5329),
    [sym_qualified_variable] = STATE(5329),
    [sym_constructor] = STATE(4661),
    [sym_qualified_constructor] = STATE(5081),
    [sym__qcon] = STATE(5329),
    [sym_con_unit] = STATE(4937),
    [sym_con_list] = STATE(4937),
    [sym_con_tuple] = STATE(4937),
    [sym_literal] = STATE(5477),
    [sym_exp_parens] = STATE(5477),
    [sym_exp_tuple] = STATE(5477),
    [sym_exp_unboxed_tuple] = STATE(5477),
    [sym_exp_unboxed_sum] = STATE(5477),
    [sym_exp_list] = STATE(5477),
    [sym_exp_arithmetic_sequence] = STATE(5477),
    [sym_exp_list_comprehension] = STATE(5477),
    [sym_exp_section_left] = STATE(5477),
    [sym_exp_section_right] = STATE(5477),
    [sym_exp_th_quoted_name] = STATE(5477),
    [sym_exp_type_application] = STATE(917),
    [sym_exp_lambda] = STATE(9199),
    [sym_exp_let] = STATE(17941),
    [sym_exp_let_in] = STATE(9199),
    [sym_exp_cond] = STATE(9199),
    [sym_exp_if_guard] = STATE(9199),
    [sym_exp_case] = STATE(9199),
    [sym_exp_lambda_case] = STATE(917),
    [sym__do_keyword] = STATE(18276),
    [sym_do_module] = STATE(18276),
    [sym_exp_do] = STATE(917),
    [sym_exp_negation] = STATE(9199),
    [sym_exp_record] = STATE(5477),
    [sym_exp_name] = STATE(5477),
    [sym_exp_projection_selector] = STATE(5477),
    [sym__aexp_projection] = STATE(5477),
    [sym_exp_projection] = STATE(5477),
    [sym__aexp] = STATE(917),
    [sym__exp_apply] = STATE(12109),
    [sym__fexp] = STATE(9199),
    [sym__lexp] = STATE(9199),
    [sym_exp_infix] = STATE(9199),
    [sym__exp_infix] = STATE(9199),
    [sym__exp] = STATE(12000),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12628),
    [sym_splice] = STATE(5477),
    [sym_quasiquote] = STATE(5477),
    [sym__varid] = ACTIONS(2733),
    [sym_float] = ACTIONS(2735),
    [sym_char] = ACTIONS(2735),
    [sym_string] = ACTIONS(2735),
    [sym__integer_literal] = ACTIONS(2737),
    [sym__binary_literal] = ACTIONS(2739),
    [sym__octal_literal] = ACTIONS(2739),
    [sym__hex_literal] = ACTIONS(2739),
    [anon_sym_LPAREN_POUND] = ACTIONS(2741),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2741),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(2745),
    [sym_implicit_parid] = ACTIONS(2743),
    [sym__conid] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2759),
    [anon_sym_BSLASH] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4075),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_mdo] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_7] = ACTIONS(2769),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2773),
  },
  [1350] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15018),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1351] = {
    [sym_integer] = STATE(4937),
    [sym__literal] = STATE(4937),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = STATE(5329),
    [sym_qualified_variable] = STATE(5329),
    [sym_constructor] = STATE(4661),
    [sym_qualified_constructor] = STATE(5081),
    [sym__qcon] = STATE(5329),
    [sym_con_unit] = STATE(4937),
    [sym_con_list] = STATE(4937),
    [sym_con_tuple] = STATE(4937),
    [sym_literal] = STATE(5477),
    [sym_exp_parens] = STATE(5477),
    [sym_exp_tuple] = STATE(5477),
    [sym_exp_unboxed_tuple] = STATE(5477),
    [sym_exp_unboxed_sum] = STATE(5477),
    [sym_exp_list] = STATE(5477),
    [sym_exp_arithmetic_sequence] = STATE(5477),
    [sym_exp_list_comprehension] = STATE(5477),
    [sym_exp_section_left] = STATE(5477),
    [sym_exp_section_right] = STATE(5477),
    [sym_exp_th_quoted_name] = STATE(5477),
    [sym_exp_type_application] = STATE(917),
    [sym_exp_lambda] = STATE(9199),
    [sym_exp_let] = STATE(17941),
    [sym_exp_let_in] = STATE(9199),
    [sym_exp_cond] = STATE(9199),
    [sym_exp_if_guard] = STATE(9199),
    [sym_exp_case] = STATE(9199),
    [sym_exp_lambda_case] = STATE(917),
    [sym__do_keyword] = STATE(18276),
    [sym_do_module] = STATE(18276),
    [sym_exp_do] = STATE(917),
    [sym_exp_negation] = STATE(9199),
    [sym_exp_record] = STATE(5477),
    [sym_exp_name] = STATE(5477),
    [sym_exp_projection_selector] = STATE(5477),
    [sym__aexp_projection] = STATE(5477),
    [sym_exp_projection] = STATE(5477),
    [sym__aexp] = STATE(917),
    [sym__exp_apply] = STATE(12109),
    [sym__fexp] = STATE(9199),
    [sym__lexp] = STATE(9199),
    [sym_exp_infix] = STATE(9199),
    [sym__exp_infix] = STATE(9199),
    [sym__exp] = STATE(11990),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12628),
    [sym_splice] = STATE(5477),
    [sym_quasiquote] = STATE(5477),
    [sym__varid] = ACTIONS(2733),
    [sym_float] = ACTIONS(2735),
    [sym_char] = ACTIONS(2735),
    [sym_string] = ACTIONS(2735),
    [sym__integer_literal] = ACTIONS(2737),
    [sym__binary_literal] = ACTIONS(2739),
    [sym__octal_literal] = ACTIONS(2739),
    [sym__hex_literal] = ACTIONS(2739),
    [anon_sym_LPAREN_POUND] = ACTIONS(2741),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2741),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(2745),
    [sym_implicit_parid] = ACTIONS(2743),
    [sym__conid] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2759),
    [anon_sym_BSLASH] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4075),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_mdo] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_7] = ACTIONS(2769),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2773),
  },
  [1352] = {
    [sym_integer] = STATE(4937),
    [sym__literal] = STATE(4937),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = STATE(5329),
    [sym_qualified_variable] = STATE(5329),
    [sym_constructor] = STATE(4661),
    [sym_qualified_constructor] = STATE(5081),
    [sym__qcon] = STATE(5329),
    [sym_con_unit] = STATE(4937),
    [sym_con_list] = STATE(4937),
    [sym_con_tuple] = STATE(4937),
    [sym_literal] = STATE(5477),
    [sym_exp_parens] = STATE(5477),
    [sym_exp_tuple] = STATE(5477),
    [sym_exp_unboxed_tuple] = STATE(5477),
    [sym_exp_unboxed_sum] = STATE(5477),
    [sym_exp_list] = STATE(5477),
    [sym_exp_arithmetic_sequence] = STATE(5477),
    [sym_exp_list_comprehension] = STATE(5477),
    [sym_exp_section_left] = STATE(5477),
    [sym_exp_section_right] = STATE(5477),
    [sym_exp_th_quoted_name] = STATE(5477),
    [sym_exp_type_application] = STATE(917),
    [sym_exp_lambda] = STATE(9199),
    [sym_exp_let] = STATE(17941),
    [sym_exp_let_in] = STATE(9199),
    [sym_exp_cond] = STATE(9199),
    [sym_exp_if_guard] = STATE(9199),
    [sym_exp_case] = STATE(9199),
    [sym_exp_lambda_case] = STATE(917),
    [sym__do_keyword] = STATE(18276),
    [sym_do_module] = STATE(18276),
    [sym_exp_do] = STATE(917),
    [sym_exp_negation] = STATE(9199),
    [sym_exp_record] = STATE(5477),
    [sym_exp_name] = STATE(5477),
    [sym_exp_projection_selector] = STATE(5477),
    [sym__aexp_projection] = STATE(5477),
    [sym_exp_projection] = STATE(5477),
    [sym__aexp] = STATE(917),
    [sym__exp_apply] = STATE(12109),
    [sym__fexp] = STATE(9199),
    [sym__lexp] = STATE(9199),
    [sym_exp_infix] = STATE(9199),
    [sym__exp_infix] = STATE(9199),
    [sym__exp] = STATE(11985),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12628),
    [sym_splice] = STATE(5477),
    [sym_quasiquote] = STATE(5477),
    [sym__varid] = ACTIONS(2733),
    [sym_float] = ACTIONS(2735),
    [sym_char] = ACTIONS(2735),
    [sym_string] = ACTIONS(2735),
    [sym__integer_literal] = ACTIONS(2737),
    [sym__binary_literal] = ACTIONS(2739),
    [sym__octal_literal] = ACTIONS(2739),
    [sym__hex_literal] = ACTIONS(2739),
    [anon_sym_LPAREN_POUND] = ACTIONS(2741),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2741),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(2745),
    [sym_implicit_parid] = ACTIONS(2743),
    [sym__conid] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2759),
    [anon_sym_BSLASH] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4075),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_mdo] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_7] = ACTIONS(2769),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2773),
  },
  [1353] = {
    [sym_integer] = STATE(4937),
    [sym__literal] = STATE(4937),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = STATE(5329),
    [sym_qualified_variable] = STATE(5329),
    [sym_constructor] = STATE(4661),
    [sym_qualified_constructor] = STATE(5081),
    [sym__qcon] = STATE(5329),
    [sym_con_unit] = STATE(4937),
    [sym_con_list] = STATE(4937),
    [sym_con_tuple] = STATE(4937),
    [sym_literal] = STATE(5477),
    [sym_exp_parens] = STATE(5477),
    [sym_exp_tuple] = STATE(5477),
    [sym_exp_unboxed_tuple] = STATE(5477),
    [sym_exp_unboxed_sum] = STATE(5477),
    [sym_exp_list] = STATE(5477),
    [sym_exp_arithmetic_sequence] = STATE(5477),
    [sym_exp_list_comprehension] = STATE(5477),
    [sym_exp_section_left] = STATE(5477),
    [sym_exp_section_right] = STATE(5477),
    [sym_exp_th_quoted_name] = STATE(5477),
    [sym_exp_type_application] = STATE(917),
    [sym_exp_lambda] = STATE(9199),
    [sym_exp_let] = STATE(17941),
    [sym_exp_let_in] = STATE(9199),
    [sym_exp_cond] = STATE(9199),
    [sym_exp_if_guard] = STATE(9199),
    [sym_exp_case] = STATE(9199),
    [sym_exp_lambda_case] = STATE(917),
    [sym__do_keyword] = STATE(18276),
    [sym_do_module] = STATE(18276),
    [sym_exp_do] = STATE(917),
    [sym_exp_negation] = STATE(9199),
    [sym_exp_record] = STATE(5477),
    [sym_exp_name] = STATE(5477),
    [sym_exp_projection_selector] = STATE(5477),
    [sym__aexp_projection] = STATE(5477),
    [sym_exp_projection] = STATE(5477),
    [sym__aexp] = STATE(917),
    [sym__exp_apply] = STATE(12109),
    [sym__fexp] = STATE(9199),
    [sym__lexp] = STATE(9199),
    [sym_exp_infix] = STATE(9199),
    [sym__exp_infix] = STATE(9199),
    [sym__exp] = STATE(11947),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12628),
    [sym_splice] = STATE(5477),
    [sym_quasiquote] = STATE(5477),
    [sym__varid] = ACTIONS(2733),
    [sym_float] = ACTIONS(2735),
    [sym_char] = ACTIONS(2735),
    [sym_string] = ACTIONS(2735),
    [sym__integer_literal] = ACTIONS(2737),
    [sym__binary_literal] = ACTIONS(2739),
    [sym__octal_literal] = ACTIONS(2739),
    [sym__hex_literal] = ACTIONS(2739),
    [anon_sym_LPAREN_POUND] = ACTIONS(2741),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2741),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(2745),
    [sym_implicit_parid] = ACTIONS(2743),
    [sym__conid] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2759),
    [anon_sym_BSLASH] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4075),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_mdo] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_7] = ACTIONS(2769),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2773),
  },
  [1354] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15355),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1355] = {
    [sym_integer] = STATE(4937),
    [sym__literal] = STATE(4937),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = STATE(5329),
    [sym_qualified_variable] = STATE(5329),
    [sym_constructor] = STATE(4661),
    [sym_qualified_constructor] = STATE(5081),
    [sym__qcon] = STATE(5329),
    [sym_con_unit] = STATE(4937),
    [sym_con_list] = STATE(4937),
    [sym_con_tuple] = STATE(4937),
    [sym_literal] = STATE(5477),
    [sym_exp_parens] = STATE(5477),
    [sym_exp_tuple] = STATE(5477),
    [sym_exp_unboxed_tuple] = STATE(5477),
    [sym_exp_unboxed_sum] = STATE(5477),
    [sym_exp_list] = STATE(5477),
    [sym_exp_arithmetic_sequence] = STATE(5477),
    [sym_exp_list_comprehension] = STATE(5477),
    [sym_exp_section_left] = STATE(5477),
    [sym_exp_section_right] = STATE(5477),
    [sym_exp_th_quoted_name] = STATE(5477),
    [sym_exp_type_application] = STATE(917),
    [sym_exp_lambda] = STATE(9199),
    [sym_exp_let] = STATE(17941),
    [sym_exp_let_in] = STATE(9199),
    [sym_exp_cond] = STATE(9199),
    [sym_exp_if_guard] = STATE(9199),
    [sym_exp_case] = STATE(9199),
    [sym_exp_lambda_case] = STATE(917),
    [sym__do_keyword] = STATE(18276),
    [sym_do_module] = STATE(18276),
    [sym_exp_do] = STATE(917),
    [sym_exp_negation] = STATE(9199),
    [sym_exp_record] = STATE(5477),
    [sym_exp_name] = STATE(5477),
    [sym_exp_projection_selector] = STATE(5477),
    [sym__aexp_projection] = STATE(5477),
    [sym_exp_projection] = STATE(5477),
    [sym__aexp] = STATE(917),
    [sym__exp_apply] = STATE(12109),
    [sym__fexp] = STATE(9199),
    [sym__lexp] = STATE(9199),
    [sym_exp_infix] = STATE(9199),
    [sym__exp_infix] = STATE(9199),
    [sym__exp] = STATE(11999),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12628),
    [sym_splice] = STATE(5477),
    [sym_quasiquote] = STATE(5477),
    [sym__varid] = ACTIONS(2733),
    [sym_float] = ACTIONS(2735),
    [sym_char] = ACTIONS(2735),
    [sym_string] = ACTIONS(2735),
    [sym__integer_literal] = ACTIONS(2737),
    [sym__binary_literal] = ACTIONS(2739),
    [sym__octal_literal] = ACTIONS(2739),
    [sym__hex_literal] = ACTIONS(2739),
    [anon_sym_LPAREN_POUND] = ACTIONS(2741),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2741),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(2745),
    [sym_implicit_parid] = ACTIONS(2743),
    [sym__conid] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2759),
    [anon_sym_BSLASH] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4075),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_mdo] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_7] = ACTIONS(2769),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2773),
  },
  [1356] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15361),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1357] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9811),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9811),
    [sym_exp_cond] = STATE(9811),
    [sym_exp_if_guard] = STATE(9811),
    [sym_exp_case] = STATE(9811),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9811),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9811),
    [sym__lexp] = STATE(9811),
    [sym_exp_infix] = STATE(9811),
    [sym__exp_infix] = STATE(9811),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4077),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1358] = {
    [sym_integer] = STATE(4937),
    [sym__literal] = STATE(4937),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = STATE(5329),
    [sym_qualified_variable] = STATE(5329),
    [sym_constructor] = STATE(4661),
    [sym_qualified_constructor] = STATE(5081),
    [sym__qcon] = STATE(5329),
    [sym_con_unit] = STATE(4937),
    [sym_con_list] = STATE(4937),
    [sym_con_tuple] = STATE(4937),
    [sym_literal] = STATE(5477),
    [sym_exp_parens] = STATE(5477),
    [sym_exp_tuple] = STATE(5477),
    [sym_exp_unboxed_tuple] = STATE(5477),
    [sym_exp_unboxed_sum] = STATE(5477),
    [sym_exp_list] = STATE(5477),
    [sym_exp_arithmetic_sequence] = STATE(5477),
    [sym_exp_list_comprehension] = STATE(5477),
    [sym_exp_section_left] = STATE(5477),
    [sym_exp_section_right] = STATE(5477),
    [sym_exp_th_quoted_name] = STATE(5477),
    [sym_exp_type_application] = STATE(917),
    [sym_exp_lambda] = STATE(9199),
    [sym_exp_let] = STATE(17941),
    [sym_exp_let_in] = STATE(9199),
    [sym_exp_cond] = STATE(9199),
    [sym_exp_if_guard] = STATE(9199),
    [sym_exp_case] = STATE(9199),
    [sym_exp_lambda_case] = STATE(917),
    [sym__do_keyword] = STATE(18276),
    [sym_do_module] = STATE(18276),
    [sym_exp_do] = STATE(917),
    [sym_exp_negation] = STATE(9199),
    [sym_exp_record] = STATE(5477),
    [sym_exp_name] = STATE(5477),
    [sym_exp_projection_selector] = STATE(5477),
    [sym__aexp_projection] = STATE(5477),
    [sym_exp_projection] = STATE(5477),
    [sym__aexp] = STATE(917),
    [sym__exp_apply] = STATE(12109),
    [sym__fexp] = STATE(9199),
    [sym__lexp] = STATE(9199),
    [sym_exp_infix] = STATE(9199),
    [sym__exp_infix] = STATE(9199),
    [sym__exp] = STATE(12047),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12628),
    [sym_splice] = STATE(5477),
    [sym_quasiquote] = STATE(5477),
    [sym__varid] = ACTIONS(2733),
    [sym_float] = ACTIONS(2735),
    [sym_char] = ACTIONS(2735),
    [sym_string] = ACTIONS(2735),
    [sym__integer_literal] = ACTIONS(2737),
    [sym__binary_literal] = ACTIONS(2739),
    [sym__octal_literal] = ACTIONS(2739),
    [sym__hex_literal] = ACTIONS(2739),
    [anon_sym_LPAREN_POUND] = ACTIONS(2741),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2741),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(2745),
    [sym_implicit_parid] = ACTIONS(2743),
    [sym__conid] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2759),
    [anon_sym_BSLASH] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4075),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_mdo] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_7] = ACTIONS(2769),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2773),
  },
  [1359] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15370),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1360] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15127),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1361] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17937),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1362] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15384),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1363] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17943),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1364] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15395),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1365] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7803),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7803),
    [sym_exp_cond] = STATE(7803),
    [sym_exp_if_guard] = STATE(7803),
    [sym_exp_case] = STATE(7803),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7803),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7803),
    [sym__lexp] = STATE(7803),
    [sym_exp_infix] = STATE(7803),
    [sym__exp_infix] = STATE(7803),
    [sym__exp] = STATE(9602),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1366] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17947),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1367] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15356),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1368] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17949),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1369] = {
    [sym_integer] = STATE(4976),
    [sym__literal] = STATE(4976),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = STATE(5481),
    [sym_qualified_variable] = STATE(5481),
    [sym_constructor] = STATE(4552),
    [sym_qualified_constructor] = STATE(5251),
    [sym__qcon] = STATE(5481),
    [sym_con_unit] = STATE(4976),
    [sym_con_list] = STATE(4976),
    [sym_con_tuple] = STATE(4976),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(948),
    [sym_exp_lambda] = STATE(9194),
    [sym_exp_let] = STATE(18616),
    [sym_exp_let_in] = STATE(9194),
    [sym_exp_cond] = STATE(9194),
    [sym_exp_if_guard] = STATE(9194),
    [sym_exp_case] = STATE(9194),
    [sym_exp_lambda_case] = STATE(948),
    [sym__do_keyword] = STATE(18242),
    [sym_do_module] = STATE(18242),
    [sym_exp_do] = STATE(948),
    [sym_exp_negation] = STATE(9194),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(948),
    [sym__exp_apply] = STATE(12137),
    [sym__fexp] = STATE(9194),
    [sym__lexp] = STATE(9194),
    [sym_exp_infix] = STATE(9194),
    [sym__exp_infix] = STATE(9194),
    [sym__exp] = STATE(12018),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12657),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2603),
    [sym_float] = ACTIONS(2605),
    [sym_char] = ACTIONS(2605),
    [sym_string] = ACTIONS(2605),
    [sym__integer_literal] = ACTIONS(2607),
    [sym__binary_literal] = ACTIONS(2609),
    [sym__octal_literal] = ACTIONS(2609),
    [sym__hex_literal] = ACTIONS(2609),
    [anon_sym_LPAREN_POUND] = ACTIONS(2611),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2611),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [sym_implicit_parid] = ACTIONS(2613),
    [sym__conid] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_mdo] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_7] = ACTIONS(2638),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2642),
  },
  [1370] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15310),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1371] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7803),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7803),
    [sym_exp_cond] = STATE(7803),
    [sym_exp_if_guard] = STATE(7803),
    [sym_exp_case] = STATE(7803),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7803),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7803),
    [sym__lexp] = STATE(7803),
    [sym_exp_infix] = STATE(7803),
    [sym__exp_infix] = STATE(7803),
    [sym__exp] = STATE(9631),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1372] = {
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = STATE(3595),
    [sym_qualified_variable] = STATE(3595),
    [sym_constructor] = STATE(3473),
    [sym_qualified_constructor] = STATE(3699),
    [sym__qcon] = STATE(3595),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(3752),
    [sym_exp_parens] = STATE(3752),
    [sym_exp_tuple] = STATE(3752),
    [sym_exp_unboxed_tuple] = STATE(3752),
    [sym_exp_unboxed_sum] = STATE(3752),
    [sym_exp_list] = STATE(3752),
    [sym_exp_arithmetic_sequence] = STATE(3752),
    [sym_exp_list_comprehension] = STATE(3752),
    [sym_exp_section_left] = STATE(3752),
    [sym_exp_section_right] = STATE(3752),
    [sym_exp_th_quoted_name] = STATE(3752),
    [sym_exp_type_application] = STATE(603),
    [sym_exp_lambda] = STATE(7662),
    [sym_exp_let] = STATE(17973),
    [sym_exp_let_in] = STATE(7662),
    [sym_exp_cond] = STATE(7662),
    [sym_exp_if_guard] = STATE(7662),
    [sym_exp_case] = STATE(7662),
    [sym_exp_lambda_case] = STATE(603),
    [sym__do_keyword] = STATE(18310),
    [sym_do_module] = STATE(18310),
    [sym_exp_do] = STATE(603),
    [sym_exp_negation] = STATE(7662),
    [sym_exp_record] = STATE(3752),
    [sym_exp_name] = STATE(3752),
    [sym_exp_projection_selector] = STATE(3752),
    [sym__aexp_projection] = STATE(3752),
    [sym_exp_projection] = STATE(3752),
    [sym__aexp] = STATE(603),
    [sym__exp_apply] = STATE(9582),
    [sym__fexp] = STATE(7662),
    [sym__lexp] = STATE(7662),
    [sym_exp_infix] = STATE(7662),
    [sym__exp_infix] = STATE(7662),
    [sym__exp] = STATE(9550),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12563),
    [sym_splice] = STATE(3752),
    [sym_quasiquote] = STATE(3752),
    [sym__varid] = ACTIONS(1634),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(1638),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1638),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(1644),
    [sym_implicit_parid] = ACTIONS(1640),
    [sym__conid] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_SQUOTE] = ACTIONS(1651),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1655),
    [anon_sym_AT] = ACTIONS(1657),
    [anon_sym_BSLASH] = ACTIONS(1659),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4089),
    [anon_sym_case] = ACTIONS(1663),
    [anon_sym_mdo] = ACTIONS(1665),
    [anon_sym_do] = ACTIONS(1665),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
  },
  [1373] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7803),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7803),
    [sym_exp_cond] = STATE(7803),
    [sym_exp_if_guard] = STATE(7803),
    [sym_exp_case] = STATE(7803),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7803),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7803),
    [sym__lexp] = STATE(7803),
    [sym_exp_infix] = STATE(7803),
    [sym__exp_infix] = STATE(7803),
    [sym__exp] = STATE(9684),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1374] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7803),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7803),
    [sym_exp_cond] = STATE(7803),
    [sym_exp_if_guard] = STATE(7803),
    [sym_exp_case] = STATE(7803),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7803),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7803),
    [sym__lexp] = STATE(7803),
    [sym_exp_infix] = STATE(7803),
    [sym__exp_infix] = STATE(7803),
    [sym__exp] = STATE(9654),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1375] = {
    [sym_integer] = STATE(4976),
    [sym__literal] = STATE(4976),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = STATE(5481),
    [sym_qualified_variable] = STATE(5481),
    [sym_constructor] = STATE(4552),
    [sym_qualified_constructor] = STATE(5251),
    [sym__qcon] = STATE(5481),
    [sym_con_unit] = STATE(4976),
    [sym_con_list] = STATE(4976),
    [sym_con_tuple] = STATE(4976),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(948),
    [sym_exp_lambda] = STATE(9194),
    [sym_exp_let] = STATE(18616),
    [sym_exp_let_in] = STATE(9194),
    [sym_exp_cond] = STATE(9194),
    [sym_exp_if_guard] = STATE(9194),
    [sym_exp_case] = STATE(9194),
    [sym_exp_lambda_case] = STATE(948),
    [sym__do_keyword] = STATE(18242),
    [sym_do_module] = STATE(18242),
    [sym_exp_do] = STATE(948),
    [sym_exp_negation] = STATE(9194),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(948),
    [sym__exp_apply] = STATE(12137),
    [sym__fexp] = STATE(9194),
    [sym__lexp] = STATE(9194),
    [sym_exp_infix] = STATE(9194),
    [sym__exp_infix] = STATE(9194),
    [sym__exp] = STATE(12098),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12657),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2603),
    [sym_float] = ACTIONS(2605),
    [sym_char] = ACTIONS(2605),
    [sym_string] = ACTIONS(2605),
    [sym__integer_literal] = ACTIONS(2607),
    [sym__binary_literal] = ACTIONS(2609),
    [sym__octal_literal] = ACTIONS(2609),
    [sym__hex_literal] = ACTIONS(2609),
    [anon_sym_LPAREN_POUND] = ACTIONS(2611),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2611),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [sym_implicit_parid] = ACTIONS(2613),
    [sym__conid] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_mdo] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_7] = ACTIONS(2638),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2642),
  },
  [1376] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7803),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7803),
    [sym_exp_cond] = STATE(7803),
    [sym_exp_if_guard] = STATE(7803),
    [sym_exp_case] = STATE(7803),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7803),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7803),
    [sym__lexp] = STATE(7803),
    [sym_exp_infix] = STATE(7803),
    [sym__exp_infix] = STATE(7803),
    [sym__exp] = STATE(9652),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1377] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7803),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7803),
    [sym_exp_cond] = STATE(7803),
    [sym_exp_if_guard] = STATE(7803),
    [sym_exp_case] = STATE(7803),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7803),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7803),
    [sym__lexp] = STATE(7803),
    [sym_exp_infix] = STATE(7803),
    [sym__exp_infix] = STATE(7803),
    [sym__exp] = STATE(9650),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1378] = {
    [sym_integer] = STATE(4976),
    [sym__literal] = STATE(4976),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = STATE(5481),
    [sym_qualified_variable] = STATE(5481),
    [sym_constructor] = STATE(4552),
    [sym_qualified_constructor] = STATE(5251),
    [sym__qcon] = STATE(5481),
    [sym_con_unit] = STATE(4976),
    [sym_con_list] = STATE(4976),
    [sym_con_tuple] = STATE(4976),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(948),
    [sym_exp_lambda] = STATE(9194),
    [sym_exp_let] = STATE(18616),
    [sym_exp_let_in] = STATE(9194),
    [sym_exp_cond] = STATE(9194),
    [sym_exp_if_guard] = STATE(9194),
    [sym_exp_case] = STATE(9194),
    [sym_exp_lambda_case] = STATE(948),
    [sym__do_keyword] = STATE(18242),
    [sym_do_module] = STATE(18242),
    [sym_exp_do] = STATE(948),
    [sym_exp_negation] = STATE(9194),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(948),
    [sym__exp_apply] = STATE(12137),
    [sym__fexp] = STATE(9194),
    [sym__lexp] = STATE(9194),
    [sym_exp_infix] = STATE(9194),
    [sym__exp_infix] = STATE(9194),
    [sym__exp] = STATE(12231),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12657),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2603),
    [sym_float] = ACTIONS(2605),
    [sym_char] = ACTIONS(2605),
    [sym_string] = ACTIONS(2605),
    [sym__integer_literal] = ACTIONS(2607),
    [sym__binary_literal] = ACTIONS(2609),
    [sym__octal_literal] = ACTIONS(2609),
    [sym__hex_literal] = ACTIONS(2609),
    [anon_sym_LPAREN_POUND] = ACTIONS(2611),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2611),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [sym_implicit_parid] = ACTIONS(2613),
    [sym__conid] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_mdo] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_7] = ACTIONS(2638),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2642),
  },
  [1379] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17953),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1380] = {
    [sym_integer] = STATE(4976),
    [sym__literal] = STATE(4976),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = STATE(5481),
    [sym_qualified_variable] = STATE(5481),
    [sym_constructor] = STATE(4552),
    [sym_qualified_constructor] = STATE(5251),
    [sym__qcon] = STATE(5481),
    [sym_con_unit] = STATE(4976),
    [sym_con_list] = STATE(4976),
    [sym_con_tuple] = STATE(4976),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(948),
    [sym_exp_lambda] = STATE(9194),
    [sym_exp_let] = STATE(18616),
    [sym_exp_let_in] = STATE(9194),
    [sym_exp_cond] = STATE(9194),
    [sym_exp_if_guard] = STATE(9194),
    [sym_exp_case] = STATE(9194),
    [sym_exp_lambda_case] = STATE(948),
    [sym__do_keyword] = STATE(18242),
    [sym_do_module] = STATE(18242),
    [sym_exp_do] = STATE(948),
    [sym_exp_negation] = STATE(9194),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(948),
    [sym__exp_apply] = STATE(12137),
    [sym__fexp] = STATE(9194),
    [sym__lexp] = STATE(9194),
    [sym_exp_infix] = STATE(9194),
    [sym__exp_infix] = STATE(9194),
    [sym__exp] = STATE(12160),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12657),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2603),
    [sym_float] = ACTIONS(2605),
    [sym_char] = ACTIONS(2605),
    [sym_string] = ACTIONS(2605),
    [sym__integer_literal] = ACTIONS(2607),
    [sym__binary_literal] = ACTIONS(2609),
    [sym__octal_literal] = ACTIONS(2609),
    [sym__hex_literal] = ACTIONS(2609),
    [anon_sym_LPAREN_POUND] = ACTIONS(2611),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2611),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [sym_implicit_parid] = ACTIONS(2613),
    [sym__conid] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_mdo] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_7] = ACTIONS(2638),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2642),
  },
  [1381] = {
    [sym_integer] = STATE(4976),
    [sym__literal] = STATE(4976),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = STATE(5481),
    [sym_qualified_variable] = STATE(5481),
    [sym_constructor] = STATE(4552),
    [sym_qualified_constructor] = STATE(5251),
    [sym__qcon] = STATE(5481),
    [sym_con_unit] = STATE(4976),
    [sym_con_list] = STATE(4976),
    [sym_con_tuple] = STATE(4976),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(948),
    [sym_exp_lambda] = STATE(9194),
    [sym_exp_let] = STATE(18616),
    [sym_exp_let_in] = STATE(9194),
    [sym_exp_cond] = STATE(9194),
    [sym_exp_if_guard] = STATE(9194),
    [sym_exp_case] = STATE(9194),
    [sym_exp_lambda_case] = STATE(948),
    [sym__do_keyword] = STATE(18242),
    [sym_do_module] = STATE(18242),
    [sym_exp_do] = STATE(948),
    [sym_exp_negation] = STATE(9194),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(948),
    [sym__exp_apply] = STATE(12137),
    [sym__fexp] = STATE(9194),
    [sym__lexp] = STATE(9194),
    [sym_exp_infix] = STATE(9194),
    [sym__exp_infix] = STATE(9194),
    [sym__exp] = STATE(12150),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12657),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2603),
    [sym_float] = ACTIONS(2605),
    [sym_char] = ACTIONS(2605),
    [sym_string] = ACTIONS(2605),
    [sym__integer_literal] = ACTIONS(2607),
    [sym__binary_literal] = ACTIONS(2609),
    [sym__octal_literal] = ACTIONS(2609),
    [sym__hex_literal] = ACTIONS(2609),
    [anon_sym_LPAREN_POUND] = ACTIONS(2611),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2611),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [sym_implicit_parid] = ACTIONS(2613),
    [sym__conid] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_mdo] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_7] = ACTIONS(2638),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2642),
  },
  [1382] = {
    [sym_integer] = STATE(4976),
    [sym__literal] = STATE(4976),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = STATE(5481),
    [sym_qualified_variable] = STATE(5481),
    [sym_constructor] = STATE(4552),
    [sym_qualified_constructor] = STATE(5251),
    [sym__qcon] = STATE(5481),
    [sym_con_unit] = STATE(4976),
    [sym_con_list] = STATE(4976),
    [sym_con_tuple] = STATE(4976),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(948),
    [sym_exp_lambda] = STATE(9194),
    [sym_exp_let] = STATE(18616),
    [sym_exp_let_in] = STATE(9194),
    [sym_exp_cond] = STATE(9194),
    [sym_exp_if_guard] = STATE(9194),
    [sym_exp_case] = STATE(9194),
    [sym_exp_lambda_case] = STATE(948),
    [sym__do_keyword] = STATE(18242),
    [sym_do_module] = STATE(18242),
    [sym_exp_do] = STATE(948),
    [sym_exp_negation] = STATE(9194),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(948),
    [sym__exp_apply] = STATE(12137),
    [sym__fexp] = STATE(9194),
    [sym__lexp] = STATE(9194),
    [sym_exp_infix] = STATE(9194),
    [sym__exp_infix] = STATE(9194),
    [sym__exp] = STATE(12141),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12657),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2603),
    [sym_float] = ACTIONS(2605),
    [sym_char] = ACTIONS(2605),
    [sym_string] = ACTIONS(2605),
    [sym__integer_literal] = ACTIONS(2607),
    [sym__binary_literal] = ACTIONS(2609),
    [sym__octal_literal] = ACTIONS(2609),
    [sym__hex_literal] = ACTIONS(2609),
    [anon_sym_LPAREN_POUND] = ACTIONS(2611),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2611),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [sym_implicit_parid] = ACTIONS(2613),
    [sym__conid] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_mdo] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_7] = ACTIONS(2638),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2642),
  },
  [1383] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15253),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1384] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18425),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1385] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17956),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1386] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15174),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1387] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17960),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1388] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9930),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9930),
    [sym_exp_cond] = STATE(9930),
    [sym_exp_if_guard] = STATE(9930),
    [sym_exp_case] = STATE(9930),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9930),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9930),
    [sym__lexp] = STATE(9930),
    [sym_exp_infix] = STATE(9930),
    [sym__exp_infix] = STATE(9930),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4091),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1389] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15095),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1390] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17964),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1391] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(14780),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1392] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15043),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1393] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9884),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9884),
    [sym_exp_cond] = STATE(9884),
    [sym_exp_if_guard] = STATE(9884),
    [sym_exp_case] = STATE(9884),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9884),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9884),
    [sym__lexp] = STATE(9884),
    [sym_exp_infix] = STATE(9884),
    [sym__exp_infix] = STATE(9884),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4093),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1394] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15005),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1395] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17971),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1396] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(14936),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1397] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17976),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1398] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(14921),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1399] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17980),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1400] = {
    [sym_integer] = STATE(9549),
    [sym__literal] = STATE(9549),
    [sym__unboxed_open] = STATE(119),
    [sym_variable] = STATE(10828),
    [sym_qualified_variable] = STATE(9576),
    [sym_constructor] = STATE(9458),
    [sym_qualified_constructor] = STATE(9525),
    [sym__qcon] = STATE(11038),
    [sym_con_unit] = STATE(9549),
    [sym_con_list] = STATE(9549),
    [sym_con_tuple] = STATE(9549),
    [sym_literal] = STATE(11039),
    [sym_exp_parens] = STATE(9934),
    [sym_exp_tuple] = STATE(9934),
    [sym_exp_unboxed_tuple] = STATE(9934),
    [sym_exp_unboxed_sum] = STATE(9934),
    [sym_exp_list] = STATE(9934),
    [sym_exp_arithmetic_sequence] = STATE(9934),
    [sym_exp_list_comprehension] = STATE(9934),
    [sym_exp_section_left] = STATE(9934),
    [sym_exp_section_right] = STATE(9934),
    [sym_exp_th_quoted_name] = STATE(9934),
    [sym_exp_type_application] = STATE(10314),
    [sym_exp_lambda_case] = STATE(10314),
    [sym__do_keyword] = STATE(18492),
    [sym_do_module] = STATE(18492),
    [sym_exp_do] = STATE(10314),
    [sym_exp_record] = STATE(9934),
    [sym_exp_name] = STATE(9934),
    [sym_exp_projection_selector] = STATE(9934),
    [sym__aexp_projection] = STATE(9934),
    [sym_exp_projection] = STATE(9934),
    [sym__aexp] = STATE(10314),
    [sym_pat_as] = STATE(12511),
    [sym_pat_parens] = STATE(12511),
    [sym_pat_tuple] = STATE(12511),
    [sym_pat_unboxed_tuple] = STATE(12511),
    [sym_pat_unboxed_sum] = STATE(12511),
    [sym_pat_list] = STATE(12511),
    [sym_pat_strict] = STATE(12511),
    [sym_pat_irrefutable] = STATE(12511),
    [sym_pat_name] = STATE(12511),
    [sym__pat_constructor] = STATE(12158),
    [sym_pat_wildcard] = STATE(12511),
    [sym_pat_record] = STATE(12511),
    [sym__apat] = STATE(12511),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12670),
    [sym_splice] = STATE(11045),
    [sym_quasiquote] = STATE(11045),
    [sym__varid] = ACTIONS(4095),
    [sym_float] = ACTIONS(4097),
    [sym_char] = ACTIONS(4097),
    [sym_string] = ACTIONS(4097),
    [sym__integer_literal] = ACTIONS(4099),
    [sym__binary_literal] = ACTIONS(4101),
    [sym__octal_literal] = ACTIONS(4101),
    [sym__hex_literal] = ACTIONS(4101),
    [anon_sym_LPAREN_POUND] = ACTIONS(4103),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4103),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4105),
    [anon_sym_LPAREN] = ACTIONS(4107),
    [anon_sym_RPAREN] = ACTIONS(4109),
    [sym_implicit_parid] = ACTIONS(4105),
    [sym__conid] = ACTIONS(4111),
    [anon_sym_LBRACK] = ACTIONS(4113),
    [anon_sym_SQUOTE] = ACTIONS(4115),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4117),
    [anon_sym_AT] = ACTIONS(4119),
    [anon_sym_BSLASH] = ACTIONS(4121),
    [anon_sym_mdo] = ACTIONS(4123),
    [anon_sym_do] = ACTIONS(4123),
    [anon_sym_7] = ACTIONS(4125),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4127),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4129),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [1401] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(14806),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1402] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17984),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1403] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9913),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9913),
    [sym_exp_cond] = STATE(9913),
    [sym_exp_if_guard] = STATE(9913),
    [sym_exp_case] = STATE(9913),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9913),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9913),
    [sym__lexp] = STATE(9913),
    [sym_exp_infix] = STATE(9913),
    [sym__exp_infix] = STATE(9913),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4131),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1404] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9857),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9857),
    [sym_exp_cond] = STATE(9857),
    [sym_exp_if_guard] = STATE(9857),
    [sym_exp_case] = STATE(9857),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9857),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9857),
    [sym__lexp] = STATE(9857),
    [sym_exp_infix] = STATE(9857),
    [sym__exp_infix] = STATE(9857),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4133),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1405] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(14646),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1406] = {
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = STATE(3595),
    [sym_qualified_variable] = STATE(3595),
    [sym_constructor] = STATE(3473),
    [sym_qualified_constructor] = STATE(3699),
    [sym__qcon] = STATE(3595),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(3752),
    [sym_exp_parens] = STATE(3752),
    [sym_exp_tuple] = STATE(3752),
    [sym_exp_unboxed_tuple] = STATE(3752),
    [sym_exp_unboxed_sum] = STATE(3752),
    [sym_exp_list] = STATE(3752),
    [sym_exp_arithmetic_sequence] = STATE(3752),
    [sym_exp_list_comprehension] = STATE(3752),
    [sym_exp_section_left] = STATE(3752),
    [sym_exp_section_right] = STATE(3752),
    [sym_exp_th_quoted_name] = STATE(3752),
    [sym_exp_type_application] = STATE(603),
    [sym_exp_lambda] = STATE(7662),
    [sym_exp_let] = STATE(17973),
    [sym_exp_let_in] = STATE(7662),
    [sym_exp_cond] = STATE(7662),
    [sym_exp_if_guard] = STATE(7662),
    [sym_exp_case] = STATE(7662),
    [sym_exp_lambda_case] = STATE(603),
    [sym__do_keyword] = STATE(18310),
    [sym_do_module] = STATE(18310),
    [sym_exp_do] = STATE(603),
    [sym_exp_negation] = STATE(7662),
    [sym_exp_record] = STATE(3752),
    [sym_exp_name] = STATE(3752),
    [sym_exp_projection_selector] = STATE(3752),
    [sym__aexp_projection] = STATE(3752),
    [sym_exp_projection] = STATE(3752),
    [sym__aexp] = STATE(603),
    [sym__exp_apply] = STATE(9582),
    [sym__fexp] = STATE(7662),
    [sym__lexp] = STATE(7662),
    [sym_exp_infix] = STATE(7662),
    [sym__exp_infix] = STATE(7662),
    [sym__exp] = STATE(9524),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12563),
    [sym_splice] = STATE(3752),
    [sym_quasiquote] = STATE(3752),
    [sym__varid] = ACTIONS(1634),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(1638),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1638),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(1644),
    [sym_implicit_parid] = ACTIONS(1640),
    [sym__conid] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_SQUOTE] = ACTIONS(1651),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1655),
    [anon_sym_AT] = ACTIONS(1657),
    [anon_sym_BSLASH] = ACTIONS(1659),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4089),
    [anon_sym_case] = ACTIONS(1663),
    [anon_sym_mdo] = ACTIONS(1665),
    [anon_sym_do] = ACTIONS(1665),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
  },
  [1407] = {
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = STATE(3595),
    [sym_qualified_variable] = STATE(3595),
    [sym_constructor] = STATE(3473),
    [sym_qualified_constructor] = STATE(3699),
    [sym__qcon] = STATE(3595),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(3752),
    [sym_exp_parens] = STATE(3752),
    [sym_exp_tuple] = STATE(3752),
    [sym_exp_unboxed_tuple] = STATE(3752),
    [sym_exp_unboxed_sum] = STATE(3752),
    [sym_exp_list] = STATE(3752),
    [sym_exp_arithmetic_sequence] = STATE(3752),
    [sym_exp_list_comprehension] = STATE(3752),
    [sym_exp_section_left] = STATE(3752),
    [sym_exp_section_right] = STATE(3752),
    [sym_exp_th_quoted_name] = STATE(3752),
    [sym_exp_type_application] = STATE(603),
    [sym_exp_lambda] = STATE(7662),
    [sym_exp_let] = STATE(17973),
    [sym_exp_let_in] = STATE(7662),
    [sym_exp_cond] = STATE(7662),
    [sym_exp_if_guard] = STATE(7662),
    [sym_exp_case] = STATE(7662),
    [sym_exp_lambda_case] = STATE(603),
    [sym__do_keyword] = STATE(18310),
    [sym_do_module] = STATE(18310),
    [sym_exp_do] = STATE(603),
    [sym_exp_negation] = STATE(7662),
    [sym_exp_record] = STATE(3752),
    [sym_exp_name] = STATE(3752),
    [sym_exp_projection_selector] = STATE(3752),
    [sym__aexp_projection] = STATE(3752),
    [sym_exp_projection] = STATE(3752),
    [sym__aexp] = STATE(603),
    [sym__exp_apply] = STATE(9582),
    [sym__fexp] = STATE(7662),
    [sym__lexp] = STATE(7662),
    [sym_exp_infix] = STATE(7662),
    [sym__exp_infix] = STATE(7662),
    [sym__exp] = STATE(9526),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12563),
    [sym_splice] = STATE(3752),
    [sym_quasiquote] = STATE(3752),
    [sym__varid] = ACTIONS(1634),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(1638),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1638),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(1644),
    [sym_implicit_parid] = ACTIONS(1640),
    [sym__conid] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_SQUOTE] = ACTIONS(1651),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1655),
    [anon_sym_AT] = ACTIONS(1657),
    [anon_sym_BSLASH] = ACTIONS(1659),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4089),
    [anon_sym_case] = ACTIONS(1663),
    [anon_sym_mdo] = ACTIONS(1665),
    [anon_sym_do] = ACTIONS(1665),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
  },
  [1408] = {
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = STATE(3595),
    [sym_qualified_variable] = STATE(3595),
    [sym_constructor] = STATE(3473),
    [sym_qualified_constructor] = STATE(3699),
    [sym__qcon] = STATE(3595),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(3752),
    [sym_exp_parens] = STATE(3752),
    [sym_exp_tuple] = STATE(3752),
    [sym_exp_unboxed_tuple] = STATE(3752),
    [sym_exp_unboxed_sum] = STATE(3752),
    [sym_exp_list] = STATE(3752),
    [sym_exp_arithmetic_sequence] = STATE(3752),
    [sym_exp_list_comprehension] = STATE(3752),
    [sym_exp_section_left] = STATE(3752),
    [sym_exp_section_right] = STATE(3752),
    [sym_exp_th_quoted_name] = STATE(3752),
    [sym_exp_type_application] = STATE(603),
    [sym_exp_lambda] = STATE(7662),
    [sym_exp_let] = STATE(17973),
    [sym_exp_let_in] = STATE(7662),
    [sym_exp_cond] = STATE(7662),
    [sym_exp_if_guard] = STATE(7662),
    [sym_exp_case] = STATE(7662),
    [sym_exp_lambda_case] = STATE(603),
    [sym__do_keyword] = STATE(18310),
    [sym_do_module] = STATE(18310),
    [sym_exp_do] = STATE(603),
    [sym_exp_negation] = STATE(7662),
    [sym_exp_record] = STATE(3752),
    [sym_exp_name] = STATE(3752),
    [sym_exp_projection_selector] = STATE(3752),
    [sym__aexp_projection] = STATE(3752),
    [sym_exp_projection] = STATE(3752),
    [sym__aexp] = STATE(603),
    [sym__exp_apply] = STATE(9582),
    [sym__fexp] = STATE(7662),
    [sym__lexp] = STATE(7662),
    [sym_exp_infix] = STATE(7662),
    [sym__exp_infix] = STATE(7662),
    [sym__exp] = STATE(9521),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12563),
    [sym_splice] = STATE(3752),
    [sym_quasiquote] = STATE(3752),
    [sym__varid] = ACTIONS(1634),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(1638),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1638),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(1644),
    [sym_implicit_parid] = ACTIONS(1640),
    [sym__conid] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_SQUOTE] = ACTIONS(1651),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1655),
    [anon_sym_AT] = ACTIONS(1657),
    [anon_sym_BSLASH] = ACTIONS(1659),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4089),
    [anon_sym_case] = ACTIONS(1663),
    [anon_sym_mdo] = ACTIONS(1665),
    [anon_sym_do] = ACTIONS(1665),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
  },
  [1409] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9735),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9735),
    [sym_exp_cond] = STATE(9735),
    [sym_exp_if_guard] = STATE(9735),
    [sym_exp_case] = STATE(9735),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9735),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9735),
    [sym__lexp] = STATE(9735),
    [sym_exp_infix] = STATE(9735),
    [sym__exp_infix] = STATE(9735),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4135),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1410] = {
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = STATE(3595),
    [sym_qualified_variable] = STATE(3595),
    [sym_constructor] = STATE(3473),
    [sym_qualified_constructor] = STATE(3699),
    [sym__qcon] = STATE(3595),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(3752),
    [sym_exp_parens] = STATE(3752),
    [sym_exp_tuple] = STATE(3752),
    [sym_exp_unboxed_tuple] = STATE(3752),
    [sym_exp_unboxed_sum] = STATE(3752),
    [sym_exp_list] = STATE(3752),
    [sym_exp_arithmetic_sequence] = STATE(3752),
    [sym_exp_list_comprehension] = STATE(3752),
    [sym_exp_section_left] = STATE(3752),
    [sym_exp_section_right] = STATE(3752),
    [sym_exp_th_quoted_name] = STATE(3752),
    [sym_exp_type_application] = STATE(603),
    [sym_exp_lambda] = STATE(7662),
    [sym_exp_let] = STATE(17973),
    [sym_exp_let_in] = STATE(7662),
    [sym_exp_cond] = STATE(7662),
    [sym_exp_if_guard] = STATE(7662),
    [sym_exp_case] = STATE(7662),
    [sym_exp_lambda_case] = STATE(603),
    [sym__do_keyword] = STATE(18310),
    [sym_do_module] = STATE(18310),
    [sym_exp_do] = STATE(603),
    [sym_exp_negation] = STATE(7662),
    [sym_exp_record] = STATE(3752),
    [sym_exp_name] = STATE(3752),
    [sym_exp_projection_selector] = STATE(3752),
    [sym__aexp_projection] = STATE(3752),
    [sym_exp_projection] = STATE(3752),
    [sym__aexp] = STATE(603),
    [sym__exp_apply] = STATE(9582),
    [sym__fexp] = STATE(7662),
    [sym__lexp] = STATE(7662),
    [sym_exp_infix] = STATE(7662),
    [sym__exp_infix] = STATE(7662),
    [sym__exp] = STATE(9522),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12563),
    [sym_splice] = STATE(3752),
    [sym_quasiquote] = STATE(3752),
    [sym__varid] = ACTIONS(1634),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(1638),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1638),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(1644),
    [sym_implicit_parid] = ACTIONS(1640),
    [sym__conid] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_SQUOTE] = ACTIONS(1651),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1655),
    [anon_sym_AT] = ACTIONS(1657),
    [anon_sym_BSLASH] = ACTIONS(1659),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4089),
    [anon_sym_case] = ACTIONS(1663),
    [anon_sym_mdo] = ACTIONS(1665),
    [anon_sym_do] = ACTIONS(1665),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
  },
  [1411] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(8211),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(8211),
    [sym_exp_cond] = STATE(8211),
    [sym_exp_if_guard] = STATE(8211),
    [sym_exp_case] = STATE(8211),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(8211),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(8211),
    [sym__lexp] = STATE(8211),
    [sym_exp_infix] = STATE(8211),
    [sym__exp_infix] = STATE(8211),
    [sym__exp] = STATE(10397),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1412] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9804),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9804),
    [sym_exp_cond] = STATE(9804),
    [sym_exp_if_guard] = STATE(9804),
    [sym_exp_case] = STATE(9804),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9804),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9804),
    [sym__lexp] = STATE(9804),
    [sym_exp_infix] = STATE(9804),
    [sym__exp_infix] = STATE(9804),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4137),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1413] = {
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = STATE(3595),
    [sym_qualified_variable] = STATE(3595),
    [sym_constructor] = STATE(3473),
    [sym_qualified_constructor] = STATE(3699),
    [sym__qcon] = STATE(3595),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(3752),
    [sym_exp_parens] = STATE(3752),
    [sym_exp_tuple] = STATE(3752),
    [sym_exp_unboxed_tuple] = STATE(3752),
    [sym_exp_unboxed_sum] = STATE(3752),
    [sym_exp_list] = STATE(3752),
    [sym_exp_arithmetic_sequence] = STATE(3752),
    [sym_exp_list_comprehension] = STATE(3752),
    [sym_exp_section_left] = STATE(3752),
    [sym_exp_section_right] = STATE(3752),
    [sym_exp_th_quoted_name] = STATE(3752),
    [sym_exp_type_application] = STATE(603),
    [sym_exp_lambda] = STATE(7662),
    [sym_exp_let] = STATE(17973),
    [sym_exp_let_in] = STATE(7662),
    [sym_exp_cond] = STATE(7662),
    [sym_exp_if_guard] = STATE(7662),
    [sym_exp_case] = STATE(7662),
    [sym_exp_lambda_case] = STATE(603),
    [sym__do_keyword] = STATE(18310),
    [sym_do_module] = STATE(18310),
    [sym_exp_do] = STATE(603),
    [sym_exp_negation] = STATE(7662),
    [sym_exp_record] = STATE(3752),
    [sym_exp_name] = STATE(3752),
    [sym_exp_projection_selector] = STATE(3752),
    [sym__aexp_projection] = STATE(3752),
    [sym_exp_projection] = STATE(3752),
    [sym__aexp] = STATE(603),
    [sym__exp_apply] = STATE(9582),
    [sym__fexp] = STATE(7662),
    [sym__lexp] = STATE(7662),
    [sym_exp_infix] = STATE(7662),
    [sym__exp_infix] = STATE(7662),
    [sym__exp] = STATE(9534),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12563),
    [sym_splice] = STATE(3752),
    [sym_quasiquote] = STATE(3752),
    [sym__varid] = ACTIONS(1634),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(1638),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1638),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(1644),
    [sym_implicit_parid] = ACTIONS(1640),
    [sym__conid] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_SQUOTE] = ACTIONS(1651),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1655),
    [anon_sym_AT] = ACTIONS(1657),
    [anon_sym_BSLASH] = ACTIONS(1659),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4089),
    [anon_sym_case] = ACTIONS(1663),
    [anon_sym_mdo] = ACTIONS(1665),
    [anon_sym_do] = ACTIONS(1665),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
  },
  [1414] = {
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = STATE(3595),
    [sym_qualified_variable] = STATE(3595),
    [sym_constructor] = STATE(3473),
    [sym_qualified_constructor] = STATE(3699),
    [sym__qcon] = STATE(3595),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(3752),
    [sym_exp_parens] = STATE(3752),
    [sym_exp_tuple] = STATE(3752),
    [sym_exp_unboxed_tuple] = STATE(3752),
    [sym_exp_unboxed_sum] = STATE(3752),
    [sym_exp_list] = STATE(3752),
    [sym_exp_arithmetic_sequence] = STATE(3752),
    [sym_exp_list_comprehension] = STATE(3752),
    [sym_exp_section_left] = STATE(3752),
    [sym_exp_section_right] = STATE(3752),
    [sym_exp_th_quoted_name] = STATE(3752),
    [sym_exp_type_application] = STATE(603),
    [sym_exp_lambda] = STATE(7662),
    [sym_exp_let] = STATE(17973),
    [sym_exp_let_in] = STATE(7662),
    [sym_exp_cond] = STATE(7662),
    [sym_exp_if_guard] = STATE(7662),
    [sym_exp_case] = STATE(7662),
    [sym_exp_lambda_case] = STATE(603),
    [sym__do_keyword] = STATE(18310),
    [sym_do_module] = STATE(18310),
    [sym_exp_do] = STATE(603),
    [sym_exp_negation] = STATE(7662),
    [sym_exp_record] = STATE(3752),
    [sym_exp_name] = STATE(3752),
    [sym_exp_projection_selector] = STATE(3752),
    [sym__aexp_projection] = STATE(3752),
    [sym_exp_projection] = STATE(3752),
    [sym__aexp] = STATE(603),
    [sym__exp_apply] = STATE(9582),
    [sym__fexp] = STATE(7662),
    [sym__lexp] = STATE(7662),
    [sym_exp_infix] = STATE(7662),
    [sym__exp_infix] = STATE(7662),
    [sym__exp] = STATE(9554),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12563),
    [sym_splice] = STATE(3752),
    [sym_quasiquote] = STATE(3752),
    [sym__varid] = ACTIONS(1634),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(1638),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1638),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(1644),
    [sym_implicit_parid] = ACTIONS(1640),
    [sym__conid] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_SQUOTE] = ACTIONS(1651),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1655),
    [anon_sym_AT] = ACTIONS(1657),
    [anon_sym_BSLASH] = ACTIONS(1659),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4089),
    [anon_sym_case] = ACTIONS(1663),
    [anon_sym_mdo] = ACTIONS(1665),
    [anon_sym_do] = ACTIONS(1665),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
  },
  [1415] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17986),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1416] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18819),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1417] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(14627),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1418] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17991),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1419] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(14639),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1420] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17995),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1421] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(14623),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1422] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18001),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1423] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(14723),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1424] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18005),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1425] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(14748),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1426] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18008),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1427] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(14801),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1428] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18012),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1429] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9869),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9869),
    [sym_exp_cond] = STATE(9869),
    [sym_exp_if_guard] = STATE(9869),
    [sym_exp_case] = STATE(9869),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9869),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9869),
    [sym__lexp] = STATE(9869),
    [sym_exp_infix] = STATE(9869),
    [sym__exp_infix] = STATE(9869),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4139),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1430] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(14837),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1431] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18023),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1432] = {
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(783),
    [sym_variable] = STATE(4615),
    [sym_qualified_variable] = STATE(4615),
    [sym_constructor] = STATE(4335),
    [sym_qualified_constructor] = STATE(4623),
    [sym__qcon] = STATE(4615),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(5187),
    [sym_exp_parens] = STATE(5187),
    [sym_exp_tuple] = STATE(5187),
    [sym_exp_unboxed_tuple] = STATE(5187),
    [sym_exp_unboxed_sum] = STATE(5187),
    [sym_exp_list] = STATE(5187),
    [sym_exp_arithmetic_sequence] = STATE(5187),
    [sym_exp_list_comprehension] = STATE(5187),
    [sym_exp_section_left] = STATE(5187),
    [sym_exp_section_right] = STATE(5187),
    [sym_exp_th_quoted_name] = STATE(5187),
    [sym_exp_type_application] = STATE(935),
    [sym_exp_lambda] = STATE(9110),
    [sym_exp_let] = STATE(18897),
    [sym_exp_let_in] = STATE(9110),
    [sym_exp_cond] = STATE(9110),
    [sym_exp_if_guard] = STATE(9110),
    [sym_exp_case] = STATE(9110),
    [sym_exp_lambda_case] = STATE(935),
    [sym__do_keyword] = STATE(18223),
    [sym_do_module] = STATE(18223),
    [sym_exp_do] = STATE(935),
    [sym_exp_negation] = STATE(9110),
    [sym_exp_record] = STATE(5187),
    [sym_exp_name] = STATE(5187),
    [sym_exp_projection_selector] = STATE(5187),
    [sym__aexp_projection] = STATE(5187),
    [sym_exp_projection] = STATE(5187),
    [sym__aexp] = STATE(935),
    [sym__exp_apply] = STATE(12112),
    [sym__fexp] = STATE(9110),
    [sym__lexp] = STATE(9110),
    [sym_exp_infix] = STATE(9110),
    [sym__exp_infix] = STATE(9110),
    [sym__exp] = STATE(12059),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12699),
    [sym_splice] = STATE(5187),
    [sym_quasiquote] = STATE(5187),
    [sym__varid] = ACTIONS(2783),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(2785),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2785),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2787),
    [anon_sym_DASH] = ACTIONS(4141),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [sym_implicit_parid] = ACTIONS(2787),
    [sym__conid] = ACTIONS(4143),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2796),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_BSLASH] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4145),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_mdo] = ACTIONS(2810),
    [anon_sym_do] = ACTIONS(2810),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
  },
  [1433] = {
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(783),
    [sym_variable] = STATE(4615),
    [sym_qualified_variable] = STATE(4615),
    [sym_constructor] = STATE(4335),
    [sym_qualified_constructor] = STATE(4623),
    [sym__qcon] = STATE(4615),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(5187),
    [sym_exp_parens] = STATE(5187),
    [sym_exp_tuple] = STATE(5187),
    [sym_exp_unboxed_tuple] = STATE(5187),
    [sym_exp_unboxed_sum] = STATE(5187),
    [sym_exp_list] = STATE(5187),
    [sym_exp_arithmetic_sequence] = STATE(5187),
    [sym_exp_list_comprehension] = STATE(5187),
    [sym_exp_section_left] = STATE(5187),
    [sym_exp_section_right] = STATE(5187),
    [sym_exp_th_quoted_name] = STATE(5187),
    [sym_exp_type_application] = STATE(935),
    [sym_exp_lambda] = STATE(9110),
    [sym_exp_let] = STATE(18897),
    [sym_exp_let_in] = STATE(9110),
    [sym_exp_cond] = STATE(9110),
    [sym_exp_if_guard] = STATE(9110),
    [sym_exp_case] = STATE(9110),
    [sym_exp_lambda_case] = STATE(935),
    [sym__do_keyword] = STATE(18223),
    [sym_do_module] = STATE(18223),
    [sym_exp_do] = STATE(935),
    [sym_exp_negation] = STATE(9110),
    [sym_exp_record] = STATE(5187),
    [sym_exp_name] = STATE(5187),
    [sym_exp_projection_selector] = STATE(5187),
    [sym__aexp_projection] = STATE(5187),
    [sym_exp_projection] = STATE(5187),
    [sym__aexp] = STATE(935),
    [sym__exp_apply] = STATE(12112),
    [sym__fexp] = STATE(9110),
    [sym__lexp] = STATE(9110),
    [sym_exp_infix] = STATE(9110),
    [sym__exp_infix] = STATE(9110),
    [sym__exp] = STATE(12077),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12699),
    [sym_splice] = STATE(5187),
    [sym_quasiquote] = STATE(5187),
    [sym__varid] = ACTIONS(2783),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(2785),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2785),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2787),
    [anon_sym_DASH] = ACTIONS(4141),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [sym_implicit_parid] = ACTIONS(2787),
    [sym__conid] = ACTIONS(4143),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2796),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_BSLASH] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4145),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_mdo] = ACTIONS(2810),
    [anon_sym_do] = ACTIONS(2810),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
  },
  [1434] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9764),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9764),
    [sym_exp_cond] = STATE(9764),
    [sym_exp_if_guard] = STATE(9764),
    [sym_exp_case] = STATE(9764),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9764),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9764),
    [sym__lexp] = STATE(9764),
    [sym_exp_infix] = STATE(9764),
    [sym__exp_infix] = STATE(9764),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4147),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1435] = {
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(783),
    [sym_variable] = STATE(4615),
    [sym_qualified_variable] = STATE(4615),
    [sym_constructor] = STATE(4335),
    [sym_qualified_constructor] = STATE(4623),
    [sym__qcon] = STATE(4615),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(5187),
    [sym_exp_parens] = STATE(5187),
    [sym_exp_tuple] = STATE(5187),
    [sym_exp_unboxed_tuple] = STATE(5187),
    [sym_exp_unboxed_sum] = STATE(5187),
    [sym_exp_list] = STATE(5187),
    [sym_exp_arithmetic_sequence] = STATE(5187),
    [sym_exp_list_comprehension] = STATE(5187),
    [sym_exp_section_left] = STATE(5187),
    [sym_exp_section_right] = STATE(5187),
    [sym_exp_th_quoted_name] = STATE(5187),
    [sym_exp_type_application] = STATE(935),
    [sym_exp_lambda] = STATE(9110),
    [sym_exp_let] = STATE(18897),
    [sym_exp_let_in] = STATE(9110),
    [sym_exp_cond] = STATE(9110),
    [sym_exp_if_guard] = STATE(9110),
    [sym_exp_case] = STATE(9110),
    [sym_exp_lambda_case] = STATE(935),
    [sym__do_keyword] = STATE(18223),
    [sym_do_module] = STATE(18223),
    [sym_exp_do] = STATE(935),
    [sym_exp_negation] = STATE(9110),
    [sym_exp_record] = STATE(5187),
    [sym_exp_name] = STATE(5187),
    [sym_exp_projection_selector] = STATE(5187),
    [sym__aexp_projection] = STATE(5187),
    [sym_exp_projection] = STATE(5187),
    [sym__aexp] = STATE(935),
    [sym__exp_apply] = STATE(12112),
    [sym__fexp] = STATE(9110),
    [sym__lexp] = STATE(9110),
    [sym_exp_infix] = STATE(9110),
    [sym__exp_infix] = STATE(9110),
    [sym__exp] = STATE(12113),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12699),
    [sym_splice] = STATE(5187),
    [sym_quasiquote] = STATE(5187),
    [sym__varid] = ACTIONS(2783),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(2785),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2785),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2787),
    [anon_sym_DASH] = ACTIONS(4141),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [sym_implicit_parid] = ACTIONS(2787),
    [sym__conid] = ACTIONS(4143),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2796),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_BSLASH] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4145),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_mdo] = ACTIONS(2810),
    [anon_sym_do] = ACTIONS(2810),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
  },
  [1436] = {
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(783),
    [sym_variable] = STATE(4615),
    [sym_qualified_variable] = STATE(4615),
    [sym_constructor] = STATE(4335),
    [sym_qualified_constructor] = STATE(4623),
    [sym__qcon] = STATE(4615),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(5187),
    [sym_exp_parens] = STATE(5187),
    [sym_exp_tuple] = STATE(5187),
    [sym_exp_unboxed_tuple] = STATE(5187),
    [sym_exp_unboxed_sum] = STATE(5187),
    [sym_exp_list] = STATE(5187),
    [sym_exp_arithmetic_sequence] = STATE(5187),
    [sym_exp_list_comprehension] = STATE(5187),
    [sym_exp_section_left] = STATE(5187),
    [sym_exp_section_right] = STATE(5187),
    [sym_exp_th_quoted_name] = STATE(5187),
    [sym_exp_type_application] = STATE(935),
    [sym_exp_lambda] = STATE(9110),
    [sym_exp_let] = STATE(18897),
    [sym_exp_let_in] = STATE(9110),
    [sym_exp_cond] = STATE(9110),
    [sym_exp_if_guard] = STATE(9110),
    [sym_exp_case] = STATE(9110),
    [sym_exp_lambda_case] = STATE(935),
    [sym__do_keyword] = STATE(18223),
    [sym_do_module] = STATE(18223),
    [sym_exp_do] = STATE(935),
    [sym_exp_negation] = STATE(9110),
    [sym_exp_record] = STATE(5187),
    [sym_exp_name] = STATE(5187),
    [sym_exp_projection_selector] = STATE(5187),
    [sym__aexp_projection] = STATE(5187),
    [sym_exp_projection] = STATE(5187),
    [sym__aexp] = STATE(935),
    [sym__exp_apply] = STATE(12112),
    [sym__fexp] = STATE(9110),
    [sym__lexp] = STATE(9110),
    [sym_exp_infix] = STATE(9110),
    [sym__exp_infix] = STATE(9110),
    [sym__exp] = STATE(12123),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12699),
    [sym_splice] = STATE(5187),
    [sym_quasiquote] = STATE(5187),
    [sym__varid] = ACTIONS(2783),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(2785),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2785),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2787),
    [anon_sym_DASH] = ACTIONS(4141),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [sym_implicit_parid] = ACTIONS(2787),
    [sym__conid] = ACTIONS(4143),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2796),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_BSLASH] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4145),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_mdo] = ACTIONS(2810),
    [anon_sym_do] = ACTIONS(2810),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
  },
  [1437] = {
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(783),
    [sym_variable] = STATE(4615),
    [sym_qualified_variable] = STATE(4615),
    [sym_constructor] = STATE(4335),
    [sym_qualified_constructor] = STATE(4623),
    [sym__qcon] = STATE(4615),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(5187),
    [sym_exp_parens] = STATE(5187),
    [sym_exp_tuple] = STATE(5187),
    [sym_exp_unboxed_tuple] = STATE(5187),
    [sym_exp_unboxed_sum] = STATE(5187),
    [sym_exp_list] = STATE(5187),
    [sym_exp_arithmetic_sequence] = STATE(5187),
    [sym_exp_list_comprehension] = STATE(5187),
    [sym_exp_section_left] = STATE(5187),
    [sym_exp_section_right] = STATE(5187),
    [sym_exp_th_quoted_name] = STATE(5187),
    [sym_exp_type_application] = STATE(935),
    [sym_exp_lambda] = STATE(9110),
    [sym_exp_let] = STATE(18897),
    [sym_exp_let_in] = STATE(9110),
    [sym_exp_cond] = STATE(9110),
    [sym_exp_if_guard] = STATE(9110),
    [sym_exp_case] = STATE(9110),
    [sym_exp_lambda_case] = STATE(935),
    [sym__do_keyword] = STATE(18223),
    [sym_do_module] = STATE(18223),
    [sym_exp_do] = STATE(935),
    [sym_exp_negation] = STATE(9110),
    [sym_exp_record] = STATE(5187),
    [sym_exp_name] = STATE(5187),
    [sym_exp_projection_selector] = STATE(5187),
    [sym__aexp_projection] = STATE(5187),
    [sym_exp_projection] = STATE(5187),
    [sym__aexp] = STATE(935),
    [sym__exp_apply] = STATE(12112),
    [sym__fexp] = STATE(9110),
    [sym__lexp] = STATE(9110),
    [sym_exp_infix] = STATE(9110),
    [sym__exp_infix] = STATE(9110),
    [sym__exp] = STATE(12125),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12699),
    [sym_splice] = STATE(5187),
    [sym_quasiquote] = STATE(5187),
    [sym__varid] = ACTIONS(2783),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(2785),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2785),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2787),
    [anon_sym_DASH] = ACTIONS(4141),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [sym_implicit_parid] = ACTIONS(2787),
    [sym__conid] = ACTIONS(4143),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2796),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_BSLASH] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4145),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_mdo] = ACTIONS(2810),
    [anon_sym_do] = ACTIONS(2810),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
  },
  [1438] = {
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(783),
    [sym_variable] = STATE(4615),
    [sym_qualified_variable] = STATE(4615),
    [sym_constructor] = STATE(4335),
    [sym_qualified_constructor] = STATE(4623),
    [sym__qcon] = STATE(4615),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(5187),
    [sym_exp_parens] = STATE(5187),
    [sym_exp_tuple] = STATE(5187),
    [sym_exp_unboxed_tuple] = STATE(5187),
    [sym_exp_unboxed_sum] = STATE(5187),
    [sym_exp_list] = STATE(5187),
    [sym_exp_arithmetic_sequence] = STATE(5187),
    [sym_exp_list_comprehension] = STATE(5187),
    [sym_exp_section_left] = STATE(5187),
    [sym_exp_section_right] = STATE(5187),
    [sym_exp_th_quoted_name] = STATE(5187),
    [sym_exp_type_application] = STATE(935),
    [sym_exp_lambda] = STATE(9110),
    [sym_exp_let] = STATE(18897),
    [sym_exp_let_in] = STATE(9110),
    [sym_exp_cond] = STATE(9110),
    [sym_exp_if_guard] = STATE(9110),
    [sym_exp_case] = STATE(9110),
    [sym_exp_lambda_case] = STATE(935),
    [sym__do_keyword] = STATE(18223),
    [sym_do_module] = STATE(18223),
    [sym_exp_do] = STATE(935),
    [sym_exp_negation] = STATE(9110),
    [sym_exp_record] = STATE(5187),
    [sym_exp_name] = STATE(5187),
    [sym_exp_projection_selector] = STATE(5187),
    [sym__aexp_projection] = STATE(5187),
    [sym_exp_projection] = STATE(5187),
    [sym__aexp] = STATE(935),
    [sym__exp_apply] = STATE(12112),
    [sym__fexp] = STATE(9110),
    [sym__lexp] = STATE(9110),
    [sym_exp_infix] = STATE(9110),
    [sym__exp_infix] = STATE(9110),
    [sym__exp] = STATE(12132),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12699),
    [sym_splice] = STATE(5187),
    [sym_quasiquote] = STATE(5187),
    [sym__varid] = ACTIONS(2783),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(2785),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2785),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2787),
    [anon_sym_DASH] = ACTIONS(4141),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [sym_implicit_parid] = ACTIONS(2787),
    [sym__conid] = ACTIONS(4143),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2796),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_BSLASH] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4145),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_mdo] = ACTIONS(2810),
    [anon_sym_do] = ACTIONS(2810),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
  },
  [1439] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17968),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1440] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9837),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9837),
    [sym_exp_cond] = STATE(9837),
    [sym_exp_if_guard] = STATE(9837),
    [sym_exp_case] = STATE(9837),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9837),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9837),
    [sym__lexp] = STATE(9837),
    [sym_exp_infix] = STATE(9837),
    [sym__exp_infix] = STATE(9837),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4149),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1441] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18033),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1442] = {
    [sym_integer] = STATE(5749),
    [sym__literal] = STATE(5749),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = STATE(5599),
    [sym_qualified_variable] = STATE(5599),
    [sym_constructor] = STATE(5259),
    [sym_qualified_constructor] = STATE(5552),
    [sym__qcon] = STATE(5599),
    [sym_con_unit] = STATE(5749),
    [sym_con_list] = STATE(5749),
    [sym_con_tuple] = STATE(5749),
    [sym_literal] = STATE(5638),
    [sym_exp_parens] = STATE(5638),
    [sym_exp_tuple] = STATE(5638),
    [sym_exp_unboxed_tuple] = STATE(5638),
    [sym_exp_unboxed_sum] = STATE(5638),
    [sym_exp_list] = STATE(5638),
    [sym_exp_arithmetic_sequence] = STATE(5638),
    [sym_exp_list_comprehension] = STATE(5638),
    [sym_exp_section_left] = STATE(5638),
    [sym_exp_section_right] = STATE(5638),
    [sym_exp_th_quoted_name] = STATE(5638),
    [sym_exp_type_application] = STATE(964),
    [sym_exp_lambda] = STATE(9220),
    [sym_exp_let] = STATE(18245),
    [sym_exp_let_in] = STATE(9220),
    [sym_exp_cond] = STATE(9220),
    [sym_exp_if_guard] = STATE(9220),
    [sym_exp_case] = STATE(9220),
    [sym_exp_lambda_case] = STATE(964),
    [sym__do_keyword] = STATE(18319),
    [sym_do_module] = STATE(18319),
    [sym_exp_do] = STATE(964),
    [sym_exp_negation] = STATE(9220),
    [sym_exp_record] = STATE(5638),
    [sym_exp_name] = STATE(5638),
    [sym_exp_projection_selector] = STATE(5638),
    [sym__aexp_projection] = STATE(5638),
    [sym_exp_projection] = STATE(5638),
    [sym__aexp] = STATE(964),
    [sym__exp_apply] = STATE(12426),
    [sym__fexp] = STATE(9220),
    [sym__lexp] = STATE(9220),
    [sym_exp_infix] = STATE(9220),
    [sym__exp_infix] = STATE(9220),
    [sym__exp] = STATE(12296),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12705),
    [sym_splice] = STATE(5638),
    [sym_quasiquote] = STATE(5638),
    [sym__varid] = ACTIONS(2973),
    [sym_float] = ACTIONS(2975),
    [sym_char] = ACTIONS(2975),
    [sym_string] = ACTIONS(2975),
    [sym__integer_literal] = ACTIONS(2977),
    [sym__binary_literal] = ACTIONS(2979),
    [sym__octal_literal] = ACTIONS(2979),
    [sym__hex_literal] = ACTIONS(2979),
    [anon_sym_LPAREN_POUND] = ACTIONS(2981),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2981),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [sym_implicit_parid] = ACTIONS(2983),
    [sym__conid] = ACTIONS(4153),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2998),
    [anon_sym_BSLASH] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4155),
    [anon_sym_case] = ACTIONS(3004),
    [anon_sym_mdo] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_7] = ACTIONS(3008),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3012),
  },
  [1443] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9726),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9726),
    [sym_exp_cond] = STATE(9726),
    [sym_exp_if_guard] = STATE(9726),
    [sym_exp_case] = STATE(9726),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9726),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9726),
    [sym__lexp] = STATE(9726),
    [sym_exp_infix] = STATE(9726),
    [sym__exp_infix] = STATE(9726),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4157),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1444] = {
    [sym_integer] = STATE(5749),
    [sym__literal] = STATE(5749),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = STATE(5599),
    [sym_qualified_variable] = STATE(5599),
    [sym_constructor] = STATE(5259),
    [sym_qualified_constructor] = STATE(5552),
    [sym__qcon] = STATE(5599),
    [sym_con_unit] = STATE(5749),
    [sym_con_list] = STATE(5749),
    [sym_con_tuple] = STATE(5749),
    [sym_literal] = STATE(5638),
    [sym_exp_parens] = STATE(5638),
    [sym_exp_tuple] = STATE(5638),
    [sym_exp_unboxed_tuple] = STATE(5638),
    [sym_exp_unboxed_sum] = STATE(5638),
    [sym_exp_list] = STATE(5638),
    [sym_exp_arithmetic_sequence] = STATE(5638),
    [sym_exp_list_comprehension] = STATE(5638),
    [sym_exp_section_left] = STATE(5638),
    [sym_exp_section_right] = STATE(5638),
    [sym_exp_th_quoted_name] = STATE(5638),
    [sym_exp_type_application] = STATE(964),
    [sym_exp_lambda] = STATE(9220),
    [sym_exp_let] = STATE(18245),
    [sym_exp_let_in] = STATE(9220),
    [sym_exp_cond] = STATE(9220),
    [sym_exp_if_guard] = STATE(9220),
    [sym_exp_case] = STATE(9220),
    [sym_exp_lambda_case] = STATE(964),
    [sym__do_keyword] = STATE(18319),
    [sym_do_module] = STATE(18319),
    [sym_exp_do] = STATE(964),
    [sym_exp_negation] = STATE(9220),
    [sym_exp_record] = STATE(5638),
    [sym_exp_name] = STATE(5638),
    [sym_exp_projection_selector] = STATE(5638),
    [sym__aexp_projection] = STATE(5638),
    [sym_exp_projection] = STATE(5638),
    [sym__aexp] = STATE(964),
    [sym__exp_apply] = STATE(12426),
    [sym__fexp] = STATE(9220),
    [sym__lexp] = STATE(9220),
    [sym_exp_infix] = STATE(9220),
    [sym__exp_infix] = STATE(9220),
    [sym__exp] = STATE(12297),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12705),
    [sym_splice] = STATE(5638),
    [sym_quasiquote] = STATE(5638),
    [sym__varid] = ACTIONS(2973),
    [sym_float] = ACTIONS(2975),
    [sym_char] = ACTIONS(2975),
    [sym_string] = ACTIONS(2975),
    [sym__integer_literal] = ACTIONS(2977),
    [sym__binary_literal] = ACTIONS(2979),
    [sym__octal_literal] = ACTIONS(2979),
    [sym__hex_literal] = ACTIONS(2979),
    [anon_sym_LPAREN_POUND] = ACTIONS(2981),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2981),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [sym_implicit_parid] = ACTIONS(2983),
    [sym__conid] = ACTIONS(4153),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2998),
    [anon_sym_BSLASH] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4155),
    [anon_sym_case] = ACTIONS(3004),
    [anon_sym_mdo] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_7] = ACTIONS(3008),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3012),
  },
  [1445] = {
    [sym_integer] = STATE(5749),
    [sym__literal] = STATE(5749),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = STATE(5599),
    [sym_qualified_variable] = STATE(5599),
    [sym_constructor] = STATE(5259),
    [sym_qualified_constructor] = STATE(5552),
    [sym__qcon] = STATE(5599),
    [sym_con_unit] = STATE(5749),
    [sym_con_list] = STATE(5749),
    [sym_con_tuple] = STATE(5749),
    [sym_literal] = STATE(5638),
    [sym_exp_parens] = STATE(5638),
    [sym_exp_tuple] = STATE(5638),
    [sym_exp_unboxed_tuple] = STATE(5638),
    [sym_exp_unboxed_sum] = STATE(5638),
    [sym_exp_list] = STATE(5638),
    [sym_exp_arithmetic_sequence] = STATE(5638),
    [sym_exp_list_comprehension] = STATE(5638),
    [sym_exp_section_left] = STATE(5638),
    [sym_exp_section_right] = STATE(5638),
    [sym_exp_th_quoted_name] = STATE(5638),
    [sym_exp_type_application] = STATE(964),
    [sym_exp_lambda] = STATE(9220),
    [sym_exp_let] = STATE(18245),
    [sym_exp_let_in] = STATE(9220),
    [sym_exp_cond] = STATE(9220),
    [sym_exp_if_guard] = STATE(9220),
    [sym_exp_case] = STATE(9220),
    [sym_exp_lambda_case] = STATE(964),
    [sym__do_keyword] = STATE(18319),
    [sym_do_module] = STATE(18319),
    [sym_exp_do] = STATE(964),
    [sym_exp_negation] = STATE(9220),
    [sym_exp_record] = STATE(5638),
    [sym_exp_name] = STATE(5638),
    [sym_exp_projection_selector] = STATE(5638),
    [sym__aexp_projection] = STATE(5638),
    [sym_exp_projection] = STATE(5638),
    [sym__aexp] = STATE(964),
    [sym__exp_apply] = STATE(12426),
    [sym__fexp] = STATE(9220),
    [sym__lexp] = STATE(9220),
    [sym_exp_infix] = STATE(9220),
    [sym__exp_infix] = STATE(9220),
    [sym__exp] = STATE(12298),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12705),
    [sym_splice] = STATE(5638),
    [sym_quasiquote] = STATE(5638),
    [sym__varid] = ACTIONS(2973),
    [sym_float] = ACTIONS(2975),
    [sym_char] = ACTIONS(2975),
    [sym_string] = ACTIONS(2975),
    [sym__integer_literal] = ACTIONS(2977),
    [sym__binary_literal] = ACTIONS(2979),
    [sym__octal_literal] = ACTIONS(2979),
    [sym__hex_literal] = ACTIONS(2979),
    [anon_sym_LPAREN_POUND] = ACTIONS(2981),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2981),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [sym_implicit_parid] = ACTIONS(2983),
    [sym__conid] = ACTIONS(4153),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2998),
    [anon_sym_BSLASH] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4155),
    [anon_sym_case] = ACTIONS(3004),
    [anon_sym_mdo] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_7] = ACTIONS(3008),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3012),
  },
  [1446] = {
    [sym_integer] = STATE(5749),
    [sym__literal] = STATE(5749),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = STATE(5599),
    [sym_qualified_variable] = STATE(5599),
    [sym_constructor] = STATE(5259),
    [sym_qualified_constructor] = STATE(5552),
    [sym__qcon] = STATE(5599),
    [sym_con_unit] = STATE(5749),
    [sym_con_list] = STATE(5749),
    [sym_con_tuple] = STATE(5749),
    [sym_literal] = STATE(5638),
    [sym_exp_parens] = STATE(5638),
    [sym_exp_tuple] = STATE(5638),
    [sym_exp_unboxed_tuple] = STATE(5638),
    [sym_exp_unboxed_sum] = STATE(5638),
    [sym_exp_list] = STATE(5638),
    [sym_exp_arithmetic_sequence] = STATE(5638),
    [sym_exp_list_comprehension] = STATE(5638),
    [sym_exp_section_left] = STATE(5638),
    [sym_exp_section_right] = STATE(5638),
    [sym_exp_th_quoted_name] = STATE(5638),
    [sym_exp_type_application] = STATE(964),
    [sym_exp_lambda] = STATE(9220),
    [sym_exp_let] = STATE(18245),
    [sym_exp_let_in] = STATE(9220),
    [sym_exp_cond] = STATE(9220),
    [sym_exp_if_guard] = STATE(9220),
    [sym_exp_case] = STATE(9220),
    [sym_exp_lambda_case] = STATE(964),
    [sym__do_keyword] = STATE(18319),
    [sym_do_module] = STATE(18319),
    [sym_exp_do] = STATE(964),
    [sym_exp_negation] = STATE(9220),
    [sym_exp_record] = STATE(5638),
    [sym_exp_name] = STATE(5638),
    [sym_exp_projection_selector] = STATE(5638),
    [sym__aexp_projection] = STATE(5638),
    [sym_exp_projection] = STATE(5638),
    [sym__aexp] = STATE(964),
    [sym__exp_apply] = STATE(12426),
    [sym__fexp] = STATE(9220),
    [sym__lexp] = STATE(9220),
    [sym_exp_infix] = STATE(9220),
    [sym__exp_infix] = STATE(9220),
    [sym__exp] = STATE(12241),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12705),
    [sym_splice] = STATE(5638),
    [sym_quasiquote] = STATE(5638),
    [sym__varid] = ACTIONS(2973),
    [sym_float] = ACTIONS(2975),
    [sym_char] = ACTIONS(2975),
    [sym_string] = ACTIONS(2975),
    [sym__integer_literal] = ACTIONS(2977),
    [sym__binary_literal] = ACTIONS(2979),
    [sym__octal_literal] = ACTIONS(2979),
    [sym__hex_literal] = ACTIONS(2979),
    [anon_sym_LPAREN_POUND] = ACTIONS(2981),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2981),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [sym_implicit_parid] = ACTIONS(2983),
    [sym__conid] = ACTIONS(4153),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2998),
    [anon_sym_BSLASH] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4155),
    [anon_sym_case] = ACTIONS(3004),
    [anon_sym_mdo] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_7] = ACTIONS(3008),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3012),
  },
  [1447] = {
    [sym_integer] = STATE(4332),
    [sym__literal] = STATE(4332),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(4280),
    [sym_qualified_variable] = STATE(4280),
    [sym_constructor] = STATE(4074),
    [sym_qualified_constructor] = STATE(4305),
    [sym__qcon] = STATE(4280),
    [sym_con_unit] = STATE(4332),
    [sym_con_list] = STATE(4332),
    [sym_con_tuple] = STATE(4332),
    [sym_literal] = STATE(4217),
    [sym_exp_parens] = STATE(4217),
    [sym_exp_tuple] = STATE(4217),
    [sym_exp_unboxed_tuple] = STATE(4217),
    [sym_exp_unboxed_sum] = STATE(4217),
    [sym_exp_list] = STATE(4217),
    [sym_exp_arithmetic_sequence] = STATE(4217),
    [sym_exp_list_comprehension] = STATE(4217),
    [sym_exp_section_left] = STATE(4217),
    [sym_exp_section_right] = STATE(4217),
    [sym_exp_th_quoted_name] = STATE(4217),
    [sym_exp_type_application] = STATE(801),
    [sym_exp_lambda] = STATE(8644),
    [sym_exp_let] = STATE(18577),
    [sym_exp_let_in] = STATE(8644),
    [sym_exp_cond] = STATE(8644),
    [sym_exp_if_guard] = STATE(8644),
    [sym_exp_case] = STATE(8644),
    [sym_exp_lambda_case] = STATE(801),
    [sym__do_keyword] = STATE(18152),
    [sym_do_module] = STATE(18152),
    [sym_exp_do] = STATE(801),
    [sym_exp_negation] = STATE(8644),
    [sym_exp_record] = STATE(4217),
    [sym_exp_name] = STATE(4217),
    [sym_exp_projection_selector] = STATE(4217),
    [sym__aexp_projection] = STATE(4217),
    [sym_exp_projection] = STATE(4217),
    [sym__aexp] = STATE(801),
    [sym__exp_apply] = STATE(11048),
    [sym__fexp] = STATE(8644),
    [sym__lexp] = STATE(8644),
    [sym_exp_infix] = STATE(8644),
    [sym__exp_infix] = STATE(8644),
    [sym__exp] = STATE(11001),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12567),
    [sym_splice] = STATE(4217),
    [sym_quasiquote] = STATE(4217),
    [sym__varid] = ACTIONS(1933),
    [sym_float] = ACTIONS(1935),
    [sym_char] = ACTIONS(1935),
    [sym_string] = ACTIONS(1935),
    [sym__integer_literal] = ACTIONS(1937),
    [sym__binary_literal] = ACTIONS(1939),
    [sym__octal_literal] = ACTIONS(1939),
    [sym__hex_literal] = ACTIONS(1939),
    [anon_sym_LPAREN_POUND] = ACTIONS(1941),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1941),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [sym_implicit_parid] = ACTIONS(1943),
    [sym__conid] = ACTIONS(4161),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1953),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(1959),
    [anon_sym_BSLASH] = ACTIONS(1961),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4163),
    [anon_sym_case] = ACTIONS(1965),
    [anon_sym_mdo] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_7] = ACTIONS(1969),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1973),
  },
  [1448] = {
    [sym_integer] = STATE(5749),
    [sym__literal] = STATE(5749),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = STATE(5599),
    [sym_qualified_variable] = STATE(5599),
    [sym_constructor] = STATE(5259),
    [sym_qualified_constructor] = STATE(5552),
    [sym__qcon] = STATE(5599),
    [sym_con_unit] = STATE(5749),
    [sym_con_list] = STATE(5749),
    [sym_con_tuple] = STATE(5749),
    [sym_literal] = STATE(5638),
    [sym_exp_parens] = STATE(5638),
    [sym_exp_tuple] = STATE(5638),
    [sym_exp_unboxed_tuple] = STATE(5638),
    [sym_exp_unboxed_sum] = STATE(5638),
    [sym_exp_list] = STATE(5638),
    [sym_exp_arithmetic_sequence] = STATE(5638),
    [sym_exp_list_comprehension] = STATE(5638),
    [sym_exp_section_left] = STATE(5638),
    [sym_exp_section_right] = STATE(5638),
    [sym_exp_th_quoted_name] = STATE(5638),
    [sym_exp_type_application] = STATE(964),
    [sym_exp_lambda] = STATE(9220),
    [sym_exp_let] = STATE(18245),
    [sym_exp_let_in] = STATE(9220),
    [sym_exp_cond] = STATE(9220),
    [sym_exp_if_guard] = STATE(9220),
    [sym_exp_case] = STATE(9220),
    [sym_exp_lambda_case] = STATE(964),
    [sym__do_keyword] = STATE(18319),
    [sym_do_module] = STATE(18319),
    [sym_exp_do] = STATE(964),
    [sym_exp_negation] = STATE(9220),
    [sym_exp_record] = STATE(5638),
    [sym_exp_name] = STATE(5638),
    [sym_exp_projection_selector] = STATE(5638),
    [sym__aexp_projection] = STATE(5638),
    [sym_exp_projection] = STATE(5638),
    [sym__aexp] = STATE(964),
    [sym__exp_apply] = STATE(12426),
    [sym__fexp] = STATE(9220),
    [sym__lexp] = STATE(9220),
    [sym_exp_infix] = STATE(9220),
    [sym__exp_infix] = STATE(9220),
    [sym__exp] = STATE(12327),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12705),
    [sym_splice] = STATE(5638),
    [sym_quasiquote] = STATE(5638),
    [sym__varid] = ACTIONS(2973),
    [sym_float] = ACTIONS(2975),
    [sym_char] = ACTIONS(2975),
    [sym_string] = ACTIONS(2975),
    [sym__integer_literal] = ACTIONS(2977),
    [sym__binary_literal] = ACTIONS(2979),
    [sym__octal_literal] = ACTIONS(2979),
    [sym__hex_literal] = ACTIONS(2979),
    [anon_sym_LPAREN_POUND] = ACTIONS(2981),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2981),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [sym_implicit_parid] = ACTIONS(2983),
    [sym__conid] = ACTIONS(4153),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2998),
    [anon_sym_BSLASH] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4155),
    [anon_sym_case] = ACTIONS(3004),
    [anon_sym_mdo] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_7] = ACTIONS(3008),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3012),
  },
  [1449] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9880),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9880),
    [sym_exp_cond] = STATE(9880),
    [sym_exp_if_guard] = STATE(9880),
    [sym_exp_case] = STATE(9880),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9880),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9880),
    [sym__lexp] = STATE(9880),
    [sym_exp_infix] = STATE(9880),
    [sym__exp_infix] = STATE(9880),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4165),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1450] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9821),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9821),
    [sym_exp_cond] = STATE(9821),
    [sym_exp_if_guard] = STATE(9821),
    [sym_exp_case] = STATE(9821),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9821),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9821),
    [sym__lexp] = STATE(9821),
    [sym_exp_infix] = STATE(9821),
    [sym__exp_infix] = STATE(9821),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4167),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1451] = {
    [sym_integer] = STATE(5749),
    [sym__literal] = STATE(5749),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = STATE(5599),
    [sym_qualified_variable] = STATE(5599),
    [sym_constructor] = STATE(5259),
    [sym_qualified_constructor] = STATE(5552),
    [sym__qcon] = STATE(5599),
    [sym_con_unit] = STATE(5749),
    [sym_con_list] = STATE(5749),
    [sym_con_tuple] = STATE(5749),
    [sym_literal] = STATE(5638),
    [sym_exp_parens] = STATE(5638),
    [sym_exp_tuple] = STATE(5638),
    [sym_exp_unboxed_tuple] = STATE(5638),
    [sym_exp_unboxed_sum] = STATE(5638),
    [sym_exp_list] = STATE(5638),
    [sym_exp_arithmetic_sequence] = STATE(5638),
    [sym_exp_list_comprehension] = STATE(5638),
    [sym_exp_section_left] = STATE(5638),
    [sym_exp_section_right] = STATE(5638),
    [sym_exp_th_quoted_name] = STATE(5638),
    [sym_exp_type_application] = STATE(964),
    [sym_exp_lambda] = STATE(9220),
    [sym_exp_let] = STATE(18245),
    [sym_exp_let_in] = STATE(9220),
    [sym_exp_cond] = STATE(9220),
    [sym_exp_if_guard] = STATE(9220),
    [sym_exp_case] = STATE(9220),
    [sym_exp_lambda_case] = STATE(964),
    [sym__do_keyword] = STATE(18319),
    [sym_do_module] = STATE(18319),
    [sym_exp_do] = STATE(964),
    [sym_exp_negation] = STATE(9220),
    [sym_exp_record] = STATE(5638),
    [sym_exp_name] = STATE(5638),
    [sym_exp_projection_selector] = STATE(5638),
    [sym__aexp_projection] = STATE(5638),
    [sym_exp_projection] = STATE(5638),
    [sym__aexp] = STATE(964),
    [sym__exp_apply] = STATE(12426),
    [sym__fexp] = STATE(9220),
    [sym__lexp] = STATE(9220),
    [sym_exp_infix] = STATE(9220),
    [sym__exp_infix] = STATE(9220),
    [sym__exp] = STATE(12350),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12705),
    [sym_splice] = STATE(5638),
    [sym_quasiquote] = STATE(5638),
    [sym__varid] = ACTIONS(2973),
    [sym_float] = ACTIONS(2975),
    [sym_char] = ACTIONS(2975),
    [sym_string] = ACTIONS(2975),
    [sym__integer_literal] = ACTIONS(2977),
    [sym__binary_literal] = ACTIONS(2979),
    [sym__octal_literal] = ACTIONS(2979),
    [sym__hex_literal] = ACTIONS(2979),
    [anon_sym_LPAREN_POUND] = ACTIONS(2981),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2981),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [sym_implicit_parid] = ACTIONS(2983),
    [sym__conid] = ACTIONS(4153),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2998),
    [anon_sym_BSLASH] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4155),
    [anon_sym_case] = ACTIONS(3004),
    [anon_sym_mdo] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_7] = ACTIONS(3008),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3012),
  },
  [1452] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(14942),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1453] = {
    [sym_integer] = STATE(5669),
    [sym__literal] = STATE(5669),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = STATE(5710),
    [sym_qualified_variable] = STATE(5710),
    [sym_constructor] = STATE(5151),
    [sym_qualified_constructor] = STATE(5594),
    [sym__qcon] = STATE(5710),
    [sym_con_unit] = STATE(5669),
    [sym_con_list] = STATE(5669),
    [sym_con_tuple] = STATE(5669),
    [sym_literal] = STATE(5640),
    [sym_exp_parens] = STATE(5640),
    [sym_exp_tuple] = STATE(5640),
    [sym_exp_unboxed_tuple] = STATE(5640),
    [sym_exp_unboxed_sum] = STATE(5640),
    [sym_exp_list] = STATE(5640),
    [sym_exp_arithmetic_sequence] = STATE(5640),
    [sym_exp_list_comprehension] = STATE(5640),
    [sym_exp_section_left] = STATE(5640),
    [sym_exp_section_right] = STATE(5640),
    [sym_exp_th_quoted_name] = STATE(5640),
    [sym_exp_type_application] = STATE(956),
    [sym_exp_lambda] = STATE(9227),
    [sym_exp_let] = STATE(17912),
    [sym_exp_let_in] = STATE(9227),
    [sym_exp_cond] = STATE(9227),
    [sym_exp_if_guard] = STATE(9227),
    [sym_exp_case] = STATE(9227),
    [sym_exp_lambda_case] = STATE(956),
    [sym__do_keyword] = STATE(17914),
    [sym_do_module] = STATE(17914),
    [sym_exp_do] = STATE(956),
    [sym_exp_negation] = STATE(9227),
    [sym_exp_record] = STATE(5640),
    [sym_exp_name] = STATE(5640),
    [sym_exp_projection_selector] = STATE(5640),
    [sym__aexp_projection] = STATE(5640),
    [sym_exp_projection] = STATE(5640),
    [sym__aexp] = STATE(956),
    [sym__exp_apply] = STATE(12238),
    [sym__fexp] = STATE(9227),
    [sym__lexp] = STATE(9227),
    [sym_exp_infix] = STATE(9227),
    [sym__exp_infix] = STATE(9227),
    [sym__exp] = STATE(12258),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12604),
    [sym_splice] = STATE(5640),
    [sym_quasiquote] = STATE(5640),
    [sym__varid] = ACTIONS(2945),
    [sym_float] = ACTIONS(2947),
    [sym_char] = ACTIONS(2947),
    [sym_string] = ACTIONS(2947),
    [sym__integer_literal] = ACTIONS(2949),
    [sym__binary_literal] = ACTIONS(2951),
    [sym__octal_literal] = ACTIONS(2951),
    [sym__hex_literal] = ACTIONS(2951),
    [anon_sym_LPAREN_POUND] = ACTIONS(2953),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2953),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(35),
    [anon_sym_AT] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_7] = ACTIONS(2967),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2969),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2971),
  },
  [1454] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(8211),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(8211),
    [sym_exp_cond] = STATE(8211),
    [sym_exp_if_guard] = STATE(8211),
    [sym_exp_case] = STATE(8211),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(8211),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(8211),
    [sym__lexp] = STATE(8211),
    [sym_exp_infix] = STATE(8211),
    [sym__exp_infix] = STATE(8211),
    [sym__exp] = STATE(10704),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1455] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18039),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1456] = {
    [sym_integer] = STATE(4866),
    [sym__literal] = STATE(4866),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = STATE(5079),
    [sym_qualified_variable] = STATE(5079),
    [sym_constructor] = STATE(4498),
    [sym_qualified_constructor] = STATE(5373),
    [sym__qcon] = STATE(5079),
    [sym_con_unit] = STATE(4866),
    [sym_con_list] = STATE(4866),
    [sym_con_tuple] = STATE(4866),
    [sym_literal] = STATE(5194),
    [sym_exp_parens] = STATE(5194),
    [sym_exp_tuple] = STATE(5194),
    [sym_exp_unboxed_tuple] = STATE(5194),
    [sym_exp_unboxed_sum] = STATE(5194),
    [sym_exp_list] = STATE(5194),
    [sym_exp_arithmetic_sequence] = STATE(5194),
    [sym_exp_list_comprehension] = STATE(5194),
    [sym_exp_section_left] = STATE(5194),
    [sym_exp_section_right] = STATE(5194),
    [sym_exp_th_quoted_name] = STATE(5194),
    [sym_exp_type_application] = STATE(924),
    [sym_exp_lambda] = STATE(9053),
    [sym_exp_let] = STATE(18498),
    [sym_exp_let_in] = STATE(9053),
    [sym_exp_cond] = STATE(9053),
    [sym_exp_if_guard] = STATE(9053),
    [sym_exp_case] = STATE(9053),
    [sym_exp_lambda_case] = STATE(924),
    [sym__do_keyword] = STATE(18413),
    [sym_do_module] = STATE(18413),
    [sym_exp_do] = STATE(924),
    [sym_exp_negation] = STATE(9053),
    [sym_exp_record] = STATE(5194),
    [sym_exp_name] = STATE(5194),
    [sym_exp_projection_selector] = STATE(5194),
    [sym__aexp_projection] = STATE(5194),
    [sym_exp_projection] = STATE(5194),
    [sym__aexp] = STATE(924),
    [sym__exp_apply] = STATE(12053),
    [sym__fexp] = STATE(9053),
    [sym__lexp] = STATE(9053),
    [sym_exp_infix] = STATE(9053),
    [sym__exp_infix] = STATE(9053),
    [sym__exp] = STATE(15301),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12556),
    [sym_splice] = STATE(5194),
    [sym_quasiquote] = STATE(5194),
    [sym__varid] = ACTIONS(2560),
    [sym_float] = ACTIONS(2562),
    [sym_char] = ACTIONS(2562),
    [sym_string] = ACTIONS(2562),
    [sym__integer_literal] = ACTIONS(2564),
    [sym__binary_literal] = ACTIONS(2566),
    [sym__octal_literal] = ACTIONS(2566),
    [sym__hex_literal] = ACTIONS(2566),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4047),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2583),
    [anon_sym_AT] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4049),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_7] = ACTIONS(2595),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2599),
  },
  [1457] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9913),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9913),
    [sym_exp_cond] = STATE(9913),
    [sym_exp_if_guard] = STATE(9913),
    [sym_exp_case] = STATE(9913),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9913),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9913),
    [sym__lexp] = STATE(9913),
    [sym_exp_infix] = STATE(9913),
    [sym__exp_infix] = STATE(9913),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4173),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1458] = {
    [sym_integer] = STATE(4706),
    [sym__literal] = STATE(4706),
    [sym__unboxed_open] = STATE(756),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4233),
    [sym_qualified_constructor] = STATE(4725),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4706),
    [sym_con_list] = STATE(4706),
    [sym_con_tuple] = STATE(4706),
    [sym_literal] = STATE(4663),
    [sym_exp_parens] = STATE(4663),
    [sym_exp_tuple] = STATE(4663),
    [sym_exp_unboxed_tuple] = STATE(4663),
    [sym_exp_unboxed_sum] = STATE(4663),
    [sym_exp_list] = STATE(4663),
    [sym_exp_arithmetic_sequence] = STATE(4663),
    [sym_exp_list_comprehension] = STATE(4663),
    [sym_exp_section_left] = STATE(4663),
    [sym_exp_section_right] = STATE(4663),
    [sym_exp_th_quoted_name] = STATE(4663),
    [sym_exp_type_application] = STATE(870),
    [sym_exp_lambda] = STATE(8796),
    [sym_exp_let] = STATE(18848),
    [sym_exp_let_in] = STATE(8796),
    [sym_exp_cond] = STATE(8796),
    [sym_exp_if_guard] = STATE(8796),
    [sym_exp_case] = STATE(8796),
    [sym_exp_lambda_case] = STATE(870),
    [sym__do_keyword] = STATE(18207),
    [sym_do_module] = STATE(18207),
    [sym_exp_do] = STATE(870),
    [sym_exp_negation] = STATE(8796),
    [sym_exp_record] = STATE(4663),
    [sym_exp_name] = STATE(4663),
    [sym_exp_projection_selector] = STATE(4663),
    [sym__aexp_projection] = STATE(4663),
    [sym_exp_projection] = STATE(4663),
    [sym__aexp] = STATE(870),
    [sym__exp_apply] = STATE(11822),
    [sym__fexp] = STATE(8796),
    [sym__lexp] = STATE(8796),
    [sym_exp_infix] = STATE(8796),
    [sym__exp_infix] = STATE(8796),
    [sym__exp] = STATE(11806),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12713),
    [sym_splice] = STATE(4663),
    [sym_quasiquote] = STATE(4663),
    [sym__varid] = ACTIONS(2350),
    [sym_float] = ACTIONS(2352),
    [sym_char] = ACTIONS(2352),
    [sym_string] = ACTIONS(2352),
    [sym__integer_literal] = ACTIONS(2354),
    [sym__binary_literal] = ACTIONS(2356),
    [sym__octal_literal] = ACTIONS(2356),
    [sym__hex_literal] = ACTIONS(2356),
    [anon_sym_LPAREN_POUND] = ACTIONS(2358),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2358),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [sym_implicit_parid] = ACTIONS(2360),
    [sym__conid] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(2376),
    [anon_sym_BSLASH] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4179),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_mdo] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_7] = ACTIONS(2386),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2390),
  },
  [1459] = {
    [sym_integer] = STATE(4706),
    [sym__literal] = STATE(4706),
    [sym__unboxed_open] = STATE(756),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4233),
    [sym_qualified_constructor] = STATE(4725),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4706),
    [sym_con_list] = STATE(4706),
    [sym_con_tuple] = STATE(4706),
    [sym_literal] = STATE(4663),
    [sym_exp_parens] = STATE(4663),
    [sym_exp_tuple] = STATE(4663),
    [sym_exp_unboxed_tuple] = STATE(4663),
    [sym_exp_unboxed_sum] = STATE(4663),
    [sym_exp_list] = STATE(4663),
    [sym_exp_arithmetic_sequence] = STATE(4663),
    [sym_exp_list_comprehension] = STATE(4663),
    [sym_exp_section_left] = STATE(4663),
    [sym_exp_section_right] = STATE(4663),
    [sym_exp_th_quoted_name] = STATE(4663),
    [sym_exp_type_application] = STATE(870),
    [sym_exp_lambda] = STATE(8796),
    [sym_exp_let] = STATE(18848),
    [sym_exp_let_in] = STATE(8796),
    [sym_exp_cond] = STATE(8796),
    [sym_exp_if_guard] = STATE(8796),
    [sym_exp_case] = STATE(8796),
    [sym_exp_lambda_case] = STATE(870),
    [sym__do_keyword] = STATE(18207),
    [sym_do_module] = STATE(18207),
    [sym_exp_do] = STATE(870),
    [sym_exp_negation] = STATE(8796),
    [sym_exp_record] = STATE(4663),
    [sym_exp_name] = STATE(4663),
    [sym_exp_projection_selector] = STATE(4663),
    [sym__aexp_projection] = STATE(4663),
    [sym_exp_projection] = STATE(4663),
    [sym__aexp] = STATE(870),
    [sym__exp_apply] = STATE(11822),
    [sym__fexp] = STATE(8796),
    [sym__lexp] = STATE(8796),
    [sym_exp_infix] = STATE(8796),
    [sym__exp_infix] = STATE(8796),
    [sym__exp] = STATE(11797),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12713),
    [sym_splice] = STATE(4663),
    [sym_quasiquote] = STATE(4663),
    [sym__varid] = ACTIONS(2350),
    [sym_float] = ACTIONS(2352),
    [sym_char] = ACTIONS(2352),
    [sym_string] = ACTIONS(2352),
    [sym__integer_literal] = ACTIONS(2354),
    [sym__binary_literal] = ACTIONS(2356),
    [sym__octal_literal] = ACTIONS(2356),
    [sym__hex_literal] = ACTIONS(2356),
    [anon_sym_LPAREN_POUND] = ACTIONS(2358),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2358),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [sym_implicit_parid] = ACTIONS(2360),
    [sym__conid] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(2376),
    [anon_sym_BSLASH] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4179),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_mdo] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_7] = ACTIONS(2386),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2390),
  },
  [1460] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9834),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9834),
    [sym_exp_cond] = STATE(9834),
    [sym_exp_if_guard] = STATE(9834),
    [sym_exp_case] = STATE(9834),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9834),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9834),
    [sym__lexp] = STATE(9834),
    [sym_exp_infix] = STATE(9834),
    [sym__exp_infix] = STATE(9834),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4181),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1461] = {
    [sym_integer] = STATE(4706),
    [sym__literal] = STATE(4706),
    [sym__unboxed_open] = STATE(756),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4233),
    [sym_qualified_constructor] = STATE(4725),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4706),
    [sym_con_list] = STATE(4706),
    [sym_con_tuple] = STATE(4706),
    [sym_literal] = STATE(4663),
    [sym_exp_parens] = STATE(4663),
    [sym_exp_tuple] = STATE(4663),
    [sym_exp_unboxed_tuple] = STATE(4663),
    [sym_exp_unboxed_sum] = STATE(4663),
    [sym_exp_list] = STATE(4663),
    [sym_exp_arithmetic_sequence] = STATE(4663),
    [sym_exp_list_comprehension] = STATE(4663),
    [sym_exp_section_left] = STATE(4663),
    [sym_exp_section_right] = STATE(4663),
    [sym_exp_th_quoted_name] = STATE(4663),
    [sym_exp_type_application] = STATE(870),
    [sym_exp_lambda] = STATE(8796),
    [sym_exp_let] = STATE(18848),
    [sym_exp_let_in] = STATE(8796),
    [sym_exp_cond] = STATE(8796),
    [sym_exp_if_guard] = STATE(8796),
    [sym_exp_case] = STATE(8796),
    [sym_exp_lambda_case] = STATE(870),
    [sym__do_keyword] = STATE(18207),
    [sym_do_module] = STATE(18207),
    [sym_exp_do] = STATE(870),
    [sym_exp_negation] = STATE(8796),
    [sym_exp_record] = STATE(4663),
    [sym_exp_name] = STATE(4663),
    [sym_exp_projection_selector] = STATE(4663),
    [sym__aexp_projection] = STATE(4663),
    [sym_exp_projection] = STATE(4663),
    [sym__aexp] = STATE(870),
    [sym__exp_apply] = STATE(11822),
    [sym__fexp] = STATE(8796),
    [sym__lexp] = STATE(8796),
    [sym_exp_infix] = STATE(8796),
    [sym__exp_infix] = STATE(8796),
    [sym__exp] = STATE(11782),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12713),
    [sym_splice] = STATE(4663),
    [sym_quasiquote] = STATE(4663),
    [sym__varid] = ACTIONS(2350),
    [sym_float] = ACTIONS(2352),
    [sym_char] = ACTIONS(2352),
    [sym_string] = ACTIONS(2352),
    [sym__integer_literal] = ACTIONS(2354),
    [sym__binary_literal] = ACTIONS(2356),
    [sym__octal_literal] = ACTIONS(2356),
    [sym__hex_literal] = ACTIONS(2356),
    [anon_sym_LPAREN_POUND] = ACTIONS(2358),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2358),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [sym_implicit_parid] = ACTIONS(2360),
    [sym__conid] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(2376),
    [anon_sym_BSLASH] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4179),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_mdo] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_7] = ACTIONS(2386),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2390),
  },
  [1462] = {
    [sym_integer] = STATE(4937),
    [sym__literal] = STATE(4937),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = STATE(5329),
    [sym_qualified_variable] = STATE(5329),
    [sym_constructor] = STATE(4661),
    [sym_qualified_constructor] = STATE(5081),
    [sym__qcon] = STATE(5329),
    [sym_con_unit] = STATE(4937),
    [sym_con_list] = STATE(4937),
    [sym_con_tuple] = STATE(4937),
    [sym_literal] = STATE(5477),
    [sym_exp_parens] = STATE(5477),
    [sym_exp_tuple] = STATE(5477),
    [sym_exp_unboxed_tuple] = STATE(5477),
    [sym_exp_unboxed_sum] = STATE(5477),
    [sym_exp_list] = STATE(5477),
    [sym_exp_arithmetic_sequence] = STATE(5477),
    [sym_exp_list_comprehension] = STATE(5477),
    [sym_exp_section_left] = STATE(5477),
    [sym_exp_section_right] = STATE(5477),
    [sym_exp_th_quoted_name] = STATE(5477),
    [sym_exp_type_application] = STATE(917),
    [sym_exp_lambda] = STATE(9065),
    [sym_exp_let] = STATE(17941),
    [sym_exp_let_in] = STATE(9065),
    [sym_exp_cond] = STATE(9065),
    [sym_exp_if_guard] = STATE(9065),
    [sym_exp_case] = STATE(9065),
    [sym_exp_lambda_case] = STATE(917),
    [sym__do_keyword] = STATE(18276),
    [sym_do_module] = STATE(18276),
    [sym_exp_do] = STATE(917),
    [sym_exp_negation] = STATE(9065),
    [sym_exp_record] = STATE(5477),
    [sym_exp_name] = STATE(5477),
    [sym_exp_projection_selector] = STATE(5477),
    [sym__aexp_projection] = STATE(5477),
    [sym_exp_projection] = STATE(5477),
    [sym__aexp] = STATE(917),
    [sym__exp_apply] = STATE(12109),
    [sym__fexp] = STATE(9065),
    [sym__lexp] = STATE(9065),
    [sym_exp_infix] = STATE(9065),
    [sym__exp_infix] = STATE(9065),
    [sym__exp] = STATE(14644),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12628),
    [sym_splice] = STATE(5477),
    [sym_quasiquote] = STATE(5477),
    [sym__varid] = ACTIONS(2733),
    [sym_float] = ACTIONS(2735),
    [sym_char] = ACTIONS(2735),
    [sym_string] = ACTIONS(2735),
    [sym__integer_literal] = ACTIONS(2737),
    [sym__binary_literal] = ACTIONS(2739),
    [sym__octal_literal] = ACTIONS(2739),
    [sym__hex_literal] = ACTIONS(2739),
    [anon_sym_LPAREN_POUND] = ACTIONS(2741),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2741),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(2745),
    [sym_implicit_parid] = ACTIONS(2743),
    [sym__conid] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2759),
    [anon_sym_BSLASH] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4075),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_mdo] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_7] = ACTIONS(2769),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2773),
  },
  [1463] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9880),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9880),
    [sym_exp_cond] = STATE(9880),
    [sym_exp_if_guard] = STATE(9880),
    [sym_exp_case] = STATE(9880),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9880),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9880),
    [sym__lexp] = STATE(9880),
    [sym_exp_infix] = STATE(9880),
    [sym__exp_infix] = STATE(9880),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4183),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1464] = {
    [sym_integer] = STATE(4706),
    [sym__literal] = STATE(4706),
    [sym__unboxed_open] = STATE(756),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4233),
    [sym_qualified_constructor] = STATE(4725),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4706),
    [sym_con_list] = STATE(4706),
    [sym_con_tuple] = STATE(4706),
    [sym_literal] = STATE(4663),
    [sym_exp_parens] = STATE(4663),
    [sym_exp_tuple] = STATE(4663),
    [sym_exp_unboxed_tuple] = STATE(4663),
    [sym_exp_unboxed_sum] = STATE(4663),
    [sym_exp_list] = STATE(4663),
    [sym_exp_arithmetic_sequence] = STATE(4663),
    [sym_exp_list_comprehension] = STATE(4663),
    [sym_exp_section_left] = STATE(4663),
    [sym_exp_section_right] = STATE(4663),
    [sym_exp_th_quoted_name] = STATE(4663),
    [sym_exp_type_application] = STATE(870),
    [sym_exp_lambda] = STATE(8796),
    [sym_exp_let] = STATE(18848),
    [sym_exp_let_in] = STATE(8796),
    [sym_exp_cond] = STATE(8796),
    [sym_exp_if_guard] = STATE(8796),
    [sym_exp_case] = STATE(8796),
    [sym_exp_lambda_case] = STATE(870),
    [sym__do_keyword] = STATE(18207),
    [sym_do_module] = STATE(18207),
    [sym_exp_do] = STATE(870),
    [sym_exp_negation] = STATE(8796),
    [sym_exp_record] = STATE(4663),
    [sym_exp_name] = STATE(4663),
    [sym_exp_projection_selector] = STATE(4663),
    [sym__aexp_projection] = STATE(4663),
    [sym_exp_projection] = STATE(4663),
    [sym__aexp] = STATE(870),
    [sym__exp_apply] = STATE(11822),
    [sym__fexp] = STATE(8796),
    [sym__lexp] = STATE(8796),
    [sym_exp_infix] = STATE(8796),
    [sym__exp_infix] = STATE(8796),
    [sym__exp] = STATE(11779),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12713),
    [sym_splice] = STATE(4663),
    [sym_quasiquote] = STATE(4663),
    [sym__varid] = ACTIONS(2350),
    [sym_float] = ACTIONS(2352),
    [sym_char] = ACTIONS(2352),
    [sym_string] = ACTIONS(2352),
    [sym__integer_literal] = ACTIONS(2354),
    [sym__binary_literal] = ACTIONS(2356),
    [sym__octal_literal] = ACTIONS(2356),
    [sym__hex_literal] = ACTIONS(2356),
    [anon_sym_LPAREN_POUND] = ACTIONS(2358),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2358),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [sym_implicit_parid] = ACTIONS(2360),
    [sym__conid] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(2376),
    [anon_sym_BSLASH] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4179),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_mdo] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_7] = ACTIONS(2386),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2390),
  },
  [1465] = {
    [sym_integer] = STATE(4706),
    [sym__literal] = STATE(4706),
    [sym__unboxed_open] = STATE(756),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4233),
    [sym_qualified_constructor] = STATE(4725),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4706),
    [sym_con_list] = STATE(4706),
    [sym_con_tuple] = STATE(4706),
    [sym_literal] = STATE(4663),
    [sym_exp_parens] = STATE(4663),
    [sym_exp_tuple] = STATE(4663),
    [sym_exp_unboxed_tuple] = STATE(4663),
    [sym_exp_unboxed_sum] = STATE(4663),
    [sym_exp_list] = STATE(4663),
    [sym_exp_arithmetic_sequence] = STATE(4663),
    [sym_exp_list_comprehension] = STATE(4663),
    [sym_exp_section_left] = STATE(4663),
    [sym_exp_section_right] = STATE(4663),
    [sym_exp_th_quoted_name] = STATE(4663),
    [sym_exp_type_application] = STATE(870),
    [sym_exp_lambda] = STATE(8796),
    [sym_exp_let] = STATE(18848),
    [sym_exp_let_in] = STATE(8796),
    [sym_exp_cond] = STATE(8796),
    [sym_exp_if_guard] = STATE(8796),
    [sym_exp_case] = STATE(8796),
    [sym_exp_lambda_case] = STATE(870),
    [sym__do_keyword] = STATE(18207),
    [sym_do_module] = STATE(18207),
    [sym_exp_do] = STATE(870),
    [sym_exp_negation] = STATE(8796),
    [sym_exp_record] = STATE(4663),
    [sym_exp_name] = STATE(4663),
    [sym_exp_projection_selector] = STATE(4663),
    [sym__aexp_projection] = STATE(4663),
    [sym_exp_projection] = STATE(4663),
    [sym__aexp] = STATE(870),
    [sym__exp_apply] = STATE(11822),
    [sym__fexp] = STATE(8796),
    [sym__lexp] = STATE(8796),
    [sym_exp_infix] = STATE(8796),
    [sym__exp_infix] = STATE(8796),
    [sym__exp] = STATE(11777),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12713),
    [sym_splice] = STATE(4663),
    [sym_quasiquote] = STATE(4663),
    [sym__varid] = ACTIONS(2350),
    [sym_float] = ACTIONS(2352),
    [sym_char] = ACTIONS(2352),
    [sym_string] = ACTIONS(2352),
    [sym__integer_literal] = ACTIONS(2354),
    [sym__binary_literal] = ACTIONS(2356),
    [sym__octal_literal] = ACTIONS(2356),
    [sym__hex_literal] = ACTIONS(2356),
    [anon_sym_LPAREN_POUND] = ACTIONS(2358),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2358),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [sym_implicit_parid] = ACTIONS(2360),
    [sym__conid] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(2376),
    [anon_sym_BSLASH] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4179),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_mdo] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_7] = ACTIONS(2386),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2390),
  },
  [1466] = {
    [sym_integer] = STATE(4706),
    [sym__literal] = STATE(4706),
    [sym__unboxed_open] = STATE(756),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4233),
    [sym_qualified_constructor] = STATE(4725),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4706),
    [sym_con_list] = STATE(4706),
    [sym_con_tuple] = STATE(4706),
    [sym_literal] = STATE(4663),
    [sym_exp_parens] = STATE(4663),
    [sym_exp_tuple] = STATE(4663),
    [sym_exp_unboxed_tuple] = STATE(4663),
    [sym_exp_unboxed_sum] = STATE(4663),
    [sym_exp_list] = STATE(4663),
    [sym_exp_arithmetic_sequence] = STATE(4663),
    [sym_exp_list_comprehension] = STATE(4663),
    [sym_exp_section_left] = STATE(4663),
    [sym_exp_section_right] = STATE(4663),
    [sym_exp_th_quoted_name] = STATE(4663),
    [sym_exp_type_application] = STATE(870),
    [sym_exp_lambda] = STATE(8796),
    [sym_exp_let] = STATE(18848),
    [sym_exp_let_in] = STATE(8796),
    [sym_exp_cond] = STATE(8796),
    [sym_exp_if_guard] = STATE(8796),
    [sym_exp_case] = STATE(8796),
    [sym_exp_lambda_case] = STATE(870),
    [sym__do_keyword] = STATE(18207),
    [sym_do_module] = STATE(18207),
    [sym_exp_do] = STATE(870),
    [sym_exp_negation] = STATE(8796),
    [sym_exp_record] = STATE(4663),
    [sym_exp_name] = STATE(4663),
    [sym_exp_projection_selector] = STATE(4663),
    [sym__aexp_projection] = STATE(4663),
    [sym_exp_projection] = STATE(4663),
    [sym__aexp] = STATE(870),
    [sym__exp_apply] = STATE(11822),
    [sym__fexp] = STATE(8796),
    [sym__lexp] = STATE(8796),
    [sym_exp_infix] = STATE(8796),
    [sym__exp_infix] = STATE(8796),
    [sym__exp] = STATE(11776),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12713),
    [sym_splice] = STATE(4663),
    [sym_quasiquote] = STATE(4663),
    [sym__varid] = ACTIONS(2350),
    [sym_float] = ACTIONS(2352),
    [sym_char] = ACTIONS(2352),
    [sym_string] = ACTIONS(2352),
    [sym__integer_literal] = ACTIONS(2354),
    [sym__binary_literal] = ACTIONS(2356),
    [sym__octal_literal] = ACTIONS(2356),
    [sym__hex_literal] = ACTIONS(2356),
    [anon_sym_LPAREN_POUND] = ACTIONS(2358),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2358),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [sym_implicit_parid] = ACTIONS(2360),
    [sym__conid] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(2376),
    [anon_sym_BSLASH] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4179),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_mdo] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_7] = ACTIONS(2386),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2390),
  },
  [1467] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9749),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9749),
    [sym_exp_cond] = STATE(9749),
    [sym_exp_if_guard] = STATE(9749),
    [sym_exp_case] = STATE(9749),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9749),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9749),
    [sym__lexp] = STATE(9749),
    [sym_exp_infix] = STATE(9749),
    [sym__exp_infix] = STATE(9749),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4185),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1468] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9816),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9816),
    [sym_exp_cond] = STATE(9816),
    [sym_exp_if_guard] = STATE(9816),
    [sym_exp_case] = STATE(9816),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9816),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9816),
    [sym__lexp] = STATE(9816),
    [sym_exp_infix] = STATE(9816),
    [sym__exp_infix] = STATE(9816),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4187),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1469] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9725),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9725),
    [sym_exp_cond] = STATE(9725),
    [sym_exp_if_guard] = STATE(9725),
    [sym_exp_case] = STATE(9725),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9725),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9725),
    [sym__lexp] = STATE(9725),
    [sym_exp_infix] = STATE(9725),
    [sym__exp_infix] = STATE(9725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4189),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1470] = {
    [sym_integer] = STATE(4936),
    [sym__literal] = STATE(4936),
    [sym__unboxed_open] = STATE(780),
    [sym_variable] = STATE(5192),
    [sym_qualified_variable] = STATE(5192),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4989),
    [sym__qcon] = STATE(5192),
    [sym_con_unit] = STATE(4936),
    [sym_con_list] = STATE(4936),
    [sym_con_tuple] = STATE(4936),
    [sym_literal] = STATE(5422),
    [sym_exp_parens] = STATE(5422),
    [sym_exp_tuple] = STATE(5422),
    [sym_exp_unboxed_tuple] = STATE(5422),
    [sym_exp_unboxed_sum] = STATE(5422),
    [sym_exp_list] = STATE(5422),
    [sym_exp_arithmetic_sequence] = STATE(5422),
    [sym_exp_list_comprehension] = STATE(5422),
    [sym_exp_section_left] = STATE(5422),
    [sym_exp_section_right] = STATE(5422),
    [sym_exp_th_quoted_name] = STATE(5422),
    [sym_exp_type_application] = STATE(901),
    [sym_exp_lambda] = STATE(9201),
    [sym_exp_let] = STATE(18508),
    [sym_exp_let_in] = STATE(9201),
    [sym_exp_cond] = STATE(9201),
    [sym_exp_if_guard] = STATE(9201),
    [sym_exp_case] = STATE(9201),
    [sym_exp_lambda_case] = STATE(901),
    [sym__do_keyword] = STATE(18325),
    [sym_do_module] = STATE(18325),
    [sym_exp_do] = STATE(901),
    [sym_exp_negation] = STATE(9201),
    [sym_exp_record] = STATE(5422),
    [sym_exp_name] = STATE(5422),
    [sym_exp_projection_selector] = STATE(5422),
    [sym__aexp_projection] = STATE(5422),
    [sym_exp_projection] = STATE(5422),
    [sym__aexp] = STATE(901),
    [sym__exp_apply] = STATE(12038),
    [sym__fexp] = STATE(9201),
    [sym__lexp] = STATE(9201),
    [sym_exp_infix] = STATE(9201),
    [sym__exp_infix] = STATE(9201),
    [sym__exp] = STATE(12048),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12676),
    [sym_splice] = STATE(5422),
    [sym_quasiquote] = STATE(5422),
    [sym__varid] = ACTIONS(2660),
    [sym_float] = ACTIONS(2662),
    [sym_char] = ACTIONS(2662),
    [sym_string] = ACTIONS(2662),
    [sym__integer_literal] = ACTIONS(2664),
    [sym__binary_literal] = ACTIONS(2666),
    [sym__octal_literal] = ACTIONS(2666),
    [sym__hex_literal] = ACTIONS(2666),
    [anon_sym_LPAREN_POUND] = ACTIONS(2668),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2668),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [sym_implicit_parid] = ACTIONS(2670),
    [sym__conid] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2686),
    [anon_sym_BSLASH] = ACTIONS(2688),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4195),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_mdo] = ACTIONS(2694),
    [anon_sym_do] = ACTIONS(2694),
    [anon_sym_7] = ACTIONS(2696),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2698),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2700),
  },
  [1471] = {
    [sym_integer] = STATE(4936),
    [sym__literal] = STATE(4936),
    [sym__unboxed_open] = STATE(780),
    [sym_variable] = STATE(5192),
    [sym_qualified_variable] = STATE(5192),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4989),
    [sym__qcon] = STATE(5192),
    [sym_con_unit] = STATE(4936),
    [sym_con_list] = STATE(4936),
    [sym_con_tuple] = STATE(4936),
    [sym_literal] = STATE(5422),
    [sym_exp_parens] = STATE(5422),
    [sym_exp_tuple] = STATE(5422),
    [sym_exp_unboxed_tuple] = STATE(5422),
    [sym_exp_unboxed_sum] = STATE(5422),
    [sym_exp_list] = STATE(5422),
    [sym_exp_arithmetic_sequence] = STATE(5422),
    [sym_exp_list_comprehension] = STATE(5422),
    [sym_exp_section_left] = STATE(5422),
    [sym_exp_section_right] = STATE(5422),
    [sym_exp_th_quoted_name] = STATE(5422),
    [sym_exp_type_application] = STATE(901),
    [sym_exp_lambda] = STATE(9201),
    [sym_exp_let] = STATE(18508),
    [sym_exp_let_in] = STATE(9201),
    [sym_exp_cond] = STATE(9201),
    [sym_exp_if_guard] = STATE(9201),
    [sym_exp_case] = STATE(9201),
    [sym_exp_lambda_case] = STATE(901),
    [sym__do_keyword] = STATE(18325),
    [sym_do_module] = STATE(18325),
    [sym_exp_do] = STATE(901),
    [sym_exp_negation] = STATE(9201),
    [sym_exp_record] = STATE(5422),
    [sym_exp_name] = STATE(5422),
    [sym_exp_projection_selector] = STATE(5422),
    [sym__aexp_projection] = STATE(5422),
    [sym_exp_projection] = STATE(5422),
    [sym__aexp] = STATE(901),
    [sym__exp_apply] = STATE(12038),
    [sym__fexp] = STATE(9201),
    [sym__lexp] = STATE(9201),
    [sym_exp_infix] = STATE(9201),
    [sym__exp_infix] = STATE(9201),
    [sym__exp] = STATE(12046),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12676),
    [sym_splice] = STATE(5422),
    [sym_quasiquote] = STATE(5422),
    [sym__varid] = ACTIONS(2660),
    [sym_float] = ACTIONS(2662),
    [sym_char] = ACTIONS(2662),
    [sym_string] = ACTIONS(2662),
    [sym__integer_literal] = ACTIONS(2664),
    [sym__binary_literal] = ACTIONS(2666),
    [sym__octal_literal] = ACTIONS(2666),
    [sym__hex_literal] = ACTIONS(2666),
    [anon_sym_LPAREN_POUND] = ACTIONS(2668),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2668),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [sym_implicit_parid] = ACTIONS(2670),
    [sym__conid] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2686),
    [anon_sym_BSLASH] = ACTIONS(2688),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4195),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_mdo] = ACTIONS(2694),
    [anon_sym_do] = ACTIONS(2694),
    [anon_sym_7] = ACTIONS(2696),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2698),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2700),
  },
  [1472] = {
    [sym_integer] = STATE(4936),
    [sym__literal] = STATE(4936),
    [sym__unboxed_open] = STATE(780),
    [sym_variable] = STATE(5192),
    [sym_qualified_variable] = STATE(5192),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4989),
    [sym__qcon] = STATE(5192),
    [sym_con_unit] = STATE(4936),
    [sym_con_list] = STATE(4936),
    [sym_con_tuple] = STATE(4936),
    [sym_literal] = STATE(5422),
    [sym_exp_parens] = STATE(5422),
    [sym_exp_tuple] = STATE(5422),
    [sym_exp_unboxed_tuple] = STATE(5422),
    [sym_exp_unboxed_sum] = STATE(5422),
    [sym_exp_list] = STATE(5422),
    [sym_exp_arithmetic_sequence] = STATE(5422),
    [sym_exp_list_comprehension] = STATE(5422),
    [sym_exp_section_left] = STATE(5422),
    [sym_exp_section_right] = STATE(5422),
    [sym_exp_th_quoted_name] = STATE(5422),
    [sym_exp_type_application] = STATE(901),
    [sym_exp_lambda] = STATE(9201),
    [sym_exp_let] = STATE(18508),
    [sym_exp_let_in] = STATE(9201),
    [sym_exp_cond] = STATE(9201),
    [sym_exp_if_guard] = STATE(9201),
    [sym_exp_case] = STATE(9201),
    [sym_exp_lambda_case] = STATE(901),
    [sym__do_keyword] = STATE(18325),
    [sym_do_module] = STATE(18325),
    [sym_exp_do] = STATE(901),
    [sym_exp_negation] = STATE(9201),
    [sym_exp_record] = STATE(5422),
    [sym_exp_name] = STATE(5422),
    [sym_exp_projection_selector] = STATE(5422),
    [sym__aexp_projection] = STATE(5422),
    [sym_exp_projection] = STATE(5422),
    [sym__aexp] = STATE(901),
    [sym__exp_apply] = STATE(12038),
    [sym__fexp] = STATE(9201),
    [sym__lexp] = STATE(9201),
    [sym_exp_infix] = STATE(9201),
    [sym__exp_infix] = STATE(9201),
    [sym__exp] = STATE(12043),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12676),
    [sym_splice] = STATE(5422),
    [sym_quasiquote] = STATE(5422),
    [sym__varid] = ACTIONS(2660),
    [sym_float] = ACTIONS(2662),
    [sym_char] = ACTIONS(2662),
    [sym_string] = ACTIONS(2662),
    [sym__integer_literal] = ACTIONS(2664),
    [sym__binary_literal] = ACTIONS(2666),
    [sym__octal_literal] = ACTIONS(2666),
    [sym__hex_literal] = ACTIONS(2666),
    [anon_sym_LPAREN_POUND] = ACTIONS(2668),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2668),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [sym_implicit_parid] = ACTIONS(2670),
    [sym__conid] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2686),
    [anon_sym_BSLASH] = ACTIONS(2688),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4195),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_mdo] = ACTIONS(2694),
    [anon_sym_do] = ACTIONS(2694),
    [anon_sym_7] = ACTIONS(2696),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2698),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2700),
  },
  [1473] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9765),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9765),
    [sym_exp_cond] = STATE(9765),
    [sym_exp_if_guard] = STATE(9765),
    [sym_exp_case] = STATE(9765),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9765),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9765),
    [sym__lexp] = STATE(9765),
    [sym_exp_infix] = STATE(9765),
    [sym__exp_infix] = STATE(9765),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4197),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1474] = {
    [sym_integer] = STATE(4936),
    [sym__literal] = STATE(4936),
    [sym__unboxed_open] = STATE(780),
    [sym_variable] = STATE(5192),
    [sym_qualified_variable] = STATE(5192),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4989),
    [sym__qcon] = STATE(5192),
    [sym_con_unit] = STATE(4936),
    [sym_con_list] = STATE(4936),
    [sym_con_tuple] = STATE(4936),
    [sym_literal] = STATE(5422),
    [sym_exp_parens] = STATE(5422),
    [sym_exp_tuple] = STATE(5422),
    [sym_exp_unboxed_tuple] = STATE(5422),
    [sym_exp_unboxed_sum] = STATE(5422),
    [sym_exp_list] = STATE(5422),
    [sym_exp_arithmetic_sequence] = STATE(5422),
    [sym_exp_list_comprehension] = STATE(5422),
    [sym_exp_section_left] = STATE(5422),
    [sym_exp_section_right] = STATE(5422),
    [sym_exp_th_quoted_name] = STATE(5422),
    [sym_exp_type_application] = STATE(901),
    [sym_exp_lambda] = STATE(9201),
    [sym_exp_let] = STATE(18508),
    [sym_exp_let_in] = STATE(9201),
    [sym_exp_cond] = STATE(9201),
    [sym_exp_if_guard] = STATE(9201),
    [sym_exp_case] = STATE(9201),
    [sym_exp_lambda_case] = STATE(901),
    [sym__do_keyword] = STATE(18325),
    [sym_do_module] = STATE(18325),
    [sym_exp_do] = STATE(901),
    [sym_exp_negation] = STATE(9201),
    [sym_exp_record] = STATE(5422),
    [sym_exp_name] = STATE(5422),
    [sym_exp_projection_selector] = STATE(5422),
    [sym__aexp_projection] = STATE(5422),
    [sym_exp_projection] = STATE(5422),
    [sym__aexp] = STATE(901),
    [sym__exp_apply] = STATE(12038),
    [sym__fexp] = STATE(9201),
    [sym__lexp] = STATE(9201),
    [sym_exp_infix] = STATE(9201),
    [sym__exp_infix] = STATE(9201),
    [sym__exp] = STATE(12042),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12676),
    [sym_splice] = STATE(5422),
    [sym_quasiquote] = STATE(5422),
    [sym__varid] = ACTIONS(2660),
    [sym_float] = ACTIONS(2662),
    [sym_char] = ACTIONS(2662),
    [sym_string] = ACTIONS(2662),
    [sym__integer_literal] = ACTIONS(2664),
    [sym__binary_literal] = ACTIONS(2666),
    [sym__octal_literal] = ACTIONS(2666),
    [sym__hex_literal] = ACTIONS(2666),
    [anon_sym_LPAREN_POUND] = ACTIONS(2668),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2668),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [sym_implicit_parid] = ACTIONS(2670),
    [sym__conid] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2686),
    [anon_sym_BSLASH] = ACTIONS(2688),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4195),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_mdo] = ACTIONS(2694),
    [anon_sym_do] = ACTIONS(2694),
    [anon_sym_7] = ACTIONS(2696),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2698),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2700),
  },
  [1475] = {
    [sym_integer] = STATE(4706),
    [sym__literal] = STATE(4706),
    [sym__unboxed_open] = STATE(756),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4233),
    [sym_qualified_constructor] = STATE(4725),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4706),
    [sym_con_list] = STATE(4706),
    [sym_con_tuple] = STATE(4706),
    [sym_literal] = STATE(4663),
    [sym_exp_parens] = STATE(4663),
    [sym_exp_tuple] = STATE(4663),
    [sym_exp_unboxed_tuple] = STATE(4663),
    [sym_exp_unboxed_sum] = STATE(4663),
    [sym_exp_list] = STATE(4663),
    [sym_exp_arithmetic_sequence] = STATE(4663),
    [sym_exp_list_comprehension] = STATE(4663),
    [sym_exp_section_left] = STATE(4663),
    [sym_exp_section_right] = STATE(4663),
    [sym_exp_th_quoted_name] = STATE(4663),
    [sym_exp_type_application] = STATE(870),
    [sym_exp_lambda] = STATE(8920),
    [sym_exp_let] = STATE(18848),
    [sym_exp_let_in] = STATE(8920),
    [sym_exp_cond] = STATE(8920),
    [sym_exp_if_guard] = STATE(8920),
    [sym_exp_case] = STATE(8920),
    [sym_exp_lambda_case] = STATE(870),
    [sym__do_keyword] = STATE(18207),
    [sym_do_module] = STATE(18207),
    [sym_exp_do] = STATE(870),
    [sym_exp_negation] = STATE(8920),
    [sym_exp_record] = STATE(4663),
    [sym_exp_name] = STATE(4663),
    [sym_exp_projection_selector] = STATE(4663),
    [sym__aexp_projection] = STATE(4663),
    [sym_exp_projection] = STATE(4663),
    [sym__aexp] = STATE(870),
    [sym__exp_apply] = STATE(11822),
    [sym__fexp] = STATE(8920),
    [sym__lexp] = STATE(8920),
    [sym_exp_infix] = STATE(8920),
    [sym__exp_infix] = STATE(8920),
    [sym__exp] = STATE(14465),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12713),
    [sym_splice] = STATE(4663),
    [sym_quasiquote] = STATE(4663),
    [sym__varid] = ACTIONS(2350),
    [sym_float] = ACTIONS(2352),
    [sym_char] = ACTIONS(2352),
    [sym_string] = ACTIONS(2352),
    [sym__integer_literal] = ACTIONS(2354),
    [sym__binary_literal] = ACTIONS(2356),
    [sym__octal_literal] = ACTIONS(2356),
    [sym__hex_literal] = ACTIONS(2356),
    [anon_sym_LPAREN_POUND] = ACTIONS(2358),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2358),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [sym_implicit_parid] = ACTIONS(2360),
    [sym__conid] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(2376),
    [anon_sym_BSLASH] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4179),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_mdo] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_7] = ACTIONS(2386),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2390),
  },
  [1476] = {
    [sym_integer] = STATE(4706),
    [sym__literal] = STATE(4706),
    [sym__unboxed_open] = STATE(756),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4233),
    [sym_qualified_constructor] = STATE(4725),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4706),
    [sym_con_list] = STATE(4706),
    [sym_con_tuple] = STATE(4706),
    [sym_literal] = STATE(4663),
    [sym_exp_parens] = STATE(4663),
    [sym_exp_tuple] = STATE(4663),
    [sym_exp_unboxed_tuple] = STATE(4663),
    [sym_exp_unboxed_sum] = STATE(4663),
    [sym_exp_list] = STATE(4663),
    [sym_exp_arithmetic_sequence] = STATE(4663),
    [sym_exp_list_comprehension] = STATE(4663),
    [sym_exp_section_left] = STATE(4663),
    [sym_exp_section_right] = STATE(4663),
    [sym_exp_th_quoted_name] = STATE(4663),
    [sym_exp_type_application] = STATE(870),
    [sym_exp_lambda] = STATE(8796),
    [sym_exp_let] = STATE(18848),
    [sym_exp_let_in] = STATE(8796),
    [sym_exp_cond] = STATE(8796),
    [sym_exp_if_guard] = STATE(8796),
    [sym_exp_case] = STATE(8796),
    [sym_exp_lambda_case] = STATE(870),
    [sym__do_keyword] = STATE(18207),
    [sym_do_module] = STATE(18207),
    [sym_exp_do] = STATE(870),
    [sym_exp_negation] = STATE(8796),
    [sym_exp_record] = STATE(4663),
    [sym_exp_name] = STATE(4663),
    [sym_exp_projection_selector] = STATE(4663),
    [sym__aexp_projection] = STATE(4663),
    [sym_exp_projection] = STATE(4663),
    [sym__aexp] = STATE(870),
    [sym__exp_apply] = STATE(11822),
    [sym__fexp] = STATE(8796),
    [sym__lexp] = STATE(8796),
    [sym_exp_infix] = STATE(8796),
    [sym__exp_infix] = STATE(8796),
    [sym__exp] = STATE(11588),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12713),
    [sym_splice] = STATE(4663),
    [sym_quasiquote] = STATE(4663),
    [sym__varid] = ACTIONS(2350),
    [sym_float] = ACTIONS(2352),
    [sym_char] = ACTIONS(2352),
    [sym_string] = ACTIONS(2352),
    [sym__integer_literal] = ACTIONS(2354),
    [sym__binary_literal] = ACTIONS(2356),
    [sym__octal_literal] = ACTIONS(2356),
    [sym__hex_literal] = ACTIONS(2356),
    [anon_sym_LPAREN_POUND] = ACTIONS(2358),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2358),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [sym_implicit_parid] = ACTIONS(2360),
    [sym__conid] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(2376),
    [anon_sym_BSLASH] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4179),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_mdo] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_7] = ACTIONS(2386),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2390),
  },
  [1477] = {
    [sym_integer] = STATE(4936),
    [sym__literal] = STATE(4936),
    [sym__unboxed_open] = STATE(780),
    [sym_variable] = STATE(5192),
    [sym_qualified_variable] = STATE(5192),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4989),
    [sym__qcon] = STATE(5192),
    [sym_con_unit] = STATE(4936),
    [sym_con_list] = STATE(4936),
    [sym_con_tuple] = STATE(4936),
    [sym_literal] = STATE(5422),
    [sym_exp_parens] = STATE(5422),
    [sym_exp_tuple] = STATE(5422),
    [sym_exp_unboxed_tuple] = STATE(5422),
    [sym_exp_unboxed_sum] = STATE(5422),
    [sym_exp_list] = STATE(5422),
    [sym_exp_arithmetic_sequence] = STATE(5422),
    [sym_exp_list_comprehension] = STATE(5422),
    [sym_exp_section_left] = STATE(5422),
    [sym_exp_section_right] = STATE(5422),
    [sym_exp_th_quoted_name] = STATE(5422),
    [sym_exp_type_application] = STATE(901),
    [sym_exp_lambda] = STATE(9201),
    [sym_exp_let] = STATE(18508),
    [sym_exp_let_in] = STATE(9201),
    [sym_exp_cond] = STATE(9201),
    [sym_exp_if_guard] = STATE(9201),
    [sym_exp_case] = STATE(9201),
    [sym_exp_lambda_case] = STATE(901),
    [sym__do_keyword] = STATE(18325),
    [sym_do_module] = STATE(18325),
    [sym_exp_do] = STATE(901),
    [sym_exp_negation] = STATE(9201),
    [sym_exp_record] = STATE(5422),
    [sym_exp_name] = STATE(5422),
    [sym_exp_projection_selector] = STATE(5422),
    [sym__aexp_projection] = STATE(5422),
    [sym_exp_projection] = STATE(5422),
    [sym__aexp] = STATE(901),
    [sym__exp_apply] = STATE(12038),
    [sym__fexp] = STATE(9201),
    [sym__lexp] = STATE(9201),
    [sym_exp_infix] = STATE(9201),
    [sym__exp_infix] = STATE(9201),
    [sym__exp] = STATE(12017),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12676),
    [sym_splice] = STATE(5422),
    [sym_quasiquote] = STATE(5422),
    [sym__varid] = ACTIONS(2660),
    [sym_float] = ACTIONS(2662),
    [sym_char] = ACTIONS(2662),
    [sym_string] = ACTIONS(2662),
    [sym__integer_literal] = ACTIONS(2664),
    [sym__binary_literal] = ACTIONS(2666),
    [sym__octal_literal] = ACTIONS(2666),
    [sym__hex_literal] = ACTIONS(2666),
    [anon_sym_LPAREN_POUND] = ACTIONS(2668),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2668),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [sym_implicit_parid] = ACTIONS(2670),
    [sym__conid] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2686),
    [anon_sym_BSLASH] = ACTIONS(2688),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4195),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_mdo] = ACTIONS(2694),
    [anon_sym_do] = ACTIONS(2694),
    [anon_sym_7] = ACTIONS(2696),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2698),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2700),
  },
  [1478] = {
    [sym_integer] = STATE(4936),
    [sym__literal] = STATE(4936),
    [sym__unboxed_open] = STATE(780),
    [sym_variable] = STATE(5192),
    [sym_qualified_variable] = STATE(5192),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4989),
    [sym__qcon] = STATE(5192),
    [sym_con_unit] = STATE(4936),
    [sym_con_list] = STATE(4936),
    [sym_con_tuple] = STATE(4936),
    [sym_literal] = STATE(5422),
    [sym_exp_parens] = STATE(5422),
    [sym_exp_tuple] = STATE(5422),
    [sym_exp_unboxed_tuple] = STATE(5422),
    [sym_exp_unboxed_sum] = STATE(5422),
    [sym_exp_list] = STATE(5422),
    [sym_exp_arithmetic_sequence] = STATE(5422),
    [sym_exp_list_comprehension] = STATE(5422),
    [sym_exp_section_left] = STATE(5422),
    [sym_exp_section_right] = STATE(5422),
    [sym_exp_th_quoted_name] = STATE(5422),
    [sym_exp_type_application] = STATE(901),
    [sym_exp_lambda] = STATE(9201),
    [sym_exp_let] = STATE(18508),
    [sym_exp_let_in] = STATE(9201),
    [sym_exp_cond] = STATE(9201),
    [sym_exp_if_guard] = STATE(9201),
    [sym_exp_case] = STATE(9201),
    [sym_exp_lambda_case] = STATE(901),
    [sym__do_keyword] = STATE(18325),
    [sym_do_module] = STATE(18325),
    [sym_exp_do] = STATE(901),
    [sym_exp_negation] = STATE(9201),
    [sym_exp_record] = STATE(5422),
    [sym_exp_name] = STATE(5422),
    [sym_exp_projection_selector] = STATE(5422),
    [sym__aexp_projection] = STATE(5422),
    [sym_exp_projection] = STATE(5422),
    [sym__aexp] = STATE(901),
    [sym__exp_apply] = STATE(12038),
    [sym__fexp] = STATE(9201),
    [sym__lexp] = STATE(9201),
    [sym_exp_infix] = STATE(9201),
    [sym__exp_infix] = STATE(9201),
    [sym__exp] = STATE(11980),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12676),
    [sym_splice] = STATE(5422),
    [sym_quasiquote] = STATE(5422),
    [sym__varid] = ACTIONS(2660),
    [sym_float] = ACTIONS(2662),
    [sym_char] = ACTIONS(2662),
    [sym_string] = ACTIONS(2662),
    [sym__integer_literal] = ACTIONS(2664),
    [sym__binary_literal] = ACTIONS(2666),
    [sym__octal_literal] = ACTIONS(2666),
    [sym__hex_literal] = ACTIONS(2666),
    [anon_sym_LPAREN_POUND] = ACTIONS(2668),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2668),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [sym_implicit_parid] = ACTIONS(2670),
    [sym__conid] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2686),
    [anon_sym_BSLASH] = ACTIONS(2688),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4195),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_mdo] = ACTIONS(2694),
    [anon_sym_do] = ACTIONS(2694),
    [anon_sym_7] = ACTIONS(2696),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2698),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2700),
  },
  [1479] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9717),
    [sym_exp_cond] = STATE(9717),
    [sym_exp_if_guard] = STATE(9717),
    [sym_exp_case] = STATE(9717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9717),
    [sym__lexp] = STATE(9717),
    [sym_exp_infix] = STATE(9717),
    [sym__exp_infix] = STATE(9717),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4199),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1480] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9014),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9014),
    [sym_exp_cond] = STATE(9014),
    [sym_exp_if_guard] = STATE(9014),
    [sym_exp_case] = STATE(9014),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9014),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9014),
    [sym__lexp] = STATE(9014),
    [sym_exp_infix] = STATE(9014),
    [sym__exp_infix] = STATE(9014),
    [sym__exp] = STATE(15352),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1481] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9804),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9804),
    [sym_exp_cond] = STATE(9804),
    [sym_exp_if_guard] = STATE(9804),
    [sym_exp_case] = STATE(9804),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9804),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9804),
    [sym__lexp] = STATE(9804),
    [sym_exp_infix] = STATE(9804),
    [sym__exp_infix] = STATE(9804),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4201),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1482] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9913),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9913),
    [sym_exp_cond] = STATE(9913),
    [sym_exp_if_guard] = STATE(9913),
    [sym_exp_case] = STATE(9913),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9913),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9913),
    [sym__lexp] = STATE(9913),
    [sym_exp_infix] = STATE(9913),
    [sym__exp_infix] = STATE(9913),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4181),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1483] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(17837),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1484] = {
    [sym_integer] = STATE(3980),
    [sym__literal] = STATE(3980),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = STATE(3975),
    [sym_qualified_variable] = STATE(3975),
    [sym_constructor] = STATE(3857),
    [sym_qualified_constructor] = STATE(3915),
    [sym__qcon] = STATE(3975),
    [sym_con_unit] = STATE(3980),
    [sym_con_list] = STATE(3980),
    [sym_con_tuple] = STATE(3980),
    [sym_literal] = STATE(3921),
    [sym_exp_parens] = STATE(3921),
    [sym_exp_tuple] = STATE(3921),
    [sym_exp_unboxed_tuple] = STATE(3921),
    [sym_exp_unboxed_sum] = STATE(3921),
    [sym_exp_list] = STATE(3921),
    [sym_exp_arithmetic_sequence] = STATE(3921),
    [sym_exp_list_comprehension] = STATE(3921),
    [sym_exp_section_left] = STATE(3921),
    [sym_exp_section_right] = STATE(3921),
    [sym_exp_th_quoted_name] = STATE(3921),
    [sym_exp_type_application] = STATE(695),
    [sym_exp_lambda] = STATE(8018),
    [sym_exp_let] = STATE(18820),
    [sym_exp_let_in] = STATE(8018),
    [sym_exp_cond] = STATE(8018),
    [sym_exp_if_guard] = STATE(8018),
    [sym_exp_case] = STATE(8018),
    [sym_exp_lambda_case] = STATE(695),
    [sym__do_keyword] = STATE(18344),
    [sym_do_module] = STATE(18344),
    [sym_exp_do] = STATE(695),
    [sym_exp_negation] = STATE(8018),
    [sym_exp_record] = STATE(3921),
    [sym_exp_name] = STATE(3921),
    [sym_exp_projection_selector] = STATE(3921),
    [sym__aexp_projection] = STATE(3921),
    [sym_exp_projection] = STATE(3921),
    [sym__aexp] = STATE(695),
    [sym__exp_apply] = STATE(9976),
    [sym__fexp] = STATE(8018),
    [sym__lexp] = STATE(8018),
    [sym_exp_infix] = STATE(8018),
    [sym__exp_infix] = STATE(8018),
    [sym__exp] = STATE(10046),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12582),
    [sym_splice] = STATE(3921),
    [sym_quasiquote] = STATE(3921),
    [sym__varid] = ACTIONS(1700),
    [sym_float] = ACTIONS(1702),
    [sym_char] = ACTIONS(1702),
    [sym_string] = ACTIONS(1702),
    [sym__integer_literal] = ACTIONS(1704),
    [sym__binary_literal] = ACTIONS(1706),
    [sym__octal_literal] = ACTIONS(1706),
    [sym__hex_literal] = ACTIONS(1706),
    [anon_sym_LPAREN_POUND] = ACTIONS(1708),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1708),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1710),
    [anon_sym_DASH] = ACTIONS(4203),
    [anon_sym_LPAREN] = ACTIONS(1712),
    [sym_implicit_parid] = ACTIONS(1710),
    [sym__conid] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(1717),
    [anon_sym_SQUOTE] = ACTIONS(1719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(1725),
    [anon_sym_BSLASH] = ACTIONS(1727),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4207),
    [anon_sym_case] = ACTIONS(1731),
    [anon_sym_mdo] = ACTIONS(1733),
    [anon_sym_do] = ACTIONS(1733),
    [anon_sym_7] = ACTIONS(1735),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1739),
  },
  [1485] = {
    [sym_integer] = STATE(3980),
    [sym__literal] = STATE(3980),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = STATE(3975),
    [sym_qualified_variable] = STATE(3975),
    [sym_constructor] = STATE(3857),
    [sym_qualified_constructor] = STATE(3915),
    [sym__qcon] = STATE(3975),
    [sym_con_unit] = STATE(3980),
    [sym_con_list] = STATE(3980),
    [sym_con_tuple] = STATE(3980),
    [sym_literal] = STATE(3921),
    [sym_exp_parens] = STATE(3921),
    [sym_exp_tuple] = STATE(3921),
    [sym_exp_unboxed_tuple] = STATE(3921),
    [sym_exp_unboxed_sum] = STATE(3921),
    [sym_exp_list] = STATE(3921),
    [sym_exp_arithmetic_sequence] = STATE(3921),
    [sym_exp_list_comprehension] = STATE(3921),
    [sym_exp_section_left] = STATE(3921),
    [sym_exp_section_right] = STATE(3921),
    [sym_exp_th_quoted_name] = STATE(3921),
    [sym_exp_type_application] = STATE(695),
    [sym_exp_lambda] = STATE(8018),
    [sym_exp_let] = STATE(18820),
    [sym_exp_let_in] = STATE(8018),
    [sym_exp_cond] = STATE(8018),
    [sym_exp_if_guard] = STATE(8018),
    [sym_exp_case] = STATE(8018),
    [sym_exp_lambda_case] = STATE(695),
    [sym__do_keyword] = STATE(18344),
    [sym_do_module] = STATE(18344),
    [sym_exp_do] = STATE(695),
    [sym_exp_negation] = STATE(8018),
    [sym_exp_record] = STATE(3921),
    [sym_exp_name] = STATE(3921),
    [sym_exp_projection_selector] = STATE(3921),
    [sym__aexp_projection] = STATE(3921),
    [sym_exp_projection] = STATE(3921),
    [sym__aexp] = STATE(695),
    [sym__exp_apply] = STATE(9976),
    [sym__fexp] = STATE(8018),
    [sym__lexp] = STATE(8018),
    [sym_exp_infix] = STATE(8018),
    [sym__exp_infix] = STATE(8018),
    [sym__exp] = STATE(10043),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12582),
    [sym_splice] = STATE(3921),
    [sym_quasiquote] = STATE(3921),
    [sym__varid] = ACTIONS(1700),
    [sym_float] = ACTIONS(1702),
    [sym_char] = ACTIONS(1702),
    [sym_string] = ACTIONS(1702),
    [sym__integer_literal] = ACTIONS(1704),
    [sym__binary_literal] = ACTIONS(1706),
    [sym__octal_literal] = ACTIONS(1706),
    [sym__hex_literal] = ACTIONS(1706),
    [anon_sym_LPAREN_POUND] = ACTIONS(1708),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1708),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1710),
    [anon_sym_DASH] = ACTIONS(4203),
    [anon_sym_LPAREN] = ACTIONS(1712),
    [sym_implicit_parid] = ACTIONS(1710),
    [sym__conid] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(1717),
    [anon_sym_SQUOTE] = ACTIONS(1719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(1725),
    [anon_sym_BSLASH] = ACTIONS(1727),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4207),
    [anon_sym_case] = ACTIONS(1731),
    [anon_sym_mdo] = ACTIONS(1733),
    [anon_sym_do] = ACTIONS(1733),
    [anon_sym_7] = ACTIONS(1735),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1739),
  },
  [1486] = {
    [sym_integer] = STATE(3980),
    [sym__literal] = STATE(3980),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = STATE(3975),
    [sym_qualified_variable] = STATE(3975),
    [sym_constructor] = STATE(3857),
    [sym_qualified_constructor] = STATE(3915),
    [sym__qcon] = STATE(3975),
    [sym_con_unit] = STATE(3980),
    [sym_con_list] = STATE(3980),
    [sym_con_tuple] = STATE(3980),
    [sym_literal] = STATE(3921),
    [sym_exp_parens] = STATE(3921),
    [sym_exp_tuple] = STATE(3921),
    [sym_exp_unboxed_tuple] = STATE(3921),
    [sym_exp_unboxed_sum] = STATE(3921),
    [sym_exp_list] = STATE(3921),
    [sym_exp_arithmetic_sequence] = STATE(3921),
    [sym_exp_list_comprehension] = STATE(3921),
    [sym_exp_section_left] = STATE(3921),
    [sym_exp_section_right] = STATE(3921),
    [sym_exp_th_quoted_name] = STATE(3921),
    [sym_exp_type_application] = STATE(695),
    [sym_exp_lambda] = STATE(8018),
    [sym_exp_let] = STATE(18820),
    [sym_exp_let_in] = STATE(8018),
    [sym_exp_cond] = STATE(8018),
    [sym_exp_if_guard] = STATE(8018),
    [sym_exp_case] = STATE(8018),
    [sym_exp_lambda_case] = STATE(695),
    [sym__do_keyword] = STATE(18344),
    [sym_do_module] = STATE(18344),
    [sym_exp_do] = STATE(695),
    [sym_exp_negation] = STATE(8018),
    [sym_exp_record] = STATE(3921),
    [sym_exp_name] = STATE(3921),
    [sym_exp_projection_selector] = STATE(3921),
    [sym__aexp_projection] = STATE(3921),
    [sym_exp_projection] = STATE(3921),
    [sym__aexp] = STATE(695),
    [sym__exp_apply] = STATE(9976),
    [sym__fexp] = STATE(8018),
    [sym__lexp] = STATE(8018),
    [sym_exp_infix] = STATE(8018),
    [sym__exp_infix] = STATE(8018),
    [sym__exp] = STATE(10038),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12582),
    [sym_splice] = STATE(3921),
    [sym_quasiquote] = STATE(3921),
    [sym__varid] = ACTIONS(1700),
    [sym_float] = ACTIONS(1702),
    [sym_char] = ACTIONS(1702),
    [sym_string] = ACTIONS(1702),
    [sym__integer_literal] = ACTIONS(1704),
    [sym__binary_literal] = ACTIONS(1706),
    [sym__octal_literal] = ACTIONS(1706),
    [sym__hex_literal] = ACTIONS(1706),
    [anon_sym_LPAREN_POUND] = ACTIONS(1708),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1708),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1710),
    [anon_sym_DASH] = ACTIONS(4203),
    [anon_sym_LPAREN] = ACTIONS(1712),
    [sym_implicit_parid] = ACTIONS(1710),
    [sym__conid] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(1717),
    [anon_sym_SQUOTE] = ACTIONS(1719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(1725),
    [anon_sym_BSLASH] = ACTIONS(1727),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4207),
    [anon_sym_case] = ACTIONS(1731),
    [anon_sym_mdo] = ACTIONS(1733),
    [anon_sym_do] = ACTIONS(1733),
    [anon_sym_7] = ACTIONS(1735),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1739),
  },
  [1487] = {
    [sym_integer] = STATE(3980),
    [sym__literal] = STATE(3980),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = STATE(3975),
    [sym_qualified_variable] = STATE(3975),
    [sym_constructor] = STATE(3857),
    [sym_qualified_constructor] = STATE(3915),
    [sym__qcon] = STATE(3975),
    [sym_con_unit] = STATE(3980),
    [sym_con_list] = STATE(3980),
    [sym_con_tuple] = STATE(3980),
    [sym_literal] = STATE(3921),
    [sym_exp_parens] = STATE(3921),
    [sym_exp_tuple] = STATE(3921),
    [sym_exp_unboxed_tuple] = STATE(3921),
    [sym_exp_unboxed_sum] = STATE(3921),
    [sym_exp_list] = STATE(3921),
    [sym_exp_arithmetic_sequence] = STATE(3921),
    [sym_exp_list_comprehension] = STATE(3921),
    [sym_exp_section_left] = STATE(3921),
    [sym_exp_section_right] = STATE(3921),
    [sym_exp_th_quoted_name] = STATE(3921),
    [sym_exp_type_application] = STATE(695),
    [sym_exp_lambda] = STATE(8018),
    [sym_exp_let] = STATE(18820),
    [sym_exp_let_in] = STATE(8018),
    [sym_exp_cond] = STATE(8018),
    [sym_exp_if_guard] = STATE(8018),
    [sym_exp_case] = STATE(8018),
    [sym_exp_lambda_case] = STATE(695),
    [sym__do_keyword] = STATE(18344),
    [sym_do_module] = STATE(18344),
    [sym_exp_do] = STATE(695),
    [sym_exp_negation] = STATE(8018),
    [sym_exp_record] = STATE(3921),
    [sym_exp_name] = STATE(3921),
    [sym_exp_projection_selector] = STATE(3921),
    [sym__aexp_projection] = STATE(3921),
    [sym_exp_projection] = STATE(3921),
    [sym__aexp] = STATE(695),
    [sym__exp_apply] = STATE(9976),
    [sym__fexp] = STATE(8018),
    [sym__lexp] = STATE(8018),
    [sym_exp_infix] = STATE(8018),
    [sym__exp_infix] = STATE(8018),
    [sym__exp] = STATE(10036),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12582),
    [sym_splice] = STATE(3921),
    [sym_quasiquote] = STATE(3921),
    [sym__varid] = ACTIONS(1700),
    [sym_float] = ACTIONS(1702),
    [sym_char] = ACTIONS(1702),
    [sym_string] = ACTIONS(1702),
    [sym__integer_literal] = ACTIONS(1704),
    [sym__binary_literal] = ACTIONS(1706),
    [sym__octal_literal] = ACTIONS(1706),
    [sym__hex_literal] = ACTIONS(1706),
    [anon_sym_LPAREN_POUND] = ACTIONS(1708),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1708),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1710),
    [anon_sym_DASH] = ACTIONS(4203),
    [anon_sym_LPAREN] = ACTIONS(1712),
    [sym_implicit_parid] = ACTIONS(1710),
    [sym__conid] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(1717),
    [anon_sym_SQUOTE] = ACTIONS(1719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(1725),
    [anon_sym_BSLASH] = ACTIONS(1727),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4207),
    [anon_sym_case] = ACTIONS(1731),
    [anon_sym_mdo] = ACTIONS(1733),
    [anon_sym_do] = ACTIONS(1733),
    [anon_sym_7] = ACTIONS(1735),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1739),
  },
  [1488] = {
    [sym_integer] = STATE(4976),
    [sym__literal] = STATE(4976),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = STATE(5481),
    [sym_qualified_variable] = STATE(5481),
    [sym_constructor] = STATE(4552),
    [sym_qualified_constructor] = STATE(5251),
    [sym__qcon] = STATE(5481),
    [sym_con_unit] = STATE(4976),
    [sym_con_list] = STATE(4976),
    [sym_con_tuple] = STATE(4976),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(948),
    [sym_exp_lambda] = STATE(9194),
    [sym_exp_let] = STATE(18616),
    [sym_exp_let_in] = STATE(9194),
    [sym_exp_cond] = STATE(9194),
    [sym_exp_if_guard] = STATE(9194),
    [sym_exp_case] = STATE(9194),
    [sym_exp_lambda_case] = STATE(948),
    [sym__do_keyword] = STATE(18242),
    [sym_do_module] = STATE(18242),
    [sym_exp_do] = STATE(948),
    [sym_exp_negation] = STATE(9194),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(948),
    [sym__exp_apply] = STATE(12137),
    [sym__fexp] = STATE(9194),
    [sym__lexp] = STATE(9194),
    [sym_exp_infix] = STATE(9194),
    [sym__exp_infix] = STATE(9194),
    [sym__exp] = STATE(12224),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12657),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2603),
    [sym_float] = ACTIONS(2605),
    [sym_char] = ACTIONS(2605),
    [sym_string] = ACTIONS(2605),
    [sym__integer_literal] = ACTIONS(2607),
    [sym__binary_literal] = ACTIONS(2609),
    [sym__octal_literal] = ACTIONS(2609),
    [sym__hex_literal] = ACTIONS(2609),
    [anon_sym_LPAREN_POUND] = ACTIONS(2611),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2611),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [sym_implicit_parid] = ACTIONS(2613),
    [sym__conid] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_mdo] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_7] = ACTIONS(2638),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2642),
  },
  [1489] = {
    [sym_integer] = STATE(3980),
    [sym__literal] = STATE(3980),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = STATE(3975),
    [sym_qualified_variable] = STATE(3975),
    [sym_constructor] = STATE(3857),
    [sym_qualified_constructor] = STATE(3915),
    [sym__qcon] = STATE(3975),
    [sym_con_unit] = STATE(3980),
    [sym_con_list] = STATE(3980),
    [sym_con_tuple] = STATE(3980),
    [sym_literal] = STATE(3921),
    [sym_exp_parens] = STATE(3921),
    [sym_exp_tuple] = STATE(3921),
    [sym_exp_unboxed_tuple] = STATE(3921),
    [sym_exp_unboxed_sum] = STATE(3921),
    [sym_exp_list] = STATE(3921),
    [sym_exp_arithmetic_sequence] = STATE(3921),
    [sym_exp_list_comprehension] = STATE(3921),
    [sym_exp_section_left] = STATE(3921),
    [sym_exp_section_right] = STATE(3921),
    [sym_exp_th_quoted_name] = STATE(3921),
    [sym_exp_type_application] = STATE(695),
    [sym_exp_lambda] = STATE(8018),
    [sym_exp_let] = STATE(18820),
    [sym_exp_let_in] = STATE(8018),
    [sym_exp_cond] = STATE(8018),
    [sym_exp_if_guard] = STATE(8018),
    [sym_exp_case] = STATE(8018),
    [sym_exp_lambda_case] = STATE(695),
    [sym__do_keyword] = STATE(18344),
    [sym_do_module] = STATE(18344),
    [sym_exp_do] = STATE(695),
    [sym_exp_negation] = STATE(8018),
    [sym_exp_record] = STATE(3921),
    [sym_exp_name] = STATE(3921),
    [sym_exp_projection_selector] = STATE(3921),
    [sym__aexp_projection] = STATE(3921),
    [sym_exp_projection] = STATE(3921),
    [sym__aexp] = STATE(695),
    [sym__exp_apply] = STATE(9976),
    [sym__fexp] = STATE(8018),
    [sym__lexp] = STATE(8018),
    [sym_exp_infix] = STATE(8018),
    [sym__exp_infix] = STATE(8018),
    [sym__exp] = STATE(10017),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12582),
    [sym_splice] = STATE(3921),
    [sym_quasiquote] = STATE(3921),
    [sym__varid] = ACTIONS(1700),
    [sym_float] = ACTIONS(1702),
    [sym_char] = ACTIONS(1702),
    [sym_string] = ACTIONS(1702),
    [sym__integer_literal] = ACTIONS(1704),
    [sym__binary_literal] = ACTIONS(1706),
    [sym__octal_literal] = ACTIONS(1706),
    [sym__hex_literal] = ACTIONS(1706),
    [anon_sym_LPAREN_POUND] = ACTIONS(1708),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1708),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1710),
    [anon_sym_DASH] = ACTIONS(4203),
    [anon_sym_LPAREN] = ACTIONS(1712),
    [sym_implicit_parid] = ACTIONS(1710),
    [sym__conid] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(1717),
    [anon_sym_SQUOTE] = ACTIONS(1719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(1725),
    [anon_sym_BSLASH] = ACTIONS(1727),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4207),
    [anon_sym_case] = ACTIONS(1731),
    [anon_sym_mdo] = ACTIONS(1733),
    [anon_sym_do] = ACTIONS(1733),
    [anon_sym_7] = ACTIONS(1735),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1739),
  },
  [1490] = {
    [sym_integer] = STATE(4558),
    [sym__literal] = STATE(4558),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = STATE(4824),
    [sym_qualified_variable] = STATE(4824),
    [sym_constructor] = STATE(4319),
    [sym_qualified_constructor] = STATE(4645),
    [sym__qcon] = STATE(4824),
    [sym_con_unit] = STATE(4558),
    [sym_con_list] = STATE(4558),
    [sym_con_tuple] = STATE(4558),
    [sym_literal] = STATE(4778),
    [sym_exp_parens] = STATE(4778),
    [sym_exp_tuple] = STATE(4778),
    [sym_exp_unboxed_tuple] = STATE(4778),
    [sym_exp_unboxed_sum] = STATE(4778),
    [sym_exp_list] = STATE(4778),
    [sym_exp_arithmetic_sequence] = STATE(4778),
    [sym_exp_list_comprehension] = STATE(4778),
    [sym_exp_section_left] = STATE(4778),
    [sym_exp_section_right] = STATE(4778),
    [sym_exp_th_quoted_name] = STATE(4778),
    [sym_exp_type_application] = STATE(875),
    [sym_exp_lambda] = STATE(8797),
    [sym_exp_let] = STATE(18765),
    [sym_exp_let_in] = STATE(8797),
    [sym_exp_cond] = STATE(8797),
    [sym_exp_if_guard] = STATE(8797),
    [sym_exp_case] = STATE(8797),
    [sym_exp_lambda_case] = STATE(875),
    [sym__do_keyword] = STATE(18183),
    [sym_do_module] = STATE(18183),
    [sym_exp_do] = STATE(875),
    [sym_exp_negation] = STATE(8797),
    [sym_exp_record] = STATE(4778),
    [sym_exp_name] = STATE(4778),
    [sym_exp_projection_selector] = STATE(4778),
    [sym__aexp_projection] = STATE(4778),
    [sym_exp_projection] = STATE(4778),
    [sym__aexp] = STATE(875),
    [sym__exp_apply] = STATE(11760),
    [sym__fexp] = STATE(8797),
    [sym__lexp] = STATE(8797),
    [sym_exp_infix] = STATE(8797),
    [sym__exp_infix] = STATE(8797),
    [sym__exp] = STATE(11505),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12688),
    [sym_splice] = STATE(4778),
    [sym_quasiquote] = STATE(4778),
    [sym__varid] = ACTIONS(2407),
    [sym_float] = ACTIONS(2409),
    [sym_char] = ACTIONS(2409),
    [sym_string] = ACTIONS(2409),
    [sym__integer_literal] = ACTIONS(2411),
    [sym__binary_literal] = ACTIONS(2413),
    [sym__octal_literal] = ACTIONS(2413),
    [sym__hex_literal] = ACTIONS(2413),
    [anon_sym_LPAREN_POUND] = ACTIONS(2415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2415),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(4209),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [sym_implicit_parid] = ACTIONS(2417),
    [sym__conid] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2431),
    [anon_sym_AT] = ACTIONS(2433),
    [anon_sym_BSLASH] = ACTIONS(2435),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4213),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_mdo] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_7] = ACTIONS(2443),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2447),
  },
  [1491] = {
    [sym_integer] = STATE(4558),
    [sym__literal] = STATE(4558),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = STATE(4824),
    [sym_qualified_variable] = STATE(4824),
    [sym_constructor] = STATE(4319),
    [sym_qualified_constructor] = STATE(4645),
    [sym__qcon] = STATE(4824),
    [sym_con_unit] = STATE(4558),
    [sym_con_list] = STATE(4558),
    [sym_con_tuple] = STATE(4558),
    [sym_literal] = STATE(4778),
    [sym_exp_parens] = STATE(4778),
    [sym_exp_tuple] = STATE(4778),
    [sym_exp_unboxed_tuple] = STATE(4778),
    [sym_exp_unboxed_sum] = STATE(4778),
    [sym_exp_list] = STATE(4778),
    [sym_exp_arithmetic_sequence] = STATE(4778),
    [sym_exp_list_comprehension] = STATE(4778),
    [sym_exp_section_left] = STATE(4778),
    [sym_exp_section_right] = STATE(4778),
    [sym_exp_th_quoted_name] = STATE(4778),
    [sym_exp_type_application] = STATE(875),
    [sym_exp_lambda] = STATE(8797),
    [sym_exp_let] = STATE(18765),
    [sym_exp_let_in] = STATE(8797),
    [sym_exp_cond] = STATE(8797),
    [sym_exp_if_guard] = STATE(8797),
    [sym_exp_case] = STATE(8797),
    [sym_exp_lambda_case] = STATE(875),
    [sym__do_keyword] = STATE(18183),
    [sym_do_module] = STATE(18183),
    [sym_exp_do] = STATE(875),
    [sym_exp_negation] = STATE(8797),
    [sym_exp_record] = STATE(4778),
    [sym_exp_name] = STATE(4778),
    [sym_exp_projection_selector] = STATE(4778),
    [sym__aexp_projection] = STATE(4778),
    [sym_exp_projection] = STATE(4778),
    [sym__aexp] = STATE(875),
    [sym__exp_apply] = STATE(11760),
    [sym__fexp] = STATE(8797),
    [sym__lexp] = STATE(8797),
    [sym_exp_infix] = STATE(8797),
    [sym__exp_infix] = STATE(8797),
    [sym__exp] = STATE(11657),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12688),
    [sym_splice] = STATE(4778),
    [sym_quasiquote] = STATE(4778),
    [sym__varid] = ACTIONS(2407),
    [sym_float] = ACTIONS(2409),
    [sym_char] = ACTIONS(2409),
    [sym_string] = ACTIONS(2409),
    [sym__integer_literal] = ACTIONS(2411),
    [sym__binary_literal] = ACTIONS(2413),
    [sym__octal_literal] = ACTIONS(2413),
    [sym__hex_literal] = ACTIONS(2413),
    [anon_sym_LPAREN_POUND] = ACTIONS(2415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2415),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(4209),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [sym_implicit_parid] = ACTIONS(2417),
    [sym__conid] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2431),
    [anon_sym_AT] = ACTIONS(2433),
    [anon_sym_BSLASH] = ACTIONS(2435),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4213),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_mdo] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_7] = ACTIONS(2443),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2447),
  },
  [1492] = {
    [sym_integer] = STATE(4558),
    [sym__literal] = STATE(4558),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = STATE(4824),
    [sym_qualified_variable] = STATE(4824),
    [sym_constructor] = STATE(4319),
    [sym_qualified_constructor] = STATE(4645),
    [sym__qcon] = STATE(4824),
    [sym_con_unit] = STATE(4558),
    [sym_con_list] = STATE(4558),
    [sym_con_tuple] = STATE(4558),
    [sym_literal] = STATE(4778),
    [sym_exp_parens] = STATE(4778),
    [sym_exp_tuple] = STATE(4778),
    [sym_exp_unboxed_tuple] = STATE(4778),
    [sym_exp_unboxed_sum] = STATE(4778),
    [sym_exp_list] = STATE(4778),
    [sym_exp_arithmetic_sequence] = STATE(4778),
    [sym_exp_list_comprehension] = STATE(4778),
    [sym_exp_section_left] = STATE(4778),
    [sym_exp_section_right] = STATE(4778),
    [sym_exp_th_quoted_name] = STATE(4778),
    [sym_exp_type_application] = STATE(875),
    [sym_exp_lambda] = STATE(8797),
    [sym_exp_let] = STATE(18765),
    [sym_exp_let_in] = STATE(8797),
    [sym_exp_cond] = STATE(8797),
    [sym_exp_if_guard] = STATE(8797),
    [sym_exp_case] = STATE(8797),
    [sym_exp_lambda_case] = STATE(875),
    [sym__do_keyword] = STATE(18183),
    [sym_do_module] = STATE(18183),
    [sym_exp_do] = STATE(875),
    [sym_exp_negation] = STATE(8797),
    [sym_exp_record] = STATE(4778),
    [sym_exp_name] = STATE(4778),
    [sym_exp_projection_selector] = STATE(4778),
    [sym__aexp_projection] = STATE(4778),
    [sym_exp_projection] = STATE(4778),
    [sym__aexp] = STATE(875),
    [sym__exp_apply] = STATE(11760),
    [sym__fexp] = STATE(8797),
    [sym__lexp] = STATE(8797),
    [sym_exp_infix] = STATE(8797),
    [sym__exp_infix] = STATE(8797),
    [sym__exp] = STATE(11646),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12688),
    [sym_splice] = STATE(4778),
    [sym_quasiquote] = STATE(4778),
    [sym__varid] = ACTIONS(2407),
    [sym_float] = ACTIONS(2409),
    [sym_char] = ACTIONS(2409),
    [sym_string] = ACTIONS(2409),
    [sym__integer_literal] = ACTIONS(2411),
    [sym__binary_literal] = ACTIONS(2413),
    [sym__octal_literal] = ACTIONS(2413),
    [sym__hex_literal] = ACTIONS(2413),
    [anon_sym_LPAREN_POUND] = ACTIONS(2415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2415),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(4209),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [sym_implicit_parid] = ACTIONS(2417),
    [sym__conid] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2431),
    [anon_sym_AT] = ACTIONS(2433),
    [anon_sym_BSLASH] = ACTIONS(2435),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4213),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_mdo] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_7] = ACTIONS(2443),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2447),
  },
  [1493] = {
    [sym_integer] = STATE(4558),
    [sym__literal] = STATE(4558),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = STATE(4824),
    [sym_qualified_variable] = STATE(4824),
    [sym_constructor] = STATE(4319),
    [sym_qualified_constructor] = STATE(4645),
    [sym__qcon] = STATE(4824),
    [sym_con_unit] = STATE(4558),
    [sym_con_list] = STATE(4558),
    [sym_con_tuple] = STATE(4558),
    [sym_literal] = STATE(4778),
    [sym_exp_parens] = STATE(4778),
    [sym_exp_tuple] = STATE(4778),
    [sym_exp_unboxed_tuple] = STATE(4778),
    [sym_exp_unboxed_sum] = STATE(4778),
    [sym_exp_list] = STATE(4778),
    [sym_exp_arithmetic_sequence] = STATE(4778),
    [sym_exp_list_comprehension] = STATE(4778),
    [sym_exp_section_left] = STATE(4778),
    [sym_exp_section_right] = STATE(4778),
    [sym_exp_th_quoted_name] = STATE(4778),
    [sym_exp_type_application] = STATE(875),
    [sym_exp_lambda] = STATE(8797),
    [sym_exp_let] = STATE(18765),
    [sym_exp_let_in] = STATE(8797),
    [sym_exp_cond] = STATE(8797),
    [sym_exp_if_guard] = STATE(8797),
    [sym_exp_case] = STATE(8797),
    [sym_exp_lambda_case] = STATE(875),
    [sym__do_keyword] = STATE(18183),
    [sym_do_module] = STATE(18183),
    [sym_exp_do] = STATE(875),
    [sym_exp_negation] = STATE(8797),
    [sym_exp_record] = STATE(4778),
    [sym_exp_name] = STATE(4778),
    [sym_exp_projection_selector] = STATE(4778),
    [sym__aexp_projection] = STATE(4778),
    [sym_exp_projection] = STATE(4778),
    [sym__aexp] = STATE(875),
    [sym__exp_apply] = STATE(11760),
    [sym__fexp] = STATE(8797),
    [sym__lexp] = STATE(8797),
    [sym_exp_infix] = STATE(8797),
    [sym__exp_infix] = STATE(8797),
    [sym__exp] = STATE(11690),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12688),
    [sym_splice] = STATE(4778),
    [sym_quasiquote] = STATE(4778),
    [sym__varid] = ACTIONS(2407),
    [sym_float] = ACTIONS(2409),
    [sym_char] = ACTIONS(2409),
    [sym_string] = ACTIONS(2409),
    [sym__integer_literal] = ACTIONS(2411),
    [sym__binary_literal] = ACTIONS(2413),
    [sym__octal_literal] = ACTIONS(2413),
    [sym__hex_literal] = ACTIONS(2413),
    [anon_sym_LPAREN_POUND] = ACTIONS(2415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2415),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(4209),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [sym_implicit_parid] = ACTIONS(2417),
    [sym__conid] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2431),
    [anon_sym_AT] = ACTIONS(2433),
    [anon_sym_BSLASH] = ACTIONS(2435),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4213),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_mdo] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_7] = ACTIONS(2443),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2447),
  },
  [1494] = {
    [sym_integer] = STATE(4558),
    [sym__literal] = STATE(4558),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = STATE(4824),
    [sym_qualified_variable] = STATE(4824),
    [sym_constructor] = STATE(4319),
    [sym_qualified_constructor] = STATE(4645),
    [sym__qcon] = STATE(4824),
    [sym_con_unit] = STATE(4558),
    [sym_con_list] = STATE(4558),
    [sym_con_tuple] = STATE(4558),
    [sym_literal] = STATE(4778),
    [sym_exp_parens] = STATE(4778),
    [sym_exp_tuple] = STATE(4778),
    [sym_exp_unboxed_tuple] = STATE(4778),
    [sym_exp_unboxed_sum] = STATE(4778),
    [sym_exp_list] = STATE(4778),
    [sym_exp_arithmetic_sequence] = STATE(4778),
    [sym_exp_list_comprehension] = STATE(4778),
    [sym_exp_section_left] = STATE(4778),
    [sym_exp_section_right] = STATE(4778),
    [sym_exp_th_quoted_name] = STATE(4778),
    [sym_exp_type_application] = STATE(875),
    [sym_exp_lambda] = STATE(8797),
    [sym_exp_let] = STATE(18765),
    [sym_exp_let_in] = STATE(8797),
    [sym_exp_cond] = STATE(8797),
    [sym_exp_if_guard] = STATE(8797),
    [sym_exp_case] = STATE(8797),
    [sym_exp_lambda_case] = STATE(875),
    [sym__do_keyword] = STATE(18183),
    [sym_do_module] = STATE(18183),
    [sym_exp_do] = STATE(875),
    [sym_exp_negation] = STATE(8797),
    [sym_exp_record] = STATE(4778),
    [sym_exp_name] = STATE(4778),
    [sym_exp_projection_selector] = STATE(4778),
    [sym__aexp_projection] = STATE(4778),
    [sym_exp_projection] = STATE(4778),
    [sym__aexp] = STATE(875),
    [sym__exp_apply] = STATE(11760),
    [sym__fexp] = STATE(8797),
    [sym__lexp] = STATE(8797),
    [sym_exp_infix] = STATE(8797),
    [sym__exp_infix] = STATE(8797),
    [sym__exp] = STATE(11642),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12688),
    [sym_splice] = STATE(4778),
    [sym_quasiquote] = STATE(4778),
    [sym__varid] = ACTIONS(2407),
    [sym_float] = ACTIONS(2409),
    [sym_char] = ACTIONS(2409),
    [sym_string] = ACTIONS(2409),
    [sym__integer_literal] = ACTIONS(2411),
    [sym__binary_literal] = ACTIONS(2413),
    [sym__octal_literal] = ACTIONS(2413),
    [sym__hex_literal] = ACTIONS(2413),
    [anon_sym_LPAREN_POUND] = ACTIONS(2415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2415),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(4209),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [sym_implicit_parid] = ACTIONS(2417),
    [sym__conid] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2431),
    [anon_sym_AT] = ACTIONS(2433),
    [anon_sym_BSLASH] = ACTIONS(2435),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4213),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_mdo] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_7] = ACTIONS(2443),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2447),
  },
  [1495] = {
    [sym_integer] = STATE(3980),
    [sym__literal] = STATE(3980),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = STATE(3975),
    [sym_qualified_variable] = STATE(3975),
    [sym_constructor] = STATE(3857),
    [sym_qualified_constructor] = STATE(3915),
    [sym__qcon] = STATE(3975),
    [sym_con_unit] = STATE(3980),
    [sym_con_list] = STATE(3980),
    [sym_con_tuple] = STATE(3980),
    [sym_literal] = STATE(3921),
    [sym_exp_parens] = STATE(3921),
    [sym_exp_tuple] = STATE(3921),
    [sym_exp_unboxed_tuple] = STATE(3921),
    [sym_exp_unboxed_sum] = STATE(3921),
    [sym_exp_list] = STATE(3921),
    [sym_exp_arithmetic_sequence] = STATE(3921),
    [sym_exp_list_comprehension] = STATE(3921),
    [sym_exp_section_left] = STATE(3921),
    [sym_exp_section_right] = STATE(3921),
    [sym_exp_th_quoted_name] = STATE(3921),
    [sym_exp_type_application] = STATE(695),
    [sym_exp_lambda] = STATE(8018),
    [sym_exp_let] = STATE(18820),
    [sym_exp_let_in] = STATE(8018),
    [sym_exp_cond] = STATE(8018),
    [sym_exp_if_guard] = STATE(8018),
    [sym_exp_case] = STATE(8018),
    [sym_exp_lambda_case] = STATE(695),
    [sym__do_keyword] = STATE(18344),
    [sym_do_module] = STATE(18344),
    [sym_exp_do] = STATE(695),
    [sym_exp_negation] = STATE(8018),
    [sym_exp_record] = STATE(3921),
    [sym_exp_name] = STATE(3921),
    [sym_exp_projection_selector] = STATE(3921),
    [sym__aexp_projection] = STATE(3921),
    [sym_exp_projection] = STATE(3921),
    [sym__aexp] = STATE(695),
    [sym__exp_apply] = STATE(9976),
    [sym__fexp] = STATE(8018),
    [sym__lexp] = STATE(8018),
    [sym_exp_infix] = STATE(8018),
    [sym__exp_infix] = STATE(8018),
    [sym__exp] = STATE(10012),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12582),
    [sym_splice] = STATE(3921),
    [sym_quasiquote] = STATE(3921),
    [sym__varid] = ACTIONS(1700),
    [sym_float] = ACTIONS(1702),
    [sym_char] = ACTIONS(1702),
    [sym_string] = ACTIONS(1702),
    [sym__integer_literal] = ACTIONS(1704),
    [sym__binary_literal] = ACTIONS(1706),
    [sym__octal_literal] = ACTIONS(1706),
    [sym__hex_literal] = ACTIONS(1706),
    [anon_sym_LPAREN_POUND] = ACTIONS(1708),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1708),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1710),
    [anon_sym_DASH] = ACTIONS(4203),
    [anon_sym_LPAREN] = ACTIONS(1712),
    [sym_implicit_parid] = ACTIONS(1710),
    [sym__conid] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(1717),
    [anon_sym_SQUOTE] = ACTIONS(1719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(1725),
    [anon_sym_BSLASH] = ACTIONS(1727),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4207),
    [anon_sym_case] = ACTIONS(1731),
    [anon_sym_mdo] = ACTIONS(1733),
    [anon_sym_do] = ACTIONS(1733),
    [anon_sym_7] = ACTIONS(1735),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1739),
  },
  [1496] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9847),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9847),
    [sym_exp_cond] = STATE(9847),
    [sym_exp_if_guard] = STATE(9847),
    [sym_exp_case] = STATE(9847),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9847),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9847),
    [sym__lexp] = STATE(9847),
    [sym_exp_infix] = STATE(9847),
    [sym__exp_infix] = STATE(9847),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4215),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1497] = {
    [sym_integer] = STATE(4558),
    [sym__literal] = STATE(4558),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = STATE(4824),
    [sym_qualified_variable] = STATE(4824),
    [sym_constructor] = STATE(4319),
    [sym_qualified_constructor] = STATE(4645),
    [sym__qcon] = STATE(4824),
    [sym_con_unit] = STATE(4558),
    [sym_con_list] = STATE(4558),
    [sym_con_tuple] = STATE(4558),
    [sym_literal] = STATE(4778),
    [sym_exp_parens] = STATE(4778),
    [sym_exp_tuple] = STATE(4778),
    [sym_exp_unboxed_tuple] = STATE(4778),
    [sym_exp_unboxed_sum] = STATE(4778),
    [sym_exp_list] = STATE(4778),
    [sym_exp_arithmetic_sequence] = STATE(4778),
    [sym_exp_list_comprehension] = STATE(4778),
    [sym_exp_section_left] = STATE(4778),
    [sym_exp_section_right] = STATE(4778),
    [sym_exp_th_quoted_name] = STATE(4778),
    [sym_exp_type_application] = STATE(875),
    [sym_exp_lambda] = STATE(8797),
    [sym_exp_let] = STATE(18765),
    [sym_exp_let_in] = STATE(8797),
    [sym_exp_cond] = STATE(8797),
    [sym_exp_if_guard] = STATE(8797),
    [sym_exp_case] = STATE(8797),
    [sym_exp_lambda_case] = STATE(875),
    [sym__do_keyword] = STATE(18183),
    [sym_do_module] = STATE(18183),
    [sym_exp_do] = STATE(875),
    [sym_exp_negation] = STATE(8797),
    [sym_exp_record] = STATE(4778),
    [sym_exp_name] = STATE(4778),
    [sym_exp_projection_selector] = STATE(4778),
    [sym__aexp_projection] = STATE(4778),
    [sym_exp_projection] = STATE(4778),
    [sym__aexp] = STATE(875),
    [sym__exp_apply] = STATE(11760),
    [sym__fexp] = STATE(8797),
    [sym__lexp] = STATE(8797),
    [sym_exp_infix] = STATE(8797),
    [sym__exp_infix] = STATE(8797),
    [sym__exp] = STATE(11639),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12688),
    [sym_splice] = STATE(4778),
    [sym_quasiquote] = STATE(4778),
    [sym__varid] = ACTIONS(2407),
    [sym_float] = ACTIONS(2409),
    [sym_char] = ACTIONS(2409),
    [sym_string] = ACTIONS(2409),
    [sym__integer_literal] = ACTIONS(2411),
    [sym__binary_literal] = ACTIONS(2413),
    [sym__octal_literal] = ACTIONS(2413),
    [sym__hex_literal] = ACTIONS(2413),
    [anon_sym_LPAREN_POUND] = ACTIONS(2415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2415),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(4209),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [sym_implicit_parid] = ACTIONS(2417),
    [sym__conid] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2431),
    [anon_sym_AT] = ACTIONS(2433),
    [anon_sym_BSLASH] = ACTIONS(2435),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4213),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_mdo] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_7] = ACTIONS(2443),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2447),
  },
  [1498] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9857),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9857),
    [sym_exp_cond] = STATE(9857),
    [sym_exp_if_guard] = STATE(9857),
    [sym_exp_case] = STATE(9857),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9857),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9857),
    [sym__lexp] = STATE(9857),
    [sym_exp_infix] = STATE(9857),
    [sym__exp_infix] = STATE(9857),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4217),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1499] = {
    [sym_integer] = STATE(5669),
    [sym__literal] = STATE(5669),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = STATE(5710),
    [sym_qualified_variable] = STATE(5710),
    [sym_constructor] = STATE(5151),
    [sym_qualified_constructor] = STATE(5594),
    [sym__qcon] = STATE(5710),
    [sym_con_unit] = STATE(5669),
    [sym_con_list] = STATE(5669),
    [sym_con_tuple] = STATE(5669),
    [sym_literal] = STATE(5640),
    [sym_exp_parens] = STATE(5640),
    [sym_exp_tuple] = STATE(5640),
    [sym_exp_unboxed_tuple] = STATE(5640),
    [sym_exp_unboxed_sum] = STATE(5640),
    [sym_exp_list] = STATE(5640),
    [sym_exp_arithmetic_sequence] = STATE(5640),
    [sym_exp_list_comprehension] = STATE(5640),
    [sym_exp_section_left] = STATE(5640),
    [sym_exp_section_right] = STATE(5640),
    [sym_exp_th_quoted_name] = STATE(5640),
    [sym_exp_type_application] = STATE(956),
    [sym_exp_lambda] = STATE(9227),
    [sym_exp_let] = STATE(17912),
    [sym_exp_let_in] = STATE(9227),
    [sym_exp_cond] = STATE(9227),
    [sym_exp_if_guard] = STATE(9227),
    [sym_exp_case] = STATE(9227),
    [sym_exp_lambda_case] = STATE(956),
    [sym__do_keyword] = STATE(17914),
    [sym_do_module] = STATE(17914),
    [sym_exp_do] = STATE(956),
    [sym_exp_negation] = STATE(9227),
    [sym_exp_record] = STATE(5640),
    [sym_exp_name] = STATE(5640),
    [sym_exp_projection_selector] = STATE(5640),
    [sym__aexp_projection] = STATE(5640),
    [sym_exp_projection] = STATE(5640),
    [sym__aexp] = STATE(956),
    [sym__exp_apply] = STATE(12238),
    [sym__fexp] = STATE(9227),
    [sym__lexp] = STATE(9227),
    [sym_exp_infix] = STATE(9227),
    [sym__exp_infix] = STATE(9227),
    [sym__exp] = STATE(12395),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12604),
    [sym_splice] = STATE(5640),
    [sym_quasiquote] = STATE(5640),
    [sym__varid] = ACTIONS(2945),
    [sym_float] = ACTIONS(2947),
    [sym_char] = ACTIONS(2947),
    [sym_string] = ACTIONS(2947),
    [sym__integer_literal] = ACTIONS(2949),
    [sym__binary_literal] = ACTIONS(2951),
    [sym__octal_literal] = ACTIONS(2951),
    [sym__hex_literal] = ACTIONS(2951),
    [anon_sym_LPAREN_POUND] = ACTIONS(2953),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2953),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(35),
    [anon_sym_AT] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_7] = ACTIONS(2967),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2969),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2971),
  },
  [1500] = {
    [sym_integer] = STATE(5669),
    [sym__literal] = STATE(5669),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = STATE(5710),
    [sym_qualified_variable] = STATE(5710),
    [sym_constructor] = STATE(5151),
    [sym_qualified_constructor] = STATE(5594),
    [sym__qcon] = STATE(5710),
    [sym_con_unit] = STATE(5669),
    [sym_con_list] = STATE(5669),
    [sym_con_tuple] = STATE(5669),
    [sym_literal] = STATE(5640),
    [sym_exp_parens] = STATE(5640),
    [sym_exp_tuple] = STATE(5640),
    [sym_exp_unboxed_tuple] = STATE(5640),
    [sym_exp_unboxed_sum] = STATE(5640),
    [sym_exp_list] = STATE(5640),
    [sym_exp_arithmetic_sequence] = STATE(5640),
    [sym_exp_list_comprehension] = STATE(5640),
    [sym_exp_section_left] = STATE(5640),
    [sym_exp_section_right] = STATE(5640),
    [sym_exp_th_quoted_name] = STATE(5640),
    [sym_exp_type_application] = STATE(956),
    [sym_exp_lambda] = STATE(9227),
    [sym_exp_let] = STATE(17912),
    [sym_exp_let_in] = STATE(9227),
    [sym_exp_cond] = STATE(9227),
    [sym_exp_if_guard] = STATE(9227),
    [sym_exp_case] = STATE(9227),
    [sym_exp_lambda_case] = STATE(956),
    [sym__do_keyword] = STATE(17914),
    [sym_do_module] = STATE(17914),
    [sym_exp_do] = STATE(956),
    [sym_exp_negation] = STATE(9227),
    [sym_exp_record] = STATE(5640),
    [sym_exp_name] = STATE(5640),
    [sym_exp_projection_selector] = STATE(5640),
    [sym__aexp_projection] = STATE(5640),
    [sym_exp_projection] = STATE(5640),
    [sym__aexp] = STATE(956),
    [sym__exp_apply] = STATE(12238),
    [sym__fexp] = STATE(9227),
    [sym__lexp] = STATE(9227),
    [sym_exp_infix] = STATE(9227),
    [sym__exp_infix] = STATE(9227),
    [sym__exp] = STATE(12477),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12604),
    [sym_splice] = STATE(5640),
    [sym_quasiquote] = STATE(5640),
    [sym__varid] = ACTIONS(2945),
    [sym_float] = ACTIONS(2947),
    [sym_char] = ACTIONS(2947),
    [sym_string] = ACTIONS(2947),
    [sym__integer_literal] = ACTIONS(2949),
    [sym__binary_literal] = ACTIONS(2951),
    [sym__octal_literal] = ACTIONS(2951),
    [sym__hex_literal] = ACTIONS(2951),
    [anon_sym_LPAREN_POUND] = ACTIONS(2953),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2953),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(35),
    [anon_sym_AT] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_7] = ACTIONS(2967),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2969),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2971),
  },
  [1501] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9913),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9913),
    [sym_exp_cond] = STATE(9913),
    [sym_exp_if_guard] = STATE(9913),
    [sym_exp_case] = STATE(9913),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9913),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9913),
    [sym__lexp] = STATE(9913),
    [sym_exp_infix] = STATE(9913),
    [sym__exp_infix] = STATE(9913),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4219),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1502] = {
    [sym_integer] = STATE(9549),
    [sym__literal] = STATE(9549),
    [sym__unboxed_open] = STATE(98),
    [sym_variable] = STATE(9923),
    [sym_qualified_variable] = STATE(9343),
    [sym_constructor] = STATE(9458),
    [sym_qualified_constructor] = STATE(9525),
    [sym__qcon] = STATE(10113),
    [sym_con_unit] = STATE(9549),
    [sym_con_list] = STATE(9549),
    [sym_con_tuple] = STATE(9549),
    [sym_literal] = STATE(10114),
    [sym_exp_parens] = STATE(9481),
    [sym_exp_tuple] = STATE(9481),
    [sym_exp_unboxed_tuple] = STATE(9481),
    [sym_exp_unboxed_sum] = STATE(9481),
    [sym_exp_list] = STATE(9481),
    [sym_exp_arithmetic_sequence] = STATE(9481),
    [sym_exp_list_comprehension] = STATE(9481),
    [sym_exp_section_left] = STATE(9481),
    [sym_exp_section_right] = STATE(9481),
    [sym_exp_th_quoted_name] = STATE(9481),
    [sym_exp_type_application] = STATE(9563),
    [sym_exp_lambda_case] = STATE(9563),
    [sym__do_keyword] = STATE(18466),
    [sym_do_module] = STATE(18466),
    [sym_exp_do] = STATE(9563),
    [sym_exp_record] = STATE(9481),
    [sym_exp_name] = STATE(9481),
    [sym_exp_projection_selector] = STATE(9481),
    [sym__aexp_projection] = STATE(9481),
    [sym_exp_projection] = STATE(9481),
    [sym__aexp] = STATE(9563),
    [sym_pat_as] = STATE(12511),
    [sym_pat_parens] = STATE(12511),
    [sym_pat_tuple] = STATE(12511),
    [sym_pat_unboxed_tuple] = STATE(12511),
    [sym_pat_unboxed_sum] = STATE(12511),
    [sym_pat_list] = STATE(12511),
    [sym_pat_strict] = STATE(12511),
    [sym_pat_irrefutable] = STATE(12511),
    [sym_pat_name] = STATE(12511),
    [sym__pat_constructor] = STATE(12158),
    [sym_pat_wildcard] = STATE(12511),
    [sym_pat_record] = STATE(12511),
    [sym__apat] = STATE(12511),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12716),
    [sym_splice] = STATE(10115),
    [sym_quasiquote] = STATE(10115),
    [sym__varid] = ACTIONS(4095),
    [sym_float] = ACTIONS(4097),
    [sym_char] = ACTIONS(4097),
    [sym_string] = ACTIONS(4097),
    [sym__integer_literal] = ACTIONS(4099),
    [sym__binary_literal] = ACTIONS(4101),
    [sym__octal_literal] = ACTIONS(4101),
    [sym__hex_literal] = ACTIONS(4101),
    [anon_sym_LPAREN_POUND] = ACTIONS(4221),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4221),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4223),
    [anon_sym_LPAREN] = ACTIONS(4225),
    [anon_sym_RPAREN] = ACTIONS(4109),
    [sym_implicit_parid] = ACTIONS(4223),
    [sym__conid] = ACTIONS(4111),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_SQUOTE] = ACTIONS(4229),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4231),
    [anon_sym_AT] = ACTIONS(4233),
    [anon_sym_BSLASH] = ACTIONS(4235),
    [anon_sym_mdo] = ACTIONS(4237),
    [anon_sym_do] = ACTIONS(4237),
    [anon_sym_7] = ACTIONS(4125),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4127),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4129),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [1503] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9894),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9894),
    [sym_exp_cond] = STATE(9894),
    [sym_exp_if_guard] = STATE(9894),
    [sym_exp_case] = STATE(9894),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9894),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9894),
    [sym__lexp] = STATE(9894),
    [sym_exp_infix] = STATE(9894),
    [sym__exp_infix] = STATE(9894),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4239),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1504] = {
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = STATE(4572),
    [sym_qualified_variable] = STATE(4572),
    [sym_constructor] = STATE(4245),
    [sym_qualified_constructor] = STATE(4556),
    [sym__qcon] = STATE(4572),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4959),
    [sym_exp_parens] = STATE(4959),
    [sym_exp_tuple] = STATE(4959),
    [sym_exp_unboxed_tuple] = STATE(4959),
    [sym_exp_unboxed_sum] = STATE(4959),
    [sym_exp_list] = STATE(4959),
    [sym_exp_arithmetic_sequence] = STATE(4959),
    [sym_exp_list_comprehension] = STATE(4959),
    [sym_exp_section_left] = STATE(4959),
    [sym_exp_section_right] = STATE(4959),
    [sym_exp_th_quoted_name] = STATE(4959),
    [sym_exp_type_application] = STATE(947),
    [sym_exp_lambda] = STATE(9082),
    [sym_exp_let] = STATE(18678),
    [sym_exp_let_in] = STATE(9082),
    [sym_exp_cond] = STATE(9082),
    [sym_exp_if_guard] = STATE(9082),
    [sym_exp_case] = STATE(9082),
    [sym_exp_lambda_case] = STATE(947),
    [sym__do_keyword] = STATE(18401),
    [sym_do_module] = STATE(18401),
    [sym_exp_do] = STATE(947),
    [sym_exp_negation] = STATE(9082),
    [sym_exp_record] = STATE(4959),
    [sym_exp_name] = STATE(4959),
    [sym_exp_projection_selector] = STATE(4959),
    [sym__aexp_projection] = STATE(4959),
    [sym_exp_projection] = STATE(4959),
    [sym__aexp] = STATE(947),
    [sym__exp_apply] = STATE(12092),
    [sym__fexp] = STATE(9082),
    [sym__lexp] = STATE(9082),
    [sym_exp_infix] = STATE(9082),
    [sym__exp_infix] = STATE(9082),
    [sym__exp] = STATE(12008),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12712),
    [sym_splice] = STATE(4959),
    [sym_quasiquote] = STATE(4959),
    [sym__varid] = ACTIONS(2529),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2531),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2531),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [sym_implicit_parid] = ACTIONS(2533),
    [sym__conid] = ACTIONS(4243),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [anon_sym_BSLASH] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4245),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_mdo] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
  },
  [1505] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18381),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1506] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9780),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9780),
    [sym_exp_cond] = STATE(9780),
    [sym_exp_if_guard] = STATE(9780),
    [sym_exp_case] = STATE(9780),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9780),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9780),
    [sym__lexp] = STATE(9780),
    [sym_exp_infix] = STATE(9780),
    [sym__exp_infix] = STATE(9780),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1507] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8312),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8312),
    [sym_exp_cond] = STATE(8312),
    [sym_exp_if_guard] = STATE(8312),
    [sym_exp_case] = STATE(8312),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8312),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8312),
    [sym__lexp] = STATE(8312),
    [sym_exp_infix] = STATE(8312),
    [sym__exp_infix] = STATE(8312),
    [sym__exp] = STATE(10740),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1508] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(797),
    [sym_variable] = STATE(5085),
    [sym_qualified_variable] = STATE(5085),
    [sym_constructor] = STATE(4716),
    [sym_qualified_constructor] = STATE(5006),
    [sym__qcon] = STATE(5085),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(4915),
    [sym_exp_parens] = STATE(4915),
    [sym_exp_tuple] = STATE(4915),
    [sym_exp_unboxed_tuple] = STATE(4915),
    [sym_exp_unboxed_sum] = STATE(4915),
    [sym_exp_list] = STATE(4915),
    [sym_exp_arithmetic_sequence] = STATE(4915),
    [sym_exp_list_comprehension] = STATE(4915),
    [sym_exp_section_left] = STATE(4915),
    [sym_exp_section_right] = STATE(4915),
    [sym_exp_th_quoted_name] = STATE(4915),
    [sym_exp_type_application] = STATE(943),
    [sym_exp_lambda] = STATE(9208),
    [sym_exp_let] = STATE(18386),
    [sym_exp_let_in] = STATE(9208),
    [sym_exp_cond] = STATE(9208),
    [sym_exp_if_guard] = STATE(9208),
    [sym_exp_case] = STATE(9208),
    [sym_exp_lambda_case] = STATE(943),
    [sym__do_keyword] = STATE(18435),
    [sym_do_module] = STATE(18435),
    [sym_exp_do] = STATE(943),
    [sym_exp_negation] = STATE(9208),
    [sym_exp_record] = STATE(4915),
    [sym_exp_name] = STATE(4915),
    [sym_exp_projection_selector] = STATE(4915),
    [sym__aexp_projection] = STATE(4915),
    [sym_exp_projection] = STATE(4915),
    [sym__aexp] = STATE(943),
    [sym__exp_apply] = STATE(12078),
    [sym__fexp] = STATE(9208),
    [sym__lexp] = STATE(9208),
    [sym_exp_infix] = STATE(9208),
    [sym__exp_infix] = STATE(9208),
    [sym__exp] = STATE(12196),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12549),
    [sym_splice] = STATE(4915),
    [sym_quasiquote] = STATE(4915),
    [sym__varid] = ACTIONS(2895),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(2897),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2897),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [sym_implicit_parid] = ACTIONS(1177),
    [sym__conid] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_mdo] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
  },
  [1509] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9765),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9765),
    [sym_exp_cond] = STATE(9765),
    [sym_exp_if_guard] = STATE(9765),
    [sym_exp_case] = STATE(9765),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9765),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9765),
    [sym__lexp] = STATE(9765),
    [sym_exp_infix] = STATE(9765),
    [sym__exp_infix] = STATE(9765),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4249),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1510] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(797),
    [sym_variable] = STATE(5085),
    [sym_qualified_variable] = STATE(5085),
    [sym_constructor] = STATE(4716),
    [sym_qualified_constructor] = STATE(5006),
    [sym__qcon] = STATE(5085),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(4915),
    [sym_exp_parens] = STATE(4915),
    [sym_exp_tuple] = STATE(4915),
    [sym_exp_unboxed_tuple] = STATE(4915),
    [sym_exp_unboxed_sum] = STATE(4915),
    [sym_exp_list] = STATE(4915),
    [sym_exp_arithmetic_sequence] = STATE(4915),
    [sym_exp_list_comprehension] = STATE(4915),
    [sym_exp_section_left] = STATE(4915),
    [sym_exp_section_right] = STATE(4915),
    [sym_exp_th_quoted_name] = STATE(4915),
    [sym_exp_type_application] = STATE(943),
    [sym_exp_lambda] = STATE(9208),
    [sym_exp_let] = STATE(18386),
    [sym_exp_let_in] = STATE(9208),
    [sym_exp_cond] = STATE(9208),
    [sym_exp_if_guard] = STATE(9208),
    [sym_exp_case] = STATE(9208),
    [sym_exp_lambda_case] = STATE(943),
    [sym__do_keyword] = STATE(18435),
    [sym_do_module] = STATE(18435),
    [sym_exp_do] = STATE(943),
    [sym_exp_negation] = STATE(9208),
    [sym_exp_record] = STATE(4915),
    [sym_exp_name] = STATE(4915),
    [sym_exp_projection_selector] = STATE(4915),
    [sym__aexp_projection] = STATE(4915),
    [sym_exp_projection] = STATE(4915),
    [sym__aexp] = STATE(943),
    [sym__exp_apply] = STATE(12078),
    [sym__fexp] = STATE(9208),
    [sym__lexp] = STATE(9208),
    [sym_exp_infix] = STATE(9208),
    [sym__exp_infix] = STATE(9208),
    [sym__exp] = STATE(12172),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12549),
    [sym_splice] = STATE(4915),
    [sym_quasiquote] = STATE(4915),
    [sym__varid] = ACTIONS(2895),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(2897),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2897),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [sym_implicit_parid] = ACTIONS(1177),
    [sym__conid] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_mdo] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
  },
  [1511] = {
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(783),
    [sym_variable] = STATE(4615),
    [sym_qualified_variable] = STATE(4615),
    [sym_constructor] = STATE(4335),
    [sym_qualified_constructor] = STATE(4623),
    [sym__qcon] = STATE(4615),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(5187),
    [sym_exp_parens] = STATE(5187),
    [sym_exp_tuple] = STATE(5187),
    [sym_exp_unboxed_tuple] = STATE(5187),
    [sym_exp_unboxed_sum] = STATE(5187),
    [sym_exp_list] = STATE(5187),
    [sym_exp_arithmetic_sequence] = STATE(5187),
    [sym_exp_list_comprehension] = STATE(5187),
    [sym_exp_section_left] = STATE(5187),
    [sym_exp_section_right] = STATE(5187),
    [sym_exp_th_quoted_name] = STATE(5187),
    [sym_exp_type_application] = STATE(935),
    [sym_exp_lambda] = STATE(9110),
    [sym_exp_let] = STATE(18897),
    [sym_exp_let_in] = STATE(9110),
    [sym_exp_cond] = STATE(9110),
    [sym_exp_if_guard] = STATE(9110),
    [sym_exp_case] = STATE(9110),
    [sym_exp_lambda_case] = STATE(935),
    [sym__do_keyword] = STATE(18223),
    [sym_do_module] = STATE(18223),
    [sym_exp_do] = STATE(935),
    [sym_exp_negation] = STATE(9110),
    [sym_exp_record] = STATE(5187),
    [sym_exp_name] = STATE(5187),
    [sym_exp_projection_selector] = STATE(5187),
    [sym__aexp_projection] = STATE(5187),
    [sym_exp_projection] = STATE(5187),
    [sym__aexp] = STATE(935),
    [sym__exp_apply] = STATE(12112),
    [sym__fexp] = STATE(9110),
    [sym__lexp] = STATE(9110),
    [sym_exp_infix] = STATE(9110),
    [sym__exp_infix] = STATE(9110),
    [sym__exp] = STATE(12171),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12699),
    [sym_splice] = STATE(5187),
    [sym_quasiquote] = STATE(5187),
    [sym__varid] = ACTIONS(2783),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(2785),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2785),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2787),
    [anon_sym_DASH] = ACTIONS(4141),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [sym_implicit_parid] = ACTIONS(2787),
    [sym__conid] = ACTIONS(4143),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2796),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_BSLASH] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4145),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_mdo] = ACTIONS(2810),
    [anon_sym_do] = ACTIONS(2810),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
  },
  [1512] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(797),
    [sym_variable] = STATE(5085),
    [sym_qualified_variable] = STATE(5085),
    [sym_constructor] = STATE(4716),
    [sym_qualified_constructor] = STATE(5006),
    [sym__qcon] = STATE(5085),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(4915),
    [sym_exp_parens] = STATE(4915),
    [sym_exp_tuple] = STATE(4915),
    [sym_exp_unboxed_tuple] = STATE(4915),
    [sym_exp_unboxed_sum] = STATE(4915),
    [sym_exp_list] = STATE(4915),
    [sym_exp_arithmetic_sequence] = STATE(4915),
    [sym_exp_list_comprehension] = STATE(4915),
    [sym_exp_section_left] = STATE(4915),
    [sym_exp_section_right] = STATE(4915),
    [sym_exp_th_quoted_name] = STATE(4915),
    [sym_exp_type_application] = STATE(943),
    [sym_exp_lambda] = STATE(9208),
    [sym_exp_let] = STATE(18386),
    [sym_exp_let_in] = STATE(9208),
    [sym_exp_cond] = STATE(9208),
    [sym_exp_if_guard] = STATE(9208),
    [sym_exp_case] = STATE(9208),
    [sym_exp_lambda_case] = STATE(943),
    [sym__do_keyword] = STATE(18435),
    [sym_do_module] = STATE(18435),
    [sym_exp_do] = STATE(943),
    [sym_exp_negation] = STATE(9208),
    [sym_exp_record] = STATE(4915),
    [sym_exp_name] = STATE(4915),
    [sym_exp_projection_selector] = STATE(4915),
    [sym__aexp_projection] = STATE(4915),
    [sym_exp_projection] = STATE(4915),
    [sym__aexp] = STATE(943),
    [sym__exp_apply] = STATE(12078),
    [sym__fexp] = STATE(9208),
    [sym__lexp] = STATE(9208),
    [sym_exp_infix] = STATE(9208),
    [sym__exp_infix] = STATE(9208),
    [sym__exp] = STATE(12106),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12549),
    [sym_splice] = STATE(4915),
    [sym_quasiquote] = STATE(4915),
    [sym__varid] = ACTIONS(2895),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(2897),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2897),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [sym_implicit_parid] = ACTIONS(1177),
    [sym__conid] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_mdo] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
  },
  [1513] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9947),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9947),
    [sym_exp_cond] = STATE(9947),
    [sym_exp_if_guard] = STATE(9947),
    [sym_exp_case] = STATE(9947),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9947),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9947),
    [sym__lexp] = STATE(9947),
    [sym_exp_infix] = STATE(9947),
    [sym__exp_infix] = STATE(9947),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4251),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1514] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9904),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9904),
    [sym_exp_cond] = STATE(9904),
    [sym_exp_if_guard] = STATE(9904),
    [sym_exp_case] = STATE(9904),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9904),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9904),
    [sym__lexp] = STATE(9904),
    [sym_exp_infix] = STATE(9904),
    [sym__exp_infix] = STATE(9904),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4253),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1515] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(8211),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(8211),
    [sym_exp_cond] = STATE(8211),
    [sym_exp_if_guard] = STATE(8211),
    [sym_exp_case] = STATE(8211),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(8211),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(8211),
    [sym__lexp] = STATE(8211),
    [sym_exp_infix] = STATE(8211),
    [sym__exp_infix] = STATE(8211),
    [sym__exp] = STATE(10782),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1516] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(797),
    [sym_variable] = STATE(5085),
    [sym_qualified_variable] = STATE(5085),
    [sym_constructor] = STATE(4716),
    [sym_qualified_constructor] = STATE(5006),
    [sym__qcon] = STATE(5085),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(4915),
    [sym_exp_parens] = STATE(4915),
    [sym_exp_tuple] = STATE(4915),
    [sym_exp_unboxed_tuple] = STATE(4915),
    [sym_exp_unboxed_sum] = STATE(4915),
    [sym_exp_list] = STATE(4915),
    [sym_exp_arithmetic_sequence] = STATE(4915),
    [sym_exp_list_comprehension] = STATE(4915),
    [sym_exp_section_left] = STATE(4915),
    [sym_exp_section_right] = STATE(4915),
    [sym_exp_th_quoted_name] = STATE(4915),
    [sym_exp_type_application] = STATE(943),
    [sym_exp_lambda] = STATE(9208),
    [sym_exp_let] = STATE(18386),
    [sym_exp_let_in] = STATE(9208),
    [sym_exp_cond] = STATE(9208),
    [sym_exp_if_guard] = STATE(9208),
    [sym_exp_case] = STATE(9208),
    [sym_exp_lambda_case] = STATE(943),
    [sym__do_keyword] = STATE(18435),
    [sym_do_module] = STATE(18435),
    [sym_exp_do] = STATE(943),
    [sym_exp_negation] = STATE(9208),
    [sym_exp_record] = STATE(4915),
    [sym_exp_name] = STATE(4915),
    [sym_exp_projection_selector] = STATE(4915),
    [sym__aexp_projection] = STATE(4915),
    [sym_exp_projection] = STATE(4915),
    [sym__aexp] = STATE(943),
    [sym__exp_apply] = STATE(12078),
    [sym__fexp] = STATE(9208),
    [sym__lexp] = STATE(9208),
    [sym_exp_infix] = STATE(9208),
    [sym__exp_infix] = STATE(9208),
    [sym__exp] = STATE(12066),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12549),
    [sym_splice] = STATE(4915),
    [sym_quasiquote] = STATE(4915),
    [sym__varid] = ACTIONS(2895),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(2897),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2897),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [sym_implicit_parid] = ACTIONS(1177),
    [sym__conid] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_mdo] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
  },
  [1517] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8774),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8774),
    [sym_exp_cond] = STATE(8774),
    [sym_exp_if_guard] = STATE(8774),
    [sym_exp_case] = STATE(8774),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8774),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8774),
    [sym__lexp] = STATE(8774),
    [sym_exp_infix] = STATE(8774),
    [sym__exp_infix] = STATE(8774),
    [sym__exp] = STATE(11923),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
  },
  [1518] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(797),
    [sym_variable] = STATE(5085),
    [sym_qualified_variable] = STATE(5085),
    [sym_constructor] = STATE(4716),
    [sym_qualified_constructor] = STATE(5006),
    [sym__qcon] = STATE(5085),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(4915),
    [sym_exp_parens] = STATE(4915),
    [sym_exp_tuple] = STATE(4915),
    [sym_exp_unboxed_tuple] = STATE(4915),
    [sym_exp_unboxed_sum] = STATE(4915),
    [sym_exp_list] = STATE(4915),
    [sym_exp_arithmetic_sequence] = STATE(4915),
    [sym_exp_list_comprehension] = STATE(4915),
    [sym_exp_section_left] = STATE(4915),
    [sym_exp_section_right] = STATE(4915),
    [sym_exp_th_quoted_name] = STATE(4915),
    [sym_exp_type_application] = STATE(943),
    [sym_exp_lambda] = STATE(9208),
    [sym_exp_let] = STATE(18386),
    [sym_exp_let_in] = STATE(9208),
    [sym_exp_cond] = STATE(9208),
    [sym_exp_if_guard] = STATE(9208),
    [sym_exp_case] = STATE(9208),
    [sym_exp_lambda_case] = STATE(943),
    [sym__do_keyword] = STATE(18435),
    [sym_do_module] = STATE(18435),
    [sym_exp_do] = STATE(943),
    [sym_exp_negation] = STATE(9208),
    [sym_exp_record] = STATE(4915),
    [sym_exp_name] = STATE(4915),
    [sym_exp_projection_selector] = STATE(4915),
    [sym__aexp_projection] = STATE(4915),
    [sym_exp_projection] = STATE(4915),
    [sym__aexp] = STATE(943),
    [sym__exp_apply] = STATE(12078),
    [sym__fexp] = STATE(9208),
    [sym__lexp] = STATE(9208),
    [sym_exp_infix] = STATE(9208),
    [sym__exp_infix] = STATE(9208),
    [sym__exp] = STATE(12016),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12549),
    [sym_splice] = STATE(4915),
    [sym_quasiquote] = STATE(4915),
    [sym__varid] = ACTIONS(2895),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(2897),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2897),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [sym_implicit_parid] = ACTIONS(1177),
    [sym__conid] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_mdo] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
  },
  [1519] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(797),
    [sym_variable] = STATE(5085),
    [sym_qualified_variable] = STATE(5085),
    [sym_constructor] = STATE(4716),
    [sym_qualified_constructor] = STATE(5006),
    [sym__qcon] = STATE(5085),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(4915),
    [sym_exp_parens] = STATE(4915),
    [sym_exp_tuple] = STATE(4915),
    [sym_exp_unboxed_tuple] = STATE(4915),
    [sym_exp_unboxed_sum] = STATE(4915),
    [sym_exp_list] = STATE(4915),
    [sym_exp_arithmetic_sequence] = STATE(4915),
    [sym_exp_list_comprehension] = STATE(4915),
    [sym_exp_section_left] = STATE(4915),
    [sym_exp_section_right] = STATE(4915),
    [sym_exp_th_quoted_name] = STATE(4915),
    [sym_exp_type_application] = STATE(943),
    [sym_exp_lambda] = STATE(9208),
    [sym_exp_let] = STATE(18386),
    [sym_exp_let_in] = STATE(9208),
    [sym_exp_cond] = STATE(9208),
    [sym_exp_if_guard] = STATE(9208),
    [sym_exp_case] = STATE(9208),
    [sym_exp_lambda_case] = STATE(943),
    [sym__do_keyword] = STATE(18435),
    [sym_do_module] = STATE(18435),
    [sym_exp_do] = STATE(943),
    [sym_exp_negation] = STATE(9208),
    [sym_exp_record] = STATE(4915),
    [sym_exp_name] = STATE(4915),
    [sym_exp_projection_selector] = STATE(4915),
    [sym__aexp_projection] = STATE(4915),
    [sym_exp_projection] = STATE(4915),
    [sym__aexp] = STATE(943),
    [sym__exp_apply] = STATE(12078),
    [sym__fexp] = STATE(9208),
    [sym__lexp] = STATE(9208),
    [sym_exp_infix] = STATE(9208),
    [sym__exp_infix] = STATE(9208),
    [sym__exp] = STATE(12014),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12549),
    [sym_splice] = STATE(4915),
    [sym_quasiquote] = STATE(4915),
    [sym__varid] = ACTIONS(2895),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(2897),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2897),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [sym_implicit_parid] = ACTIONS(1177),
    [sym__conid] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_mdo] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
  },
  [1520] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9735),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9735),
    [sym_exp_cond] = STATE(9735),
    [sym_exp_if_guard] = STATE(9735),
    [sym_exp_case] = STATE(9735),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9735),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9735),
    [sym__lexp] = STATE(9735),
    [sym_exp_infix] = STATE(9735),
    [sym__exp_infix] = STATE(9735),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4255),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1521] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20829),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1522] = {
    [sym_integer] = STATE(3980),
    [sym__literal] = STATE(3980),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = STATE(3975),
    [sym_qualified_variable] = STATE(3975),
    [sym_constructor] = STATE(3857),
    [sym_qualified_constructor] = STATE(3915),
    [sym__qcon] = STATE(3975),
    [sym_con_unit] = STATE(3980),
    [sym_con_list] = STATE(3980),
    [sym_con_tuple] = STATE(3980),
    [sym_literal] = STATE(3921),
    [sym_exp_parens] = STATE(3921),
    [sym_exp_tuple] = STATE(3921),
    [sym_exp_unboxed_tuple] = STATE(3921),
    [sym_exp_unboxed_sum] = STATE(3921),
    [sym_exp_list] = STATE(3921),
    [sym_exp_arithmetic_sequence] = STATE(3921),
    [sym_exp_list_comprehension] = STATE(3921),
    [sym_exp_section_left] = STATE(3921),
    [sym_exp_section_right] = STATE(3921),
    [sym_exp_th_quoted_name] = STATE(3921),
    [sym_exp_type_application] = STATE(695),
    [sym_exp_lambda] = STATE(8018),
    [sym_exp_let] = STATE(18820),
    [sym_exp_let_in] = STATE(8018),
    [sym_exp_cond] = STATE(8018),
    [sym_exp_if_guard] = STATE(8018),
    [sym_exp_case] = STATE(8018),
    [sym_exp_lambda_case] = STATE(695),
    [sym__do_keyword] = STATE(18344),
    [sym_do_module] = STATE(18344),
    [sym_exp_do] = STATE(695),
    [sym_exp_negation] = STATE(8018),
    [sym_exp_record] = STATE(3921),
    [sym_exp_name] = STATE(3921),
    [sym_exp_projection_selector] = STATE(3921),
    [sym__aexp_projection] = STATE(3921),
    [sym_exp_projection] = STATE(3921),
    [sym__aexp] = STATE(695),
    [sym__exp_apply] = STATE(9976),
    [sym__fexp] = STATE(8018),
    [sym__lexp] = STATE(8018),
    [sym_exp_infix] = STATE(8018),
    [sym__exp_infix] = STATE(8018),
    [sym__exp] = STATE(10098),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12582),
    [sym_splice] = STATE(3921),
    [sym_quasiquote] = STATE(3921),
    [sym__varid] = ACTIONS(1700),
    [sym_float] = ACTIONS(1702),
    [sym_char] = ACTIONS(1702),
    [sym_string] = ACTIONS(1702),
    [sym__integer_literal] = ACTIONS(1704),
    [sym__binary_literal] = ACTIONS(1706),
    [sym__octal_literal] = ACTIONS(1706),
    [sym__hex_literal] = ACTIONS(1706),
    [anon_sym_LPAREN_POUND] = ACTIONS(1708),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1708),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1710),
    [anon_sym_DASH] = ACTIONS(4203),
    [anon_sym_LPAREN] = ACTIONS(1712),
    [sym_implicit_parid] = ACTIONS(1710),
    [sym__conid] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(1717),
    [anon_sym_SQUOTE] = ACTIONS(1719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(1725),
    [anon_sym_BSLASH] = ACTIONS(1727),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4207),
    [anon_sym_case] = ACTIONS(1731),
    [anon_sym_mdo] = ACTIONS(1733),
    [anon_sym_do] = ACTIONS(1733),
    [anon_sym_7] = ACTIONS(1735),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1739),
  },
  [1523] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9780),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9780),
    [sym_exp_cond] = STATE(9780),
    [sym_exp_if_guard] = STATE(9780),
    [sym_exp_case] = STATE(9780),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9780),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9780),
    [sym__lexp] = STATE(9780),
    [sym_exp_infix] = STATE(9780),
    [sym__exp_infix] = STATE(9780),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4257),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1524] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18045),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1525] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9857),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9857),
    [sym_exp_cond] = STATE(9857),
    [sym_exp_if_guard] = STATE(9857),
    [sym_exp_case] = STATE(9857),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9857),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9857),
    [sym__lexp] = STATE(9857),
    [sym_exp_infix] = STATE(9857),
    [sym__exp_infix] = STATE(9857),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4259),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1526] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8774),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8774),
    [sym_exp_cond] = STATE(8774),
    [sym_exp_if_guard] = STATE(8774),
    [sym_exp_case] = STATE(8774),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8774),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8774),
    [sym__lexp] = STATE(8774),
    [sym_exp_infix] = STATE(8774),
    [sym__exp_infix] = STATE(8774),
    [sym__exp] = STATE(11825),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
  },
  [1527] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8774),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8774),
    [sym_exp_cond] = STATE(8774),
    [sym_exp_if_guard] = STATE(8774),
    [sym_exp_case] = STATE(8774),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8774),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8774),
    [sym__lexp] = STATE(8774),
    [sym_exp_infix] = STATE(8774),
    [sym__exp_infix] = STATE(8774),
    [sym__exp] = STATE(11824),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
  },
  [1528] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8774),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8774),
    [sym_exp_cond] = STATE(8774),
    [sym_exp_if_guard] = STATE(8774),
    [sym_exp_case] = STATE(8774),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8774),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8774),
    [sym__lexp] = STATE(8774),
    [sym_exp_infix] = STATE(8774),
    [sym__exp_infix] = STATE(8774),
    [sym__exp] = STATE(11791),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
  },
  [1529] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8774),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8774),
    [sym_exp_cond] = STATE(8774),
    [sym_exp_if_guard] = STATE(8774),
    [sym_exp_case] = STATE(8774),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8774),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8774),
    [sym__lexp] = STATE(8774),
    [sym_exp_infix] = STATE(8774),
    [sym__exp_infix] = STATE(8774),
    [sym__exp] = STATE(11783),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
  },
  [1530] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8774),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8774),
    [sym_exp_cond] = STATE(8774),
    [sym_exp_if_guard] = STATE(8774),
    [sym_exp_case] = STATE(8774),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8774),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8774),
    [sym__lexp] = STATE(8774),
    [sym_exp_infix] = STATE(8774),
    [sym__exp_infix] = STATE(8774),
    [sym__exp] = STATE(11781),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
  },
  [1531] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(8774),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(8774),
    [sym_exp_cond] = STATE(8774),
    [sym_exp_if_guard] = STATE(8774),
    [sym_exp_case] = STATE(8774),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(8774),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(8774),
    [sym__lexp] = STATE(8774),
    [sym_exp_infix] = STATE(8774),
    [sym__exp_infix] = STATE(8774),
    [sym__exp] = STATE(11765),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
  },
  [1532] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9929),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9929),
    [sym_exp_cond] = STATE(9929),
    [sym_exp_if_guard] = STATE(9929),
    [sym_exp_case] = STATE(9929),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9929),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9929),
    [sym__lexp] = STATE(9929),
    [sym_exp_infix] = STATE(9929),
    [sym__exp_infix] = STATE(9929),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4261),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1533] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18051),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1534] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9915),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9915),
    [sym_exp_cond] = STATE(9915),
    [sym_exp_if_guard] = STATE(9915),
    [sym_exp_case] = STATE(9915),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9915),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9915),
    [sym__lexp] = STATE(9915),
    [sym_exp_infix] = STATE(9915),
    [sym__exp_infix] = STATE(9915),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4247),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1535] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(8211),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(8211),
    [sym_exp_cond] = STATE(8211),
    [sym_exp_if_guard] = STATE(8211),
    [sym_exp_case] = STATE(8211),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(8211),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(8211),
    [sym__lexp] = STATE(8211),
    [sym_exp_infix] = STATE(8211),
    [sym__exp_infix] = STATE(8211),
    [sym__exp] = STATE(10322),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1536] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(8211),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(8211),
    [sym_exp_cond] = STATE(8211),
    [sym_exp_if_guard] = STATE(8211),
    [sym_exp_case] = STATE(8211),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(8211),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(8211),
    [sym__lexp] = STATE(8211),
    [sym_exp_infix] = STATE(8211),
    [sym__exp_infix] = STATE(8211),
    [sym__exp] = STATE(10323),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1537] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9936),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9936),
    [sym_exp_cond] = STATE(9936),
    [sym_exp_if_guard] = STATE(9936),
    [sym_exp_case] = STATE(9936),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9936),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9936),
    [sym__lexp] = STATE(9936),
    [sym_exp_infix] = STATE(9936),
    [sym__exp_infix] = STATE(9936),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4263),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1538] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9880),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9880),
    [sym_exp_cond] = STATE(9880),
    [sym_exp_if_guard] = STATE(9880),
    [sym_exp_case] = STATE(9880),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9880),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9880),
    [sym__lexp] = STATE(9880),
    [sym_exp_infix] = STATE(9880),
    [sym__exp_infix] = STATE(9880),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4185),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1539] = {
    [sym_integer] = STATE(5669),
    [sym__literal] = STATE(5669),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = STATE(5710),
    [sym_qualified_variable] = STATE(5710),
    [sym_constructor] = STATE(5151),
    [sym_qualified_constructor] = STATE(5594),
    [sym__qcon] = STATE(5710),
    [sym_con_unit] = STATE(5669),
    [sym_con_list] = STATE(5669),
    [sym_con_tuple] = STATE(5669),
    [sym_literal] = STATE(5640),
    [sym_exp_parens] = STATE(5640),
    [sym_exp_tuple] = STATE(5640),
    [sym_exp_unboxed_tuple] = STATE(5640),
    [sym_exp_unboxed_sum] = STATE(5640),
    [sym_exp_list] = STATE(5640),
    [sym_exp_arithmetic_sequence] = STATE(5640),
    [sym_exp_list_comprehension] = STATE(5640),
    [sym_exp_section_left] = STATE(5640),
    [sym_exp_section_right] = STATE(5640),
    [sym_exp_th_quoted_name] = STATE(5640),
    [sym_exp_type_application] = STATE(956),
    [sym_exp_lambda] = STATE(9227),
    [sym_exp_let] = STATE(17912),
    [sym_exp_let_in] = STATE(9227),
    [sym_exp_cond] = STATE(9227),
    [sym_exp_if_guard] = STATE(9227),
    [sym_exp_case] = STATE(9227),
    [sym_exp_lambda_case] = STATE(956),
    [sym__do_keyword] = STATE(17914),
    [sym_do_module] = STATE(17914),
    [sym_exp_do] = STATE(956),
    [sym_exp_negation] = STATE(9227),
    [sym_exp_record] = STATE(5640),
    [sym_exp_name] = STATE(5640),
    [sym_exp_projection_selector] = STATE(5640),
    [sym__aexp_projection] = STATE(5640),
    [sym_exp_projection] = STATE(5640),
    [sym__aexp] = STATE(956),
    [sym__exp_apply] = STATE(12238),
    [sym__fexp] = STATE(9227),
    [sym__lexp] = STATE(9227),
    [sym_exp_infix] = STATE(9227),
    [sym__exp_infix] = STATE(9227),
    [sym__exp] = STATE(12493),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12604),
    [sym_splice] = STATE(5640),
    [sym_quasiquote] = STATE(5640),
    [sym__varid] = ACTIONS(2945),
    [sym_float] = ACTIONS(2947),
    [sym_char] = ACTIONS(2947),
    [sym_string] = ACTIONS(2947),
    [sym__integer_literal] = ACTIONS(2949),
    [sym__binary_literal] = ACTIONS(2951),
    [sym__octal_literal] = ACTIONS(2951),
    [sym__hex_literal] = ACTIONS(2951),
    [anon_sym_LPAREN_POUND] = ACTIONS(2953),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2953),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(35),
    [anon_sym_AT] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_7] = ACTIONS(2967),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2969),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2971),
  },
  [1540] = {
    [sym_integer] = STATE(4936),
    [sym__literal] = STATE(4936),
    [sym__unboxed_open] = STATE(780),
    [sym_variable] = STATE(5192),
    [sym_qualified_variable] = STATE(5192),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4989),
    [sym__qcon] = STATE(5192),
    [sym_con_unit] = STATE(4936),
    [sym_con_list] = STATE(4936),
    [sym_con_tuple] = STATE(4936),
    [sym_literal] = STATE(5422),
    [sym_exp_parens] = STATE(5422),
    [sym_exp_tuple] = STATE(5422),
    [sym_exp_unboxed_tuple] = STATE(5422),
    [sym_exp_unboxed_sum] = STATE(5422),
    [sym_exp_list] = STATE(5422),
    [sym_exp_arithmetic_sequence] = STATE(5422),
    [sym_exp_list_comprehension] = STATE(5422),
    [sym_exp_section_left] = STATE(5422),
    [sym_exp_section_right] = STATE(5422),
    [sym_exp_th_quoted_name] = STATE(5422),
    [sym_exp_type_application] = STATE(901),
    [sym_exp_lambda] = STATE(9128),
    [sym_exp_let] = STATE(18508),
    [sym_exp_let_in] = STATE(9128),
    [sym_exp_cond] = STATE(9128),
    [sym_exp_if_guard] = STATE(9128),
    [sym_exp_case] = STATE(9128),
    [sym_exp_lambda_case] = STATE(901),
    [sym__do_keyword] = STATE(18325),
    [sym_do_module] = STATE(18325),
    [sym_exp_do] = STATE(901),
    [sym_exp_negation] = STATE(9128),
    [sym_exp_record] = STATE(5422),
    [sym_exp_name] = STATE(5422),
    [sym_exp_projection_selector] = STATE(5422),
    [sym__aexp_projection] = STATE(5422),
    [sym_exp_projection] = STATE(5422),
    [sym__aexp] = STATE(901),
    [sym__exp_apply] = STATE(12038),
    [sym__fexp] = STATE(9128),
    [sym__lexp] = STATE(9128),
    [sym_exp_infix] = STATE(9128),
    [sym__exp_infix] = STATE(9128),
    [sym__exp] = STATE(14735),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12676),
    [sym_splice] = STATE(5422),
    [sym_quasiquote] = STATE(5422),
    [sym__varid] = ACTIONS(2660),
    [sym_float] = ACTIONS(2662),
    [sym_char] = ACTIONS(2662),
    [sym_string] = ACTIONS(2662),
    [sym__integer_literal] = ACTIONS(2664),
    [sym__binary_literal] = ACTIONS(2666),
    [sym__octal_literal] = ACTIONS(2666),
    [sym__hex_literal] = ACTIONS(2666),
    [anon_sym_LPAREN_POUND] = ACTIONS(2668),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2668),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [sym_implicit_parid] = ACTIONS(2670),
    [sym__conid] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2686),
    [anon_sym_BSLASH] = ACTIONS(2688),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4195),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_mdo] = ACTIONS(2694),
    [anon_sym_do] = ACTIONS(2694),
    [anon_sym_7] = ACTIONS(2696),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2698),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2700),
  },
  [1541] = {
    [sym_integer] = STATE(4662),
    [sym__literal] = STATE(4662),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = STATE(4833),
    [sym_qualified_variable] = STATE(4833),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4790),
    [sym__qcon] = STATE(4833),
    [sym_con_unit] = STATE(4662),
    [sym_con_list] = STATE(4662),
    [sym_con_tuple] = STATE(4662),
    [sym_literal] = STATE(4650),
    [sym_exp_parens] = STATE(4650),
    [sym_exp_tuple] = STATE(4650),
    [sym_exp_unboxed_tuple] = STATE(4650),
    [sym_exp_unboxed_sum] = STATE(4650),
    [sym_exp_list] = STATE(4650),
    [sym_exp_arithmetic_sequence] = STATE(4650),
    [sym_exp_list_comprehension] = STATE(4650),
    [sym_exp_section_left] = STATE(4650),
    [sym_exp_section_right] = STATE(4650),
    [sym_exp_th_quoted_name] = STATE(4650),
    [sym_exp_type_application] = STATE(882),
    [sym_exp_lambda] = STATE(8780),
    [sym_exp_let] = STATE(18846),
    [sym_exp_let_in] = STATE(8780),
    [sym_exp_cond] = STATE(8780),
    [sym_exp_if_guard] = STATE(8780),
    [sym_exp_case] = STATE(8780),
    [sym_exp_lambda_case] = STATE(882),
    [sym__do_keyword] = STATE(18352),
    [sym_do_module] = STATE(18352),
    [sym_exp_do] = STATE(882),
    [sym_exp_negation] = STATE(8780),
    [sym_exp_record] = STATE(4650),
    [sym_exp_name] = STATE(4650),
    [sym_exp_projection_selector] = STATE(4650),
    [sym__aexp_projection] = STATE(4650),
    [sym_exp_projection] = STATE(4650),
    [sym__aexp] = STATE(882),
    [sym__exp_apply] = STATE(11843),
    [sym__fexp] = STATE(8780),
    [sym__lexp] = STATE(8780),
    [sym_exp_infix] = STATE(8780),
    [sym__exp_infix] = STATE(8780),
    [sym__exp] = STATE(11720),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12534),
    [sym_splice] = STATE(4650),
    [sym_quasiquote] = STATE(4650),
    [sym__varid] = ACTIONS(2305),
    [sym_float] = ACTIONS(2307),
    [sym_char] = ACTIONS(2307),
    [sym_string] = ACTIONS(2307),
    [sym__integer_literal] = ACTIONS(2309),
    [sym__binary_literal] = ACTIONS(2311),
    [sym__octal_literal] = ACTIONS(2311),
    [sym__hex_literal] = ACTIONS(2311),
    [anon_sym_LPAREN_POUND] = ACTIONS(2313),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2313),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(4265),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [sym_implicit_parid] = ACTIONS(2315),
    [sym__conid] = ACTIONS(4267),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_BSLASH] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4269),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_mdo] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_7] = ACTIONS(2340),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2344),
  },
  [1542] = {
    [sym_integer] = STATE(4662),
    [sym__literal] = STATE(4662),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = STATE(4833),
    [sym_qualified_variable] = STATE(4833),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4790),
    [sym__qcon] = STATE(4833),
    [sym_con_unit] = STATE(4662),
    [sym_con_list] = STATE(4662),
    [sym_con_tuple] = STATE(4662),
    [sym_literal] = STATE(4650),
    [sym_exp_parens] = STATE(4650),
    [sym_exp_tuple] = STATE(4650),
    [sym_exp_unboxed_tuple] = STATE(4650),
    [sym_exp_unboxed_sum] = STATE(4650),
    [sym_exp_list] = STATE(4650),
    [sym_exp_arithmetic_sequence] = STATE(4650),
    [sym_exp_list_comprehension] = STATE(4650),
    [sym_exp_section_left] = STATE(4650),
    [sym_exp_section_right] = STATE(4650),
    [sym_exp_th_quoted_name] = STATE(4650),
    [sym_exp_type_application] = STATE(882),
    [sym_exp_lambda] = STATE(8780),
    [sym_exp_let] = STATE(18846),
    [sym_exp_let_in] = STATE(8780),
    [sym_exp_cond] = STATE(8780),
    [sym_exp_if_guard] = STATE(8780),
    [sym_exp_case] = STATE(8780),
    [sym_exp_lambda_case] = STATE(882),
    [sym__do_keyword] = STATE(18352),
    [sym_do_module] = STATE(18352),
    [sym_exp_do] = STATE(882),
    [sym_exp_negation] = STATE(8780),
    [sym_exp_record] = STATE(4650),
    [sym_exp_name] = STATE(4650),
    [sym_exp_projection_selector] = STATE(4650),
    [sym__aexp_projection] = STATE(4650),
    [sym_exp_projection] = STATE(4650),
    [sym__aexp] = STATE(882),
    [sym__exp_apply] = STATE(11843),
    [sym__fexp] = STATE(8780),
    [sym__lexp] = STATE(8780),
    [sym_exp_infix] = STATE(8780),
    [sym__exp_infix] = STATE(8780),
    [sym__exp] = STATE(11721),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12534),
    [sym_splice] = STATE(4650),
    [sym_quasiquote] = STATE(4650),
    [sym__varid] = ACTIONS(2305),
    [sym_float] = ACTIONS(2307),
    [sym_char] = ACTIONS(2307),
    [sym_string] = ACTIONS(2307),
    [sym__integer_literal] = ACTIONS(2309),
    [sym__binary_literal] = ACTIONS(2311),
    [sym__octal_literal] = ACTIONS(2311),
    [sym__hex_literal] = ACTIONS(2311),
    [anon_sym_LPAREN_POUND] = ACTIONS(2313),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2313),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(4265),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [sym_implicit_parid] = ACTIONS(2315),
    [sym__conid] = ACTIONS(4267),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_BSLASH] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4269),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_mdo] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_7] = ACTIONS(2340),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2344),
  },
  [1543] = {
    [sym_integer] = STATE(4662),
    [sym__literal] = STATE(4662),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = STATE(4833),
    [sym_qualified_variable] = STATE(4833),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4790),
    [sym__qcon] = STATE(4833),
    [sym_con_unit] = STATE(4662),
    [sym_con_list] = STATE(4662),
    [sym_con_tuple] = STATE(4662),
    [sym_literal] = STATE(4650),
    [sym_exp_parens] = STATE(4650),
    [sym_exp_tuple] = STATE(4650),
    [sym_exp_unboxed_tuple] = STATE(4650),
    [sym_exp_unboxed_sum] = STATE(4650),
    [sym_exp_list] = STATE(4650),
    [sym_exp_arithmetic_sequence] = STATE(4650),
    [sym_exp_list_comprehension] = STATE(4650),
    [sym_exp_section_left] = STATE(4650),
    [sym_exp_section_right] = STATE(4650),
    [sym_exp_th_quoted_name] = STATE(4650),
    [sym_exp_type_application] = STATE(882),
    [sym_exp_lambda] = STATE(8780),
    [sym_exp_let] = STATE(18846),
    [sym_exp_let_in] = STATE(8780),
    [sym_exp_cond] = STATE(8780),
    [sym_exp_if_guard] = STATE(8780),
    [sym_exp_case] = STATE(8780),
    [sym_exp_lambda_case] = STATE(882),
    [sym__do_keyword] = STATE(18352),
    [sym_do_module] = STATE(18352),
    [sym_exp_do] = STATE(882),
    [sym_exp_negation] = STATE(8780),
    [sym_exp_record] = STATE(4650),
    [sym_exp_name] = STATE(4650),
    [sym_exp_projection_selector] = STATE(4650),
    [sym__aexp_projection] = STATE(4650),
    [sym_exp_projection] = STATE(4650),
    [sym__aexp] = STATE(882),
    [sym__exp_apply] = STATE(11843),
    [sym__fexp] = STATE(8780),
    [sym__lexp] = STATE(8780),
    [sym_exp_infix] = STATE(8780),
    [sym__exp_infix] = STATE(8780),
    [sym__exp] = STATE(11723),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12534),
    [sym_splice] = STATE(4650),
    [sym_quasiquote] = STATE(4650),
    [sym__varid] = ACTIONS(2305),
    [sym_float] = ACTIONS(2307),
    [sym_char] = ACTIONS(2307),
    [sym_string] = ACTIONS(2307),
    [sym__integer_literal] = ACTIONS(2309),
    [sym__binary_literal] = ACTIONS(2311),
    [sym__octal_literal] = ACTIONS(2311),
    [sym__hex_literal] = ACTIONS(2311),
    [anon_sym_LPAREN_POUND] = ACTIONS(2313),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2313),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(4265),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [sym_implicit_parid] = ACTIONS(2315),
    [sym__conid] = ACTIONS(4267),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_BSLASH] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4269),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_mdo] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_7] = ACTIONS(2340),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2344),
  },
  [1544] = {
    [sym_integer] = STATE(4662),
    [sym__literal] = STATE(4662),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = STATE(4833),
    [sym_qualified_variable] = STATE(4833),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4790),
    [sym__qcon] = STATE(4833),
    [sym_con_unit] = STATE(4662),
    [sym_con_list] = STATE(4662),
    [sym_con_tuple] = STATE(4662),
    [sym_literal] = STATE(4650),
    [sym_exp_parens] = STATE(4650),
    [sym_exp_tuple] = STATE(4650),
    [sym_exp_unboxed_tuple] = STATE(4650),
    [sym_exp_unboxed_sum] = STATE(4650),
    [sym_exp_list] = STATE(4650),
    [sym_exp_arithmetic_sequence] = STATE(4650),
    [sym_exp_list_comprehension] = STATE(4650),
    [sym_exp_section_left] = STATE(4650),
    [sym_exp_section_right] = STATE(4650),
    [sym_exp_th_quoted_name] = STATE(4650),
    [sym_exp_type_application] = STATE(882),
    [sym_exp_lambda] = STATE(8780),
    [sym_exp_let] = STATE(18846),
    [sym_exp_let_in] = STATE(8780),
    [sym_exp_cond] = STATE(8780),
    [sym_exp_if_guard] = STATE(8780),
    [sym_exp_case] = STATE(8780),
    [sym_exp_lambda_case] = STATE(882),
    [sym__do_keyword] = STATE(18352),
    [sym_do_module] = STATE(18352),
    [sym_exp_do] = STATE(882),
    [sym_exp_negation] = STATE(8780),
    [sym_exp_record] = STATE(4650),
    [sym_exp_name] = STATE(4650),
    [sym_exp_projection_selector] = STATE(4650),
    [sym__aexp_projection] = STATE(4650),
    [sym_exp_projection] = STATE(4650),
    [sym__aexp] = STATE(882),
    [sym__exp_apply] = STATE(11843),
    [sym__fexp] = STATE(8780),
    [sym__lexp] = STATE(8780),
    [sym_exp_infix] = STATE(8780),
    [sym__exp_infix] = STATE(8780),
    [sym__exp] = STATE(11724),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12534),
    [sym_splice] = STATE(4650),
    [sym_quasiquote] = STATE(4650),
    [sym__varid] = ACTIONS(2305),
    [sym_float] = ACTIONS(2307),
    [sym_char] = ACTIONS(2307),
    [sym_string] = ACTIONS(2307),
    [sym__integer_literal] = ACTIONS(2309),
    [sym__binary_literal] = ACTIONS(2311),
    [sym__octal_literal] = ACTIONS(2311),
    [sym__hex_literal] = ACTIONS(2311),
    [anon_sym_LPAREN_POUND] = ACTIONS(2313),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2313),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(4265),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [sym_implicit_parid] = ACTIONS(2315),
    [sym__conid] = ACTIONS(4267),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_BSLASH] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4269),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_mdo] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_7] = ACTIONS(2340),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2344),
  },
  [1545] = {
    [sym_integer] = STATE(4830),
    [sym__literal] = STATE(4830),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = STATE(4419),
    [sym_qualified_variable] = STATE(4419),
    [sym_constructor] = STATE(4257),
    [sym_qualified_constructor] = STATE(4416),
    [sym__qcon] = STATE(4419),
    [sym_con_unit] = STATE(4830),
    [sym_con_list] = STATE(4830),
    [sym_con_tuple] = STATE(4830),
    [sym_literal] = STATE(4455),
    [sym_exp_parens] = STATE(4455),
    [sym_exp_tuple] = STATE(4455),
    [sym_exp_unboxed_tuple] = STATE(4455),
    [sym_exp_unboxed_sum] = STATE(4455),
    [sym_exp_list] = STATE(4455),
    [sym_exp_arithmetic_sequence] = STATE(4455),
    [sym_exp_list_comprehension] = STATE(4455),
    [sym_exp_section_left] = STATE(4455),
    [sym_exp_section_right] = STATE(4455),
    [sym_exp_th_quoted_name] = STATE(4455),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(8786),
    [sym_exp_let] = STATE(18318),
    [sym_exp_let_in] = STATE(8786),
    [sym_exp_cond] = STATE(8786),
    [sym_exp_if_guard] = STATE(8786),
    [sym_exp_case] = STATE(8786),
    [sym_exp_lambda_case] = STATE(828),
    [sym__do_keyword] = STATE(18263),
    [sym_do_module] = STATE(18263),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(8786),
    [sym_exp_record] = STATE(4455),
    [sym_exp_name] = STATE(4455),
    [sym_exp_projection_selector] = STATE(4455),
    [sym__aexp_projection] = STATE(4455),
    [sym_exp_projection] = STATE(4455),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(11903),
    [sym__fexp] = STATE(8786),
    [sym__lexp] = STATE(8786),
    [sym_exp_infix] = STATE(8786),
    [sym__exp_infix] = STATE(8786),
    [sym__exp] = STATE(11894),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12635),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(2080),
    [sym_float] = ACTIONS(2082),
    [sym_char] = ACTIONS(2082),
    [sym_string] = ACTIONS(2082),
    [sym__integer_literal] = ACTIONS(2084),
    [sym__binary_literal] = ACTIONS(2086),
    [sym__octal_literal] = ACTIONS(2086),
    [sym__hex_literal] = ACTIONS(2086),
    [anon_sym_LPAREN_POUND] = ACTIONS(2088),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2088),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2090),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [sym_implicit_parid] = ACTIONS(2090),
    [sym__conid] = ACTIONS(4055),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_BSLASH] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4057),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_mdo] = ACTIONS(2114),
    [anon_sym_do] = ACTIONS(2114),
    [anon_sym_7] = ACTIONS(2116),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2120),
  },
  [1546] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20521),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1547] = {
    [sym_integer] = STATE(4662),
    [sym__literal] = STATE(4662),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = STATE(4833),
    [sym_qualified_variable] = STATE(4833),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4790),
    [sym__qcon] = STATE(4833),
    [sym_con_unit] = STATE(4662),
    [sym_con_list] = STATE(4662),
    [sym_con_tuple] = STATE(4662),
    [sym_literal] = STATE(4650),
    [sym_exp_parens] = STATE(4650),
    [sym_exp_tuple] = STATE(4650),
    [sym_exp_unboxed_tuple] = STATE(4650),
    [sym_exp_unboxed_sum] = STATE(4650),
    [sym_exp_list] = STATE(4650),
    [sym_exp_arithmetic_sequence] = STATE(4650),
    [sym_exp_list_comprehension] = STATE(4650),
    [sym_exp_section_left] = STATE(4650),
    [sym_exp_section_right] = STATE(4650),
    [sym_exp_th_quoted_name] = STATE(4650),
    [sym_exp_type_application] = STATE(882),
    [sym_exp_lambda] = STATE(8780),
    [sym_exp_let] = STATE(18846),
    [sym_exp_let_in] = STATE(8780),
    [sym_exp_cond] = STATE(8780),
    [sym_exp_if_guard] = STATE(8780),
    [sym_exp_case] = STATE(8780),
    [sym_exp_lambda_case] = STATE(882),
    [sym__do_keyword] = STATE(18352),
    [sym_do_module] = STATE(18352),
    [sym_exp_do] = STATE(882),
    [sym_exp_negation] = STATE(8780),
    [sym_exp_record] = STATE(4650),
    [sym_exp_name] = STATE(4650),
    [sym_exp_projection_selector] = STATE(4650),
    [sym__aexp_projection] = STATE(4650),
    [sym_exp_projection] = STATE(4650),
    [sym__aexp] = STATE(882),
    [sym__exp_apply] = STATE(11843),
    [sym__fexp] = STATE(8780),
    [sym__lexp] = STATE(8780),
    [sym_exp_infix] = STATE(8780),
    [sym__exp_infix] = STATE(8780),
    [sym__exp] = STATE(11739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12534),
    [sym_splice] = STATE(4650),
    [sym_quasiquote] = STATE(4650),
    [sym__varid] = ACTIONS(2305),
    [sym_float] = ACTIONS(2307),
    [sym_char] = ACTIONS(2307),
    [sym_string] = ACTIONS(2307),
    [sym__integer_literal] = ACTIONS(2309),
    [sym__binary_literal] = ACTIONS(2311),
    [sym__octal_literal] = ACTIONS(2311),
    [sym__hex_literal] = ACTIONS(2311),
    [anon_sym_LPAREN_POUND] = ACTIONS(2313),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2313),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(4265),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [sym_implicit_parid] = ACTIONS(2315),
    [sym__conid] = ACTIONS(4267),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_BSLASH] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4269),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_mdo] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_7] = ACTIONS(2340),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2344),
  },
  [1548] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9829),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9829),
    [sym_exp_cond] = STATE(9829),
    [sym_exp_if_guard] = STATE(9829),
    [sym_exp_case] = STATE(9829),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9829),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9829),
    [sym__lexp] = STATE(9829),
    [sym_exp_infix] = STATE(9829),
    [sym__exp_infix] = STATE(9829),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4271),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1549] = {
    [sym_integer] = STATE(4662),
    [sym__literal] = STATE(4662),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = STATE(4833),
    [sym_qualified_variable] = STATE(4833),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4790),
    [sym__qcon] = STATE(4833),
    [sym_con_unit] = STATE(4662),
    [sym_con_list] = STATE(4662),
    [sym_con_tuple] = STATE(4662),
    [sym_literal] = STATE(4650),
    [sym_exp_parens] = STATE(4650),
    [sym_exp_tuple] = STATE(4650),
    [sym_exp_unboxed_tuple] = STATE(4650),
    [sym_exp_unboxed_sum] = STATE(4650),
    [sym_exp_list] = STATE(4650),
    [sym_exp_arithmetic_sequence] = STATE(4650),
    [sym_exp_list_comprehension] = STATE(4650),
    [sym_exp_section_left] = STATE(4650),
    [sym_exp_section_right] = STATE(4650),
    [sym_exp_th_quoted_name] = STATE(4650),
    [sym_exp_type_application] = STATE(882),
    [sym_exp_lambda] = STATE(8780),
    [sym_exp_let] = STATE(18846),
    [sym_exp_let_in] = STATE(8780),
    [sym_exp_cond] = STATE(8780),
    [sym_exp_if_guard] = STATE(8780),
    [sym_exp_case] = STATE(8780),
    [sym_exp_lambda_case] = STATE(882),
    [sym__do_keyword] = STATE(18352),
    [sym_do_module] = STATE(18352),
    [sym_exp_do] = STATE(882),
    [sym_exp_negation] = STATE(8780),
    [sym_exp_record] = STATE(4650),
    [sym_exp_name] = STATE(4650),
    [sym_exp_projection_selector] = STATE(4650),
    [sym__aexp_projection] = STATE(4650),
    [sym_exp_projection] = STATE(4650),
    [sym__aexp] = STATE(882),
    [sym__exp_apply] = STATE(11843),
    [sym__fexp] = STATE(8780),
    [sym__lexp] = STATE(8780),
    [sym_exp_infix] = STATE(8780),
    [sym__exp_infix] = STATE(8780),
    [sym__exp] = STATE(11759),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12534),
    [sym_splice] = STATE(4650),
    [sym_quasiquote] = STATE(4650),
    [sym__varid] = ACTIONS(2305),
    [sym_float] = ACTIONS(2307),
    [sym_char] = ACTIONS(2307),
    [sym_string] = ACTIONS(2307),
    [sym__integer_literal] = ACTIONS(2309),
    [sym__binary_literal] = ACTIONS(2311),
    [sym__octal_literal] = ACTIONS(2311),
    [sym__hex_literal] = ACTIONS(2311),
    [anon_sym_LPAREN_POUND] = ACTIONS(2313),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2313),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(4265),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [sym_implicit_parid] = ACTIONS(2315),
    [sym__conid] = ACTIONS(4267),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_BSLASH] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4269),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_mdo] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_7] = ACTIONS(2340),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2344),
  },
  [1550] = {
    [sym_integer] = STATE(4332),
    [sym__literal] = STATE(4332),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(4280),
    [sym_qualified_variable] = STATE(4280),
    [sym_constructor] = STATE(4074),
    [sym_qualified_constructor] = STATE(4305),
    [sym__qcon] = STATE(4280),
    [sym_con_unit] = STATE(4332),
    [sym_con_list] = STATE(4332),
    [sym_con_tuple] = STATE(4332),
    [sym_literal] = STATE(4217),
    [sym_exp_parens] = STATE(4217),
    [sym_exp_tuple] = STATE(4217),
    [sym_exp_unboxed_tuple] = STATE(4217),
    [sym_exp_unboxed_sum] = STATE(4217),
    [sym_exp_list] = STATE(4217),
    [sym_exp_arithmetic_sequence] = STATE(4217),
    [sym_exp_list_comprehension] = STATE(4217),
    [sym_exp_section_left] = STATE(4217),
    [sym_exp_section_right] = STATE(4217),
    [sym_exp_th_quoted_name] = STATE(4217),
    [sym_exp_type_application] = STATE(801),
    [sym_exp_lambda] = STATE(8644),
    [sym_exp_let] = STATE(18577),
    [sym_exp_let_in] = STATE(8644),
    [sym_exp_cond] = STATE(8644),
    [sym_exp_if_guard] = STATE(8644),
    [sym_exp_case] = STATE(8644),
    [sym_exp_lambda_case] = STATE(801),
    [sym__do_keyword] = STATE(18152),
    [sym_do_module] = STATE(18152),
    [sym_exp_do] = STATE(801),
    [sym_exp_negation] = STATE(8644),
    [sym_exp_record] = STATE(4217),
    [sym_exp_name] = STATE(4217),
    [sym_exp_projection_selector] = STATE(4217),
    [sym__aexp_projection] = STATE(4217),
    [sym_exp_projection] = STATE(4217),
    [sym__aexp] = STATE(801),
    [sym__exp_apply] = STATE(11048),
    [sym__fexp] = STATE(8644),
    [sym__lexp] = STATE(8644),
    [sym_exp_infix] = STATE(8644),
    [sym__exp_infix] = STATE(8644),
    [sym__exp] = STATE(10984),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12567),
    [sym_splice] = STATE(4217),
    [sym_quasiquote] = STATE(4217),
    [sym__varid] = ACTIONS(1933),
    [sym_float] = ACTIONS(1935),
    [sym_char] = ACTIONS(1935),
    [sym_string] = ACTIONS(1935),
    [sym__integer_literal] = ACTIONS(1937),
    [sym__binary_literal] = ACTIONS(1939),
    [sym__octal_literal] = ACTIONS(1939),
    [sym__hex_literal] = ACTIONS(1939),
    [anon_sym_LPAREN_POUND] = ACTIONS(1941),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1941),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [sym_implicit_parid] = ACTIONS(1943),
    [sym__conid] = ACTIONS(4161),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1953),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(1959),
    [anon_sym_BSLASH] = ACTIONS(1961),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4163),
    [anon_sym_case] = ACTIONS(1965),
    [anon_sym_mdo] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_7] = ACTIONS(1969),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1973),
  },
  [1551] = {
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = STATE(4572),
    [sym_qualified_variable] = STATE(4572),
    [sym_constructor] = STATE(4245),
    [sym_qualified_constructor] = STATE(4556),
    [sym__qcon] = STATE(4572),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4959),
    [sym_exp_parens] = STATE(4959),
    [sym_exp_tuple] = STATE(4959),
    [sym_exp_unboxed_tuple] = STATE(4959),
    [sym_exp_unboxed_sum] = STATE(4959),
    [sym_exp_list] = STATE(4959),
    [sym_exp_arithmetic_sequence] = STATE(4959),
    [sym_exp_list_comprehension] = STATE(4959),
    [sym_exp_section_left] = STATE(4959),
    [sym_exp_section_right] = STATE(4959),
    [sym_exp_th_quoted_name] = STATE(4959),
    [sym_exp_type_application] = STATE(947),
    [sym_exp_lambda] = STATE(9082),
    [sym_exp_let] = STATE(18678),
    [sym_exp_let_in] = STATE(9082),
    [sym_exp_cond] = STATE(9082),
    [sym_exp_if_guard] = STATE(9082),
    [sym_exp_case] = STATE(9082),
    [sym_exp_lambda_case] = STATE(947),
    [sym__do_keyword] = STATE(18401),
    [sym_do_module] = STATE(18401),
    [sym_exp_do] = STATE(947),
    [sym_exp_negation] = STATE(9082),
    [sym_exp_record] = STATE(4959),
    [sym_exp_name] = STATE(4959),
    [sym_exp_projection_selector] = STATE(4959),
    [sym__aexp_projection] = STATE(4959),
    [sym_exp_projection] = STATE(4959),
    [sym__aexp] = STATE(947),
    [sym__exp_apply] = STATE(12092),
    [sym__fexp] = STATE(9082),
    [sym__lexp] = STATE(9082),
    [sym_exp_infix] = STATE(9082),
    [sym__exp_infix] = STATE(9082),
    [sym__exp] = STATE(11946),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12712),
    [sym_splice] = STATE(4959),
    [sym_quasiquote] = STATE(4959),
    [sym__varid] = ACTIONS(2529),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2531),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2531),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [sym_implicit_parid] = ACTIONS(2533),
    [sym__conid] = ACTIONS(4243),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [anon_sym_BSLASH] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4245),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_mdo] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
  },
  [1552] = {
    [sym_integer] = STATE(4332),
    [sym__literal] = STATE(4332),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(4280),
    [sym_qualified_variable] = STATE(4280),
    [sym_constructor] = STATE(4074),
    [sym_qualified_constructor] = STATE(4305),
    [sym__qcon] = STATE(4280),
    [sym_con_unit] = STATE(4332),
    [sym_con_list] = STATE(4332),
    [sym_con_tuple] = STATE(4332),
    [sym_literal] = STATE(4217),
    [sym_exp_parens] = STATE(4217),
    [sym_exp_tuple] = STATE(4217),
    [sym_exp_unboxed_tuple] = STATE(4217),
    [sym_exp_unboxed_sum] = STATE(4217),
    [sym_exp_list] = STATE(4217),
    [sym_exp_arithmetic_sequence] = STATE(4217),
    [sym_exp_list_comprehension] = STATE(4217),
    [sym_exp_section_left] = STATE(4217),
    [sym_exp_section_right] = STATE(4217),
    [sym_exp_th_quoted_name] = STATE(4217),
    [sym_exp_type_application] = STATE(801),
    [sym_exp_lambda] = STATE(8644),
    [sym_exp_let] = STATE(18577),
    [sym_exp_let_in] = STATE(8644),
    [sym_exp_cond] = STATE(8644),
    [sym_exp_if_guard] = STATE(8644),
    [sym_exp_case] = STATE(8644),
    [sym_exp_lambda_case] = STATE(801),
    [sym__do_keyword] = STATE(18152),
    [sym_do_module] = STATE(18152),
    [sym_exp_do] = STATE(801),
    [sym_exp_negation] = STATE(8644),
    [sym_exp_record] = STATE(4217),
    [sym_exp_name] = STATE(4217),
    [sym_exp_projection_selector] = STATE(4217),
    [sym__aexp_projection] = STATE(4217),
    [sym_exp_projection] = STATE(4217),
    [sym__aexp] = STATE(801),
    [sym__exp_apply] = STATE(11048),
    [sym__fexp] = STATE(8644),
    [sym__lexp] = STATE(8644),
    [sym_exp_infix] = STATE(8644),
    [sym__exp_infix] = STATE(8644),
    [sym__exp] = STATE(10939),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12567),
    [sym_splice] = STATE(4217),
    [sym_quasiquote] = STATE(4217),
    [sym__varid] = ACTIONS(1933),
    [sym_float] = ACTIONS(1935),
    [sym_char] = ACTIONS(1935),
    [sym_string] = ACTIONS(1935),
    [sym__integer_literal] = ACTIONS(1937),
    [sym__binary_literal] = ACTIONS(1939),
    [sym__octal_literal] = ACTIONS(1939),
    [sym__hex_literal] = ACTIONS(1939),
    [anon_sym_LPAREN_POUND] = ACTIONS(1941),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1941),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [sym_implicit_parid] = ACTIONS(1943),
    [sym__conid] = ACTIONS(4161),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1953),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(1959),
    [anon_sym_BSLASH] = ACTIONS(1961),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4163),
    [anon_sym_case] = ACTIONS(1965),
    [anon_sym_mdo] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_7] = ACTIONS(1969),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1973),
  },
  [1553] = {
    [sym_integer] = STATE(4332),
    [sym__literal] = STATE(4332),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(4280),
    [sym_qualified_variable] = STATE(4280),
    [sym_constructor] = STATE(4074),
    [sym_qualified_constructor] = STATE(4305),
    [sym__qcon] = STATE(4280),
    [sym_con_unit] = STATE(4332),
    [sym_con_list] = STATE(4332),
    [sym_con_tuple] = STATE(4332),
    [sym_literal] = STATE(4217),
    [sym_exp_parens] = STATE(4217),
    [sym_exp_tuple] = STATE(4217),
    [sym_exp_unboxed_tuple] = STATE(4217),
    [sym_exp_unboxed_sum] = STATE(4217),
    [sym_exp_list] = STATE(4217),
    [sym_exp_arithmetic_sequence] = STATE(4217),
    [sym_exp_list_comprehension] = STATE(4217),
    [sym_exp_section_left] = STATE(4217),
    [sym_exp_section_right] = STATE(4217),
    [sym_exp_th_quoted_name] = STATE(4217),
    [sym_exp_type_application] = STATE(801),
    [sym_exp_lambda] = STATE(8644),
    [sym_exp_let] = STATE(18577),
    [sym_exp_let_in] = STATE(8644),
    [sym_exp_cond] = STATE(8644),
    [sym_exp_if_guard] = STATE(8644),
    [sym_exp_case] = STATE(8644),
    [sym_exp_lambda_case] = STATE(801),
    [sym__do_keyword] = STATE(18152),
    [sym_do_module] = STATE(18152),
    [sym_exp_do] = STATE(801),
    [sym_exp_negation] = STATE(8644),
    [sym_exp_record] = STATE(4217),
    [sym_exp_name] = STATE(4217),
    [sym_exp_projection_selector] = STATE(4217),
    [sym__aexp_projection] = STATE(4217),
    [sym_exp_projection] = STATE(4217),
    [sym__aexp] = STATE(801),
    [sym__exp_apply] = STATE(11048),
    [sym__fexp] = STATE(8644),
    [sym__lexp] = STATE(8644),
    [sym_exp_infix] = STATE(8644),
    [sym__exp_infix] = STATE(8644),
    [sym__exp] = STATE(10883),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12567),
    [sym_splice] = STATE(4217),
    [sym_quasiquote] = STATE(4217),
    [sym__varid] = ACTIONS(1933),
    [sym_float] = ACTIONS(1935),
    [sym_char] = ACTIONS(1935),
    [sym_string] = ACTIONS(1935),
    [sym__integer_literal] = ACTIONS(1937),
    [sym__binary_literal] = ACTIONS(1939),
    [sym__octal_literal] = ACTIONS(1939),
    [sym__hex_literal] = ACTIONS(1939),
    [anon_sym_LPAREN_POUND] = ACTIONS(1941),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1941),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [sym_implicit_parid] = ACTIONS(1943),
    [sym__conid] = ACTIONS(4161),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1953),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(1959),
    [anon_sym_BSLASH] = ACTIONS(1961),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4163),
    [anon_sym_case] = ACTIONS(1965),
    [anon_sym_mdo] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_7] = ACTIONS(1969),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1973),
  },
  [1554] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9761),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9761),
    [sym_exp_cond] = STATE(9761),
    [sym_exp_if_guard] = STATE(9761),
    [sym_exp_case] = STATE(9761),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9761),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9761),
    [sym__lexp] = STATE(9761),
    [sym_exp_infix] = STATE(9761),
    [sym__exp_infix] = STATE(9761),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4197),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1555] = {
    [sym_integer] = STATE(4332),
    [sym__literal] = STATE(4332),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(4280),
    [sym_qualified_variable] = STATE(4280),
    [sym_constructor] = STATE(4074),
    [sym_qualified_constructor] = STATE(4305),
    [sym__qcon] = STATE(4280),
    [sym_con_unit] = STATE(4332),
    [sym_con_list] = STATE(4332),
    [sym_con_tuple] = STATE(4332),
    [sym_literal] = STATE(4217),
    [sym_exp_parens] = STATE(4217),
    [sym_exp_tuple] = STATE(4217),
    [sym_exp_unboxed_tuple] = STATE(4217),
    [sym_exp_unboxed_sum] = STATE(4217),
    [sym_exp_list] = STATE(4217),
    [sym_exp_arithmetic_sequence] = STATE(4217),
    [sym_exp_list_comprehension] = STATE(4217),
    [sym_exp_section_left] = STATE(4217),
    [sym_exp_section_right] = STATE(4217),
    [sym_exp_th_quoted_name] = STATE(4217),
    [sym_exp_type_application] = STATE(801),
    [sym_exp_lambda] = STATE(8644),
    [sym_exp_let] = STATE(18577),
    [sym_exp_let_in] = STATE(8644),
    [sym_exp_cond] = STATE(8644),
    [sym_exp_if_guard] = STATE(8644),
    [sym_exp_case] = STATE(8644),
    [sym_exp_lambda_case] = STATE(801),
    [sym__do_keyword] = STATE(18152),
    [sym_do_module] = STATE(18152),
    [sym_exp_do] = STATE(801),
    [sym_exp_negation] = STATE(8644),
    [sym_exp_record] = STATE(4217),
    [sym_exp_name] = STATE(4217),
    [sym_exp_projection_selector] = STATE(4217),
    [sym__aexp_projection] = STATE(4217),
    [sym_exp_projection] = STATE(4217),
    [sym__aexp] = STATE(801),
    [sym__exp_apply] = STATE(11048),
    [sym__fexp] = STATE(8644),
    [sym__lexp] = STATE(8644),
    [sym_exp_infix] = STATE(8644),
    [sym__exp_infix] = STATE(8644),
    [sym__exp] = STATE(10875),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12567),
    [sym_splice] = STATE(4217),
    [sym_quasiquote] = STATE(4217),
    [sym__varid] = ACTIONS(1933),
    [sym_float] = ACTIONS(1935),
    [sym_char] = ACTIONS(1935),
    [sym_string] = ACTIONS(1935),
    [sym__integer_literal] = ACTIONS(1937),
    [sym__binary_literal] = ACTIONS(1939),
    [sym__octal_literal] = ACTIONS(1939),
    [sym__hex_literal] = ACTIONS(1939),
    [anon_sym_LPAREN_POUND] = ACTIONS(1941),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1941),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [sym_implicit_parid] = ACTIONS(1943),
    [sym__conid] = ACTIONS(4161),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1953),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(1959),
    [anon_sym_BSLASH] = ACTIONS(1961),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4163),
    [anon_sym_case] = ACTIONS(1965),
    [anon_sym_mdo] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_7] = ACTIONS(1969),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1973),
  },
  [1556] = {
    [sym_integer] = STATE(4937),
    [sym__literal] = STATE(4937),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = STATE(5329),
    [sym_qualified_variable] = STATE(5329),
    [sym_constructor] = STATE(4661),
    [sym_qualified_constructor] = STATE(5081),
    [sym__qcon] = STATE(5329),
    [sym_con_unit] = STATE(4937),
    [sym_con_list] = STATE(4937),
    [sym_con_tuple] = STATE(4937),
    [sym_literal] = STATE(5477),
    [sym_exp_parens] = STATE(5477),
    [sym_exp_tuple] = STATE(5477),
    [sym_exp_unboxed_tuple] = STATE(5477),
    [sym_exp_unboxed_sum] = STATE(5477),
    [sym_exp_list] = STATE(5477),
    [sym_exp_arithmetic_sequence] = STATE(5477),
    [sym_exp_list_comprehension] = STATE(5477),
    [sym_exp_section_left] = STATE(5477),
    [sym_exp_section_right] = STATE(5477),
    [sym_exp_th_quoted_name] = STATE(5477),
    [sym_exp_type_application] = STATE(917),
    [sym_exp_lambda] = STATE(9065),
    [sym_exp_let] = STATE(17941),
    [sym_exp_let_in] = STATE(9065),
    [sym_exp_cond] = STATE(9065),
    [sym_exp_if_guard] = STATE(9065),
    [sym_exp_case] = STATE(9065),
    [sym_exp_lambda_case] = STATE(917),
    [sym__do_keyword] = STATE(18276),
    [sym_do_module] = STATE(18276),
    [sym_exp_do] = STATE(917),
    [sym_exp_negation] = STATE(9065),
    [sym_exp_record] = STATE(5477),
    [sym_exp_name] = STATE(5477),
    [sym_exp_projection_selector] = STATE(5477),
    [sym__aexp_projection] = STATE(5477),
    [sym_exp_projection] = STATE(5477),
    [sym__aexp] = STATE(917),
    [sym__exp_apply] = STATE(12109),
    [sym__fexp] = STATE(9065),
    [sym__lexp] = STATE(9065),
    [sym_exp_infix] = STATE(9065),
    [sym__exp_infix] = STATE(9065),
    [sym__exp] = STATE(14827),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12628),
    [sym_splice] = STATE(5477),
    [sym_quasiquote] = STATE(5477),
    [sym__varid] = ACTIONS(2733),
    [sym_float] = ACTIONS(2735),
    [sym_char] = ACTIONS(2735),
    [sym_string] = ACTIONS(2735),
    [sym__integer_literal] = ACTIONS(2737),
    [sym__binary_literal] = ACTIONS(2739),
    [sym__octal_literal] = ACTIONS(2739),
    [sym__hex_literal] = ACTIONS(2739),
    [anon_sym_LPAREN_POUND] = ACTIONS(2741),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2741),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(2745),
    [sym_implicit_parid] = ACTIONS(2743),
    [sym__conid] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2759),
    [anon_sym_BSLASH] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4075),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_mdo] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_7] = ACTIONS(2769),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2773),
  },
  [1557] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8312),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8312),
    [sym_exp_cond] = STATE(8312),
    [sym_exp_if_guard] = STATE(8312),
    [sym_exp_case] = STATE(8312),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8312),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8312),
    [sym__lexp] = STATE(8312),
    [sym_exp_infix] = STATE(8312),
    [sym__exp_infix] = STATE(8312),
    [sym__exp] = STATE(10777),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1558] = {
    [sym_integer] = STATE(4332),
    [sym__literal] = STATE(4332),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(4280),
    [sym_qualified_variable] = STATE(4280),
    [sym_constructor] = STATE(4074),
    [sym_qualified_constructor] = STATE(4305),
    [sym__qcon] = STATE(4280),
    [sym_con_unit] = STATE(4332),
    [sym_con_list] = STATE(4332),
    [sym_con_tuple] = STATE(4332),
    [sym_literal] = STATE(4217),
    [sym_exp_parens] = STATE(4217),
    [sym_exp_tuple] = STATE(4217),
    [sym_exp_unboxed_tuple] = STATE(4217),
    [sym_exp_unboxed_sum] = STATE(4217),
    [sym_exp_list] = STATE(4217),
    [sym_exp_arithmetic_sequence] = STATE(4217),
    [sym_exp_list_comprehension] = STATE(4217),
    [sym_exp_section_left] = STATE(4217),
    [sym_exp_section_right] = STATE(4217),
    [sym_exp_th_quoted_name] = STATE(4217),
    [sym_exp_type_application] = STATE(801),
    [sym_exp_lambda] = STATE(8644),
    [sym_exp_let] = STATE(18577),
    [sym_exp_let_in] = STATE(8644),
    [sym_exp_cond] = STATE(8644),
    [sym_exp_if_guard] = STATE(8644),
    [sym_exp_case] = STATE(8644),
    [sym_exp_lambda_case] = STATE(801),
    [sym__do_keyword] = STATE(18152),
    [sym_do_module] = STATE(18152),
    [sym_exp_do] = STATE(801),
    [sym_exp_negation] = STATE(8644),
    [sym_exp_record] = STATE(4217),
    [sym_exp_name] = STATE(4217),
    [sym_exp_projection_selector] = STATE(4217),
    [sym__aexp_projection] = STATE(4217),
    [sym_exp_projection] = STATE(4217),
    [sym__aexp] = STATE(801),
    [sym__exp_apply] = STATE(11048),
    [sym__fexp] = STATE(8644),
    [sym__lexp] = STATE(8644),
    [sym_exp_infix] = STATE(8644),
    [sym__exp_infix] = STATE(8644),
    [sym__exp] = STATE(10874),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12567),
    [sym_splice] = STATE(4217),
    [sym_quasiquote] = STATE(4217),
    [sym__varid] = ACTIONS(1933),
    [sym_float] = ACTIONS(1935),
    [sym_char] = ACTIONS(1935),
    [sym_string] = ACTIONS(1935),
    [sym__integer_literal] = ACTIONS(1937),
    [sym__binary_literal] = ACTIONS(1939),
    [sym__octal_literal] = ACTIONS(1939),
    [sym__hex_literal] = ACTIONS(1939),
    [anon_sym_LPAREN_POUND] = ACTIONS(1941),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1941),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [sym_implicit_parid] = ACTIONS(1943),
    [sym__conid] = ACTIONS(4161),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1953),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(1959),
    [anon_sym_BSLASH] = ACTIONS(1961),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4163),
    [anon_sym_case] = ACTIONS(1965),
    [anon_sym_mdo] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_7] = ACTIONS(1969),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1973),
  },
  [1559] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8312),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8312),
    [sym_exp_cond] = STATE(8312),
    [sym_exp_if_guard] = STATE(8312),
    [sym_exp_case] = STATE(8312),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8312),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8312),
    [sym__lexp] = STATE(8312),
    [sym_exp_infix] = STATE(8312),
    [sym__exp_infix] = STATE(8312),
    [sym__exp] = STATE(10741),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1560] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18217),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1561] = {
    [sym_integer] = STATE(4332),
    [sym__literal] = STATE(4332),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(4280),
    [sym_qualified_variable] = STATE(4280),
    [sym_constructor] = STATE(4074),
    [sym_qualified_constructor] = STATE(4305),
    [sym__qcon] = STATE(4280),
    [sym_con_unit] = STATE(4332),
    [sym_con_list] = STATE(4332),
    [sym_con_tuple] = STATE(4332),
    [sym_literal] = STATE(4217),
    [sym_exp_parens] = STATE(4217),
    [sym_exp_tuple] = STATE(4217),
    [sym_exp_unboxed_tuple] = STATE(4217),
    [sym_exp_unboxed_sum] = STATE(4217),
    [sym_exp_list] = STATE(4217),
    [sym_exp_arithmetic_sequence] = STATE(4217),
    [sym_exp_list_comprehension] = STATE(4217),
    [sym_exp_section_left] = STATE(4217),
    [sym_exp_section_right] = STATE(4217),
    [sym_exp_th_quoted_name] = STATE(4217),
    [sym_exp_type_application] = STATE(801),
    [sym_exp_lambda] = STATE(8644),
    [sym_exp_let] = STATE(18577),
    [sym_exp_let_in] = STATE(8644),
    [sym_exp_cond] = STATE(8644),
    [sym_exp_if_guard] = STATE(8644),
    [sym_exp_case] = STATE(8644),
    [sym_exp_lambda_case] = STATE(801),
    [sym__do_keyword] = STATE(18152),
    [sym_do_module] = STATE(18152),
    [sym_exp_do] = STATE(801),
    [sym_exp_negation] = STATE(8644),
    [sym_exp_record] = STATE(4217),
    [sym_exp_name] = STATE(4217),
    [sym_exp_projection_selector] = STATE(4217),
    [sym__aexp_projection] = STATE(4217),
    [sym_exp_projection] = STATE(4217),
    [sym__aexp] = STATE(801),
    [sym__exp_apply] = STATE(11048),
    [sym__fexp] = STATE(8644),
    [sym__lexp] = STATE(8644),
    [sym_exp_infix] = STATE(8644),
    [sym__exp_infix] = STATE(8644),
    [sym__exp] = STATE(10873),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12567),
    [sym_splice] = STATE(4217),
    [sym_quasiquote] = STATE(4217),
    [sym__varid] = ACTIONS(1933),
    [sym_float] = ACTIONS(1935),
    [sym_char] = ACTIONS(1935),
    [sym_string] = ACTIONS(1935),
    [sym__integer_literal] = ACTIONS(1937),
    [sym__binary_literal] = ACTIONS(1939),
    [sym__octal_literal] = ACTIONS(1939),
    [sym__hex_literal] = ACTIONS(1939),
    [anon_sym_LPAREN_POUND] = ACTIONS(1941),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1941),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [sym_implicit_parid] = ACTIONS(1943),
    [sym__conid] = ACTIONS(4161),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1953),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(1959),
    [anon_sym_BSLASH] = ACTIONS(1961),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4163),
    [anon_sym_case] = ACTIONS(1965),
    [anon_sym_mdo] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_7] = ACTIONS(1969),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1973),
  },
  [1562] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(17936),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1563] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8312),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8312),
    [sym_exp_cond] = STATE(8312),
    [sym_exp_if_guard] = STATE(8312),
    [sym_exp_case] = STATE(8312),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8312),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8312),
    [sym__lexp] = STATE(8312),
    [sym_exp_infix] = STATE(8312),
    [sym__exp_infix] = STATE(8312),
    [sym__exp] = STATE(10565),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1564] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8312),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8312),
    [sym_exp_cond] = STATE(8312),
    [sym_exp_if_guard] = STATE(8312),
    [sym_exp_case] = STATE(8312),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8312),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8312),
    [sym__lexp] = STATE(8312),
    [sym_exp_infix] = STATE(8312),
    [sym__exp_infix] = STATE(8312),
    [sym__exp] = STATE(10342),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1565] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9837),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9837),
    [sym_exp_cond] = STATE(9837),
    [sym_exp_if_guard] = STATE(9837),
    [sym_exp_case] = STATE(9837),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9837),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9837),
    [sym__lexp] = STATE(9837),
    [sym_exp_infix] = STATE(9837),
    [sym__exp_infix] = STATE(9837),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4273),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1566] = {
    [sym_integer] = STATE(4976),
    [sym__literal] = STATE(4976),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = STATE(5481),
    [sym_qualified_variable] = STATE(5481),
    [sym_constructor] = STATE(4552),
    [sym_qualified_constructor] = STATE(5251),
    [sym__qcon] = STATE(5481),
    [sym_con_unit] = STATE(4976),
    [sym_con_list] = STATE(4976),
    [sym_con_tuple] = STATE(4976),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(948),
    [sym_exp_lambda] = STATE(9212),
    [sym_exp_let] = STATE(18616),
    [sym_exp_let_in] = STATE(9212),
    [sym_exp_cond] = STATE(9212),
    [sym_exp_if_guard] = STATE(9212),
    [sym_exp_case] = STATE(9212),
    [sym_exp_lambda_case] = STATE(948),
    [sym__do_keyword] = STATE(18242),
    [sym_do_module] = STATE(18242),
    [sym_exp_do] = STATE(948),
    [sym_exp_negation] = STATE(9212),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(948),
    [sym__exp_apply] = STATE(12137),
    [sym__fexp] = STATE(9212),
    [sym__lexp] = STATE(9212),
    [sym_exp_infix] = STATE(9212),
    [sym__exp_infix] = STATE(9212),
    [sym__exp] = STATE(15164),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12657),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2603),
    [sym_float] = ACTIONS(2605),
    [sym_char] = ACTIONS(2605),
    [sym_string] = ACTIONS(2605),
    [sym__integer_literal] = ACTIONS(2607),
    [sym__binary_literal] = ACTIONS(2609),
    [sym__octal_literal] = ACTIONS(2609),
    [sym__hex_literal] = ACTIONS(2609),
    [anon_sym_LPAREN_POUND] = ACTIONS(2611),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2611),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [sym_implicit_parid] = ACTIONS(2613),
    [sym__conid] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_mdo] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_7] = ACTIONS(2638),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2642),
  },
  [1567] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18122),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1568] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9719),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9719),
    [sym_exp_cond] = STATE(9719),
    [sym_exp_if_guard] = STATE(9719),
    [sym_exp_case] = STATE(9719),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9719),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9719),
    [sym__lexp] = STATE(9719),
    [sym_exp_infix] = STATE(9719),
    [sym__exp_infix] = STATE(9719),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4275),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1569] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9880),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9880),
    [sym_exp_cond] = STATE(9880),
    [sym_exp_if_guard] = STATE(9880),
    [sym_exp_case] = STATE(9880),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9880),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9880),
    [sym__lexp] = STATE(9880),
    [sym_exp_infix] = STATE(9880),
    [sym__exp_infix] = STATE(9880),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4277),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1570] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9913),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9913),
    [sym_exp_cond] = STATE(9913),
    [sym_exp_if_guard] = STATE(9913),
    [sym_exp_case] = STATE(9913),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9913),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9913),
    [sym__lexp] = STATE(9913),
    [sym_exp_infix] = STATE(9913),
    [sym__exp_infix] = STATE(9913),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4279),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1571] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18126),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1572] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9753),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9753),
    [sym_exp_cond] = STATE(9753),
    [sym_exp_if_guard] = STATE(9753),
    [sym_exp_case] = STATE(9753),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9753),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9753),
    [sym__lexp] = STATE(9753),
    [sym_exp_infix] = STATE(9753),
    [sym__exp_infix] = STATE(9753),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4281),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1573] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9913),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9913),
    [sym_exp_cond] = STATE(9913),
    [sym_exp_if_guard] = STATE(9913),
    [sym_exp_case] = STATE(9913),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9913),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9913),
    [sym__lexp] = STATE(9913),
    [sym_exp_infix] = STATE(9913),
    [sym__exp_infix] = STATE(9913),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4069),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1574] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20317),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1575] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8312),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8312),
    [sym_exp_cond] = STATE(8312),
    [sym_exp_if_guard] = STATE(8312),
    [sym_exp_case] = STATE(8312),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8312),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8312),
    [sym__lexp] = STATE(8312),
    [sym_exp_infix] = STATE(8312),
    [sym__exp_infix] = STATE(8312),
    [sym__exp] = STATE(10351),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1576] = {
    [sym_integer] = STATE(4662),
    [sym__literal] = STATE(4662),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = STATE(4833),
    [sym_qualified_variable] = STATE(4833),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4790),
    [sym__qcon] = STATE(4833),
    [sym_con_unit] = STATE(4662),
    [sym_con_list] = STATE(4662),
    [sym_con_tuple] = STATE(4662),
    [sym_literal] = STATE(4650),
    [sym_exp_parens] = STATE(4650),
    [sym_exp_tuple] = STATE(4650),
    [sym_exp_unboxed_tuple] = STATE(4650),
    [sym_exp_unboxed_sum] = STATE(4650),
    [sym_exp_list] = STATE(4650),
    [sym_exp_arithmetic_sequence] = STATE(4650),
    [sym_exp_list_comprehension] = STATE(4650),
    [sym_exp_section_left] = STATE(4650),
    [sym_exp_section_right] = STATE(4650),
    [sym_exp_th_quoted_name] = STATE(4650),
    [sym_exp_type_application] = STATE(882),
    [sym_exp_lambda] = STATE(8759),
    [sym_exp_let] = STATE(18846),
    [sym_exp_let_in] = STATE(8759),
    [sym_exp_cond] = STATE(8759),
    [sym_exp_if_guard] = STATE(8759),
    [sym_exp_case] = STATE(8759),
    [sym_exp_lambda_case] = STATE(882),
    [sym__do_keyword] = STATE(18352),
    [sym_do_module] = STATE(18352),
    [sym_exp_do] = STATE(882),
    [sym_exp_negation] = STATE(8759),
    [sym_exp_record] = STATE(4650),
    [sym_exp_name] = STATE(4650),
    [sym_exp_projection_selector] = STATE(4650),
    [sym__aexp_projection] = STATE(4650),
    [sym_exp_projection] = STATE(4650),
    [sym__aexp] = STATE(882),
    [sym__exp_apply] = STATE(11843),
    [sym__fexp] = STATE(8759),
    [sym__lexp] = STATE(8759),
    [sym_exp_infix] = STATE(8759),
    [sym__exp_infix] = STATE(8759),
    [sym__exp] = STATE(14524),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12534),
    [sym_splice] = STATE(4650),
    [sym_quasiquote] = STATE(4650),
    [sym__varid] = ACTIONS(2305),
    [sym_float] = ACTIONS(2307),
    [sym_char] = ACTIONS(2307),
    [sym_string] = ACTIONS(2307),
    [sym__integer_literal] = ACTIONS(2309),
    [sym__binary_literal] = ACTIONS(2311),
    [sym__octal_literal] = ACTIONS(2311),
    [sym__hex_literal] = ACTIONS(2311),
    [anon_sym_LPAREN_POUND] = ACTIONS(2313),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2313),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(4265),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [sym_implicit_parid] = ACTIONS(2315),
    [sym__conid] = ACTIONS(4267),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_BSLASH] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4269),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_mdo] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_7] = ACTIONS(2340),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2344),
  },
  [1577] = {
    [sym_integer] = STATE(5669),
    [sym__literal] = STATE(5669),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = STATE(5710),
    [sym_qualified_variable] = STATE(5710),
    [sym_constructor] = STATE(5151),
    [sym_qualified_constructor] = STATE(5594),
    [sym__qcon] = STATE(5710),
    [sym_con_unit] = STATE(5669),
    [sym_con_list] = STATE(5669),
    [sym_con_tuple] = STATE(5669),
    [sym_literal] = STATE(5640),
    [sym_exp_parens] = STATE(5640),
    [sym_exp_tuple] = STATE(5640),
    [sym_exp_unboxed_tuple] = STATE(5640),
    [sym_exp_unboxed_sum] = STATE(5640),
    [sym_exp_list] = STATE(5640),
    [sym_exp_arithmetic_sequence] = STATE(5640),
    [sym_exp_list_comprehension] = STATE(5640),
    [sym_exp_section_left] = STATE(5640),
    [sym_exp_section_right] = STATE(5640),
    [sym_exp_th_quoted_name] = STATE(5640),
    [sym_exp_type_application] = STATE(956),
    [sym_exp_lambda] = STATE(9227),
    [sym_exp_let] = STATE(17912),
    [sym_exp_let_in] = STATE(9227),
    [sym_exp_cond] = STATE(9227),
    [sym_exp_if_guard] = STATE(9227),
    [sym_exp_case] = STATE(9227),
    [sym_exp_lambda_case] = STATE(956),
    [sym__do_keyword] = STATE(17914),
    [sym_do_module] = STATE(17914),
    [sym_exp_do] = STATE(956),
    [sym_exp_negation] = STATE(9227),
    [sym_exp_record] = STATE(5640),
    [sym_exp_name] = STATE(5640),
    [sym_exp_projection_selector] = STATE(5640),
    [sym__aexp_projection] = STATE(5640),
    [sym_exp_projection] = STATE(5640),
    [sym__aexp] = STATE(956),
    [sym__exp_apply] = STATE(12238),
    [sym__fexp] = STATE(9227),
    [sym__lexp] = STATE(9227),
    [sym_exp_infix] = STATE(9227),
    [sym__exp_infix] = STATE(9227),
    [sym__exp] = STATE(12307),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12604),
    [sym_splice] = STATE(5640),
    [sym_quasiquote] = STATE(5640),
    [sym__varid] = ACTIONS(2945),
    [sym_float] = ACTIONS(2947),
    [sym_char] = ACTIONS(2947),
    [sym_string] = ACTIONS(2947),
    [sym__integer_literal] = ACTIONS(2949),
    [sym__binary_literal] = ACTIONS(2951),
    [sym__octal_literal] = ACTIONS(2951),
    [sym__hex_literal] = ACTIONS(2951),
    [anon_sym_LPAREN_POUND] = ACTIONS(2953),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2953),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(35),
    [anon_sym_AT] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_7] = ACTIONS(2967),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2969),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2971),
  },
  [1578] = {
    [sym_integer] = STATE(4830),
    [sym__literal] = STATE(4830),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = STATE(4419),
    [sym_qualified_variable] = STATE(4419),
    [sym_constructor] = STATE(4257),
    [sym_qualified_constructor] = STATE(4416),
    [sym__qcon] = STATE(4419),
    [sym_con_unit] = STATE(4830),
    [sym_con_list] = STATE(4830),
    [sym_con_tuple] = STATE(4830),
    [sym_literal] = STATE(4455),
    [sym_exp_parens] = STATE(4455),
    [sym_exp_tuple] = STATE(4455),
    [sym_exp_unboxed_tuple] = STATE(4455),
    [sym_exp_unboxed_sum] = STATE(4455),
    [sym_exp_list] = STATE(4455),
    [sym_exp_arithmetic_sequence] = STATE(4455),
    [sym_exp_list_comprehension] = STATE(4455),
    [sym_exp_section_left] = STATE(4455),
    [sym_exp_section_right] = STATE(4455),
    [sym_exp_th_quoted_name] = STATE(4455),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(8848),
    [sym_exp_let] = STATE(18318),
    [sym_exp_let_in] = STATE(8848),
    [sym_exp_cond] = STATE(8848),
    [sym_exp_if_guard] = STATE(8848),
    [sym_exp_case] = STATE(8848),
    [sym_exp_lambda_case] = STATE(828),
    [sym__do_keyword] = STATE(18263),
    [sym_do_module] = STATE(18263),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(8848),
    [sym_exp_record] = STATE(4455),
    [sym_exp_name] = STATE(4455),
    [sym_exp_projection_selector] = STATE(4455),
    [sym__aexp_projection] = STATE(4455),
    [sym_exp_projection] = STATE(4455),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(11903),
    [sym__fexp] = STATE(8848),
    [sym__lexp] = STATE(8848),
    [sym_exp_infix] = STATE(8848),
    [sym__exp_infix] = STATE(8848),
    [sym__exp] = STATE(14414),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12635),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(2080),
    [sym_float] = ACTIONS(2082),
    [sym_char] = ACTIONS(2082),
    [sym_string] = ACTIONS(2082),
    [sym__integer_literal] = ACTIONS(2084),
    [sym__binary_literal] = ACTIONS(2086),
    [sym__octal_literal] = ACTIONS(2086),
    [sym__hex_literal] = ACTIONS(2086),
    [anon_sym_LPAREN_POUND] = ACTIONS(2088),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2088),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2090),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [sym_implicit_parid] = ACTIONS(2090),
    [sym__conid] = ACTIONS(4055),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_BSLASH] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4057),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_mdo] = ACTIONS(2114),
    [anon_sym_do] = ACTIONS(2114),
    [anon_sym_7] = ACTIONS(2116),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2120),
  },
  [1579] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9880),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9880),
    [sym_exp_cond] = STATE(9880),
    [sym_exp_if_guard] = STATE(9880),
    [sym_exp_case] = STATE(9880),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9880),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9880),
    [sym__lexp] = STATE(9880),
    [sym_exp_infix] = STATE(9880),
    [sym__exp_infix] = STATE(9880),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4283),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1580] = {
    [sym_integer] = STATE(5669),
    [sym__literal] = STATE(5669),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = STATE(5710),
    [sym_qualified_variable] = STATE(5710),
    [sym_constructor] = STATE(5151),
    [sym_qualified_constructor] = STATE(5594),
    [sym__qcon] = STATE(5710),
    [sym_con_unit] = STATE(5669),
    [sym_con_list] = STATE(5669),
    [sym_con_tuple] = STATE(5669),
    [sym_literal] = STATE(5640),
    [sym_exp_parens] = STATE(5640),
    [sym_exp_tuple] = STATE(5640),
    [sym_exp_unboxed_tuple] = STATE(5640),
    [sym_exp_unboxed_sum] = STATE(5640),
    [sym_exp_list] = STATE(5640),
    [sym_exp_arithmetic_sequence] = STATE(5640),
    [sym_exp_list_comprehension] = STATE(5640),
    [sym_exp_section_left] = STATE(5640),
    [sym_exp_section_right] = STATE(5640),
    [sym_exp_th_quoted_name] = STATE(5640),
    [sym_exp_type_application] = STATE(956),
    [sym_exp_lambda] = STATE(9227),
    [sym_exp_let] = STATE(17912),
    [sym_exp_let_in] = STATE(9227),
    [sym_exp_cond] = STATE(9227),
    [sym_exp_if_guard] = STATE(9227),
    [sym_exp_case] = STATE(9227),
    [sym_exp_lambda_case] = STATE(956),
    [sym__do_keyword] = STATE(17914),
    [sym_do_module] = STATE(17914),
    [sym_exp_do] = STATE(956),
    [sym_exp_negation] = STATE(9227),
    [sym_exp_record] = STATE(5640),
    [sym_exp_name] = STATE(5640),
    [sym_exp_projection_selector] = STATE(5640),
    [sym__aexp_projection] = STATE(5640),
    [sym_exp_projection] = STATE(5640),
    [sym__aexp] = STATE(956),
    [sym__exp_apply] = STATE(12238),
    [sym__fexp] = STATE(9227),
    [sym__lexp] = STATE(9227),
    [sym_exp_infix] = STATE(9227),
    [sym__exp_infix] = STATE(9227),
    [sym__exp] = STATE(12319),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12604),
    [sym_splice] = STATE(5640),
    [sym_quasiquote] = STATE(5640),
    [sym__varid] = ACTIONS(2945),
    [sym_float] = ACTIONS(2947),
    [sym_char] = ACTIONS(2947),
    [sym_string] = ACTIONS(2947),
    [sym__integer_literal] = ACTIONS(2949),
    [sym__binary_literal] = ACTIONS(2951),
    [sym__octal_literal] = ACTIONS(2951),
    [sym__hex_literal] = ACTIONS(2951),
    [anon_sym_LPAREN_POUND] = ACTIONS(2953),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2953),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(35),
    [anon_sym_AT] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_7] = ACTIONS(2967),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2969),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2971),
  },
  [1581] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9763),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9763),
    [sym_exp_cond] = STATE(9763),
    [sym_exp_if_guard] = STATE(9763),
    [sym_exp_case] = STATE(9763),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9763),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9763),
    [sym__lexp] = STATE(9763),
    [sym_exp_infix] = STATE(9763),
    [sym__exp_infix] = STATE(9763),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4285),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1582] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18255),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1583] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20183),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1584] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(750),
    [sym_variable] = STATE(4795),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(4308),
    [sym_qualified_constructor] = STATE(4664),
    [sym__qcon] = STATE(4795),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(5587),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9219),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9219),
    [sym_exp_cond] = STATE(9219),
    [sym_exp_if_guard] = STATE(9219),
    [sym_exp_case] = STATE(9219),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9219),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9219),
    [sym__lexp] = STATE(9219),
    [sym_exp_infix] = STATE(9219),
    [sym__exp_infix] = STATE(9219),
    [sym__exp] = STATE(12309),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12545),
    [sym_splice] = STATE(5587),
    [sym_quasiquote] = STATE(5587),
    [sym__varid] = ACTIONS(3014),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(3016),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3016),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
  },
  [1585] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(750),
    [sym_variable] = STATE(4795),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(4308),
    [sym_qualified_constructor] = STATE(4664),
    [sym__qcon] = STATE(4795),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(5587),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9219),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9219),
    [sym_exp_cond] = STATE(9219),
    [sym_exp_if_guard] = STATE(9219),
    [sym_exp_case] = STATE(9219),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9219),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9219),
    [sym__lexp] = STATE(9219),
    [sym_exp_infix] = STATE(9219),
    [sym__exp_infix] = STATE(9219),
    [sym__exp] = STATE(12313),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12545),
    [sym_splice] = STATE(5587),
    [sym_quasiquote] = STATE(5587),
    [sym__varid] = ACTIONS(3014),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(3016),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3016),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
  },
  [1586] = {
    [sym_integer] = STATE(4662),
    [sym__literal] = STATE(4662),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = STATE(4833),
    [sym_qualified_variable] = STATE(4833),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4790),
    [sym__qcon] = STATE(4833),
    [sym_con_unit] = STATE(4662),
    [sym_con_list] = STATE(4662),
    [sym_con_tuple] = STATE(4662),
    [sym_literal] = STATE(4650),
    [sym_exp_parens] = STATE(4650),
    [sym_exp_tuple] = STATE(4650),
    [sym_exp_unboxed_tuple] = STATE(4650),
    [sym_exp_unboxed_sum] = STATE(4650),
    [sym_exp_list] = STATE(4650),
    [sym_exp_arithmetic_sequence] = STATE(4650),
    [sym_exp_list_comprehension] = STATE(4650),
    [sym_exp_section_left] = STATE(4650),
    [sym_exp_section_right] = STATE(4650),
    [sym_exp_th_quoted_name] = STATE(4650),
    [sym_exp_type_application] = STATE(882),
    [sym_exp_lambda] = STATE(8780),
    [sym_exp_let] = STATE(18846),
    [sym_exp_let_in] = STATE(8780),
    [sym_exp_cond] = STATE(8780),
    [sym_exp_if_guard] = STATE(8780),
    [sym_exp_case] = STATE(8780),
    [sym_exp_lambda_case] = STATE(882),
    [sym__do_keyword] = STATE(18352),
    [sym_do_module] = STATE(18352),
    [sym_exp_do] = STATE(882),
    [sym_exp_negation] = STATE(8780),
    [sym_exp_record] = STATE(4650),
    [sym_exp_name] = STATE(4650),
    [sym_exp_projection_selector] = STATE(4650),
    [sym__aexp_projection] = STATE(4650),
    [sym_exp_projection] = STATE(4650),
    [sym__aexp] = STATE(882),
    [sym__exp_apply] = STATE(11843),
    [sym__fexp] = STATE(8780),
    [sym__lexp] = STATE(8780),
    [sym_exp_infix] = STATE(8780),
    [sym__exp_infix] = STATE(8780),
    [sym__exp] = STATE(11673),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12534),
    [sym_splice] = STATE(4650),
    [sym_quasiquote] = STATE(4650),
    [sym__varid] = ACTIONS(2305),
    [sym_float] = ACTIONS(2307),
    [sym_char] = ACTIONS(2307),
    [sym_string] = ACTIONS(2307),
    [sym__integer_literal] = ACTIONS(2309),
    [sym__binary_literal] = ACTIONS(2311),
    [sym__octal_literal] = ACTIONS(2311),
    [sym__hex_literal] = ACTIONS(2311),
    [anon_sym_LPAREN_POUND] = ACTIONS(2313),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2313),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(4265),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [sym_implicit_parid] = ACTIONS(2315),
    [sym__conid] = ACTIONS(4267),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_BSLASH] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4269),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_mdo] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_7] = ACTIONS(2340),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2344),
  },
  [1587] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9749),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9749),
    [sym_exp_cond] = STATE(9749),
    [sym_exp_if_guard] = STATE(9749),
    [sym_exp_case] = STATE(9749),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9749),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9749),
    [sym__lexp] = STATE(9749),
    [sym_exp_infix] = STATE(9749),
    [sym__exp_infix] = STATE(9749),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4291),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1588] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(750),
    [sym_variable] = STATE(4795),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(4308),
    [sym_qualified_constructor] = STATE(4664),
    [sym__qcon] = STATE(4795),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(5587),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9219),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9219),
    [sym_exp_cond] = STATE(9219),
    [sym_exp_if_guard] = STATE(9219),
    [sym_exp_case] = STATE(9219),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9219),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9219),
    [sym__lexp] = STATE(9219),
    [sym_exp_infix] = STATE(9219),
    [sym__exp_infix] = STATE(9219),
    [sym__exp] = STATE(12385),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12545),
    [sym_splice] = STATE(5587),
    [sym_quasiquote] = STATE(5587),
    [sym__varid] = ACTIONS(3014),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(3016),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3016),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
  },
  [1589] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19742),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1590] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18497),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1591] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18304),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1592] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(750),
    [sym_variable] = STATE(4795),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(4308),
    [sym_qualified_constructor] = STATE(4664),
    [sym__qcon] = STATE(4795),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(5587),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9219),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9219),
    [sym_exp_cond] = STATE(9219),
    [sym_exp_if_guard] = STATE(9219),
    [sym_exp_case] = STATE(9219),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9219),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9219),
    [sym__lexp] = STATE(9219),
    [sym_exp_infix] = STATE(9219),
    [sym__exp_infix] = STATE(9219),
    [sym__exp] = STATE(12396),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12545),
    [sym_splice] = STATE(5587),
    [sym_quasiquote] = STATE(5587),
    [sym__varid] = ACTIONS(3014),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(3016),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3016),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
  },
  [1593] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9773),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9773),
    [sym_exp_cond] = STATE(9773),
    [sym_exp_if_guard] = STATE(9773),
    [sym_exp_case] = STATE(9773),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9773),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9773),
    [sym__lexp] = STATE(9773),
    [sym_exp_infix] = STATE(9773),
    [sym__exp_infix] = STATE(9773),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4293),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1594] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9880),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9880),
    [sym_exp_cond] = STATE(9880),
    [sym_exp_if_guard] = STATE(9880),
    [sym_exp_case] = STATE(9880),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9880),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9880),
    [sym__lexp] = STATE(9880),
    [sym_exp_infix] = STATE(9880),
    [sym__exp_infix] = STATE(9880),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4067),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1595] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18500),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1596] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(750),
    [sym_variable] = STATE(4795),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(4308),
    [sym_qualified_constructor] = STATE(4664),
    [sym__qcon] = STATE(4795),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(5587),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9219),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9219),
    [sym_exp_cond] = STATE(9219),
    [sym_exp_if_guard] = STATE(9219),
    [sym_exp_case] = STATE(9219),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9219),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9219),
    [sym__lexp] = STATE(9219),
    [sym_exp_infix] = STATE(9219),
    [sym__exp_infix] = STATE(9219),
    [sym__exp] = STATE(12407),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12545),
    [sym_splice] = STATE(5587),
    [sym_quasiquote] = STATE(5587),
    [sym__varid] = ACTIONS(3014),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(3016),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3016),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
  },
  [1597] = {
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = STATE(4572),
    [sym_qualified_variable] = STATE(4572),
    [sym_constructor] = STATE(4245),
    [sym_qualified_constructor] = STATE(4556),
    [sym__qcon] = STATE(4572),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4959),
    [sym_exp_parens] = STATE(4959),
    [sym_exp_tuple] = STATE(4959),
    [sym_exp_unboxed_tuple] = STATE(4959),
    [sym_exp_unboxed_sum] = STATE(4959),
    [sym_exp_list] = STATE(4959),
    [sym_exp_arithmetic_sequence] = STATE(4959),
    [sym_exp_list_comprehension] = STATE(4959),
    [sym_exp_section_left] = STATE(4959),
    [sym_exp_section_right] = STATE(4959),
    [sym_exp_th_quoted_name] = STATE(4959),
    [sym_exp_type_application] = STATE(947),
    [sym_exp_lambda] = STATE(9082),
    [sym_exp_let] = STATE(18678),
    [sym_exp_let_in] = STATE(9082),
    [sym_exp_cond] = STATE(9082),
    [sym_exp_if_guard] = STATE(9082),
    [sym_exp_case] = STATE(9082),
    [sym_exp_lambda_case] = STATE(947),
    [sym__do_keyword] = STATE(18401),
    [sym_do_module] = STATE(18401),
    [sym_exp_do] = STATE(947),
    [sym_exp_negation] = STATE(9082),
    [sym_exp_record] = STATE(4959),
    [sym_exp_name] = STATE(4959),
    [sym_exp_projection_selector] = STATE(4959),
    [sym__aexp_projection] = STATE(4959),
    [sym_exp_projection] = STATE(4959),
    [sym__aexp] = STATE(947),
    [sym__exp_apply] = STATE(12092),
    [sym__fexp] = STATE(9082),
    [sym__lexp] = STATE(9082),
    [sym_exp_infix] = STATE(9082),
    [sym__exp_infix] = STATE(9082),
    [sym__exp] = STATE(12097),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12712),
    [sym_splice] = STATE(4959),
    [sym_quasiquote] = STATE(4959),
    [sym__varid] = ACTIONS(2529),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2531),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2531),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [sym_implicit_parid] = ACTIONS(2533),
    [sym__conid] = ACTIONS(4243),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [anon_sym_BSLASH] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4245),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_mdo] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
  },
  [1598] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9728),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9728),
    [sym_exp_cond] = STATE(9728),
    [sym_exp_if_guard] = STATE(9728),
    [sym_exp_case] = STATE(9728),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9728),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9728),
    [sym__lexp] = STATE(9728),
    [sym_exp_infix] = STATE(9728),
    [sym__exp_infix] = STATE(9728),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4295),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1599] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(750),
    [sym_variable] = STATE(4795),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(4308),
    [sym_qualified_constructor] = STATE(4664),
    [sym__qcon] = STATE(4795),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(5587),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9219),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9219),
    [sym_exp_cond] = STATE(9219),
    [sym_exp_if_guard] = STATE(9219),
    [sym_exp_case] = STATE(9219),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9219),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9219),
    [sym__lexp] = STATE(9219),
    [sym_exp_infix] = STATE(9219),
    [sym__exp_infix] = STATE(9219),
    [sym__exp] = STATE(12410),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12545),
    [sym_splice] = STATE(5587),
    [sym_quasiquote] = STATE(5587),
    [sym__varid] = ACTIONS(3014),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(3016),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3016),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
  },
  [1600] = {
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = STATE(4572),
    [sym_qualified_variable] = STATE(4572),
    [sym_constructor] = STATE(4245),
    [sym_qualified_constructor] = STATE(4556),
    [sym__qcon] = STATE(4572),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4959),
    [sym_exp_parens] = STATE(4959),
    [sym_exp_tuple] = STATE(4959),
    [sym_exp_unboxed_tuple] = STATE(4959),
    [sym_exp_unboxed_sum] = STATE(4959),
    [sym_exp_list] = STATE(4959),
    [sym_exp_arithmetic_sequence] = STATE(4959),
    [sym_exp_list_comprehension] = STATE(4959),
    [sym_exp_section_left] = STATE(4959),
    [sym_exp_section_right] = STATE(4959),
    [sym_exp_th_quoted_name] = STATE(4959),
    [sym_exp_type_application] = STATE(947),
    [sym_exp_lambda] = STATE(9082),
    [sym_exp_let] = STATE(18678),
    [sym_exp_let_in] = STATE(9082),
    [sym_exp_cond] = STATE(9082),
    [sym_exp_if_guard] = STATE(9082),
    [sym_exp_case] = STATE(9082),
    [sym_exp_lambda_case] = STATE(947),
    [sym__do_keyword] = STATE(18401),
    [sym_do_module] = STATE(18401),
    [sym_exp_do] = STATE(947),
    [sym_exp_negation] = STATE(9082),
    [sym_exp_record] = STATE(4959),
    [sym_exp_name] = STATE(4959),
    [sym_exp_projection_selector] = STATE(4959),
    [sym__aexp_projection] = STATE(4959),
    [sym_exp_projection] = STATE(4959),
    [sym__aexp] = STATE(947),
    [sym__exp_apply] = STATE(12092),
    [sym__fexp] = STATE(9082),
    [sym__lexp] = STATE(9082),
    [sym_exp_infix] = STATE(9082),
    [sym__exp_infix] = STATE(9082),
    [sym__exp] = STATE(12221),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12712),
    [sym_splice] = STATE(4959),
    [sym_quasiquote] = STATE(4959),
    [sym__varid] = ACTIONS(2529),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2531),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2531),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [sym_implicit_parid] = ACTIONS(2533),
    [sym__conid] = ACTIONS(4243),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [anon_sym_BSLASH] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4245),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_mdo] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
  },
  [1601] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(8312),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(8312),
    [sym_exp_cond] = STATE(8312),
    [sym_exp_if_guard] = STATE(8312),
    [sym_exp_case] = STATE(8312),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(8312),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(8312),
    [sym__lexp] = STATE(8312),
    [sym_exp_infix] = STATE(8312),
    [sym__exp_infix] = STATE(8312),
    [sym__exp] = STATE(10507),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1602] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18477),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1603] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18314),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1604] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18487),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1605] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18410),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1606] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20058),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1607] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18377),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1608] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19622),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1609] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18602),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1610] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9202),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9202),
    [sym_exp_cond] = STATE(9202),
    [sym_exp_if_guard] = STATE(9202),
    [sym_exp_case] = STATE(9202),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9202),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9202),
    [sym__lexp] = STATE(9202),
    [sym_exp_infix] = STATE(9202),
    [sym__exp_infix] = STATE(9202),
    [sym__exp] = STATE(12122),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1611] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9202),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9202),
    [sym_exp_cond] = STATE(9202),
    [sym_exp_if_guard] = STATE(9202),
    [sym_exp_case] = STATE(9202),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9202),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9202),
    [sym__lexp] = STATE(9202),
    [sym_exp_infix] = STATE(9202),
    [sym__exp_infix] = STATE(9202),
    [sym__exp] = STATE(12130),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1612] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18382),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1613] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18619),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1614] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19934),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1615] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18611),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1616] = {
    [sym_integer] = STATE(5749),
    [sym__literal] = STATE(5749),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = STATE(5599),
    [sym_qualified_variable] = STATE(5599),
    [sym_constructor] = STATE(5259),
    [sym_qualified_constructor] = STATE(5552),
    [sym__qcon] = STATE(5599),
    [sym_con_unit] = STATE(5749),
    [sym_con_list] = STATE(5749),
    [sym_con_tuple] = STATE(5749),
    [sym_literal] = STATE(5638),
    [sym_exp_parens] = STATE(5638),
    [sym_exp_tuple] = STATE(5638),
    [sym_exp_unboxed_tuple] = STATE(5638),
    [sym_exp_unboxed_sum] = STATE(5638),
    [sym_exp_list] = STATE(5638),
    [sym_exp_arithmetic_sequence] = STATE(5638),
    [sym_exp_list_comprehension] = STATE(5638),
    [sym_exp_section_left] = STATE(5638),
    [sym_exp_section_right] = STATE(5638),
    [sym_exp_th_quoted_name] = STATE(5638),
    [sym_exp_type_application] = STATE(964),
    [sym_exp_lambda] = STATE(9241),
    [sym_exp_let] = STATE(18245),
    [sym_exp_let_in] = STATE(9241),
    [sym_exp_cond] = STATE(9241),
    [sym_exp_if_guard] = STATE(9241),
    [sym_exp_case] = STATE(9241),
    [sym_exp_lambda_case] = STATE(964),
    [sym__do_keyword] = STATE(18319),
    [sym_do_module] = STATE(18319),
    [sym_exp_do] = STATE(964),
    [sym_exp_negation] = STATE(9241),
    [sym_exp_record] = STATE(5638),
    [sym_exp_name] = STATE(5638),
    [sym_exp_projection_selector] = STATE(5638),
    [sym__aexp_projection] = STATE(5638),
    [sym_exp_projection] = STATE(5638),
    [sym__aexp] = STATE(964),
    [sym__exp_apply] = STATE(12426),
    [sym__fexp] = STATE(9241),
    [sym__lexp] = STATE(9241),
    [sym_exp_infix] = STATE(9241),
    [sym__exp_infix] = STATE(9241),
    [sym__exp] = STATE(15433),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12705),
    [sym_splice] = STATE(5638),
    [sym_quasiquote] = STATE(5638),
    [sym__varid] = ACTIONS(2973),
    [sym_float] = ACTIONS(2975),
    [sym_char] = ACTIONS(2975),
    [sym_string] = ACTIONS(2975),
    [sym__integer_literal] = ACTIONS(2977),
    [sym__binary_literal] = ACTIONS(2979),
    [sym__octal_literal] = ACTIONS(2979),
    [sym__hex_literal] = ACTIONS(2979),
    [anon_sym_LPAREN_POUND] = ACTIONS(2981),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2981),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [sym_implicit_parid] = ACTIONS(2983),
    [sym__conid] = ACTIONS(4153),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2998),
    [anon_sym_BSLASH] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4155),
    [anon_sym_case] = ACTIONS(3004),
    [anon_sym_mdo] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_7] = ACTIONS(3008),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3012),
  },
  [1617] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9202),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9202),
    [sym_exp_cond] = STATE(9202),
    [sym_exp_if_guard] = STATE(9202),
    [sym_exp_case] = STATE(9202),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9202),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9202),
    [sym__lexp] = STATE(9202),
    [sym_exp_infix] = STATE(9202),
    [sym__exp_infix] = STATE(9202),
    [sym__exp] = STATE(12131),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1618] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9202),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9202),
    [sym_exp_cond] = STATE(9202),
    [sym_exp_if_guard] = STATE(9202),
    [sym_exp_case] = STATE(9202),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9202),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9202),
    [sym__lexp] = STATE(9202),
    [sym_exp_infix] = STATE(9202),
    [sym__exp_infix] = STATE(9202),
    [sym__exp] = STATE(12136),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1619] = {
    [sym_integer] = STATE(4558),
    [sym__literal] = STATE(4558),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = STATE(4824),
    [sym_qualified_variable] = STATE(4824),
    [sym_constructor] = STATE(4319),
    [sym_qualified_constructor] = STATE(4645),
    [sym__qcon] = STATE(4824),
    [sym_con_unit] = STATE(4558),
    [sym_con_list] = STATE(4558),
    [sym_con_tuple] = STATE(4558),
    [sym_literal] = STATE(4778),
    [sym_exp_parens] = STATE(4778),
    [sym_exp_tuple] = STATE(4778),
    [sym_exp_unboxed_tuple] = STATE(4778),
    [sym_exp_unboxed_sum] = STATE(4778),
    [sym_exp_list] = STATE(4778),
    [sym_exp_arithmetic_sequence] = STATE(4778),
    [sym_exp_list_comprehension] = STATE(4778),
    [sym_exp_section_left] = STATE(4778),
    [sym_exp_section_right] = STATE(4778),
    [sym_exp_th_quoted_name] = STATE(4778),
    [sym_exp_type_application] = STATE(875),
    [sym_exp_lambda] = STATE(8927),
    [sym_exp_let] = STATE(18765),
    [sym_exp_let_in] = STATE(8927),
    [sym_exp_cond] = STATE(8927),
    [sym_exp_if_guard] = STATE(8927),
    [sym_exp_case] = STATE(8927),
    [sym_exp_lambda_case] = STATE(875),
    [sym__do_keyword] = STATE(18183),
    [sym_do_module] = STATE(18183),
    [sym_exp_do] = STATE(875),
    [sym_exp_negation] = STATE(8927),
    [sym_exp_record] = STATE(4778),
    [sym_exp_name] = STATE(4778),
    [sym_exp_projection_selector] = STATE(4778),
    [sym__aexp_projection] = STATE(4778),
    [sym_exp_projection] = STATE(4778),
    [sym__aexp] = STATE(875),
    [sym__exp_apply] = STATE(11760),
    [sym__fexp] = STATE(8927),
    [sym__lexp] = STATE(8927),
    [sym_exp_infix] = STATE(8927),
    [sym__exp_infix] = STATE(8927),
    [sym__exp] = STATE(14263),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12688),
    [sym_splice] = STATE(4778),
    [sym_quasiquote] = STATE(4778),
    [sym__varid] = ACTIONS(2407),
    [sym_float] = ACTIONS(2409),
    [sym_char] = ACTIONS(2409),
    [sym_string] = ACTIONS(2409),
    [sym__integer_literal] = ACTIONS(2411),
    [sym__binary_literal] = ACTIONS(2413),
    [sym__octal_literal] = ACTIONS(2413),
    [sym__hex_literal] = ACTIONS(2413),
    [anon_sym_LPAREN_POUND] = ACTIONS(2415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2415),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(4209),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [sym_implicit_parid] = ACTIONS(2417),
    [sym__conid] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2431),
    [anon_sym_AT] = ACTIONS(2433),
    [anon_sym_BSLASH] = ACTIONS(2435),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4213),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_mdo] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_7] = ACTIONS(2443),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2447),
  },
  [1620] = {
    [sym_integer] = STATE(4976),
    [sym__literal] = STATE(4976),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = STATE(5481),
    [sym_qualified_variable] = STATE(5481),
    [sym_constructor] = STATE(4552),
    [sym_qualified_constructor] = STATE(5251),
    [sym__qcon] = STATE(5481),
    [sym_con_unit] = STATE(4976),
    [sym_con_list] = STATE(4976),
    [sym_con_tuple] = STATE(4976),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(948),
    [sym_exp_lambda] = STATE(9212),
    [sym_exp_let] = STATE(18616),
    [sym_exp_let_in] = STATE(9212),
    [sym_exp_cond] = STATE(9212),
    [sym_exp_if_guard] = STATE(9212),
    [sym_exp_case] = STATE(9212),
    [sym_exp_lambda_case] = STATE(948),
    [sym__do_keyword] = STATE(18242),
    [sym_do_module] = STATE(18242),
    [sym_exp_do] = STATE(948),
    [sym_exp_negation] = STATE(9212),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(948),
    [sym__exp_apply] = STATE(12137),
    [sym__fexp] = STATE(9212),
    [sym__lexp] = STATE(9212),
    [sym_exp_infix] = STATE(9212),
    [sym__exp_infix] = STATE(9212),
    [sym__exp] = STATE(14909),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12657),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2603),
    [sym_float] = ACTIONS(2605),
    [sym_char] = ACTIONS(2605),
    [sym_string] = ACTIONS(2605),
    [sym__integer_literal] = ACTIONS(2607),
    [sym__binary_literal] = ACTIONS(2609),
    [sym__octal_literal] = ACTIONS(2609),
    [sym__hex_literal] = ACTIONS(2609),
    [anon_sym_LPAREN_POUND] = ACTIONS(2611),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2611),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [sym_implicit_parid] = ACTIONS(2613),
    [sym__conid] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_mdo] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_7] = ACTIONS(2638),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2642),
  },
  [1621] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9202),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9202),
    [sym_exp_cond] = STATE(9202),
    [sym_exp_if_guard] = STATE(9202),
    [sym_exp_case] = STATE(9202),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9202),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9202),
    [sym__lexp] = STATE(9202),
    [sym_exp_infix] = STATE(9202),
    [sym__exp_infix] = STATE(9202),
    [sym__exp] = STATE(12156),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1622] = {
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = STATE(4572),
    [sym_qualified_variable] = STATE(4572),
    [sym_constructor] = STATE(4245),
    [sym_qualified_constructor] = STATE(4556),
    [sym__qcon] = STATE(4572),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4959),
    [sym_exp_parens] = STATE(4959),
    [sym_exp_tuple] = STATE(4959),
    [sym_exp_unboxed_tuple] = STATE(4959),
    [sym_exp_unboxed_sum] = STATE(4959),
    [sym_exp_list] = STATE(4959),
    [sym_exp_arithmetic_sequence] = STATE(4959),
    [sym_exp_list_comprehension] = STATE(4959),
    [sym_exp_section_left] = STATE(4959),
    [sym_exp_section_right] = STATE(4959),
    [sym_exp_th_quoted_name] = STATE(4959),
    [sym_exp_type_application] = STATE(947),
    [sym_exp_lambda] = STATE(9082),
    [sym_exp_let] = STATE(18678),
    [sym_exp_let_in] = STATE(9082),
    [sym_exp_cond] = STATE(9082),
    [sym_exp_if_guard] = STATE(9082),
    [sym_exp_case] = STATE(9082),
    [sym_exp_lambda_case] = STATE(947),
    [sym__do_keyword] = STATE(18401),
    [sym_do_module] = STATE(18401),
    [sym_exp_do] = STATE(947),
    [sym_exp_negation] = STATE(9082),
    [sym_exp_record] = STATE(4959),
    [sym_exp_name] = STATE(4959),
    [sym_exp_projection_selector] = STATE(4959),
    [sym__aexp_projection] = STATE(4959),
    [sym_exp_projection] = STATE(4959),
    [sym__aexp] = STATE(947),
    [sym__exp_apply] = STATE(12092),
    [sym__fexp] = STATE(9082),
    [sym__lexp] = STATE(9082),
    [sym_exp_infix] = STATE(9082),
    [sym__exp_infix] = STATE(9082),
    [sym__exp] = STATE(12095),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12712),
    [sym_splice] = STATE(4959),
    [sym_quasiquote] = STATE(4959),
    [sym__varid] = ACTIONS(2529),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2531),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2531),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [sym_implicit_parid] = ACTIONS(2533),
    [sym__conid] = ACTIONS(4243),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [anon_sym_BSLASH] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4245),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_mdo] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
  },
  [1623] = {
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = STATE(4572),
    [sym_qualified_variable] = STATE(4572),
    [sym_constructor] = STATE(4245),
    [sym_qualified_constructor] = STATE(4556),
    [sym__qcon] = STATE(4572),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4959),
    [sym_exp_parens] = STATE(4959),
    [sym_exp_tuple] = STATE(4959),
    [sym_exp_unboxed_tuple] = STATE(4959),
    [sym_exp_unboxed_sum] = STATE(4959),
    [sym_exp_list] = STATE(4959),
    [sym_exp_arithmetic_sequence] = STATE(4959),
    [sym_exp_list_comprehension] = STATE(4959),
    [sym_exp_section_left] = STATE(4959),
    [sym_exp_section_right] = STATE(4959),
    [sym_exp_th_quoted_name] = STATE(4959),
    [sym_exp_type_application] = STATE(947),
    [sym_exp_lambda] = STATE(9082),
    [sym_exp_let] = STATE(18678),
    [sym_exp_let_in] = STATE(9082),
    [sym_exp_cond] = STATE(9082),
    [sym_exp_if_guard] = STATE(9082),
    [sym_exp_case] = STATE(9082),
    [sym_exp_lambda_case] = STATE(947),
    [sym__do_keyword] = STATE(18401),
    [sym_do_module] = STATE(18401),
    [sym_exp_do] = STATE(947),
    [sym_exp_negation] = STATE(9082),
    [sym_exp_record] = STATE(4959),
    [sym_exp_name] = STATE(4959),
    [sym_exp_projection_selector] = STATE(4959),
    [sym__aexp_projection] = STATE(4959),
    [sym_exp_projection] = STATE(4959),
    [sym__aexp] = STATE(947),
    [sym__exp_apply] = STATE(12092),
    [sym__fexp] = STATE(9082),
    [sym__lexp] = STATE(9082),
    [sym_exp_infix] = STATE(9082),
    [sym__exp_infix] = STATE(9082),
    [sym__exp] = STATE(12094),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12712),
    [sym_splice] = STATE(4959),
    [sym_quasiquote] = STATE(4959),
    [sym__varid] = ACTIONS(2529),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2531),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2531),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [sym_implicit_parid] = ACTIONS(2533),
    [sym__conid] = ACTIONS(4243),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [anon_sym_BSLASH] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4245),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_mdo] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
  },
  [1624] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(9202),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(9202),
    [sym_exp_cond] = STATE(9202),
    [sym_exp_if_guard] = STATE(9202),
    [sym_exp_case] = STATE(9202),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(9202),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(9202),
    [sym__lexp] = STATE(9202),
    [sym_exp_infix] = STATE(9202),
    [sym__exp_infix] = STATE(9202),
    [sym__exp] = STATE(12208),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1625] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19355),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1626] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18787),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1627] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9828),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9828),
    [sym_exp_cond] = STATE(9828),
    [sym_exp_if_guard] = STATE(9828),
    [sym_exp_case] = STATE(9828),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9828),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9828),
    [sym__lexp] = STATE(9828),
    [sym_exp_infix] = STATE(9828),
    [sym__exp_infix] = STATE(9828),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4279),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1628] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18797),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1629] = {
    [sym_integer] = STATE(4913),
    [sym__literal] = STATE(4913),
    [sym__unboxed_open] = STATE(747),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4400),
    [sym_qualified_constructor] = STATE(5105),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(4913),
    [sym_con_list] = STATE(4913),
    [sym_con_tuple] = STATE(4913),
    [sym_literal] = STATE(5786),
    [sym_exp_parens] = STATE(5786),
    [sym_exp_tuple] = STATE(5786),
    [sym_exp_unboxed_tuple] = STATE(5786),
    [sym_exp_unboxed_sum] = STATE(5786),
    [sym_exp_list] = STATE(5786),
    [sym_exp_arithmetic_sequence] = STATE(5786),
    [sym_exp_list_comprehension] = STATE(5786),
    [sym_exp_section_left] = STATE(5786),
    [sym_exp_section_right] = STATE(5786),
    [sym_exp_th_quoted_name] = STATE(5786),
    [sym_exp_type_application] = STATE(1283),
    [sym_exp_lambda] = STATE(9297),
    [sym_exp_let] = STATE(18321),
    [sym_exp_let_in] = STATE(9297),
    [sym_exp_cond] = STATE(9297),
    [sym_exp_if_guard] = STATE(9297),
    [sym_exp_case] = STATE(9297),
    [sym_exp_lambda_case] = STATE(1283),
    [sym__do_keyword] = STATE(18454),
    [sym_do_module] = STATE(18454),
    [sym_exp_do] = STATE(1283),
    [sym_exp_negation] = STATE(9297),
    [sym_exp_record] = STATE(5786),
    [sym_exp_name] = STATE(5786),
    [sym_exp_projection_selector] = STATE(5786),
    [sym__aexp_projection] = STATE(5786),
    [sym_exp_projection] = STATE(5786),
    [sym__aexp] = STATE(1283),
    [sym__exp_apply] = STATE(12708),
    [sym__fexp] = STATE(9297),
    [sym__lexp] = STATE(9297),
    [sym_exp_infix] = STATE(9297),
    [sym__exp_infix] = STATE(9297),
    [sym__exp] = STATE(12603),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12665),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym__varid] = ACTIONS(3041),
    [sym_float] = ACTIONS(1362),
    [sym_char] = ACTIONS(1362),
    [sym_string] = ACTIONS(1362),
    [sym__integer_literal] = ACTIONS(1364),
    [sym__binary_literal] = ACTIONS(1366),
    [sym__octal_literal] = ACTIONS(1366),
    [sym__hex_literal] = ACTIONS(1366),
    [anon_sym_LPAREN_POUND] = ACTIONS(3043),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3043),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [sym_implicit_parid] = ACTIONS(3045),
    [sym__conid] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3057),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_BSLASH] = ACTIONS(3061),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_mdo] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_7] = ACTIONS(1380),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1384),
  },
  [1630] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9972),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9972),
    [sym_exp_cond] = STATE(9972),
    [sym_exp_if_guard] = STATE(9972),
    [sym_exp_case] = STATE(9972),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9972),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9972),
    [sym__lexp] = STATE(9972),
    [sym_exp_infix] = STATE(9972),
    [sym__exp_infix] = STATE(9972),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4297),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1631] = {
    [sym_integer] = STATE(5749),
    [sym__literal] = STATE(5749),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = STATE(5599),
    [sym_qualified_variable] = STATE(5599),
    [sym_constructor] = STATE(5259),
    [sym_qualified_constructor] = STATE(5552),
    [sym__qcon] = STATE(5599),
    [sym_con_unit] = STATE(5749),
    [sym_con_list] = STATE(5749),
    [sym_con_tuple] = STATE(5749),
    [sym_literal] = STATE(5638),
    [sym_exp_parens] = STATE(5638),
    [sym_exp_tuple] = STATE(5638),
    [sym_exp_unboxed_tuple] = STATE(5638),
    [sym_exp_unboxed_sum] = STATE(5638),
    [sym_exp_list] = STATE(5638),
    [sym_exp_arithmetic_sequence] = STATE(5638),
    [sym_exp_list_comprehension] = STATE(5638),
    [sym_exp_section_left] = STATE(5638),
    [sym_exp_section_right] = STATE(5638),
    [sym_exp_th_quoted_name] = STATE(5638),
    [sym_exp_type_application] = STATE(964),
    [sym_exp_lambda] = STATE(9241),
    [sym_exp_let] = STATE(18245),
    [sym_exp_let_in] = STATE(9241),
    [sym_exp_cond] = STATE(9241),
    [sym_exp_if_guard] = STATE(9241),
    [sym_exp_case] = STATE(9241),
    [sym_exp_lambda_case] = STATE(964),
    [sym__do_keyword] = STATE(18319),
    [sym_do_module] = STATE(18319),
    [sym_exp_do] = STATE(964),
    [sym_exp_negation] = STATE(9241),
    [sym_exp_record] = STATE(5638),
    [sym_exp_name] = STATE(5638),
    [sym_exp_projection_selector] = STATE(5638),
    [sym__aexp_projection] = STATE(5638),
    [sym_exp_projection] = STATE(5638),
    [sym__aexp] = STATE(964),
    [sym__exp_apply] = STATE(12426),
    [sym__fexp] = STATE(9241),
    [sym__lexp] = STATE(9241),
    [sym_exp_infix] = STATE(9241),
    [sym__exp_infix] = STATE(9241),
    [sym__exp] = STATE(16080),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12705),
    [sym_splice] = STATE(5638),
    [sym_quasiquote] = STATE(5638),
    [sym__varid] = ACTIONS(2973),
    [sym_float] = ACTIONS(2975),
    [sym_char] = ACTIONS(2975),
    [sym_string] = ACTIONS(2975),
    [sym__integer_literal] = ACTIONS(2977),
    [sym__binary_literal] = ACTIONS(2979),
    [sym__octal_literal] = ACTIONS(2979),
    [sym__hex_literal] = ACTIONS(2979),
    [anon_sym_LPAREN_POUND] = ACTIONS(2981),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2981),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [sym_implicit_parid] = ACTIONS(2983),
    [sym__conid] = ACTIONS(4153),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2998),
    [anon_sym_BSLASH] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4155),
    [anon_sym_case] = ACTIONS(3004),
    [anon_sym_mdo] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_7] = ACTIONS(3008),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3012),
  },
  [1632] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19088),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1633] = {
    [sym_integer] = STATE(4913),
    [sym__literal] = STATE(4913),
    [sym__unboxed_open] = STATE(747),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4400),
    [sym_qualified_constructor] = STATE(5105),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(4913),
    [sym_con_list] = STATE(4913),
    [sym_con_tuple] = STATE(4913),
    [sym_literal] = STATE(5786),
    [sym_exp_parens] = STATE(5786),
    [sym_exp_tuple] = STATE(5786),
    [sym_exp_unboxed_tuple] = STATE(5786),
    [sym_exp_unboxed_sum] = STATE(5786),
    [sym_exp_list] = STATE(5786),
    [sym_exp_arithmetic_sequence] = STATE(5786),
    [sym_exp_list_comprehension] = STATE(5786),
    [sym_exp_section_left] = STATE(5786),
    [sym_exp_section_right] = STATE(5786),
    [sym_exp_th_quoted_name] = STATE(5786),
    [sym_exp_type_application] = STATE(1283),
    [sym_exp_lambda] = STATE(9297),
    [sym_exp_let] = STATE(18321),
    [sym_exp_let_in] = STATE(9297),
    [sym_exp_cond] = STATE(9297),
    [sym_exp_if_guard] = STATE(9297),
    [sym_exp_case] = STATE(9297),
    [sym_exp_lambda_case] = STATE(1283),
    [sym__do_keyword] = STATE(18454),
    [sym_do_module] = STATE(18454),
    [sym_exp_do] = STATE(1283),
    [sym_exp_negation] = STATE(9297),
    [sym_exp_record] = STATE(5786),
    [sym_exp_name] = STATE(5786),
    [sym_exp_projection_selector] = STATE(5786),
    [sym__aexp_projection] = STATE(5786),
    [sym_exp_projection] = STATE(5786),
    [sym__aexp] = STATE(1283),
    [sym__exp_apply] = STATE(12708),
    [sym__fexp] = STATE(9297),
    [sym__lexp] = STATE(9297),
    [sym_exp_infix] = STATE(9297),
    [sym__exp_infix] = STATE(9297),
    [sym__exp] = STATE(12601),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12665),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym__varid] = ACTIONS(3041),
    [sym_float] = ACTIONS(1362),
    [sym_char] = ACTIONS(1362),
    [sym_string] = ACTIONS(1362),
    [sym__integer_literal] = ACTIONS(1364),
    [sym__binary_literal] = ACTIONS(1366),
    [sym__octal_literal] = ACTIONS(1366),
    [sym__hex_literal] = ACTIONS(1366),
    [anon_sym_LPAREN_POUND] = ACTIONS(3043),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3043),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [sym_implicit_parid] = ACTIONS(3045),
    [sym__conid] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3057),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_BSLASH] = ACTIONS(3061),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_mdo] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_7] = ACTIONS(1380),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1384),
  },
  [1634] = {
    [sym_integer] = STATE(4913),
    [sym__literal] = STATE(4913),
    [sym__unboxed_open] = STATE(747),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4400),
    [sym_qualified_constructor] = STATE(5105),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(4913),
    [sym_con_list] = STATE(4913),
    [sym_con_tuple] = STATE(4913),
    [sym_literal] = STATE(5786),
    [sym_exp_parens] = STATE(5786),
    [sym_exp_tuple] = STATE(5786),
    [sym_exp_unboxed_tuple] = STATE(5786),
    [sym_exp_unboxed_sum] = STATE(5786),
    [sym_exp_list] = STATE(5786),
    [sym_exp_arithmetic_sequence] = STATE(5786),
    [sym_exp_list_comprehension] = STATE(5786),
    [sym_exp_section_left] = STATE(5786),
    [sym_exp_section_right] = STATE(5786),
    [sym_exp_th_quoted_name] = STATE(5786),
    [sym_exp_type_application] = STATE(1283),
    [sym_exp_lambda] = STATE(9297),
    [sym_exp_let] = STATE(18321),
    [sym_exp_let_in] = STATE(9297),
    [sym_exp_cond] = STATE(9297),
    [sym_exp_if_guard] = STATE(9297),
    [sym_exp_case] = STATE(9297),
    [sym_exp_lambda_case] = STATE(1283),
    [sym__do_keyword] = STATE(18454),
    [sym_do_module] = STATE(18454),
    [sym_exp_do] = STATE(1283),
    [sym_exp_negation] = STATE(9297),
    [sym_exp_record] = STATE(5786),
    [sym_exp_name] = STATE(5786),
    [sym_exp_projection_selector] = STATE(5786),
    [sym__aexp_projection] = STATE(5786),
    [sym_exp_projection] = STATE(5786),
    [sym__aexp] = STATE(1283),
    [sym__exp_apply] = STATE(12708),
    [sym__fexp] = STATE(9297),
    [sym__lexp] = STATE(9297),
    [sym_exp_infix] = STATE(9297),
    [sym__exp_infix] = STATE(9297),
    [sym__exp] = STATE(12599),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12665),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym__varid] = ACTIONS(3041),
    [sym_float] = ACTIONS(1362),
    [sym_char] = ACTIONS(1362),
    [sym_string] = ACTIONS(1362),
    [sym__integer_literal] = ACTIONS(1364),
    [sym__binary_literal] = ACTIONS(1366),
    [sym__octal_literal] = ACTIONS(1366),
    [sym__hex_literal] = ACTIONS(1366),
    [anon_sym_LPAREN_POUND] = ACTIONS(3043),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3043),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [sym_implicit_parid] = ACTIONS(3045),
    [sym__conid] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3057),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_BSLASH] = ACTIONS(3061),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_mdo] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_7] = ACTIONS(1380),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1384),
  },
  [1635] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18875),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1636] = {
    [sym_integer] = STATE(4913),
    [sym__literal] = STATE(4913),
    [sym__unboxed_open] = STATE(747),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4400),
    [sym_qualified_constructor] = STATE(5105),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(4913),
    [sym_con_list] = STATE(4913),
    [sym_con_tuple] = STATE(4913),
    [sym_literal] = STATE(5786),
    [sym_exp_parens] = STATE(5786),
    [sym_exp_tuple] = STATE(5786),
    [sym_exp_unboxed_tuple] = STATE(5786),
    [sym_exp_unboxed_sum] = STATE(5786),
    [sym_exp_list] = STATE(5786),
    [sym_exp_arithmetic_sequence] = STATE(5786),
    [sym_exp_list_comprehension] = STATE(5786),
    [sym_exp_section_left] = STATE(5786),
    [sym_exp_section_right] = STATE(5786),
    [sym_exp_th_quoted_name] = STATE(5786),
    [sym_exp_type_application] = STATE(1283),
    [sym_exp_lambda] = STATE(9297),
    [sym_exp_let] = STATE(18321),
    [sym_exp_let_in] = STATE(9297),
    [sym_exp_cond] = STATE(9297),
    [sym_exp_if_guard] = STATE(9297),
    [sym_exp_case] = STATE(9297),
    [sym_exp_lambda_case] = STATE(1283),
    [sym__do_keyword] = STATE(18454),
    [sym_do_module] = STATE(18454),
    [sym_exp_do] = STATE(1283),
    [sym_exp_negation] = STATE(9297),
    [sym_exp_record] = STATE(5786),
    [sym_exp_name] = STATE(5786),
    [sym_exp_projection_selector] = STATE(5786),
    [sym__aexp_projection] = STATE(5786),
    [sym_exp_projection] = STATE(5786),
    [sym__aexp] = STATE(1283),
    [sym__exp_apply] = STATE(12708),
    [sym__fexp] = STATE(9297),
    [sym__lexp] = STATE(9297),
    [sym_exp_infix] = STATE(9297),
    [sym__exp_infix] = STATE(9297),
    [sym__exp] = STATE(12578),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12665),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym__varid] = ACTIONS(3041),
    [sym_float] = ACTIONS(1362),
    [sym_char] = ACTIONS(1362),
    [sym_string] = ACTIONS(1362),
    [sym__integer_literal] = ACTIONS(1364),
    [sym__binary_literal] = ACTIONS(1366),
    [sym__octal_literal] = ACTIONS(1366),
    [sym__hex_literal] = ACTIONS(1366),
    [anon_sym_LPAREN_POUND] = ACTIONS(3043),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3043),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [sym_implicit_parid] = ACTIONS(3045),
    [sym__conid] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3057),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_BSLASH] = ACTIONS(3061),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_mdo] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_7] = ACTIONS(1380),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1384),
  },
  [1637] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18934),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1638] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1639] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9939),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9939),
    [sym_exp_cond] = STATE(9939),
    [sym_exp_if_guard] = STATE(9939),
    [sym_exp_case] = STATE(9939),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9939),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9939),
    [sym__lexp] = STATE(9939),
    [sym_exp_infix] = STATE(9939),
    [sym__exp_infix] = STATE(9939),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4299),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1640] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18834),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1641] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9880),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9880),
    [sym_exp_cond] = STATE(9880),
    [sym_exp_if_guard] = STATE(9880),
    [sym_exp_case] = STATE(9880),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9880),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9880),
    [sym__lexp] = STATE(9880),
    [sym_exp_infix] = STATE(9880),
    [sym__exp_infix] = STATE(9880),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4273),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1642] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19410),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1643] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18589),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1644] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18428),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1645] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18561),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1646] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9826),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9826),
    [sym_exp_cond] = STATE(9826),
    [sym_exp_if_guard] = STATE(9826),
    [sym_exp_case] = STATE(9826),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9826),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9826),
    [sym__lexp] = STATE(9826),
    [sym_exp_infix] = STATE(9826),
    [sym__exp_infix] = STATE(9826),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4301),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1647] = {
    [sym_integer] = STATE(4332),
    [sym__literal] = STATE(4332),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(4280),
    [sym_qualified_variable] = STATE(4280),
    [sym_constructor] = STATE(4074),
    [sym_qualified_constructor] = STATE(4305),
    [sym__qcon] = STATE(4280),
    [sym_con_unit] = STATE(4332),
    [sym_con_list] = STATE(4332),
    [sym_con_tuple] = STATE(4332),
    [sym_literal] = STATE(4217),
    [sym_exp_parens] = STATE(4217),
    [sym_exp_tuple] = STATE(4217),
    [sym_exp_unboxed_tuple] = STATE(4217),
    [sym_exp_unboxed_sum] = STATE(4217),
    [sym_exp_list] = STATE(4217),
    [sym_exp_arithmetic_sequence] = STATE(4217),
    [sym_exp_list_comprehension] = STATE(4217),
    [sym_exp_section_left] = STATE(4217),
    [sym_exp_section_right] = STATE(4217),
    [sym_exp_th_quoted_name] = STATE(4217),
    [sym_exp_type_application] = STATE(801),
    [sym_exp_lambda] = STATE(8612),
    [sym_exp_let] = STATE(18577),
    [sym_exp_let_in] = STATE(8612),
    [sym_exp_cond] = STATE(8612),
    [sym_exp_if_guard] = STATE(8612),
    [sym_exp_case] = STATE(8612),
    [sym_exp_lambda_case] = STATE(801),
    [sym__do_keyword] = STATE(18152),
    [sym_do_module] = STATE(18152),
    [sym_exp_do] = STATE(801),
    [sym_exp_negation] = STATE(8612),
    [sym_exp_record] = STATE(4217),
    [sym_exp_name] = STATE(4217),
    [sym_exp_projection_selector] = STATE(4217),
    [sym__aexp_projection] = STATE(4217),
    [sym_exp_projection] = STATE(4217),
    [sym__aexp] = STATE(801),
    [sym__exp_apply] = STATE(11048),
    [sym__fexp] = STATE(8612),
    [sym__lexp] = STATE(8612),
    [sym_exp_infix] = STATE(8612),
    [sym__exp_infix] = STATE(8612),
    [sym__exp] = STATE(13934),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12567),
    [sym_splice] = STATE(4217),
    [sym_quasiquote] = STATE(4217),
    [sym__varid] = ACTIONS(1933),
    [sym_float] = ACTIONS(1935),
    [sym_char] = ACTIONS(1935),
    [sym_string] = ACTIONS(1935),
    [sym__integer_literal] = ACTIONS(1937),
    [sym__binary_literal] = ACTIONS(1939),
    [sym__octal_literal] = ACTIONS(1939),
    [sym__hex_literal] = ACTIONS(1939),
    [anon_sym_LPAREN_POUND] = ACTIONS(1941),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1941),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [sym_implicit_parid] = ACTIONS(1943),
    [sym__conid] = ACTIONS(4161),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1953),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(1959),
    [anon_sym_BSLASH] = ACTIONS(1961),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4163),
    [anon_sym_case] = ACTIONS(1965),
    [anon_sym_mdo] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_7] = ACTIONS(1969),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1973),
  },
  [1648] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18431),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1649] = {
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = STATE(4572),
    [sym_qualified_variable] = STATE(4572),
    [sym_constructor] = STATE(4245),
    [sym_qualified_constructor] = STATE(4556),
    [sym__qcon] = STATE(4572),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4959),
    [sym_exp_parens] = STATE(4959),
    [sym_exp_tuple] = STATE(4959),
    [sym_exp_unboxed_tuple] = STATE(4959),
    [sym_exp_unboxed_sum] = STATE(4959),
    [sym_exp_list] = STATE(4959),
    [sym_exp_arithmetic_sequence] = STATE(4959),
    [sym_exp_list_comprehension] = STATE(4959),
    [sym_exp_section_left] = STATE(4959),
    [sym_exp_section_right] = STATE(4959),
    [sym_exp_th_quoted_name] = STATE(4959),
    [sym_exp_type_application] = STATE(947),
    [sym_exp_lambda] = STATE(9082),
    [sym_exp_let] = STATE(18678),
    [sym_exp_let_in] = STATE(9082),
    [sym_exp_cond] = STATE(9082),
    [sym_exp_if_guard] = STATE(9082),
    [sym_exp_case] = STATE(9082),
    [sym_exp_lambda_case] = STATE(947),
    [sym__do_keyword] = STATE(18401),
    [sym_do_module] = STATE(18401),
    [sym_exp_do] = STATE(947),
    [sym_exp_negation] = STATE(9082),
    [sym_exp_record] = STATE(4959),
    [sym_exp_name] = STATE(4959),
    [sym_exp_projection_selector] = STATE(4959),
    [sym__aexp_projection] = STATE(4959),
    [sym_exp_projection] = STATE(4959),
    [sym__aexp] = STATE(947),
    [sym__exp_apply] = STATE(12092),
    [sym__fexp] = STATE(9082),
    [sym__lexp] = STATE(9082),
    [sym_exp_infix] = STATE(9082),
    [sym__exp_infix] = STATE(9082),
    [sym__exp] = STATE(12088),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12712),
    [sym_splice] = STATE(4959),
    [sym_quasiquote] = STATE(4959),
    [sym__varid] = ACTIONS(2529),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2531),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2531),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [sym_implicit_parid] = ACTIONS(2533),
    [sym__conid] = ACTIONS(4243),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [anon_sym_BSLASH] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4245),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_mdo] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
  },
  [1650] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18564),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1651] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9807),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9807),
    [sym_exp_cond] = STATE(9807),
    [sym_exp_if_guard] = STATE(9807),
    [sym_exp_case] = STATE(9807),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9807),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9807),
    [sym__lexp] = STATE(9807),
    [sym_exp_infix] = STATE(9807),
    [sym__exp_infix] = STATE(9807),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4303),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1652] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19835),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1653] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20008),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1654] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18239),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1655] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(8211),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(8211),
    [sym_exp_cond] = STATE(8211),
    [sym_exp_if_guard] = STATE(8211),
    [sym_exp_case] = STATE(8211),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(8211),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(8211),
    [sym__lexp] = STATE(8211),
    [sym_exp_infix] = STATE(8211),
    [sym__exp_infix] = STATE(8211),
    [sym__exp] = STATE(10517),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1656] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18225),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1657] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9063),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9063),
    [sym_exp_cond] = STATE(9063),
    [sym_exp_if_guard] = STATE(9063),
    [sym_exp_case] = STATE(9063),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9063),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9063),
    [sym__lexp] = STATE(9063),
    [sym_exp_infix] = STATE(9063),
    [sym__exp_infix] = STATE(9063),
    [sym__exp] = STATE(18739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1658] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20804),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1659] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17893),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1660] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18483),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1661] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(17860),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1662] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(750),
    [sym_variable] = STATE(4795),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(4308),
    [sym_qualified_constructor] = STATE(4664),
    [sym__qcon] = STATE(4795),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(5587),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(9236),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(9236),
    [sym_exp_cond] = STATE(9236),
    [sym_exp_if_guard] = STATE(9236),
    [sym_exp_case] = STATE(9236),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(9236),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(9236),
    [sym__lexp] = STATE(9236),
    [sym_exp_infix] = STATE(9236),
    [sym__exp_infix] = STATE(9236),
    [sym__exp] = STATE(17168),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12545),
    [sym_splice] = STATE(5587),
    [sym_quasiquote] = STATE(5587),
    [sym__varid] = ACTIONS(3014),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(3016),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3016),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
  },
  [1663] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20850),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1664] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9948),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9948),
    [sym_exp_cond] = STATE(9948),
    [sym_exp_if_guard] = STATE(9948),
    [sym_exp_case] = STATE(9948),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9948),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9948),
    [sym__lexp] = STATE(9948),
    [sym_exp_infix] = STATE(9948),
    [sym__exp_infix] = STATE(9948),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4219),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1665] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18000),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1666] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18490),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1667] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18015),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1668] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19723),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1669] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(20236),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1670] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18274),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1671] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(797),
    [sym_variable] = STATE(5085),
    [sym_qualified_variable] = STATE(5085),
    [sym_constructor] = STATE(4716),
    [sym_qualified_constructor] = STATE(5006),
    [sym__qcon] = STATE(5085),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(4915),
    [sym_exp_parens] = STATE(4915),
    [sym_exp_tuple] = STATE(4915),
    [sym_exp_unboxed_tuple] = STATE(4915),
    [sym_exp_unboxed_sum] = STATE(4915),
    [sym_exp_list] = STATE(4915),
    [sym_exp_arithmetic_sequence] = STATE(4915),
    [sym_exp_list_comprehension] = STATE(4915),
    [sym_exp_section_left] = STATE(4915),
    [sym_exp_section_right] = STATE(4915),
    [sym_exp_th_quoted_name] = STATE(4915),
    [sym_exp_type_application] = STATE(943),
    [sym_exp_lambda] = STATE(9208),
    [sym_exp_let] = STATE(18386),
    [sym_exp_let_in] = STATE(9208),
    [sym_exp_cond] = STATE(9208),
    [sym_exp_if_guard] = STATE(9208),
    [sym_exp_case] = STATE(9208),
    [sym_exp_lambda_case] = STATE(943),
    [sym__do_keyword] = STATE(18435),
    [sym_do_module] = STATE(18435),
    [sym_exp_do] = STATE(943),
    [sym_exp_negation] = STATE(9208),
    [sym_exp_record] = STATE(4915),
    [sym_exp_name] = STATE(4915),
    [sym_exp_projection_selector] = STATE(4915),
    [sym__aexp_projection] = STATE(4915),
    [sym_exp_projection] = STATE(4915),
    [sym__aexp] = STATE(943),
    [sym__exp_apply] = STATE(12078),
    [sym__fexp] = STATE(9208),
    [sym__lexp] = STATE(9208),
    [sym_exp_infix] = STATE(9208),
    [sym__exp_infix] = STATE(9208),
    [sym__exp] = STATE(11949),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12549),
    [sym_splice] = STATE(4915),
    [sym_quasiquote] = STATE(4915),
    [sym__varid] = ACTIONS(2895),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(2897),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2897),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [sym_implicit_parid] = ACTIONS(1177),
    [sym__conid] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_mdo] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
  },
  [1672] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18305),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1673] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18859),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1674] = {
    [sym_integer] = STATE(4913),
    [sym__literal] = STATE(4913),
    [sym__unboxed_open] = STATE(747),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4400),
    [sym_qualified_constructor] = STATE(5105),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(4913),
    [sym_con_list] = STATE(4913),
    [sym_con_tuple] = STATE(4913),
    [sym_literal] = STATE(5786),
    [sym_exp_parens] = STATE(5786),
    [sym_exp_tuple] = STATE(5786),
    [sym_exp_unboxed_tuple] = STATE(5786),
    [sym_exp_unboxed_sum] = STATE(5786),
    [sym_exp_list] = STATE(5786),
    [sym_exp_arithmetic_sequence] = STATE(5786),
    [sym_exp_list_comprehension] = STATE(5786),
    [sym_exp_section_left] = STATE(5786),
    [sym_exp_section_right] = STATE(5786),
    [sym_exp_th_quoted_name] = STATE(5786),
    [sym_exp_type_application] = STATE(1283),
    [sym_exp_lambda] = STATE(9297),
    [sym_exp_let] = STATE(18321),
    [sym_exp_let_in] = STATE(9297),
    [sym_exp_cond] = STATE(9297),
    [sym_exp_if_guard] = STATE(9297),
    [sym_exp_case] = STATE(9297),
    [sym_exp_lambda_case] = STATE(1283),
    [sym__do_keyword] = STATE(18454),
    [sym_do_module] = STATE(18454),
    [sym_exp_do] = STATE(1283),
    [sym_exp_negation] = STATE(9297),
    [sym_exp_record] = STATE(5786),
    [sym_exp_name] = STATE(5786),
    [sym_exp_projection_selector] = STATE(5786),
    [sym__aexp_projection] = STATE(5786),
    [sym_exp_projection] = STATE(5786),
    [sym__aexp] = STATE(1283),
    [sym__exp_apply] = STATE(12708),
    [sym__fexp] = STATE(9297),
    [sym__lexp] = STATE(9297),
    [sym_exp_infix] = STATE(9297),
    [sym__exp_infix] = STATE(9297),
    [sym__exp] = STATE(12515),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12665),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym__varid] = ACTIONS(3041),
    [sym_float] = ACTIONS(1362),
    [sym_char] = ACTIONS(1362),
    [sym_string] = ACTIONS(1362),
    [sym__integer_literal] = ACTIONS(1364),
    [sym__binary_literal] = ACTIONS(1366),
    [sym__octal_literal] = ACTIONS(1366),
    [sym__hex_literal] = ACTIONS(1366),
    [anon_sym_LPAREN_POUND] = ACTIONS(3043),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3043),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [sym_implicit_parid] = ACTIONS(3045),
    [sym__conid] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3057),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_BSLASH] = ACTIONS(3061),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_mdo] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_7] = ACTIONS(1380),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1384),
  },
  [1675] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18542),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1676] = {
    [sym_integer] = STATE(4866),
    [sym__literal] = STATE(4866),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = STATE(5079),
    [sym_qualified_variable] = STATE(5079),
    [sym_constructor] = STATE(4498),
    [sym_qualified_constructor] = STATE(5373),
    [sym__qcon] = STATE(5079),
    [sym_con_unit] = STATE(4866),
    [sym_con_list] = STATE(4866),
    [sym_con_tuple] = STATE(4866),
    [sym_literal] = STATE(5194),
    [sym_exp_parens] = STATE(5194),
    [sym_exp_tuple] = STATE(5194),
    [sym_exp_unboxed_tuple] = STATE(5194),
    [sym_exp_unboxed_sum] = STATE(5194),
    [sym_exp_list] = STATE(5194),
    [sym_exp_arithmetic_sequence] = STATE(5194),
    [sym_exp_list_comprehension] = STATE(5194),
    [sym_exp_section_left] = STATE(5194),
    [sym_exp_section_right] = STATE(5194),
    [sym_exp_th_quoted_name] = STATE(5194),
    [sym_exp_type_application] = STATE(924),
    [sym_exp_lambda] = STATE(9206),
    [sym_exp_let] = STATE(18498),
    [sym_exp_let_in] = STATE(9206),
    [sym_exp_cond] = STATE(9206),
    [sym_exp_if_guard] = STATE(9206),
    [sym_exp_case] = STATE(9206),
    [sym_exp_lambda_case] = STATE(924),
    [sym__do_keyword] = STATE(18413),
    [sym_do_module] = STATE(18413),
    [sym_exp_do] = STATE(924),
    [sym_exp_negation] = STATE(9206),
    [sym_exp_record] = STATE(5194),
    [sym_exp_name] = STATE(5194),
    [sym_exp_projection_selector] = STATE(5194),
    [sym__aexp_projection] = STATE(5194),
    [sym_exp_projection] = STATE(5194),
    [sym__aexp] = STATE(924),
    [sym__exp_apply] = STATE(12053),
    [sym__fexp] = STATE(9206),
    [sym__lexp] = STATE(9206),
    [sym_exp_infix] = STATE(9206),
    [sym__exp_infix] = STATE(9206),
    [sym__exp] = STATE(12162),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12556),
    [sym_splice] = STATE(5194),
    [sym_quasiquote] = STATE(5194),
    [sym__varid] = ACTIONS(2560),
    [sym_float] = ACTIONS(2562),
    [sym_char] = ACTIONS(2562),
    [sym_string] = ACTIONS(2562),
    [sym__integer_literal] = ACTIONS(2564),
    [sym__binary_literal] = ACTIONS(2566),
    [sym__octal_literal] = ACTIONS(2566),
    [sym__hex_literal] = ACTIONS(2566),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4047),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2583),
    [anon_sym_AT] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4049),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_7] = ACTIONS(2595),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2599),
  },
  [1677] = {
    [sym_integer] = STATE(4866),
    [sym__literal] = STATE(4866),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = STATE(5079),
    [sym_qualified_variable] = STATE(5079),
    [sym_constructor] = STATE(4498),
    [sym_qualified_constructor] = STATE(5373),
    [sym__qcon] = STATE(5079),
    [sym_con_unit] = STATE(4866),
    [sym_con_list] = STATE(4866),
    [sym_con_tuple] = STATE(4866),
    [sym_literal] = STATE(5194),
    [sym_exp_parens] = STATE(5194),
    [sym_exp_tuple] = STATE(5194),
    [sym_exp_unboxed_tuple] = STATE(5194),
    [sym_exp_unboxed_sum] = STATE(5194),
    [sym_exp_list] = STATE(5194),
    [sym_exp_arithmetic_sequence] = STATE(5194),
    [sym_exp_list_comprehension] = STATE(5194),
    [sym_exp_section_left] = STATE(5194),
    [sym_exp_section_right] = STATE(5194),
    [sym_exp_th_quoted_name] = STATE(5194),
    [sym_exp_type_application] = STATE(924),
    [sym_exp_lambda] = STATE(9206),
    [sym_exp_let] = STATE(18498),
    [sym_exp_let_in] = STATE(9206),
    [sym_exp_cond] = STATE(9206),
    [sym_exp_if_guard] = STATE(9206),
    [sym_exp_case] = STATE(9206),
    [sym_exp_lambda_case] = STATE(924),
    [sym__do_keyword] = STATE(18413),
    [sym_do_module] = STATE(18413),
    [sym_exp_do] = STATE(924),
    [sym_exp_negation] = STATE(9206),
    [sym_exp_record] = STATE(5194),
    [sym_exp_name] = STATE(5194),
    [sym_exp_projection_selector] = STATE(5194),
    [sym__aexp_projection] = STATE(5194),
    [sym_exp_projection] = STATE(5194),
    [sym__aexp] = STATE(924),
    [sym__exp_apply] = STATE(12053),
    [sym__fexp] = STATE(9206),
    [sym__lexp] = STATE(9206),
    [sym_exp_infix] = STATE(9206),
    [sym__exp_infix] = STATE(9206),
    [sym__exp] = STATE(12149),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12556),
    [sym_splice] = STATE(5194),
    [sym_quasiquote] = STATE(5194),
    [sym__varid] = ACTIONS(2560),
    [sym_float] = ACTIONS(2562),
    [sym_char] = ACTIONS(2562),
    [sym_string] = ACTIONS(2562),
    [sym__integer_literal] = ACTIONS(2564),
    [sym__binary_literal] = ACTIONS(2566),
    [sym__octal_literal] = ACTIONS(2566),
    [sym__hex_literal] = ACTIONS(2566),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4047),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2583),
    [anon_sym_AT] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4049),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_7] = ACTIONS(2595),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2599),
  },
  [1678] = {
    [sym_integer] = STATE(4866),
    [sym__literal] = STATE(4866),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = STATE(5079),
    [sym_qualified_variable] = STATE(5079),
    [sym_constructor] = STATE(4498),
    [sym_qualified_constructor] = STATE(5373),
    [sym__qcon] = STATE(5079),
    [sym_con_unit] = STATE(4866),
    [sym_con_list] = STATE(4866),
    [sym_con_tuple] = STATE(4866),
    [sym_literal] = STATE(5194),
    [sym_exp_parens] = STATE(5194),
    [sym_exp_tuple] = STATE(5194),
    [sym_exp_unboxed_tuple] = STATE(5194),
    [sym_exp_unboxed_sum] = STATE(5194),
    [sym_exp_list] = STATE(5194),
    [sym_exp_arithmetic_sequence] = STATE(5194),
    [sym_exp_list_comprehension] = STATE(5194),
    [sym_exp_section_left] = STATE(5194),
    [sym_exp_section_right] = STATE(5194),
    [sym_exp_th_quoted_name] = STATE(5194),
    [sym_exp_type_application] = STATE(924),
    [sym_exp_lambda] = STATE(9206),
    [sym_exp_let] = STATE(18498),
    [sym_exp_let_in] = STATE(9206),
    [sym_exp_cond] = STATE(9206),
    [sym_exp_if_guard] = STATE(9206),
    [sym_exp_case] = STATE(9206),
    [sym_exp_lambda_case] = STATE(924),
    [sym__do_keyword] = STATE(18413),
    [sym_do_module] = STATE(18413),
    [sym_exp_do] = STATE(924),
    [sym_exp_negation] = STATE(9206),
    [sym_exp_record] = STATE(5194),
    [sym_exp_name] = STATE(5194),
    [sym_exp_projection_selector] = STATE(5194),
    [sym__aexp_projection] = STATE(5194),
    [sym_exp_projection] = STATE(5194),
    [sym__aexp] = STATE(924),
    [sym__exp_apply] = STATE(12053),
    [sym__fexp] = STATE(9206),
    [sym__lexp] = STATE(9206),
    [sym_exp_infix] = STATE(9206),
    [sym__exp_infix] = STATE(9206),
    [sym__exp] = STATE(12145),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12556),
    [sym_splice] = STATE(5194),
    [sym_quasiquote] = STATE(5194),
    [sym__varid] = ACTIONS(2560),
    [sym_float] = ACTIONS(2562),
    [sym_char] = ACTIONS(2562),
    [sym_string] = ACTIONS(2562),
    [sym__integer_literal] = ACTIONS(2564),
    [sym__binary_literal] = ACTIONS(2566),
    [sym__octal_literal] = ACTIONS(2566),
    [sym__hex_literal] = ACTIONS(2566),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4047),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2583),
    [anon_sym_AT] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4049),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_7] = ACTIONS(2595),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2599),
  },
  [1679] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19777),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1680] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18553),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1681] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18548),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1682] = {
    [sym_integer] = STATE(4706),
    [sym__literal] = STATE(4706),
    [sym__unboxed_open] = STATE(756),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4233),
    [sym_qualified_constructor] = STATE(4725),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4706),
    [sym_con_list] = STATE(4706),
    [sym_con_tuple] = STATE(4706),
    [sym_literal] = STATE(4663),
    [sym_exp_parens] = STATE(4663),
    [sym_exp_tuple] = STATE(4663),
    [sym_exp_unboxed_tuple] = STATE(4663),
    [sym_exp_unboxed_sum] = STATE(4663),
    [sym_exp_list] = STATE(4663),
    [sym_exp_arithmetic_sequence] = STATE(4663),
    [sym_exp_list_comprehension] = STATE(4663),
    [sym_exp_section_left] = STATE(4663),
    [sym_exp_section_right] = STATE(4663),
    [sym_exp_th_quoted_name] = STATE(4663),
    [sym_exp_type_application] = STATE(870),
    [sym_exp_lambda] = STATE(8920),
    [sym_exp_let] = STATE(18848),
    [sym_exp_let_in] = STATE(8920),
    [sym_exp_cond] = STATE(8920),
    [sym_exp_if_guard] = STATE(8920),
    [sym_exp_case] = STATE(8920),
    [sym_exp_lambda_case] = STATE(870),
    [sym__do_keyword] = STATE(18207),
    [sym_do_module] = STATE(18207),
    [sym_exp_do] = STATE(870),
    [sym_exp_negation] = STATE(8920),
    [sym_exp_record] = STATE(4663),
    [sym_exp_name] = STATE(4663),
    [sym_exp_projection_selector] = STATE(4663),
    [sym__aexp_projection] = STATE(4663),
    [sym_exp_projection] = STATE(4663),
    [sym__aexp] = STATE(870),
    [sym__exp_apply] = STATE(11822),
    [sym__fexp] = STATE(8920),
    [sym__lexp] = STATE(8920),
    [sym_exp_infix] = STATE(8920),
    [sym__exp_infix] = STATE(8920),
    [sym__exp] = STATE(14093),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12713),
    [sym_splice] = STATE(4663),
    [sym_quasiquote] = STATE(4663),
    [sym__varid] = ACTIONS(2350),
    [sym_float] = ACTIONS(2352),
    [sym_char] = ACTIONS(2352),
    [sym_string] = ACTIONS(2352),
    [sym__integer_literal] = ACTIONS(2354),
    [sym__binary_literal] = ACTIONS(2356),
    [sym__octal_literal] = ACTIONS(2356),
    [sym__hex_literal] = ACTIONS(2356),
    [anon_sym_LPAREN_POUND] = ACTIONS(2358),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2358),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [sym_implicit_parid] = ACTIONS(2360),
    [sym__conid] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(2376),
    [anon_sym_BSLASH] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4179),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_mdo] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_7] = ACTIONS(2386),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2390),
  },
  [1683] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9919),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9919),
    [sym_exp_cond] = STATE(9919),
    [sym_exp_if_guard] = STATE(9919),
    [sym_exp_case] = STATE(9919),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9919),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9919),
    [sym__lexp] = STATE(9919),
    [sym_exp_infix] = STATE(9919),
    [sym__exp_infix] = STATE(9919),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4305),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1684] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9882),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9882),
    [sym_exp_cond] = STATE(9882),
    [sym_exp_if_guard] = STATE(9882),
    [sym_exp_case] = STATE(9882),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9882),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9882),
    [sym__lexp] = STATE(9882),
    [sym_exp_infix] = STATE(9882),
    [sym__exp_infix] = STATE(9882),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4307),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1685] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18582),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1686] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19615),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1687] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19239),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1688] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18851),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1689] = {
    [sym_integer] = STATE(4866),
    [sym__literal] = STATE(4866),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = STATE(5079),
    [sym_qualified_variable] = STATE(5079),
    [sym_constructor] = STATE(4498),
    [sym_qualified_constructor] = STATE(5373),
    [sym__qcon] = STATE(5079),
    [sym_con_unit] = STATE(4866),
    [sym_con_list] = STATE(4866),
    [sym_con_tuple] = STATE(4866),
    [sym_literal] = STATE(5194),
    [sym_exp_parens] = STATE(5194),
    [sym_exp_tuple] = STATE(5194),
    [sym_exp_unboxed_tuple] = STATE(5194),
    [sym_exp_unboxed_sum] = STATE(5194),
    [sym_exp_list] = STATE(5194),
    [sym_exp_arithmetic_sequence] = STATE(5194),
    [sym_exp_list_comprehension] = STATE(5194),
    [sym_exp_section_left] = STATE(5194),
    [sym_exp_section_right] = STATE(5194),
    [sym_exp_th_quoted_name] = STATE(5194),
    [sym_exp_type_application] = STATE(924),
    [sym_exp_lambda] = STATE(9206),
    [sym_exp_let] = STATE(18498),
    [sym_exp_let_in] = STATE(9206),
    [sym_exp_cond] = STATE(9206),
    [sym_exp_if_guard] = STATE(9206),
    [sym_exp_case] = STATE(9206),
    [sym_exp_lambda_case] = STATE(924),
    [sym__do_keyword] = STATE(18413),
    [sym_do_module] = STATE(18413),
    [sym_exp_do] = STATE(924),
    [sym_exp_negation] = STATE(9206),
    [sym_exp_record] = STATE(5194),
    [sym_exp_name] = STATE(5194),
    [sym_exp_projection_selector] = STATE(5194),
    [sym__aexp_projection] = STATE(5194),
    [sym_exp_projection] = STATE(5194),
    [sym__aexp] = STATE(924),
    [sym__exp_apply] = STATE(12053),
    [sym__fexp] = STATE(9206),
    [sym__lexp] = STATE(9206),
    [sym_exp_infix] = STATE(9206),
    [sym__exp_infix] = STATE(9206),
    [sym__exp] = STATE(12070),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12556),
    [sym_splice] = STATE(5194),
    [sym_quasiquote] = STATE(5194),
    [sym__varid] = ACTIONS(2560),
    [sym_float] = ACTIONS(2562),
    [sym_char] = ACTIONS(2562),
    [sym_string] = ACTIONS(2562),
    [sym__integer_literal] = ACTIONS(2564),
    [sym__binary_literal] = ACTIONS(2566),
    [sym__octal_literal] = ACTIONS(2566),
    [sym__hex_literal] = ACTIONS(2566),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4047),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2583),
    [anon_sym_AT] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4049),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_7] = ACTIONS(2595),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2599),
  },
  [1690] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9879),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9879),
    [sym_exp_cond] = STATE(9879),
    [sym_exp_if_guard] = STATE(9879),
    [sym_exp_case] = STATE(9879),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9879),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9879),
    [sym__lexp] = STATE(9879),
    [sym_exp_infix] = STATE(9879),
    [sym__exp_infix] = STATE(9879),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(4131),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1691] = {
    [sym_integer] = STATE(4866),
    [sym__literal] = STATE(4866),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = STATE(5079),
    [sym_qualified_variable] = STATE(5079),
    [sym_constructor] = STATE(4498),
    [sym_qualified_constructor] = STATE(5373),
    [sym__qcon] = STATE(5079),
    [sym_con_unit] = STATE(4866),
    [sym_con_list] = STATE(4866),
    [sym_con_tuple] = STATE(4866),
    [sym_literal] = STATE(5194),
    [sym_exp_parens] = STATE(5194),
    [sym_exp_tuple] = STATE(5194),
    [sym_exp_unboxed_tuple] = STATE(5194),
    [sym_exp_unboxed_sum] = STATE(5194),
    [sym_exp_list] = STATE(5194),
    [sym_exp_arithmetic_sequence] = STATE(5194),
    [sym_exp_list_comprehension] = STATE(5194),
    [sym_exp_section_left] = STATE(5194),
    [sym_exp_section_right] = STATE(5194),
    [sym_exp_th_quoted_name] = STATE(5194),
    [sym_exp_type_application] = STATE(924),
    [sym_exp_lambda] = STATE(9206),
    [sym_exp_let] = STATE(18498),
    [sym_exp_let_in] = STATE(9206),
    [sym_exp_cond] = STATE(9206),
    [sym_exp_if_guard] = STATE(9206),
    [sym_exp_case] = STATE(9206),
    [sym_exp_lambda_case] = STATE(924),
    [sym__do_keyword] = STATE(18413),
    [sym_do_module] = STATE(18413),
    [sym_exp_do] = STATE(924),
    [sym_exp_negation] = STATE(9206),
    [sym_exp_record] = STATE(5194),
    [sym_exp_name] = STATE(5194),
    [sym_exp_projection_selector] = STATE(5194),
    [sym__aexp_projection] = STATE(5194),
    [sym_exp_projection] = STATE(5194),
    [sym__aexp] = STATE(924),
    [sym__exp_apply] = STATE(12053),
    [sym__fexp] = STATE(9206),
    [sym__lexp] = STATE(9206),
    [sym_exp_infix] = STATE(9206),
    [sym__exp_infix] = STATE(9206),
    [sym__exp] = STATE(12037),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12556),
    [sym_splice] = STATE(5194),
    [sym_quasiquote] = STATE(5194),
    [sym__varid] = ACTIONS(2560),
    [sym_float] = ACTIONS(2562),
    [sym_char] = ACTIONS(2562),
    [sym_string] = ACTIONS(2562),
    [sym__integer_literal] = ACTIONS(2564),
    [sym__binary_literal] = ACTIONS(2566),
    [sym__octal_literal] = ACTIONS(2566),
    [sym__hex_literal] = ACTIONS(2566),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4047),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2583),
    [anon_sym_AT] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4049),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_7] = ACTIONS(2595),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2599),
  },
  [1692] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18878),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1693] = {
    [sym_integer] = STATE(4913),
    [sym__literal] = STATE(4913),
    [sym__unboxed_open] = STATE(747),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4400),
    [sym_qualified_constructor] = STATE(5105),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(4913),
    [sym_con_list] = STATE(4913),
    [sym_con_tuple] = STATE(4913),
    [sym_literal] = STATE(5786),
    [sym_exp_parens] = STATE(5786),
    [sym_exp_tuple] = STATE(5786),
    [sym_exp_unboxed_tuple] = STATE(5786),
    [sym_exp_unboxed_sum] = STATE(5786),
    [sym_exp_list] = STATE(5786),
    [sym_exp_arithmetic_sequence] = STATE(5786),
    [sym_exp_list_comprehension] = STATE(5786),
    [sym_exp_section_left] = STATE(5786),
    [sym_exp_section_right] = STATE(5786),
    [sym_exp_th_quoted_name] = STATE(5786),
    [sym_exp_type_application] = STATE(1283),
    [sym_exp_lambda] = STATE(9297),
    [sym_exp_let] = STATE(18321),
    [sym_exp_let_in] = STATE(9297),
    [sym_exp_cond] = STATE(9297),
    [sym_exp_if_guard] = STATE(9297),
    [sym_exp_case] = STATE(9297),
    [sym_exp_lambda_case] = STATE(1283),
    [sym__do_keyword] = STATE(18454),
    [sym_do_module] = STATE(18454),
    [sym_exp_do] = STATE(1283),
    [sym_exp_negation] = STATE(9297),
    [sym_exp_record] = STATE(5786),
    [sym_exp_name] = STATE(5786),
    [sym_exp_projection_selector] = STATE(5786),
    [sym__aexp_projection] = STATE(5786),
    [sym_exp_projection] = STATE(5786),
    [sym__aexp] = STATE(1283),
    [sym__exp_apply] = STATE(12708),
    [sym__fexp] = STATE(9297),
    [sym__lexp] = STATE(9297),
    [sym_exp_infix] = STATE(9297),
    [sym__exp_infix] = STATE(9297),
    [sym__exp] = STATE(12614),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12665),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym__varid] = ACTIONS(3041),
    [sym_float] = ACTIONS(1362),
    [sym_char] = ACTIONS(1362),
    [sym_string] = ACTIONS(1362),
    [sym__integer_literal] = ACTIONS(1364),
    [sym__binary_literal] = ACTIONS(1366),
    [sym__octal_literal] = ACTIONS(1366),
    [sym__hex_literal] = ACTIONS(1366),
    [anon_sym_LPAREN_POUND] = ACTIONS(3043),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3043),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [sym_implicit_parid] = ACTIONS(3045),
    [sym__conid] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3057),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_BSLASH] = ACTIONS(3061),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_mdo] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_7] = ACTIONS(1380),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1384),
  },
  [1694] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19057),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1695] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18831),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1696] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18628),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1697] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18825),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1698] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(19366),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1699] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(7717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(7717),
    [sym_exp_cond] = STATE(7717),
    [sym_exp_if_guard] = STATE(7717),
    [sym_exp_case] = STATE(7717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(7717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(7717),
    [sym__lexp] = STATE(7717),
    [sym_exp_infix] = STATE(7717),
    [sym__exp_infix] = STATE(7717),
    [sym__exp] = STATE(18656),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1700] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9856),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9856),
    [sym_exp_cond] = STATE(9856),
    [sym_exp_if_guard] = STATE(9856),
    [sym_exp_case] = STATE(9856),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9856),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9856),
    [sym__lexp] = STATE(9856),
    [sym_exp_infix] = STATE(9856),
    [sym__exp_infix] = STATE(9856),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1701] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9769),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9769),
    [sym_exp_cond] = STATE(9769),
    [sym_exp_if_guard] = STATE(9769),
    [sym_exp_case] = STATE(9769),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9769),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9769),
    [sym__lexp] = STATE(9769),
    [sym_exp_infix] = STATE(9769),
    [sym__exp_infix] = STATE(9769),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1702] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9884),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9884),
    [sym_exp_cond] = STATE(9884),
    [sym_exp_if_guard] = STATE(9884),
    [sym_exp_case] = STATE(9884),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9884),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9884),
    [sym__lexp] = STATE(9884),
    [sym_exp_infix] = STATE(9884),
    [sym__exp_infix] = STATE(9884),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1703] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9807),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9807),
    [sym_exp_cond] = STATE(9807),
    [sym_exp_if_guard] = STATE(9807),
    [sym_exp_case] = STATE(9807),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9807),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9807),
    [sym__lexp] = STATE(9807),
    [sym_exp_infix] = STATE(9807),
    [sym__exp_infix] = STATE(9807),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1704] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9755),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9755),
    [sym_exp_cond] = STATE(9755),
    [sym_exp_if_guard] = STATE(9755),
    [sym_exp_case] = STATE(9755),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9755),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9755),
    [sym__lexp] = STATE(9755),
    [sym_exp_infix] = STATE(9755),
    [sym__exp_infix] = STATE(9755),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1705] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9857),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9857),
    [sym_exp_cond] = STATE(9857),
    [sym_exp_if_guard] = STATE(9857),
    [sym_exp_case] = STATE(9857),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9857),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9857),
    [sym__lexp] = STATE(9857),
    [sym_exp_infix] = STATE(9857),
    [sym__exp_infix] = STATE(9857),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1706] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9886),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9886),
    [sym_exp_cond] = STATE(9886),
    [sym_exp_if_guard] = STATE(9886),
    [sym_exp_case] = STATE(9886),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9886),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9886),
    [sym__lexp] = STATE(9886),
    [sym_exp_infix] = STATE(9886),
    [sym__exp_infix] = STATE(9886),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1707] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9903),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9903),
    [sym_exp_cond] = STATE(9903),
    [sym_exp_if_guard] = STATE(9903),
    [sym_exp_case] = STATE(9903),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9903),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9903),
    [sym__lexp] = STATE(9903),
    [sym_exp_infix] = STATE(9903),
    [sym__exp_infix] = STATE(9903),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1708] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(97),
    [sym_variable] = STATE(10548),
    [sym_qualified_variable] = STATE(9343),
    [sym_constructor] = STATE(9240),
    [sym_qualified_constructor] = STATE(9275),
    [sym__qcon] = STATE(11153),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(11152),
    [sym_exp_parens] = STATE(9481),
    [sym_exp_tuple] = STATE(9481),
    [sym_exp_unboxed_tuple] = STATE(9481),
    [sym_exp_unboxed_sum] = STATE(9481),
    [sym_exp_list] = STATE(9481),
    [sym_exp_arithmetic_sequence] = STATE(9481),
    [sym_exp_list_comprehension] = STATE(9481),
    [sym_exp_section_left] = STATE(9481),
    [sym_exp_section_right] = STATE(9481),
    [sym_exp_th_quoted_name] = STATE(9481),
    [sym_exp_type_application] = STATE(9563),
    [sym_exp_lambda_case] = STATE(9563),
    [sym__do_keyword] = STATE(18466),
    [sym_do_module] = STATE(18466),
    [sym_exp_do] = STATE(9563),
    [sym_exp_record] = STATE(9481),
    [sym_exp_name] = STATE(9481),
    [sym_exp_projection_selector] = STATE(9481),
    [sym__aexp_projection] = STATE(9481),
    [sym_exp_projection] = STATE(9481),
    [sym__aexp] = STATE(9563),
    [sym_pat_as] = STATE(12278),
    [sym_pat_parens] = STATE(12278),
    [sym_pat_tuple] = STATE(12278),
    [sym_pat_unboxed_tuple] = STATE(12278),
    [sym_pat_unboxed_sum] = STATE(12278),
    [sym_pat_list] = STATE(12278),
    [sym_pat_strict] = STATE(12278),
    [sym_pat_irrefutable] = STATE(12278),
    [sym_pat_name] = STATE(12278),
    [sym__pat_constructor] = STATE(11599),
    [sym_pat_wildcard] = STATE(12278),
    [sym_pat_record] = STATE(12278),
    [sym__apat] = STATE(12278),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12535),
    [sym_splice] = STATE(11149),
    [sym_quasiquote] = STATE(11149),
    [sym__varid] = ACTIONS(4309),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4317),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4317),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4223),
    [anon_sym_LPAREN] = ACTIONS(4319),
    [sym_implicit_parid] = ACTIONS(4223),
    [sym__conid] = ACTIONS(4321),
    [anon_sym_LBRACK] = ACTIONS(4323),
    [anon_sym_SQUOTE] = ACTIONS(4229),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4231),
    [anon_sym_AT] = ACTIONS(4233),
    [anon_sym_BSLASH] = ACTIONS(4235),
    [anon_sym_mdo] = ACTIONS(4237),
    [anon_sym_do] = ACTIONS(4237),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [1709] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9717),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9717),
    [sym_exp_cond] = STATE(9717),
    [sym_exp_if_guard] = STATE(9717),
    [sym_exp_case] = STATE(9717),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9717),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9717),
    [sym__lexp] = STATE(9717),
    [sym_exp_infix] = STATE(9717),
    [sym__exp_infix] = STATE(9717),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1710] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9916),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9916),
    [sym_exp_cond] = STATE(9916),
    [sym_exp_if_guard] = STATE(9916),
    [sym_exp_case] = STATE(9916),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9916),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9916),
    [sym__lexp] = STATE(9916),
    [sym_exp_infix] = STATE(9916),
    [sym__exp_infix] = STATE(9916),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1711] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9913),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9913),
    [sym_exp_cond] = STATE(9913),
    [sym_exp_if_guard] = STATE(9913),
    [sym_exp_case] = STATE(9913),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9913),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9913),
    [sym__lexp] = STATE(9913),
    [sym_exp_infix] = STATE(9913),
    [sym__exp_infix] = STATE(9913),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1712] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9972),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9972),
    [sym_exp_cond] = STATE(9972),
    [sym_exp_if_guard] = STATE(9972),
    [sym_exp_case] = STATE(9972),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9972),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9972),
    [sym__lexp] = STATE(9972),
    [sym_exp_infix] = STATE(9972),
    [sym__exp_infix] = STATE(9972),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1713] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9956),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9956),
    [sym_exp_cond] = STATE(9956),
    [sym_exp_if_guard] = STATE(9956),
    [sym_exp_case] = STATE(9956),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9956),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9956),
    [sym__lexp] = STATE(9956),
    [sym_exp_infix] = STATE(9956),
    [sym__exp_infix] = STATE(9956),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1714] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9919),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9919),
    [sym_exp_cond] = STATE(9919),
    [sym_exp_if_guard] = STATE(9919),
    [sym_exp_case] = STATE(9919),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9919),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9919),
    [sym__lexp] = STATE(9919),
    [sym_exp_infix] = STATE(9919),
    [sym__exp_infix] = STATE(9919),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1715] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9963),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9963),
    [sym_exp_cond] = STATE(9963),
    [sym_exp_if_guard] = STATE(9963),
    [sym_exp_case] = STATE(9963),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9963),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9963),
    [sym__lexp] = STATE(9963),
    [sym_exp_infix] = STATE(9963),
    [sym__exp_infix] = STATE(9963),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1716] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9908),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9908),
    [sym_exp_cond] = STATE(9908),
    [sym_exp_if_guard] = STATE(9908),
    [sym_exp_case] = STATE(9908),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9908),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9908),
    [sym__lexp] = STATE(9908),
    [sym_exp_infix] = STATE(9908),
    [sym__exp_infix] = STATE(9908),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1717] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9879),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9879),
    [sym_exp_cond] = STATE(9879),
    [sym_exp_if_guard] = STATE(9879),
    [sym_exp_case] = STATE(9879),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9879),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9879),
    [sym__lexp] = STATE(9879),
    [sym_exp_infix] = STATE(9879),
    [sym__exp_infix] = STATE(9879),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1718] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9947),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9947),
    [sym_exp_cond] = STATE(9947),
    [sym_exp_if_guard] = STATE(9947),
    [sym_exp_case] = STATE(9947),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9947),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9947),
    [sym__lexp] = STATE(9947),
    [sym_exp_infix] = STATE(9947),
    [sym__exp_infix] = STATE(9947),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1719] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9859),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9859),
    [sym_exp_cond] = STATE(9859),
    [sym_exp_if_guard] = STATE(9859),
    [sym_exp_case] = STATE(9859),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9859),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9859),
    [sym__lexp] = STATE(9859),
    [sym_exp_infix] = STATE(9859),
    [sym__exp_infix] = STATE(9859),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1720] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9828),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9828),
    [sym_exp_cond] = STATE(9828),
    [sym_exp_if_guard] = STATE(9828),
    [sym_exp_case] = STATE(9828),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9828),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9828),
    [sym__lexp] = STATE(9828),
    [sym_exp_infix] = STATE(9828),
    [sym__exp_infix] = STATE(9828),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1721] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(9455),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(9455),
    [sym_exp_cond] = STATE(9455),
    [sym_exp_if_guard] = STATE(9455),
    [sym_exp_case] = STATE(9455),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(9455),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(9455),
    [sym__lexp] = STATE(9455),
    [sym_exp_infix] = STATE(9455),
    [sym__exp_infix] = STATE(9455),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1722] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9964),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9964),
    [sym_exp_cond] = STATE(9964),
    [sym_exp_if_guard] = STATE(9964),
    [sym_exp_case] = STATE(9964),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9964),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9964),
    [sym__lexp] = STATE(9964),
    [sym_exp_infix] = STATE(9964),
    [sym__exp_infix] = STATE(9964),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1723] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9797),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9797),
    [sym_exp_cond] = STATE(9797),
    [sym_exp_if_guard] = STATE(9797),
    [sym_exp_case] = STATE(9797),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9797),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9797),
    [sym__lexp] = STATE(9797),
    [sym_exp_infix] = STATE(9797),
    [sym__exp_infix] = STATE(9797),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1724] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9765),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9765),
    [sym_exp_cond] = STATE(9765),
    [sym_exp_if_guard] = STATE(9765),
    [sym_exp_case] = STATE(9765),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9765),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9765),
    [sym__lexp] = STATE(9765),
    [sym_exp_infix] = STATE(9765),
    [sym__exp_infix] = STATE(9765),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1725] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9752),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9752),
    [sym_exp_cond] = STATE(9752),
    [sym_exp_if_guard] = STATE(9752),
    [sym_exp_case] = STATE(9752),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9752),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9752),
    [sym__lexp] = STATE(9752),
    [sym_exp_infix] = STATE(9752),
    [sym__exp_infix] = STATE(9752),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1726] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9725),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9725),
    [sym_exp_cond] = STATE(9725),
    [sym_exp_if_guard] = STATE(9725),
    [sym_exp_case] = STATE(9725),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9725),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9725),
    [sym__lexp] = STATE(9725),
    [sym_exp_infix] = STATE(9725),
    [sym__exp_infix] = STATE(9725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1727] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9760),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9760),
    [sym_exp_cond] = STATE(9760),
    [sym_exp_if_guard] = STATE(9760),
    [sym_exp_case] = STATE(9760),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9760),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9760),
    [sym__lexp] = STATE(9760),
    [sym_exp_infix] = STATE(9760),
    [sym__exp_infix] = STATE(9760),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1728] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9915),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9915),
    [sym_exp_cond] = STATE(9915),
    [sym_exp_if_guard] = STATE(9915),
    [sym_exp_case] = STATE(9915),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9915),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9915),
    [sym__lexp] = STATE(9915),
    [sym_exp_infix] = STATE(9915),
    [sym__exp_infix] = STATE(9915),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1729] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9816),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9816),
    [sym_exp_cond] = STATE(9816),
    [sym_exp_if_guard] = STATE(9816),
    [sym_exp_case] = STATE(9816),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9816),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9816),
    [sym__lexp] = STATE(9816),
    [sym_exp_infix] = STATE(9816),
    [sym__exp_infix] = STATE(9816),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1730] = {
    [sym_integer] = STATE(9549),
    [sym__literal] = STATE(9549),
    [sym__unboxed_open] = STATE(101),
    [sym_variable] = STATE(9621),
    [sym_qualified_variable] = STATE(9576),
    [sym_constructor] = STATE(9458),
    [sym_qualified_constructor] = STATE(9525),
    [sym__qcon] = STATE(9784),
    [sym_con_unit] = STATE(9549),
    [sym_con_list] = STATE(9549),
    [sym_con_tuple] = STATE(9549),
    [sym_literal] = STATE(9779),
    [sym_exp_parens] = STATE(9934),
    [sym_exp_tuple] = STATE(9934),
    [sym_exp_unboxed_tuple] = STATE(9934),
    [sym_exp_unboxed_sum] = STATE(9934),
    [sym_exp_list] = STATE(9934),
    [sym_exp_arithmetic_sequence] = STATE(9934),
    [sym_exp_list_comprehension] = STATE(9934),
    [sym_exp_section_left] = STATE(9934),
    [sym_exp_section_right] = STATE(9934),
    [sym_exp_th_quoted_name] = STATE(9934),
    [sym_exp_type_application] = STATE(10314),
    [sym_exp_lambda_case] = STATE(10314),
    [sym__do_keyword] = STATE(18492),
    [sym_do_module] = STATE(18492),
    [sym_exp_do] = STATE(10314),
    [sym_exp_record] = STATE(9934),
    [sym_exp_name] = STATE(9934),
    [sym_exp_projection_selector] = STATE(9934),
    [sym__aexp_projection] = STATE(9934),
    [sym_exp_projection] = STATE(9934),
    [sym__aexp] = STATE(10314),
    [sym_pat_as] = STATE(12278),
    [sym_pat_parens] = STATE(12278),
    [sym_pat_tuple] = STATE(12278),
    [sym_pat_unboxed_tuple] = STATE(12278),
    [sym_pat_unboxed_sum] = STATE(12278),
    [sym_pat_list] = STATE(12278),
    [sym_pat_strict] = STATE(12278),
    [sym_pat_irrefutable] = STATE(12278),
    [sym_pat_name] = STATE(12278),
    [sym__pat_constructor] = STATE(11599),
    [sym_pat_wildcard] = STATE(12278),
    [sym_pat_record] = STATE(12278),
    [sym__apat] = STATE(12278),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12670),
    [sym_splice] = STATE(9776),
    [sym_quasiquote] = STATE(9776),
    [sym__varid] = ACTIONS(4095),
    [sym_float] = ACTIONS(4097),
    [sym_char] = ACTIONS(4097),
    [sym_string] = ACTIONS(4097),
    [sym__integer_literal] = ACTIONS(4099),
    [sym__binary_literal] = ACTIONS(4101),
    [sym__octal_literal] = ACTIONS(4101),
    [sym__hex_literal] = ACTIONS(4101),
    [anon_sym_LPAREN_POUND] = ACTIONS(4331),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4331),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4105),
    [anon_sym_LPAREN] = ACTIONS(4333),
    [sym_implicit_parid] = ACTIONS(4105),
    [sym__conid] = ACTIONS(4111),
    [anon_sym_LBRACK] = ACTIONS(4335),
    [anon_sym_SQUOTE] = ACTIONS(4115),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4117),
    [anon_sym_AT] = ACTIONS(4119),
    [anon_sym_BSLASH] = ACTIONS(4121),
    [anon_sym_mdo] = ACTIONS(4123),
    [anon_sym_do] = ACTIONS(4123),
    [anon_sym_7] = ACTIONS(4125),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4127),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4129),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [1731] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9948),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9948),
    [sym_exp_cond] = STATE(9948),
    [sym_exp_if_guard] = STATE(9948),
    [sym_exp_case] = STATE(9948),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9948),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9948),
    [sym__lexp] = STATE(9948),
    [sym_exp_infix] = STATE(9948),
    [sym__exp_infix] = STATE(9948),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1732] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9895),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9895),
    [sym_exp_cond] = STATE(9895),
    [sym_exp_if_guard] = STATE(9895),
    [sym_exp_case] = STATE(9895),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9895),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9895),
    [sym__lexp] = STATE(9895),
    [sym_exp_infix] = STATE(9895),
    [sym__exp_infix] = STATE(9895),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1733] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9939),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9939),
    [sym_exp_cond] = STATE(9939),
    [sym_exp_if_guard] = STATE(9939),
    [sym_exp_case] = STATE(9939),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9939),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9939),
    [sym__lexp] = STATE(9939),
    [sym_exp_infix] = STATE(9939),
    [sym__exp_infix] = STATE(9939),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1734] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9905),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9905),
    [sym_exp_cond] = STATE(9905),
    [sym_exp_if_guard] = STATE(9905),
    [sym_exp_case] = STATE(9905),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9905),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9905),
    [sym__lexp] = STATE(9905),
    [sym_exp_infix] = STATE(9905),
    [sym__exp_infix] = STATE(9905),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1735] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9921),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9921),
    [sym_exp_cond] = STATE(9921),
    [sym_exp_if_guard] = STATE(9921),
    [sym_exp_case] = STATE(9921),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9921),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9921),
    [sym__lexp] = STATE(9921),
    [sym_exp_infix] = STATE(9921),
    [sym__exp_infix] = STATE(9921),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1736] = {
    [sym_integer] = STATE(11301),
    [sym__literal] = STATE(11301),
    [sym__unboxed_open] = STATE(121),
    [sym_variable] = STATE(10592),
    [sym_qualified_variable] = STATE(9343),
    [sym_constructor] = STATE(10791),
    [sym_qualified_constructor] = STATE(10925),
    [sym__qcon] = STATE(11051),
    [sym_con_unit] = STATE(11301),
    [sym_con_list] = STATE(11301),
    [sym_con_tuple] = STATE(11301),
    [sym_literal] = STATE(11050),
    [sym_exp_parens] = STATE(9481),
    [sym_exp_tuple] = STATE(9481),
    [sym_exp_unboxed_tuple] = STATE(9481),
    [sym_exp_unboxed_sum] = STATE(9481),
    [sym_exp_list] = STATE(9481),
    [sym_exp_arithmetic_sequence] = STATE(9481),
    [sym_exp_list_comprehension] = STATE(9481),
    [sym_exp_section_left] = STATE(9481),
    [sym_exp_section_right] = STATE(9481),
    [sym_exp_th_quoted_name] = STATE(9481),
    [sym_exp_type_application] = STATE(9563),
    [sym_exp_lambda_case] = STATE(9563),
    [sym__do_keyword] = STATE(18466),
    [sym_do_module] = STATE(18466),
    [sym_exp_do] = STATE(9563),
    [sym_exp_record] = STATE(9481),
    [sym_exp_name] = STATE(9481),
    [sym_exp_projection_selector] = STATE(9481),
    [sym__aexp_projection] = STATE(9481),
    [sym_exp_projection] = STATE(9481),
    [sym__aexp] = STATE(9563),
    [sym_pat_as] = STATE(13129),
    [sym_pat_parens] = STATE(13129),
    [sym_pat_tuple] = STATE(13129),
    [sym_pat_unboxed_tuple] = STATE(13129),
    [sym_pat_unboxed_sum] = STATE(13129),
    [sym_pat_list] = STATE(13129),
    [sym_pat_strict] = STATE(13129),
    [sym_pat_irrefutable] = STATE(13129),
    [sym_pat_name] = STATE(13129),
    [sym__pat_constructor] = STATE(12594),
    [sym_pat_wildcard] = STATE(13129),
    [sym_pat_record] = STATE(13129),
    [sym__apat] = STATE(13129),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12557),
    [sym_splice] = STATE(11047),
    [sym_quasiquote] = STATE(11047),
    [sym__varid] = ACTIONS(4337),
    [sym_float] = ACTIONS(4339),
    [sym_char] = ACTIONS(4339),
    [sym_string] = ACTIONS(4339),
    [sym__integer_literal] = ACTIONS(4341),
    [sym__binary_literal] = ACTIONS(4343),
    [sym__octal_literal] = ACTIONS(4343),
    [sym__hex_literal] = ACTIONS(4343),
    [anon_sym_LPAREN_POUND] = ACTIONS(4345),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4345),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4223),
    [anon_sym_LPAREN] = ACTIONS(4347),
    [sym_implicit_parid] = ACTIONS(4223),
    [sym__conid] = ACTIONS(4349),
    [anon_sym_LBRACK] = ACTIONS(4351),
    [anon_sym_SQUOTE] = ACTIONS(4229),
    [anon_sym__] = ACTIONS(1192),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4231),
    [anon_sym_AT] = ACTIONS(4233),
    [anon_sym_BSLASH] = ACTIONS(4235),
    [anon_sym_mdo] = ACTIONS(4237),
    [anon_sym_do] = ACTIONS(4237),
    [anon_sym_7] = ACTIONS(4353),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4355),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4357),
    [sym__strict] = ACTIONS(1212),
    [sym__lazy] = ACTIONS(1214),
  },
  [1737] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9837),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9837),
    [sym_exp_cond] = STATE(9837),
    [sym_exp_if_guard] = STATE(9837),
    [sym_exp_case] = STATE(9837),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9837),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9837),
    [sym__lexp] = STATE(9837),
    [sym_exp_infix] = STATE(9837),
    [sym__exp_infix] = STATE(9837),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1738] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9882),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9882),
    [sym_exp_cond] = STATE(9882),
    [sym_exp_if_guard] = STATE(9882),
    [sym_exp_case] = STATE(9882),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9882),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9882),
    [sym__lexp] = STATE(9882),
    [sym_exp_infix] = STATE(9882),
    [sym__exp_infix] = STATE(9882),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1739] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9841),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9841),
    [sym_exp_cond] = STATE(9841),
    [sym_exp_if_guard] = STATE(9841),
    [sym_exp_case] = STATE(9841),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9841),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9841),
    [sym__lexp] = STATE(9841),
    [sym_exp_infix] = STATE(9841),
    [sym__exp_infix] = STATE(9841),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1740] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9826),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9826),
    [sym_exp_cond] = STATE(9826),
    [sym_exp_if_guard] = STATE(9826),
    [sym_exp_case] = STATE(9826),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9826),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9826),
    [sym__lexp] = STATE(9826),
    [sym_exp_infix] = STATE(9826),
    [sym__exp_infix] = STATE(9826),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1741] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9885),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9885),
    [sym_exp_cond] = STATE(9885),
    [sym_exp_if_guard] = STATE(9885),
    [sym_exp_case] = STATE(9885),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9885),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9885),
    [sym__lexp] = STATE(9885),
    [sym_exp_infix] = STATE(9885),
    [sym__exp_infix] = STATE(9885),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1742] = {
    [sym_integer] = STATE(10715),
    [sym__literal] = STATE(10715),
    [sym__unboxed_open] = STATE(112),
    [sym_variable] = STATE(10247),
    [sym_qualified_variable] = STATE(10627),
    [sym_constructor] = STATE(10105),
    [sym_qualified_constructor] = STATE(10604),
    [sym__qcon] = STATE(10542),
    [sym_con_unit] = STATE(10715),
    [sym_con_list] = STATE(10715),
    [sym_con_tuple] = STATE(10715),
    [sym_literal] = STATE(10543),
    [sym_exp_parens] = STATE(11645),
    [sym_exp_tuple] = STATE(11645),
    [sym_exp_unboxed_tuple] = STATE(11645),
    [sym_exp_unboxed_sum] = STATE(11645),
    [sym_exp_list] = STATE(11645),
    [sym_exp_arithmetic_sequence] = STATE(11645),
    [sym_exp_list_comprehension] = STATE(11645),
    [sym_exp_section_left] = STATE(11645),
    [sym_exp_section_right] = STATE(11645),
    [sym_exp_th_quoted_name] = STATE(11645),
    [sym_exp_type_application] = STATE(12027),
    [sym_exp_lambda_case] = STATE(12027),
    [sym__do_keyword] = STATE(18375),
    [sym_do_module] = STATE(18375),
    [sym_exp_do] = STATE(12027),
    [sym_exp_record] = STATE(11645),
    [sym_exp_name] = STATE(11645),
    [sym_exp_projection_selector] = STATE(11645),
    [sym__aexp_projection] = STATE(11645),
    [sym_exp_projection] = STATE(11645),
    [sym__aexp] = STATE(12027),
    [sym_pat_as] = STATE(12278),
    [sym_pat_parens] = STATE(12278),
    [sym_pat_tuple] = STATE(12278),
    [sym_pat_unboxed_tuple] = STATE(12278),
    [sym_pat_unboxed_sum] = STATE(12278),
    [sym_pat_list] = STATE(12278),
    [sym_pat_strict] = STATE(12278),
    [sym_pat_irrefutable] = STATE(12278),
    [sym_pat_name] = STATE(12278),
    [sym__pat_constructor] = STATE(11599),
    [sym_pat_wildcard] = STATE(12278),
    [sym_pat_record] = STATE(12278),
    [sym__apat] = STATE(12278),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12661),
    [sym_splice] = STATE(10544),
    [sym_quasiquote] = STATE(10544),
    [sym__varid] = ACTIONS(4359),
    [sym_float] = ACTIONS(4361),
    [sym_char] = ACTIONS(4361),
    [sym_string] = ACTIONS(4361),
    [sym__integer_literal] = ACTIONS(4363),
    [sym__binary_literal] = ACTIONS(4365),
    [sym__octal_literal] = ACTIONS(4365),
    [sym__hex_literal] = ACTIONS(4365),
    [anon_sym_LPAREN_POUND] = ACTIONS(4367),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4367),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4369),
    [anon_sym_LPAREN] = ACTIONS(4371),
    [sym_implicit_parid] = ACTIONS(4369),
    [sym__conid] = ACTIONS(4373),
    [anon_sym_LBRACK] = ACTIONS(4375),
    [anon_sym_SQUOTE] = ACTIONS(4377),
    [anon_sym__] = ACTIONS(661),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4379),
    [anon_sym_AT] = ACTIONS(4381),
    [anon_sym_BSLASH] = ACTIONS(4383),
    [anon_sym_mdo] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4385),
    [anon_sym_7] = ACTIONS(4387),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4389),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4391),
    [sym__strict] = ACTIONS(673),
    [sym__lazy] = ACTIONS(675),
  },
  [1743] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9820),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9820),
    [sym_exp_cond] = STATE(9820),
    [sym_exp_if_guard] = STATE(9820),
    [sym_exp_case] = STATE(9820),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9820),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9820),
    [sym__lexp] = STATE(9820),
    [sym_exp_infix] = STATE(9820),
    [sym__exp_infix] = STATE(9820),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1744] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9728),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9728),
    [sym_exp_cond] = STATE(9728),
    [sym_exp_if_guard] = STATE(9728),
    [sym_exp_case] = STATE(9728),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9728),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9728),
    [sym__lexp] = STATE(9728),
    [sym_exp_infix] = STATE(9728),
    [sym__exp_infix] = STATE(9728),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1745] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9800),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9800),
    [sym_exp_cond] = STATE(9800),
    [sym_exp_if_guard] = STATE(9800),
    [sym_exp_case] = STATE(9800),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9800),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9800),
    [sym__lexp] = STATE(9800),
    [sym_exp_infix] = STATE(9800),
    [sym__exp_infix] = STATE(9800),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1746] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9922),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9922),
    [sym_exp_cond] = STATE(9922),
    [sym_exp_if_guard] = STATE(9922),
    [sym_exp_case] = STATE(9922),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9922),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9922),
    [sym__lexp] = STATE(9922),
    [sym_exp_infix] = STATE(9922),
    [sym__exp_infix] = STATE(9922),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1747] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9747),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9747),
    [sym_exp_cond] = STATE(9747),
    [sym_exp_if_guard] = STATE(9747),
    [sym_exp_case] = STATE(9747),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9747),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9747),
    [sym__lexp] = STATE(9747),
    [sym_exp_infix] = STATE(9747),
    [sym__exp_infix] = STATE(9747),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1748] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9834),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9834),
    [sym_exp_cond] = STATE(9834),
    [sym_exp_if_guard] = STATE(9834),
    [sym_exp_case] = STATE(9834),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9834),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9834),
    [sym__lexp] = STATE(9834),
    [sym_exp_infix] = STATE(9834),
    [sym__exp_infix] = STATE(9834),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1749] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9854),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9854),
    [sym_exp_cond] = STATE(9854),
    [sym_exp_if_guard] = STATE(9854),
    [sym_exp_case] = STATE(9854),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9854),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9854),
    [sym__lexp] = STATE(9854),
    [sym_exp_infix] = STATE(9854),
    [sym__exp_infix] = STATE(9854),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1750] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9880),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9880),
    [sym_exp_cond] = STATE(9880),
    [sym_exp_if_guard] = STATE(9880),
    [sym_exp_case] = STATE(9880),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9880),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9880),
    [sym__lexp] = STATE(9880),
    [sym_exp_infix] = STATE(9880),
    [sym__exp_infix] = STATE(9880),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1751] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9811),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9811),
    [sym_exp_cond] = STATE(9811),
    [sym_exp_if_guard] = STATE(9811),
    [sym_exp_case] = STATE(9811),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9811),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9811),
    [sym__lexp] = STATE(9811),
    [sym_exp_infix] = STATE(9811),
    [sym__exp_infix] = STATE(9811),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1752] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9866),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9866),
    [sym_exp_cond] = STATE(9866),
    [sym_exp_if_guard] = STATE(9866),
    [sym_exp_case] = STATE(9866),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9866),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9866),
    [sym__lexp] = STATE(9866),
    [sym_exp_infix] = STATE(9866),
    [sym__exp_infix] = STATE(9866),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1753] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9966),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9966),
    [sym_exp_cond] = STATE(9966),
    [sym_exp_if_guard] = STATE(9966),
    [sym_exp_case] = STATE(9966),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9966),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9966),
    [sym__lexp] = STATE(9966),
    [sym_exp_infix] = STATE(9966),
    [sym__exp_infix] = STATE(9966),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1754] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9920),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9920),
    [sym_exp_cond] = STATE(9920),
    [sym_exp_if_guard] = STATE(9920),
    [sym_exp_case] = STATE(9920),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9920),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9920),
    [sym__lexp] = STATE(9920),
    [sym_exp_infix] = STATE(9920),
    [sym__exp_infix] = STATE(9920),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1755] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9861),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9861),
    [sym_exp_cond] = STATE(9861),
    [sym_exp_if_guard] = STATE(9861),
    [sym_exp_case] = STATE(9861),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9861),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9861),
    [sym__lexp] = STATE(9861),
    [sym_exp_infix] = STATE(9861),
    [sym__exp_infix] = STATE(9861),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1756] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9727),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9727),
    [sym_exp_cond] = STATE(9727),
    [sym_exp_if_guard] = STATE(9727),
    [sym_exp_case] = STATE(9727),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9727),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9727),
    [sym__lexp] = STATE(9727),
    [sym_exp_infix] = STATE(9727),
    [sym__exp_infix] = STATE(9727),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1757] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9930),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9930),
    [sym_exp_cond] = STATE(9930),
    [sym_exp_if_guard] = STATE(9930),
    [sym_exp_case] = STATE(9930),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9930),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9930),
    [sym__lexp] = STATE(9930),
    [sym_exp_infix] = STATE(9930),
    [sym__exp_infix] = STATE(9930),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1758] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9832),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9832),
    [sym_exp_cond] = STATE(9832),
    [sym_exp_if_guard] = STATE(9832),
    [sym_exp_case] = STATE(9832),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9832),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9832),
    [sym__lexp] = STATE(9832),
    [sym_exp_infix] = STATE(9832),
    [sym__exp_infix] = STATE(9832),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1759] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9910),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9910),
    [sym_exp_cond] = STATE(9910),
    [sym_exp_if_guard] = STATE(9910),
    [sym_exp_case] = STATE(9910),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9910),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9910),
    [sym__lexp] = STATE(9910),
    [sym_exp_infix] = STATE(9910),
    [sym__exp_infix] = STATE(9910),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1760] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9804),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9804),
    [sym_exp_cond] = STATE(9804),
    [sym_exp_if_guard] = STATE(9804),
    [sym_exp_case] = STATE(9804),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9804),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9804),
    [sym__lexp] = STATE(9804),
    [sym_exp_infix] = STATE(9804),
    [sym__exp_infix] = STATE(9804),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1761] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9869),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9869),
    [sym_exp_cond] = STATE(9869),
    [sym_exp_if_guard] = STATE(9869),
    [sym_exp_case] = STATE(9869),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9869),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9869),
    [sym__lexp] = STATE(9869),
    [sym_exp_infix] = STATE(9869),
    [sym__exp_infix] = STATE(9869),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1762] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9864),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9864),
    [sym_exp_cond] = STATE(9864),
    [sym_exp_if_guard] = STATE(9864),
    [sym_exp_case] = STATE(9864),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9864),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9864),
    [sym__lexp] = STATE(9864),
    [sym_exp_infix] = STATE(9864),
    [sym__exp_infix] = STATE(9864),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1763] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9764),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9764),
    [sym_exp_cond] = STATE(9764),
    [sym_exp_if_guard] = STATE(9764),
    [sym_exp_case] = STATE(9764),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9764),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9764),
    [sym__lexp] = STATE(9764),
    [sym_exp_infix] = STATE(9764),
    [sym__exp_infix] = STATE(9764),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1764] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9746),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9746),
    [sym_exp_cond] = STATE(9746),
    [sym_exp_if_guard] = STATE(9746),
    [sym_exp_case] = STATE(9746),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9746),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9746),
    [sym__lexp] = STATE(9746),
    [sym_exp_infix] = STATE(9746),
    [sym__exp_infix] = STATE(9746),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1765] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9787),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9787),
    [sym_exp_cond] = STATE(9787),
    [sym_exp_if_guard] = STATE(9787),
    [sym_exp_case] = STATE(9787),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9787),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9787),
    [sym__lexp] = STATE(9787),
    [sym_exp_infix] = STATE(9787),
    [sym__exp_infix] = STATE(9787),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1766] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9726),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9726),
    [sym_exp_cond] = STATE(9726),
    [sym_exp_if_guard] = STATE(9726),
    [sym_exp_case] = STATE(9726),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9726),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9726),
    [sym__lexp] = STATE(9726),
    [sym_exp_infix] = STATE(9726),
    [sym__exp_infix] = STATE(9726),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1767] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9730),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9730),
    [sym_exp_cond] = STATE(9730),
    [sym_exp_if_guard] = STATE(9730),
    [sym_exp_case] = STATE(9730),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9730),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9730),
    [sym__lexp] = STATE(9730),
    [sym_exp_infix] = STATE(9730),
    [sym__exp_infix] = STATE(9730),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1768] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9821),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9821),
    [sym_exp_cond] = STATE(9821),
    [sym_exp_if_guard] = STATE(9821),
    [sym_exp_case] = STATE(9821),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9821),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9821),
    [sym__lexp] = STATE(9821),
    [sym_exp_infix] = STATE(9821),
    [sym__exp_infix] = STATE(9821),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1769] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9825),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9825),
    [sym_exp_cond] = STATE(9825),
    [sym_exp_if_guard] = STATE(9825),
    [sym_exp_case] = STATE(9825),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9825),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9825),
    [sym__lexp] = STATE(9825),
    [sym_exp_infix] = STATE(9825),
    [sym__exp_infix] = STATE(9825),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1770] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9838),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9838),
    [sym_exp_cond] = STATE(9838),
    [sym_exp_if_guard] = STATE(9838),
    [sym_exp_case] = STATE(9838),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9838),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9838),
    [sym__lexp] = STATE(9838),
    [sym_exp_infix] = STATE(9838),
    [sym__exp_infix] = STATE(9838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1771] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9847),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9847),
    [sym_exp_cond] = STATE(9847),
    [sym_exp_if_guard] = STATE(9847),
    [sym_exp_case] = STATE(9847),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9847),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9847),
    [sym__lexp] = STATE(9847),
    [sym_exp_infix] = STATE(9847),
    [sym__exp_infix] = STATE(9847),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1772] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9848),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9848),
    [sym_exp_cond] = STATE(9848),
    [sym_exp_if_guard] = STATE(9848),
    [sym_exp_case] = STATE(9848),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9848),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9848),
    [sym__lexp] = STATE(9848),
    [sym_exp_infix] = STATE(9848),
    [sym__exp_infix] = STATE(9848),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1773] = {
    [sym_integer] = STATE(10538),
    [sym__literal] = STATE(10538),
    [sym__unboxed_open] = STATE(96),
    [sym_variable] = STATE(10178),
    [sym_qualified_variable] = STATE(10320),
    [sym_constructor] = STATE(10164),
    [sym_qualified_constructor] = STATE(10683),
    [sym__qcon] = STATE(10589),
    [sym_con_unit] = STATE(10538),
    [sym_con_list] = STATE(10538),
    [sym_con_tuple] = STATE(10538),
    [sym_literal] = STATE(10591),
    [sym_exp_parens] = STATE(10593),
    [sym_exp_tuple] = STATE(10593),
    [sym_exp_unboxed_tuple] = STATE(10593),
    [sym_exp_unboxed_sum] = STATE(10593),
    [sym_exp_list] = STATE(10593),
    [sym_exp_arithmetic_sequence] = STATE(10593),
    [sym_exp_list_comprehension] = STATE(10593),
    [sym_exp_section_left] = STATE(10593),
    [sym_exp_section_right] = STATE(10593),
    [sym_exp_th_quoted_name] = STATE(10593),
    [sym_exp_type_application] = STATE(11370),
    [sym_exp_lambda_case] = STATE(11370),
    [sym__do_keyword] = STATE(18445),
    [sym_do_module] = STATE(18445),
    [sym_exp_do] = STATE(11370),
    [sym_exp_record] = STATE(10593),
    [sym_exp_name] = STATE(10593),
    [sym_exp_projection_selector] = STATE(10593),
    [sym__aexp_projection] = STATE(10593),
    [sym_exp_projection] = STATE(10593),
    [sym__aexp] = STATE(11370),
    [sym_pat_as] = STATE(12785),
    [sym_pat_parens] = STATE(12785),
    [sym_pat_tuple] = STATE(12785),
    [sym_pat_unboxed_tuple] = STATE(12785),
    [sym_pat_unboxed_sum] = STATE(12785),
    [sym_pat_list] = STATE(12785),
    [sym_pat_strict] = STATE(12785),
    [sym_pat_irrefutable] = STATE(12785),
    [sym_pat_name] = STATE(12785),
    [sym__pat_constructor] = STATE(12487),
    [sym_pat_wildcard] = STATE(12785),
    [sym_pat_record] = STATE(12785),
    [sym__apat] = STATE(12785),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12500),
    [sym_splice] = STATE(10594),
    [sym_quasiquote] = STATE(10594),
    [sym__varid] = ACTIONS(4393),
    [sym_float] = ACTIONS(4395),
    [sym_char] = ACTIONS(4395),
    [sym_string] = ACTIONS(4395),
    [sym__integer_literal] = ACTIONS(4397),
    [sym__binary_literal] = ACTIONS(4399),
    [sym__octal_literal] = ACTIONS(4399),
    [sym__hex_literal] = ACTIONS(4399),
    [anon_sym_LPAREN_POUND] = ACTIONS(4401),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4401),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(4405),
    [sym_implicit_parid] = ACTIONS(4403),
    [sym__conid] = ACTIONS(4407),
    [anon_sym_LBRACK] = ACTIONS(4409),
    [anon_sym_SQUOTE] = ACTIONS(4411),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4413),
    [anon_sym_AT] = ACTIONS(4415),
    [anon_sym_BSLASH] = ACTIONS(4417),
    [anon_sym_mdo] = ACTIONS(4419),
    [anon_sym_do] = ACTIONS(4419),
    [anon_sym_7] = ACTIONS(4421),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4423),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4425),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
  },
  [1774] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9749),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9749),
    [sym_exp_cond] = STATE(9749),
    [sym_exp_if_guard] = STATE(9749),
    [sym_exp_case] = STATE(9749),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9749),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9749),
    [sym__lexp] = STATE(9749),
    [sym_exp_infix] = STATE(9749),
    [sym__exp_infix] = STATE(9749),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1775] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9894),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9894),
    [sym_exp_cond] = STATE(9894),
    [sym_exp_if_guard] = STATE(9894),
    [sym_exp_case] = STATE(9894),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9894),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9894),
    [sym__lexp] = STATE(9894),
    [sym_exp_infix] = STATE(9894),
    [sym__exp_infix] = STATE(9894),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1776] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9897),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9897),
    [sym_exp_cond] = STATE(9897),
    [sym_exp_if_guard] = STATE(9897),
    [sym_exp_case] = STATE(9897),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9897),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9897),
    [sym__lexp] = STATE(9897),
    [sym_exp_infix] = STATE(9897),
    [sym__exp_infix] = STATE(9897),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1777] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9904),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9904),
    [sym_exp_cond] = STATE(9904),
    [sym_exp_if_guard] = STATE(9904),
    [sym_exp_case] = STATE(9904),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9904),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9904),
    [sym__lexp] = STATE(9904),
    [sym_exp_infix] = STATE(9904),
    [sym__exp_infix] = STATE(9904),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1778] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9914),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9914),
    [sym_exp_cond] = STATE(9914),
    [sym_exp_if_guard] = STATE(9914),
    [sym_exp_case] = STATE(9914),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9914),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9914),
    [sym__lexp] = STATE(9914),
    [sym_exp_infix] = STATE(9914),
    [sym__exp_infix] = STATE(9914),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1779] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9929),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9929),
    [sym_exp_cond] = STATE(9929),
    [sym_exp_if_guard] = STATE(9929),
    [sym_exp_case] = STATE(9929),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9929),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9929),
    [sym__lexp] = STATE(9929),
    [sym_exp_infix] = STATE(9929),
    [sym__exp_infix] = STATE(9929),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1780] = {
    [sym_integer] = STATE(11487),
    [sym__literal] = STATE(11487),
    [sym__unboxed_open] = STATE(102),
    [sym_variable] = STATE(10666),
    [sym_qualified_variable] = STATE(9343),
    [sym_constructor] = STATE(10806),
    [sym_qualified_constructor] = STATE(10906),
    [sym__qcon] = STATE(10942),
    [sym_con_unit] = STATE(11487),
    [sym_con_list] = STATE(11487),
    [sym_con_tuple] = STATE(11487),
    [sym_literal] = STATE(10994),
    [sym_exp_parens] = STATE(9481),
    [sym_exp_tuple] = STATE(9481),
    [sym_exp_unboxed_tuple] = STATE(9481),
    [sym_exp_unboxed_sum] = STATE(9481),
    [sym_exp_list] = STATE(9481),
    [sym_exp_arithmetic_sequence] = STATE(9481),
    [sym_exp_list_comprehension] = STATE(9481),
    [sym_exp_section_left] = STATE(9481),
    [sym_exp_section_right] = STATE(9481),
    [sym_exp_th_quoted_name] = STATE(9481),
    [sym_exp_type_application] = STATE(9563),
    [sym_exp_lambda_case] = STATE(9563),
    [sym__do_keyword] = STATE(18466),
    [sym_do_module] = STATE(18466),
    [sym_exp_do] = STATE(9563),
    [sym_exp_record] = STATE(9481),
    [sym_exp_name] = STATE(9481),
    [sym_exp_projection_selector] = STATE(9481),
    [sym__aexp_projection] = STATE(9481),
    [sym_exp_projection] = STATE(9481),
    [sym__aexp] = STATE(9563),
    [sym_pat_as] = STATE(13374),
    [sym_pat_parens] = STATE(13374),
    [sym_pat_tuple] = STATE(13374),
    [sym_pat_unboxed_tuple] = STATE(13374),
    [sym_pat_unboxed_sum] = STATE(13374),
    [sym_pat_list] = STATE(13374),
    [sym_pat_strict] = STATE(13374),
    [sym_pat_irrefutable] = STATE(13374),
    [sym_pat_name] = STATE(13374),
    [sym__pat_constructor] = STATE(12544),
    [sym_pat_wildcard] = STATE(13374),
    [sym_pat_record] = STATE(13374),
    [sym__apat] = STATE(13374),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12571),
    [sym_splice] = STATE(10944),
    [sym_quasiquote] = STATE(10944),
    [sym__varid] = ACTIONS(4427),
    [sym_float] = ACTIONS(4429),
    [sym_char] = ACTIONS(4429),
    [sym_string] = ACTIONS(4429),
    [sym__integer_literal] = ACTIONS(4431),
    [sym__binary_literal] = ACTIONS(4433),
    [sym__octal_literal] = ACTIONS(4433),
    [sym__hex_literal] = ACTIONS(4433),
    [anon_sym_LPAREN_POUND] = ACTIONS(4435),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4435),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4223),
    [anon_sym_LPAREN] = ACTIONS(4437),
    [sym_implicit_parid] = ACTIONS(4223),
    [sym__conid] = ACTIONS(4439),
    [anon_sym_LBRACK] = ACTIONS(4441),
    [anon_sym_SQUOTE] = ACTIONS(4229),
    [anon_sym__] = ACTIONS(1378),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4231),
    [anon_sym_AT] = ACTIONS(4233),
    [anon_sym_BSLASH] = ACTIONS(4235),
    [anon_sym_mdo] = ACTIONS(4237),
    [anon_sym_do] = ACTIONS(4237),
    [anon_sym_7] = ACTIONS(4443),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4445),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4447),
    [sym__strict] = ACTIONS(1386),
    [sym__lazy] = ACTIONS(1388),
  },
  [1781] = {
    [sym_integer] = STATE(10538),
    [sym__literal] = STATE(10538),
    [sym__unboxed_open] = STATE(118),
    [sym_variable] = STATE(10119),
    [sym_qualified_variable] = STATE(9343),
    [sym_constructor] = STATE(10164),
    [sym_qualified_constructor] = STATE(10683),
    [sym__qcon] = STATE(10626),
    [sym_con_unit] = STATE(10538),
    [sym_con_list] = STATE(10538),
    [sym_con_tuple] = STATE(10538),
    [sym_literal] = STATE(10623),
    [sym_exp_parens] = STATE(9481),
    [sym_exp_tuple] = STATE(9481),
    [sym_exp_unboxed_tuple] = STATE(9481),
    [sym_exp_unboxed_sum] = STATE(9481),
    [sym_exp_list] = STATE(9481),
    [sym_exp_arithmetic_sequence] = STATE(9481),
    [sym_exp_list_comprehension] = STATE(9481),
    [sym_exp_section_left] = STATE(9481),
    [sym_exp_section_right] = STATE(9481),
    [sym_exp_th_quoted_name] = STATE(9481),
    [sym_exp_type_application] = STATE(9563),
    [sym_exp_lambda_case] = STATE(9563),
    [sym__do_keyword] = STATE(18466),
    [sym_do_module] = STATE(18466),
    [sym_exp_do] = STATE(9563),
    [sym_exp_record] = STATE(9481),
    [sym_exp_name] = STATE(9481),
    [sym_exp_projection_selector] = STATE(9481),
    [sym__aexp_projection] = STATE(9481),
    [sym_exp_projection] = STATE(9481),
    [sym__aexp] = STATE(9563),
    [sym_pat_as] = STATE(12785),
    [sym_pat_parens] = STATE(12785),
    [sym_pat_tuple] = STATE(12785),
    [sym_pat_unboxed_tuple] = STATE(12785),
    [sym_pat_unboxed_sum] = STATE(12785),
    [sym_pat_list] = STATE(12785),
    [sym_pat_strict] = STATE(12785),
    [sym_pat_irrefutable] = STATE(12785),
    [sym_pat_name] = STATE(12785),
    [sym__pat_constructor] = STATE(12487),
    [sym_pat_wildcard] = STATE(12785),
    [sym_pat_record] = STATE(12785),
    [sym__apat] = STATE(12785),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12682),
    [sym_splice] = STATE(10622),
    [sym_quasiquote] = STATE(10622),
    [sym__varid] = ACTIONS(4393),
    [sym_float] = ACTIONS(4395),
    [sym_char] = ACTIONS(4395),
    [sym_string] = ACTIONS(4395),
    [sym__integer_literal] = ACTIONS(4397),
    [sym__binary_literal] = ACTIONS(4399),
    [sym__octal_literal] = ACTIONS(4399),
    [sym__hex_literal] = ACTIONS(4399),
    [anon_sym_LPAREN_POUND] = ACTIONS(4449),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4449),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4223),
    [anon_sym_LPAREN] = ACTIONS(4451),
    [sym_implicit_parid] = ACTIONS(4223),
    [sym__conid] = ACTIONS(4407),
    [anon_sym_LBRACK] = ACTIONS(4453),
    [anon_sym_SQUOTE] = ACTIONS(4229),
    [anon_sym__] = ACTIONS(557),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4231),
    [anon_sym_AT] = ACTIONS(4233),
    [anon_sym_BSLASH] = ACTIONS(4235),
    [anon_sym_mdo] = ACTIONS(4237),
    [anon_sym_do] = ACTIONS(4237),
    [anon_sym_7] = ACTIONS(4421),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4423),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4425),
    [sym__strict] = ACTIONS(579),
    [sym__lazy] = ACTIONS(581),
  },
  [1782] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9973),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9973),
    [sym_exp_cond] = STATE(9973),
    [sym_exp_if_guard] = STATE(9973),
    [sym_exp_case] = STATE(9973),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9973),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9973),
    [sym__lexp] = STATE(9973),
    [sym_exp_infix] = STATE(9973),
    [sym__exp_infix] = STATE(9973),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1783] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9936),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9936),
    [sym_exp_cond] = STATE(9936),
    [sym_exp_if_guard] = STATE(9936),
    [sym_exp_case] = STATE(9936),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9936),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9936),
    [sym__lexp] = STATE(9936),
    [sym_exp_infix] = STATE(9936),
    [sym__exp_infix] = STATE(9936),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1784] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9743),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9743),
    [sym_exp_cond] = STATE(9743),
    [sym_exp_if_guard] = STATE(9743),
    [sym_exp_case] = STATE(9743),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9743),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9743),
    [sym__lexp] = STATE(9743),
    [sym_exp_infix] = STATE(9743),
    [sym__exp_infix] = STATE(9743),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1785] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9889),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9889),
    [sym_exp_cond] = STATE(9889),
    [sym_exp_if_guard] = STATE(9889),
    [sym_exp_case] = STATE(9889),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9889),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9889),
    [sym__lexp] = STATE(9889),
    [sym_exp_infix] = STATE(9889),
    [sym__exp_infix] = STATE(9889),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1786] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9829),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9829),
    [sym_exp_cond] = STATE(9829),
    [sym_exp_if_guard] = STATE(9829),
    [sym_exp_case] = STATE(9829),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9829),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9829),
    [sym__lexp] = STATE(9829),
    [sym_exp_infix] = STATE(9829),
    [sym__exp_infix] = STATE(9829),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1787] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9780),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9780),
    [sym_exp_cond] = STATE(9780),
    [sym_exp_if_guard] = STATE(9780),
    [sym_exp_case] = STATE(9780),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9780),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9780),
    [sym__lexp] = STATE(9780),
    [sym_exp_infix] = STATE(9780),
    [sym__exp_infix] = STATE(9780),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1788] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9808),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9808),
    [sym_exp_cond] = STATE(9808),
    [sym_exp_if_guard] = STATE(9808),
    [sym_exp_case] = STATE(9808),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9808),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9808),
    [sym__lexp] = STATE(9808),
    [sym_exp_infix] = STATE(9808),
    [sym__exp_infix] = STATE(9808),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1789] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9761),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9761),
    [sym_exp_cond] = STATE(9761),
    [sym_exp_if_guard] = STATE(9761),
    [sym_exp_case] = STATE(9761),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9761),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9761),
    [sym__lexp] = STATE(9761),
    [sym_exp_infix] = STATE(9761),
    [sym__exp_infix] = STATE(9761),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1790] = {
    [sym_integer] = STATE(11301),
    [sym__literal] = STATE(11301),
    [sym__unboxed_open] = STATE(104),
    [sym_variable] = STATE(10419),
    [sym_qualified_variable] = STATE(10982),
    [sym_constructor] = STATE(10791),
    [sym_qualified_constructor] = STATE(10925),
    [sym__qcon] = STATE(11451),
    [sym_con_unit] = STATE(11301),
    [sym_con_list] = STATE(11301),
    [sym_con_tuple] = STATE(11301),
    [sym_literal] = STATE(11452),
    [sym_exp_parens] = STATE(11327),
    [sym_exp_tuple] = STATE(11327),
    [sym_exp_unboxed_tuple] = STATE(11327),
    [sym_exp_unboxed_sum] = STATE(11327),
    [sym_exp_list] = STATE(11327),
    [sym_exp_arithmetic_sequence] = STATE(11327),
    [sym_exp_list_comprehension] = STATE(11327),
    [sym_exp_section_left] = STATE(11327),
    [sym_exp_section_right] = STATE(11327),
    [sym_exp_th_quoted_name] = STATE(11327),
    [sym_exp_type_application] = STATE(11683),
    [sym_exp_lambda_case] = STATE(11683),
    [sym__do_keyword] = STATE(18385),
    [sym_do_module] = STATE(18385),
    [sym_exp_do] = STATE(11683),
    [sym_exp_record] = STATE(11327),
    [sym_exp_name] = STATE(11327),
    [sym_exp_projection_selector] = STATE(11327),
    [sym__aexp_projection] = STATE(11327),
    [sym_exp_projection] = STATE(11327),
    [sym__aexp] = STATE(11683),
    [sym_pat_as] = STATE(13129),
    [sym_pat_parens] = STATE(13129),
    [sym_pat_tuple] = STATE(13129),
    [sym_pat_unboxed_tuple] = STATE(13129),
    [sym_pat_unboxed_sum] = STATE(13129),
    [sym_pat_list] = STATE(13129),
    [sym_pat_strict] = STATE(13129),
    [sym_pat_irrefutable] = STATE(13129),
    [sym_pat_name] = STATE(13129),
    [sym__pat_constructor] = STATE(12594),
    [sym_pat_wildcard] = STATE(13129),
    [sym_pat_record] = STATE(13129),
    [sym__apat] = STATE(13129),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12528),
    [sym_splice] = STATE(11453),
    [sym_quasiquote] = STATE(11453),
    [sym__varid] = ACTIONS(4337),
    [sym_float] = ACTIONS(4339),
    [sym_char] = ACTIONS(4339),
    [sym_string] = ACTIONS(4339),
    [sym__integer_literal] = ACTIONS(4341),
    [sym__binary_literal] = ACTIONS(4343),
    [sym__octal_literal] = ACTIONS(4343),
    [sym__hex_literal] = ACTIONS(4343),
    [anon_sym_LPAREN_POUND] = ACTIONS(4455),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4455),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4457),
    [anon_sym_LPAREN] = ACTIONS(4459),
    [sym_implicit_parid] = ACTIONS(4457),
    [sym__conid] = ACTIONS(4349),
    [anon_sym_LBRACK] = ACTIONS(4461),
    [anon_sym_SQUOTE] = ACTIONS(4463),
    [anon_sym__] = ACTIONS(1192),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4465),
    [anon_sym_AT] = ACTIONS(4467),
    [anon_sym_BSLASH] = ACTIONS(4469),
    [anon_sym_mdo] = ACTIONS(4471),
    [anon_sym_do] = ACTIONS(4471),
    [anon_sym_7] = ACTIONS(4353),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4355),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4357),
    [sym__strict] = ACTIONS(1212),
    [sym__lazy] = ACTIONS(1214),
  },
  [1791] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9741),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9741),
    [sym_exp_cond] = STATE(9741),
    [sym_exp_if_guard] = STATE(9741),
    [sym_exp_case] = STATE(9741),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9741),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9741),
    [sym__lexp] = STATE(9741),
    [sym_exp_infix] = STATE(9741),
    [sym__exp_infix] = STATE(9741),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1792] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9719),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9719),
    [sym_exp_cond] = STATE(9719),
    [sym_exp_if_guard] = STATE(9719),
    [sym_exp_case] = STATE(9719),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9719),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9719),
    [sym__lexp] = STATE(9719),
    [sym_exp_infix] = STATE(9719),
    [sym__exp_infix] = STATE(9719),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1793] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9734),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9734),
    [sym_exp_cond] = STATE(9734),
    [sym_exp_if_guard] = STATE(9734),
    [sym_exp_case] = STATE(9734),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9734),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9734),
    [sym__lexp] = STATE(9734),
    [sym_exp_infix] = STATE(9734),
    [sym__exp_infix] = STATE(9734),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1794] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9753),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9753),
    [sym_exp_cond] = STATE(9753),
    [sym_exp_if_guard] = STATE(9753),
    [sym_exp_case] = STATE(9753),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9753),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9753),
    [sym__lexp] = STATE(9753),
    [sym_exp_infix] = STATE(9753),
    [sym__exp_infix] = STATE(9753),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1795] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9754),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9754),
    [sym_exp_cond] = STATE(9754),
    [sym_exp_if_guard] = STATE(9754),
    [sym_exp_case] = STATE(9754),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9754),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9754),
    [sym__lexp] = STATE(9754),
    [sym_exp_infix] = STATE(9754),
    [sym__exp_infix] = STATE(9754),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1796] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9763),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9763),
    [sym_exp_cond] = STATE(9763),
    [sym_exp_if_guard] = STATE(9763),
    [sym_exp_case] = STATE(9763),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9763),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9763),
    [sym__lexp] = STATE(9763),
    [sym_exp_infix] = STATE(9763),
    [sym__exp_infix] = STATE(9763),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1797] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9767),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9767),
    [sym_exp_cond] = STATE(9767),
    [sym_exp_if_guard] = STATE(9767),
    [sym_exp_case] = STATE(9767),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9767),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9767),
    [sym__lexp] = STATE(9767),
    [sym_exp_infix] = STATE(9767),
    [sym__exp_infix] = STATE(9767),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1798] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9773),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9773),
    [sym_exp_cond] = STATE(9773),
    [sym_exp_if_guard] = STATE(9773),
    [sym_exp_case] = STATE(9773),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9773),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9773),
    [sym__lexp] = STATE(9773),
    [sym_exp_infix] = STATE(9773),
    [sym__exp_infix] = STATE(9773),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1799] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9778),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9778),
    [sym_exp_cond] = STATE(9778),
    [sym_exp_if_guard] = STATE(9778),
    [sym_exp_case] = STATE(9778),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9778),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9778),
    [sym__lexp] = STATE(9778),
    [sym_exp_infix] = STATE(9778),
    [sym__exp_infix] = STATE(9778),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1800] = {
    [sym_integer] = STATE(9877),
    [sym__literal] = STATE(9877),
    [sym__unboxed_open] = STATE(99),
    [sym_variable] = STATE(9671),
    [sym_qualified_variable] = STATE(9898),
    [sym_constructor] = STATE(9690),
    [sym_qualified_constructor] = STATE(9781),
    [sym__qcon] = STATE(9766),
    [sym_con_unit] = STATE(9877),
    [sym_con_list] = STATE(9877),
    [sym_con_tuple] = STATE(9877),
    [sym_literal] = STATE(9758),
    [sym_exp_parens] = STATE(9912),
    [sym_exp_tuple] = STATE(9912),
    [sym_exp_unboxed_tuple] = STATE(9912),
    [sym_exp_unboxed_sum] = STATE(9912),
    [sym_exp_list] = STATE(9912),
    [sym_exp_arithmetic_sequence] = STATE(9912),
    [sym_exp_list_comprehension] = STATE(9912),
    [sym_exp_section_left] = STATE(9912),
    [sym_exp_section_right] = STATE(9912),
    [sym_exp_th_quoted_name] = STATE(9912),
    [sym_exp_type_application] = STATE(10035),
    [sym_exp_lambda_case] = STATE(10035),
    [sym__do_keyword] = STATE(18480),
    [sym_do_module] = STATE(18480),
    [sym_exp_do] = STATE(10035),
    [sym_exp_record] = STATE(9912),
    [sym_exp_name] = STATE(9912),
    [sym_exp_projection_selector] = STATE(9912),
    [sym__aexp_projection] = STATE(9912),
    [sym_exp_projection] = STATE(9912),
    [sym__aexp] = STATE(10035),
    [sym_pat_as] = STATE(12511),
    [sym_pat_parens] = STATE(12511),
    [sym_pat_tuple] = STATE(12511),
    [sym_pat_unboxed_tuple] = STATE(12511),
    [sym_pat_unboxed_sum] = STATE(12511),
    [sym_pat_list] = STATE(12511),
    [sym_pat_strict] = STATE(12511),
    [sym_pat_irrefutable] = STATE(12511),
    [sym_pat_name] = STATE(12511),
    [sym__pat_constructor] = STATE(12158),
    [sym_pat_wildcard] = STATE(12511),
    [sym_pat_record] = STATE(12511),
    [sym__apat] = STATE(12511),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12558),
    [sym_splice] = STATE(9748),
    [sym_quasiquote] = STATE(9748),
    [sym__varid] = ACTIONS(4473),
    [sym_float] = ACTIONS(4475),
    [sym_char] = ACTIONS(4475),
    [sym_string] = ACTIONS(4475),
    [sym__integer_literal] = ACTIONS(4477),
    [sym__binary_literal] = ACTIONS(4479),
    [sym__octal_literal] = ACTIONS(4479),
    [sym__hex_literal] = ACTIONS(4479),
    [anon_sym_LPAREN_POUND] = ACTIONS(4481),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4481),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4483),
    [anon_sym_LPAREN] = ACTIONS(4485),
    [sym_implicit_parid] = ACTIONS(4483),
    [sym__conid] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(4489),
    [anon_sym_SQUOTE] = ACTIONS(4491),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4493),
    [anon_sym_AT] = ACTIONS(4495),
    [anon_sym_BSLASH] = ACTIONS(4497),
    [anon_sym_mdo] = ACTIONS(4499),
    [anon_sym_do] = ACTIONS(4499),
    [anon_sym_7] = ACTIONS(4501),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4503),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4505),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [1801] = {
    [sym_integer] = STATE(10518),
    [sym__literal] = STATE(10518),
    [sym__unboxed_open] = STATE(105),
    [sym_variable] = STATE(10014),
    [sym_qualified_variable] = STATE(10627),
    [sym_constructor] = STATE(10104),
    [sym_qualified_constructor] = STATE(10702),
    [sym__qcon] = STATE(10682),
    [sym_con_unit] = STATE(10518),
    [sym_con_list] = STATE(10518),
    [sym_con_tuple] = STATE(10518),
    [sym_literal] = STATE(10681),
    [sym_exp_parens] = STATE(11645),
    [sym_exp_tuple] = STATE(11645),
    [sym_exp_unboxed_tuple] = STATE(11645),
    [sym_exp_unboxed_sum] = STATE(11645),
    [sym_exp_list] = STATE(11645),
    [sym_exp_arithmetic_sequence] = STATE(11645),
    [sym_exp_list_comprehension] = STATE(11645),
    [sym_exp_section_left] = STATE(11645),
    [sym_exp_section_right] = STATE(11645),
    [sym_exp_th_quoted_name] = STATE(11645),
    [sym_exp_type_application] = STATE(12027),
    [sym_exp_lambda_case] = STATE(12027),
    [sym__do_keyword] = STATE(18375),
    [sym_do_module] = STATE(18375),
    [sym_exp_do] = STATE(12027),
    [sym_exp_record] = STATE(11645),
    [sym_exp_name] = STATE(11645),
    [sym_exp_projection_selector] = STATE(11645),
    [sym__aexp_projection] = STATE(11645),
    [sym_exp_projection] = STATE(11645),
    [sym__aexp] = STATE(12027),
    [sym_pat_as] = STATE(12592),
    [sym_pat_parens] = STATE(12592),
    [sym_pat_tuple] = STATE(12592),
    [sym_pat_unboxed_tuple] = STATE(12592),
    [sym_pat_unboxed_sum] = STATE(12592),
    [sym_pat_list] = STATE(12592),
    [sym_pat_strict] = STATE(12592),
    [sym_pat_irrefutable] = STATE(12592),
    [sym_pat_name] = STATE(12592),
    [sym__pat_constructor] = STATE(12015),
    [sym_pat_wildcard] = STATE(12592),
    [sym_pat_record] = STATE(12592),
    [sym__apat] = STATE(12592),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12677),
    [sym_splice] = STATE(10675),
    [sym_quasiquote] = STATE(10675),
    [sym__varid] = ACTIONS(4507),
    [sym_float] = ACTIONS(4509),
    [sym_char] = ACTIONS(4509),
    [sym_string] = ACTIONS(4509),
    [sym__integer_literal] = ACTIONS(4511),
    [sym__binary_literal] = ACTIONS(4513),
    [sym__octal_literal] = ACTIONS(4513),
    [sym__hex_literal] = ACTIONS(4513),
    [anon_sym_LPAREN_POUND] = ACTIONS(4515),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4515),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4369),
    [anon_sym_LPAREN] = ACTIONS(4517),
    [sym_implicit_parid] = ACTIONS(4369),
    [sym__conid] = ACTIONS(4519),
    [anon_sym_LBRACK] = ACTIONS(4521),
    [anon_sym_SQUOTE] = ACTIONS(4377),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4379),
    [anon_sym_AT] = ACTIONS(4381),
    [anon_sym_BSLASH] = ACTIONS(4383),
    [anon_sym_mdo] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4385),
    [anon_sym_7] = ACTIONS(4523),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4525),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4527),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [1802] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(115),
    [sym_variable] = STATE(10827),
    [sym_qualified_variable] = STATE(9343),
    [sym_constructor] = STATE(9235),
    [sym_qualified_constructor] = STATE(9289),
    [sym__qcon] = STATE(11150),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(11156),
    [sym_exp_parens] = STATE(9481),
    [sym_exp_tuple] = STATE(9481),
    [sym_exp_unboxed_tuple] = STATE(9481),
    [sym_exp_unboxed_sum] = STATE(9481),
    [sym_exp_list] = STATE(9481),
    [sym_exp_arithmetic_sequence] = STATE(9481),
    [sym_exp_list_comprehension] = STATE(9481),
    [sym_exp_section_left] = STATE(9481),
    [sym_exp_section_right] = STATE(9481),
    [sym_exp_th_quoted_name] = STATE(9481),
    [sym_exp_type_application] = STATE(9563),
    [sym_exp_lambda_case] = STATE(9563),
    [sym__do_keyword] = STATE(18466),
    [sym_do_module] = STATE(18466),
    [sym_exp_do] = STATE(9563),
    [sym_exp_record] = STATE(9481),
    [sym_exp_name] = STATE(9481),
    [sym_exp_projection_selector] = STATE(9481),
    [sym__aexp_projection] = STATE(9481),
    [sym_exp_projection] = STATE(9481),
    [sym__aexp] = STATE(9563),
    [sym_pat_as] = STATE(12592),
    [sym_pat_parens] = STATE(12592),
    [sym_pat_tuple] = STATE(12592),
    [sym_pat_unboxed_tuple] = STATE(12592),
    [sym_pat_unboxed_sum] = STATE(12592),
    [sym_pat_list] = STATE(12592),
    [sym_pat_strict] = STATE(12592),
    [sym_pat_irrefutable] = STATE(12592),
    [sym_pat_name] = STATE(12592),
    [sym__pat_constructor] = STATE(12015),
    [sym_pat_wildcard] = STATE(12592),
    [sym_pat_record] = STATE(12592),
    [sym__apat] = STATE(12592),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12685),
    [sym_splice] = STATE(11168),
    [sym_quasiquote] = STATE(11168),
    [sym__varid] = ACTIONS(4529),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4537),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4537),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4223),
    [anon_sym_LPAREN] = ACTIONS(4539),
    [sym_implicit_parid] = ACTIONS(4223),
    [sym__conid] = ACTIONS(4541),
    [anon_sym_LBRACK] = ACTIONS(4543),
    [anon_sym_SQUOTE] = ACTIONS(4229),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4231),
    [anon_sym_AT] = ACTIONS(4233),
    [anon_sym_BSLASH] = ACTIONS(4235),
    [anon_sym_mdo] = ACTIONS(4237),
    [anon_sym_do] = ACTIONS(4237),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [1803] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9735),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9735),
    [sym_exp_cond] = STATE(9735),
    [sym_exp_if_guard] = STATE(9735),
    [sym_exp_case] = STATE(9735),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9735),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9735),
    [sym__lexp] = STATE(9735),
    [sym_exp_infix] = STATE(9735),
    [sym__exp_infix] = STATE(9735),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1804] = {
    [sym_integer] = STATE(9549),
    [sym__literal] = STATE(9549),
    [sym__unboxed_open] = STATE(98),
    [sym_variable] = STATE(9923),
    [sym_qualified_variable] = STATE(9343),
    [sym_constructor] = STATE(9458),
    [sym_qualified_constructor] = STATE(9525),
    [sym__qcon] = STATE(10113),
    [sym_con_unit] = STATE(9549),
    [sym_con_list] = STATE(9549),
    [sym_con_tuple] = STATE(9549),
    [sym_literal] = STATE(10114),
    [sym_exp_parens] = STATE(9481),
    [sym_exp_tuple] = STATE(9481),
    [sym_exp_unboxed_tuple] = STATE(9481),
    [sym_exp_unboxed_sum] = STATE(9481),
    [sym_exp_list] = STATE(9481),
    [sym_exp_arithmetic_sequence] = STATE(9481),
    [sym_exp_list_comprehension] = STATE(9481),
    [sym_exp_section_left] = STATE(9481),
    [sym_exp_section_right] = STATE(9481),
    [sym_exp_th_quoted_name] = STATE(9481),
    [sym_exp_type_application] = STATE(9563),
    [sym_exp_lambda_case] = STATE(9563),
    [sym__do_keyword] = STATE(18466),
    [sym_do_module] = STATE(18466),
    [sym_exp_do] = STATE(9563),
    [sym_exp_record] = STATE(9481),
    [sym_exp_name] = STATE(9481),
    [sym_exp_projection_selector] = STATE(9481),
    [sym__aexp_projection] = STATE(9481),
    [sym_exp_projection] = STATE(9481),
    [sym__aexp] = STATE(9563),
    [sym_pat_as] = STATE(12511),
    [sym_pat_parens] = STATE(12511),
    [sym_pat_tuple] = STATE(12511),
    [sym_pat_unboxed_tuple] = STATE(12511),
    [sym_pat_unboxed_sum] = STATE(12511),
    [sym_pat_list] = STATE(12511),
    [sym_pat_strict] = STATE(12511),
    [sym_pat_irrefutable] = STATE(12511),
    [sym_pat_name] = STATE(12511),
    [sym__pat_constructor] = STATE(12158),
    [sym_pat_wildcard] = STATE(12511),
    [sym_pat_record] = STATE(12511),
    [sym__apat] = STATE(12511),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12716),
    [sym_splice] = STATE(10115),
    [sym_quasiquote] = STATE(10115),
    [sym__varid] = ACTIONS(4095),
    [sym_float] = ACTIONS(4097),
    [sym_char] = ACTIONS(4097),
    [sym_string] = ACTIONS(4097),
    [sym__integer_literal] = ACTIONS(4099),
    [sym__binary_literal] = ACTIONS(4101),
    [sym__octal_literal] = ACTIONS(4101),
    [sym__hex_literal] = ACTIONS(4101),
    [anon_sym_LPAREN_POUND] = ACTIONS(4221),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4221),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4223),
    [anon_sym_LPAREN] = ACTIONS(4225),
    [sym_implicit_parid] = ACTIONS(4223),
    [sym__conid] = ACTIONS(4111),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_SQUOTE] = ACTIONS(4229),
    [anon_sym__] = ACTIONS(255),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4231),
    [anon_sym_AT] = ACTIONS(4233),
    [anon_sym_BSLASH] = ACTIONS(4235),
    [anon_sym_mdo] = ACTIONS(4237),
    [anon_sym_do] = ACTIONS(4237),
    [anon_sym_7] = ACTIONS(4125),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4127),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4129),
    [sym__strict] = ACTIONS(281),
    [sym__lazy] = ACTIONS(283),
  },
  [1805] = {
    [sym_integer] = STATE(10796),
    [sym__literal] = STATE(10796),
    [sym__unboxed_open] = STATE(110),
    [sym_variable] = STATE(10261),
    [sym_qualified_variable] = STATE(11861),
    [sym_constructor] = STATE(10044),
    [sym_qualified_constructor] = STATE(10640),
    [sym__qcon] = STATE(10377),
    [sym_con_unit] = STATE(10796),
    [sym_con_list] = STATE(10796),
    [sym_con_tuple] = STATE(10796),
    [sym_literal] = STATE(10371),
    [sym_exp_parens] = STATE(11623),
    [sym_exp_tuple] = STATE(11623),
    [sym_exp_unboxed_tuple] = STATE(11623),
    [sym_exp_unboxed_sum] = STATE(11623),
    [sym_exp_list] = STATE(11623),
    [sym_exp_arithmetic_sequence] = STATE(11623),
    [sym_exp_list_comprehension] = STATE(11623),
    [sym_exp_section_left] = STATE(11623),
    [sym_exp_section_right] = STATE(11623),
    [sym_exp_th_quoted_name] = STATE(11623),
    [sym_exp_type_application] = STATE(12068),
    [sym_exp_lambda_case] = STATE(12068),
    [sym__do_keyword] = STATE(18599),
    [sym_do_module] = STATE(18599),
    [sym_exp_do] = STATE(12068),
    [sym_exp_record] = STATE(11623),
    [sym_exp_name] = STATE(11623),
    [sym_exp_projection_selector] = STATE(11623),
    [sym__aexp_projection] = STATE(11623),
    [sym_exp_projection] = STATE(11623),
    [sym__aexp] = STATE(12068),
    [sym_pat_as] = STATE(12592),
    [sym_pat_parens] = STATE(12592),
    [sym_pat_tuple] = STATE(12592),
    [sym_pat_unboxed_tuple] = STATE(12592),
    [sym_pat_unboxed_sum] = STATE(12592),
    [sym_pat_list] = STATE(12592),
    [sym_pat_strict] = STATE(12592),
    [sym_pat_irrefutable] = STATE(12592),
    [sym_pat_name] = STATE(12592),
    [sym__pat_constructor] = STATE(12015),
    [sym_pat_wildcard] = STATE(12592),
    [sym_pat_record] = STATE(12592),
    [sym__apat] = STATE(12592),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12538),
    [sym_splice] = STATE(10360),
    [sym_quasiquote] = STATE(10360),
    [sym__varid] = ACTIONS(4551),
    [sym_float] = ACTIONS(4553),
    [sym_char] = ACTIONS(4553),
    [sym_string] = ACTIONS(4553),
    [sym__integer_literal] = ACTIONS(4555),
    [sym__binary_literal] = ACTIONS(4557),
    [sym__octal_literal] = ACTIONS(4557),
    [sym__hex_literal] = ACTIONS(4557),
    [anon_sym_LPAREN_POUND] = ACTIONS(4559),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4559),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4561),
    [anon_sym_LPAREN] = ACTIONS(4563),
    [sym_implicit_parid] = ACTIONS(4561),
    [sym__conid] = ACTIONS(4565),
    [anon_sym_LBRACK] = ACTIONS(4567),
    [anon_sym_SQUOTE] = ACTIONS(4569),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4571),
    [anon_sym_AT] = ACTIONS(4573),
    [anon_sym_BSLASH] = ACTIONS(4575),
    [anon_sym_mdo] = ACTIONS(4577),
    [anon_sym_do] = ACTIONS(4577),
    [anon_sym_7] = ACTIONS(4579),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4581),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4583),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [1806] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19510),
    [sym_qualified_constructor_operator] = STATE(19510),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19510),
    [sym_qualified_type_operator] = STATE(19510),
    [sym__qualified_type_operator] = STATE(19510),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19804),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17542),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(4006),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4585),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2168),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1807] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20240),
    [sym_qualified_constructor_operator] = STATE(20240),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20240),
    [sym_qualified_type_operator] = STATE(20240),
    [sym__qualified_type_operator] = STATE(20240),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1808] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4589),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1809] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20501),
    [sym_qualified_constructor_operator] = STATE(20501),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20501),
    [sym_qualified_type_operator] = STATE(20501),
    [sym__qualified_type_operator] = STATE(20501),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4591),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1810] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4593),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1811] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19513),
    [sym_qualified_constructor_operator] = STATE(19513),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19513),
    [sym_qualified_type_operator] = STATE(19513),
    [sym__qualified_type_operator] = STATE(19513),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19530),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16623),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3594),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4595),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2184),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1812] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20300),
    [sym_qualified_constructor_operator] = STATE(20300),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20300),
    [sym_qualified_type_operator] = STATE(20300),
    [sym__qualified_type_operator] = STATE(20300),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20951),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15539),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(365),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4597),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3846),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1813] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20115),
    [sym_qualified_constructor_operator] = STATE(20115),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20115),
    [sym_qualified_type_operator] = STATE(20115),
    [sym__qualified_type_operator] = STATE(20115),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20224),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17065),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3326),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4599),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1992),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1814] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4601),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1815] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4603),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1816] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19459),
    [sym_qualified_constructor_operator] = STATE(19459),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19459),
    [sym_qualified_type_operator] = STATE(19459),
    [sym__qualified_type_operator] = STATE(19459),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4605),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1817] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19463),
    [sym_qualified_constructor_operator] = STATE(19463),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19463),
    [sym_qualified_type_operator] = STATE(19463),
    [sym__qualified_type_operator] = STATE(19463),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19478),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16617),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3644),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4607),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2128),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1818] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20701),
    [sym_qualified_constructor_operator] = STATE(20701),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20701),
    [sym_qualified_type_operator] = STATE(20701),
    [sym__qualified_type_operator] = STATE(20701),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20657),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16791),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(243),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4609),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3692),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1819] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19353),
    [sym_qualified_constructor_operator] = STATE(19353),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19353),
    [sym_qualified_type_operator] = STATE(19353),
    [sym__qualified_type_operator] = STATE(19353),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19317),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17761),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3694),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4611),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2260),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1820] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20062),
    [sym_qualified_constructor_operator] = STATE(20062),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20062),
    [sym_qualified_type_operator] = STATE(20062),
    [sym__qualified_type_operator] = STATE(20062),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20178),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17034),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3430),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4613),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2152),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1821] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4615),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1822] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20009),
    [sym_qualified_constructor_operator] = STATE(20009),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20009),
    [sym_qualified_type_operator] = STATE(20009),
    [sym__qualified_type_operator] = STATE(20009),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20130),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16997),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1586),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4617),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3278),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1823] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4619),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1824] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20063),
    [sym_qualified_constructor_operator] = STATE(20063),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20063),
    [sym_qualified_type_operator] = STATE(20063),
    [sym__qualified_type_operator] = STATE(20063),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20098),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17296),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3922),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4621),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2240),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1825] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19674),
    [sym_qualified_constructor_operator] = STATE(19674),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19674),
    [sym_qualified_type_operator] = STATE(19674),
    [sym__qualified_type_operator] = STATE(19674),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20569),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15466),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(289),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4623),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3920),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1826] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20364),
    [sym_qualified_constructor_operator] = STATE(20364),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20364),
    [sym_qualified_type_operator] = STATE(20364),
    [sym__qualified_type_operator] = STATE(20364),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4625),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1827] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20501),
    [sym_qualified_constructor_operator] = STATE(20501),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20501),
    [sym_qualified_type_operator] = STATE(20501),
    [sym__qualified_type_operator] = STATE(20501),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19859),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16850),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3110),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4591),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2280),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1828] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4627),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1829] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4629),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1830] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19963),
    [sym_qualified_constructor_operator] = STATE(19963),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19963),
    [sym_qualified_type_operator] = STATE(19963),
    [sym__qualified_type_operator] = STATE(19963),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20081),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16969),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1534),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4631),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3256),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1831] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19894),
    [sym_qualified_constructor_operator] = STATE(19894),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19894),
    [sym_qualified_type_operator] = STATE(19894),
    [sym__qualified_type_operator] = STATE(19894),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20026),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16926),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1602),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4633),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3228),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1832] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19353),
    [sym_qualified_constructor_operator] = STATE(19353),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19353),
    [sym_qualified_type_operator] = STATE(19353),
    [sym__qualified_type_operator] = STATE(19353),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4611),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1833] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20168),
    [sym_qualified_constructor_operator] = STATE(20168),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20168),
    [sym_qualified_type_operator] = STATE(20168),
    [sym__qualified_type_operator] = STATE(20168),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20222),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17080),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3232),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4635),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2176),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1834] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4637),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1835] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19600),
    [sym_qualified_constructor_operator] = STATE(19600),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19600),
    [sym_qualified_type_operator] = STATE(19600),
    [sym__qualified_type_operator] = STATE(19600),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19583),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17451),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3262),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4639),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3266),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1836] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19411),
    [sym_qualified_constructor_operator] = STATE(19411),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19411),
    [sym_qualified_type_operator] = STATE(19411),
    [sym__qualified_type_operator] = STATE(19411),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19427),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16608),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4641),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3356),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1837] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18999),
    [sym_qualified_constructor_operator] = STATE(18999),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18999),
    [sym_qualified_type_operator] = STATE(18999),
    [sym__qualified_type_operator] = STATE(18999),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4643),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1838] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20698),
    [sym_qualified_constructor_operator] = STATE(20698),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20698),
    [sym_qualified_type_operator] = STATE(20698),
    [sym__qualified_type_operator] = STATE(20698),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20755),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16981),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1486),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4645),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(4015),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1839] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20775),
    [sym_qualified_constructor_operator] = STATE(20775),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20775),
    [sym_qualified_type_operator] = STATE(20775),
    [sym__qualified_type_operator] = STATE(20775),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20502),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15938),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3914),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4647),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2078),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1840] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4649),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1841] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19845),
    [sym_qualified_constructor_operator] = STATE(19845),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19845),
    [sym_qualified_type_operator] = STATE(19845),
    [sym__qualified_type_operator] = STATE(19845),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19982),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16902),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3472),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4651),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2494),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1842] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20205),
    [sym_qualified_constructor_operator] = STATE(20205),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20205),
    [sym_qualified_type_operator] = STATE(20205),
    [sym__qualified_type_operator] = STATE(20205),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20319),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17100),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(285),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4653),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3296),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1843] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20254),
    [sym_qualified_constructor_operator] = STATE(20254),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20254),
    [sym_qualified_type_operator] = STATE(20254),
    [sym__qualified_type_operator] = STATE(20254),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20367),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17134),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3166),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4655),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2455),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1844] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19367),
    [sym_qualified_constructor_operator] = STATE(19367),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19367),
    [sym_qualified_type_operator] = STATE(19367),
    [sym__qualified_type_operator] = STATE(19367),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19378),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16083),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(529),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4657),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(531),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1845] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19165),
    [sym_qualified_constructor_operator] = STATE(19165),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19165),
    [sym_qualified_type_operator] = STATE(19165),
    [sym__qualified_type_operator] = STATE(19165),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19073),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17730),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1422),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4659),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3678),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1846] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4661),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1847] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19502),
    [sym_qualified_constructor_operator] = STATE(19502),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19502),
    [sym_qualified_type_operator] = STATE(19502),
    [sym__qualified_type_operator] = STATE(19502),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19458),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17804),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1502),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4663),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3768),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1848] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19772),
    [sym_qualified_constructor_operator] = STATE(19772),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19772),
    [sym_qualified_type_operator] = STATE(19772),
    [sym__qualified_type_operator] = STATE(19772),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20020),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17084),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(2650),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4665),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2654),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1849] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20529),
    [sym_qualified_constructor_operator] = STATE(20529),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20529),
    [sym_qualified_type_operator] = STATE(20529),
    [sym__qualified_type_operator] = STATE(20529),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20453),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16601),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(389),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3334),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1850] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4669),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1851] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19198),
    [sym_qualified_constructor_operator] = STATE(19198),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19198),
    [sym_qualified_type_operator] = STATE(19198),
    [sym__qualified_type_operator] = STATE(19198),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19338),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16597),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1618),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4671),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3470),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1852] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19613),
    [sym_qualified_constructor_operator] = STATE(19613),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19613),
    [sym_qualified_type_operator] = STATE(19613),
    [sym__qualified_type_operator] = STATE(19613),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19593),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17785),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3652),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4673),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2136),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1853] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19637),
    [sym_qualified_constructor_operator] = STATE(19637),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19637),
    [sym_qualified_type_operator] = STATE(19637),
    [sym__qualified_type_operator] = STATE(19637),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19745),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15899),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(443),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4675),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(445),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1854] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4677),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1855] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19653),
    [sym_qualified_constructor_operator] = STATE(19653),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19653),
    [sym_qualified_type_operator] = STATE(19653),
    [sym__qualified_type_operator] = STATE(19653),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4679),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1856] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19282),
    [sym_qualified_constructor_operator] = STATE(19282),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19282),
    [sym_qualified_type_operator] = STATE(19282),
    [sym__qualified_type_operator] = STATE(19282),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19296),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16587),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3666),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4681),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2004),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1857] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19791),
    [sym_qualified_constructor_operator] = STATE(19791),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19791),
    [sym_qualified_type_operator] = STATE(19791),
    [sym__qualified_type_operator] = STATE(19791),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19921),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16878),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1470),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4683),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3216),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1858] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4685),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1859] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20309),
    [sym_qualified_constructor_operator] = STATE(20309),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20309),
    [sym_qualified_type_operator] = STATE(20309),
    [sym__qualified_type_operator] = STATE(20309),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20463),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17157),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3184),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4687),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2467),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1860] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4689),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1861] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20358),
    [sym_qualified_constructor_operator] = STATE(20358),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20358),
    [sym_qualified_type_operator] = STATE(20358),
    [sym__qualified_type_operator] = STATE(20358),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20555),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17186),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3314),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4691),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3318),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1862] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18933),
    [sym_qualified_constructor_operator] = STATE(18933),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18933),
    [sym_qualified_type_operator] = STATE(18933),
    [sym__qualified_type_operator] = STATE(18933),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19836),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15556),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3912),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4693),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2160),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1863] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19550),
    [sym_qualified_constructor_operator] = STATE(19550),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19550),
    [sym_qualified_type_operator] = STATE(19550),
    [sym__qualified_type_operator] = STATE(19550),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19910),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16108),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3502),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4695),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2474),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1864] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20204),
    [sym_qualified_constructor_operator] = STATE(20204),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20204),
    [sym_qualified_type_operator] = STATE(20204),
    [sym__qualified_type_operator] = STATE(20204),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20238),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17265),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(4002),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4697),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2046),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1865] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20425),
    [sym_qualified_constructor_operator] = STATE(20425),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20425),
    [sym_qualified_type_operator] = STATE(20425),
    [sym__qualified_type_operator] = STATE(20425),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20639),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17216),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3344),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4699),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3348),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1866] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19236),
    [sym_qualified_constructor_operator] = STATE(19236),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19236),
    [sym_qualified_type_operator] = STATE(19236),
    [sym__qualified_type_operator] = STATE(19236),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19244),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16580),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3328),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4701),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2228),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1867] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4703),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1868] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4705),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1869] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19678),
    [sym_qualified_constructor_operator] = STATE(19678),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19678),
    [sym_qualified_type_operator] = STATE(19678),
    [sym__qualified_type_operator] = STATE(19678),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19670),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17759),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3638),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4707),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2054),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1870] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19163),
    [sym_qualified_constructor_operator] = STATE(19163),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19163),
    [sym_qualified_type_operator] = STATE(19163),
    [sym__qualified_type_operator] = STATE(19163),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19187),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16569),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1494),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4709),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3496),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1871] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4711),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1872] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18916),
    [sym_qualified_constructor_operator] = STATE(18916),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18916),
    [sym_qualified_type_operator] = STATE(18916),
    [sym__qualified_type_operator] = STATE(18916),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18943),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17699),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1478),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4713),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3610),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1873] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19759),
    [sym_qualified_constructor_operator] = STATE(19759),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19759),
    [sym_qualified_type_operator] = STATE(19759),
    [sym__qualified_type_operator] = STATE(19759),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19741),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17737),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1542),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4715),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3900),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1874] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19087),
    [sym_qualified_constructor_operator] = STATE(19087),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19087),
    [sym_qualified_type_operator] = STATE(19087),
    [sym__qualified_type_operator] = STATE(19087),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19115),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16564),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3760),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4717),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2268),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1875] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19550),
    [sym_qualified_constructor_operator] = STATE(19550),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19550),
    [sym_qualified_type_operator] = STATE(19550),
    [sym__qualified_type_operator] = STATE(19550),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4695),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1876] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4719),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1877] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20527),
    [sym_qualified_constructor_operator] = STATE(20527),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20527),
    [sym_qualified_type_operator] = STATE(20527),
    [sym__qualified_type_operator] = STATE(20527),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20735),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17235),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3376),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4721),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3380),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1878] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19495),
    [sym_qualified_constructor_operator] = STATE(19495),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19495),
    [sym_qualified_type_operator] = STATE(19495),
    [sym__qualified_type_operator] = STATE(19495),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19520),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17482),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(349),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3340),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1879] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19020),
    [sym_qualified_constructor_operator] = STATE(19020),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19020),
    [sym_qualified_type_operator] = STATE(19020),
    [sym__qualified_type_operator] = STATE(19020),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19038),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16558),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1414),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4725),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3516),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1880] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19564),
    [sym_qualified_constructor_operator] = STATE(19564),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19564),
    [sym_qualified_type_operator] = STATE(19564),
    [sym__qualified_type_operator] = STATE(19564),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19569),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16657),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(381),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4727),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3246),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1881] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19738),
    [sym_qualified_constructor_operator] = STATE(19738),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19738),
    [sym_qualified_type_operator] = STATE(19738),
    [sym__qualified_type_operator] = STATE(19738),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19810),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16820),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1562),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4729),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3196),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1882] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19840),
    [sym_qualified_constructor_operator] = STATE(19840),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19840),
    [sym_qualified_type_operator] = STATE(19840),
    [sym__qualified_type_operator] = STATE(19840),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19814),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17722),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3628),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4731),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2014),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1883] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20261),
    [sym_qualified_constructor_operator] = STATE(20261),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20261),
    [sym_qualified_type_operator] = STATE(20261),
    [sym__qualified_type_operator] = STATE(20261),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20156),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16411),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(353),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4733),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3238),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1884] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20716),
    [sym_qualified_constructor_operator] = STATE(20716),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20716),
    [sym_qualified_type_operator] = STATE(20716),
    [sym__qualified_type_operator] = STATE(20716),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19400),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16523),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(313),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4735),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3684),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1885] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4737),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1886] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4739),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1887] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19000),
    [sym_qualified_constructor_operator] = STATE(19000),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19000),
    [sym_qualified_type_operator] = STATE(19000),
    [sym__qualified_type_operator] = STATE(19000),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19280),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15651),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3994),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4741),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3998),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1888] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4743),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1889] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18922),
    [sym_qualified_constructor_operator] = STATE(18922),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18922),
    [sym_qualified_type_operator] = STATE(18922),
    [sym__qualified_type_operator] = STATE(18922),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18915),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16527),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3550),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4745),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3554),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1890] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20589),
    [sym_qualified_constructor_operator] = STATE(20589),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20589),
    [sym_qualified_type_operator] = STATE(20589),
    [sym__qualified_type_operator] = STATE(20589),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20776),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17262),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3406),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4747),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3410),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1891] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19928),
    [sym_qualified_constructor_operator] = STATE(19928),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19928),
    [sym_qualified_type_operator] = STATE(19928),
    [sym__qualified_type_operator] = STATE(19928),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19887),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17697),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1554),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4749),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3826),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1892] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18944),
    [sym_qualified_constructor_operator] = STATE(18944),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18944),
    [sym_qualified_type_operator] = STATE(18944),
    [sym__qualified_type_operator] = STATE(18944),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18937),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16517),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3656),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4751),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3660),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1893] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20722),
    [sym_qualified_constructor_operator] = STATE(20722),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20722),
    [sym_qualified_type_operator] = STATE(20722),
    [sym__qualified_type_operator] = STATE(20722),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20823),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17286),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3434),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4753),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3438),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1894] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4755),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1895] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18963),
    [sym_qualified_constructor_operator] = STATE(18963),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18963),
    [sym_qualified_type_operator] = STATE(18963),
    [sym__qualified_type_operator] = STATE(18963),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18958),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16509),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3856),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4757),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2486),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1896] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4759),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1897] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20764),
    [sym_qualified_constructor_operator] = STATE(20764),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20764),
    [sym_qualified_type_operator] = STATE(20764),
    [sym__qualified_type_operator] = STATE(20764),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20868),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17308),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3176),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4761),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2200),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1898] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19997),
    [sym_qualified_constructor_operator] = STATE(19997),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19997),
    [sym_qualified_type_operator] = STATE(19997),
    [sym__qualified_type_operator] = STATE(19997),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19975),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17677),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1510),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4763),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3808),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1899] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4765),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1900] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19980),
    [sym_qualified_constructor_operator] = STATE(19980),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19980),
    [sym_qualified_type_operator] = STATE(19980),
    [sym__qualified_type_operator] = STATE(19980),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20282),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16357),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(337),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4767),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3096),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1901] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4769),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1902] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19677),
    [sym_qualified_constructor_operator] = STATE(19677),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19677),
    [sym_qualified_type_operator] = STATE(19677),
    [sym__qualified_type_operator] = STATE(19677),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19760),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16752),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3154),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4771),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3158),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1903] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20326),
    [sym_qualified_constructor_operator] = STATE(20326),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20326),
    [sym_qualified_type_operator] = STATE(20326),
    [sym__qualified_type_operator] = STATE(20326),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20346),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17234),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3970),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4773),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2256),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1904] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20064),
    [sym_qualified_constructor_operator] = STATE(20064),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20064),
    [sym_qualified_type_operator] = STATE(20064),
    [sym__qualified_type_operator] = STATE(20064),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20048),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17652),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4775),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3794),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1905] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18992),
    [sym_qualified_constructor_operator] = STATE(18992),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18992),
    [sym_qualified_type_operator] = STATE(18992),
    [sym__qualified_type_operator] = STATE(18992),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18983),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16501),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3862),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4777),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2521),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1906] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4779),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1907] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4781),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1908] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20044),
    [sym_qualified_constructor_operator] = STATE(20044),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20044),
    [sym_qualified_type_operator] = STATE(20044),
    [sym__qualified_type_operator] = STATE(20044),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18972),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16871),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4783),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3394),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1909] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19021),
    [sym_qualified_constructor_operator] = STATE(19021),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19021),
    [sym_qualified_type_operator] = STATE(19021),
    [sym__qualified_type_operator] = STATE(19021),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19012),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16492),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3866),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4785),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2405),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1910] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4787),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1911] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19172),
    [sym_qualified_constructor_operator] = STATE(19172),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19172),
    [sym_qualified_type_operator] = STATE(19172),
    [sym__qualified_type_operator] = STATE(19172),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19693),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17739),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3134),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4789),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3138),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1912] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4791),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1913] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19869),
    [sym_qualified_constructor_operator] = STATE(19869),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19869),
    [sym_qualified_type_operator] = STATE(19869),
    [sym__qualified_type_operator] = STATE(19869),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20148),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16824),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(321),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4793),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3854),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1914] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19211),
    [sym_qualified_constructor_operator] = STATE(19211),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19211),
    [sym_qualified_type_operator] = STATE(19211),
    [sym__qualified_type_operator] = STATE(19211),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(18971),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15746),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4795),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(511),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1915] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19050),
    [sym_qualified_constructor_operator] = STATE(19050),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19050),
    [sym_qualified_type_operator] = STATE(19050),
    [sym__qualified_type_operator] = STATE(19050),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19041),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16483),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1526),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4797),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3784),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1916] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20010),
    [sym_qualified_constructor_operator] = STATE(20010),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20010),
    [sym_qualified_type_operator] = STATE(20010),
    [sym__qualified_type_operator] = STATE(20010),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4799),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1917] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19970),
    [sym_qualified_constructor_operator] = STATE(19970),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19970),
    [sym_qualified_type_operator] = STATE(19970),
    [sym__qualified_type_operator] = STATE(19970),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19913),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16316),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(345),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4801),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3164),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1918] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18999),
    [sym_qualified_constructor_operator] = STATE(18999),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18999),
    [sym_qualified_type_operator] = STATE(18999),
    [sym__qualified_type_operator] = STATE(18999),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19024),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17668),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3718),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4643),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2459),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1919] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20567),
    [sym_qualified_constructor_operator] = STATE(20567),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20567),
    [sym_qualified_type_operator] = STATE(20567),
    [sym__qualified_type_operator] = STATE(20567),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20598),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17075),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1610),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3650),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1920] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20146),
    [sym_qualified_constructor_operator] = STATE(20146),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20146),
    [sym_qualified_type_operator] = STATE(20146),
    [sym__qualified_type_operator] = STATE(20146),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20125),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17633),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3476),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4805),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2212),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1921] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4807),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1922] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19619),
    [sym_qualified_constructor_operator] = STATE(19619),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19619),
    [sym_qualified_type_operator] = STATE(19619),
    [sym__qualified_type_operator] = STATE(19619),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19640),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16681),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3578),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4809),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3582),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1923] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4811),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1924] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20810),
    [sym_qualified_constructor_operator] = STATE(20810),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20810),
    [sym_qualified_type_operator] = STATE(20810),
    [sym__qualified_type_operator] = STATE(20810),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20903),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15615),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(385),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4813),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(433),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1925] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19937),
    [sym_qualified_constructor_operator] = STATE(19937),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19937),
    [sym_qualified_type_operator] = STATE(19937),
    [sym__qualified_type_operator] = STATE(19937),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19959),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17327),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(305),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4815),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3840),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1926] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20010),
    [sym_qualified_constructor_operator] = STATE(20010),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20010),
    [sym_qualified_type_operator] = STATE(20010),
    [sym__qualified_type_operator] = STATE(20010),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19269),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17120),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3892),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4799),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2248),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1927] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19079),
    [sym_qualified_constructor_operator] = STATE(19079),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19079),
    [sym_qualified_type_operator] = STATE(19079),
    [sym__qualified_type_operator] = STATE(19079),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19070),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16468),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3868),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4817),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2303),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1928] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20223),
    [sym_qualified_constructor_operator] = STATE(20223),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20223),
    [sym_qualified_type_operator] = STATE(20223),
    [sym__qualified_type_operator] = STATE(20223),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20200),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17608),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(357),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4819),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3774),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1929] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19653),
    [sym_qualified_constructor_operator] = STATE(19653),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19653),
    [sym_qualified_type_operator] = STATE(19653),
    [sym__qualified_type_operator] = STATE(19653),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19904),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17337),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3186),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4679),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1827),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1930] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4821),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1931] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4823),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1932] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20858),
    [sym_qualified_constructor_operator] = STATE(20858),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20858),
    [sym_qualified_type_operator] = STATE(20858),
    [sym__qualified_type_operator] = STATE(20858),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20936),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17329),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4825),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2144),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1933] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20283),
    [sym_qualified_constructor_operator] = STATE(20283),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20283),
    [sym_qualified_type_operator] = STATE(20283),
    [sym__qualified_type_operator] = STATE(20283),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20266),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17582),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3446),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4827),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2288),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1934] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19376),
    [sym_qualified_constructor_operator] = STATE(19376),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19376),
    [sym_qualified_type_operator] = STATE(19376),
    [sym__qualified_type_operator] = STATE(19376),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19414),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17513),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(329),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4829),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3424),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1935] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19108),
    [sym_qualified_constructor_operator] = STATE(19108),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19108),
    [sym_qualified_type_operator] = STATE(19108),
    [sym__qualified_type_operator] = STATE(19108),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19099),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16455),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3814),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4831),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3818),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1936] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4833),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1937] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19459),
    [sym_qualified_constructor_operator] = STATE(19459),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19459),
    [sym_qualified_type_operator] = STATE(19459),
    [sym__qualified_type_operator] = STATE(19459),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19162),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16031),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3108),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4605),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2204),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1938] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19137),
    [sym_qualified_constructor_operator] = STATE(19137),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19137),
    [sym_qualified_type_operator] = STATE(19137),
    [sym__qualified_type_operator] = STATE(19137),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19128),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16444),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3830),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4835),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3834),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1939] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20893),
    [sym_qualified_constructor_operator] = STATE(20893),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20893),
    [sym_qualified_type_operator] = STATE(20893),
    [sym__qualified_type_operator] = STATE(20893),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20961),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17352),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1570),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4837),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3508),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1940] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20591),
    [sym_qualified_constructor_operator] = STATE(20591),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20591),
    [sym_qualified_type_operator] = STATE(20591),
    [sym__qualified_type_operator] = STATE(20591),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20343),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17563),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3748),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4839),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3752),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1941] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20723),
    [sym_qualified_constructor_operator] = STATE(20723),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20723),
    [sym_qualified_type_operator] = STATE(20723),
    [sym__qualified_type_operator] = STATE(20723),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20427),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17539),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3304),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4841),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2513),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1942] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20785),
    [sym_qualified_constructor_operator] = STATE(20785),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20785),
    [sym_qualified_type_operator] = STATE(20785),
    [sym__qualified_type_operator] = STATE(20785),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20566),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17520),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1594),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4843),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3708),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1943] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4845),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1944] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19124),
    [sym_qualified_constructor_operator] = STATE(19124),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19124),
    [sym_qualified_type_operator] = STATE(19124),
    [sym__qualified_type_operator] = STATE(19124),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19145),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17637),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(369),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4847),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3522),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1945] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19166),
    [sym_qualified_constructor_operator] = STATE(19166),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19166),
    [sym_qualified_type_operator] = STATE(19166),
    [sym__qualified_type_operator] = STATE(19166),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19157),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16433),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3882),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4849),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2220),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1946] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4851),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1947] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4853),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1948] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20350),
    [sym_qualified_constructor_operator] = STATE(20350),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20350),
    [sym_qualified_type_operator] = STATE(20350),
    [sym__qualified_type_operator] = STATE(20350),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20465),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17161),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3456),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4855),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3460),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1949] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4857),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1950] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19195),
    [sym_qualified_constructor_operator] = STATE(19195),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19195),
    [sym_qualified_type_operator] = STATE(19195),
    [sym__qualified_type_operator] = STATE(19195),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19186),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16421),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3890),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4859),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2030),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1951] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20852),
    [sym_qualified_constructor_operator] = STATE(20852),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20852),
    [sym_qualified_type_operator] = STATE(20852),
    [sym__qualified_type_operator] = STATE(20852),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20702),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17494),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1518),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4861),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3672),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1952] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20240),
    [sym_qualified_constructor_operator] = STATE(20240),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20240),
    [sym_qualified_type_operator] = STATE(20240),
    [sym__qualified_type_operator] = STATE(20240),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19691),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16221),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3222),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4587),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2272),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1953] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20927),
    [sym_qualified_constructor_operator] = STATE(20927),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20927),
    [sym_qualified_type_operator] = STATE(20927),
    [sym__qualified_type_operator] = STATE(20927),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20984),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17368),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1398),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4863),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3534),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1954] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4865),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1955] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19222),
    [sym_qualified_constructor_operator] = STATE(19222),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19222),
    [sym_qualified_type_operator] = STATE(19222),
    [sym__qualified_type_operator] = STATE(19222),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19214),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16413),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3894),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4867),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2038),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1956] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4869),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1957] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(18980),
    [sym_qualified_constructor_operator] = STATE(18980),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(18980),
    [sym_qualified_type_operator] = STATE(18980),
    [sym__qualified_type_operator] = STATE(18980),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19566),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17630),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(297),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4871),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3418),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1958] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20921),
    [sym_qualified_constructor_operator] = STATE(20921),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20921),
    [sym_qualified_type_operator] = STATE(20921),
    [sym__qualified_type_operator] = STATE(20921),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20766),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17476),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3284),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4873),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2022),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1959] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4875),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1960] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4877),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1961] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20678),
    [sym_qualified_constructor_operator] = STATE(20678),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20678),
    [sym_qualified_type_operator] = STATE(20678),
    [sym__qualified_type_operator] = STATE(20678),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20739),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15645),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1550),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4879),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3724),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1962] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20956),
    [sym_qualified_constructor_operator] = STATE(20956),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20956),
    [sym_qualified_type_operator] = STATE(20956),
    [sym__qualified_type_operator] = STATE(20956),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20836),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17458),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1454),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3602),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1963] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20988),
    [sym_qualified_constructor_operator] = STATE(20988),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20988),
    [sym_qualified_type_operator] = STATE(20988),
    [sym__qualified_type_operator] = STATE(20988),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20900),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17440),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1578),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3088),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1964] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4885),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1965] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19223),
    [sym_qualified_constructor_operator] = STATE(19223),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19223),
    [sym_qualified_type_operator] = STATE(19223),
    [sym__qualified_type_operator] = STATE(19223),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19257),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17606),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3736),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4887),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2502),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1966] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19743),
    [sym_qualified_constructor_operator] = STATE(19743),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19743),
    [sym_qualified_type_operator] = STATE(19743),
    [sym__qualified_type_operator] = STATE(19743),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19453),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16126),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3614),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4889),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3618),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1967] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4891),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1968] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [anon_sym_RPAREN] = ACTIONS(4893),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1969] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20108),
    [sym_qualified_constructor_operator] = STATE(20108),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20108),
    [sym_qualified_type_operator] = STATE(20108),
    [sym__qualified_type_operator] = STATE(20108),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20474),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16162),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1446),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4895),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3082),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1970] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20364),
    [sym_qualified_constructor_operator] = STATE(20364),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20364),
    [sym_qualified_type_operator] = STATE(20364),
    [sym__qualified_type_operator] = STATE(20364),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19705),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(16729),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3124),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4625),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2062),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1971] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20433),
    [sym_qualified_constructor_operator] = STATE(20433),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20433),
    [sym_qualified_type_operator] = STATE(20433),
    [sym__qualified_type_operator] = STATE(20433),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20477),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(15462),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3144),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4897),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(1807),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1972] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20977),
    [sym_qualified_constructor_operator] = STATE(20977),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20977),
    [sym_qualified_type_operator] = STATE(20977),
    [sym__qualified_type_operator] = STATE(20977),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20952),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17417),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3240),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4899),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(2070),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1973] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(19816),
    [sym_qualified_constructor_operator] = STATE(19816),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(19816),
    [sym_qualified_type_operator] = STATE(19816),
    [sym__qualified_type_operator] = STATE(19816),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(19861),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17420),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3100),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4901),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3104),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1974] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_constructor_operator] = STATE(20957),
    [sym_qualified_constructor_operator] = STATE(20957),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym__type_operator] = STATE(20957),
    [sym_qualified_type_operator] = STATE(20957),
    [sym__qualified_type_operator] = STATE(20957),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym__type_tuple] = STATE(20987),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(18354),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18354),
    [sym__type_context] = STATE(18354),
    [sym__type_fun] = STATE(18354),
    [sym__type] = STATE(18354),
    [sym__type_or_implicit] = STATE(18354),
    [sym__modid] = STATE(20324),
    [aux_sym__qualifying_module] = STATE(13133),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [aux_sym_con_tuple_repeat1] = STATE(17396),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(1434),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym__consym] = ACTIONS(425),
    [sym__tyconsym] = ACTIONS(4903),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(3566),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [1975] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(15545),
    [sym_class_datafam] = STATE(15545),
    [sym_class_tyfam] = STATE(15545),
    [sym__cdecl] = STATE(15545),
    [sym_inst_tyinst] = STATE(18430),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(15545),
    [sym_fixity] = STATE(15545),
    [sym_signature] = STATE(15545),
    [sym__gendecl] = STATE(15545),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(4905),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4917),
    [anon_sym_RBRACE] = ACTIONS(4919),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4923),
    [anon_sym_default] = ACTIONS(4925),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [1976] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(15714),
    [sym_class_datafam] = STATE(15714),
    [sym_class_tyfam] = STATE(15714),
    [sym__cdecl] = STATE(15714),
    [sym_inst_tyinst] = STATE(18430),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(15714),
    [sym_fixity] = STATE(15714),
    [sym_signature] = STATE(15714),
    [sym__gendecl] = STATE(15714),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(4931),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4917),
    [anon_sym_RBRACE] = ACTIONS(4933),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4923),
    [anon_sym_default] = ACTIONS(4925),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [1977] = {
    [sym_integer] = STATE(3511),
    [sym__literal] = STATE(3511),
    [sym__unboxed_open] = STATE(779),
    [sym_variable] = STATE(3549),
    [sym_qualified_variable] = STATE(3549),
    [sym_constructor] = STATE(3471),
    [sym_qualified_constructor] = STATE(3677),
    [sym__qcon] = STATE(3549),
    [sym_con_unit] = STATE(3511),
    [sym_con_list] = STATE(3511),
    [sym_con_tuple] = STATE(3511),
    [sym_literal] = STATE(3789),
    [sym_exp_parens] = STATE(3789),
    [sym_exp_tuple] = STATE(3789),
    [sym_exp_unboxed_tuple] = STATE(3789),
    [sym_exp_unboxed_sum] = STATE(3789),
    [sym_exp_list] = STATE(3789),
    [sym_exp_arithmetic_sequence] = STATE(3789),
    [sym_exp_list_comprehension] = STATE(3789),
    [sym_exp_section_left] = STATE(3789),
    [sym_exp_section_right] = STATE(3789),
    [sym_exp_th_quoted_name] = STATE(3789),
    [sym_exp_type_application] = STATE(604),
    [sym_exp_lambda] = STATE(9603),
    [sym_exp_let] = STATE(18164),
    [sym_exp_let_in] = STATE(9603),
    [sym_exp_cond] = STATE(9603),
    [sym_exp_if_guard] = STATE(9603),
    [sym_exp_case] = STATE(9603),
    [sym_exp_lambda_case] = STATE(604),
    [sym__do_keyword] = STATE(18519),
    [sym_do_module] = STATE(18519),
    [sym_exp_do] = STATE(604),
    [sym_exp_negation] = STATE(9603),
    [sym_exp_record] = STATE(3789),
    [sym_exp_name] = STATE(3789),
    [sym_exp_projection_selector] = STATE(3789),
    [sym__aexp_projection] = STATE(3789),
    [sym_exp_projection] = STATE(3789),
    [sym__aexp] = STATE(604),
    [sym__exp_apply] = STATE(9644),
    [sym__fexp] = STATE(9603),
    [sym__lexp] = STATE(9603),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12649),
    [sym_splice] = STATE(3789),
    [sym_quasiquote] = STATE(3789),
    [sym__varid] = ACTIONS(1677),
    [sym_float] = ACTIONS(643),
    [sym_char] = ACTIONS(643),
    [sym_string] = ACTIONS(643),
    [sym__integer_literal] = ACTIONS(645),
    [sym__binary_literal] = ACTIONS(647),
    [sym__octal_literal] = ACTIONS(647),
    [sym__hex_literal] = ACTIONS(647),
    [anon_sym_LPAREN_POUND] = ACTIONS(1679),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1679),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(93),
    [anon_sym_DASH] = ACTIONS(1978),
    [anon_sym_LPAREN] = ACTIONS(1681),
    [sym_implicit_parid] = ACTIONS(93),
    [sym__conid] = ACTIONS(1698),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_SQUOTE] = ACTIONS(105),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(113),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_BSLASH] = ACTIONS(117),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_case] = ACTIONS(121),
    [anon_sym_mdo] = ACTIONS(123),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_7] = ACTIONS(667),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(671),
  },
  [1978] = {
    [sym_integer] = STATE(3685),
    [sym__literal] = STATE(3685),
    [sym__unboxed_open] = STATE(792),
    [sym_variable] = STATE(3595),
    [sym_qualified_variable] = STATE(3595),
    [sym_constructor] = STATE(3473),
    [sym_qualified_constructor] = STATE(3699),
    [sym__qcon] = STATE(3595),
    [sym_con_unit] = STATE(3685),
    [sym_con_list] = STATE(3685),
    [sym_con_tuple] = STATE(3685),
    [sym_literal] = STATE(3752),
    [sym_exp_parens] = STATE(3752),
    [sym_exp_tuple] = STATE(3752),
    [sym_exp_unboxed_tuple] = STATE(3752),
    [sym_exp_unboxed_sum] = STATE(3752),
    [sym_exp_list] = STATE(3752),
    [sym_exp_arithmetic_sequence] = STATE(3752),
    [sym_exp_list_comprehension] = STATE(3752),
    [sym_exp_section_left] = STATE(3752),
    [sym_exp_section_right] = STATE(3752),
    [sym_exp_th_quoted_name] = STATE(3752),
    [sym_exp_type_application] = STATE(603),
    [sym_exp_lambda] = STATE(9553),
    [sym_exp_let] = STATE(17973),
    [sym_exp_let_in] = STATE(9553),
    [sym_exp_cond] = STATE(9553),
    [sym_exp_if_guard] = STATE(9553),
    [sym_exp_case] = STATE(9553),
    [sym_exp_lambda_case] = STATE(603),
    [sym__do_keyword] = STATE(18310),
    [sym_do_module] = STATE(18310),
    [sym_exp_do] = STATE(603),
    [sym_exp_negation] = STATE(9553),
    [sym_exp_record] = STATE(3752),
    [sym_exp_name] = STATE(3752),
    [sym_exp_projection_selector] = STATE(3752),
    [sym__aexp_projection] = STATE(3752),
    [sym_exp_projection] = STATE(3752),
    [sym__aexp] = STATE(603),
    [sym__exp_apply] = STATE(9582),
    [sym__fexp] = STATE(9553),
    [sym__lexp] = STATE(9553),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12563),
    [sym_splice] = STATE(3752),
    [sym_quasiquote] = STATE(3752),
    [sym__varid] = ACTIONS(1634),
    [sym_float] = ACTIONS(85),
    [sym_char] = ACTIONS(85),
    [sym_string] = ACTIONS(85),
    [sym__integer_literal] = ACTIONS(87),
    [sym__binary_literal] = ACTIONS(89),
    [sym__octal_literal] = ACTIONS(89),
    [sym__hex_literal] = ACTIONS(89),
    [anon_sym_LPAREN_POUND] = ACTIONS(1638),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1638),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1640),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_LPAREN] = ACTIONS(1644),
    [sym_implicit_parid] = ACTIONS(1640),
    [sym__conid] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_SQUOTE] = ACTIONS(1651),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1655),
    [anon_sym_AT] = ACTIONS(1657),
    [anon_sym_BSLASH] = ACTIONS(1659),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4089),
    [anon_sym_case] = ACTIONS(1663),
    [anon_sym_mdo] = ACTIONS(1665),
    [anon_sym_do] = ACTIONS(1665),
    [anon_sym_7] = ACTIONS(143),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(147),
  },
  [1979] = {
    [sym_integer] = STATE(4830),
    [sym__literal] = STATE(4830),
    [sym__unboxed_open] = STATE(774),
    [sym_variable] = STATE(4419),
    [sym_qualified_variable] = STATE(4419),
    [sym_constructor] = STATE(4257),
    [sym_qualified_constructor] = STATE(4416),
    [sym__qcon] = STATE(4419),
    [sym_con_unit] = STATE(4830),
    [sym_con_list] = STATE(4830),
    [sym_con_tuple] = STATE(4830),
    [sym_literal] = STATE(4455),
    [sym_exp_parens] = STATE(4455),
    [sym_exp_tuple] = STATE(4455),
    [sym_exp_unboxed_tuple] = STATE(4455),
    [sym_exp_unboxed_sum] = STATE(4455),
    [sym_exp_list] = STATE(4455),
    [sym_exp_arithmetic_sequence] = STATE(4455),
    [sym_exp_list_comprehension] = STATE(4455),
    [sym_exp_section_left] = STATE(4455),
    [sym_exp_section_right] = STATE(4455),
    [sym_exp_th_quoted_name] = STATE(4455),
    [sym_exp_type_application] = STATE(828),
    [sym_exp_lambda] = STATE(11750),
    [sym_exp_let] = STATE(18318),
    [sym_exp_let_in] = STATE(11750),
    [sym_exp_cond] = STATE(11750),
    [sym_exp_if_guard] = STATE(11750),
    [sym_exp_case] = STATE(11750),
    [sym_exp_lambda_case] = STATE(828),
    [sym__do_keyword] = STATE(18263),
    [sym_do_module] = STATE(18263),
    [sym_exp_do] = STATE(828),
    [sym_exp_negation] = STATE(11750),
    [sym_exp_record] = STATE(4455),
    [sym_exp_name] = STATE(4455),
    [sym_exp_projection_selector] = STATE(4455),
    [sym__aexp_projection] = STATE(4455),
    [sym_exp_projection] = STATE(4455),
    [sym__aexp] = STATE(828),
    [sym__exp_apply] = STATE(11903),
    [sym__fexp] = STATE(11750),
    [sym__lexp] = STATE(11750),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12635),
    [sym_splice] = STATE(4455),
    [sym_quasiquote] = STATE(4455),
    [sym__varid] = ACTIONS(2080),
    [sym_float] = ACTIONS(2082),
    [sym_char] = ACTIONS(2082),
    [sym_string] = ACTIONS(2082),
    [sym__integer_literal] = ACTIONS(2084),
    [sym__binary_literal] = ACTIONS(2086),
    [sym__octal_literal] = ACTIONS(2086),
    [sym__hex_literal] = ACTIONS(2086),
    [anon_sym_LPAREN_POUND] = ACTIONS(2088),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2088),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2090),
    [anon_sym_DASH] = ACTIONS(4053),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [sym_implicit_parid] = ACTIONS(2090),
    [sym__conid] = ACTIONS(4055),
    [anon_sym_LBRACK] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2100),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2104),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_BSLASH] = ACTIONS(2108),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4057),
    [anon_sym_case] = ACTIONS(2112),
    [anon_sym_mdo] = ACTIONS(2114),
    [anon_sym_do] = ACTIONS(2114),
    [anon_sym_7] = ACTIONS(2116),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2118),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2120),
  },
  [1980] = {
    [sym_integer] = STATE(5224),
    [sym__literal] = STATE(5224),
    [sym__unboxed_open] = STATE(797),
    [sym_variable] = STATE(5085),
    [sym_qualified_variable] = STATE(5085),
    [sym_constructor] = STATE(4716),
    [sym_qualified_constructor] = STATE(5006),
    [sym__qcon] = STATE(5085),
    [sym_con_unit] = STATE(5224),
    [sym_con_list] = STATE(5224),
    [sym_con_tuple] = STATE(5224),
    [sym_literal] = STATE(4915),
    [sym_exp_parens] = STATE(4915),
    [sym_exp_tuple] = STATE(4915),
    [sym_exp_unboxed_tuple] = STATE(4915),
    [sym_exp_unboxed_sum] = STATE(4915),
    [sym_exp_list] = STATE(4915),
    [sym_exp_arithmetic_sequence] = STATE(4915),
    [sym_exp_list_comprehension] = STATE(4915),
    [sym_exp_section_left] = STATE(4915),
    [sym_exp_section_right] = STATE(4915),
    [sym_exp_th_quoted_name] = STATE(4915),
    [sym_exp_type_application] = STATE(943),
    [sym_exp_lambda] = STATE(12211),
    [sym_exp_let] = STATE(18386),
    [sym_exp_let_in] = STATE(12211),
    [sym_exp_cond] = STATE(12211),
    [sym_exp_if_guard] = STATE(12211),
    [sym_exp_case] = STATE(12211),
    [sym_exp_lambda_case] = STATE(943),
    [sym__do_keyword] = STATE(18435),
    [sym_do_module] = STATE(18435),
    [sym_exp_do] = STATE(943),
    [sym_exp_negation] = STATE(12211),
    [sym_exp_record] = STATE(4915),
    [sym_exp_name] = STATE(4915),
    [sym_exp_projection_selector] = STATE(4915),
    [sym__aexp_projection] = STATE(4915),
    [sym_exp_projection] = STATE(4915),
    [sym__aexp] = STATE(943),
    [sym__exp_apply] = STATE(12078),
    [sym__fexp] = STATE(12211),
    [sym__lexp] = STATE(12211),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12549),
    [sym_splice] = STATE(4915),
    [sym_quasiquote] = STATE(4915),
    [sym__varid] = ACTIONS(2895),
    [sym_float] = ACTIONS(1169),
    [sym_char] = ACTIONS(1169),
    [sym_string] = ACTIONS(1169),
    [sym__integer_literal] = ACTIONS(1171),
    [sym__binary_literal] = ACTIONS(1173),
    [sym__octal_literal] = ACTIONS(1173),
    [sym__hex_literal] = ACTIONS(1173),
    [anon_sym_LPAREN_POUND] = ACTIONS(2897),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2897),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1177),
    [anon_sym_DASH] = ACTIONS(3030),
    [anon_sym_LPAREN] = ACTIONS(2899),
    [sym_implicit_parid] = ACTIONS(1177),
    [sym__conid] = ACTIONS(3032),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_SQUOTE] = ACTIONS(1187),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1194),
    [anon_sym_AT] = ACTIONS(1196),
    [anon_sym_BSLASH] = ACTIONS(1198),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1200),
    [anon_sym_case] = ACTIONS(1202),
    [anon_sym_mdo] = ACTIONS(1204),
    [anon_sym_do] = ACTIONS(1204),
    [anon_sym_7] = ACTIONS(1206),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1208),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1210),
  },
  [1981] = {
    [sym_integer] = STATE(4936),
    [sym__literal] = STATE(4936),
    [sym__unboxed_open] = STATE(780),
    [sym_variable] = STATE(5192),
    [sym_qualified_variable] = STATE(5192),
    [sym_constructor] = STATE(4632),
    [sym_qualified_constructor] = STATE(4989),
    [sym__qcon] = STATE(5192),
    [sym_con_unit] = STATE(4936),
    [sym_con_list] = STATE(4936),
    [sym_con_tuple] = STATE(4936),
    [sym_literal] = STATE(5422),
    [sym_exp_parens] = STATE(5422),
    [sym_exp_tuple] = STATE(5422),
    [sym_exp_unboxed_tuple] = STATE(5422),
    [sym_exp_unboxed_sum] = STATE(5422),
    [sym_exp_list] = STATE(5422),
    [sym_exp_arithmetic_sequence] = STATE(5422),
    [sym_exp_list_comprehension] = STATE(5422),
    [sym_exp_section_left] = STATE(5422),
    [sym_exp_section_right] = STATE(5422),
    [sym_exp_th_quoted_name] = STATE(5422),
    [sym_exp_type_application] = STATE(901),
    [sym_exp_lambda] = STATE(11981),
    [sym_exp_let] = STATE(18508),
    [sym_exp_let_in] = STATE(11981),
    [sym_exp_cond] = STATE(11981),
    [sym_exp_if_guard] = STATE(11981),
    [sym_exp_case] = STATE(11981),
    [sym_exp_lambda_case] = STATE(901),
    [sym__do_keyword] = STATE(18325),
    [sym_do_module] = STATE(18325),
    [sym_exp_do] = STATE(901),
    [sym_exp_negation] = STATE(11981),
    [sym_exp_record] = STATE(5422),
    [sym_exp_name] = STATE(5422),
    [sym_exp_projection_selector] = STATE(5422),
    [sym__aexp_projection] = STATE(5422),
    [sym_exp_projection] = STATE(5422),
    [sym__aexp] = STATE(901),
    [sym__exp_apply] = STATE(12038),
    [sym__fexp] = STATE(11981),
    [sym__lexp] = STATE(11981),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12676),
    [sym_splice] = STATE(5422),
    [sym_quasiquote] = STATE(5422),
    [sym__varid] = ACTIONS(2660),
    [sym_float] = ACTIONS(2662),
    [sym_char] = ACTIONS(2662),
    [sym_string] = ACTIONS(2662),
    [sym__integer_literal] = ACTIONS(2664),
    [sym__binary_literal] = ACTIONS(2666),
    [sym__octal_literal] = ACTIONS(2666),
    [sym__hex_literal] = ACTIONS(2666),
    [anon_sym_LPAREN_POUND] = ACTIONS(2668),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2668),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2670),
    [anon_sym_DASH] = ACTIONS(4191),
    [anon_sym_LPAREN] = ACTIONS(2672),
    [sym_implicit_parid] = ACTIONS(2670),
    [sym__conid] = ACTIONS(4193),
    [anon_sym_LBRACK] = ACTIONS(2678),
    [anon_sym_SQUOTE] = ACTIONS(2680),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2684),
    [anon_sym_AT] = ACTIONS(2686),
    [anon_sym_BSLASH] = ACTIONS(2688),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4195),
    [anon_sym_case] = ACTIONS(2692),
    [anon_sym_mdo] = ACTIONS(2694),
    [anon_sym_do] = ACTIONS(2694),
    [anon_sym_7] = ACTIONS(2696),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2698),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2700),
  },
  [1982] = {
    [sym_integer] = STATE(4414),
    [sym__literal] = STATE(4414),
    [sym__unboxed_open] = STATE(783),
    [sym_variable] = STATE(4615),
    [sym_qualified_variable] = STATE(4615),
    [sym_constructor] = STATE(4335),
    [sym_qualified_constructor] = STATE(4623),
    [sym__qcon] = STATE(4615),
    [sym_con_unit] = STATE(4414),
    [sym_con_list] = STATE(4414),
    [sym_con_tuple] = STATE(4414),
    [sym_literal] = STATE(5187),
    [sym_exp_parens] = STATE(5187),
    [sym_exp_tuple] = STATE(5187),
    [sym_exp_unboxed_tuple] = STATE(5187),
    [sym_exp_unboxed_sum] = STATE(5187),
    [sym_exp_list] = STATE(5187),
    [sym_exp_arithmetic_sequence] = STATE(5187),
    [sym_exp_list_comprehension] = STATE(5187),
    [sym_exp_section_left] = STATE(5187),
    [sym_exp_section_right] = STATE(5187),
    [sym_exp_th_quoted_name] = STATE(5187),
    [sym_exp_type_application] = STATE(935),
    [sym_exp_lambda] = STATE(12064),
    [sym_exp_let] = STATE(18897),
    [sym_exp_let_in] = STATE(12064),
    [sym_exp_cond] = STATE(12064),
    [sym_exp_if_guard] = STATE(12064),
    [sym_exp_case] = STATE(12064),
    [sym_exp_lambda_case] = STATE(935),
    [sym__do_keyword] = STATE(18223),
    [sym_do_module] = STATE(18223),
    [sym_exp_do] = STATE(935),
    [sym_exp_negation] = STATE(12064),
    [sym_exp_record] = STATE(5187),
    [sym_exp_name] = STATE(5187),
    [sym_exp_projection_selector] = STATE(5187),
    [sym__aexp_projection] = STATE(5187),
    [sym_exp_projection] = STATE(5187),
    [sym__aexp] = STATE(935),
    [sym__exp_apply] = STATE(12112),
    [sym__fexp] = STATE(12064),
    [sym__lexp] = STATE(12064),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12699),
    [sym_splice] = STATE(5187),
    [sym_quasiquote] = STATE(5187),
    [sym__varid] = ACTIONS(2783),
    [sym_float] = ACTIONS(157),
    [sym_char] = ACTIONS(157),
    [sym_string] = ACTIONS(157),
    [sym__integer_literal] = ACTIONS(159),
    [sym__binary_literal] = ACTIONS(161),
    [sym__octal_literal] = ACTIONS(161),
    [sym__hex_literal] = ACTIONS(161),
    [anon_sym_LPAREN_POUND] = ACTIONS(2785),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2785),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2787),
    [anon_sym_DASH] = ACTIONS(4141),
    [anon_sym_LPAREN] = ACTIONS(2789),
    [sym_implicit_parid] = ACTIONS(2787),
    [sym__conid] = ACTIONS(4143),
    [anon_sym_LBRACK] = ACTIONS(2794),
    [anon_sym_SQUOTE] = ACTIONS(2796),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2800),
    [anon_sym_AT] = ACTIONS(2802),
    [anon_sym_BSLASH] = ACTIONS(2804),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4145),
    [anon_sym_case] = ACTIONS(2808),
    [anon_sym_mdo] = ACTIONS(2810),
    [anon_sym_do] = ACTIONS(2810),
    [anon_sym_7] = ACTIONS(213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(217),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(219),
  },
  [1983] = {
    [sym_integer] = STATE(4866),
    [sym__literal] = STATE(4866),
    [sym__unboxed_open] = STATE(757),
    [sym_variable] = STATE(5079),
    [sym_qualified_variable] = STATE(5079),
    [sym_constructor] = STATE(4498),
    [sym_qualified_constructor] = STATE(5373),
    [sym__qcon] = STATE(5079),
    [sym_con_unit] = STATE(4866),
    [sym_con_list] = STATE(4866),
    [sym_con_tuple] = STATE(4866),
    [sym_literal] = STATE(5194),
    [sym_exp_parens] = STATE(5194),
    [sym_exp_tuple] = STATE(5194),
    [sym_exp_unboxed_tuple] = STATE(5194),
    [sym_exp_unboxed_sum] = STATE(5194),
    [sym_exp_list] = STATE(5194),
    [sym_exp_arithmetic_sequence] = STATE(5194),
    [sym_exp_list_comprehension] = STATE(5194),
    [sym_exp_section_left] = STATE(5194),
    [sym_exp_section_right] = STATE(5194),
    [sym_exp_th_quoted_name] = STATE(5194),
    [sym_exp_type_application] = STATE(924),
    [sym_exp_lambda] = STATE(12041),
    [sym_exp_let] = STATE(18498),
    [sym_exp_let_in] = STATE(12041),
    [sym_exp_cond] = STATE(12041),
    [sym_exp_if_guard] = STATE(12041),
    [sym_exp_case] = STATE(12041),
    [sym_exp_lambda_case] = STATE(924),
    [sym__do_keyword] = STATE(18413),
    [sym_do_module] = STATE(18413),
    [sym_exp_do] = STATE(924),
    [sym_exp_negation] = STATE(12041),
    [sym_exp_record] = STATE(5194),
    [sym_exp_name] = STATE(5194),
    [sym_exp_projection_selector] = STATE(5194),
    [sym__aexp_projection] = STATE(5194),
    [sym_exp_projection] = STATE(5194),
    [sym__aexp] = STATE(924),
    [sym__exp_apply] = STATE(12053),
    [sym__fexp] = STATE(12041),
    [sym__lexp] = STATE(12041),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12556),
    [sym_splice] = STATE(5194),
    [sym_quasiquote] = STATE(5194),
    [sym__varid] = ACTIONS(2560),
    [sym_float] = ACTIONS(2562),
    [sym_char] = ACTIONS(2562),
    [sym_string] = ACTIONS(2562),
    [sym__integer_literal] = ACTIONS(2564),
    [sym__binary_literal] = ACTIONS(2566),
    [sym__octal_literal] = ACTIONS(2566),
    [sym__hex_literal] = ACTIONS(2566),
    [anon_sym_LPAREN_POUND] = ACTIONS(2568),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2568),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(4045),
    [anon_sym_LPAREN] = ACTIONS(2572),
    [sym_implicit_parid] = ACTIONS(2570),
    [sym__conid] = ACTIONS(4047),
    [anon_sym_LBRACK] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2583),
    [anon_sym_AT] = ACTIONS(2585),
    [anon_sym_BSLASH] = ACTIONS(2587),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4049),
    [anon_sym_case] = ACTIONS(2591),
    [anon_sym_mdo] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_7] = ACTIONS(2595),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2597),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2599),
  },
  [1984] = {
    [sym_integer] = STATE(4332),
    [sym__literal] = STATE(4332),
    [sym__unboxed_open] = STATE(748),
    [sym_variable] = STATE(4280),
    [sym_qualified_variable] = STATE(4280),
    [sym_constructor] = STATE(4074),
    [sym_qualified_constructor] = STATE(4305),
    [sym__qcon] = STATE(4280),
    [sym_con_unit] = STATE(4332),
    [sym_con_list] = STATE(4332),
    [sym_con_tuple] = STATE(4332),
    [sym_literal] = STATE(4217),
    [sym_exp_parens] = STATE(4217),
    [sym_exp_tuple] = STATE(4217),
    [sym_exp_unboxed_tuple] = STATE(4217),
    [sym_exp_unboxed_sum] = STATE(4217),
    [sym_exp_list] = STATE(4217),
    [sym_exp_arithmetic_sequence] = STATE(4217),
    [sym_exp_list_comprehension] = STATE(4217),
    [sym_exp_section_left] = STATE(4217),
    [sym_exp_section_right] = STATE(4217),
    [sym_exp_th_quoted_name] = STATE(4217),
    [sym_exp_type_application] = STATE(801),
    [sym_exp_lambda] = STATE(10971),
    [sym_exp_let] = STATE(18577),
    [sym_exp_let_in] = STATE(10971),
    [sym_exp_cond] = STATE(10971),
    [sym_exp_if_guard] = STATE(10971),
    [sym_exp_case] = STATE(10971),
    [sym_exp_lambda_case] = STATE(801),
    [sym__do_keyword] = STATE(18152),
    [sym_do_module] = STATE(18152),
    [sym_exp_do] = STATE(801),
    [sym_exp_negation] = STATE(10971),
    [sym_exp_record] = STATE(4217),
    [sym_exp_name] = STATE(4217),
    [sym_exp_projection_selector] = STATE(4217),
    [sym__aexp_projection] = STATE(4217),
    [sym_exp_projection] = STATE(4217),
    [sym__aexp] = STATE(801),
    [sym__exp_apply] = STATE(11048),
    [sym__fexp] = STATE(10971),
    [sym__lexp] = STATE(10971),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12567),
    [sym_splice] = STATE(4217),
    [sym_quasiquote] = STATE(4217),
    [sym__varid] = ACTIONS(1933),
    [sym_float] = ACTIONS(1935),
    [sym_char] = ACTIONS(1935),
    [sym_string] = ACTIONS(1935),
    [sym__integer_literal] = ACTIONS(1937),
    [sym__binary_literal] = ACTIONS(1939),
    [sym__octal_literal] = ACTIONS(1939),
    [sym__hex_literal] = ACTIONS(1939),
    [anon_sym_LPAREN_POUND] = ACTIONS(1941),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1941),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(4159),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [sym_implicit_parid] = ACTIONS(1943),
    [sym__conid] = ACTIONS(4161),
    [anon_sym_LBRACK] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1953),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1957),
    [anon_sym_AT] = ACTIONS(1959),
    [anon_sym_BSLASH] = ACTIONS(1961),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4163),
    [anon_sym_case] = ACTIONS(1965),
    [anon_sym_mdo] = ACTIONS(1967),
    [anon_sym_do] = ACTIONS(1967),
    [anon_sym_7] = ACTIONS(1969),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1971),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1973),
  },
  [1985] = {
    [sym_integer] = STATE(5749),
    [sym__literal] = STATE(5749),
    [sym__unboxed_open] = STATE(787),
    [sym_variable] = STATE(5599),
    [sym_qualified_variable] = STATE(5599),
    [sym_constructor] = STATE(5259),
    [sym_qualified_constructor] = STATE(5552),
    [sym__qcon] = STATE(5599),
    [sym_con_unit] = STATE(5749),
    [sym_con_list] = STATE(5749),
    [sym_con_tuple] = STATE(5749),
    [sym_literal] = STATE(5638),
    [sym_exp_parens] = STATE(5638),
    [sym_exp_tuple] = STATE(5638),
    [sym_exp_unboxed_tuple] = STATE(5638),
    [sym_exp_unboxed_sum] = STATE(5638),
    [sym_exp_list] = STATE(5638),
    [sym_exp_arithmetic_sequence] = STATE(5638),
    [sym_exp_list_comprehension] = STATE(5638),
    [sym_exp_section_left] = STATE(5638),
    [sym_exp_section_right] = STATE(5638),
    [sym_exp_th_quoted_name] = STATE(5638),
    [sym_exp_type_application] = STATE(964),
    [sym_exp_lambda] = STATE(12349),
    [sym_exp_let] = STATE(18245),
    [sym_exp_let_in] = STATE(12349),
    [sym_exp_cond] = STATE(12349),
    [sym_exp_if_guard] = STATE(12349),
    [sym_exp_case] = STATE(12349),
    [sym_exp_lambda_case] = STATE(964),
    [sym__do_keyword] = STATE(18319),
    [sym_do_module] = STATE(18319),
    [sym_exp_do] = STATE(964),
    [sym_exp_negation] = STATE(12349),
    [sym_exp_record] = STATE(5638),
    [sym_exp_name] = STATE(5638),
    [sym_exp_projection_selector] = STATE(5638),
    [sym__aexp_projection] = STATE(5638),
    [sym_exp_projection] = STATE(5638),
    [sym__aexp] = STATE(964),
    [sym__exp_apply] = STATE(12426),
    [sym__fexp] = STATE(12349),
    [sym__lexp] = STATE(12349),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12705),
    [sym_splice] = STATE(5638),
    [sym_quasiquote] = STATE(5638),
    [sym__varid] = ACTIONS(2973),
    [sym_float] = ACTIONS(2975),
    [sym_char] = ACTIONS(2975),
    [sym_string] = ACTIONS(2975),
    [sym__integer_literal] = ACTIONS(2977),
    [sym__binary_literal] = ACTIONS(2979),
    [sym__octal_literal] = ACTIONS(2979),
    [sym__hex_literal] = ACTIONS(2979),
    [anon_sym_LPAREN_POUND] = ACTIONS(2981),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2981),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2983),
    [anon_sym_DASH] = ACTIONS(4151),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [sym_implicit_parid] = ACTIONS(2983),
    [sym__conid] = ACTIONS(4153),
    [anon_sym_LBRACK] = ACTIONS(2990),
    [anon_sym_SQUOTE] = ACTIONS(2992),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2996),
    [anon_sym_AT] = ACTIONS(2998),
    [anon_sym_BSLASH] = ACTIONS(3000),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4155),
    [anon_sym_case] = ACTIONS(3004),
    [anon_sym_mdo] = ACTIONS(3006),
    [anon_sym_do] = ACTIONS(3006),
    [anon_sym_7] = ACTIONS(3008),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(3012),
  },
  [1986] = {
    [sym_integer] = STATE(5669),
    [sym__literal] = STATE(5669),
    [sym__unboxed_open] = STATE(761),
    [sym_variable] = STATE(5710),
    [sym_qualified_variable] = STATE(5710),
    [sym_constructor] = STATE(5151),
    [sym_qualified_constructor] = STATE(5594),
    [sym__qcon] = STATE(5710),
    [sym_con_unit] = STATE(5669),
    [sym_con_list] = STATE(5669),
    [sym_con_tuple] = STATE(5669),
    [sym_literal] = STATE(5640),
    [sym_exp_parens] = STATE(5640),
    [sym_exp_tuple] = STATE(5640),
    [sym_exp_unboxed_tuple] = STATE(5640),
    [sym_exp_unboxed_sum] = STATE(5640),
    [sym_exp_list] = STATE(5640),
    [sym_exp_arithmetic_sequence] = STATE(5640),
    [sym_exp_list_comprehension] = STATE(5640),
    [sym_exp_section_left] = STATE(5640),
    [sym_exp_section_right] = STATE(5640),
    [sym_exp_th_quoted_name] = STATE(5640),
    [sym_exp_type_application] = STATE(956),
    [sym_exp_lambda] = STATE(12300),
    [sym_exp_let] = STATE(17912),
    [sym_exp_let_in] = STATE(12300),
    [sym_exp_cond] = STATE(12300),
    [sym_exp_if_guard] = STATE(12300),
    [sym_exp_case] = STATE(12300),
    [sym_exp_lambda_case] = STATE(956),
    [sym__do_keyword] = STATE(17914),
    [sym_do_module] = STATE(17914),
    [sym_exp_do] = STATE(956),
    [sym_exp_negation] = STATE(12300),
    [sym_exp_record] = STATE(5640),
    [sym_exp_name] = STATE(5640),
    [sym_exp_projection_selector] = STATE(5640),
    [sym__aexp_projection] = STATE(5640),
    [sym_exp_projection] = STATE(5640),
    [sym__aexp] = STATE(956),
    [sym__exp_apply] = STATE(12238),
    [sym__fexp] = STATE(12300),
    [sym__lexp] = STATE(12300),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12604),
    [sym_splice] = STATE(5640),
    [sym_quasiquote] = STATE(5640),
    [sym__varid] = ACTIONS(2945),
    [sym_float] = ACTIONS(2947),
    [sym_char] = ACTIONS(2947),
    [sym_string] = ACTIONS(2947),
    [sym__integer_literal] = ACTIONS(2949),
    [sym__binary_literal] = ACTIONS(2951),
    [sym__octal_literal] = ACTIONS(2951),
    [sym__hex_literal] = ACTIONS(2951),
    [anon_sym_LPAREN_POUND] = ACTIONS(2953),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2953),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(15),
    [anon_sym_DASH] = ACTIONS(4169),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [sym_implicit_parid] = ACTIONS(15),
    [sym__conid] = ACTIONS(4171),
    [anon_sym_LBRACK] = ACTIONS(2961),
    [anon_sym_SQUOTE] = ACTIONS(27),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(35),
    [anon_sym_AT] = ACTIONS(37),
    [anon_sym_BSLASH] = ACTIONS(39),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(43),
    [anon_sym_case] = ACTIONS(45),
    [anon_sym_mdo] = ACTIONS(47),
    [anon_sym_do] = ACTIONS(47),
    [anon_sym_7] = ACTIONS(2967),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2969),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2971),
  },
  [1987] = {
    [sym_integer] = STATE(4118),
    [sym__literal] = STATE(4118),
    [sym__unboxed_open] = STATE(770),
    [sym_variable] = STATE(4114),
    [sym_qualified_variable] = STATE(4114),
    [sym_constructor] = STATE(3978),
    [sym_qualified_constructor] = STATE(4121),
    [sym__qcon] = STATE(4114),
    [sym_con_unit] = STATE(4118),
    [sym_con_list] = STATE(4118),
    [sym_con_tuple] = STATE(4118),
    [sym_literal] = STATE(4065),
    [sym_exp_parens] = STATE(4065),
    [sym_exp_tuple] = STATE(4065),
    [sym_exp_unboxed_tuple] = STATE(4065),
    [sym_exp_unboxed_sum] = STATE(4065),
    [sym_exp_list] = STATE(4065),
    [sym_exp_arithmetic_sequence] = STATE(4065),
    [sym_exp_list_comprehension] = STATE(4065),
    [sym_exp_section_left] = STATE(4065),
    [sym_exp_section_right] = STATE(4065),
    [sym_exp_th_quoted_name] = STATE(4065),
    [sym_exp_type_application] = STATE(763),
    [sym_exp_lambda] = STATE(10514),
    [sym_exp_let] = STATE(18088),
    [sym_exp_let_in] = STATE(10514),
    [sym_exp_cond] = STATE(10514),
    [sym_exp_if_guard] = STATE(10514),
    [sym_exp_case] = STATE(10514),
    [sym_exp_lambda_case] = STATE(763),
    [sym__do_keyword] = STATE(18532),
    [sym_do_module] = STATE(18532),
    [sym_exp_do] = STATE(763),
    [sym_exp_negation] = STATE(10514),
    [sym_exp_record] = STATE(4065),
    [sym_exp_name] = STATE(4065),
    [sym_exp_projection_selector] = STATE(4065),
    [sym__aexp_projection] = STATE(4065),
    [sym_exp_projection] = STATE(4065),
    [sym__aexp] = STATE(763),
    [sym__exp_apply] = STATE(10801),
    [sym__fexp] = STATE(10514),
    [sym__lexp] = STATE(10514),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12523),
    [sym_splice] = STATE(4065),
    [sym_quasiquote] = STATE(4065),
    [sym__varid] = ACTIONS(1837),
    [sym_float] = ACTIONS(1228),
    [sym_char] = ACTIONS(1228),
    [sym_string] = ACTIONS(1228),
    [sym__integer_literal] = ACTIONS(1230),
    [sym__binary_literal] = ACTIONS(1232),
    [sym__octal_literal] = ACTIONS(1232),
    [sym__hex_literal] = ACTIONS(1232),
    [anon_sym_LPAREN_POUND] = ACTIONS(1839),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1839),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1236),
    [anon_sym_DASH] = ACTIONS(3114),
    [anon_sym_LPAREN] = ACTIONS(1841),
    [sym_implicit_parid] = ACTIONS(1236),
    [sym__conid] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1252),
    [anon_sym_BSLASH] = ACTIONS(1254),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(1256),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_mdo] = ACTIONS(1260),
    [anon_sym_do] = ACTIONS(1260),
    [anon_sym_7] = ACTIONS(1262),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1264),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1266),
  },
  [1988] = {
    [sym_integer] = STATE(4662),
    [sym__literal] = STATE(4662),
    [sym__unboxed_open] = STATE(753),
    [sym_variable] = STATE(4833),
    [sym_qualified_variable] = STATE(4833),
    [sym_constructor] = STATE(4342),
    [sym_qualified_constructor] = STATE(4790),
    [sym__qcon] = STATE(4833),
    [sym_con_unit] = STATE(4662),
    [sym_con_list] = STATE(4662),
    [sym_con_tuple] = STATE(4662),
    [sym_literal] = STATE(4650),
    [sym_exp_parens] = STATE(4650),
    [sym_exp_tuple] = STATE(4650),
    [sym_exp_unboxed_tuple] = STATE(4650),
    [sym_exp_unboxed_sum] = STATE(4650),
    [sym_exp_list] = STATE(4650),
    [sym_exp_arithmetic_sequence] = STATE(4650),
    [sym_exp_list_comprehension] = STATE(4650),
    [sym_exp_section_left] = STATE(4650),
    [sym_exp_section_right] = STATE(4650),
    [sym_exp_th_quoted_name] = STATE(4650),
    [sym_exp_type_application] = STATE(882),
    [sym_exp_lambda] = STATE(11757),
    [sym_exp_let] = STATE(18846),
    [sym_exp_let_in] = STATE(11757),
    [sym_exp_cond] = STATE(11757),
    [sym_exp_if_guard] = STATE(11757),
    [sym_exp_case] = STATE(11757),
    [sym_exp_lambda_case] = STATE(882),
    [sym__do_keyword] = STATE(18352),
    [sym_do_module] = STATE(18352),
    [sym_exp_do] = STATE(882),
    [sym_exp_negation] = STATE(11757),
    [sym_exp_record] = STATE(4650),
    [sym_exp_name] = STATE(4650),
    [sym_exp_projection_selector] = STATE(4650),
    [sym__aexp_projection] = STATE(4650),
    [sym_exp_projection] = STATE(4650),
    [sym__aexp] = STATE(882),
    [sym__exp_apply] = STATE(11843),
    [sym__fexp] = STATE(11757),
    [sym__lexp] = STATE(11757),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12534),
    [sym_splice] = STATE(4650),
    [sym_quasiquote] = STATE(4650),
    [sym__varid] = ACTIONS(2305),
    [sym_float] = ACTIONS(2307),
    [sym_char] = ACTIONS(2307),
    [sym_string] = ACTIONS(2307),
    [sym__integer_literal] = ACTIONS(2309),
    [sym__binary_literal] = ACTIONS(2311),
    [sym__octal_literal] = ACTIONS(2311),
    [sym__hex_literal] = ACTIONS(2311),
    [anon_sym_LPAREN_POUND] = ACTIONS(2313),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2313),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(4265),
    [anon_sym_LPAREN] = ACTIONS(2317),
    [sym_implicit_parid] = ACTIONS(2315),
    [sym__conid] = ACTIONS(4267),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_SQUOTE] = ACTIONS(2324),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2328),
    [anon_sym_AT] = ACTIONS(2330),
    [anon_sym_BSLASH] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4269),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_mdo] = ACTIONS(2338),
    [anon_sym_do] = ACTIONS(2338),
    [anon_sym_7] = ACTIONS(2340),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2344),
  },
  [1989] = {
    [sym_integer] = STATE(4706),
    [sym__literal] = STATE(4706),
    [sym__unboxed_open] = STATE(756),
    [sym_variable] = STATE(4756),
    [sym_qualified_variable] = STATE(4756),
    [sym_constructor] = STATE(4233),
    [sym_qualified_constructor] = STATE(4725),
    [sym__qcon] = STATE(4756),
    [sym_con_unit] = STATE(4706),
    [sym_con_list] = STATE(4706),
    [sym_con_tuple] = STATE(4706),
    [sym_literal] = STATE(4663),
    [sym_exp_parens] = STATE(4663),
    [sym_exp_tuple] = STATE(4663),
    [sym_exp_unboxed_tuple] = STATE(4663),
    [sym_exp_unboxed_sum] = STATE(4663),
    [sym_exp_list] = STATE(4663),
    [sym_exp_arithmetic_sequence] = STATE(4663),
    [sym_exp_list_comprehension] = STATE(4663),
    [sym_exp_section_left] = STATE(4663),
    [sym_exp_section_right] = STATE(4663),
    [sym_exp_th_quoted_name] = STATE(4663),
    [sym_exp_type_application] = STATE(870),
    [sym_exp_lambda] = STATE(11805),
    [sym_exp_let] = STATE(18848),
    [sym_exp_let_in] = STATE(11805),
    [sym_exp_cond] = STATE(11805),
    [sym_exp_if_guard] = STATE(11805),
    [sym_exp_case] = STATE(11805),
    [sym_exp_lambda_case] = STATE(870),
    [sym__do_keyword] = STATE(18207),
    [sym_do_module] = STATE(18207),
    [sym_exp_do] = STATE(870),
    [sym_exp_negation] = STATE(11805),
    [sym_exp_record] = STATE(4663),
    [sym_exp_name] = STATE(4663),
    [sym_exp_projection_selector] = STATE(4663),
    [sym__aexp_projection] = STATE(4663),
    [sym_exp_projection] = STATE(4663),
    [sym__aexp] = STATE(870),
    [sym__exp_apply] = STATE(11822),
    [sym__fexp] = STATE(11805),
    [sym__lexp] = STATE(11805),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12713),
    [sym_splice] = STATE(4663),
    [sym_quasiquote] = STATE(4663),
    [sym__varid] = ACTIONS(2350),
    [sym_float] = ACTIONS(2352),
    [sym_char] = ACTIONS(2352),
    [sym_string] = ACTIONS(2352),
    [sym__integer_literal] = ACTIONS(2354),
    [sym__binary_literal] = ACTIONS(2356),
    [sym__octal_literal] = ACTIONS(2356),
    [sym__hex_literal] = ACTIONS(2356),
    [anon_sym_LPAREN_POUND] = ACTIONS(2358),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2358),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(4175),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [sym_implicit_parid] = ACTIONS(2360),
    [sym__conid] = ACTIONS(4177),
    [anon_sym_LBRACK] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2374),
    [anon_sym_AT] = ACTIONS(2376),
    [anon_sym_BSLASH] = ACTIONS(2378),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4179),
    [anon_sym_case] = ACTIONS(2382),
    [anon_sym_mdo] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_7] = ACTIONS(2386),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2390),
  },
  [1990] = {
    [sym_integer] = STATE(5033),
    [sym__literal] = STATE(5033),
    [sym__unboxed_open] = STATE(782),
    [sym_variable] = STATE(5110),
    [sym_qualified_variable] = STATE(5110),
    [sym_constructor] = STATE(4535),
    [sym_qualified_constructor] = STATE(5315),
    [sym__qcon] = STATE(5110),
    [sym_con_unit] = STATE(5033),
    [sym_con_list] = STATE(5033),
    [sym_con_tuple] = STATE(5033),
    [sym_literal] = STATE(5409),
    [sym_exp_parens] = STATE(5409),
    [sym_exp_tuple] = STATE(5409),
    [sym_exp_unboxed_tuple] = STATE(5409),
    [sym_exp_unboxed_sum] = STATE(5409),
    [sym_exp_list] = STATE(5409),
    [sym_exp_arithmetic_sequence] = STATE(5409),
    [sym_exp_list_comprehension] = STATE(5409),
    [sym_exp_section_left] = STATE(5409),
    [sym_exp_section_right] = STATE(5409),
    [sym_exp_th_quoted_name] = STATE(5409),
    [sym_exp_type_application] = STATE(952),
    [sym_exp_lambda] = STATE(12165),
    [sym_exp_let] = STATE(18549),
    [sym_exp_let_in] = STATE(12165),
    [sym_exp_cond] = STATE(12165),
    [sym_exp_if_guard] = STATE(12165),
    [sym_exp_case] = STATE(12165),
    [sym_exp_lambda_case] = STATE(952),
    [sym__do_keyword] = STATE(18406),
    [sym_do_module] = STATE(18406),
    [sym_exp_do] = STATE(952),
    [sym_exp_negation] = STATE(12165),
    [sym_exp_record] = STATE(5409),
    [sym_exp_name] = STATE(5409),
    [sym_exp_projection_selector] = STATE(5409),
    [sym__aexp_projection] = STATE(5409),
    [sym_exp_projection] = STATE(5409),
    [sym__aexp] = STATE(952),
    [sym__exp_apply] = STATE(12176),
    [sym__fexp] = STATE(12165),
    [sym__lexp] = STATE(12165),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12550),
    [sym_splice] = STATE(5409),
    [sym_quasiquote] = STATE(5409),
    [sym__varid] = ACTIONS(2844),
    [sym_float] = ACTIONS(2846),
    [sym_char] = ACTIONS(2846),
    [sym_string] = ACTIONS(2846),
    [sym__integer_literal] = ACTIONS(2848),
    [sym__binary_literal] = ACTIONS(2850),
    [sym__octal_literal] = ACTIONS(2850),
    [sym__hex_literal] = ACTIONS(2850),
    [anon_sym_LPAREN_POUND] = ACTIONS(2852),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2852),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2854),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [sym_implicit_parid] = ACTIONS(2854),
    [sym__conid] = ACTIONS(4061),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [anon_sym_SQUOTE] = ACTIONS(2863),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2867),
    [anon_sym_AT] = ACTIONS(2869),
    [anon_sym_BSLASH] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4063),
    [anon_sym_case] = ACTIONS(2875),
    [anon_sym_mdo] = ACTIONS(2877),
    [anon_sym_do] = ACTIONS(2877),
    [anon_sym_7] = ACTIONS(2879),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2883),
  },
  [1991] = {
    [sym_integer] = STATE(3856),
    [sym__literal] = STATE(3856),
    [sym__unboxed_open] = STATE(790),
    [sym_variable] = STATE(3901),
    [sym_qualified_variable] = STATE(3901),
    [sym_constructor] = STATE(3818),
    [sym_qualified_constructor] = STATE(3884),
    [sym__qcon] = STATE(3901),
    [sym_con_unit] = STATE(3856),
    [sym_con_list] = STATE(3856),
    [sym_con_tuple] = STATE(3856),
    [sym_literal] = STATE(4050),
    [sym_exp_parens] = STATE(4050),
    [sym_exp_tuple] = STATE(4050),
    [sym_exp_unboxed_tuple] = STATE(4050),
    [sym_exp_unboxed_sum] = STATE(4050),
    [sym_exp_list] = STATE(4050),
    [sym_exp_arithmetic_sequence] = STATE(4050),
    [sym_exp_list_comprehension] = STATE(4050),
    [sym_exp_section_left] = STATE(4050),
    [sym_exp_section_right] = STATE(4050),
    [sym_exp_th_quoted_name] = STATE(4050),
    [sym_exp_type_application] = STATE(767),
    [sym_exp_lambda] = STATE(10725),
    [sym_exp_let] = STATE(17929),
    [sym_exp_let_in] = STATE(10725),
    [sym_exp_cond] = STATE(10725),
    [sym_exp_if_guard] = STATE(10725),
    [sym_exp_case] = STATE(10725),
    [sym_exp_lambda_case] = STATE(767),
    [sym__do_keyword] = STATE(18555),
    [sym_do_module] = STATE(18555),
    [sym_exp_do] = STATE(767),
    [sym_exp_negation] = STATE(10725),
    [sym_exp_record] = STATE(4050),
    [sym_exp_name] = STATE(4050),
    [sym_exp_projection_selector] = STATE(4050),
    [sym__aexp_projection] = STATE(4050),
    [sym_exp_projection] = STATE(4050),
    [sym__aexp] = STATE(767),
    [sym__exp_apply] = STATE(10369),
    [sym__fexp] = STATE(10725),
    [sym__lexp] = STATE(10725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12598),
    [sym_splice] = STATE(4050),
    [sym_quasiquote] = STATE(4050),
    [sym__varid] = ACTIONS(1390),
    [sym_float] = ACTIONS(229),
    [sym_char] = ACTIONS(229),
    [sym_string] = ACTIONS(229),
    [sym__integer_literal] = ACTIONS(231),
    [sym__binary_literal] = ACTIONS(233),
    [sym__octal_literal] = ACTIONS(233),
    [sym__hex_literal] = ACTIONS(233),
    [anon_sym_LPAREN_POUND] = ACTIONS(1392),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1392),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(237),
    [anon_sym_DASH] = ACTIONS(2523),
    [anon_sym_LPAREN] = ACTIONS(1396),
    [sym_implicit_parid] = ACTIONS(237),
    [sym__conid] = ACTIONS(1402),
    [anon_sym_LBRACK] = ACTIONS(1404),
    [anon_sym_SQUOTE] = ACTIONS(251),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(257),
    [anon_sym_AT] = ACTIONS(259),
    [anon_sym_BSLASH] = ACTIONS(261),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(263),
    [anon_sym_case] = ACTIONS(265),
    [anon_sym_mdo] = ACTIONS(267),
    [anon_sym_do] = ACTIONS(267),
    [anon_sym_7] = ACTIONS(269),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(279),
  },
  [1992] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(16904),
    [sym_class_datafam] = STATE(16904),
    [sym_class_tyfam] = STATE(16904),
    [sym__cdecl] = STATE(16904),
    [sym_inst_tyinst] = STATE(18430),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(16904),
    [sym_fixity] = STATE(16904),
    [sym_signature] = STATE(16904),
    [sym__gendecl] = STATE(16904),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(4935),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4917),
    [anon_sym_RBRACE] = ACTIONS(4937),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4923),
    [anon_sym_default] = ACTIONS(4925),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [1993] = {
    [sym_integer] = STATE(4976),
    [sym__literal] = STATE(4976),
    [sym__unboxed_open] = STATE(794),
    [sym_variable] = STATE(5481),
    [sym_qualified_variable] = STATE(5481),
    [sym_constructor] = STATE(4552),
    [sym_qualified_constructor] = STATE(5251),
    [sym__qcon] = STATE(5481),
    [sym_con_unit] = STATE(4976),
    [sym_con_list] = STATE(4976),
    [sym_con_tuple] = STATE(4976),
    [sym_literal] = STATE(5314),
    [sym_exp_parens] = STATE(5314),
    [sym_exp_tuple] = STATE(5314),
    [sym_exp_unboxed_tuple] = STATE(5314),
    [sym_exp_unboxed_sum] = STATE(5314),
    [sym_exp_list] = STATE(5314),
    [sym_exp_arithmetic_sequence] = STATE(5314),
    [sym_exp_list_comprehension] = STATE(5314),
    [sym_exp_section_left] = STATE(5314),
    [sym_exp_section_right] = STATE(5314),
    [sym_exp_th_quoted_name] = STATE(5314),
    [sym_exp_type_application] = STATE(948),
    [sym_exp_lambda] = STATE(11987),
    [sym_exp_let] = STATE(18616),
    [sym_exp_let_in] = STATE(11987),
    [sym_exp_cond] = STATE(11987),
    [sym_exp_if_guard] = STATE(11987),
    [sym_exp_case] = STATE(11987),
    [sym_exp_lambda_case] = STATE(948),
    [sym__do_keyword] = STATE(18242),
    [sym_do_module] = STATE(18242),
    [sym_exp_do] = STATE(948),
    [sym_exp_negation] = STATE(11987),
    [sym_exp_record] = STATE(5314),
    [sym_exp_name] = STATE(5314),
    [sym_exp_projection_selector] = STATE(5314),
    [sym__aexp_projection] = STATE(5314),
    [sym_exp_projection] = STATE(5314),
    [sym__aexp] = STATE(948),
    [sym__exp_apply] = STATE(12137),
    [sym__fexp] = STATE(11987),
    [sym__lexp] = STATE(11987),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12657),
    [sym_splice] = STATE(5314),
    [sym_quasiquote] = STATE(5314),
    [sym__varid] = ACTIONS(2603),
    [sym_float] = ACTIONS(2605),
    [sym_char] = ACTIONS(2605),
    [sym_string] = ACTIONS(2605),
    [sym__integer_literal] = ACTIONS(2607),
    [sym__binary_literal] = ACTIONS(2609),
    [sym__octal_literal] = ACTIONS(2609),
    [sym__hex_literal] = ACTIONS(2609),
    [anon_sym_LPAREN_POUND] = ACTIONS(2611),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2611),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2613),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_LPAREN] = ACTIONS(2615),
    [sym_implicit_parid] = ACTIONS(2613),
    [sym__conid] = ACTIONS(4081),
    [anon_sym_LBRACK] = ACTIONS(2620),
    [anon_sym_SQUOTE] = ACTIONS(2622),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2626),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_BSLASH] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4083),
    [anon_sym_case] = ACTIONS(2634),
    [anon_sym_mdo] = ACTIONS(2636),
    [anon_sym_do] = ACTIONS(2636),
    [anon_sym_7] = ACTIONS(2638),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2642),
  },
  [1994] = {
    [sym_integer] = STATE(4547),
    [sym__literal] = STATE(4547),
    [sym__unboxed_open] = STATE(799),
    [sym_variable] = STATE(4401),
    [sym_qualified_variable] = STATE(4401),
    [sym_constructor] = STATE(4265),
    [sym_qualified_constructor] = STATE(4502),
    [sym__qcon] = STATE(4401),
    [sym_con_unit] = STATE(4547),
    [sym_con_list] = STATE(4547),
    [sym_con_tuple] = STATE(4547),
    [sym_literal] = STATE(4433),
    [sym_exp_parens] = STATE(4433),
    [sym_exp_tuple] = STATE(4433),
    [sym_exp_unboxed_tuple] = STATE(4433),
    [sym_exp_unboxed_sum] = STATE(4433),
    [sym_exp_list] = STATE(4433),
    [sym_exp_arithmetic_sequence] = STATE(4433),
    [sym_exp_list_comprehension] = STATE(4433),
    [sym_exp_section_left] = STATE(4433),
    [sym_exp_section_right] = STATE(4433),
    [sym_exp_th_quoted_name] = STATE(4433),
    [sym_exp_type_application] = STATE(873),
    [sym_exp_lambda] = STATE(11922),
    [sym_exp_let] = STATE(18243),
    [sym_exp_let_in] = STATE(11922),
    [sym_exp_cond] = STATE(11922),
    [sym_exp_if_guard] = STATE(11922),
    [sym_exp_case] = STATE(11922),
    [sym_exp_lambda_case] = STATE(873),
    [sym__do_keyword] = STATE(18503),
    [sym_do_module] = STATE(18503),
    [sym_exp_do] = STATE(873),
    [sym_exp_negation] = STATE(11922),
    [sym_exp_record] = STATE(4433),
    [sym_exp_name] = STATE(4433),
    [sym_exp_projection_selector] = STATE(4433),
    [sym__aexp_projection] = STATE(4433),
    [sym_exp_projection] = STATE(4433),
    [sym__aexp] = STATE(873),
    [sym__exp_apply] = STATE(11911),
    [sym__fexp] = STATE(11922),
    [sym__lexp] = STATE(11922),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12681),
    [sym_splice] = STATE(4433),
    [sym_quasiquote] = STATE(4433),
    [sym__varid] = ACTIONS(1745),
    [sym_float] = ACTIONS(535),
    [sym_char] = ACTIONS(535),
    [sym_string] = ACTIONS(535),
    [sym__integer_literal] = ACTIONS(537),
    [sym__binary_literal] = ACTIONS(539),
    [sym__octal_literal] = ACTIONS(539),
    [sym__hex_literal] = ACTIONS(539),
    [anon_sym_LPAREN_POUND] = ACTIONS(1747),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1747),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(1749),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [sym_implicit_parid] = ACTIONS(543),
    [sym__conid] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_SQUOTE] = ACTIONS(553),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(559),
    [anon_sym_AT] = ACTIONS(561),
    [anon_sym_BSLASH] = ACTIONS(563),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_case] = ACTIONS(567),
    [anon_sym_mdo] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_7] = ACTIONS(571),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(577),
  },
  [1995] = {
    [sym_integer] = STATE(4441),
    [sym__literal] = STATE(4441),
    [sym__unboxed_open] = STATE(750),
    [sym_variable] = STATE(4795),
    [sym_qualified_variable] = STATE(4795),
    [sym_constructor] = STATE(4308),
    [sym_qualified_constructor] = STATE(4664),
    [sym__qcon] = STATE(4795),
    [sym_con_unit] = STATE(4441),
    [sym_con_list] = STATE(4441),
    [sym_con_tuple] = STATE(4441),
    [sym_literal] = STATE(5587),
    [sym_exp_parens] = STATE(5587),
    [sym_exp_tuple] = STATE(5587),
    [sym_exp_unboxed_tuple] = STATE(5587),
    [sym_exp_unboxed_sum] = STATE(5587),
    [sym_exp_list] = STATE(5587),
    [sym_exp_arithmetic_sequence] = STATE(5587),
    [sym_exp_list_comprehension] = STATE(5587),
    [sym_exp_section_left] = STATE(5587),
    [sym_exp_section_right] = STATE(5587),
    [sym_exp_th_quoted_name] = STATE(5587),
    [sym_exp_type_application] = STATE(958),
    [sym_exp_lambda] = STATE(12288),
    [sym_exp_let] = STATE(18437),
    [sym_exp_let_in] = STATE(12288),
    [sym_exp_cond] = STATE(12288),
    [sym_exp_if_guard] = STATE(12288),
    [sym_exp_case] = STATE(12288),
    [sym_exp_lambda_case] = STATE(958),
    [sym__do_keyword] = STATE(18424),
    [sym_do_module] = STATE(18424),
    [sym_exp_do] = STATE(958),
    [sym_exp_negation] = STATE(12288),
    [sym_exp_record] = STATE(5587),
    [sym_exp_name] = STATE(5587),
    [sym_exp_projection_selector] = STATE(5587),
    [sym__aexp_projection] = STATE(5587),
    [sym_exp_projection] = STATE(5587),
    [sym__aexp] = STATE(958),
    [sym__exp_apply] = STATE(12489),
    [sym__fexp] = STATE(12288),
    [sym__lexp] = STATE(12288),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12545),
    [sym_splice] = STATE(5587),
    [sym_quasiquote] = STATE(5587),
    [sym__varid] = ACTIONS(3014),
    [sym_float] = ACTIONS(883),
    [sym_char] = ACTIONS(883),
    [sym_string] = ACTIONS(883),
    [sym__integer_literal] = ACTIONS(885),
    [sym__binary_literal] = ACTIONS(887),
    [sym__octal_literal] = ACTIONS(887),
    [sym__hex_literal] = ACTIONS(887),
    [anon_sym_LPAREN_POUND] = ACTIONS(3016),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3016),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(165),
    [anon_sym_DASH] = ACTIONS(4287),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [sym_implicit_parid] = ACTIONS(165),
    [sym__conid] = ACTIONS(4289),
    [anon_sym_LBRACK] = ACTIONS(3024),
    [anon_sym_SQUOTE] = ACTIONS(177),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(183),
    [anon_sym_AT] = ACTIONS(185),
    [anon_sym_BSLASH] = ACTIONS(187),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(191),
    [anon_sym_mdo] = ACTIONS(193),
    [anon_sym_do] = ACTIONS(193),
    [anon_sym_7] = ACTIONS(903),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(907),
  },
  [1996] = {
    [sym_integer] = STATE(4937),
    [sym__literal] = STATE(4937),
    [sym__unboxed_open] = STATE(784),
    [sym_variable] = STATE(5329),
    [sym_qualified_variable] = STATE(5329),
    [sym_constructor] = STATE(4661),
    [sym_qualified_constructor] = STATE(5081),
    [sym__qcon] = STATE(5329),
    [sym_con_unit] = STATE(4937),
    [sym_con_list] = STATE(4937),
    [sym_con_tuple] = STATE(4937),
    [sym_literal] = STATE(5477),
    [sym_exp_parens] = STATE(5477),
    [sym_exp_tuple] = STATE(5477),
    [sym_exp_unboxed_tuple] = STATE(5477),
    [sym_exp_unboxed_sum] = STATE(5477),
    [sym_exp_list] = STATE(5477),
    [sym_exp_arithmetic_sequence] = STATE(5477),
    [sym_exp_list_comprehension] = STATE(5477),
    [sym_exp_section_left] = STATE(5477),
    [sym_exp_section_right] = STATE(5477),
    [sym_exp_th_quoted_name] = STATE(5477),
    [sym_exp_type_application] = STATE(917),
    [sym_exp_lambda] = STATE(12044),
    [sym_exp_let] = STATE(17941),
    [sym_exp_let_in] = STATE(12044),
    [sym_exp_cond] = STATE(12044),
    [sym_exp_if_guard] = STATE(12044),
    [sym_exp_case] = STATE(12044),
    [sym_exp_lambda_case] = STATE(917),
    [sym__do_keyword] = STATE(18276),
    [sym_do_module] = STATE(18276),
    [sym_exp_do] = STATE(917),
    [sym_exp_negation] = STATE(12044),
    [sym_exp_record] = STATE(5477),
    [sym_exp_name] = STATE(5477),
    [sym_exp_projection_selector] = STATE(5477),
    [sym__aexp_projection] = STATE(5477),
    [sym_exp_projection] = STATE(5477),
    [sym__aexp] = STATE(917),
    [sym__exp_apply] = STATE(12109),
    [sym__fexp] = STATE(12044),
    [sym__lexp] = STATE(12044),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12628),
    [sym_splice] = STATE(5477),
    [sym_quasiquote] = STATE(5477),
    [sym__varid] = ACTIONS(2733),
    [sym_float] = ACTIONS(2735),
    [sym_char] = ACTIONS(2735),
    [sym_string] = ACTIONS(2735),
    [sym__integer_literal] = ACTIONS(2737),
    [sym__binary_literal] = ACTIONS(2739),
    [sym__octal_literal] = ACTIONS(2739),
    [sym__hex_literal] = ACTIONS(2739),
    [anon_sym_LPAREN_POUND] = ACTIONS(2741),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2741),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2743),
    [anon_sym_DASH] = ACTIONS(4071),
    [anon_sym_LPAREN] = ACTIONS(2745),
    [sym_implicit_parid] = ACTIONS(2743),
    [sym__conid] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_SQUOTE] = ACTIONS(2753),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2757),
    [anon_sym_AT] = ACTIONS(2759),
    [anon_sym_BSLASH] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4075),
    [anon_sym_case] = ACTIONS(2765),
    [anon_sym_mdo] = ACTIONS(2767),
    [anon_sym_do] = ACTIONS(2767),
    [anon_sym_7] = ACTIONS(2769),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2773),
  },
  [1997] = {
    [sym_integer] = STATE(3980),
    [sym__literal] = STATE(3980),
    [sym__unboxed_open] = STATE(769),
    [sym_variable] = STATE(3975),
    [sym_qualified_variable] = STATE(3975),
    [sym_constructor] = STATE(3857),
    [sym_qualified_constructor] = STATE(3915),
    [sym__qcon] = STATE(3975),
    [sym_con_unit] = STATE(3980),
    [sym_con_list] = STATE(3980),
    [sym_con_tuple] = STATE(3980),
    [sym_literal] = STATE(3921),
    [sym_exp_parens] = STATE(3921),
    [sym_exp_tuple] = STATE(3921),
    [sym_exp_unboxed_tuple] = STATE(3921),
    [sym_exp_unboxed_sum] = STATE(3921),
    [sym_exp_list] = STATE(3921),
    [sym_exp_arithmetic_sequence] = STATE(3921),
    [sym_exp_list_comprehension] = STATE(3921),
    [sym_exp_section_left] = STATE(3921),
    [sym_exp_section_right] = STATE(3921),
    [sym_exp_th_quoted_name] = STATE(3921),
    [sym_exp_type_application] = STATE(695),
    [sym_exp_lambda] = STATE(10013),
    [sym_exp_let] = STATE(18820),
    [sym_exp_let_in] = STATE(10013),
    [sym_exp_cond] = STATE(10013),
    [sym_exp_if_guard] = STATE(10013),
    [sym_exp_case] = STATE(10013),
    [sym_exp_lambda_case] = STATE(695),
    [sym__do_keyword] = STATE(18344),
    [sym_do_module] = STATE(18344),
    [sym_exp_do] = STATE(695),
    [sym_exp_negation] = STATE(10013),
    [sym_exp_record] = STATE(3921),
    [sym_exp_name] = STATE(3921),
    [sym_exp_projection_selector] = STATE(3921),
    [sym__aexp_projection] = STATE(3921),
    [sym_exp_projection] = STATE(3921),
    [sym__aexp] = STATE(695),
    [sym__exp_apply] = STATE(9976),
    [sym__fexp] = STATE(10013),
    [sym__lexp] = STATE(10013),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12582),
    [sym_splice] = STATE(3921),
    [sym_quasiquote] = STATE(3921),
    [sym__varid] = ACTIONS(1700),
    [sym_float] = ACTIONS(1702),
    [sym_char] = ACTIONS(1702),
    [sym_string] = ACTIONS(1702),
    [sym__integer_literal] = ACTIONS(1704),
    [sym__binary_literal] = ACTIONS(1706),
    [sym__octal_literal] = ACTIONS(1706),
    [sym__hex_literal] = ACTIONS(1706),
    [anon_sym_LPAREN_POUND] = ACTIONS(1708),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1708),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(1710),
    [anon_sym_DASH] = ACTIONS(4203),
    [anon_sym_LPAREN] = ACTIONS(1712),
    [sym_implicit_parid] = ACTIONS(1710),
    [sym__conid] = ACTIONS(4205),
    [anon_sym_LBRACK] = ACTIONS(1717),
    [anon_sym_SQUOTE] = ACTIONS(1719),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(1723),
    [anon_sym_AT] = ACTIONS(1725),
    [anon_sym_BSLASH] = ACTIONS(1727),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4207),
    [anon_sym_case] = ACTIONS(1731),
    [anon_sym_mdo] = ACTIONS(1733),
    [anon_sym_do] = ACTIONS(1733),
    [anon_sym_7] = ACTIONS(1735),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1739),
  },
  [1998] = {
    [sym_integer] = STATE(4727),
    [sym__literal] = STATE(4727),
    [sym__unboxed_open] = STATE(786),
    [sym_variable] = STATE(4572),
    [sym_qualified_variable] = STATE(4572),
    [sym_constructor] = STATE(4245),
    [sym_qualified_constructor] = STATE(4556),
    [sym__qcon] = STATE(4572),
    [sym_con_unit] = STATE(4727),
    [sym_con_list] = STATE(4727),
    [sym_con_tuple] = STATE(4727),
    [sym_literal] = STATE(4959),
    [sym_exp_parens] = STATE(4959),
    [sym_exp_tuple] = STATE(4959),
    [sym_exp_unboxed_tuple] = STATE(4959),
    [sym_exp_unboxed_sum] = STATE(4959),
    [sym_exp_list] = STATE(4959),
    [sym_exp_arithmetic_sequence] = STATE(4959),
    [sym_exp_list_comprehension] = STATE(4959),
    [sym_exp_section_left] = STATE(4959),
    [sym_exp_section_right] = STATE(4959),
    [sym_exp_th_quoted_name] = STATE(4959),
    [sym_exp_type_application] = STATE(947),
    [sym_exp_lambda] = STATE(11982),
    [sym_exp_let] = STATE(18678),
    [sym_exp_let_in] = STATE(11982),
    [sym_exp_cond] = STATE(11982),
    [sym_exp_if_guard] = STATE(11982),
    [sym_exp_case] = STATE(11982),
    [sym_exp_lambda_case] = STATE(947),
    [sym__do_keyword] = STATE(18401),
    [sym_do_module] = STATE(18401),
    [sym_exp_do] = STATE(947),
    [sym_exp_negation] = STATE(11982),
    [sym_exp_record] = STATE(4959),
    [sym_exp_name] = STATE(4959),
    [sym_exp_projection_selector] = STATE(4959),
    [sym__aexp_projection] = STATE(4959),
    [sym_exp_projection] = STATE(4959),
    [sym__aexp] = STATE(947),
    [sym__exp_apply] = STATE(12092),
    [sym__fexp] = STATE(11982),
    [sym__lexp] = STATE(11982),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12712),
    [sym_splice] = STATE(4959),
    [sym_quasiquote] = STATE(4959),
    [sym__varid] = ACTIONS(2529),
    [sym_float] = ACTIONS(7),
    [sym_char] = ACTIONS(7),
    [sym_string] = ACTIONS(7),
    [sym__integer_literal] = ACTIONS(9),
    [sym__binary_literal] = ACTIONS(11),
    [sym__octal_literal] = ACTIONS(11),
    [sym__hex_literal] = ACTIONS(11),
    [anon_sym_LPAREN_POUND] = ACTIONS(2531),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2531),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2533),
    [anon_sym_DASH] = ACTIONS(4241),
    [anon_sym_LPAREN] = ACTIONS(2535),
    [sym_implicit_parid] = ACTIONS(2533),
    [sym__conid] = ACTIONS(4243),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_SQUOTE] = ACTIONS(2542),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2546),
    [anon_sym_AT] = ACTIONS(2548),
    [anon_sym_BSLASH] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4245),
    [anon_sym_case] = ACTIONS(2554),
    [anon_sym_mdo] = ACTIONS(2556),
    [anon_sym_do] = ACTIONS(2556),
    [anon_sym_7] = ACTIONS(69),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(73),
  },
  [1999] = {
    [sym_integer] = STATE(4558),
    [sym__literal] = STATE(4558),
    [sym__unboxed_open] = STATE(798),
    [sym_variable] = STATE(4824),
    [sym_qualified_variable] = STATE(4824),
    [sym_constructor] = STATE(4319),
    [sym_qualified_constructor] = STATE(4645),
    [sym__qcon] = STATE(4824),
    [sym_con_unit] = STATE(4558),
    [sym_con_list] = STATE(4558),
    [sym_con_tuple] = STATE(4558),
    [sym_literal] = STATE(4778),
    [sym_exp_parens] = STATE(4778),
    [sym_exp_tuple] = STATE(4778),
    [sym_exp_unboxed_tuple] = STATE(4778),
    [sym_exp_unboxed_sum] = STATE(4778),
    [sym_exp_list] = STATE(4778),
    [sym_exp_arithmetic_sequence] = STATE(4778),
    [sym_exp_list_comprehension] = STATE(4778),
    [sym_exp_section_left] = STATE(4778),
    [sym_exp_section_right] = STATE(4778),
    [sym_exp_th_quoted_name] = STATE(4778),
    [sym_exp_type_application] = STATE(875),
    [sym_exp_lambda] = STATE(11685),
    [sym_exp_let] = STATE(18765),
    [sym_exp_let_in] = STATE(11685),
    [sym_exp_cond] = STATE(11685),
    [sym_exp_if_guard] = STATE(11685),
    [sym_exp_case] = STATE(11685),
    [sym_exp_lambda_case] = STATE(875),
    [sym__do_keyword] = STATE(18183),
    [sym_do_module] = STATE(18183),
    [sym_exp_do] = STATE(875),
    [sym_exp_negation] = STATE(11685),
    [sym_exp_record] = STATE(4778),
    [sym_exp_name] = STATE(4778),
    [sym_exp_projection_selector] = STATE(4778),
    [sym__aexp_projection] = STATE(4778),
    [sym_exp_projection] = STATE(4778),
    [sym__aexp] = STATE(875),
    [sym__exp_apply] = STATE(11760),
    [sym__fexp] = STATE(11685),
    [sym__lexp] = STATE(11685),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12688),
    [sym_splice] = STATE(4778),
    [sym_quasiquote] = STATE(4778),
    [sym__varid] = ACTIONS(2407),
    [sym_float] = ACTIONS(2409),
    [sym_char] = ACTIONS(2409),
    [sym_string] = ACTIONS(2409),
    [sym__integer_literal] = ACTIONS(2411),
    [sym__binary_literal] = ACTIONS(2413),
    [sym__octal_literal] = ACTIONS(2413),
    [sym__hex_literal] = ACTIONS(2413),
    [anon_sym_LPAREN_POUND] = ACTIONS(2415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(2415),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(2417),
    [anon_sym_DASH] = ACTIONS(4209),
    [anon_sym_LPAREN] = ACTIONS(2419),
    [sym_implicit_parid] = ACTIONS(2417),
    [sym__conid] = ACTIONS(4211),
    [anon_sym_LBRACK] = ACTIONS(2425),
    [anon_sym_SQUOTE] = ACTIONS(2427),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(2431),
    [anon_sym_AT] = ACTIONS(2433),
    [anon_sym_BSLASH] = ACTIONS(2435),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(4213),
    [anon_sym_case] = ACTIONS(2439),
    [anon_sym_mdo] = ACTIONS(2441),
    [anon_sym_do] = ACTIONS(2441),
    [anon_sym_7] = ACTIONS(2443),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(2447),
  },
  [2000] = {
    [sym_integer] = STATE(4913),
    [sym__literal] = STATE(4913),
    [sym__unboxed_open] = STATE(747),
    [sym_variable] = STATE(4861),
    [sym_qualified_variable] = STATE(4861),
    [sym_constructor] = STATE(4400),
    [sym_qualified_constructor] = STATE(5105),
    [sym__qcon] = STATE(4861),
    [sym_con_unit] = STATE(4913),
    [sym_con_list] = STATE(4913),
    [sym_con_tuple] = STATE(4913),
    [sym_literal] = STATE(5786),
    [sym_exp_parens] = STATE(5786),
    [sym_exp_tuple] = STATE(5786),
    [sym_exp_unboxed_tuple] = STATE(5786),
    [sym_exp_unboxed_sum] = STATE(5786),
    [sym_exp_list] = STATE(5786),
    [sym_exp_arithmetic_sequence] = STATE(5786),
    [sym_exp_list_comprehension] = STATE(5786),
    [sym_exp_section_left] = STATE(5786),
    [sym_exp_section_right] = STATE(5786),
    [sym_exp_th_quoted_name] = STATE(5786),
    [sym_exp_type_application] = STATE(1283),
    [sym_exp_lambda] = STATE(12613),
    [sym_exp_let] = STATE(18321),
    [sym_exp_let_in] = STATE(12613),
    [sym_exp_cond] = STATE(12613),
    [sym_exp_if_guard] = STATE(12613),
    [sym_exp_case] = STATE(12613),
    [sym_exp_lambda_case] = STATE(1283),
    [sym__do_keyword] = STATE(18454),
    [sym_do_module] = STATE(18454),
    [sym_exp_do] = STATE(1283),
    [sym_exp_negation] = STATE(12613),
    [sym_exp_record] = STATE(5786),
    [sym_exp_name] = STATE(5786),
    [sym_exp_projection_selector] = STATE(5786),
    [sym__aexp_projection] = STATE(5786),
    [sym_exp_projection] = STATE(5786),
    [sym__aexp] = STATE(1283),
    [sym__exp_apply] = STATE(12708),
    [sym__fexp] = STATE(12613),
    [sym__lexp] = STATE(12613),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12665),
    [sym_splice] = STATE(5786),
    [sym_quasiquote] = STATE(5786),
    [sym__varid] = ACTIONS(3041),
    [sym_float] = ACTIONS(1362),
    [sym_char] = ACTIONS(1362),
    [sym_string] = ACTIONS(1362),
    [sym__integer_literal] = ACTIONS(1364),
    [sym__binary_literal] = ACTIONS(1366),
    [sym__octal_literal] = ACTIONS(1366),
    [sym__hex_literal] = ACTIONS(1366),
    [anon_sym_LPAREN_POUND] = ACTIONS(3043),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(3043),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(3045),
    [anon_sym_DASH] = ACTIONS(3047),
    [anon_sym_LPAREN] = ACTIONS(3049),
    [sym_implicit_parid] = ACTIONS(3045),
    [sym__conid] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(3053),
    [anon_sym_SQUOTE] = ACTIONS(3055),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(3057),
    [anon_sym_AT] = ACTIONS(3059),
    [anon_sym_BSLASH] = ACTIONS(3061),
    [anon_sym_let] = ACTIONS(41),
    [anon_sym_if] = ACTIONS(3063),
    [anon_sym_case] = ACTIONS(3065),
    [anon_sym_mdo] = ACTIONS(3067),
    [anon_sym_do] = ACTIONS(3067),
    [anon_sym_7] = ACTIONS(1380),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1382),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1384),
  },
  [2001] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(17223),
    [sym_class_datafam] = STATE(17223),
    [sym_class_tyfam] = STATE(17223),
    [sym__cdecl] = STATE(17223),
    [sym_inst_tyinst] = STATE(16897),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17223),
    [sym_fixity] = STATE(17223),
    [sym_signature] = STATE(17223),
    [sym__gendecl] = STATE(17223),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4941),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4943),
    [anon_sym_default] = ACTIONS(4945),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4947),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2002] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(18607),
    [sym_class_datafam] = STATE(18607),
    [sym_class_tyfam] = STATE(18607),
    [sym__cdecl] = STATE(18607),
    [sym_inst_tyinst] = STATE(18430),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18607),
    [sym_fixity] = STATE(18607),
    [sym_signature] = STATE(18607),
    [sym__gendecl] = STATE(18607),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4917),
    [anon_sym_RBRACE] = ACTIONS(4947),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4923),
    [anon_sym_default] = ACTIONS(4925),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2003] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(15346),
    [sym_class_datafam] = STATE(15346),
    [sym_class_tyfam] = STATE(15346),
    [sym__cdecl] = STATE(15346),
    [sym_inst_tyinst] = STATE(16897),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15346),
    [sym_fixity] = STATE(15346),
    [sym_signature] = STATE(15346),
    [sym__gendecl] = STATE(15346),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4941),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4943),
    [anon_sym_default] = ACTIONS(4945),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4937),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2004] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(18607),
    [sym_class_datafam] = STATE(18607),
    [sym_class_tyfam] = STATE(18607),
    [sym__cdecl] = STATE(18607),
    [sym_inst_tyinst] = STATE(18430),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18607),
    [sym_fixity] = STATE(18607),
    [sym_signature] = STATE(18607),
    [sym__gendecl] = STATE(18607),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4917),
    [anon_sym_RBRACE] = ACTIONS(4949),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4923),
    [anon_sym_default] = ACTIONS(4925),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2005] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(18607),
    [sym_class_datafam] = STATE(18607),
    [sym_class_tyfam] = STATE(18607),
    [sym__cdecl] = STATE(18607),
    [sym_inst_tyinst] = STATE(18430),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18607),
    [sym_fixity] = STATE(18607),
    [sym_signature] = STATE(18607),
    [sym__gendecl] = STATE(18607),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4917),
    [anon_sym_RBRACE] = ACTIONS(4951),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4923),
    [anon_sym_default] = ACTIONS(4925),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2006] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(18607),
    [sym_class_datafam] = STATE(18607),
    [sym_class_tyfam] = STATE(18607),
    [sym__cdecl] = STATE(18607),
    [sym_inst_tyinst] = STATE(18430),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18607),
    [sym_fixity] = STATE(18607),
    [sym_signature] = STATE(18607),
    [sym__gendecl] = STATE(18607),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4917),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4923),
    [anon_sym_default] = ACTIONS(4925),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2007] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(17223),
    [sym_class_datafam] = STATE(17223),
    [sym_class_tyfam] = STATE(17223),
    [sym__cdecl] = STATE(17223),
    [sym_inst_tyinst] = STATE(16897),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17223),
    [sym_fixity] = STATE(17223),
    [sym_signature] = STATE(17223),
    [sym__gendecl] = STATE(17223),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4941),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4943),
    [anon_sym_default] = ACTIONS(4945),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4953),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2008] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(17223),
    [sym_class_datafam] = STATE(17223),
    [sym_class_tyfam] = STATE(17223),
    [sym__cdecl] = STATE(17223),
    [sym_inst_tyinst] = STATE(16897),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17223),
    [sym_fixity] = STATE(17223),
    [sym_signature] = STATE(17223),
    [sym__gendecl] = STATE(17223),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4941),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4943),
    [anon_sym_default] = ACTIONS(4945),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4951),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2009] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(15039),
    [sym_class_datafam] = STATE(15039),
    [sym_class_tyfam] = STATE(15039),
    [sym__cdecl] = STATE(15039),
    [sym_inst_tyinst] = STATE(16897),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15039),
    [sym_fixity] = STATE(15039),
    [sym_signature] = STATE(15039),
    [sym__gendecl] = STATE(15039),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4941),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4943),
    [anon_sym_default] = ACTIONS(4945),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4933),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2010] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(18607),
    [sym_class_datafam] = STATE(18607),
    [sym_class_tyfam] = STATE(18607),
    [sym__cdecl] = STATE(18607),
    [sym_inst_tyinst] = STATE(18430),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18607),
    [sym_fixity] = STATE(18607),
    [sym_signature] = STATE(18607),
    [sym__gendecl] = STATE(18607),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4917),
    [anon_sym_RBRACE] = ACTIONS(4955),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4923),
    [anon_sym_default] = ACTIONS(4925),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2011] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(17223),
    [sym_class_datafam] = STATE(17223),
    [sym_class_tyfam] = STATE(17223),
    [sym__cdecl] = STATE(17223),
    [sym_inst_tyinst] = STATE(16897),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17223),
    [sym_fixity] = STATE(17223),
    [sym_signature] = STATE(17223),
    [sym__gendecl] = STATE(17223),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4941),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4943),
    [anon_sym_default] = ACTIONS(4945),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4955),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2012] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(14750),
    [sym_class_datafam] = STATE(14750),
    [sym_class_tyfam] = STATE(14750),
    [sym__cdecl] = STATE(14750),
    [sym_inst_tyinst] = STATE(16897),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(14750),
    [sym_fixity] = STATE(14750),
    [sym_signature] = STATE(14750),
    [sym__gendecl] = STATE(14750),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4941),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4943),
    [anon_sym_default] = ACTIONS(4945),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4919),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2013] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(18607),
    [sym_class_datafam] = STATE(18607),
    [sym_class_tyfam] = STATE(18607),
    [sym__cdecl] = STATE(18607),
    [sym_inst_tyinst] = STATE(18430),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18607),
    [sym_fixity] = STATE(18607),
    [sym_signature] = STATE(18607),
    [sym__gendecl] = STATE(18607),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4917),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4923),
    [anon_sym_default] = ACTIONS(4925),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2014] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(17223),
    [sym_class_datafam] = STATE(17223),
    [sym_class_tyfam] = STATE(17223),
    [sym__cdecl] = STATE(17223),
    [sym_inst_tyinst] = STATE(16897),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17223),
    [sym_fixity] = STATE(17223),
    [sym_signature] = STATE(17223),
    [sym__gendecl] = STATE(17223),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4941),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4943),
    [anon_sym_default] = ACTIONS(4945),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4949),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2015] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(17223),
    [sym_class_datafam] = STATE(17223),
    [sym_class_tyfam] = STATE(17223),
    [sym__cdecl] = STATE(17223),
    [sym_inst_tyinst] = STATE(16897),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17223),
    [sym_fixity] = STATE(17223),
    [sym_signature] = STATE(17223),
    [sym__gendecl] = STATE(17223),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4941),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4943),
    [anon_sym_default] = ACTIONS(4945),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4957),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2016] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(17223),
    [sym_class_datafam] = STATE(17223),
    [sym_class_tyfam] = STATE(17223),
    [sym__cdecl] = STATE(17223),
    [sym_inst_tyinst] = STATE(16897),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17223),
    [sym_fixity] = STATE(17223),
    [sym_signature] = STATE(17223),
    [sym__gendecl] = STATE(17223),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4941),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4943),
    [anon_sym_default] = ACTIONS(4945),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2017] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_default_signature] = STATE(18607),
    [sym_class_datafam] = STATE(18607),
    [sym_class_tyfam] = STATE(18607),
    [sym__cdecl] = STATE(18607),
    [sym_inst_tyinst] = STATE(18430),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18607),
    [sym_fixity] = STATE(18607),
    [sym_signature] = STATE(18607),
    [sym__gendecl] = STATE(18607),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(4917),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_data] = ACTIONS(4923),
    [anon_sym_default] = ACTIONS(4925),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2018] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7160),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13919),
    [sym__typed_pat] = STATE(13919),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(14699),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13947),
    [sym_function] = STATE(14927),
    [sym_fixity] = STATE(14927),
    [sym_signature] = STATE(14927),
    [sym__gendecl] = STATE(14927),
    [sym__decl_fun] = STATE(14927),
    [sym__decl] = STATE(14927),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_in] = ACTIONS(4967),
    [anon_sym_infixl] = ACTIONS(4969),
    [anon_sym_infixr] = ACTIONS(4969),
    [anon_sym_infix] = ACTIONS(4969),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4971),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2019] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(15723),
    [sym_fixity] = STATE(15723),
    [sym_signature] = STATE(15723),
    [sym__gendecl] = STATE(15723),
    [sym__decl_fun] = STATE(15723),
    [sym__decl] = STATE(15723),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(4973),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4977),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2020] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(17279),
    [sym_fixity] = STATE(17279),
    [sym_signature] = STATE(17279),
    [sym__gendecl] = STATE(17279),
    [sym__decl_fun] = STATE(17279),
    [sym__decl] = STATE(17279),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(4979),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4981),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2021] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7160),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13919),
    [sym__typed_pat] = STATE(13919),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(14699),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13947),
    [sym_function] = STATE(14927),
    [sym_fixity] = STATE(14927),
    [sym_signature] = STATE(14927),
    [sym__gendecl] = STATE(14927),
    [sym__decl_fun] = STATE(14927),
    [sym__decl] = STATE(14927),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_in] = ACTIONS(4967),
    [anon_sym_infixl] = ACTIONS(4969),
    [anon_sym_infixr] = ACTIONS(4969),
    [anon_sym_infix] = ACTIONS(4969),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4983),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2022] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(15958),
    [sym_fixity] = STATE(15958),
    [sym_signature] = STATE(15958),
    [sym__gendecl] = STATE(15958),
    [sym__decl_fun] = STATE(15958),
    [sym__decl] = STATE(15958),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(4985),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4987),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2023] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(15685),
    [sym_fixity] = STATE(15685),
    [sym_signature] = STATE(15685),
    [sym__gendecl] = STATE(15685),
    [sym__decl_fun] = STATE(15685),
    [sym__decl] = STATE(15685),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(4989),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2024] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(15549),
    [sym_fixity] = STATE(15549),
    [sym_signature] = STATE(15549),
    [sym__gendecl] = STATE(15549),
    [sym__decl_fun] = STATE(15549),
    [sym__decl] = STATE(15549),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(4993),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4995),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2025] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(16347),
    [sym_fixity] = STATE(16347),
    [sym_signature] = STATE(16347),
    [sym__gendecl] = STATE(16347),
    [sym__decl_fun] = STATE(16347),
    [sym__decl] = STATE(16347),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(4997),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4999),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2026] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(15709),
    [sym_fixity] = STATE(15709),
    [sym_signature] = STATE(15709),
    [sym__gendecl] = STATE(15709),
    [sym__decl_fun] = STATE(15709),
    [sym__decl] = STATE(15709),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(5001),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5003),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2027] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7160),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13919),
    [sym__typed_pat] = STATE(13919),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(14699),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13947),
    [sym_function] = STATE(14400),
    [sym_fixity] = STATE(14400),
    [sym_signature] = STATE(14400),
    [sym__gendecl] = STATE(14400),
    [sym__decl_fun] = STATE(14400),
    [sym__decl] = STATE(14400),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_in] = ACTIONS(5005),
    [anon_sym_infixl] = ACTIONS(4969),
    [anon_sym_infixr] = ACTIONS(4969),
    [anon_sym_infix] = ACTIONS(4969),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5007),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2028] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(15866),
    [sym_fixity] = STATE(15866),
    [sym_signature] = STATE(15866),
    [sym__gendecl] = STATE(15866),
    [sym__decl_fun] = STATE(15866),
    [sym__decl] = STATE(15866),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(5009),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5011),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2029] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7160),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13919),
    [sym__typed_pat] = STATE(13919),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(14699),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13947),
    [sym_function] = STATE(14927),
    [sym_fixity] = STATE(14927),
    [sym_signature] = STATE(14927),
    [sym__gendecl] = STATE(14927),
    [sym__decl_fun] = STATE(14927),
    [sym__decl] = STATE(14927),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_in] = ACTIONS(5013),
    [anon_sym_infixl] = ACTIONS(4969),
    [anon_sym_infixr] = ACTIONS(4969),
    [anon_sym_infix] = ACTIONS(4969),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5015),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2030] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7160),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13919),
    [sym__typed_pat] = STATE(13919),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(14699),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13947),
    [sym_function] = STATE(14927),
    [sym_fixity] = STATE(14927),
    [sym_signature] = STATE(14927),
    [sym__gendecl] = STATE(14927),
    [sym__decl_fun] = STATE(14927),
    [sym__decl] = STATE(14927),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_in] = ACTIONS(5013),
    [anon_sym_infixl] = ACTIONS(4969),
    [anon_sym_infixr] = ACTIONS(4969),
    [anon_sym_infix] = ACTIONS(4969),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5017),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2031] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7160),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13919),
    [sym__typed_pat] = STATE(13919),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(14699),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13947),
    [sym_function] = STATE(14927),
    [sym_fixity] = STATE(14927),
    [sym_signature] = STATE(14927),
    [sym__gendecl] = STATE(14927),
    [sym__decl_fun] = STATE(14927),
    [sym__decl] = STATE(14927),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_in] = ACTIONS(5013),
    [anon_sym_infixl] = ACTIONS(4969),
    [anon_sym_infixr] = ACTIONS(4969),
    [anon_sym_infix] = ACTIONS(4969),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5019),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2032] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7160),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13919),
    [sym__typed_pat] = STATE(13919),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(14699),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13947),
    [sym_function] = STATE(14299),
    [sym_fixity] = STATE(14299),
    [sym_signature] = STATE(14299),
    [sym__gendecl] = STATE(14299),
    [sym__decl_fun] = STATE(14299),
    [sym__decl] = STATE(14299),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_in] = ACTIONS(5005),
    [anon_sym_infixl] = ACTIONS(4969),
    [anon_sym_infixr] = ACTIONS(4969),
    [anon_sym_infix] = ACTIONS(4969),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4977),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2033] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7160),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13919),
    [sym__typed_pat] = STATE(13919),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(14699),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13947),
    [sym_function] = STATE(14927),
    [sym_fixity] = STATE(14927),
    [sym_signature] = STATE(14927),
    [sym__gendecl] = STATE(14927),
    [sym__decl_fun] = STATE(14927),
    [sym__decl] = STATE(14927),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_in] = ACTIONS(4967),
    [anon_sym_infixl] = ACTIONS(4969),
    [anon_sym_infixr] = ACTIONS(4969),
    [anon_sym_infix] = ACTIONS(4969),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5021),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2034] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7160),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13919),
    [sym__typed_pat] = STATE(13919),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(14699),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13947),
    [sym_function] = STATE(14520),
    [sym_fixity] = STATE(14520),
    [sym_signature] = STATE(14520),
    [sym__gendecl] = STATE(14520),
    [sym__decl_fun] = STATE(14520),
    [sym__decl] = STATE(14520),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_in] = ACTIONS(5005),
    [anon_sym_infixl] = ACTIONS(4969),
    [anon_sym_infixr] = ACTIONS(4969),
    [anon_sym_infix] = ACTIONS(4969),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5011),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2035] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(15534),
    [sym_fixity] = STATE(15534),
    [sym_signature] = STATE(15534),
    [sym__gendecl] = STATE(15534),
    [sym__decl_fun] = STATE(15534),
    [sym__decl] = STATE(15534),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(5023),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5025),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2036] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4971),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2037] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2037),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym_type_parens] = STATE(2037),
    [sym_type_list] = STATE(2037),
    [sym_type_tuple] = STATE(2037),
    [sym__type_promotable_literal] = STATE(2037),
    [sym__type_promoted_literal] = STATE(2037),
    [sym__type_literal] = STATE(2037),
    [sym_type_name] = STATE(2037),
    [sym_type_star] = STATE(2037),
    [sym_type_unboxed_tuple] = STATE(2037),
    [sym_type_unboxed_sum] = STATE(2037),
    [sym__atype] = STATE(2037),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2037),
    [sym_quasiquote] = STATE(2037),
    [aux_sym_type_apply_repeat1] = STATE(2037),
    [sym__varid] = ACTIONS(5027),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(5032),
    [sym_char] = ACTIONS(5032),
    [sym_string] = ACTIONS(5032),
    [sym__integer_literal] = ACTIONS(5035),
    [sym__binary_literal] = ACTIONS(5038),
    [sym__octal_literal] = ACTIONS(5038),
    [sym__hex_literal] = ACTIONS(5038),
    [anon_sym_LPAREN_POUND] = ACTIONS(5041),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5041),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_3] = ACTIONS(5030),
    [anon_sym_LT_DASH] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5044),
    [anon_sym_RPAREN] = ACTIONS(5030),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(5047),
    [anon_sym_LBRACK] = ACTIONS(5050),
    [anon_sym_RBRACK] = ACTIONS(5030),
    [anon_sym_SQUOTE] = ACTIONS(5053),
    [anon_sym_STAR] = ACTIONS(5056),
    [anon_sym_6] = ACTIONS(5056),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_EQ] = ACTIONS(5059),
    [anon_sym_RBRACE] = ACTIONS(5030),
    [anon_sym_instance] = ACTIONS(5059),
    [anon_sym_using] = ACTIONS(5059),
    [anon_sym_then] = ACTIONS(5059),
    [anon_sym_else] = ACTIONS(5059),
    [anon_sym_of] = ACTIONS(5059),
    [anon_sym_deriving] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(5061),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5064),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5067),
  },
  [2038] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15988),
    [sym_fixity] = STATE(15988),
    [sym_signature] = STATE(15988),
    [sym__gendecl] = STATE(15988),
    [sym__decl_fun] = STATE(15988),
    [sym__decl] = STATE(15988),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5072),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2039] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5072),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2040] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15324),
    [sym_fixity] = STATE(15324),
    [sym_signature] = STATE(15324),
    [sym__gendecl] = STATE(15324),
    [sym__decl_fun] = STATE(15324),
    [sym__decl] = STATE(15324),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5011),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2041] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5074),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2042] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2065),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym_type_parens] = STATE(2065),
    [sym_type_list] = STATE(2065),
    [sym_type_tuple] = STATE(2065),
    [sym__type_promotable_literal] = STATE(2065),
    [sym__type_promoted_literal] = STATE(2065),
    [sym__type_literal] = STATE(2065),
    [sym_type_name] = STATE(2065),
    [sym_type_star] = STATE(2065),
    [sym_type_unboxed_tuple] = STATE(2065),
    [sym_type_unboxed_sum] = STATE(2065),
    [sym__atype] = STATE(2065),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2065),
    [sym_quasiquote] = STATE(2065),
    [aux_sym_type_apply_repeat1] = STATE(2065),
    [sym__varid] = ACTIONS(5076),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_3] = ACTIONS(5078),
    [anon_sym_LT_DASH] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5088),
    [anon_sym_RPAREN] = ACTIONS(5078),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(5090),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_RBRACK] = ACTIONS(5078),
    [anon_sym_SQUOTE] = ACTIONS(5095),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_EQ] = ACTIONS(5100),
    [anon_sym_RBRACE] = ACTIONS(5078),
    [anon_sym_instance] = ACTIONS(5100),
    [anon_sym_using] = ACTIONS(5100),
    [anon_sym_then] = ACTIONS(5100),
    [anon_sym_else] = ACTIONS(5100),
    [anon_sym_of] = ACTIONS(5100),
    [anon_sym_deriving] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2043] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15988),
    [sym_fixity] = STATE(15988),
    [sym_signature] = STATE(15988),
    [sym__gendecl] = STATE(15988),
    [sym__decl_fun] = STATE(15988),
    [sym__decl] = STATE(15988),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5108),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2044] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5110),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2045] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15041),
    [sym_fixity] = STATE(15041),
    [sym_signature] = STATE(15041),
    [sym__gendecl] = STATE(15041),
    [sym__decl_fun] = STATE(15041),
    [sym__decl] = STATE(15041),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4977),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2046] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5108),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2047] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7052),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13760),
    [sym__typed_pat] = STATE(13760),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16889),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13762),
    [sym_function] = STATE(14993),
    [sym_fixity] = STATE(14993),
    [sym_signature] = STATE(14993),
    [sym__gendecl] = STATE(14993),
    [sym__decl_fun] = STATE(14993),
    [sym__decl] = STATE(14993),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5112),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_in] = ACTIONS(5005),
    [anon_sym_infixl] = ACTIONS(5114),
    [anon_sym_infixr] = ACTIONS(5114),
    [anon_sym_infix] = ACTIONS(5114),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2048] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15988),
    [sym_fixity] = STATE(15988),
    [sym_signature] = STATE(15988),
    [sym__gendecl] = STATE(15988),
    [sym__decl_fun] = STATE(15988),
    [sym__decl] = STATE(15988),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5116),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2049] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5118),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2050] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15988),
    [sym_fixity] = STATE(15988),
    [sym_signature] = STATE(15988),
    [sym__gendecl] = STATE(15988),
    [sym__decl_fun] = STATE(15988),
    [sym__decl] = STATE(15988),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5120),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2051] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15362),
    [sym_fixity] = STATE(15362),
    [sym_signature] = STATE(15362),
    [sym__gendecl] = STATE(15362),
    [sym__decl_fun] = STATE(15362),
    [sym__decl] = STATE(15362),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4987),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2052] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5120),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2053] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5122),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2054] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5116),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2055] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15988),
    [sym_fixity] = STATE(15988),
    [sym_signature] = STATE(15988),
    [sym__gendecl] = STATE(15988),
    [sym__decl_fun] = STATE(15988),
    [sym__decl] = STATE(15988),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5110),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2056] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15988),
    [sym_fixity] = STATE(15988),
    [sym_signature] = STATE(15988),
    [sym__gendecl] = STATE(15988),
    [sym__decl_fun] = STATE(15988),
    [sym__decl] = STATE(15988),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4971),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2057] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5124),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2058] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7052),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13760),
    [sym__typed_pat] = STATE(13760),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16889),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13762),
    [sym_function] = STATE(16339),
    [sym_fixity] = STATE(16339),
    [sym_signature] = STATE(16339),
    [sym__gendecl] = STATE(16339),
    [sym__decl_fun] = STATE(16339),
    [sym__decl] = STATE(16339),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5112),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_in] = ACTIONS(5013),
    [anon_sym_infixl] = ACTIONS(5114),
    [anon_sym_infixr] = ACTIONS(5114),
    [anon_sym_infix] = ACTIONS(5114),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2059] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_3] = ACTIONS(5129),
    [anon_sym_LT_DASH] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_RBRACK] = ACTIONS(5129),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_EQ] = ACTIONS(5160),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_instance] = ACTIONS(5160),
    [anon_sym_using] = ACTIONS(5160),
    [anon_sym_then] = ACTIONS(5160),
    [anon_sym_else] = ACTIONS(5160),
    [anon_sym_of] = ACTIONS(5160),
    [anon_sym_deriving] = ACTIONS(5160),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2060] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5171),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2061] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(14768),
    [sym_fixity] = STATE(14768),
    [sym_signature] = STATE(14768),
    [sym__gendecl] = STATE(14768),
    [sym__decl_fun] = STATE(14768),
    [sym__decl] = STATE(14768),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4995),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2062] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15988),
    [sym_fixity] = STATE(15988),
    [sym_signature] = STATE(15988),
    [sym__gendecl] = STATE(15988),
    [sym__decl_fun] = STATE(15988),
    [sym__decl] = STATE(15988),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5171),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2063] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5173),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2064] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5175),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2065] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2037),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym_type_parens] = STATE(2037),
    [sym_type_list] = STATE(2037),
    [sym_type_tuple] = STATE(2037),
    [sym__type_promotable_literal] = STATE(2037),
    [sym__type_promoted_literal] = STATE(2037),
    [sym__type_literal] = STATE(2037),
    [sym_type_name] = STATE(2037),
    [sym_type_star] = STATE(2037),
    [sym_type_unboxed_tuple] = STATE(2037),
    [sym_type_unboxed_sum] = STATE(2037),
    [sym__atype] = STATE(2037),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2037),
    [sym_quasiquote] = STATE(2037),
    [aux_sym_type_apply_repeat1] = STATE(2037),
    [sym__varid] = ACTIONS(5076),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_3] = ACTIONS(5177),
    [anon_sym_LT_DASH] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5088),
    [anon_sym_RPAREN] = ACTIONS(5177),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(5179),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_RBRACK] = ACTIONS(5177),
    [anon_sym_SQUOTE] = ACTIONS(5182),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_EQ] = ACTIONS(5185),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_instance] = ACTIONS(5185),
    [anon_sym_using] = ACTIONS(5185),
    [anon_sym_then] = ACTIONS(5185),
    [anon_sym_else] = ACTIONS(5185),
    [anon_sym_of] = ACTIONS(5185),
    [anon_sym_deriving] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2066] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15988),
    [sym_fixity] = STATE(15988),
    [sym_signature] = STATE(15988),
    [sym__gendecl] = STATE(15988),
    [sym__decl_fun] = STATE(15988),
    [sym__decl] = STATE(15988),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5015),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2067] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5015),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2068] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15988),
    [sym_fixity] = STATE(15988),
    [sym_signature] = STATE(15988),
    [sym__gendecl] = STATE(15988),
    [sym__decl_fun] = STATE(15988),
    [sym__decl] = STATE(15988),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4983),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2069] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15033),
    [sym_fixity] = STATE(15033),
    [sym_signature] = STATE(15033),
    [sym__gendecl] = STATE(15033),
    [sym__decl_fun] = STATE(15033),
    [sym__decl] = STATE(15033),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(4981),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2070] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5017),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2071] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15988),
    [sym_fixity] = STATE(15988),
    [sym_signature] = STATE(15988),
    [sym__gendecl] = STATE(15988),
    [sym__decl_fun] = STATE(15988),
    [sym__decl] = STATE(15988),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5017),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2072] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(4983),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2073] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2074] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7052),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13760),
    [sym__typed_pat] = STATE(13760),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16889),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13762),
    [sym_function] = STATE(16339),
    [sym_fixity] = STATE(16339),
    [sym_signature] = STATE(16339),
    [sym__gendecl] = STATE(16339),
    [sym__decl_fun] = STATE(16339),
    [sym__decl] = STATE(16339),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5112),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_in] = ACTIONS(4967),
    [anon_sym_infixl] = ACTIONS(5114),
    [anon_sym_infixr] = ACTIONS(5114),
    [anon_sym_infix] = ACTIONS(5114),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2075] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym_RBRACE] = ACTIONS(5189),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2076] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7052),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13760),
    [sym__typed_pat] = STATE(13760),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16889),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13762),
    [sym_function] = STATE(16339),
    [sym_fixity] = STATE(16339),
    [sym_signature] = STATE(16339),
    [sym__gendecl] = STATE(16339),
    [sym__decl_fun] = STATE(16339),
    [sym__decl] = STATE(16339),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5112),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(5114),
    [anon_sym_infixr] = ACTIONS(5114),
    [anon_sym_infix] = ACTIONS(5114),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2077] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7072),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13945),
    [sym__typed_pat] = STATE(13945),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(16952),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15988),
    [sym_fixity] = STATE(15988),
    [sym_signature] = STATE(15988),
    [sym__gendecl] = STATE(15988),
    [sym__decl_fun] = STATE(15988),
    [sym__decl] = STATE(15988),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(5070),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(209),
    [anon_sym_infixr] = ACTIONS(209),
    [anon_sym_infix] = ACTIONS(209),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2078] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7238),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13838),
    [sym__typed_pat] = STATE(13838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(18114),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18560),
    [sym_fixity] = STATE(18560),
    [sym_signature] = STATE(18560),
    [sym__gendecl] = STATE(18560),
    [sym__decl_fun] = STATE(18560),
    [sym__decl] = STATE(18560),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4975),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(139),
    [anon_sym_infixr] = ACTIONS(139),
    [anon_sym_infix] = ACTIONS(139),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2079] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(456),
    [sym_variable] = STATE(7160),
    [sym_constructor] = STATE(3918),
    [sym_qualified_constructor] = STATE(4144),
    [sym__qcon] = STATE(7891),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(12624),
    [sym_pat_as] = STATE(10582),
    [sym_pat_parens] = STATE(10582),
    [sym_pat_tuple] = STATE(10582),
    [sym_pat_unboxed_tuple] = STATE(10582),
    [sym_pat_unboxed_sum] = STATE(10582),
    [sym_pat_list] = STATE(10582),
    [sym_pat_strict] = STATE(10582),
    [sym_pat_irrefutable] = STATE(10582),
    [sym_pat_negation] = STATE(10582),
    [sym_pat_name] = STATE(10582),
    [sym__pat_constructor] = STATE(2790),
    [sym_pat_wildcard] = STATE(10582),
    [sym_pat_record] = STATE(10582),
    [sym__apat] = STATE(10582),
    [sym_pat_apply] = STATE(10582),
    [sym__lpat] = STATE(10582),
    [sym_pat_infix] = STATE(11762),
    [sym__pat] = STATE(11762),
    [sym_pat_typed] = STATE(13919),
    [sym__typed_pat] = STATE(13919),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15129),
    [sym__funpat_infix] = STATE(17942),
    [sym__funpat] = STATE(14699),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13947),
    [sym_function] = STATE(14927),
    [sym_fixity] = STATE(14927),
    [sym_signature] = STATE(14927),
    [sym__gendecl] = STATE(14927),
    [sym__decl_fun] = STATE(14927),
    [sym__decl] = STATE(14927),
    [sym_splice] = STATE(10582),
    [sym_quasiquote] = STATE(10582),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(4959),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4959),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_LPAREN] = ACTIONS(4963),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(4965),
    [anon_sym__] = ACTIONS(33),
    [anon_sym_infixl] = ACTIONS(4969),
    [anon_sym_infixr] = ACTIONS(4969),
    [anon_sym_infix] = ACTIONS(4969),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
    [sym__strict] = ACTIONS(75),
    [sym__lazy] = ACTIONS(77),
  },
  [2080] = {
    [sym_integer] = STATE(4542),
    [sym__literal] = STATE(4542),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(4213),
    [sym_con_unit] = STATE(4542),
    [sym_con_list] = STATE(4542),
    [sym_con_tuple] = STATE(4542),
    [sym_qualified_type] = STATE(4722),
    [sym_tycon_arrow] = STATE(4722),
    [sym_type_literal] = STATE(2081),
    [sym__promoted_tycon] = STATE(4722),
    [sym_type_variable] = STATE(4722),
    [sym_annotated_type_variable] = STATE(4722),
    [sym_type_parens] = STATE(2081),
    [sym_type_list] = STATE(2081),
    [sym_type_tuple] = STATE(2081),
    [sym__type_promotable_literal] = STATE(2081),
    [sym__type_promoted_literal] = STATE(2081),
    [sym__type_literal] = STATE(2081),
    [sym_type_name] = STATE(2081),
    [sym_type_star] = STATE(2081),
    [sym_type_unboxed_tuple] = STATE(2081),
    [sym_type_unboxed_sum] = STATE(2081),
    [sym__atype] = STATE(2081),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14868),
    [sym_splice] = STATE(2081),
    [sym_quasiquote] = STATE(2081),
    [aux_sym_type_apply_repeat1] = STATE(2081),
    [sym__varid] = ACTIONS(5191),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(5193),
    [sym_char] = ACTIONS(5193),
    [sym_string] = ACTIONS(5193),
    [sym__integer_literal] = ACTIONS(5195),
    [sym__binary_literal] = ACTIONS(5197),
    [sym__octal_literal] = ACTIONS(5197),
    [sym__hex_literal] = ACTIONS(5197),
    [anon_sym_LPAREN_POUND] = ACTIONS(5199),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5199),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(5201),
    [anon_sym_RPAREN] = ACTIONS(5078),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(5203),
    [anon_sym_LBRACK] = ACTIONS(5206),
    [anon_sym_RBRACK] = ACTIONS(5078),
    [anon_sym_SQUOTE] = ACTIONS(5208),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(5211),
    [anon_sym_6] = ACTIONS(5211),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_RBRACE] = ACTIONS(5078),
    [anon_sym_using] = ACTIONS(5100),
    [anon_sym_then] = ACTIONS(5100),
    [anon_sym_else] = ACTIONS(5100),
    [anon_sym_of] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(5213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5215),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5217),
  },
  [2081] = {
    [sym_integer] = STATE(4542),
    [sym__literal] = STATE(4542),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(4213),
    [sym_con_unit] = STATE(4542),
    [sym_con_list] = STATE(4542),
    [sym_con_tuple] = STATE(4542),
    [sym_qualified_type] = STATE(4722),
    [sym_tycon_arrow] = STATE(4722),
    [sym_type_literal] = STATE(2083),
    [sym__promoted_tycon] = STATE(4722),
    [sym_type_variable] = STATE(4722),
    [sym_annotated_type_variable] = STATE(4722),
    [sym_type_parens] = STATE(2083),
    [sym_type_list] = STATE(2083),
    [sym_type_tuple] = STATE(2083),
    [sym__type_promotable_literal] = STATE(2083),
    [sym__type_promoted_literal] = STATE(2083),
    [sym__type_literal] = STATE(2083),
    [sym_type_name] = STATE(2083),
    [sym_type_star] = STATE(2083),
    [sym_type_unboxed_tuple] = STATE(2083),
    [sym_type_unboxed_sum] = STATE(2083),
    [sym__atype] = STATE(2083),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14868),
    [sym_splice] = STATE(2083),
    [sym_quasiquote] = STATE(2083),
    [aux_sym_type_apply_repeat1] = STATE(2083),
    [sym__varid] = ACTIONS(5191),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(5193),
    [sym_char] = ACTIONS(5193),
    [sym_string] = ACTIONS(5193),
    [sym__integer_literal] = ACTIONS(5195),
    [sym__binary_literal] = ACTIONS(5197),
    [sym__octal_literal] = ACTIONS(5197),
    [sym__hex_literal] = ACTIONS(5197),
    [anon_sym_LPAREN_POUND] = ACTIONS(5199),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5199),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(5201),
    [anon_sym_RPAREN] = ACTIONS(5177),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(5219),
    [anon_sym_LBRACK] = ACTIONS(5206),
    [anon_sym_RBRACK] = ACTIONS(5177),
    [anon_sym_SQUOTE] = ACTIONS(5222),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(5211),
    [anon_sym_6] = ACTIONS(5211),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_using] = ACTIONS(5185),
    [anon_sym_then] = ACTIONS(5185),
    [anon_sym_else] = ACTIONS(5185),
    [anon_sym_of] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(5213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5215),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5217),
  },
  [2082] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_RBRACK] = ACTIONS(5129),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_using] = ACTIONS(5160),
    [anon_sym_then] = ACTIONS(5160),
    [anon_sym_else] = ACTIONS(5160),
    [anon_sym_of] = ACTIONS(5160),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2083] = {
    [sym_integer] = STATE(4542),
    [sym__literal] = STATE(4542),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(4213),
    [sym_con_unit] = STATE(4542),
    [sym_con_list] = STATE(4542),
    [sym_con_tuple] = STATE(4542),
    [sym_qualified_type] = STATE(4722),
    [sym_tycon_arrow] = STATE(4722),
    [sym_type_literal] = STATE(2083),
    [sym__promoted_tycon] = STATE(4722),
    [sym_type_variable] = STATE(4722),
    [sym_annotated_type_variable] = STATE(4722),
    [sym_type_parens] = STATE(2083),
    [sym_type_list] = STATE(2083),
    [sym_type_tuple] = STATE(2083),
    [sym__type_promotable_literal] = STATE(2083),
    [sym__type_promoted_literal] = STATE(2083),
    [sym__type_literal] = STATE(2083),
    [sym_type_name] = STATE(2083),
    [sym_type_star] = STATE(2083),
    [sym_type_unboxed_tuple] = STATE(2083),
    [sym_type_unboxed_sum] = STATE(2083),
    [sym__atype] = STATE(2083),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14868),
    [sym_splice] = STATE(2083),
    [sym_quasiquote] = STATE(2083),
    [aux_sym_type_apply_repeat1] = STATE(2083),
    [sym__varid] = ACTIONS(5225),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(5228),
    [sym_char] = ACTIONS(5228),
    [sym_string] = ACTIONS(5228),
    [sym__integer_literal] = ACTIONS(5231),
    [sym__binary_literal] = ACTIONS(5234),
    [sym__octal_literal] = ACTIONS(5234),
    [sym__hex_literal] = ACTIONS(5234),
    [anon_sym_LPAREN_POUND] = ACTIONS(5237),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5237),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(5240),
    [anon_sym_RPAREN] = ACTIONS(5030),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(5243),
    [anon_sym_LBRACK] = ACTIONS(5246),
    [anon_sym_RBRACK] = ACTIONS(5030),
    [anon_sym_SQUOTE] = ACTIONS(5249),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(5252),
    [anon_sym_6] = ACTIONS(5252),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_RBRACE] = ACTIONS(5030),
    [anon_sym_using] = ACTIONS(5059),
    [anon_sym_then] = ACTIONS(5059),
    [anon_sym_else] = ACTIONS(5059),
    [anon_sym_of] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(5255),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5258),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5261),
  },
  [2084] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(15530),
    [sym_inst_tyinst] = STATE(15530),
    [sym__idecl] = STATE(15530),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(15530),
    [sym_signature] = STATE(15530),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(5264),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5266),
    [anon_sym_RBRACE] = ACTIONS(5268),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5270),
    [anon_sym_data] = ACTIONS(5272),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2085] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14596),
    [sym_forall] = STATE(2494),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_strict_type] = STATE(13929),
    [sym_lazy_type] = STATE(13929),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(13929),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2779),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_record_fields] = STATE(17408),
    [sym__gadt_fun] = STATE(17395),
    [sym__gadt_sig] = STATE(17395),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(5274),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5294),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
    [sym__strict] = ACTIONS(5302),
    [sym__lazy] = ACTIONS(5304),
  },
  [2086] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(16219),
    [sym_inst_tyinst] = STATE(16219),
    [sym__idecl] = STATE(16219),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(16219),
    [sym_signature] = STATE(16219),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(5306),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5266),
    [anon_sym_RBRACE] = ACTIONS(5308),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5270),
    [anon_sym_data] = ACTIONS(5272),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2087] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(2375),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14596),
    [sym_forall] = STATE(2577),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(16372),
    [sym_lazy_type] = STATE(16372),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9510),
    [sym__btype] = STATE(9510),
    [sym_type_infix] = STATE(15079),
    [sym__type_infix] = STATE(16372),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2814),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_data_constructor] = STATE(13643),
    [sym_data_constructor_infix] = STATE(13643),
    [sym_data_constructor_record] = STATE(13643),
    [sym_constructors] = STATE(13642),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5312),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5316),
    [sym__lazy] = ACTIONS(5318),
  },
  [2088] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_RBRACK] = ACTIONS(5129),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_using] = ACTIONS(5160),
    [anon_sym_then] = ACTIONS(5160),
    [anon_sym_else] = ACTIONS(5160),
    [anon_sym_of] = ACTIONS(5160),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2089] = {
    [sym_integer] = STATE(4881),
    [sym__literal] = STATE(4881),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(4828),
    [sym_con_unit] = STATE(4881),
    [sym_con_list] = STATE(4881),
    [sym_con_tuple] = STATE(4881),
    [sym_qualified_type] = STATE(4884),
    [sym_tycon_arrow] = STATE(4884),
    [sym_type_literal] = STATE(2089),
    [sym__promoted_tycon] = STATE(4884),
    [sym_type_variable] = STATE(4884),
    [sym_annotated_type_variable] = STATE(4884),
    [sym_type_parens] = STATE(2089),
    [sym_type_list] = STATE(2089),
    [sym_type_tuple] = STATE(2089),
    [sym__type_promotable_literal] = STATE(2089),
    [sym__type_promoted_literal] = STATE(2089),
    [sym__type_literal] = STATE(2089),
    [sym_type_name] = STATE(2089),
    [sym_type_star] = STATE(2089),
    [sym_type_unboxed_tuple] = STATE(2089),
    [sym_type_unboxed_sum] = STATE(2089),
    [sym__atype] = STATE(2089),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15214),
    [sym_splice] = STATE(2089),
    [sym_quasiquote] = STATE(2089),
    [aux_sym_type_apply_repeat1] = STATE(2089),
    [sym__varid] = ACTIONS(5320),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(5323),
    [sym_char] = ACTIONS(5323),
    [sym_string] = ACTIONS(5323),
    [sym__integer_literal] = ACTIONS(5326),
    [sym__binary_literal] = ACTIONS(5329),
    [sym__octal_literal] = ACTIONS(5329),
    [sym__hex_literal] = ACTIONS(5329),
    [anon_sym_LPAREN_POUND] = ACTIONS(5332),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5332),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(5335),
    [anon_sym_RPAREN] = ACTIONS(5030),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(5338),
    [anon_sym_LBRACK] = ACTIONS(5341),
    [anon_sym_RBRACK] = ACTIONS(5030),
    [anon_sym_SQUOTE] = ACTIONS(5344),
    [anon_sym_STAR] = ACTIONS(5347),
    [anon_sym_6] = ACTIONS(5347),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_RBRACE] = ACTIONS(5030),
    [anon_sym_using] = ACTIONS(5059),
    [anon_sym_then] = ACTIONS(5059),
    [anon_sym_else] = ACTIONS(5059),
    [anon_sym_of] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(5350),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5353),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5356),
  },
  [2090] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(2445),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14596),
    [sym_forall] = STATE(2554),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(16310),
    [sym_lazy_type] = STATE(16310),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9510),
    [sym__btype] = STATE(9510),
    [sym_type_infix] = STATE(15079),
    [sym__type_infix] = STATE(16310),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2806),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_data_constructor] = STATE(14151),
    [sym_data_constructor_infix] = STATE(14151),
    [sym_data_constructor_record] = STATE(14151),
    [sym_constructors] = STATE(14155),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5359),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5316),
    [sym__lazy] = ACTIONS(5318),
  },
  [2091] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14596),
    [sym_forall] = STATE(2488),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(14224),
    [sym_lazy_type] = STATE(14224),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(14224),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2778),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_record_fields] = STATE(15590),
    [sym__gadt_fun] = STATE(18279),
    [sym__gadt_sig] = STATE(18279),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_LBRACE] = ACTIONS(5294),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5363),
    [sym__lazy] = ACTIONS(5365),
  },
  [2092] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(15704),
    [sym_inst_tyinst] = STATE(15704),
    [sym__idecl] = STATE(15704),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(15704),
    [sym_signature] = STATE(15704),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(5367),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5266),
    [anon_sym_RBRACE] = ACTIONS(5369),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5270),
    [anon_sym_data] = ACTIONS(5272),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2093] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(2419),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14596),
    [sym_forall] = STATE(2531),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(16124),
    [sym_lazy_type] = STATE(16124),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9510),
    [sym__btype] = STATE(9510),
    [sym_type_infix] = STATE(15079),
    [sym__type_infix] = STATE(16124),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2807),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_data_constructor] = STATE(13860),
    [sym_data_constructor_infix] = STATE(13860),
    [sym_data_constructor_record] = STATE(13860),
    [sym_constructors] = STATE(13852),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5371),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5316),
    [sym__lazy] = ACTIONS(5318),
  },
  [2094] = {
    [sym_integer] = STATE(4881),
    [sym__literal] = STATE(4881),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(4828),
    [sym_con_unit] = STATE(4881),
    [sym_con_list] = STATE(4881),
    [sym_con_tuple] = STATE(4881),
    [sym_qualified_type] = STATE(4884),
    [sym_tycon_arrow] = STATE(4884),
    [sym_type_literal] = STATE(2095),
    [sym__promoted_tycon] = STATE(4884),
    [sym_type_variable] = STATE(4884),
    [sym_annotated_type_variable] = STATE(4884),
    [sym_type_parens] = STATE(2095),
    [sym_type_list] = STATE(2095),
    [sym_type_tuple] = STATE(2095),
    [sym__type_promotable_literal] = STATE(2095),
    [sym__type_promoted_literal] = STATE(2095),
    [sym__type_literal] = STATE(2095),
    [sym_type_name] = STATE(2095),
    [sym_type_star] = STATE(2095),
    [sym_type_unboxed_tuple] = STATE(2095),
    [sym_type_unboxed_sum] = STATE(2095),
    [sym__atype] = STATE(2095),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15214),
    [sym_splice] = STATE(2095),
    [sym_quasiquote] = STATE(2095),
    [aux_sym_type_apply_repeat1] = STATE(2095),
    [sym__varid] = ACTIONS(5373),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(5375),
    [sym_char] = ACTIONS(5375),
    [sym_string] = ACTIONS(5375),
    [sym__integer_literal] = ACTIONS(5377),
    [sym__binary_literal] = ACTIONS(5379),
    [sym__octal_literal] = ACTIONS(5379),
    [sym__hex_literal] = ACTIONS(5379),
    [anon_sym_LPAREN_POUND] = ACTIONS(5381),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5381),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(5383),
    [anon_sym_RPAREN] = ACTIONS(5078),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(5385),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_RBRACK] = ACTIONS(5078),
    [anon_sym_SQUOTE] = ACTIONS(5390),
    [anon_sym_STAR] = ACTIONS(5393),
    [anon_sym_6] = ACTIONS(5393),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_RBRACE] = ACTIONS(5078),
    [anon_sym_using] = ACTIONS(5100),
    [anon_sym_then] = ACTIONS(5100),
    [anon_sym_else] = ACTIONS(5100),
    [anon_sym_of] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(5395),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5397),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5399),
  },
  [2095] = {
    [sym_integer] = STATE(4881),
    [sym__literal] = STATE(4881),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(4828),
    [sym_con_unit] = STATE(4881),
    [sym_con_list] = STATE(4881),
    [sym_con_tuple] = STATE(4881),
    [sym_qualified_type] = STATE(4884),
    [sym_tycon_arrow] = STATE(4884),
    [sym_type_literal] = STATE(2089),
    [sym__promoted_tycon] = STATE(4884),
    [sym_type_variable] = STATE(4884),
    [sym_annotated_type_variable] = STATE(4884),
    [sym_type_parens] = STATE(2089),
    [sym_type_list] = STATE(2089),
    [sym_type_tuple] = STATE(2089),
    [sym__type_promotable_literal] = STATE(2089),
    [sym__type_promoted_literal] = STATE(2089),
    [sym__type_literal] = STATE(2089),
    [sym_type_name] = STATE(2089),
    [sym_type_star] = STATE(2089),
    [sym_type_unboxed_tuple] = STATE(2089),
    [sym_type_unboxed_sum] = STATE(2089),
    [sym__atype] = STATE(2089),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15214),
    [sym_splice] = STATE(2089),
    [sym_quasiquote] = STATE(2089),
    [aux_sym_type_apply_repeat1] = STATE(2089),
    [sym__varid] = ACTIONS(5373),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(5375),
    [sym_char] = ACTIONS(5375),
    [sym_string] = ACTIONS(5375),
    [sym__integer_literal] = ACTIONS(5377),
    [sym__binary_literal] = ACTIONS(5379),
    [sym__octal_literal] = ACTIONS(5379),
    [sym__hex_literal] = ACTIONS(5379),
    [anon_sym_LPAREN_POUND] = ACTIONS(5381),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5381),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(5383),
    [anon_sym_RPAREN] = ACTIONS(5177),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(5401),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_RBRACK] = ACTIONS(5177),
    [anon_sym_SQUOTE] = ACTIONS(5404),
    [anon_sym_STAR] = ACTIONS(5393),
    [anon_sym_6] = ACTIONS(5393),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_using] = ACTIONS(5185),
    [anon_sym_then] = ACTIONS(5185),
    [anon_sym_else] = ACTIONS(5185),
    [anon_sym_of] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(5395),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5397),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5399),
  },
  [2096] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20161),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14212),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14212),
    [sym__type_context] = STATE(14212),
    [sym__type_fun] = STATE(14212),
    [sym__type] = STATE(14212),
    [sym__type_or_implicit] = STATE(14212),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5435),
  },
  [2097] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19074),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14071),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14071),
    [sym__type_context] = STATE(14071),
    [sym__type_fun] = STATE(14071),
    [sym__type] = STATE(14071),
    [sym__type_or_implicit] = STATE(14071),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5437),
  },
  [2098] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19326),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14492),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14492),
    [sym__type_context] = STATE(14492),
    [sym__type_fun] = STATE(14492),
    [sym__type] = STATE(14492),
    [sym__type_or_implicit] = STATE(14492),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5439),
  },
  [2099] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(14718),
    [sym_inst_tyinst] = STATE(14718),
    [sym__idecl] = STATE(14718),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(14718),
    [sym_signature] = STATE(14718),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5441),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5443),
    [anon_sym_data] = ACTIONS(5445),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5308),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2100] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20470),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14380),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14380),
    [sym__type_context] = STATE(14380),
    [sym__type_fun] = STATE(14380),
    [sym__type] = STATE(14380),
    [sym__type_or_implicit] = STATE(14380),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5447),
  },
  [2101] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19740),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14378),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14378),
    [sym__type_context] = STATE(14378),
    [sym__type_fun] = STATE(14378),
    [sym__type] = STATE(14378),
    [sym__type_or_implicit] = STATE(14378),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5449),
  },
  [2102] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(18065),
    [sym_inst_tyinst] = STATE(18065),
    [sym__idecl] = STATE(18065),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18065),
    [sym_signature] = STATE(18065),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5266),
    [anon_sym_RBRACE] = ACTIONS(5451),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5270),
    [anon_sym_data] = ACTIONS(5272),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2103] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19132),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14090),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14090),
    [sym__type_context] = STATE(14090),
    [sym__type_fun] = STATE(14090),
    [sym__type] = STATE(14090),
    [sym__type_or_implicit] = STATE(14090),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5453),
  },
  [2104] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20732),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(13996),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(13996),
    [sym__type_context] = STATE(13996),
    [sym__type_fun] = STATE(13996),
    [sym__type] = STATE(13996),
    [sym__type_or_implicit] = STATE(13996),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5455),
  },
  [2105] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(14706),
    [sym_inst_tyinst] = STATE(14706),
    [sym__idecl] = STATE(14706),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(14706),
    [sym_signature] = STATE(14706),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5441),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5443),
    [anon_sym_data] = ACTIONS(5445),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5268),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2106] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20216),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14601),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14601),
    [sym__type_context] = STATE(14601),
    [sym__type_fun] = STATE(14601),
    [sym__type] = STATE(14601),
    [sym__type_or_implicit] = STATE(14601),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5457),
  },
  [2107] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(17752),
    [sym_inst_tyinst] = STATE(17752),
    [sym__idecl] = STATE(17752),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17752),
    [sym_signature] = STATE(17752),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5441),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5443),
    [anon_sym_data] = ACTIONS(5445),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5459),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2108] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19324),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14359),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14359),
    [sym__type_context] = STATE(14359),
    [sym__type_fun] = STATE(14359),
    [sym__type] = STATE(14359),
    [sym__type_or_implicit] = STATE(14359),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5461),
  },
  [2109] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(18965),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14005),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14005),
    [sym__type_context] = STATE(14005),
    [sym__type_fun] = STATE(14005),
    [sym__type] = STATE(14005),
    [sym__type_or_implicit] = STATE(14005),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5463),
  },
  [2110] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20267),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14125),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14125),
    [sym__type_context] = STATE(14125),
    [sym__type_fun] = STATE(14125),
    [sym__type] = STATE(14125),
    [sym__type_or_implicit] = STATE(14125),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5465),
  },
  [2111] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20073),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14511),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14511),
    [sym__type_context] = STATE(14511),
    [sym__type_fun] = STATE(14511),
    [sym__type] = STATE(14511),
    [sym__type_or_implicit] = STATE(14511),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5467),
  },
  [2112] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(17752),
    [sym_inst_tyinst] = STATE(17752),
    [sym__idecl] = STATE(17752),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17752),
    [sym_signature] = STATE(17752),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5441),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5443),
    [anon_sym_data] = ACTIONS(5445),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5469),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2113] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20260),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14555),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14555),
    [sym__type_context] = STATE(14555),
    [sym__type_fun] = STATE(14555),
    [sym__type] = STATE(14555),
    [sym__type_or_implicit] = STATE(14555),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5471),
  },
  [2114] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19016),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14081),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14081),
    [sym__type_context] = STATE(14081),
    [sym__type_fun] = STATE(14081),
    [sym__type] = STATE(14081),
    [sym__type_or_implicit] = STATE(14081),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5473),
  },
  [2115] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(18065),
    [sym_inst_tyinst] = STATE(18065),
    [sym__idecl] = STATE(18065),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18065),
    [sym_signature] = STATE(18065),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5266),
    [anon_sym_RBRACE] = ACTIONS(5459),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5270),
    [anon_sym_data] = ACTIONS(5272),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2116] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(2445),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14596),
    [sym_forall] = STATE(2508),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(16310),
    [sym_lazy_type] = STATE(16310),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9510),
    [sym__btype] = STATE(9510),
    [sym_type_infix] = STATE(15079),
    [sym__type_infix] = STATE(16310),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2809),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_data_constructor] = STATE(14900),
    [sym_data_constructor_infix] = STATE(14900),
    [sym_data_constructor_record] = STATE(14900),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5359),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5316),
    [sym__lazy] = ACTIONS(5318),
  },
  [2117] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19560),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14217),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14217),
    [sym__type_context] = STATE(14217),
    [sym__type_fun] = STATE(14217),
    [sym__type] = STATE(14217),
    [sym__type_or_implicit] = STATE(14217),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5475),
  },
  [2118] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19899),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14337),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14337),
    [sym__type_context] = STATE(14337),
    [sym__type_fun] = STATE(14337),
    [sym__type] = STATE(14337),
    [sym__type_or_implicit] = STATE(14337),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5477),
  },
  [2119] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(18979),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14504),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14504),
    [sym__type_context] = STATE(14504),
    [sym__type_fun] = STATE(14504),
    [sym__type] = STATE(14504),
    [sym__type_or_implicit] = STATE(14504),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5479),
  },
  [2120] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(18987),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(13985),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(13985),
    [sym__type_context] = STATE(13985),
    [sym__type_fun] = STATE(13985),
    [sym__type] = STATE(13985),
    [sym__type_or_implicit] = STATE(13985),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5481),
  },
  [2121] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20971),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14015),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14015),
    [sym__type_context] = STATE(14015),
    [sym__type_fun] = STATE(14015),
    [sym__type] = STATE(14015),
    [sym__type_or_implicit] = STATE(14015),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5483),
  },
  [2122] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19801),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14595),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14595),
    [sym__type_context] = STATE(14595),
    [sym__type_fun] = STATE(14595),
    [sym__type] = STATE(14595),
    [sym__type_or_implicit] = STATE(14595),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5485),
  },
  [2123] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(18065),
    [sym_inst_tyinst] = STATE(18065),
    [sym__idecl] = STATE(18065),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18065),
    [sym_signature] = STATE(18065),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5266),
    [anon_sym_RBRACE] = ACTIONS(5487),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5270),
    [anon_sym_data] = ACTIONS(5272),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2124] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19405),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14505),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14505),
    [sym__type_context] = STATE(14505),
    [sym__type_fun] = STATE(14505),
    [sym__type] = STATE(14505),
    [sym__type_or_implicit] = STATE(14505),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5489),
  },
  [2125] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20666),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14032),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14032),
    [sym__type_context] = STATE(14032),
    [sym__type_fun] = STATE(14032),
    [sym__type] = STATE(14032),
    [sym__type_or_implicit] = STATE(14032),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5491),
  },
  [2126] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(17752),
    [sym_inst_tyinst] = STATE(17752),
    [sym__idecl] = STATE(17752),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17752),
    [sym_signature] = STATE(17752),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5441),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5443),
    [anon_sym_data] = ACTIONS(5445),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5487),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2127] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19518),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14348),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14348),
    [sym__type_context] = STATE(14348),
    [sym__type_fun] = STATE(14348),
    [sym__type] = STATE(14348),
    [sym__type_or_implicit] = STATE(14348),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5493),
  },
  [2128] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20315),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14517),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14517),
    [sym__type_context] = STATE(14517),
    [sym__type_fun] = STATE(14517),
    [sym__type] = STATE(14517),
    [sym__type_or_implicit] = STATE(14517),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5495),
  },
  [2129] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19978),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14202),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14202),
    [sym__type_context] = STATE(14202),
    [sym__type_fun] = STATE(14202),
    [sym__type] = STATE(14202),
    [sym__type_or_implicit] = STATE(14202),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5497),
  },
  [2130] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20353),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14114),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14114),
    [sym__type_context] = STATE(14114),
    [sym__type_fun] = STATE(14114),
    [sym__type] = STATE(14114),
    [sym__type_or_implicit] = STATE(14114),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5499),
  },
  [2131] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19700),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14394),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14394),
    [sym__type_context] = STATE(14394),
    [sym__type_fun] = STATE(14394),
    [sym__type] = STATE(14394),
    [sym__type_or_implicit] = STATE(14394),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5501),
  },
  [2132] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20014),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14503),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14503),
    [sym__type_context] = STATE(14503),
    [sym__type_fun] = STATE(14503),
    [sym__type] = STATE(14503),
    [sym__type_or_implicit] = STATE(14503),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5503),
  },
  [2133] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19241),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14127),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14127),
    [sym__type_context] = STATE(14127),
    [sym__type_fun] = STATE(14127),
    [sym__type] = STATE(14127),
    [sym__type_or_implicit] = STATE(14127),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5505),
  },
  [2134] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(18065),
    [sym_inst_tyinst] = STATE(18065),
    [sym__idecl] = STATE(18065),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18065),
    [sym_signature] = STATE(18065),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5266),
    [anon_sym_RBRACE] = ACTIONS(5507),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5270),
    [anon_sym_data] = ACTIONS(5272),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2135] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20953),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14003),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14003),
    [sym__type_context] = STATE(14003),
    [sym__type_fun] = STATE(14003),
    [sym__type] = STATE(14003),
    [sym__type_or_implicit] = STATE(14003),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5509),
  },
  [2136] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19952),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14292),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14292),
    [sym__type_context] = STATE(14292),
    [sym__type_fun] = STATE(14292),
    [sym__type] = STATE(14292),
    [sym__type_or_implicit] = STATE(14292),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5511),
  },
  [2137] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20507),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14099),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14099),
    [sym__type_context] = STATE(14099),
    [sym__type_fun] = STATE(14099),
    [sym__type] = STATE(14099),
    [sym__type_or_implicit] = STATE(14099),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5513),
  },
  [2138] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20955),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14058),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14058),
    [sym__type_context] = STATE(14058),
    [sym__type_fun] = STATE(14058),
    [sym__type] = STATE(14058),
    [sym__type_or_implicit] = STATE(14058),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5515),
  },
  [2139] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20141),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14021),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14021),
    [sym__type_context] = STATE(14021),
    [sym__type_fun] = STATE(14021),
    [sym__type] = STATE(14021),
    [sym__type_or_implicit] = STATE(14021),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5517),
  },
  [2140] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20462),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14106),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14106),
    [sym__type_context] = STATE(14106),
    [sym__type_fun] = STATE(14106),
    [sym__type] = STATE(14106),
    [sym__type_or_implicit] = STATE(14106),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5519),
  },
  [2141] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19893),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14213),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14213),
    [sym__type_context] = STATE(14213),
    [sym__type_fun] = STATE(14213),
    [sym__type] = STATE(14213),
    [sym__type_or_implicit] = STATE(14213),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5521),
  },
  [2142] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20983),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(13995),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(13995),
    [sym__type_context] = STATE(13995),
    [sym__type_fun] = STATE(13995),
    [sym__type] = STATE(13995),
    [sym__type_or_implicit] = STATE(13995),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5523),
  },
  [2143] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20015),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(13992),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(13992),
    [sym__type_context] = STATE(13992),
    [sym__type_fun] = STATE(13992),
    [sym__type] = STATE(13992),
    [sym__type_or_implicit] = STATE(13992),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5525),
  },
  [2144] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(17752),
    [sym_inst_tyinst] = STATE(17752),
    [sym__idecl] = STATE(17752),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17752),
    [sym_signature] = STATE(17752),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5441),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5443),
    [anon_sym_data] = ACTIONS(5445),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5507),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2145] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20932),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14107),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14107),
    [sym__type_context] = STATE(14107),
    [sym__type_fun] = STATE(14107),
    [sym__type] = STATE(14107),
    [sym__type_or_implicit] = STATE(14107),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5527),
  },
  [2146] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(18940),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14047),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14047),
    [sym__type_context] = STATE(14047),
    [sym__type_fun] = STATE(14047),
    [sym__type] = STATE(14047),
    [sym__type_or_implicit] = STATE(14047),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5529),
  },
  [2147] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20363),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14498),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14498),
    [sym__type_context] = STATE(14498),
    [sym__type_fun] = STATE(14498),
    [sym__type] = STATE(14498),
    [sym__type_or_implicit] = STATE(14498),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5531),
  },
  [2148] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19404),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14386),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14386),
    [sym__type_context] = STATE(14386),
    [sym__type_fun] = STATE(14386),
    [sym__type] = STATE(14386),
    [sym__type_or_implicit] = STATE(14386),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5533),
  },
  [2149] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(17752),
    [sym_inst_tyinst] = STATE(17752),
    [sym__idecl] = STATE(17752),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17752),
    [sym_signature] = STATE(17752),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5441),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5443),
    [anon_sym_data] = ACTIONS(5445),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5535),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2150] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19473),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14312),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14312),
    [sym__type_context] = STATE(14312),
    [sym__type_fun] = STATE(14312),
    [sym__type] = STATE(14312),
    [sym__type_or_implicit] = STATE(14312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5537),
  },
  [2151] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(18918),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14069),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14069),
    [sym__type_context] = STATE(14069),
    [sym__type_fun] = STATE(14069),
    [sym__type] = STATE(14069),
    [sym__type_or_implicit] = STATE(14069),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5539),
  },
  [2152] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(18065),
    [sym_inst_tyinst] = STATE(18065),
    [sym__idecl] = STATE(18065),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18065),
    [sym_signature] = STATE(18065),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5266),
    [anon_sym_RBRACE] = ACTIONS(5535),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5270),
    [anon_sym_data] = ACTIONS(5272),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2153] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20202),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14141),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14141),
    [sym__type_context] = STATE(14141),
    [sym__type_fun] = STATE(14141),
    [sym__type] = STATE(14141),
    [sym__type_or_implicit] = STATE(14141),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5541),
  },
  [2154] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19112),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14397),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14397),
    [sym__type_context] = STATE(14397),
    [sym__type_fun] = STATE(14397),
    [sym__type] = STATE(14397),
    [sym__type_or_implicit] = STATE(14397),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5543),
  },
  [2155] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20980),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(13988),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(13988),
    [sym__type_context] = STATE(13988),
    [sym__type_fun] = STATE(13988),
    [sym__type] = STATE(13988),
    [sym__type_or_implicit] = STATE(13988),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5545),
  },
  [2156] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19971),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14497),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14497),
    [sym__type_context] = STATE(14497),
    [sym__type_fun] = STATE(14497),
    [sym__type] = STATE(14497),
    [sym__type_or_implicit] = STATE(14497),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5547),
  },
  [2157] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19045),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14011),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14011),
    [sym__type_context] = STATE(14011),
    [sym__type_fun] = STATE(14011),
    [sym__type] = STATE(14011),
    [sym__type_or_implicit] = STATE(14011),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5549),
  },
  [2158] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20846),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14046),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14046),
    [sym__type_context] = STATE(14046),
    [sym__type_fun] = STATE(14046),
    [sym__type] = STATE(14046),
    [sym__type_or_implicit] = STATE(14046),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5551),
  },
  [2159] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20097),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14237),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14237),
    [sym__type_context] = STATE(14237),
    [sym__type_fun] = STATE(14237),
    [sym__type] = STATE(14237),
    [sym__type_or_implicit] = STATE(14237),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5553),
  },
  [2160] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20959),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14061),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14061),
    [sym__type_context] = STATE(14061),
    [sym__type_fun] = STATE(14061),
    [sym__type] = STATE(14061),
    [sym__type_or_implicit] = STATE(14061),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5555),
  },
  [2161] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20278),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14168),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14168),
    [sym__type_context] = STATE(14168),
    [sym__type_fun] = STATE(14168),
    [sym__type] = STATE(14168),
    [sym__type_or_implicit] = STATE(14168),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5557),
  },
  [2162] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19023),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14532),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14532),
    [sym__type_context] = STATE(14532),
    [sym__type_fun] = STATE(14532),
    [sym__type] = STATE(14532),
    [sym__type_or_implicit] = STATE(14532),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5559),
  },
  [2163] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20461),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14126),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14126),
    [sym__type_context] = STATE(14126),
    [sym__type_fun] = STATE(14126),
    [sym__type] = STATE(14126),
    [sym__type_or_implicit] = STATE(14126),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5561),
  },
  [2164] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19422),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14293),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14293),
    [sym__type_context] = STATE(14293),
    [sym__type_fun] = STATE(14293),
    [sym__type] = STATE(14293),
    [sym__type_or_implicit] = STATE(14293),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5563),
  },
  [2165] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20345),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14161),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14161),
    [sym__type_context] = STATE(14161),
    [sym__type_fun] = STATE(14161),
    [sym__type] = STATE(14161),
    [sym__type_or_implicit] = STATE(14161),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5565),
  },
  [2166] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19173),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14574),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14574),
    [sym__type_context] = STATE(14574),
    [sym__type_fun] = STATE(14574),
    [sym__type] = STATE(14574),
    [sym__type_or_implicit] = STATE(14574),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5567),
  },
  [2167] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20129),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14153),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14153),
    [sym__type_context] = STATE(14153),
    [sym__type_fun] = STATE(14153),
    [sym__type] = STATE(14153),
    [sym__type_or_implicit] = STATE(14153),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5569),
  },
  [2168] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20865),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14201),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14201),
    [sym__type_context] = STATE(14201),
    [sym__type_fun] = STATE(14201),
    [sym__type] = STATE(14201),
    [sym__type_or_implicit] = STATE(14201),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5571),
  },
  [2169] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20446),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14478),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14478),
    [sym__type_context] = STATE(14478),
    [sym__type_fun] = STATE(14478),
    [sym__type] = STATE(14478),
    [sym__type_or_implicit] = STATE(14478),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5573),
  },
  [2170] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20473),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14122),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14122),
    [sym__type_context] = STATE(14122),
    [sym__type_fun] = STATE(14122),
    [sym__type] = STATE(14122),
    [sym__type_or_implicit] = STATE(14122),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5575),
  },
  [2171] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20771),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14063),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14063),
    [sym__type_context] = STATE(14063),
    [sym__type_fun] = STATE(14063),
    [sym__type] = STATE(14063),
    [sym__type_or_implicit] = STATE(14063),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5577),
  },
  [2172] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19710),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14227),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14227),
    [sym__type_context] = STATE(14227),
    [sym__type_fun] = STATE(14227),
    [sym__type] = STATE(14227),
    [sym__type_or_implicit] = STATE(14227),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5579),
  },
  [2173] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19234),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14369),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14369),
    [sym__type_context] = STATE(14369),
    [sym__type_fun] = STATE(14369),
    [sym__type] = STATE(14369),
    [sym__type_or_implicit] = STATE(14369),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5581),
  },
  [2174] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(18961),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14004),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14004),
    [sym__type_context] = STATE(14004),
    [sym__type_fun] = STATE(14004),
    [sym__type] = STATE(14004),
    [sym__type_or_implicit] = STATE(14004),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5583),
  },
  [2175] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19625),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14385),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14385),
    [sym__type_context] = STATE(14385),
    [sym__type_fun] = STATE(14385),
    [sym__type] = STATE(14385),
    [sym__type_or_implicit] = STATE(14385),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5585),
  },
  [2176] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20547),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14447),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14447),
    [sym__type_context] = STATE(14447),
    [sym__type_fun] = STATE(14447),
    [sym__type] = STATE(14447),
    [sym__type_or_implicit] = STATE(14447),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5587),
  },
  [2177] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19749),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14245),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14245),
    [sym__type_context] = STATE(14245),
    [sym__type_fun] = STATE(14245),
    [sym__type] = STATE(14245),
    [sym__type_or_implicit] = STATE(14245),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5589),
  },
  [2178] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19102),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14092),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14092),
    [sym__type_context] = STATE(14092),
    [sym__type_fun] = STATE(14092),
    [sym__type] = STATE(14092),
    [sym__type_or_implicit] = STATE(14092),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5591),
  },
  [2179] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19966),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14181),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14181),
    [sym__type_context] = STATE(14181),
    [sym__type_fun] = STATE(14181),
    [sym__type] = STATE(14181),
    [sym__type_or_implicit] = STATE(14181),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5593),
  },
  [2180] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19630),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14426),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14426),
    [sym__type_context] = STATE(14426),
    [sym__type_fun] = STATE(14426),
    [sym__type] = STATE(14426),
    [sym__type_or_implicit] = STATE(14426),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5595),
  },
  [2181] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19907),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14481),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14481),
    [sym__type_context] = STATE(14481),
    [sym__type_fun] = STATE(14481),
    [sym__type] = STATE(14481),
    [sym__type_or_implicit] = STATE(14481),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5597),
  },
  [2182] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20611),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14425),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14425),
    [sym__type_context] = STATE(14425),
    [sym__type_fun] = STATE(14425),
    [sym__type] = STATE(14425),
    [sym__type_or_implicit] = STATE(14425),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5599),
  },
  [2183] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20519),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14452),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14452),
    [sym__type_context] = STATE(14452),
    [sym__type_fun] = STATE(14452),
    [sym__type] = STATE(14452),
    [sym__type_or_implicit] = STATE(14452),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5601),
  },
  [2184] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20235),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14195),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14195),
    [sym__type_context] = STATE(14195),
    [sym__type_fun] = STATE(14195),
    [sym__type] = STATE(14195),
    [sym__type_or_implicit] = STATE(14195),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5603),
  },
  [2185] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19217),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14109),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14109),
    [sym__type_context] = STATE(14109),
    [sym__type_fun] = STATE(14109),
    [sym__type] = STATE(14109),
    [sym__type_or_implicit] = STATE(14109),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5605),
  },
  [2186] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19460),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14315),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14315),
    [sym__type_context] = STATE(14315),
    [sym__type_fun] = STATE(14315),
    [sym__type] = STATE(14315),
    [sym__type_or_implicit] = STATE(14315),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5607),
  },
  [2187] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20122),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14513),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14513),
    [sym__type_context] = STATE(14513),
    [sym__type_fun] = STATE(14513),
    [sym__type] = STATE(14513),
    [sym__type_or_implicit] = STATE(14513),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5609),
  },
  [2188] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19032),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14173),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14173),
    [sym__type_context] = STATE(14173),
    [sym__type_fun] = STATE(14173),
    [sym__type] = STATE(14173),
    [sym__type_or_implicit] = STATE(14173),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5611),
  },
  [2189] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20729),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14281),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14281),
    [sym__type_context] = STATE(14281),
    [sym__type_fun] = STATE(14281),
    [sym__type] = STATE(14281),
    [sym__type_or_implicit] = STATE(14281),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5613),
  },
  [2190] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19574),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14356),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14356),
    [sym__type_context] = STATE(14356),
    [sym__type_fun] = STATE(14356),
    [sym__type] = STATE(14356),
    [sym__type_or_implicit] = STATE(14356),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5615),
  },
  [2191] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19920),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14308),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14308),
    [sym__type_context] = STATE(14308),
    [sym__type_fun] = STATE(14308),
    [sym__type] = STATE(14308),
    [sym__type_or_implicit] = STATE(14308),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5617),
  },
  [2192] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19671),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14256),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14256),
    [sym__type_context] = STATE(14256),
    [sym__type_fun] = STATE(14256),
    [sym__type] = STATE(14256),
    [sym__type_or_implicit] = STATE(14256),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5619),
  },
  [2193] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(2375),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14596),
    [sym_forall] = STATE(2540),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(16372),
    [sym_lazy_type] = STATE(16372),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9510),
    [sym__btype] = STATE(9510),
    [sym_type_infix] = STATE(15079),
    [sym__type_infix] = STATE(16372),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2791),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_data_constructor] = STATE(14278),
    [sym_data_constructor_infix] = STATE(14278),
    [sym_data_constructor_record] = STATE(14278),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5312),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5316),
    [sym__lazy] = ACTIONS(5318),
  },
  [2194] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19858),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14346),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14346),
    [sym__type_context] = STATE(14346),
    [sym__type_fun] = STATE(14346),
    [sym__type] = STATE(14346),
    [sym__type_or_implicit] = STATE(14346),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5621),
  },
  [2195] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(2419),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14596),
    [sym_forall] = STATE(2546),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(16124),
    [sym_lazy_type] = STATE(16124),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9510),
    [sym__btype] = STATE(9510),
    [sym_type_infix] = STATE(15079),
    [sym__type_infix] = STATE(16124),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2812),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_data_constructor] = STATE(14376),
    [sym_data_constructor_infix] = STATE(14376),
    [sym_data_constructor_record] = STATE(14376),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5371),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5316),
    [sym__lazy] = ACTIONS(5318),
  },
  [2196] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19375),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14268),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14268),
    [sym__type_context] = STATE(14268),
    [sym__type_fun] = STATE(14268),
    [sym__type] = STATE(14268),
    [sym__type_or_implicit] = STATE(14268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5623),
  },
  [2197] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19854),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14469),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14469),
    [sym__type_context] = STATE(14469),
    [sym__type_fun] = STATE(14469),
    [sym__type] = STATE(14469),
    [sym__type_or_implicit] = STATE(14469),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5625),
  },
  [2198] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(18938),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14464),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14464),
    [sym__type_context] = STATE(14464),
    [sym__type_fun] = STATE(14464),
    [sym__type] = STATE(14464),
    [sym__type_or_implicit] = STATE(14464),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5627),
  },
  [2199] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19142),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14585),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14585),
    [sym__type_context] = STATE(14585),
    [sym__type_fun] = STATE(14585),
    [sym__type] = STATE(14585),
    [sym__type_or_implicit] = STATE(14585),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5629),
  },
  [2200] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19161),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14094),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14094),
    [sym__type_context] = STATE(14094),
    [sym__type_fun] = STATE(14094),
    [sym__type] = STATE(14094),
    [sym__type_or_implicit] = STATE(14094),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5631),
  },
  [2201] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19690),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14409),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14409),
    [sym__type_context] = STATE(14409),
    [sym__type_fun] = STATE(14409),
    [sym__type] = STATE(14409),
    [sym__type_or_implicit] = STATE(14409),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5633),
  },
  [2202] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19946),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14482),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14482),
    [sym__type_context] = STATE(14482),
    [sym__type_fun] = STATE(14482),
    [sym__type] = STATE(14482),
    [sym__type_or_implicit] = STATE(14482),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5635),
  },
  [2203] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19332),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14265),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14265),
    [sym__type_context] = STATE(14265),
    [sym__type_fun] = STATE(14265),
    [sym__type] = STATE(14265),
    [sym__type_or_implicit] = STATE(14265),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5637),
  },
  [2204] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19177),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14143),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14143),
    [sym__type_context] = STATE(14143),
    [sym__type_fun] = STATE(14143),
    [sym__type] = STATE(14143),
    [sym__type_or_implicit] = STATE(14143),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5639),
  },
  [2205] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20587),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14091),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14091),
    [sym__type_context] = STATE(14091),
    [sym__type_fun] = STATE(14091),
    [sym__type] = STATE(14091),
    [sym__type_or_implicit] = STATE(14091),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5641),
  },
  [2206] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19688),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14463),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14463),
    [sym__type_context] = STATE(14463),
    [sym__type_fun] = STATE(14463),
    [sym__type] = STATE(14463),
    [sym__type_or_implicit] = STATE(14463),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5643),
  },
  [2207] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20728),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14567),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14567),
    [sym__type_context] = STATE(14567),
    [sym__type_fun] = STATE(14567),
    [sym__type] = STATE(14567),
    [sym__type_or_implicit] = STATE(14567),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5645),
  },
  [2208] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19752),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14436),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14436),
    [sym__type_context] = STATE(14436),
    [sym__type_fun] = STATE(14436),
    [sym__type] = STATE(14436),
    [sym__type_or_implicit] = STATE(14436),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5647),
  },
  [2209] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19784),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14234),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14234),
    [sym__type_context] = STATE(14234),
    [sym__type_fun] = STATE(14234),
    [sym__type] = STATE(14234),
    [sym__type_or_implicit] = STATE(14234),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5649),
  },
  [2210] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20457),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14355),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14355),
    [sym__type_context] = STATE(14355),
    [sym__type_fun] = STATE(14355),
    [sym__type] = STATE(14355),
    [sym__type_or_implicit] = STATE(14355),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5651),
  },
  [2211] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20719),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14075),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14075),
    [sym__type_context] = STATE(14075),
    [sym__type_fun] = STATE(14075),
    [sym__type] = STATE(14075),
    [sym__type_or_implicit] = STATE(14075),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5653),
  },
  [2212] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19603),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14272),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14272),
    [sym__type_context] = STATE(14272),
    [sym__type_fun] = STATE(14272),
    [sym__type] = STATE(14272),
    [sym__type_or_implicit] = STATE(14272),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5655),
  },
  [2213] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20773),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14364),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14364),
    [sym__type_context] = STATE(14364),
    [sym__type_fun] = STATE(14364),
    [sym__type] = STATE(14364),
    [sym__type_or_implicit] = STATE(14364),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5657),
  },
  [2214] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19242),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14226),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14226),
    [sym__type_context] = STATE(14226),
    [sym__type_fun] = STATE(14226),
    [sym__type] = STATE(14226),
    [sym__type_or_implicit] = STATE(14226),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5659),
  },
  [2215] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20897),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14146),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14146),
    [sym__type_context] = STATE(14146),
    [sym__type_fun] = STATE(14146),
    [sym__type] = STATE(14146),
    [sym__type_or_implicit] = STATE(14146),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5661),
  },
  [2216] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19519),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14472),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14472),
    [sym__type_context] = STATE(14472),
    [sym__type_fun] = STATE(14472),
    [sym__type] = STATE(14472),
    [sym__type_or_implicit] = STATE(14472),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5663),
  },
  [2217] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(18065),
    [sym_inst_tyinst] = STATE(18065),
    [sym__idecl] = STATE(18065),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18065),
    [sym_signature] = STATE(18065),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5266),
    [anon_sym_RBRACE] = ACTIONS(5469),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5270),
    [anon_sym_data] = ACTIONS(5272),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2218] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20816),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(13982),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(13982),
    [sym__type_context] = STATE(13982),
    [sym__type_fun] = STATE(13982),
    [sym__type] = STATE(13982),
    [sym__type_or_implicit] = STATE(13982),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5665),
  },
  [2219] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19290),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14255),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14255),
    [sym__type_context] = STATE(14255),
    [sym__type_fun] = STATE(14255),
    [sym__type] = STATE(14255),
    [sym__type_or_implicit] = STATE(14255),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5667),
  },
  [2220] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(15023),
    [sym_inst_tyinst] = STATE(15023),
    [sym__idecl] = STATE(15023),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(15023),
    [sym_signature] = STATE(15023),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5441),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5443),
    [anon_sym_data] = ACTIONS(5445),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5369),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2221] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20174),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14522),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14522),
    [sym__type_context] = STATE(14522),
    [sym__type_fun] = STATE(14522),
    [sym__type] = STATE(14522),
    [sym__type_or_implicit] = STATE(14522),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5669),
  },
  [2222] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19800),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14460),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14460),
    [sym__type_context] = STATE(14460),
    [sym__type_fun] = STATE(14460),
    [sym__type] = STATE(14460),
    [sym__type_or_implicit] = STATE(14460),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5671),
  },
  [2223] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19254),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14538),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14538),
    [sym__type_context] = STATE(14538),
    [sym__type_fun] = STATE(14538),
    [sym__type] = STATE(14538),
    [sym__type_or_implicit] = STATE(14538),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5673),
  },
  [2224] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(17752),
    [sym_inst_tyinst] = STATE(17752),
    [sym__idecl] = STATE(17752),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17752),
    [sym_signature] = STATE(17752),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5441),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5443),
    [anon_sym_data] = ACTIONS(5445),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_end] = ACTIONS(5451),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2225] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(20595),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14067),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14067),
    [sym__type_context] = STATE(14067),
    [sym__type_fun] = STATE(14067),
    [sym__type] = STATE(14067),
    [sym__type_or_implicit] = STATE(14067),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5675),
  },
  [2226] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19103),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14089),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14089),
    [sym__type_context] = STATE(14089),
    [sym__type_fun] = STATE(14089),
    [sym__type] = STATE(14089),
    [sym__type_or_implicit] = STATE(14089),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5677),
  },
  [2227] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_sum] = STATE(19190),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14096),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14096),
    [sym__type_context] = STATE(14096),
    [sym__type_fun] = STATE(14096),
    [sym__type] = STATE(14096),
    [sym__type_or_implicit] = STATE(14096),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
    [sym__unboxed_close] = ACTIONS(5679),
  },
  [2228] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15950),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15950),
    [sym__type_context] = STATE(15950),
    [sym__type_fun] = STATE(15950),
    [sym__type] = STATE(15950),
    [sym__type_or_implicit] = STATE(15950),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5681),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2229] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15811),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15811),
    [sym__type_context] = STATE(15811),
    [sym__type_fun] = STATE(15811),
    [sym__type] = STATE(15811),
    [sym__type_or_implicit] = STATE(15811),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1268),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2230] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16045),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16045),
    [sym__type_context] = STATE(16045),
    [sym__type_fun] = STATE(16045),
    [sym__type] = STATE(16045),
    [sym__type_or_implicit] = STATE(16045),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1280),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2231] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17695),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17695),
    [sym__type_context] = STATE(17695),
    [sym__type_fun] = STATE(17695),
    [sym__type] = STATE(17695),
    [sym__type_or_implicit] = STATE(17695),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5683),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2232] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17173),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17173),
    [sym__type_context] = STATE(17173),
    [sym__type_fun] = STATE(17173),
    [sym__type] = STATE(17173),
    [sym__type_or_implicit] = STATE(17173),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3738),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2233] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17735),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17735),
    [sym__type_context] = STATE(17735),
    [sym__type_fun] = STATE(17735),
    [sym__type] = STATE(17735),
    [sym__type_or_implicit] = STATE(17735),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(4017),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2234] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17063),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17063),
    [sym__type_context] = STATE(17063),
    [sym__type_fun] = STATE(17063),
    [sym__type] = STATE(17063),
    [sym__type_or_implicit] = STATE(17063),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5685),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2235] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15541),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15541),
    [sym__type_context] = STATE(15541),
    [sym__type_fun] = STATE(15541),
    [sym__type] = STATE(15541),
    [sym__type_or_implicit] = STATE(15541),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3366),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2236] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15570),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15570),
    [sym__type_context] = STATE(15570),
    [sym__type_fun] = STATE(15570),
    [sym__type] = STATE(15570),
    [sym__type_or_implicit] = STATE(15570),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2237] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16710),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16710),
    [sym__type_context] = STATE(16710),
    [sym__type_fun] = STATE(16710),
    [sym__type] = STATE(16710),
    [sym__type_or_implicit] = STATE(16710),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1348),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2238] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15999),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15999),
    [sym__type_context] = STATE(15999),
    [sym__type_fun] = STATE(15999),
    [sym__type] = STATE(15999),
    [sym__type_or_implicit] = STATE(15999),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5687),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2239] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17675),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17675),
    [sym__type_context] = STATE(17675),
    [sym__type_fun] = STATE(17675),
    [sym__type] = STATE(17675),
    [sym__type_or_implicit] = STATE(17675),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5689),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2240] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15902),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15902),
    [sym__type_context] = STATE(15902),
    [sym__type_fun] = STATE(15902),
    [sym__type] = STATE(15902),
    [sym__type_or_implicit] = STATE(15902),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1282),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2241] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16486),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16486),
    [sym__type_context] = STATE(16486),
    [sym__type_fun] = STATE(16486),
    [sym__type] = STATE(16486),
    [sym__type_or_implicit] = STATE(16486),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5691),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2242] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17022),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17022),
    [sym__type_context] = STATE(17022),
    [sym__type_fun] = STATE(17022),
    [sym__type] = STATE(17022),
    [sym__type_or_implicit] = STATE(17022),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3908),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2243] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16520),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16520),
    [sym__type_context] = STATE(16520),
    [sym__type_fun] = STATE(16520),
    [sym__type] = STATE(16520),
    [sym__type_or_implicit] = STATE(16520),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1314),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2244] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17280),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17280),
    [sym__type_context] = STATE(17280),
    [sym__type_fun] = STATE(17280),
    [sym__type] = STATE(17280),
    [sym__type_or_implicit] = STATE(17280),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5693),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2245] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17213),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17213),
    [sym__type_context] = STATE(17213),
    [sym__type_fun] = STATE(17213),
    [sym__type] = STATE(17213),
    [sym__type_or_implicit] = STATE(17213),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5695),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2246] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17305),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17305),
    [sym__type_context] = STATE(17305),
    [sym__type_fun] = STATE(17305),
    [sym__type] = STATE(17305),
    [sym__type_or_implicit] = STATE(17305),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5697),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2247] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17673),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17673),
    [sym__type_context] = STATE(17673),
    [sym__type_fun] = STATE(17673),
    [sym__type] = STATE(17673),
    [sym__type_or_implicit] = STATE(17673),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5699),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2248] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17270),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17270),
    [sym__type_context] = STATE(17270),
    [sym__type_fun] = STATE(17270),
    [sym__type] = STATE(17270),
    [sym__type_or_implicit] = STATE(17270),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5701),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2249] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17649),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17649),
    [sym__type_context] = STATE(17649),
    [sym__type_fun] = STATE(17649),
    [sym__type] = STATE(17649),
    [sym__type_or_implicit] = STATE(17649),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5703),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2250] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7065),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(17752),
    [sym_inst_tyinst] = STATE(17752),
    [sym__idecl] = STATE(17752),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13389),
    [sym_function] = STATE(17752),
    [sym_signature] = STATE(17752),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4939),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5441),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5443),
    [anon_sym_data] = ACTIONS(5445),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2251] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15667),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15667),
    [sym__type_context] = STATE(15667),
    [sym__type_fun] = STATE(15667),
    [sym__type] = STATE(15667),
    [sym__type_or_implicit] = STATE(15667),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5705),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2252] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(236),
    [sym_variable] = STATE(7214),
    [sym_constructor] = STATE(3977),
    [sym_qualified_constructor] = STATE(4051),
    [sym__qcon] = STATE(8915),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(14211),
    [sym_pat_as] = STATE(12302),
    [sym_pat_parens] = STATE(12302),
    [sym_pat_tuple] = STATE(12302),
    [sym_pat_unboxed_tuple] = STATE(12302),
    [sym_pat_unboxed_sum] = STATE(12302),
    [sym_pat_list] = STATE(12302),
    [sym_pat_strict] = STATE(12302),
    [sym_pat_irrefutable] = STATE(12302),
    [sym_pat_negation] = STATE(12302),
    [sym_pat_name] = STATE(12302),
    [sym__pat_constructor] = STATE(3202),
    [sym_pat_wildcard] = STATE(12302),
    [sym_pat_record] = STATE(12302),
    [sym__apat] = STATE(12302),
    [sym_pat_apply] = STATE(12302),
    [sym__lpat] = STATE(12302),
    [sym_pat_infix] = STATE(13739),
    [sym__pat] = STATE(13739),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15169),
    [sym_inst_datainst] = STATE(18065),
    [sym_inst_tyinst] = STATE(18065),
    [sym__idecl] = STATE(18065),
    [sym__funpat_infix] = STATE(17942),
    [sym__fun_name] = STATE(3420),
    [sym__funvar] = STATE(17946),
    [sym__funlhs] = STATE(13839),
    [sym_function] = STATE(18065),
    [sym_signature] = STATE(18065),
    [sym_splice] = STATE(12302),
    [sym_quasiquote] = STATE(12302),
    [sym__varid] = ACTIONS(81),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(4907),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(4907),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_LPAREN] = ACTIONS(4911),
    [sym_implicit_parid] = ACTIONS(4913),
    [sym__conid] = ACTIONS(655),
    [anon_sym_LBRACK] = ACTIONS(4915),
    [anon_sym_type] = ACTIONS(5266),
    [anon_sym__] = ACTIONS(4921),
    [anon_sym_newtype] = ACTIONS(5270),
    [anon_sym_data] = ACTIONS(5272),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
    [sym__strict] = ACTIONS(4927),
    [sym__lazy] = ACTIONS(4929),
  },
  [2253] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16646),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16646),
    [sym__type_context] = STATE(16646),
    [sym__type_fun] = STATE(16646),
    [sym__type] = STATE(16646),
    [sym__type_or_implicit] = STATE(16646),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5707),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2254] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17319),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17319),
    [sym__type_context] = STATE(17319),
    [sym__type_fun] = STATE(17319),
    [sym__type] = STATE(17319),
    [sym__type_or_implicit] = STATE(17319),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5709),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2255] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16991),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16991),
    [sym__type_context] = STATE(16991),
    [sym__type_fun] = STATE(16991),
    [sym__type] = STATE(16991),
    [sym__type_or_implicit] = STATE(16991),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5711),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2256] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17714),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17714),
    [sym__type_context] = STATE(17714),
    [sym__type_fun] = STATE(17714),
    [sym__type] = STATE(17714),
    [sym__type_or_implicit] = STATE(17714),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5713),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2257] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16725),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16725),
    [sym__type_context] = STATE(16725),
    [sym__type_fun] = STATE(16725),
    [sym__type] = STATE(16725),
    [sym__type_or_implicit] = STATE(16725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5715),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2258] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17260),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17260),
    [sym__type_context] = STATE(17260),
    [sym__type_fun] = STATE(17260),
    [sym__type] = STATE(17260),
    [sym__type_or_implicit] = STATE(17260),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5717),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2259] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17301),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17301),
    [sym__type_context] = STATE(17301),
    [sym__type_fun] = STATE(17301),
    [sym__type] = STATE(17301),
    [sym__type_or_implicit] = STATE(17301),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3586),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2260] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16283),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16283),
    [sym__type_context] = STATE(16283),
    [sym__type_fun] = STATE(16283),
    [sym__type] = STATE(16283),
    [sym__type_or_implicit] = STATE(16283),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5719),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2261] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17078),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17078),
    [sym__type_context] = STATE(17078),
    [sym__type_fun] = STATE(17078),
    [sym__type] = STATE(17078),
    [sym__type_or_implicit] = STATE(17078),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5721),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2262] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17549),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17549),
    [sym__type_context] = STATE(17549),
    [sym__type_fun] = STATE(17549),
    [sym__type] = STATE(17549),
    [sym__type_or_implicit] = STATE(17549),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5723),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2263] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16995),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16995),
    [sym__type_context] = STATE(16995),
    [sym__type_fun] = STATE(16995),
    [sym__type] = STATE(16995),
    [sym__type_or_implicit] = STATE(16995),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3888),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2264] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16235),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16235),
    [sym__type_context] = STATE(16235),
    [sym__type_fun] = STATE(16235),
    [sym__type] = STATE(16235),
    [sym__type_or_implicit] = STATE(16235),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1310),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2265] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17378),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17378),
    [sym__type_context] = STATE(17378),
    [sym__type_fun] = STATE(17378),
    [sym__type] = STATE(17378),
    [sym__type_or_implicit] = STATE(17378),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5725),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2266] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17631),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17631),
    [sym__type_context] = STATE(17631),
    [sym__type_fun] = STATE(17631),
    [sym__type] = STATE(17631),
    [sym__type_or_implicit] = STATE(17631),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5727),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2267] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17325),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17325),
    [sym__type_context] = STATE(17325),
    [sym__type_fun] = STATE(17325),
    [sym__type] = STATE(17325),
    [sym__type_or_implicit] = STATE(17325),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3620),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2268] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17642),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17642),
    [sym__type_context] = STATE(17642),
    [sym__type_fun] = STATE(17642),
    [sym__type] = STATE(17642),
    [sym__type_or_implicit] = STATE(17642),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3758),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2269] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16087),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16087),
    [sym__type_context] = STATE(16087),
    [sym__type_fun] = STATE(16087),
    [sym__type] = STATE(16087),
    [sym__type_or_implicit] = STATE(16087),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1344),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2270] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17732),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17732),
    [sym__type_context] = STATE(17732),
    [sym__type_fun] = STATE(17732),
    [sym__type] = STATE(17732),
    [sym__type_or_implicit] = STATE(17732),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1320),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2271] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16673),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16673),
    [sym__type_context] = STATE(16673),
    [sym__type_fun] = STATE(16673),
    [sym__type] = STATE(16673),
    [sym__type_or_implicit] = STATE(16673),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5729),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2272] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16962),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16962),
    [sym__type_context] = STATE(16962),
    [sym__type_fun] = STATE(16962),
    [sym__type] = STATE(16962),
    [sym__type_or_implicit] = STATE(16962),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(4031),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2273] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17604),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17604),
    [sym__type_context] = STATE(17604),
    [sym__type_fun] = STATE(17604),
    [sym__type] = STATE(17604),
    [sym__type_or_implicit] = STATE(17604),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5731),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2274] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17435),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17435),
    [sym__type_context] = STATE(17435),
    [sym__type_fun] = STATE(17435),
    [sym__type] = STATE(17435),
    [sym__type_or_implicit] = STATE(17435),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3358),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2275] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17487),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17487),
    [sym__type_context] = STATE(17487),
    [sym__type_fun] = STATE(17487),
    [sym__type] = STATE(17487),
    [sym__type_or_implicit] = STATE(17487),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1352),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2276] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15855),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15855),
    [sym__type_context] = STATE(15855),
    [sym__type_fun] = STATE(15855),
    [sym__type] = STATE(15855),
    [sym__type_or_implicit] = STATE(15855),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5733),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2277] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17231),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17231),
    [sym__type_context] = STATE(17231),
    [sym__type_fun] = STATE(17231),
    [sym__type] = STATE(17231),
    [sym__type_or_implicit] = STATE(17231),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1306),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2278] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17587),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17587),
    [sym__type_context] = STATE(17587),
    [sym__type_fun] = STATE(17587),
    [sym__type] = STATE(17587),
    [sym__type_or_implicit] = STATE(17587),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5735),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2279] = {
    [sym_integer] = STATE(5892),
    [sym__literal] = STATE(5892),
    [sym__unboxed_open] = STATE(2185),
    [sym_constructor] = STATE(5658),
    [sym_con_unit] = STATE(5892),
    [sym_con_list] = STATE(5892),
    [sym_con_tuple] = STATE(5892),
    [sym_qualified_type] = STATE(5887),
    [sym_tycon_arrow] = STATE(5887),
    [sym_type_literal] = STATE(2279),
    [sym__promoted_tycon] = STATE(5887),
    [sym_type_variable] = STATE(5887),
    [sym_annotated_type_variable] = STATE(5887),
    [sym_type_parens] = STATE(2279),
    [sym_type_list] = STATE(2279),
    [sym_type_tuple] = STATE(2279),
    [sym__type_promotable_literal] = STATE(2279),
    [sym__type_promoted_literal] = STATE(2279),
    [sym__type_literal] = STATE(2279),
    [sym_type_name] = STATE(2279),
    [sym_type_star] = STATE(2279),
    [sym_type_unboxed_tuple] = STATE(2279),
    [sym_type_unboxed_sum] = STATE(2279),
    [sym__atype] = STATE(2279),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15268),
    [sym_splice] = STATE(2279),
    [sym_quasiquote] = STATE(2279),
    [aux_sym_type_apply_repeat1] = STATE(2279),
    [sym__varid] = ACTIONS(5737),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(5740),
    [sym_char] = ACTIONS(5740),
    [sym_string] = ACTIONS(5740),
    [sym__integer_literal] = ACTIONS(5743),
    [sym__binary_literal] = ACTIONS(5746),
    [sym__octal_literal] = ACTIONS(5746),
    [sym__hex_literal] = ACTIONS(5746),
    [anon_sym_LPAREN_POUND] = ACTIONS(5749),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5749),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(5752),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(5755),
    [anon_sym_LBRACK] = ACTIONS(5758),
    [anon_sym_SQUOTE] = ACTIONS(5761),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(5764),
    [anon_sym_6] = ACTIONS(5764),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_in] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(5767),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym__layout_end] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(5770),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5773),
  },
  [2280] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16425),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16425),
    [sym__type_context] = STATE(16425),
    [sym__type_fun] = STATE(16425),
    [sym__type] = STATE(16425),
    [sym__type_or_implicit] = STATE(16425),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1312),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2281] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16921),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16921),
    [sym__type_context] = STATE(16921),
    [sym__type_fun] = STATE(16921),
    [sym__type] = STATE(16921),
    [sym__type_or_implicit] = STATE(16921),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5776),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2282] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17332),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17332),
    [sym__type_context] = STATE(17332),
    [sym__type_fun] = STATE(17332),
    [sym__type] = STATE(17332),
    [sym__type_or_implicit] = STATE(17332),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5778),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2283] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17239),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17239),
    [sym__type_context] = STATE(17239),
    [sym__type_fun] = STATE(17239),
    [sym__type] = STATE(17239),
    [sym__type_or_implicit] = STATE(17239),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5780),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2284] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17757),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17757),
    [sym__type_context] = STATE(17757),
    [sym__type_fun] = STATE(17757),
    [sym__type] = STATE(17757),
    [sym__type_or_implicit] = STATE(17757),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5782),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2285] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17578),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17578),
    [sym__type_context] = STATE(17578),
    [sym__type_fun] = STATE(17578),
    [sym__type] = STATE(17578),
    [sym__type_or_implicit] = STATE(17578),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5784),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2286] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17344),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17344),
    [sym__type_context] = STATE(17344),
    [sym__type_fun] = STATE(17344),
    [sym__type] = STATE(17344),
    [sym__type_or_implicit] = STATE(17344),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5786),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2287] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17363),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17363),
    [sym__type_context] = STATE(17363),
    [sym__type_fun] = STATE(17363),
    [sym__type] = STATE(17363),
    [sym__type_or_implicit] = STATE(17363),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3364),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2288] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17057),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17057),
    [sym__type_context] = STATE(17057),
    [sym__type_fun] = STATE(17057),
    [sym__type] = STATE(17057),
    [sym__type_or_implicit] = STATE(17057),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5788),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2289] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17556),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17556),
    [sym__type_context] = STATE(17556),
    [sym__type_fun] = STATE(17556),
    [sym__type] = STATE(17556),
    [sym__type_or_implicit] = STATE(17556),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5790),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2290] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17704),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17704),
    [sym__type_context] = STATE(17704),
    [sym__type_fun] = STATE(17704),
    [sym__type] = STATE(17704),
    [sym__type_or_implicit] = STATE(17704),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3928),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2291] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_strict_type] = STATE(18192),
    [sym_lazy_type] = STATE(18192),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18192),
    [sym__type_context] = STATE(18192),
    [sym__type_fun] = STATE(18192),
    [sym__type] = STATE(18192),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
    [sym__strict] = ACTIONS(5792),
    [sym__lazy] = ACTIONS(5794),
  },
  [2292] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15668),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15668),
    [sym__type_context] = STATE(15668),
    [sym__type_fun] = STATE(15668),
    [sym__type] = STATE(15668),
    [sym__type_or_implicit] = STATE(15668),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1296),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2293] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17095),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17095),
    [sym__type_context] = STATE(17095),
    [sym__type_fun] = STATE(17095),
    [sym__type] = STATE(17095),
    [sym__type_or_implicit] = STATE(17095),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3786),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2294] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_strict_type] = STATE(18141),
    [sym_lazy_type] = STATE(18141),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(18141),
    [sym__type_context] = STATE(18141),
    [sym__type_fun] = STATE(18141),
    [sym__type] = STATE(18141),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
    [sym__strict] = ACTIONS(5792),
    [sym__lazy] = ACTIONS(5794),
  },
  [2295] = {
    [sym_integer] = STATE(5892),
    [sym__literal] = STATE(5892),
    [sym__unboxed_open] = STATE(2185),
    [sym_constructor] = STATE(5658),
    [sym_con_unit] = STATE(5892),
    [sym_con_list] = STATE(5892),
    [sym_con_tuple] = STATE(5892),
    [sym_qualified_type] = STATE(5887),
    [sym_tycon_arrow] = STATE(5887),
    [sym_type_literal] = STATE(2309),
    [sym__promoted_tycon] = STATE(5887),
    [sym_type_variable] = STATE(5887),
    [sym_annotated_type_variable] = STATE(5887),
    [sym_type_parens] = STATE(2309),
    [sym_type_list] = STATE(2309),
    [sym_type_tuple] = STATE(2309),
    [sym__type_promotable_literal] = STATE(2309),
    [sym__type_promoted_literal] = STATE(2309),
    [sym__type_literal] = STATE(2309),
    [sym_type_name] = STATE(2309),
    [sym_type_star] = STATE(2309),
    [sym_type_unboxed_tuple] = STATE(2309),
    [sym_type_unboxed_sum] = STATE(2309),
    [sym__atype] = STATE(2309),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15268),
    [sym_splice] = STATE(2309),
    [sym_quasiquote] = STATE(2309),
    [aux_sym_type_apply_repeat1] = STATE(2309),
    [sym__varid] = ACTIONS(5796),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(5798),
    [sym_char] = ACTIONS(5798),
    [sym_string] = ACTIONS(5798),
    [sym__integer_literal] = ACTIONS(5800),
    [sym__binary_literal] = ACTIONS(5802),
    [sym__octal_literal] = ACTIONS(5802),
    [sym__hex_literal] = ACTIONS(5802),
    [anon_sym_LPAREN_POUND] = ACTIONS(5804),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5804),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(5806),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(5808),
    [anon_sym_LBRACK] = ACTIONS(5811),
    [anon_sym_SQUOTE] = ACTIONS(5813),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(5816),
    [anon_sym_6] = ACTIONS(5816),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_in] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(5818),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym__layout_end] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(5820),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5822),
  },
  [2296] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17131),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17131),
    [sym__type_context] = STATE(17131),
    [sym__type_fun] = STATE(17131),
    [sym__type] = STATE(17131),
    [sym__type_or_implicit] = STATE(17131),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1324),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2297] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17454),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17454),
    [sym__type_context] = STATE(17454),
    [sym__type_fun] = STATE(17454),
    [sym__type] = STATE(17454),
    [sym__type_or_implicit] = STATE(17454),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3272),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2298] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16900),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16900),
    [sym__type_context] = STATE(16900),
    [sym__type_fun] = STATE(16900),
    [sym__type] = STATE(16900),
    [sym__type_or_implicit] = STATE(16900),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3990),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2299] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16140),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16140),
    [sym__type_context] = STATE(16140),
    [sym__type_fun] = STATE(16140),
    [sym__type] = STATE(16140),
    [sym__type_or_implicit] = STATE(16140),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5824),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2300] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17088),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17088),
    [sym__type_context] = STATE(17088),
    [sym__type_fun] = STATE(17088),
    [sym__type] = STATE(17088),
    [sym__type_or_implicit] = STATE(17088),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5826),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2301] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15665),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15665),
    [sym__type_context] = STATE(15665),
    [sym__type_fun] = STATE(15665),
    [sym__type] = STATE(15665),
    [sym__type_or_implicit] = STATE(15665),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5828),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2302] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16899),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16899),
    [sym__type_context] = STATE(16899),
    [sym__type_fun] = STATE(16899),
    [sym__type] = STATE(16899),
    [sym__type_or_implicit] = STATE(16899),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5830),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2303] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17366),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17366),
    [sym__type_context] = STATE(17366),
    [sym__type_fun] = STATE(17366),
    [sym__type] = STATE(17366),
    [sym__type_or_implicit] = STATE(17366),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3526),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2304] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16698),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16698),
    [sym__type_context] = STATE(16698),
    [sym__type_fun] = STATE(16698),
    [sym__type] = STATE(16698),
    [sym__type_or_implicit] = STATE(16698),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5832),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2305] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17781),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17781),
    [sym__type_context] = STATE(17781),
    [sym__type_fun] = STATE(17781),
    [sym__type] = STATE(17781),
    [sym__type_or_implicit] = STATE(17781),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3440),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2306] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17141),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17141),
    [sym__type_context] = STATE(17141),
    [sym__type_fun] = STATE(17141),
    [sym__type] = STATE(17141),
    [sym__type_or_implicit] = STATE(17141),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1292),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2307] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16875),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16875),
    [sym__type_context] = STATE(16875),
    [sym__type_fun] = STATE(16875),
    [sym__type] = STATE(16875),
    [sym__type_or_implicit] = STATE(16875),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5834),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2308] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17536),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17536),
    [sym__type_context] = STATE(17536),
    [sym__type_fun] = STATE(17536),
    [sym__type] = STATE(17536),
    [sym__type_or_implicit] = STATE(17536),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1304),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2309] = {
    [sym_integer] = STATE(5892),
    [sym__literal] = STATE(5892),
    [sym__unboxed_open] = STATE(2185),
    [sym_constructor] = STATE(5658),
    [sym_con_unit] = STATE(5892),
    [sym_con_list] = STATE(5892),
    [sym_con_tuple] = STATE(5892),
    [sym_qualified_type] = STATE(5887),
    [sym_tycon_arrow] = STATE(5887),
    [sym_type_literal] = STATE(2279),
    [sym__promoted_tycon] = STATE(5887),
    [sym_type_variable] = STATE(5887),
    [sym_annotated_type_variable] = STATE(5887),
    [sym_type_parens] = STATE(2279),
    [sym_type_list] = STATE(2279),
    [sym_type_tuple] = STATE(2279),
    [sym__type_promotable_literal] = STATE(2279),
    [sym__type_promoted_literal] = STATE(2279),
    [sym__type_literal] = STATE(2279),
    [sym_type_name] = STATE(2279),
    [sym_type_star] = STATE(2279),
    [sym_type_unboxed_tuple] = STATE(2279),
    [sym_type_unboxed_sum] = STATE(2279),
    [sym__atype] = STATE(2279),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15268),
    [sym_splice] = STATE(2279),
    [sym_quasiquote] = STATE(2279),
    [aux_sym_type_apply_repeat1] = STATE(2279),
    [sym__varid] = ACTIONS(5796),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(5798),
    [sym_char] = ACTIONS(5798),
    [sym_string] = ACTIONS(5798),
    [sym__integer_literal] = ACTIONS(5800),
    [sym__binary_literal] = ACTIONS(5802),
    [sym__octal_literal] = ACTIONS(5802),
    [sym__hex_literal] = ACTIONS(5802),
    [anon_sym_LPAREN_POUND] = ACTIONS(5804),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5804),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(5806),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(5836),
    [anon_sym_LBRACK] = ACTIONS(5811),
    [anon_sym_SQUOTE] = ACTIONS(5839),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(5816),
    [anon_sym_6] = ACTIONS(5816),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_in] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(5818),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym__layout_end] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(5820),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5822),
  },
  [2310] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(19229),
    [sym_lazy_type] = STATE(19229),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(19229),
    [sym__type_context] = STATE(19229),
    [sym__type_fun] = STATE(19229),
    [sym__type] = STATE(19229),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5363),
    [sym__lazy] = ACTIONS(5365),
  },
  [2311] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16848),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16848),
    [sym__type_context] = STATE(16848),
    [sym__type_fun] = STATE(16848),
    [sym__type] = STATE(16848),
    [sym__type_or_implicit] = STATE(16848),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5842),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2312] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17394),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17394),
    [sym__type_context] = STATE(17394),
    [sym__type_fun] = STATE(17394),
    [sym__type] = STATE(17394),
    [sym__type_or_implicit] = STATE(17394),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3210),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2313] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17155),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17155),
    [sym__type_context] = STATE(17155),
    [sym__type_fun] = STATE(17155),
    [sym__type] = STATE(17155),
    [sym__type_or_implicit] = STATE(17155),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5844),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2314] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17806),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17806),
    [sym__type_context] = STATE(17806),
    [sym__type_fun] = STATE(17806),
    [sym__type] = STATE(17806),
    [sym__type_or_implicit] = STATE(17806),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3624),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2315] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16614),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16614),
    [sym__type_context] = STATE(16614),
    [sym__type_fun] = STATE(16614),
    [sym__type] = STATE(16614),
    [sym__type_or_implicit] = STATE(16614),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5846),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2316] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17518),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17518),
    [sym__type_context] = STATE(17518),
    [sym__type_fun] = STATE(17518),
    [sym__type] = STATE(17518),
    [sym__type_or_implicit] = STATE(17518),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5848),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2317] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15909),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15909),
    [sym__type_context] = STATE(15909),
    [sym__type_fun] = STATE(15909),
    [sym__type] = STATE(15909),
    [sym__type_or_implicit] = STATE(15909),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1358),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2318] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17768),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17768),
    [sym__type_context] = STATE(17768),
    [sym__type_fun] = STATE(17768),
    [sym__type] = STATE(17768),
    [sym__type_or_implicit] = STATE(17768),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1270),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2319] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17611),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17611),
    [sym__type_context] = STATE(17611),
    [sym__type_fun] = STATE(17611),
    [sym__type] = STATE(17611),
    [sym__type_or_implicit] = STATE(17611),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3510),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2320] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17425),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17425),
    [sym__type_context] = STATE(17425),
    [sym__type_fun] = STATE(17425),
    [sym__type] = STATE(17425),
    [sym__type_or_implicit] = STATE(17425),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1332),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2321] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17793),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17793),
    [sym__type_context] = STATE(17793),
    [sym__type_fun] = STATE(17793),
    [sym__type] = STATE(17793),
    [sym__type_or_implicit] = STATE(17793),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3910),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2322] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17598),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17598),
    [sym__type_context] = STATE(17598),
    [sym__type_fun] = STATE(17598),
    [sym__type] = STATE(17598),
    [sym__type_or_implicit] = STATE(17598),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2323] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16281),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16281),
    [sym__type_context] = STATE(16281),
    [sym__type_fun] = STATE(16281),
    [sym__type] = STATE(16281),
    [sym__type_or_implicit] = STATE(16281),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5850),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2324] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17391),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17391),
    [sym__type_context] = STATE(17391),
    [sym__type_fun] = STATE(17391),
    [sym__type] = STATE(17391),
    [sym__type_or_implicit] = STATE(17391),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5852),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2325] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17515),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17515),
    [sym__type_context] = STATE(17515),
    [sym__type_fun] = STATE(17515),
    [sym__type] = STATE(17515),
    [sym__type_or_implicit] = STATE(17515),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5854),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2326] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16615),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16615),
    [sym__type_context] = STATE(16615),
    [sym__type_fun] = STATE(16615),
    [sym__type] = STATE(16615),
    [sym__type_or_implicit] = STATE(16615),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5856),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2327] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15524),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15524),
    [sym__type_context] = STATE(15524),
    [sym__type_fun] = STATE(15524),
    [sym__type] = STATE(15524),
    [sym__type_or_implicit] = STATE(15524),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1334),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2328] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16816),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16816),
    [sym__type_context] = STATE(16816),
    [sym__type_fun] = STATE(16816),
    [sym__type] = STATE(16816),
    [sym__type_or_implicit] = STATE(16816),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5858),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2329] = {
    [sym_integer] = STATE(5783),
    [sym__literal] = STATE(5783),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(5543),
    [sym_con_unit] = STATE(5783),
    [sym_con_list] = STATE(5783),
    [sym_con_tuple] = STATE(5783),
    [sym_qualified_type] = STATE(5773),
    [sym_tycon_arrow] = STATE(5773),
    [sym_type_literal] = STATE(2329),
    [sym__promoted_tycon] = STATE(5773),
    [sym_type_variable] = STATE(5773),
    [sym_annotated_type_variable] = STATE(5773),
    [sym_type_parens] = STATE(2329),
    [sym_type_list] = STATE(2329),
    [sym_type_tuple] = STATE(2329),
    [sym__type_promotable_literal] = STATE(2329),
    [sym__type_promoted_literal] = STATE(2329),
    [sym__type_literal] = STATE(2329),
    [sym_type_name] = STATE(2329),
    [sym_type_star] = STATE(2329),
    [sym_type_unboxed_tuple] = STATE(2329),
    [sym_type_unboxed_sum] = STATE(2329),
    [sym__atype] = STATE(2329),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15397),
    [sym_splice] = STATE(2329),
    [sym_quasiquote] = STATE(2329),
    [aux_sym_type_apply_repeat1] = STATE(2329),
    [sym__varid] = ACTIONS(5860),
    [sym_float] = ACTIONS(5863),
    [sym_char] = ACTIONS(5863),
    [sym_string] = ACTIONS(5863),
    [sym__integer_literal] = ACTIONS(5866),
    [sym__binary_literal] = ACTIONS(5869),
    [sym__octal_literal] = ACTIONS(5869),
    [sym__hex_literal] = ACTIONS(5869),
    [anon_sym_LPAREN_POUND] = ACTIONS(5872),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5872),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(5875),
    [anon_sym_RPAREN] = ACTIONS(5030),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(5878),
    [anon_sym_LBRACK] = ACTIONS(5881),
    [anon_sym_RBRACK] = ACTIONS(5030),
    [anon_sym_SQUOTE] = ACTIONS(5884),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(5887),
    [anon_sym_6] = ACTIONS(5887),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_EQ] = ACTIONS(5059),
    [anon_sym_RBRACE] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(5890),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5893),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5030),
    [sym_quasiquote_start] = ACTIONS(5896),
  },
  [2330] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_RBRACK] = ACTIONS(5129),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_EQ] = ACTIONS(5160),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5129),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2331] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17580),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17580),
    [sym__type_context] = STATE(17580),
    [sym__type_fun] = STATE(17580),
    [sym__type] = STATE(17580),
    [sym__type_or_implicit] = STATE(17580),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5902),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2332] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15659),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15659),
    [sym__type_context] = STATE(15659),
    [sym__type_fun] = STATE(15659),
    [sym__type] = STATE(15659),
    [sym__type_or_implicit] = STATE(15659),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3930),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2333] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16856),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16856),
    [sym__type_context] = STATE(16856),
    [sym__type_fun] = STATE(16856),
    [sym__type] = STATE(16856),
    [sym__type_or_implicit] = STATE(16856),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1276),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2334] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16184),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16184),
    [sym__type_context] = STATE(16184),
    [sym__type_fun] = STATE(16184),
    [sym__type] = STATE(16184),
    [sym__type_or_implicit] = STATE(16184),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5904),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2335] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17182),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17182),
    [sym__type_context] = STATE(17182),
    [sym__type_fun] = STATE(17182),
    [sym__type] = STATE(17182),
    [sym__type_or_implicit] = STATE(17182),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5906),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2336] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16748),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16748),
    [sym__type_context] = STATE(16748),
    [sym__type_fun] = STATE(16748),
    [sym__type] = STATE(16748),
    [sym__type_or_implicit] = STATE(16748),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5908),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2337] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16392),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16392),
    [sym__type_context] = STATE(16392),
    [sym__type_fun] = STATE(16392),
    [sym__type] = STATE(16392),
    [sym__type_or_implicit] = STATE(16392),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1330),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2338] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17491),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17491),
    [sym__type_context] = STATE(17491),
    [sym__type_fun] = STATE(17491),
    [sym__type] = STATE(17491),
    [sym__type_or_implicit] = STATE(17491),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5910),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2339] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16787),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16787),
    [sym__type_context] = STATE(16787),
    [sym__type_fun] = STATE(16787),
    [sym__type] = STATE(16787),
    [sym__type_or_implicit] = STATE(16787),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3986),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2340] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17766),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17766),
    [sym__type_context] = STATE(17766),
    [sym__type_fun] = STATE(17766),
    [sym__type] = STATE(17766),
    [sym__type_or_implicit] = STATE(17766),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5912),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2341] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17415),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17415),
    [sym__type_context] = STATE(17415),
    [sym__type_fun] = STATE(17415),
    [sym__type] = STATE(17415),
    [sym__type_or_implicit] = STATE(17415),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3428),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2342] = {
    [sym_integer] = STATE(5783),
    [sym__literal] = STATE(5783),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(5543),
    [sym_con_unit] = STATE(5783),
    [sym_con_list] = STATE(5783),
    [sym_con_tuple] = STATE(5783),
    [sym_qualified_type] = STATE(5773),
    [sym_tycon_arrow] = STATE(5773),
    [sym_type_literal] = STATE(2329),
    [sym__promoted_tycon] = STATE(5773),
    [sym_type_variable] = STATE(5773),
    [sym_annotated_type_variable] = STATE(5773),
    [sym_type_parens] = STATE(2329),
    [sym_type_list] = STATE(2329),
    [sym_type_tuple] = STATE(2329),
    [sym__type_promotable_literal] = STATE(2329),
    [sym__type_promoted_literal] = STATE(2329),
    [sym__type_literal] = STATE(2329),
    [sym_type_name] = STATE(2329),
    [sym_type_star] = STATE(2329),
    [sym_type_unboxed_tuple] = STATE(2329),
    [sym_type_unboxed_sum] = STATE(2329),
    [sym__atype] = STATE(2329),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15397),
    [sym_splice] = STATE(2329),
    [sym_quasiquote] = STATE(2329),
    [aux_sym_type_apply_repeat1] = STATE(2329),
    [sym__varid] = ACTIONS(5914),
    [sym_float] = ACTIONS(5916),
    [sym_char] = ACTIONS(5916),
    [sym_string] = ACTIONS(5916),
    [sym__integer_literal] = ACTIONS(5918),
    [sym__binary_literal] = ACTIONS(5920),
    [sym__octal_literal] = ACTIONS(5920),
    [sym__hex_literal] = ACTIONS(5920),
    [anon_sym_LPAREN_POUND] = ACTIONS(5922),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5922),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(5924),
    [anon_sym_RPAREN] = ACTIONS(5177),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(5926),
    [anon_sym_LBRACK] = ACTIONS(5929),
    [anon_sym_RBRACK] = ACTIONS(5177),
    [anon_sym_SQUOTE] = ACTIONS(5931),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(5934),
    [anon_sym_6] = ACTIONS(5934),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_EQ] = ACTIONS(5185),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(5936),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5938),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5177),
    [sym_quasiquote_start] = ACTIONS(5940),
  },
  [2343] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17474),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17474),
    [sym__type_context] = STATE(17474),
    [sym__type_fun] = STATE(17474),
    [sym__type] = STATE(17474),
    [sym__type_or_implicit] = STATE(17474),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5942),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2344] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16864),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16864),
    [sym__type_context] = STATE(16864),
    [sym__type_fun] = STATE(16864),
    [sym__type] = STATE(16864),
    [sym__type_or_implicit] = STATE(16864),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5944),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2345] = {
    [sym_integer] = STATE(5783),
    [sym__literal] = STATE(5783),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(5543),
    [sym_con_unit] = STATE(5783),
    [sym_con_list] = STATE(5783),
    [sym_con_tuple] = STATE(5783),
    [sym_qualified_type] = STATE(5773),
    [sym_tycon_arrow] = STATE(5773),
    [sym_type_literal] = STATE(2342),
    [sym__promoted_tycon] = STATE(5773),
    [sym_type_variable] = STATE(5773),
    [sym_annotated_type_variable] = STATE(5773),
    [sym_type_parens] = STATE(2342),
    [sym_type_list] = STATE(2342),
    [sym_type_tuple] = STATE(2342),
    [sym__type_promotable_literal] = STATE(2342),
    [sym__type_promoted_literal] = STATE(2342),
    [sym__type_literal] = STATE(2342),
    [sym_type_name] = STATE(2342),
    [sym_type_star] = STATE(2342),
    [sym_type_unboxed_tuple] = STATE(2342),
    [sym_type_unboxed_sum] = STATE(2342),
    [sym__atype] = STATE(2342),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15397),
    [sym_splice] = STATE(2342),
    [sym_quasiquote] = STATE(2342),
    [aux_sym_type_apply_repeat1] = STATE(2342),
    [sym__varid] = ACTIONS(5914),
    [sym_float] = ACTIONS(5916),
    [sym_char] = ACTIONS(5916),
    [sym_string] = ACTIONS(5916),
    [sym__integer_literal] = ACTIONS(5918),
    [sym__binary_literal] = ACTIONS(5920),
    [sym__octal_literal] = ACTIONS(5920),
    [sym__hex_literal] = ACTIONS(5920),
    [anon_sym_LPAREN_POUND] = ACTIONS(5922),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5922),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(5924),
    [anon_sym_RPAREN] = ACTIONS(5078),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(5946),
    [anon_sym_LBRACK] = ACTIONS(5929),
    [anon_sym_RBRACK] = ACTIONS(5078),
    [anon_sym_SQUOTE] = ACTIONS(5949),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(5934),
    [anon_sym_6] = ACTIONS(5934),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_EQ] = ACTIONS(5100),
    [anon_sym_RBRACE] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(5936),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5938),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5078),
    [sym_quasiquote_start] = ACTIONS(5940),
  },
  [2346] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16103),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16103),
    [sym__type_context] = STATE(16103),
    [sym__type_fun] = STATE(16103),
    [sym__type] = STATE(16103),
    [sym__type_or_implicit] = STATE(16103),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5952),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2347] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15477),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15477),
    [sym__type_context] = STATE(15477),
    [sym__type_fun] = STATE(15477),
    [sym__type] = STATE(15477),
    [sym__type_or_implicit] = STATE(15477),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(3820),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2348] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(19013),
    [sym_lazy_type] = STATE(19013),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(19013),
    [sym__type_context] = STATE(19013),
    [sym__type_fun] = STATE(19013),
    [sym__type] = STATE(19013),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5363),
    [sym__lazy] = ACTIONS(5365),
  },
  [2349] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16805),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16805),
    [sym__type_context] = STATE(16805),
    [sym__type_fun] = STATE(16805),
    [sym__type] = STATE(16805),
    [sym__type_or_implicit] = STATE(16805),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5954),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2350] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16330),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16330),
    [sym__type_context] = STATE(16330),
    [sym__type_fun] = STATE(16330),
    [sym__type] = STATE(16330),
    [sym__type_or_implicit] = STATE(16330),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5956),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2351] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_in] = ACTIONS(5160),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym__layout_end] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2352] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(15760),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(15760),
    [sym__type_context] = STATE(15760),
    [sym__type_fun] = STATE(15760),
    [sym__type] = STATE(15760),
    [sym__type_or_implicit] = STATE(15760),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5958),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2353] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(17456),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(17456),
    [sym__type_context] = STATE(17456),
    [sym__type_fun] = STATE(17456),
    [sym__type] = STATE(17456),
    [sym__type_or_implicit] = STATE(17456),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5960),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2354] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16769),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16769),
    [sym__type_context] = STATE(16769),
    [sym__type_fun] = STATE(16769),
    [sym__type] = STATE(16769),
    [sym__type_or_implicit] = STATE(16769),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5962),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2355] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16700),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16700),
    [sym__type_context] = STATE(16700),
    [sym__type_fun] = STATE(16700),
    [sym__type] = STATE(16700),
    [sym__type_or_implicit] = STATE(16700),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(5964),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2356] = {
    [sym_integer] = STATE(6347),
    [sym__literal] = STATE(6347),
    [sym__unboxed_open] = STATE(2174),
    [sym_constructor] = STATE(6222),
    [sym_con_unit] = STATE(6347),
    [sym_con_list] = STATE(6347),
    [sym_con_tuple] = STATE(6347),
    [sym_qualified_type] = STATE(6343),
    [sym_tycon_arrow] = STATE(6343),
    [sym_type_literal] = STATE(2448),
    [sym__promoted_tycon] = STATE(6343),
    [sym_type_variable] = STATE(6343),
    [sym_annotated_type_variable] = STATE(6343),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14160),
    [sym_type_parens] = STATE(2448),
    [sym_type_list] = STATE(2448),
    [sym_type_tuple] = STATE(2448),
    [sym__type_promotable_literal] = STATE(2448),
    [sym__type_promoted_literal] = STATE(2448),
    [sym__type_literal] = STATE(2448),
    [sym_type_name] = STATE(2454),
    [sym_type_star] = STATE(2448),
    [sym_type_unboxed_tuple] = STATE(2448),
    [sym_type_unboxed_sum] = STATE(2448),
    [sym__atype] = STATE(2448),
    [sym_type_apply] = STATE(7672),
    [sym__btype] = STATE(7672),
    [sym_implicit_param] = STATE(12069),
    [sym_type_infix] = STATE(9777),
    [sym__type_infix] = STATE(9698),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2669),
    [sym__type_quantifiers] = STATE(12069),
    [sym__type_context] = STATE(12069),
    [sym__type_fun] = STATE(12069),
    [sym__type] = STATE(12069),
    [sym__type_or_implicit] = STATE(12069),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15364),
    [sym_splice] = STATE(2448),
    [sym_quasiquote] = STATE(2448),
    [sym__varid] = ACTIONS(5966),
    [sym_float] = ACTIONS(5968),
    [sym_char] = ACTIONS(5968),
    [sym_string] = ACTIONS(5968),
    [sym__integer_literal] = ACTIONS(5970),
    [sym__binary_literal] = ACTIONS(5972),
    [sym__octal_literal] = ACTIONS(5972),
    [sym__hex_literal] = ACTIONS(5972),
    [anon_sym_LPAREN_POUND] = ACTIONS(5974),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5974),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [sym_implicit_parid] = ACTIONS(5978),
    [sym__conid] = ACTIONS(5980),
    [anon_sym_LBRACK] = ACTIONS(5982),
    [anon_sym_SQUOTE] = ACTIONS(5984),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5986),
    [anon_sym_6] = ACTIONS(5986),
    [anon_sym_7] = ACTIONS(5988),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5990),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5992),
  },
  [2357] = {
    [sym_integer] = STATE(4542),
    [sym__literal] = STATE(4542),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(4213),
    [sym_con_unit] = STATE(4542),
    [sym_con_list] = STATE(4542),
    [sym_con_tuple] = STATE(4542),
    [sym_qualified_type] = STATE(4722),
    [sym_tycon_arrow] = STATE(4722),
    [sym_type_literal] = STATE(2080),
    [sym__promoted_tycon] = STATE(4722),
    [sym_type_variable] = STATE(4722),
    [sym_annotated_type_variable] = STATE(4722),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14007),
    [sym_type_parens] = STATE(2080),
    [sym_type_list] = STATE(2080),
    [sym_type_tuple] = STATE(2080),
    [sym__type_promotable_literal] = STATE(2080),
    [sym__type_promoted_literal] = STATE(2080),
    [sym__type_literal] = STATE(2080),
    [sym_type_name] = STATE(2082),
    [sym_type_star] = STATE(2080),
    [sym_type_unboxed_tuple] = STATE(2080),
    [sym_type_unboxed_sum] = STATE(2080),
    [sym__atype] = STATE(2080),
    [sym_type_apply] = STATE(6274),
    [sym__btype] = STATE(6274),
    [sym_implicit_param] = STATE(9523),
    [sym_type_infix] = STATE(9268),
    [sym__type_infix] = STATE(9218),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2613),
    [sym__type_quantifiers] = STATE(9523),
    [sym__type_context] = STATE(9523),
    [sym__type_fun] = STATE(9523),
    [sym__type] = STATE(9523),
    [sym__type_or_implicit] = STATE(9523),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14868),
    [sym_splice] = STATE(2080),
    [sym_quasiquote] = STATE(2080),
    [sym__varid] = ACTIONS(5191),
    [sym_float] = ACTIONS(5193),
    [sym_char] = ACTIONS(5193),
    [sym_string] = ACTIONS(5193),
    [sym__integer_literal] = ACTIONS(5195),
    [sym__binary_literal] = ACTIONS(5197),
    [sym__octal_literal] = ACTIONS(5197),
    [sym__hex_literal] = ACTIONS(5197),
    [anon_sym_LPAREN_POUND] = ACTIONS(5199),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5199),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5994),
    [sym_implicit_parid] = ACTIONS(5996),
    [sym__conid] = ACTIONS(5998),
    [anon_sym_LBRACK] = ACTIONS(5206),
    [anon_sym_SQUOTE] = ACTIONS(6000),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5211),
    [anon_sym_6] = ACTIONS(5211),
    [anon_sym_7] = ACTIONS(5213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5215),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5217),
  },
  [2358] = {
    [sym_integer] = STATE(7485),
    [sym__literal] = STATE(7485),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7295),
    [sym_con_unit] = STATE(7485),
    [sym_con_list] = STATE(7485),
    [sym_con_tuple] = STATE(7485),
    [sym_qualified_type] = STATE(7412),
    [sym_tycon_arrow] = STATE(7412),
    [sym_type_literal] = STATE(2753),
    [sym__promoted_tycon] = STATE(7412),
    [sym_type_variable] = STATE(7412),
    [sym_annotated_type_variable] = STATE(7412),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14444),
    [sym_type_parens] = STATE(2753),
    [sym_type_list] = STATE(2753),
    [sym_type_tuple] = STATE(2753),
    [sym__type_promotable_literal] = STATE(2753),
    [sym__type_promoted_literal] = STATE(2753),
    [sym__type_literal] = STATE(2753),
    [sym_type_name] = STATE(2737),
    [sym_type_star] = STATE(2753),
    [sym_type_unboxed_tuple] = STATE(2753),
    [sym_type_unboxed_sum] = STATE(2753),
    [sym__atype] = STATE(2753),
    [sym_type_apply] = STATE(8310),
    [sym__btype] = STATE(8310),
    [sym_implicit_param] = STATE(15985),
    [sym_type_infix] = STATE(12638),
    [sym__type_infix] = STATE(12387),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2571),
    [sym__type_quantifiers] = STATE(15985),
    [sym__type_context] = STATE(15985),
    [sym__type_fun] = STATE(15985),
    [sym__type] = STATE(15985),
    [sym__type_or_implicit] = STATE(15985),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14836),
    [sym_splice] = STATE(2753),
    [sym_quasiquote] = STATE(2753),
    [sym__varid] = ACTIONS(6002),
    [sym_float] = ACTIONS(6004),
    [sym_char] = ACTIONS(6004),
    [sym_string] = ACTIONS(6004),
    [sym__integer_literal] = ACTIONS(6006),
    [sym__binary_literal] = ACTIONS(6008),
    [sym__octal_literal] = ACTIONS(6008),
    [sym__hex_literal] = ACTIONS(6008),
    [anon_sym_LPAREN_POUND] = ACTIONS(6010),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6010),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6012),
    [sym_implicit_parid] = ACTIONS(6014),
    [sym__conid] = ACTIONS(6016),
    [anon_sym_LBRACK] = ACTIONS(6018),
    [anon_sym_SQUOTE] = ACTIONS(6020),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6022),
    [anon_sym_6] = ACTIONS(6022),
    [anon_sym_7] = ACTIONS(6024),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6026),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6028),
  },
  [2359] = {
    [sym_integer] = STATE(5783),
    [sym__literal] = STATE(5783),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(5543),
    [sym_con_unit] = STATE(5783),
    [sym_con_list] = STATE(5783),
    [sym_con_tuple] = STATE(5783),
    [sym_qualified_type] = STATE(5773),
    [sym_tycon_arrow] = STATE(5773),
    [sym_type_literal] = STATE(2345),
    [sym__promoted_tycon] = STATE(5773),
    [sym_type_variable] = STATE(5773),
    [sym_annotated_type_variable] = STATE(5773),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14056),
    [sym_type_parens] = STATE(2345),
    [sym_type_list] = STATE(2345),
    [sym_type_tuple] = STATE(2345),
    [sym__type_promotable_literal] = STATE(2345),
    [sym__type_promoted_literal] = STATE(2345),
    [sym__type_literal] = STATE(2345),
    [sym_type_name] = STATE(2330),
    [sym_type_star] = STATE(2345),
    [sym_type_unboxed_tuple] = STATE(2345),
    [sym_type_unboxed_sum] = STATE(2345),
    [sym__atype] = STATE(2345),
    [sym_type_apply] = STATE(7063),
    [sym__btype] = STATE(7063),
    [sym_implicit_param] = STATE(10163),
    [sym_type_infix] = STATE(9520),
    [sym__type_infix] = STATE(9485),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2545),
    [sym__type_quantifiers] = STATE(10163),
    [sym__type_context] = STATE(10163),
    [sym__type_fun] = STATE(10163),
    [sym__type] = STATE(10163),
    [sym__type_or_implicit] = STATE(10163),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15397),
    [sym_splice] = STATE(2345),
    [sym_quasiquote] = STATE(2345),
    [sym__varid] = ACTIONS(6030),
    [sym_float] = ACTIONS(5916),
    [sym_char] = ACTIONS(5916),
    [sym_string] = ACTIONS(5916),
    [sym__integer_literal] = ACTIONS(5918),
    [sym__binary_literal] = ACTIONS(5920),
    [sym__octal_literal] = ACTIONS(5920),
    [sym__hex_literal] = ACTIONS(5920),
    [anon_sym_LPAREN_POUND] = ACTIONS(5922),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5922),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6032),
    [sym_implicit_parid] = ACTIONS(6034),
    [sym__conid] = ACTIONS(6036),
    [anon_sym_LBRACK] = ACTIONS(5929),
    [anon_sym_SQUOTE] = ACTIONS(6038),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5934),
    [anon_sym_6] = ACTIONS(5934),
    [anon_sym_7] = ACTIONS(5936),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5940),
  },
  [2360] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_implicit_param] = STATE(11309),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(11309),
    [sym__type_context] = STATE(11309),
    [sym__type_fun] = STATE(11309),
    [sym__type] = STATE(11309),
    [sym__type_or_implicit] = STATE(11309),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym_implicit_parid] = ACTIONS(6040),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2361] = {
    [sym_integer] = STATE(7818),
    [sym__literal] = STATE(7818),
    [sym__unboxed_open] = STATE(2165),
    [sym_constructor] = STATE(7684),
    [sym_con_unit] = STATE(7818),
    [sym_con_list] = STATE(7818),
    [sym_con_tuple] = STATE(7818),
    [sym_qualified_type] = STATE(7768),
    [sym_tycon_arrow] = STATE(7768),
    [sym_type_literal] = STATE(2799),
    [sym__promoted_tycon] = STATE(7768),
    [sym_type_variable] = STATE(7768),
    [sym_annotated_type_variable] = STATE(7768),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14565),
    [sym_type_parens] = STATE(2799),
    [sym_type_list] = STATE(2799),
    [sym_type_tuple] = STATE(2799),
    [sym__type_promotable_literal] = STATE(2799),
    [sym__type_promoted_literal] = STATE(2799),
    [sym__type_literal] = STATE(2799),
    [sym_type_name] = STATE(2788),
    [sym_type_star] = STATE(2799),
    [sym_type_unboxed_tuple] = STATE(2799),
    [sym_type_unboxed_sum] = STATE(2799),
    [sym__atype] = STATE(2799),
    [sym_type_apply] = STATE(8878),
    [sym__btype] = STATE(8878),
    [sym_implicit_param] = STATE(18495),
    [sym_type_infix] = STATE(13177),
    [sym__type_infix] = STATE(12764),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2638),
    [sym__type_quantifiers] = STATE(18495),
    [sym__type_context] = STATE(18495),
    [sym__type_fun] = STATE(18495),
    [sym__type] = STATE(18495),
    [sym__type_or_implicit] = STATE(18495),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15161),
    [sym_splice] = STATE(2799),
    [sym_quasiquote] = STATE(2799),
    [sym__varid] = ACTIONS(6042),
    [sym_float] = ACTIONS(6044),
    [sym_char] = ACTIONS(6044),
    [sym_string] = ACTIONS(6044),
    [sym__integer_literal] = ACTIONS(6046),
    [sym__binary_literal] = ACTIONS(6048),
    [sym__octal_literal] = ACTIONS(6048),
    [sym__hex_literal] = ACTIONS(6048),
    [anon_sym_LPAREN_POUND] = ACTIONS(6050),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6050),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6052),
    [sym_implicit_parid] = ACTIONS(6054),
    [sym__conid] = ACTIONS(6056),
    [anon_sym_LBRACK] = ACTIONS(6058),
    [anon_sym_SQUOTE] = ACTIONS(6060),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6062),
    [anon_sym_6] = ACTIONS(6062),
    [anon_sym_7] = ACTIONS(6064),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6066),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6068),
  },
  [2362] = {
    [sym_integer] = STATE(7485),
    [sym__literal] = STATE(7485),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7295),
    [sym_con_unit] = STATE(7485),
    [sym_con_list] = STATE(7485),
    [sym_con_tuple] = STATE(7485),
    [sym_qualified_type] = STATE(7412),
    [sym_tycon_arrow] = STATE(7412),
    [sym_type_literal] = STATE(2753),
    [sym__promoted_tycon] = STATE(7412),
    [sym_type_variable] = STATE(7412),
    [sym_annotated_type_variable] = STATE(7412),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14444),
    [sym_type_parens] = STATE(2753),
    [sym_type_list] = STATE(2753),
    [sym_type_tuple] = STATE(2753),
    [sym__type_promotable_literal] = STATE(2753),
    [sym__type_promoted_literal] = STATE(2753),
    [sym__type_literal] = STATE(2753),
    [sym_type_name] = STATE(2737),
    [sym_type_star] = STATE(2753),
    [sym_type_unboxed_tuple] = STATE(2753),
    [sym_type_unboxed_sum] = STATE(2753),
    [sym__atype] = STATE(2753),
    [sym_type_apply] = STATE(8310),
    [sym__btype] = STATE(8310),
    [sym_implicit_param] = STATE(16256),
    [sym_type_infix] = STATE(12638),
    [sym__type_infix] = STATE(12387),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2571),
    [sym__type_quantifiers] = STATE(16256),
    [sym__type_context] = STATE(16256),
    [sym__type_fun] = STATE(16256),
    [sym__type] = STATE(16256),
    [sym__type_or_implicit] = STATE(16256),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14836),
    [sym_splice] = STATE(2753),
    [sym_quasiquote] = STATE(2753),
    [sym__varid] = ACTIONS(6002),
    [sym_float] = ACTIONS(6004),
    [sym_char] = ACTIONS(6004),
    [sym_string] = ACTIONS(6004),
    [sym__integer_literal] = ACTIONS(6006),
    [sym__binary_literal] = ACTIONS(6008),
    [sym__octal_literal] = ACTIONS(6008),
    [sym__hex_literal] = ACTIONS(6008),
    [anon_sym_LPAREN_POUND] = ACTIONS(6010),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6010),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6012),
    [sym_implicit_parid] = ACTIONS(6014),
    [sym__conid] = ACTIONS(6016),
    [anon_sym_LBRACK] = ACTIONS(6018),
    [anon_sym_SQUOTE] = ACTIONS(6020),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6022),
    [anon_sym_6] = ACTIONS(6022),
    [anon_sym_7] = ACTIONS(6024),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6026),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6028),
  },
  [2363] = {
    [sym_integer] = STATE(6026),
    [sym__literal] = STATE(6026),
    [sym__unboxed_open] = STATE(2192),
    [sym_constructor] = STATE(5913),
    [sym_con_unit] = STATE(6026),
    [sym_con_list] = STATE(6026),
    [sym_con_tuple] = STATE(6026),
    [sym_qualified_type] = STATE(6029),
    [sym_tycon_arrow] = STATE(6029),
    [sym_type_literal] = STATE(2363),
    [sym__promoted_tycon] = STATE(6029),
    [sym_type_variable] = STATE(6029),
    [sym_annotated_type_variable] = STATE(6029),
    [sym_type_parens] = STATE(2363),
    [sym_type_list] = STATE(2363),
    [sym_type_tuple] = STATE(2363),
    [sym__type_promotable_literal] = STATE(2363),
    [sym__type_promoted_literal] = STATE(2363),
    [sym__type_literal] = STATE(2363),
    [sym_type_name] = STATE(2363),
    [sym_type_star] = STATE(2363),
    [sym_type_unboxed_tuple] = STATE(2363),
    [sym_type_unboxed_sum] = STATE(2363),
    [sym__atype] = STATE(2363),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15103),
    [sym_splice] = STATE(2363),
    [sym_quasiquote] = STATE(2363),
    [aux_sym_type_apply_repeat1] = STATE(2363),
    [sym__varid] = ACTIONS(6070),
    [sym_float] = ACTIONS(6073),
    [sym_char] = ACTIONS(6073),
    [sym_string] = ACTIONS(6073),
    [sym__integer_literal] = ACTIONS(6076),
    [sym__binary_literal] = ACTIONS(6079),
    [sym__octal_literal] = ACTIONS(6079),
    [sym__hex_literal] = ACTIONS(6079),
    [anon_sym_LPAREN_POUND] = ACTIONS(6082),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6082),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(6085),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(6088),
    [anon_sym_LBRACK] = ACTIONS(6091),
    [anon_sym_RBRACK] = ACTIONS(5030),
    [anon_sym_SQUOTE] = ACTIONS(6094),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(6097),
    [anon_sym_6] = ACTIONS(6097),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_DOT_DOT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(6100),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(6103),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5030),
    [sym_quasiquote_start] = ACTIONS(6106),
  },
  [2364] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14412),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_implicit_param] = STATE(17179),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(12341),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2561),
    [sym__type_quantifiers] = STATE(17179),
    [sym__type_context] = STATE(17179),
    [sym__type_fun] = STATE(17179),
    [sym__type] = STATE(17179),
    [sym__type_or_implicit] = STATE(17179),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(5274),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym_implicit_parid] = ACTIONS(6109),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
  },
  [2365] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_implicit_param] = STATE(14371),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14371),
    [sym__type_context] = STATE(14371),
    [sym__type_fun] = STATE(14371),
    [sym__type] = STATE(14371),
    [sym__type_or_implicit] = STATE(14371),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym_implicit_parid] = ACTIONS(5419),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
  },
  [2366] = {
    [sym_integer] = STATE(7581),
    [sym__literal] = STATE(7581),
    [sym__unboxed_open] = STATE(2145),
    [sym_constructor] = STATE(7303),
    [sym_con_unit] = STATE(7581),
    [sym_con_list] = STATE(7581),
    [sym_con_tuple] = STATE(7581),
    [sym_qualified_type] = STATE(7348),
    [sym_tycon_arrow] = STATE(7348),
    [sym_type_literal] = STATE(2754),
    [sym__promoted_tycon] = STATE(7348),
    [sym_type_variable] = STATE(7348),
    [sym_annotated_type_variable] = STATE(7348),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14002),
    [sym_type_parens] = STATE(2754),
    [sym_type_list] = STATE(2754),
    [sym_type_tuple] = STATE(2754),
    [sym__type_promotable_literal] = STATE(2754),
    [sym__type_promoted_literal] = STATE(2754),
    [sym__type_literal] = STATE(2754),
    [sym_type_name] = STATE(2750),
    [sym_type_star] = STATE(2754),
    [sym_type_unboxed_tuple] = STATE(2754),
    [sym_type_unboxed_sum] = STATE(2754),
    [sym__atype] = STATE(2754),
    [sym_type_apply] = STATE(8239),
    [sym__btype] = STATE(8239),
    [sym_implicit_param] = STATE(14731),
    [sym_type_infix] = STATE(12660),
    [sym__type_infix] = STATE(12425),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2584),
    [sym__type_quantifiers] = STATE(14731),
    [sym__type_context] = STATE(14731),
    [sym__type_fun] = STATE(14731),
    [sym__type] = STATE(14731),
    [sym__type_or_implicit] = STATE(14731),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14983),
    [sym_splice] = STATE(2754),
    [sym_quasiquote] = STATE(2754),
    [sym__varid] = ACTIONS(6111),
    [sym_float] = ACTIONS(6113),
    [sym_char] = ACTIONS(6113),
    [sym_string] = ACTIONS(6113),
    [sym__integer_literal] = ACTIONS(6115),
    [sym__binary_literal] = ACTIONS(6117),
    [sym__octal_literal] = ACTIONS(6117),
    [sym__hex_literal] = ACTIONS(6117),
    [anon_sym_LPAREN_POUND] = ACTIONS(6119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6119),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [sym_implicit_parid] = ACTIONS(6123),
    [sym__conid] = ACTIONS(6125),
    [anon_sym_LBRACK] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6129),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_6] = ACTIONS(6131),
    [anon_sym_7] = ACTIONS(6133),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6137),
  },
  [2367] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_implicit_param] = STATE(18283),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(18283),
    [sym__type_context] = STATE(18283),
    [sym__type_fun] = STATE(18283),
    [sym__type] = STATE(18283),
    [sym__type_or_implicit] = STATE(18283),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym_implicit_parid] = ACTIONS(6040),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2368] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(18345),
    [sym__constraint_context] = STATE(18345),
    [sym__constraint] = STATE(18345),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(13971),
    [sym__type_context] = STATE(13971),
    [sym__type_fun] = STATE(13971),
    [sym__type] = STATE(13971),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2369] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14412),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_implicit_param] = STATE(16062),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(12341),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2561),
    [sym__type_quantifiers] = STATE(16062),
    [sym__type_context] = STATE(16062),
    [sym__type_fun] = STATE(16062),
    [sym__type] = STATE(16062),
    [sym__type_or_implicit] = STATE(16062),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(5274),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym_implicit_parid] = ACTIONS(6109),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
  },
  [2370] = {
    [sym_integer] = STATE(7485),
    [sym__literal] = STATE(7485),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7295),
    [sym_con_unit] = STATE(7485),
    [sym_con_list] = STATE(7485),
    [sym_con_tuple] = STATE(7485),
    [sym_qualified_type] = STATE(7412),
    [sym_tycon_arrow] = STATE(7412),
    [sym_type_literal] = STATE(2753),
    [sym__promoted_tycon] = STATE(7412),
    [sym_type_variable] = STATE(7412),
    [sym_annotated_type_variable] = STATE(7412),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14444),
    [sym_type_parens] = STATE(2753),
    [sym_type_list] = STATE(2753),
    [sym_type_tuple] = STATE(2753),
    [sym__type_promotable_literal] = STATE(2753),
    [sym__type_promoted_literal] = STATE(2753),
    [sym__type_literal] = STATE(2753),
    [sym_type_name] = STATE(2737),
    [sym_type_star] = STATE(2753),
    [sym_type_unboxed_tuple] = STATE(2753),
    [sym_type_unboxed_sum] = STATE(2753),
    [sym__atype] = STATE(2753),
    [sym_type_apply] = STATE(8310),
    [sym__btype] = STATE(8310),
    [sym_implicit_param] = STATE(15971),
    [sym_type_infix] = STATE(12638),
    [sym__type_infix] = STATE(12387),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2571),
    [sym__type_quantifiers] = STATE(15971),
    [sym__type_context] = STATE(15971),
    [sym__type_fun] = STATE(15971),
    [sym__type] = STATE(15971),
    [sym__type_or_implicit] = STATE(15971),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14836),
    [sym_splice] = STATE(2753),
    [sym_quasiquote] = STATE(2753),
    [sym__varid] = ACTIONS(6002),
    [sym_float] = ACTIONS(6004),
    [sym_char] = ACTIONS(6004),
    [sym_string] = ACTIONS(6004),
    [sym__integer_literal] = ACTIONS(6006),
    [sym__binary_literal] = ACTIONS(6008),
    [sym__octal_literal] = ACTIONS(6008),
    [sym__hex_literal] = ACTIONS(6008),
    [anon_sym_LPAREN_POUND] = ACTIONS(6010),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6010),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6012),
    [sym_implicit_parid] = ACTIONS(6014),
    [sym__conid] = ACTIONS(6016),
    [anon_sym_LBRACK] = ACTIONS(6018),
    [anon_sym_SQUOTE] = ACTIONS(6020),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6022),
    [anon_sym_6] = ACTIONS(6022),
    [anon_sym_7] = ACTIONS(6024),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6026),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6028),
  },
  [2371] = {
    [sym_integer] = STATE(7705),
    [sym__literal] = STATE(7705),
    [sym__unboxed_open] = STATE(2184),
    [sym_constructor] = STATE(7681),
    [sym_con_unit] = STATE(7705),
    [sym_con_list] = STATE(7705),
    [sym_con_tuple] = STATE(7705),
    [sym_qualified_type] = STATE(7706),
    [sym_tycon_arrow] = STATE(7706),
    [sym_type_literal] = STATE(2802),
    [sym__promoted_tycon] = STATE(7706),
    [sym_type_variable] = STATE(7706),
    [sym_annotated_type_variable] = STATE(7706),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14603),
    [sym_type_parens] = STATE(2802),
    [sym_type_list] = STATE(2802),
    [sym_type_tuple] = STATE(2802),
    [sym__type_promotable_literal] = STATE(2802),
    [sym__type_promoted_literal] = STATE(2802),
    [sym__type_literal] = STATE(2802),
    [sym_type_name] = STATE(2805),
    [sym_type_star] = STATE(2802),
    [sym_type_unboxed_tuple] = STATE(2802),
    [sym_type_unboxed_sum] = STATE(2802),
    [sym__atype] = STATE(2802),
    [sym_type_apply] = STATE(8735),
    [sym__btype] = STATE(8735),
    [sym_implicit_param] = STATE(14783),
    [sym_type_infix] = STATE(13317),
    [sym__type_infix] = STATE(13018),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2597),
    [sym__type_quantifiers] = STATE(14783),
    [sym__type_context] = STATE(14783),
    [sym__type_fun] = STATE(14783),
    [sym__type] = STATE(14783),
    [sym__type_or_implicit] = STATE(14783),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15120),
    [sym_splice] = STATE(2802),
    [sym_quasiquote] = STATE(2802),
    [sym__varid] = ACTIONS(6139),
    [sym_float] = ACTIONS(6141),
    [sym_char] = ACTIONS(6141),
    [sym_string] = ACTIONS(6141),
    [sym__integer_literal] = ACTIONS(6143),
    [sym__binary_literal] = ACTIONS(6145),
    [sym__octal_literal] = ACTIONS(6145),
    [sym__hex_literal] = ACTIONS(6145),
    [anon_sym_LPAREN_POUND] = ACTIONS(6147),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6147),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6149),
    [sym_implicit_parid] = ACTIONS(6151),
    [sym__conid] = ACTIONS(6153),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_SQUOTE] = ACTIONS(6157),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6159),
    [anon_sym_6] = ACTIONS(6159),
    [anon_sym_7] = ACTIONS(6161),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6163),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6165),
  },
  [2372] = {
    [sym_integer] = STATE(7386),
    [sym__literal] = STATE(7386),
    [sym__unboxed_open] = STATE(2197),
    [sym_constructor] = STATE(7110),
    [sym_con_unit] = STATE(7386),
    [sym_con_list] = STATE(7386),
    [sym_con_tuple] = STATE(7386),
    [sym_qualified_type] = STATE(7585),
    [sym_tycon_arrow] = STATE(7585),
    [sym_type_literal] = STATE(2736),
    [sym__promoted_tycon] = STATE(7585),
    [sym_type_variable] = STATE(7585),
    [sym_annotated_type_variable] = STATE(7585),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14082),
    [sym_type_parens] = STATE(2736),
    [sym_type_list] = STATE(2736),
    [sym_type_tuple] = STATE(2736),
    [sym__type_promotable_literal] = STATE(2736),
    [sym__type_promoted_literal] = STATE(2736),
    [sym__type_literal] = STATE(2736),
    [sym_type_name] = STATE(2755),
    [sym_type_star] = STATE(2736),
    [sym_type_unboxed_tuple] = STATE(2736),
    [sym_type_unboxed_sum] = STATE(2736),
    [sym__atype] = STATE(2736),
    [sym_type_apply] = STATE(8314),
    [sym__btype] = STATE(8314),
    [sym_implicit_param] = STATE(15170),
    [sym_type_infix] = STATE(12645),
    [sym__type_infix] = STATE(12371),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2503),
    [sym__type_quantifiers] = STATE(15170),
    [sym__type_context] = STATE(15170),
    [sym__type_fun] = STATE(15170),
    [sym__type] = STATE(15170),
    [sym__type_or_implicit] = STATE(15170),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15277),
    [sym_splice] = STATE(2736),
    [sym_quasiquote] = STATE(2736),
    [sym__varid] = ACTIONS(6167),
    [sym_float] = ACTIONS(6169),
    [sym_char] = ACTIONS(6169),
    [sym_string] = ACTIONS(6169),
    [sym__integer_literal] = ACTIONS(6171),
    [sym__binary_literal] = ACTIONS(6173),
    [sym__octal_literal] = ACTIONS(6173),
    [sym__hex_literal] = ACTIONS(6173),
    [anon_sym_LPAREN_POUND] = ACTIONS(6175),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6175),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6177),
    [sym_implicit_parid] = ACTIONS(6179),
    [sym__conid] = ACTIONS(6181),
    [anon_sym_LBRACK] = ACTIONS(6183),
    [anon_sym_SQUOTE] = ACTIONS(6185),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6187),
    [anon_sym_6] = ACTIONS(6187),
    [anon_sym_7] = ACTIONS(6189),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6191),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6193),
  },
  [2373] = {
    [sym_integer] = STATE(6228),
    [sym__literal] = STATE(6228),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(5787),
    [sym_con_unit] = STATE(6228),
    [sym_con_list] = STATE(6228),
    [sym_con_tuple] = STATE(6228),
    [sym_qualified_type] = STATE(6115),
    [sym_tycon_arrow] = STATE(6115),
    [sym_type_literal] = STATE(2385),
    [sym__promoted_tycon] = STATE(6115),
    [sym_type_variable] = STATE(6115),
    [sym_annotated_type_variable] = STATE(6115),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14177),
    [sym_type_parens] = STATE(2385),
    [sym_type_list] = STATE(2385),
    [sym_type_tuple] = STATE(2385),
    [sym__type_promotable_literal] = STATE(2385),
    [sym__type_promoted_literal] = STATE(2385),
    [sym__type_literal] = STATE(2385),
    [sym_type_name] = STATE(2427),
    [sym_type_star] = STATE(2385),
    [sym_type_unboxed_tuple] = STATE(2385),
    [sym_type_unboxed_sum] = STATE(2385),
    [sym__atype] = STATE(2385),
    [sym_type_apply] = STATE(7511),
    [sym__btype] = STATE(7511),
    [sym_implicit_param] = STATE(11694),
    [sym_type_infix] = STATE(9687),
    [sym__type_infix] = STATE(9538),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2547),
    [sym__type_quantifiers] = STATE(11694),
    [sym__type_context] = STATE(11694),
    [sym__type_fun] = STATE(11694),
    [sym__type] = STATE(11694),
    [sym__type_or_implicit] = STATE(11694),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15408),
    [sym_splice] = STATE(2385),
    [sym_quasiquote] = STATE(2385),
    [sym__varid] = ACTIONS(6195),
    [sym_float] = ACTIONS(6197),
    [sym_char] = ACTIONS(6197),
    [sym_string] = ACTIONS(6197),
    [sym__integer_literal] = ACTIONS(6199),
    [sym__binary_literal] = ACTIONS(6201),
    [sym__octal_literal] = ACTIONS(6201),
    [sym__hex_literal] = ACTIONS(6201),
    [anon_sym_LPAREN_POUND] = ACTIONS(6203),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6203),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6205),
    [sym_implicit_parid] = ACTIONS(6207),
    [sym__conid] = ACTIONS(6209),
    [anon_sym_LBRACK] = ACTIONS(6211),
    [anon_sym_SQUOTE] = ACTIONS(6213),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6215),
    [anon_sym_6] = ACTIONS(6215),
    [anon_sym_7] = ACTIONS(6217),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6219),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6221),
  },
  [2374] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14412),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_implicit_param] = STATE(16271),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(12341),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2561),
    [sym__type_quantifiers] = STATE(16271),
    [sym__type_context] = STATE(16271),
    [sym__type_fun] = STATE(16271),
    [sym__type] = STATE(16271),
    [sym__type_or_implicit] = STATE(16271),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(5274),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym_implicit_parid] = ACTIONS(6109),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
  },
  [2375] = {
    [sym_integer] = STATE(8351),
    [sym__literal] = STATE(8351),
    [sym__unboxed_open] = STATE(2164),
    [sym_constructor] = STATE(8075),
    [sym_con_unit] = STATE(8351),
    [sym_con_list] = STATE(8351),
    [sym_con_tuple] = STATE(8351),
    [sym_qualified_type] = STATE(8355),
    [sym_tycon_arrow] = STATE(8355),
    [sym_type_literal] = STATE(2823),
    [sym__promoted_tycon] = STATE(8355),
    [sym_type_variable] = STATE(8355),
    [sym_annotated_type_variable] = STATE(8355),
    [sym_type_parens] = STATE(2823),
    [sym_type_list] = STATE(2823),
    [sym_type_tuple] = STATE(2823),
    [sym__type_promotable_literal] = STATE(2823),
    [sym__type_promoted_literal] = STATE(2823),
    [sym__type_literal] = STATE(2823),
    [sym_strict_type] = STATE(2823),
    [sym_lazy_type] = STATE(2823),
    [sym_type_name] = STATE(2823),
    [sym_type_star] = STATE(2823),
    [sym_type_unboxed_tuple] = STATE(2823),
    [sym_type_unboxed_sum] = STATE(2823),
    [sym__atype] = STATE(2823),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15062),
    [sym_record_fields] = STATE(14353),
    [sym_splice] = STATE(2823),
    [sym_quasiquote] = STATE(2823),
    [aux_sym_data_constructor_repeat1] = STATE(2823),
    [sym__varid] = ACTIONS(6223),
    [anon_sym_SEMI] = ACTIONS(6226),
    [sym_float] = ACTIONS(6228),
    [sym_char] = ACTIONS(6228),
    [sym_string] = ACTIONS(6228),
    [sym__integer_literal] = ACTIONS(6231),
    [sym__binary_literal] = ACTIONS(6234),
    [sym__octal_literal] = ACTIONS(6234),
    [sym__hex_literal] = ACTIONS(6234),
    [anon_sym_LPAREN_POUND] = ACTIONS(6237),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6237),
    [anon_sym_] = ACTIONS(6240),
    [anon_sym_EQ_GT] = ACTIONS(6240),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6242),
    [anon_sym_BQUOTE] = ACTIONS(6240),
    [sym__conid] = ACTIONS(6245),
    [anon_sym_LBRACK] = ACTIONS(6248),
    [anon_sym_SQUOTE] = ACTIONS(6251),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_STAR] = ACTIONS(6254),
    [anon_sym_6] = ACTIONS(6254),
    [anon_sym_LBRACE] = ACTIONS(6257),
    [anon_sym_deriving] = ACTIONS(6259),
    [anon_sym_7] = ACTIONS(6261),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(6226),
    [sym__layout_end] = ACTIONS(6226),
    [sym__dot] = ACTIONS(6264),
    [sym__splice_dollar] = ACTIONS(6266),
    [sym__consym] = ACTIONS(6240),
    [sym__tyconsym] = ACTIONS(6240),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6269),
    [sym__strict] = ACTIONS(6272),
    [sym__lazy] = ACTIONS(6274),
  },
  [2376] = {
    [sym_integer] = STATE(6064),
    [sym__literal] = STATE(6064),
    [sym__unboxed_open] = STATE(2150),
    [sym_constructor] = STATE(5877),
    [sym_con_unit] = STATE(6064),
    [sym_con_list] = STATE(6064),
    [sym_con_tuple] = STATE(6064),
    [sym_qualified_type] = STATE(6066),
    [sym_tycon_arrow] = STATE(6066),
    [sym_type_literal] = STATE(2378),
    [sym__promoted_tycon] = STATE(6066),
    [sym_type_variable] = STATE(6066),
    [sym_annotated_type_variable] = STATE(6066),
    [sym_type_parens] = STATE(2378),
    [sym_type_list] = STATE(2378),
    [sym_type_tuple] = STATE(2378),
    [sym__type_promotable_literal] = STATE(2378),
    [sym__type_promoted_literal] = STATE(2378),
    [sym__type_literal] = STATE(2378),
    [sym_type_name] = STATE(2378),
    [sym_type_star] = STATE(2378),
    [sym_type_unboxed_tuple] = STATE(2378),
    [sym_type_unboxed_sum] = STATE(2378),
    [sym__atype] = STATE(2378),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14778),
    [sym_splice] = STATE(2378),
    [sym_quasiquote] = STATE(2378),
    [aux_sym_type_apply_repeat1] = STATE(2378),
    [ts_builtin_sym_end] = ACTIONS(5078),
    [sym__varid] = ACTIONS(6276),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(6278),
    [sym_char] = ACTIONS(6278),
    [sym_string] = ACTIONS(6278),
    [sym__integer_literal] = ACTIONS(6280),
    [sym__binary_literal] = ACTIONS(6282),
    [sym__octal_literal] = ACTIONS(6282),
    [sym__hex_literal] = ACTIONS(6282),
    [anon_sym_LPAREN_POUND] = ACTIONS(6284),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6284),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(6286),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(6288),
    [anon_sym_LBRACK] = ACTIONS(6291),
    [anon_sym_SQUOTE] = ACTIONS(6293),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_6] = ACTIONS(6296),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(6298),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6300),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6302),
  },
  [2377] = {
    [sym_integer] = STATE(6592),
    [sym__literal] = STATE(6592),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6403),
    [sym_con_unit] = STATE(6592),
    [sym_con_list] = STATE(6592),
    [sym_con_tuple] = STATE(6592),
    [sym_qualified_type] = STATE(6680),
    [sym_tycon_arrow] = STATE(6680),
    [sym_type_literal] = STATE(2491),
    [sym__promoted_tycon] = STATE(6680),
    [sym_type_variable] = STATE(6680),
    [sym_annotated_type_variable] = STATE(6680),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14515),
    [sym_type_parens] = STATE(2491),
    [sym_type_list] = STATE(2491),
    [sym_type_tuple] = STATE(2491),
    [sym__type_promotable_literal] = STATE(2491),
    [sym__type_promoted_literal] = STATE(2491),
    [sym__type_literal] = STATE(2491),
    [sym_type_name] = STATE(2480),
    [sym_type_star] = STATE(2491),
    [sym_type_unboxed_tuple] = STATE(2491),
    [sym_type_unboxed_sum] = STATE(2491),
    [sym__atype] = STATE(2491),
    [sym_type_apply] = STATE(7807),
    [sym__btype] = STATE(7807),
    [sym_implicit_param] = STATE(14029),
    [sym_type_infix] = STATE(11549),
    [sym__type_infix] = STATE(12168),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2544),
    [sym__type_quantifiers] = STATE(14029),
    [sym__type_context] = STATE(14029),
    [sym__type_fun] = STATE(14029),
    [sym__type] = STATE(14029),
    [sym__type_or_implicit] = STATE(14029),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14854),
    [sym_splice] = STATE(2491),
    [sym_quasiquote] = STATE(2491),
    [sym__varid] = ACTIONS(6304),
    [sym_float] = ACTIONS(6306),
    [sym_char] = ACTIONS(6306),
    [sym_string] = ACTIONS(6306),
    [sym__integer_literal] = ACTIONS(6308),
    [sym__binary_literal] = ACTIONS(6310),
    [sym__octal_literal] = ACTIONS(6310),
    [sym__hex_literal] = ACTIONS(6310),
    [anon_sym_LPAREN_POUND] = ACTIONS(6312),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6312),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6314),
    [sym_implicit_parid] = ACTIONS(6316),
    [sym__conid] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_6] = ACTIONS(6324),
    [anon_sym_7] = ACTIONS(6326),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6328),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6330),
  },
  [2378] = {
    [sym_integer] = STATE(6064),
    [sym__literal] = STATE(6064),
    [sym__unboxed_open] = STATE(2150),
    [sym_constructor] = STATE(5877),
    [sym_con_unit] = STATE(6064),
    [sym_con_list] = STATE(6064),
    [sym_con_tuple] = STATE(6064),
    [sym_qualified_type] = STATE(6066),
    [sym_tycon_arrow] = STATE(6066),
    [sym_type_literal] = STATE(2410),
    [sym__promoted_tycon] = STATE(6066),
    [sym_type_variable] = STATE(6066),
    [sym_annotated_type_variable] = STATE(6066),
    [sym_type_parens] = STATE(2410),
    [sym_type_list] = STATE(2410),
    [sym_type_tuple] = STATE(2410),
    [sym__type_promotable_literal] = STATE(2410),
    [sym__type_promoted_literal] = STATE(2410),
    [sym__type_literal] = STATE(2410),
    [sym_type_name] = STATE(2410),
    [sym_type_star] = STATE(2410),
    [sym_type_unboxed_tuple] = STATE(2410),
    [sym_type_unboxed_sum] = STATE(2410),
    [sym__atype] = STATE(2410),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14778),
    [sym_splice] = STATE(2410),
    [sym_quasiquote] = STATE(2410),
    [aux_sym_type_apply_repeat1] = STATE(2410),
    [ts_builtin_sym_end] = ACTIONS(5177),
    [sym__varid] = ACTIONS(6276),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(6278),
    [sym_char] = ACTIONS(6278),
    [sym_string] = ACTIONS(6278),
    [sym__integer_literal] = ACTIONS(6280),
    [sym__binary_literal] = ACTIONS(6282),
    [sym__octal_literal] = ACTIONS(6282),
    [sym__hex_literal] = ACTIONS(6282),
    [anon_sym_LPAREN_POUND] = ACTIONS(6284),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6284),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(6286),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(6332),
    [anon_sym_LBRACK] = ACTIONS(6291),
    [anon_sym_SQUOTE] = ACTIONS(6335),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_6] = ACTIONS(6296),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(6298),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6300),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6302),
  },
  [2379] = {
    [sym_integer] = STATE(5958),
    [sym__literal] = STATE(5958),
    [sym__unboxed_open] = STATE(2212),
    [sym_constructor] = STATE(5940),
    [sym_con_unit] = STATE(5958),
    [sym_con_list] = STATE(5958),
    [sym_con_tuple] = STATE(5958),
    [sym_qualified_type] = STATE(5952),
    [sym_tycon_arrow] = STATE(5952),
    [sym_type_literal] = STATE(2418),
    [sym__promoted_tycon] = STATE(5952),
    [sym_type_variable] = STATE(5952),
    [sym_annotated_type_variable] = STATE(5952),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14367),
    [sym_type_parens] = STATE(2418),
    [sym_type_list] = STATE(2418),
    [sym_type_tuple] = STATE(2418),
    [sym__type_promotable_literal] = STATE(2418),
    [sym__type_promoted_literal] = STATE(2418),
    [sym__type_literal] = STATE(2418),
    [sym_type_name] = STATE(2425),
    [sym_type_star] = STATE(2418),
    [sym_type_unboxed_tuple] = STATE(2418),
    [sym_type_unboxed_sum] = STATE(2418),
    [sym__atype] = STATE(2418),
    [sym_type_apply] = STATE(7561),
    [sym__btype] = STATE(7561),
    [sym_implicit_param] = STATE(10709),
    [sym_type_infix] = STATE(9686),
    [sym__type_infix] = STATE(9571),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2640),
    [sym__type_quantifiers] = STATE(10709),
    [sym__type_context] = STATE(10709),
    [sym__type_fun] = STATE(10709),
    [sym__type] = STATE(10709),
    [sym__type_or_implicit] = STATE(10709),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15080),
    [sym_splice] = STATE(2418),
    [sym_quasiquote] = STATE(2418),
    [sym__varid] = ACTIONS(6338),
    [sym_float] = ACTIONS(6340),
    [sym_char] = ACTIONS(6340),
    [sym_string] = ACTIONS(6340),
    [sym__integer_literal] = ACTIONS(6342),
    [sym__binary_literal] = ACTIONS(6344),
    [sym__octal_literal] = ACTIONS(6344),
    [sym__hex_literal] = ACTIONS(6344),
    [anon_sym_LPAREN_POUND] = ACTIONS(6346),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6346),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6348),
    [sym_implicit_parid] = ACTIONS(6350),
    [sym__conid] = ACTIONS(6352),
    [anon_sym_LBRACK] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6356),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6358),
    [anon_sym_6] = ACTIONS(6358),
    [anon_sym_7] = ACTIONS(6360),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6362),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6364),
  },
  [2380] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_implicit_param] = STATE(18072),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(18072),
    [sym__type_context] = STATE(18072),
    [sym__type_fun] = STATE(18072),
    [sym__type] = STATE(18072),
    [sym__type_or_implicit] = STATE(18072),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym_implicit_parid] = ACTIONS(6040),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2381] = {
    [sym_integer] = STATE(7485),
    [sym__literal] = STATE(7485),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7295),
    [sym_con_unit] = STATE(7485),
    [sym_con_list] = STATE(7485),
    [sym_con_tuple] = STATE(7485),
    [sym_qualified_type] = STATE(7412),
    [sym_tycon_arrow] = STATE(7412),
    [sym_type_literal] = STATE(2753),
    [sym__promoted_tycon] = STATE(7412),
    [sym_type_variable] = STATE(7412),
    [sym_annotated_type_variable] = STATE(7412),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14444),
    [sym_type_parens] = STATE(2753),
    [sym_type_list] = STATE(2753),
    [sym_type_tuple] = STATE(2753),
    [sym__type_promotable_literal] = STATE(2753),
    [sym__type_promoted_literal] = STATE(2753),
    [sym__type_literal] = STATE(2753),
    [sym_type_name] = STATE(2737),
    [sym_type_star] = STATE(2753),
    [sym_type_unboxed_tuple] = STATE(2753),
    [sym_type_unboxed_sum] = STATE(2753),
    [sym__atype] = STATE(2753),
    [sym_type_apply] = STATE(8310),
    [sym__btype] = STATE(8310),
    [sym_implicit_param] = STATE(15854),
    [sym_type_infix] = STATE(12638),
    [sym__type_infix] = STATE(12387),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2571),
    [sym__type_quantifiers] = STATE(15854),
    [sym__type_context] = STATE(15854),
    [sym__type_fun] = STATE(15854),
    [sym__type] = STATE(15854),
    [sym__type_or_implicit] = STATE(15854),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14836),
    [sym_splice] = STATE(2753),
    [sym_quasiquote] = STATE(2753),
    [sym__varid] = ACTIONS(6002),
    [sym_float] = ACTIONS(6004),
    [sym_char] = ACTIONS(6004),
    [sym_string] = ACTIONS(6004),
    [sym__integer_literal] = ACTIONS(6006),
    [sym__binary_literal] = ACTIONS(6008),
    [sym__octal_literal] = ACTIONS(6008),
    [sym__hex_literal] = ACTIONS(6008),
    [anon_sym_LPAREN_POUND] = ACTIONS(6010),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6010),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6012),
    [sym_implicit_parid] = ACTIONS(6014),
    [sym__conid] = ACTIONS(6016),
    [anon_sym_LBRACK] = ACTIONS(6018),
    [anon_sym_SQUOTE] = ACTIONS(6020),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6022),
    [anon_sym_6] = ACTIONS(6022),
    [anon_sym_7] = ACTIONS(6024),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6026),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6028),
  },
  [2382] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14398),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2797),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_type_infix] = STATE(13123),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(18523),
    [sym__constraint_context] = STATE(18523),
    [sym__constraint] = STATE(18523),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2368),
    [sym__type_quantifiers] = STATE(13658),
    [sym__type_context] = STATE(13658),
    [sym__type_fun] = STATE(13658),
    [sym__type] = STATE(13658),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1982),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2383] = {
    [sym_integer] = STATE(7104),
    [sym__literal] = STATE(7104),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7046),
    [sym_con_unit] = STATE(7104),
    [sym_con_list] = STATE(7104),
    [sym_con_tuple] = STATE(7104),
    [sym_qualified_type] = STATE(7087),
    [sym_tycon_arrow] = STATE(7087),
    [sym_type_literal] = STATE(2721),
    [sym__promoted_tycon] = STATE(7087),
    [sym_type_variable] = STATE(7087),
    [sym_annotated_type_variable] = STATE(7087),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14084),
    [sym_type_parens] = STATE(2721),
    [sym_type_list] = STATE(2721),
    [sym_type_tuple] = STATE(2721),
    [sym__type_promotable_literal] = STATE(2721),
    [sym__type_promoted_literal] = STATE(2721),
    [sym__type_literal] = STATE(2721),
    [sym_type_name] = STATE(2688),
    [sym_type_star] = STATE(2721),
    [sym_type_unboxed_tuple] = STATE(2721),
    [sym_type_unboxed_sum] = STATE(2721),
    [sym__atype] = STATE(2721),
    [sym_type_apply] = STATE(8113),
    [sym__btype] = STATE(8113),
    [sym_implicit_param] = STATE(14605),
    [sym_type_infix] = STATE(12422),
    [sym__type_infix] = STATE(11995),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2636),
    [sym__type_quantifiers] = STATE(14605),
    [sym__type_context] = STATE(14605),
    [sym__type_fun] = STATE(14605),
    [sym__type] = STATE(14605),
    [sym__type_or_implicit] = STATE(14605),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15134),
    [sym_splice] = STATE(2721),
    [sym_quasiquote] = STATE(2721),
    [sym__varid] = ACTIONS(6366),
    [sym_float] = ACTIONS(6368),
    [sym_char] = ACTIONS(6368),
    [sym_string] = ACTIONS(6368),
    [sym__integer_literal] = ACTIONS(6370),
    [sym__binary_literal] = ACTIONS(6372),
    [sym__octal_literal] = ACTIONS(6372),
    [sym__hex_literal] = ACTIONS(6372),
    [anon_sym_LPAREN_POUND] = ACTIONS(6374),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6374),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [sym_implicit_parid] = ACTIONS(6378),
    [sym__conid] = ACTIONS(6380),
    [anon_sym_LBRACK] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6384),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6386),
    [anon_sym_6] = ACTIONS(6386),
    [anon_sym_7] = ACTIONS(6388),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6390),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6392),
  },
  [2384] = {
    [sym_integer] = STATE(5998),
    [sym__literal] = STATE(5998),
    [sym__unboxed_open] = STATE(2200),
    [sym_constructor] = STATE(5931),
    [sym_con_unit] = STATE(5998),
    [sym_con_list] = STATE(5998),
    [sym_con_tuple] = STATE(5998),
    [sym_qualified_type] = STATE(5996),
    [sym_tycon_arrow] = STATE(5996),
    [sym_type_literal] = STATE(2403),
    [sym__promoted_tycon] = STATE(5996),
    [sym_type_variable] = STATE(5996),
    [sym_annotated_type_variable] = STATE(5996),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14150),
    [sym_type_parens] = STATE(2403),
    [sym_type_list] = STATE(2403),
    [sym_type_tuple] = STATE(2403),
    [sym__type_promotable_literal] = STATE(2403),
    [sym__type_promoted_literal] = STATE(2403),
    [sym__type_literal] = STATE(2403),
    [sym_type_name] = STATE(2433),
    [sym_type_star] = STATE(2403),
    [sym_type_unboxed_tuple] = STATE(2403),
    [sym_type_unboxed_sum] = STATE(2403),
    [sym__atype] = STATE(2403),
    [sym_type_apply] = STATE(7479),
    [sym__btype] = STATE(7479),
    [sym_implicit_param] = STATE(11624),
    [sym_type_infix] = STATE(9706),
    [sym__type_infix] = STATE(9574),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2632),
    [sym__type_quantifiers] = STATE(11624),
    [sym__type_context] = STATE(11624),
    [sym__type_fun] = STATE(11624),
    [sym__type] = STATE(11624),
    [sym__type_or_implicit] = STATE(11624),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15278),
    [sym_splice] = STATE(2403),
    [sym_quasiquote] = STATE(2403),
    [sym__varid] = ACTIONS(6394),
    [sym_float] = ACTIONS(6396),
    [sym_char] = ACTIONS(6396),
    [sym_string] = ACTIONS(6396),
    [sym__integer_literal] = ACTIONS(6398),
    [sym__binary_literal] = ACTIONS(6400),
    [sym__octal_literal] = ACTIONS(6400),
    [sym__hex_literal] = ACTIONS(6400),
    [anon_sym_LPAREN_POUND] = ACTIONS(6402),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6402),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [sym_implicit_parid] = ACTIONS(6406),
    [sym__conid] = ACTIONS(6408),
    [anon_sym_LBRACK] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6412),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6414),
    [anon_sym_6] = ACTIONS(6414),
    [anon_sym_7] = ACTIONS(6416),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6418),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6420),
  },
  [2385] = {
    [sym_integer] = STATE(6228),
    [sym__literal] = STATE(6228),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(5787),
    [sym_con_unit] = STATE(6228),
    [sym_con_list] = STATE(6228),
    [sym_con_tuple] = STATE(6228),
    [sym_qualified_type] = STATE(6115),
    [sym_tycon_arrow] = STATE(6115),
    [sym_type_literal] = STATE(2387),
    [sym__promoted_tycon] = STATE(6115),
    [sym_type_variable] = STATE(6115),
    [sym_annotated_type_variable] = STATE(6115),
    [sym_type_parens] = STATE(2387),
    [sym_type_list] = STATE(2387),
    [sym_type_tuple] = STATE(2387),
    [sym__type_promotable_literal] = STATE(2387),
    [sym__type_promoted_literal] = STATE(2387),
    [sym__type_literal] = STATE(2387),
    [sym_type_name] = STATE(2387),
    [sym_type_star] = STATE(2387),
    [sym_type_unboxed_tuple] = STATE(2387),
    [sym_type_unboxed_sum] = STATE(2387),
    [sym__atype] = STATE(2387),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15408),
    [sym_splice] = STATE(2387),
    [sym_quasiquote] = STATE(2387),
    [aux_sym_type_apply_repeat1] = STATE(2387),
    [sym__varid] = ACTIONS(6195),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(6197),
    [sym_char] = ACTIONS(6197),
    [sym_string] = ACTIONS(6197),
    [sym__integer_literal] = ACTIONS(6199),
    [sym__binary_literal] = ACTIONS(6201),
    [sym__octal_literal] = ACTIONS(6201),
    [sym__hex_literal] = ACTIONS(6201),
    [anon_sym_LPAREN_POUND] = ACTIONS(6203),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6203),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(6422),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(6424),
    [anon_sym_LBRACK] = ACTIONS(6211),
    [anon_sym_SQUOTE] = ACTIONS(6427),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(6215),
    [anon_sym_6] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_in] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(6217),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6219),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6221),
  },
  [2386] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_implicit_param] = STATE(18080),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(18080),
    [sym__type_context] = STATE(18080),
    [sym__type_fun] = STATE(18080),
    [sym__type] = STATE(18080),
    [sym__type_or_implicit] = STATE(18080),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym_implicit_parid] = ACTIONS(6040),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2387] = {
    [sym_integer] = STATE(6228),
    [sym__literal] = STATE(6228),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(5787),
    [sym_con_unit] = STATE(6228),
    [sym_con_list] = STATE(6228),
    [sym_con_tuple] = STATE(6228),
    [sym_qualified_type] = STATE(6115),
    [sym_tycon_arrow] = STATE(6115),
    [sym_type_literal] = STATE(2431),
    [sym__promoted_tycon] = STATE(6115),
    [sym_type_variable] = STATE(6115),
    [sym_annotated_type_variable] = STATE(6115),
    [sym_type_parens] = STATE(2431),
    [sym_type_list] = STATE(2431),
    [sym_type_tuple] = STATE(2431),
    [sym__type_promotable_literal] = STATE(2431),
    [sym__type_promoted_literal] = STATE(2431),
    [sym__type_literal] = STATE(2431),
    [sym_type_name] = STATE(2431),
    [sym_type_star] = STATE(2431),
    [sym_type_unboxed_tuple] = STATE(2431),
    [sym_type_unboxed_sum] = STATE(2431),
    [sym__atype] = STATE(2431),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15408),
    [sym_splice] = STATE(2431),
    [sym_quasiquote] = STATE(2431),
    [aux_sym_type_apply_repeat1] = STATE(2431),
    [sym__varid] = ACTIONS(6195),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(6197),
    [sym_char] = ACTIONS(6197),
    [sym_string] = ACTIONS(6197),
    [sym__integer_literal] = ACTIONS(6199),
    [sym__binary_literal] = ACTIONS(6201),
    [sym__octal_literal] = ACTIONS(6201),
    [sym__hex_literal] = ACTIONS(6201),
    [anon_sym_LPAREN_POUND] = ACTIONS(6203),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6203),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(6422),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(6430),
    [anon_sym_LBRACK] = ACTIONS(6211),
    [anon_sym_SQUOTE] = ACTIONS(6433),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(6215),
    [anon_sym_6] = ACTIONS(6215),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_in] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(6217),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6219),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6221),
  },
  [2388] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14412),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_implicit_param] = STATE(16460),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(12341),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2561),
    [sym__type_quantifiers] = STATE(16460),
    [sym__type_context] = STATE(16460),
    [sym__type_fun] = STATE(16460),
    [sym__type] = STATE(16460),
    [sym__type_or_implicit] = STATE(16460),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(5274),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym_implicit_parid] = ACTIONS(6109),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
  },
  [2389] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [ts_builtin_sym_end] = ACTIONS(5129),
    [sym__varid] = ACTIONS(5899),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2390] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(16314),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(16314),
    [sym__type_context] = STATE(16314),
    [sym__type_fun] = STATE(16314),
    [sym__type] = STATE(16314),
    [sym__type_or_implicit] = STATE(16314),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2391] = {
    [sym_integer] = STATE(7208),
    [sym__literal] = STATE(7208),
    [sym__unboxed_open] = STATE(2156),
    [sym_constructor] = STATE(6817),
    [sym_con_unit] = STATE(7208),
    [sym_con_list] = STATE(7208),
    [sym_con_tuple] = STATE(7208),
    [sym_qualified_type] = STATE(7291),
    [sym_tycon_arrow] = STATE(7291),
    [sym_type_literal] = STATE(2699),
    [sym__promoted_tycon] = STATE(7291),
    [sym_type_variable] = STATE(7291),
    [sym_annotated_type_variable] = STATE(7291),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14074),
    [sym_type_parens] = STATE(2699),
    [sym_type_list] = STATE(2699),
    [sym_type_tuple] = STATE(2699),
    [sym__type_promotable_literal] = STATE(2699),
    [sym__type_promoted_literal] = STATE(2699),
    [sym__type_literal] = STATE(2699),
    [sym_type_name] = STATE(2693),
    [sym_type_star] = STATE(2699),
    [sym_type_unboxed_tuple] = STATE(2699),
    [sym_type_unboxed_sum] = STATE(2699),
    [sym__atype] = STATE(2699),
    [sym_type_apply] = STATE(8012),
    [sym__btype] = STATE(8012),
    [sym_implicit_param] = STATE(14192),
    [sym_type_infix] = STATE(12364),
    [sym__type_infix] = STATE(12056),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2560),
    [sym__type_quantifiers] = STATE(14192),
    [sym__type_context] = STATE(14192),
    [sym__type_fun] = STATE(14192),
    [sym__type] = STATE(14192),
    [sym__type_or_implicit] = STATE(14192),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14826),
    [sym_splice] = STATE(2699),
    [sym_quasiquote] = STATE(2699),
    [sym__varid] = ACTIONS(6436),
    [sym_float] = ACTIONS(6438),
    [sym_char] = ACTIONS(6438),
    [sym_string] = ACTIONS(6438),
    [sym__integer_literal] = ACTIONS(6440),
    [sym__binary_literal] = ACTIONS(6442),
    [sym__octal_literal] = ACTIONS(6442),
    [sym__hex_literal] = ACTIONS(6442),
    [anon_sym_LPAREN_POUND] = ACTIONS(6444),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6444),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6446),
    [sym_implicit_parid] = ACTIONS(6448),
    [sym__conid] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_6] = ACTIONS(6456),
    [anon_sym_7] = ACTIONS(6458),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6460),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6462),
  },
  [2392] = {
    [sym_integer] = STATE(5958),
    [sym__literal] = STATE(5958),
    [sym__unboxed_open] = STATE(2212),
    [sym_constructor] = STATE(5940),
    [sym_con_unit] = STATE(5958),
    [sym_con_list] = STATE(5958),
    [sym_con_tuple] = STATE(5958),
    [sym_qualified_type] = STATE(5952),
    [sym_tycon_arrow] = STATE(5952),
    [sym_type_literal] = STATE(2392),
    [sym__promoted_tycon] = STATE(5952),
    [sym_type_variable] = STATE(5952),
    [sym_annotated_type_variable] = STATE(5952),
    [sym_type_parens] = STATE(2392),
    [sym_type_list] = STATE(2392),
    [sym_type_tuple] = STATE(2392),
    [sym__type_promotable_literal] = STATE(2392),
    [sym__type_promoted_literal] = STATE(2392),
    [sym__type_literal] = STATE(2392),
    [sym_type_name] = STATE(2392),
    [sym_type_star] = STATE(2392),
    [sym_type_unboxed_tuple] = STATE(2392),
    [sym_type_unboxed_sum] = STATE(2392),
    [sym__atype] = STATE(2392),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15080),
    [sym_splice] = STATE(2392),
    [sym_quasiquote] = STATE(2392),
    [aux_sym_type_apply_repeat1] = STATE(2392),
    [sym__varid] = ACTIONS(6464),
    [sym_float] = ACTIONS(6467),
    [sym_char] = ACTIONS(6467),
    [sym_string] = ACTIONS(6467),
    [sym__integer_literal] = ACTIONS(6470),
    [sym__binary_literal] = ACTIONS(6473),
    [sym__octal_literal] = ACTIONS(6473),
    [sym__hex_literal] = ACTIONS(6473),
    [anon_sym_LPAREN_POUND] = ACTIONS(6476),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6476),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(6479),
    [anon_sym_RPAREN] = ACTIONS(5030),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(6482),
    [anon_sym_LBRACK] = ACTIONS(6485),
    [anon_sym_RBRACK] = ACTIONS(5030),
    [anon_sym_SQUOTE] = ACTIONS(6488),
    [anon_sym_STAR] = ACTIONS(6491),
    [anon_sym_6] = ACTIONS(6491),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_EQ] = ACTIONS(5059),
    [anon_sym_RBRACE] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(6494),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6497),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5030),
    [sym_quasiquote_start] = ACTIONS(6500),
  },
  [2393] = {
    [sym_integer] = STATE(7156),
    [sym__literal] = STATE(7156),
    [sym__unboxed_open] = STATE(2209),
    [sym_constructor] = STATE(6790),
    [sym_con_unit] = STATE(7156),
    [sym_con_list] = STATE(7156),
    [sym_con_tuple] = STATE(7156),
    [sym_qualified_type] = STATE(7260),
    [sym_tycon_arrow] = STATE(7260),
    [sym_type_literal] = STATE(2713),
    [sym__promoted_tycon] = STATE(7260),
    [sym_type_variable] = STATE(7260),
    [sym_annotated_type_variable] = STATE(7260),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14496),
    [sym_type_parens] = STATE(2713),
    [sym_type_list] = STATE(2713),
    [sym_type_tuple] = STATE(2713),
    [sym__type_promotable_literal] = STATE(2713),
    [sym__type_promoted_literal] = STATE(2713),
    [sym__type_literal] = STATE(2713),
    [sym_type_name] = STATE(2682),
    [sym_type_star] = STATE(2713),
    [sym_type_unboxed_tuple] = STATE(2713),
    [sym_type_unboxed_sum] = STATE(2713),
    [sym__atype] = STATE(2713),
    [sym_type_apply] = STATE(7968),
    [sym__btype] = STATE(7968),
    [sym_implicit_param] = STATE(13166),
    [sym_type_infix] = STATE(12340),
    [sym__type_infix] = STATE(12119),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2666),
    [sym__type_quantifiers] = STATE(13166),
    [sym__type_context] = STATE(13166),
    [sym__type_fun] = STATE(13166),
    [sym__type] = STATE(13166),
    [sym__type_or_implicit] = STATE(13166),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14821),
    [sym_splice] = STATE(2713),
    [sym_quasiquote] = STATE(2713),
    [sym__varid] = ACTIONS(6503),
    [sym_float] = ACTIONS(6505),
    [sym_char] = ACTIONS(6505),
    [sym_string] = ACTIONS(6505),
    [sym__integer_literal] = ACTIONS(6507),
    [sym__binary_literal] = ACTIONS(6509),
    [sym__octal_literal] = ACTIONS(6509),
    [sym__hex_literal] = ACTIONS(6509),
    [anon_sym_LPAREN_POUND] = ACTIONS(6511),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6511),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6513),
    [sym_implicit_parid] = ACTIONS(6515),
    [sym__conid] = ACTIONS(6517),
    [anon_sym_LBRACK] = ACTIONS(6519),
    [anon_sym_SQUOTE] = ACTIONS(6521),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6523),
    [anon_sym_6] = ACTIONS(6523),
    [anon_sym_7] = ACTIONS(6525),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6527),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6529),
  },
  [2394] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_RBRACK] = ACTIONS(5129),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5129),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2395] = {
    [sym_integer] = STATE(7224),
    [sym__literal] = STATE(7224),
    [sym__unboxed_open] = STATE(2201),
    [sym_constructor] = STATE(6997),
    [sym_con_unit] = STATE(7224),
    [sym_con_list] = STATE(7224),
    [sym_con_tuple] = STATE(7224),
    [sym_qualified_type] = STATE(7098),
    [sym_tycon_arrow] = STATE(7098),
    [sym_type_literal] = STATE(2726),
    [sym__promoted_tycon] = STATE(7098),
    [sym_type_variable] = STATE(7098),
    [sym_annotated_type_variable] = STATE(7098),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14123),
    [sym_type_parens] = STATE(2726),
    [sym_type_list] = STATE(2726),
    [sym_type_tuple] = STATE(2726),
    [sym__type_promotable_literal] = STATE(2726),
    [sym__type_promoted_literal] = STATE(2726),
    [sym__type_literal] = STATE(2726),
    [sym_type_name] = STATE(2712),
    [sym_type_star] = STATE(2726),
    [sym_type_unboxed_tuple] = STATE(2726),
    [sym_type_unboxed_sum] = STATE(2726),
    [sym__atype] = STATE(2726),
    [sym_type_apply] = STATE(8043),
    [sym__btype] = STATE(8043),
    [sym_implicit_param] = STATE(14133),
    [sym_type_infix] = STATE(12452),
    [sym__type_infix] = STATE(12183),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2594),
    [sym__type_quantifiers] = STATE(14133),
    [sym__type_context] = STATE(14133),
    [sym__type_fun] = STATE(14133),
    [sym__type] = STATE(14133),
    [sym__type_or_implicit] = STATE(14133),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15261),
    [sym_splice] = STATE(2726),
    [sym_quasiquote] = STATE(2726),
    [sym__varid] = ACTIONS(6531),
    [sym_float] = ACTIONS(6533),
    [sym_char] = ACTIONS(6533),
    [sym_string] = ACTIONS(6533),
    [sym__integer_literal] = ACTIONS(6535),
    [sym__binary_literal] = ACTIONS(6537),
    [sym__octal_literal] = ACTIONS(6537),
    [sym__hex_literal] = ACTIONS(6537),
    [anon_sym_LPAREN_POUND] = ACTIONS(6539),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6539),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6541),
    [sym_implicit_parid] = ACTIONS(6543),
    [sym__conid] = ACTIONS(6545),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_SQUOTE] = ACTIONS(6549),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6551),
    [anon_sym_6] = ACTIONS(6551),
    [anon_sym_7] = ACTIONS(6553),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6555),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6557),
  },
  [2396] = {
    [sym_integer] = STATE(7705),
    [sym__literal] = STATE(7705),
    [sym__unboxed_open] = STATE(2184),
    [sym_constructor] = STATE(7681),
    [sym_con_unit] = STATE(7705),
    [sym_con_list] = STATE(7705),
    [sym_con_tuple] = STATE(7705),
    [sym_qualified_type] = STATE(7706),
    [sym_tycon_arrow] = STATE(7706),
    [sym_type_literal] = STATE(2802),
    [sym__promoted_tycon] = STATE(7706),
    [sym_type_variable] = STATE(7706),
    [sym_annotated_type_variable] = STATE(7706),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14603),
    [sym_type_parens] = STATE(2802),
    [sym_type_list] = STATE(2802),
    [sym_type_tuple] = STATE(2802),
    [sym__type_promotable_literal] = STATE(2802),
    [sym__type_promoted_literal] = STATE(2802),
    [sym__type_literal] = STATE(2802),
    [sym_type_name] = STATE(2805),
    [sym_type_star] = STATE(2802),
    [sym_type_unboxed_tuple] = STATE(2802),
    [sym_type_unboxed_sum] = STATE(2802),
    [sym__atype] = STATE(2802),
    [sym_type_apply] = STATE(8735),
    [sym__btype] = STATE(8735),
    [sym_implicit_param] = STATE(18544),
    [sym_type_infix] = STATE(13317),
    [sym__type_infix] = STATE(13018),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2597),
    [sym__type_quantifiers] = STATE(18544),
    [sym__type_context] = STATE(18544),
    [sym__type_fun] = STATE(18544),
    [sym__type] = STATE(18544),
    [sym__type_or_implicit] = STATE(18544),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15120),
    [sym_splice] = STATE(2802),
    [sym_quasiquote] = STATE(2802),
    [sym__varid] = ACTIONS(6139),
    [sym_float] = ACTIONS(6141),
    [sym_char] = ACTIONS(6141),
    [sym_string] = ACTIONS(6141),
    [sym__integer_literal] = ACTIONS(6143),
    [sym__binary_literal] = ACTIONS(6145),
    [sym__octal_literal] = ACTIONS(6145),
    [sym__hex_literal] = ACTIONS(6145),
    [anon_sym_LPAREN_POUND] = ACTIONS(6147),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6147),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6149),
    [sym_implicit_parid] = ACTIONS(6151),
    [sym__conid] = ACTIONS(6153),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_SQUOTE] = ACTIONS(6157),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6159),
    [anon_sym_6] = ACTIONS(6159),
    [anon_sym_7] = ACTIONS(6161),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6163),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6165),
  },
  [2397] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14412),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_implicit_param] = STATE(16481),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(12341),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2561),
    [sym__type_quantifiers] = STATE(16481),
    [sym__type_context] = STATE(16481),
    [sym__type_fun] = STATE(16481),
    [sym__type] = STATE(16481),
    [sym__type_or_implicit] = STATE(16481),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(5274),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym_implicit_parid] = ACTIONS(6109),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
  },
  [2398] = {
    [sym_integer] = STATE(7019),
    [sym__literal] = STATE(7019),
    [sym__unboxed_open] = STATE(2169),
    [sym_constructor] = STATE(6740),
    [sym_con_unit] = STATE(7019),
    [sym_con_list] = STATE(7019),
    [sym_con_tuple] = STATE(7019),
    [sym_qualified_type] = STATE(6980),
    [sym_tycon_arrow] = STATE(6980),
    [sym_type_literal] = STATE(2552),
    [sym__promoted_tycon] = STATE(6980),
    [sym_type_variable] = STATE(6980),
    [sym_annotated_type_variable] = STATE(6980),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14019),
    [sym_type_parens] = STATE(2552),
    [sym_type_list] = STATE(2552),
    [sym_type_tuple] = STATE(2552),
    [sym__type_promotable_literal] = STATE(2552),
    [sym__type_promoted_literal] = STATE(2552),
    [sym__type_literal] = STATE(2552),
    [sym_type_name] = STATE(2616),
    [sym_type_star] = STATE(2552),
    [sym_type_unboxed_tuple] = STATE(2552),
    [sym_type_unboxed_sum] = STATE(2552),
    [sym__atype] = STATE(2552),
    [sym_type_apply] = STATE(7895),
    [sym__btype] = STATE(7895),
    [sym_implicit_param] = STATE(12702),
    [sym_type_infix] = STATE(10510),
    [sym__type_infix] = STATE(10063),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2623),
    [sym__type_quantifiers] = STATE(12702),
    [sym__type_context] = STATE(12702),
    [sym__type_fun] = STATE(12702),
    [sym__type] = STATE(12702),
    [sym__type_or_implicit] = STATE(12702),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14684),
    [sym_splice] = STATE(2552),
    [sym_quasiquote] = STATE(2552),
    [sym__varid] = ACTIONS(6559),
    [sym_float] = ACTIONS(6561),
    [sym_char] = ACTIONS(6561),
    [sym_string] = ACTIONS(6561),
    [sym__integer_literal] = ACTIONS(6563),
    [sym__binary_literal] = ACTIONS(6565),
    [sym__octal_literal] = ACTIONS(6565),
    [sym__hex_literal] = ACTIONS(6565),
    [anon_sym_LPAREN_POUND] = ACTIONS(6567),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6567),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6569),
    [sym_implicit_parid] = ACTIONS(6571),
    [sym__conid] = ACTIONS(6573),
    [anon_sym_LBRACK] = ACTIONS(6575),
    [anon_sym_SQUOTE] = ACTIONS(6577),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6579),
    [anon_sym_6] = ACTIONS(6579),
    [anon_sym_7] = ACTIONS(6581),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6583),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6585),
  },
  [2399] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_implicit_param] = STATE(13402),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(13402),
    [sym__type_context] = STATE(13402),
    [sym__type_fun] = STATE(13402),
    [sym__type] = STATE(13402),
    [sym__type_or_implicit] = STATE(13402),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2400] = {
    [sym_integer] = STATE(6389),
    [sym__literal] = STATE(6389),
    [sym__unboxed_open] = STATE(2127),
    [sym_constructor] = STATE(6056),
    [sym_con_unit] = STATE(6389),
    [sym_con_list] = STATE(6389),
    [sym_con_tuple] = STATE(6389),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2465),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym_annotated_type_variable] = STATE(6375),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14088),
    [sym_type_parens] = STATE(2465),
    [sym_type_list] = STATE(2465),
    [sym_type_tuple] = STATE(2465),
    [sym__type_promotable_literal] = STATE(2465),
    [sym__type_promoted_literal] = STATE(2465),
    [sym__type_literal] = STATE(2465),
    [sym_type_name] = STATE(2446),
    [sym_type_star] = STATE(2465),
    [sym_type_unboxed_tuple] = STATE(2465),
    [sym_type_unboxed_sum] = STATE(2465),
    [sym__atype] = STATE(2465),
    [sym_type_apply] = STATE(7694),
    [sym__btype] = STATE(7694),
    [sym_implicit_param] = STATE(12202),
    [sym_type_infix] = STATE(9909),
    [sym__type_infix] = STATE(9672),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2601),
    [sym__type_quantifiers] = STATE(12202),
    [sym__type_context] = STATE(12202),
    [sym__type_fun] = STATE(12202),
    [sym__type] = STATE(12202),
    [sym__type_or_implicit] = STATE(12202),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15001),
    [sym_splice] = STATE(2465),
    [sym_quasiquote] = STATE(2465),
    [sym__varid] = ACTIONS(6587),
    [sym_float] = ACTIONS(6589),
    [sym_char] = ACTIONS(6589),
    [sym_string] = ACTIONS(6589),
    [sym__integer_literal] = ACTIONS(6591),
    [sym__binary_literal] = ACTIONS(6593),
    [sym__octal_literal] = ACTIONS(6593),
    [sym__hex_literal] = ACTIONS(6593),
    [anon_sym_LPAREN_POUND] = ACTIONS(6595),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6595),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6597),
    [sym_implicit_parid] = ACTIONS(6599),
    [sym__conid] = ACTIONS(6601),
    [anon_sym_LBRACK] = ACTIONS(6603),
    [anon_sym_SQUOTE] = ACTIONS(6605),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6607),
    [anon_sym_6] = ACTIONS(6607),
    [anon_sym_7] = ACTIONS(6609),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6611),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6613),
  },
  [2401] = {
    [sym_integer] = STATE(6026),
    [sym__literal] = STATE(6026),
    [sym__unboxed_open] = STATE(2192),
    [sym_constructor] = STATE(5913),
    [sym_con_unit] = STATE(6026),
    [sym_con_list] = STATE(6026),
    [sym_con_tuple] = STATE(6026),
    [sym_qualified_type] = STATE(6029),
    [sym_tycon_arrow] = STATE(6029),
    [sym_type_literal] = STATE(2411),
    [sym__promoted_tycon] = STATE(6029),
    [sym_type_variable] = STATE(6029),
    [sym_annotated_type_variable] = STATE(6029),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14334),
    [sym_type_parens] = STATE(2411),
    [sym_type_list] = STATE(2411),
    [sym_type_tuple] = STATE(2411),
    [sym__type_promotable_literal] = STATE(2411),
    [sym__type_promoted_literal] = STATE(2411),
    [sym__type_literal] = STATE(2411),
    [sym_type_name] = STATE(2394),
    [sym_type_star] = STATE(2411),
    [sym_type_unboxed_tuple] = STATE(2411),
    [sym_type_unboxed_sum] = STATE(2411),
    [sym__atype] = STATE(2411),
    [sym_type_apply] = STATE(7537),
    [sym__btype] = STATE(7537),
    [sym_implicit_param] = STATE(10647),
    [sym_type_infix] = STATE(9633),
    [sym__type_infix] = STATE(9585),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2603),
    [sym__type_quantifiers] = STATE(10647),
    [sym__type_context] = STATE(10647),
    [sym__type_fun] = STATE(10647),
    [sym__type] = STATE(10647),
    [sym__type_or_implicit] = STATE(10647),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15103),
    [sym_splice] = STATE(2411),
    [sym_quasiquote] = STATE(2411),
    [sym__varid] = ACTIONS(6615),
    [sym_float] = ACTIONS(6617),
    [sym_char] = ACTIONS(6617),
    [sym_string] = ACTIONS(6617),
    [sym__integer_literal] = ACTIONS(6619),
    [sym__binary_literal] = ACTIONS(6621),
    [sym__octal_literal] = ACTIONS(6621),
    [sym__hex_literal] = ACTIONS(6621),
    [anon_sym_LPAREN_POUND] = ACTIONS(6623),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6623),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6625),
    [sym_implicit_parid] = ACTIONS(6627),
    [sym__conid] = ACTIONS(6629),
    [anon_sym_LBRACK] = ACTIONS(6631),
    [anon_sym_SQUOTE] = ACTIONS(6633),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6635),
    [anon_sym_6] = ACTIONS(6635),
    [anon_sym_7] = ACTIONS(6637),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6639),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6641),
  },
  [2402] = {
    [sym_integer] = STATE(6475),
    [sym__literal] = STATE(6475),
    [sym__unboxed_open] = STATE(2221),
    [sym_constructor] = STATE(6005),
    [sym_con_unit] = STATE(6475),
    [sym_con_list] = STATE(6475),
    [sym_con_tuple] = STATE(6475),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2474),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym_annotated_type_variable] = STATE(6545),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14062),
    [sym_type_parens] = STATE(2474),
    [sym_type_list] = STATE(2474),
    [sym_type_tuple] = STATE(2474),
    [sym__type_promotable_literal] = STATE(2474),
    [sym__type_promoted_literal] = STATE(2474),
    [sym__type_literal] = STATE(2474),
    [sym_type_name] = STATE(2453),
    [sym_type_star] = STATE(2474),
    [sym_type_unboxed_tuple] = STATE(2474),
    [sym_type_unboxed_sum] = STATE(2474),
    [sym__atype] = STATE(2474),
    [sym_type_apply] = STATE(7618),
    [sym__btype] = STATE(7618),
    [sym_implicit_param] = STATE(11984),
    [sym_type_infix] = STATE(9792),
    [sym__type_infix] = STATE(9655),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2631),
    [sym__type_quantifiers] = STATE(11984),
    [sym__type_context] = STATE(11984),
    [sym__type_fun] = STATE(11984),
    [sym__type] = STATE(11984),
    [sym__type_or_implicit] = STATE(11984),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14761),
    [sym_splice] = STATE(2474),
    [sym_quasiquote] = STATE(2474),
    [sym__varid] = ACTIONS(6643),
    [sym_float] = ACTIONS(6645),
    [sym_char] = ACTIONS(6645),
    [sym_string] = ACTIONS(6645),
    [sym__integer_literal] = ACTIONS(6647),
    [sym__binary_literal] = ACTIONS(6649),
    [sym__octal_literal] = ACTIONS(6649),
    [sym__hex_literal] = ACTIONS(6649),
    [anon_sym_LPAREN_POUND] = ACTIONS(6651),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6651),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6653),
    [sym_implicit_parid] = ACTIONS(6655),
    [sym__conid] = ACTIONS(6657),
    [anon_sym_LBRACK] = ACTIONS(6659),
    [anon_sym_SQUOTE] = ACTIONS(6661),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6663),
    [anon_sym_6] = ACTIONS(6663),
    [anon_sym_7] = ACTIONS(6665),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6669),
  },
  [2403] = {
    [sym_integer] = STATE(5998),
    [sym__literal] = STATE(5998),
    [sym__unboxed_open] = STATE(2200),
    [sym_constructor] = STATE(5931),
    [sym_con_unit] = STATE(5998),
    [sym_con_list] = STATE(5998),
    [sym_con_tuple] = STATE(5998),
    [sym_qualified_type] = STATE(5996),
    [sym_tycon_arrow] = STATE(5996),
    [sym_type_literal] = STATE(2409),
    [sym__promoted_tycon] = STATE(5996),
    [sym_type_variable] = STATE(5996),
    [sym_annotated_type_variable] = STATE(5996),
    [sym_type_parens] = STATE(2409),
    [sym_type_list] = STATE(2409),
    [sym_type_tuple] = STATE(2409),
    [sym__type_promotable_literal] = STATE(2409),
    [sym__type_promoted_literal] = STATE(2409),
    [sym__type_literal] = STATE(2409),
    [sym_type_name] = STATE(2409),
    [sym_type_star] = STATE(2409),
    [sym_type_unboxed_tuple] = STATE(2409),
    [sym_type_unboxed_sum] = STATE(2409),
    [sym__atype] = STATE(2409),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15278),
    [sym_splice] = STATE(2409),
    [sym_quasiquote] = STATE(2409),
    [aux_sym_type_apply_repeat1] = STATE(2409),
    [sym__varid] = ACTIONS(6671),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(6396),
    [sym_char] = ACTIONS(6396),
    [sym_string] = ACTIONS(6396),
    [sym__integer_literal] = ACTIONS(6398),
    [sym__binary_literal] = ACTIONS(6400),
    [sym__octal_literal] = ACTIONS(6400),
    [sym__hex_literal] = ACTIONS(6400),
    [anon_sym_LPAREN_POUND] = ACTIONS(6402),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6402),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(6673),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(6675),
    [anon_sym_LBRACK] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6678),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(6414),
    [anon_sym_6] = ACTIONS(6414),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(6416),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym__layout_end] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6418),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6420),
  },
  [2404] = {
    [sym_integer] = STATE(7818),
    [sym__literal] = STATE(7818),
    [sym__unboxed_open] = STATE(2165),
    [sym_constructor] = STATE(7684),
    [sym_con_unit] = STATE(7818),
    [sym_con_list] = STATE(7818),
    [sym_con_tuple] = STATE(7818),
    [sym_qualified_type] = STATE(7768),
    [sym_tycon_arrow] = STATE(7768),
    [sym_type_literal] = STATE(2799),
    [sym__promoted_tycon] = STATE(7768),
    [sym_type_variable] = STATE(7768),
    [sym_annotated_type_variable] = STATE(7768),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14565),
    [sym_type_parens] = STATE(2799),
    [sym_type_list] = STATE(2799),
    [sym_type_tuple] = STATE(2799),
    [sym__type_promotable_literal] = STATE(2799),
    [sym__type_promoted_literal] = STATE(2799),
    [sym__type_literal] = STATE(2799),
    [sym_type_name] = STATE(2788),
    [sym_type_star] = STATE(2799),
    [sym_type_unboxed_tuple] = STATE(2799),
    [sym_type_unboxed_sum] = STATE(2799),
    [sym__atype] = STATE(2799),
    [sym_type_apply] = STATE(8878),
    [sym__btype] = STATE(8878),
    [sym_implicit_param] = STATE(18635),
    [sym_type_infix] = STATE(13177),
    [sym__type_infix] = STATE(12764),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2638),
    [sym__type_quantifiers] = STATE(18635),
    [sym__type_context] = STATE(18635),
    [sym__type_fun] = STATE(18635),
    [sym__type] = STATE(18635),
    [sym__type_or_implicit] = STATE(18635),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15161),
    [sym_splice] = STATE(2799),
    [sym_quasiquote] = STATE(2799),
    [sym__varid] = ACTIONS(6042),
    [sym_float] = ACTIONS(6044),
    [sym_char] = ACTIONS(6044),
    [sym_string] = ACTIONS(6044),
    [sym__integer_literal] = ACTIONS(6046),
    [sym__binary_literal] = ACTIONS(6048),
    [sym__octal_literal] = ACTIONS(6048),
    [sym__hex_literal] = ACTIONS(6048),
    [anon_sym_LPAREN_POUND] = ACTIONS(6050),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6050),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6052),
    [sym_implicit_parid] = ACTIONS(6054),
    [sym__conid] = ACTIONS(6056),
    [anon_sym_LBRACK] = ACTIONS(6058),
    [anon_sym_SQUOTE] = ACTIONS(6060),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6062),
    [anon_sym_6] = ACTIONS(6062),
    [anon_sym_7] = ACTIONS(6064),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6066),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6068),
  },
  [2405] = {
    [sym_integer] = STATE(6751),
    [sym__literal] = STATE(6751),
    [sym__unboxed_open] = STATE(2140),
    [sym_constructor] = STATE(6530),
    [sym_con_unit] = STATE(6751),
    [sym_con_list] = STATE(6751),
    [sym_con_tuple] = STATE(6751),
    [sym_qualified_type] = STATE(6610),
    [sym_tycon_arrow] = STATE(6610),
    [sym_type_literal] = STATE(2499),
    [sym__promoted_tycon] = STATE(6610),
    [sym_type_variable] = STATE(6610),
    [sym_annotated_type_variable] = STATE(6610),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14167),
    [sym_type_parens] = STATE(2499),
    [sym_type_list] = STATE(2499),
    [sym_type_tuple] = STATE(2499),
    [sym__type_promotable_literal] = STATE(2499),
    [sym__type_promoted_literal] = STATE(2499),
    [sym__type_literal] = STATE(2499),
    [sym_type_name] = STATE(2484),
    [sym_type_star] = STATE(2499),
    [sym_type_unboxed_tuple] = STATE(2499),
    [sym_type_unboxed_sum] = STATE(2499),
    [sym__atype] = STATE(2499),
    [sym_type_apply] = STATE(7714),
    [sym__btype] = STATE(7714),
    [sym_implicit_param] = STATE(11556),
    [sym_type_infix] = STATE(10095),
    [sym__type_infix] = STATE(9721),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2593),
    [sym__type_quantifiers] = STATE(11556),
    [sym__type_context] = STATE(11556),
    [sym__type_fun] = STATE(11556),
    [sym__type] = STATE(11556),
    [sym__type_or_implicit] = STATE(11556),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15339),
    [sym_splice] = STATE(2499),
    [sym_quasiquote] = STATE(2499),
    [sym__varid] = ACTIONS(6681),
    [sym_float] = ACTIONS(6683),
    [sym_char] = ACTIONS(6683),
    [sym_string] = ACTIONS(6683),
    [sym__integer_literal] = ACTIONS(6685),
    [sym__binary_literal] = ACTIONS(6687),
    [sym__octal_literal] = ACTIONS(6687),
    [sym__hex_literal] = ACTIONS(6687),
    [anon_sym_LPAREN_POUND] = ACTIONS(6689),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6689),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6691),
    [sym_implicit_parid] = ACTIONS(6693),
    [sym__conid] = ACTIONS(6695),
    [anon_sym_LBRACK] = ACTIONS(6697),
    [anon_sym_SQUOTE] = ACTIONS(6699),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6701),
    [anon_sym_6] = ACTIONS(6701),
    [anon_sym_7] = ACTIONS(6703),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6705),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6707),
  },
  [2406] = {
    [sym_integer] = STATE(5955),
    [sym__literal] = STATE(5955),
    [sym__unboxed_open] = STATE(2227),
    [sym_constructor] = STATE(5941),
    [sym_con_unit] = STATE(5955),
    [sym_con_list] = STATE(5955),
    [sym_con_tuple] = STATE(5955),
    [sym_qualified_type] = STATE(5953),
    [sym_tycon_arrow] = STATE(5953),
    [sym_type_literal] = STATE(2406),
    [sym__promoted_tycon] = STATE(5953),
    [sym_type_variable] = STATE(5953),
    [sym_annotated_type_variable] = STATE(5953),
    [sym_type_parens] = STATE(2406),
    [sym_type_list] = STATE(2406),
    [sym_type_tuple] = STATE(2406),
    [sym__type_promotable_literal] = STATE(2406),
    [sym__type_promoted_literal] = STATE(2406),
    [sym__type_literal] = STATE(2406),
    [sym_type_name] = STATE(2406),
    [sym_type_star] = STATE(2406),
    [sym_type_unboxed_tuple] = STATE(2406),
    [sym_type_unboxed_sum] = STATE(2406),
    [sym__atype] = STATE(2406),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15273),
    [sym_splice] = STATE(2406),
    [sym_quasiquote] = STATE(2406),
    [aux_sym_type_apply_repeat1] = STATE(2406),
    [sym__varid] = ACTIONS(6709),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(6712),
    [sym_char] = ACTIONS(6712),
    [sym_string] = ACTIONS(6712),
    [sym__integer_literal] = ACTIONS(6715),
    [sym__binary_literal] = ACTIONS(6718),
    [sym__octal_literal] = ACTIONS(6718),
    [sym__hex_literal] = ACTIONS(6718),
    [anon_sym_LPAREN_POUND] = ACTIONS(6721),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6721),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(6724),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(6727),
    [anon_sym_LBRACK] = ACTIONS(6730),
    [anon_sym_SQUOTE] = ACTIONS(6733),
    [anon_sym_STAR] = ACTIONS(6736),
    [anon_sym_6] = ACTIONS(6736),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_in] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(6739),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym__layout_end] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(6742),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6745),
  },
  [2407] = {
    [sym_integer] = STATE(6388),
    [sym__literal] = STATE(6388),
    [sym__unboxed_open] = STATE(2114),
    [sym_constructor] = STATE(6175),
    [sym_con_unit] = STATE(6388),
    [sym_con_list] = STATE(6388),
    [sym_con_tuple] = STATE(6388),
    [sym_qualified_type] = STATE(6387),
    [sym_tycon_arrow] = STATE(6387),
    [sym_type_literal] = STATE(2458),
    [sym__promoted_tycon] = STATE(6387),
    [sym_type_variable] = STATE(6387),
    [sym_annotated_type_variable] = STATE(6387),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14193),
    [sym_type_parens] = STATE(2458),
    [sym_type_list] = STATE(2458),
    [sym_type_tuple] = STATE(2458),
    [sym__type_promotable_literal] = STATE(2458),
    [sym__type_promoted_literal] = STATE(2458),
    [sym__type_literal] = STATE(2458),
    [sym_type_name] = STATE(2455),
    [sym_type_star] = STATE(2458),
    [sym_type_unboxed_tuple] = STATE(2458),
    [sym_type_unboxed_sum] = STATE(2458),
    [sym__atype] = STATE(2458),
    [sym_type_apply] = STATE(7646),
    [sym__btype] = STATE(7646),
    [sym_implicit_param] = STATE(11961),
    [sym_type_infix] = STATE(9881),
    [sym__type_infix] = STATE(9597),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2670),
    [sym__type_quantifiers] = STATE(11961),
    [sym__type_context] = STATE(11961),
    [sym__type_fun] = STATE(11961),
    [sym__type] = STATE(11961),
    [sym__type_or_implicit] = STATE(11961),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15425),
    [sym_splice] = STATE(2458),
    [sym_quasiquote] = STATE(2458),
    [sym__varid] = ACTIONS(6748),
    [sym_float] = ACTIONS(6750),
    [sym_char] = ACTIONS(6750),
    [sym_string] = ACTIONS(6750),
    [sym__integer_literal] = ACTIONS(6752),
    [sym__binary_literal] = ACTIONS(6754),
    [sym__octal_literal] = ACTIONS(6754),
    [sym__hex_literal] = ACTIONS(6754),
    [anon_sym_LPAREN_POUND] = ACTIONS(6756),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6756),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6758),
    [sym_implicit_parid] = ACTIONS(6760),
    [sym__conid] = ACTIONS(6762),
    [anon_sym_LBRACK] = ACTIONS(6764),
    [anon_sym_SQUOTE] = ACTIONS(6766),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6768),
    [anon_sym_6] = ACTIONS(6768),
    [anon_sym_7] = ACTIONS(6770),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6772),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6774),
  },
  [2408] = {
    [sym_integer] = STATE(7008),
    [sym__literal] = STATE(7008),
    [sym__unboxed_open] = STATE(2147),
    [sym_constructor] = STATE(6715),
    [sym_con_unit] = STATE(7008),
    [sym_con_list] = STATE(7008),
    [sym_con_tuple] = STATE(7008),
    [sym_qualified_type] = STATE(6959),
    [sym_tycon_arrow] = STATE(6959),
    [sym_type_literal] = STATE(2557),
    [sym__promoted_tycon] = STATE(6959),
    [sym_type_variable] = STATE(6959),
    [sym_annotated_type_variable] = STATE(6959),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14030),
    [sym_type_parens] = STATE(2557),
    [sym_type_list] = STATE(2557),
    [sym_type_tuple] = STATE(2557),
    [sym__type_promotable_literal] = STATE(2557),
    [sym__type_promoted_literal] = STATE(2557),
    [sym__type_literal] = STATE(2557),
    [sym_type_name] = STATE(2622),
    [sym_type_star] = STATE(2557),
    [sym_type_unboxed_tuple] = STATE(2557),
    [sym_type_unboxed_sum] = STATE(2557),
    [sym__atype] = STATE(2557),
    [sym_type_apply] = STATE(7908),
    [sym__btype] = STATE(7908),
    [sym_implicit_param] = STATE(12020),
    [sym_type_infix] = STATE(10402),
    [sym__type_infix] = STATE(10136),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2563),
    [sym__type_quantifiers] = STATE(12020),
    [sym__type_context] = STATE(12020),
    [sym__type_fun] = STATE(12020),
    [sym__type] = STATE(12020),
    [sym__type_or_implicit] = STATE(12020),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14702),
    [sym_splice] = STATE(2557),
    [sym_quasiquote] = STATE(2557),
    [sym__varid] = ACTIONS(6776),
    [sym_float] = ACTIONS(6778),
    [sym_char] = ACTIONS(6778),
    [sym_string] = ACTIONS(6778),
    [sym__integer_literal] = ACTIONS(6780),
    [sym__binary_literal] = ACTIONS(6782),
    [sym__octal_literal] = ACTIONS(6782),
    [sym__hex_literal] = ACTIONS(6782),
    [anon_sym_LPAREN_POUND] = ACTIONS(6784),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6784),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [sym_implicit_parid] = ACTIONS(6788),
    [sym__conid] = ACTIONS(6790),
    [anon_sym_LBRACK] = ACTIONS(6792),
    [anon_sym_SQUOTE] = ACTIONS(6794),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6796),
    [anon_sym_6] = ACTIONS(6796),
    [anon_sym_7] = ACTIONS(6798),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6800),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6802),
  },
  [2409] = {
    [sym_integer] = STATE(5998),
    [sym__literal] = STATE(5998),
    [sym__unboxed_open] = STATE(2200),
    [sym_constructor] = STATE(5931),
    [sym_con_unit] = STATE(5998),
    [sym_con_list] = STATE(5998),
    [sym_con_tuple] = STATE(5998),
    [sym_qualified_type] = STATE(5996),
    [sym_tycon_arrow] = STATE(5996),
    [sym_type_literal] = STATE(2442),
    [sym__promoted_tycon] = STATE(5996),
    [sym_type_variable] = STATE(5996),
    [sym_annotated_type_variable] = STATE(5996),
    [sym_type_parens] = STATE(2442),
    [sym_type_list] = STATE(2442),
    [sym_type_tuple] = STATE(2442),
    [sym__type_promotable_literal] = STATE(2442),
    [sym__type_promoted_literal] = STATE(2442),
    [sym__type_literal] = STATE(2442),
    [sym_type_name] = STATE(2442),
    [sym_type_star] = STATE(2442),
    [sym_type_unboxed_tuple] = STATE(2442),
    [sym_type_unboxed_sum] = STATE(2442),
    [sym__atype] = STATE(2442),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15278),
    [sym_splice] = STATE(2442),
    [sym_quasiquote] = STATE(2442),
    [aux_sym_type_apply_repeat1] = STATE(2442),
    [sym__varid] = ACTIONS(6671),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(6396),
    [sym_char] = ACTIONS(6396),
    [sym_string] = ACTIONS(6396),
    [sym__integer_literal] = ACTIONS(6398),
    [sym__binary_literal] = ACTIONS(6400),
    [sym__octal_literal] = ACTIONS(6400),
    [sym__hex_literal] = ACTIONS(6400),
    [anon_sym_LPAREN_POUND] = ACTIONS(6402),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6402),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(6673),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(6804),
    [anon_sym_LBRACK] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6807),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(6414),
    [anon_sym_6] = ACTIONS(6414),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(6416),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym__layout_end] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6418),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6420),
  },
  [2410] = {
    [sym_integer] = STATE(6064),
    [sym__literal] = STATE(6064),
    [sym__unboxed_open] = STATE(2150),
    [sym_constructor] = STATE(5877),
    [sym_con_unit] = STATE(6064),
    [sym_con_list] = STATE(6064),
    [sym_con_tuple] = STATE(6064),
    [sym_qualified_type] = STATE(6066),
    [sym_tycon_arrow] = STATE(6066),
    [sym_type_literal] = STATE(2410),
    [sym__promoted_tycon] = STATE(6066),
    [sym_type_variable] = STATE(6066),
    [sym_annotated_type_variable] = STATE(6066),
    [sym_type_parens] = STATE(2410),
    [sym_type_list] = STATE(2410),
    [sym_type_tuple] = STATE(2410),
    [sym__type_promotable_literal] = STATE(2410),
    [sym__type_promoted_literal] = STATE(2410),
    [sym__type_literal] = STATE(2410),
    [sym_type_name] = STATE(2410),
    [sym_type_star] = STATE(2410),
    [sym_type_unboxed_tuple] = STATE(2410),
    [sym_type_unboxed_sum] = STATE(2410),
    [sym__atype] = STATE(2410),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14778),
    [sym_splice] = STATE(2410),
    [sym_quasiquote] = STATE(2410),
    [aux_sym_type_apply_repeat1] = STATE(2410),
    [ts_builtin_sym_end] = ACTIONS(5030),
    [sym__varid] = ACTIONS(6810),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(6813),
    [sym_char] = ACTIONS(6813),
    [sym_string] = ACTIONS(6813),
    [sym__integer_literal] = ACTIONS(6816),
    [sym__binary_literal] = ACTIONS(6819),
    [sym__octal_literal] = ACTIONS(6819),
    [sym__hex_literal] = ACTIONS(6819),
    [anon_sym_LPAREN_POUND] = ACTIONS(6822),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6822),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(6825),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(6828),
    [anon_sym_LBRACK] = ACTIONS(6831),
    [anon_sym_SQUOTE] = ACTIONS(6834),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(6837),
    [anon_sym_6] = ACTIONS(6837),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(6840),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(6843),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6846),
  },
  [2411] = {
    [sym_integer] = STATE(6026),
    [sym__literal] = STATE(6026),
    [sym__unboxed_open] = STATE(2192),
    [sym_constructor] = STATE(5913),
    [sym_con_unit] = STATE(6026),
    [sym_con_list] = STATE(6026),
    [sym_con_tuple] = STATE(6026),
    [sym_qualified_type] = STATE(6029),
    [sym_tycon_arrow] = STATE(6029),
    [sym_type_literal] = STATE(2422),
    [sym__promoted_tycon] = STATE(6029),
    [sym_type_variable] = STATE(6029),
    [sym_annotated_type_variable] = STATE(6029),
    [sym_type_parens] = STATE(2422),
    [sym_type_list] = STATE(2422),
    [sym_type_tuple] = STATE(2422),
    [sym__type_promotable_literal] = STATE(2422),
    [sym__type_promoted_literal] = STATE(2422),
    [sym__type_literal] = STATE(2422),
    [sym_type_name] = STATE(2422),
    [sym_type_star] = STATE(2422),
    [sym_type_unboxed_tuple] = STATE(2422),
    [sym_type_unboxed_sum] = STATE(2422),
    [sym__atype] = STATE(2422),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15103),
    [sym_splice] = STATE(2422),
    [sym_quasiquote] = STATE(2422),
    [aux_sym_type_apply_repeat1] = STATE(2422),
    [sym__varid] = ACTIONS(6849),
    [sym_float] = ACTIONS(6617),
    [sym_char] = ACTIONS(6617),
    [sym_string] = ACTIONS(6617),
    [sym__integer_literal] = ACTIONS(6619),
    [sym__binary_literal] = ACTIONS(6621),
    [sym__octal_literal] = ACTIONS(6621),
    [sym__hex_literal] = ACTIONS(6621),
    [anon_sym_LPAREN_POUND] = ACTIONS(6623),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6623),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(6851),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(6853),
    [anon_sym_LBRACK] = ACTIONS(6631),
    [anon_sym_RBRACK] = ACTIONS(5078),
    [anon_sym_SQUOTE] = ACTIONS(6856),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(6635),
    [anon_sym_6] = ACTIONS(6635),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(6637),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6639),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5078),
    [sym_quasiquote_start] = ACTIONS(6641),
  },
  [2412] = {
    [sym_integer] = STATE(5955),
    [sym__literal] = STATE(5955),
    [sym__unboxed_open] = STATE(2227),
    [sym_constructor] = STATE(5941),
    [sym_con_unit] = STATE(5955),
    [sym_con_list] = STATE(5955),
    [sym_con_tuple] = STATE(5955),
    [sym_qualified_type] = STATE(5953),
    [sym_tycon_arrow] = STATE(5953),
    [sym_type_literal] = STATE(2413),
    [sym__promoted_tycon] = STATE(5953),
    [sym_type_variable] = STATE(5953),
    [sym_annotated_type_variable] = STATE(5953),
    [sym_type_parens] = STATE(2413),
    [sym_type_list] = STATE(2413),
    [sym_type_tuple] = STATE(2413),
    [sym__type_promotable_literal] = STATE(2413),
    [sym__type_promoted_literal] = STATE(2413),
    [sym__type_literal] = STATE(2413),
    [sym_type_name] = STATE(2413),
    [sym_type_star] = STATE(2413),
    [sym_type_unboxed_tuple] = STATE(2413),
    [sym_type_unboxed_sum] = STATE(2413),
    [sym__atype] = STATE(2413),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15273),
    [sym_splice] = STATE(2413),
    [sym_quasiquote] = STATE(2413),
    [aux_sym_type_apply_repeat1] = STATE(2413),
    [sym__varid] = ACTIONS(6859),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(6861),
    [sym_char] = ACTIONS(6861),
    [sym_string] = ACTIONS(6861),
    [sym__integer_literal] = ACTIONS(6863),
    [sym__binary_literal] = ACTIONS(6865),
    [sym__octal_literal] = ACTIONS(6865),
    [sym__hex_literal] = ACTIONS(6865),
    [anon_sym_LPAREN_POUND] = ACTIONS(6867),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6867),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(6869),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(6871),
    [anon_sym_LBRACK] = ACTIONS(6874),
    [anon_sym_SQUOTE] = ACTIONS(6876),
    [anon_sym_STAR] = ACTIONS(6879),
    [anon_sym_6] = ACTIONS(6879),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_in] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(6881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym__layout_end] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6883),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6885),
  },
  [2413] = {
    [sym_integer] = STATE(5955),
    [sym__literal] = STATE(5955),
    [sym__unboxed_open] = STATE(2227),
    [sym_constructor] = STATE(5941),
    [sym_con_unit] = STATE(5955),
    [sym_con_list] = STATE(5955),
    [sym_con_tuple] = STATE(5955),
    [sym_qualified_type] = STATE(5953),
    [sym_tycon_arrow] = STATE(5953),
    [sym_type_literal] = STATE(2406),
    [sym__promoted_tycon] = STATE(5953),
    [sym_type_variable] = STATE(5953),
    [sym_annotated_type_variable] = STATE(5953),
    [sym_type_parens] = STATE(2406),
    [sym_type_list] = STATE(2406),
    [sym_type_tuple] = STATE(2406),
    [sym__type_promotable_literal] = STATE(2406),
    [sym__type_promoted_literal] = STATE(2406),
    [sym__type_literal] = STATE(2406),
    [sym_type_name] = STATE(2406),
    [sym_type_star] = STATE(2406),
    [sym_type_unboxed_tuple] = STATE(2406),
    [sym_type_unboxed_sum] = STATE(2406),
    [sym__atype] = STATE(2406),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15273),
    [sym_splice] = STATE(2406),
    [sym_quasiquote] = STATE(2406),
    [aux_sym_type_apply_repeat1] = STATE(2406),
    [sym__varid] = ACTIONS(6859),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(6861),
    [sym_char] = ACTIONS(6861),
    [sym_string] = ACTIONS(6861),
    [sym__integer_literal] = ACTIONS(6863),
    [sym__binary_literal] = ACTIONS(6865),
    [sym__octal_literal] = ACTIONS(6865),
    [sym__hex_literal] = ACTIONS(6865),
    [anon_sym_LPAREN_POUND] = ACTIONS(6867),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6867),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(6869),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(6887),
    [anon_sym_LBRACK] = ACTIONS(6874),
    [anon_sym_SQUOTE] = ACTIONS(6890),
    [anon_sym_STAR] = ACTIONS(6879),
    [anon_sym_6] = ACTIONS(6879),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_in] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(6881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym__layout_end] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6883),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6885),
  },
  [2414] = {
    [sym_integer] = STATE(5955),
    [sym__literal] = STATE(5955),
    [sym__unboxed_open] = STATE(2227),
    [sym_constructor] = STATE(5941),
    [sym_con_unit] = STATE(5955),
    [sym_con_list] = STATE(5955),
    [sym_con_tuple] = STATE(5955),
    [sym_qualified_type] = STATE(5953),
    [sym_tycon_arrow] = STATE(5953),
    [sym_type_literal] = STATE(2412),
    [sym__promoted_tycon] = STATE(5953),
    [sym_type_variable] = STATE(5953),
    [sym_annotated_type_variable] = STATE(5953),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14242),
    [sym_type_parens] = STATE(2412),
    [sym_type_list] = STATE(2412),
    [sym_type_tuple] = STATE(2412),
    [sym__type_promotable_literal] = STATE(2412),
    [sym__type_promoted_literal] = STATE(2412),
    [sym__type_literal] = STATE(2412),
    [sym_type_name] = STATE(2437),
    [sym_type_star] = STATE(2412),
    [sym_type_unboxed_tuple] = STATE(2412),
    [sym_type_unboxed_sum] = STATE(2412),
    [sym__atype] = STATE(2412),
    [sym_type_apply] = STATE(7431),
    [sym__btype] = STATE(7431),
    [sym_implicit_param] = STATE(11622),
    [sym_type_infix] = STATE(9700),
    [sym__type_infix] = STATE(9545),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2541),
    [sym__type_quantifiers] = STATE(11622),
    [sym__type_context] = STATE(11622),
    [sym__type_fun] = STATE(11622),
    [sym__type] = STATE(11622),
    [sym__type_or_implicit] = STATE(11622),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15273),
    [sym_splice] = STATE(2412),
    [sym_quasiquote] = STATE(2412),
    [sym__varid] = ACTIONS(6859),
    [sym_float] = ACTIONS(6861),
    [sym_char] = ACTIONS(6861),
    [sym_string] = ACTIONS(6861),
    [sym__integer_literal] = ACTIONS(6863),
    [sym__binary_literal] = ACTIONS(6865),
    [sym__octal_literal] = ACTIONS(6865),
    [sym__hex_literal] = ACTIONS(6865),
    [anon_sym_LPAREN_POUND] = ACTIONS(6867),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6867),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6893),
    [sym_implicit_parid] = ACTIONS(6895),
    [sym__conid] = ACTIONS(6897),
    [anon_sym_LBRACK] = ACTIONS(6874),
    [anon_sym_SQUOTE] = ACTIONS(6899),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6879),
    [anon_sym_6] = ACTIONS(6879),
    [anon_sym_7] = ACTIONS(6881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6885),
  },
  [2415] = {
    [sym_integer] = STATE(6357),
    [sym__literal] = STATE(6357),
    [sym__unboxed_open] = STATE(2219),
    [sym_constructor] = STATE(6142),
    [sym_con_unit] = STATE(6357),
    [sym_con_list] = STATE(6357),
    [sym_con_tuple] = STATE(6357),
    [sym_qualified_type] = STATE(6354),
    [sym_tycon_arrow] = STATE(6354),
    [sym_type_literal] = STATE(2460),
    [sym__promoted_tycon] = STATE(6354),
    [sym_type_variable] = STATE(6354),
    [sym_annotated_type_variable] = STATE(6354),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14131),
    [sym_type_parens] = STATE(2460),
    [sym_type_list] = STATE(2460),
    [sym_type_tuple] = STATE(2460),
    [sym__type_promotable_literal] = STATE(2460),
    [sym__type_promoted_literal] = STATE(2460),
    [sym__type_literal] = STATE(2460),
    [sym_type_name] = STATE(2469),
    [sym_type_star] = STATE(2460),
    [sym_type_unboxed_tuple] = STATE(2460),
    [sym_type_unboxed_sum] = STATE(2460),
    [sym__atype] = STATE(2460),
    [sym_type_apply] = STATE(7651),
    [sym__btype] = STATE(7651),
    [sym_implicit_param] = STATE(12061),
    [sym_type_infix] = STATE(9893),
    [sym__type_infix] = STATE(9713),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2534),
    [sym__type_quantifiers] = STATE(12061),
    [sym__type_context] = STATE(12061),
    [sym__type_fun] = STATE(12061),
    [sym__type] = STATE(12061),
    [sym__type_or_implicit] = STATE(12061),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15108),
    [sym_splice] = STATE(2460),
    [sym_quasiquote] = STATE(2460),
    [sym__varid] = ACTIONS(6901),
    [sym_float] = ACTIONS(6903),
    [sym_char] = ACTIONS(6903),
    [sym_string] = ACTIONS(6903),
    [sym__integer_literal] = ACTIONS(6905),
    [sym__binary_literal] = ACTIONS(6907),
    [sym__octal_literal] = ACTIONS(6907),
    [sym__hex_literal] = ACTIONS(6907),
    [anon_sym_LPAREN_POUND] = ACTIONS(6909),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6909),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6911),
    [sym_implicit_parid] = ACTIONS(6913),
    [sym__conid] = ACTIONS(6915),
    [anon_sym_LBRACK] = ACTIONS(6917),
    [anon_sym_SQUOTE] = ACTIONS(6919),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6921),
    [anon_sym_6] = ACTIONS(6921),
    [anon_sym_7] = ACTIONS(6923),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6925),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6927),
  },
  [2416] = {
    [sym_integer] = STATE(7278),
    [sym__literal] = STATE(7278),
    [sym__unboxed_open] = STATE(2178),
    [sym_constructor] = STATE(6843),
    [sym_con_unit] = STATE(7278),
    [sym_con_list] = STATE(7278),
    [sym_con_tuple] = STATE(7278),
    [sym_qualified_type] = STATE(7262),
    [sym_tycon_arrow] = STATE(7262),
    [sym_type_literal] = STATE(2679),
    [sym__promoted_tycon] = STATE(7262),
    [sym_type_variable] = STATE(7262),
    [sym_annotated_type_variable] = STATE(7262),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14152),
    [sym_type_parens] = STATE(2679),
    [sym_type_list] = STATE(2679),
    [sym_type_tuple] = STATE(2679),
    [sym__type_promotable_literal] = STATE(2679),
    [sym__type_promoted_literal] = STATE(2679),
    [sym__type_literal] = STATE(2679),
    [sym_type_name] = STATE(2687),
    [sym_type_star] = STATE(2679),
    [sym_type_unboxed_tuple] = STATE(2679),
    [sym_type_unboxed_sum] = STATE(2679),
    [sym__atype] = STATE(2679),
    [sym_type_apply] = STATE(8109),
    [sym__btype] = STATE(8109),
    [sym_implicit_param] = STATE(14108),
    [sym_type_infix] = STATE(12317),
    [sym__type_infix] = STATE(12203),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2549),
    [sym__type_quantifiers] = STATE(14108),
    [sym__type_context] = STATE(14108),
    [sym__type_fun] = STATE(14108),
    [sym__type] = STATE(14108),
    [sym__type_or_implicit] = STATE(14108),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15295),
    [sym_splice] = STATE(2679),
    [sym_quasiquote] = STATE(2679),
    [sym__varid] = ACTIONS(6929),
    [sym_float] = ACTIONS(6931),
    [sym_char] = ACTIONS(6931),
    [sym_string] = ACTIONS(6931),
    [sym__integer_literal] = ACTIONS(6933),
    [sym__binary_literal] = ACTIONS(6935),
    [sym__octal_literal] = ACTIONS(6935),
    [sym__hex_literal] = ACTIONS(6935),
    [anon_sym_LPAREN_POUND] = ACTIONS(6937),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6937),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6939),
    [sym_implicit_parid] = ACTIONS(6941),
    [sym__conid] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(6945),
    [anon_sym_SQUOTE] = ACTIONS(6947),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6949),
    [anon_sym_6] = ACTIONS(6949),
    [anon_sym_7] = ACTIONS(6951),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6953),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6955),
  },
  [2417] = {
    [sym_integer] = STATE(7406),
    [sym__literal] = STATE(7406),
    [sym__unboxed_open] = STATE(2172),
    [sym_constructor] = STATE(7276),
    [sym_con_unit] = STATE(7406),
    [sym_con_list] = STATE(7406),
    [sym_con_tuple] = STATE(7406),
    [sym_qualified_type] = STATE(7394),
    [sym_tycon_arrow] = STATE(7394),
    [sym_type_literal] = STATE(2761),
    [sym__promoted_tycon] = STATE(7394),
    [sym_type_variable] = STATE(7394),
    [sym_annotated_type_variable] = STATE(7394),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14306),
    [sym_type_parens] = STATE(2761),
    [sym_type_list] = STATE(2761),
    [sym_type_tuple] = STATE(2761),
    [sym__type_promotable_literal] = STATE(2761),
    [sym__type_promoted_literal] = STATE(2761),
    [sym__type_literal] = STATE(2761),
    [sym_type_name] = STATE(2734),
    [sym_type_star] = STATE(2761),
    [sym_type_unboxed_tuple] = STATE(2761),
    [sym_type_unboxed_sum] = STATE(2761),
    [sym__atype] = STATE(2761),
    [sym_type_apply] = STATE(8261),
    [sym__btype] = STATE(8261),
    [sym_implicit_param] = STATE(15247),
    [sym_type_infix] = STATE(12526),
    [sym__type_infix] = STATE(12243),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2535),
    [sym__type_quantifiers] = STATE(15247),
    [sym__type_context] = STATE(15247),
    [sym__type_fun] = STATE(15247),
    [sym__type] = STATE(15247),
    [sym__type_or_implicit] = STATE(15247),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15131),
    [sym_splice] = STATE(2761),
    [sym_quasiquote] = STATE(2761),
    [sym__varid] = ACTIONS(6957),
    [sym_float] = ACTIONS(6959),
    [sym_char] = ACTIONS(6959),
    [sym_string] = ACTIONS(6959),
    [sym__integer_literal] = ACTIONS(6961),
    [sym__binary_literal] = ACTIONS(6963),
    [sym__octal_literal] = ACTIONS(6963),
    [sym__hex_literal] = ACTIONS(6963),
    [anon_sym_LPAREN_POUND] = ACTIONS(6965),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6965),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6967),
    [sym_implicit_parid] = ACTIONS(6969),
    [sym__conid] = ACTIONS(6971),
    [anon_sym_LBRACK] = ACTIONS(6973),
    [anon_sym_SQUOTE] = ACTIONS(6975),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6977),
    [anon_sym_6] = ACTIONS(6977),
    [anon_sym_7] = ACTIONS(6979),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6981),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6983),
  },
  [2418] = {
    [sym_integer] = STATE(5958),
    [sym__literal] = STATE(5958),
    [sym__unboxed_open] = STATE(2212),
    [sym_constructor] = STATE(5940),
    [sym_con_unit] = STATE(5958),
    [sym_con_list] = STATE(5958),
    [sym_con_tuple] = STATE(5958),
    [sym_qualified_type] = STATE(5952),
    [sym_tycon_arrow] = STATE(5952),
    [sym_type_literal] = STATE(2423),
    [sym__promoted_tycon] = STATE(5952),
    [sym_type_variable] = STATE(5952),
    [sym_annotated_type_variable] = STATE(5952),
    [sym_type_parens] = STATE(2423),
    [sym_type_list] = STATE(2423),
    [sym_type_tuple] = STATE(2423),
    [sym__type_promotable_literal] = STATE(2423),
    [sym__type_promoted_literal] = STATE(2423),
    [sym__type_literal] = STATE(2423),
    [sym_type_name] = STATE(2423),
    [sym_type_star] = STATE(2423),
    [sym_type_unboxed_tuple] = STATE(2423),
    [sym_type_unboxed_sum] = STATE(2423),
    [sym__atype] = STATE(2423),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15080),
    [sym_splice] = STATE(2423),
    [sym_quasiquote] = STATE(2423),
    [aux_sym_type_apply_repeat1] = STATE(2423),
    [sym__varid] = ACTIONS(6985),
    [sym_float] = ACTIONS(6340),
    [sym_char] = ACTIONS(6340),
    [sym_string] = ACTIONS(6340),
    [sym__integer_literal] = ACTIONS(6342),
    [sym__binary_literal] = ACTIONS(6344),
    [sym__octal_literal] = ACTIONS(6344),
    [sym__hex_literal] = ACTIONS(6344),
    [anon_sym_LPAREN_POUND] = ACTIONS(6346),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6346),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(6987),
    [anon_sym_RPAREN] = ACTIONS(5078),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(6989),
    [anon_sym_LBRACK] = ACTIONS(6354),
    [anon_sym_RBRACK] = ACTIONS(5078),
    [anon_sym_SQUOTE] = ACTIONS(6992),
    [anon_sym_STAR] = ACTIONS(6358),
    [anon_sym_6] = ACTIONS(6358),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_EQ] = ACTIONS(5100),
    [anon_sym_RBRACE] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(6360),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6362),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5078),
    [sym_quasiquote_start] = ACTIONS(6364),
  },
  [2419] = {
    [sym_integer] = STATE(8348),
    [sym__literal] = STATE(8348),
    [sym__unboxed_open] = STATE(2180),
    [sym_constructor] = STATE(8056),
    [sym_con_unit] = STATE(8348),
    [sym_con_list] = STATE(8348),
    [sym_con_tuple] = STATE(8348),
    [sym_qualified_type] = STATE(8353),
    [sym_tycon_arrow] = STATE(8353),
    [sym_type_literal] = STATE(2824),
    [sym__promoted_tycon] = STATE(8353),
    [sym_type_variable] = STATE(8353),
    [sym_annotated_type_variable] = STATE(8353),
    [sym_type_parens] = STATE(2824),
    [sym_type_list] = STATE(2824),
    [sym_type_tuple] = STATE(2824),
    [sym__type_promotable_literal] = STATE(2824),
    [sym__type_promoted_literal] = STATE(2824),
    [sym__type_literal] = STATE(2824),
    [sym_strict_type] = STATE(2824),
    [sym_lazy_type] = STATE(2824),
    [sym_type_name] = STATE(2824),
    [sym_type_star] = STATE(2824),
    [sym_type_unboxed_tuple] = STATE(2824),
    [sym_type_unboxed_sum] = STATE(2824),
    [sym__atype] = STATE(2824),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14820),
    [sym_record_fields] = STATE(14055),
    [sym_splice] = STATE(2824),
    [sym_quasiquote] = STATE(2824),
    [aux_sym_data_constructor_repeat1] = STATE(2824),
    [ts_builtin_sym_end] = ACTIONS(6226),
    [sym__varid] = ACTIONS(6995),
    [anon_sym_SEMI] = ACTIONS(6226),
    [sym_float] = ACTIONS(6998),
    [sym_char] = ACTIONS(6998),
    [sym_string] = ACTIONS(6998),
    [sym__integer_literal] = ACTIONS(7001),
    [sym__binary_literal] = ACTIONS(7004),
    [sym__octal_literal] = ACTIONS(7004),
    [sym__hex_literal] = ACTIONS(7004),
    [anon_sym_LPAREN_POUND] = ACTIONS(7007),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7007),
    [anon_sym_] = ACTIONS(6240),
    [anon_sym_EQ_GT] = ACTIONS(6240),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7010),
    [anon_sym_BQUOTE] = ACTIONS(6240),
    [sym__conid] = ACTIONS(7013),
    [anon_sym_LBRACK] = ACTIONS(7016),
    [anon_sym_SQUOTE] = ACTIONS(7019),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_STAR] = ACTIONS(7022),
    [anon_sym_6] = ACTIONS(7022),
    [anon_sym_LBRACE] = ACTIONS(7025),
    [anon_sym_deriving] = ACTIONS(6259),
    [anon_sym_7] = ACTIONS(7027),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(6226),
    [sym__dot] = ACTIONS(6264),
    [sym__splice_dollar] = ACTIONS(7030),
    [sym__consym] = ACTIONS(6240),
    [sym__tyconsym] = ACTIONS(6240),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7033),
    [sym__strict] = ACTIONS(7036),
    [sym__lazy] = ACTIONS(7038),
  },
  [2420] = {
    [sym_integer] = STATE(6722),
    [sym__literal] = STATE(6722),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(6476),
    [sym_con_unit] = STATE(6722),
    [sym_con_list] = STATE(6722),
    [sym_con_tuple] = STATE(6722),
    [sym_qualified_type] = STATE(6642),
    [sym_tycon_arrow] = STATE(6642),
    [sym_type_literal] = STATE(2483),
    [sym__promoted_tycon] = STATE(6642),
    [sym_type_variable] = STATE(6642),
    [sym_annotated_type_variable] = STATE(6642),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14037),
    [sym_type_parens] = STATE(2483),
    [sym_type_list] = STATE(2483),
    [sym_type_tuple] = STATE(2483),
    [sym__type_promotable_literal] = STATE(2483),
    [sym__type_promoted_literal] = STATE(2483),
    [sym__type_literal] = STATE(2483),
    [sym_type_name] = STATE(2496),
    [sym_type_star] = STATE(2483),
    [sym_type_unboxed_tuple] = STATE(2483),
    [sym_type_unboxed_sum] = STATE(2483),
    [sym__atype] = STATE(2483),
    [sym_type_apply] = STATE(7781),
    [sym__btype] = STATE(7781),
    [sym_implicit_param] = STATE(12455),
    [sym_type_infix] = STATE(10316),
    [sym__type_infix] = STATE(9849),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2526),
    [sym__type_quantifiers] = STATE(12455),
    [sym__type_context] = STATE(12455),
    [sym__type_fun] = STATE(12455),
    [sym__type] = STATE(12455),
    [sym__type_or_implicit] = STATE(12455),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14736),
    [sym_splice] = STATE(2483),
    [sym_quasiquote] = STATE(2483),
    [sym__varid] = ACTIONS(7040),
    [sym_float] = ACTIONS(7042),
    [sym_char] = ACTIONS(7042),
    [sym_string] = ACTIONS(7042),
    [sym__integer_literal] = ACTIONS(7044),
    [sym__binary_literal] = ACTIONS(7046),
    [sym__octal_literal] = ACTIONS(7046),
    [sym__hex_literal] = ACTIONS(7046),
    [anon_sym_LPAREN_POUND] = ACTIONS(7048),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7048),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7050),
    [sym_implicit_parid] = ACTIONS(7052),
    [sym__conid] = ACTIONS(7054),
    [anon_sym_LBRACK] = ACTIONS(7056),
    [anon_sym_SQUOTE] = ACTIONS(7058),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7060),
    [anon_sym_6] = ACTIONS(7060),
    [anon_sym_7] = ACTIONS(7062),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7064),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7066),
  },
  [2421] = {
    [sym_integer] = STATE(7576),
    [sym__literal] = STATE(7576),
    [sym__unboxed_open] = STATE(2135),
    [sym_constructor] = STATE(7313),
    [sym_con_unit] = STATE(7576),
    [sym_con_list] = STATE(7576),
    [sym_con_tuple] = STATE(7576),
    [sym_qualified_type] = STATE(7334),
    [sym_tycon_arrow] = STATE(7334),
    [sym_type_literal] = STATE(2759),
    [sym__promoted_tycon] = STATE(7334),
    [sym_type_variable] = STATE(7334),
    [sym_annotated_type_variable] = STATE(7334),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(13993),
    [sym_type_parens] = STATE(2759),
    [sym_type_list] = STATE(2759),
    [sym_type_tuple] = STATE(2759),
    [sym__type_promotable_literal] = STATE(2759),
    [sym__type_promoted_literal] = STATE(2759),
    [sym__type_literal] = STATE(2759),
    [sym_type_name] = STATE(2751),
    [sym_type_star] = STATE(2759),
    [sym_type_unboxed_tuple] = STATE(2759),
    [sym_type_unboxed_sum] = STATE(2759),
    [sym__atype] = STATE(2759),
    [sym_type_apply] = STATE(8300),
    [sym__btype] = STATE(8300),
    [sym_implicit_param] = STATE(14700),
    [sym_type_infix] = STATE(12706),
    [sym__type_infix] = STATE(12293),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2630),
    [sym__type_quantifiers] = STATE(14700),
    [sym__type_context] = STATE(14700),
    [sym__type_fun] = STATE(14700),
    [sym__type] = STATE(14700),
    [sym__type_or_implicit] = STATE(14700),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15269),
    [sym_splice] = STATE(2759),
    [sym_quasiquote] = STATE(2759),
    [sym__varid] = ACTIONS(7068),
    [sym_float] = ACTIONS(7070),
    [sym_char] = ACTIONS(7070),
    [sym_string] = ACTIONS(7070),
    [sym__integer_literal] = ACTIONS(7072),
    [sym__binary_literal] = ACTIONS(7074),
    [sym__octal_literal] = ACTIONS(7074),
    [sym__hex_literal] = ACTIONS(7074),
    [anon_sym_LPAREN_POUND] = ACTIONS(7076),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7076),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7078),
    [sym_implicit_parid] = ACTIONS(7080),
    [sym__conid] = ACTIONS(7082),
    [anon_sym_LBRACK] = ACTIONS(7084),
    [anon_sym_SQUOTE] = ACTIONS(7086),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7088),
    [anon_sym_6] = ACTIONS(7088),
    [anon_sym_7] = ACTIONS(7090),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7092),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7094),
  },
  [2422] = {
    [sym_integer] = STATE(6026),
    [sym__literal] = STATE(6026),
    [sym__unboxed_open] = STATE(2192),
    [sym_constructor] = STATE(5913),
    [sym_con_unit] = STATE(6026),
    [sym_con_list] = STATE(6026),
    [sym_con_tuple] = STATE(6026),
    [sym_qualified_type] = STATE(6029),
    [sym_tycon_arrow] = STATE(6029),
    [sym_type_literal] = STATE(2363),
    [sym__promoted_tycon] = STATE(6029),
    [sym_type_variable] = STATE(6029),
    [sym_annotated_type_variable] = STATE(6029),
    [sym_type_parens] = STATE(2363),
    [sym_type_list] = STATE(2363),
    [sym_type_tuple] = STATE(2363),
    [sym__type_promotable_literal] = STATE(2363),
    [sym__type_promoted_literal] = STATE(2363),
    [sym__type_literal] = STATE(2363),
    [sym_type_name] = STATE(2363),
    [sym_type_star] = STATE(2363),
    [sym_type_unboxed_tuple] = STATE(2363),
    [sym_type_unboxed_sum] = STATE(2363),
    [sym__atype] = STATE(2363),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15103),
    [sym_splice] = STATE(2363),
    [sym_quasiquote] = STATE(2363),
    [aux_sym_type_apply_repeat1] = STATE(2363),
    [sym__varid] = ACTIONS(6849),
    [sym_float] = ACTIONS(6617),
    [sym_char] = ACTIONS(6617),
    [sym_string] = ACTIONS(6617),
    [sym__integer_literal] = ACTIONS(6619),
    [sym__binary_literal] = ACTIONS(6621),
    [sym__octal_literal] = ACTIONS(6621),
    [sym__hex_literal] = ACTIONS(6621),
    [anon_sym_LPAREN_POUND] = ACTIONS(6623),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6623),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(6851),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(7096),
    [anon_sym_LBRACK] = ACTIONS(6631),
    [anon_sym_RBRACK] = ACTIONS(5177),
    [anon_sym_SQUOTE] = ACTIONS(7099),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(6635),
    [anon_sym_6] = ACTIONS(6635),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_DOT_DOT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(6637),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6639),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5177),
    [sym_quasiquote_start] = ACTIONS(6641),
  },
  [2423] = {
    [sym_integer] = STATE(5958),
    [sym__literal] = STATE(5958),
    [sym__unboxed_open] = STATE(2212),
    [sym_constructor] = STATE(5940),
    [sym_con_unit] = STATE(5958),
    [sym_con_list] = STATE(5958),
    [sym_con_tuple] = STATE(5958),
    [sym_qualified_type] = STATE(5952),
    [sym_tycon_arrow] = STATE(5952),
    [sym_type_literal] = STATE(2392),
    [sym__promoted_tycon] = STATE(5952),
    [sym_type_variable] = STATE(5952),
    [sym_annotated_type_variable] = STATE(5952),
    [sym_type_parens] = STATE(2392),
    [sym_type_list] = STATE(2392),
    [sym_type_tuple] = STATE(2392),
    [sym__type_promotable_literal] = STATE(2392),
    [sym__type_promoted_literal] = STATE(2392),
    [sym__type_literal] = STATE(2392),
    [sym_type_name] = STATE(2392),
    [sym_type_star] = STATE(2392),
    [sym_type_unboxed_tuple] = STATE(2392),
    [sym_type_unboxed_sum] = STATE(2392),
    [sym__atype] = STATE(2392),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15080),
    [sym_splice] = STATE(2392),
    [sym_quasiquote] = STATE(2392),
    [aux_sym_type_apply_repeat1] = STATE(2392),
    [sym__varid] = ACTIONS(6985),
    [sym_float] = ACTIONS(6340),
    [sym_char] = ACTIONS(6340),
    [sym_string] = ACTIONS(6340),
    [sym__integer_literal] = ACTIONS(6342),
    [sym__binary_literal] = ACTIONS(6344),
    [sym__octal_literal] = ACTIONS(6344),
    [sym__hex_literal] = ACTIONS(6344),
    [anon_sym_LPAREN_POUND] = ACTIONS(6346),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6346),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(6987),
    [anon_sym_RPAREN] = ACTIONS(5177),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(7102),
    [anon_sym_LBRACK] = ACTIONS(6354),
    [anon_sym_RBRACK] = ACTIONS(5177),
    [anon_sym_SQUOTE] = ACTIONS(7105),
    [anon_sym_STAR] = ACTIONS(6358),
    [anon_sym_6] = ACTIONS(6358),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_EQ] = ACTIONS(5185),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(6360),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6362),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5177),
    [sym_quasiquote_start] = ACTIONS(6364),
  },
  [2424] = {
    [sym_integer] = STATE(6064),
    [sym__literal] = STATE(6064),
    [sym__unboxed_open] = STATE(2150),
    [sym_constructor] = STATE(5877),
    [sym_con_unit] = STATE(6064),
    [sym_con_list] = STATE(6064),
    [sym_con_tuple] = STATE(6064),
    [sym_qualified_type] = STATE(6066),
    [sym_tycon_arrow] = STATE(6066),
    [sym_type_literal] = STATE(2376),
    [sym__promoted_tycon] = STATE(6066),
    [sym_type_variable] = STATE(6066),
    [sym_annotated_type_variable] = STATE(6066),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14102),
    [sym_type_parens] = STATE(2376),
    [sym_type_list] = STATE(2376),
    [sym_type_tuple] = STATE(2376),
    [sym__type_promotable_literal] = STATE(2376),
    [sym__type_promoted_literal] = STATE(2376),
    [sym__type_literal] = STATE(2376),
    [sym_type_name] = STATE(2389),
    [sym_type_star] = STATE(2376),
    [sym_type_unboxed_tuple] = STATE(2376),
    [sym_type_unboxed_sum] = STATE(2376),
    [sym__atype] = STATE(2376),
    [sym_type_apply] = STATE(7487),
    [sym__btype] = STATE(7487),
    [sym_implicit_param] = STATE(11905),
    [sym_type_infix] = STATE(9707),
    [sym__type_infix] = STATE(9579),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2513),
    [sym__type_quantifiers] = STATE(11905),
    [sym__type_context] = STATE(11905),
    [sym__type_fun] = STATE(11905),
    [sym__type] = STATE(11905),
    [sym__type_or_implicit] = STATE(11905),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14778),
    [sym_splice] = STATE(2376),
    [sym_quasiquote] = STATE(2376),
    [sym__varid] = ACTIONS(7108),
    [sym_float] = ACTIONS(6278),
    [sym_char] = ACTIONS(6278),
    [sym_string] = ACTIONS(6278),
    [sym__integer_literal] = ACTIONS(6280),
    [sym__binary_literal] = ACTIONS(6282),
    [sym__octal_literal] = ACTIONS(6282),
    [sym__hex_literal] = ACTIONS(6282),
    [anon_sym_LPAREN_POUND] = ACTIONS(6284),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6284),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7110),
    [sym_implicit_parid] = ACTIONS(7112),
    [sym__conid] = ACTIONS(7114),
    [anon_sym_LBRACK] = ACTIONS(6291),
    [anon_sym_SQUOTE] = ACTIONS(7116),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_6] = ACTIONS(6296),
    [anon_sym_7] = ACTIONS(6298),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6300),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6302),
  },
  [2425] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_RPAREN] = ACTIONS(5129),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_RBRACK] = ACTIONS(5129),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_EQ] = ACTIONS(5160),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5129),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2426] = {
    [sym_integer] = STATE(5892),
    [sym__literal] = STATE(5892),
    [sym__unboxed_open] = STATE(2185),
    [sym_constructor] = STATE(5658),
    [sym_con_unit] = STATE(5892),
    [sym_con_list] = STATE(5892),
    [sym_con_tuple] = STATE(5892),
    [sym_qualified_type] = STATE(5887),
    [sym_tycon_arrow] = STATE(5887),
    [sym_type_literal] = STATE(2295),
    [sym__promoted_tycon] = STATE(5887),
    [sym_type_variable] = STATE(5887),
    [sym_annotated_type_variable] = STATE(5887),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14262),
    [sym_type_parens] = STATE(2295),
    [sym_type_list] = STATE(2295),
    [sym_type_tuple] = STATE(2295),
    [sym__type_promotable_literal] = STATE(2295),
    [sym__type_promoted_literal] = STATE(2295),
    [sym__type_literal] = STATE(2295),
    [sym_type_name] = STATE(2351),
    [sym_type_star] = STATE(2295),
    [sym_type_unboxed_tuple] = STATE(2295),
    [sym_type_unboxed_sum] = STATE(2295),
    [sym__atype] = STATE(2295),
    [sym_type_apply] = STATE(7097),
    [sym__btype] = STATE(7097),
    [sym_implicit_param] = STATE(10896),
    [sym_type_infix] = STATE(9558),
    [sym__type_infix] = STATE(9459),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2511),
    [sym__type_quantifiers] = STATE(10896),
    [sym__type_context] = STATE(10896),
    [sym__type_fun] = STATE(10896),
    [sym__type] = STATE(10896),
    [sym__type_or_implicit] = STATE(10896),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15268),
    [sym_splice] = STATE(2295),
    [sym_quasiquote] = STATE(2295),
    [sym__varid] = ACTIONS(5796),
    [sym_float] = ACTIONS(5798),
    [sym_char] = ACTIONS(5798),
    [sym_string] = ACTIONS(5798),
    [sym__integer_literal] = ACTIONS(5800),
    [sym__binary_literal] = ACTIONS(5802),
    [sym__octal_literal] = ACTIONS(5802),
    [sym__hex_literal] = ACTIONS(5802),
    [anon_sym_LPAREN_POUND] = ACTIONS(5804),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5804),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7118),
    [sym_implicit_parid] = ACTIONS(7120),
    [sym__conid] = ACTIONS(7122),
    [anon_sym_LBRACK] = ACTIONS(5811),
    [anon_sym_SQUOTE] = ACTIONS(7124),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5816),
    [anon_sym_6] = ACTIONS(5816),
    [anon_sym_7] = ACTIONS(5818),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5822),
  },
  [2427] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_in] = ACTIONS(5160),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2428] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_implicit_param] = STATE(18214),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(18214),
    [sym__type_context] = STATE(18214),
    [sym__type_fun] = STATE(18214),
    [sym__type] = STATE(18214),
    [sym__type_or_implicit] = STATE(18214),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym_implicit_parid] = ACTIONS(6040),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2429] = {
    [sym_integer] = STATE(6402),
    [sym__literal] = STATE(6402),
    [sym__unboxed_open] = STATE(2110),
    [sym_constructor] = STATE(6210),
    [sym_con_unit] = STATE(6402),
    [sym_con_list] = STATE(6402),
    [sym_con_tuple] = STATE(6402),
    [sym_qualified_type] = STATE(6415),
    [sym_tycon_arrow] = STATE(6415),
    [sym_type_literal] = STATE(2467),
    [sym__promoted_tycon] = STATE(6415),
    [sym_type_variable] = STATE(6415),
    [sym_annotated_type_variable] = STATE(6415),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14198),
    [sym_type_parens] = STATE(2467),
    [sym_type_list] = STATE(2467),
    [sym_type_tuple] = STATE(2467),
    [sym__type_promotable_literal] = STATE(2467),
    [sym__type_promoted_literal] = STATE(2467),
    [sym__type_literal] = STATE(2467),
    [sym_type_name] = STATE(2451),
    [sym_type_star] = STATE(2467),
    [sym_type_unboxed_tuple] = STATE(2467),
    [sym_type_unboxed_sum] = STATE(2467),
    [sym__atype] = STATE(2467),
    [sym_type_apply] = STATE(7671),
    [sym__btype] = STATE(7671),
    [sym_implicit_param] = STATE(12217),
    [sym_type_infix] = STATE(9845),
    [sym__type_infix] = STATE(9634),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2512),
    [sym__type_quantifiers] = STATE(12217),
    [sym__type_context] = STATE(12217),
    [sym__type_fun] = STATE(12217),
    [sym__type] = STATE(12217),
    [sym__type_or_implicit] = STATE(12217),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15251),
    [sym_splice] = STATE(2467),
    [sym_quasiquote] = STATE(2467),
    [sym__varid] = ACTIONS(7126),
    [sym_float] = ACTIONS(7128),
    [sym_char] = ACTIONS(7128),
    [sym_string] = ACTIONS(7128),
    [sym__integer_literal] = ACTIONS(7130),
    [sym__binary_literal] = ACTIONS(7132),
    [sym__octal_literal] = ACTIONS(7132),
    [sym__hex_literal] = ACTIONS(7132),
    [anon_sym_LPAREN_POUND] = ACTIONS(7134),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7134),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7136),
    [sym_implicit_parid] = ACTIONS(7138),
    [sym__conid] = ACTIONS(7140),
    [anon_sym_LBRACK] = ACTIONS(7142),
    [anon_sym_SQUOTE] = ACTIONS(7144),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7146),
    [anon_sym_6] = ACTIONS(7146),
    [anon_sym_7] = ACTIONS(7148),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7150),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7152),
  },
  [2430] = {
    [sym_integer] = STATE(4881),
    [sym__literal] = STATE(4881),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(4828),
    [sym_con_unit] = STATE(4881),
    [sym_con_list] = STATE(4881),
    [sym_con_tuple] = STATE(4881),
    [sym_qualified_type] = STATE(4884),
    [sym_tycon_arrow] = STATE(4884),
    [sym_type_literal] = STATE(2094),
    [sym__promoted_tycon] = STATE(4884),
    [sym_type_variable] = STATE(4884),
    [sym_annotated_type_variable] = STATE(4884),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14261),
    [sym_type_parens] = STATE(2094),
    [sym_type_list] = STATE(2094),
    [sym_type_tuple] = STATE(2094),
    [sym__type_promotable_literal] = STATE(2094),
    [sym__type_promoted_literal] = STATE(2094),
    [sym__type_literal] = STATE(2094),
    [sym_type_name] = STATE(2088),
    [sym_type_star] = STATE(2094),
    [sym_type_unboxed_tuple] = STATE(2094),
    [sym_type_unboxed_sum] = STATE(2094),
    [sym__atype] = STATE(2094),
    [sym_type_apply] = STATE(6655),
    [sym__btype] = STATE(6655),
    [sym_implicit_param] = STATE(9677),
    [sym_type_infix] = STATE(9439),
    [sym__type_infix] = STATE(9338),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2605),
    [sym__type_quantifiers] = STATE(9677),
    [sym__type_context] = STATE(9677),
    [sym__type_fun] = STATE(9677),
    [sym__type] = STATE(9677),
    [sym__type_or_implicit] = STATE(9677),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15214),
    [sym_splice] = STATE(2094),
    [sym_quasiquote] = STATE(2094),
    [sym__varid] = ACTIONS(5373),
    [sym_float] = ACTIONS(5375),
    [sym_char] = ACTIONS(5375),
    [sym_string] = ACTIONS(5375),
    [sym__integer_literal] = ACTIONS(5377),
    [sym__binary_literal] = ACTIONS(5379),
    [sym__octal_literal] = ACTIONS(5379),
    [sym__hex_literal] = ACTIONS(5379),
    [anon_sym_LPAREN_POUND] = ACTIONS(5381),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5381),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7154),
    [sym_implicit_parid] = ACTIONS(7156),
    [sym__conid] = ACTIONS(7158),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_SQUOTE] = ACTIONS(7160),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5393),
    [anon_sym_6] = ACTIONS(5393),
    [anon_sym_7] = ACTIONS(5395),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5397),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5399),
  },
  [2431] = {
    [sym_integer] = STATE(6228),
    [sym__literal] = STATE(6228),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(5787),
    [sym_con_unit] = STATE(6228),
    [sym_con_list] = STATE(6228),
    [sym_con_tuple] = STATE(6228),
    [sym_qualified_type] = STATE(6115),
    [sym_tycon_arrow] = STATE(6115),
    [sym_type_literal] = STATE(2431),
    [sym__promoted_tycon] = STATE(6115),
    [sym_type_variable] = STATE(6115),
    [sym_annotated_type_variable] = STATE(6115),
    [sym_type_parens] = STATE(2431),
    [sym_type_list] = STATE(2431),
    [sym_type_tuple] = STATE(2431),
    [sym__type_promotable_literal] = STATE(2431),
    [sym__type_promoted_literal] = STATE(2431),
    [sym__type_literal] = STATE(2431),
    [sym_type_name] = STATE(2431),
    [sym_type_star] = STATE(2431),
    [sym_type_unboxed_tuple] = STATE(2431),
    [sym_type_unboxed_sum] = STATE(2431),
    [sym__atype] = STATE(2431),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15408),
    [sym_splice] = STATE(2431),
    [sym_quasiquote] = STATE(2431),
    [aux_sym_type_apply_repeat1] = STATE(2431),
    [sym__varid] = ACTIONS(7162),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(7165),
    [sym_char] = ACTIONS(7165),
    [sym_string] = ACTIONS(7165),
    [sym__integer_literal] = ACTIONS(7168),
    [sym__binary_literal] = ACTIONS(7171),
    [sym__octal_literal] = ACTIONS(7171),
    [sym__hex_literal] = ACTIONS(7171),
    [anon_sym_LPAREN_POUND] = ACTIONS(7174),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7174),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(7177),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(7180),
    [anon_sym_LBRACK] = ACTIONS(7183),
    [anon_sym_SQUOTE] = ACTIONS(7186),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(7189),
    [anon_sym_6] = ACTIONS(7189),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_in] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(7192),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(7195),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7198),
  },
  [2432] = {
    [sym_integer] = STATE(6622),
    [sym__literal] = STATE(6622),
    [sym__unboxed_open] = STATE(2223),
    [sym_constructor] = STATE(6527),
    [sym_con_unit] = STATE(6622),
    [sym_con_list] = STATE(6622),
    [sym_con_tuple] = STATE(6622),
    [sym_qualified_type] = STATE(6611),
    [sym_tycon_arrow] = STATE(6611),
    [sym_type_literal] = STATE(2490),
    [sym__promoted_tycon] = STATE(6611),
    [sym_type_variable] = STATE(6611),
    [sym_annotated_type_variable] = STATE(6611),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14484),
    [sym_type_parens] = STATE(2490),
    [sym_type_list] = STATE(2490),
    [sym_type_tuple] = STATE(2490),
    [sym__type_promotable_literal] = STATE(2490),
    [sym__type_promoted_literal] = STATE(2490),
    [sym__type_literal] = STATE(2490),
    [sym_type_name] = STATE(2482),
    [sym_type_star] = STATE(2490),
    [sym_type_unboxed_tuple] = STATE(2490),
    [sym_type_unboxed_sum] = STATE(2490),
    [sym__atype] = STATE(2490),
    [sym_type_apply] = STATE(7827),
    [sym__btype] = STATE(7827),
    [sym_implicit_param] = STATE(12259),
    [sym_type_infix] = STATE(10085),
    [sym__type_infix] = STATE(9970),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2578),
    [sym__type_quantifiers] = STATE(12259),
    [sym__type_context] = STATE(12259),
    [sym__type_fun] = STATE(12259),
    [sym__type] = STATE(12259),
    [sym__type_or_implicit] = STATE(12259),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14645),
    [sym_splice] = STATE(2490),
    [sym_quasiquote] = STATE(2490),
    [sym__varid] = ACTIONS(7201),
    [sym_float] = ACTIONS(7203),
    [sym_char] = ACTIONS(7203),
    [sym_string] = ACTIONS(7203),
    [sym__integer_literal] = ACTIONS(7205),
    [sym__binary_literal] = ACTIONS(7207),
    [sym__octal_literal] = ACTIONS(7207),
    [sym__hex_literal] = ACTIONS(7207),
    [anon_sym_LPAREN_POUND] = ACTIONS(7209),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7209),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7211),
    [sym_implicit_parid] = ACTIONS(7213),
    [sym__conid] = ACTIONS(7215),
    [anon_sym_LBRACK] = ACTIONS(7217),
    [anon_sym_SQUOTE] = ACTIONS(7219),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7221),
    [anon_sym_6] = ACTIONS(7221),
    [anon_sym_7] = ACTIONS(7223),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7225),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7227),
  },
  [2433] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym__layout_end] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2434] = {
    [sym_integer] = STATE(6425),
    [sym__literal] = STATE(6425),
    [sym__unboxed_open] = STATE(2108),
    [sym_constructor] = STATE(5969),
    [sym_con_unit] = STATE(6425),
    [sym_con_list] = STATE(6425),
    [sym_con_tuple] = STATE(6425),
    [sym_qualified_type] = STATE(6424),
    [sym_tycon_arrow] = STATE(6424),
    [sym_type_literal] = STATE(2461),
    [sym__promoted_tycon] = STATE(6424),
    [sym_type_variable] = STATE(6424),
    [sym_annotated_type_variable] = STATE(6424),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14052),
    [sym_type_parens] = STATE(2461),
    [sym_type_list] = STATE(2461),
    [sym_type_tuple] = STATE(2461),
    [sym__type_promotable_literal] = STATE(2461),
    [sym__type_promoted_literal] = STATE(2461),
    [sym__type_literal] = STATE(2461),
    [sym_type_name] = STATE(2449),
    [sym_type_star] = STATE(2461),
    [sym_type_unboxed_tuple] = STATE(2461),
    [sym_type_unboxed_sum] = STATE(2461),
    [sym__atype] = STATE(2461),
    [sym_type_apply] = STATE(7690),
    [sym__btype] = STATE(7690),
    [sym_implicit_param] = STATE(13530),
    [sym_type_infix] = STATE(11131),
    [sym__type_infix] = STATE(11614),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2619),
    [sym__type_quantifiers] = STATE(13530),
    [sym__type_context] = STATE(13530),
    [sym__type_fun] = STATE(13530),
    [sym__type] = STATE(13530),
    [sym__type_or_implicit] = STATE(13530),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15009),
    [sym_splice] = STATE(2461),
    [sym_quasiquote] = STATE(2461),
    [sym__varid] = ACTIONS(7229),
    [sym_float] = ACTIONS(7231),
    [sym_char] = ACTIONS(7231),
    [sym_string] = ACTIONS(7231),
    [sym__integer_literal] = ACTIONS(7233),
    [sym__binary_literal] = ACTIONS(7235),
    [sym__octal_literal] = ACTIONS(7235),
    [sym__hex_literal] = ACTIONS(7235),
    [anon_sym_LPAREN_POUND] = ACTIONS(7237),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7237),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7239),
    [sym_implicit_parid] = ACTIONS(7241),
    [sym__conid] = ACTIONS(7243),
    [anon_sym_LBRACK] = ACTIONS(7245),
    [anon_sym_SQUOTE] = ACTIONS(7247),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7249),
    [anon_sym_6] = ACTIONS(7249),
    [anon_sym_7] = ACTIONS(7251),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7253),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7255),
  },
  [2435] = {
    [sym_integer] = STATE(7045),
    [sym__literal] = STATE(7045),
    [sym__unboxed_open] = STATE(2097),
    [sym_constructor] = STATE(6786),
    [sym_con_unit] = STATE(7045),
    [sym_con_list] = STATE(7045),
    [sym_con_tuple] = STATE(7045),
    [sym_qualified_type] = STATE(7047),
    [sym_tycon_arrow] = STATE(7047),
    [sym_type_literal] = STATE(2621),
    [sym__promoted_tycon] = STATE(7047),
    [sym_type_variable] = STATE(7047),
    [sym_annotated_type_variable] = STATE(7047),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14203),
    [sym_type_parens] = STATE(2621),
    [sym_type_list] = STATE(2621),
    [sym_type_tuple] = STATE(2621),
    [sym__type_promotable_literal] = STATE(2621),
    [sym__type_promoted_literal] = STATE(2621),
    [sym__type_literal] = STATE(2621),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2621),
    [sym_type_unboxed_tuple] = STATE(2621),
    [sym_type_unboxed_sum] = STATE(2621),
    [sym__atype] = STATE(2621),
    [sym_type_apply] = STATE(7940),
    [sym__btype] = STATE(7940),
    [sym_implicit_param] = STATE(13431),
    [sym_type_infix] = STATE(11945),
    [sym__type_infix] = STATE(11900),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2516),
    [sym__type_quantifiers] = STATE(13431),
    [sym__type_context] = STATE(13431),
    [sym__type_fun] = STATE(13431),
    [sym__type] = STATE(13431),
    [sym__type_or_implicit] = STATE(13431),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15321),
    [sym_splice] = STATE(2621),
    [sym_quasiquote] = STATE(2621),
    [sym__varid] = ACTIONS(7257),
    [sym_float] = ACTIONS(7259),
    [sym_char] = ACTIONS(7259),
    [sym_string] = ACTIONS(7259),
    [sym__integer_literal] = ACTIONS(7261),
    [sym__binary_literal] = ACTIONS(7263),
    [sym__octal_literal] = ACTIONS(7263),
    [sym__hex_literal] = ACTIONS(7263),
    [anon_sym_LPAREN_POUND] = ACTIONS(7265),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7265),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7267),
    [sym_implicit_parid] = ACTIONS(7269),
    [sym__conid] = ACTIONS(7271),
    [anon_sym_LBRACK] = ACTIONS(7273),
    [anon_sym_SQUOTE] = ACTIONS(7275),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7277),
    [anon_sym_6] = ACTIONS(7277),
    [anon_sym_7] = ACTIONS(7279),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7281),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7283),
  },
  [2436] = {
    [sym_integer] = STATE(6432),
    [sym__literal] = STATE(6432),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(5995),
    [sym_con_unit] = STATE(6432),
    [sym_con_list] = STATE(6432),
    [sym_con_tuple] = STATE(6432),
    [sym_qualified_type] = STATE(6532),
    [sym_tycon_arrow] = STATE(6532),
    [sym_type_literal] = STATE(2477),
    [sym__promoted_tycon] = STATE(6532),
    [sym_type_variable] = STATE(6532),
    [sym_annotated_type_variable] = STATE(6532),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14042),
    [sym_type_parens] = STATE(2477),
    [sym_type_list] = STATE(2477),
    [sym_type_tuple] = STATE(2477),
    [sym__type_promotable_literal] = STATE(2477),
    [sym__type_promoted_literal] = STATE(2477),
    [sym__type_literal] = STATE(2477),
    [sym_type_name] = STATE(2457),
    [sym_type_star] = STATE(2477),
    [sym_type_unboxed_tuple] = STATE(2477),
    [sym_type_unboxed_sum] = STATE(2477),
    [sym__atype] = STATE(2477),
    [sym_type_apply] = STATE(7621),
    [sym__btype] = STATE(7621),
    [sym_implicit_param] = STATE(12142),
    [sym_type_infix] = STATE(9737),
    [sym__type_infix] = STATE(9596),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2649),
    [sym__type_quantifiers] = STATE(12142),
    [sym__type_context] = STATE(12142),
    [sym__type_fun] = STATE(12142),
    [sym__type] = STATE(12142),
    [sym__type_or_implicit] = STATE(12142),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14749),
    [sym_splice] = STATE(2477),
    [sym_quasiquote] = STATE(2477),
    [sym__varid] = ACTIONS(7285),
    [sym_float] = ACTIONS(7287),
    [sym_char] = ACTIONS(7287),
    [sym_string] = ACTIONS(7287),
    [sym__integer_literal] = ACTIONS(7289),
    [sym__binary_literal] = ACTIONS(7291),
    [sym__octal_literal] = ACTIONS(7291),
    [sym__hex_literal] = ACTIONS(7291),
    [anon_sym_LPAREN_POUND] = ACTIONS(7293),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7293),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7295),
    [sym_implicit_parid] = ACTIONS(7297),
    [sym__conid] = ACTIONS(7299),
    [anon_sym_LBRACK] = ACTIONS(7301),
    [anon_sym_SQUOTE] = ACTIONS(7303),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7305),
    [anon_sym_6] = ACTIONS(7305),
    [anon_sym_7] = ACTIONS(7307),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7309),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7311),
  },
  [2437] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_in] = ACTIONS(5160),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym__layout_end] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2438] = {
    [sym_integer] = STATE(6771),
    [sym__literal] = STATE(6771),
    [sym__unboxed_open] = STATE(2214),
    [sym_constructor] = STATE(6276),
    [sym_con_unit] = STATE(6771),
    [sym_con_list] = STATE(6771),
    [sym_con_tuple] = STATE(6771),
    [sym_qualified_type] = STATE(6769),
    [sym_tycon_arrow] = STATE(6769),
    [sym_type_literal] = STATE(2489),
    [sym__promoted_tycon] = STATE(6769),
    [sym_type_variable] = STATE(6769),
    [sym_annotated_type_variable] = STATE(6769),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14144),
    [sym_type_parens] = STATE(2489),
    [sym_type_list] = STATE(2489),
    [sym_type_tuple] = STATE(2489),
    [sym__type_promotable_literal] = STATE(2489),
    [sym__type_promoted_literal] = STATE(2489),
    [sym__type_literal] = STATE(2489),
    [sym_type_name] = STATE(2487),
    [sym_type_star] = STATE(2489),
    [sym_type_unboxed_tuple] = STATE(2489),
    [sym_type_unboxed_sum] = STATE(2489),
    [sym__atype] = STATE(2489),
    [sym_type_apply] = STATE(7772),
    [sym__btype] = STATE(7772),
    [sym_implicit_param] = STATE(12399),
    [sym_type_infix] = STATE(10200),
    [sym__type_infix] = STATE(9950),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2588),
    [sym__type_quantifiers] = STATE(12399),
    [sym__type_context] = STATE(12399),
    [sym__type_fun] = STATE(12399),
    [sym__type] = STATE(12399),
    [sym__type_or_implicit] = STATE(12399),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15096),
    [sym_splice] = STATE(2489),
    [sym_quasiquote] = STATE(2489),
    [sym__varid] = ACTIONS(7313),
    [sym_float] = ACTIONS(7315),
    [sym_char] = ACTIONS(7315),
    [sym_string] = ACTIONS(7315),
    [sym__integer_literal] = ACTIONS(7317),
    [sym__binary_literal] = ACTIONS(7319),
    [sym__octal_literal] = ACTIONS(7319),
    [sym__hex_literal] = ACTIONS(7319),
    [anon_sym_LPAREN_POUND] = ACTIONS(7321),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7321),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7323),
    [sym_implicit_parid] = ACTIONS(7325),
    [sym__conid] = ACTIONS(7327),
    [anon_sym_LBRACK] = ACTIONS(7329),
    [anon_sym_SQUOTE] = ACTIONS(7331),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7333),
    [anon_sym_6] = ACTIONS(7333),
    [anon_sym_7] = ACTIONS(7335),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7337),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7339),
  },
  [2439] = {
    [sym_integer] = STATE(7144),
    [sym__literal] = STATE(7144),
    [sym__unboxed_open] = STATE(2183),
    [sym_constructor] = STATE(6953),
    [sym_con_unit] = STATE(7144),
    [sym_con_list] = STATE(7144),
    [sym_con_tuple] = STATE(7144),
    [sym_qualified_type] = STATE(7070),
    [sym_tycon_arrow] = STATE(7070),
    [sym_type_literal] = STATE(2715),
    [sym__promoted_tycon] = STATE(7070),
    [sym_type_variable] = STATE(7070),
    [sym_annotated_type_variable] = STATE(7070),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14471),
    [sym_type_parens] = STATE(2715),
    [sym_type_list] = STATE(2715),
    [sym_type_tuple] = STATE(2715),
    [sym__type_promotable_literal] = STATE(2715),
    [sym__type_promoted_literal] = STATE(2715),
    [sym__type_literal] = STATE(2715),
    [sym_type_name] = STATE(2784),
    [sym_type_star] = STATE(2715),
    [sym_type_unboxed_tuple] = STATE(2715),
    [sym_type_unboxed_sum] = STATE(2715),
    [sym__atype] = STATE(2715),
    [sym_type_apply] = STATE(8118),
    [sym__btype] = STATE(8118),
    [sym_implicit_param] = STATE(18735),
    [sym_type_infix] = STATE(13351),
    [sym__type_infix] = STATE(12972),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2595),
    [sym__type_quantifiers] = STATE(18735),
    [sym__type_context] = STATE(18735),
    [sym__type_fun] = STATE(18735),
    [sym__type] = STATE(18735),
    [sym__type_or_implicit] = STATE(18735),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15335),
    [sym_splice] = STATE(2715),
    [sym_quasiquote] = STATE(2715),
    [sym__varid] = ACTIONS(7341),
    [sym_float] = ACTIONS(7343),
    [sym_char] = ACTIONS(7343),
    [sym_string] = ACTIONS(7343),
    [sym__integer_literal] = ACTIONS(7345),
    [sym__binary_literal] = ACTIONS(7347),
    [sym__octal_literal] = ACTIONS(7347),
    [sym__hex_literal] = ACTIONS(7347),
    [anon_sym_LPAREN_POUND] = ACTIONS(7349),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7349),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7351),
    [sym_implicit_parid] = ACTIONS(7353),
    [sym__conid] = ACTIONS(7355),
    [anon_sym_LBRACK] = ACTIONS(7357),
    [anon_sym_SQUOTE] = ACTIONS(7359),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7361),
    [anon_sym_6] = ACTIONS(7361),
    [anon_sym_7] = ACTIONS(7363),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7365),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7367),
  },
  [2440] = {
    [sym_integer] = STATE(7606),
    [sym__literal] = STATE(7606),
    [sym__unboxed_open] = STATE(2159),
    [sym_constructor] = STATE(7574),
    [sym_con_unit] = STATE(7606),
    [sym_con_list] = STATE(7606),
    [sym_con_tuple] = STATE(7606),
    [sym_qualified_type] = STATE(7609),
    [sym_tycon_arrow] = STATE(7609),
    [sym_type_literal] = STATE(2780),
    [sym__promoted_tycon] = STATE(7609),
    [sym_type_variable] = STATE(7609),
    [sym_annotated_type_variable] = STATE(7609),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14566),
    [sym_type_parens] = STATE(2780),
    [sym_type_list] = STATE(2780),
    [sym_type_tuple] = STATE(2780),
    [sym__type_promotable_literal] = STATE(2780),
    [sym__type_promoted_literal] = STATE(2780),
    [sym__type_literal] = STATE(2780),
    [sym_type_name] = STATE(2771),
    [sym_type_star] = STATE(2780),
    [sym_type_unboxed_tuple] = STATE(2780),
    [sym_type_unboxed_sum] = STATE(2780),
    [sym__atype] = STATE(2780),
    [sym_type_apply] = STATE(8651),
    [sym__btype] = STATE(8651),
    [sym_implicit_param] = STATE(16746),
    [sym_type_infix] = STATE(12900),
    [sym__type_infix] = STATE(12620),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2514),
    [sym__type_quantifiers] = STATE(16746),
    [sym__type_context] = STATE(16746),
    [sym__type_fun] = STATE(16746),
    [sym__type] = STATE(16746),
    [sym__type_or_implicit] = STATE(16746),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15052),
    [sym_splice] = STATE(2780),
    [sym_quasiquote] = STATE(2780),
    [sym__varid] = ACTIONS(7369),
    [sym_float] = ACTIONS(7371),
    [sym_char] = ACTIONS(7371),
    [sym_string] = ACTIONS(7371),
    [sym__integer_literal] = ACTIONS(7373),
    [sym__binary_literal] = ACTIONS(7375),
    [sym__octal_literal] = ACTIONS(7375),
    [sym__hex_literal] = ACTIONS(7375),
    [anon_sym_LPAREN_POUND] = ACTIONS(7377),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7377),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7379),
    [sym_implicit_parid] = ACTIONS(7381),
    [sym__conid] = ACTIONS(7383),
    [anon_sym_LBRACK] = ACTIONS(7385),
    [anon_sym_SQUOTE] = ACTIONS(7387),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7389),
    [anon_sym_6] = ACTIONS(7389),
    [anon_sym_7] = ACTIONS(7391),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7393),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7395),
  },
  [2441] = {
    [sym_integer] = STATE(6509),
    [sym__literal] = STATE(6509),
    [sym__unboxed_open] = STATE(2133),
    [sym_constructor] = STATE(5968),
    [sym_con_unit] = STATE(6509),
    [sym_con_list] = STATE(6509),
    [sym_con_tuple] = STATE(6509),
    [sym_qualified_type] = STATE(6463),
    [sym_tycon_arrow] = STATE(6463),
    [sym_type_literal] = STATE(2456),
    [sym__promoted_tycon] = STATE(6463),
    [sym_type_variable] = STATE(6463),
    [sym_annotated_type_variable] = STATE(6463),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14523),
    [sym_type_parens] = STATE(2456),
    [sym_type_list] = STATE(2456),
    [sym_type_tuple] = STATE(2456),
    [sym__type_promotable_literal] = STATE(2456),
    [sym__type_promoted_literal] = STATE(2456),
    [sym__type_literal] = STATE(2456),
    [sym_type_name] = STATE(2478),
    [sym_type_star] = STATE(2456),
    [sym_type_unboxed_tuple] = STATE(2456),
    [sym_type_unboxed_sum] = STATE(2456),
    [sym__atype] = STATE(2456),
    [sym_type_apply] = STATE(7597),
    [sym__btype] = STATE(7597),
    [sym_implicit_param] = STATE(13831),
    [sym_type_infix] = STATE(11310),
    [sym__type_infix] = STATE(11811),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2644),
    [sym__type_quantifiers] = STATE(13831),
    [sym__type_context] = STATE(13831),
    [sym__type_fun] = STATE(13831),
    [sym__type] = STATE(13831),
    [sym__type_or_implicit] = STATE(13831),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14649),
    [sym_splice] = STATE(2456),
    [sym_quasiquote] = STATE(2456),
    [sym__varid] = ACTIONS(7397),
    [sym_float] = ACTIONS(7399),
    [sym_char] = ACTIONS(7399),
    [sym_string] = ACTIONS(7399),
    [sym__integer_literal] = ACTIONS(7401),
    [sym__binary_literal] = ACTIONS(7403),
    [sym__octal_literal] = ACTIONS(7403),
    [sym__hex_literal] = ACTIONS(7403),
    [anon_sym_LPAREN_POUND] = ACTIONS(7405),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7405),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7407),
    [sym_implicit_parid] = ACTIONS(7409),
    [sym__conid] = ACTIONS(7411),
    [anon_sym_LBRACK] = ACTIONS(7413),
    [anon_sym_SQUOTE] = ACTIONS(7415),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7417),
    [anon_sym_6] = ACTIONS(7417),
    [anon_sym_7] = ACTIONS(7419),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7421),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7423),
  },
  [2442] = {
    [sym_integer] = STATE(5998),
    [sym__literal] = STATE(5998),
    [sym__unboxed_open] = STATE(2200),
    [sym_constructor] = STATE(5931),
    [sym_con_unit] = STATE(5998),
    [sym_con_list] = STATE(5998),
    [sym_con_tuple] = STATE(5998),
    [sym_qualified_type] = STATE(5996),
    [sym_tycon_arrow] = STATE(5996),
    [sym_type_literal] = STATE(2442),
    [sym__promoted_tycon] = STATE(5996),
    [sym_type_variable] = STATE(5996),
    [sym_annotated_type_variable] = STATE(5996),
    [sym_type_parens] = STATE(2442),
    [sym_type_list] = STATE(2442),
    [sym_type_tuple] = STATE(2442),
    [sym__type_promotable_literal] = STATE(2442),
    [sym__type_promoted_literal] = STATE(2442),
    [sym__type_literal] = STATE(2442),
    [sym_type_name] = STATE(2442),
    [sym_type_star] = STATE(2442),
    [sym_type_unboxed_tuple] = STATE(2442),
    [sym_type_unboxed_sum] = STATE(2442),
    [sym__atype] = STATE(2442),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15278),
    [sym_splice] = STATE(2442),
    [sym_quasiquote] = STATE(2442),
    [aux_sym_type_apply_repeat1] = STATE(2442),
    [sym__varid] = ACTIONS(7425),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(7428),
    [sym_char] = ACTIONS(7428),
    [sym_string] = ACTIONS(7428),
    [sym__integer_literal] = ACTIONS(7431),
    [sym__binary_literal] = ACTIONS(7434),
    [sym__octal_literal] = ACTIONS(7434),
    [sym__hex_literal] = ACTIONS(7434),
    [anon_sym_LPAREN_POUND] = ACTIONS(7437),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7437),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(7440),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(7443),
    [anon_sym_LBRACK] = ACTIONS(7446),
    [anon_sym_SQUOTE] = ACTIONS(7449),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(7452),
    [anon_sym_6] = ACTIONS(7452),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(7455),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym__layout_end] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(7458),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7461),
  },
  [2443] = {
    [sym_integer] = STATE(6509),
    [sym__literal] = STATE(6509),
    [sym__unboxed_open] = STATE(2133),
    [sym_constructor] = STATE(5968),
    [sym_con_unit] = STATE(6509),
    [sym_con_list] = STATE(6509),
    [sym_con_tuple] = STATE(6509),
    [sym_qualified_type] = STATE(6463),
    [sym_tycon_arrow] = STATE(6463),
    [sym_type_literal] = STATE(2443),
    [sym__promoted_tycon] = STATE(6463),
    [sym_type_variable] = STATE(6463),
    [sym_annotated_type_variable] = STATE(6463),
    [sym_type_parens] = STATE(2443),
    [sym_type_list] = STATE(2443),
    [sym_type_tuple] = STATE(2443),
    [sym__type_promotable_literal] = STATE(2443),
    [sym__type_promoted_literal] = STATE(2443),
    [sym__type_literal] = STATE(2443),
    [sym_type_name] = STATE(2443),
    [sym_type_star] = STATE(2443),
    [sym_type_unboxed_tuple] = STATE(2443),
    [sym_type_unboxed_sum] = STATE(2443),
    [sym__atype] = STATE(2443),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14649),
    [sym_splice] = STATE(2443),
    [sym_quasiquote] = STATE(2443),
    [aux_sym_type_apply_repeat1] = STATE(2443),
    [ts_builtin_sym_end] = ACTIONS(5030),
    [sym__varid] = ACTIONS(7464),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(7467),
    [sym_char] = ACTIONS(7467),
    [sym_string] = ACTIONS(7467),
    [sym__integer_literal] = ACTIONS(7470),
    [sym__binary_literal] = ACTIONS(7473),
    [sym__octal_literal] = ACTIONS(7473),
    [sym__hex_literal] = ACTIONS(7473),
    [anon_sym_LPAREN_POUND] = ACTIONS(7476),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7476),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7479),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(7482),
    [anon_sym_LBRACK] = ACTIONS(7485),
    [anon_sym_SQUOTE] = ACTIONS(7488),
    [anon_sym_STAR] = ACTIONS(7491),
    [anon_sym_6] = ACTIONS(7491),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_EQ] = ACTIONS(5059),
    [anon_sym_deriving] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(7494),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(7497),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7500),
  },
  [2444] = {
    [sym_integer] = STATE(6388),
    [sym__literal] = STATE(6388),
    [sym__unboxed_open] = STATE(2114),
    [sym_constructor] = STATE(6175),
    [sym_con_unit] = STATE(6388),
    [sym_con_list] = STATE(6388),
    [sym_con_tuple] = STATE(6388),
    [sym_qualified_type] = STATE(6387),
    [sym_tycon_arrow] = STATE(6387),
    [sym_type_literal] = STATE(2464),
    [sym__promoted_tycon] = STATE(6387),
    [sym_type_variable] = STATE(6387),
    [sym_annotated_type_variable] = STATE(6387),
    [sym_type_parens] = STATE(2464),
    [sym_type_list] = STATE(2464),
    [sym_type_tuple] = STATE(2464),
    [sym__type_promotable_literal] = STATE(2464),
    [sym__type_promoted_literal] = STATE(2464),
    [sym__type_literal] = STATE(2464),
    [sym_type_name] = STATE(2464),
    [sym_type_star] = STATE(2464),
    [sym_type_unboxed_tuple] = STATE(2464),
    [sym_type_unboxed_sum] = STATE(2464),
    [sym__atype] = STATE(2464),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15425),
    [sym_splice] = STATE(2464),
    [sym_quasiquote] = STATE(2464),
    [aux_sym_type_apply_repeat1] = STATE(2464),
    [sym__varid] = ACTIONS(7503),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(6750),
    [sym_char] = ACTIONS(6750),
    [sym_string] = ACTIONS(6750),
    [sym__integer_literal] = ACTIONS(6752),
    [sym__binary_literal] = ACTIONS(6754),
    [sym__octal_literal] = ACTIONS(6754),
    [sym__hex_literal] = ACTIONS(6754),
    [anon_sym_LPAREN_POUND] = ACTIONS(6756),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6756),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(7505),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(7507),
    [anon_sym_LBRACK] = ACTIONS(6764),
    [anon_sym_SQUOTE] = ACTIONS(7510),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(6768),
    [anon_sym_6] = ACTIONS(6768),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(6770),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6772),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6774),
  },
  [2445] = {
    [sym_integer] = STATE(8413),
    [sym__literal] = STATE(8413),
    [sym__unboxed_open] = STATE(2196),
    [sym_constructor] = STATE(8398),
    [sym_con_unit] = STATE(8413),
    [sym_con_list] = STATE(8413),
    [sym_con_tuple] = STATE(8413),
    [sym_qualified_type] = STATE(8404),
    [sym_tycon_arrow] = STATE(8404),
    [sym_type_literal] = STATE(2867),
    [sym__promoted_tycon] = STATE(8404),
    [sym_type_variable] = STATE(8404),
    [sym_annotated_type_variable] = STATE(8404),
    [sym_type_parens] = STATE(2867),
    [sym_type_list] = STATE(2867),
    [sym_type_tuple] = STATE(2867),
    [sym__type_promotable_literal] = STATE(2867),
    [sym__type_promoted_literal] = STATE(2867),
    [sym__type_literal] = STATE(2867),
    [sym_strict_type] = STATE(2867),
    [sym_lazy_type] = STATE(2867),
    [sym_type_name] = STATE(2867),
    [sym_type_star] = STATE(2867),
    [sym_type_unboxed_tuple] = STATE(2867),
    [sym_type_unboxed_sum] = STATE(2867),
    [sym__atype] = STATE(2867),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15075),
    [sym_record_fields] = STATE(15047),
    [sym_splice] = STATE(2867),
    [sym_quasiquote] = STATE(2867),
    [aux_sym_data_constructor_repeat1] = STATE(2867),
    [sym__varid] = ACTIONS(7513),
    [anon_sym_SEMI] = ACTIONS(6226),
    [sym_float] = ACTIONS(7516),
    [sym_char] = ACTIONS(7516),
    [sym_string] = ACTIONS(7516),
    [sym__integer_literal] = ACTIONS(7519),
    [sym__binary_literal] = ACTIONS(7522),
    [sym__octal_literal] = ACTIONS(7522),
    [sym__hex_literal] = ACTIONS(7522),
    [anon_sym_LPAREN_POUND] = ACTIONS(7525),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7525),
    [anon_sym_] = ACTIONS(6240),
    [anon_sym_EQ_GT] = ACTIONS(6240),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7528),
    [anon_sym_BQUOTE] = ACTIONS(6240),
    [sym__conid] = ACTIONS(7531),
    [anon_sym_LBRACK] = ACTIONS(7534),
    [anon_sym_SQUOTE] = ACTIONS(7537),
    [anon_sym_PIPE] = ACTIONS(6226),
    [anon_sym_STAR] = ACTIONS(7540),
    [anon_sym_6] = ACTIONS(7540),
    [anon_sym_LBRACE] = ACTIONS(7543),
    [anon_sym_RBRACE] = ACTIONS(6226),
    [anon_sym_deriving] = ACTIONS(6259),
    [anon_sym_7] = ACTIONS(7545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__dot] = ACTIONS(6264),
    [sym__splice_dollar] = ACTIONS(7548),
    [sym__consym] = ACTIONS(6240),
    [sym__tyconsym] = ACTIONS(6240),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7551),
    [sym__strict] = ACTIONS(7554),
    [sym__lazy] = ACTIONS(7556),
  },
  [2446] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym__layout_end] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2447] = {
    [sym_integer] = STATE(6347),
    [sym__literal] = STATE(6347),
    [sym__unboxed_open] = STATE(2174),
    [sym_constructor] = STATE(6222),
    [sym_con_unit] = STATE(6347),
    [sym_con_list] = STATE(6347),
    [sym_con_tuple] = STATE(6347),
    [sym_qualified_type] = STATE(6343),
    [sym_tycon_arrow] = STATE(6343),
    [sym_type_literal] = STATE(2472),
    [sym__promoted_tycon] = STATE(6343),
    [sym_type_variable] = STATE(6343),
    [sym_annotated_type_variable] = STATE(6343),
    [sym_type_parens] = STATE(2472),
    [sym_type_list] = STATE(2472),
    [sym_type_tuple] = STATE(2472),
    [sym__type_promotable_literal] = STATE(2472),
    [sym__type_promoted_literal] = STATE(2472),
    [sym__type_literal] = STATE(2472),
    [sym_type_name] = STATE(2472),
    [sym_type_star] = STATE(2472),
    [sym_type_unboxed_tuple] = STATE(2472),
    [sym_type_unboxed_sum] = STATE(2472),
    [sym__atype] = STATE(2472),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15364),
    [sym_splice] = STATE(2472),
    [sym_quasiquote] = STATE(2472),
    [aux_sym_type_apply_repeat1] = STATE(2472),
    [sym__varid] = ACTIONS(7558),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(5968),
    [sym_char] = ACTIONS(5968),
    [sym_string] = ACTIONS(5968),
    [sym__integer_literal] = ACTIONS(5970),
    [sym__binary_literal] = ACTIONS(5972),
    [sym__octal_literal] = ACTIONS(5972),
    [sym__hex_literal] = ACTIONS(5972),
    [anon_sym_LPAREN_POUND] = ACTIONS(5974),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5974),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(7560),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(7562),
    [anon_sym_LBRACK] = ACTIONS(5982),
    [anon_sym_SQUOTE] = ACTIONS(7565),
    [anon_sym_STAR] = ACTIONS(5986),
    [anon_sym_6] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(5988),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym__layout_end] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(5990),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5992),
  },
  [2448] = {
    [sym_integer] = STATE(6347),
    [sym__literal] = STATE(6347),
    [sym__unboxed_open] = STATE(2174),
    [sym_constructor] = STATE(6222),
    [sym_con_unit] = STATE(6347),
    [sym_con_list] = STATE(6347),
    [sym_con_tuple] = STATE(6347),
    [sym_qualified_type] = STATE(6343),
    [sym_tycon_arrow] = STATE(6343),
    [sym_type_literal] = STATE(2447),
    [sym__promoted_tycon] = STATE(6343),
    [sym_type_variable] = STATE(6343),
    [sym_annotated_type_variable] = STATE(6343),
    [sym_type_parens] = STATE(2447),
    [sym_type_list] = STATE(2447),
    [sym_type_tuple] = STATE(2447),
    [sym__type_promotable_literal] = STATE(2447),
    [sym__type_promoted_literal] = STATE(2447),
    [sym__type_literal] = STATE(2447),
    [sym_type_name] = STATE(2447),
    [sym_type_star] = STATE(2447),
    [sym_type_unboxed_tuple] = STATE(2447),
    [sym_type_unboxed_sum] = STATE(2447),
    [sym__atype] = STATE(2447),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15364),
    [sym_splice] = STATE(2447),
    [sym_quasiquote] = STATE(2447),
    [aux_sym_type_apply_repeat1] = STATE(2447),
    [sym__varid] = ACTIONS(7558),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(5968),
    [sym_char] = ACTIONS(5968),
    [sym_string] = ACTIONS(5968),
    [sym__integer_literal] = ACTIONS(5970),
    [sym__binary_literal] = ACTIONS(5972),
    [sym__octal_literal] = ACTIONS(5972),
    [sym__hex_literal] = ACTIONS(5972),
    [anon_sym_LPAREN_POUND] = ACTIONS(5974),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5974),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(7560),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(7568),
    [anon_sym_LBRACK] = ACTIONS(5982),
    [anon_sym_SQUOTE] = ACTIONS(7571),
    [anon_sym_STAR] = ACTIONS(5986),
    [anon_sym_6] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(5988),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym__layout_end] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(5990),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5992),
  },
  [2449] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_EQ] = ACTIONS(5160),
    [anon_sym_deriving] = ACTIONS(5160),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym__layout_end] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2450] = {
    [sym_integer] = STATE(6475),
    [sym__literal] = STATE(6475),
    [sym__unboxed_open] = STATE(2221),
    [sym_constructor] = STATE(6005),
    [sym_con_unit] = STATE(6475),
    [sym_con_list] = STATE(6475),
    [sym_con_tuple] = STATE(6475),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2450),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym_annotated_type_variable] = STATE(6545),
    [sym_type_parens] = STATE(2450),
    [sym_type_list] = STATE(2450),
    [sym_type_tuple] = STATE(2450),
    [sym__type_promotable_literal] = STATE(2450),
    [sym__type_promoted_literal] = STATE(2450),
    [sym__type_literal] = STATE(2450),
    [sym_type_name] = STATE(2450),
    [sym_type_star] = STATE(2450),
    [sym_type_unboxed_tuple] = STATE(2450),
    [sym_type_unboxed_sum] = STATE(2450),
    [sym__atype] = STATE(2450),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14761),
    [sym_splice] = STATE(2450),
    [sym_quasiquote] = STATE(2450),
    [aux_sym_type_apply_repeat1] = STATE(2450),
    [sym__varid] = ACTIONS(7574),
    [sym_float] = ACTIONS(7577),
    [sym_char] = ACTIONS(7577),
    [sym_string] = ACTIONS(7577),
    [sym__integer_literal] = ACTIONS(7580),
    [sym__binary_literal] = ACTIONS(7583),
    [sym__octal_literal] = ACTIONS(7583),
    [sym__hex_literal] = ACTIONS(7583),
    [anon_sym_LPAREN_POUND] = ACTIONS(7586),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7586),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(7589),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(7592),
    [anon_sym_LBRACK] = ACTIONS(7595),
    [anon_sym_RBRACK] = ACTIONS(5030),
    [anon_sym_SQUOTE] = ACTIONS(7598),
    [anon_sym_STAR] = ACTIONS(7601),
    [anon_sym_6] = ACTIONS(7601),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_DOT_DOT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(7604),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(7607),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5030),
    [sym_quasiquote_start] = ACTIONS(7610),
  },
  [2451] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [ts_builtin_sym_end] = ACTIONS(5129),
    [sym__varid] = ACTIONS(5899),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2452] = {
    [sym_integer] = STATE(6432),
    [sym__literal] = STATE(6432),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(5995),
    [sym_con_unit] = STATE(6432),
    [sym_con_list] = STATE(6432),
    [sym_con_tuple] = STATE(6432),
    [sym_qualified_type] = STATE(6532),
    [sym_tycon_arrow] = STATE(6532),
    [sym_type_literal] = STATE(2452),
    [sym__promoted_tycon] = STATE(6532),
    [sym_type_variable] = STATE(6532),
    [sym_annotated_type_variable] = STATE(6532),
    [sym_type_parens] = STATE(2452),
    [sym_type_list] = STATE(2452),
    [sym_type_tuple] = STATE(2452),
    [sym__type_promotable_literal] = STATE(2452),
    [sym__type_promoted_literal] = STATE(2452),
    [sym__type_literal] = STATE(2452),
    [sym_type_name] = STATE(2452),
    [sym_type_star] = STATE(2452),
    [sym_type_unboxed_tuple] = STATE(2452),
    [sym_type_unboxed_sum] = STATE(2452),
    [sym__atype] = STATE(2452),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14749),
    [sym_splice] = STATE(2452),
    [sym_quasiquote] = STATE(2452),
    [aux_sym_type_apply_repeat1] = STATE(2452),
    [ts_builtin_sym_end] = ACTIONS(5030),
    [sym__varid] = ACTIONS(7613),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(7616),
    [sym_char] = ACTIONS(7616),
    [sym_string] = ACTIONS(7616),
    [sym__integer_literal] = ACTIONS(7619),
    [sym__binary_literal] = ACTIONS(7622),
    [sym__octal_literal] = ACTIONS(7622),
    [sym__hex_literal] = ACTIONS(7622),
    [anon_sym_LPAREN_POUND] = ACTIONS(7625),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7625),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(7628),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(7631),
    [anon_sym_LBRACK] = ACTIONS(7634),
    [anon_sym_SQUOTE] = ACTIONS(7637),
    [anon_sym_STAR] = ACTIONS(7640),
    [anon_sym_6] = ACTIONS(7640),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(7643),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(7646),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7649),
  },
  [2453] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_RBRACK] = ACTIONS(5129),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5129),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2454] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym__layout_end] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2455] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2456] = {
    [sym_integer] = STATE(6509),
    [sym__literal] = STATE(6509),
    [sym__unboxed_open] = STATE(2133),
    [sym_constructor] = STATE(5968),
    [sym_con_unit] = STATE(6509),
    [sym_con_list] = STATE(6509),
    [sym_con_tuple] = STATE(6509),
    [sym_qualified_type] = STATE(6463),
    [sym_tycon_arrow] = STATE(6463),
    [sym_type_literal] = STATE(2475),
    [sym__promoted_tycon] = STATE(6463),
    [sym_type_variable] = STATE(6463),
    [sym_annotated_type_variable] = STATE(6463),
    [sym_type_parens] = STATE(2475),
    [sym_type_list] = STATE(2475),
    [sym_type_tuple] = STATE(2475),
    [sym__type_promotable_literal] = STATE(2475),
    [sym__type_promoted_literal] = STATE(2475),
    [sym__type_literal] = STATE(2475),
    [sym_type_name] = STATE(2475),
    [sym_type_star] = STATE(2475),
    [sym_type_unboxed_tuple] = STATE(2475),
    [sym_type_unboxed_sum] = STATE(2475),
    [sym__atype] = STATE(2475),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14649),
    [sym_splice] = STATE(2475),
    [sym_quasiquote] = STATE(2475),
    [aux_sym_type_apply_repeat1] = STATE(2475),
    [ts_builtin_sym_end] = ACTIONS(5078),
    [sym__varid] = ACTIONS(7397),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(7399),
    [sym_char] = ACTIONS(7399),
    [sym_string] = ACTIONS(7399),
    [sym__integer_literal] = ACTIONS(7401),
    [sym__binary_literal] = ACTIONS(7403),
    [sym__octal_literal] = ACTIONS(7403),
    [sym__hex_literal] = ACTIONS(7403),
    [anon_sym_LPAREN_POUND] = ACTIONS(7405),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7405),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7652),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(7654),
    [anon_sym_LBRACK] = ACTIONS(7413),
    [anon_sym_SQUOTE] = ACTIONS(7657),
    [anon_sym_STAR] = ACTIONS(7417),
    [anon_sym_6] = ACTIONS(7417),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_EQ] = ACTIONS(5100),
    [anon_sym_deriving] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(7419),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(7421),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7423),
  },
  [2457] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [ts_builtin_sym_end] = ACTIONS(5129),
    [sym__varid] = ACTIONS(5899),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2458] = {
    [sym_integer] = STATE(6388),
    [sym__literal] = STATE(6388),
    [sym__unboxed_open] = STATE(2114),
    [sym_constructor] = STATE(6175),
    [sym_con_unit] = STATE(6388),
    [sym_con_list] = STATE(6388),
    [sym_con_tuple] = STATE(6388),
    [sym_qualified_type] = STATE(6387),
    [sym_tycon_arrow] = STATE(6387),
    [sym_type_literal] = STATE(2444),
    [sym__promoted_tycon] = STATE(6387),
    [sym_type_variable] = STATE(6387),
    [sym_annotated_type_variable] = STATE(6387),
    [sym_type_parens] = STATE(2444),
    [sym_type_list] = STATE(2444),
    [sym_type_tuple] = STATE(2444),
    [sym__type_promotable_literal] = STATE(2444),
    [sym__type_promoted_literal] = STATE(2444),
    [sym__type_literal] = STATE(2444),
    [sym_type_name] = STATE(2444),
    [sym_type_star] = STATE(2444),
    [sym_type_unboxed_tuple] = STATE(2444),
    [sym_type_unboxed_sum] = STATE(2444),
    [sym__atype] = STATE(2444),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15425),
    [sym_splice] = STATE(2444),
    [sym_quasiquote] = STATE(2444),
    [aux_sym_type_apply_repeat1] = STATE(2444),
    [sym__varid] = ACTIONS(7503),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(6750),
    [sym_char] = ACTIONS(6750),
    [sym_string] = ACTIONS(6750),
    [sym__integer_literal] = ACTIONS(6752),
    [sym__binary_literal] = ACTIONS(6754),
    [sym__octal_literal] = ACTIONS(6754),
    [sym__hex_literal] = ACTIONS(6754),
    [anon_sym_LPAREN_POUND] = ACTIONS(6756),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6756),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(7505),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(7660),
    [anon_sym_LBRACK] = ACTIONS(6764),
    [anon_sym_SQUOTE] = ACTIONS(7663),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(6768),
    [anon_sym_6] = ACTIONS(6768),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_RBRACE] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(6770),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6772),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6774),
  },
  [2459] = {
    [sym_integer] = STATE(6357),
    [sym__literal] = STATE(6357),
    [sym__unboxed_open] = STATE(2219),
    [sym_constructor] = STATE(6142),
    [sym_con_unit] = STATE(6357),
    [sym_con_list] = STATE(6357),
    [sym_con_tuple] = STATE(6357),
    [sym_qualified_type] = STATE(6354),
    [sym_tycon_arrow] = STATE(6354),
    [sym_type_literal] = STATE(2462),
    [sym__promoted_tycon] = STATE(6354),
    [sym_type_variable] = STATE(6354),
    [sym_annotated_type_variable] = STATE(6354),
    [sym_type_parens] = STATE(2462),
    [sym_type_list] = STATE(2462),
    [sym_type_tuple] = STATE(2462),
    [sym__type_promotable_literal] = STATE(2462),
    [sym__type_promoted_literal] = STATE(2462),
    [sym__type_literal] = STATE(2462),
    [sym_type_name] = STATE(2462),
    [sym_type_star] = STATE(2462),
    [sym_type_unboxed_tuple] = STATE(2462),
    [sym_type_unboxed_sum] = STATE(2462),
    [sym__atype] = STATE(2462),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15108),
    [sym_splice] = STATE(2462),
    [sym_quasiquote] = STATE(2462),
    [aux_sym_type_apply_repeat1] = STATE(2462),
    [sym__varid] = ACTIONS(6901),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(6903),
    [sym_char] = ACTIONS(6903),
    [sym_string] = ACTIONS(6903),
    [sym__integer_literal] = ACTIONS(6905),
    [sym__binary_literal] = ACTIONS(6907),
    [sym__octal_literal] = ACTIONS(6907),
    [sym__hex_literal] = ACTIONS(6907),
    [anon_sym_LPAREN_POUND] = ACTIONS(6909),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6909),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(7666),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(7668),
    [anon_sym_LBRACK] = ACTIONS(6917),
    [anon_sym_SQUOTE] = ACTIONS(7671),
    [anon_sym_STAR] = ACTIONS(6921),
    [anon_sym_6] = ACTIONS(6921),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_in] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(6923),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6925),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6927),
  },
  [2460] = {
    [sym_integer] = STATE(6357),
    [sym__literal] = STATE(6357),
    [sym__unboxed_open] = STATE(2219),
    [sym_constructor] = STATE(6142),
    [sym_con_unit] = STATE(6357),
    [sym_con_list] = STATE(6357),
    [sym_con_tuple] = STATE(6357),
    [sym_qualified_type] = STATE(6354),
    [sym_tycon_arrow] = STATE(6354),
    [sym_type_literal] = STATE(2459),
    [sym__promoted_tycon] = STATE(6354),
    [sym_type_variable] = STATE(6354),
    [sym_annotated_type_variable] = STATE(6354),
    [sym_type_parens] = STATE(2459),
    [sym_type_list] = STATE(2459),
    [sym_type_tuple] = STATE(2459),
    [sym__type_promotable_literal] = STATE(2459),
    [sym__type_promoted_literal] = STATE(2459),
    [sym__type_literal] = STATE(2459),
    [sym_type_name] = STATE(2459),
    [sym_type_star] = STATE(2459),
    [sym_type_unboxed_tuple] = STATE(2459),
    [sym_type_unboxed_sum] = STATE(2459),
    [sym__atype] = STATE(2459),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15108),
    [sym_splice] = STATE(2459),
    [sym_quasiquote] = STATE(2459),
    [aux_sym_type_apply_repeat1] = STATE(2459),
    [sym__varid] = ACTIONS(6901),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(6903),
    [sym_char] = ACTIONS(6903),
    [sym_string] = ACTIONS(6903),
    [sym__integer_literal] = ACTIONS(6905),
    [sym__binary_literal] = ACTIONS(6907),
    [sym__octal_literal] = ACTIONS(6907),
    [sym__hex_literal] = ACTIONS(6907),
    [anon_sym_LPAREN_POUND] = ACTIONS(6909),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6909),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(7666),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(7674),
    [anon_sym_LBRACK] = ACTIONS(6917),
    [anon_sym_SQUOTE] = ACTIONS(7677),
    [anon_sym_STAR] = ACTIONS(6921),
    [anon_sym_6] = ACTIONS(6921),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_in] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(6923),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6925),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6927),
  },
  [2461] = {
    [sym_integer] = STATE(6425),
    [sym__literal] = STATE(6425),
    [sym__unboxed_open] = STATE(2108),
    [sym_constructor] = STATE(5969),
    [sym_con_unit] = STATE(6425),
    [sym_con_list] = STATE(6425),
    [sym_con_tuple] = STATE(6425),
    [sym_qualified_type] = STATE(6424),
    [sym_tycon_arrow] = STATE(6424),
    [sym_type_literal] = STATE(2470),
    [sym__promoted_tycon] = STATE(6424),
    [sym_type_variable] = STATE(6424),
    [sym_annotated_type_variable] = STATE(6424),
    [sym_type_parens] = STATE(2470),
    [sym_type_list] = STATE(2470),
    [sym_type_tuple] = STATE(2470),
    [sym__type_promotable_literal] = STATE(2470),
    [sym__type_promoted_literal] = STATE(2470),
    [sym__type_literal] = STATE(2470),
    [sym_type_name] = STATE(2470),
    [sym_type_star] = STATE(2470),
    [sym_type_unboxed_tuple] = STATE(2470),
    [sym_type_unboxed_sum] = STATE(2470),
    [sym__atype] = STATE(2470),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15009),
    [sym_splice] = STATE(2470),
    [sym_quasiquote] = STATE(2470),
    [aux_sym_type_apply_repeat1] = STATE(2470),
    [sym__varid] = ACTIONS(7229),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(7231),
    [sym_char] = ACTIONS(7231),
    [sym_string] = ACTIONS(7231),
    [sym__integer_literal] = ACTIONS(7233),
    [sym__binary_literal] = ACTIONS(7235),
    [sym__octal_literal] = ACTIONS(7235),
    [sym__hex_literal] = ACTIONS(7235),
    [anon_sym_LPAREN_POUND] = ACTIONS(7237),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7237),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7680),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(7682),
    [anon_sym_LBRACK] = ACTIONS(7245),
    [anon_sym_SQUOTE] = ACTIONS(7685),
    [anon_sym_STAR] = ACTIONS(7249),
    [anon_sym_6] = ACTIONS(7249),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_EQ] = ACTIONS(5100),
    [anon_sym_deriving] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(7251),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym__layout_end] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(7253),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7255),
  },
  [2462] = {
    [sym_integer] = STATE(6357),
    [sym__literal] = STATE(6357),
    [sym__unboxed_open] = STATE(2219),
    [sym_constructor] = STATE(6142),
    [sym_con_unit] = STATE(6357),
    [sym_con_list] = STATE(6357),
    [sym_con_tuple] = STATE(6357),
    [sym_qualified_type] = STATE(6354),
    [sym_tycon_arrow] = STATE(6354),
    [sym_type_literal] = STATE(2462),
    [sym__promoted_tycon] = STATE(6354),
    [sym_type_variable] = STATE(6354),
    [sym_annotated_type_variable] = STATE(6354),
    [sym_type_parens] = STATE(2462),
    [sym_type_list] = STATE(2462),
    [sym_type_tuple] = STATE(2462),
    [sym__type_promotable_literal] = STATE(2462),
    [sym__type_promoted_literal] = STATE(2462),
    [sym__type_literal] = STATE(2462),
    [sym_type_name] = STATE(2462),
    [sym_type_star] = STATE(2462),
    [sym_type_unboxed_tuple] = STATE(2462),
    [sym_type_unboxed_sum] = STATE(2462),
    [sym__atype] = STATE(2462),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15108),
    [sym_splice] = STATE(2462),
    [sym_quasiquote] = STATE(2462),
    [aux_sym_type_apply_repeat1] = STATE(2462),
    [sym__varid] = ACTIONS(7688),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(7691),
    [sym_char] = ACTIONS(7691),
    [sym_string] = ACTIONS(7691),
    [sym__integer_literal] = ACTIONS(7694),
    [sym__binary_literal] = ACTIONS(7697),
    [sym__octal_literal] = ACTIONS(7697),
    [sym__hex_literal] = ACTIONS(7697),
    [anon_sym_LPAREN_POUND] = ACTIONS(7700),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7700),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(7703),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(7706),
    [anon_sym_LBRACK] = ACTIONS(7709),
    [anon_sym_SQUOTE] = ACTIONS(7712),
    [anon_sym_STAR] = ACTIONS(7715),
    [anon_sym_6] = ACTIONS(7715),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_in] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(7718),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(7721),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7724),
  },
  [2463] = {
    [sym_integer] = STATE(6389),
    [sym__literal] = STATE(6389),
    [sym__unboxed_open] = STATE(2127),
    [sym_constructor] = STATE(6056),
    [sym_con_unit] = STATE(6389),
    [sym_con_list] = STATE(6389),
    [sym_con_tuple] = STATE(6389),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2468),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym_annotated_type_variable] = STATE(6375),
    [sym_type_parens] = STATE(2468),
    [sym_type_list] = STATE(2468),
    [sym_type_tuple] = STATE(2468),
    [sym__type_promotable_literal] = STATE(2468),
    [sym__type_promoted_literal] = STATE(2468),
    [sym__type_literal] = STATE(2468),
    [sym_type_name] = STATE(2468),
    [sym_type_star] = STATE(2468),
    [sym_type_unboxed_tuple] = STATE(2468),
    [sym_type_unboxed_sum] = STATE(2468),
    [sym__atype] = STATE(2468),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15001),
    [sym_splice] = STATE(2468),
    [sym_quasiquote] = STATE(2468),
    [aux_sym_type_apply_repeat1] = STATE(2468),
    [sym__varid] = ACTIONS(7727),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(6589),
    [sym_char] = ACTIONS(6589),
    [sym_string] = ACTIONS(6589),
    [sym__integer_literal] = ACTIONS(6591),
    [sym__binary_literal] = ACTIONS(6593),
    [sym__octal_literal] = ACTIONS(6593),
    [sym__hex_literal] = ACTIONS(6593),
    [anon_sym_LPAREN_POUND] = ACTIONS(6595),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6595),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(7729),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(7731),
    [anon_sym_LBRACK] = ACTIONS(6603),
    [anon_sym_SQUOTE] = ACTIONS(7734),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(6607),
    [anon_sym_6] = ACTIONS(6607),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(6609),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym__layout_end] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6611),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6613),
  },
  [2464] = {
    [sym_integer] = STATE(6388),
    [sym__literal] = STATE(6388),
    [sym__unboxed_open] = STATE(2114),
    [sym_constructor] = STATE(6175),
    [sym_con_unit] = STATE(6388),
    [sym_con_list] = STATE(6388),
    [sym_con_tuple] = STATE(6388),
    [sym_qualified_type] = STATE(6387),
    [sym_tycon_arrow] = STATE(6387),
    [sym_type_literal] = STATE(2464),
    [sym__promoted_tycon] = STATE(6387),
    [sym_type_variable] = STATE(6387),
    [sym_annotated_type_variable] = STATE(6387),
    [sym_type_parens] = STATE(2464),
    [sym_type_list] = STATE(2464),
    [sym_type_tuple] = STATE(2464),
    [sym__type_promotable_literal] = STATE(2464),
    [sym__type_promoted_literal] = STATE(2464),
    [sym__type_literal] = STATE(2464),
    [sym_type_name] = STATE(2464),
    [sym_type_star] = STATE(2464),
    [sym_type_unboxed_tuple] = STATE(2464),
    [sym_type_unboxed_sum] = STATE(2464),
    [sym__atype] = STATE(2464),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15425),
    [sym_splice] = STATE(2464),
    [sym_quasiquote] = STATE(2464),
    [aux_sym_type_apply_repeat1] = STATE(2464),
    [sym__varid] = ACTIONS(7737),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(7740),
    [sym_char] = ACTIONS(7740),
    [sym_string] = ACTIONS(7740),
    [sym__integer_literal] = ACTIONS(7743),
    [sym__binary_literal] = ACTIONS(7746),
    [sym__octal_literal] = ACTIONS(7746),
    [sym__hex_literal] = ACTIONS(7746),
    [anon_sym_LPAREN_POUND] = ACTIONS(7749),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7749),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(7752),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(7755),
    [anon_sym_LBRACK] = ACTIONS(7758),
    [anon_sym_SQUOTE] = ACTIONS(7761),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(7764),
    [anon_sym_6] = ACTIONS(7764),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_RBRACE] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(7767),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(7770),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7773),
  },
  [2465] = {
    [sym_integer] = STATE(6389),
    [sym__literal] = STATE(6389),
    [sym__unboxed_open] = STATE(2127),
    [sym_constructor] = STATE(6056),
    [sym_con_unit] = STATE(6389),
    [sym_con_list] = STATE(6389),
    [sym_con_tuple] = STATE(6389),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2463),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym_annotated_type_variable] = STATE(6375),
    [sym_type_parens] = STATE(2463),
    [sym_type_list] = STATE(2463),
    [sym_type_tuple] = STATE(2463),
    [sym__type_promotable_literal] = STATE(2463),
    [sym__type_promoted_literal] = STATE(2463),
    [sym__type_literal] = STATE(2463),
    [sym_type_name] = STATE(2463),
    [sym_type_star] = STATE(2463),
    [sym_type_unboxed_tuple] = STATE(2463),
    [sym_type_unboxed_sum] = STATE(2463),
    [sym__atype] = STATE(2463),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15001),
    [sym_splice] = STATE(2463),
    [sym_quasiquote] = STATE(2463),
    [aux_sym_type_apply_repeat1] = STATE(2463),
    [sym__varid] = ACTIONS(7727),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(6589),
    [sym_char] = ACTIONS(6589),
    [sym_string] = ACTIONS(6589),
    [sym__integer_literal] = ACTIONS(6591),
    [sym__binary_literal] = ACTIONS(6593),
    [sym__octal_literal] = ACTIONS(6593),
    [sym__hex_literal] = ACTIONS(6593),
    [anon_sym_LPAREN_POUND] = ACTIONS(6595),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6595),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(7729),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(7776),
    [anon_sym_LBRACK] = ACTIONS(6603),
    [anon_sym_SQUOTE] = ACTIONS(7779),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(6607),
    [anon_sym_6] = ACTIONS(6607),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(6609),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym__layout_end] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6611),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6613),
  },
  [2466] = {
    [sym_integer] = STATE(6402),
    [sym__literal] = STATE(6402),
    [sym__unboxed_open] = STATE(2110),
    [sym_constructor] = STATE(6210),
    [sym_con_unit] = STATE(6402),
    [sym_con_list] = STATE(6402),
    [sym_con_tuple] = STATE(6402),
    [sym_qualified_type] = STATE(6415),
    [sym_tycon_arrow] = STATE(6415),
    [sym_type_literal] = STATE(2466),
    [sym__promoted_tycon] = STATE(6415),
    [sym_type_variable] = STATE(6415),
    [sym_annotated_type_variable] = STATE(6415),
    [sym_type_parens] = STATE(2466),
    [sym_type_list] = STATE(2466),
    [sym_type_tuple] = STATE(2466),
    [sym__type_promotable_literal] = STATE(2466),
    [sym__type_promoted_literal] = STATE(2466),
    [sym__type_literal] = STATE(2466),
    [sym_type_name] = STATE(2466),
    [sym_type_star] = STATE(2466),
    [sym_type_unboxed_tuple] = STATE(2466),
    [sym_type_unboxed_sum] = STATE(2466),
    [sym__atype] = STATE(2466),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15251),
    [sym_splice] = STATE(2466),
    [sym_quasiquote] = STATE(2466),
    [aux_sym_type_apply_repeat1] = STATE(2466),
    [ts_builtin_sym_end] = ACTIONS(5030),
    [sym__varid] = ACTIONS(7782),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(7785),
    [sym_char] = ACTIONS(7785),
    [sym_string] = ACTIONS(7785),
    [sym__integer_literal] = ACTIONS(7788),
    [sym__binary_literal] = ACTIONS(7791),
    [sym__octal_literal] = ACTIONS(7791),
    [sym__hex_literal] = ACTIONS(7791),
    [anon_sym_LPAREN_POUND] = ACTIONS(7794),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7794),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(7797),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(7800),
    [anon_sym_LBRACK] = ACTIONS(7803),
    [anon_sym_SQUOTE] = ACTIONS(7806),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(7809),
    [anon_sym_6] = ACTIONS(7809),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(7812),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(7815),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7818),
  },
  [2467] = {
    [sym_integer] = STATE(6402),
    [sym__literal] = STATE(6402),
    [sym__unboxed_open] = STATE(2110),
    [sym_constructor] = STATE(6210),
    [sym_con_unit] = STATE(6402),
    [sym_con_list] = STATE(6402),
    [sym_con_tuple] = STATE(6402),
    [sym_qualified_type] = STATE(6415),
    [sym_tycon_arrow] = STATE(6415),
    [sym_type_literal] = STATE(2471),
    [sym__promoted_tycon] = STATE(6415),
    [sym_type_variable] = STATE(6415),
    [sym_annotated_type_variable] = STATE(6415),
    [sym_type_parens] = STATE(2471),
    [sym_type_list] = STATE(2471),
    [sym_type_tuple] = STATE(2471),
    [sym__type_promotable_literal] = STATE(2471),
    [sym__type_promoted_literal] = STATE(2471),
    [sym__type_literal] = STATE(2471),
    [sym_type_name] = STATE(2471),
    [sym_type_star] = STATE(2471),
    [sym_type_unboxed_tuple] = STATE(2471),
    [sym_type_unboxed_sum] = STATE(2471),
    [sym__atype] = STATE(2471),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15251),
    [sym_splice] = STATE(2471),
    [sym_quasiquote] = STATE(2471),
    [aux_sym_type_apply_repeat1] = STATE(2471),
    [ts_builtin_sym_end] = ACTIONS(5078),
    [sym__varid] = ACTIONS(7821),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(7128),
    [sym_char] = ACTIONS(7128),
    [sym_string] = ACTIONS(7128),
    [sym__integer_literal] = ACTIONS(7130),
    [sym__binary_literal] = ACTIONS(7132),
    [sym__octal_literal] = ACTIONS(7132),
    [sym__hex_literal] = ACTIONS(7132),
    [anon_sym_LPAREN_POUND] = ACTIONS(7134),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7134),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(7823),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(7825),
    [anon_sym_LBRACK] = ACTIONS(7142),
    [anon_sym_SQUOTE] = ACTIONS(7828),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(7146),
    [anon_sym_6] = ACTIONS(7146),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(7148),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(7150),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7152),
  },
  [2468] = {
    [sym_integer] = STATE(6389),
    [sym__literal] = STATE(6389),
    [sym__unboxed_open] = STATE(2127),
    [sym_constructor] = STATE(6056),
    [sym_con_unit] = STATE(6389),
    [sym_con_list] = STATE(6389),
    [sym_con_tuple] = STATE(6389),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2468),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym_annotated_type_variable] = STATE(6375),
    [sym_type_parens] = STATE(2468),
    [sym_type_list] = STATE(2468),
    [sym_type_tuple] = STATE(2468),
    [sym__type_promotable_literal] = STATE(2468),
    [sym__type_promoted_literal] = STATE(2468),
    [sym__type_literal] = STATE(2468),
    [sym_type_name] = STATE(2468),
    [sym_type_star] = STATE(2468),
    [sym_type_unboxed_tuple] = STATE(2468),
    [sym_type_unboxed_sum] = STATE(2468),
    [sym__atype] = STATE(2468),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15001),
    [sym_splice] = STATE(2468),
    [sym_quasiquote] = STATE(2468),
    [aux_sym_type_apply_repeat1] = STATE(2468),
    [sym__varid] = ACTIONS(7831),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(7834),
    [sym_char] = ACTIONS(7834),
    [sym_string] = ACTIONS(7834),
    [sym__integer_literal] = ACTIONS(7837),
    [sym__binary_literal] = ACTIONS(7840),
    [sym__octal_literal] = ACTIONS(7840),
    [sym__hex_literal] = ACTIONS(7840),
    [anon_sym_LPAREN_POUND] = ACTIONS(7843),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7843),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(7846),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(7849),
    [anon_sym_LBRACK] = ACTIONS(7852),
    [anon_sym_SQUOTE] = ACTIONS(7855),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(7858),
    [anon_sym_6] = ACTIONS(7858),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(7861),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym__layout_end] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(7864),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7867),
  },
  [2469] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_in] = ACTIONS(5160),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2470] = {
    [sym_integer] = STATE(6425),
    [sym__literal] = STATE(6425),
    [sym__unboxed_open] = STATE(2108),
    [sym_constructor] = STATE(5969),
    [sym_con_unit] = STATE(6425),
    [sym_con_list] = STATE(6425),
    [sym_con_tuple] = STATE(6425),
    [sym_qualified_type] = STATE(6424),
    [sym_tycon_arrow] = STATE(6424),
    [sym_type_literal] = STATE(2479),
    [sym__promoted_tycon] = STATE(6424),
    [sym_type_variable] = STATE(6424),
    [sym_annotated_type_variable] = STATE(6424),
    [sym_type_parens] = STATE(2479),
    [sym_type_list] = STATE(2479),
    [sym_type_tuple] = STATE(2479),
    [sym__type_promotable_literal] = STATE(2479),
    [sym__type_promoted_literal] = STATE(2479),
    [sym__type_literal] = STATE(2479),
    [sym_type_name] = STATE(2479),
    [sym_type_star] = STATE(2479),
    [sym_type_unboxed_tuple] = STATE(2479),
    [sym_type_unboxed_sum] = STATE(2479),
    [sym__atype] = STATE(2479),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15009),
    [sym_splice] = STATE(2479),
    [sym_quasiquote] = STATE(2479),
    [aux_sym_type_apply_repeat1] = STATE(2479),
    [sym__varid] = ACTIONS(7229),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(7231),
    [sym_char] = ACTIONS(7231),
    [sym_string] = ACTIONS(7231),
    [sym__integer_literal] = ACTIONS(7233),
    [sym__binary_literal] = ACTIONS(7235),
    [sym__octal_literal] = ACTIONS(7235),
    [sym__hex_literal] = ACTIONS(7235),
    [anon_sym_LPAREN_POUND] = ACTIONS(7237),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7237),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7680),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(7870),
    [anon_sym_LBRACK] = ACTIONS(7245),
    [anon_sym_SQUOTE] = ACTIONS(7873),
    [anon_sym_STAR] = ACTIONS(7249),
    [anon_sym_6] = ACTIONS(7249),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_EQ] = ACTIONS(5185),
    [anon_sym_deriving] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(7251),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym__layout_end] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(7253),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7255),
  },
  [2471] = {
    [sym_integer] = STATE(6402),
    [sym__literal] = STATE(6402),
    [sym__unboxed_open] = STATE(2110),
    [sym_constructor] = STATE(6210),
    [sym_con_unit] = STATE(6402),
    [sym_con_list] = STATE(6402),
    [sym_con_tuple] = STATE(6402),
    [sym_qualified_type] = STATE(6415),
    [sym_tycon_arrow] = STATE(6415),
    [sym_type_literal] = STATE(2466),
    [sym__promoted_tycon] = STATE(6415),
    [sym_type_variable] = STATE(6415),
    [sym_annotated_type_variable] = STATE(6415),
    [sym_type_parens] = STATE(2466),
    [sym_type_list] = STATE(2466),
    [sym_type_tuple] = STATE(2466),
    [sym__type_promotable_literal] = STATE(2466),
    [sym__type_promoted_literal] = STATE(2466),
    [sym__type_literal] = STATE(2466),
    [sym_type_name] = STATE(2466),
    [sym_type_star] = STATE(2466),
    [sym_type_unboxed_tuple] = STATE(2466),
    [sym_type_unboxed_sum] = STATE(2466),
    [sym__atype] = STATE(2466),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15251),
    [sym_splice] = STATE(2466),
    [sym_quasiquote] = STATE(2466),
    [aux_sym_type_apply_repeat1] = STATE(2466),
    [ts_builtin_sym_end] = ACTIONS(5177),
    [sym__varid] = ACTIONS(7821),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(7128),
    [sym_char] = ACTIONS(7128),
    [sym_string] = ACTIONS(7128),
    [sym__integer_literal] = ACTIONS(7130),
    [sym__binary_literal] = ACTIONS(7132),
    [sym__octal_literal] = ACTIONS(7132),
    [sym__hex_literal] = ACTIONS(7132),
    [anon_sym_LPAREN_POUND] = ACTIONS(7134),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7134),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(7823),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(7876),
    [anon_sym_LBRACK] = ACTIONS(7142),
    [anon_sym_SQUOTE] = ACTIONS(7879),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(7146),
    [anon_sym_6] = ACTIONS(7146),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(7148),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(7150),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7152),
  },
  [2472] = {
    [sym_integer] = STATE(6347),
    [sym__literal] = STATE(6347),
    [sym__unboxed_open] = STATE(2174),
    [sym_constructor] = STATE(6222),
    [sym_con_unit] = STATE(6347),
    [sym_con_list] = STATE(6347),
    [sym_con_tuple] = STATE(6347),
    [sym_qualified_type] = STATE(6343),
    [sym_tycon_arrow] = STATE(6343),
    [sym_type_literal] = STATE(2472),
    [sym__promoted_tycon] = STATE(6343),
    [sym_type_variable] = STATE(6343),
    [sym_annotated_type_variable] = STATE(6343),
    [sym_type_parens] = STATE(2472),
    [sym_type_list] = STATE(2472),
    [sym_type_tuple] = STATE(2472),
    [sym__type_promotable_literal] = STATE(2472),
    [sym__type_promoted_literal] = STATE(2472),
    [sym__type_literal] = STATE(2472),
    [sym_type_name] = STATE(2472),
    [sym_type_star] = STATE(2472),
    [sym_type_unboxed_tuple] = STATE(2472),
    [sym_type_unboxed_sum] = STATE(2472),
    [sym__atype] = STATE(2472),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15364),
    [sym_splice] = STATE(2472),
    [sym_quasiquote] = STATE(2472),
    [aux_sym_type_apply_repeat1] = STATE(2472),
    [sym__varid] = ACTIONS(7882),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(7885),
    [sym_char] = ACTIONS(7885),
    [sym_string] = ACTIONS(7885),
    [sym__integer_literal] = ACTIONS(7888),
    [sym__binary_literal] = ACTIONS(7891),
    [sym__octal_literal] = ACTIONS(7891),
    [sym__hex_literal] = ACTIONS(7891),
    [anon_sym_LPAREN_POUND] = ACTIONS(7894),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7894),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(7897),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(7900),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_SQUOTE] = ACTIONS(7906),
    [anon_sym_STAR] = ACTIONS(7909),
    [anon_sym_6] = ACTIONS(7909),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(7912),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym__layout_end] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(7915),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7918),
  },
  [2473] = {
    [sym_integer] = STATE(6475),
    [sym__literal] = STATE(6475),
    [sym__unboxed_open] = STATE(2221),
    [sym_constructor] = STATE(6005),
    [sym_con_unit] = STATE(6475),
    [sym_con_list] = STATE(6475),
    [sym_con_tuple] = STATE(6475),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2450),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym_annotated_type_variable] = STATE(6545),
    [sym_type_parens] = STATE(2450),
    [sym_type_list] = STATE(2450),
    [sym_type_tuple] = STATE(2450),
    [sym__type_promotable_literal] = STATE(2450),
    [sym__type_promoted_literal] = STATE(2450),
    [sym__type_literal] = STATE(2450),
    [sym_type_name] = STATE(2450),
    [sym_type_star] = STATE(2450),
    [sym_type_unboxed_tuple] = STATE(2450),
    [sym_type_unboxed_sum] = STATE(2450),
    [sym__atype] = STATE(2450),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14761),
    [sym_splice] = STATE(2450),
    [sym_quasiquote] = STATE(2450),
    [aux_sym_type_apply_repeat1] = STATE(2450),
    [sym__varid] = ACTIONS(7921),
    [sym_float] = ACTIONS(6645),
    [sym_char] = ACTIONS(6645),
    [sym_string] = ACTIONS(6645),
    [sym__integer_literal] = ACTIONS(6647),
    [sym__binary_literal] = ACTIONS(6649),
    [sym__octal_literal] = ACTIONS(6649),
    [sym__hex_literal] = ACTIONS(6649),
    [anon_sym_LPAREN_POUND] = ACTIONS(6651),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6651),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(7923),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(7925),
    [anon_sym_LBRACK] = ACTIONS(6659),
    [anon_sym_RBRACK] = ACTIONS(5177),
    [anon_sym_SQUOTE] = ACTIONS(7928),
    [anon_sym_STAR] = ACTIONS(6663),
    [anon_sym_6] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_DOT_DOT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(6665),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6667),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5177),
    [sym_quasiquote_start] = ACTIONS(6669),
  },
  [2474] = {
    [sym_integer] = STATE(6475),
    [sym__literal] = STATE(6475),
    [sym__unboxed_open] = STATE(2221),
    [sym_constructor] = STATE(6005),
    [sym_con_unit] = STATE(6475),
    [sym_con_list] = STATE(6475),
    [sym_con_tuple] = STATE(6475),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2473),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym_annotated_type_variable] = STATE(6545),
    [sym_type_parens] = STATE(2473),
    [sym_type_list] = STATE(2473),
    [sym_type_tuple] = STATE(2473),
    [sym__type_promotable_literal] = STATE(2473),
    [sym__type_promoted_literal] = STATE(2473),
    [sym__type_literal] = STATE(2473),
    [sym_type_name] = STATE(2473),
    [sym_type_star] = STATE(2473),
    [sym_type_unboxed_tuple] = STATE(2473),
    [sym_type_unboxed_sum] = STATE(2473),
    [sym__atype] = STATE(2473),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14761),
    [sym_splice] = STATE(2473),
    [sym_quasiquote] = STATE(2473),
    [aux_sym_type_apply_repeat1] = STATE(2473),
    [sym__varid] = ACTIONS(7921),
    [sym_float] = ACTIONS(6645),
    [sym_char] = ACTIONS(6645),
    [sym_string] = ACTIONS(6645),
    [sym__integer_literal] = ACTIONS(6647),
    [sym__binary_literal] = ACTIONS(6649),
    [sym__octal_literal] = ACTIONS(6649),
    [sym__hex_literal] = ACTIONS(6649),
    [anon_sym_LPAREN_POUND] = ACTIONS(6651),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6651),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(7923),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(7931),
    [anon_sym_LBRACK] = ACTIONS(6659),
    [anon_sym_RBRACK] = ACTIONS(5078),
    [anon_sym_SQUOTE] = ACTIONS(7934),
    [anon_sym_STAR] = ACTIONS(6663),
    [anon_sym_6] = ACTIONS(6663),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(6665),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6667),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5078),
    [sym_quasiquote_start] = ACTIONS(6669),
  },
  [2475] = {
    [sym_integer] = STATE(6509),
    [sym__literal] = STATE(6509),
    [sym__unboxed_open] = STATE(2133),
    [sym_constructor] = STATE(5968),
    [sym_con_unit] = STATE(6509),
    [sym_con_list] = STATE(6509),
    [sym_con_tuple] = STATE(6509),
    [sym_qualified_type] = STATE(6463),
    [sym_tycon_arrow] = STATE(6463),
    [sym_type_literal] = STATE(2443),
    [sym__promoted_tycon] = STATE(6463),
    [sym_type_variable] = STATE(6463),
    [sym_annotated_type_variable] = STATE(6463),
    [sym_type_parens] = STATE(2443),
    [sym_type_list] = STATE(2443),
    [sym_type_tuple] = STATE(2443),
    [sym__type_promotable_literal] = STATE(2443),
    [sym__type_promoted_literal] = STATE(2443),
    [sym__type_literal] = STATE(2443),
    [sym_type_name] = STATE(2443),
    [sym_type_star] = STATE(2443),
    [sym_type_unboxed_tuple] = STATE(2443),
    [sym_type_unboxed_sum] = STATE(2443),
    [sym__atype] = STATE(2443),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14649),
    [sym_splice] = STATE(2443),
    [sym_quasiquote] = STATE(2443),
    [aux_sym_type_apply_repeat1] = STATE(2443),
    [ts_builtin_sym_end] = ACTIONS(5177),
    [sym__varid] = ACTIONS(7397),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(7399),
    [sym_char] = ACTIONS(7399),
    [sym_string] = ACTIONS(7399),
    [sym__integer_literal] = ACTIONS(7401),
    [sym__binary_literal] = ACTIONS(7403),
    [sym__octal_literal] = ACTIONS(7403),
    [sym__hex_literal] = ACTIONS(7403),
    [anon_sym_LPAREN_POUND] = ACTIONS(7405),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7405),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7652),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(7937),
    [anon_sym_LBRACK] = ACTIONS(7413),
    [anon_sym_SQUOTE] = ACTIONS(7940),
    [anon_sym_STAR] = ACTIONS(7417),
    [anon_sym_6] = ACTIONS(7417),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_EQ] = ACTIONS(5185),
    [anon_sym_deriving] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(7419),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(7421),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7423),
  },
  [2476] = {
    [sym_integer] = STATE(6432),
    [sym__literal] = STATE(6432),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(5995),
    [sym_con_unit] = STATE(6432),
    [sym_con_list] = STATE(6432),
    [sym_con_tuple] = STATE(6432),
    [sym_qualified_type] = STATE(6532),
    [sym_tycon_arrow] = STATE(6532),
    [sym_type_literal] = STATE(2452),
    [sym__promoted_tycon] = STATE(6532),
    [sym_type_variable] = STATE(6532),
    [sym_annotated_type_variable] = STATE(6532),
    [sym_type_parens] = STATE(2452),
    [sym_type_list] = STATE(2452),
    [sym_type_tuple] = STATE(2452),
    [sym__type_promotable_literal] = STATE(2452),
    [sym__type_promoted_literal] = STATE(2452),
    [sym__type_literal] = STATE(2452),
    [sym_type_name] = STATE(2452),
    [sym_type_star] = STATE(2452),
    [sym_type_unboxed_tuple] = STATE(2452),
    [sym_type_unboxed_sum] = STATE(2452),
    [sym__atype] = STATE(2452),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14749),
    [sym_splice] = STATE(2452),
    [sym_quasiquote] = STATE(2452),
    [aux_sym_type_apply_repeat1] = STATE(2452),
    [ts_builtin_sym_end] = ACTIONS(5177),
    [sym__varid] = ACTIONS(7943),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(7287),
    [sym_char] = ACTIONS(7287),
    [sym_string] = ACTIONS(7287),
    [sym__integer_literal] = ACTIONS(7289),
    [sym__binary_literal] = ACTIONS(7291),
    [sym__octal_literal] = ACTIONS(7291),
    [sym__hex_literal] = ACTIONS(7291),
    [anon_sym_LPAREN_POUND] = ACTIONS(7293),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7293),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(7945),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(7947),
    [anon_sym_LBRACK] = ACTIONS(7301),
    [anon_sym_SQUOTE] = ACTIONS(7950),
    [anon_sym_STAR] = ACTIONS(7305),
    [anon_sym_6] = ACTIONS(7305),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(7307),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(7309),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7311),
  },
  [2477] = {
    [sym_integer] = STATE(6432),
    [sym__literal] = STATE(6432),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(5995),
    [sym_con_unit] = STATE(6432),
    [sym_con_list] = STATE(6432),
    [sym_con_tuple] = STATE(6432),
    [sym_qualified_type] = STATE(6532),
    [sym_tycon_arrow] = STATE(6532),
    [sym_type_literal] = STATE(2476),
    [sym__promoted_tycon] = STATE(6532),
    [sym_type_variable] = STATE(6532),
    [sym_annotated_type_variable] = STATE(6532),
    [sym_type_parens] = STATE(2476),
    [sym_type_list] = STATE(2476),
    [sym_type_tuple] = STATE(2476),
    [sym__type_promotable_literal] = STATE(2476),
    [sym__type_promoted_literal] = STATE(2476),
    [sym__type_literal] = STATE(2476),
    [sym_type_name] = STATE(2476),
    [sym_type_star] = STATE(2476),
    [sym_type_unboxed_tuple] = STATE(2476),
    [sym_type_unboxed_sum] = STATE(2476),
    [sym__atype] = STATE(2476),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14749),
    [sym_splice] = STATE(2476),
    [sym_quasiquote] = STATE(2476),
    [aux_sym_type_apply_repeat1] = STATE(2476),
    [ts_builtin_sym_end] = ACTIONS(5078),
    [sym__varid] = ACTIONS(7943),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(7287),
    [sym_char] = ACTIONS(7287),
    [sym_string] = ACTIONS(7287),
    [sym__integer_literal] = ACTIONS(7289),
    [sym__binary_literal] = ACTIONS(7291),
    [sym__octal_literal] = ACTIONS(7291),
    [sym__hex_literal] = ACTIONS(7291),
    [anon_sym_LPAREN_POUND] = ACTIONS(7293),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7293),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(7945),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(7953),
    [anon_sym_LBRACK] = ACTIONS(7301),
    [anon_sym_SQUOTE] = ACTIONS(7956),
    [anon_sym_STAR] = ACTIONS(7305),
    [anon_sym_6] = ACTIONS(7305),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(7307),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(7309),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7311),
  },
  [2478] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [ts_builtin_sym_end] = ACTIONS(5129),
    [sym__varid] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_EQ] = ACTIONS(5160),
    [anon_sym_deriving] = ACTIONS(5160),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2479] = {
    [sym_integer] = STATE(6425),
    [sym__literal] = STATE(6425),
    [sym__unboxed_open] = STATE(2108),
    [sym_constructor] = STATE(5969),
    [sym_con_unit] = STATE(6425),
    [sym_con_list] = STATE(6425),
    [sym_con_tuple] = STATE(6425),
    [sym_qualified_type] = STATE(6424),
    [sym_tycon_arrow] = STATE(6424),
    [sym_type_literal] = STATE(2479),
    [sym__promoted_tycon] = STATE(6424),
    [sym_type_variable] = STATE(6424),
    [sym_annotated_type_variable] = STATE(6424),
    [sym_type_parens] = STATE(2479),
    [sym_type_list] = STATE(2479),
    [sym_type_tuple] = STATE(2479),
    [sym__type_promotable_literal] = STATE(2479),
    [sym__type_promoted_literal] = STATE(2479),
    [sym__type_literal] = STATE(2479),
    [sym_type_name] = STATE(2479),
    [sym_type_star] = STATE(2479),
    [sym_type_unboxed_tuple] = STATE(2479),
    [sym_type_unboxed_sum] = STATE(2479),
    [sym__atype] = STATE(2479),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15009),
    [sym_splice] = STATE(2479),
    [sym_quasiquote] = STATE(2479),
    [aux_sym_type_apply_repeat1] = STATE(2479),
    [sym__varid] = ACTIONS(7959),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(7962),
    [sym_char] = ACTIONS(7962),
    [sym_string] = ACTIONS(7962),
    [sym__integer_literal] = ACTIONS(7965),
    [sym__binary_literal] = ACTIONS(7968),
    [sym__octal_literal] = ACTIONS(7968),
    [sym__hex_literal] = ACTIONS(7968),
    [anon_sym_LPAREN_POUND] = ACTIONS(7971),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7971),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7974),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(7977),
    [anon_sym_LBRACK] = ACTIONS(7980),
    [anon_sym_SQUOTE] = ACTIONS(7983),
    [anon_sym_STAR] = ACTIONS(7986),
    [anon_sym_6] = ACTIONS(7986),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_EQ] = ACTIONS(5059),
    [anon_sym_deriving] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(7989),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym__layout_end] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(7992),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7995),
  },
  [2480] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_EQ] = ACTIONS(5160),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_deriving] = ACTIONS(5160),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2481] = {
    [sym_integer] = STATE(6722),
    [sym__literal] = STATE(6722),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(6476),
    [sym_con_unit] = STATE(6722),
    [sym_con_list] = STATE(6722),
    [sym_con_tuple] = STATE(6722),
    [sym_qualified_type] = STATE(6642),
    [sym_tycon_arrow] = STATE(6642),
    [sym_type_literal] = STATE(2498),
    [sym__promoted_tycon] = STATE(6642),
    [sym_type_variable] = STATE(6642),
    [sym_annotated_type_variable] = STATE(6642),
    [sym_type_parens] = STATE(2498),
    [sym_type_list] = STATE(2498),
    [sym_type_tuple] = STATE(2498),
    [sym__type_promotable_literal] = STATE(2498),
    [sym__type_promoted_literal] = STATE(2498),
    [sym__type_literal] = STATE(2498),
    [sym_type_name] = STATE(2498),
    [sym_type_star] = STATE(2498),
    [sym_type_unboxed_tuple] = STATE(2498),
    [sym_type_unboxed_sum] = STATE(2498),
    [sym__atype] = STATE(2498),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14736),
    [sym_splice] = STATE(2498),
    [sym_quasiquote] = STATE(2498),
    [aux_sym_type_apply_repeat1] = STATE(2498),
    [sym__varid] = ACTIONS(7998),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(7042),
    [sym_char] = ACTIONS(7042),
    [sym_string] = ACTIONS(7042),
    [sym__integer_literal] = ACTIONS(7044),
    [sym__binary_literal] = ACTIONS(7046),
    [sym__octal_literal] = ACTIONS(7046),
    [sym__hex_literal] = ACTIONS(7046),
    [anon_sym_LPAREN_POUND] = ACTIONS(7048),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7048),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(8000),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(8002),
    [anon_sym_LBRACK] = ACTIONS(7056),
    [anon_sym_SQUOTE] = ACTIONS(8005),
    [anon_sym_STAR] = ACTIONS(7060),
    [anon_sym_6] = ACTIONS(7060),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(7062),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym__layout_end] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(7064),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7066),
  },
  [2482] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [ts_builtin_sym_end] = ACTIONS(5129),
    [sym__varid] = ACTIONS(5899),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2483] = {
    [sym_integer] = STATE(6722),
    [sym__literal] = STATE(6722),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(6476),
    [sym_con_unit] = STATE(6722),
    [sym_con_list] = STATE(6722),
    [sym_con_tuple] = STATE(6722),
    [sym_qualified_type] = STATE(6642),
    [sym_tycon_arrow] = STATE(6642),
    [sym_type_literal] = STATE(2481),
    [sym__promoted_tycon] = STATE(6642),
    [sym_type_variable] = STATE(6642),
    [sym_annotated_type_variable] = STATE(6642),
    [sym_type_parens] = STATE(2481),
    [sym_type_list] = STATE(2481),
    [sym_type_tuple] = STATE(2481),
    [sym__type_promotable_literal] = STATE(2481),
    [sym__type_promoted_literal] = STATE(2481),
    [sym__type_literal] = STATE(2481),
    [sym_type_name] = STATE(2481),
    [sym_type_star] = STATE(2481),
    [sym_type_unboxed_tuple] = STATE(2481),
    [sym_type_unboxed_sum] = STATE(2481),
    [sym__atype] = STATE(2481),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14736),
    [sym_splice] = STATE(2481),
    [sym_quasiquote] = STATE(2481),
    [aux_sym_type_apply_repeat1] = STATE(2481),
    [sym__varid] = ACTIONS(7998),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(7042),
    [sym_char] = ACTIONS(7042),
    [sym_string] = ACTIONS(7042),
    [sym__integer_literal] = ACTIONS(7044),
    [sym__binary_literal] = ACTIONS(7046),
    [sym__octal_literal] = ACTIONS(7046),
    [sym__hex_literal] = ACTIONS(7046),
    [anon_sym_LPAREN_POUND] = ACTIONS(7048),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7048),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(8000),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(8008),
    [anon_sym_LBRACK] = ACTIONS(7056),
    [anon_sym_SQUOTE] = ACTIONS(8011),
    [anon_sym_STAR] = ACTIONS(7060),
    [anon_sym_6] = ACTIONS(7060),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(7062),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym__layout_end] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(7064),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7066),
  },
  [2484] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5129),
    [sym_quasiquote_start] = ACTIONS(5168),
    [sym__unboxed_close] = ACTIONS(5129),
  },
  [2485] = {
    [sym_integer] = STATE(6751),
    [sym__literal] = STATE(6751),
    [sym__unboxed_open] = STATE(2140),
    [sym_constructor] = STATE(6530),
    [sym_con_unit] = STATE(6751),
    [sym_con_list] = STATE(6751),
    [sym_con_tuple] = STATE(6751),
    [sym_qualified_type] = STATE(6610),
    [sym_tycon_arrow] = STATE(6610),
    [sym_type_literal] = STATE(2493),
    [sym__promoted_tycon] = STATE(6610),
    [sym_type_variable] = STATE(6610),
    [sym_annotated_type_variable] = STATE(6610),
    [sym_type_parens] = STATE(2493),
    [sym_type_list] = STATE(2493),
    [sym_type_tuple] = STATE(2493),
    [sym__type_promotable_literal] = STATE(2493),
    [sym__type_promoted_literal] = STATE(2493),
    [sym__type_literal] = STATE(2493),
    [sym_type_name] = STATE(2493),
    [sym_type_star] = STATE(2493),
    [sym_type_unboxed_tuple] = STATE(2493),
    [sym_type_unboxed_sum] = STATE(2493),
    [sym__atype] = STATE(2493),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15339),
    [sym_splice] = STATE(2493),
    [sym_quasiquote] = STATE(2493),
    [aux_sym_type_apply_repeat1] = STATE(2493),
    [sym__varid] = ACTIONS(8014),
    [sym_float] = ACTIONS(6683),
    [sym_char] = ACTIONS(6683),
    [sym_string] = ACTIONS(6683),
    [sym__integer_literal] = ACTIONS(6685),
    [sym__binary_literal] = ACTIONS(6687),
    [sym__octal_literal] = ACTIONS(6687),
    [sym__hex_literal] = ACTIONS(6687),
    [anon_sym_LPAREN_POUND] = ACTIONS(6689),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6689),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(8016),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(8018),
    [anon_sym_LBRACK] = ACTIONS(6697),
    [anon_sym_SQUOTE] = ACTIONS(8021),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(6701),
    [anon_sym_6] = ACTIONS(6701),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(6703),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6705),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5177),
    [sym_quasiquote_start] = ACTIONS(6707),
    [sym__unboxed_close] = ACTIONS(5177),
  },
  [2486] = {
    [sym_integer] = STATE(6592),
    [sym__literal] = STATE(6592),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6403),
    [sym_con_unit] = STATE(6592),
    [sym_con_list] = STATE(6592),
    [sym_con_tuple] = STATE(6592),
    [sym_qualified_type] = STATE(6680),
    [sym_tycon_arrow] = STATE(6680),
    [sym_type_literal] = STATE(2486),
    [sym__promoted_tycon] = STATE(6680),
    [sym_type_variable] = STATE(6680),
    [sym_annotated_type_variable] = STATE(6680),
    [sym_type_parens] = STATE(2486),
    [sym_type_list] = STATE(2486),
    [sym_type_tuple] = STATE(2486),
    [sym__type_promotable_literal] = STATE(2486),
    [sym__type_promoted_literal] = STATE(2486),
    [sym__type_literal] = STATE(2486),
    [sym_type_name] = STATE(2486),
    [sym_type_star] = STATE(2486),
    [sym_type_unboxed_tuple] = STATE(2486),
    [sym_type_unboxed_sum] = STATE(2486),
    [sym__atype] = STATE(2486),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14854),
    [sym_splice] = STATE(2486),
    [sym_quasiquote] = STATE(2486),
    [aux_sym_type_apply_repeat1] = STATE(2486),
    [sym__varid] = ACTIONS(8024),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(8027),
    [sym_char] = ACTIONS(8027),
    [sym_string] = ACTIONS(8027),
    [sym__integer_literal] = ACTIONS(8030),
    [sym__binary_literal] = ACTIONS(8033),
    [sym__octal_literal] = ACTIONS(8033),
    [sym__hex_literal] = ACTIONS(8033),
    [anon_sym_LPAREN_POUND] = ACTIONS(8036),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8036),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8039),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(8042),
    [anon_sym_LBRACK] = ACTIONS(8045),
    [anon_sym_SQUOTE] = ACTIONS(8048),
    [anon_sym_STAR] = ACTIONS(8051),
    [anon_sym_6] = ACTIONS(8051),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_EQ] = ACTIONS(5059),
    [anon_sym_RBRACE] = ACTIONS(5030),
    [anon_sym_deriving] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(8054),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(8057),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8060),
  },
  [2487] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_RBRACE] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2488] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(14224),
    [sym_lazy_type] = STATE(14224),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(14224),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2772),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_record_fields] = STATE(15609),
    [sym__gadt_fun] = STATE(18228),
    [sym__gadt_sig] = STATE(18228),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(8063),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_LBRACE] = ACTIONS(5294),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5363),
    [sym__lazy] = ACTIONS(5365),
  },
  [2489] = {
    [sym_integer] = STATE(6771),
    [sym__literal] = STATE(6771),
    [sym__unboxed_open] = STATE(2214),
    [sym_constructor] = STATE(6276),
    [sym_con_unit] = STATE(6771),
    [sym_con_list] = STATE(6771),
    [sym_con_tuple] = STATE(6771),
    [sym_qualified_type] = STATE(6769),
    [sym_tycon_arrow] = STATE(6769),
    [sym_type_literal] = STATE(2497),
    [sym__promoted_tycon] = STATE(6769),
    [sym_type_variable] = STATE(6769),
    [sym_annotated_type_variable] = STATE(6769),
    [sym_type_parens] = STATE(2497),
    [sym_type_list] = STATE(2497),
    [sym_type_tuple] = STATE(2497),
    [sym__type_promotable_literal] = STATE(2497),
    [sym__type_promoted_literal] = STATE(2497),
    [sym__type_literal] = STATE(2497),
    [sym_type_name] = STATE(2497),
    [sym_type_star] = STATE(2497),
    [sym_type_unboxed_tuple] = STATE(2497),
    [sym_type_unboxed_sum] = STATE(2497),
    [sym__atype] = STATE(2497),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15096),
    [sym_splice] = STATE(2497),
    [sym_quasiquote] = STATE(2497),
    [aux_sym_type_apply_repeat1] = STATE(2497),
    [sym__varid] = ACTIONS(8065),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(7315),
    [sym_char] = ACTIONS(7315),
    [sym_string] = ACTIONS(7315),
    [sym__integer_literal] = ACTIONS(7317),
    [sym__binary_literal] = ACTIONS(7319),
    [sym__octal_literal] = ACTIONS(7319),
    [sym__hex_literal] = ACTIONS(7319),
    [anon_sym_LPAREN_POUND] = ACTIONS(7321),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7321),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(8067),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(8069),
    [anon_sym_LBRACK] = ACTIONS(7329),
    [anon_sym_SQUOTE] = ACTIONS(8072),
    [anon_sym_STAR] = ACTIONS(7333),
    [anon_sym_6] = ACTIONS(7333),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_RBRACE] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(7335),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(7337),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7339),
  },
  [2490] = {
    [sym_integer] = STATE(6622),
    [sym__literal] = STATE(6622),
    [sym__unboxed_open] = STATE(2223),
    [sym_constructor] = STATE(6527),
    [sym_con_unit] = STATE(6622),
    [sym_con_list] = STATE(6622),
    [sym_con_tuple] = STATE(6622),
    [sym_qualified_type] = STATE(6611),
    [sym_tycon_arrow] = STATE(6611),
    [sym_type_literal] = STATE(2495),
    [sym__promoted_tycon] = STATE(6611),
    [sym_type_variable] = STATE(6611),
    [sym_annotated_type_variable] = STATE(6611),
    [sym_type_parens] = STATE(2495),
    [sym_type_list] = STATE(2495),
    [sym_type_tuple] = STATE(2495),
    [sym__type_promotable_literal] = STATE(2495),
    [sym__type_promoted_literal] = STATE(2495),
    [sym__type_literal] = STATE(2495),
    [sym_type_name] = STATE(2495),
    [sym_type_star] = STATE(2495),
    [sym_type_unboxed_tuple] = STATE(2495),
    [sym_type_unboxed_sum] = STATE(2495),
    [sym__atype] = STATE(2495),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14645),
    [sym_splice] = STATE(2495),
    [sym_quasiquote] = STATE(2495),
    [aux_sym_type_apply_repeat1] = STATE(2495),
    [ts_builtin_sym_end] = ACTIONS(5078),
    [sym__varid] = ACTIONS(8075),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(7203),
    [sym_char] = ACTIONS(7203),
    [sym_string] = ACTIONS(7203),
    [sym__integer_literal] = ACTIONS(7205),
    [sym__binary_literal] = ACTIONS(7207),
    [sym__octal_literal] = ACTIONS(7207),
    [sym__hex_literal] = ACTIONS(7207),
    [anon_sym_LPAREN_POUND] = ACTIONS(7209),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7209),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(8077),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(8079),
    [anon_sym_LBRACK] = ACTIONS(7217),
    [anon_sym_SQUOTE] = ACTIONS(8082),
    [anon_sym_STAR] = ACTIONS(7221),
    [anon_sym_6] = ACTIONS(7221),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(7223),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(7225),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7227),
  },
  [2491] = {
    [sym_integer] = STATE(6592),
    [sym__literal] = STATE(6592),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6403),
    [sym_con_unit] = STATE(6592),
    [sym_con_list] = STATE(6592),
    [sym_con_tuple] = STATE(6592),
    [sym_qualified_type] = STATE(6680),
    [sym_tycon_arrow] = STATE(6680),
    [sym_type_literal] = STATE(2500),
    [sym__promoted_tycon] = STATE(6680),
    [sym_type_variable] = STATE(6680),
    [sym_annotated_type_variable] = STATE(6680),
    [sym_type_parens] = STATE(2500),
    [sym_type_list] = STATE(2500),
    [sym_type_tuple] = STATE(2500),
    [sym__type_promotable_literal] = STATE(2500),
    [sym__type_promoted_literal] = STATE(2500),
    [sym__type_literal] = STATE(2500),
    [sym_type_name] = STATE(2500),
    [sym_type_star] = STATE(2500),
    [sym_type_unboxed_tuple] = STATE(2500),
    [sym_type_unboxed_sum] = STATE(2500),
    [sym__atype] = STATE(2500),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14854),
    [sym_splice] = STATE(2500),
    [sym_quasiquote] = STATE(2500),
    [aux_sym_type_apply_repeat1] = STATE(2500),
    [sym__varid] = ACTIONS(6304),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(6306),
    [sym_char] = ACTIONS(6306),
    [sym_string] = ACTIONS(6306),
    [sym__integer_literal] = ACTIONS(6308),
    [sym__binary_literal] = ACTIONS(6310),
    [sym__octal_literal] = ACTIONS(6310),
    [sym__hex_literal] = ACTIONS(6310),
    [anon_sym_LPAREN_POUND] = ACTIONS(6312),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6312),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8085),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(8087),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_SQUOTE] = ACTIONS(8090),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_6] = ACTIONS(6324),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_EQ] = ACTIONS(5100),
    [anon_sym_RBRACE] = ACTIONS(5078),
    [anon_sym_deriving] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(6326),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6328),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6330),
  },
  [2492] = {
    [sym_integer] = STATE(6622),
    [sym__literal] = STATE(6622),
    [sym__unboxed_open] = STATE(2223),
    [sym_constructor] = STATE(6527),
    [sym_con_unit] = STATE(6622),
    [sym_con_list] = STATE(6622),
    [sym_con_tuple] = STATE(6622),
    [sym_qualified_type] = STATE(6611),
    [sym_tycon_arrow] = STATE(6611),
    [sym_type_literal] = STATE(2492),
    [sym__promoted_tycon] = STATE(6611),
    [sym_type_variable] = STATE(6611),
    [sym_annotated_type_variable] = STATE(6611),
    [sym_type_parens] = STATE(2492),
    [sym_type_list] = STATE(2492),
    [sym_type_tuple] = STATE(2492),
    [sym__type_promotable_literal] = STATE(2492),
    [sym__type_promoted_literal] = STATE(2492),
    [sym__type_literal] = STATE(2492),
    [sym_type_name] = STATE(2492),
    [sym_type_star] = STATE(2492),
    [sym_type_unboxed_tuple] = STATE(2492),
    [sym_type_unboxed_sum] = STATE(2492),
    [sym__atype] = STATE(2492),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14645),
    [sym_splice] = STATE(2492),
    [sym_quasiquote] = STATE(2492),
    [aux_sym_type_apply_repeat1] = STATE(2492),
    [ts_builtin_sym_end] = ACTIONS(5030),
    [sym__varid] = ACTIONS(8093),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(8096),
    [sym_char] = ACTIONS(8096),
    [sym_string] = ACTIONS(8096),
    [sym__integer_literal] = ACTIONS(8099),
    [sym__binary_literal] = ACTIONS(8102),
    [sym__octal_literal] = ACTIONS(8102),
    [sym__hex_literal] = ACTIONS(8102),
    [anon_sym_LPAREN_POUND] = ACTIONS(8105),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8105),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(8108),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(8111),
    [anon_sym_LBRACK] = ACTIONS(8114),
    [anon_sym_SQUOTE] = ACTIONS(8117),
    [anon_sym_STAR] = ACTIONS(8120),
    [anon_sym_6] = ACTIONS(8120),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(8123),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(8126),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8129),
  },
  [2493] = {
    [sym_integer] = STATE(6751),
    [sym__literal] = STATE(6751),
    [sym__unboxed_open] = STATE(2140),
    [sym_constructor] = STATE(6530),
    [sym_con_unit] = STATE(6751),
    [sym_con_list] = STATE(6751),
    [sym_con_tuple] = STATE(6751),
    [sym_qualified_type] = STATE(6610),
    [sym_tycon_arrow] = STATE(6610),
    [sym_type_literal] = STATE(2493),
    [sym__promoted_tycon] = STATE(6610),
    [sym_type_variable] = STATE(6610),
    [sym_annotated_type_variable] = STATE(6610),
    [sym_type_parens] = STATE(2493),
    [sym_type_list] = STATE(2493),
    [sym_type_tuple] = STATE(2493),
    [sym__type_promotable_literal] = STATE(2493),
    [sym__type_promoted_literal] = STATE(2493),
    [sym__type_literal] = STATE(2493),
    [sym_type_name] = STATE(2493),
    [sym_type_star] = STATE(2493),
    [sym_type_unboxed_tuple] = STATE(2493),
    [sym_type_unboxed_sum] = STATE(2493),
    [sym__atype] = STATE(2493),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15339),
    [sym_splice] = STATE(2493),
    [sym_quasiquote] = STATE(2493),
    [aux_sym_type_apply_repeat1] = STATE(2493),
    [sym__varid] = ACTIONS(8132),
    [sym_float] = ACTIONS(8135),
    [sym_char] = ACTIONS(8135),
    [sym_string] = ACTIONS(8135),
    [sym__integer_literal] = ACTIONS(8138),
    [sym__binary_literal] = ACTIONS(8141),
    [sym__octal_literal] = ACTIONS(8141),
    [sym__hex_literal] = ACTIONS(8141),
    [anon_sym_LPAREN_POUND] = ACTIONS(8144),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8144),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(8147),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(8150),
    [anon_sym_LBRACK] = ACTIONS(8153),
    [anon_sym_SQUOTE] = ACTIONS(8156),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(8159),
    [anon_sym_6] = ACTIONS(8159),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(8162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8165),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5030),
    [sym_quasiquote_start] = ACTIONS(8168),
    [sym__unboxed_close] = ACTIONS(5030),
  },
  [2494] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_strict_type] = STATE(13929),
    [sym_lazy_type] = STATE(13929),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(13929),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2770),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_record_fields] = STATE(17061),
    [sym__gadt_fun] = STATE(17060),
    [sym__gadt_sig] = STATE(17060),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(8171),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_LBRACE] = ACTIONS(5294),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
    [sym__strict] = ACTIONS(5302),
    [sym__lazy] = ACTIONS(5304),
  },
  [2495] = {
    [sym_integer] = STATE(6622),
    [sym__literal] = STATE(6622),
    [sym__unboxed_open] = STATE(2223),
    [sym_constructor] = STATE(6527),
    [sym_con_unit] = STATE(6622),
    [sym_con_list] = STATE(6622),
    [sym_con_tuple] = STATE(6622),
    [sym_qualified_type] = STATE(6611),
    [sym_tycon_arrow] = STATE(6611),
    [sym_type_literal] = STATE(2492),
    [sym__promoted_tycon] = STATE(6611),
    [sym_type_variable] = STATE(6611),
    [sym_annotated_type_variable] = STATE(6611),
    [sym_type_parens] = STATE(2492),
    [sym_type_list] = STATE(2492),
    [sym_type_tuple] = STATE(2492),
    [sym__type_promotable_literal] = STATE(2492),
    [sym__type_promoted_literal] = STATE(2492),
    [sym__type_literal] = STATE(2492),
    [sym_type_name] = STATE(2492),
    [sym_type_star] = STATE(2492),
    [sym_type_unboxed_tuple] = STATE(2492),
    [sym_type_unboxed_sum] = STATE(2492),
    [sym__atype] = STATE(2492),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14645),
    [sym_splice] = STATE(2492),
    [sym_quasiquote] = STATE(2492),
    [aux_sym_type_apply_repeat1] = STATE(2492),
    [ts_builtin_sym_end] = ACTIONS(5177),
    [sym__varid] = ACTIONS(8075),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(7203),
    [sym_char] = ACTIONS(7203),
    [sym_string] = ACTIONS(7203),
    [sym__integer_literal] = ACTIONS(7205),
    [sym__binary_literal] = ACTIONS(7207),
    [sym__octal_literal] = ACTIONS(7207),
    [sym__hex_literal] = ACTIONS(7207),
    [anon_sym_LPAREN_POUND] = ACTIONS(7209),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7209),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(8077),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(8173),
    [anon_sym_LBRACK] = ACTIONS(7217),
    [anon_sym_SQUOTE] = ACTIONS(8176),
    [anon_sym_STAR] = ACTIONS(7221),
    [anon_sym_6] = ACTIONS(7221),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(7223),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(7225),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7227),
  },
  [2496] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym__layout_end] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2497] = {
    [sym_integer] = STATE(6771),
    [sym__literal] = STATE(6771),
    [sym__unboxed_open] = STATE(2214),
    [sym_constructor] = STATE(6276),
    [sym_con_unit] = STATE(6771),
    [sym_con_list] = STATE(6771),
    [sym_con_tuple] = STATE(6771),
    [sym_qualified_type] = STATE(6769),
    [sym_tycon_arrow] = STATE(6769),
    [sym_type_literal] = STATE(2501),
    [sym__promoted_tycon] = STATE(6769),
    [sym_type_variable] = STATE(6769),
    [sym_annotated_type_variable] = STATE(6769),
    [sym_type_parens] = STATE(2501),
    [sym_type_list] = STATE(2501),
    [sym_type_tuple] = STATE(2501),
    [sym__type_promotable_literal] = STATE(2501),
    [sym__type_promoted_literal] = STATE(2501),
    [sym__type_literal] = STATE(2501),
    [sym_type_name] = STATE(2501),
    [sym_type_star] = STATE(2501),
    [sym_type_unboxed_tuple] = STATE(2501),
    [sym_type_unboxed_sum] = STATE(2501),
    [sym__atype] = STATE(2501),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15096),
    [sym_splice] = STATE(2501),
    [sym_quasiquote] = STATE(2501),
    [aux_sym_type_apply_repeat1] = STATE(2501),
    [sym__varid] = ACTIONS(8065),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(7315),
    [sym_char] = ACTIONS(7315),
    [sym_string] = ACTIONS(7315),
    [sym__integer_literal] = ACTIONS(7317),
    [sym__binary_literal] = ACTIONS(7319),
    [sym__octal_literal] = ACTIONS(7319),
    [sym__hex_literal] = ACTIONS(7319),
    [anon_sym_LPAREN_POUND] = ACTIONS(7321),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7321),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(8067),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(8179),
    [anon_sym_LBRACK] = ACTIONS(7329),
    [anon_sym_SQUOTE] = ACTIONS(8182),
    [anon_sym_STAR] = ACTIONS(7333),
    [anon_sym_6] = ACTIONS(7333),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(7335),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(7337),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7339),
  },
  [2498] = {
    [sym_integer] = STATE(6722),
    [sym__literal] = STATE(6722),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(6476),
    [sym_con_unit] = STATE(6722),
    [sym_con_list] = STATE(6722),
    [sym_con_tuple] = STATE(6722),
    [sym_qualified_type] = STATE(6642),
    [sym_tycon_arrow] = STATE(6642),
    [sym_type_literal] = STATE(2498),
    [sym__promoted_tycon] = STATE(6642),
    [sym_type_variable] = STATE(6642),
    [sym_annotated_type_variable] = STATE(6642),
    [sym_type_parens] = STATE(2498),
    [sym_type_list] = STATE(2498),
    [sym_type_tuple] = STATE(2498),
    [sym__type_promotable_literal] = STATE(2498),
    [sym__type_promoted_literal] = STATE(2498),
    [sym__type_literal] = STATE(2498),
    [sym_type_name] = STATE(2498),
    [sym_type_star] = STATE(2498),
    [sym_type_unboxed_tuple] = STATE(2498),
    [sym_type_unboxed_sum] = STATE(2498),
    [sym__atype] = STATE(2498),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14736),
    [sym_splice] = STATE(2498),
    [sym_quasiquote] = STATE(2498),
    [aux_sym_type_apply_repeat1] = STATE(2498),
    [sym__varid] = ACTIONS(8185),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(8188),
    [sym_char] = ACTIONS(8188),
    [sym_string] = ACTIONS(8188),
    [sym__integer_literal] = ACTIONS(8191),
    [sym__binary_literal] = ACTIONS(8194),
    [sym__octal_literal] = ACTIONS(8194),
    [sym__hex_literal] = ACTIONS(8194),
    [anon_sym_LPAREN_POUND] = ACTIONS(8197),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8197),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(8200),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(8203),
    [anon_sym_LBRACK] = ACTIONS(8206),
    [anon_sym_SQUOTE] = ACTIONS(8209),
    [anon_sym_STAR] = ACTIONS(8212),
    [anon_sym_6] = ACTIONS(8212),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(8215),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym__layout_end] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(8218),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8221),
  },
  [2499] = {
    [sym_integer] = STATE(6751),
    [sym__literal] = STATE(6751),
    [sym__unboxed_open] = STATE(2140),
    [sym_constructor] = STATE(6530),
    [sym_con_unit] = STATE(6751),
    [sym_con_list] = STATE(6751),
    [sym_con_tuple] = STATE(6751),
    [sym_qualified_type] = STATE(6610),
    [sym_tycon_arrow] = STATE(6610),
    [sym_type_literal] = STATE(2485),
    [sym__promoted_tycon] = STATE(6610),
    [sym_type_variable] = STATE(6610),
    [sym_annotated_type_variable] = STATE(6610),
    [sym_type_parens] = STATE(2485),
    [sym_type_list] = STATE(2485),
    [sym_type_tuple] = STATE(2485),
    [sym__type_promotable_literal] = STATE(2485),
    [sym__type_promoted_literal] = STATE(2485),
    [sym__type_literal] = STATE(2485),
    [sym_type_name] = STATE(2485),
    [sym_type_star] = STATE(2485),
    [sym_type_unboxed_tuple] = STATE(2485),
    [sym_type_unboxed_sum] = STATE(2485),
    [sym__atype] = STATE(2485),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15339),
    [sym_splice] = STATE(2485),
    [sym_quasiquote] = STATE(2485),
    [aux_sym_type_apply_repeat1] = STATE(2485),
    [sym__varid] = ACTIONS(8014),
    [sym_float] = ACTIONS(6683),
    [sym_char] = ACTIONS(6683),
    [sym_string] = ACTIONS(6683),
    [sym__integer_literal] = ACTIONS(6685),
    [sym__binary_literal] = ACTIONS(6687),
    [sym__octal_literal] = ACTIONS(6687),
    [sym__hex_literal] = ACTIONS(6687),
    [anon_sym_LPAREN_POUND] = ACTIONS(6689),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6689),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(8016),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(8224),
    [anon_sym_LBRACK] = ACTIONS(6697),
    [anon_sym_SQUOTE] = ACTIONS(8227),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(6701),
    [anon_sym_6] = ACTIONS(6701),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(6703),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6705),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5078),
    [sym_quasiquote_start] = ACTIONS(6707),
    [sym__unboxed_close] = ACTIONS(5078),
  },
  [2500] = {
    [sym_integer] = STATE(6592),
    [sym__literal] = STATE(6592),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6403),
    [sym_con_unit] = STATE(6592),
    [sym_con_list] = STATE(6592),
    [sym_con_tuple] = STATE(6592),
    [sym_qualified_type] = STATE(6680),
    [sym_tycon_arrow] = STATE(6680),
    [sym_type_literal] = STATE(2486),
    [sym__promoted_tycon] = STATE(6680),
    [sym_type_variable] = STATE(6680),
    [sym_annotated_type_variable] = STATE(6680),
    [sym_type_parens] = STATE(2486),
    [sym_type_list] = STATE(2486),
    [sym_type_tuple] = STATE(2486),
    [sym__type_promotable_literal] = STATE(2486),
    [sym__type_promoted_literal] = STATE(2486),
    [sym__type_literal] = STATE(2486),
    [sym_type_name] = STATE(2486),
    [sym_type_star] = STATE(2486),
    [sym_type_unboxed_tuple] = STATE(2486),
    [sym_type_unboxed_sum] = STATE(2486),
    [sym__atype] = STATE(2486),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14854),
    [sym_splice] = STATE(2486),
    [sym_quasiquote] = STATE(2486),
    [aux_sym_type_apply_repeat1] = STATE(2486),
    [sym__varid] = ACTIONS(6304),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(6306),
    [sym_char] = ACTIONS(6306),
    [sym_string] = ACTIONS(6306),
    [sym__integer_literal] = ACTIONS(6308),
    [sym__binary_literal] = ACTIONS(6310),
    [sym__octal_literal] = ACTIONS(6310),
    [sym__hex_literal] = ACTIONS(6310),
    [anon_sym_LPAREN_POUND] = ACTIONS(6312),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6312),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8085),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(8230),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_SQUOTE] = ACTIONS(8233),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_6] = ACTIONS(6324),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_EQ] = ACTIONS(5185),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_deriving] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(6326),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6328),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6330),
  },
  [2501] = {
    [sym_integer] = STATE(6771),
    [sym__literal] = STATE(6771),
    [sym__unboxed_open] = STATE(2214),
    [sym_constructor] = STATE(6276),
    [sym_con_unit] = STATE(6771),
    [sym_con_list] = STATE(6771),
    [sym_con_tuple] = STATE(6771),
    [sym_qualified_type] = STATE(6769),
    [sym_tycon_arrow] = STATE(6769),
    [sym_type_literal] = STATE(2501),
    [sym__promoted_tycon] = STATE(6769),
    [sym_type_variable] = STATE(6769),
    [sym_annotated_type_variable] = STATE(6769),
    [sym_type_parens] = STATE(2501),
    [sym_type_list] = STATE(2501),
    [sym_type_tuple] = STATE(2501),
    [sym__type_promotable_literal] = STATE(2501),
    [sym__type_promoted_literal] = STATE(2501),
    [sym__type_literal] = STATE(2501),
    [sym_type_name] = STATE(2501),
    [sym_type_star] = STATE(2501),
    [sym_type_unboxed_tuple] = STATE(2501),
    [sym_type_unboxed_sum] = STATE(2501),
    [sym__atype] = STATE(2501),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15096),
    [sym_splice] = STATE(2501),
    [sym_quasiquote] = STATE(2501),
    [aux_sym_type_apply_repeat1] = STATE(2501),
    [sym__varid] = ACTIONS(8236),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(8239),
    [sym_char] = ACTIONS(8239),
    [sym_string] = ACTIONS(8239),
    [sym__integer_literal] = ACTIONS(8242),
    [sym__binary_literal] = ACTIONS(8245),
    [sym__octal_literal] = ACTIONS(8245),
    [sym__hex_literal] = ACTIONS(8245),
    [anon_sym_LPAREN_POUND] = ACTIONS(8248),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8248),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(8251),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(8254),
    [anon_sym_LBRACK] = ACTIONS(8257),
    [anon_sym_SQUOTE] = ACTIONS(8260),
    [anon_sym_STAR] = ACTIONS(8263),
    [anon_sym_6] = ACTIONS(8263),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_RBRACE] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(8266),
    [aux_sym__token1] = ACTIONS(3),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(8269),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8272),
  },
  [2502] = {
    [sym_integer] = STATE(6592),
    [sym__literal] = STATE(6592),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6403),
    [sym_con_unit] = STATE(6592),
    [sym_con_list] = STATE(6592),
    [sym_con_tuple] = STATE(6592),
    [sym_qualified_type] = STATE(6680),
    [sym_tycon_arrow] = STATE(6680),
    [sym_type_literal] = STATE(2491),
    [sym__promoted_tycon] = STATE(6680),
    [sym_type_variable] = STATE(6680),
    [sym_annotated_type_variable] = STATE(6680),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14515),
    [sym_type_parens] = STATE(2491),
    [sym_type_list] = STATE(2491),
    [sym_type_tuple] = STATE(2491),
    [sym__type_promotable_literal] = STATE(2491),
    [sym__type_promoted_literal] = STATE(2491),
    [sym__type_literal] = STATE(2491),
    [sym_type_name] = STATE(2480),
    [sym_type_star] = STATE(2491),
    [sym_type_unboxed_tuple] = STATE(2491),
    [sym_type_unboxed_sum] = STATE(2491),
    [sym__atype] = STATE(2491),
    [sym_type_apply] = STATE(7807),
    [sym__btype] = STATE(7807),
    [sym_type_infix] = STATE(11549),
    [sym__type_infix] = STATE(12168),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2544),
    [sym__type_quantifiers] = STATE(14570),
    [sym__type_context] = STATE(14570),
    [sym__type_fun] = STATE(14570),
    [sym__type] = STATE(14570),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14854),
    [sym_splice] = STATE(2491),
    [sym_quasiquote] = STATE(2491),
    [sym__varid] = ACTIONS(6304),
    [sym_float] = ACTIONS(6306),
    [sym_char] = ACTIONS(6306),
    [sym_string] = ACTIONS(6306),
    [sym__integer_literal] = ACTIONS(6308),
    [sym__binary_literal] = ACTIONS(6310),
    [sym__octal_literal] = ACTIONS(6310),
    [sym__hex_literal] = ACTIONS(6310),
    [anon_sym_LPAREN_POUND] = ACTIONS(6312),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6312),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6314),
    [sym__conid] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_6] = ACTIONS(6324),
    [anon_sym_7] = ACTIONS(6326),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6328),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6330),
  },
  [2503] = {
    [sym_integer] = STATE(7386),
    [sym__literal] = STATE(7386),
    [sym__unboxed_open] = STATE(2197),
    [sym_constructor] = STATE(7110),
    [sym_con_unit] = STATE(7386),
    [sym_con_list] = STATE(7386),
    [sym_con_tuple] = STATE(7386),
    [sym_qualified_type] = STATE(7585),
    [sym_tycon_arrow] = STATE(7585),
    [sym_type_literal] = STATE(2736),
    [sym__promoted_tycon] = STATE(7585),
    [sym_type_variable] = STATE(7585),
    [sym_annotated_type_variable] = STATE(7585),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14082),
    [sym_type_parens] = STATE(2736),
    [sym_type_list] = STATE(2736),
    [sym_type_tuple] = STATE(2736),
    [sym__type_promotable_literal] = STATE(2736),
    [sym__type_promoted_literal] = STATE(2736),
    [sym__type_literal] = STATE(2736),
    [sym_type_name] = STATE(2755),
    [sym_type_star] = STATE(2736),
    [sym_type_unboxed_tuple] = STATE(2736),
    [sym_type_unboxed_sum] = STATE(2736),
    [sym__atype] = STATE(2736),
    [sym_type_apply] = STATE(8314),
    [sym__btype] = STATE(8314),
    [sym_type_infix] = STATE(12645),
    [sym__type_infix] = STATE(12371),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2503),
    [sym__type_quantifiers] = STATE(15145),
    [sym__type_context] = STATE(15145),
    [sym__type_fun] = STATE(15145),
    [sym__type] = STATE(15145),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15277),
    [sym_splice] = STATE(2736),
    [sym_quasiquote] = STATE(2736),
    [sym__varid] = ACTIONS(6167),
    [sym_float] = ACTIONS(6169),
    [sym_char] = ACTIONS(6169),
    [sym_string] = ACTIONS(6169),
    [sym__integer_literal] = ACTIONS(6171),
    [sym__binary_literal] = ACTIONS(6173),
    [sym__octal_literal] = ACTIONS(6173),
    [sym__hex_literal] = ACTIONS(6173),
    [anon_sym_LPAREN_POUND] = ACTIONS(6175),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6175),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6177),
    [sym__conid] = ACTIONS(6181),
    [anon_sym_LBRACK] = ACTIONS(6183),
    [anon_sym_SQUOTE] = ACTIONS(6185),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6187),
    [anon_sym_6] = ACTIONS(6187),
    [anon_sym_7] = ACTIONS(6189),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6191),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6193),
  },
  [2504] = {
    [sym_integer] = STATE(6771),
    [sym__literal] = STATE(6771),
    [sym__unboxed_open] = STATE(2214),
    [sym_constructor] = STATE(6276),
    [sym_con_unit] = STATE(6771),
    [sym_con_list] = STATE(6771),
    [sym_con_tuple] = STATE(6771),
    [sym_qualified_type] = STATE(6769),
    [sym_tycon_arrow] = STATE(6769),
    [sym_type_literal] = STATE(2489),
    [sym__promoted_tycon] = STATE(6769),
    [sym_type_variable] = STATE(6769),
    [sym_annotated_type_variable] = STATE(6769),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14144),
    [sym_type_parens] = STATE(2489),
    [sym_type_list] = STATE(2489),
    [sym_type_tuple] = STATE(2489),
    [sym__type_promotable_literal] = STATE(2489),
    [sym__type_promoted_literal] = STATE(2489),
    [sym__type_literal] = STATE(2489),
    [sym_type_name] = STATE(2487),
    [sym_type_star] = STATE(2489),
    [sym_type_unboxed_tuple] = STATE(2489),
    [sym_type_unboxed_sum] = STATE(2489),
    [sym__atype] = STATE(2489),
    [sym_type_apply] = STATE(7772),
    [sym__btype] = STATE(7772),
    [sym_type_infix] = STATE(10200),
    [sym__type_infix] = STATE(9950),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2588),
    [sym__type_quantifiers] = STATE(12332),
    [sym__type_context] = STATE(12332),
    [sym__type_fun] = STATE(12332),
    [sym__type] = STATE(12332),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15096),
    [sym_splice] = STATE(2489),
    [sym_quasiquote] = STATE(2489),
    [sym__varid] = ACTIONS(7313),
    [sym_float] = ACTIONS(7315),
    [sym_char] = ACTIONS(7315),
    [sym_string] = ACTIONS(7315),
    [sym__integer_literal] = ACTIONS(7317),
    [sym__binary_literal] = ACTIONS(7319),
    [sym__octal_literal] = ACTIONS(7319),
    [sym__hex_literal] = ACTIONS(7319),
    [anon_sym_LPAREN_POUND] = ACTIONS(7321),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7321),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7323),
    [sym__conid] = ACTIONS(7327),
    [anon_sym_LBRACK] = ACTIONS(7329),
    [anon_sym_SQUOTE] = ACTIONS(7331),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7333),
    [anon_sym_6] = ACTIONS(7333),
    [anon_sym_7] = ACTIONS(7335),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7337),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7339),
  },
  [2505] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(10318),
    [sym__type_context] = STATE(10318),
    [sym__type_fun] = STATE(10318),
    [sym__type] = STATE(10318),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2506] = {
    [sym_integer] = STATE(6622),
    [sym__literal] = STATE(6622),
    [sym__unboxed_open] = STATE(2223),
    [sym_constructor] = STATE(6527),
    [sym_con_unit] = STATE(6622),
    [sym_con_list] = STATE(6622),
    [sym_con_tuple] = STATE(6622),
    [sym_qualified_type] = STATE(6611),
    [sym_tycon_arrow] = STATE(6611),
    [sym_type_literal] = STATE(2490),
    [sym__promoted_tycon] = STATE(6611),
    [sym_type_variable] = STATE(6611),
    [sym_annotated_type_variable] = STATE(6611),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14484),
    [sym_type_parens] = STATE(2490),
    [sym_type_list] = STATE(2490),
    [sym_type_tuple] = STATE(2490),
    [sym__type_promotable_literal] = STATE(2490),
    [sym__type_promoted_literal] = STATE(2490),
    [sym__type_literal] = STATE(2490),
    [sym_type_name] = STATE(2482),
    [sym_type_star] = STATE(2490),
    [sym_type_unboxed_tuple] = STATE(2490),
    [sym_type_unboxed_sum] = STATE(2490),
    [sym__atype] = STATE(2490),
    [sym_type_apply] = STATE(7827),
    [sym__btype] = STATE(7827),
    [sym_type_infix] = STATE(10085),
    [sym__type_infix] = STATE(9970),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2578),
    [sym__type_quantifiers] = STATE(12245),
    [sym__type_context] = STATE(12245),
    [sym__type_fun] = STATE(12245),
    [sym__type] = STATE(12245),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14645),
    [sym_splice] = STATE(2490),
    [sym_quasiquote] = STATE(2490),
    [sym__varid] = ACTIONS(7201),
    [sym_float] = ACTIONS(7203),
    [sym_char] = ACTIONS(7203),
    [sym_string] = ACTIONS(7203),
    [sym__integer_literal] = ACTIONS(7205),
    [sym__binary_literal] = ACTIONS(7207),
    [sym__octal_literal] = ACTIONS(7207),
    [sym__hex_literal] = ACTIONS(7207),
    [anon_sym_LPAREN_POUND] = ACTIONS(7209),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7209),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7211),
    [sym__conid] = ACTIONS(7215),
    [anon_sym_LBRACK] = ACTIONS(7217),
    [anon_sym_SQUOTE] = ACTIONS(7219),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7221),
    [anon_sym_6] = ACTIONS(7221),
    [anon_sym_7] = ACTIONS(7223),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7225),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7227),
  },
  [2507] = {
    [sym_integer] = STATE(7606),
    [sym__literal] = STATE(7606),
    [sym__unboxed_open] = STATE(2159),
    [sym_constructor] = STATE(7574),
    [sym_con_unit] = STATE(7606),
    [sym_con_list] = STATE(7606),
    [sym_con_tuple] = STATE(7606),
    [sym_qualified_type] = STATE(7609),
    [sym_tycon_arrow] = STATE(7609),
    [sym_type_literal] = STATE(2780),
    [sym__promoted_tycon] = STATE(7609),
    [sym_type_variable] = STATE(7609),
    [sym_annotated_type_variable] = STATE(7609),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14566),
    [sym_type_parens] = STATE(2780),
    [sym_type_list] = STATE(2780),
    [sym_type_tuple] = STATE(2780),
    [sym__type_promotable_literal] = STATE(2780),
    [sym__type_promoted_literal] = STATE(2780),
    [sym__type_literal] = STATE(2780),
    [sym_type_name] = STATE(2771),
    [sym_type_star] = STATE(2780),
    [sym_type_unboxed_tuple] = STATE(2780),
    [sym_type_unboxed_sum] = STATE(2780),
    [sym__atype] = STATE(2780),
    [sym_type_apply] = STATE(8651),
    [sym__btype] = STATE(8651),
    [sym_type_infix] = STATE(12900),
    [sym__type_infix] = STATE(12620),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2514),
    [sym__type_quantifiers] = STATE(16236),
    [sym__type_context] = STATE(16236),
    [sym__type_fun] = STATE(16236),
    [sym__type] = STATE(16236),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15052),
    [sym_splice] = STATE(2780),
    [sym_quasiquote] = STATE(2780),
    [sym__varid] = ACTIONS(7369),
    [sym_float] = ACTIONS(7371),
    [sym_char] = ACTIONS(7371),
    [sym_string] = ACTIONS(7371),
    [sym__integer_literal] = ACTIONS(7373),
    [sym__binary_literal] = ACTIONS(7375),
    [sym__octal_literal] = ACTIONS(7375),
    [sym__hex_literal] = ACTIONS(7375),
    [anon_sym_LPAREN_POUND] = ACTIONS(7377),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7377),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7379),
    [sym__conid] = ACTIONS(7383),
    [anon_sym_LBRACK] = ACTIONS(7385),
    [anon_sym_SQUOTE] = ACTIONS(7387),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7389),
    [anon_sym_6] = ACTIONS(7389),
    [anon_sym_7] = ACTIONS(7391),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7393),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7395),
  },
  [2508] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(2445),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(16310),
    [sym_lazy_type] = STATE(16310),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9510),
    [sym__btype] = STATE(9510),
    [sym_type_infix] = STATE(15079),
    [sym__type_infix] = STATE(16310),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2811),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_data_constructor] = STATE(14835),
    [sym_data_constructor_infix] = STATE(14835),
    [sym_data_constructor_record] = STATE(14835),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(8063),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5359),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5316),
    [sym__lazy] = ACTIONS(5318),
  },
  [2509] = {
    [sym_integer] = STATE(6064),
    [sym__literal] = STATE(6064),
    [sym__unboxed_open] = STATE(2150),
    [sym_constructor] = STATE(5877),
    [sym_con_unit] = STATE(6064),
    [sym_con_list] = STATE(6064),
    [sym_con_tuple] = STATE(6064),
    [sym_qualified_type] = STATE(6066),
    [sym_tycon_arrow] = STATE(6066),
    [sym_type_literal] = STATE(2376),
    [sym__promoted_tycon] = STATE(6066),
    [sym_type_variable] = STATE(6066),
    [sym_annotated_type_variable] = STATE(6066),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14102),
    [sym_type_parens] = STATE(2376),
    [sym_type_list] = STATE(2376),
    [sym_type_tuple] = STATE(2376),
    [sym__type_promotable_literal] = STATE(2376),
    [sym__type_promoted_literal] = STATE(2376),
    [sym__type_literal] = STATE(2376),
    [sym_type_name] = STATE(2389),
    [sym_type_star] = STATE(2376),
    [sym_type_unboxed_tuple] = STATE(2376),
    [sym_type_unboxed_sum] = STATE(2376),
    [sym__atype] = STATE(2376),
    [sym_type_apply] = STATE(7487),
    [sym__btype] = STATE(7487),
    [sym_type_infix] = STATE(9707),
    [sym__type_infix] = STATE(9579),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2513),
    [sym__type_quantifiers] = STATE(11870),
    [sym__type_context] = STATE(11870),
    [sym__type_fun] = STATE(11870),
    [sym__type] = STATE(11870),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14778),
    [sym_splice] = STATE(2376),
    [sym_quasiquote] = STATE(2376),
    [sym__varid] = ACTIONS(7108),
    [sym_float] = ACTIONS(6278),
    [sym_char] = ACTIONS(6278),
    [sym_string] = ACTIONS(6278),
    [sym__integer_literal] = ACTIONS(6280),
    [sym__binary_literal] = ACTIONS(6282),
    [sym__octal_literal] = ACTIONS(6282),
    [sym__hex_literal] = ACTIONS(6282),
    [anon_sym_LPAREN_POUND] = ACTIONS(6284),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6284),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7110),
    [sym__conid] = ACTIONS(7114),
    [anon_sym_LBRACK] = ACTIONS(6291),
    [anon_sym_SQUOTE] = ACTIONS(7116),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_6] = ACTIONS(6296),
    [anon_sym_7] = ACTIONS(6298),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6300),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6302),
  },
  [2510] = {
    [sym_integer] = STATE(7606),
    [sym__literal] = STATE(7606),
    [sym__unboxed_open] = STATE(2159),
    [sym_constructor] = STATE(7574),
    [sym_con_unit] = STATE(7606),
    [sym_con_list] = STATE(7606),
    [sym_con_tuple] = STATE(7606),
    [sym_qualified_type] = STATE(7609),
    [sym_tycon_arrow] = STATE(7609),
    [sym_type_literal] = STATE(2780),
    [sym__promoted_tycon] = STATE(7609),
    [sym_type_variable] = STATE(7609),
    [sym_annotated_type_variable] = STATE(7609),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14566),
    [sym_type_parens] = STATE(2780),
    [sym_type_list] = STATE(2780),
    [sym_type_tuple] = STATE(2780),
    [sym__type_promotable_literal] = STATE(2780),
    [sym__type_promoted_literal] = STATE(2780),
    [sym__type_literal] = STATE(2780),
    [sym_type_name] = STATE(2771),
    [sym_type_star] = STATE(2780),
    [sym_type_unboxed_tuple] = STATE(2780),
    [sym_type_unboxed_sum] = STATE(2780),
    [sym__atype] = STATE(2780),
    [sym_type_apply] = STATE(8651),
    [sym__btype] = STATE(8651),
    [sym_type_infix] = STATE(12900),
    [sym__type_infix] = STATE(12620),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2514),
    [sym__type_quantifiers] = STATE(16234),
    [sym__type_context] = STATE(16234),
    [sym__type_fun] = STATE(16234),
    [sym__type] = STATE(16234),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15052),
    [sym_splice] = STATE(2780),
    [sym_quasiquote] = STATE(2780),
    [sym__varid] = ACTIONS(7369),
    [sym_float] = ACTIONS(7371),
    [sym_char] = ACTIONS(7371),
    [sym_string] = ACTIONS(7371),
    [sym__integer_literal] = ACTIONS(7373),
    [sym__binary_literal] = ACTIONS(7375),
    [sym__octal_literal] = ACTIONS(7375),
    [sym__hex_literal] = ACTIONS(7375),
    [anon_sym_LPAREN_POUND] = ACTIONS(7377),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7377),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7379),
    [sym__conid] = ACTIONS(7383),
    [anon_sym_LBRACK] = ACTIONS(7385),
    [anon_sym_SQUOTE] = ACTIONS(7387),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7389),
    [anon_sym_6] = ACTIONS(7389),
    [anon_sym_7] = ACTIONS(7391),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7393),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7395),
  },
  [2511] = {
    [sym_integer] = STATE(5892),
    [sym__literal] = STATE(5892),
    [sym__unboxed_open] = STATE(2185),
    [sym_constructor] = STATE(5658),
    [sym_con_unit] = STATE(5892),
    [sym_con_list] = STATE(5892),
    [sym_con_tuple] = STATE(5892),
    [sym_qualified_type] = STATE(5887),
    [sym_tycon_arrow] = STATE(5887),
    [sym_type_literal] = STATE(2295),
    [sym__promoted_tycon] = STATE(5887),
    [sym_type_variable] = STATE(5887),
    [sym_annotated_type_variable] = STATE(5887),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14262),
    [sym_type_parens] = STATE(2295),
    [sym_type_list] = STATE(2295),
    [sym_type_tuple] = STATE(2295),
    [sym__type_promotable_literal] = STATE(2295),
    [sym__type_promoted_literal] = STATE(2295),
    [sym__type_literal] = STATE(2295),
    [sym_type_name] = STATE(2351),
    [sym_type_star] = STATE(2295),
    [sym_type_unboxed_tuple] = STATE(2295),
    [sym_type_unboxed_sum] = STATE(2295),
    [sym__atype] = STATE(2295),
    [sym_type_apply] = STATE(7097),
    [sym__btype] = STATE(7097),
    [sym_type_infix] = STATE(9558),
    [sym__type_infix] = STATE(9459),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2511),
    [sym__type_quantifiers] = STATE(10912),
    [sym__type_context] = STATE(10912),
    [sym__type_fun] = STATE(10912),
    [sym__type] = STATE(10912),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15268),
    [sym_splice] = STATE(2295),
    [sym_quasiquote] = STATE(2295),
    [sym__varid] = ACTIONS(5796),
    [sym_float] = ACTIONS(5798),
    [sym_char] = ACTIONS(5798),
    [sym_string] = ACTIONS(5798),
    [sym__integer_literal] = ACTIONS(5800),
    [sym__binary_literal] = ACTIONS(5802),
    [sym__octal_literal] = ACTIONS(5802),
    [sym__hex_literal] = ACTIONS(5802),
    [anon_sym_LPAREN_POUND] = ACTIONS(5804),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5804),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7118),
    [sym__conid] = ACTIONS(7122),
    [anon_sym_LBRACK] = ACTIONS(5811),
    [anon_sym_SQUOTE] = ACTIONS(7124),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5816),
    [anon_sym_6] = ACTIONS(5816),
    [anon_sym_7] = ACTIONS(5818),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5822),
  },
  [2512] = {
    [sym_integer] = STATE(6402),
    [sym__literal] = STATE(6402),
    [sym__unboxed_open] = STATE(2110),
    [sym_constructor] = STATE(6210),
    [sym_con_unit] = STATE(6402),
    [sym_con_list] = STATE(6402),
    [sym_con_tuple] = STATE(6402),
    [sym_qualified_type] = STATE(6415),
    [sym_tycon_arrow] = STATE(6415),
    [sym_type_literal] = STATE(2467),
    [sym__promoted_tycon] = STATE(6415),
    [sym_type_variable] = STATE(6415),
    [sym_annotated_type_variable] = STATE(6415),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14198),
    [sym_type_parens] = STATE(2467),
    [sym_type_list] = STATE(2467),
    [sym_type_tuple] = STATE(2467),
    [sym__type_promotable_literal] = STATE(2467),
    [sym__type_promoted_literal] = STATE(2467),
    [sym__type_literal] = STATE(2467),
    [sym_type_name] = STATE(2451),
    [sym_type_star] = STATE(2467),
    [sym_type_unboxed_tuple] = STATE(2467),
    [sym_type_unboxed_sum] = STATE(2467),
    [sym__atype] = STATE(2467),
    [sym_type_apply] = STATE(7671),
    [sym__btype] = STATE(7671),
    [sym_type_infix] = STATE(9845),
    [sym__type_infix] = STATE(9634),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2512),
    [sym__type_quantifiers] = STATE(12198),
    [sym__type_context] = STATE(12198),
    [sym__type_fun] = STATE(12198),
    [sym__type] = STATE(12198),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15251),
    [sym_splice] = STATE(2467),
    [sym_quasiquote] = STATE(2467),
    [sym__varid] = ACTIONS(7126),
    [sym_float] = ACTIONS(7128),
    [sym_char] = ACTIONS(7128),
    [sym_string] = ACTIONS(7128),
    [sym__integer_literal] = ACTIONS(7130),
    [sym__binary_literal] = ACTIONS(7132),
    [sym__octal_literal] = ACTIONS(7132),
    [sym__hex_literal] = ACTIONS(7132),
    [anon_sym_LPAREN_POUND] = ACTIONS(7134),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7134),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7136),
    [sym__conid] = ACTIONS(7140),
    [anon_sym_LBRACK] = ACTIONS(7142),
    [anon_sym_SQUOTE] = ACTIONS(7144),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7146),
    [anon_sym_6] = ACTIONS(7146),
    [anon_sym_7] = ACTIONS(7148),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7150),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7152),
  },
  [2513] = {
    [sym_integer] = STATE(6064),
    [sym__literal] = STATE(6064),
    [sym__unboxed_open] = STATE(2150),
    [sym_constructor] = STATE(5877),
    [sym_con_unit] = STATE(6064),
    [sym_con_list] = STATE(6064),
    [sym_con_tuple] = STATE(6064),
    [sym_qualified_type] = STATE(6066),
    [sym_tycon_arrow] = STATE(6066),
    [sym_type_literal] = STATE(2376),
    [sym__promoted_tycon] = STATE(6066),
    [sym_type_variable] = STATE(6066),
    [sym_annotated_type_variable] = STATE(6066),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14102),
    [sym_type_parens] = STATE(2376),
    [sym_type_list] = STATE(2376),
    [sym_type_tuple] = STATE(2376),
    [sym__type_promotable_literal] = STATE(2376),
    [sym__type_promoted_literal] = STATE(2376),
    [sym__type_literal] = STATE(2376),
    [sym_type_name] = STATE(2389),
    [sym_type_star] = STATE(2376),
    [sym_type_unboxed_tuple] = STATE(2376),
    [sym_type_unboxed_sum] = STATE(2376),
    [sym__atype] = STATE(2376),
    [sym_type_apply] = STATE(7487),
    [sym__btype] = STATE(7487),
    [sym_type_infix] = STATE(9707),
    [sym__type_infix] = STATE(9579),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2513),
    [sym__type_quantifiers] = STATE(11876),
    [sym__type_context] = STATE(11876),
    [sym__type_fun] = STATE(11876),
    [sym__type] = STATE(11876),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14778),
    [sym_splice] = STATE(2376),
    [sym_quasiquote] = STATE(2376),
    [sym__varid] = ACTIONS(7108),
    [sym_float] = ACTIONS(6278),
    [sym_char] = ACTIONS(6278),
    [sym_string] = ACTIONS(6278),
    [sym__integer_literal] = ACTIONS(6280),
    [sym__binary_literal] = ACTIONS(6282),
    [sym__octal_literal] = ACTIONS(6282),
    [sym__hex_literal] = ACTIONS(6282),
    [anon_sym_LPAREN_POUND] = ACTIONS(6284),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6284),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7110),
    [sym__conid] = ACTIONS(7114),
    [anon_sym_LBRACK] = ACTIONS(6291),
    [anon_sym_SQUOTE] = ACTIONS(7116),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_6] = ACTIONS(6296),
    [anon_sym_7] = ACTIONS(6298),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6300),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6302),
  },
  [2514] = {
    [sym_integer] = STATE(7606),
    [sym__literal] = STATE(7606),
    [sym__unboxed_open] = STATE(2159),
    [sym_constructor] = STATE(7574),
    [sym_con_unit] = STATE(7606),
    [sym_con_list] = STATE(7606),
    [sym_con_tuple] = STATE(7606),
    [sym_qualified_type] = STATE(7609),
    [sym_tycon_arrow] = STATE(7609),
    [sym_type_literal] = STATE(2780),
    [sym__promoted_tycon] = STATE(7609),
    [sym_type_variable] = STATE(7609),
    [sym_annotated_type_variable] = STATE(7609),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14566),
    [sym_type_parens] = STATE(2780),
    [sym_type_list] = STATE(2780),
    [sym_type_tuple] = STATE(2780),
    [sym__type_promotable_literal] = STATE(2780),
    [sym__type_promoted_literal] = STATE(2780),
    [sym__type_literal] = STATE(2780),
    [sym_type_name] = STATE(2771),
    [sym_type_star] = STATE(2780),
    [sym_type_unboxed_tuple] = STATE(2780),
    [sym_type_unboxed_sum] = STATE(2780),
    [sym__atype] = STATE(2780),
    [sym_type_apply] = STATE(8651),
    [sym__btype] = STATE(8651),
    [sym_type_infix] = STATE(12900),
    [sym__type_infix] = STATE(12620),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2514),
    [sym__type_quantifiers] = STATE(16250),
    [sym__type_context] = STATE(16250),
    [sym__type_fun] = STATE(16250),
    [sym__type] = STATE(16250),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15052),
    [sym_splice] = STATE(2780),
    [sym_quasiquote] = STATE(2780),
    [sym__varid] = ACTIONS(7369),
    [sym_float] = ACTIONS(7371),
    [sym_char] = ACTIONS(7371),
    [sym_string] = ACTIONS(7371),
    [sym__integer_literal] = ACTIONS(7373),
    [sym__binary_literal] = ACTIONS(7375),
    [sym__octal_literal] = ACTIONS(7375),
    [sym__hex_literal] = ACTIONS(7375),
    [anon_sym_LPAREN_POUND] = ACTIONS(7377),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7377),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7379),
    [sym__conid] = ACTIONS(7383),
    [anon_sym_LBRACK] = ACTIONS(7385),
    [anon_sym_SQUOTE] = ACTIONS(7387),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7389),
    [anon_sym_6] = ACTIONS(7389),
    [anon_sym_7] = ACTIONS(7391),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7393),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7395),
  },
  [2515] = {
    [sym_integer] = STATE(6357),
    [sym__literal] = STATE(6357),
    [sym__unboxed_open] = STATE(2219),
    [sym_constructor] = STATE(6142),
    [sym_con_unit] = STATE(6357),
    [sym_con_list] = STATE(6357),
    [sym_con_tuple] = STATE(6357),
    [sym_qualified_type] = STATE(6354),
    [sym_tycon_arrow] = STATE(6354),
    [sym_type_literal] = STATE(2460),
    [sym__promoted_tycon] = STATE(6354),
    [sym_type_variable] = STATE(6354),
    [sym_annotated_type_variable] = STATE(6354),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14131),
    [sym_type_parens] = STATE(2460),
    [sym_type_list] = STATE(2460),
    [sym_type_tuple] = STATE(2460),
    [sym__type_promotable_literal] = STATE(2460),
    [sym__type_promoted_literal] = STATE(2460),
    [sym__type_literal] = STATE(2460),
    [sym_type_name] = STATE(2469),
    [sym_type_star] = STATE(2460),
    [sym_type_unboxed_tuple] = STATE(2460),
    [sym_type_unboxed_sum] = STATE(2460),
    [sym__atype] = STATE(2460),
    [sym_type_apply] = STATE(7651),
    [sym__btype] = STATE(7651),
    [sym_type_infix] = STATE(9893),
    [sym__type_infix] = STATE(9713),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2534),
    [sym__type_quantifiers] = STATE(11972),
    [sym__type_context] = STATE(11972),
    [sym__type_fun] = STATE(11972),
    [sym__type] = STATE(11972),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15108),
    [sym_splice] = STATE(2460),
    [sym_quasiquote] = STATE(2460),
    [sym__varid] = ACTIONS(6901),
    [sym_float] = ACTIONS(6903),
    [sym_char] = ACTIONS(6903),
    [sym_string] = ACTIONS(6903),
    [sym__integer_literal] = ACTIONS(6905),
    [sym__binary_literal] = ACTIONS(6907),
    [sym__octal_literal] = ACTIONS(6907),
    [sym__hex_literal] = ACTIONS(6907),
    [anon_sym_LPAREN_POUND] = ACTIONS(6909),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6909),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6911),
    [sym__conid] = ACTIONS(6915),
    [anon_sym_LBRACK] = ACTIONS(6917),
    [anon_sym_SQUOTE] = ACTIONS(6919),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6921),
    [anon_sym_6] = ACTIONS(6921),
    [anon_sym_7] = ACTIONS(6923),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6925),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6927),
  },
  [2516] = {
    [sym_integer] = STATE(7045),
    [sym__literal] = STATE(7045),
    [sym__unboxed_open] = STATE(2097),
    [sym_constructor] = STATE(6786),
    [sym_con_unit] = STATE(7045),
    [sym_con_list] = STATE(7045),
    [sym_con_tuple] = STATE(7045),
    [sym_qualified_type] = STATE(7047),
    [sym_tycon_arrow] = STATE(7047),
    [sym_type_literal] = STATE(2621),
    [sym__promoted_tycon] = STATE(7047),
    [sym_type_variable] = STATE(7047),
    [sym_annotated_type_variable] = STATE(7047),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14203),
    [sym_type_parens] = STATE(2621),
    [sym_type_list] = STATE(2621),
    [sym_type_tuple] = STATE(2621),
    [sym__type_promotable_literal] = STATE(2621),
    [sym__type_promoted_literal] = STATE(2621),
    [sym__type_literal] = STATE(2621),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2621),
    [sym_type_unboxed_tuple] = STATE(2621),
    [sym_type_unboxed_sum] = STATE(2621),
    [sym__atype] = STATE(2621),
    [sym_type_apply] = STATE(7940),
    [sym__btype] = STATE(7940),
    [sym_type_infix] = STATE(11945),
    [sym__type_infix] = STATE(11900),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2516),
    [sym__type_quantifiers] = STATE(13429),
    [sym__type_context] = STATE(13429),
    [sym__type_fun] = STATE(13429),
    [sym__type] = STATE(13429),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15321),
    [sym_splice] = STATE(2621),
    [sym_quasiquote] = STATE(2621),
    [sym__varid] = ACTIONS(7257),
    [sym_float] = ACTIONS(7259),
    [sym_char] = ACTIONS(7259),
    [sym_string] = ACTIONS(7259),
    [sym__integer_literal] = ACTIONS(7261),
    [sym__binary_literal] = ACTIONS(7263),
    [sym__octal_literal] = ACTIONS(7263),
    [sym__hex_literal] = ACTIONS(7263),
    [anon_sym_LPAREN_POUND] = ACTIONS(7265),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7265),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7267),
    [sym__conid] = ACTIONS(7271),
    [anon_sym_LBRACK] = ACTIONS(7273),
    [anon_sym_SQUOTE] = ACTIONS(7275),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7277),
    [anon_sym_6] = ACTIONS(7277),
    [anon_sym_7] = ACTIONS(7279),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7281),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7283),
  },
  [2517] = {
    [sym_integer] = STATE(6357),
    [sym__literal] = STATE(6357),
    [sym__unboxed_open] = STATE(2219),
    [sym_constructor] = STATE(6142),
    [sym_con_unit] = STATE(6357),
    [sym_con_list] = STATE(6357),
    [sym_con_tuple] = STATE(6357),
    [sym_qualified_type] = STATE(6354),
    [sym_tycon_arrow] = STATE(6354),
    [sym_type_literal] = STATE(2460),
    [sym__promoted_tycon] = STATE(6354),
    [sym_type_variable] = STATE(6354),
    [sym_annotated_type_variable] = STATE(6354),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14131),
    [sym_type_parens] = STATE(2460),
    [sym_type_list] = STATE(2460),
    [sym_type_tuple] = STATE(2460),
    [sym__type_promotable_literal] = STATE(2460),
    [sym__type_promoted_literal] = STATE(2460),
    [sym__type_literal] = STATE(2460),
    [sym_type_name] = STATE(2469),
    [sym_type_star] = STATE(2460),
    [sym_type_unboxed_tuple] = STATE(2460),
    [sym_type_unboxed_sum] = STATE(2460),
    [sym__atype] = STATE(2460),
    [sym_type_apply] = STATE(7651),
    [sym__btype] = STATE(7651),
    [sym_type_infix] = STATE(9893),
    [sym__type_infix] = STATE(9713),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2534),
    [sym__type_quantifiers] = STATE(11963),
    [sym__type_context] = STATE(11963),
    [sym__type_fun] = STATE(11963),
    [sym__type] = STATE(11963),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15108),
    [sym_splice] = STATE(2460),
    [sym_quasiquote] = STATE(2460),
    [sym__varid] = ACTIONS(6901),
    [sym_float] = ACTIONS(6903),
    [sym_char] = ACTIONS(6903),
    [sym_string] = ACTIONS(6903),
    [sym__integer_literal] = ACTIONS(6905),
    [sym__binary_literal] = ACTIONS(6907),
    [sym__octal_literal] = ACTIONS(6907),
    [sym__hex_literal] = ACTIONS(6907),
    [anon_sym_LPAREN_POUND] = ACTIONS(6909),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6909),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6911),
    [sym__conid] = ACTIONS(6915),
    [anon_sym_LBRACK] = ACTIONS(6917),
    [anon_sym_SQUOTE] = ACTIONS(6919),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6921),
    [anon_sym_6] = ACTIONS(6921),
    [anon_sym_7] = ACTIONS(6923),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6925),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6927),
  },
  [2518] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14475),
    [sym__type_context] = STATE(14475),
    [sym__type_fun] = STATE(14475),
    [sym__type] = STATE(14475),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
  },
  [2519] = {
    [sym_integer] = STATE(6402),
    [sym__literal] = STATE(6402),
    [sym__unboxed_open] = STATE(2110),
    [sym_constructor] = STATE(6210),
    [sym_con_unit] = STATE(6402),
    [sym_con_list] = STATE(6402),
    [sym_con_tuple] = STATE(6402),
    [sym_qualified_type] = STATE(6415),
    [sym_tycon_arrow] = STATE(6415),
    [sym_type_literal] = STATE(2467),
    [sym__promoted_tycon] = STATE(6415),
    [sym_type_variable] = STATE(6415),
    [sym_annotated_type_variable] = STATE(6415),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14198),
    [sym_type_parens] = STATE(2467),
    [sym_type_list] = STATE(2467),
    [sym_type_tuple] = STATE(2467),
    [sym__type_promotable_literal] = STATE(2467),
    [sym__type_promoted_literal] = STATE(2467),
    [sym__type_literal] = STATE(2467),
    [sym_type_name] = STATE(2451),
    [sym_type_star] = STATE(2467),
    [sym_type_unboxed_tuple] = STATE(2467),
    [sym_type_unboxed_sum] = STATE(2467),
    [sym__atype] = STATE(2467),
    [sym_type_apply] = STATE(7671),
    [sym__btype] = STATE(7671),
    [sym_type_infix] = STATE(9845),
    [sym__type_infix] = STATE(9634),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2512),
    [sym__type_quantifiers] = STATE(12164),
    [sym__type_context] = STATE(12164),
    [sym__type_fun] = STATE(12164),
    [sym__type] = STATE(12164),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15251),
    [sym_splice] = STATE(2467),
    [sym_quasiquote] = STATE(2467),
    [sym__varid] = ACTIONS(7126),
    [sym_float] = ACTIONS(7128),
    [sym_char] = ACTIONS(7128),
    [sym_string] = ACTIONS(7128),
    [sym__integer_literal] = ACTIONS(7130),
    [sym__binary_literal] = ACTIONS(7132),
    [sym__octal_literal] = ACTIONS(7132),
    [sym__hex_literal] = ACTIONS(7132),
    [anon_sym_LPAREN_POUND] = ACTIONS(7134),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7134),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7136),
    [sym__conid] = ACTIONS(7140),
    [anon_sym_LBRACK] = ACTIONS(7142),
    [anon_sym_SQUOTE] = ACTIONS(7144),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7146),
    [anon_sym_6] = ACTIONS(7146),
    [anon_sym_7] = ACTIONS(7148),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7150),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7152),
  },
  [2520] = {
    [sym_integer] = STATE(6402),
    [sym__literal] = STATE(6402),
    [sym__unboxed_open] = STATE(2110),
    [sym_constructor] = STATE(6210),
    [sym_con_unit] = STATE(6402),
    [sym_con_list] = STATE(6402),
    [sym_con_tuple] = STATE(6402),
    [sym_qualified_type] = STATE(6415),
    [sym_tycon_arrow] = STATE(6415),
    [sym_type_literal] = STATE(2467),
    [sym__promoted_tycon] = STATE(6415),
    [sym_type_variable] = STATE(6415),
    [sym_annotated_type_variable] = STATE(6415),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14198),
    [sym_type_parens] = STATE(2467),
    [sym_type_list] = STATE(2467),
    [sym_type_tuple] = STATE(2467),
    [sym__type_promotable_literal] = STATE(2467),
    [sym__type_promoted_literal] = STATE(2467),
    [sym__type_literal] = STATE(2467),
    [sym_type_name] = STATE(2451),
    [sym_type_star] = STATE(2467),
    [sym_type_unboxed_tuple] = STATE(2467),
    [sym_type_unboxed_sum] = STATE(2467),
    [sym__atype] = STATE(2467),
    [sym_type_apply] = STATE(7671),
    [sym__btype] = STATE(7671),
    [sym_type_infix] = STATE(9845),
    [sym__type_infix] = STATE(9634),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2512),
    [sym__type_quantifiers] = STATE(11944),
    [sym__type_context] = STATE(11944),
    [sym__type_fun] = STATE(11944),
    [sym__type] = STATE(11944),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15251),
    [sym_splice] = STATE(2467),
    [sym_quasiquote] = STATE(2467),
    [sym__varid] = ACTIONS(7126),
    [sym_float] = ACTIONS(7128),
    [sym_char] = ACTIONS(7128),
    [sym_string] = ACTIONS(7128),
    [sym__integer_literal] = ACTIONS(7130),
    [sym__binary_literal] = ACTIONS(7132),
    [sym__octal_literal] = ACTIONS(7132),
    [sym__hex_literal] = ACTIONS(7132),
    [anon_sym_LPAREN_POUND] = ACTIONS(7134),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7134),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7136),
    [sym__conid] = ACTIONS(7140),
    [anon_sym_LBRACK] = ACTIONS(7142),
    [anon_sym_SQUOTE] = ACTIONS(7144),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7146),
    [anon_sym_6] = ACTIONS(7146),
    [anon_sym_7] = ACTIONS(7148),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7150),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7152),
  },
  [2521] = {
    [sym_integer] = STATE(6722),
    [sym__literal] = STATE(6722),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(6476),
    [sym_con_unit] = STATE(6722),
    [sym_con_list] = STATE(6722),
    [sym_con_tuple] = STATE(6722),
    [sym_qualified_type] = STATE(6642),
    [sym_tycon_arrow] = STATE(6642),
    [sym_type_literal] = STATE(2483),
    [sym__promoted_tycon] = STATE(6642),
    [sym_type_variable] = STATE(6642),
    [sym_annotated_type_variable] = STATE(6642),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14037),
    [sym_type_parens] = STATE(2483),
    [sym_type_list] = STATE(2483),
    [sym_type_tuple] = STATE(2483),
    [sym__type_promotable_literal] = STATE(2483),
    [sym__type_promoted_literal] = STATE(2483),
    [sym__type_literal] = STATE(2483),
    [sym_type_name] = STATE(2496),
    [sym_type_star] = STATE(2483),
    [sym_type_unboxed_tuple] = STATE(2483),
    [sym_type_unboxed_sum] = STATE(2483),
    [sym__atype] = STATE(2483),
    [sym_type_apply] = STATE(7781),
    [sym__btype] = STATE(7781),
    [sym_type_infix] = STATE(10316),
    [sym__type_infix] = STATE(9849),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2526),
    [sym__type_quantifiers] = STATE(12434),
    [sym__type_context] = STATE(12434),
    [sym__type_fun] = STATE(12434),
    [sym__type] = STATE(12434),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14736),
    [sym_splice] = STATE(2483),
    [sym_quasiquote] = STATE(2483),
    [sym__varid] = ACTIONS(7040),
    [sym_float] = ACTIONS(7042),
    [sym_char] = ACTIONS(7042),
    [sym_string] = ACTIONS(7042),
    [sym__integer_literal] = ACTIONS(7044),
    [sym__binary_literal] = ACTIONS(7046),
    [sym__octal_literal] = ACTIONS(7046),
    [sym__hex_literal] = ACTIONS(7046),
    [anon_sym_LPAREN_POUND] = ACTIONS(7048),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7048),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7050),
    [sym__conid] = ACTIONS(7054),
    [anon_sym_LBRACK] = ACTIONS(7056),
    [anon_sym_SQUOTE] = ACTIONS(7058),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7060),
    [anon_sym_6] = ACTIONS(7060),
    [anon_sym_7] = ACTIONS(7062),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7064),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7066),
  },
  [2522] = {
    [sym_integer] = STATE(6722),
    [sym__literal] = STATE(6722),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(6476),
    [sym_con_unit] = STATE(6722),
    [sym_con_list] = STATE(6722),
    [sym_con_tuple] = STATE(6722),
    [sym_qualified_type] = STATE(6642),
    [sym_tycon_arrow] = STATE(6642),
    [sym_type_literal] = STATE(2483),
    [sym__promoted_tycon] = STATE(6642),
    [sym_type_variable] = STATE(6642),
    [sym_annotated_type_variable] = STATE(6642),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14037),
    [sym_type_parens] = STATE(2483),
    [sym_type_list] = STATE(2483),
    [sym_type_tuple] = STATE(2483),
    [sym__type_promotable_literal] = STATE(2483),
    [sym__type_promoted_literal] = STATE(2483),
    [sym__type_literal] = STATE(2483),
    [sym_type_name] = STATE(2496),
    [sym_type_star] = STATE(2483),
    [sym_type_unboxed_tuple] = STATE(2483),
    [sym_type_unboxed_sum] = STATE(2483),
    [sym__atype] = STATE(2483),
    [sym_type_apply] = STATE(7781),
    [sym__btype] = STATE(7781),
    [sym_type_infix] = STATE(10316),
    [sym__type_infix] = STATE(9849),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2526),
    [sym__type_quantifiers] = STATE(12429),
    [sym__type_context] = STATE(12429),
    [sym__type_fun] = STATE(12429),
    [sym__type] = STATE(12429),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14736),
    [sym_splice] = STATE(2483),
    [sym_quasiquote] = STATE(2483),
    [sym__varid] = ACTIONS(7040),
    [sym_float] = ACTIONS(7042),
    [sym_char] = ACTIONS(7042),
    [sym_string] = ACTIONS(7042),
    [sym__integer_literal] = ACTIONS(7044),
    [sym__binary_literal] = ACTIONS(7046),
    [sym__octal_literal] = ACTIONS(7046),
    [sym__hex_literal] = ACTIONS(7046),
    [anon_sym_LPAREN_POUND] = ACTIONS(7048),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7048),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7050),
    [sym__conid] = ACTIONS(7054),
    [anon_sym_LBRACK] = ACTIONS(7056),
    [anon_sym_SQUOTE] = ACTIONS(7058),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7060),
    [anon_sym_6] = ACTIONS(7060),
    [anon_sym_7] = ACTIONS(7062),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7064),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7066),
  },
  [2523] = {
    [sym_integer] = STATE(7045),
    [sym__literal] = STATE(7045),
    [sym__unboxed_open] = STATE(2097),
    [sym_constructor] = STATE(6786),
    [sym_con_unit] = STATE(7045),
    [sym_con_list] = STATE(7045),
    [sym_con_tuple] = STATE(7045),
    [sym_qualified_type] = STATE(7047),
    [sym_tycon_arrow] = STATE(7047),
    [sym_type_literal] = STATE(2621),
    [sym__promoted_tycon] = STATE(7047),
    [sym_type_variable] = STATE(7047),
    [sym_annotated_type_variable] = STATE(7047),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14203),
    [sym_type_parens] = STATE(2621),
    [sym_type_list] = STATE(2621),
    [sym_type_tuple] = STATE(2621),
    [sym__type_promotable_literal] = STATE(2621),
    [sym__type_promoted_literal] = STATE(2621),
    [sym__type_literal] = STATE(2621),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2621),
    [sym_type_unboxed_tuple] = STATE(2621),
    [sym_type_unboxed_sum] = STATE(2621),
    [sym__atype] = STATE(2621),
    [sym_type_apply] = STATE(7940),
    [sym__btype] = STATE(7940),
    [sym_type_infix] = STATE(11945),
    [sym__type_infix] = STATE(11900),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2516),
    [sym__type_quantifiers] = STATE(13425),
    [sym__type_context] = STATE(13425),
    [sym__type_fun] = STATE(13425),
    [sym__type] = STATE(13425),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15321),
    [sym_splice] = STATE(2621),
    [sym_quasiquote] = STATE(2621),
    [sym__varid] = ACTIONS(7257),
    [sym_float] = ACTIONS(7259),
    [sym_char] = ACTIONS(7259),
    [sym_string] = ACTIONS(7259),
    [sym__integer_literal] = ACTIONS(7261),
    [sym__binary_literal] = ACTIONS(7263),
    [sym__octal_literal] = ACTIONS(7263),
    [sym__hex_literal] = ACTIONS(7263),
    [anon_sym_LPAREN_POUND] = ACTIONS(7265),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7265),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7267),
    [sym__conid] = ACTIONS(7271),
    [anon_sym_LBRACK] = ACTIONS(7273),
    [anon_sym_SQUOTE] = ACTIONS(7275),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7277),
    [anon_sym_6] = ACTIONS(7277),
    [anon_sym_7] = ACTIONS(7279),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7281),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7283),
  },
  [2524] = {
    [sym_integer] = STATE(7045),
    [sym__literal] = STATE(7045),
    [sym__unboxed_open] = STATE(2097),
    [sym_constructor] = STATE(6786),
    [sym_con_unit] = STATE(7045),
    [sym_con_list] = STATE(7045),
    [sym_con_tuple] = STATE(7045),
    [sym_qualified_type] = STATE(7047),
    [sym_tycon_arrow] = STATE(7047),
    [sym_type_literal] = STATE(2621),
    [sym__promoted_tycon] = STATE(7047),
    [sym_type_variable] = STATE(7047),
    [sym_annotated_type_variable] = STATE(7047),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14203),
    [sym_type_parens] = STATE(2621),
    [sym_type_list] = STATE(2621),
    [sym_type_tuple] = STATE(2621),
    [sym__type_promotable_literal] = STATE(2621),
    [sym__type_promoted_literal] = STATE(2621),
    [sym__type_literal] = STATE(2621),
    [sym_type_name] = STATE(2580),
    [sym_type_star] = STATE(2621),
    [sym_type_unboxed_tuple] = STATE(2621),
    [sym_type_unboxed_sum] = STATE(2621),
    [sym__atype] = STATE(2621),
    [sym_type_apply] = STATE(7940),
    [sym__btype] = STATE(7940),
    [sym_type_infix] = STATE(11945),
    [sym__type_infix] = STATE(11900),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2516),
    [sym__type_quantifiers] = STATE(13428),
    [sym__type_context] = STATE(13428),
    [sym__type_fun] = STATE(13428),
    [sym__type] = STATE(13428),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15321),
    [sym_splice] = STATE(2621),
    [sym_quasiquote] = STATE(2621),
    [sym__varid] = ACTIONS(7257),
    [sym_float] = ACTIONS(7259),
    [sym_char] = ACTIONS(7259),
    [sym_string] = ACTIONS(7259),
    [sym__integer_literal] = ACTIONS(7261),
    [sym__binary_literal] = ACTIONS(7263),
    [sym__octal_literal] = ACTIONS(7263),
    [sym__hex_literal] = ACTIONS(7263),
    [anon_sym_LPAREN_POUND] = ACTIONS(7265),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7265),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7267),
    [sym__conid] = ACTIONS(7271),
    [anon_sym_LBRACK] = ACTIONS(7273),
    [anon_sym_SQUOTE] = ACTIONS(7275),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7277),
    [anon_sym_6] = ACTIONS(7277),
    [anon_sym_7] = ACTIONS(7279),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7281),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7283),
  },
  [2525] = {
    [sym_integer] = STATE(6228),
    [sym__literal] = STATE(6228),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(5787),
    [sym_con_unit] = STATE(6228),
    [sym_con_list] = STATE(6228),
    [sym_con_tuple] = STATE(6228),
    [sym_qualified_type] = STATE(6115),
    [sym_tycon_arrow] = STATE(6115),
    [sym_type_literal] = STATE(2385),
    [sym__promoted_tycon] = STATE(6115),
    [sym_type_variable] = STATE(6115),
    [sym_annotated_type_variable] = STATE(6115),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14177),
    [sym_type_parens] = STATE(2385),
    [sym_type_list] = STATE(2385),
    [sym_type_tuple] = STATE(2385),
    [sym__type_promotable_literal] = STATE(2385),
    [sym__type_promoted_literal] = STATE(2385),
    [sym__type_literal] = STATE(2385),
    [sym_type_name] = STATE(2427),
    [sym_type_star] = STATE(2385),
    [sym_type_unboxed_tuple] = STATE(2385),
    [sym_type_unboxed_sum] = STATE(2385),
    [sym__atype] = STATE(2385),
    [sym_type_apply] = STATE(7511),
    [sym__btype] = STATE(7511),
    [sym_type_infix] = STATE(9687),
    [sym__type_infix] = STATE(9538),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2547),
    [sym__type_quantifiers] = STATE(11793),
    [sym__type_context] = STATE(11793),
    [sym__type_fun] = STATE(11793),
    [sym__type] = STATE(11793),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15408),
    [sym_splice] = STATE(2385),
    [sym_quasiquote] = STATE(2385),
    [sym__varid] = ACTIONS(6195),
    [sym_float] = ACTIONS(6197),
    [sym_char] = ACTIONS(6197),
    [sym_string] = ACTIONS(6197),
    [sym__integer_literal] = ACTIONS(6199),
    [sym__binary_literal] = ACTIONS(6201),
    [sym__octal_literal] = ACTIONS(6201),
    [sym__hex_literal] = ACTIONS(6201),
    [anon_sym_LPAREN_POUND] = ACTIONS(6203),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6203),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6205),
    [sym__conid] = ACTIONS(6209),
    [anon_sym_LBRACK] = ACTIONS(6211),
    [anon_sym_SQUOTE] = ACTIONS(6213),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6215),
    [anon_sym_6] = ACTIONS(6215),
    [anon_sym_7] = ACTIONS(6217),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6219),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6221),
  },
  [2526] = {
    [sym_integer] = STATE(6722),
    [sym__literal] = STATE(6722),
    [sym__unboxed_open] = STATE(2113),
    [sym_constructor] = STATE(6476),
    [sym_con_unit] = STATE(6722),
    [sym_con_list] = STATE(6722),
    [sym_con_tuple] = STATE(6722),
    [sym_qualified_type] = STATE(6642),
    [sym_tycon_arrow] = STATE(6642),
    [sym_type_literal] = STATE(2483),
    [sym__promoted_tycon] = STATE(6642),
    [sym_type_variable] = STATE(6642),
    [sym_annotated_type_variable] = STATE(6642),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14037),
    [sym_type_parens] = STATE(2483),
    [sym_type_list] = STATE(2483),
    [sym_type_tuple] = STATE(2483),
    [sym__type_promotable_literal] = STATE(2483),
    [sym__type_promoted_literal] = STATE(2483),
    [sym__type_literal] = STATE(2483),
    [sym_type_name] = STATE(2496),
    [sym_type_star] = STATE(2483),
    [sym_type_unboxed_tuple] = STATE(2483),
    [sym_type_unboxed_sum] = STATE(2483),
    [sym__atype] = STATE(2483),
    [sym_type_apply] = STATE(7781),
    [sym__btype] = STATE(7781),
    [sym_type_infix] = STATE(10316),
    [sym__type_infix] = STATE(9849),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2526),
    [sym__type_quantifiers] = STATE(12444),
    [sym__type_context] = STATE(12444),
    [sym__type_fun] = STATE(12444),
    [sym__type] = STATE(12444),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14736),
    [sym_splice] = STATE(2483),
    [sym_quasiquote] = STATE(2483),
    [sym__varid] = ACTIONS(7040),
    [sym_float] = ACTIONS(7042),
    [sym_char] = ACTIONS(7042),
    [sym_string] = ACTIONS(7042),
    [sym__integer_literal] = ACTIONS(7044),
    [sym__binary_literal] = ACTIONS(7046),
    [sym__octal_literal] = ACTIONS(7046),
    [sym__hex_literal] = ACTIONS(7046),
    [anon_sym_LPAREN_POUND] = ACTIONS(7048),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7048),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7050),
    [sym__conid] = ACTIONS(7054),
    [anon_sym_LBRACK] = ACTIONS(7056),
    [anon_sym_SQUOTE] = ACTIONS(7058),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7060),
    [anon_sym_6] = ACTIONS(7060),
    [anon_sym_7] = ACTIONS(7062),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7064),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7066),
  },
  [2527] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(13971),
    [sym__type_context] = STATE(13971),
    [sym__type_fun] = STATE(13971),
    [sym__type] = STATE(13971),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2528] = {
    [sym_integer] = STATE(6425),
    [sym__literal] = STATE(6425),
    [sym__unboxed_open] = STATE(2108),
    [sym_constructor] = STATE(5969),
    [sym_con_unit] = STATE(6425),
    [sym_con_list] = STATE(6425),
    [sym_con_tuple] = STATE(6425),
    [sym_qualified_type] = STATE(6424),
    [sym_tycon_arrow] = STATE(6424),
    [sym_type_literal] = STATE(2461),
    [sym__promoted_tycon] = STATE(6424),
    [sym_type_variable] = STATE(6424),
    [sym_annotated_type_variable] = STATE(6424),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14052),
    [sym_type_parens] = STATE(2461),
    [sym_type_list] = STATE(2461),
    [sym_type_tuple] = STATE(2461),
    [sym__type_promotable_literal] = STATE(2461),
    [sym__type_promoted_literal] = STATE(2461),
    [sym__type_literal] = STATE(2461),
    [sym_type_name] = STATE(2449),
    [sym_type_star] = STATE(2461),
    [sym_type_unboxed_tuple] = STATE(2461),
    [sym_type_unboxed_sum] = STATE(2461),
    [sym__atype] = STATE(2461),
    [sym_type_apply] = STATE(7690),
    [sym__btype] = STATE(7690),
    [sym_type_infix] = STATE(11131),
    [sym__type_infix] = STATE(11614),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2619),
    [sym__type_quantifiers] = STATE(13521),
    [sym__type_context] = STATE(13521),
    [sym__type_fun] = STATE(13521),
    [sym__type] = STATE(13521),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15009),
    [sym_splice] = STATE(2461),
    [sym_quasiquote] = STATE(2461),
    [sym__varid] = ACTIONS(7229),
    [sym_float] = ACTIONS(7231),
    [sym_char] = ACTIONS(7231),
    [sym_string] = ACTIONS(7231),
    [sym__integer_literal] = ACTIONS(7233),
    [sym__binary_literal] = ACTIONS(7235),
    [sym__octal_literal] = ACTIONS(7235),
    [sym__hex_literal] = ACTIONS(7235),
    [anon_sym_LPAREN_POUND] = ACTIONS(7237),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7237),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7239),
    [sym__conid] = ACTIONS(7243),
    [anon_sym_LBRACK] = ACTIONS(7245),
    [anon_sym_SQUOTE] = ACTIONS(7247),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7249),
    [anon_sym_6] = ACTIONS(7249),
    [anon_sym_7] = ACTIONS(7251),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7253),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7255),
  },
  [2529] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14412),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(12341),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2561),
    [sym__type_quantifiers] = STATE(17794),
    [sym__type_context] = STATE(17794),
    [sym__type_fun] = STATE(17794),
    [sym__type] = STATE(17794),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(5274),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
  },
  [2530] = {
    [sym_integer] = STATE(6425),
    [sym__literal] = STATE(6425),
    [sym__unboxed_open] = STATE(2108),
    [sym_constructor] = STATE(5969),
    [sym_con_unit] = STATE(6425),
    [sym_con_list] = STATE(6425),
    [sym_con_tuple] = STATE(6425),
    [sym_qualified_type] = STATE(6424),
    [sym_tycon_arrow] = STATE(6424),
    [sym_type_literal] = STATE(2461),
    [sym__promoted_tycon] = STATE(6424),
    [sym_type_variable] = STATE(6424),
    [sym_annotated_type_variable] = STATE(6424),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14052),
    [sym_type_parens] = STATE(2461),
    [sym_type_list] = STATE(2461),
    [sym_type_tuple] = STATE(2461),
    [sym__type_promotable_literal] = STATE(2461),
    [sym__type_promoted_literal] = STATE(2461),
    [sym__type_literal] = STATE(2461),
    [sym_type_name] = STATE(2449),
    [sym_type_star] = STATE(2461),
    [sym_type_unboxed_tuple] = STATE(2461),
    [sym_type_unboxed_sum] = STATE(2461),
    [sym__atype] = STATE(2461),
    [sym_type_apply] = STATE(7690),
    [sym__btype] = STATE(7690),
    [sym_type_infix] = STATE(11131),
    [sym__type_infix] = STATE(11614),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2619),
    [sym__type_quantifiers] = STATE(13525),
    [sym__type_context] = STATE(13525),
    [sym__type_fun] = STATE(13525),
    [sym__type] = STATE(13525),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15009),
    [sym_splice] = STATE(2461),
    [sym_quasiquote] = STATE(2461),
    [sym__varid] = ACTIONS(7229),
    [sym_float] = ACTIONS(7231),
    [sym_char] = ACTIONS(7231),
    [sym_string] = ACTIONS(7231),
    [sym__integer_literal] = ACTIONS(7233),
    [sym__binary_literal] = ACTIONS(7235),
    [sym__octal_literal] = ACTIONS(7235),
    [sym__hex_literal] = ACTIONS(7235),
    [anon_sym_LPAREN_POUND] = ACTIONS(7237),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7237),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7239),
    [sym__conid] = ACTIONS(7243),
    [anon_sym_LBRACK] = ACTIONS(7245),
    [anon_sym_SQUOTE] = ACTIONS(7247),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7249),
    [anon_sym_6] = ACTIONS(7249),
    [anon_sym_7] = ACTIONS(7251),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7253),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7255),
  },
  [2531] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(2419),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(16124),
    [sym_lazy_type] = STATE(16124),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9510),
    [sym__btype] = STATE(9510),
    [sym_type_infix] = STATE(15079),
    [sym__type_infix] = STATE(16124),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2794),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_data_constructor] = STATE(13398),
    [sym_data_constructor_infix] = STATE(13398),
    [sym_data_constructor_record] = STATE(13398),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(8063),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5371),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5316),
    [sym__lazy] = ACTIONS(5318),
  },
  [2532] = {
    [sym_integer] = STATE(7406),
    [sym__literal] = STATE(7406),
    [sym__unboxed_open] = STATE(2172),
    [sym_constructor] = STATE(7276),
    [sym_con_unit] = STATE(7406),
    [sym_con_list] = STATE(7406),
    [sym_con_tuple] = STATE(7406),
    [sym_qualified_type] = STATE(7394),
    [sym_tycon_arrow] = STATE(7394),
    [sym_type_literal] = STATE(2761),
    [sym__promoted_tycon] = STATE(7394),
    [sym_type_variable] = STATE(7394),
    [sym_annotated_type_variable] = STATE(7394),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14306),
    [sym_type_parens] = STATE(2761),
    [sym_type_list] = STATE(2761),
    [sym_type_tuple] = STATE(2761),
    [sym__type_promotable_literal] = STATE(2761),
    [sym__type_promoted_literal] = STATE(2761),
    [sym__type_literal] = STATE(2761),
    [sym_type_name] = STATE(2734),
    [sym_type_star] = STATE(2761),
    [sym_type_unboxed_tuple] = STATE(2761),
    [sym_type_unboxed_sum] = STATE(2761),
    [sym__atype] = STATE(2761),
    [sym_type_apply] = STATE(8261),
    [sym__btype] = STATE(8261),
    [sym_type_infix] = STATE(12526),
    [sym__type_infix] = STATE(12243),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2535),
    [sym__type_quantifiers] = STATE(15140),
    [sym__type_context] = STATE(15140),
    [sym__type_fun] = STATE(15140),
    [sym__type] = STATE(15140),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15131),
    [sym_splice] = STATE(2761),
    [sym_quasiquote] = STATE(2761),
    [sym__varid] = ACTIONS(6957),
    [sym_float] = ACTIONS(6959),
    [sym_char] = ACTIONS(6959),
    [sym_string] = ACTIONS(6959),
    [sym__integer_literal] = ACTIONS(6961),
    [sym__binary_literal] = ACTIONS(6963),
    [sym__octal_literal] = ACTIONS(6963),
    [sym__hex_literal] = ACTIONS(6963),
    [anon_sym_LPAREN_POUND] = ACTIONS(6965),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6965),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6967),
    [sym__conid] = ACTIONS(6971),
    [anon_sym_LBRACK] = ACTIONS(6973),
    [anon_sym_SQUOTE] = ACTIONS(6975),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6977),
    [anon_sym_6] = ACTIONS(6977),
    [anon_sym_7] = ACTIONS(6979),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6981),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6983),
  },
  [2533] = {
    [sym_integer] = STATE(7406),
    [sym__literal] = STATE(7406),
    [sym__unboxed_open] = STATE(2172),
    [sym_constructor] = STATE(7276),
    [sym_con_unit] = STATE(7406),
    [sym_con_list] = STATE(7406),
    [sym_con_tuple] = STATE(7406),
    [sym_qualified_type] = STATE(7394),
    [sym_tycon_arrow] = STATE(7394),
    [sym_type_literal] = STATE(2761),
    [sym__promoted_tycon] = STATE(7394),
    [sym_type_variable] = STATE(7394),
    [sym_annotated_type_variable] = STATE(7394),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14306),
    [sym_type_parens] = STATE(2761),
    [sym_type_list] = STATE(2761),
    [sym_type_tuple] = STATE(2761),
    [sym__type_promotable_literal] = STATE(2761),
    [sym__type_promoted_literal] = STATE(2761),
    [sym__type_literal] = STATE(2761),
    [sym_type_name] = STATE(2734),
    [sym_type_star] = STATE(2761),
    [sym_type_unboxed_tuple] = STATE(2761),
    [sym_type_unboxed_sum] = STATE(2761),
    [sym__atype] = STATE(2761),
    [sym_type_apply] = STATE(8261),
    [sym__btype] = STATE(8261),
    [sym_type_infix] = STATE(12526),
    [sym__type_infix] = STATE(12243),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2535),
    [sym__type_quantifiers] = STATE(15193),
    [sym__type_context] = STATE(15193),
    [sym__type_fun] = STATE(15193),
    [sym__type] = STATE(15193),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15131),
    [sym_splice] = STATE(2761),
    [sym_quasiquote] = STATE(2761),
    [sym__varid] = ACTIONS(6957),
    [sym_float] = ACTIONS(6959),
    [sym_char] = ACTIONS(6959),
    [sym_string] = ACTIONS(6959),
    [sym__integer_literal] = ACTIONS(6961),
    [sym__binary_literal] = ACTIONS(6963),
    [sym__octal_literal] = ACTIONS(6963),
    [sym__hex_literal] = ACTIONS(6963),
    [anon_sym_LPAREN_POUND] = ACTIONS(6965),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6965),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6967),
    [sym__conid] = ACTIONS(6971),
    [anon_sym_LBRACK] = ACTIONS(6973),
    [anon_sym_SQUOTE] = ACTIONS(6975),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6977),
    [anon_sym_6] = ACTIONS(6977),
    [anon_sym_7] = ACTIONS(6979),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6981),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6983),
  },
  [2534] = {
    [sym_integer] = STATE(6357),
    [sym__literal] = STATE(6357),
    [sym__unboxed_open] = STATE(2219),
    [sym_constructor] = STATE(6142),
    [sym_con_unit] = STATE(6357),
    [sym_con_list] = STATE(6357),
    [sym_con_tuple] = STATE(6357),
    [sym_qualified_type] = STATE(6354),
    [sym_tycon_arrow] = STATE(6354),
    [sym_type_literal] = STATE(2460),
    [sym__promoted_tycon] = STATE(6354),
    [sym_type_variable] = STATE(6354),
    [sym_annotated_type_variable] = STATE(6354),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14131),
    [sym_type_parens] = STATE(2460),
    [sym_type_list] = STATE(2460),
    [sym_type_tuple] = STATE(2460),
    [sym__type_promotable_literal] = STATE(2460),
    [sym__type_promoted_literal] = STATE(2460),
    [sym__type_literal] = STATE(2460),
    [sym_type_name] = STATE(2469),
    [sym_type_star] = STATE(2460),
    [sym_type_unboxed_tuple] = STATE(2460),
    [sym_type_unboxed_sum] = STATE(2460),
    [sym__atype] = STATE(2460),
    [sym_type_apply] = STATE(7651),
    [sym__btype] = STATE(7651),
    [sym_type_infix] = STATE(9893),
    [sym__type_infix] = STATE(9713),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2534),
    [sym__type_quantifiers] = STATE(12001),
    [sym__type_context] = STATE(12001),
    [sym__type_fun] = STATE(12001),
    [sym__type] = STATE(12001),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15108),
    [sym_splice] = STATE(2460),
    [sym_quasiquote] = STATE(2460),
    [sym__varid] = ACTIONS(6901),
    [sym_float] = ACTIONS(6903),
    [sym_char] = ACTIONS(6903),
    [sym_string] = ACTIONS(6903),
    [sym__integer_literal] = ACTIONS(6905),
    [sym__binary_literal] = ACTIONS(6907),
    [sym__octal_literal] = ACTIONS(6907),
    [sym__hex_literal] = ACTIONS(6907),
    [anon_sym_LPAREN_POUND] = ACTIONS(6909),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6909),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6911),
    [sym__conid] = ACTIONS(6915),
    [anon_sym_LBRACK] = ACTIONS(6917),
    [anon_sym_SQUOTE] = ACTIONS(6919),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6921),
    [anon_sym_6] = ACTIONS(6921),
    [anon_sym_7] = ACTIONS(6923),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6925),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6927),
  },
  [2535] = {
    [sym_integer] = STATE(7406),
    [sym__literal] = STATE(7406),
    [sym__unboxed_open] = STATE(2172),
    [sym_constructor] = STATE(7276),
    [sym_con_unit] = STATE(7406),
    [sym_con_list] = STATE(7406),
    [sym_con_tuple] = STATE(7406),
    [sym_qualified_type] = STATE(7394),
    [sym_tycon_arrow] = STATE(7394),
    [sym_type_literal] = STATE(2761),
    [sym__promoted_tycon] = STATE(7394),
    [sym_type_variable] = STATE(7394),
    [sym_annotated_type_variable] = STATE(7394),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14306),
    [sym_type_parens] = STATE(2761),
    [sym_type_list] = STATE(2761),
    [sym_type_tuple] = STATE(2761),
    [sym__type_promotable_literal] = STATE(2761),
    [sym__type_promoted_literal] = STATE(2761),
    [sym__type_literal] = STATE(2761),
    [sym_type_name] = STATE(2734),
    [sym_type_star] = STATE(2761),
    [sym_type_unboxed_tuple] = STATE(2761),
    [sym_type_unboxed_sum] = STATE(2761),
    [sym__atype] = STATE(2761),
    [sym_type_apply] = STATE(8261),
    [sym__btype] = STATE(8261),
    [sym_type_infix] = STATE(12526),
    [sym__type_infix] = STATE(12243),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2535),
    [sym__type_quantifiers] = STATE(15217),
    [sym__type_context] = STATE(15217),
    [sym__type_fun] = STATE(15217),
    [sym__type] = STATE(15217),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15131),
    [sym_splice] = STATE(2761),
    [sym_quasiquote] = STATE(2761),
    [sym__varid] = ACTIONS(6957),
    [sym_float] = ACTIONS(6959),
    [sym_char] = ACTIONS(6959),
    [sym_string] = ACTIONS(6959),
    [sym__integer_literal] = ACTIONS(6961),
    [sym__binary_literal] = ACTIONS(6963),
    [sym__octal_literal] = ACTIONS(6963),
    [sym__hex_literal] = ACTIONS(6963),
    [anon_sym_LPAREN_POUND] = ACTIONS(6965),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6965),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6967),
    [sym__conid] = ACTIONS(6971),
    [anon_sym_LBRACK] = ACTIONS(6973),
    [anon_sym_SQUOTE] = ACTIONS(6975),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6977),
    [anon_sym_6] = ACTIONS(6977),
    [anon_sym_7] = ACTIONS(6979),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6981),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6983),
  },
  [2536] = {
    [sym_integer] = STATE(5955),
    [sym__literal] = STATE(5955),
    [sym__unboxed_open] = STATE(2227),
    [sym_constructor] = STATE(5941),
    [sym_con_unit] = STATE(5955),
    [sym_con_list] = STATE(5955),
    [sym_con_tuple] = STATE(5955),
    [sym_qualified_type] = STATE(5953),
    [sym_tycon_arrow] = STATE(5953),
    [sym_type_literal] = STATE(2412),
    [sym__promoted_tycon] = STATE(5953),
    [sym_type_variable] = STATE(5953),
    [sym_annotated_type_variable] = STATE(5953),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14242),
    [sym_type_parens] = STATE(2412),
    [sym_type_list] = STATE(2412),
    [sym_type_tuple] = STATE(2412),
    [sym__type_promotable_literal] = STATE(2412),
    [sym__type_promoted_literal] = STATE(2412),
    [sym__type_literal] = STATE(2412),
    [sym_type_name] = STATE(2437),
    [sym_type_star] = STATE(2412),
    [sym_type_unboxed_tuple] = STATE(2412),
    [sym_type_unboxed_sum] = STATE(2412),
    [sym__atype] = STATE(2412),
    [sym_type_apply] = STATE(7431),
    [sym__btype] = STATE(7431),
    [sym_type_infix] = STATE(9700),
    [sym__type_infix] = STATE(9545),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2541),
    [sym__type_quantifiers] = STATE(11699),
    [sym__type_context] = STATE(11699),
    [sym__type_fun] = STATE(11699),
    [sym__type] = STATE(11699),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15273),
    [sym_splice] = STATE(2412),
    [sym_quasiquote] = STATE(2412),
    [sym__varid] = ACTIONS(6859),
    [sym_float] = ACTIONS(6861),
    [sym_char] = ACTIONS(6861),
    [sym_string] = ACTIONS(6861),
    [sym__integer_literal] = ACTIONS(6863),
    [sym__binary_literal] = ACTIONS(6865),
    [sym__octal_literal] = ACTIONS(6865),
    [sym__hex_literal] = ACTIONS(6865),
    [anon_sym_LPAREN_POUND] = ACTIONS(6867),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6867),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6893),
    [sym__conid] = ACTIONS(6897),
    [anon_sym_LBRACK] = ACTIONS(6874),
    [anon_sym_SQUOTE] = ACTIONS(6899),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6879),
    [anon_sym_6] = ACTIONS(6879),
    [anon_sym_7] = ACTIONS(6881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6885),
  },
  [2537] = {
    [sym_integer] = STATE(5955),
    [sym__literal] = STATE(5955),
    [sym__unboxed_open] = STATE(2227),
    [sym_constructor] = STATE(5941),
    [sym_con_unit] = STATE(5955),
    [sym_con_list] = STATE(5955),
    [sym_con_tuple] = STATE(5955),
    [sym_qualified_type] = STATE(5953),
    [sym_tycon_arrow] = STATE(5953),
    [sym_type_literal] = STATE(2412),
    [sym__promoted_tycon] = STATE(5953),
    [sym_type_variable] = STATE(5953),
    [sym_annotated_type_variable] = STATE(5953),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14242),
    [sym_type_parens] = STATE(2412),
    [sym_type_list] = STATE(2412),
    [sym_type_tuple] = STATE(2412),
    [sym__type_promotable_literal] = STATE(2412),
    [sym__type_promoted_literal] = STATE(2412),
    [sym__type_literal] = STATE(2412),
    [sym_type_name] = STATE(2437),
    [sym_type_star] = STATE(2412),
    [sym_type_unboxed_tuple] = STATE(2412),
    [sym_type_unboxed_sum] = STATE(2412),
    [sym__atype] = STATE(2412),
    [sym_type_apply] = STATE(7431),
    [sym__btype] = STATE(7431),
    [sym_type_infix] = STATE(9700),
    [sym__type_infix] = STATE(9545),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2541),
    [sym__type_quantifiers] = STATE(11702),
    [sym__type_context] = STATE(11702),
    [sym__type_fun] = STATE(11702),
    [sym__type] = STATE(11702),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15273),
    [sym_splice] = STATE(2412),
    [sym_quasiquote] = STATE(2412),
    [sym__varid] = ACTIONS(6859),
    [sym_float] = ACTIONS(6861),
    [sym_char] = ACTIONS(6861),
    [sym_string] = ACTIONS(6861),
    [sym__integer_literal] = ACTIONS(6863),
    [sym__binary_literal] = ACTIONS(6865),
    [sym__octal_literal] = ACTIONS(6865),
    [sym__hex_literal] = ACTIONS(6865),
    [anon_sym_LPAREN_POUND] = ACTIONS(6867),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6867),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6893),
    [sym__conid] = ACTIONS(6897),
    [anon_sym_LBRACK] = ACTIONS(6874),
    [anon_sym_SQUOTE] = ACTIONS(6899),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6879),
    [anon_sym_6] = ACTIONS(6879),
    [anon_sym_7] = ACTIONS(6881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6885),
  },
  [2538] = {
    [sym_integer] = STATE(5783),
    [sym__literal] = STATE(5783),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(5543),
    [sym_con_unit] = STATE(5783),
    [sym_con_list] = STATE(5783),
    [sym_con_tuple] = STATE(5783),
    [sym_qualified_type] = STATE(5773),
    [sym_tycon_arrow] = STATE(5773),
    [sym_type_literal] = STATE(2345),
    [sym__promoted_tycon] = STATE(5773),
    [sym_type_variable] = STATE(5773),
    [sym_annotated_type_variable] = STATE(5773),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14056),
    [sym_type_parens] = STATE(2345),
    [sym_type_list] = STATE(2345),
    [sym_type_tuple] = STATE(2345),
    [sym__type_promotable_literal] = STATE(2345),
    [sym__type_promoted_literal] = STATE(2345),
    [sym__type_literal] = STATE(2345),
    [sym_type_name] = STATE(2330),
    [sym_type_star] = STATE(2345),
    [sym_type_unboxed_tuple] = STATE(2345),
    [sym_type_unboxed_sum] = STATE(2345),
    [sym__atype] = STATE(2345),
    [sym_type_apply] = STATE(7063),
    [sym__btype] = STATE(7063),
    [sym_type_infix] = STATE(9520),
    [sym__type_infix] = STATE(9485),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2545),
    [sym__type_quantifiers] = STATE(10147),
    [sym__type_context] = STATE(10147),
    [sym__type_fun] = STATE(10147),
    [sym__type] = STATE(10147),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15397),
    [sym_splice] = STATE(2345),
    [sym_quasiquote] = STATE(2345),
    [sym__varid] = ACTIONS(6030),
    [sym_float] = ACTIONS(5916),
    [sym_char] = ACTIONS(5916),
    [sym_string] = ACTIONS(5916),
    [sym__integer_literal] = ACTIONS(5918),
    [sym__binary_literal] = ACTIONS(5920),
    [sym__octal_literal] = ACTIONS(5920),
    [sym__hex_literal] = ACTIONS(5920),
    [anon_sym_LPAREN_POUND] = ACTIONS(5922),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5922),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6032),
    [sym__conid] = ACTIONS(6036),
    [anon_sym_LBRACK] = ACTIONS(5929),
    [anon_sym_SQUOTE] = ACTIONS(6038),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5934),
    [anon_sym_6] = ACTIONS(5934),
    [anon_sym_7] = ACTIONS(5936),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5940),
  },
  [2539] = {
    [sym_integer] = STATE(5783),
    [sym__literal] = STATE(5783),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(5543),
    [sym_con_unit] = STATE(5783),
    [sym_con_list] = STATE(5783),
    [sym_con_tuple] = STATE(5783),
    [sym_qualified_type] = STATE(5773),
    [sym_tycon_arrow] = STATE(5773),
    [sym_type_literal] = STATE(2345),
    [sym__promoted_tycon] = STATE(5773),
    [sym_type_variable] = STATE(5773),
    [sym_annotated_type_variable] = STATE(5773),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14056),
    [sym_type_parens] = STATE(2345),
    [sym_type_list] = STATE(2345),
    [sym_type_tuple] = STATE(2345),
    [sym__type_promotable_literal] = STATE(2345),
    [sym__type_promoted_literal] = STATE(2345),
    [sym__type_literal] = STATE(2345),
    [sym_type_name] = STATE(2330),
    [sym_type_star] = STATE(2345),
    [sym_type_unboxed_tuple] = STATE(2345),
    [sym_type_unboxed_sum] = STATE(2345),
    [sym__atype] = STATE(2345),
    [sym_type_apply] = STATE(7063),
    [sym__btype] = STATE(7063),
    [sym_type_infix] = STATE(9520),
    [sym__type_infix] = STATE(9485),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2545),
    [sym__type_quantifiers] = STATE(10145),
    [sym__type_context] = STATE(10145),
    [sym__type_fun] = STATE(10145),
    [sym__type] = STATE(10145),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15397),
    [sym_splice] = STATE(2345),
    [sym_quasiquote] = STATE(2345),
    [sym__varid] = ACTIONS(6030),
    [sym_float] = ACTIONS(5916),
    [sym_char] = ACTIONS(5916),
    [sym_string] = ACTIONS(5916),
    [sym__integer_literal] = ACTIONS(5918),
    [sym__binary_literal] = ACTIONS(5920),
    [sym__octal_literal] = ACTIONS(5920),
    [sym__hex_literal] = ACTIONS(5920),
    [anon_sym_LPAREN_POUND] = ACTIONS(5922),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5922),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6032),
    [sym__conid] = ACTIONS(6036),
    [anon_sym_LBRACK] = ACTIONS(5929),
    [anon_sym_SQUOTE] = ACTIONS(6038),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5934),
    [anon_sym_6] = ACTIONS(5934),
    [anon_sym_7] = ACTIONS(5936),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5940),
  },
  [2540] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(2375),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(16372),
    [sym_lazy_type] = STATE(16372),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9510),
    [sym__btype] = STATE(9510),
    [sym_type_infix] = STATE(15079),
    [sym__type_infix] = STATE(16372),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2795),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_data_constructor] = STATE(14216),
    [sym_data_constructor_infix] = STATE(14216),
    [sym_data_constructor_record] = STATE(14216),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(8063),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5312),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5316),
    [sym__lazy] = ACTIONS(5318),
  },
  [2541] = {
    [sym_integer] = STATE(5955),
    [sym__literal] = STATE(5955),
    [sym__unboxed_open] = STATE(2227),
    [sym_constructor] = STATE(5941),
    [sym_con_unit] = STATE(5955),
    [sym_con_list] = STATE(5955),
    [sym_con_tuple] = STATE(5955),
    [sym_qualified_type] = STATE(5953),
    [sym_tycon_arrow] = STATE(5953),
    [sym_type_literal] = STATE(2412),
    [sym__promoted_tycon] = STATE(5953),
    [sym_type_variable] = STATE(5953),
    [sym_annotated_type_variable] = STATE(5953),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14242),
    [sym_type_parens] = STATE(2412),
    [sym_type_list] = STATE(2412),
    [sym_type_tuple] = STATE(2412),
    [sym__type_promotable_literal] = STATE(2412),
    [sym__type_promoted_literal] = STATE(2412),
    [sym__type_literal] = STATE(2412),
    [sym_type_name] = STATE(2437),
    [sym_type_star] = STATE(2412),
    [sym_type_unboxed_tuple] = STATE(2412),
    [sym_type_unboxed_sum] = STATE(2412),
    [sym__atype] = STATE(2412),
    [sym_type_apply] = STATE(7431),
    [sym__btype] = STATE(7431),
    [sym_type_infix] = STATE(9700),
    [sym__type_infix] = STATE(9545),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2541),
    [sym__type_quantifiers] = STATE(11675),
    [sym__type_context] = STATE(11675),
    [sym__type_fun] = STATE(11675),
    [sym__type] = STATE(11675),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15273),
    [sym_splice] = STATE(2412),
    [sym_quasiquote] = STATE(2412),
    [sym__varid] = ACTIONS(6859),
    [sym_float] = ACTIONS(6861),
    [sym_char] = ACTIONS(6861),
    [sym_string] = ACTIONS(6861),
    [sym__integer_literal] = ACTIONS(6863),
    [sym__binary_literal] = ACTIONS(6865),
    [sym__octal_literal] = ACTIONS(6865),
    [sym__hex_literal] = ACTIONS(6865),
    [anon_sym_LPAREN_POUND] = ACTIONS(6867),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6867),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6893),
    [sym__conid] = ACTIONS(6897),
    [anon_sym_LBRACK] = ACTIONS(6874),
    [anon_sym_SQUOTE] = ACTIONS(6899),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6879),
    [anon_sym_6] = ACTIONS(6879),
    [anon_sym_7] = ACTIONS(6881),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6883),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6885),
  },
  [2542] = {
    [sym_integer] = STATE(7581),
    [sym__literal] = STATE(7581),
    [sym__unboxed_open] = STATE(2145),
    [sym_constructor] = STATE(7303),
    [sym_con_unit] = STATE(7581),
    [sym_con_list] = STATE(7581),
    [sym_con_tuple] = STATE(7581),
    [sym_qualified_type] = STATE(7348),
    [sym_tycon_arrow] = STATE(7348),
    [sym_type_literal] = STATE(2754),
    [sym__promoted_tycon] = STATE(7348),
    [sym_type_variable] = STATE(7348),
    [sym_annotated_type_variable] = STATE(7348),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14002),
    [sym_type_parens] = STATE(2754),
    [sym_type_list] = STATE(2754),
    [sym_type_tuple] = STATE(2754),
    [sym__type_promotable_literal] = STATE(2754),
    [sym__type_promoted_literal] = STATE(2754),
    [sym__type_literal] = STATE(2754),
    [sym_type_name] = STATE(2750),
    [sym_type_star] = STATE(2754),
    [sym_type_unboxed_tuple] = STATE(2754),
    [sym_type_unboxed_sum] = STATE(2754),
    [sym__atype] = STATE(2754),
    [sym_type_apply] = STATE(8239),
    [sym__btype] = STATE(8239),
    [sym_type_infix] = STATE(12660),
    [sym__type_infix] = STATE(12425),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2584),
    [sym__type_quantifiers] = STATE(14754),
    [sym__type_context] = STATE(14754),
    [sym__type_fun] = STATE(14754),
    [sym__type] = STATE(14754),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14983),
    [sym_splice] = STATE(2754),
    [sym_quasiquote] = STATE(2754),
    [sym__varid] = ACTIONS(6111),
    [sym_float] = ACTIONS(6113),
    [sym_char] = ACTIONS(6113),
    [sym_string] = ACTIONS(6113),
    [sym__integer_literal] = ACTIONS(6115),
    [sym__binary_literal] = ACTIONS(6117),
    [sym__octal_literal] = ACTIONS(6117),
    [sym__hex_literal] = ACTIONS(6117),
    [anon_sym_LPAREN_POUND] = ACTIONS(6119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6119),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [sym__conid] = ACTIONS(6125),
    [anon_sym_LBRACK] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6129),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_6] = ACTIONS(6131),
    [anon_sym_7] = ACTIONS(6133),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6137),
  },
  [2543] = {
    [sym_integer] = STATE(7581),
    [sym__literal] = STATE(7581),
    [sym__unboxed_open] = STATE(2145),
    [sym_constructor] = STATE(7303),
    [sym_con_unit] = STATE(7581),
    [sym_con_list] = STATE(7581),
    [sym_con_tuple] = STATE(7581),
    [sym_qualified_type] = STATE(7348),
    [sym_tycon_arrow] = STATE(7348),
    [sym_type_literal] = STATE(2754),
    [sym__promoted_tycon] = STATE(7348),
    [sym_type_variable] = STATE(7348),
    [sym_annotated_type_variable] = STATE(7348),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14002),
    [sym_type_parens] = STATE(2754),
    [sym_type_list] = STATE(2754),
    [sym_type_tuple] = STATE(2754),
    [sym__type_promotable_literal] = STATE(2754),
    [sym__type_promoted_literal] = STATE(2754),
    [sym__type_literal] = STATE(2754),
    [sym_type_name] = STATE(2750),
    [sym_type_star] = STATE(2754),
    [sym_type_unboxed_tuple] = STATE(2754),
    [sym_type_unboxed_sum] = STATE(2754),
    [sym__atype] = STATE(2754),
    [sym_type_apply] = STATE(8239),
    [sym__btype] = STATE(8239),
    [sym_type_infix] = STATE(12660),
    [sym__type_infix] = STATE(12425),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2584),
    [sym__type_quantifiers] = STATE(14752),
    [sym__type_context] = STATE(14752),
    [sym__type_fun] = STATE(14752),
    [sym__type] = STATE(14752),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14983),
    [sym_splice] = STATE(2754),
    [sym_quasiquote] = STATE(2754),
    [sym__varid] = ACTIONS(6111),
    [sym_float] = ACTIONS(6113),
    [sym_char] = ACTIONS(6113),
    [sym_string] = ACTIONS(6113),
    [sym__integer_literal] = ACTIONS(6115),
    [sym__binary_literal] = ACTIONS(6117),
    [sym__octal_literal] = ACTIONS(6117),
    [sym__hex_literal] = ACTIONS(6117),
    [anon_sym_LPAREN_POUND] = ACTIONS(6119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6119),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [sym__conid] = ACTIONS(6125),
    [anon_sym_LBRACK] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6129),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_6] = ACTIONS(6131),
    [anon_sym_7] = ACTIONS(6133),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6137),
  },
  [2544] = {
    [sym_integer] = STATE(6592),
    [sym__literal] = STATE(6592),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6403),
    [sym_con_unit] = STATE(6592),
    [sym_con_list] = STATE(6592),
    [sym_con_tuple] = STATE(6592),
    [sym_qualified_type] = STATE(6680),
    [sym_tycon_arrow] = STATE(6680),
    [sym_type_literal] = STATE(2491),
    [sym__promoted_tycon] = STATE(6680),
    [sym_type_variable] = STATE(6680),
    [sym_annotated_type_variable] = STATE(6680),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14515),
    [sym_type_parens] = STATE(2491),
    [sym_type_list] = STATE(2491),
    [sym_type_tuple] = STATE(2491),
    [sym__type_promotable_literal] = STATE(2491),
    [sym__type_promoted_literal] = STATE(2491),
    [sym__type_literal] = STATE(2491),
    [sym_type_name] = STATE(2480),
    [sym_type_star] = STATE(2491),
    [sym_type_unboxed_tuple] = STATE(2491),
    [sym_type_unboxed_sum] = STATE(2491),
    [sym__atype] = STATE(2491),
    [sym_type_apply] = STATE(7807),
    [sym__btype] = STATE(7807),
    [sym_type_infix] = STATE(11549),
    [sym__type_infix] = STATE(12168),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2544),
    [sym__type_quantifiers] = STATE(14582),
    [sym__type_context] = STATE(14582),
    [sym__type_fun] = STATE(14582),
    [sym__type] = STATE(14582),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14854),
    [sym_splice] = STATE(2491),
    [sym_quasiquote] = STATE(2491),
    [sym__varid] = ACTIONS(6304),
    [sym_float] = ACTIONS(6306),
    [sym_char] = ACTIONS(6306),
    [sym_string] = ACTIONS(6306),
    [sym__integer_literal] = ACTIONS(6308),
    [sym__binary_literal] = ACTIONS(6310),
    [sym__octal_literal] = ACTIONS(6310),
    [sym__hex_literal] = ACTIONS(6310),
    [anon_sym_LPAREN_POUND] = ACTIONS(6312),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6312),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6314),
    [sym__conid] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_6] = ACTIONS(6324),
    [anon_sym_7] = ACTIONS(6326),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6328),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6330),
  },
  [2545] = {
    [sym_integer] = STATE(5783),
    [sym__literal] = STATE(5783),
    [sym__unboxed_open] = STATE(2171),
    [sym_constructor] = STATE(5543),
    [sym_con_unit] = STATE(5783),
    [sym_con_list] = STATE(5783),
    [sym_con_tuple] = STATE(5783),
    [sym_qualified_type] = STATE(5773),
    [sym_tycon_arrow] = STATE(5773),
    [sym_type_literal] = STATE(2345),
    [sym__promoted_tycon] = STATE(5773),
    [sym_type_variable] = STATE(5773),
    [sym_annotated_type_variable] = STATE(5773),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14056),
    [sym_type_parens] = STATE(2345),
    [sym_type_list] = STATE(2345),
    [sym_type_tuple] = STATE(2345),
    [sym__type_promotable_literal] = STATE(2345),
    [sym__type_promoted_literal] = STATE(2345),
    [sym__type_literal] = STATE(2345),
    [sym_type_name] = STATE(2330),
    [sym_type_star] = STATE(2345),
    [sym_type_unboxed_tuple] = STATE(2345),
    [sym_type_unboxed_sum] = STATE(2345),
    [sym__atype] = STATE(2345),
    [sym_type_apply] = STATE(7063),
    [sym__btype] = STATE(7063),
    [sym_type_infix] = STATE(9520),
    [sym__type_infix] = STATE(9485),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2545),
    [sym__type_quantifiers] = STATE(10153),
    [sym__type_context] = STATE(10153),
    [sym__type_fun] = STATE(10153),
    [sym__type] = STATE(10153),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15397),
    [sym_splice] = STATE(2345),
    [sym_quasiquote] = STATE(2345),
    [sym__varid] = ACTIONS(6030),
    [sym_float] = ACTIONS(5916),
    [sym_char] = ACTIONS(5916),
    [sym_string] = ACTIONS(5916),
    [sym__integer_literal] = ACTIONS(5918),
    [sym__binary_literal] = ACTIONS(5920),
    [sym__octal_literal] = ACTIONS(5920),
    [sym__hex_literal] = ACTIONS(5920),
    [anon_sym_LPAREN_POUND] = ACTIONS(5922),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5922),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6032),
    [sym__conid] = ACTIONS(6036),
    [anon_sym_LBRACK] = ACTIONS(5929),
    [anon_sym_SQUOTE] = ACTIONS(6038),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5934),
    [anon_sym_6] = ACTIONS(5934),
    [anon_sym_7] = ACTIONS(5936),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5938),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5940),
  },
  [2546] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(2419),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(16124),
    [sym_lazy_type] = STATE(16124),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9510),
    [sym__btype] = STATE(9510),
    [sym_type_infix] = STATE(15079),
    [sym__type_infix] = STATE(16124),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2801),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_data_constructor] = STATE(14246),
    [sym_data_constructor_infix] = STATE(14246),
    [sym_data_constructor_record] = STATE(14246),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(8063),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5371),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5316),
    [sym__lazy] = ACTIONS(5318),
  },
  [2547] = {
    [sym_integer] = STATE(6228),
    [sym__literal] = STATE(6228),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(5787),
    [sym_con_unit] = STATE(6228),
    [sym_con_list] = STATE(6228),
    [sym_con_tuple] = STATE(6228),
    [sym_qualified_type] = STATE(6115),
    [sym_tycon_arrow] = STATE(6115),
    [sym_type_literal] = STATE(2385),
    [sym__promoted_tycon] = STATE(6115),
    [sym_type_variable] = STATE(6115),
    [sym_annotated_type_variable] = STATE(6115),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14177),
    [sym_type_parens] = STATE(2385),
    [sym_type_list] = STATE(2385),
    [sym_type_tuple] = STATE(2385),
    [sym__type_promotable_literal] = STATE(2385),
    [sym__type_promoted_literal] = STATE(2385),
    [sym__type_literal] = STATE(2385),
    [sym_type_name] = STATE(2427),
    [sym_type_star] = STATE(2385),
    [sym_type_unboxed_tuple] = STATE(2385),
    [sym_type_unboxed_sum] = STATE(2385),
    [sym__atype] = STATE(2385),
    [sym_type_apply] = STATE(7511),
    [sym__btype] = STATE(7511),
    [sym_type_infix] = STATE(9687),
    [sym__type_infix] = STATE(9538),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2547),
    [sym__type_quantifiers] = STATE(11732),
    [sym__type_context] = STATE(11732),
    [sym__type_fun] = STATE(11732),
    [sym__type] = STATE(11732),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15408),
    [sym_splice] = STATE(2385),
    [sym_quasiquote] = STATE(2385),
    [sym__varid] = ACTIONS(6195),
    [sym_float] = ACTIONS(6197),
    [sym_char] = ACTIONS(6197),
    [sym_string] = ACTIONS(6197),
    [sym__integer_literal] = ACTIONS(6199),
    [sym__binary_literal] = ACTIONS(6201),
    [sym__octal_literal] = ACTIONS(6201),
    [sym__hex_literal] = ACTIONS(6201),
    [anon_sym_LPAREN_POUND] = ACTIONS(6203),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6203),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6205),
    [sym__conid] = ACTIONS(6209),
    [anon_sym_LBRACK] = ACTIONS(6211),
    [anon_sym_SQUOTE] = ACTIONS(6213),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6215),
    [anon_sym_6] = ACTIONS(6215),
    [anon_sym_7] = ACTIONS(6217),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6219),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6221),
  },
  [2548] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14374),
    [sym__type_context] = STATE(14374),
    [sym__type_fun] = STATE(14374),
    [sym__type] = STATE(14374),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
  },
  [2549] = {
    [sym_integer] = STATE(7278),
    [sym__literal] = STATE(7278),
    [sym__unboxed_open] = STATE(2178),
    [sym_constructor] = STATE(6843),
    [sym_con_unit] = STATE(7278),
    [sym_con_list] = STATE(7278),
    [sym_con_tuple] = STATE(7278),
    [sym_qualified_type] = STATE(7262),
    [sym_tycon_arrow] = STATE(7262),
    [sym_type_literal] = STATE(2679),
    [sym__promoted_tycon] = STATE(7262),
    [sym_type_variable] = STATE(7262),
    [sym_annotated_type_variable] = STATE(7262),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14152),
    [sym_type_parens] = STATE(2679),
    [sym_type_list] = STATE(2679),
    [sym_type_tuple] = STATE(2679),
    [sym__type_promotable_literal] = STATE(2679),
    [sym__type_promoted_literal] = STATE(2679),
    [sym__type_literal] = STATE(2679),
    [sym_type_name] = STATE(2687),
    [sym_type_star] = STATE(2679),
    [sym_type_unboxed_tuple] = STATE(2679),
    [sym_type_unboxed_sum] = STATE(2679),
    [sym__atype] = STATE(2679),
    [sym_type_apply] = STATE(8109),
    [sym__btype] = STATE(8109),
    [sym_type_infix] = STATE(12317),
    [sym__type_infix] = STATE(12203),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2549),
    [sym__type_quantifiers] = STATE(14101),
    [sym__type_context] = STATE(14101),
    [sym__type_fun] = STATE(14101),
    [sym__type] = STATE(14101),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15295),
    [sym_splice] = STATE(2679),
    [sym_quasiquote] = STATE(2679),
    [sym__varid] = ACTIONS(6929),
    [sym_float] = ACTIONS(6931),
    [sym_char] = ACTIONS(6931),
    [sym_string] = ACTIONS(6931),
    [sym__integer_literal] = ACTIONS(6933),
    [sym__binary_literal] = ACTIONS(6935),
    [sym__octal_literal] = ACTIONS(6935),
    [sym__hex_literal] = ACTIONS(6935),
    [anon_sym_LPAREN_POUND] = ACTIONS(6937),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6937),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6939),
    [sym__conid] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(6945),
    [anon_sym_SQUOTE] = ACTIONS(6947),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6949),
    [anon_sym_6] = ACTIONS(6949),
    [anon_sym_7] = ACTIONS(6951),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6953),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6955),
  },
  [2550] = {
    [sym_integer] = STATE(7008),
    [sym__literal] = STATE(7008),
    [sym__unboxed_open] = STATE(2147),
    [sym_constructor] = STATE(6715),
    [sym_con_unit] = STATE(7008),
    [sym_con_list] = STATE(7008),
    [sym_con_tuple] = STATE(7008),
    [sym_qualified_type] = STATE(6959),
    [sym_tycon_arrow] = STATE(6959),
    [sym_type_literal] = STATE(2557),
    [sym__promoted_tycon] = STATE(6959),
    [sym_type_variable] = STATE(6959),
    [sym_annotated_type_variable] = STATE(6959),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14030),
    [sym_type_parens] = STATE(2557),
    [sym_type_list] = STATE(2557),
    [sym_type_tuple] = STATE(2557),
    [sym__type_promotable_literal] = STATE(2557),
    [sym__type_promoted_literal] = STATE(2557),
    [sym__type_literal] = STATE(2557),
    [sym_type_name] = STATE(2622),
    [sym_type_star] = STATE(2557),
    [sym_type_unboxed_tuple] = STATE(2557),
    [sym_type_unboxed_sum] = STATE(2557),
    [sym__atype] = STATE(2557),
    [sym_type_apply] = STATE(7908),
    [sym__btype] = STATE(7908),
    [sym_type_infix] = STATE(10402),
    [sym__type_infix] = STATE(10136),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2563),
    [sym__type_quantifiers] = STATE(11998),
    [sym__type_context] = STATE(11998),
    [sym__type_fun] = STATE(11998),
    [sym__type] = STATE(11998),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14702),
    [sym_splice] = STATE(2557),
    [sym_quasiquote] = STATE(2557),
    [sym__varid] = ACTIONS(6776),
    [sym_float] = ACTIONS(6778),
    [sym_char] = ACTIONS(6778),
    [sym_string] = ACTIONS(6778),
    [sym__integer_literal] = ACTIONS(6780),
    [sym__binary_literal] = ACTIONS(6782),
    [sym__octal_literal] = ACTIONS(6782),
    [sym__hex_literal] = ACTIONS(6782),
    [anon_sym_LPAREN_POUND] = ACTIONS(6784),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6784),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [sym__conid] = ACTIONS(6790),
    [anon_sym_LBRACK] = ACTIONS(6792),
    [anon_sym_SQUOTE] = ACTIONS(6794),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6796),
    [anon_sym_6] = ACTIONS(6796),
    [anon_sym_7] = ACTIONS(6798),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6800),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6802),
  },
  [2551] = {
    [sym_integer] = STATE(6592),
    [sym__literal] = STATE(6592),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6403),
    [sym_con_unit] = STATE(6592),
    [sym_con_list] = STATE(6592),
    [sym_con_tuple] = STATE(6592),
    [sym_qualified_type] = STATE(6680),
    [sym_tycon_arrow] = STATE(6680),
    [sym_type_literal] = STATE(2491),
    [sym__promoted_tycon] = STATE(6680),
    [sym_type_variable] = STATE(6680),
    [sym_annotated_type_variable] = STATE(6680),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14515),
    [sym_type_parens] = STATE(2491),
    [sym_type_list] = STATE(2491),
    [sym_type_tuple] = STATE(2491),
    [sym__type_promotable_literal] = STATE(2491),
    [sym__type_promoted_literal] = STATE(2491),
    [sym__type_literal] = STATE(2491),
    [sym_type_name] = STATE(2480),
    [sym_type_star] = STATE(2491),
    [sym_type_unboxed_tuple] = STATE(2491),
    [sym_type_unboxed_sum] = STATE(2491),
    [sym__atype] = STATE(2491),
    [sym_type_apply] = STATE(7807),
    [sym__btype] = STATE(7807),
    [sym_type_infix] = STATE(11549),
    [sym__type_infix] = STATE(12168),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2544),
    [sym__type_quantifiers] = STATE(14568),
    [sym__type_context] = STATE(14568),
    [sym__type_fun] = STATE(14568),
    [sym__type] = STATE(14568),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14854),
    [sym_splice] = STATE(2491),
    [sym_quasiquote] = STATE(2491),
    [sym__varid] = ACTIONS(6304),
    [sym_float] = ACTIONS(6306),
    [sym_char] = ACTIONS(6306),
    [sym_string] = ACTIONS(6306),
    [sym__integer_literal] = ACTIONS(6308),
    [sym__binary_literal] = ACTIONS(6310),
    [sym__octal_literal] = ACTIONS(6310),
    [sym__hex_literal] = ACTIONS(6310),
    [anon_sym_LPAREN_POUND] = ACTIONS(6312),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6312),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6314),
    [sym__conid] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_6] = ACTIONS(6324),
    [anon_sym_7] = ACTIONS(6326),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6328),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6330),
  },
  [2552] = {
    [sym_integer] = STATE(7019),
    [sym__literal] = STATE(7019),
    [sym__unboxed_open] = STATE(2169),
    [sym_constructor] = STATE(6740),
    [sym_con_unit] = STATE(7019),
    [sym_con_list] = STATE(7019),
    [sym_con_tuple] = STATE(7019),
    [sym_qualified_type] = STATE(6980),
    [sym_tycon_arrow] = STATE(6980),
    [sym_type_literal] = STATE(2556),
    [sym__promoted_tycon] = STATE(6980),
    [sym_type_variable] = STATE(6980),
    [sym_annotated_type_variable] = STATE(6980),
    [sym_type_parens] = STATE(2556),
    [sym_type_list] = STATE(2556),
    [sym_type_tuple] = STATE(2556),
    [sym__type_promotable_literal] = STATE(2556),
    [sym__type_promoted_literal] = STATE(2556),
    [sym__type_literal] = STATE(2556),
    [sym_type_name] = STATE(2556),
    [sym_type_star] = STATE(2556),
    [sym_type_unboxed_tuple] = STATE(2556),
    [sym_type_unboxed_sum] = STATE(2556),
    [sym__atype] = STATE(2556),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14684),
    [sym_splice] = STATE(2556),
    [sym_quasiquote] = STATE(2556),
    [aux_sym_type_apply_repeat1] = STATE(2556),
    [sym__varid] = ACTIONS(8275),
    [sym_float] = ACTIONS(6561),
    [sym_char] = ACTIONS(6561),
    [sym_string] = ACTIONS(6561),
    [sym__integer_literal] = ACTIONS(6563),
    [sym__binary_literal] = ACTIONS(6565),
    [sym__octal_literal] = ACTIONS(6565),
    [sym__hex_literal] = ACTIONS(6565),
    [anon_sym_LPAREN_POUND] = ACTIONS(6567),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6567),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(8277),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(8279),
    [anon_sym_LBRACK] = ACTIONS(6575),
    [anon_sym_SQUOTE] = ACTIONS(8282),
    [anon_sym_STAR] = ACTIONS(6579),
    [anon_sym_6] = ACTIONS(6579),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(6581),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6583),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5078),
    [sym_quasiquote_start] = ACTIONS(6585),
    [sym__unboxed_close] = ACTIONS(5078),
  },
  [2553] = {
    [sym_integer] = STATE(7008),
    [sym__literal] = STATE(7008),
    [sym__unboxed_open] = STATE(2147),
    [sym_constructor] = STATE(6715),
    [sym_con_unit] = STATE(7008),
    [sym_con_list] = STATE(7008),
    [sym_con_tuple] = STATE(7008),
    [sym_qualified_type] = STATE(6959),
    [sym_tycon_arrow] = STATE(6959),
    [sym_type_literal] = STATE(2557),
    [sym__promoted_tycon] = STATE(6959),
    [sym_type_variable] = STATE(6959),
    [sym_annotated_type_variable] = STATE(6959),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14030),
    [sym_type_parens] = STATE(2557),
    [sym_type_list] = STATE(2557),
    [sym_type_tuple] = STATE(2557),
    [sym__type_promotable_literal] = STATE(2557),
    [sym__type_promoted_literal] = STATE(2557),
    [sym__type_literal] = STATE(2557),
    [sym_type_name] = STATE(2622),
    [sym_type_star] = STATE(2557),
    [sym_type_unboxed_tuple] = STATE(2557),
    [sym_type_unboxed_sum] = STATE(2557),
    [sym__atype] = STATE(2557),
    [sym_type_apply] = STATE(7908),
    [sym__btype] = STATE(7908),
    [sym_type_infix] = STATE(10402),
    [sym__type_infix] = STATE(10136),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2563),
    [sym__type_quantifiers] = STATE(11996),
    [sym__type_context] = STATE(11996),
    [sym__type_fun] = STATE(11996),
    [sym__type] = STATE(11996),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14702),
    [sym_splice] = STATE(2557),
    [sym_quasiquote] = STATE(2557),
    [sym__varid] = ACTIONS(6776),
    [sym_float] = ACTIONS(6778),
    [sym_char] = ACTIONS(6778),
    [sym_string] = ACTIONS(6778),
    [sym__integer_literal] = ACTIONS(6780),
    [sym__binary_literal] = ACTIONS(6782),
    [sym__octal_literal] = ACTIONS(6782),
    [sym__hex_literal] = ACTIONS(6782),
    [anon_sym_LPAREN_POUND] = ACTIONS(6784),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6784),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [sym__conid] = ACTIONS(6790),
    [anon_sym_LBRACK] = ACTIONS(6792),
    [anon_sym_SQUOTE] = ACTIONS(6794),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6796),
    [anon_sym_6] = ACTIONS(6796),
    [anon_sym_7] = ACTIONS(6798),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6800),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6802),
  },
  [2554] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(2445),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(16310),
    [sym_lazy_type] = STATE(16310),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9510),
    [sym__btype] = STATE(9510),
    [sym_type_infix] = STATE(15079),
    [sym__type_infix] = STATE(16310),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2800),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_data_constructor] = STATE(14289),
    [sym_data_constructor_infix] = STATE(14289),
    [sym_data_constructor_record] = STATE(14289),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(8063),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5359),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5316),
    [sym__lazy] = ACTIONS(5318),
  },
  [2555] = {
    [sym_integer] = STATE(7627),
    [sym__literal] = STATE(7627),
    [sym__unboxed_open] = STATE(2122),
    [sym_constructor] = STATE(7422),
    [sym_con_unit] = STATE(7627),
    [sym_con_list] = STATE(7627),
    [sym_con_tuple] = STATE(7627),
    [sym_qualified_type] = STATE(7693),
    [sym_tycon_arrow] = STATE(7693),
    [sym_type_literal] = STATE(2767),
    [sym__promoted_tycon] = STATE(7693),
    [sym_type_variable] = STATE(7693),
    [sym_annotated_type_variable] = STATE(7693),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14352),
    [sym_type_parens] = STATE(2767),
    [sym_type_list] = STATE(2767),
    [sym_type_tuple] = STATE(2767),
    [sym__type_promotable_literal] = STATE(2767),
    [sym__type_promoted_literal] = STATE(2767),
    [sym__type_literal] = STATE(2767),
    [sym_type_name] = STATE(2768),
    [sym_type_star] = STATE(2767),
    [sym_type_unboxed_tuple] = STATE(2767),
    [sym_type_unboxed_sum] = STATE(2767),
    [sym__atype] = STATE(2767),
    [sym_type_apply] = STATE(8575),
    [sym__btype] = STATE(8575),
    [sym_type_infix] = STATE(13054),
    [sym__type_infix] = STATE(12674),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2518),
    [sym__type_quantifiers] = STATE(14384),
    [sym__type_context] = STATE(14384),
    [sym__type_fun] = STATE(14384),
    [sym__type] = STATE(14384),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15142),
    [sym_splice] = STATE(2767),
    [sym_quasiquote] = STATE(2767),
    [sym__varid] = ACTIONS(5407),
    [sym_float] = ACTIONS(5409),
    [sym_char] = ACTIONS(5409),
    [sym_string] = ACTIONS(5409),
    [sym__integer_literal] = ACTIONS(5411),
    [sym__binary_literal] = ACTIONS(5413),
    [sym__octal_literal] = ACTIONS(5413),
    [sym__hex_literal] = ACTIONS(5413),
    [anon_sym_LPAREN_POUND] = ACTIONS(5415),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5415),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5417),
    [sym__conid] = ACTIONS(5421),
    [anon_sym_LBRACK] = ACTIONS(5423),
    [anon_sym_SQUOTE] = ACTIONS(5425),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5427),
    [anon_sym_6] = ACTIONS(5427),
    [anon_sym_7] = ACTIONS(5429),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5431),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5433),
  },
  [2556] = {
    [sym_integer] = STATE(7019),
    [sym__literal] = STATE(7019),
    [sym__unboxed_open] = STATE(2169),
    [sym_constructor] = STATE(6740),
    [sym_con_unit] = STATE(7019),
    [sym_con_list] = STATE(7019),
    [sym_con_tuple] = STATE(7019),
    [sym_qualified_type] = STATE(6980),
    [sym_tycon_arrow] = STATE(6980),
    [sym_type_literal] = STATE(2627),
    [sym__promoted_tycon] = STATE(6980),
    [sym_type_variable] = STATE(6980),
    [sym_annotated_type_variable] = STATE(6980),
    [sym_type_parens] = STATE(2627),
    [sym_type_list] = STATE(2627),
    [sym_type_tuple] = STATE(2627),
    [sym__type_promotable_literal] = STATE(2627),
    [sym__type_promoted_literal] = STATE(2627),
    [sym__type_literal] = STATE(2627),
    [sym_type_name] = STATE(2627),
    [sym_type_star] = STATE(2627),
    [sym_type_unboxed_tuple] = STATE(2627),
    [sym_type_unboxed_sum] = STATE(2627),
    [sym__atype] = STATE(2627),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14684),
    [sym_splice] = STATE(2627),
    [sym_quasiquote] = STATE(2627),
    [aux_sym_type_apply_repeat1] = STATE(2627),
    [sym__varid] = ACTIONS(8275),
    [sym_float] = ACTIONS(6561),
    [sym_char] = ACTIONS(6561),
    [sym_string] = ACTIONS(6561),
    [sym__integer_literal] = ACTIONS(6563),
    [sym__binary_literal] = ACTIONS(6565),
    [sym__octal_literal] = ACTIONS(6565),
    [sym__hex_literal] = ACTIONS(6565),
    [anon_sym_LPAREN_POUND] = ACTIONS(6567),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6567),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(8277),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(8285),
    [anon_sym_LBRACK] = ACTIONS(6575),
    [anon_sym_SQUOTE] = ACTIONS(8288),
    [anon_sym_STAR] = ACTIONS(6579),
    [anon_sym_6] = ACTIONS(6579),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(6581),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6583),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5177),
    [sym_quasiquote_start] = ACTIONS(6585),
    [sym__unboxed_close] = ACTIONS(5177),
  },
  [2557] = {
    [sym_integer] = STATE(7008),
    [sym__literal] = STATE(7008),
    [sym__unboxed_open] = STATE(2147),
    [sym_constructor] = STATE(6715),
    [sym_con_unit] = STATE(7008),
    [sym_con_list] = STATE(7008),
    [sym_con_tuple] = STATE(7008),
    [sym_qualified_type] = STATE(6959),
    [sym_tycon_arrow] = STATE(6959),
    [sym_type_literal] = STATE(2558),
    [sym__promoted_tycon] = STATE(6959),
    [sym_type_variable] = STATE(6959),
    [sym_annotated_type_variable] = STATE(6959),
    [sym_type_parens] = STATE(2558),
    [sym_type_list] = STATE(2558),
    [sym_type_tuple] = STATE(2558),
    [sym__type_promotable_literal] = STATE(2558),
    [sym__type_promoted_literal] = STATE(2558),
    [sym__type_literal] = STATE(2558),
    [sym_type_name] = STATE(2558),
    [sym_type_star] = STATE(2558),
    [sym_type_unboxed_tuple] = STATE(2558),
    [sym_type_unboxed_sum] = STATE(2558),
    [sym__atype] = STATE(2558),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14702),
    [sym_splice] = STATE(2558),
    [sym_quasiquote] = STATE(2558),
    [aux_sym_type_apply_repeat1] = STATE(2558),
    [sym__varid] = ACTIONS(8291),
    [sym_float] = ACTIONS(6778),
    [sym_char] = ACTIONS(6778),
    [sym_string] = ACTIONS(6778),
    [sym__integer_literal] = ACTIONS(6780),
    [sym__binary_literal] = ACTIONS(6782),
    [sym__octal_literal] = ACTIONS(6782),
    [sym__hex_literal] = ACTIONS(6782),
    [anon_sym_LPAREN_POUND] = ACTIONS(6784),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6784),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [anon_sym_4] = ACTIONS(5078),
    [anon_sym_COLON_COLON] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5100),
    [anon_sym_LPAREN] = ACTIONS(8293),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(8295),
    [anon_sym_LBRACK] = ACTIONS(6792),
    [anon_sym_SQUOTE] = ACTIONS(8298),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(6796),
    [anon_sym_6] = ACTIONS(6796),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(6798),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6800),
    [sym__varsym] = ACTIONS(5078),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6802),
    [sym__unboxed_close] = ACTIONS(5078),
  },
  [2558] = {
    [sym_integer] = STATE(7008),
    [sym__literal] = STATE(7008),
    [sym__unboxed_open] = STATE(2147),
    [sym_constructor] = STATE(6715),
    [sym_con_unit] = STATE(7008),
    [sym_con_list] = STATE(7008),
    [sym_con_tuple] = STATE(7008),
    [sym_qualified_type] = STATE(6959),
    [sym_tycon_arrow] = STATE(6959),
    [sym_type_literal] = STATE(2641),
    [sym__promoted_tycon] = STATE(6959),
    [sym_type_variable] = STATE(6959),
    [sym_annotated_type_variable] = STATE(6959),
    [sym_type_parens] = STATE(2641),
    [sym_type_list] = STATE(2641),
    [sym_type_tuple] = STATE(2641),
    [sym__type_promotable_literal] = STATE(2641),
    [sym__type_promoted_literal] = STATE(2641),
    [sym__type_literal] = STATE(2641),
    [sym_type_name] = STATE(2641),
    [sym_type_star] = STATE(2641),
    [sym_type_unboxed_tuple] = STATE(2641),
    [sym_type_unboxed_sum] = STATE(2641),
    [sym__atype] = STATE(2641),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14702),
    [sym_splice] = STATE(2641),
    [sym_quasiquote] = STATE(2641),
    [aux_sym_type_apply_repeat1] = STATE(2641),
    [sym__varid] = ACTIONS(8291),
    [sym_float] = ACTIONS(6778),
    [sym_char] = ACTIONS(6778),
    [sym_string] = ACTIONS(6778),
    [sym__integer_literal] = ACTIONS(6780),
    [sym__binary_literal] = ACTIONS(6782),
    [sym__octal_literal] = ACTIONS(6782),
    [sym__hex_literal] = ACTIONS(6782),
    [anon_sym_LPAREN_POUND] = ACTIONS(6784),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6784),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [anon_sym_4] = ACTIONS(5177),
    [anon_sym_COLON_COLON] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(8293),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(8301),
    [anon_sym_LBRACK] = ACTIONS(6792),
    [anon_sym_SQUOTE] = ACTIONS(8304),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(6796),
    [anon_sym_6] = ACTIONS(6796),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(6798),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6800),
    [sym__varsym] = ACTIONS(5177),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6802),
    [sym__unboxed_close] = ACTIONS(5177),
  },
  [2559] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(18334),
    [sym__type_context] = STATE(18334),
    [sym__type_fun] = STATE(18334),
    [sym__type] = STATE(18334),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2560] = {
    [sym_integer] = STATE(7208),
    [sym__literal] = STATE(7208),
    [sym__unboxed_open] = STATE(2156),
    [sym_constructor] = STATE(6817),
    [sym_con_unit] = STATE(7208),
    [sym_con_list] = STATE(7208),
    [sym_con_tuple] = STATE(7208),
    [sym_qualified_type] = STATE(7291),
    [sym_tycon_arrow] = STATE(7291),
    [sym_type_literal] = STATE(2699),
    [sym__promoted_tycon] = STATE(7291),
    [sym_type_variable] = STATE(7291),
    [sym_annotated_type_variable] = STATE(7291),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14074),
    [sym_type_parens] = STATE(2699),
    [sym_type_list] = STATE(2699),
    [sym_type_tuple] = STATE(2699),
    [sym__type_promotable_literal] = STATE(2699),
    [sym__type_promoted_literal] = STATE(2699),
    [sym__type_literal] = STATE(2699),
    [sym_type_name] = STATE(2693),
    [sym_type_star] = STATE(2699),
    [sym_type_unboxed_tuple] = STATE(2699),
    [sym_type_unboxed_sum] = STATE(2699),
    [sym__atype] = STATE(2699),
    [sym_type_apply] = STATE(8012),
    [sym__btype] = STATE(8012),
    [sym_type_infix] = STATE(12364),
    [sym__type_infix] = STATE(12056),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2560),
    [sym__type_quantifiers] = STATE(14189),
    [sym__type_context] = STATE(14189),
    [sym__type_fun] = STATE(14189),
    [sym__type] = STATE(14189),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14826),
    [sym_splice] = STATE(2699),
    [sym_quasiquote] = STATE(2699),
    [sym__varid] = ACTIONS(6436),
    [sym_float] = ACTIONS(6438),
    [sym_char] = ACTIONS(6438),
    [sym_string] = ACTIONS(6438),
    [sym__integer_literal] = ACTIONS(6440),
    [sym__binary_literal] = ACTIONS(6442),
    [sym__octal_literal] = ACTIONS(6442),
    [sym__hex_literal] = ACTIONS(6442),
    [anon_sym_LPAREN_POUND] = ACTIONS(6444),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6444),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6446),
    [sym__conid] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_6] = ACTIONS(6456),
    [anon_sym_7] = ACTIONS(6458),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6460),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6462),
  },
  [2561] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14412),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(12341),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2561),
    [sym__type_quantifiers] = STATE(15106),
    [sym__type_context] = STATE(15106),
    [sym__type_fun] = STATE(15106),
    [sym__type] = STATE(15106),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(5274),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
  },
  [2562] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(10312),
    [sym__type_context] = STATE(10312),
    [sym__type_fun] = STATE(10312),
    [sym__type] = STATE(10312),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2563] = {
    [sym_integer] = STATE(7008),
    [sym__literal] = STATE(7008),
    [sym__unboxed_open] = STATE(2147),
    [sym_constructor] = STATE(6715),
    [sym_con_unit] = STATE(7008),
    [sym_con_list] = STATE(7008),
    [sym_con_tuple] = STATE(7008),
    [sym_qualified_type] = STATE(6959),
    [sym_tycon_arrow] = STATE(6959),
    [sym_type_literal] = STATE(2557),
    [sym__promoted_tycon] = STATE(6959),
    [sym_type_variable] = STATE(6959),
    [sym_annotated_type_variable] = STATE(6959),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14030),
    [sym_type_parens] = STATE(2557),
    [sym_type_list] = STATE(2557),
    [sym_type_tuple] = STATE(2557),
    [sym__type_promotable_literal] = STATE(2557),
    [sym__type_promoted_literal] = STATE(2557),
    [sym__type_literal] = STATE(2557),
    [sym_type_name] = STATE(2622),
    [sym_type_star] = STATE(2557),
    [sym_type_unboxed_tuple] = STATE(2557),
    [sym_type_unboxed_sum] = STATE(2557),
    [sym__atype] = STATE(2557),
    [sym_type_apply] = STATE(7908),
    [sym__btype] = STATE(7908),
    [sym_type_infix] = STATE(10402),
    [sym__type_infix] = STATE(10136),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2563),
    [sym__type_quantifiers] = STATE(12004),
    [sym__type_context] = STATE(12004),
    [sym__type_fun] = STATE(12004),
    [sym__type] = STATE(12004),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14702),
    [sym_splice] = STATE(2557),
    [sym_quasiquote] = STATE(2557),
    [sym__varid] = ACTIONS(6776),
    [sym_float] = ACTIONS(6778),
    [sym_char] = ACTIONS(6778),
    [sym_string] = ACTIONS(6778),
    [sym__integer_literal] = ACTIONS(6780),
    [sym__binary_literal] = ACTIONS(6782),
    [sym__octal_literal] = ACTIONS(6782),
    [sym__hex_literal] = ACTIONS(6782),
    [anon_sym_LPAREN_POUND] = ACTIONS(6784),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6784),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6786),
    [sym__conid] = ACTIONS(6790),
    [anon_sym_LBRACK] = ACTIONS(6792),
    [anon_sym_SQUOTE] = ACTIONS(6794),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6796),
    [anon_sym_6] = ACTIONS(6796),
    [anon_sym_7] = ACTIONS(6798),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6800),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6802),
  },
  [2564] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14412),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(12341),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2561),
    [sym__type_quantifiers] = STATE(15136),
    [sym__type_context] = STATE(15136),
    [sym__type_fun] = STATE(15136),
    [sym__type] = STATE(15136),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(5274),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
  },
  [2565] = {
    [sym_integer] = STATE(6064),
    [sym__literal] = STATE(6064),
    [sym__unboxed_open] = STATE(2150),
    [sym_constructor] = STATE(5877),
    [sym_con_unit] = STATE(6064),
    [sym_con_list] = STATE(6064),
    [sym_con_tuple] = STATE(6064),
    [sym_qualified_type] = STATE(6066),
    [sym_tycon_arrow] = STATE(6066),
    [sym_type_literal] = STATE(2376),
    [sym__promoted_tycon] = STATE(6066),
    [sym_type_variable] = STATE(6066),
    [sym_annotated_type_variable] = STATE(6066),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14102),
    [sym_type_parens] = STATE(2376),
    [sym_type_list] = STATE(2376),
    [sym_type_tuple] = STATE(2376),
    [sym__type_promotable_literal] = STATE(2376),
    [sym__type_promoted_literal] = STATE(2376),
    [sym__type_literal] = STATE(2376),
    [sym_type_name] = STATE(2389),
    [sym_type_star] = STATE(2376),
    [sym_type_unboxed_tuple] = STATE(2376),
    [sym_type_unboxed_sum] = STATE(2376),
    [sym__atype] = STATE(2376),
    [sym_type_apply] = STATE(7487),
    [sym__btype] = STATE(7487),
    [sym_type_infix] = STATE(9707),
    [sym__type_infix] = STATE(9579),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2513),
    [sym__type_quantifiers] = STATE(11873),
    [sym__type_context] = STATE(11873),
    [sym__type_fun] = STATE(11873),
    [sym__type] = STATE(11873),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14778),
    [sym_splice] = STATE(2376),
    [sym_quasiquote] = STATE(2376),
    [sym__varid] = ACTIONS(7108),
    [sym_float] = ACTIONS(6278),
    [sym_char] = ACTIONS(6278),
    [sym_string] = ACTIONS(6278),
    [sym__integer_literal] = ACTIONS(6280),
    [sym__binary_literal] = ACTIONS(6282),
    [sym__octal_literal] = ACTIONS(6282),
    [sym__hex_literal] = ACTIONS(6282),
    [anon_sym_LPAREN_POUND] = ACTIONS(6284),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6284),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7110),
    [sym__conid] = ACTIONS(7114),
    [anon_sym_LBRACK] = ACTIONS(6291),
    [anon_sym_SQUOTE] = ACTIONS(7116),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6296),
    [anon_sym_6] = ACTIONS(6296),
    [anon_sym_7] = ACTIONS(6298),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6300),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6302),
  },
  [2566] = {
    [sym_integer] = STATE(5892),
    [sym__literal] = STATE(5892),
    [sym__unboxed_open] = STATE(2185),
    [sym_constructor] = STATE(5658),
    [sym_con_unit] = STATE(5892),
    [sym_con_list] = STATE(5892),
    [sym_con_tuple] = STATE(5892),
    [sym_qualified_type] = STATE(5887),
    [sym_tycon_arrow] = STATE(5887),
    [sym_type_literal] = STATE(2295),
    [sym__promoted_tycon] = STATE(5887),
    [sym_type_variable] = STATE(5887),
    [sym_annotated_type_variable] = STATE(5887),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14262),
    [sym_type_parens] = STATE(2295),
    [sym_type_list] = STATE(2295),
    [sym_type_tuple] = STATE(2295),
    [sym__type_promotable_literal] = STATE(2295),
    [sym__type_promoted_literal] = STATE(2295),
    [sym__type_literal] = STATE(2295),
    [sym_type_name] = STATE(2351),
    [sym_type_star] = STATE(2295),
    [sym_type_unboxed_tuple] = STATE(2295),
    [sym_type_unboxed_sum] = STATE(2295),
    [sym__atype] = STATE(2295),
    [sym_type_apply] = STATE(7097),
    [sym__btype] = STATE(7097),
    [sym_type_infix] = STATE(9558),
    [sym__type_infix] = STATE(9459),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2511),
    [sym__type_quantifiers] = STATE(10922),
    [sym__type_context] = STATE(10922),
    [sym__type_fun] = STATE(10922),
    [sym__type] = STATE(10922),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15268),
    [sym_splice] = STATE(2295),
    [sym_quasiquote] = STATE(2295),
    [sym__varid] = ACTIONS(5796),
    [sym_float] = ACTIONS(5798),
    [sym_char] = ACTIONS(5798),
    [sym_string] = ACTIONS(5798),
    [sym__integer_literal] = ACTIONS(5800),
    [sym__binary_literal] = ACTIONS(5802),
    [sym__octal_literal] = ACTIONS(5802),
    [sym__hex_literal] = ACTIONS(5802),
    [anon_sym_LPAREN_POUND] = ACTIONS(5804),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5804),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7118),
    [sym__conid] = ACTIONS(7122),
    [anon_sym_LBRACK] = ACTIONS(5811),
    [anon_sym_SQUOTE] = ACTIONS(7124),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5816),
    [anon_sym_6] = ACTIONS(5816),
    [anon_sym_7] = ACTIONS(5818),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5822),
  },
  [2567] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14412),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(12341),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2561),
    [sym__type_quantifiers] = STATE(15030),
    [sym__type_context] = STATE(15030),
    [sym__type_fun] = STATE(15030),
    [sym__type] = STATE(15030),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(5274),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
  },
  [2568] = {
    [sym_integer] = STATE(6622),
    [sym__literal] = STATE(6622),
    [sym__unboxed_open] = STATE(2223),
    [sym_constructor] = STATE(6527),
    [sym_con_unit] = STATE(6622),
    [sym_con_list] = STATE(6622),
    [sym_con_tuple] = STATE(6622),
    [sym_qualified_type] = STATE(6611),
    [sym_tycon_arrow] = STATE(6611),
    [sym_type_literal] = STATE(2490),
    [sym__promoted_tycon] = STATE(6611),
    [sym_type_variable] = STATE(6611),
    [sym_annotated_type_variable] = STATE(6611),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14484),
    [sym_type_parens] = STATE(2490),
    [sym_type_list] = STATE(2490),
    [sym_type_tuple] = STATE(2490),
    [sym__type_promotable_literal] = STATE(2490),
    [sym__type_promoted_literal] = STATE(2490),
    [sym__type_literal] = STATE(2490),
    [sym_type_name] = STATE(2482),
    [sym_type_star] = STATE(2490),
    [sym_type_unboxed_tuple] = STATE(2490),
    [sym_type_unboxed_sum] = STATE(2490),
    [sym__atype] = STATE(2490),
    [sym_type_apply] = STATE(7827),
    [sym__btype] = STATE(7827),
    [sym_type_infix] = STATE(10085),
    [sym__type_infix] = STATE(9970),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2578),
    [sym__type_quantifiers] = STATE(12246),
    [sym__type_context] = STATE(12246),
    [sym__type_fun] = STATE(12246),
    [sym__type] = STATE(12246),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14645),
    [sym_splice] = STATE(2490),
    [sym_quasiquote] = STATE(2490),
    [sym__varid] = ACTIONS(7201),
    [sym_float] = ACTIONS(7203),
    [sym_char] = ACTIONS(7203),
    [sym_string] = ACTIONS(7203),
    [sym__integer_literal] = ACTIONS(7205),
    [sym__binary_literal] = ACTIONS(7207),
    [sym__octal_literal] = ACTIONS(7207),
    [sym__hex_literal] = ACTIONS(7207),
    [anon_sym_LPAREN_POUND] = ACTIONS(7209),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7209),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7211),
    [sym__conid] = ACTIONS(7215),
    [anon_sym_LBRACK] = ACTIONS(7217),
    [anon_sym_SQUOTE] = ACTIONS(7219),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7221),
    [anon_sym_6] = ACTIONS(7221),
    [anon_sym_7] = ACTIONS(7223),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7225),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7227),
  },
  [2569] = {
    [sym_integer] = STATE(7278),
    [sym__literal] = STATE(7278),
    [sym__unboxed_open] = STATE(2178),
    [sym_constructor] = STATE(6843),
    [sym_con_unit] = STATE(7278),
    [sym_con_list] = STATE(7278),
    [sym_con_tuple] = STATE(7278),
    [sym_qualified_type] = STATE(7262),
    [sym_tycon_arrow] = STATE(7262),
    [sym_type_literal] = STATE(2679),
    [sym__promoted_tycon] = STATE(7262),
    [sym_type_variable] = STATE(7262),
    [sym_annotated_type_variable] = STATE(7262),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14152),
    [sym_type_parens] = STATE(2679),
    [sym_type_list] = STATE(2679),
    [sym_type_tuple] = STATE(2679),
    [sym__type_promotable_literal] = STATE(2679),
    [sym__type_promoted_literal] = STATE(2679),
    [sym__type_literal] = STATE(2679),
    [sym_type_name] = STATE(2687),
    [sym_type_star] = STATE(2679),
    [sym_type_unboxed_tuple] = STATE(2679),
    [sym_type_unboxed_sum] = STATE(2679),
    [sym__atype] = STATE(2679),
    [sym_type_apply] = STATE(8109),
    [sym__btype] = STATE(8109),
    [sym_type_infix] = STATE(12317),
    [sym__type_infix] = STATE(12203),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2549),
    [sym__type_quantifiers] = STATE(14097),
    [sym__type_context] = STATE(14097),
    [sym__type_fun] = STATE(14097),
    [sym__type] = STATE(14097),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15295),
    [sym_splice] = STATE(2679),
    [sym_quasiquote] = STATE(2679),
    [sym__varid] = ACTIONS(6929),
    [sym_float] = ACTIONS(6931),
    [sym_char] = ACTIONS(6931),
    [sym_string] = ACTIONS(6931),
    [sym__integer_literal] = ACTIONS(6933),
    [sym__binary_literal] = ACTIONS(6935),
    [sym__octal_literal] = ACTIONS(6935),
    [sym__hex_literal] = ACTIONS(6935),
    [anon_sym_LPAREN_POUND] = ACTIONS(6937),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6937),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6939),
    [sym__conid] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(6945),
    [anon_sym_SQUOTE] = ACTIONS(6947),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6949),
    [anon_sym_6] = ACTIONS(6949),
    [anon_sym_7] = ACTIONS(6951),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6953),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6955),
  },
  [2570] = {
    [sym_integer] = STATE(7278),
    [sym__literal] = STATE(7278),
    [sym__unboxed_open] = STATE(2178),
    [sym_constructor] = STATE(6843),
    [sym_con_unit] = STATE(7278),
    [sym_con_list] = STATE(7278),
    [sym_con_tuple] = STATE(7278),
    [sym_qualified_type] = STATE(7262),
    [sym_tycon_arrow] = STATE(7262),
    [sym_type_literal] = STATE(2679),
    [sym__promoted_tycon] = STATE(7262),
    [sym_type_variable] = STATE(7262),
    [sym_annotated_type_variable] = STATE(7262),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14152),
    [sym_type_parens] = STATE(2679),
    [sym_type_list] = STATE(2679),
    [sym_type_tuple] = STATE(2679),
    [sym__type_promotable_literal] = STATE(2679),
    [sym__type_promoted_literal] = STATE(2679),
    [sym__type_literal] = STATE(2679),
    [sym_type_name] = STATE(2687),
    [sym_type_star] = STATE(2679),
    [sym_type_unboxed_tuple] = STATE(2679),
    [sym_type_unboxed_sum] = STATE(2679),
    [sym__atype] = STATE(2679),
    [sym_type_apply] = STATE(8109),
    [sym__btype] = STATE(8109),
    [sym_type_infix] = STATE(12317),
    [sym__type_infix] = STATE(12203),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2549),
    [sym__type_quantifiers] = STATE(14098),
    [sym__type_context] = STATE(14098),
    [sym__type_fun] = STATE(14098),
    [sym__type] = STATE(14098),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15295),
    [sym_splice] = STATE(2679),
    [sym_quasiquote] = STATE(2679),
    [sym__varid] = ACTIONS(6929),
    [sym_float] = ACTIONS(6931),
    [sym_char] = ACTIONS(6931),
    [sym_string] = ACTIONS(6931),
    [sym__integer_literal] = ACTIONS(6933),
    [sym__binary_literal] = ACTIONS(6935),
    [sym__octal_literal] = ACTIONS(6935),
    [sym__hex_literal] = ACTIONS(6935),
    [anon_sym_LPAREN_POUND] = ACTIONS(6937),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6937),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6939),
    [sym__conid] = ACTIONS(6943),
    [anon_sym_LBRACK] = ACTIONS(6945),
    [anon_sym_SQUOTE] = ACTIONS(6947),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6949),
    [anon_sym_6] = ACTIONS(6949),
    [anon_sym_7] = ACTIONS(6951),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6953),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6955),
  },
  [2571] = {
    [sym_integer] = STATE(7485),
    [sym__literal] = STATE(7485),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7295),
    [sym_con_unit] = STATE(7485),
    [sym_con_list] = STATE(7485),
    [sym_con_tuple] = STATE(7485),
    [sym_qualified_type] = STATE(7412),
    [sym_tycon_arrow] = STATE(7412),
    [sym_type_literal] = STATE(2753),
    [sym__promoted_tycon] = STATE(7412),
    [sym_type_variable] = STATE(7412),
    [sym_annotated_type_variable] = STATE(7412),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14444),
    [sym_type_parens] = STATE(2753),
    [sym_type_list] = STATE(2753),
    [sym_type_tuple] = STATE(2753),
    [sym__type_promotable_literal] = STATE(2753),
    [sym__type_promoted_literal] = STATE(2753),
    [sym__type_literal] = STATE(2753),
    [sym_type_name] = STATE(2737),
    [sym_type_star] = STATE(2753),
    [sym_type_unboxed_tuple] = STATE(2753),
    [sym_type_unboxed_sum] = STATE(2753),
    [sym__atype] = STATE(2753),
    [sym_type_apply] = STATE(8310),
    [sym__btype] = STATE(8310),
    [sym_type_infix] = STATE(12638),
    [sym__type_infix] = STATE(12387),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2571),
    [sym__type_quantifiers] = STATE(14690),
    [sym__type_context] = STATE(14690),
    [sym__type_fun] = STATE(14690),
    [sym__type] = STATE(14690),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14836),
    [sym_splice] = STATE(2753),
    [sym_quasiquote] = STATE(2753),
    [sym__varid] = ACTIONS(6002),
    [sym_float] = ACTIONS(6004),
    [sym_char] = ACTIONS(6004),
    [sym_string] = ACTIONS(6004),
    [sym__integer_literal] = ACTIONS(6006),
    [sym__binary_literal] = ACTIONS(6008),
    [sym__octal_literal] = ACTIONS(6008),
    [sym__hex_literal] = ACTIONS(6008),
    [anon_sym_LPAREN_POUND] = ACTIONS(6010),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6010),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6012),
    [sym__conid] = ACTIONS(6016),
    [anon_sym_LBRACK] = ACTIONS(6018),
    [anon_sym_SQUOTE] = ACTIONS(6020),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6022),
    [anon_sym_6] = ACTIONS(6022),
    [anon_sym_7] = ACTIONS(6024),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6026),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6028),
  },
  [2572] = {
    [sym_integer] = STATE(7818),
    [sym__literal] = STATE(7818),
    [sym__unboxed_open] = STATE(2165),
    [sym_constructor] = STATE(7684),
    [sym_con_unit] = STATE(7818),
    [sym_con_list] = STATE(7818),
    [sym_con_tuple] = STATE(7818),
    [sym_qualified_type] = STATE(7768),
    [sym_tycon_arrow] = STATE(7768),
    [sym_type_literal] = STATE(2799),
    [sym__promoted_tycon] = STATE(7768),
    [sym_type_variable] = STATE(7768),
    [sym_annotated_type_variable] = STATE(7768),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14565),
    [sym_type_parens] = STATE(2799),
    [sym_type_list] = STATE(2799),
    [sym_type_tuple] = STATE(2799),
    [sym__type_promotable_literal] = STATE(2799),
    [sym__type_promoted_literal] = STATE(2799),
    [sym__type_literal] = STATE(2799),
    [sym_type_name] = STATE(2788),
    [sym_type_star] = STATE(2799),
    [sym_type_unboxed_tuple] = STATE(2799),
    [sym_type_unboxed_sum] = STATE(2799),
    [sym__atype] = STATE(2799),
    [sym_type_apply] = STATE(8878),
    [sym__btype] = STATE(8878),
    [sym_type_infix] = STATE(13177),
    [sym__type_infix] = STATE(12764),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2638),
    [sym__type_quantifiers] = STATE(18780),
    [sym__type_context] = STATE(18780),
    [sym__type_fun] = STATE(18780),
    [sym__type] = STATE(18780),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15161),
    [sym_splice] = STATE(2799),
    [sym_quasiquote] = STATE(2799),
    [sym__varid] = ACTIONS(6042),
    [sym_float] = ACTIONS(6044),
    [sym_char] = ACTIONS(6044),
    [sym_string] = ACTIONS(6044),
    [sym__integer_literal] = ACTIONS(6046),
    [sym__binary_literal] = ACTIONS(6048),
    [sym__octal_literal] = ACTIONS(6048),
    [sym__hex_literal] = ACTIONS(6048),
    [anon_sym_LPAREN_POUND] = ACTIONS(6050),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6050),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6052),
    [sym__conid] = ACTIONS(6056),
    [anon_sym_LBRACK] = ACTIONS(6058),
    [anon_sym_SQUOTE] = ACTIONS(6060),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6062),
    [anon_sym_6] = ACTIONS(6062),
    [anon_sym_7] = ACTIONS(6064),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6066),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6068),
  },
  [2573] = {
    [sym_integer] = STATE(7818),
    [sym__literal] = STATE(7818),
    [sym__unboxed_open] = STATE(2165),
    [sym_constructor] = STATE(7684),
    [sym_con_unit] = STATE(7818),
    [sym_con_list] = STATE(7818),
    [sym_con_tuple] = STATE(7818),
    [sym_qualified_type] = STATE(7768),
    [sym_tycon_arrow] = STATE(7768),
    [sym_type_literal] = STATE(2799),
    [sym__promoted_tycon] = STATE(7768),
    [sym_type_variable] = STATE(7768),
    [sym_annotated_type_variable] = STATE(7768),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14565),
    [sym_type_parens] = STATE(2799),
    [sym_type_list] = STATE(2799),
    [sym_type_tuple] = STATE(2799),
    [sym__type_promotable_literal] = STATE(2799),
    [sym__type_promoted_literal] = STATE(2799),
    [sym__type_literal] = STATE(2799),
    [sym_type_name] = STATE(2788),
    [sym_type_star] = STATE(2799),
    [sym_type_unboxed_tuple] = STATE(2799),
    [sym_type_unboxed_sum] = STATE(2799),
    [sym__atype] = STATE(2799),
    [sym_type_apply] = STATE(8878),
    [sym__btype] = STATE(8878),
    [sym_type_infix] = STATE(13177),
    [sym__type_infix] = STATE(12764),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2638),
    [sym__type_quantifiers] = STATE(18772),
    [sym__type_context] = STATE(18772),
    [sym__type_fun] = STATE(18772),
    [sym__type] = STATE(18772),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15161),
    [sym_splice] = STATE(2799),
    [sym_quasiquote] = STATE(2799),
    [sym__varid] = ACTIONS(6042),
    [sym_float] = ACTIONS(6044),
    [sym_char] = ACTIONS(6044),
    [sym_string] = ACTIONS(6044),
    [sym__integer_literal] = ACTIONS(6046),
    [sym__binary_literal] = ACTIONS(6048),
    [sym__octal_literal] = ACTIONS(6048),
    [sym__hex_literal] = ACTIONS(6048),
    [anon_sym_LPAREN_POUND] = ACTIONS(6050),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6050),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6052),
    [sym__conid] = ACTIONS(6056),
    [anon_sym_LBRACK] = ACTIONS(6058),
    [anon_sym_SQUOTE] = ACTIONS(6060),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6062),
    [anon_sym_6] = ACTIONS(6062),
    [anon_sym_7] = ACTIONS(6064),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6066),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6068),
  },
  [2574] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14412),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(12341),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2561),
    [sym__type_quantifiers] = STATE(17016),
    [sym__type_context] = STATE(17016),
    [sym__type_fun] = STATE(17016),
    [sym__type] = STATE(17016),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(5274),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
  },
  [2575] = {
    [sym_integer] = STATE(5892),
    [sym__literal] = STATE(5892),
    [sym__unboxed_open] = STATE(2185),
    [sym_constructor] = STATE(5658),
    [sym_con_unit] = STATE(5892),
    [sym_con_list] = STATE(5892),
    [sym_con_tuple] = STATE(5892),
    [sym_qualified_type] = STATE(5887),
    [sym_tycon_arrow] = STATE(5887),
    [sym_type_literal] = STATE(2295),
    [sym__promoted_tycon] = STATE(5887),
    [sym_type_variable] = STATE(5887),
    [sym_annotated_type_variable] = STATE(5887),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14262),
    [sym_type_parens] = STATE(2295),
    [sym_type_list] = STATE(2295),
    [sym_type_tuple] = STATE(2295),
    [sym__type_promotable_literal] = STATE(2295),
    [sym__type_promoted_literal] = STATE(2295),
    [sym__type_literal] = STATE(2295),
    [sym_type_name] = STATE(2351),
    [sym_type_star] = STATE(2295),
    [sym_type_unboxed_tuple] = STATE(2295),
    [sym_type_unboxed_sum] = STATE(2295),
    [sym__atype] = STATE(2295),
    [sym_type_apply] = STATE(7097),
    [sym__btype] = STATE(7097),
    [sym_type_infix] = STATE(9558),
    [sym__type_infix] = STATE(9459),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2511),
    [sym__type_quantifiers] = STATE(10921),
    [sym__type_context] = STATE(10921),
    [sym__type_fun] = STATE(10921),
    [sym__type] = STATE(10921),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15268),
    [sym_splice] = STATE(2295),
    [sym_quasiquote] = STATE(2295),
    [sym__varid] = ACTIONS(5796),
    [sym_float] = ACTIONS(5798),
    [sym_char] = ACTIONS(5798),
    [sym_string] = ACTIONS(5798),
    [sym__integer_literal] = ACTIONS(5800),
    [sym__binary_literal] = ACTIONS(5802),
    [sym__octal_literal] = ACTIONS(5802),
    [sym__hex_literal] = ACTIONS(5802),
    [anon_sym_LPAREN_POUND] = ACTIONS(5804),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5804),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7118),
    [sym__conid] = ACTIONS(7122),
    [anon_sym_LBRACK] = ACTIONS(5811),
    [anon_sym_SQUOTE] = ACTIONS(7124),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5816),
    [anon_sym_6] = ACTIONS(5816),
    [anon_sym_7] = ACTIONS(5818),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5820),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5822),
  },
  [2576] = {
    [sym_integer] = STATE(6389),
    [sym__literal] = STATE(6389),
    [sym__unboxed_open] = STATE(2127),
    [sym_constructor] = STATE(6056),
    [sym_con_unit] = STATE(6389),
    [sym_con_list] = STATE(6389),
    [sym_con_tuple] = STATE(6389),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2465),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym_annotated_type_variable] = STATE(6375),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14088),
    [sym_type_parens] = STATE(2465),
    [sym_type_list] = STATE(2465),
    [sym_type_tuple] = STATE(2465),
    [sym__type_promotable_literal] = STATE(2465),
    [sym__type_promoted_literal] = STATE(2465),
    [sym__type_literal] = STATE(2465),
    [sym_type_name] = STATE(2446),
    [sym_type_star] = STATE(2465),
    [sym_type_unboxed_tuple] = STATE(2465),
    [sym_type_unboxed_sum] = STATE(2465),
    [sym__atype] = STATE(2465),
    [sym_type_apply] = STATE(7694),
    [sym__btype] = STATE(7694),
    [sym_type_infix] = STATE(9909),
    [sym__type_infix] = STATE(9672),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2601),
    [sym__type_quantifiers] = STATE(11991),
    [sym__type_context] = STATE(11991),
    [sym__type_fun] = STATE(11991),
    [sym__type] = STATE(11991),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15001),
    [sym_splice] = STATE(2465),
    [sym_quasiquote] = STATE(2465),
    [sym__varid] = ACTIONS(6587),
    [sym_float] = ACTIONS(6589),
    [sym_char] = ACTIONS(6589),
    [sym_string] = ACTIONS(6589),
    [sym__integer_literal] = ACTIONS(6591),
    [sym__binary_literal] = ACTIONS(6593),
    [sym__octal_literal] = ACTIONS(6593),
    [sym__hex_literal] = ACTIONS(6593),
    [anon_sym_LPAREN_POUND] = ACTIONS(6595),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6595),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6597),
    [sym__conid] = ACTIONS(6601),
    [anon_sym_LBRACK] = ACTIONS(6603),
    [anon_sym_SQUOTE] = ACTIONS(6605),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6607),
    [anon_sym_6] = ACTIONS(6607),
    [anon_sym_7] = ACTIONS(6609),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6611),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6613),
  },
  [2577] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(2375),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_strict_type] = STATE(16372),
    [sym_lazy_type] = STATE(16372),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9510),
    [sym__btype] = STATE(9510),
    [sym_type_infix] = STATE(15079),
    [sym__type_infix] = STATE(16372),
    [sym_constraint] = STATE(15631),
    [sym__context_constraints] = STATE(15631),
    [sym__context] = STATE(9228),
    [sym_context] = STATE(2793),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_data_constructor] = STATE(13577),
    [sym_data_constructor_infix] = STATE(13577),
    [sym_data_constructor_record] = STATE(13577),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(8063),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5312),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
    [sym__strict] = ACTIONS(5316),
    [sym__lazy] = ACTIONS(5318),
  },
  [2578] = {
    [sym_integer] = STATE(6622),
    [sym__literal] = STATE(6622),
    [sym__unboxed_open] = STATE(2223),
    [sym_constructor] = STATE(6527),
    [sym_con_unit] = STATE(6622),
    [sym_con_list] = STATE(6622),
    [sym_con_tuple] = STATE(6622),
    [sym_qualified_type] = STATE(6611),
    [sym_tycon_arrow] = STATE(6611),
    [sym_type_literal] = STATE(2490),
    [sym__promoted_tycon] = STATE(6611),
    [sym_type_variable] = STATE(6611),
    [sym_annotated_type_variable] = STATE(6611),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14484),
    [sym_type_parens] = STATE(2490),
    [sym_type_list] = STATE(2490),
    [sym_type_tuple] = STATE(2490),
    [sym__type_promotable_literal] = STATE(2490),
    [sym__type_promoted_literal] = STATE(2490),
    [sym__type_literal] = STATE(2490),
    [sym_type_name] = STATE(2482),
    [sym_type_star] = STATE(2490),
    [sym_type_unboxed_tuple] = STATE(2490),
    [sym_type_unboxed_sum] = STATE(2490),
    [sym__atype] = STATE(2490),
    [sym_type_apply] = STATE(7827),
    [sym__btype] = STATE(7827),
    [sym_type_infix] = STATE(10085),
    [sym__type_infix] = STATE(9970),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2578),
    [sym__type_quantifiers] = STATE(12279),
    [sym__type_context] = STATE(12279),
    [sym__type_fun] = STATE(12279),
    [sym__type] = STATE(12279),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14645),
    [sym_splice] = STATE(2490),
    [sym_quasiquote] = STATE(2490),
    [sym__varid] = ACTIONS(7201),
    [sym_float] = ACTIONS(7203),
    [sym_char] = ACTIONS(7203),
    [sym_string] = ACTIONS(7203),
    [sym__integer_literal] = ACTIONS(7205),
    [sym__binary_literal] = ACTIONS(7207),
    [sym__octal_literal] = ACTIONS(7207),
    [sym__hex_literal] = ACTIONS(7207),
    [anon_sym_LPAREN_POUND] = ACTIONS(7209),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7209),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7211),
    [sym__conid] = ACTIONS(7215),
    [anon_sym_LBRACK] = ACTIONS(7217),
    [anon_sym_SQUOTE] = ACTIONS(7219),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7221),
    [anon_sym_6] = ACTIONS(7221),
    [anon_sym_7] = ACTIONS(7223),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7225),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7227),
  },
  [2579] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(18226),
    [sym__type_context] = STATE(18226),
    [sym__type_fun] = STATE(18226),
    [sym__type] = STATE(18226),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2580] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_in] = ACTIONS(5160),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym__layout_end] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2581] = {
    [sym_integer] = STATE(7485),
    [sym__literal] = STATE(7485),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7295),
    [sym_con_unit] = STATE(7485),
    [sym_con_list] = STATE(7485),
    [sym_con_tuple] = STATE(7485),
    [sym_qualified_type] = STATE(7412),
    [sym_tycon_arrow] = STATE(7412),
    [sym_type_literal] = STATE(2753),
    [sym__promoted_tycon] = STATE(7412),
    [sym_type_variable] = STATE(7412),
    [sym_annotated_type_variable] = STATE(7412),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14444),
    [sym_type_parens] = STATE(2753),
    [sym_type_list] = STATE(2753),
    [sym_type_tuple] = STATE(2753),
    [sym__type_promotable_literal] = STATE(2753),
    [sym__type_promoted_literal] = STATE(2753),
    [sym__type_literal] = STATE(2753),
    [sym_type_name] = STATE(2737),
    [sym_type_star] = STATE(2753),
    [sym_type_unboxed_tuple] = STATE(2753),
    [sym_type_unboxed_sum] = STATE(2753),
    [sym__atype] = STATE(2753),
    [sym_type_apply] = STATE(8310),
    [sym__btype] = STATE(8310),
    [sym_type_infix] = STATE(12638),
    [sym__type_infix] = STATE(12387),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2571),
    [sym__type_quantifiers] = STATE(14818),
    [sym__type_context] = STATE(14818),
    [sym__type_fun] = STATE(14818),
    [sym__type] = STATE(14818),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14836),
    [sym_splice] = STATE(2753),
    [sym_quasiquote] = STATE(2753),
    [sym__varid] = ACTIONS(6002),
    [sym_float] = ACTIONS(6004),
    [sym_char] = ACTIONS(6004),
    [sym_string] = ACTIONS(6004),
    [sym__integer_literal] = ACTIONS(6006),
    [sym__binary_literal] = ACTIONS(6008),
    [sym__octal_literal] = ACTIONS(6008),
    [sym__hex_literal] = ACTIONS(6008),
    [anon_sym_LPAREN_POUND] = ACTIONS(6010),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6010),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6012),
    [sym__conid] = ACTIONS(6016),
    [anon_sym_LBRACK] = ACTIONS(6018),
    [anon_sym_SQUOTE] = ACTIONS(6020),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6022),
    [anon_sym_6] = ACTIONS(6022),
    [anon_sym_7] = ACTIONS(6024),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6026),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6028),
  },
  [2582] = {
    [sym_integer] = STATE(6389),
    [sym__literal] = STATE(6389),
    [sym__unboxed_open] = STATE(2127),
    [sym_constructor] = STATE(6056),
    [sym_con_unit] = STATE(6389),
    [sym_con_list] = STATE(6389),
    [sym_con_tuple] = STATE(6389),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2465),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym_annotated_type_variable] = STATE(6375),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14088),
    [sym_type_parens] = STATE(2465),
    [sym_type_list] = STATE(2465),
    [sym_type_tuple] = STATE(2465),
    [sym__type_promotable_literal] = STATE(2465),
    [sym__type_promoted_literal] = STATE(2465),
    [sym__type_literal] = STATE(2465),
    [sym_type_name] = STATE(2446),
    [sym_type_star] = STATE(2465),
    [sym_type_unboxed_tuple] = STATE(2465),
    [sym_type_unboxed_sum] = STATE(2465),
    [sym__atype] = STATE(2465),
    [sym_type_apply] = STATE(7694),
    [sym__btype] = STATE(7694),
    [sym_type_infix] = STATE(9909),
    [sym__type_infix] = STATE(9672),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2601),
    [sym__type_quantifiers] = STATE(11960),
    [sym__type_context] = STATE(11960),
    [sym__type_fun] = STATE(11960),
    [sym__type] = STATE(11960),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15001),
    [sym_splice] = STATE(2465),
    [sym_quasiquote] = STATE(2465),
    [sym__varid] = ACTIONS(6587),
    [sym_float] = ACTIONS(6589),
    [sym_char] = ACTIONS(6589),
    [sym_string] = ACTIONS(6589),
    [sym__integer_literal] = ACTIONS(6591),
    [sym__binary_literal] = ACTIONS(6593),
    [sym__octal_literal] = ACTIONS(6593),
    [sym__hex_literal] = ACTIONS(6593),
    [anon_sym_LPAREN_POUND] = ACTIONS(6595),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6595),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6597),
    [sym__conid] = ACTIONS(6601),
    [anon_sym_LBRACK] = ACTIONS(6603),
    [anon_sym_SQUOTE] = ACTIONS(6605),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6607),
    [anon_sym_6] = ACTIONS(6607),
    [anon_sym_7] = ACTIONS(6609),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6611),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6613),
  },
  [2583] = {
    [sym_integer] = STATE(7156),
    [sym__literal] = STATE(7156),
    [sym__unboxed_open] = STATE(2209),
    [sym_constructor] = STATE(6790),
    [sym_con_unit] = STATE(7156),
    [sym_con_list] = STATE(7156),
    [sym_con_tuple] = STATE(7156),
    [sym_qualified_type] = STATE(7260),
    [sym_tycon_arrow] = STATE(7260),
    [sym_type_literal] = STATE(2713),
    [sym__promoted_tycon] = STATE(7260),
    [sym_type_variable] = STATE(7260),
    [sym_annotated_type_variable] = STATE(7260),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14496),
    [sym_type_parens] = STATE(2713),
    [sym_type_list] = STATE(2713),
    [sym_type_tuple] = STATE(2713),
    [sym__type_promotable_literal] = STATE(2713),
    [sym__type_promoted_literal] = STATE(2713),
    [sym__type_literal] = STATE(2713),
    [sym_type_name] = STATE(2682),
    [sym_type_star] = STATE(2713),
    [sym_type_unboxed_tuple] = STATE(2713),
    [sym_type_unboxed_sum] = STATE(2713),
    [sym__atype] = STATE(2713),
    [sym_type_apply] = STATE(7968),
    [sym__btype] = STATE(7968),
    [sym_type_infix] = STATE(12340),
    [sym__type_infix] = STATE(12119),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2666),
    [sym__type_quantifiers] = STATE(13315),
    [sym__type_context] = STATE(13315),
    [sym__type_fun] = STATE(13315),
    [sym__type] = STATE(13315),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14821),
    [sym_splice] = STATE(2713),
    [sym_quasiquote] = STATE(2713),
    [sym__varid] = ACTIONS(6503),
    [sym_float] = ACTIONS(6505),
    [sym_char] = ACTIONS(6505),
    [sym_string] = ACTIONS(6505),
    [sym__integer_literal] = ACTIONS(6507),
    [sym__binary_literal] = ACTIONS(6509),
    [sym__octal_literal] = ACTIONS(6509),
    [sym__hex_literal] = ACTIONS(6509),
    [anon_sym_LPAREN_POUND] = ACTIONS(6511),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6511),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6513),
    [sym__conid] = ACTIONS(6517),
    [anon_sym_LBRACK] = ACTIONS(6519),
    [anon_sym_SQUOTE] = ACTIONS(6521),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6523),
    [anon_sym_6] = ACTIONS(6523),
    [anon_sym_7] = ACTIONS(6525),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6527),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6529),
  },
  [2584] = {
    [sym_integer] = STATE(7581),
    [sym__literal] = STATE(7581),
    [sym__unboxed_open] = STATE(2145),
    [sym_constructor] = STATE(7303),
    [sym_con_unit] = STATE(7581),
    [sym_con_list] = STATE(7581),
    [sym_con_tuple] = STATE(7581),
    [sym_qualified_type] = STATE(7348),
    [sym_tycon_arrow] = STATE(7348),
    [sym_type_literal] = STATE(2754),
    [sym__promoted_tycon] = STATE(7348),
    [sym_type_variable] = STATE(7348),
    [sym_annotated_type_variable] = STATE(7348),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14002),
    [sym_type_parens] = STATE(2754),
    [sym_type_list] = STATE(2754),
    [sym_type_tuple] = STATE(2754),
    [sym__type_promotable_literal] = STATE(2754),
    [sym__type_promoted_literal] = STATE(2754),
    [sym__type_literal] = STATE(2754),
    [sym_type_name] = STATE(2750),
    [sym_type_star] = STATE(2754),
    [sym_type_unboxed_tuple] = STATE(2754),
    [sym_type_unboxed_sum] = STATE(2754),
    [sym__atype] = STATE(2754),
    [sym_type_apply] = STATE(8239),
    [sym__btype] = STATE(8239),
    [sym_type_infix] = STATE(12660),
    [sym__type_infix] = STATE(12425),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2584),
    [sym__type_quantifiers] = STATE(14704),
    [sym__type_context] = STATE(14704),
    [sym__type_fun] = STATE(14704),
    [sym__type] = STATE(14704),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14983),
    [sym_splice] = STATE(2754),
    [sym_quasiquote] = STATE(2754),
    [sym__varid] = ACTIONS(6111),
    [sym_float] = ACTIONS(6113),
    [sym_char] = ACTIONS(6113),
    [sym_string] = ACTIONS(6113),
    [sym__integer_literal] = ACTIONS(6115),
    [sym__binary_literal] = ACTIONS(6117),
    [sym__octal_literal] = ACTIONS(6117),
    [sym__hex_literal] = ACTIONS(6117),
    [anon_sym_LPAREN_POUND] = ACTIONS(6119),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6119),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6121),
    [sym__conid] = ACTIONS(6125),
    [anon_sym_LBRACK] = ACTIONS(6127),
    [anon_sym_SQUOTE] = ACTIONS(6129),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6131),
    [anon_sym_6] = ACTIONS(6131),
    [anon_sym_7] = ACTIONS(6133),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6135),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6137),
  },
  [2585] = {
    [sym_integer] = STATE(7156),
    [sym__literal] = STATE(7156),
    [sym__unboxed_open] = STATE(2209),
    [sym_constructor] = STATE(6790),
    [sym_con_unit] = STATE(7156),
    [sym_con_list] = STATE(7156),
    [sym_con_tuple] = STATE(7156),
    [sym_qualified_type] = STATE(7260),
    [sym_tycon_arrow] = STATE(7260),
    [sym_type_literal] = STATE(2713),
    [sym__promoted_tycon] = STATE(7260),
    [sym_type_variable] = STATE(7260),
    [sym_annotated_type_variable] = STATE(7260),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14496),
    [sym_type_parens] = STATE(2713),
    [sym_type_list] = STATE(2713),
    [sym_type_tuple] = STATE(2713),
    [sym__type_promotable_literal] = STATE(2713),
    [sym__type_promoted_literal] = STATE(2713),
    [sym__type_literal] = STATE(2713),
    [sym_type_name] = STATE(2682),
    [sym_type_star] = STATE(2713),
    [sym_type_unboxed_tuple] = STATE(2713),
    [sym_type_unboxed_sum] = STATE(2713),
    [sym__atype] = STATE(2713),
    [sym_type_apply] = STATE(7968),
    [sym__btype] = STATE(7968),
    [sym_type_infix] = STATE(12340),
    [sym__type_infix] = STATE(12119),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2666),
    [sym__type_quantifiers] = STATE(13308),
    [sym__type_context] = STATE(13308),
    [sym__type_fun] = STATE(13308),
    [sym__type] = STATE(13308),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14821),
    [sym_splice] = STATE(2713),
    [sym_quasiquote] = STATE(2713),
    [sym__varid] = ACTIONS(6503),
    [sym_float] = ACTIONS(6505),
    [sym_char] = ACTIONS(6505),
    [sym_string] = ACTIONS(6505),
    [sym__integer_literal] = ACTIONS(6507),
    [sym__binary_literal] = ACTIONS(6509),
    [sym__octal_literal] = ACTIONS(6509),
    [sym__hex_literal] = ACTIONS(6509),
    [anon_sym_LPAREN_POUND] = ACTIONS(6511),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6511),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6513),
    [sym__conid] = ACTIONS(6517),
    [anon_sym_LBRACK] = ACTIONS(6519),
    [anon_sym_SQUOTE] = ACTIONS(6521),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6523),
    [anon_sym_6] = ACTIONS(6523),
    [anon_sym_7] = ACTIONS(6525),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6527),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6529),
  },
  [2586] = {
    [sym_integer] = STATE(7485),
    [sym__literal] = STATE(7485),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7295),
    [sym_con_unit] = STATE(7485),
    [sym_con_list] = STATE(7485),
    [sym_con_tuple] = STATE(7485),
    [sym_qualified_type] = STATE(7412),
    [sym_tycon_arrow] = STATE(7412),
    [sym_type_literal] = STATE(2753),
    [sym__promoted_tycon] = STATE(7412),
    [sym_type_variable] = STATE(7412),
    [sym_annotated_type_variable] = STATE(7412),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14444),
    [sym_type_parens] = STATE(2753),
    [sym_type_list] = STATE(2753),
    [sym_type_tuple] = STATE(2753),
    [sym__type_promotable_literal] = STATE(2753),
    [sym__type_promoted_literal] = STATE(2753),
    [sym__type_literal] = STATE(2753),
    [sym_type_name] = STATE(2737),
    [sym_type_star] = STATE(2753),
    [sym_type_unboxed_tuple] = STATE(2753),
    [sym_type_unboxed_sum] = STATE(2753),
    [sym__atype] = STATE(2753),
    [sym_type_apply] = STATE(8310),
    [sym__btype] = STATE(8310),
    [sym_type_infix] = STATE(12638),
    [sym__type_infix] = STATE(12387),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2571),
    [sym__type_quantifiers] = STATE(14819),
    [sym__type_context] = STATE(14819),
    [sym__type_fun] = STATE(14819),
    [sym__type] = STATE(14819),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14836),
    [sym_splice] = STATE(2753),
    [sym_quasiquote] = STATE(2753),
    [sym__varid] = ACTIONS(6002),
    [sym_float] = ACTIONS(6004),
    [sym_char] = ACTIONS(6004),
    [sym_string] = ACTIONS(6004),
    [sym__integer_literal] = ACTIONS(6006),
    [sym__binary_literal] = ACTIONS(6008),
    [sym__octal_literal] = ACTIONS(6008),
    [sym__hex_literal] = ACTIONS(6008),
    [anon_sym_LPAREN_POUND] = ACTIONS(6010),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6010),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6012),
    [sym__conid] = ACTIONS(6016),
    [anon_sym_LBRACK] = ACTIONS(6018),
    [anon_sym_SQUOTE] = ACTIONS(6020),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6022),
    [anon_sym_6] = ACTIONS(6022),
    [anon_sym_7] = ACTIONS(6024),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6026),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6028),
  },
  [2587] = {
    [sym_integer] = STATE(6771),
    [sym__literal] = STATE(6771),
    [sym__unboxed_open] = STATE(2214),
    [sym_constructor] = STATE(6276),
    [sym_con_unit] = STATE(6771),
    [sym_con_list] = STATE(6771),
    [sym_con_tuple] = STATE(6771),
    [sym_qualified_type] = STATE(6769),
    [sym_tycon_arrow] = STATE(6769),
    [sym_type_literal] = STATE(2489),
    [sym__promoted_tycon] = STATE(6769),
    [sym_type_variable] = STATE(6769),
    [sym_annotated_type_variable] = STATE(6769),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14144),
    [sym_type_parens] = STATE(2489),
    [sym_type_list] = STATE(2489),
    [sym_type_tuple] = STATE(2489),
    [sym__type_promotable_literal] = STATE(2489),
    [sym__type_promoted_literal] = STATE(2489),
    [sym__type_literal] = STATE(2489),
    [sym_type_name] = STATE(2487),
    [sym_type_star] = STATE(2489),
    [sym_type_unboxed_tuple] = STATE(2489),
    [sym_type_unboxed_sum] = STATE(2489),
    [sym__atype] = STATE(2489),
    [sym_type_apply] = STATE(7772),
    [sym__btype] = STATE(7772),
    [sym_type_infix] = STATE(10200),
    [sym__type_infix] = STATE(9950),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2588),
    [sym__type_quantifiers] = STATE(12330),
    [sym__type_context] = STATE(12330),
    [sym__type_fun] = STATE(12330),
    [sym__type] = STATE(12330),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15096),
    [sym_splice] = STATE(2489),
    [sym_quasiquote] = STATE(2489),
    [sym__varid] = ACTIONS(7313),
    [sym_float] = ACTIONS(7315),
    [sym_char] = ACTIONS(7315),
    [sym_string] = ACTIONS(7315),
    [sym__integer_literal] = ACTIONS(7317),
    [sym__binary_literal] = ACTIONS(7319),
    [sym__octal_literal] = ACTIONS(7319),
    [sym__hex_literal] = ACTIONS(7319),
    [anon_sym_LPAREN_POUND] = ACTIONS(7321),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7321),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7323),
    [sym__conid] = ACTIONS(7327),
    [anon_sym_LBRACK] = ACTIONS(7329),
    [anon_sym_SQUOTE] = ACTIONS(7331),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7333),
    [anon_sym_6] = ACTIONS(7333),
    [anon_sym_7] = ACTIONS(7335),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7337),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7339),
  },
  [2588] = {
    [sym_integer] = STATE(6771),
    [sym__literal] = STATE(6771),
    [sym__unboxed_open] = STATE(2214),
    [sym_constructor] = STATE(6276),
    [sym_con_unit] = STATE(6771),
    [sym_con_list] = STATE(6771),
    [sym_con_tuple] = STATE(6771),
    [sym_qualified_type] = STATE(6769),
    [sym_tycon_arrow] = STATE(6769),
    [sym_type_literal] = STATE(2489),
    [sym__promoted_tycon] = STATE(6769),
    [sym_type_variable] = STATE(6769),
    [sym_annotated_type_variable] = STATE(6769),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14144),
    [sym_type_parens] = STATE(2489),
    [sym_type_list] = STATE(2489),
    [sym_type_tuple] = STATE(2489),
    [sym__type_promotable_literal] = STATE(2489),
    [sym__type_promoted_literal] = STATE(2489),
    [sym__type_literal] = STATE(2489),
    [sym_type_name] = STATE(2487),
    [sym_type_star] = STATE(2489),
    [sym_type_unboxed_tuple] = STATE(2489),
    [sym_type_unboxed_sum] = STATE(2489),
    [sym__atype] = STATE(2489),
    [sym_type_apply] = STATE(7772),
    [sym__btype] = STATE(7772),
    [sym_type_infix] = STATE(10200),
    [sym__type_infix] = STATE(9950),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2588),
    [sym__type_quantifiers] = STATE(12351),
    [sym__type_context] = STATE(12351),
    [sym__type_fun] = STATE(12351),
    [sym__type] = STATE(12351),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15096),
    [sym_splice] = STATE(2489),
    [sym_quasiquote] = STATE(2489),
    [sym__varid] = ACTIONS(7313),
    [sym_float] = ACTIONS(7315),
    [sym_char] = ACTIONS(7315),
    [sym_string] = ACTIONS(7315),
    [sym__integer_literal] = ACTIONS(7317),
    [sym__binary_literal] = ACTIONS(7319),
    [sym__octal_literal] = ACTIONS(7319),
    [sym__hex_literal] = ACTIONS(7319),
    [anon_sym_LPAREN_POUND] = ACTIONS(7321),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7321),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7323),
    [sym__conid] = ACTIONS(7327),
    [anon_sym_LBRACK] = ACTIONS(7329),
    [anon_sym_SQUOTE] = ACTIONS(7331),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7333),
    [anon_sym_6] = ACTIONS(7333),
    [anon_sym_7] = ACTIONS(7335),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7337),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7339),
  },
  [2589] = {
    [sym_integer] = STATE(7144),
    [sym__literal] = STATE(7144),
    [sym__unboxed_open] = STATE(2183),
    [sym_constructor] = STATE(6953),
    [sym_con_unit] = STATE(7144),
    [sym_con_list] = STATE(7144),
    [sym_con_tuple] = STATE(7144),
    [sym_qualified_type] = STATE(7070),
    [sym_tycon_arrow] = STATE(7070),
    [sym_type_literal] = STATE(2715),
    [sym__promoted_tycon] = STATE(7070),
    [sym_type_variable] = STATE(7070),
    [sym_annotated_type_variable] = STATE(7070),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14471),
    [sym_type_parens] = STATE(2715),
    [sym_type_list] = STATE(2715),
    [sym_type_tuple] = STATE(2715),
    [sym__type_promotable_literal] = STATE(2715),
    [sym__type_promoted_literal] = STATE(2715),
    [sym__type_literal] = STATE(2715),
    [sym_type_name] = STATE(2784),
    [sym_type_star] = STATE(2715),
    [sym_type_unboxed_tuple] = STATE(2715),
    [sym_type_unboxed_sum] = STATE(2715),
    [sym__atype] = STATE(2715),
    [sym_type_apply] = STATE(8118),
    [sym__btype] = STATE(8118),
    [sym_type_infix] = STATE(13351),
    [sym__type_infix] = STATE(12972),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2595),
    [sym__type_quantifiers] = STATE(18313),
    [sym__type_context] = STATE(18313),
    [sym__type_fun] = STATE(18313),
    [sym__type] = STATE(18313),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15335),
    [sym_splice] = STATE(2715),
    [sym_quasiquote] = STATE(2715),
    [sym__varid] = ACTIONS(7341),
    [sym_float] = ACTIONS(7343),
    [sym_char] = ACTIONS(7343),
    [sym_string] = ACTIONS(7343),
    [sym__integer_literal] = ACTIONS(7345),
    [sym__binary_literal] = ACTIONS(7347),
    [sym__octal_literal] = ACTIONS(7347),
    [sym__hex_literal] = ACTIONS(7347),
    [anon_sym_LPAREN_POUND] = ACTIONS(7349),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7349),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7351),
    [sym__conid] = ACTIONS(7355),
    [anon_sym_LBRACK] = ACTIONS(7357),
    [anon_sym_SQUOTE] = ACTIONS(7359),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7361),
    [anon_sym_6] = ACTIONS(7361),
    [anon_sym_7] = ACTIONS(7363),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7365),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7367),
  },
  [2590] = {
    [sym_integer] = STATE(7144),
    [sym__literal] = STATE(7144),
    [sym__unboxed_open] = STATE(2183),
    [sym_constructor] = STATE(6953),
    [sym_con_unit] = STATE(7144),
    [sym_con_list] = STATE(7144),
    [sym_con_tuple] = STATE(7144),
    [sym_qualified_type] = STATE(7070),
    [sym_tycon_arrow] = STATE(7070),
    [sym_type_literal] = STATE(2715),
    [sym__promoted_tycon] = STATE(7070),
    [sym_type_variable] = STATE(7070),
    [sym_annotated_type_variable] = STATE(7070),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14471),
    [sym_type_parens] = STATE(2715),
    [sym_type_list] = STATE(2715),
    [sym_type_tuple] = STATE(2715),
    [sym__type_promotable_literal] = STATE(2715),
    [sym__type_promoted_literal] = STATE(2715),
    [sym__type_literal] = STATE(2715),
    [sym_type_name] = STATE(2784),
    [sym_type_star] = STATE(2715),
    [sym_type_unboxed_tuple] = STATE(2715),
    [sym_type_unboxed_sum] = STATE(2715),
    [sym__atype] = STATE(2715),
    [sym_type_apply] = STATE(8118),
    [sym__btype] = STATE(8118),
    [sym_type_infix] = STATE(13351),
    [sym__type_infix] = STATE(12972),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2595),
    [sym__type_quantifiers] = STATE(18247),
    [sym__type_context] = STATE(18247),
    [sym__type_fun] = STATE(18247),
    [sym__type] = STATE(18247),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15335),
    [sym_splice] = STATE(2715),
    [sym_quasiquote] = STATE(2715),
    [sym__varid] = ACTIONS(7341),
    [sym_float] = ACTIONS(7343),
    [sym_char] = ACTIONS(7343),
    [sym_string] = ACTIONS(7343),
    [sym__integer_literal] = ACTIONS(7345),
    [sym__binary_literal] = ACTIONS(7347),
    [sym__octal_literal] = ACTIONS(7347),
    [sym__hex_literal] = ACTIONS(7347),
    [anon_sym_LPAREN_POUND] = ACTIONS(7349),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7349),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7351),
    [sym__conid] = ACTIONS(7355),
    [anon_sym_LBRACK] = ACTIONS(7357),
    [anon_sym_SQUOTE] = ACTIONS(7359),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7361),
    [anon_sym_6] = ACTIONS(7361),
    [anon_sym_7] = ACTIONS(7363),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7365),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7367),
  },
  [2591] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14412),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(12341),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2561),
    [sym__type_quantifiers] = STATE(15391),
    [sym__type_context] = STATE(15391),
    [sym__type_fun] = STATE(15391),
    [sym__type] = STATE(15391),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(5274),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
  },
  [2592] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(18165),
    [sym__type_context] = STATE(18165),
    [sym__type_fun] = STATE(18165),
    [sym__type] = STATE(18165),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2593] = {
    [sym_integer] = STATE(6751),
    [sym__literal] = STATE(6751),
    [sym__unboxed_open] = STATE(2140),
    [sym_constructor] = STATE(6530),
    [sym_con_unit] = STATE(6751),
    [sym_con_list] = STATE(6751),
    [sym_con_tuple] = STATE(6751),
    [sym_qualified_type] = STATE(6610),
    [sym_tycon_arrow] = STATE(6610),
    [sym_type_literal] = STATE(2499),
    [sym__promoted_tycon] = STATE(6610),
    [sym_type_variable] = STATE(6610),
    [sym_annotated_type_variable] = STATE(6610),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14167),
    [sym_type_parens] = STATE(2499),
    [sym_type_list] = STATE(2499),
    [sym_type_tuple] = STATE(2499),
    [sym__type_promotable_literal] = STATE(2499),
    [sym__type_promoted_literal] = STATE(2499),
    [sym__type_literal] = STATE(2499),
    [sym_type_name] = STATE(2484),
    [sym_type_star] = STATE(2499),
    [sym_type_unboxed_tuple] = STATE(2499),
    [sym_type_unboxed_sum] = STATE(2499),
    [sym__atype] = STATE(2499),
    [sym_type_apply] = STATE(7714),
    [sym__btype] = STATE(7714),
    [sym_type_infix] = STATE(10095),
    [sym__type_infix] = STATE(9721),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2593),
    [sym__type_quantifiers] = STATE(11511),
    [sym__type_context] = STATE(11511),
    [sym__type_fun] = STATE(11511),
    [sym__type] = STATE(11511),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15339),
    [sym_splice] = STATE(2499),
    [sym_quasiquote] = STATE(2499),
    [sym__varid] = ACTIONS(6681),
    [sym_float] = ACTIONS(6683),
    [sym_char] = ACTIONS(6683),
    [sym_string] = ACTIONS(6683),
    [sym__integer_literal] = ACTIONS(6685),
    [sym__binary_literal] = ACTIONS(6687),
    [sym__octal_literal] = ACTIONS(6687),
    [sym__hex_literal] = ACTIONS(6687),
    [anon_sym_LPAREN_POUND] = ACTIONS(6689),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6689),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6691),
    [sym__conid] = ACTIONS(6695),
    [anon_sym_LBRACK] = ACTIONS(6697),
    [anon_sym_SQUOTE] = ACTIONS(6699),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6701),
    [anon_sym_6] = ACTIONS(6701),
    [anon_sym_7] = ACTIONS(6703),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6705),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6707),
  },
  [2594] = {
    [sym_integer] = STATE(7224),
    [sym__literal] = STATE(7224),
    [sym__unboxed_open] = STATE(2201),
    [sym_constructor] = STATE(6997),
    [sym_con_unit] = STATE(7224),
    [sym_con_list] = STATE(7224),
    [sym_con_tuple] = STATE(7224),
    [sym_qualified_type] = STATE(7098),
    [sym_tycon_arrow] = STATE(7098),
    [sym_type_literal] = STATE(2726),
    [sym__promoted_tycon] = STATE(7098),
    [sym_type_variable] = STATE(7098),
    [sym_annotated_type_variable] = STATE(7098),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14123),
    [sym_type_parens] = STATE(2726),
    [sym_type_list] = STATE(2726),
    [sym_type_tuple] = STATE(2726),
    [sym__type_promotable_literal] = STATE(2726),
    [sym__type_promoted_literal] = STATE(2726),
    [sym__type_literal] = STATE(2726),
    [sym_type_name] = STATE(2712),
    [sym_type_star] = STATE(2726),
    [sym_type_unboxed_tuple] = STATE(2726),
    [sym_type_unboxed_sum] = STATE(2726),
    [sym__atype] = STATE(2726),
    [sym_type_apply] = STATE(8043),
    [sym__btype] = STATE(8043),
    [sym_type_infix] = STATE(12452),
    [sym__type_infix] = STATE(12183),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2594),
    [sym__type_quantifiers] = STATE(14129),
    [sym__type_context] = STATE(14129),
    [sym__type_fun] = STATE(14129),
    [sym__type] = STATE(14129),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15261),
    [sym_splice] = STATE(2726),
    [sym_quasiquote] = STATE(2726),
    [sym__varid] = ACTIONS(6531),
    [sym_float] = ACTIONS(6533),
    [sym_char] = ACTIONS(6533),
    [sym_string] = ACTIONS(6533),
    [sym__integer_literal] = ACTIONS(6535),
    [sym__binary_literal] = ACTIONS(6537),
    [sym__octal_literal] = ACTIONS(6537),
    [sym__hex_literal] = ACTIONS(6537),
    [anon_sym_LPAREN_POUND] = ACTIONS(6539),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6539),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6541),
    [sym__conid] = ACTIONS(6545),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_SQUOTE] = ACTIONS(6549),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6551),
    [anon_sym_6] = ACTIONS(6551),
    [anon_sym_7] = ACTIONS(6553),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6555),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6557),
  },
  [2595] = {
    [sym_integer] = STATE(7144),
    [sym__literal] = STATE(7144),
    [sym__unboxed_open] = STATE(2183),
    [sym_constructor] = STATE(6953),
    [sym_con_unit] = STATE(7144),
    [sym_con_list] = STATE(7144),
    [sym_con_tuple] = STATE(7144),
    [sym_qualified_type] = STATE(7070),
    [sym_tycon_arrow] = STATE(7070),
    [sym_type_literal] = STATE(2715),
    [sym__promoted_tycon] = STATE(7070),
    [sym_type_variable] = STATE(7070),
    [sym_annotated_type_variable] = STATE(7070),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14471),
    [sym_type_parens] = STATE(2715),
    [sym_type_list] = STATE(2715),
    [sym_type_tuple] = STATE(2715),
    [sym__type_promotable_literal] = STATE(2715),
    [sym__type_promoted_literal] = STATE(2715),
    [sym__type_literal] = STATE(2715),
    [sym_type_name] = STATE(2784),
    [sym_type_star] = STATE(2715),
    [sym_type_unboxed_tuple] = STATE(2715),
    [sym_type_unboxed_sum] = STATE(2715),
    [sym__atype] = STATE(2715),
    [sym_type_apply] = STATE(8118),
    [sym__btype] = STATE(8118),
    [sym_type_infix] = STATE(13351),
    [sym__type_infix] = STATE(12972),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2595),
    [sym__type_quantifiers] = STATE(18362),
    [sym__type_context] = STATE(18362),
    [sym__type_fun] = STATE(18362),
    [sym__type] = STATE(18362),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15335),
    [sym_splice] = STATE(2715),
    [sym_quasiquote] = STATE(2715),
    [sym__varid] = ACTIONS(7341),
    [sym_float] = ACTIONS(7343),
    [sym_char] = ACTIONS(7343),
    [sym_string] = ACTIONS(7343),
    [sym__integer_literal] = ACTIONS(7345),
    [sym__binary_literal] = ACTIONS(7347),
    [sym__octal_literal] = ACTIONS(7347),
    [sym__hex_literal] = ACTIONS(7347),
    [anon_sym_LPAREN_POUND] = ACTIONS(7349),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7349),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7351),
    [sym__conid] = ACTIONS(7355),
    [anon_sym_LBRACK] = ACTIONS(7357),
    [anon_sym_SQUOTE] = ACTIONS(7359),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7361),
    [anon_sym_6] = ACTIONS(7361),
    [anon_sym_7] = ACTIONS(7363),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7365),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7367),
  },
  [2596] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = STATE(9343),
    [sym_qualified_variable] = STATE(9343),
    [sym_constructor] = STATE(9240),
    [sym_qualified_constructor] = STATE(9275),
    [sym__qcon] = STATE(9343),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(9481),
    [sym_exp_parens] = STATE(9481),
    [sym_exp_tuple] = STATE(9481),
    [sym_exp_unboxed_tuple] = STATE(9481),
    [sym_exp_unboxed_sum] = STATE(9481),
    [sym_exp_list] = STATE(9481),
    [sym_exp_arithmetic_sequence] = STATE(9481),
    [sym_exp_list_comprehension] = STATE(9481),
    [sym_exp_section_left] = STATE(9481),
    [sym_exp_section_right] = STATE(9481),
    [sym_exp_th_quoted_name] = STATE(9481),
    [sym_exp_type_application] = STATE(9563),
    [sym_exp_lambda_case] = STATE(9563),
    [sym__do_keyword] = STATE(18466),
    [sym_do_module] = STATE(18466),
    [sym_exp_do] = STATE(9563),
    [sym_exp_record] = STATE(9481),
    [sym_exp_name] = STATE(9481),
    [sym_exp_projection_selector] = STATE(9481),
    [sym__aexp_projection] = STATE(9481),
    [sym_exp_projection] = STATE(9481),
    [sym__aexp] = STATE(9563),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12535),
    [sym_splice] = STATE(9481),
    [sym_quasiquote] = STATE(9481),
    [sym__varid] = ACTIONS(4309),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(8307),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8307),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4223),
    [anon_sym_LPAREN] = ACTIONS(8309),
    [anon_sym_RPAREN] = ACTIONS(4109),
    [sym_implicit_parid] = ACTIONS(4223),
    [sym__conid] = ACTIONS(4321),
    [anon_sym_LBRACK] = ACTIONS(8311),
    [anon_sym_SQUOTE] = ACTIONS(4229),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4231),
    [anon_sym_AT] = ACTIONS(4233),
    [anon_sym_BSLASH] = ACTIONS(4235),
    [anon_sym_mdo] = ACTIONS(4237),
    [anon_sym_do] = ACTIONS(4237),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
  },
  [2597] = {
    [sym_integer] = STATE(7705),
    [sym__literal] = STATE(7705),
    [sym__unboxed_open] = STATE(2184),
    [sym_constructor] = STATE(7681),
    [sym_con_unit] = STATE(7705),
    [sym_con_list] = STATE(7705),
    [sym_con_tuple] = STATE(7705),
    [sym_qualified_type] = STATE(7706),
    [sym_tycon_arrow] = STATE(7706),
    [sym_type_literal] = STATE(2802),
    [sym__promoted_tycon] = STATE(7706),
    [sym_type_variable] = STATE(7706),
    [sym_annotated_type_variable] = STATE(7706),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14603),
    [sym_type_parens] = STATE(2802),
    [sym_type_list] = STATE(2802),
    [sym_type_tuple] = STATE(2802),
    [sym__type_promotable_literal] = STATE(2802),
    [sym__type_promoted_literal] = STATE(2802),
    [sym__type_literal] = STATE(2802),
    [sym_type_name] = STATE(2805),
    [sym_type_star] = STATE(2802),
    [sym_type_unboxed_tuple] = STATE(2802),
    [sym_type_unboxed_sum] = STATE(2802),
    [sym__atype] = STATE(2802),
    [sym_type_apply] = STATE(8735),
    [sym__btype] = STATE(8735),
    [sym_type_infix] = STATE(13317),
    [sym__type_infix] = STATE(13018),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2597),
    [sym__type_quantifiers] = STATE(14933),
    [sym__type_context] = STATE(14933),
    [sym__type_fun] = STATE(14933),
    [sym__type] = STATE(14933),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15120),
    [sym_splice] = STATE(2802),
    [sym_quasiquote] = STATE(2802),
    [sym__varid] = ACTIONS(6139),
    [sym_float] = ACTIONS(6141),
    [sym_char] = ACTIONS(6141),
    [sym_string] = ACTIONS(6141),
    [sym__integer_literal] = ACTIONS(6143),
    [sym__binary_literal] = ACTIONS(6145),
    [sym__octal_literal] = ACTIONS(6145),
    [sym__hex_literal] = ACTIONS(6145),
    [anon_sym_LPAREN_POUND] = ACTIONS(6147),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6147),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6149),
    [sym__conid] = ACTIONS(6153),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_SQUOTE] = ACTIONS(6157),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6159),
    [anon_sym_6] = ACTIONS(6159),
    [anon_sym_7] = ACTIONS(6161),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6163),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6165),
  },
  [2598] = {
    [sym_integer] = STATE(6026),
    [sym__literal] = STATE(6026),
    [sym__unboxed_open] = STATE(2192),
    [sym_constructor] = STATE(5913),
    [sym_con_unit] = STATE(6026),
    [sym_con_list] = STATE(6026),
    [sym_con_tuple] = STATE(6026),
    [sym_qualified_type] = STATE(6029),
    [sym_tycon_arrow] = STATE(6029),
    [sym_type_literal] = STATE(2411),
    [sym__promoted_tycon] = STATE(6029),
    [sym_type_variable] = STATE(6029),
    [sym_annotated_type_variable] = STATE(6029),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14334),
    [sym_type_parens] = STATE(2411),
    [sym_type_list] = STATE(2411),
    [sym_type_tuple] = STATE(2411),
    [sym__type_promotable_literal] = STATE(2411),
    [sym__type_promoted_literal] = STATE(2411),
    [sym__type_literal] = STATE(2411),
    [sym_type_name] = STATE(2394),
    [sym_type_star] = STATE(2411),
    [sym_type_unboxed_tuple] = STATE(2411),
    [sym_type_unboxed_sum] = STATE(2411),
    [sym__atype] = STATE(2411),
    [sym_type_apply] = STATE(7537),
    [sym__btype] = STATE(7537),
    [sym_type_infix] = STATE(9633),
    [sym__type_infix] = STATE(9585),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2603),
    [sym__type_quantifiers] = STATE(10632),
    [sym__type_context] = STATE(10632),
    [sym__type_fun] = STATE(10632),
    [sym__type] = STATE(10632),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15103),
    [sym_splice] = STATE(2411),
    [sym_quasiquote] = STATE(2411),
    [sym__varid] = ACTIONS(6615),
    [sym_float] = ACTIONS(6617),
    [sym_char] = ACTIONS(6617),
    [sym_string] = ACTIONS(6617),
    [sym__integer_literal] = ACTIONS(6619),
    [sym__binary_literal] = ACTIONS(6621),
    [sym__octal_literal] = ACTIONS(6621),
    [sym__hex_literal] = ACTIONS(6621),
    [anon_sym_LPAREN_POUND] = ACTIONS(6623),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6623),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6625),
    [sym__conid] = ACTIONS(6629),
    [anon_sym_LBRACK] = ACTIONS(6631),
    [anon_sym_SQUOTE] = ACTIONS(6633),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6635),
    [anon_sym_6] = ACTIONS(6635),
    [anon_sym_7] = ACTIONS(6637),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6639),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6641),
  },
  [2599] = {
    [sym_integer] = STATE(7386),
    [sym__literal] = STATE(7386),
    [sym__unboxed_open] = STATE(2197),
    [sym_constructor] = STATE(7110),
    [sym_con_unit] = STATE(7386),
    [sym_con_list] = STATE(7386),
    [sym_con_tuple] = STATE(7386),
    [sym_qualified_type] = STATE(7585),
    [sym_tycon_arrow] = STATE(7585),
    [sym_type_literal] = STATE(2736),
    [sym__promoted_tycon] = STATE(7585),
    [sym_type_variable] = STATE(7585),
    [sym_annotated_type_variable] = STATE(7585),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14082),
    [sym_type_parens] = STATE(2736),
    [sym_type_list] = STATE(2736),
    [sym_type_tuple] = STATE(2736),
    [sym__type_promotable_literal] = STATE(2736),
    [sym__type_promoted_literal] = STATE(2736),
    [sym__type_literal] = STATE(2736),
    [sym_type_name] = STATE(2755),
    [sym_type_star] = STATE(2736),
    [sym_type_unboxed_tuple] = STATE(2736),
    [sym_type_unboxed_sum] = STATE(2736),
    [sym__atype] = STATE(2736),
    [sym_type_apply] = STATE(8314),
    [sym__btype] = STATE(8314),
    [sym_type_infix] = STATE(12645),
    [sym__type_infix] = STATE(12371),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2503),
    [sym__type_quantifiers] = STATE(15172),
    [sym__type_context] = STATE(15172),
    [sym__type_fun] = STATE(15172),
    [sym__type] = STATE(15172),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15277),
    [sym_splice] = STATE(2736),
    [sym_quasiquote] = STATE(2736),
    [sym__varid] = ACTIONS(6167),
    [sym_float] = ACTIONS(6169),
    [sym_char] = ACTIONS(6169),
    [sym_string] = ACTIONS(6169),
    [sym__integer_literal] = ACTIONS(6171),
    [sym__binary_literal] = ACTIONS(6173),
    [sym__octal_literal] = ACTIONS(6173),
    [sym__hex_literal] = ACTIONS(6173),
    [anon_sym_LPAREN_POUND] = ACTIONS(6175),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6175),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6177),
    [sym__conid] = ACTIONS(6181),
    [anon_sym_LBRACK] = ACTIONS(6183),
    [anon_sym_SQUOTE] = ACTIONS(6185),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6187),
    [anon_sym_6] = ACTIONS(6187),
    [anon_sym_7] = ACTIONS(6189),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6191),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6193),
  },
  [2600] = {
    [sym_integer] = STATE(6026),
    [sym__literal] = STATE(6026),
    [sym__unboxed_open] = STATE(2192),
    [sym_constructor] = STATE(5913),
    [sym_con_unit] = STATE(6026),
    [sym_con_list] = STATE(6026),
    [sym_con_tuple] = STATE(6026),
    [sym_qualified_type] = STATE(6029),
    [sym_tycon_arrow] = STATE(6029),
    [sym_type_literal] = STATE(2411),
    [sym__promoted_tycon] = STATE(6029),
    [sym_type_variable] = STATE(6029),
    [sym_annotated_type_variable] = STATE(6029),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14334),
    [sym_type_parens] = STATE(2411),
    [sym_type_list] = STATE(2411),
    [sym_type_tuple] = STATE(2411),
    [sym__type_promotable_literal] = STATE(2411),
    [sym__type_promoted_literal] = STATE(2411),
    [sym__type_literal] = STATE(2411),
    [sym_type_name] = STATE(2394),
    [sym_type_star] = STATE(2411),
    [sym_type_unboxed_tuple] = STATE(2411),
    [sym_type_unboxed_sum] = STATE(2411),
    [sym__atype] = STATE(2411),
    [sym_type_apply] = STATE(7537),
    [sym__btype] = STATE(7537),
    [sym_type_infix] = STATE(9633),
    [sym__type_infix] = STATE(9585),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2603),
    [sym__type_quantifiers] = STATE(10631),
    [sym__type_context] = STATE(10631),
    [sym__type_fun] = STATE(10631),
    [sym__type] = STATE(10631),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15103),
    [sym_splice] = STATE(2411),
    [sym_quasiquote] = STATE(2411),
    [sym__varid] = ACTIONS(6615),
    [sym_float] = ACTIONS(6617),
    [sym_char] = ACTIONS(6617),
    [sym_string] = ACTIONS(6617),
    [sym__integer_literal] = ACTIONS(6619),
    [sym__binary_literal] = ACTIONS(6621),
    [sym__octal_literal] = ACTIONS(6621),
    [sym__hex_literal] = ACTIONS(6621),
    [anon_sym_LPAREN_POUND] = ACTIONS(6623),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6623),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6625),
    [sym__conid] = ACTIONS(6629),
    [anon_sym_LBRACK] = ACTIONS(6631),
    [anon_sym_SQUOTE] = ACTIONS(6633),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6635),
    [anon_sym_6] = ACTIONS(6635),
    [anon_sym_7] = ACTIONS(6637),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6639),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6641),
  },
  [2601] = {
    [sym_integer] = STATE(6389),
    [sym__literal] = STATE(6389),
    [sym__unboxed_open] = STATE(2127),
    [sym_constructor] = STATE(6056),
    [sym_con_unit] = STATE(6389),
    [sym_con_list] = STATE(6389),
    [sym_con_tuple] = STATE(6389),
    [sym_qualified_type] = STATE(6375),
    [sym_tycon_arrow] = STATE(6375),
    [sym_type_literal] = STATE(2465),
    [sym__promoted_tycon] = STATE(6375),
    [sym_type_variable] = STATE(6375),
    [sym_annotated_type_variable] = STATE(6375),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14088),
    [sym_type_parens] = STATE(2465),
    [sym_type_list] = STATE(2465),
    [sym_type_tuple] = STATE(2465),
    [sym__type_promotable_literal] = STATE(2465),
    [sym__type_promoted_literal] = STATE(2465),
    [sym__type_literal] = STATE(2465),
    [sym_type_name] = STATE(2446),
    [sym_type_star] = STATE(2465),
    [sym_type_unboxed_tuple] = STATE(2465),
    [sym_type_unboxed_sum] = STATE(2465),
    [sym__atype] = STATE(2465),
    [sym_type_apply] = STATE(7694),
    [sym__btype] = STATE(7694),
    [sym_type_infix] = STATE(9909),
    [sym__type_infix] = STATE(9672),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2601),
    [sym__type_quantifiers] = STATE(12154),
    [sym__type_context] = STATE(12154),
    [sym__type_fun] = STATE(12154),
    [sym__type] = STATE(12154),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15001),
    [sym_splice] = STATE(2465),
    [sym_quasiquote] = STATE(2465),
    [sym__varid] = ACTIONS(6587),
    [sym_float] = ACTIONS(6589),
    [sym_char] = ACTIONS(6589),
    [sym_string] = ACTIONS(6589),
    [sym__integer_literal] = ACTIONS(6591),
    [sym__binary_literal] = ACTIONS(6593),
    [sym__octal_literal] = ACTIONS(6593),
    [sym__hex_literal] = ACTIONS(6593),
    [anon_sym_LPAREN_POUND] = ACTIONS(6595),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6595),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6597),
    [sym__conid] = ACTIONS(6601),
    [anon_sym_LBRACK] = ACTIONS(6603),
    [anon_sym_SQUOTE] = ACTIONS(6605),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6607),
    [anon_sym_6] = ACTIONS(6607),
    [anon_sym_7] = ACTIONS(6609),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6611),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6613),
  },
  [2602] = {
    [sym_integer] = STATE(7386),
    [sym__literal] = STATE(7386),
    [sym__unboxed_open] = STATE(2197),
    [sym_constructor] = STATE(7110),
    [sym_con_unit] = STATE(7386),
    [sym_con_list] = STATE(7386),
    [sym_con_tuple] = STATE(7386),
    [sym_qualified_type] = STATE(7585),
    [sym_tycon_arrow] = STATE(7585),
    [sym_type_literal] = STATE(2736),
    [sym__promoted_tycon] = STATE(7585),
    [sym_type_variable] = STATE(7585),
    [sym_annotated_type_variable] = STATE(7585),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14082),
    [sym_type_parens] = STATE(2736),
    [sym_type_list] = STATE(2736),
    [sym_type_tuple] = STATE(2736),
    [sym__type_promotable_literal] = STATE(2736),
    [sym__type_promoted_literal] = STATE(2736),
    [sym__type_literal] = STATE(2736),
    [sym_type_name] = STATE(2755),
    [sym_type_star] = STATE(2736),
    [sym_type_unboxed_tuple] = STATE(2736),
    [sym_type_unboxed_sum] = STATE(2736),
    [sym__atype] = STATE(2736),
    [sym_type_apply] = STATE(8314),
    [sym__btype] = STATE(8314),
    [sym_type_infix] = STATE(12645),
    [sym__type_infix] = STATE(12371),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2503),
    [sym__type_quantifiers] = STATE(15182),
    [sym__type_context] = STATE(15182),
    [sym__type_fun] = STATE(15182),
    [sym__type] = STATE(15182),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15277),
    [sym_splice] = STATE(2736),
    [sym_quasiquote] = STATE(2736),
    [sym__varid] = ACTIONS(6167),
    [sym_float] = ACTIONS(6169),
    [sym_char] = ACTIONS(6169),
    [sym_string] = ACTIONS(6169),
    [sym__integer_literal] = ACTIONS(6171),
    [sym__binary_literal] = ACTIONS(6173),
    [sym__octal_literal] = ACTIONS(6173),
    [sym__hex_literal] = ACTIONS(6173),
    [anon_sym_LPAREN_POUND] = ACTIONS(6175),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6175),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6177),
    [sym__conid] = ACTIONS(6181),
    [anon_sym_LBRACK] = ACTIONS(6183),
    [anon_sym_SQUOTE] = ACTIONS(6185),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6187),
    [anon_sym_6] = ACTIONS(6187),
    [anon_sym_7] = ACTIONS(6189),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6191),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6193),
  },
  [2603] = {
    [sym_integer] = STATE(6026),
    [sym__literal] = STATE(6026),
    [sym__unboxed_open] = STATE(2192),
    [sym_constructor] = STATE(5913),
    [sym_con_unit] = STATE(6026),
    [sym_con_list] = STATE(6026),
    [sym_con_tuple] = STATE(6026),
    [sym_qualified_type] = STATE(6029),
    [sym_tycon_arrow] = STATE(6029),
    [sym_type_literal] = STATE(2411),
    [sym__promoted_tycon] = STATE(6029),
    [sym_type_variable] = STATE(6029),
    [sym_annotated_type_variable] = STATE(6029),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14334),
    [sym_type_parens] = STATE(2411),
    [sym_type_list] = STATE(2411),
    [sym_type_tuple] = STATE(2411),
    [sym__type_promotable_literal] = STATE(2411),
    [sym__type_promoted_literal] = STATE(2411),
    [sym__type_literal] = STATE(2411),
    [sym_type_name] = STATE(2394),
    [sym_type_star] = STATE(2411),
    [sym_type_unboxed_tuple] = STATE(2411),
    [sym_type_unboxed_sum] = STATE(2411),
    [sym__atype] = STATE(2411),
    [sym_type_apply] = STATE(7537),
    [sym__btype] = STATE(7537),
    [sym_type_infix] = STATE(9633),
    [sym__type_infix] = STATE(9585),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2603),
    [sym__type_quantifiers] = STATE(10636),
    [sym__type_context] = STATE(10636),
    [sym__type_fun] = STATE(10636),
    [sym__type] = STATE(10636),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15103),
    [sym_splice] = STATE(2411),
    [sym_quasiquote] = STATE(2411),
    [sym__varid] = ACTIONS(6615),
    [sym_float] = ACTIONS(6617),
    [sym_char] = ACTIONS(6617),
    [sym_string] = ACTIONS(6617),
    [sym__integer_literal] = ACTIONS(6619),
    [sym__binary_literal] = ACTIONS(6621),
    [sym__octal_literal] = ACTIONS(6621),
    [sym__hex_literal] = ACTIONS(6621),
    [anon_sym_LPAREN_POUND] = ACTIONS(6623),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6623),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6625),
    [sym__conid] = ACTIONS(6629),
    [anon_sym_LBRACK] = ACTIONS(6631),
    [anon_sym_SQUOTE] = ACTIONS(6633),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6635),
    [anon_sym_6] = ACTIONS(6635),
    [anon_sym_7] = ACTIONS(6637),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6639),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6641),
  },
  [2604] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(2971),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(14284),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3372),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym__datainst] = STATE(18057),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_instance] = ACTIONS(8313),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2605] = {
    [sym_integer] = STATE(4881),
    [sym__literal] = STATE(4881),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(4828),
    [sym_con_unit] = STATE(4881),
    [sym_con_list] = STATE(4881),
    [sym_con_tuple] = STATE(4881),
    [sym_qualified_type] = STATE(4884),
    [sym_tycon_arrow] = STATE(4884),
    [sym_type_literal] = STATE(2094),
    [sym__promoted_tycon] = STATE(4884),
    [sym_type_variable] = STATE(4884),
    [sym_annotated_type_variable] = STATE(4884),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14261),
    [sym_type_parens] = STATE(2094),
    [sym_type_list] = STATE(2094),
    [sym_type_tuple] = STATE(2094),
    [sym__type_promotable_literal] = STATE(2094),
    [sym__type_promoted_literal] = STATE(2094),
    [sym__type_literal] = STATE(2094),
    [sym_type_name] = STATE(2088),
    [sym_type_star] = STATE(2094),
    [sym_type_unboxed_tuple] = STATE(2094),
    [sym_type_unboxed_sum] = STATE(2094),
    [sym__atype] = STATE(2094),
    [sym_type_apply] = STATE(6655),
    [sym__btype] = STATE(6655),
    [sym_type_infix] = STATE(9439),
    [sym__type_infix] = STATE(9338),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2605),
    [sym__type_quantifiers] = STATE(9647),
    [sym__type_context] = STATE(9647),
    [sym__type_fun] = STATE(9647),
    [sym__type] = STATE(9647),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15214),
    [sym_splice] = STATE(2094),
    [sym_quasiquote] = STATE(2094),
    [sym__varid] = ACTIONS(5373),
    [sym_float] = ACTIONS(5375),
    [sym_char] = ACTIONS(5375),
    [sym_string] = ACTIONS(5375),
    [sym__integer_literal] = ACTIONS(5377),
    [sym__binary_literal] = ACTIONS(5379),
    [sym__octal_literal] = ACTIONS(5379),
    [sym__hex_literal] = ACTIONS(5379),
    [anon_sym_LPAREN_POUND] = ACTIONS(5381),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5381),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7154),
    [sym__conid] = ACTIONS(7158),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_SQUOTE] = ACTIONS(7160),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5393),
    [anon_sym_6] = ACTIONS(5393),
    [anon_sym_7] = ACTIONS(5395),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5397),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5399),
  },
  [2606] = {
    [sym_integer] = STATE(7397),
    [sym__literal] = STATE(7397),
    [sym__unboxed_open] = STATE(2162),
    [sym_constructor] = STATE(7280),
    [sym_con_unit] = STATE(7397),
    [sym_con_list] = STATE(7397),
    [sym_con_tuple] = STATE(7397),
    [sym_qualified_type] = STATE(7399),
    [sym_tycon_arrow] = STATE(7399),
    [sym_type_literal] = STATE(2749),
    [sym__promoted_tycon] = STATE(7399),
    [sym_type_variable] = STATE(7399),
    [sym_annotated_type_variable] = STATE(7399),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14412),
    [sym_type_parens] = STATE(2749),
    [sym_type_list] = STATE(2749),
    [sym_type_tuple] = STATE(2749),
    [sym__type_promotable_literal] = STATE(2749),
    [sym__type_promoted_literal] = STATE(2749),
    [sym__type_literal] = STATE(2749),
    [sym_type_name] = STATE(2747),
    [sym_type_star] = STATE(2749),
    [sym_type_unboxed_tuple] = STATE(2749),
    [sym_type_unboxed_sum] = STATE(2749),
    [sym__atype] = STATE(2749),
    [sym_type_apply] = STATE(8399),
    [sym__btype] = STATE(8399),
    [sym_type_infix] = STATE(12632),
    [sym__type_infix] = STATE(12341),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2561),
    [sym__type_quantifiers] = STATE(17207),
    [sym__type_context] = STATE(17207),
    [sym__type_fun] = STATE(17207),
    [sym__type] = STATE(17207),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14607),
    [sym_splice] = STATE(2749),
    [sym_quasiquote] = STATE(2749),
    [sym__varid] = ACTIONS(5274),
    [sym_float] = ACTIONS(5276),
    [sym_char] = ACTIONS(5276),
    [sym_string] = ACTIONS(5276),
    [sym__integer_literal] = ACTIONS(5278),
    [sym__binary_literal] = ACTIONS(5280),
    [sym__octal_literal] = ACTIONS(5280),
    [sym__hex_literal] = ACTIONS(5280),
    [anon_sym_LPAREN_POUND] = ACTIONS(5282),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5282),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5284),
    [sym__conid] = ACTIONS(5286),
    [anon_sym_LBRACK] = ACTIONS(5288),
    [anon_sym_SQUOTE] = ACTIONS(5290),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5292),
    [anon_sym_6] = ACTIONS(5292),
    [anon_sym_7] = ACTIONS(5296),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5298),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5300),
  },
  [2607] = {
    [sym_integer] = STATE(7019),
    [sym__literal] = STATE(7019),
    [sym__unboxed_open] = STATE(2169),
    [sym_constructor] = STATE(6740),
    [sym_con_unit] = STATE(7019),
    [sym_con_list] = STATE(7019),
    [sym_con_tuple] = STATE(7019),
    [sym_qualified_type] = STATE(6980),
    [sym_tycon_arrow] = STATE(6980),
    [sym_type_literal] = STATE(2552),
    [sym__promoted_tycon] = STATE(6980),
    [sym_type_variable] = STATE(6980),
    [sym_annotated_type_variable] = STATE(6980),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14019),
    [sym_type_parens] = STATE(2552),
    [sym_type_list] = STATE(2552),
    [sym_type_tuple] = STATE(2552),
    [sym__type_promotable_literal] = STATE(2552),
    [sym__type_promoted_literal] = STATE(2552),
    [sym__type_literal] = STATE(2552),
    [sym_type_name] = STATE(2616),
    [sym_type_star] = STATE(2552),
    [sym_type_unboxed_tuple] = STATE(2552),
    [sym_type_unboxed_sum] = STATE(2552),
    [sym__atype] = STATE(2552),
    [sym_type_apply] = STATE(7895),
    [sym__btype] = STATE(7895),
    [sym_type_infix] = STATE(10510),
    [sym__type_infix] = STATE(10063),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2623),
    [sym__type_quantifiers] = STATE(12693),
    [sym__type_context] = STATE(12693),
    [sym__type_fun] = STATE(12693),
    [sym__type] = STATE(12693),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14684),
    [sym_splice] = STATE(2552),
    [sym_quasiquote] = STATE(2552),
    [sym__varid] = ACTIONS(6559),
    [sym_float] = ACTIONS(6561),
    [sym_char] = ACTIONS(6561),
    [sym_string] = ACTIONS(6561),
    [sym__integer_literal] = ACTIONS(6563),
    [sym__binary_literal] = ACTIONS(6565),
    [sym__octal_literal] = ACTIONS(6565),
    [sym__hex_literal] = ACTIONS(6565),
    [anon_sym_LPAREN_POUND] = ACTIONS(6567),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6567),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6569),
    [sym__conid] = ACTIONS(6573),
    [anon_sym_LBRACK] = ACTIONS(6575),
    [anon_sym_SQUOTE] = ACTIONS(6577),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6579),
    [anon_sym_6] = ACTIONS(6579),
    [anon_sym_7] = ACTIONS(6581),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6583),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6585),
  },
  [2608] = {
    [sym_integer] = STATE(5998),
    [sym__literal] = STATE(5998),
    [sym__unboxed_open] = STATE(2200),
    [sym_constructor] = STATE(5931),
    [sym_con_unit] = STATE(5998),
    [sym_con_list] = STATE(5998),
    [sym_con_tuple] = STATE(5998),
    [sym_qualified_type] = STATE(5996),
    [sym_tycon_arrow] = STATE(5996),
    [sym_type_literal] = STATE(2403),
    [sym__promoted_tycon] = STATE(5996),
    [sym_type_variable] = STATE(5996),
    [sym_annotated_type_variable] = STATE(5996),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14150),
    [sym_type_parens] = STATE(2403),
    [sym_type_list] = STATE(2403),
    [sym_type_tuple] = STATE(2403),
    [sym__type_promotable_literal] = STATE(2403),
    [sym__type_promoted_literal] = STATE(2403),
    [sym__type_literal] = STATE(2403),
    [sym_type_name] = STATE(2433),
    [sym_type_star] = STATE(2403),
    [sym_type_unboxed_tuple] = STATE(2403),
    [sym_type_unboxed_sum] = STATE(2403),
    [sym__atype] = STATE(2403),
    [sym_type_apply] = STATE(7479),
    [sym__btype] = STATE(7479),
    [sym_type_infix] = STATE(9706),
    [sym__type_infix] = STATE(9574),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2632),
    [sym__type_quantifiers] = STATE(11533),
    [sym__type_context] = STATE(11533),
    [sym__type_fun] = STATE(11533),
    [sym__type] = STATE(11533),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15278),
    [sym_splice] = STATE(2403),
    [sym_quasiquote] = STATE(2403),
    [sym__varid] = ACTIONS(6394),
    [sym_float] = ACTIONS(6396),
    [sym_char] = ACTIONS(6396),
    [sym_string] = ACTIONS(6396),
    [sym__integer_literal] = ACTIONS(6398),
    [sym__binary_literal] = ACTIONS(6400),
    [sym__octal_literal] = ACTIONS(6400),
    [sym__hex_literal] = ACTIONS(6400),
    [anon_sym_LPAREN_POUND] = ACTIONS(6402),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6402),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [sym__conid] = ACTIONS(6408),
    [anon_sym_LBRACK] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6412),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6414),
    [anon_sym_6] = ACTIONS(6414),
    [anon_sym_7] = ACTIONS(6416),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6418),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6420),
  },
  [2609] = {
    [sym_integer] = STATE(6751),
    [sym__literal] = STATE(6751),
    [sym__unboxed_open] = STATE(2140),
    [sym_constructor] = STATE(6530),
    [sym_con_unit] = STATE(6751),
    [sym_con_list] = STATE(6751),
    [sym_con_tuple] = STATE(6751),
    [sym_qualified_type] = STATE(6610),
    [sym_tycon_arrow] = STATE(6610),
    [sym_type_literal] = STATE(2499),
    [sym__promoted_tycon] = STATE(6610),
    [sym_type_variable] = STATE(6610),
    [sym_annotated_type_variable] = STATE(6610),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14167),
    [sym_type_parens] = STATE(2499),
    [sym_type_list] = STATE(2499),
    [sym_type_tuple] = STATE(2499),
    [sym__type_promotable_literal] = STATE(2499),
    [sym__type_promoted_literal] = STATE(2499),
    [sym__type_literal] = STATE(2499),
    [sym_type_name] = STATE(2484),
    [sym_type_star] = STATE(2499),
    [sym_type_unboxed_tuple] = STATE(2499),
    [sym_type_unboxed_sum] = STATE(2499),
    [sym__atype] = STATE(2499),
    [sym_type_apply] = STATE(7714),
    [sym__btype] = STATE(7714),
    [sym_type_infix] = STATE(10095),
    [sym__type_infix] = STATE(9721),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2593),
    [sym__type_quantifiers] = STATE(11688),
    [sym__type_context] = STATE(11688),
    [sym__type_fun] = STATE(11688),
    [sym__type] = STATE(11688),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15339),
    [sym_splice] = STATE(2499),
    [sym_quasiquote] = STATE(2499),
    [sym__varid] = ACTIONS(6681),
    [sym_float] = ACTIONS(6683),
    [sym_char] = ACTIONS(6683),
    [sym_string] = ACTIONS(6683),
    [sym__integer_literal] = ACTIONS(6685),
    [sym__binary_literal] = ACTIONS(6687),
    [sym__octal_literal] = ACTIONS(6687),
    [sym__hex_literal] = ACTIONS(6687),
    [anon_sym_LPAREN_POUND] = ACTIONS(6689),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6689),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6691),
    [sym__conid] = ACTIONS(6695),
    [anon_sym_LBRACK] = ACTIONS(6697),
    [anon_sym_SQUOTE] = ACTIONS(6699),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6701),
    [anon_sym_6] = ACTIONS(6701),
    [anon_sym_7] = ACTIONS(6703),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6705),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6707),
  },
  [2610] = {
    [sym_integer] = STATE(6751),
    [sym__literal] = STATE(6751),
    [sym__unboxed_open] = STATE(2140),
    [sym_constructor] = STATE(6530),
    [sym_con_unit] = STATE(6751),
    [sym_con_list] = STATE(6751),
    [sym_con_tuple] = STATE(6751),
    [sym_qualified_type] = STATE(6610),
    [sym_tycon_arrow] = STATE(6610),
    [sym_type_literal] = STATE(2499),
    [sym__promoted_tycon] = STATE(6610),
    [sym_type_variable] = STATE(6610),
    [sym_annotated_type_variable] = STATE(6610),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14167),
    [sym_type_parens] = STATE(2499),
    [sym_type_list] = STATE(2499),
    [sym_type_tuple] = STATE(2499),
    [sym__type_promotable_literal] = STATE(2499),
    [sym__type_promoted_literal] = STATE(2499),
    [sym__type_literal] = STATE(2499),
    [sym_type_name] = STATE(2484),
    [sym_type_star] = STATE(2499),
    [sym_type_unboxed_tuple] = STATE(2499),
    [sym_type_unboxed_sum] = STATE(2499),
    [sym__atype] = STATE(2499),
    [sym_type_apply] = STATE(7714),
    [sym__btype] = STATE(7714),
    [sym_type_infix] = STATE(10095),
    [sym__type_infix] = STATE(9721),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2593),
    [sym__type_quantifiers] = STATE(11687),
    [sym__type_context] = STATE(11687),
    [sym__type_fun] = STATE(11687),
    [sym__type] = STATE(11687),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15339),
    [sym_splice] = STATE(2499),
    [sym_quasiquote] = STATE(2499),
    [sym__varid] = ACTIONS(6681),
    [sym_float] = ACTIONS(6683),
    [sym_char] = ACTIONS(6683),
    [sym_string] = ACTIONS(6683),
    [sym__integer_literal] = ACTIONS(6685),
    [sym__binary_literal] = ACTIONS(6687),
    [sym__octal_literal] = ACTIONS(6687),
    [sym__hex_literal] = ACTIONS(6687),
    [anon_sym_LPAREN_POUND] = ACTIONS(6689),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6689),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6691),
    [sym__conid] = ACTIONS(6695),
    [anon_sym_LBRACK] = ACTIONS(6697),
    [anon_sym_SQUOTE] = ACTIONS(6699),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6701),
    [anon_sym_6] = ACTIONS(6701),
    [anon_sym_7] = ACTIONS(6703),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6705),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6707),
  },
  [2611] = {
    [sym_integer] = STATE(7045),
    [sym__literal] = STATE(7045),
    [sym__unboxed_open] = STATE(2097),
    [sym_constructor] = STATE(6786),
    [sym_con_unit] = STATE(7045),
    [sym_con_list] = STATE(7045),
    [sym_con_tuple] = STATE(7045),
    [sym_qualified_type] = STATE(7047),
    [sym_tycon_arrow] = STATE(7047),
    [sym_type_literal] = STATE(2652),
    [sym__promoted_tycon] = STATE(7047),
    [sym_type_variable] = STATE(7047),
    [sym_annotated_type_variable] = STATE(7047),
    [sym_type_parens] = STATE(2652),
    [sym_type_list] = STATE(2652),
    [sym_type_tuple] = STATE(2652),
    [sym__type_promotable_literal] = STATE(2652),
    [sym__type_promoted_literal] = STATE(2652),
    [sym__type_literal] = STATE(2652),
    [sym_type_name] = STATE(2652),
    [sym_type_star] = STATE(2652),
    [sym_type_unboxed_tuple] = STATE(2652),
    [sym_type_unboxed_sum] = STATE(2652),
    [sym__atype] = STATE(2652),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15321),
    [sym_splice] = STATE(2652),
    [sym_quasiquote] = STATE(2652),
    [aux_sym_type_apply_repeat1] = STATE(2652),
    [sym__varid] = ACTIONS(7257),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(7259),
    [sym_char] = ACTIONS(7259),
    [sym_string] = ACTIONS(7259),
    [sym__integer_literal] = ACTIONS(7261),
    [sym__binary_literal] = ACTIONS(7263),
    [sym__octal_literal] = ACTIONS(7263),
    [sym__hex_literal] = ACTIONS(7263),
    [anon_sym_LPAREN_POUND] = ACTIONS(7265),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7265),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8315),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(8317),
    [anon_sym_LBRACK] = ACTIONS(7273),
    [anon_sym_SQUOTE] = ACTIONS(8320),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(7277),
    [anon_sym_6] = ACTIONS(7277),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_in] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(7279),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym__layout_end] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(7281),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7283),
  },
  [2612] = {
    [sym_integer] = STATE(5998),
    [sym__literal] = STATE(5998),
    [sym__unboxed_open] = STATE(2200),
    [sym_constructor] = STATE(5931),
    [sym_con_unit] = STATE(5998),
    [sym_con_list] = STATE(5998),
    [sym_con_tuple] = STATE(5998),
    [sym_qualified_type] = STATE(5996),
    [sym_tycon_arrow] = STATE(5996),
    [sym_type_literal] = STATE(2403),
    [sym__promoted_tycon] = STATE(5996),
    [sym_type_variable] = STATE(5996),
    [sym_annotated_type_variable] = STATE(5996),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14150),
    [sym_type_parens] = STATE(2403),
    [sym_type_list] = STATE(2403),
    [sym_type_tuple] = STATE(2403),
    [sym__type_promotable_literal] = STATE(2403),
    [sym__type_promoted_literal] = STATE(2403),
    [sym__type_literal] = STATE(2403),
    [sym_type_name] = STATE(2433),
    [sym_type_star] = STATE(2403),
    [sym_type_unboxed_tuple] = STATE(2403),
    [sym_type_unboxed_sum] = STATE(2403),
    [sym__atype] = STATE(2403),
    [sym_type_apply] = STATE(7479),
    [sym__btype] = STATE(7479),
    [sym_type_infix] = STATE(9706),
    [sym__type_infix] = STATE(9574),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2632),
    [sym__type_quantifiers] = STATE(11535),
    [sym__type_context] = STATE(11535),
    [sym__type_fun] = STATE(11535),
    [sym__type] = STATE(11535),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15278),
    [sym_splice] = STATE(2403),
    [sym_quasiquote] = STATE(2403),
    [sym__varid] = ACTIONS(6394),
    [sym_float] = ACTIONS(6396),
    [sym_char] = ACTIONS(6396),
    [sym_string] = ACTIONS(6396),
    [sym__integer_literal] = ACTIONS(6398),
    [sym__binary_literal] = ACTIONS(6400),
    [sym__octal_literal] = ACTIONS(6400),
    [sym__hex_literal] = ACTIONS(6400),
    [anon_sym_LPAREN_POUND] = ACTIONS(6402),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6402),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [sym__conid] = ACTIONS(6408),
    [anon_sym_LBRACK] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6412),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6414),
    [anon_sym_6] = ACTIONS(6414),
    [anon_sym_7] = ACTIONS(6416),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6418),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6420),
  },
  [2613] = {
    [sym_integer] = STATE(4542),
    [sym__literal] = STATE(4542),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(4213),
    [sym_con_unit] = STATE(4542),
    [sym_con_list] = STATE(4542),
    [sym_con_tuple] = STATE(4542),
    [sym_qualified_type] = STATE(4722),
    [sym_tycon_arrow] = STATE(4722),
    [sym_type_literal] = STATE(2080),
    [sym__promoted_tycon] = STATE(4722),
    [sym_type_variable] = STATE(4722),
    [sym_annotated_type_variable] = STATE(4722),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14007),
    [sym_type_parens] = STATE(2080),
    [sym_type_list] = STATE(2080),
    [sym_type_tuple] = STATE(2080),
    [sym__type_promotable_literal] = STATE(2080),
    [sym__type_promoted_literal] = STATE(2080),
    [sym__type_literal] = STATE(2080),
    [sym_type_name] = STATE(2082),
    [sym_type_star] = STATE(2080),
    [sym_type_unboxed_tuple] = STATE(2080),
    [sym_type_unboxed_sum] = STATE(2080),
    [sym__atype] = STATE(2080),
    [sym_type_apply] = STATE(6274),
    [sym__btype] = STATE(6274),
    [sym_type_infix] = STATE(9268),
    [sym__type_infix] = STATE(9218),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2613),
    [sym__type_quantifiers] = STATE(9531),
    [sym__type_context] = STATE(9531),
    [sym__type_fun] = STATE(9531),
    [sym__type] = STATE(9531),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14868),
    [sym_splice] = STATE(2080),
    [sym_quasiquote] = STATE(2080),
    [sym__varid] = ACTIONS(5191),
    [sym_float] = ACTIONS(5193),
    [sym_char] = ACTIONS(5193),
    [sym_string] = ACTIONS(5193),
    [sym__integer_literal] = ACTIONS(5195),
    [sym__binary_literal] = ACTIONS(5197),
    [sym__octal_literal] = ACTIONS(5197),
    [sym__hex_literal] = ACTIONS(5197),
    [anon_sym_LPAREN_POUND] = ACTIONS(5199),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5199),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5994),
    [sym__conid] = ACTIONS(5998),
    [anon_sym_LBRACK] = ACTIONS(5206),
    [anon_sym_SQUOTE] = ACTIONS(6000),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5211),
    [anon_sym_6] = ACTIONS(5211),
    [anon_sym_7] = ACTIONS(5213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5215),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5217),
  },
  [2614] = {
    [sym_integer] = STATE(4881),
    [sym__literal] = STATE(4881),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(4828),
    [sym_con_unit] = STATE(4881),
    [sym_con_list] = STATE(4881),
    [sym_con_tuple] = STATE(4881),
    [sym_qualified_type] = STATE(4884),
    [sym_tycon_arrow] = STATE(4884),
    [sym_type_literal] = STATE(2094),
    [sym__promoted_tycon] = STATE(4884),
    [sym_type_variable] = STATE(4884),
    [sym_annotated_type_variable] = STATE(4884),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14261),
    [sym_type_parens] = STATE(2094),
    [sym_type_list] = STATE(2094),
    [sym_type_tuple] = STATE(2094),
    [sym__type_promotable_literal] = STATE(2094),
    [sym__type_promoted_literal] = STATE(2094),
    [sym__type_literal] = STATE(2094),
    [sym_type_name] = STATE(2088),
    [sym_type_star] = STATE(2094),
    [sym_type_unboxed_tuple] = STATE(2094),
    [sym_type_unboxed_sum] = STATE(2094),
    [sym__atype] = STATE(2094),
    [sym_type_apply] = STATE(6655),
    [sym__btype] = STATE(6655),
    [sym_type_infix] = STATE(9439),
    [sym__type_infix] = STATE(9338),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2605),
    [sym__type_quantifiers] = STATE(9588),
    [sym__type_context] = STATE(9588),
    [sym__type_fun] = STATE(9588),
    [sym__type] = STATE(9588),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15214),
    [sym_splice] = STATE(2094),
    [sym_quasiquote] = STATE(2094),
    [sym__varid] = ACTIONS(5373),
    [sym_float] = ACTIONS(5375),
    [sym_char] = ACTIONS(5375),
    [sym_string] = ACTIONS(5375),
    [sym__integer_literal] = ACTIONS(5377),
    [sym__binary_literal] = ACTIONS(5379),
    [sym__octal_literal] = ACTIONS(5379),
    [sym__hex_literal] = ACTIONS(5379),
    [anon_sym_LPAREN_POUND] = ACTIONS(5381),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5381),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7154),
    [sym__conid] = ACTIONS(7158),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_SQUOTE] = ACTIONS(7160),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5393),
    [anon_sym_6] = ACTIONS(5393),
    [anon_sym_7] = ACTIONS(5395),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5397),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5399),
  },
  [2615] = {
    [sym_integer] = STATE(7224),
    [sym__literal] = STATE(7224),
    [sym__unboxed_open] = STATE(2201),
    [sym_constructor] = STATE(6997),
    [sym_con_unit] = STATE(7224),
    [sym_con_list] = STATE(7224),
    [sym_con_tuple] = STATE(7224),
    [sym_qualified_type] = STATE(7098),
    [sym_tycon_arrow] = STATE(7098),
    [sym_type_literal] = STATE(2726),
    [sym__promoted_tycon] = STATE(7098),
    [sym_type_variable] = STATE(7098),
    [sym_annotated_type_variable] = STATE(7098),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14123),
    [sym_type_parens] = STATE(2726),
    [sym_type_list] = STATE(2726),
    [sym_type_tuple] = STATE(2726),
    [sym__type_promotable_literal] = STATE(2726),
    [sym__type_promoted_literal] = STATE(2726),
    [sym__type_literal] = STATE(2726),
    [sym_type_name] = STATE(2712),
    [sym_type_star] = STATE(2726),
    [sym_type_unboxed_tuple] = STATE(2726),
    [sym_type_unboxed_sum] = STATE(2726),
    [sym__atype] = STATE(2726),
    [sym_type_apply] = STATE(8043),
    [sym__btype] = STATE(8043),
    [sym_type_infix] = STATE(12452),
    [sym__type_infix] = STATE(12183),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2594),
    [sym__type_quantifiers] = STATE(14110),
    [sym__type_context] = STATE(14110),
    [sym__type_fun] = STATE(14110),
    [sym__type] = STATE(14110),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15261),
    [sym_splice] = STATE(2726),
    [sym_quasiquote] = STATE(2726),
    [sym__varid] = ACTIONS(6531),
    [sym_float] = ACTIONS(6533),
    [sym_char] = ACTIONS(6533),
    [sym_string] = ACTIONS(6533),
    [sym__integer_literal] = ACTIONS(6535),
    [sym__binary_literal] = ACTIONS(6537),
    [sym__octal_literal] = ACTIONS(6537),
    [sym__hex_literal] = ACTIONS(6537),
    [anon_sym_LPAREN_POUND] = ACTIONS(6539),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6539),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6541),
    [sym__conid] = ACTIONS(6545),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_SQUOTE] = ACTIONS(6549),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6551),
    [anon_sym_6] = ACTIONS(6551),
    [anon_sym_7] = ACTIONS(6553),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6555),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6557),
  },
  [2616] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5129),
    [sym_quasiquote_start] = ACTIONS(5168),
    [sym__unboxed_close] = ACTIONS(5129),
  },
  [2617] = {
    [sym_integer] = STATE(4881),
    [sym__literal] = STATE(4881),
    [sym__unboxed_open] = STATE(2167),
    [sym_constructor] = STATE(4828),
    [sym_con_unit] = STATE(4881),
    [sym_con_list] = STATE(4881),
    [sym_con_tuple] = STATE(4881),
    [sym_qualified_type] = STATE(4884),
    [sym_tycon_arrow] = STATE(4884),
    [sym_type_literal] = STATE(2094),
    [sym__promoted_tycon] = STATE(4884),
    [sym_type_variable] = STATE(4884),
    [sym_annotated_type_variable] = STATE(4884),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14261),
    [sym_type_parens] = STATE(2094),
    [sym_type_list] = STATE(2094),
    [sym_type_tuple] = STATE(2094),
    [sym__type_promotable_literal] = STATE(2094),
    [sym__type_promoted_literal] = STATE(2094),
    [sym__type_literal] = STATE(2094),
    [sym_type_name] = STATE(2088),
    [sym_type_star] = STATE(2094),
    [sym_type_unboxed_tuple] = STATE(2094),
    [sym_type_unboxed_sum] = STATE(2094),
    [sym__atype] = STATE(2094),
    [sym_type_apply] = STATE(6655),
    [sym__btype] = STATE(6655),
    [sym_type_infix] = STATE(9439),
    [sym__type_infix] = STATE(9338),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2605),
    [sym__type_quantifiers] = STATE(9651),
    [sym__type_context] = STATE(9651),
    [sym__type_fun] = STATE(9651),
    [sym__type] = STATE(9651),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15214),
    [sym_splice] = STATE(2094),
    [sym_quasiquote] = STATE(2094),
    [sym__varid] = ACTIONS(5373),
    [sym_float] = ACTIONS(5375),
    [sym_char] = ACTIONS(5375),
    [sym_string] = ACTIONS(5375),
    [sym__integer_literal] = ACTIONS(5377),
    [sym__binary_literal] = ACTIONS(5379),
    [sym__octal_literal] = ACTIONS(5379),
    [sym__hex_literal] = ACTIONS(5379),
    [anon_sym_LPAREN_POUND] = ACTIONS(5381),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5381),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7154),
    [sym__conid] = ACTIONS(7158),
    [anon_sym_LBRACK] = ACTIONS(5388),
    [anon_sym_SQUOTE] = ACTIONS(7160),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5393),
    [anon_sym_6] = ACTIONS(5393),
    [anon_sym_7] = ACTIONS(5395),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5397),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5399),
  },
  [2618] = {
    [sym_integer] = STATE(7019),
    [sym__literal] = STATE(7019),
    [sym__unboxed_open] = STATE(2169),
    [sym_constructor] = STATE(6740),
    [sym_con_unit] = STATE(7019),
    [sym_con_list] = STATE(7019),
    [sym_con_tuple] = STATE(7019),
    [sym_qualified_type] = STATE(6980),
    [sym_tycon_arrow] = STATE(6980),
    [sym_type_literal] = STATE(2552),
    [sym__promoted_tycon] = STATE(6980),
    [sym_type_variable] = STATE(6980),
    [sym_annotated_type_variable] = STATE(6980),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14019),
    [sym_type_parens] = STATE(2552),
    [sym_type_list] = STATE(2552),
    [sym_type_tuple] = STATE(2552),
    [sym__type_promotable_literal] = STATE(2552),
    [sym__type_promoted_literal] = STATE(2552),
    [sym__type_literal] = STATE(2552),
    [sym_type_name] = STATE(2616),
    [sym_type_star] = STATE(2552),
    [sym_type_unboxed_tuple] = STATE(2552),
    [sym_type_unboxed_sum] = STATE(2552),
    [sym__atype] = STATE(2552),
    [sym_type_apply] = STATE(7895),
    [sym__btype] = STATE(7895),
    [sym_type_infix] = STATE(10510),
    [sym__type_infix] = STATE(10063),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2623),
    [sym__type_quantifiers] = STATE(12691),
    [sym__type_context] = STATE(12691),
    [sym__type_fun] = STATE(12691),
    [sym__type] = STATE(12691),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14684),
    [sym_splice] = STATE(2552),
    [sym_quasiquote] = STATE(2552),
    [sym__varid] = ACTIONS(6559),
    [sym_float] = ACTIONS(6561),
    [sym_char] = ACTIONS(6561),
    [sym_string] = ACTIONS(6561),
    [sym__integer_literal] = ACTIONS(6563),
    [sym__binary_literal] = ACTIONS(6565),
    [sym__octal_literal] = ACTIONS(6565),
    [sym__hex_literal] = ACTIONS(6565),
    [anon_sym_LPAREN_POUND] = ACTIONS(6567),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6567),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6569),
    [sym__conid] = ACTIONS(6573),
    [anon_sym_LBRACK] = ACTIONS(6575),
    [anon_sym_SQUOTE] = ACTIONS(6577),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6579),
    [anon_sym_6] = ACTIONS(6579),
    [anon_sym_7] = ACTIONS(6581),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6583),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6585),
  },
  [2619] = {
    [sym_integer] = STATE(6425),
    [sym__literal] = STATE(6425),
    [sym__unboxed_open] = STATE(2108),
    [sym_constructor] = STATE(5969),
    [sym_con_unit] = STATE(6425),
    [sym_con_list] = STATE(6425),
    [sym_con_tuple] = STATE(6425),
    [sym_qualified_type] = STATE(6424),
    [sym_tycon_arrow] = STATE(6424),
    [sym_type_literal] = STATE(2461),
    [sym__promoted_tycon] = STATE(6424),
    [sym_type_variable] = STATE(6424),
    [sym_annotated_type_variable] = STATE(6424),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14052),
    [sym_type_parens] = STATE(2461),
    [sym_type_list] = STATE(2461),
    [sym_type_tuple] = STATE(2461),
    [sym__type_promotable_literal] = STATE(2461),
    [sym__type_promoted_literal] = STATE(2461),
    [sym__type_literal] = STATE(2461),
    [sym_type_name] = STATE(2449),
    [sym_type_star] = STATE(2461),
    [sym_type_unboxed_tuple] = STATE(2461),
    [sym_type_unboxed_sum] = STATE(2461),
    [sym__atype] = STATE(2461),
    [sym_type_apply] = STATE(7690),
    [sym__btype] = STATE(7690),
    [sym_type_infix] = STATE(11131),
    [sym__type_infix] = STATE(11614),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2619),
    [sym__type_quantifiers] = STATE(13526),
    [sym__type_context] = STATE(13526),
    [sym__type_fun] = STATE(13526),
    [sym__type] = STATE(13526),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15009),
    [sym_splice] = STATE(2461),
    [sym_quasiquote] = STATE(2461),
    [sym__varid] = ACTIONS(7229),
    [sym_float] = ACTIONS(7231),
    [sym_char] = ACTIONS(7231),
    [sym_string] = ACTIONS(7231),
    [sym__integer_literal] = ACTIONS(7233),
    [sym__binary_literal] = ACTIONS(7235),
    [sym__octal_literal] = ACTIONS(7235),
    [sym__hex_literal] = ACTIONS(7235),
    [anon_sym_LPAREN_POUND] = ACTIONS(7237),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7237),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7239),
    [sym__conid] = ACTIONS(7243),
    [anon_sym_LBRACK] = ACTIONS(7245),
    [anon_sym_SQUOTE] = ACTIONS(7247),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7249),
    [anon_sym_6] = ACTIONS(7249),
    [anon_sym_7] = ACTIONS(7251),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7253),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7255),
  },
  [2620] = {
    [sym_integer] = STATE(7705),
    [sym__literal] = STATE(7705),
    [sym__unboxed_open] = STATE(2184),
    [sym_constructor] = STATE(7681),
    [sym_con_unit] = STATE(7705),
    [sym_con_list] = STATE(7705),
    [sym_con_tuple] = STATE(7705),
    [sym_qualified_type] = STATE(7706),
    [sym_tycon_arrow] = STATE(7706),
    [sym_type_literal] = STATE(2802),
    [sym__promoted_tycon] = STATE(7706),
    [sym_type_variable] = STATE(7706),
    [sym_annotated_type_variable] = STATE(7706),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14603),
    [sym_type_parens] = STATE(2802),
    [sym_type_list] = STATE(2802),
    [sym_type_tuple] = STATE(2802),
    [sym__type_promotable_literal] = STATE(2802),
    [sym__type_promoted_literal] = STATE(2802),
    [sym__type_literal] = STATE(2802),
    [sym_type_name] = STATE(2805),
    [sym_type_star] = STATE(2802),
    [sym_type_unboxed_tuple] = STATE(2802),
    [sym_type_unboxed_sum] = STATE(2802),
    [sym__atype] = STATE(2802),
    [sym_type_apply] = STATE(8735),
    [sym__btype] = STATE(8735),
    [sym_type_infix] = STATE(13317),
    [sym__type_infix] = STATE(13018),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2597),
    [sym__type_quantifiers] = STATE(14888),
    [sym__type_context] = STATE(14888),
    [sym__type_fun] = STATE(14888),
    [sym__type] = STATE(14888),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15120),
    [sym_splice] = STATE(2802),
    [sym_quasiquote] = STATE(2802),
    [sym__varid] = ACTIONS(6139),
    [sym_float] = ACTIONS(6141),
    [sym_char] = ACTIONS(6141),
    [sym_string] = ACTIONS(6141),
    [sym__integer_literal] = ACTIONS(6143),
    [sym__binary_literal] = ACTIONS(6145),
    [sym__octal_literal] = ACTIONS(6145),
    [sym__hex_literal] = ACTIONS(6145),
    [anon_sym_LPAREN_POUND] = ACTIONS(6147),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6147),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6149),
    [sym__conid] = ACTIONS(6153),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_SQUOTE] = ACTIONS(6157),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6159),
    [anon_sym_6] = ACTIONS(6159),
    [anon_sym_7] = ACTIONS(6161),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6163),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6165),
  },
  [2621] = {
    [sym_integer] = STATE(7045),
    [sym__literal] = STATE(7045),
    [sym__unboxed_open] = STATE(2097),
    [sym_constructor] = STATE(6786),
    [sym_con_unit] = STATE(7045),
    [sym_con_list] = STATE(7045),
    [sym_con_tuple] = STATE(7045),
    [sym_qualified_type] = STATE(7047),
    [sym_tycon_arrow] = STATE(7047),
    [sym_type_literal] = STATE(2611),
    [sym__promoted_tycon] = STATE(7047),
    [sym_type_variable] = STATE(7047),
    [sym_annotated_type_variable] = STATE(7047),
    [sym_type_parens] = STATE(2611),
    [sym_type_list] = STATE(2611),
    [sym_type_tuple] = STATE(2611),
    [sym__type_promotable_literal] = STATE(2611),
    [sym__type_promoted_literal] = STATE(2611),
    [sym__type_literal] = STATE(2611),
    [sym_type_name] = STATE(2611),
    [sym_type_star] = STATE(2611),
    [sym_type_unboxed_tuple] = STATE(2611),
    [sym_type_unboxed_sum] = STATE(2611),
    [sym__atype] = STATE(2611),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15321),
    [sym_splice] = STATE(2611),
    [sym_quasiquote] = STATE(2611),
    [aux_sym_type_apply_repeat1] = STATE(2611),
    [sym__varid] = ACTIONS(7257),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(7259),
    [sym_char] = ACTIONS(7259),
    [sym_string] = ACTIONS(7259),
    [sym__integer_literal] = ACTIONS(7261),
    [sym__binary_literal] = ACTIONS(7263),
    [sym__octal_literal] = ACTIONS(7263),
    [sym__hex_literal] = ACTIONS(7263),
    [anon_sym_LPAREN_POUND] = ACTIONS(7265),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7265),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8315),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(8323),
    [anon_sym_LBRACK] = ACTIONS(7273),
    [anon_sym_SQUOTE] = ACTIONS(8326),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(7277),
    [anon_sym_6] = ACTIONS(7277),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_in] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(7279),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym__layout_end] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(7281),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7283),
  },
  [2622] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [anon_sym_4] = ACTIONS(5129),
    [anon_sym_COLON_COLON] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5160),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__varsym] = ACTIONS(5129),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
    [sym__unboxed_close] = ACTIONS(5129),
  },
  [2623] = {
    [sym_integer] = STATE(7019),
    [sym__literal] = STATE(7019),
    [sym__unboxed_open] = STATE(2169),
    [sym_constructor] = STATE(6740),
    [sym_con_unit] = STATE(7019),
    [sym_con_list] = STATE(7019),
    [sym_con_tuple] = STATE(7019),
    [sym_qualified_type] = STATE(6980),
    [sym_tycon_arrow] = STATE(6980),
    [sym_type_literal] = STATE(2552),
    [sym__promoted_tycon] = STATE(6980),
    [sym_type_variable] = STATE(6980),
    [sym_annotated_type_variable] = STATE(6980),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14019),
    [sym_type_parens] = STATE(2552),
    [sym_type_list] = STATE(2552),
    [sym_type_tuple] = STATE(2552),
    [sym__type_promotable_literal] = STATE(2552),
    [sym__type_promoted_literal] = STATE(2552),
    [sym__type_literal] = STATE(2552),
    [sym_type_name] = STATE(2616),
    [sym_type_star] = STATE(2552),
    [sym_type_unboxed_tuple] = STATE(2552),
    [sym_type_unboxed_sum] = STATE(2552),
    [sym__atype] = STATE(2552),
    [sym_type_apply] = STATE(7895),
    [sym__btype] = STATE(7895),
    [sym_type_infix] = STATE(10510),
    [sym__type_infix] = STATE(10063),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2623),
    [sym__type_quantifiers] = STATE(12694),
    [sym__type_context] = STATE(12694),
    [sym__type_fun] = STATE(12694),
    [sym__type] = STATE(12694),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14684),
    [sym_splice] = STATE(2552),
    [sym_quasiquote] = STATE(2552),
    [sym__varid] = ACTIONS(6559),
    [sym_float] = ACTIONS(6561),
    [sym_char] = ACTIONS(6561),
    [sym_string] = ACTIONS(6561),
    [sym__integer_literal] = ACTIONS(6563),
    [sym__binary_literal] = ACTIONS(6565),
    [sym__octal_literal] = ACTIONS(6565),
    [sym__hex_literal] = ACTIONS(6565),
    [anon_sym_LPAREN_POUND] = ACTIONS(6567),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6567),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6569),
    [sym__conid] = ACTIONS(6573),
    [anon_sym_LBRACK] = ACTIONS(6575),
    [anon_sym_SQUOTE] = ACTIONS(6577),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6579),
    [anon_sym_6] = ACTIONS(6579),
    [anon_sym_7] = ACTIONS(6581),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6583),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6585),
  },
  [2624] = {
    [sym_integer] = STATE(4542),
    [sym__literal] = STATE(4542),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(4213),
    [sym_con_unit] = STATE(4542),
    [sym_con_list] = STATE(4542),
    [sym_con_tuple] = STATE(4542),
    [sym_qualified_type] = STATE(4722),
    [sym_tycon_arrow] = STATE(4722),
    [sym_type_literal] = STATE(2080),
    [sym__promoted_tycon] = STATE(4722),
    [sym_type_variable] = STATE(4722),
    [sym_annotated_type_variable] = STATE(4722),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14007),
    [sym_type_parens] = STATE(2080),
    [sym_type_list] = STATE(2080),
    [sym_type_tuple] = STATE(2080),
    [sym__type_promotable_literal] = STATE(2080),
    [sym__type_promoted_literal] = STATE(2080),
    [sym__type_literal] = STATE(2080),
    [sym_type_name] = STATE(2082),
    [sym_type_star] = STATE(2080),
    [sym_type_unboxed_tuple] = STATE(2080),
    [sym_type_unboxed_sum] = STATE(2080),
    [sym__atype] = STATE(2080),
    [sym_type_apply] = STATE(6274),
    [sym__btype] = STATE(6274),
    [sym_type_infix] = STATE(9268),
    [sym__type_infix] = STATE(9218),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2613),
    [sym__type_quantifiers] = STATE(9541),
    [sym__type_context] = STATE(9541),
    [sym__type_fun] = STATE(9541),
    [sym__type] = STATE(9541),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14868),
    [sym_splice] = STATE(2080),
    [sym_quasiquote] = STATE(2080),
    [sym__varid] = ACTIONS(5191),
    [sym_float] = ACTIONS(5193),
    [sym_char] = ACTIONS(5193),
    [sym_string] = ACTIONS(5193),
    [sym__integer_literal] = ACTIONS(5195),
    [sym__binary_literal] = ACTIONS(5197),
    [sym__octal_literal] = ACTIONS(5197),
    [sym__hex_literal] = ACTIONS(5197),
    [anon_sym_LPAREN_POUND] = ACTIONS(5199),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5199),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5994),
    [sym__conid] = ACTIONS(5998),
    [anon_sym_LBRACK] = ACTIONS(5206),
    [anon_sym_SQUOTE] = ACTIONS(6000),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5211),
    [anon_sym_6] = ACTIONS(5211),
    [anon_sym_7] = ACTIONS(5213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5215),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5217),
  },
  [2625] = {
    [sym_integer] = STATE(4542),
    [sym__literal] = STATE(4542),
    [sym__unboxed_open] = STATE(2168),
    [sym_constructor] = STATE(4213),
    [sym_con_unit] = STATE(4542),
    [sym_con_list] = STATE(4542),
    [sym_con_tuple] = STATE(4542),
    [sym_qualified_type] = STATE(4722),
    [sym_tycon_arrow] = STATE(4722),
    [sym_type_literal] = STATE(2080),
    [sym__promoted_tycon] = STATE(4722),
    [sym_type_variable] = STATE(4722),
    [sym_annotated_type_variable] = STATE(4722),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14007),
    [sym_type_parens] = STATE(2080),
    [sym_type_list] = STATE(2080),
    [sym_type_tuple] = STATE(2080),
    [sym__type_promotable_literal] = STATE(2080),
    [sym__type_promoted_literal] = STATE(2080),
    [sym__type_literal] = STATE(2080),
    [sym_type_name] = STATE(2082),
    [sym_type_star] = STATE(2080),
    [sym_type_unboxed_tuple] = STATE(2080),
    [sym_type_unboxed_sum] = STATE(2080),
    [sym__atype] = STATE(2080),
    [sym_type_apply] = STATE(6274),
    [sym__btype] = STATE(6274),
    [sym_type_infix] = STATE(9268),
    [sym__type_infix] = STATE(9218),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2613),
    [sym__type_quantifiers] = STATE(9539),
    [sym__type_context] = STATE(9539),
    [sym__type_fun] = STATE(9539),
    [sym__type] = STATE(9539),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14868),
    [sym_splice] = STATE(2080),
    [sym_quasiquote] = STATE(2080),
    [sym__varid] = ACTIONS(5191),
    [sym_float] = ACTIONS(5193),
    [sym_char] = ACTIONS(5193),
    [sym_string] = ACTIONS(5193),
    [sym__integer_literal] = ACTIONS(5195),
    [sym__binary_literal] = ACTIONS(5197),
    [sym__octal_literal] = ACTIONS(5197),
    [sym__hex_literal] = ACTIONS(5197),
    [anon_sym_LPAREN_POUND] = ACTIONS(5199),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5199),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5994),
    [sym__conid] = ACTIONS(5998),
    [anon_sym_LBRACK] = ACTIONS(5206),
    [anon_sym_SQUOTE] = ACTIONS(6000),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5211),
    [anon_sym_6] = ACTIONS(5211),
    [anon_sym_7] = ACTIONS(5213),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5215),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5217),
  },
  [2626] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(10311),
    [sym__type_context] = STATE(10311),
    [sym__type_fun] = STATE(10311),
    [sym__type] = STATE(10311),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2627] = {
    [sym_integer] = STATE(7019),
    [sym__literal] = STATE(7019),
    [sym__unboxed_open] = STATE(2169),
    [sym_constructor] = STATE(6740),
    [sym_con_unit] = STATE(7019),
    [sym_con_list] = STATE(7019),
    [sym_con_tuple] = STATE(7019),
    [sym_qualified_type] = STATE(6980),
    [sym_tycon_arrow] = STATE(6980),
    [sym_type_literal] = STATE(2627),
    [sym__promoted_tycon] = STATE(6980),
    [sym_type_variable] = STATE(6980),
    [sym_annotated_type_variable] = STATE(6980),
    [sym_type_parens] = STATE(2627),
    [sym_type_list] = STATE(2627),
    [sym_type_tuple] = STATE(2627),
    [sym__type_promotable_literal] = STATE(2627),
    [sym__type_promoted_literal] = STATE(2627),
    [sym__type_literal] = STATE(2627),
    [sym_type_name] = STATE(2627),
    [sym_type_star] = STATE(2627),
    [sym_type_unboxed_tuple] = STATE(2627),
    [sym_type_unboxed_sum] = STATE(2627),
    [sym__atype] = STATE(2627),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14684),
    [sym_splice] = STATE(2627),
    [sym_quasiquote] = STATE(2627),
    [aux_sym_type_apply_repeat1] = STATE(2627),
    [sym__varid] = ACTIONS(8329),
    [sym_float] = ACTIONS(8332),
    [sym_char] = ACTIONS(8332),
    [sym_string] = ACTIONS(8332),
    [sym__integer_literal] = ACTIONS(8335),
    [sym__binary_literal] = ACTIONS(8338),
    [sym__octal_literal] = ACTIONS(8338),
    [sym__hex_literal] = ACTIONS(8338),
    [anon_sym_LPAREN_POUND] = ACTIONS(8341),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8341),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(8344),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(8347),
    [anon_sym_LBRACK] = ACTIONS(8350),
    [anon_sym_SQUOTE] = ACTIONS(8353),
    [anon_sym_STAR] = ACTIONS(8356),
    [anon_sym_6] = ACTIONS(8356),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(8359),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8362),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5030),
    [sym_quasiquote_start] = ACTIONS(8365),
    [sym__unboxed_close] = ACTIONS(5030),
  },
  [2628] = {
    [sym_integer] = STATE(7104),
    [sym__literal] = STATE(7104),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7046),
    [sym_con_unit] = STATE(7104),
    [sym_con_list] = STATE(7104),
    [sym_con_tuple] = STATE(7104),
    [sym_qualified_type] = STATE(7087),
    [sym_tycon_arrow] = STATE(7087),
    [sym_type_literal] = STATE(2721),
    [sym__promoted_tycon] = STATE(7087),
    [sym_type_variable] = STATE(7087),
    [sym_annotated_type_variable] = STATE(7087),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14084),
    [sym_type_parens] = STATE(2721),
    [sym_type_list] = STATE(2721),
    [sym_type_tuple] = STATE(2721),
    [sym__type_promotable_literal] = STATE(2721),
    [sym__type_promoted_literal] = STATE(2721),
    [sym__type_literal] = STATE(2721),
    [sym_type_name] = STATE(2688),
    [sym_type_star] = STATE(2721),
    [sym_type_unboxed_tuple] = STATE(2721),
    [sym_type_unboxed_sum] = STATE(2721),
    [sym__atype] = STATE(2721),
    [sym_type_apply] = STATE(8113),
    [sym__btype] = STATE(8113),
    [sym_type_infix] = STATE(12422),
    [sym__type_infix] = STATE(11995),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2636),
    [sym__type_quantifiers] = STATE(14584),
    [sym__type_context] = STATE(14584),
    [sym__type_fun] = STATE(14584),
    [sym__type] = STATE(14584),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15134),
    [sym_splice] = STATE(2721),
    [sym_quasiquote] = STATE(2721),
    [sym__varid] = ACTIONS(6366),
    [sym_float] = ACTIONS(6368),
    [sym_char] = ACTIONS(6368),
    [sym_string] = ACTIONS(6368),
    [sym__integer_literal] = ACTIONS(6370),
    [sym__binary_literal] = ACTIONS(6372),
    [sym__octal_literal] = ACTIONS(6372),
    [sym__hex_literal] = ACTIONS(6372),
    [anon_sym_LPAREN_POUND] = ACTIONS(6374),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6374),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [sym__conid] = ACTIONS(6380),
    [anon_sym_LBRACK] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6384),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6386),
    [anon_sym_6] = ACTIONS(6386),
    [anon_sym_7] = ACTIONS(6388),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6390),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6392),
  },
  [2629] = {
    [sym_integer] = STATE(7104),
    [sym__literal] = STATE(7104),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7046),
    [sym_con_unit] = STATE(7104),
    [sym_con_list] = STATE(7104),
    [sym_con_tuple] = STATE(7104),
    [sym_qualified_type] = STATE(7087),
    [sym_tycon_arrow] = STATE(7087),
    [sym_type_literal] = STATE(2721),
    [sym__promoted_tycon] = STATE(7087),
    [sym_type_variable] = STATE(7087),
    [sym_annotated_type_variable] = STATE(7087),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14084),
    [sym_type_parens] = STATE(2721),
    [sym_type_list] = STATE(2721),
    [sym_type_tuple] = STATE(2721),
    [sym__type_promotable_literal] = STATE(2721),
    [sym__type_promoted_literal] = STATE(2721),
    [sym__type_literal] = STATE(2721),
    [sym_type_name] = STATE(2688),
    [sym_type_star] = STATE(2721),
    [sym_type_unboxed_tuple] = STATE(2721),
    [sym_type_unboxed_sum] = STATE(2721),
    [sym__atype] = STATE(2721),
    [sym_type_apply] = STATE(8113),
    [sym__btype] = STATE(8113),
    [sym_type_infix] = STATE(12422),
    [sym__type_infix] = STATE(11995),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2636),
    [sym__type_quantifiers] = STATE(14581),
    [sym__type_context] = STATE(14581),
    [sym__type_fun] = STATE(14581),
    [sym__type] = STATE(14581),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15134),
    [sym_splice] = STATE(2721),
    [sym_quasiquote] = STATE(2721),
    [sym__varid] = ACTIONS(6366),
    [sym_float] = ACTIONS(6368),
    [sym_char] = ACTIONS(6368),
    [sym_string] = ACTIONS(6368),
    [sym__integer_literal] = ACTIONS(6370),
    [sym__binary_literal] = ACTIONS(6372),
    [sym__octal_literal] = ACTIONS(6372),
    [sym__hex_literal] = ACTIONS(6372),
    [anon_sym_LPAREN_POUND] = ACTIONS(6374),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6374),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [sym__conid] = ACTIONS(6380),
    [anon_sym_LBRACK] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6384),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6386),
    [anon_sym_6] = ACTIONS(6386),
    [anon_sym_7] = ACTIONS(6388),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6390),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6392),
  },
  [2630] = {
    [sym_integer] = STATE(7576),
    [sym__literal] = STATE(7576),
    [sym__unboxed_open] = STATE(2135),
    [sym_constructor] = STATE(7313),
    [sym_con_unit] = STATE(7576),
    [sym_con_list] = STATE(7576),
    [sym_con_tuple] = STATE(7576),
    [sym_qualified_type] = STATE(7334),
    [sym_tycon_arrow] = STATE(7334),
    [sym_type_literal] = STATE(2759),
    [sym__promoted_tycon] = STATE(7334),
    [sym_type_variable] = STATE(7334),
    [sym_annotated_type_variable] = STATE(7334),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(13993),
    [sym_type_parens] = STATE(2759),
    [sym_type_list] = STATE(2759),
    [sym_type_tuple] = STATE(2759),
    [sym__type_promotable_literal] = STATE(2759),
    [sym__type_promoted_literal] = STATE(2759),
    [sym__type_literal] = STATE(2759),
    [sym_type_name] = STATE(2751),
    [sym_type_star] = STATE(2759),
    [sym_type_unboxed_tuple] = STATE(2759),
    [sym_type_unboxed_sum] = STATE(2759),
    [sym__atype] = STATE(2759),
    [sym_type_apply] = STATE(8300),
    [sym__btype] = STATE(8300),
    [sym_type_infix] = STATE(12706),
    [sym__type_infix] = STATE(12293),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2630),
    [sym__type_quantifiers] = STATE(14703),
    [sym__type_context] = STATE(14703),
    [sym__type_fun] = STATE(14703),
    [sym__type] = STATE(14703),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15269),
    [sym_splice] = STATE(2759),
    [sym_quasiquote] = STATE(2759),
    [sym__varid] = ACTIONS(7068),
    [sym_float] = ACTIONS(7070),
    [sym_char] = ACTIONS(7070),
    [sym_string] = ACTIONS(7070),
    [sym__integer_literal] = ACTIONS(7072),
    [sym__binary_literal] = ACTIONS(7074),
    [sym__octal_literal] = ACTIONS(7074),
    [sym__hex_literal] = ACTIONS(7074),
    [anon_sym_LPAREN_POUND] = ACTIONS(7076),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7076),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7078),
    [sym__conid] = ACTIONS(7082),
    [anon_sym_LBRACK] = ACTIONS(7084),
    [anon_sym_SQUOTE] = ACTIONS(7086),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7088),
    [anon_sym_6] = ACTIONS(7088),
    [anon_sym_7] = ACTIONS(7090),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7092),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7094),
  },
  [2631] = {
    [sym_integer] = STATE(6475),
    [sym__literal] = STATE(6475),
    [sym__unboxed_open] = STATE(2221),
    [sym_constructor] = STATE(6005),
    [sym_con_unit] = STATE(6475),
    [sym_con_list] = STATE(6475),
    [sym_con_tuple] = STATE(6475),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2474),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym_annotated_type_variable] = STATE(6545),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14062),
    [sym_type_parens] = STATE(2474),
    [sym_type_list] = STATE(2474),
    [sym_type_tuple] = STATE(2474),
    [sym__type_promotable_literal] = STATE(2474),
    [sym__type_promoted_literal] = STATE(2474),
    [sym__type_literal] = STATE(2474),
    [sym_type_name] = STATE(2453),
    [sym_type_star] = STATE(2474),
    [sym_type_unboxed_tuple] = STATE(2474),
    [sym_type_unboxed_sum] = STATE(2474),
    [sym__atype] = STATE(2474),
    [sym_type_apply] = STATE(7618),
    [sym__btype] = STATE(7618),
    [sym_type_infix] = STATE(9792),
    [sym__type_infix] = STATE(9655),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2631),
    [sym__type_quantifiers] = STATE(11948),
    [sym__type_context] = STATE(11948),
    [sym__type_fun] = STATE(11948),
    [sym__type] = STATE(11948),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14761),
    [sym_splice] = STATE(2474),
    [sym_quasiquote] = STATE(2474),
    [sym__varid] = ACTIONS(6643),
    [sym_float] = ACTIONS(6645),
    [sym_char] = ACTIONS(6645),
    [sym_string] = ACTIONS(6645),
    [sym__integer_literal] = ACTIONS(6647),
    [sym__binary_literal] = ACTIONS(6649),
    [sym__octal_literal] = ACTIONS(6649),
    [sym__hex_literal] = ACTIONS(6649),
    [anon_sym_LPAREN_POUND] = ACTIONS(6651),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6651),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6653),
    [sym__conid] = ACTIONS(6657),
    [anon_sym_LBRACK] = ACTIONS(6659),
    [anon_sym_SQUOTE] = ACTIONS(6661),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6663),
    [anon_sym_6] = ACTIONS(6663),
    [anon_sym_7] = ACTIONS(6665),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6669),
  },
  [2632] = {
    [sym_integer] = STATE(5998),
    [sym__literal] = STATE(5998),
    [sym__unboxed_open] = STATE(2200),
    [sym_constructor] = STATE(5931),
    [sym_con_unit] = STATE(5998),
    [sym_con_list] = STATE(5998),
    [sym_con_tuple] = STATE(5998),
    [sym_qualified_type] = STATE(5996),
    [sym_tycon_arrow] = STATE(5996),
    [sym_type_literal] = STATE(2403),
    [sym__promoted_tycon] = STATE(5996),
    [sym_type_variable] = STATE(5996),
    [sym_annotated_type_variable] = STATE(5996),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14150),
    [sym_type_parens] = STATE(2403),
    [sym_type_list] = STATE(2403),
    [sym_type_tuple] = STATE(2403),
    [sym__type_promotable_literal] = STATE(2403),
    [sym__type_promoted_literal] = STATE(2403),
    [sym__type_literal] = STATE(2403),
    [sym_type_name] = STATE(2433),
    [sym_type_star] = STATE(2403),
    [sym_type_unboxed_tuple] = STATE(2403),
    [sym_type_unboxed_sum] = STATE(2403),
    [sym__atype] = STATE(2403),
    [sym_type_apply] = STATE(7479),
    [sym__btype] = STATE(7479),
    [sym_type_infix] = STATE(9706),
    [sym__type_infix] = STATE(9574),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2632),
    [sym__type_quantifiers] = STATE(11574),
    [sym__type_context] = STATE(11574),
    [sym__type_fun] = STATE(11574),
    [sym__type] = STATE(11574),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15278),
    [sym_splice] = STATE(2403),
    [sym_quasiquote] = STATE(2403),
    [sym__varid] = ACTIONS(6394),
    [sym_float] = ACTIONS(6396),
    [sym_char] = ACTIONS(6396),
    [sym_string] = ACTIONS(6396),
    [sym__integer_literal] = ACTIONS(6398),
    [sym__binary_literal] = ACTIONS(6400),
    [sym__octal_literal] = ACTIONS(6400),
    [sym__hex_literal] = ACTIONS(6400),
    [anon_sym_LPAREN_POUND] = ACTIONS(6402),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6402),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6404),
    [sym__conid] = ACTIONS(6408),
    [anon_sym_LBRACK] = ACTIONS(6410),
    [anon_sym_SQUOTE] = ACTIONS(6412),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6414),
    [anon_sym_6] = ACTIONS(6414),
    [anon_sym_7] = ACTIONS(6416),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6418),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6420),
  },
  [2633] = {
    [sym_integer] = STATE(7208),
    [sym__literal] = STATE(7208),
    [sym__unboxed_open] = STATE(2156),
    [sym_constructor] = STATE(6817),
    [sym_con_unit] = STATE(7208),
    [sym_con_list] = STATE(7208),
    [sym_con_tuple] = STATE(7208),
    [sym_qualified_type] = STATE(7291),
    [sym_tycon_arrow] = STATE(7291),
    [sym_type_literal] = STATE(2699),
    [sym__promoted_tycon] = STATE(7291),
    [sym_type_variable] = STATE(7291),
    [sym_annotated_type_variable] = STATE(7291),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14074),
    [sym_type_parens] = STATE(2699),
    [sym_type_list] = STATE(2699),
    [sym_type_tuple] = STATE(2699),
    [sym__type_promotable_literal] = STATE(2699),
    [sym__type_promoted_literal] = STATE(2699),
    [sym__type_literal] = STATE(2699),
    [sym_type_name] = STATE(2693),
    [sym_type_star] = STATE(2699),
    [sym_type_unboxed_tuple] = STATE(2699),
    [sym_type_unboxed_sum] = STATE(2699),
    [sym__atype] = STATE(2699),
    [sym_type_apply] = STATE(8012),
    [sym__btype] = STATE(8012),
    [sym_type_infix] = STATE(12364),
    [sym__type_infix] = STATE(12056),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2560),
    [sym__type_quantifiers] = STATE(14187),
    [sym__type_context] = STATE(14187),
    [sym__type_fun] = STATE(14187),
    [sym__type] = STATE(14187),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14826),
    [sym_splice] = STATE(2699),
    [sym_quasiquote] = STATE(2699),
    [sym__varid] = ACTIONS(6436),
    [sym_float] = ACTIONS(6438),
    [sym_char] = ACTIONS(6438),
    [sym_string] = ACTIONS(6438),
    [sym__integer_literal] = ACTIONS(6440),
    [sym__binary_literal] = ACTIONS(6442),
    [sym__octal_literal] = ACTIONS(6442),
    [sym__hex_literal] = ACTIONS(6442),
    [anon_sym_LPAREN_POUND] = ACTIONS(6444),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6444),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6446),
    [sym__conid] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_6] = ACTIONS(6456),
    [anon_sym_7] = ACTIONS(6458),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6460),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6462),
  },
  [2634] = {
    [sym_integer] = STATE(6347),
    [sym__literal] = STATE(6347),
    [sym__unboxed_open] = STATE(2174),
    [sym_constructor] = STATE(6222),
    [sym_con_unit] = STATE(6347),
    [sym_con_list] = STATE(6347),
    [sym_con_tuple] = STATE(6347),
    [sym_qualified_type] = STATE(6343),
    [sym_tycon_arrow] = STATE(6343),
    [sym_type_literal] = STATE(2448),
    [sym__promoted_tycon] = STATE(6343),
    [sym_type_variable] = STATE(6343),
    [sym_annotated_type_variable] = STATE(6343),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14160),
    [sym_type_parens] = STATE(2448),
    [sym_type_list] = STATE(2448),
    [sym_type_tuple] = STATE(2448),
    [sym__type_promotable_literal] = STATE(2448),
    [sym__type_promoted_literal] = STATE(2448),
    [sym__type_literal] = STATE(2448),
    [sym_type_name] = STATE(2454),
    [sym_type_star] = STATE(2448),
    [sym_type_unboxed_tuple] = STATE(2448),
    [sym_type_unboxed_sum] = STATE(2448),
    [sym__atype] = STATE(2448),
    [sym_type_apply] = STATE(7672),
    [sym__btype] = STATE(7672),
    [sym_type_infix] = STATE(9777),
    [sym__type_infix] = STATE(9698),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2669),
    [sym__type_quantifiers] = STATE(11976),
    [sym__type_context] = STATE(11976),
    [sym__type_fun] = STATE(11976),
    [sym__type] = STATE(11976),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15364),
    [sym_splice] = STATE(2448),
    [sym_quasiquote] = STATE(2448),
    [sym__varid] = ACTIONS(5966),
    [sym_float] = ACTIONS(5968),
    [sym_char] = ACTIONS(5968),
    [sym_string] = ACTIONS(5968),
    [sym__integer_literal] = ACTIONS(5970),
    [sym__binary_literal] = ACTIONS(5972),
    [sym__octal_literal] = ACTIONS(5972),
    [sym__hex_literal] = ACTIONS(5972),
    [anon_sym_LPAREN_POUND] = ACTIONS(5974),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5974),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [sym__conid] = ACTIONS(5980),
    [anon_sym_LBRACK] = ACTIONS(5982),
    [anon_sym_SQUOTE] = ACTIONS(5984),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5986),
    [anon_sym_6] = ACTIONS(5986),
    [anon_sym_7] = ACTIONS(5988),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5990),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5992),
  },
  [2635] = {
    [sym_integer] = STATE(6509),
    [sym__literal] = STATE(6509),
    [sym__unboxed_open] = STATE(2133),
    [sym_constructor] = STATE(5968),
    [sym_con_unit] = STATE(6509),
    [sym_con_list] = STATE(6509),
    [sym_con_tuple] = STATE(6509),
    [sym_qualified_type] = STATE(6463),
    [sym_tycon_arrow] = STATE(6463),
    [sym_type_literal] = STATE(2456),
    [sym__promoted_tycon] = STATE(6463),
    [sym_type_variable] = STATE(6463),
    [sym_annotated_type_variable] = STATE(6463),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14523),
    [sym_type_parens] = STATE(2456),
    [sym_type_list] = STATE(2456),
    [sym_type_tuple] = STATE(2456),
    [sym__type_promotable_literal] = STATE(2456),
    [sym__type_promoted_literal] = STATE(2456),
    [sym__type_literal] = STATE(2456),
    [sym_type_name] = STATE(2478),
    [sym_type_star] = STATE(2456),
    [sym_type_unboxed_tuple] = STATE(2456),
    [sym_type_unboxed_sum] = STATE(2456),
    [sym__atype] = STATE(2456),
    [sym_type_apply] = STATE(7597),
    [sym__btype] = STATE(7597),
    [sym_type_infix] = STATE(11310),
    [sym__type_infix] = STATE(11811),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2644),
    [sym__type_quantifiers] = STATE(13487),
    [sym__type_context] = STATE(13487),
    [sym__type_fun] = STATE(13487),
    [sym__type] = STATE(13487),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14649),
    [sym_splice] = STATE(2456),
    [sym_quasiquote] = STATE(2456),
    [sym__varid] = ACTIONS(7397),
    [sym_float] = ACTIONS(7399),
    [sym_char] = ACTIONS(7399),
    [sym_string] = ACTIONS(7399),
    [sym__integer_literal] = ACTIONS(7401),
    [sym__binary_literal] = ACTIONS(7403),
    [sym__octal_literal] = ACTIONS(7403),
    [sym__hex_literal] = ACTIONS(7403),
    [anon_sym_LPAREN_POUND] = ACTIONS(7405),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7405),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7407),
    [sym__conid] = ACTIONS(7411),
    [anon_sym_LBRACK] = ACTIONS(7413),
    [anon_sym_SQUOTE] = ACTIONS(7415),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7417),
    [anon_sym_6] = ACTIONS(7417),
    [anon_sym_7] = ACTIONS(7419),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7421),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7423),
  },
  [2636] = {
    [sym_integer] = STATE(7104),
    [sym__literal] = STATE(7104),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7046),
    [sym_con_unit] = STATE(7104),
    [sym_con_list] = STATE(7104),
    [sym_con_tuple] = STATE(7104),
    [sym_qualified_type] = STATE(7087),
    [sym_tycon_arrow] = STATE(7087),
    [sym_type_literal] = STATE(2721),
    [sym__promoted_tycon] = STATE(7087),
    [sym_type_variable] = STATE(7087),
    [sym_annotated_type_variable] = STATE(7087),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14084),
    [sym_type_parens] = STATE(2721),
    [sym_type_list] = STATE(2721),
    [sym_type_tuple] = STATE(2721),
    [sym__type_promotable_literal] = STATE(2721),
    [sym__type_promoted_literal] = STATE(2721),
    [sym__type_literal] = STATE(2721),
    [sym_type_name] = STATE(2688),
    [sym_type_star] = STATE(2721),
    [sym_type_unboxed_tuple] = STATE(2721),
    [sym_type_unboxed_sum] = STATE(2721),
    [sym__atype] = STATE(2721),
    [sym_type_apply] = STATE(8113),
    [sym__btype] = STATE(8113),
    [sym_type_infix] = STATE(12422),
    [sym__type_infix] = STATE(11995),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2636),
    [sym__type_quantifiers] = STATE(14591),
    [sym__type_context] = STATE(14591),
    [sym__type_fun] = STATE(14591),
    [sym__type] = STATE(14591),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15134),
    [sym_splice] = STATE(2721),
    [sym_quasiquote] = STATE(2721),
    [sym__varid] = ACTIONS(6366),
    [sym_float] = ACTIONS(6368),
    [sym_char] = ACTIONS(6368),
    [sym_string] = ACTIONS(6368),
    [sym__integer_literal] = ACTIONS(6370),
    [sym__binary_literal] = ACTIONS(6372),
    [sym__octal_literal] = ACTIONS(6372),
    [sym__hex_literal] = ACTIONS(6372),
    [anon_sym_LPAREN_POUND] = ACTIONS(6374),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6374),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6376),
    [sym__conid] = ACTIONS(6380),
    [anon_sym_LBRACK] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(6384),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6386),
    [anon_sym_6] = ACTIONS(6386),
    [anon_sym_7] = ACTIONS(6388),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6390),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6392),
  },
  [2637] = {
    [sym_integer] = STATE(6347),
    [sym__literal] = STATE(6347),
    [sym__unboxed_open] = STATE(2174),
    [sym_constructor] = STATE(6222),
    [sym_con_unit] = STATE(6347),
    [sym_con_list] = STATE(6347),
    [sym_con_tuple] = STATE(6347),
    [sym_qualified_type] = STATE(6343),
    [sym_tycon_arrow] = STATE(6343),
    [sym_type_literal] = STATE(2448),
    [sym__promoted_tycon] = STATE(6343),
    [sym_type_variable] = STATE(6343),
    [sym_annotated_type_variable] = STATE(6343),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14160),
    [sym_type_parens] = STATE(2448),
    [sym_type_list] = STATE(2448),
    [sym_type_tuple] = STATE(2448),
    [sym__type_promotable_literal] = STATE(2448),
    [sym__type_promoted_literal] = STATE(2448),
    [sym__type_literal] = STATE(2448),
    [sym_type_name] = STATE(2454),
    [sym_type_star] = STATE(2448),
    [sym_type_unboxed_tuple] = STATE(2448),
    [sym_type_unboxed_sum] = STATE(2448),
    [sym__atype] = STATE(2448),
    [sym_type_apply] = STATE(7672),
    [sym__btype] = STATE(7672),
    [sym_type_infix] = STATE(9777),
    [sym__type_infix] = STATE(9698),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2669),
    [sym__type_quantifiers] = STATE(11983),
    [sym__type_context] = STATE(11983),
    [sym__type_fun] = STATE(11983),
    [sym__type] = STATE(11983),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15364),
    [sym_splice] = STATE(2448),
    [sym_quasiquote] = STATE(2448),
    [sym__varid] = ACTIONS(5966),
    [sym_float] = ACTIONS(5968),
    [sym_char] = ACTIONS(5968),
    [sym_string] = ACTIONS(5968),
    [sym__integer_literal] = ACTIONS(5970),
    [sym__binary_literal] = ACTIONS(5972),
    [sym__octal_literal] = ACTIONS(5972),
    [sym__hex_literal] = ACTIONS(5972),
    [anon_sym_LPAREN_POUND] = ACTIONS(5974),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5974),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [sym__conid] = ACTIONS(5980),
    [anon_sym_LBRACK] = ACTIONS(5982),
    [anon_sym_SQUOTE] = ACTIONS(5984),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5986),
    [anon_sym_6] = ACTIONS(5986),
    [anon_sym_7] = ACTIONS(5988),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5990),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5992),
  },
  [2638] = {
    [sym_integer] = STATE(7818),
    [sym__literal] = STATE(7818),
    [sym__unboxed_open] = STATE(2165),
    [sym_constructor] = STATE(7684),
    [sym_con_unit] = STATE(7818),
    [sym_con_list] = STATE(7818),
    [sym_con_tuple] = STATE(7818),
    [sym_qualified_type] = STATE(7768),
    [sym_tycon_arrow] = STATE(7768),
    [sym_type_literal] = STATE(2799),
    [sym__promoted_tycon] = STATE(7768),
    [sym_type_variable] = STATE(7768),
    [sym_annotated_type_variable] = STATE(7768),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14565),
    [sym_type_parens] = STATE(2799),
    [sym_type_list] = STATE(2799),
    [sym_type_tuple] = STATE(2799),
    [sym__type_promotable_literal] = STATE(2799),
    [sym__type_promoted_literal] = STATE(2799),
    [sym__type_literal] = STATE(2799),
    [sym_type_name] = STATE(2788),
    [sym_type_star] = STATE(2799),
    [sym_type_unboxed_tuple] = STATE(2799),
    [sym_type_unboxed_sum] = STATE(2799),
    [sym__atype] = STATE(2799),
    [sym_type_apply] = STATE(8878),
    [sym__btype] = STATE(8878),
    [sym_type_infix] = STATE(13177),
    [sym__type_infix] = STATE(12764),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2638),
    [sym__type_quantifiers] = STATE(18838),
    [sym__type_context] = STATE(18838),
    [sym__type_fun] = STATE(18838),
    [sym__type] = STATE(18838),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15161),
    [sym_splice] = STATE(2799),
    [sym_quasiquote] = STATE(2799),
    [sym__varid] = ACTIONS(6042),
    [sym_float] = ACTIONS(6044),
    [sym_char] = ACTIONS(6044),
    [sym_string] = ACTIONS(6044),
    [sym__integer_literal] = ACTIONS(6046),
    [sym__binary_literal] = ACTIONS(6048),
    [sym__octal_literal] = ACTIONS(6048),
    [sym__hex_literal] = ACTIONS(6048),
    [anon_sym_LPAREN_POUND] = ACTIONS(6050),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6050),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6052),
    [sym__conid] = ACTIONS(6056),
    [anon_sym_LBRACK] = ACTIONS(6058),
    [anon_sym_SQUOTE] = ACTIONS(6060),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6062),
    [anon_sym_6] = ACTIONS(6062),
    [anon_sym_7] = ACTIONS(6064),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6066),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6068),
  },
  [2639] = {
    [sym_integer] = STATE(7576),
    [sym__literal] = STATE(7576),
    [sym__unboxed_open] = STATE(2135),
    [sym_constructor] = STATE(7313),
    [sym_con_unit] = STATE(7576),
    [sym_con_list] = STATE(7576),
    [sym_con_tuple] = STATE(7576),
    [sym_qualified_type] = STATE(7334),
    [sym_tycon_arrow] = STATE(7334),
    [sym_type_literal] = STATE(2759),
    [sym__promoted_tycon] = STATE(7334),
    [sym_type_variable] = STATE(7334),
    [sym_annotated_type_variable] = STATE(7334),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(13993),
    [sym_type_parens] = STATE(2759),
    [sym_type_list] = STATE(2759),
    [sym_type_tuple] = STATE(2759),
    [sym__type_promotable_literal] = STATE(2759),
    [sym__type_promoted_literal] = STATE(2759),
    [sym__type_literal] = STATE(2759),
    [sym_type_name] = STATE(2751),
    [sym_type_star] = STATE(2759),
    [sym_type_unboxed_tuple] = STATE(2759),
    [sym_type_unboxed_sum] = STATE(2759),
    [sym__atype] = STATE(2759),
    [sym_type_apply] = STATE(8300),
    [sym__btype] = STATE(8300),
    [sym_type_infix] = STATE(12706),
    [sym__type_infix] = STATE(12293),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2630),
    [sym__type_quantifiers] = STATE(14705),
    [sym__type_context] = STATE(14705),
    [sym__type_fun] = STATE(14705),
    [sym__type] = STATE(14705),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15269),
    [sym_splice] = STATE(2759),
    [sym_quasiquote] = STATE(2759),
    [sym__varid] = ACTIONS(7068),
    [sym_float] = ACTIONS(7070),
    [sym_char] = ACTIONS(7070),
    [sym_string] = ACTIONS(7070),
    [sym__integer_literal] = ACTIONS(7072),
    [sym__binary_literal] = ACTIONS(7074),
    [sym__octal_literal] = ACTIONS(7074),
    [sym__hex_literal] = ACTIONS(7074),
    [anon_sym_LPAREN_POUND] = ACTIONS(7076),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7076),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7078),
    [sym__conid] = ACTIONS(7082),
    [anon_sym_LBRACK] = ACTIONS(7084),
    [anon_sym_SQUOTE] = ACTIONS(7086),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7088),
    [anon_sym_6] = ACTIONS(7088),
    [anon_sym_7] = ACTIONS(7090),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7092),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7094),
  },
  [2640] = {
    [sym_integer] = STATE(5958),
    [sym__literal] = STATE(5958),
    [sym__unboxed_open] = STATE(2212),
    [sym_constructor] = STATE(5940),
    [sym_con_unit] = STATE(5958),
    [sym_con_list] = STATE(5958),
    [sym_con_tuple] = STATE(5958),
    [sym_qualified_type] = STATE(5952),
    [sym_tycon_arrow] = STATE(5952),
    [sym_type_literal] = STATE(2418),
    [sym__promoted_tycon] = STATE(5952),
    [sym_type_variable] = STATE(5952),
    [sym_annotated_type_variable] = STATE(5952),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14367),
    [sym_type_parens] = STATE(2418),
    [sym_type_list] = STATE(2418),
    [sym_type_tuple] = STATE(2418),
    [sym__type_promotable_literal] = STATE(2418),
    [sym__type_promoted_literal] = STATE(2418),
    [sym__type_literal] = STATE(2418),
    [sym_type_name] = STATE(2425),
    [sym_type_star] = STATE(2418),
    [sym_type_unboxed_tuple] = STATE(2418),
    [sym_type_unboxed_sum] = STATE(2418),
    [sym__atype] = STATE(2418),
    [sym_type_apply] = STATE(7561),
    [sym__btype] = STATE(7561),
    [sym_type_infix] = STATE(9686),
    [sym__type_infix] = STATE(9571),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2640),
    [sym__type_quantifiers] = STATE(10706),
    [sym__type_context] = STATE(10706),
    [sym__type_fun] = STATE(10706),
    [sym__type] = STATE(10706),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15080),
    [sym_splice] = STATE(2418),
    [sym_quasiquote] = STATE(2418),
    [sym__varid] = ACTIONS(6338),
    [sym_float] = ACTIONS(6340),
    [sym_char] = ACTIONS(6340),
    [sym_string] = ACTIONS(6340),
    [sym__integer_literal] = ACTIONS(6342),
    [sym__binary_literal] = ACTIONS(6344),
    [sym__octal_literal] = ACTIONS(6344),
    [sym__hex_literal] = ACTIONS(6344),
    [anon_sym_LPAREN_POUND] = ACTIONS(6346),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6346),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6348),
    [sym__conid] = ACTIONS(6352),
    [anon_sym_LBRACK] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6356),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6358),
    [anon_sym_6] = ACTIONS(6358),
    [anon_sym_7] = ACTIONS(6360),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6362),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6364),
  },
  [2641] = {
    [sym_integer] = STATE(7008),
    [sym__literal] = STATE(7008),
    [sym__unboxed_open] = STATE(2147),
    [sym_constructor] = STATE(6715),
    [sym_con_unit] = STATE(7008),
    [sym_con_list] = STATE(7008),
    [sym_con_tuple] = STATE(7008),
    [sym_qualified_type] = STATE(6959),
    [sym_tycon_arrow] = STATE(6959),
    [sym_type_literal] = STATE(2641),
    [sym__promoted_tycon] = STATE(6959),
    [sym_type_variable] = STATE(6959),
    [sym_annotated_type_variable] = STATE(6959),
    [sym_type_parens] = STATE(2641),
    [sym_type_list] = STATE(2641),
    [sym_type_tuple] = STATE(2641),
    [sym__type_promotable_literal] = STATE(2641),
    [sym__type_promoted_literal] = STATE(2641),
    [sym__type_literal] = STATE(2641),
    [sym_type_name] = STATE(2641),
    [sym_type_star] = STATE(2641),
    [sym_type_unboxed_tuple] = STATE(2641),
    [sym_type_unboxed_sum] = STATE(2641),
    [sym__atype] = STATE(2641),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14702),
    [sym_splice] = STATE(2641),
    [sym_quasiquote] = STATE(2641),
    [aux_sym_type_apply_repeat1] = STATE(2641),
    [sym__varid] = ACTIONS(8368),
    [sym_float] = ACTIONS(8371),
    [sym_char] = ACTIONS(8371),
    [sym_string] = ACTIONS(8371),
    [sym__integer_literal] = ACTIONS(8374),
    [sym__binary_literal] = ACTIONS(8377),
    [sym__octal_literal] = ACTIONS(8377),
    [sym__hex_literal] = ACTIONS(8377),
    [anon_sym_LPAREN_POUND] = ACTIONS(8380),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8380),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [anon_sym_4] = ACTIONS(5030),
    [anon_sym_COLON_COLON] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(5059),
    [anon_sym_LPAREN] = ACTIONS(8383),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(8386),
    [anon_sym_LBRACK] = ACTIONS(8389),
    [anon_sym_SQUOTE] = ACTIONS(8392),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(8395),
    [anon_sym_6] = ACTIONS(8395),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(8398),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8401),
    [sym__varsym] = ACTIONS(5030),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8404),
    [sym__unboxed_close] = ACTIONS(5030),
  },
  [2642] = {
    [sym_integer] = STATE(7705),
    [sym__literal] = STATE(7705),
    [sym__unboxed_open] = STATE(2184),
    [sym_constructor] = STATE(7681),
    [sym_con_unit] = STATE(7705),
    [sym_con_list] = STATE(7705),
    [sym_con_tuple] = STATE(7705),
    [sym_qualified_type] = STATE(7706),
    [sym_tycon_arrow] = STATE(7706),
    [sym_type_literal] = STATE(2802),
    [sym__promoted_tycon] = STATE(7706),
    [sym_type_variable] = STATE(7706),
    [sym_annotated_type_variable] = STATE(7706),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14603),
    [sym_type_parens] = STATE(2802),
    [sym_type_list] = STATE(2802),
    [sym_type_tuple] = STATE(2802),
    [sym__type_promotable_literal] = STATE(2802),
    [sym__type_promoted_literal] = STATE(2802),
    [sym__type_literal] = STATE(2802),
    [sym_type_name] = STATE(2805),
    [sym_type_star] = STATE(2802),
    [sym_type_unboxed_tuple] = STATE(2802),
    [sym_type_unboxed_sum] = STATE(2802),
    [sym__atype] = STATE(2802),
    [sym_type_apply] = STATE(8735),
    [sym__btype] = STATE(8735),
    [sym_type_infix] = STATE(13317),
    [sym__type_infix] = STATE(13018),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2597),
    [sym__type_quantifiers] = STATE(14891),
    [sym__type_context] = STATE(14891),
    [sym__type_fun] = STATE(14891),
    [sym__type] = STATE(14891),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15120),
    [sym_splice] = STATE(2802),
    [sym_quasiquote] = STATE(2802),
    [sym__varid] = ACTIONS(6139),
    [sym_float] = ACTIONS(6141),
    [sym_char] = ACTIONS(6141),
    [sym_string] = ACTIONS(6141),
    [sym__integer_literal] = ACTIONS(6143),
    [sym__binary_literal] = ACTIONS(6145),
    [sym__octal_literal] = ACTIONS(6145),
    [sym__hex_literal] = ACTIONS(6145),
    [anon_sym_LPAREN_POUND] = ACTIONS(6147),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6147),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6149),
    [sym__conid] = ACTIONS(6153),
    [anon_sym_LBRACK] = ACTIONS(6155),
    [anon_sym_SQUOTE] = ACTIONS(6157),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6159),
    [anon_sym_6] = ACTIONS(6159),
    [anon_sym_7] = ACTIONS(6161),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6163),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6165),
  },
  [2643] = {
    [sym_integer] = STATE(6228),
    [sym__literal] = STATE(6228),
    [sym__unboxed_open] = STATE(2120),
    [sym_constructor] = STATE(5787),
    [sym_con_unit] = STATE(6228),
    [sym_con_list] = STATE(6228),
    [sym_con_tuple] = STATE(6228),
    [sym_qualified_type] = STATE(6115),
    [sym_tycon_arrow] = STATE(6115),
    [sym_type_literal] = STATE(2385),
    [sym__promoted_tycon] = STATE(6115),
    [sym_type_variable] = STATE(6115),
    [sym_annotated_type_variable] = STATE(6115),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14177),
    [sym_type_parens] = STATE(2385),
    [sym_type_list] = STATE(2385),
    [sym_type_tuple] = STATE(2385),
    [sym__type_promotable_literal] = STATE(2385),
    [sym__type_promoted_literal] = STATE(2385),
    [sym__type_literal] = STATE(2385),
    [sym_type_name] = STATE(2427),
    [sym_type_star] = STATE(2385),
    [sym_type_unboxed_tuple] = STATE(2385),
    [sym_type_unboxed_sum] = STATE(2385),
    [sym__atype] = STATE(2385),
    [sym_type_apply] = STATE(7511),
    [sym__btype] = STATE(7511),
    [sym_type_infix] = STATE(9687),
    [sym__type_infix] = STATE(9538),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2547),
    [sym__type_quantifiers] = STATE(11725),
    [sym__type_context] = STATE(11725),
    [sym__type_fun] = STATE(11725),
    [sym__type] = STATE(11725),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15408),
    [sym_splice] = STATE(2385),
    [sym_quasiquote] = STATE(2385),
    [sym__varid] = ACTIONS(6195),
    [sym_float] = ACTIONS(6197),
    [sym_char] = ACTIONS(6197),
    [sym_string] = ACTIONS(6197),
    [sym__integer_literal] = ACTIONS(6199),
    [sym__binary_literal] = ACTIONS(6201),
    [sym__octal_literal] = ACTIONS(6201),
    [sym__hex_literal] = ACTIONS(6201),
    [anon_sym_LPAREN_POUND] = ACTIONS(6203),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6203),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6205),
    [sym__conid] = ACTIONS(6209),
    [anon_sym_LBRACK] = ACTIONS(6211),
    [anon_sym_SQUOTE] = ACTIONS(6213),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6215),
    [anon_sym_6] = ACTIONS(6215),
    [anon_sym_7] = ACTIONS(6217),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6219),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6221),
  },
  [2644] = {
    [sym_integer] = STATE(6509),
    [sym__literal] = STATE(6509),
    [sym__unboxed_open] = STATE(2133),
    [sym_constructor] = STATE(5968),
    [sym_con_unit] = STATE(6509),
    [sym_con_list] = STATE(6509),
    [sym_con_tuple] = STATE(6509),
    [sym_qualified_type] = STATE(6463),
    [sym_tycon_arrow] = STATE(6463),
    [sym_type_literal] = STATE(2456),
    [sym__promoted_tycon] = STATE(6463),
    [sym_type_variable] = STATE(6463),
    [sym_annotated_type_variable] = STATE(6463),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14523),
    [sym_type_parens] = STATE(2456),
    [sym_type_list] = STATE(2456),
    [sym_type_tuple] = STATE(2456),
    [sym__type_promotable_literal] = STATE(2456),
    [sym__type_promoted_literal] = STATE(2456),
    [sym__type_literal] = STATE(2456),
    [sym_type_name] = STATE(2478),
    [sym_type_star] = STATE(2456),
    [sym_type_unboxed_tuple] = STATE(2456),
    [sym_type_unboxed_sum] = STATE(2456),
    [sym__atype] = STATE(2456),
    [sym_type_apply] = STATE(7597),
    [sym__btype] = STATE(7597),
    [sym_type_infix] = STATE(11310),
    [sym__type_infix] = STATE(11811),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2644),
    [sym__type_quantifiers] = STATE(13511),
    [sym__type_context] = STATE(13511),
    [sym__type_fun] = STATE(13511),
    [sym__type] = STATE(13511),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14649),
    [sym_splice] = STATE(2456),
    [sym_quasiquote] = STATE(2456),
    [sym__varid] = ACTIONS(7397),
    [sym_float] = ACTIONS(7399),
    [sym_char] = ACTIONS(7399),
    [sym_string] = ACTIONS(7399),
    [sym__integer_literal] = ACTIONS(7401),
    [sym__binary_literal] = ACTIONS(7403),
    [sym__octal_literal] = ACTIONS(7403),
    [sym__hex_literal] = ACTIONS(7403),
    [anon_sym_LPAREN_POUND] = ACTIONS(7405),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7405),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7407),
    [sym__conid] = ACTIONS(7411),
    [anon_sym_LBRACK] = ACTIONS(7413),
    [anon_sym_SQUOTE] = ACTIONS(7415),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7417),
    [anon_sym_6] = ACTIONS(7417),
    [anon_sym_7] = ACTIONS(7419),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7421),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7423),
  },
  [2645] = {
    [sym_integer] = STATE(5958),
    [sym__literal] = STATE(5958),
    [sym__unboxed_open] = STATE(2212),
    [sym_constructor] = STATE(5940),
    [sym_con_unit] = STATE(5958),
    [sym_con_list] = STATE(5958),
    [sym_con_tuple] = STATE(5958),
    [sym_qualified_type] = STATE(5952),
    [sym_tycon_arrow] = STATE(5952),
    [sym_type_literal] = STATE(2418),
    [sym__promoted_tycon] = STATE(5952),
    [sym_type_variable] = STATE(5952),
    [sym_annotated_type_variable] = STATE(5952),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14367),
    [sym_type_parens] = STATE(2418),
    [sym_type_list] = STATE(2418),
    [sym_type_tuple] = STATE(2418),
    [sym__type_promotable_literal] = STATE(2418),
    [sym__type_promoted_literal] = STATE(2418),
    [sym__type_literal] = STATE(2418),
    [sym_type_name] = STATE(2425),
    [sym_type_star] = STATE(2418),
    [sym_type_unboxed_tuple] = STATE(2418),
    [sym_type_unboxed_sum] = STATE(2418),
    [sym__atype] = STATE(2418),
    [sym_type_apply] = STATE(7561),
    [sym__btype] = STATE(7561),
    [sym_type_infix] = STATE(9686),
    [sym__type_infix] = STATE(9571),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2640),
    [sym__type_quantifiers] = STATE(10700),
    [sym__type_context] = STATE(10700),
    [sym__type_fun] = STATE(10700),
    [sym__type] = STATE(10700),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15080),
    [sym_splice] = STATE(2418),
    [sym_quasiquote] = STATE(2418),
    [sym__varid] = ACTIONS(6338),
    [sym_float] = ACTIONS(6340),
    [sym_char] = ACTIONS(6340),
    [sym_string] = ACTIONS(6340),
    [sym__integer_literal] = ACTIONS(6342),
    [sym__binary_literal] = ACTIONS(6344),
    [sym__octal_literal] = ACTIONS(6344),
    [sym__hex_literal] = ACTIONS(6344),
    [anon_sym_LPAREN_POUND] = ACTIONS(6346),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6346),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6348),
    [sym__conid] = ACTIONS(6352),
    [anon_sym_LBRACK] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6356),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6358),
    [anon_sym_6] = ACTIONS(6358),
    [anon_sym_7] = ACTIONS(6360),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6362),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6364),
  },
  [2646] = {
    [sym_integer] = STATE(5958),
    [sym__literal] = STATE(5958),
    [sym__unboxed_open] = STATE(2212),
    [sym_constructor] = STATE(5940),
    [sym_con_unit] = STATE(5958),
    [sym_con_list] = STATE(5958),
    [sym_con_tuple] = STATE(5958),
    [sym_qualified_type] = STATE(5952),
    [sym_tycon_arrow] = STATE(5952),
    [sym_type_literal] = STATE(2418),
    [sym__promoted_tycon] = STATE(5952),
    [sym_type_variable] = STATE(5952),
    [sym_annotated_type_variable] = STATE(5952),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14367),
    [sym_type_parens] = STATE(2418),
    [sym_type_list] = STATE(2418),
    [sym_type_tuple] = STATE(2418),
    [sym__type_promotable_literal] = STATE(2418),
    [sym__type_promoted_literal] = STATE(2418),
    [sym__type_literal] = STATE(2418),
    [sym_type_name] = STATE(2425),
    [sym_type_star] = STATE(2418),
    [sym_type_unboxed_tuple] = STATE(2418),
    [sym_type_unboxed_sum] = STATE(2418),
    [sym__atype] = STATE(2418),
    [sym_type_apply] = STATE(7561),
    [sym__btype] = STATE(7561),
    [sym_type_infix] = STATE(9686),
    [sym__type_infix] = STATE(9571),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2640),
    [sym__type_quantifiers] = STATE(10701),
    [sym__type_context] = STATE(10701),
    [sym__type_fun] = STATE(10701),
    [sym__type] = STATE(10701),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15080),
    [sym_splice] = STATE(2418),
    [sym_quasiquote] = STATE(2418),
    [sym__varid] = ACTIONS(6338),
    [sym_float] = ACTIONS(6340),
    [sym_char] = ACTIONS(6340),
    [sym_string] = ACTIONS(6340),
    [sym__integer_literal] = ACTIONS(6342),
    [sym__binary_literal] = ACTIONS(6344),
    [sym__octal_literal] = ACTIONS(6344),
    [sym__hex_literal] = ACTIONS(6344),
    [anon_sym_LPAREN_POUND] = ACTIONS(6346),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6346),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6348),
    [sym__conid] = ACTIONS(6352),
    [anon_sym_LBRACK] = ACTIONS(6354),
    [anon_sym_SQUOTE] = ACTIONS(6356),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6358),
    [anon_sym_6] = ACTIONS(6358),
    [anon_sym_7] = ACTIONS(6360),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6362),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6364),
  },
  [2647] = {
    [sym_integer] = STATE(7485),
    [sym__literal] = STATE(7485),
    [sym__unboxed_open] = STATE(2202),
    [sym_constructor] = STATE(7295),
    [sym_con_unit] = STATE(7485),
    [sym_con_list] = STATE(7485),
    [sym_con_tuple] = STATE(7485),
    [sym_qualified_type] = STATE(7412),
    [sym_tycon_arrow] = STATE(7412),
    [sym_type_literal] = STATE(2753),
    [sym__promoted_tycon] = STATE(7412),
    [sym_type_variable] = STATE(7412),
    [sym_annotated_type_variable] = STATE(7412),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14444),
    [sym_type_parens] = STATE(2753),
    [sym_type_list] = STATE(2753),
    [sym_type_tuple] = STATE(2753),
    [sym__type_promotable_literal] = STATE(2753),
    [sym__type_promoted_literal] = STATE(2753),
    [sym__type_literal] = STATE(2753),
    [sym_type_name] = STATE(2737),
    [sym_type_star] = STATE(2753),
    [sym_type_unboxed_tuple] = STATE(2753),
    [sym_type_unboxed_sum] = STATE(2753),
    [sym__atype] = STATE(2753),
    [sym_type_apply] = STATE(8310),
    [sym__btype] = STATE(8310),
    [sym_type_infix] = STATE(12638),
    [sym__type_infix] = STATE(12387),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2571),
    [sym__type_quantifiers] = STATE(14711),
    [sym__type_context] = STATE(14711),
    [sym__type_fun] = STATE(14711),
    [sym__type] = STATE(14711),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14836),
    [sym_splice] = STATE(2753),
    [sym_quasiquote] = STATE(2753),
    [sym__varid] = ACTIONS(6002),
    [sym_float] = ACTIONS(6004),
    [sym_char] = ACTIONS(6004),
    [sym_string] = ACTIONS(6004),
    [sym__integer_literal] = ACTIONS(6006),
    [sym__binary_literal] = ACTIONS(6008),
    [sym__octal_literal] = ACTIONS(6008),
    [sym__hex_literal] = ACTIONS(6008),
    [anon_sym_LPAREN_POUND] = ACTIONS(6010),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6010),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6012),
    [sym__conid] = ACTIONS(6016),
    [anon_sym_LBRACK] = ACTIONS(6018),
    [anon_sym_SQUOTE] = ACTIONS(6020),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6022),
    [anon_sym_6] = ACTIONS(6022),
    [anon_sym_7] = ACTIONS(6024),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6026),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6028),
  },
  [2648] = {
    [sym_integer] = STATE(7576),
    [sym__literal] = STATE(7576),
    [sym__unboxed_open] = STATE(2135),
    [sym_constructor] = STATE(7313),
    [sym_con_unit] = STATE(7576),
    [sym_con_list] = STATE(7576),
    [sym_con_tuple] = STATE(7576),
    [sym_qualified_type] = STATE(7334),
    [sym_tycon_arrow] = STATE(7334),
    [sym_type_literal] = STATE(2759),
    [sym__promoted_tycon] = STATE(7334),
    [sym_type_variable] = STATE(7334),
    [sym_annotated_type_variable] = STATE(7334),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(13993),
    [sym_type_parens] = STATE(2759),
    [sym_type_list] = STATE(2759),
    [sym_type_tuple] = STATE(2759),
    [sym__type_promotable_literal] = STATE(2759),
    [sym__type_promoted_literal] = STATE(2759),
    [sym__type_literal] = STATE(2759),
    [sym_type_name] = STATE(2751),
    [sym_type_star] = STATE(2759),
    [sym_type_unboxed_tuple] = STATE(2759),
    [sym_type_unboxed_sum] = STATE(2759),
    [sym__atype] = STATE(2759),
    [sym_type_apply] = STATE(8300),
    [sym__btype] = STATE(8300),
    [sym_type_infix] = STATE(12706),
    [sym__type_infix] = STATE(12293),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2630),
    [sym__type_quantifiers] = STATE(14662),
    [sym__type_context] = STATE(14662),
    [sym__type_fun] = STATE(14662),
    [sym__type] = STATE(14662),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15269),
    [sym_splice] = STATE(2759),
    [sym_quasiquote] = STATE(2759),
    [sym__varid] = ACTIONS(7068),
    [sym_float] = ACTIONS(7070),
    [sym_char] = ACTIONS(7070),
    [sym_string] = ACTIONS(7070),
    [sym__integer_literal] = ACTIONS(7072),
    [sym__binary_literal] = ACTIONS(7074),
    [sym__octal_literal] = ACTIONS(7074),
    [sym__hex_literal] = ACTIONS(7074),
    [anon_sym_LPAREN_POUND] = ACTIONS(7076),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7076),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7078),
    [sym__conid] = ACTIONS(7082),
    [anon_sym_LBRACK] = ACTIONS(7084),
    [anon_sym_SQUOTE] = ACTIONS(7086),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7088),
    [anon_sym_6] = ACTIONS(7088),
    [anon_sym_7] = ACTIONS(7090),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7092),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7094),
  },
  [2649] = {
    [sym_integer] = STATE(6432),
    [sym__literal] = STATE(6432),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(5995),
    [sym_con_unit] = STATE(6432),
    [sym_con_list] = STATE(6432),
    [sym_con_tuple] = STATE(6432),
    [sym_qualified_type] = STATE(6532),
    [sym_tycon_arrow] = STATE(6532),
    [sym_type_literal] = STATE(2477),
    [sym__promoted_tycon] = STATE(6532),
    [sym_type_variable] = STATE(6532),
    [sym_annotated_type_variable] = STATE(6532),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14042),
    [sym_type_parens] = STATE(2477),
    [sym_type_list] = STATE(2477),
    [sym_type_tuple] = STATE(2477),
    [sym__type_promotable_literal] = STATE(2477),
    [sym__type_promoted_literal] = STATE(2477),
    [sym__type_literal] = STATE(2477),
    [sym_type_name] = STATE(2457),
    [sym_type_star] = STATE(2477),
    [sym_type_unboxed_tuple] = STATE(2477),
    [sym_type_unboxed_sum] = STATE(2477),
    [sym__atype] = STATE(2477),
    [sym_type_apply] = STATE(7621),
    [sym__btype] = STATE(7621),
    [sym_type_infix] = STATE(9737),
    [sym__type_infix] = STATE(9596),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2649),
    [sym__type_quantifiers] = STATE(12138),
    [sym__type_context] = STATE(12138),
    [sym__type_fun] = STATE(12138),
    [sym__type] = STATE(12138),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14749),
    [sym_splice] = STATE(2477),
    [sym_quasiquote] = STATE(2477),
    [sym__varid] = ACTIONS(7285),
    [sym_float] = ACTIONS(7287),
    [sym_char] = ACTIONS(7287),
    [sym_string] = ACTIONS(7287),
    [sym__integer_literal] = ACTIONS(7289),
    [sym__binary_literal] = ACTIONS(7291),
    [sym__octal_literal] = ACTIONS(7291),
    [sym__hex_literal] = ACTIONS(7291),
    [anon_sym_LPAREN_POUND] = ACTIONS(7293),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7293),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7295),
    [sym__conid] = ACTIONS(7299),
    [anon_sym_LBRACK] = ACTIONS(7301),
    [anon_sym_SQUOTE] = ACTIONS(7303),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7305),
    [anon_sym_6] = ACTIONS(7305),
    [anon_sym_7] = ACTIONS(7307),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7309),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7311),
  },
  [2650] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(13658),
    [sym__type_context] = STATE(13658),
    [sym__type_fun] = STATE(13658),
    [sym__type] = STATE(13658),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2651] = {
    [sym_integer] = STATE(7208),
    [sym__literal] = STATE(7208),
    [sym__unboxed_open] = STATE(2156),
    [sym_constructor] = STATE(6817),
    [sym_con_unit] = STATE(7208),
    [sym_con_list] = STATE(7208),
    [sym_con_tuple] = STATE(7208),
    [sym_qualified_type] = STATE(7291),
    [sym_tycon_arrow] = STATE(7291),
    [sym_type_literal] = STATE(2699),
    [sym__promoted_tycon] = STATE(7291),
    [sym_type_variable] = STATE(7291),
    [sym_annotated_type_variable] = STATE(7291),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14074),
    [sym_type_parens] = STATE(2699),
    [sym_type_list] = STATE(2699),
    [sym_type_tuple] = STATE(2699),
    [sym__type_promotable_literal] = STATE(2699),
    [sym__type_promoted_literal] = STATE(2699),
    [sym__type_literal] = STATE(2699),
    [sym_type_name] = STATE(2693),
    [sym_type_star] = STATE(2699),
    [sym_type_unboxed_tuple] = STATE(2699),
    [sym_type_unboxed_sum] = STATE(2699),
    [sym__atype] = STATE(2699),
    [sym_type_apply] = STATE(8012),
    [sym__btype] = STATE(8012),
    [sym_type_infix] = STATE(12364),
    [sym__type_infix] = STATE(12056),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2560),
    [sym__type_quantifiers] = STATE(14185),
    [sym__type_context] = STATE(14185),
    [sym__type_fun] = STATE(14185),
    [sym__type] = STATE(14185),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14826),
    [sym_splice] = STATE(2699),
    [sym_quasiquote] = STATE(2699),
    [sym__varid] = ACTIONS(6436),
    [sym_float] = ACTIONS(6438),
    [sym_char] = ACTIONS(6438),
    [sym_string] = ACTIONS(6438),
    [sym__integer_literal] = ACTIONS(6440),
    [sym__binary_literal] = ACTIONS(6442),
    [sym__octal_literal] = ACTIONS(6442),
    [sym__hex_literal] = ACTIONS(6442),
    [anon_sym_LPAREN_POUND] = ACTIONS(6444),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6444),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6446),
    [sym__conid] = ACTIONS(6450),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(6454),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_6] = ACTIONS(6456),
    [anon_sym_7] = ACTIONS(6458),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6460),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6462),
  },
  [2652] = {
    [sym_integer] = STATE(7045),
    [sym__literal] = STATE(7045),
    [sym__unboxed_open] = STATE(2097),
    [sym_constructor] = STATE(6786),
    [sym_con_unit] = STATE(7045),
    [sym_con_list] = STATE(7045),
    [sym_con_tuple] = STATE(7045),
    [sym_qualified_type] = STATE(7047),
    [sym_tycon_arrow] = STATE(7047),
    [sym_type_literal] = STATE(2652),
    [sym__promoted_tycon] = STATE(7047),
    [sym_type_variable] = STATE(7047),
    [sym_annotated_type_variable] = STATE(7047),
    [sym_type_parens] = STATE(2652),
    [sym_type_list] = STATE(2652),
    [sym_type_tuple] = STATE(2652),
    [sym__type_promotable_literal] = STATE(2652),
    [sym__type_promoted_literal] = STATE(2652),
    [sym__type_literal] = STATE(2652),
    [sym_type_name] = STATE(2652),
    [sym_type_star] = STATE(2652),
    [sym_type_unboxed_tuple] = STATE(2652),
    [sym_type_unboxed_sum] = STATE(2652),
    [sym__atype] = STATE(2652),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15321),
    [sym_splice] = STATE(2652),
    [sym_quasiquote] = STATE(2652),
    [aux_sym_type_apply_repeat1] = STATE(2652),
    [sym__varid] = ACTIONS(8407),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(8410),
    [sym_char] = ACTIONS(8410),
    [sym_string] = ACTIONS(8410),
    [sym__integer_literal] = ACTIONS(8413),
    [sym__binary_literal] = ACTIONS(8416),
    [sym__octal_literal] = ACTIONS(8416),
    [sym__hex_literal] = ACTIONS(8416),
    [anon_sym_LPAREN_POUND] = ACTIONS(8419),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8419),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8422),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(8425),
    [anon_sym_LBRACK] = ACTIONS(8428),
    [anon_sym_SQUOTE] = ACTIONS(8431),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(8434),
    [anon_sym_6] = ACTIONS(8434),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_in] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(8437),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym__layout_end] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(8440),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8443),
  },
  [2653] = {
    [sym_integer] = STATE(6509),
    [sym__literal] = STATE(6509),
    [sym__unboxed_open] = STATE(2133),
    [sym_constructor] = STATE(5968),
    [sym_con_unit] = STATE(6509),
    [sym_con_list] = STATE(6509),
    [sym_con_tuple] = STATE(6509),
    [sym_qualified_type] = STATE(6463),
    [sym_tycon_arrow] = STATE(6463),
    [sym_type_literal] = STATE(2456),
    [sym__promoted_tycon] = STATE(6463),
    [sym_type_variable] = STATE(6463),
    [sym_annotated_type_variable] = STATE(6463),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14523),
    [sym_type_parens] = STATE(2456),
    [sym_type_list] = STATE(2456),
    [sym_type_tuple] = STATE(2456),
    [sym__type_promotable_literal] = STATE(2456),
    [sym__type_promoted_literal] = STATE(2456),
    [sym__type_literal] = STATE(2456),
    [sym_type_name] = STATE(2478),
    [sym_type_star] = STATE(2456),
    [sym_type_unboxed_tuple] = STATE(2456),
    [sym_type_unboxed_sum] = STATE(2456),
    [sym__atype] = STATE(2456),
    [sym_type_apply] = STATE(7597),
    [sym__btype] = STATE(7597),
    [sym_type_infix] = STATE(11310),
    [sym__type_infix] = STATE(11811),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2644),
    [sym__type_quantifiers] = STATE(13488),
    [sym__type_context] = STATE(13488),
    [sym__type_fun] = STATE(13488),
    [sym__type] = STATE(13488),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14649),
    [sym_splice] = STATE(2456),
    [sym_quasiquote] = STATE(2456),
    [sym__varid] = ACTIONS(7397),
    [sym_float] = ACTIONS(7399),
    [sym_char] = ACTIONS(7399),
    [sym_string] = ACTIONS(7399),
    [sym__integer_literal] = ACTIONS(7401),
    [sym__binary_literal] = ACTIONS(7403),
    [sym__octal_literal] = ACTIONS(7403),
    [sym__hex_literal] = ACTIONS(7403),
    [anon_sym_LPAREN_POUND] = ACTIONS(7405),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7405),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7407),
    [sym__conid] = ACTIONS(7411),
    [anon_sym_LBRACK] = ACTIONS(7413),
    [anon_sym_SQUOTE] = ACTIONS(7415),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7417),
    [anon_sym_6] = ACTIONS(7417),
    [anon_sym_7] = ACTIONS(7419),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7421),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7423),
  },
  [2654] = {
    [sym_integer] = STATE(6432),
    [sym__literal] = STATE(6432),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(5995),
    [sym_con_unit] = STATE(6432),
    [sym_con_list] = STATE(6432),
    [sym_con_tuple] = STATE(6432),
    [sym_qualified_type] = STATE(6532),
    [sym_tycon_arrow] = STATE(6532),
    [sym_type_literal] = STATE(2477),
    [sym__promoted_tycon] = STATE(6532),
    [sym_type_variable] = STATE(6532),
    [sym_annotated_type_variable] = STATE(6532),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14042),
    [sym_type_parens] = STATE(2477),
    [sym_type_list] = STATE(2477),
    [sym_type_tuple] = STATE(2477),
    [sym__type_promotable_literal] = STATE(2477),
    [sym__type_promoted_literal] = STATE(2477),
    [sym__type_literal] = STATE(2477),
    [sym_type_name] = STATE(2457),
    [sym_type_star] = STATE(2477),
    [sym_type_unboxed_tuple] = STATE(2477),
    [sym_type_unboxed_sum] = STATE(2477),
    [sym__atype] = STATE(2477),
    [sym_type_apply] = STATE(7621),
    [sym__btype] = STATE(7621),
    [sym_type_infix] = STATE(9737),
    [sym__type_infix] = STATE(9596),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2649),
    [sym__type_quantifiers] = STATE(12124),
    [sym__type_context] = STATE(12124),
    [sym__type_fun] = STATE(12124),
    [sym__type] = STATE(12124),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14749),
    [sym_splice] = STATE(2477),
    [sym_quasiquote] = STATE(2477),
    [sym__varid] = ACTIONS(7285),
    [sym_float] = ACTIONS(7287),
    [sym_char] = ACTIONS(7287),
    [sym_string] = ACTIONS(7287),
    [sym__integer_literal] = ACTIONS(7289),
    [sym__binary_literal] = ACTIONS(7291),
    [sym__octal_literal] = ACTIONS(7291),
    [sym__hex_literal] = ACTIONS(7291),
    [anon_sym_LPAREN_POUND] = ACTIONS(7293),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7293),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7295),
    [sym__conid] = ACTIONS(7299),
    [anon_sym_LBRACK] = ACTIONS(7301),
    [anon_sym_SQUOTE] = ACTIONS(7303),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7305),
    [anon_sym_6] = ACTIONS(7305),
    [anon_sym_7] = ACTIONS(7307),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7309),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7311),
  },
  [2655] = {
    [sym_integer] = STATE(6388),
    [sym__literal] = STATE(6388),
    [sym__unboxed_open] = STATE(2114),
    [sym_constructor] = STATE(6175),
    [sym_con_unit] = STATE(6388),
    [sym_con_list] = STATE(6388),
    [sym_con_tuple] = STATE(6388),
    [sym_qualified_type] = STATE(6387),
    [sym_tycon_arrow] = STATE(6387),
    [sym_type_literal] = STATE(2458),
    [sym__promoted_tycon] = STATE(6387),
    [sym_type_variable] = STATE(6387),
    [sym_annotated_type_variable] = STATE(6387),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14193),
    [sym_type_parens] = STATE(2458),
    [sym_type_list] = STATE(2458),
    [sym_type_tuple] = STATE(2458),
    [sym__type_promotable_literal] = STATE(2458),
    [sym__type_promoted_literal] = STATE(2458),
    [sym__type_literal] = STATE(2458),
    [sym_type_name] = STATE(2455),
    [sym_type_star] = STATE(2458),
    [sym_type_unboxed_tuple] = STATE(2458),
    [sym_type_unboxed_sum] = STATE(2458),
    [sym__atype] = STATE(2458),
    [sym_type_apply] = STATE(7646),
    [sym__btype] = STATE(7646),
    [sym_type_infix] = STATE(9881),
    [sym__type_infix] = STATE(9597),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2670),
    [sym__type_quantifiers] = STATE(11986),
    [sym__type_context] = STATE(11986),
    [sym__type_fun] = STATE(11986),
    [sym__type] = STATE(11986),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15425),
    [sym_splice] = STATE(2458),
    [sym_quasiquote] = STATE(2458),
    [sym__varid] = ACTIONS(6748),
    [sym_float] = ACTIONS(6750),
    [sym_char] = ACTIONS(6750),
    [sym_string] = ACTIONS(6750),
    [sym__integer_literal] = ACTIONS(6752),
    [sym__binary_literal] = ACTIONS(6754),
    [sym__octal_literal] = ACTIONS(6754),
    [sym__hex_literal] = ACTIONS(6754),
    [anon_sym_LPAREN_POUND] = ACTIONS(6756),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6756),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6758),
    [sym__conid] = ACTIONS(6762),
    [anon_sym_LBRACK] = ACTIONS(6764),
    [anon_sym_SQUOTE] = ACTIONS(6766),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6768),
    [anon_sym_6] = ACTIONS(6768),
    [anon_sym_7] = ACTIONS(6770),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6772),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6774),
  },
  [2656] = {
    [sym_integer] = STATE(6432),
    [sym__literal] = STATE(6432),
    [sym__unboxed_open] = STATE(2106),
    [sym_constructor] = STATE(5995),
    [sym_con_unit] = STATE(6432),
    [sym_con_list] = STATE(6432),
    [sym_con_tuple] = STATE(6432),
    [sym_qualified_type] = STATE(6532),
    [sym_tycon_arrow] = STATE(6532),
    [sym_type_literal] = STATE(2477),
    [sym__promoted_tycon] = STATE(6532),
    [sym_type_variable] = STATE(6532),
    [sym_annotated_type_variable] = STATE(6532),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14042),
    [sym_type_parens] = STATE(2477),
    [sym_type_list] = STATE(2477),
    [sym_type_tuple] = STATE(2477),
    [sym__type_promotable_literal] = STATE(2477),
    [sym__type_promoted_literal] = STATE(2477),
    [sym__type_literal] = STATE(2477),
    [sym_type_name] = STATE(2457),
    [sym_type_star] = STATE(2477),
    [sym_type_unboxed_tuple] = STATE(2477),
    [sym_type_unboxed_sum] = STATE(2477),
    [sym__atype] = STATE(2477),
    [sym_type_apply] = STATE(7621),
    [sym__btype] = STATE(7621),
    [sym_type_infix] = STATE(9737),
    [sym__type_infix] = STATE(9596),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2649),
    [sym__type_quantifiers] = STATE(12126),
    [sym__type_context] = STATE(12126),
    [sym__type_fun] = STATE(12126),
    [sym__type] = STATE(12126),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14749),
    [sym_splice] = STATE(2477),
    [sym_quasiquote] = STATE(2477),
    [sym__varid] = ACTIONS(7285),
    [sym_float] = ACTIONS(7287),
    [sym_char] = ACTIONS(7287),
    [sym_string] = ACTIONS(7287),
    [sym__integer_literal] = ACTIONS(7289),
    [sym__binary_literal] = ACTIONS(7291),
    [sym__octal_literal] = ACTIONS(7291),
    [sym__hex_literal] = ACTIONS(7291),
    [anon_sym_LPAREN_POUND] = ACTIONS(7293),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7293),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7295),
    [sym__conid] = ACTIONS(7299),
    [anon_sym_LBRACK] = ACTIONS(7301),
    [anon_sym_SQUOTE] = ACTIONS(7303),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7305),
    [anon_sym_6] = ACTIONS(7305),
    [anon_sym_7] = ACTIONS(7307),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7309),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7311),
  },
  [2657] = {
    [sym_integer] = STATE(6388),
    [sym__literal] = STATE(6388),
    [sym__unboxed_open] = STATE(2114),
    [sym_constructor] = STATE(6175),
    [sym_con_unit] = STATE(6388),
    [sym_con_list] = STATE(6388),
    [sym_con_tuple] = STATE(6388),
    [sym_qualified_type] = STATE(6387),
    [sym_tycon_arrow] = STATE(6387),
    [sym_type_literal] = STATE(2458),
    [sym__promoted_tycon] = STATE(6387),
    [sym_type_variable] = STATE(6387),
    [sym_annotated_type_variable] = STATE(6387),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14193),
    [sym_type_parens] = STATE(2458),
    [sym_type_list] = STATE(2458),
    [sym_type_tuple] = STATE(2458),
    [sym__type_promotable_literal] = STATE(2458),
    [sym__type_promoted_literal] = STATE(2458),
    [sym__type_literal] = STATE(2458),
    [sym_type_name] = STATE(2455),
    [sym_type_star] = STATE(2458),
    [sym_type_unboxed_tuple] = STATE(2458),
    [sym_type_unboxed_sum] = STATE(2458),
    [sym__atype] = STATE(2458),
    [sym_type_apply] = STATE(7646),
    [sym__btype] = STATE(7646),
    [sym_type_infix] = STATE(9881),
    [sym__type_infix] = STATE(9597),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2670),
    [sym__type_quantifiers] = STATE(11988),
    [sym__type_context] = STATE(11988),
    [sym__type_fun] = STATE(11988),
    [sym__type] = STATE(11988),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15425),
    [sym_splice] = STATE(2458),
    [sym_quasiquote] = STATE(2458),
    [sym__varid] = ACTIONS(6748),
    [sym_float] = ACTIONS(6750),
    [sym_char] = ACTIONS(6750),
    [sym_string] = ACTIONS(6750),
    [sym__integer_literal] = ACTIONS(6752),
    [sym__binary_literal] = ACTIONS(6754),
    [sym__octal_literal] = ACTIONS(6754),
    [sym__hex_literal] = ACTIONS(6754),
    [anon_sym_LPAREN_POUND] = ACTIONS(6756),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6756),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6758),
    [sym__conid] = ACTIONS(6762),
    [anon_sym_LBRACK] = ACTIONS(6764),
    [anon_sym_SQUOTE] = ACTIONS(6766),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6768),
    [anon_sym_6] = ACTIONS(6768),
    [anon_sym_7] = ACTIONS(6770),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6772),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6774),
  },
  [2658] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14569),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(9442),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2505),
    [sym__type_quantifiers] = STATE(15066),
    [sym__type_context] = STATE(15066),
    [sym__type_fun] = STATE(15066),
    [sym__type] = STATE(15066),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2659] = {
    [sym_integer] = STATE(7224),
    [sym__literal] = STATE(7224),
    [sym__unboxed_open] = STATE(2201),
    [sym_constructor] = STATE(6997),
    [sym_con_unit] = STATE(7224),
    [sym_con_list] = STATE(7224),
    [sym_con_tuple] = STATE(7224),
    [sym_qualified_type] = STATE(7098),
    [sym_tycon_arrow] = STATE(7098),
    [sym_type_literal] = STATE(2726),
    [sym__promoted_tycon] = STATE(7098),
    [sym_type_variable] = STATE(7098),
    [sym_annotated_type_variable] = STATE(7098),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14123),
    [sym_type_parens] = STATE(2726),
    [sym_type_list] = STATE(2726),
    [sym_type_tuple] = STATE(2726),
    [sym__type_promotable_literal] = STATE(2726),
    [sym__type_promoted_literal] = STATE(2726),
    [sym__type_literal] = STATE(2726),
    [sym_type_name] = STATE(2712),
    [sym_type_star] = STATE(2726),
    [sym_type_unboxed_tuple] = STATE(2726),
    [sym_type_unboxed_sum] = STATE(2726),
    [sym__atype] = STATE(2726),
    [sym_type_apply] = STATE(8043),
    [sym__btype] = STATE(8043),
    [sym_type_infix] = STATE(12452),
    [sym__type_infix] = STATE(12183),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2594),
    [sym__type_quantifiers] = STATE(14116),
    [sym__type_context] = STATE(14116),
    [sym__type_fun] = STATE(14116),
    [sym__type] = STATE(14116),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15261),
    [sym_splice] = STATE(2726),
    [sym_quasiquote] = STATE(2726),
    [sym__varid] = ACTIONS(6531),
    [sym_float] = ACTIONS(6533),
    [sym_char] = ACTIONS(6533),
    [sym_string] = ACTIONS(6533),
    [sym__integer_literal] = ACTIONS(6535),
    [sym__binary_literal] = ACTIONS(6537),
    [sym__octal_literal] = ACTIONS(6537),
    [sym__hex_literal] = ACTIONS(6537),
    [anon_sym_LPAREN_POUND] = ACTIONS(6539),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6539),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6541),
    [sym__conid] = ACTIONS(6545),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_SQUOTE] = ACTIONS(6549),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6551),
    [anon_sym_6] = ACTIONS(6551),
    [anon_sym_7] = ACTIONS(6553),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6555),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6557),
  },
  [2660] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(2971),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(14284),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3372),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym__datainst] = STATE(18638),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_instance] = ACTIONS(8446),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2661] = {
    [sym_integer] = STATE(9549),
    [sym__literal] = STATE(9549),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = STATE(9576),
    [sym_qualified_variable] = STATE(9576),
    [sym_constructor] = STATE(9458),
    [sym_qualified_constructor] = STATE(9525),
    [sym__qcon] = STATE(9576),
    [sym_con_unit] = STATE(9549),
    [sym_con_list] = STATE(9549),
    [sym_con_tuple] = STATE(9549),
    [sym_literal] = STATE(9934),
    [sym_exp_parens] = STATE(9934),
    [sym_exp_tuple] = STATE(9934),
    [sym_exp_unboxed_tuple] = STATE(9934),
    [sym_exp_unboxed_sum] = STATE(9934),
    [sym_exp_list] = STATE(9934),
    [sym_exp_arithmetic_sequence] = STATE(9934),
    [sym_exp_list_comprehension] = STATE(9934),
    [sym_exp_section_left] = STATE(9934),
    [sym_exp_section_right] = STATE(9934),
    [sym_exp_th_quoted_name] = STATE(9934),
    [sym_exp_type_application] = STATE(10314),
    [sym_exp_lambda_case] = STATE(10314),
    [sym__do_keyword] = STATE(18492),
    [sym_do_module] = STATE(18492),
    [sym_exp_do] = STATE(10314),
    [sym_exp_record] = STATE(9934),
    [sym_exp_name] = STATE(9934),
    [sym_exp_projection_selector] = STATE(9934),
    [sym__aexp_projection] = STATE(9934),
    [sym_exp_projection] = STATE(9934),
    [sym__aexp] = STATE(10314),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12670),
    [sym_splice] = STATE(9934),
    [sym_quasiquote] = STATE(9934),
    [sym__varid] = ACTIONS(4095),
    [sym_float] = ACTIONS(4097),
    [sym_char] = ACTIONS(4097),
    [sym_string] = ACTIONS(4097),
    [sym__integer_literal] = ACTIONS(4099),
    [sym__binary_literal] = ACTIONS(4101),
    [sym__octal_literal] = ACTIONS(4101),
    [sym__hex_literal] = ACTIONS(4101),
    [anon_sym_LPAREN_POUND] = ACTIONS(8448),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8448),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4105),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [anon_sym_RPAREN] = ACTIONS(4109),
    [sym_implicit_parid] = ACTIONS(4105),
    [sym__conid] = ACTIONS(4111),
    [anon_sym_LBRACK] = ACTIONS(8452),
    [anon_sym_SQUOTE] = ACTIONS(4115),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4117),
    [anon_sym_AT] = ACTIONS(4119),
    [anon_sym_BSLASH] = ACTIONS(4121),
    [anon_sym_mdo] = ACTIONS(4123),
    [anon_sym_do] = ACTIONS(4123),
    [anon_sym_7] = ACTIONS(4125),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4127),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4129),
  },
  [2662] = {
    [sym_integer] = STATE(6475),
    [sym__literal] = STATE(6475),
    [sym__unboxed_open] = STATE(2221),
    [sym_constructor] = STATE(6005),
    [sym_con_unit] = STATE(6475),
    [sym_con_list] = STATE(6475),
    [sym_con_tuple] = STATE(6475),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2474),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym_annotated_type_variable] = STATE(6545),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14062),
    [sym_type_parens] = STATE(2474),
    [sym_type_list] = STATE(2474),
    [sym_type_tuple] = STATE(2474),
    [sym__type_promotable_literal] = STATE(2474),
    [sym__type_promoted_literal] = STATE(2474),
    [sym__type_literal] = STATE(2474),
    [sym_type_name] = STATE(2453),
    [sym_type_star] = STATE(2474),
    [sym_type_unboxed_tuple] = STATE(2474),
    [sym_type_unboxed_sum] = STATE(2474),
    [sym__atype] = STATE(2474),
    [sym_type_apply] = STATE(7618),
    [sym__btype] = STATE(7618),
    [sym_type_infix] = STATE(9792),
    [sym__type_infix] = STATE(9655),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2631),
    [sym__type_quantifiers] = STATE(12178),
    [sym__type_context] = STATE(12178),
    [sym__type_fun] = STATE(12178),
    [sym__type] = STATE(12178),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14761),
    [sym_splice] = STATE(2474),
    [sym_quasiquote] = STATE(2474),
    [sym__varid] = ACTIONS(6643),
    [sym_float] = ACTIONS(6645),
    [sym_char] = ACTIONS(6645),
    [sym_string] = ACTIONS(6645),
    [sym__integer_literal] = ACTIONS(6647),
    [sym__binary_literal] = ACTIONS(6649),
    [sym__octal_literal] = ACTIONS(6649),
    [sym__hex_literal] = ACTIONS(6649),
    [anon_sym_LPAREN_POUND] = ACTIONS(6651),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6651),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6653),
    [sym__conid] = ACTIONS(6657),
    [anon_sym_LBRACK] = ACTIONS(6659),
    [anon_sym_SQUOTE] = ACTIONS(6661),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6663),
    [anon_sym_6] = ACTIONS(6663),
    [anon_sym_7] = ACTIONS(6665),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6669),
  },
  [2663] = {
    [sym_integer] = STATE(6475),
    [sym__literal] = STATE(6475),
    [sym__unboxed_open] = STATE(2221),
    [sym_constructor] = STATE(6005),
    [sym_con_unit] = STATE(6475),
    [sym_con_list] = STATE(6475),
    [sym_con_tuple] = STATE(6475),
    [sym_qualified_type] = STATE(6545),
    [sym_tycon_arrow] = STATE(6545),
    [sym_type_literal] = STATE(2474),
    [sym__promoted_tycon] = STATE(6545),
    [sym_type_variable] = STATE(6545),
    [sym_annotated_type_variable] = STATE(6545),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14062),
    [sym_type_parens] = STATE(2474),
    [sym_type_list] = STATE(2474),
    [sym_type_tuple] = STATE(2474),
    [sym__type_promotable_literal] = STATE(2474),
    [sym__type_promoted_literal] = STATE(2474),
    [sym__type_literal] = STATE(2474),
    [sym_type_name] = STATE(2453),
    [sym_type_star] = STATE(2474),
    [sym_type_unboxed_tuple] = STATE(2474),
    [sym_type_unboxed_sum] = STATE(2474),
    [sym__atype] = STATE(2474),
    [sym_type_apply] = STATE(7618),
    [sym__btype] = STATE(7618),
    [sym_type_infix] = STATE(9792),
    [sym__type_infix] = STATE(9655),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2631),
    [sym__type_quantifiers] = STATE(12034),
    [sym__type_context] = STATE(12034),
    [sym__type_fun] = STATE(12034),
    [sym__type] = STATE(12034),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14761),
    [sym_splice] = STATE(2474),
    [sym_quasiquote] = STATE(2474),
    [sym__varid] = ACTIONS(6643),
    [sym_float] = ACTIONS(6645),
    [sym_char] = ACTIONS(6645),
    [sym_string] = ACTIONS(6645),
    [sym__integer_literal] = ACTIONS(6647),
    [sym__binary_literal] = ACTIONS(6649),
    [sym__octal_literal] = ACTIONS(6649),
    [sym__hex_literal] = ACTIONS(6649),
    [anon_sym_LPAREN_POUND] = ACTIONS(6651),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6651),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6653),
    [sym__conid] = ACTIONS(6657),
    [anon_sym_LBRACK] = ACTIONS(6659),
    [anon_sym_SQUOTE] = ACTIONS(6661),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6663),
    [anon_sym_6] = ACTIONS(6663),
    [anon_sym_7] = ACTIONS(6665),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6667),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6669),
  },
  [2664] = {
    [sym_integer] = STATE(6425),
    [sym__literal] = STATE(6425),
    [sym__unboxed_open] = STATE(2108),
    [sym_constructor] = STATE(5969),
    [sym_con_unit] = STATE(6425),
    [sym_con_list] = STATE(6425),
    [sym_con_tuple] = STATE(6425),
    [sym_qualified_type] = STATE(6424),
    [sym_tycon_arrow] = STATE(6424),
    [sym_type_literal] = STATE(2461),
    [sym__promoted_tycon] = STATE(6424),
    [sym_type_variable] = STATE(6424),
    [sym_annotated_type_variable] = STATE(6424),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(3144),
    [sym_type_parens] = STATE(2461),
    [sym_type_list] = STATE(2461),
    [sym_type_tuple] = STATE(2461),
    [sym__type_promotable_literal] = STATE(2461),
    [sym__type_promoted_literal] = STATE(2461),
    [sym__type_literal] = STATE(2461),
    [sym_type_name] = STATE(2449),
    [sym_type_star] = STATE(2461),
    [sym_type_unboxed_tuple] = STATE(2461),
    [sym_type_unboxed_sum] = STATE(2461),
    [sym__atype] = STATE(2461),
    [sym_type_apply] = STATE(7690),
    [sym__btype] = STATE(7690),
    [sym_type_infix] = STATE(11131),
    [sym__type_infix] = STATE(12519),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3413),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15009),
    [sym__datainst] = STATE(13072),
    [sym_splice] = STATE(2461),
    [sym_quasiquote] = STATE(2461),
    [sym__varid] = ACTIONS(7229),
    [sym_float] = ACTIONS(7231),
    [sym_char] = ACTIONS(7231),
    [sym_string] = ACTIONS(7231),
    [sym__integer_literal] = ACTIONS(7233),
    [sym__binary_literal] = ACTIONS(7235),
    [sym__octal_literal] = ACTIONS(7235),
    [sym__hex_literal] = ACTIONS(7235),
    [anon_sym_LPAREN_POUND] = ACTIONS(7237),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7237),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7239),
    [sym__conid] = ACTIONS(7243),
    [anon_sym_LBRACK] = ACTIONS(7245),
    [anon_sym_SQUOTE] = ACTIONS(7247),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7249),
    [anon_sym_6] = ACTIONS(7249),
    [anon_sym_instance] = ACTIONS(8454),
    [anon_sym_7] = ACTIONS(7251),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7253),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7255),
  },
  [2665] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14454),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(3154),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9653),
    [sym__btype] = STATE(9653),
    [sym_implicit_param] = STATE(18531),
    [sym_type_infix] = STATE(14979),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(18531),
    [sym__constraint_context] = STATE(18531),
    [sym__constraint] = STATE(18531),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2743),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8456),
    [sym_implicit_parid] = ACTIONS(1787),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(8458),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2666] = {
    [sym_integer] = STATE(7156),
    [sym__literal] = STATE(7156),
    [sym__unboxed_open] = STATE(2209),
    [sym_constructor] = STATE(6790),
    [sym_con_unit] = STATE(7156),
    [sym_con_list] = STATE(7156),
    [sym_con_tuple] = STATE(7156),
    [sym_qualified_type] = STATE(7260),
    [sym_tycon_arrow] = STATE(7260),
    [sym_type_literal] = STATE(2713),
    [sym__promoted_tycon] = STATE(7260),
    [sym_type_variable] = STATE(7260),
    [sym_annotated_type_variable] = STATE(7260),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14496),
    [sym_type_parens] = STATE(2713),
    [sym_type_list] = STATE(2713),
    [sym_type_tuple] = STATE(2713),
    [sym__type_promotable_literal] = STATE(2713),
    [sym__type_promoted_literal] = STATE(2713),
    [sym__type_literal] = STATE(2713),
    [sym_type_name] = STATE(2682),
    [sym_type_star] = STATE(2713),
    [sym_type_unboxed_tuple] = STATE(2713),
    [sym_type_unboxed_sum] = STATE(2713),
    [sym__atype] = STATE(2713),
    [sym_type_apply] = STATE(7968),
    [sym__btype] = STATE(7968),
    [sym_type_infix] = STATE(12340),
    [sym__type_infix] = STATE(12119),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2666),
    [sym__type_quantifiers] = STATE(13110),
    [sym__type_context] = STATE(13110),
    [sym__type_fun] = STATE(13110),
    [sym__type] = STATE(13110),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14821),
    [sym_splice] = STATE(2713),
    [sym_quasiquote] = STATE(2713),
    [sym__varid] = ACTIONS(6503),
    [sym_float] = ACTIONS(6505),
    [sym_char] = ACTIONS(6505),
    [sym_string] = ACTIONS(6505),
    [sym__integer_literal] = ACTIONS(6507),
    [sym__binary_literal] = ACTIONS(6509),
    [sym__octal_literal] = ACTIONS(6509),
    [sym__hex_literal] = ACTIONS(6509),
    [anon_sym_LPAREN_POUND] = ACTIONS(6511),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6511),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6513),
    [sym__conid] = ACTIONS(6517),
    [anon_sym_LBRACK] = ACTIONS(6519),
    [anon_sym_SQUOTE] = ACTIONS(6521),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6523),
    [anon_sym_6] = ACTIONS(6523),
    [anon_sym_7] = ACTIONS(6525),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6527),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6529),
  },
  [2667] = {
    [sym_integer] = STATE(6592),
    [sym__literal] = STATE(6592),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6403),
    [sym_con_unit] = STATE(6592),
    [sym_con_list] = STATE(6592),
    [sym_con_tuple] = STATE(6592),
    [sym_qualified_type] = STATE(6680),
    [sym_tycon_arrow] = STATE(6680),
    [sym_type_literal] = STATE(2491),
    [sym__promoted_tycon] = STATE(6680),
    [sym_type_variable] = STATE(6680),
    [sym_annotated_type_variable] = STATE(6680),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(3127),
    [sym_type_parens] = STATE(2491),
    [sym_type_list] = STATE(2491),
    [sym_type_tuple] = STATE(2491),
    [sym__type_promotable_literal] = STATE(2491),
    [sym__type_promoted_literal] = STATE(2491),
    [sym__type_literal] = STATE(2491),
    [sym_type_name] = STATE(2480),
    [sym_type_star] = STATE(2491),
    [sym_type_unboxed_tuple] = STATE(2491),
    [sym_type_unboxed_sum] = STATE(2491),
    [sym__atype] = STATE(2491),
    [sym_type_apply] = STATE(7807),
    [sym__btype] = STATE(7807),
    [sym_type_infix] = STATE(11549),
    [sym__type_infix] = STATE(13063),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3394),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14854),
    [sym__datainst] = STATE(13175),
    [sym_splice] = STATE(2491),
    [sym_quasiquote] = STATE(2491),
    [sym__varid] = ACTIONS(6304),
    [sym_float] = ACTIONS(6306),
    [sym_char] = ACTIONS(6306),
    [sym_string] = ACTIONS(6306),
    [sym__integer_literal] = ACTIONS(6308),
    [sym__binary_literal] = ACTIONS(6310),
    [sym__octal_literal] = ACTIONS(6310),
    [sym__hex_literal] = ACTIONS(6310),
    [anon_sym_LPAREN_POUND] = ACTIONS(6312),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6312),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6314),
    [sym__conid] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_6] = ACTIONS(6324),
    [anon_sym_instance] = ACTIONS(8460),
    [anon_sym_7] = ACTIONS(6326),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6328),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6330),
  },
  [2668] = {
    [sym_integer] = STATE(7364),
    [sym__literal] = STATE(7364),
    [sym__unboxed_open] = STATE(2118),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(7364),
    [sym_con_list] = STATE(7364),
    [sym_con_tuple] = STATE(7364),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2742),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14362),
    [sym_type_parens] = STATE(2742),
    [sym_type_list] = STATE(2742),
    [sym_type_tuple] = STATE(2742),
    [sym__type_promotable_literal] = STATE(2742),
    [sym__type_promoted_literal] = STATE(2742),
    [sym__type_literal] = STATE(2742),
    [sym_type_name] = STATE(2746),
    [sym_type_star] = STATE(2742),
    [sym_type_unboxed_tuple] = STATE(2742),
    [sym_type_unboxed_sum] = STATE(2742),
    [sym__atype] = STATE(2742),
    [sym_type_apply] = STATE(8238),
    [sym__btype] = STATE(8238),
    [sym_type_infix] = STATE(12673),
    [sym__type_infix] = STATE(12353),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2527),
    [sym__type_quantifiers] = STATE(13645),
    [sym__type_context] = STATE(13645),
    [sym__type_fun] = STATE(13645),
    [sym__type] = STATE(13645),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2742),
    [sym_quasiquote] = STATE(2742),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(1773),
    [sym_char] = ACTIONS(1773),
    [sym_string] = ACTIONS(1773),
    [sym__integer_literal] = ACTIONS(1775),
    [sym__binary_literal] = ACTIONS(1777),
    [sym__octal_literal] = ACTIONS(1777),
    [sym__hex_literal] = ACTIONS(1777),
    [anon_sym_LPAREN_POUND] = ACTIONS(1779),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(1779),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3078),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_6] = ACTIONS(1799),
    [anon_sym_7] = ACTIONS(1801),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(1809),
  },
  [2669] = {
    [sym_integer] = STATE(6347),
    [sym__literal] = STATE(6347),
    [sym__unboxed_open] = STATE(2174),
    [sym_constructor] = STATE(6222),
    [sym_con_unit] = STATE(6347),
    [sym_con_list] = STATE(6347),
    [sym_con_tuple] = STATE(6347),
    [sym_qualified_type] = STATE(6343),
    [sym_tycon_arrow] = STATE(6343),
    [sym_type_literal] = STATE(2448),
    [sym__promoted_tycon] = STATE(6343),
    [sym_type_variable] = STATE(6343),
    [sym_annotated_type_variable] = STATE(6343),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14160),
    [sym_type_parens] = STATE(2448),
    [sym_type_list] = STATE(2448),
    [sym_type_tuple] = STATE(2448),
    [sym__type_promotable_literal] = STATE(2448),
    [sym__type_promoted_literal] = STATE(2448),
    [sym__type_literal] = STATE(2448),
    [sym_type_name] = STATE(2454),
    [sym_type_star] = STATE(2448),
    [sym_type_unboxed_tuple] = STATE(2448),
    [sym_type_unboxed_sum] = STATE(2448),
    [sym__atype] = STATE(2448),
    [sym_type_apply] = STATE(7672),
    [sym__btype] = STATE(7672),
    [sym_type_infix] = STATE(9777),
    [sym__type_infix] = STATE(9698),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2669),
    [sym__type_quantifiers] = STATE(12057),
    [sym__type_context] = STATE(12057),
    [sym__type_fun] = STATE(12057),
    [sym__type] = STATE(12057),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15364),
    [sym_splice] = STATE(2448),
    [sym_quasiquote] = STATE(2448),
    [sym__varid] = ACTIONS(5966),
    [sym_float] = ACTIONS(5968),
    [sym_char] = ACTIONS(5968),
    [sym_string] = ACTIONS(5968),
    [sym__integer_literal] = ACTIONS(5970),
    [sym__binary_literal] = ACTIONS(5972),
    [sym__octal_literal] = ACTIONS(5972),
    [sym__hex_literal] = ACTIONS(5972),
    [anon_sym_LPAREN_POUND] = ACTIONS(5974),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5974),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [sym__conid] = ACTIONS(5980),
    [anon_sym_LBRACK] = ACTIONS(5982),
    [anon_sym_SQUOTE] = ACTIONS(5984),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5986),
    [anon_sym_6] = ACTIONS(5986),
    [anon_sym_7] = ACTIONS(5988),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5990),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5992),
  },
  [2670] = {
    [sym_integer] = STATE(6388),
    [sym__literal] = STATE(6388),
    [sym__unboxed_open] = STATE(2114),
    [sym_constructor] = STATE(6175),
    [sym_con_unit] = STATE(6388),
    [sym_con_list] = STATE(6388),
    [sym_con_tuple] = STATE(6388),
    [sym_qualified_type] = STATE(6387),
    [sym_tycon_arrow] = STATE(6387),
    [sym_type_literal] = STATE(2458),
    [sym__promoted_tycon] = STATE(6387),
    [sym_type_variable] = STATE(6387),
    [sym_annotated_type_variable] = STATE(6387),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14193),
    [sym_type_parens] = STATE(2458),
    [sym_type_list] = STATE(2458),
    [sym_type_tuple] = STATE(2458),
    [sym__type_promotable_literal] = STATE(2458),
    [sym__type_promoted_literal] = STATE(2458),
    [sym__type_literal] = STATE(2458),
    [sym_type_name] = STATE(2455),
    [sym_type_star] = STATE(2458),
    [sym_type_unboxed_tuple] = STATE(2458),
    [sym_type_unboxed_sum] = STATE(2458),
    [sym__atype] = STATE(2458),
    [sym_type_apply] = STATE(7646),
    [sym__btype] = STATE(7646),
    [sym_type_infix] = STATE(9881),
    [sym__type_infix] = STATE(9597),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2670),
    [sym__type_quantifiers] = STATE(11964),
    [sym__type_context] = STATE(11964),
    [sym__type_fun] = STATE(11964),
    [sym__type] = STATE(11964),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15425),
    [sym_splice] = STATE(2458),
    [sym_quasiquote] = STATE(2458),
    [sym__varid] = ACTIONS(6748),
    [sym_float] = ACTIONS(6750),
    [sym_char] = ACTIONS(6750),
    [sym_string] = ACTIONS(6750),
    [sym__integer_literal] = ACTIONS(6752),
    [sym__binary_literal] = ACTIONS(6754),
    [sym__octal_literal] = ACTIONS(6754),
    [sym__hex_literal] = ACTIONS(6754),
    [anon_sym_LPAREN_POUND] = ACTIONS(6756),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6756),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6758),
    [sym__conid] = ACTIONS(6762),
    [anon_sym_LBRACK] = ACTIONS(6764),
    [anon_sym_SQUOTE] = ACTIONS(6766),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6768),
    [anon_sym_6] = ACTIONS(6768),
    [anon_sym_7] = ACTIONS(6770),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6772),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6774),
  },
  [2671] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(2971),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(14284),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3372),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym__datainst] = STATE(18135),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2672] = {
    [sym_integer] = STATE(10684),
    [sym__literal] = STATE(10684),
    [sym__unboxed_open] = STATE(765),
    [sym_variable] = STATE(10508),
    [sym_qualified_variable] = STATE(10508),
    [sym_constructor] = STATE(10211),
    [sym_qualified_constructor] = STATE(10450),
    [sym__qcon] = STATE(10508),
    [sym_con_unit] = STATE(10684),
    [sym_con_list] = STATE(10684),
    [sym_con_tuple] = STATE(10684),
    [sym_literal] = STATE(10555),
    [sym_exp_parens] = STATE(10555),
    [sym_exp_tuple] = STATE(10555),
    [sym_exp_unboxed_tuple] = STATE(10555),
    [sym_exp_unboxed_sum] = STATE(10555),
    [sym_exp_list] = STATE(10555),
    [sym_exp_arithmetic_sequence] = STATE(10555),
    [sym_exp_list_comprehension] = STATE(10555),
    [sym_exp_section_left] = STATE(10555),
    [sym_exp_section_right] = STATE(10555),
    [sym_exp_th_quoted_name] = STATE(10555),
    [sym_exp_type_application] = STATE(10935),
    [sym_exp_lambda_case] = STATE(10935),
    [sym__do_keyword] = STATE(18295),
    [sym_do_module] = STATE(18295),
    [sym_exp_do] = STATE(10935),
    [sym_exp_record] = STATE(10555),
    [sym_exp_name] = STATE(10555),
    [sym_exp_projection_selector] = STATE(10555),
    [sym__aexp_projection] = STATE(10555),
    [sym_exp_projection] = STATE(10555),
    [sym__aexp] = STATE(10935),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12586),
    [sym_splice] = STATE(10555),
    [sym_quasiquote] = STATE(10555),
    [sym__varid] = ACTIONS(8462),
    [sym_float] = ACTIONS(8464),
    [sym_char] = ACTIONS(8464),
    [sym_string] = ACTIONS(8464),
    [sym__integer_literal] = ACTIONS(8466),
    [sym__binary_literal] = ACTIONS(8468),
    [sym__octal_literal] = ACTIONS(8468),
    [sym__hex_literal] = ACTIONS(8468),
    [anon_sym_LPAREN_POUND] = ACTIONS(8470),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8470),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(8472),
    [anon_sym_LPAREN] = ACTIONS(8474),
    [sym_implicit_parid] = ACTIONS(8472),
    [sym__conid] = ACTIONS(8476),
    [anon_sym_LBRACK] = ACTIONS(8478),
    [anon_sym_SQUOTE] = ACTIONS(8480),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(8482),
    [anon_sym_AT] = ACTIONS(8484),
    [anon_sym_BSLASH] = ACTIONS(8486),
    [anon_sym_mdo] = ACTIONS(8488),
    [anon_sym_do] = ACTIONS(8488),
    [anon_sym_7] = ACTIONS(8490),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8492),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8494),
  },
  [2673] = {
    [sym_integer] = STATE(10518),
    [sym__literal] = STATE(10518),
    [sym__unboxed_open] = STATE(781),
    [sym_variable] = STATE(10394),
    [sym_qualified_variable] = STATE(10394),
    [sym_constructor] = STATE(10104),
    [sym_qualified_constructor] = STATE(10702),
    [sym__qcon] = STATE(10394),
    [sym_con_unit] = STATE(10518),
    [sym_con_list] = STATE(10518),
    [sym_con_tuple] = STATE(10518),
    [sym_literal] = STATE(11306),
    [sym_exp_parens] = STATE(11306),
    [sym_exp_tuple] = STATE(11306),
    [sym_exp_unboxed_tuple] = STATE(11306),
    [sym_exp_unboxed_sum] = STATE(11306),
    [sym_exp_list] = STATE(11306),
    [sym_exp_arithmetic_sequence] = STATE(11306),
    [sym_exp_list_comprehension] = STATE(11306),
    [sym_exp_section_left] = STATE(11306),
    [sym_exp_section_right] = STATE(11306),
    [sym_exp_th_quoted_name] = STATE(11306),
    [sym_exp_type_application] = STATE(11890),
    [sym_exp_lambda_case] = STATE(11890),
    [sym__do_keyword] = STATE(18176),
    [sym_do_module] = STATE(18176),
    [sym_exp_do] = STATE(11890),
    [sym_exp_record] = STATE(11306),
    [sym_exp_name] = STATE(11306),
    [sym_exp_projection_selector] = STATE(11306),
    [sym__aexp_projection] = STATE(11306),
    [sym_exp_projection] = STATE(11306),
    [sym__aexp] = STATE(11890),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12662),
    [sym_splice] = STATE(11306),
    [sym_quasiquote] = STATE(11306),
    [sym__varid] = ACTIONS(4507),
    [sym_float] = ACTIONS(4509),
    [sym_char] = ACTIONS(4509),
    [sym_string] = ACTIONS(4509),
    [sym__integer_literal] = ACTIONS(4511),
    [sym__binary_literal] = ACTIONS(4513),
    [sym__octal_literal] = ACTIONS(4513),
    [sym__hex_literal] = ACTIONS(4513),
    [anon_sym_LPAREN_POUND] = ACTIONS(8496),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8496),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(8498),
    [anon_sym_LPAREN] = ACTIONS(8500),
    [sym_implicit_parid] = ACTIONS(8498),
    [sym__conid] = ACTIONS(4519),
    [anon_sym_LBRACK] = ACTIONS(8502),
    [anon_sym_SQUOTE] = ACTIONS(8504),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(8506),
    [anon_sym_AT] = ACTIONS(8508),
    [anon_sym_BSLASH] = ACTIONS(8510),
    [anon_sym_mdo] = ACTIONS(8512),
    [anon_sym_do] = ACTIONS(8512),
    [anon_sym_7] = ACTIONS(4523),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4525),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4527),
  },
  [2674] = {
    [sym_integer] = STATE(6425),
    [sym__literal] = STATE(6425),
    [sym__unboxed_open] = STATE(2108),
    [sym_constructor] = STATE(5969),
    [sym_con_unit] = STATE(6425),
    [sym_con_list] = STATE(6425),
    [sym_con_tuple] = STATE(6425),
    [sym_qualified_type] = STATE(6424),
    [sym_tycon_arrow] = STATE(6424),
    [sym_type_literal] = STATE(2461),
    [sym__promoted_tycon] = STATE(6424),
    [sym_type_variable] = STATE(6424),
    [sym_annotated_type_variable] = STATE(6424),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(3144),
    [sym_type_parens] = STATE(2461),
    [sym_type_list] = STATE(2461),
    [sym_type_tuple] = STATE(2461),
    [sym__type_promotable_literal] = STATE(2461),
    [sym__type_promoted_literal] = STATE(2461),
    [sym__type_literal] = STATE(2461),
    [sym_type_name] = STATE(2449),
    [sym_type_star] = STATE(2461),
    [sym_type_unboxed_tuple] = STATE(2461),
    [sym_type_unboxed_sum] = STATE(2461),
    [sym__atype] = STATE(2461),
    [sym_type_apply] = STATE(7690),
    [sym__btype] = STATE(7690),
    [sym_type_infix] = STATE(11131),
    [sym__type_infix] = STATE(12519),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3413),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15009),
    [sym__datainst] = STATE(12762),
    [sym_splice] = STATE(2461),
    [sym_quasiquote] = STATE(2461),
    [sym__varid] = ACTIONS(7229),
    [sym_float] = ACTIONS(7231),
    [sym_char] = ACTIONS(7231),
    [sym_string] = ACTIONS(7231),
    [sym__integer_literal] = ACTIONS(7233),
    [sym__binary_literal] = ACTIONS(7235),
    [sym__octal_literal] = ACTIONS(7235),
    [sym__hex_literal] = ACTIONS(7235),
    [anon_sym_LPAREN_POUND] = ACTIONS(7237),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7237),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7239),
    [sym__conid] = ACTIONS(7243),
    [anon_sym_LBRACK] = ACTIONS(7245),
    [anon_sym_SQUOTE] = ACTIONS(7247),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7249),
    [anon_sym_6] = ACTIONS(7249),
    [anon_sym_7] = ACTIONS(7251),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7253),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7255),
  },
  [2675] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(2971),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(14284),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3372),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym__datainst] = STATE(17854),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2676] = {
    [sym_integer] = STATE(7156),
    [sym__literal] = STATE(7156),
    [sym__unboxed_open] = STATE(2209),
    [sym_constructor] = STATE(6790),
    [sym_con_unit] = STATE(7156),
    [sym_con_list] = STATE(7156),
    [sym_con_tuple] = STATE(7156),
    [sym_qualified_type] = STATE(7260),
    [sym_tycon_arrow] = STATE(7260),
    [sym_type_literal] = STATE(2714),
    [sym__promoted_tycon] = STATE(7260),
    [sym_type_variable] = STATE(7260),
    [sym_annotated_type_variable] = STATE(7260),
    [sym_type_parens] = STATE(2714),
    [sym_type_list] = STATE(2714),
    [sym_type_tuple] = STATE(2714),
    [sym__type_promotable_literal] = STATE(2714),
    [sym__type_promoted_literal] = STATE(2714),
    [sym__type_literal] = STATE(2714),
    [sym_type_name] = STATE(2714),
    [sym_type_star] = STATE(2714),
    [sym_type_unboxed_tuple] = STATE(2714),
    [sym_type_unboxed_sum] = STATE(2714),
    [sym__atype] = STATE(2714),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14821),
    [sym_splice] = STATE(2714),
    [sym_quasiquote] = STATE(2714),
    [aux_sym_type_apply_repeat1] = STATE(2714),
    [sym__varid] = ACTIONS(8514),
    [sym_float] = ACTIONS(6505),
    [sym_char] = ACTIONS(6505),
    [sym_string] = ACTIONS(6505),
    [sym__integer_literal] = ACTIONS(6507),
    [sym__binary_literal] = ACTIONS(6509),
    [sym__octal_literal] = ACTIONS(6509),
    [sym__hex_literal] = ACTIONS(6509),
    [anon_sym_LPAREN_POUND] = ACTIONS(6511),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6511),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8516),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(8518),
    [anon_sym_LBRACK] = ACTIONS(6519),
    [anon_sym_RBRACK] = ACTIONS(5177),
    [anon_sym_SQUOTE] = ACTIONS(8521),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(6523),
    [anon_sym_6] = ACTIONS(6523),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_DOT_DOT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(6525),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6527),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5177),
    [sym_quasiquote_start] = ACTIONS(6529),
  },
  [2677] = {
    [sym_integer] = STATE(7104),
    [sym__literal] = STATE(7104),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7046),
    [sym_con_unit] = STATE(7104),
    [sym_con_list] = STATE(7104),
    [sym_con_tuple] = STATE(7104),
    [sym_qualified_type] = STATE(7087),
    [sym_tycon_arrow] = STATE(7087),
    [sym_type_literal] = STATE(2702),
    [sym__promoted_tycon] = STATE(7087),
    [sym_type_variable] = STATE(7087),
    [sym_annotated_type_variable] = STATE(7087),
    [sym_type_parens] = STATE(2702),
    [sym_type_list] = STATE(2702),
    [sym_type_tuple] = STATE(2702),
    [sym__type_promotable_literal] = STATE(2702),
    [sym__type_promoted_literal] = STATE(2702),
    [sym__type_literal] = STATE(2702),
    [sym_type_name] = STATE(2702),
    [sym_type_star] = STATE(2702),
    [sym_type_unboxed_tuple] = STATE(2702),
    [sym_type_unboxed_sum] = STATE(2702),
    [sym__atype] = STATE(2702),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15134),
    [sym_splice] = STATE(2702),
    [sym_quasiquote] = STATE(2702),
    [aux_sym_type_apply_repeat1] = STATE(2702),
    [ts_builtin_sym_end] = ACTIONS(5177),
    [sym__varid] = ACTIONS(8524),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(6368),
    [sym_char] = ACTIONS(6368),
    [sym_string] = ACTIONS(6368),
    [sym__integer_literal] = ACTIONS(6370),
    [sym__binary_literal] = ACTIONS(6372),
    [sym__octal_literal] = ACTIONS(6372),
    [sym__hex_literal] = ACTIONS(6372),
    [anon_sym_LPAREN_POUND] = ACTIONS(6374),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6374),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8526),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(8528),
    [anon_sym_LBRACK] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(8531),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(6386),
    [anon_sym_6] = ACTIONS(6386),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(6388),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6390),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6392),
  },
  [2678] = {
    [sym_integer] = STATE(7278),
    [sym__literal] = STATE(7278),
    [sym__unboxed_open] = STATE(2178),
    [sym_constructor] = STATE(6843),
    [sym_con_unit] = STATE(7278),
    [sym_con_list] = STATE(7278),
    [sym_con_tuple] = STATE(7278),
    [sym_qualified_type] = STATE(7262),
    [sym_tycon_arrow] = STATE(7262),
    [sym_type_literal] = STATE(2685),
    [sym__promoted_tycon] = STATE(7262),
    [sym_type_variable] = STATE(7262),
    [sym_annotated_type_variable] = STATE(7262),
    [sym_type_parens] = STATE(2685),
    [sym_type_list] = STATE(2685),
    [sym_type_tuple] = STATE(2685),
    [sym__type_promotable_literal] = STATE(2685),
    [sym__type_promoted_literal] = STATE(2685),
    [sym__type_literal] = STATE(2685),
    [sym_type_name] = STATE(2685),
    [sym_type_star] = STATE(2685),
    [sym_type_unboxed_tuple] = STATE(2685),
    [sym_type_unboxed_sum] = STATE(2685),
    [sym__atype] = STATE(2685),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15295),
    [sym_splice] = STATE(2685),
    [sym_quasiquote] = STATE(2685),
    [aux_sym_type_apply_repeat1] = STATE(2685),
    [sym__varid] = ACTIONS(6929),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(6931),
    [sym_char] = ACTIONS(6931),
    [sym_string] = ACTIONS(6931),
    [sym__integer_literal] = ACTIONS(6933),
    [sym__binary_literal] = ACTIONS(6935),
    [sym__octal_literal] = ACTIONS(6935),
    [sym__hex_literal] = ACTIONS(6935),
    [anon_sym_LPAREN_POUND] = ACTIONS(6937),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6937),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8534),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(8536),
    [anon_sym_LBRACK] = ACTIONS(6945),
    [anon_sym_SQUOTE] = ACTIONS(8539),
    [anon_sym_STAR] = ACTIONS(6949),
    [anon_sym_6] = ACTIONS(6949),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_in] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(6951),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym__layout_end] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6953),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6955),
  },
  [2679] = {
    [sym_integer] = STATE(7278),
    [sym__literal] = STATE(7278),
    [sym__unboxed_open] = STATE(2178),
    [sym_constructor] = STATE(6843),
    [sym_con_unit] = STATE(7278),
    [sym_con_list] = STATE(7278),
    [sym_con_tuple] = STATE(7278),
    [sym_qualified_type] = STATE(7262),
    [sym_tycon_arrow] = STATE(7262),
    [sym_type_literal] = STATE(2678),
    [sym__promoted_tycon] = STATE(7262),
    [sym_type_variable] = STATE(7262),
    [sym_annotated_type_variable] = STATE(7262),
    [sym_type_parens] = STATE(2678),
    [sym_type_list] = STATE(2678),
    [sym_type_tuple] = STATE(2678),
    [sym__type_promotable_literal] = STATE(2678),
    [sym__type_promoted_literal] = STATE(2678),
    [sym__type_literal] = STATE(2678),
    [sym_type_name] = STATE(2678),
    [sym_type_star] = STATE(2678),
    [sym_type_unboxed_tuple] = STATE(2678),
    [sym_type_unboxed_sum] = STATE(2678),
    [sym__atype] = STATE(2678),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15295),
    [sym_splice] = STATE(2678),
    [sym_quasiquote] = STATE(2678),
    [aux_sym_type_apply_repeat1] = STATE(2678),
    [sym__varid] = ACTIONS(6929),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(6931),
    [sym_char] = ACTIONS(6931),
    [sym_string] = ACTIONS(6931),
    [sym__integer_literal] = ACTIONS(6933),
    [sym__binary_literal] = ACTIONS(6935),
    [sym__octal_literal] = ACTIONS(6935),
    [sym__hex_literal] = ACTIONS(6935),
    [anon_sym_LPAREN_POUND] = ACTIONS(6937),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6937),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8534),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(8542),
    [anon_sym_LBRACK] = ACTIONS(6945),
    [anon_sym_SQUOTE] = ACTIONS(8545),
    [anon_sym_STAR] = ACTIONS(6949),
    [anon_sym_6] = ACTIONS(6949),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_in] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(6951),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym__layout_end] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6953),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6955),
  },
  [2680] = {
    [sym_integer] = STATE(7144),
    [sym__literal] = STATE(7144),
    [sym__unboxed_open] = STATE(2183),
    [sym_constructor] = STATE(6953),
    [sym_con_unit] = STATE(7144),
    [sym_con_list] = STATE(7144),
    [sym_con_tuple] = STATE(7144),
    [sym_qualified_type] = STATE(7070),
    [sym_tycon_arrow] = STATE(7070),
    [sym_type_literal] = STATE(2680),
    [sym__promoted_tycon] = STATE(7070),
    [sym_type_variable] = STATE(7070),
    [sym_annotated_type_variable] = STATE(7070),
    [sym_type_parens] = STATE(2680),
    [sym_type_list] = STATE(2680),
    [sym_type_tuple] = STATE(2680),
    [sym__type_promotable_literal] = STATE(2680),
    [sym__type_promoted_literal] = STATE(2680),
    [sym__type_literal] = STATE(2680),
    [sym_type_name] = STATE(2680),
    [sym_type_star] = STATE(2680),
    [sym_type_unboxed_tuple] = STATE(2680),
    [sym_type_unboxed_sum] = STATE(2680),
    [sym__atype] = STATE(2680),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15335),
    [sym_splice] = STATE(2680),
    [sym_quasiquote] = STATE(2680),
    [aux_sym_type_apply_repeat1] = STATE(2680),
    [sym__varid] = ACTIONS(8548),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(8551),
    [sym_char] = ACTIONS(8551),
    [sym_string] = ACTIONS(8551),
    [sym__integer_literal] = ACTIONS(8554),
    [sym__binary_literal] = ACTIONS(8557),
    [sym__octal_literal] = ACTIONS(8557),
    [sym__hex_literal] = ACTIONS(8557),
    [anon_sym_LPAREN_POUND] = ACTIONS(8560),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8560),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8563),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(8566),
    [anon_sym_LBRACK] = ACTIONS(8569),
    [anon_sym_SQUOTE] = ACTIONS(8572),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(8575),
    [anon_sym_6] = ACTIONS(8575),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_EQ] = ACTIONS(5059),
    [anon_sym_RBRACE] = ACTIONS(5030),
    [anon_sym_deriving] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(8578),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8581),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8584),
  },
  [2681] = {
    [sym_integer] = STATE(7208),
    [sym__literal] = STATE(7208),
    [sym__unboxed_open] = STATE(2156),
    [sym_constructor] = STATE(6817),
    [sym_con_unit] = STATE(7208),
    [sym_con_list] = STATE(7208),
    [sym_con_tuple] = STATE(7208),
    [sym_qualified_type] = STATE(7291),
    [sym_tycon_arrow] = STATE(7291),
    [sym_type_literal] = STATE(2681),
    [sym__promoted_tycon] = STATE(7291),
    [sym_type_variable] = STATE(7291),
    [sym_annotated_type_variable] = STATE(7291),
    [sym_type_parens] = STATE(2681),
    [sym_type_list] = STATE(2681),
    [sym_type_tuple] = STATE(2681),
    [sym__type_promotable_literal] = STATE(2681),
    [sym__type_promoted_literal] = STATE(2681),
    [sym__type_literal] = STATE(2681),
    [sym_type_name] = STATE(2681),
    [sym_type_star] = STATE(2681),
    [sym_type_unboxed_tuple] = STATE(2681),
    [sym_type_unboxed_sum] = STATE(2681),
    [sym__atype] = STATE(2681),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14826),
    [sym_splice] = STATE(2681),
    [sym_quasiquote] = STATE(2681),
    [aux_sym_type_apply_repeat1] = STATE(2681),
    [sym__varid] = ACTIONS(8587),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(8590),
    [sym_char] = ACTIONS(8590),
    [sym_string] = ACTIONS(8590),
    [sym__integer_literal] = ACTIONS(8593),
    [sym__binary_literal] = ACTIONS(8596),
    [sym__octal_literal] = ACTIONS(8596),
    [sym__hex_literal] = ACTIONS(8596),
    [anon_sym_LPAREN_POUND] = ACTIONS(8599),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8599),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8602),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(8605),
    [anon_sym_LBRACK] = ACTIONS(8608),
    [anon_sym_SQUOTE] = ACTIONS(8611),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(8614),
    [anon_sym_6] = ACTIONS(8614),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_in] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(8617),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(8620),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8623),
  },
  [2682] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_RBRACK] = ACTIONS(5129),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_DOT_DOT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5129),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2683] = {
    [sym_integer] = STATE(9378),
    [sym__literal] = STATE(9378),
    [sym__unboxed_open] = STATE(749),
    [sym_variable] = STATE(9343),
    [sym_qualified_variable] = STATE(9343),
    [sym_constructor] = STATE(9240),
    [sym_qualified_constructor] = STATE(9275),
    [sym__qcon] = STATE(9343),
    [sym_con_unit] = STATE(9378),
    [sym_con_list] = STATE(9378),
    [sym_con_tuple] = STATE(9378),
    [sym_literal] = STATE(9481),
    [sym_exp_parens] = STATE(9481),
    [sym_exp_tuple] = STATE(9481),
    [sym_exp_unboxed_tuple] = STATE(9481),
    [sym_exp_unboxed_sum] = STATE(9481),
    [sym_exp_list] = STATE(9481),
    [sym_exp_arithmetic_sequence] = STATE(9481),
    [sym_exp_list_comprehension] = STATE(9481),
    [sym_exp_section_left] = STATE(9481),
    [sym_exp_section_right] = STATE(9481),
    [sym_exp_th_quoted_name] = STATE(9481),
    [sym_exp_type_application] = STATE(9563),
    [sym_exp_lambda_case] = STATE(9563),
    [sym__do_keyword] = STATE(18466),
    [sym_do_module] = STATE(18466),
    [sym_exp_do] = STATE(9563),
    [sym_exp_record] = STATE(9481),
    [sym_exp_name] = STATE(9481),
    [sym_exp_projection_selector] = STATE(9481),
    [sym__aexp_projection] = STATE(9481),
    [sym_exp_projection] = STATE(9481),
    [sym__aexp] = STATE(9563),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12535),
    [sym_splice] = STATE(9481),
    [sym_quasiquote] = STATE(9481),
    [sym__varid] = ACTIONS(4309),
    [sym_float] = ACTIONS(4311),
    [sym_char] = ACTIONS(4311),
    [sym_string] = ACTIONS(4311),
    [sym__integer_literal] = ACTIONS(4313),
    [sym__binary_literal] = ACTIONS(4315),
    [sym__octal_literal] = ACTIONS(4315),
    [sym__hex_literal] = ACTIONS(4315),
    [anon_sym_LPAREN_POUND] = ACTIONS(8307),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8307),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4223),
    [anon_sym_LPAREN] = ACTIONS(8309),
    [sym_implicit_parid] = ACTIONS(4223),
    [sym__conid] = ACTIONS(4321),
    [anon_sym_LBRACK] = ACTIONS(8311),
    [anon_sym_SQUOTE] = ACTIONS(4229),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4231),
    [anon_sym_AT] = ACTIONS(4233),
    [anon_sym_BSLASH] = ACTIONS(4235),
    [anon_sym_mdo] = ACTIONS(4237),
    [anon_sym_do] = ACTIONS(4237),
    [anon_sym_7] = ACTIONS(4325),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4327),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4329),
  },
  [2684] = {
    [sym_integer] = STATE(6509),
    [sym__literal] = STATE(6509),
    [sym__unboxed_open] = STATE(2133),
    [sym_constructor] = STATE(5968),
    [sym_con_unit] = STATE(6509),
    [sym_con_list] = STATE(6509),
    [sym_con_tuple] = STATE(6509),
    [sym_qualified_type] = STATE(6463),
    [sym_tycon_arrow] = STATE(6463),
    [sym_type_literal] = STATE(2456),
    [sym__promoted_tycon] = STATE(6463),
    [sym_type_variable] = STATE(6463),
    [sym_annotated_type_variable] = STATE(6463),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(2953),
    [sym_type_parens] = STATE(2456),
    [sym_type_list] = STATE(2456),
    [sym_type_tuple] = STATE(2456),
    [sym__type_promotable_literal] = STATE(2456),
    [sym__type_promoted_literal] = STATE(2456),
    [sym__type_literal] = STATE(2456),
    [sym_type_name] = STATE(2478),
    [sym_type_star] = STATE(2456),
    [sym_type_unboxed_tuple] = STATE(2456),
    [sym_type_unboxed_sum] = STATE(2456),
    [sym__atype] = STATE(2456),
    [sym_type_apply] = STATE(7597),
    [sym__btype] = STATE(7597),
    [sym_type_infix] = STATE(11310),
    [sym__type_infix] = STATE(12715),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3384),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14649),
    [sym__datainst] = STATE(12924),
    [sym_splice] = STATE(2456),
    [sym_quasiquote] = STATE(2456),
    [sym__varid] = ACTIONS(7397),
    [sym_float] = ACTIONS(7399),
    [sym_char] = ACTIONS(7399),
    [sym_string] = ACTIONS(7399),
    [sym__integer_literal] = ACTIONS(7401),
    [sym__binary_literal] = ACTIONS(7403),
    [sym__octal_literal] = ACTIONS(7403),
    [sym__hex_literal] = ACTIONS(7403),
    [anon_sym_LPAREN_POUND] = ACTIONS(7405),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7405),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7407),
    [sym__conid] = ACTIONS(7411),
    [anon_sym_LBRACK] = ACTIONS(7413),
    [anon_sym_SQUOTE] = ACTIONS(7415),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7417),
    [anon_sym_6] = ACTIONS(7417),
    [anon_sym_7] = ACTIONS(7419),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7421),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7423),
  },
  [2685] = {
    [sym_integer] = STATE(7278),
    [sym__literal] = STATE(7278),
    [sym__unboxed_open] = STATE(2178),
    [sym_constructor] = STATE(6843),
    [sym_con_unit] = STATE(7278),
    [sym_con_list] = STATE(7278),
    [sym_con_tuple] = STATE(7278),
    [sym_qualified_type] = STATE(7262),
    [sym_tycon_arrow] = STATE(7262),
    [sym_type_literal] = STATE(2685),
    [sym__promoted_tycon] = STATE(7262),
    [sym_type_variable] = STATE(7262),
    [sym_annotated_type_variable] = STATE(7262),
    [sym_type_parens] = STATE(2685),
    [sym_type_list] = STATE(2685),
    [sym_type_tuple] = STATE(2685),
    [sym__type_promotable_literal] = STATE(2685),
    [sym__type_promoted_literal] = STATE(2685),
    [sym__type_literal] = STATE(2685),
    [sym_type_name] = STATE(2685),
    [sym_type_star] = STATE(2685),
    [sym_type_unboxed_tuple] = STATE(2685),
    [sym_type_unboxed_sum] = STATE(2685),
    [sym__atype] = STATE(2685),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15295),
    [sym_splice] = STATE(2685),
    [sym_quasiquote] = STATE(2685),
    [aux_sym_type_apply_repeat1] = STATE(2685),
    [sym__varid] = ACTIONS(8626),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(8629),
    [sym_char] = ACTIONS(8629),
    [sym_string] = ACTIONS(8629),
    [sym__integer_literal] = ACTIONS(8632),
    [sym__binary_literal] = ACTIONS(8635),
    [sym__octal_literal] = ACTIONS(8635),
    [sym__hex_literal] = ACTIONS(8635),
    [anon_sym_LPAREN_POUND] = ACTIONS(8638),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8638),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8641),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(8644),
    [anon_sym_LBRACK] = ACTIONS(8647),
    [anon_sym_SQUOTE] = ACTIONS(8650),
    [anon_sym_STAR] = ACTIONS(8653),
    [anon_sym_6] = ACTIONS(8653),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_in] = ACTIONS(5059),
    [anon_sym_7] = ACTIONS(8656),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym__layout_end] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(8659),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8662),
  },
  [2686] = {
    [sym_integer] = STATE(10970),
    [sym__literal] = STATE(10970),
    [sym__unboxed_open] = STATE(791),
    [sym_variable] = STATE(11352),
    [sym_qualified_variable] = STATE(11352),
    [sym_constructor] = STATE(10570),
    [sym_qualified_constructor] = STATE(11171),
    [sym__qcon] = STATE(11352),
    [sym_con_unit] = STATE(10970),
    [sym_con_list] = STATE(10970),
    [sym_con_tuple] = STATE(10970),
    [sym_literal] = STATE(11355),
    [sym_exp_parens] = STATE(11355),
    [sym_exp_tuple] = STATE(11355),
    [sym_exp_unboxed_tuple] = STATE(11355),
    [sym_exp_unboxed_sum] = STATE(11355),
    [sym_exp_list] = STATE(11355),
    [sym_exp_arithmetic_sequence] = STATE(11355),
    [sym_exp_list_comprehension] = STATE(11355),
    [sym_exp_section_left] = STATE(11355),
    [sym_exp_section_right] = STATE(11355),
    [sym_exp_th_quoted_name] = STATE(11355),
    [sym_exp_type_application] = STATE(11529),
    [sym_exp_lambda_case] = STATE(11529),
    [sym__do_keyword] = STATE(18367),
    [sym_do_module] = STATE(18367),
    [sym_exp_do] = STATE(11529),
    [sym_exp_record] = STATE(11355),
    [sym_exp_name] = STATE(11355),
    [sym_exp_projection_selector] = STATE(11355),
    [sym__aexp_projection] = STATE(11355),
    [sym_exp_projection] = STATE(11355),
    [sym__aexp] = STATE(11529),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12525),
    [sym_splice] = STATE(11355),
    [sym_quasiquote] = STATE(11355),
    [sym__varid] = ACTIONS(8665),
    [sym_float] = ACTIONS(8667),
    [sym_char] = ACTIONS(8667),
    [sym_string] = ACTIONS(8667),
    [sym__integer_literal] = ACTIONS(8669),
    [sym__binary_literal] = ACTIONS(8671),
    [sym__octal_literal] = ACTIONS(8671),
    [sym__hex_literal] = ACTIONS(8671),
    [anon_sym_LPAREN_POUND] = ACTIONS(8673),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8673),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(8675),
    [anon_sym_LPAREN] = ACTIONS(8677),
    [sym_implicit_parid] = ACTIONS(8675),
    [sym__conid] = ACTIONS(8679),
    [anon_sym_LBRACK] = ACTIONS(8681),
    [anon_sym_SQUOTE] = ACTIONS(8683),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(8685),
    [anon_sym_AT] = ACTIONS(8687),
    [anon_sym_BSLASH] = ACTIONS(8689),
    [anon_sym_mdo] = ACTIONS(8691),
    [anon_sym_do] = ACTIONS(8691),
    [anon_sym_7] = ACTIONS(8693),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8695),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8697),
  },
  [2687] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_in] = ACTIONS(5160),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym__layout_end] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2688] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [ts_builtin_sym_end] = ACTIONS(5129),
    [sym__varid] = ACTIONS(5899),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2689] = {
    [sym_integer] = STATE(9877),
    [sym__literal] = STATE(9877),
    [sym__unboxed_open] = STATE(755),
    [sym_variable] = STATE(9898),
    [sym_qualified_variable] = STATE(9898),
    [sym_constructor] = STATE(9690),
    [sym_qualified_constructor] = STATE(9781),
    [sym__qcon] = STATE(9898),
    [sym_con_unit] = STATE(9877),
    [sym_con_list] = STATE(9877),
    [sym_con_tuple] = STATE(9877),
    [sym_literal] = STATE(9912),
    [sym_exp_parens] = STATE(9912),
    [sym_exp_tuple] = STATE(9912),
    [sym_exp_unboxed_tuple] = STATE(9912),
    [sym_exp_unboxed_sum] = STATE(9912),
    [sym_exp_list] = STATE(9912),
    [sym_exp_arithmetic_sequence] = STATE(9912),
    [sym_exp_list_comprehension] = STATE(9912),
    [sym_exp_section_left] = STATE(9912),
    [sym_exp_section_right] = STATE(9912),
    [sym_exp_th_quoted_name] = STATE(9912),
    [sym_exp_type_application] = STATE(10035),
    [sym_exp_lambda_case] = STATE(10035),
    [sym__do_keyword] = STATE(18480),
    [sym_do_module] = STATE(18480),
    [sym_exp_do] = STATE(10035),
    [sym_exp_record] = STATE(9912),
    [sym_exp_name] = STATE(9912),
    [sym_exp_projection_selector] = STATE(9912),
    [sym__aexp_projection] = STATE(9912),
    [sym_exp_projection] = STATE(9912),
    [sym__aexp] = STATE(10035),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12558),
    [sym_splice] = STATE(9912),
    [sym_quasiquote] = STATE(9912),
    [sym__varid] = ACTIONS(4473),
    [sym_float] = ACTIONS(4475),
    [sym_char] = ACTIONS(4475),
    [sym_string] = ACTIONS(4475),
    [sym__integer_literal] = ACTIONS(4477),
    [sym__binary_literal] = ACTIONS(4479),
    [sym__octal_literal] = ACTIONS(4479),
    [sym__hex_literal] = ACTIONS(4479),
    [anon_sym_LPAREN_POUND] = ACTIONS(8699),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8699),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4483),
    [anon_sym_LPAREN] = ACTIONS(8701),
    [sym_implicit_parid] = ACTIONS(4483),
    [sym__conid] = ACTIONS(4487),
    [anon_sym_LBRACK] = ACTIONS(8703),
    [anon_sym_SQUOTE] = ACTIONS(4491),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4493),
    [anon_sym_AT] = ACTIONS(4495),
    [anon_sym_BSLASH] = ACTIONS(4497),
    [anon_sym_mdo] = ACTIONS(4499),
    [anon_sym_do] = ACTIONS(4499),
    [anon_sym_7] = ACTIONS(4501),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4503),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4505),
  },
  [2690] = {
    [sym_integer] = STATE(11301),
    [sym__literal] = STATE(11301),
    [sym__unboxed_open] = STATE(796),
    [sym_variable] = STATE(10982),
    [sym_qualified_variable] = STATE(10982),
    [sym_constructor] = STATE(10791),
    [sym_qualified_constructor] = STATE(10925),
    [sym__qcon] = STATE(10982),
    [sym_con_unit] = STATE(11301),
    [sym_con_list] = STATE(11301),
    [sym_con_tuple] = STATE(11301),
    [sym_literal] = STATE(11327),
    [sym_exp_parens] = STATE(11327),
    [sym_exp_tuple] = STATE(11327),
    [sym_exp_unboxed_tuple] = STATE(11327),
    [sym_exp_unboxed_sum] = STATE(11327),
    [sym_exp_list] = STATE(11327),
    [sym_exp_arithmetic_sequence] = STATE(11327),
    [sym_exp_list_comprehension] = STATE(11327),
    [sym_exp_section_left] = STATE(11327),
    [sym_exp_section_right] = STATE(11327),
    [sym_exp_th_quoted_name] = STATE(11327),
    [sym_exp_type_application] = STATE(11683),
    [sym_exp_lambda_case] = STATE(11683),
    [sym__do_keyword] = STATE(18385),
    [sym_do_module] = STATE(18385),
    [sym_exp_do] = STATE(11683),
    [sym_exp_record] = STATE(11327),
    [sym_exp_name] = STATE(11327),
    [sym_exp_projection_selector] = STATE(11327),
    [sym__aexp_projection] = STATE(11327),
    [sym_exp_projection] = STATE(11327),
    [sym__aexp] = STATE(11683),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12528),
    [sym_splice] = STATE(11327),
    [sym_quasiquote] = STATE(11327),
    [sym__varid] = ACTIONS(4337),
    [sym_float] = ACTIONS(4339),
    [sym_char] = ACTIONS(4339),
    [sym_string] = ACTIONS(4339),
    [sym__integer_literal] = ACTIONS(4341),
    [sym__binary_literal] = ACTIONS(4343),
    [sym__octal_literal] = ACTIONS(4343),
    [sym__hex_literal] = ACTIONS(4343),
    [anon_sym_LPAREN_POUND] = ACTIONS(8705),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8705),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4457),
    [anon_sym_LPAREN] = ACTIONS(8707),
    [sym_implicit_parid] = ACTIONS(4457),
    [sym__conid] = ACTIONS(4349),
    [anon_sym_LBRACK] = ACTIONS(8709),
    [anon_sym_SQUOTE] = ACTIONS(4463),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4465),
    [anon_sym_AT] = ACTIONS(4467),
    [anon_sym_BSLASH] = ACTIONS(4469),
    [anon_sym_mdo] = ACTIONS(4471),
    [anon_sym_do] = ACTIONS(4471),
    [anon_sym_7] = ACTIONS(4353),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4355),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4357),
  },
  [2691] = {
    [sym_integer] = STATE(11294),
    [sym__literal] = STATE(11294),
    [sym__unboxed_open] = STATE(773),
    [sym_variable] = STATE(11206),
    [sym_qualified_variable] = STATE(11206),
    [sym_constructor] = STATE(10588),
    [sym_qualified_constructor] = STATE(11140),
    [sym__qcon] = STATE(11206),
    [sym_con_unit] = STATE(11294),
    [sym_con_list] = STATE(11294),
    [sym_con_tuple] = STATE(11294),
    [sym_literal] = STATE(11470),
    [sym_exp_parens] = STATE(11470),
    [sym_exp_tuple] = STATE(11470),
    [sym_exp_unboxed_tuple] = STATE(11470),
    [sym_exp_unboxed_sum] = STATE(11470),
    [sym_exp_list] = STATE(11470),
    [sym_exp_arithmetic_sequence] = STATE(11470),
    [sym_exp_list_comprehension] = STATE(11470),
    [sym_exp_section_left] = STATE(11470),
    [sym_exp_section_right] = STATE(11470),
    [sym_exp_th_quoted_name] = STATE(11470),
    [sym_exp_type_application] = STATE(11636),
    [sym_exp_lambda_case] = STATE(11636),
    [sym__do_keyword] = STATE(18188),
    [sym_do_module] = STATE(18188),
    [sym_exp_do] = STATE(11636),
    [sym_exp_record] = STATE(11470),
    [sym_exp_name] = STATE(11470),
    [sym_exp_projection_selector] = STATE(11470),
    [sym__aexp_projection] = STATE(11470),
    [sym_exp_projection] = STATE(11470),
    [sym__aexp] = STATE(11636),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12726),
    [sym_splice] = STATE(11470),
    [sym_quasiquote] = STATE(11470),
    [sym__varid] = ACTIONS(8711),
    [sym_float] = ACTIONS(8713),
    [sym_char] = ACTIONS(8713),
    [sym_string] = ACTIONS(8713),
    [sym__integer_literal] = ACTIONS(8715),
    [sym__binary_literal] = ACTIONS(8717),
    [sym__octal_literal] = ACTIONS(8717),
    [sym__hex_literal] = ACTIONS(8717),
    [anon_sym_LPAREN_POUND] = ACTIONS(8719),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8719),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(8721),
    [anon_sym_LPAREN] = ACTIONS(8723),
    [sym_implicit_parid] = ACTIONS(8721),
    [sym__conid] = ACTIONS(8725),
    [anon_sym_LBRACK] = ACTIONS(8727),
    [anon_sym_SQUOTE] = ACTIONS(8729),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(8731),
    [anon_sym_AT] = ACTIONS(8733),
    [anon_sym_BSLASH] = ACTIONS(8735),
    [anon_sym_mdo] = ACTIONS(8737),
    [anon_sym_do] = ACTIONS(8737),
    [anon_sym_7] = ACTIONS(8739),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8741),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8743),
  },
  [2692] = {
    [sym_integer] = STATE(7144),
    [sym__literal] = STATE(7144),
    [sym__unboxed_open] = STATE(2183),
    [sym_constructor] = STATE(6953),
    [sym_con_unit] = STATE(7144),
    [sym_con_list] = STATE(7144),
    [sym_con_tuple] = STATE(7144),
    [sym_qualified_type] = STATE(7070),
    [sym_tycon_arrow] = STATE(7070),
    [sym_type_literal] = STATE(2680),
    [sym__promoted_tycon] = STATE(7070),
    [sym_type_variable] = STATE(7070),
    [sym_annotated_type_variable] = STATE(7070),
    [sym_type_parens] = STATE(2680),
    [sym_type_list] = STATE(2680),
    [sym_type_tuple] = STATE(2680),
    [sym__type_promotable_literal] = STATE(2680),
    [sym__type_promoted_literal] = STATE(2680),
    [sym__type_literal] = STATE(2680),
    [sym_type_name] = STATE(2680),
    [sym_type_star] = STATE(2680),
    [sym_type_unboxed_tuple] = STATE(2680),
    [sym_type_unboxed_sum] = STATE(2680),
    [sym__atype] = STATE(2680),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15335),
    [sym_splice] = STATE(2680),
    [sym_quasiquote] = STATE(2680),
    [aux_sym_type_apply_repeat1] = STATE(2680),
    [sym__varid] = ACTIONS(7341),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(7343),
    [sym_char] = ACTIONS(7343),
    [sym_string] = ACTIONS(7343),
    [sym__integer_literal] = ACTIONS(7345),
    [sym__binary_literal] = ACTIONS(7347),
    [sym__octal_literal] = ACTIONS(7347),
    [sym__hex_literal] = ACTIONS(7347),
    [anon_sym_LPAREN_POUND] = ACTIONS(7349),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7349),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8745),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(8747),
    [anon_sym_LBRACK] = ACTIONS(7357),
    [anon_sym_SQUOTE] = ACTIONS(8750),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(7361),
    [anon_sym_6] = ACTIONS(7361),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_EQ] = ACTIONS(5185),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_deriving] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(7363),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7365),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7367),
  },
  [2693] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5126),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_in] = ACTIONS(5160),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2694] = {
    [sym_integer] = STATE(11917),
    [sym__literal] = STATE(11917),
    [sym__unboxed_open] = STATE(762),
    [sym_variable] = STATE(11861),
    [sym_qualified_variable] = STATE(11861),
    [sym_constructor] = STATE(10871),
    [sym_qualified_constructor] = STATE(11567),
    [sym__qcon] = STATE(11861),
    [sym_con_unit] = STATE(11917),
    [sym_con_list] = STATE(11917),
    [sym_con_tuple] = STATE(11917),
    [sym_literal] = STATE(11623),
    [sym_exp_parens] = STATE(11623),
    [sym_exp_tuple] = STATE(11623),
    [sym_exp_unboxed_tuple] = STATE(11623),
    [sym_exp_unboxed_sum] = STATE(11623),
    [sym_exp_list] = STATE(11623),
    [sym_exp_arithmetic_sequence] = STATE(11623),
    [sym_exp_list_comprehension] = STATE(11623),
    [sym_exp_section_left] = STATE(11623),
    [sym_exp_section_right] = STATE(11623),
    [sym_exp_th_quoted_name] = STATE(11623),
    [sym_exp_type_application] = STATE(12068),
    [sym_exp_lambda_case] = STATE(12068),
    [sym__do_keyword] = STATE(18599),
    [sym_do_module] = STATE(18599),
    [sym_exp_do] = STATE(12068),
    [sym_exp_record] = STATE(11623),
    [sym_exp_name] = STATE(11623),
    [sym_exp_projection_selector] = STATE(11623),
    [sym__aexp_projection] = STATE(11623),
    [sym_exp_projection] = STATE(11623),
    [sym__aexp] = STATE(12068),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12503),
    [sym_splice] = STATE(11623),
    [sym_quasiquote] = STATE(11623),
    [sym__varid] = ACTIONS(8753),
    [sym_float] = ACTIONS(8755),
    [sym_char] = ACTIONS(8755),
    [sym_string] = ACTIONS(8755),
    [sym__integer_literal] = ACTIONS(8757),
    [sym__binary_literal] = ACTIONS(8759),
    [sym__octal_literal] = ACTIONS(8759),
    [sym__hex_literal] = ACTIONS(8759),
    [anon_sym_LPAREN_POUND] = ACTIONS(8761),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8761),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4561),
    [anon_sym_LPAREN] = ACTIONS(8763),
    [sym_implicit_parid] = ACTIONS(4561),
    [sym__conid] = ACTIONS(8765),
    [anon_sym_LBRACK] = ACTIONS(8767),
    [anon_sym_SQUOTE] = ACTIONS(4569),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4571),
    [anon_sym_AT] = ACTIONS(4573),
    [anon_sym_BSLASH] = ACTIONS(4575),
    [anon_sym_mdo] = ACTIONS(4577),
    [anon_sym_do] = ACTIONS(4577),
    [anon_sym_7] = ACTIONS(8769),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8771),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8773),
  },
  [2695] = {
    [sym_integer] = STATE(10449),
    [sym__literal] = STATE(10449),
    [sym__unboxed_open] = STATE(751),
    [sym_variable] = STATE(10585),
    [sym_qualified_variable] = STATE(10585),
    [sym_constructor] = STATE(10192),
    [sym_qualified_constructor] = STATE(10556),
    [sym__qcon] = STATE(10585),
    [sym_con_unit] = STATE(10449),
    [sym_con_list] = STATE(10449),
    [sym_con_tuple] = STATE(10449),
    [sym_literal] = STATE(10571),
    [sym_exp_parens] = STATE(10571),
    [sym_exp_tuple] = STATE(10571),
    [sym_exp_unboxed_tuple] = STATE(10571),
    [sym_exp_unboxed_sum] = STATE(10571),
    [sym_exp_list] = STATE(10571),
    [sym_exp_arithmetic_sequence] = STATE(10571),
    [sym_exp_list_comprehension] = STATE(10571),
    [sym_exp_section_left] = STATE(10571),
    [sym_exp_section_right] = STATE(10571),
    [sym_exp_th_quoted_name] = STATE(10571),
    [sym_exp_type_application] = STATE(11341),
    [sym_exp_lambda_case] = STATE(11341),
    [sym__do_keyword] = STATE(18199),
    [sym_do_module] = STATE(18199),
    [sym_exp_do] = STATE(11341),
    [sym_exp_record] = STATE(10571),
    [sym_exp_name] = STATE(10571),
    [sym_exp_projection_selector] = STATE(10571),
    [sym__aexp_projection] = STATE(10571),
    [sym_exp_projection] = STATE(10571),
    [sym__aexp] = STATE(11341),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12714),
    [sym_splice] = STATE(10571),
    [sym_quasiquote] = STATE(10571),
    [sym__varid] = ACTIONS(8775),
    [sym_float] = ACTIONS(8777),
    [sym_char] = ACTIONS(8777),
    [sym_string] = ACTIONS(8777),
    [sym__integer_literal] = ACTIONS(8779),
    [sym__binary_literal] = ACTIONS(8781),
    [sym__octal_literal] = ACTIONS(8781),
    [sym__hex_literal] = ACTIONS(8781),
    [anon_sym_LPAREN_POUND] = ACTIONS(8783),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8783),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(8785),
    [anon_sym_LPAREN] = ACTIONS(8787),
    [sym_implicit_parid] = ACTIONS(8785),
    [sym__conid] = ACTIONS(8789),
    [anon_sym_LBRACK] = ACTIONS(8791),
    [anon_sym_SQUOTE] = ACTIONS(8793),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(8795),
    [anon_sym_AT] = ACTIONS(8797),
    [anon_sym_BSLASH] = ACTIONS(8799),
    [anon_sym_mdo] = ACTIONS(8801),
    [anon_sym_do] = ACTIONS(8801),
    [anon_sym_7] = ACTIONS(8803),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8805),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8807),
  },
  [2696] = {
    [sym_integer] = STATE(9630),
    [sym__literal] = STATE(9630),
    [sym__unboxed_open] = STATE(746),
    [sym_variable] = STATE(9656),
    [sym_qualified_variable] = STATE(9656),
    [sym_constructor] = STATE(9537),
    [sym_qualified_constructor] = STATE(9678),
    [sym__qcon] = STATE(9656),
    [sym_con_unit] = STATE(9630),
    [sym_con_list] = STATE(9630),
    [sym_con_tuple] = STATE(9630),
    [sym_literal] = STATE(9627),
    [sym_exp_parens] = STATE(9627),
    [sym_exp_tuple] = STATE(9627),
    [sym_exp_unboxed_tuple] = STATE(9627),
    [sym_exp_unboxed_sum] = STATE(9627),
    [sym_exp_list] = STATE(9627),
    [sym_exp_arithmetic_sequence] = STATE(9627),
    [sym_exp_list_comprehension] = STATE(9627),
    [sym_exp_section_left] = STATE(9627),
    [sym_exp_section_right] = STATE(9627),
    [sym_exp_th_quoted_name] = STATE(9627),
    [sym_exp_type_application] = STATE(9965),
    [sym_exp_lambda_case] = STATE(9965),
    [sym__do_keyword] = STATE(18287),
    [sym_do_module] = STATE(18287),
    [sym_exp_do] = STATE(9965),
    [sym_exp_record] = STATE(9627),
    [sym_exp_name] = STATE(9627),
    [sym_exp_projection_selector] = STATE(9627),
    [sym__aexp_projection] = STATE(9627),
    [sym_exp_projection] = STATE(9627),
    [sym__aexp] = STATE(9965),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12591),
    [sym_splice] = STATE(9627),
    [sym_quasiquote] = STATE(9627),
    [sym__varid] = ACTIONS(8809),
    [sym_float] = ACTIONS(8811),
    [sym_char] = ACTIONS(8811),
    [sym_string] = ACTIONS(8811),
    [sym__integer_literal] = ACTIONS(8813),
    [sym__binary_literal] = ACTIONS(8815),
    [sym__octal_literal] = ACTIONS(8815),
    [sym__hex_literal] = ACTIONS(8815),
    [anon_sym_LPAREN_POUND] = ACTIONS(8817),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8817),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(8819),
    [anon_sym_LPAREN] = ACTIONS(8821),
    [sym_implicit_parid] = ACTIONS(8819),
    [sym__conid] = ACTIONS(8823),
    [anon_sym_LBRACK] = ACTIONS(8825),
    [anon_sym_SQUOTE] = ACTIONS(8827),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(8829),
    [anon_sym_AT] = ACTIONS(8831),
    [anon_sym_BSLASH] = ACTIONS(8833),
    [anon_sym_mdo] = ACTIONS(8835),
    [anon_sym_do] = ACTIONS(8835),
    [anon_sym_7] = ACTIONS(8837),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8839),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8841),
  },
  [2697] = {
    [sym_integer] = STATE(6592),
    [sym__literal] = STATE(6592),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6403),
    [sym_con_unit] = STATE(6592),
    [sym_con_list] = STATE(6592),
    [sym_con_tuple] = STATE(6592),
    [sym_qualified_type] = STATE(6680),
    [sym_tycon_arrow] = STATE(6680),
    [sym_type_literal] = STATE(2491),
    [sym__promoted_tycon] = STATE(6680),
    [sym_type_variable] = STATE(6680),
    [sym_annotated_type_variable] = STATE(6680),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(3127),
    [sym_type_parens] = STATE(2491),
    [sym_type_list] = STATE(2491),
    [sym_type_tuple] = STATE(2491),
    [sym__type_promotable_literal] = STATE(2491),
    [sym__type_promoted_literal] = STATE(2491),
    [sym__type_literal] = STATE(2491),
    [sym_type_name] = STATE(2480),
    [sym_type_star] = STATE(2491),
    [sym_type_unboxed_tuple] = STATE(2491),
    [sym_type_unboxed_sum] = STATE(2491),
    [sym__atype] = STATE(2491),
    [sym_type_apply] = STATE(7807),
    [sym__btype] = STATE(7807),
    [sym_type_infix] = STATE(11549),
    [sym__type_infix] = STATE(13063),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3394),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14854),
    [sym__datainst] = STATE(13237),
    [sym_splice] = STATE(2491),
    [sym_quasiquote] = STATE(2491),
    [sym__varid] = ACTIONS(6304),
    [sym_float] = ACTIONS(6306),
    [sym_char] = ACTIONS(6306),
    [sym_string] = ACTIONS(6306),
    [sym__integer_literal] = ACTIONS(6308),
    [sym__binary_literal] = ACTIONS(6310),
    [sym__octal_literal] = ACTIONS(6310),
    [sym__hex_literal] = ACTIONS(6310),
    [anon_sym_LPAREN_POUND] = ACTIONS(6312),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6312),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6314),
    [sym__conid] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_6] = ACTIONS(6324),
    [anon_sym_7] = ACTIONS(6326),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6328),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6330),
  },
  [2698] = {
    [sym_integer] = STATE(6592),
    [sym__literal] = STATE(6592),
    [sym__unboxed_open] = STATE(2166),
    [sym_constructor] = STATE(6403),
    [sym_con_unit] = STATE(6592),
    [sym_con_list] = STATE(6592),
    [sym_con_tuple] = STATE(6592),
    [sym_qualified_type] = STATE(6680),
    [sym_tycon_arrow] = STATE(6680),
    [sym_type_literal] = STATE(2491),
    [sym__promoted_tycon] = STATE(6680),
    [sym_type_variable] = STATE(6680),
    [sym_annotated_type_variable] = STATE(6680),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(3127),
    [sym_type_parens] = STATE(2491),
    [sym_type_list] = STATE(2491),
    [sym_type_tuple] = STATE(2491),
    [sym__type_promotable_literal] = STATE(2491),
    [sym__type_promoted_literal] = STATE(2491),
    [sym__type_literal] = STATE(2491),
    [sym_type_name] = STATE(2480),
    [sym_type_star] = STATE(2491),
    [sym_type_unboxed_tuple] = STATE(2491),
    [sym_type_unboxed_sum] = STATE(2491),
    [sym__atype] = STATE(2491),
    [sym_type_apply] = STATE(7807),
    [sym__btype] = STATE(7807),
    [sym_type_infix] = STATE(11549),
    [sym__type_infix] = STATE(13063),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3394),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14854),
    [sym__datainst] = STATE(13245),
    [sym_splice] = STATE(2491),
    [sym_quasiquote] = STATE(2491),
    [sym__varid] = ACTIONS(6304),
    [sym_float] = ACTIONS(6306),
    [sym_char] = ACTIONS(6306),
    [sym_string] = ACTIONS(6306),
    [sym__integer_literal] = ACTIONS(6308),
    [sym__binary_literal] = ACTIONS(6310),
    [sym__octal_literal] = ACTIONS(6310),
    [sym__hex_literal] = ACTIONS(6310),
    [anon_sym_LPAREN_POUND] = ACTIONS(6312),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6312),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(6314),
    [sym__conid] = ACTIONS(6318),
    [anon_sym_LBRACK] = ACTIONS(6320),
    [anon_sym_SQUOTE] = ACTIONS(6322),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(6324),
    [anon_sym_6] = ACTIONS(6324),
    [anon_sym_7] = ACTIONS(6326),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(6328),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6330),
  },
  [2699] = {
    [sym_integer] = STATE(7208),
    [sym__literal] = STATE(7208),
    [sym__unboxed_open] = STATE(2156),
    [sym_constructor] = STATE(6817),
    [sym_con_unit] = STATE(7208),
    [sym_con_list] = STATE(7208),
    [sym_con_tuple] = STATE(7208),
    [sym_qualified_type] = STATE(7291),
    [sym_tycon_arrow] = STATE(7291),
    [sym_type_literal] = STATE(2700),
    [sym__promoted_tycon] = STATE(7291),
    [sym_type_variable] = STATE(7291),
    [sym_annotated_type_variable] = STATE(7291),
    [sym_type_parens] = STATE(2700),
    [sym_type_list] = STATE(2700),
    [sym_type_tuple] = STATE(2700),
    [sym__type_promotable_literal] = STATE(2700),
    [sym__type_promoted_literal] = STATE(2700),
    [sym__type_literal] = STATE(2700),
    [sym_type_name] = STATE(2700),
    [sym_type_star] = STATE(2700),
    [sym_type_unboxed_tuple] = STATE(2700),
    [sym_type_unboxed_sum] = STATE(2700),
    [sym__atype] = STATE(2700),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14826),
    [sym_splice] = STATE(2700),
    [sym_quasiquote] = STATE(2700),
    [aux_sym_type_apply_repeat1] = STATE(2700),
    [sym__varid] = ACTIONS(6436),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(6438),
    [sym_char] = ACTIONS(6438),
    [sym_string] = ACTIONS(6438),
    [sym__integer_literal] = ACTIONS(6440),
    [sym__binary_literal] = ACTIONS(6442),
    [sym__octal_literal] = ACTIONS(6442),
    [sym__hex_literal] = ACTIONS(6442),
    [anon_sym_LPAREN_POUND] = ACTIONS(6444),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6444),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8843),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(8845),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(8848),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_6] = ACTIONS(6456),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_in] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(6458),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6460),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6462),
  },
  [2700] = {
    [sym_integer] = STATE(7208),
    [sym__literal] = STATE(7208),
    [sym__unboxed_open] = STATE(2156),
    [sym_constructor] = STATE(6817),
    [sym_con_unit] = STATE(7208),
    [sym_con_list] = STATE(7208),
    [sym_con_tuple] = STATE(7208),
    [sym_qualified_type] = STATE(7291),
    [sym_tycon_arrow] = STATE(7291),
    [sym_type_literal] = STATE(2681),
    [sym__promoted_tycon] = STATE(7291),
    [sym_type_variable] = STATE(7291),
    [sym_annotated_type_variable] = STATE(7291),
    [sym_type_parens] = STATE(2681),
    [sym_type_list] = STATE(2681),
    [sym_type_tuple] = STATE(2681),
    [sym__type_promotable_literal] = STATE(2681),
    [sym__type_promoted_literal] = STATE(2681),
    [sym__type_literal] = STATE(2681),
    [sym_type_name] = STATE(2681),
    [sym_type_star] = STATE(2681),
    [sym_type_unboxed_tuple] = STATE(2681),
    [sym_type_unboxed_sum] = STATE(2681),
    [sym__atype] = STATE(2681),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14826),
    [sym_splice] = STATE(2681),
    [sym_quasiquote] = STATE(2681),
    [aux_sym_type_apply_repeat1] = STATE(2681),
    [sym__varid] = ACTIONS(6436),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(6438),
    [sym_char] = ACTIONS(6438),
    [sym_string] = ACTIONS(6438),
    [sym__integer_literal] = ACTIONS(6440),
    [sym__binary_literal] = ACTIONS(6442),
    [sym__octal_literal] = ACTIONS(6442),
    [sym__hex_literal] = ACTIONS(6442),
    [anon_sym_LPAREN_POUND] = ACTIONS(6444),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6444),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8843),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(8851),
    [anon_sym_LBRACK] = ACTIONS(6452),
    [anon_sym_SQUOTE] = ACTIONS(8854),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(6456),
    [anon_sym_6] = ACTIONS(6456),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_in] = ACTIONS(5185),
    [anon_sym_7] = ACTIONS(6458),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6460),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6462),
  },
  [2701] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14454),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(3154),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9653),
    [sym__btype] = STATE(9653),
    [sym_type_infix] = STATE(14979),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15742),
    [sym__constraint_context] = STATE(15742),
    [sym__constraint] = STATE(15742),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2743),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(8857),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(8458),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2702] = {
    [sym_integer] = STATE(7104),
    [sym__literal] = STATE(7104),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7046),
    [sym_con_unit] = STATE(7104),
    [sym_con_list] = STATE(7104),
    [sym_con_tuple] = STATE(7104),
    [sym_qualified_type] = STATE(7087),
    [sym_tycon_arrow] = STATE(7087),
    [sym_type_literal] = STATE(2702),
    [sym__promoted_tycon] = STATE(7087),
    [sym_type_variable] = STATE(7087),
    [sym_annotated_type_variable] = STATE(7087),
    [sym_type_parens] = STATE(2702),
    [sym_type_list] = STATE(2702),
    [sym_type_tuple] = STATE(2702),
    [sym__type_promotable_literal] = STATE(2702),
    [sym__type_promoted_literal] = STATE(2702),
    [sym__type_literal] = STATE(2702),
    [sym_type_name] = STATE(2702),
    [sym_type_star] = STATE(2702),
    [sym_type_unboxed_tuple] = STATE(2702),
    [sym_type_unboxed_sum] = STATE(2702),
    [sym__atype] = STATE(2702),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15134),
    [sym_splice] = STATE(2702),
    [sym_quasiquote] = STATE(2702),
    [aux_sym_type_apply_repeat1] = STATE(2702),
    [ts_builtin_sym_end] = ACTIONS(5030),
    [sym__varid] = ACTIONS(8859),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(8862),
    [sym_char] = ACTIONS(8862),
    [sym_string] = ACTIONS(8862),
    [sym__integer_literal] = ACTIONS(8865),
    [sym__binary_literal] = ACTIONS(8868),
    [sym__octal_literal] = ACTIONS(8868),
    [sym__hex_literal] = ACTIONS(8868),
    [anon_sym_LPAREN_POUND] = ACTIONS(8871),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8871),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8874),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(8877),
    [anon_sym_LBRACK] = ACTIONS(8880),
    [anon_sym_SQUOTE] = ACTIONS(8883),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(8886),
    [anon_sym_6] = ACTIONS(8886),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(8889),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(8892),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8895),
  },
  [2703] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14454),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(3154),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9653),
    [sym__btype] = STATE(9653),
    [sym_type_infix] = STATE(14979),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15544),
    [sym__constraint_context] = STATE(15544),
    [sym__constraint] = STATE(15544),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2743),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(8898),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(8458),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2704] = {
    [sym_integer] = STATE(9283),
    [sym__literal] = STATE(9283),
    [sym__unboxed_open] = STATE(800),
    [sym_variable] = STATE(9342),
    [sym_qualified_variable] = STATE(9342),
    [sym_constructor] = STATE(9235),
    [sym_qualified_constructor] = STATE(9289),
    [sym__qcon] = STATE(9342),
    [sym_con_unit] = STATE(9283),
    [sym_con_list] = STATE(9283),
    [sym_con_tuple] = STATE(9283),
    [sym_literal] = STATE(9408),
    [sym_exp_parens] = STATE(9408),
    [sym_exp_tuple] = STATE(9408),
    [sym_exp_unboxed_tuple] = STATE(9408),
    [sym_exp_unboxed_sum] = STATE(9408),
    [sym_exp_list] = STATE(9408),
    [sym_exp_arithmetic_sequence] = STATE(9408),
    [sym_exp_list_comprehension] = STATE(9408),
    [sym_exp_section_left] = STATE(9408),
    [sym_exp_section_right] = STATE(9408),
    [sym_exp_th_quoted_name] = STATE(9408),
    [sym_exp_type_application] = STATE(9449),
    [sym_exp_lambda_case] = STATE(9449),
    [sym__do_keyword] = STATE(18234),
    [sym_do_module] = STATE(18234),
    [sym_exp_do] = STATE(9449),
    [sym_exp_record] = STATE(9408),
    [sym_exp_name] = STATE(9408),
    [sym_exp_projection_selector] = STATE(9408),
    [sym__aexp_projection] = STATE(9408),
    [sym_exp_projection] = STATE(9408),
    [sym__aexp] = STATE(9449),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12671),
    [sym_splice] = STATE(9408),
    [sym_quasiquote] = STATE(9408),
    [sym__varid] = ACTIONS(4529),
    [sym_float] = ACTIONS(4531),
    [sym_char] = ACTIONS(4531),
    [sym_string] = ACTIONS(4531),
    [sym__integer_literal] = ACTIONS(4533),
    [sym__binary_literal] = ACTIONS(4535),
    [sym__octal_literal] = ACTIONS(4535),
    [sym__hex_literal] = ACTIONS(4535),
    [anon_sym_LPAREN_POUND] = ACTIONS(8900),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8900),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(8902),
    [anon_sym_LPAREN] = ACTIONS(8904),
    [sym_implicit_parid] = ACTIONS(8902),
    [sym__conid] = ACTIONS(4541),
    [anon_sym_LBRACK] = ACTIONS(8906),
    [anon_sym_SQUOTE] = ACTIONS(8908),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(8910),
    [anon_sym_AT] = ACTIONS(8912),
    [anon_sym_BSLASH] = ACTIONS(8914),
    [anon_sym_mdo] = ACTIONS(8916),
    [anon_sym_do] = ACTIONS(8916),
    [anon_sym_7] = ACTIONS(4545),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4547),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4549),
  },
  [2705] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14454),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(3154),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9653),
    [sym__btype] = STATE(9653),
    [sym_type_infix] = STATE(14979),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15572),
    [sym__constraint_context] = STATE(15572),
    [sym__constraint] = STATE(15572),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2743),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(8918),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(8458),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2706] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14454),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(3154),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9653),
    [sym__btype] = STATE(9653),
    [sym_type_infix] = STATE(14979),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(16813),
    [sym__constraint_context] = STATE(16813),
    [sym__constraint] = STATE(16813),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2743),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(8920),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(8458),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2707] = {
    [sym_integer] = STATE(10363),
    [sym__literal] = STATE(10363),
    [sym__unboxed_open] = STATE(775),
    [sym_variable] = STATE(10731),
    [sym_qualified_variable] = STATE(10731),
    [sym_constructor] = STATE(10294),
    [sym_qualified_constructor] = STATE(10364),
    [sym__qcon] = STATE(10731),
    [sym_con_unit] = STATE(10363),
    [sym_con_list] = STATE(10363),
    [sym_con_tuple] = STATE(10363),
    [sym_literal] = STATE(10813),
    [sym_exp_parens] = STATE(10813),
    [sym_exp_tuple] = STATE(10813),
    [sym_exp_unboxed_tuple] = STATE(10813),
    [sym_exp_unboxed_sum] = STATE(10813),
    [sym_exp_list] = STATE(10813),
    [sym_exp_arithmetic_sequence] = STATE(10813),
    [sym_exp_list_comprehension] = STATE(10813),
    [sym_exp_section_left] = STATE(10813),
    [sym_exp_section_right] = STATE(10813),
    [sym_exp_th_quoted_name] = STATE(10813),
    [sym_exp_type_application] = STATE(11138),
    [sym_exp_lambda_case] = STATE(11138),
    [sym__do_keyword] = STATE(18157),
    [sym_do_module] = STATE(18157),
    [sym_exp_do] = STATE(11138),
    [sym_exp_record] = STATE(10813),
    [sym_exp_name] = STATE(10813),
    [sym_exp_projection_selector] = STATE(10813),
    [sym__aexp_projection] = STATE(10813),
    [sym_exp_projection] = STATE(10813),
    [sym__aexp] = STATE(11138),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12640),
    [sym_splice] = STATE(10813),
    [sym_quasiquote] = STATE(10813),
    [sym__varid] = ACTIONS(8922),
    [sym_float] = ACTIONS(8924),
    [sym_char] = ACTIONS(8924),
    [sym_string] = ACTIONS(8924),
    [sym__integer_literal] = ACTIONS(8926),
    [sym__binary_literal] = ACTIONS(8928),
    [sym__octal_literal] = ACTIONS(8928),
    [sym__hex_literal] = ACTIONS(8928),
    [anon_sym_LPAREN_POUND] = ACTIONS(8930),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8930),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(8932),
    [anon_sym_LPAREN] = ACTIONS(8934),
    [sym_implicit_parid] = ACTIONS(8932),
    [sym__conid] = ACTIONS(8936),
    [anon_sym_LBRACK] = ACTIONS(8938),
    [anon_sym_SQUOTE] = ACTIONS(8940),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(8942),
    [anon_sym_AT] = ACTIONS(8944),
    [anon_sym_BSLASH] = ACTIONS(8946),
    [anon_sym_mdo] = ACTIONS(8948),
    [anon_sym_do] = ACTIONS(8948),
    [anon_sym_7] = ACTIONS(8950),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8952),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8954),
  },
  [2708] = {
    [sym_integer] = STATE(6425),
    [sym__literal] = STATE(6425),
    [sym__unboxed_open] = STATE(2108),
    [sym_constructor] = STATE(5969),
    [sym_con_unit] = STATE(6425),
    [sym_con_list] = STATE(6425),
    [sym_con_tuple] = STATE(6425),
    [sym_qualified_type] = STATE(6424),
    [sym_tycon_arrow] = STATE(6424),
    [sym_type_literal] = STATE(2461),
    [sym__promoted_tycon] = STATE(6424),
    [sym_type_variable] = STATE(6424),
    [sym_annotated_type_variable] = STATE(6424),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(3144),
    [sym_type_parens] = STATE(2461),
    [sym_type_list] = STATE(2461),
    [sym_type_tuple] = STATE(2461),
    [sym__type_promotable_literal] = STATE(2461),
    [sym__type_promoted_literal] = STATE(2461),
    [sym__type_literal] = STATE(2461),
    [sym_type_name] = STATE(2449),
    [sym_type_star] = STATE(2461),
    [sym_type_unboxed_tuple] = STATE(2461),
    [sym_type_unboxed_sum] = STATE(2461),
    [sym__atype] = STATE(2461),
    [sym_type_apply] = STATE(7690),
    [sym__btype] = STATE(7690),
    [sym_type_infix] = STATE(11131),
    [sym__type_infix] = STATE(12519),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3413),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15009),
    [sym__datainst] = STATE(12737),
    [sym_splice] = STATE(2461),
    [sym_quasiquote] = STATE(2461),
    [sym__varid] = ACTIONS(7229),
    [sym_float] = ACTIONS(7231),
    [sym_char] = ACTIONS(7231),
    [sym_string] = ACTIONS(7231),
    [sym__integer_literal] = ACTIONS(7233),
    [sym__binary_literal] = ACTIONS(7235),
    [sym__octal_literal] = ACTIONS(7235),
    [sym__hex_literal] = ACTIONS(7235),
    [anon_sym_LPAREN_POUND] = ACTIONS(7237),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7237),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(7239),
    [sym__conid] = ACTIONS(7243),
    [anon_sym_LBRACK] = ACTIONS(7245),
    [anon_sym_SQUOTE] = ACTIONS(7247),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(7249),
    [anon_sym_6] = ACTIONS(7249),
    [anon_sym_7] = ACTIONS(7251),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7253),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7255),
  },
  [2709] = {
    [sym_integer] = STATE(11772),
    [sym__literal] = STATE(11772),
    [sym__unboxed_open] = STATE(788),
    [sym_variable] = STATE(11537),
    [sym_qualified_variable] = STATE(11537),
    [sym_constructor] = STATE(10870),
    [sym_qualified_constructor] = STATE(11713),
    [sym__qcon] = STATE(11537),
    [sym_con_unit] = STATE(11772),
    [sym_con_list] = STATE(11772),
    [sym_con_tuple] = STATE(11772),
    [sym_literal] = STATE(11650),
    [sym_exp_parens] = STATE(11650),
    [sym_exp_tuple] = STATE(11650),
    [sym_exp_unboxed_tuple] = STATE(11650),
    [sym_exp_unboxed_sum] = STATE(11650),
    [sym_exp_list] = STATE(11650),
    [sym_exp_arithmetic_sequence] = STATE(11650),
    [sym_exp_list_comprehension] = STATE(11650),
    [sym_exp_section_left] = STATE(11650),
    [sym_exp_section_right] = STATE(11650),
    [sym_exp_th_quoted_name] = STATE(11650),
    [sym_exp_type_application] = STATE(12065),
    [sym_exp_lambda_case] = STATE(12065),
    [sym__do_keyword] = STATE(18254),
    [sym_do_module] = STATE(18254),
    [sym_exp_do] = STATE(12065),
    [sym_exp_record] = STATE(11650),
    [sym_exp_name] = STATE(11650),
    [sym_exp_projection_selector] = STATE(11650),
    [sym__aexp_projection] = STATE(11650),
    [sym_exp_projection] = STATE(11650),
    [sym__aexp] = STATE(12065),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12641),
    [sym_splice] = STATE(11650),
    [sym_quasiquote] = STATE(11650),
    [sym__varid] = ACTIONS(8956),
    [sym_float] = ACTIONS(8958),
    [sym_char] = ACTIONS(8958),
    [sym_string] = ACTIONS(8958),
    [sym__integer_literal] = ACTIONS(8960),
    [sym__binary_literal] = ACTIONS(8962),
    [sym__octal_literal] = ACTIONS(8962),
    [sym__hex_literal] = ACTIONS(8962),
    [anon_sym_LPAREN_POUND] = ACTIONS(8964),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8964),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(8966),
    [anon_sym_LPAREN] = ACTIONS(8968),
    [sym_implicit_parid] = ACTIONS(8966),
    [sym__conid] = ACTIONS(8970),
    [anon_sym_LBRACK] = ACTIONS(8972),
    [anon_sym_SQUOTE] = ACTIONS(8974),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(8976),
    [anon_sym_AT] = ACTIONS(8978),
    [anon_sym_BSLASH] = ACTIONS(8980),
    [anon_sym_mdo] = ACTIONS(8982),
    [anon_sym_do] = ACTIONS(8982),
    [anon_sym_7] = ACTIONS(8984),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(8986),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(8988),
  },
  [2710] = {
    [sym_integer] = STATE(7224),
    [sym__literal] = STATE(7224),
    [sym__unboxed_open] = STATE(2201),
    [sym_constructor] = STATE(6997),
    [sym_con_unit] = STATE(7224),
    [sym_con_list] = STATE(7224),
    [sym_con_tuple] = STATE(7224),
    [sym_qualified_type] = STATE(7098),
    [sym_tycon_arrow] = STATE(7098),
    [sym_type_literal] = STATE(2710),
    [sym__promoted_tycon] = STATE(7098),
    [sym_type_variable] = STATE(7098),
    [sym_annotated_type_variable] = STATE(7098),
    [sym_type_parens] = STATE(2710),
    [sym_type_list] = STATE(2710),
    [sym_type_tuple] = STATE(2710),
    [sym__type_promotable_literal] = STATE(2710),
    [sym__type_promoted_literal] = STATE(2710),
    [sym__type_literal] = STATE(2710),
    [sym_type_name] = STATE(2710),
    [sym_type_star] = STATE(2710),
    [sym_type_unboxed_tuple] = STATE(2710),
    [sym_type_unboxed_sum] = STATE(2710),
    [sym__atype] = STATE(2710),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15261),
    [sym_splice] = STATE(2710),
    [sym_quasiquote] = STATE(2710),
    [aux_sym_type_apply_repeat1] = STATE(2710),
    [sym__varid] = ACTIONS(8990),
    [anon_sym_SEMI] = ACTIONS(5030),
    [sym_float] = ACTIONS(8993),
    [sym_char] = ACTIONS(8993),
    [sym_string] = ACTIONS(8993),
    [sym__integer_literal] = ACTIONS(8996),
    [sym__binary_literal] = ACTIONS(8999),
    [sym__octal_literal] = ACTIONS(8999),
    [sym__hex_literal] = ACTIONS(8999),
    [anon_sym_LPAREN_POUND] = ACTIONS(9002),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9002),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9005),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(9008),
    [anon_sym_LBRACK] = ACTIONS(9011),
    [anon_sym_SQUOTE] = ACTIONS(9014),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(9017),
    [anon_sym_6] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(9020),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5030),
    [sym__layout_end] = ACTIONS(5030),
    [sym_where] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(9023),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9026),
  },
  [2711] = {
    [sym_integer] = STATE(10538),
    [sym__literal] = STATE(10538),
    [sym__unboxed_open] = STATE(759),
    [sym_variable] = STATE(10320),
    [sym_qualified_variable] = STATE(10320),
    [sym_constructor] = STATE(10164),
    [sym_qualified_constructor] = STATE(10683),
    [sym__qcon] = STATE(10320),
    [sym_con_unit] = STATE(10538),
    [sym_con_list] = STATE(10538),
    [sym_con_tuple] = STATE(10538),
    [sym_literal] = STATE(10593),
    [sym_exp_parens] = STATE(10593),
    [sym_exp_tuple] = STATE(10593),
    [sym_exp_unboxed_tuple] = STATE(10593),
    [sym_exp_unboxed_sum] = STATE(10593),
    [sym_exp_list] = STATE(10593),
    [sym_exp_arithmetic_sequence] = STATE(10593),
    [sym_exp_list_comprehension] = STATE(10593),
    [sym_exp_section_left] = STATE(10593),
    [sym_exp_section_right] = STATE(10593),
    [sym_exp_th_quoted_name] = STATE(10593),
    [sym_exp_type_application] = STATE(11370),
    [sym_exp_lambda_case] = STATE(11370),
    [sym__do_keyword] = STATE(18445),
    [sym_do_module] = STATE(18445),
    [sym_exp_do] = STATE(11370),
    [sym_exp_record] = STATE(10593),
    [sym_exp_name] = STATE(10593),
    [sym_exp_projection_selector] = STATE(10593),
    [sym__aexp_projection] = STATE(10593),
    [sym_exp_projection] = STATE(10593),
    [sym__aexp] = STATE(11370),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12500),
    [sym_splice] = STATE(10593),
    [sym_quasiquote] = STATE(10593),
    [sym__varid] = ACTIONS(4393),
    [sym_float] = ACTIONS(4395),
    [sym_char] = ACTIONS(4395),
    [sym_string] = ACTIONS(4395),
    [sym__integer_literal] = ACTIONS(4397),
    [sym__binary_literal] = ACTIONS(4399),
    [sym__octal_literal] = ACTIONS(4399),
    [sym__hex_literal] = ACTIONS(4399),
    [anon_sym_LPAREN_POUND] = ACTIONS(9029),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9029),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4403),
    [anon_sym_LPAREN] = ACTIONS(9031),
    [sym_implicit_parid] = ACTIONS(4403),
    [sym__conid] = ACTIONS(4407),
    [anon_sym_LBRACK] = ACTIONS(9033),
    [anon_sym_SQUOTE] = ACTIONS(4411),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4413),
    [anon_sym_AT] = ACTIONS(4415),
    [anon_sym_BSLASH] = ACTIONS(4417),
    [anon_sym_mdo] = ACTIONS(4419),
    [anon_sym_do] = ACTIONS(4419),
    [anon_sym_7] = ACTIONS(4421),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4423),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4425),
  },
  [2712] = {
    [sym_integer] = STATE(8945),
    [sym__literal] = STATE(8945),
    [sym__unboxed_open] = STATE(2143),
    [sym_constructor] = STATE(8683),
    [sym_con_unit] = STATE(8945),
    [sym_con_list] = STATE(8945),
    [sym_con_tuple] = STATE(8945),
    [sym_qualified_type] = STATE(8872),
    [sym_tycon_arrow] = STATE(8872),
    [sym_type_literal] = STATE(3268),
    [sym__promoted_tycon] = STATE(8872),
    [sym_type_variable] = STATE(8872),
    [sym_annotated_type_variable] = STATE(8872),
    [sym_type_parens] = STATE(3268),
    [sym_type_list] = STATE(3268),
    [sym_type_tuple] = STATE(3268),
    [sym__type_promotable_literal] = STATE(3268),
    [sym__type_promoted_literal] = STATE(3268),
    [sym__type_literal] = STATE(3268),
    [sym_type_name] = STATE(3268),
    [sym_type_star] = STATE(3268),
    [sym_type_unboxed_tuple] = STATE(3268),
    [sym_type_unboxed_sum] = STATE(3268),
    [sym__atype] = STATE(3268),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14683),
    [sym_splice] = STATE(3268),
    [sym_quasiquote] = STATE(3268),
    [aux_sym_type_apply_repeat1] = STATE(3268),
    [sym__varid] = ACTIONS(5899),
    [anon_sym_SEMI] = ACTIONS(5129),
    [sym_float] = ACTIONS(5131),
    [sym_char] = ACTIONS(5131),
    [sym_string] = ACTIONS(5131),
    [sym__integer_literal] = ACTIONS(5134),
    [sym__binary_literal] = ACTIONS(5137),
    [sym__octal_literal] = ACTIONS(5137),
    [sym__hex_literal] = ACTIONS(5137),
    [anon_sym_LPAREN_POUND] = ACTIONS(5140),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5140),
    [anon_sym_] = ACTIONS(5143),
    [anon_sym_EQ_GT] = ACTIONS(5143),
    [anon_sym_2] = ACTIONS(5129),
    [anon_sym_DASH_GT] = ACTIONS(5129),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5145),
    [anon_sym_BQUOTE] = ACTIONS(5129),
    [sym__conid] = ACTIONS(5148),
    [anon_sym_LBRACK] = ACTIONS(5151),
    [anon_sym_SQUOTE] = ACTIONS(5154),
    [anon_sym_PIPE] = ACTIONS(5129),
    [anon_sym_STAR] = ACTIONS(5157),
    [anon_sym_6] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5129),
    [anon_sym_7] = ACTIONS(5162),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5129),
    [sym__layout_end] = ACTIONS(5129),
    [sym_where] = ACTIONS(5129),
    [sym__splice_dollar] = ACTIONS(5165),
    [sym__consym] = ACTIONS(5129),
    [sym__tyconsym] = ACTIONS(5129),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5168),
  },
  [2713] = {
    [sym_integer] = STATE(7156),
    [sym__literal] = STATE(7156),
    [sym__unboxed_open] = STATE(2209),
    [sym_constructor] = STATE(6790),
    [sym_con_unit] = STATE(7156),
    [sym_con_list] = STATE(7156),
    [sym_con_tuple] = STATE(7156),
    [sym_qualified_type] = STATE(7260),
    [sym_tycon_arrow] = STATE(7260),
    [sym_type_literal] = STATE(2676),
    [sym__promoted_tycon] = STATE(7260),
    [sym_type_variable] = STATE(7260),
    [sym_annotated_type_variable] = STATE(7260),
    [sym_type_parens] = STATE(2676),
    [sym_type_list] = STATE(2676),
    [sym_type_tuple] = STATE(2676),
    [sym__type_promotable_literal] = STATE(2676),
    [sym__type_promoted_literal] = STATE(2676),
    [sym__type_literal] = STATE(2676),
    [sym_type_name] = STATE(2676),
    [sym_type_star] = STATE(2676),
    [sym_type_unboxed_tuple] = STATE(2676),
    [sym_type_unboxed_sum] = STATE(2676),
    [sym__atype] = STATE(2676),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14821),
    [sym_splice] = STATE(2676),
    [sym_quasiquote] = STATE(2676),
    [aux_sym_type_apply_repeat1] = STATE(2676),
    [sym__varid] = ACTIONS(8514),
    [sym_float] = ACTIONS(6505),
    [sym_char] = ACTIONS(6505),
    [sym_string] = ACTIONS(6505),
    [sym__integer_literal] = ACTIONS(6507),
    [sym__binary_literal] = ACTIONS(6509),
    [sym__octal_literal] = ACTIONS(6509),
    [sym__hex_literal] = ACTIONS(6509),
    [anon_sym_LPAREN_POUND] = ACTIONS(6511),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6511),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8516),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(9035),
    [anon_sym_LBRACK] = ACTIONS(6519),
    [anon_sym_RBRACK] = ACTIONS(5078),
    [anon_sym_SQUOTE] = ACTIONS(9038),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(6523),
    [anon_sym_6] = ACTIONS(6523),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_DOT_DOT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(6525),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6527),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5078),
    [sym_quasiquote_start] = ACTIONS(6529),
  },
  [2714] = {
    [sym_integer] = STATE(7156),
    [sym__literal] = STATE(7156),
    [sym__unboxed_open] = STATE(2209),
    [sym_constructor] = STATE(6790),
    [sym_con_unit] = STATE(7156),
    [sym_con_list] = STATE(7156),
    [sym_con_tuple] = STATE(7156),
    [sym_qualified_type] = STATE(7260),
    [sym_tycon_arrow] = STATE(7260),
    [sym_type_literal] = STATE(2714),
    [sym__promoted_tycon] = STATE(7260),
    [sym_type_variable] = STATE(7260),
    [sym_annotated_type_variable] = STATE(7260),
    [sym_type_parens] = STATE(2714),
    [sym_type_list] = STATE(2714),
    [sym_type_tuple] = STATE(2714),
    [sym__type_promotable_literal] = STATE(2714),
    [sym__type_promoted_literal] = STATE(2714),
    [sym__type_literal] = STATE(2714),
    [sym_type_name] = STATE(2714),
    [sym_type_star] = STATE(2714),
    [sym_type_unboxed_tuple] = STATE(2714),
    [sym_type_unboxed_sum] = STATE(2714),
    [sym__atype] = STATE(2714),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14821),
    [sym_splice] = STATE(2714),
    [sym_quasiquote] = STATE(2714),
    [aux_sym_type_apply_repeat1] = STATE(2714),
    [sym__varid] = ACTIONS(9041),
    [sym_float] = ACTIONS(9044),
    [sym_char] = ACTIONS(9044),
    [sym_string] = ACTIONS(9044),
    [sym__integer_literal] = ACTIONS(9047),
    [sym__binary_literal] = ACTIONS(9050),
    [sym__octal_literal] = ACTIONS(9050),
    [sym__hex_literal] = ACTIONS(9050),
    [anon_sym_LPAREN_POUND] = ACTIONS(9053),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9053),
    [anon_sym_] = ACTIONS(5030),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_2] = ACTIONS(5030),
    [anon_sym_DASH_GT] = ACTIONS(5030),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9056),
    [anon_sym_BQUOTE] = ACTIONS(5030),
    [sym__conid] = ACTIONS(9059),
    [anon_sym_LBRACK] = ACTIONS(9062),
    [anon_sym_RBRACK] = ACTIONS(5030),
    [anon_sym_SQUOTE] = ACTIONS(9065),
    [anon_sym_PIPE] = ACTIONS(5030),
    [anon_sym_STAR] = ACTIONS(9068),
    [anon_sym_6] = ACTIONS(9068),
    [anon_sym_PERCENT] = ACTIONS(5030),
    [anon_sym_DOT_DOT] = ACTIONS(5030),
    [anon_sym_7] = ACTIONS(9071),
    [aux_sym__token1] = ACTIONS(3),
    [sym__arith_dotdot] = ACTIONS(5030),
    [sym__splice_dollar] = ACTIONS(9074),
    [sym__consym] = ACTIONS(5030),
    [sym__tyconsym] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_comma] = ACTIONS(5030),
    [sym_quasiquote_start] = ACTIONS(9077),
  },
  [2715] = {
    [sym_integer] = STATE(7144),
    [sym__literal] = STATE(7144),
    [sym__unboxed_open] = STATE(2183),
    [sym_constructor] = STATE(6953),
    [sym_con_unit] = STATE(7144),
    [sym_con_list] = STATE(7144),
    [sym_con_tuple] = STATE(7144),
    [sym_qualified_type] = STATE(7070),
    [sym_tycon_arrow] = STATE(7070),
    [sym_type_literal] = STATE(2692),
    [sym__promoted_tycon] = STATE(7070),
    [sym_type_variable] = STATE(7070),
    [sym_annotated_type_variable] = STATE(7070),
    [sym_type_parens] = STATE(2692),
    [sym_type_list] = STATE(2692),
    [sym_type_tuple] = STATE(2692),
    [sym__type_promotable_literal] = STATE(2692),
    [sym__type_promoted_literal] = STATE(2692),
    [sym__type_literal] = STATE(2692),
    [sym_type_name] = STATE(2692),
    [sym_type_star] = STATE(2692),
    [sym_type_unboxed_tuple] = STATE(2692),
    [sym_type_unboxed_sum] = STATE(2692),
    [sym__atype] = STATE(2692),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15335),
    [sym_splice] = STATE(2692),
    [sym_quasiquote] = STATE(2692),
    [aux_sym_type_apply_repeat1] = STATE(2692),
    [sym__varid] = ACTIONS(7341),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(7343),
    [sym_char] = ACTIONS(7343),
    [sym_string] = ACTIONS(7343),
    [sym__integer_literal] = ACTIONS(7345),
    [sym__binary_literal] = ACTIONS(7347),
    [sym__octal_literal] = ACTIONS(7347),
    [sym__hex_literal] = ACTIONS(7347),
    [anon_sym_LPAREN_POUND] = ACTIONS(7349),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(7349),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8745),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(9080),
    [anon_sym_LBRACK] = ACTIONS(7357),
    [anon_sym_SQUOTE] = ACTIONS(9083),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(7361),
    [anon_sym_6] = ACTIONS(7361),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_EQ] = ACTIONS(5100),
    [anon_sym_RBRACE] = ACTIONS(5078),
    [anon_sym_deriving] = ACTIONS(5100),
    [anon_sym_7] = ACTIONS(7363),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(7365),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(7367),
  },
  [2716] = {
    [sym_integer] = STATE(11475),
    [sym__literal] = STATE(11475),
    [sym__unboxed_open] = STATE(760),
    [sym_variable] = STATE(10868),
    [sym_qualified_variable] = STATE(10868),
    [sym_constructor] = STATE(10505),
    [sym_qualified_constructor] = STATE(11262),
    [sym__qcon] = STATE(10868),
    [sym_con_unit] = STATE(11475),
    [sym_con_list] = STATE(11475),
    [sym_con_tuple] = STATE(11475),
    [sym_literal] = STATE(11049),
    [sym_exp_parens] = STATE(11049),
    [sym_exp_tuple] = STATE(11049),
    [sym_exp_unboxed_tuple] = STATE(11049),
    [sym_exp_unboxed_sum] = STATE(11049),
    [sym_exp_list] = STATE(11049),
    [sym_exp_arithmetic_sequence] = STATE(11049),
    [sym_exp_list_comprehension] = STATE(11049),
    [sym_exp_section_left] = STATE(11049),
    [sym_exp_section_right] = STATE(11049),
    [sym_exp_th_quoted_name] = STATE(11049),
    [sym_exp_type_application] = STATE(11697),
    [sym_exp_lambda_case] = STATE(11697),
    [sym__do_keyword] = STATE(18332),
    [sym_do_module] = STATE(18332),
    [sym_exp_do] = STATE(11697),
    [sym_exp_record] = STATE(11049),
    [sym_exp_name] = STATE(11049),
    [sym_exp_projection_selector] = STATE(11049),
    [sym__aexp_projection] = STATE(11049),
    [sym_exp_projection] = STATE(11049),
    [sym__aexp] = STATE(11697),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12618),
    [sym_splice] = STATE(11049),
    [sym_quasiquote] = STATE(11049),
    [sym__varid] = ACTIONS(9086),
    [sym_float] = ACTIONS(9088),
    [sym_char] = ACTIONS(9088),
    [sym_string] = ACTIONS(9088),
    [sym__integer_literal] = ACTIONS(9090),
    [sym__binary_literal] = ACTIONS(9092),
    [sym__octal_literal] = ACTIONS(9092),
    [sym__hex_literal] = ACTIONS(9092),
    [anon_sym_LPAREN_POUND] = ACTIONS(9094),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9094),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9096),
    [anon_sym_LPAREN] = ACTIONS(9098),
    [sym_implicit_parid] = ACTIONS(9096),
    [sym__conid] = ACTIONS(9100),
    [anon_sym_LBRACK] = ACTIONS(9102),
    [anon_sym_SQUOTE] = ACTIONS(9104),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9106),
    [anon_sym_AT] = ACTIONS(9108),
    [anon_sym_BSLASH] = ACTIONS(9110),
    [anon_sym_mdo] = ACTIONS(9112),
    [anon_sym_do] = ACTIONS(9112),
    [anon_sym_7] = ACTIONS(9114),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9116),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9118),
  },
  [2717] = {
    [sym_integer] = STATE(10418),
    [sym__literal] = STATE(10418),
    [sym__unboxed_open] = STATE(785),
    [sym_variable] = STATE(10552),
    [sym_qualified_variable] = STATE(10552),
    [sym_constructor] = STATE(10171),
    [sym_qualified_constructor] = STATE(10673),
    [sym__qcon] = STATE(10552),
    [sym_con_unit] = STATE(10418),
    [sym_con_list] = STATE(10418),
    [sym_con_tuple] = STATE(10418),
    [sym_literal] = STATE(10584),
    [sym_exp_parens] = STATE(10584),
    [sym_exp_tuple] = STATE(10584),
    [sym_exp_unboxed_tuple] = STATE(10584),
    [sym_exp_unboxed_sum] = STATE(10584),
    [sym_exp_list] = STATE(10584),
    [sym_exp_arithmetic_sequence] = STATE(10584),
    [sym_exp_list_comprehension] = STATE(10584),
    [sym_exp_section_left] = STATE(10584),
    [sym_exp_section_right] = STATE(10584),
    [sym_exp_th_quoted_name] = STATE(10584),
    [sym_exp_type_application] = STATE(11195),
    [sym_exp_lambda_case] = STATE(11195),
    [sym__do_keyword] = STATE(18168),
    [sym_do_module] = STATE(18168),
    [sym_exp_do] = STATE(11195),
    [sym_exp_record] = STATE(10584),
    [sym_exp_name] = STATE(10584),
    [sym_exp_projection_selector] = STATE(10584),
    [sym__aexp_projection] = STATE(10584),
    [sym_exp_projection] = STATE(10584),
    [sym__aexp] = STATE(11195),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12655),
    [sym_splice] = STATE(10584),
    [sym_quasiquote] = STATE(10584),
    [sym__varid] = ACTIONS(9120),
    [sym_float] = ACTIONS(9122),
    [sym_char] = ACTIONS(9122),
    [sym_string] = ACTIONS(9122),
    [sym__integer_literal] = ACTIONS(9124),
    [sym__binary_literal] = ACTIONS(9126),
    [sym__octal_literal] = ACTIONS(9126),
    [sym__hex_literal] = ACTIONS(9126),
    [anon_sym_LPAREN_POUND] = ACTIONS(9128),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9128),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9130),
    [anon_sym_LPAREN] = ACTIONS(9132),
    [sym_implicit_parid] = ACTIONS(9130),
    [sym__conid] = ACTIONS(9134),
    [anon_sym_LBRACK] = ACTIONS(9136),
    [anon_sym_SQUOTE] = ACTIONS(9138),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9140),
    [anon_sym_AT] = ACTIONS(9142),
    [anon_sym_BSLASH] = ACTIONS(9144),
    [anon_sym_mdo] = ACTIONS(9146),
    [anon_sym_do] = ACTIONS(9146),
    [anon_sym_7] = ACTIONS(9148),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9150),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9152),
  },
  [2718] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14454),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(3154),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9653),
    [sym__btype] = STATE(9653),
    [sym_type_infix] = STATE(14979),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(17694),
    [sym__constraint_context] = STATE(17694),
    [sym__constraint] = STATE(17694),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2743),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(9154),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(8458),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2719] = {
    [sym_integer] = STATE(11159),
    [sym__literal] = STATE(11159),
    [sym__unboxed_open] = STATE(754),
    [sym_variable] = STATE(11476),
    [sym_qualified_variable] = STATE(11476),
    [sym_constructor] = STATE(10756),
    [sym_qualified_constructor] = STATE(10941),
    [sym__qcon] = STATE(11476),
    [sym_con_unit] = STATE(11159),
    [sym_con_list] = STATE(11159),
    [sym_con_tuple] = STATE(11159),
    [sym_literal] = STATE(11488),
    [sym_exp_parens] = STATE(11488),
    [sym_exp_tuple] = STATE(11488),
    [sym_exp_unboxed_tuple] = STATE(11488),
    [sym_exp_unboxed_sum] = STATE(11488),
    [sym_exp_list] = STATE(11488),
    [sym_exp_arithmetic_sequence] = STATE(11488),
    [sym_exp_list_comprehension] = STATE(11488),
    [sym_exp_section_left] = STATE(11488),
    [sym_exp_section_right] = STATE(11488),
    [sym_exp_th_quoted_name] = STATE(11488),
    [sym_exp_type_application] = STATE(11560),
    [sym_exp_lambda_case] = STATE(11560),
    [sym__do_keyword] = STATE(18271),
    [sym_do_module] = STATE(18271),
    [sym_exp_do] = STATE(11560),
    [sym_exp_record] = STATE(11488),
    [sym_exp_name] = STATE(11488),
    [sym_exp_projection_selector] = STATE(11488),
    [sym__aexp_projection] = STATE(11488),
    [sym_exp_projection] = STATE(11488),
    [sym__aexp] = STATE(11560),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12631),
    [sym_splice] = STATE(11488),
    [sym_quasiquote] = STATE(11488),
    [sym__varid] = ACTIONS(9156),
    [sym_float] = ACTIONS(9158),
    [sym_char] = ACTIONS(9158),
    [sym_string] = ACTIONS(9158),
    [sym__integer_literal] = ACTIONS(9160),
    [sym__binary_literal] = ACTIONS(9162),
    [sym__octal_literal] = ACTIONS(9162),
    [sym__hex_literal] = ACTIONS(9162),
    [anon_sym_LPAREN_POUND] = ACTIONS(9164),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9164),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9166),
    [anon_sym_LPAREN] = ACTIONS(9168),
    [sym_implicit_parid] = ACTIONS(9166),
    [sym__conid] = ACTIONS(9170),
    [anon_sym_LBRACK] = ACTIONS(9172),
    [anon_sym_SQUOTE] = ACTIONS(9174),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9176),
    [anon_sym_AT] = ACTIONS(9178),
    [anon_sym_BSLASH] = ACTIONS(9180),
    [anon_sym_mdo] = ACTIONS(9182),
    [anon_sym_do] = ACTIONS(9182),
    [anon_sym_7] = ACTIONS(9184),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9186),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9188),
  },
  [2720] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(2971),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(14284),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3372),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym__datainst] = STATE(18036),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2721] = {
    [sym_integer] = STATE(7104),
    [sym__literal] = STATE(7104),
    [sym__unboxed_open] = STATE(2131),
    [sym_constructor] = STATE(7046),
    [sym_con_unit] = STATE(7104),
    [sym_con_list] = STATE(7104),
    [sym_con_tuple] = STATE(7104),
    [sym_qualified_type] = STATE(7087),
    [sym_tycon_arrow] = STATE(7087),
    [sym_type_literal] = STATE(2677),
    [sym__promoted_tycon] = STATE(7087),
    [sym_type_variable] = STATE(7087),
    [sym_annotated_type_variable] = STATE(7087),
    [sym_type_parens] = STATE(2677),
    [sym_type_list] = STATE(2677),
    [sym_type_tuple] = STATE(2677),
    [sym__type_promotable_literal] = STATE(2677),
    [sym__type_promoted_literal] = STATE(2677),
    [sym__type_literal] = STATE(2677),
    [sym_type_name] = STATE(2677),
    [sym_type_star] = STATE(2677),
    [sym_type_unboxed_tuple] = STATE(2677),
    [sym_type_unboxed_sum] = STATE(2677),
    [sym__atype] = STATE(2677),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15134),
    [sym_splice] = STATE(2677),
    [sym_quasiquote] = STATE(2677),
    [aux_sym_type_apply_repeat1] = STATE(2677),
    [ts_builtin_sym_end] = ACTIONS(5078),
    [sym__varid] = ACTIONS(8524),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(6368),
    [sym_char] = ACTIONS(6368),
    [sym_string] = ACTIONS(6368),
    [sym__integer_literal] = ACTIONS(6370),
    [sym__binary_literal] = ACTIONS(6372),
    [sym__octal_literal] = ACTIONS(6372),
    [sym__hex_literal] = ACTIONS(6372),
    [anon_sym_LPAREN_POUND] = ACTIONS(6374),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6374),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8526),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(9190),
    [anon_sym_LBRACK] = ACTIONS(6382),
    [anon_sym_SQUOTE] = ACTIONS(9193),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(6386),
    [anon_sym_6] = ACTIONS(6386),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(6388),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6390),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6392),
  },
  [2722] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(7143),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(7392),
    [sym_tycon_arrow] = STATE(7392),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(7392),
    [sym_type_variable] = STATE(7392),
    [sym_annotated_type_variable] = STATE(7392),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14454),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(3154),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(9653),
    [sym__btype] = STATE(9653),
    [sym_type_infix] = STATE(14979),
    [sym_constraint] = STATE(14919),
    [sym__quantified_constraint] = STATE(15713),
    [sym__constraint_context] = STATE(15713),
    [sym__constraint] = STATE(15713),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(2743),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14885),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(1771),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(8456),
    [anon_sym_RPAREN] = ACTIONS(9196),
    [sym__conid] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(8458),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2723] = {
    [sym_integer] = STATE(7224),
    [sym__literal] = STATE(7224),
    [sym__unboxed_open] = STATE(2201),
    [sym_constructor] = STATE(6997),
    [sym_con_unit] = STATE(7224),
    [sym_con_list] = STATE(7224),
    [sym_con_tuple] = STATE(7224),
    [sym_qualified_type] = STATE(7098),
    [sym_tycon_arrow] = STATE(7098),
    [sym_type_literal] = STATE(2710),
    [sym__promoted_tycon] = STATE(7098),
    [sym_type_variable] = STATE(7098),
    [sym_annotated_type_variable] = STATE(7098),
    [sym_type_parens] = STATE(2710),
    [sym_type_list] = STATE(2710),
    [sym_type_tuple] = STATE(2710),
    [sym__type_promotable_literal] = STATE(2710),
    [sym__type_promoted_literal] = STATE(2710),
    [sym__type_literal] = STATE(2710),
    [sym_type_name] = STATE(2710),
    [sym_type_star] = STATE(2710),
    [sym_type_unboxed_tuple] = STATE(2710),
    [sym_type_unboxed_sum] = STATE(2710),
    [sym__atype] = STATE(2710),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15261),
    [sym_splice] = STATE(2710),
    [sym_quasiquote] = STATE(2710),
    [aux_sym_type_apply_repeat1] = STATE(2710),
    [sym__varid] = ACTIONS(9198),
    [anon_sym_SEMI] = ACTIONS(5177),
    [sym_float] = ACTIONS(6533),
    [sym_char] = ACTIONS(6533),
    [sym_string] = ACTIONS(6533),
    [sym__integer_literal] = ACTIONS(6535),
    [sym__binary_literal] = ACTIONS(6537),
    [sym__octal_literal] = ACTIONS(6537),
    [sym__hex_literal] = ACTIONS(6537),
    [anon_sym_LPAREN_POUND] = ACTIONS(6539),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6539),
    [anon_sym_] = ACTIONS(5177),
    [anon_sym_EQ_GT] = ACTIONS(5177),
    [anon_sym_2] = ACTIONS(5177),
    [anon_sym_DASH_GT] = ACTIONS(5177),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9200),
    [anon_sym_BQUOTE] = ACTIONS(5177),
    [sym__conid] = ACTIONS(9202),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_SQUOTE] = ACTIONS(9205),
    [anon_sym_PIPE] = ACTIONS(5177),
    [anon_sym_STAR] = ACTIONS(6551),
    [anon_sym_6] = ACTIONS(6551),
    [anon_sym_PERCENT] = ACTIONS(5177),
    [anon_sym_7] = ACTIONS(6553),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5177),
    [sym__layout_end] = ACTIONS(5177),
    [sym_where] = ACTIONS(5177),
    [sym__splice_dollar] = ACTIONS(6555),
    [sym__consym] = ACTIONS(5177),
    [sym__tyconsym] = ACTIONS(5177),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6557),
  },
  [2724] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(2971),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(14284),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3372),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym__datainst] = STATE(18070),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2725] = {
    [sym_integer] = STATE(4163),
    [sym__literal] = STATE(4163),
    [sym__unboxed_open] = STATE(2210),
    [sym_constructor] = STATE(3928),
    [sym_con_unit] = STATE(4163),
    [sym_con_list] = STATE(4163),
    [sym_con_tuple] = STATE(4163),
    [sym_qualified_type] = STATE(4017),
    [sym_tycon_arrow] = STATE(4017),
    [sym_type_literal] = STATE(2042),
    [sym__promoted_tycon] = STATE(4017),
    [sym_type_variable] = STATE(4017),
    [sym_annotated_type_variable] = STATE(4017),
    [sym__forall_kw] = STATE(14571),
    [sym__forall] = STATE(14550),
    [sym_forall] = STATE(2971),
    [sym_type_parens] = STATE(2042),
    [sym_type_list] = STATE(2042),
    [sym_type_tuple] = STATE(2042),
    [sym__type_promotable_literal] = STATE(2042),
    [sym__type_promoted_literal] = STATE(2042),
    [sym__type_literal] = STATE(2042),
    [sym_type_name] = STATE(2059),
    [sym_type_star] = STATE(2042),
    [sym_type_unboxed_tuple] = STATE(2042),
    [sym_type_unboxed_sum] = STATE(2042),
    [sym__atype] = STATE(2042),
    [sym_type_apply] = STATE(5856),
    [sym__btype] = STATE(5856),
    [sym_type_infix] = STATE(9433),
    [sym__type_infix] = STATE(14284),
    [sym_constraint] = STATE(15479),
    [sym__context_constraints] = STATE(15479),
    [sym__context] = STATE(9450),
    [sym_context] = STATE(3372),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(14865),
    [sym__datainst] = STATE(18112),
    [sym_splice] = STATE(2042),
    [sym_quasiquote] = STATE(2042),
    [sym__varid] = ACTIONS(5076),
    [sym_float] = ACTIONS(5080),
    [sym_char] = ACTIONS(5080),
    [sym_string] = ACTIONS(5080),
    [sym__integer_literal] = ACTIONS(5082),
    [sym__binary_literal] = ACTIONS(5084),
    [sym__octal_literal] = ACTIONS(5084),
    [sym__hex_literal] = ACTIONS(5084),
    [anon_sym_LPAREN_POUND] = ACTIONS(5086),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(5086),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(5310),
    [sym__conid] = ACTIONS(5361),
    [anon_sym_LBRACK] = ACTIONS(5093),
    [anon_sym_SQUOTE] = ACTIONS(5314),
    [anon_sym_forall] = ACTIONS(1795),
    [anon_sym_5] = ACTIONS(1797),
    [anon_sym_STAR] = ACTIONS(5098),
    [anon_sym_6] = ACTIONS(5098),
    [anon_sym_7] = ACTIONS(5102),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(5104),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(5106),
  },
  [2726] = {
    [sym_integer] = STATE(7224),
    [sym__literal] = STATE(7224),
    [sym__unboxed_open] = STATE(2201),
    [sym_constructor] = STATE(6997),
    [sym_con_unit] = STATE(7224),
    [sym_con_list] = STATE(7224),
    [sym_con_tuple] = STATE(7224),
    [sym_qualified_type] = STATE(7098),
    [sym_tycon_arrow] = STATE(7098),
    [sym_type_literal] = STATE(2723),
    [sym__promoted_tycon] = STATE(7098),
    [sym_type_variable] = STATE(7098),
    [sym_annotated_type_variable] = STATE(7098),
    [sym_type_parens] = STATE(2723),
    [sym_type_list] = STATE(2723),
    [sym_type_tuple] = STATE(2723),
    [sym__type_promotable_literal] = STATE(2723),
    [sym__type_promoted_literal] = STATE(2723),
    [sym__type_literal] = STATE(2723),
    [sym_type_name] = STATE(2723),
    [sym_type_star] = STATE(2723),
    [sym_type_unboxed_tuple] = STATE(2723),
    [sym_type_unboxed_sum] = STATE(2723),
    [sym__atype] = STATE(2723),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(15261),
    [sym_splice] = STATE(2723),
    [sym_quasiquote] = STATE(2723),
    [aux_sym_type_apply_repeat1] = STATE(2723),
    [sym__varid] = ACTIONS(9198),
    [anon_sym_SEMI] = ACTIONS(5078),
    [sym_float] = ACTIONS(6533),
    [sym_char] = ACTIONS(6533),
    [sym_string] = ACTIONS(6533),
    [sym__integer_literal] = ACTIONS(6535),
    [sym__binary_literal] = ACTIONS(6537),
    [sym__octal_literal] = ACTIONS(6537),
    [sym__hex_literal] = ACTIONS(6537),
    [anon_sym_LPAREN_POUND] = ACTIONS(6539),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(6539),
    [anon_sym_] = ACTIONS(5078),
    [anon_sym_EQ_GT] = ACTIONS(5078),
    [anon_sym_2] = ACTIONS(5078),
    [anon_sym_DASH_GT] = ACTIONS(5078),
    [sym_pragma] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9200),
    [anon_sym_BQUOTE] = ACTIONS(5078),
    [sym__conid] = ACTIONS(9208),
    [anon_sym_LBRACK] = ACTIONS(6547),
    [anon_sym_SQUOTE] = ACTIONS(9211),
    [anon_sym_PIPE] = ACTIONS(5078),
    [anon_sym_STAR] = ACTIONS(6551),
    [anon_sym_6] = ACTIONS(6551),
    [anon_sym_PERCENT] = ACTIONS(5078),
    [anon_sym_7] = ACTIONS(6553),
    [aux_sym__token1] = ACTIONS(3),
    [sym__layout_semicolon] = ACTIONS(5078),
    [sym__layout_end] = ACTIONS(5078),
    [sym_where] = ACTIONS(5078),
    [sym__splice_dollar] = ACTIONS(6555),
    [sym__consym] = ACTIONS(5078),
    [sym__tyconsym] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(6557),
  },
  [2727] = {
    [sym_integer] = STATE(10796),
    [sym__literal] = STATE(10796),
    [sym__unboxed_open] = STATE(778),
    [sym_variable] = STATE(10362),
    [sym_qualified_variable] = STATE(10362),
    [sym_constructor] = STATE(10044),
    [sym_qualified_constructor] = STATE(10640),
    [sym__qcon] = STATE(10362),
    [sym_con_unit] = STATE(10796),
    [sym_con_list] = STATE(10796),
    [sym_con_tuple] = STATE(10796),
    [sym_literal] = STATE(11023),
    [sym_exp_parens] = STATE(11023),
    [sym_exp_tuple] = STATE(11023),
    [sym_exp_unboxed_tuple] = STATE(11023),
    [sym_exp_unboxed_sum] = STATE(11023),
    [sym_exp_list] = STATE(11023),
    [sym_exp_arithmetic_sequence] = STATE(11023),
    [sym_exp_list_comprehension] = STATE(11023),
    [sym_exp_section_left] = STATE(11023),
    [sym_exp_section_right] = STATE(11023),
    [sym_exp_th_quoted_name] = STATE(11023),
    [sym_exp_type_application] = STATE(11860),
    [sym_exp_lambda_case] = STATE(11860),
    [sym__do_keyword] = STATE(18300),
    [sym_do_module] = STATE(18300),
    [sym_exp_do] = STATE(11860),
    [sym_exp_record] = STATE(11023),
    [sym_exp_name] = STATE(11023),
    [sym_exp_projection_selector] = STATE(11023),
    [sym__aexp_projection] = STATE(11023),
    [sym_exp_projection] = STATE(11023),
    [sym__aexp] = STATE(11860),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12719),
    [sym_splice] = STATE(11023),
    [sym_quasiquote] = STATE(11023),
    [sym__varid] = ACTIONS(4551),
    [sym_float] = ACTIONS(4553),
    [sym_char] = ACTIONS(4553),
    [sym_string] = ACTIONS(4553),
    [sym__integer_literal] = ACTIONS(4555),
    [sym__binary_literal] = ACTIONS(4557),
    [sym__octal_literal] = ACTIONS(4557),
    [sym__hex_literal] = ACTIONS(4557),
    [anon_sym_LPAREN_POUND] = ACTIONS(9214),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9214),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9216),
    [anon_sym_LPAREN] = ACTIONS(9218),
    [sym_implicit_parid] = ACTIONS(9216),
    [sym__conid] = ACTIONS(4565),
    [anon_sym_LBRACK] = ACTIONS(9220),
    [anon_sym_SQUOTE] = ACTIONS(9222),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9224),
    [anon_sym_AT] = ACTIONS(9226),
    [anon_sym_BSLASH] = ACTIONS(9228),
    [anon_sym_mdo] = ACTIONS(9230),
    [anon_sym_do] = ACTIONS(9230),
    [anon_sym_7] = ACTIONS(4579),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4581),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4583),
  },
  [2728] = {
    [sym_integer] = STATE(10715),
    [sym__literal] = STATE(10715),
    [sym__unboxed_open] = STATE(776),
    [sym_variable] = STATE(10627),
    [sym_qualified_variable] = STATE(10627),
    [sym_constructor] = STATE(10105),
    [sym_qualified_constructor] = STATE(10604),
    [sym__qcon] = STATE(10627),
    [sym_con_unit] = STATE(10715),
    [sym_con_list] = STATE(10715),
    [sym_con_tuple] = STATE(10715),
    [sym_literal] = STATE(11645),
    [sym_exp_parens] = STATE(11645),
    [sym_exp_tuple] = STATE(11645),
    [sym_exp_unboxed_tuple] = STATE(11645),
    [sym_exp_unboxed_sum] = STATE(11645),
    [sym_exp_list] = STATE(11645),
    [sym_exp_arithmetic_sequence] = STATE(11645),
    [sym_exp_list_comprehension] = STATE(11645),
    [sym_exp_section_left] = STATE(11645),
    [sym_exp_section_right] = STATE(11645),
    [sym_exp_th_quoted_name] = STATE(11645),
    [sym_exp_type_application] = STATE(12027),
    [sym_exp_lambda_case] = STATE(12027),
    [sym__do_keyword] = STATE(18375),
    [sym_do_module] = STATE(18375),
    [sym_exp_do] = STATE(12027),
    [sym_exp_record] = STATE(11645),
    [sym_exp_name] = STATE(11645),
    [sym_exp_projection_selector] = STATE(11645),
    [sym__aexp_projection] = STATE(11645),
    [sym_exp_projection] = STATE(11645),
    [sym__aexp] = STATE(12027),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12661),
    [sym_splice] = STATE(11645),
    [sym_quasiquote] = STATE(11645),
    [sym__varid] = ACTIONS(4359),
    [sym_float] = ACTIONS(4361),
    [sym_char] = ACTIONS(4361),
    [sym_string] = ACTIONS(4361),
    [sym__integer_literal] = ACTIONS(4363),
    [sym__binary_literal] = ACTIONS(4365),
    [sym__octal_literal] = ACTIONS(4365),
    [sym__hex_literal] = ACTIONS(4365),
    [anon_sym_LPAREN_POUND] = ACTIONS(9232),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9232),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4369),
    [anon_sym_LPAREN] = ACTIONS(9234),
    [sym_implicit_parid] = ACTIONS(4369),
    [sym__conid] = ACTIONS(4373),
    [anon_sym_LBRACK] = ACTIONS(9236),
    [anon_sym_SQUOTE] = ACTIONS(4377),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4379),
    [anon_sym_AT] = ACTIONS(4381),
    [anon_sym_BSLASH] = ACTIONS(4383),
    [anon_sym_mdo] = ACTIONS(4385),
    [anon_sym_do] = ACTIONS(4385),
    [anon_sym_7] = ACTIONS(4387),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4389),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4391),
  },
  [2729] = {
    [sym_integer] = STATE(10271),
    [sym__literal] = STATE(10271),
    [sym__unboxed_open] = STATE(777),
    [sym_variable] = STATE(10194),
    [sym_qualified_variable] = STATE(10194),
    [sym_constructor] = STATE(9941),
    [sym_qualified_constructor] = STATE(10009),
    [sym__qcon] = STATE(10194),
    [sym_con_unit] = STATE(10271),
    [sym_con_list] = STATE(10271),
    [sym_con_tuple] = STATE(10271),
    [sym_literal] = STATE(9995),
    [sym_exp_parens] = STATE(9995),
    [sym_exp_tuple] = STATE(9995),
    [sym_exp_unboxed_tuple] = STATE(9995),
    [sym_exp_unboxed_sum] = STATE(9995),
    [sym_exp_list] = STATE(9995),
    [sym_exp_arithmetic_sequence] = STATE(9995),
    [sym_exp_list_comprehension] = STATE(9995),
    [sym_exp_section_left] = STATE(9995),
    [sym_exp_section_right] = STATE(9995),
    [sym_exp_th_quoted_name] = STATE(9995),
    [sym_exp_type_application] = STATE(10667),
    [sym_exp_lambda_case] = STATE(10667),
    [sym__do_keyword] = STATE(18142),
    [sym_do_module] = STATE(18142),
    [sym_exp_do] = STATE(10667),
    [sym_exp_record] = STATE(9995),
    [sym_exp_name] = STATE(9995),
    [sym_exp_projection_selector] = STATE(9995),
    [sym__aexp_projection] = STATE(9995),
    [sym_exp_projection] = STATE(9995),
    [sym__aexp] = STATE(10667),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12512),
    [sym_splice] = STATE(9995),
    [sym_quasiquote] = STATE(9995),
    [sym__varid] = ACTIONS(9238),
    [sym_float] = ACTIONS(9240),
    [sym_char] = ACTIONS(9240),
    [sym_string] = ACTIONS(9240),
    [sym__integer_literal] = ACTIONS(9242),
    [sym__binary_literal] = ACTIONS(9244),
    [sym__octal_literal] = ACTIONS(9244),
    [sym__hex_literal] = ACTIONS(9244),
    [anon_sym_LPAREN_POUND] = ACTIONS(9246),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9246),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9248),
    [anon_sym_LPAREN] = ACTIONS(9250),
    [sym_implicit_parid] = ACTIONS(9248),
    [sym__conid] = ACTIONS(9252),
    [anon_sym_LBRACK] = ACTIONS(9254),
    [anon_sym_SQUOTE] = ACTIONS(9256),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9258),
    [anon_sym_AT] = ACTIONS(9260),
    [anon_sym_BSLASH] = ACTIONS(9262),
    [anon_sym_mdo] = ACTIONS(9264),
    [anon_sym_do] = ACTIONS(9264),
    [anon_sym_7] = ACTIONS(9266),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9268),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9270),
  },
  [2730] = {
    [sym_integer] = STATE(9549),
    [sym__literal] = STATE(9549),
    [sym__unboxed_open] = STATE(795),
    [sym_variable] = STATE(9576),
    [sym_qualified_variable] = STATE(9576),
    [sym_constructor] = STATE(9458),
    [sym_qualified_constructor] = STATE(9525),
    [sym__qcon] = STATE(9576),
    [sym_con_unit] = STATE(9549),
    [sym_con_list] = STATE(9549),
    [sym_con_tuple] = STATE(9549),
    [sym_literal] = STATE(9934),
    [sym_exp_parens] = STATE(9934),
    [sym_exp_tuple] = STATE(9934),
    [sym_exp_unboxed_tuple] = STATE(9934),
    [sym_exp_unboxed_sum] = STATE(9934),
    [sym_exp_list] = STATE(9934),
    [sym_exp_arithmetic_sequence] = STATE(9934),
    [sym_exp_list_comprehension] = STATE(9934),
    [sym_exp_section_left] = STATE(9934),
    [sym_exp_section_right] = STATE(9934),
    [sym_exp_th_quoted_name] = STATE(9934),
    [sym_exp_type_application] = STATE(10314),
    [sym_exp_lambda_case] = STATE(10314),
    [sym__do_keyword] = STATE(18492),
    [sym_do_module] = STATE(18492),
    [sym_exp_do] = STATE(10314),
    [sym_exp_record] = STATE(9934),
    [sym_exp_name] = STATE(9934),
    [sym_exp_projection_selector] = STATE(9934),
    [sym__aexp_projection] = STATE(9934),
    [sym_exp_projection] = STATE(9934),
    [sym__aexp] = STATE(10314),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12670),
    [sym_splice] = STATE(9934),
    [sym_quasiquote] = STATE(9934),
    [sym__varid] = ACTIONS(4095),
    [sym_float] = ACTIONS(4097),
    [sym_char] = ACTIONS(4097),
    [sym_string] = ACTIONS(4097),
    [sym__integer_literal] = ACTIONS(4099),
    [sym__binary_literal] = ACTIONS(4101),
    [sym__octal_literal] = ACTIONS(4101),
    [sym__hex_literal] = ACTIONS(4101),
    [anon_sym_LPAREN_POUND] = ACTIONS(8448),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(8448),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(4105),
    [anon_sym_LPAREN] = ACTIONS(8450),
    [sym_implicit_parid] = ACTIONS(4105),
    [sym__conid] = ACTIONS(4111),
    [anon_sym_LBRACK] = ACTIONS(8452),
    [anon_sym_SQUOTE] = ACTIONS(4115),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(4117),
    [anon_sym_AT] = ACTIONS(4119),
    [anon_sym_BSLASH] = ACTIONS(4121),
    [anon_sym_mdo] = ACTIONS(4123),
    [anon_sym_do] = ACTIONS(4123),
    [anon_sym_7] = ACTIONS(4125),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4127),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4129),
  },
  [2731] = {
    [sym_integer] = STATE(11261),
    [sym__literal] = STATE(11261),
    [sym__unboxed_open] = STATE(766),
    [sym_variable] = STATE(10999),
    [sym_qualified_variable] = STATE(10999),
    [sym_constructor] = STATE(10370),
    [sym_qualified_constructor] = STATE(11461),
    [sym__qcon] = STATE(10999),
    [sym_con_unit] = STATE(11261),
    [sym_con_list] = STATE(11261),
    [sym_con_tuple] = STATE(11261),
    [sym_literal] = STATE(10972),
    [sym_exp_parens] = STATE(10972),
    [sym_exp_tuple] = STATE(10972),
    [sym_exp_unboxed_tuple] = STATE(10972),
    [sym_exp_unboxed_sum] = STATE(10972),
    [sym_exp_list] = STATE(10972),
    [sym_exp_arithmetic_sequence] = STATE(10972),
    [sym_exp_list_comprehension] = STATE(10972),
    [sym_exp_section_left] = STATE(10972),
    [sym_exp_section_right] = STATE(10972),
    [sym_exp_th_quoted_name] = STATE(10972),
    [sym_exp_type_application] = STATE(11850),
    [sym_exp_lambda_case] = STATE(11850),
    [sym__do_keyword] = STATE(18213),
    [sym_do_module] = STATE(18213),
    [sym_exp_do] = STATE(11850),
    [sym_exp_record] = STATE(10972),
    [sym_exp_name] = STATE(10972),
    [sym_exp_projection_selector] = STATE(10972),
    [sym__aexp_projection] = STATE(10972),
    [sym_exp_projection] = STATE(10972),
    [sym__aexp] = STATE(11850),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12701),
    [sym_splice] = STATE(10972),
    [sym_quasiquote] = STATE(10972),
    [sym__varid] = ACTIONS(9272),
    [sym_float] = ACTIONS(9274),
    [sym_char] = ACTIONS(9274),
    [sym_string] = ACTIONS(9274),
    [sym__integer_literal] = ACTIONS(9276),
    [sym__binary_literal] = ACTIONS(9278),
    [sym__octal_literal] = ACTIONS(9278),
    [sym__hex_literal] = ACTIONS(9278),
    [anon_sym_LPAREN_POUND] = ACTIONS(9280),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9280),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9282),
    [anon_sym_LPAREN] = ACTIONS(9284),
    [sym_implicit_parid] = ACTIONS(9282),
    [sym__conid] = ACTIONS(9286),
    [anon_sym_LBRACK] = ACTIONS(9288),
    [anon_sym_SQUOTE] = ACTIONS(9290),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9292),
    [anon_sym_AT] = ACTIONS(9294),
    [anon_sym_BSLASH] = ACTIONS(9296),
    [anon_sym_mdo] = ACTIONS(9298),
    [anon_sym_do] = ACTIONS(9298),
    [anon_sym_7] = ACTIONS(9300),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(9302),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(9304),
  },
  [2732] = {
    [sym_integer] = STATE(11487),
    [sym__literal] = STATE(11487),
    [sym__unboxed_open] = STATE(771),
    [sym_variable] = STATE(11282),
    [sym_qualified_variable] = STATE(11282),
    [sym_constructor] = STATE(10806),
    [sym_qualified_constructor] = STATE(10906),
    [sym__qcon] = STATE(11282),
    [sym_con_unit] = STATE(11487),
    [sym_con_list] = STATE(11487),
    [sym_con_tuple] = STATE(11487),
    [sym_literal] = STATE(12110),
    [sym_exp_parens] = STATE(12110),
    [sym_exp_tuple] = STATE(12110),
    [sym_exp_unboxed_tuple] = STATE(12110),
    [sym_exp_unboxed_sum] = STATE(12110),
    [sym_exp_list] = STATE(12110),
    [sym_exp_arithmetic_sequence] = STATE(12110),
    [sym_exp_list_comprehension] = STATE(12110),
    [sym_exp_section_left] = STATE(12110),
    [sym_exp_section_right] = STATE(12110),
    [sym_exp_th_quoted_name] = STATE(12110),
    [sym_exp_type_application] = STATE(12271),
    [sym_exp_lambda_case] = STATE(12271),
    [sym__do_keyword] = STATE(18392),
    [sym_do_module] = STATE(18392),
    [sym_exp_do] = STATE(12271),
    [sym_exp_record] = STATE(12110),
    [sym_exp_name] = STATE(12110),
    [sym_exp_projection_selector] = STATE(12110),
    [sym__aexp_projection] = STATE(12110),
    [sym_exp_projection] = STATE(12110),
    [sym__aexp] = STATE(12271),
    [sym__modid] = STATE(20878),
    [aux_sym__qualifying_module] = STATE(12537),
    [sym_splice] = STATE(12110),
    [sym_quasiquote] = STATE(12110),
    [sym__varid] = ACTIONS(4427),
    [sym_float] = ACTIONS(4429),
    [sym_char] = ACTIONS(4429),
    [sym_string] = ACTIONS(4429),
    [sym__integer_literal] = ACTIONS(4431),
    [sym__binary_literal] = ACTIONS(4433),
    [sym__octal_literal] = ACTIONS(4433),
    [sym__hex_literal] = ACTIONS(4433),
    [anon_sym_LPAREN_POUND] = ACTIONS(9306),
    [anon_sym_LPAREN_POUND_LF] = ACTIONS(9306),
    [sym_pragma] = ACTIONS(3),
    [sym_label] = ACTIONS(9308),
    [anon_sym_LPAREN] = ACTIONS(9310),
    [sym_implicit_parid] = ACTIONS(9308),
    [sym__conid] = ACTIONS(4439),
    [anon_sym_LBRACK] = ACTIONS(9312),
    [anon_sym_SQUOTE] = ACTIONS(9314),
    [anon_sym_SQUOTE_SQUOTE] = ACTIONS(9316),
    [anon_sym_AT] = ACTIONS(9318),
    [anon_sym_BSLASH] = ACTIONS(9320),
    [anon_sym_mdo] = ACTIONS(9322),
    [anon_sym_do] = ACTIONS(9322),
    [anon_sym_7] = ACTIONS(4443),
    [aux_sym__token1] = ACTIONS(3),
    [sym__splice_dollar] = ACTIONS(4445),
    [sym_comment] = ACTIONS(3),
    [sym_cpp] = ACTIONS(3),
    [sym_quasiquote_start] = ACTIONS(4447),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 22,
    ACTIONS(9324), 1,
      sym__varid,
    ACTIONS(9330), 1,
      sym__integer_literal,
    ACTIONS(9339), 1,
      anon_sym_LPAREN,
    ACTIONS(9342), 1,
      sym__conid,
    ACTIONS(9345), 1,
      anon_sym_LBRACK,
    ACTIONS(9348), 1,
      anon_sym_SQUOTE,
    ACTIONS(9354), 1,
      anon_sym_7,
    ACTIONS(9357), 1,
      sym__splice_dollar,
    ACTIONS(9360), 1,
      sym_quasiquote_start,
    STATE(2118), 1,
      sym__unboxed_open,
    STATE(7143), 1,
      sym_constructor,
    STATE(14885), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9336), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9351), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9327), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9333), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7364), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7392), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5030), 12,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
    STATE(2733), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [109] = 23,
    ACTIONS(5134), 1,
      sym__integer_literal,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      sym__conid,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_SQUOTE,
    ACTIONS(5162), 1,
      anon_sym_7,
    ACTIONS(5165), 1,
      sym__splice_dollar,
    ACTIONS(5168), 1,
      sym_quasiquote_start,
    ACTIONS(5899), 1,
      sym__varid,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5143), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(5157), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5129), 10,
      sym__arith_dotdot,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    STATE(3268), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [220] = 23,
    ACTIONS(5059), 1,
      anon_sym_in,
    ACTIONS(9363), 1,
      sym__varid,
    ACTIONS(9369), 1,
      sym__integer_literal,
    ACTIONS(9378), 1,
      anon_sym_LPAREN,
    ACTIONS(9381), 1,
      sym__conid,
    ACTIONS(9384), 1,
      anon_sym_LBRACK,
    ACTIONS(9387), 1,
      anon_sym_SQUOTE,
    ACTIONS(9393), 1,
      anon_sym_7,
    ACTIONS(9396), 1,
      sym__splice_dollar,
    ACTIONS(9399), 1,
      sym_quasiquote_start,
    STATE(2145), 1,
      sym__unboxed_open,
    STATE(7303), 1,
      sym_constructor,
    STATE(14983), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9375), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9390), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9366), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9372), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7348), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7581), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5030), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2735), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [331] = 22,
    ACTIONS(6171), 1,
      sym__integer_literal,
    ACTIONS(6183), 1,
      anon_sym_LBRACK,
    ACTIONS(6189), 1,
      anon_sym_7,
    ACTIONS(6191), 1,
      sym__splice_dollar,
    ACTIONS(6193), 1,
      sym_quasiquote_start,
    ACTIONS(9402), 1,
      sym__varid,
    ACTIONS(9404), 1,
      anon_sym_LPAREN,
    ACTIONS(9406), 1,
      sym__conid,
    ACTIONS(9409), 1,
      anon_sym_SQUOTE,
    STATE(2197), 1,
      sym__unboxed_open,
    STATE(7110), 1,
      sym_constructor,
    STATE(15277), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6175), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6187), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(6169), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6173), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7386), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7585), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5078), 12,
      sym_where,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
    STATE(2748), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [440] = 24,
    ACTIONS(5126), 1,
      sym__varid,
    ACTIONS(5134), 1,
      sym__integer_literal,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      sym__conid,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_SQUOTE,
    ACTIONS(5160), 1,
      anon_sym_deriving,
    ACTIONS(5162), 1,
      anon_sym_7,
    ACTIONS(5165), 1,
      sym__splice_dollar,
    ACTIONS(5168), 1,
      sym_quasiquote_start,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5143), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(5157), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5129), 9,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(3268), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [553] = 22,
    ACTIONS(1775), 1,
      sym__integer_literal,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1801), 1,
      anon_sym_7,
    ACTIONS(1803), 1,
      sym__splice_dollar,
    ACTIONS(1809), 1,
      sym_quasiquote_start,
    ACTIONS(9412), 1,
      sym__varid,
    ACTIONS(9414), 1,
      anon_sym_LPAREN,
    ACTIONS(9416), 1,
      sym__conid,
    ACTIONS(9419), 1,
      anon_sym_SQUOTE,
    STATE(2118), 1,
      sym__unboxed_open,
    STATE(7143), 1,
      sym_constructor,
    STATE(14885), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(1799), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(1773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7364), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7392), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5177), 12,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
    STATE(2733), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [662] = 32,
    ACTIONS(1771), 1,
      sym__varid,
    ACTIONS(1789), 1,
      sym__conid,
    ACTIONS(1795), 1,
      anon_sym_forall,
    ACTIONS(1797), 1,
      anon_sym_5,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(8456), 1,
      anon_sym_LPAREN,
    ACTIONS(8458), 1,
      anon_sym_SQUOTE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2743), 1,
      sym__context,
    STATE(3154), 1,
      sym_type_name,
    STATE(7143), 1,
      sym_constructor,
    STATE(14454), 1,
      sym__forall,
    STATE(14571), 1,
      sym__forall_kw,
    STATE(14885), 1,
      aux_sym__qualifying_module,
    STATE(14919), 1,
      sym_constraint,
    STATE(14979), 1,
      sym_type_infix,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9653), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(18523), 3,
      sym__quantified_constraint,
      sym__constraint_context,
      sym__constraint,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7392), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [791] = 23,
    ACTIONS(5059), 1,
      anon_sym_in,
    ACTIONS(9422), 1,
      sym__varid,
    ACTIONS(9428), 1,
      sym__integer_literal,
    ACTIONS(9437), 1,
      anon_sym_LPAREN,
    ACTIONS(9440), 1,
      sym__conid,
    ACTIONS(9443), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_SQUOTE,
    ACTIONS(9452), 1,
      anon_sym_7,
    ACTIONS(9455), 1,
      sym__splice_dollar,
    ACTIONS(9458), 1,
      sym_quasiquote_start,
    STATE(2135), 1,
      sym__unboxed_open,
    STATE(7313), 1,
      sym_constructor,
    STATE(15269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9434), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9449), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9425), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9431), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7334), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7576), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5030), 11,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2740), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [902] = 32,
    ACTIONS(1771), 1,
      sym__varid,
    ACTIONS(1789), 1,
      sym__conid,
    ACTIONS(1795), 1,
      anon_sym_forall,
    ACTIONS(1797), 1,
      anon_sym_5,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(8456), 1,
      anon_sym_LPAREN,
    ACTIONS(8458), 1,
      anon_sym_SQUOTE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2743), 1,
      sym__context,
    STATE(3154), 1,
      sym_type_name,
    STATE(7143), 1,
      sym_constructor,
    STATE(14454), 1,
      sym__forall,
    STATE(14571), 1,
      sym__forall_kw,
    STATE(14885), 1,
      aux_sym__qualifying_module,
    STATE(14919), 1,
      sym_constraint,
    STATE(14979), 1,
      sym_type_infix,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9653), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(18515), 3,
      sym__quantified_constraint,
      sym__constraint_context,
      sym__constraint,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7392), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [1031] = 22,
    ACTIONS(1775), 1,
      sym__integer_literal,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1801), 1,
      anon_sym_7,
    ACTIONS(1803), 1,
      sym__splice_dollar,
    ACTIONS(1809), 1,
      sym_quasiquote_start,
    ACTIONS(9412), 1,
      sym__varid,
    ACTIONS(9414), 1,
      anon_sym_LPAREN,
    ACTIONS(9461), 1,
      sym__conid,
    ACTIONS(9464), 1,
      anon_sym_SQUOTE,
    STATE(2118), 1,
      sym__unboxed_open,
    STATE(7143), 1,
      sym_constructor,
    STATE(14885), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(1799), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(1773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7364), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7392), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5078), 12,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
    STATE(2738), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [1140] = 32,
    ACTIONS(1771), 1,
      sym__varid,
    ACTIONS(1789), 1,
      sym__conid,
    ACTIONS(1795), 1,
      anon_sym_forall,
    ACTIONS(1797), 1,
      anon_sym_5,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(8456), 1,
      anon_sym_LPAREN,
    ACTIONS(8458), 1,
      anon_sym_SQUOTE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2743), 1,
      sym__context,
    STATE(3154), 1,
      sym_type_name,
    STATE(7143), 1,
      sym_constructor,
    STATE(14454), 1,
      sym__forall,
    STATE(14571), 1,
      sym__forall_kw,
    STATE(14885), 1,
      aux_sym__qualifying_module,
    STATE(14919), 1,
      sym_constraint,
    STATE(14979), 1,
      sym_type_infix,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9653), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(18345), 3,
      sym__quantified_constraint,
      sym__constraint_context,
      sym__constraint,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7392), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [1269] = 23,
    ACTIONS(5185), 1,
      anon_sym_in,
    ACTIONS(6111), 1,
      sym__varid,
    ACTIONS(6115), 1,
      sym__integer_literal,
    ACTIONS(6127), 1,
      anon_sym_LBRACK,
    ACTIONS(6133), 1,
      anon_sym_7,
    ACTIONS(6135), 1,
      sym__splice_dollar,
    ACTIONS(6137), 1,
      sym_quasiquote_start,
    ACTIONS(9467), 1,
      anon_sym_LPAREN,
    ACTIONS(9469), 1,
      sym__conid,
    ACTIONS(9472), 1,
      anon_sym_SQUOTE,
    STATE(2145), 1,
      sym__unboxed_open,
    STATE(7303), 1,
      sym_constructor,
    STATE(14983), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6119), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6131), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(6113), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6117), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7348), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7581), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5177), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2735), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [1380] = 23,
    ACTIONS(5059), 1,
      anon_sym_deriving,
    ACTIONS(9475), 1,
      sym__varid,
    ACTIONS(9481), 1,
      sym__integer_literal,
    ACTIONS(9490), 1,
      anon_sym_LPAREN,
    ACTIONS(9493), 1,
      sym__conid,
    ACTIONS(9496), 1,
      anon_sym_LBRACK,
    ACTIONS(9499), 1,
      anon_sym_SQUOTE,
    ACTIONS(9505), 1,
      anon_sym_7,
    ACTIONS(9508), 1,
      sym__splice_dollar,
    ACTIONS(9511), 1,
      sym_quasiquote_start,
    STATE(2162), 1,
      sym__unboxed_open,
    STATE(7280), 1,
      sym_constructor,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9487), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9502), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9478), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5030), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2745), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [1491] = 23,
    ACTIONS(5134), 1,
      sym__integer_literal,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      sym__conid,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_SQUOTE,
    ACTIONS(5162), 1,
      anon_sym_7,
    ACTIONS(5165), 1,
      sym__splice_dollar,
    ACTIONS(5168), 1,
      sym_quasiquote_start,
    ACTIONS(5899), 1,
      sym__varid,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5143), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(5157), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5129), 10,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
    STATE(3268), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [1602] = 24,
    ACTIONS(5126), 1,
      sym__varid,
    ACTIONS(5134), 1,
      sym__integer_literal,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      sym__conid,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_SQUOTE,
    ACTIONS(5160), 1,
      anon_sym_deriving,
    ACTIONS(5162), 1,
      anon_sym_7,
    ACTIONS(5165), 1,
      sym__splice_dollar,
    ACTIONS(5168), 1,
      sym_quasiquote_start,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5143), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(5157), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5129), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(3268), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [1715] = 22,
    ACTIONS(6171), 1,
      sym__integer_literal,
    ACTIONS(6183), 1,
      anon_sym_LBRACK,
    ACTIONS(6189), 1,
      anon_sym_7,
    ACTIONS(6191), 1,
      sym__splice_dollar,
    ACTIONS(6193), 1,
      sym_quasiquote_start,
    ACTIONS(9402), 1,
      sym__varid,
    ACTIONS(9404), 1,
      anon_sym_LPAREN,
    ACTIONS(9514), 1,
      sym__conid,
    ACTIONS(9517), 1,
      anon_sym_SQUOTE,
    STATE(2197), 1,
      sym__unboxed_open,
    STATE(7110), 1,
      sym_constructor,
    STATE(15277), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6175), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6187), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(6169), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6173), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7386), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7585), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5177), 12,
      sym_where,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
    STATE(2757), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [1824] = 23,
    ACTIONS(5100), 1,
      anon_sym_deriving,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5278), 1,
      sym__integer_literal,
    ACTIONS(5288), 1,
      anon_sym_LBRACK,
    ACTIONS(5296), 1,
      anon_sym_7,
    ACTIONS(5298), 1,
      sym__splice_dollar,
    ACTIONS(5300), 1,
      sym_quasiquote_start,
    ACTIONS(9520), 1,
      anon_sym_LPAREN,
    ACTIONS(9522), 1,
      sym__conid,
    ACTIONS(9525), 1,
      anon_sym_SQUOTE,
    STATE(2162), 1,
      sym__unboxed_open,
    STATE(7280), 1,
      sym_constructor,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5282), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5292), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5276), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5078), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2756), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [1935] = 24,
    ACTIONS(5126), 1,
      sym__varid,
    ACTIONS(5134), 1,
      sym__integer_literal,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      sym__conid,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_SQUOTE,
    ACTIONS(5160), 1,
      anon_sym_in,
    ACTIONS(5162), 1,
      anon_sym_7,
    ACTIONS(5165), 1,
      sym__splice_dollar,
    ACTIONS(5168), 1,
      sym_quasiquote_start,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5143), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(5157), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5129), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(3268), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [2048] = 24,
    ACTIONS(5126), 1,
      sym__varid,
    ACTIONS(5134), 1,
      sym__integer_literal,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      sym__conid,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_SQUOTE,
    ACTIONS(5160), 1,
      anon_sym_in,
    ACTIONS(5162), 1,
      anon_sym_7,
    ACTIONS(5165), 1,
      sym__splice_dollar,
    ACTIONS(5168), 1,
      sym_quasiquote_start,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5143), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(5157), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5129), 9,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(3268), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [2161] = 23,
    ACTIONS(5185), 1,
      anon_sym_deriving,
    ACTIONS(6002), 1,
      sym__varid,
    ACTIONS(6006), 1,
      sym__integer_literal,
    ACTIONS(6018), 1,
      anon_sym_LBRACK,
    ACTIONS(6024), 1,
      anon_sym_7,
    ACTIONS(6026), 1,
      sym__splice_dollar,
    ACTIONS(6028), 1,
      sym_quasiquote_start,
    ACTIONS(9528), 1,
      anon_sym_LPAREN,
    ACTIONS(9530), 1,
      sym__conid,
    ACTIONS(9533), 1,
      anon_sym_SQUOTE,
    STATE(2202), 1,
      sym__unboxed_open,
    STATE(7295), 1,
      sym_constructor,
    STATE(14836), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6010), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6022), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(6004), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6008), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7412), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7485), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5177), 11,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2763), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [2272] = 23,
    ACTIONS(5100), 1,
      anon_sym_deriving,
    ACTIONS(6002), 1,
      sym__varid,
    ACTIONS(6006), 1,
      sym__integer_literal,
    ACTIONS(6018), 1,
      anon_sym_LBRACK,
    ACTIONS(6024), 1,
      anon_sym_7,
    ACTIONS(6026), 1,
      sym__splice_dollar,
    ACTIONS(6028), 1,
      sym_quasiquote_start,
    ACTIONS(9528), 1,
      anon_sym_LPAREN,
    ACTIONS(9536), 1,
      sym__conid,
    ACTIONS(9539), 1,
      anon_sym_SQUOTE,
    STATE(2202), 1,
      sym__unboxed_open,
    STATE(7295), 1,
      sym_constructor,
    STATE(14836), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6010), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6022), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(6004), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6008), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7412), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7485), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5078), 11,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2752), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [2383] = 23,
    ACTIONS(5100), 1,
      anon_sym_in,
    ACTIONS(6111), 1,
      sym__varid,
    ACTIONS(6115), 1,
      sym__integer_literal,
    ACTIONS(6127), 1,
      anon_sym_LBRACK,
    ACTIONS(6133), 1,
      anon_sym_7,
    ACTIONS(6135), 1,
      sym__splice_dollar,
    ACTIONS(6137), 1,
      sym_quasiquote_start,
    ACTIONS(9467), 1,
      anon_sym_LPAREN,
    ACTIONS(9542), 1,
      sym__conid,
    ACTIONS(9545), 1,
      anon_sym_SQUOTE,
    STATE(2145), 1,
      sym__unboxed_open,
    STATE(7303), 1,
      sym_constructor,
    STATE(14983), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6119), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6131), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(6113), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6117), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7348), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7581), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5078), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2744), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [2494] = 23,
    ACTIONS(5134), 1,
      sym__integer_literal,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      sym__conid,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_SQUOTE,
    ACTIONS(5162), 1,
      anon_sym_7,
    ACTIONS(5165), 1,
      sym__splice_dollar,
    ACTIONS(5168), 1,
      sym_quasiquote_start,
    ACTIONS(5899), 1,
      sym__varid,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5143), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(5157), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5129), 10,
      sym_where,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
    STATE(3268), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [2605] = 23,
    ACTIONS(5185), 1,
      anon_sym_deriving,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5278), 1,
      sym__integer_literal,
    ACTIONS(5288), 1,
      anon_sym_LBRACK,
    ACTIONS(5296), 1,
      anon_sym_7,
    ACTIONS(5298), 1,
      sym__splice_dollar,
    ACTIONS(5300), 1,
      sym_quasiquote_start,
    ACTIONS(9520), 1,
      anon_sym_LPAREN,
    ACTIONS(9548), 1,
      sym__conid,
    ACTIONS(9551), 1,
      anon_sym_SQUOTE,
    STATE(2162), 1,
      sym__unboxed_open,
    STATE(7280), 1,
      sym_constructor,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5282), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5292), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5276), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5177), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2745), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [2716] = 22,
    ACTIONS(9554), 1,
      sym__varid,
    ACTIONS(9560), 1,
      sym__integer_literal,
    ACTIONS(9569), 1,
      anon_sym_LPAREN,
    ACTIONS(9572), 1,
      sym__conid,
    ACTIONS(9575), 1,
      anon_sym_LBRACK,
    ACTIONS(9578), 1,
      anon_sym_SQUOTE,
    ACTIONS(9584), 1,
      anon_sym_7,
    ACTIONS(9587), 1,
      sym__splice_dollar,
    ACTIONS(9590), 1,
      sym_quasiquote_start,
    STATE(2197), 1,
      sym__unboxed_open,
    STATE(7110), 1,
      sym_constructor,
    STATE(15277), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9566), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9581), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9557), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9563), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7386), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7585), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5030), 12,
      sym_where,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
    STATE(2757), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [2825] = 23,
    ACTIONS(5185), 1,
      anon_sym_in,
    ACTIONS(7068), 1,
      sym__varid,
    ACTIONS(7072), 1,
      sym__integer_literal,
    ACTIONS(7084), 1,
      anon_sym_LBRACK,
    ACTIONS(7090), 1,
      anon_sym_7,
    ACTIONS(7092), 1,
      sym__splice_dollar,
    ACTIONS(7094), 1,
      sym_quasiquote_start,
    ACTIONS(9593), 1,
      anon_sym_LPAREN,
    ACTIONS(9595), 1,
      sym__conid,
    ACTIONS(9598), 1,
      anon_sym_SQUOTE,
    STATE(2135), 1,
      sym__unboxed_open,
    STATE(7313), 1,
      sym_constructor,
    STATE(15269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7076), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7088), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(7070), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7074), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7334), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7576), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5177), 11,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2740), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [2936] = 23,
    ACTIONS(5100), 1,
      anon_sym_in,
    ACTIONS(7068), 1,
      sym__varid,
    ACTIONS(7072), 1,
      sym__integer_literal,
    ACTIONS(7084), 1,
      anon_sym_LBRACK,
    ACTIONS(7090), 1,
      anon_sym_7,
    ACTIONS(7092), 1,
      sym__splice_dollar,
    ACTIONS(7094), 1,
      sym_quasiquote_start,
    ACTIONS(9593), 1,
      anon_sym_LPAREN,
    ACTIONS(9601), 1,
      sym__conid,
    ACTIONS(9604), 1,
      anon_sym_SQUOTE,
    STATE(2135), 1,
      sym__unboxed_open,
    STATE(7313), 1,
      sym_constructor,
    STATE(15269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7076), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7088), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(7070), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7074), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7334), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7576), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5078), 11,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2758), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [3047] = 22,
    ACTIONS(6961), 1,
      sym__integer_literal,
    ACTIONS(6973), 1,
      anon_sym_LBRACK,
    ACTIONS(6979), 1,
      anon_sym_7,
    ACTIONS(6981), 1,
      sym__splice_dollar,
    ACTIONS(6983), 1,
      sym_quasiquote_start,
    ACTIONS(9607), 1,
      sym__varid,
    ACTIONS(9609), 1,
      anon_sym_LPAREN,
    ACTIONS(9611), 1,
      sym__conid,
    ACTIONS(9614), 1,
      anon_sym_SQUOTE,
    STATE(2172), 1,
      sym__unboxed_open,
    STATE(7276), 1,
      sym_constructor,
    STATE(15131), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6965), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6977), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(6959), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6963), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7394), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7406), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5177), 12,
      sym__arith_dotdot,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    STATE(2762), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [3156] = 22,
    ACTIONS(6961), 1,
      sym__integer_literal,
    ACTIONS(6973), 1,
      anon_sym_LBRACK,
    ACTIONS(6979), 1,
      anon_sym_7,
    ACTIONS(6981), 1,
      sym__splice_dollar,
    ACTIONS(6983), 1,
      sym_quasiquote_start,
    ACTIONS(9607), 1,
      sym__varid,
    ACTIONS(9609), 1,
      anon_sym_LPAREN,
    ACTIONS(9617), 1,
      sym__conid,
    ACTIONS(9620), 1,
      anon_sym_SQUOTE,
    STATE(2172), 1,
      sym__unboxed_open,
    STATE(7276), 1,
      sym_constructor,
    STATE(15131), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6965), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6977), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(6959), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6963), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7394), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7406), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5078), 12,
      sym__arith_dotdot,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    STATE(2760), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [3265] = 22,
    ACTIONS(9623), 1,
      sym__varid,
    ACTIONS(9629), 1,
      sym__integer_literal,
    ACTIONS(9638), 1,
      anon_sym_LPAREN,
    ACTIONS(9641), 1,
      sym__conid,
    ACTIONS(9644), 1,
      anon_sym_LBRACK,
    ACTIONS(9647), 1,
      anon_sym_SQUOTE,
    ACTIONS(9653), 1,
      anon_sym_7,
    ACTIONS(9656), 1,
      sym__splice_dollar,
    ACTIONS(9659), 1,
      sym_quasiquote_start,
    STATE(2172), 1,
      sym__unboxed_open,
    STATE(7276), 1,
      sym_constructor,
    STATE(15131), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9635), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9650), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9626), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9632), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7394), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7406), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5030), 12,
      sym__arith_dotdot,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    STATE(2762), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [3374] = 23,
    ACTIONS(5059), 1,
      anon_sym_deriving,
    ACTIONS(9662), 1,
      sym__varid,
    ACTIONS(9668), 1,
      sym__integer_literal,
    ACTIONS(9677), 1,
      anon_sym_LPAREN,
    ACTIONS(9680), 1,
      sym__conid,
    ACTIONS(9683), 1,
      anon_sym_LBRACK,
    ACTIONS(9686), 1,
      anon_sym_SQUOTE,
    ACTIONS(9692), 1,
      anon_sym_7,
    ACTIONS(9695), 1,
      sym__splice_dollar,
    ACTIONS(9698), 1,
      sym_quasiquote_start,
    STATE(2202), 1,
      sym__unboxed_open,
    STATE(7295), 1,
      sym_constructor,
    STATE(14836), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9674), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9689), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9665), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9671), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7412), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7485), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5030), 11,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2763), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [3485] = 29,
    ACTIONS(9701), 1,
      sym__varid,
    ACTIONS(9707), 1,
      sym__integer_literal,
    ACTIONS(9713), 1,
      anon_sym_LPAREN,
    ACTIONS(9715), 1,
      sym__conid,
    ACTIONS(9718), 1,
      anon_sym_LBRACK,
    ACTIONS(9720), 1,
      anon_sym_LBRACE,
    ACTIONS(9722), 1,
      anon_sym__,
    ACTIONS(9724), 1,
      anon_sym_7,
    ACTIONS(9726), 1,
      sym__splice_dollar,
    ACTIONS(9728), 1,
      sym_quasiquote_start,
    ACTIONS(9730), 1,
      sym__strict,
    ACTIONS(9732), 1,
      sym__lazy,
    STATE(350), 1,
      sym__unboxed_open,
    STATE(7601), 1,
      sym__pat_constructor,
    STATE(7661), 1,
      sym_constructor,
    STATE(7726), 1,
      sym_variable,
    STATE(7780), 1,
      sym_qualified_constructor,
    STATE(7820), 1,
      sym__qcon,
    STATE(7932), 1,
      sym_literal,
    STATE(12472), 1,
      sym_pat_fields,
    STATE(14862), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9711), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9705), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9709), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7924), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(9703), 9,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_EQ,
      anon_sym_RBRACE,
    STATE(2829), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [3607] = 22,
    ACTIONS(9734), 1,
      sym__varid,
    ACTIONS(9740), 1,
      sym__integer_literal,
    ACTIONS(9749), 1,
      anon_sym_LPAREN,
    ACTIONS(9752), 1,
      sym__conid,
    ACTIONS(9755), 1,
      anon_sym_LBRACK,
    ACTIONS(9758), 1,
      anon_sym_SQUOTE,
    ACTIONS(9764), 1,
      anon_sym_7,
    ACTIONS(9767), 1,
      sym__splice_dollar,
    ACTIONS(9770), 1,
      sym_quasiquote_start,
    STATE(2122), 1,
      sym__unboxed_open,
    STATE(7422), 1,
      sym_constructor,
    STATE(15142), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9746), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9761), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9737), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9743), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7627), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7693), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5030), 11,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
    STATE(2765), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [3715] = 33,
    ACTIONS(1795), 1,
      anon_sym_forall,
    ACTIONS(1797), 1,
      anon_sym_5,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5274), 1,
      sym__varid,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(9773), 1,
      anon_sym_LPAREN,
    ACTIONS(9775), 1,
      anon_sym_SQUOTE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2866), 1,
      sym_type_name,
    STATE(3194), 1,
      sym_forall,
    STATE(3412), 1,
      sym_context,
    STATE(7280), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(14283), 1,
      sym_type_infix,
    STATE(14339), 1,
      sym_constraint,
    STATE(14550), 1,
      sym__forall,
    STATE(14571), 1,
      sym__forall_kw,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9712), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [3845] = 22,
    ACTIONS(5411), 1,
      sym__integer_literal,
    ACTIONS(5423), 1,
      anon_sym_LBRACK,
    ACTIONS(5429), 1,
      anon_sym_7,
    ACTIONS(5431), 1,
      sym__splice_dollar,
    ACTIONS(5433), 1,
      sym_quasiquote_start,
    ACTIONS(9777), 1,
      sym__varid,
    ACTIONS(9779), 1,
      anon_sym_LPAREN,
    ACTIONS(9781), 1,
      sym__conid,
    ACTIONS(9784), 1,
      anon_sym_SQUOTE,
    STATE(2122), 1,
      sym__unboxed_open,
    STATE(7422), 1,
      sym_constructor,
    STATE(15142), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5415), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5427), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5409), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5413), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7627), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7693), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5078), 11,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
    STATE(2774), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [3953] = 23,
    ACTIONS(5134), 1,
      sym__integer_literal,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      sym__conid,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_SQUOTE,
    ACTIONS(5162), 1,
      anon_sym_7,
    ACTIONS(5165), 1,
      sym__splice_dollar,
    ACTIONS(5168), 1,
      sym_quasiquote_start,
    ACTIONS(5899), 1,
      sym__varid,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5143), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(5157), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5129), 9,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
    STATE(3268), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [4063] = 33,
    ACTIONS(1795), 1,
      anon_sym_forall,
    ACTIONS(1797), 1,
      anon_sym_5,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6002), 1,
      sym__varid,
    ACTIONS(6016), 1,
      sym__conid,
    ACTIONS(9787), 1,
      anon_sym_LPAREN,
    ACTIONS(9789), 1,
      anon_sym_SQUOTE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2840), 1,
      sym_type_name,
    STATE(3195), 1,
      sym_forall,
    STATE(3377), 1,
      sym_context,
    STATE(7295), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(14519), 1,
      sym_constraint,
    STATE(14547), 1,
      sym_type_infix,
    STATE(14550), 1,
      sym__forall,
    STATE(14571), 1,
      sym__forall_kw,
    STATE(14836), 1,
      aux_sym__qualifying_module,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9626), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7412), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [4193] = 28,
    ACTIONS(5278), 1,
      sym__integer_literal,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(5288), 1,
      anon_sym_LBRACK,
    ACTIONS(5290), 1,
      anon_sym_SQUOTE,
    ACTIONS(5294), 1,
      anon_sym_LBRACE,
    ACTIONS(5296), 1,
      anon_sym_7,
    ACTIONS(5298), 1,
      sym__splice_dollar,
    ACTIONS(5300), 1,
      sym_quasiquote_start,
    ACTIONS(5302), 1,
      sym__strict,
    ACTIONS(5304), 1,
      sym__lazy,
    ACTIONS(8171), 1,
      sym__varid,
    ACTIONS(9520), 1,
      anon_sym_LPAREN,
    STATE(2162), 1,
      sym__unboxed_open,
    STATE(7280), 1,
      sym_constructor,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(16960), 1,
      sym_record_fields,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5282), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5292), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8399), 2,
      sym_type_apply,
      sym__btype,
    STATE(16959), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5276), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13929), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2749), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [4313] = 24,
    ACTIONS(5126), 1,
      sym__varid,
    ACTIONS(5134), 1,
      sym__integer_literal,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      sym__conid,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_SQUOTE,
    ACTIONS(5160), 1,
      anon_sym_in,
    ACTIONS(5162), 1,
      anon_sym_7,
    ACTIONS(5165), 1,
      sym__splice_dollar,
    ACTIONS(5168), 1,
      sym_quasiquote_start,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5143), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(5157), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5129), 8,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(3268), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [4425] = 28,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5294), 1,
      anon_sym_LBRACE,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(5363), 1,
      sym__strict,
    ACTIONS(5365), 1,
      sym__lazy,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3928), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15613), 1,
      sym_record_fields,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(5856), 2,
      sym_type_apply,
      sym__btype,
    STATE(18147), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14224), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [4545] = 23,
    ACTIONS(5059), 1,
      anon_sym_in,
    ACTIONS(9791), 1,
      sym__varid,
    ACTIONS(9797), 1,
      sym__integer_literal,
    ACTIONS(9806), 1,
      anon_sym_LPAREN,
    ACTIONS(9809), 1,
      sym__conid,
    ACTIONS(9812), 1,
      anon_sym_LBRACK,
    ACTIONS(9815), 1,
      anon_sym_SQUOTE,
    ACTIONS(9821), 1,
      anon_sym_7,
    ACTIONS(9824), 1,
      sym__splice_dollar,
    ACTIONS(9827), 1,
      sym_quasiquote_start,
    STATE(2159), 1,
      sym__unboxed_open,
    STATE(7574), 1,
      sym_constructor,
    STATE(15052), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9803), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9818), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9794), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9800), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7606), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7609), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5030), 10,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2773), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [4655] = 22,
    ACTIONS(5411), 1,
      sym__integer_literal,
    ACTIONS(5423), 1,
      anon_sym_LBRACK,
    ACTIONS(5429), 1,
      anon_sym_7,
    ACTIONS(5431), 1,
      sym__splice_dollar,
    ACTIONS(5433), 1,
      sym_quasiquote_start,
    ACTIONS(9777), 1,
      sym__varid,
    ACTIONS(9779), 1,
      anon_sym_LPAREN,
    ACTIONS(9830), 1,
      sym__conid,
    ACTIONS(9833), 1,
      anon_sym_SQUOTE,
    STATE(2122), 1,
      sym__unboxed_open,
    STATE(7422), 1,
      sym_constructor,
    STATE(15142), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5415), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5427), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5409), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5413), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7627), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7693), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5177), 11,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
    STATE(2765), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [4763] = 23,
    ACTIONS(5185), 1,
      anon_sym_in,
    ACTIONS(7369), 1,
      sym__varid,
    ACTIONS(7373), 1,
      sym__integer_literal,
    ACTIONS(7385), 1,
      anon_sym_LBRACK,
    ACTIONS(7391), 1,
      anon_sym_7,
    ACTIONS(7393), 1,
      sym__splice_dollar,
    ACTIONS(7395), 1,
      sym_quasiquote_start,
    ACTIONS(9836), 1,
      anon_sym_LPAREN,
    ACTIONS(9838), 1,
      sym__conid,
    ACTIONS(9841), 1,
      anon_sym_SQUOTE,
    STATE(2159), 1,
      sym__unboxed_open,
    STATE(7574), 1,
      sym_constructor,
    STATE(15052), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7377), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7389), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(7371), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7375), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7606), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7609), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5177), 10,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2773), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [4873] = 33,
    ACTIONS(1795), 1,
      anon_sym_forall,
    ACTIONS(1797), 1,
      anon_sym_5,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(7229), 1,
      sym__varid,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(9844), 1,
      anon_sym_LPAREN,
    ACTIONS(9846), 1,
      anon_sym_SQUOTE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2827), 1,
      sym_type_name,
    STATE(3207), 1,
      sym_forall,
    STATE(3414), 1,
      sym_context,
    STATE(5969), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(13466), 1,
      sym_constraint,
    STATE(13961), 1,
      sym_type_infix,
    STATE(14550), 1,
      sym__forall,
    STATE(14571), 1,
      sym__forall_kw,
    STATE(15009), 1,
      aux_sym__qualifying_module,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9658), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6424), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [5003] = 33,
    ACTIONS(1795), 1,
      anon_sym_forall,
    ACTIONS(1797), 1,
      anon_sym_5,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6304), 1,
      sym__varid,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(9848), 1,
      anon_sym_LPAREN,
    ACTIONS(9850), 1,
      anon_sym_SQUOTE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2843), 1,
      sym_type_name,
    STATE(3191), 1,
      sym_forall,
    STATE(3344), 1,
      sym_context,
    STATE(6403), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(14431), 1,
      sym_type_infix,
    STATE(14550), 1,
      sym__forall,
    STATE(14556), 1,
      sym_constraint,
    STATE(14571), 1,
      sym__forall_kw,
    STATE(14854), 1,
      aux_sym__qualifying_module,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9675), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6680), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [5133] = 28,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5294), 1,
      anon_sym_LBRACE,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(5363), 1,
      sym__strict,
    ACTIONS(5365), 1,
      sym__lazy,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3928), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15609), 1,
      sym_record_fields,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(5856), 2,
      sym_type_apply,
      sym__btype,
    STATE(18228), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14224), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [5253] = 28,
    ACTIONS(5278), 1,
      sym__integer_literal,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(5288), 1,
      anon_sym_LBRACK,
    ACTIONS(5290), 1,
      anon_sym_SQUOTE,
    ACTIONS(5294), 1,
      anon_sym_LBRACE,
    ACTIONS(5296), 1,
      anon_sym_7,
    ACTIONS(5298), 1,
      sym__splice_dollar,
    ACTIONS(5300), 1,
      sym_quasiquote_start,
    ACTIONS(5302), 1,
      sym__strict,
    ACTIONS(5304), 1,
      sym__lazy,
    ACTIONS(8171), 1,
      sym__varid,
    ACTIONS(9520), 1,
      anon_sym_LPAREN,
    STATE(2162), 1,
      sym__unboxed_open,
    STATE(7280), 1,
      sym_constructor,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(17061), 1,
      sym_record_fields,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5282), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5292), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8399), 2,
      sym_type_apply,
      sym__btype,
    STATE(17060), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5276), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13929), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2749), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [5373] = 23,
    ACTIONS(5100), 1,
      anon_sym_in,
    ACTIONS(7369), 1,
      sym__varid,
    ACTIONS(7373), 1,
      sym__integer_literal,
    ACTIONS(7385), 1,
      anon_sym_LBRACK,
    ACTIONS(7391), 1,
      anon_sym_7,
    ACTIONS(7393), 1,
      sym__splice_dollar,
    ACTIONS(7395), 1,
      sym_quasiquote_start,
    ACTIONS(9836), 1,
      anon_sym_LPAREN,
    ACTIONS(9852), 1,
      sym__conid,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    STATE(2159), 1,
      sym__unboxed_open,
    STATE(7574), 1,
      sym_constructor,
    STATE(15052), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7377), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7389), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(7371), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7375), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7606), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7609), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5078), 10,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2775), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [5483] = 33,
    ACTIONS(1795), 1,
      anon_sym_forall,
    ACTIONS(1797), 1,
      anon_sym_5,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(7397), 1,
      sym__varid,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(9858), 1,
      anon_sym_LPAREN,
    ACTIONS(9860), 1,
      anon_sym_SQUOTE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      sym_type_name,
    STATE(3205), 1,
      sym_forall,
    STATE(3352), 1,
      sym_context,
    STATE(5968), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(13786), 1,
      sym_type_infix,
    STATE(13787), 1,
      sym_constraint,
    STATE(14550), 1,
      sym__forall,
    STATE(14571), 1,
      sym__forall_kw,
    STATE(14649), 1,
      aux_sym__qualifying_module,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9600), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6463), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [5613] = 33,
    ACTIONS(1795), 1,
      anon_sym_forall,
    ACTIONS(1797), 1,
      anon_sym_5,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5310), 1,
      anon_sym_LPAREN,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2969), 1,
      sym_type_name,
    STATE(3192), 1,
      sym_forall,
    STATE(3330), 1,
      sym_context,
    STATE(3928), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(14550), 1,
      sym__forall,
    STATE(14571), 1,
      sym__forall_kw,
    STATE(14714), 1,
      sym_type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15330), 1,
      sym_constraint,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9589), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [5743] = 32,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(9862), 1,
      anon_sym_LPAREN,
    ACTIONS(9864), 1,
      anon_sym_instance,
    STATE(2059), 1,
      sym_type_name,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(6317), 1,
      sym_constructor,
    STATE(12844), 1,
      sym_context,
    STATE(13052), 1,
      sym__context_newtype,
    STATE(13366), 1,
      sym__simpletype_infix,
    STATE(14685), 1,
      sym__simpletype,
    STATE(14714), 1,
      sym_type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(16836), 1,
      sym__context,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8119), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9589), 2,
      sym_type_apply,
      sym__btype,
    STATE(15456), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4017), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [5870] = 24,
    ACTIONS(5134), 1,
      sym__integer_literal,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      sym__conid,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_SQUOTE,
    ACTIONS(5160), 1,
      anon_sym_EQ,
    ACTIONS(5162), 1,
      anon_sym_7,
    ACTIONS(5165), 1,
      sym__splice_dollar,
    ACTIONS(5168), 1,
      sym_quasiquote_start,
    ACTIONS(5899), 1,
      sym__varid,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5143), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(5157), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5129), 7,
      sym__consym,
      sym__tyconsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
    STATE(3268), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [5981] = 22,
    ACTIONS(9866), 1,
      sym__varid,
    ACTIONS(9872), 1,
      sym__integer_literal,
    ACTIONS(9881), 1,
      anon_sym_LPAREN,
    ACTIONS(9884), 1,
      sym__conid,
    ACTIONS(9887), 1,
      anon_sym_LBRACK,
    ACTIONS(9890), 1,
      anon_sym_SQUOTE,
    ACTIONS(9896), 1,
      anon_sym_7,
    ACTIONS(9899), 1,
      sym__splice_dollar,
    ACTIONS(9902), 1,
      sym_quasiquote_start,
    STATE(2184), 1,
      sym__unboxed_open,
    STATE(7681), 1,
      sym_constructor,
    STATE(15120), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9878), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9893), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9869), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9875), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7705), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7706), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5030), 10,
      sym__consym,
      sym__tyconsym,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
    STATE(2785), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [6088] = 23,
    ACTIONS(9905), 1,
      sym__varid,
    ACTIONS(9911), 1,
      sym__integer_literal,
    ACTIONS(9920), 1,
      anon_sym_LPAREN,
    ACTIONS(9923), 1,
      sym__conid,
    ACTIONS(9926), 1,
      anon_sym_LBRACK,
    ACTIONS(9929), 1,
      anon_sym_SQUOTE,
    ACTIONS(9935), 1,
      anon_sym_7,
    ACTIONS(9938), 1,
      sym__splice_dollar,
    ACTIONS(9941), 1,
      sym_quasiquote_start,
    STATE(2213), 1,
      sym__unboxed_open,
    STATE(8141), 1,
      sym_constructor,
    STATE(14795), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9917), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9932), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5129), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(9908), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9914), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8196), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8354), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5143), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(3072), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [6197] = 22,
    ACTIONS(6143), 1,
      sym__integer_literal,
    ACTIONS(6155), 1,
      anon_sym_LBRACK,
    ACTIONS(6161), 1,
      anon_sym_7,
    ACTIONS(6163), 1,
      sym__splice_dollar,
    ACTIONS(6165), 1,
      sym_quasiquote_start,
    ACTIONS(9944), 1,
      sym__varid,
    ACTIONS(9946), 1,
      anon_sym_LPAREN,
    ACTIONS(9948), 1,
      sym__conid,
    ACTIONS(9951), 1,
      anon_sym_SQUOTE,
    STATE(2184), 1,
      sym__unboxed_open,
    STATE(7681), 1,
      sym_constructor,
    STATE(15120), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6147), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6159), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(6141), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6145), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7705), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7706), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5177), 10,
      sym__consym,
      sym__tyconsym,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
    STATE(2785), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [6304] = 23,
    ACTIONS(5134), 1,
      sym__integer_literal,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      sym__conid,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_SQUOTE,
    ACTIONS(5162), 1,
      anon_sym_7,
    ACTIONS(5165), 1,
      sym__splice_dollar,
    ACTIONS(5168), 1,
      sym_quasiquote_start,
    ACTIONS(5899), 1,
      sym__varid,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5143), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(5157), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5129), 8,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(3268), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [6413] = 29,
    ACTIONS(9954), 1,
      sym__varid,
    ACTIONS(9958), 1,
      sym__integer_literal,
    ACTIONS(9964), 1,
      anon_sym_LPAREN,
    ACTIONS(9966), 1,
      sym__conid,
    ACTIONS(9969), 1,
      anon_sym_LBRACK,
    ACTIONS(9971), 1,
      anon_sym_LBRACE,
    ACTIONS(9973), 1,
      anon_sym__,
    ACTIONS(9975), 1,
      anon_sym_7,
    ACTIONS(9977), 1,
      sym__splice_dollar,
    ACTIONS(9979), 1,
      sym_quasiquote_start,
    ACTIONS(9981), 1,
      sym__strict,
    ACTIONS(9983), 1,
      sym__lazy,
    STATE(392), 1,
      sym__unboxed_open,
    STATE(7727), 1,
      sym_constructor,
    STATE(7812), 1,
      sym__pat_constructor,
    STATE(7879), 1,
      sym_variable,
    STATE(7896), 1,
      sym__qcon,
    STATE(7923), 1,
      sym_qualified_constructor,
    STATE(7960), 1,
      sym_literal,
    STATE(12560), 1,
      sym_pat_fields,
    STATE(15107), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9962), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9956), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9960), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8048), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(9703), 8,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(2865), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [6534] = 29,
    ACTIONS(9985), 1,
      sym__varid,
    ACTIONS(9989), 1,
      sym__integer_literal,
    ACTIONS(9995), 1,
      anon_sym_LPAREN,
    ACTIONS(9997), 1,
      sym__conid,
    ACTIONS(10000), 1,
      anon_sym_LBRACK,
    ACTIONS(10002), 1,
      anon_sym_LBRACE,
    ACTIONS(10004), 1,
      anon_sym__,
    ACTIONS(10006), 1,
      anon_sym_7,
    ACTIONS(10008), 1,
      sym__splice_dollar,
    ACTIONS(10010), 1,
      sym_quasiquote_start,
    ACTIONS(10012), 1,
      sym__strict,
    ACTIONS(10014), 1,
      sym__lazy,
    STATE(244), 1,
      sym__unboxed_open,
    STATE(3918), 1,
      sym_constructor,
    STATE(4144), 1,
      sym_qualified_constructor,
    STATE(7785), 1,
      sym__pat_constructor,
    STATE(7891), 1,
      sym__qcon,
    STATE(7911), 1,
      sym_variable,
    STATE(8114), 1,
      sym_literal,
    STATE(12536), 1,
      sym_pat_fields,
    STATE(15129), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9993), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9987), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9991), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8149), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(9703), 8,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(2891), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [6655] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5312), 1,
      sym__conid,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5316), 1,
      sym__strict,
    ACTIONS(5318), 1,
      sym__lazy,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2375), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9510), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(14216), 3,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16372), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [6770] = 23,
    ACTIONS(10016), 1,
      sym__varid,
    ACTIONS(10022), 1,
      sym__integer_literal,
    ACTIONS(10031), 1,
      anon_sym_LPAREN,
    ACTIONS(10034), 1,
      sym__conid,
    ACTIONS(10037), 1,
      anon_sym_LBRACK,
    ACTIONS(10040), 1,
      anon_sym_SQUOTE,
    ACTIONS(10046), 1,
      anon_sym_7,
    ACTIONS(10049), 1,
      sym__splice_dollar,
    ACTIONS(10052), 1,
      sym_quasiquote_start,
    STATE(2109), 1,
      sym__unboxed_open,
    STATE(8025), 1,
      sym_constructor,
    STATE(14637), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10028), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10043), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5129), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(10019), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10025), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8274), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8316), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5143), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(3167), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [6879] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5312), 1,
      sym__conid,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5316), 1,
      sym__strict,
    ACTIONS(5318), 1,
      sym__lazy,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2375), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9510), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(13513), 3,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16372), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [6994] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5316), 1,
      sym__strict,
    ACTIONS(5318), 1,
      sym__lazy,
    ACTIONS(5371), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2419), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9510), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(13846), 3,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16124), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [7109] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5312), 1,
      sym__conid,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5316), 1,
      sym__strict,
    ACTIONS(5318), 1,
      sym__lazy,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2375), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9510), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(14174), 3,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16372), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [7224] = 32,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(9862), 1,
      anon_sym_LPAREN,
    ACTIONS(10055), 1,
      anon_sym_instance,
    STATE(2059), 1,
      sym_type_name,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(6317), 1,
      sym_constructor,
    STATE(12732), 1,
      sym__context_newtype,
    STATE(12844), 1,
      sym_context,
    STATE(13366), 1,
      sym__simpletype_infix,
    STATE(14685), 1,
      sym__simpletype,
    STATE(14714), 1,
      sym_type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(16836), 1,
      sym__context,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8119), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9589), 2,
      sym_type_apply,
      sym__btype,
    STATE(15456), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4017), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [7351] = 24,
    ACTIONS(10057), 1,
      sym__varid,
    ACTIONS(10063), 1,
      sym__integer_literal,
    ACTIONS(10072), 1,
      anon_sym_LPAREN,
    ACTIONS(10078), 1,
      sym__conid,
    ACTIONS(10081), 1,
      anon_sym_LBRACK,
    ACTIONS(10084), 1,
      anon_sym_SQUOTE,
    ACTIONS(10090), 1,
      anon_sym_7,
    ACTIONS(10093), 1,
      sym__splice_dollar,
    ACTIONS(10096), 1,
      sym_quasiquote_start,
    STATE(2173), 1,
      sym__unboxed_open,
    STATE(8883), 1,
      sym_constructor,
    STATE(14618), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5143), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(10069), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10075), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(10087), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10060), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10066), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9097), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9169), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5129), 6,
      sym__consym,
      sym__tyconsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(3317), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [7462] = 32,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(10099), 1,
      anon_sym_LPAREN,
    ACTIONS(10101), 1,
      anon_sym_family,
    ACTIONS(10103), 1,
      anon_sym_instance,
    STATE(2059), 1,
      sym_type_name,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(6227), 1,
      sym_constructor,
    STATE(10285), 1,
      sym__simpletype,
    STATE(13000), 1,
      sym_context,
    STATE(13047), 1,
      sym__simpletype_infix,
    STATE(14714), 1,
      sym_type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(16836), 1,
      sym__context,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7942), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9589), 2,
      sym_type_apply,
      sym__btype,
    STATE(15456), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4017), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [7589] = 22,
    ACTIONS(6046), 1,
      sym__integer_literal,
    ACTIONS(6058), 1,
      anon_sym_LBRACK,
    ACTIONS(6064), 1,
      anon_sym_7,
    ACTIONS(6066), 1,
      sym__splice_dollar,
    ACTIONS(6068), 1,
      sym_quasiquote_start,
    ACTIONS(10105), 1,
      sym__varid,
    ACTIONS(10107), 1,
      anon_sym_LPAREN,
    ACTIONS(10109), 1,
      sym__conid,
    ACTIONS(10112), 1,
      anon_sym_SQUOTE,
    STATE(2165), 1,
      sym__unboxed_open,
    STATE(7684), 1,
      sym_constructor,
    STATE(15161), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6050), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6062), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(6044), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6048), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7768), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7818), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5078), 10,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2810), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [7696] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5316), 1,
      sym__strict,
    ACTIONS(5318), 1,
      sym__lazy,
    ACTIONS(5359), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2445), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9510), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(14365), 3,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16310), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [7811] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5316), 1,
      sym__strict,
    ACTIONS(5318), 1,
      sym__lazy,
    ACTIONS(5371), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2419), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9510), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(14383), 3,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16124), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [7926] = 22,
    ACTIONS(6143), 1,
      sym__integer_literal,
    ACTIONS(6155), 1,
      anon_sym_LBRACK,
    ACTIONS(6161), 1,
      anon_sym_7,
    ACTIONS(6163), 1,
      sym__splice_dollar,
    ACTIONS(6165), 1,
      sym_quasiquote_start,
    ACTIONS(9944), 1,
      sym__varid,
    ACTIONS(9946), 1,
      anon_sym_LPAREN,
    ACTIONS(10115), 1,
      sym__conid,
    ACTIONS(10118), 1,
      anon_sym_SQUOTE,
    STATE(2184), 1,
      sym__unboxed_open,
    STATE(7681), 1,
      sym_constructor,
    STATE(15120), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6147), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6159), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(6141), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6145), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7705), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7706), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5078), 10,
      sym__consym,
      sym__tyconsym,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
    STATE(2787), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [8033] = 22,
    ACTIONS(10121), 1,
      sym__varid,
    ACTIONS(10127), 1,
      sym__integer_literal,
    ACTIONS(10136), 1,
      anon_sym_LPAREN,
    ACTIONS(10139), 1,
      sym__conid,
    ACTIONS(10142), 1,
      anon_sym_LBRACK,
    ACTIONS(10145), 1,
      anon_sym_SQUOTE,
    ACTIONS(10151), 1,
      anon_sym_7,
    ACTIONS(10154), 1,
      sym__splice_dollar,
    ACTIONS(10157), 1,
      sym_quasiquote_start,
    STATE(2165), 1,
      sym__unboxed_open,
    STATE(7684), 1,
      sym_constructor,
    STATE(15161), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10133), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10148), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10124), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10130), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7768), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7818), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5030), 10,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2803), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [8140] = 32,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(9862), 1,
      anon_sym_LPAREN,
    ACTIONS(10160), 1,
      anon_sym_family,
    ACTIONS(10162), 1,
      anon_sym_instance,
    STATE(2059), 1,
      sym_type_name,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(6317), 1,
      sym_constructor,
    STATE(10345), 1,
      sym__simpletype,
    STATE(13065), 1,
      sym_context,
    STATE(13366), 1,
      sym__simpletype_infix,
    STATE(14714), 1,
      sym_type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(16836), 1,
      sym__context,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8119), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9589), 2,
      sym_type_apply,
      sym__btype,
    STATE(15456), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4017), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [8267] = 23,
    ACTIONS(5134), 1,
      sym__integer_literal,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      sym__conid,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_SQUOTE,
    ACTIONS(5162), 1,
      anon_sym_7,
    ACTIONS(5165), 1,
      sym__splice_dollar,
    ACTIONS(5168), 1,
      sym_quasiquote_start,
    ACTIONS(5899), 1,
      sym__varid,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5143), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(5157), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5129), 8,
      sym__consym,
      sym__tyconsym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_PERCENT,
    STATE(3268), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [8376] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5316), 1,
      sym__strict,
    ACTIONS(5318), 1,
      sym__lazy,
    ACTIONS(5359), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2445), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9510), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(14289), 3,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16310), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [8491] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5316), 1,
      sym__strict,
    ACTIONS(5318), 1,
      sym__lazy,
    ACTIONS(5371), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2419), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9510), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(13398), 3,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16124), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [8606] = 32,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(10164), 1,
      anon_sym_LPAREN,
    ACTIONS(10166), 1,
      anon_sym_family,
    ACTIONS(10168), 1,
      anon_sym_instance,
    STATE(2059), 1,
      sym_type_name,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(5977), 1,
      sym_constructor,
    STATE(10300), 1,
      sym__simpletype,
    STATE(12745), 1,
      sym_context,
    STATE(12791), 1,
      sym__simpletype_infix,
    STATE(14714), 1,
      sym_type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(16836), 1,
      sym__context,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8139), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9589), 2,
      sym_type_apply,
      sym__btype,
    STATE(15456), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4017), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [8733] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5316), 1,
      sym__strict,
    ACTIONS(5318), 1,
      sym__lazy,
    ACTIONS(5359), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2445), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9510), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(14835), 3,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16310), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [8848] = 22,
    ACTIONS(6046), 1,
      sym__integer_literal,
    ACTIONS(6058), 1,
      anon_sym_LBRACK,
    ACTIONS(6064), 1,
      anon_sym_7,
    ACTIONS(6066), 1,
      sym__splice_dollar,
    ACTIONS(6068), 1,
      sym_quasiquote_start,
    ACTIONS(10105), 1,
      sym__varid,
    ACTIONS(10107), 1,
      anon_sym_LPAREN,
    ACTIONS(10170), 1,
      sym__conid,
    ACTIONS(10173), 1,
      anon_sym_SQUOTE,
    STATE(2165), 1,
      sym__unboxed_open,
    STATE(7684), 1,
      sym_constructor,
    STATE(15161), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6050), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6062), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(6044), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6048), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7768), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7818), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5177), 10,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PERCENT,
    STATE(2803), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [8955] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5316), 1,
      sym__strict,
    ACTIONS(5318), 1,
      sym__lazy,
    ACTIONS(5359), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2445), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9510), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(14770), 3,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16310), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [9070] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5316), 1,
      sym__strict,
    ACTIONS(5318), 1,
      sym__lazy,
    ACTIONS(5371), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2419), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9510), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(14246), 3,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16124), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [9185] = 32,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(9862), 1,
      anon_sym_LPAREN,
    ACTIONS(10176), 1,
      anon_sym_instance,
    STATE(2059), 1,
      sym_type_name,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(6317), 1,
      sym_constructor,
    STATE(12844), 1,
      sym_context,
    STATE(12986), 1,
      sym__context_newtype,
    STATE(13366), 1,
      sym__simpletype_infix,
    STATE(14685), 1,
      sym__simpletype,
    STATE(14714), 1,
      sym_type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(16836), 1,
      sym__context,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8119), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9589), 2,
      sym_type_apply,
      sym__btype,
    STATE(15456), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4017), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [9312] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5312), 1,
      sym__conid,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5316), 1,
      sym__strict,
    ACTIONS(5318), 1,
      sym__lazy,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2375), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9510), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(13577), 3,
      sym_data_constructor,
      sym_data_constructor_infix,
      sym_data_constructor_record,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(16372), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [9427] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(5363), 1,
      sym__strict,
    ACTIONS(5365), 1,
      sym__lazy,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3928), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(5856), 2,
      sym_type_apply,
      sym__btype,
    STATE(18143), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14224), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [9541] = 23,
    ACTIONS(10178), 1,
      sym__varid,
    ACTIONS(10184), 1,
      sym__integer_literal,
    ACTIONS(10193), 1,
      anon_sym_LPAREN,
    ACTIONS(10196), 1,
      sym__conid,
    ACTIONS(10199), 1,
      anon_sym_LBRACK,
    ACTIONS(10202), 1,
      anon_sym_SQUOTE,
    ACTIONS(10208), 1,
      anon_sym_7,
    ACTIONS(10211), 1,
      sym__splice_dollar,
    ACTIONS(10214), 1,
      sym_quasiquote_start,
    STATE(2182), 1,
      sym__unboxed_open,
    STATE(8210), 1,
      sym_constructor,
    STATE(14724), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10190), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10205), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5129), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(10181), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10187), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8643), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8646), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5143), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_RBRACE,
    STATE(3193), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [9649] = 26,
    ACTIONS(5278), 1,
      sym__integer_literal,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(5288), 1,
      anon_sym_LBRACK,
    ACTIONS(5290), 1,
      anon_sym_SQUOTE,
    ACTIONS(5296), 1,
      anon_sym_7,
    ACTIONS(5298), 1,
      sym__splice_dollar,
    ACTIONS(5300), 1,
      sym_quasiquote_start,
    ACTIONS(5302), 1,
      sym__strict,
    ACTIONS(5304), 1,
      sym__lazy,
    ACTIONS(8171), 1,
      sym__varid,
    ACTIONS(9520), 1,
      anon_sym_LPAREN,
    STATE(2162), 1,
      sym__unboxed_open,
    STATE(7280), 1,
      sym_constructor,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5282), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5292), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8399), 2,
      sym_type_apply,
      sym__btype,
    STATE(16935), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5276), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13929), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2749), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [9763] = 23,
    ACTIONS(10217), 1,
      sym__varid,
    ACTIONS(10223), 1,
      sym__integer_literal,
    ACTIONS(10232), 1,
      anon_sym_LPAREN,
    ACTIONS(10235), 1,
      sym__conid,
    ACTIONS(10238), 1,
      anon_sym_LBRACK,
    ACTIONS(10241), 1,
      anon_sym_SQUOTE,
    ACTIONS(10247), 1,
      anon_sym_7,
    ACTIONS(10250), 1,
      sym__splice_dollar,
    ACTIONS(10253), 1,
      sym_quasiquote_start,
    STATE(2206), 1,
      sym__unboxed_open,
    STATE(8344), 1,
      sym_constructor,
    STATE(15347), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10229), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10244), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5129), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(10220), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10226), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8491), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8702), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5143), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
    STATE(3183), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [9871] = 26,
    ACTIONS(5278), 1,
      sym__integer_literal,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(5288), 1,
      anon_sym_LBRACK,
    ACTIONS(5290), 1,
      anon_sym_SQUOTE,
    ACTIONS(5296), 1,
      anon_sym_7,
    ACTIONS(5298), 1,
      sym__splice_dollar,
    ACTIONS(5300), 1,
      sym_quasiquote_start,
    ACTIONS(5302), 1,
      sym__strict,
    ACTIONS(5304), 1,
      sym__lazy,
    ACTIONS(8171), 1,
      sym__varid,
    ACTIONS(9520), 1,
      anon_sym_LPAREN,
    STATE(2162), 1,
      sym__unboxed_open,
    STATE(7280), 1,
      sym_constructor,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5282), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5292), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8399), 2,
      sym_type_apply,
      sym__btype,
    STATE(16957), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5276), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13929), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2749), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [9985] = 26,
    ACTIONS(5278), 1,
      sym__integer_literal,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(5288), 1,
      anon_sym_LBRACK,
    ACTIONS(5290), 1,
      anon_sym_SQUOTE,
    ACTIONS(5296), 1,
      anon_sym_7,
    ACTIONS(5298), 1,
      sym__splice_dollar,
    ACTIONS(5300), 1,
      sym_quasiquote_start,
    ACTIONS(5302), 1,
      sym__strict,
    ACTIONS(5304), 1,
      sym__lazy,
    ACTIONS(8171), 1,
      sym__varid,
    ACTIONS(9520), 1,
      anon_sym_LPAREN,
    STATE(2162), 1,
      sym__unboxed_open,
    STATE(7280), 1,
      sym_constructor,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5282), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5292), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8399), 2,
      sym_type_apply,
      sym__btype,
    STATE(16959), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5276), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13929), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2749), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [10099] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(5363), 1,
      sym__strict,
    ACTIONS(5365), 1,
      sym__lazy,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3928), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(5856), 2,
      sym_type_apply,
      sym__btype,
    STATE(18147), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14224), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [10213] = 26,
    ACTIONS(5278), 1,
      sym__integer_literal,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(5288), 1,
      anon_sym_LBRACK,
    ACTIONS(5290), 1,
      anon_sym_SQUOTE,
    ACTIONS(5296), 1,
      anon_sym_7,
    ACTIONS(5298), 1,
      sym__splice_dollar,
    ACTIONS(5300), 1,
      sym_quasiquote_start,
    ACTIONS(5302), 1,
      sym__strict,
    ACTIONS(5304), 1,
      sym__lazy,
    ACTIONS(8171), 1,
      sym__varid,
    ACTIONS(9520), 1,
      anon_sym_LPAREN,
    STATE(2162), 1,
      sym__unboxed_open,
    STATE(7280), 1,
      sym_constructor,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5282), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5292), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8399), 2,
      sym_type_apply,
      sym__btype,
    STATE(16936), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5276), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13929), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2749), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [10327] = 25,
    ACTIONS(6272), 1,
      sym__strict,
    ACTIONS(6274), 1,
      sym__lazy,
    ACTIONS(10256), 1,
      sym__varid,
    ACTIONS(10262), 1,
      sym__integer_literal,
    ACTIONS(10268), 1,
      anon_sym_LPAREN,
    ACTIONS(10270), 1,
      sym__conid,
    ACTIONS(10272), 1,
      anon_sym_LBRACK,
    ACTIONS(10274), 1,
      anon_sym_SQUOTE,
    ACTIONS(10278), 1,
      anon_sym_deriving,
    ACTIONS(10280), 1,
      anon_sym_7,
    ACTIONS(10282), 1,
      sym__splice_dollar,
    ACTIONS(10284), 1,
      sym_quasiquote_start,
    STATE(2164), 1,
      sym__unboxed_open,
    STATE(8075), 1,
      sym_constructor,
    STATE(15062), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10266), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10276), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10260), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10264), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10258), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(8351), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8355), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2828), 17,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_strict_type,
      sym_lazy_type,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_data_constructor_repeat1,
  [10439] = 25,
    ACTIONS(7036), 1,
      sym__strict,
    ACTIONS(7038), 1,
      sym__lazy,
    ACTIONS(10278), 1,
      anon_sym_deriving,
    ACTIONS(10286), 1,
      sym__varid,
    ACTIONS(10290), 1,
      sym__integer_literal,
    ACTIONS(10296), 1,
      anon_sym_LPAREN,
    ACTIONS(10298), 1,
      sym__conid,
    ACTIONS(10300), 1,
      anon_sym_LBRACK,
    ACTIONS(10302), 1,
      anon_sym_SQUOTE,
    ACTIONS(10306), 1,
      anon_sym_7,
    ACTIONS(10308), 1,
      sym__splice_dollar,
    ACTIONS(10310), 1,
      sym_quasiquote_start,
    STATE(2180), 1,
      sym__unboxed_open,
    STATE(8056), 1,
      sym_constructor,
    STATE(14820), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10294), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10304), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10288), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10292), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10258), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(8348), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8353), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2832), 17,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_strict_type,
      sym_lazy_type,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_data_constructor_repeat1,
  [10551] = 29,
    ACTIONS(10312), 1,
      sym__varid,
    ACTIONS(10316), 1,
      sym__integer_literal,
    ACTIONS(10322), 1,
      anon_sym_LPAREN,
    ACTIONS(10324), 1,
      sym__conid,
    ACTIONS(10327), 1,
      anon_sym_LBRACK,
    ACTIONS(10329), 1,
      anon_sym_LBRACE,
    ACTIONS(10331), 1,
      anon_sym__,
    ACTIONS(10333), 1,
      anon_sym_7,
    ACTIONS(10335), 1,
      sym__splice_dollar,
    ACTIONS(10337), 1,
      sym_quasiquote_start,
    ACTIONS(10339), 1,
      sym__strict,
    ACTIONS(10341), 1,
      sym__lazy,
    STATE(461), 1,
      sym__unboxed_open,
    STATE(7889), 1,
      sym_constructor,
    STATE(7930), 1,
      sym__pat_constructor,
    STATE(8054), 1,
      sym_qualified_constructor,
    STATE(8069), 1,
      sym_variable,
    STATE(8070), 1,
      sym__qcon,
    STATE(8364), 1,
      sym_literal,
    STATE(13014), 1,
      sym_pat_fields,
    STATE(14874), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10320), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10314), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10318), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8245), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(9703), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(2928), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [10671] = 27,
    ACTIONS(10343), 1,
      sym__varid,
    ACTIONS(10351), 1,
      sym__integer_literal,
    ACTIONS(10360), 1,
      anon_sym_LPAREN,
    ACTIONS(10363), 1,
      sym__conid,
    ACTIONS(10366), 1,
      anon_sym_LBRACK,
    ACTIONS(10369), 1,
      anon_sym__,
    ACTIONS(10372), 1,
      anon_sym_7,
    ACTIONS(10375), 1,
      sym__splice_dollar,
    ACTIONS(10378), 1,
      sym_quasiquote_start,
    ACTIONS(10381), 1,
      sym__strict,
    ACTIONS(10384), 1,
      sym__lazy,
    STATE(350), 1,
      sym__unboxed_open,
    STATE(7601), 1,
      sym__pat_constructor,
    STATE(7661), 1,
      sym_constructor,
    STATE(7726), 1,
      sym_variable,
    STATE(7780), 1,
      sym_qualified_constructor,
    STATE(7820), 1,
      sym__qcon,
    STATE(7932), 1,
      sym_literal,
    STATE(14862), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10357), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10348), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10354), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7924), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10346), 9,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_EQ,
      anon_sym_RBRACE,
    STATE(2826), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [10787] = 23,
    ACTIONS(10387), 1,
      sym__varid,
    ACTIONS(10393), 1,
      sym__integer_literal,
    ACTIONS(10402), 1,
      anon_sym_LPAREN,
    ACTIONS(10405), 1,
      sym__conid,
    ACTIONS(10408), 1,
      anon_sym_LBRACK,
    ACTIONS(10411), 1,
      anon_sym_SQUOTE,
    ACTIONS(10417), 1,
      anon_sym_7,
    ACTIONS(10420), 1,
      sym__splice_dollar,
    ACTIONS(10423), 1,
      sym_quasiquote_start,
    STATE(2218), 1,
      sym__unboxed_open,
    STATE(8241), 1,
      sym_constructor,
    STATE(14853), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10399), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10414), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5129), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(10390), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10396), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8426), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8616), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5143), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
    STATE(3185), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [10895] = 25,
    ACTIONS(10426), 1,
      sym__varid,
    ACTIONS(10434), 1,
      sym__integer_literal,
    ACTIONS(10443), 1,
      anon_sym_LPAREN,
    ACTIONS(10446), 1,
      sym__conid,
    ACTIONS(10449), 1,
      anon_sym_LBRACK,
    ACTIONS(10452), 1,
      anon_sym_SQUOTE,
    ACTIONS(10458), 1,
      anon_sym_deriving,
    ACTIONS(10460), 1,
      anon_sym_7,
    ACTIONS(10463), 1,
      sym__splice_dollar,
    ACTIONS(10466), 1,
      sym_quasiquote_start,
    ACTIONS(10469), 1,
      sym__strict,
    ACTIONS(10472), 1,
      sym__lazy,
    STATE(2164), 1,
      sym__unboxed_open,
    STATE(8075), 1,
      sym_constructor,
    STATE(15062), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10440), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10455), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10431), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10437), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(8351), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8355), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2828), 17,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_strict_type,
      sym_lazy_type,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_data_constructor_repeat1,
  [11007] = 27,
    ACTIONS(9701), 1,
      sym__varid,
    ACTIONS(9707), 1,
      sym__integer_literal,
    ACTIONS(9713), 1,
      anon_sym_LPAREN,
    ACTIONS(9718), 1,
      anon_sym_LBRACK,
    ACTIONS(9722), 1,
      anon_sym__,
    ACTIONS(9724), 1,
      anon_sym_7,
    ACTIONS(9726), 1,
      sym__splice_dollar,
    ACTIONS(9728), 1,
      sym_quasiquote_start,
    ACTIONS(9730), 1,
      sym__strict,
    ACTIONS(9732), 1,
      sym__lazy,
    ACTIONS(10477), 1,
      sym__conid,
    STATE(350), 1,
      sym__unboxed_open,
    STATE(7601), 1,
      sym__pat_constructor,
    STATE(7661), 1,
      sym_constructor,
    STATE(7726), 1,
      sym_variable,
    STATE(7780), 1,
      sym_qualified_constructor,
    STATE(7820), 1,
      sym__qcon,
    STATE(7932), 1,
      sym_literal,
    STATE(14862), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9711), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9705), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9709), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7924), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10475), 9,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_EQ,
      anon_sym_RBRACE,
    STATE(2826), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [11123] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(5363), 1,
      sym__strict,
    ACTIONS(5365), 1,
      sym__lazy,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3928), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(5856), 2,
      sym_type_apply,
      sym__btype,
    STATE(18131), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14224), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [11237] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(5363), 1,
      sym__strict,
    ACTIONS(5365), 1,
      sym__lazy,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3928), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(5856), 2,
      sym_type_apply,
      sym__btype,
    STATE(18132), 2,
      sym__gadt_fun,
      sym__gadt_sig,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14224), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [11351] = 25,
    ACTIONS(10458), 1,
      anon_sym_deriving,
    ACTIONS(10480), 1,
      sym__varid,
    ACTIONS(10486), 1,
      sym__integer_literal,
    ACTIONS(10495), 1,
      anon_sym_LPAREN,
    ACTIONS(10498), 1,
      sym__conid,
    ACTIONS(10501), 1,
      anon_sym_LBRACK,
    ACTIONS(10504), 1,
      anon_sym_SQUOTE,
    ACTIONS(10510), 1,
      anon_sym_7,
    ACTIONS(10513), 1,
      sym__splice_dollar,
    ACTIONS(10516), 1,
      sym_quasiquote_start,
    ACTIONS(10519), 1,
      sym__strict,
    ACTIONS(10522), 1,
      sym__lazy,
    STATE(2180), 1,
      sym__unboxed_open,
    STATE(8056), 1,
      sym_constructor,
    STATE(14820), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10492), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10507), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10483), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10489), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10429), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(8348), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8353), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2832), 17,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_strict_type,
      sym_lazy_type,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_data_constructor_repeat1,
  [11463] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10527), 1,
      anon_sym_SEMI,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10545), 1,
      anon_sym_RBRACE,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16020), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [11586] = 31,
    ACTIONS(661), 1,
      anon_sym__,
    ACTIONS(673), 1,
      sym__strict,
    ACTIONS(675), 1,
      sym__lazy,
    ACTIONS(10559), 1,
      sym__varid,
    ACTIONS(10563), 1,
      sym__integer_literal,
    ACTIONS(10569), 1,
      anon_sym_DASH,
    ACTIONS(10571), 1,
      anon_sym_LPAREN,
    ACTIONS(10573), 1,
      sym__conid,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    ACTIONS(10577), 1,
      anon_sym_7,
    ACTIONS(10579), 1,
      sym__splice_dollar,
    ACTIONS(10581), 1,
      sym_quasiquote_start,
    STATE(366), 1,
      sym__unboxed_open,
    STATE(2764), 1,
      sym__pat_constructor,
    STATE(7663), 1,
      sym_constructor,
    STATE(7780), 1,
      sym_qualified_constructor,
    STATE(7820), 1,
      sym__qcon,
    STATE(12024), 1,
      sym_variable,
    STATE(12264), 1,
      sym_literal,
    STATE(14862), 1,
      aux_sym__qualifying_module,
    STATE(16809), 1,
      sym__pattern_arrow,
    STATE(16810), 1,
      sym__pattern_equals,
    STATE(16811), 1,
      sym__pattern_type,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10567), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15037), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10561), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12470), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10062), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [11709] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10583), 1,
      anon_sym_SEMI,
    ACTIONS(10585), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16814), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [11832] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10587), 1,
      anon_sym_SEMI,
    ACTIONS(10589), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16168), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [11955] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10591), 1,
      anon_sym_SEMI,
    ACTIONS(10593), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15513), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [12078] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10595), 1,
      anon_sym_SEMI,
    ACTIONS(10597), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17521), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [12201] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10599), 1,
      anon_sym_SEMI,
    ACTIONS(10601), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17595), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13823), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [12324] = 23,
    ACTIONS(10603), 1,
      sym__varid,
    ACTIONS(10609), 1,
      sym__integer_literal,
    ACTIONS(10618), 1,
      anon_sym_LPAREN,
    ACTIONS(10621), 1,
      sym__conid,
    ACTIONS(10624), 1,
      anon_sym_LBRACK,
    ACTIONS(10627), 1,
      anon_sym_SQUOTE,
    ACTIONS(10633), 1,
      anon_sym_7,
    ACTIONS(10636), 1,
      sym__splice_dollar,
    ACTIONS(10639), 1,
      sym_quasiquote_start,
    STATE(2098), 1,
      sym__unboxed_open,
    STATE(8614), 1,
      sym_constructor,
    STATE(14977), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10615), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10630), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5129), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(10606), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10612), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5143), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
    STATE(8732), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8836), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(3253), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [12431] = 27,
    ACTIONS(10642), 1,
      sym__varid,
    ACTIONS(10648), 1,
      sym__integer_literal,
    ACTIONS(10657), 1,
      anon_sym_LPAREN,
    ACTIONS(10660), 1,
      sym__conid,
    ACTIONS(10663), 1,
      anon_sym_LBRACK,
    ACTIONS(10666), 1,
      anon_sym__,
    ACTIONS(10669), 1,
      anon_sym_7,
    ACTIONS(10672), 1,
      sym__splice_dollar,
    ACTIONS(10675), 1,
      sym_quasiquote_start,
    ACTIONS(10678), 1,
      sym__strict,
    ACTIONS(10681), 1,
      sym__lazy,
    STATE(392), 1,
      sym__unboxed_open,
    STATE(7727), 1,
      sym_constructor,
    STATE(7812), 1,
      sym__pat_constructor,
    STATE(7879), 1,
      sym_variable,
    STATE(7896), 1,
      sym__qcon,
    STATE(7923), 1,
      sym_qualified_constructor,
    STATE(7960), 1,
      sym_literal,
    STATE(15107), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10654), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10645), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10651), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8048), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10346), 8,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(2841), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [12546] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10684), 1,
      anon_sym_SEMI,
    ACTIONS(10686), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15693), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [12669] = 23,
    ACTIONS(10688), 1,
      sym__varid,
    ACTIONS(10694), 1,
      sym__integer_literal,
    ACTIONS(10703), 1,
      anon_sym_LPAREN,
    ACTIONS(10706), 1,
      sym__conid,
    ACTIONS(10709), 1,
      anon_sym_LBRACK,
    ACTIONS(10712), 1,
      anon_sym_SQUOTE,
    ACTIONS(10718), 1,
      anon_sym_7,
    ACTIONS(10721), 1,
      sym__splice_dollar,
    ACTIONS(10724), 1,
      sym_quasiquote_start,
    STATE(2189), 1,
      sym__unboxed_open,
    STATE(8427), 1,
      sym_constructor,
    STATE(14776), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10700), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10715), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5129), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(10691), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10697), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5143), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
    STATE(8904), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8989), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3231), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [12776] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10727), 1,
      anon_sym_SEMI,
    ACTIONS(10729), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15825), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [12899] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10731), 1,
      anon_sym_SEMI,
    ACTIONS(10733), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16358), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13022] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10735), 1,
      anon_sym_SEMI,
    ACTIONS(10737), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16950), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13145] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10739), 1,
      anon_sym_SEMI,
    ACTIONS(10741), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16131), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13268] = 23,
    ACTIONS(5059), 1,
      anon_sym_deriving,
    ACTIONS(10743), 1,
      sym__varid,
    ACTIONS(10749), 1,
      sym__integer_literal,
    ACTIONS(10758), 1,
      anon_sym_LPAREN,
    ACTIONS(10761), 1,
      sym__conid,
    ACTIONS(10764), 1,
      anon_sym_LBRACK,
    ACTIONS(10767), 1,
      anon_sym_SQUOTE,
    ACTIONS(10773), 1,
      anon_sym_7,
    ACTIONS(10776), 1,
      sym__splice_dollar,
    ACTIONS(10779), 1,
      sym_quasiquote_start,
    STATE(2146), 1,
      sym__unboxed_open,
    STATE(7937), 1,
      sym_constructor,
    STATE(15334), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10755), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10770), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10746), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10752), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7988), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7989), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5030), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(2848), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [13375] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10782), 1,
      anon_sym_SEMI,
    ACTIONS(10784), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15589), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13823), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13498] = 29,
    ACTIONS(10786), 1,
      sym__varid,
    ACTIONS(10790), 1,
      sym__integer_literal,
    ACTIONS(10796), 1,
      anon_sym_LPAREN,
    ACTIONS(10798), 1,
      sym__conid,
    ACTIONS(10801), 1,
      anon_sym_LBRACK,
    ACTIONS(10803), 1,
      anon_sym_LBRACE,
    ACTIONS(10805), 1,
      anon_sym__,
    ACTIONS(10807), 1,
      anon_sym_7,
    ACTIONS(10809), 1,
      sym__splice_dollar,
    ACTIONS(10811), 1,
      sym_quasiquote_start,
    ACTIONS(10813), 1,
      sym__strict,
    ACTIONS(10815), 1,
      sym__lazy,
    STATE(354), 1,
      sym__unboxed_open,
    STATE(8041), 1,
      sym_constructor,
    STATE(8112), 1,
      sym__pat_constructor,
    STATE(8277), 1,
      sym_variable,
    STATE(8307), 1,
      sym_qualified_constructor,
    STATE(8383), 1,
      sym__qcon,
    STATE(8429), 1,
      sym_literal,
    STATE(13380), 1,
      sym_pat_fields,
    STATE(14715), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10794), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10788), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10792), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8662), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(9703), 6,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    STATE(3182), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [13617] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10817), 1,
      anon_sym_SEMI,
    ACTIONS(10819), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17197), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13740] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10821), 1,
      anon_sym_SEMI,
    ACTIONS(10823), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16451), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13863] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10825), 1,
      anon_sym_SEMI,
    ACTIONS(10827), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15978), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [13986] = 29,
    ACTIONS(10829), 1,
      sym__varid,
    ACTIONS(10833), 1,
      sym__integer_literal,
    ACTIONS(10839), 1,
      anon_sym_LPAREN,
    ACTIONS(10841), 1,
      sym__conid,
    ACTIONS(10844), 1,
      anon_sym_LBRACK,
    ACTIONS(10846), 1,
      anon_sym_LBRACE,
    ACTIONS(10848), 1,
      anon_sym__,
    ACTIONS(10850), 1,
      anon_sym_7,
    ACTIONS(10852), 1,
      sym__splice_dollar,
    ACTIONS(10854), 1,
      sym_quasiquote_start,
    ACTIONS(10856), 1,
      sym__strict,
    ACTIONS(10858), 1,
      sym__lazy,
    STATE(417), 1,
      sym__unboxed_open,
    STATE(8050), 1,
      sym__pat_constructor,
    STATE(8096), 1,
      sym_constructor,
    STATE(8157), 1,
      sym_variable,
    STATE(8280), 1,
      sym__qcon,
    STATE(8294), 1,
      sym_qualified_constructor,
    STATE(8722), 1,
      sym_literal,
    STATE(13238), 1,
      sym_pat_fields,
    STATE(15081), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10837), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10831), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10835), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8434), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(9703), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(3190), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [14105] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10860), 1,
      anon_sym_SEMI,
    ACTIONS(10862), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15883), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [14228] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10864), 1,
      anon_sym_SEMI,
    ACTIONS(10866), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15945), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [14351] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10868), 1,
      anon_sym_SEMI,
    ACTIONS(10870), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15852), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [14474] = 23,
    ACTIONS(5185), 1,
      anon_sym_deriving,
    ACTIONS(10872), 1,
      sym__varid,
    ACTIONS(10876), 1,
      sym__integer_literal,
    ACTIONS(10882), 1,
      anon_sym_LPAREN,
    ACTIONS(10884), 1,
      sym__conid,
    ACTIONS(10887), 1,
      anon_sym_LBRACK,
    ACTIONS(10889), 1,
      anon_sym_SQUOTE,
    ACTIONS(10894), 1,
      anon_sym_7,
    ACTIONS(10896), 1,
      sym__splice_dollar,
    ACTIONS(10898), 1,
      sym_quasiquote_start,
    STATE(2130), 1,
      sym__unboxed_open,
    STATE(7915), 1,
      sym_constructor,
    STATE(15326), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10880), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10892), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10874), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10878), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8066), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8094), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5177), 7,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(2899), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [14581] = 23,
    ACTIONS(5100), 1,
      anon_sym_deriving,
    ACTIONS(10872), 1,
      sym__varid,
    ACTIONS(10876), 1,
      sym__integer_literal,
    ACTIONS(10882), 1,
      anon_sym_LPAREN,
    ACTIONS(10887), 1,
      anon_sym_LBRACK,
    ACTIONS(10894), 1,
      anon_sym_7,
    ACTIONS(10896), 1,
      sym__splice_dollar,
    ACTIONS(10898), 1,
      sym_quasiquote_start,
    ACTIONS(10900), 1,
      sym__conid,
    ACTIONS(10903), 1,
      anon_sym_SQUOTE,
    STATE(2130), 1,
      sym__unboxed_open,
    STATE(7915), 1,
      sym_constructor,
    STATE(15326), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10880), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10892), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10874), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10878), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8066), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8094), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5078), 7,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(2858), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [14688] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10906), 1,
      anon_sym_SEMI,
    ACTIONS(10908), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15788), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [14811] = 31,
    ACTIONS(661), 1,
      anon_sym__,
    ACTIONS(673), 1,
      sym__strict,
    ACTIONS(675), 1,
      sym__lazy,
    ACTIONS(10559), 1,
      sym__varid,
    ACTIONS(10563), 1,
      sym__integer_literal,
    ACTIONS(10569), 1,
      anon_sym_DASH,
    ACTIONS(10573), 1,
      sym__conid,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    ACTIONS(10577), 1,
      anon_sym_7,
    ACTIONS(10579), 1,
      sym__splice_dollar,
    ACTIONS(10581), 1,
      sym_quasiquote_start,
    ACTIONS(10910), 1,
      anon_sym_LPAREN,
    STATE(366), 1,
      sym__unboxed_open,
    STATE(2764), 1,
      sym__pat_constructor,
    STATE(7625), 1,
      sym_constructor,
    STATE(7780), 1,
      sym_qualified_constructor,
    STATE(7820), 1,
      sym__qcon,
    STATE(12024), 1,
      sym_variable,
    STATE(12264), 1,
      sym_literal,
    STATE(14862), 1,
      aux_sym__qualifying_module,
    STATE(18084), 1,
      sym__pattern_arrow,
    STATE(18085), 1,
      sym__pattern_equals,
    STATE(18086), 1,
      sym__pattern_type,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10567), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14871), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10561), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12470), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10062), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [14934] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10912), 1,
      anon_sym_SEMI,
    ACTIONS(10914), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15767), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13823), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [15057] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10916), 1,
      anon_sym_SEMI,
    ACTIONS(10918), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15686), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [15180] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10920), 1,
      anon_sym_SEMI,
    ACTIONS(10922), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17432), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [15303] = 27,
    ACTIONS(9954), 1,
      sym__varid,
    ACTIONS(9958), 1,
      sym__integer_literal,
    ACTIONS(9964), 1,
      anon_sym_LPAREN,
    ACTIONS(9969), 1,
      anon_sym_LBRACK,
    ACTIONS(9973), 1,
      anon_sym__,
    ACTIONS(9975), 1,
      anon_sym_7,
    ACTIONS(9977), 1,
      sym__splice_dollar,
    ACTIONS(9979), 1,
      sym_quasiquote_start,
    ACTIONS(9981), 1,
      sym__strict,
    ACTIONS(9983), 1,
      sym__lazy,
    ACTIONS(10924), 1,
      sym__conid,
    STATE(392), 1,
      sym__unboxed_open,
    STATE(7727), 1,
      sym_constructor,
    STATE(7812), 1,
      sym__pat_constructor,
    STATE(7879), 1,
      sym_variable,
    STATE(7896), 1,
      sym__qcon,
    STATE(7923), 1,
      sym_qualified_constructor,
    STATE(7960), 1,
      sym_literal,
    STATE(15107), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9962), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9956), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9960), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8048), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10475), 8,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(2841), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [15418] = 23,
    ACTIONS(10927), 1,
      sym__varid,
    ACTIONS(10933), 1,
      sym__integer_literal,
    ACTIONS(10942), 1,
      anon_sym_LPAREN,
    ACTIONS(10945), 1,
      sym__conid,
    ACTIONS(10948), 1,
      anon_sym_LBRACK,
    ACTIONS(10951), 1,
      anon_sym_SQUOTE,
    ACTIONS(10957), 1,
      anon_sym_7,
    ACTIONS(10960), 1,
      sym__splice_dollar,
    ACTIONS(10963), 1,
      sym_quasiquote_start,
    STATE(2208), 1,
      sym__unboxed_open,
    STATE(8551), 1,
      sym_constructor,
    STATE(14954), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10939), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10954), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5129), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(10930), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10936), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5143), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
    STATE(8773), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8809), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3252), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [15525] = 25,
    ACTIONS(7554), 1,
      sym__strict,
    ACTIONS(7556), 1,
      sym__lazy,
    ACTIONS(10278), 1,
      anon_sym_deriving,
    ACTIONS(10966), 1,
      sym__varid,
    ACTIONS(10970), 1,
      sym__integer_literal,
    ACTIONS(10976), 1,
      anon_sym_LPAREN,
    ACTIONS(10978), 1,
      sym__conid,
    ACTIONS(10980), 1,
      anon_sym_LBRACK,
    ACTIONS(10982), 1,
      anon_sym_SQUOTE,
    ACTIONS(10986), 1,
      anon_sym_7,
    ACTIONS(10988), 1,
      sym__splice_dollar,
    ACTIONS(10990), 1,
      sym_quasiquote_start,
    STATE(2196), 1,
      sym__unboxed_open,
    STATE(8398), 1,
      sym_constructor,
    STATE(15075), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10974), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10984), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10258), 3,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
    ACTIONS(10968), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8404), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8413), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2895), 17,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_strict_type,
      sym_lazy_type,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_data_constructor_repeat1,
  [15636] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10992), 1,
      anon_sym_SEMI,
    ACTIONS(10994), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17023), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [15759] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10996), 1,
      anon_sym_SEMI,
    ACTIONS(10998), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16738), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [15882] = 29,
    ACTIONS(11000), 1,
      sym__varid,
    ACTIONS(11004), 1,
      sym__integer_literal,
    ACTIONS(11010), 1,
      anon_sym_LPAREN,
    ACTIONS(11012), 1,
      sym__conid,
    ACTIONS(11015), 1,
      anon_sym_LBRACK,
    ACTIONS(11017), 1,
      anon_sym_LBRACE,
    ACTIONS(11019), 1,
      anon_sym__,
    ACTIONS(11021), 1,
      anon_sym_7,
    ACTIONS(11023), 1,
      sym__splice_dollar,
    ACTIONS(11025), 1,
      sym_quasiquote_start,
    ACTIONS(11027), 1,
      sym__strict,
    ACTIONS(11029), 1,
      sym__lazy,
    STATE(315), 1,
      sym__unboxed_open,
    STATE(7993), 1,
      sym_constructor,
    STATE(8023), 1,
      sym__pat_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(8305), 1,
      sym_variable,
    STATE(8536), 1,
      sym_literal,
    STATE(13291), 1,
      sym_pat_fields,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11008), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11002), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11006), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8502), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(9703), 6,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(3201), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [16001] = 31,
    ACTIONS(661), 1,
      anon_sym__,
    ACTIONS(673), 1,
      sym__strict,
    ACTIONS(675), 1,
      sym__lazy,
    ACTIONS(10559), 1,
      sym__varid,
    ACTIONS(10563), 1,
      sym__integer_literal,
    ACTIONS(10569), 1,
      anon_sym_DASH,
    ACTIONS(10573), 1,
      sym__conid,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    ACTIONS(10577), 1,
      anon_sym_7,
    ACTIONS(10579), 1,
      sym__splice_dollar,
    ACTIONS(10581), 1,
      sym_quasiquote_start,
    ACTIONS(11031), 1,
      anon_sym_LPAREN,
    STATE(366), 1,
      sym__unboxed_open,
    STATE(2764), 1,
      sym__pat_constructor,
    STATE(7655), 1,
      sym_constructor,
    STATE(7780), 1,
      sym_qualified_constructor,
    STATE(7820), 1,
      sym__qcon,
    STATE(12024), 1,
      sym_variable,
    STATE(12264), 1,
      sym_literal,
    STATE(14862), 1,
      aux_sym__qualifying_module,
    STATE(15496), 1,
      sym__pattern_type,
    STATE(15501), 1,
      sym__pattern_arrow,
    STATE(15604), 1,
      sym__pattern_equals,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10567), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14673), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10561), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12470), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10062), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [16124] = 23,
    ACTIONS(5100), 1,
      anon_sym_deriving,
    ACTIONS(11033), 1,
      sym__varid,
    ACTIONS(11037), 1,
      sym__integer_literal,
    ACTIONS(11043), 1,
      anon_sym_LPAREN,
    ACTIONS(11045), 1,
      sym__conid,
    ACTIONS(11048), 1,
      anon_sym_LBRACK,
    ACTIONS(11050), 1,
      anon_sym_SQUOTE,
    ACTIONS(11055), 1,
      anon_sym_7,
    ACTIONS(11057), 1,
      sym__splice_dollar,
    ACTIONS(11059), 1,
      sym_quasiquote_start,
    STATE(2146), 1,
      sym__unboxed_open,
    STATE(7937), 1,
      sym_constructor,
    STATE(15334), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11041), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11053), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(11035), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11039), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7988), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7989), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5078), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(2907), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [16231] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11061), 1,
      anon_sym_SEMI,
    ACTIONS(11063), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16694), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [16354] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11065), 1,
      anon_sym_SEMI,
    ACTIONS(11067), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16209), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [16477] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11069), 1,
      anon_sym_SEMI,
    ACTIONS(11071), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17257), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [16600] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11073), 1,
      anon_sym_SEMI,
    ACTIONS(11075), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16073), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [16723] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11077), 1,
      anon_sym_SEMI,
    ACTIONS(11079), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17114), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [16846] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11081), 1,
      anon_sym_SEMI,
    ACTIONS(11083), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16263), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [16969] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11085), 1,
      anon_sym_SEMI,
    ACTIONS(11087), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15624), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [17092] = 30,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(9862), 1,
      anon_sym_LPAREN,
    STATE(2059), 1,
      sym_type_name,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(6317), 1,
      sym_constructor,
    STATE(10553), 1,
      sym__simpletype,
    STATE(13074), 1,
      sym_context,
    STATE(13366), 1,
      sym__simpletype_infix,
    STATE(14714), 1,
      sym_type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(16836), 1,
      sym__context,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8119), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9589), 2,
      sym_type_apply,
      sym__btype,
    STATE(15456), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4017), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [17213] = 29,
    ACTIONS(11089), 1,
      sym__varid,
    ACTIONS(11093), 1,
      sym__integer_literal,
    ACTIONS(11099), 1,
      anon_sym_LPAREN,
    ACTIONS(11101), 1,
      sym__conid,
    ACTIONS(11104), 1,
      anon_sym_LBRACK,
    ACTIONS(11106), 1,
      anon_sym_LBRACE,
    ACTIONS(11108), 1,
      anon_sym__,
    ACTIONS(11110), 1,
      anon_sym_7,
    ACTIONS(11112), 1,
      sym__splice_dollar,
    ACTIONS(11114), 1,
      sym_quasiquote_start,
    ACTIONS(11116), 1,
      sym__strict,
    ACTIONS(11118), 1,
      sym__lazy,
    STATE(481), 1,
      sym__unboxed_open,
    STATE(8017), 1,
      sym_constructor,
    STATE(8101), 1,
      sym__pat_constructor,
    STATE(8254), 1,
      sym_qualified_constructor,
    STATE(8324), 1,
      sym_variable,
    STATE(8386), 1,
      sym__qcon,
    STATE(8663), 1,
      sym_literal,
    STATE(13176), 1,
      sym_pat_fields,
    STATE(15071), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11097), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11091), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11095), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8608), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(9703), 6,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(3198), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [17332] = 30,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(10099), 1,
      anon_sym_LPAREN,
    STATE(2059), 1,
      sym_type_name,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(6227), 1,
      sym_constructor,
    STATE(10214), 1,
      sym__simpletype,
    STATE(13047), 1,
      sym__simpletype_infix,
    STATE(13066), 1,
      sym_context,
    STATE(14714), 1,
      sym_type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(16836), 1,
      sym__context,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7942), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9589), 2,
      sym_type_apply,
      sym__btype,
    STATE(15456), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4017), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [17453] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11120), 1,
      anon_sym_SEMI,
    ACTIONS(11122), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15500), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [17576] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11124), 1,
      anon_sym_SEMI,
    ACTIONS(11126), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17780), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [17699] = 30,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(10164), 1,
      anon_sym_LPAREN,
    STATE(2059), 1,
      sym_type_name,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(5977), 1,
      sym_constructor,
    STATE(10289), 1,
      sym__simpletype,
    STATE(12791), 1,
      sym__simpletype_infix,
    STATE(13097), 1,
      sym_context,
    STATE(14714), 1,
      sym_type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(16836), 1,
      sym__context,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8139), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9589), 2,
      sym_type_apply,
      sym__btype,
    STATE(15456), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(4017), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [17820] = 29,
    ACTIONS(11128), 1,
      sym__varid,
    ACTIONS(11132), 1,
      sym__integer_literal,
    ACTIONS(11138), 1,
      anon_sym_LPAREN,
    ACTIONS(11140), 1,
      sym__conid,
    ACTIONS(11143), 1,
      anon_sym_LBRACK,
    ACTIONS(11145), 1,
      anon_sym_LBRACE,
    ACTIONS(11147), 1,
      anon_sym__,
    ACTIONS(11149), 1,
      anon_sym_7,
    ACTIONS(11151), 1,
      sym__splice_dollar,
    ACTIONS(11153), 1,
      sym_quasiquote_start,
    ACTIONS(11155), 1,
      sym__strict,
    ACTIONS(11157), 1,
      sym__lazy,
    STATE(423), 1,
      sym__unboxed_open,
    STATE(7943), 1,
      sym__pat_constructor,
    STATE(8116), 1,
      sym_constructor,
    STATE(8182), 1,
      sym__qcon,
    STATE(8187), 1,
      sym_variable,
    STATE(8271), 1,
      sym_qualified_constructor,
    STATE(8588), 1,
      sym_literal,
    STATE(13205), 1,
      sym_pat_fields,
    STATE(14857), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11136), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11130), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11134), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8600), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(9703), 6,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(3209), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [17939] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11159), 1,
      anon_sym_SEMI,
    ACTIONS(11161), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16833), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [18062] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11163), 1,
      anon_sym_SEMI,
    ACTIONS(11165), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16018), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [18185] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11167), 1,
      anon_sym_SEMI,
    ACTIONS(11169), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16318), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [18308] = 27,
    ACTIONS(11171), 1,
      sym__varid,
    ACTIONS(11177), 1,
      sym__integer_literal,
    ACTIONS(11186), 1,
      anon_sym_LPAREN,
    ACTIONS(11189), 1,
      sym__conid,
    ACTIONS(11192), 1,
      anon_sym_LBRACK,
    ACTIONS(11195), 1,
      anon_sym__,
    ACTIONS(11198), 1,
      anon_sym_7,
    ACTIONS(11201), 1,
      sym__splice_dollar,
    ACTIONS(11204), 1,
      sym_quasiquote_start,
    ACTIONS(11207), 1,
      sym__strict,
    ACTIONS(11210), 1,
      sym__lazy,
    STATE(244), 1,
      sym__unboxed_open,
    STATE(3918), 1,
      sym_constructor,
    STATE(4144), 1,
      sym_qualified_constructor,
    STATE(7785), 1,
      sym__pat_constructor,
    STATE(7891), 1,
      sym__qcon,
    STATE(7911), 1,
      sym_variable,
    STATE(8114), 1,
      sym_literal,
    STATE(15129), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11183), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11174), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11180), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8149), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10346), 8,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(2890), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [18423] = 27,
    ACTIONS(9985), 1,
      sym__varid,
    ACTIONS(9989), 1,
      sym__integer_literal,
    ACTIONS(9995), 1,
      anon_sym_LPAREN,
    ACTIONS(10000), 1,
      anon_sym_LBRACK,
    ACTIONS(10004), 1,
      anon_sym__,
    ACTIONS(10006), 1,
      anon_sym_7,
    ACTIONS(10008), 1,
      sym__splice_dollar,
    ACTIONS(10010), 1,
      sym_quasiquote_start,
    ACTIONS(10012), 1,
      sym__strict,
    ACTIONS(10014), 1,
      sym__lazy,
    ACTIONS(11213), 1,
      sym__conid,
    STATE(244), 1,
      sym__unboxed_open,
    STATE(3918), 1,
      sym_constructor,
    STATE(4144), 1,
      sym_qualified_constructor,
    STATE(7785), 1,
      sym__pat_constructor,
    STATE(7891), 1,
      sym__qcon,
    STATE(7911), 1,
      sym_variable,
    STATE(8114), 1,
      sym_literal,
    STATE(15129), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9993), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9987), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9991), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8149), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10475), 8,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(2890), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [18538] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11216), 1,
      anon_sym_SEMI,
    ACTIONS(11218), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16223), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [18661] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11220), 1,
      anon_sym_SEMI,
    ACTIONS(11222), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16649), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [18784] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11224), 1,
      anon_sym_SEMI,
    ACTIONS(11226), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17004), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [18907] = 25,
    ACTIONS(10458), 1,
      anon_sym_deriving,
    ACTIONS(11228), 1,
      sym__varid,
    ACTIONS(11234), 1,
      sym__integer_literal,
    ACTIONS(11243), 1,
      anon_sym_LPAREN,
    ACTIONS(11246), 1,
      sym__conid,
    ACTIONS(11249), 1,
      anon_sym_LBRACK,
    ACTIONS(11252), 1,
      anon_sym_SQUOTE,
    ACTIONS(11258), 1,
      anon_sym_7,
    ACTIONS(11261), 1,
      sym__splice_dollar,
    ACTIONS(11264), 1,
      sym_quasiquote_start,
    ACTIONS(11267), 1,
      sym__strict,
    ACTIONS(11270), 1,
      sym__lazy,
    STATE(2196), 1,
      sym__unboxed_open,
    STATE(8398), 1,
      sym_constructor,
    STATE(15075), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11240), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11255), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10429), 3,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
    ACTIONS(11231), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11237), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8404), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8413), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2895), 17,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_strict_type,
      sym_lazy_type,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_data_constructor_repeat1,
  [19018] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11273), 1,
      anon_sym_SEMI,
    ACTIONS(11275), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17658), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [19141] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11277), 1,
      anon_sym_SEMI,
    ACTIONS(11279), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15432), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [19264] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11281), 1,
      anon_sym_SEMI,
    ACTIONS(11283), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17226), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [19387] = 23,
    ACTIONS(5059), 1,
      anon_sym_deriving,
    ACTIONS(11285), 1,
      sym__varid,
    ACTIONS(11291), 1,
      sym__integer_literal,
    ACTIONS(11300), 1,
      anon_sym_LPAREN,
    ACTIONS(11303), 1,
      sym__conid,
    ACTIONS(11306), 1,
      anon_sym_LBRACK,
    ACTIONS(11309), 1,
      anon_sym_SQUOTE,
    ACTIONS(11315), 1,
      anon_sym_7,
    ACTIONS(11318), 1,
      sym__splice_dollar,
    ACTIONS(11321), 1,
      sym_quasiquote_start,
    STATE(2130), 1,
      sym__unboxed_open,
    STATE(7915), 1,
      sym_constructor,
    STATE(15326), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11297), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11312), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(11288), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11294), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8066), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8094), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5030), 7,
      sym__layout_semicolon,
      sym__consym,
      sym__tyconsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(2899), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [19494] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11324), 1,
      anon_sym_SEMI,
    ACTIONS(11326), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16928), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [19617] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11328), 1,
      anon_sym_SEMI,
    ACTIONS(11330), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16028), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [19740] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11332), 1,
      anon_sym_SEMI,
    ACTIONS(11334), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16447), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [19863] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11336), 1,
      anon_sym_SEMI,
    ACTIONS(11338), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16548), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [19986] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11340), 1,
      anon_sym_SEMI,
    ACTIONS(11342), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15598), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [20109] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11344), 1,
      anon_sym_SEMI,
    ACTIONS(11346), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16643), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [20232] = 31,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11348), 1,
      anon_sym_SEMI,
    ACTIONS(11350), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16453), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [20355] = 23,
    ACTIONS(5185), 1,
      anon_sym_deriving,
    ACTIONS(11033), 1,
      sym__varid,
    ACTIONS(11037), 1,
      sym__integer_literal,
    ACTIONS(11043), 1,
      anon_sym_LPAREN,
    ACTIONS(11048), 1,
      anon_sym_LBRACK,
    ACTIONS(11055), 1,
      anon_sym_7,
    ACTIONS(11057), 1,
      sym__splice_dollar,
    ACTIONS(11059), 1,
      sym_quasiquote_start,
    ACTIONS(11352), 1,
      sym__conid,
    ACTIONS(11355), 1,
      anon_sym_SQUOTE,
    STATE(2146), 1,
      sym__unboxed_open,
    STATE(7937), 1,
      sym_constructor,
    STATE(15334), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11041), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11053), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(11035), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11039), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7988), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7989), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5177), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      sym__tyconsym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(2848), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [20462] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11358), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [20582] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11071), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15082), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [20702] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11360), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [20822] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11360), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [20942] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11362), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21062] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11364), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21182] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11366), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21302] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11346), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14671), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21422] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11362), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21542] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11366), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21662] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11063), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15275), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21782] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10545), 1,
      sym__layout_end,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15313), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [21902] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11368), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22022] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11338), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14741), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22142] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11370), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22262] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11350), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14796), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22382] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11222), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14663), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22502] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11370), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22622] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11372), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22742] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11372), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [22862] = 27,
    ACTIONS(10312), 1,
      sym__varid,
    ACTIONS(10316), 1,
      sym__integer_literal,
    ACTIONS(10322), 1,
      anon_sym_LPAREN,
    ACTIONS(10327), 1,
      anon_sym_LBRACK,
    ACTIONS(10331), 1,
      anon_sym__,
    ACTIONS(10333), 1,
      anon_sym_7,
    ACTIONS(10335), 1,
      sym__splice_dollar,
    ACTIONS(10337), 1,
      sym_quasiquote_start,
    ACTIONS(10339), 1,
      sym__strict,
    ACTIONS(10341), 1,
      sym__lazy,
    ACTIONS(11374), 1,
      sym__conid,
    STATE(461), 1,
      sym__unboxed_open,
    STATE(7889), 1,
      sym_constructor,
    STATE(7930), 1,
      sym__pat_constructor,
    STATE(8054), 1,
      sym_qualified_constructor,
    STATE(8069), 1,
      sym_variable,
    STATE(8070), 1,
      sym__qcon,
    STATE(8364), 1,
      sym_literal,
    STATE(14874), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10320), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10314), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10318), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8245), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10475), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(3160), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [22976] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11377), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23096] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11368), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23216] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10866), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15350), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23336] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11379), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23456] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11381), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23576] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11383), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23696] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11381), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23816] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11383), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [23936] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11385), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24056] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11385), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24176] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11379), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24296] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10733), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14850), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24416] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11387), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24536] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11364), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24656] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11389), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24776] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11391), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [24896] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11393), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [25016] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11393), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [25136] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11395), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [25256] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11395), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [25376] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11391), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [25496] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11397), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [25616] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11399), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [25736] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11399), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [25856] = 28,
    ACTIONS(7401), 1,
      sym__integer_literal,
    ACTIONS(7407), 1,
      anon_sym_LPAREN,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(7413), 1,
      anon_sym_LBRACK,
    ACTIONS(7415), 1,
      anon_sym_SQUOTE,
    ACTIONS(7419), 1,
      anon_sym_7,
    ACTIONS(7421), 1,
      sym__splice_dollar,
    ACTIONS(7423), 1,
      sym_quasiquote_start,
    ACTIONS(11401), 1,
      sym__varid,
    STATE(2133), 1,
      sym__unboxed_open,
    STATE(2478), 1,
      sym_type_name,
    STATE(3407), 1,
      sym_context,
    STATE(5968), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(11310), 1,
      sym_type_infix,
    STATE(12683), 1,
      sym__type_infix,
    STATE(14649), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7405), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7417), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7597), 2,
      sym_type_apply,
      sym__btype,
    STATE(15479), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(7399), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7403), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6463), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6509), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2456), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [25972] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11397), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26092] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11403), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26212] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11403), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26332] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11405), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26452] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11405), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26572] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11407), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26692] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11407), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26812] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11083), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14912), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [26932] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11387), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27052] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11409), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27172] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11389), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27292] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11411), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27412] = 22,
    ACTIONS(11413), 1,
      sym__varid,
    ACTIONS(11419), 1,
      sym__integer_literal,
    ACTIONS(11428), 1,
      anon_sym_LPAREN,
    ACTIONS(11431), 1,
      sym__conid,
    ACTIONS(11434), 1,
      anon_sym_LBRACK,
    ACTIONS(11437), 1,
      anon_sym_SQUOTE,
    ACTIONS(11443), 1,
      anon_sym_7,
    ACTIONS(11446), 1,
      sym__splice_dollar,
    ACTIONS(11449), 1,
      sym_quasiquote_start,
    STATE(2109), 1,
      sym__unboxed_open,
    STATE(8025), 1,
      sym_constructor,
    STATE(14637), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11425), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11440), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(11416), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11422), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8274), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8316), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5030), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(2966), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [27516] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11411), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27636] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11126), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15394), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27756] = 23,
    ACTIONS(5134), 1,
      sym__integer_literal,
    ACTIONS(5145), 1,
      anon_sym_LPAREN,
    ACTIONS(5148), 1,
      sym__conid,
    ACTIONS(5151), 1,
      anon_sym_LBRACK,
    ACTIONS(5154), 1,
      anon_sym_SQUOTE,
    ACTIONS(5162), 1,
      anon_sym_7,
    ACTIONS(5165), 1,
      sym__splice_dollar,
    ACTIONS(5168), 1,
      sym_quasiquote_start,
    ACTIONS(5899), 1,
      sym__varid,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5140), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5157), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5129), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(5131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5137), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5143), 4,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3268), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [27862] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11409), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [27982] = 28,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5310), 1,
      anon_sym_LPAREN,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2059), 1,
      sym_type_name,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3324), 1,
      sym_context,
    STATE(3928), 1,
      sym_constructor,
    STATE(9433), 1,
      sym_type_infix,
    STATE(9450), 1,
      sym__context,
    STATE(14336), 1,
      sym__type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(5856), 2,
      sym_type_apply,
      sym__btype,
    STATE(15479), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [28098] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11452), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28218] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11452), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28338] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11454), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28458] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11454), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28578] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11456), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28698] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11456), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28818] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10823), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15073), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [28938] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10998), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14615), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [29058] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11458), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [29178] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11458), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [29298] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10870), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15213), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [29418] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10593), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14680), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [29538] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10585), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14694), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [29658] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11460), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [29778] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11460), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [29898] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11334), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14797), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30018] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11377), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30138] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10589), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14971), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30258] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11462), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30378] = 22,
    ACTIONS(11464), 1,
      sym__varid,
    ACTIONS(11470), 1,
      sym__integer_literal,
    ACTIONS(11479), 1,
      anon_sym_LPAREN,
    ACTIONS(11482), 1,
      sym__conid,
    ACTIONS(11485), 1,
      anon_sym_LBRACK,
    ACTIONS(11488), 1,
      anon_sym_SQUOTE,
    ACTIONS(11494), 1,
      anon_sym_7,
    ACTIONS(11497), 1,
      sym__splice_dollar,
    ACTIONS(11500), 1,
      sym_quasiquote_start,
    STATE(2213), 1,
      sym__unboxed_open,
    STATE(8141), 1,
      sym_constructor,
    STATE(14795), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11476), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11491), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(11467), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11473), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8196), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8354), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5030), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(2991), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [30482] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11462), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30602] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11161), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14708), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30722] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11503), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30842] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11505), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [30962] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11503), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [31082] = 29,
    ACTIONS(11507), 1,
      sym__varid,
    ACTIONS(11511), 1,
      sym__integer_literal,
    ACTIONS(11517), 1,
      anon_sym_LPAREN,
    ACTIONS(11519), 1,
      sym__conid,
    ACTIONS(11522), 1,
      anon_sym_LBRACK,
    ACTIONS(11524), 1,
      anon_sym_LBRACE,
    ACTIONS(11526), 1,
      anon_sym__,
    ACTIONS(11528), 1,
      anon_sym_7,
    ACTIONS(11530), 1,
      sym__splice_dollar,
    ACTIONS(11532), 1,
      sym_quasiquote_start,
    ACTIONS(11534), 1,
      sym__strict,
    ACTIONS(11536), 1,
      sym__lazy,
    STATE(473), 1,
      sym__unboxed_open,
    STATE(8287), 1,
      sym__pat_constructor,
    STATE(8357), 1,
      sym_constructor,
    STATE(8515), 1,
      sym_variable,
    STATE(8520), 1,
      sym_qualified_constructor,
    STATE(8599), 1,
      sym__qcon,
    STATE(8905), 1,
      sym_literal,
    STATE(13736), 1,
      sym_pat_fields,
    STATE(14966), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11515), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11509), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11513), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(8856), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3241), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [31200] = 25,
    ACTIONS(11037), 1,
      sym__integer_literal,
    ACTIONS(11043), 1,
      anon_sym_LPAREN,
    ACTIONS(11048), 1,
      anon_sym_LBRACK,
    ACTIONS(11055), 1,
      anon_sym_7,
    ACTIONS(11057), 1,
      sym__splice_dollar,
    ACTIONS(11059), 1,
      sym_quasiquote_start,
    ACTIONS(11538), 1,
      sym__varid,
    ACTIONS(11540), 1,
      sym__conid,
    ACTIONS(11542), 1,
      anon_sym_SQUOTE,
    ACTIONS(11544), 1,
      sym__strict,
    ACTIONS(11546), 1,
      sym__lazy,
    STATE(2146), 1,
      sym__unboxed_open,
    STATE(7937), 1,
      sym_constructor,
    STATE(15334), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11041), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11053), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9234), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(11035), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11039), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14282), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7988), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7989), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2872), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [31310] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10737), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15303), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [31430] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11548), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [31550] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11505), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [31670] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11550), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [31790] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11548), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [31910] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11550), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32030] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11218), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14924), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32150] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11552), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32270] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11552), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32390] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11075), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15027), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32510] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11554), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32630] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11554), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32750] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11556), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [32870] = 29,
    ACTIONS(11558), 1,
      sym__varid,
    ACTIONS(11562), 1,
      sym__integer_literal,
    ACTIONS(11568), 1,
      anon_sym_LPAREN,
    ACTIONS(11570), 1,
      sym__conid,
    ACTIONS(11573), 1,
      anon_sym_LBRACK,
    ACTIONS(11575), 1,
      anon_sym_LBRACE,
    ACTIONS(11577), 1,
      anon_sym__,
    ACTIONS(11579), 1,
      anon_sym_7,
    ACTIONS(11581), 1,
      sym__splice_dollar,
    ACTIONS(11583), 1,
      sym_quasiquote_start,
    ACTIONS(11585), 1,
      sym__strict,
    ACTIONS(11587), 1,
      sym__lazy,
    STATE(476), 1,
      sym__unboxed_open,
    STATE(8298), 1,
      sym_constructor,
    STATE(8301), 1,
      sym__pat_constructor,
    STATE(8535), 1,
      sym__qcon,
    STATE(8545), 1,
      sym_qualified_constructor,
    STATE(8609), 1,
      sym_variable,
    STATE(8853), 1,
      sym_literal,
    STATE(13861), 1,
      sym_pat_fields,
    STATE(15198), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11566), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11560), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11564), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 5,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(8846), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3225), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [32988] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11556), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33108] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11589), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33228] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11591), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33348] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11591), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33468] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11593), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33588] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11326), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14840), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33708] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11593), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33828] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10827), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15098), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [33948] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11589), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34068] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11595), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34188] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11597), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34308] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11597), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34428] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11595), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34548] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11599), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34668] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11599), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34788] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11601), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [34908] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11601), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35028] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11169), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14841), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35148] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11165), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15044), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35268] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11330), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15254), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35388] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11603), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35508] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11603), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35628] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10862), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15148), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35748] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11605), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35868] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11605), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [35988] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10597), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15243), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36108] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11607), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36228] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11609), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36348] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11611), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18869), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13823), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36468] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11613), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16973), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36588] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11615), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16852), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36708] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11617), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36828] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11619), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [36948] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11619), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37068] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11617), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37188] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10908), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15190), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37308] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11621), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37428] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11609), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37548] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11621), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37668] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11623), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37788] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11607), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [37908] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11623), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38028] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11625), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38148] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11625), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38268] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10784), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14817), 1,
      sym__pattern_decl,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38388] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10729), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15159), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38508] = 25,
    ACTIONS(11037), 1,
      sym__integer_literal,
    ACTIONS(11043), 1,
      anon_sym_LPAREN,
    ACTIONS(11048), 1,
      anon_sym_LBRACK,
    ACTIONS(11055), 1,
      anon_sym_7,
    ACTIONS(11057), 1,
      sym__splice_dollar,
    ACTIONS(11059), 1,
      sym_quasiquote_start,
    ACTIONS(11538), 1,
      sym__varid,
    ACTIONS(11540), 1,
      sym__conid,
    ACTIONS(11542), 1,
      anon_sym_SQUOTE,
    ACTIONS(11544), 1,
      sym__strict,
    ACTIONS(11546), 1,
      sym__lazy,
    STATE(2146), 1,
      sym__unboxed_open,
    STATE(7937), 1,
      sym_constructor,
    STATE(15334), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11041), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11053), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9234), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(11035), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11039), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14175), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7988), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7989), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2872), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [38618] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11627), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38738] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11629), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38858] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11627), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [38978] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11631), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39098] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11629), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39218] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11633), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39338] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11633), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39458] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11635), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39578] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11637), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39698] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11637), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39818] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11358), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [39938] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11639), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18869), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13823), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40058] = 22,
    ACTIONS(11641), 1,
      sym__varid,
    ACTIONS(11647), 1,
      sym__integer_literal,
    ACTIONS(11653), 1,
      anon_sym_LPAREN,
    ACTIONS(11655), 1,
      sym__conid,
    ACTIONS(11657), 1,
      anon_sym_LBRACK,
    ACTIONS(11659), 1,
      anon_sym_SQUOTE,
    ACTIONS(11663), 1,
      anon_sym_7,
    ACTIONS(11665), 1,
      sym__splice_dollar,
    ACTIONS(11667), 1,
      sym_quasiquote_start,
    STATE(2213), 1,
      sym__unboxed_open,
    STATE(8141), 1,
      sym_constructor,
    STATE(14795), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11651), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11661), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(11645), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11649), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8196), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8354), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(11643), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(2991), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [40162] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11669), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16973), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40282] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11671), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16852), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40402] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11635), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40522] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11673), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40642] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11675), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40762] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11677), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [40882] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11679), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41002] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11679), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41122] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11677), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41242] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11087), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15272), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41362] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11675), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41482] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11681), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41602] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11275), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14897), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41722] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11683), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41842] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11631), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [41962] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11681), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42082] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11685), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42202] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11685), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42322] = 25,
    ACTIONS(7345), 1,
      sym__integer_literal,
    ACTIONS(7355), 1,
      sym__conid,
    ACTIONS(7357), 1,
      anon_sym_LBRACK,
    ACTIONS(7359), 1,
      anon_sym_SQUOTE,
    ACTIONS(7363), 1,
      anon_sym_7,
    ACTIONS(7365), 1,
      sym__splice_dollar,
    ACTIONS(7367), 1,
      sym_quasiquote_start,
    ACTIONS(8745), 1,
      anon_sym_LPAREN,
    ACTIONS(11687), 1,
      sym__varid,
    ACTIONS(11689), 1,
      sym__strict,
    ACTIONS(11691), 1,
      sym__lazy,
    STATE(2183), 1,
      sym__unboxed_open,
    STATE(6953), 1,
      sym_constructor,
    STATE(15335), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7349), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7361), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8118), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(7343), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7347), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14773), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7070), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7144), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2715), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [42432] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11693), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18869), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13823), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42552] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11695), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16852), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42672] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11226), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14899), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42792] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10686), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15232), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [42912] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11697), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16973), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43032] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11683), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43152] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11699), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16852), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43272] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11701), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43392] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11703), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16973), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43512] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11705), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18869), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13823), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43632] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11701), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43752] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11707), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43872] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11707), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [43992] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11283), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14962), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [44112] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11079), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14964), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [44232] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10914), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15100), 1,
      sym__pattern_decl,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [44352] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11067), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14687), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [44472] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10994), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14903), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [44592] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11709), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [44712] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11711), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [44832] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11711), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [44952] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11713), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16852), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [45072] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11715), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16973), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [45192] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11717), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18869), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13823), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [45312] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11719), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [45432] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11721), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [45552] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11709), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [45672] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11719), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [45792] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11723), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [45912] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11723), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [46032] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11725), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [46152] = 25,
    ACTIONS(7345), 1,
      sym__integer_literal,
    ACTIONS(7355), 1,
      sym__conid,
    ACTIONS(7357), 1,
      anon_sym_LBRACK,
    ACTIONS(7359), 1,
      anon_sym_SQUOTE,
    ACTIONS(7363), 1,
      anon_sym_7,
    ACTIONS(7365), 1,
      sym__splice_dollar,
    ACTIONS(7367), 1,
      sym_quasiquote_start,
    ACTIONS(8745), 1,
      anon_sym_LPAREN,
    ACTIONS(11687), 1,
      sym__varid,
    ACTIONS(11689), 1,
      sym__strict,
    ACTIONS(11691), 1,
      sym__lazy,
    STATE(2183), 1,
      sym__unboxed_open,
    STATE(6953), 1,
      sym_constructor,
    STATE(15335), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7349), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7361), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8118), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(7343), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7347), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14935), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(7070), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7144), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2715), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [46262] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11725), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [46382] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11727), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [46502] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11729), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [46622] = 28,
    ACTIONS(6308), 1,
      sym__integer_literal,
    ACTIONS(6314), 1,
      anon_sym_LPAREN,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(6320), 1,
      anon_sym_LBRACK,
    ACTIONS(6322), 1,
      anon_sym_SQUOTE,
    ACTIONS(6326), 1,
      anon_sym_7,
    ACTIONS(6328), 1,
      sym__splice_dollar,
    ACTIONS(6330), 1,
      sym_quasiquote_start,
    ACTIONS(11731), 1,
      sym__varid,
    STATE(2166), 1,
      sym__unboxed_open,
    STATE(2480), 1,
      sym_type_name,
    STATE(3396), 1,
      sym_context,
    STATE(6403), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(11549), 1,
      sym_type_infix,
    STATE(12759), 1,
      sym__type_infix,
    STATE(14854), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6312), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7807), 2,
      sym_type_apply,
      sym__btype,
    STATE(15479), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(6306), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6310), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6680), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2491), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [46738] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11727), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [46858] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11733), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [46978] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11733), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47098] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11729), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47218] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11279), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15385), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47338] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11673), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47458] = 25,
    ACTIONS(10876), 1,
      sym__integer_literal,
    ACTIONS(10882), 1,
      anon_sym_LPAREN,
    ACTIONS(10887), 1,
      anon_sym_LBRACK,
    ACTIONS(10894), 1,
      anon_sym_7,
    ACTIONS(10896), 1,
      sym__splice_dollar,
    ACTIONS(10898), 1,
      sym_quasiquote_start,
    ACTIONS(11735), 1,
      sym__varid,
    ACTIONS(11737), 1,
      sym__conid,
    ACTIONS(11739), 1,
      anon_sym_SQUOTE,
    ACTIONS(11741), 1,
      sym__strict,
    ACTIONS(11743), 1,
      sym__lazy,
    STATE(2130), 1,
      sym__unboxed_open,
    STATE(7915), 1,
      sym_constructor,
    STATE(15326), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10880), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10892), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9237), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(10874), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10878), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14382), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(8066), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8094), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2859), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [47568] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11745), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18869), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13823), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47688] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11342), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15305), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47808] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11747), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [47928] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11721), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [48048] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10741), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14880), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [48168] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11749), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [48288] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11747), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [48408] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11749), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [48528] = 25,
    ACTIONS(10876), 1,
      sym__integer_literal,
    ACTIONS(10882), 1,
      anon_sym_LPAREN,
    ACTIONS(10887), 1,
      anon_sym_LBRACK,
    ACTIONS(10894), 1,
      anon_sym_7,
    ACTIONS(10896), 1,
      sym__splice_dollar,
    ACTIONS(10898), 1,
      sym_quasiquote_start,
    ACTIONS(11735), 1,
      sym__varid,
    ACTIONS(11737), 1,
      sym__conid,
    ACTIONS(11739), 1,
      anon_sym_SQUOTE,
    ACTIONS(11741), 1,
      sym__strict,
    ACTIONS(11743), 1,
      sym__lazy,
    STATE(2130), 1,
      sym__unboxed_open,
    STATE(7915), 1,
      sym_constructor,
    STATE(15326), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10880), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10892), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9237), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(10874), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10878), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14390), 4,
      sym_strict_type,
      sym_lazy_type,
      sym_type_infix,
      sym__type_infix,
    STATE(8066), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8094), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2859), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [48638] = 28,
    ACTIONS(7233), 1,
      sym__integer_literal,
    ACTIONS(7239), 1,
      anon_sym_LPAREN,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(7245), 1,
      anon_sym_LBRACK,
    ACTIONS(7247), 1,
      anon_sym_SQUOTE,
    ACTIONS(7251), 1,
      anon_sym_7,
    ACTIONS(7253), 1,
      sym__splice_dollar,
    ACTIONS(7255), 1,
      sym_quasiquote_start,
    ACTIONS(11751), 1,
      sym__varid,
    STATE(2108), 1,
      sym__unboxed_open,
    STATE(2449), 1,
      sym_type_name,
    STATE(3357), 1,
      sym_context,
    STATE(5969), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(11131), 1,
      sym_type_infix,
    STATE(12710), 1,
      sym__type_infix,
    STATE(15009), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7237), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7249), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7690), 2,
      sym_type_apply,
      sym__btype,
    STATE(15479), 2,
      sym_constraint,
      sym__context_constraints,
    ACTIONS(7231), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7235), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6424), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6425), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2461), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [48754] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11753), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [48874] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11753), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [48994] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11755), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16973), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [49114] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11757), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16852), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [49234] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11759), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [49354] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11759), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [49474] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11761), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [49594] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11763), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [49714] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11761), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [49834] = 23,
    ACTIONS(10057), 1,
      sym__varid,
    ACTIONS(10063), 1,
      sym__integer_literal,
    ACTIONS(10072), 1,
      anon_sym_LPAREN,
    ACTIONS(10078), 1,
      sym__conid,
    ACTIONS(10081), 1,
      anon_sym_LBRACK,
    ACTIONS(10084), 1,
      anon_sym_SQUOTE,
    ACTIONS(10090), 1,
      anon_sym_7,
    ACTIONS(10093), 1,
      sym__splice_dollar,
    ACTIONS(10096), 1,
      sym_quasiquote_start,
    STATE(2173), 1,
      sym__unboxed_open,
    STATE(8883), 1,
      sym_constructor,
    STATE(14618), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10069), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10087), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(5129), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(10060), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10066), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5143), 4,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
    STATE(9097), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9169), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3317), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [49940] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11763), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [50060] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10601), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15283), 1,
      sym__pattern_decl,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [50180] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10918), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14998), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [50300] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10922), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(14740), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [50420] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11122), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(15379), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [50540] = 27,
    ACTIONS(11765), 1,
      sym__varid,
    ACTIONS(11771), 1,
      sym__integer_literal,
    ACTIONS(11780), 1,
      anon_sym_LPAREN,
    ACTIONS(11783), 1,
      sym__conid,
    ACTIONS(11786), 1,
      anon_sym_LBRACK,
    ACTIONS(11789), 1,
      anon_sym__,
    ACTIONS(11792), 1,
      anon_sym_7,
    ACTIONS(11795), 1,
      sym__splice_dollar,
    ACTIONS(11798), 1,
      sym_quasiquote_start,
    ACTIONS(11801), 1,
      sym__strict,
    ACTIONS(11804), 1,
      sym__lazy,
    STATE(461), 1,
      sym__unboxed_open,
    STATE(7889), 1,
      sym_constructor,
    STATE(7930), 1,
      sym__pat_constructor,
    STATE(8054), 1,
      sym_qualified_constructor,
    STATE(8069), 1,
      sym_variable,
    STATE(8070), 1,
      sym__qcon,
    STATE(8364), 1,
      sym_literal,
    STATE(14874), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11777), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11768), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11774), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8245), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10346), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(3160), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [50654] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11807), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [50774] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11809), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [50894] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11809), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51014] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11811), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51134] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11807), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51254] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11813), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51374] = 22,
    ACTIONS(11815), 1,
      sym__varid,
    ACTIONS(11819), 1,
      sym__integer_literal,
    ACTIONS(11825), 1,
      anon_sym_LPAREN,
    ACTIONS(11827), 1,
      sym__conid,
    ACTIONS(11829), 1,
      anon_sym_LBRACK,
    ACTIONS(11831), 1,
      anon_sym_SQUOTE,
    ACTIONS(11835), 1,
      anon_sym_7,
    ACTIONS(11837), 1,
      sym__splice_dollar,
    ACTIONS(11839), 1,
      sym_quasiquote_start,
    STATE(2109), 1,
      sym__unboxed_open,
    STATE(8025), 1,
      sym_constructor,
    STATE(14637), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11823), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11833), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(11817), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11821), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8274), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8316), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(11643), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
    STATE(2966), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [51478] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11811), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51598] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11841), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51718] = 29,
    ACTIONS(11843), 1,
      sym__varid,
    ACTIONS(11847), 1,
      sym__integer_literal,
    ACTIONS(11853), 1,
      anon_sym_LPAREN,
    ACTIONS(11855), 1,
      sym__conid,
    ACTIONS(11858), 1,
      anon_sym_LBRACK,
    ACTIONS(11860), 1,
      anon_sym_LBRACE,
    ACTIONS(11862), 1,
      anon_sym__,
    ACTIONS(11864), 1,
      anon_sym_7,
    ACTIONS(11866), 1,
      sym__splice_dollar,
    ACTIONS(11868), 1,
      sym_quasiquote_start,
    ACTIONS(11870), 1,
      sym__strict,
    ACTIONS(11872), 1,
      sym__lazy,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(8206), 1,
      sym__pat_constructor,
    STATE(8282), 1,
      sym_constructor,
    STATE(8549), 1,
      sym_qualified_constructor,
    STATE(8605), 1,
      sym_variable,
    STATE(8636), 1,
      sym__qcon,
    STATE(8922), 1,
      sym_literal,
    STATE(13697), 1,
      sym_pat_fields,
    STATE(15196), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11851), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11845), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11849), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 5,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
    STATE(8940), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3220), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [51836] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11841), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [51956] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11813), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [52076] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11874), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [52196] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11874), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [52316] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11876), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [52436] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(10819), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15020), 1,
      sym_alt,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [52556] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11878), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [52676] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11878), 1,
      anon_sym_RBRACE,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [52796] = 30,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(11876), 1,
      sym__layout_end,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [52916] = 22,
    ACTIONS(11880), 1,
      sym__varid,
    ACTIONS(11886), 1,
      sym__integer_literal,
    ACTIONS(11895), 1,
      anon_sym_LPAREN,
    ACTIONS(11898), 1,
      sym__conid,
    ACTIONS(11901), 1,
      anon_sym_LBRACK,
    ACTIONS(11904), 1,
      anon_sym_SQUOTE,
    ACTIONS(11910), 1,
      anon_sym_7,
    ACTIONS(11913), 1,
      sym__splice_dollar,
    ACTIONS(11916), 1,
      sym_quasiquote_start,
    STATE(2206), 1,
      sym__unboxed_open,
    STATE(8344), 1,
      sym_constructor,
    STATE(15347), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11892), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11907), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(11883), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11889), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8491), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8702), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5030), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
    STATE(3180), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [53019] = 27,
    ACTIONS(11919), 1,
      sym__varid,
    ACTIONS(11925), 1,
      sym__integer_literal,
    ACTIONS(11934), 1,
      anon_sym_LPAREN,
    ACTIONS(11937), 1,
      sym__conid,
    ACTIONS(11940), 1,
      anon_sym_LBRACK,
    ACTIONS(11943), 1,
      anon_sym__,
    ACTIONS(11946), 1,
      anon_sym_7,
    ACTIONS(11949), 1,
      sym__splice_dollar,
    ACTIONS(11952), 1,
      sym_quasiquote_start,
    ACTIONS(11955), 1,
      sym__strict,
    ACTIONS(11958), 1,
      sym__lazy,
    STATE(315), 1,
      sym__unboxed_open,
    STATE(7993), 1,
      sym_constructor,
    STATE(8023), 1,
      sym__pat_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(8305), 1,
      sym_variable,
    STATE(8536), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11931), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11922), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11928), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8502), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10346), 6,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(3181), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [53132] = 27,
    ACTIONS(10786), 1,
      sym__varid,
    ACTIONS(10790), 1,
      sym__integer_literal,
    ACTIONS(10796), 1,
      anon_sym_LPAREN,
    ACTIONS(10801), 1,
      anon_sym_LBRACK,
    ACTIONS(10805), 1,
      anon_sym__,
    ACTIONS(10807), 1,
      anon_sym_7,
    ACTIONS(10809), 1,
      sym__splice_dollar,
    ACTIONS(10811), 1,
      sym_quasiquote_start,
    ACTIONS(10813), 1,
      sym__strict,
    ACTIONS(10815), 1,
      sym__lazy,
    ACTIONS(11961), 1,
      sym__conid,
    STATE(354), 1,
      sym__unboxed_open,
    STATE(8041), 1,
      sym_constructor,
    STATE(8112), 1,
      sym__pat_constructor,
    STATE(8277), 1,
      sym_variable,
    STATE(8307), 1,
      sym_qualified_constructor,
    STATE(8383), 1,
      sym__qcon,
    STATE(8429), 1,
      sym_literal,
    STATE(14715), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10794), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10788), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10792), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8662), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10475), 6,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    STATE(3188), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [53245] = 22,
    ACTIONS(11964), 1,
      sym__varid,
    ACTIONS(11968), 1,
      sym__integer_literal,
    ACTIONS(11974), 1,
      anon_sym_LPAREN,
    ACTIONS(11976), 1,
      sym__conid,
    ACTIONS(11978), 1,
      anon_sym_LBRACK,
    ACTIONS(11980), 1,
      anon_sym_SQUOTE,
    ACTIONS(11984), 1,
      anon_sym_7,
    ACTIONS(11986), 1,
      sym__splice_dollar,
    ACTIONS(11988), 1,
      sym_quasiquote_start,
    STATE(2206), 1,
      sym__unboxed_open,
    STATE(8344), 1,
      sym_constructor,
    STATE(15347), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11972), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11982), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(11966), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11970), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8491), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8702), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(11643), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
    STATE(3180), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [53348] = 29,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18476), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12896), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [53465] = 22,
    ACTIONS(11990), 1,
      sym__varid,
    ACTIONS(11994), 1,
      sym__integer_literal,
    ACTIONS(12000), 1,
      anon_sym_LPAREN,
    ACTIONS(12002), 1,
      sym__conid,
    ACTIONS(12004), 1,
      anon_sym_LBRACK,
    ACTIONS(12006), 1,
      anon_sym_SQUOTE,
    ACTIONS(12010), 1,
      anon_sym_7,
    ACTIONS(12012), 1,
      sym__splice_dollar,
    ACTIONS(12014), 1,
      sym_quasiquote_start,
    STATE(2218), 1,
      sym__unboxed_open,
    STATE(8241), 1,
      sym_constructor,
    STATE(14853), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11998), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12008), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(11992), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11996), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8426), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8616), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(11643), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
    STATE(3189), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [53568] = 29,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(17291), 1,
      sym_alt,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(12822), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [53685] = 27,
    ACTIONS(12016), 1,
      sym__varid,
    ACTIONS(12022), 1,
      sym__integer_literal,
    ACTIONS(12031), 1,
      anon_sym_LPAREN,
    ACTIONS(12034), 1,
      sym__conid,
    ACTIONS(12037), 1,
      anon_sym_LBRACK,
    ACTIONS(12040), 1,
      anon_sym__,
    ACTIONS(12043), 1,
      anon_sym_7,
    ACTIONS(12046), 1,
      sym__splice_dollar,
    ACTIONS(12049), 1,
      sym_quasiquote_start,
    ACTIONS(12052), 1,
      sym__strict,
    ACTIONS(12055), 1,
      sym__lazy,
    STATE(481), 1,
      sym__unboxed_open,
    STATE(8017), 1,
      sym_constructor,
    STATE(8101), 1,
      sym__pat_constructor,
    STATE(8254), 1,
      sym_qualified_constructor,
    STATE(8324), 1,
      sym_variable,
    STATE(8386), 1,
      sym__qcon,
    STATE(8663), 1,
      sym_literal,
    STATE(15071), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12028), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12019), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12025), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8608), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10346), 6,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(3187), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [53798] = 27,
    ACTIONS(12058), 1,
      sym__varid,
    ACTIONS(12064), 1,
      sym__integer_literal,
    ACTIONS(12073), 1,
      anon_sym_LPAREN,
    ACTIONS(12076), 1,
      sym__conid,
    ACTIONS(12079), 1,
      anon_sym_LBRACK,
    ACTIONS(12082), 1,
      anon_sym__,
    ACTIONS(12085), 1,
      anon_sym_7,
    ACTIONS(12088), 1,
      sym__splice_dollar,
    ACTIONS(12091), 1,
      sym_quasiquote_start,
    ACTIONS(12094), 1,
      sym__strict,
    ACTIONS(12097), 1,
      sym__lazy,
    STATE(354), 1,
      sym__unboxed_open,
    STATE(8041), 1,
      sym_constructor,
    STATE(8112), 1,
      sym__pat_constructor,
    STATE(8277), 1,
      sym_variable,
    STATE(8307), 1,
      sym_qualified_constructor,
    STATE(8383), 1,
      sym__qcon,
    STATE(8429), 1,
      sym_literal,
    STATE(14715), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12070), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12061), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12067), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8662), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10346), 6,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
    STATE(3188), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [53911] = 22,
    ACTIONS(12100), 1,
      sym__varid,
    ACTIONS(12106), 1,
      sym__integer_literal,
    ACTIONS(12115), 1,
      anon_sym_LPAREN,
    ACTIONS(12118), 1,
      sym__conid,
    ACTIONS(12121), 1,
      anon_sym_LBRACK,
    ACTIONS(12124), 1,
      anon_sym_SQUOTE,
    ACTIONS(12130), 1,
      anon_sym_7,
    ACTIONS(12133), 1,
      sym__splice_dollar,
    ACTIONS(12136), 1,
      sym_quasiquote_start,
    STATE(2218), 1,
      sym__unboxed_open,
    STATE(8241), 1,
      sym_constructor,
    STATE(14853), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12112), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12127), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12103), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12109), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8426), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8616), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(5030), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
    STATE(3189), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [54014] = 27,
    ACTIONS(10829), 1,
      sym__varid,
    ACTIONS(10833), 1,
      sym__integer_literal,
    ACTIONS(10839), 1,
      anon_sym_LPAREN,
    ACTIONS(10844), 1,
      anon_sym_LBRACK,
    ACTIONS(10848), 1,
      anon_sym__,
    ACTIONS(10850), 1,
      anon_sym_7,
    ACTIONS(10852), 1,
      sym__splice_dollar,
    ACTIONS(10854), 1,
      sym_quasiquote_start,
    ACTIONS(10856), 1,
      sym__strict,
    ACTIONS(10858), 1,
      sym__lazy,
    ACTIONS(12139), 1,
      sym__conid,
    STATE(417), 1,
      sym__unboxed_open,
    STATE(8050), 1,
      sym__pat_constructor,
    STATE(8096), 1,
      sym_constructor,
    STATE(8157), 1,
      sym_variable,
    STATE(8280), 1,
      sym__qcon,
    STATE(8294), 1,
      sym_qualified_constructor,
    STATE(8722), 1,
      sym_literal,
    STATE(15081), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10837), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10831), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10835), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8434), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10475), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(3197), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [54127] = 28,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(9848), 1,
      anon_sym_LPAREN,
    ACTIONS(9850), 1,
      anon_sym_SQUOTE,
    ACTIONS(11731), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2843), 1,
      sym_type_name,
    STATE(3358), 1,
      sym_context,
    STATE(6403), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(14431), 1,
      sym_type_infix,
    STATE(14587), 1,
      sym_constraint,
    STATE(14854), 1,
      aux_sym__qualifying_module,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9675), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6680), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [54242] = 28,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5310), 1,
      anon_sym_LPAREN,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2969), 1,
      sym_type_name,
    STATE(3338), 1,
      sym_context,
    STATE(3928), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(14714), 1,
      sym_type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15375), 1,
      sym_constraint,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9589), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [54357] = 22,
    ACTIONS(12142), 1,
      sym__varid,
    ACTIONS(12146), 1,
      sym__integer_literal,
    ACTIONS(12152), 1,
      anon_sym_LPAREN,
    ACTIONS(12154), 1,
      sym__conid,
    ACTIONS(12156), 1,
      anon_sym_LBRACK,
    ACTIONS(12158), 1,
      anon_sym_SQUOTE,
    ACTIONS(12162), 1,
      anon_sym_7,
    ACTIONS(12164), 1,
      sym__splice_dollar,
    ACTIONS(12166), 1,
      sym_quasiquote_start,
    STATE(2182), 1,
      sym__unboxed_open,
    STATE(8210), 1,
      sym_constructor,
    STATE(14724), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12150), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12160), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12144), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12148), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8643), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8646), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(11643), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_RBRACE,
    STATE(3199), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [54460] = 28,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(8171), 1,
      sym__varid,
    ACTIONS(9773), 1,
      anon_sym_LPAREN,
    ACTIONS(9775), 1,
      anon_sym_SQUOTE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2866), 1,
      sym_type_name,
    STATE(3400), 1,
      sym_context,
    STATE(7280), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(14283), 1,
      sym_type_infix,
    STATE(14296), 1,
      sym_constraint,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9712), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [54575] = 28,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6016), 1,
      sym__conid,
    ACTIONS(9787), 1,
      anon_sym_LPAREN,
    ACTIONS(9789), 1,
      anon_sym_SQUOTE,
    ACTIONS(12168), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2840), 1,
      sym_type_name,
    STATE(3366), 1,
      sym_context,
    STATE(7295), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(14547), 1,
      sym_type_infix,
    STATE(14576), 1,
      sym_constraint,
    STATE(14836), 1,
      aux_sym__qualifying_module,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9626), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7412), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [54690] = 27,
    ACTIONS(12170), 1,
      sym__varid,
    ACTIONS(12176), 1,
      sym__integer_literal,
    ACTIONS(12185), 1,
      anon_sym_LPAREN,
    ACTIONS(12188), 1,
      sym__conid,
    ACTIONS(12191), 1,
      anon_sym_LBRACK,
    ACTIONS(12194), 1,
      anon_sym__,
    ACTIONS(12197), 1,
      anon_sym_7,
    ACTIONS(12200), 1,
      sym__splice_dollar,
    ACTIONS(12203), 1,
      sym_quasiquote_start,
    ACTIONS(12206), 1,
      sym__strict,
    ACTIONS(12209), 1,
      sym__lazy,
    STATE(423), 1,
      sym__unboxed_open,
    STATE(7943), 1,
      sym__pat_constructor,
    STATE(8116), 1,
      sym_constructor,
    STATE(8182), 1,
      sym__qcon,
    STATE(8187), 1,
      sym_variable,
    STATE(8271), 1,
      sym_qualified_constructor,
    STATE(8588), 1,
      sym_literal,
    STATE(14857), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12182), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12173), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12179), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8600), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10346), 6,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(3196), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [54803] = 27,
    ACTIONS(12212), 1,
      sym__varid,
    ACTIONS(12218), 1,
      sym__integer_literal,
    ACTIONS(12227), 1,
      anon_sym_LPAREN,
    ACTIONS(12230), 1,
      sym__conid,
    ACTIONS(12233), 1,
      anon_sym_LBRACK,
    ACTIONS(12236), 1,
      anon_sym__,
    ACTIONS(12239), 1,
      anon_sym_7,
    ACTIONS(12242), 1,
      sym__splice_dollar,
    ACTIONS(12245), 1,
      sym_quasiquote_start,
    ACTIONS(12248), 1,
      sym__strict,
    ACTIONS(12251), 1,
      sym__lazy,
    STATE(417), 1,
      sym__unboxed_open,
    STATE(8050), 1,
      sym__pat_constructor,
    STATE(8096), 1,
      sym_constructor,
    STATE(8157), 1,
      sym_variable,
    STATE(8280), 1,
      sym__qcon,
    STATE(8294), 1,
      sym_qualified_constructor,
    STATE(8722), 1,
      sym_literal,
    STATE(15081), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12224), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12215), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12221), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8434), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10346), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(3197), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [54916] = 27,
    ACTIONS(11089), 1,
      sym__varid,
    ACTIONS(11093), 1,
      sym__integer_literal,
    ACTIONS(11099), 1,
      anon_sym_LPAREN,
    ACTIONS(11104), 1,
      anon_sym_LBRACK,
    ACTIONS(11108), 1,
      anon_sym__,
    ACTIONS(11110), 1,
      anon_sym_7,
    ACTIONS(11112), 1,
      sym__splice_dollar,
    ACTIONS(11114), 1,
      sym_quasiquote_start,
    ACTIONS(11116), 1,
      sym__strict,
    ACTIONS(11118), 1,
      sym__lazy,
    ACTIONS(12254), 1,
      sym__conid,
    STATE(481), 1,
      sym__unboxed_open,
    STATE(8017), 1,
      sym_constructor,
    STATE(8101), 1,
      sym__pat_constructor,
    STATE(8254), 1,
      sym_qualified_constructor,
    STATE(8324), 1,
      sym_variable,
    STATE(8386), 1,
      sym__qcon,
    STATE(8663), 1,
      sym_literal,
    STATE(15071), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11097), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11091), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11095), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8608), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10475), 6,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
    STATE(3187), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [55029] = 22,
    ACTIONS(12257), 1,
      sym__varid,
    ACTIONS(12263), 1,
      sym__integer_literal,
    ACTIONS(12272), 1,
      anon_sym_LPAREN,
    ACTIONS(12275), 1,
      sym__conid,
    ACTIONS(12278), 1,
      anon_sym_LBRACK,
    ACTIONS(12281), 1,
      anon_sym_SQUOTE,
    ACTIONS(12287), 1,
      anon_sym_7,
    ACTIONS(12290), 1,
      sym__splice_dollar,
    ACTIONS(12293), 1,
      sym_quasiquote_start,
    STATE(2182), 1,
      sym__unboxed_open,
    STATE(8210), 1,
      sym_constructor,
    STATE(14724), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12269), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12284), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12260), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12266), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8643), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8646), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(5030), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_RBRACE,
    STATE(3199), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [55132] = 28,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6380), 1,
      sym__conid,
    ACTIONS(8524), 1,
      sym__varid,
    ACTIONS(12296), 1,
      anon_sym_LPAREN,
    ACTIONS(12298), 1,
      anon_sym_SQUOTE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2792), 1,
      sym_type_name,
    STATE(3367), 1,
      sym_context,
    STATE(7046), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(12504), 1,
      sym_constraint,
    STATE(13388), 1,
      sym_type_infix,
    STATE(15134), 1,
      aux_sym__qualifying_module,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9607), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7087), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [55247] = 27,
    ACTIONS(11000), 1,
      sym__varid,
    ACTIONS(11004), 1,
      sym__integer_literal,
    ACTIONS(11010), 1,
      anon_sym_LPAREN,
    ACTIONS(11015), 1,
      anon_sym_LBRACK,
    ACTIONS(11019), 1,
      anon_sym__,
    ACTIONS(11021), 1,
      anon_sym_7,
    ACTIONS(11023), 1,
      sym__splice_dollar,
    ACTIONS(11025), 1,
      sym_quasiquote_start,
    ACTIONS(11027), 1,
      sym__strict,
    ACTIONS(11029), 1,
      sym__lazy,
    ACTIONS(12300), 1,
      sym__conid,
    STATE(315), 1,
      sym__unboxed_open,
    STATE(7993), 1,
      sym_constructor,
    STATE(8023), 1,
      sym__pat_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(8305), 1,
      sym_variable,
    STATE(8536), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11008), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11002), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11006), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8502), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10475), 6,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(3181), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [55360] = 29,
    ACTIONS(12303), 1,
      sym__varid,
    ACTIONS(12307), 1,
      sym__integer_literal,
    ACTIONS(12313), 1,
      anon_sym_LPAREN,
    ACTIONS(12315), 1,
      sym__conid,
    ACTIONS(12318), 1,
      anon_sym_LBRACK,
    ACTIONS(12320), 1,
      anon_sym_LBRACE,
    ACTIONS(12322), 1,
      anon_sym__,
    ACTIONS(12324), 1,
      anon_sym_7,
    ACTIONS(12326), 1,
      sym__splice_dollar,
    ACTIONS(12328), 1,
      sym_quasiquote_start,
    ACTIONS(12330), 1,
      sym__strict,
    ACTIONS(12332), 1,
      sym__lazy,
    STATE(475), 1,
      sym__unboxed_open,
    STATE(3977), 1,
      sym_constructor,
    STATE(4051), 1,
      sym_qualified_constructor,
    STATE(8553), 1,
      sym__pat_constructor,
    STATE(8915), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_variable,
    STATE(9006), 1,
      sym_literal,
    STATE(14379), 1,
      sym_pat_fields,
    STATE(15169), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12311), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12305), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12309), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(9106), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3305), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [55477] = 29,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(16852), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13954), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [55594] = 28,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6181), 1,
      sym__conid,
    ACTIONS(9402), 1,
      sym__varid,
    ACTIONS(12334), 1,
      anon_sym_LPAREN,
    ACTIONS(12336), 1,
      anon_sym_SQUOTE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2816), 1,
      sym_type_name,
    STATE(3416), 1,
      sym_context,
    STATE(7110), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(12776), 1,
      sym_constraint,
    STATE(13403), 1,
      sym_type_infix,
    STATE(15277), 1,
      aux_sym__qualifying_module,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9694), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7585), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [55709] = 28,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(9858), 1,
      anon_sym_LPAREN,
    ACTIONS(9860), 1,
      anon_sym_SQUOTE,
    ACTIONS(11401), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      sym_type_name,
    STATE(3402), 1,
      sym_context,
    STATE(5968), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(13786), 1,
      sym_type_infix,
    STATE(13871), 1,
      sym_constraint,
    STATE(14649), 1,
      aux_sym__qualifying_module,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9600), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6463), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [55824] = 28,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6545), 1,
      sym__conid,
    ACTIONS(9198), 1,
      sym__varid,
    ACTIONS(12338), 1,
      anon_sym_LPAREN,
    ACTIONS(12340), 1,
      anon_sym_SQUOTE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2786), 1,
      sym_type_name,
    STATE(3368), 1,
      sym_context,
    STATE(6997), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(12530), 1,
      sym_constraint,
    STATE(13219), 1,
      sym_type_infix,
    STATE(15261), 1,
      aux_sym__qualifying_module,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9674), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7098), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [55939] = 28,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(9844), 1,
      anon_sym_LPAREN,
    ACTIONS(9846), 1,
      anon_sym_SQUOTE,
    ACTIONS(11751), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2827), 1,
      sym_type_name,
    STATE(3418), 1,
      sym_context,
    STATE(5969), 1,
      sym_constructor,
    STATE(9450), 1,
      sym__context,
    STATE(13409), 1,
      sym_constraint,
    STATE(13961), 1,
      sym_type_infix,
    STATE(15009), 1,
      aux_sym__qualifying_module,
    STATE(15479), 1,
      sym__context_constraints,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9658), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6424), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [56054] = 29,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(18869), 1,
      sym__pattern_decl,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13823), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [56171] = 27,
    ACTIONS(11128), 1,
      sym__varid,
    ACTIONS(11132), 1,
      sym__integer_literal,
    ACTIONS(11138), 1,
      anon_sym_LPAREN,
    ACTIONS(11143), 1,
      anon_sym_LBRACK,
    ACTIONS(11147), 1,
      anon_sym__,
    ACTIONS(11149), 1,
      anon_sym_7,
    ACTIONS(11151), 1,
      sym__splice_dollar,
    ACTIONS(11153), 1,
      sym_quasiquote_start,
    ACTIONS(11155), 1,
      sym__strict,
    ACTIONS(11157), 1,
      sym__lazy,
    ACTIONS(12342), 1,
      sym__conid,
    STATE(423), 1,
      sym__unboxed_open,
    STATE(7943), 1,
      sym__pat_constructor,
    STATE(8116), 1,
      sym_constructor,
    STATE(8182), 1,
      sym__qcon,
    STATE(8187), 1,
      sym_variable,
    STATE(8271), 1,
      sym_qualified_constructor,
    STATE(8588), 1,
      sym_literal,
    STATE(14857), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11136), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11130), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11134), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8600), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    ACTIONS(10475), 6,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(3196), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [56284] = 28,
    ACTIONS(12345), 1,
      sym__varid,
    ACTIONS(12349), 1,
      sym__integer_literal,
    ACTIONS(12355), 1,
      anon_sym_DASH,
    ACTIONS(12357), 1,
      anon_sym_LPAREN,
    ACTIONS(12359), 1,
      sym__conid,
    ACTIONS(12361), 1,
      anon_sym_LBRACK,
    ACTIONS(12363), 1,
      anon_sym__,
    ACTIONS(12365), 1,
      anon_sym_7,
    ACTIONS(12367), 1,
      sym__splice_dollar,
    ACTIONS(12369), 1,
      sym_quasiquote_start,
    ACTIONS(12371), 1,
      sym__strict,
    ACTIONS(12373), 1,
      sym__lazy,
    STATE(335), 1,
      sym__unboxed_open,
    STATE(2854), 1,
      sym__pat_constructor,
    STATE(8096), 1,
      sym_constructor,
    STATE(8280), 1,
      sym__qcon,
    STATE(8294), 1,
      sym_qualified_constructor,
    STATE(12906), 1,
      sym_variable,
    STATE(13230), 1,
      sym_literal,
    STATE(15081), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12353), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14693), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12347), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12351), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13356), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11838), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [56398] = 28,
    ACTIONS(557), 1,
      anon_sym__,
    ACTIONS(579), 1,
      sym__strict,
    ACTIONS(581), 1,
      sym__lazy,
    ACTIONS(12375), 1,
      sym__varid,
    ACTIONS(12379), 1,
      sym__integer_literal,
    ACTIONS(12385), 1,
      anon_sym_DASH,
    ACTIONS(12387), 1,
      anon_sym_LPAREN,
    ACTIONS(12389), 1,
      sym__conid,
    ACTIONS(12391), 1,
      anon_sym_LBRACK,
    ACTIONS(12393), 1,
      anon_sym_7,
    ACTIONS(12395), 1,
      sym__splice_dollar,
    ACTIONS(12397), 1,
      sym_quasiquote_start,
    STATE(462), 1,
      sym__unboxed_open,
    STATE(2825), 1,
      sym__pat_constructor,
    STATE(7889), 1,
      sym_constructor,
    STATE(8054), 1,
      sym_qualified_constructor,
    STATE(8070), 1,
      sym__qcon,
    STATE(12516), 1,
      sym_variable,
    STATE(12754), 1,
      sym_literal,
    STATE(14874), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12383), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14561), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12377), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12381), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13060), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11079), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [56512] = 27,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12399), 1,
      anon_sym_SEMI,
    ACTIONS(12401), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17657), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [56624] = 27,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12403), 1,
      anon_sym_SEMI,
    ACTIONS(12405), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17687), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [56736] = 28,
    ACTIONS(661), 1,
      anon_sym__,
    ACTIONS(673), 1,
      sym__strict,
    ACTIONS(675), 1,
      sym__lazy,
    ACTIONS(10559), 1,
      sym__varid,
    ACTIONS(10563), 1,
      sym__integer_literal,
    ACTIONS(10569), 1,
      anon_sym_DASH,
    ACTIONS(10573), 1,
      sym__conid,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    ACTIONS(10577), 1,
      anon_sym_7,
    ACTIONS(10579), 1,
      sym__splice_dollar,
    ACTIONS(10581), 1,
      sym_quasiquote_start,
    ACTIONS(12407), 1,
      anon_sym_LPAREN,
    STATE(366), 1,
      sym__unboxed_open,
    STATE(2764), 1,
      sym__pat_constructor,
    STATE(7661), 1,
      sym_constructor,
    STATE(7780), 1,
      sym_qualified_constructor,
    STATE(7820), 1,
      sym__qcon,
    STATE(12024), 1,
      sym_variable,
    STATE(12264), 1,
      sym_literal,
    STATE(14862), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10567), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13162), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10561), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12470), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10062), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [56850] = 28,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(18269), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [56964] = 28,
    ACTIONS(12409), 1,
      sym__varid,
    ACTIONS(12413), 1,
      sym__integer_literal,
    ACTIONS(12419), 1,
      anon_sym_DASH,
    ACTIONS(12421), 1,
      anon_sym_LPAREN,
    ACTIONS(12423), 1,
      sym__conid,
    ACTIONS(12425), 1,
      anon_sym_LBRACK,
    ACTIONS(12427), 1,
      anon_sym__,
    ACTIONS(12429), 1,
      anon_sym_7,
    ACTIONS(12431), 1,
      sym__splice_dollar,
    ACTIONS(12433), 1,
      sym_quasiquote_start,
    ACTIONS(12435), 1,
      sym__strict,
    ACTIONS(12437), 1,
      sym__lazy,
    STATE(246), 1,
      sym__unboxed_open,
    STATE(3170), 1,
      sym__pat_constructor,
    STATE(8282), 1,
      sym_constructor,
    STATE(8549), 1,
      sym_qualified_constructor,
    STATE(8636), 1,
      sym__qcon,
    STATE(13254), 1,
      sym_variable,
    STATE(13703), 1,
      sym_literal,
    STATE(15196), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12417), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(16042), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12411), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12415), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13394), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12197), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [57078] = 24,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(12439), 1,
      sym__varid,
    ACTIONS(12445), 1,
      sym__integer_literal,
    ACTIONS(12454), 1,
      anon_sym_LPAREN,
    ACTIONS(12457), 1,
      sym__conid,
    ACTIONS(12460), 1,
      anon_sym_LBRACK,
    ACTIONS(12463), 1,
      anon_sym_SQUOTE,
    ACTIONS(12469), 1,
      anon_sym_EQ,
    ACTIONS(12471), 1,
      anon_sym_7,
    ACTIONS(12474), 1,
      sym__splice_dollar,
    ACTIONS(12477), 1,
      sym_quasiquote_start,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12451), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12466), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(6240), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(12442), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12448), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3453), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [57184] = 28,
    ACTIONS(12409), 1,
      sym__varid,
    ACTIONS(12413), 1,
      sym__integer_literal,
    ACTIONS(12419), 1,
      anon_sym_DASH,
    ACTIONS(12421), 1,
      anon_sym_LPAREN,
    ACTIONS(12423), 1,
      sym__conid,
    ACTIONS(12425), 1,
      anon_sym_LBRACK,
    ACTIONS(12427), 1,
      anon_sym__,
    ACTIONS(12429), 1,
      anon_sym_7,
    ACTIONS(12431), 1,
      sym__splice_dollar,
    ACTIONS(12433), 1,
      sym_quasiquote_start,
    ACTIONS(12435), 1,
      sym__strict,
    ACTIONS(12437), 1,
      sym__lazy,
    STATE(246), 1,
      sym__unboxed_open,
    STATE(3170), 1,
      sym__pat_constructor,
    STATE(8282), 1,
      sym_constructor,
    STATE(8549), 1,
      sym_qualified_constructor,
    STATE(8636), 1,
      sym__qcon,
    STATE(13254), 1,
      sym_variable,
    STATE(13703), 1,
      sym_literal,
    STATE(15196), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12417), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(16044), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12411), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12415), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13394), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12197), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [57298] = 27,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12488), 1,
      anon_sym_LPAREN,
    ACTIONS(12490), 1,
      sym__conid,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12498), 1,
      anon_sym_EQ,
    ACTIONS(12500), 1,
      anon_sym_family,
    ACTIONS(12502), 1,
      anon_sym_instance,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(7809), 1,
      sym_constructor,
    STATE(13149), 1,
      sym__simpletype,
    STATE(14079), 1,
      sym__simpletype_infix,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8203), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(8872), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3446), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [57410] = 27,
    ACTIONS(11843), 1,
      sym__varid,
    ACTIONS(11847), 1,
      sym__integer_literal,
    ACTIONS(11853), 1,
      anon_sym_LPAREN,
    ACTIONS(11858), 1,
      anon_sym_LBRACK,
    ACTIONS(11862), 1,
      anon_sym__,
    ACTIONS(11864), 1,
      anon_sym_7,
    ACTIONS(11866), 1,
      sym__splice_dollar,
    ACTIONS(11868), 1,
      sym_quasiquote_start,
    ACTIONS(11870), 1,
      sym__strict,
    ACTIONS(11872), 1,
      sym__lazy,
    ACTIONS(12510), 1,
      sym__conid,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(8206), 1,
      sym__pat_constructor,
    STATE(8282), 1,
      sym_constructor,
    STATE(8549), 1,
      sym_qualified_constructor,
    STATE(8605), 1,
      sym_variable,
    STATE(8636), 1,
      sym__qcon,
    STATE(8922), 1,
      sym_literal,
    STATE(15196), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11851), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11845), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11849), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10475), 5,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
    STATE(8940), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3242), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [57522] = 27,
    ACTIONS(5076), 1,
      sym__varid,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12513), 1,
      anon_sym_LPAREN,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(12517), 1,
      anon_sym_EQ,
    ACTIONS(12519), 1,
      anon_sym_family,
    ACTIONS(12521), 1,
      anon_sym_instance,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(7876), 1,
      sym_constructor,
    STATE(13543), 1,
      sym__simpletype,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8213), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    STATE(8872), 3,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3447), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [57634] = 28,
    ACTIONS(12523), 1,
      sym__varid,
    ACTIONS(12527), 1,
      sym__integer_literal,
    ACTIONS(12533), 1,
      anon_sym_DASH,
    ACTIONS(12535), 1,
      anon_sym_LPAREN,
    ACTIONS(12537), 1,
      sym__conid,
    ACTIONS(12539), 1,
      anon_sym_LBRACK,
    ACTIONS(12541), 1,
      anon_sym__,
    ACTIONS(12543), 1,
      anon_sym_7,
    ACTIONS(12545), 1,
      sym__splice_dollar,
    ACTIONS(12547), 1,
      sym_quasiquote_start,
    ACTIONS(12549), 1,
      sym__strict,
    ACTIONS(12551), 1,
      sym__lazy,
    STATE(316), 1,
      sym__unboxed_open,
    STATE(3012), 1,
      sym__pat_constructor,
    STATE(8298), 1,
      sym_constructor,
    STATE(8535), 1,
      sym__qcon,
    STATE(8545), 1,
      sym_qualified_constructor,
    STATE(13258), 1,
      sym_variable,
    STATE(13742), 1,
      sym_literal,
    STATE(15198), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12531), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(16041), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12525), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12529), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13590), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12084), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [57748] = 28,
    ACTIONS(12345), 1,
      sym__varid,
    ACTIONS(12349), 1,
      sym__integer_literal,
    ACTIONS(12355), 1,
      anon_sym_DASH,
    ACTIONS(12357), 1,
      anon_sym_LPAREN,
    ACTIONS(12359), 1,
      sym__conid,
    ACTIONS(12361), 1,
      anon_sym_LBRACK,
    ACTIONS(12363), 1,
      anon_sym__,
    ACTIONS(12365), 1,
      anon_sym_7,
    ACTIONS(12367), 1,
      sym__splice_dollar,
    ACTIONS(12369), 1,
      sym_quasiquote_start,
    ACTIONS(12371), 1,
      sym__strict,
    ACTIONS(12373), 1,
      sym__lazy,
    STATE(335), 1,
      sym__unboxed_open,
    STATE(2854), 1,
      sym__pat_constructor,
    STATE(8096), 1,
      sym_constructor,
    STATE(8280), 1,
      sym__qcon,
    STATE(8294), 1,
      sym_qualified_constructor,
    STATE(12906), 1,
      sym_variable,
    STATE(13230), 1,
      sym_literal,
    STATE(15081), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12353), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14779), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12347), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12351), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13356), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11838), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [57862] = 27,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12553), 1,
      anon_sym_SEMI,
    ACTIONS(12555), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15587), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [57974] = 27,
    ACTIONS(11558), 1,
      sym__varid,
    ACTIONS(11562), 1,
      sym__integer_literal,
    ACTIONS(11568), 1,
      anon_sym_LPAREN,
    ACTIONS(11573), 1,
      anon_sym_LBRACK,
    ACTIONS(11577), 1,
      anon_sym__,
    ACTIONS(11579), 1,
      anon_sym_7,
    ACTIONS(11581), 1,
      sym__splice_dollar,
    ACTIONS(11583), 1,
      sym_quasiquote_start,
    ACTIONS(11585), 1,
      sym__strict,
    ACTIONS(11587), 1,
      sym__lazy,
    ACTIONS(12557), 1,
      sym__conid,
    STATE(476), 1,
      sym__unboxed_open,
    STATE(8298), 1,
      sym_constructor,
    STATE(8301), 1,
      sym__pat_constructor,
    STATE(8535), 1,
      sym__qcon,
    STATE(8545), 1,
      sym_qualified_constructor,
    STATE(8609), 1,
      sym_variable,
    STATE(8853), 1,
      sym_literal,
    STATE(15198), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11566), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11560), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11564), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10475), 5,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(8846), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3235), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [58086] = 27,
    ACTIONS(12560), 1,
      sym__varid,
    ACTIONS(12566), 1,
      sym__integer_literal,
    ACTIONS(12575), 1,
      anon_sym_LPAREN,
    ACTIONS(12578), 1,
      sym__conid,
    ACTIONS(12581), 1,
      anon_sym_LBRACK,
    ACTIONS(12584), 1,
      anon_sym__,
    ACTIONS(12587), 1,
      anon_sym_7,
    ACTIONS(12590), 1,
      sym__splice_dollar,
    ACTIONS(12593), 1,
      sym_quasiquote_start,
    ACTIONS(12596), 1,
      sym__strict,
    ACTIONS(12599), 1,
      sym__lazy,
    STATE(473), 1,
      sym__unboxed_open,
    STATE(8287), 1,
      sym__pat_constructor,
    STATE(8357), 1,
      sym_constructor,
    STATE(8515), 1,
      sym_variable,
    STATE(8520), 1,
      sym_qualified_constructor,
    STATE(8599), 1,
      sym__qcon,
    STATE(8905), 1,
      sym_literal,
    STATE(14966), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12572), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12563), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12569), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10346), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(8856), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3226), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [58198] = 28,
    ACTIONS(557), 1,
      anon_sym__,
    ACTIONS(579), 1,
      sym__strict,
    ACTIONS(581), 1,
      sym__lazy,
    ACTIONS(12375), 1,
      sym__varid,
    ACTIONS(12379), 1,
      sym__integer_literal,
    ACTIONS(12385), 1,
      anon_sym_DASH,
    ACTIONS(12387), 1,
      anon_sym_LPAREN,
    ACTIONS(12389), 1,
      sym__conid,
    ACTIONS(12391), 1,
      anon_sym_LBRACK,
    ACTIONS(12393), 1,
      anon_sym_7,
    ACTIONS(12395), 1,
      sym__splice_dollar,
    ACTIONS(12397), 1,
      sym_quasiquote_start,
    STATE(462), 1,
      sym__unboxed_open,
    STATE(2825), 1,
      sym__pat_constructor,
    STATE(7889), 1,
      sym_constructor,
    STATE(8054), 1,
      sym_qualified_constructor,
    STATE(8070), 1,
      sym__qcon,
    STATE(12516), 1,
      sym_variable,
    STATE(12754), 1,
      sym_literal,
    STATE(14874), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12383), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14443), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12377), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12381), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13060), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11079), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [58312] = 22,
    ACTIONS(12602), 1,
      sym__varid,
    ACTIONS(12608), 1,
      sym__integer_literal,
    ACTIONS(12617), 1,
      anon_sym_LPAREN,
    ACTIONS(12620), 1,
      sym__conid,
    ACTIONS(12623), 1,
      anon_sym_LBRACK,
    ACTIONS(12626), 1,
      anon_sym_SQUOTE,
    ACTIONS(12632), 1,
      anon_sym_7,
    ACTIONS(12635), 1,
      sym__splice_dollar,
    ACTIONS(12638), 1,
      sym_quasiquote_start,
    STATE(2208), 1,
      sym__unboxed_open,
    STATE(8551), 1,
      sym_constructor,
    STATE(14954), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12614), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12629), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12605), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12611), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5030), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
    STATE(8773), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8809), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3228), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [58414] = 28,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15167), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [58528] = 28,
    ACTIONS(1192), 1,
      anon_sym__,
    ACTIONS(1212), 1,
      sym__strict,
    ACTIONS(1214), 1,
      sym__lazy,
    ACTIONS(12641), 1,
      sym__varid,
    ACTIONS(12645), 1,
      sym__integer_literal,
    ACTIONS(12651), 1,
      anon_sym_DASH,
    ACTIONS(12653), 1,
      anon_sym_LPAREN,
    ACTIONS(12655), 1,
      sym__conid,
    ACTIONS(12657), 1,
      anon_sym_LBRACK,
    ACTIONS(12659), 1,
      anon_sym_7,
    ACTIONS(12661), 1,
      sym__splice_dollar,
    ACTIONS(12663), 1,
      sym_quasiquote_start,
    STATE(459), 1,
      sym__unboxed_open,
    STATE(2881), 1,
      sym__pat_constructor,
    STATE(8017), 1,
      sym_constructor,
    STATE(8254), 1,
      sym_qualified_constructor,
    STATE(8386), 1,
      sym__qcon,
    STATE(13094), 1,
      sym_variable,
    STATE(13249), 1,
      sym_literal,
    STATE(15071), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12649), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15076), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12643), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12647), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13328), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11761), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [58642] = 22,
    ACTIONS(12665), 1,
      sym__varid,
    ACTIONS(12669), 1,
      sym__integer_literal,
    ACTIONS(12675), 1,
      anon_sym_LPAREN,
    ACTIONS(12677), 1,
      sym__conid,
    ACTIONS(12679), 1,
      anon_sym_LBRACK,
    ACTIONS(12681), 1,
      anon_sym_SQUOTE,
    ACTIONS(12685), 1,
      anon_sym_7,
    ACTIONS(12687), 1,
      sym__splice_dollar,
    ACTIONS(12689), 1,
      sym_quasiquote_start,
    STATE(2189), 1,
      sym__unboxed_open,
    STATE(8427), 1,
      sym_constructor,
    STATE(14776), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12673), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12683), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12667), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12671), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(11643), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
    STATE(8904), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8989), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3239), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [58744] = 27,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12691), 1,
      anon_sym_SEMI,
    ACTIONS(12693), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15578), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [58856] = 28,
    ACTIONS(12695), 1,
      sym__varid,
    ACTIONS(12699), 1,
      sym__integer_literal,
    ACTIONS(12705), 1,
      anon_sym_DASH,
    ACTIONS(12707), 1,
      anon_sym_LPAREN,
    ACTIONS(12709), 1,
      sym__conid,
    ACTIONS(12711), 1,
      anon_sym_LBRACK,
    ACTIONS(12713), 1,
      anon_sym__,
    ACTIONS(12715), 1,
      anon_sym_7,
    ACTIONS(12717), 1,
      sym__splice_dollar,
    ACTIONS(12719), 1,
      sym_quasiquote_start,
    ACTIONS(12721), 1,
      sym__strict,
    ACTIONS(12723), 1,
      sym__lazy,
    STATE(242), 1,
      sym__unboxed_open,
    STATE(2886), 1,
      sym__pat_constructor,
    STATE(8116), 1,
      sym_constructor,
    STATE(8182), 1,
      sym__qcon,
    STATE(8271), 1,
      sym_qualified_constructor,
    STATE(12735), 1,
      sym_variable,
    STATE(13384), 1,
      sym_literal,
    STATE(14857), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12703), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15186), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12697), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12701), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13274), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11927), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [58970] = 27,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12725), 1,
      anon_sym_SEMI,
    ACTIONS(12727), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15729), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [59082] = 27,
    ACTIONS(12729), 1,
      sym__varid,
    ACTIONS(12735), 1,
      sym__integer_literal,
    ACTIONS(12744), 1,
      anon_sym_LPAREN,
    ACTIONS(12747), 1,
      sym__conid,
    ACTIONS(12750), 1,
      anon_sym_LBRACK,
    ACTIONS(12753), 1,
      anon_sym__,
    ACTIONS(12756), 1,
      anon_sym_7,
    ACTIONS(12759), 1,
      sym__splice_dollar,
    ACTIONS(12762), 1,
      sym_quasiquote_start,
    ACTIONS(12765), 1,
      sym__strict,
    ACTIONS(12768), 1,
      sym__lazy,
    STATE(476), 1,
      sym__unboxed_open,
    STATE(8298), 1,
      sym_constructor,
    STATE(8301), 1,
      sym__pat_constructor,
    STATE(8535), 1,
      sym__qcon,
    STATE(8545), 1,
      sym_qualified_constructor,
    STATE(8609), 1,
      sym_variable,
    STATE(8853), 1,
      sym_literal,
    STATE(15198), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12741), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12732), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12738), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10346), 5,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(8846), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3235), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [59194] = 28,
    ACTIONS(1192), 1,
      anon_sym__,
    ACTIONS(1212), 1,
      sym__strict,
    ACTIONS(1214), 1,
      sym__lazy,
    ACTIONS(12641), 1,
      sym__varid,
    ACTIONS(12645), 1,
      sym__integer_literal,
    ACTIONS(12651), 1,
      anon_sym_DASH,
    ACTIONS(12653), 1,
      anon_sym_LPAREN,
    ACTIONS(12655), 1,
      sym__conid,
    ACTIONS(12657), 1,
      anon_sym_LBRACK,
    ACTIONS(12659), 1,
      anon_sym_7,
    ACTIONS(12661), 1,
      sym__splice_dollar,
    ACTIONS(12663), 1,
      sym_quasiquote_start,
    STATE(459), 1,
      sym__unboxed_open,
    STATE(2881), 1,
      sym__pat_constructor,
    STATE(8017), 1,
      sym_constructor,
    STATE(8254), 1,
      sym_qualified_constructor,
    STATE(8386), 1,
      sym__qcon,
    STATE(13094), 1,
      sym_variable,
    STATE(13249), 1,
      sym_literal,
    STATE(15071), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12649), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15204), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12643), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12647), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13328), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11761), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [59308] = 28,
    ACTIONS(1378), 1,
      anon_sym__,
    ACTIONS(1386), 1,
      sym__strict,
    ACTIONS(1388), 1,
      sym__lazy,
    ACTIONS(12771), 1,
      sym__varid,
    ACTIONS(12775), 1,
      sym__integer_literal,
    ACTIONS(12781), 1,
      anon_sym_DASH,
    ACTIONS(12783), 1,
      anon_sym_LPAREN,
    ACTIONS(12785), 1,
      sym__conid,
    ACTIONS(12787), 1,
      anon_sym_LBRACK,
    ACTIONS(12789), 1,
      anon_sym_7,
    ACTIONS(12791), 1,
      sym__splice_dollar,
    ACTIONS(12793), 1,
      sym_quasiquote_start,
    STATE(263), 1,
      sym__unboxed_open,
    STATE(2850), 1,
      sym__pat_constructor,
    STATE(8041), 1,
      sym_constructor,
    STATE(8307), 1,
      sym_qualified_constructor,
    STATE(8383), 1,
      sym__qcon,
    STATE(12874), 1,
      sym_variable,
    STATE(13152), 1,
      sym_literal,
    STATE(14715), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15061), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13099), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11508), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [59422] = 28,
    ACTIONS(1378), 1,
      anon_sym__,
    ACTIONS(1386), 1,
      sym__strict,
    ACTIONS(1388), 1,
      sym__lazy,
    ACTIONS(12771), 1,
      sym__varid,
    ACTIONS(12775), 1,
      sym__integer_literal,
    ACTIONS(12781), 1,
      anon_sym_DASH,
    ACTIONS(12783), 1,
      anon_sym_LPAREN,
    ACTIONS(12785), 1,
      sym__conid,
    ACTIONS(12787), 1,
      anon_sym_LBRACK,
    ACTIONS(12789), 1,
      anon_sym_7,
    ACTIONS(12791), 1,
      sym__splice_dollar,
    ACTIONS(12793), 1,
      sym_quasiquote_start,
    STATE(263), 1,
      sym__unboxed_open,
    STATE(2850), 1,
      sym__pat_constructor,
    STATE(8041), 1,
      sym_constructor,
    STATE(8307), 1,
      sym_qualified_constructor,
    STATE(8383), 1,
      sym__qcon,
    STATE(12874), 1,
      sym_variable,
    STATE(13152), 1,
      sym_literal,
    STATE(14715), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15294), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13099), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11508), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [59536] = 22,
    ACTIONS(12795), 1,
      sym__varid,
    ACTIONS(12801), 1,
      sym__integer_literal,
    ACTIONS(12810), 1,
      anon_sym_LPAREN,
    ACTIONS(12813), 1,
      sym__conid,
    ACTIONS(12816), 1,
      anon_sym_LBRACK,
    ACTIONS(12819), 1,
      anon_sym_SQUOTE,
    ACTIONS(12825), 1,
      anon_sym_7,
    ACTIONS(12828), 1,
      sym__splice_dollar,
    ACTIONS(12831), 1,
      sym_quasiquote_start,
    STATE(2189), 1,
      sym__unboxed_open,
    STATE(8427), 1,
      sym_constructor,
    STATE(14776), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12807), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12822), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12798), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12804), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5030), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
    STATE(8904), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8989), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3239), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [59638] = 28,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10537), 1,
      anon_sym_DASH,
    ACTIONS(10539), 1,
      anon_sym_LPAREN,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(2870), 1,
      sym__pat_constructor,
    STATE(7993), 1,
      sym_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13035), 1,
      sym_variable,
    STATE(13142), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15365), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11752), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [59752] = 27,
    ACTIONS(11507), 1,
      sym__varid,
    ACTIONS(11511), 1,
      sym__integer_literal,
    ACTIONS(11517), 1,
      anon_sym_LPAREN,
    ACTIONS(11522), 1,
      anon_sym_LBRACK,
    ACTIONS(11526), 1,
      anon_sym__,
    ACTIONS(11528), 1,
      anon_sym_7,
    ACTIONS(11530), 1,
      sym__splice_dollar,
    ACTIONS(11532), 1,
      sym_quasiquote_start,
    ACTIONS(11534), 1,
      sym__strict,
    ACTIONS(11536), 1,
      sym__lazy,
    ACTIONS(12834), 1,
      sym__conid,
    STATE(473), 1,
      sym__unboxed_open,
    STATE(8287), 1,
      sym__pat_constructor,
    STATE(8357), 1,
      sym_constructor,
    STATE(8515), 1,
      sym_variable,
    STATE(8520), 1,
      sym_qualified_constructor,
    STATE(8599), 1,
      sym__qcon,
    STATE(8905), 1,
      sym_literal,
    STATE(14966), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11515), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11509), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11513), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10475), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(8856), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3226), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [59864] = 27,
    ACTIONS(12837), 1,
      sym__varid,
    ACTIONS(12843), 1,
      sym__integer_literal,
    ACTIONS(12852), 1,
      anon_sym_LPAREN,
    ACTIONS(12855), 1,
      sym__conid,
    ACTIONS(12858), 1,
      anon_sym_LBRACK,
    ACTIONS(12861), 1,
      anon_sym__,
    ACTIONS(12864), 1,
      anon_sym_7,
    ACTIONS(12867), 1,
      sym__splice_dollar,
    ACTIONS(12870), 1,
      sym_quasiquote_start,
    ACTIONS(12873), 1,
      sym__strict,
    ACTIONS(12876), 1,
      sym__lazy,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(8206), 1,
      sym__pat_constructor,
    STATE(8282), 1,
      sym_constructor,
    STATE(8549), 1,
      sym_qualified_constructor,
    STATE(8605), 1,
      sym_variable,
    STATE(8636), 1,
      sym__qcon,
    STATE(8922), 1,
      sym_literal,
    STATE(15196), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12849), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12840), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12846), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10346), 5,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
    STATE(8940), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3242), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [59976] = 28,
    ACTIONS(12879), 1,
      sym__varid,
    ACTIONS(12883), 1,
      sym__integer_literal,
    ACTIONS(12889), 1,
      anon_sym_DASH,
    ACTIONS(12891), 1,
      anon_sym_LPAREN,
    ACTIONS(12893), 1,
      sym__conid,
    ACTIONS(12895), 1,
      anon_sym_LBRACK,
    ACTIONS(12897), 1,
      anon_sym__,
    ACTIONS(12899), 1,
      anon_sym_7,
    ACTIONS(12901), 1,
      sym__splice_dollar,
    ACTIONS(12903), 1,
      sym_quasiquote_start,
    ACTIONS(12905), 1,
      sym__strict,
    ACTIONS(12907), 1,
      sym__lazy,
    STATE(448), 1,
      sym__unboxed_open,
    STATE(2997), 1,
      sym__pat_constructor,
    STATE(8357), 1,
      sym_constructor,
    STATE(8520), 1,
      sym_qualified_constructor,
    STATE(8599), 1,
      sym__qcon,
    STATE(13211), 1,
      sym_variable,
    STATE(13720), 1,
      sym_literal,
    STATE(14966), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12887), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(16228), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12881), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12885), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13393), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12091), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [60090] = 28,
    ACTIONS(661), 1,
      anon_sym__,
    ACTIONS(673), 1,
      sym__strict,
    ACTIONS(675), 1,
      sym__lazy,
    ACTIONS(10559), 1,
      sym__varid,
    ACTIONS(10563), 1,
      sym__integer_literal,
    ACTIONS(10569), 1,
      anon_sym_DASH,
    ACTIONS(10573), 1,
      sym__conid,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    ACTIONS(10577), 1,
      anon_sym_7,
    ACTIONS(10579), 1,
      sym__splice_dollar,
    ACTIONS(10581), 1,
      sym_quasiquote_start,
    ACTIONS(12407), 1,
      anon_sym_LPAREN,
    STATE(366), 1,
      sym__unboxed_open,
    STATE(2764), 1,
      sym__pat_constructor,
    STATE(7661), 1,
      sym_constructor,
    STATE(7780), 1,
      sym_qualified_constructor,
    STATE(7820), 1,
      sym__qcon,
    STATE(12024), 1,
      sym_variable,
    STATE(12264), 1,
      sym_literal,
    STATE(14862), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10567), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(18091), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10561), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12470), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10062), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [60204] = 28,
    ACTIONS(255), 1,
      anon_sym__,
    ACTIONS(281), 1,
      sym__strict,
    ACTIONS(283), 1,
      sym__lazy,
    ACTIONS(12909), 1,
      sym__varid,
    ACTIONS(12913), 1,
      sym__integer_literal,
    ACTIONS(12919), 1,
      anon_sym_DASH,
    ACTIONS(12921), 1,
      anon_sym_LPAREN,
    ACTIONS(12923), 1,
      sym__conid,
    ACTIONS(12925), 1,
      anon_sym_LBRACK,
    ACTIONS(12927), 1,
      anon_sym_7,
    ACTIONS(12929), 1,
      sym__splice_dollar,
    ACTIONS(12931), 1,
      sym_quasiquote_start,
    STATE(463), 1,
      sym__unboxed_open,
    STATE(2789), 1,
      sym__pat_constructor,
    STATE(7727), 1,
      sym_constructor,
    STATE(7896), 1,
      sym__qcon,
    STATE(7923), 1,
      sym_qualified_constructor,
    STATE(12236), 1,
      sym_variable,
    STATE(12725), 1,
      sym_literal,
    STATE(15107), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12917), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13567), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12911), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12915), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12718), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10367), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [60318] = 27,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12933), 1,
      anon_sym_SEMI,
    ACTIONS(12935), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17266), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [60430] = 27,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12937), 1,
      anon_sym_SEMI,
    ACTIONS(12939), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15756), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [60542] = 27,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12941), 1,
      anon_sym_SEMI,
    ACTIONS(12943), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15554), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [60654] = 27,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12945), 1,
      anon_sym_SEMI,
    ACTIONS(12947), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15762), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [60766] = 28,
    ACTIONS(12879), 1,
      sym__varid,
    ACTIONS(12883), 1,
      sym__integer_literal,
    ACTIONS(12889), 1,
      anon_sym_DASH,
    ACTIONS(12891), 1,
      anon_sym_LPAREN,
    ACTIONS(12893), 1,
      sym__conid,
    ACTIONS(12895), 1,
      anon_sym_LBRACK,
    ACTIONS(12897), 1,
      anon_sym__,
    ACTIONS(12899), 1,
      anon_sym_7,
    ACTIONS(12901), 1,
      sym__splice_dollar,
    ACTIONS(12903), 1,
      sym_quasiquote_start,
    ACTIONS(12905), 1,
      sym__strict,
    ACTIONS(12907), 1,
      sym__lazy,
    STATE(448), 1,
      sym__unboxed_open,
    STATE(2997), 1,
      sym__pat_constructor,
    STATE(8357), 1,
      sym_constructor,
    STATE(8520), 1,
      sym_qualified_constructor,
    STATE(8599), 1,
      sym__qcon,
    STATE(13211), 1,
      sym_variable,
    STATE(13720), 1,
      sym_literal,
    STATE(14966), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12887), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(16225), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12881), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12885), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13393), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12091), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [60880] = 28,
    ACTIONS(12523), 1,
      sym__varid,
    ACTIONS(12527), 1,
      sym__integer_literal,
    ACTIONS(12533), 1,
      anon_sym_DASH,
    ACTIONS(12535), 1,
      anon_sym_LPAREN,
    ACTIONS(12537), 1,
      sym__conid,
    ACTIONS(12539), 1,
      anon_sym_LBRACK,
    ACTIONS(12541), 1,
      anon_sym__,
    ACTIONS(12543), 1,
      anon_sym_7,
    ACTIONS(12545), 1,
      sym__splice_dollar,
    ACTIONS(12547), 1,
      sym_quasiquote_start,
    ACTIONS(12549), 1,
      sym__strict,
    ACTIONS(12551), 1,
      sym__lazy,
    STATE(316), 1,
      sym__unboxed_open,
    STATE(3012), 1,
      sym__pat_constructor,
    STATE(8298), 1,
      sym_constructor,
    STATE(8535), 1,
      sym__qcon,
    STATE(8545), 1,
      sym_qualified_constructor,
    STATE(13258), 1,
      sym_variable,
    STATE(13742), 1,
      sym_literal,
    STATE(15198), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12531), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17553), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12525), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12529), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13590), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12084), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [60994] = 22,
    ACTIONS(12490), 1,
      sym__conid,
    ACTIONS(12949), 1,
      sym__varid,
    ACTIONS(12953), 1,
      sym__integer_literal,
    ACTIONS(12959), 1,
      anon_sym_LPAREN,
    ACTIONS(12961), 1,
      anon_sym_LBRACK,
    ACTIONS(12963), 1,
      anon_sym_SQUOTE,
    ACTIONS(12967), 1,
      anon_sym_7,
    ACTIONS(12969), 1,
      sym__splice_dollar,
    ACTIONS(12971), 1,
      sym_quasiquote_start,
    STATE(2208), 1,
      sym__unboxed_open,
    STATE(8551), 1,
      sym_constructor,
    STATE(14954), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12957), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12965), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12951), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12955), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(11643), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
    STATE(8773), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8809), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3228), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [61096] = 22,
    ACTIONS(12973), 1,
      sym__varid,
    ACTIONS(12977), 1,
      sym__integer_literal,
    ACTIONS(12983), 1,
      anon_sym_LPAREN,
    ACTIONS(12985), 1,
      sym__conid,
    ACTIONS(12987), 1,
      anon_sym_LBRACK,
    ACTIONS(12989), 1,
      anon_sym_SQUOTE,
    ACTIONS(12993), 1,
      anon_sym_7,
    ACTIONS(12995), 1,
      sym__splice_dollar,
    ACTIONS(12997), 1,
      sym_quasiquote_start,
    STATE(2098), 1,
      sym__unboxed_open,
    STATE(8614), 1,
      sym_constructor,
    STATE(14977), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12981), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12991), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12975), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12979), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(11643), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
    STATE(8732), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8836), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(3255), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [61198] = 28,
    ACTIONS(12523), 1,
      sym__varid,
    ACTIONS(12527), 1,
      sym__integer_literal,
    ACTIONS(12533), 1,
      anon_sym_DASH,
    ACTIONS(12535), 1,
      anon_sym_LPAREN,
    ACTIONS(12537), 1,
      sym__conid,
    ACTIONS(12539), 1,
      anon_sym_LBRACK,
    ACTIONS(12541), 1,
      anon_sym__,
    ACTIONS(12543), 1,
      anon_sym_7,
    ACTIONS(12545), 1,
      sym__splice_dollar,
    ACTIONS(12547), 1,
      sym_quasiquote_start,
    ACTIONS(12549), 1,
      sym__strict,
    ACTIONS(12551), 1,
      sym__lazy,
    STATE(316), 1,
      sym__unboxed_open,
    STATE(3012), 1,
      sym__pat_constructor,
    STATE(8298), 1,
      sym_constructor,
    STATE(8535), 1,
      sym__qcon,
    STATE(8545), 1,
      sym_qualified_constructor,
    STATE(13258), 1,
      sym_variable,
    STATE(13742), 1,
      sym_literal,
    STATE(15198), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12531), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(17478), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12525), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12529), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13590), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12084), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [61312] = 22,
    ACTIONS(12999), 1,
      sym__varid,
    ACTIONS(13005), 1,
      sym__integer_literal,
    ACTIONS(13014), 1,
      anon_sym_LPAREN,
    ACTIONS(13017), 1,
      sym__conid,
    ACTIONS(13020), 1,
      anon_sym_LBRACK,
    ACTIONS(13023), 1,
      anon_sym_SQUOTE,
    ACTIONS(13029), 1,
      anon_sym_7,
    ACTIONS(13032), 1,
      sym__splice_dollar,
    ACTIONS(13035), 1,
      sym_quasiquote_start,
    STATE(2098), 1,
      sym__unboxed_open,
    STATE(8614), 1,
      sym_constructor,
    STATE(14977), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13011), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13026), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13002), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13008), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5030), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
    STATE(8732), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8836), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(3255), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [61414] = 28,
    ACTIONS(12409), 1,
      sym__varid,
    ACTIONS(12413), 1,
      sym__integer_literal,
    ACTIONS(12419), 1,
      anon_sym_DASH,
    ACTIONS(12421), 1,
      anon_sym_LPAREN,
    ACTIONS(12423), 1,
      sym__conid,
    ACTIONS(12425), 1,
      anon_sym_LBRACK,
    ACTIONS(12427), 1,
      anon_sym__,
    ACTIONS(12429), 1,
      anon_sym_7,
    ACTIONS(12431), 1,
      sym__splice_dollar,
    ACTIONS(12433), 1,
      sym_quasiquote_start,
    ACTIONS(12435), 1,
      sym__strict,
    ACTIONS(12437), 1,
      sym__lazy,
    STATE(246), 1,
      sym__unboxed_open,
    STATE(3170), 1,
      sym__pat_constructor,
    STATE(8282), 1,
      sym_constructor,
    STATE(8549), 1,
      sym_qualified_constructor,
    STATE(8636), 1,
      sym__qcon,
    STATE(13254), 1,
      sym_variable,
    STATE(13703), 1,
      sym_literal,
    STATE(15196), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12417), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15622), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12411), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12415), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13394), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12197), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [61528] = 28,
    ACTIONS(12879), 1,
      sym__varid,
    ACTIONS(12883), 1,
      sym__integer_literal,
    ACTIONS(12889), 1,
      anon_sym_DASH,
    ACTIONS(12891), 1,
      anon_sym_LPAREN,
    ACTIONS(12893), 1,
      sym__conid,
    ACTIONS(12895), 1,
      anon_sym_LBRACK,
    ACTIONS(12897), 1,
      anon_sym__,
    ACTIONS(12899), 1,
      anon_sym_7,
    ACTIONS(12901), 1,
      sym__splice_dollar,
    ACTIONS(12903), 1,
      sym_quasiquote_start,
    ACTIONS(12905), 1,
      sym__strict,
    ACTIONS(12907), 1,
      sym__lazy,
    STATE(448), 1,
      sym__unboxed_open,
    STATE(2997), 1,
      sym__pat_constructor,
    STATE(8357), 1,
      sym_constructor,
    STATE(8520), 1,
      sym_qualified_constructor,
    STATE(8599), 1,
      sym__qcon,
    STATE(13211), 1,
      sym_variable,
    STATE(13720), 1,
      sym_literal,
    STATE(14966), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12887), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(16415), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12881), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12885), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13393), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12091), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [61642] = 28,
    ACTIONS(12345), 1,
      sym__varid,
    ACTIONS(12349), 1,
      sym__integer_literal,
    ACTIONS(12355), 1,
      anon_sym_DASH,
    ACTIONS(12357), 1,
      anon_sym_LPAREN,
    ACTIONS(12359), 1,
      sym__conid,
    ACTIONS(12361), 1,
      anon_sym_LBRACK,
    ACTIONS(12363), 1,
      anon_sym__,
    ACTIONS(12365), 1,
      anon_sym_7,
    ACTIONS(12367), 1,
      sym__splice_dollar,
    ACTIONS(12369), 1,
      sym_quasiquote_start,
    ACTIONS(12371), 1,
      sym__strict,
    ACTIONS(12373), 1,
      sym__lazy,
    STATE(335), 1,
      sym__unboxed_open,
    STATE(2854), 1,
      sym__pat_constructor,
    STATE(8096), 1,
      sym_constructor,
    STATE(8280), 1,
      sym__qcon,
    STATE(8294), 1,
      sym_qualified_constructor,
    STATE(12906), 1,
      sym_variable,
    STATE(13230), 1,
      sym_literal,
    STATE(15081), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12353), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14813), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12347), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12351), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13356), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11838), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [61756] = 28,
    ACTIONS(255), 1,
      anon_sym__,
    ACTIONS(281), 1,
      sym__strict,
    ACTIONS(283), 1,
      sym__lazy,
    ACTIONS(12909), 1,
      sym__varid,
    ACTIONS(12913), 1,
      sym__integer_literal,
    ACTIONS(12919), 1,
      anon_sym_DASH,
    ACTIONS(12921), 1,
      anon_sym_LPAREN,
    ACTIONS(12923), 1,
      sym__conid,
    ACTIONS(12925), 1,
      anon_sym_LBRACK,
    ACTIONS(12927), 1,
      anon_sym_7,
    ACTIONS(12929), 1,
      sym__splice_dollar,
    ACTIONS(12931), 1,
      sym_quasiquote_start,
    STATE(463), 1,
      sym__unboxed_open,
    STATE(2789), 1,
      sym__pat_constructor,
    STATE(7727), 1,
      sym_constructor,
    STATE(7896), 1,
      sym__qcon,
    STATE(7923), 1,
      sym_qualified_constructor,
    STATE(12236), 1,
      sym_variable,
    STATE(12725), 1,
      sym_literal,
    STATE(15107), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12917), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13721), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12911), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12915), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12718), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10367), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [61870] = 28,
    ACTIONS(33), 1,
      anon_sym__,
    ACTIONS(75), 1,
      sym__strict,
    ACTIONS(77), 1,
      sym__lazy,
    ACTIONS(101), 1,
      sym__conid,
    ACTIONS(4529), 1,
      sym__varid,
    ACTIONS(4533), 1,
      sym__integer_literal,
    ACTIONS(4545), 1,
      anon_sym_7,
    ACTIONS(4547), 1,
      sym__splice_dollar,
    ACTIONS(4549), 1,
      sym_quasiquote_start,
    ACTIONS(4961), 1,
      anon_sym_DASH,
    ACTIONS(4965), 1,
      anon_sym_LBRACK,
    ACTIONS(13038), 1,
      anon_sym_LPAREN,
    STATE(456), 1,
      sym__unboxed_open,
    STATE(2790), 1,
      sym__pat_constructor,
    STATE(3918), 1,
      sym_constructor,
    STATE(4144), 1,
      sym_qualified_constructor,
    STATE(7891), 1,
      sym__qcon,
    STATE(12454), 1,
      sym_variable,
    STATE(12624), 1,
      sym_literal,
    STATE(15129), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4959), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13250), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(4531), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4535), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9283), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10582), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [61984] = 28,
    ACTIONS(655), 1,
      sym__conid,
    ACTIONS(4309), 1,
      sym__varid,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(4325), 1,
      anon_sym_7,
    ACTIONS(4327), 1,
      sym__splice_dollar,
    ACTIONS(4329), 1,
      sym_quasiquote_start,
    ACTIONS(4909), 1,
      anon_sym_DASH,
    ACTIONS(4915), 1,
      anon_sym_LBRACK,
    ACTIONS(4921), 1,
      anon_sym__,
    ACTIONS(4927), 1,
      sym__strict,
    ACTIONS(4929), 1,
      sym__lazy,
    ACTIONS(13040), 1,
      anon_sym_LPAREN,
    STATE(236), 1,
      sym__unboxed_open,
    STATE(3202), 1,
      sym__pat_constructor,
    STATE(3977), 1,
      sym_constructor,
    STATE(4051), 1,
      sym_qualified_constructor,
    STATE(8915), 1,
      sym__qcon,
    STATE(13773), 1,
      sym_variable,
    STATE(14211), 1,
      sym_literal,
    STATE(15169), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4907), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(16393), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(4311), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12302), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [62098] = 28,
    ACTIONS(655), 1,
      sym__conid,
    ACTIONS(4309), 1,
      sym__varid,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(4325), 1,
      anon_sym_7,
    ACTIONS(4327), 1,
      sym__splice_dollar,
    ACTIONS(4329), 1,
      sym_quasiquote_start,
    ACTIONS(4909), 1,
      anon_sym_DASH,
    ACTIONS(4915), 1,
      anon_sym_LBRACK,
    ACTIONS(4921), 1,
      anon_sym__,
    ACTIONS(4927), 1,
      sym__strict,
    ACTIONS(4929), 1,
      sym__lazy,
    ACTIONS(13040), 1,
      anon_sym_LPAREN,
    STATE(236), 1,
      sym__unboxed_open,
    STATE(3202), 1,
      sym__pat_constructor,
    STATE(3977), 1,
      sym_constructor,
    STATE(4051), 1,
      sym_qualified_constructor,
    STATE(8915), 1,
      sym__qcon,
    STATE(13773), 1,
      sym_variable,
    STATE(14211), 1,
      sym_literal,
    STATE(15169), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4907), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(16337), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(4311), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12302), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [62212] = 23,
    ACTIONS(5059), 1,
      anon_sym_EQ,
    ACTIONS(13042), 1,
      sym__varid,
    ACTIONS(13048), 1,
      sym__integer_literal,
    ACTIONS(13057), 1,
      anon_sym_LPAREN,
    ACTIONS(13060), 1,
      sym__conid,
    ACTIONS(13063), 1,
      anon_sym_LBRACK,
    ACTIONS(13066), 1,
      anon_sym_SQUOTE,
    ACTIONS(13072), 1,
      anon_sym_7,
    ACTIONS(13075), 1,
      sym__splice_dollar,
    ACTIONS(13078), 1,
      sym_quasiquote_start,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13054), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13069), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13045), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13051), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5030), 4,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3263), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [62316] = 28,
    ACTIONS(12695), 1,
      sym__varid,
    ACTIONS(12699), 1,
      sym__integer_literal,
    ACTIONS(12705), 1,
      anon_sym_DASH,
    ACTIONS(12707), 1,
      anon_sym_LPAREN,
    ACTIONS(12709), 1,
      sym__conid,
    ACTIONS(12711), 1,
      anon_sym_LBRACK,
    ACTIONS(12713), 1,
      anon_sym__,
    ACTIONS(12715), 1,
      anon_sym_7,
    ACTIONS(12717), 1,
      sym__splice_dollar,
    ACTIONS(12719), 1,
      sym_quasiquote_start,
    ACTIONS(12721), 1,
      sym__strict,
    ACTIONS(12723), 1,
      sym__lazy,
    STATE(242), 1,
      sym__unboxed_open,
    STATE(2886), 1,
      sym__pat_constructor,
    STATE(8116), 1,
      sym_constructor,
    STATE(8182), 1,
      sym__qcon,
    STATE(8271), 1,
      sym_qualified_constructor,
    STATE(12735), 1,
      sym_variable,
    STATE(13384), 1,
      sym_literal,
    STATE(14857), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12703), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(15252), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12697), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12701), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13274), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11927), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [62430] = 28,
    ACTIONS(12695), 1,
      sym__varid,
    ACTIONS(12699), 1,
      sym__integer_literal,
    ACTIONS(12705), 1,
      anon_sym_DASH,
    ACTIONS(12707), 1,
      anon_sym_LPAREN,
    ACTIONS(12709), 1,
      sym__conid,
    ACTIONS(12711), 1,
      anon_sym_LBRACK,
    ACTIONS(12713), 1,
      anon_sym__,
    ACTIONS(12715), 1,
      anon_sym_7,
    ACTIONS(12717), 1,
      sym__splice_dollar,
    ACTIONS(12719), 1,
      sym_quasiquote_start,
    ACTIONS(12721), 1,
      sym__strict,
    ACTIONS(12723), 1,
      sym__lazy,
    STATE(242), 1,
      sym__unboxed_open,
    STATE(2886), 1,
      sym__pat_constructor,
    STATE(8116), 1,
      sym_constructor,
    STATE(8182), 1,
      sym__qcon,
    STATE(8271), 1,
      sym_qualified_constructor,
    STATE(12735), 1,
      sym_variable,
    STATE(13384), 1,
      sym_literal,
    STATE(14857), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12703), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(14970), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(12697), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12701), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13274), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11927), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [62544] = 28,
    ACTIONS(661), 1,
      anon_sym__,
    ACTIONS(673), 1,
      sym__strict,
    ACTIONS(675), 1,
      sym__lazy,
    ACTIONS(10559), 1,
      sym__varid,
    ACTIONS(10563), 1,
      sym__integer_literal,
    ACTIONS(10569), 1,
      anon_sym_DASH,
    ACTIONS(10573), 1,
      sym__conid,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    ACTIONS(10577), 1,
      anon_sym_7,
    ACTIONS(10579), 1,
      sym__splice_dollar,
    ACTIONS(10581), 1,
      sym_quasiquote_start,
    ACTIONS(12407), 1,
      anon_sym_LPAREN,
    STATE(366), 1,
      sym__unboxed_open,
    STATE(2764), 1,
      sym__pat_constructor,
    STATE(7661), 1,
      sym_constructor,
    STATE(7780), 1,
      sym_qualified_constructor,
    STATE(7820), 1,
      sym__qcon,
    STATE(12024), 1,
      sym_variable,
    STATE(12264), 1,
      sym_literal,
    STATE(14862), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10567), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13120), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(10561), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12470), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10062), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [62658] = 28,
    ACTIONS(33), 1,
      anon_sym__,
    ACTIONS(75), 1,
      sym__strict,
    ACTIONS(77), 1,
      sym__lazy,
    ACTIONS(101), 1,
      sym__conid,
    ACTIONS(4529), 1,
      sym__varid,
    ACTIONS(4533), 1,
      sym__integer_literal,
    ACTIONS(4545), 1,
      anon_sym_7,
    ACTIONS(4547), 1,
      sym__splice_dollar,
    ACTIONS(4549), 1,
      sym_quasiquote_start,
    ACTIONS(4961), 1,
      anon_sym_DASH,
    ACTIONS(4965), 1,
      anon_sym_LBRACK,
    ACTIONS(13038), 1,
      anon_sym_LPAREN,
    STATE(456), 1,
      sym__unboxed_open,
    STATE(2790), 1,
      sym__pat_constructor,
    STATE(3918), 1,
      sym_constructor,
    STATE(4144), 1,
      sym_qualified_constructor,
    STATE(7891), 1,
      sym__qcon,
    STATE(12454), 1,
      sym_variable,
    STATE(12624), 1,
      sym_literal,
    STATE(15129), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4959), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    STATE(13131), 2,
      sym_pat_infix,
      sym__pat,
    ACTIONS(4531), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4535), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9283), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10582), 17,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_negation,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_pat_apply,
      sym__lpat,
      sym_splice,
      sym_quasiquote,
  [62772] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(11643), 4,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3263), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [62873] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13085), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [62982] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13087), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [63091] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13087), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [63200] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13089), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [63309] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13091), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [63418] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13093), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [63527] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13095), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [63636] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13097), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [63745] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13099), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [63854] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13101), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [63963] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13103), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [64072] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13105), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [64181] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13107), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [64290] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13109), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [64399] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13111), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [64508] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13111), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [64617] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13113), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [64726] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12935), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14833), 1,
      sym_tyfam_eq,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [64835] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13115), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [64944] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13117), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [65053] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13119), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [65162] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13115), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [65271] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13121), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [65380] = 24,
    ACTIONS(1775), 1,
      sym__integer_literal,
    ACTIONS(1789), 1,
      sym__conid,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1793), 1,
      anon_sym_SQUOTE,
    ACTIONS(1801), 1,
      anon_sym_7,
    ACTIONS(1803), 1,
      sym__splice_dollar,
    ACTIONS(1809), 1,
      sym_quasiquote_start,
    ACTIONS(9412), 1,
      sym__varid,
    ACTIONS(9414), 1,
      anon_sym_LPAREN,
    ACTIONS(13123), 1,
      anon_sym_RPAREN,
    STATE(2118), 1,
      sym__unboxed_open,
    STATE(7143), 1,
      sym_constructor,
    STATE(14885), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(1799), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8238), 2,
      sym_type_apply,
      sym__btype,
    STATE(15782), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(1773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7364), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7392), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2742), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [65485] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13099), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [65594] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13125), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [65703] = 24,
    ACTIONS(1775), 1,
      sym__integer_literal,
    ACTIONS(1789), 1,
      sym__conid,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1793), 1,
      anon_sym_SQUOTE,
    ACTIONS(1801), 1,
      anon_sym_7,
    ACTIONS(1803), 1,
      sym__splice_dollar,
    ACTIONS(1809), 1,
      sym_quasiquote_start,
    ACTIONS(9412), 1,
      sym__varid,
    ACTIONS(9414), 1,
      anon_sym_LPAREN,
    ACTIONS(13127), 1,
      anon_sym_RPAREN,
    STATE(2118), 1,
      sym__unboxed_open,
    STATE(7143), 1,
      sym_constructor,
    STATE(14885), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(1799), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8238), 2,
      sym_type_apply,
      sym__btype,
    STATE(15483), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(1773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7364), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7392), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2742), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [65808] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13129), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [65917] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13129), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [66026] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13131), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [66135] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13131), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [66244] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12943), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14777), 1,
      sym_tyfam_eq,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [66353] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13133), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [66462] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12947), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15094), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [66571] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13125), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [66680] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13135), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15093), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [66789] = 27,
    ACTIONS(12303), 1,
      sym__varid,
    ACTIONS(12307), 1,
      sym__integer_literal,
    ACTIONS(12313), 1,
      anon_sym_LPAREN,
    ACTIONS(12318), 1,
      anon_sym_LBRACK,
    ACTIONS(12322), 1,
      anon_sym__,
    ACTIONS(12324), 1,
      anon_sym_7,
    ACTIONS(12326), 1,
      sym__splice_dollar,
    ACTIONS(12328), 1,
      sym_quasiquote_start,
    ACTIONS(12330), 1,
      sym__strict,
    ACTIONS(12332), 1,
      sym__lazy,
    ACTIONS(13137), 1,
      sym__conid,
    STATE(475), 1,
      sym__unboxed_open,
    STATE(3977), 1,
      sym_constructor,
    STATE(4051), 1,
      sym_qualified_constructor,
    STATE(8553), 1,
      sym__pat_constructor,
    STATE(8915), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_variable,
    STATE(9006), 1,
      sym_literal,
    STATE(15169), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12311), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12305), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12309), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10475), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(9106), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3310), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [66900] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12727), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15053), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [67009] = 23,
    ACTIONS(13140), 1,
      sym__varid,
    ACTIONS(13146), 1,
      sym__integer_literal,
    ACTIONS(13155), 1,
      anon_sym_LPAREN,
    ACTIONS(13160), 1,
      sym__conid,
    ACTIONS(13163), 1,
      anon_sym_LBRACK,
    ACTIONS(13166), 1,
      anon_sym_SQUOTE,
    ACTIONS(13172), 1,
      anon_sym_EQ,
    ACTIONS(13174), 1,
      anon_sym_7,
    ACTIONS(13177), 1,
      sym__splice_dollar,
    ACTIONS(13180), 1,
      sym_quasiquote_start,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13152), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13169), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13143), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13149), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13158), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3454), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [67112] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13183), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15342), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [67221] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12401), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(15328), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [67330] = 27,
    ACTIONS(13185), 1,
      sym__varid,
    ACTIONS(13191), 1,
      sym__integer_literal,
    ACTIONS(13200), 1,
      anon_sym_LPAREN,
    ACTIONS(13203), 1,
      sym__conid,
    ACTIONS(13206), 1,
      anon_sym_LBRACK,
    ACTIONS(13209), 1,
      anon_sym__,
    ACTIONS(13212), 1,
      anon_sym_7,
    ACTIONS(13215), 1,
      sym__splice_dollar,
    ACTIONS(13218), 1,
      sym_quasiquote_start,
    ACTIONS(13221), 1,
      sym__strict,
    ACTIONS(13224), 1,
      sym__lazy,
    STATE(475), 1,
      sym__unboxed_open,
    STATE(3977), 1,
      sym_constructor,
    STATE(4051), 1,
      sym_qualified_constructor,
    STATE(8553), 1,
      sym__pat_constructor,
    STATE(8915), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_variable,
    STATE(9006), 1,
      sym_literal,
    STATE(15169), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13197), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13188), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13194), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(10346), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    STATE(9106), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3310), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [67441] = 24,
    ACTIONS(1775), 1,
      sym__integer_literal,
    ACTIONS(1789), 1,
      sym__conid,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1793), 1,
      anon_sym_SQUOTE,
    ACTIONS(1801), 1,
      anon_sym_7,
    ACTIONS(1803), 1,
      sym__splice_dollar,
    ACTIONS(1809), 1,
      sym_quasiquote_start,
    ACTIONS(9412), 1,
      sym__varid,
    ACTIONS(9414), 1,
      anon_sym_LPAREN,
    ACTIONS(13227), 1,
      anon_sym_RPAREN,
    STATE(2118), 1,
      sym__unboxed_open,
    STATE(7143), 1,
      sym_constructor,
    STATE(14885), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(1799), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8238), 2,
      sym_type_apply,
      sym__btype,
    STATE(15664), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(1773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7364), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7392), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2742), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [67546] = 22,
    ACTIONS(13229), 1,
      sym__varid,
    ACTIONS(13235), 1,
      sym__integer_literal,
    ACTIONS(13244), 1,
      anon_sym_LPAREN,
    ACTIONS(13247), 1,
      sym__conid,
    ACTIONS(13250), 1,
      anon_sym_LBRACK,
    ACTIONS(13253), 1,
      anon_sym_SQUOTE,
    ACTIONS(13259), 1,
      anon_sym_7,
    ACTIONS(13262), 1,
      sym__splice_dollar,
    ACTIONS(13265), 1,
      sym_quasiquote_start,
    STATE(2173), 1,
      sym__unboxed_open,
    STATE(8883), 1,
      sym_constructor,
    STATE(14618), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13241), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13256), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13232), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13238), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(5030), 4,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
    STATE(9097), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9169), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3312), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [67647] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(12555), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14808), 1,
      sym_tyfam_eq,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [67756] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13268), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [67865] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13270), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [67974] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13272), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [68083] = 22,
    ACTIONS(13274), 1,
      sym__varid,
    ACTIONS(13278), 1,
      sym__integer_literal,
    ACTIONS(13284), 1,
      anon_sym_LPAREN,
    ACTIONS(13286), 1,
      sym__conid,
    ACTIONS(13288), 1,
      anon_sym_LBRACK,
    ACTIONS(13290), 1,
      anon_sym_SQUOTE,
    ACTIONS(13294), 1,
      anon_sym_7,
    ACTIONS(13296), 1,
      sym__splice_dollar,
    ACTIONS(13298), 1,
      sym_quasiquote_start,
    STATE(2173), 1,
      sym__unboxed_open,
    STATE(8883), 1,
      sym_constructor,
    STATE(14618), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13282), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13292), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13276), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(11643), 4,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
    STATE(9097), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9169), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3312), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [68184] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13300), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14804), 1,
      sym_tyfam_eq,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [68293] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13272), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [68402] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13302), 1,
      sym__layout_end,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [68511] = 26,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    ACTIONS(13133), 1,
      anon_sym_RBRACE,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [68620] = 23,
    ACTIONS(7072), 1,
      sym__integer_literal,
    ACTIONS(7082), 1,
      sym__conid,
    ACTIONS(7084), 1,
      anon_sym_LBRACK,
    ACTIONS(7086), 1,
      anon_sym_SQUOTE,
    ACTIONS(7090), 1,
      anon_sym_7,
    ACTIONS(7092), 1,
      sym__splice_dollar,
    ACTIONS(7094), 1,
      sym_quasiquote_start,
    ACTIONS(9593), 1,
      anon_sym_LPAREN,
    ACTIONS(13304), 1,
      sym__varid,
    STATE(2135), 1,
      sym__unboxed_open,
    STATE(7313), 1,
      sym_constructor,
    STATE(15269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7076), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7088), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8300), 2,
      sym_type_apply,
      sym__btype,
    STATE(12621), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7070), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7074), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7334), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7576), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2759), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [68722] = 23,
    ACTIONS(7130), 1,
      sym__integer_literal,
    ACTIONS(7140), 1,
      sym__conid,
    ACTIONS(7142), 1,
      anon_sym_LBRACK,
    ACTIONS(7144), 1,
      anon_sym_SQUOTE,
    ACTIONS(7148), 1,
      anon_sym_7,
    ACTIONS(7150), 1,
      sym__splice_dollar,
    ACTIONS(7152), 1,
      sym_quasiquote_start,
    ACTIONS(7821), 1,
      sym__varid,
    ACTIONS(7823), 1,
      anon_sym_LPAREN,
    STATE(2110), 1,
      sym__unboxed_open,
    STATE(6210), 1,
      sym_constructor,
    STATE(15251), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7134), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7146), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7671), 2,
      sym_type_apply,
      sym__btype,
    STATE(9867), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7128), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7132), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6402), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6415), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2467), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [68824] = 23,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3928), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(5856), 2,
      sym_type_apply,
      sym__btype,
    STATE(14095), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [68926] = 23,
    ACTIONS(5914), 1,
      sym__varid,
    ACTIONS(5918), 1,
      sym__integer_literal,
    ACTIONS(5924), 1,
      anon_sym_LPAREN,
    ACTIONS(5929), 1,
      anon_sym_LBRACK,
    ACTIONS(5936), 1,
      anon_sym_7,
    ACTIONS(5938), 1,
      sym__splice_dollar,
    ACTIONS(5940), 1,
      sym_quasiquote_start,
    ACTIONS(6036), 1,
      sym__conid,
    ACTIONS(6038), 1,
      anon_sym_SQUOTE,
    STATE(2171), 1,
      sym__unboxed_open,
    STATE(5543), 1,
      sym_constructor,
    STATE(15397), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5922), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5934), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7063), 2,
      sym_type_apply,
      sym__btype,
    STATE(9555), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5916), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5920), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5773), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5783), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2345), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [69028] = 23,
    ACTIONS(6647), 1,
      sym__integer_literal,
    ACTIONS(6657), 1,
      sym__conid,
    ACTIONS(6659), 1,
      anon_sym_LBRACK,
    ACTIONS(6661), 1,
      anon_sym_SQUOTE,
    ACTIONS(6665), 1,
      anon_sym_7,
    ACTIONS(6667), 1,
      sym__splice_dollar,
    ACTIONS(6669), 1,
      sym_quasiquote_start,
    ACTIONS(7921), 1,
      sym__varid,
    ACTIONS(7923), 1,
      anon_sym_LPAREN,
    STATE(2221), 1,
      sym__unboxed_open,
    STATE(6005), 1,
      sym_constructor,
    STATE(14761), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6651), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6663), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7618), 2,
      sym_type_apply,
      sym__btype,
    STATE(9878), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6645), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6649), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6475), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6545), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2474), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [69130] = 23,
    ACTIONS(7261), 1,
      sym__integer_literal,
    ACTIONS(7271), 1,
      sym__conid,
    ACTIONS(7273), 1,
      anon_sym_LBRACK,
    ACTIONS(7275), 1,
      anon_sym_SQUOTE,
    ACTIONS(7279), 1,
      anon_sym_7,
    ACTIONS(7281), 1,
      sym__splice_dollar,
    ACTIONS(7283), 1,
      sym_quasiquote_start,
    ACTIONS(8315), 1,
      anon_sym_LPAREN,
    ACTIONS(13306), 1,
      sym__varid,
    STATE(2097), 1,
      sym__unboxed_open,
    STATE(6786), 1,
      sym_constructor,
    STATE(15321), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7265), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7277), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7940), 2,
      sym_type_apply,
      sym__btype,
    STATE(12228), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7259), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7263), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7045), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7047), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2621), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [69232] = 23,
    ACTIONS(7345), 1,
      sym__integer_literal,
    ACTIONS(7355), 1,
      sym__conid,
    ACTIONS(7357), 1,
      anon_sym_LBRACK,
    ACTIONS(7359), 1,
      anon_sym_SQUOTE,
    ACTIONS(7363), 1,
      anon_sym_7,
    ACTIONS(7365), 1,
      sym__splice_dollar,
    ACTIONS(7367), 1,
      sym_quasiquote_start,
    ACTIONS(8745), 1,
      anon_sym_LPAREN,
    ACTIONS(11687), 1,
      sym__varid,
    STATE(2183), 1,
      sym__unboxed_open,
    STATE(6953), 1,
      sym_constructor,
    STATE(15335), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7349), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7361), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8118), 2,
      sym_type_apply,
      sym__btype,
    STATE(12312), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7343), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7347), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7070), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7144), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2715), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [69334] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1674), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13318), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [69446] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2969), 1,
      sym_type_name,
    STATE(3928), 1,
      sym_constructor,
    STATE(14714), 1,
      sym_type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17940), 1,
      sym_constraint,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9589), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [69552] = 23,
    ACTIONS(6046), 1,
      sym__integer_literal,
    ACTIONS(6056), 1,
      sym__conid,
    ACTIONS(6058), 1,
      anon_sym_LBRACK,
    ACTIONS(6060), 1,
      anon_sym_SQUOTE,
    ACTIONS(6064), 1,
      anon_sym_7,
    ACTIONS(6066), 1,
      sym__splice_dollar,
    ACTIONS(6068), 1,
      sym_quasiquote_start,
    ACTIONS(10105), 1,
      sym__varid,
    ACTIONS(10107), 1,
      anon_sym_LPAREN,
    STATE(2165), 1,
      sym__unboxed_open,
    STATE(7684), 1,
      sym_constructor,
    STATE(15161), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6050), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6062), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8878), 2,
      sym_type_apply,
      sym__btype,
    STATE(13222), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6044), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6048), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7768), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7818), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2799), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [69654] = 23,
    ACTIONS(6591), 1,
      sym__integer_literal,
    ACTIONS(6601), 1,
      sym__conid,
    ACTIONS(6603), 1,
      anon_sym_LBRACK,
    ACTIONS(6605), 1,
      anon_sym_SQUOTE,
    ACTIONS(6609), 1,
      anon_sym_7,
    ACTIONS(6611), 1,
      sym__splice_dollar,
    ACTIONS(6613), 1,
      sym_quasiquote_start,
    ACTIONS(7727), 1,
      sym__varid,
    ACTIONS(7729), 1,
      anon_sym_LPAREN,
    STATE(2127), 1,
      sym__unboxed_open,
    STATE(6056), 1,
      sym_constructor,
    STATE(15001), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6595), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6607), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7694), 2,
      sym_type_apply,
      sym__btype,
    STATE(9971), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6589), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6593), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6375), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6389), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2465), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [69756] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(18653), 1,
      sym_tyfam_eq,
    STATE(20617), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [69862] = 23,
    ACTIONS(6685), 1,
      sym__integer_literal,
    ACTIONS(6695), 1,
      sym__conid,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(6699), 1,
      anon_sym_SQUOTE,
    ACTIONS(6703), 1,
      anon_sym_7,
    ACTIONS(6705), 1,
      sym__splice_dollar,
    ACTIONS(6707), 1,
      sym_quasiquote_start,
    ACTIONS(8014), 1,
      sym__varid,
    ACTIONS(8016), 1,
      anon_sym_LPAREN,
    STATE(2140), 1,
      sym__unboxed_open,
    STATE(6530), 1,
      sym_constructor,
    STATE(15339), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6689), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6701), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7714), 2,
      sym_type_apply,
      sym__btype,
    STATE(10096), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6683), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6687), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6610), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6751), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2499), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [69964] = 23,
    ACTIONS(6961), 1,
      sym__integer_literal,
    ACTIONS(6971), 1,
      sym__conid,
    ACTIONS(6973), 1,
      anon_sym_LBRACK,
    ACTIONS(6975), 1,
      anon_sym_SQUOTE,
    ACTIONS(6979), 1,
      anon_sym_7,
    ACTIONS(6981), 1,
      sym__splice_dollar,
    ACTIONS(6983), 1,
      sym_quasiquote_start,
    ACTIONS(9607), 1,
      sym__varid,
    ACTIONS(9609), 1,
      anon_sym_LPAREN,
    STATE(2172), 1,
      sym__unboxed_open,
    STATE(7276), 1,
      sym_constructor,
    STATE(15131), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6965), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6977), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8261), 2,
      sym_type_apply,
      sym__btype,
    STATE(12600), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6959), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6963), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7394), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7406), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2761), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [70066] = 23,
    ACTIONS(7205), 1,
      sym__integer_literal,
    ACTIONS(7215), 1,
      sym__conid,
    ACTIONS(7217), 1,
      anon_sym_LBRACK,
    ACTIONS(7219), 1,
      anon_sym_SQUOTE,
    ACTIONS(7223), 1,
      anon_sym_7,
    ACTIONS(7225), 1,
      sym__splice_dollar,
    ACTIONS(7227), 1,
      sym_quasiquote_start,
    ACTIONS(8075), 1,
      sym__varid,
    ACTIONS(8077), 1,
      anon_sym_LPAREN,
    STATE(2223), 1,
      sym__unboxed_open,
    STATE(6527), 1,
      sym_constructor,
    STATE(14645), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7209), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7221), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7827), 2,
      sym_type_apply,
      sym__btype,
    STATE(10102), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7203), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7207), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6611), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6622), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2490), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [70168] = 23,
    ACTIONS(6440), 1,
      sym__integer_literal,
    ACTIONS(6450), 1,
      sym__conid,
    ACTIONS(6452), 1,
      anon_sym_LBRACK,
    ACTIONS(6454), 1,
      anon_sym_SQUOTE,
    ACTIONS(6458), 1,
      anon_sym_7,
    ACTIONS(6460), 1,
      sym__splice_dollar,
    ACTIONS(6462), 1,
      sym_quasiquote_start,
    ACTIONS(8843), 1,
      anon_sym_LPAREN,
    ACTIONS(13338), 1,
      sym__varid,
    STATE(2156), 1,
      sym__unboxed_open,
    STATE(6817), 1,
      sym_constructor,
    STATE(14826), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6444), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6456), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8012), 2,
      sym_type_apply,
      sym__btype,
    STATE(12270), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6438), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6442), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7208), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7291), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2699), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [70270] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2969), 1,
      sym_type_name,
    STATE(3928), 1,
      sym_constructor,
    STATE(14714), 1,
      sym_type_infix,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17891), 1,
      sym_constraint,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9589), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [70376] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1477), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13340), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [70488] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1433), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13342), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [70600] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1355), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13344), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [70712] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1413), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13346), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [70824] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1552), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13348), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [70936] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(9850), 1,
      anon_sym_SQUOTE,
    ACTIONS(11731), 1,
      sym__varid,
    ACTIONS(13350), 1,
      anon_sym_LPAREN,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2843), 1,
      sym_type_name,
    STATE(6403), 1,
      sym_constructor,
    STATE(14431), 1,
      sym_type_infix,
    STATE(14854), 1,
      aux_sym__qualifying_module,
    STATE(16762), 1,
      sym_constraint,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9675), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6680), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [71042] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1371), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13352), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [71154] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1689), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13354), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [71266] = 23,
    ACTIONS(5800), 1,
      sym__integer_literal,
    ACTIONS(5806), 1,
      anon_sym_LPAREN,
    ACTIONS(5811), 1,
      anon_sym_LBRACK,
    ACTIONS(5818), 1,
      anon_sym_7,
    ACTIONS(5820), 1,
      sym__splice_dollar,
    ACTIONS(5822), 1,
      sym_quasiquote_start,
    ACTIONS(7122), 1,
      sym__conid,
    ACTIONS(7124), 1,
      anon_sym_SQUOTE,
    ACTIONS(13356), 1,
      sym__varid,
    STATE(2185), 1,
      sym__unboxed_open,
    STATE(5658), 1,
      sym_constructor,
    STATE(15268), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5804), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5816), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7097), 2,
      sym_type_apply,
      sym__btype,
    STATE(9565), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5798), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5802), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5887), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5892), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2295), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [71368] = 23,
    ACTIONS(6752), 1,
      sym__integer_literal,
    ACTIONS(6762), 1,
      sym__conid,
    ACTIONS(6764), 1,
      anon_sym_LBRACK,
    ACTIONS(6766), 1,
      anon_sym_SQUOTE,
    ACTIONS(6770), 1,
      anon_sym_7,
    ACTIONS(6772), 1,
      sym__splice_dollar,
    ACTIONS(6774), 1,
      sym_quasiquote_start,
    ACTIONS(7503), 1,
      sym__varid,
    ACTIONS(7505), 1,
      anon_sym_LPAREN,
    STATE(2114), 1,
      sym__unboxed_open,
    STATE(6175), 1,
      sym_constructor,
    STATE(15425), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6756), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6768), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7646), 2,
      sym_type_apply,
      sym__btype,
    STATE(9954), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6750), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6754), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6387), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6388), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2458), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [71470] = 23,
    ACTIONS(6276), 1,
      sym__varid,
    ACTIONS(6280), 1,
      sym__integer_literal,
    ACTIONS(6286), 1,
      anon_sym_LPAREN,
    ACTIONS(6291), 1,
      anon_sym_LBRACK,
    ACTIONS(6298), 1,
      anon_sym_7,
    ACTIONS(6300), 1,
      sym__splice_dollar,
    ACTIONS(6302), 1,
      sym_quasiquote_start,
    ACTIONS(7114), 1,
      sym__conid,
    ACTIONS(7116), 1,
      anon_sym_SQUOTE,
    STATE(2150), 1,
      sym__unboxed_open,
    STATE(5877), 1,
      sym_constructor,
    STATE(14778), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6284), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6296), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7487), 2,
      sym_type_apply,
      sym__btype,
    STATE(9668), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6278), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6282), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6064), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6066), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2376), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [71572] = 23,
    ACTIONS(1775), 1,
      sym__integer_literal,
    ACTIONS(1789), 1,
      sym__conid,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1793), 1,
      anon_sym_SQUOTE,
    ACTIONS(1801), 1,
      anon_sym_7,
    ACTIONS(1803), 1,
      sym__splice_dollar,
    ACTIONS(1809), 1,
      sym_quasiquote_start,
    ACTIONS(9412), 1,
      sym__varid,
    ACTIONS(9414), 1,
      anon_sym_LPAREN,
    STATE(2118), 1,
      sym__unboxed_open,
    STATE(7143), 1,
      sym_constructor,
    STATE(14885), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(1799), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8238), 2,
      sym_type_apply,
      sym__btype,
    STATE(18888), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(1773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7364), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7392), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2742), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [71674] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1621), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13358), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [71786] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(9860), 1,
      anon_sym_SQUOTE,
    ACTIONS(11401), 1,
      sym__varid,
    ACTIONS(13360), 1,
      anon_sym_LPAREN,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      sym_type_name,
    STATE(5968), 1,
      sym_constructor,
    STATE(13786), 1,
      sym_type_infix,
    STATE(14649), 1,
      aux_sym__qualifying_module,
    STATE(14990), 1,
      sym_constraint,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9600), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6463), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [71892] = 23,
    ACTIONS(10876), 1,
      sym__integer_literal,
    ACTIONS(10882), 1,
      anon_sym_LPAREN,
    ACTIONS(10887), 1,
      anon_sym_LBRACK,
    ACTIONS(10894), 1,
      anon_sym_7,
    ACTIONS(10896), 1,
      sym__splice_dollar,
    ACTIONS(10898), 1,
      sym_quasiquote_start,
    ACTIONS(11735), 1,
      sym__varid,
    ACTIONS(11737), 1,
      sym__conid,
    ACTIONS(11739), 1,
      anon_sym_SQUOTE,
    STATE(2130), 1,
      sym__unboxed_open,
    STATE(7915), 1,
      sym_constructor,
    STATE(15326), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10880), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10892), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9237), 2,
      sym_type_apply,
      sym__btype,
    STATE(14501), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(10874), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10878), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8066), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8094), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2859), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [71994] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1489), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13362), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [72106] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1491), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13364), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [72218] = 23,
    ACTIONS(6535), 1,
      sym__integer_literal,
    ACTIONS(6545), 1,
      sym__conid,
    ACTIONS(6547), 1,
      anon_sym_LBRACK,
    ACTIONS(6549), 1,
      anon_sym_SQUOTE,
    ACTIONS(6553), 1,
      anon_sym_7,
    ACTIONS(6555), 1,
      sym__splice_dollar,
    ACTIONS(6557), 1,
      sym_quasiquote_start,
    ACTIONS(9198), 1,
      sym__varid,
    ACTIONS(9200), 1,
      anon_sym_LPAREN,
    STATE(2201), 1,
      sym__unboxed_open,
    STATE(6997), 1,
      sym_constructor,
    STATE(15261), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6539), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6551), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8043), 2,
      sym_type_apply,
      sym__btype,
    STATE(12339), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6533), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6537), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7098), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7224), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2726), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [72320] = 23,
    ACTIONS(7233), 1,
      sym__integer_literal,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(7245), 1,
      anon_sym_LBRACK,
    ACTIONS(7247), 1,
      anon_sym_SQUOTE,
    ACTIONS(7251), 1,
      anon_sym_7,
    ACTIONS(7253), 1,
      sym__splice_dollar,
    ACTIONS(7255), 1,
      sym_quasiquote_start,
    ACTIONS(7680), 1,
      anon_sym_LPAREN,
    ACTIONS(11751), 1,
      sym__varid,
    STATE(2108), 1,
      sym__unboxed_open,
    STATE(5969), 1,
      sym_constructor,
    STATE(15009), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7237), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7249), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7690), 2,
      sym_type_apply,
      sym__btype,
    STATE(12551), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7231), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7235), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6424), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6425), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2461), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [72422] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(9850), 1,
      anon_sym_SQUOTE,
    ACTIONS(11731), 1,
      sym__varid,
    ACTIONS(13350), 1,
      anon_sym_LPAREN,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2843), 1,
      sym_type_name,
    STATE(6403), 1,
      sym_constructor,
    STATE(14431), 1,
      sym_type_infix,
    STATE(14854), 1,
      aux_sym__qualifying_module,
    STATE(16808), 1,
      sym_constraint,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9675), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6680), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [72528] = 23,
    ACTIONS(5411), 1,
      sym__integer_literal,
    ACTIONS(5421), 1,
      sym__conid,
    ACTIONS(5423), 1,
      anon_sym_LBRACK,
    ACTIONS(5425), 1,
      anon_sym_SQUOTE,
    ACTIONS(5429), 1,
      anon_sym_7,
    ACTIONS(5431), 1,
      sym__splice_dollar,
    ACTIONS(5433), 1,
      sym_quasiquote_start,
    ACTIONS(9777), 1,
      sym__varid,
    ACTIONS(9779), 1,
      anon_sym_LPAREN,
    STATE(2122), 1,
      sym__unboxed_open,
    STATE(7422), 1,
      sym_constructor,
    STATE(15142), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5415), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5427), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8575), 2,
      sym_type_apply,
      sym__btype,
    STATE(12847), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5409), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5413), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7627), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7693), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2767), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [72630] = 23,
    ACTIONS(7401), 1,
      sym__integer_literal,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(7413), 1,
      anon_sym_LBRACK,
    ACTIONS(7415), 1,
      anon_sym_SQUOTE,
    ACTIONS(7419), 1,
      anon_sym_7,
    ACTIONS(7421), 1,
      sym__splice_dollar,
    ACTIONS(7423), 1,
      sym_quasiquote_start,
    ACTIONS(7652), 1,
      anon_sym_LPAREN,
    ACTIONS(11401), 1,
      sym__varid,
    STATE(2133), 1,
      sym__unboxed_open,
    STATE(5968), 1,
      sym_constructor,
    STATE(14649), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7405), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7417), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7597), 2,
      sym_type_apply,
      sym__btype,
    STATE(10945), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7399), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7403), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6463), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6509), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2456), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [72732] = 23,
    ACTIONS(5377), 1,
      sym__integer_literal,
    ACTIONS(5383), 1,
      anon_sym_LPAREN,
    ACTIONS(5388), 1,
      anon_sym_LBRACK,
    ACTIONS(5395), 1,
      anon_sym_7,
    ACTIONS(5397), 1,
      sym__splice_dollar,
    ACTIONS(5399), 1,
      sym_quasiquote_start,
    ACTIONS(7158), 1,
      sym__conid,
    ACTIONS(7160), 1,
      anon_sym_SQUOTE,
    ACTIONS(13366), 1,
      sym__varid,
    STATE(2167), 1,
      sym__unboxed_open,
    STATE(4828), 1,
      sym_constructor,
    STATE(15214), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5381), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5393), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(6655), 2,
      sym_type_apply,
      sym__btype,
    STATE(9415), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5375), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5379), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4881), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4884), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2094), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [72834] = 23,
    ACTIONS(7233), 1,
      sym__integer_literal,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(7245), 1,
      anon_sym_LBRACK,
    ACTIONS(7247), 1,
      anon_sym_SQUOTE,
    ACTIONS(7251), 1,
      anon_sym_7,
    ACTIONS(7253), 1,
      sym__splice_dollar,
    ACTIONS(7255), 1,
      sym_quasiquote_start,
    ACTIONS(7680), 1,
      anon_sym_LPAREN,
    ACTIONS(11751), 1,
      sym__varid,
    STATE(2108), 1,
      sym__unboxed_open,
    STATE(5969), 1,
      sym_constructor,
    STATE(15009), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7237), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7249), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7690), 2,
      sym_type_apply,
      sym__btype,
    STATE(11161), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7231), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7235), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6424), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6425), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2461), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [72936] = 23,
    ACTIONS(6370), 1,
      sym__integer_literal,
    ACTIONS(6380), 1,
      sym__conid,
    ACTIONS(6382), 1,
      anon_sym_LBRACK,
    ACTIONS(6384), 1,
      anon_sym_SQUOTE,
    ACTIONS(6388), 1,
      anon_sym_7,
    ACTIONS(6390), 1,
      sym__splice_dollar,
    ACTIONS(6392), 1,
      sym_quasiquote_start,
    ACTIONS(8524), 1,
      sym__varid,
    ACTIONS(8526), 1,
      anon_sym_LPAREN,
    STATE(2131), 1,
      sym__unboxed_open,
    STATE(7046), 1,
      sym_constructor,
    STATE(15134), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6374), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6386), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8113), 2,
      sym_type_apply,
      sym__btype,
    STATE(12446), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6368), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6372), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7087), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7104), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2721), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [73038] = 23,
    ACTIONS(6115), 1,
      sym__integer_literal,
    ACTIONS(6125), 1,
      sym__conid,
    ACTIONS(6127), 1,
      anon_sym_LBRACK,
    ACTIONS(6129), 1,
      anon_sym_SQUOTE,
    ACTIONS(6133), 1,
      anon_sym_7,
    ACTIONS(6135), 1,
      sym__splice_dollar,
    ACTIONS(6137), 1,
      sym_quasiquote_start,
    ACTIONS(9467), 1,
      anon_sym_LPAREN,
    ACTIONS(13368), 1,
      sym__varid,
    STATE(2145), 1,
      sym__unboxed_open,
    STATE(7303), 1,
      sym_constructor,
    STATE(14983), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6119), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6131), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8239), 2,
      sym_type_apply,
      sym__btype,
    STATE(12548), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6113), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6117), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7348), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7581), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2754), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [73140] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1547), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13370), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [73252] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6016), 1,
      sym__conid,
    ACTIONS(9789), 1,
      anon_sym_SQUOTE,
    ACTIONS(12168), 1,
      sym__varid,
    ACTIONS(13372), 1,
      anon_sym_LPAREN,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2840), 1,
      sym_type_name,
    STATE(7295), 1,
      sym_constructor,
    STATE(14547), 1,
      sym_type_infix,
    STATE(14836), 1,
      aux_sym__qualifying_module,
    STATE(16446), 1,
      sym_constraint,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9626), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7412), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [73358] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6380), 1,
      sym__conid,
    ACTIONS(8524), 1,
      sym__varid,
    ACTIONS(12298), 1,
      anon_sym_SQUOTE,
    ACTIONS(13374), 1,
      anon_sym_LPAREN,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2792), 1,
      sym_type_name,
    STATE(7046), 1,
      sym_constructor,
    STATE(13256), 1,
      sym_constraint,
    STATE(13388), 1,
      sym_type_infix,
    STATE(15134), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9607), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7087), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [73464] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6545), 1,
      sym__conid,
    ACTIONS(9198), 1,
      sym__varid,
    ACTIONS(12340), 1,
      anon_sym_SQUOTE,
    ACTIONS(13376), 1,
      anon_sym_LPAREN,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2786), 1,
      sym_type_name,
    STATE(6997), 1,
      sym_constructor,
    STATE(13219), 1,
      sym_type_infix,
    STATE(13348), 1,
      sym_constraint,
    STATE(15261), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9674), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7098), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [73570] = 23,
    ACTIONS(6143), 1,
      sym__integer_literal,
    ACTIONS(6153), 1,
      sym__conid,
    ACTIONS(6155), 1,
      anon_sym_LBRACK,
    ACTIONS(6157), 1,
      anon_sym_SQUOTE,
    ACTIONS(6161), 1,
      anon_sym_7,
    ACTIONS(6163), 1,
      sym__splice_dollar,
    ACTIONS(6165), 1,
      sym_quasiquote_start,
    ACTIONS(9944), 1,
      sym__varid,
    ACTIONS(9946), 1,
      anon_sym_LPAREN,
    STATE(2184), 1,
      sym__unboxed_open,
    STATE(7681), 1,
      sym_constructor,
    STATE(15120), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6147), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6159), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8735), 2,
      sym_type_apply,
      sym__btype,
    STATE(13363), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6141), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6145), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7705), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7706), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2802), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [73672] = 23,
    ACTIONS(6199), 1,
      sym__integer_literal,
    ACTIONS(6209), 1,
      sym__conid,
    ACTIONS(6211), 1,
      anon_sym_LBRACK,
    ACTIONS(6213), 1,
      anon_sym_SQUOTE,
    ACTIONS(6217), 1,
      anon_sym_7,
    ACTIONS(6219), 1,
      sym__splice_dollar,
    ACTIONS(6221), 1,
      sym_quasiquote_start,
    ACTIONS(6422), 1,
      anon_sym_LPAREN,
    ACTIONS(13378), 1,
      sym__varid,
    STATE(2120), 1,
      sym__unboxed_open,
    STATE(5787), 1,
      sym_constructor,
    STATE(15408), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6203), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6215), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7511), 2,
      sym_type_apply,
      sym__btype,
    STATE(9625), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6197), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6201), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6115), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6228), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2385), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [73774] = 23,
    ACTIONS(6342), 1,
      sym__integer_literal,
    ACTIONS(6352), 1,
      sym__conid,
    ACTIONS(6354), 1,
      anon_sym_LBRACK,
    ACTIONS(6356), 1,
      anon_sym_SQUOTE,
    ACTIONS(6360), 1,
      anon_sym_7,
    ACTIONS(6362), 1,
      sym__splice_dollar,
    ACTIONS(6364), 1,
      sym_quasiquote_start,
    ACTIONS(6985), 1,
      sym__varid,
    ACTIONS(6987), 1,
      anon_sym_LPAREN,
    STATE(2212), 1,
      sym__unboxed_open,
    STATE(5940), 1,
      sym_constructor,
    STATE(15080), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6346), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6358), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7561), 2,
      sym_type_apply,
      sym__btype,
    STATE(9624), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6340), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6344), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5952), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5958), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2418), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [73876] = 23,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3928), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(5856), 2,
      sym_type_apply,
      sym__btype,
    STATE(14336), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [73978] = 23,
    ACTIONS(7289), 1,
      sym__integer_literal,
    ACTIONS(7299), 1,
      sym__conid,
    ACTIONS(7301), 1,
      anon_sym_LBRACK,
    ACTIONS(7303), 1,
      anon_sym_SQUOTE,
    ACTIONS(7307), 1,
      anon_sym_7,
    ACTIONS(7309), 1,
      sym__splice_dollar,
    ACTIONS(7311), 1,
      sym_quasiquote_start,
    ACTIONS(7943), 1,
      sym__varid,
    ACTIONS(7945), 1,
      anon_sym_LPAREN,
    STATE(2106), 1,
      sym__unboxed_open,
    STATE(5995), 1,
      sym_constructor,
    STATE(14749), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7293), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7305), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7621), 2,
      sym_type_apply,
      sym__btype,
    STATE(9843), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7287), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7291), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6432), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6532), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2477), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [74080] = 23,
    ACTIONS(7044), 1,
      sym__integer_literal,
    ACTIONS(7054), 1,
      sym__conid,
    ACTIONS(7056), 1,
      anon_sym_LBRACK,
    ACTIONS(7058), 1,
      anon_sym_SQUOTE,
    ACTIONS(7062), 1,
      anon_sym_7,
    ACTIONS(7064), 1,
      sym__splice_dollar,
    ACTIONS(7066), 1,
      sym_quasiquote_start,
    ACTIONS(7998), 1,
      sym__varid,
    ACTIONS(8000), 1,
      anon_sym_LPAREN,
    STATE(2113), 1,
      sym__unboxed_open,
    STATE(6476), 1,
      sym_constructor,
    STATE(14736), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7048), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7060), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7781), 2,
      sym_type_apply,
      sym__btype,
    STATE(10235), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7042), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7046), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6642), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6722), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2483), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [74182] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1515), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13380), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [74294] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1448), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13382), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [74406] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6016), 1,
      sym__conid,
    ACTIONS(9789), 1,
      anon_sym_SQUOTE,
    ACTIONS(12168), 1,
      sym__varid,
    ACTIONS(13372), 1,
      anon_sym_LPAREN,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2840), 1,
      sym_type_name,
    STATE(7295), 1,
      sym_constructor,
    STATE(14547), 1,
      sym_type_infix,
    STATE(14836), 1,
      aux_sym__qualifying_module,
    STATE(16683), 1,
      sym_constraint,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9626), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7412), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [74512] = 23,
    ACTIONS(5278), 1,
      sym__integer_literal,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(5288), 1,
      anon_sym_LBRACK,
    ACTIONS(5290), 1,
      anon_sym_SQUOTE,
    ACTIONS(5296), 1,
      anon_sym_7,
    ACTIONS(5298), 1,
      sym__splice_dollar,
    ACTIONS(5300), 1,
      sym_quasiquote_start,
    ACTIONS(8171), 1,
      sym__varid,
    ACTIONS(9520), 1,
      anon_sym_LPAREN,
    STATE(2162), 1,
      sym__unboxed_open,
    STATE(7280), 1,
      sym_constructor,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5282), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5292), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8399), 2,
      sym_type_apply,
      sym__btype,
    STATE(12666), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5276), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2749), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [74614] = 23,
    ACTIONS(6619), 1,
      sym__integer_literal,
    ACTIONS(6629), 1,
      sym__conid,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(6633), 1,
      anon_sym_SQUOTE,
    ACTIONS(6637), 1,
      anon_sym_7,
    ACTIONS(6639), 1,
      sym__splice_dollar,
    ACTIONS(6641), 1,
      sym_quasiquote_start,
    ACTIONS(6849), 1,
      sym__varid,
    ACTIONS(6851), 1,
      anon_sym_LPAREN,
    STATE(2192), 1,
      sym__unboxed_open,
    STATE(5913), 1,
      sym_constructor,
    STATE(15103), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6623), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6635), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7537), 2,
      sym_type_apply,
      sym__btype,
    STATE(9660), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6617), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6621), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6026), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6029), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2411), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [74716] = 23,
    ACTIONS(6398), 1,
      sym__integer_literal,
    ACTIONS(6408), 1,
      sym__conid,
    ACTIONS(6410), 1,
      anon_sym_LBRACK,
    ACTIONS(6412), 1,
      anon_sym_SQUOTE,
    ACTIONS(6416), 1,
      anon_sym_7,
    ACTIONS(6418), 1,
      sym__splice_dollar,
    ACTIONS(6420), 1,
      sym_quasiquote_start,
    ACTIONS(6671), 1,
      sym__varid,
    ACTIONS(6673), 1,
      anon_sym_LPAREN,
    STATE(2200), 1,
      sym__unboxed_open,
    STATE(5931), 1,
      sym_constructor,
    STATE(15278), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6402), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6414), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7479), 2,
      sym_type_apply,
      sym__btype,
    STATE(9688), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6396), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6400), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5996), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5998), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2403), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [74818] = 23,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3928), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(5856), 2,
      sym_type_apply,
      sym__btype,
    STATE(9384), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [74920] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3217), 1,
      sym_constructor,
    STATE(3307), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(17177), 1,
      sym_tyfam_eq,
    STATE(19611), 1,
      sym_tyfam_pat,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9615), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 4,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [75026] = 23,
    ACTIONS(6905), 1,
      sym__integer_literal,
    ACTIONS(6915), 1,
      sym__conid,
    ACTIONS(6917), 1,
      anon_sym_LBRACK,
    ACTIONS(6919), 1,
      anon_sym_SQUOTE,
    ACTIONS(6923), 1,
      anon_sym_7,
    ACTIONS(6925), 1,
      sym__splice_dollar,
    ACTIONS(6927), 1,
      sym_quasiquote_start,
    ACTIONS(7666), 1,
      anon_sym_LPAREN,
    ACTIONS(13384), 1,
      sym__varid,
    STATE(2219), 1,
      sym__unboxed_open,
    STATE(6142), 1,
      sym_constructor,
    STATE(15108), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6909), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6921), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7651), 2,
      sym_type_apply,
      sym__btype,
    STATE(9872), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6903), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6907), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6354), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6357), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2460), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [75128] = 23,
    ACTIONS(7401), 1,
      sym__integer_literal,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(7413), 1,
      anon_sym_LBRACK,
    ACTIONS(7415), 1,
      anon_sym_SQUOTE,
    ACTIONS(7419), 1,
      anon_sym_7,
    ACTIONS(7421), 1,
      sym__splice_dollar,
    ACTIONS(7423), 1,
      sym_quasiquote_start,
    ACTIONS(7652), 1,
      anon_sym_LPAREN,
    ACTIONS(11401), 1,
      sym__varid,
    STATE(2133), 1,
      sym__unboxed_open,
    STATE(5968), 1,
      sym_constructor,
    STATE(14649), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7405), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7417), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7597), 2,
      sym_type_apply,
      sym__btype,
    STATE(12683), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7399), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7403), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6463), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6509), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2456), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [75230] = 23,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5088), 1,
      anon_sym_LPAREN,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5314), 1,
      anon_sym_SQUOTE,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(8063), 1,
      sym__varid,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(3928), 1,
      sym_constructor,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9510), 2,
      sym_type_apply,
      sym__btype,
    STATE(14856), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4017), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2042), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [75332] = 23,
    ACTIONS(6308), 1,
      sym__integer_literal,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(6320), 1,
      anon_sym_LBRACK,
    ACTIONS(6322), 1,
      anon_sym_SQUOTE,
    ACTIONS(6326), 1,
      anon_sym_7,
    ACTIONS(6328), 1,
      sym__splice_dollar,
    ACTIONS(6330), 1,
      sym_quasiquote_start,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(11731), 1,
      sym__varid,
    STATE(2166), 1,
      sym__unboxed_open,
    STATE(6403), 1,
      sym_constructor,
    STATE(14854), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6312), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7807), 2,
      sym_type_apply,
      sym__btype,
    STATE(11580), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6306), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6310), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6680), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2491), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [75434] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1526), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13386), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [75546] = 23,
    ACTIONS(1775), 1,
      sym__integer_literal,
    ACTIONS(1789), 1,
      sym__conid,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(1793), 1,
      anon_sym_SQUOTE,
    ACTIONS(1801), 1,
      anon_sym_7,
    ACTIONS(1803), 1,
      sym__splice_dollar,
    ACTIONS(1809), 1,
      sym_quasiquote_start,
    ACTIONS(9412), 1,
      sym__varid,
    ACTIONS(9414), 1,
      anon_sym_LPAREN,
    STATE(2118), 1,
      sym__unboxed_open,
    STATE(7143), 1,
      sym_constructor,
    STATE(14885), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(1799), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8238), 2,
      sym_type_apply,
      sym__btype,
    STATE(12543), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(1773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7364), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7392), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2742), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [75648] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1510), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13388), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [75760] = 23,
    ACTIONS(7317), 1,
      sym__integer_literal,
    ACTIONS(7327), 1,
      sym__conid,
    ACTIONS(7329), 1,
      anon_sym_LBRACK,
    ACTIONS(7331), 1,
      anon_sym_SQUOTE,
    ACTIONS(7335), 1,
      anon_sym_7,
    ACTIONS(7337), 1,
      sym__splice_dollar,
    ACTIONS(7339), 1,
      sym_quasiquote_start,
    ACTIONS(8065), 1,
      sym__varid,
    ACTIONS(8067), 1,
      anon_sym_LPAREN,
    STATE(2214), 1,
      sym__unboxed_open,
    STATE(6276), 1,
      sym_constructor,
    STATE(15096), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7321), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7333), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7772), 2,
      sym_type_apply,
      sym__btype,
    STATE(10280), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7315), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7319), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6769), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6771), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2489), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [75862] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1375), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13390), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [75974] = 23,
    ACTIONS(6863), 1,
      sym__integer_literal,
    ACTIONS(6869), 1,
      anon_sym_LPAREN,
    ACTIONS(6874), 1,
      anon_sym_LBRACK,
    ACTIONS(6881), 1,
      anon_sym_7,
    ACTIONS(6883), 1,
      sym__splice_dollar,
    ACTIONS(6885), 1,
      sym_quasiquote_start,
    ACTIONS(6897), 1,
      sym__conid,
    ACTIONS(6899), 1,
      anon_sym_SQUOTE,
    ACTIONS(13392), 1,
      sym__varid,
    STATE(2227), 1,
      sym__unboxed_open,
    STATE(5941), 1,
      sym_constructor,
    STATE(15273), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6867), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6879), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7431), 2,
      sym_type_apply,
      sym__btype,
    STATE(9670), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6861), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6865), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5953), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5955), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2412), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [76076] = 23,
    ACTIONS(5195), 1,
      sym__integer_literal,
    ACTIONS(5201), 1,
      anon_sym_LPAREN,
    ACTIONS(5206), 1,
      anon_sym_LBRACK,
    ACTIONS(5213), 1,
      anon_sym_7,
    ACTIONS(5215), 1,
      sym__splice_dollar,
    ACTIONS(5217), 1,
      sym_quasiquote_start,
    ACTIONS(5998), 1,
      sym__conid,
    ACTIONS(6000), 1,
      anon_sym_SQUOTE,
    ACTIONS(13394), 1,
      sym__varid,
    STATE(2168), 1,
      sym__unboxed_open,
    STATE(4213), 1,
      sym_constructor,
    STATE(14868), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5199), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5211), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(6274), 2,
      sym_type_apply,
      sym__btype,
    STATE(9333), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5193), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5197), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4542), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4722), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2080), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [76178] = 23,
    ACTIONS(6308), 1,
      sym__integer_literal,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(6320), 1,
      anon_sym_LBRACK,
    ACTIONS(6322), 1,
      anon_sym_SQUOTE,
    ACTIONS(6326), 1,
      anon_sym_7,
    ACTIONS(6328), 1,
      sym__splice_dollar,
    ACTIONS(6330), 1,
      sym_quasiquote_start,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(11731), 1,
      sym__varid,
    STATE(2166), 1,
      sym__unboxed_open,
    STATE(6403), 1,
      sym_constructor,
    STATE(14854), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6312), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7807), 2,
      sym_type_apply,
      sym__btype,
    STATE(12759), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6306), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6310), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6680), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2491), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [76280] = 23,
    ACTIONS(5970), 1,
      sym__integer_literal,
    ACTIONS(5980), 1,
      sym__conid,
    ACTIONS(5982), 1,
      anon_sym_LBRACK,
    ACTIONS(5984), 1,
      anon_sym_SQUOTE,
    ACTIONS(5988), 1,
      anon_sym_7,
    ACTIONS(5990), 1,
      sym__splice_dollar,
    ACTIONS(5992), 1,
      sym_quasiquote_start,
    ACTIONS(7558), 1,
      sym__varid,
    ACTIONS(7560), 1,
      anon_sym_LPAREN,
    STATE(2174), 1,
      sym__unboxed_open,
    STATE(6222), 1,
      sym_constructor,
    STATE(15364), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5974), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5986), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7672), 2,
      sym_type_apply,
      sym__btype,
    STATE(9836), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(5968), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6343), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6347), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2448), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [76382] = 23,
    ACTIONS(6308), 1,
      sym__integer_literal,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(6320), 1,
      anon_sym_LBRACK,
    ACTIONS(6322), 1,
      anon_sym_SQUOTE,
    ACTIONS(6326), 1,
      anon_sym_7,
    ACTIONS(6328), 1,
      sym__splice_dollar,
    ACTIONS(6330), 1,
      sym_quasiquote_start,
    ACTIONS(8085), 1,
      anon_sym_LPAREN,
    ACTIONS(11731), 1,
      sym__varid,
    STATE(2166), 1,
      sym__unboxed_open,
    STATE(6403), 1,
      sym_constructor,
    STATE(14854), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6312), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6324), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7807), 2,
      sym_type_apply,
      sym__btype,
    STATE(12842), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6306), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6310), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6680), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2491), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [76484] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1585), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13396), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [76596] = 23,
    ACTIONS(6563), 1,
      sym__integer_literal,
    ACTIONS(6573), 1,
      sym__conid,
    ACTIONS(6575), 1,
      anon_sym_LBRACK,
    ACTIONS(6577), 1,
      anon_sym_SQUOTE,
    ACTIONS(6581), 1,
      anon_sym_7,
    ACTIONS(6583), 1,
      sym__splice_dollar,
    ACTIONS(6585), 1,
      sym_quasiquote_start,
    ACTIONS(8275), 1,
      sym__varid,
    ACTIONS(8277), 1,
      anon_sym_LPAREN,
    STATE(2169), 1,
      sym__unboxed_open,
    STATE(6740), 1,
      sym_constructor,
    STATE(14684), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6567), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6579), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7895), 2,
      sym_type_apply,
      sym__btype,
    STATE(10337), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6561), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6980), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7019), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2552), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [76698] = 23,
    ACTIONS(6006), 1,
      sym__integer_literal,
    ACTIONS(6016), 1,
      sym__conid,
    ACTIONS(6018), 1,
      anon_sym_LBRACK,
    ACTIONS(6020), 1,
      anon_sym_SQUOTE,
    ACTIONS(6024), 1,
      anon_sym_7,
    ACTIONS(6026), 1,
      sym__splice_dollar,
    ACTIONS(6028), 1,
      sym_quasiquote_start,
    ACTIONS(9528), 1,
      anon_sym_LPAREN,
    ACTIONS(12168), 1,
      sym__varid,
    STATE(2202), 1,
      sym__unboxed_open,
    STATE(7295), 1,
      sym_constructor,
    STATE(14836), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6010), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6022), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8310), 2,
      sym_type_apply,
      sym__btype,
    STATE(12524), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6004), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6008), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7412), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7485), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2753), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [76800] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(8171), 1,
      sym__varid,
    ACTIONS(9775), 1,
      anon_sym_SQUOTE,
    ACTIONS(13398), 1,
      anon_sym_LPAREN,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2866), 1,
      sym_type_name,
    STATE(7280), 1,
      sym_constructor,
    STATE(14283), 1,
      sym_type_infix,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(17412), 1,
      sym_constraint,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9712), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [76906] = 23,
    ACTIONS(6507), 1,
      sym__integer_literal,
    ACTIONS(6517), 1,
      sym__conid,
    ACTIONS(6519), 1,
      anon_sym_LBRACK,
    ACTIONS(6521), 1,
      anon_sym_SQUOTE,
    ACTIONS(6525), 1,
      anon_sym_7,
    ACTIONS(6527), 1,
      sym__splice_dollar,
    ACTIONS(6529), 1,
      sym_quasiquote_start,
    ACTIONS(8514), 1,
      sym__varid,
    ACTIONS(8516), 1,
      anon_sym_LPAREN,
    STATE(2209), 1,
      sym__unboxed_open,
    STATE(6790), 1,
      sym_constructor,
    STATE(14821), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6511), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6523), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7968), 2,
      sym_type_apply,
      sym__btype,
    STATE(12301), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6505), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6509), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7156), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7260), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2713), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [77008] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(9860), 1,
      anon_sym_SQUOTE,
    ACTIONS(11401), 1,
      sym__varid,
    ACTIONS(13360), 1,
      anon_sym_LPAREN,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2818), 1,
      sym_type_name,
    STATE(5968), 1,
      sym_constructor,
    STATE(13786), 1,
      sym_type_infix,
    STATE(14649), 1,
      aux_sym__qualifying_module,
    STATE(15341), 1,
      sym_constraint,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9600), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6463), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [77114] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1329), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13400), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [77226] = 23,
    ACTIONS(6780), 1,
      sym__integer_literal,
    ACTIONS(6790), 1,
      sym__conid,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(6794), 1,
      anon_sym_SQUOTE,
    ACTIONS(6798), 1,
      anon_sym_7,
    ACTIONS(6800), 1,
      sym__splice_dollar,
    ACTIONS(6802), 1,
      sym_quasiquote_start,
    ACTIONS(8291), 1,
      sym__varid,
    ACTIONS(8293), 1,
      anon_sym_LPAREN,
    STATE(2147), 1,
      sym__unboxed_open,
    STATE(6715), 1,
      sym_constructor,
    STATE(14702), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6784), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6796), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7908), 2,
      sym_type_apply,
      sym__btype,
    STATE(10382), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6778), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6782), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6959), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7008), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2557), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [77328] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1500), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13402), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [77440] = 23,
    ACTIONS(6171), 1,
      sym__integer_literal,
    ACTIONS(6181), 1,
      sym__conid,
    ACTIONS(6183), 1,
      anon_sym_LBRACK,
    ACTIONS(6185), 1,
      anon_sym_SQUOTE,
    ACTIONS(6189), 1,
      anon_sym_7,
    ACTIONS(6191), 1,
      sym__splice_dollar,
    ACTIONS(6193), 1,
      sym_quasiquote_start,
    ACTIONS(9402), 1,
      sym__varid,
    ACTIONS(9404), 1,
      anon_sym_LPAREN,
    STATE(2197), 1,
      sym__unboxed_open,
    STATE(7110), 1,
      sym_constructor,
    STATE(15277), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6175), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6187), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8314), 2,
      sym_type_apply,
      sym__btype,
    STATE(12547), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6169), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6173), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7386), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7585), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2736), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [77542] = 23,
    ACTIONS(7401), 1,
      sym__integer_literal,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(7413), 1,
      anon_sym_LBRACK,
    ACTIONS(7415), 1,
      anon_sym_SQUOTE,
    ACTIONS(7419), 1,
      anon_sym_7,
    ACTIONS(7421), 1,
      sym__splice_dollar,
    ACTIONS(7423), 1,
      sym_quasiquote_start,
    ACTIONS(7652), 1,
      anon_sym_LPAREN,
    ACTIONS(11401), 1,
      sym__varid,
    STATE(2133), 1,
      sym__unboxed_open,
    STATE(5968), 1,
      sym_constructor,
    STATE(14649), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7405), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7417), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7597), 2,
      sym_type_apply,
      sym__btype,
    STATE(12583), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7399), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7403), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6463), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6509), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2456), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [77644] = 23,
    ACTIONS(6933), 1,
      sym__integer_literal,
    ACTIONS(6943), 1,
      sym__conid,
    ACTIONS(6945), 1,
      anon_sym_LBRACK,
    ACTIONS(6947), 1,
      anon_sym_SQUOTE,
    ACTIONS(6951), 1,
      anon_sym_7,
    ACTIONS(6953), 1,
      sym__splice_dollar,
    ACTIONS(6955), 1,
      sym_quasiquote_start,
    ACTIONS(8534), 1,
      anon_sym_LPAREN,
    ACTIONS(13404), 1,
      sym__varid,
    STATE(2178), 1,
      sym__unboxed_open,
    STATE(6843), 1,
      sym_constructor,
    STATE(15295), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6937), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(6949), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8109), 2,
      sym_type_apply,
      sym__btype,
    STATE(12240), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(6931), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6935), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7262), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7278), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2679), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [77746] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1459), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13406), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [77858] = 23,
    ACTIONS(11037), 1,
      sym__integer_literal,
    ACTIONS(11043), 1,
      anon_sym_LPAREN,
    ACTIONS(11048), 1,
      anon_sym_LBRACK,
    ACTIONS(11055), 1,
      anon_sym_7,
    ACTIONS(11057), 1,
      sym__splice_dollar,
    ACTIONS(11059), 1,
      sym_quasiquote_start,
    ACTIONS(11538), 1,
      sym__varid,
    ACTIONS(11540), 1,
      sym__conid,
    ACTIONS(11542), 1,
      anon_sym_SQUOTE,
    STATE(2146), 1,
      sym__unboxed_open,
    STATE(7937), 1,
      sym_constructor,
    STATE(15334), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11041), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11053), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9234), 2,
      sym_type_apply,
      sym__btype,
    STATE(14080), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(11035), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11039), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7988), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(7989), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2872), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [77960] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1600), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13408), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [78072] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(8171), 1,
      sym__varid,
    ACTIONS(9775), 1,
      anon_sym_SQUOTE,
    ACTIONS(13398), 1,
      anon_sym_LPAREN,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2866), 1,
      sym_type_name,
    STATE(7280), 1,
      sym_constructor,
    STATE(14283), 1,
      sym_type_infix,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(17217), 1,
      sym_constraint,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9712), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7399), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [78178] = 23,
    ACTIONS(7233), 1,
      sym__integer_literal,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(7245), 1,
      anon_sym_LBRACK,
    ACTIONS(7247), 1,
      anon_sym_SQUOTE,
    ACTIONS(7251), 1,
      anon_sym_7,
    ACTIONS(7253), 1,
      sym__splice_dollar,
    ACTIONS(7255), 1,
      sym_quasiquote_start,
    ACTIONS(7680), 1,
      anon_sym_LPAREN,
    ACTIONS(11751), 1,
      sym__varid,
    STATE(2108), 1,
      sym__unboxed_open,
    STATE(5969), 1,
      sym_constructor,
    STATE(15009), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7237), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7249), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(7690), 2,
      sym_type_apply,
      sym__btype,
    STATE(12710), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7231), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7235), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6424), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6425), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(2461), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [78280] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(9846), 1,
      anon_sym_SQUOTE,
    ACTIONS(11751), 1,
      sym__varid,
    ACTIONS(13410), 1,
      anon_sym_LPAREN,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2827), 1,
      sym_type_name,
    STATE(5969), 1,
      sym_constructor,
    STATE(13961), 1,
      sym_type_infix,
    STATE(15009), 1,
      aux_sym__qualifying_module,
    STATE(15383), 1,
      sym_constraint,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9658), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6424), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [78386] = 28,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(1575), 1,
      sym__arrow,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13412), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [78498] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(6181), 1,
      sym__conid,
    ACTIONS(9402), 1,
      sym__varid,
    ACTIONS(12336), 1,
      anon_sym_SQUOTE,
    ACTIONS(13414), 1,
      anon_sym_LPAREN,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2816), 1,
      sym_type_name,
    STATE(7110), 1,
      sym_constructor,
    STATE(13399), 1,
      sym_constraint,
    STATE(13403), 1,
      sym_type_infix,
    STATE(15277), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9694), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7585), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [78604] = 23,
    ACTIONS(7373), 1,
      sym__integer_literal,
    ACTIONS(7383), 1,
      sym__conid,
    ACTIONS(7385), 1,
      anon_sym_LBRACK,
    ACTIONS(7387), 1,
      anon_sym_SQUOTE,
    ACTIONS(7391), 1,
      anon_sym_7,
    ACTIONS(7393), 1,
      sym__splice_dollar,
    ACTIONS(7395), 1,
      sym_quasiquote_start,
    ACTIONS(9836), 1,
      anon_sym_LPAREN,
    ACTIONS(13416), 1,
      sym__varid,
    STATE(2159), 1,
      sym__unboxed_open,
    STATE(7574), 1,
      sym_constructor,
    STATE(15052), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7377), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(7389), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(8651), 2,
      sym_type_apply,
      sym__btype,
    STATE(13005), 2,
      sym_type_infix,
      sym__type_infix,
    ACTIONS(7371), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7375), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7606), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7609), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2780), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [78706] = 25,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5102), 1,
      anon_sym_7,
    ACTIONS(5104), 1,
      sym__splice_dollar,
    ACTIONS(5106), 1,
      sym_quasiquote_start,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(9846), 1,
      anon_sym_SQUOTE,
    ACTIONS(11751), 1,
      sym__varid,
    ACTIONS(13410), 1,
      anon_sym_LPAREN,
    STATE(2210), 1,
      sym__unboxed_open,
    STATE(2827), 1,
      sym_type_name,
    STATE(5969), 1,
      sym_constructor,
    STATE(13961), 1,
      sym_type_infix,
    STATE(15009), 1,
      aux_sym__qualifying_module,
    STATE(15290), 1,
      sym_constraint,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5086), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(5098), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(9658), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(6424), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(2042), 13,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [78812] = 27,
    ACTIONS(13418), 1,
      sym__varid,
    ACTIONS(13424), 1,
      sym__integer_literal,
    ACTIONS(13433), 1,
      anon_sym_LPAREN,
    ACTIONS(13436), 1,
      sym__conid,
    ACTIONS(13439), 1,
      anon_sym_LBRACK,
    ACTIONS(13442), 1,
      anon_sym__,
    ACTIONS(13445), 1,
      anon_sym_7,
    ACTIONS(13448), 1,
      sym__splice_dollar,
    ACTIONS(13451), 1,
      sym_quasiquote_start,
    ACTIONS(13454), 1,
      sym__strict,
    ACTIONS(13457), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10346), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(13430), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13421), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13427), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3419), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [78921] = 28,
    ACTIONS(10970), 1,
      sym__integer_literal,
    ACTIONS(10978), 1,
      sym__conid,
    ACTIONS(10986), 1,
      anon_sym_7,
    ACTIONS(10988), 1,
      sym__splice_dollar,
    ACTIONS(10990), 1,
      sym_quasiquote_start,
    ACTIONS(13460), 1,
      sym__varid,
    ACTIONS(13466), 1,
      anon_sym_LPAREN,
    ACTIONS(13468), 1,
      anon_sym_LBRACK,
    ACTIONS(13472), 1,
      anon_sym__,
    ACTIONS(13474), 1,
      sym__strict,
    ACTIONS(13476), 1,
      sym__lazy,
    STATE(284), 1,
      sym__unboxed_open,
    STATE(3422), 1,
      aux_sym__fun_patterns,
    STATE(7865), 1,
      sym_constructor,
    STATE(7921), 1,
      sym_qualified_constructor,
    STATE(9088), 1,
      sym__pat_constructor,
    STATE(9223), 1,
      sym_variable,
    STATE(9225), 1,
      sym__qcon,
    STATE(9369), 1,
      sym_literal,
    STATE(15266), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13464), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13470), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(10972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13462), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9318), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9262), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [79032] = 28,
    ACTIONS(13478), 1,
      sym__varid,
    ACTIONS(13484), 1,
      sym__integer_literal,
    ACTIONS(13493), 1,
      anon_sym_LPAREN,
    ACTIONS(13496), 1,
      sym__conid,
    ACTIONS(13499), 1,
      anon_sym_LBRACK,
    ACTIONS(13504), 1,
      anon_sym__,
    ACTIONS(13507), 1,
      anon_sym_7,
    ACTIONS(13510), 1,
      sym__splice_dollar,
    ACTIONS(13513), 1,
      sym_quasiquote_start,
    ACTIONS(13516), 1,
      sym__strict,
    ACTIONS(13519), 1,
      sym__lazy,
    STATE(284), 1,
      sym__unboxed_open,
    STATE(3421), 1,
      aux_sym__fun_patterns,
    STATE(7865), 1,
      sym_constructor,
    STATE(7921), 1,
      sym_qualified_constructor,
    STATE(9088), 1,
      sym__pat_constructor,
    STATE(9223), 1,
      sym_variable,
    STATE(9225), 1,
      sym__qcon,
    STATE(9369), 1,
      sym_literal,
    STATE(15266), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13490), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13502), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13481), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13487), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9318), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9262), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [79143] = 28,
    ACTIONS(10970), 1,
      sym__integer_literal,
    ACTIONS(10978), 1,
      sym__conid,
    ACTIONS(10986), 1,
      anon_sym_7,
    ACTIONS(10988), 1,
      sym__splice_dollar,
    ACTIONS(10990), 1,
      sym_quasiquote_start,
    ACTIONS(13460), 1,
      sym__varid,
    ACTIONS(13466), 1,
      anon_sym_LPAREN,
    ACTIONS(13468), 1,
      anon_sym_LBRACK,
    ACTIONS(13472), 1,
      anon_sym__,
    ACTIONS(13474), 1,
      sym__strict,
    ACTIONS(13476), 1,
      sym__lazy,
    STATE(284), 1,
      sym__unboxed_open,
    STATE(3421), 1,
      aux_sym__fun_patterns,
    STATE(7865), 1,
      sym_constructor,
    STATE(7921), 1,
      sym_qualified_constructor,
    STATE(9088), 1,
      sym__pat_constructor,
    STATE(9223), 1,
      sym_variable,
    STATE(9225), 1,
      sym__qcon,
    STATE(9369), 1,
      sym_literal,
    STATE(15266), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13464), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13522), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(10972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13462), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9318), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9262), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [79254] = 23,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12498), 1,
      anon_sym_EQ,
    ACTIONS(12502), 1,
      anon_sym_instance,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13524), 1,
      sym__varid,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3446), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [79355] = 23,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(12517), 1,
      anon_sym_EQ,
    ACTIONS(12521), 1,
      anon_sym_instance,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13524), 1,
      sym__varid,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3447), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [79456] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13526), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3351), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [79564] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13528), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3263), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [79662] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13530), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3467), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [79760] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13532), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3409), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [79868] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13534), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3387), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [79976] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13536), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3346), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [80084] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13538), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3405), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [80192] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13540), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3340), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [80300] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13542), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3354), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [80408] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13544), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3263), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [80506] = 22,
    ACTIONS(13546), 1,
      sym__varid,
    ACTIONS(13550), 1,
      sym__integer_literal,
    ACTIONS(13556), 1,
      anon_sym_LPAREN,
    ACTIONS(13558), 1,
      sym__conid,
    ACTIONS(13560), 1,
      anon_sym_LBRACK,
    ACTIONS(13562), 1,
      anon_sym_SQUOTE,
    ACTIONS(13566), 1,
      anon_sym_LBRACE,
    ACTIONS(13568), 1,
      anon_sym_7,
    ACTIONS(13570), 1,
      sym__splice_dollar,
    ACTIONS(13572), 1,
      sym_quasiquote_start,
    STATE(2194), 1,
      sym__unboxed_open,
    STATE(14135), 1,
      sym_constructor,
    STATE(15092), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13554), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13564), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13548), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13552), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15221), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15223), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(15292), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym__record_field,
      sym_splice,
      sym_quasiquote,
  [80604] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13574), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3415), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [80712] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13576), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3466), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [80810] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13578), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3365), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [80918] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13580), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3329), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [81026] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13582), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3345), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [81134] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13584), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3342), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [81242] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13586), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3375), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [81350] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13588), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3263), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [81448] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13590), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3443), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [81546] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13592), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3426), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [81644] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13592), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3263), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [81742] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13594), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3263), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [81840] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13594), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3434), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [81938] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13596), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3397), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [82046] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13598), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3339), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [82154] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13600), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3391), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [82262] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13602), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3411), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [82370] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13604), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3263), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [82468] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13606), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3263), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [82566] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13608), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3343), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [82674] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    STATE(19511), 2,
      sym_type_apply,
      sym__btype,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3465), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [82772] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13610), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3389), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [82880] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13612), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3403), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [82988] = 22,
    ACTIONS(13614), 1,
      sym__varid,
    ACTIONS(13618), 1,
      sym__integer_literal,
    ACTIONS(13624), 1,
      anon_sym_LPAREN,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(13628), 1,
      anon_sym_LBRACK,
    ACTIONS(13630), 1,
      anon_sym_SQUOTE,
    ACTIONS(13634), 1,
      anon_sym_LBRACE,
    ACTIONS(13636), 1,
      anon_sym_7,
    ACTIONS(13638), 1,
      sym__splice_dollar,
    ACTIONS(13640), 1,
      sym_quasiquote_start,
    STATE(2163), 1,
      sym__unboxed_open,
    STATE(13520), 1,
      sym_constructor,
    STATE(14747), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13622), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13632), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13616), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13620), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14250), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(14252), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(16012), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym__record_field,
      sym_splice,
      sym_quasiquote,
  [83086] = 22,
    ACTIONS(13642), 1,
      sym__varid,
    ACTIONS(13646), 1,
      sym__integer_literal,
    ACTIONS(13652), 1,
      anon_sym_LPAREN,
    ACTIONS(13654), 1,
      sym__conid,
    ACTIONS(13656), 1,
      anon_sym_LBRACK,
    ACTIONS(13658), 1,
      anon_sym_SQUOTE,
    ACTIONS(13662), 1,
      anon_sym_LBRACE,
    ACTIONS(13664), 1,
      anon_sym_7,
    ACTIONS(13666), 1,
      sym__splice_dollar,
    ACTIONS(13668), 1,
      sym_quasiquote_start,
    STATE(2175), 1,
      sym__unboxed_open,
    STATE(13333), 1,
      sym_constructor,
    STATE(15304), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13650), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13660), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13644), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13648), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13448), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13450), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(14950), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym__record_field,
      sym_splice,
      sym_quasiquote,
  [83184] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13670), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3376), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [83292] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13672), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3341), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [83400] = 27,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    ACTIONS(13674), 1,
      anon_sym_case,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3355), 15,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
      aux_sym_exp_lambda_repeat1,
  [83508] = 22,
    ACTIONS(5177), 1,
      anon_sym_EQ,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3263), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [83606] = 22,
    ACTIONS(5078), 1,
      anon_sym_EQ,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3464), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [83704] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13676), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3263), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [83802] = 22,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12494), 1,
      anon_sym_SQUOTE,
    ACTIONS(12504), 1,
      anon_sym_7,
    ACTIONS(12506), 1,
      sym__splice_dollar,
    ACTIONS(12508), 1,
      sym_quasiquote_start,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(13081), 1,
      sym__varid,
    ACTIONS(13083), 1,
      anon_sym_LPAREN,
    ACTIONS(13678), 1,
      anon_sym_EQ,
    STATE(2143), 1,
      sym__unboxed_open,
    STATE(8683), 1,
      sym_constructor,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12486), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12496), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8872), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3263), 15,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
      aux_sym_type_apply_repeat1,
  [83900] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 33,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [83959] = 16,
    ACTIONS(13698), 1,
      sym__conid,
    ACTIONS(13707), 1,
      anon_sym__,
    ACTIONS(13709), 1,
      anon_sym_AT2,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2381), 1,
      sym__colon2,
    STATE(13815), 1,
      aux_sym_signature_repeat1,
    STATE(15559), 1,
      sym__type_annotation,
    ACTIONS(13692), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13704), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13713), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(13686), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13684), 8,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(13702), 8,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13689), 12,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [84044] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 35,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [84105] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [84166] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [84227] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [84288] = 16,
    ACTIONS(13698), 1,
      sym__conid,
    ACTIONS(13707), 1,
      anon_sym__,
    ACTIONS(13709), 1,
      anon_sym_AT2,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2369), 1,
      sym__colon2,
    STATE(13926), 1,
      aux_sym_signature_repeat1,
    STATE(16688), 1,
      sym__type_annotation,
    ACTIONS(13704), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13713), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(13723), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13686), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13684), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(13702), 8,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13689), 12,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [84373] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 35,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [84434] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 33,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [84493] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [84554] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 36,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [84613] = 26,
    ACTIONS(12879), 1,
      sym__varid,
    ACTIONS(12883), 1,
      sym__integer_literal,
    ACTIONS(12895), 1,
      anon_sym_LBRACK,
    ACTIONS(12897), 1,
      anon_sym__,
    ACTIONS(12899), 1,
      anon_sym_7,
    ACTIONS(12901), 1,
      sym__splice_dollar,
    ACTIONS(12903), 1,
      sym_quasiquote_start,
    ACTIONS(12905), 1,
      sym__strict,
    ACTIONS(12907), 1,
      sym__lazy,
    ACTIONS(13726), 1,
      anon_sym_LPAREN,
    ACTIONS(13728), 1,
      sym__conid,
    STATE(448), 1,
      sym__unboxed_open,
    STATE(12875), 1,
      sym__pat_constructor,
    STATE(13021), 1,
      sym_constructor,
    STATE(13155), 1,
      sym_qualified_constructor,
    STATE(13211), 1,
      sym_variable,
    STATE(13247), 1,
      sym__qcon,
    STATE(13720), 1,
      sym_literal,
    STATE(15309), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12887), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12881), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12885), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13393), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13724), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [84717] = 26,
    ACTIONS(12523), 1,
      sym__varid,
    ACTIONS(12527), 1,
      sym__integer_literal,
    ACTIONS(12539), 1,
      anon_sym_LBRACK,
    ACTIONS(12541), 1,
      anon_sym__,
    ACTIONS(12543), 1,
      anon_sym_7,
    ACTIONS(12545), 1,
      sym__splice_dollar,
    ACTIONS(12547), 1,
      sym_quasiquote_start,
    ACTIONS(12549), 1,
      sym__strict,
    ACTIONS(12551), 1,
      sym__lazy,
    ACTIONS(13730), 1,
      anon_sym_LPAREN,
    ACTIONS(13732), 1,
      sym__conid,
    STATE(316), 1,
      sym__unboxed_open,
    STATE(12839), 1,
      sym_constructor,
    STATE(13032), 1,
      sym__pat_constructor,
    STATE(13179), 1,
      sym__qcon,
    STATE(13258), 1,
      sym_variable,
    STATE(13272), 1,
      sym_qualified_constructor,
    STATE(13742), 1,
      sym_literal,
    STATE(15014), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12531), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12525), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12529), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13590), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13898), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [84821] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [84879] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [84937] = 21,
    ACTIONS(4511), 1,
      sym__integer_literal,
    ACTIONS(4519), 1,
      sym__conid,
    ACTIONS(4523), 1,
      anon_sym_7,
    ACTIONS(4525), 1,
      sym__splice_dollar,
    ACTIONS(4527), 1,
      sym_quasiquote_start,
    ACTIONS(13742), 1,
      sym__varid,
    ACTIONS(13748), 1,
      anon_sym_LPAREN,
    ACTIONS(13750), 1,
      anon_sym_LBRACK,
    ACTIONS(13752), 1,
      anon_sym_SQUOTE,
    STATE(2190), 1,
      sym__unboxed_open,
    STATE(10396), 1,
      sym_constructor,
    STATE(14968), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13746), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13754), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4513), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13744), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11415), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11433), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11906), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [85031] = 21,
    ACTIONS(9276), 1,
      sym__integer_literal,
    ACTIONS(9286), 1,
      sym__conid,
    ACTIONS(9300), 1,
      anon_sym_7,
    ACTIONS(9302), 1,
      sym__splice_dollar,
    ACTIONS(9304), 1,
      sym_quasiquote_start,
    ACTIONS(13756), 1,
      sym__varid,
    ACTIONS(13762), 1,
      anon_sym_LPAREN,
    ACTIONS(13764), 1,
      anon_sym_LBRACK,
    ACTIONS(13766), 1,
      anon_sym_SQUOTE,
    STATE(2187), 1,
      sym__unboxed_open,
    STATE(10628), 1,
      sym_constructor,
    STATE(14784), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13760), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13768), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9278), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13758), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10940), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11096), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11609), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [85125] = 21,
    ACTIONS(9276), 1,
      sym__integer_literal,
    ACTIONS(9286), 1,
      sym__conid,
    ACTIONS(9300), 1,
      anon_sym_7,
    ACTIONS(9302), 1,
      sym__splice_dollar,
    ACTIONS(9304), 1,
      sym_quasiquote_start,
    ACTIONS(13756), 1,
      sym__varid,
    ACTIONS(13762), 1,
      anon_sym_LPAREN,
    ACTIONS(13764), 1,
      anon_sym_LBRACK,
    ACTIONS(13766), 1,
      anon_sym_SQUOTE,
    STATE(2187), 1,
      sym__unboxed_open,
    STATE(10628), 1,
      sym_constructor,
    STATE(14784), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13760), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13768), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9278), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13758), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10940), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11096), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(10973), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [85219] = 26,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(13770), 1,
      anon_sym_LPAREN,
    ACTIONS(13772), 1,
      sym__conid,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(12587), 1,
      sym_constructor,
    STATE(12720), 1,
      sym__pat_constructor,
    STATE(12782), 1,
      sym__qcon,
    STATE(13035), 1,
      sym_variable,
    STATE(13075), 1,
      sym_qualified_constructor,
    STATE(13142), 1,
      sym_literal,
    STATE(15349), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13260), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [85323] = 26,
    ACTIONS(101), 1,
      sym__conid,
    ACTIONS(9985), 1,
      sym__varid,
    ACTIONS(9989), 1,
      sym__integer_literal,
    ACTIONS(9995), 1,
      anon_sym_LPAREN,
    ACTIONS(10000), 1,
      anon_sym_LBRACK,
    ACTIONS(10004), 1,
      anon_sym__,
    ACTIONS(10006), 1,
      anon_sym_7,
    ACTIONS(10008), 1,
      sym__splice_dollar,
    ACTIONS(10010), 1,
      sym_quasiquote_start,
    ACTIONS(10012), 1,
      sym__strict,
    ACTIONS(10014), 1,
      sym__lazy,
    STATE(244), 1,
      sym__unboxed_open,
    STATE(3918), 1,
      sym_constructor,
    STATE(4144), 1,
      sym_qualified_constructor,
    STATE(7785), 1,
      sym__pat_constructor,
    STATE(7891), 1,
      sym__qcon,
    STATE(7911), 1,
      sym_variable,
    STATE(8114), 1,
      sym_literal,
    STATE(15129), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9993), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9987), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9991), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8149), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7963), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [85427] = 26,
    ACTIONS(101), 1,
      sym__conid,
    ACTIONS(9985), 1,
      sym__varid,
    ACTIONS(9989), 1,
      sym__integer_literal,
    ACTIONS(9995), 1,
      anon_sym_LPAREN,
    ACTIONS(10000), 1,
      anon_sym_LBRACK,
    ACTIONS(10004), 1,
      anon_sym__,
    ACTIONS(10006), 1,
      anon_sym_7,
    ACTIONS(10008), 1,
      sym__splice_dollar,
    ACTIONS(10010), 1,
      sym_quasiquote_start,
    ACTIONS(10012), 1,
      sym__strict,
    ACTIONS(10014), 1,
      sym__lazy,
    STATE(244), 1,
      sym__unboxed_open,
    STATE(3918), 1,
      sym_constructor,
    STATE(4144), 1,
      sym_qualified_constructor,
    STATE(7785), 1,
      sym__pat_constructor,
    STATE(7891), 1,
      sym__qcon,
    STATE(7911), 1,
      sym_variable,
    STATE(8114), 1,
      sym_literal,
    STATE(15129), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9993), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9987), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9991), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8149), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7962), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [85531] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [85589] = 26,
    ACTIONS(661), 1,
      anon_sym__,
    ACTIONS(673), 1,
      sym__strict,
    ACTIONS(675), 1,
      sym__lazy,
    ACTIONS(10559), 1,
      sym__varid,
    ACTIONS(10563), 1,
      sym__integer_literal,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    ACTIONS(10577), 1,
      anon_sym_7,
    ACTIONS(10579), 1,
      sym__splice_dollar,
    ACTIONS(10581), 1,
      sym_quasiquote_start,
    ACTIONS(13778), 1,
      anon_sym_LPAREN,
    ACTIONS(13780), 1,
      sym__conid,
    STATE(366), 1,
      sym__unboxed_open,
    STATE(11599), 1,
      sym__pat_constructor,
    STATE(11620), 1,
      sym_constructor,
    STATE(12024), 1,
      sym_variable,
    STATE(12025), 1,
      sym__qcon,
    STATE(12143), 1,
      sym_qualified_constructor,
    STATE(12264), 1,
      sym_literal,
    STATE(14725), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10567), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10561), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12470), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12315), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [85693] = 21,
    ACTIONS(13642), 1,
      sym__varid,
    ACTIONS(13646), 1,
      sym__integer_literal,
    ACTIONS(13652), 1,
      anon_sym_LPAREN,
    ACTIONS(13654), 1,
      sym__conid,
    ACTIONS(13656), 1,
      anon_sym_LBRACK,
    ACTIONS(13658), 1,
      anon_sym_SQUOTE,
    ACTIONS(13664), 1,
      anon_sym_7,
    ACTIONS(13666), 1,
      sym__splice_dollar,
    ACTIONS(13668), 1,
      sym_quasiquote_start,
    STATE(2175), 1,
      sym__unboxed_open,
    STATE(13333), 1,
      sym_constructor,
    STATE(15304), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13650), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13660), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13644), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13648), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13448), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13450), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(14450), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [85787] = 26,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(13770), 1,
      anon_sym_LPAREN,
    ACTIONS(13772), 1,
      sym__conid,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(12587), 1,
      sym_constructor,
    STATE(12720), 1,
      sym__pat_constructor,
    STATE(12782), 1,
      sym__qcon,
    STATE(13035), 1,
      sym_variable,
    STATE(13075), 1,
      sym_qualified_constructor,
    STATE(13142), 1,
      sym_literal,
    STATE(15349), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13261), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [85891] = 21,
    ACTIONS(13642), 1,
      sym__varid,
    ACTIONS(13646), 1,
      sym__integer_literal,
    ACTIONS(13652), 1,
      anon_sym_LPAREN,
    ACTIONS(13654), 1,
      sym__conid,
    ACTIONS(13656), 1,
      anon_sym_LBRACK,
    ACTIONS(13658), 1,
      anon_sym_SQUOTE,
    ACTIONS(13664), 1,
      anon_sym_7,
    ACTIONS(13666), 1,
      sym__splice_dollar,
    ACTIONS(13668), 1,
      sym_quasiquote_start,
    STATE(2175), 1,
      sym__unboxed_open,
    STATE(13333), 1,
      sym_constructor,
    STATE(15304), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13650), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13660), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13644), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13648), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13448), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13450), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(14453), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [85985] = 21,
    ACTIONS(537), 1,
      sym__integer_literal,
    ACTIONS(571), 1,
      anon_sym_7,
    ACTIONS(573), 1,
      sym__splice_dollar,
    ACTIONS(577), 1,
      sym_quasiquote_start,
    ACTIONS(1753), 1,
      sym__conid,
    ACTIONS(13782), 1,
      sym__varid,
    ACTIONS(13788), 1,
      anon_sym_LPAREN,
    ACTIONS(13790), 1,
      anon_sym_LBRACK,
    ACTIONS(13792), 1,
      anon_sym_SQUOTE,
    STATE(2148), 1,
      sym__unboxed_open,
    STATE(4255), 1,
      sym_constructor,
    STATE(15112), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13786), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13794), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(539), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13784), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4421), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4667), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4415), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [86079] = 15,
    ACTIONS(13711), 1,
      sym_comma,
    ACTIONS(13808), 1,
      sym__conid,
    ACTIONS(13815), 1,
      anon_sym__,
    STATE(2369), 1,
      sym__colon2,
    STATE(13938), 1,
      aux_sym_signature_repeat1,
    STATE(16772), 1,
      sym__type_annotation,
    ACTIONS(13802), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13812), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13817), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(13796), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13774), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(13799), 12,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [86161] = 21,
    ACTIONS(537), 1,
      sym__integer_literal,
    ACTIONS(571), 1,
      anon_sym_7,
    ACTIONS(573), 1,
      sym__splice_dollar,
    ACTIONS(577), 1,
      sym_quasiquote_start,
    ACTIONS(1753), 1,
      sym__conid,
    ACTIONS(13782), 1,
      sym__varid,
    ACTIONS(13788), 1,
      anon_sym_LPAREN,
    ACTIONS(13790), 1,
      anon_sym_LBRACK,
    ACTIONS(13792), 1,
      anon_sym_SQUOTE,
    STATE(2148), 1,
      sym__unboxed_open,
    STATE(4255), 1,
      sym_constructor,
    STATE(15112), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13786), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13794), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(539), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13784), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4421), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4667), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5159), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [86255] = 26,
    ACTIONS(12409), 1,
      sym__varid,
    ACTIONS(12413), 1,
      sym__integer_literal,
    ACTIONS(12425), 1,
      anon_sym_LBRACK,
    ACTIONS(12427), 1,
      anon_sym__,
    ACTIONS(12429), 1,
      anon_sym_7,
    ACTIONS(12431), 1,
      sym__splice_dollar,
    ACTIONS(12433), 1,
      sym_quasiquote_start,
    ACTIONS(12435), 1,
      sym__strict,
    ACTIONS(12437), 1,
      sym__lazy,
    ACTIONS(13819), 1,
      anon_sym_LPAREN,
    ACTIONS(13821), 1,
      sym__conid,
    STATE(246), 1,
      sym__unboxed_open,
    STATE(12769), 1,
      sym_constructor,
    STATE(12956), 1,
      sym__pat_constructor,
    STATE(13103), 1,
      sym__qcon,
    STATE(13254), 1,
      sym_variable,
    STATE(13359), 1,
      sym_qualified_constructor,
    STATE(13703), 1,
      sym_literal,
    STATE(15353), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12417), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12411), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12415), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13394), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13684), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [86359] = 21,
    ACTIONS(9124), 1,
      sym__integer_literal,
    ACTIONS(9134), 1,
      sym__conid,
    ACTIONS(9148), 1,
      anon_sym_7,
    ACTIONS(9150), 1,
      sym__splice_dollar,
    ACTIONS(9152), 1,
      sym_quasiquote_start,
    ACTIONS(13823), 1,
      sym__varid,
    ACTIONS(13829), 1,
      anon_sym_LPAREN,
    ACTIONS(13831), 1,
      anon_sym_LBRACK,
    ACTIONS(13833), 1,
      anon_sym_SQUOTE,
    STATE(2203), 1,
      sym__unboxed_open,
    STATE(9974), 1,
      sym_constructor,
    STATE(15083), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13827), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13835), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9126), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13825), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10746), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(10842), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10609), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [86453] = 21,
    ACTIONS(4397), 1,
      sym__integer_literal,
    ACTIONS(4407), 1,
      sym__conid,
    ACTIONS(4421), 1,
      anon_sym_7,
    ACTIONS(4423), 1,
      sym__splice_dollar,
    ACTIONS(4425), 1,
      sym_quasiquote_start,
    ACTIONS(13837), 1,
      sym__varid,
    ACTIONS(13843), 1,
      anon_sym_LPAREN,
    ACTIONS(13845), 1,
      anon_sym_LBRACK,
    ACTIONS(13847), 1,
      anon_sym_SQUOTE,
    STATE(2096), 1,
      sym__unboxed_open,
    STATE(10057), 1,
      sym_constructor,
    STATE(15320), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13841), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13849), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4399), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13839), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10822), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(10824), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11130), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [86547] = 21,
    ACTIONS(4397), 1,
      sym__integer_literal,
    ACTIONS(4407), 1,
      sym__conid,
    ACTIONS(4421), 1,
      anon_sym_7,
    ACTIONS(4423), 1,
      sym__splice_dollar,
    ACTIONS(4425), 1,
      sym_quasiquote_start,
    ACTIONS(13837), 1,
      sym__varid,
    ACTIONS(13843), 1,
      anon_sym_LPAREN,
    ACTIONS(13845), 1,
      anon_sym_LBRACK,
    ACTIONS(13847), 1,
      anon_sym_SQUOTE,
    STATE(2096), 1,
      sym__unboxed_open,
    STATE(10057), 1,
      sym_constructor,
    STATE(15320), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13841), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13849), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4399), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13839), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10822), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(10824), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10598), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [86641] = 26,
    ACTIONS(10829), 1,
      sym__varid,
    ACTIONS(10833), 1,
      sym__integer_literal,
    ACTIONS(10839), 1,
      anon_sym_LPAREN,
    ACTIONS(10844), 1,
      anon_sym_LBRACK,
    ACTIONS(10848), 1,
      anon_sym__,
    ACTIONS(10850), 1,
      anon_sym_7,
    ACTIONS(10852), 1,
      sym__splice_dollar,
    ACTIONS(10854), 1,
      sym_quasiquote_start,
    ACTIONS(10856), 1,
      sym__strict,
    ACTIONS(10858), 1,
      sym__lazy,
    ACTIONS(12359), 1,
      sym__conid,
    STATE(417), 1,
      sym__unboxed_open,
    STATE(8050), 1,
      sym__pat_constructor,
    STATE(8096), 1,
      sym_constructor,
    STATE(8157), 1,
      sym_variable,
    STATE(8280), 1,
      sym__qcon,
    STATE(8294), 1,
      sym_qualified_constructor,
    STATE(8722), 1,
      sym_literal,
    STATE(15081), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10837), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10831), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10835), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8434), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8630), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [86745] = 26,
    ACTIONS(255), 1,
      anon_sym__,
    ACTIONS(281), 1,
      sym__strict,
    ACTIONS(283), 1,
      sym__lazy,
    ACTIONS(12909), 1,
      sym__varid,
    ACTIONS(12913), 1,
      sym__integer_literal,
    ACTIONS(12925), 1,
      anon_sym_LBRACK,
    ACTIONS(12927), 1,
      anon_sym_7,
    ACTIONS(12929), 1,
      sym__splice_dollar,
    ACTIONS(12931), 1,
      sym_quasiquote_start,
    ACTIONS(13851), 1,
      anon_sym_LPAREN,
    ACTIONS(13853), 1,
      sym__conid,
    STATE(463), 1,
      sym__unboxed_open,
    STATE(12060), 1,
      sym_constructor,
    STATE(12158), 1,
      sym__pat_constructor,
    STATE(12236), 1,
      sym_variable,
    STATE(12290), 1,
      sym_qualified_constructor,
    STATE(12365), 1,
      sym__qcon,
    STATE(12725), 1,
      sym_literal,
    STATE(15373), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12917), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12911), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12915), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12718), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12568), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [86849] = 26,
    ACTIONS(10312), 1,
      sym__varid,
    ACTIONS(10316), 1,
      sym__integer_literal,
    ACTIONS(10322), 1,
      anon_sym_LPAREN,
    ACTIONS(10327), 1,
      anon_sym_LBRACK,
    ACTIONS(10331), 1,
      anon_sym__,
    ACTIONS(10333), 1,
      anon_sym_7,
    ACTIONS(10335), 1,
      sym__splice_dollar,
    ACTIONS(10337), 1,
      sym_quasiquote_start,
    ACTIONS(10339), 1,
      sym__strict,
    ACTIONS(10341), 1,
      sym__lazy,
    ACTIONS(12389), 1,
      sym__conid,
    STATE(461), 1,
      sym__unboxed_open,
    STATE(7889), 1,
      sym_constructor,
    STATE(7930), 1,
      sym__pat_constructor,
    STATE(8054), 1,
      sym_qualified_constructor,
    STATE(8069), 1,
      sym_variable,
    STATE(8070), 1,
      sym__qcon,
    STATE(8364), 1,
      sym_literal,
    STATE(14874), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10320), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10314), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10318), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8245), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8172), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [86953] = 26,
    ACTIONS(10312), 1,
      sym__varid,
    ACTIONS(10316), 1,
      sym__integer_literal,
    ACTIONS(10322), 1,
      anon_sym_LPAREN,
    ACTIONS(10327), 1,
      anon_sym_LBRACK,
    ACTIONS(10331), 1,
      anon_sym__,
    ACTIONS(10333), 1,
      anon_sym_7,
    ACTIONS(10335), 1,
      sym__splice_dollar,
    ACTIONS(10337), 1,
      sym_quasiquote_start,
    ACTIONS(10339), 1,
      sym__strict,
    ACTIONS(10341), 1,
      sym__lazy,
    ACTIONS(12389), 1,
      sym__conid,
    STATE(461), 1,
      sym__unboxed_open,
    STATE(7889), 1,
      sym_constructor,
    STATE(7930), 1,
      sym__pat_constructor,
    STATE(8054), 1,
      sym_qualified_constructor,
    STATE(8069), 1,
      sym_variable,
    STATE(8070), 1,
      sym__qcon,
    STATE(8364), 1,
      sym_literal,
    STATE(14874), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10320), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10314), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10318), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8245), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8173), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [87057] = 26,
    ACTIONS(12523), 1,
      sym__varid,
    ACTIONS(12527), 1,
      sym__integer_literal,
    ACTIONS(12539), 1,
      anon_sym_LBRACK,
    ACTIONS(12541), 1,
      anon_sym__,
    ACTIONS(12543), 1,
      anon_sym_7,
    ACTIONS(12545), 1,
      sym__splice_dollar,
    ACTIONS(12547), 1,
      sym_quasiquote_start,
    ACTIONS(12549), 1,
      sym__strict,
    ACTIONS(12551), 1,
      sym__lazy,
    ACTIONS(13730), 1,
      anon_sym_LPAREN,
    ACTIONS(13732), 1,
      sym__conid,
    STATE(316), 1,
      sym__unboxed_open,
    STATE(12839), 1,
      sym_constructor,
    STATE(13032), 1,
      sym__pat_constructor,
    STATE(13179), 1,
      sym__qcon,
    STATE(13258), 1,
      sym_variable,
    STATE(13272), 1,
      sym_qualified_constructor,
    STATE(13742), 1,
      sym_literal,
    STATE(15014), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12531), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12525), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12529), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13590), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13904), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [87161] = 26,
    ACTIONS(101), 1,
      sym__conid,
    ACTIONS(9985), 1,
      sym__varid,
    ACTIONS(9989), 1,
      sym__integer_literal,
    ACTIONS(9995), 1,
      anon_sym_LPAREN,
    ACTIONS(10000), 1,
      anon_sym_LBRACK,
    ACTIONS(10004), 1,
      anon_sym__,
    ACTIONS(10006), 1,
      anon_sym_7,
    ACTIONS(10008), 1,
      sym__splice_dollar,
    ACTIONS(10010), 1,
      sym_quasiquote_start,
    ACTIONS(10012), 1,
      sym__strict,
    ACTIONS(10014), 1,
      sym__lazy,
    STATE(244), 1,
      sym__unboxed_open,
    STATE(3918), 1,
      sym_constructor,
    STATE(4144), 1,
      sym_qualified_constructor,
    STATE(7785), 1,
      sym__pat_constructor,
    STATE(7891), 1,
      sym__qcon,
    STATE(7911), 1,
      sym_variable,
    STATE(8114), 1,
      sym_literal,
    STATE(15129), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9993), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9987), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9991), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8149), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7945), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [87265] = 21,
    ACTIONS(159), 1,
      sym__integer_literal,
    ACTIONS(213), 1,
      anon_sym_7,
    ACTIONS(217), 1,
      sym__splice_dollar,
    ACTIONS(219), 1,
      sym_quasiquote_start,
    ACTIONS(4143), 1,
      sym__conid,
    ACTIONS(13855), 1,
      sym__varid,
    ACTIONS(13861), 1,
      anon_sym_LPAREN,
    ACTIONS(13863), 1,
      anon_sym_LBRACK,
    ACTIONS(13865), 1,
      anon_sym_SQUOTE,
    STATE(2128), 1,
      sym__unboxed_open,
    STATE(4464), 1,
      sym_constructor,
    STATE(14722), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13859), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13867), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(161), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13857), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5213), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5413), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5583), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [87359] = 21,
    ACTIONS(159), 1,
      sym__integer_literal,
    ACTIONS(213), 1,
      anon_sym_7,
    ACTIONS(217), 1,
      sym__splice_dollar,
    ACTIONS(219), 1,
      sym_quasiquote_start,
    ACTIONS(4143), 1,
      sym__conid,
    ACTIONS(13855), 1,
      sym__varid,
    ACTIONS(13861), 1,
      anon_sym_LPAREN,
    ACTIONS(13863), 1,
      anon_sym_LBRACK,
    ACTIONS(13865), 1,
      anon_sym_SQUOTE,
    STATE(2128), 1,
      sym__unboxed_open,
    STATE(4464), 1,
      sym_constructor,
    STATE(14722), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13859), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13867), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(161), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13857), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5213), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5413), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5182), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [87453] = 26,
    ACTIONS(33), 1,
      anon_sym__,
    ACTIONS(75), 1,
      sym__strict,
    ACTIONS(77), 1,
      sym__lazy,
    ACTIONS(4529), 1,
      sym__varid,
    ACTIONS(4533), 1,
      sym__integer_literal,
    ACTIONS(4541), 1,
      sym__conid,
    ACTIONS(4545), 1,
      anon_sym_7,
    ACTIONS(4547), 1,
      sym__splice_dollar,
    ACTIONS(4549), 1,
      sym_quasiquote_start,
    ACTIONS(4965), 1,
      anon_sym_LBRACK,
    ACTIONS(13869), 1,
      anon_sym_LPAREN,
    STATE(456), 1,
      sym__unboxed_open,
    STATE(9235), 1,
      sym_constructor,
    STATE(9289), 1,
      sym_qualified_constructor,
    STATE(12015), 1,
      sym__pat_constructor,
    STATE(12454), 1,
      sym_variable,
    STATE(12460), 1,
      sym__qcon,
    STATE(12624), 1,
      sym_literal,
    STATE(14621), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4959), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4531), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4535), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9283), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12616), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [87557] = 26,
    ACTIONS(33), 1,
      anon_sym__,
    ACTIONS(75), 1,
      sym__strict,
    ACTIONS(77), 1,
      sym__lazy,
    ACTIONS(4529), 1,
      sym__varid,
    ACTIONS(4533), 1,
      sym__integer_literal,
    ACTIONS(4541), 1,
      sym__conid,
    ACTIONS(4545), 1,
      anon_sym_7,
    ACTIONS(4547), 1,
      sym__splice_dollar,
    ACTIONS(4549), 1,
      sym_quasiquote_start,
    ACTIONS(4965), 1,
      anon_sym_LBRACK,
    ACTIONS(13869), 1,
      anon_sym_LPAREN,
    STATE(456), 1,
      sym__unboxed_open,
    STATE(9235), 1,
      sym_constructor,
    STATE(9289), 1,
      sym_qualified_constructor,
    STATE(12015), 1,
      sym__pat_constructor,
    STATE(12454), 1,
      sym_variable,
    STATE(12460), 1,
      sym__qcon,
    STATE(12624), 1,
      sym_literal,
    STATE(14621), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4959), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4531), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4535), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9283), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12592), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [87661] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [87719] = 21,
    ACTIONS(8926), 1,
      sym__integer_literal,
    ACTIONS(8936), 1,
      sym__conid,
    ACTIONS(8950), 1,
      anon_sym_7,
    ACTIONS(8952), 1,
      sym__splice_dollar,
    ACTIONS(8954), 1,
      sym_quasiquote_start,
    ACTIONS(13875), 1,
      sym__varid,
    ACTIONS(13881), 1,
      anon_sym_LPAREN,
    ACTIONS(13883), 1,
      anon_sym_LBRACK,
    ACTIONS(13885), 1,
      anon_sym_SQUOTE,
    STATE(2204), 1,
      sym__unboxed_open,
    STATE(10097), 1,
      sym_constructor,
    STATE(15282), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13879), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13887), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8928), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13877), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10779), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(10780), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10814), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [87813] = 21,
    ACTIONS(8926), 1,
      sym__integer_literal,
    ACTIONS(8936), 1,
      sym__conid,
    ACTIONS(8950), 1,
      anon_sym_7,
    ACTIONS(8952), 1,
      sym__splice_dollar,
    ACTIONS(8954), 1,
      sym_quasiquote_start,
    ACTIONS(13875), 1,
      sym__varid,
    ACTIONS(13881), 1,
      anon_sym_LPAREN,
    ACTIONS(13883), 1,
      anon_sym_LBRACK,
    ACTIONS(13885), 1,
      anon_sym_SQUOTE,
    STATE(2204), 1,
      sym__unboxed_open,
    STATE(10097), 1,
      sym_constructor,
    STATE(15282), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13879), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13887), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8928), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13877), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10779), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(10780), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10900), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [87907] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [87965] = 26,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(11000), 1,
      sym__varid,
    ACTIONS(11004), 1,
      sym__integer_literal,
    ACTIONS(11010), 1,
      anon_sym_LPAREN,
    ACTIONS(11015), 1,
      anon_sym_LBRACK,
    ACTIONS(11019), 1,
      anon_sym__,
    ACTIONS(11021), 1,
      anon_sym_7,
    ACTIONS(11023), 1,
      sym__splice_dollar,
    ACTIONS(11025), 1,
      sym_quasiquote_start,
    ACTIONS(11027), 1,
      sym__strict,
    ACTIONS(11029), 1,
      sym__lazy,
    STATE(315), 1,
      sym__unboxed_open,
    STATE(7993), 1,
      sym_constructor,
    STATE(8023), 1,
      sym__pat_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(8305), 1,
      sym_variable,
    STATE(8536), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11008), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11002), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11006), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8502), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8705), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [88069] = 21,
    ACTIONS(4533), 1,
      sym__integer_literal,
    ACTIONS(4541), 1,
      sym__conid,
    ACTIONS(4545), 1,
      anon_sym_7,
    ACTIONS(4547), 1,
      sym__splice_dollar,
    ACTIONS(4549), 1,
      sym_quasiquote_start,
    ACTIONS(13893), 1,
      sym__varid,
    ACTIONS(13899), 1,
      anon_sym_LPAREN,
    ACTIONS(13901), 1,
      anon_sym_LBRACK,
    ACTIONS(13903), 1,
      anon_sym_SQUOTE,
    STATE(2215), 1,
      sym__unboxed_open,
    STATE(9282), 1,
      sym_constructor,
    STATE(14915), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13897), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13905), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4535), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13895), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9380), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9381), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9444), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [88163] = 21,
    ACTIONS(1230), 1,
      sym__integer_literal,
    ACTIONS(1262), 1,
      anon_sym_7,
    ACTIONS(1264), 1,
      sym__splice_dollar,
    ACTIONS(1266), 1,
      sym_quasiquote_start,
    ACTIONS(3116), 1,
      sym__conid,
    ACTIONS(13907), 1,
      sym__varid,
    ACTIONS(13913), 1,
      anon_sym_LPAREN,
    ACTIONS(13915), 1,
      anon_sym_LBRACK,
    ACTIONS(13917), 1,
      anon_sym_SQUOTE,
    STATE(2139), 1,
      sym__unboxed_open,
    STATE(3920), 1,
      sym_constructor,
    STATE(15099), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13911), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13919), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(1232), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13909), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4126), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4153), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4207), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [88257] = 26,
    ACTIONS(1192), 1,
      anon_sym__,
    ACTIONS(1212), 1,
      sym__strict,
    ACTIONS(1214), 1,
      sym__lazy,
    ACTIONS(12641), 1,
      sym__varid,
    ACTIONS(12645), 1,
      sym__integer_literal,
    ACTIONS(12657), 1,
      anon_sym_LBRACK,
    ACTIONS(12659), 1,
      anon_sym_7,
    ACTIONS(12661), 1,
      sym__splice_dollar,
    ACTIONS(12663), 1,
      sym_quasiquote_start,
    ACTIONS(13921), 1,
      anon_sym_LPAREN,
    ACTIONS(13923), 1,
      sym__conid,
    STATE(459), 1,
      sym__unboxed_open,
    STATE(12594), 1,
      sym__pat_constructor,
    STATE(12717), 1,
      sym_constructor,
    STATE(12730), 1,
      sym_qualified_constructor,
    STATE(13094), 1,
      sym_variable,
    STATE(13095), 1,
      sym__qcon,
    STATE(13249), 1,
      sym_literal,
    STATE(14609), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12649), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12643), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12647), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13328), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13147), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [88361] = 21,
    ACTIONS(1171), 1,
      sym__integer_literal,
    ACTIONS(1206), 1,
      anon_sym_7,
    ACTIONS(1208), 1,
      sym__splice_dollar,
    ACTIONS(1210), 1,
      sym_quasiquote_start,
    ACTIONS(3032), 1,
      sym__conid,
    ACTIONS(13925), 1,
      sym__varid,
    ACTIONS(13931), 1,
      anon_sym_LPAREN,
    ACTIONS(13933), 1,
      anon_sym_LBRACK,
    ACTIONS(13935), 1,
      anon_sym_SQUOTE,
    STATE(2170), 1,
      sym__unboxed_open,
    STATE(4351), 1,
      sym_constructor,
    STATE(15388), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13929), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13937), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(1173), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13927), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4864), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4865), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4931), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [88455] = 21,
    ACTIONS(1171), 1,
      sym__integer_literal,
    ACTIONS(1206), 1,
      anon_sym_7,
    ACTIONS(1208), 1,
      sym__splice_dollar,
    ACTIONS(1210), 1,
      sym_quasiquote_start,
    ACTIONS(3032), 1,
      sym__conid,
    ACTIONS(13925), 1,
      sym__varid,
    ACTIONS(13931), 1,
      anon_sym_LPAREN,
    ACTIONS(13933), 1,
      anon_sym_LBRACK,
    ACTIONS(13935), 1,
      anon_sym_SQUOTE,
    STATE(2170), 1,
      sym__unboxed_open,
    STATE(4351), 1,
      sym_constructor,
    STATE(15388), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13929), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13937), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(1173), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13927), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4864), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4865), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5685), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [88549] = 21,
    ACTIONS(4533), 1,
      sym__integer_literal,
    ACTIONS(4541), 1,
      sym__conid,
    ACTIONS(4545), 1,
      anon_sym_7,
    ACTIONS(4547), 1,
      sym__splice_dollar,
    ACTIONS(4549), 1,
      sym_quasiquote_start,
    ACTIONS(13893), 1,
      sym__varid,
    ACTIONS(13899), 1,
      anon_sym_LPAREN,
    ACTIONS(13901), 1,
      anon_sym_LBRACK,
    ACTIONS(13903), 1,
      anon_sym_SQUOTE,
    STATE(2215), 1,
      sym__unboxed_open,
    STATE(9282), 1,
      sym_constructor,
    STATE(14915), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13897), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13905), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4535), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13895), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9380), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9381), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9400), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [88643] = 26,
    ACTIONS(11843), 1,
      sym__varid,
    ACTIONS(11847), 1,
      sym__integer_literal,
    ACTIONS(11853), 1,
      anon_sym_LPAREN,
    ACTIONS(11858), 1,
      anon_sym_LBRACK,
    ACTIONS(11862), 1,
      anon_sym__,
    ACTIONS(11864), 1,
      anon_sym_7,
    ACTIONS(11866), 1,
      sym__splice_dollar,
    ACTIONS(11868), 1,
      sym_quasiquote_start,
    ACTIONS(11870), 1,
      sym__strict,
    ACTIONS(11872), 1,
      sym__lazy,
    ACTIONS(12423), 1,
      sym__conid,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(8206), 1,
      sym__pat_constructor,
    STATE(8282), 1,
      sym_constructor,
    STATE(8549), 1,
      sym_qualified_constructor,
    STATE(8605), 1,
      sym_variable,
    STATE(8636), 1,
      sym__qcon,
    STATE(8922), 1,
      sym_literal,
    STATE(15196), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11851), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11845), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11849), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8940), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8873), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [88747] = 21,
    ACTIONS(1230), 1,
      sym__integer_literal,
    ACTIONS(1262), 1,
      anon_sym_7,
    ACTIONS(1264), 1,
      sym__splice_dollar,
    ACTIONS(1266), 1,
      sym_quasiquote_start,
    ACTIONS(3116), 1,
      sym__conid,
    ACTIONS(13907), 1,
      sym__varid,
    ACTIONS(13913), 1,
      anon_sym_LPAREN,
    ACTIONS(13915), 1,
      anon_sym_LBRACK,
    ACTIONS(13917), 1,
      anon_sym_SQUOTE,
    STATE(2139), 1,
      sym__unboxed_open,
    STATE(3920), 1,
      sym_constructor,
    STATE(15099), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13911), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13919), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(1232), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13909), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4126), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4153), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4159), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [88841] = 26,
    ACTIONS(557), 1,
      anon_sym__,
    ACTIONS(579), 1,
      sym__strict,
    ACTIONS(581), 1,
      sym__lazy,
    ACTIONS(12375), 1,
      sym__varid,
    ACTIONS(12379), 1,
      sym__integer_literal,
    ACTIONS(12391), 1,
      anon_sym_LBRACK,
    ACTIONS(12393), 1,
      anon_sym_7,
    ACTIONS(12395), 1,
      sym__splice_dollar,
    ACTIONS(12397), 1,
      sym_quasiquote_start,
    ACTIONS(13939), 1,
      anon_sym_LPAREN,
    ACTIONS(13941), 1,
      sym__conid,
    STATE(462), 1,
      sym__unboxed_open,
    STATE(12358), 1,
      sym_constructor,
    STATE(12487), 1,
      sym__pat_constructor,
    STATE(12510), 1,
      sym__qcon,
    STATE(12516), 1,
      sym_variable,
    STATE(12679), 1,
      sym_qualified_constructor,
    STATE(12754), 1,
      sym_literal,
    STATE(14733), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12383), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12377), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12381), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13060), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12785), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [88945] = 26,
    ACTIONS(661), 1,
      anon_sym__,
    ACTIONS(673), 1,
      sym__strict,
    ACTIONS(675), 1,
      sym__lazy,
    ACTIONS(10559), 1,
      sym__varid,
    ACTIONS(10563), 1,
      sym__integer_literal,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    ACTIONS(10577), 1,
      anon_sym_7,
    ACTIONS(10579), 1,
      sym__splice_dollar,
    ACTIONS(10581), 1,
      sym_quasiquote_start,
    ACTIONS(13778), 1,
      anon_sym_LPAREN,
    ACTIONS(13780), 1,
      sym__conid,
    STATE(366), 1,
      sym__unboxed_open,
    STATE(11599), 1,
      sym__pat_constructor,
    STATE(11620), 1,
      sym_constructor,
    STATE(12024), 1,
      sym_variable,
    STATE(12025), 1,
      sym__qcon,
    STATE(12143), 1,
      sym_qualified_constructor,
    STATE(12264), 1,
      sym_literal,
    STATE(14725), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10567), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10561), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12470), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12283), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [89049] = 26,
    ACTIONS(661), 1,
      anon_sym__,
    ACTIONS(673), 1,
      sym__strict,
    ACTIONS(675), 1,
      sym__lazy,
    ACTIONS(10559), 1,
      sym__varid,
    ACTIONS(10563), 1,
      sym__integer_literal,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    ACTIONS(10577), 1,
      anon_sym_7,
    ACTIONS(10579), 1,
      sym__splice_dollar,
    ACTIONS(10581), 1,
      sym_quasiquote_start,
    ACTIONS(13778), 1,
      anon_sym_LPAREN,
    ACTIONS(13780), 1,
      sym__conid,
    STATE(366), 1,
      sym__unboxed_open,
    STATE(11599), 1,
      sym__pat_constructor,
    STATE(11620), 1,
      sym_constructor,
    STATE(12024), 1,
      sym_variable,
    STATE(12025), 1,
      sym__qcon,
    STATE(12143), 1,
      sym_qualified_constructor,
    STATE(12264), 1,
      sym_literal,
    STATE(14725), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10567), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10561), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12470), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12289), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [89153] = 21,
    ACTIONS(2607), 1,
      sym__integer_literal,
    ACTIONS(2638), 1,
      anon_sym_7,
    ACTIONS(2640), 1,
      sym__splice_dollar,
    ACTIONS(2642), 1,
      sym_quasiquote_start,
    ACTIONS(4081), 1,
      sym__conid,
    ACTIONS(13943), 1,
      sym__varid,
    ACTIONS(13949), 1,
      anon_sym_LPAREN,
    ACTIONS(13951), 1,
      anon_sym_LBRACK,
    ACTIONS(13953), 1,
      anon_sym_SQUOTE,
    STATE(2160), 1,
      sym__unboxed_open,
    STATE(4530), 1,
      sym_constructor,
    STATE(15046), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13947), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13955), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2609), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13945), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5335), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5546), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [89247] = 21,
    ACTIONS(9), 1,
      sym__integer_literal,
    ACTIONS(69), 1,
      anon_sym_7,
    ACTIONS(71), 1,
      sym__splice_dollar,
    ACTIONS(73), 1,
      sym_quasiquote_start,
    ACTIONS(4243), 1,
      sym__conid,
    ACTIONS(13957), 1,
      sym__varid,
    ACTIONS(13963), 1,
      anon_sym_LPAREN,
    ACTIONS(13965), 1,
      anon_sym_LBRACK,
    ACTIONS(13967), 1,
      anon_sym_SQUOTE,
    STATE(2136), 1,
      sym__unboxed_open,
    STATE(4540), 1,
      sym_constructor,
    STATE(14996), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13961), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13969), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(11), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13959), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5301), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5303), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5596), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [89341] = 21,
    ACTIONS(2607), 1,
      sym__integer_literal,
    ACTIONS(2638), 1,
      anon_sym_7,
    ACTIONS(2640), 1,
      sym__splice_dollar,
    ACTIONS(2642), 1,
      sym_quasiquote_start,
    ACTIONS(4081), 1,
      sym__conid,
    ACTIONS(13943), 1,
      sym__varid,
    ACTIONS(13949), 1,
      anon_sym_LPAREN,
    ACTIONS(13951), 1,
      anon_sym_LBRACK,
    ACTIONS(13953), 1,
      anon_sym_SQUOTE,
    STATE(2160), 1,
      sym__unboxed_open,
    STATE(4530), 1,
      sym_constructor,
    STATE(15046), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13947), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13955), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2609), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13945), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5335), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5163), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [89435] = 21,
    ACTIONS(4431), 1,
      sym__integer_literal,
    ACTIONS(4439), 1,
      sym__conid,
    ACTIONS(4443), 1,
      anon_sym_7,
    ACTIONS(4445), 1,
      sym__splice_dollar,
    ACTIONS(4447), 1,
      sym_quasiquote_start,
    ACTIONS(13971), 1,
      sym__varid,
    ACTIONS(13977), 1,
      anon_sym_LPAREN,
    ACTIONS(13979), 1,
      anon_sym_LBRACK,
    ACTIONS(13981), 1,
      anon_sym_SQUOTE,
    STATE(2216), 1,
      sym__unboxed_open,
    STATE(11700), 1,
      sym_constructor,
    STATE(14765), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13975), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13983), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4433), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13973), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12185), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12194), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(12397), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [89529] = 21,
    ACTIONS(4431), 1,
      sym__integer_literal,
    ACTIONS(4439), 1,
      sym__conid,
    ACTIONS(4443), 1,
      anon_sym_7,
    ACTIONS(4445), 1,
      sym__splice_dollar,
    ACTIONS(4447), 1,
      sym_quasiquote_start,
    ACTIONS(13971), 1,
      sym__varid,
    ACTIONS(13977), 1,
      anon_sym_LPAREN,
    ACTIONS(13979), 1,
      anon_sym_LBRACK,
    ACTIONS(13981), 1,
      anon_sym_SQUOTE,
    STATE(2216), 1,
      sym__unboxed_open,
    STATE(11700), 1,
      sym_constructor,
    STATE(14765), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13975), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13983), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4433), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13973), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12185), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12194), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(12099), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [89623] = 21,
    ACTIONS(9), 1,
      sym__integer_literal,
    ACTIONS(69), 1,
      anon_sym_7,
    ACTIONS(71), 1,
      sym__splice_dollar,
    ACTIONS(73), 1,
      sym_quasiquote_start,
    ACTIONS(4243), 1,
      sym__conid,
    ACTIONS(13957), 1,
      sym__varid,
    ACTIONS(13963), 1,
      anon_sym_LPAREN,
    ACTIONS(13965), 1,
      anon_sym_LBRACK,
    ACTIONS(13967), 1,
      anon_sym_SQUOTE,
    STATE(2136), 1,
      sym__unboxed_open,
    STATE(4540), 1,
      sym_constructor,
    STATE(14996), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13961), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13969), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(11), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13959), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5301), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5303), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4996), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [89717] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [89775] = 26,
    ACTIONS(12345), 1,
      sym__varid,
    ACTIONS(12349), 1,
      sym__integer_literal,
    ACTIONS(12361), 1,
      anon_sym_LBRACK,
    ACTIONS(12363), 1,
      anon_sym__,
    ACTIONS(12365), 1,
      anon_sym_7,
    ACTIONS(12367), 1,
      sym__splice_dollar,
    ACTIONS(12369), 1,
      sym_quasiquote_start,
    ACTIONS(12371), 1,
      sym__strict,
    ACTIONS(12373), 1,
      sym__lazy,
    ACTIONS(13985), 1,
      anon_sym_LPAREN,
    ACTIONS(13987), 1,
      sym__conid,
    STATE(335), 1,
      sym__unboxed_open,
    STATE(12576), 1,
      sym_constructor,
    STATE(12723), 1,
      sym__pat_constructor,
    STATE(12906), 1,
      sym_variable,
    STATE(13025), 1,
      sym_qualified_constructor,
    STATE(13080), 1,
      sym__qcon,
    STATE(13230), 1,
      sym_literal,
    STATE(15422), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12353), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12347), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12351), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13356), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13298), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [89879] = 21,
    ACTIONS(13989), 1,
      sym__varid,
    ACTIONS(13993), 1,
      sym__integer_literal,
    ACTIONS(13999), 1,
      anon_sym_LPAREN,
    ACTIONS(14001), 1,
      sym__conid,
    ACTIONS(14003), 1,
      anon_sym_LBRACK,
    ACTIONS(14005), 1,
      anon_sym_SQUOTE,
    ACTIONS(14009), 1,
      anon_sym_7,
    ACTIONS(14011), 1,
      sym__splice_dollar,
    ACTIONS(14013), 1,
      sym_quasiquote_start,
    STATE(2151), 1,
      sym__unboxed_open,
    STATE(14932), 1,
      aux_sym__qualifying_module,
    STATE(15442), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13997), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14007), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13991), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13995), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(17844), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(17846), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(17892), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [89973] = 21,
    ACTIONS(13989), 1,
      sym__varid,
    ACTIONS(13993), 1,
      sym__integer_literal,
    ACTIONS(13999), 1,
      anon_sym_LPAREN,
    ACTIONS(14001), 1,
      sym__conid,
    ACTIONS(14003), 1,
      anon_sym_LBRACK,
    ACTIONS(14005), 1,
      anon_sym_SQUOTE,
    ACTIONS(14009), 1,
      anon_sym_7,
    ACTIONS(14011), 1,
      sym__splice_dollar,
    ACTIONS(14013), 1,
      sym_quasiquote_start,
    STATE(2151), 1,
      sym__unboxed_open,
    STATE(14932), 1,
      aux_sym__qualifying_module,
    STATE(15442), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13997), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14007), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13991), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13995), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(17844), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(17846), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(17896), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [90067] = 26,
    ACTIONS(12695), 1,
      sym__varid,
    ACTIONS(12699), 1,
      sym__integer_literal,
    ACTIONS(12711), 1,
      anon_sym_LBRACK,
    ACTIONS(12713), 1,
      anon_sym__,
    ACTIONS(12715), 1,
      anon_sym_7,
    ACTIONS(12717), 1,
      sym__splice_dollar,
    ACTIONS(12719), 1,
      sym_quasiquote_start,
    ACTIONS(12721), 1,
      sym__strict,
    ACTIONS(12723), 1,
      sym__lazy,
    ACTIONS(14015), 1,
      anon_sym_LPAREN,
    ACTIONS(14017), 1,
      sym__conid,
    STATE(242), 1,
      sym__unboxed_open,
    STATE(12531), 1,
      sym_constructor,
    STATE(12675), 1,
      sym__pat_constructor,
    STATE(12735), 1,
      sym_variable,
    STATE(12808), 1,
      sym_qualified_constructor,
    STATE(12873), 1,
      sym__qcon,
    STATE(13384), 1,
      sym_literal,
    STATE(14834), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12703), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12697), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12701), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13274), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13270), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [90171] = 21,
    ACTIONS(8960), 1,
      sym__integer_literal,
    ACTIONS(8970), 1,
      sym__conid,
    ACTIONS(8984), 1,
      anon_sym_7,
    ACTIONS(8986), 1,
      sym__splice_dollar,
    ACTIONS(8988), 1,
      sym_quasiquote_start,
    ACTIONS(14019), 1,
      sym__varid,
    ACTIONS(14025), 1,
      anon_sym_LPAREN,
    ACTIONS(14027), 1,
      anon_sym_LBRACK,
    ACTIONS(14029), 1,
      anon_sym_SQUOTE,
    STATE(2155), 1,
      sym__unboxed_open,
    STATE(11490), 1,
      sym_constructor,
    STATE(15154), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14023), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14031), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8962), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14021), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11547), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11569), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(12144), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [90265] = 21,
    ACTIONS(8960), 1,
      sym__integer_literal,
    ACTIONS(8970), 1,
      sym__conid,
    ACTIONS(8984), 1,
      anon_sym_7,
    ACTIONS(8986), 1,
      sym__splice_dollar,
    ACTIONS(8988), 1,
      sym_quasiquote_start,
    ACTIONS(14019), 1,
      sym__varid,
    ACTIONS(14025), 1,
      anon_sym_LPAREN,
    ACTIONS(14027), 1,
      anon_sym_LBRACK,
    ACTIONS(14029), 1,
      anon_sym_SQUOTE,
    STATE(2155), 1,
      sym__unboxed_open,
    STATE(11490), 1,
      sym_constructor,
    STATE(15154), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14023), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14031), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8962), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14021), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11547), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11569), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11651), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [90359] = 26,
    ACTIONS(1378), 1,
      anon_sym__,
    ACTIONS(1386), 1,
      sym__strict,
    ACTIONS(1388), 1,
      sym__lazy,
    ACTIONS(12771), 1,
      sym__varid,
    ACTIONS(12775), 1,
      sym__integer_literal,
    ACTIONS(12787), 1,
      anon_sym_LBRACK,
    ACTIONS(12789), 1,
      anon_sym_7,
    ACTIONS(12791), 1,
      sym__splice_dollar,
    ACTIONS(12793), 1,
      sym_quasiquote_start,
    ACTIONS(14033), 1,
      anon_sym_LPAREN,
    ACTIONS(14035), 1,
      sym__conid,
    STATE(263), 1,
      sym__unboxed_open,
    STATE(12540), 1,
      sym_constructor,
    STATE(12544), 1,
      sym__pat_constructor,
    STATE(12828), 1,
      sym_qualified_constructor,
    STATE(12874), 1,
      sym_variable,
    STATE(13029), 1,
      sym__qcon,
    STATE(13152), 1,
      sym_literal,
    STATE(14631), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13099), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13339), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [90463] = 15,
    ACTIONS(13711), 1,
      sym_comma,
    ACTIONS(13808), 1,
      sym__conid,
    ACTIONS(13815), 1,
      anon_sym__,
    STATE(2381), 1,
      sym__colon2,
    STATE(13964), 1,
      aux_sym_signature_repeat1,
    STATE(15914), 1,
      sym__type_annotation,
    ACTIONS(13812), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13817), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(14037), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13796), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13774), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(13799), 12,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [90545] = 26,
    ACTIONS(10970), 1,
      sym__integer_literal,
    ACTIONS(10978), 1,
      sym__conid,
    ACTIONS(10986), 1,
      anon_sym_7,
    ACTIONS(10988), 1,
      sym__splice_dollar,
    ACTIONS(10990), 1,
      sym_quasiquote_start,
    ACTIONS(13460), 1,
      sym__varid,
    ACTIONS(13466), 1,
      anon_sym_LPAREN,
    ACTIONS(13468), 1,
      anon_sym_LBRACK,
    ACTIONS(13472), 1,
      anon_sym__,
    ACTIONS(13474), 1,
      sym__strict,
    ACTIONS(13476), 1,
      sym__lazy,
    STATE(284), 1,
      sym__unboxed_open,
    STATE(7865), 1,
      sym_constructor,
    STATE(7921), 1,
      sym_qualified_constructor,
    STATE(9088), 1,
      sym__pat_constructor,
    STATE(9223), 1,
      sym_variable,
    STATE(9225), 1,
      sym__qcon,
    STATE(9369), 1,
      sym_literal,
    STATE(15266), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13464), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13462), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9318), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9278), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [90649] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [90707] = 26,
    ACTIONS(11128), 1,
      sym__varid,
    ACTIONS(11132), 1,
      sym__integer_literal,
    ACTIONS(11138), 1,
      anon_sym_LPAREN,
    ACTIONS(11143), 1,
      anon_sym_LBRACK,
    ACTIONS(11147), 1,
      anon_sym__,
    ACTIONS(11149), 1,
      anon_sym_7,
    ACTIONS(11151), 1,
      sym__splice_dollar,
    ACTIONS(11153), 1,
      sym_quasiquote_start,
    ACTIONS(11155), 1,
      sym__strict,
    ACTIONS(11157), 1,
      sym__lazy,
    ACTIONS(12709), 1,
      sym__conid,
    STATE(423), 1,
      sym__unboxed_open,
    STATE(7943), 1,
      sym__pat_constructor,
    STATE(8116), 1,
      sym_constructor,
    STATE(8182), 1,
      sym__qcon,
    STATE(8187), 1,
      sym_variable,
    STATE(8271), 1,
      sym_qualified_constructor,
    STATE(8588), 1,
      sym_literal,
    STATE(14857), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11136), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11130), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11134), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8600), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8512), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [90811] = 21,
    ACTIONS(2084), 1,
      sym__integer_literal,
    ACTIONS(2116), 1,
      anon_sym_7,
    ACTIONS(2118), 1,
      sym__splice_dollar,
    ACTIONS(2120), 1,
      sym_quasiquote_start,
    ACTIONS(4055), 1,
      sym__conid,
    ACTIONS(14044), 1,
      sym__varid,
    ACTIONS(14050), 1,
      anon_sym_LPAREN,
    ACTIONS(14052), 1,
      anon_sym_LBRACK,
    ACTIONS(14054), 1,
      anon_sym_SQUOTE,
    STATE(2142), 1,
      sym__unboxed_open,
    STATE(4256), 1,
      sym_constructor,
    STATE(15230), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14048), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14056), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2086), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14046), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4374), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4459), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5419), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [90905] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [90963] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [91021] = 26,
    ACTIONS(1378), 1,
      anon_sym__,
    ACTIONS(1386), 1,
      sym__strict,
    ACTIONS(1388), 1,
      sym__lazy,
    ACTIONS(12771), 1,
      sym__varid,
    ACTIONS(12775), 1,
      sym__integer_literal,
    ACTIONS(12787), 1,
      anon_sym_LBRACK,
    ACTIONS(12789), 1,
      anon_sym_7,
    ACTIONS(12791), 1,
      sym__splice_dollar,
    ACTIONS(12793), 1,
      sym_quasiquote_start,
    ACTIONS(14033), 1,
      anon_sym_LPAREN,
    ACTIONS(14035), 1,
      sym__conid,
    STATE(263), 1,
      sym__unboxed_open,
    STATE(12540), 1,
      sym_constructor,
    STATE(12544), 1,
      sym__pat_constructor,
    STATE(12828), 1,
      sym_qualified_constructor,
    STATE(12874), 1,
      sym_variable,
    STATE(13029), 1,
      sym__qcon,
    STATE(13152), 1,
      sym_literal,
    STATE(14631), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13099), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13345), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [91125] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [91183] = 26,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(13770), 1,
      anon_sym_LPAREN,
    ACTIONS(13772), 1,
      sym__conid,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(12587), 1,
      sym_constructor,
    STATE(12720), 1,
      sym__pat_constructor,
    STATE(12782), 1,
      sym__qcon,
    STATE(13035), 1,
      sym_variable,
    STATE(13075), 1,
      sym_qualified_constructor,
    STATE(13142), 1,
      sym_literal,
    STATE(15349), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13180), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [91287] = 26,
    ACTIONS(10970), 1,
      sym__integer_literal,
    ACTIONS(10978), 1,
      sym__conid,
    ACTIONS(10986), 1,
      anon_sym_7,
    ACTIONS(10988), 1,
      sym__splice_dollar,
    ACTIONS(10990), 1,
      sym_quasiquote_start,
    ACTIONS(13460), 1,
      sym__varid,
    ACTIONS(13466), 1,
      anon_sym_LPAREN,
    ACTIONS(13468), 1,
      anon_sym_LBRACK,
    ACTIONS(13472), 1,
      anon_sym__,
    ACTIONS(13474), 1,
      sym__strict,
    ACTIONS(13476), 1,
      sym__lazy,
    STATE(284), 1,
      sym__unboxed_open,
    STATE(7865), 1,
      sym_constructor,
    STATE(7921), 1,
      sym_qualified_constructor,
    STATE(9088), 1,
      sym__pat_constructor,
    STATE(9223), 1,
      sym_variable,
    STATE(9225), 1,
      sym__qcon,
    STATE(9369), 1,
      sym_literal,
    STATE(15266), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13464), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13462), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9318), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9327), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [91391] = 26,
    ACTIONS(10970), 1,
      sym__integer_literal,
    ACTIONS(10978), 1,
      sym__conid,
    ACTIONS(10986), 1,
      anon_sym_7,
    ACTIONS(10988), 1,
      sym__splice_dollar,
    ACTIONS(10990), 1,
      sym_quasiquote_start,
    ACTIONS(13460), 1,
      sym__varid,
    ACTIONS(13466), 1,
      anon_sym_LPAREN,
    ACTIONS(13468), 1,
      anon_sym_LBRACK,
    ACTIONS(13472), 1,
      anon_sym__,
    ACTIONS(13474), 1,
      sym__strict,
    ACTIONS(13476), 1,
      sym__lazy,
    STATE(284), 1,
      sym__unboxed_open,
    STATE(7865), 1,
      sym_constructor,
    STATE(7921), 1,
      sym_qualified_constructor,
    STATE(9088), 1,
      sym__pat_constructor,
    STATE(9223), 1,
      sym_variable,
    STATE(9225), 1,
      sym__qcon,
    STATE(9369), 1,
      sym_literal,
    STATE(15266), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13464), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13462), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9318), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9325), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [91495] = 21,
    ACTIONS(14066), 1,
      sym__varid,
    ACTIONS(14070), 1,
      sym__integer_literal,
    ACTIONS(14076), 1,
      anon_sym_LPAREN,
    ACTIONS(14078), 1,
      sym__conid,
    ACTIONS(14080), 1,
      anon_sym_LBRACK,
    ACTIONS(14082), 1,
      anon_sym_SQUOTE,
    ACTIONS(14086), 1,
      anon_sym_7,
    ACTIONS(14088), 1,
      sym__splice_dollar,
    ACTIONS(14090), 1,
      sym_quasiquote_start,
    STATE(2103), 1,
      sym__unboxed_open,
    STATE(14342), 1,
      sym_constructor,
    STATE(15289), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14074), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14084), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(14068), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14072), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14989), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(14991), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14881), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [91589] = 16,
    ACTIONS(13698), 1,
      sym__conid,
    ACTIONS(13707), 1,
      anon_sym__,
    ACTIONS(13709), 1,
      anon_sym_AT2,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2360), 1,
      sym__colon2,
    STATE(13849), 1,
      aux_sym_signature_repeat1,
    STATE(18067), 1,
      sym__type_annotation,
    ACTIONS(13704), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13713), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(14092), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13686), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13684), 7,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
    ACTIONS(13702), 8,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13689), 12,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [91673] = 21,
    ACTIONS(14066), 1,
      sym__varid,
    ACTIONS(14070), 1,
      sym__integer_literal,
    ACTIONS(14076), 1,
      anon_sym_LPAREN,
    ACTIONS(14078), 1,
      sym__conid,
    ACTIONS(14080), 1,
      anon_sym_LBRACK,
    ACTIONS(14082), 1,
      anon_sym_SQUOTE,
    ACTIONS(14086), 1,
      anon_sym_7,
    ACTIONS(14088), 1,
      sym__splice_dollar,
    ACTIONS(14090), 1,
      sym_quasiquote_start,
    STATE(2103), 1,
      sym__unboxed_open,
    STATE(14342), 1,
      sym_constructor,
    STATE(15289), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14074), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14084), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(14068), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14072), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14989), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(14991), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14882), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [91767] = 26,
    ACTIONS(655), 1,
      sym__conid,
    ACTIONS(12303), 1,
      sym__varid,
    ACTIONS(12307), 1,
      sym__integer_literal,
    ACTIONS(12313), 1,
      anon_sym_LPAREN,
    ACTIONS(12318), 1,
      anon_sym_LBRACK,
    ACTIONS(12322), 1,
      anon_sym__,
    ACTIONS(12324), 1,
      anon_sym_7,
    ACTIONS(12326), 1,
      sym__splice_dollar,
    ACTIONS(12328), 1,
      sym_quasiquote_start,
    ACTIONS(12330), 1,
      sym__strict,
    ACTIONS(12332), 1,
      sym__lazy,
    STATE(475), 1,
      sym__unboxed_open,
    STATE(3977), 1,
      sym_constructor,
    STATE(4051), 1,
      sym_qualified_constructor,
    STATE(8553), 1,
      sym__pat_constructor,
    STATE(8915), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_variable,
    STATE(9006), 1,
      sym_literal,
    STATE(15169), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12311), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12305), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12309), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9106), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9017), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [91871] = 26,
    ACTIONS(655), 1,
      sym__conid,
    ACTIONS(12303), 1,
      sym__varid,
    ACTIONS(12307), 1,
      sym__integer_literal,
    ACTIONS(12313), 1,
      anon_sym_LPAREN,
    ACTIONS(12318), 1,
      anon_sym_LBRACK,
    ACTIONS(12322), 1,
      anon_sym__,
    ACTIONS(12324), 1,
      anon_sym_7,
    ACTIONS(12326), 1,
      sym__splice_dollar,
    ACTIONS(12328), 1,
      sym_quasiquote_start,
    ACTIONS(12330), 1,
      sym__strict,
    ACTIONS(12332), 1,
      sym__lazy,
    STATE(475), 1,
      sym__unboxed_open,
    STATE(3977), 1,
      sym_constructor,
    STATE(4051), 1,
      sym_qualified_constructor,
    STATE(8553), 1,
      sym__pat_constructor,
    STATE(8915), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_variable,
    STATE(9006), 1,
      sym_literal,
    STATE(15169), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12311), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12305), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12309), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9106), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9044), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [91975] = 21,
    ACTIONS(4099), 1,
      sym__integer_literal,
    ACTIONS(4111), 1,
      sym__conid,
    ACTIONS(4125), 1,
      anon_sym_7,
    ACTIONS(4127), 1,
      sym__splice_dollar,
    ACTIONS(4129), 1,
      sym_quasiquote_start,
    ACTIONS(14095), 1,
      sym__varid,
    ACTIONS(14101), 1,
      anon_sym_LPAREN,
    ACTIONS(14103), 1,
      anon_sym_LBRACK,
    ACTIONS(14105), 1,
      anon_sym_SQUOTE,
    STATE(2138), 1,
      sym__unboxed_open,
    STATE(9703), 1,
      sym_constructor,
    STATE(15156), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14099), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14107), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4101), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14097), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9827), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9871), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9943), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [92069] = 21,
    ACTIONS(4099), 1,
      sym__integer_literal,
    ACTIONS(4111), 1,
      sym__conid,
    ACTIONS(4125), 1,
      anon_sym_7,
    ACTIONS(4127), 1,
      sym__splice_dollar,
    ACTIONS(4129), 1,
      sym_quasiquote_start,
    ACTIONS(14095), 1,
      sym__varid,
    ACTIONS(14101), 1,
      anon_sym_LPAREN,
    ACTIONS(14103), 1,
      anon_sym_LBRACK,
    ACTIONS(14105), 1,
      anon_sym_SQUOTE,
    STATE(2138), 1,
      sym__unboxed_open,
    STATE(9703), 1,
      sym_constructor,
    STATE(15156), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14099), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14107), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4101), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14097), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9827), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9871), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10008), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [92163] = 26,
    ACTIONS(11558), 1,
      sym__varid,
    ACTIONS(11562), 1,
      sym__integer_literal,
    ACTIONS(11568), 1,
      anon_sym_LPAREN,
    ACTIONS(11573), 1,
      anon_sym_LBRACK,
    ACTIONS(11577), 1,
      anon_sym__,
    ACTIONS(11579), 1,
      anon_sym_7,
    ACTIONS(11581), 1,
      sym__splice_dollar,
    ACTIONS(11583), 1,
      sym_quasiquote_start,
    ACTIONS(11585), 1,
      sym__strict,
    ACTIONS(11587), 1,
      sym__lazy,
    ACTIONS(12537), 1,
      sym__conid,
    STATE(476), 1,
      sym__unboxed_open,
    STATE(8298), 1,
      sym_constructor,
    STATE(8301), 1,
      sym__pat_constructor,
    STATE(8535), 1,
      sym__qcon,
    STATE(8545), 1,
      sym_qualified_constructor,
    STATE(8609), 1,
      sym_variable,
    STATE(8853), 1,
      sym_literal,
    STATE(15198), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11566), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11560), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11564), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8846), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8769), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [92267] = 21,
    ACTIONS(13614), 1,
      sym__varid,
    ACTIONS(13618), 1,
      sym__integer_literal,
    ACTIONS(13624), 1,
      anon_sym_LPAREN,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(13628), 1,
      anon_sym_LBRACK,
    ACTIONS(13630), 1,
      anon_sym_SQUOTE,
    ACTIONS(13636), 1,
      anon_sym_7,
    ACTIONS(13638), 1,
      sym__splice_dollar,
    ACTIONS(13640), 1,
      sym_quasiquote_start,
    STATE(2163), 1,
      sym__unboxed_open,
    STATE(13520), 1,
      sym_constructor,
    STATE(14747), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13622), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13632), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13616), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13620), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14250), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(14252), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15222), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [92361] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [92419] = 21,
    ACTIONS(1937), 1,
      sym__integer_literal,
    ACTIONS(1969), 1,
      anon_sym_7,
    ACTIONS(1971), 1,
      sym__splice_dollar,
    ACTIONS(1973), 1,
      sym_quasiquote_start,
    ACTIONS(4161), 1,
      sym__conid,
    ACTIONS(14113), 1,
      sym__varid,
    ACTIONS(14119), 1,
      anon_sym_LPAREN,
    ACTIONS(14121), 1,
      anon_sym_LBRACK,
    ACTIONS(14123), 1,
      anon_sym_SQUOTE,
    STATE(2188), 1,
      sym__unboxed_open,
    STATE(4151), 1,
      sym_constructor,
    STATE(15315), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14117), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14125), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(1939), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14115), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4235), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4246), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4237), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [92513] = 21,
    ACTIONS(1937), 1,
      sym__integer_literal,
    ACTIONS(1969), 1,
      anon_sym_7,
    ACTIONS(1971), 1,
      sym__splice_dollar,
    ACTIONS(1973), 1,
      sym_quasiquote_start,
    ACTIONS(4161), 1,
      sym__conid,
    ACTIONS(14113), 1,
      sym__varid,
    ACTIONS(14119), 1,
      anon_sym_LPAREN,
    ACTIONS(14121), 1,
      anon_sym_LBRACK,
    ACTIONS(14123), 1,
      anon_sym_SQUOTE,
    STATE(2188), 1,
      sym__unboxed_open,
    STATE(4151), 1,
      sym_constructor,
    STATE(15315), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14117), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14125), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(1939), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14115), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4235), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4246), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4427), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [92607] = 26,
    ACTIONS(4309), 1,
      sym__varid,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(4321), 1,
      sym__conid,
    ACTIONS(4325), 1,
      anon_sym_7,
    ACTIONS(4327), 1,
      sym__splice_dollar,
    ACTIONS(4329), 1,
      sym_quasiquote_start,
    ACTIONS(4915), 1,
      anon_sym_LBRACK,
    ACTIONS(4921), 1,
      anon_sym__,
    ACTIONS(4927), 1,
      sym__strict,
    ACTIONS(4929), 1,
      sym__lazy,
    ACTIONS(14127), 1,
      anon_sym_LPAREN,
    STATE(236), 1,
      sym__unboxed_open,
    STATE(9240), 1,
      sym_constructor,
    STATE(9275), 1,
      sym_qualified_constructor,
    STATE(13271), 1,
      sym__pat_constructor,
    STATE(13750), 1,
      sym__qcon,
    STATE(13773), 1,
      sym_variable,
    STATE(14211), 1,
      sym_literal,
    STATE(14842), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4907), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4311), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14321), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [92711] = 21,
    ACTIONS(9090), 1,
      sym__integer_literal,
    ACTIONS(9100), 1,
      sym__conid,
    ACTIONS(9114), 1,
      anon_sym_7,
    ACTIONS(9116), 1,
      sym__splice_dollar,
    ACTIONS(9118), 1,
      sym_quasiquote_start,
    ACTIONS(14129), 1,
      sym__varid,
    ACTIONS(14135), 1,
      anon_sym_LPAREN,
    ACTIONS(14137), 1,
      anon_sym_LBRACK,
    ACTIONS(14139), 1,
      anon_sym_SQUOTE,
    STATE(2177), 1,
      sym__unboxed_open,
    STATE(10665), 1,
      sym_constructor,
    STATE(15116), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14133), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14141), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9092), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11033), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11041), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11036), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [92805] = 26,
    ACTIONS(33), 1,
      anon_sym__,
    ACTIONS(75), 1,
      sym__strict,
    ACTIONS(77), 1,
      sym__lazy,
    ACTIONS(4529), 1,
      sym__varid,
    ACTIONS(4533), 1,
      sym__integer_literal,
    ACTIONS(4541), 1,
      sym__conid,
    ACTIONS(4545), 1,
      anon_sym_7,
    ACTIONS(4547), 1,
      sym__splice_dollar,
    ACTIONS(4549), 1,
      sym_quasiquote_start,
    ACTIONS(4965), 1,
      anon_sym_LBRACK,
    ACTIONS(13869), 1,
      anon_sym_LPAREN,
    STATE(456), 1,
      sym__unboxed_open,
    STATE(9235), 1,
      sym_constructor,
    STATE(9289), 1,
      sym_qualified_constructor,
    STATE(12015), 1,
      sym__pat_constructor,
    STATE(12454), 1,
      sym_variable,
    STATE(12460), 1,
      sym__qcon,
    STATE(12624), 1,
      sym_literal,
    STATE(14621), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4959), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4531), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4535), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9283), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12623), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [92909] = 26,
    ACTIONS(4309), 1,
      sym__varid,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(4321), 1,
      sym__conid,
    ACTIONS(4325), 1,
      anon_sym_7,
    ACTIONS(4327), 1,
      sym__splice_dollar,
    ACTIONS(4329), 1,
      sym_quasiquote_start,
    ACTIONS(4915), 1,
      anon_sym_LBRACK,
    ACTIONS(4921), 1,
      anon_sym__,
    ACTIONS(4927), 1,
      sym__strict,
    ACTIONS(4929), 1,
      sym__lazy,
    ACTIONS(14127), 1,
      anon_sym_LPAREN,
    STATE(236), 1,
      sym__unboxed_open,
    STATE(9240), 1,
      sym_constructor,
    STATE(9275), 1,
      sym_qualified_constructor,
    STATE(13271), 1,
      sym__pat_constructor,
    STATE(13750), 1,
      sym__qcon,
    STATE(13773), 1,
      sym_variable,
    STATE(14211), 1,
      sym_literal,
    STATE(14842), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4907), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4311), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14322), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [93013] = 21,
    ACTIONS(4363), 1,
      sym__integer_literal,
    ACTIONS(4373), 1,
      sym__conid,
    ACTIONS(4387), 1,
      anon_sym_7,
    ACTIONS(4389), 1,
      sym__splice_dollar,
    ACTIONS(4391), 1,
      sym_quasiquote_start,
    ACTIONS(14143), 1,
      sym__varid,
    ACTIONS(14149), 1,
      anon_sym_LPAREN,
    ACTIONS(14151), 1,
      anon_sym_LBRACK,
    ACTIONS(14153), 1,
      anon_sym_SQUOTE,
    STATE(2199), 1,
      sym__unboxed_open,
    STATE(11342), 1,
      sym_constructor,
    STATE(14664), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14147), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14155), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4365), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14145), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11879), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11882), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11621), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93107] = 21,
    ACTIONS(4363), 1,
      sym__integer_literal,
    ACTIONS(4373), 1,
      sym__conid,
    ACTIONS(4387), 1,
      anon_sym_7,
    ACTIONS(4389), 1,
      sym__splice_dollar,
    ACTIONS(4391), 1,
      sym_quasiquote_start,
    ACTIONS(14143), 1,
      sym__varid,
    ACTIONS(14149), 1,
      anon_sym_LPAREN,
    ACTIONS(14151), 1,
      anon_sym_LBRACK,
    ACTIONS(14153), 1,
      anon_sym_SQUOTE,
    STATE(2199), 1,
      sym__unboxed_open,
    STATE(11342), 1,
      sym_constructor,
    STATE(14664), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14147), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14155), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4365), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14145), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11879), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11882), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(12102), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93201] = 21,
    ACTIONS(4511), 1,
      sym__integer_literal,
    ACTIONS(4519), 1,
      sym__conid,
    ACTIONS(4523), 1,
      anon_sym_7,
    ACTIONS(4525), 1,
      sym__splice_dollar,
    ACTIONS(4527), 1,
      sym_quasiquote_start,
    ACTIONS(13742), 1,
      sym__varid,
    ACTIONS(13748), 1,
      anon_sym_LPAREN,
    ACTIONS(13750), 1,
      anon_sym_LBRACK,
    ACTIONS(13752), 1,
      anon_sym_SQUOTE,
    STATE(2190), 1,
      sym__unboxed_open,
    STATE(10396), 1,
      sym_constructor,
    STATE(14968), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13746), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13754), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4513), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13744), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11415), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11433), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11305), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93295] = 21,
    ACTIONS(8757), 1,
      sym__integer_literal,
    ACTIONS(8765), 1,
      sym__conid,
    ACTIONS(8769), 1,
      anon_sym_7,
    ACTIONS(8771), 1,
      sym__splice_dollar,
    ACTIONS(8773), 1,
      sym_quasiquote_start,
    ACTIONS(14157), 1,
      sym__varid,
    ACTIONS(14163), 1,
      anon_sym_LPAREN,
    ACTIONS(14165), 1,
      anon_sym_LBRACK,
    ACTIONS(14167), 1,
      anon_sym_SQUOTE,
    STATE(2100), 1,
      sym__unboxed_open,
    STATE(11113), 1,
      sym_constructor,
    STATE(15267), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14161), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14169), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8759), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14159), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11561), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11845), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11955), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93389] = 21,
    ACTIONS(2354), 1,
      sym__integer_literal,
    ACTIONS(2386), 1,
      anon_sym_7,
    ACTIONS(2388), 1,
      sym__splice_dollar,
    ACTIONS(2390), 1,
      sym_quasiquote_start,
    ACTIONS(4177), 1,
      sym__conid,
    ACTIONS(14171), 1,
      sym__varid,
    ACTIONS(14177), 1,
      anon_sym_LPAREN,
    ACTIONS(14179), 1,
      anon_sym_LBRACK,
    ACTIONS(14181), 1,
      anon_sym_SQUOTE,
    STATE(2111), 1,
      sym__unboxed_open,
    STATE(4219), 1,
      sym_constructor,
    STATE(14803), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14175), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14183), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2356), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14173), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4700), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4776), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4669), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93483] = 21,
    ACTIONS(9090), 1,
      sym__integer_literal,
    ACTIONS(9100), 1,
      sym__conid,
    ACTIONS(9114), 1,
      anon_sym_7,
    ACTIONS(9116), 1,
      sym__splice_dollar,
    ACTIONS(9118), 1,
      sym_quasiquote_start,
    ACTIONS(14129), 1,
      sym__varid,
    ACTIONS(14135), 1,
      anon_sym_LPAREN,
    ACTIONS(14137), 1,
      anon_sym_LBRACK,
    ACTIONS(14139), 1,
      anon_sym_SQUOTE,
    STATE(2177), 1,
      sym__unboxed_open,
    STATE(10665), 1,
      sym_constructor,
    STATE(15116), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14133), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14141), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9092), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11033), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11041), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11606), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93577] = 26,
    ACTIONS(11089), 1,
      sym__varid,
    ACTIONS(11093), 1,
      sym__integer_literal,
    ACTIONS(11099), 1,
      anon_sym_LPAREN,
    ACTIONS(11104), 1,
      anon_sym_LBRACK,
    ACTIONS(11108), 1,
      anon_sym__,
    ACTIONS(11110), 1,
      anon_sym_7,
    ACTIONS(11112), 1,
      sym__splice_dollar,
    ACTIONS(11114), 1,
      sym_quasiquote_start,
    ACTIONS(11116), 1,
      sym__strict,
    ACTIONS(11118), 1,
      sym__lazy,
    ACTIONS(12655), 1,
      sym__conid,
    STATE(481), 1,
      sym__unboxed_open,
    STATE(8017), 1,
      sym_constructor,
    STATE(8101), 1,
      sym__pat_constructor,
    STATE(8254), 1,
      sym_qualified_constructor,
    STATE(8324), 1,
      sym_variable,
    STATE(8386), 1,
      sym__qcon,
    STATE(8663), 1,
      sym_literal,
    STATE(15071), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11097), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11091), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11095), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8608), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8475), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [93681] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [93739] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [93797] = 21,
    ACTIONS(2309), 1,
      sym__integer_literal,
    ACTIONS(2340), 1,
      anon_sym_7,
    ACTIONS(2342), 1,
      sym__splice_dollar,
    ACTIONS(2344), 1,
      sym_quasiquote_start,
    ACTIONS(4267), 1,
      sym__conid,
    ACTIONS(14193), 1,
      sym__varid,
    ACTIONS(14199), 1,
      anon_sym_LPAREN,
    ACTIONS(14201), 1,
      anon_sym_LBRACK,
    ACTIONS(14203), 1,
      anon_sym_SQUOTE,
    STATE(2154), 1,
      sym__unboxed_open,
    STATE(4306), 1,
      sym_constructor,
    STATE(14943), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14197), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14205), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2311), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14195), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4590), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5111), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [93891] = 26,
    ACTIONS(655), 1,
      sym__conid,
    ACTIONS(12303), 1,
      sym__varid,
    ACTIONS(12307), 1,
      sym__integer_literal,
    ACTIONS(12313), 1,
      anon_sym_LPAREN,
    ACTIONS(12318), 1,
      anon_sym_LBRACK,
    ACTIONS(12322), 1,
      anon_sym__,
    ACTIONS(12324), 1,
      anon_sym_7,
    ACTIONS(12326), 1,
      sym__splice_dollar,
    ACTIONS(12328), 1,
      sym_quasiquote_start,
    ACTIONS(12330), 1,
      sym__strict,
    ACTIONS(12332), 1,
      sym__lazy,
    STATE(475), 1,
      sym__unboxed_open,
    STATE(3977), 1,
      sym_constructor,
    STATE(4051), 1,
      sym_qualified_constructor,
    STATE(8553), 1,
      sym__pat_constructor,
    STATE(8915), 1,
      sym__qcon,
    STATE(8979), 1,
      sym_variable,
    STATE(9006), 1,
      sym_literal,
    STATE(15169), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12311), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12305), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12309), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9106), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9098), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [93995] = 21,
    ACTIONS(2354), 1,
      sym__integer_literal,
    ACTIONS(2386), 1,
      anon_sym_7,
    ACTIONS(2388), 1,
      sym__splice_dollar,
    ACTIONS(2390), 1,
      sym_quasiquote_start,
    ACTIONS(4177), 1,
      sym__conid,
    ACTIONS(14171), 1,
      sym__varid,
    ACTIONS(14177), 1,
      anon_sym_LPAREN,
    ACTIONS(14179), 1,
      anon_sym_LBRACK,
    ACTIONS(14181), 1,
      anon_sym_SQUOTE,
    STATE(2111), 1,
      sym__unboxed_open,
    STATE(4219), 1,
      sym_constructor,
    STATE(14803), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14175), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14183), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2356), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14173), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4700), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4776), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5070), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94089] = 21,
    ACTIONS(9160), 1,
      sym__integer_literal,
    ACTIONS(9170), 1,
      sym__conid,
    ACTIONS(9184), 1,
      anon_sym_7,
    ACTIONS(9186), 1,
      sym__splice_dollar,
    ACTIONS(9188), 1,
      sym_quasiquote_start,
    ACTIONS(14207), 1,
      sym__varid,
    ACTIONS(14213), 1,
      anon_sym_LPAREN,
    ACTIONS(14215), 1,
      anon_sym_LBRACK,
    ACTIONS(14217), 1,
      anon_sym_SQUOTE,
    STATE(2121), 1,
      sym__unboxed_open,
    STATE(10355), 1,
      sym_constructor,
    STATE(15421), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14211), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14219), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9162), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14209), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11396), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11483), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11570), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94183] = 21,
    ACTIONS(9160), 1,
      sym__integer_literal,
    ACTIONS(9170), 1,
      sym__conid,
    ACTIONS(9184), 1,
      anon_sym_7,
    ACTIONS(9186), 1,
      sym__splice_dollar,
    ACTIONS(9188), 1,
      sym_quasiquote_start,
    ACTIONS(14207), 1,
      sym__varid,
    ACTIONS(14213), 1,
      anon_sym_LPAREN,
    ACTIONS(14215), 1,
      anon_sym_LBRACK,
    ACTIONS(14217), 1,
      anon_sym_SQUOTE,
    STATE(2121), 1,
      sym__unboxed_open,
    STATE(10355), 1,
      sym_constructor,
    STATE(15421), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14211), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14219), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9162), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14209), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11396), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11483), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11485), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94277] = 21,
    ACTIONS(9242), 1,
      sym__integer_literal,
    ACTIONS(9252), 1,
      sym__conid,
    ACTIONS(9266), 1,
      anon_sym_7,
    ACTIONS(9268), 1,
      sym__splice_dollar,
    ACTIONS(9270), 1,
      sym_quasiquote_start,
    ACTIONS(14221), 1,
      sym__varid,
    ACTIONS(14227), 1,
      anon_sym_LPAREN,
    ACTIONS(14229), 1,
      anon_sym_LBRACK,
    ACTIONS(14231), 1,
      anon_sym_SQUOTE,
    STATE(2157), 1,
      sym__unboxed_open,
    STATE(9788), 1,
      sym_constructor,
    STATE(15417), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14225), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14233), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9244), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14223), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10255), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(10257), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10011), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94371] = 26,
    ACTIONS(4309), 1,
      sym__varid,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(4321), 1,
      sym__conid,
    ACTIONS(4325), 1,
      anon_sym_7,
    ACTIONS(4327), 1,
      sym__splice_dollar,
    ACTIONS(4329), 1,
      sym_quasiquote_start,
    ACTIONS(4915), 1,
      anon_sym_LBRACK,
    ACTIONS(4921), 1,
      anon_sym__,
    ACTIONS(4927), 1,
      sym__strict,
    ACTIONS(4929), 1,
      sym__lazy,
    ACTIONS(14127), 1,
      anon_sym_LPAREN,
    STATE(236), 1,
      sym__unboxed_open,
    STATE(9240), 1,
      sym_constructor,
    STATE(9275), 1,
      sym_qualified_constructor,
    STATE(13271), 1,
      sym__pat_constructor,
    STATE(13750), 1,
      sym__qcon,
    STATE(13773), 1,
      sym_variable,
    STATE(14211), 1,
      sym_literal,
    STATE(14842), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4907), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4311), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14244), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [94475] = 21,
    ACTIONS(9242), 1,
      sym__integer_literal,
    ACTIONS(9252), 1,
      sym__conid,
    ACTIONS(9266), 1,
      anon_sym_7,
    ACTIONS(9268), 1,
      sym__splice_dollar,
    ACTIONS(9270), 1,
      sym_quasiquote_start,
    ACTIONS(14221), 1,
      sym__varid,
    ACTIONS(14227), 1,
      anon_sym_LPAREN,
    ACTIONS(14229), 1,
      anon_sym_LBRACK,
    ACTIONS(14231), 1,
      anon_sym_SQUOTE,
    STATE(2157), 1,
      sym__unboxed_open,
    STATE(9788), 1,
      sym_constructor,
    STATE(15417), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14225), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14233), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9244), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14223), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10255), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(10257), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10768), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94569] = 26,
    ACTIONS(557), 1,
      anon_sym__,
    ACTIONS(579), 1,
      sym__strict,
    ACTIONS(581), 1,
      sym__lazy,
    ACTIONS(12375), 1,
      sym__varid,
    ACTIONS(12379), 1,
      sym__integer_literal,
    ACTIONS(12391), 1,
      anon_sym_LBRACK,
    ACTIONS(12393), 1,
      anon_sym_7,
    ACTIONS(12395), 1,
      sym__splice_dollar,
    ACTIONS(12397), 1,
      sym_quasiquote_start,
    ACTIONS(13939), 1,
      anon_sym_LPAREN,
    ACTIONS(13941), 1,
      sym__conid,
    STATE(462), 1,
      sym__unboxed_open,
    STATE(12358), 1,
      sym_constructor,
    STATE(12487), 1,
      sym__pat_constructor,
    STATE(12510), 1,
      sym__qcon,
    STATE(12516), 1,
      sym_variable,
    STATE(12679), 1,
      sym_qualified_constructor,
    STATE(12754), 1,
      sym_literal,
    STATE(14733), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12383), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12377), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12381), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13060), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13084), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [94673] = 21,
    ACTIONS(2848), 1,
      sym__integer_literal,
    ACTIONS(2879), 1,
      anon_sym_7,
    ACTIONS(2881), 1,
      sym__splice_dollar,
    ACTIONS(2883), 1,
      sym_quasiquote_start,
    ACTIONS(4061), 1,
      sym__conid,
    ACTIONS(14235), 1,
      sym__varid,
    ACTIONS(14241), 1,
      anon_sym_LPAREN,
    ACTIONS(14243), 1,
      anon_sym_LBRACK,
    ACTIONS(14245), 1,
      anon_sym_SQUOTE,
    STATE(2225), 1,
      sym__unboxed_open,
    STATE(4428), 1,
      sym_constructor,
    STATE(15211), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14239), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14247), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2850), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14237), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5358), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5368), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5541), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94767] = 21,
    ACTIONS(2848), 1,
      sym__integer_literal,
    ACTIONS(2879), 1,
      anon_sym_7,
    ACTIONS(2881), 1,
      sym__splice_dollar,
    ACTIONS(2883), 1,
      sym_quasiquote_start,
    ACTIONS(4061), 1,
      sym__conid,
    ACTIONS(14235), 1,
      sym__varid,
    ACTIONS(14241), 1,
      anon_sym_LPAREN,
    ACTIONS(14243), 1,
      anon_sym_LBRACK,
    ACTIONS(14245), 1,
      anon_sym_SQUOTE,
    STATE(2225), 1,
      sym__unboxed_open,
    STATE(4428), 1,
      sym_constructor,
    STATE(15211), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14239), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14247), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2850), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14237), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5358), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5368), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5363), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [94861] = 26,
    ACTIONS(12879), 1,
      sym__varid,
    ACTIONS(12883), 1,
      sym__integer_literal,
    ACTIONS(12895), 1,
      anon_sym_LBRACK,
    ACTIONS(12897), 1,
      anon_sym__,
    ACTIONS(12899), 1,
      anon_sym_7,
    ACTIONS(12901), 1,
      sym__splice_dollar,
    ACTIONS(12903), 1,
      sym_quasiquote_start,
    ACTIONS(12905), 1,
      sym__strict,
    ACTIONS(12907), 1,
      sym__lazy,
    ACTIONS(13726), 1,
      anon_sym_LPAREN,
    ACTIONS(13728), 1,
      sym__conid,
    STATE(448), 1,
      sym__unboxed_open,
    STATE(12875), 1,
      sym__pat_constructor,
    STATE(13021), 1,
      sym_constructor,
    STATE(13155), 1,
      sym_qualified_constructor,
    STATE(13211), 1,
      sym_variable,
    STATE(13247), 1,
      sym__qcon,
    STATE(13720), 1,
      sym_literal,
    STATE(15309), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12887), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12881), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12885), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13393), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13622), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [94965] = 26,
    ACTIONS(9701), 1,
      sym__varid,
    ACTIONS(9707), 1,
      sym__integer_literal,
    ACTIONS(9713), 1,
      anon_sym_LPAREN,
    ACTIONS(9718), 1,
      anon_sym_LBRACK,
    ACTIONS(9722), 1,
      anon_sym__,
    ACTIONS(9724), 1,
      anon_sym_7,
    ACTIONS(9726), 1,
      sym__splice_dollar,
    ACTIONS(9728), 1,
      sym_quasiquote_start,
    ACTIONS(9730), 1,
      sym__strict,
    ACTIONS(9732), 1,
      sym__lazy,
    ACTIONS(10573), 1,
      sym__conid,
    STATE(350), 1,
      sym__unboxed_open,
    STATE(7601), 1,
      sym__pat_constructor,
    STATE(7661), 1,
      sym_constructor,
    STATE(7726), 1,
      sym_variable,
    STATE(7780), 1,
      sym_qualified_constructor,
    STATE(7820), 1,
      sym__qcon,
    STATE(7932), 1,
      sym_literal,
    STATE(14862), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9711), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9705), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9709), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7924), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7899), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [95069] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [95127] = 21,
    ACTIONS(8757), 1,
      sym__integer_literal,
    ACTIONS(8765), 1,
      sym__conid,
    ACTIONS(8769), 1,
      anon_sym_7,
    ACTIONS(8771), 1,
      sym__splice_dollar,
    ACTIONS(8773), 1,
      sym_quasiquote_start,
    ACTIONS(14157), 1,
      sym__varid,
    ACTIONS(14163), 1,
      anon_sym_LPAREN,
    ACTIONS(14165), 1,
      anon_sym_LBRACK,
    ACTIONS(14167), 1,
      anon_sym_SQUOTE,
    STATE(2100), 1,
      sym__unboxed_open,
    STATE(11113), 1,
      sym_constructor,
    STATE(15267), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14161), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14169), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8759), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14159), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11561), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11845), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11534), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [95221] = 21,
    ACTIONS(10290), 1,
      sym__integer_literal,
    ACTIONS(10296), 1,
      anon_sym_LPAREN,
    ACTIONS(10298), 1,
      sym__conid,
    ACTIONS(10300), 1,
      anon_sym_LBRACK,
    ACTIONS(10302), 1,
      anon_sym_SQUOTE,
    ACTIONS(10306), 1,
      anon_sym_7,
    ACTIONS(10308), 1,
      sym__splice_dollar,
    ACTIONS(10310), 1,
      sym_quasiquote_start,
    ACTIONS(14253), 1,
      sym__varid,
    STATE(2180), 1,
      sym__unboxed_open,
    STATE(8056), 1,
      sym_constructor,
    STATE(14820), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10294), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10304), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10288), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10292), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8348), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8353), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8304), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [95315] = 21,
    ACTIONS(10290), 1,
      sym__integer_literal,
    ACTIONS(10296), 1,
      anon_sym_LPAREN,
    ACTIONS(10298), 1,
      sym__conid,
    ACTIONS(10300), 1,
      anon_sym_LBRACK,
    ACTIONS(10302), 1,
      anon_sym_SQUOTE,
    ACTIONS(10306), 1,
      anon_sym_7,
    ACTIONS(10308), 1,
      sym__splice_dollar,
    ACTIONS(10310), 1,
      sym_quasiquote_start,
    ACTIONS(14253), 1,
      sym__varid,
    STATE(2180), 1,
      sym__unboxed_open,
    STATE(8056), 1,
      sym_constructor,
    STATE(14820), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10294), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10304), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10288), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10292), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8348), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8353), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8293), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [95409] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [95467] = 26,
    ACTIONS(12409), 1,
      sym__varid,
    ACTIONS(12413), 1,
      sym__integer_literal,
    ACTIONS(12425), 1,
      anon_sym_LBRACK,
    ACTIONS(12427), 1,
      anon_sym__,
    ACTIONS(12429), 1,
      anon_sym_7,
    ACTIONS(12431), 1,
      sym__splice_dollar,
    ACTIONS(12433), 1,
      sym_quasiquote_start,
    ACTIONS(12435), 1,
      sym__strict,
    ACTIONS(12437), 1,
      sym__lazy,
    ACTIONS(13819), 1,
      anon_sym_LPAREN,
    ACTIONS(13821), 1,
      sym__conid,
    STATE(246), 1,
      sym__unboxed_open,
    STATE(12769), 1,
      sym_constructor,
    STATE(12956), 1,
      sym__pat_constructor,
    STATE(13103), 1,
      sym__qcon,
    STATE(13254), 1,
      sym_variable,
    STATE(13359), 1,
      sym_qualified_constructor,
    STATE(13703), 1,
      sym_literal,
    STATE(15353), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12417), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12411), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12415), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13394), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13832), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [95571] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [95629] = 26,
    ACTIONS(11089), 1,
      sym__varid,
    ACTIONS(11093), 1,
      sym__integer_literal,
    ACTIONS(11099), 1,
      anon_sym_LPAREN,
    ACTIONS(11104), 1,
      anon_sym_LBRACK,
    ACTIONS(11108), 1,
      anon_sym__,
    ACTIONS(11110), 1,
      anon_sym_7,
    ACTIONS(11112), 1,
      sym__splice_dollar,
    ACTIONS(11114), 1,
      sym_quasiquote_start,
    ACTIONS(11116), 1,
      sym__strict,
    ACTIONS(11118), 1,
      sym__lazy,
    ACTIONS(12655), 1,
      sym__conid,
    STATE(481), 1,
      sym__unboxed_open,
    STATE(8017), 1,
      sym_constructor,
    STATE(8101), 1,
      sym__pat_constructor,
    STATE(8254), 1,
      sym_qualified_constructor,
    STATE(8324), 1,
      sym_variable,
    STATE(8386), 1,
      sym__qcon,
    STATE(8663), 1,
      sym_literal,
    STATE(15071), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11097), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11091), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11095), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8608), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8451), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [95733] = 26,
    ACTIONS(11089), 1,
      sym__varid,
    ACTIONS(11093), 1,
      sym__integer_literal,
    ACTIONS(11099), 1,
      anon_sym_LPAREN,
    ACTIONS(11104), 1,
      anon_sym_LBRACK,
    ACTIONS(11108), 1,
      anon_sym__,
    ACTIONS(11110), 1,
      anon_sym_7,
    ACTIONS(11112), 1,
      sym__splice_dollar,
    ACTIONS(11114), 1,
      sym_quasiquote_start,
    ACTIONS(11116), 1,
      sym__strict,
    ACTIONS(11118), 1,
      sym__lazy,
    ACTIONS(12655), 1,
      sym__conid,
    STATE(481), 1,
      sym__unboxed_open,
    STATE(8017), 1,
      sym_constructor,
    STATE(8101), 1,
      sym__pat_constructor,
    STATE(8254), 1,
      sym_qualified_constructor,
    STATE(8324), 1,
      sym_variable,
    STATE(8386), 1,
      sym__qcon,
    STATE(8663), 1,
      sym_literal,
    STATE(15071), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11097), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11091), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11095), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8608), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8462), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [95837] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [95897] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [95955] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [96013] = 21,
    ACTIONS(2084), 1,
      sym__integer_literal,
    ACTIONS(2116), 1,
      anon_sym_7,
    ACTIONS(2118), 1,
      sym__splice_dollar,
    ACTIONS(2120), 1,
      sym_quasiquote_start,
    ACTIONS(4055), 1,
      sym__conid,
    ACTIONS(14044), 1,
      sym__varid,
    ACTIONS(14050), 1,
      anon_sym_LPAREN,
    ACTIONS(14052), 1,
      anon_sym_LBRACK,
    ACTIONS(14054), 1,
      anon_sym_SQUOTE,
    STATE(2142), 1,
      sym__unboxed_open,
    STATE(4256), 1,
      sym_constructor,
    STATE(15230), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14048), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14056), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2086), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14046), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4374), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4459), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4457), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96107] = 21,
    ACTIONS(10262), 1,
      sym__integer_literal,
    ACTIONS(10268), 1,
      anon_sym_LPAREN,
    ACTIONS(10270), 1,
      sym__conid,
    ACTIONS(10272), 1,
      anon_sym_LBRACK,
    ACTIONS(10274), 1,
      anon_sym_SQUOTE,
    ACTIONS(10280), 1,
      anon_sym_7,
    ACTIONS(10282), 1,
      sym__splice_dollar,
    ACTIONS(10284), 1,
      sym_quasiquote_start,
    ACTIONS(14263), 1,
      sym__varid,
    STATE(2164), 1,
      sym__unboxed_open,
    STATE(8075), 1,
      sym_constructor,
    STATE(15062), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10266), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10276), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10260), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10264), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8351), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8355), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8215), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96201] = 21,
    ACTIONS(13614), 1,
      sym__varid,
    ACTIONS(13618), 1,
      sym__integer_literal,
    ACTIONS(13624), 1,
      anon_sym_LPAREN,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(13628), 1,
      anon_sym_LBRACK,
    ACTIONS(13630), 1,
      anon_sym_SQUOTE,
    ACTIONS(13636), 1,
      anon_sym_7,
    ACTIONS(13638), 1,
      sym__splice_dollar,
    ACTIONS(13640), 1,
      sym_quasiquote_start,
    STATE(2163), 1,
      sym__unboxed_open,
    STATE(13520), 1,
      sym_constructor,
    STATE(14747), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13622), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13632), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13616), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13620), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14250), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(14252), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(18537), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96295] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [96353] = 21,
    ACTIONS(10262), 1,
      sym__integer_literal,
    ACTIONS(10268), 1,
      anon_sym_LPAREN,
    ACTIONS(10270), 1,
      sym__conid,
    ACTIONS(10272), 1,
      anon_sym_LBRACK,
    ACTIONS(10274), 1,
      anon_sym_SQUOTE,
    ACTIONS(10280), 1,
      anon_sym_7,
    ACTIONS(10282), 1,
      sym__splice_dollar,
    ACTIONS(10284), 1,
      sym_quasiquote_start,
    ACTIONS(14263), 1,
      sym__varid,
    STATE(2164), 1,
      sym__unboxed_open,
    STATE(8075), 1,
      sym_constructor,
    STATE(15062), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10266), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10276), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10260), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10264), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8351), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8355), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8223), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96447] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [96505] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [96563] = 21,
    ACTIONS(14273), 1,
      sym__varid,
    ACTIONS(14277), 1,
      sym__integer_literal,
    ACTIONS(14283), 1,
      anon_sym_LPAREN,
    ACTIONS(14285), 1,
      sym__conid,
    ACTIONS(14287), 1,
      anon_sym_LBRACK,
    ACTIONS(14289), 1,
      anon_sym_SQUOTE,
    ACTIONS(14293), 1,
      anon_sym_7,
    ACTIONS(14295), 1,
      sym__splice_dollar,
    ACTIONS(14297), 1,
      sym_quasiquote_start,
    STATE(2176), 1,
      sym__unboxed_open,
    STATE(13424), 1,
      sym_constructor,
    STATE(14674), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14281), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14291), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(14275), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14279), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14031), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14045), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(14280), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96657] = 21,
    ACTIONS(14273), 1,
      sym__varid,
    ACTIONS(14277), 1,
      sym__integer_literal,
    ACTIONS(14283), 1,
      anon_sym_LPAREN,
    ACTIONS(14285), 1,
      sym__conid,
    ACTIONS(14287), 1,
      anon_sym_LBRACK,
    ACTIONS(14289), 1,
      anon_sym_SQUOTE,
    ACTIONS(14293), 1,
      anon_sym_7,
    ACTIONS(14295), 1,
      sym__splice_dollar,
    ACTIONS(14297), 1,
      sym_quasiquote_start,
    STATE(2176), 1,
      sym__unboxed_open,
    STATE(13424), 1,
      sym_constructor,
    STATE(14674), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14281), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14291), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(14275), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14279), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14031), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14045), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(14276), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [96751] = 26,
    ACTIONS(12879), 1,
      sym__varid,
    ACTIONS(12883), 1,
      sym__integer_literal,
    ACTIONS(12895), 1,
      anon_sym_LBRACK,
    ACTIONS(12897), 1,
      anon_sym__,
    ACTIONS(12899), 1,
      anon_sym_7,
    ACTIONS(12901), 1,
      sym__splice_dollar,
    ACTIONS(12903), 1,
      sym_quasiquote_start,
    ACTIONS(12905), 1,
      sym__strict,
    ACTIONS(12907), 1,
      sym__lazy,
    ACTIONS(13726), 1,
      anon_sym_LPAREN,
    ACTIONS(13728), 1,
      sym__conid,
    STATE(448), 1,
      sym__unboxed_open,
    STATE(12875), 1,
      sym__pat_constructor,
    STATE(13021), 1,
      sym_constructor,
    STATE(13155), 1,
      sym_qualified_constructor,
    STATE(13211), 1,
      sym_variable,
    STATE(13247), 1,
      sym__qcon,
    STATE(13720), 1,
      sym_literal,
    STATE(15309), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12887), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12881), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12885), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13393), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13741), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [96855] = 26,
    ACTIONS(12879), 1,
      sym__varid,
    ACTIONS(12883), 1,
      sym__integer_literal,
    ACTIONS(12895), 1,
      anon_sym_LBRACK,
    ACTIONS(12897), 1,
      anon_sym__,
    ACTIONS(12899), 1,
      anon_sym_7,
    ACTIONS(12901), 1,
      sym__splice_dollar,
    ACTIONS(12903), 1,
      sym_quasiquote_start,
    ACTIONS(12905), 1,
      sym__strict,
    ACTIONS(12907), 1,
      sym__lazy,
    ACTIONS(13726), 1,
      anon_sym_LPAREN,
    ACTIONS(13728), 1,
      sym__conid,
    STATE(448), 1,
      sym__unboxed_open,
    STATE(12875), 1,
      sym__pat_constructor,
    STATE(13021), 1,
      sym_constructor,
    STATE(13155), 1,
      sym_qualified_constructor,
    STATE(13211), 1,
      sym_variable,
    STATE(13247), 1,
      sym__qcon,
    STATE(13720), 1,
      sym_literal,
    STATE(15309), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12887), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12881), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12885), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13393), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13740), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [96959] = 21,
    ACTIONS(2737), 1,
      sym__integer_literal,
    ACTIONS(2769), 1,
      anon_sym_7,
    ACTIONS(2771), 1,
      sym__splice_dollar,
    ACTIONS(2773), 1,
      sym_quasiquote_start,
    ACTIONS(4073), 1,
      sym__conid,
    ACTIONS(14299), 1,
      sym__varid,
    ACTIONS(14305), 1,
      anon_sym_LPAREN,
    ACTIONS(14307), 1,
      anon_sym_LBRACK,
    ACTIONS(14309), 1,
      anon_sym_SQUOTE,
    STATE(2158), 1,
      sym__unboxed_open,
    STATE(4518), 1,
      sym_constructor,
    STATE(15405), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14303), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14311), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2739), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14301), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5349), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5626), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97053] = 21,
    ACTIONS(2737), 1,
      sym__integer_literal,
    ACTIONS(2769), 1,
      anon_sym_7,
    ACTIONS(2771), 1,
      sym__splice_dollar,
    ACTIONS(2773), 1,
      sym_quasiquote_start,
    ACTIONS(4073), 1,
      sym__conid,
    ACTIONS(14299), 1,
      sym__varid,
    ACTIONS(14305), 1,
      anon_sym_LPAREN,
    ACTIONS(14307), 1,
      anon_sym_LBRACK,
    ACTIONS(14309), 1,
      anon_sym_SQUOTE,
    STATE(2158), 1,
      sym__unboxed_open,
    STATE(4518), 1,
      sym_constructor,
    STATE(15405), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14303), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14311), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2739), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14301), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5349), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5487), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97147] = 26,
    ACTIONS(9701), 1,
      sym__varid,
    ACTIONS(9707), 1,
      sym__integer_literal,
    ACTIONS(9713), 1,
      anon_sym_LPAREN,
    ACTIONS(9718), 1,
      anon_sym_LBRACK,
    ACTIONS(9722), 1,
      anon_sym__,
    ACTIONS(9724), 1,
      anon_sym_7,
    ACTIONS(9726), 1,
      sym__splice_dollar,
    ACTIONS(9728), 1,
      sym_quasiquote_start,
    ACTIONS(9730), 1,
      sym__strict,
    ACTIONS(9732), 1,
      sym__lazy,
    ACTIONS(10573), 1,
      sym__conid,
    STATE(350), 1,
      sym__unboxed_open,
    STATE(7601), 1,
      sym__pat_constructor,
    STATE(7661), 1,
      sym_constructor,
    STATE(7726), 1,
      sym_variable,
    STATE(7780), 1,
      sym_qualified_constructor,
    STATE(7820), 1,
      sym__qcon,
    STATE(7932), 1,
      sym_literal,
    STATE(14862), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9711), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9705), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9709), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7924), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7894), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [97251] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [97309] = 26,
    ACTIONS(12345), 1,
      sym__varid,
    ACTIONS(12349), 1,
      sym__integer_literal,
    ACTIONS(12361), 1,
      anon_sym_LBRACK,
    ACTIONS(12363), 1,
      anon_sym__,
    ACTIONS(12365), 1,
      anon_sym_7,
    ACTIONS(12367), 1,
      sym__splice_dollar,
    ACTIONS(12369), 1,
      sym_quasiquote_start,
    ACTIONS(12371), 1,
      sym__strict,
    ACTIONS(12373), 1,
      sym__lazy,
    ACTIONS(13985), 1,
      anon_sym_LPAREN,
    ACTIONS(13987), 1,
      sym__conid,
    STATE(335), 1,
      sym__unboxed_open,
    STATE(12576), 1,
      sym_constructor,
    STATE(12723), 1,
      sym__pat_constructor,
    STATE(12906), 1,
      sym_variable,
    STATE(13025), 1,
      sym_qualified_constructor,
    STATE(13080), 1,
      sym__qcon,
    STATE(13230), 1,
      sym_literal,
    STATE(15422), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12353), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12347), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12351), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13356), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13267), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [97413] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [97471] = 26,
    ACTIONS(4309), 1,
      sym__varid,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(4321), 1,
      sym__conid,
    ACTIONS(4325), 1,
      anon_sym_7,
    ACTIONS(4327), 1,
      sym__splice_dollar,
    ACTIONS(4329), 1,
      sym_quasiquote_start,
    ACTIONS(4915), 1,
      anon_sym_LBRACK,
    ACTIONS(4921), 1,
      anon_sym__,
    ACTIONS(4927), 1,
      sym__strict,
    ACTIONS(4929), 1,
      sym__lazy,
    ACTIONS(14127), 1,
      anon_sym_LPAREN,
    STATE(236), 1,
      sym__unboxed_open,
    STATE(9240), 1,
      sym_constructor,
    STATE(9275), 1,
      sym_qualified_constructor,
    STATE(13271), 1,
      sym__pat_constructor,
    STATE(13750), 1,
      sym__qcon,
    STATE(13773), 1,
      sym_variable,
    STATE(14211), 1,
      sym_literal,
    STATE(14842), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4907), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4311), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14418), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [97575] = 26,
    ACTIONS(11558), 1,
      sym__varid,
    ACTIONS(11562), 1,
      sym__integer_literal,
    ACTIONS(11568), 1,
      anon_sym_LPAREN,
    ACTIONS(11573), 1,
      anon_sym_LBRACK,
    ACTIONS(11577), 1,
      anon_sym__,
    ACTIONS(11579), 1,
      anon_sym_7,
    ACTIONS(11581), 1,
      sym__splice_dollar,
    ACTIONS(11583), 1,
      sym_quasiquote_start,
    ACTIONS(11585), 1,
      sym__strict,
    ACTIONS(11587), 1,
      sym__lazy,
    ACTIONS(12537), 1,
      sym__conid,
    STATE(476), 1,
      sym__unboxed_open,
    STATE(8298), 1,
      sym_constructor,
    STATE(8301), 1,
      sym__pat_constructor,
    STATE(8535), 1,
      sym__qcon,
    STATE(8545), 1,
      sym_qualified_constructor,
    STATE(8609), 1,
      sym_variable,
    STATE(8853), 1,
      sym_literal,
    STATE(15198), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11566), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11560), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11564), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8846), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8770), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [97679] = 21,
    ACTIONS(8669), 1,
      sym__integer_literal,
    ACTIONS(8679), 1,
      sym__conid,
    ACTIONS(8693), 1,
      anon_sym_7,
    ACTIONS(8695), 1,
      sym__splice_dollar,
    ACTIONS(8697), 1,
      sym_quasiquote_start,
    ACTIONS(14313), 1,
      sym__varid,
    ACTIONS(14319), 1,
      anon_sym_LPAREN,
    ACTIONS(14321), 1,
      anon_sym_LBRACK,
    ACTIONS(14323), 1,
      anon_sym_SQUOTE,
    STATE(2198), 1,
      sym__unboxed_open,
    STATE(10620), 1,
      sym_constructor,
    STATE(14886), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14317), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14325), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8671), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14315), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11103), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11106), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11338), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97773] = 26,
    ACTIONS(557), 1,
      anon_sym__,
    ACTIONS(579), 1,
      sym__strict,
    ACTIONS(581), 1,
      sym__lazy,
    ACTIONS(12375), 1,
      sym__varid,
    ACTIONS(12379), 1,
      sym__integer_literal,
    ACTIONS(12391), 1,
      anon_sym_LBRACK,
    ACTIONS(12393), 1,
      anon_sym_7,
    ACTIONS(12395), 1,
      sym__splice_dollar,
    ACTIONS(12397), 1,
      sym_quasiquote_start,
    ACTIONS(13939), 1,
      anon_sym_LPAREN,
    ACTIONS(13941), 1,
      sym__conid,
    STATE(462), 1,
      sym__unboxed_open,
    STATE(12358), 1,
      sym_constructor,
    STATE(12487), 1,
      sym__pat_constructor,
    STATE(12510), 1,
      sym__qcon,
    STATE(12516), 1,
      sym_variable,
    STATE(12679), 1,
      sym_qualified_constructor,
    STATE(12754), 1,
      sym_literal,
    STATE(14733), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12383), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12377), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12381), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13060), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13077), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [97877] = 21,
    ACTIONS(2664), 1,
      sym__integer_literal,
    ACTIONS(2696), 1,
      anon_sym_7,
    ACTIONS(2698), 1,
      sym__splice_dollar,
    ACTIONS(2700), 1,
      sym_quasiquote_start,
    ACTIONS(4193), 1,
      sym__conid,
    ACTIONS(14327), 1,
      sym__varid,
    ACTIONS(14333), 1,
      anon_sym_LPAREN,
    ACTIONS(14335), 1,
      anon_sym_LBRACK,
    ACTIONS(14337), 1,
      anon_sym_SQUOTE,
    STATE(2141), 1,
      sym__unboxed_open,
    STATE(4683), 1,
      sym_constructor,
    STATE(15150), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14331), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14339), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2666), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14329), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5056), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5059), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5382), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [97971] = 21,
    ACTIONS(2664), 1,
      sym__integer_literal,
    ACTIONS(2696), 1,
      anon_sym_7,
    ACTIONS(2698), 1,
      sym__splice_dollar,
    ACTIONS(2700), 1,
      sym_quasiquote_start,
    ACTIONS(4193), 1,
      sym__conid,
    ACTIONS(14327), 1,
      sym__varid,
    ACTIONS(14333), 1,
      anon_sym_LPAREN,
    ACTIONS(14335), 1,
      anon_sym_LBRACK,
    ACTIONS(14337), 1,
      anon_sym_SQUOTE,
    STATE(2141), 1,
      sym__unboxed_open,
    STATE(4683), 1,
      sym_constructor,
    STATE(15150), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14331), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14339), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2666), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14329), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5056), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5059), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5533), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [98065] = 26,
    ACTIONS(255), 1,
      anon_sym__,
    ACTIONS(281), 1,
      sym__strict,
    ACTIONS(283), 1,
      sym__lazy,
    ACTIONS(12909), 1,
      sym__varid,
    ACTIONS(12913), 1,
      sym__integer_literal,
    ACTIONS(12925), 1,
      anon_sym_LBRACK,
    ACTIONS(12927), 1,
      anon_sym_7,
    ACTIONS(12929), 1,
      sym__splice_dollar,
    ACTIONS(12931), 1,
      sym_quasiquote_start,
    ACTIONS(13851), 1,
      anon_sym_LPAREN,
    ACTIONS(13853), 1,
      sym__conid,
    STATE(463), 1,
      sym__unboxed_open,
    STATE(12060), 1,
      sym_constructor,
    STATE(12158), 1,
      sym__pat_constructor,
    STATE(12236), 1,
      sym_variable,
    STATE(12290), 1,
      sym_qualified_constructor,
    STATE(12365), 1,
      sym__qcon,
    STATE(12725), 1,
      sym_literal,
    STATE(15373), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12917), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12911), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12915), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12718), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12518), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [98169] = 26,
    ACTIONS(255), 1,
      anon_sym__,
    ACTIONS(281), 1,
      sym__strict,
    ACTIONS(283), 1,
      sym__lazy,
    ACTIONS(12909), 1,
      sym__varid,
    ACTIONS(12913), 1,
      sym__integer_literal,
    ACTIONS(12925), 1,
      anon_sym_LBRACK,
    ACTIONS(12927), 1,
      anon_sym_7,
    ACTIONS(12929), 1,
      sym__splice_dollar,
    ACTIONS(12931), 1,
      sym_quasiquote_start,
    ACTIONS(13851), 1,
      anon_sym_LPAREN,
    ACTIONS(13853), 1,
      sym__conid,
    STATE(463), 1,
      sym__unboxed_open,
    STATE(12060), 1,
      sym_constructor,
    STATE(12158), 1,
      sym__pat_constructor,
    STATE(12236), 1,
      sym_variable,
    STATE(12290), 1,
      sym_qualified_constructor,
    STATE(12365), 1,
      sym__qcon,
    STATE(12725), 1,
      sym_literal,
    STATE(15373), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12917), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12911), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12915), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12718), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12520), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [98273] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [98331] = 21,
    ACTIONS(13614), 1,
      sym__varid,
    ACTIONS(13618), 1,
      sym__integer_literal,
    ACTIONS(13624), 1,
      anon_sym_LPAREN,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(13628), 1,
      anon_sym_LBRACK,
    ACTIONS(13630), 1,
      anon_sym_SQUOTE,
    ACTIONS(13636), 1,
      anon_sym_7,
    ACTIONS(13638), 1,
      sym__splice_dollar,
    ACTIONS(13640), 1,
      sym_quasiquote_start,
    STATE(2163), 1,
      sym__unboxed_open,
    STATE(13520), 1,
      sym_constructor,
    STATE(14747), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13622), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13632), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(13616), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13620), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14250), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(14252), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(15197), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [98425] = 26,
    ACTIONS(9954), 1,
      sym__varid,
    ACTIONS(9958), 1,
      sym__integer_literal,
    ACTIONS(9964), 1,
      anon_sym_LPAREN,
    ACTIONS(9969), 1,
      anon_sym_LBRACK,
    ACTIONS(9973), 1,
      anon_sym__,
    ACTIONS(9975), 1,
      anon_sym_7,
    ACTIONS(9977), 1,
      sym__splice_dollar,
    ACTIONS(9979), 1,
      sym_quasiquote_start,
    ACTIONS(9981), 1,
      sym__strict,
    ACTIONS(9983), 1,
      sym__lazy,
    ACTIONS(12923), 1,
      sym__conid,
    STATE(392), 1,
      sym__unboxed_open,
    STATE(7727), 1,
      sym_constructor,
    STATE(7812), 1,
      sym__pat_constructor,
    STATE(7879), 1,
      sym_variable,
    STATE(7896), 1,
      sym__qcon,
    STATE(7923), 1,
      sym_qualified_constructor,
    STATE(7960), 1,
      sym_literal,
    STATE(15107), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9962), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9956), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9960), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8048), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8005), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [98529] = 26,
    ACTIONS(9954), 1,
      sym__varid,
    ACTIONS(9958), 1,
      sym__integer_literal,
    ACTIONS(9964), 1,
      anon_sym_LPAREN,
    ACTIONS(9969), 1,
      anon_sym_LBRACK,
    ACTIONS(9973), 1,
      anon_sym__,
    ACTIONS(9975), 1,
      anon_sym_7,
    ACTIONS(9977), 1,
      sym__splice_dollar,
    ACTIONS(9979), 1,
      sym_quasiquote_start,
    ACTIONS(9981), 1,
      sym__strict,
    ACTIONS(9983), 1,
      sym__lazy,
    ACTIONS(12923), 1,
      sym__conid,
    STATE(392), 1,
      sym__unboxed_open,
    STATE(7727), 1,
      sym_constructor,
    STATE(7812), 1,
      sym__pat_constructor,
    STATE(7879), 1,
      sym_variable,
    STATE(7896), 1,
      sym__qcon,
    STATE(7923), 1,
      sym_qualified_constructor,
    STATE(7960), 1,
      sym_literal,
    STATE(15107), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9962), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9956), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9960), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8048), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8008), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [98633] = 6,
    ACTIONS(14345), 1,
      anon_sym_LBRACE,
    ACTIONS(14348), 1,
      sym__layout_start,
    STATE(3853), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 14,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [98697] = 21,
    ACTIONS(8669), 1,
      sym__integer_literal,
    ACTIONS(8679), 1,
      sym__conid,
    ACTIONS(8693), 1,
      anon_sym_7,
    ACTIONS(8695), 1,
      sym__splice_dollar,
    ACTIONS(8697), 1,
      sym_quasiquote_start,
    ACTIONS(14313), 1,
      sym__varid,
    ACTIONS(14319), 1,
      anon_sym_LPAREN,
    ACTIONS(14321), 1,
      anon_sym_LBRACK,
    ACTIONS(14323), 1,
      anon_sym_SQUOTE,
    STATE(2198), 1,
      sym__unboxed_open,
    STATE(10620), 1,
      sym_constructor,
    STATE(14886), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14317), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14325), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8671), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14315), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11103), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11106), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11908), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [98791] = 21,
    ACTIONS(9124), 1,
      sym__integer_literal,
    ACTIONS(9134), 1,
      sym__conid,
    ACTIONS(9148), 1,
      anon_sym_7,
    ACTIONS(9150), 1,
      sym__splice_dollar,
    ACTIONS(9152), 1,
      sym_quasiquote_start,
    ACTIONS(13823), 1,
      sym__varid,
    ACTIONS(13829), 1,
      anon_sym_LPAREN,
    ACTIONS(13831), 1,
      anon_sym_LBRACK,
    ACTIONS(13833), 1,
      anon_sym_SQUOTE,
    STATE(2203), 1,
      sym__unboxed_open,
    STATE(9974), 1,
      sym_constructor,
    STATE(15083), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13827), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13835), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(9126), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13825), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10746), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(10842), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11101), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [98885] = 21,
    ACTIONS(1364), 1,
      sym__integer_literal,
    ACTIONS(1380), 1,
      anon_sym_7,
    ACTIONS(1382), 1,
      sym__splice_dollar,
    ACTIONS(1384), 1,
      sym_quasiquote_start,
    ACTIONS(3051), 1,
      sym__conid,
    ACTIONS(14350), 1,
      sym__varid,
    ACTIONS(14356), 1,
      anon_sym_LPAREN,
    ACTIONS(14358), 1,
      anon_sym_LBRACK,
    ACTIONS(14360), 1,
      anon_sym_SQUOTE,
    STATE(2191), 1,
      sym__unboxed_open,
    STATE(5529), 1,
      sym_constructor,
    STATE(15207), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14354), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14362), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(1366), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14352), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5828), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5833), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(6215), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [98979] = 21,
    ACTIONS(1364), 1,
      sym__integer_literal,
    ACTIONS(1380), 1,
      anon_sym_7,
    ACTIONS(1382), 1,
      sym__splice_dollar,
    ACTIONS(1384), 1,
      sym_quasiquote_start,
    ACTIONS(3051), 1,
      sym__conid,
    ACTIONS(14350), 1,
      sym__varid,
    ACTIONS(14356), 1,
      anon_sym_LPAREN,
    ACTIONS(14358), 1,
      anon_sym_LBRACK,
    ACTIONS(14360), 1,
      anon_sym_SQUOTE,
    STATE(2191), 1,
      sym__unboxed_open,
    STATE(5529), 1,
      sym_constructor,
    STATE(15207), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14354), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14362), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(1366), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14352), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5828), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5833), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5801), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99073] = 26,
    ACTIONS(9954), 1,
      sym__varid,
    ACTIONS(9958), 1,
      sym__integer_literal,
    ACTIONS(9964), 1,
      anon_sym_LPAREN,
    ACTIONS(9969), 1,
      anon_sym_LBRACK,
    ACTIONS(9973), 1,
      anon_sym__,
    ACTIONS(9975), 1,
      anon_sym_7,
    ACTIONS(9977), 1,
      sym__splice_dollar,
    ACTIONS(9979), 1,
      sym_quasiquote_start,
    ACTIONS(9981), 1,
      sym__strict,
    ACTIONS(9983), 1,
      sym__lazy,
    ACTIONS(12923), 1,
      sym__conid,
    STATE(392), 1,
      sym__unboxed_open,
    STATE(7727), 1,
      sym_constructor,
    STATE(7812), 1,
      sym__pat_constructor,
    STATE(7879), 1,
      sym_variable,
    STATE(7896), 1,
      sym__qcon,
    STATE(7923), 1,
      sym_qualified_constructor,
    STATE(7960), 1,
      sym_literal,
    STATE(15107), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9962), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9956), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9960), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8048), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8034), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [99177] = 26,
    ACTIONS(255), 1,
      anon_sym__,
    ACTIONS(281), 1,
      sym__strict,
    ACTIONS(283), 1,
      sym__lazy,
    ACTIONS(12909), 1,
      sym__varid,
    ACTIONS(12913), 1,
      sym__integer_literal,
    ACTIONS(12925), 1,
      anon_sym_LBRACK,
    ACTIONS(12927), 1,
      anon_sym_7,
    ACTIONS(12929), 1,
      sym__splice_dollar,
    ACTIONS(12931), 1,
      sym_quasiquote_start,
    ACTIONS(13851), 1,
      anon_sym_LPAREN,
    ACTIONS(13853), 1,
      sym__conid,
    STATE(463), 1,
      sym__unboxed_open,
    STATE(12060), 1,
      sym_constructor,
    STATE(12158), 1,
      sym__pat_constructor,
    STATE(12236), 1,
      sym_variable,
    STATE(12290), 1,
      sym_qualified_constructor,
    STATE(12365), 1,
      sym__qcon,
    STATE(12725), 1,
      sym_literal,
    STATE(15373), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12917), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12911), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12915), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12718), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12511), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [99281] = 26,
    ACTIONS(33), 1,
      anon_sym__,
    ACTIONS(75), 1,
      sym__strict,
    ACTIONS(77), 1,
      sym__lazy,
    ACTIONS(4529), 1,
      sym__varid,
    ACTIONS(4533), 1,
      sym__integer_literal,
    ACTIONS(4541), 1,
      sym__conid,
    ACTIONS(4545), 1,
      anon_sym_7,
    ACTIONS(4547), 1,
      sym__splice_dollar,
    ACTIONS(4549), 1,
      sym_quasiquote_start,
    ACTIONS(4965), 1,
      anon_sym_LBRACK,
    ACTIONS(13869), 1,
      anon_sym_LPAREN,
    STATE(456), 1,
      sym__unboxed_open,
    STATE(9235), 1,
      sym_constructor,
    STATE(9289), 1,
      sym_qualified_constructor,
    STATE(12015), 1,
      sym__pat_constructor,
    STATE(12454), 1,
      sym_variable,
    STATE(12460), 1,
      sym__qcon,
    STATE(12624), 1,
      sym_literal,
    STATE(14621), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4959), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(4531), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(4535), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9283), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12700), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [99385] = 26,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9344), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [99489] = 26,
    ACTIONS(1192), 1,
      anon_sym__,
    ACTIONS(1212), 1,
      sym__strict,
    ACTIONS(1214), 1,
      sym__lazy,
    ACTIONS(12641), 1,
      sym__varid,
    ACTIONS(12645), 1,
      sym__integer_literal,
    ACTIONS(12657), 1,
      anon_sym_LBRACK,
    ACTIONS(12659), 1,
      anon_sym_7,
    ACTIONS(12661), 1,
      sym__splice_dollar,
    ACTIONS(12663), 1,
      sym_quasiquote_start,
    ACTIONS(13921), 1,
      anon_sym_LPAREN,
    ACTIONS(13923), 1,
      sym__conid,
    STATE(459), 1,
      sym__unboxed_open,
    STATE(12594), 1,
      sym__pat_constructor,
    STATE(12717), 1,
      sym_constructor,
    STATE(12730), 1,
      sym_qualified_constructor,
    STATE(13094), 1,
      sym_variable,
    STATE(13095), 1,
      sym__qcon,
    STATE(13249), 1,
      sym_literal,
    STATE(14609), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12649), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12643), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12647), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13328), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13190), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [99593] = 26,
    ACTIONS(1192), 1,
      anon_sym__,
    ACTIONS(1212), 1,
      sym__strict,
    ACTIONS(1214), 1,
      sym__lazy,
    ACTIONS(12641), 1,
      sym__varid,
    ACTIONS(12645), 1,
      sym__integer_literal,
    ACTIONS(12657), 1,
      anon_sym_LBRACK,
    ACTIONS(12659), 1,
      anon_sym_7,
    ACTIONS(12661), 1,
      sym__splice_dollar,
    ACTIONS(12663), 1,
      sym_quasiquote_start,
    ACTIONS(13921), 1,
      anon_sym_LPAREN,
    ACTIONS(13923), 1,
      sym__conid,
    STATE(459), 1,
      sym__unboxed_open,
    STATE(12594), 1,
      sym__pat_constructor,
    STATE(12717), 1,
      sym_constructor,
    STATE(12730), 1,
      sym_qualified_constructor,
    STATE(13094), 1,
      sym_variable,
    STATE(13095), 1,
      sym__qcon,
    STATE(13249), 1,
      sym_literal,
    STATE(14609), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12649), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12643), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12647), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13328), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13191), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [99697] = 21,
    ACTIONS(2564), 1,
      sym__integer_literal,
    ACTIONS(2595), 1,
      anon_sym_7,
    ACTIONS(2597), 1,
      sym__splice_dollar,
    ACTIONS(2599), 1,
      sym_quasiquote_start,
    ACTIONS(4047), 1,
      sym__conid,
    ACTIONS(14364), 1,
      sym__varid,
    ACTIONS(14370), 1,
      anon_sym_LPAREN,
    ACTIONS(14372), 1,
      anon_sym_LBRACK,
    ACTIONS(14374), 1,
      anon_sym_SQUOTE,
    STATE(2104), 1,
      sym__unboxed_open,
    STATE(4406), 1,
      sym_constructor,
    STATE(15263), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14368), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14376), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2566), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14366), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5167), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5173), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5574), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99791] = 21,
    ACTIONS(4477), 1,
      sym__integer_literal,
    ACTIONS(4487), 1,
      sym__conid,
    ACTIONS(4501), 1,
      anon_sym_7,
    ACTIONS(4503), 1,
      sym__splice_dollar,
    ACTIONS(4505), 1,
      sym_quasiquote_start,
    ACTIONS(14378), 1,
      sym__varid,
    ACTIONS(14384), 1,
      anon_sym_LPAREN,
    ACTIONS(14386), 1,
      anon_sym_LBRACK,
    ACTIONS(14388), 1,
      anon_sym_SQUOTE,
    STATE(2137), 1,
      sym__unboxed_open,
    STATE(9608), 1,
      sym_constructor,
    STATE(15007), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14382), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14390), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4479), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14380), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9768), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9830), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9906), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99885] = 21,
    ACTIONS(4477), 1,
      sym__integer_literal,
    ACTIONS(4487), 1,
      sym__conid,
    ACTIONS(4501), 1,
      anon_sym_7,
    ACTIONS(4503), 1,
      sym__splice_dollar,
    ACTIONS(4505), 1,
      sym_quasiquote_start,
    ACTIONS(14378), 1,
      sym__varid,
    ACTIONS(14384), 1,
      anon_sym_LPAREN,
    ACTIONS(14386), 1,
      anon_sym_LBRACK,
    ACTIONS(14388), 1,
      anon_sym_SQUOTE,
    STATE(2137), 1,
      sym__unboxed_open,
    STATE(9608), 1,
      sym_constructor,
    STATE(15007), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14382), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14390), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4479), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14380), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9768), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9830), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10101), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [99979] = 26,
    ACTIONS(1378), 1,
      anon_sym__,
    ACTIONS(1386), 1,
      sym__strict,
    ACTIONS(1388), 1,
      sym__lazy,
    ACTIONS(12771), 1,
      sym__varid,
    ACTIONS(12775), 1,
      sym__integer_literal,
    ACTIONS(12787), 1,
      anon_sym_LBRACK,
    ACTIONS(12789), 1,
      anon_sym_7,
    ACTIONS(12791), 1,
      sym__splice_dollar,
    ACTIONS(12793), 1,
      sym_quasiquote_start,
    ACTIONS(14033), 1,
      anon_sym_LPAREN,
    ACTIONS(14035), 1,
      sym__conid,
    STATE(263), 1,
      sym__unboxed_open,
    STATE(12540), 1,
      sym_constructor,
    STATE(12544), 1,
      sym__pat_constructor,
    STATE(12828), 1,
      sym_qualified_constructor,
    STATE(12874), 1,
      sym_variable,
    STATE(13029), 1,
      sym__qcon,
    STATE(13152), 1,
      sym_literal,
    STATE(14631), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13099), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13352), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [100083] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [100141] = 21,
    ACTIONS(2564), 1,
      sym__integer_literal,
    ACTIONS(2595), 1,
      anon_sym_7,
    ACTIONS(2597), 1,
      sym__splice_dollar,
    ACTIONS(2599), 1,
      sym_quasiquote_start,
    ACTIONS(4047), 1,
      sym__conid,
    ACTIONS(14364), 1,
      sym__varid,
    ACTIONS(14370), 1,
      anon_sym_LPAREN,
    ACTIONS(14372), 1,
      anon_sym_LBRACK,
    ACTIONS(14374), 1,
      anon_sym_SQUOTE,
    STATE(2104), 1,
      sym__unboxed_open,
    STATE(4406), 1,
      sym_constructor,
    STATE(15263), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14368), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14376), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2566), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14366), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5167), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5173), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5197), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100235] = 26,
    ACTIONS(12695), 1,
      sym__varid,
    ACTIONS(12699), 1,
      sym__integer_literal,
    ACTIONS(12711), 1,
      anon_sym_LBRACK,
    ACTIONS(12713), 1,
      anon_sym__,
    ACTIONS(12715), 1,
      anon_sym_7,
    ACTIONS(12717), 1,
      sym__splice_dollar,
    ACTIONS(12719), 1,
      sym_quasiquote_start,
    ACTIONS(12721), 1,
      sym__strict,
    ACTIONS(12723), 1,
      sym__lazy,
    ACTIONS(14015), 1,
      anon_sym_LPAREN,
    ACTIONS(14017), 1,
      sym__conid,
    STATE(242), 1,
      sym__unboxed_open,
    STATE(12531), 1,
      sym_constructor,
    STATE(12675), 1,
      sym__pat_constructor,
    STATE(12735), 1,
      sym_variable,
    STATE(12808), 1,
      sym_qualified_constructor,
    STATE(12873), 1,
      sym__qcon,
    STATE(13384), 1,
      sym_literal,
    STATE(14834), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12703), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12697), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12701), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13274), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13117), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [100339] = 21,
    ACTIONS(8779), 1,
      sym__integer_literal,
    ACTIONS(8789), 1,
      sym__conid,
    ACTIONS(8803), 1,
      anon_sym_7,
    ACTIONS(8805), 1,
      sym__splice_dollar,
    ACTIONS(8807), 1,
      sym_quasiquote_start,
    ACTIONS(14392), 1,
      sym__varid,
    ACTIONS(14398), 1,
      anon_sym_LPAREN,
    ACTIONS(14400), 1,
      anon_sym_LBRACK,
    ACTIONS(14402), 1,
      anon_sym_SQUOTE,
    STATE(2132), 1,
      sym__unboxed_open,
    STATE(10210), 1,
      sym_constructor,
    STATE(14816), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14396), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14404), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8781), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14394), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10534), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(10629), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10563), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100433] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [100491] = 26,
    ACTIONS(12695), 1,
      sym__varid,
    ACTIONS(12699), 1,
      sym__integer_literal,
    ACTIONS(12711), 1,
      anon_sym_LBRACK,
    ACTIONS(12713), 1,
      anon_sym__,
    ACTIONS(12715), 1,
      anon_sym_7,
    ACTIONS(12717), 1,
      sym__splice_dollar,
    ACTIONS(12719), 1,
      sym_quasiquote_start,
    ACTIONS(12721), 1,
      sym__strict,
    ACTIONS(12723), 1,
      sym__lazy,
    ACTIONS(14015), 1,
      anon_sym_LPAREN,
    ACTIONS(14017), 1,
      sym__conid,
    STATE(242), 1,
      sym__unboxed_open,
    STATE(12531), 1,
      sym_constructor,
    STATE(12675), 1,
      sym__pat_constructor,
    STATE(12735), 1,
      sym_variable,
    STATE(12808), 1,
      sym_qualified_constructor,
    STATE(12873), 1,
      sym__qcon,
    STATE(13384), 1,
      sym_literal,
    STATE(14834), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12703), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12697), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12701), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13274), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13355), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [100595] = 21,
    ACTIONS(8813), 1,
      sym__integer_literal,
    ACTIONS(8823), 1,
      sym__conid,
    ACTIONS(8837), 1,
      anon_sym_7,
    ACTIONS(8839), 1,
      sym__splice_dollar,
    ACTIONS(8841), 1,
      sym_quasiquote_start,
    ACTIONS(14406), 1,
      sym__varid,
    ACTIONS(14412), 1,
      anon_sym_LPAREN,
    ACTIONS(14414), 1,
      anon_sym_LBRACK,
    ACTIONS(14416), 1,
      anon_sym_SQUOTE,
    STATE(2211), 1,
      sym__unboxed_open,
    STATE(9518), 1,
      sym_constructor,
    STATE(15386), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14410), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14418), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8815), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14408), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9599), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9664), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9785), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100689] = 21,
    ACTIONS(8779), 1,
      sym__integer_literal,
    ACTIONS(8789), 1,
      sym__conid,
    ACTIONS(8803), 1,
      anon_sym_7,
    ACTIONS(8805), 1,
      sym__splice_dollar,
    ACTIONS(8807), 1,
      sym_quasiquote_start,
    ACTIONS(14392), 1,
      sym__varid,
    ACTIONS(14398), 1,
      anon_sym_LPAREN,
    ACTIONS(14400), 1,
      anon_sym_LBRACK,
    ACTIONS(14402), 1,
      anon_sym_SQUOTE,
    STATE(2132), 1,
      sym__unboxed_open,
    STATE(10210), 1,
      sym_constructor,
    STATE(14816), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14396), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14404), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8781), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14394), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10534), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(10629), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11183), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100783] = 21,
    ACTIONS(645), 1,
      sym__integer_literal,
    ACTIONS(667), 1,
      anon_sym_7,
    ACTIONS(669), 1,
      sym__splice_dollar,
    ACTIONS(671), 1,
      sym_quasiquote_start,
    ACTIONS(1698), 1,
      sym__conid,
    ACTIONS(14420), 1,
      sym__varid,
    ACTIONS(14426), 1,
      anon_sym_LPAREN,
    ACTIONS(14428), 1,
      anon_sym_LBRACK,
    ACTIONS(14430), 1,
      anon_sym_SQUOTE,
    STATE(2117), 1,
      sym__unboxed_open,
    STATE(3786), 1,
      sym_constructor,
    STATE(15139), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14424), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14432), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(647), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14422), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3816), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(3842), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3804), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [100877] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [100935] = 26,
    ACTIONS(10786), 1,
      sym__varid,
    ACTIONS(10790), 1,
      sym__integer_literal,
    ACTIONS(10796), 1,
      anon_sym_LPAREN,
    ACTIONS(10801), 1,
      anon_sym_LBRACK,
    ACTIONS(10805), 1,
      anon_sym__,
    ACTIONS(10807), 1,
      anon_sym_7,
    ACTIONS(10809), 1,
      sym__splice_dollar,
    ACTIONS(10811), 1,
      sym_quasiquote_start,
    ACTIONS(10813), 1,
      sym__strict,
    ACTIONS(10815), 1,
      sym__lazy,
    ACTIONS(12785), 1,
      sym__conid,
    STATE(354), 1,
      sym__unboxed_open,
    STATE(8041), 1,
      sym_constructor,
    STATE(8112), 1,
      sym__pat_constructor,
    STATE(8277), 1,
      sym_variable,
    STATE(8307), 1,
      sym_qualified_constructor,
    STATE(8383), 1,
      sym__qcon,
    STATE(8429), 1,
      sym_literal,
    STATE(14715), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10794), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10788), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10792), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8662), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8405), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [101039] = 21,
    ACTIONS(8813), 1,
      sym__integer_literal,
    ACTIONS(8823), 1,
      sym__conid,
    ACTIONS(8837), 1,
      anon_sym_7,
    ACTIONS(8839), 1,
      sym__splice_dollar,
    ACTIONS(8841), 1,
      sym_quasiquote_start,
    ACTIONS(14406), 1,
      sym__varid,
    ACTIONS(14412), 1,
      anon_sym_LPAREN,
    ACTIONS(14414), 1,
      anon_sym_LBRACK,
    ACTIONS(14416), 1,
      anon_sym_SQUOTE,
    STATE(2211), 1,
      sym__unboxed_open,
    STATE(9518), 1,
      sym_constructor,
    STATE(15386), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14410), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14418), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8815), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14408), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9599), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9664), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9628), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [101133] = 21,
    ACTIONS(2949), 1,
      sym__integer_literal,
    ACTIONS(2967), 1,
      anon_sym_7,
    ACTIONS(2969), 1,
      sym__splice_dollar,
    ACTIONS(2971), 1,
      sym_quasiquote_start,
    ACTIONS(4171), 1,
      sym__conid,
    ACTIONS(14434), 1,
      sym__varid,
    ACTIONS(14440), 1,
      anon_sym_LPAREN,
    ACTIONS(14442), 1,
      anon_sym_LBRACK,
    ACTIONS(14444), 1,
      anon_sym_SQUOTE,
    STATE(2207), 1,
      sym__unboxed_open,
    STATE(5332), 1,
      sym_constructor,
    STATE(14611), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14438), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14446), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2951), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14436), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5544), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5625), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5532), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [101227] = 21,
    ACTIONS(645), 1,
      sym__integer_literal,
    ACTIONS(667), 1,
      anon_sym_7,
    ACTIONS(669), 1,
      sym__splice_dollar,
    ACTIONS(671), 1,
      sym_quasiquote_start,
    ACTIONS(1698), 1,
      sym__conid,
    ACTIONS(14420), 1,
      sym__varid,
    ACTIONS(14426), 1,
      anon_sym_LPAREN,
    ACTIONS(14428), 1,
      anon_sym_LBRACK,
    ACTIONS(14430), 1,
      anon_sym_SQUOTE,
    STATE(2117), 1,
      sym__unboxed_open,
    STATE(3786), 1,
      sym_constructor,
    STATE(15139), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14424), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14432), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(647), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14422), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3816), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(3842), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3883), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [101321] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 35,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [101379] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [101437] = 26,
    ACTIONS(11843), 1,
      sym__varid,
    ACTIONS(11847), 1,
      sym__integer_literal,
    ACTIONS(11853), 1,
      anon_sym_LPAREN,
    ACTIONS(11858), 1,
      anon_sym_LBRACK,
    ACTIONS(11862), 1,
      anon_sym__,
    ACTIONS(11864), 1,
      anon_sym_7,
    ACTIONS(11866), 1,
      sym__splice_dollar,
    ACTIONS(11868), 1,
      sym_quasiquote_start,
    ACTIONS(11870), 1,
      sym__strict,
    ACTIONS(11872), 1,
      sym__lazy,
    ACTIONS(12423), 1,
      sym__conid,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(8206), 1,
      sym__pat_constructor,
    STATE(8282), 1,
      sym_constructor,
    STATE(8549), 1,
      sym_qualified_constructor,
    STATE(8605), 1,
      sym_variable,
    STATE(8636), 1,
      sym__qcon,
    STATE(8922), 1,
      sym_literal,
    STATE(15196), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11851), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11845), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11849), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8940), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8909), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [101541] = 26,
    ACTIONS(12345), 1,
      sym__varid,
    ACTIONS(12349), 1,
      sym__integer_literal,
    ACTIONS(12361), 1,
      anon_sym_LBRACK,
    ACTIONS(12363), 1,
      anon_sym__,
    ACTIONS(12365), 1,
      anon_sym_7,
    ACTIONS(12367), 1,
      sym__splice_dollar,
    ACTIONS(12369), 1,
      sym_quasiquote_start,
    ACTIONS(12371), 1,
      sym__strict,
    ACTIONS(12373), 1,
      sym__lazy,
    ACTIONS(13985), 1,
      anon_sym_LPAREN,
    ACTIONS(13987), 1,
      sym__conid,
    STATE(335), 1,
      sym__unboxed_open,
    STATE(12576), 1,
      sym_constructor,
    STATE(12723), 1,
      sym__pat_constructor,
    STATE(12906), 1,
      sym_variable,
    STATE(13025), 1,
      sym_qualified_constructor,
    STATE(13080), 1,
      sym__qcon,
    STATE(13230), 1,
      sym_literal,
    STATE(15422), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12353), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12347), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12351), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13356), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13233), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [101645] = 26,
    ACTIONS(12345), 1,
      sym__varid,
    ACTIONS(12349), 1,
      sym__integer_literal,
    ACTIONS(12361), 1,
      anon_sym_LBRACK,
    ACTIONS(12363), 1,
      anon_sym__,
    ACTIONS(12365), 1,
      anon_sym_7,
    ACTIONS(12367), 1,
      sym__splice_dollar,
    ACTIONS(12369), 1,
      sym_quasiquote_start,
    ACTIONS(12371), 1,
      sym__strict,
    ACTIONS(12373), 1,
      sym__lazy,
    ACTIONS(13985), 1,
      anon_sym_LPAREN,
    ACTIONS(13987), 1,
      sym__conid,
    STATE(335), 1,
      sym__unboxed_open,
    STATE(12576), 1,
      sym_constructor,
    STATE(12723), 1,
      sym__pat_constructor,
    STATE(12906), 1,
      sym_variable,
    STATE(13025), 1,
      sym_qualified_constructor,
    STATE(13080), 1,
      sym__qcon,
    STATE(13230), 1,
      sym_literal,
    STATE(15422), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12353), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12347), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12351), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13356), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13236), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [101749] = 21,
    ACTIONS(2977), 1,
      sym__integer_literal,
    ACTIONS(3008), 1,
      anon_sym_7,
    ACTIONS(3010), 1,
      sym__splice_dollar,
    ACTIONS(3012), 1,
      sym_quasiquote_start,
    ACTIONS(4153), 1,
      sym__conid,
    ACTIONS(14448), 1,
      sym__varid,
    ACTIONS(14454), 1,
      anon_sym_LPAREN,
    ACTIONS(14456), 1,
      anon_sym_LBRACK,
    ACTIONS(14458), 1,
      anon_sym_SQUOTE,
    STATE(2129), 1,
      sym__unboxed_open,
    STATE(4930), 1,
      sym_constructor,
    STATE(15162), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14452), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14460), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2979), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14450), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5701), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5702), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5650), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [101843] = 21,
    ACTIONS(2411), 1,
      sym__integer_literal,
    ACTIONS(2443), 1,
      anon_sym_7,
    ACTIONS(2445), 1,
      sym__splice_dollar,
    ACTIONS(2447), 1,
      sym_quasiquote_start,
    ACTIONS(4211), 1,
      sym__conid,
    ACTIONS(14462), 1,
      sym__varid,
    ACTIONS(14468), 1,
      anon_sym_LPAREN,
    ACTIONS(14470), 1,
      anon_sym_LBRACK,
    ACTIONS(14472), 1,
      anon_sym_SQUOTE,
    STATE(2222), 1,
      sym__unboxed_open,
    STATE(4311), 1,
      sym_constructor,
    STATE(14913), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14466), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14474), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2413), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14464), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4758), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4927), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [101937] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [101995] = 26,
    ACTIONS(10312), 1,
      sym__varid,
    ACTIONS(10316), 1,
      sym__integer_literal,
    ACTIONS(10322), 1,
      anon_sym_LPAREN,
    ACTIONS(10327), 1,
      anon_sym_LBRACK,
    ACTIONS(10331), 1,
      anon_sym__,
    ACTIONS(10333), 1,
      anon_sym_7,
    ACTIONS(10335), 1,
      sym__splice_dollar,
    ACTIONS(10337), 1,
      sym_quasiquote_start,
    ACTIONS(10339), 1,
      sym__strict,
    ACTIONS(10341), 1,
      sym__lazy,
    ACTIONS(12389), 1,
      sym__conid,
    STATE(461), 1,
      sym__unboxed_open,
    STATE(7889), 1,
      sym_constructor,
    STATE(7930), 1,
      sym__pat_constructor,
    STATE(8054), 1,
      sym_qualified_constructor,
    STATE(8069), 1,
      sym_variable,
    STATE(8070), 1,
      sym__qcon,
    STATE(8364), 1,
      sym_literal,
    STATE(14874), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10320), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10314), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10318), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8245), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8207), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [102099] = 26,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(11000), 1,
      sym__varid,
    ACTIONS(11004), 1,
      sym__integer_literal,
    ACTIONS(11010), 1,
      anon_sym_LPAREN,
    ACTIONS(11015), 1,
      anon_sym_LBRACK,
    ACTIONS(11019), 1,
      anon_sym__,
    ACTIONS(11021), 1,
      anon_sym_7,
    ACTIONS(11023), 1,
      sym__splice_dollar,
    ACTIONS(11025), 1,
      sym_quasiquote_start,
    ACTIONS(11027), 1,
      sym__strict,
    ACTIONS(11029), 1,
      sym__lazy,
    STATE(315), 1,
      sym__unboxed_open,
    STATE(7993), 1,
      sym_constructor,
    STATE(8023), 1,
      sym__pat_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(8305), 1,
      sym_variable,
    STATE(8536), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11008), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11002), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11006), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8502), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8625), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [102203] = 21,
    ACTIONS(2977), 1,
      sym__integer_literal,
    ACTIONS(3008), 1,
      anon_sym_7,
    ACTIONS(3010), 1,
      sym__splice_dollar,
    ACTIONS(3012), 1,
      sym_quasiquote_start,
    ACTIONS(4153), 1,
      sym__conid,
    ACTIONS(14448), 1,
      sym__varid,
    ACTIONS(14454), 1,
      anon_sym_LPAREN,
    ACTIONS(14456), 1,
      anon_sym_LBRACK,
    ACTIONS(14458), 1,
      anon_sym_SQUOTE,
    STATE(2129), 1,
      sym__unboxed_open,
    STATE(4930), 1,
      sym_constructor,
    STATE(15162), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14452), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14460), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2979), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14450), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5701), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5702), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5896), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [102297] = 26,
    ACTIONS(11843), 1,
      sym__varid,
    ACTIONS(11847), 1,
      sym__integer_literal,
    ACTIONS(11853), 1,
      anon_sym_LPAREN,
    ACTIONS(11858), 1,
      anon_sym_LBRACK,
    ACTIONS(11862), 1,
      anon_sym__,
    ACTIONS(11864), 1,
      anon_sym_7,
    ACTIONS(11866), 1,
      sym__splice_dollar,
    ACTIONS(11868), 1,
      sym_quasiquote_start,
    ACTIONS(11870), 1,
      sym__strict,
    ACTIONS(11872), 1,
      sym__lazy,
    ACTIONS(12423), 1,
      sym__conid,
    STATE(336), 1,
      sym__unboxed_open,
    STATE(8206), 1,
      sym__pat_constructor,
    STATE(8282), 1,
      sym_constructor,
    STATE(8549), 1,
      sym_qualified_constructor,
    STATE(8605), 1,
      sym_variable,
    STATE(8636), 1,
      sym__qcon,
    STATE(8922), 1,
      sym_literal,
    STATE(15196), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11851), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11845), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11849), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8940), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8913), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [102401] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [102459] = 21,
    ACTIONS(231), 1,
      sym__integer_literal,
    ACTIONS(269), 1,
      anon_sym_7,
    ACTIONS(271), 1,
      sym__splice_dollar,
    ACTIONS(279), 1,
      sym_quasiquote_start,
    ACTIONS(1402), 1,
      sym__conid,
    ACTIONS(14480), 1,
      sym__varid,
    ACTIONS(14486), 1,
      anon_sym_LPAREN,
    ACTIONS(14488), 1,
      anon_sym_LBRACK,
    ACTIONS(14490), 1,
      anon_sym_SQUOTE,
    STATE(2161), 1,
      sym__unboxed_open,
    STATE(3983), 1,
      sym_constructor,
    STATE(15376), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14484), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14492), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(233), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14482), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4166), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4168), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4248), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [102553] = 21,
    ACTIONS(231), 1,
      sym__integer_literal,
    ACTIONS(269), 1,
      anon_sym_7,
    ACTIONS(271), 1,
      sym__splice_dollar,
    ACTIONS(279), 1,
      sym_quasiquote_start,
    ACTIONS(1402), 1,
      sym__conid,
    ACTIONS(14480), 1,
      sym__varid,
    ACTIONS(14486), 1,
      anon_sym_LPAREN,
    ACTIONS(14488), 1,
      anon_sym_LBRACK,
    ACTIONS(14490), 1,
      anon_sym_SQUOTE,
    STATE(2161), 1,
      sym__unboxed_open,
    STATE(3983), 1,
      sym_constructor,
    STATE(15376), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14484), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14492), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(233), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14482), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4166), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4168), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4031), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [102647] = 21,
    ACTIONS(2411), 1,
      sym__integer_literal,
    ACTIONS(2443), 1,
      anon_sym_7,
    ACTIONS(2445), 1,
      sym__splice_dollar,
    ACTIONS(2447), 1,
      sym_quasiquote_start,
    ACTIONS(4211), 1,
      sym__conid,
    ACTIONS(14462), 1,
      sym__varid,
    ACTIONS(14468), 1,
      anon_sym_LPAREN,
    ACTIONS(14470), 1,
      anon_sym_LBRACK,
    ACTIONS(14472), 1,
      anon_sym_SQUOTE,
    STATE(2222), 1,
      sym__unboxed_open,
    STATE(4311), 1,
      sym_constructor,
    STATE(14913), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14466), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14474), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2413), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14464), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4758), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4787), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [102741] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [102799] = 26,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(11000), 1,
      sym__varid,
    ACTIONS(11004), 1,
      sym__integer_literal,
    ACTIONS(11010), 1,
      anon_sym_LPAREN,
    ACTIONS(11015), 1,
      anon_sym_LBRACK,
    ACTIONS(11019), 1,
      anon_sym__,
    ACTIONS(11021), 1,
      anon_sym_7,
    ACTIONS(11023), 1,
      sym__splice_dollar,
    ACTIONS(11025), 1,
      sym_quasiquote_start,
    ACTIONS(11027), 1,
      sym__strict,
    ACTIONS(11029), 1,
      sym__lazy,
    STATE(315), 1,
      sym__unboxed_open,
    STATE(7993), 1,
      sym_constructor,
    STATE(8023), 1,
      sym__pat_constructor,
    STATE(8174), 1,
      sym__qcon,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(8305), 1,
      sym_variable,
    STATE(8536), 1,
      sym_literal,
    STATE(15316), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11008), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11002), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11006), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8502), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8635), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [102903] = 26,
    ACTIONS(661), 1,
      anon_sym__,
    ACTIONS(673), 1,
      sym__strict,
    ACTIONS(675), 1,
      sym__lazy,
    ACTIONS(10559), 1,
      sym__varid,
    ACTIONS(10563), 1,
      sym__integer_literal,
    ACTIONS(10575), 1,
      anon_sym_LBRACK,
    ACTIONS(10577), 1,
      anon_sym_7,
    ACTIONS(10579), 1,
      sym__splice_dollar,
    ACTIONS(10581), 1,
      sym_quasiquote_start,
    ACTIONS(13778), 1,
      anon_sym_LPAREN,
    ACTIONS(13780), 1,
      sym__conid,
    STATE(366), 1,
      sym__unboxed_open,
    STATE(11599), 1,
      sym__pat_constructor,
    STATE(11620), 1,
      sym_constructor,
    STATE(12024), 1,
      sym_variable,
    STATE(12025), 1,
      sym__qcon,
    STATE(12143), 1,
      sym_qualified_constructor,
    STATE(12264), 1,
      sym_literal,
    STATE(14725), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10567), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10561), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12470), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12278), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103007] = 26,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9286), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103111] = 26,
    ACTIONS(13308), 1,
      sym__varid,
    ACTIONS(13312), 1,
      sym__integer_literal,
    ACTIONS(13320), 1,
      anon_sym_LPAREN,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(13324), 1,
      anon_sym_LBRACK,
    ACTIONS(13326), 1,
      anon_sym__,
    ACTIONS(13328), 1,
      anon_sym_7,
    ACTIONS(13330), 1,
      sym__splice_dollar,
    ACTIONS(13332), 1,
      sym_quasiquote_start,
    ACTIONS(13334), 1,
      sym__strict,
    ACTIONS(13336), 1,
      sym__lazy,
    STATE(367), 1,
      sym__unboxed_open,
    STATE(9086), 1,
      sym__pat_constructor,
    STATE(9139), 1,
      sym_constructor,
    STATE(9230), 1,
      sym_variable,
    STATE(9232), 1,
      sym__qcon,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(9248), 1,
      sym_literal,
    STATE(15017), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13316), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(13310), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13314), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9321), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9288), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103215] = 26,
    ACTIONS(11507), 1,
      sym__varid,
    ACTIONS(11511), 1,
      sym__integer_literal,
    ACTIONS(11517), 1,
      anon_sym_LPAREN,
    ACTIONS(11522), 1,
      anon_sym_LBRACK,
    ACTIONS(11526), 1,
      anon_sym__,
    ACTIONS(11528), 1,
      anon_sym_7,
    ACTIONS(11530), 1,
      sym__splice_dollar,
    ACTIONS(11532), 1,
      sym_quasiquote_start,
    ACTIONS(11534), 1,
      sym__strict,
    ACTIONS(11536), 1,
      sym__lazy,
    ACTIONS(12893), 1,
      sym__conid,
    STATE(473), 1,
      sym__unboxed_open,
    STATE(8287), 1,
      sym__pat_constructor,
    STATE(8357), 1,
      sym_constructor,
    STATE(8515), 1,
      sym_variable,
    STATE(8520), 1,
      sym_qualified_constructor,
    STATE(8599), 1,
      sym__qcon,
    STATE(8905), 1,
      sym_literal,
    STATE(14966), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11515), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11509), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11513), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8856), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8969), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103319] = 26,
    ACTIONS(1192), 1,
      anon_sym__,
    ACTIONS(1212), 1,
      sym__strict,
    ACTIONS(1214), 1,
      sym__lazy,
    ACTIONS(12641), 1,
      sym__varid,
    ACTIONS(12645), 1,
      sym__integer_literal,
    ACTIONS(12657), 1,
      anon_sym_LBRACK,
    ACTIONS(12659), 1,
      anon_sym_7,
    ACTIONS(12661), 1,
      sym__splice_dollar,
    ACTIONS(12663), 1,
      sym_quasiquote_start,
    ACTIONS(13921), 1,
      anon_sym_LPAREN,
    ACTIONS(13923), 1,
      sym__conid,
    STATE(459), 1,
      sym__unboxed_open,
    STATE(12594), 1,
      sym__pat_constructor,
    STATE(12717), 1,
      sym_constructor,
    STATE(12730), 1,
      sym_qualified_constructor,
    STATE(13094), 1,
      sym_variable,
    STATE(13095), 1,
      sym__qcon,
    STATE(13249), 1,
      sym_literal,
    STATE(14609), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12649), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12643), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12647), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13328), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13129), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103423] = 26,
    ACTIONS(557), 1,
      anon_sym__,
    ACTIONS(579), 1,
      sym__strict,
    ACTIONS(581), 1,
      sym__lazy,
    ACTIONS(12375), 1,
      sym__varid,
    ACTIONS(12379), 1,
      sym__integer_literal,
    ACTIONS(12391), 1,
      anon_sym_LBRACK,
    ACTIONS(12393), 1,
      anon_sym_7,
    ACTIONS(12395), 1,
      sym__splice_dollar,
    ACTIONS(12397), 1,
      sym_quasiquote_start,
    ACTIONS(13939), 1,
      anon_sym_LPAREN,
    ACTIONS(13941), 1,
      sym__conid,
    STATE(462), 1,
      sym__unboxed_open,
    STATE(12358), 1,
      sym_constructor,
    STATE(12487), 1,
      sym__pat_constructor,
    STATE(12510), 1,
      sym__qcon,
    STATE(12516), 1,
      sym_variable,
    STATE(12679), 1,
      sym_qualified_constructor,
    STATE(12754), 1,
      sym_literal,
    STATE(14733), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12383), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12377), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12381), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13060), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(12943), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103527] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [103585] = 26,
    ACTIONS(10525), 1,
      sym__varid,
    ACTIONS(10531), 1,
      sym__integer_literal,
    ACTIONS(10543), 1,
      anon_sym_LBRACK,
    ACTIONS(10547), 1,
      anon_sym__,
    ACTIONS(10549), 1,
      anon_sym_7,
    ACTIONS(10551), 1,
      sym__splice_dollar,
    ACTIONS(10553), 1,
      sym_quasiquote_start,
    ACTIONS(10555), 1,
      sym__strict,
    ACTIONS(10557), 1,
      sym__lazy,
    ACTIONS(13770), 1,
      anon_sym_LPAREN,
    ACTIONS(13772), 1,
      sym__conid,
    STATE(416), 1,
      sym__unboxed_open,
    STATE(12587), 1,
      sym_constructor,
    STATE(12720), 1,
      sym__pat_constructor,
    STATE(12782), 1,
      sym__qcon,
    STATE(13035), 1,
      sym_variable,
    STATE(13075), 1,
      sym_qualified_constructor,
    STATE(13142), 1,
      sym_literal,
    STATE(15349), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10535), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10529), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10533), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13378), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13335), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [103689] = 21,
    ACTIONS(8715), 1,
      sym__integer_literal,
    ACTIONS(8725), 1,
      sym__conid,
    ACTIONS(8739), 1,
      anon_sym_7,
    ACTIONS(8741), 1,
      sym__splice_dollar,
    ACTIONS(8743), 1,
      sym_quasiquote_start,
    ACTIONS(14494), 1,
      sym__varid,
    ACTIONS(14500), 1,
      anon_sym_LPAREN,
    ACTIONS(14502), 1,
      anon_sym_LBRACK,
    ACTIONS(14504), 1,
      anon_sym_SQUOTE,
    STATE(2181), 1,
      sym__unboxed_open,
    STATE(10417), 1,
      sym_constructor,
    STATE(14873), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14498), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14506), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8717), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14496), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11226), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11347), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11627), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [103783] = 21,
    ACTIONS(8466), 1,
      sym__integer_literal,
    ACTIONS(8476), 1,
      sym__conid,
    ACTIONS(8490), 1,
      anon_sym_7,
    ACTIONS(8492), 1,
      sym__splice_dollar,
    ACTIONS(8494), 1,
      sym_quasiquote_start,
    ACTIONS(14508), 1,
      sym__varid,
    ACTIONS(14514), 1,
      anon_sym_LPAREN,
    ACTIONS(14516), 1,
      anon_sym_LBRACK,
    ACTIONS(14518), 1,
      anon_sym_SQUOTE,
    STATE(2205), 1,
      sym__unboxed_open,
    STATE(10223), 1,
      sym_constructor,
    STATE(15372), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14512), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14520), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8468), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14510), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10444), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(10490), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11192), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [103877] = 21,
    ACTIONS(14522), 1,
      sym__varid,
    ACTIONS(14526), 1,
      sym__integer_literal,
    ACTIONS(14532), 1,
      anon_sym_LPAREN,
    ACTIONS(14534), 1,
      sym__conid,
    ACTIONS(14536), 1,
      anon_sym_LBRACK,
    ACTIONS(14538), 1,
      anon_sym_SQUOTE,
    ACTIONS(14542), 1,
      anon_sym_7,
    ACTIONS(14544), 1,
      sym__splice_dollar,
    ACTIONS(14546), 1,
      sym_quasiquote_start,
    STATE(2226), 1,
      sym__unboxed_open,
    STATE(13572), 1,
      sym_constructor,
    STATE(15298), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14530), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14540), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(14524), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14528), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14273), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14285), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(14196), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [103971] = 21,
    ACTIONS(14522), 1,
      sym__varid,
    ACTIONS(14526), 1,
      sym__integer_literal,
    ACTIONS(14532), 1,
      anon_sym_LPAREN,
    ACTIONS(14534), 1,
      sym__conid,
    ACTIONS(14536), 1,
      anon_sym_LBRACK,
    ACTIONS(14538), 1,
      anon_sym_SQUOTE,
    ACTIONS(14542), 1,
      anon_sym_7,
    ACTIONS(14544), 1,
      sym__splice_dollar,
    ACTIONS(14546), 1,
      sym_quasiquote_start,
    STATE(2226), 1,
      sym__unboxed_open,
    STATE(13572), 1,
      sym_constructor,
    STATE(15298), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14530), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14540), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(14524), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14528), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14273), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(14285), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(14182), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [104065] = 26,
    ACTIONS(11558), 1,
      sym__varid,
    ACTIONS(11562), 1,
      sym__integer_literal,
    ACTIONS(11568), 1,
      anon_sym_LPAREN,
    ACTIONS(11573), 1,
      anon_sym_LBRACK,
    ACTIONS(11577), 1,
      anon_sym__,
    ACTIONS(11579), 1,
      anon_sym_7,
    ACTIONS(11581), 1,
      sym__splice_dollar,
    ACTIONS(11583), 1,
      sym_quasiquote_start,
    ACTIONS(11585), 1,
      sym__strict,
    ACTIONS(11587), 1,
      sym__lazy,
    ACTIONS(12537), 1,
      sym__conid,
    STATE(476), 1,
      sym__unboxed_open,
    STATE(8298), 1,
      sym_constructor,
    STATE(8301), 1,
      sym__pat_constructor,
    STATE(8535), 1,
      sym__qcon,
    STATE(8545), 1,
      sym_qualified_constructor,
    STATE(8609), 1,
      sym_variable,
    STATE(8853), 1,
      sym_literal,
    STATE(15198), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11566), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11560), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11564), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8846), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8804), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [104169] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [104229] = 21,
    ACTIONS(1704), 1,
      sym__integer_literal,
    ACTIONS(1735), 1,
      anon_sym_7,
    ACTIONS(1737), 1,
      sym__splice_dollar,
    ACTIONS(1739), 1,
      sym_quasiquote_start,
    ACTIONS(4205), 1,
      sym__conid,
    ACTIONS(14552), 1,
      sym__varid,
    ACTIONS(14558), 1,
      anon_sym_LPAREN,
    ACTIONS(14560), 1,
      anon_sym_LBRACK,
    ACTIONS(14562), 1,
      anon_sym_SQUOTE,
    STATE(2186), 1,
      sym__unboxed_open,
    STATE(3891), 1,
      sym_constructor,
    STATE(15054), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14556), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14564), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(1706), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14554), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3984), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(3985), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4100), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [104323] = 21,
    ACTIONS(885), 1,
      sym__integer_literal,
    ACTIONS(903), 1,
      anon_sym_7,
    ACTIONS(905), 1,
      sym__splice_dollar,
    ACTIONS(907), 1,
      sym_quasiquote_start,
    ACTIONS(4289), 1,
      sym__conid,
    ACTIONS(14566), 1,
      sym__varid,
    ACTIONS(14572), 1,
      anon_sym_LPAREN,
    ACTIONS(14574), 1,
      anon_sym_LBRACK,
    ACTIONS(14576), 1,
      anon_sym_SQUOTE,
    STATE(2125), 1,
      sym__unboxed_open,
    STATE(5071), 1,
      sym_constructor,
    STATE(15340), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14570), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14578), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(887), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14568), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5653), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5655), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5654), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [104417] = 21,
    ACTIONS(885), 1,
      sym__integer_literal,
    ACTIONS(903), 1,
      anon_sym_7,
    ACTIONS(905), 1,
      sym__splice_dollar,
    ACTIONS(907), 1,
      sym_quasiquote_start,
    ACTIONS(4289), 1,
      sym__conid,
    ACTIONS(14566), 1,
      sym__varid,
    ACTIONS(14572), 1,
      anon_sym_LPAREN,
    ACTIONS(14574), 1,
      anon_sym_LBRACK,
    ACTIONS(14576), 1,
      anon_sym_SQUOTE,
    STATE(2125), 1,
      sym__unboxed_open,
    STATE(5071), 1,
      sym_constructor,
    STATE(15340), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14570), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14578), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(887), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14568), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5653), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5655), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5872), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [104511] = 26,
    ACTIONS(9701), 1,
      sym__varid,
    ACTIONS(9707), 1,
      sym__integer_literal,
    ACTIONS(9713), 1,
      anon_sym_LPAREN,
    ACTIONS(9718), 1,
      anon_sym_LBRACK,
    ACTIONS(9722), 1,
      anon_sym__,
    ACTIONS(9724), 1,
      anon_sym_7,
    ACTIONS(9726), 1,
      sym__splice_dollar,
    ACTIONS(9728), 1,
      sym_quasiquote_start,
    ACTIONS(9730), 1,
      sym__strict,
    ACTIONS(9732), 1,
      sym__lazy,
    ACTIONS(10573), 1,
      sym__conid,
    STATE(350), 1,
      sym__unboxed_open,
    STATE(7601), 1,
      sym__pat_constructor,
    STATE(7661), 1,
      sym_constructor,
    STATE(7726), 1,
      sym_variable,
    STATE(7780), 1,
      sym_qualified_constructor,
    STATE(7820), 1,
      sym__qcon,
    STATE(7932), 1,
      sym_literal,
    STATE(14862), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9711), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(9705), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(9709), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7924), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(7897), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [104615] = 21,
    ACTIONS(2949), 1,
      sym__integer_literal,
    ACTIONS(2967), 1,
      anon_sym_7,
    ACTIONS(2969), 1,
      sym__splice_dollar,
    ACTIONS(2971), 1,
      sym_quasiquote_start,
    ACTIONS(4171), 1,
      sym__conid,
    ACTIONS(14434), 1,
      sym__varid,
    ACTIONS(14440), 1,
      anon_sym_LPAREN,
    ACTIONS(14442), 1,
      anon_sym_LBRACK,
    ACTIONS(14444), 1,
      anon_sym_SQUOTE,
    STATE(2207), 1,
      sym__unboxed_open,
    STATE(5332), 1,
      sym_constructor,
    STATE(14611), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14438), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14446), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2951), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14436), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5544), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(5625), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(5918), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [104709] = 21,
    ACTIONS(1704), 1,
      sym__integer_literal,
    ACTIONS(1735), 1,
      anon_sym_7,
    ACTIONS(1737), 1,
      sym__splice_dollar,
    ACTIONS(1739), 1,
      sym_quasiquote_start,
    ACTIONS(4205), 1,
      sym__conid,
    ACTIONS(14552), 1,
      sym__varid,
    ACTIONS(14558), 1,
      anon_sym_LPAREN,
    ACTIONS(14560), 1,
      anon_sym_LBRACK,
    ACTIONS(14562), 1,
      anon_sym_SQUOTE,
    STATE(2186), 1,
      sym__unboxed_open,
    STATE(3891), 1,
      sym_constructor,
    STATE(15054), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14556), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14564), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(1706), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14554), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3984), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(3985), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3916), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [104803] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [104861] = 21,
    ACTIONS(8715), 1,
      sym__integer_literal,
    ACTIONS(8725), 1,
      sym__conid,
    ACTIONS(8739), 1,
      anon_sym_7,
    ACTIONS(8741), 1,
      sym__splice_dollar,
    ACTIONS(8743), 1,
      sym_quasiquote_start,
    ACTIONS(14494), 1,
      sym__varid,
    ACTIONS(14500), 1,
      anon_sym_LPAREN,
    ACTIONS(14502), 1,
      anon_sym_LBRACK,
    ACTIONS(14504), 1,
      anon_sym_SQUOTE,
    STATE(2181), 1,
      sym__unboxed_open,
    STATE(10417), 1,
      sym_constructor,
    STATE(14873), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14498), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14506), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8717), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14496), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11226), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11347), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11464), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [104955] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [105013] = 21,
    ACTIONS(4341), 1,
      sym__integer_literal,
    ACTIONS(4349), 1,
      sym__conid,
    ACTIONS(4353), 1,
      anon_sym_7,
    ACTIONS(4355), 1,
      sym__splice_dollar,
    ACTIONS(4357), 1,
      sym_quasiquote_start,
    ACTIONS(14580), 1,
      sym__varid,
    ACTIONS(14586), 1,
      anon_sym_LPAREN,
    ACTIONS(14588), 1,
      anon_sym_LBRACK,
    ACTIONS(14590), 1,
      anon_sym_SQUOTE,
    STATE(2124), 1,
      sym__unboxed_open,
    STATE(10562), 1,
      sym_constructor,
    STATE(14716), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14584), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14592), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4343), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14582), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11180), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11182), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11346), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [105107] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 35,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [105165] = 26,
    ACTIONS(10786), 1,
      sym__varid,
    ACTIONS(10790), 1,
      sym__integer_literal,
    ACTIONS(10796), 1,
      anon_sym_LPAREN,
    ACTIONS(10801), 1,
      anon_sym_LBRACK,
    ACTIONS(10805), 1,
      anon_sym__,
    ACTIONS(10807), 1,
      anon_sym_7,
    ACTIONS(10809), 1,
      sym__splice_dollar,
    ACTIONS(10811), 1,
      sym_quasiquote_start,
    ACTIONS(10813), 1,
      sym__strict,
    ACTIONS(10815), 1,
      sym__lazy,
    ACTIONS(12785), 1,
      sym__conid,
    STATE(354), 1,
      sym__unboxed_open,
    STATE(8041), 1,
      sym_constructor,
    STATE(8112), 1,
      sym__pat_constructor,
    STATE(8277), 1,
      sym_variable,
    STATE(8307), 1,
      sym_qualified_constructor,
    STATE(8383), 1,
      sym__qcon,
    STATE(8429), 1,
      sym_literal,
    STATE(14715), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10794), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10788), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10792), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8662), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8408), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105269] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [105329] = 21,
    ACTIONS(4341), 1,
      sym__integer_literal,
    ACTIONS(4349), 1,
      sym__conid,
    ACTIONS(4353), 1,
      anon_sym_7,
    ACTIONS(4355), 1,
      sym__splice_dollar,
    ACTIONS(4357), 1,
      sym_quasiquote_start,
    ACTIONS(14580), 1,
      sym__varid,
    ACTIONS(14586), 1,
      anon_sym_LPAREN,
    ACTIONS(14588), 1,
      anon_sym_LBRACK,
    ACTIONS(14590), 1,
      anon_sym_SQUOTE,
    STATE(2124), 1,
      sym__unboxed_open,
    STATE(10562), 1,
      sym_constructor,
    STATE(14716), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14584), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14592), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4343), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14582), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11180), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11182), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11859), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [105423] = 26,
    ACTIONS(11128), 1,
      sym__varid,
    ACTIONS(11132), 1,
      sym__integer_literal,
    ACTIONS(11138), 1,
      anon_sym_LPAREN,
    ACTIONS(11143), 1,
      anon_sym_LBRACK,
    ACTIONS(11147), 1,
      anon_sym__,
    ACTIONS(11149), 1,
      anon_sym_7,
    ACTIONS(11151), 1,
      sym__splice_dollar,
    ACTIONS(11153), 1,
      sym_quasiquote_start,
    ACTIONS(11155), 1,
      sym__strict,
    ACTIONS(11157), 1,
      sym__lazy,
    ACTIONS(12709), 1,
      sym__conid,
    STATE(423), 1,
      sym__unboxed_open,
    STATE(7943), 1,
      sym__pat_constructor,
    STATE(8116), 1,
      sym_constructor,
    STATE(8182), 1,
      sym__qcon,
    STATE(8187), 1,
      sym_variable,
    STATE(8271), 1,
      sym_qualified_constructor,
    STATE(8588), 1,
      sym_literal,
    STATE(14857), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11136), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11130), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11134), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8600), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8560), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105527] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [105585] = 21,
    ACTIONS(2309), 1,
      sym__integer_literal,
    ACTIONS(2340), 1,
      anon_sym_7,
    ACTIONS(2342), 1,
      sym__splice_dollar,
    ACTIONS(2344), 1,
      sym_quasiquote_start,
    ACTIONS(4267), 1,
      sym__conid,
    ACTIONS(14193), 1,
      sym__varid,
    ACTIONS(14199), 1,
      anon_sym_LPAREN,
    ACTIONS(14201), 1,
      anon_sym_LBRACK,
    ACTIONS(14203), 1,
      anon_sym_SQUOTE,
    STATE(2154), 1,
      sym__unboxed_open,
    STATE(4306), 1,
      sym_constructor,
    STATE(14943), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14197), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14205), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(2311), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14195), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4590), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(4592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(4633), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [105679] = 26,
    ACTIONS(11128), 1,
      sym__varid,
    ACTIONS(11132), 1,
      sym__integer_literal,
    ACTIONS(11138), 1,
      anon_sym_LPAREN,
    ACTIONS(11143), 1,
      anon_sym_LBRACK,
    ACTIONS(11147), 1,
      anon_sym__,
    ACTIONS(11149), 1,
      anon_sym_7,
    ACTIONS(11151), 1,
      sym__splice_dollar,
    ACTIONS(11153), 1,
      sym_quasiquote_start,
    ACTIONS(11155), 1,
      sym__strict,
    ACTIONS(11157), 1,
      sym__lazy,
    ACTIONS(12709), 1,
      sym__conid,
    STATE(423), 1,
      sym__unboxed_open,
    STATE(7943), 1,
      sym__pat_constructor,
    STATE(8116), 1,
      sym_constructor,
    STATE(8182), 1,
      sym__qcon,
    STATE(8187), 1,
      sym_variable,
    STATE(8271), 1,
      sym_qualified_constructor,
    STATE(8588), 1,
      sym_literal,
    STATE(14857), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11136), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11130), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11134), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8600), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8555), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105783] = 26,
    ACTIONS(10829), 1,
      sym__varid,
    ACTIONS(10833), 1,
      sym__integer_literal,
    ACTIONS(10839), 1,
      anon_sym_LPAREN,
    ACTIONS(10844), 1,
      anon_sym_LBRACK,
    ACTIONS(10848), 1,
      anon_sym__,
    ACTIONS(10850), 1,
      anon_sym_7,
    ACTIONS(10852), 1,
      sym__splice_dollar,
    ACTIONS(10854), 1,
      sym_quasiquote_start,
    ACTIONS(10856), 1,
      sym__strict,
    ACTIONS(10858), 1,
      sym__lazy,
    ACTIONS(12359), 1,
      sym__conid,
    STATE(417), 1,
      sym__unboxed_open,
    STATE(8050), 1,
      sym__pat_constructor,
    STATE(8096), 1,
      sym_constructor,
    STATE(8157), 1,
      sym_variable,
    STATE(8280), 1,
      sym__qcon,
    STATE(8294), 1,
      sym_qualified_constructor,
    STATE(8722), 1,
      sym_literal,
    STATE(15081), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10837), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10831), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10835), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8434), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8724), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105887] = 26,
    ACTIONS(12409), 1,
      sym__varid,
    ACTIONS(12413), 1,
      sym__integer_literal,
    ACTIONS(12425), 1,
      anon_sym_LBRACK,
    ACTIONS(12427), 1,
      anon_sym__,
    ACTIONS(12429), 1,
      anon_sym_7,
    ACTIONS(12431), 1,
      sym__splice_dollar,
    ACTIONS(12433), 1,
      sym_quasiquote_start,
    ACTIONS(12435), 1,
      sym__strict,
    ACTIONS(12437), 1,
      sym__lazy,
    ACTIONS(13819), 1,
      anon_sym_LPAREN,
    ACTIONS(13821), 1,
      sym__conid,
    STATE(246), 1,
      sym__unboxed_open,
    STATE(12769), 1,
      sym_constructor,
    STATE(12956), 1,
      sym__pat_constructor,
    STATE(13103), 1,
      sym__qcon,
    STATE(13254), 1,
      sym_variable,
    STATE(13359), 1,
      sym_qualified_constructor,
    STATE(13703), 1,
      sym_literal,
    STATE(15353), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12417), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12411), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12415), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13394), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13702), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [105991] = 26,
    ACTIONS(12409), 1,
      sym__varid,
    ACTIONS(12413), 1,
      sym__integer_literal,
    ACTIONS(12425), 1,
      anon_sym_LBRACK,
    ACTIONS(12427), 1,
      anon_sym__,
    ACTIONS(12429), 1,
      anon_sym_7,
    ACTIONS(12431), 1,
      sym__splice_dollar,
    ACTIONS(12433), 1,
      sym_quasiquote_start,
    ACTIONS(12435), 1,
      sym__strict,
    ACTIONS(12437), 1,
      sym__lazy,
    ACTIONS(13819), 1,
      anon_sym_LPAREN,
    ACTIONS(13821), 1,
      sym__conid,
    STATE(246), 1,
      sym__unboxed_open,
    STATE(12769), 1,
      sym_constructor,
    STATE(12956), 1,
      sym__pat_constructor,
    STATE(13103), 1,
      sym__qcon,
    STATE(13254), 1,
      sym_variable,
    STATE(13359), 1,
      sym_qualified_constructor,
    STATE(13703), 1,
      sym_literal,
    STATE(15353), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12417), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12411), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12415), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13394), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13701), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106095] = 26,
    ACTIONS(11507), 1,
      sym__varid,
    ACTIONS(11511), 1,
      sym__integer_literal,
    ACTIONS(11517), 1,
      anon_sym_LPAREN,
    ACTIONS(11522), 1,
      anon_sym_LBRACK,
    ACTIONS(11526), 1,
      anon_sym__,
    ACTIONS(11528), 1,
      anon_sym_7,
    ACTIONS(11530), 1,
      sym__splice_dollar,
    ACTIONS(11532), 1,
      sym_quasiquote_start,
    ACTIONS(11534), 1,
      sym__strict,
    ACTIONS(11536), 1,
      sym__lazy,
    ACTIONS(12893), 1,
      sym__conid,
    STATE(473), 1,
      sym__unboxed_open,
    STATE(8287), 1,
      sym__pat_constructor,
    STATE(8357), 1,
      sym_constructor,
    STATE(8515), 1,
      sym_variable,
    STATE(8520), 1,
      sym_qualified_constructor,
    STATE(8599), 1,
      sym__qcon,
    STATE(8905), 1,
      sym_literal,
    STATE(14966), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11515), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11509), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11513), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8856), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8906), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106199] = 21,
    ACTIONS(87), 1,
      sym__integer_literal,
    ACTIONS(143), 1,
      anon_sym_7,
    ACTIONS(145), 1,
      sym__splice_dollar,
    ACTIONS(147), 1,
      sym_quasiquote_start,
    ACTIONS(4087), 1,
      sym__conid,
    ACTIONS(14596), 1,
      sym__varid,
    ACTIONS(14602), 1,
      anon_sym_LPAREN,
    ACTIONS(14604), 1,
      anon_sym_LBRACK,
    ACTIONS(14606), 1,
      anon_sym_SQUOTE,
    STATE(2179), 1,
      sym__unboxed_open,
    STATE(3705), 1,
      sym_constructor,
    STATE(15195), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14600), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14608), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(89), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14598), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3740), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(3745), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3750), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [106293] = 26,
    ACTIONS(11507), 1,
      sym__varid,
    ACTIONS(11511), 1,
      sym__integer_literal,
    ACTIONS(11517), 1,
      anon_sym_LPAREN,
    ACTIONS(11522), 1,
      anon_sym_LBRACK,
    ACTIONS(11526), 1,
      anon_sym__,
    ACTIONS(11528), 1,
      anon_sym_7,
    ACTIONS(11530), 1,
      sym__splice_dollar,
    ACTIONS(11532), 1,
      sym_quasiquote_start,
    ACTIONS(11534), 1,
      sym__strict,
    ACTIONS(11536), 1,
      sym__lazy,
    ACTIONS(12893), 1,
      sym__conid,
    STATE(473), 1,
      sym__unboxed_open,
    STATE(8287), 1,
      sym__pat_constructor,
    STATE(8357), 1,
      sym_constructor,
    STATE(8515), 1,
      sym_variable,
    STATE(8520), 1,
      sym_qualified_constructor,
    STATE(8599), 1,
      sym__qcon,
    STATE(8905), 1,
      sym_literal,
    STATE(14966), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11515), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(11509), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11513), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8856), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8911), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106397] = 26,
    ACTIONS(10829), 1,
      sym__varid,
    ACTIONS(10833), 1,
      sym__integer_literal,
    ACTIONS(10839), 1,
      anon_sym_LPAREN,
    ACTIONS(10844), 1,
      anon_sym_LBRACK,
    ACTIONS(10848), 1,
      anon_sym__,
    ACTIONS(10850), 1,
      anon_sym_7,
    ACTIONS(10852), 1,
      sym__splice_dollar,
    ACTIONS(10854), 1,
      sym_quasiquote_start,
    ACTIONS(10856), 1,
      sym__strict,
    ACTIONS(10858), 1,
      sym__lazy,
    ACTIONS(12359), 1,
      sym__conid,
    STATE(417), 1,
      sym__unboxed_open,
    STATE(8050), 1,
      sym__pat_constructor,
    STATE(8096), 1,
      sym_constructor,
    STATE(8157), 1,
      sym_variable,
    STATE(8280), 1,
      sym__qcon,
    STATE(8294), 1,
      sym_qualified_constructor,
    STATE(8722), 1,
      sym_literal,
    STATE(15081), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10837), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10831), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10835), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8434), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8695), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106501] = 26,
    ACTIONS(1378), 1,
      anon_sym__,
    ACTIONS(1386), 1,
      sym__strict,
    ACTIONS(1388), 1,
      sym__lazy,
    ACTIONS(12771), 1,
      sym__varid,
    ACTIONS(12775), 1,
      sym__integer_literal,
    ACTIONS(12787), 1,
      anon_sym_LBRACK,
    ACTIONS(12789), 1,
      anon_sym_7,
    ACTIONS(12791), 1,
      sym__splice_dollar,
    ACTIONS(12793), 1,
      sym_quasiquote_start,
    ACTIONS(14033), 1,
      anon_sym_LPAREN,
    ACTIONS(14035), 1,
      sym__conid,
    STATE(263), 1,
      sym__unboxed_open,
    STATE(12540), 1,
      sym_constructor,
    STATE(12544), 1,
      sym__pat_constructor,
    STATE(12828), 1,
      sym_qualified_constructor,
    STATE(12874), 1,
      sym_variable,
    STATE(13029), 1,
      sym__qcon,
    STATE(13152), 1,
      sym_literal,
    STATE(14631), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12779), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13099), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13374), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106605] = 26,
    ACTIONS(12523), 1,
      sym__varid,
    ACTIONS(12527), 1,
      sym__integer_literal,
    ACTIONS(12539), 1,
      anon_sym_LBRACK,
    ACTIONS(12541), 1,
      anon_sym__,
    ACTIONS(12543), 1,
      anon_sym_7,
    ACTIONS(12545), 1,
      sym__splice_dollar,
    ACTIONS(12547), 1,
      sym_quasiquote_start,
    ACTIONS(12549), 1,
      sym__strict,
    ACTIONS(12551), 1,
      sym__lazy,
    ACTIONS(13730), 1,
      anon_sym_LPAREN,
    ACTIONS(13732), 1,
      sym__conid,
    STATE(316), 1,
      sym__unboxed_open,
    STATE(12839), 1,
      sym_constructor,
    STATE(13032), 1,
      sym__pat_constructor,
    STATE(13179), 1,
      sym__qcon,
    STATE(13258), 1,
      sym_variable,
    STATE(13272), 1,
      sym_qualified_constructor,
    STATE(13742), 1,
      sym_literal,
    STATE(15014), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12531), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12525), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12529), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13590), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13827), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106709] = 21,
    ACTIONS(87), 1,
      sym__integer_literal,
    ACTIONS(143), 1,
      anon_sym_7,
    ACTIONS(145), 1,
      sym__splice_dollar,
    ACTIONS(147), 1,
      sym_quasiquote_start,
    ACTIONS(4087), 1,
      sym__conid,
    ACTIONS(14596), 1,
      sym__varid,
    ACTIONS(14602), 1,
      anon_sym_LPAREN,
    ACTIONS(14604), 1,
      anon_sym_LBRACK,
    ACTIONS(14606), 1,
      anon_sym_SQUOTE,
    STATE(2179), 1,
      sym__unboxed_open,
    STATE(3705), 1,
      sym_constructor,
    STATE(15195), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14600), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14608), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(89), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14598), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3740), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(3745), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(3825), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [106803] = 26,
    ACTIONS(12695), 1,
      sym__varid,
    ACTIONS(12699), 1,
      sym__integer_literal,
    ACTIONS(12711), 1,
      anon_sym_LBRACK,
    ACTIONS(12713), 1,
      anon_sym__,
    ACTIONS(12715), 1,
      anon_sym_7,
    ACTIONS(12717), 1,
      sym__splice_dollar,
    ACTIONS(12719), 1,
      sym_quasiquote_start,
    ACTIONS(12721), 1,
      sym__strict,
    ACTIONS(12723), 1,
      sym__lazy,
    ACTIONS(14015), 1,
      anon_sym_LPAREN,
    ACTIONS(14017), 1,
      sym__conid,
    STATE(242), 1,
      sym__unboxed_open,
    STATE(12531), 1,
      sym_constructor,
    STATE(12675), 1,
      sym__pat_constructor,
    STATE(12735), 1,
      sym_variable,
    STATE(12808), 1,
      sym_qualified_constructor,
    STATE(12873), 1,
      sym__qcon,
    STATE(13384), 1,
      sym_literal,
    STATE(14834), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12703), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12697), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12701), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13274), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13188), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [106907] = 21,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(4321), 1,
      sym__conid,
    ACTIONS(4325), 1,
      anon_sym_7,
    ACTIONS(4327), 1,
      sym__splice_dollar,
    ACTIONS(4329), 1,
      sym_quasiquote_start,
    ACTIONS(14610), 1,
      sym__varid,
    ACTIONS(14616), 1,
      anon_sym_LPAREN,
    ACTIONS(14618), 1,
      anon_sym_LBRACK,
    ACTIONS(14620), 1,
      anon_sym_SQUOTE,
    STATE(2119), 1,
      sym__unboxed_open,
    STATE(9424), 1,
      sym_constructor,
    STATE(14727), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14614), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14622), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14612), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9448), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9496), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9519), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [107001] = 26,
    ACTIONS(12523), 1,
      sym__varid,
    ACTIONS(12527), 1,
      sym__integer_literal,
    ACTIONS(12539), 1,
      anon_sym_LBRACK,
    ACTIONS(12541), 1,
      anon_sym__,
    ACTIONS(12543), 1,
      anon_sym_7,
    ACTIONS(12545), 1,
      sym__splice_dollar,
    ACTIONS(12547), 1,
      sym_quasiquote_start,
    ACTIONS(12549), 1,
      sym__strict,
    ACTIONS(12551), 1,
      sym__lazy,
    ACTIONS(13730), 1,
      anon_sym_LPAREN,
    ACTIONS(13732), 1,
      sym__conid,
    STATE(316), 1,
      sym__unboxed_open,
    STATE(12839), 1,
      sym_constructor,
    STATE(13032), 1,
      sym__pat_constructor,
    STATE(13179), 1,
      sym__qcon,
    STATE(13258), 1,
      sym_variable,
    STATE(13272), 1,
      sym_qualified_constructor,
    STATE(13742), 1,
      sym_literal,
    STATE(15014), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12531), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(12525), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12529), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13590), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(13830), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [107105] = 21,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(4321), 1,
      sym__conid,
    ACTIONS(4325), 1,
      anon_sym_7,
    ACTIONS(4327), 1,
      sym__splice_dollar,
    ACTIONS(4329), 1,
      sym_quasiquote_start,
    ACTIONS(14610), 1,
      sym__varid,
    ACTIONS(14616), 1,
      anon_sym_LPAREN,
    ACTIONS(14618), 1,
      anon_sym_LBRACK,
    ACTIONS(14620), 1,
      anon_sym_SQUOTE,
    STATE(2119), 1,
      sym__unboxed_open,
    STATE(9424), 1,
      sym_constructor,
    STATE(14727), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14614), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14622), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14612), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9448), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(9496), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(9445), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [107199] = 21,
    ACTIONS(4555), 1,
      sym__integer_literal,
    ACTIONS(4565), 1,
      sym__conid,
    ACTIONS(4579), 1,
      anon_sym_7,
    ACTIONS(4581), 1,
      sym__splice_dollar,
    ACTIONS(4583), 1,
      sym_quasiquote_start,
    ACTIONS(14624), 1,
      sym__varid,
    ACTIONS(14630), 1,
      anon_sym_LPAREN,
    ACTIONS(14632), 1,
      anon_sym_LBRACK,
    ACTIONS(14634), 1,
      anon_sym_SQUOTE,
    STATE(2153), 1,
      sym__unboxed_open,
    STATE(10547), 1,
      sym_constructor,
    STATE(15240), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14628), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14636), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4557), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14626), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11196), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11197), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11937), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [107293] = 21,
    ACTIONS(10970), 1,
      sym__integer_literal,
    ACTIONS(10976), 1,
      anon_sym_LPAREN,
    ACTIONS(10978), 1,
      sym__conid,
    ACTIONS(10980), 1,
      anon_sym_LBRACK,
    ACTIONS(10982), 1,
      anon_sym_SQUOTE,
    ACTIONS(10986), 1,
      anon_sym_7,
    ACTIONS(10988), 1,
      sym__splice_dollar,
    ACTIONS(10990), 1,
      sym_quasiquote_start,
    ACTIONS(14638), 1,
      sym__varid,
    STATE(2196), 1,
      sym__unboxed_open,
    STATE(8398), 1,
      sym_constructor,
    STATE(15075), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10974), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10984), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10968), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8404), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8413), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8522), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [107387] = 21,
    ACTIONS(10563), 1,
      sym__integer_literal,
    ACTIONS(10577), 1,
      anon_sym_7,
    ACTIONS(10579), 1,
      sym__splice_dollar,
    ACTIONS(10581), 1,
      sym_quasiquote_start,
    ACTIONS(13780), 1,
      sym__conid,
    ACTIONS(14640), 1,
      sym__varid,
    ACTIONS(14646), 1,
      anon_sym_LPAREN,
    ACTIONS(14648), 1,
      anon_sym_LBRACK,
    ACTIONS(14650), 1,
      anon_sym_SQUOTE,
    STATE(2101), 1,
      sym__unboxed_open,
    STATE(14877), 1,
      aux_sym__qualifying_module,
    STATE(15441), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14644), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14652), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14642), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(17835), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(17839), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(18847), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [107481] = 21,
    ACTIONS(4555), 1,
      sym__integer_literal,
    ACTIONS(4565), 1,
      sym__conid,
    ACTIONS(4579), 1,
      anon_sym_7,
    ACTIONS(4581), 1,
      sym__splice_dollar,
    ACTIONS(4583), 1,
      sym_quasiquote_start,
    ACTIONS(14624), 1,
      sym__varid,
    ACTIONS(14630), 1,
      anon_sym_LPAREN,
    ACTIONS(14632), 1,
      anon_sym_LBRACK,
    ACTIONS(14634), 1,
      anon_sym_SQUOTE,
    STATE(2153), 1,
      sym__unboxed_open,
    STATE(10547), 1,
      sym_constructor,
    STATE(15240), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14628), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14636), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(4557), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14626), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11196), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(11197), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(11034), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [107575] = 21,
    ACTIONS(8466), 1,
      sym__integer_literal,
    ACTIONS(8476), 1,
      sym__conid,
    ACTIONS(8490), 1,
      anon_sym_7,
    ACTIONS(8492), 1,
      sym__splice_dollar,
    ACTIONS(8494), 1,
      sym_quasiquote_start,
    ACTIONS(14508), 1,
      sym__varid,
    ACTIONS(14514), 1,
      anon_sym_LPAREN,
    ACTIONS(14516), 1,
      anon_sym_LBRACK,
    ACTIONS(14518), 1,
      anon_sym_SQUOTE,
    STATE(2205), 1,
      sym__unboxed_open,
    STATE(10223), 1,
      sym_constructor,
    STATE(15372), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14512), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14520), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(8468), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14510), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10444), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(10490), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(10554), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [107669] = 21,
    ACTIONS(10970), 1,
      sym__integer_literal,
    ACTIONS(10976), 1,
      anon_sym_LPAREN,
    ACTIONS(10978), 1,
      sym__conid,
    ACTIONS(10980), 1,
      anon_sym_LBRACK,
    ACTIONS(10982), 1,
      anon_sym_SQUOTE,
    ACTIONS(10986), 1,
      anon_sym_7,
    ACTIONS(10988), 1,
      sym__splice_dollar,
    ACTIONS(10990), 1,
      sym_quasiquote_start,
    ACTIONS(14638), 1,
      sym__varid,
    STATE(2196), 1,
      sym__unboxed_open,
    STATE(8398), 1,
      sym_constructor,
    STATE(15075), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10974), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10984), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10968), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8404), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(8413), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8523), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [107763] = 26,
    ACTIONS(10786), 1,
      sym__varid,
    ACTIONS(10790), 1,
      sym__integer_literal,
    ACTIONS(10796), 1,
      anon_sym_LPAREN,
    ACTIONS(10801), 1,
      anon_sym_LBRACK,
    ACTIONS(10805), 1,
      anon_sym__,
    ACTIONS(10807), 1,
      anon_sym_7,
    ACTIONS(10809), 1,
      sym__splice_dollar,
    ACTIONS(10811), 1,
      sym_quasiquote_start,
    ACTIONS(10813), 1,
      sym__strict,
    ACTIONS(10815), 1,
      sym__lazy,
    ACTIONS(12785), 1,
      sym__conid,
    STATE(354), 1,
      sym__unboxed_open,
    STATE(8041), 1,
      sym_constructor,
    STATE(8112), 1,
      sym__pat_constructor,
    STATE(8277), 1,
      sym_variable,
    STATE(8307), 1,
      sym_qualified_constructor,
    STATE(8383), 1,
      sym__qcon,
    STATE(8429), 1,
      sym_literal,
    STATE(14715), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10794), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(10788), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10792), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8662), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(8481), 14,
      sym_pat_as,
      sym_pat_parens,
      sym_pat_tuple,
      sym_pat_unboxed_tuple,
      sym_pat_unboxed_sum,
      sym_pat_list,
      sym_pat_strict,
      sym_pat_irrefutable,
      sym_pat_name,
      sym_pat_wildcard,
      sym_pat_record,
      sym__apat,
      sym_splice,
      sym_quasiquote,
  [107867] = 21,
    ACTIONS(10563), 1,
      sym__integer_literal,
    ACTIONS(10577), 1,
      anon_sym_7,
    ACTIONS(10579), 1,
      sym__splice_dollar,
    ACTIONS(10581), 1,
      sym_quasiquote_start,
    ACTIONS(13780), 1,
      sym__conid,
    ACTIONS(14640), 1,
      sym__varid,
    ACTIONS(14646), 1,
      anon_sym_LPAREN,
    ACTIONS(14648), 1,
      anon_sym_LBRACK,
    ACTIONS(14650), 1,
      anon_sym_SQUOTE,
    STATE(2101), 1,
      sym__unboxed_open,
    STATE(14877), 1,
      aux_sym__qualifying_module,
    STATE(15441), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14644), 2,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
    ACTIONS(14652), 2,
      anon_sym_STAR,
      anon_sym_6,
    ACTIONS(10565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14642), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(17835), 5,
      sym_qualified_type,
      sym_tycon_arrow,
      sym__promoted_tycon,
      sym_type_variable,
      sym_annotated_type_variable,
    STATE(17839), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
    STATE(18853), 14,
      sym_type_literal,
      sym_type_parens,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
      sym__type_promoted_literal,
      sym__type_literal,
      sym_type_name,
      sym_type_star,
      sym_type_unboxed_tuple,
      sym_type_unboxed_sum,
      sym__atype,
      sym_splice,
      sym_quasiquote,
  [107961] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108019] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108076] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108133] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108249] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108306] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108363] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108420] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108479] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108536] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108593] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108650] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108707] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108764] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108821] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108878] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108935] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [108992] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109049] = 4,
    ACTIONS(14720), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109108] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109165] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109222] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 33,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109279] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109336] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109393] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109450] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109509] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109566] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109623] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109680] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109737] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109794] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109851] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109908] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [109965] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110022] = 15,
    ACTIONS(13711), 1,
      sym_comma,
    ACTIONS(13808), 1,
      sym__conid,
    ACTIONS(13815), 1,
      anon_sym__,
    STATE(2360), 1,
      sym__colon2,
    STATE(13873), 1,
      aux_sym_signature_repeat1,
    STATE(18047), 1,
      sym__type_annotation,
    ACTIONS(13812), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13817), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(14770), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13796), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13774), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 8,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(13799), 12,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [110103] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110217] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110274] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110331] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110388] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110502] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110561] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110618] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110675] = 6,
    ACTIONS(14801), 1,
      anon_sym_LBRACE,
    ACTIONS(14804), 1,
      sym__layout_start,
    STATE(3878), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 14,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110738] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110795] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110852] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110909] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [110966] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111023] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111082] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111139] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111196] = 4,
    ACTIONS(14830), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111254] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 33,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_7,
  [111310] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111366] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111422] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111478] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111590] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111646] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111702] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111758] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111814] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111870] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111926] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [111982] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112038] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112150] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112206] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112262] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112374] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112430] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_7,
  [112486] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112654] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112766] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(14854), 4,
      sym__strict,
      sym__lazy,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(13702), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 12,
      sym__varsym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 17,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [112830] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112888] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [112944] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 34,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113000] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(14854), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(13702), 8,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 11,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 19,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_7,
  [113064] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113120] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113234] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113290] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113346] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113402] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113458] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113570] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113626] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113682] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113738] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113794] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113850] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113906] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [113962] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114018] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114074] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114130] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114186] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114242] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114298] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114354] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_7,
  [114410] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114466] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114578] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114634] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114690] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114746] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114802] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114858] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114914] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [114970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115025] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115082] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115137] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 33,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115247] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115304] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115361] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115418] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115473] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115528] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115585] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115640] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115695] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115750] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115805] = 6,
    ACTIONS(14882), 1,
      anon_sym_LBRACE,
    ACTIONS(14885), 1,
      sym__layout_start,
    STATE(4178), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115866] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115921] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [115978] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116033] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116088] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116143] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116198] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116253] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116308] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116365] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116420] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 32,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116475] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116530] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116585] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116642] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116697] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116754] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116811] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116866] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116921] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [116978] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 33,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117033] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117088] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117143] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117200] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(14854), 6,
      sym_comma,
      sym__strict,
      sym__lazy,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(13702), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 9,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 17,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [117263] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117373] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117428] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117485] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117540] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_7,
  [117595] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 15,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_let,
      anon_sym_if,
      anon_sym_else,
      anon_sym_case,
      anon_sym_of,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117650] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 33,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117705] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117759] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117815] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117869] = 6,
    ACTIONS(14889), 1,
      anon_sym_AT2,
    ACTIONS(14887), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13702), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 23,
      sym__splice_dollar,
      sym__varsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_7,
  [117929] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [117983] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118037] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(13702), 6,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14854), 6,
      sym__strict,
      sym__lazy,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13684), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 17,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [118099] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118155] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118209] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118263] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118317] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118371] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118425] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118481] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118535] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118591] = 4,
    ACTIONS(14891), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118647] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118701] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118755] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118809] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118863] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [118917] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14261), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [118973] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(6240), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [119029] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119083] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119137] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119193] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119247] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14550), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [119303] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119357] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119411] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119465] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(14854), 4,
      sym__strict,
      sym__lazy,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(13702), 6,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 17,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [119527] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119581] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119635] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119689] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119743] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119797] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 32,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119851] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 31,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119905] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [119959] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120015] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120069] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120123] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120177] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(14854), 5,
      sym_comma,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(13702), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 9,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 17,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [120239] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120293] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120347] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120401] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120455] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120509] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120563] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120617] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120671] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120725] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_7,
  [120779] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120833] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120887] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(13682), 32,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [120941] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [120995] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121049] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121103] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121157] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 31,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121211] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121267] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121321] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(13717), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [121377] = 6,
    ACTIONS(14893), 1,
      anon_sym_LBRACE,
    ACTIONS(14896), 1,
      sym__layout_start,
    STATE(4303), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121437] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121491] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121545] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121599] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121655] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121711] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121767] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121823] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121877] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121931] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [121985] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122041] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122095] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122149] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122203] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 32,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122257] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122311] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122367] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(13702), 6,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14854), 6,
      sym__strict,
      sym__lazy,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13684), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 17,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [122429] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(13721), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [122485] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122539] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122595] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122649] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122703] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122757] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122811] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122865] = 6,
    ACTIONS(14898), 1,
      anon_sym_LBRACE,
    ACTIONS(14901), 1,
      sym__layout_start,
    STATE(4295), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [122925] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(14854), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(13702), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 9,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 20,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [122987] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123041] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123095] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123149] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123203] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123257] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123311] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 31,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123365] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123419] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123475] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123529] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123583] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123639] = 5,
    ACTIONS(14903), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
    ACTIONS(13702), 13,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 22,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_7,
  [123697] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123751] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(14854), 4,
      sym_comma,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
    ACTIONS(13702), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 9,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 17,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [123812] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14787), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [123865] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(13158), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [123918] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [123971] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124024] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124077] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124130] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124183] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124291] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124344] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124397] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124450] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124503] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124556] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124609] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124662] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124715] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124768] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124821] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124874] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124927] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [124980] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125033] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14672), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [125086] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14698), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [125139] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125245] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125298] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125404] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14664), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [125457] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(13736), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [125510] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125563] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14682), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [125616] = 4,
    ACTIONS(14905), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125671] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125724] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125777] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125830] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125883] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125936] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [125989] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [126042] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14911), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
    ACTIONS(14907), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 23,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [126097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [126150] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [126203] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [126256] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14111), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [126309] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [126362] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [126415] = 4,
    ACTIONS(14914), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [126470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [126523] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14686), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [126576] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14064), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [126629] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [126682] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [126735] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(13740), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [126788] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(14854), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(13702), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 9,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 19,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [126849] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [126902] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [126957] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14267), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [127010] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [127063] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [127116] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(13721), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [127169] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14916), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
    ACTIONS(14907), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 23,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [127224] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [127277] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [127330] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [127383] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14824), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [127436] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14678), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [127489] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [127542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [127595] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [127648] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(14854), 4,
      sym__strict,
      sym__lazy,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(13702), 6,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 10,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 17,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [127709] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [127764] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [127817] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [127870] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [127923] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14694), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [127976] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128029] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14919), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
    ACTIONS(14704), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 23,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128084] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128137] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128190] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128243] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128296] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128349] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128402] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128455] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128508] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128561] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128614] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(13891), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [128667] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128773] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128826] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128879] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14257), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [128932] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [128985] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129038] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129091] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129144] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129197] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129250] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129303] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14748), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [129356] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129409] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129462] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129515] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129568] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14042), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [129621] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(13891), 29,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [129676] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129729] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129782] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129835] = 5,
    ACTIONS(14924), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 24,
      sym__splice_dollar,
      sym__varsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129892] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129945] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [129998] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [130051] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [130104] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14740), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [130157] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(13684), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [130210] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [130263] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [130316] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [130369] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14060), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [130422] = 6,
    ACTIONS(14903), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13702), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_7,
  [130481] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [130534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [130587] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [130640] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [130693] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(14854), 2,
      sym__strict,
      sym__lazy,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(13702), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 9,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 19,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [130754] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [130807] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [130860] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14271), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [130913] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [130966] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14478), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [131019] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131074] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131127] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131180] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131233] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131286] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14656), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [131339] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131392] = 6,
    ACTIONS(14926), 1,
      anon_sym_LBRACE,
    ACTIONS(14929), 1,
      sym__layout_start,
    STATE(4397), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131451] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131504] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131557] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14714), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [131610] = 5,
    ACTIONS(14931), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 24,
      sym__splice_dollar,
      sym__varsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131667] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14690), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [131720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131773] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131826] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131879] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131934] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [131987] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [132040] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14702), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [132093] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [132146] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [132199] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [132252] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [132305] = 5,
    ACTIONS(14933), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 24,
      sym__splice_dollar,
      sym__varsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [132362] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [132415] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [132468] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [132521] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14668), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [132574] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [132627] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14191), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [132680] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14251), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [132733] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [132786] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14187), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [132839] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [132892] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [132945] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(14795), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [132998] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133051] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133104] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
    ACTIONS(13776), 31,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [133157] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133210] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133263] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133316] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(14854), 4,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(13702), 7,
      anon_sym_DASH,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 9,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 17,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [133377] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133430] = 7,
    ACTIONS(14856), 1,
      anon_sym__,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14848), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(13702), 6,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14854), 6,
      sym__strict,
      sym__lazy,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13684), 8,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(14851), 17,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [133491] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
    ACTIONS(13774), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 23,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133546] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133599] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 12,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133652] = 5,
    ACTIONS(9703), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 24,
      sym__splice_dollar,
      sym__varsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133762] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133815] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133867] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133923] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [133975] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134027] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134079] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134131] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134185] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134237] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134289] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134343] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(6240), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [134397] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134453] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134507] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134561] = 4,
    ACTIONS(14935), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134615] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134667] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134721] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134773] = 6,
    ACTIONS(14937), 1,
      anon_sym_LBRACE,
    ACTIONS(14940), 1,
      sym__layout_start,
    STATE(5144), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134831] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134885] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134937] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [134989] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135041] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135093] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135145] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135197] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135249] = 6,
    ACTIONS(14942), 1,
      anon_sym_LBRACE,
    ACTIONS(14945), 1,
      sym__layout_start,
    STATE(5109), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135307] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135359] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135411] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135465] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135517] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135569] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135623] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135675] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135727] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135779] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135831] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [135883] = 6,
    ACTIONS(14889), 1,
      anon_sym_AT2,
    ACTIONS(14887), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13702), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_7,
  [135941] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14550), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [135995] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136047] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136101] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136153] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136205] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136257] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136309] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136361] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136413] = 6,
    ACTIONS(14947), 1,
      anon_sym_AT2,
    ACTIONS(14887), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13702), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_7,
  [136471] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_7,
  [136523] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136577] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136631] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136685] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136739] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136791] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136843] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136895] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [136949] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 30,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137001] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_7,
  [137053] = 5,
    ACTIONS(14947), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(13702), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_7,
  [137109] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137163] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137217] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137269] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137323] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137375] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137427] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137479] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 31,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137531] = 7,
    ACTIONS(13707), 1,
      anon_sym__,
    ACTIONS(13686), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13713), 4,
      sym__strict,
      sym__lazy,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13702), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(13689), 13,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [137591] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137643] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137699] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137751] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137803] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137857] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13717), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [137911] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [137963] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138015] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138067] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138119] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138175] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138229] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138283] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138335] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13721), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [138389] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138441] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138493] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138545] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138597] = 6,
    ACTIONS(14949), 1,
      anon_sym_LBRACE,
    ACTIONS(14952), 1,
      sym__layout_start,
    STATE(5058), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138655] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138707] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138759] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138811] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138863] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138915] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 30,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [138967] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139019] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139071] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139125] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139177] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139231] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139283] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139337] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14261), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [139391] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139445] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139499] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139551] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139605] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139657] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139761] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139813] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139865] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13682), 32,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [139917] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [139969] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140023] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140075] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140127] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140181] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140233] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140285] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140337] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140389] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140441] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140493] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140545] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140597] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140649] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140701] = 7,
    ACTIONS(13707), 1,
      anon_sym__,
    ACTIONS(13686), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13713), 4,
      sym__strict,
      sym__lazy,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13702), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(13689), 13,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [140761] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140815] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140869] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140921] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [140973] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141025] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141077] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141129] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141181] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141235] = 6,
    ACTIONS(14954), 1,
      anon_sym_LBRACE,
    ACTIONS(14957), 1,
      sym__layout_start,
    STATE(4916), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141293] = 6,
    ACTIONS(14959), 1,
      anon_sym_LBRACE,
    ACTIONS(14962), 1,
      sym__layout_start,
    STATE(5412), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141403] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 31,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141455] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141507] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141559] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141610] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141661] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141714] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141765] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141816] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141867] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141918] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [141969] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142020] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142073] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142124] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142175] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142228] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142279] = 5,
    ACTIONS(14924), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142334] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142385] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142436] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142487] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142538] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142589] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142640] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142691] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142793] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142844] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142895] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [142997] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143048] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143099] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143150] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143201] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143252] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143303] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143354] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143405] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143456] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143509] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143560] = 6,
    ACTIONS(14964), 1,
      anon_sym_AT2,
    ACTIONS(14887), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13702), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_7,
  [143617] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143668] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13891), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [143721] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143772] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143823] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143874] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143925] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [143976] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144027] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144078] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144129] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144180] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144233] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144284] = 6,
    ACTIONS(14966), 1,
      anon_sym_LBRACE,
    ACTIONS(14969), 1,
      sym__layout_start,
    STATE(5520), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144341] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144392] = 5,
    ACTIONS(14933), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144447] = 5,
    ACTIONS(9703), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144502] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144555] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144606] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144657] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144708] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144759] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13736), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [144810] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144861] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144912] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [144963] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145014] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145065] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145118] = 6,
    ACTIONS(14971), 1,
      anon_sym_LBRACE,
    ACTIONS(14974), 1,
      sym__layout_start,
    STATE(5579), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145175] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145226] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145277] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145328] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145379] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14919), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145434] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145485] = 6,
    ACTIONS(14976), 1,
      anon_sym_LBRACE,
    ACTIONS(14979), 1,
      sym__layout_start,
    STATE(5562), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145593] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145644] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145697] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145748] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145799] = 5,
    ACTIONS(14931), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145854] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145907] = 4,
    ACTIONS(14981), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [145960] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146013] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14111), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [146064] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13721), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [146115] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14916), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146170] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14911), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146225] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146276] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146327] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146378] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146429] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146480] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146531] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146633] = 6,
    ACTIONS(14983), 1,
      anon_sym_LBRACE,
    ACTIONS(14986), 1,
      sym__layout_start,
    STATE(5496), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146690] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146741] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146792] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_7,
  [146843] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146894] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146947] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [146998] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13891), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [147049] = 4,
    ACTIONS(14988), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147102] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147153] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147204] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147255] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147306] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147357] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147408] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147459] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147510] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147563] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147616] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147667] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147718] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147769] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147871] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147922] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [147973] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148024] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148075] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148126] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148177] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148228] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148279] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148330] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148381] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148432] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148483] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148585] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148687] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148738] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148789] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148891] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148942] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [148993] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149044] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149095] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149146] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149197] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149248] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149301] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149352] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149403] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149456] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149507] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149558] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149609] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149660] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149711] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149762] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149813] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149915] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [149968] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150019] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150070] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150121] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150172] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150223] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150274] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150327] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150378] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150429] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150480] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150531] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150633] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150684] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150735] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150786] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150837] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150888] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150941] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [150994] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14919), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151047] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151098] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151149] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151202] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14916), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151255] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151306] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151357] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14911), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151410] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151463] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14694), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [151514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14690), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [151565] = 6,
    ACTIONS(14990), 1,
      anon_sym_LBRACE,
    ACTIONS(14993), 1,
      sym__layout_start,
    STATE(5548), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151622] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151673] = 5,
    ACTIONS(14903), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13702), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_7,
  [151728] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151781] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151832] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151885] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [151938] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14787), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [151989] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14042), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [152040] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [152093] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14748), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [152144] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14698), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [152195] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14686), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [152246] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [152297] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14682), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [152348] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [152399] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14678), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [152450] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_7,
  [152501] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14672), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [152552] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [152605] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [152658] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [152709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [152760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [152811] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [152862] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14668), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [152913] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [152964] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153015] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153066] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153117] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153168] = 6,
    ACTIONS(14995), 1,
      anon_sym_LBRACE,
    ACTIONS(14998), 1,
      sym__layout_start,
    STATE(5569), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153225] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153276] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153327] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153378] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153429] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14187), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [153480] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13776), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [153531] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13682), 31,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [153582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13684), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [153633] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153684] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153735] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153786] = 7,
    ACTIONS(13707), 1,
      anon_sym__,
    ACTIONS(13686), 3,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13713), 4,
      sym__strict,
      sym__lazy,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13702), 7,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 12,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
    ACTIONS(13689), 13,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [153845] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153896] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [153949] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154000] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154051] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14911), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154106] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154157] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154208] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154259] = 6,
    ACTIONS(15000), 1,
      anon_sym_LBRACE,
    ACTIONS(15003), 1,
      sym__layout_start,
    STATE(5589), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154316] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 30,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154367] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14795), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [154418] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154469] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154520] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154573] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154624] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154675] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14714), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [154726] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154777] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154828] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154879] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154930] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [154981] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155032] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155083] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 29,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155134] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155185] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155236] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155287] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155338] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155389] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155440] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155491] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155593] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155644] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155695] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155746] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14916), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155801] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13717), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [155854] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155905] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [155956] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13721), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [156009] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [156060] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [156111] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [156162] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [156215] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [156266] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14478), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [156317] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14267), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [156368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13740), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [156419] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14060), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [156470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [156521] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [156572] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14191), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [156623] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14251), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [156674] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [156725] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14271), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [156776] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14257), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [156827] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [156878] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [156929] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [156980] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14740), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [157031] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157082] = 4,
    ACTIONS(15005), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157135] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157188] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14064), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [157239] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157290] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157341] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157392] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157443] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157494] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157545] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 30,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157596] = 5,
    ACTIONS(14931), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157651] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157704] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157755] = 4,
    ACTIONS(15007), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157808] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157859] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157910] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [157963] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158014] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158065] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158116] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158167] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158218] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158269] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158320] = 6,
    ACTIONS(14889), 1,
      anon_sym_AT2,
    ACTIONS(14887), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13702), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_7,
  [158377] = 5,
    ACTIONS(9703), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158432] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158483] = 5,
    ACTIONS(14933), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158538] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158589] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158640] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158691] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158742] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158795] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158848] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158899] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [158950] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159001] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159052] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159103] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159154] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159205] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159256] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159307] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159358] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159409] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159460] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159511] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159562] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159613] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159664] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159715] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159766] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159817] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159868] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159919] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [159970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160021] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160072] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160123] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160174] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160225] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160278] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160329] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160380] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160431] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160482] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160535] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160586] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160637] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160688] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160739] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160790] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13158), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [160841] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14919), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160896] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160947] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [160998] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161049] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161100] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161151] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161202] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161253] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161304] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161355] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161408] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161459] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161510] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161561] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161612] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161663] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161714] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161765] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161816] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14702), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [161867] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14656), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [161918] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [161969] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162071] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162122] = 5,
    ACTIONS(14924), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162177] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14261), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [162230] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162281] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162332] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162383] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162434] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162485] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14824), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [162536] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162587] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162638] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162689] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162740] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162791] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162842] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162893] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162944] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [162995] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163046] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163148] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163199] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163250] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163301] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163352] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_AT2,
      anon_sym_7,
  [163403] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163454] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163505] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 29,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163556] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163607] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 29,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163658] = 4,
    ACTIONS(15009), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163711] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163762] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163813] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163864] = 6,
    ACTIONS(15011), 1,
      anon_sym_LBRACE,
    ACTIONS(15014), 1,
      sym__layout_start,
    STATE(5694), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163921] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [163972] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164023] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164074] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164125] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164176] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164227] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164278] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164329] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164380] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164431] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164482] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164533] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164584] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164635] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164686] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164737] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164788] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164839] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164890] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164941] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [164992] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165043] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165094] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165147] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165198] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165249] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165300] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165402] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165453] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165504] = 6,
    ACTIONS(15016), 1,
      anon_sym_AT2,
    ACTIONS(14887), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13702), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_7,
  [165561] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165612] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165663] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165714] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165765] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165816] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165867] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165918] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [165969] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166071] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166122] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166173] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14550), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [166226] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(6240), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [166279] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166330] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166381] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 29,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166432] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166483] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166585] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166687] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166738] = 5,
    ACTIONS(14964), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(13702), 12,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_AT,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 20,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_BSLASH,
      anon_sym_7,
  [166793] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166844] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166895] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [166997] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167048] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167099] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167150] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167201] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167252] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167303] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167354] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167405] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167456] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167507] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167558] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14664), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [167609] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167660] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167711] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167762] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167813] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167914] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [167964] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168014] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168066] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168116] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168166] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168266] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168316] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168366] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168416] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168466] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168516] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168566] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168616] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168666] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168716] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168766] = 5,
    ACTIONS(14924), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [168870] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14694), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [168920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14690), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [168970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169070] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13158), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [169120] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169170] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14824), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [169220] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14787), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [169270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14748), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [169320] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169370] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169420] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169520] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169570] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14702), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [169620] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169670] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169770] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169870] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [169920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14656), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [169970] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170022] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14686), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [170072] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170122] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170172] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170222] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170322] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170422] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170472] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170524] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170574] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14911), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170626] = 4,
    ACTIONS(15018), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170678] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170728] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14682), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [170778] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14678), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [170828] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14916), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170880] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14672), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [170930] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [170980] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14668), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [171030] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14664), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [171080] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14795), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [171130] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13684), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [171180] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171230] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171280] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171330] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171380] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171432] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171482] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171532] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171632] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14919), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171684] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171734] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13776), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [171834] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14187), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [171884] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171934] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [171984] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172034] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172084] = 5,
    ACTIONS(14933), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172138] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172188] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172288] = 5,
    ACTIONS(9703), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172342] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172392] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172442] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172492] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172592] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172642] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172692] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172792] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172842] = 4,
    ACTIONS(15020), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172894] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172944] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [172994] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14478), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [173044] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173144] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173194] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173244] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173294] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173344] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173394] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173444] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173494] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13891), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [173544] = 5,
    ACTIONS(14931), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173648] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173700] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173750] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173800] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14042), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [173850] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173900] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [173950] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14267), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [174000] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174050] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174100] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174150] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174200] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174250] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174300] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174350] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174450] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174500] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174550] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174600] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174650] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174700] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174750] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174800] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174850] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174900] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [174950] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [175000] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13740), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [175050] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14714), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [175100] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [175150] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [175200] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [175250] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [175300] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14740), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [175350] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [175400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [175450] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14060), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [175500] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [175550] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [175600] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [175650] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [175700] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14191), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [175750] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14251), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [175800] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13891), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [175852] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [175902] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [175952] = 6,
    ACTIONS(15022), 1,
      anon_sym_LBRACE,
    ACTIONS(15025), 1,
      sym__layout_start,
    STATE(5875), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176008] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176058] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176108] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176158] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176208] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176258] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176308] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176358] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176408] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176458] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176508] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176558] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176608] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176658] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176708] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176758] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176808] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176858] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176908] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [176958] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177008] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177058] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177108] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177158] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14919), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177212] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177262] = 6,
    ACTIONS(15027), 1,
      anon_sym_LBRACE,
    ACTIONS(15030), 1,
      sym__layout_start,
    STATE(5861), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14271), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [177368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177418] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177468] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177518] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177568] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177618] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177668] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177718] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177768] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14257), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [177818] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177868] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177918] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [177968] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14064), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [178018] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178068] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178118] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178168] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178218] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178268] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178418] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178468] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178520] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178570] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178620] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178670] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178720] = 6,
    ACTIONS(15032), 1,
      anon_sym_LBRACE,
    ACTIONS(15035), 1,
      sym__layout_start,
    STATE(5886), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178776] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178826] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178876] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178926] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [178976] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179026] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179076] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179126] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179176] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179226] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14919), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179278] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179328] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179378] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179428] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179478] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179528] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179578] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179628] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179678] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179728] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179778] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179830] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179880] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179930] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14916), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [179984] = 5,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14911), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180038] = 5,
    ACTIONS(14924), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 22,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180092] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180142] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180242] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180292] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180342] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180392] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180442] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180492] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180592] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180642] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180692] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180792] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180842] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180892] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180942] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [180992] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181042] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181092] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181142] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181242] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181292] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181342] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13721), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [181392] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181442] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181492] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181592] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181642] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181692] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181792] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181842] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181892] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181942] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [181992] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14111), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [182042] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14916), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182144] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182194] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182244] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182294] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182344] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182394] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182444] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182494] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182546] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182596] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182646] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182696] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182746] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182796] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182846] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182896] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [182996] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183046] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183096] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183146] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183196] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183246] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183296] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183346] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183396] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183446] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183496] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183546] = 4,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14911), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183648] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183698] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183748] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183798] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183848] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183898] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183948] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [183998] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184048] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184098] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184148] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184198] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184248] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184298] = 4,
    ACTIONS(15037), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184350] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184450] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184500] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184550] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184600] = 5,
    ACTIONS(14933), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 22,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184654] = 4,
    ACTIONS(15039), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184706] = 5,
    ACTIONS(9703), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 22,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184810] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184860] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184910] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 29,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [184960] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185010] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185060] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185110] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185210] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185260] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185310] = 5,
    ACTIONS(14931), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 22,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185364] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185414] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185464] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185564] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185614] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185664] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185714] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185764] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185814] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(13736), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [185914] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [185964] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186014] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186064] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186114] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186164] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186214] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186264] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186364] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186414] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186464] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186564] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186614] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186664] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186714] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186764] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186814] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186914] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [186964] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187014] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187064] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187114] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187164] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187214] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187264] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187364] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187414] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187464] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187564] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187614] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187664] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187714] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187764] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187814] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187914] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [187966] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188016] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188066] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188116] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188166] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188266] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188316] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188366] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188416] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188466] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188516] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188566] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188616] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188666] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188716] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188766] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188816] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188866] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188916] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [188966] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189016] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189066] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189116] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189166] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189266] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189316] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189366] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189416] = 5,
    ACTIONS(14931), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14704), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189470] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189520] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189570] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189620] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189670] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189770] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189870] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [189970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190070] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190120] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190170] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190220] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190270] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190322] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190422] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190472] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
    ACTIONS(14698), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [190522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190572] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190622] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190672] = 4,
    ACTIONS(15041), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190724] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190774] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190824] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190874] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190924] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [190974] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191024] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191074] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191124] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191174] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191224] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191274] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191324] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191374] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191424] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191474] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191524] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191574] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191626] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191676] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191726] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191776] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191826] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191876] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191926] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [191976] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192026] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192076] = 5,
    ACTIONS(9703), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192130] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192180] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192230] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192280] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192330] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192380] = 5,
    ACTIONS(14933), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14907), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14909), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192434] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192484] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192584] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192634] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192684] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192734] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192834] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13682), 29,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192884] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192934] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [192984] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193034] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193084] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193134] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193184] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193234] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193284] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193334] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193384] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193434] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193484] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193536] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193586] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193686] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193736] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193786] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193836] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193886] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193936] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [193986] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194036] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194086] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194136] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194186] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194236] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194286] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194336] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194386] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194436] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194486] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194536] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194586] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194686] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194736] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194786] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194836] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194886] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194936] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [194986] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195036] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195086] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195136] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195186] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195236] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13717), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195288] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195338] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195388] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195438] = 4,
    ACTIONS(15043), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195490] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195540] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195590] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195640] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195690] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195740] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195790] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195890] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195940] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [195990] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196040] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196090] = 4,
    ACTIONS(15045), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196142] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196242] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196292] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196342] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196392] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196442] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196492] = 5,
    ACTIONS(14924), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13774), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 21,
      sym__splice_dollar,
      sym__varsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      sym_label,
      sym_implicit_parid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196546] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196596] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196646] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196696] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196746] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196796] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196848] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196898] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196948] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [196998] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197048] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197098] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197148] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197198] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197248] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197298] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197348] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197398] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197448] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197498] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197548] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197648] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197698] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197748] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197798] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197848] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197898] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197948] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [197998] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198048] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198098] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198148] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198198] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198248] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198298] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198348] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198398] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198448] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 11,
      sym__integer_literal,
      sym__immediate_dot,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198498] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198548] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198648] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198698] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198750] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198800] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198850] = 4,
    ACTIONS(15047), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198902] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [198952] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199002] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199052] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199102] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199152] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199202] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199252] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199302] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199352] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199402] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199452] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199501] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199550] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14261), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [199601] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199650] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199699] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199748] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199797] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199846] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199895] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199944] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [199993] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200042] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200091] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200140] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200189] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200287] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200336] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200385] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200434] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200483] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200532] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200581] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200630] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200679] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200728] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200777] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200826] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200875] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200924] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [200973] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201022] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201071] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201120] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201218] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201267] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201316] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201365] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201414] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(6240), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201465] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201563] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201612] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201661] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201759] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13736), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201808] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201857] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201906] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [201955] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202004] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202053] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14550), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [202104] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(6240), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [202155] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202204] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202253] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202302] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14111), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202449] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202498] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13717), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [202549] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202647] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202696] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202745] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14550), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202796] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13682), 33,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [202845] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202894] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14478), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202943] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [202992] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203041] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203090] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203139] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203188] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203237] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203286] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13740), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203335] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203384] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203433] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14060), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203482] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203531] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13721), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [203582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203631] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203680] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203729] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14191), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203778] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14257), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203827] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203876] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203925] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [203974] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204023] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14251), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204072] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204121] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204170] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204219] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204268] = 4,
    ACTIONS(15049), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204319] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204417] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204466] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204515] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204564] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204613] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13721), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204662] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204711] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204809] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204858] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204907] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [204956] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205005] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13776), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205054] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205103] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205152] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205201] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205250] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205299] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14271), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205348] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205397] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205446] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205495] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205544] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205593] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205642] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205691] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205740] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205789] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205838] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205887] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205936] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [205985] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14267), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206034] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206083] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206132] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206181] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206230] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206279] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206328] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206377] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206426] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206475] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206524] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206573] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206622] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206671] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14064), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206769] = 4,
    ACTIONS(15051), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14187), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206869] = 4,
    ACTIONS(15053), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206920] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14261), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [206971] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207069] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207118] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207167] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207216] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207265] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207363] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207412] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207461] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207510] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207559] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207608] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207657] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207706] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207755] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(6240), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [207806] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [207857] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207906] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [207955] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13717), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [208006] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14550), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [208057] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208106] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13682), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [208155] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208204] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208253] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208302] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14042), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208449] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208498] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208547] = 6,
    ACTIONS(15055), 1,
      anon_sym_LBRACE,
    ACTIONS(15058), 1,
      sym__layout_start,
    STATE(6204), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14341), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14343), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208602] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208651] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208700] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208749] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208798] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_in,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208847] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208896] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14261), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [208947] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [208996] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209045] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209143] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13891), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209241] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209290] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209339] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209388] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209437] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209486] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209535] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 11,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209584] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209633] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209682] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209731] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209780] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209829] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209878] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209927] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [209976] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210025] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210074] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210123] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210172] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210221] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210319] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13684), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210417] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210466] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210515] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210564] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210613] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210662] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210711] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210809] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210858] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210907] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [210956] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211005] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211054] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211103] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211152] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211201] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211250] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211299] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211348] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211397] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211446] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211495] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211544] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211593] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211642] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211691] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211740] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211789] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211838] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211887] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211936] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [211985] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212034] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212083] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212132] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212181] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212230] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13873), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212279] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212328] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212377] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212426] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212475] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212524] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212573] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212622] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212671] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212769] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212818] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [212867] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14478), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [212915] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13682), 31,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [212963] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [213011] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [213059] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14740), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213107] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14704), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14706), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [213155] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14714), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213203] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14664), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213251] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14656), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213299] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14702), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213347] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14824), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213395] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13158), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213443] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14795), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213491] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14668), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213539] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14672), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213587] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14678), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213635] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14682), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213683] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14686), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213731] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14698), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213779] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14748), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213827] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14787), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213875] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14690), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213923] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14694), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [213971] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14714), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [214019] = 4,
    ACTIONS(15060), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14716), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14718), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214069] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(6240), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [214119] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13736), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [214167] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [214217] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14722), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14724), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214265] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14726), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14728), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214313] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14550), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [214363] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14261), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [214413] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [214463] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14730), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14732), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214511] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214559] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14734), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14736), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214607] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14740), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214655] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214703] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14742), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14744), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214751] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14708), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14710), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214799] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14750), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14752), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214847] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14758), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14760), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214895] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14762), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14764), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214943] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [214991] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215039] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14766), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14768), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215087] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14777), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14779), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215135] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14111), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [215183] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14658), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14660), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215231] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13891), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [215281] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14797), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14799), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215329] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14810), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14812), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215377] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215425] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14818), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14820), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215473] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14814), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14816), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215521] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13721), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [215569] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14694), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215617] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14789), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14791), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215665] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215713] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14826), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14828), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215761] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14795), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [215809] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215857] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14781), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14783), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [215905] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14664), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [215953] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [216001] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14773), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14775), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [216049] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14690), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [216097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14668), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [216145] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13740), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [216193] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [216241] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14754), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14756), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [216289] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(13158), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [216337] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14806), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14808), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [216385] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13891), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [216433] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14672), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [216481] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14714), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [216529] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14064), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [216577] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13684), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [216625] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14678), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [216673] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14257), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [216721] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [216769] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14271), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [216817] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14251), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [216865] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14682), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [216913] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14191), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [216961] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13776), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217009] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14686), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217057] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14187), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217105] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [217153] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14698), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217201] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14060), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217249] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14267), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217297] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14478), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217345] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217395] = 12,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_EQ,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15072), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3381), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 19,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [217461] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14042), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217509] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14656), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217557] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14702), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217605] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13717), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217655] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [217703] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217753] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 33,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217801] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14042), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [217849] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217899] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217949] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [217999] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13717), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [218049] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [218097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14111), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [218145] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13736), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [218193] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [218241] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 33,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [218289] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13682), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [218337] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [218385] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [218435] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [218485] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14187), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [218533] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14748), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [218581] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [218631] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14824), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [218679] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14787), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [218727] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14824), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [218775] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13776), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [218823] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14787), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [218871] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [218919] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13158), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [218967] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [219015] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14748), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [219063] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13684), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [219111] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14740), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [219159] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14690), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [219207] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 33,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [219255] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13682), 32,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [219303] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14694), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [219351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [219399] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [219449] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [219499] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 27,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [219547] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13717), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [219597] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13721), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [219647] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14267), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [219695] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13740), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [219743] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14261), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [219793] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14060), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [219841] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14191), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [219889] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14251), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [219937] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14271), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [219985] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220033] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [220083] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14257), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [220131] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14064), 32,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [220179] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [220229] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220277] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220325] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14702), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220373] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14656), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220421] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220469] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220517] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220565] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14698), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220613] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220661] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14686), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14682), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220757] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14678), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220805] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14672), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220853] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220901] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220949] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [220997] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 27,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [221045] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [221095] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [221145] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [221195] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14668), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [221243] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14664), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [221291] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14795), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [221339] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14261), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [221389] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [221439] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [221487] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(6240), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [221537] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(6240), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [221587] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [221635] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [221683] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14550), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [221733] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [221781] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [221829] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14550), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [221879] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14740), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [221926] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14824), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [221973] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14824), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [222020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14787), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [222067] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13158), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [222114] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13158), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [222161] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14787), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [222208] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14690), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [222255] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14748), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [222302] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14694), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [222349] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14690), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [222396] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14694), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [222443] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14748), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [222490] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14261), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [222539] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13891), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [222588] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14550), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [222637] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14702), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [222684] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 30,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [222733] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14702), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [222780] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14656), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [222827] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(6240), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [222876] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(6240), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [222925] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13684), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [222972] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13776), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [223019] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223066] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223113] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14187), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [223160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14698), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223207] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223254] = 9,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(15076), 1,
      sym__varid,
    ACTIONS(15079), 1,
      anon_sym_LPAREN,
    ACTIONS(14594), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    ACTIONS(15082), 2,
      anon_sym_EQ,
      anon_sym_deriving,
    STATE(11193), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15074), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(6240), 20,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [223313] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223360] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223407] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223454] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223501] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223548] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [223595] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [223642] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [223689] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223736] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223783] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14656), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [223830] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223879] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223926] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [223973] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [224020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14698), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [224067] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13891), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [224114] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [224163] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [224210] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14686), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [224257] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [224304] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [224351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14042), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [224398] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [224447] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14682), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [224494] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [224541] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14678), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [224588] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [224637] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [224684] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [224731] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [224780] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14686), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [224827] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14682), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [224874] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14672), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [224921] = 10,
    ACTIONS(15086), 1,
      anon_sym_BQUOTE,
    ACTIONS(15089), 1,
      sym__consym,
    ACTIONS(15092), 1,
      sym__tyconsym,
    STATE(2360), 1,
      sym__colon2,
    STATE(19175), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(14889), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 23,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [224982] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14668), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [225029] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14664), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [225076] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [225125] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14678), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [225172] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13717), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [225221] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [225270] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [225319] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14795), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [225366] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14672), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [225413] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14740), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [225460] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14668), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [225507] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [225554] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [225603] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [225650] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14664), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [225697] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [225746] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [225793] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [225840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14795), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [225887] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [225934] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13717), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [225983] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226030] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226077] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226124] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226173] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13682), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [226220] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226267] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13721), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [226314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226361] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14111), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [226408] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226455] = 10,
    ACTIONS(15086), 1,
      anon_sym_BQUOTE,
    ACTIONS(15089), 1,
      sym__consym,
    ACTIONS(15092), 1,
      sym__tyconsym,
    STATE(2360), 1,
      sym__colon2,
    STATE(20246), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(14889), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 23,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [226516] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226563] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226610] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 28,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [226659] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14714), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [226706] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226753] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226800] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226847] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226894] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13736), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [226941] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [226988] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [227035] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [227084] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [227131] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [227178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [227225] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [227272] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [227321] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [227368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [227415] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [227462] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [227509] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [227556] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [227603] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [227650] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [227697] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [227744] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [227793] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [227840] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14261), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [227889] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [227936] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [227983] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228030] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [228079] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [228126] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 32,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [228173] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228220] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228267] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228361] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228408] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228455] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228502] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228549] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228596] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13736), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228643] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228690] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [228737] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14478), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [228784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14111), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228831] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14267), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [228878] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228925] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [228972] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [229019] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [229066] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [229113] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [229160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13682), 30,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [229207] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13736), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [229254] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [229301] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [229350] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [229399] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13740), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [229446] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14060), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [229493] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14111), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [229540] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [229587] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14714), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [229634] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [229681] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14191), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [229728] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [229775] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14251), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [229822] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13158), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [229869] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [229916] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14271), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [229963] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230012] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14740), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [230059] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [230106] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230155] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14042), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230202] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230249] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230296] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230343] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14257), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [230390] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230439] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230488] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 32,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [230535] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14478), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14267), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230629] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13740), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230676] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14060), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230723] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230770] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14187), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230817] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13776), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14191), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230911] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [230960] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14064), 31,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [231007] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231054] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14251), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231101] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(6240), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231150] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14870), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14872), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [231197] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14866), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14868), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [231244] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14858), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14860), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [231291] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231338] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231387] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14257), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231434] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14550), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231483] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14261), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231532] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231579] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13684), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231626] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 32,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231673] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14064), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231767] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231814] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [231863] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14844), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14846), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [231910] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [231957] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232004] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14840), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14842), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [232051] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232098] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232145] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14271), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232239] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232286] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232333] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [232382] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232429] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232476] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232523] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232570] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232617] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232664] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [232713] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 32,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232807] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14550), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232856] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14836), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14838), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [232903] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14832), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14834), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [232950] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [232999] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13717), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233048] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233095] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233144] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14042), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233191] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14478), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14267), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233285] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13740), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233332] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14060), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233379] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14187), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233426] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233473] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14795), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233520] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14664), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233567] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14668), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233614] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13776), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233661] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14191), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233708] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14672), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233755] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14678), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233802] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14682), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233849] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14686), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233896] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14874), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14876), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [233943] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14698), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [233990] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14656), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234037] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14878), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14880), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [234084] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14251), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234131] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14271), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14702), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234225] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14257), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234319] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14748), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234415] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14787), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234462] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14824), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234509] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234558] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14862), 10,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(14864), 26,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym_label,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [234605] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 32,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [234652] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13684), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234699] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14064), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234746] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234795] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234844] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234893] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234942] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 32,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [234989] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235038] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14714), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235085] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235134] = 9,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(15095), 1,
      sym__varid,
    ACTIONS(15098), 1,
      anon_sym_LPAREN,
    ACTIONS(14594), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    ACTIONS(15082), 2,
      anon_sym_EQ,
      anon_sym_deriving,
    STATE(11322), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15074), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(6240), 20,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [235193] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14690), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235240] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14694), 30,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235287] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 32,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235334] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13682), 30,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235381] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235427] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [235473] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13684), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235519] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14702), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235565] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14656), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235611] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [235657] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235705] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14251), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235751] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14698), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235797] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14686), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235843] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235889] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [235935] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14682), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [235981] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14678), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [236027] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14672), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [236073] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [236119] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [236165] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [236211] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14261), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [236259] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14714), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [236305] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 31,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [236351] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [236399] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [236445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [236491] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [236537] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14787), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [236583] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [236629] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [236675] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14042), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [236721] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14191), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [236767] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14251), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [236813] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [236859] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [236905] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14668), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [236951] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [236997] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14664), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237043] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13717), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [237091] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 31,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237137] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [237183] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14795), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237229] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14748), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237275] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237321] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15110), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3393), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 17,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [237385] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237431] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [237479] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14740), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237525] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237571] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237617] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237663] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237755] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237801] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237847] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237893] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237939] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [237985] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238031] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14191), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238077] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [238123] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [238169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14257), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238215] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [238261] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [238307] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14702), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238353] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14064), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238399] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238491] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [238539] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238585] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238631] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238677] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238725] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [238771] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14271), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238817] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238863] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238911] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [238957] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239003] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14257), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239049] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239095] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239141] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239187] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239233] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239279] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14656), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239325] = 9,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(15112), 1,
      sym__varid,
    ACTIONS(15115), 1,
      anon_sym_LPAREN,
    ACTIONS(14594), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    ACTIONS(15082), 2,
      anon_sym_EQ,
      anon_sym_deriving,
    STATE(11855), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15074), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
    ACTIONS(6240), 20,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [239383] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13684), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239429] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [239475] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239521] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239569] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13721), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [239617] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239663] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13684), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239755] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14060), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239801] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239847] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13891), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239895] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239943] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [239989] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 29,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [240037] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13776), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240083] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14187), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240129] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240175] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14191), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240221] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240267] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240313] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240359] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240405] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240451] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13776), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240497] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240543] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240589] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [240635] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14187), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240681] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240727] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240773] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240819] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [240865] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240911] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13736), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [240957] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241005] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14740), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241051] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13158), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [241143] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [241189] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14690), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241235] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241281] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [241327] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241373] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13736), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241419] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [241467] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241515] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241561] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13740), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241607] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241655] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241701] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14694), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241793] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14267), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241839] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [241885] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241931] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14795), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [241977] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14664), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242023] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242069] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14668), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242115] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242161] = 8,
    ACTIONS(15120), 1,
      sym__varid,
    ACTIONS(15123), 1,
      anon_sym_LPAREN,
    ACTIONS(14654), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    ACTIONS(15126), 2,
      anon_sym_EQ,
      anon_sym_deriving,
    STATE(11473), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15118), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14656), 20,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [242217] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [242263] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14064), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242309] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [242355] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14672), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242401] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14678), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242447] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14682), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242493] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14686), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242539] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [242585] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [242631] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [242677] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242723] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14698), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242769] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14656), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242815] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14702), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242861] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [242909] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13682), 29,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [242955] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13740), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243001] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243047] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243093] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13891), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243141] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14267), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243187] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243233] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [243279] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243325] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(6240), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [243373] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14060), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243419] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14748), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243465] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14787), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243511] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14824), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243557] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14714), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243603] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14111), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243649] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14064), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243695] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14824), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243741] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14111), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243787] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14060), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243833] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [243881] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [243927] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [243973] = 8,
    ACTIONS(15128), 1,
      sym__varid,
    ACTIONS(15131), 1,
      anon_sym_LPAREN,
    ACTIONS(14654), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    ACTIONS(15126), 2,
      anon_sym_EQ,
      anon_sym_deriving,
    STATE(11175), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15118), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14656), 20,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [244029] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [244075] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [244123] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13776), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244215] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14478), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244261] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244307] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13158), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244353] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14690), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244399] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14694), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14795), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244491] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14668), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244537] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14672), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244583] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [244629] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244675] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244721] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14042), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244767] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14678), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244813] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244859] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244905] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244951] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14682), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [244997] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245043] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14550), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [245091] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14824), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245137] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245183] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13736), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245229] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14686), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245275] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245321] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245367] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13740), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245413] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14267), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245459] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245505] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245551] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245597] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14698), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245643] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245689] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14714), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245735] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245781] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14740), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245827] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245873] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245919] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14111), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [245965] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246011] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246057] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246103] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13158), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246149] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246195] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246241] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14478), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246287] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246333] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246379] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246425] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [246471] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246517] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246563] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246609] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [246655] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [246701] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246749] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246795] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246843] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14257), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246889] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246937] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [246983] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247029] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247075] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247121] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247167] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247213] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247259] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247305] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14271), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247397] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [247443] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14748), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247489] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247535] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [247581] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [247627] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247673] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14042), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247719] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [247765] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247811] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [247857] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247903] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14787), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247949] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [247997] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [248043] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [248089] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [248135] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [248181] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [248227] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14690), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [248273] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [248319] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 31,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [248365] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [248411] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14694), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [248457] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [248503] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [248549] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [248595] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [248641] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [248687] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [248733] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [248779] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [248825] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14187), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [248871] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [248917] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [248963] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249009] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [249055] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249103] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249149] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249195] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249243] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [249289] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249335] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249381] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249427] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249473] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249519] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249567] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249613] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249659] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [249705] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249751] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249799] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249845] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14271), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249891] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [249937] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14251), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [249983] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [250029] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [250077] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [250123] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [250169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [250215] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [250261] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [250307] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [250353] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14664), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [250399] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [250445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [250491] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [250539] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [250585] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [250631] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [250677] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [250723] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [250769] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [250815] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [250861] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [250907] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [250953] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [250999] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [251045] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [251091] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [251137] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [251185] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14478), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [251231] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [251277] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [251323] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [251369] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 31,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [251415] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [251461] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 31,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [251507] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 31,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [251553] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [251599] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [251645] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [251691] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [251737] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 31,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [251783] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [251829] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [251875] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [251921] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 31,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [251967] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252012] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [252057] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14690), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [252102] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14694), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [252147] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252192] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13891), 26,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [252239] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252284] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252329] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252374] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252419] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252464] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252509] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14664), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [252554] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252599] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252644] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252691] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252736] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [252781] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [252826] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252871] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252916] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [252961] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14656), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [253006] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14702), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [253051] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253096] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14478), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [253141] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253186] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253231] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253276] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253321] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253366] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253411] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253456] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253501] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253546] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253591] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253681] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [253726] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253771] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253816] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253861] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253906] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253951] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [253998] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 28,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [254045] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [254090] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [254135] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14267), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [254180] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13740), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [254225] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [254270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14748), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [254315] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [254360] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [254405] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 28,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [254452] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [254497] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [254542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [254587] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14042), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [254632] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [254677] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [254722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [254767] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14824), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [254812] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14261), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [254859] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [254904] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15134), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3361), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 16,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [254967] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255012] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255057] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255102] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255147] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255237] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255282] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255327] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [255417] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255462] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255507] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255552] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14187), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [255597] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255642] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255687] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [255732] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255777] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255822] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [255867] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14060), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [255912] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [255957] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256002] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256047] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13158), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [256092] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256137] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256182] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13776), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [256227] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14191), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [256317] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14251), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [256362] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256407] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256454] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256501] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14787), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [256546] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256591] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256681] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256726] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14698), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [256771] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14271), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [256816] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256861] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256906] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14257), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [256951] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [256996] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [257041] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [257088] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13684), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [257133] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [257180] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14686), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [257225] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 28,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [257272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [257317] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [257362] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14064), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [257407] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [257452] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [257497] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [257542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14682), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [257587] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13717), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [257634] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [257681] = 8,
    ACTIONS(15136), 1,
      sym__varid,
    ACTIONS(15139), 1,
      anon_sym_LPAREN,
    ACTIONS(14654), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    ACTIONS(15126), 2,
      anon_sym_EQ,
      anon_sym_deriving,
    STATE(11865), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15118), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
    ACTIONS(14656), 20,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [257736] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [257781] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14678), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [257826] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13736), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [257871] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [257916] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14672), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [257961] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258006] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258051] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258096] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258141] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258186] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258231] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258276] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258321] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14740), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [258366] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [258411] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258456] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258501] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258546] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14550), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258593] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14714), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [258638] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258683] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258728] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258773] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(6240), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13721), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [258865] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13891), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [258910] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [258955] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [259000] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [259045] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259090] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [259135] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259180] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259225] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [259315] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259360] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259405] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259450] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259495] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259540] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259585] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259630] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [259675] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259765] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259810] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [259855] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [259900] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14795), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [259945] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [259990] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14111), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [260035] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 30,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [260080] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [260125] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [260172] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [260217] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [260262] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [260307] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13717), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [260354] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [260399] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14668), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [260444] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 30,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [260489] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 30,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [260534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [260579] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13682), 30,
      sym__dot,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [260624] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14261), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [260671] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14550), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [260718] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13682), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [260763] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [260808] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [260853] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(6240), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [260900] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [260945] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [260990] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 30,
      sym_where,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [261035] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [261081] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20690), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261131] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20571), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261181] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20430), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261231] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19996), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261281] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20206), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261331] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261375] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20065), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261425] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14550), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261471] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14740), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261515] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19938), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261565] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20981), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261615] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20526), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261665] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19094), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261715] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20812), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261765] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19171), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261815] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20232), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261865] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19522), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261915] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20331), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [261965] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19796), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262015] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19954), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262065] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19739), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262115] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19477), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262165] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19724), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262215] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19606), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262265] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19200), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262315] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(18997), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262365] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(6240), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262411] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(18962), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262461] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19182), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262511] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [262557] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19025), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262607] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19699), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262657] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20039), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262707] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20246), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262757] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19512), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262807] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19496), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262857] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19380), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262907] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(18919), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [262957] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19283), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263007] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20894), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263057] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20256), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263107] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20707), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263157] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263201] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19225), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263251] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19744), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263301] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19125), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263351] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19313), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263401] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13717), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263447] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20213), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263497] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19328), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263547] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(18920), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263597] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20929), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263647] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(6240), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263693] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19968), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263743] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263787] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19002), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263837] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19175), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263887] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(18921), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263937] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [263983] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264029] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14042), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264073] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19160), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264123] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19237), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264173] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19352), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264223] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264269] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14478), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264313] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264359] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_deriving,
    ACTIONS(13682), 27,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [264403] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14267), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264447] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13740), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264491] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14060), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264535] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14187), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264579] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19286), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264629] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20725), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264679] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20860), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264729] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13776), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264773] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14191), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264817] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14550), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264863] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19501), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264913] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [264957] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19655), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265007] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14251), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265051] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19605), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265101] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14271), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265145] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14257), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265189] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265233] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19329), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265283] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19775), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265333] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13682), 28,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265377] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13684), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265421] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19413), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265471] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265515] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14064), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265559] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19268), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265609] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19873), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265659] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14261), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265705] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20111), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265755] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19900), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265805] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19675), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265855] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19755), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265905] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14714), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265949] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14740), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [265993] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266037] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20958), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266087] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266131] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266175] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266219] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19915), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266269] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266313] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20783), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266363] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266407] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266451] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19967), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266501] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19253), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266551] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14261), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266597] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20071), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266647] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266691] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266735] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20437), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266785] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266829] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13717), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266875] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14714), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266919] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20059), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [266969] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14064), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267013] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14257), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267057] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(18942), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267107] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14271), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267151] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20138), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267201] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20096), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267251] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19238), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267301] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19298), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267351] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14251), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267395] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19370), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14060), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267489] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 30,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [267533] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20769), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267583] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19817), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267633] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14191), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267677] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267721] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267765] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267809] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20442), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267859] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13717), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [267905] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [267951] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20609), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268001] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14261), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [268047] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13740), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268091] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19164), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268141] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14267), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268185] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19466), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268235] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14478), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268279] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268325] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 30,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268369] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 30,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268413] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14042), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268457] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14550), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [268503] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268549] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268593] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20539), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268643] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20360), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268693] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [268739] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20276), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268789] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(6240), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [268835] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268879] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268923] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [268967] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(18990), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269017] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13721), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [269063] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269107] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14795), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269151] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19514), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269201] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20362), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269251] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269295] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14664), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269339] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14111), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269383] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19847), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269433] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19454), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269483] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14668), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269527] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14664), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269571] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20118), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269621] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269667] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 30,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [269711] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_deriving,
    ACTIONS(13682), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [269755] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20978), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269805] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269849] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14656), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269893] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14702), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269937] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14824), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [269981] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19624), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270031] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13158), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270075] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19220), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270125] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270171] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13776), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270215] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14187), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270259] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270303] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270347] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270391] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270435] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270481] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270525] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270571] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270615] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270659] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [270705] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [270751] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20489), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270801] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270847] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14672), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270891] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19193), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270941] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20590), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [270991] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271035] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14678), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271079] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14682), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271123] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271167] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13736), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271211] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14686), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271255] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20720), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271305] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271349] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271393] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14698), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271437] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14656), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271481] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19019), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271531] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19106), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271581] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20683), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271631] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14702), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271675] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14694), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271719] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271763] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20848), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271813] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14690), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271857] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20918), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271907] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20954), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [271957] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14111), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272001] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13891), 27,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272047] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13721), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272091] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14787), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272135] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14748), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272179] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14748), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272223] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14787), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272267] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13682), 27,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [272311] = 8,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(15142), 1,
      sym__varid,
    ACTIONS(15145), 1,
      anon_sym_LPAREN,
    ACTIONS(15148), 1,
      anon_sym_RPAREN,
    ACTIONS(14594), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    STATE(12167), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 24,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272365] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14824), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272409] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14698), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272453] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(13684), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272497] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14686), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272541] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13736), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272585] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20976), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272635] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13682), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272679] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14682), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272723] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14678), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272767] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14672), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272811] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272857] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20012), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272907] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(20171), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [272957] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14694), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273001] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14690), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273045] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273091] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13158), 28,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273135] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14795), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273179] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19135), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273229] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_DASH,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(14668), 29,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273273] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(19684), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273323] = 11,
    ACTIONS(13709), 1,
      anon_sym_AT2,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2440), 1,
      sym__colon2,
    STATE(13776), 1,
      aux_sym_signature_repeat1,
    STATE(16776), 1,
      sym__type_annotation,
    ACTIONS(15151), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13704), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13707), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13713), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [273382] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14271), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273425] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273468] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273513] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14060), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273556] = 7,
    ACTIONS(15154), 1,
      sym__varid,
    ACTIONS(15157), 1,
      anon_sym_LPAREN,
    ACTIONS(15160), 1,
      anon_sym_RPAREN,
    ACTIONS(14654), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    STATE(12021), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 24,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273607] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13740), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273650] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273693] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273736] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14824), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [273779] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13682), 27,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [273822] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15163), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(15068), 2,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3325), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 13,
      sym__varsym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [273883] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14111), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [273926] = 11,
    ACTIONS(13704), 1,
      sym__conid,
    ACTIONS(13711), 1,
      sym_comma,
    ACTIONS(15167), 1,
      anon_sym_AT2,
    STATE(2369), 1,
      sym__colon2,
    STATE(13926), 1,
      aux_sym_signature_repeat1,
    STATE(16688), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13707), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13713), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [273985] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [274028] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14740), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [274071] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [274114] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14702), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [274157] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [274200] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14656), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [274243] = 11,
    ACTIONS(13709), 1,
      anon_sym_AT2,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2369), 1,
      sym__colon2,
    STATE(13926), 1,
      aux_sym_signature_repeat1,
    STATE(16688), 1,
      sym__type_annotation,
    ACTIONS(13723), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13704), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13707), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13713), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [274302] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [274345] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14664), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [274388] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14267), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [274431] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [274474] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13717), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [274519] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14261), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [274564] = 7,
    ACTIONS(15086), 1,
      anon_sym_BQUOTE,
    ACTIONS(15089), 1,
      sym__consym,
    ACTIONS(15092), 1,
      sym__tyconsym,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(14889), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 23,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [274615] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [274658] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14795), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [274701] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 25,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [274746] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [274789] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [274832] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [274875] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14668), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [274918] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [274961] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13721), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [275006] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13721), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [275049] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [275092] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym_deriving,
    ACTIONS(13682), 26,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [275135] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14672), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [275178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14678), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [275221] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13684), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [275264] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14682), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [275307] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [275350] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15169), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3347), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [275411] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [275454] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [275497] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [275540] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14686), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [275583] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14698), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [275626] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [275669] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [275712] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [275755] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [275800] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14478), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [275843] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [275888] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [275931] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [275976] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [276019] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14714), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [276062] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14748), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [276105] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13682), 27,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [276148] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14787), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [276191] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [276234] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13776), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [276277] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [276320] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [276363] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [276406] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14187), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [276449] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [276492] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [276535] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14267), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [276578] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [276621] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13740), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [276664] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [276707] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14740), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [276750] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14064), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [276793] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [276838] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13717), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [276883] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14060), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [276926] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [276969] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277012] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 29,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [277055] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13684), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277098] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277141] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14042), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277184] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [277227] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277270] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13736), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277313] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277356] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [277401] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14690), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [277444] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14694), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [277487] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13776), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277530] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13684), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277573] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277616] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277661] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [277704] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14187), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14191), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277790] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [277833] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 29,
      sym__dot,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [277876] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14550), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [277921] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [277964] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [278007] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [278050] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [278093] = 11,
    ACTIONS(13709), 1,
      anon_sym_AT2,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2366), 1,
      sym__colon2,
    STATE(13956), 1,
      aux_sym_signature_repeat1,
    STATE(15003), 1,
      sym__type_annotation,
    ACTIONS(15171), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13704), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13707), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13713), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [278152] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [278195] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [278238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13736), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [278281] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [278324] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [278369] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 25,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [278414] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [278457] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [278500] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [278543] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14257), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [278586] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [278629] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14251), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [278672] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14261), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [278717] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [278760] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [278803] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [278848] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [278891] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [278934] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [278977] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279020] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279063] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279106] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [279151] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14795), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279194] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279237] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14664), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279280] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14668), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279323] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279366] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279409] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14672), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279452] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14678), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279495] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279538] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279581] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14682), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279624] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279667] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279710] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279753] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279796] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279839] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [279882] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [279925] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [279968] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [280011] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14064), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [280054] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14694), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280097] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [280140] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [280185] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14690), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280228] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280271] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14686), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280357] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [280400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14698), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280443] = 11,
    ACTIONS(13704), 1,
      sym__conid,
    ACTIONS(13711), 1,
      sym_comma,
    ACTIONS(15167), 1,
      anon_sym_AT2,
    STATE(2360), 1,
      sym__colon2,
    STATE(13849), 1,
      aux_sym_signature_repeat1,
    STATE(18067), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13707), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13713), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [280502] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14656), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280545] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14787), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280588] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14748), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280631] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14257), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [280674] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14698), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280717] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14686), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280803] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14682), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280846] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13682), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280889] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280932] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14678), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [280975] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [281018] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14702), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [281061] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [281104] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14672), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [281147] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [281190] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14271), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [281233] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14668), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [281276] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [281319] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14795), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [281362] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [281405] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14271), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [281448] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [281491] = 11,
    ACTIONS(13709), 1,
      anon_sym_AT2,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2360), 1,
      sym__colon2,
    STATE(13849), 1,
      aux_sym_signature_repeat1,
    STATE(18067), 1,
      sym__type_annotation,
    ACTIONS(14092), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13704), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13707), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13713), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [281550] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14257), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [281593] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14740), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [281636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14251), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [281679] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14191), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [281722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14748), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [281765] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14787), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [281808] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14714), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [281851] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13776), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [281894] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14824), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [281937] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [281982] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14060), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [282025] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282068] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14042), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282111] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13740), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [282154] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282197] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14267), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [282240] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282283] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282328] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282371] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14550), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282416] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14550), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282461] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [282504] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14714), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282547] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13158), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282590] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14187), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282633] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282676] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282719] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [282762] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282805] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 27,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [282850] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13682), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282893] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14478), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [282936] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14111), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [282979] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283022] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283065] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [283108] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(14042), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [283151] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [283196] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14064), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283239] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14690), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283282] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13721), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283327] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(6240), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14191), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283415] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14478), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283458] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283501] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14261), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283546] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14251), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283589] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14694), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283632] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [283677] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283720] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14261), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283765] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [283808] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13158), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283851] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13717), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283896] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13891), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [283939] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 27,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [283984] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(6240), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284029] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 29,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [284072] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13717), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284117] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14824), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284160] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14550), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284205] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [284248] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [284291] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284334] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(6240), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284379] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 29,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284422] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284465] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14702), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284508] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14111), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284551] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14656), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284594] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [284639] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284682] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284725] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_deriving,
    ACTIONS(13736), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [284768] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(6240), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284813] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [284858] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14664), 27,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284901] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [284946] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [284989] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 29,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [285032] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 29,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [285075] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14787), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [285117] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [285159] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [285201] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [285243] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [285285] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [285327] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14042), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [285369] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [285411] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [285453] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [285495] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [285537] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [285579] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14191), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [285621] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [285663] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13158), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [285705] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [285747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14478), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [285789] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [285831] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [285873] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14060), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [285915] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14187), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [285957] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [285999] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14694), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286041] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14678), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286083] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13682), 26,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286125] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14740), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286167] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [286209] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14251), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286251] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13158), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286293] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [286335] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [286377] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14682), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286419] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14257), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286461] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14478), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286503] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14261), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286547] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14111), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286589] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14271), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286631] = 10,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2360), 1,
      sym__colon2,
    STATE(13873), 1,
      aux_sym_signature_repeat1,
    STATE(18047), 1,
      sym__type_annotation,
    ACTIONS(14770), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13812), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13815), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13817), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [286687] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [286729] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [286771] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286813] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 24,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [286857] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [286899] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [286941] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [286983] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [287025] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14271), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [287067] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13776), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [287109] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [287151] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [287193] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14257), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [287235] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [287277] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [287321] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [287363] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 28,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [287405] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14824), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [287447] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14064), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [287489] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [287531] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [287573] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14748), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [287615] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14672), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [287657] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13684), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [287699] = 10,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2369), 1,
      sym__colon2,
    STATE(13938), 1,
      aux_sym_signature_repeat1,
    STATE(16772), 1,
      sym__type_annotation,
    ACTIONS(13802), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13812), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13815), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13817), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [287755] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13891), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [287797] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14064), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [287839] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [287881] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [287923] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [287965] = 5,
    ACTIONS(15178), 1,
      sym_comma,
    STATE(7388), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15174), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15176), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [288011] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13717), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [288055] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [288097] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [288139] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [288181] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [288223] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [288265] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13891), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [288307] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14694), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [288349] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14690), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [288391] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14668), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [288433] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13158), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [288475] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [288517] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [288559] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13721), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [288601] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14795), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [288643] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [288685] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14824), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [288727] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [288769] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [288811] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [288853] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13736), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [288895] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [288937] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [288979] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13158), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289021] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [289063] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13740), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289105] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14698), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289147] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14042), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289189] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14267), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289231] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [289273] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14824), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289315] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14787), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289357] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14748), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289399] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289443] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14698), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289485] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14748), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289527] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14656), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289569] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [289611] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [289653] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14686), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289695] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14740), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289737] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [289779] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15181), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3392), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_in,
  [289839] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14251), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289881] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14682), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [289923] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [289965] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14824), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290007] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14664), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290049] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14714), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290091] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 24,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290135] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [290177] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [290219] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14267), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290261] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14678), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290303] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14702), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290345] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14656), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290387] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14698), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290429] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14714), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290471] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14686), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290513] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14682), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290555] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14678), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290597] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14672), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290639] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14191), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290681] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [290723] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13684), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290765] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290809] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14111), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290851] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [290893] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14740), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290935] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14702), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [290977] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14656), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291019] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14664), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291061] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14672), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291103] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [291145] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14787), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291187] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14668), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291229] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14664), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291271] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14795), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291313] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [291355] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [291397] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13740), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291439] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14664), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291481] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291525] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14748), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291567] = 10,
    ACTIONS(13711), 1,
      sym_comma,
    ACTIONS(13812), 1,
      sym__conid,
    STATE(2360), 1,
      sym__colon2,
    STATE(13873), 1,
      aux_sym_signature_repeat1,
    STATE(18047), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13815), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13817), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [291623] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13891), 24,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291667] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14042), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291709] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [291751] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13776), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291793] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [291835] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15183), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3380), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [291895] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14787), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291937] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14060), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [291979] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [292021] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [292063] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14187), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [292105] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14690), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [292147] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [292189] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15185), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3349), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [292249] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [292291] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [292333] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14064), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [292375] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [292417] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13736), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [292459] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13684), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [292501] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [292543] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 26,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [292587] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [292629] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [292671] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [292713] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13721), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [292755] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [292797] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [292839] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [292881] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13736), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [292923] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [292965] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [293007] = 10,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2440), 1,
      sym__colon2,
    STATE(13795), 1,
      aux_sym_signature_repeat1,
    STATE(16524), 1,
      sym__type_annotation,
    ACTIONS(15187), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13812), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13815), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13817), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [293063] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14668), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293105] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [293147] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14257), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293189] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [293231] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15190), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3370), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [293291] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13740), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293333] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14271), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293375] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14251), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293417] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14702), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293459] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14191), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293501] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [293543] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14795), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293585] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13684), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293627] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [293669] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [293711] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14668), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293753] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14267), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293795] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14795), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293837] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [293879] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293923] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13776), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [293965] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [294007] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14060), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294049] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14191), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294091] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14060), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294133] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [294175] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13740), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294217] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14187), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294259] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14550), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294303] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14267), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294345] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15192), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3379), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [294405] = 10,
    ACTIONS(13711), 1,
      sym_comma,
    ACTIONS(13812), 1,
      sym__conid,
    STATE(2369), 1,
      sym__colon2,
    STATE(13938), 1,
      aux_sym_signature_repeat1,
    STATE(16772), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13815), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13817), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [294461] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [294503] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14478), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294545] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14042), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294587] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14111), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294629] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14187), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294671] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14702), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294713] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13776), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294755] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13891), 24,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294799] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [294841] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [294883] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [294925] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [294967] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [295009] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13736), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [295051] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14672), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [295093] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [295135] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14714), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [295177] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [295219] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [295261] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [295303] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14714), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [295345] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 26,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [295389] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15194), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(15068), 2,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3371), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 12,
      sym__varsym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [295449] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [295491] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14678), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [295533] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [295575] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14478), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [295617] = 10,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2366), 1,
      sym__colon2,
    STATE(13965), 1,
      aux_sym_signature_repeat1,
    STATE(15111), 1,
      sym__type_annotation,
    ACTIONS(15196), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(13812), 3,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13815), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(13817), 14,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_LBRACK,
      anon_sym_7,
  [295673] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [295717] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14686), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [295759] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [295801] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14682), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [295843] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14251), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [295885] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 28,
      sym__arith_dotdot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
      anon_sym_7,
  [295927] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [295969] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(6240), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296013] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [296055] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14690), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296097] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [296139] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14694), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296181] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [296223] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14271), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296265] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14690), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296307] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [296349] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14656), 26,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296391] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14257), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296433] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [296475] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14686), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296517] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [296559] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14111), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296601] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14740), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296643] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 28,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [296685] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14698), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296727] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [296771] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14064), 26,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296813] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 28,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_7,
  [296855] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14694), 26,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296897] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [296940] = 12,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_EQ,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15199), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3360), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [296999] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297040] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14251), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297081] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297122] = 5,
    ACTIONS(15203), 1,
      anon_sym_LBRACE,
    STATE(7875), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [297167] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14060), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297208] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13740), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297249] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14694), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297290] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14267), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297331] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14690), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14191), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297413] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14714), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297454] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13158), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297495] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297538] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297579] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14478), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297620] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297661] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13717), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [297704] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13682), 25,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [297745] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 25,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297788] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13684), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297829] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15205), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3326), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 12,
      sym__arith_dotdot,
      sym__varsym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [297888] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297931] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [297974] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15207), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3373), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
  [298033] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14824), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298074] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298115] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14787), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298156] = 7,
    ACTIONS(6264), 1,
      sym__dot,
    STATE(2360), 1,
      sym__colon2,
    STATE(18059), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 20,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_7,
  [298205] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14271), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298246] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298287] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 27,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298328] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298369] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13736), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298410] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14748), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298451] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298494] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298537] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14702), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298578] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14656), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298619] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14698), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298660] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14686), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298701] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14682), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14678), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298783] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14672), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298824] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13776), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298865] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14187), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298906] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14668), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298947] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14257), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [298988] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14664), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299029] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15209), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3348), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 12,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [299088] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13891), 23,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299131] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299174] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14795), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299215] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299256] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15211), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3383), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_in,
  [299315] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299356] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299397] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299438] = 7,
    ACTIONS(6264), 1,
      sym__dot,
    STATE(2381), 1,
      sym__colon2,
    STATE(15708), 1,
      sym__type_annotation,
    ACTIONS(15213), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 20,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_7,
  [299487] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(13721), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299528] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 27,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299569] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299610] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299651] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299692] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [299735] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2357), 1,
      sym__colon2,
    STATE(9567), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15217), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1978), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
    ACTIONS(15215), 11,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [299798] = 7,
    ACTIONS(6264), 1,
      sym__dot,
    STATE(2369), 1,
      sym__colon2,
    STATE(16674), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 20,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_7,
  [299847] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299888] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14064), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299929] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [299970] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300013] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14740), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300054] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300095] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300136] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15223), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3323), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 12,
      sym__layout_semicolon,
      sym__varsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [300195] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15225), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3395), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
  [300254] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300295] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300336] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300377] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300418] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300459] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300500] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300541] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300582] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300625] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300666] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300707] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300750] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300791] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300832] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300873] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300914] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [300955] = 12,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_EQ,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15227), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3362), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [301014] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [301055] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14111), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [301096] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [301137] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15229), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3332), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [301196] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_in,
    ACTIONS(14042), 25,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [301237] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 27,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [301278] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [301318] = 4,
    ACTIONS(15235), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [301360] = 4,
    ACTIONS(15237), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [301402] = 4,
    ACTIONS(15239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [301444] = 4,
    ACTIONS(15241), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [301486] = 4,
    ACTIONS(15243), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [301528] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15245), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15247), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [301568] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [301608] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [301648] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [301688] = 4,
    ACTIONS(15249), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [301730] = 4,
    ACTIONS(15251), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [301772] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [301812] = 4,
    ACTIONS(15253), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [301854] = 4,
    ACTIONS(15255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [301896] = 4,
    ACTIONS(15257), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [301938] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [301978] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15259), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3334), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 11,
      sym__varsym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [302036] = 4,
    ACTIONS(15261), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [302078] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [302118] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2360), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(12435), 1,
      sym__type_annotation,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
    ACTIONS(15215), 10,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [302180] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [302220] = 4,
    ACTIONS(15263), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [302262] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [302302] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [302342] = 4,
    ACTIONS(15265), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [302384] = 4,
    ACTIONS(15267), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [302426] = 4,
    ACTIONS(15269), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [302468] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15271), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(4109), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [302508] = 4,
    ACTIONS(15275), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [302550] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [302592] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13891), 23,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [302634] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [302674] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [302714] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [302754] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [302794] = 4,
    ACTIONS(15277), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [302836] = 4,
    ACTIONS(15279), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [302878] = 4,
    ACTIONS(15281), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [302920] = 4,
    ACTIONS(15283), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [302962] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303002] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303042] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303082] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303122] = 4,
    ACTIONS(15285), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [303164] = 4,
    ACTIONS(15287), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [303206] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303246] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303286] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303326] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303366] = 4,
    ACTIONS(15289), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [303408] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303448] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303488] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303528] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303568] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303608] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303648] = 4,
    ACTIONS(15291), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [303690] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303730] = 4,
    ACTIONS(15293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [303772] = 4,
    ACTIONS(15295), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [303814] = 4,
    ACTIONS(15297), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [303856] = 4,
    ACTIONS(15299), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [303898] = 4,
    ACTIONS(15301), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [303940] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [303980] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [304020] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [304060] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [304100] = 4,
    ACTIONS(15303), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [304142] = 4,
    ACTIONS(15305), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [304184] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [304224] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [304264] = 4,
    ACTIONS(15307), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [304306] = 4,
    ACTIONS(15309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [304348] = 4,
    ACTIONS(15311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [304390] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15313), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3390), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 11,
      sym_where,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [304448] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [304488] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [304528] = 4,
    ACTIONS(15315), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [304570] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [304610] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [304650] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [304690] = 4,
    ACTIONS(15317), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [304732] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [304772] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15319), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3374), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
  [304830] = 4,
    ACTIONS(15321), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [304872] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [304912] = 4,
    ACTIONS(15323), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [304954] = 5,
    ACTIONS(15325), 1,
      anon_sym_LBRACE,
    STATE(7959), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [304998] = 6,
    STATE(2360), 1,
      sym__colon2,
    STATE(18315), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 20,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_7,
  [305044] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [305084] = 4,
    ACTIONS(15327), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305126] = 4,
    ACTIONS(15329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305168] = 4,
    ACTIONS(15331), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305210] = 4,
    ACTIONS(15333), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305252] = 4,
    ACTIONS(15335), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305294] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [305334] = 4,
    ACTIONS(15337), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305376] = 4,
    ACTIONS(15339), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305418] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [305458] = 4,
    ACTIONS(15341), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305500] = 4,
    ACTIONS(15343), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305542] = 4,
    ACTIONS(15345), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305584] = 4,
    ACTIONS(15347), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305626] = 4,
    ACTIONS(15349), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305668] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [305708] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2430), 1,
      sym__colon2,
    STATE(9685), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15351), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
    ACTIONS(15215), 10,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [305770] = 4,
    ACTIONS(15353), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305812] = 4,
    ACTIONS(15355), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305854] = 4,
    ACTIONS(15357), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [305896] = 12,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_EQ,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15359), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3386), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 11,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [305954] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [305994] = 8,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(15361), 1,
      sym__varid,
    ACTIONS(15364), 1,
      anon_sym_LPAREN,
    ACTIONS(14594), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    STATE(12369), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15074), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(6240), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_7,
  [306044] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15367), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15369), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [306084] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15371), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15373), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [306124] = 5,
    ACTIONS(15375), 1,
      anon_sym_LBRACE,
    STATE(8014), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [306168] = 4,
    ACTIONS(15377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [306210] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [306250] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [306290] = 4,
    ACTIONS(15379), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [306332] = 4,
    ACTIONS(15381), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [306374] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [306414] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13717), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [306456] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [306496] = 4,
    ACTIONS(15383), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [306538] = 4,
    ACTIONS(15385), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [306580] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [306620] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [306660] = 4,
    ACTIONS(15387), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [306702] = 4,
    ACTIONS(15389), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [306744] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15391), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3336), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 11,
      sym__layout_semicolon,
      sym__varsym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
  [306802] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [306842] = 4,
    ACTIONS(15393), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [306884] = 4,
    ACTIONS(15395), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [306926] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [306966] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [307006] = 4,
    ACTIONS(15397), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [307048] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [307088] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [307128] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13682), 24,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [307168] = 4,
    ACTIONS(15399), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [307210] = 6,
    STATE(2381), 1,
      sym__colon2,
    STATE(16350), 1,
      sym__type_annotation,
    ACTIONS(15213), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 20,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_7,
  [307256] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [307296] = 4,
    ACTIONS(15401), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [307338] = 4,
    ACTIONS(15403), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [307380] = 4,
    ACTIONS(15405), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [307422] = 4,
    ACTIONS(15407), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [307464] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [307504] = 4,
    ACTIONS(15409), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [307546] = 6,
    STATE(2369), 1,
      sym__colon2,
    STATE(16206), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 20,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_7,
  [307592] = 4,
    ACTIONS(15411), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [307634] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [307674] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 25,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_AT2,
      anon_sym_7,
  [307714] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [307754] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [307794] = 4,
    ACTIONS(15413), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [307836] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [307876] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [307916] = 4,
    ACTIONS(15415), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [307958] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [307998] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15417), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15419), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [308038] = 4,
    ACTIONS(15421), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [308080] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15423), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15425), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [308120] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 24,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [308162] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [308202] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15427), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15429), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      anon_sym_RPAREN,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [308242] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [308282] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(13717), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [308324] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(13721), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [308366] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [308406] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(13682), 22,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [308446] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [308486] = 4,
    ACTIONS(14922), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 24,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [308528] = 4,
    ACTIONS(15431), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [308570] = 4,
    ACTIONS(15433), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15231), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15233), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [308612] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [308652] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_comma,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [308692] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 26,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__varid,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_PERCENT,
      anon_sym_7,
  [308732] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [308771] = 8,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(15142), 1,
      sym__varid,
    ACTIONS(15145), 1,
      anon_sym_LPAREN,
    ACTIONS(14594), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    STATE(12167), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15074), 4,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
    ACTIONS(6240), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_7,
  [308820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [308859] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [308898] = 4,
    ACTIONS(15443), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [308939] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [308978] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309017] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 24,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT2,
      anon_sym_7,
  [309056] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309095] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309134] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(14111), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309173] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13717), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [309214] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309253] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(13736), 22,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_AT2,
      anon_sym_7,
  [309292] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [309333] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [309411] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309450] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14261), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [309491] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309530] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15461), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3398), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 10,
      sym__varsym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
  [309587] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [309626] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309665] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15467), 9,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_let,
      anon_sym_if,
      anon_sym_case,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(15469), 19,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym_label,
      anon_sym_DASH,
      sym_implicit_parid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_SQUOTE_SQUOTE,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_7,
  [309704] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309743] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309782] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309821] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309860] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309899] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [309938] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13721), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [309979] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13721), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [310020] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13717), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [310061] = 12,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15104), 1,
      sym__conid,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(15495), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3404), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 10,
      sym__varsym,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [310118] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [310157] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14550), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [310198] = 4,
    ACTIONS(15497), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [310239] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [310278] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [310317] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [310356] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(6240), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [310397] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13682), 24,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [310436] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [310475] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [310514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13682), 23,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [310553] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [310592] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 7,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(13721), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [310631] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 24,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
      anon_sym_7,
  [310670] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [310709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [310748] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [310787] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [310826] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [310865] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14261), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [310906] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [310945] = 5,
    ACTIONS(15507), 1,
      anon_sym_LBRACE,
    STATE(8167), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [310988] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14550), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [311029] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [311068] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [311107] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [311146] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13717), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [311187] = 7,
    ACTIONS(15515), 1,
      sym__varid,
    ACTIONS(15518), 1,
      anon_sym_LPAREN,
    ACTIONS(14654), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    STATE(12498), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15118), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(14656), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_7,
  [311234] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(6240), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [311275] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13682), 23,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [311314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13682), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [311353] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15521), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3327), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [311408] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 24,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [311447] = 7,
    ACTIONS(15086), 1,
      anon_sym_BQUOTE,
    ACTIONS(15089), 1,
      sym__consym,
    ACTIONS(15523), 1,
      sym__tyconsym,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(15317), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [311493] = 5,
    ACTIONS(15526), 1,
      anon_sym_LBRACE,
    STATE(8550), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [311535] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [311573] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [311611] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [311649] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [311687] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [311725] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(14267), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [311763] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [311801] = 7,
    ACTIONS(15154), 1,
      sym__varid,
    ACTIONS(15157), 1,
      anon_sym_LPAREN,
    ACTIONS(14654), 2,
      sym__integer_literal,
      anon_sym_SQUOTE,
    STATE(12021), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15118), 4,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RBRACE,
    ACTIONS(14656), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_7,
  [311847] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(13740), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [311885] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [311923] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [311961] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [311999] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13891), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [312037] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13682), 22,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [312075] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [312113] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [312151] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [312189] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14064), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [312227] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [312265] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [312303] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13717), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [312343] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [312381] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [312419] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13684), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [312457] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15528), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3401), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 10,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [312511] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14257), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [312549] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14795), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [312587] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [312625] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(14042), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [312663] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14664), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [312701] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14668), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [312739] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14672), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [312777] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [312817] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14678), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [312855] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(14478), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [312893] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14682), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [312931] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14698), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [312969] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14656), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313007] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14702), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313045] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14748), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313083] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14787), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313121] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14824), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313159] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14271), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313197] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13682), 22,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [313235] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13158), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313273] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14690), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313311] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14694), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313349] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14251), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313387] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT2,
      anon_sym_7,
  [313425] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [313465] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14191), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313503] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13776), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313541] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(14060), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [313579] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14187), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313617] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [313655] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14060), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313693] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(14191), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [313731] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13740), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313769] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(14251), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [313807] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14267), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313845] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [313883] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [313921] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14478), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [313959] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [313997] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [314035] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14042), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [314073] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14686), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [314111] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13717), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [314151] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15530), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3337), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 10,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [314205] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13736), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [314243] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [314281] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [314319] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14740), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [314357] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [314397] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2359), 1,
      sym__colon2,
    STATE(10217), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15532), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1997), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
    ACTIONS(15215), 8,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [314457] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(14064), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [314495] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13721), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [314535] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [314573] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13717), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [314613] = 5,
    ACTIONS(15534), 1,
      anon_sym_LBRACE,
    STATE(8637), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [314655] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [314693] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [314733] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(14187), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [314771] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(13776), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [314809] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(14271), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [314847] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14714), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [314885] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13891), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [314923] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [314963] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [315001] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [315039] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [315077] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [315115] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [315153] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [315191] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [315229] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(13684), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [315267] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [315305] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [315345] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [315383] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15536), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3356), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [315437] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [315475] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14111), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [315513] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13682), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [315551] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13721), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [315589] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [315627] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(14257), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [315665] = 5,
    ACTIONS(15538), 1,
      anon_sym_LBRACE,
    STATE(8641), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [315707] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13721), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [315745] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [315783] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14111), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [315821] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [315859] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13682), 23,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [315897] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(6240), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [315937] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [315975] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [316013] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14550), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316053] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14664), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316091] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13717), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [316131] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14261), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316171] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14656), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316209] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14702), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316247] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14824), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316285] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13158), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316323] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [316361] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [316399] = 4,
    ACTIONS(15540), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [316439] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [316477] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316517] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [316555] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13736), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316593] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14550), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316633] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(6240), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316673] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14795), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316711] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [316749] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [316787] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14261), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316827] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14668), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316865] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13682), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316903] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14672), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316941] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14678), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [316979] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14682), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [317017] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14686), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [317055] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [317093] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14698), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [317131] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [317169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [317207] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [317245] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14748), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [317283] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [317321] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14787), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [317359] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14690), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [317397] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14694), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [317435] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [317475] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [317515] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14187), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [317553] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [317591] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 6,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
      anon_sym_deriving,
    ACTIONS(13891), 21,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_7,
  [317629] = 5,
    ACTIONS(15542), 1,
      anon_sym_LBRACE,
    STATE(8430), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [317671] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13776), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [317709] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13684), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [317747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [317785] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 24,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [317823] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [317861] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 24,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [317899] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [317937] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15544), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3408), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [317991] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13717), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [318031] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14042), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318069] = 5,
    ACTIONS(15546), 1,
      anon_sym_LBRACE,
    STATE(8463), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [318111] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15548), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3363), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
    ACTIONS(15062), 10,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [318165] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [318203] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [318241] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [318281] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13682), 22,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [318319] = 12,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15068), 1,
      anon_sym_EQ,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15550), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 9,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_deriving,
    STATE(3328), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [318375] = 7,
    ACTIONS(15086), 1,
      anon_sym_BQUOTE,
    ACTIONS(15089), 1,
      sym__consym,
    ACTIONS(15552), 1,
      sym__tyconsym,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(14635), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318421] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14478), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318459] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14267), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318497] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13740), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318535] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [318573] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14060), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318611] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14191), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318649] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14251), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318687] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14271), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318725] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14257), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318763] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14064), 22,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318801] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318841] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [318879] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [318917] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13717), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318957] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13721), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [318997] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [319035] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13682), 22,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [319073] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319113] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13717), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [319153] = 7,
    ACTIONS(15086), 1,
      anon_sym_BQUOTE,
    ACTIONS(15089), 1,
      sym__consym,
    ACTIONS(15555), 1,
      sym__tyconsym,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(14906), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319199] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [319237] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319277] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14740), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319315] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [319353] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [319391] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319431] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13682), 22,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319469] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [319507] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14714), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym__tyconsym,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319545] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 23,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [319583] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [319621] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 23,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [319659] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319699] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319736] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319773] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [319812] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14251), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319849] = 4,
    ACTIONS(15558), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [319888] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14271), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319925] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14478), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319962] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14267), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [319999] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13740), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [320036] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14060), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [320073] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [320112] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14191), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [320149] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [320186] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [320223] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [320260] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14251), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [320297] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [320334] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14271), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [320371] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14257), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [320408] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [320445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [320482] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [320519] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [320556] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [320593] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [320630] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_7,
  [320667] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14064), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [320704] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [320741] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_7,
  [320778] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [320815] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [320852] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [320889] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [320926] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [320963] = 4,
    ACTIONS(15560), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [321002] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321039] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321076] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321113] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 23,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [321150] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321187] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321224] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [321261] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [321298] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321335] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [321374] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14257), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321411] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321448] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [321485] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14060), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [321559] = 7,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(15562), 1,
      anon_sym_BQUOTE,
    ACTIONS(15564), 1,
      sym__tyconsym,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(15390), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_7,
  [321604] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321641] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13740), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321678] = 5,
    ACTIONS(15566), 1,
      anon_sym_LBRACE,
    STATE(8903), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [321719] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [321756] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321793] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321830] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [321869] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2379), 1,
      sym__colon2,
    STATE(10530), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15568), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 7,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
    STATE(1991), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [321928] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14267), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [321965] = 7,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(15562), 1,
      anon_sym_BQUOTE,
    ACTIONS(15570), 1,
      sym__tyconsym,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    STATE(14889), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_EQ,
      anon_sym_7,
  [322010] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322047] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15572), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15574), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322084] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [322121] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14478), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322158] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14042), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322195] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322232] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13682), 21,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [322269] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13721), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322306] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [322343] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15576), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15578), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322380] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14111), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322417] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [322454] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_7,
  [322491] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322528] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [322565] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [322602] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322639] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322676] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13717), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [322715] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [322752] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [322789] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322828] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14187), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322865] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13776), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [322902] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15580), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 9,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
    STATE(3388), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [322955] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15582), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
    STATE(3364), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [323008] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 23,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323045] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323084] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13684), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323121] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323158] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323195] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [323232] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323269] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14191), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323306] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323343] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323380] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323417] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323454] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323491] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323528] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [323565] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323602] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323639] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13721), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323676] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14111), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323713] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323750] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323787] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15584), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 9,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
    STATE(3335), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [323840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14740), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323877] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323914] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [323951] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [323988] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13776), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324025] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13717), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [324064] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14187), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324101] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14714), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324138] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324175] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [324212] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [324249] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [324286] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324323] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324360] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13684), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324397] = 4,
    ACTIONS(15586), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [324436] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324473] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13891), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324510] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [324547] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324584] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [324623] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324660] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13736), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324697] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13682), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [324734] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13736), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324771] = 5,
    ACTIONS(15588), 1,
      anon_sym_LBRACE,
    STATE(8914), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [324812] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [324849] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [324886] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [324925] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324962] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14714), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [324999] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15576), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15578), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [325036] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [325073] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [325110] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [325147] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [325184] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [325223] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14740), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [325260] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15590), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 9,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
    STATE(3322), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [325313] = 5,
    ACTIONS(15592), 1,
      anon_sym_LBRACE,
    STATE(8753), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [325354] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [325391] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_AT2,
      anon_sym_7,
  [325428] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15572), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15574), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [325465] = 4,
    ACTIONS(15594), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [325504] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 22,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
      anon_sym_7,
  [325541] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [325578] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [325615] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14064), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [325652] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15596), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
    STATE(3399), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [325705] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [325742] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2401), 1,
      sym__colon2,
    STATE(10618), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15598), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    STATE(1987), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [325801] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [325838] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15600), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 9,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
    STATE(3406), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [325891] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [325928] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [325965] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326004] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326043] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [326080] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326117] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326154] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326191] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326228] = 4,
    ACTIONS(15602), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [326267] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326304] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326341] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2393), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13226), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15604), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    STATE(1987), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [326400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [326437] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [326474] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326513] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326550] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [326587] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326624] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [326661] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13717), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [326700] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326737] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326774] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326811] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [326848] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14261), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [326887] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326924] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [326961] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327000] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327039] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327076] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13682), 21,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [327113] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14694), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327150] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14690), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327187] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14694), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327224] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327261] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14690), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327298] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327335] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13158), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327372] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327409] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13158), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327446] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 23,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327483] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [327522] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327561] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14824), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327635] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [327672] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327711] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14787), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327748] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 22,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [327785] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327822] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14824), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327859] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14748), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327896] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327933] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14702), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [327970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14656), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328007] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14698), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328044] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14686), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328081] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14682), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328118] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14678), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328155] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14672), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328192] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14795), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328229] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14664), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328266] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14668), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328303] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14668), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328340] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14664), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328377] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14795), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328414] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14787), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328451] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [328488] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14672), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328525] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14678), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328562] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [328599] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14682), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14686), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328673] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14748), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328710] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14042), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328747] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13891), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328784] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14698), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328821] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14656), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328858] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14702), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328895] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 23,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [328932] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14550), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [328971] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [329010] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(6240), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [329049] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15606), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
    STATE(3378), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [329102] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14698), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [329138] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [329174] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [329210] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [329246] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(13158), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [329282] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [329318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [329354] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [329390] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [329426] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [329462] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [329498] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [329534] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [329570] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14690), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [329606] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [329642] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14824), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [329678] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [329714] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14787), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [329750] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14748), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [329786] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [329822] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [329858] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [329894] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [329930] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14694), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [329966] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [330002] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [330038] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [330074] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [330112] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [330148] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [330184] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [330220] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [330256] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [330292] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14702), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [330328] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [330364] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 22,
      sym__layout_semicolon,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [330400] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [330436] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [330472] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [330508] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [330544] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [330580] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14656), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [330616] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [330652] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14686), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [330688] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14682), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [330724] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14678), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [330760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14672), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [330796] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [330832] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [330868] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [330904] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [330940] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [330976] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [331012] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [331048] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14668), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [331084] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14664), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [331120] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14795), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [331156] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [331192] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [331228] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [331264] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [331300] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [331336] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [331372] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [331408] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [331444] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [331480] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [331516] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [331552] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [331588] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [331624] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [331660] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [331696] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [331732] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [331768] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [331804] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [331840] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [331876] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [331912] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [331948] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [331984] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332056] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332092] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [332128] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [332164] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [332200] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332236] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [332272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332308] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332344] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332380] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [332416] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [332452] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [332488] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 22,
      sym__dot,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [332524] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13717), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [332562] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [332598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332634] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [332670] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [332706] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332778] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [332814] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332850] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332886] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332922] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [332958] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [332994] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [333030] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [333066] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [333104] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [333140] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [333176] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [333212] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [333248] = 4,
    ACTIONS(15608), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [333286] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [333324] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [333360] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [333396] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [333432] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [333468] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [333506] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15576), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15578), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [333542] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15572), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(15574), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [333578] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [333614] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [333650] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [333686] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [333722] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [333758] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [333794] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [333830] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [333866] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [333902] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [333938] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [333974] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [334010] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [334046] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [334082] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [334118] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [334154] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [334190] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [334226] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [334262] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [334298] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [334334] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [334370] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [334408] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13721), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [334446] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [334482] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [334518] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [334554] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [334592] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [334628] = 5,
    ACTIONS(15610), 1,
      anon_sym_LBRACE,
    STATE(9052), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [334668] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [334704] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [334740] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [334776] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [334812] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [334848] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [334884] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [334920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [334956] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [334992] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [335028] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [335064] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [335100] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [335136] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [335172] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [335208] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [335244] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [335280] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14259), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14261), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [335318] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [335354] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [335390] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [335426] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15612), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 8,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
    STATE(3359), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [335478] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [335514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [335550] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [335586] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14548), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14550), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [335624] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [335660] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [335696] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [335732] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14740), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [335768] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [335804] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_deriving,
    ACTIONS(14714), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [335840] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [335876] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [335912] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [335948] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [335984] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [336020] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [336056] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [336094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [336130] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [336166] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [336202] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [336238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 21,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_AT2,
      anon_sym_7,
  [336274] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [336310] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [336346] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [336382] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [336418] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [336454] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [336490] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [336526] = 4,
    ACTIONS(15614), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [336564] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [336600] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [336636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [336672] = 4,
    ACTIONS(15616), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [336710] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [336746] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [336782] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2435), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13473), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15618), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(1984), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [336840] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [336876] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [336914] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [336950] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [336986] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [337022] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [337058] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [337094] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [337130] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [337166] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [337202] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [337238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [337274] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [337310] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [337346] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [337382] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [337418] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [337454] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [337490] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [337526] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [337562] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [337598] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [337634] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [337670] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [337706] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [337742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [337778] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [337814] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [337850] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [337886] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [337922] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [337958] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2426), 1,
      sym__colon2,
    STATE(11331), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15622), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(1984), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [338016] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 21,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338052] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [338088] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [338124] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338160] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338196] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338232] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15624), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 8,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
    STATE(3417), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [338284] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338320] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [338356] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338392] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [338428] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338464] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338500] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 22,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [338536] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [338574] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [338610] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338646] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338682] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [338718] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [338754] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338790] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338826] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [338862] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [338900] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338936] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [338972] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [339008] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [339044] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [339080] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [339116] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [339152] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [339188] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [339224] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [339260] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [339296] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 21,
      sym__splice_dollar,
      sym__consym,
      sym_comma,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [339332] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [339368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [339404] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14594), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(6240), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [339442] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [339478] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [339514] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [339550] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [339586] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [339622] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [339658] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [339694] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [339730] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [339766] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [339802] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [339838] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [339874] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_7,
  [339910] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [339946] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [339982] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [340018] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [340054] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [340092] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [340128] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [340164] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [340200] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [340236] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 22,
      sym__layout_semicolon,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [340272] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [340308] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [340346] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [340382] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [340418] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [340454] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [340490] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [340526] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [340564] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [340600] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_7,
  [340636] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [340672] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [340710] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [340748] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [340784] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [340820] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [340856] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [340892] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [340928] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [340964] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341000] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [341036] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [341072] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 21,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym__unboxed_close,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_7,
  [341108] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 22,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [341144] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341180] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [341215] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [341250] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341285] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15626), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 7,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
    STATE(3369), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [341336] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341371] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341406] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341441] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14712), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14714), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [341476] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341511] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341546] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341581] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341616] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14060), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [341651] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341686] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [341721] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341756] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341791] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [341826] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341861] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341896] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14191), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [341931] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [341966] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14251), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [342001] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [342036] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [342071] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [342106] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [342141] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2383), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(14119), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15628), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(1988), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [342198] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [342233] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [342268] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [342303] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [342338] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [342373] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [342408] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [342443] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [342478] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14271), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [342513] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [342548] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [342583] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14257), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [342618] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [342653] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [342688] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2405), 1,
      sym__colon2,
    STATE(11603), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15630), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    STATE(1994), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [342745] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [342780] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [342815] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [342850] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [342885] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14700), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14702), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [342920] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2424), 1,
      sym__colon2,
    STATE(11558), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15632), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(1988), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [342977] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [343012] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [343047] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [343082] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [343117] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [343152] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2373), 1,
      sym__colon2,
    STATE(11638), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15634), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(1979), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [343209] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [343244] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [343279] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [343314] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [343349] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [343384] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [343419] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [343454] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [343489] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [343524] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2384), 1,
      sym__colon2,
    STATE(11818), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15636), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(1989), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [343581] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2414), 1,
      sym__colon2,
    STATE(11652), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15638), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1999), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [343638] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [343673] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [343708] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [343743] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [343778] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [343813] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [343848] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [343883] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [343918] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [343953] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13740), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [343988] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [344023] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [344058] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [344093] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14267), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [344128] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [344163] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [344198] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [344233] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [344268] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [344303] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [344338] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [344373] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [344408] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [344443] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [344478] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [344513] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14042), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [344548] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [344583] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [344618] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [344653] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [344688] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [344723] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [344758] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14680), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14682), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [344793] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [344828] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [344863] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [344898] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [344933] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [344968] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [345003] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [345038] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [345073] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [345108] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [345143] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [345178] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [345213] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14478), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [345248] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [345283] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [345318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [345353] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [345388] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2391), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(14402), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15640), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
    STATE(1979), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [345445] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13891), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [345480] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [345515] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [345550] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [345585] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [345620] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [345655] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14738), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14740), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [345690] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [345725] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [345760] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [345795] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [345830] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [345865] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [345900] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [345935] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14064), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [345970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [346005] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [346040] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [346075] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [346110] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [346145] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14793), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14795), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [346180] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [346215] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [346250] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14674), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13158), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [346285] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [346320] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [346355] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14662), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14664), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [346390] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [346425] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14666), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14668), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [346460] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15642), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 7,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
    STATE(3331), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [346511] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14111), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [346546] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 20,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_7,
  [346581] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [346616] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [346651] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [346688] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13684), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [346723] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [346758] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [346793] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [346830] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14670), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14672), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [346865] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [346900] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [346935] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [346970] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [347005] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [347042] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [347077] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [347112] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [347147] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [347182] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [347217] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14676), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14678), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [347252] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [347287] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14684), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14686), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [347322] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14696), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14698), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [347357] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [347392] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [347427] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [347462] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [347497] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [347532] = 3,
    ACTIONS(13680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 21,
      sym__dot,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [347567] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [347602] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [347637] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [347672] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14822), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14824), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [347707] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [347742] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [347777] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [347812] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [347847] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13776), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [347882] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [347917] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [347952] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2395), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(14210), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15644), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(1989), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [348009] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [348044] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [348079] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14187), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [348114] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [348149] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [348184] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [348219] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2416), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(14156), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15646), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1999), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [348276] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [348311] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [348346] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [348381] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [348416] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [348451] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13721), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [348486] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [348523] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14746), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14748), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [348558] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14785), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14787), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [348593] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [348630] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [348665] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2365), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(14597), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15648), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    STATE(1994), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [348722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [348757] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [348792] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [348827] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [348862] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [348897] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14688), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14690), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [348932] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [348967] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [349002] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 20,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [349037] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14692), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14694), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [349072] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [349107] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 20,
      sym_where,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
      anon_sym_7,
  [349142] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [349177] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [349212] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [349247] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(13736), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [349282] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [349317] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [349352] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [349387] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [349422] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [349457] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [349492] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [349527] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [349562] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [349597] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14654), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_EQ,
    ACTIONS(14656), 20,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [349632] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [349667] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [349702] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [349737] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [349772] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [349807] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [349842] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [349877] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [349912] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [349947] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [349982] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [350017] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [350052] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [350087] = 4,
    ACTIONS(15650), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [350124] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [350159] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 21,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [350194] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [350229] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [350264] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [350299] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [350334] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [350369] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [350404] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [350439] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 21,
      sym_where,
      sym__splice_dollar,
      sym_quasiquote_start,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_RBRACE,
      anon_sym_7,
  [350474] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 20,
      sym__layout_semicolon,
      sym__layout_end,
      sym__splice_dollar,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [350509] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 21,
      sym__layout_semicolon,
      sym__splice_dollar,
      sym_quasiquote_start,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [350544] = 13,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(15652), 1,
      anon_sym_LPAREN,
    STATE(6178), 1,
      sym_constructor,
    STATE(6411), 1,
      sym_qualified_type,
    STATE(14649), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4016), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [350598] = 13,
    ACTIONS(7401), 1,
      sym__integer_literal,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(7413), 1,
      anon_sym_LBRACK,
    ACTIONS(15654), 1,
      anon_sym_LPAREN,
    STATE(6178), 1,
      sym_constructor,
    STATE(6411), 1,
      sym_qualified_type,
    STATE(14649), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7399), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7403), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6502), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6509), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [350652] = 3,
    ACTIONS(13889), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [350686] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [350720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [350754] = 13,
    ACTIONS(9242), 1,
      sym__integer_literal,
    ACTIONS(9252), 1,
      sym__conid,
    ACTIONS(14229), 1,
      anon_sym_LBRACK,
    ACTIONS(15656), 1,
      anon_sym_LPAREN,
    STATE(9790), 1,
      sym_constructor,
    STATE(10250), 1,
      sym_qualified_type,
    STATE(15417), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9244), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14223), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10249), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(10257), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [350808] = 13,
    ACTIONS(12490), 1,
      sym__conid,
    ACTIONS(12953), 1,
      sym__integer_literal,
    ACTIONS(12961), 1,
      anon_sym_LBRACK,
    ACTIONS(15658), 1,
      anon_sym_LPAREN,
    STATE(8546), 1,
      sym_constructor,
    STATE(8765), 1,
      sym_qualified_type,
    STATE(14954), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12951), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12955), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8800), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8809), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [350862] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [350896] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [350930] = 13,
    ACTIONS(885), 1,
      sym__integer_literal,
    ACTIONS(4289), 1,
      sym__conid,
    ACTIONS(14574), 1,
      anon_sym_LBRACK,
    ACTIONS(15660), 1,
      anon_sym_LPAREN,
    STATE(5097), 1,
      sym_constructor,
    STATE(5645), 1,
      sym_qualified_type,
    STATE(15340), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(887), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14568), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5644), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5655), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [350984] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [351018] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [351052] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [351086] = 13,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(15662), 1,
      anon_sym_LPAREN,
    STATE(5963), 1,
      sym_constructor,
    STATE(6407), 1,
      sym_qualified_type,
    STATE(15009), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4016), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [351140] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [351174] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [351208] = 13,
    ACTIONS(4397), 1,
      sym__integer_literal,
    ACTIONS(4407), 1,
      sym__conid,
    ACTIONS(13845), 1,
      anon_sym_LBRACK,
    ACTIONS(15664), 1,
      anon_sym_LPAREN,
    STATE(10066), 1,
      sym_constructor,
    STATE(10809), 1,
      sym_qualified_type,
    STATE(15320), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4399), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13839), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10808), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(10824), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [351262] = 13,
    ACTIONS(6535), 1,
      sym__integer_literal,
    ACTIONS(6545), 1,
      sym__conid,
    ACTIONS(6547), 1,
      anon_sym_LBRACK,
    ACTIONS(15666), 1,
      anon_sym_LPAREN,
    STATE(7041), 1,
      sym_constructor,
    STATE(7068), 1,
      sym_qualified_type,
    STATE(15261), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6533), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6537), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7210), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7224), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [351316] = 13,
    ACTIONS(7130), 1,
      sym__integer_literal,
    ACTIONS(7140), 1,
      sym__conid,
    ACTIONS(7142), 1,
      anon_sym_LBRACK,
    ACTIONS(15668), 1,
      anon_sym_LPAREN,
    STATE(6214), 1,
      sym_constructor,
    STATE(6460), 1,
      sym_qualified_type,
    STATE(15251), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7128), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7132), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6535), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6402), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [351370] = 13,
    ACTIONS(8757), 1,
      sym__integer_literal,
    ACTIONS(8765), 1,
      sym__conid,
    ACTIONS(14165), 1,
      anon_sym_LBRACK,
    ACTIONS(15670), 1,
      anon_sym_LPAREN,
    STATE(11319), 1,
      sym_constructor,
    STATE(11928), 1,
      sym_qualified_type,
    STATE(15267), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8759), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14159), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11758), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11561), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [351424] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [351458] = 13,
    ACTIONS(2411), 1,
      sym__integer_literal,
    ACTIONS(4211), 1,
      sym__conid,
    ACTIONS(14470), 1,
      anon_sym_LBRACK,
    ACTIONS(15672), 1,
      anon_sym_LPAREN,
    STATE(4302), 1,
      sym_constructor,
    STATE(4752), 1,
      sym_qualified_type,
    STATE(14913), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2413), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14464), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4774), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4788), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [351512] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2417), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(14626), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15674), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
    STATE(1990), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [351568] = 13,
    ACTIONS(13646), 1,
      sym__integer_literal,
    ACTIONS(13654), 1,
      sym__conid,
    ACTIONS(13656), 1,
      anon_sym_LBRACK,
    ACTIONS(15676), 1,
      anon_sym_LPAREN,
    STATE(13362), 1,
      sym_constructor,
    STATE(13451), 1,
      sym_qualified_type,
    STATE(15304), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13644), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13648), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(13452), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(13448), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [351622] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [351656] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [351690] = 13,
    ACTIONS(4555), 1,
      sym__integer_literal,
    ACTIONS(4565), 1,
      sym__conid,
    ACTIONS(14632), 1,
      anon_sym_LBRACK,
    ACTIONS(15678), 1,
      anon_sym_LPAREN,
    STATE(10550), 1,
      sym_constructor,
    STATE(11201), 1,
      sym_qualified_type,
    STATE(15240), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4557), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14626), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11204), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11196), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [351744] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1943), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [351800] = 13,
    ACTIONS(6370), 1,
      sym__integer_literal,
    ACTIONS(6380), 1,
      sym__conid,
    ACTIONS(6382), 1,
      anon_sym_LBRACK,
    ACTIONS(15682), 1,
      anon_sym_LPAREN,
    STATE(6947), 1,
      sym_constructor,
    STATE(7164), 1,
      sym_qualified_type,
    STATE(15134), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6368), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6372), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7060), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7104), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [351854] = 3,
    ACTIONS(14062), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [351888] = 13,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(6545), 1,
      sym__conid,
    ACTIONS(15684), 1,
      anon_sym_LPAREN,
    STATE(7041), 1,
      sym_constructor,
    STATE(7068), 1,
      sym_qualified_type,
    STATE(15261), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4016), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [351942] = 13,
    ACTIONS(5377), 1,
      sym__integer_literal,
    ACTIONS(5388), 1,
      anon_sym_LBRACK,
    ACTIONS(7158), 1,
      sym__conid,
    ACTIONS(15686), 1,
      anon_sym_LPAREN,
    STATE(4827), 1,
      sym_constructor,
    STATE(4886), 1,
      sym_qualified_type,
    STATE(15214), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5375), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5379), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4887), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4881), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [351996] = 13,
    ACTIONS(11968), 1,
      sym__integer_literal,
    ACTIONS(11976), 1,
      sym__conid,
    ACTIONS(11978), 1,
      anon_sym_LBRACK,
    ACTIONS(15688), 1,
      anon_sym_LPAREN,
    STATE(8330), 1,
      sym_constructor,
    STATE(8706), 1,
      sym_qualified_type,
    STATE(15347), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11966), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11970), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8460), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8491), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352050] = 13,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(6016), 1,
      sym__conid,
    ACTIONS(15690), 1,
      anon_sym_LPAREN,
    STATE(7155), 1,
      sym_constructor,
    STATE(7405), 1,
      sym_qualified_type,
    STATE(14836), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4016), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352104] = 3,
    ACTIONS(14255), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [352138] = 3,
    ACTIONS(14746), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [352172] = 13,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(15692), 1,
      anon_sym_LPAREN,
    STATE(6440), 1,
      sym_constructor,
    STATE(6652), 1,
      sym_qualified_type,
    STATE(14854), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4016), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352226] = 13,
    ACTIONS(6171), 1,
      sym__integer_literal,
    ACTIONS(6181), 1,
      sym__conid,
    ACTIONS(6183), 1,
      anon_sym_LBRACK,
    ACTIONS(15694), 1,
      anon_sym_LPAREN,
    STATE(7130), 1,
      sym_constructor,
    STATE(7582), 1,
      sym_qualified_type,
    STATE(15277), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6169), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6173), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7350), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7386), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352280] = 3,
    ACTIONS(14269), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [352314] = 13,
    ACTIONS(6006), 1,
      sym__integer_literal,
    ACTIONS(6016), 1,
      sym__conid,
    ACTIONS(6018), 1,
      anon_sym_LBRACK,
    ACTIONS(15696), 1,
      anon_sym_LPAREN,
    STATE(7155), 1,
      sym_constructor,
    STATE(7405), 1,
      sym_qualified_type,
    STATE(14836), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6004), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6008), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7320), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7485), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352368] = 13,
    ACTIONS(8715), 1,
      sym__integer_literal,
    ACTIONS(8725), 1,
      sym__conid,
    ACTIONS(14502), 1,
      anon_sym_LBRACK,
    ACTIONS(15698), 1,
      anon_sym_LPAREN,
    STATE(10413), 1,
      sym_constructor,
    STATE(11354), 1,
      sym_qualified_type,
    STATE(14873), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8717), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14496), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11249), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11226), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352422] = 13,
    ACTIONS(2564), 1,
      sym__integer_literal,
    ACTIONS(4047), 1,
      sym__conid,
    ACTIONS(14372), 1,
      anon_sym_LBRACK,
    ACTIONS(15700), 1,
      anon_sym_LPAREN,
    STATE(4417), 1,
      sym_constructor,
    STATE(5238), 1,
      sym_qualified_type,
    STATE(15263), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2566), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14366), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5250), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5167), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352476] = 13,
    ACTIONS(87), 1,
      sym__integer_literal,
    ACTIONS(4087), 1,
      sym__conid,
    ACTIONS(14604), 1,
      anon_sym_LBRACK,
    ACTIONS(15702), 1,
      anon_sym_LPAREN,
    STATE(3692), 1,
      sym_constructor,
    STATE(3785), 1,
      sym_qualified_type,
    STATE(15195), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(89), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14598), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3774), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(3745), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352530] = 3,
    ACTIONS(13719), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [352564] = 13,
    ACTIONS(6440), 1,
      sym__integer_literal,
    ACTIONS(6450), 1,
      sym__conid,
    ACTIONS(6452), 1,
      anon_sym_LBRACK,
    ACTIONS(15704), 1,
      anon_sym_LPAREN,
    STATE(6798), 1,
      sym_constructor,
    STATE(7298), 1,
      sym_qualified_type,
    STATE(14826), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6438), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6442), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7216), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7208), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352618] = 13,
    ACTIONS(4431), 1,
      sym__integer_literal,
    ACTIONS(4439), 1,
      sym__conid,
    ACTIONS(13979), 1,
      anon_sym_LBRACK,
    ACTIONS(15706), 1,
      anon_sym_LPAREN,
    STATE(11719), 1,
      sym_constructor,
    STATE(12214), 1,
      sym_qualified_type,
    STATE(14765), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4433), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13973), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(12222), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(12185), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352672] = 13,
    ACTIONS(2977), 1,
      sym__integer_literal,
    ACTIONS(4153), 1,
      sym__conid,
    ACTIONS(14456), 1,
      anon_sym_LBRACK,
    ACTIONS(15708), 1,
      anon_sym_LPAREN,
    STATE(4912), 1,
      sym_constructor,
    STATE(5713), 1,
      sym_qualified_type,
    STATE(15162), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2979), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14450), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5718), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5701), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352726] = 13,
    ACTIONS(7373), 1,
      sym__integer_literal,
    ACTIONS(7383), 1,
      sym__conid,
    ACTIONS(7385), 1,
      anon_sym_LBRACK,
    ACTIONS(15710), 1,
      anon_sym_LPAREN,
    STATE(7535), 1,
      sym_constructor,
    STATE(7622), 1,
      sym_qualified_type,
    STATE(15052), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7371), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7375), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7624), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7606), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352780] = 3,
    ACTIONS(14249), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [352814] = 13,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(6181), 1,
      sym__conid,
    ACTIONS(15712), 1,
      anon_sym_LPAREN,
    STATE(7130), 1,
      sym_constructor,
    STATE(7582), 1,
      sym_qualified_type,
    STATE(15277), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4016), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352868] = 13,
    ACTIONS(8779), 1,
      sym__integer_literal,
    ACTIONS(8789), 1,
      sym__conid,
    ACTIONS(14400), 1,
      anon_sym_LBRACK,
    ACTIONS(15714), 1,
      anon_sym_LPAREN,
    STATE(10216), 1,
      sym_constructor,
    STATE(10527), 1,
      sym_qualified_type,
    STATE(14816), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8781), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14394), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10616), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(10629), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [352922] = 3,
    ACTIONS(14189), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [352956] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [352990] = 3,
    ACTIONS(14109), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [353024] = 13,
    ACTIONS(2664), 1,
      sym__integer_literal,
    ACTIONS(4193), 1,
      sym__conid,
    ACTIONS(14335), 1,
      anon_sym_LBRACK,
    ACTIONS(15716), 1,
      anon_sym_LPAREN,
    STATE(4711), 1,
      sym_constructor,
    STATE(5000), 1,
      sym_qualified_type,
    STATE(15150), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2666), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14329), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4995), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5059), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [353078] = 3,
    ACTIONS(14058), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [353112] = 13,
    ACTIONS(1364), 1,
      sym__integer_literal,
    ACTIONS(3051), 1,
      sym__conid,
    ACTIONS(14358), 1,
      anon_sym_LBRACK,
    ACTIONS(15718), 1,
      anon_sym_LPAREN,
    STATE(5556), 1,
      sym_constructor,
    STATE(5881), 1,
      sym_qualified_type,
    STATE(15207), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1366), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14352), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5885), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5828), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [353166] = 13,
    ACTIONS(7345), 1,
      sym__integer_literal,
    ACTIONS(7355), 1,
      sym__conid,
    ACTIONS(7357), 1,
      anon_sym_LBRACK,
    ACTIONS(15720), 1,
      anon_sym_LPAREN,
    STATE(6946), 1,
      sym_constructor,
    STATE(7061), 1,
      sym_qualified_type,
    STATE(15335), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7343), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7347), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7115), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7144), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [353220] = 13,
    ACTIONS(6143), 1,
      sym__integer_literal,
    ACTIONS(6153), 1,
      sym__conid,
    ACTIONS(6155), 1,
      anon_sym_LBRACK,
    ACTIONS(15722), 1,
      anon_sym_LPAREN,
    STATE(7596), 1,
      sym_constructor,
    STATE(7729), 1,
      sym_qualified_type,
    STATE(15120), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6141), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6145), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7731), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7705), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [353274] = 13,
    ACTIONS(6308), 1,
      sym__integer_literal,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(6320), 1,
      anon_sym_LBRACK,
    ACTIONS(15724), 1,
      anon_sym_LPAREN,
    STATE(6440), 1,
      sym_constructor,
    STATE(6652), 1,
      sym_qualified_type,
    STATE(14854), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6306), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6310), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6690), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [353328] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [353362] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2441), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(15345), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15726), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(1983), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [353418] = 13,
    ACTIONS(2354), 1,
      sym__integer_literal,
    ACTIONS(4177), 1,
      sym__conid,
    ACTIONS(14179), 1,
      anon_sym_LBRACK,
    ACTIONS(15728), 1,
      anon_sym_LPAREN,
    STATE(4222), 1,
      sym_constructor,
    STATE(4779), 1,
      sym_qualified_type,
    STATE(14803), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2356), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14173), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4715), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4700), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [353472] = 13,
    ACTIONS(5800), 1,
      sym__integer_literal,
    ACTIONS(5811), 1,
      anon_sym_LBRACK,
    ACTIONS(7122), 1,
      sym__conid,
    ACTIONS(15730), 1,
      anon_sym_LPAREN,
    STATE(5663), 1,
      sym_constructor,
    STATE(5883), 1,
      sym_qualified_type,
    STATE(15268), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5798), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5802), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5882), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5892), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [353526] = 13,
    ACTIONS(6961), 1,
      sym__integer_literal,
    ACTIONS(6971), 1,
      sym__conid,
    ACTIONS(6973), 1,
      anon_sym_LBRACK,
    ACTIONS(15732), 1,
      anon_sym_LPAREN,
    STATE(7314), 1,
      sym_constructor,
    STATE(7341), 1,
      sym_qualified_type,
    STATE(15131), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6959), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6963), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7346), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7406), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [353580] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [353614] = 3,
    ACTIONS(14785), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [353648] = 13,
    ACTIONS(1789), 1,
      sym__conid,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(15734), 1,
      anon_sym_LPAREN,
    STATE(7248), 1,
      sym_constructor,
    STATE(7439), 1,
      sym_qualified_type,
    STATE(14885), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4016), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [353702] = 13,
    ACTIONS(9090), 1,
      sym__integer_literal,
    ACTIONS(9100), 1,
      sym__conid,
    ACTIONS(14137), 1,
      anon_sym_LBRACK,
    ACTIONS(15736), 1,
      anon_sym_LPAREN,
    STATE(10651), 1,
      sym_constructor,
    STATE(11056), 1,
      sym_qualified_type,
    STATE(15116), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9092), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14131), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11057), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11033), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [353756] = 13,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(6380), 1,
      sym__conid,
    ACTIONS(15738), 1,
      anon_sym_LPAREN,
    STATE(6947), 1,
      sym_constructor,
    STATE(7164), 1,
      sym_qualified_type,
    STATE(15134), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4016), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [353810] = 13,
    ACTIONS(6863), 1,
      sym__integer_literal,
    ACTIONS(6874), 1,
      anon_sym_LBRACK,
    ACTIONS(6897), 1,
      sym__conid,
    ACTIONS(15740), 1,
      anon_sym_LPAREN,
    STATE(5944), 1,
      sym_constructor,
    STATE(5950), 1,
      sym_qualified_type,
    STATE(15273), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6861), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6865), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5951), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5955), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [353864] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(1991), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [353920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [353954] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2434), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(14875), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15742), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(1996), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [354010] = 13,
    ACTIONS(11647), 1,
      sym__integer_literal,
    ACTIONS(11655), 1,
      sym__conid,
    ACTIONS(11657), 1,
      anon_sym_LBRACK,
    ACTIONS(15744), 1,
      anon_sym_LPAREN,
    STATE(8145), 1,
      sym_constructor,
    STATE(8192), 1,
      sym_qualified_type,
    STATE(14795), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11645), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11649), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8278), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8354), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [354064] = 13,
    ACTIONS(5411), 1,
      sym__integer_literal,
    ACTIONS(5421), 1,
      sym__conid,
    ACTIONS(5423), 1,
      anon_sym_LBRACK,
    ACTIONS(15746), 1,
      anon_sym_LPAREN,
    STATE(7372), 1,
      sym_constructor,
    STATE(7688), 1,
      sym_qualified_type,
    STATE(15142), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5409), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5413), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7666), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7627), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [354118] = 13,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(4321), 1,
      sym__conid,
    ACTIONS(14618), 1,
      anon_sym_LBRACK,
    ACTIONS(15748), 1,
      anon_sym_LPAREN,
    STATE(9407), 1,
      sym_constructor,
    STATE(9482), 1,
      sym_qualified_type,
    STATE(14727), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14612), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9460), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9448), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [354172] = 3,
    ACTIONS(14662), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [354206] = 13,
    ACTIONS(6398), 1,
      sym__integer_literal,
    ACTIONS(6408), 1,
      sym__conid,
    ACTIONS(6410), 1,
      anon_sym_LBRACK,
    ACTIONS(15750), 1,
      anon_sym_LPAREN,
    STATE(5932), 1,
      sym_constructor,
    STATE(5992), 1,
      sym_qualified_type,
    STATE(15278), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6396), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6400), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5991), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5998), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [354260] = 13,
    ACTIONS(7317), 1,
      sym__integer_literal,
    ACTIONS(7327), 1,
      sym__conid,
    ACTIONS(7329), 1,
      anon_sym_LBRACK,
    ACTIONS(15752), 1,
      anon_sym_LPAREN,
    STATE(6299), 1,
      sym_constructor,
    STATE(6762), 1,
      sym_qualified_type,
    STATE(15096), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7315), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7319), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6761), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6771), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [354314] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1967), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [354370] = 13,
    ACTIONS(4511), 1,
      sym__integer_literal,
    ACTIONS(4519), 1,
      sym__conid,
    ACTIONS(13750), 1,
      anon_sym_LBRACK,
    ACTIONS(15754), 1,
      anon_sym_LPAREN,
    STATE(10409), 1,
      sym_constructor,
    STATE(11368), 1,
      sym_qualified_type,
    STATE(14968), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4513), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13744), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11366), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11433), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [354424] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [354458] = 13,
    ACTIONS(6619), 1,
      sym__integer_literal,
    ACTIONS(6629), 1,
      sym__conid,
    ACTIONS(6631), 1,
      anon_sym_LBRACK,
    ACTIONS(15756), 1,
      anon_sym_LPAREN,
    STATE(5910), 1,
      sym_constructor,
    STATE(6032), 1,
      sym_qualified_type,
    STATE(15103), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6617), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6621), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6034), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6026), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [354512] = 3,
    ACTIONS(13738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [354546] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [354580] = 13,
    ACTIONS(14070), 1,
      sym__integer_literal,
    ACTIONS(14078), 1,
      sym__conid,
    ACTIONS(14080), 1,
      anon_sym_LBRACK,
    ACTIONS(15758), 1,
      anon_sym_LPAREN,
    STATE(14373), 1,
      sym_constructor,
    STATE(14976), 1,
      sym_qualified_type,
    STATE(15289), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14068), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14072), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14975), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(14991), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [354634] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13682), 18,
      sym__dot,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [354668] = 3,
    ACTIONS(14265), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [354702] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13715), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13717), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [354738] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2429), 1,
      sym__colon2,
    STATE(11965), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15760), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(1998), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [354794] = 13,
    ACTIONS(6046), 1,
      sym__integer_literal,
    ACTIONS(6056), 1,
      sym__conid,
    ACTIONS(6058), 1,
      anon_sym_LBRACK,
    ACTIONS(15762), 1,
      anon_sym_LPAREN,
    STATE(7619), 1,
      sym_constructor,
    STATE(7783), 1,
      sym_qualified_type,
    STATE(15161), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6044), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6048), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7776), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7818), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [354848] = 13,
    ACTIONS(231), 1,
      sym__integer_literal,
    ACTIONS(1402), 1,
      sym__conid,
    ACTIONS(14488), 1,
      anon_sym_LBRACK,
    ACTIONS(15764), 1,
      anon_sym_LPAREN,
    STATE(3979), 1,
      sym_constructor,
    STATE(4021), 1,
      sym_qualified_type,
    STATE(15376), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(233), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14482), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4098), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4168), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [354902] = 13,
    ACTIONS(13550), 1,
      sym__integer_literal,
    ACTIONS(13558), 1,
      sym__conid,
    ACTIONS(13560), 1,
      anon_sym_LBRACK,
    ACTIONS(15766), 1,
      anon_sym_LPAREN,
    STATE(14134), 1,
      sym_constructor,
    STATE(15092), 1,
      aux_sym__qualifying_module,
    STATE(15226), 1,
      sym_qualified_type,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13548), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13552), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(15227), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(15221), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [354956] = 5,
    ACTIONS(15768), 1,
      anon_sym_LBRACE,
    STATE(9299), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [354994] = 3,
    ACTIONS(14654), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [355028] = 5,
    ACTIONS(15770), 1,
      anon_sym_LBRACE,
    STATE(9306), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15201), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(9703), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [355066] = 13,
    ACTIONS(6342), 1,
      sym__integer_literal,
    ACTIONS(6352), 1,
      sym__conid,
    ACTIONS(6354), 1,
      anon_sym_LBRACK,
    ACTIONS(15772), 1,
      anon_sym_LPAREN,
    STATE(5947), 1,
      sym_constructor,
    STATE(5949), 1,
      sym_qualified_type,
    STATE(15080), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6340), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6344), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5954), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5958), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [355120] = 3,
    ACTIONS(14700), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [355154] = 13,
    ACTIONS(1704), 1,
      sym__integer_literal,
    ACTIONS(4205), 1,
      sym__conid,
    ACTIONS(14560), 1,
      anon_sym_LBRACK,
    ACTIONS(15774), 1,
      anon_sym_LPAREN,
    STATE(3861), 1,
      sym_constructor,
    STATE(3966), 1,
      sym_qualified_type,
    STATE(15054), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1706), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14554), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3965), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(3985), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [355208] = 13,
    ACTIONS(10876), 1,
      sym__integer_literal,
    ACTIONS(10887), 1,
      anon_sym_LBRACK,
    ACTIONS(11737), 1,
      sym__conid,
    ACTIONS(15776), 1,
      anon_sym_LPAREN,
    STATE(7910), 1,
      sym_constructor,
    STATE(8065), 1,
      sym_qualified_type,
    STATE(15326), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10874), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10878), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8093), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8094), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [355262] = 3,
    ACTIONS(14822), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [355296] = 13,
    ACTIONS(7233), 1,
      sym__integer_literal,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(7245), 1,
      anon_sym_LBRACK,
    ACTIONS(15778), 1,
      anon_sym_LPAREN,
    STATE(5963), 1,
      sym_constructor,
    STATE(6407), 1,
      sym_qualified_type,
    STATE(15009), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7231), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7235), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6406), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6425), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [355350] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [355384] = 13,
    ACTIONS(2949), 1,
      sym__integer_literal,
    ACTIONS(4171), 1,
      sym__conid,
    ACTIONS(14442), 1,
      anon_sym_LBRACK,
    ACTIONS(15780), 1,
      anon_sym_LPAREN,
    STATE(5436), 1,
      sym_constructor,
    STATE(5493), 1,
      sym_qualified_type,
    STATE(14611), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2951), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14436), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5495), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5544), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [355438] = 3,
    ACTIONS(14674), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [355472] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [355506] = 13,
    ACTIONS(2309), 1,
      sym__integer_literal,
    ACTIONS(4267), 1,
      sym__conid,
    ACTIONS(14201), 1,
      anon_sym_LBRACK,
    ACTIONS(15782), 1,
      anon_sym_LPAREN,
    STATE(4278), 1,
      sym_constructor,
    STATE(4575), 1,
      sym_qualified_type,
    STATE(14943), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2311), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14195), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4567), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4592), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [355560] = 13,
    ACTIONS(6685), 1,
      sym__integer_literal,
    ACTIONS(6695), 1,
      sym__conid,
    ACTIONS(6697), 1,
      anon_sym_LBRACK,
    ACTIONS(15784), 1,
      anon_sym_LPAREN,
    STATE(6572), 1,
      sym_constructor,
    STATE(6594), 1,
      sym_qualified_type,
    STATE(15339), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6683), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6687), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6747), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6751), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [355614] = 13,
    ACTIONS(9276), 1,
      sym__integer_literal,
    ACTIONS(9286), 1,
      sym__conid,
    ACTIONS(13764), 1,
      anon_sym_LBRACK,
    ACTIONS(15786), 1,
      anon_sym_LPAREN,
    STATE(10617), 1,
      sym_constructor,
    STATE(11110), 1,
      sym_qualified_type,
    STATE(14784), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9278), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13758), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10965), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(10940), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [355668] = 13,
    ACTIONS(6507), 1,
      sym__integer_literal,
    ACTIONS(6517), 1,
      sym__conid,
    ACTIONS(6519), 1,
      anon_sym_LBRACK,
    ACTIONS(15788), 1,
      anon_sym_LPAREN,
    STATE(6820), 1,
      sym_constructor,
    STATE(7290), 1,
      sym_qualified_type,
    STATE(14821), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6505), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6509), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7233), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7156), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [355722] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [355756] = 13,
    ACTIONS(8466), 1,
      sym__integer_literal,
    ACTIONS(8476), 1,
      sym__conid,
    ACTIONS(14516), 1,
      anon_sym_LBRACK,
    ACTIONS(15790), 1,
      anon_sym_LPAREN,
    STATE(10225), 1,
      sym_constructor,
    STATE(10442), 1,
      sym_qualified_type,
    STATE(15372), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8468), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14510), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10484), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(10490), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [355810] = 13,
    ACTIONS(13618), 1,
      sym__integer_literal,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(13628), 1,
      anon_sym_LBRACK,
    ACTIONS(15792), 1,
      anon_sym_LPAREN,
    STATE(13518), 1,
      sym_constructor,
    STATE(14241), 1,
      sym_qualified_type,
    STATE(14747), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13616), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13620), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14238), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(14252), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [355864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [355898] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [355932] = 13,
    ACTIONS(8813), 1,
      sym__integer_literal,
    ACTIONS(8823), 1,
      sym__conid,
    ACTIONS(14414), 1,
      anon_sym_LBRACK,
    ACTIONS(15794), 1,
      anon_sym_LPAREN,
    STATE(9575), 1,
      sym_constructor,
    STATE(9604), 1,
      sym_qualified_type,
    STATE(15386), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8815), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14408), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9637), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9664), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [355986] = 13,
    ACTIONS(14526), 1,
      sym__integer_literal,
    ACTIONS(14534), 1,
      sym__conid,
    ACTIONS(14536), 1,
      anon_sym_LBRACK,
    ACTIONS(15796), 1,
      anon_sym_LPAREN,
    STATE(13552), 1,
      sym_constructor,
    STATE(14298), 1,
      sym_qualified_type,
    STATE(15298), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14524), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14528), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14307), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(14273), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [356040] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2400), 1,
      sym__colon2,
    STATE(12108), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15798), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
    STATE(1982), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [356096] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [356130] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1906), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [356186] = 13,
    ACTIONS(7261), 1,
      sym__integer_literal,
    ACTIONS(7271), 1,
      sym__conid,
    ACTIONS(7273), 1,
      anon_sym_LBRACK,
    ACTIONS(15800), 1,
      anon_sym_LPAREN,
    STATE(6782), 1,
      sym_constructor,
    STATE(7031), 1,
      sym_qualified_type,
    STATE(15321), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7259), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7263), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7028), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7045), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [356240] = 3,
    ACTIONS(13702), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [356274] = 13,
    ACTIONS(5918), 1,
      sym__integer_literal,
    ACTIONS(5929), 1,
      anon_sym_LBRACK,
    ACTIONS(6036), 1,
      sym__conid,
    ACTIONS(15802), 1,
      anon_sym_LPAREN,
    STATE(5542), 1,
      sym_constructor,
    STATE(5772), 1,
      sym_qualified_type,
    STATE(15397), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5916), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5920), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5782), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5783), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [356328] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1885), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [356384] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2371), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(15343), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15804), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    STATE(1980), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [356440] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [356474] = 13,
    ACTIONS(2737), 1,
      sym__integer_literal,
    ACTIONS(4073), 1,
      sym__conid,
    ACTIONS(14307), 1,
      anon_sym_LBRACK,
    ACTIONS(15806), 1,
      anon_sym_LPAREN,
    STATE(4511), 1,
      sym_constructor,
    STATE(5293), 1,
      sym_qualified_type,
    STATE(15405), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2739), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14301), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4860), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5305), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [356528] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [356562] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1896), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [356618] = 13,
    ACTIONS(6647), 1,
      sym__integer_literal,
    ACTIONS(6657), 1,
      sym__conid,
    ACTIONS(6659), 1,
      anon_sym_LBRACK,
    ACTIONS(15808), 1,
      anon_sym_LPAREN,
    STATE(6008), 1,
      sym_constructor,
    STATE(6547), 1,
      sym_qualified_type,
    STATE(14761), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6645), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6649), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6491), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6475), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [356672] = 13,
    ACTIONS(9160), 1,
      sym__integer_literal,
    ACTIONS(9170), 1,
      sym__conid,
    ACTIONS(14215), 1,
      anon_sym_LBRACK,
    ACTIONS(15810), 1,
      anon_sym_LPAREN,
    STATE(10343), 1,
      sym_constructor,
    STATE(11493), 1,
      sym_qualified_type,
    STATE(15421), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9162), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14209), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11404), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11396), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [356726] = 13,
    ACTIONS(11819), 1,
      sym__integer_literal,
    ACTIONS(11827), 1,
      sym__conid,
    ACTIONS(11829), 1,
      anon_sym_LBRACK,
    ACTIONS(15812), 1,
      anon_sym_LPAREN,
    STATE(8031), 1,
      sym_constructor,
    STATE(8275), 1,
      sym_qualified_type,
    STATE(14637), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11817), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11821), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8341), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8316), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [356780] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [356814] = 13,
    ACTIONS(12977), 1,
      sym__integer_literal,
    ACTIONS(12985), 1,
      sym__conid,
    ACTIONS(12987), 1,
      anon_sym_LBRACK,
    ACTIONS(15814), 1,
      anon_sym_LPAREN,
    STATE(8701), 1,
      sym_constructor,
    STATE(8819), 1,
      sym_qualified_type,
    STATE(14977), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12975), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12979), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8886), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8732), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [356868] = 13,
    ACTIONS(7289), 1,
      sym__integer_literal,
    ACTIONS(7299), 1,
      sym__conid,
    ACTIONS(7301), 1,
      anon_sym_LBRACK,
    ACTIONS(15816), 1,
      anon_sym_LPAREN,
    STATE(6001), 1,
      sym_constructor,
    STATE(6534), 1,
      sym_qualified_type,
    STATE(14749), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7287), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7291), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6436), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6432), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [356922] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2421), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(14938), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15818), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1981), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [356978] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1860), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [357034] = 3,
    ACTIONS(14040), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [357068] = 13,
    ACTIONS(4099), 1,
      sym__integer_literal,
    ACTIONS(4111), 1,
      sym__conid,
    ACTIONS(14103), 1,
      anon_sym_LBRACK,
    ACTIONS(15820), 1,
      anon_sym_LPAREN,
    STATE(9683), 1,
      sym_constructor,
    STATE(9819), 1,
      sym_qualified_type,
    STATE(15156), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4101), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14097), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9865), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9871), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [357122] = 13,
    ACTIONS(7044), 1,
      sym__integer_literal,
    ACTIONS(7054), 1,
      sym__conid,
    ACTIONS(7056), 1,
      anon_sym_LBRACK,
    ACTIONS(15822), 1,
      anon_sym_LPAREN,
    STATE(6480), 1,
      sym_constructor,
    STATE(6636), 1,
      sym_qualified_type,
    STATE(14736), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7042), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7046), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6621), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6722), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [357176] = 13,
    ACTIONS(8669), 1,
      sym__integer_literal,
    ACTIONS(8679), 1,
      sym__conid,
    ACTIONS(14321), 1,
      anon_sym_LBRACK,
    ACTIONS(15824), 1,
      anon_sym_LPAREN,
    STATE(10732), 1,
      sym_constructor,
    STATE(11070), 1,
      sym_qualified_type,
    STATE(14886), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8671), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14315), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11067), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11106), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [357230] = 3,
    ACTIONS(14793), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [357264] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1946), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [357320] = 13,
    ACTIONS(8926), 1,
      sym__integer_literal,
    ACTIONS(8936), 1,
      sym__conid,
    ACTIONS(13883), 1,
      anon_sym_LBRACK,
    ACTIONS(15826), 1,
      anon_sym_LPAREN,
    STATE(10107), 1,
      sym_constructor,
    STATE(10762), 1,
      sym_qualified_type,
    STATE(15282), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8928), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13877), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10760), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(10780), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [357374] = 13,
    ACTIONS(159), 1,
      sym__integer_literal,
    ACTIONS(4143), 1,
      sym__conid,
    ACTIONS(13863), 1,
      anon_sym_LBRACK,
    ACTIONS(15828), 1,
      anon_sym_LPAREN,
    STATE(4501), 1,
      sym_constructor,
    STATE(5362), 1,
      sym_qualified_type,
    STATE(14722), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(161), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13857), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5316), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5213), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [357428] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [357462] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [357498] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [357532] = 13,
    ACTIONS(4341), 1,
      sym__integer_literal,
    ACTIONS(4349), 1,
      sym__conid,
    ACTIONS(14588), 1,
      anon_sym_LBRACK,
    ACTIONS(15830), 1,
      anon_sym_LPAREN,
    STATE(10549), 1,
      sym_constructor,
    STATE(11203), 1,
      sym_qualified_type,
    STATE(14716), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4343), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14582), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11219), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11180), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [357586] = 3,
    ACTIONS(14666), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [357620] = 13,
    ACTIONS(5278), 1,
      sym__integer_literal,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(5288), 1,
      anon_sym_LBRACK,
    ACTIONS(15832), 1,
      anon_sym_LPAREN,
    STATE(7258), 1,
      sym_constructor,
    STATE(7419), 1,
      sym_qualified_type,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5276), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7420), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7397), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [357674] = 13,
    ACTIONS(6780), 1,
      sym__integer_literal,
    ACTIONS(6790), 1,
      sym__conid,
    ACTIONS(6792), 1,
      anon_sym_LBRACK,
    ACTIONS(15834), 1,
      anon_sym_LPAREN,
    STATE(6702), 1,
      sym_constructor,
    STATE(6956), 1,
      sym_qualified_type,
    STATE(14702), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6778), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6782), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7004), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7008), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [357728] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [357762] = 13,
    ACTIONS(1775), 1,
      sym__integer_literal,
    ACTIONS(1789), 1,
      sym__conid,
    ACTIONS(1791), 1,
      anon_sym_LBRACK,
    ACTIONS(15836), 1,
      anon_sym_LPAREN,
    STATE(7248), 1,
      sym_constructor,
    STATE(7439), 1,
      sym_qualified_type,
    STATE(14885), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1773), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(1777), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7494), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7364), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [357816] = 13,
    ACTIONS(6563), 1,
      sym__integer_literal,
    ACTIONS(6573), 1,
      sym__conid,
    ACTIONS(6575), 1,
      anon_sym_LBRACK,
    ACTIONS(15838), 1,
      anon_sym_LPAREN,
    STATE(6735), 1,
      sym_constructor,
    STATE(6978), 1,
      sym_qualified_type,
    STATE(14684), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6561), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7025), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7019), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [357870] = 13,
    ACTIONS(6905), 1,
      sym__integer_literal,
    ACTIONS(6915), 1,
      sym__conid,
    ACTIONS(6917), 1,
      anon_sym_LBRACK,
    ACTIONS(15840), 1,
      anon_sym_LPAREN,
    STATE(6149), 1,
      sym_constructor,
    STATE(6441), 1,
      sym_qualified_type,
    STATE(15108), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6903), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6907), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6257), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6357), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [357924] = 13,
    ACTIONS(537), 1,
      sym__integer_literal,
    ACTIONS(1753), 1,
      sym__conid,
    ACTIONS(13790), 1,
      anon_sym_LBRACK,
    ACTIONS(15842), 1,
      anon_sym_LPAREN,
    STATE(4286), 1,
      sym_constructor,
    STATE(4409), 1,
      sym_qualified_type,
    STATE(15112), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(539), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13784), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4647), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4667), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [357978] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1823), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [358034] = 13,
    ACTIONS(14277), 1,
      sym__integer_literal,
    ACTIONS(14285), 1,
      sym__conid,
    ACTIONS(14287), 1,
      anon_sym_LBRACK,
    ACTIONS(15844), 1,
      anon_sym_LPAREN,
    STATE(13422), 1,
      sym_constructor,
    STATE(14048), 1,
      sym_qualified_type,
    STATE(14674), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(14275), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(14279), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(14033), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(14031), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [358088] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [358122] = 13,
    ACTIONS(1230), 1,
      sym__integer_literal,
    ACTIONS(3116), 1,
      sym__conid,
    ACTIONS(13915), 1,
      anon_sym_LBRACK,
    ACTIONS(15846), 1,
      anon_sym_LPAREN,
    STATE(3931), 1,
      sym_constructor,
    STATE(4080), 1,
      sym_qualified_type,
    STATE(15099), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1232), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13909), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4094), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4153), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [358176] = 13,
    ACTIONS(7072), 1,
      sym__integer_literal,
    ACTIONS(7082), 1,
      sym__conid,
    ACTIONS(7084), 1,
      anon_sym_LBRACK,
    ACTIONS(15848), 1,
      anon_sym_LPAREN,
    STATE(7259), 1,
      sym_constructor,
    STATE(7435), 1,
      sym_qualified_type,
    STATE(15269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7070), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7074), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7480), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7576), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [358230] = 13,
    ACTIONS(1171), 1,
      sym__integer_literal,
    ACTIONS(3032), 1,
      sym__conid,
    ACTIONS(13933), 1,
      anon_sym_LBRACK,
    ACTIONS(15850), 1,
      anon_sym_LPAREN,
    STATE(4361), 1,
      sym_constructor,
    STATE(4891), 1,
      sym_qualified_type,
    STATE(15388), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1173), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13927), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4893), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4865), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [358284] = 13,
    ACTIONS(6933), 1,
      sym__integer_literal,
    ACTIONS(6943), 1,
      sym__conid,
    ACTIONS(6945), 1,
      anon_sym_LBRACK,
    ACTIONS(15852), 1,
      anon_sym_LPAREN,
    STATE(6868), 1,
      sym_constructor,
    STATE(7247), 1,
      sym_qualified_type,
    STATE(15295), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6931), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6935), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7244), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7278), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [358338] = 3,
    ACTIONS(13734), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [358372] = 3,
    ACTIONS(14670), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [358406] = 13,
    ACTIONS(645), 1,
      sym__integer_literal,
    ACTIONS(1698), 1,
      sym__conid,
    ACTIONS(14428), 1,
      anon_sym_LBRACK,
    ACTIONS(15854), 1,
      anon_sym_LPAREN,
    STATE(3759), 1,
      sym_constructor,
    STATE(3844), 1,
      sym_qualified_type,
    STATE(15139), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(647), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14422), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3807), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(3842), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [358460] = 13,
    ACTIONS(6752), 1,
      sym__integer_literal,
    ACTIONS(6762), 1,
      sym__conid,
    ACTIONS(6764), 1,
      anon_sym_LBRACK,
    ACTIONS(15856), 1,
      anon_sym_LPAREN,
    STATE(6168), 1,
      sym_constructor,
    STATE(6381), 1,
      sym_qualified_type,
    STATE(15425), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6750), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6754), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6379), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6388), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [358514] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [358548] = 13,
    ACTIONS(9124), 1,
      sym__integer_literal,
    ACTIONS(9134), 1,
      sym__conid,
    ACTIONS(13831), 1,
      anon_sym_LBRACK,
    ACTIONS(15858), 1,
      anon_sym_LPAREN,
    STATE(9984), 1,
      sym_constructor,
    STATE(10761), 1,
      sym_qualified_type,
    STATE(15083), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9126), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13825), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(10764), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(10842), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [358602] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1949), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [358658] = 3,
    ACTIONS(14476), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [358692] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 19,
      sym__splice_dollar,
      sym__varsym,
      sym__consym,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [358726] = 3,
    ACTIONS(14676), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [358760] = 3,
    ACTIONS(14680), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [358794] = 3,
    ACTIONS(14684), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [358828] = 3,
    ACTIONS(14688), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [358862] = 13,
    ACTIONS(10563), 1,
      sym__integer_literal,
    ACTIONS(13780), 1,
      sym__conid,
    ACTIONS(14648), 1,
      anon_sym_LBRACK,
    ACTIONS(15860), 1,
      anon_sym_LPAREN,
    STATE(14877), 1,
      aux_sym__qualifying_module,
    STATE(15440), 1,
      sym_constructor,
    STATE(17834), 1,
      sym_qualified_type,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10565), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14642), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(17833), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(17839), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [358916] = 13,
    ACTIONS(12146), 1,
      sym__integer_literal,
    ACTIONS(12154), 1,
      sym__conid,
    ACTIONS(12156), 1,
      anon_sym_LBRACK,
    ACTIONS(15862), 1,
      anon_sym_LPAREN,
    STATE(8197), 1,
      sym_constructor,
    STATE(8660), 1,
      sym_qualified_type,
    STATE(14724), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12144), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12148), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8673), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8646), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [358970] = 13,
    ACTIONS(10970), 1,
      sym__integer_literal,
    ACTIONS(10978), 1,
      sym__conid,
    ACTIONS(10980), 1,
      anon_sym_LBRACK,
    ACTIONS(15864), 1,
      anon_sym_LPAREN,
    STATE(8396), 1,
      sym_constructor,
    STATE(8415), 1,
      sym_qualified_type,
    STATE(15075), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10968), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8417), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8413), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359024] = 13,
    ACTIONS(12669), 1,
      sym__integer_literal,
    ACTIONS(12677), 1,
      sym__conid,
    ACTIONS(12679), 1,
      anon_sym_LBRACK,
    ACTIONS(15866), 1,
      anon_sym_LPAREN,
    STATE(8516), 1,
      sym_constructor,
    STATE(8896), 1,
      sym_qualified_type,
    STATE(14776), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12667), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12671), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8984), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8989), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359078] = 13,
    ACTIONS(10290), 1,
      sym__integer_literal,
    ACTIONS(10298), 1,
      sym__conid,
    ACTIONS(10300), 1,
      anon_sym_LBRACK,
    ACTIONS(15868), 1,
      anon_sym_LPAREN,
    STATE(8059), 1,
      sym_constructor,
    STATE(8366), 1,
      sym_qualified_type,
    STATE(14820), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10288), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10292), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8382), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8348), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359132] = 3,
    ACTIONS(14696), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [359166] = 13,
    ACTIONS(12482), 1,
      sym__integer_literal,
    ACTIONS(12492), 1,
      anon_sym_LBRACK,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(15870), 1,
      anon_sym_LPAREN,
    STATE(8579), 1,
      sym_constructor,
    STATE(8912), 1,
      sym_qualified_type,
    STATE(14683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(12480), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(12484), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8936), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359220] = 13,
    ACTIONS(6199), 1,
      sym__integer_literal,
    ACTIONS(6209), 1,
      sym__conid,
    ACTIONS(6211), 1,
      anon_sym_LBRACK,
    ACTIONS(15872), 1,
      anon_sym_LPAREN,
    STATE(5792), 1,
      sym_constructor,
    STATE(6213), 1,
      sym_qualified_type,
    STATE(15408), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6197), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6201), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6212), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6228), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359274] = 13,
    ACTIONS(4363), 1,
      sym__integer_literal,
    ACTIONS(4373), 1,
      sym__conid,
    ACTIONS(14151), 1,
      anon_sym_LBRACK,
    ACTIONS(15874), 1,
      anon_sym_LPAREN,
    STATE(11325), 1,
      sym_constructor,
    STATE(11910), 1,
      sym_qualified_type,
    STATE(14664), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4365), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14145), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11915), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11879), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359328] = 13,
    ACTIONS(13278), 1,
      sym__integer_literal,
    ACTIONS(13286), 1,
      sym__conid,
    ACTIONS(13288), 1,
      anon_sym_LBRACK,
    ACTIONS(15876), 1,
      anon_sym_LPAREN,
    STATE(8887), 1,
      sym_constructor,
    STATE(9093), 1,
      sym_qualified_type,
    STATE(14618), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13276), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13280), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9058), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9169), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359382] = 13,
    ACTIONS(2848), 1,
      sym__integer_literal,
    ACTIONS(4061), 1,
      sym__conid,
    ACTIONS(14243), 1,
      anon_sym_LBRACK,
    ACTIONS(15878), 1,
      anon_sym_LPAREN,
    STATE(4432), 1,
      sym_constructor,
    STATE(5383), 1,
      sym_qualified_type,
    STATE(15211), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2850), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14237), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5388), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5358), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359436] = 13,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(15880), 1,
      anon_sym_LPAREN,
    STATE(3933), 1,
      sym_constructor,
    STATE(4083), 1,
      sym_qualified_type,
    STATE(14865), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4016), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359490] = 13,
    ACTIONS(5970), 1,
      sym__integer_literal,
    ACTIONS(5980), 1,
      sym__conid,
    ACTIONS(5982), 1,
      anon_sym_LBRACK,
    ACTIONS(15882), 1,
      anon_sym_LPAREN,
    STATE(6224), 1,
      sym_constructor,
    STATE(6302), 1,
      sym_qualified_type,
    STATE(15364), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5968), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5972), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6301), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6347), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359544] = 13,
    ACTIONS(2084), 1,
      sym__integer_literal,
    ACTIONS(4055), 1,
      sym__conid,
    ACTIONS(14052), 1,
      anon_sym_LBRACK,
    ACTIONS(15884), 1,
      anon_sym_LPAREN,
    STATE(4261), 1,
      sym_constructor,
    STATE(4372), 1,
      sym_qualified_type,
    STATE(15230), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2086), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14046), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4449), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4459), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359598] = 13,
    ACTIONS(9), 1,
      sym__integer_literal,
    ACTIONS(4243), 1,
      sym__conid,
    ACTIONS(13965), 1,
      anon_sym_LBRACK,
    ACTIONS(15886), 1,
      anon_sym_LPAREN,
    STATE(4548), 1,
      sym_constructor,
    STATE(5285), 1,
      sym_qualified_type,
    STATE(14996), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13959), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(5284), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(5303), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359652] = 3,
    ACTIONS(14738), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [359686] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1899), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [359742] = 13,
    ACTIONS(11037), 1,
      sym__integer_literal,
    ACTIONS(11048), 1,
      anon_sym_LBRACK,
    ACTIONS(11540), 1,
      sym__conid,
    ACTIONS(15888), 1,
      anon_sym_LPAREN,
    STATE(7931), 1,
      sym_constructor,
    STATE(7985), 1,
      sym_qualified_type,
    STATE(15334), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11035), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11039), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7984), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7989), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359796] = 13,
    ACTIONS(6591), 1,
      sym__integer_literal,
    ACTIONS(6601), 1,
      sym__conid,
    ACTIONS(6603), 1,
      anon_sym_LBRACK,
    ACTIONS(15890), 1,
      anon_sym_LPAREN,
    STATE(6061), 1,
      sym_constructor,
    STATE(6348), 1,
      sym_qualified_type,
    STATE(15001), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6589), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6593), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6342), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6389), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359850] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1886), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [359906] = 13,
    ACTIONS(8960), 1,
      sym__integer_literal,
    ACTIONS(8970), 1,
      sym__conid,
    ACTIONS(14027), 1,
      anon_sym_LBRACK,
    ACTIONS(15892), 1,
      anon_sym_LPAREN,
    STATE(11477), 1,
      sym_constructor,
    STATE(11582), 1,
      sym_qualified_type,
    STATE(15154), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8962), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14021), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(11527), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(11547), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [359960] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1814), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [360016] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15423), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym__,
    ACTIONS(15425), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [360050] = 13,
    ACTIONS(7205), 1,
      sym__integer_literal,
    ACTIONS(7215), 1,
      sym__conid,
    ACTIONS(7217), 1,
      anon_sym_LBRACK,
    ACTIONS(15894), 1,
      anon_sym_LPAREN,
    STATE(6558), 1,
      sym_constructor,
    STATE(6600), 1,
      sym_qualified_type,
    STATE(14645), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(7203), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(7207), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6599), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6622), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [360104] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2407), 1,
      sym__colon2,
    STATE(12011), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15896), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
    STATE(1993), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [360160] = 13,
    ACTIONS(2607), 1,
      sym__integer_literal,
    ACTIONS(4081), 1,
      sym__conid,
    ACTIONS(13951), 1,
      anon_sym_LBRACK,
    ACTIONS(15898), 1,
      anon_sym_LPAREN,
    STATE(4531), 1,
      sym_constructor,
    STATE(5330), 1,
      sym_qualified_type,
    STATE(15046), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2609), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13945), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4906), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4945), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [360214] = 13,
    ACTIONS(13993), 1,
      sym__integer_literal,
    ACTIONS(14001), 1,
      sym__conid,
    ACTIONS(14003), 1,
      anon_sym_LBRACK,
    ACTIONS(15900), 1,
      anon_sym_LPAREN,
    STATE(14932), 1,
      aux_sym__qualifying_module,
    STATE(15445), 1,
      sym_constructor,
    STATE(17849), 1,
      sym_qualified_type,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(13991), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(13995), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(17850), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(17844), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [360268] = 13,
    ACTIONS(6280), 1,
      sym__integer_literal,
    ACTIONS(6291), 1,
      anon_sym_LBRACK,
    ACTIONS(7114), 1,
      sym__conid,
    ACTIONS(15902), 1,
      anon_sym_LPAREN,
    STATE(5876), 1,
      sym_constructor,
    STATE(6068), 1,
      sym_qualified_type,
    STATE(14778), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6278), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6282), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(6069), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(6064), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [360322] = 13,
    ACTIONS(6115), 1,
      sym__integer_literal,
    ACTIONS(6125), 1,
      sym__conid,
    ACTIONS(6127), 1,
      anon_sym_LBRACK,
    ACTIONS(15904), 1,
      anon_sym_LPAREN,
    STATE(7299), 1,
      sym_constructor,
    STATE(7375), 1,
      sym_qualified_type,
    STATE(14983), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(6113), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(6117), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(7463), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(7581), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [360376] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2356), 1,
      sym__colon2,
    STATE(12161), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15906), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
    STATE(1996), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [360432] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1930), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [360488] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2415), 1,
      sym__colon2,
    STATE(12118), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15908), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
    STATE(1981), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [360544] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2402), 1,
      sym__colon2,
    STATE(12210), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15910), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
    STATE(1990), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [360600] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
    STATE(1910), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [360656] = 13,
    ACTIONS(4533), 1,
      sym__integer_literal,
    ACTIONS(4541), 1,
      sym__conid,
    ACTIONS(13901), 1,
      anon_sym_LBRACK,
    ACTIONS(15912), 1,
      anon_sym_LPAREN,
    STATE(9260), 1,
      sym_constructor,
    STATE(9438), 1,
      sym_qualified_type,
    STATE(14915), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4535), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(13895), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9386), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9381), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [360710] = 13,
    ACTIONS(5195), 1,
      sym__integer_literal,
    ACTIONS(5206), 1,
      anon_sym_LBRACK,
    ACTIONS(5998), 1,
      sym__conid,
    ACTIONS(15914), 1,
      anon_sym_LPAREN,
    STATE(4243), 1,
      sym_constructor,
    STATE(4755), 1,
      sym_qualified_type,
    STATE(14868), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5193), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5197), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4550), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4542), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [360764] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2436), 1,
      sym__colon2,
    STATE(12180), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15916), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(1983), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [360820] = 3,
    ACTIONS(14712), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [360854] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(2408), 1,
      sym__colon2,
    STATE(12192), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15918), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
    STATE(1980), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [360910] = 13,
    ACTIONS(1937), 1,
      sym__integer_literal,
    ACTIONS(4161), 1,
      sym__conid,
    ACTIONS(14121), 1,
      anon_sym_LBRACK,
    ACTIONS(15920), 1,
      anon_sym_LPAREN,
    STATE(4167), 1,
      sym_constructor,
    STATE(4231), 1,
      sym_qualified_type,
    STATE(15315), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1939), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14115), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4224), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4246), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [360964] = 13,
    ACTIONS(11994), 1,
      sym__integer_literal,
    ACTIONS(12002), 1,
      sym__conid,
    ACTIONS(12004), 1,
      anon_sym_LBRACK,
    ACTIONS(15922), 1,
      anon_sym_LPAREN,
    STATE(8235), 1,
      sym_constructor,
    STATE(8619), 1,
      sym_qualified_type,
    STATE(14853), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(11992), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(11996), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8422), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8426), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [361018] = 13,
    ACTIONS(10262), 1,
      sym__integer_literal,
    ACTIONS(10270), 1,
      sym__conid,
    ACTIONS(10272), 1,
      anon_sym_LBRACK,
    ACTIONS(15924), 1,
      anon_sym_LPAREN,
    STATE(8074), 1,
      sym_constructor,
    STATE(8360), 1,
      sym_qualified_type,
    STATE(15062), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(10260), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(10264), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(8363), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(8351), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [361072] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2372), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(14997), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15926), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15215), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
    STATE(1993), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [361128] = 3,
    ACTIONS(14692), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [361162] = 3,
    ACTIONS(14185), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [361196] = 13,
    ACTIONS(5082), 1,
      sym__integer_literal,
    ACTIONS(5093), 1,
      anon_sym_LBRACK,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(15928), 1,
      anon_sym_LPAREN,
    STATE(7258), 1,
      sym_constructor,
    STATE(7419), 1,
      sym_qualified_type,
    STATE(14607), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(5080), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(5084), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(4016), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(4163), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [361250] = 13,
    ACTIONS(4477), 1,
      sym__integer_literal,
    ACTIONS(4487), 1,
      sym__conid,
    ACTIONS(14386), 1,
      anon_sym_LBRACK,
    ACTIONS(15930), 1,
      anon_sym_LPAREN,
    STATE(9635), 1,
      sym_constructor,
    STATE(9724), 1,
      sym_qualified_type,
    STATE(15007), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4479), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(14380), 3,
      sym_float,
      sym_char,
      sym_string,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9818), 4,
      sym_type_literal,
      sym_type_list,
      sym_type_tuple,
      sym__type_promotable_literal,
    STATE(9830), 5,
      sym_integer,
      sym__literal,
      sym_con_unit,
      sym_con_list,
      sym_con_tuple,
  [361304] = 3,
    ACTIONS(13774), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 20,
      sym__splice_dollar,
      sym_comma,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_,
      anon_sym_EQ_GT,
      sym__varid,
      anon_sym_RPAREN,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [361338] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(15934), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2624), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 15,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [361379] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2420), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(12414), 1,
      sym__type_annotation,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15940), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(15215), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1995), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [361434] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2438), 1,
      sym__colon2,
    STATE(12321), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15942), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(15215), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1985), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [361489] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13734), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13736), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_AT2,
      anon_sym_7,
  [361522] = 3,
    ACTIONS(13734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 20,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_AT2,
  [361555] = 4,
    ACTIONS(15944), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [361590] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [361625] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [361658] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [361693] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2432), 1,
      sym__colon2,
    STATE(12329), 1,
      sym__type_annotation,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15946), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(15215), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1986), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [361748] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15950), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
    ACTIONS(15948), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [361781] = 3,
    ACTIONS(13734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 20,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_AT2,
  [361814] = 4,
    ACTIONS(15952), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15273), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14887), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [361849] = 3,
    ACTIONS(13680), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 20,
      sym__dot,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [361882] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14856), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14854), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [361915] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13719), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(13721), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [361948] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15954), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
    STATE(3410), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [361997] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [362032] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2369), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(17273), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(15215), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1995), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [362087] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15956), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
    STATE(3353), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [362136] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14109), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym__,
    ACTIONS(14111), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [362169] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15960), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
    ACTIONS(15958), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [362202] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [362237] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2377), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(15567), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15962), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(15215), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1985), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [362292] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15966), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
    ACTIONS(15964), 18,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [362325] = 3,
    ACTIONS(13680), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 20,
      sym__dot,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [362358] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1858), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [362412] = 3,
    ACTIONS(14109), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [362444] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [362476] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [362508] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [362540] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [362572] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [362604] = 3,
    ACTIONS(14476), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [362636] = 3,
    ACTIONS(14189), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [362668] = 3,
    ACTIONS(14040), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [362700] = 3,
    ACTIONS(14265), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [362732] = 3,
    ACTIONS(14255), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [362764] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14476), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14478), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [362796] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1808), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [362850] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [362882] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1876), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [362936] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [362970] = 3,
    ACTIONS(13738), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [363002] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15968), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15970), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [363034] = 5,
    ACTIONS(15974), 1,
      anon_sym_DASH,
    STATE(15790), 1,
      sym_guards,
    STATE(9277), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [363070] = 3,
    ACTIONS(13889), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [363102] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [363134] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15475), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15477), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [363166] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13702), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13684), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [363198] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [363232] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1923), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [363286] = 3,
    ACTIONS(14265), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [363318] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [363350] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1850), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [363404] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1829), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [363458] = 3,
    ACTIONS(13738), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [363490] = 3,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [363522] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14249), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14251), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [363554] = 6,
    ACTIONS(15980), 1,
      anon_sym_DASH,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(15790), 1,
      sym_guards,
    STATE(9277), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15978), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [363592] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [363624] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [363656] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1947), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [363710] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1868), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [363764] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [363798] = 3,
    ACTIONS(13871), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [363830] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [363864] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [363896] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [363928] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [363960] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [363992] = 3,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [364024] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1907), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [364078] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13707), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13713), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [364110] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15499), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15501), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [364142] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1954), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [364196] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14265), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14267), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [364228] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1867), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [364282] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13774), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13776), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [364314] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2398), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(12692), 1,
      sym__type_annotation,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(15985), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2000), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [364368] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14185), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14187), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [364400] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [364432] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [364464] = 3,
    ACTIONS(14476), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [364496] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1901), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [364550] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15966), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_forall,
    ACTIONS(15964), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_5,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [364582] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [364614] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1846), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [364668] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15435), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15437), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [364700] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1840), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [364754] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1968), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [364808] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1834), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [364862] = 3,
    ACTIONS(14058), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [364894] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1931), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [364948] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1810), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [365002] = 3,
    ACTIONS(14189), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [365034] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1871), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [365088] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13738), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13740), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [365120] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1815), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [365174] = 3,
    ACTIONS(14249), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [365206] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [365238] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13889), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13891), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [365270] = 3,
    ACTIONS(14249), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [365302] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13871), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(13873), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [365334] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1854), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [365388] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14040), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14042), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [365420] = 3,
    ACTIONS(14269), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [365452] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15457), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15459), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [365484] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1888), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [365538] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15463), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15465), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [365570] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1894), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [365624] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2404), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(18621), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(15987), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(2000), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [365678] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1960), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [365732] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1821), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [365786] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(15974), 1,
      anon_sym_DASH,
    STATE(15790), 1,
      sym_guards,
    STATE(9277), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [365824] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 20,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [365856] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14058), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14060), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [365888] = 3,
    ACTIONS(14255), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [365920] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [365952] = 3,
    ACTIONS(14185), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [365984] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(15993), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2614), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 14,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [366024] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1828), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [366078] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15449), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15451), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [366110] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14062), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14064), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [366142] = 3,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [366174] = 3,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [366206] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15471), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15473), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [366238] = 3,
    ACTIONS(14269), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [366270] = 3,
    ACTIONS(14062), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [366302] = 3,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [366334] = 3,
    ACTIONS(14062), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [366366] = 3,
    ACTIONS(13889), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [366398] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14189), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14191), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [366430] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15503), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14924), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [366462] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14255), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14257), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [366494] = 3,
    ACTIONS(14058), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [366526] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1959), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [366580] = 6,
    ACTIONS(14341), 1,
      anon_sym_DASH,
    ACTIONS(15995), 1,
      anon_sym_LBRACE,
    ACTIONS(15998), 1,
      sym__layout_start,
    STATE(9472), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [366618] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15439), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15441), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [366650] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14269), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14271), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [366682] = 6,
    ACTIONS(15998), 1,
      sym__layout_start,
    ACTIONS(16002), 1,
      anon_sym_DASH,
    ACTIONS(16004), 1,
      anon_sym_LBRACE,
    STATE(9533), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [366720] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16006), 5,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_forall,
    ACTIONS(16008), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_5,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [366752] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1921), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [366806] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1912), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [366860] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15511), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15513), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [366892] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15491), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15493), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [366924] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15445), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15447), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [366956] = 3,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [366988] = 3,
    ACTIONS(14185), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367020] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15505), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14931), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [367052] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1936), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [367106] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15509), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(14933), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_7,
  [367138] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15483), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15485), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [367170] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15487), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15489), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [367202] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15479), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15481), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [367234] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1964), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [367288] = 3,
    ACTIONS(14109), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367320] = 3,
    ACTIONS(14040), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367352] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15453), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15455), 17,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [367384] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(2399), 1,
      sym__colon2,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(13843), 1,
      sym__type_annotation,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(15215), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1956), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [367438] = 3,
    ACTIONS(13871), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367470] = 3,
    ACTIONS(14676), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367501] = 3,
    ACTIONS(14674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367532] = 3,
    ACTIONS(14688), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367563] = 3,
    ACTIONS(14722), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367594] = 3,
    ACTIONS(14712), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367625] = 3,
    ACTIONS(15991), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 19,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [367656] = 3,
    ACTIONS(14726), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367687] = 3,
    ACTIONS(14785), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367718] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15245), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15247), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [367749] = 3,
    ACTIONS(14692), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367780] = 3,
    ACTIONS(14730), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367811] = 3,
    ACTIONS(14734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367842] = 3,
    ACTIONS(14734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367873] = 3,
    ACTIONS(14746), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367904] = 3,
    ACTIONS(14742), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367935] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13680), 4,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
      anon_sym_LBRACE,
    ACTIONS(13682), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [367966] = 3,
    ACTIONS(14750), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [367997] = 3,
    ACTIONS(14758), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368028] = 3,
    ACTIONS(14762), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368059] = 3,
    ACTIONS(14696), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368090] = 3,
    ACTIONS(14766), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368121] = 3,
    ACTIONS(14708), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368152] = 3,
    ACTIONS(14766), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368183] = 3,
    ACTIONS(14684), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368214] = 3,
    ACTIONS(14777), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368245] = 3,
    ACTIONS(14680), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368276] = 3,
    ACTIONS(14806), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368307] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16010), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16012), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [368338] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368371] = 4,
    ACTIONS(16014), 1,
      sym__immediate_dot,
    ACTIONS(14716), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368404] = 3,
    ACTIONS(14754), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368435] = 3,
    ACTIONS(14738), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368466] = 3,
    ACTIONS(14814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368497] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16016), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(16018), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [368528] = 3,
    ACTIONS(14658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368559] = 3,
    ACTIONS(14670), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368590] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 19,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368621] = 3,
    ACTIONS(14797), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368652] = 3,
    ACTIONS(14810), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368683] = 3,
    ACTIONS(14662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368714] = 3,
    ACTIONS(14818), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368745] = 3,
    ACTIONS(14666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368776] = 3,
    ACTIONS(14793), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368807] = 3,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368838] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15271), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(4109), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [368869] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368902] = 3,
    ACTIONS(14814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368933] = 3,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15417), 4,
      sym__integer_literal,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym__,
    ACTIONS(15419), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym__strict,
      sym__lazy,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      anon_sym_DASH,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_7,
  [368964] = 3,
    ACTIONS(14654), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [368995] = 3,
    ACTIONS(14700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369026] = 6,
    ACTIONS(16002), 1,
      anon_sym_DASH,
    ACTIONS(16020), 1,
      anon_sym_LBRACE,
    ACTIONS(16022), 1,
      sym__layout_start,
    STATE(9648), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369063] = 3,
    ACTIONS(14789), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369094] = 3,
    ACTIONS(14826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369125] = 3,
    ACTIONS(14781), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369156] = 4,
    ACTIONS(15068), 1,
      anon_sym_EQ,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 17,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [369189] = 3,
    ACTIONS(14781), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369220] = 3,
    ACTIONS(14773), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369251] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369284] = 3,
    ACTIONS(14754), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369315] = 3,
    ACTIONS(14822), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 18,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369346] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369379] = 6,
    ACTIONS(14341), 1,
      anon_sym_DASH,
    ACTIONS(16022), 1,
      sym__layout_start,
    ACTIONS(16024), 1,
      anon_sym_LBRACE,
    STATE(9528), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369416] = 3,
    ACTIONS(14758), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369446] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16027), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2626), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 13,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [369482] = 3,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369512] = 3,
    ACTIONS(14862), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369542] = 3,
    ACTIONS(14708), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369572] = 3,
    ACTIONS(15423), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15425), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [369602] = 3,
    ACTIONS(14692), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369632] = 3,
    ACTIONS(14688), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369662] = 4,
    ACTIONS(16031), 1,
      anon_sym_DASH,
    ACTIONS(16033), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369694] = 3,
    ACTIONS(15950), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15948), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [369724] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16035), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_EQ,
    STATE(1991), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [369770] = 3,
    ACTIONS(15245), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15247), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [369800] = 3,
    ACTIONS(14662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369830] = 3,
    ACTIONS(15960), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15958), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [369860] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15219), 1,
      anon_sym_DASH,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16037), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_EQ,
    STATE(1991), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [369906] = 3,
    ACTIONS(14818), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [369936] = 3,
    ACTIONS(13734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 17,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_AT2,
  [369966] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [369998] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16039), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2566), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [370036] = 3,
    ACTIONS(14785), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370066] = 3,
    ACTIONS(14746), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370096] = 3,
    ACTIONS(16043), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16041), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [370126] = 3,
    ACTIONS(16047), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16045), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [370156] = 3,
    ACTIONS(14654), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370186] = 3,
    ACTIONS(14738), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370216] = 3,
    ACTIONS(16051), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16049), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [370246] = 3,
    ACTIONS(16055), 3,
      sym__integer_literal,
      anon_sym_LPAREN,
      anon_sym_SQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16053), 16,
      sym__splice_dollar,
      sym_quasiquote_start,
      sym_float,
      sym_char,
      sym_string,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
      anon_sym_LPAREN_POUND,
      anon_sym_LPAREN_POUND_LF,
      sym__varid,
      sym__conid,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_6,
      anon_sym_7,
  [370276] = 3,
    ACTIONS(14754), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370306] = 3,
    ACTIONS(14814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370336] = 3,
    ACTIONS(14810), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370366] = 3,
    ACTIONS(14754), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370396] = 3,
    ACTIONS(14878), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370426] = 3,
    ACTIONS(14874), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370456] = 3,
    ACTIONS(14696), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370486] = 3,
    ACTIONS(14797), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370516] = 3,
    ACTIONS(14684), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370546] = 3,
    ACTIONS(14680), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370576] = 3,
    ACTIONS(14658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370606] = 3,
    ACTIONS(14700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370636] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [370668] = 4,
    ACTIONS(16057), 1,
      sym__immediate_dot,
    ACTIONS(14716), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370700] = 3,
    ACTIONS(14822), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370730] = 3,
    ACTIONS(14806), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370760] = 3,
    ACTIONS(14777), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370790] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16059), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2539), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [370828] = 3,
    ACTIONS(14766), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370858] = 3,
    ACTIONS(14773), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370888] = 3,
    ACTIONS(14781), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370918] = 3,
    ACTIONS(14766), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370948] = 3,
    ACTIONS(14676), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [370978] = 3,
    ACTIONS(14762), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371008] = 3,
    ACTIONS(14712), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371038] = 3,
    ACTIONS(13680), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 17,
      sym__dot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [371068] = 3,
    ACTIONS(14832), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371098] = 3,
    ACTIONS(14670), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371128] = 3,
    ACTIONS(14674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371158] = 3,
    ACTIONS(14750), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371188] = 3,
    ACTIONS(14836), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371218] = 3,
    ACTIONS(14742), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371248] = 3,
    ACTIONS(14781), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371278] = 3,
    ACTIONS(14840), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371308] = 3,
    ACTIONS(14844), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371338] = 3,
    ACTIONS(14666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371368] = 3,
    ACTIONS(14734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371398] = 3,
    ACTIONS(14734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371428] = 3,
    ACTIONS(14858), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371458] = 3,
    ACTIONS(14866), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371488] = 3,
    ACTIONS(14870), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371518] = 3,
    ACTIONS(14730), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371548] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15101), 1,
      anon_sym_BQUOTE,
    ACTIONS(15107), 1,
      sym__consym,
    ACTIONS(16061), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(15062), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3385), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [371594] = 3,
    ACTIONS(14826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371624] = 3,
    ACTIONS(14726), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371654] = 3,
    ACTIONS(14814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371684] = 3,
    ACTIONS(14789), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371714] = 3,
    ACTIONS(14722), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371744] = 3,
    ACTIONS(14793), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371774] = 3,
    ACTIONS(14858), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371803] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [371834] = 3,
    ACTIONS(14862), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371863] = 4,
    ACTIONS(15068), 2,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [371894] = 3,
    ACTIONS(16065), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371923] = 3,
    ACTIONS(16069), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371952] = 3,
    ACTIONS(16073), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [371981] = 3,
    ACTIONS(16077), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372010] = 3,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [372039] = 3,
    ACTIONS(16081), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372068] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(16083), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1995), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [372113] = 3,
    ACTIONS(14878), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372142] = 3,
    ACTIONS(16087), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372171] = 5,
    ACTIONS(15974), 1,
      anon_sym_DASH,
    STATE(15458), 1,
      sym_guards,
    STATE(9572), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [372204] = 3,
    ACTIONS(16091), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372233] = 3,
    ACTIONS(14476), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [372262] = 3,
    ACTIONS(16095), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372291] = 3,
    ACTIONS(16099), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372320] = 3,
    ACTIONS(14109), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [372349] = 3,
    ACTIONS(14874), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372378] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [372409] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16101), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2643), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [372446] = 3,
    ACTIONS(16105), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372475] = 3,
    ACTIONS(14265), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [372504] = 3,
    ACTIONS(16109), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372533] = 3,
    ACTIONS(14844), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372562] = 3,
    ACTIONS(13680), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 16,
      sym__dot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [372591] = 6,
    ACTIONS(16002), 1,
      anon_sym_DASH,
    ACTIONS(16111), 1,
      anon_sym_LBRACE,
    ACTIONS(16113), 1,
      sym__layout_start,
    STATE(10021), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [372626] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16115), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2537), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [372663] = 3,
    ACTIONS(14832), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372692] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [372723] = 3,
    ACTIONS(14836), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372752] = 3,
    ACTIONS(13871), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [372781] = 3,
    ACTIONS(16119), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372810] = 3,
    ACTIONS(13738), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [372839] = 3,
    ACTIONS(14866), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372868] = 3,
    ACTIONS(16123), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372897] = 3,
    ACTIONS(16127), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372926] = 3,
    ACTIONS(15991), 2,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [372955] = 3,
    ACTIONS(14870), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [372984] = 3,
    ACTIONS(14058), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373013] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 15,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [373044] = 3,
    ACTIONS(14189), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373073] = 6,
    ACTIONS(14341), 1,
      anon_sym_DASH,
    ACTIONS(16113), 1,
      sym__layout_start,
    ACTIONS(16129), 1,
      anon_sym_LBRACE,
    STATE(9782), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373108] = 3,
    ACTIONS(14040), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373137] = 3,
    ACTIONS(16134), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [373166] = 4,
    ACTIONS(16031), 1,
      anon_sym_DASH,
    ACTIONS(16136), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [373197] = 3,
    ACTIONS(14840), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [373226] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 17,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [373255] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(15974), 1,
      anon_sym_DASH,
    STATE(15458), 1,
      sym_guards,
    STATE(9572), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373290] = 3,
    ACTIONS(16140), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [373319] = 3,
    ACTIONS(13889), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373348] = 3,
    ACTIONS(16144), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [373377] = 3,
    ACTIONS(14249), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373406] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16146), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2645), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373443] = 6,
    ACTIONS(15980), 1,
      anon_sym_DASH,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(15458), 1,
      sym_guards,
    STATE(9572), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15978), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373478] = 3,
    ACTIONS(14062), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373507] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16148), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2612), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [373544] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373575] = 3,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373604] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373635] = 3,
    ACTIONS(14269), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373664] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16150), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2509), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [373701] = 3,
    ACTIONS(14255), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373730] = 3,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373759] = 3,
    ACTIONS(16154), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 17,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [373788] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(16083), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1986), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [373833] = 3,
    ACTIONS(14185), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 16,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373862] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16156), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2600), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [373899] = 3,
    ACTIONS(14265), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373927] = 3,
    ACTIONS(14750), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [373955] = 3,
    ACTIONS(16109), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [373983] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15072), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3381), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [374025] = 3,
    ACTIONS(14680), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374053] = 3,
    ACTIONS(14676), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374081] = 3,
    ACTIONS(14670), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374109] = 3,
    ACTIONS(13734), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 14,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
      anon_sym_AT2,
  [374137] = 3,
    ACTIONS(14666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374165] = 3,
    ACTIONS(14793), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374193] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16158), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2654), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 10,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [374229] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16160), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2657), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [374265] = 3,
    ACTIONS(14712), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374293] = 3,
    ACTIONS(14674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374321] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15199), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3360), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [374363] = 3,
    ACTIONS(14040), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374391] = 3,
    ACTIONS(16127), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [374419] = 3,
    ACTIONS(16123), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [374447] = 3,
    ACTIONS(14822), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374475] = 6,
    ACTIONS(16002), 1,
      anon_sym_DASH,
    ACTIONS(16162), 1,
      anon_sym_LBRACE,
    ACTIONS(16164), 1,
      sym__layout_start,
    STATE(10775), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374509] = 3,
    ACTIONS(14062), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374537] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15548), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3363), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [374579] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [374609] = 3,
    ACTIONS(14700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374637] = 3,
    ACTIONS(14255), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374665] = 3,
    ACTIONS(14269), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374693] = 3,
    ACTIONS(14249), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374721] = 3,
    ACTIONS(14189), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374749] = 3,
    ACTIONS(14058), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374777] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(16166), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3456), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [374819] = 3,
    ACTIONS(13738), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374847] = 3,
    ACTIONS(14654), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374875] = 3,
    ACTIONS(14662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374903] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [374933] = 3,
    ACTIONS(14476), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [374961] = 6,
    ACTIONS(14889), 1,
      anon_sym_AT2,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14887), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13684), 7,
      sym__varsym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [374995] = 3,
    ACTIONS(14684), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375023] = 3,
    ACTIONS(14696), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375051] = 3,
    ACTIONS(15991), 2,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [375079] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 16,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [375107] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15596), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3399), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [375149] = 4,
    ACTIONS(16168), 1,
      sym__immediate_dot,
    ACTIONS(14716), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375179] = 3,
    ACTIONS(14708), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375207] = 5,
    ACTIONS(15974), 1,
      anon_sym_DASH,
    STATE(15635), 1,
      sym_guards,
    STATE(9681), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [375239] = 3,
    ACTIONS(13871), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375267] = 3,
    ACTIONS(16099), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [375295] = 3,
    ACTIONS(14746), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375323] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 14,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [375353] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16170), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2519), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [375389] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [375419] = 3,
    ACTIONS(14109), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375447] = 3,
    ACTIONS(14785), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375475] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375505] = 6,
    ACTIONS(14341), 1,
      anon_sym_DASH,
    ACTIONS(16172), 1,
      anon_sym_LBRACE,
    ACTIONS(16175), 1,
      sym__layout_start,
    STATE(10121), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [375539] = 3,
    ACTIONS(14722), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375567] = 3,
    ACTIONS(14726), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375595] = 3,
    ACTIONS(14730), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375623] = 3,
    ACTIONS(14734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375651] = 3,
    ACTIONS(16154), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [375679] = 3,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375707] = 3,
    ACTIONS(14734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375735] = 3,
    ACTIONS(16091), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [375763] = 3,
    ACTIONS(16095), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [375791] = 3,
    ACTIONS(14742), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [375819] = 3,
    ACTIONS(16077), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [375847] = 3,
    ACTIONS(16105), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [375875] = 3,
    ACTIONS(16081), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [375903] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15580), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3388), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [375945] = 3,
    ACTIONS(16065), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [375973] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16177), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2663), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 10,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [376009] = 3,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376037] = 3,
    ACTIONS(16087), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [376065] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15227), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3362), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [376107] = 3,
    ACTIONS(14758), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376135] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 16,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [376163] = 3,
    ACTIONS(13734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376191] = 3,
    ACTIONS(14762), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376219] = 3,
    ACTIONS(14766), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376247] = 3,
    ACTIONS(14688), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376275] = 3,
    ACTIONS(14766), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376303] = 3,
    ACTIONS(14777), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376331] = 3,
    ACTIONS(14692), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376359] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 16,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [376387] = 3,
    ACTIONS(14806), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376415] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 16,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
      anon_sym_in,
  [376443] = 5,
    ACTIONS(14903), 1,
      anon_sym_AT2,
    ACTIONS(13702), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 6,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(13695), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
  [376475] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16179), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2582), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [376511] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [376541] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15536), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3356), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [376583] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15359), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3386), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [376625] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(16083), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [376669] = 3,
    ACTIONS(16073), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [376697] = 3,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376725] = 6,
    ACTIONS(14341), 1,
      anon_sym_DASH,
    ACTIONS(16164), 1,
      sym__layout_start,
    ACTIONS(16181), 1,
      anon_sym_LBRACE,
    STATE(9992), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376759] = 3,
    ACTIONS(14658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376787] = 6,
    ACTIONS(15980), 1,
      anon_sym_DASH,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(15635), 1,
      sym_guards,
    STATE(9681), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15978), 12,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [376821] = 3,
    ACTIONS(13889), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376849] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [376879] = 3,
    ACTIONS(16069), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [376907] = 3,
    ACTIONS(16140), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [376935] = 4,
    ACTIONS(15068), 2,
      anon_sym_DASH,
      anon_sym_EQ,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [376965] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 14,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [376995] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 16,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [377023] = 3,
    ACTIONS(14797), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377051] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [377081] = 6,
    ACTIONS(16002), 1,
      anon_sym_DASH,
    ACTIONS(16175), 1,
      sym__layout_start,
    ACTIONS(16184), 1,
      anon_sym_LBRACE,
    STATE(10348), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [377115] = 3,
    ACTIONS(14810), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377143] = 3,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377171] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15600), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3406), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [377213] = 3,
    ACTIONS(14814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377241] = 3,
    ACTIONS(14818), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377269] = 3,
    ACTIONS(14185), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377297] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16186), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2637), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [377333] = 3,
    ACTIONS(14814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377361] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
      anon_sym_in,
  [377391] = 3,
    ACTIONS(14789), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377419] = 3,
    ACTIONS(13680), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 14,
      sym__dot,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [377447] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377477] = 3,
    ACTIONS(14826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377505] = 3,
    ACTIONS(16134), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [377533] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [377563] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 14,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [377593] = 3,
    ACTIONS(14781), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377621] = 3,
    ACTIONS(14781), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377649] = 3,
    ACTIONS(14773), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377677] = 3,
    ACTIONS(14754), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377705] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15066), 1,
      anon_sym_SQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(15606), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(3378), 9,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
      sym__promoted_tyconop,
      sym__qtyconop,
  [377747] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16188), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2517), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 10,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [377783] = 3,
    ACTIONS(16144), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 16,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [377811] = 3,
    ACTIONS(14754), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377839] = 3,
    ACTIONS(14738), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 15,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377867] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16190), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [377910] = 3,
    ACTIONS(14814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [377937] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16192), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [377980] = 3,
    ACTIONS(14476), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [378007] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16194), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2609), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [378042] = 3,
    ACTIONS(14662), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [378069] = 3,
    ACTIONS(14062), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [378096] = 3,
    ACTIONS(14822), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [378123] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16196), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [378166] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16198), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [378209] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16200), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [378252] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16202), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [378295] = 3,
    ACTIONS(14654), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [378322] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16204), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [378365] = 3,
    ACTIONS(14700), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [378392] = 3,
    ACTIONS(14870), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [378419] = 3,
    ACTIONS(14866), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [378446] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16206), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [378489] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16208), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [378532] = 3,
    ACTIONS(14858), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [378559] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [378588] = 4,
    ACTIONS(14704), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 6,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(14919), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
  [378617] = 3,
    ACTIONS(14844), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [378644] = 3,
    ACTIONS(14265), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [378671] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16210), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [378714] = 3,
    ACTIONS(13738), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [378741] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16212), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [378784] = 3,
    ACTIONS(14840), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [378811] = 3,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [378838] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16214), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [378881] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16216), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [378924] = 4,
    ACTIONS(14907), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 6,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(14916), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
  [378953] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16218), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [378996] = 3,
    ACTIONS(14836), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [379023] = 3,
    ACTIONS(14058), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [379050] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16220), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [379093] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16222), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [379136] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16224), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [379179] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16226), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [379222] = 3,
    ACTIONS(14832), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [379249] = 3,
    ACTIONS(14189), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [379276] = 4,
    ACTIONS(14907), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 6,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(14911), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
  [379305] = 5,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14931), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14706), 7,
      sym__varsym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [379336] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16228), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [379379] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16230), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [379422] = 3,
    ACTIONS(14249), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [379449] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16232), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [379492] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16234), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [379535] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16236), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [379578] = 5,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(13702), 2,
      sym__immediate_dot,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 6,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(14851), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
  [379609] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16238), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [379652] = 3,
    ACTIONS(14674), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [379679] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16240), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [379722] = 3,
    ACTIONS(14754), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [379749] = 3,
    ACTIONS(14269), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [379776] = 3,
    ACTIONS(14874), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [379803] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16242), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [379846] = 3,
    ACTIONS(14255), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [379873] = 3,
    ACTIONS(14754), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [379900] = 5,
    ACTIONS(9703), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14909), 7,
      sym__varsym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [379931] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [379960] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16244), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [380003] = 5,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14933), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14909), 7,
      sym__varsym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [380034] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16246), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [380077] = 3,
    ACTIONS(13719), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380104] = 3,
    ACTIONS(14878), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [380131] = 3,
    ACTIONS(14773), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380158] = 6,
    ACTIONS(13702), 1,
      anon_sym_DASH,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(14854), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14851), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13684), 7,
      sym__varsym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [380191] = 3,
    ACTIONS(14862), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [380218] = 3,
    ACTIONS(14781), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380245] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16248), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [380288] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [380317] = 3,
    ACTIONS(14781), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380344] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [380373] = 15,
    ACTIONS(14001), 1,
      sym__conid,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(16252), 1,
      anon_sym_LPAREN,
    ACTIONS(16254), 1,
      anon_sym_RPAREN,
    ACTIONS(16258), 1,
      anon_sym_module,
    ACTIONS(16260), 1,
      sym_comma,
    STATE(13883), 1,
      aux_sym__qualifying_module,
    STATE(13885), 1,
      sym_namespace,
    STATE(14317), 1,
      sym_constructor,
    STATE(15008), 1,
      sym_qualified_type,
    STATE(16095), 1,
      sym_export,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    STATE(18403), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [380424] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [380453] = 3,
    ACTIONS(14793), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380480] = 3,
    ACTIONS(14662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [380507] = 3,
    ACTIONS(14109), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380534] = 3,
    ACTIONS(14666), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380561] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16262), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [380604] = 3,
    ACTIONS(14684), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380631] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [380660] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16264), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [380703] = 3,
    ACTIONS(14670), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380730] = 3,
    ACTIONS(14826), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380757] = 3,
    ACTIONS(14676), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380784] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16266), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [380827] = 3,
    ACTIONS(14789), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380854] = 3,
    ACTIONS(14680), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380881] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16268), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [380924] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16270), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [380967] = 3,
    ACTIONS(14814), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [380994] = 3,
    ACTIONS(14696), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [381021] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16272), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [381064] = 3,
    ACTIONS(14654), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [381091] = 3,
    ACTIONS(14818), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [381118] = 3,
    ACTIONS(14700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [381145] = 5,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14924), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13776), 7,
      sym__varsym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [381176] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16274), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [381219] = 3,
    ACTIONS(14746), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [381246] = 3,
    ACTIONS(14785), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [381273] = 3,
    ACTIONS(14822), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [381300] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16276), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [381343] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16278), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [381386] = 3,
    ACTIONS(14814), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [381413] = 3,
    ACTIONS(14810), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [381440] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 15,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [381467] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16280), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [381510] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16282), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [381553] = 3,
    ACTIONS(14674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [381580] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16284), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [381623] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16286), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [381666] = 3,
    ACTIONS(14688), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [381693] = 3,
    ACTIONS(14692), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [381720] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16288), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [381763] = 3,
    ACTIONS(13889), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [381790] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16290), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [381833] = 3,
    ACTIONS(14797), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [381860] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 15,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [381887] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16292), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [381930] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16294), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [381973] = 3,
    ACTIONS(14712), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [382000] = 3,
    ACTIONS(14793), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [382027] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16296), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [382070] = 3,
    ACTIONS(14666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [382097] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 15,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [382124] = 3,
    ACTIONS(14658), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [382151] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [382180] = 3,
    ACTIONS(14746), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [382207] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16298), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [382250] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16300), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [382293] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16302), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2522), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [382328] = 3,
    ACTIONS(14670), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [382355] = 3,
    ACTIONS(14676), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [382382] = 3,
    ACTIONS(14680), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [382409] = 3,
    ACTIONS(14684), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [382436] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16304), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [382479] = 3,
    ACTIONS(14806), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [382506] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16306), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [382549] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16308), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [382592] = 3,
    ACTIONS(14777), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [382619] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16310), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [382662] = 3,
    ACTIONS(14696), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [382689] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16312), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [382732] = 3,
    ACTIONS(14766), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [382759] = 3,
    ACTIONS(14766), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [382786] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16314), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [382829] = 3,
    ACTIONS(14785), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [382856] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16316), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [382899] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 15,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [382926] = 3,
    ACTIONS(14738), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [382953] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16318), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [382996] = 3,
    ACTIONS(14762), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [383023] = 3,
    ACTIONS(14688), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [383050] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 15,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
      anon_sym_in,
  [383077] = 3,
    ACTIONS(14692), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [383104] = 3,
    ACTIONS(14758), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [383131] = 3,
    ACTIONS(14750), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [383158] = 4,
    ACTIONS(13774), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 6,
      sym__arith_dotdot,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
    ACTIONS(13805), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
  [383187] = 3,
    ACTIONS(13871), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [383214] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 15,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [383241] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16320), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [383284] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16322), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [383327] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 13,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [383356] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16324), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [383399] = 3,
    ACTIONS(14742), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [383426] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16326), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [383469] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16328), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [383512] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16330), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [383555] = 3,
    ACTIONS(14712), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [383582] = 3,
    ACTIONS(14734), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [383609] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16332), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [383652] = 3,
    ACTIONS(14734), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [383679] = 3,
    ACTIONS(14730), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [383706] = 3,
    ACTIONS(14726), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [383733] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
      anon_sym_in,
  [383762] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16334), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [383805] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16336), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [383848] = 3,
    ACTIONS(14722), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [383875] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16338), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [383918] = 3,
    ACTIONS(13702), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [383945] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 16,
      sym__dot,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
      anon_sym_via,
      anon_sym_deriving,
  [383970] = 5,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(17303), 1,
      sym_guards,
    STATE(9900), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15978), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [384001] = 3,
    ACTIONS(13774), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [384028] = 3,
    ACTIONS(14185), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [384055] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16340), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [384098] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16342), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [384141] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16344), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [384184] = 3,
    ACTIONS(14708), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [384211] = 3,
    ACTIONS(14704), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [384238] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16346), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [384281] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [384310] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16348), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [384353] = 5,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    STATE(17303), 1,
      sym_guards,
    STATE(9900), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [384384] = 4,
    ACTIONS(16350), 1,
      sym__immediate_dot,
    ACTIONS(14716), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [384413] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16352), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [384456] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16354), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [384499] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16356), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [384542] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16358), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [384585] = 3,
    ACTIONS(14754), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [384612] = 3,
    ACTIONS(14754), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [384639] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16360), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [384682] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16362), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [384725] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16364), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [384768] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16366), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [384811] = 6,
    ACTIONS(14903), 1,
      anon_sym_AT2,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14887), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [384844] = 3,
    ACTIONS(14773), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [384871] = 3,
    ACTIONS(14781), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [384898] = 3,
    ACTIONS(14738), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [384925] = 3,
    ACTIONS(14781), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [384952] = 3,
    ACTIONS(14826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [384979] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16368), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [385022] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16370), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [385065] = 3,
    ACTIONS(14789), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385092] = 3,
    ACTIONS(14814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385119] = 3,
    ACTIONS(14762), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385146] = 4,
    ACTIONS(16372), 1,
      sym__immediate_dot,
    ACTIONS(14716), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385175] = 3,
    ACTIONS(14818), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385202] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16374), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [385245] = 3,
    ACTIONS(14810), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385272] = 5,
    ACTIONS(16376), 1,
      anon_sym_LBRACE,
    ACTIONS(16379), 1,
      sym__layout_start,
    STATE(10766), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [385303] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16381), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [385346] = 4,
    STATE(17303), 1,
      sym_guards,
    STATE(9900), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [385375] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [385404] = 3,
    ACTIONS(14797), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385431] = 3,
    ACTIONS(14708), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385458] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [385487] = 11,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    ACTIONS(16385), 1,
      sym__tyconsym,
    STATE(12129), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20070), 1,
      sym__modid,
    STATE(19289), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(19319), 5,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
  [385530] = 3,
    ACTIONS(14658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385557] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16387), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [385600] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16389), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [385643] = 5,
    ACTIONS(16379), 1,
      sym__layout_start,
    ACTIONS(16391), 1,
      anon_sym_LBRACE,
    STATE(10938), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [385674] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16393), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2587), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 9,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [385709] = 3,
    ACTIONS(14722), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385736] = 3,
    ACTIONS(14806), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385763] = 3,
    ACTIONS(14726), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385790] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 15,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [385817] = 3,
    ACTIONS(14730), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385844] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16395), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [385887] = 3,
    ACTIONS(14777), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385914] = 3,
    ACTIONS(14040), 3,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [385941] = 3,
    ACTIONS(14734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385968] = 3,
    ACTIONS(14766), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [385995] = 3,
    ACTIONS(14734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [386022] = 3,
    ACTIONS(14766), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [386049] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16397), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [386092] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16399), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [386135] = 4,
    ACTIONS(16031), 1,
      anon_sym_DASH,
    ACTIONS(16401), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [386164] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16403), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [386207] = 3,
    ACTIONS(14758), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [386234] = 3,
    ACTIONS(14742), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [386261] = 3,
    ACTIONS(14750), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [386288] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16405), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2568), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 9,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [386323] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 15,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [386350] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16407), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [386393] = 11,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15221), 1,
      anon_sym_BQUOTE,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    ACTIONS(16409), 1,
      anon_sym_RPAREN,
    STATE(12413), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(1977), 7,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
      sym__qvarop,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__qop,
  [386436] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [386464] = 11,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(16411), 1,
      sym__varid,
    ACTIONS(16415), 1,
      anon_sym_LPAREN,
    STATE(9139), 1,
      sym_constructor,
    STATE(9233), 1,
      sym_qualified_constructor,
    STATE(13620), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16413), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9267), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9352), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386506] = 3,
    ACTIONS(16154), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [386532] = 11,
    ACTIONS(4073), 1,
      sym__conid,
    ACTIONS(16417), 1,
      sym__varid,
    ACTIONS(16419), 1,
      anon_sym_LPAREN,
    STATE(4661), 1,
      sym_constructor,
    STATE(5081), 1,
      sym_qualified_constructor,
    STATE(13808), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2743), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5200), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(5329), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386574] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [386600] = 14,
    ACTIONS(14001), 1,
      sym__conid,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(16252), 1,
      anon_sym_LPAREN,
    ACTIONS(16258), 1,
      anon_sym_module,
    ACTIONS(16421), 1,
      anon_sym_RPAREN,
    STATE(13883), 1,
      aux_sym__qualifying_module,
    STATE(13885), 1,
      sym_namespace,
    STATE(14317), 1,
      sym_constructor,
    STATE(15008), 1,
      sym_qualified_type,
    STATE(18161), 1,
      sym_export,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    STATE(18403), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386648] = 11,
    ACTIONS(9170), 1,
      sym__conid,
    ACTIONS(16423), 1,
      sym__varid,
    ACTIONS(16425), 1,
      anon_sym_LPAREN,
    STATE(10756), 1,
      sym_constructor,
    STATE(10941), 1,
      sym_qualified_constructor,
    STATE(13802), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9166), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10930), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(11476), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386690] = 11,
    ACTIONS(6971), 1,
      sym__conid,
    ACTIONS(16427), 1,
      sym__varid,
    ACTIONS(16431), 1,
      anon_sym_LPAREN,
    STATE(7183), 1,
      sym_constructor,
    STATE(7497), 1,
      sym_qualified_constructor,
    STATE(13818), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16429), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7456), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7572), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386732] = 3,
    ACTIONS(14874), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [386758] = 5,
    ACTIONS(16433), 1,
      anon_sym_LBRACE,
    ACTIONS(16435), 1,
      sym__layout_start,
    STATE(11735), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [386788] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [386816] = 11,
    ACTIONS(6629), 1,
      sym__conid,
    ACTIONS(16437), 1,
      sym__varid,
    ACTIONS(16441), 1,
      anon_sym_LPAREN,
    STATE(5898), 1,
      sym_constructor,
    STATE(6046), 1,
      sym_qualified_constructor,
    STATE(13826), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16439), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5983), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6078), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386858] = 3,
    ACTIONS(16134), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [386884] = 11,
    ACTIONS(4055), 1,
      sym__conid,
    ACTIONS(16443), 1,
      sym__varid,
    ACTIONS(16445), 1,
      anon_sym_LPAREN,
    STATE(4257), 1,
      sym_constructor,
    STATE(4416), 1,
      sym_qualified_constructor,
    STATE(13792), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2090), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4419), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(4456), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386926] = 11,
    ACTIONS(6352), 1,
      sym__conid,
    ACTIONS(16447), 1,
      sym__varid,
    ACTIONS(16451), 1,
      anon_sym_LPAREN,
    STATE(5901), 1,
      sym_constructor,
    STATE(6040), 1,
      sym_qualified_constructor,
    STATE(13842), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16449), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5970), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6126), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [386968] = 11,
    ACTIONS(8823), 1,
      sym__conid,
    ACTIONS(16453), 1,
      sym__varid,
    ACTIONS(16455), 1,
      anon_sym_LPAREN,
    STATE(9537), 1,
      sym_constructor,
    STATE(9678), 1,
      sym_qualified_constructor,
    STATE(13851), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8819), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9610), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9656), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387010] = 11,
    ACTIONS(655), 1,
      sym__conid,
    ACTIONS(16457), 1,
      sym__varid,
    ACTIONS(16461), 1,
      anon_sym_LPAREN,
    STATE(3977), 1,
      sym_constructor,
    STATE(4051), 1,
      sym_qualified_constructor,
    STATE(13862), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16459), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9002), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9165), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387052] = 11,
    ACTIONS(13732), 1,
      sym__conid,
    ACTIONS(16463), 1,
      sym__varid,
    ACTIONS(16467), 1,
      anon_sym_LPAREN,
    STATE(12839), 1,
      sym_constructor,
    STATE(13272), 1,
      sym_qualified_constructor,
    STATE(13749), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16465), 2,
      sym_label,
      sym_implicit_parid,
    STATE(13420), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(13444), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387094] = 3,
    ACTIONS(14878), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [387120] = 5,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(17053), 1,
      sym_guards,
    STATE(9993), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15978), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [387150] = 11,
    ACTIONS(4111), 1,
      sym__conid,
    ACTIONS(16469), 1,
      sym__varid,
    ACTIONS(16471), 1,
      anon_sym_LPAREN,
    STATE(9458), 1,
      sym_constructor,
    STATE(9525), 1,
      sym_qualified_constructor,
    STATE(13966), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4105), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9576), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(9580), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387192] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(16473), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387220] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387246] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387272] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387298] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387324] = 3,
    ACTIONS(14836), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [387350] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387376] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387402] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387428] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387454] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387480] = 11,
    ACTIONS(8970), 1,
      sym__conid,
    ACTIONS(16475), 1,
      sym__varid,
    ACTIONS(16477), 1,
      anon_sym_LPAREN,
    STATE(10870), 1,
      sym_constructor,
    STATE(11713), 1,
      sym_qualified_constructor,
    STATE(13765), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8966), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11537), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(11648), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387522] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387548] = 3,
    ACTIONS(14862), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [387574] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387600] = 11,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(16479), 1,
      sym__varid,
    ACTIONS(16483), 1,
      anon_sym_LPAREN,
    STATE(6028), 1,
      sym_constructor,
    STATE(6372), 1,
      sym_qualified_constructor,
    STATE(13880), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16481), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6310), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6324), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387642] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387668] = 3,
    ACTIONS(16127), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [387694] = 3,
    ACTIONS(16123), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [387720] = 6,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(13709), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(14887), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13695), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [387752] = 3,
    ACTIONS(16144), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [387778] = 4,
    STATE(16164), 1,
      sym_guards,
    STATE(10123), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [387806] = 3,
    ACTIONS(16099), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [387832] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387858] = 11,
    ACTIONS(3051), 1,
      sym__conid,
    ACTIONS(16485), 1,
      sym__varid,
    ACTIONS(16487), 1,
      anon_sym_LPAREN,
    STATE(4400), 1,
      sym_constructor,
    STATE(5105), 1,
      sym_qualified_constructor,
    STATE(13395), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3045), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4861), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5046), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [387900] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387926] = 3,
    ACTIONS(16095), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [387952] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [387978] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388004] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388030] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [388056] = 11,
    ACTIONS(13853), 1,
      sym__conid,
    ACTIONS(16489), 1,
      sym__varid,
    ACTIONS(16493), 1,
      anon_sym_LPAREN,
    STATE(12060), 1,
      sym_constructor,
    STATE(12290), 1,
      sym_qualified_constructor,
    STATE(13901), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16491), 2,
      sym_label,
      sym_implicit_parid,
    STATE(12595), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(12643), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388098] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388124] = 3,
    ACTIONS(14840), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [388150] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [388178] = 3,
    ACTIONS(14844), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [388204] = 5,
    ACTIONS(16495), 1,
      anon_sym_LBRACE,
    ACTIONS(16498), 1,
      sym__layout_start,
    STATE(10893), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [388234] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388260] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388286] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388312] = 4,
    ACTIONS(16031), 1,
      anon_sym_DASH,
    ACTIONS(16500), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [388340] = 3,
    ACTIONS(16069), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [388366] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388392] = 3,
    ACTIONS(16065), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [388418] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388444] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388470] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388496] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388522] = 3,
    ACTIONS(16081), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [388548] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [388576] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388602] = 3,
    ACTIONS(16077), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [388628] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388654] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388680] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388706] = 11,
    ACTIONS(4171), 1,
      sym__conid,
    ACTIONS(16502), 1,
      sym__varid,
    ACTIONS(16504), 1,
      anon_sym_LPAREN,
    STATE(5151), 1,
      sym_constructor,
    STATE(5594), 1,
      sym_qualified_constructor,
    STATE(13763), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(15), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5577), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(5710), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388748] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388774] = 3,
    ACTIONS(14858), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [388800] = 11,
    ACTIONS(4081), 1,
      sym__conid,
    ACTIONS(16506), 1,
      sym__varid,
    ACTIONS(16508), 1,
      anon_sym_LPAREN,
    STATE(4552), 1,
      sym_constructor,
    STATE(5251), 1,
      sym_qualified_constructor,
    STATE(13737), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2613), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5098), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(5481), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [388842] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388868] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388894] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388920] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [388948] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [388974] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [389000] = 11,
    ACTIONS(9286), 1,
      sym__conid,
    ACTIONS(16510), 1,
      sym__varid,
    ACTIONS(16512), 1,
      anon_sym_LPAREN,
    STATE(10370), 1,
      sym_constructor,
    STATE(11461), 1,
      sym_qualified_constructor,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9282), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10999), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(11383), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389042] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [389068] = 9,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16516), 1,
      anon_sym_BQUOTE,
    ACTIONS(16518), 1,
      sym__consym,
    STATE(13225), 1,
      sym_constructor,
    STATE(13821), 1,
      aux_sym__qualifying_module,
    STATE(20542), 1,
      sym__modid,
    STATE(3214), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16514), 7,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [389106] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16520), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2618), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 8,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [389140] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [389166] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [389192] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [389220] = 5,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    STATE(16547), 1,
      sym_guards,
    STATE(10088), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [389250] = 3,
    ACTIONS(14866), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [389276] = 11,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(16522), 1,
      sym__varid,
    ACTIONS(16526), 1,
      anon_sym_LPAREN,
    STATE(7279), 1,
      sym_constructor,
    STATE(7402), 1,
      sym_qualified_constructor,
    STATE(13939), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16524), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7370), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7519), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389318] = 11,
    ACTIONS(7215), 1,
      sym__conid,
    ACTIONS(16528), 1,
      sym__varid,
    ACTIONS(16532), 1,
      anon_sym_LPAREN,
    STATE(6503), 1,
      sym_constructor,
    STATE(6631), 1,
      sym_qualified_constructor,
    STATE(13948), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16530), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6601), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6763), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389360] = 11,
    ACTIONS(12785), 1,
      sym__conid,
    ACTIONS(16534), 1,
      sym__varid,
    ACTIONS(16538), 1,
      anon_sym_LPAREN,
    STATE(8041), 1,
      sym_constructor,
    STATE(8307), 1,
      sym_qualified_constructor,
    STATE(13959), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16536), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8652), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8670), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389402] = 11,
    ACTIONS(14035), 1,
      sym__conid,
    ACTIONS(16540), 1,
      sym__varid,
    ACTIONS(16544), 1,
      anon_sym_LPAREN,
    STATE(12540), 1,
      sym_constructor,
    STATE(12828), 1,
      sym_qualified_constructor,
    STATE(13975), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16542), 2,
      sym_label,
      sym_implicit_parid,
    STATE(13173), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(13185), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389444] = 11,
    ACTIONS(1698), 1,
      sym__conid,
    ACTIONS(16546), 1,
      sym__varid,
    ACTIONS(16548), 1,
      anon_sym_LPAREN,
    STATE(3471), 1,
      sym_constructor,
    STATE(3677), 1,
      sym_qualified_constructor,
    STATE(13516), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(93), 2,
      sym_label,
      sym_implicit_parid,
    STATE(3549), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(3656), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389486] = 11,
    ACTIONS(7158), 1,
      sym__conid,
    ACTIONS(16550), 1,
      sym__varid,
    ACTIONS(16554), 1,
      anon_sym_LPAREN,
    STATE(4628), 1,
      sym_constructor,
    STATE(5128), 1,
      sym_qualified_constructor,
    STATE(13726), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16552), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4925), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5057), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389528] = 11,
    ACTIONS(10298), 1,
      sym__conid,
    ACTIONS(16556), 1,
      sym__varid,
    ACTIONS(16560), 1,
      anon_sym_LPAREN,
    STATE(8134), 1,
      sym_constructor,
    STATE(8221), 1,
      sym_qualified_constructor,
    STATE(13390), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16558), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8171), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8242), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389570] = 3,
    ACTIONS(14870), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [389596] = 11,
    ACTIONS(13286), 1,
      sym__conid,
    ACTIONS(16562), 1,
      sym__varid,
    ACTIONS(16566), 1,
      anon_sym_LPAREN,
    STATE(8937), 1,
      sym_constructor,
    STATE(9035), 1,
      sym_qualified_constructor,
    STATE(13731), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16564), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9026), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9114), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389638] = 10,
    ACTIONS(16570), 1,
      anon_sym_EQ,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(16574), 1,
      sym_where,
    STATE(2434), 1,
      sym__colon2,
    STATE(12103), 1,
      sym__type_annotation,
    ACTIONS(15742), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    STATE(13597), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(16568), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(16257), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389678] = 11,
    ACTIONS(7140), 1,
      sym__conid,
    ACTIONS(16576), 1,
      sym__varid,
    ACTIONS(16580), 1,
      anon_sym_LPAREN,
    STATE(6138), 1,
      sym_constructor,
    STATE(6396), 1,
      sym_qualified_constructor,
    STATE(13717), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16578), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6442), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6576), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389720] = 11,
    ACTIONS(4519), 1,
      sym__conid,
    ACTIONS(16582), 1,
      sym__varid,
    ACTIONS(16584), 1,
      anon_sym_LPAREN,
    STATE(10104), 1,
      sym_constructor,
    STATE(10702), 1,
      sym_qualified_constructor,
    STATE(13708), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8498), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10394), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(10583), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389762] = 11,
    ACTIONS(11737), 1,
      sym__conid,
    ACTIONS(16586), 1,
      sym__varid,
    ACTIONS(16590), 1,
      anon_sym_LPAREN,
    STATE(7906), 1,
      sym_constructor,
    STATE(8047), 1,
      sym_qualified_constructor,
    STATE(13698), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16588), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8103), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8128), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389804] = 11,
    ACTIONS(13558), 1,
      sym__conid,
    ACTIONS(16592), 1,
      sym__varid,
    ACTIONS(16596), 1,
      anon_sym_LPAREN,
    STATE(13980), 1,
      aux_sym__qualifying_module,
    STATE(14077), 1,
      sym_constructor,
    STATE(15327), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16594), 2,
      sym_label,
      sym_implicit_parid,
    STATE(15401), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(15412), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389846] = 11,
    ACTIONS(11976), 1,
      sym__conid,
    ACTIONS(16598), 1,
      sym__varid,
    ACTIONS(16602), 1,
      anon_sym_LPAREN,
    STATE(8362), 1,
      sym_constructor,
    STATE(8447), 1,
      sym_qualified_constructor,
    STATE(13644), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16600), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8461), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8552), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389888] = 11,
    ACTIONS(6695), 1,
      sym__conid,
    ACTIONS(16604), 1,
      sym__varid,
    ACTIONS(16608), 1,
      anon_sym_LPAREN,
    STATE(6329), 1,
      sym_constructor,
    STATE(6739), 1,
      sym_qualified_constructor,
    STATE(13683), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16606), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6650), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6691), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [389930] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [389958] = 11,
    ACTIONS(6036), 1,
      sym__conid,
    ACTIONS(16610), 1,
      sym__varid,
    ACTIONS(16614), 1,
      anon_sym_LPAREN,
    STATE(5572), 1,
      sym_constructor,
    STATE(5817), 1,
      sym_qualified_constructor,
    STATE(13671), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16612), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5890), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5911), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390000] = 11,
    ACTIONS(8476), 1,
      sym__conid,
    ACTIONS(16616), 1,
      sym__varid,
    ACTIONS(16618), 1,
      anon_sym_LPAREN,
    STATE(10211), 1,
      sym_constructor,
    STATE(10450), 1,
      sym_qualified_constructor,
    STATE(13914), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8472), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10451), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(10508), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390042] = 5,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(16547), 1,
      sym_guards,
    STATE(10088), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15978), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [390072] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [390098] = 11,
    ACTIONS(14078), 1,
      sym__conid,
    ACTIONS(16620), 1,
      sym__varid,
    ACTIONS(16624), 1,
      anon_sym_LPAREN,
    STATE(13540), 1,
      aux_sym__qualifying_module,
    STATE(14579), 1,
      sym_constructor,
    STATE(14634), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16622), 2,
      sym_label,
      sym_implicit_parid,
    STATE(14669), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(14670), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390140] = 3,
    ACTIONS(14832), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [390166] = 5,
    ACTIONS(16498), 1,
      sym__layout_start,
    ACTIONS(16626), 1,
      anon_sym_LBRACE,
    STATE(11656), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [390196] = 10,
    ACTIONS(16628), 1,
      anon_sym_EQ,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    ACTIONS(16632), 1,
      sym_where,
    STATE(2441), 1,
      sym__colon2,
    STATE(11950), 1,
      sym__type_annotation,
    ACTIONS(15726), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    STATE(13681), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(16568), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(16269), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390236] = 11,
    ACTIONS(4143), 1,
      sym__conid,
    ACTIONS(16634), 1,
      sym__varid,
    ACTIONS(16636), 1,
      anon_sym_LPAREN,
    STATE(4335), 1,
      sym_constructor,
    STATE(4623), 1,
      sym_qualified_constructor,
    STATE(13973), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2787), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4520), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(4615), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390278] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [390306] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [390332] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [390360] = 3,
    ACTIONS(16119), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [390386] = 11,
    ACTIONS(4177), 1,
      sym__conid,
    ACTIONS(16638), 1,
      sym__varid,
    ACTIONS(16640), 1,
      anon_sym_LPAREN,
    STATE(4233), 1,
      sym_constructor,
    STATE(4725), 1,
      sym_qualified_constructor,
    STATE(13634), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2360), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4740), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(4756), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390428] = 5,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14924), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [390458] = 3,
    ACTIONS(14862), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [390484] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 14,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [390510] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [390536] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [390564] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [390592] = 6,
    ACTIONS(14341), 1,
      anon_sym_DASH,
    ACTIONS(16642), 1,
      anon_sym_LBRACE,
    ACTIONS(16645), 1,
      sym__layout_start,
    STATE(11097), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [390624] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [390652] = 11,
    ACTIONS(4321), 1,
      sym__conid,
    ACTIONS(16647), 1,
      sym__varid,
    ACTIONS(16649), 1,
      anon_sym_LPAREN,
    STATE(9240), 1,
      sym_constructor,
    STATE(9275), 1,
      sym_qualified_constructor,
    STATE(13579), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4223), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9335), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9343), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390694] = 11,
    ACTIONS(4407), 1,
      sym__conid,
    ACTIONS(16651), 1,
      sym__varid,
    ACTIONS(16653), 1,
      anon_sym_LPAREN,
    STATE(10164), 1,
      sym_constructor,
    STATE(10683), 1,
      sym_qualified_constructor,
    STATE(13468), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4403), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10320), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(10415), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390736] = 11,
    ACTIONS(4061), 1,
      sym__conid,
    ACTIONS(16655), 1,
      sym__varid,
    ACTIONS(16657), 1,
      anon_sym_LPAREN,
    STATE(4535), 1,
      sym_constructor,
    STATE(5315), 1,
      sym_qualified_constructor,
    STATE(13695), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2854), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5074), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(5110), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390778] = 11,
    ACTIONS(13780), 1,
      sym__conid,
    ACTIONS(16659), 1,
      sym__varid,
    ACTIONS(16663), 1,
      anon_sym_LPAREN,
    STATE(11620), 1,
      sym_constructor,
    STATE(12143), 1,
      sym_qualified_constructor,
    STATE(13438), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16661), 2,
      sym_label,
      sym_implicit_parid,
    STATE(12294), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(12431), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390820] = 11,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(16665), 1,
      sym__varid,
    ACTIONS(16669), 1,
      anon_sym_LPAREN,
    STATE(3991), 1,
      sym_constructor,
    STATE(4078), 1,
      sym_qualified_constructor,
    STATE(13725), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16667), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4111), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(4135), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390862] = 6,
    ACTIONS(13702), 1,
      anon_sym_DASH,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14854), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(14851), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [390894] = 5,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14933), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [390924] = 5,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [390954] = 11,
    ACTIONS(8765), 1,
      sym__conid,
    ACTIONS(16671), 1,
      sym__varid,
    ACTIONS(16673), 1,
      anon_sym_LPAREN,
    STATE(10871), 1,
      sym_constructor,
    STATE(11567), 1,
      sym_qualified_constructor,
    STATE(13951), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4561), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11563), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(11861), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [390996] = 10,
    ACTIONS(16570), 1,
      anon_sym_EQ,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(16574), 1,
      sym_where,
    STATE(2434), 1,
      sym__colon2,
    STATE(12134), 1,
      sym__type_annotation,
    ACTIONS(15742), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    STATE(13646), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(16675), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(16377), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391036] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [391064] = 6,
    ACTIONS(14947), 1,
      anon_sym_AT2,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14887), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [391096] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [391122] = 3,
    ACTIONS(14878), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [391148] = 11,
    ACTIONS(7082), 1,
      sym__conid,
    ACTIONS(16677), 1,
      sym__varid,
    ACTIONS(16681), 1,
      anon_sym_LPAREN,
    STATE(7149), 1,
      sym_constructor,
    STATE(7550), 1,
      sym_qualified_constructor,
    STATE(13602), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16679), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7381), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7509), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391190] = 5,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(16164), 1,
      sym_guards,
    STATE(10123), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15978), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [391220] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [391246] = 11,
    ACTIONS(12923), 1,
      sym__conid,
    ACTIONS(16683), 1,
      sym__varid,
    ACTIONS(16687), 1,
      anon_sym_LPAREN,
    STATE(7727), 1,
      sym_constructor,
    STATE(7923), 1,
      sym_qualified_constructor,
    STATE(13935), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16685), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8015), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8123), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391288] = 5,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14931), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [391318] = 11,
    ACTIONS(12389), 1,
      sym__conid,
    ACTIONS(16689), 1,
      sym__varid,
    ACTIONS(16693), 1,
      anon_sym_LPAREN,
    STATE(7889), 1,
      sym_constructor,
    STATE(8054), 1,
      sym_qualified_constructor,
    STATE(13492), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16691), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8175), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8328), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391360] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [391388] = 11,
    ACTIONS(8789), 1,
      sym__conid,
    ACTIONS(16695), 1,
      sym__varid,
    ACTIONS(16697), 1,
      anon_sym_LPAREN,
    STATE(10192), 1,
      sym_constructor,
    STATE(10556), 1,
      sym_qualified_constructor,
    STATE(13588), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8785), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10374), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(10585), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391430] = 3,
    ACTIONS(14874), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [391456] = 11,
    ACTIONS(14017), 1,
      sym__conid,
    ACTIONS(16699), 1,
      sym__varid,
    ACTIONS(16703), 1,
      anon_sym_LPAREN,
    STATE(12531), 1,
      sym_constructor,
    STATE(12808), 1,
      sym_qualified_constructor,
    STATE(13782), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16701), 2,
      sym_label,
      sym_implicit_parid,
    STATE(13108), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(13160), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391498] = 11,
    ACTIONS(12709), 1,
      sym__conid,
    ACTIONS(16705), 1,
      sym__varid,
    ACTIONS(16709), 1,
      anon_sym_LPAREN,
    STATE(8116), 1,
      sym_constructor,
    STATE(8271), 1,
      sym_qualified_constructor,
    STATE(13967), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16707), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8401), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8538), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391540] = 11,
    ACTIONS(12537), 1,
      sym__conid,
    ACTIONS(16711), 1,
      sym__varid,
    ACTIONS(16715), 1,
      anon_sym_LPAREN,
    STATE(8298), 1,
      sym_constructor,
    STATE(8545), 1,
      sym_qualified_constructor,
    STATE(13963), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16713), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8812), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8865), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391582] = 11,
    ACTIONS(8725), 1,
      sym__conid,
    ACTIONS(16717), 1,
      sym__varid,
    ACTIONS(16719), 1,
      anon_sym_LPAREN,
    STATE(10588), 1,
      sym_constructor,
    STATE(11140), 1,
      sym_qualified_constructor,
    STATE(13578), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8721), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11206), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(11299), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391624] = 11,
    ACTIONS(6125), 1,
      sym__conid,
    ACTIONS(16721), 1,
      sym__varid,
    ACTIONS(16725), 1,
      anon_sym_LPAREN,
    STATE(7055), 1,
      sym_constructor,
    STATE(7391), 1,
      sym_qualified_constructor,
    STATE(13571), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16723), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7493), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7584), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391666] = 7,
    ACTIONS(15936), 1,
      anon_sym_DASH,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(16727), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2553), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 8,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [391700] = 11,
    ACTIONS(4211), 1,
      sym__conid,
    ACTIONS(16729), 1,
      sym__varid,
    ACTIONS(16731), 1,
      anon_sym_LPAREN,
    STATE(4319), 1,
      sym_constructor,
    STATE(4645), 1,
      sym_qualified_constructor,
    STATE(13564), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2417), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4681), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(4824), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391742] = 11,
    ACTIONS(4087), 1,
      sym__conid,
    ACTIONS(16733), 1,
      sym__varid,
    ACTIONS(16735), 1,
      anon_sym_LPAREN,
    STATE(3473), 1,
      sym_constructor,
    STATE(3699), 1,
      sym_qualified_constructor,
    STATE(13960), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1640), 2,
      sym_label,
      sym_implicit_parid,
    STATE(3595), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(3597), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391784] = 11,
    ACTIONS(5998), 1,
      sym__conid,
    ACTIONS(16737), 1,
      sym__varid,
    ACTIONS(16741), 1,
      anon_sym_LPAREN,
    STATE(4288), 1,
      sym_constructor,
    STATE(4436), 1,
      sym_qualified_constructor,
    STATE(13551), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16739), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4582), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(4644), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391826] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [391852] = 11,
    ACTIONS(4153), 1,
      sym__conid,
    ACTIONS(16743), 1,
      sym__varid,
    ACTIONS(16745), 1,
      anon_sym_LPAREN,
    STATE(5259), 1,
      sym_constructor,
    STATE(5552), 1,
      sym_qualified_constructor,
    STATE(13955), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2983), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5494), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(5599), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391894] = 5,
    ACTIONS(16747), 1,
      anon_sym_LBRACE,
    ACTIONS(16750), 1,
      sym__layout_start,
    STATE(11058), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [391924] = 11,
    ACTIONS(4193), 1,
      sym__conid,
    ACTIONS(16752), 1,
      sym__varid,
    ACTIONS(16754), 1,
      anon_sym_LPAREN,
    STATE(4632), 1,
      sym_constructor,
    STATE(4989), 1,
      sym_qualified_constructor,
    STATE(13953), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2670), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5022), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(5192), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [391966] = 11,
    ACTIONS(7383), 1,
      sym__conid,
    ACTIONS(16756), 1,
      sym__varid,
    ACTIONS(16760), 1,
      anon_sym_LPAREN,
    STATE(7471), 1,
      sym_constructor,
    STATE(7656), 1,
      sym_qualified_constructor,
    STATE(13946), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16758), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7617), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7644), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392008] = 3,
    ACTIONS(16109), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [392034] = 11,
    ACTIONS(7122), 1,
      sym__conid,
    ACTIONS(16762), 1,
      sym__varid,
    ACTIONS(16766), 1,
      anon_sym_LPAREN,
    STATE(5659), 1,
      sym_constructor,
    STATE(5869), 1,
      sym_qualified_constructor,
    STATE(13549), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16764), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5839), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5841), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392076] = 3,
    ACTIONS(16105), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [392102] = 11,
    ACTIONS(6897), 1,
      sym__conid,
    ACTIONS(16768), 1,
      sym__varid,
    ACTIONS(16772), 1,
      anon_sym_LPAREN,
    STATE(5867), 1,
      sym_constructor,
    STATE(6095), 1,
      sym_qualified_constructor,
    STATE(13548), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16770), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6148), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6152), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392144] = 11,
    ACTIONS(12002), 1,
      sym__conid,
    ACTIONS(16774), 1,
      sym__varid,
    ACTIONS(16778), 1,
      anon_sym_LPAREN,
    STATE(8358), 1,
      sym_constructor,
    STATE(8458), 1,
      sym_qualified_constructor,
    STATE(13541), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16776), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8467), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8525), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392186] = 11,
    ACTIONS(6408), 1,
      sym__conid,
    ACTIONS(16780), 1,
      sym__varid,
    ACTIONS(16784), 1,
      anon_sym_LPAREN,
    STATE(5865), 1,
      sym_constructor,
    STATE(6099), 1,
      sym_qualified_constructor,
    STATE(13545), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16782), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6172), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6173), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392228] = 11,
    ACTIONS(3116), 1,
      sym__conid,
    ACTIONS(16786), 1,
      sym__varid,
    ACTIONS(16788), 1,
      anon_sym_LPAREN,
    STATE(3978), 1,
      sym_constructor,
    STATE(4121), 1,
      sym_qualified_constructor,
    STATE(13810), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1236), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4114), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(4130), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392270] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [392298] = 3,
    ACTIONS(16091), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [392324] = 11,
    ACTIONS(6153), 1,
      sym__conid,
    ACTIONS(16790), 1,
      sym__varid,
    ACTIONS(16794), 1,
      anon_sym_LPAREN,
    STATE(7632), 1,
      sym_constructor,
    STATE(7743), 1,
      sym_qualified_constructor,
    STATE(13943), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16792), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7793), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7839), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392366] = 11,
    ACTIONS(12359), 1,
      sym__conid,
    ACTIONS(16796), 1,
      sym__varid,
    ACTIONS(16800), 1,
      anon_sym_LPAREN,
    STATE(8096), 1,
      sym_constructor,
    STATE(8294), 1,
      sym_qualified_constructor,
    STATE(13498), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16798), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8717), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8723), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392408] = 3,
    ACTIONS(13680), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 13,
      sym__dot,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [392434] = 11,
    ACTIONS(14534), 1,
      sym__conid,
    ACTIONS(16802), 1,
      sym__varid,
    ACTIONS(16806), 1,
      anon_sym_LPAREN,
    STATE(13539), 1,
      aux_sym__qualifying_module,
    STATE(13751), 1,
      sym_constructor,
    STATE(14573), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16804), 2,
      sym_label,
      sym_implicit_parid,
    STATE(14527), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(14528), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392476] = 3,
    ACTIONS(16087), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [392502] = 11,
    ACTIONS(6056), 1,
      sym__conid,
    ACTIONS(16808), 1,
      sym__varid,
    ACTIONS(16812), 1,
      anon_sym_LPAREN,
    STATE(7648), 1,
      sym_constructor,
    STATE(7802), 1,
      sym_qualified_constructor,
    STATE(13942), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16810), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7861), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7872), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392544] = 11,
    ACTIONS(7271), 1,
      sym__conid,
    ACTIONS(16814), 1,
      sym__varid,
    ACTIONS(16818), 1,
      anon_sym_LPAREN,
    STATE(6770), 1,
      sym_constructor,
    STATE(7017), 1,
      sym_qualified_constructor,
    STATE(13536), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16816), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6875), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6880), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392586] = 11,
    ACTIONS(11655), 1,
      sym__conid,
    ACTIONS(16820), 1,
      sym__varid,
    ACTIONS(16824), 1,
      anon_sym_LPAREN,
    STATE(8097), 1,
      sym_constructor,
    STATE(8270), 1,
      sym_qualified_constructor,
    STATE(13531), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16822), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8297), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8336), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392628] = 11,
    ACTIONS(11827), 1,
      sym__conid,
    ACTIONS(16826), 1,
      sym__varid,
    ACTIONS(16830), 1,
      anon_sym_LPAREN,
    STATE(8137), 1,
      sym_constructor,
    STATE(8204), 1,
      sym_qualified_constructor,
    STATE(13433), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16828), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8219), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8338), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392670] = 3,
    ACTIONS(16073), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [392696] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [392724] = 11,
    ACTIONS(6762), 1,
      sym__conid,
    ACTIONS(16832), 1,
      sym__varid,
    ACTIONS(16836), 1,
      anon_sym_LPAREN,
    STATE(6105), 1,
      sym_constructor,
    STATE(6294), 1,
      sym_qualified_constructor,
    STATE(13535), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16834), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6559), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6563), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392766] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [392794] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [392820] = 11,
    ACTIONS(6209), 1,
      sym__conid,
    ACTIONS(16838), 1,
      sym__varid,
    ACTIONS(16842), 1,
      anon_sym_LPAREN,
    STATE(5855), 1,
      sym_constructor,
    STATE(6111), 1,
      sym_qualified_constructor,
    STATE(13529), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16840), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6208), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6217), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392862] = 11,
    ACTIONS(12677), 1,
      sym__conid,
    ACTIONS(16844), 1,
      sym__varid,
    ACTIONS(16848), 1,
      anon_sym_LPAREN,
    STATE(8668), 1,
      sym_constructor,
    STATE(8930), 1,
      sym_qualified_constructor,
    STATE(13519), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16846), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8814), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8972), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [392904] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [392930] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [392958] = 11,
    ACTIONS(5980), 1,
      sym__conid,
    ACTIONS(16850), 1,
      sym__varid,
    ACTIONS(16854), 1,
      anon_sym_LPAREN,
    STATE(6127), 1,
      sym_constructor,
    STATE(6517), 1,
      sym_qualified_constructor,
    STATE(13524), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16852), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6457), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6462), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393000] = 11,
    ACTIONS(11540), 1,
      sym__conid,
    ACTIONS(16856), 1,
      sym__varid,
    ACTIONS(16860), 1,
      anon_sym_LPAREN,
    STATE(7905), 1,
      sym_constructor,
    STATE(8051), 1,
      sym_qualified_constructor,
    STATE(13523), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16858), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7967), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7969), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393042] = 5,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    STATE(15635), 1,
      sym_guards,
    STATE(9681), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [393072] = 5,
    ACTIONS(16750), 1,
      sym__layout_start,
    ACTIONS(16862), 1,
      anon_sym_LBRACE,
    STATE(11792), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [393102] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 14,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [393128] = 11,
    ACTIONS(1753), 1,
      sym__conid,
    ACTIONS(16864), 1,
      sym__varid,
    ACTIONS(16866), 1,
      anon_sym_LPAREN,
    STATE(4265), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_qualified_constructor,
    STATE(13485), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(543), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4401), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(4834), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393170] = 5,
    ACTIONS(14947), 1,
      anon_sym_AT2,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(13695), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [393200] = 5,
    ACTIONS(16868), 1,
      anon_sym_LBRACE,
    ACTIONS(16871), 1,
      sym__layout_start,
    STATE(11225), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [393230] = 11,
    ACTIONS(6517), 1,
      sym__conid,
    ACTIONS(16873), 1,
      sym__varid,
    ACTIONS(16877), 1,
      anon_sym_LPAREN,
    STATE(6951), 1,
      sym_constructor,
    STATE(7153), 1,
      sym_qualified_constructor,
    STATE(13653), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16875), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7133), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7228), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393272] = 11,
    ACTIONS(14001), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(16883), 1,
      anon_sym_LPAREN,
    STATE(13517), 1,
      aux_sym__qualifying_module,
    STATE(15450), 1,
      sym_constructor,
    STATE(17917), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16881), 2,
      sym_label,
      sym_implicit_parid,
    STATE(17873), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(17874), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393314] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(16889), 1,
      anon_sym_LPAREN,
    STATE(13407), 1,
      sym_constructor,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(14006), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16887), 2,
      sym_label,
      sym_implicit_parid,
    STATE(13991), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(14018), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393356] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [393384] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [393410] = 3,
    ACTIONS(14832), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [393436] = 11,
    ACTIONS(12423), 1,
      sym__conid,
    ACTIONS(16891), 1,
      sym__varid,
    ACTIONS(16895), 1,
      anon_sym_LPAREN,
    STATE(8282), 1,
      sym_constructor,
    STATE(8549), 1,
      sym_qualified_constructor,
    STATE(13510), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16893), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8776), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8777), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393478] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [393506] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [393532] = 11,
    ACTIONS(13821), 1,
      sym__conid,
    ACTIONS(16897), 1,
      sym__varid,
    ACTIONS(16901), 1,
      anon_sym_LPAREN,
    STATE(12769), 1,
      sym_constructor,
    STATE(13359), 1,
      sym_qualified_constructor,
    STATE(13482), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16899), 2,
      sym_label,
      sym_implicit_parid,
    STATE(13618), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(13638), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393574] = 11,
    ACTIONS(4487), 1,
      sym__conid,
    ACTIONS(16903), 1,
      sym__varid,
    ACTIONS(16905), 1,
      anon_sym_LPAREN,
    STATE(9690), 1,
      sym_constructor,
    STATE(9781), 1,
      sym_qualified_constructor,
    STATE(13888), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4483), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9774), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9898), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393616] = 4,
    STATE(17053), 1,
      sym_guards,
    STATE(9993), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [393644] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [393672] = 11,
    ACTIONS(12893), 1,
      sym__conid,
    ACTIONS(16907), 1,
      sym__varid,
    ACTIONS(16911), 1,
      anon_sym_LPAREN,
    STATE(8357), 1,
      sym_constructor,
    STATE(8520), 1,
      sym_qualified_constructor,
    STATE(13506), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16909), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8741), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8742), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393714] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [393740] = 11,
    ACTIONS(9100), 1,
      sym__conid,
    ACTIONS(16913), 1,
      sym__varid,
    ACTIONS(16915), 1,
      anon_sym_LPAREN,
    STATE(10505), 1,
      sym_constructor,
    STATE(11262), 1,
      sym_qualified_constructor,
    STATE(13940), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9096), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10868), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(11173), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393782] = 3,
    ACTIONS(14836), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [393808] = 11,
    ACTIONS(4047), 1,
      sym__conid,
    ACTIONS(16917), 1,
      sym__varid,
    ACTIONS(16919), 1,
      anon_sym_LPAREN,
    STATE(4498), 1,
      sym_constructor,
    STATE(5373), 1,
      sym_qualified_constructor,
    STATE(13613), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2570), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5079), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5185), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393850] = 11,
    ACTIONS(10573), 1,
      sym__conid,
    ACTIONS(16921), 1,
      sym__varid,
    ACTIONS(16925), 1,
      anon_sym_LPAREN,
    STATE(7661), 1,
      sym_constructor,
    STATE(7780), 1,
      sym_qualified_constructor,
    STATE(13533), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16923), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7880), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7927), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393892] = 11,
    ACTIONS(9252), 1,
      sym__conid,
    ACTIONS(16927), 1,
      sym__varid,
    ACTIONS(16929), 1,
      anon_sym_LPAREN,
    STATE(9941), 1,
      sym_constructor,
    STATE(10009), 1,
      sym_qualified_constructor,
    STATE(13503), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9248), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10004), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(10194), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [393934] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [393962] = 11,
    ACTIONS(4205), 1,
      sym__conid,
    ACTIONS(16931), 1,
      sym__varid,
    ACTIONS(16933), 1,
      anon_sym_LPAREN,
    STATE(3857), 1,
      sym_constructor,
    STATE(3915), 1,
      sym_qualified_constructor,
    STATE(13936), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1710), 2,
      sym_label,
      sym_implicit_parid,
    STATE(3975), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(4005), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394004] = 11,
    ACTIONS(6943), 1,
      sym__conid,
    ACTIONS(16935), 1,
      sym__varid,
    ACTIONS(16939), 1,
      anon_sym_LPAREN,
    STATE(6849), 1,
      sym_constructor,
    STATE(7264), 1,
      sym_qualified_constructor,
    STATE(13502), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16937), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7136), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7170), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394046] = 11,
    ACTIONS(12154), 1,
      sym__conid,
    ACTIONS(16941), 1,
      sym__varid,
    ACTIONS(16945), 1,
      anon_sym_LPAREN,
    STATE(8155), 1,
      sym_constructor,
    STATE(8730), 1,
      sym_qualified_constructor,
    STATE(13497), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16943), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8526), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8602), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394088] = 11,
    ACTIONS(7327), 1,
      sym__conid,
    ACTIONS(16947), 1,
      sym__varid,
    ACTIONS(16951), 1,
      anon_sym_LPAREN,
    STATE(6419), 1,
      sym_constructor,
    STATE(6665), 1,
      sym_qualified_constructor,
    STATE(13500), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16949), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6628), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6775), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394130] = 5,
    ACTIONS(16435), 1,
      sym__layout_start,
    ACTIONS(16953), 1,
      anon_sym_LBRACE,
    STATE(11272), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [394160] = 11,
    ACTIONS(4267), 1,
      sym__conid,
    ACTIONS(16956), 1,
      sym__varid,
    ACTIONS(16958), 1,
      anon_sym_LPAREN,
    STATE(4342), 1,
      sym_constructor,
    STATE(4790), 1,
      sym_qualified_constructor,
    STATE(13927), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2315), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4781), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(4833), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394202] = 11,
    ACTIONS(6915), 1,
      sym__conid,
    ACTIONS(16960), 1,
      sym__varid,
    ACTIONS(16964), 1,
      anon_sym_LPAREN,
    STATE(6184), 1,
      sym_constructor,
    STATE(6520), 1,
      sym_qualified_constructor,
    STATE(13499), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16962), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6234), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6479), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394244] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [394272] = 11,
    ACTIONS(10270), 1,
      sym__conid,
    ACTIONS(16966), 1,
      sym__varid,
    ACTIONS(16970), 1,
      anon_sym_LPAREN,
    STATE(8020), 1,
      sym_constructor,
    STATE(8257), 1,
      sym_qualified_constructor,
    STATE(13412), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16968), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8198), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8276), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394314] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [394342] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [394370] = 11,
    ACTIONS(8679), 1,
      sym__conid,
    ACTIONS(16972), 1,
      sym__varid,
    ACTIONS(16974), 1,
      anon_sym_LPAREN,
    STATE(10570), 1,
      sym_constructor,
    STATE(11171), 1,
      sym_qualified_constructor,
    STATE(13925), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8675), 2,
      sym_label,
      sym_implicit_parid,
    STATE(11134), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(11352), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394412] = 11,
    ACTIONS(13772), 1,
      sym__conid,
    ACTIONS(16976), 1,
      sym__varid,
    ACTIONS(16980), 1,
      anon_sym_LPAREN,
    STATE(12587), 1,
      sym_constructor,
    STATE(13075), 1,
      sym_qualified_constructor,
    STATE(13582), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16978), 2,
      sym_label,
      sym_implicit_parid,
    STATE(13234), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(13302), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394454] = 10,
    ACTIONS(16570), 1,
      anon_sym_EQ,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(16574), 1,
      sym_where,
    STATE(2434), 1,
      sym__colon2,
    STATE(12195), 1,
      sym__type_annotation,
    ACTIONS(15742), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    STATE(13633), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(16675), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(16467), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394494] = 5,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    STATE(17053), 1,
      sym_guards,
    STATE(9993), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [394524] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [394552] = 3,
    ACTIONS(16140), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 14,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [394578] = 11,
    ACTIONS(1402), 1,
      sym__conid,
    ACTIONS(16982), 1,
      sym__varid,
    ACTIONS(16984), 1,
      anon_sym_LPAREN,
    STATE(3818), 1,
      sym_constructor,
    STATE(3884), 1,
      sym_qualified_constructor,
    STATE(13977), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(237), 2,
      sym_label,
      sym_implicit_parid,
    STATE(3901), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(3904), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394620] = 11,
    ACTIONS(4541), 1,
      sym__conid,
    ACTIONS(16986), 1,
      sym__varid,
    ACTIONS(16988), 1,
      anon_sym_LPAREN,
    STATE(9235), 1,
      sym_constructor,
    STATE(9289), 1,
      sym_qualified_constructor,
    STATE(13841), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8902), 2,
      sym_label,
      sym_implicit_parid,
    STATE(9255), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(9342), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394662] = 11,
    ACTIONS(7114), 1,
      sym__conid,
    ACTIONS(16990), 1,
      sym__varid,
    ACTIONS(16994), 1,
      anon_sym_LPAREN,
    STATE(5789), 1,
      sym_constructor,
    STATE(6209), 1,
      sym_qualified_constructor,
    STATE(13494), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16992), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6081), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6125), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394704] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [394732] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
  [394758] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [394786] = 11,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(16996), 1,
      sym__varid,
    ACTIONS(17000), 1,
      anon_sym_LPAREN,
    STATE(7993), 1,
      sym_constructor,
    STATE(8225), 1,
      sym_qualified_constructor,
    STATE(13922), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16998), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8533), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8624), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394828] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [394856] = 11,
    ACTIONS(6601), 1,
      sym__conid,
    ACTIONS(17002), 1,
      sym__varid,
    ACTIONS(17006), 1,
      anon_sym_LPAREN,
    STATE(6220), 1,
      sym_constructor,
    STATE(6461), 1,
      sym_qualified_constructor,
    STATE(13489), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17004), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6468), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6523), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394898] = 11,
    ACTIONS(14285), 1,
      sym__conid,
    ACTIONS(17008), 1,
      sym__varid,
    ACTIONS(17012), 1,
      anon_sym_LPAREN,
    STATE(13462), 1,
      aux_sym__qualifying_module,
    STATE(13680), 1,
      sym_constructor,
    STATE(14403), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17010), 2,
      sym_label,
      sym_implicit_parid,
    STATE(14139), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(14178), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394940] = 11,
    ACTIONS(13654), 1,
      sym__conid,
    ACTIONS(17014), 1,
      sym__varid,
    ACTIONS(17018), 1,
      anon_sym_LPAREN,
    STATE(13161), 1,
      sym_constructor,
    STATE(13483), 1,
      aux_sym__qualifying_module,
    STATE(13730), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17016), 2,
      sym_label,
      sym_implicit_parid,
    STATE(13641), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(13666), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [394982] = 3,
    ACTIONS(14840), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [395008] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [395036] = 3,
    ACTIONS(14844), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [395062] = 11,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(17020), 1,
      sym__varid,
    ACTIONS(17024), 1,
      anon_sym_LPAREN,
    STATE(6025), 1,
      sym_constructor,
    STATE(6377), 1,
      sym_qualified_constructor,
    STATE(13490), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17022), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6292), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6318), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395104] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395130] = 10,
    ACTIONS(16628), 1,
      anon_sym_EQ,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    ACTIONS(16632), 1,
      sym_where,
    STATE(2441), 1,
      sym__colon2,
    STATE(12181), 1,
      sym__type_annotation,
    ACTIONS(15726), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    STATE(13863), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(16675), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(16123), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395170] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [395196] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395222] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395248] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395274] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395300] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395326] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395352] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395378] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395404] = 14,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(1390), 1,
      sym__varid,
    ACTIONS(1402), 1,
      sym__conid,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(3823), 1,
      sym_constructor,
    STATE(3859), 1,
      sym_variable,
    STATE(7703), 1,
      sym_constructor_operator,
    STATE(12325), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    STATE(7862), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395452] = 11,
    ACTIONS(12655), 1,
      sym__conid,
    ACTIONS(17028), 1,
      sym__varid,
    ACTIONS(17032), 1,
      anon_sym_LPAREN,
    STATE(8017), 1,
      sym_constructor,
    STATE(8254), 1,
      sym_qualified_constructor,
    STATE(13908), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17030), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8577), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8709), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395494] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395520] = 6,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(14889), 1,
      anon_sym_AT2,
    ACTIONS(14887), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13684), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
  [395552] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395578] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395604] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395630] = 11,
    ACTIONS(6016), 1,
      sym__conid,
    ACTIONS(17034), 1,
      sym__varid,
    ACTIONS(17038), 1,
      anon_sym_LPAREN,
    STATE(7088), 1,
      sym_constructor,
    STATE(7499), 1,
      sym_qualified_constructor,
    STATE(13508), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17036), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7352), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7453), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395672] = 11,
    ACTIONS(4349), 1,
      sym__conid,
    ACTIONS(17040), 1,
      sym__varid,
    ACTIONS(17042), 1,
      anon_sym_LPAREN,
    STATE(10791), 1,
      sym_constructor,
    STATE(10925), 1,
      sym_qualified_constructor,
    STATE(13905), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4457), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10913), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(10982), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395714] = 6,
    ACTIONS(16002), 1,
      anon_sym_DASH,
    ACTIONS(16645), 1,
      sym__layout_start,
    ACTIONS(17044), 1,
      anon_sym_LBRACE,
    STATE(11819), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [395746] = 6,
    ACTIONS(15980), 1,
      anon_sym_DASH,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(15952), 1,
      sym_guards,
    STATE(10254), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15978), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [395778] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395804] = 11,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(17046), 1,
      sym__varid,
    ACTIONS(17050), 1,
      anon_sym_LPAREN,
    STATE(8547), 1,
      sym_constructor,
    STATE(8933), 1,
      sym_qualified_constructor,
    STATE(13836), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17048), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8771), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8884), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395846] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395872] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [395898] = 11,
    ACTIONS(6545), 1,
      sym__conid,
    ACTIONS(17052), 1,
      sym__varid,
    ACTIONS(17056), 1,
      anon_sym_LPAREN,
    STATE(6991), 1,
      sym_constructor,
    STATE(7317), 1,
      sym_qualified_constructor,
    STATE(13477), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17054), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7171), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7267), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395940] = 11,
    ACTIONS(4243), 1,
      sym__conid,
    ACTIONS(17058), 1,
      sym__varid,
    ACTIONS(17060), 1,
      anon_sym_LPAREN,
    STATE(4245), 1,
      sym_constructor,
    STATE(4556), 1,
      sym_qualified_constructor,
    STATE(13770), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(2533), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4572), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(4621), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [395982] = 6,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(13709), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(14887), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13695), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [396014] = 11,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(17062), 1,
      sym__varid,
    ACTIONS(17066), 1,
      anon_sym_LPAREN,
    STATE(6322), 1,
      sym_constructor,
    STATE(6741), 1,
      sym_qualified_constructor,
    STATE(13809), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17064), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6699), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6703), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396056] = 11,
    ACTIONS(10978), 1,
      sym__conid,
    ACTIONS(17068), 1,
      sym__varid,
    ACTIONS(17072), 1,
      anon_sym_LPAREN,
    STATE(7865), 1,
      sym_constructor,
    STATE(7921), 1,
      sym_qualified_constructor,
    STATE(13766), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17070), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8039), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8049), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396098] = 3,
    ACTIONS(14858), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [396124] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [396152] = 11,
    ACTIONS(12490), 1,
      sym__conid,
    ACTIONS(17074), 1,
      sym__varid,
    ACTIONS(17078), 1,
      anon_sym_LPAREN,
    STATE(8719), 1,
      sym_constructor,
    STATE(8757), 1,
      sym_qualified_constructor,
    STATE(13471), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17076), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8950), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8964), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396194] = 3,
    ACTIONS(14866), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [396220] = 14,
    ACTIONS(247), 1,
      sym__conid,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(1390), 1,
      sym__varid,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(3470), 1,
      sym_constructor,
    STATE(3859), 1,
      sym_variable,
    STATE(7703), 1,
      sym_constructor_operator,
    STATE(12325), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    STATE(7862), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396268] = 14,
    ACTIONS(14001), 1,
      sym__conid,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(16252), 1,
      anon_sym_LPAREN,
    ACTIONS(16258), 1,
      anon_sym_module,
    ACTIONS(17080), 1,
      anon_sym_RPAREN,
    STATE(13883), 1,
      aux_sym__qualifying_module,
    STATE(13885), 1,
      sym_namespace,
    STATE(14317), 1,
      sym_constructor,
    STATE(15008), 1,
      sym_qualified_type,
    STATE(18161), 1,
      sym_export,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    STATE(18403), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396316] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 14,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [396342] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [396368] = 11,
    ACTIONS(7355), 1,
      sym__conid,
    ACTIONS(17082), 1,
      sym__varid,
    ACTIONS(17086), 1,
      anon_sym_LPAREN,
    STATE(6958), 1,
      sym_constructor,
    STATE(7089), 1,
      sym_qualified_constructor,
    STATE(13566), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17084), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7094), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7218), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396410] = 11,
    ACTIONS(5421), 1,
      sym__conid,
    ACTIONS(17088), 1,
      sym__varid,
    ACTIONS(17092), 1,
      anon_sym_LPAREN,
    STATE(7454), 1,
      sym_constructor,
    STATE(7658), 1,
      sym_qualified_constructor,
    STATE(13738), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17090), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7611), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7613), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396452] = 5,
    ACTIONS(15974), 1,
      anon_sym_DASH,
    STATE(15952), 1,
      sym_guards,
    STATE(10254), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [396482] = 3,
    ACTIONS(14870), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [396508] = 11,
    ACTIONS(13987), 1,
      sym__conid,
    ACTIONS(17094), 1,
      sym__varid,
    ACTIONS(17098), 1,
      anon_sym_LPAREN,
    STATE(12576), 1,
      sym_constructor,
    STATE(13025), 1,
      sym_qualified_constructor,
    STATE(13467), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17096), 2,
      sym_label,
      sym_implicit_parid,
    STATE(13178), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(13202), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396550] = 11,
    ACTIONS(13923), 1,
      sym__conid,
    ACTIONS(17100), 1,
      sym__varid,
    ACTIONS(17104), 1,
      anon_sym_LPAREN,
    STATE(12717), 1,
      sym_constructor,
    STATE(12730), 1,
      sym_qualified_constructor,
    STATE(13902), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17102), 2,
      sym_label,
      sym_implicit_parid,
    STATE(13125), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(13297), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396592] = 11,
    ACTIONS(13728), 1,
      sym__conid,
    ACTIONS(17106), 1,
      sym__varid,
    ACTIONS(17110), 1,
      anon_sym_LPAREN,
    STATE(13021), 1,
      sym_constructor,
    STATE(13155), 1,
      sym_qualified_constructor,
    STATE(13459), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17108), 2,
      sym_label,
      sym_implicit_parid,
    STATE(13585), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(13608), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396634] = 11,
    ACTIONS(6573), 1,
      sym__conid,
    ACTIONS(17112), 1,
      sym__varid,
    ACTIONS(17116), 1,
      anon_sym_LPAREN,
    STATE(6605), 1,
      sym_constructor,
    STATE(7024), 1,
      sym_qualified_constructor,
    STATE(13453), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17114), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6895), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6931), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396676] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 14,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [396702] = 4,
    STATE(16547), 1,
      sym_guards,
    STATE(10088), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [396730] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [396758] = 11,
    ACTIONS(13941), 1,
      sym__conid,
    ACTIONS(17118), 1,
      sym__varid,
    ACTIONS(17122), 1,
      anon_sym_LPAREN,
    STATE(12358), 1,
      sym_constructor,
    STATE(12679), 1,
      sym_qualified_constructor,
    STATE(13417), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17120), 2,
      sym_label,
      sym_implicit_parid,
    STATE(12927), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(13089), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396800] = 11,
    ACTIONS(4161), 1,
      sym__conid,
    ACTIONS(17124), 1,
      sym__varid,
    ACTIONS(17126), 1,
      anon_sym_LPAREN,
    STATE(4074), 1,
      sym_constructor,
    STATE(4305), 1,
      sym_qualified_constructor,
    STATE(13449), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1943), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4241), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(4280), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396842] = 10,
    ACTIONS(16570), 1,
      anon_sym_EQ,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(16574), 1,
      sym_where,
    STATE(2434), 1,
      sym__colon2,
    STATE(12199), 1,
      sym__type_annotation,
    ACTIONS(15742), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    STATE(13747), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(17128), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(16621), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396882] = 11,
    ACTIONS(4439), 1,
      sym__conid,
    ACTIONS(17130), 1,
      sym__varid,
    ACTIONS(17132), 1,
      anon_sym_LPAREN,
    STATE(10806), 1,
      sym_constructor,
    STATE(10906), 1,
      sym_qualified_constructor,
    STATE(13876), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9308), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10869), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(11282), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396924] = 11,
    ACTIONS(3032), 1,
      sym__conid,
    ACTIONS(17134), 1,
      sym__varid,
    ACTIONS(17136), 1,
      anon_sym_LPAREN,
    STATE(4716), 1,
      sym_constructor,
    STATE(5006), 1,
      sym_qualified_constructor,
    STATE(13481), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(1177), 2,
      sym_label,
      sym_implicit_parid,
    STATE(5085), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(5485), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [396966] = 11,
    ACTIONS(101), 1,
      sym__conid,
    ACTIONS(17138), 1,
      sym__varid,
    ACTIONS(17142), 1,
      anon_sym_LPAREN,
    STATE(3918), 1,
      sym_constructor,
    STATE(4144), 1,
      sym_qualified_constructor,
    STATE(13627), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17140), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8104), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(8115), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397008] = 10,
    ACTIONS(16628), 1,
      anon_sym_EQ,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    ACTIONS(16632), 1,
      sym_where,
    STATE(2441), 1,
      sym__colon2,
    STATE(12135), 1,
      sym__type_annotation,
    ACTIONS(15726), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    STATE(13972), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(16675), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(15976), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397048] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 14,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [397074] = 11,
    ACTIONS(6790), 1,
      sym__conid,
    ACTIONS(17144), 1,
      sym__varid,
    ACTIONS(17148), 1,
      anon_sym_LPAREN,
    STATE(6688), 1,
      sym_constructor,
    STATE(6899), 1,
      sym_qualified_constructor,
    STATE(13437), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17146), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6915), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7033), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397116] = 11,
    ACTIONS(4373), 1,
      sym__conid,
    ACTIONS(17150), 1,
      sym__varid,
    ACTIONS(17152), 1,
      anon_sym_LPAREN,
    STATE(10105), 1,
      sym_constructor,
    STATE(10604), 1,
      sym_qualified_constructor,
    STATE(13911), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(4369), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10627), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(10680), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397158] = 5,
    ACTIONS(16871), 1,
      sym__layout_start,
    ACTIONS(17154), 1,
      anon_sym_LBRACE,
    STATE(11708), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [397188] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [397216] = 11,
    ACTIONS(6380), 1,
      sym__conid,
    ACTIONS(17156), 1,
      sym__varid,
    ACTIONS(17160), 1,
      anon_sym_LPAREN,
    STATE(6971), 1,
      sym_constructor,
    STATE(7142), 1,
      sym_qualified_constructor,
    STATE(13856), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17158), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7127), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7137), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397258] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 14,
      sym__layout_semicolon,
      sym__dot,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [397284] = 11,
    ACTIONS(8936), 1,
      sym__conid,
    ACTIONS(17162), 1,
      sym__varid,
    ACTIONS(17164), 1,
      anon_sym_LPAREN,
    STATE(10294), 1,
      sym_constructor,
    STATE(10364), 1,
      sym_qualified_constructor,
    STATE(13435), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(8932), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10501), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(10731), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397326] = 11,
    ACTIONS(7054), 1,
      sym__conid,
    ACTIONS(17166), 1,
      sym__varid,
    ACTIONS(17170), 1,
      anon_sym_LPAREN,
    STATE(6238), 1,
      sym_constructor,
    STATE(6632), 1,
      sym_qualified_constructor,
    STATE(13427), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17168), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6596), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(6679), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397368] = 11,
    ACTIONS(7299), 1,
      sym__conid,
    ACTIONS(17172), 1,
      sym__varid,
    ACTIONS(17176), 1,
      anon_sym_LPAREN,
    STATE(6128), 1,
      sym_constructor,
    STATE(6453), 1,
      sym_qualified_constructor,
    STATE(13421), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17174), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6360), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6496), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397410] = 10,
    ACTIONS(16628), 1,
      anon_sym_EQ,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    ACTIONS(16632), 1,
      sym_where,
    STATE(2441), 1,
      sym__colon2,
    STATE(12022), 1,
      sym__type_annotation,
    ACTIONS(15726), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    STATE(13918), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(17128), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(15772), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397450] = 14,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(1677), 1,
      sym__varid,
    ACTIONS(1698), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(3477), 1,
      sym_constructor,
    STATE(3543), 1,
      sym_variable,
    STATE(12325), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20660), 1,
      sym_constructor_operator,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    STATE(19109), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397498] = 5,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    STATE(16164), 1,
      sym_guards,
    STATE(10123), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [397528] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 14,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
  [397554] = 11,
    ACTIONS(1789), 1,
      sym__conid,
    ACTIONS(17178), 1,
      sym__varid,
    ACTIONS(17182), 1,
      anon_sym_LPAREN,
    STATE(7316), 1,
      sym_constructor,
    STATE(7328), 1,
      sym_qualified_constructor,
    STATE(13783), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17180), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7404), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(7468), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397596] = 11,
    ACTIONS(6181), 1,
      sym__conid,
    ACTIONS(17184), 1,
      sym__varid,
    ACTIONS(17188), 1,
      anon_sym_LPAREN,
    STATE(7108), 1,
      sym_constructor,
    STATE(7378), 1,
      sym_qualified_constructor,
    STATE(13411), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17186), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7393), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7426), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397638] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [397666] = 11,
    ACTIONS(6657), 1,
      sym__conid,
    ACTIONS(17190), 1,
      sym__varid,
    ACTIONS(17194), 1,
      anon_sym_LPAREN,
    STATE(6077), 1,
      sym_constructor,
    STATE(6290), 1,
      sym_qualified_constructor,
    STATE(13404), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17192), 2,
      sym_label,
      sym_implicit_parid,
    STATE(6255), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(6270), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397708] = 11,
    ACTIONS(12985), 1,
      sym__conid,
    ACTIONS(17196), 1,
      sym__varid,
    ACTIONS(17200), 1,
      anon_sym_LPAREN,
    STATE(8718), 1,
      sym_constructor,
    STATE(8760), 1,
      sym_qualified_constructor,
    STATE(13845), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17198), 2,
      sym_label,
      sym_implicit_parid,
    STATE(8907), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(8944), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397750] = 3,
    ACTIONS(13734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT2,
  [397776] = 11,
    ACTIONS(9134), 1,
      sym__conid,
    ACTIONS(17202), 1,
      sym__varid,
    ACTIONS(17204), 1,
      anon_sym_LPAREN,
    STATE(10171), 1,
      sym_constructor,
    STATE(10673), 1,
      sym_qualified_constructor,
    STATE(13397), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9130), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10378), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(10552), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397818] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 15,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [397842] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 15,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [397866] = 11,
    ACTIONS(4289), 1,
      sym__conid,
    ACTIONS(17206), 1,
      sym__varid,
    ACTIONS(17208), 1,
      anon_sym_LPAREN,
    STATE(4308), 1,
      sym_constructor,
    STATE(4664), 1,
      sym_qualified_constructor,
    STATE(13542), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(165), 2,
      sym_label,
      sym_implicit_parid,
    STATE(4499), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    STATE(4795), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397908] = 4,
    ACTIONS(16031), 1,
      anon_sym_DASH,
    ACTIONS(17210), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [397936] = 11,
    ACTIONS(6450), 1,
      sym__conid,
    ACTIONS(17212), 1,
      sym__varid,
    ACTIONS(17216), 1,
      anon_sym_LPAREN,
    STATE(6942), 1,
      sym_constructor,
    STATE(7162), 1,
      sym_qualified_constructor,
    STATE(13391), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17214), 2,
      sym_label,
      sym_implicit_parid,
    STATE(7147), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(7239), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [397978] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [398006] = 11,
    ACTIONS(4565), 1,
      sym__conid,
    ACTIONS(17218), 1,
      sym__varid,
    ACTIONS(17220), 1,
      anon_sym_LPAREN,
    STATE(10044), 1,
      sym_constructor,
    STATE(10640), 1,
      sym_qualified_constructor,
    STATE(13924), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(9216), 2,
      sym_label,
      sym_implicit_parid,
    STATE(10362), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    STATE(10826), 3,
      sym_exp_parens,
      sym_exp_name,
      sym__splice_exp,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398048] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 15,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_instance,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
      anon_sym_deriving,
  [398072] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [398097] = 3,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [398122] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [398147] = 3,
    ACTIONS(16081), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [398172] = 3,
    ACTIONS(16065), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [398197] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [398224] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [398249] = 3,
    ACTIONS(14738), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [398274] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [398299] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [398324] = 3,
    ACTIONS(14189), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [398349] = 10,
    ACTIONS(17222), 1,
      anon_sym_EQ,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17226), 1,
      sym_where,
    STATE(2377), 1,
      sym__colon2,
    STATE(12367), 1,
      sym__type_annotation,
    ACTIONS(15962), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(16675), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14148), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(18123), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398388] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [398413] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [398438] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [398463] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [398488] = 5,
    ACTIONS(17228), 1,
      anon_sym_LBRACE,
    ACTIONS(17230), 1,
      sym__layout_start,
    STATE(12100), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [398517] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [398542] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [398567] = 5,
    ACTIONS(17232), 1,
      anon_sym_LBRACE,
    ACTIONS(17234), 1,
      sym__layout_start,
    STATE(12072), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [398596] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [398621] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [398646] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [398671] = 3,
    ACTIONS(16119), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [398696] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [398723] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [398748] = 10,
    ACTIONS(17222), 1,
      anon_sym_EQ,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17226), 1,
      sym_where,
    STATE(2377), 1,
      sym__colon2,
    STATE(12450), 1,
      sym__type_annotation,
    ACTIONS(15962), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(17128), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(13984), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(17848), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [398787] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [398812] = 3,
    ACTIONS(14712), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [398837] = 3,
    ACTIONS(16095), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [398862] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [398887] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [398912] = 3,
    ACTIONS(16099), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [398937] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [398962] = 5,
    ACTIONS(17236), 1,
      anon_sym_LBRACE,
    ACTIONS(17239), 1,
      sym__layout_start,
    STATE(11579), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [398991] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [399016] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [399043] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [399068] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [399093] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [399118] = 3,
    ACTIONS(14040), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [399143] = 5,
    ACTIONS(14907), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14909), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(14916), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [399172] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [399197] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [399222] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [399247] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [399272] = 4,
    STATE(16779), 1,
      sym_guards,
    STATE(10812), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [399299] = 3,
    ACTIONS(13680), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 12,
      sym__dot,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [399324] = 9,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16518), 1,
      sym__consym,
    ACTIONS(17241), 1,
      anon_sym_BQUOTE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13821), 1,
      aux_sym__qualifying_module,
    STATE(20542), 1,
      sym__modid,
    STATE(3259), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16514), 6,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [399361] = 3,
    ACTIONS(14476), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [399386] = 3,
    ACTIONS(16154), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [399411] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [399438] = 5,
    ACTIONS(14907), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(14933), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14911), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [399467] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [399492] = 5,
    ACTIONS(17230), 1,
      sym__layout_start,
    ACTIONS(17243), 1,
      anon_sym_LBRACE,
    STATE(11689), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [399521] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [399546] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [399573] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [399598] = 5,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(14854), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14851), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [399627] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [399652] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [399677] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [399702] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [399727] = 3,
    ACTIONS(15991), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 13,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [399752] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [399777] = 5,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(14931), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14919), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [399806] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [399833] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [399858] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [399883] = 3,
    ACTIONS(14265), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [399908] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [399933] = 3,
    ACTIONS(13738), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [399958] = 5,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    STATE(15489), 1,
      sym_guards,
    STATE(10429), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [399987] = 3,
    ACTIONS(16144), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [400012] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400037] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [400062] = 3,
    ACTIONS(16134), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [400087] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400114] = 3,
    ACTIONS(16077), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [400139] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [400164] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400189] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400214] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [400239] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [400266] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [400293] = 3,
    ACTIONS(14058), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400318] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [400343] = 6,
    ACTIONS(14341), 1,
      anon_sym_DASH,
    ACTIONS(17246), 1,
      anon_sym_LBRACE,
    ACTIONS(17249), 1,
      sym__layout_start,
    STATE(11775), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400374] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [400399] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400424] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400451] = 3,
    ACTIONS(14249), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400476] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [400501] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [400526] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [400553] = 3,
    ACTIONS(14269), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400578] = 3,
    ACTIONS(14255), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400603] = 9,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15064), 1,
      anon_sym_BQUOTE,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(17251), 1,
      sym__tyconsym,
    STATE(13140), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(9466), 7,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
      sym__ticked_qtycon,
      sym__qtyconops,
  [400640] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [400667] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400692] = 5,
    ACTIONS(14964), 1,
      anon_sym_AT2,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(13695), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400721] = 3,
    ACTIONS(14062), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400746] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [400771] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400796] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 13,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [400821] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [400846] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [400871] = 5,
    ACTIONS(17234), 1,
      sym__layout_start,
    ACTIONS(17253), 1,
      anon_sym_LBRACE,
    STATE(11898), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [400900] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400925] = 4,
    STATE(16065), 1,
      sym_guards,
    STATE(10853), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [400952] = 5,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(15489), 1,
      sym_guards,
    STATE(10429), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15978), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [400981] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401006] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401031] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401056] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401081] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [401106] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [401131] = 3,
    ACTIONS(13680), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 12,
      sym__dot,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [401156] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401181] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401206] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401231] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401256] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [401281] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401306] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401331] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401356] = 5,
    ACTIONS(17256), 1,
      anon_sym_LBRACE,
    ACTIONS(17259), 1,
      sym__layout_start,
    STATE(11889), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401385] = 5,
    ACTIONS(17259), 1,
      sym__layout_start,
    ACTIONS(17261), 1,
      anon_sym_LBRACE,
    STATE(12080), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401414] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401439] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401464] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [401489] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401514] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401539] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401564] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401589] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401614] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [401639] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [401664] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401689] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401714] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401739] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401764] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401789] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401814] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401839] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [401864] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401889] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401914] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [401939] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401964] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [401989] = 5,
    ACTIONS(17263), 1,
      anon_sym_LBRACE,
    ACTIONS(17265), 1,
      sym__layout_start,
    STATE(11997), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [402018] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402043] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402068] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402093] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402118] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402143] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402168] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402193] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402218] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402243] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402268] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402293] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402318] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402343] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402368] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [402395] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [402420] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402445] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [402470] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402495] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402520] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402545] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402570] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [402595] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402620] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [402645] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402670] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402695] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [402720] = 5,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(14924), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13776), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
  [402749] = 3,
    ACTIONS(14185), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402774] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [402799] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402824] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [402849] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [402874] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [402901] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [402926] = 3,
    ACTIONS(16127), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [402951] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [402976] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [403001] = 4,
    ACTIONS(15068), 1,
      anon_sym_DASH,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PERCENT,
  [403028] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [403053] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [403078] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [403103] = 3,
    ACTIONS(16123), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [403128] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [403153] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [403178] = 3,
    ACTIONS(16069), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [403203] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [403228] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [403255] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [403282] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [403307] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [403332] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [403357] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [403382] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [403409] = 3,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [403434] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [403459] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [403484] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [403509] = 3,
    ACTIONS(16140), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [403534] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [403559] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [403584] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [403609] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [403634] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [403659] = 10,
    ACTIONS(17222), 1,
      anon_sym_EQ,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17226), 1,
      sym_where,
    STATE(2377), 1,
      sym__colon2,
    STATE(12459), 1,
      sym__type_annotation,
    ACTIONS(15962), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(16568), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14248), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(18316), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [403698] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [403723] = 3,
    ACTIONS(13871), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [403748] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [403773] = 5,
    ACTIONS(17267), 1,
      anon_sym_LBRACE,
    ACTIONS(17269), 1,
      sym__layout_start,
    STATE(12153), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [403802] = 3,
    ACTIONS(13680), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 12,
      sym__dot,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [403827] = 5,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(14854), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14851), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(13684), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
  [403856] = 5,
    ACTIONS(14907), 1,
      anon_sym_LBRACE,
    ACTIONS(14933), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14909), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
  [403885] = 5,
    ACTIONS(14907), 1,
      anon_sym_LBRACE,
    ACTIONS(9703), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14909), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
  [403914] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [403941] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [403966] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [403993] = 6,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(14889), 1,
      anon_sym_AT2,
    ACTIONS(14887), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 5,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_RBRACE,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [404024] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [404051] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [404078] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [404103] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [404128] = 10,
    ACTIONS(17222), 1,
      anon_sym_EQ,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17226), 1,
      sym_where,
    STATE(2377), 1,
      sym__colon2,
    STATE(12461), 1,
      sym__type_annotation,
    ACTIONS(15962), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(16675), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14073), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(18078), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404167] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [404192] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17271), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [404219] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [404244] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [404269] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [404294] = 5,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(14931), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
    ACTIONS(14706), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
  [404323] = 4,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(13805), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [404350] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [404375] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [404402] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [404427] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [404452] = 3,
    ACTIONS(16069), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [404477] = 13,
    ACTIONS(14001), 1,
      sym__conid,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(16252), 1,
      anon_sym_LPAREN,
    ACTIONS(16258), 1,
      anon_sym_module,
    STATE(13883), 1,
      aux_sym__qualifying_module,
    STATE(13885), 1,
      sym_namespace,
    STATE(14317), 1,
      sym_constructor,
    STATE(15008), 1,
      sym_qualified_type,
    STATE(18161), 1,
      sym_export,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    STATE(18403), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [404522] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [404547] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [404572] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [404597] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [404624] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17273), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [404651] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [404676] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [404701] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [404726] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [404751] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [404776] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [404801] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [404826] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [404851] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [404876] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [404901] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16518), 1,
      sym__consym,
    STATE(13225), 1,
      sym_constructor,
    STATE(13821), 1,
      aux_sym__qualifying_module,
    STATE(20542), 1,
      sym__modid,
    STATE(3260), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16514), 7,
      sym__varsym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [404936] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [404961] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17275), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [404988] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [405013] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [405038] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 13,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [405063] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [405090] = 5,
    ACTIONS(13702), 1,
      anon_sym_DASH,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14851), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [405119] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [405144] = 4,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14911), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [405171] = 6,
    ACTIONS(14964), 1,
      anon_sym_AT2,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14887), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [405202] = 4,
    ACTIONS(17277), 1,
      sym__immediate_dot,
    ACTIONS(14716), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [405229] = 4,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14916), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [405256] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [405281] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [405306] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [405331] = 3,
    ACTIONS(14708), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [405356] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [405381] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [405406] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [405431] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [405456] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [405481] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [405506] = 4,
    STATE(15489), 1,
      sym_guards,
    STATE(10429), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [405533] = 5,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14931), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [405562] = 4,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14919), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [405589] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [405614] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [405639] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [405664] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [405691] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [405716] = 5,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    STATE(16065), 1,
      sym_guards,
    STATE(10853), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [405745] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [405772] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [405797] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [405822] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [405849] = 3,
    ACTIONS(16140), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [405874] = 3,
    ACTIONS(14726), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [405899] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [405926] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [405951] = 5,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(9703), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [405980] = 5,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14933), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [406009] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [406034] = 3,
    ACTIONS(16144), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [406059] = 6,
    ACTIONS(13702), 1,
      anon_sym_DASH,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(14854), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14851), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [406090] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [406115] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [406142] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [406167] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [406192] = 3,
    ACTIONS(16109), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [406217] = 3,
    ACTIONS(16105), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [406242] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406267] = 3,
    ACTIONS(16134), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [406292] = 3,
    ACTIONS(13734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 12,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT2,
  [406317] = 3,
    ACTIONS(16091), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [406342] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406367] = 3,
    ACTIONS(16087), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [406392] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [406417] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [406442] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [406467] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [406492] = 5,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14924), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [406521] = 5,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(14924), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13805), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [406550] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406575] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406600] = 3,
    ACTIONS(16073), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [406625] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406650] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406675] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406700] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [406727] = 5,
    ACTIONS(17279), 1,
      anon_sym_LBRACE,
    ACTIONS(17281), 1,
      sym__layout_start,
    STATE(12052), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406756] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406781] = 3,
    ACTIONS(14730), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406806] = 3,
    ACTIONS(14734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406831] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406856] = 3,
    ACTIONS(14109), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406881] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [406906] = 3,
    ACTIONS(14734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [406931] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [406956] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [406981] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407006] = 5,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(14931), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14919), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [407035] = 5,
    ACTIONS(17281), 1,
      sym__layout_start,
    ACTIONS(17283), 1,
      anon_sym_LBRACE,
    STATE(11907), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407064] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [407091] = 6,
    ACTIONS(15016), 1,
      anon_sym_AT2,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14887), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(13695), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [407122] = 3,
    ACTIONS(17286), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [407147] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [407172] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407197] = 3,
    ACTIONS(13889), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407222] = 5,
    ACTIONS(17269), 1,
      sym__layout_start,
    ACTIONS(17288), 1,
      anon_sym_LBRACE,
    STATE(11562), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [407251] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [407276] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407301] = 6,
    ACTIONS(15980), 1,
      anon_sym_DASH,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(15970), 1,
      sym_guards,
    STATE(10674), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15978), 9,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [407332] = 5,
    ACTIONS(14907), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14909), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(14916), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [407361] = 3,
    ACTIONS(14742), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407386] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [407411] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407436] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407461] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [407486] = 5,
    ACTIONS(14907), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(14933), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14911), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [407515] = 5,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(14854), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14851), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [407544] = 3,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407569] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407594] = 3,
    ACTIONS(14722), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407619] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [407644] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [407669] = 5,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    STATE(16779), 1,
      sym_guards,
    STATE(10812), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [407698] = 3,
    ACTIONS(14750), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407723] = 3,
    ACTIONS(13734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [407748] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407773] = 3,
    ACTIONS(14758), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407798] = 3,
    ACTIONS(14762), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407823] = 3,
    ACTIONS(14766), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407848] = 3,
    ACTIONS(14766), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407873] = 3,
    ACTIONS(14777), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407898] = 3,
    ACTIONS(14806), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407923] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [407948] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [407973] = 3,
    ACTIONS(16109), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [407998] = 3,
    ACTIONS(16105), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [408023] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [408048] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 13,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [408073] = 3,
    ACTIONS(16127), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [408098] = 3,
    ACTIONS(14658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408123] = 3,
    ACTIONS(16091), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [408148] = 3,
    ACTIONS(16087), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [408173] = 3,
    ACTIONS(14797), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408198] = 3,
    ACTIONS(16073), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [408223] = 5,
    ACTIONS(17239), 1,
      sym__layout_start,
    ACTIONS(17291), 1,
      anon_sym_LBRACE,
    STATE(12026), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [408252] = 3,
    ACTIONS(14810), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408277] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408304] = 3,
    ACTIONS(14814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408329] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408354] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [408379] = 3,
    ACTIONS(14818), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408404] = 3,
    ACTIONS(14814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408429] = 5,
    ACTIONS(17293), 1,
      sym__varid,
    ACTIONS(17298), 1,
      anon_sym_LPAREN,
    STATE(10718), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17296), 9,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [408458] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408483] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408508] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [408533] = 3,
    ACTIONS(14789), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408558] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [408583] = 5,
    ACTIONS(17265), 1,
      sym__layout_start,
    ACTIONS(17301), 1,
      anon_sym_LBRACE,
    STATE(11573), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [408612] = 3,
    ACTIONS(16123), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [408637] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [408662] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [408687] = 3,
    ACTIONS(14826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408712] = 3,
    ACTIONS(14781), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408737] = 3,
    ACTIONS(14781), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408762] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [408787] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [408814] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408839] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [408864] = 3,
    ACTIONS(14754), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408889] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408914] = 3,
    ACTIONS(14754), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [408939] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [408964] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [408989] = 3,
    ACTIONS(16065), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [409014] = 3,
    ACTIONS(16081), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [409039] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [409064] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [409089] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [409114] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [409139] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [409164] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [409189] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [409214] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [409239] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [409264] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [409289] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [409314] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [409339] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [409364] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [409389] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [409416] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [409441] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [409466] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [409491] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [409516] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [409541] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [409566] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [409593] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [409618] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [409643] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [409668] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [409693] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [409718] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [409743] = 3,
    ACTIONS(14793), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [409768] = 3,
    ACTIONS(14662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [409793] = 3,
    ACTIONS(14666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [409818] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [409843] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [409868] = 3,
    ACTIONS(16095), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [409893] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [409918] = 3,
    ACTIONS(16077), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [409943] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [409968] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [409993] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [410018] = 3,
    ACTIONS(14670), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410043] = 3,
    ACTIONS(16099), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 13,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [410068] = 3,
    ACTIONS(14676), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410093] = 3,
    ACTIONS(14680), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410118] = 3,
    ACTIONS(14684), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410143] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410168] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410193] = 3,
    ACTIONS(14696), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410218] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [410243] = 3,
    ACTIONS(14654), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410268] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410295] = 3,
    ACTIONS(14700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410320] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410345] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410370] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410395] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [410420] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410445] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410470] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410495] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410520] = 3,
    ACTIONS(16154), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 13,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [410545] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410570] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410595] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410620] = 3,
    ACTIONS(14773), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410645] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [410672] = 3,
    ACTIONS(14746), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410697] = 3,
    ACTIONS(14785), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410722] = 3,
    ACTIONS(14822), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410747] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 13,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [410772] = 3,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [410797] = 5,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(16779), 1,
      sym_guards,
    STATE(10812), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15978), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [410826] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17304), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [410853] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [410878] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [410903] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [410928] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [410955] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [410982] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411007] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411032] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411057] = 3,
    ACTIONS(14674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [411082] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411107] = 3,
    ACTIONS(14688), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [411132] = 3,
    ACTIONS(14692), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 12,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [411157] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 13,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [411182] = 6,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(13709), 1,
      anon_sym_AT2,
    ACTIONS(13684), 3,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13695), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [411213] = 5,
    ACTIONS(14903), 1,
      anon_sym_AT2,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(13695), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
  [411242] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411267] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411292] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411317] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411342] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411367] = 5,
    ACTIONS(15974), 1,
      anon_sym_DASH,
    STATE(15970), 1,
      sym_guards,
    STATE(10674), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [411396] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411421] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411446] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411471] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [411496] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411521] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411546] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411571] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [411596] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411621] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411646] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [411671] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411696] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411721] = 5,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym__immediate_dot,
    ACTIONS(14924), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13805), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [411750] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411775] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411800] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411825] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411850] = 5,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(16065), 1,
      sym_guards,
    STATE(10853), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15978), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [411879] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411904] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411929] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [411954] = 6,
    ACTIONS(16002), 1,
      anon_sym_DASH,
    ACTIONS(17249), 1,
      sym__layout_start,
    ACTIONS(17306), 1,
      anon_sym_LBRACE,
    STATE(12170), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [411985] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [412009] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [412033] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [412057] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [412081] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [412107] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [412131] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [412155] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [412179] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [412203] = 3,
    ACTIONS(14062), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [412227] = 3,
    ACTIONS(13702), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [412251] = 3,
    ACTIONS(14255), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [412275] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [412301] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [412327] = 3,
    ACTIONS(14040), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [412351] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [412373] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [412395] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [412417] = 3,
    ACTIONS(14269), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [412441] = 3,
    ACTIONS(14754), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [412465] = 3,
    ACTIONS(14754), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [412489] = 3,
    ACTIONS(14249), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [412513] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [412537] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [412561] = 4,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(13805), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
  [412587] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [412609] = 3,
    ACTIONS(14189), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [412633] = 3,
    ACTIONS(14773), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [412657] = 3,
    ACTIONS(14781), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [412681] = 6,
    ACTIONS(15126), 1,
      anon_sym_deriving,
    ACTIONS(17308), 1,
      sym__varid,
    ACTIONS(17310), 1,
      anon_sym_LPAREN,
    STATE(11473), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15118), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [412711] = 3,
    ACTIONS(14781), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [412735] = 3,
    ACTIONS(14826), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [412759] = 3,
    ACTIONS(13774), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [412783] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [412807] = 3,
    ACTIONS(14789), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [412831] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [412855] = 3,
    ACTIONS(14185), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [412879] = 3,
    ACTIONS(14058), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [412903] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [412925] = 3,
    ACTIONS(13738), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [412949] = 3,
    ACTIONS(14109), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [412973] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [412997] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [413021] = 3,
    ACTIONS(14265), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [413045] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [413069] = 3,
    ACTIONS(14814), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [413093] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [413117] = 3,
    ACTIONS(14818), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [413141] = 3,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [413165] = 3,
    ACTIONS(14814), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [413189] = 3,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [413213] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [413235] = 3,
    ACTIONS(14810), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [413259] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [413283] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [413305] = 3,
    ACTIONS(14255), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [413329] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [413353] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [413377] = 3,
    ACTIONS(14476), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [413401] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [413425] = 5,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(13776), 3,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(13805), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [413453] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [413477] = 3,
    ACTIONS(14797), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [413501] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [413523] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [413545] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [413569] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [413593] = 3,
    ACTIONS(13719), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [413617] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [413641] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [413665] = 3,
    ACTIONS(14185), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [413689] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [413715] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [413739] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [413763] = 3,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [413787] = 3,
    ACTIONS(14109), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [413811] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [413835] = 3,
    ACTIONS(17312), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [413859] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [413883] = 3,
    ACTIONS(14658), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [413907] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [413929] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [413951] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [413975] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [413999] = 6,
    ACTIONS(13702), 1,
      anon_sym_DASH,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(14854), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14851), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [414029] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [414053] = 5,
    ACTIONS(9703), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [414081] = 3,
    ACTIONS(15991), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 12,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [414105] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [414129] = 3,
    ACTIONS(14806), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [414153] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [414177] = 3,
    ACTIONS(14777), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [414201] = 3,
    ACTIONS(14766), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [414225] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [414249] = 3,
    ACTIONS(14766), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [414273] = 3,
    ACTIONS(14062), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [414297] = 3,
    ACTIONS(14762), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [414321] = 3,
    ACTIONS(14758), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [414345] = 3,
    ACTIONS(14750), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [414369] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [414393] = 3,
    ACTIONS(14870), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [414417] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [414441] = 5,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14924), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [414469] = 3,
    ACTIONS(14738), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [414493] = 5,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14931), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [414521] = 3,
    ACTIONS(14866), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [414545] = 3,
    ACTIONS(14858), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [414569] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [414593] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 12,
      sym__dot,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [414617] = 3,
    ACTIONS(14696), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [414641] = 3,
    ACTIONS(14269), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [414665] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [414689] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [414713] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [414735] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17314), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [414761] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [414785] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [414809] = 3,
    ACTIONS(14844), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [414833] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [414857] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [414881] = 3,
    ACTIONS(14742), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [414905] = 3,
    ACTIONS(14840), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [414929] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [414953] = 3,
    ACTIONS(14249), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [414977] = 3,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [415001] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415025] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [415047] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415071] = 3,
    ACTIONS(14189), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [415095] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415119] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [415143] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [415167] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415191] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415215] = 3,
    ACTIONS(14836), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [415239] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415263] = 5,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14933), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [415291] = 10,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(17316), 1,
      anon_sym_DASH,
    ACTIONS(17318), 1,
      anon_sym_BQUOTE,
    ACTIONS(17320), 1,
      sym__varsym,
    ACTIONS(17322), 1,
      sym__consym,
    STATE(12757), 1,
      sym_integer,
    STATE(14500), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(14755), 2,
      sym_operator,
      sym__minus,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [415329] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415353] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415377] = 3,
    ACTIONS(14734), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [415401] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415425] = 3,
    ACTIONS(14058), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [415449] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [415471] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415495] = 3,
    ACTIONS(14734), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [415519] = 3,
    ACTIONS(14730), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [415543] = 3,
    ACTIONS(13738), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [415567] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 13,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [415589] = 3,
    ACTIONS(14265), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [415613] = 3,
    ACTIONS(14832), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [415637] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415661] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415685] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415709] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415733] = 6,
    ACTIONS(15126), 1,
      anon_sym_deriving,
    ACTIONS(17324), 1,
      sym__varid,
    ACTIONS(17326), 1,
      anon_sym_LPAREN,
    STATE(11175), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15118), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [415763] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415787] = 3,
    ACTIONS(14726), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [415811] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415835] = 3,
    ACTIONS(14476), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [415859] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415883] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415907] = 3,
    ACTIONS(14040), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [415931] = 3,
    ACTIONS(14722), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [415955] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [415979] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17328), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [416005] = 3,
    ACTIONS(14692), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [416029] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [416053] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [416077] = 3,
    ACTIONS(14874), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [416101] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [416123] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [416145] = 5,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14931), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [416173] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [416197] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [416221] = 3,
    ACTIONS(14688), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [416245] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [416269] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [416293] = 3,
    ACTIONS(14708), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [416317] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [416341] = 5,
    ACTIONS(13702), 1,
      anon_sym_DASH,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14851), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
  [416369] = 4,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14911), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
  [416395] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [416419] = 3,
    ACTIONS(14674), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [416443] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [416467] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [416491] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [416515] = 4,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14916), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
  [416541] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [416565] = 5,
    ACTIONS(9703), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [416593] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [416615] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17330), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [416641] = 5,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14933), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [416669] = 6,
    ACTIONS(13702), 1,
      anon_sym_DASH,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(14854), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14851), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [416699] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [416723] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [416747] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [416771] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [416795] = 3,
    ACTIONS(14822), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [416819] = 3,
    ACTIONS(14785), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [416843] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [416867] = 5,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    STATE(15952), 1,
      sym_guards,
    STATE(10254), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15972), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [416895] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [416919] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [416943] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [416967] = 3,
    ACTIONS(14746), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [416991] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [417015] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [417039] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417063] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417087] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417111] = 3,
    ACTIONS(14700), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [417135] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417159] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [417183] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417207] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417231] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417255] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417279] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [417303] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417327] = 3,
    ACTIONS(14654), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [417351] = 9,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16518), 1,
      sym__consym,
    ACTIONS(17332), 1,
      anon_sym_BQUOTE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13821), 1,
      aux_sym__qualifying_module,
    STATE(20542), 1,
      sym__modid,
    STATE(3211), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16514), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [417387] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [417411] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [417435] = 5,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(14924), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [417463] = 3,
    ACTIONS(14684), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [417487] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417511] = 6,
    ACTIONS(15082), 1,
      anon_sym_deriving,
    ACTIONS(17324), 1,
      sym__varid,
    ACTIONS(17326), 1,
      anon_sym_LPAREN,
    STATE(11322), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15074), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [417541] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [417565] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [417589] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417613] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417637] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417661] = 5,
    ACTIONS(17334), 1,
      anon_sym_LBRACE,
    ACTIONS(17336), 1,
      sym__layout_start,
    STATE(12323), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [417689] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [417713] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417737] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417761] = 3,
    ACTIONS(14680), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [417785] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417809] = 3,
    ACTIONS(14878), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [417833] = 3,
    ACTIONS(14676), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [417857] = 3,
    ACTIONS(14670), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [417881] = 3,
    ACTIONS(14666), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [417905] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [417929] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [417953] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [417977] = 3,
    ACTIONS(14662), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [418001] = 3,
    ACTIONS(14793), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [418025] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418049] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [418073] = 3,
    ACTIONS(14040), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418097] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418121] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418145] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418169] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418193] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418219] = 10,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(17338), 1,
      anon_sym_DASH,
    ACTIONS(17340), 1,
      anon_sym_BQUOTE,
    ACTIONS(17342), 1,
      sym__varsym,
    ACTIONS(17344), 1,
      sym__consym,
    STATE(12750), 1,
      sym_integer,
    STATE(14328), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(15332), 2,
      sym_operator,
      sym__minus,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [418257] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418281] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418305] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418329] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418353] = 3,
    ACTIONS(14712), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418377] = 4,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14919), 7,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
  [418403] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418427] = 5,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(14931), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 5,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_RBRACE,
    ACTIONS(14919), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [418455] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418479] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418503] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418527] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418551] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418575] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [418599] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418623] = 3,
    ACTIONS(14862), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418647] = 4,
    ACTIONS(15068), 1,
      anon_sym_EQ,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [418673] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [418697] = 3,
    ACTIONS(13889), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418721] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418745] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418769] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418793] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418817] = 3,
    ACTIONS(17346), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [418841] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418865] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [418889] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [418913] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418937] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418961] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [418985] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [419009] = 5,
    ACTIONS(17336), 1,
      sym__layout_start,
    ACTIONS(17348), 1,
      anon_sym_LBRACE,
    STATE(12225), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [419037] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [419061] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [419085] = 5,
    ACTIONS(14907), 1,
      anon_sym_LBRACE,
    ACTIONS(9703), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 5,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_RBRACE,
    ACTIONS(14916), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [419113] = 5,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(13684), 3,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14851), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [419141] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [419165] = 5,
    ACTIONS(14907), 1,
      anon_sym_LBRACE,
    ACTIONS(14933), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 5,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_RBRACE,
    ACTIONS(14911), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [419193] = 5,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(14854), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 5,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_RBRACE,
    ACTIONS(14851), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [419221] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [419245] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [419269] = 5,
    ACTIONS(14907), 1,
      anon_sym_LBRACE,
    ACTIONS(14909), 3,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14911), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [419297] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [419321] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [419345] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [419369] = 3,
    ACTIONS(13889), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [419393] = 3,
    ACTIONS(15991), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [419417] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [419441] = 3,
    ACTIONS(14712), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [419465] = 5,
    ACTIONS(17351), 1,
      anon_sym_LBRACE,
    ACTIONS(17353), 1,
      sym__layout_start,
    STATE(12326), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [419493] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [419517] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [419541] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [419565] = 5,
    ACTIONS(14907), 1,
      anon_sym_LBRACE,
    ACTIONS(14909), 3,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14916), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [419593] = 3,
    ACTIONS(14738), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [419617] = 3,
    ACTIONS(14062), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [419641] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [419665] = 5,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(14924), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 5,
      sym__varsym,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_RBRACE,
    ACTIONS(13805), 5,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [419693] = 3,
    ACTIONS(14255), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [419717] = 3,
    ACTIONS(14269), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [419741] = 6,
    ACTIONS(17324), 1,
      sym__varid,
    ACTIONS(17326), 1,
      anon_sym_LPAREN,
    ACTIONS(17357), 1,
      anon_sym_deriving,
    STATE(11241), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17355), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [419771] = 3,
    ACTIONS(14249), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [419795] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [419819] = 3,
    ACTIONS(14704), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [419843] = 3,
    ACTIONS(14692), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [419867] = 3,
    ACTIONS(14688), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [419891] = 3,
    ACTIONS(14189), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [419915] = 3,
    ACTIONS(14674), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [419939] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [419963] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [419987] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [420011] = 3,
    ACTIONS(14058), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [420035] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420059] = 3,
    ACTIONS(13738), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [420083] = 3,
    ACTIONS(14265), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [420107] = 3,
    ACTIONS(14476), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [420131] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420155] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420179] = 6,
    ACTIONS(17308), 1,
      sym__varid,
    ACTIONS(17310), 1,
      anon_sym_LPAREN,
    ACTIONS(17361), 1,
      anon_sym_deriving,
    STATE(11233), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17359), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [420209] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420233] = 3,
    ACTIONS(17363), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420257] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420281] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420305] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420329] = 5,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(14706), 3,
      anon_sym_SEMI,
      sym__immediate_dot,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 4,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(14919), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [420357] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420381] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420405] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [420429] = 3,
    ACTIONS(14822), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420453] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420477] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 12,
      sym__layout_semicolon,
      sym__dot,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [420501] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [420525] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420549] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420573] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420597] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [420621] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [420645] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420669] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420693] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420717] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [420741] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [420765] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420789] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420813] = 3,
    ACTIONS(14785), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420837] = 3,
    ACTIONS(14746), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420861] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [420885] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [420909] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [420933] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [420957] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [420981] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [421005] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421029] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421053] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421077] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421101] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421125] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421149] = 6,
    ACTIONS(17365), 1,
      sym__varid,
    ACTIONS(17368), 1,
      anon_sym_LPAREN,
    ACTIONS(17371), 1,
      anon_sym_deriving,
    STATE(11233), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17296), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [421179] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [421203] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [421227] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [421251] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [421275] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [421299] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [421323] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421347] = 6,
    ACTIONS(17371), 1,
      anon_sym_deriving,
    ACTIONS(17373), 1,
      sym__varid,
    ACTIONS(17376), 1,
      anon_sym_LPAREN,
    STATE(11241), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17296), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [421377] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [421401] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [421425] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [421449] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [421473] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421497] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421521] = 10,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(17379), 1,
      anon_sym_DASH,
    ACTIONS(17381), 1,
      anon_sym_BQUOTE,
    ACTIONS(17383), 1,
      sym__varsym,
    ACTIONS(17385), 1,
      sym__consym,
    STATE(12905), 1,
      sym_integer,
    STATE(13755), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(14329), 2,
      sym_operator,
      sym__minus,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [421559] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [421583] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421607] = 3,
    ACTIONS(14185), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [421631] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421655] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [421679] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [421703] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421727] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421751] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [421775] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [421799] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [421823] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [421847] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [421871] = 3,
    ACTIONS(13719), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [421895] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [421919] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [421943] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [421967] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [421991] = 3,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [422015] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [422039] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [422063] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [422087] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [422111] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422135] = 3,
    ACTIONS(14109), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [422159] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422183] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [422207] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [422231] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [422255] = 10,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(17387), 1,
      anon_sym_DASH,
    ACTIONS(17389), 1,
      anon_sym_BQUOTE,
    ACTIONS(17391), 1,
      sym__varsym,
    ACTIONS(17393), 1,
      sym__consym,
    STATE(12728), 1,
      sym_integer,
    STATE(14546), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(15306), 2,
      sym_operator,
      sym__minus,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [422293] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422317] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [422341] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [422365] = 3,
    ACTIONS(13702), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [422389] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422413] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [422437] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [422463] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [422487] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422511] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [422535] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [422559] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [422583] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [422607] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [422631] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 12,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422655] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [422679] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422703] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422727] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [422751] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [422777] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [422801] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422825] = 3,
    ACTIONS(13871), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422849] = 3,
    ACTIONS(14700), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422873] = 3,
    ACTIONS(14654), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422897] = 3,
    ACTIONS(14696), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422921] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422945] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17395), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [422971] = 3,
    ACTIONS(13734), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [422995] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423019] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 13,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [423041] = 4,
    ACTIONS(15068), 1,
      anon_sym_EQ,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 10,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [423067] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [423091] = 3,
    ACTIONS(14684), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423115] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [423139] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [423163] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423187] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423211] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423235] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [423261] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [423287] = 5,
    ACTIONS(17397), 1,
      anon_sym_LBRACE,
    ACTIONS(17399), 1,
      sym__layout_start,
    STATE(12449), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [423315] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423339] = 6,
    ACTIONS(17324), 1,
      sym__varid,
    ACTIONS(17326), 1,
      anon_sym_LPAREN,
    ACTIONS(17361), 1,
      anon_sym_deriving,
    STATE(11241), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17359), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [423369] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423393] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [423417] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [423443] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [423467] = 4,
    ACTIONS(17401), 1,
      sym__immediate_dot,
    ACTIONS(14716), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423493] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [423517] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [423541] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423565] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 13,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [423587] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [423611] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423635] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423659] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423683] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423707] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [423731] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [423755] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [423779] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423803] = 3,
    ACTIONS(17403), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [423827] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [423853] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [423877] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [423901] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423925] = 3,
    ACTIONS(14708), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [423949] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [423973] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [423997] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424021] = 3,
    ACTIONS(13889), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [424045] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [424069] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [424093] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [424117] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424141] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17405), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [424167] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424191] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [424215] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [424239] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424263] = 3,
    ACTIONS(14680), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [424287] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424311] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424335] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [424359] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424383] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424407] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [424431] = 3,
    ACTIONS(14722), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [424455] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [424479] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424503] = 4,
    ACTIONS(16031), 1,
      anon_sym_DASH,
    ACTIONS(17407), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [424529] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424553] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424577] = 3,
    ACTIONS(14726), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [424601] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424625] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [424649] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [424673] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [424697] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424721] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424745] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424769] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [424793] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [424817] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [424841] = 3,
    ACTIONS(14730), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [424865] = 3,
    ACTIONS(14734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [424889] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [424913] = 3,
    ACTIONS(14734), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [424937] = 3,
    ACTIONS(14676), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [424961] = 3,
    ACTIONS(14742), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [424985] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [425009] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [425033] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [425057] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [425081] = 4,
    ACTIONS(13774), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(13805), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [425107] = 3,
    ACTIONS(14750), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [425131] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [425155] = 3,
    ACTIONS(14762), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [425179] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [425203] = 3,
    ACTIONS(14766), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [425227] = 3,
    ACTIONS(14758), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [425251] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [425275] = 3,
    ACTIONS(14670), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [425299] = 3,
    ACTIONS(14777), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [425323] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [425347] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [425371] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [425395] = 10,
    ACTIONS(4313), 1,
      sym__integer_literal,
    ACTIONS(17409), 1,
      anon_sym_DASH,
    ACTIONS(17411), 1,
      anon_sym_BQUOTE,
    ACTIONS(17413), 1,
      sym__varsym,
    ACTIONS(17415), 1,
      sym__consym,
    STATE(12946), 1,
      sym_integer,
    STATE(15311), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(16663), 2,
      sym_operator,
      sym__minus,
    ACTIONS(4315), 3,
      sym__binary_literal,
      sym__octal_literal,
      sym__hex_literal,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [425433] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [425457] = 3,
    ACTIONS(14806), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [425481] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [425505] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [425529] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [425553] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [425577] = 3,
    ACTIONS(14658), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [425601] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [425625] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [425649] = 3,
    ACTIONS(14797), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [425673] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [425697] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [425721] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [425745] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [425769] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [425793] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [425817] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [425841] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [425865] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [425889] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [425913] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [425937] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [425961] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [425985] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [426009] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426033] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426057] = 3,
    ACTIONS(14810), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426081] = 3,
    ACTIONS(14814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426105] = 3,
    ACTIONS(14818), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426129] = 3,
    ACTIONS(14814), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426153] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426177] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [426201] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426225] = 3,
    ACTIONS(14789), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426249] = 3,
    ACTIONS(14826), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426273] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426297] = 3,
    ACTIONS(14781), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426321] = 3,
    ACTIONS(14781), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426345] = 3,
    ACTIONS(14773), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426369] = 3,
    ACTIONS(14754), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426393] = 3,
    ACTIONS(14754), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426417] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426441] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426465] = 5,
    ACTIONS(13702), 1,
      anon_sym_DASH,
    ACTIONS(14848), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14851), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426493] = 4,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14911), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426519] = 4,
    ACTIONS(14907), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14909), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14916), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426545] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426569] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [426593] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426617] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [426641] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426665] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426689] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426713] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [426737] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426761] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426785] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 12,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [426809] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426833] = 5,
    ACTIONS(17353), 1,
      sym__layout_start,
    ACTIONS(17417), 1,
      anon_sym_LBRACE,
    STATE(12055), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [426861] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426885] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [426909] = 4,
    ACTIONS(14704), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 4,
      sym__varsym,
      anon_sym_2,
      anon_sym_DASH_GT,
      sym__immediate_dot,
    ACTIONS(14919), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426935] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17420), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [426961] = 3,
    ACTIONS(14766), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [426985] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [427009] = 6,
    ACTIONS(17308), 1,
      sym__varid,
    ACTIONS(17310), 1,
      anon_sym_LPAREN,
    ACTIONS(17357), 1,
      anon_sym_deriving,
    STATE(11233), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17355), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [427039] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427063] = 3,
    ACTIONS(13871), 2,
      sym__immediate_dot,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [427087] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427111] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [427137] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [427161] = 3,
    ACTIONS(14662), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [427185] = 5,
    ACTIONS(17399), 1,
      sym__layout_start,
    ACTIONS(17422), 1,
      anon_sym_LBRACE,
    STATE(12104), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [427213] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427237] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427261] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427285] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [427309] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427333] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427357] = 3,
    ACTIONS(13871), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
  [427381] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17425), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427407] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427431] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [427457] = 3,
    ACTIONS(14793), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [427481] = 6,
    ACTIONS(15082), 1,
      anon_sym_deriving,
    ACTIONS(17308), 1,
      sym__varid,
    ACTIONS(17310), 1,
      anon_sym_LPAREN,
    STATE(11193), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15074), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [427511] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427535] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [427559] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [427583] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427607] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [427631] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427655] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427679] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [427703] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [427727] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427751] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427775] = 3,
    ACTIONS(14666), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 11,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [427799] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [427820] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [427843] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [427866] = 9,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16518), 1,
      sym__consym,
    ACTIONS(17427), 1,
      anon_sym_BQUOTE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13821), 1,
      aux_sym__qualifying_module,
    STATE(20542), 1,
      sym__modid,
    STATE(3238), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16514), 4,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [427901] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20390), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19450), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [427938] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [427961] = 3,
    ACTIONS(16091), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [427984] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [428007] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [428030] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [428053] = 3,
    ACTIONS(16087), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [428076] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428099] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428122] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20538), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19683), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428159] = 12,
    ACTIONS(17429), 1,
      sym__varid,
    ACTIONS(17431), 1,
      anon_sym_LPAREN,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(17435), 1,
      anon_sym_family,
    ACTIONS(17437), 1,
      anon_sym_instance,
    ACTIONS(17439), 1,
      anon_sym_role,
    ACTIONS(17441), 1,
      anon_sym_data,
    STATE(12166), 1,
      sym_constructor,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(14575), 1,
      sym__simpletype,
    STATE(13778), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428200] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [428223] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428246] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428269] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [428292] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428315] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428338] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428361] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [428384] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [428407] = 3,
    ACTIONS(17443), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428430] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20328), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19071), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428467] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [428490] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428513] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [428534] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428557] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [428578] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428601] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [428624] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [428647] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20241), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(18967), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428684] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20188), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19333), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [428721] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428744] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428767] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [428790] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428813] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428836] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428859] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [428882] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [428905] = 4,
    ACTIONS(15068), 1,
      anon_sym_EQ,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 9,
      sym_where,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [428930] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [428953] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 11,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
      anon_sym_via,
      anon_sym_deriving,
  [428976] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [428999] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20933), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19903), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429036] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19958), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19857), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429073] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [429096] = 3,
    ACTIONS(16073), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [429119] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429142] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [429163] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429186] = 3,
    ACTIONS(17445), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [429209] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429232] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [429255] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429278] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429301] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429324] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429347] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429370] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429393] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [429416] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [429439] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429462] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429485] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429508] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [429529] = 3,
    ACTIONS(14476), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [429552] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429575] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429598] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [429619] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [429642] = 3,
    ACTIONS(15991), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 11,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [429665] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429688] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [429711] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429734] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429757] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429780] = 3,
    ACTIONS(14265), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [429803] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [429826] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [429847] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429870] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [429893] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19868), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20601), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [429930] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [429953] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [429976] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20965), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20134), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430013] = 3,
    ACTIONS(13738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [430036] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [430059] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [430082] = 5,
    ACTIONS(17447), 1,
      anon_sym_LBRACE,
    ACTIONS(17449), 1,
      sym__layout_start,
    STATE(12502), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16000), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [430109] = 4,
    ACTIONS(9720), 1,
      anon_sym_LBRACE,
    STATE(12472), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [430134] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [430157] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [430180] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [430203] = 3,
    ACTIONS(16140), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [430226] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [430249] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [430272] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [430295] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [430318] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20864), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20429), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430355] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [430378] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [430401] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [430424] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [430447] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [430470] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17451), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2528), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [430499] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [430522] = 3,
    ACTIONS(14189), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [430545] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [430568] = 3,
    ACTIONS(14249), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [430591] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [430614] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [430639] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [430662] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [430683] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17453), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [430708] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [430729] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [430752] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19827), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20650), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430789] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [430812] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [430835] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [430858] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [430881] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20545), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20948), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [430918] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [430941] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [430964] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [430987] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [431010] = 3,
    ACTIONS(17455), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [431033] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [431056] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [431077] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [431098] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20789), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20765), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431135] = 3,
    ACTIONS(14269), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [431158] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [431179] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [431202] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [431225] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17457), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [431250] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [431271] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20663), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20487), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431308] = 3,
    ACTIONS(14255), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [431331] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19061), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20413), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431368] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17459), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [431393] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [431416] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [431437] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [431460] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [431483] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [431506] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [431527] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [431548] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [431571] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [431592] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [431613] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [431634] = 3,
    ACTIONS(14870), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [431657] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20334), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20475), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [431694] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [431717] = 3,
    ACTIONS(14062), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [431740] = 3,
    ACTIONS(13734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [431763] = 3,
    ACTIONS(14866), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [431786] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [431807] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [431828] = 3,
    ACTIONS(14858), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [431851] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [431874] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [431897] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [431918] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [431941] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [431962] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [431985] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [432008] = 3,
    ACTIONS(14844), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [432031] = 3,
    ACTIONS(14840), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [432054] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20280), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20279), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432091] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [432114] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19169), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19889), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432151] = 4,
    ACTIONS(16031), 1,
      anon_sym_DASH,
    ACTIONS(17461), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [432176] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20230), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20248), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432213] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [432234] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [432257] = 3,
    ACTIONS(16105), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [432280] = 3,
    ACTIONS(16109), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [432303] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [432326] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [432347] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [432370] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 11,
      sym__dot,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [432393] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19544), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19357), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432430] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [432451] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [432474] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [432497] = 3,
    ACTIONS(17463), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [432520] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [432543] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [432564] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14594), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [432589] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [432612] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [432633] = 3,
    ACTIONS(14712), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 10,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [432656] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [432679] = 3,
    ACTIONS(14836), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [432702] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20190), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20094), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432739] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [432762] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [432783] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [432804] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [432827] = 3,
    ACTIONS(14832), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [432850] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19979), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(18994), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [432887] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [432910] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [432933] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [432956] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [432979] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [433000] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [433021] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14548), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433046] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [433067] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [433088] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433111] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [433132] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [433153] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [433174] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [433197] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433220] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [433241] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433264] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433287] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433310] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [433331] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433354] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433377] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [433398] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433421] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [433444] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433467] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [433488] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [433511] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433534] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433557] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20142), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19936), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433594] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
      anon_sym_via,
      anon_sym_deriving,
  [433615] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20123), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19274), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433652] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [433675] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [433698] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [433721] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [433744] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [433765] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [433790] = 9,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16518), 1,
      sym__consym,
    ACTIONS(17465), 1,
      anon_sym_BQUOTE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13821), 1,
      aux_sym__qualifying_module,
    STATE(20542), 1,
      sym__modid,
    STATE(3240), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16514), 4,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_EQ,
  [433825] = 3,
    ACTIONS(14874), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [433848] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433871] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [433892] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20805), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19866), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [433929] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [433950] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [433973] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [433994] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [434015] = 9,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16518), 1,
      sym__consym,
    ACTIONS(17467), 1,
      anon_sym_BQUOTE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13821), 1,
      aux_sym__qualifying_module,
    STATE(20542), 1,
      sym__modid,
    STATE(3230), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16514), 4,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [434050] = 10,
    ACTIONS(17471), 1,
      anon_sym_DASH,
    ACTIONS(17473), 1,
      anon_sym_BQUOTE,
    ACTIONS(17477), 1,
      sym__varsym,
    STATE(2439), 1,
      sym__colon2,
    STATE(3215), 1,
      sym_varop,
    STATE(18074), 1,
      sym__type_annotation,
    ACTIONS(17469), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(17475), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    STATE(9406), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434087] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434110] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [434133] = 3,
    ACTIONS(16077), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434156] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [434179] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434202] = 12,
    ACTIONS(17429), 1,
      sym__varid,
    ACTIONS(17431), 1,
      anon_sym_LPAREN,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(17479), 1,
      anon_sym_family,
    ACTIONS(17481), 1,
      anon_sym_instance,
    ACTIONS(17483), 1,
      anon_sym_role,
    ACTIONS(17485), 1,
      anon_sym_data,
    STATE(12166), 1,
      sym_constructor,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(14598), 1,
      sym__simpletype,
    STATE(13778), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434243] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [434266] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19713), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20753), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434303] = 12,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(17431), 1,
      anon_sym_LPAREN,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17489), 1,
      sym__tyconsym,
    STATE(12166), 1,
      sym_constructor,
    STATE(12265), 1,
      sym_type_variable,
    STATE(13778), 1,
      sym_annotated_type_variable,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(20482), 1,
      sym__simpletype,
    STATE(20750), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434344] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [434367] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434388] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434411] = 3,
    ACTIONS(14878), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434434] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434455] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434476] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [434499] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434520] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20967), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19748), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434557] = 3,
    ACTIONS(16081), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434580] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434601] = 3,
    ACTIONS(16065), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434624] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [434647] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [434670] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [434693] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [434716] = 6,
    ACTIONS(15082), 1,
      anon_sym_deriving,
    ACTIONS(17491), 1,
      sym__varid,
    ACTIONS(17493), 1,
      anon_sym_LPAREN,
    STATE(11855), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15074), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [434745] = 6,
    ACTIONS(17371), 1,
      anon_sym_deriving,
    ACTIONS(17495), 1,
      sym__varid,
    ACTIONS(17498), 1,
      anon_sym_LPAREN,
    STATE(11789), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17296), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [434774] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19770), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19641), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434811] = 3,
    ACTIONS(16069), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434834] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434855] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [434876] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [434899] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20252), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19570), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [434936] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [434959] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [434980] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19715), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19531), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435017] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [435040] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [435063] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19598), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19423), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435100] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [435123] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435146] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435169] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435190] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435211] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20630), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19698), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435248] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435269] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [435292] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435313] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17501), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2635), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [435342] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [435365] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435386] = 3,
    ACTIONS(14738), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 10,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_DOT,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [435409] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435430] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19543), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19270), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435467] = 3,
    ACTIONS(13889), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [435490] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435511] = 3,
    ACTIONS(16095), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435534] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19393), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19809), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435571] = 12,
    ACTIONS(17429), 1,
      sym__varid,
    ACTIONS(17431), 1,
      anon_sym_LPAREN,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(17503), 1,
      anon_sym_family,
    ACTIONS(17505), 1,
      anon_sym_instance,
    ACTIONS(17507), 1,
      anon_sym_role,
    ACTIONS(17509), 1,
      anon_sym_data,
    STATE(12166), 1,
      sym_constructor,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(14422), 1,
      sym__simpletype,
    STATE(13778), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435612] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 12,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435633] = 12,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(17431), 1,
      anon_sym_LPAREN,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17511), 1,
      sym__tyconsym,
    STATE(12166), 1,
      sym_constructor,
    STATE(12265), 1,
      sym_type_variable,
    STATE(13778), 1,
      sym_annotated_type_variable,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(20511), 1,
      sym__simpletype,
    STATE(20515), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435674] = 3,
    ACTIONS(16119), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435697] = 3,
    ACTIONS(16099), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435720] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435743] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [435766] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [435787] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [435808] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [435831] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20505), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20517), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435868] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [435891] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [435914] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19440), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19159), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [435951] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [435974] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [435997] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436020] = 9,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16518), 1,
      sym__consym,
    ACTIONS(17513), 1,
      anon_sym_BQUOTE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13821), 1,
      aux_sym__qualifying_module,
    STATE(20542), 1,
      sym__modid,
    STATE(3210), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16514), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [436055] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19599), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20486), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436092] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436115] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19993), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19037), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436152] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436175] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [436196] = 12,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(17431), 1,
      anon_sym_LPAREN,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17515), 1,
      sym__tyconsym,
    STATE(12166), 1,
      sym_constructor,
    STATE(12265), 1,
      sym_type_variable,
    STATE(13778), 1,
      sym_annotated_type_variable,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(20746), 1,
      sym__simpletype,
    STATE(20485), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436237] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436260] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [436283] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [436306] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14259), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436331] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [436354] = 3,
    ACTIONS(17517), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436377] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19111), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19908), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436414] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436437] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436460] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436483] = 6,
    ACTIONS(17361), 1,
      anon_sym_deriving,
    ACTIONS(17491), 1,
      sym__varid,
    ACTIONS(17493), 1,
      anon_sym_LPAREN,
    STATE(11789), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17359), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [436512] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [436535] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [436558] = 5,
    ACTIONS(17449), 1,
      sym__layout_start,
    ACTIONS(17519), 1,
      anon_sym_LBRACE,
    STATE(12433), 1,
      sym_alts,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14343), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436585] = 3,
    ACTIONS(14862), 2,
      anon_sym_DASH,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [436608] = 3,
    ACTIONS(17522), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [436631] = 3,
    ACTIONS(13702), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436654] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [436677] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [436700] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436723] = 6,
    ACTIONS(17357), 1,
      anon_sym_deriving,
    ACTIONS(17491), 1,
      sym__varid,
    ACTIONS(17493), 1,
      anon_sym_LPAREN,
    STATE(11789), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17355), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [436752] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [436775] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436798] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [436821] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436844] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [436865] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436888] = 12,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(17431), 1,
      anon_sym_LPAREN,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17524), 1,
      sym__tyconsym,
    STATE(12166), 1,
      sym_constructor,
    STATE(12265), 1,
      sym_type_variable,
    STATE(13778), 1,
      sym_annotated_type_variable,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(20151), 1,
      sym__simpletype,
    STATE(20031), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [436929] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [436950] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436973] = 3,
    ACTIONS(14185), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [436996] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [437017] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437040] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [437063] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437086] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20738), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20032), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437123] = 3,
    ACTIONS(16144), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [437146] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437169] = 3,
    ACTIONS(16134), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [437192] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [437215] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437238] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19092), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(18947), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437275] = 3,
    ACTIONS(13774), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437298] = 6,
    ACTIONS(15126), 1,
      anon_sym_deriving,
    ACTIONS(17491), 1,
      sym__varid,
    ACTIONS(17493), 1,
      anon_sym_LPAREN,
    STATE(11865), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15118), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [437327] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [437350] = 3,
    ACTIONS(17526), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [437373] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [437396] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [437419] = 3,
    ACTIONS(14040), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437442] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [437463] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437486] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [437509] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437532] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437555] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [437578] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17528), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2523), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [437607] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19287), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20290), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437644] = 12,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(17431), 1,
      anon_sym_LPAREN,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17530), 1,
      sym__tyconsym,
    STATE(12166), 1,
      sym_constructor,
    STATE(12265), 1,
      sym_type_variable,
    STATE(13778), 1,
      sym_annotated_type_variable,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(20288), 1,
      sym__simpletype,
    STATE(20289), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437685] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_in,
  [437706] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437729] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 12,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [437750] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [437773] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [437796] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437819] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [437842] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437865] = 3,
    ACTIONS(16154), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [437888] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19179), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19085), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [437925] = 3,
    ACTIONS(14058), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437948] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437971] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [437994] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438017] = 3,
    ACTIONS(13871), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438040] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438063] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [438086] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19207), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19300), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438123] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [438146] = 3,
    ACTIONS(16123), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [438169] = 3,
    ACTIONS(16127), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 11,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [438192] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438215] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438238] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438261] = 9,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16518), 1,
      sym__consym,
    ACTIONS(17532), 1,
      anon_sym_BQUOTE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13821), 1,
      aux_sym__qualifying_module,
    STATE(20542), 1,
      sym__modid,
    STATE(3265), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16514), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [438296] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438319] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438342] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438365] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438388] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(19396), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(19448), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438425] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438448] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [438471] = 12,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(17431), 1,
      anon_sym_LPAREN,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17534), 1,
      sym__tyconsym,
    STATE(12166), 1,
      sym_constructor,
    STATE(12265), 1,
      sym_type_variable,
    STATE(13778), 1,
      sym_annotated_type_variable,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(20030), 1,
      sym__simpletype,
    STATE(20152), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438512] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12284), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(20297), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    STATE(20153), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438549] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [438572] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [438595] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438618] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [438641] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [438664] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [438687] = 3,
    ACTIONS(14654), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438709] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [438729] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 9,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [438751] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [438771] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438791] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [438811] = 3,
    ACTIONS(16119), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [438833] = 7,
    ACTIONS(16628), 1,
      anon_sym_EQ,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    ACTIONS(16632), 1,
      sym_where,
    STATE(13626), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(17536), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(17289), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [438863] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438885] = 3,
    ACTIONS(14781), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14783), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438907] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [438929] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [438951] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438973] = 3,
    ACTIONS(14826), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14828), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [438995] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17540), 1,
      anon_sym_RBRACE,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16011), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439033] = 3,
    ACTIONS(14789), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14791), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439055] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17544), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16890), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439093] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [439113] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [439133] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [439155] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [439175] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [439195] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [439215] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439235] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439255] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17546), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17399), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439293] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439315] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439337] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [439359] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [439379] = 3,
    ACTIONS(14754), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14756), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439401] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439423] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17548), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16300), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [439461] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439481] = 3,
    ACTIONS(14818), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14820), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439503] = 3,
    ACTIONS(14814), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14816), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439525] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439547] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [439567] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [439587] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [439607] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439627] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [439647] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439667] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [439687] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [439707] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [439727] = 3,
    ACTIONS(14797), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14799), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439749] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439769] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [439789] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439811] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [439833] = 3,
    ACTIONS(14658), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14660), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439855] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17550), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2629), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [439883] = 3,
    ACTIONS(16109), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [439905] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439925] = 3,
    ACTIONS(16105), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [439947] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439967] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [439987] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [440007] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [440027] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [440047] = 3,
    ACTIONS(16091), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [440069] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [440089] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [440109] = 3,
    ACTIONS(16087), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [440131] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [440151] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17552), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15886), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440189] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17554), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16473), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440227] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [440247] = 3,
    ACTIONS(14712), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [440269] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17556), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15486), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440307] = 3,
    ACTIONS(16077), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [440329] = 4,
    ACTIONS(10002), 1,
      anon_sym_LBRACE,
    STATE(12536), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [440353] = 3,
    ACTIONS(16081), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [440375] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [440395] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [440415] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17558), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17810), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440453] = 3,
    ACTIONS(16073), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [440475] = 5,
    ACTIONS(13614), 1,
      sym__varid,
    ACTIONS(17560), 1,
      anon_sym_LPAREN,
    STATE(10718), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17355), 6,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [440501] = 7,
    ACTIONS(16628), 1,
      anon_sym_EQ,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    ACTIONS(16632), 1,
      sym_where,
    STATE(13825), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(17562), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(16139), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [440531] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [440551] = 3,
    ACTIONS(14889), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [440573] = 3,
    ACTIONS(14856), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [440595] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [440615] = 3,
    ACTIONS(17564), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [440637] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [440657] = 3,
    ACTIONS(14806), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14808), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [440679] = 3,
    ACTIONS(14777), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14779), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [440701] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [440723] = 3,
    ACTIONS(14766), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14768), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [440745] = 3,
    ACTIONS(14762), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14764), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [440767] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [440787] = 3,
    ACTIONS(14758), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14760), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [440809] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [440829] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [440849] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [440869] = 3,
    ACTIONS(14750), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14752), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [440891] = 8,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(17566), 1,
      sym__tyconsym,
    STATE(13169), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(20435), 5,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
  [440923] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [440943] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [440963] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [440983] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441003] = 3,
    ACTIONS(14742), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14744), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441025] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [441045] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441065] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [441085] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441107] = 3,
    ACTIONS(14734), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14736), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441129] = 3,
    ACTIONS(14730), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14732), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441151] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [441171] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441191] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17568), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16675), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441229] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441251] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17570), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2651), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [441279] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441299] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [441319] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [441339] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [441363] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [441383] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [441403] = 3,
    ACTIONS(14726), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14728), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441425] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [441445] = 3,
    ACTIONS(17572), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [441467] = 3,
    ACTIONS(16065), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [441489] = 3,
    ACTIONS(14722), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14724), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441511] = 3,
    ACTIONS(17574), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441533] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441553] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441573] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [441593] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441613] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441635] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441655] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441675] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17576), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15897), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441713] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [441733] = 3,
    ACTIONS(16154), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [441755] = 5,
    ACTIONS(13614), 1,
      sym__varid,
    ACTIONS(17560), 1,
      anon_sym_LPAREN,
    STATE(12021), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15118), 6,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [441781] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [441801] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17578), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16844), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441839] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441861] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17580), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17043), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441899] = 9,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16518), 1,
      sym__consym,
    ACTIONS(17582), 1,
      anon_sym_BQUOTE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13821), 1,
      aux_sym__qualifying_module,
    STATE(20542), 1,
      sym__modid,
    STATE(3251), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(16514), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [441933] = 3,
    ACTIONS(14810), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14812), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [441955] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [441975] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17584), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16264), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442013] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [442033] = 9,
    ACTIONS(17588), 1,
      anon_sym_EQ,
    ACTIONS(17590), 1,
      sym_where,
    STATE(2434), 1,
      sym__colon2,
    STATE(13696), 1,
      sym_tyfam_result_type,
    STATE(14769), 1,
      sym__type_annotation,
    STATE(14775), 1,
      sym__tyfam_inj,
    ACTIONS(15742), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(17586), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442067] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [442089] = 9,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16518), 1,
      sym__consym,
    ACTIONS(17592), 1,
      anon_sym_BQUOTE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13821), 1,
      aux_sym__qualifying_module,
    STATE(20542), 1,
      sym__modid,
    STATE(3250), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(16514), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442123] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [442143] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [442165] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [442185] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [442205] = 3,
    ACTIONS(14700), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [442227] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [442247] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [442267] = 3,
    ACTIONS(14708), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14710), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [442289] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [442309] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [442331] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [442353] = 7,
    ACTIONS(16570), 1,
      anon_sym_EQ,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(16574), 1,
      sym_where,
    STATE(13561), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(17536), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(16085), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442383] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [442405] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [442427] = 3,
    ACTIONS(16069), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [442449] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17594), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15638), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442487] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [442507] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [442527] = 4,
    ACTIONS(14716), 1,
      anon_sym_LBRACE,
    ACTIONS(17596), 1,
      sym__immediate_dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14718), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [442551] = 8,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(17598), 1,
      sym__tyconsym,
    STATE(13169), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(20286), 5,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
  [442583] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [442603] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [442623] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 10,
      sym__dot,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [442645] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17600), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17302), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442683] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 11,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_AT2,
  [442703] = 3,
    ACTIONS(14704), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14706), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [442725] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_in,
  [442745] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17602), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2585), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 5,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [442773] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [442793] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17604), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15511), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442831] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [442851] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [442871] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [442891] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [442911] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [442931] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17606), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15830), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [442969] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17608), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16115), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [443007] = 11,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    ACTIONS(17610), 1,
      sym__tyconsym,
    STATE(12917), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20070), 1,
      sym__modid,
    STATE(20660), 1,
      sym_constructor_operator,
    STATE(19109), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [443045] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [443065] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [443085] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [443105] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17612), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16659), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [443143] = 7,
    ACTIONS(16570), 1,
      anon_sym_EQ,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(16574), 1,
      sym_where,
    STATE(13580), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(17614), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(16182), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [443173] = 7,
    ACTIONS(16628), 1,
      anon_sym_EQ,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    ACTIONS(16632), 1,
      sym_where,
    STATE(13677), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(17614), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(16304), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [443203] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [443223] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [443243] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [443263] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [443285] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [443305] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [443325] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [443345] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [443367] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [443389] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [443409] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [443431] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [443451] = 3,
    ACTIONS(16144), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [443473] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [443493] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [443513] = 3,
    ACTIONS(16134), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [443535] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17616), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17561), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [443573] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [443593] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [443613] = 3,
    ACTIONS(14738), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [443635] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [443655] = 11,
    ACTIONS(247), 1,
      sym__conid,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(1677), 1,
      sym__varid,
    STATE(3470), 1,
      sym_constructor,
    STATE(3543), 1,
      sym_variable,
    STATE(12858), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20542), 1,
      sym__modid,
    STATE(20660), 1,
      sym_constructor_operator,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [443693] = 4,
    ACTIONS(9971), 1,
      anon_sym_LBRACE,
    STATE(12560), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [443717] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [443737] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [443757] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [443777] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [443797] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [443819] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [443839] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [443859] = 5,
    ACTIONS(13614), 1,
      sym__varid,
    ACTIONS(17560), 1,
      anon_sym_LPAREN,
    STATE(12167), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15074), 6,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [443885] = 5,
    ACTIONS(13614), 1,
      sym__varid,
    ACTIONS(17560), 1,
      anon_sym_LPAREN,
    STATE(10718), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17359), 6,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [443911] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17618), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2551), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [443939] = 3,
    ACTIONS(14793), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [443961] = 3,
    ACTIONS(16095), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [443983] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [444003] = 3,
    ACTIONS(16099), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [444025] = 3,
    ACTIONS(14662), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [444047] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17620), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15931), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [444085] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [444107] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [444127] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17622), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16405), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [444165] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [444185] = 3,
    ACTIONS(14746), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [444207] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 11,
      sym__layout_semicolon,
      sym_where,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [444227] = 7,
    ACTIONS(16628), 1,
      anon_sym_EQ,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    ACTIONS(16632), 1,
      sym_where,
    STATE(13440), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(17614), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(16754), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [444257] = 3,
    ACTIONS(14692), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [444279] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17624), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2615), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [444307] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17626), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16190), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [444345] = 3,
    ACTIONS(14688), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [444367] = 8,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(17628), 1,
      sym__tyconsym,
    STATE(13169), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(20060), 5,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
  [444399] = 3,
    ACTIONS(14666), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [444421] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [444443] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17630), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15676), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [444481] = 3,
    ACTIONS(14670), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [444503] = 8,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(17632), 1,
      sym__tyconsym,
    STATE(13169), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    STATE(20681), 5,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
      sym__type_operator,
      sym_qualified_type_operator,
      sym__qualified_type_operator,
  [444535] = 3,
    ACTIONS(16140), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [444557] = 9,
    ACTIONS(17634), 1,
      anon_sym_EQ,
    ACTIONS(17636), 1,
      sym_where,
    STATE(2441), 1,
      sym__colon2,
    STATE(13979), 1,
      sym_tyfam_result_type,
    STATE(15374), 1,
      sym__tyfam_inj,
    STATE(15378), 1,
      sym__type_annotation,
    ACTIONS(15726), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(17586), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [444591] = 3,
    ACTIONS(14674), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [444613] = 7,
    ACTIONS(16570), 1,
      anon_sym_EQ,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(16574), 1,
      sym_where,
    STATE(13595), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(17614), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(16241), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [444643] = 3,
    ACTIONS(16127), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [444665] = 9,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16518), 1,
      sym__consym,
    ACTIONS(17638), 1,
      anon_sym_BQUOTE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13821), 1,
      aux_sym__qualifying_module,
    STATE(20542), 1,
      sym__modid,
    STATE(3216), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(16514), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [444699] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [444719] = 7,
    ACTIONS(16570), 1,
      anon_sym_EQ,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(16574), 1,
      sym_where,
    STATE(13639), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(17562), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(16366), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [444749] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [444769] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [444791] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [444811] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17640), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2569), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [444839] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [444861] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [444881] = 3,
    ACTIONS(14676), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [444903] = 3,
    ACTIONS(14680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [444925] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [444945] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17642), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16056), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [444983] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [445003] = 3,
    ACTIONS(16123), 1,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 10,
      sym__varsym,
      sym__consym,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [445025] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17644), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15494), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [445063] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [445085] = 3,
    ACTIONS(14822), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [445107] = 3,
    ACTIONS(14684), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [445129] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [445153] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [445173] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 11,
      sym__arith_dotdot,
      sym__varsym,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [445193] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [445215] = 3,
    ACTIONS(14696), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [445237] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 11,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [445257] = 3,
    ACTIONS(14785), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [445279] = 3,
    ACTIONS(14773), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14775), 10,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [445301] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [445321] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [445343] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17646), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17615), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [445381] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [445403] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 11,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [445423] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [445445] = 11,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17648), 1,
      anon_sym_RBRACE,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17170), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [445483] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 11,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [445503] = 9,
    ACTIONS(4087), 1,
      sym__conid,
    ACTIONS(16733), 1,
      sym__varid,
    ACTIONS(17650), 1,
      anon_sym_LPAREN,
    STATE(3473), 1,
      sym_constructor,
    STATE(3699), 1,
      sym_qualified_constructor,
    STATE(13960), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(3750), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [445536] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [445555] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16059), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [445590] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16642), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [445625] = 3,
    ACTIONS(14903), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [445646] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [445665] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [445684] = 9,
    ACTIONS(4267), 1,
      sym__conid,
    ACTIONS(16956), 1,
      sym__varid,
    ACTIONS(17656), 1,
      anon_sym_LPAREN,
    STATE(4342), 1,
      sym_constructor,
    STATE(4790), 1,
      sym_qualified_constructor,
    STATE(13927), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(4633), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [445717] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [445736] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [445755] = 9,
    ACTIONS(4487), 1,
      sym__conid,
    ACTIONS(16903), 1,
      sym__varid,
    ACTIONS(17658), 1,
      anon_sym_LPAREN,
    STATE(9690), 1,
      sym_constructor,
    STATE(9781), 1,
      sym_qualified_constructor,
    STATE(13888), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(9906), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [445788] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17660), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2533), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [445815] = 9,
    ACTIONS(4211), 1,
      sym__conid,
    ACTIONS(16729), 1,
      sym__varid,
    ACTIONS(17662), 1,
      anon_sym_LPAREN,
    STATE(4319), 1,
      sym_constructor,
    STATE(4645), 1,
      sym_qualified_constructor,
    STATE(13564), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(4787), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [445848] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [445867] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [445886] = 3,
    ACTIONS(14712), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [445907] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17666), 1,
      anon_sym_RPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(16072), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [445942] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 10,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_AT2,
  [445961] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [445982] = 5,
    ACTIONS(13546), 1,
      sym__varid,
    ACTIONS(17670), 1,
      anon_sym_LPAREN,
    STATE(12345), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17355), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [446007] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16154), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446042] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15455), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [446061] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17672), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(18277), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446096] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15451), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [446115] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15477), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [446134] = 9,
    ACTIONS(1698), 1,
      sym__conid,
    ACTIONS(16546), 1,
      sym__varid,
    ACTIONS(17674), 1,
      anon_sym_LPAREN,
    STATE(3471), 1,
      sym_constructor,
    STATE(3677), 1,
      sym_qualified_constructor,
    STATE(13516), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(3804), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446167] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [446186] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [446205] = 9,
    ACTIONS(8789), 1,
      sym__conid,
    ACTIONS(16695), 1,
      sym__varid,
    ACTIONS(17676), 1,
      anon_sym_LPAREN,
    STATE(10192), 1,
      sym_constructor,
    STATE(10556), 1,
      sym_qualified_constructor,
    STATE(13588), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(10563), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446238] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [446257] = 9,
    ACTIONS(8936), 1,
      sym__conid,
    ACTIONS(17162), 1,
      sym__varid,
    ACTIONS(17678), 1,
      anon_sym_LPAREN,
    STATE(10294), 1,
      sym_constructor,
    STATE(10364), 1,
      sym_qualified_constructor,
    STATE(13435), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(10814), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446290] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17680), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(18277), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446325] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [446344] = 8,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(15562), 1,
      anon_sym_BQUOTE,
    ACTIONS(15570), 1,
      sym__tyconsym,
    STATE(2360), 1,
      sym__colon2,
    STATE(20082), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    STATE(14889), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446375] = 9,
    ACTIONS(17682), 1,
      anon_sym_EQ,
    ACTIONS(17684), 1,
      sym_where,
    STATE(2377), 1,
      sym__colon2,
    STATE(14068), 1,
      sym_tyfam_result_type,
    STATE(15564), 1,
      sym__type_annotation,
    STATE(15576), 1,
      sym__tyfam_inj,
    ACTIONS(15962), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(17586), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446408] = 5,
    ACTIONS(13546), 1,
      sym__varid,
    ACTIONS(17670), 1,
      anon_sym_LPAREN,
    STATE(12451), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15074), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [446433] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [446452] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [446471] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 10,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [446490] = 3,
    ACTIONS(17686), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16029), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [446511] = 9,
    ACTIONS(4541), 1,
      sym__conid,
    ACTIONS(16986), 1,
      sym__varid,
    ACTIONS(17688), 1,
      anon_sym_LPAREN,
    STATE(9235), 1,
      sym_constructor,
    STATE(9289), 1,
      sym_qualified_constructor,
    STATE(13841), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(9400), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446544] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16249), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446579] = 9,
    ACTIONS(1402), 1,
      sym__conid,
    ACTIONS(16982), 1,
      sym__varid,
    ACTIONS(17690), 1,
      anon_sym_LPAREN,
    STATE(3818), 1,
      sym_constructor,
    STATE(3884), 1,
      sym_qualified_constructor,
    STATE(13977), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(4031), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446612] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16884), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446647] = 9,
    ACTIONS(13654), 1,
      sym__conid,
    ACTIONS(17692), 1,
      anon_sym_LPAREN,
    STATE(13365), 1,
      sym_constructor,
    STATE(13640), 1,
      sym_qualified_type,
    STATE(13800), 1,
      sym_deriving_strategy,
    STATE(15304), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17694), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446680] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15964), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446715] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17696), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [446734] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [446753] = 9,
    ACTIONS(8679), 1,
      sym__conid,
    ACTIONS(16972), 1,
      sym__varid,
    ACTIONS(17698), 1,
      anon_sym_LPAREN,
    STATE(10570), 1,
      sym_constructor,
    STATE(11171), 1,
      sym_qualified_constructor,
    STATE(13925), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(11338), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446786] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [446805] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15493), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446840] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15459), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [446859] = 10,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12325), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20660), 1,
      sym_constructor_operator,
    STATE(20874), 1,
      sym__modid,
    STATE(19109), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446894] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [446913] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [446932] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16344), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [446967] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [446986] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15465), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [447005] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [447026] = 9,
    ACTIONS(4407), 1,
      sym__conid,
    ACTIONS(16651), 1,
      sym__varid,
    ACTIONS(17700), 1,
      anon_sym_LPAREN,
    STATE(10164), 1,
      sym_constructor,
    STATE(10683), 1,
      sym_qualified_constructor,
    STATE(13468), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(10598), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [447059] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [447078] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17702), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2639), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [447105] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [447124] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17166), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [447159] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [447178] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [447197] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [447216] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [447235] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [447254] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 10,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [447273] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16518), 1,
      sym__consym,
    STATE(13225), 1,
      sym_constructor,
    STATE(13821), 1,
      aux_sym__qualifying_module,
    STATE(20542), 1,
      sym__modid,
    STATE(3261), 2,
      sym_constructor_operator,
      sym_qualified_constructor_operator,
    ACTIONS(16514), 3,
      sym__varsym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [447304] = 3,
    ACTIONS(14712), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
  [447325] = 9,
    ACTIONS(4193), 1,
      sym__conid,
    ACTIONS(16752), 1,
      sym__varid,
    ACTIONS(17704), 1,
      anon_sym_LPAREN,
    STATE(4632), 1,
      sym_constructor,
    STATE(4989), 1,
      sym_qualified_constructor,
    STATE(13953), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(5382), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [447358] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16404), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [447393] = 5,
    ACTIONS(13546), 1,
      sym__varid,
    ACTIONS(17670), 1,
      anon_sym_LPAREN,
    STATE(12251), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15118), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [447418] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [447437] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15869), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [447472] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [447491] = 9,
    ACTIONS(4143), 1,
      sym__conid,
    ACTIONS(16634), 1,
      sym__varid,
    ACTIONS(17706), 1,
      anon_sym_LPAREN,
    STATE(4335), 1,
      sym_constructor,
    STATE(4623), 1,
      sym_qualified_constructor,
    STATE(13973), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(5182), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [447524] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16439), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [447559] = 3,
    ACTIONS(15991), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 9,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [447580] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [447599] = 3,
    ACTIONS(13680), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [447620] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15473), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [447639] = 9,
    ACTIONS(4349), 1,
      sym__conid,
    ACTIONS(17040), 1,
      sym__varid,
    ACTIONS(17708), 1,
      anon_sym_LPAREN,
    STATE(10791), 1,
      sym_constructor,
    STATE(10925), 1,
      sym_qualified_constructor,
    STATE(13905), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(11346), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [447672] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [447693] = 3,
    ACTIONS(14712), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [447714] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [447733] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15774), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [447768] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [447787] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [447806] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [447825] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17398), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [447860] = 7,
    ACTIONS(17714), 1,
      sym__conid,
    STATE(12325), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    ACTIONS(17710), 3,
      sym__varid,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(17712), 3,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [447889] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [447908] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [447927] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16534), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [447962] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [447981] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [448000] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16297), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448035] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [448054] = 3,
    ACTIONS(14738), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [448075] = 9,
    ACTIONS(4061), 1,
      sym__conid,
    ACTIONS(16655), 1,
      sym__varid,
    ACTIONS(17717), 1,
      anon_sym_LPAREN,
    STATE(4535), 1,
      sym_constructor,
    STATE(5315), 1,
      sym_qualified_constructor,
    STATE(13695), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(5363), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448108] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15679), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448143] = 9,
    ACTIONS(4205), 1,
      sym__conid,
    ACTIONS(16931), 1,
      sym__varid,
    ACTIONS(17719), 1,
      anon_sym_LPAREN,
    STATE(3857), 1,
      sym_constructor,
    STATE(3915), 1,
      sym_qualified_constructor,
    STATE(13936), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(3916), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448176] = 3,
    ACTIONS(14738), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 8,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
  [448197] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [448216] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [448235] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 8,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [448256] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17721), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2564), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [448283] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16629), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448318] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(18725), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448353] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [448372] = 5,
    ACTIONS(17723), 1,
      sym__varid,
    ACTIONS(17726), 1,
      anon_sym_LPAREN,
    STATE(12345), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17296), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [448397] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15501), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [448416] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17614), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448451] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16189), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448486] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [448505] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [448524] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [448543] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [448562] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17729), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2668), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [448589] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15584), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448624] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17538), 1,
      anon_sym_LPAREN,
    ACTIONS(17542), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(18696), 1,
      sym_pat_field,
    STATE(20878), 1,
      sym__modid,
    STATE(15893), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448659] = 9,
    ACTIONS(4161), 1,
      sym__conid,
    ACTIONS(17124), 1,
      sym__varid,
    ACTIONS(17731), 1,
      anon_sym_LPAREN,
    STATE(4074), 1,
      sym_constructor,
    STATE(4305), 1,
      sym_qualified_constructor,
    STATE(13449), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(4237), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448692] = 9,
    ACTIONS(4519), 1,
      sym__conid,
    ACTIONS(16582), 1,
      sym__varid,
    ACTIONS(17733), 1,
      anon_sym_LPAREN,
    STATE(10104), 1,
      sym_constructor,
    STATE(10702), 1,
      sym_qualified_constructor,
    STATE(13708), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(11305), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448725] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [448748] = 9,
    ACTIONS(9100), 1,
      sym__conid,
    ACTIONS(16913), 1,
      sym__varid,
    ACTIONS(17735), 1,
      anon_sym_LPAREN,
    STATE(10505), 1,
      sym_constructor,
    STATE(11262), 1,
      sym_qualified_constructor,
    STATE(13940), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(11036), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448781] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16724), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448816] = 9,
    ACTIONS(4153), 1,
      sym__conid,
    ACTIONS(16743), 1,
      sym__varid,
    ACTIONS(17737), 1,
      anon_sym_LPAREN,
    STATE(5259), 1,
      sym_constructor,
    STATE(5552), 1,
      sym_qualified_constructor,
    STATE(13955), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(5650), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448849] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17739), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(18277), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448884] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15485), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448919] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 8,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_in,
  [448940] = 3,
    ACTIONS(14856), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [448961] = 9,
    ACTIONS(4565), 1,
      sym__conid,
    ACTIONS(17218), 1,
      sym__varid,
    ACTIONS(17741), 1,
      anon_sym_LPAREN,
    STATE(10044), 1,
      sym_constructor,
    STATE(10640), 1,
      sym_qualified_constructor,
    STATE(13924), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(11034), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [448994] = 7,
    ACTIONS(17222), 1,
      anon_sym_EQ,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17226), 1,
      sym_where,
    ACTIONS(17614), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14275), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(18484), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449023] = 9,
    ACTIONS(4243), 1,
      sym__conid,
    ACTIONS(17058), 1,
      sym__varid,
    ACTIONS(17743), 1,
      anon_sym_LPAREN,
    STATE(4245), 1,
      sym_constructor,
    STATE(4556), 1,
      sym_qualified_constructor,
    STATE(13770), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(4996), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449056] = 5,
    ACTIONS(13642), 1,
      sym__varid,
    ACTIONS(17745), 1,
      anon_sym_LPAREN,
    STATE(12443), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17359), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [449081] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17747), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(15689), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449116] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17749), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2599), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [449143] = 3,
    ACTIONS(13680), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [449164] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17812), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449199] = 9,
    ACTIONS(4177), 1,
      sym__conid,
    ACTIONS(16638), 1,
      sym__varid,
    ACTIONS(17751), 1,
      anon_sym_LPAREN,
    STATE(4233), 1,
      sym_constructor,
    STATE(4725), 1,
      sym_qualified_constructor,
    STATE(13634), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(4669), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449232] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16114), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449267] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15512), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449302] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17753), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(18277), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449337] = 5,
    ACTIONS(13642), 1,
      sym__varid,
    ACTIONS(17745), 1,
      anon_sym_LPAREN,
    STATE(12369), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15074), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [449362] = 9,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(17755), 1,
      anon_sym_LPAREN,
    STATE(13484), 1,
      sym_constructor,
    STATE(13884), 1,
      sym_deriving_strategy,
    STATE(14159), 1,
      sym_qualified_type,
    STATE(14747), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17694), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449395] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15441), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [449414] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17757), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(15560), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449449] = 9,
    ACTIONS(4289), 1,
      sym__conid,
    ACTIONS(17206), 1,
      sym__varid,
    ACTIONS(17759), 1,
      anon_sym_LPAREN,
    STATE(4308), 1,
      sym_constructor,
    STATE(4664), 1,
      sym_qualified_constructor,
    STATE(13542), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(5654), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449482] = 9,
    ACTIONS(4055), 1,
      sym__conid,
    ACTIONS(16443), 1,
      sym__varid,
    ACTIONS(17761), 1,
      anon_sym_LPAREN,
    STATE(4257), 1,
      sym_constructor,
    STATE(4416), 1,
      sym_qualified_constructor,
    STATE(13792), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(4457), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449515] = 9,
    ACTIONS(4047), 1,
      sym__conid,
    ACTIONS(16917), 1,
      sym__varid,
    ACTIONS(17763), 1,
      anon_sym_LPAREN,
    STATE(4498), 1,
      sym_constructor,
    STATE(5373), 1,
      sym_qualified_constructor,
    STATE(13613), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(5197), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449548] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [449567] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15493), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [449586] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17765), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2586), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [449613] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [449632] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15642), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449667] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [449686] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15513), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [449705] = 9,
    ACTIONS(3051), 1,
      sym__conid,
    ACTIONS(16485), 1,
      sym__varid,
    ACTIONS(17767), 1,
      anon_sym_LPAREN,
    STATE(4400), 1,
      sym_constructor,
    STATE(5105), 1,
      sym_qualified_constructor,
    STATE(13395), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(5801), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449738] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [449757] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16819), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449792] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [449811] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [449830] = 3,
    ACTIONS(14862), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14864), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [449851] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [449870] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [449889] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [449908] = 9,
    ACTIONS(8823), 1,
      sym__conid,
    ACTIONS(16453), 1,
      sym__varid,
    ACTIONS(17769), 1,
      anon_sym_LPAREN,
    STATE(9537), 1,
      sym_constructor,
    STATE(9678), 1,
      sym_qualified_constructor,
    STATE(13851), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(9628), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449941] = 9,
    ACTIONS(9252), 1,
      sym__conid,
    ACTIONS(16927), 1,
      sym__varid,
    ACTIONS(17771), 1,
      anon_sym_LPAREN,
    STATE(9941), 1,
      sym_constructor,
    STATE(10009), 1,
      sym_qualified_constructor,
    STATE(13503), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(10011), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [449974] = 9,
    ACTIONS(4321), 1,
      sym__conid,
    ACTIONS(16647), 1,
      sym__varid,
    ACTIONS(17773), 1,
      anon_sym_LPAREN,
    STATE(9240), 1,
      sym_constructor,
    STATE(9275), 1,
      sym_qualified_constructor,
    STATE(13579), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(9445), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450007] = 9,
    ACTIONS(4439), 1,
      sym__conid,
    ACTIONS(17130), 1,
      sym__varid,
    ACTIONS(17775), 1,
      anon_sym_LPAREN,
    STATE(10806), 1,
      sym_constructor,
    STATE(10906), 1,
      sym_qualified_constructor,
    STATE(13876), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(12099), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450040] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17777), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(15517), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450075] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16010), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450110] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [450129] = 9,
    ACTIONS(9170), 1,
      sym__conid,
    ACTIONS(16423), 1,
      sym__varid,
    ACTIONS(17779), 1,
      anon_sym_LPAREN,
    STATE(10756), 1,
      sym_constructor,
    STATE(10941), 1,
      sym_qualified_constructor,
    STATE(13802), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(11485), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450162] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15889), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450197] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [450216] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [450235] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [450254] = 10,
    ACTIONS(273), 1,
      sym__varsym,
    ACTIONS(275), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15620), 1,
      anon_sym_DASH,
    STATE(7703), 1,
      sym_constructor_operator,
    STATE(12325), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20874), 1,
      sym__modid,
    STATE(7862), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450289] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [450308] = 9,
    ACTIONS(3116), 1,
      sym__conid,
    ACTIONS(16786), 1,
      sym__varid,
    ACTIONS(17781), 1,
      anon_sym_LPAREN,
    STATE(3978), 1,
      sym_constructor,
    STATE(4121), 1,
      sym_qualified_constructor,
    STATE(13810), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(4159), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450341] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [450360] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15882), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450395] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17565), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450430] = 9,
    ACTIONS(8476), 1,
      sym__conid,
    ACTIONS(16616), 1,
      sym__varid,
    ACTIONS(17783), 1,
      anon_sym_LPAREN,
    STATE(10211), 1,
      sym_constructor,
    STATE(10450), 1,
      sym_qualified_constructor,
    STATE(13914), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(10554), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450463] = 9,
    ACTIONS(8765), 1,
      sym__conid,
    ACTIONS(16671), 1,
      sym__varid,
    ACTIONS(17785), 1,
      anon_sym_LPAREN,
    STATE(10871), 1,
      sym_constructor,
    STATE(11567), 1,
      sym_qualified_constructor,
    STATE(13951), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(11534), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450496] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17787), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(18277), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450531] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [450552] = 9,
    ACTIONS(4111), 1,
      sym__conid,
    ACTIONS(16469), 1,
      sym__varid,
    ACTIONS(17789), 1,
      anon_sym_LPAREN,
    STATE(9458), 1,
      sym_constructor,
    STATE(9525), 1,
      sym_qualified_constructor,
    STATE(13966), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(9943), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450585] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [450604] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17791), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2542), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15932), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [450631] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 10,
      sym_where,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [450650] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [450669] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 10,
      sym__layout_semicolon,
      sym__dot,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
      anon_sym_via,
      anon_sym_deriving,
  [450688] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [450707] = 9,
    ACTIONS(4081), 1,
      sym__conid,
    ACTIONS(16506), 1,
      sym__varid,
    ACTIONS(17793), 1,
      anon_sym_LPAREN,
    STATE(4552), 1,
      sym_constructor,
    STATE(5251), 1,
      sym_qualified_constructor,
    STATE(13737), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(5163), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450740] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [450759] = 7,
    ACTIONS(17797), 1,
      anon_sym_LBRACE,
    ACTIONS(17799), 1,
      anon_sym_in,
    ACTIONS(17801), 1,
      sym__layout_start,
    STATE(14111), 1,
      sym_decls,
    STATE(20711), 1,
      sym__let_decls,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17795), 5,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [450788] = 3,
    ACTIONS(14878), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14880), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [450809] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [450828] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 10,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      anon_sym_using,
      anon_sym_then,
      anon_sym_else,
      anon_sym_of,
  [450847] = 3,
    ACTIONS(14874), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14876), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [450868] = 9,
    ACTIONS(1753), 1,
      sym__conid,
    ACTIONS(16864), 1,
      sym__varid,
    ACTIONS(17803), 1,
      anon_sym_LPAREN,
    STATE(4265), 1,
      sym_constructor,
    STATE(4502), 1,
      sym_qualified_constructor,
    STATE(13485), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(4415), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450901] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17805), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(15711), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450936] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15674), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [450971] = 5,
    ACTIONS(13642), 1,
      sym__varid,
    ACTIONS(17745), 1,
      anon_sym_LPAREN,
    STATE(12498), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15118), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [450996] = 9,
    ACTIONS(8970), 1,
      sym__conid,
    ACTIONS(16475), 1,
      sym__varid,
    ACTIONS(17807), 1,
      anon_sym_LPAREN,
    STATE(10870), 1,
      sym_constructor,
    STATE(11713), 1,
      sym_qualified_constructor,
    STATE(13765), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(11651), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451029] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16914), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451064] = 5,
    ACTIONS(17809), 1,
      sym__varid,
    ACTIONS(17812), 1,
      anon_sym_LPAREN,
    STATE(12443), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17296), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [451089] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [451108] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [451127] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 10,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [451146] = 9,
    ACTIONS(9286), 1,
      sym__conid,
    ACTIONS(16510), 1,
      sym__varid,
    ACTIONS(17815), 1,
      anon_sym_LPAREN,
    STATE(10370), 1,
      sym_constructor,
    STATE(11461), 1,
      sym_qualified_constructor,
    STATE(13659), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(10973), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451179] = 9,
    ACTIONS(3032), 1,
      sym__conid,
    ACTIONS(17134), 1,
      sym__varid,
    ACTIONS(17817), 1,
      anon_sym_LPAREN,
    STATE(4716), 1,
      sym_constructor,
    STATE(5006), 1,
      sym_qualified_constructor,
    STATE(13481), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(4931), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451212] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [451231] = 7,
    ACTIONS(17222), 1,
      anon_sym_EQ,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17226), 1,
      sym_where,
    ACTIONS(17562), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14162), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(18158), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451260] = 5,
    ACTIONS(13546), 1,
      sym__varid,
    ACTIONS(17670), 1,
      anon_sym_LPAREN,
    STATE(12345), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17359), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [451285] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [451306] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17819), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(18277), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451341] = 3,
    ACTIONS(13709), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [451362] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [451381] = 9,
    ACTIONS(13558), 1,
      sym__conid,
    ACTIONS(17821), 1,
      anon_sym_LPAREN,
    STATE(13310), 1,
      sym_constructor,
    STATE(13840), 1,
      sym_deriving_strategy,
    STATE(13847), 1,
      sym_qualified_type,
    STATE(15092), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17694), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451414] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16066), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451449] = 9,
    ACTIONS(8725), 1,
      sym__conid,
    ACTIONS(16717), 1,
      sym__varid,
    ACTIONS(17823), 1,
      anon_sym_LPAREN,
    STATE(10588), 1,
      sym_constructor,
    STATE(11140), 1,
      sym_qualified_constructor,
    STATE(13578), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(11464), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451482] = 7,
    ACTIONS(17222), 1,
      anon_sym_EQ,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17226), 1,
      sym_where,
    ACTIONS(17536), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14351), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(18459), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451511] = 3,
    ACTIONS(14856), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [451532] = 7,
    ACTIONS(17222), 1,
      anon_sym_EQ,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17226), 1,
      sym_where,
    ACTIONS(17614), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14251), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    STATE(18337), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451561] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15829), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451596] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17304), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451631] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17009), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451666] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17825), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(16402), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451701] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 9,
      sym__dot,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [451722] = 3,
    ACTIONS(14832), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14834), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [451743] = 9,
    ACTIONS(9134), 1,
      sym__conid,
    ACTIONS(17202), 1,
      sym__varid,
    ACTIONS(17827), 1,
      anon_sym_LPAREN,
    STATE(10171), 1,
      sym_constructor,
    STATE(10673), 1,
      sym_qualified_constructor,
    STATE(13397), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(10609), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451776] = 3,
    ACTIONS(14836), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14838), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [451797] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [451816] = 3,
    ACTIONS(14870), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14872), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [451837] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15437), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [451856] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17102), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451891] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17829), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(18277), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451926] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(15928), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451961] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17044), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [451996] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [452015] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15447), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [452034] = 3,
    ACTIONS(14738), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
  [452055] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16845), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452090] = 9,
    ACTIONS(4373), 1,
      sym__conid,
    ACTIONS(17150), 1,
      sym__varid,
    ACTIONS(17831), 1,
      anon_sym_LPAREN,
    STATE(10105), 1,
      sym_constructor,
    STATE(10604), 1,
      sym_qualified_constructor,
    STATE(13911), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(11621), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452123] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17833), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(18277), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452158] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [452181] = 3,
    ACTIONS(14840), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14842), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [452202] = 3,
    ACTIONS(14844), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14846), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [452223] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15489), 10,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [452242] = 4,
    ACTIONS(10329), 1,
      anon_sym_LBRACE,
    STATE(13014), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [452265] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(17185), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452300] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 10,
      sym__layout_semicolon,
      sym__layout_end,
      sym__varsym,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [452319] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16265), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452354] = 10,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(17835), 1,
      anon_sym_RPAREN,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(18277), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452389] = 9,
    ACTIONS(4171), 1,
      sym__conid,
    ACTIONS(16502), 1,
      sym__varid,
    ACTIONS(17837), 1,
      anon_sym_LPAREN,
    STATE(5151), 1,
      sym_constructor,
    STATE(5594), 1,
      sym_qualified_constructor,
    STATE(13763), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(5532), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452422] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 10,
      sym__layout_semicolon,
      sym__varsym,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [452441] = 3,
    ACTIONS(14866), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14868), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [452462] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16474), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452497] = 9,
    ACTIONS(4073), 1,
      sym__conid,
    ACTIONS(16417), 1,
      sym__varid,
    ACTIONS(17839), 1,
      anon_sym_LPAREN,
    STATE(4661), 1,
      sym_constructor,
    STATE(5081), 1,
      sym_qualified_constructor,
    STATE(13808), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(5487), 3,
      sym_variable,
      sym_qualified_variable,
      sym__qcon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452530] = 3,
    ACTIONS(14858), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14860), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [452551] = 5,
    ACTIONS(13642), 1,
      sym__varid,
    ACTIONS(17745), 1,
      anon_sym_LPAREN,
    STATE(12443), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17355), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [452576] = 10,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17652), 1,
      anon_sym_LPAREN,
    ACTIONS(17654), 1,
      anon_sym_DOT_DOT,
    STATE(13225), 1,
      sym_constructor,
    STATE(13768), 1,
      aux_sym__qualifying_module,
    STATE(16676), 1,
      sym_exp_field,
    STATE(20878), 1,
      sym__modid,
    STATE(14112), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452611] = 9,
    ACTIONS(4393), 1,
      sym__varid,
    ACTIONS(4407), 1,
      sym__conid,
    STATE(10208), 1,
      sym_constructor,
    STATE(10359), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452643] = 9,
    ACTIONS(549), 1,
      sym__conid,
    ACTIONS(1677), 1,
      sym__varid,
    STATE(3543), 1,
      sym_variable,
    STATE(3866), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452675] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16093), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [452693] = 9,
    ACTIONS(8753), 1,
      sym__varid,
    ACTIONS(8765), 1,
      sym__conid,
    STATE(10929), 1,
      sym_constructor,
    STATE(11893), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452725] = 7,
    ACTIONS(17845), 1,
      anon_sym_PIPE,
    ACTIONS(17847), 1,
      sym_where,
    STATE(14214), 1,
      sym_fundeps,
    STATE(15795), 1,
      sym_class_body,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(17841), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452753] = 9,
    ACTIONS(101), 1,
      sym__conid,
    ACTIONS(1677), 1,
      sym__varid,
    STATE(3543), 1,
      sym_variable,
    STATE(3976), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452785] = 9,
    ACTIONS(17851), 1,
      anon_sym_RBRACK,
    ACTIONS(17853), 1,
      anon_sym_PIPE,
    ACTIONS(17855), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17857), 1,
      sym__arith_dotdot,
    ACTIONS(17859), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(16274), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452817] = 9,
    ACTIONS(17429), 1,
      sym__varid,
    ACTIONS(17431), 1,
      anon_sym_LPAREN,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(17861), 1,
      anon_sym_family,
    STATE(12166), 1,
      sym_constructor,
    STATE(13538), 1,
      sym__simpletype,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(13778), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452849] = 9,
    ACTIONS(17429), 1,
      sym__varid,
    ACTIONS(17863), 1,
      anon_sym_LPAREN,
    ACTIONS(17865), 1,
      sym__conid,
    ACTIONS(17867), 1,
      anon_sym_family,
    STATE(12378), 1,
      sym_constructor,
    STATE(13146), 1,
      sym__simpletype,
    STATE(14079), 1,
      sym__simpletype_infix,
    STATE(13691), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452881] = 4,
    STATE(13279), 1,
      sym_calling_convention,
    STATE(13931), 1,
      sym__foreign_pre,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17869), 7,
      anon_sym_ccall,
      anon_sym_stdcall,
      anon_sym_cplusplus,
      anon_sym_jvm,
      anon_sym_dotnet,
      anon_sym_prim,
      anon_sym_capi,
  [452903] = 3,
    ACTIONS(14856), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [452923] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17696), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [452941] = 9,
    ACTIONS(9238), 1,
      sym__varid,
    ACTIONS(9252), 1,
      sym__conid,
    STATE(9944), 1,
      sym_constructor,
    STATE(10167), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [452973] = 3,
    ACTIONS(13680), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [452993] = 4,
    STATE(13279), 1,
      sym_calling_convention,
    STATE(13933), 1,
      sym__foreign_pre,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17869), 7,
      anon_sym_ccall,
      anon_sym_stdcall,
      anon_sym_cplusplus,
      anon_sym_jvm,
      anon_sym_dotnet,
      anon_sym_prim,
      anon_sym_capi,
  [453015] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16097), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [453033] = 3,
    ACTIONS(14947), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [453053] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [453071] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15459), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [453089] = 5,
    STATE(2434), 1,
      sym__colon2,
    STATE(14130), 1,
      sym__type_annotation,
    ACTIONS(15742), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17871), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
  [453113] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15465), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [453131] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15477), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [453149] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [453171] = 9,
    ACTIONS(1837), 1,
      sym__varid,
    ACTIONS(3116), 1,
      sym__conid,
    STATE(3906), 1,
      sym_constructor,
    STATE(4193), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453203] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 9,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [453221] = 9,
    ACTIONS(8665), 1,
      sym__varid,
    ACTIONS(8679), 1,
      sym__conid,
    STATE(10545), 1,
      sym_constructor,
    STATE(10899), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453253] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [453273] = 4,
    STATE(12629), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(17873), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17875), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [453295] = 9,
    ACTIONS(4337), 1,
      sym__varid,
    ACTIONS(4349), 1,
      sym__conid,
    STATE(10712), 1,
      sym_constructor,
    STATE(11108), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453327] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 9,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [453345] = 7,
    ACTIONS(17877), 1,
      anon_sym_PIPE,
    ACTIONS(17879), 1,
      sym_where,
    STATE(14536), 1,
      sym_fundeps,
    STATE(16606), 1,
      sym_class_body,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(17841), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453373] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [453395] = 4,
    STATE(12629), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(17881), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17875), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [453417] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15441), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [453435] = 9,
    ACTIONS(2305), 1,
      sym__varid,
    ACTIONS(4267), 1,
      sym__conid,
    STATE(4266), 1,
      sym_constructor,
    STATE(4424), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453467] = 9,
    ACTIONS(4309), 1,
      sym__varid,
    ACTIONS(4321), 1,
      sym__conid,
    STATE(9226), 1,
      sym_constructor,
    STATE(9375), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453499] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15437), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [453517] = 9,
    ACTIONS(4427), 1,
      sym__varid,
    ACTIONS(4439), 1,
      sym__conid,
    STATE(10817), 1,
      sym_constructor,
    STATE(10872), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453549] = 9,
    ACTIONS(4565), 1,
      sym__conid,
    ACTIONS(8753), 1,
      sym__varid,
    STATE(10230), 1,
      sym_constructor,
    STATE(11893), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453581] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 8,
      sym__dot,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [453601] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [453623] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 9,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT2,
  [453641] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 8,
      sym__dot,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [453661] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 9,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [453679] = 4,
    ACTIONS(10803), 1,
      anon_sym_LBRACE,
    STATE(13380), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [453701] = 9,
    ACTIONS(3014), 1,
      sym__varid,
    ACTIONS(4289), 1,
      sym__conid,
    STATE(4285), 1,
      sym_constructor,
    STATE(4630), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453733] = 9,
    ACTIONS(17883), 1,
      anon_sym_RBRACK,
    ACTIONS(17885), 1,
      anon_sym_PIPE,
    ACTIONS(17887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17889), 1,
      sym__arith_dotdot,
    ACTIONS(17891), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(17348), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453765] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 9,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [453783] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [453801] = 9,
    ACTIONS(2895), 1,
      sym__varid,
    ACTIONS(3032), 1,
      sym__conid,
    STATE(4733), 1,
      sym_constructor,
    STATE(4979), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453833] = 9,
    ACTIONS(2844), 1,
      sym__varid,
    ACTIONS(4061), 1,
      sym__conid,
    STATE(4563), 1,
      sym_constructor,
    STATE(5217), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453865] = 5,
    STATE(2434), 1,
      sym__colon2,
    STATE(14361), 1,
      sym__type_annotation,
    ACTIONS(15742), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17893), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
  [453889] = 9,
    ACTIONS(1242), 1,
      sym__conid,
    ACTIONS(1837), 1,
      sym__varid,
    STATE(3741), 1,
      sym_constructor,
    STATE(4193), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453921] = 9,
    ACTIONS(17895), 1,
      anon_sym_RBRACK,
    ACTIONS(17897), 1,
      anon_sym_PIPE,
    ACTIONS(17899), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17901), 1,
      sym__arith_dotdot,
    ACTIONS(17903), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(17107), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [453953] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15441), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [453971] = 4,
    STATE(12596), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(17905), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17907), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [453993] = 9,
    ACTIONS(2560), 1,
      sym__varid,
    ACTIONS(4047), 1,
      sym__conid,
    STATE(4546), 1,
      sym_constructor,
    STATE(5341), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454025] = 9,
    ACTIONS(4309), 1,
      sym__varid,
    ACTIONS(4349), 1,
      sym__conid,
    STATE(9375), 1,
      sym_variable,
    STATE(10712), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454057] = 9,
    ACTIONS(4473), 1,
      sym__varid,
    ACTIONS(4487), 1,
      sym__conid,
    STATE(9619), 1,
      sym_constructor,
    STATE(9958), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454089] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15501), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [454107] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15437), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [454125] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15489), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [454143] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [454165] = 9,
    ACTIONS(1634), 1,
      sym__varid,
    ACTIONS(4087), 1,
      sym__conid,
    STATE(3472), 1,
      sym_constructor,
    STATE(3708), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454197] = 9,
    ACTIONS(17909), 1,
      anon_sym_RBRACK,
    ACTIONS(17911), 1,
      anon_sym_PIPE,
    ACTIONS(17913), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17915), 1,
      sym__arith_dotdot,
    ACTIONS(17917), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(15648), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454229] = 9,
    ACTIONS(17919), 1,
      anon_sym_RBRACK,
    ACTIONS(17921), 1,
      anon_sym_PIPE,
    ACTIONS(17923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17925), 1,
      sym__arith_dotdot,
    ACTIONS(17927), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(15905), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454261] = 9,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17929), 1,
      anon_sym_LPAREN,
    ACTIONS(17931), 1,
      sym__conid,
    STATE(11788), 1,
      sym_constructor,
    STATE(12266), 1,
      sym_tyfam_head,
    STATE(13366), 1,
      sym__simpletype_infix,
    STATE(13415), 1,
      sym__simpletype,
    STATE(13623), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454293] = 9,
    ACTIONS(1933), 1,
      sym__varid,
    ACTIONS(4161), 1,
      sym__conid,
    STATE(4089), 1,
      sym_constructor,
    STATE(4210), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454325] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15473), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [454343] = 9,
    ACTIONS(655), 1,
      sym__conid,
    ACTIONS(1677), 1,
      sym__varid,
    STATE(3543), 1,
      sym_variable,
    STATE(4012), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454375] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [454397] = 9,
    ACTIONS(4309), 1,
      sym__varid,
    ACTIONS(4439), 1,
      sym__conid,
    STATE(9375), 1,
      sym_variable,
    STATE(10817), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454429] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [454447] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15501), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [454465] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15447), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [454483] = 4,
    STATE(13279), 1,
      sym_calling_convention,
    STATE(13793), 1,
      sym__foreign_pre,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17869), 7,
      anon_sym_ccall,
      anon_sym_stdcall,
      anon_sym_cplusplus,
      anon_sym_jvm,
      anon_sym_dotnet,
      anon_sym_prim,
      anon_sym_capi,
  [454505] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [454527] = 4,
    STATE(13279), 1,
      sym_calling_convention,
    STATE(13794), 1,
      sym__foreign_pre,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17869), 7,
      anon_sym_ccall,
      anon_sym_stdcall,
      anon_sym_cplusplus,
      anon_sym_jvm,
      anon_sym_dotnet,
      anon_sym_prim,
      anon_sym_capi,
  [454549] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16067), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [454567] = 9,
    ACTIONS(247), 1,
      sym__conid,
    ACTIONS(1677), 1,
      sym__varid,
    STATE(3470), 1,
      sym_constructor,
    STATE(3543), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454599] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [454621] = 9,
    ACTIONS(1183), 1,
      sym__conid,
    ACTIONS(1677), 1,
      sym__varid,
    STATE(3543), 1,
      sym_variable,
    STATE(3912), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454653] = 9,
    ACTIONS(1700), 1,
      sym__varid,
    ACTIONS(4205), 1,
      sym__conid,
    STATE(3880), 1,
      sym_constructor,
    STATE(3982), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454685] = 5,
    STATE(2441), 1,
      sym__colon2,
    STATE(14286), 1,
      sym__type_annotation,
    ACTIONS(15726), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17893), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
  [454709] = 9,
    ACTIONS(247), 1,
      sym__conid,
    ACTIONS(1390), 1,
      sym__varid,
    STATE(3470), 1,
      sym_constructor,
    STATE(3859), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454741] = 9,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17933), 1,
      anon_sym_LPAREN,
    ACTIONS(17935), 1,
      sym__conid,
    STATE(11492), 1,
      sym_constructor,
    STATE(12193), 1,
      sym_tyfam_head,
    STATE(12791), 1,
      sym__simpletype_infix,
    STATE(13119), 1,
      sym__simpletype,
    STATE(13554), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454773] = 9,
    ACTIONS(8462), 1,
      sym__varid,
    ACTIONS(8476), 1,
      sym__conid,
    STATE(10187), 1,
      sym_constructor,
    STATE(10443), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454805] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [454827] = 9,
    ACTIONS(17937), 1,
      anon_sym_RBRACK,
    ACTIONS(17939), 1,
      anon_sym_PIPE,
    ACTIONS(17941), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17943), 1,
      sym__arith_dotdot,
    ACTIONS(17945), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(16829), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454859] = 9,
    ACTIONS(1374), 1,
      sym__conid,
    ACTIONS(1677), 1,
      sym__varid,
    STATE(3543), 1,
      sym_variable,
    STATE(3993), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454891] = 9,
    ACTIONS(17947), 1,
      anon_sym_RBRACK,
    ACTIONS(17949), 1,
      anon_sym_PIPE,
    ACTIONS(17951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17953), 1,
      sym__arith_dotdot,
    ACTIONS(17955), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(15633), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454923] = 9,
    ACTIONS(8809), 1,
      sym__varid,
    ACTIONS(8823), 1,
      sym__conid,
    STATE(9577), 1,
      sym_constructor,
    STATE(9601), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [454955] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17696), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [454973] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15455), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [454991] = 4,
    ACTIONS(11106), 1,
      anon_sym_LBRACE,
    STATE(13176), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [455013] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [455031] = 4,
    STATE(12596), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(17957), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17959), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [455053] = 9,
    ACTIONS(173), 1,
      sym__conid,
    ACTIONS(3014), 1,
      sym__varid,
    STATE(3862), 1,
      sym_constructor,
    STATE(4630), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455085] = 9,
    ACTIONS(1390), 1,
      sym__varid,
    ACTIONS(1402), 1,
      sym__conid,
    STATE(3823), 1,
      sym_constructor,
    STATE(3859), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455117] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16063), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [455135] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 9,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_DOT_DOT,
  [455153] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16079), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [455171] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [455189] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16075), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [455207] = 9,
    ACTIONS(2945), 1,
      sym__varid,
    ACTIONS(4171), 1,
      sym__conid,
    STATE(5405), 1,
      sym_constructor,
    STATE(5573), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455239] = 4,
    STATE(13279), 1,
      sym_calling_convention,
    STATE(13869), 1,
      sym__foreign_pre,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17869), 7,
      anon_sym_ccall,
      anon_sym_stdcall,
      anon_sym_cplusplus,
      anon_sym_jvm,
      anon_sym_dotnet,
      anon_sym_prim,
      anon_sym_capi,
  [455261] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15451), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [455279] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [455297] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [455315] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [455333] = 3,
    ACTIONS(14712), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [455353] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [455371] = 4,
    STATE(13279), 1,
      sym_calling_convention,
    STATE(13870), 1,
      sym__foreign_pre,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17869), 7,
      anon_sym_ccall,
      anon_sym_stdcall,
      anon_sym_cplusplus,
      anon_sym_jvm,
      anon_sym_dotnet,
      anon_sym_prim,
      anon_sym_capi,
  [455393] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16121), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [455411] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16125), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [455429] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [455447] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15459), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [455465] = 9,
    ACTIONS(17962), 1,
      anon_sym_RBRACK,
    ACTIONS(17964), 1,
      anon_sym_PIPE,
    ACTIONS(17966), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17968), 1,
      sym__arith_dotdot,
    ACTIONS(17970), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(16092), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455497] = 9,
    ACTIONS(9086), 1,
      sym__varid,
    ACTIONS(9100), 1,
      sym__conid,
    STATE(10485), 1,
      sym_constructor,
    STATE(11020), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455529] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(17974), 1,
      sym_where,
    STATE(19716), 1,
      sym_guards,
    STATE(12634), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17972), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [455555] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(17976), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2510), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(15932), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455581] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 9,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [455599] = 9,
    ACTIONS(17978), 1,
      anon_sym_RBRACK,
    ACTIONS(17980), 1,
      anon_sym_PIPE,
    ACTIONS(17982), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17984), 1,
      sym__arith_dotdot,
    ACTIONS(17986), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(17099), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455631] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15465), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [455649] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [455667] = 9,
    ACTIONS(895), 1,
      sym__conid,
    ACTIONS(3014), 1,
      sym__varid,
    STATE(3895), 1,
      sym_constructor,
    STATE(4630), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455699] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [455717] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [455735] = 9,
    ACTIONS(2733), 1,
      sym__varid,
    ACTIONS(4073), 1,
      sym__conid,
    STATE(4651), 1,
      sym_constructor,
    STATE(5431), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455767] = 4,
    STATE(12629), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(17957), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17988), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [455789] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [455807] = 9,
    ACTIONS(9156), 1,
      sym__varid,
    ACTIONS(9170), 1,
      sym__conid,
    STATE(10763), 1,
      sym_constructor,
    STATE(11503), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455839] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [455859] = 4,
    STATE(12629), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(17905), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17875), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [455881] = 5,
    ACTIONS(17993), 1,
      anon_sym_PIPE,
    STATE(19716), 1,
      sym_guards,
    STATE(12634), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17991), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [455905] = 9,
    ACTIONS(2080), 1,
      sym__varid,
    ACTIONS(4055), 1,
      sym__conid,
    STATE(4309), 1,
      sym_constructor,
    STATE(4451), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455937] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15477), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [455955] = 9,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17996), 1,
      anon_sym_LPAREN,
    ACTIONS(17998), 1,
      sym__conid,
    STATE(11085), 1,
      sym_constructor,
    STATE(12089), 1,
      sym_tyfam_head,
    STATE(13047), 1,
      sym__simpletype_infix,
    STATE(13231), 1,
      sym__simpletype,
    STATE(13727), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [455987] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 7,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [456007] = 9,
    ACTIONS(18000), 1,
      anon_sym_RBRACK,
    ACTIONS(18002), 1,
      anon_sym_PIPE,
    ACTIONS(18004), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18006), 1,
      sym__arith_dotdot,
    ACTIONS(18008), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(15473), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456039] = 9,
    ACTIONS(8922), 1,
      sym__varid,
    ACTIONS(8936), 1,
      sym__conid,
    STATE(10306), 1,
      sym_constructor,
    STATE(10823), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456071] = 9,
    ACTIONS(8956), 1,
      sym__varid,
    ACTIONS(8970), 1,
      sym__conid,
    STATE(10862), 1,
      sym_constructor,
    STATE(11619), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456103] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [456121] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [456139] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [456157] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [456177] = 9,
    ACTIONS(18010), 1,
      anon_sym_RBRACK,
    ACTIONS(18012), 1,
      anon_sym_PIPE,
    ACTIONS(18014), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18016), 1,
      sym__arith_dotdot,
    ACTIONS(18018), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(16593), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456209] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15489), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [456227] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16132), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [456245] = 9,
    ACTIONS(1677), 1,
      sym__varid,
    ACTIONS(1698), 1,
      sym__conid,
    STATE(3477), 1,
      sym_constructor,
    STATE(3543), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456277] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16142), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [456295] = 9,
    ACTIONS(23), 1,
      sym__conid,
    ACTIONS(2945), 1,
      sym__varid,
    STATE(3888), 1,
      sym_constructor,
    STATE(5573), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456327] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [456345] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [456363] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 8,
      sym__layout_semicolon,
      sym__dot,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [456383] = 9,
    ACTIONS(9120), 1,
      sym__varid,
    ACTIONS(9134), 1,
      sym__conid,
    STATE(10183), 1,
      sym_constructor,
    STATE(10653), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456415] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15447), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [456433] = 9,
    ACTIONS(2603), 1,
      sym__varid,
    ACTIONS(4081), 1,
      sym__conid,
    STATE(4562), 1,
      sym_constructor,
    STATE(5290), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456465] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [456485] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [456503] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [456523] = 9,
    ACTIONS(4359), 1,
      sym__varid,
    ACTIONS(4373), 1,
      sym__conid,
    STATE(10118), 1,
      sym_constructor,
    STATE(10421), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456555] = 9,
    ACTIONS(4507), 1,
      sym__varid,
    ACTIONS(4519), 1,
      sym__conid,
    STATE(10128), 1,
      sym_constructor,
    STATE(10401), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456587] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15493), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [456605] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [456625] = 9,
    ACTIONS(3041), 1,
      sym__varid,
    ACTIONS(3051), 1,
      sym__conid,
    STATE(4358), 1,
      sym_constructor,
    STATE(5041), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456657] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 9,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_deriving,
  [456675] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 8,
      sym__dot,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [456695] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [456713] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15513), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [456731] = 9,
    ACTIONS(4095), 1,
      sym__varid,
    ACTIONS(4111), 1,
      sym__conid,
    STATE(9480), 1,
      sym_constructor,
    STATE(9561), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456763] = 9,
    ACTIONS(4529), 1,
      sym__varid,
    ACTIONS(4541), 1,
      sym__conid,
    STATE(9224), 1,
      sym_constructor,
    STATE(9253), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456795] = 9,
    ACTIONS(18020), 1,
      anon_sym_RBRACK,
    ACTIONS(18022), 1,
      anon_sym_PIPE,
    ACTIONS(18024), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18026), 1,
      sym__arith_dotdot,
    ACTIONS(18028), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(15804), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456827] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 7,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PERCENT,
      anon_sym_RBRACE,
  [456847] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(18030), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2548), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(15932), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456873] = 4,
    ACTIONS(11145), 1,
      anon_sym_LBRACE,
    STATE(13205), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [456895] = 9,
    ACTIONS(2660), 1,
      sym__varid,
    ACTIONS(4193), 1,
      sym__conid,
    STATE(4549), 1,
      sym_constructor,
    STATE(5067), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456927] = 9,
    ACTIONS(4359), 1,
      sym__varid,
    ACTIONS(4519), 1,
      sym__conid,
    STATE(10128), 1,
      sym_constructor,
    STATE(10421), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [456959] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [456977] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [456997] = 3,
    ACTIONS(14738), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [457017] = 9,
    ACTIONS(1745), 1,
      sym__varid,
    ACTIONS(1753), 1,
      sym__conid,
    STATE(4268), 1,
      sym_constructor,
    STATE(4526), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457049] = 9,
    ACTIONS(4309), 1,
      sym__varid,
    ACTIONS(4407), 1,
      sym__conid,
    STATE(9375), 1,
      sym_variable,
    STATE(10208), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457081] = 5,
    STATE(2441), 1,
      sym__colon2,
    STATE(14363), 1,
      sym__type_annotation,
    ACTIONS(15726), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18032), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
  [457105] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15493), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [457123] = 9,
    ACTIONS(4309), 1,
      sym__varid,
    ACTIONS(4541), 1,
      sym__conid,
    STATE(9224), 1,
      sym_constructor,
    STATE(9375), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457155] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [457177] = 8,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12830), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20197), 1,
      sym__modid,
    STATE(19778), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457207] = 9,
    ACTIONS(2407), 1,
      sym__varid,
    ACTIONS(4211), 1,
      sym__conid,
    STATE(4334), 1,
      sym_constructor,
    STATE(4757), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457239] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [457257] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15513), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [457275] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [457293] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [457311] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [457329] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [457347] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15451), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [457365] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [457383] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15455), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [457401] = 9,
    ACTIONS(1183), 1,
      sym__conid,
    ACTIONS(2895), 1,
      sym__varid,
    STATE(3912), 1,
      sym_constructor,
    STATE(4979), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457433] = 9,
    ACTIONS(2783), 1,
      sym__varid,
    ACTIONS(4143), 1,
      sym__conid,
    STATE(4322), 1,
      sym_constructor,
    STATE(4759), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457465] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15473), 9,
      sym__varsym,
      sym__consym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [457483] = 9,
    ACTIONS(9272), 1,
      sym__varid,
    ACTIONS(9286), 1,
      sym__conid,
    STATE(10403), 1,
      sym_constructor,
    STATE(11157), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457515] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [457533] = 9,
    ACTIONS(18034), 1,
      anon_sym_RBRACK,
    ACTIONS(18036), 1,
      anon_sym_PIPE,
    ACTIONS(18038), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18040), 1,
      sym__arith_dotdot,
    ACTIONS(18042), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(15984), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457565] = 4,
    STATE(12596), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(17873), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17907), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [457587] = 9,
    ACTIONS(2973), 1,
      sym__varid,
    ACTIONS(4153), 1,
      sym__conid,
    STATE(5306), 1,
      sym_constructor,
    STATE(5671), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457619] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 7,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [457639] = 4,
    STATE(12596), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(17881), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17907), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [457661] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16152), 9,
      sym__varsym,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [457679] = 9,
    ACTIONS(16250), 1,
      sym__varid,
    ACTIONS(17664), 1,
      anon_sym_LPAREN,
    ACTIONS(17668), 1,
      sym__conid,
    STATE(14294), 1,
      sym_namespace,
    STATE(15206), 1,
      sym_constructor,
    STATE(18277), 1,
      sym_import_item,
    STATE(18395), 1,
      sym_variable,
    ACTIONS(16256), 2,
      anon_sym_type,
      anon_sym_pattern,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457711] = 5,
    STATE(2434), 1,
      sym__colon2,
    STATE(13983), 1,
      sym__type_annotation,
    ACTIONS(15742), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18032), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
  [457735] = 9,
    ACTIONS(18044), 1,
      anon_sym_RBRACK,
    ACTIONS(18046), 1,
      anon_sym_PIPE,
    ACTIONS(18048), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18050), 1,
      sym__arith_dotdot,
    ACTIONS(18052), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    STATE(16171), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457767] = 9,
    ACTIONS(2529), 1,
      sym__varid,
    ACTIONS(4243), 1,
      sym__conid,
    STATE(4212), 1,
      sym_constructor,
    STATE(4491), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457799] = 9,
    ACTIONS(2350), 1,
      sym__varid,
    ACTIONS(4177), 1,
      sym__conid,
    STATE(4215), 1,
      sym_constructor,
    STATE(4818), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457831] = 9,
    ACTIONS(8775), 1,
      sym__varid,
    ACTIONS(8789), 1,
      sym__conid,
    STATE(10166), 1,
      sym_constructor,
    STATE(10434), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457863] = 5,
    STATE(2441), 1,
      sym__colon2,
    STATE(14458), 1,
      sym__type_annotation,
    ACTIONS(15726), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17871), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
  [457887] = 9,
    ACTIONS(4111), 1,
      sym__conid,
    ACTIONS(4309), 1,
      sym__varid,
    STATE(9375), 1,
      sym_variable,
    STATE(9480), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457919] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [457941] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [457959] = 9,
    ACTIONS(4551), 1,
      sym__varid,
    ACTIONS(4565), 1,
      sym__conid,
    STATE(10230), 1,
      sym_constructor,
    STATE(10528), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [457991] = 4,
    ACTIONS(11017), 1,
      anon_sym_LBRACE,
    STATE(13291), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [458013] = 8,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(12830), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20197), 1,
      sym__modid,
    STATE(19790), 3,
      sym_operator,
      sym__minus,
      sym_qualified_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458043] = 9,
    ACTIONS(549), 1,
      sym__conid,
    ACTIONS(1745), 1,
      sym__varid,
    STATE(3866), 1,
      sym_constructor,
    STATE(4526), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458075] = 4,
    ACTIONS(10846), 1,
      anon_sym_LBRACE,
    STATE(13238), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [458097] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [458115] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 9,
      sym__consym,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [458133] = 9,
    ACTIONS(8711), 1,
      sym__varid,
    ACTIONS(8725), 1,
      sym__conid,
    STATE(10614), 1,
      sym_constructor,
    STATE(11349), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(18077), 1,
      sym__do_keyword,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17026), 2,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458165] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15451), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [458182] = 7,
    ACTIONS(17387), 1,
      anon_sym_DASH,
    ACTIONS(17391), 1,
      sym__varsym,
    ACTIONS(17393), 1,
      sym__consym,
    ACTIONS(18054), 1,
      anon_sym_BQUOTE,
    STATE(14526), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(15306), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458209] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 8,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [458226] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [458245] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18058), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20664), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458274] = 8,
    ACTIONS(16632), 1,
      sym_where,
    ACTIONS(18060), 1,
      anon_sym_EQ,
    STATE(2377), 1,
      sym__colon2,
    STATE(15734), 1,
      sym__gadt_rhs,
    STATE(15740), 1,
      sym__newtype,
    STATE(18146), 1,
      sym__type_annotation,
    ACTIONS(15962), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458303] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18062), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19856), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458332] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18064), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20661), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458361] = 3,
    ACTIONS(18066), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [458380] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18068), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20201), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458409] = 5,
    ACTIONS(16570), 1,
      anon_sym_EQ,
    ACTIONS(16574), 1,
      sym_where,
    ACTIONS(18070), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(16382), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458432] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 7,
      sym__layout_semicolon,
      sym__dot,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [458451] = 3,
    ACTIONS(18074), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18072), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [458470] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18076), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20658), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458499] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18078), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20655), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458528] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18080), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20652), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458557] = 8,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(18082), 1,
      anon_sym_LPAREN,
    ACTIONS(18084), 1,
      sym__conid,
    STATE(12267), 1,
      sym_constructor,
    STATE(13217), 1,
      sym__simpletype,
    STATE(14544), 1,
      sym__simpletype_infix,
    STATE(13657), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458586] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18088), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16285), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458615] = 8,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17933), 1,
      anon_sym_LPAREN,
    ACTIONS(17935), 1,
      sym__conid,
    STATE(10234), 1,
      sym__simpletype,
    STATE(11492), 1,
      sym_constructor,
    STATE(12791), 1,
      sym__simpletype_infix,
    STATE(13554), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458644] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18090), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20648), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458673] = 7,
    ACTIONS(17338), 1,
      anon_sym_DASH,
    ACTIONS(17342), 1,
      sym__varsym,
    ACTIONS(17344), 1,
      sym__consym,
    ACTIONS(18092), 1,
      anon_sym_BQUOTE,
    STATE(15160), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(15332), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458700] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18094), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20045), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458729] = 4,
    ACTIONS(17957), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(12749), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18096), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [458750] = 7,
    ACTIONS(17338), 1,
      anon_sym_DASH,
    ACTIONS(17342), 1,
      sym__varsym,
    ACTIONS(17344), 1,
      sym__consym,
    ACTIONS(18099), 1,
      anon_sym_BQUOTE,
    STATE(14288), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(15332), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458777] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18101), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20644), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458806] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [458823] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15513), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [458840] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [458857] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18103), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20640), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458886] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [458905] = 7,
    ACTIONS(17316), 1,
      anon_sym_DASH,
    ACTIONS(17320), 1,
      sym__varsym,
    ACTIONS(17322), 1,
      sym__consym,
    ACTIONS(18105), 1,
      anon_sym_BQUOTE,
    STATE(14199), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(14755), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458932] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(18020), 1,
      sym_constructor,
    STATE(20741), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [458961] = 5,
    STATE(2377), 1,
      sym__colon2,
    STATE(14825), 1,
      sym__type_annotation,
    ACTIONS(15962), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18032), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [458984] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18107), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20636), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459013] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18109), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20028), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459042] = 5,
    ACTIONS(16570), 1,
      anon_sym_EQ,
    ACTIONS(16574), 1,
      sym_where,
    ACTIONS(18111), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(17204), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459065] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18113), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20215), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459094] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(15932), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(18115), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2573), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459119] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [459136] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17885), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20931), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459165] = 7,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    ACTIONS(18123), 1,
      anon_sym_qualified,
    ACTIONS(18125), 1,
      anon_sym_as,
    STATE(16397), 1,
      sym_import_list,
    ACTIONS(18117), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459192] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18127), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20632), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459221] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [459242] = 5,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(16254), 1,
      sym_guards,
    STATE(12770), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15978), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [459265] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18129), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20628), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459294] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17888), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20928), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459323] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18131), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20624), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459352] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18133), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15824), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459381] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18135), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20620), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459410] = 7,
    ACTIONS(18137), 1,
      anon_sym_PIPE,
    ACTIONS(18139), 1,
      sym_where,
    STATE(15416), 1,
      sym_fundeps,
    STATE(17836), 1,
      sym_class_body,
    ACTIONS(17841), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459437] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18141), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20616), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459466] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18143), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20229), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459495] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18145), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19838), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459524] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17894), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20925), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459553] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [459570] = 3,
    ACTIONS(14856), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [459589] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18147), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16185), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459618] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18149), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20612), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459647] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17696), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [459664] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18151), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20608), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459693] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18153), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20011), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459722] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [459743] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18155), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20604), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459772] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18157), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20243), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459801] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18159), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [459818] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6264), 8,
      sym__layout_semicolon,
      sym__dot,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [459835] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18161), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20187), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459864] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18163), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20600), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459893] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18165), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20257), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459922] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(18251), 1,
      sym_constructor,
    STATE(20186), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20193), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459951] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18167), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19820), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [459980] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [459999] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18169), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20596), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460028] = 8,
    ACTIONS(17431), 1,
      anon_sym_LPAREN,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(17487), 1,
      sym__varid,
    STATE(12166), 1,
      sym_constructor,
    STATE(13496), 1,
      sym__simpletype,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(13778), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460057] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17911), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20901), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460086] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 8,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
      anon_sym_AT2,
  [460103] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15501), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [460120] = 8,
    ACTIONS(17431), 1,
      anon_sym_LPAREN,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(17487), 1,
      sym__varid,
    STATE(12166), 1,
      sym_constructor,
    STATE(13495), 1,
      sym__simpletype,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(13778), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460149] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18171), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20271), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460178] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [460199] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18173), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(15913), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460228] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [460247] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17897), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20922), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460276] = 7,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    ACTIONS(18177), 1,
      anon_sym_qualified,
    ACTIONS(18179), 1,
      anon_sym_as,
    STATE(16662), 1,
      sym_import_list,
    ACTIONS(18175), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460303] = 4,
    ACTIONS(18181), 1,
      sym__varid,
    STATE(12890), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18183), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
  [460324] = 5,
    ACTIONS(17993), 1,
      anon_sym_PIPE,
    STATE(19562), 1,
      sym_guards,
    STATE(12812), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17991), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [460347] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18185), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20667), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460376] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17899), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20919), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460405] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18187), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20592), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460434] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18189), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19874), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460463] = 4,
    ACTIONS(17881), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(12749), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18191), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [460484] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17900), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20916), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460513] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18193), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19994), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460542] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18195), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20588), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460571] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18197), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20285), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460600] = 7,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    STATE(1556), 1,
      sym__arrow,
    STATE(14876), 1,
      sym__alt_variants,
    STATE(16254), 1,
      sym_guards,
    ACTIONS(18199), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(13059), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460627] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17983), 1,
      sym_constructor,
    STATE(20801), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460656] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17903), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20913), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460685] = 4,
    ACTIONS(18201), 1,
      sym__varid,
    STATE(13036), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18183), 5,
      sym__layout_semicolon,
      sym_where,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [460706] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18203), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19798), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460735] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18205), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16007), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460764] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [460783] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15493), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [460800] = 8,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(13225), 1,
      sym_constructor,
    STATE(13887), 1,
      aux_sym__qualifying_module,
    STATE(20197), 1,
      sym__modid,
    STATE(19109), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460829] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18207), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20584), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460858] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(18209), 1,
      sym_where,
    STATE(20581), 1,
      sym_guards,
    STATE(12894), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(17972), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460883] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18211), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20580), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460912] = 7,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    ACTIONS(18215), 1,
      anon_sym_qualified,
    ACTIONS(18217), 1,
      anon_sym_as,
    STATE(16200), 1,
      sym_import_list,
    ACTIONS(18213), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460939] = 8,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18219), 1,
      anon_sym_SEMI,
    ACTIONS(18221), 1,
      anon_sym_LPAREN,
    ACTIONS(18223), 1,
      anon_sym_RBRACE,
    STATE(14737), 1,
      sym_constructor,
    STATE(15543), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460968] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18225), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20576), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [460997] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17880), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20937), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461026] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [461045] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [461066] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17931), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20880), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461095] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18227), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20572), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461124] = 5,
    STATE(2377), 1,
      sym__colon2,
    STATE(14848), 1,
      sym__type_annotation,
    ACTIONS(15962), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17893), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [461147] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18229), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19776), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461176] = 8,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17929), 1,
      anon_sym_LPAREN,
    ACTIONS(17931), 1,
      sym__conid,
    STATE(11788), 1,
      sym_constructor,
    STATE(13366), 1,
      sym__simpletype_infix,
    STATE(15049), 1,
      sym__simpletype,
    STATE(13623), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461205] = 7,
    ACTIONS(17799), 1,
      anon_sym_in,
    ACTIONS(18231), 1,
      anon_sym_LBRACE,
    ACTIONS(18233), 1,
      sym__layout_start,
    STATE(16426), 1,
      sym_decls,
    STATE(20711), 1,
      sym__let_decls,
    ACTIONS(17795), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461232] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18235), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19892), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461261] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 8,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [461278] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18237), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20299), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461307] = 7,
    ACTIONS(17316), 1,
      anon_sym_DASH,
    ACTIONS(17320), 1,
      sym__varsym,
    ACTIONS(17322), 1,
      sym__consym,
    ACTIONS(18239), 1,
      anon_sym_BQUOTE,
    STATE(14642), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(14755), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461334] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(18030), 1,
      sym_constructor,
    STATE(20727), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461363] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18241), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20670), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461392] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17999), 1,
      sym_constructor,
    STATE(20774), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461421] = 4,
    ACTIONS(17873), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(12749), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18191), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [461442] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17994), 1,
      sym_constructor,
    STATE(20781), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461471] = 8,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18221), 1,
      anon_sym_LPAREN,
    ACTIONS(18243), 1,
      anon_sym_SEMI,
    ACTIONS(18245), 1,
      anon_sym_RBRACE,
    STATE(14737), 1,
      sym_constructor,
    STATE(16734), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461500] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17990), 1,
      sym_constructor,
    STATE(20788), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461529] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18247), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15817), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461558] = 7,
    ACTIONS(17712), 1,
      sym__consym,
    ACTIONS(17714), 1,
      sym__conid,
    STATE(12858), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20542), 1,
      sym__modid,
    ACTIONS(17710), 3,
      sym__varid,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461585] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18249), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20313), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461614] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17985), 1,
      sym_constructor,
    STATE(20795), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461643] = 7,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    ACTIONS(18253), 1,
      anon_sym_qualified,
    ACTIONS(18255), 1,
      anon_sym_as,
    STATE(16403), 1,
      sym_import_list,
    ACTIONS(18251), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461670] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17977), 1,
      sym_constructor,
    STATE(20807), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461699] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17972), 1,
      sym_constructor,
    STATE(20813), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461728] = 7,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(18257), 1,
      anon_sym_LPAREN,
    ACTIONS(18259), 1,
      anon_sym_RPAREN,
    ACTIONS(18261), 1,
      anon_sym_DOT_DOT,
    STATE(17523), 3,
      sym_variable,
      sym_constructor,
      sym__name,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461755] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_via,
      anon_sym_deriving,
  [461774] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18263), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20173), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461803] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17970), 1,
      sym_constructor,
    STATE(20819), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461832] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18265), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20673), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461861] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17927), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20883), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461890] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17966), 1,
      sym_constructor,
    STATE(20825), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461919] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18267), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19754), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461948] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17962), 1,
      sym_constructor,
    STATE(20831), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [461977] = 3,
    ACTIONS(14856), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [461996] = 3,
    ACTIONS(15016), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [462015] = 4,
    ACTIONS(11524), 1,
      anon_sym_LBRACE,
    STATE(13736), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [462036] = 3,
    ACTIONS(14738), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 6,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
  [462055] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [462072] = 7,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    ACTIONS(18273), 1,
      anon_sym_qualified,
    ACTIONS(18275), 1,
      anon_sym_as,
    STATE(15716), 1,
      sym_import_list,
    ACTIONS(18175), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462099] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18277), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20676), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462128] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17957), 1,
      sym_constructor,
    STATE(20837), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462157] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18279), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [462174] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(18281), 1,
      sym_where,
    STATE(19685), 1,
      sym_guards,
    STATE(12993), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(17972), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462199] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18283), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20159), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462228] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [462245] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [462264] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17925), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20886), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462293] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17955), 1,
      sym_constructor,
    STATE(20843), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462322] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17952), 1,
      sym_constructor,
    STATE(20849), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462351] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18285), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19909), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462380] = 4,
    ACTIONS(18287), 1,
      sym__varid,
    STATE(12890), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18290), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
  [462401] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18292), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [462418] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18294), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20327), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462447] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18292), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [462464] = 5,
    ACTIONS(17993), 1,
      anon_sym_PIPE,
    STATE(20581), 1,
      sym_guards,
    STATE(12894), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17991), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [462487] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18296), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19977), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462516] = 7,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    STATE(1631), 1,
      sym__arrow,
    STATE(16224), 1,
      sym__alt_variants,
    STATE(16342), 1,
      sym_guards,
    ACTIONS(18298), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(13124), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462543] = 3,
    ACTIONS(13680), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 7,
      sym__dot,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [462562] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18300), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20145), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462591] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18302), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20564), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462620] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 6,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [462639] = 8,
    ACTIONS(13654), 1,
      sym__conid,
    ACTIONS(18304), 1,
      sym_string,
    ACTIONS(18306), 1,
      anon_sym_qualified,
    STATE(12739), 1,
      sym__modid,
    STATE(13071), 1,
      sym_constructor,
    STATE(15144), 1,
      aux_sym__qualifying_module,
    STATE(12810), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462668] = 6,
    ACTIONS(18308), 1,
      anon_sym_instance,
    ACTIONS(18310), 1,
      anon_sym_via,
    STATE(16796), 1,
      sym__instance,
    STATE(17965), 2,
      sym_via,
      sym_deriving_strategy,
    ACTIONS(17694), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462693] = 7,
    ACTIONS(17379), 1,
      anon_sym_DASH,
    ACTIONS(17383), 1,
      sym__varsym,
    ACTIONS(17385), 1,
      sym__consym,
    ACTIONS(18312), 1,
      anon_sym_BQUOTE,
    STATE(14329), 2,
      sym_operator,
      sym__minus,
    STATE(14488), 2,
      sym_varop,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462720] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17948), 1,
      sym_constructor,
    STATE(20855), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462749] = 7,
    ACTIONS(17379), 1,
      anon_sym_DASH,
    ACTIONS(17383), 1,
      sym__varsym,
    ACTIONS(17385), 1,
      sym__consym,
    ACTIONS(18314), 1,
      anon_sym_BQUOTE,
    STATE(13784), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(14329), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462776] = 3,
    ACTIONS(18316), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [462795] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18318), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(17145), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462824] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [462841] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [462858] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [462875] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [462892] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18320), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20560), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462921] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18322), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20131), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462950] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18324), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19730), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [462979] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17907), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20910), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463008] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18326), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20679), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463037] = 6,
    ACTIONS(17714), 1,
      sym__conid,
    STATE(12917), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20070), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17712), 4,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      anon_sym_DASH,
  [463062] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18328), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20341), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463091] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18330), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19926), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463120] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [463137] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18332), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20117), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463166] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18334), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20556), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463195] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18336), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20552), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463224] = 5,
    ACTIONS(16628), 1,
      anon_sym_EQ,
    ACTIONS(16632), 1,
      sym_where,
    ACTIONS(18070), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    STATE(16120), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463247] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [463264] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(18011), 1,
      sym_constructor,
    STATE(20752), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463293] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [463310] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17944), 1,
      sym_constructor,
    STATE(20861), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463339] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18338), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16107), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463368] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17939), 1,
      sym_constructor,
    STATE(20867), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463397] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18340), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16627), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463426] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17933), 1,
      sym_constructor,
    STATE(20873), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463455] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18342), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20355), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463484] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18344), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20103), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463513] = 3,
    ACTIONS(18074), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18072), 7,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [463532] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [463551] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17932), 1,
      sym_constructor,
    STATE(20877), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463580] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17908), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20907), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463609] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15477), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [463626] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 8,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_AT2,
  [463643] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18346), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20368), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463672] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18279), 8,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [463689] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15473), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [463706] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15455), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [463723] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18348), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20847), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463752] = 7,
    ACTIONS(17409), 1,
      anon_sym_DASH,
    ACTIONS(17413), 1,
      sym__varsym,
    ACTIONS(17415), 1,
      sym__consym,
    ACTIONS(18350), 1,
      anon_sym_BQUOTE,
    STATE(15411), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(16663), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463779] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [463796] = 7,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    ACTIONS(18352), 1,
      sym__tyconsym,
    STATE(19573), 2,
      sym_constructor_operator,
      sym__type_operator,
    STATE(19576), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463823] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17919), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20892), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463852] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18354), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20380), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463881] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17915), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20895), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463910] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18356), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19704), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463939] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18358), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20384), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463968] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18360), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20388), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [463997] = 7,
    ACTIONS(17387), 1,
      anon_sym_DASH,
    ACTIONS(17391), 1,
      sym__varsym,
    ACTIONS(17393), 1,
      sym__consym,
    ACTIONS(18362), 1,
      anon_sym_BQUOTE,
    STATE(14867), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(15306), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464024] = 4,
    ACTIONS(11860), 1,
      anon_sym_LBRACE,
    STATE(13697), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [464045] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18364), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20682), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464074] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18366), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20392), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464103] = 7,
    ACTIONS(17409), 1,
      anon_sym_DASH,
    ACTIONS(17413), 1,
      sym__varsym,
    ACTIONS(17415), 1,
      sym__consym,
    ACTIONS(18368), 1,
      anon_sym_BQUOTE,
    STATE(15799), 2,
      sym_varop,
      sym_constructor_operator,
    STATE(16663), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464130] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18370), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20396), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464159] = 3,
    ACTIONS(18074), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18372), 7,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [464178] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18374), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20685), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464207] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [464224] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18376), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20688), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464253] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18378), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20691), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464282] = 7,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    ACTIONS(18380), 1,
      anon_sym_qualified,
    ACTIONS(18382), 1,
      anon_sym_as,
    STATE(16057), 1,
      sym_import_list,
    ACTIONS(18117), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464309] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18384), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20400), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464338] = 7,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    ACTIONS(18386), 1,
      anon_sym_qualified,
    ACTIONS(18388), 1,
      anon_sym_as,
    STATE(16046), 1,
      sym_import_list,
    ACTIONS(18251), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464365] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18390), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20694), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464394] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18392), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20404), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464423] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18394), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20408), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464452] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(15932), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(18396), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2590), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464477] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18398), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20412), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464506] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18400), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20697), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464535] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18402), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20700), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464564] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18404), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(17051), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464593] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18406), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20416), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464622] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17877), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20943), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464651] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18408), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20703), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464680] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15447), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [464697] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15489), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [464714] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18410), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(17315), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464743] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18412), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19673), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464772] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18414), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20706), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464801] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18416), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20709), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464830] = 8,
    ACTIONS(16574), 1,
      sym_where,
    ACTIONS(18418), 1,
      anon_sym_EQ,
    STATE(2377), 1,
      sym__colon2,
    STATE(16653), 1,
      sym__newtype,
    STATE(16655), 1,
      sym__gadt_rhs,
    STATE(18798), 1,
      sym__type_annotation,
    ACTIONS(15962), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464859] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18420), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20712), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464888] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18422), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20715), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464917] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18424), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20718), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464946] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18426), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20420), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [464975] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18428), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20721), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465004] = 8,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17863), 1,
      anon_sym_LPAREN,
    ACTIONS(17865), 1,
      sym__conid,
    STATE(12378), 1,
      sym_constructor,
    STATE(13381), 1,
      sym__simpletype,
    STATE(14079), 1,
      sym__simpletype_infix,
    STATE(13691), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465033] = 5,
    ACTIONS(17993), 1,
      anon_sym_PIPE,
    STATE(19685), 1,
      sym_guards,
    STATE(12993), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17991), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [465056] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18430), 1,
      sym_string,
    ACTIONS(18432), 1,
      anon_sym_qualified,
    STATE(13158), 1,
      sym__modid,
    STATE(13225), 1,
      sym_constructor,
    STATE(15293), 1,
      aux_sym__qualifying_module,
    STATE(13372), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465085] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17913), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20898), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465114] = 6,
    ACTIONS(18310), 1,
      anon_sym_via,
    ACTIONS(18434), 1,
      anon_sym_instance,
    STATE(18081), 1,
      sym__instance,
    STATE(18097), 2,
      sym_via,
      sym_deriving_strategy,
    ACTIONS(17694), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465139] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18436), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20548), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465168] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17922), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20889), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465197] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18438), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20544), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465226] = 8,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17996), 1,
      anon_sym_LPAREN,
    ACTIONS(17998), 1,
      sym__conid,
    STATE(10117), 1,
      sym__simpletype,
    STATE(11085), 1,
      sym_constructor,
    STATE(13047), 1,
      sym__simpletype_infix,
    STATE(13727), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465255] = 8,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17863), 1,
      anon_sym_LPAREN,
    ACTIONS(17865), 1,
      sym__conid,
    STATE(12378), 1,
      sym_constructor,
    STATE(13213), 1,
      sym__simpletype,
    STATE(14079), 1,
      sym__simpletype_infix,
    STATE(13691), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465284] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18440), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19943), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465313] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18442), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20540), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465342] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18444), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20089), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465371] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 8,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
      anon_sym_in,
  [465388] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18446), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20536), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465417] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(18004), 1,
      sym_constructor,
    STATE(20767), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465446] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17909), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20904), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465475] = 8,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18221), 1,
      anon_sym_LPAREN,
    ACTIONS(18448), 1,
      anon_sym_SEMI,
    ACTIONS(18450), 1,
      anon_sym_RBRACE,
    STATE(14737), 1,
      sym_constructor,
    STATE(15712), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465504] = 8,
    ACTIONS(13558), 1,
      sym__conid,
    ACTIONS(18452), 1,
      sym_string,
    ACTIONS(18454), 1,
      anon_sym_qualified,
    STATE(12792), 1,
      sym_constructor,
    STATE(12935), 1,
      sym__modid,
    STATE(14692), 1,
      aux_sym__qualifying_module,
    STATE(12878), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465533] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18456), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20532), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465562] = 6,
    ACTIONS(18310), 1,
      anon_sym_via,
    ACTIONS(18458), 1,
      anon_sym_instance,
    STATE(15532), 1,
      sym__instance,
    STATE(18049), 2,
      sym_via,
      sym_deriving_strategy,
    ACTIONS(17694), 3,
      anon_sym_stock,
      anon_sym_newtype,
      anon_sym_anyclass,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465587] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18460), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20528), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465616] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15437), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [465633] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18462), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15487), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465662] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [465679] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18464), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20424), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465708] = 6,
    ACTIONS(15938), 1,
      anon_sym_PERCENT,
    STATE(15994), 1,
      sym_modifier,
    ACTIONS(15932), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(18466), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(2620), 2,
      sym__arrow,
      sym__fun_arrow,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465733] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18468), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20428), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465762] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18470), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20432), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465791] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [465812] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [465829] = 7,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    ACTIONS(18472), 1,
      anon_sym_qualified,
    ACTIONS(18474), 1,
      anon_sym_as,
    STATE(16360), 1,
      sym_import_list,
    ACTIONS(18213), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465856] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18476), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20436), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465885] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [465904] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15441), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [465921] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18478), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20440), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465950] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18480), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20524), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [465979] = 3,
    ACTIONS(14856), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [465998] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(18007), 1,
      sym_constructor,
    STATE(20760), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466027] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18482), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20444), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466056] = 4,
    ACTIONS(11575), 1,
      anon_sym_LBRACE,
    STATE(13861), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [466077] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(18484), 1,
      sym_where,
    STATE(19562), 1,
      sym_guards,
    STATE(12812), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(17972), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466102] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18486), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20568), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466131] = 3,
    ACTIONS(18488), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [466150] = 4,
    ACTIONS(18490), 1,
      sym__varid,
    STATE(13036), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18290), 5,
      sym__layout_semicolon,
      sym_where,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [466171] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18493), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20520), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466200] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18495), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20448), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466229] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13715), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [466250] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18497), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20452), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466279] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18499), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19960), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466308] = 5,
    ACTIONS(13614), 1,
      sym__varid,
    ACTIONS(17560), 1,
      anon_sym_LPAREN,
    ACTIONS(18501), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    STATE(10718), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466331] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [466348] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [466365] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18503), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20061), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466394] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18505), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20456), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466423] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18159), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_deriving,
  [466440] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18507), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20460), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466469] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18509), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20464), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466498] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18511), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466527] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(18089), 1,
      sym_constructor,
    STATE(20537), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466556] = 8,
    ACTIONS(17226), 1,
      sym_where,
    ACTIONS(18513), 1,
      anon_sym_EQ,
    STATE(2377), 1,
      sym__colon2,
    STATE(17926), 1,
      sym__newtype,
    STATE(17938), 1,
      sym__gadt_rhs,
    STATE(18022), 1,
      sym__type_annotation,
    ACTIONS(15962), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466585] = 5,
    STATE(2399), 1,
      sym__colon2,
    STATE(14640), 1,
      sym__type_annotation,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17475), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [466608] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 6,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [466627] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18515), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20468), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466656] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18517), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20516), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466685] = 8,
    ACTIONS(17431), 1,
      anon_sym_LPAREN,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(17487), 1,
      sym__varid,
    STATE(12166), 1,
      sym_constructor,
    STATE(13408), 1,
      sym__simpletype,
    STATE(13780), 1,
      sym__simpletype_infix,
    STATE(13778), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466714] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [466731] = 5,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    STATE(16254), 1,
      sym_guards,
    STATE(12770), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18519), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [466754] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [466771] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18521), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20075), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466800] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18523), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(19623), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466829] = 5,
    STATE(2377), 1,
      sym__colon2,
    STATE(14756), 1,
      sym__type_annotation,
    ACTIONS(15962), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17871), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [466852] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18525), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20472), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466881] = 8,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17929), 1,
      anon_sym_LPAREN,
    ACTIONS(17931), 1,
      sym__conid,
    STATE(10330), 1,
      sym__simpletype,
    STATE(11788), 1,
      sym_constructor,
    STATE(13366), 1,
      sym__simpletype_infix,
    STATE(13623), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466910] = 8,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17996), 1,
      anon_sym_LPAREN,
    ACTIONS(17998), 1,
      sym__conid,
    STATE(10078), 1,
      sym__simpletype,
    STATE(11085), 1,
      sym_constructor,
    STATE(13047), 1,
      sym__simpletype_infix,
    STATE(13727), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466939] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18527), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20476), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466968] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18529), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20512), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [466997] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18531), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20480), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467026] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18533), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15670), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467055] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6264), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [467072] = 5,
    ACTIONS(16570), 1,
      anon_sym_EQ,
    ACTIONS(16574), 1,
      sym_where,
    ACTIONS(18535), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    STATE(17767), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467095] = 8,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17863), 1,
      anon_sym_LPAREN,
    ACTIONS(17865), 1,
      sym__conid,
    STATE(12378), 1,
      sym_constructor,
    STATE(13135), 1,
      sym__simpletype,
    STATE(14079), 1,
      sym__simpletype_infix,
    STATE(13691), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467124] = 8,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17929), 1,
      anon_sym_LPAREN,
    ACTIONS(17931), 1,
      sym__conid,
    STATE(10536), 1,
      sym__simpletype,
    STATE(11788), 1,
      sym_constructor,
    STATE(13366), 1,
      sym__simpletype_infix,
    STATE(13623), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467153] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [467172] = 3,
    ACTIONS(18074), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18372), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [467191] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15459), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [467208] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17883), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20934), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467237] = 8,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18537), 1,
      sym__unboxed_close,
    STATE(551), 1,
      sym__arrow,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16880), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467266] = 3,
    ACTIONS(14856), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [467285] = 3,
    ACTIONS(14712), 2,
      sym__varid,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 6,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_LPAREN,
  [467304] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18539), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20484), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467333] = 4,
    ACTIONS(17905), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(12749), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18191), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [467354] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15465), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [467371] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18541), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20488), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467400] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [467419] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18543), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20492), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467448] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13923), 1,
      aux_sym__qualifying_module,
    STATE(17878), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    STATE(20940), 1,
      sym_qualified_constructor,
    STATE(20541), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467477] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 8,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [467494] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18545), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20496), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467523] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18547), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20508), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467552] = 7,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    ACTIONS(18549), 1,
      sym__tyconsym,
    STATE(20100), 2,
      sym_operator,
      sym__minus,
    STATE(20101), 2,
      sym_constructor_operator,
      sym__type_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467579] = 7,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(18551), 1,
      anon_sym_LPAREN,
    ACTIONS(18553), 1,
      anon_sym_RPAREN,
    ACTIONS(18555), 1,
      anon_sym_DOT_DOT,
    STATE(17434), 3,
      sym_variable,
      sym_constructor,
      sym__import_name,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467606] = 3,
    ACTIONS(14964), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [467625] = 3,
    ACTIONS(14856), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [467644] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18557), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20500), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467673] = 8,
    ACTIONS(17487), 1,
      sym__varid,
    ACTIONS(17933), 1,
      anon_sym_LPAREN,
    ACTIONS(17935), 1,
      sym__conid,
    STATE(10093), 1,
      sym__simpletype,
    STATE(11492), 1,
      sym_constructor,
    STATE(12791), 1,
      sym__simpletype_infix,
    STATE(13554), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467702] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    ACTIONS(18559), 1,
      sym_quasiquote_bar,
    STATE(13225), 1,
      sym_constructor,
    STATE(13771), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    STATE(20504), 2,
      sym_variable,
      sym_qualified_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467731] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [467747] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [467763] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [467779] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [467795] = 3,
    ACTIONS(14856), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [467813] = 3,
    ACTIONS(17710), 3,
      sym__varid,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17712), 4,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      sym__conid,
  [467831] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [467847] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    STATE(12532), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17875), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [467867] = 6,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    ACTIONS(18563), 1,
      anon_sym_as,
    STATE(17463), 1,
      sym_import_list,
    ACTIONS(18561), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467891] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [467907] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [467923] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [467939] = 6,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    ACTIONS(18565), 1,
      anon_sym_as,
    STATE(16049), 1,
      sym_import_list,
    ACTIONS(18561), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [467963] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    STATE(12707), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17907), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [467983] = 4,
    ACTIONS(6264), 1,
      sym__dot,
    STATE(12817), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18191), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [468003] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15513), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468019] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15493), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468035] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [468053] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15459), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468069] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15477), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468085] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18567), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [468101] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18569), 7,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [468117] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15501), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468133] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15441), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468149] = 4,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(18571), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(15062), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [468169] = 5,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    STATE(16342), 1,
      sym_guards,
    STATE(13156), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(18519), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [468191] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468207] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15501), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468223] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 7,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [468239] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 6,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [468257] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17696), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468273] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468291] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18569), 7,
      sym__varsym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [468307] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468323] = 8,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(1789), 1,
      sym__conid,
    ACTIONS(17610), 1,
      sym__tyconsym,
    STATE(7309), 1,
      sym_constructor,
    STATE(13769), 1,
      aux_sym__qualifying_module,
    STATE(20324), 1,
      sym__modid,
    STATE(20660), 1,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [468351] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468367] = 5,
    STATE(2369), 1,
      sym__colon2,
    STATE(17030), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(18574), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [468389] = 5,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(18578), 1,
      anon_sym_via,
    STATE(15063), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18576), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [468411] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468427] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(18580), 1,
      sym_where,
    STATE(19642), 1,
      sym_guards,
    ACTIONS(17972), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(13153), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [468451] = 4,
    ACTIONS(18582), 1,
      sym__varid,
    STATE(13139), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18290), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [468471] = 8,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(15070), 1,
      sym__consym,
    ACTIONS(18585), 1,
      sym__tyconsym,
    STATE(9452), 1,
      sym_constructor_operator,
    STATE(13225), 1,
      sym_constructor,
    STATE(13769), 1,
      aux_sym__qualifying_module,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [468499] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468515] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [468531] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468547] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468563] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15493), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468579] = 5,
    STATE(2369), 1,
      sym__colon2,
    STATE(17227), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(18587), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [468601] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15473), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468617] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15455), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468633] = 5,
    STATE(2369), 1,
      sym__colon2,
    STATE(17253), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(18589), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [468655] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15451), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468671] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468687] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [468703] = 5,
    ACTIONS(17993), 1,
      anon_sym_PIPE,
    STATE(19642), 1,
      sym_guards,
    STATE(13153), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(17991), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [468725] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15513), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468741] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468759] = 5,
    ACTIONS(15982), 1,
      anon_sym_PIPE,
    STATE(16342), 1,
      sym_guards,
    STATE(13156), 2,
      sym_gdpat,
      aux_sym_exp_if_guard_repeat1,
    ACTIONS(15978), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [468781] = 6,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    ACTIONS(18593), 1,
      anon_sym_as,
    STATE(16370), 1,
      sym_import_list,
    ACTIONS(18591), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [468805] = 3,
    ACTIONS(18074), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18072), 6,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [468823] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [468839] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468855] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [468873] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18595), 7,
      anon_sym_SEMI,
      anon_sym_3,
      anon_sym_LT_DASH,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [468889] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468905] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15447), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468921] = 7,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18450), 1,
      sym__layout_end,
    ACTIONS(18597), 1,
      anon_sym_LPAREN,
    STATE(15279), 1,
      sym_constructor,
    STATE(15035), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [468947] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [468963] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [468979] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15489), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [468995] = 8,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(17610), 1,
      sym__tyconsym,
    STATE(13225), 1,
      sym_constructor,
    STATE(13769), 1,
      aux_sym__qualifying_module,
    STATE(20324), 1,
      sym__modid,
    STATE(20660), 1,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [469023] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469039] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_AT2,
  [469055] = 7,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18599), 1,
      sym_string,
    STATE(13158), 1,
      sym__modid,
    STATE(13225), 1,
      sym_constructor,
    STATE(15293), 1,
      aux_sym__qualifying_module,
    STATE(13341), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [469081] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [469097] = 6,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    ACTIONS(18603), 1,
      anon_sym_as,
    STATE(16354), 1,
      sym_import_list,
    ACTIONS(18601), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [469121] = 5,
    ACTIONS(17222), 1,
      anon_sym_EQ,
    ACTIONS(17226), 1,
      sym_where,
    ACTIONS(18535), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(18323), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [469143] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15437), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469159] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
  [469177] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469193] = 3,
    ACTIONS(14856), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469211] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17696), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [469227] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469243] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [469259] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469275] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469291] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [469307] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469323] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469339] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17696), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469355] = 7,
    ACTIONS(13654), 1,
      sym__conid,
    ACTIONS(18605), 1,
      sym_string,
    STATE(12739), 1,
      sym__modid,
    STATE(13071), 1,
      sym_constructor,
    STATE(15144), 1,
      aux_sym__qualifying_module,
    STATE(12767), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [469381] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15459), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469397] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15465), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469413] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469429] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469445] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469461] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469477] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [469495] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469511] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469527] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15441), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469543] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [469559] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469575] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469591] = 7,
    ACTIONS(13558), 1,
      sym__conid,
    ACTIONS(18607), 1,
      sym_string,
    STATE(12792), 1,
      sym_constructor,
    STATE(12935), 1,
      sym__modid,
    STATE(14692), 1,
      aux_sym__qualifying_module,
    STATE(12966), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [469617] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469633] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15437), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469649] = 6,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    ACTIONS(18382), 1,
      anon_sym_as,
    STATE(16057), 1,
      sym_import_list,
    ACTIONS(18117), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [469673] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469689] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469705] = 7,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18597), 1,
      anon_sym_LPAREN,
    ACTIONS(18609), 1,
      sym__layout_end,
    STATE(15279), 1,
      sym_constructor,
    STATE(17380), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [469731] = 7,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18221), 1,
      anon_sym_LPAREN,
    ACTIONS(18609), 1,
      anon_sym_RBRACE,
    STATE(14737), 1,
      sym_constructor,
    STATE(18567), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [469757] = 3,
    ACTIONS(18611), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [469775] = 4,
    ACTIONS(18613), 1,
      sym__varid,
    STATE(13303), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18183), 4,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [469795] = 5,
    STATE(2369), 1,
      sym__colon2,
    STATE(17031), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(18615), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [469817] = 5,
    ACTIONS(18619), 1,
      anon_sym_LBRACE,
    ACTIONS(18621), 1,
      sym__layout_start,
    STATE(15175), 1,
      sym_decls,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18617), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [469839] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469855] = 4,
    ACTIONS(18623), 1,
      sym__varid,
    STATE(13216), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18290), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [469875] = 5,
    STATE(2381), 1,
      sym__colon2,
    STATE(16119), 1,
      sym__type_annotation,
    ACTIONS(15213), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(18626), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [469897] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [469913] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15976), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
  [469929] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [469945] = 4,
    ACTIONS(18630), 1,
      sym__varid,
    STATE(13139), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18628), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [469965] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 7,
      sym_comma,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PERCENT,
  [469981] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [469997] = 7,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18221), 1,
      anon_sym_LPAREN,
    ACTIONS(18632), 1,
      anon_sym_RBRACE,
    STATE(14737), 1,
      sym_constructor,
    STATE(18567), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [470023] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6264), 7,
      sym__dot,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [470039] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [470055] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15441), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470071] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 7,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [470087] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470103] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470119] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18567), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [470135] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [470151] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15465), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470167] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [470183] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [470199] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15459), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470215] = 5,
    ACTIONS(17222), 1,
      anon_sym_EQ,
    ACTIONS(17226), 1,
      sym_where,
    ACTIONS(18070), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(18136), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [470237] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15437), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470253] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470269] = 7,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18221), 1,
      anon_sym_LPAREN,
    ACTIONS(18634), 1,
      anon_sym_RBRACE,
    STATE(14737), 1,
      sym_constructor,
    STATE(18567), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [470295] = 7,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18597), 1,
      anon_sym_LPAREN,
    ACTIONS(18632), 1,
      sym__layout_end,
    STATE(15279), 1,
      sym_constructor,
    STATE(17380), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [470321] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 7,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
      anon_sym_AT2,
  [470337] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470353] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470369] = 5,
    ACTIONS(17222), 1,
      anon_sym_EQ,
    ACTIONS(17226), 1,
      sym_where,
    ACTIONS(18111), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(18218), 3,
      sym__adt_rhs,
      sym__gadt_rhs,
      sym__adt,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [470391] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470407] = 3,
    ACTIONS(14856), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470425] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470441] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470457] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18595), 7,
      sym__varsym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      anon_sym_PIPE,
      anon_sym_EQ,
  [470473] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [470489] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15441), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [470505] = 7,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18597), 1,
      anon_sym_LPAREN,
    ACTIONS(18634), 1,
      sym__layout_end,
    STATE(15279), 1,
      sym_constructor,
    STATE(17380), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [470531] = 3,
    ACTIONS(18636), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [470549] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [470565] = 6,
    ACTIONS(17845), 1,
      anon_sym_PIPE,
    ACTIONS(17847), 1,
      sym_where,
    STATE(14540), 1,
      sym_fundeps,
    STATE(16152), 1,
      sym_class_body,
    ACTIONS(18638), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [470589] = 7,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18245), 1,
      sym__layout_end,
    ACTIONS(18597), 1,
      anon_sym_LPAREN,
    STATE(15279), 1,
      sym_constructor,
    STATE(15281), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [470615] = 3,
    ACTIONS(18640), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470633] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470649] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15465), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [470665] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15459), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [470681] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15489), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470697] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [470713] = 7,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18221), 1,
      anon_sym_LPAREN,
    ACTIONS(18642), 1,
      anon_sym_RBRACE,
    STATE(14737), 1,
      sym_constructor,
    STATE(18567), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [470739] = 7,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18597), 1,
      anon_sym_LPAREN,
    ACTIONS(18642), 1,
      sym__layout_end,
    STATE(15279), 1,
      sym_constructor,
    STATE(17380), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [470765] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15447), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470781] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17696), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470797] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18644), 7,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [470813] = 6,
    ACTIONS(17714), 1,
      sym__conid,
    STATE(13225), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(17710), 3,
      sym__varid,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [470837] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15473), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470853] = 4,
    ACTIONS(12320), 1,
      anon_sym_LBRACE,
    STATE(14379), 1,
      sym_pat_fields,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(9703), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [470873] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470891] = 6,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    ACTIONS(18646), 1,
      anon_sym_as,
    STATE(16199), 1,
      sym_import_list,
    ACTIONS(18591), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [470915] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [470931] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
  [470947] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15501), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [470963] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [470979] = 7,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18223), 1,
      sym__layout_end,
    ACTIONS(18597), 1,
      anon_sym_LPAREN,
    STATE(15279), 1,
      sym_constructor,
    STATE(14738), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [471005] = 5,
    ACTIONS(18648), 1,
      sym__varid,
    STATE(16160), 1,
      sym_safety,
    ACTIONS(18650), 2,
      sym_string,
      anon_sym_LPAREN,
    ACTIONS(18652), 3,
      anon_sym_unsafe,
      anon_sym_safe,
      anon_sym_interruptible,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [471027] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [471043] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471059] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471075] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471091] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471107] = 6,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    ACTIONS(18654), 1,
      anon_sym_as,
    STATE(16205), 1,
      sym_import_list,
    ACTIONS(18601), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [471131] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471147] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15441), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [471163] = 5,
    ACTIONS(18619), 1,
      anon_sym_LBRACE,
    ACTIONS(18621), 1,
      sym__layout_start,
    STATE(15205), 1,
      sym_decls,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18656), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [471185] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471201] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [471217] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15437), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471233] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15451), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [471249] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15455), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [471265] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471281] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 7,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      sym__varid,
      anon_sym_LPAREN,
  [471297] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15493), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [471313] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471329] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15473), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [471345] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15513), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [471361] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [471377] = 3,
    ACTIONS(18074), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18372), 6,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_hiding,
      anon_sym_qualified,
      anon_sym_as,
  [471395] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471411] = 4,
    ACTIONS(18658), 1,
      sym__varid,
    STATE(13303), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18290), 4,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [471431] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15477), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [471447] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [471463] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15489), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471479] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471495] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [471511] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471527] = 5,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(18663), 1,
      anon_sym_via,
    STATE(15427), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [471549] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18279), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [471565] = 7,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18221), 1,
      anon_sym_LPAREN,
    ACTIONS(18665), 1,
      anon_sym_RBRACE,
    STATE(14737), 1,
      sym_constructor,
    STATE(18567), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [471591] = 7,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18597), 1,
      anon_sym_LPAREN,
    ACTIONS(18665), 1,
      sym__layout_end,
    STATE(15279), 1,
      sym_constructor,
    STATE(17380), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [471617] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15447), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471633] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 7,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_PIPE,
      anon_sym_DOT_DOT,
  [471649] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [471665] = 3,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 5,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [471683] = 7,
    ACTIONS(17799), 1,
      anon_sym_in,
    ACTIONS(18667), 1,
      anon_sym_LBRACE,
    ACTIONS(18669), 1,
      sym__layout_start,
    STATE(18083), 1,
      sym_decls,
    STATE(20711), 1,
      sym__let_decls,
    ACTIONS(17795), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [471709] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15455), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [471725] = 3,
    ACTIONS(14109), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [471743] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [471759] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471775] = 7,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    ACTIONS(18675), 1,
      anon_sym_qualified,
    ACTIONS(18677), 1,
      anon_sym_as,
    STATE(18349), 1,
      sym_import_list,
    ACTIONS(18213), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [471801] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15451), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [471817] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471833] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471849] = 7,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18221), 1,
      anon_sym_LPAREN,
    ACTIONS(18679), 1,
      anon_sym_RBRACE,
    STATE(14737), 1,
      sym_constructor,
    STATE(18567), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [471875] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 7,
      sym__consym,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
  [471891] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [471907] = 7,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    ACTIONS(18681), 1,
      anon_sym_qualified,
    ACTIONS(18683), 1,
      anon_sym_as,
    STATE(18092), 1,
      sym_import_list,
    ACTIONS(18251), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [471933] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15513), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [471949] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15451), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471965] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [471983] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15455), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [471999] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15473), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [472015] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472031] = 4,
    ACTIONS(18685), 1,
      sym__varid,
    STATE(13216), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18628), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [472051] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [472067] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15465), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472083] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15477), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [472099] = 7,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    ACTIONS(18687), 1,
      anon_sym_qualified,
    ACTIONS(18689), 1,
      anon_sym_as,
    STATE(18121), 1,
      sym_import_list,
    ACTIONS(18117), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [472125] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15489), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [472141] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18644), 7,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [472157] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15477), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472173] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15459), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472189] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15493), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [472205] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15477), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [472221] = 6,
    ACTIONS(17877), 1,
      anon_sym_PIPE,
    ACTIONS(17879), 1,
      sym_where,
    STATE(14427), 1,
      sym_fundeps,
    STATE(16335), 1,
      sym_class_body,
    ACTIONS(18638), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [472245] = 5,
    STATE(2365), 1,
      sym__colon2,
    STATE(15561), 1,
      sym__type_annotation,
    ACTIONS(15648), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(17475), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [472267] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472283] = 4,
    ACTIONS(15068), 1,
      anon_sym_EQ,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15062), 4,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [472303] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15473), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472319] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18292), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [472335] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15455), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472351] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15465), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [472367] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [472383] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [472399] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [472415] = 3,
    ACTIONS(13719), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [472433] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472449] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15451), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472465] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [472483] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 7,
      sym__unboxed_close,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_PERCENT,
  [472499] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472515] = 5,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(18578), 1,
      anon_sym_via,
    STATE(14972), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18661), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [472537] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18159), 7,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [472553] = 6,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    ACTIONS(18125), 1,
      anon_sym_as,
    STATE(16397), 1,
      sym_import_list,
    ACTIONS(18117), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [472577] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15513), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [472593] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15493), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [472609] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472625] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15447), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472641] = 7,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    ACTIONS(18691), 1,
      anon_sym_qualified,
    ACTIONS(18693), 1,
      anon_sym_as,
    STATE(17958), 1,
      sym_import_list,
    ACTIONS(18175), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [472667] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15489), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472683] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17696), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472699] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15501), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [472715] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472731] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472747] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 7,
      sym__consym,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_PIPE,
      anon_sym_EQ,
  [472763] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472779] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15437), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472795] = 5,
    STATE(2369), 1,
      sym__colon2,
    STATE(16386), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(18626), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [472817] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15501), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [472833] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 7,
      sym__consym,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
      sym__conid,
  [472849] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [472865] = 7,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18597), 1,
      anon_sym_LPAREN,
    ACTIONS(18679), 1,
      sym__layout_end,
    STATE(15279), 1,
      sym_constructor,
    STATE(17380), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [472891] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15447), 7,
      sym__layout_semicolon,
      sym_where,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [472907] = 5,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(18663), 1,
      anon_sym_via,
    STATE(15036), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18576), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [472929] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15976), 7,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
  [472945] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(18695), 1,
      anon_sym_EQ,
    STATE(16641), 1,
      sym__funrhs,
    STATE(19685), 1,
      sym_guards,
    STATE(12882), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [472968] = 7,
    ACTIONS(10298), 1,
      sym__conid,
    ACTIONS(16556), 1,
      sym__varid,
    STATE(8133), 1,
      sym_constructor,
    STATE(8390), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [472993] = 7,
    ACTIONS(6450), 1,
      sym__conid,
    ACTIONS(17212), 1,
      sym__varid,
    STATE(6838), 1,
      sym_constructor,
    STATE(7138), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473018] = 4,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    STATE(13824), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18697), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473037] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [473052] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [473067] = 7,
    ACTIONS(3051), 1,
      sym__conid,
    ACTIONS(16485), 1,
      sym__varid,
    STATE(4358), 1,
      sym_constructor,
    STATE(5041), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473092] = 6,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    ACTIONS(18689), 1,
      anon_sym_as,
    STATE(18121), 1,
      sym_import_list,
    ACTIONS(18117), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473115] = 7,
    ACTIONS(9134), 1,
      sym__conid,
    ACTIONS(17202), 1,
      sym__varid,
    STATE(10183), 1,
      sym_constructor,
    STATE(10653), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473140] = 4,
    ACTIONS(18701), 1,
      anon_sym_PIPE,
    STATE(13848), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [473159] = 6,
    ACTIONS(18137), 1,
      anon_sym_PIPE,
    ACTIONS(18139), 1,
      sym_where,
    STATE(15188), 1,
      sym_fundeps,
    STATE(18178), 1,
      sym_class_body,
    ACTIONS(18638), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473182] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 6,
      sym__layout_semicolon,
      sym_where,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      sym__varid,
  [473197] = 4,
    ACTIONS(18663), 1,
      anon_sym_via,
    STATE(15084), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [473216] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 6,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [473231] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15976), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [473246] = 7,
    ACTIONS(6657), 1,
      sym__conid,
    ACTIONS(17190), 1,
      sym__varid,
    STATE(6037), 1,
      sym_constructor,
    STATE(6344), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473271] = 7,
    ACTIONS(18705), 1,
      anon_sym_RBRACK,
    ACTIONS(18707), 1,
      anon_sym_PIPE,
    ACTIONS(18709), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18711), 1,
      sym__arith_dotdot,
    ACTIONS(18713), 1,
      sym_comma,
    STATE(15657), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473296] = 4,
    ACTIONS(18701), 1,
      anon_sym_PIPE,
    STATE(13952), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [473315] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [473332] = 5,
    STATE(2360), 1,
      sym__colon2,
    STATE(18130), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(18626), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473353] = 3,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18715), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [473370] = 7,
    ACTIONS(18717), 1,
      anon_sym_RBRACK,
    ACTIONS(18719), 1,
      anon_sym_PIPE,
    ACTIONS(18721), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18723), 1,
      sym__arith_dotdot,
    ACTIONS(18725), 1,
      sym_comma,
    STATE(15562), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473395] = 7,
    ACTIONS(6181), 1,
      sym__conid,
    ACTIONS(17184), 1,
      sym__varid,
    STATE(7287), 1,
      sym_constructor,
    STATE(7410), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473420] = 7,
    ACTIONS(10270), 1,
      sym__conid,
    ACTIONS(16966), 1,
      sym__varid,
    STATE(8022), 1,
      sym_constructor,
    STATE(8218), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473445] = 4,
    ACTIONS(18663), 1,
      anon_sym_via,
    STATE(14961), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18727), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [473464] = 7,
    ACTIONS(17937), 1,
      anon_sym_RBRACK,
    ACTIONS(17939), 1,
      anon_sym_PIPE,
    ACTIONS(17941), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17943), 1,
      sym__arith_dotdot,
    ACTIONS(17945), 1,
      sym_comma,
    STATE(16829), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473489] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18567), 6,
      sym_where,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [473504] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [473519] = 7,
    ACTIONS(13941), 1,
      sym__conid,
    ACTIONS(17118), 1,
      sym__varid,
    STATE(12483), 1,
      sym_constructor,
    STATE(12765), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473544] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [473559] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [473574] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [473589] = 7,
    ACTIONS(7299), 1,
      sym__conid,
    ACTIONS(17172), 1,
      sym__varid,
    STATE(6118), 1,
      sym_constructor,
    STATE(6579), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473614] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [473631] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [473648] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [473665] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [473680] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18644), 6,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [473695] = 7,
    ACTIONS(7054), 1,
      sym__conid,
    ACTIONS(17166), 1,
      sym__varid,
    STATE(6537), 1,
      sym_constructor,
    STATE(6787), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473720] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [473735] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [473750] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [473765] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [473780] = 7,
    ACTIONS(18729), 1,
      anon_sym_RBRACK,
    ACTIONS(18731), 1,
      anon_sym_PIPE,
    ACTIONS(18733), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18735), 1,
      sym__arith_dotdot,
    ACTIONS(18737), 1,
      sym_comma,
    STATE(15752), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473805] = 7,
    ACTIONS(11827), 1,
      sym__conid,
    ACTIONS(16826), 1,
      sym__varid,
    STATE(8152), 1,
      sym_constructor,
    STATE(8302), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473830] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [473845] = 7,
    ACTIONS(8936), 1,
      sym__conid,
    ACTIONS(17162), 1,
      sym__varid,
    STATE(10306), 1,
      sym_constructor,
    STATE(10823), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473870] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [473885] = 7,
    ACTIONS(6790), 1,
      sym__conid,
    ACTIONS(17144), 1,
      sym__varid,
    STATE(6714), 1,
      sym_constructor,
    STATE(6945), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473910] = 7,
    ACTIONS(13780), 1,
      sym__conid,
    ACTIONS(16659), 1,
      sym__varid,
    STATE(11751), 1,
      sym_constructor,
    STATE(12411), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473935] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [473950] = 4,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    STATE(13824), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18739), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [473969] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [473984] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [473999] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [474014] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [474029] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [474044] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474059] = 4,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    STATE(13824), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18741), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474078] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474093] = 7,
    ACTIONS(4161), 1,
      sym__conid,
    ACTIONS(17124), 1,
      sym__varid,
    STATE(4089), 1,
      sym_constructor,
    STATE(4210), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474118] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474133] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474148] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474163] = 7,
    ACTIONS(6573), 1,
      sym__conid,
    ACTIONS(17112), 1,
      sym__varid,
    STATE(6704), 1,
      sym_constructor,
    STATE(6833), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474188] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474203] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474218] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474233] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474248] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474263] = 7,
    ACTIONS(13728), 1,
      sym__conid,
    ACTIONS(17106), 1,
      sym__varid,
    STATE(13039), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(13614), 1,
      sym_variable,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474288] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474303] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474318] = 7,
    ACTIONS(14285), 1,
      sym__conid,
    ACTIONS(17008), 1,
      sym__varid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(13615), 1,
      sym_constructor,
    STATE(14254), 1,
      sym_variable,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474343] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474358] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474373] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474388] = 3,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18743), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [474405] = 7,
    ACTIONS(13987), 1,
      sym__conid,
    ACTIONS(17094), 1,
      sym__varid,
    STATE(12562), 1,
      sym_constructor,
    STATE(13239), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474430] = 7,
    ACTIONS(4407), 1,
      sym__conid,
    ACTIONS(16651), 1,
      sym__varid,
    STATE(10208), 1,
      sym_constructor,
    STATE(10359), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474455] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [474470] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [474485] = 7,
    ACTIONS(12490), 1,
      sym__conid,
    ACTIONS(17074), 1,
      sym__varid,
    STATE(8708), 1,
      sym_constructor,
    STATE(8898), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474510] = 6,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    ACTIONS(18745), 1,
      anon_sym_as,
    STATE(18346), 1,
      sym_import_list,
    ACTIONS(18601), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474533] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [474548] = 5,
    STATE(2371), 1,
      sym__colon2,
    STATE(18826), 1,
      sym__type_annotation,
    ACTIONS(15804), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(17475), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474569] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [474584] = 7,
    ACTIONS(18747), 1,
      anon_sym_RBRACK,
    ACTIONS(18749), 1,
      anon_sym_PIPE,
    ACTIONS(18751), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18753), 1,
      sym__arith_dotdot,
    ACTIONS(18755), 1,
      sym_comma,
    STATE(15470), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474609] = 7,
    ACTIONS(6545), 1,
      sym__conid,
    ACTIONS(17052), 1,
      sym__varid,
    STATE(6989), 1,
      sym_constructor,
    STATE(7167), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474634] = 6,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    ACTIONS(18757), 1,
      anon_sym_as,
    STATE(18355), 1,
      sym_import_list,
    ACTIONS(18591), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474657] = 7,
    ACTIONS(18759), 1,
      anon_sym_RBRACK,
    ACTIONS(18761), 1,
      anon_sym_PIPE,
    ACTIONS(18763), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18765), 1,
      sym__arith_dotdot,
    ACTIONS(18767), 1,
      sym_comma,
    STATE(15847), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474682] = 7,
    ACTIONS(18010), 1,
      anon_sym_RBRACK,
    ACTIONS(18012), 1,
      anon_sym_PIPE,
    ACTIONS(18014), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18016), 1,
      sym__arith_dotdot,
    ACTIONS(18018), 1,
      sym_comma,
    STATE(16593), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474707] = 7,
    ACTIONS(3032), 1,
      sym__conid,
    ACTIONS(17134), 1,
      sym__varid,
    STATE(4733), 1,
      sym_constructor,
    STATE(4979), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474732] = 7,
    ACTIONS(13821), 1,
      sym__conid,
    ACTIONS(16897), 1,
      sym__varid,
    STATE(12788), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(13679), 1,
      sym_variable,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474757] = 7,
    ACTIONS(13654), 1,
      sym__conid,
    ACTIONS(17014), 1,
      sym__varid,
    STATE(13116), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(13700), 1,
      sym_variable,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474782] = 5,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(18310), 1,
      anon_sym_via,
    STATE(16081), 1,
      sym_via,
    ACTIONS(18661), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474803] = 7,
    ACTIONS(1753), 1,
      sym__conid,
    ACTIONS(16864), 1,
      sym__varid,
    STATE(4268), 1,
      sym_constructor,
    STATE(4526), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474828] = 7,
    ACTIONS(18769), 1,
      anon_sym_RBRACK,
    ACTIONS(18771), 1,
      anon_sym_PIPE,
    ACTIONS(18773), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18775), 1,
      sym__arith_dotdot,
    ACTIONS(18777), 1,
      sym_comma,
    STATE(15942), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474853] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [474868] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [474883] = 7,
    ACTIONS(6601), 1,
      sym__conid,
    ACTIONS(17002), 1,
      sym__varid,
    STATE(6219), 1,
      sym_constructor,
    STATE(6577), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474908] = 7,
    ACTIONS(7411), 1,
      sym__conid,
    ACTIONS(17020), 1,
      sym__varid,
    STATE(6017), 1,
      sym_constructor,
    STATE(6497), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474933] = 4,
    ACTIONS(18578), 1,
      anon_sym_via,
    STATE(15209), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18779), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [474952] = 7,
    ACTIONS(12389), 1,
      sym__conid,
    ACTIONS(16689), 1,
      sym__varid,
    STATE(7935), 1,
      sym_constructor,
    STATE(8319), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [474977] = 7,
    ACTIONS(18781), 1,
      anon_sym_RBRACK,
    ACTIONS(18783), 1,
      anon_sym_PIPE,
    ACTIONS(18785), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18787), 1,
      sym__arith_dotdot,
    ACTIONS(18789), 1,
      sym_comma,
    STATE(16037), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475002] = 7,
    ACTIONS(7114), 1,
      sym__conid,
    ACTIONS(16990), 1,
      sym__varid,
    STATE(5794), 1,
      sym_constructor,
    STATE(6163), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475027] = 5,
    STATE(2360), 1,
      sym__colon2,
    STATE(18171), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(18574), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475048] = 5,
    STATE(2360), 1,
      sym__colon2,
    STATE(18174), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(18615), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475069] = 7,
    ACTIONS(12154), 1,
      sym__conid,
    ACTIONS(16941), 1,
      sym__varid,
    STATE(8163), 1,
      sym_constructor,
    STATE(8685), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475094] = 7,
    ACTIONS(12359), 1,
      sym__conid,
    ACTIONS(16796), 1,
      sym__varid,
    STATE(8110), 1,
      sym_constructor,
    STATE(8692), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475119] = 7,
    ACTIONS(6915), 1,
      sym__conid,
    ACTIONS(16960), 1,
      sym__varid,
    STATE(6182), 1,
      sym_constructor,
    STATE(6260), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475144] = 7,
    ACTIONS(7327), 1,
      sym__conid,
    ACTIONS(16947), 1,
      sym__varid,
    STATE(6414), 1,
      sym_constructor,
    STATE(6779), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475169] = 4,
    ACTIONS(18578), 1,
      anon_sym_via,
    STATE(15178), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18791), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [475188] = 7,
    ACTIONS(6943), 1,
      sym__conid,
    ACTIONS(16935), 1,
      sym__varid,
    STATE(6911), 1,
      sym_constructor,
    STATE(7251), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475213] = 7,
    ACTIONS(9252), 1,
      sym__conid,
    ACTIONS(16927), 1,
      sym__varid,
    STATE(9944), 1,
      sym_constructor,
    STATE(10167), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475238] = 7,
    ACTIONS(18793), 1,
      anon_sym_RBRACK,
    ACTIONS(18795), 1,
      anon_sym_PIPE,
    ACTIONS(18797), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18799), 1,
      sym__arith_dotdot,
    ACTIONS(18801), 1,
      sym_comma,
    STATE(15536), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475263] = 4,
    ACTIONS(18578), 1,
      anon_sym_via,
    STATE(15176), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18803), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [475282] = 7,
    ACTIONS(12893), 1,
      sym__conid,
    ACTIONS(16907), 1,
      sym__varid,
    STATE(8335), 1,
      sym_constructor,
    STATE(8782), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475307] = 4,
    ACTIONS(18807), 1,
      anon_sym_PIPE,
    STATE(13547), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18805), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [475326] = 7,
    ACTIONS(6016), 1,
      sym__conid,
    ACTIONS(17034), 1,
      sym__varid,
    STATE(7297), 1,
      sym_constructor,
    STATE(7475), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475351] = 5,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    STATE(15820), 1,
      sym_import_list,
    ACTIONS(18809), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475372] = 7,
    ACTIONS(12423), 1,
      sym__conid,
    ACTIONS(16891), 1,
      sym__varid,
    STATE(8232), 1,
      sym_constructor,
    STATE(8818), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475397] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [475412] = 3,
    STATE(13083), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18191), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [475429] = 4,
    ACTIONS(18807), 1,
      anon_sym_PIPE,
    STATE(13507), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18811), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [475448] = 4,
    ACTIONS(18815), 1,
      sym_comma,
    STATE(13981), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18813), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [475467] = 7,
    ACTIONS(18817), 1,
      anon_sym_RBRACK,
    ACTIONS(18819), 1,
      anon_sym_PIPE,
    ACTIONS(18821), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18823), 1,
      sym__arith_dotdot,
    ACTIONS(18825), 1,
      sym_comma,
    STATE(16132), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475492] = 7,
    ACTIONS(1698), 1,
      sym__conid,
    ACTIONS(16546), 1,
      sym__varid,
    STATE(3477), 1,
      sym_constructor,
    STATE(3543), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475517] = 7,
    ACTIONS(14001), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(14535), 1,
      sym_variable,
    STATE(15447), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475542] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [475559] = 7,
    ACTIONS(12677), 1,
      sym__conid,
    ACTIONS(16844), 1,
      sym__varid,
    STATE(8714), 1,
      sym_constructor,
    STATE(8820), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475584] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [475601] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [475616] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [475631] = 7,
    ACTIONS(11540), 1,
      sym__conid,
    ACTIONS(16856), 1,
      sym__varid,
    STATE(7886), 1,
      sym_constructor,
    STATE(8009), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475656] = 7,
    ACTIONS(5980), 1,
      sym__conid,
    ACTIONS(16850), 1,
      sym__varid,
    STATE(6121), 1,
      sym_constructor,
    STATE(6518), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475681] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [475696] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [475711] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [475726] = 4,
    ACTIONS(18829), 1,
      sym_comma,
    STATE(13528), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18827), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [475745] = 7,
    ACTIONS(6209), 1,
      sym__conid,
    ACTIONS(16838), 1,
      sym__varid,
    STATE(5860), 1,
      sym_constructor,
    STATE(6185), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475770] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [475785] = 7,
    ACTIONS(11655), 1,
      sym__conid,
    ACTIONS(16820), 1,
      sym__varid,
    STATE(8130), 1,
      sym_constructor,
    STATE(8244), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475810] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [475825] = 7,
    ACTIONS(10573), 1,
      sym__conid,
    ACTIONS(16921), 1,
      sym__varid,
    STATE(7614), 1,
      sym_constructor,
    STATE(7926), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475850] = 6,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    ACTIONS(18832), 1,
      anon_sym_as,
    STATE(18468), 1,
      sym_import_list,
    ACTIONS(18561), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475873] = 7,
    ACTIONS(6762), 1,
      sym__conid,
    ACTIONS(16832), 1,
      sym__varid,
    STATE(6104), 1,
      sym_constructor,
    STATE(6495), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475898] = 7,
    ACTIONS(7271), 1,
      sym__conid,
    ACTIONS(16814), 1,
      sym__varid,
    STATE(6774), 1,
      sym_constructor,
    STATE(6851), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475923] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [475938] = 5,
    STATE(2360), 1,
      sym__colon2,
    STATE(18244), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(18587), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475959] = 7,
    ACTIONS(14534), 1,
      sym__conid,
    ACTIONS(16802), 1,
      sym__varid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(13756), 1,
      sym_constructor,
    STATE(14552), 1,
      sym_variable,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [475984] = 7,
    ACTIONS(14078), 1,
      sym__conid,
    ACTIONS(16620), 1,
      sym__varid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(14580), 1,
      sym_constructor,
    STATE(14650), 1,
      sym_variable,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476009] = 7,
    ACTIONS(12002), 1,
      sym__conid,
    ACTIONS(16774), 1,
      sym__varid,
    STATE(8397), 1,
      sym_constructor,
    STATE(8589), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476034] = 7,
    ACTIONS(4289), 1,
      sym__conid,
    ACTIONS(17206), 1,
      sym__varid,
    STATE(4285), 1,
      sym_constructor,
    STATE(4630), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476059] = 5,
    STATE(2360), 1,
      sym__colon2,
    STATE(18250), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(18589), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476080] = 4,
    ACTIONS(18578), 1,
      anon_sym_via,
    STATE(15138), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18834), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [476099] = 7,
    ACTIONS(6408), 1,
      sym__conid,
    ACTIONS(16780), 1,
      sym__varid,
    STATE(5866), 1,
      sym_constructor,
    STATE(6140), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476124] = 4,
    ACTIONS(18578), 1,
      anon_sym_via,
    STATE(15133), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18836), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [476143] = 4,
    ACTIONS(18840), 1,
      anon_sym_PIPE,
    STATE(13547), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18838), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [476162] = 7,
    ACTIONS(6897), 1,
      sym__conid,
    ACTIONS(16768), 1,
      sym__varid,
    STATE(5868), 1,
      sym_constructor,
    STATE(6122), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476187] = 7,
    ACTIONS(7122), 1,
      sym__conid,
    ACTIONS(16762), 1,
      sym__varid,
    STATE(5662), 1,
      sym_constructor,
    STATE(5857), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476212] = 4,
    ACTIONS(18807), 1,
      anon_sym_PIPE,
    STATE(13547), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18811), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [476231] = 7,
    ACTIONS(5998), 1,
      sym__conid,
    ACTIONS(16737), 1,
      sym__varid,
    STATE(4279), 1,
      sym_constructor,
    STATE(4551), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476256] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [476273] = 7,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18843), 1,
      anon_sym_LPAREN,
    STATE(13112), 1,
      sym_constructor,
    STATE(13781), 1,
      sym_qualified_type,
    STATE(14747), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476298] = 5,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(15562), 1,
      anon_sym_BQUOTE,
    ACTIONS(18845), 1,
      sym__tyconsym,
    STATE(14906), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476319] = 5,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    STATE(15916), 1,
      sym_import_list,
    ACTIONS(18847), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476340] = 5,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    STATE(15918), 1,
      sym_import_list,
    ACTIONS(18849), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476361] = 7,
    ACTIONS(18851), 1,
      anon_sym_RBRACK,
    ACTIONS(18853), 1,
      anon_sym_PIPE,
    ACTIONS(18855), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18857), 1,
      sym__arith_dotdot,
    ACTIONS(18859), 1,
      sym_comma,
    STATE(17795), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476386] = 5,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    STATE(15921), 1,
      sym_import_list,
    ACTIONS(18861), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476407] = 7,
    ACTIONS(18863), 1,
      anon_sym_RBRACK,
    ACTIONS(18865), 1,
      anon_sym_PIPE,
    ACTIONS(18867), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18869), 1,
      sym__arith_dotdot,
    ACTIONS(18871), 1,
      sym_comma,
    STATE(16227), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476432] = 7,
    ACTIONS(17883), 1,
      anon_sym_RBRACK,
    ACTIONS(17885), 1,
      anon_sym_PIPE,
    ACTIONS(17887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17889), 1,
      sym__arith_dotdot,
    ACTIONS(17891), 1,
      sym_comma,
    STATE(17348), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476457] = 4,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    STATE(13637), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18873), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476476] = 5,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(18310), 1,
      anon_sym_via,
    STATE(16275), 1,
      sym_via,
    ACTIONS(18576), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476497] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [476514] = 7,
    ACTIONS(4211), 1,
      sym__conid,
    ACTIONS(16729), 1,
      sym__varid,
    STATE(4334), 1,
      sym_constructor,
    STATE(4757), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476539] = 7,
    ACTIONS(18044), 1,
      anon_sym_RBRACK,
    ACTIONS(18046), 1,
      anon_sym_PIPE,
    ACTIONS(18048), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18050), 1,
      sym__arith_dotdot,
    ACTIONS(18052), 1,
      sym_comma,
    STATE(16171), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476564] = 7,
    ACTIONS(7355), 1,
      sym__conid,
    ACTIONS(17082), 1,
      sym__varid,
    STATE(6933), 1,
      sym_constructor,
    STATE(7275), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476589] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18569), 6,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [476604] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [476619] = 4,
    ACTIONS(18875), 1,
      sym_comma,
    STATE(13528), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18813), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [476638] = 4,
    ACTIONS(18578), 1,
      anon_sym_via,
    STATE(15064), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18703), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [476657] = 7,
    ACTIONS(6125), 1,
      sym__conid,
    ACTIONS(16721), 1,
      sym__varid,
    STATE(7077), 1,
      sym_constructor,
    STATE(7326), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476682] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [476699] = 7,
    ACTIONS(17978), 1,
      anon_sym_RBRACK,
    ACTIONS(17980), 1,
      anon_sym_PIPE,
    ACTIONS(17982), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17984), 1,
      sym__arith_dotdot,
    ACTIONS(17986), 1,
      sym_comma,
    STATE(17099), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476724] = 4,
    ACTIONS(18578), 1,
      anon_sym_via,
    STATE(15056), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18727), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [476743] = 4,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    STATE(13637), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18697), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476762] = 4,
    ACTIONS(18807), 1,
      anon_sym_PIPE,
    STATE(13547), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [476781] = 4,
    ACTIONS(18807), 1,
      anon_sym_PIPE,
    STATE(13550), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18699), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [476800] = 7,
    ACTIONS(8725), 1,
      sym__conid,
    ACTIONS(16717), 1,
      sym__varid,
    STATE(10614), 1,
      sym_constructor,
    STATE(11349), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476825] = 7,
    ACTIONS(4321), 1,
      sym__conid,
    ACTIONS(16647), 1,
      sym__varid,
    STATE(9226), 1,
      sym_constructor,
    STATE(9375), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476850] = 4,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    STATE(13637), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18739), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476869] = 4,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    STATE(13637), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18741), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476888] = 7,
    ACTIONS(13772), 1,
      sym__conid,
    ACTIONS(16976), 1,
      sym__varid,
    STATE(12580), 1,
      sym_constructor,
    STATE(13251), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476913] = 5,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    STATE(16036), 1,
      sym_import_list,
    ACTIONS(18877), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476934] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [476949] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [476964] = 5,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    STATE(16050), 1,
      sym_import_list,
    ACTIONS(18879), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [476985] = 5,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    STATE(17401), 1,
      sym_import_list,
    ACTIONS(18877), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477006] = 7,
    ACTIONS(8789), 1,
      sym__conid,
    ACTIONS(16695), 1,
      sym__varid,
    STATE(10166), 1,
      sym_constructor,
    STATE(10434), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477031] = 5,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(15547), 1,
      sym__arrow,
    ACTIONS(18881), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(14078), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477052] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13873), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [477067] = 6,
    ACTIONS(13558), 1,
      sym__conid,
    STATE(12792), 1,
      sym_constructor,
    STATE(12935), 1,
      sym__modid,
    STATE(14692), 1,
      aux_sym__qualifying_module,
    STATE(13705), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477090] = 6,
    ACTIONS(13558), 1,
      sym__conid,
    STATE(12792), 1,
      sym_constructor,
    STATE(12935), 1,
      sym__modid,
    STATE(14692), 1,
      aux_sym__qualifying_module,
    STATE(13704), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477113] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [477128] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [477143] = 4,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    STATE(13637), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18739), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477162] = 7,
    ACTIONS(18883), 1,
      anon_sym_RBRACK,
    ACTIONS(18885), 1,
      anon_sym_PIPE,
    ACTIONS(18887), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18889), 1,
      sym__arith_dotdot,
    ACTIONS(18891), 1,
      sym_comma,
    STATE(16322), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477187] = 4,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    STATE(13637), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18893), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477206] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [477221] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [477236] = 5,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    STATE(17373), 1,
      sym_import_list,
    ACTIONS(18879), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477257] = 6,
    ACTIONS(13558), 1,
      sym__conid,
    STATE(12792), 1,
      sym_constructor,
    STATE(12935), 1,
      sym__modid,
    STATE(14692), 1,
      aux_sym__qualifying_module,
    STATE(13687), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477280] = 7,
    ACTIONS(7082), 1,
      sym__conid,
    ACTIONS(16677), 1,
      sym__varid,
    STATE(7131), 1,
      sym_constructor,
    STATE(7416), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477305] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [477320] = 3,
    STATE(12555), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17907), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [477337] = 7,
    ACTIONS(18895), 1,
      anon_sym_RBRACK,
    ACTIONS(18897), 1,
      anon_sym_PIPE,
    ACTIONS(18899), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18901), 1,
      sym__arith_dotdot,
    ACTIONS(18903), 1,
      sym_comma,
    STATE(15691), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477362] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [477377] = 3,
    ACTIONS(18907), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18905), 5,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [477394] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [477409] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [477424] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [477439] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [477454] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_via,
      anon_sym_deriving,
  [477471] = 7,
    ACTIONS(4047), 1,
      sym__conid,
    ACTIONS(16917), 1,
      sym__varid,
    STATE(4546), 1,
      sym_constructor,
    STATE(5341), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477496] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [477511] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [477528] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [477543] = 5,
    ACTIONS(18909), 1,
      anon_sym_LBRACE,
    ACTIONS(18911), 1,
      sym__layout_start,
    STATE(16104), 1,
      sym_decls,
    ACTIONS(18656), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477564] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [477579] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [477594] = 7,
    ACTIONS(13322), 1,
      sym__conid,
    ACTIONS(16411), 1,
      sym__varid,
    STATE(9081), 1,
      sym_constructor,
    STATE(9323), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477619] = 7,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18913), 1,
      anon_sym_LPAREN,
    STATE(13113), 1,
      sym_constructor,
    STATE(13854), 1,
      sym_qualified_type,
    STATE(14747), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477644] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17696), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [477659] = 5,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(15562), 1,
      anon_sym_BQUOTE,
    ACTIONS(18915), 1,
      sym__tyconsym,
    STATE(14635), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477680] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [477695] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [477710] = 4,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    STATE(13824), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18873), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477729] = 7,
    ACTIONS(101), 1,
      sym__conid,
    ACTIONS(17138), 1,
      sym__varid,
    STATE(3976), 1,
      sym_constructor,
    STATE(8007), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477754] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [477769] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [477784] = 7,
    ACTIONS(18917), 1,
      anon_sym_RBRACK,
    ACTIONS(18919), 1,
      anon_sym_PIPE,
    ACTIONS(18921), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18923), 1,
      sym__arith_dotdot,
    ACTIONS(18925), 1,
      sym_comma,
    STATE(16417), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477809] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [477824] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [477839] = 4,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    STATE(13637), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18927), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477858] = 7,
    ACTIONS(4177), 1,
      sym__conid,
    ACTIONS(16638), 1,
      sym__varid,
    STATE(4215), 1,
      sym_constructor,
    STATE(4818), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477883] = 4,
    ACTIONS(18875), 1,
      sym_comma,
    STATE(13569), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18929), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [477902] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [477917] = 4,
    ACTIONS(18933), 1,
      anon_sym_deriving,
    STATE(13637), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18931), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477936] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [477951] = 4,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    STATE(13637), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18936), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [477970] = 4,
    ACTIONS(18578), 1,
      anon_sym_via,
    STATE(14973), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18938), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [477989] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [478004] = 4,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    STATE(13575), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18940), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478023] = 4,
    ACTIONS(18807), 1,
      anon_sym_PIPE,
    STATE(13576), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18942), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [478042] = 7,
    ACTIONS(11976), 1,
      sym__conid,
    ACTIONS(16598), 1,
      sym__varid,
    STATE(8318), 1,
      sym_constructor,
    STATE(8631), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478067] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 6,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [478082] = 4,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    STATE(13637), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18927), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478101] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [478116] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [478131] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [478146] = 5,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(15719), 1,
      sym__arrow,
    ACTIONS(18944), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(14078), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478167] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478182] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478197] = 7,
    ACTIONS(6517), 1,
      sym__conid,
    ACTIONS(16873), 1,
      sym__varid,
    STATE(6995), 1,
      sym_constructor,
    STATE(7274), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478222] = 4,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    STATE(13581), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18946), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478241] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [478256] = 5,
    ACTIONS(18950), 1,
      anon_sym_LBRACE,
    ACTIONS(18952), 1,
      sym__layout_start,
    STATE(17656), 1,
      sym_decls,
    ACTIONS(18948), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478277] = 5,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(15562), 1,
      anon_sym_BQUOTE,
    ACTIONS(18954), 1,
      sym__tyconsym,
    STATE(15158), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478298] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 6,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [478313] = 7,
    ACTIONS(9286), 1,
      sym__conid,
    ACTIONS(16510), 1,
      sym__varid,
    STATE(10403), 1,
      sym_constructor,
    STATE(11157), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478338] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [478353] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [478368] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [478383] = 5,
    ACTIONS(18119), 1,
      anon_sym_LPAREN,
    ACTIONS(18121), 1,
      anon_sym_hiding,
    STATE(16199), 1,
      sym_import_list,
    ACTIONS(18591), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478404] = 7,
    ACTIONS(18956), 1,
      anon_sym_RBRACK,
    ACTIONS(18958), 1,
      anon_sym_PIPE,
    ACTIONS(18960), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18962), 1,
      sym__arith_dotdot,
    ACTIONS(18964), 1,
      sym_comma,
    STATE(17569), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478429] = 4,
    ACTIONS(18966), 1,
      sym__varid,
    STATE(13752), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(18628), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478448] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [478463] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15501), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478478] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
      sym__varid,
  [478493] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15493), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478508] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15513), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478523] = 7,
    ACTIONS(6036), 1,
      sym__conid,
    ACTIONS(16610), 1,
      sym__varid,
    STATE(5551), 1,
      sym_constructor,
    STATE(5864), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478548] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [478563] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [478578] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478593] = 3,
    ACTIONS(18970), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18968), 5,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [478610] = 7,
    ACTIONS(18972), 1,
      anon_sym_RBRACK,
    ACTIONS(18974), 1,
      anon_sym_PIPE,
    ACTIONS(18976), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18978), 1,
      sym__arith_dotdot,
    ACTIONS(18980), 1,
      sym_comma,
    STATE(16512), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478635] = 4,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    STATE(13824), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18739), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478654] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478669] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478684] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [478701] = 4,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    STATE(13824), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18893), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478720] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15477), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478735] = 7,
    ACTIONS(6695), 1,
      sym__conid,
    ACTIONS(16604), 1,
      sym__varid,
    STATE(6352), 1,
      sym_constructor,
    STATE(6768), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478760] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15473), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478775] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15455), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478790] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15451), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478805] = 5,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    STATE(17594), 1,
      sym_import_list,
    ACTIONS(18861), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478826] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478841] = 6,
    ACTIONS(13558), 1,
      sym__conid,
    STATE(12792), 1,
      sym_constructor,
    STATE(12935), 1,
      sym__modid,
    STATE(14692), 1,
      aux_sym__qualifying_module,
    STATE(13949), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478864] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15489), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478879] = 5,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(15562), 1,
      anon_sym_BQUOTE,
    ACTIONS(15564), 1,
      sym__tyconsym,
    STATE(15390), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478900] = 3,
    STATE(12633), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17875), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [478917] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [478932] = 7,
    ACTIONS(18982), 1,
      anon_sym_RBRACK,
    ACTIONS(18984), 1,
      anon_sym_PIPE,
    ACTIONS(18986), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18988), 1,
      sym__arith_dotdot,
    ACTIONS(18990), 1,
      sym_comma,
    STATE(15919), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478957] = 7,
    ACTIONS(4061), 1,
      sym__conid,
    ACTIONS(16655), 1,
      sym__varid,
    STATE(4563), 1,
      sym_constructor,
    STATE(5217), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [478982] = 4,
    ACTIONS(18994), 1,
      anon_sym_PIPE,
    STATE(14898), 1,
      sym_tyfam_injectivity,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18992), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [479001] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15437), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [479016] = 7,
    ACTIONS(11737), 1,
      sym__conid,
    ACTIONS(16586), 1,
      sym__varid,
    STATE(7907), 1,
      sym_constructor,
    STATE(8111), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479041] = 7,
    ACTIONS(18996), 1,
      anon_sym_RBRACK,
    ACTIONS(18998), 1,
      anon_sym_PIPE,
    ACTIONS(19000), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19002), 1,
      sym__arith_dotdot,
    ACTIONS(19004), 1,
      sym_comma,
    STATE(17625), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479066] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [479081] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15459), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [479096] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15465), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [479111] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [479126] = 5,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    STATE(17568), 1,
      sym_import_list,
    ACTIONS(18849), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479147] = 5,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    STATE(17566), 1,
      sym_import_list,
    ACTIONS(18847), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479168] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15441), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [479183] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479198] = 7,
    ACTIONS(4519), 1,
      sym__conid,
    ACTIONS(16582), 1,
      sym__varid,
    STATE(10128), 1,
      sym_constructor,
    STATE(10401), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479223] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15501), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479238] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 6,
      sym__layout_semicolon,
      sym__dot,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [479253] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15493), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479268] = 5,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(20366), 3,
      sym_operator,
      sym__minus,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479289] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15513), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479304] = 7,
    ACTIONS(19006), 1,
      anon_sym_RBRACK,
    ACTIONS(19008), 1,
      anon_sym_PIPE,
    ACTIONS(19010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19012), 1,
      sym__arith_dotdot,
    ACTIONS(19014), 1,
      sym_comma,
    STATE(16607), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479329] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15447), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [479344] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479359] = 7,
    ACTIONS(7140), 1,
      sym__conid,
    ACTIONS(16576), 1,
      sym__varid,
    STATE(6147), 1,
      sym_constructor,
    STATE(6477), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479384] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479399] = 5,
    ACTIONS(18909), 1,
      anon_sym_LBRACE,
    ACTIONS(18911), 1,
      sym__layout_start,
    STATE(16296), 1,
      sym_decls,
    ACTIONS(18617), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479420] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479435] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18595), 6,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [479450] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15477), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479465] = 6,
    ACTIONS(19016), 1,
      sym__conid,
    STATE(14620), 1,
      aux_sym__qualifying_module,
    STATE(15666), 1,
      sym_constructor,
    STATE(16806), 1,
      sym__modid,
    STATE(15516), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479488] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15473), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479503] = 7,
    ACTIONS(5361), 1,
      sym__conid,
    ACTIONS(16665), 1,
      sym__varid,
    STATE(3971), 1,
      sym_constructor,
    STATE(4124), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479528] = 7,
    ACTIONS(7158), 1,
      sym__conid,
    ACTIONS(16550), 1,
      sym__varid,
    STATE(4625), 1,
      sym_constructor,
    STATE(4978), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479553] = 5,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(15562), 1,
      anon_sym_BQUOTE,
    ACTIONS(19018), 1,
      sym__tyconsym,
    STATE(15317), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479574] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15455), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479589] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15451), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479604] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [479619] = 7,
    ACTIONS(13286), 1,
      sym__conid,
    ACTIONS(16562), 1,
      sym__varid,
    STATE(8893), 1,
      sym_constructor,
    STATE(9130), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479644] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [479659] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15447), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479674] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15489), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479689] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479704] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15437), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479719] = 7,
    ACTIONS(4081), 1,
      sym__conid,
    ACTIONS(16506), 1,
      sym__varid,
    STATE(4562), 1,
      sym_constructor,
    STATE(5290), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479744] = 7,
    ACTIONS(5421), 1,
      sym__conid,
    ACTIONS(17088), 1,
      sym__varid,
    STATE(7526), 1,
      sym_constructor,
    STATE(7673), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479769] = 6,
    ACTIONS(17471), 1,
      anon_sym_DASH,
    ACTIONS(17473), 1,
      anon_sym_BQUOTE,
    ACTIONS(17477), 1,
      sym__varsym,
    STATE(3215), 1,
      sym_varop,
    STATE(9406), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479792] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15459), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479807] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15465), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479822] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479837] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15441), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [479852] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_deriving,
  [479867] = 5,
    STATE(2360), 1,
      sym__colon2,
    STATE(18674), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(17475), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479888] = 5,
    ACTIONS(19020), 1,
      anon_sym_LBRACE,
    ACTIONS(19022), 1,
      sym__layout_start,
    STATE(17151), 1,
      sym_decls,
    ACTIONS(18656), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479909] = 4,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    STATE(13637), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(19024), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479928] = 7,
    ACTIONS(19026), 1,
      anon_sym_RBRACK,
    ACTIONS(19028), 1,
      anon_sym_PIPE,
    ACTIONS(19030), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19032), 1,
      sym__arith_dotdot,
    ACTIONS(19034), 1,
      sym_comma,
    STATE(16702), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479953] = 7,
    ACTIONS(13732), 1,
      sym__conid,
    ACTIONS(16463), 1,
      sym__varid,
    STATE(12806), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(13416), 1,
      sym_variable,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [479978] = 3,
    ACTIONS(14856), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14854), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [479995] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [480012] = 4,
    ACTIONS(19036), 1,
      sym__varid,
    STATE(13752), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(18290), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480031] = 7,
    ACTIONS(19039), 1,
      anon_sym_RBRACK,
    ACTIONS(19041), 1,
      anon_sym_PIPE,
    ACTIONS(19043), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19045), 1,
      sym__arith_dotdot,
    ACTIONS(19047), 1,
      sym_comma,
    STATE(16097), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480056] = 7,
    ACTIONS(17947), 1,
      anon_sym_RBRACK,
    ACTIONS(17949), 1,
      anon_sym_PIPE,
    ACTIONS(17951), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17953), 1,
      sym__arith_dotdot,
    ACTIONS(17955), 1,
      sym_comma,
    STATE(15633), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480081] = 4,
    ACTIONS(19051), 1,
      sym_comma,
    STATE(13785), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19049), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [480100] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [480117] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym__dot,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [480132] = 7,
    ACTIONS(19053), 1,
      anon_sym_RBRACK,
    ACTIONS(19055), 1,
      anon_sym_PIPE,
    ACTIONS(19057), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19059), 1,
      sym__arith_dotdot,
    ACTIONS(19061), 1,
      sym_comma,
    STATE(16797), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480157] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(19063), 1,
      anon_sym_EQ,
    STATE(15585), 1,
      sym__funrhs,
    STATE(20581), 1,
      sym_guards,
    STATE(12832), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480180] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(19065), 1,
      anon_sym_EQ,
    STATE(16766), 1,
      sym__funrhs,
    STATE(19562), 1,
      sym_guards,
    STATE(13033), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480203] = 7,
    ACTIONS(17962), 1,
      anon_sym_RBRACK,
    ACTIONS(17964), 1,
      anon_sym_PIPE,
    ACTIONS(17966), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17968), 1,
      sym__arith_dotdot,
    ACTIONS(17970), 1,
      sym_comma,
    STATE(16092), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480228] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(19065), 1,
      anon_sym_EQ,
    STATE(16756), 1,
      sym__funrhs,
    STATE(19562), 1,
      sym_guards,
    STATE(13033), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480251] = 7,
    ACTIONS(4171), 1,
      sym__conid,
    ACTIONS(16502), 1,
      sym__varid,
    STATE(5405), 1,
      sym_constructor,
    STATE(5573), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480276] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15441), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [480291] = 7,
    ACTIONS(8970), 1,
      sym__conid,
    ACTIONS(16475), 1,
      sym__varid,
    STATE(10862), 1,
      sym_constructor,
    STATE(11619), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480316] = 7,
    ACTIONS(10978), 1,
      sym__conid,
    ACTIONS(17068), 1,
      sym__varid,
    STATE(7864), 1,
      sym_constructor,
    STATE(7972), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480341] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(19063), 1,
      anon_sym_EQ,
    STATE(15596), 1,
      sym__funrhs,
    STATE(20581), 1,
      sym_guards,
    STATE(12832), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480364] = 7,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    STATE(13225), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(14535), 1,
      sym_variable,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480389] = 6,
    ACTIONS(17714), 1,
      sym__conid,
    STATE(13225), 1,
      sym_constructor,
    STATE(13769), 1,
      aux_sym__qualifying_module,
    STATE(20324), 1,
      sym__modid,
    ACTIONS(17712), 2,
      sym__consym,
      sym__tyconsym,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480412] = 7,
    ACTIONS(4243), 1,
      sym__conid,
    ACTIONS(17058), 1,
      sym__varid,
    STATE(4212), 1,
      sym_constructor,
    STATE(4491), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480437] = 7,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(18056), 1,
      sym__varid,
    STATE(13225), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20634), 1,
      sym_variable,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480462] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 6,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [480477] = 3,
    ACTIONS(15167), 1,
      anon_sym_AT2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14887), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [480494] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [480509] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2381), 1,
      sym__colon2,
    STATE(13815), 1,
      aux_sym_signature_repeat1,
    STATE(15559), 1,
      sym__type_annotation,
    ACTIONS(15213), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480532] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2440), 1,
      sym__colon2,
    STATE(15218), 1,
      aux_sym_signature_repeat1,
    STATE(16572), 1,
      sym__type_annotation,
    ACTIONS(19067), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480555] = 7,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(19069), 1,
      anon_sym_LPAREN,
    STATE(13106), 1,
      sym_constructor,
    STATE(13850), 1,
      sym_qualified_type,
    STATE(14747), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480580] = 5,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(15562), 1,
      anon_sym_BQUOTE,
    ACTIONS(15570), 1,
      sym__tyconsym,
    STATE(14889), 3,
      sym_constructor_operator,
      sym__type_operator,
      sym__ticked_tycon,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480601] = 5,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(425), 1,
      sym__consym,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(20166), 3,
      sym_operator,
      sym__minus,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480622] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18159), 6,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [480637] = 3,
    STATE(12704), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17907), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [480654] = 7,
    ACTIONS(14017), 1,
      sym__conid,
    ACTIONS(16699), 1,
      sym__varid,
    STATE(12522), 1,
      sym_constructor,
    STATE(13244), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480679] = 7,
    ACTIONS(1789), 1,
      sym__conid,
    ACTIONS(17178), 1,
      sym__varid,
    STATE(7207), 1,
      sym_constructor,
    STATE(7482), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480704] = 4,
    ACTIONS(19051), 1,
      sym_comma,
    STATE(13813), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19071), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [480723] = 4,
    ACTIONS(19051), 1,
      sym_comma,
    STATE(13814), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19071), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [480742] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15976), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
  [480757] = 3,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18743), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [480774] = 7,
    ACTIONS(17909), 1,
      anon_sym_RBRACK,
    ACTIONS(17911), 1,
      anon_sym_PIPE,
    ACTIONS(17913), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17915), 1,
      sym__arith_dotdot,
    ACTIONS(17917), 1,
      sym_comma,
    STATE(15648), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480799] = 6,
    ACTIONS(13654), 1,
      sym__conid,
    STATE(12739), 1,
      sym__modid,
    STATE(13071), 1,
      sym_constructor,
    STATE(15144), 1,
      aux_sym__qualifying_module,
    STATE(12834), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480822] = 6,
    ACTIONS(13654), 1,
      sym__conid,
    STATE(12739), 1,
      sym__modid,
    STATE(13071), 1,
      sym_constructor,
    STATE(15144), 1,
      aux_sym__qualifying_module,
    STATE(13663), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480845] = 5,
    ACTIONS(18950), 1,
      anon_sym_LBRACE,
    ACTIONS(18952), 1,
      sym__layout_start,
    STATE(16894), 1,
      sym_decls,
    ACTIONS(18617), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480866] = 7,
    ACTIONS(4055), 1,
      sym__conid,
    ACTIONS(16443), 1,
      sym__varid,
    STATE(4309), 1,
      sym_constructor,
    STATE(4451), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480891] = 7,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19073), 1,
      sym_string,
    ACTIONS(19075), 1,
      anon_sym_LPAREN,
    STATE(13817), 1,
      sym_variable,
    STATE(14696), 1,
      sym_impent,
    STATE(16319), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480916] = 7,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19075), 1,
      anon_sym_LPAREN,
    ACTIONS(19077), 1,
      sym_string,
    STATE(13817), 1,
      sym_variable,
    STATE(14697), 1,
      sym_expent,
    STATE(16309), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480941] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2440), 1,
      sym__colon2,
    STATE(15218), 1,
      aux_sym_signature_repeat1,
    STATE(16291), 1,
      sym__type_annotation,
    ACTIONS(19067), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480964] = 6,
    ACTIONS(13558), 1,
      sym__conid,
    STATE(12792), 1,
      sym_constructor,
    STATE(12935), 1,
      sym__modid,
    STATE(14692), 1,
      aux_sym__qualifying_module,
    STATE(12968), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [480987] = 6,
    ACTIONS(13654), 1,
      sym__conid,
    STATE(12739), 1,
      sym__modid,
    STATE(13071), 1,
      sym_constructor,
    STATE(15144), 1,
      aux_sym__qualifying_module,
    STATE(12861), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481010] = 6,
    ACTIONS(13654), 1,
      sym__conid,
    STATE(12739), 1,
      sym__modid,
    STATE(13071), 1,
      sym_constructor,
    STATE(15144), 1,
      aux_sym__qualifying_module,
    STATE(13586), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481033] = 6,
    ACTIONS(13654), 1,
      sym__conid,
    STATE(12739), 1,
      sym__modid,
    STATE(13071), 1,
      sym_constructor,
    STATE(15144), 1,
      aux_sym__qualifying_module,
    STATE(13583), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481056] = 7,
    ACTIONS(13654), 1,
      sym__conid,
    ACTIONS(19079), 1,
      anon_sym_LPAREN,
    STATE(13136), 1,
      sym_constructor,
    STATE(13570), 1,
      sym_qualified_type,
    STATE(15304), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481081] = 7,
    ACTIONS(19081), 1,
      anon_sym_RBRACK,
    ACTIONS(19083), 1,
      anon_sym_PIPE,
    ACTIONS(19085), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19087), 1,
      sym__arith_dotdot,
    ACTIONS(19089), 1,
      sym_comma,
    STATE(16892), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481106] = 7,
    ACTIONS(9170), 1,
      sym__conid,
    ACTIONS(16423), 1,
      sym__varid,
    STATE(10763), 1,
      sym_constructor,
    STATE(11503), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481131] = 6,
    ACTIONS(13654), 1,
      sym__conid,
    STATE(12739), 1,
      sym__modid,
    STATE(13071), 1,
      sym_constructor,
    STATE(15144), 1,
      aux_sym__qualifying_module,
    STATE(13558), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481154] = 6,
    ACTIONS(13654), 1,
      sym__conid,
    STATE(12739), 1,
      sym__modid,
    STATE(13071), 1,
      sym_constructor,
    STATE(15144), 1,
      aux_sym__qualifying_module,
    STATE(13556), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481177] = 6,
    ACTIONS(13654), 1,
      sym__conid,
    STATE(12739), 1,
      sym__modid,
    STATE(13071), 1,
      sym_constructor,
    STATE(15144), 1,
      aux_sym__qualifying_module,
    STATE(13555), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481200] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [481215] = 7,
    ACTIONS(19091), 1,
      anon_sym_RBRACK,
    ACTIONS(19093), 1,
      anon_sym_PIPE,
    ACTIONS(19095), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19097), 1,
      sym__arith_dotdot,
    ACTIONS(19099), 1,
      sym_comma,
    STATE(16289), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481240] = 7,
    ACTIONS(4073), 1,
      sym__conid,
    ACTIONS(16417), 1,
      sym__varid,
    STATE(4651), 1,
      sym_constructor,
    STATE(5431), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481265] = 7,
    ACTIONS(6318), 1,
      sym__conid,
    ACTIONS(17062), 1,
      sym__varid,
    STATE(6268), 1,
      sym_constructor,
    STATE(6648), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481290] = 7,
    ACTIONS(3116), 1,
      sym__conid,
    ACTIONS(16786), 1,
      sym__varid,
    STATE(3906), 1,
      sym_constructor,
    STATE(4193), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481315] = 4,
    ACTIONS(19051), 1,
      sym_comma,
    STATE(13829), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19101), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [481334] = 5,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(16944), 1,
      sym__arrow,
    ACTIONS(19103), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(14078), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481355] = 4,
    ACTIONS(19051), 1,
      sym_comma,
    STATE(13814), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19101), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [481374] = 4,
    ACTIONS(19107), 1,
      sym_comma,
    STATE(13814), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19105), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [481393] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2381), 1,
      sym__colon2,
    STATE(15218), 1,
      aux_sym_signature_repeat1,
    STATE(15858), 1,
      sym__type_annotation,
    ACTIONS(15213), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481416] = 6,
    ACTIONS(13654), 1,
      sym__conid,
    STATE(12739), 1,
      sym__modid,
    STATE(13071), 1,
      sym_constructor,
    STATE(15144), 1,
      aux_sym__qualifying_module,
    STATE(13509), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481439] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2369), 1,
      sym__colon2,
    STATE(13926), 1,
      aux_sym_signature_repeat1,
    STATE(16688), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481462] = 7,
    ACTIONS(6971), 1,
      sym__conid,
    ACTIONS(16427), 1,
      sym__varid,
    STATE(7176), 1,
      sym_constructor,
    STATE(7498), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481487] = 4,
    ACTIONS(18815), 1,
      sym_comma,
    STATE(13514), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18929), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [481506] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2369), 1,
      sym__colon2,
    STATE(13938), 1,
      aux_sym_signature_repeat1,
    STATE(16772), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481529] = 7,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16518), 1,
      sym__consym,
    STATE(9387), 1,
      sym_constructor_operator,
    STATE(12858), 1,
      aux_sym__qualifying_module,
    STATE(13225), 1,
      sym_constructor,
    STATE(20542), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481554] = 5,
    ACTIONS(18950), 1,
      anon_sym_LBRACE,
    ACTIONS(18952), 1,
      sym__layout_start,
    STATE(16929), 1,
      sym_decls,
    ACTIONS(18656), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481575] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(19110), 1,
      anon_sym_EQ,
    STATE(18201), 1,
      sym__funrhs,
    STATE(19642), 1,
      sym_guards,
    STATE(13138), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481598] = 4,
    ACTIONS(19112), 1,
      anon_sym_deriving,
    STATE(13824), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18931), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481617] = 4,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    STATE(13824), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18936), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481636] = 7,
    ACTIONS(6629), 1,
      sym__conid,
    ACTIONS(16437), 1,
      sym__varid,
    STATE(5897), 1,
      sym_constructor,
    STATE(6007), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481661] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15465), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [481676] = 7,
    ACTIONS(19115), 1,
      anon_sym_RBRACK,
    ACTIONS(19117), 1,
      anon_sym_PIPE,
    ACTIONS(19119), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19121), 1,
      sym__arith_dotdot,
    ACTIONS(19123), 1,
      sym_comma,
    STATE(16987), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481701] = 4,
    ACTIONS(19051), 1,
      sym_comma,
    STATE(13814), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19125), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [481720] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15459), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [481735] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 6,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_deriving,
  [481750] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17696), 6,
      sym_where,
      sym__consym,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
      anon_sym_RBRACE,
  [481765] = 4,
    ACTIONS(19051), 1,
      sym_comma,
    STATE(13837), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19125), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [481784] = 7,
    ACTIONS(18000), 1,
      anon_sym_RBRACK,
    ACTIONS(18002), 1,
      anon_sym_PIPE,
    ACTIONS(18004), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18006), 1,
      sym__arith_dotdot,
    ACTIONS(18008), 1,
      sym_comma,
    STATE(15473), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481809] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 6,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_BQUOTE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [481824] = 7,
    ACTIONS(12515), 1,
      sym__conid,
    ACTIONS(17046), 1,
      sym__varid,
    STATE(8495), 1,
      sym_constructor,
    STATE(8823), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481849] = 4,
    ACTIONS(19051), 1,
      sym_comma,
    STATE(13814), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19127), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [481868] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(19110), 1,
      anon_sym_EQ,
    STATE(18063), 1,
      sym__funrhs,
    STATE(19642), 1,
      sym_guards,
    STATE(13138), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481891] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(19110), 1,
      anon_sym_EQ,
    STATE(18052), 1,
      sym__funrhs,
    STATE(19642), 1,
      sym_guards,
    STATE(13138), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481914] = 7,
    ACTIONS(13558), 1,
      sym__conid,
    ACTIONS(19129), 1,
      anon_sym_LPAREN,
    STATE(13387), 1,
      sym_constructor,
    STATE(13401), 1,
      sym_qualified_type,
    STATE(15092), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481939] = 7,
    ACTIONS(4541), 1,
      sym__conid,
    ACTIONS(16986), 1,
      sym__varid,
    STATE(9224), 1,
      sym_constructor,
    STATE(9253), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481964] = 7,
    ACTIONS(6352), 1,
      sym__conid,
    ACTIONS(16447), 1,
      sym__varid,
    STATE(5900), 1,
      sym_constructor,
    STATE(6000), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [481989] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 6,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [482004] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(13158), 1,
      sym__modid,
    STATE(13225), 1,
      sym_constructor,
    STATE(15293), 1,
      aux_sym__qualifying_module,
    STATE(13330), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482027] = 7,
    ACTIONS(12985), 1,
      sym__conid,
    ACTIONS(17196), 1,
      sym__varid,
    STATE(8659), 1,
      sym_constructor,
    STATE(8962), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482052] = 4,
    ACTIONS(18701), 1,
      anon_sym_PIPE,
    STATE(13917), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18811), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [482071] = 4,
    ACTIONS(18663), 1,
      anon_sym_via,
    STATE(15034), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18938), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [482090] = 4,
    ACTIONS(18701), 1,
      anon_sym_PIPE,
    STATE(13952), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18811), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [482109] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2360), 1,
      sym__colon2,
    STATE(15218), 1,
      aux_sym_signature_repeat1,
    STATE(17816), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482132] = 3,
    STATE(12527), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17875), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [482149] = 7,
    ACTIONS(8823), 1,
      sym__conid,
    ACTIONS(16453), 1,
      sym__varid,
    STATE(9577), 1,
      sym_constructor,
    STATE(9601), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482174] = 4,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    STATE(13392), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18940), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482193] = 7,
    ACTIONS(19131), 1,
      anon_sym_RBRACK,
    ACTIONS(19133), 1,
      anon_sym_PIPE,
    ACTIONS(19135), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19137), 1,
      sym__arith_dotdot,
    ACTIONS(19139), 1,
      sym_comma,
    STATE(17081), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482218] = 3,
    STATE(12853), 2,
      sym_type_role,
      aux_sym_decl_role_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18191), 4,
      anon_sym_representational,
      anon_sym_nominal,
      anon_sym_phantom,
      anon_sym__,
  [482235] = 4,
    ACTIONS(18663), 1,
      anon_sym_via,
    STATE(14879), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18779), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [482254] = 7,
    ACTIONS(6380), 1,
      sym__conid,
    ACTIONS(17156), 1,
      sym__varid,
    STATE(6855), 1,
      sym_constructor,
    STATE(7096), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482279] = 7,
    ACTIONS(19141), 1,
      anon_sym_RBRACK,
    ACTIONS(19143), 1,
      anon_sym_PIPE,
    ACTIONS(19145), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19147), 1,
      sym__arith_dotdot,
    ACTIONS(19149), 1,
      sym_comma,
    STATE(16497), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482304] = 7,
    ACTIONS(18020), 1,
      anon_sym_RBRACK,
    ACTIONS(18022), 1,
      anon_sym_PIPE,
    ACTIONS(18024), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18026), 1,
      sym__arith_dotdot,
    ACTIONS(18028), 1,
      sym_comma,
    STATE(15804), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482329] = 6,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18221), 1,
      anon_sym_LPAREN,
    STATE(14737), 1,
      sym_constructor,
    STATE(18567), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482352] = 4,
    ACTIONS(18701), 1,
      anon_sym_PIPE,
    STATE(13406), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18942), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [482371] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15437), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [482386] = 7,
    ACTIONS(655), 1,
      sym__conid,
    ACTIONS(16457), 1,
      sym__varid,
    STATE(4012), 1,
      sym_constructor,
    STATE(9161), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482411] = 4,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    STATE(13824), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18927), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482430] = 5,
    STATE(2404), 1,
      sym__colon2,
    STATE(17979), 1,
      sym__type_annotation,
    ACTIONS(15987), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(17475), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482451] = 6,
    ACTIONS(16572), 1,
      anon_sym_deriving,
    ACTIONS(17433), 1,
      sym__conid,
    ACTIONS(18597), 1,
      anon_sym_LPAREN,
    STATE(15279), 1,
      sym_constructor,
    STATE(17380), 2,
      sym_deriving,
      sym_gadt_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482474] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(13158), 1,
      sym__modid,
    STATE(13225), 1,
      sym_constructor,
    STATE(15293), 1,
      aux_sym__qualifying_module,
    STATE(14124), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482497] = 7,
    ACTIONS(19151), 1,
      anon_sym_RBRACK,
    ACTIONS(19153), 1,
      anon_sym_PIPE,
    ACTIONS(19155), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19157), 1,
      sym__arith_dotdot,
    ACTIONS(19159), 1,
      sym_comma,
    STATE(17167), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482522] = 4,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    STATE(13447), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18946), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482541] = 7,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19073), 1,
      sym_string,
    ACTIONS(19161), 1,
      anon_sym_LPAREN,
    STATE(13886), 1,
      sym_variable,
    STATE(15015), 1,
      sym_impent,
    STATE(18184), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482566] = 7,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19077), 1,
      sym_string,
    ACTIONS(19161), 1,
      anon_sym_LPAREN,
    STATE(13886), 1,
      sym_variable,
    STATE(15019), 1,
      sym_expent,
    STATE(18190), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482591] = 3,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18715), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [482608] = 4,
    ACTIONS(18663), 1,
      anon_sym_via,
    STATE(15102), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18836), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [482627] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2360), 1,
      sym__colon2,
    STATE(15218), 1,
      aux_sym_signature_repeat1,
    STATE(18266), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482650] = 7,
    ACTIONS(17919), 1,
      anon_sym_RBRACK,
    ACTIONS(17921), 1,
      anon_sym_PIPE,
    ACTIONS(17923), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17925), 1,
      sym__arith_dotdot,
    ACTIONS(17927), 1,
      sym_comma,
    STATE(15905), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482675] = 7,
    ACTIONS(19163), 1,
      anon_sym_RBRACK,
    ACTIONS(19165), 1,
      anon_sym_PIPE,
    ACTIONS(19167), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19169), 1,
      sym__arith_dotdot,
    ACTIONS(19171), 1,
      sym_comma,
    STATE(17356), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482700] = 7,
    ACTIONS(4439), 1,
      sym__conid,
    ACTIONS(17130), 1,
      sym__varid,
    STATE(10817), 1,
      sym_constructor,
    STATE(10872), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482725] = 4,
    ACTIONS(18663), 1,
      anon_sym_via,
    STATE(15089), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18834), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [482744] = 3,
    ACTIONS(19175), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19173), 5,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [482761] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15489), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [482776] = 7,
    ACTIONS(7243), 1,
      sym__conid,
    ACTIONS(16479), 1,
      sym__varid,
    STATE(6033), 1,
      sym_constructor,
    STATE(6433), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482801] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(13158), 1,
      sym__modid,
    STATE(13225), 1,
      sym_constructor,
    STATE(15293), 1,
      aux_sym__qualifying_module,
    STATE(14264), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482824] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(13158), 1,
      sym__modid,
    STATE(13225), 1,
      sym_constructor,
    STATE(15293), 1,
      aux_sym__qualifying_module,
    STATE(14267), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482847] = 7,
    ACTIONS(14001), 1,
      sym__conid,
    ACTIONS(16879), 1,
      sym__varid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(14516), 1,
      sym_constructor,
    STATE(14535), 1,
      sym_variable,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482872] = 7,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(19177), 1,
      anon_sym_LPAREN,
    STATE(13562), 1,
      sym_constructor,
    STATE(14325), 1,
      sym_qualified_type,
    STATE(14747), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482897] = 7,
    ACTIONS(14001), 1,
      sym__conid,
    ACTIONS(19179), 1,
      anon_sym_LPAREN,
    STATE(14104), 1,
      sym_constructor,
    STATE(14932), 1,
      aux_sym__qualifying_module,
    STATE(15270), 1,
      sym_qualified_type,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482922] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2360), 1,
      sym__colon2,
    STATE(13849), 1,
      aux_sym_signature_repeat1,
    STATE(18067), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482945] = 6,
    ACTIONS(17714), 1,
      sym__conid,
    STATE(13225), 1,
      sym_constructor,
    STATE(13887), 1,
      aux_sym__qualifying_module,
    STATE(20197), 1,
      sym__modid,
    ACTIONS(17712), 2,
      sym__varsym,
      anon_sym_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482968] = 7,
    ACTIONS(4487), 1,
      sym__conid,
    ACTIONS(16903), 1,
      sym__varid,
    STATE(9619), 1,
      sym_constructor,
    STATE(9958), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [482993] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15447), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [483008] = 6,
    ACTIONS(14001), 1,
      sym__conid,
    STATE(14878), 1,
      aux_sym__qualifying_module,
    STATE(15610), 1,
      sym__modid,
    STATE(16605), 1,
      sym_constructor,
    STATE(18818), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483031] = 6,
    ACTIONS(13558), 1,
      sym__conid,
    STATE(12792), 1,
      sym_constructor,
    STATE(12935), 1,
      sym__modid,
    STATE(14692), 1,
      aux_sym__qualifying_module,
    STATE(13023), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483054] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(13158), 1,
      sym__modid,
    STATE(13225), 1,
      sym_constructor,
    STATE(15293), 1,
      aux_sym__qualifying_module,
    STATE(14354), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483077] = 5,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    STATE(16370), 1,
      sym_import_list,
    ACTIONS(18591), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483098] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15451), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [483113] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15455), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [483128] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(13158), 1,
      sym__modid,
    STATE(13225), 1,
      sym_constructor,
    STATE(15293), 1,
      aux_sym__qualifying_module,
    STATE(14358), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483151] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(13158), 1,
      sym__modid,
    STATE(13225), 1,
      sym_constructor,
    STATE(15293), 1,
      aux_sym__qualifying_module,
    STATE(14360), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483174] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15473), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [483189] = 6,
    ACTIONS(13558), 1,
      sym__conid,
    STATE(12792), 1,
      sym_constructor,
    STATE(12935), 1,
      sym__modid,
    STATE(14692), 1,
      aux_sym__qualifying_module,
    STATE(13893), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483212] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(13158), 1,
      sym__modid,
    STATE(13225), 1,
      sym_constructor,
    STATE(15293), 1,
      aux_sym__qualifying_module,
    STATE(13323), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483235] = 7,
    ACTIONS(13853), 1,
      sym__conid,
    ACTIONS(16489), 1,
      sym__varid,
    STATE(12216), 1,
      sym_constructor,
    STATE(12668), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483260] = 7,
    ACTIONS(13923), 1,
      sym__conid,
    ACTIONS(17100), 1,
      sym__varid,
    STATE(12686), 1,
      sym_constructor,
    STATE(13215), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483285] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(13158), 1,
      sym__modid,
    STATE(13225), 1,
      sym_constructor,
    STATE(15293), 1,
      aux_sym__qualifying_module,
    STATE(14434), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483308] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17696), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [483323] = 7,
    ACTIONS(4349), 1,
      sym__conid,
    ACTIONS(17040), 1,
      sym__varid,
    STATE(10712), 1,
      sym_constructor,
    STATE(11108), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483348] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2360), 1,
      sym__colon2,
    STATE(13873), 1,
      aux_sym_signature_repeat1,
    STATE(18047), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483371] = 4,
    ACTIONS(18663), 1,
      anon_sym_via,
    STATE(14917), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18791), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [483390] = 7,
    ACTIONS(12655), 1,
      sym__conid,
    ACTIONS(17028), 1,
      sym__varid,
    STATE(7964), 1,
      sym_constructor,
    STATE(8406), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483415] = 4,
    ACTIONS(18663), 1,
      anon_sym_via,
    STATE(14918), 1,
      sym_via,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18803), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [483434] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15477), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [483449] = 7,
    ACTIONS(4373), 1,
      sym__conid,
    ACTIONS(17150), 1,
      sym__varid,
    STATE(10118), 1,
      sym_constructor,
    STATE(10421), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483474] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [483489] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [483504] = 7,
    ACTIONS(8476), 1,
      sym__conid,
    ACTIONS(16616), 1,
      sym__varid,
    STATE(10187), 1,
      sym_constructor,
    STATE(10443), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483529] = 7,
    ACTIONS(19181), 1,
      anon_sym_RBRACK,
    ACTIONS(19183), 1,
      anon_sym_PIPE,
    ACTIONS(19185), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19187), 1,
      sym__arith_dotdot,
    ACTIONS(19189), 1,
      sym_comma,
    STATE(16714), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483554] = 6,
    ACTIONS(13558), 1,
      sym__conid,
    STATE(12792), 1,
      sym_constructor,
    STATE(12935), 1,
      sym__modid,
    STATE(14692), 1,
      aux_sym__qualifying_module,
    STATE(13587), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483577] = 4,
    ACTIONS(18701), 1,
      anon_sym_PIPE,
    STATE(13952), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18805), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [483596] = 4,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    STATE(13824), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(19024), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483615] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(19191), 1,
      anon_sym_EQ,
    STATE(14622), 1,
      sym__funrhs,
    STATE(19716), 1,
      sym_guards,
    STATE(12619), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483638] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15513), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [483653] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15493), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [483668] = 7,
    ACTIONS(10541), 1,
      sym__conid,
    ACTIONS(16996), 1,
      sym__varid,
    STATE(8011), 1,
      sym_constructor,
    STATE(8448), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483693] = 7,
    ACTIONS(13626), 1,
      sym__conid,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(13128), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(13772), 1,
      sym_variable,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483718] = 7,
    ACTIONS(4565), 1,
      sym__conid,
    ACTIONS(17218), 1,
      sym__varid,
    STATE(10230), 1,
      sym_constructor,
    STATE(10528), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483743] = 7,
    ACTIONS(8679), 1,
      sym__conid,
    ACTIONS(16972), 1,
      sym__varid,
    STATE(10545), 1,
      sym_constructor,
    STATE(10899), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483768] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2369), 1,
      sym__colon2,
    STATE(15218), 1,
      aux_sym_signature_repeat1,
    STATE(16771), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483791] = 7,
    ACTIONS(4267), 1,
      sym__conid,
    ACTIONS(16956), 1,
      sym__varid,
    STATE(4266), 1,
      sym_constructor,
    STATE(4424), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483816] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15501), 6,
      sym__layout_semicolon,
      sym__consym,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      sym__conid,
  [483831] = 4,
    STATE(2819), 1,
      sym__arrow,
    ACTIONS(19195), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(19193), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483850] = 3,
    ACTIONS(19199), 2,
      sym_string,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19197), 4,
      sym__varid,
      anon_sym_unsafe,
      anon_sym_safe,
      anon_sym_interruptible,
  [483867] = 7,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19073), 1,
      sym_string,
    ACTIONS(19201), 1,
      anon_sym_LPAREN,
    STATE(13775), 1,
      sym_variable,
    STATE(14745), 1,
      sym_impent,
    STATE(16174), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483892] = 6,
    ACTIONS(13558), 1,
      sym__conid,
    STATE(12792), 1,
      sym_constructor,
    STATE(12935), 1,
      sym__modid,
    STATE(14692), 1,
      aux_sym__qualifying_module,
    STATE(13600), 2,
      sym_qualified_module,
      sym__qmodid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483915] = 7,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19077), 1,
      sym_string,
    ACTIONS(19201), 1,
      anon_sym_LPAREN,
    STATE(13775), 1,
      sym_variable,
    STATE(14717), 1,
      sym_expent,
    STATE(16176), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483940] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19203), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [483955] = 7,
    ACTIONS(12923), 1,
      sym__conid,
    ACTIONS(16683), 1,
      sym__varid,
    STATE(7819), 1,
      sym_constructor,
    STATE(8038), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [483980] = 7,
    ACTIONS(4205), 1,
      sym__conid,
    ACTIONS(16931), 1,
      sym__varid,
    STATE(3880), 1,
      sym_constructor,
    STATE(3982), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484005] = 7,
    ACTIONS(17851), 1,
      anon_sym_RBRACK,
    ACTIONS(17853), 1,
      anon_sym_PIPE,
    ACTIONS(17855), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17857), 1,
      sym__arith_dotdot,
    ACTIONS(17859), 1,
      sym_comma,
    STATE(16274), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484030] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2369), 1,
      sym__colon2,
    STATE(15218), 1,
      aux_sym_signature_repeat1,
    STATE(16905), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484053] = 7,
    ACTIONS(5286), 1,
      sym__conid,
    ACTIONS(16522), 1,
      sym__varid,
    STATE(7292), 1,
      sym_constructor,
    STATE(7541), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484078] = 7,
    ACTIONS(9100), 1,
      sym__conid,
    ACTIONS(16913), 1,
      sym__varid,
    STATE(10485), 1,
      sym_constructor,
    STATE(11020), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484103] = 5,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(18257), 1,
      anon_sym_LPAREN,
    STATE(18759), 3,
      sym_variable,
      sym_constructor,
      sym__name,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484124] = 7,
    ACTIONS(6056), 1,
      sym__conid,
    ACTIONS(16808), 1,
      sym__varid,
    STATE(7620), 1,
      sym_constructor,
    STATE(7808), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484149] = 7,
    ACTIONS(6153), 1,
      sym__conid,
    ACTIONS(16790), 1,
      sym__varid,
    STATE(7610), 1,
      sym_constructor,
    STATE(7744), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484174] = 5,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(18551), 1,
      anon_sym_LPAREN,
    STATE(18850), 3,
      sym_variable,
      sym_constructor,
      sym__import_name,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484195] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(18695), 1,
      anon_sym_EQ,
    STATE(17163), 1,
      sym__funrhs,
    STATE(19685), 1,
      sym_guards,
    STATE(12882), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484218] = 7,
    ACTIONS(7383), 1,
      sym__conid,
    ACTIONS(16756), 1,
      sym__varid,
    STATE(7389), 1,
      sym_constructor,
    STATE(7695), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484243] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(19191), 1,
      anon_sym_EQ,
    STATE(15013), 1,
      sym__funrhs,
    STATE(19716), 1,
      sym_guards,
    STATE(12619), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484266] = 7,
    ACTIONS(7215), 1,
      sym__conid,
    ACTIONS(16528), 1,
      sym__varid,
    STATE(6478), 1,
      sym_constructor,
    STATE(6737), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484291] = 5,
    ACTIONS(18269), 1,
      anon_sym_LPAREN,
    ACTIONS(18271), 1,
      anon_sym_hiding,
    STATE(17121), 1,
      sym_import_list,
    ACTIONS(18809), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484312] = 7,
    ACTIONS(19205), 1,
      anon_sym_RBRACK,
    ACTIONS(19207), 1,
      anon_sym_PIPE,
    ACTIONS(19209), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19211), 1,
      sym__arith_dotdot,
    ACTIONS(19213), 1,
      sym_comma,
    STATE(16867), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484337] = 7,
    ACTIONS(8765), 1,
      sym__conid,
    ACTIONS(16671), 1,
      sym__varid,
    STATE(10929), 1,
      sym_constructor,
    STATE(11893), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484362] = 4,
    ACTIONS(19215), 1,
      anon_sym_PIPE,
    STATE(13952), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18838), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [484381] = 7,
    ACTIONS(4193), 1,
      sym__conid,
    ACTIONS(16752), 1,
      sym__varid,
    STATE(4549), 1,
      sym_constructor,
    STATE(5067), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484406] = 6,
    ACTIONS(1980), 1,
      anon_sym_PIPE,
    ACTIONS(18695), 1,
      anon_sym_EQ,
    STATE(17132), 1,
      sym__funrhs,
    STATE(19685), 1,
      sym_guards,
    STATE(12882), 2,
      sym_guard_equation,
      aux_sym__fun_guards,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484429] = 7,
    ACTIONS(4153), 1,
      sym__conid,
    ACTIONS(16743), 1,
      sym__varid,
    STATE(5306), 1,
      sym_constructor,
    STATE(5671), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484454] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2366), 1,
      sym__colon2,
    STATE(15055), 1,
      sym__type_annotation,
    STATE(15218), 1,
      aux_sym_signature_repeat1,
    ACTIONS(19218), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484477] = 3,
    ACTIONS(19222), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19220), 5,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [484494] = 5,
    ACTIONS(19020), 1,
      anon_sym_LBRACE,
    ACTIONS(19022), 1,
      sym__layout_start,
    STATE(16210), 1,
      sym_decls,
    ACTIONS(18617), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484515] = 7,
    ACTIONS(12785), 1,
      sym__conid,
    ACTIONS(16534), 1,
      sym__varid,
    STATE(8061), 1,
      sym_constructor,
    STATE(8615), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484540] = 7,
    ACTIONS(4087), 1,
      sym__conid,
    ACTIONS(16733), 1,
      sym__varid,
    STATE(3472), 1,
      sym_constructor,
    STATE(3708), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484565] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15976), 6,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
  [484580] = 7,
    ACTIONS(18034), 1,
      anon_sym_RBRACK,
    ACTIONS(18036), 1,
      anon_sym_PIPE,
    ACTIONS(18038), 1,
      anon_sym_DOT_DOT,
    ACTIONS(18040), 1,
      sym__arith_dotdot,
    ACTIONS(18042), 1,
      sym_comma,
    STATE(15984), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484605] = 7,
    ACTIONS(12537), 1,
      sym__conid,
    ACTIONS(16711), 1,
      sym__varid,
    STATE(8267), 1,
      sym_constructor,
    STATE(8910), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484630] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2381), 1,
      sym__colon2,
    STATE(15218), 1,
      aux_sym_signature_repeat1,
    STATE(16231), 1,
      sym__type_annotation,
    ACTIONS(15213), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484653] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2366), 1,
      sym__colon2,
    STATE(15180), 1,
      sym__type_annotation,
    STATE(15218), 1,
      aux_sym_signature_repeat1,
    ACTIONS(19218), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484676] = 7,
    ACTIONS(4111), 1,
      sym__conid,
    ACTIONS(16469), 1,
      sym__varid,
    STATE(9480), 1,
      sym_constructor,
    STATE(9561), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484701] = 7,
    ACTIONS(12709), 1,
      sym__conid,
    ACTIONS(16705), 1,
      sym__varid,
    STATE(8138), 1,
      sym_constructor,
    STATE(8452), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484726] = 6,
    ACTIONS(13711), 1,
      sym_comma,
    STATE(2381), 1,
      sym__colon2,
    STATE(13964), 1,
      aux_sym_signature_repeat1,
    STATE(15914), 1,
      sym__type_annotation,
    ACTIONS(15213), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484749] = 7,
    ACTIONS(17895), 1,
      anon_sym_RBRACK,
    ACTIONS(17897), 1,
      anon_sym_PIPE,
    ACTIONS(17899), 1,
      anon_sym_DOT_DOT,
    ACTIONS(17901), 1,
      sym__arith_dotdot,
    ACTIONS(17903), 1,
      sym_comma,
    STATE(17107), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484774] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 6,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [484789] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 6,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [484804] = 4,
    ACTIONS(16630), 1,
      anon_sym_deriving,
    STATE(13824), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(18927), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484823] = 7,
    ACTIONS(4143), 1,
      sym__conid,
    ACTIONS(16634), 1,
      sym__varid,
    STATE(4322), 1,
      sym_constructor,
    STATE(4759), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484848] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18279), 6,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [484863] = 7,
    ACTIONS(14035), 1,
      sym__conid,
    ACTIONS(16540), 1,
      sym__varid,
    STATE(12570), 1,
      sym_constructor,
    STATE(13182), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484888] = 7,
    ACTIONS(19224), 1,
      anon_sym_RBRACK,
    ACTIONS(19226), 1,
      anon_sym_PIPE,
    ACTIONS(19228), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19230), 1,
      sym__arith_dotdot,
    ACTIONS(19232), 1,
      sym_comma,
    STATE(16375), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484913] = 7,
    ACTIONS(1402), 1,
      sym__conid,
    ACTIONS(16982), 1,
      sym__varid,
    STATE(3823), 1,
      sym_constructor,
    STATE(3859), 1,
      sym_variable,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484938] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18292), 6,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [484953] = 4,
    ACTIONS(19234), 1,
      anon_sym_PIPE,
    STATE(14760), 1,
      sym_tyfam_injectivity,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18992), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [484972] = 7,
    ACTIONS(13558), 1,
      sym__conid,
    ACTIONS(16592), 1,
      sym__varid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(14066), 1,
      sym_constructor,
    STATE(15368), 1,
      sym_variable,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [484997] = 4,
    ACTIONS(19236), 1,
      sym_comma,
    STATE(13981), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18827), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [485016] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19243), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17691), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485038] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19245), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
  [485052] = 4,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(19024), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14164), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485070] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19247), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16840), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485092] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485106] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18205), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16007), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485128] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19249), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17809), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485150] = 5,
    ACTIONS(19251), 1,
      sym__immediate_dot,
    ACTIONS(19253), 1,
      anon_sym_EQ,
    STATE(14259), 1,
      aux_sym_exp_field_repeat1,
    ACTIONS(19255), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485170] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19259), 1,
      sym__unboxed_close,
    STATE(15482), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485192] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485206] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19261), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16026), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485228] = 3,
    STATE(2648), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19263), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485244] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 5,
      sym__dot,
      sym_comma,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [485258] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19265), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17797), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485280] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19267), 1,
      sym__unboxed_close,
    STATE(15497), 1,
      aux_sym_type_list_repeat1,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485302] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485316] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485330] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19269), 1,
      sym__unboxed_close,
    STATE(15580), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485352] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485366] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19271), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(16881), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485388] = 3,
    STATE(2543), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19273), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485404] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19275), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17774), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485426] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19277), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16870), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485448] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19279), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16945), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485470] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485484] = 3,
    STATE(2625), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19281), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485500] = 5,
    ACTIONS(19283), 1,
      anon_sym_LBRACE,
    ACTIONS(19285), 1,
      sym__layout_start,
    STATE(18200), 1,
      sym_decls,
    ACTIONS(18617), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485520] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485534] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19287), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(16008), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485556] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19289), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16784), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485578] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485592] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485606] = 5,
    ACTIONS(19291), 1,
      anon_sym_RPAREN,
    ACTIONS(19293), 1,
      sym_comma,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485626] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19295), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17743), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485648] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485662] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485676] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485690] = 3,
    STATE(2607), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19297), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485706] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18279), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [485720] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19299), 1,
      sym__unboxed_close,
    STATE(15943), 1,
      aux_sym_type_list_repeat1,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485742] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18292), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [485756] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485770] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485784] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19301), 1,
      sym__unboxed_close,
    STATE(15481), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485806] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18340), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16627), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485828] = 4,
    ACTIONS(19305), 1,
      anon_sym_LBRACE,
    ACTIONS(19307), 1,
      sym__layout_start,
    ACTIONS(19303), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485846] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [485860] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [485874] = 3,
    STATE(2550), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19309), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485890] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [485904] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19311), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16352), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485926] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [485940] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [485954] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [485968] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [485982] = 3,
    STATE(2521), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19313), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [485998] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486012] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486026] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486040] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486054] = 3,
    STATE(2656), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19315), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486070] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486084] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [486098] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486112] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19317), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17712), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486134] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19319), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16895), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486156] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486170] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486184] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486198] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17712), 5,
      sym__varsym,
      sym__consym,
      sym__tyconsym,
      anon_sym_DASH,
      sym__conid,
  [486212] = 3,
    STATE(2530), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19321), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486228] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486242] = 3,
    ACTIONS(17712), 2,
      sym__consym,
      sym__conid,
    ACTIONS(17710), 3,
      sym__varid,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486258] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19323), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486272] = 3,
    STATE(2538), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19325), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486288] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486302] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19327), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17783), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486324] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18088), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16285), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486346] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486360] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19329), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17771), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486382] = 3,
    STATE(2662), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19331), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486398] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19333), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17681), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486420] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19335), 1,
      sym__unboxed_close,
    STATE(15519), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486442] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19337), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(17583), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486464] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [486480] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19339), 1,
      sym__unboxed_close,
    STATE(15595), 1,
      aux_sym_type_list_repeat1,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486502] = 4,
    ACTIONS(19341), 1,
      anon_sym_PIPE,
    STATE(15903), 1,
      sym_tyfam_injectivity,
    ACTIONS(18992), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486520] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19343), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16917), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486542] = 5,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19345), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486562] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19347), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16767), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486584] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19349), 1,
      sym__unboxed_close,
    STATE(15675), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486606] = 4,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(18927), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14164), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486624] = 3,
    STATE(2633), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19351), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486640] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19353), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17650), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486662] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19220), 5,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [486676] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [486692] = 4,
    ACTIONS(19355), 1,
      sym__varid,
    ACTIONS(18290), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    STATE(14078), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486710] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18159), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [486724] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [486738] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19358), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16807), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486760] = 3,
    STATE(2602), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19360), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486776] = 4,
    ACTIONS(19362), 1,
      sym_comma,
    STATE(14572), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19125), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486794] = 3,
    STATE(2628), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19364), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486810] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19366), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(15920), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486832] = 4,
    ACTIONS(19362), 1,
      sym_comma,
    STATE(14087), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19125), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486850] = 4,
    ACTIONS(19362), 1,
      sym_comma,
    STATE(14572), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19127), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486868] = 3,
    STATE(2576), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19368), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486884] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19370), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16744), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486906] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19372), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16719), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486928] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19374), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17619), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486950] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19376), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16984), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [486972] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [486986] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19378), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16692), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487008] = 5,
    ACTIONS(17893), 1,
      anon_sym_EQ,
    STATE(2360), 1,
      sym__colon2,
    STATE(20399), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487028] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19380), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16665), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487050] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [487064] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [487078] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19382), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17528), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487100] = 5,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19384), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487120] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [487134] = 3,
    STATE(2565), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19386), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487150] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [487164] = 5,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(19388), 1,
      anon_sym_LPAREN,
    STATE(18186), 1,
      sym_export_names,
    ACTIONS(19390), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487184] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18318), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(17145), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487206] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19392), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17588), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487228] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19394), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17749), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487250] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [487264] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19396), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16637), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487286] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [487300] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19398), 5,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [487314] = 5,
    ACTIONS(19251), 1,
      sym__immediate_dot,
    ACTIONS(19400), 1,
      anon_sym_EQ,
    STATE(14559), 1,
      aux_sym_exp_field_repeat1,
    ACTIONS(19402), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487334] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18827), 5,
      sym__layout_semicolon,
      sym_where,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [487348] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19404), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17557), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487370] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19406), 1,
      sym__unboxed_close,
    STATE(15520), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487392] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [487406] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [487420] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18147), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16185), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487442] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [487456] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [487470] = 4,
    ACTIONS(19410), 1,
      sym_comma,
    STATE(14388), 1,
      aux_sym_guards_repeat1,
    ACTIONS(19408), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487488] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19412), 1,
      sym__unboxed_close,
    STATE(15627), 1,
      aux_sym_type_list_repeat1,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487510] = 3,
    STATE(2659), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19414), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487526] = 5,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    STATE(18355), 1,
      sym_import_list,
    ACTIONS(18591), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487546] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19416), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17526), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487568] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19418), 1,
      sym__unboxed_close,
    STATE(15690), 1,
      aux_sym_type_list_repeat1,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487590] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19420), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16690), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487612] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19422), 1,
      sym__unboxed_close,
    STATE(15770), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487634] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [487648] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19424), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
  [487662] = 3,
    STATE(2515), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19426), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487678] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [487692] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [487706] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [487722] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [487738] = 4,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(18946), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14274), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487756] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [487770] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [487784] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [487798] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19428), 1,
      sym__unboxed_close,
    STATE(15653), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487820] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19430), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17495), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487842] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [487856] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19432), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17015), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487878] = 3,
    STATE(2504), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19434), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487894] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [487908] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19436), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17727), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487930] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [487944] = 4,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(18927), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14164), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487962] = 4,
    ACTIONS(19438), 1,
      sym_comma,
    STATE(14183), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19127), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487980] = 3,
    STATE(2608), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19440), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [487996] = 4,
    ACTIONS(19442), 1,
      anon_sym_PIPE,
    STATE(14290), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(18942), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488014] = 3,
    STATE(2570), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19444), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488030] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19446), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17464), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488052] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [488066] = 4,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(18940), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14304), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488084] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [488098] = 4,
    ACTIONS(19438), 1,
      sym_comma,
    STATE(14149), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19125), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488116] = 4,
    ACTIONS(19438), 1,
      sym_comma,
    STATE(14183), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19125), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488134] = 4,
    ACTIONS(18310), 1,
      anon_sym_via,
    STATE(16084), 1,
      sym_via,
    ACTIONS(18938), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488152] = 3,
    STATE(2634), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19448), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488168] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19450), 1,
      sym__unboxed_close,
    STATE(15785), 1,
      aux_sym_type_list_repeat1,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488190] = 4,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(18936), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14164), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488208] = 4,
    STATE(553), 1,
      sym__arrow,
    ACTIONS(19452), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(19454), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488226] = 4,
    ACTIONS(19456), 1,
      anon_sym_deriving,
    ACTIONS(18931), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14164), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488244] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18247), 1,
      sym__unboxed_close,
    STATE(15817), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488266] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19459), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(15865), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488288] = 3,
    STATE(2610), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19461), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488304] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19463), 1,
      sym__unboxed_close,
    STATE(15850), 1,
      aux_sym_type_list_repeat1,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488326] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [488340] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [488354] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [488368] = 4,
    ACTIONS(19465), 1,
      sym_comma,
    STATE(14332), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(18929), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488386] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19467), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16956), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488408] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19469), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [488422] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19471), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [488436] = 5,
    ACTIONS(19283), 1,
      anon_sym_LBRACE,
    ACTIONS(19285), 1,
      sym__layout_start,
    STATE(18453), 1,
      sym_decls,
    ACTIONS(18656), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488456] = 3,
    STATE(2525), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19473), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488472] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [488486] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [488500] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [488514] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19475), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17433), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488536] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15574), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [488550] = 4,
    ACTIONS(19477), 1,
      sym_comma,
    STATE(14183), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19105), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488568] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [488582] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [488596] = 4,
    ACTIONS(19438), 1,
      sym_comma,
    STATE(14183), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19101), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488614] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [488628] = 4,
    ACTIONS(19438), 1,
      sym_comma,
    STATE(14158), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19101), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488646] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [488660] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16018), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [488674] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [488688] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [488702] = 3,
    STATE(2655), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19480), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488718] = 4,
    ACTIONS(19362), 1,
      sym_comma,
    STATE(14572), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19071), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488736] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19482), 1,
      sym__unboxed_close,
    STATE(15880), 1,
      aux_sym_type_list_repeat1,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488758] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15578), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [488772] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19484), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(17788), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488794] = 3,
    STATE(2520), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19486), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488810] = 4,
    ACTIONS(19362), 1,
      sym_comma,
    STATE(14562), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19071), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488828] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19488), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(17313), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488850] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19490), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17711), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488872] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19492), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17402), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488894] = 3,
    STATE(2524), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19494), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488910] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19496), 1,
      sym__unboxed_close,
    STATE(15818), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488932] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19498), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(15960), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488954] = 5,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19500), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488974] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19502), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(16630), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [488996] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18410), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(17315), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489018] = 5,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19504), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489038] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [489052] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14933), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489066] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19506), 1,
      sym__unboxed_close,
    STATE(15828), 1,
      aux_sym_type_list_repeat1,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489088] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19508), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17371), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489110] = 4,
    ACTIONS(17847), 1,
      sym_where,
    STATE(16148), 1,
      sym_class_body,
    ACTIONS(19510), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489128] = 5,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19512), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489148] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19514), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [489162] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19516), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16440), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489184] = 5,
    ACTIONS(5017), 1,
      sym__layout_end,
    ACTIONS(18970), 1,
      anon_sym_in,
    STATE(14309), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(19518), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489204] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489218] = 4,
    ACTIONS(19522), 1,
      anon_sym_LBRACE,
    ACTIONS(19524), 1,
      sym__layout_start,
    ACTIONS(19520), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489236] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489250] = 5,
    ACTIONS(19528), 1,
      sym_comma,
    STATE(2348), 1,
      sym__colon2,
    STATE(14923), 1,
      aux_sym_field_repeat1,
    ACTIONS(19526), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489270] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489284] = 4,
    STATE(2815), 1,
      sym__arrow,
    ACTIONS(19193), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(19530), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489302] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489316] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19532), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17055), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489338] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19534), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17340), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489360] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489374] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489388] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14931), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489402] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19536), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [489416] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489430] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489444] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19538), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17271), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489466] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489480] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489494] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19540), 1,
      sym__unboxed_close,
    STATE(15975), 1,
      aux_sym_type_list_repeat1,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489516] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489530] = 5,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19542), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489550] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19544), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16853), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489572] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489586] = 3,
    STATE(2536), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19546), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489602] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19548), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(17150), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489624] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(17696), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [489638] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19550), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17309), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489660] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19514), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [489674] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19552), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16055), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489696] = 4,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(18893), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14164), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489714] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19554), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(15894), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489736] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489750] = 4,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(18739), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14164), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489768] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489782] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 5,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [489796] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [489810] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19556), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17073), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489832] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19558), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17278), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489854] = 5,
    ACTIONS(19251), 1,
      sym__immediate_dot,
    ACTIONS(19560), 1,
      anon_sym_EQ,
    STATE(13989), 1,
      aux_sym_exp_field_repeat1,
    ACTIONS(19562), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489874] = 4,
    ACTIONS(19564), 1,
      sym_comma,
    STATE(14415), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19127), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489892] = 4,
    ACTIONS(19566), 1,
      sym__immediate_dot,
    STATE(14259), 1,
      aux_sym_exp_field_repeat1,
    ACTIONS(19569), 3,
      sym_comma,
      anon_sym_EQ,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489910] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18827), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
  [489924] = 3,
    STATE(2617), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19571), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489940] = 3,
    STATE(2575), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19573), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489956] = 3,
    ACTIONS(19577), 1,
      sym_where,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19575), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [489972] = 5,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    STATE(18462), 1,
      sym_import_list,
    ACTIONS(18879), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [489992] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19579), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17091), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490014] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [490028] = 5,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    STATE(18469), 1,
      sym_import_list,
    ACTIONS(18877), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490048] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19581), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17117), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490070] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18462), 1,
      sym__unboxed_close,
    STATE(15487), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490092] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490106] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15419), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [490120] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19583), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17247), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490142] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490156] = 4,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(18741), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14164), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490174] = 4,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(18739), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14164), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490192] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15574), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490206] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [490220] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18838), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490234] = 4,
    ACTIONS(19587), 1,
      anon_sym_LBRACE,
    ACTIONS(19589), 1,
      sym__layout_start,
    ACTIONS(19585), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490252] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15578), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490266] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19591), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17646), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490288] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19593), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490302] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15976), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
  [490316] = 5,
    ACTIONS(17871), 1,
      anon_sym_EQ,
    STATE(2360), 1,
      sym__colon2,
    STATE(19793), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490336] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490350] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19595), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
  [490364] = 4,
    ACTIONS(19438), 1,
      sym_comma,
    STATE(14183), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19071), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490382] = 4,
    ACTIONS(19438), 1,
      sym_comma,
    STATE(14186), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19071), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490400] = 4,
    ACTIONS(19442), 1,
      anon_sym_PIPE,
    STATE(14366), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(18699), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490418] = 4,
    ACTIONS(19442), 1,
      anon_sym_PIPE,
    STATE(14372), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(18699), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490436] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18537), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16880), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490458] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19597), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16070), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490480] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19599), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17146), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490502] = 6,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(17668), 1,
      sym__conid,
    ACTIONS(19601), 1,
      anon_sym_LPAREN,
    STATE(14980), 1,
      sym_constructor,
    STATE(18584), 1,
      sym_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490524] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19603), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16150), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490546] = 3,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(18715), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490562] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19605), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(16109), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490584] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490598] = 5,
    ACTIONS(18907), 1,
      anon_sym_in,
    ACTIONS(19609), 1,
      sym__layout_end,
    STATE(14218), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(19607), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490618] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19611), 1,
      sym__unboxed_close,
    STATE(15654), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490640] = 5,
    ACTIONS(19283), 1,
      anon_sym_LBRACE,
    ACTIONS(19285), 1,
      sym__layout_start,
    STATE(18296), 1,
      sym_decls,
    ACTIONS(18948), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490660] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15441), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [490674] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18173), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(15913), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490696] = 4,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(18697), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14164), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490714] = 4,
    ACTIONS(18310), 1,
      anon_sym_via,
    STATE(16239), 1,
      sym_via,
    ACTIONS(18727), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490732] = 3,
    STATE(2532), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19613), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490748] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490762] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19615), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16033), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490784] = 4,
    STATE(14309), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(19617), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(19620), 2,
      sym__layout_end,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490802] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19622), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(17602), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490824] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490838] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19624), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17175), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490860] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19626), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(17181), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490882] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4109), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [490896] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19628), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17194), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490918] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490932] = 5,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(19388), 1,
      anon_sym_LPAREN,
    STATE(18770), 1,
      sym_export_names,
    ACTIONS(19630), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [490952] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490966] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490980] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [490994] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15465), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491008] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15459), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [491022] = 4,
    ACTIONS(19410), 1,
      sym_comma,
    STATE(14121), 1,
      aux_sym_guards_repeat1,
    ACTIONS(19632), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491040] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [491054] = 4,
    ACTIONS(18310), 1,
      anon_sym_via,
    STATE(16434), 1,
      sym_via,
    ACTIONS(18703), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491072] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [491086] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [491100] = 4,
    ACTIONS(19438), 1,
      sym_comma,
    STATE(14287), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19049), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491118] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16012), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [491132] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [491146] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [491160] = 4,
    ACTIONS(19465), 1,
      sym_comma,
    STATE(14407), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(18813), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491178] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19173), 5,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [491192] = 3,
    STATE(2598), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19634), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491208] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19636), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(17049), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491230] = 5,
    ACTIONS(18032), 1,
      anon_sym_EQ,
    STATE(2360), 1,
      sym__colon2,
    STATE(19174), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491250] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19638), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16130), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491272] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [491286] = 3,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(18743), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491302] = 4,
    ACTIONS(19564), 1,
      sym_comma,
    STATE(14258), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19125), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491320] = 4,
    ACTIONS(19564), 1,
      sym_comma,
    STATE(14415), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19125), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491338] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(6240), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [491354] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19640), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16394), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491376] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(14747), 1,
      aux_sym__qualifying_module,
    STATE(18358), 1,
      sym_constructor,
    STATE(20000), 1,
      sym_qualified_type,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491398] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19642), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(16075), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491420] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19644), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16165), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491442] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(15124), 1,
      aux_sym__qualifying_module,
    STATE(18041), 1,
      sym_constructor,
    STATE(20695), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491464] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19646), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17198), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491486] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19648), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16245), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491508] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [491524] = 4,
    ACTIONS(17224), 1,
      anon_sym_deriving,
    ACTIONS(18873), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    STATE(14164), 2,
      sym_deriving,
      aux_sym__adt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491542] = 3,
    STATE(2555), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19650), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491558] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19323), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [491572] = 5,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    STATE(18569), 1,
      sym_import_list,
    ACTIONS(18861), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491592] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19652), 1,
      sym__unboxed_close,
    STATE(16004), 1,
      aux_sym_type_list_repeat1,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491614] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19654), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17228), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491636] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19656), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(17098), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491658] = 5,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    STATE(18571), 1,
      sym_import_list,
    ACTIONS(18849), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491678] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19658), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17111), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491700] = 5,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    STATE(18506), 1,
      sym_import_list,
    ACTIONS(18847), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491720] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19595), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
  [491734] = 3,
    STATE(2650), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19660), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491750] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19245), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
  [491764] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19662), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17669), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491786] = 4,
    ACTIONS(19442), 1,
      anon_sym_PIPE,
    STATE(14442), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(18811), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491804] = 4,
    ACTIONS(19442), 1,
      anon_sym_PIPE,
    STATE(14372), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(18811), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491822] = 3,
    STATE(2646), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19664), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491838] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(15124), 1,
      aux_sym__qualifying_module,
    STATE(18646), 1,
      sym_constructor,
    STATE(19470), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491860] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19666), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17021), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491882] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18533), 1,
      sym__unboxed_close,
    STATE(15670), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491904] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [491918] = 4,
    ACTIONS(19668), 1,
      anon_sym_PIPE,
    STATE(14372), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(18838), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491936] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14550), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [491952] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [491966] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19671), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16680), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [491988] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18838), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [492002] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19673), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [492016] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19675), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16260), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492038] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15437), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492052] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19677), 1,
      sym__unboxed_close,
    STATE(15684), 1,
      aux_sym_type_list_repeat1,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492074] = 4,
    ACTIONS(18310), 1,
      anon_sym_via,
    STATE(16380), 1,
      sym_via,
    ACTIONS(18836), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492092] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19471), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [492106] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19469), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [492120] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [492134] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19679), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17258), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492156] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19681), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17220), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492178] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18404), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(17051), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492200] = 4,
    ACTIONS(19685), 1,
      sym_comma,
    STATE(14388), 1,
      aux_sym_guards_repeat1,
    ACTIONS(19683), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492218] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19688), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(16395), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492240] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19593), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [492254] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19690), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(15895), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492276] = 4,
    ACTIONS(19694), 1,
      anon_sym_LBRACE,
    ACTIONS(19696), 1,
      sym__layout_start,
    ACTIONS(19692), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492294] = 4,
    ACTIONS(18310), 1,
      anon_sym_via,
    STATE(16381), 1,
      sym_via,
    ACTIONS(18834), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492312] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19698), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16229), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492334] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19700), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(17005), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492356] = 4,
    ACTIONS(19704), 1,
      anon_sym_LBRACE,
    ACTIONS(19706), 1,
      sym__layout_start,
    ACTIONS(19702), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492374] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19708), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17020), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492396] = 3,
    STATE(2382), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19710), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492412] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19712), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [492426] = 5,
    ACTIONS(18907), 1,
      anon_sym_in,
    ACTIONS(19716), 1,
      sym__layout_end,
    STATE(14468), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(19714), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492446] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18905), 5,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [492460] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [492474] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [492488] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15513), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492502] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15489), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492516] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15447), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492530] = 4,
    ACTIONS(19718), 1,
      sym_comma,
    STATE(14407), 1,
      aux_sym_fundeps_repeat1,
    ACTIONS(18827), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492548] = 5,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19721), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492568] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19723), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17274), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492590] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [492604] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19725), 1,
      sym__unboxed_close,
    STATE(15672), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492626] = 3,
    STATE(2567), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19727), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492642] = 5,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19729), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492662] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19203), 5,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_in,
  [492676] = 4,
    ACTIONS(19731), 1,
      sym_comma,
    STATE(14415), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19105), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492694] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15451), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492708] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15455), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492722] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15473), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492736] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19734), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(16270), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492758] = 4,
    ACTIONS(19564), 1,
      sym_comma,
    STATE(14415), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19101), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492776] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15477), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492790] = 5,
    ACTIONS(19736), 1,
      anon_sym_EQ,
    STATE(2360), 1,
      sym__colon2,
    STATE(18044), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492810] = 5,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19738), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492830] = 4,
    ACTIONS(19564), 1,
      sym_comma,
    STATE(14341), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19101), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492848] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19740), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17621), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492870] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19742), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16355), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492892] = 4,
    ACTIONS(17879), 1,
      sym_where,
    STATE(16129), 1,
      sym_class_body,
    ACTIONS(19744), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492910] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15481), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [492924] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19746), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16340), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492946] = 5,
    ACTIONS(19528), 1,
      sym_comma,
    STATE(2310), 1,
      sym__colon2,
    STATE(14222), 1,
      aux_sym_field_repeat1,
    ACTIONS(19748), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [492966] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15976), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
  [492980] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19750), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [492994] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15485), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [493008] = 5,
    ACTIONS(18671), 1,
      anon_sym_LPAREN,
    ACTIONS(18673), 1,
      anon_sym_hiding,
    STATE(18631), 1,
      sym_import_list,
    ACTIONS(18809), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493028] = 5,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19752), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493048] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19754), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17297), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493070] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(15124), 1,
      aux_sym__qualifying_module,
    STATE(18116), 1,
      sym_constructor,
    STATE(20445), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493092] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15493), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [493106] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19536), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [493120] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15501), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [493134] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(15124), 1,
      aux_sym__qualifying_module,
    STATE(18907), 1,
      sym_constructor,
    STATE(18941), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493156] = 4,
    ACTIONS(19442), 1,
      anon_sym_PIPE,
    STATE(14372), 1,
      aux_sym_constructors_repeat1,
    ACTIONS(18805), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493174] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18569), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [493188] = 3,
    STATE(2581), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19756), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493204] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19758), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(17589), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493226] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15425), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [493240] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19760), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17600), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493262] = 4,
    ACTIONS(18310), 1,
      anon_sym_via,
    STATE(16487), 1,
      sym_via,
    ACTIONS(18803), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493280] = 4,
    ACTIONS(18310), 1,
      anon_sym_via,
    STATE(16498), 1,
      sym_via,
    ACTIONS(18791), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493298] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15578), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
  [493312] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19762), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16910), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493334] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19764), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17644), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493356] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15574), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
  [493370] = 3,
    STATE(2739), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19766), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493386] = 5,
    ACTIONS(19528), 1,
      sym_comma,
    STATE(2294), 1,
      sym__colon2,
    STATE(14923), 1,
      aux_sym_field_repeat1,
    ACTIONS(19768), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493406] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19770), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(17385), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493428] = 4,
    ACTIONS(19774), 1,
      anon_sym_LBRACE,
    ACTIONS(19776), 1,
      sym__layout_start,
    ACTIONS(19772), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493446] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19424), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_EQ,
  [493460] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18338), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16107), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493482] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19778), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17322), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493504] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [493518] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18292), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [493532] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19780), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16313), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493554] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19782), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16925), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493576] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19203), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [493590] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18968), 5,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACK,
      anon_sym_EQ,
  [493604] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(15124), 1,
      aux_sym__qualifying_module,
    STATE(18203), 1,
      sym_constructor,
    STATE(20259), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493626] = 5,
    ACTIONS(5019), 1,
      sym__layout_end,
    ACTIONS(18970), 1,
      anon_sym_in,
    STATE(14309), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(19784), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493646] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19786), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17339), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493668] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19788), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(16851), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493690] = 3,
    STATE(2589), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19790), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493706] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19792), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16450), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493728] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [493742] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19794), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16435), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493764] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [493778] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [493792] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 5,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
      sym__varid,
      anon_sym_RBRACE,
  [493806] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19796), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17576), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493828] = 4,
    ACTIONS(19564), 1,
      sym_comma,
    STATE(14415), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19071), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493846] = 5,
    ACTIONS(19528), 1,
      sym_comma,
    STATE(2291), 1,
      sym__colon2,
    STATE(14455), 1,
      aux_sym_field_repeat1,
    ACTIONS(19798), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493866] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19800), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17364), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493888] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19802), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17423), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493910] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [493924] = 3,
    STATE(2506), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19804), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493940] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19806), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16076), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493962] = 5,
    ACTIONS(5015), 1,
      sym__layout_end,
    ACTIONS(18970), 1,
      anon_sym_in,
    STATE(14309), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(19808), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [493982] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(15124), 1,
      aux_sym__qualifying_module,
    STATE(18290), 1,
      sym_constructor,
    STATE(20121), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494004] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19105), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [494018] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19810), 1,
      sym__unboxed_close,
    STATE(15833), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494040] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19812), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(16286), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494062] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19673), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [494076] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19814), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16454), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494098] = 4,
    ACTIONS(19816), 1,
      anon_sym_LBRACE,
    ACTIONS(19818), 1,
      sym__layout_start,
    ACTIONS(19692), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494116] = 4,
    ACTIONS(19820), 1,
      anon_sym_LBRACE,
    ACTIONS(19822), 1,
      sym__layout_start,
    ACTIONS(19303), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494134] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19824), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(17778), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494156] = 3,
    STATE(2583), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19826), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494172] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19828), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17386), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494194] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19830), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17551), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494216] = 4,
    ACTIONS(18310), 1,
      anon_sym_via,
    STATE(16571), 1,
      sym_via,
    ACTIONS(18779), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494234] = 4,
    ACTIONS(19362), 1,
      sym_comma,
    STATE(14194), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19049), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494252] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [494266] = 4,
    ACTIONS(19832), 1,
      anon_sym_LBRACE,
    ACTIONS(19834), 1,
      sym__layout_start,
    ACTIONS(19702), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494284] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19836), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17410), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494306] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19838), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16826), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494328] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19840), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16545), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494350] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19842), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16530), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494372] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19712), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [494386] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19844), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(16477), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494408] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(15124), 1,
      aux_sym__qualifying_module,
    STATE(18802), 1,
      sym_constructor,
    STATE(19202), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494430] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19846), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16479), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494452] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19848), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17429), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494474] = 5,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19850), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494494] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19852), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17448), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494516] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(15124), 1,
      aux_sym__qualifying_module,
    STATE(18366), 1,
      sym_constructor,
    STATE(19991), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494538] = 3,
    STATE(2502), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19854), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494554] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14261), 4,
      sym_comma,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [494570] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19856), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17530), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494592] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [494606] = 3,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(18743), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494622] = 5,
    ACTIONS(18907), 1,
      anon_sym_in,
    ACTIONS(19860), 1,
      sym__layout_end,
    STATE(14486), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(19858), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494642] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(15124), 1,
      aux_sym__qualifying_module,
    STATE(18417), 1,
      sym_constructor,
    STATE(19883), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494664] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19862), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17471), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494686] = 3,
    STATE(2653), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19864), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494702] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19203), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [494716] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [494730] = 4,
    ACTIONS(19564), 1,
      sym_comma,
    STATE(14420), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19071), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494748] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [494762] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [494776] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [494790] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19866), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16815), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494812] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [494826] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19868), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16830), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494848] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [494862] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [494876] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 5,
      sym_comma,
      sym__immediate_dot,
      anon_sym_RPAREN,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [494890] = 4,
    ACTIONS(17879), 1,
      sym_where,
    STATE(16334), 1,
      sym_class_body,
    ACTIONS(19510), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494908] = 4,
    ACTIONS(19870), 1,
      anon_sym_LBRACE,
    ACTIONS(19872), 1,
      sym__layout_start,
    ACTIONS(19520), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494926] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19874), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16640), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494948] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [494962] = 4,
    ACTIONS(17847), 1,
      sym_where,
    STATE(16948), 1,
      sym_class_body,
    ACTIONS(19744), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [494980] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18279), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [494994] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [495008] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19876), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16625), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495030] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18159), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [495044] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [495058] = 4,
    ACTIONS(19564), 1,
      sym_comma,
    STATE(14479), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19049), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495076] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15976), 5,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
  [495090] = 4,
    ACTIONS(19362), 1,
      sym_comma,
    STATE(14083), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19101), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495108] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [495122] = 3,
    STATE(9454), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19878), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495138] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [495152] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [495166] = 4,
    ACTIONS(19880), 1,
      anon_sym_LBRACE,
    ACTIONS(19882), 1,
      sym__layout_start,
    ACTIONS(19585), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495184] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19884), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(17603), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495206] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19886), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17510), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495228] = 3,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(18743), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495244] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(15124), 1,
      aux_sym__qualifying_module,
    STATE(18471), 1,
      sym_constructor,
    STATE(19785), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495266] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14924), 5,
      sym__varsym,
      sym__consym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
      sym__conid,
  [495280] = 5,
    ACTIONS(19251), 1,
      sym__immediate_dot,
    ACTIONS(19888), 1,
      anon_sym_EQ,
    STATE(14259), 1,
      aux_sym_exp_field_repeat1,
    ACTIONS(19890), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495300] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19892), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16273), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495322] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18595), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [495336] = 4,
    ACTIONS(19362), 1,
      sym_comma,
    STATE(14572), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19101), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495354] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19894), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(16186), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495376] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(18133), 1,
      sym__unboxed_close,
    STATE(15824), 1,
      aux_sym__exp_tuple_repeat1,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495398] = 3,
    STATE(2572), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19896), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495414] = 3,
    STATE(2507), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19898), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495430] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19900), 1,
      sym__unboxed_close,
    STATE(15509), 1,
      aux_sym_type_list_repeat1,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495452] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [495466] = 3,
    STATE(2562), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19902), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495482] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [495496] = 4,
    ACTIONS(13614), 1,
      sym__varid,
    ACTIONS(17560), 1,
      anon_sym_LPAREN,
    STATE(13042), 3,
      sym_type_variable,
      sym_annotated_type_variable,
      aux_sym__forall_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495514] = 4,
    ACTIONS(19904), 1,
      sym_comma,
    STATE(14572), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19105), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495532] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [495546] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19907), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16654), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495568] = 5,
    ACTIONS(19909), 1,
      anon_sym_EQ,
    STATE(2381), 1,
      sym__colon2,
    STATE(15655), 1,
      sym__type_annotation,
    ACTIONS(15213), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495588] = 3,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(18715), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495604] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [495618] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [495632] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [495648] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13717), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [495664] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [495678] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 5,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [495692] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_deriving,
  [495706] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [495720] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19911), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16735), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495742] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 5,
      sym__consym,
      sym__tyconsym,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_BQUOTE,
  [495756] = 3,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(18715), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495772] = 5,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19913), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495792] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13682), 5,
      sym__dot,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [495806] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19915), 1,
      sym__unboxed_close,
    STATE(15491), 1,
      aux_sym_pat_tuple_repeat1,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495828] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [495842] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [495856] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19917), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(16720), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495878] = 6,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(19919), 1,
      sym__unboxed_close,
    STATE(15826), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    STATE(17383), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495900] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19921), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(16202), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495922] = 3,
    STATE(9239), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19923), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495938] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 5,
      sym_comma,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [495952] = 5,
    ACTIONS(19925), 1,
      anon_sym_EQ,
    STATE(2369), 1,
      sym__colon2,
    STATE(16701), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495972] = 4,
    ACTIONS(19927), 1,
      anon_sym_LBRACE,
    ACTIONS(19929), 1,
      sym__layout_start,
    ACTIONS(19772), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [495990] = 5,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19931), 1,
      anon_sym_RPAREN,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496010] = 6,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(19933), 1,
      sym__unboxed_close,
    STATE(16006), 1,
      aux_sym__type_sum_repeat1,
    STATE(17489), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496032] = 6,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(15124), 1,
      aux_sym__qualifying_module,
    STATE(18527), 1,
      sym_constructor,
    STATE(19676), 1,
      sym_qualified_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496054] = 3,
    STATE(2642), 2,
      sym__arrow,
      sym__forall_dot,
    ACTIONS(19935), 3,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_DOT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496070] = 6,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(19937), 1,
      sym__unboxed_close,
    STATE(15836), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    STATE(16679), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496092] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 5,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_PIPE,
  [496106] = 4,
    ACTIONS(11550), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(19939), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496123] = 5,
    ACTIONS(5286), 1,
      sym__conid,
    STATE(7173), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496142] = 4,
    ACTIONS(11458), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(19941), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496159] = 5,
    ACTIONS(13923), 1,
      sym__conid,
    STATE(12686), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496178] = 4,
    STATE(2441), 1,
      sym__colon2,
    STATE(13522), 1,
      sym__type_annotation,
    ACTIONS(15726), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496195] = 5,
    ACTIONS(4171), 1,
      sym__conid,
    STATE(5370), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496214] = 3,
    ACTIONS(19945), 1,
      sym_where,
    ACTIONS(19943), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496229] = 4,
    ACTIONS(991), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(19947), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496246] = 4,
    ACTIONS(1081), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(19949), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496263] = 4,
    ACTIONS(19953), 1,
      sym__layout_end,
    STATE(14608), 1,
      aux_sym_alts_repeat2,
    ACTIONS(19951), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496280] = 4,
    ACTIONS(19388), 1,
      anon_sym_LPAREN,
    STATE(18260), 1,
      sym_export_names,
    ACTIONS(19955), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496297] = 4,
    ACTIONS(19959), 1,
      sym__layout_end,
    STATE(14613), 1,
      aux_sym_rec_repeat2,
    ACTIONS(19957), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496314] = 5,
    ACTIONS(13286), 1,
      sym__conid,
    STATE(8934), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496333] = 4,
    STATE(2360), 1,
      sym__colon2,
    STATE(19048), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496350] = 5,
    ACTIONS(19016), 1,
      sym__conid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(15666), 1,
      sym_constructor,
    STATE(16667), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496369] = 5,
    ACTIONS(4541), 1,
      sym__conid,
    STATE(9224), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496388] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19961), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [496401] = 4,
    ACTIONS(19965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19967), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496418] = 4,
    ACTIONS(19971), 1,
      sym__layout_end,
    STATE(14710), 1,
      aux_sym_rec_repeat2,
    ACTIONS(19969), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496435] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [496448] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [496461] = 4,
    ACTIONS(19973), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19975), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496478] = 4,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(19663), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496495] = 4,
    STATE(2359), 1,
      sym__colon2,
    STATE(10158), 1,
      sym__type_annotation,
    ACTIONS(15532), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496512] = 4,
    STATE(2407), 1,
      sym__colon2,
    STATE(12036), 1,
      sym__type_annotation,
    ACTIONS(15896), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496529] = 5,
    ACTIONS(14035), 1,
      sym__conid,
    STATE(12570), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496548] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [496561] = 4,
    STATE(2360), 1,
      sym__colon2,
    STATE(19077), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496578] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [496591] = 4,
    ACTIONS(17493), 1,
      anon_sym_LPAREN,
    ACTIONS(18966), 1,
      sym__varid,
    STATE(13311), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496608] = 4,
    STATE(2365), 1,
      sym__colon2,
    STATE(14476), 1,
      sym__type_annotation,
    ACTIONS(15648), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496625] = 5,
    ACTIONS(11827), 1,
      sym__conid,
    STATE(8071), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496644] = 4,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(19076), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496661] = 4,
    ACTIONS(19977), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19979), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496678] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19981), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [496691] = 4,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(19587), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496708] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19105), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [496721] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(19065), 1,
      sym_constructor,
    STATE(20308), 1,
      sym_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496740] = 3,
    ACTIONS(19983), 1,
      sym_where,
    ACTIONS(19575), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496755] = 5,
    ACTIONS(7215), 1,
      sym__conid,
    STATE(6303), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496774] = 4,
    ACTIONS(19985), 1,
      anon_sym_DOT_DOT,
    ACTIONS(19987), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496791] = 4,
    ACTIONS(19991), 1,
      sym__layout_end,
    STATE(14668), 1,
      aux_sym_rec_repeat2,
    ACTIONS(19989), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496808] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [496821] = 5,
    ACTIONS(7411), 1,
      sym__conid,
    STATE(6073), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496840] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [496853] = 4,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(13635), 1,
      sym_fundep,
    STATE(13589), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496870] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [496883] = 4,
    STATE(2360), 1,
      sym__colon2,
    STATE(20071), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496900] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [496913] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [496926] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [496939] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [496952] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [496965] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20458), 1,
      sym_variable,
    STATE(20665), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [496984] = 4,
    ACTIONS(19995), 1,
      sym__layout_end,
    STATE(14698), 1,
      aux_sym_rec_repeat2,
    ACTIONS(19993), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497001] = 4,
    ACTIONS(11383), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(19997), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497018] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [497031] = 4,
    ACTIONS(20001), 1,
      sym__layout_end,
    STATE(14678), 1,
      aux_sym_alts_repeat2,
    ACTIONS(19999), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497048] = 5,
    ACTIONS(4373), 1,
      sym__conid,
    STATE(11285), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497067] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [497080] = 4,
    ACTIONS(955), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20003), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497097] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [497110] = 4,
    ACTIONS(1113), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20005), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497127] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [497140] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [497153] = 4,
    ACTIONS(20009), 1,
      sym__layout_end,
    STATE(14661), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20007), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497170] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [497183] = 4,
    ACTIONS(20013), 1,
      anon_sym_EQ,
    STATE(3233), 1,
      sym__larrow,
    ACTIONS(20011), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497200] = 5,
    ACTIONS(14285), 1,
      sym__conid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(13423), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497219] = 4,
    ACTIONS(20015), 1,
      sym__varid,
    ACTIONS(20017), 1,
      anon_sym_LPAREN,
    STATE(14399), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497236] = 4,
    ACTIONS(20021), 1,
      sym__layout_end,
    STATE(14666), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20019), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497253] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16018), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [497266] = 4,
    ACTIONS(11379), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20023), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497283] = 4,
    ACTIONS(11389), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20025), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497300] = 4,
    ACTIONS(20029), 1,
      sym__layout_end,
    STATE(14709), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20027), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497317] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20005), 1,
      sym_variable,
    STATE(20099), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497336] = 4,
    ACTIONS(215), 1,
      sym__layout_end,
    STATE(14712), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(20031), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497353] = 5,
    ACTIONS(12515), 1,
      sym__conid,
    STATE(8571), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497372] = 5,
    ACTIONS(6573), 1,
      sym__conid,
    STATE(6653), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497391] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20033), 4,
      sym_where,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [497404] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20458), 1,
      sym_variable,
    STATE(20633), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497423] = 4,
    ACTIONS(20037), 1,
      sym__layout_end,
    STATE(14831), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20035), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497440] = 4,
    STATE(2435), 1,
      sym__colon2,
    STATE(13430), 1,
      sym__type_annotation,
    ACTIONS(15618), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497457] = 4,
    STATE(2373), 1,
      sym__colon2,
    STATE(11728), 1,
      sym__type_annotation,
    ACTIONS(15634), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497474] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [497487] = 4,
    ACTIONS(1003), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20039), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497504] = 5,
    ACTIONS(13558), 1,
      sym__conid,
    STATE(12792), 1,
      sym_constructor,
    STATE(12961), 1,
      sym__modid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497523] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18595), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [497536] = 4,
    ACTIONS(20043), 1,
      sym__layout_end,
    STATE(14679), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20041), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497553] = 4,
    ACTIONS(20047), 1,
      sym__layout_end,
    STATE(14713), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20045), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497570] = 5,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19075), 1,
      anon_sym_LPAREN,
    STATE(13817), 1,
      sym_variable,
    STATE(16117), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497589] = 5,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19075), 1,
      anon_sym_LPAREN,
    STATE(13817), 1,
      sym_variable,
    STATE(16113), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497608] = 4,
    ACTIONS(909), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20049), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497625] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20051), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [497638] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [497651] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [497664] = 5,
    ACTIONS(6790), 1,
      sym__conid,
    STATE(6634), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497683] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [497696] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [497709] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [497722] = 4,
    ACTIONS(20055), 1,
      sym__layout_end,
    STATE(14772), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(20053), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497739] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [497752] = 4,
    ACTIONS(20059), 1,
      sym__layout_end,
    STATE(14721), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20057), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497769] = 4,
    ACTIONS(11503), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20061), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497786] = 4,
    ACTIONS(1109), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20063), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497803] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20065), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [497816] = 4,
    ACTIONS(20070), 1,
      sym__layout_end,
    STATE(14712), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(20067), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497833] = 4,
    ACTIONS(1089), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20072), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497850] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15976), 4,
      anon_sym_SEMI,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_RBRACE,
  [497863] = 5,
    ACTIONS(12785), 1,
      sym__conid,
    STATE(8061), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497882] = 5,
    ACTIONS(4349), 1,
      sym__conid,
    STATE(10385), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497901] = 5,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19201), 1,
      anon_sym_LPAREN,
    STATE(13775), 1,
      sym_variable,
    STATE(17003), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497920] = 4,
    ACTIONS(20076), 1,
      sym__layout_end,
    STATE(14988), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(20074), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497937] = 4,
    ACTIONS(11759), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20078), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497954] = 4,
    STATE(2360), 1,
      sym__colon2,
    STATE(20311), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497971] = 4,
    ACTIONS(11548), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20080), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [497988] = 5,
    ACTIONS(4143), 1,
      sym__conid,
    STATE(4666), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498007] = 4,
    ACTIONS(20082), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20084), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498024] = 5,
    ACTIONS(12154), 1,
      sym__conid,
    STATE(8290), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498043] = 5,
    ACTIONS(13780), 1,
      sym__conid,
    STATE(11751), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498062] = 4,
    ACTIONS(20088), 1,
      sym__layout_end,
    STATE(14691), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20086), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498079] = 5,
    ACTIONS(4321), 1,
      sym__conid,
    STATE(9436), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498098] = 4,
    ACTIONS(20090), 1,
      ts_builtin_sym_end,
    STATE(14771), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(20092), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498115] = 4,
    ACTIONS(977), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20094), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498132] = 5,
    ACTIONS(17799), 1,
      anon_sym_in,
    ACTIONS(20096), 1,
      anon_sym_LBRACE,
    ACTIONS(20098), 1,
      sym__layout_start,
    STATE(20711), 1,
      sym__let_decls,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498151] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [498164] = 4,
    ACTIONS(11370), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20100), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498181] = 5,
    ACTIONS(13941), 1,
      sym__conid,
    STATE(12483), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498200] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4109), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [498213] = 3,
    ACTIONS(20102), 1,
      sym_where,
    ACTIONS(19575), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498228] = 5,
    ACTIONS(7054), 1,
      sym__conid,
    STATE(6548), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498247] = 4,
    STATE(2091), 1,
      sym__colon2,
    STATE(18372), 1,
      sym__gadt_constr_type,
    ACTIONS(20104), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498264] = 4,
    ACTIONS(20108), 1,
      sym__layout_end,
    STATE(14847), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(20106), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498281] = 4,
    ACTIONS(995), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20110), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498298] = 4,
    ACTIONS(20114), 1,
      sym__layout_end,
    STATE(14719), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20112), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498315] = 4,
    ACTIONS(20118), 1,
      sym__layout_end,
    STATE(14732), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20116), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498332] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20306), 1,
      sym_constructor,
    STATE(20308), 1,
      sym_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498351] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [498364] = 4,
    STATE(2360), 1,
      sym__colon2,
    STATE(19822), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498381] = 5,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19201), 1,
      anon_sym_LPAREN,
    STATE(13775), 1,
      sym_variable,
    STATE(16990), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498400] = 5,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19161), 1,
      anon_sym_LPAREN,
    STATE(13886), 1,
      sym_variable,
    STATE(18347), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498419] = 5,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(11551), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498438] = 4,
    ACTIONS(20120), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20122), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498455] = 5,
    ACTIONS(7299), 1,
      sym__conid,
    STATE(6018), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498474] = 4,
    ACTIONS(20126), 1,
      sym__layout_end,
    STATE(14788), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(20124), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498491] = 4,
    ACTIONS(20128), 1,
      anon_sym_LPAREN,
    STATE(18139), 1,
      sym_import_con_names,
    ACTIONS(20130), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498508] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [498521] = 4,
    STATE(2356), 1,
      sym__colon2,
    STATE(12023), 1,
      sym__type_annotation,
    ACTIONS(15906), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498538] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [498551] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16012), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [498564] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19424), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [498577] = 4,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(14260), 1,
      sym_fundep,
    STATE(13589), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498594] = 4,
    ACTIONS(20134), 1,
      sym__layout_end,
    STATE(14792), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20132), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498611] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [498624] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20136), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [498637] = 5,
    ACTIONS(6657), 1,
      sym__conid,
    STATE(6019), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498656] = 4,
    ACTIONS(20140), 1,
      sym__layout_end,
    STATE(14729), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20138), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498673] = 4,
    STATE(2421), 1,
      sym__colon2,
    STATE(14701), 1,
      sym__type_annotation,
    ACTIONS(15818), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498690] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15425), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [498703] = 5,
    ACTIONS(4439), 1,
      sym__conid,
    STATE(11848), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498722] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15419), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [498735] = 4,
    STATE(2383), 1,
      sym__colon2,
    STATE(14592), 1,
      sym__type_annotation,
    ACTIONS(15628), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498752] = 4,
    ACTIONS(20144), 1,
      sym__layout_end,
    STATE(14793), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(20142), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498769] = 3,
    ACTIONS(20148), 1,
      sym_where,
    ACTIONS(20146), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498784] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19469), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [498797] = 4,
    ACTIONS(225), 1,
      ts_builtin_sym_end,
    STATE(15185), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(20150), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498814] = 4,
    ACTIONS(5469), 1,
      sym__layout_end,
    STATE(15381), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(20152), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498831] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19471), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [498844] = 4,
    ACTIONS(215), 1,
      sym__layout_end,
    STATE(15165), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(20031), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498861] = 3,
    ACTIONS(20154), 1,
      sym_where,
    ACTIONS(19303), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498876] = 5,
    ACTIONS(12677), 1,
      sym__conid,
    STATE(8592), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498895] = 4,
    ACTIONS(12555), 1,
      sym__layout_end,
    STATE(14800), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(20156), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498912] = 5,
    ACTIONS(7114), 1,
      sym__conid,
    STATE(5862), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498931] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18569), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [498944] = 4,
    ACTIONS(20158), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20160), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498961] = 4,
    ACTIONS(20164), 1,
      sym__layout_end,
    STATE(14802), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20162), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498978] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20005), 1,
      sym_variable,
    STATE(20135), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [498997] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 4,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [499010] = 5,
    ACTIONS(9286), 1,
      sym__conid,
    STATE(10520), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499029] = 4,
    STATE(2401), 1,
      sym__colon2,
    STATE(10638), 1,
      sym__type_annotation,
    ACTIONS(15598), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499046] = 4,
    STATE(2379), 1,
      sym__colon2,
    STATE(10707), 1,
      sym__type_annotation,
    ACTIONS(15568), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499063] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20005), 1,
      sym_variable,
    STATE(20084), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499082] = 4,
    ACTIONS(4955), 1,
      sym__layout_end,
    STATE(15050), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(20166), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499099] = 4,
    ACTIONS(11360), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20168), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499116] = 4,
    STATE(2360), 1,
      sym__colon2,
    STATE(20001), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499133] = 4,
    STATE(2404), 1,
      sym__colon2,
    STATE(18839), 1,
      sym__type_annotation,
    ACTIONS(15987), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499150] = 4,
    ACTIONS(1101), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20170), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499167] = 4,
    ACTIONS(5120), 1,
      sym__layout_end,
    STATE(15086), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(20172), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499184] = 4,
    ACTIONS(1039), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20174), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499201] = 5,
    ACTIONS(11655), 1,
      sym__conid,
    STATE(7976), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499220] = 4,
    ACTIONS(20178), 1,
      sym__layout_end,
    STATE(14789), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20176), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499237] = 4,
    ACTIONS(20182), 1,
      sym__layout_end,
    STATE(14812), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20180), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499254] = 4,
    STATE(2360), 1,
      sym__colon2,
    STATE(20707), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499271] = 4,
    ACTIONS(20186), 1,
      sym__layout_end,
    STATE(14794), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20184), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499288] = 4,
    ACTIONS(13131), 1,
      sym__layout_end,
    STATE(15012), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(20188), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499305] = 4,
    ACTIONS(20190), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20192), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499322] = 4,
    ACTIONS(993), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20194), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499339] = 5,
    ACTIONS(4177), 1,
      sym__conid,
    STATE(4209), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499358] = 5,
    ACTIONS(20196), 1,
      anon_sym_SEMI,
    ACTIONS(20198), 1,
      sym__layout_semicolon,
    ACTIONS(20200), 1,
      sym__layout_end,
    STATE(14828), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499377] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [499390] = 4,
    ACTIONS(20202), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20204), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499407] = 3,
    ACTIONS(20206), 1,
      sym_where,
    ACTIONS(19943), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499422] = 4,
    ACTIONS(13131), 1,
      sym__layout_end,
    STATE(14830), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(20188), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499439] = 3,
    ACTIONS(20208), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(20210), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499454] = 4,
    STATE(2416), 1,
      sym__colon2,
    STATE(14103), 1,
      sym__type_annotation,
    ACTIONS(15646), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499471] = 4,
    STATE(2384), 1,
      sym__colon2,
    STATE(11578), 1,
      sym__type_annotation,
    ACTIONS(15636), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499488] = 4,
    ACTIONS(11377), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20212), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499505] = 3,
    ACTIONS(20216), 1,
      sym_where,
    ACTIONS(20214), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499520] = 3,
    ACTIONS(17712), 1,
      sym__conid,
    ACTIONS(17710), 3,
      sym__varid,
      anon_sym_mdo,
      anon_sym_do,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499535] = 4,
    ACTIONS(11809), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20218), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499552] = 5,
    ACTIONS(8789), 1,
      sym__conid,
    STATE(10282), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499571] = 5,
    ACTIONS(20220), 1,
      anon_sym_SEMI,
    ACTIONS(20222), 1,
      sym__layout_semicolon,
    ACTIONS(20224), 1,
      sym__layout_end,
    STATE(14838), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499590] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [499603] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [499616] = 5,
    ACTIONS(10298), 1,
      sym__conid,
    STATE(8079), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499635] = 5,
    ACTIONS(6517), 1,
      sym__conid,
    STATE(6994), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499654] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20136), 1,
      sym_variable,
    STATE(20273), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499673] = 4,
    STATE(2091), 1,
      sym__colon2,
    STATE(18194), 1,
      sym__gadt_constr_type,
    ACTIONS(20104), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499690] = 4,
    ACTIONS(20228), 1,
      sym__layout_end,
    STATE(14995), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20226), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499707] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19245), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [499720] = 5,
    ACTIONS(6450), 1,
      sym__conid,
    STATE(6886), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499739] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20230), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [499752] = 5,
    ACTIONS(20232), 1,
      anon_sym_SEMI,
    ACTIONS(20234), 1,
      sym__layout_semicolon,
    ACTIONS(20236), 1,
      sym__layout_end,
    STATE(15012), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499771] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20136), 1,
      sym_variable,
    STATE(20219), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499790] = 4,
    ACTIONS(13115), 1,
      sym__layout_end,
    STATE(15012), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(20238), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499807] = 4,
    ACTIONS(11683), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20240), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499824] = 4,
    ACTIONS(20244), 1,
      sym__layout_end,
    STATE(14846), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20242), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499841] = 4,
    ACTIONS(12401), 1,
      sym__layout_end,
    STATE(15359), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(20246), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499858] = 5,
    ACTIONS(14017), 1,
      sym__conid,
    STATE(12522), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499877] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19514), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [499890] = 5,
    ACTIONS(6016), 1,
      sym__conid,
    STATE(7284), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499909] = 4,
    ACTIONS(20248), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20250), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499926] = 5,
    ACTIONS(20252), 1,
      anon_sym_SEMI,
    ACTIONS(20254), 1,
      sym__layout_semicolon,
    ACTIONS(20256), 1,
      sym__layout_end,
    STATE(14887), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499945] = 4,
    ACTIONS(18679), 1,
      sym__layout_end,
    STATE(15137), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(20258), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499962] = 4,
    ACTIONS(20262), 1,
      sym__layout_end,
    STATE(14864), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20260), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499979] = 4,
    ACTIONS(20266), 1,
      sym__layout_end,
    STATE(14860), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20264), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [499996] = 5,
    ACTIONS(4321), 1,
      sym__conid,
    STATE(9226), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500015] = 4,
    ACTIONS(20271), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20268), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500032] = 4,
    ACTIONS(11385), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20273), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500049] = 4,
    ACTIONS(20277), 1,
      sym_comma,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(20275), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500066] = 4,
    ACTIONS(1027), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20280), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500083] = 4,
    ACTIONS(18665), 1,
      sym__layout_end,
    STATE(15137), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(20282), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500100] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19595), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [500113] = 4,
    ACTIONS(1085), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20284), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500130] = 4,
    ACTIONS(20288), 1,
      sym__layout_end,
    STATE(14844), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20286), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500147] = 4,
    ACTIONS(20292), 1,
      sym__layout_end,
    STATE(14928), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20290), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500164] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20136), 1,
      sym_variable,
    STATE(20233), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500183] = 5,
    ACTIONS(12002), 1,
      sym__conid,
    STATE(8317), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500202] = 5,
    ACTIONS(6318), 1,
      sym__conid,
    STATE(6250), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500221] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20274), 1,
      sym_variable,
    STATE(20455), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500240] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15989), 4,
      sym__consym,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_BQUOTE,
  [500253] = 5,
    ACTIONS(12709), 1,
      sym__conid,
    STATE(8138), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500272] = 4,
    ACTIONS(20296), 1,
      sym__layout_end,
    STATE(14849), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20294), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500289] = 4,
    ACTIONS(969), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20298), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500306] = 4,
    ACTIONS(11597), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20300), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500323] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19536), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [500336] = 5,
    ACTIONS(10573), 1,
      sym__conid,
    STATE(7614), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500355] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19673), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [500368] = 4,
    ACTIONS(11681), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20302), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500385] = 5,
    ACTIONS(5361), 1,
      sym__conid,
    STATE(3927), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500404] = 4,
    STATE(2438), 1,
      sym__colon2,
    STATE(12352), 1,
      sym__type_annotation,
    ACTIONS(15942), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500421] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19105), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [500434] = 5,
    ACTIONS(5998), 1,
      sym__conid,
    STATE(4307), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500453] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4109), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [500466] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15419), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [500479] = 4,
    ACTIONS(20306), 1,
      anon_sym_EQ,
    STATE(3256), 1,
      sym__larrow,
    ACTIONS(20304), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500496] = 4,
    ACTIONS(11721), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20308), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500513] = 5,
    ACTIONS(8725), 1,
      sym__conid,
    STATE(10375), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500532] = 5,
    ACTIONS(12389), 1,
      sym__conid,
    STATE(7935), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500551] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [500564] = 3,
    ACTIONS(20312), 1,
      sym_where,
    ACTIONS(20310), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500579] = 5,
    ACTIONS(13780), 1,
      sym__conid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(15438), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500598] = 5,
    ACTIONS(14001), 1,
      sym__conid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(15469), 1,
      sym__modid,
    STATE(16605), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500617] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20314), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [500630] = 4,
    ACTIONS(20318), 1,
      sym__layout_end,
    STATE(14815), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20316), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500647] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15578), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [500660] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15574), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [500673] = 4,
    ACTIONS(20320), 1,
      sym_comma,
    STATE(15177), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19127), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500690] = 4,
    ACTIONS(11675), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20322), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500707] = 5,
    ACTIONS(1789), 1,
      sym__conid,
    STATE(7309), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500726] = 5,
    ACTIONS(8679), 1,
      sym__conid,
    STATE(10818), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500745] = 4,
    ACTIONS(20327), 1,
      sym__layout_end,
    STATE(14887), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(20324), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500762] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 4,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [500775] = 4,
    ACTIONS(13614), 1,
      sym__varid,
    ACTIONS(17560), 1,
      anon_sym_LPAREN,
    STATE(13974), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500792] = 4,
    STATE(2366), 1,
      sym__colon2,
    STATE(14743), 1,
      sym__type_annotation,
    ACTIONS(19218), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500809] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 4,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [500822] = 4,
    ACTIONS(19620), 1,
      anon_sym_in,
    STATE(14892), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(20329), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500839] = 4,
    STATE(2414), 1,
      sym__colon2,
    STATE(11669), 1,
      sym__type_annotation,
    ACTIONS(15638), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500856] = 4,
    STATE(2399), 1,
      sym__colon2,
    STATE(13970), 1,
      sym__type_annotation,
    ACTIONS(15680), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500873] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18827), 4,
      sym_where,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
  [500886] = 4,
    ACTIONS(913), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20332), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500903] = 4,
    ACTIONS(20336), 1,
      sym__layout_end,
    STATE(14953), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20334), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500920] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20136), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [500933] = 4,
    ACTIONS(20340), 1,
      sym__layout_end,
    STATE(14884), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20338), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500950] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18838), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [500963] = 4,
    ACTIONS(11407), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20342), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500980] = 4,
    ACTIONS(20346), 1,
      sym__layout_end,
    STATE(14905), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20344), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [500997] = 4,
    ACTIONS(20350), 1,
      sym__layout_end,
    STATE(14916), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20348), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501014] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19683), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_EQ,
  [501027] = 4,
    ACTIONS(1015), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20352), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501044] = 4,
    ACTIONS(17310), 1,
      anon_sym_LPAREN,
    ACTIONS(18630), 1,
      sym__varid,
    STATE(12942), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501061] = 4,
    STATE(2381), 1,
      sym__colon2,
    STATE(15600), 1,
      sym__type_annotation,
    ACTIONS(15213), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501078] = 4,
    ACTIONS(20356), 1,
      sym__layout_end,
    STATE(14929), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20354), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501095] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16117), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [501108] = 4,
    ACTIONS(1121), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20358), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501125] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20274), 1,
      sym_variable,
    STATE(20381), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501144] = 4,
    ACTIONS(20362), 1,
      sym__layout_end,
    STATE(14901), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20360), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501161] = 5,
    ACTIONS(4211), 1,
      sym__conid,
    STATE(4254), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501180] = 4,
    ACTIONS(20366), 1,
      sym__layout_end,
    STATE(14910), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20364), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501197] = 5,
    ACTIONS(4541), 1,
      sym__conid,
    STATE(9284), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501216] = 4,
    ACTIONS(11709), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20368), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501233] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20370), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [501246] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20372), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [501259] = 3,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(20374), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501274] = 4,
    ACTIONS(20378), 1,
      sym__layout_end,
    STATE(14896), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20376), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501291] = 4,
    ACTIONS(20380), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20382), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501308] = 4,
    STATE(2415), 1,
      sym__colon2,
    STATE(12058), 1,
      sym__type_annotation,
    ACTIONS(15908), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501325] = 4,
    ACTIONS(20386), 1,
      sym_comma,
    STATE(14923), 1,
      aux_sym_field_repeat1,
    ACTIONS(20384), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501342] = 4,
    ACTIONS(20391), 1,
      sym__layout_end,
    STATE(14939), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20389), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501359] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20274), 1,
      sym_variable,
    STATE(20418), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501378] = 4,
    ACTIONS(11719), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20393), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501395] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20395), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [501408] = 4,
    ACTIONS(1095), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20397), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501425] = 4,
    ACTIONS(1059), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20399), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501442] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15419), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [501455] = 3,
    ACTIONS(18907), 1,
      anon_sym_in,
    ACTIONS(18905), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501470] = 5,
    ACTIONS(14001), 1,
      sym__conid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(14516), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501489] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 4,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [501502] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 4,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [501515] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19593), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [501528] = 4,
    ACTIONS(20401), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20403), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501545] = 4,
    STATE(2360), 1,
      sym__colon2,
    STATE(20696), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501562] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 4,
      sym__layout_semicolon,
      sym_where,
      anon_sym_SEMI,
      anon_sym_in,
  [501575] = 4,
    ACTIONS(11554), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20405), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501592] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [501605] = 4,
    ACTIONS(1023), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20407), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501622] = 4,
    ACTIONS(20409), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20411), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501639] = 5,
    ACTIONS(4267), 1,
      sym__conid,
    STATE(4304), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501658] = 4,
    STATE(2426), 1,
      sym__colon2,
    STATE(10909), 1,
      sym__type_annotation,
    ACTIONS(15622), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501675] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [501688] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [501701] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [501714] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [501727] = 4,
    STATE(2405), 1,
      sym__colon2,
    STATE(11515), 1,
      sym__type_annotation,
    ACTIONS(15630), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501744] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20413), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [501757] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [501770] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [501783] = 4,
    ACTIONS(11635), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20415), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501800] = 5,
    ACTIONS(12490), 1,
      sym__conid,
    STATE(8521), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501819] = 4,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(14172), 1,
      sym_fundep,
    STATE(13650), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501836] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [501849] = 4,
    ACTIONS(20419), 1,
      sym__layout_end,
    STATE(14967), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20417), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501866] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [501879] = 4,
    ACTIONS(11452), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20421), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501896] = 4,
    ACTIONS(20425), 1,
      sym__layout_end,
    STATE(14859), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20423), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501913] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18834), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [501926] = 4,
    ACTIONS(20429), 1,
      sym__layout_end,
    STATE(14926), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20427), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501943] = 4,
    STATE(2371), 1,
      sym__colon2,
    STATE(14934), 1,
      sym__type_annotation,
    ACTIONS(15804), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501960] = 4,
    ACTIONS(20433), 1,
      sym__layout_end,
    STATE(14984), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20431), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [501977] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [501990] = 5,
    ACTIONS(12893), 1,
      sym__conid,
    STATE(8335), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502009] = 4,
    ACTIONS(1049), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20435), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502026] = 5,
    ACTIONS(4519), 1,
      sym__conid,
    STATE(10525), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502045] = 4,
    ACTIONS(1161), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20437), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502062] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18595), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [502075] = 4,
    ACTIONS(20441), 1,
      sym__layout_end,
    STATE(14959), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20439), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502092] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20443), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [502105] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20445), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [502118] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [502131] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [502144] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [502157] = 5,
    ACTIONS(12985), 1,
      sym__conid,
    STATE(8510), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502176] = 4,
    ACTIONS(20449), 1,
      sym__layout_end,
    STATE(14969), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20447), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502193] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15976), 4,
      sym_comma,
      anon_sym_,
      anon_sym_EQ_GT,
      anon_sym_RPAREN,
  [502206] = 4,
    ACTIONS(20128), 1,
      anon_sym_LPAREN,
    STATE(18302), 1,
      sym_import_con_names,
    ACTIONS(20451), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502223] = 4,
    ACTIONS(20320), 1,
      sym_comma,
    STATE(14883), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19125), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502240] = 4,
    ACTIONS(20455), 1,
      sym__layout_end,
    STATE(15022), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20453), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502257] = 5,
    ACTIONS(6125), 1,
      sym__conid,
    STATE(7289), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502276] = 4,
    ACTIONS(11747), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20457), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502293] = 5,
    ACTIONS(20459), 1,
      anon_sym_SEMI,
    ACTIONS(20461), 1,
      sym__layout_semicolon,
    ACTIONS(20463), 1,
      sym__layout_end,
    STATE(14887), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502312] = 4,
    STATE(2395), 1,
      sym__colon2,
    STATE(14132), 1,
      sym__type_annotation,
    ACTIONS(15644), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502329] = 4,
    ACTIONS(20320), 1,
      sym_comma,
    STATE(15177), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19125), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502346] = 4,
    ACTIONS(5507), 1,
      sym__layout_end,
    STATE(15381), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(20465), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502363] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [502376] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18715), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [502389] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [502402] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [502415] = 4,
    ACTIONS(18907), 1,
      anon_sym_in,
    STATE(15265), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(20467), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502432] = 4,
    ACTIONS(20469), 1,
      sym__varid,
    ACTIONS(20471), 1,
      anon_sym_LPAREN,
    STATE(15135), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502449] = 4,
    ACTIONS(1007), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20473), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502466] = 5,
    ACTIONS(4243), 1,
      sym__conid,
    STATE(4600), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502485] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [502498] = 4,
    ACTIONS(20477), 1,
      sym__layout_end,
    STATE(15025), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20475), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502515] = 4,
    ACTIONS(13133), 1,
      sym__layout_end,
    STATE(15012), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(20479), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502532] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16035), 4,
      sym_comma,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_EQ,
  [502545] = 5,
    ACTIONS(6601), 1,
      sym__conid,
    STATE(6071), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502564] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(4109), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [502577] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20481), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [502590] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20458), 1,
      sym_variable,
    STATE(20713), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502609] = 4,
    ACTIONS(20483), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20485), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502626] = 4,
    STATE(2377), 1,
      sym__colon2,
    STATE(14577), 1,
      sym__type_annotation,
    ACTIONS(15962), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502643] = 5,
    ACTIONS(4487), 1,
      sym__conid,
    STATE(9673), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502662] = 4,
    ACTIONS(19388), 1,
      anon_sym_LPAREN,
    STATE(18779), 1,
      sym_export_names,
    ACTIONS(20487), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502679] = 5,
    ACTIONS(7243), 1,
      sym__conid,
    STATE(5961), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502698] = 4,
    STATE(2357), 1,
      sym__colon2,
    STATE(9529), 1,
      sym__type_annotation,
    ACTIONS(15217), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502715] = 5,
    ACTIONS(20489), 1,
      anon_sym_SEMI,
    ACTIONS(20491), 1,
      sym__layout_semicolon,
    ACTIONS(20493), 1,
      sym__layout_end,
    STATE(15012), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502734] = 4,
    ACTIONS(20498), 1,
      sym__layout_end,
    STATE(15012), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(20495), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502751] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20500), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [502764] = 5,
    ACTIONS(13732), 1,
      sym__conid,
    STATE(12806), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502783] = 5,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19161), 1,
      anon_sym_LPAREN,
    STATE(13886), 1,
      sym_variable,
    STATE(18440), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502802] = 4,
    ACTIONS(20504), 1,
      sym__layout_end,
    STATE(14739), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20502), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502819] = 5,
    ACTIONS(13322), 1,
      sym__conid,
    STATE(9081), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502838] = 4,
    ACTIONS(20506), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20508), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502855] = 5,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19161), 1,
      anon_sym_LPAREN,
    STATE(13886), 1,
      sym_variable,
    STATE(18441), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502874] = 4,
    ACTIONS(20512), 1,
      sym__layout_end,
    STATE(15032), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20510), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502891] = 4,
    ACTIONS(949), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20514), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502908] = 4,
    ACTIONS(1083), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20516), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502925] = 4,
    ACTIONS(20520), 1,
      sym__layout_end,
    STATE(15045), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(20518), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502942] = 4,
    ACTIONS(20524), 1,
      sym__layout_end,
    STATE(14941), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20522), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502959] = 4,
    ACTIONS(11733), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20526), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502976] = 4,
    ACTIONS(1097), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20528), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [502993] = 4,
    ACTIONS(20532), 1,
      sym__layout_end,
    STATE(14606), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20530), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503010] = 4,
    ACTIONS(20536), 1,
      sym__layout_end,
    STATE(15048), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20534), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503027] = 3,
    ACTIONS(18970), 1,
      anon_sym_in,
    ACTIONS(18968), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503042] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [503055] = 4,
    ACTIONS(20540), 1,
      sym__layout_end,
    STATE(15026), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20538), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503072] = 4,
    ACTIONS(11878), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20542), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503089] = 4,
    ACTIONS(20546), 1,
      sym__layout_end,
    STATE(15403), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(20544), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503106] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20445), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [503119] = 4,
    ACTIONS(20550), 1,
      sym__layout_end,
    STATE(15065), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(20548), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503136] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20552), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [503149] = 4,
    ACTIONS(20556), 1,
      anon_sym_EQ,
    STATE(3258), 1,
      sym__larrow,
    ACTIONS(20554), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503166] = 4,
    STATE(2424), 1,
      sym__colon2,
    STATE(11773), 1,
      sym__type_annotation,
    ACTIONS(15632), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503183] = 4,
    ACTIONS(20560), 1,
      sym__layout_end,
    STATE(15070), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(20558), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503200] = 4,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(14895), 1,
      sym_fundep,
    STATE(13650), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503217] = 4,
    ACTIONS(19609), 1,
      sym__layout_end,
    STATE(15090), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(20562), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503234] = 4,
    ACTIONS(20566), 1,
      sym__layout_end,
    STATE(15074), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20564), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503251] = 4,
    ACTIONS(20568), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20570), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503268] = 4,
    ACTIONS(20574), 1,
      sym__layout_end,
    STATE(15058), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20572), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503285] = 4,
    ACTIONS(5459), 1,
      sym__layout_end,
    STATE(15381), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(20576), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503302] = 5,
    ACTIONS(4081), 1,
      sym__conid,
    STATE(4682), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503321] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19323), 4,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_deriving,
  [503334] = 4,
    ACTIONS(983), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20578), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503351] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20580), 4,
      sym_where,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_EQ,
  [503364] = 4,
    ACTIONS(20585), 1,
      sym__layout_end,
    STATE(15050), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(20582), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503381] = 4,
    ACTIONS(151), 1,
      sym__layout_end,
    STATE(14682), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(20587), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503398] = 5,
    ACTIONS(7383), 1,
      sym__conid,
    STATE(7354), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503417] = 4,
    ACTIONS(12947), 1,
      sym__layout_end,
    STATE(15091), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(20589), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503434] = 5,
    ACTIONS(4205), 1,
      sym__conid,
    STATE(3873), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503453] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20591), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [503466] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18834), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [503479] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16018), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [503492] = 4,
    ACTIONS(11605), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20593), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503509] = 4,
    ACTIONS(11874), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20595), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503526] = 4,
    ACTIONS(20597), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20599), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503543] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18569), 4,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [503556] = 5,
    ACTIONS(10270), 1,
      sym__conid,
    STATE(8062), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503575] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20552), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [503588] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18836), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [503601] = 4,
    ACTIONS(18609), 1,
      sym__layout_end,
    STATE(15137), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(20601), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503618] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20065), 4,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_instance,
      anon_sym_deriving,
  [503631] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14714), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [503644] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14740), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [503657] = 4,
    ACTIONS(20603), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20605), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503674] = 4,
    ACTIONS(4957), 1,
      sym__layout_end,
    STATE(15050), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(20607), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503691] = 5,
    ACTIONS(12655), 1,
      sym__conid,
    STATE(7964), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503710] = 4,
    STATE(2369), 1,
      sym__colon2,
    STATE(16060), 1,
      sym__type_annotation,
    ACTIONS(15165), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503727] = 4,
    ACTIONS(20611), 1,
      sym__layout_end,
    STATE(15077), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20609), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503744] = 4,
    ACTIONS(1135), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20613), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503761] = 5,
    ACTIONS(10978), 1,
      sym__conid,
    STATE(8340), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503780] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18595), 4,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [503793] = 4,
    ACTIONS(11409), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20615), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503810] = 4,
    ACTIONS(1021), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20617), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503827] = 3,
    ACTIONS(15062), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(15976), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503842] = 5,
    ACTIONS(6352), 1,
      sym__conid,
    STATE(5904), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503861] = 5,
    ACTIONS(12359), 1,
      sym__conid,
    STATE(8110), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503880] = 4,
    ACTIONS(20621), 1,
      sym__layout_end,
    STATE(15059), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20619), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503897] = 5,
    ACTIONS(9134), 1,
      sym__conid,
    STATE(10029), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503916] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18836), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [503929] = 4,
    ACTIONS(11593), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20623), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503946] = 4,
    ACTIONS(19620), 1,
      sym__layout_end,
    STATE(15086), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(20625), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [503963] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19750), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [503976] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20628), 4,
      sym_comma,
      sym__immediate_dot,
      anon_sym_EQ,
      anon_sym_RBRACE,
  [503989] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20630), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [504002] = 4,
    ACTIONS(5017), 1,
      sym__layout_end,
    STATE(15086), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(20632), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504019] = 4,
    ACTIONS(13129), 1,
      sym__layout_end,
    STATE(15012), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(20634), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504036] = 5,
    ACTIONS(13558), 1,
      sym__conid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(13612), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504055] = 5,
    ACTIONS(20636), 1,
      anon_sym_SEMI,
    ACTIONS(20638), 1,
      sym__layout_semicolon,
    ACTIONS(20640), 1,
      sym__layout_end,
    STATE(15109), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504074] = 4,
    ACTIONS(13129), 1,
      sym__layout_end,
    STATE(15114), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(20634), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504091] = 4,
    ACTIONS(20642), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20644), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504108] = 5,
    ACTIONS(7327), 1,
      sym__conid,
    STATE(6362), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504127] = 4,
    ACTIONS(1005), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20646), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504144] = 4,
    ACTIONS(20650), 1,
      sym__layout_end,
    STATE(15085), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20648), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504161] = 5,
    ACTIONS(3116), 1,
      sym__conid,
    STATE(3946), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504180] = 5,
    ACTIONS(20652), 1,
      anon_sym_SEMI,
    ACTIONS(20654), 1,
      sym__layout_semicolon,
    ACTIONS(20656), 1,
      sym__layout_end,
    STATE(15115), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504199] = 4,
    ACTIONS(20660), 1,
      sym__layout_end,
    STATE(15097), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20658), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504216] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20662), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [504229] = 5,
    ACTIONS(6629), 1,
      sym__conid,
    STATE(5880), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504248] = 4,
    ACTIONS(20664), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20666), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504265] = 4,
    ACTIONS(20670), 1,
      sym__layout_end,
    STATE(15078), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20668), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504282] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [504295] = 5,
    ACTIONS(12923), 1,
      sym__conid,
    STATE(7819), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504314] = 5,
    ACTIONS(6915), 1,
      sym__conid,
    STATE(6150), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504333] = 5,
    ACTIONS(20672), 1,
      anon_sym_SEMI,
    ACTIONS(20674), 1,
      sym__layout_semicolon,
    ACTIONS(20676), 1,
      sym__layout_end,
    STATE(15012), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504352] = 4,
    STATE(2400), 1,
      sym__colon2,
    STATE(12147), 1,
      sym__type_annotation,
    ACTIONS(15798), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504369] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20678), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [504382] = 5,
    ACTIONS(1753), 1,
      sym__conid,
    STATE(4236), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504401] = 3,
    ACTIONS(19222), 1,
      anon_sym_in,
    ACTIONS(19220), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504416] = 4,
    ACTIONS(13087), 1,
      sym__layout_end,
    STATE(15012), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(20680), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504433] = 5,
    ACTIONS(20682), 1,
      anon_sym_SEMI,
    ACTIONS(20684), 1,
      sym__layout_semicolon,
    ACTIONS(20686), 1,
      sym__layout_end,
    STATE(14887), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504452] = 5,
    ACTIONS(9100), 1,
      sym__conid,
    STATE(10611), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504471] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20688), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [504484] = 4,
    ACTIONS(20693), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20690), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504501] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19173), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [504514] = 5,
    ACTIONS(6153), 1,
      sym__conid,
    STATE(7667), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504533] = 4,
    ACTIONS(20695), 1,
      anon_sym_LBRACE,
    ACTIONS(20697), 1,
      sym__layout_start,
    ACTIONS(19692), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504550] = 4,
    STATE(2429), 1,
      sym__colon2,
    STATE(12200), 1,
      sym__type_annotation,
    ACTIONS(15760), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504567] = 4,
    ACTIONS(20699), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20701), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504584] = 5,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(13128), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504603] = 4,
    STATE(2398), 1,
      sym__colon2,
    STATE(12696), 1,
      sym__type_annotation,
    ACTIONS(15985), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504620] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20688), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [504633] = 4,
    ACTIONS(20703), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20705), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504650] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19220), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [504663] = 5,
    ACTIONS(101), 1,
      sym__conid,
    STATE(3976), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504682] = 4,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(13819), 1,
      sym_fundep,
    STATE(13812), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504699] = 5,
    ACTIONS(6971), 1,
      sym__conid,
    STATE(7106), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504718] = 4,
    ACTIONS(20707), 1,
      anon_sym_LBRACE,
    ACTIONS(20709), 1,
      sym__layout_start,
    ACTIONS(19702), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504735] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20662), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [504748] = 5,
    ACTIONS(6380), 1,
      sym__conid,
    STATE(6934), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504767] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19712), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [504780] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [504793] = 4,
    ACTIONS(20714), 1,
      sym__layout_end,
    STATE(15137), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(20711), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504810] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20630), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [504823] = 5,
    ACTIONS(1698), 1,
      sym__conid,
    STATE(3777), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504842] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [504855] = 4,
    ACTIONS(11603), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20716), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504872] = 5,
    ACTIONS(5421), 1,
      sym__conid,
    STATE(7567), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504891] = 4,
    ACTIONS(20720), 1,
      sym__layout_end,
    STATE(15163), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20718), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504908] = 5,
    ACTIONS(13654), 1,
      sym__conid,
    STATE(13071), 1,
      sym_constructor,
    STATE(13076), 1,
      sym__modid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504927] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [504940] = 4,
    ACTIONS(20722), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20724), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504957] = 4,
    ACTIONS(925), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20726), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504974] = 4,
    ACTIONS(20730), 1,
      sym__layout_end,
    STATE(15141), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20728), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [504991] = 4,
    ACTIONS(20734), 1,
      sym__layout_end,
    STATE(15147), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20732), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505008] = 5,
    ACTIONS(4193), 1,
      sym__conid,
    STATE(4806), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505027] = 4,
    ACTIONS(20736), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20738), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505044] = 4,
    STATE(2085), 1,
      sym__colon2,
    STATE(17062), 1,
      sym__gadt_constr_type,
    ACTIONS(20740), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505061] = 4,
    STATE(2372), 1,
      sym__colon2,
    STATE(15171), 1,
      sym__type_annotation,
    ACTIONS(15926), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505078] = 5,
    ACTIONS(8970), 1,
      sym__conid,
    STATE(11298), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505097] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18968), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [505110] = 5,
    ACTIONS(4111), 1,
      sym__conid,
    STATE(9638), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505129] = 3,
    ACTIONS(19175), 1,
      anon_sym_in,
    ACTIONS(19173), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505144] = 4,
    ACTIONS(13546), 1,
      sym__varid,
    ACTIONS(17670), 1,
      anon_sym_LPAREN,
    STATE(14541), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505161] = 4,
    ACTIONS(20744), 1,
      sym__layout_end,
    STATE(15173), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20742), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505178] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19105), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [505191] = 5,
    ACTIONS(6056), 1,
      sym__conid,
    STATE(7633), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505210] = 5,
    ACTIONS(4153), 1,
      sym__conid,
    STATE(4902), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505229] = 4,
    ACTIONS(1099), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20746), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505246] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19203), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [505259] = 4,
    ACTIONS(153), 1,
      sym__layout_end,
    STATE(14712), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(20748), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505276] = 4,
    STATE(2439), 1,
      sym__colon2,
    STATE(18866), 1,
      sym__type_annotation,
    ACTIONS(17469), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505293] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18569), 4,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_EQ,
  [505306] = 4,
    ACTIONS(20750), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20752), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505323] = 5,
    ACTIONS(655), 1,
      sym__conid,
    STATE(4012), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505342] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [505355] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [505368] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [505381] = 4,
    ACTIONS(11633), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20754), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505398] = 4,
    ACTIONS(20756), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20758), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505415] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20760), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [505428] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20372), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [505441] = 4,
    ACTIONS(20762), 1,
      sym_comma,
    STATE(15177), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19105), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505458] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20370), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [505471] = 4,
    ACTIONS(11617), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20765), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505488] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20767), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [505501] = 4,
    ACTIONS(20320), 1,
      sym_comma,
    STATE(15177), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19101), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505518] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16103), 4,
      sym_where,
      anon_sym_SEMI,
      anon_sym_PIPE,
      anon_sym_RBRACE,
  [505531] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14672), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [505544] = 4,
    ACTIONS(20320), 1,
      sym_comma,
    STATE(14987), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19101), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505561] = 4,
    ACTIONS(20070), 1,
      ts_builtin_sym_end,
    STATE(15185), 1,
      aux_sym_haskell_repeat1,
    ACTIONS(20769), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505578] = 3,
    ACTIONS(20772), 1,
      sym_where,
    ACTIONS(20214), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505593] = 4,
    ACTIONS(11619), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20774), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505610] = 4,
    ACTIONS(18139), 1,
      sym_where,
    STATE(18429), 1,
      sym_class_body,
    ACTIONS(19744), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505627] = 4,
    ACTIONS(1139), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20776), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505644] = 4,
    ACTIONS(20780), 1,
      sym__layout_end,
    STATE(15179), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20778), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505661] = 4,
    STATE(2440), 1,
      sym__colon2,
    STATE(16252), 1,
      sym__type_annotation,
    ACTIONS(19067), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505678] = 4,
    ACTIONS(20784), 1,
      sym__layout_end,
    STATE(15189), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20782), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505695] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16107), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [505708] = 4,
    ACTIONS(19388), 1,
      anon_sym_LPAREN,
    STATE(18788), 1,
      sym_export_names,
    ACTIONS(20786), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505725] = 5,
    ACTIONS(4087), 1,
      sym__conid,
    STATE(3600), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505744] = 5,
    ACTIONS(12423), 1,
      sym__conid,
    STATE(8232), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505763] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15574), 4,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
  [505776] = 5,
    ACTIONS(12537), 1,
      sym__conid,
    STATE(8267), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505795] = 4,
    ACTIONS(20788), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20790), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505812] = 4,
    STATE(2391), 1,
      sym__colon2,
    STATE(14191), 1,
      sym__type_annotation,
    ACTIONS(15640), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505829] = 4,
    ACTIONS(20794), 1,
      sym__layout_end,
    STATE(15215), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20792), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505846] = 4,
    ACTIONS(20796), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20798), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505863] = 4,
    ACTIONS(20802), 1,
      sym__layout_end,
    STATE(15414), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20800), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505880] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18569), 4,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [505893] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20804), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [505906] = 4,
    ACTIONS(20128), 1,
      anon_sym_LPAREN,
    STATE(18581), 1,
      sym_import_con_names,
    ACTIONS(20806), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505923] = 5,
    ACTIONS(3051), 1,
      sym__conid,
    STATE(5641), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505942] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19750), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [505955] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20314), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [505968] = 4,
    ACTIONS(20808), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20810), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [505985] = 5,
    ACTIONS(4061), 1,
      sym__conid,
    STATE(4465), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506004] = 4,
    ACTIONS(4947), 1,
      sym__layout_end,
    STATE(15050), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(20812), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506021] = 4,
    ACTIONS(20816), 1,
      sym__layout_end,
    STATE(15231), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20814), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506038] = 5,
    ACTIONS(7158), 1,
      sym__conid,
    STATE(4749), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506057] = 4,
    ACTIONS(1053), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20818), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506074] = 4,
    ACTIONS(11679), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20820), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506091] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16089), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [506104] = 4,
    ACTIONS(20824), 1,
      sym_comma,
    STATE(15218), 1,
      aux_sym_signature_repeat1,
    ACTIONS(20822), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506121] = 4,
    ACTIONS(20827), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20829), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506138] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14694), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506151] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14690), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506164] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15578), 4,
      anon_sym_SEMI,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_RBRACE,
  [506177] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13158), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506190] = 4,
    ACTIONS(11629), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20831), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506207] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16085), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [506220] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14824), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506233] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14787), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506246] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14748), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506259] = 4,
    ACTIONS(1093), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20833), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506276] = 5,
    ACTIONS(4055), 1,
      sym__conid,
    STATE(4216), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506295] = 4,
    ACTIONS(11456), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20835), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506312] = 4,
    ACTIONS(20839), 1,
      sym__layout_end,
    STATE(15224), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20837), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506329] = 4,
    ACTIONS(423), 1,
      sym__varsym,
    ACTIONS(16383), 1,
      anon_sym_DASH,
    STATE(19797), 2,
      sym_operator,
      sym__minus,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506346] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14656), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506359] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14698), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506372] = 4,
    ACTIONS(1043), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20841), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506389] = 4,
    ACTIONS(20845), 1,
      sym__layout_end,
    STATE(15229), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20843), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506406] = 4,
    STATE(2408), 1,
      sym__colon2,
    STATE(12007), 1,
      sym__type_annotation,
    ACTIONS(15918), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506423] = 4,
    ACTIONS(20849), 1,
      sym__layout_end,
    STATE(14614), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20847), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506440] = 5,
    ACTIONS(4565), 1,
      sym__conid,
    STATE(10519), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506459] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14686), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506472] = 4,
    ACTIONS(20851), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20853), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506489] = 4,
    ACTIONS(20857), 1,
      sym__layout_end,
    STATE(15216), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20855), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506506] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14682), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506519] = 4,
    STATE(2402), 1,
      sym__colon2,
    STATE(12120), 1,
      sym__type_annotation,
    ACTIONS(15910), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506536] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14678), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506549] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16071), 4,
      sym__arith_dotdot,
      sym_comma,
      anon_sym_RBRACK,
      anon_sym_DOT_DOT,
  [506562] = 4,
    ACTIONS(5015), 1,
      sym__layout_end,
    STATE(15086), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(20859), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506579] = 4,
    ACTIONS(20128), 1,
      anon_sym_LPAREN,
    STATE(18732), 1,
      sym_import_con_names,
    ACTIONS(20861), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506596] = 4,
    ACTIONS(20863), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20865), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506613] = 5,
    ACTIONS(7140), 1,
      sym__conid,
    STATE(6221), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506632] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18569), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [506645] = 4,
    ACTIONS(20867), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20869), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506662] = 4,
    ACTIONS(20873), 1,
      sym__layout_end,
    STATE(15187), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20871), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506679] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14702), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506692] = 4,
    ACTIONS(20877), 1,
      sym__layout_end,
    STATE(15276), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20875), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506709] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14664), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506722] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14795), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506735] = 4,
    ACTIONS(20881), 1,
      sym__layout_end,
    STATE(15280), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20879), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506752] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14668), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [506765] = 5,
    ACTIONS(6545), 1,
      sym__conid,
    STATE(6982), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506784] = 4,
    ACTIONS(20885), 1,
      sym__layout_end,
    STATE(15236), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20883), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506801] = 5,
    ACTIONS(4047), 1,
      sym__conid,
    STATE(4452), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506820] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18905), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_in,
  [506833] = 4,
    ACTIONS(18970), 1,
      anon_sym_in,
    STATE(14892), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(20887), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506850] = 5,
    ACTIONS(10978), 1,
      sym__conid,
    STATE(7864), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506869] = 5,
    ACTIONS(8765), 1,
      sym__conid,
    STATE(11318), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506888] = 5,
    ACTIONS(7122), 1,
      sym__conid,
    STATE(5681), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506907] = 5,
    ACTIONS(7082), 1,
      sym__conid,
    STATE(7078), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506926] = 4,
    ACTIONS(19388), 1,
      anon_sym_LPAREN,
    STATE(18232), 1,
      sym_export_names,
    ACTIONS(20889), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506943] = 4,
    ACTIONS(20891), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20893), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506960] = 4,
    ACTIONS(20897), 1,
      sym__layout_end,
    STATE(15286), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20895), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506977] = 5,
    ACTIONS(6897), 1,
      sym__conid,
    STATE(5937), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [506996] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15425), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [507009] = 4,
    ACTIONS(20901), 1,
      sym__layout_end,
    STATE(15285), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20899), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507026] = 4,
    ACTIONS(1133), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20903), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507043] = 5,
    ACTIONS(6181), 1,
      sym__conid,
    STATE(7165), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507062] = 5,
    ACTIONS(6408), 1,
      sym__conid,
    STATE(5933), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507081] = 4,
    STATE(2085), 1,
      sym__colon2,
    STATE(17585), 1,
      sym__gadt_constr_type,
    ACTIONS(20740), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507098] = 4,
    ACTIONS(1041), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20905), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507115] = 4,
    ACTIONS(20909), 1,
      sym__layout_end,
    STATE(14839), 1,
      aux_sym__gadt_rhs_repeat2,
    ACTIONS(20907), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507132] = 5,
    ACTIONS(8936), 1,
      sym__conid,
    STATE(10152), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507151] = 5,
    ACTIONS(20911), 1,
      anon_sym_SEMI,
    ACTIONS(20913), 1,
      sym__layout_semicolon,
    ACTIONS(20915), 1,
      sym__layout_end,
    STATE(14985), 1,
      aux_sym__pattern_arrow_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507170] = 4,
    ACTIONS(11727), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20917), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507187] = 4,
    ACTIONS(11366), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20919), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507204] = 4,
    ACTIONS(11701), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20921), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507221] = 4,
    STATE(2417), 1,
      sym__colon2,
    STATE(15225), 1,
      sym__type_annotation,
    ACTIONS(15674), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507238] = 4,
    STATE(2430), 1,
      sym__colon2,
    STATE(9657), 1,
      sym__type_annotation,
    ACTIONS(15351), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507255] = 5,
    ACTIONS(14078), 1,
      sym__conid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(14350), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507274] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20923), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [507287] = 4,
    ACTIONS(11595), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20925), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507304] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20413), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [507317] = 5,
    ACTIONS(13626), 1,
      sym__conid,
    STATE(13225), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(13301), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507336] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18595), 4,
      sym_comma,
      sym__unboxed_close,
      anon_sym_4,
      anon_sym_COLON_COLON,
  [507349] = 5,
    ACTIONS(6943), 1,
      sym__conid,
    STATE(6905), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507368] = 5,
    ACTIONS(16885), 1,
      sym__varid,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(19831), 1,
      sym_constructor,
    STATE(20308), 1,
      sym_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507387] = 4,
    ACTIONS(20927), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20929), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507404] = 5,
    ACTIONS(14534), 1,
      sym__conid,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(13563), 1,
      sym_constructor,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507423] = 4,
    ACTIONS(971), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20931), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507440] = 4,
    ACTIONS(20933), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20935), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507457] = 3,
    ACTIONS(20937), 1,
      sym_where,
    ACTIONS(19575), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507472] = 4,
    ACTIONS(917), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20939), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507489] = 4,
    ACTIONS(20943), 1,
      sym__layout_end,
    STATE(15291), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20941), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507506] = 5,
    ACTIONS(13654), 1,
      sym__conid,
    STATE(12865), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507525] = 4,
    ACTIONS(20947), 1,
      sym__layout_end,
    STATE(15284), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20945), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507542] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16012), 4,
      sym__layout_semicolon,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_in,
  [507555] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13736), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [507568] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(19750), 4,
      sym__layout_semicolon,
      sym_comma,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [507581] = 5,
    ACTIONS(13728), 1,
      sym__conid,
    STATE(13039), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507600] = 4,
    ACTIONS(20949), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20951), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507617] = 4,
    ACTIONS(20320), 1,
      sym_comma,
    STATE(15410), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19049), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507634] = 4,
    ACTIONS(20955), 1,
      sym__layout_end,
    STATE(15302), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20953), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507651] = 4,
    ACTIONS(20959), 1,
      sym__layout_end,
    STATE(14872), 1,
      aux_sym_alts_repeat2,
    ACTIONS(20957), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507668] = 4,
    ACTIONS(20961), 1,
      anon_sym_LBRACE,
    ACTIONS(20963), 1,
      sym__layout_start,
    ACTIONS(19585), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507685] = 5,
    ACTIONS(4161), 1,
      sym__conid,
    STATE(4023), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507704] = 5,
    ACTIONS(10541), 1,
      sym__conid,
    STATE(8011), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507723] = 4,
    ACTIONS(17326), 1,
      anon_sym_LPAREN,
    ACTIONS(18685), 1,
      sym__varid,
    STATE(12881), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507740] = 4,
    STATE(2393), 1,
      sym__colon2,
    STATE(13280), 1,
      sym__type_annotation,
    ACTIONS(15604), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507757] = 4,
    ACTIONS(20965), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20967), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507774] = 5,
    ACTIONS(4407), 1,
      sym__conid,
    STATE(10221), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507793] = 5,
    ACTIONS(7271), 1,
      sym__conid,
    STATE(6781), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507812] = 4,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(14113), 1,
      sym_fundep,
    STATE(13812), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507829] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14111), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [507842] = 4,
    ACTIONS(19860), 1,
      sym__layout_end,
    STATE(15248), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(20969), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507859] = 4,
    ACTIONS(20973), 1,
      sym__layout_end,
    STATE(15357), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20971), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507876] = 5,
    ACTIONS(11737), 1,
      sym__conid,
    STATE(7893), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507895] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13721), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [507908] = 4,
    ACTIONS(13272), 1,
      sym__layout_end,
    STATE(14999), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(20975), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507925] = 4,
    STATE(2434), 1,
      sym__colon2,
    STATE(13527), 1,
      sym__type_annotation,
    ACTIONS(15742), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507942] = 3,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(18743), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507957] = 4,
    ACTIONS(20977), 1,
      anon_sym_LBRACE,
    ACTIONS(20979), 1,
      sym__layout_start,
    ACTIONS(19303), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [507974] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16012), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [507987] = 4,
    ACTIONS(20983), 1,
      sym__layout_end,
    STATE(15358), 1,
      aux_sym_rec_repeat2,
    ACTIONS(20981), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508004] = 5,
    ACTIONS(11540), 1,
      sym__conid,
    STATE(7928), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508023] = 5,
    ACTIONS(7355), 1,
      sym__conid,
    STATE(6936), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508042] = 4,
    ACTIONS(20985), 1,
      anon_sym_DOT_DOT,
    ACTIONS(20987), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508059] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20989), 4,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [508072] = 4,
    ACTIONS(20991), 1,
      anon_sym_LBRACE,
    ACTIONS(20993), 1,
      sym__layout_start,
    ACTIONS(19772), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508089] = 5,
    ACTIONS(6695), 1,
      sym__conid,
    STATE(6366), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508108] = 5,
    ACTIONS(4289), 1,
      sym__conid,
    STATE(5474), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508127] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20923), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [508140] = 5,
    ACTIONS(20995), 1,
      anon_sym_SEMI,
    ACTIONS(20997), 1,
      sym__layout_semicolon,
    ACTIONS(20999), 1,
      sym__layout_end,
    STATE(15011), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508159] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 4,
      sym__unboxed_close,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
  [508172] = 4,
    ACTIONS(21003), 1,
      sym__layout_end,
    STATE(15021), 1,
      aux_sym_rec_repeat2,
    ACTIONS(21001), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508189] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16138), 4,
      sym__layout_semicolon,
      sym_where,
      ts_builtin_sym_end,
      anon_sym_SEMI,
  [508202] = 4,
    ACTIONS(21007), 1,
      sym__layout_end,
    STATE(15212), 1,
      aux_sym_class_body_repeat2,
    ACTIONS(21005), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508219] = 5,
    ACTIONS(11976), 1,
      sym__conid,
    STATE(8343), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508238] = 4,
    ACTIONS(21011), 1,
      sym_comma,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(21009), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508255] = 5,
    ACTIONS(13772), 1,
      sym__conid,
    STATE(12580), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508274] = 4,
    ACTIONS(21016), 1,
      sym__layout_end,
    STATE(15360), 1,
      aux_sym_alts_repeat2,
    ACTIONS(21014), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508291] = 4,
    STATE(2420), 1,
      sym__colon2,
    STATE(12445), 1,
      sym__type_annotation,
    ACTIONS(15940), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508308] = 4,
    ACTIONS(21018), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21020), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508325] = 5,
    ACTIONS(13821), 1,
      sym__conid,
    STATE(12788), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508344] = 4,
    ACTIONS(21024), 1,
      sym__layout_end,
    STATE(15299), 1,
      aux_sym_rec_repeat2,
    ACTIONS(21022), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508361] = 4,
    ACTIONS(21026), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21028), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508378] = 4,
    ACTIONS(21030), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21032), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508395] = 4,
    ACTIONS(921), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(21034), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508412] = 4,
    ACTIONS(1073), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(21036), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508429] = 4,
    ACTIONS(13272), 1,
      sym__layout_end,
    STATE(15012), 1,
      aux_sym_decl_tyfam_repeat2,
    ACTIONS(20975), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508446] = 4,
    ACTIONS(11391), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(21038), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508463] = 4,
    ACTIONS(21040), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21042), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508480] = 4,
    ACTIONS(21046), 1,
      sym__layout_end,
    STATE(15366), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(21044), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508497] = 5,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(19075), 1,
      anon_sym_LPAREN,
    STATE(13817), 1,
      sym_variable,
    STATE(17725), 1,
      sym_signature,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508516] = 5,
    ACTIONS(5980), 1,
      sym__conid,
    STATE(6226), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508535] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18595), 4,
      anon_sym_2,
      anon_sym_DASH_GT,
      anon_sym_PIPE,
      anon_sym_EQ,
  [508548] = 4,
    ACTIONS(5108), 1,
      sym__layout_end,
    STATE(15086), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(21048), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508565] = 4,
    ACTIONS(21050), 1,
      sym__varid,
    ACTIONS(21052), 1,
      anon_sym_LPAREN,
    STATE(14507), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508582] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14042), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [508595] = 4,
    ACTIONS(21056), 1,
      sym__layout_end,
    STATE(15389), 1,
      aux_sym_rec_repeat2,
    ACTIONS(21054), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508612] = 4,
    ACTIONS(21058), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21060), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508629] = 4,
    ACTIONS(11813), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(21062), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508646] = 5,
    ACTIONS(8476), 1,
      sym__conid,
    STATE(10265), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508665] = 5,
    ACTIONS(13853), 1,
      sym__conid,
    STATE(12216), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508684] = 3,
    ACTIONS(21064), 1,
      sym_where,
    ACTIONS(19303), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508699] = 3,
    ACTIONS(17843), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(18715), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508714] = 5,
    ACTIONS(1402), 1,
      sym__conid,
    STATE(4009), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508733] = 4,
    ACTIONS(999), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(21066), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508750] = 3,
    ACTIONS(21068), 1,
      sym_where,
    ACTIONS(20146), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508765] = 4,
    ACTIONS(21072), 1,
      sym__layout_end,
    STATE(15371), 1,
      aux_sym_alts_repeat2,
    ACTIONS(21070), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508782] = 4,
    ACTIONS(11395), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(21074), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508799] = 4,
    ACTIONS(21079), 1,
      sym__layout_end,
    STATE(15381), 1,
      aux_sym_decl_instance_repeat2,
    ACTIONS(21076), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508816] = 4,
    STATE(2360), 1,
      sym__colon2,
    STATE(19522), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508833] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(18715), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_where,
      anon_sym_SEMI,
  [508846] = 4,
    ACTIONS(21081), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21083), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508863] = 4,
    ACTIONS(21087), 1,
      sym__layout_end,
    STATE(15399), 1,
      aux_sym_alts_repeat2,
    ACTIONS(21085), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508880] = 5,
    ACTIONS(8823), 1,
      sym__conid,
    STATE(9547), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508899] = 4,
    ACTIONS(951), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(21089), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508916] = 5,
    ACTIONS(3032), 1,
      sym__conid,
    STATE(4434), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508935] = 4,
    ACTIONS(1071), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(21091), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508952] = 4,
    ACTIONS(13642), 1,
      sym__varid,
    ACTIONS(17745), 1,
      anon_sym_LPAREN,
    STATE(14020), 2,
      sym_type_variable,
      sym_annotated_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508969] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20065), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [508982] = 4,
    STATE(2360), 1,
      sym__colon2,
    STATE(11006), 1,
      sym__type_annotation,
    ACTIONS(15084), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [508999] = 4,
    STATE(2436), 1,
      sym__colon2,
    STATE(12140), 1,
      sym__type_annotation,
    ACTIONS(15916), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509016] = 4,
    ACTIONS(21095), 1,
      sym__layout_end,
    STATE(15380), 1,
      aux_sym_alts_repeat2,
    ACTIONS(21093), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509033] = 4,
    ACTIONS(21097), 1,
      anon_sym_DOT_DOT,
    ACTIONS(21099), 1,
      sym__arith_dotdot,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509050] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14187), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509063] = 5,
    ACTIONS(6036), 1,
      sym__conid,
    STATE(5491), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509082] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13776), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509095] = 4,
    ACTIONS(11673), 1,
      sym__layout_end,
    STATE(14843), 1,
      aux_sym_alts_repeat2,
    ACTIONS(21101), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509112] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(16018), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [509125] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13684), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509138] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(15425), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym_comma,
      anon_sym_SEMI,
  [509151] = 4,
    ACTIONS(5110), 1,
      sym__layout_end,
    STATE(15086), 1,
      aux_sym__let_decls_repeat2,
    ACTIONS(21103), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509168] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14191), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509181] = 5,
    ACTIONS(4073), 1,
      sym__conid,
    STATE(4386), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509200] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13891), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509213] = 4,
    ACTIONS(21107), 1,
      sym__layout_end,
    STATE(15387), 1,
      aux_sym_rec_repeat2,
    ACTIONS(21105), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509230] = 5,
    ACTIONS(6209), 1,
      sym__conid,
    STATE(5793), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509249] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14064), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509262] = 4,
    ACTIONS(20320), 1,
      sym_comma,
    STATE(15177), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19071), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509279] = 4,
    ACTIONS(20320), 1,
      sym_comma,
    STATE(15181), 1,
      aux_sym_fixity_repeat1,
    ACTIONS(19071), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509296] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14257), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509309] = 4,
    STATE(2432), 1,
      sym__colon2,
    STATE(12292), 1,
      sym__type_annotation,
    ACTIONS(15946), 2,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509326] = 4,
    ACTIONS(1055), 1,
      sym__layout_end,
    STATE(15118), 1,
      aux_sym_rec_repeat2,
    ACTIONS(21109), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509343] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14271), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509356] = 4,
    ACTIONS(18139), 1,
      sym_where,
    STATE(18170), 1,
      sym_class_body,
    ACTIONS(19510), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509373] = 5,
    ACTIONS(9252), 1,
      sym__conid,
    STATE(9799), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509392] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14251), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509405] = 4,
    ACTIONS(21111), 1,
      anon_sym_LBRACE,
    ACTIONS(21113), 1,
      sym__layout_start,
    ACTIONS(19520), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509422] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14060), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509435] = 5,
    ACTIONS(9170), 1,
      sym__conid,
    STATE(10324), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509454] = 5,
    ACTIONS(13987), 1,
      sym__conid,
    STATE(12562), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509473] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(13740), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509486] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14267), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509499] = 5,
    ACTIONS(6762), 1,
      sym__conid,
    STATE(6157), 1,
      sym_constructor,
    STATE(13269), 1,
      aux_sym__qualifying_module,
    STATE(20878), 1,
      sym__modid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509518] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(14478), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509531] = 2,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
    ACTIONS(20443), 4,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_deriving,
  [509544] = 4,
    ACTIONS(21117), 1,
      sym__layout_end,
    STATE(15377), 1,
      aux_sym_rec_repeat2,
    ACTIONS(21115), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509561] = 3,
    ACTIONS(21121), 1,
      sym_quasiquote_body,
    ACTIONS(21119), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509575] = 4,
    ACTIONS(1055), 1,
      anon_sym_RBRACE,
    ACTIONS(21123), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509591] = 2,
    ACTIONS(13682), 3,
      sym_comma,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509603] = 4,
    ACTIONS(21087), 1,
      anon_sym_RBRACE,
    ACTIONS(21125), 1,
      anon_sym_SEMI,
    STATE(15439), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509619] = 3,
    ACTIONS(21127), 1,
      sym_where,
    ACTIONS(19575), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509633] = 4,
    ACTIONS(1071), 1,
      anon_sym_RBRACE,
    ACTIONS(21129), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509649] = 4,
    ACTIONS(21131), 1,
      anon_sym_RBRACE,
    ACTIONS(21133), 1,
      sym_comma,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509665] = 4,
    ACTIONS(21135), 1,
      anon_sym_RBRACE,
    ACTIONS(21137), 1,
      sym_comma,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509681] = 4,
    ACTIONS(21139), 1,
      anon_sym_RBRACK,
    ACTIONS(21141), 1,
      sym_comma,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509697] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14261), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509711] = 4,
    ACTIONS(11673), 1,
      anon_sym_RBRACE,
    ACTIONS(21143), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509727] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14550), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509741] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(6240), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509755] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(6240), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509769] = 3,
    ACTIONS(21147), 1,
      sym_quasiquote_body,
    ACTIONS(21145), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509783] = 3,
    ACTIONS(21151), 1,
      sym_quasiquote_body,
    ACTIONS(21149), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509797] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(14550), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509811] = 3,
    ACTIONS(21155), 1,
      sym_quasiquote_body,
    ACTIONS(21153), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509825] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13717), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509839] = 4,
    ACTIONS(21157), 1,
      anon_sym_RPAREN,
    ACTIONS(21159), 1,
      sym_comma,
    STATE(15468), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509855] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21161), 1,
      anon_sym_RBRACK,
    STATE(15471), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509871] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(13721), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509885] = 3,
    ACTIONS(21165), 1,
      sym_quasiquote_body,
    ACTIONS(21163), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509899] = 2,
    ACTIONS(20051), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509911] = 3,
    ACTIONS(21169), 1,
      sym_quasiquote_body,
    ACTIONS(21167), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509925] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21171), 1,
      anon_sym_RPAREN,
    STATE(15472), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509941] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21173), 1,
      anon_sym_RBRACK,
    STATE(15474), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509957] = 3,
    STATE(16687), 1,
      sym__carrow,
    ACTIONS(21175), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509971] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21177), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [509987] = 3,
    STATE(1522), 1,
      sym__arrow,
    ACTIONS(21179), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510001] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21181), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510017] = 3,
    ACTIONS(21185), 1,
      sym_quasiquote_body,
    ACTIONS(21183), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510031] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21187), 1,
      anon_sym_RPAREN,
    STATE(15629), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510047] = 4,
    ACTIONS(21189), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510063] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21193), 1,
      anon_sym_RBRACK,
    STATE(15637), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510079] = 3,
    ACTIONS(21197), 1,
      sym_quasiquote_body,
    ACTIONS(21195), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510093] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21201), 1,
      anon_sym_RPAREN,
    STATE(15499), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510109] = 4,
    ACTIONS(2775), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510125] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21203), 1,
      anon_sym_RPAREN,
    STATE(15488), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510141] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21205), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510157] = 3,
    ACTIONS(18074), 1,
      sym__dot,
    ACTIONS(18372), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510171] = 4,
    ACTIONS(21207), 1,
      anon_sym_RBRACK,
    ACTIONS(21209), 1,
      sym_comma,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510187] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21211), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510203] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21213), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510219] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(21215), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510235] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21217), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510251] = 3,
    ACTIONS(21221), 1,
      sym_quasiquote_body,
    ACTIONS(21219), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510265] = 4,
    ACTIONS(21223), 1,
      anon_sym_RPAREN,
    ACTIONS(21225), 1,
      sym_comma,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510281] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21227), 1,
      anon_sym_RBRACK,
    STATE(15495), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510297] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21229), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510313] = 3,
    STATE(9303), 1,
      sym__carrow,
    ACTIONS(21231), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510327] = 4,
    ACTIONS(21233), 1,
      sym__conid,
    STATE(3460), 1,
      sym_constructor,
    STATE(13654), 1,
      sym_newtype_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510343] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21235), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510359] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(21237), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510375] = 4,
    ACTIONS(21239), 1,
      anon_sym_RPAREN,
    ACTIONS(21241), 1,
      sym_comma,
    STATE(15518), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510391] = 4,
    ACTIONS(21117), 1,
      anon_sym_RBRACE,
    ACTIONS(21243), 1,
      anon_sym_SEMI,
    STATE(15504), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510407] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21245), 1,
      anon_sym_RBRACE,
    STATE(15505), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510423] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(21247), 1,
      anon_sym_RBRACE,
    STATE(15506), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510439] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21249), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510455] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21251), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510471] = 3,
    STATE(1504), 1,
      sym__arrow,
    ACTIONS(21253), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510485] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21255), 1,
      anon_sym_RBRACK,
    STATE(15510), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510501] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(21257), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510517] = 4,
    ACTIONS(19995), 1,
      anon_sym_RBRACE,
    ACTIONS(21259), 1,
      anon_sym_SEMI,
    STATE(15522), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510533] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21261), 1,
      anon_sym_RBRACE,
    STATE(15523), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510549] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(21263), 1,
      anon_sym_RBRACE,
    STATE(15525), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510565] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21265), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510581] = 2,
    ACTIONS(21267), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510593] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(21269), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510609] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21271), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510625] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21273), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510641] = 4,
    ACTIONS(21072), 1,
      anon_sym_RBRACE,
    ACTIONS(21275), 1,
      anon_sym_SEMI,
    STATE(15514), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510657] = 2,
    ACTIONS(21277), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510669] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21279), 1,
      anon_sym_RBRACK,
    STATE(15531), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510685] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21281), 1,
      anon_sym_RBRACK,
    STATE(15437), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510701] = 4,
    ACTIONS(999), 1,
      anon_sym_RBRACE,
    ACTIONS(21283), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510717] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21285), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510733] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(21287), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510749] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21289), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510765] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21291), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510781] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(21293), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510797] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21295), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510813] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(21297), 1,
      anon_sym_RBRACE,
    STATE(15436), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510829] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21299), 1,
      anon_sym_RBRACE,
    STATE(15435), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510845] = 4,
    ACTIONS(20029), 1,
      anon_sym_RBRACE,
    ACTIONS(21301), 1,
      anon_sym_SEMI,
    STATE(15533), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510861] = 4,
    ACTIONS(11813), 1,
      anon_sym_RBRACE,
    ACTIONS(21303), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510877] = 4,
    ACTIONS(21056), 1,
      anon_sym_RBRACE,
    ACTIONS(21305), 1,
      anon_sym_SEMI,
    STATE(15434), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510893] = 4,
    ACTIONS(21307), 1,
      anon_sym_LPAREN,
    ACTIONS(21309), 1,
      sym_where,
    STATE(20379), 1,
      sym_exports,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510909] = 4,
    ACTIONS(17757), 1,
      anon_sym_RPAREN,
    ACTIONS(21311), 1,
      sym_comma,
    STATE(15540), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510925] = 4,
    ACTIONS(21241), 1,
      sym_comma,
    ACTIONS(21313), 1,
      anon_sym_RPAREN,
    STATE(16862), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510941] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(21315), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510957] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21317), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510973] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21319), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [510989] = 4,
    ACTIONS(909), 1,
      anon_sym_RBRACE,
    ACTIONS(21321), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511005] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21323), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511021] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21325), 1,
      anon_sym_RBRACK,
    STATE(15498), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511037] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(21327), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511053] = 3,
    ACTIONS(21331), 1,
      sym_quasiquote_body,
    ACTIONS(21329), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511067] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21333), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511083] = 3,
    ACTIONS(21337), 1,
      sym_quasiquote_body,
    ACTIONS(21335), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511097] = 2,
    ACTIONS(21339), 3,
      anon_sym_LPAREN,
      sym__conid,
      anon_sym_instance,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511109] = 4,
    ACTIONS(20055), 1,
      anon_sym_RBRACE,
    ACTIONS(21341), 1,
      anon_sym_SEMI,
    STATE(15550), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511125] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21343), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511141] = 2,
    ACTIONS(21345), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511153] = 4,
    ACTIONS(11503), 1,
      anon_sym_RBRACE,
    ACTIONS(21347), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511169] = 4,
    ACTIONS(21349), 1,
      anon_sym_SEMI,
    ACTIONS(21351), 1,
      anon_sym_RBRACE,
    STATE(15594), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511185] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21353), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511201] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(21355), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511217] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21357), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511233] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21359), 1,
      anon_sym_RPAREN,
    STATE(15508), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511249] = 4,
    ACTIONS(2830), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511265] = 4,
    ACTIONS(17833), 1,
      anon_sym_RPAREN,
    ACTIONS(21361), 1,
      sym_comma,
    STATE(17466), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511281] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21363), 1,
      anon_sym_RBRACK,
    STATE(15507), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511297] = 3,
    ACTIONS(21367), 1,
      sym_quasiquote_body,
    ACTIONS(21365), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511311] = 4,
    ACTIONS(20108), 1,
      anon_sym_RBRACE,
    ACTIONS(21369), 1,
      anon_sym_SEMI,
    STATE(15565), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511327] = 4,
    ACTIONS(21371), 1,
      anon_sym_RPAREN,
    ACTIONS(21373), 1,
      sym_comma,
    STATE(15571), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511343] = 4,
    ACTIONS(20126), 1,
      anon_sym_RBRACE,
    ACTIONS(21375), 1,
      anon_sym_SEMI,
    STATE(15573), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511359] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21377), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511375] = 3,
    ACTIONS(18181), 1,
      sym__varid,
    STATE(12811), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511389] = 4,
    ACTIONS(20134), 1,
      anon_sym_RBRACE,
    ACTIONS(21379), 1,
      anon_sym_SEMI,
    STATE(15574), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511405] = 4,
    ACTIONS(20144), 1,
      anon_sym_RBRACE,
    ACTIONS(21381), 1,
      anon_sym_SEMI,
    STATE(15575), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511421] = 4,
    ACTIONS(5469), 1,
      anon_sym_RBRACE,
    ACTIONS(21383), 1,
      anon_sym_SEMI,
    STATE(17736), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511437] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21385), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511453] = 4,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(21387), 1,
      sym__unboxed_close,
    STATE(15838), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511469] = 4,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(21389), 1,
      sym__unboxed_close,
    STATE(15848), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511485] = 4,
    ACTIONS(12555), 1,
      anon_sym_RBRACE,
    ACTIONS(21391), 1,
      anon_sym_SEMI,
    STATE(15577), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511501] = 3,
    ACTIONS(21395), 1,
      sym_quasiquote_body,
    ACTIONS(21393), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511515] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(21397), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511531] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21399), 1,
      anon_sym_RPAREN,
    STATE(15586), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511547] = 4,
    ACTIONS(16879), 1,
      sym__varid,
    ACTIONS(21401), 1,
      anon_sym_LPAREN,
    STATE(15851), 1,
      sym_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511563] = 2,
    ACTIONS(20481), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511575] = 4,
    ACTIONS(17833), 1,
      anon_sym_RPAREN,
    ACTIONS(21361), 1,
      sym_comma,
    STATE(15563), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511591] = 2,
    ACTIONS(19981), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511603] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(21403), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511619] = 4,
    ACTIONS(17787), 1,
      anon_sym_RPAREN,
    ACTIONS(21405), 1,
      sym_comma,
    STATE(17466), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511635] = 3,
    ACTIONS(21407), 1,
      sym_where,
    ACTIONS(20146), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511649] = 4,
    ACTIONS(18665), 1,
      anon_sym_RBRACE,
    ACTIONS(21409), 1,
      anon_sym_SEMI,
    STATE(17349), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511665] = 4,
    ACTIONS(21411), 1,
      anon_sym_RBRACE,
    ACTIONS(21413), 1,
      sym_comma,
    STATE(15591), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511681] = 2,
    ACTIONS(16138), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511693] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21415), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511709] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21417), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511725] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21419), 1,
      anon_sym_RBRACK,
    STATE(15593), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511741] = 4,
    ACTIONS(21373), 1,
      sym_comma,
    ACTIONS(21421), 1,
      anon_sym_RPAREN,
    STATE(17284), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511757] = 4,
    ACTIONS(21373), 1,
      sym_comma,
    ACTIONS(21423), 1,
      anon_sym_RPAREN,
    STATE(15592), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511773] = 4,
    ACTIONS(4955), 1,
      anon_sym_RBRACE,
    ACTIONS(21425), 1,
      anon_sym_SEMI,
    STATE(17215), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511789] = 4,
    ACTIONS(1101), 1,
      anon_sym_RBRACE,
    ACTIONS(21427), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511805] = 4,
    ACTIONS(5120), 1,
      anon_sym_RBRACE,
    ACTIONS(21429), 1,
      anon_sym_SEMI,
    STATE(16345), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511821] = 3,
    ACTIONS(21431), 1,
      sym_where,
    ACTIONS(19303), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511835] = 4,
    ACTIONS(13131), 1,
      anon_sym_RBRACE,
    ACTIONS(21433), 1,
      anon_sym_SEMI,
    STATE(17165), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511851] = 4,
    ACTIONS(21435), 1,
      anon_sym_SEMI,
    ACTIONS(21437), 1,
      anon_sym_RBRACE,
    STATE(15639), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511867] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21439), 1,
      anon_sym_RBRACK,
    STATE(15535), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511883] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21441), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511899] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21443), 1,
      anon_sym_RPAREN,
    STATE(15537), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511915] = 3,
    ACTIONS(18685), 1,
      sym__varid,
    STATE(13337), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511929] = 4,
    ACTIONS(20955), 1,
      anon_sym_RBRACE,
    ACTIONS(21445), 1,
      anon_sym_SEMI,
    STATE(15602), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511945] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21447), 1,
      anon_sym_RBRACE,
    STATE(15603), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511961] = 2,
    ACTIONS(19961), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511973] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21449), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [511989] = 4,
    ACTIONS(13131), 1,
      anon_sym_RBRACE,
    ACTIONS(21433), 1,
      anon_sym_SEMI,
    STATE(15597), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512005] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21451), 1,
      anon_sym_RBRACK,
    STATE(15607), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512021] = 4,
    ACTIONS(21453), 1,
      anon_sym_SEMI,
    ACTIONS(21455), 1,
      anon_sym_RBRACE,
    STATE(15605), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512037] = 3,
    STATE(2821), 1,
      sym__arrow,
    ACTIONS(21457), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512051] = 4,
    ACTIONS(21413), 1,
      sym_comma,
    ACTIONS(21459), 1,
      anon_sym_RBRACE,
    STATE(17042), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512067] = 4,
    ACTIONS(21373), 1,
      sym_comma,
    ACTIONS(21461), 1,
      anon_sym_RPAREN,
    STATE(17284), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512083] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21463), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512099] = 4,
    ACTIONS(5074), 1,
      anon_sym_RBRACE,
    ACTIONS(21465), 1,
      anon_sym_SEMI,
    STATE(16345), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512115] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(21467), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512131] = 2,
    ACTIONS(20500), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512143] = 4,
    ACTIONS(13115), 1,
      anon_sym_RBRACE,
    ACTIONS(21469), 1,
      anon_sym_SEMI,
    STATE(17165), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512159] = 4,
    ACTIONS(20947), 1,
      anon_sym_RBRACE,
    ACTIONS(21471), 1,
      anon_sym_SEMI,
    STATE(15611), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512175] = 3,
    ACTIONS(21475), 1,
      sym_quasiquote_body,
    ACTIONS(21473), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512189] = 2,
    ACTIONS(16085), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512201] = 3,
    ACTIONS(21479), 1,
      sym_quasiquote_body,
    ACTIONS(21477), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512215] = 4,
    ACTIONS(917), 1,
      anon_sym_RBRACE,
    ACTIONS(21481), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512231] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21483), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512247] = 2,
    ACTIONS(21485), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512259] = 4,
    ACTIONS(21487), 1,
      anon_sym_SEMI,
    ACTIONS(21489), 1,
      anon_sym_RBRACE,
    STATE(16963), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512275] = 3,
    ACTIONS(21493), 1,
      sym_quasiquote_body,
    ACTIONS(21491), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512289] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21495), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512305] = 4,
    ACTIONS(11701), 1,
      anon_sym_RBRACE,
    ACTIONS(21497), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512321] = 3,
    STATE(2831), 1,
      sym__arrow,
    ACTIONS(21499), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512335] = 3,
    ACTIONS(18074), 1,
      sym__dot,
    ACTIONS(18072), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512349] = 4,
    ACTIONS(11727), 1,
      anon_sym_RBRACE,
    ACTIONS(21501), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512365] = 3,
    STATE(549), 1,
      sym__arrow,
    ACTIONS(17849), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512379] = 3,
    STATE(2830), 1,
      sym__arrow,
    ACTIONS(21503), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512393] = 3,
    ACTIONS(21507), 1,
      sym_quasiquote_body,
    ACTIONS(21505), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512407] = 4,
    ACTIONS(2720), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512423] = 3,
    ACTIONS(21511), 1,
      sym_quasiquote_body,
    ACTIONS(21509), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512437] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21513), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512453] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(21515), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512469] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21517), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512485] = 4,
    ACTIONS(1133), 1,
      anon_sym_RBRACE,
    ACTIONS(21519), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512501] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21521), 1,
      anon_sym_RPAREN,
    STATE(15912), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512517] = 3,
    ACTIONS(21523), 1,
      sym_where,
    ACTIONS(20214), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512531] = 3,
    ACTIONS(21527), 1,
      sym_quasiquote_body,
    ACTIONS(21525), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512545] = 4,
    ACTIONS(20897), 1,
      anon_sym_RBRACE,
    ACTIONS(21529), 1,
      anon_sym_SEMI,
    STATE(15608), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512561] = 3,
    ACTIONS(21533), 1,
      sym_quasiquote_body,
    ACTIONS(21531), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512575] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21535), 1,
      anon_sym_RPAREN,
    STATE(15647), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512591] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(21537), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512607] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21539), 1,
      anon_sym_RBRACK,
    STATE(15649), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512623] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21541), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512639] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21543), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512655] = 3,
    STATE(9242), 1,
      sym__carrow,
    ACTIONS(21545), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512669] = 4,
    ACTIONS(2917), 1,
      sym_comma,
    ACTIONS(21547), 1,
      anon_sym_RPAREN,
    STATE(15939), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512685] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(21549), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512701] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21551), 1,
      anon_sym_RBRACK,
    STATE(15521), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512717] = 3,
    STATE(1564), 1,
      sym__arrow,
    ACTIONS(21553), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512731] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21555), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512747] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21557), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512763] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(21559), 1,
      anon_sym_RBRACE,
    STATE(15618), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512779] = 4,
    ACTIONS(21561), 1,
      anon_sym_SEMI,
    ACTIONS(21563), 1,
      anon_sym_RBRACE,
    STATE(17165), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512795] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21565), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512811] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21567), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512827] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21569), 1,
      anon_sym_RBRACE,
    STATE(15619), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512843] = 4,
    ACTIONS(20877), 1,
      anon_sym_RBRACE,
    ACTIONS(21571), 1,
      anon_sym_SEMI,
    STATE(15620), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512859] = 3,
    ACTIONS(21575), 1,
      sym_quasiquote_body,
    ACTIONS(21573), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512873] = 4,
    ACTIONS(2726), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512889] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21577), 1,
      anon_sym_RPAREN,
    STATE(15677), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512905] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21579), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512921] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(21581), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512937] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21583), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512953] = 3,
    ACTIONS(21587), 1,
      sym_quasiquote_body,
    ACTIONS(21585), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512967] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(21589), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512983] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21591), 1,
      anon_sym_RPAREN,
    STATE(15681), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [512999] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(21593), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513015] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21595), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513031] = 2,
    ACTIONS(21597), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513043] = 4,
    ACTIONS(21599), 1,
      anon_sym_RPAREN,
    ACTIONS(21602), 1,
      sym_comma,
    STATE(15993), 1,
      aux_sym__context_constraints_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513059] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(21605), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513075] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21607), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513091] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21609), 1,
      anon_sym_RBRACK,
    STATE(15682), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513107] = 4,
    ACTIONS(21611), 1,
      anon_sym_RPAREN,
    ACTIONS(21613), 1,
      sym_comma,
    STATE(15993), 1,
      aux_sym__context_constraints_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513123] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21615), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513139] = 4,
    ACTIONS(21233), 1,
      sym__conid,
    STATE(3459), 1,
      sym_constructor,
    STATE(14136), 1,
      sym_newtype_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513155] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21617), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513171] = 4,
    ACTIONS(21241), 1,
      sym_comma,
    ACTIONS(21619), 1,
      anon_sym_RPAREN,
    STATE(15692), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513187] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21621), 1,
      anon_sym_RBRACK,
    STATE(15688), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513203] = 2,
    ACTIONS(6264), 3,
      sym__dot,
      sym_where,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513215] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21623), 1,
      anon_sym_RBRACK,
    STATE(16001), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513231] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21625), 1,
      anon_sym_RBRACK,
    STATE(15630), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513247] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21627), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513263] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21629), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513279] = 3,
    ACTIONS(21631), 1,
      sym_where,
    ACTIONS(19943), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513293] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(21633), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513309] = 4,
    ACTIONS(20455), 1,
      anon_sym_RBRACE,
    ACTIONS(21635), 1,
      anon_sym_SEMI,
    STATE(15743), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513325] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21637), 1,
      anon_sym_RBRACE,
    STATE(15695), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513341] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21639), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513357] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(21641), 1,
      anon_sym_RBRACE,
    STATE(15701), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513373] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21643), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513389] = 4,
    ACTIONS(20845), 1,
      anon_sym_RBRACE,
    ACTIONS(21645), 1,
      anon_sym_SEMI,
    STATE(15697), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513405] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21647), 1,
      anon_sym_RBRACE,
    STATE(15698), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513421] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21649), 1,
      anon_sym_RBRACK,
    STATE(15705), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513437] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21651), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513453] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21653), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513469] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21655), 1,
      anon_sym_RBRACK,
    STATE(15702), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513485] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(21657), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513501] = 4,
    ACTIONS(21659), 1,
      anon_sym_SEMI,
    ACTIONS(21661), 1,
      anon_sym_RBRACE,
    STATE(16027), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513517] = 4,
    ACTIONS(20477), 1,
      anon_sym_RBRACE,
    ACTIONS(21663), 1,
      anon_sym_SEMI,
    STATE(15707), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513533] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21665), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513549] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21667), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513565] = 4,
    ACTIONS(17805), 1,
      anon_sym_RPAREN,
    ACTIONS(21669), 1,
      sym_comma,
    STATE(15710), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513581] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(21671), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513597] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(21673), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513613] = 4,
    ACTIONS(21241), 1,
      sym_comma,
    ACTIONS(21675), 1,
      anon_sym_RPAREN,
    STATE(16862), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513629] = 4,
    ACTIONS(20839), 1,
      anon_sym_RBRACE,
    ACTIONS(21677), 1,
      anon_sym_SEMI,
    STATE(15706), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513645] = 3,
    STATE(1721), 1,
      sym__larrow,
    ACTIONS(21679), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513659] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21681), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513675] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21683), 1,
      anon_sym_RPAREN,
    STATE(15636), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513691] = 4,
    ACTIONS(1093), 1,
      anon_sym_RBRACE,
    ACTIONS(21685), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513707] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21687), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513723] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(21689), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513739] = 2,
    ACTIONS(21691), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513751] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(21693), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513767] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21695), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513783] = 3,
    ACTIONS(21699), 1,
      sym_quasiquote_body,
    ACTIONS(21697), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513797] = 4,
    ACTIONS(20520), 1,
      anon_sym_RBRACE,
    ACTIONS(21701), 1,
      anon_sym_SEMI,
    STATE(15727), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513813] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21703), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513829] = 4,
    ACTIONS(11629), 1,
      anon_sym_RBRACE,
    ACTIONS(21705), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513845] = 4,
    ACTIONS(11733), 1,
      anon_sym_RBRACE,
    ACTIONS(21707), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513861] = 2,
    ACTIONS(21709), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513873] = 4,
    ACTIONS(21711), 1,
      anon_sym_SEMI,
    ACTIONS(21713), 1,
      anon_sym_RBRACE,
    STATE(15731), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513889] = 4,
    ACTIONS(17835), 1,
      anon_sym_RPAREN,
    ACTIONS(21715), 1,
      sym_comma,
    STATE(17466), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513905] = 4,
    ACTIONS(17835), 1,
      anon_sym_RPAREN,
    ACTIONS(21715), 1,
      sym_comma,
    STATE(15732), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513921] = 4,
    ACTIONS(20550), 1,
      anon_sym_RBRACE,
    ACTIONS(21717), 1,
      anon_sym_SEMI,
    STATE(15735), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513937] = 4,
    ACTIONS(21373), 1,
      sym_comma,
    ACTIONS(21719), 1,
      anon_sym_RPAREN,
    STATE(15741), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513953] = 4,
    ACTIONS(20560), 1,
      anon_sym_RBRACE,
    ACTIONS(21721), 1,
      anon_sym_SEMI,
    STATE(15771), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513969] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21723), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513985] = 2,
    ACTIONS(18117), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [513997] = 4,
    ACTIONS(21725), 1,
      ts_builtin_sym_end,
    ACTIONS(21727), 1,
      anon_sym_LBRACE,
    ACTIONS(21729), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514013] = 3,
    ACTIONS(21733), 1,
      sym_quasiquote_body,
    ACTIONS(21731), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514027] = 3,
    ACTIONS(18613), 1,
      sym__varid,
    STATE(13212), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514041] = 3,
    ACTIONS(21737), 1,
      sym_quasiquote_body,
    ACTIONS(21735), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514055] = 2,
    ACTIONS(21739), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514067] = 2,
    ACTIONS(21691), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514079] = 4,
    ACTIONS(19609), 1,
      anon_sym_RBRACE,
    ACTIONS(21741), 1,
      anon_sym_SEMI,
    STATE(15753), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514095] = 2,
    ACTIONS(21691), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514107] = 2,
    ACTIONS(21743), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514119] = 2,
    ACTIONS(21745), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514131] = 4,
    ACTIONS(5459), 1,
      anon_sym_RBRACE,
    ACTIONS(21747), 1,
      anon_sym_SEMI,
    STATE(17736), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514147] = 2,
    ACTIONS(21745), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514159] = 4,
    ACTIONS(12947), 1,
      anon_sym_RBRACE,
    ACTIONS(21749), 1,
      anon_sym_SEMI,
    STATE(15755), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514175] = 2,
    ACTIONS(21745), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514187] = 4,
    ACTIONS(5173), 1,
      anon_sym_RBRACE,
    ACTIONS(21751), 1,
      anon_sym_SEMI,
    STATE(16345), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514203] = 4,
    ACTIONS(17829), 1,
      anon_sym_RPAREN,
    ACTIONS(21753), 1,
      sym_comma,
    STATE(17466), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514219] = 4,
    ACTIONS(21233), 1,
      sym__conid,
    STATE(3435), 1,
      sym_constructor,
    STATE(13868), 1,
      sym_newtype_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514235] = 2,
    ACTIONS(21755), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514247] = 4,
    ACTIONS(18609), 1,
      anon_sym_RBRACE,
    ACTIONS(21757), 1,
      anon_sym_SEMI,
    STATE(17349), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514263] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21759), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514279] = 4,
    ACTIONS(21413), 1,
      sym_comma,
    ACTIONS(21761), 1,
      anon_sym_RBRACE,
    STATE(15768), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514295] = 2,
    ACTIONS(21763), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514307] = 2,
    ACTIONS(21765), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514319] = 2,
    ACTIONS(21755), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514331] = 4,
    ACTIONS(21373), 1,
      sym_comma,
    ACTIONS(21767), 1,
      anon_sym_RPAREN,
    STATE(17284), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514347] = 4,
    ACTIONS(21373), 1,
      sym_comma,
    ACTIONS(21769), 1,
      anon_sym_RPAREN,
    STATE(15769), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514363] = 4,
    ACTIONS(1083), 1,
      anon_sym_RBRACE,
    ACTIONS(21771), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514379] = 2,
    ACTIONS(21773), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514391] = 3,
    ACTIONS(21777), 1,
      sym_quasiquote_body,
    ACTIONS(21775), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514405] = 4,
    ACTIONS(2939), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514421] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21779), 1,
      anon_sym_RPAREN,
    STATE(15776), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514437] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21781), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514453] = 2,
    ACTIONS(21763), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514465] = 2,
    ACTIONS(21765), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514477] = 2,
    ACTIONS(21765), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514489] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(21783), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514505] = 4,
    ACTIONS(5017), 1,
      anon_sym_RBRACE,
    ACTIONS(21785), 1,
      anon_sym_SEMI,
    STATE(16345), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514521] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21787), 1,
      anon_sym_RBRACK,
    STATE(15687), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514537] = 4,
    ACTIONS(13129), 1,
      anon_sym_RBRACE,
    ACTIONS(21789), 1,
      anon_sym_SEMI,
    STATE(17165), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514553] = 4,
    ACTIONS(21791), 1,
      anon_sym_SEMI,
    ACTIONS(21793), 1,
      anon_sym_RBRACE,
    STATE(15816), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514569] = 3,
    ACTIONS(18966), 1,
      sym__varid,
    STATE(13665), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514583] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21795), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514599] = 2,
    ACTIONS(21797), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514611] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21799), 1,
      anon_sym_RBRACK,
    STATE(15783), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514627] = 2,
    ACTIONS(21797), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514639] = 4,
    ACTIONS(13129), 1,
      anon_sym_RBRACE,
    ACTIONS(21789), 1,
      anon_sym_SEMI,
    STATE(15775), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514655] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21801), 1,
      anon_sym_RPAREN,
    STATE(15617), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514671] = 2,
    ACTIONS(21797), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514683] = 2,
    ACTIONS(21797), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514695] = 2,
    ACTIONS(21797), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514707] = 4,
    ACTIONS(21803), 1,
      anon_sym_SEMI,
    ACTIONS(21805), 1,
      anon_sym_RBRACE,
    STATE(15777), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514723] = 4,
    ACTIONS(21413), 1,
      sym_comma,
    ACTIONS(21807), 1,
      anon_sym_RBRACE,
    STATE(17042), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514739] = 4,
    ACTIONS(21373), 1,
      sym_comma,
    ACTIONS(21809), 1,
      anon_sym_RPAREN,
    STATE(17284), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514755] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21811), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514771] = 4,
    ACTIONS(4957), 1,
      anon_sym_RBRACE,
    ACTIONS(21813), 1,
      anon_sym_SEMI,
    STATE(17215), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514787] = 2,
    ACTIONS(19024), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514799] = 4,
    ACTIONS(20784), 1,
      anon_sym_RBRACE,
    ACTIONS(21815), 1,
      anon_sym_SEMI,
    STATE(15792), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514815] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21817), 1,
      anon_sym_RBRACE,
    STATE(15793), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514831] = 4,
    ACTIONS(13087), 1,
      anon_sym_RBRACE,
    ACTIONS(21819), 1,
      anon_sym_SEMI,
    STATE(17165), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514847] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21821), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514863] = 4,
    ACTIONS(21823), 1,
      anon_sym_SEMI,
    ACTIONS(21825), 1,
      anon_sym_RBRACE,
    STATE(16963), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514879] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21827), 1,
      anon_sym_RBRACK,
    STATE(15797), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514895] = 3,
    ACTIONS(21831), 1,
      sym_quasiquote_body,
    ACTIONS(21829), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514909] = 2,
    ACTIONS(21833), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514921] = 2,
    ACTIONS(21835), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514933] = 4,
    ACTIONS(21241), 1,
      sym_comma,
    ACTIONS(21837), 1,
      anon_sym_RPAREN,
    STATE(16145), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514949] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21839), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514965] = 3,
    ACTIONS(21843), 1,
      sym_quasiquote_body,
    ACTIONS(21841), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514979] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(21845), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [514995] = 3,
    ACTIONS(21849), 1,
      sym_quasiquote_body,
    ACTIONS(21847), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515009] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21851), 1,
      anon_sym_RPAREN,
    STATE(15803), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515025] = 4,
    ACTIONS(20780), 1,
      anon_sym_RBRACE,
    ACTIONS(21853), 1,
      anon_sym_SEMI,
    STATE(15801), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515041] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21855), 1,
      anon_sym_RBRACK,
    STATE(15805), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515057] = 3,
    STATE(1372), 1,
      sym__arrow,
    ACTIONS(21857), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515071] = 2,
    ACTIONS(21859), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515083] = 4,
    ACTIONS(1139), 1,
      anon_sym_RBRACE,
    ACTIONS(21861), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515099] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21863), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515115] = 3,
    ACTIONS(21867), 1,
      sym_quasiquote_body,
    ACTIONS(21865), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515129] = 2,
    ACTIONS(19510), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515141] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21869), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515157] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21871), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515173] = 3,
    ACTIONS(21875), 1,
      sym_quasiquote_body,
    ACTIONS(21873), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515187] = 2,
    ACTIONS(19105), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515199] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(21877), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515215] = 4,
    ACTIONS(11617), 1,
      anon_sym_RBRACE,
    ACTIONS(21879), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515231] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21881), 1,
      anon_sym_RPAREN,
    STATE(15835), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515247] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21883), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515263] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(21885), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515279] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(21887), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515295] = 4,
    ACTIONS(11633), 1,
      anon_sym_RBRACE,
    ACTIONS(21889), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515311] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21891), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515327] = 2,
    ACTIONS(21893), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515339] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21895), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515355] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(21897), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515371] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21899), 1,
      anon_sym_RBRACK,
    STATE(15849), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515387] = 2,
    ACTIONS(21901), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515399] = 3,
    ACTIONS(21905), 1,
      sym_quasiquote_body,
    ACTIONS(21903), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515413] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21907), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515429] = 3,
    ACTIONS(21911), 1,
      sym_quasiquote_body,
    ACTIONS(21909), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515443] = 4,
    ACTIONS(21913), 1,
      anon_sym_SEMI,
    ACTIONS(21915), 1,
      anon_sym_RBRACE,
    STATE(17165), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515459] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21917), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515475] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(21919), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515491] = 2,
    ACTIONS(21921), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515503] = 2,
    ACTIONS(21923), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515515] = 2,
    ACTIONS(21739), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515527] = 4,
    ACTIONS(1099), 1,
      anon_sym_RBRACE,
    ACTIONS(21925), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515543] = 2,
    ACTIONS(21927), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515555] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21929), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515571] = 4,
    ACTIONS(20744), 1,
      anon_sym_RBRACE,
    ACTIONS(21931), 1,
      anon_sym_SEMI,
    STATE(15806), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515587] = 4,
    ACTIONS(1757), 1,
      anon_sym_PIPE,
    ACTIONS(21933), 1,
      sym__unboxed_close,
    STATE(15838), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515603] = 4,
    ACTIONS(20794), 1,
      anon_sym_RBRACE,
    ACTIONS(21935), 1,
      anon_sym_SEMI,
    STATE(15857), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515619] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(21937), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515635] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(21939), 1,
      anon_sym_RBRACE,
    STATE(15859), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515651] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(21941), 1,
      anon_sym_RBRACE,
    STATE(15860), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515667] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(21943), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515683] = 2,
    ACTIONS(19173), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515695] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(21945), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515711] = 2,
    ACTIONS(21947), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515723] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21949), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515739] = 4,
    ACTIONS(935), 1,
      anon_sym_PIPE,
    ACTIONS(21951), 1,
      sym__unboxed_close,
    STATE(15848), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515755] = 4,
    ACTIONS(21953), 1,
      sym_comma,
    ACTIONS(21956), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515771] = 4,
    ACTIONS(21958), 1,
      anon_sym_PIPE,
    ACTIONS(21961), 1,
      sym__unboxed_close,
    STATE(15838), 1,
      aux_sym__exp_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515787] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(21963), 1,
      anon_sym_RBRACK,
    STATE(15861), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515803] = 3,
    ACTIONS(21967), 1,
      sym_quasiquote_body,
    ACTIONS(21965), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515817] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(21969), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515833] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(21971), 1,
      anon_sym_RPAREN,
    STATE(15871), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515849] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21973), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515865] = 2,
    ACTIONS(21947), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515877] = 2,
    ACTIONS(21947), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515889] = 2,
    ACTIONS(21975), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515901] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(21977), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515917] = 4,
    ACTIONS(21979), 1,
      anon_sym_PIPE,
    ACTIONS(21982), 1,
      sym__unboxed_close,
    STATE(15848), 1,
      aux_sym__pat_unboxed_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515933] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21984), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515949] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(21986), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515965] = 2,
    ACTIONS(21988), 3,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515977] = 4,
    ACTIONS(20816), 1,
      anon_sym_RBRACE,
    ACTIONS(21990), 1,
      anon_sym_SEMI,
    STATE(15862), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [515993] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21992), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516009] = 2,
    ACTIONS(16071), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516021] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(21994), 1,
      anon_sym_RBRACK,
    STATE(15878), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516037] = 2,
    ACTIONS(21996), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516049] = 4,
    ACTIONS(1053), 1,
      anon_sym_RBRACE,
    ACTIONS(21998), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516065] = 2,
    ACTIONS(20591), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516077] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22000), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516093] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22002), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516109] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22004), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516125] = 4,
    ACTIONS(11456), 1,
      anon_sym_RBRACE,
    ACTIONS(22006), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516141] = 2,
    ACTIONS(22008), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516153] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22010), 1,
      anon_sym_RBRACK,
    STATE(15809), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516169] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22012), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516185] = 4,
    ACTIONS(19860), 1,
      anon_sym_RBRACE,
    ACTIONS(22014), 1,
      anon_sym_SEMI,
    STATE(15875), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516201] = 2,
    ACTIONS(22016), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516213] = 4,
    ACTIONS(20734), 1,
      anon_sym_RBRACE,
    ACTIONS(22018), 1,
      anon_sym_SEMI,
    STATE(15887), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516229] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22020), 1,
      anon_sym_RBRACE,
    STATE(15888), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516245] = 3,
    STATE(1662), 1,
      sym__larrow,
    ACTIONS(22022), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516259] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22024), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516275] = 4,
    ACTIONS(20849), 1,
      anon_sym_RBRACE,
    ACTIONS(22026), 1,
      anon_sym_SEMI,
    STATE(16279), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516291] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22028), 1,
      anon_sym_RBRACK,
    STATE(15892), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516307] = 4,
    ACTIONS(21413), 1,
      sym_comma,
    ACTIONS(22030), 1,
      anon_sym_RBRACE,
    STATE(15876), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516323] = 4,
    ACTIONS(5015), 1,
      anon_sym_RBRACE,
    ACTIONS(22032), 1,
      anon_sym_SEMI,
    STATE(16345), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516339] = 4,
    ACTIONS(21413), 1,
      sym_comma,
    ACTIONS(22034), 1,
      anon_sym_RBRACE,
    STATE(17042), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516355] = 2,
    ACTIONS(22036), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516367] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22038), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516383] = 3,
    ACTIONS(22042), 1,
      sym_quasiquote_body,
    ACTIONS(22040), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516397] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22044), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516413] = 3,
    ACTIONS(22048), 1,
      sym_quasiquote_body,
    ACTIONS(22046), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516427] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22050), 1,
      anon_sym_RBRACE,
    STATE(16192), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516443] = 4,
    ACTIONS(20730), 1,
      anon_sym_RBRACE,
    ACTIONS(22052), 1,
      anon_sym_SEMI,
    STATE(15896), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516459] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22054), 1,
      anon_sym_RPAREN,
    STATE(15901), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516475] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22056), 1,
      anon_sym_RBRACK,
    STATE(15906), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516491] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22058), 1,
      anon_sym_RBRACE,
    STATE(15810), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516507] = 4,
    ACTIONS(925), 1,
      anon_sym_RBRACE,
    ACTIONS(22060), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516523] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22062), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516539] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22064), 1,
      anon_sym_RBRACE,
    STATE(15814), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516555] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22066), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516571] = 4,
    ACTIONS(20720), 1,
      anon_sym_RBRACE,
    ACTIONS(22068), 1,
      anon_sym_SEMI,
    STATE(15822), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516587] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22070), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516603] = 3,
    ACTIONS(22072), 1,
      anon_sym_EQ,
    ACTIONS(22074), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516617] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(22076), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516633] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22078), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516649] = 4,
    ACTIONS(11603), 1,
      anon_sym_RBRACE,
    ACTIONS(22080), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516665] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22082), 1,
      anon_sym_RBRACE,
    STATE(16198), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516681] = 3,
    ACTIONS(22086), 1,
      sym_quasiquote_body,
    ACTIONS(22084), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516695] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(22088), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516711] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22090), 1,
      anon_sym_RPAREN,
    STATE(15933), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516727] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22092), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516743] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22094), 1,
      anon_sym_RBRACK,
    STATE(15843), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516759] = 2,
    ACTIONS(20136), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516771] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22096), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516787] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22098), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516803] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22100), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516819] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22102), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516835] = 3,
    ACTIONS(22106), 1,
      sym_quasiquote_body,
    ACTIONS(22104), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516849] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22108), 1,
      anon_sym_RBRACK,
    STATE(15940), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516865] = 3,
    ACTIONS(22112), 1,
      sym_quasiquote_body,
    ACTIONS(22110), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516879] = 2,
    ACTIONS(22114), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516891] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22116), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516907] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22118), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516923] = 2,
    ACTIONS(20678), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516935] = 2,
    ACTIONS(22120), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516947] = 2,
    ACTIONS(22122), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516959] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22124), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516975] = 2,
    ACTIONS(18809), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [516987] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22126), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517003] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(22128), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517019] = 2,
    ACTIONS(22130), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517031] = 2,
    ACTIONS(22132), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517043] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22134), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517059] = 4,
    ACTIONS(20983), 1,
      anon_sym_RBRACE,
    ACTIONS(22136), 1,
      anon_sym_SEMI,
    STATE(15947), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517075] = 4,
    ACTIONS(2917), 1,
      sym_comma,
    ACTIONS(22138), 1,
      anon_sym_RPAREN,
    STATE(16232), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517091] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22140), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517107] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22142), 1,
      anon_sym_RPAREN,
    STATE(15748), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517123] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22144), 1,
      anon_sym_RBRACE,
    STATE(15959), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517139] = 2,
    ACTIONS(19220), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517151] = 4,
    ACTIONS(2917), 1,
      sym_comma,
    ACTIONS(22138), 1,
      anon_sym_RPAREN,
    STATE(16579), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517167] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22146), 1,
      anon_sym_RBRACE,
    STATE(15953), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517183] = 2,
    ACTIONS(21009), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517195] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22148), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517211] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22150), 1,
      anon_sym_RBRACK,
    STATE(15954), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517227] = 3,
    ACTIONS(22154), 1,
      sym_quasiquote_body,
    ACTIONS(22152), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517241] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(22156), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517257] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22158), 1,
      anon_sym_RPAREN,
    STATE(15966), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517273] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(22160), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517289] = 4,
    ACTIONS(2917), 1,
      sym_comma,
    ACTIONS(22162), 1,
      anon_sym_RPAREN,
    STATE(16579), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517305] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22164), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517321] = 2,
    ACTIONS(22166), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517333] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22168), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517349] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22170), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517365] = 3,
    ACTIONS(22174), 1,
      sym_quasiquote_body,
    ACTIONS(22172), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517379] = 4,
    ACTIONS(21016), 1,
      anon_sym_RBRACE,
    ACTIONS(22176), 1,
      anon_sym_SEMI,
    STATE(15957), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517395] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22178), 1,
      anon_sym_RBRACK,
    STATE(16240), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517411] = 4,
    ACTIONS(1073), 1,
      anon_sym_RBRACE,
    ACTIONS(22180), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517427] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22182), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517443] = 2,
    ACTIONS(22166), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517455] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22184), 1,
      anon_sym_RBRACK,
    STATE(15973), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517471] = 2,
    ACTIONS(22186), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517483] = 3,
    STATE(1527), 1,
      sym__arrow,
    ACTIONS(22188), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517497] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22190), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517513] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22192), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517529] = 4,
    ACTIONS(22194), 1,
      anon_sym_RBRACK,
    ACTIONS(22196), 1,
      sym_comma,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517545] = 2,
    ACTIONS(22199), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517557] = 4,
    ACTIONS(11391), 1,
      anon_sym_RBRACE,
    ACTIONS(22201), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517573] = 4,
    ACTIONS(21046), 1,
      anon_sym_RBRACE,
    ACTIONS(22203), 1,
      anon_sym_SEMI,
    STATE(16024), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517589] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22205), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517605] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22207), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517621] = 2,
    ACTIONS(13682), 3,
      sym__dot,
      sym_where,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517633] = 3,
    ACTIONS(22211), 1,
      sym_quasiquote_body,
    ACTIONS(22209), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517647] = 4,
    ACTIONS(20660), 1,
      anon_sym_RBRACE,
    ACTIONS(22213), 1,
      anon_sym_SEMI,
    STATE(15982), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517663] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22215), 1,
      anon_sym_RBRACE,
    STATE(15983), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517679] = 3,
    ACTIONS(22219), 1,
      sym_quasiquote_body,
    ACTIONS(22217), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517693] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22221), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517709] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22223), 1,
      anon_sym_RPAREN,
    STATE(15981), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517725] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22225), 1,
      anon_sym_RBRACK,
    STATE(15987), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517741] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22227), 1,
      anon_sym_RBRACK,
    STATE(15992), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517757] = 3,
    STATE(1671), 1,
      sym__arrow,
    ACTIONS(22229), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517771] = 2,
    ACTIONS(22231), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517783] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22233), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517799] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22235), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517815] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22237), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517831] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22239), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517847] = 2,
    ACTIONS(18927), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517859] = 3,
    ACTIONS(22243), 1,
      sym_quasiquote_body,
    ACTIONS(22241), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517873] = 4,
    ACTIONS(20650), 1,
      anon_sym_RBRACE,
    ACTIONS(22245), 1,
      anon_sym_SEMI,
    STATE(15991), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517889] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(22247), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517905] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22249), 1,
      anon_sym_RPAREN,
    STATE(16019), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517921] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22251), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517937] = 4,
    ACTIONS(1005), 1,
      anon_sym_RBRACE,
    ACTIONS(22253), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517953] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22255), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517969] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22257), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517985] = 2,
    ACTIONS(22259), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [517997] = 4,
    ACTIONS(21613), 1,
      sym_comma,
    ACTIONS(22261), 1,
      anon_sym_RPAREN,
    STATE(15993), 1,
      aux_sym__context_constraints_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518013] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22263), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518029] = 2,
    ACTIONS(20395), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518041] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22265), 1,
      anon_sym_RBRACK,
    STATE(15917), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518057] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22267), 1,
      anon_sym_RPAREN,
    STATE(15923), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518073] = 4,
    ACTIONS(11593), 1,
      anon_sym_RBRACE,
    ACTIONS(22269), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518089] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22271), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518105] = 4,
    ACTIONS(21613), 1,
      sym_comma,
    ACTIONS(22273), 1,
      anon_sym_RPAREN,
    STATE(16408), 1,
      aux_sym__context_constraints_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518121] = 3,
    STATE(9359), 1,
      sym__arrow,
    ACTIONS(22275), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518135] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22277), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518151] = 3,
    ACTIONS(18907), 1,
      anon_sym_in,
    ACTIONS(18905), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518165] = 2,
    ACTIONS(22279), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518177] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22281), 1,
      anon_sym_RPAREN,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518193] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22283), 1,
      anon_sym_RBRACK,
    STATE(16025), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518209] = 3,
    ACTIONS(22287), 1,
      sym_quasiquote_body,
    ACTIONS(22285), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518223] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22289), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518239] = 3,
    ACTIONS(22293), 1,
      sym_quasiquote_body,
    ACTIONS(22291), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518253] = 3,
    ACTIONS(22297), 1,
      sym_quasiquote_body,
    ACTIONS(22295), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518267] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22299), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518283] = 3,
    ACTIONS(22303), 1,
      sym_quasiquote_body,
    ACTIONS(22301), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518297] = 4,
    ACTIONS(19239), 1,
      anon_sym_PIPE,
    ACTIONS(22305), 1,
      sym__unboxed_close,
    STATE(16327), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518313] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22307), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518329] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(22309), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518345] = 4,
    ACTIONS(20973), 1,
      anon_sym_RBRACE,
    ACTIONS(22311), 1,
      anon_sym_SEMI,
    STATE(16029), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518361] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22313), 1,
      anon_sym_RBRACE,
    STATE(16034), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518377] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22315), 1,
      anon_sym_RBRACE,
    STATE(16105), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518393] = 2,
    ACTIONS(20413), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518405] = 4,
    ACTIONS(11605), 1,
      anon_sym_RBRACE,
    ACTIONS(22317), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518421] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22319), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518437] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22321), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518453] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22323), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518469] = 4,
    ACTIONS(983), 1,
      anon_sym_RBRACE,
    ACTIONS(22325), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518485] = 4,
    ACTIONS(20574), 1,
      anon_sym_RBRACE,
    ACTIONS(22327), 1,
      anon_sym_SEMI,
    STATE(16013), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518501] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22329), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518517] = 4,
    ACTIONS(20959), 1,
      anon_sym_RBRACE,
    ACTIONS(22331), 1,
      anon_sym_SEMI,
    STATE(16338), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518533] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22333), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518549] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22335), 1,
      anon_sym_RBRACK,
    STATE(16038), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518565] = 2,
    ACTIONS(22337), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518577] = 4,
    ACTIONS(5108), 1,
      anon_sym_RBRACE,
    ACTIONS(22339), 1,
      anon_sym_SEMI,
    STATE(16345), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518593] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22341), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518609] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22343), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518625] = 4,
    ACTIONS(5124), 1,
      anon_sym_RBRACE,
    ACTIONS(22345), 1,
      anon_sym_SEMI,
    STATE(16345), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518641] = 4,
    ACTIONS(20873), 1,
      anon_sym_RBRACE,
    ACTIONS(22347), 1,
      anon_sym_SEMI,
    STATE(16040), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518657] = 4,
    ACTIONS(921), 1,
      anon_sym_RBRACE,
    ACTIONS(22349), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518673] = 3,
    ACTIONS(22353), 1,
      sym_quasiquote_body,
    ACTIONS(22351), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518687] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(22355), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518703] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22357), 1,
      anon_sym_RPAREN,
    STATE(16061), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518719] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22359), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518735] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22361), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518751] = 2,
    ACTIONS(22363), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518763] = 2,
    ACTIONS(18847), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518775] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22365), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518791] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22367), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518807] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22369), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518823] = 4,
    ACTIONS(11619), 1,
      anon_sym_RBRACE,
    ACTIONS(22371), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518839] = 2,
    ACTIONS(22373), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518851] = 2,
    ACTIONS(18595), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518863] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22375), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518879] = 2,
    ACTIONS(18569), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518891] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22377), 1,
      anon_sym_RBRACK,
    STATE(16068), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518907] = 2,
    ACTIONS(18601), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518919] = 3,
    ACTIONS(22381), 1,
      sym_quasiquote_body,
    ACTIONS(22379), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518933] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22383), 1,
      anon_sym_RBRACK,
    STATE(16014), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518949] = 2,
    ACTIONS(18849), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518961] = 2,
    ACTIONS(18861), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518973] = 3,
    ACTIONS(22387), 1,
      sym_quasiquote_body,
    ACTIONS(22385), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [518987] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22389), 1,
      anon_sym_RPAREN,
    STATE(16090), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519003] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22391), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519019] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22393), 1,
      anon_sym_RBRACK,
    STATE(16093), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519035] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22395), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519051] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22397), 1,
      anon_sym_RBRACE,
    STATE(16015), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519067] = 2,
    ACTIONS(18591), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519079] = 4,
    ACTIONS(20540), 1,
      anon_sym_RBRACE,
    ACTIONS(22399), 1,
      anon_sym_SEMI,
    STATE(16077), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519095] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22401), 1,
      anon_sym_RBRACE,
    STATE(16078), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519111] = 2,
    ACTIONS(16085), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519123] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22403), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519139] = 2,
    ACTIONS(16071), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519151] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22405), 1,
      anon_sym_RBRACK,
    STATE(16082), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519167] = 2,
    ACTIONS(22407), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519179] = 3,
    STATE(1511), 1,
      sym__arrow,
    ACTIONS(22409), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519193] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22411), 1,
      anon_sym_RBRACE,
    STATE(16016), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519209] = 4,
    ACTIONS(20536), 1,
      anon_sym_RBRACE,
    ACTIONS(22413), 1,
      anon_sym_SEMI,
    STATE(16017), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519225] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22415), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519241] = 2,
    ACTIONS(22417), 3,
      sym__varid,
      anon_sym_LPAREN,
      sym__conid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519253] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22419), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519269] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22421), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519285] = 4,
    ACTIONS(17825), 1,
      anon_sym_RPAREN,
    ACTIONS(22423), 1,
      sym_comma,
    STATE(16399), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519301] = 4,
    ACTIONS(20532), 1,
      anon_sym_RBRACE,
    ACTIONS(22425), 1,
      anon_sym_SEMI,
    STATE(16086), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519317] = 2,
    ACTIONS(18968), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519329] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(22427), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519345] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22429), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519361] = 4,
    ACTIONS(1097), 1,
      anon_sym_RBRACE,
    ACTIONS(22431), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519377] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22433), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519393] = 3,
    ACTIONS(22437), 1,
      sym_quasiquote_body,
    ACTIONS(22435), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519407] = 2,
    ACTIONS(20230), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519419] = 2,
    ACTIONS(20443), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519431] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22439), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519447] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(22441), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519463] = 2,
    ACTIONS(20445), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519475] = 2,
    ACTIONS(18873), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519487] = 4,
    ACTIONS(11550), 1,
      anon_sym_RBRACE,
    ACTIONS(22443), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519503] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22445), 1,
      anon_sym_RBRACK,
    STATE(16039), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519519] = 2,
    ACTIONS(22447), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519531] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22449), 1,
      anon_sym_RPAREN,
    STATE(16121), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519547] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22451), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519563] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22453), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519579] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22455), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519595] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22457), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519611] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22459), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519627] = 4,
    ACTIONS(22461), 1,
      anon_sym_RPAREN,
    ACTIONS(22463), 1,
      sym_comma,
    STATE(16684), 1,
      aux_sym_exports_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519643] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22465), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519659] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22467), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519675] = 3,
    ACTIONS(22471), 1,
      sym_quasiquote_body,
    ACTIONS(22469), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519689] = 4,
    ACTIONS(22473), 1,
      ts_builtin_sym_end,
    ACTIONS(22475), 1,
      anon_sym_LBRACE,
    ACTIONS(22477), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519705] = 3,
    ACTIONS(22481), 1,
      sym_quasiquote_body,
    ACTIONS(22479), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519719] = 2,
    ACTIONS(22483), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519731] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22485), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519747] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22487), 1,
      anon_sym_RBRACK,
    STATE(16128), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519763] = 2,
    ACTIONS(20804), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519775] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22489), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519791] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22491), 1,
      anon_sym_RPAREN,
    STATE(16053), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519807] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22493), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519823] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(22495), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519839] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(22497), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519855] = 2,
    ACTIONS(22499), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519867] = 3,
    ACTIONS(22503), 1,
      sym_quasiquote_body,
    ACTIONS(22501), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519881] = 4,
    ACTIONS(20425), 1,
      anon_sym_RBRACE,
    ACTIONS(22505), 1,
      anon_sym_SEMI,
    STATE(16133), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519897] = 2,
    ACTIONS(22507), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519909] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22509), 1,
      anon_sym_RBRACE,
    STATE(16134), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519925] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22511), 1,
      anon_sym_RBRACE,
    STATE(16135), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519941] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22513), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519957] = 2,
    ACTIONS(22515), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519969] = 2,
    ACTIONS(22517), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519981] = 2,
    ACTIONS(22519), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [519993] = 2,
    ACTIONS(22499), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520005] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22521), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520021] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22523), 1,
      anon_sym_RBRACK,
    STATE(16136), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520037] = 2,
    ACTIONS(18927), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520049] = 4,
    ACTIONS(16518), 1,
      sym__consym,
    ACTIONS(22525), 1,
      anon_sym_BQUOTE,
    STATE(3143), 1,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520065] = 3,
    ACTIONS(22529), 1,
      sym_quasiquote_body,
    ACTIONS(22527), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520079] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(22531), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520095] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22533), 1,
      anon_sym_RPAREN,
    STATE(16156), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520111] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22535), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520127] = 2,
    ACTIONS(22537), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520139] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22539), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520155] = 4,
    ACTIONS(20318), 1,
      anon_sym_RBRACE,
    ACTIONS(22541), 1,
      anon_sym_SEMI,
    STATE(16137), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520171] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22543), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520187] = 4,
    ACTIONS(969), 1,
      anon_sym_RBRACE,
    ACTIONS(22545), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520203] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22547), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520219] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22549), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520235] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22551), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520251] = 4,
    ACTIONS(11809), 1,
      anon_sym_RBRACE,
    ACTIONS(22553), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520267] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22555), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520283] = 2,
    ACTIONS(18936), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520295] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22557), 1,
      anon_sym_RBRACK,
    STATE(16163), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520311] = 2,
    ACTIONS(22559), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520323] = 2,
    ACTIONS(22561), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520335] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22563), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520351] = 2,
    ACTIONS(22565), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520363] = 4,
    ACTIONS(21241), 1,
      sym_comma,
    ACTIONS(22567), 1,
      anon_sym_RPAREN,
    STATE(16862), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520379] = 3,
    ACTIONS(22571), 1,
      sym_quasiquote_body,
    ACTIONS(22569), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520393] = 3,
    ACTIONS(22575), 1,
      sym_quasiquote_body,
    ACTIONS(22573), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520407] = 2,
    ACTIONS(22577), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520419] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22579), 1,
      anon_sym_RPAREN,
    STATE(16169), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520435] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22581), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520451] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22583), 1,
      anon_sym_RBRACK,
    STATE(16175), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520467] = 2,
    ACTIONS(19744), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520479] = 4,
    ACTIONS(20449), 1,
      anon_sym_RBRACE,
    ACTIONS(22585), 1,
      anon_sym_SEMI,
    STATE(16172), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520495] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22587), 1,
      anon_sym_RBRACE,
    STATE(16173), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520511] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22589), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520527] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22591), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520543] = 3,
    ACTIONS(22595), 1,
      sym_quasiquote_body,
    ACTIONS(22593), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520557] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22597), 1,
      anon_sym_RBRACK,
    STATE(16177), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520573] = 2,
    ACTIONS(22599), 3,
      sym_string,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520585] = 2,
    ACTIONS(22601), 3,
      sym_string,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520597] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22603), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520613] = 4,
    ACTIONS(2710), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520629] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22605), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520645] = 3,
    STATE(1586), 1,
      sym__arrow,
    ACTIONS(22607), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520659] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22609), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520675] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22611), 1,
      anon_sym_RBRACK,
    STATE(16096), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520691] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22613), 1,
      anon_sym_RPAREN,
    STATE(16191), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520707] = 4,
    ACTIONS(20441), 1,
      anon_sym_RBRACE,
    ACTIONS(22615), 1,
      anon_sym_SEMI,
    STATE(16181), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520723] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22617), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520739] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22619), 1,
      anon_sym_RPAREN,
    STATE(16102), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520755] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22621), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520771] = 4,
    ACTIONS(1161), 1,
      anon_sym_RBRACE,
    ACTIONS(22623), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520787] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22625), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520803] = 2,
    ACTIONS(22627), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520815] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22629), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520831] = 2,
    ACTIONS(22631), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520843] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22633), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520859] = 3,
    ACTIONS(22637), 1,
      sym_quasiquote_body,
    ACTIONS(22635), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520873] = 3,
    ACTIONS(18970), 1,
      anon_sym_in,
    ACTIONS(18968), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520887] = 3,
    ACTIONS(22641), 1,
      sym_quasiquote_body,
    ACTIONS(22639), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520901] = 4,
    ACTIONS(11452), 1,
      anon_sym_RBRACE,
    ACTIONS(22643), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520917] = 2,
    ACTIONS(18739), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520929] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22645), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520945] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22647), 1,
      anon_sym_RBRACK,
    STATE(16197), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520961] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22649), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520977] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(22651), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [520993] = 2,
    ACTIONS(22653), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521005] = 4,
    ACTIONS(19971), 1,
      anon_sym_RBRACE,
    ACTIONS(22655), 1,
      anon_sym_SEMI,
    STATE(16213), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521021] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22657), 1,
      anon_sym_RBRACE,
    STATE(16215), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521037] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22659), 1,
      anon_sym_RBRACE,
    STATE(16216), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521053] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22661), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521069] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22663), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521085] = 3,
    ACTIONS(22667), 1,
      sym_quasiquote_body,
    ACTIONS(22665), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521099] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22669), 1,
      anon_sym_RBRACK,
    STATE(16217), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521115] = 3,
    ACTIONS(22673), 1,
      sym_quasiquote_body,
    ACTIONS(22671), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521129] = 2,
    ACTIONS(22675), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521141] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22677), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521157] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22679), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521173] = 2,
    ACTIONS(18877), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521185] = 2,
    ACTIONS(18561), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521197] = 4,
    ACTIONS(11554), 1,
      anon_sym_RBRACE,
    ACTIONS(22681), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521213] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22683), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521229] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22685), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521245] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22687), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521261] = 2,
    ACTIONS(18879), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521273] = 2,
    ACTIONS(22689), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521285] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22691), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521301] = 2,
    ACTIONS(18905), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521313] = 4,
    ACTIONS(20037), 1,
      anon_sym_RBRACE,
    ACTIONS(22693), 1,
      anon_sym_SEMI,
    STATE(16218), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521329] = 2,
    ACTIONS(20760), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521341] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22695), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521357] = 4,
    ACTIONS(1059), 1,
      anon_sym_RBRACE,
    ACTIONS(22697), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521373] = 4,
    ACTIONS(1109), 1,
      anon_sym_RBRACE,
    ACTIONS(22699), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521389] = 2,
    ACTIONS(22701), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521401] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22703), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521417] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22705), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521433] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22707), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521449] = 4,
    ACTIONS(11683), 1,
      anon_sym_RBRACE,
    ACTIONS(22709), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521465] = 4,
    ACTIONS(20076), 1,
      anon_sym_RBRACE,
    ACTIONS(22711), 1,
      anon_sym_SEMI,
    STATE(17211), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521481] = 3,
    ACTIONS(22715), 1,
      sym_quasiquote_body,
    ACTIONS(22713), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521495] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(22717), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521511] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22719), 1,
      anon_sym_RPAREN,
    STATE(16251), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521527] = 4,
    ACTIONS(20391), 1,
      anon_sym_RBRACE,
    ACTIONS(22721), 1,
      anon_sym_SEMI,
    STATE(16201), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521543] = 3,
    ACTIONS(22723), 1,
      sym_where,
    ACTIONS(20310), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521557] = 2,
    ACTIONS(18595), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521569] = 4,
    ACTIONS(20275), 1,
      sym__unboxed_close,
    ACTIONS(22725), 1,
      sym_comma,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521585] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22728), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521601] = 2,
    ACTIONS(18569), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521613] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22730), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521629] = 4,
    ACTIONS(22732), 1,
      sym__immediate_dot,
    ACTIONS(22735), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521645] = 2,
    ACTIONS(20767), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521657] = 4,
    ACTIONS(2917), 1,
      sym_comma,
    ACTIONS(22737), 1,
      anon_sym_RPAREN,
    STATE(16579), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521673] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22739), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521689] = 2,
    ACTIONS(16107), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521701] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22741), 1,
      anon_sym_RBRACK,
    STATE(16258), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521717] = 2,
    ACTIONS(16103), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521729] = 3,
    ACTIONS(22745), 1,
      sym_quasiquote_body,
    ACTIONS(22743), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521743] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22747), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521759] = 2,
    ACTIONS(18834), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521771] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22749), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521787] = 2,
    ACTIONS(18739), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521799] = 3,
    ACTIONS(22753), 1,
      sym_quasiquote_body,
    ACTIONS(22751), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521813] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22755), 1,
      anon_sym_RPAREN,
    STATE(16262), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521829] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22757), 1,
      anon_sym_RBRACK,
    STATE(16203), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521845] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22759), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521861] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22761), 1,
      anon_sym_RBRACK,
    STATE(16277), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521877] = 2,
    ACTIONS(14740), 3,
      sym__consym,
      sym__tyconsym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521889] = 4,
    ACTIONS(20366), 1,
      anon_sym_RBRACE,
    ACTIONS(22763), 1,
      anon_sym_SEMI,
    STATE(16267), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521905] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22765), 1,
      anon_sym_RBRACE,
    STATE(16268), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521921] = 2,
    ACTIONS(16089), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521933] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22767), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521949] = 2,
    ACTIONS(16085), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521961] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22769), 1,
      anon_sym_RBRACK,
    STATE(16272), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521977] = 3,
    STATE(1682), 1,
      sym__arrow,
    ACTIONS(22771), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [521991] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22773), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522007] = 2,
    ACTIONS(22775), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522019] = 2,
    ACTIONS(18893), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522031] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22777), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522047] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(22779), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522063] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22781), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522079] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22783), 1,
      anon_sym_RPAREN,
    STATE(16302), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522095] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22785), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522111] = 4,
    ACTIONS(20362), 1,
      anon_sym_RBRACE,
    ACTIONS(22787), 1,
      anon_sym_SEMI,
    STATE(16276), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522127] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22789), 1,
      anon_sym_RBRACE,
    STATE(16204), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522143] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22791), 1,
      anon_sym_RBRACE,
    STATE(16207), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522159] = 4,
    ACTIONS(20356), 1,
      anon_sym_RBRACE,
    ACTIONS(22793), 1,
      anon_sym_SEMI,
    STATE(16212), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522175] = 4,
    ACTIONS(1121), 1,
      anon_sym_RBRACE,
    ACTIONS(22795), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522191] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22797), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522207] = 2,
    ACTIONS(18893), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522219] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(22799), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522235] = 2,
    ACTIONS(22775), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522247] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22801), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522263] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22803), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522279] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22805), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522295] = 2,
    ACTIONS(20552), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522307] = 4,
    ACTIONS(11407), 1,
      anon_sym_RBRACE,
    ACTIONS(22807), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522323] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22809), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522339] = 4,
    ACTIONS(16879), 1,
      sym__varid,
    STATE(14480), 1,
      sym_variable,
    STATE(15874), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522355] = 4,
    ACTIONS(1081), 1,
      anon_sym_RBRACE,
    ACTIONS(22811), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522371] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22813), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522387] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22815), 1,
      anon_sym_RBRACK,
    STATE(16238), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522403] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22817), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522419] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22819), 1,
      anon_sym_RBRACK,
    STATE(16311), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522435] = 3,
    STATE(552), 1,
      sym__arrow,
    ACTIONS(22821), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522449] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22823), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522465] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(22825), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522481] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22827), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522497] = 3,
    ACTIONS(22831), 1,
      sym_quasiquote_body,
    ACTIONS(22829), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522511] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22833), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522527] = 3,
    ACTIONS(22837), 1,
      sym_quasiquote_body,
    ACTIONS(22835), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522541] = 2,
    ACTIONS(20767), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522553] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22839), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522569] = 4,
    ACTIONS(20228), 1,
      anon_sym_RBRACE,
    ACTIONS(22841), 1,
      anon_sym_SEMI,
    STATE(16321), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522585] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22843), 1,
      anon_sym_RPAREN,
    STATE(16161), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522601] = 2,
    ACTIONS(22701), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522613] = 2,
    ACTIONS(20760), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522625] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22845), 1,
      anon_sym_RBRACE,
    STATE(16323), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522641] = 2,
    ACTIONS(19750), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522653] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(22847), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522669] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22849), 1,
      anon_sym_RBRACE,
    STATE(16324), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522685] = 3,
    ACTIONS(22853), 1,
      sym_quasiquote_body,
    ACTIONS(22851), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522699] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22855), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522715] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22857), 1,
      anon_sym_RBRACK,
    STATE(16325), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522731] = 2,
    ACTIONS(18739), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522743] = 3,
    STATE(15757), 1,
      sym__arrow,
    ACTIONS(22859), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522757] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22861), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522773] = 4,
    ACTIONS(16879), 1,
      sym__varid,
    STATE(14480), 1,
      sym_variable,
    STATE(15737), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522789] = 4,
    ACTIONS(16879), 1,
      sym__varid,
    STATE(14430), 1,
      sym_variable,
    STATE(20359), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522805] = 2,
    ACTIONS(22631), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522817] = 4,
    ACTIONS(16518), 1,
      sym__consym,
    ACTIONS(22863), 1,
      anon_sym_BQUOTE,
    STATE(3123), 1,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522833] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22865), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522849] = 3,
    STATE(1384), 1,
      sym__larrow,
    ACTIONS(22867), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522863] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22869), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522879] = 2,
    ACTIONS(20275), 3,
      sym_comma,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522891] = 3,
    ACTIONS(22873), 1,
      sym_quasiquote_body,
    ACTIONS(22871), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522905] = 4,
    ACTIONS(2820), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522921] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22875), 1,
      anon_sym_RPAREN,
    STATE(16346), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522937] = 4,
    ACTIONS(20266), 1,
      anon_sym_RBRACE,
    ACTIONS(22877), 1,
      anon_sym_SEMI,
    STATE(16326), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522953] = 2,
    ACTIONS(22627), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522965] = 3,
    STATE(553), 1,
      sym__arrow,
    ACTIONS(19452), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522979] = 4,
    ACTIONS(1007), 1,
      anon_sym_RBRACE,
    ACTIONS(22879), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [522995] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22881), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523011] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22883), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523027] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(22885), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523043] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22887), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523059] = 4,
    ACTIONS(11597), 1,
      anon_sym_RBRACE,
    ACTIONS(22889), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523075] = 4,
    ACTIONS(22891), 1,
      anon_sym_PIPE,
    ACTIONS(22894), 1,
      sym__unboxed_close,
    STATE(16327), 1,
      aux_sym__type_sum_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523091] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22896), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523107] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22898), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523123] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22900), 1,
      anon_sym_RBRACK,
    STATE(16353), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523139] = 3,
    ACTIONS(22904), 1,
      sym_quasiquote_body,
    ACTIONS(22902), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523153] = 3,
    ACTIONS(22908), 1,
      sym_quasiquote_body,
    ACTIONS(22906), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523167] = 3,
    ACTIONS(22912), 1,
      sym_quasiquote_body,
    ACTIONS(22910), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523181] = 2,
    ACTIONS(22577), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523193] = 2,
    ACTIONS(19744), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523205] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22914), 1,
      anon_sym_RPAREN,
    STATE(16374), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523221] = 2,
    ACTIONS(18569), 3,
      sym__varsym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523233] = 4,
    ACTIONS(11721), 1,
      anon_sym_RBRACE,
    ACTIONS(22916), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523249] = 2,
    ACTIONS(20395), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523261] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22918), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523277] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22920), 1,
      anon_sym_RBRACK,
    STATE(16378), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523293] = 3,
    STATE(1620), 1,
      sym__arrow,
    ACTIONS(22922), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523307] = 4,
    ACTIONS(20296), 1,
      anon_sym_RBRACE,
    ACTIONS(22924), 1,
      anon_sym_SEMI,
    STATE(16362), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523323] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22926), 1,
      anon_sym_RBRACE,
    STATE(16363), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523339] = 4,
    ACTIONS(22928), 1,
      anon_sym_SEMI,
    ACTIONS(22931), 1,
      anon_sym_RBRACE,
    STATE(16345), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523355] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22933), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523371] = 4,
    ACTIONS(22935), 1,
      anon_sym_SEMI,
    ACTIONS(22937), 1,
      anon_sym_RBRACE,
    STATE(17354), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523387] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22939), 1,
      anon_sym_RBRACK,
    STATE(16367), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523403] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(22941), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523419] = 2,
    ACTIONS(22689), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523431] = 3,
    ACTIONS(19222), 1,
      anon_sym_in,
    ACTIONS(19220), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523445] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22943), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523461] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22945), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523477] = 2,
    ACTIONS(18879), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523489] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(22947), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523505] = 3,
    ACTIONS(22951), 1,
      sym_quasiquote_body,
    ACTIONS(22949), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523519] = 4,
    ACTIONS(2889), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523535] = 4,
    ACTIONS(20288), 1,
      anon_sym_RBRACE,
    ACTIONS(22953), 1,
      anon_sym_SEMI,
    STATE(16371), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523551] = 2,
    ACTIONS(22561), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523563] = 2,
    ACTIONS(18561), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523575] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22955), 1,
      anon_sym_RBRACK,
    STATE(16287), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523591] = 4,
    ACTIONS(1085), 1,
      anon_sym_RBRACE,
    ACTIONS(22957), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523607] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(22959), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523623] = 3,
    STATE(15582), 1,
      sym__arrow,
    ACTIONS(22961), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523637] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22963), 1,
      anon_sym_RPAREN,
    STATE(16292), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523653] = 2,
    ACTIONS(18936), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523665] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(22965), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523681] = 4,
    ACTIONS(16879), 1,
      sym__varid,
    STATE(14480), 1,
      sym_variable,
    STATE(15566), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523697] = 4,
    ACTIONS(16879), 1,
      sym__varid,
    STATE(14430), 1,
      sym_variable,
    STATE(20599), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523713] = 2,
    ACTIONS(18877), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523725] = 4,
    ACTIONS(11385), 1,
      anon_sym_RBRACE,
    ACTIONS(22967), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523741] = 4,
    ACTIONS(16518), 1,
      sym__consym,
    ACTIONS(22969), 1,
      anon_sym_BQUOTE,
    STATE(2998), 1,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523757] = 2,
    ACTIONS(20688), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523769] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22971), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523785] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(22973), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523801] = 3,
    ACTIONS(22977), 1,
      sym_quasiquote_body,
    ACTIONS(22975), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523815] = 2,
    ACTIONS(18927), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523827] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(22979), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523843] = 3,
    ACTIONS(22983), 1,
      sym_quasiquote_body,
    ACTIONS(22981), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523857] = 2,
    ACTIONS(20662), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523869] = 2,
    ACTIONS(20630), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523881] = 2,
    ACTIONS(22499), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523893] = 3,
    ACTIONS(22987), 1,
      sym_quasiquote_body,
    ACTIONS(22985), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523907] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(22989), 1,
      anon_sym_RPAREN,
    STATE(16471), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523923] = 3,
    ACTIONS(22993), 1,
      sym_quasiquote_body,
    ACTIONS(22991), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523937] = 2,
    ACTIONS(22519), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523949] = 2,
    ACTIONS(22517), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523961] = 3,
    STATE(1605), 1,
      sym__larrow,
    ACTIONS(22995), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523975] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22997), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [523991] = 2,
    ACTIONS(22499), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524003] = 3,
    STATE(551), 1,
      sym__arrow,
    ACTIONS(18086), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524017] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(22999), 1,
      anon_sym_RBRACK,
    STATE(16428), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524033] = 2,
    ACTIONS(18595), 3,
      sym__varsym,
      anon_sym_DASH,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524045] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23001), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524061] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(23003), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524077] = 2,
    ACTIONS(22407), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524089] = 2,
    ACTIONS(18591), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524101] = 2,
    ACTIONS(22675), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524113] = 4,
    ACTIONS(17680), 1,
      anon_sym_RPAREN,
    ACTIONS(23005), 1,
      sym_comma,
    STATE(17466), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524129] = 4,
    ACTIONS(20566), 1,
      anon_sym_RBRACE,
    ACTIONS(23007), 1,
      anon_sym_SEMI,
    STATE(16464), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524145] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23009), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524161] = 4,
    ACTIONS(17680), 1,
      anon_sym_RPAREN,
    ACTIONS(23005), 1,
      sym_comma,
    STATE(17570), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524177] = 2,
    ACTIONS(18601), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524189] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23011), 1,
      anon_sym_RBRACE,
    STATE(16472), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524205] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(23013), 1,
      anon_sym_RBRACE,
    STATE(16516), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524221] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23015), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524237] = 4,
    ACTIONS(151), 1,
      anon_sym_RBRACE,
    ACTIONS(23017), 1,
      anon_sym_SEMI,
    STATE(17480), 1,
      aux_sym__module_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524253] = 4,
    ACTIONS(23019), 1,
      anon_sym_RPAREN,
    ACTIONS(23021), 1,
      sym_comma,
    STATE(16408), 1,
      aux_sym__context_constraints_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524269] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23024), 1,
      anon_sym_RBRACK,
    STATE(16489), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524285] = 3,
    ACTIONS(23028), 1,
      sym_quasiquote_body,
    ACTIONS(23026), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524299] = 4,
    ACTIONS(2644), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524315] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23030), 1,
      anon_sym_RPAREN,
    STATE(16441), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524331] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23032), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524347] = 4,
    ACTIONS(11377), 1,
      anon_sym_RBRACE,
    ACTIONS(23034), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524363] = 2,
    ACTIONS(22373), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524375] = 3,
    ACTIONS(23038), 1,
      sym_quasiquote_body,
    ACTIONS(23036), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524389] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(23040), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524405] = 3,
    ACTIONS(23044), 1,
      sym_quasiquote_body,
    ACTIONS(23042), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524419] = 3,
    ACTIONS(19175), 1,
      anon_sym_in,
    ACTIONS(19173), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524433] = 3,
    ACTIONS(23048), 1,
      sym_quasiquote_body,
    ACTIONS(23046), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524447] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23050), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524463] = 3,
    ACTIONS(23054), 1,
      sym_quasiquote_body,
    ACTIONS(23052), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524477] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23056), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524493] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23058), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524509] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23060), 1,
      anon_sym_RBRACK,
    STATE(16448), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524525] = 2,
    ACTIONS(19398), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524537] = 3,
    ACTIONS(23064), 1,
      sym_quasiquote_body,
    ACTIONS(23062), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524551] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23066), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524567] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(23068), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524583] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23070), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524599] = 4,
    ACTIONS(993), 1,
      anon_sym_RBRACE,
    ACTIONS(23072), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524615] = 3,
    ACTIONS(23076), 1,
      sym_quasiquote_body,
    ACTIONS(23074), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524629] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23078), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524645] = 2,
    ACTIONS(18836), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524657] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23080), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524673] = 3,
    ACTIONS(23084), 1,
      sym_quasiquote_body,
    ACTIONS(23082), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524687] = 3,
    ACTIONS(23088), 1,
      sym_quasiquote_body,
    ACTIONS(23086), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524701] = 4,
    ACTIONS(20186), 1,
      anon_sym_RBRACE,
    ACTIONS(23090), 1,
      anon_sym_SEMI,
    STATE(16457), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524717] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23092), 1,
      anon_sym_RBRACE,
    STATE(16458), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524733] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23094), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524749] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23096), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524765] = 3,
    ACTIONS(23100), 1,
      sym_quasiquote_body,
    ACTIONS(23098), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524779] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23102), 1,
      anon_sym_RBRACK,
    STATE(16462), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524795] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23104), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524811] = 3,
    ACTIONS(23108), 1,
      sym_quasiquote_body,
    ACTIONS(23106), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524825] = 2,
    ACTIONS(20923), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524837] = 4,
    ACTIONS(20182), 1,
      anon_sym_RBRACE,
    ACTIONS(23110), 1,
      anon_sym_SEMI,
    STATE(16414), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524853] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23112), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524869] = 3,
    ACTIONS(23116), 1,
      sym_quasiquote_body,
    ACTIONS(23114), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524883] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23118), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524899] = 4,
    ACTIONS(20611), 1,
      anon_sym_RBRACE,
    ACTIONS(23120), 1,
      anon_sym_SEMI,
    STATE(16491), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524915] = 3,
    ACTIONS(23124), 1,
      sym_quasiquote_body,
    ACTIONS(23122), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524929] = 4,
    ACTIONS(20178), 1,
      anon_sym_RBRACE,
    ACTIONS(23126), 1,
      anon_sym_SEMI,
    STATE(16466), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524945] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23128), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524961] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23130), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524977] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23132), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [524993] = 4,
    ACTIONS(1039), 1,
      anon_sym_RBRACE,
    ACTIONS(23134), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525009] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23136), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525025] = 3,
    ACTIONS(23140), 1,
      sym_quasiquote_body,
    ACTIONS(23138), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525039] = 2,
    ACTIONS(22259), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525051] = 3,
    ACTIONS(23144), 1,
      sym_quasiquote_body,
    ACTIONS(23142), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525065] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23146), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525081] = 3,
    ACTIONS(23150), 1,
      sym_quasiquote_body,
    ACTIONS(23148), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525095] = 4,
    ACTIONS(1135), 1,
      anon_sym_RBRACE,
    ACTIONS(23152), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525111] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23154), 1,
      anon_sym_RBRACK,
    STATE(16424), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525127] = 4,
    ACTIONS(11360), 1,
      anon_sym_RBRACE,
    ACTIONS(23156), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525143] = 2,
    ACTIONS(18927), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525155] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23158), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525171] = 3,
    ACTIONS(23162), 1,
      sym_quasiquote_body,
    ACTIONS(23160), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525185] = 3,
    ACTIONS(23166), 1,
      sym_quasiquote_body,
    ACTIONS(23164), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525199] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23168), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525215] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23170), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525231] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(23172), 1,
      anon_sym_RBRACE,
    STATE(16429), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525247] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23174), 1,
      anon_sym_RBRACE,
    STATE(16430), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525263] = 4,
    ACTIONS(20164), 1,
      anon_sym_RBRACE,
    ACTIONS(23176), 1,
      anon_sym_SEMI,
    STATE(16431), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525279] = 3,
    ACTIONS(23180), 1,
      sym_quasiquote_body,
    ACTIONS(23178), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525293] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(23182), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525309] = 3,
    ACTIONS(23186), 1,
      sym_quasiquote_body,
    ACTIONS(23184), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525323] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23188), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525339] = 3,
    ACTIONS(23192), 1,
      sym_quasiquote_body,
    ACTIONS(23190), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525353] = 2,
    ACTIONS(22231), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525365] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23194), 1,
      anon_sym_RPAREN,
    STATE(16406), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525381] = 4,
    ACTIONS(2913), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525397] = 3,
    ACTIONS(23198), 1,
      sym_quasiquote_body,
    ACTIONS(23196), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525411] = 3,
    ACTIONS(23202), 1,
      sym_quasiquote_body,
    ACTIONS(23200), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525425] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23204), 1,
      anon_sym_RBRACK,
    STATE(16456), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525441] = 2,
    ACTIONS(20372), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525453] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23206), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525469] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23208), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525485] = 3,
    ACTIONS(23212), 1,
      sym_quasiquote_body,
    ACTIONS(23210), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525499] = 4,
    ACTIONS(11409), 1,
      anon_sym_RBRACE,
    ACTIONS(23214), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525515] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23216), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525531] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23218), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525547] = 3,
    ACTIONS(23222), 1,
      sym_quasiquote_body,
    ACTIONS(23220), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525561] = 3,
    ACTIONS(23226), 1,
      sym_quasiquote_body,
    ACTIONS(23224), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525575] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23228), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525591] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(23230), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525607] = 2,
    ACTIONS(20370), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525619] = 4,
    ACTIONS(21009), 1,
      sym__unboxed_close,
    ACTIONS(23232), 1,
      sym_comma,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525635] = 3,
    ACTIONS(23237), 1,
      sym_quasiquote_body,
    ACTIONS(23235), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525649] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23239), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525665] = 3,
    ACTIONS(23243), 1,
      sym_quasiquote_body,
    ACTIONS(23241), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525679] = 3,
    ACTIONS(23247), 1,
      sym_quasiquote_body,
    ACTIONS(23245), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525693] = 3,
    ACTIONS(23251), 1,
      sym_quasiquote_body,
    ACTIONS(23249), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525707] = 3,
    ACTIONS(23255), 1,
      sym_quasiquote_body,
    ACTIONS(23253), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525721] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23257), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525737] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23259), 1,
      anon_sym_RPAREN,
    STATE(16536), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525753] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23261), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525769] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23263), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525785] = 3,
    ACTIONS(23267), 1,
      sym_quasiquote_body,
    ACTIONS(23265), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525799] = 2,
    ACTIONS(20989), 3,
      sym_comma,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525811] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(23269), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525827] = 3,
    ACTIONS(23273), 1,
      sym_quasiquote_body,
    ACTIONS(23271), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525841] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23275), 1,
      anon_sym_RPAREN,
    STATE(16508), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525857] = 3,
    ACTIONS(23279), 1,
      sym_quasiquote_body,
    ACTIONS(23277), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525871] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(23281), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525887] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23283), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525903] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23285), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525919] = 3,
    ACTIONS(23289), 1,
      sym_quasiquote_body,
    ACTIONS(23287), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525933] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23291), 1,
      anon_sym_RBRACK,
    STATE(16543), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525949] = 3,
    ACTIONS(23295), 1,
      sym_quasiquote_body,
    ACTIONS(23293), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525963] = 3,
    ACTIONS(23299), 1,
      sym_quasiquote_body,
    ACTIONS(23297), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525977] = 4,
    ACTIONS(2933), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [525993] = 2,
    ACTIONS(20678), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526005] = 3,
    ACTIONS(23303), 1,
      sym_quasiquote_body,
    ACTIONS(23301), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526019] = 3,
    ACTIONS(23307), 1,
      sym_quasiquote_body,
    ACTIONS(23305), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526033] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23309), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526049] = 3,
    ACTIONS(23313), 1,
      sym_quasiquote_body,
    ACTIONS(23311), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526063] = 3,
    ACTIONS(23317), 1,
      sym_quasiquote_body,
    ACTIONS(23315), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526077] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23319), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526093] = 3,
    ACTIONS(23323), 1,
      sym_quasiquote_body,
    ACTIONS(23321), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526107] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23325), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526123] = 4,
    ACTIONS(20504), 1,
      anon_sym_RBRACE,
    ACTIONS(23327), 1,
      anon_sym_SEMI,
    STATE(16552), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526139] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23329), 1,
      anon_sym_RBRACE,
    STATE(16553), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526155] = 3,
    ACTIONS(23333), 1,
      sym_quasiquote_body,
    ACTIONS(23331), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526169] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23335), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526185] = 3,
    ACTIONS(23339), 1,
      sym_quasiquote_body,
    ACTIONS(23337), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526199] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23341), 1,
      anon_sym_RBRACK,
    STATE(16557), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526215] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23343), 1,
      anon_sym_RPAREN,
    STATE(16589), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526231] = 3,
    ACTIONS(23347), 1,
      sym_quasiquote_body,
    ACTIONS(23345), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526245] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23349), 1,
      anon_sym_RBRACK,
    STATE(16596), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526261] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23351), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526277] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23353), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526293] = 3,
    ACTIONS(23357), 1,
      sym_quasiquote_body,
    ACTIONS(23355), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526307] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23359), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526323] = 3,
    ACTIONS(23363), 1,
      sym_quasiquote_body,
    ACTIONS(23361), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526337] = 3,
    STATE(1545), 1,
      sym__arrow,
    ACTIONS(23365), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526351] = 4,
    ACTIONS(20118), 1,
      anon_sym_RBRACE,
    ACTIONS(23367), 1,
      anon_sym_SEMI,
    STATE(16561), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526367] = 3,
    ACTIONS(23371), 1,
      sym_quasiquote_body,
    ACTIONS(23369), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526381] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23373), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526397] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23375), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526413] = 4,
    ACTIONS(995), 1,
      anon_sym_RBRACE,
    ACTIONS(23377), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526429] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23379), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526445] = 3,
    ACTIONS(23383), 1,
      sym_quasiquote_body,
    ACTIONS(23381), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526459] = 3,
    ACTIONS(23387), 1,
      sym_quasiquote_body,
    ACTIONS(23385), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526473] = 3,
    ACTIONS(23391), 1,
      sym_quasiquote_body,
    ACTIONS(23389), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526487] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23393), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526503] = 4,
    ACTIONS(2779), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526519] = 3,
    ACTIONS(23397), 1,
      sym_quasiquote_body,
    ACTIONS(23395), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526533] = 3,
    ACTIONS(23401), 1,
      sym_quasiquote_body,
    ACTIONS(23399), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526547] = 4,
    ACTIONS(11370), 1,
      anon_sym_RBRACE,
    ACTIONS(23403), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526563] = 3,
    ACTIONS(23407), 1,
      sym_quasiquote_body,
    ACTIONS(23405), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526577] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23409), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526593] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23411), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526609] = 3,
    ACTIONS(23415), 1,
      sym_quasiquote_body,
    ACTIONS(23413), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526623] = 3,
    ACTIONS(23419), 1,
      sym_quasiquote_body,
    ACTIONS(23417), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526637] = 3,
    ACTIONS(23423), 1,
      sym_quasiquote_body,
    ACTIONS(23421), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526651] = 3,
    ACTIONS(23427), 1,
      sym_quasiquote_body,
    ACTIONS(23425), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526665] = 4,
    ACTIONS(2777), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526681] = 3,
    ACTIONS(23431), 1,
      sym_quasiquote_body,
    ACTIONS(23429), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526695] = 2,
    ACTIONS(20314), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_deriving,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526707] = 2,
    ACTIONS(20591), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526719] = 3,
    ACTIONS(23435), 1,
      sym_quasiquote_body,
    ACTIONS(23433), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526733] = 3,
    ACTIONS(23439), 1,
      sym_quasiquote_body,
    ACTIONS(23437), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526747] = 3,
    ACTIONS(23443), 1,
      sym_quasiquote_body,
    ACTIONS(23441), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526761] = 3,
    ACTIONS(23447), 1,
      sym_quasiquote_body,
    ACTIONS(23445), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526775] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23449), 1,
      anon_sym_RBRACK,
    STATE(16493), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526791] = 3,
    ACTIONS(23453), 1,
      sym_quasiquote_body,
    ACTIONS(23451), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526805] = 4,
    ACTIONS(21956), 1,
      anon_sym_RPAREN,
    ACTIONS(23455), 1,
      sym_comma,
    STATE(16579), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526821] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23458), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526837] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(23460), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526853] = 3,
    ACTIONS(23464), 1,
      sym_quasiquote_body,
    ACTIONS(23462), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526867] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23466), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526883] = 3,
    ACTIONS(23470), 1,
      sym_quasiquote_body,
    ACTIONS(23468), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526897] = 3,
    ACTIONS(23474), 1,
      sym_quasiquote_body,
    ACTIONS(23472), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526911] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23476), 1,
      anon_sym_RPAREN,
    STATE(16737), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526927] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23478), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526943] = 3,
    ACTIONS(23482), 1,
      sym_quasiquote_body,
    ACTIONS(23480), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526957] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23484), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526973] = 3,
    ACTIONS(23488), 1,
      sym_quasiquote_body,
    ACTIONS(23486), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [526987] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23490), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527003] = 2,
    ACTIONS(21893), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527015] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(23492), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527031] = 3,
    ACTIONS(23496), 1,
      sym_quasiquote_body,
    ACTIONS(23494), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527045] = 3,
    ACTIONS(23500), 1,
      sym_quasiquote_body,
    ACTIONS(23498), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527059] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23502), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527075] = 4,
    ACTIONS(2828), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527091] = 3,
    ACTIONS(23506), 1,
      sym_quasiquote_body,
    ACTIONS(23504), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527105] = 3,
    ACTIONS(23510), 1,
      sym_quasiquote_body,
    ACTIONS(23508), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527119] = 3,
    ACTIONS(23514), 1,
      sym_quasiquote_body,
    ACTIONS(23512), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527133] = 4,
    ACTIONS(2702), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527149] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23516), 1,
      anon_sym_RPAREN,
    STATE(16631), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527165] = 3,
    ACTIONS(23520), 1,
      sym_quasiquote_body,
    ACTIONS(23518), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527179] = 3,
    ACTIONS(23524), 1,
      sym_quasiquote_body,
    ACTIONS(23522), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527193] = 2,
    ACTIONS(6264), 3,
      sym__dot,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527205] = 2,
    ACTIONS(19510), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527217] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(23526), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527233] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23528), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527249] = 3,
    ACTIONS(23532), 1,
      sym_quasiquote_body,
    ACTIONS(23530), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527263] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23534), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527279] = 3,
    ACTIONS(23538), 1,
      sym_quasiquote_body,
    ACTIONS(23536), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527293] = 3,
    ACTIONS(23542), 1,
      sym_quasiquote_body,
    ACTIONS(23540), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527307] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23544), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527323] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23546), 1,
      anon_sym_RBRACK,
    STATE(16685), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527339] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23548), 1,
      anon_sym_RBRACK,
    STATE(16638), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527355] = 2,
    ACTIONS(15425), 3,
      sym__varid,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527367] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23550), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527383] = 3,
    ACTIONS(23554), 1,
      sym_quasiquote_body,
    ACTIONS(23552), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527397] = 2,
    ACTIONS(21833), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527409] = 3,
    ACTIONS(23558), 1,
      sym_quasiquote_body,
    ACTIONS(23556), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527423] = 2,
    ACTIONS(19024), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527435] = 3,
    ACTIONS(23562), 1,
      sym_quasiquote_body,
    ACTIONS(23560), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527449] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23564), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527465] = 3,
    ACTIONS(23568), 1,
      sym_quasiquote_body,
    ACTIONS(23566), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527479] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23570), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527495] = 4,
    ACTIONS(11379), 1,
      anon_sym_RBRACE,
    ACTIONS(23572), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527511] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23574), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527527] = 4,
    ACTIONS(20021), 1,
      anon_sym_RBRACE,
    ACTIONS(23576), 1,
      anon_sym_SEMI,
    STATE(16647), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527543] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23578), 1,
      anon_sym_RBRACE,
    STATE(16648), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527559] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(23580), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527575] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23582), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527591] = 3,
    ACTIONS(23586), 1,
      sym_quasiquote_body,
    ACTIONS(23584), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527605] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23588), 1,
      anon_sym_RBRACK,
    STATE(16652), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527621] = 3,
    ACTIONS(23592), 1,
      sym_quasiquote_body,
    ACTIONS(23590), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527635] = 4,
    ACTIONS(20881), 1,
      anon_sym_RBRACE,
    ACTIONS(23594), 1,
      anon_sym_SEMI,
    STATE(16706), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527651] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23596), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527667] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23598), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527683] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23600), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527699] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23602), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527715] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23604), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527731] = 2,
    ACTIONS(20500), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527743] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23606), 1,
      anon_sym_RBRACE,
    STATE(16707), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527759] = 4,
    ACTIONS(20009), 1,
      anon_sym_RBRACE,
    ACTIONS(23608), 1,
      anon_sym_SEMI,
    STATE(16656), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527775] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23610), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527791] = 4,
    ACTIONS(1113), 1,
      anon_sym_RBRACE,
    ACTIONS(23612), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527807] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23614), 1,
      anon_sym_RBRACK,
    STATE(16639), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527823] = 4,
    ACTIONS(955), 1,
      anon_sym_RBRACE,
    ACTIONS(23616), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527839] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23618), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527855] = 4,
    ACTIONS(20001), 1,
      anon_sym_RBRACE,
    ACTIONS(23620), 1,
      anon_sym_SEMI,
    STATE(16626), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527871] = 2,
    ACTIONS(21773), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527883] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23622), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527899] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23624), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527915] = 2,
    ACTIONS(21755), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527927] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23626), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527943] = 2,
    ACTIONS(21755), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527955] = 4,
    ACTIONS(11383), 1,
      anon_sym_RBRACE,
    ACTIONS(23628), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527971] = 4,
    ACTIONS(2832), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [527987] = 3,
    ACTIONS(23632), 1,
      sym_quasiquote_body,
    ACTIONS(23630), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528001] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(23634), 1,
      anon_sym_RBRACE,
    STATE(16709), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528017] = 3,
    ACTIONS(23638), 1,
      sym_quasiquote_body,
    ACTIONS(23636), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528031] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23640), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528047] = 2,
    ACTIONS(18117), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528059] = 2,
    ACTIONS(16012), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528071] = 3,
    ACTIONS(23644), 1,
      sym_quasiquote_body,
    ACTIONS(23642), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528085] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23646), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528101] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23648), 1,
      anon_sym_RBRACK,
    STATE(16636), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528117] = 3,
    ACTIONS(18074), 1,
      sym__dot,
    ACTIONS(18372), 2,
      sym_where,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528131] = 3,
    ACTIONS(23652), 1,
      sym_quasiquote_body,
    ACTIONS(23650), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528145] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23654), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528161] = 3,
    ACTIONS(23658), 1,
      sym_quasiquote_body,
    ACTIONS(23656), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528175] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23660), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528191] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23662), 1,
      anon_sym_RBRACK,
    STATE(16712), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528207] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23664), 1,
      anon_sym_RBRACK,
    STATE(16669), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528223] = 2,
    ACTIONS(21709), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528235] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(23666), 1,
      anon_sym_RBRACE,
    STATE(16581), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528251] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23668), 1,
      anon_sym_RBRACE,
    STATE(16644), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528267] = 4,
    ACTIONS(19991), 1,
      anon_sym_RBRACE,
    ACTIONS(23670), 1,
      anon_sym_SEMI,
    STATE(16645), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528283] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23672), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528299] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(23674), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528315] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23676), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528331] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23678), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528347] = 3,
    ACTIONS(23682), 1,
      sym_quasiquote_body,
    ACTIONS(23680), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528361] = 2,
    ACTIONS(18715), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528373] = 4,
    ACTIONS(17080), 1,
      anon_sym_RPAREN,
    ACTIONS(23684), 1,
      sym_comma,
    STATE(17545), 1,
      aux_sym_exports_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528389] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23686), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528405] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23688), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528421] = 2,
    ACTIONS(15964), 3,
      sym__varid,
      anon_sym_LPAREN,
      sym__conid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528433] = 2,
    ACTIONS(20481), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528445] = 3,
    ACTIONS(23692), 1,
      sym_quasiquote_body,
    ACTIONS(23690), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528459] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23694), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528475] = 3,
    ACTIONS(23698), 1,
      sym_quasiquote_body,
    ACTIONS(23696), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528489] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23700), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528505] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23702), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528521] = 4,
    ACTIONS(20901), 1,
      anon_sym_RBRACE,
    ACTIONS(23704), 1,
      anon_sym_SEMI,
    STATE(16717), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528537] = 3,
    ACTIONS(23708), 1,
      sym_quasiquote_body,
    ACTIONS(23706), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528551] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23710), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528567] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23712), 1,
      anon_sym_RPAREN,
    STATE(16726), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528583] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23714), 1,
      anon_sym_RBRACK,
    STATE(16661), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528599] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23716), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528615] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23718), 1,
      anon_sym_RBRACK,
    STATE(16693), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528631] = 2,
    ACTIONS(21597), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528643] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(23720), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528659] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23722), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528675] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23724), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528691] = 3,
    ACTIONS(23728), 1,
      sym_quasiquote_body,
    ACTIONS(23726), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528705] = 4,
    ACTIONS(1041), 1,
      anon_sym_RBRACE,
    ACTIONS(23730), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528721] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23732), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528737] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23734), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528753] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(23736), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528769] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23738), 1,
      anon_sym_RBRACK,
    STATE(16733), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528785] = 3,
    ACTIONS(23742), 1,
      sym_quasiquote_body,
    ACTIONS(23740), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528799] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23744), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528815] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23746), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528831] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(23748), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528847] = 3,
    ACTIONS(23752), 1,
      sym_quasiquote_body,
    ACTIONS(23750), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528861] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23754), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528877] = 4,
    ACTIONS(11366), 1,
      anon_sym_RBRACE,
    ACTIONS(23756), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528893] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23758), 1,
      anon_sym_RPAREN,
    STATE(16671), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528909] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23760), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528925] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23762), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528941] = 2,
    ACTIONS(17712), 3,
      sym__consym,
      sym__tyconsym,
      sym__conid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528953] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23764), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528969] = 4,
    ACTIONS(19959), 1,
      anon_sym_RBRACE,
    ACTIONS(23766), 1,
      anon_sym_SEMI,
    STATE(16742), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [528985] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23768), 1,
      anon_sym_RBRACE,
    STATE(16743), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529001] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23770), 1,
      anon_sym_RBRACK,
    STATE(16722), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529017] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23772), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529033] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23774), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529049] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23776), 1,
      anon_sym_RBRACK,
    STATE(16747), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529065] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23778), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529081] = 3,
    ACTIONS(23782), 1,
      sym_quasiquote_body,
    ACTIONS(23780), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529095] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23784), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529111] = 4,
    ACTIONS(15176), 1,
      anon_sym_RPAREN,
    ACTIONS(23786), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529127] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23789), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529143] = 4,
    ACTIONS(20909), 1,
      anon_sym_RBRACE,
    ACTIONS(23791), 1,
      anon_sym_SEMI,
    STATE(17613), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529159] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23793), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529175] = 4,
    ACTIONS(16879), 1,
      sym__varid,
    STATE(14430), 1,
      sym_variable,
    STATE(20625), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529191] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23795), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529207] = 4,
    ACTIONS(19953), 1,
      anon_sym_RBRACE,
    ACTIONS(23797), 1,
      anon_sym_SEMI,
    STATE(16751), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529223] = 3,
    ACTIONS(23801), 1,
      sym_quasiquote_body,
    ACTIONS(23799), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529237] = 3,
    ACTIONS(23805), 1,
      sym_quasiquote_body,
    ACTIONS(23803), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529251] = 3,
    ACTIONS(23809), 1,
      sym_quasiquote_body,
    ACTIONS(23807), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529265] = 4,
    ACTIONS(991), 1,
      anon_sym_RBRACE,
    ACTIONS(23811), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529281] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23813), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529297] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23815), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529313] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23817), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529329] = 2,
    ACTIONS(16071), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529341] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23819), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529357] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23821), 1,
      anon_sym_RBRACK,
    STATE(16745), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529373] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23823), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529389] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23825), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529405] = 4,
    ACTIONS(11458), 1,
      anon_sym_RBRACE,
    ACTIONS(23827), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529421] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23829), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529437] = 3,
    ACTIONS(23833), 1,
      sym_quasiquote_body,
    ACTIONS(23831), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529451] = 2,
    ACTIONS(18739), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529463] = 3,
    ACTIONS(23837), 1,
      sym_quasiquote_body,
    ACTIONS(23835), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529477] = 2,
    ACTIONS(20500), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529489] = 3,
    ACTIONS(23841), 1,
      sym_quasiquote_body,
    ACTIONS(23839), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529503] = 3,
    ACTIONS(23845), 1,
      sym_quasiquote_body,
    ACTIONS(23843), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529517] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23847), 1,
      anon_sym_RBRACK,
    STATE(16713), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529533] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23849), 1,
      anon_sym_RPAREN,
    STATE(16716), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529549] = 3,
    ACTIONS(23853), 1,
      sym_quasiquote_body,
    ACTIONS(23851), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529563] = 2,
    ACTIONS(18715), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529575] = 3,
    ACTIONS(23857), 1,
      sym_quasiquote_body,
    ACTIONS(23855), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529589] = 3,
    ACTIONS(23861), 1,
      sym_quasiquote_body,
    ACTIONS(23859), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529603] = 3,
    ACTIONS(23865), 1,
      sym_quasiquote_body,
    ACTIONS(23863), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529617] = 2,
    ACTIONS(19961), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529629] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23867), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529645] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23869), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529661] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23871), 1,
      anon_sym_RBRACK,
    STATE(16768), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529677] = 3,
    ACTIONS(23875), 1,
      sym_quasiquote_body,
    ACTIONS(23873), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529691] = 2,
    ACTIONS(20591), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529703] = 2,
    ACTIONS(20678), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529715] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23877), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529731] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23879), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529747] = 3,
    ACTIONS(23883), 1,
      sym_quasiquote_body,
    ACTIONS(23881), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529761] = 2,
    ACTIONS(20481), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529773] = 4,
    ACTIONS(16879), 1,
      sym__varid,
    STATE(14480), 1,
      sym_variable,
    STATE(17635), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529789] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23885), 1,
      anon_sym_RBRACK,
    STATE(16834), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529805] = 3,
    STATE(1488), 1,
      sym__arrow,
    ACTIONS(23887), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529819] = 3,
    ACTIONS(23891), 1,
      sym_quasiquote_body,
    ACTIONS(23889), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529833] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23893), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529849] = 3,
    ACTIONS(23897), 1,
      sym_quasiquote_body,
    ACTIONS(23895), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529863] = 4,
    ACTIONS(11389), 1,
      anon_sym_RBRACE,
    ACTIONS(23899), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529879] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23901), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529895] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23903), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529911] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23905), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529927] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23907), 1,
      anon_sym_RBRACK,
    STATE(16785), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529943] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23909), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529959] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(23911), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529975] = 3,
    ACTIONS(23915), 1,
      sym_quasiquote_body,
    ACTIONS(23913), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [529989] = 4,
    ACTIONS(2826), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530005] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23917), 1,
      anon_sym_RPAREN,
    STATE(16821), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530021] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23919), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530037] = 3,
    ACTIONS(23923), 1,
      sym_quasiquote_body,
    ACTIONS(23921), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530051] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(23925), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530067] = 2,
    ACTIONS(21345), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530079] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(23927), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530095] = 2,
    ACTIONS(22653), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530107] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23929), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530123] = 3,
    ACTIONS(23933), 1,
      sym_quasiquote_body,
    ACTIONS(23931), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530137] = 3,
    ACTIONS(23937), 1,
      sym_quasiquote_body,
    ACTIONS(23935), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530151] = 3,
    ACTIONS(23941), 1,
      sym_quasiquote_body,
    ACTIONS(23939), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530165] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23943), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530181] = 4,
    ACTIONS(1003), 1,
      anon_sym_RBRACE,
    ACTIONS(23945), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530197] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23947), 1,
      anon_sym_RBRACK,
    STATE(16828), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530213] = 3,
    ACTIONS(18074), 1,
      sym__dot,
    ACTIONS(18072), 2,
      sym_where,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530227] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23949), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530243] = 2,
    ACTIONS(20923), 3,
      sym_where,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530255] = 2,
    ACTIONS(21277), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530267] = 2,
    ACTIONS(21485), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530279] = 2,
    ACTIONS(21267), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530291] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23951), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530307] = 4,
    ACTIONS(21373), 1,
      sym_comma,
    ACTIONS(23953), 1,
      anon_sym_RPAREN,
    STATE(17680), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530323] = 4,
    ACTIONS(20043), 1,
      anon_sym_RBRACE,
    ACTIONS(23955), 1,
      anon_sym_SEMI,
    STATE(16783), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530339] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(23957), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530355] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23959), 1,
      anon_sym_RBRACK,
    STATE(16812), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530371] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23961), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530387] = 4,
    ACTIONS(20047), 1,
      anon_sym_RBRACE,
    ACTIONS(23963), 1,
      anon_sym_SEMI,
    STATE(16837), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530403] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(23965), 1,
      anon_sym_RBRACE,
    STATE(16838), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530419] = 4,
    ACTIONS(2708), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530435] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23967), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530451] = 3,
    ACTIONS(23971), 1,
      sym_quasiquote_body,
    ACTIONS(23969), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530465] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(23973), 1,
      anon_sym_RBRACK,
    STATE(16842), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530481] = 4,
    ACTIONS(2818), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530497] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(23975), 1,
      anon_sym_RPAREN,
    STATE(16907), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530513] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23977), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530529] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23979), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530545] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23981), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530561] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(23983), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530577] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(23985), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530593] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(23987), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530609] = 3,
    ACTIONS(23991), 1,
      sym_quasiquote_body,
    ACTIONS(23989), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530623] = 4,
    ACTIONS(20059), 1,
      anon_sym_RBRACE,
    ACTIONS(23993), 1,
      anon_sym_SEMI,
    STATE(16846), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530639] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(23995), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530655] = 3,
    ACTIONS(23999), 1,
      sym_quasiquote_body,
    ACTIONS(23997), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530669] = 2,
    ACTIONS(15948), 3,
      sym__varid,
      anon_sym_LPAREN,
      sym__conid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530681] = 4,
    ACTIONS(1089), 1,
      anon_sym_RBRACE,
    ACTIONS(24001), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530697] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24003), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530713] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24005), 1,
      anon_sym_RBRACK,
    STATE(16793), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530729] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24007), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530745] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24009), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530761] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24011), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530777] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24013), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530793] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(24015), 1,
      anon_sym_RBRACE,
    STATE(16795), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530809] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24017), 1,
      anon_sym_RBRACE,
    STATE(16799), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530825] = 4,
    ACTIONS(11548), 1,
      anon_sym_RBRACE,
    ACTIONS(24019), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530841] = 4,
    ACTIONS(20088), 1,
      anon_sym_RBRACE,
    ACTIONS(24021), 1,
      anon_sym_SEMI,
    STATE(16804), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530857] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24023), 1,
      anon_sym_RBRACK,
    STATE(16843), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530873] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24025), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530889] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24027), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530905] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(24029), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530921] = 2,
    ACTIONS(24031), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530933] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24033), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530949] = 3,
    ACTIONS(24037), 1,
      sym_quasiquote_body,
    ACTIONS(24035), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530963] = 2,
    ACTIONS(22565), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530975] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24039), 1,
      anon_sym_RBRACK,
    STATE(16831), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [530991] = 2,
    ACTIONS(16018), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531003] = 3,
    ACTIONS(24043), 1,
      sym_quasiquote_body,
    ACTIONS(24041), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531017] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24045), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531033] = 3,
    ACTIONS(24049), 1,
      sym_quasiquote_body,
    ACTIONS(24047), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531047] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24051), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531063] = 4,
    ACTIONS(24053), 1,
      anon_sym_RPAREN,
    ACTIONS(24055), 1,
      sym_comma,
    STATE(16862), 1,
      aux_sym_decl_default_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531079] = 3,
    ACTIONS(24060), 1,
      sym_quasiquote_body,
    ACTIONS(24058), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531093] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24062), 1,
      anon_sym_RBRACK,
    STATE(16920), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531109] = 3,
    ACTIONS(24066), 1,
      sym_quasiquote_body,
    ACTIONS(24064), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531123] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24068), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531139] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(24070), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531155] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24072), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531171] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24074), 1,
      anon_sym_RPAREN,
    STATE(16841), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531187] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24076), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531203] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24078), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531219] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24080), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531235] = 3,
    ACTIONS(24084), 1,
      sym_quasiquote_body,
    ACTIONS(24082), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531249] = 2,
    ACTIONS(22559), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531261] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24086), 1,
      anon_sym_RBRACK,
    STATE(16872), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531277] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24088), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531293] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24090), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531309] = 4,
    ACTIONS(2706), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531325] = 3,
    ACTIONS(24094), 1,
      sym_quasiquote_body,
    ACTIONS(24092), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531339] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24096), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531355] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(24098), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531371] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24100), 1,
      anon_sym_RPAREN,
    STATE(16827), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531387] = 4,
    ACTIONS(21024), 1,
      anon_sym_RBRACE,
    ACTIONS(24102), 1,
      anon_sym_SEMI,
    STATE(17019), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531403] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24104), 1,
      anon_sym_RBRACE,
    STATE(16961), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531419] = 3,
    ACTIONS(24108), 1,
      sym_quasiquote_body,
    ACTIONS(24106), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531433] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24110), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531449] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24112), 1,
      anon_sym_RPAREN,
    STATE(16916), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531465] = 3,
    ACTIONS(24116), 1,
      sym_quasiquote_body,
    ACTIONS(24114), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531479] = 2,
    ACTIONS(20051), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531491] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(24118), 1,
      anon_sym_RBRACE,
    STATE(16975), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531507] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24120), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531523] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(24122), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531539] = 3,
    ACTIONS(24126), 1,
      sym_quasiquote_body,
    ACTIONS(24124), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531553] = 2,
    ACTIONS(20760), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531565] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24128), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531581] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24130), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531597] = 2,
    ACTIONS(24132), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531609] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24134), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531625] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24136), 1,
      anon_sym_RBRACK,
    STATE(16896), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531641] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24138), 1,
      anon_sym_RBRACK,
    STATE(16923), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531657] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24140), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531673] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24142), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531689] = 3,
    ACTIONS(24146), 1,
      sym_quasiquote_body,
    ACTIONS(24144), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531703] = 4,
    ACTIONS(21007), 1,
      anon_sym_RBRACE,
    ACTIONS(24148), 1,
      anon_sym_SEMI,
    STATE(17740), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531719] = 2,
    ACTIONS(20767), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531731] = 2,
    ACTIONS(18905), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531743] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24150), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531759] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24152), 1,
      anon_sym_RBRACK,
    STATE(16866), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531775] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24154), 1,
      anon_sym_RPAREN,
    STATE(16868), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531791] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24156), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531807] = 3,
    ACTIONS(24160), 1,
      sym_quasiquote_body,
    ACTIONS(24158), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531821] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24162), 1,
      anon_sym_RBRACK,
    STATE(16976), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531837] = 4,
    ACTIONS(20244), 1,
      anon_sym_RBRACE,
    ACTIONS(24164), 1,
      anon_sym_SEMI,
    STATE(16932), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531853] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24166), 1,
      anon_sym_RBRACE,
    STATE(16933), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531869] = 3,
    ACTIONS(24170), 1,
      sym_quasiquote_body,
    ACTIONS(24168), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531883] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24172), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531899] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24174), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531915] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24176), 1,
      anon_sym_RBRACK,
    STATE(16937), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531931] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24178), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531947] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24180), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531963] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24182), 1,
      anon_sym_RBRACK,
    STATE(16919), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531979] = 3,
    ACTIONS(24186), 1,
      sym_quasiquote_body,
    ACTIONS(24184), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [531993] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24188), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532009] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24190), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532025] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24192), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532041] = 4,
    ACTIONS(2722), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532057] = 3,
    ACTIONS(24196), 1,
      sym_quasiquote_body,
    ACTIONS(24194), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532071] = 4,
    ACTIONS(20262), 1,
      anon_sym_RBRACE,
    ACTIONS(24198), 1,
      anon_sym_SEMI,
    STATE(16941), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532087] = 2,
    ACTIONS(20804), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532099] = 3,
    ACTIONS(24202), 1,
      sym_quasiquote_body,
    ACTIONS(24200), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532113] = 2,
    ACTIONS(18968), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532125] = 4,
    ACTIONS(1027), 1,
      anon_sym_RBRACE,
    ACTIONS(24204), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532141] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24206), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532157] = 2,
    ACTIONS(19220), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532169] = 2,
    ACTIONS(24208), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532181] = 2,
    ACTIONS(24210), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532193] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24212), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532209] = 2,
    ACTIONS(21691), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532221] = 2,
    ACTIONS(19173), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532233] = 2,
    ACTIONS(21691), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532245] = 4,
    ACTIONS(11681), 1,
      anon_sym_RBRACE,
    ACTIONS(24214), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532261] = 2,
    ACTIONS(21691), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532273] = 2,
    ACTIONS(21743), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532285] = 3,
    ACTIONS(18201), 1,
      sym__varid,
    STATE(12825), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532299] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24216), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532315] = 2,
    ACTIONS(21745), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532327] = 2,
    ACTIONS(21745), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532339] = 2,
    ACTIONS(22537), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532351] = 3,
    ACTIONS(24220), 1,
      sym_quasiquote_body,
    ACTIONS(24218), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532365] = 4,
    ACTIONS(20943), 1,
      anon_sym_RBRACE,
    ACTIONS(24222), 1,
      anon_sym_SEMI,
    STATE(16977), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532381] = 2,
    ACTIONS(21745), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532393] = 2,
    ACTIONS(20051), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532405] = 3,
    ACTIONS(24226), 1,
      sym_quasiquote_body,
    ACTIONS(24224), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532419] = 3,
    ACTIONS(24230), 1,
      sym_quasiquote_body,
    ACTIONS(24228), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532433] = 3,
    ACTIONS(24234), 1,
      sym_quasiquote_body,
    ACTIONS(24232), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532447] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24236), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532463] = 2,
    ACTIONS(24238), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532475] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24240), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532491] = 2,
    ACTIONS(24242), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532503] = 3,
    STATE(2817), 1,
      sym__arrow,
    ACTIONS(24244), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532517] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24246), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532533] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24248), 1,
      anon_sym_RBRACK,
    STATE(16958), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532549] = 4,
    ACTIONS(24250), 1,
      anon_sym_SEMI,
    ACTIONS(24253), 1,
      anon_sym_RBRACE,
    STATE(16963), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532565] = 4,
    ACTIONS(11675), 1,
      anon_sym_RBRACE,
    ACTIONS(24255), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532581] = 2,
    ACTIONS(21763), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532593] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24257), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532609] = 2,
    ACTIONS(21765), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532621] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24259), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532637] = 4,
    ACTIONS(2658), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532653] = 3,
    ACTIONS(24263), 1,
      sym_quasiquote_body,
    ACTIONS(24261), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532667] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24265), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532683] = 2,
    ACTIONS(21763), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532695] = 2,
    ACTIONS(24031), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532707] = 2,
    ACTIONS(21765), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532719] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(24267), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532735] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24269), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532751] = 4,
    ACTIONS(11595), 1,
      anon_sym_RBRACE,
    ACTIONS(24271), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532767] = 3,
    ACTIONS(24275), 1,
      sym_quasiquote_body,
    ACTIONS(24273), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532781] = 3,
    ACTIONS(24279), 1,
      sym_quasiquote_body,
    ACTIONS(24277), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532795] = 3,
    ACTIONS(24283), 1,
      sym_quasiquote_body,
    ACTIONS(24281), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532809] = 4,
    ACTIONS(2891), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532825] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24285), 1,
      anon_sym_RPAREN,
    STATE(17011), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532841] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(24287), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532857] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24289), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532873] = 2,
    ACTIONS(21765), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532885] = 2,
    ACTIONS(21797), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532897] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(24291), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532913] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24293), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532929] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24295), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532945] = 2,
    ACTIONS(22515), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532957] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24297), 1,
      anon_sym_RBRACK,
    STATE(16988), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532973] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24299), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [532989] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24301), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533005] = 2,
    ACTIONS(21797), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533017] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24303), 1,
      anon_sym_RBRACK,
    STATE(17018), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533033] = 2,
    ACTIONS(21797), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533045] = 4,
    ACTIONS(2781), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533061] = 4,
    ACTIONS(913), 1,
      anon_sym_RBRACE,
    ACTIONS(24305), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533077] = 2,
    ACTIONS(21797), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533089] = 2,
    ACTIONS(21797), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533101] = 2,
    ACTIONS(21835), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533113] = 3,
    ACTIONS(24309), 1,
      sym_quasiquote_body,
    ACTIONS(24307), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533127] = 2,
    ACTIONS(22507), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533139] = 4,
    ACTIONS(20340), 1,
      anon_sym_RBRACE,
    ACTIONS(24311), 1,
      anon_sym_SEMI,
    STATE(16964), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533155] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24313), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533171] = 2,
    ACTIONS(24315), 3,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533183] = 2,
    ACTIONS(24317), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533195] = 4,
    ACTIONS(20346), 1,
      anon_sym_RBRACE,
    ACTIONS(24319), 1,
      anon_sym_SEMI,
    STATE(17027), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533211] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24321), 1,
      anon_sym_RBRACE,
    STATE(17028), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533227] = 3,
    ACTIONS(24325), 1,
      sym_quasiquote_body,
    ACTIONS(24323), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533241] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24327), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533257] = 3,
    ACTIONS(24331), 1,
      sym_quasiquote_body,
    ACTIONS(24329), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533271] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24333), 1,
      anon_sym_RBRACK,
    STATE(17032), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533287] = 3,
    ACTIONS(24337), 1,
      sym_quasiquote_body,
    ACTIONS(24335), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533301] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24339), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533317] = 2,
    ACTIONS(24341), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533329] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24343), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533345] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24345), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533361] = 4,
    ACTIONS(971), 1,
      anon_sym_RBRACE,
    ACTIONS(24347), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533377] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24349), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533393] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24351), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533409] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24353), 1,
      anon_sym_RBRACK,
    STATE(17017), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533425] = 4,
    ACTIONS(20350), 1,
      anon_sym_RBRACE,
    ACTIONS(24355), 1,
      anon_sym_SEMI,
    STATE(17036), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533441] = 2,
    ACTIONS(24357), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533453] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24359), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533469] = 2,
    ACTIONS(21859), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533481] = 4,
    ACTIONS(1015), 1,
      anon_sym_RBRACE,
    ACTIONS(24361), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533497] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24363), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533513] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24365), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533529] = 2,
    ACTIONS(24367), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533541] = 2,
    ACTIONS(24369), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533553] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24371), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533569] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24373), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533585] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24375), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533601] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24377), 1,
      anon_sym_RBRACK,
    STATE(16968), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533617] = 4,
    ACTIONS(11709), 1,
      anon_sym_RBRACE,
    ACTIONS(24379), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533633] = 3,
    ACTIONS(24383), 1,
      sym_quasiquote_body,
    ACTIONS(24381), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533647] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24385), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533663] = 4,
    ACTIONS(20802), 1,
      anon_sym_RBRACE,
    ACTIONS(24387), 1,
      anon_sym_SEMI,
    STATE(15430), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533679] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24389), 1,
      anon_sym_RPAREN,
    STATE(17094), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533695] = 2,
    ACTIONS(24391), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533707] = 4,
    ACTIONS(24393), 1,
      anon_sym_RBRACE,
    ACTIONS(24395), 1,
      sym_comma,
    STATE(17042), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533723] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(24398), 1,
      anon_sym_RBRACE,
    STATE(16983), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533739] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24400), 1,
      anon_sym_RBRACE,
    STATE(16989), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533755] = 4,
    ACTIONS(20378), 1,
      anon_sym_RBRACE,
    ACTIONS(24402), 1,
      anon_sym_SEMI,
    STATE(16998), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533771] = 3,
    ACTIONS(24406), 1,
      sym_quasiquote_body,
    ACTIONS(24404), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533785] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24408), 1,
      anon_sym_RBRACK,
    STATE(17110), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533801] = 3,
    ACTIONS(24412), 1,
      sym_quasiquote_body,
    ACTIONS(24410), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533815] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(24414), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533831] = 3,
    ACTIONS(24418), 1,
      sym_quasiquote_body,
    ACTIONS(24416), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533845] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24420), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533861] = 3,
    ACTIONS(24424), 1,
      sym_quasiquote_body,
    ACTIONS(24422), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533875] = 3,
    STATE(1476), 1,
      sym__arrow,
    ACTIONS(24426), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533889] = 2,
    ACTIONS(20384), 3,
      sym_comma,
      anon_sym_4,
      anon_sym_COLON_COLON,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533901] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24428), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533917] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24430), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533933] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24432), 1,
      anon_sym_RBRACK,
    STATE(17029), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533949] = 2,
    ACTIONS(21901), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533961] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24434), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533977] = 2,
    ACTIONS(24436), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [533989] = 3,
    STATE(2822), 1,
      sym__arrow,
    ACTIONS(24438), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534003] = 2,
    ACTIONS(24440), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534015] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24442), 1,
      anon_sym_RBRACK,
    STATE(17056), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534031] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24444), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534047] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24446), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534063] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24448), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534079] = 4,
    ACTIONS(24450), 1,
      anon_sym_RPAREN,
    ACTIONS(24452), 1,
      sym_comma,
    STATE(17067), 1,
      aux_sym_export_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534095] = 3,
    ACTIONS(24457), 1,
      sym_quasiquote_body,
    ACTIONS(24455), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534109] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24459), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534125] = 4,
    ACTIONS(24461), 1,
      anon_sym_SEMI,
    ACTIONS(24464), 1,
      anon_sym_RBRACE,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534141] = 3,
    ACTIONS(24468), 1,
      sym_quasiquote_body,
    ACTIONS(24466), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534155] = 3,
    ACTIONS(24472), 1,
      sym_quasiquote_body,
    ACTIONS(24470), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534169] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24474), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534185] = 3,
    ACTIONS(24478), 1,
      sym_quasiquote_body,
    ACTIONS(24476), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534199] = 4,
    ACTIONS(2943), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534215] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24480), 1,
      anon_sym_RPAREN,
    STATE(17104), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534231] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24482), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534247] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24484), 1,
      anon_sym_RBRACK,
    STATE(17077), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534263] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24486), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534279] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24488), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534295] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(24490), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534311] = 3,
    ACTIONS(24494), 1,
      sym_quasiquote_body,
    ACTIONS(24492), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534325] = 3,
    ACTIONS(24498), 1,
      sym_quasiquote_body,
    ACTIONS(24496), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534339] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24500), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534355] = 3,
    ACTIONS(24504), 1,
      sym_quasiquote_body,
    ACTIONS(24502), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534369] = 3,
    ACTIONS(24508), 1,
      sym_quasiquote_body,
    ACTIONS(24506), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534383] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24510), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534399] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24512), 1,
      anon_sym_RBRACK,
    STATE(17109), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534415] = 2,
    ACTIONS(21921), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534427] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24514), 1,
      anon_sym_RPAREN,
    STATE(17190), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534443] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24516), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534459] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24518), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534475] = 4,
    ACTIONS(24520), 1,
      anon_sym_RPAREN,
    ACTIONS(24522), 1,
      sym_comma,
    STATE(17093), 1,
      aux_sym_import_con_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534491] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24525), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534507] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24527), 1,
      anon_sym_RBRACK,
    STATE(17092), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534523] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24529), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534539] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24531), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534555] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24533), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534571] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(24535), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534587] = 4,
    ACTIONS(2887), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534603] = 4,
    ACTIONS(20419), 1,
      anon_sym_RBRACE,
    ACTIONS(24537), 1,
      anon_sym_SEMI,
    STATE(17118), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534619] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24539), 1,
      anon_sym_RBRACE,
    STATE(17119), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534635] = 3,
    ACTIONS(24543), 1,
      sym_quasiquote_body,
    ACTIONS(24541), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534649] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24545), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534665] = 4,
    ACTIONS(24547), 1,
      anon_sym_RBRACE,
    ACTIONS(24549), 1,
      sym_comma,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534681] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24552), 1,
      anon_sym_RBRACK,
    STATE(17123), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534697] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(24554), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534713] = 3,
    ACTIONS(24556), 1,
      anon_sym_EQ,
    ACTIONS(24558), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534727] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24560), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534743] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24562), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534759] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24564), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534775] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24566), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534791] = 3,
    ACTIONS(24570), 1,
      sym_quasiquote_body,
    ACTIONS(24568), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534805] = 4,
    ACTIONS(20433), 1,
      anon_sym_RBRACE,
    ACTIONS(24572), 1,
      anon_sym_SEMI,
    STATE(17127), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534821] = 3,
    ACTIONS(24576), 1,
      sym_quasiquote_body,
    ACTIONS(24574), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534835] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24578), 1,
      anon_sym_RPAREN,
    STATE(17038), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534851] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24580), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534867] = 4,
    ACTIONS(1049), 1,
      anon_sym_RBRACE,
    ACTIONS(24582), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534883] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24584), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534899] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24586), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534915] = 2,
    ACTIONS(21923), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534927] = 4,
    ACTIONS(24588), 1,
      anon_sym_SEMI,
    ACTIONS(24590), 1,
      anon_sym_RBRACE,
    STATE(16963), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534943] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24592), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534959] = 2,
    ACTIONS(21739), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534971] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24594), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534987] = 2,
    ACTIONS(21927), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [534999] = 4,
    ACTIONS(11747), 1,
      anon_sym_RBRACE,
    ACTIONS(24596), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535015] = 3,
    ACTIONS(24600), 1,
      sym_quasiquote_body,
    ACTIONS(24598), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535029] = 2,
    ACTIONS(21739), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535041] = 3,
    ACTIONS(24604), 1,
      sym_quasiquote_body,
    ACTIONS(24602), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535055] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24606), 1,
      anon_sym_RBRACK,
    STATE(17125), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535071] = 2,
    ACTIONS(24608), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535083] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24610), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535099] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24612), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535115] = 3,
    ACTIONS(24616), 1,
      sym_quasiquote_body,
    ACTIONS(24614), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535129] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24618), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535145] = 3,
    ACTIONS(24622), 1,
      sym_quasiquote_body,
    ACTIONS(24620), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535159] = 4,
    ACTIONS(24624), 1,
      anon_sym_RBRACE,
    ACTIONS(24626), 1,
      sym_comma,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535175] = 3,
    ACTIONS(24631), 1,
      sym_quasiquote_body,
    ACTIONS(24629), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535189] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24633), 1,
      anon_sym_RBRACK,
    STATE(17097), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535205] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24635), 1,
      anon_sym_RBRACK,
    STATE(17209), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535221] = 3,
    ACTIONS(24639), 1,
      sym_quasiquote_body,
    ACTIONS(24637), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535235] = 4,
    ACTIONS(13133), 1,
      anon_sym_RBRACE,
    ACTIONS(24641), 1,
      anon_sym_SEMI,
    STATE(17165), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535251] = 3,
    ACTIONS(24645), 1,
      sym_quasiquote_body,
    ACTIONS(24643), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535265] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24647), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535281] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24649), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535297] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24651), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535313] = 4,
    ACTIONS(24653), 1,
      anon_sym_SEMI,
    ACTIONS(24655), 1,
      anon_sym_RBRACE,
    STATE(17165), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535329] = 2,
    ACTIONS(21947), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535341] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(24657), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535357] = 2,
    ACTIONS(20804), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535369] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24659), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535385] = 2,
    ACTIONS(21947), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535397] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24661), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535413] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24663), 1,
      anon_sym_RBRACK,
    STATE(17147), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535429] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24665), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535445] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24667), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535461] = 3,
    ACTIONS(24671), 1,
      sym_quasiquote_body,
    ACTIONS(24669), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535475] = 4,
    ACTIONS(20524), 1,
      anon_sym_RBRACE,
    ACTIONS(24673), 1,
      anon_sym_SEMI,
    STATE(17240), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535491] = 3,
    ACTIONS(24677), 1,
      sym_quasiquote_body,
    ACTIONS(24675), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535505] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24679), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535521] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24681), 1,
      anon_sym_RPAREN,
    STATE(17187), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535537] = 2,
    ACTIONS(19961), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535549] = 2,
    ACTIONS(21947), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535561] = 4,
    ACTIONS(24683), 1,
      anon_sym_SEMI,
    ACTIONS(24686), 1,
      anon_sym_RBRACE,
    STATE(17165), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535577] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24688), 1,
      anon_sym_RBRACE,
    STATE(17241), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535593] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(24690), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535609] = 2,
    ACTIONS(24692), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535621] = 3,
    ACTIONS(24696), 1,
      sym_quasiquote_body,
    ACTIONS(24694), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535635] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(24698), 1,
      anon_sym_RBRACE,
    STATE(17243), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535651] = 3,
    ACTIONS(24702), 1,
      sym_quasiquote_body,
    ACTIONS(24700), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535665] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24704), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535681] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24706), 1,
      anon_sym_RBRACK,
    STATE(17192), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535697] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24708), 1,
      anon_sym_RPAREN,
    STATE(17112), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535713] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24710), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535729] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24712), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535745] = 2,
    ACTIONS(24714), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535757] = 2,
    ACTIONS(21975), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535769] = 2,
    ACTIONS(24716), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535781] = 2,
    ACTIONS(17712), 3,
      sym__varsym,
      anon_sym_DASH,
      sym__conid,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535793] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(24718), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535809] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24720), 1,
      anon_sym_RBRACK,
    STATE(17176), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535825] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24722), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535841] = 4,
    ACTIONS(21003), 1,
      anon_sym_RBRACE,
    ACTIONS(24724), 1,
      anon_sym_SEMI,
    STATE(17201), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535857] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24726), 1,
      anon_sym_RBRACE,
    STATE(17202), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535873] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24728), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535889] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24730), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535905] = 3,
    ACTIONS(24734), 1,
      sym_quasiquote_body,
    ACTIONS(24732), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535919] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24736), 1,
      anon_sym_RBRACK,
    STATE(17206), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535935] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24738), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535951] = 2,
    ACTIONS(22483), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535963] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24740), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535979] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24742), 1,
      anon_sym_RBRACK,
    STATE(17246), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [535995] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24744), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536011] = 3,
    ACTIONS(24748), 1,
      sym_quasiquote_body,
    ACTIONS(24746), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536025] = 3,
    ACTIONS(24752), 1,
      sym_quasiquote_body,
    ACTIONS(24750), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536039] = 4,
    ACTIONS(20512), 1,
      anon_sym_RBRACE,
    ACTIONS(24754), 1,
      anon_sym_SEMI,
    STATE(17210), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536055] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24756), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536071] = 3,
    ACTIONS(24760), 1,
      sym_quasiquote_body,
    ACTIONS(24758), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536085] = 2,
    ACTIONS(21996), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536097] = 4,
    ACTIONS(949), 1,
      anon_sym_RBRACE,
    ACTIONS(24762), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536113] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24764), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536129] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24766), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536145] = 2,
    ACTIONS(24768), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536157] = 2,
    ACTIONS(24768), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536169] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24770), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536185] = 2,
    ACTIONS(24772), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536197] = 3,
    ACTIONS(24776), 1,
      sym_quasiquote_body,
    ACTIONS(24774), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536211] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24778), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536227] = 4,
    ACTIONS(11878), 1,
      anon_sym_RBRACE,
    ACTIONS(24780), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536243] = 4,
    ACTIONS(5507), 1,
      anon_sym_RBRACE,
    ACTIONS(24782), 1,
      anon_sym_SEMI,
    STATE(17736), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536259] = 2,
    ACTIONS(24784), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536271] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24786), 1,
      anon_sym_RBRACK,
    STATE(17203), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536287] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24788), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536303] = 4,
    ACTIONS(24790), 1,
      anon_sym_SEMI,
    ACTIONS(24793), 1,
      anon_sym_RBRACE,
    STATE(17215), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536319] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24795), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536335] = 2,
    ACTIONS(18715), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536347] = 3,
    ACTIONS(24799), 1,
      sym_quasiquote_body,
    ACTIONS(24797), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536361] = 3,
    ACTIONS(24803), 1,
      sym_quasiquote_body,
    ACTIONS(24801), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536375] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24805), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536391] = 3,
    ACTIONS(24809), 1,
      sym_quasiquote_body,
    ACTIONS(24807), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536405] = 3,
    ACTIONS(24813), 1,
      sym_quasiquote_body,
    ACTIONS(24811), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536419] = 2,
    ACTIONS(24815), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536431] = 3,
    ACTIONS(24819), 1,
      sym_quasiquote_body,
    ACTIONS(24817), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536445] = 2,
    ACTIONS(22036), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536457] = 4,
    ACTIONS(20429), 1,
      anon_sym_RBRACE,
    ACTIONS(24821), 1,
      anon_sym_SEMI,
    STATE(17342), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536473] = 2,
    ACTIONS(24823), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536485] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24825), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536501] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24827), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536517] = 4,
    ACTIONS(24829), 1,
      anon_sym_RBRACK,
    ACTIONS(24831), 1,
      sym_comma,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536533] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24834), 1,
      anon_sym_RBRACK,
    STATE(17229), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536549] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24836), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536565] = 3,
    ACTIONS(24840), 1,
      sym_quasiquote_body,
    ACTIONS(24838), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536579] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24842), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536595] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24844), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536611] = 3,
    ACTIONS(24848), 1,
      sym_quasiquote_body,
    ACTIONS(24846), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536625] = 2,
    ACTIONS(22447), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536637] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24850), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536653] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24852), 1,
      anon_sym_RBRACK,
    STATE(17245), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536669] = 4,
    ACTIONS(1023), 1,
      anon_sym_RBRACE,
    ACTIONS(24854), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536685] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24856), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536701] = 4,
    ACTIONS(11874), 1,
      anon_sym_RBRACE,
    ACTIONS(24858), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536717] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(24860), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536733] = 3,
    ACTIONS(24864), 1,
      sym_quasiquote_body,
    ACTIONS(24862), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536747] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24866), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536763] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24868), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536779] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24870), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536795] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24872), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536811] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(24874), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536827] = 3,
    ACTIONS(24878), 1,
      sym_quasiquote_body,
    ACTIONS(24876), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536841] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(24880), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536857] = 3,
    ACTIONS(24884), 1,
      sym_quasiquote_body,
    ACTIONS(24882), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536871] = 2,
    ACTIONS(24886), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536883] = 4,
    ACTIONS(1021), 1,
      anon_sym_RBRACE,
    ACTIONS(24888), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536899] = 3,
    ACTIONS(24892), 1,
      sym_quasiquote_body,
    ACTIONS(24890), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536913] = 4,
    ACTIONS(21373), 1,
      sym_comma,
    ACTIONS(24894), 1,
      anon_sym_RPAREN,
    STATE(17284), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536929] = 4,
    ACTIONS(20621), 1,
      anon_sym_RBRACE,
    ACTIONS(24896), 1,
      anon_sym_SEMI,
    STATE(17242), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536945] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24898), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536961] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24900), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536977] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24902), 1,
      anon_sym_RBRACK,
    STATE(17259), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [536993] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24904), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537009] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24906), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537025] = 3,
    ACTIONS(24910), 1,
      sym_quasiquote_body,
    ACTIONS(24908), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537039] = 3,
    ACTIONS(24914), 1,
      sym_quasiquote_body,
    ACTIONS(24912), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537053] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24916), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537069] = 4,
    ACTIONS(12401), 1,
      anon_sym_RBRACE,
    ACTIONS(24918), 1,
      anon_sym_SEMI,
    STATE(17718), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537085] = 3,
    STATE(17674), 1,
      sym__arrow,
    ACTIONS(24920), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537099] = 3,
    ACTIONS(24924), 1,
      sym_quasiquote_body,
    ACTIONS(24922), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537113] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24926), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537129] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24928), 1,
      anon_sym_RBRACK,
    STATE(17276), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537145] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24930), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537161] = 3,
    ACTIONS(24934), 1,
      sym_quasiquote_body,
    ACTIONS(24932), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537175] = 2,
    ACTIONS(16138), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537187] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24936), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537203] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24938), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537219] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24940), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537235] = 3,
    ACTIONS(24944), 1,
      sym_quasiquote_body,
    ACTIONS(24942), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537249] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24946), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537265] = 4,
    ACTIONS(20546), 1,
      anon_sym_RBRACE,
    ACTIONS(24948), 1,
      anon_sym_SEMI,
    STATE(17801), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537281] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24950), 1,
      anon_sym_RBRACK,
    STATE(17275), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537297] = 3,
    ACTIONS(24954), 1,
      sym_quasiquote_body,
    ACTIONS(24952), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537311] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(24956), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537327] = 3,
    ACTIONS(24960), 1,
      sym_quasiquote_body,
    ACTIONS(24958), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537341] = 4,
    ACTIONS(24962), 1,
      anon_sym_RPAREN,
    ACTIONS(24964), 1,
      sym_comma,
    STATE(17284), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537357] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(24967), 1,
      anon_sym_RBRACK,
    STATE(17248), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537373] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24969), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537389] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(24971), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537405] = 3,
    ACTIONS(24975), 1,
      sym_quasiquote_body,
    ACTIONS(24973), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537419] = 2,
    ACTIONS(18873), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537431] = 3,
    ACTIONS(24979), 1,
      sym_quasiquote_body,
    ACTIONS(24977), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537445] = 2,
    ACTIONS(24981), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537457] = 3,
    ACTIONS(24985), 1,
      sym_quasiquote_body,
    ACTIONS(24983), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537471] = 3,
    ACTIONS(24989), 1,
      sym_quasiquote_body,
    ACTIONS(24987), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537485] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(24991), 1,
      anon_sym_RPAREN,
    STATE(17355), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537501] = 3,
    ACTIONS(24995), 1,
      sym_quasiquote_body,
    ACTIONS(24993), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537515] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(24997), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537531] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(24999), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537547] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25001), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537563] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25003), 1,
      anon_sym_RBRACK,
    STATE(17359), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537579] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25005), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537595] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25007), 1,
      anon_sym_RBRACK,
    STATE(17307), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537611] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(25009), 1,
      anon_sym_RBRACE,
    STATE(17249), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537627] = 3,
    STATE(1447), 1,
      sym__arrow,
    ACTIONS(25011), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537641] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(25013), 1,
      anon_sym_RBRACE,
    STATE(17251), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537657] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25015), 1,
      anon_sym_RBRACK,
    STATE(17298), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537673] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25017), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537689] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25019), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537705] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25021), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537721] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25023), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537737] = 4,
    ACTIONS(20670), 1,
      anon_sym_RBRACE,
    ACTIONS(25025), 1,
      anon_sym_SEMI,
    STATE(17254), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537753] = 3,
    ACTIONS(25029), 1,
      sym_quasiquote_body,
    ACTIONS(25027), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537767] = 3,
    ACTIONS(25033), 1,
      sym_quasiquote_body,
    ACTIONS(25031), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537781] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(25035), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537797] = 3,
    ACTIONS(25039), 1,
      sym_quasiquote_body,
    ACTIONS(25037), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537811] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(25041), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537827] = 4,
    ACTIONS(21413), 1,
      sym_comma,
    ACTIONS(25043), 1,
      anon_sym_RBRACE,
    STATE(17042), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537843] = 3,
    ACTIONS(25047), 1,
      sym_quasiquote_body,
    ACTIONS(25045), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537857] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(25049), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537873] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25051), 1,
      anon_sym_RBRACK,
    STATE(17154), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537889] = 4,
    ACTIONS(16879), 1,
      sym__varid,
    STATE(14480), 1,
      sym_variable,
    STATE(18794), 1,
      sym_field,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537905] = 3,
    ACTIONS(25055), 1,
      sym_quasiquote_body,
    ACTIONS(25053), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537919] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25057), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537935] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25059), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537951] = 4,
    ACTIONS(25061), 1,
      anon_sym_SEMI,
    ACTIONS(25064), 1,
      anon_sym_RBRACE,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537967] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25066), 1,
      anon_sym_RBRACK,
    STATE(17323), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537983] = 3,
    ACTIONS(25070), 1,
      sym_quasiquote_body,
    ACTIONS(25068), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [537997] = 4,
    ACTIONS(2525), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538013] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25072), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538029] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25074), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538045] = 3,
    ACTIONS(25078), 1,
      sym_quasiquote_body,
    ACTIONS(25076), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538059] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25080), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538075] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25082), 1,
      anon_sym_RBRACK,
    STATE(17338), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538091] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25084), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538107] = 3,
    ACTIONS(25088), 1,
      sym_quasiquote_body,
    ACTIONS(25086), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538121] = 3,
    ACTIONS(25092), 1,
      sym_quasiquote_body,
    ACTIONS(25090), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538135] = 3,
    ACTIONS(25096), 1,
      sym_quasiquote_body,
    ACTIONS(25094), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538149] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25098), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538165] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25100), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538181] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25102), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538197] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25104), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538213] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25106), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538229] = 4,
    ACTIONS(11719), 1,
      anon_sym_RBRACE,
    ACTIONS(25108), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538245] = 3,
    ACTIONS(25112), 1,
      sym_quasiquote_body,
    ACTIONS(25110), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538259] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25114), 1,
      anon_sym_RBRACK,
    STATE(17341), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538275] = 3,
    ACTIONS(25118), 1,
      sym_quasiquote_body,
    ACTIONS(25116), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538289] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25120), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538305] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25122), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538321] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(25124), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538337] = 4,
    ACTIONS(25126), 1,
      anon_sym_SEMI,
    ACTIONS(25129), 1,
      anon_sym_RBRACE,
    STATE(17349), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538353] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25131), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538369] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(25133), 1,
      anon_sym_RPAREN,
    STATE(17287), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538385] = 4,
    ACTIONS(2941), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538401] = 3,
    ACTIONS(25137), 1,
      sym_quasiquote_body,
    ACTIONS(25135), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538415] = 4,
    ACTIONS(5118), 1,
      anon_sym_RBRACE,
    ACTIONS(25139), 1,
      anon_sym_SEMI,
    STATE(16345), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538431] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25141), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538447] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(25143), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538463] = 3,
    ACTIONS(25147), 1,
      sym_quasiquote_body,
    ACTIONS(25145), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538477] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25149), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538493] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25151), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538509] = 3,
    ACTIONS(25155), 1,
      sym_quasiquote_body,
    ACTIONS(25153), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538523] = 3,
    ACTIONS(25159), 1,
      sym_quasiquote_body,
    ACTIONS(25157), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538537] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25161), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538553] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25163), 1,
      anon_sym_RBRACK,
    STATE(17369), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538569] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25165), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538585] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25167), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538601] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25169), 1,
      anon_sym_RBRACK,
    STATE(17365), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538617] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25171), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538633] = 4,
    ACTIONS(2911), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538649] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25173), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538665] = 3,
    ACTIONS(25177), 1,
      sym_quasiquote_body,
    ACTIONS(25175), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538679] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25179), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538695] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25181), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538711] = 2,
    ACTIONS(18861), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538723] = 3,
    ACTIONS(25185), 1,
      sym_quasiquote_body,
    ACTIONS(25183), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538737] = 3,
    ACTIONS(25189), 1,
      sym_quasiquote_body,
    ACTIONS(25187), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538751] = 3,
    ACTIONS(25193), 1,
      sym_quasiquote_body,
    ACTIONS(25191), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538765] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25195), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538781] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25197), 1,
      anon_sym_RBRACK,
    STATE(17421), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538797] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(25199), 1,
      anon_sym_RPAREN,
    STATE(17406), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538813] = 2,
    ACTIONS(25201), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538825] = 3,
    ACTIONS(25205), 1,
      sym_quasiquote_body,
    ACTIONS(25203), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538839] = 2,
    ACTIONS(22114), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538851] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(25207), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538867] = 3,
    ACTIONS(25211), 1,
      sym_quasiquote_body,
    ACTIONS(25209), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538881] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(25213), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538897] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25215), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538913] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25217), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538929] = 3,
    ACTIONS(25221), 1,
      sym_quasiquote_body,
    ACTIONS(25219), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538943] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25223), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538959] = 4,
    ACTIONS(20140), 1,
      anon_sym_RBRACE,
    ACTIONS(25225), 1,
      anon_sym_SEMI,
    STATE(17535), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538975] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25227), 1,
      anon_sym_RBRACK,
    STATE(17387), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [538991] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25229), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539007] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25231), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539023] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25233), 1,
      anon_sym_RBRACK,
    STATE(17400), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539039] = 2,
    ACTIONS(25235), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539051] = 4,
    ACTIONS(2885), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539067] = 3,
    ACTIONS(25239), 1,
      sym_quasiquote_body,
    ACTIONS(25237), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539081] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(25241), 1,
      anon_sym_RBRACE,
    STATE(17445), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539097] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(25243), 1,
      anon_sym_RBRACE,
    STATE(17447), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539113] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25245), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539129] = 2,
    ACTIONS(18847), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539141] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25247), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539157] = 3,
    ACTIONS(25251), 1,
      sym_quasiquote_body,
    ACTIONS(25249), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539171] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(25253), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539187] = 3,
    ACTIONS(25257), 1,
      sym_quasiquote_body,
    ACTIONS(25255), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539201] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(25259), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539217] = 3,
    ACTIONS(25263), 1,
      sym_quasiquote_body,
    ACTIONS(25261), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539231] = 3,
    STATE(2820), 1,
      sym__arrow,
    ACTIONS(25265), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539245] = 3,
    ACTIONS(25269), 1,
      sym_quasiquote_body,
    ACTIONS(25267), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539259] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25271), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539275] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25273), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539291] = 2,
    ACTIONS(20923), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539303] = 4,
    ACTIONS(153), 1,
      anon_sym_RBRACE,
    ACTIONS(25275), 1,
      anon_sym_SEMI,
    STATE(17488), 1,
      aux_sym__module_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539319] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(25277), 1,
      anon_sym_RBRACK,
    STATE(17452), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539335] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25279), 1,
      anon_sym_RBRACK,
    STATE(17411), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539351] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25281), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539367] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25283), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539383] = 3,
    ACTIONS(25287), 1,
      sym_quasiquote_body,
    ACTIONS(25285), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539397] = 3,
    ACTIONS(25291), 1,
      sym_quasiquote_body,
    ACTIONS(25289), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539411] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25293), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539427] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25295), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539443] = 3,
    ACTIONS(25299), 1,
      sym_quasiquote_body,
    ACTIONS(25297), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539457] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25301), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539473] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25303), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539489] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25305), 1,
      anon_sym_RBRACK,
    STATE(17431), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539505] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25307), 1,
      anon_sym_RBRACK,
    STATE(17346), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539521] = 3,
    ACTIONS(25311), 1,
      sym_quasiquote_body,
    ACTIONS(25309), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539535] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25313), 1,
      anon_sym_RPAREN,
    STATE(17350), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539551] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25315), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539567] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25317), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539583] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25319), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539599] = 4,
    ACTIONS(20114), 1,
      anon_sym_RBRACE,
    ACTIONS(25321), 1,
      anon_sym_SEMI,
    STATE(17461), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539615] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25323), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539631] = 4,
    ACTIONS(25325), 1,
      anon_sym_RPAREN,
    ACTIONS(25327), 1,
      sym_comma,
    STATE(17533), 1,
      aux_sym_import_con_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539647] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25329), 1,
      anon_sym_RBRACK,
    STATE(17430), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539663] = 3,
    ACTIONS(25333), 1,
      sym_quasiquote_body,
    ACTIONS(25331), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539677] = 3,
    ACTIONS(25337), 1,
      sym_quasiquote_body,
    ACTIONS(25335), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539691] = 3,
    ACTIONS(25341), 1,
      sym_quasiquote_body,
    ACTIONS(25339), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539705] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25343), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539721] = 4,
    ACTIONS(2712), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539737] = 3,
    ACTIONS(25347), 1,
      sym_quasiquote_body,
    ACTIONS(25345), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539751] = 3,
    ACTIONS(25351), 1,
      sym_quasiquote_body,
    ACTIONS(25349), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539765] = 3,
    ACTIONS(25355), 1,
      sym_quasiquote_body,
    ACTIONS(25353), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539779] = 4,
    ACTIONS(25357), 1,
      anon_sym_RPAREN,
    ACTIONS(25359), 1,
      sym_comma,
    STATE(17067), 1,
      aux_sym_export_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539795] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(25361), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539811] = 3,
    ACTIONS(25365), 1,
      sym_quasiquote_body,
    ACTIONS(25363), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539825] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(25367), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539841] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25369), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539857] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25371), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539873] = 3,
    ACTIONS(25375), 1,
      sym_quasiquote_body,
    ACTIONS(25373), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539887] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25377), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539903] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(25379), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539919] = 2,
    ACTIONS(22363), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539931] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25381), 1,
      anon_sym_RBRACK,
    STATE(17449), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539947] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25383), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539963] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25385), 1,
      anon_sym_RBRACK,
    STATE(17462), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539979] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25387), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [539995] = 4,
    ACTIONS(2656), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540011] = 2,
    ACTIONS(18905), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540023] = 3,
    ACTIONS(25391), 1,
      sym_quasiquote_body,
    ACTIONS(25389), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540037] = 4,
    ACTIONS(11759), 1,
      anon_sym_RBRACE,
    ACTIONS(25393), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540053] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25395), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540069] = 2,
    ACTIONS(18849), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540081] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25397), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540097] = 2,
    ACTIONS(18968), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540109] = 4,
    ACTIONS(25399), 1,
      anon_sym_RPAREN,
    ACTIONS(25401), 1,
      sym_comma,
    STATE(17466), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540125] = 3,
    ACTIONS(25406), 1,
      sym_quasiquote_body,
    ACTIONS(25404), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540139] = 3,
    ACTIONS(25410), 1,
      sym_quasiquote_body,
    ACTIONS(25408), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540153] = 3,
    ACTIONS(25414), 1,
      sym_quasiquote_body,
    ACTIONS(25412), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540167] = 3,
    ACTIONS(25418), 1,
      sym_quasiquote_body,
    ACTIONS(25416), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540181] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25420), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540197] = 2,
    ACTIONS(19220), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540209] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25422), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540225] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25424), 1,
      anon_sym_RBRACK,
    STATE(17473), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540241] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25426), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540257] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25428), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540273] = 3,
    ACTIONS(25432), 1,
      sym_quasiquote_body,
    ACTIONS(25430), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540287] = 2,
    ACTIONS(18569), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540299] = 3,
    ACTIONS(25436), 1,
      sym_quasiquote_body,
    ACTIONS(25434), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540313] = 4,
    ACTIONS(215), 1,
      anon_sym_RBRACE,
    ACTIONS(25438), 1,
      anon_sym_SEMI,
    STATE(17488), 1,
      aux_sym__module_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540329] = 3,
    ACTIONS(25442), 1,
      sym_quasiquote_body,
    ACTIONS(25440), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540343] = 4,
    ACTIONS(2822), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540359] = 3,
    ACTIONS(25446), 1,
      sym_quasiquote_body,
    ACTIONS(25444), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540373] = 3,
    ACTIONS(25450), 1,
      sym_quasiquote_body,
    ACTIONS(25448), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540387] = 3,
    ACTIONS(25454), 1,
      sym_quasiquote_body,
    ACTIONS(25452), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540401] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25456), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540417] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25458), 1,
      anon_sym_RBRACK,
    STATE(17493), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540433] = 4,
    ACTIONS(25460), 1,
      anon_sym_SEMI,
    ACTIONS(25463), 1,
      anon_sym_RBRACE,
    STATE(17488), 1,
      aux_sym__module_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540449] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25465), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540465] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25467), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540481] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25469), 1,
      anon_sym_RBRACK,
    STATE(17490), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540497] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25471), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540513] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25473), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540529] = 4,
    ACTIONS(2893), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540545] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25475), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540561] = 4,
    ACTIONS(11679), 1,
      anon_sym_RBRACE,
    ACTIONS(25477), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540577] = 2,
    ACTIONS(19173), 3,
      sym__layout_semicolon,
      anon_sym_SEMI,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540589] = 3,
    ACTIONS(25481), 1,
      sym_quasiquote_body,
    ACTIONS(25479), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540603] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(25483), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540619] = 3,
    ACTIONS(25487), 1,
      sym_quasiquote_body,
    ACTIONS(25485), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540633] = 2,
    ACTIONS(22132), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540645] = 3,
    ACTIONS(25491), 1,
      sym_quasiquote_body,
    ACTIONS(25489), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540659] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(25493), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540675] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(25495), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540691] = 4,
    ACTIONS(1043), 1,
      anon_sym_RBRACE,
    ACTIONS(25497), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540707] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25499), 1,
      anon_sym_RPAREN,
    STATE(17554), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540723] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25501), 1,
      anon_sym_RBRACK,
    STATE(17571), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540739] = 3,
    ACTIONS(25505), 1,
      sym_quasiquote_body,
    ACTIONS(25503), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540753] = 3,
    ACTIONS(25509), 1,
      sym_quasiquote_body,
    ACTIONS(25507), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540767] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25511), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540783] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25513), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540799] = 3,
    ACTIONS(25517), 1,
      sym_quasiquote_body,
    ACTIONS(25515), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540813] = 4,
    ACTIONS(2834), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540829] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(25519), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540845] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25521), 1,
      anon_sym_RBRACK,
    STATE(17511), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540861] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25523), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540877] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25525), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540893] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25527), 1,
      anon_sym_RBRACK,
    STATE(17524), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540909] = 2,
    ACTIONS(22120), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540921] = 4,
    ACTIONS(2716), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540937] = 4,
    ACTIONS(20857), 1,
      anon_sym_RBRACE,
    ACTIONS(25529), 1,
      anon_sym_SEMI,
    STATE(17496), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540953] = 3,
    ACTIONS(25533), 1,
      sym_quasiquote_body,
    ACTIONS(25531), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540967] = 4,
    ACTIONS(25359), 1,
      sym_comma,
    ACTIONS(25535), 1,
      anon_sym_RPAREN,
    STATE(17444), 1,
      aux_sym_export_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540983] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25537), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [540999] = 3,
    ACTIONS(25541), 1,
      sym_quasiquote_body,
    ACTIONS(25539), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541013] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25543), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541029] = 3,
    ACTIONS(25547), 1,
      sym_quasiquote_body,
    ACTIONS(25545), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541043] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25549), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541059] = 3,
    ACTIONS(25553), 1,
      sym_quasiquote_body,
    ACTIONS(25551), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541073] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25555), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541089] = 3,
    ACTIONS(25559), 1,
      sym_quasiquote_body,
    ACTIONS(25557), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541103] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25561), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541119] = 4,
    ACTIONS(25327), 1,
      sym_comma,
    ACTIONS(25563), 1,
      anon_sym_RPAREN,
    STATE(17093), 1,
      aux_sym_import_con_names_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541135] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25565), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541151] = 4,
    ACTIONS(977), 1,
      anon_sym_RBRACE,
    ACTIONS(25567), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541167] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25569), 1,
      anon_sym_RBRACK,
    STATE(17534), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541183] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(25571), 1,
      anon_sym_RBRACK,
    STATE(17499), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541199] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25573), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541215] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25575), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541231] = 3,
    ACTIONS(25579), 1,
      sym_quasiquote_body,
    ACTIONS(25577), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541245] = 3,
    ACTIONS(25583), 1,
      sym_quasiquote_body,
    ACTIONS(25581), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541259] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25585), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541275] = 3,
    ACTIONS(25589), 1,
      sym_quasiquote_body,
    ACTIONS(25587), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541289] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25591), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541305] = 4,
    ACTIONS(25593), 1,
      anon_sym_RPAREN,
    ACTIONS(25595), 1,
      sym_comma,
    STATE(17545), 1,
      aux_sym_exports_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541321] = 3,
    ACTIONS(25600), 1,
      sym_quasiquote_body,
    ACTIONS(25598), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541335] = 3,
    ACTIONS(25604), 1,
      sym_quasiquote_body,
    ACTIONS(25602), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541349] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25606), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541365] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25608), 1,
      anon_sym_RBRACK,
    STATE(17555), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541381] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(25610), 1,
      anon_sym_RPAREN,
    STATE(17620), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541397] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25612), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541413] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25614), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541429] = 2,
    ACTIONS(18595), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541441] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25616), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541457] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25618), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541473] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25620), 1,
      anon_sym_RBRACK,
    STATE(17552), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541489] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25622), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541505] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(25624), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541521] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25626), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541537] = 3,
    ACTIONS(25630), 1,
      sym_quasiquote_body,
    ACTIONS(25628), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541551] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(25632), 1,
      anon_sym_RBRACE,
    STATE(17503), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541567] = 3,
    ACTIONS(25636), 1,
      sym_quasiquote_body,
    ACTIONS(25634), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541581] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25638), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541597] = 3,
    ACTIONS(25642), 1,
      sym_quasiquote_body,
    ACTIONS(25640), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541611] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(25644), 1,
      anon_sym_RBRACE,
    STATE(17504), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541627] = 2,
    ACTIONS(22122), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541639] = 4,
    ACTIONS(20885), 1,
      anon_sym_RBRACE,
    ACTIONS(25646), 1,
      anon_sym_SEMI,
    STATE(17505), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541655] = 2,
    ACTIONS(18809), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541667] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(25648), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541683] = 4,
    ACTIONS(17739), 1,
      anon_sym_RPAREN,
    ACTIONS(25650), 1,
      sym_comma,
    STATE(17466), 1,
      aux_sym_import_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541699] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25652), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541715] = 3,
    ACTIONS(25656), 1,
      sym_quasiquote_body,
    ACTIONS(25654), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541729] = 3,
    ACTIONS(25660), 1,
      sym_quasiquote_body,
    ACTIONS(25658), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541743] = 3,
    ACTIONS(25664), 1,
      sym_quasiquote_body,
    ACTIONS(25662), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541757] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25666), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541773] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25668), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541789] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25670), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541805] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25672), 1,
      anon_sym_RBRACK,
    STATE(17577), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541821] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25674), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541837] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25676), 1,
      anon_sym_RBRACK,
    STATE(17586), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541853] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25678), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541869] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25680), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541885] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(25682), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541901] = 3,
    ACTIONS(25686), 1,
      sym_quasiquote_body,
    ACTIONS(25684), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541915] = 2,
    ACTIONS(25688), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541927] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25690), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541943] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25692), 1,
      anon_sym_RBRACK,
    STATE(17639), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541959] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25694), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541975] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(25696), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [541991] = 2,
    ACTIONS(22337), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542003] = 3,
    ACTIONS(25700), 1,
      sym_quasiquote_body,
    ACTIONS(25698), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542017] = 3,
    ACTIONS(25704), 1,
      sym_quasiquote_body,
    ACTIONS(25702), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542031] = 3,
    ACTIONS(25708), 1,
      sym_quasiquote_body,
    ACTIONS(25706), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542045] = 2,
    ACTIONS(22130), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542057] = 4,
    ACTIONS(25710), 1,
      anon_sym_SEMI,
    ACTIONS(25712), 1,
      anon_sym_RBRACE,
    STATE(17122), 1,
      aux_sym__pattern_arrow_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542073] = 2,
    ACTIONS(15419), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542085] = 3,
    ACTIONS(25716), 1,
      sym_quasiquote_body,
    ACTIONS(25714), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542099] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25718), 1,
      anon_sym_RBRACK,
    STATE(17532), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542115] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25720), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542131] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25722), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542147] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25724), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542163] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(25726), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542179] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(25728), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542195] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25730), 1,
      anon_sym_RBRACK,
    STATE(17601), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542211] = 3,
    ACTIONS(25734), 1,
      sym_quasiquote_body,
    ACTIONS(25732), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542225] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25736), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542241] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25738), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542257] = 4,
    ACTIONS(2728), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542273] = 3,
    ACTIONS(25742), 1,
      sym_quasiquote_body,
    ACTIONS(25740), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542287] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25744), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542303] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25746), 1,
      anon_sym_RBRACK,
    STATE(17617), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542319] = 4,
    ACTIONS(20292), 1,
      anon_sym_RBRACE,
    ACTIONS(25748), 1,
      anon_sym_SEMI,
    STATE(17659), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542335] = 4,
    ACTIONS(18679), 1,
      anon_sym_RBRACE,
    ACTIONS(25750), 1,
      anon_sym_SEMI,
    STATE(17349), 1,
      aux_sym__gadt_rhs_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542351] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(25752), 1,
      anon_sym_RBRACE,
    STATE(17660), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542367] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(25754), 1,
      anon_sym_RBRACE,
    STATE(17664), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542383] = 3,
    ACTIONS(25758), 1,
      sym_quasiquote_body,
    ACTIONS(25756), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542397] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25760), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542413] = 3,
    ACTIONS(25764), 1,
      sym_quasiquote_body,
    ACTIONS(25762), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542427] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25766), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542443] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(25768), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542459] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25770), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542475] = 3,
    ACTIONS(25774), 1,
      sym_quasiquote_body,
    ACTIONS(25772), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542489] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25776), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542505] = 3,
    ACTIONS(25780), 1,
      sym_quasiquote_body,
    ACTIONS(25778), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542519] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(25782), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542535] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25784), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542551] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(25786), 1,
      anon_sym_RPAREN,
    STATE(17558), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542567] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25788), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542583] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25790), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542599] = 4,
    ACTIONS(2558), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542615] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25792), 1,
      anon_sym_RBRACK,
    STATE(17628), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542631] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25794), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542647] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25796), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542663] = 3,
    ACTIONS(25800), 1,
      sym_quasiquote_body,
    ACTIONS(25798), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542677] = 4,
    ACTIONS(21413), 1,
      sym_comma,
    ACTIONS(25802), 1,
      anon_sym_RBRACE,
    STATE(17316), 1,
      aux_sym_record_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542693] = 3,
    ACTIONS(25806), 1,
      sym_quasiquote_body,
    ACTIONS(25804), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542707] = 4,
    ACTIONS(2601), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542723] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(25808), 1,
      anon_sym_RBRACK,
    STATE(17666), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542739] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25810), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542755] = 3,
    ACTIONS(25814), 1,
      sym_quasiquote_body,
    ACTIONS(25812), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542769] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25816), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542785] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25818), 1,
      anon_sym_RBRACK,
    STATE(17648), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542801] = 3,
    ACTIONS(25822), 1,
      sym_quasiquote_body,
    ACTIONS(25820), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542815] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25824), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542831] = 3,
    ACTIONS(25828), 1,
      sym_quasiquote_body,
    ACTIONS(25826), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542845] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25830), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542861] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25832), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542877] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25834), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542893] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25836), 1,
      anon_sym_RBRACK,
    STATE(17647), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542909] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25838), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542925] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25840), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542941] = 4,
    ACTIONS(2704), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542957] = 3,
    ACTIONS(25844), 1,
      sym_quasiquote_body,
    ACTIONS(25842), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542971] = 3,
    ACTIONS(25848), 1,
      sym_quasiquote_body,
    ACTIONS(25846), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542985] = 3,
    ACTIONS(25852), 1,
      sym_quasiquote_body,
    ACTIONS(25850), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [542999] = 2,
    ACTIONS(25854), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543011] = 4,
    ACTIONS(13272), 1,
      anon_sym_RBRACE,
    ACTIONS(25856), 1,
      anon_sym_SEMI,
    STATE(17143), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543027] = 4,
    ACTIONS(20336), 1,
      anon_sym_RBRACE,
    ACTIONS(25858), 1,
      anon_sym_SEMI,
    STATE(17671), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543043] = 4,
    ACTIONS(1095), 1,
      anon_sym_RBRACE,
    ACTIONS(25860), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543059] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(25862), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543075] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(25864), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543091] = 4,
    ACTIONS(215), 1,
      anon_sym_RBRACE,
    ACTIONS(25438), 1,
      anon_sym_SEMI,
    STATE(17413), 1,
      aux_sym__module_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543107] = 3,
    ACTIONS(25868), 1,
      sym_quasiquote_body,
    ACTIONS(25866), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543121] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(25870), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543137] = 3,
    ACTIONS(25874), 1,
      sym_quasiquote_body,
    ACTIONS(25872), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543151] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(25876), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543167] = 3,
    ACTIONS(25880), 1,
      sym_quasiquote_body,
    ACTIONS(25878), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543181] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(25882), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543197] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25884), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543213] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25886), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543229] = 4,
    ACTIONS(11635), 1,
      anon_sym_RBRACE,
    ACTIONS(25888), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543245] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25890), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543261] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25892), 1,
      anon_sym_RBRACK,
    STATE(17679), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543277] = 3,
    ACTIONS(18630), 1,
      sym__varid,
    STATE(13221), 2,
      sym_type_variable,
      aux_sym_tyfam_injectivity_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543291] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25894), 1,
      anon_sym_RBRACK,
    STATE(17670), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543307] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25896), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543323] = 4,
    ACTIONS(2718), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543339] = 3,
    ACTIONS(25900), 1,
      sym_quasiquote_body,
    ACTIONS(25898), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543353] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25902), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543369] = 4,
    ACTIONS(21373), 1,
      sym_comma,
    ACTIONS(25904), 1,
      anon_sym_RPAREN,
    STATE(17284), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543385] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25906), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543401] = 3,
    ACTIONS(25910), 1,
      sym_quasiquote_body,
    ACTIONS(25908), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543415] = 3,
    ACTIONS(25914), 1,
      sym_quasiquote_body,
    ACTIONS(25912), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543429] = 3,
    ACTIONS(25918), 1,
      sym_quasiquote_body,
    ACTIONS(25916), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543443] = 3,
    ACTIONS(25922), 1,
      sym_quasiquote_body,
    ACTIONS(25920), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543457] = 3,
    ACTIONS(25926), 1,
      sym_quasiquote_body,
    ACTIONS(25924), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543471] = 4,
    ACTIONS(25928), 1,
      anon_sym_SEMI,
    ACTIONS(25930), 1,
      anon_sym_RBRACE,
    STATE(17148), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543487] = 2,
    ACTIONS(22166), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543499] = 2,
    ACTIONS(4109), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543511] = 2,
    ACTIONS(15425), 3,
      sym_comma,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543523] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25932), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543539] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25934), 1,
      anon_sym_RBRACK,
    STATE(17623), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543555] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25936), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543571] = 4,
    ACTIONS(21373), 1,
      sym_comma,
    ACTIONS(25938), 1,
      anon_sym_RPAREN,
    STATE(17256), 1,
      aux_sym_deriving_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543587] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25940), 1,
      anon_sym_RBRACK,
    STATE(17693), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543603] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25942), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543619] = 4,
    ACTIONS(2842), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543635] = 3,
    ACTIONS(25946), 1,
      sym_quasiquote_body,
    ACTIONS(25944), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543649] = 4,
    ACTIONS(2714), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543665] = 3,
    ACTIONS(25950), 1,
      sym_quasiquote_body,
    ACTIONS(25948), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543679] = 3,
    ACTIONS(25954), 1,
      sym_quasiquote_body,
    ACTIONS(25952), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543693] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25956), 1,
      anon_sym_RPAREN,
    STATE(17745), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543709] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25958), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543725] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25960), 1,
      anon_sym_RBRACK,
    STATE(17710), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543741] = 2,
    ACTIONS(22166), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543753] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25962), 1,
      anon_sym_RBRACK,
    STATE(17756), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543769] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(25964), 1,
      anon_sym_RPAREN,
    STATE(17626), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543785] = 3,
    ACTIONS(25968), 1,
      sym_quasiquote_body,
    ACTIONS(25966), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543799] = 3,
    ACTIONS(25972), 1,
      sym_quasiquote_body,
    ACTIONS(25970), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543813] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25974), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543829] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25976), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543845] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(25978), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543861] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25980), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543877] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25982), 1,
      anon_sym_RBRACK,
    STATE(17713), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543893] = 3,
    ACTIONS(25986), 1,
      sym_quasiquote_body,
    ACTIONS(25984), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543907] = 3,
    ACTIONS(25990), 1,
      sym_quasiquote_body,
    ACTIONS(25988), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543921] = 3,
    ACTIONS(25994), 1,
      sym_quasiquote_body,
    ACTIONS(25992), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543935] = 4,
    ACTIONS(13272), 1,
      anon_sym_RBRACE,
    ACTIONS(25856), 1,
      anon_sym_SEMI,
    STATE(17165), 1,
      aux_sym_decl_tyfam_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543951] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(25996), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543967] = 3,
    ACTIONS(26000), 1,
      sym_quasiquote_body,
    ACTIONS(25998), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543981] = 2,
    ACTIONS(22186), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [543993] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(26002), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544009] = 3,
    ACTIONS(26006), 1,
      sym_quasiquote_body,
    ACTIONS(26004), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544023] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(26008), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544039] = 2,
    ACTIONS(26010), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544051] = 3,
    ACTIONS(26014), 1,
      sym_quasiquote_body,
    ACTIONS(26012), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544065] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(26016), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544081] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26018), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544097] = 3,
    ACTIONS(26022), 1,
      sym_quasiquote_body,
    ACTIONS(26020), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544111] = 4,
    ACTIONS(2724), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544127] = 2,
    ACTIONS(22279), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544139] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26024), 1,
      anon_sym_RBRACK,
    STATE(17728), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544155] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26026), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544171] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26028), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544187] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26030), 1,
      anon_sym_RBRACK,
    STATE(17741), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544203] = 4,
    ACTIONS(26032), 1,
      anon_sym_SEMI,
    ACTIONS(26035), 1,
      anon_sym_RBRACE,
    STATE(17736), 1,
      aux_sym_decl_instance_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544219] = 4,
    ACTIONS(2824), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544235] = 3,
    ACTIONS(26039), 1,
      sym_quasiquote_body,
    ACTIONS(26037), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544249] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(26041), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544265] = 4,
    ACTIONS(4947), 1,
      anon_sym_RBRACE,
    ACTIONS(26043), 1,
      anon_sym_SEMI,
    STATE(17215), 1,
      aux_sym_class_body_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544281] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26045), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544297] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(26047), 1,
      anon_sym_RPAREN,
    STATE(17807), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544313] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(26049), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544329] = 3,
    ACTIONS(26053), 1,
      sym_quasiquote_body,
    ACTIONS(26051), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544343] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(26055), 1,
      anon_sym_RPAREN,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544359] = 3,
    ACTIONS(26059), 1,
      sym_quasiquote_body,
    ACTIONS(26057), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544373] = 3,
    ACTIONS(26063), 1,
      sym_quasiquote_body,
    ACTIONS(26061), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544387] = 3,
    ACTIONS(26067), 1,
      sym_quasiquote_body,
    ACTIONS(26065), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544401] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(26069), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544417] = 4,
    ACTIONS(11395), 1,
      anon_sym_RBRACE,
    ACTIONS(26071), 1,
      anon_sym_SEMI,
    STATE(17324), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544433] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26073), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544449] = 2,
    ACTIONS(26075), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544461] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(26077), 1,
      anon_sym_RBRACK,
    STATE(17230), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544477] = 2,
    ACTIONS(22199), 3,
      sym__layout_semicolon,
      ts_builtin_sym_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544489] = 3,
    ACTIONS(26081), 1,
      sym_quasiquote_body,
    ACTIONS(26079), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544503] = 4,
    ACTIONS(21159), 1,
      sym_comma,
    ACTIONS(26083), 1,
      anon_sym_RBRACK,
    STATE(15348), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544519] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26085), 1,
      anon_sym_RBRACK,
    STATE(17751), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544535] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26087), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544551] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(26089), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544567] = 3,
    ACTIONS(26093), 1,
      sym_quasiquote_body,
    ACTIONS(26091), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544581] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(26095), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544597] = 3,
    ACTIONS(26099), 1,
      sym_quasiquote_body,
    ACTIONS(26097), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544611] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26101), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544627] = 3,
    ACTIONS(26105), 1,
      sym_quasiquote_body,
    ACTIONS(26103), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544641] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26107), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544657] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26109), 1,
      anon_sym_RBRACK,
    STATE(17772), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544673] = 2,
    ACTIONS(26111), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544685] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26113), 1,
      anon_sym_RBRACK,
    STATE(17798), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544701] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(26115), 1,
      anon_sym_RBRACE,
    STATE(17138), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544717] = 3,
    ACTIONS(26119), 1,
      sym_quasiquote_body,
    ACTIONS(26117), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544731] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(26121), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544747] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26123), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544763] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26125), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544779] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(26127), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544795] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(26129), 1,
      anon_sym_RBRACE,
    STATE(17105), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544811] = 4,
    ACTIONS(951), 1,
      anon_sym_RBRACE,
    ACTIONS(26131), 1,
      anon_sym_SEMI,
    STATE(17070), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544827] = 3,
    ACTIONS(26135), 1,
      sym_quasiquote_body,
    ACTIONS(26133), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544841] = 4,
    ACTIONS(575), 1,
      sym_comma,
    ACTIONS(26137), 1,
      sym__unboxed_close,
    STATE(15837), 1,
      aux_sym__exp_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544857] = 3,
    ACTIONS(26141), 1,
      sym_quasiquote_body,
    ACTIONS(26139), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544871] = 4,
    ACTIONS(21095), 1,
      anon_sym_RBRACE,
    ACTIONS(26143), 1,
      anon_sym_SEMI,
    STATE(17750), 1,
      aux_sym_alts_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544887] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26145), 1,
      anon_sym_RBRACK,
    STATE(17773), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544903] = 2,
    ACTIONS(26111), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544915] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(26147), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544931] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26149), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544947] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(26151), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544963] = 3,
    ACTIONS(26155), 1,
      sym_quasiquote_body,
    ACTIONS(26153), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544977] = 2,
    ACTIONS(26157), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [544989] = 4,
    ACTIONS(19257), 1,
      sym_comma,
    ACTIONS(26159), 1,
      sym__unboxed_close,
    STATE(16499), 1,
      aux_sym_pat_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545005] = 4,
    ACTIONS(21107), 1,
      anon_sym_RBRACE,
    ACTIONS(26161), 1,
      anon_sym_SEMI,
    STATE(17776), 1,
      aux_sym_rec_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545021] = 3,
    ACTIONS(26165), 1,
      sym_quasiquote_body,
    ACTIONS(26163), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545035] = 4,
    ACTIONS(21191), 1,
      sym_comma,
    ACTIONS(26167), 1,
      anon_sym_RPAREN,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545051] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26169), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545067] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26171), 1,
      anon_sym_RBRACK,
    STATE(17796), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545083] = 2,
    ACTIONS(26173), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545095] = 4,
    ACTIONS(21209), 1,
      sym_comma,
    ACTIONS(26175), 1,
      anon_sym_RBRACK,
    STATE(15955), 1,
      aux_sym_exp_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545111] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26177), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545127] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(26179), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545143] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26181), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545159] = 3,
    ACTIONS(26185), 1,
      sym_quasiquote_body,
    ACTIONS(26183), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545173] = 3,
    ACTIONS(26189), 1,
      sym_quasiquote_body,
    ACTIONS(26187), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545187] = 4,
    ACTIONS(5110), 1,
      anon_sym_RBRACE,
    ACTIONS(26191), 1,
      anon_sym_SEMI,
    STATE(16345), 1,
      aux_sym__let_decls_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545203] = 4,
    ACTIONS(21141), 1,
      sym_comma,
    ACTIONS(26193), 1,
      anon_sym_RBRACK,
    STATE(17753), 1,
      aux_sym_exp_list_comprehension_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545219] = 3,
    ACTIONS(26197), 1,
      sym_quasiquote_body,
    ACTIONS(26195), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545233] = 4,
    ACTIONS(2836), 1,
      anon_sym_RPAREN,
    ACTIONS(21191), 1,
      sym_comma,
    STATE(16732), 1,
      aux_sym_con_tuple_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545249] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26199), 1,
      anon_sym_RPAREN,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545265] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26201), 1,
      anon_sym_RBRACK,
    STATE(17808), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545281] = 4,
    ACTIONS(21199), 1,
      sym__immediate_dot,
    ACTIONS(26203), 1,
      anon_sym_RPAREN,
    STATE(16230), 1,
      aux_sym_exp_projection_selector_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545297] = 4,
    ACTIONS(21225), 1,
      sym_comma,
    ACTIONS(26205), 1,
      anon_sym_RBRACK,
    STATE(14845), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545313] = 4,
    ACTIONS(19241), 1,
      sym_comma,
    ACTIONS(26207), 1,
      sym__unboxed_close,
    STATE(16226), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545329] = 4,
    ACTIONS(21137), 1,
      sym_comma,
    ACTIONS(26209), 1,
      anon_sym_RBRACE,
    STATE(17769), 1,
      aux_sym_pat_fields_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545345] = 3,
    ACTIONS(26213), 1,
      sym_quasiquote_body,
    ACTIONS(26211), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545359] = 4,
    ACTIONS(21133), 1,
      sym_comma,
    ACTIONS(26215), 1,
      anon_sym_RBRACE,
    STATE(17775), 1,
      aux_sym_exp_record_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545375] = 3,
    ACTIONS(26219), 1,
      sym_quasiquote_body,
    ACTIONS(26217), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545389] = 3,
    ACTIONS(26221), 1,
      anon_sym_LBRACE,
    ACTIONS(26223), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545402] = 2,
    ACTIONS(26225), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545413] = 2,
    ACTIONS(20591), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545424] = 2,
    ACTIONS(14714), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545435] = 2,
    ACTIONS(26227), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545446] = 2,
    ACTIONS(14740), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545457] = 2,
    ACTIONS(14795), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545468] = 2,
    ACTIONS(14664), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545479] = 2,
    ACTIONS(14668), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545490] = 2,
    ACTIONS(14672), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545501] = 2,
    ACTIONS(14678), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545512] = 2,
    ACTIONS(14682), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545523] = 2,
    ACTIONS(14686), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545534] = 2,
    ACTIONS(14656), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545545] = 2,
    ACTIONS(26229), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545556] = 2,
    ACTIONS(26231), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545567] = 2,
    ACTIONS(14702), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545578] = 2,
    ACTIONS(26233), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545589] = 2,
    ACTIONS(14748), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545600] = 2,
    ACTIONS(14787), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545611] = 2,
    ACTIONS(14824), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545622] = 2,
    ACTIONS(13158), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545633] = 2,
    ACTIONS(19510), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545644] = 2,
    ACTIONS(26235), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545655] = 2,
    ACTIONS(26187), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545666] = 2,
    ACTIONS(14690), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545677] = 2,
    ACTIONS(14694), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545688] = 2,
    ACTIONS(26237), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545699] = 2,
    ACTIONS(14698), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545710] = 2,
    ACTIONS(26217), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545721] = 2,
    ACTIONS(14690), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545732] = 2,
    ACTIONS(21833), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545743] = 2,
    ACTIONS(13158), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545754] = 2,
    ACTIONS(26239), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545765] = 2,
    ACTIONS(19024), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545776] = 2,
    ACTIONS(14824), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545787] = 2,
    ACTIONS(14787), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545798] = 2,
    ACTIONS(14748), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545809] = 2,
    ACTIONS(14702), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545820] = 2,
    ACTIONS(26139), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545831] = 3,
    ACTIONS(18418), 1,
      anon_sym_EQ,
    STATE(17205), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545844] = 2,
    ACTIONS(14656), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545855] = 2,
    ACTIONS(14698), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545866] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19504), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545879] = 2,
    ACTIONS(26241), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545890] = 2,
    ACTIONS(14694), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545901] = 3,
    ACTIONS(26243), 1,
      anon_sym_SEMI,
    ACTIONS(26245), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545914] = 2,
    ACTIONS(14682), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545925] = 2,
    ACTIONS(14678), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545936] = 2,
    ACTIONS(14672), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545947] = 2,
    ACTIONS(14668), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545958] = 2,
    ACTIONS(26247), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545969] = 2,
    ACTIONS(14664), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545980] = 2,
    ACTIONS(14795), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [545991] = 2,
    ACTIONS(14686), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546002] = 2,
    ACTIONS(14714), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546013] = 2,
    ACTIONS(14740), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546024] = 2,
    ACTIONS(14064), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546035] = 2,
    ACTIONS(26103), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546046] = 2,
    ACTIONS(13684), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546057] = 2,
    ACTIONS(14257), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546068] = 2,
    ACTIONS(14271), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546079] = 2,
    ACTIONS(26249), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546090] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26251), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546103] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26253), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546116] = 2,
    ACTIONS(14251), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546127] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26255), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546140] = 2,
    ACTIONS(14191), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546151] = 2,
    ACTIONS(26257), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546162] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26259), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546175] = 2,
    ACTIONS(13776), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546186] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26261), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546199] = 2,
    ACTIONS(14187), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546210] = 2,
    ACTIONS(26263), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546221] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26265), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546234] = 2,
    ACTIONS(26065), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546245] = 2,
    ACTIONS(14060), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546256] = 2,
    ACTIONS(20923), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546267] = 2,
    ACTIONS(15574), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546278] = 3,
    ACTIONS(26267), 1,
      anon_sym_SEMI,
    ACTIONS(26269), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546291] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26271), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546304] = 2,
    ACTIONS(13740), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546315] = 2,
    ACTIONS(15578), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546326] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26273), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546339] = 2,
    ACTIONS(14267), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546350] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26275), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546363] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26277), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546376] = 2,
    ACTIONS(26051), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546387] = 2,
    ACTIONS(14478), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546398] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26279), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546411] = 3,
    ACTIONS(26281), 1,
      anon_sym_import,
    ACTIONS(26283), 1,
      anon_sym_export,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546424] = 2,
    ACTIONS(26285), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546435] = 2,
    ACTIONS(26287), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546446] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26289), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546459] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26291), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546472] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26293), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546485] = 2,
    ACTIONS(13891), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546496] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26295), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546509] = 3,
    ACTIONS(26297), 1,
      anon_sym_in,
    STATE(12427), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546522] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26299), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546535] = 3,
    ACTIONS(26301), 1,
      anon_sym_LBRACE,
    ACTIONS(26303), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546548] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26305), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546561] = 2,
    ACTIONS(26307), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546572] = 2,
    ACTIONS(13721), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546583] = 2,
    ACTIONS(26309), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546594] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26311), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546607] = 2,
    ACTIONS(26313), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546618] = 2,
    ACTIONS(21773), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546629] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26315), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546642] = 2,
    ACTIONS(26317), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546653] = 2,
    ACTIONS(14111), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546664] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26319), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546677] = 2,
    ACTIONS(21755), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546688] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26321), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546701] = 3,
    ACTIONS(26323), 1,
      sym__immediate_varid,
    STATE(5486), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546714] = 3,
    ACTIONS(26325), 1,
      anon_sym_in,
    STATE(10392), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546727] = 2,
    ACTIONS(21119), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546738] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26327), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546751] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26329), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546764] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26331), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546777] = 2,
    ACTIONS(26333), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546788] = 2,
    ACTIONS(25992), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546799] = 2,
    ACTIONS(26335), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546810] = 3,
    ACTIONS(26337), 1,
      anon_sym_SEMI,
    ACTIONS(26339), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546823] = 2,
    ACTIONS(21755), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546834] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26341), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546847] = 2,
    ACTIONS(18715), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546858] = 3,
    ACTIONS(26343), 1,
      anon_sym_in,
    STATE(12075), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546871] = 2,
    ACTIONS(26345), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546882] = 3,
    ACTIONS(26347), 1,
      anon_sym_SEMI,
    ACTIONS(26349), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546895] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26351), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546908] = 2,
    ACTIONS(26353), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546919] = 2,
    ACTIONS(26355), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546930] = 3,
    ACTIONS(26357), 1,
      anon_sym_SEMI,
    ACTIONS(26359), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546943] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26361), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546956] = 3,
    ACTIONS(26363), 1,
      anon_sym_SEMI,
    ACTIONS(26365), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546969] = 2,
    ACTIONS(25952), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546980] = 2,
    ACTIONS(21149), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [546991] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26367), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547004] = 3,
    ACTIONS(26369), 1,
      anon_sym_SEMI,
    ACTIONS(26371), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547017] = 2,
    ACTIONS(26373), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547028] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26375), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547041] = 3,
    ACTIONS(26377), 1,
      anon_sym_SEMI,
    ACTIONS(26379), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547054] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26381), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547067] = 2,
    ACTIONS(18117), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547078] = 2,
    ACTIONS(25966), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547089] = 3,
    ACTIONS(26383), 1,
      anon_sym_SEMI,
    ACTIONS(26385), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547102] = 3,
    ACTIONS(26387), 1,
      sym__immediate_varid,
    STATE(10487), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547115] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26389), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547128] = 2,
    ACTIONS(26391), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547139] = 3,
    ACTIONS(26393), 1,
      anon_sym_SEMI,
    ACTIONS(26395), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547152] = 3,
    ACTIONS(18308), 1,
      anon_sym_instance,
    STATE(16650), 1,
      sym__instance,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547165] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26397), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547178] = 2,
    ACTIONS(21219), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547189] = 3,
    ACTIONS(26399), 1,
      anon_sym_SEMI,
    ACTIONS(26401), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547202] = 2,
    ACTIONS(26403), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547213] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26405), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547226] = 3,
    ACTIONS(26407), 1,
      anon_sym_SEMI,
    ACTIONS(26409), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547239] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26411), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547252] = 3,
    ACTIONS(26413), 1,
      anon_sym_in,
    STATE(9569), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547265] = 2,
    ACTIONS(26415), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547276] = 3,
    ACTIONS(26417), 1,
      sym__immediate_varid,
    STATE(11643), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547289] = 3,
    ACTIONS(26419), 1,
      anon_sym_SEMI,
    ACTIONS(26421), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547302] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26423), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547315] = 2,
    ACTIONS(25924), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547326] = 2,
    ACTIONS(19981), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547337] = 3,
    ACTIONS(26425), 1,
      anon_sym_SEMI,
    ACTIONS(26427), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547350] = 3,
    ACTIONS(26429), 1,
      sym__immediate_varid,
    STATE(15621), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547363] = 2,
    ACTIONS(25988), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547374] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26431), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547387] = 3,
    ACTIONS(26433), 1,
      anon_sym_SEMI,
    ACTIONS(26435), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547400] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26437), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547413] = 3,
    ACTIONS(26439), 1,
      anon_sym_SEMI,
    ACTIONS(26441), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547426] = 3,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(14633), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547439] = 2,
    ACTIONS(25908), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547450] = 2,
    ACTIONS(26443), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547461] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26445), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547474] = 3,
    ACTIONS(26447), 1,
      anon_sym_SEMI,
    ACTIONS(26449), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547487] = 2,
    ACTIONS(26451), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547498] = 3,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(14619), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547511] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26453), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547524] = 3,
    ACTIONS(26455), 1,
      anon_sym_SEMI,
    ACTIONS(26457), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547537] = 3,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(14653), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547550] = 2,
    ACTIONS(26459), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547561] = 2,
    ACTIONS(26461), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547572] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26463), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547585] = 3,
    ACTIONS(26465), 1,
      anon_sym_SEMI,
    ACTIONS(26467), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547598] = 3,
    ACTIONS(26469), 1,
      anon_sym_SEMI,
    ACTIONS(26471), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547611] = 3,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(14720), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547624] = 2,
    ACTIONS(26473), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547635] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26475), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547648] = 3,
    ACTIONS(26477), 1,
      anon_sym_SEMI,
    ACTIONS(26479), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547661] = 3,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(14744), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547674] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26481), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547687] = 3,
    ACTIONS(26483), 1,
      anon_sym_SEMI,
    ACTIONS(26485), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547700] = 2,
    ACTIONS(26487), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547711] = 3,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(14798), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547724] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26489), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547737] = 3,
    ACTIONS(26491), 1,
      anon_sym_SEMI,
    ACTIONS(26493), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547750] = 2,
    ACTIONS(25850), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547761] = 3,
    ACTIONS(26495), 1,
      sym__immediate_varid,
    STATE(12045), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547774] = 3,
    ACTIONS(26497), 1,
      anon_sym_SEMI,
    ACTIONS(26499), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547787] = 3,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(19665), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547800] = 2,
    ACTIONS(25866), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547811] = 3,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(16305), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547824] = 3,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(14790), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547837] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26501), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547850] = 2,
    ACTIONS(26503), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547861] = 3,
    ACTIONS(17226), 1,
      sym_where,
    STATE(18129), 1,
      sym__gadt_rhs,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547874] = 3,
    ACTIONS(26505), 1,
      anon_sym_SEMI,
    ACTIONS(26507), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547887] = 3,
    ACTIONS(26509), 1,
      anon_sym_import,
    ACTIONS(26511), 1,
      anon_sym_export,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547900] = 3,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(19591), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547913] = 3,
    ACTIONS(425), 1,
      sym__consym,
    STATE(19590), 1,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547926] = 3,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(16364), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547939] = 2,
    ACTIONS(26513), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547950] = 3,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(14937), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547963] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26515), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547976] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19738), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [547989] = 2,
    ACTIONS(26517), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548000] = 3,
    ACTIONS(26519), 1,
      anon_sym_SEMI,
    ACTIONS(26521), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548013] = 3,
    ACTIONS(26523), 1,
      anon_sym_import,
    ACTIONS(26525), 1,
      anon_sym_export,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548026] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(26527), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548039] = 3,
    ACTIONS(18418), 1,
      anon_sym_EQ,
    STATE(16390), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548052] = 2,
    ACTIONS(26529), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548063] = 2,
    ACTIONS(26531), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548074] = 3,
    ACTIONS(26533), 1,
      anon_sym_SEMI,
    ACTIONS(26535), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548087] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(26537), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548100] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26539), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548113] = 2,
    ACTIONS(26541), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548124] = 2,
    ACTIONS(26543), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548135] = 2,
    ACTIONS(21597), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548146] = 3,
    ACTIONS(26545), 1,
      anon_sym_SEMI,
    ACTIONS(26547), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548159] = 2,
    ACTIONS(25812), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548170] = 2,
    ACTIONS(20678), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548181] = 2,
    ACTIONS(20989), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548192] = 3,
    ACTIONS(18458), 1,
      anon_sym_instance,
    STATE(15744), 1,
      sym__instance,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548205] = 2,
    ACTIONS(26549), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548216] = 3,
    ACTIONS(26551), 1,
      anon_sym_SEMI,
    ACTIONS(26553), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548229] = 2,
    ACTIONS(20500), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548240] = 2,
    ACTIONS(26555), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548251] = 2,
    ACTIONS(21335), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548262] = 2,
    ACTIONS(21167), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548273] = 3,
    ACTIONS(26557), 1,
      sym__immediate_varid,
    STATE(9649), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548286] = 3,
    ACTIONS(18513), 1,
      anon_sym_EQ,
    STATE(18331), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548299] = 2,
    ACTIONS(26559), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548310] = 2,
    ACTIONS(21709), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548321] = 2,
    ACTIONS(25778), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548332] = 2,
    ACTIONS(26561), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548343] = 3,
    ACTIONS(26563), 1,
      sym__immediate_varid,
    STATE(11064), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548356] = 2,
    ACTIONS(19961), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548367] = 3,
    ACTIONS(26565), 1,
      sym__immediate_varid,
    STATE(5706), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548380] = 2,
    ACTIONS(26035), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548391] = 2,
    ACTIONS(21473), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548402] = 2,
    ACTIONS(20481), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548413] = 2,
    ACTIONS(26567), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548424] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(26569), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548437] = 3,
    ACTIONS(18513), 1,
      anon_sym_EQ,
    STATE(18222), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548450] = 2,
    ACTIONS(26571), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548461] = 2,
    ACTIONS(22231), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548472] = 3,
    ACTIONS(16885), 1,
      sym__varid,
    STATE(20714), 1,
      sym_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548485] = 2,
    ACTIONS(19981), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548496] = 2,
    ACTIONS(25756), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548507] = 2,
    ACTIONS(26573), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548518] = 3,
    ACTIONS(26575), 1,
      anon_sym_LBRACE,
    ACTIONS(26577), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548531] = 2,
    ACTIONS(18927), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548542] = 2,
    ACTIONS(26579), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548553] = 2,
    ACTIONS(22259), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548564] = 2,
    ACTIONS(21345), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548575] = 2,
    ACTIONS(26581), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548586] = 2,
    ACTIONS(19398), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548597] = 2,
    ACTIONS(21277), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548608] = 2,
    ACTIONS(21485), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548619] = 2,
    ACTIONS(21267), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548630] = 2,
    ACTIONS(26583), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548641] = 3,
    ACTIONS(26585), 1,
      anon_sym_in,
    STATE(10625), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548654] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26587), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548667] = 2,
    ACTIONS(26589), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548678] = 2,
    ACTIONS(22373), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548689] = 2,
    ACTIONS(18601), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548700] = 2,
    ACTIONS(26591), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548711] = 2,
    ACTIONS(21531), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548722] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19931), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548735] = 2,
    ACTIONS(25706), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548746] = 3,
    ACTIONS(18434), 1,
      anon_sym_instance,
    STATE(17921), 1,
      sym__instance,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548759] = 3,
    ACTIONS(26593), 1,
      sym__immediate_varid,
    STATE(4185), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548772] = 2,
    ACTIONS(26595), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548783] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(26597), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548796] = 2,
    ACTIONS(26599), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548807] = 3,
    ACTIONS(26601), 1,
      sym__immediate_varid,
    STATE(5468), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548820] = 3,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(15382), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548833] = 2,
    ACTIONS(25702), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548844] = 3,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20038), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548857] = 2,
    ACTIONS(26603), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548868] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(26605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548881] = 2,
    ACTIONS(26607), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548892] = 2,
    ACTIONS(21509), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548903] = 2,
    ACTIONS(26609), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548914] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19512), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548927] = 3,
    ACTIONS(18513), 1,
      anon_sym_EQ,
    STATE(18124), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548940] = 2,
    ACTIONS(22407), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548951] = 2,
    ACTIONS(20051), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548962] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(26611), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548975] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26613), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548988] = 2,
    ACTIONS(26615), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [548999] = 2,
    ACTIONS(26617), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549010] = 2,
    ACTIONS(26619), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549021] = 3,
    ACTIONS(19291), 1,
      anon_sym_RPAREN,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549034] = 2,
    ACTIONS(18591), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549045] = 3,
    ACTIONS(26621), 1,
      anon_sym_SEMI,
    ACTIONS(26623), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549058] = 2,
    ACTIONS(18927), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549069] = 2,
    ACTIONS(22499), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549080] = 2,
    ACTIONS(26625), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549091] = 3,
    ACTIONS(26627), 1,
      anon_sym_SEMI,
    ACTIONS(26629), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549104] = 2,
    ACTIONS(26631), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549115] = 3,
    ACTIONS(26633), 1,
      sym__immediate_varid,
    STATE(3761), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549128] = 2,
    ACTIONS(22517), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549139] = 2,
    ACTIONS(22519), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549150] = 2,
    ACTIONS(24208), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549161] = 2,
    ACTIONS(24210), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549172] = 2,
    ACTIONS(25654), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549183] = 2,
    ACTIONS(21847), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549194] = 3,
    ACTIONS(18060), 1,
      anon_sym_EQ,
    STATE(16110), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549207] = 2,
    ACTIONS(22499), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549218] = 2,
    ACTIONS(26635), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549229] = 2,
    ACTIONS(25634), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549240] = 2,
    ACTIONS(20861), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549251] = 3,
    ACTIONS(26637), 1,
      sym__immediate_varid,
    STATE(17162), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549264] = 2,
    ACTIONS(26639), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549275] = 3,
    ACTIONS(26641), 1,
      anon_sym_LBRACE,
    ACTIONS(26643), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549288] = 2,
    ACTIONS(24238), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549299] = 2,
    ACTIONS(26645), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549310] = 2,
    ACTIONS(21735), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549321] = 3,
    ACTIONS(16632), 1,
      sym_where,
    STATE(16118), 1,
      sym__gadt_rhs,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549334] = 2,
    ACTIONS(24242), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549345] = 2,
    ACTIONS(26647), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549356] = 3,
    ACTIONS(26649), 1,
      sym__immediate_varid,
    STATE(11465), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549369] = 2,
    ACTIONS(26651), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549380] = 3,
    ACTIONS(26653), 1,
      sym__immediate_varid,
    STATE(17076), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549393] = 3,
    ACTIONS(26655), 1,
      anon_sym_LBRACE,
    ACTIONS(26657), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549406] = 2,
    ACTIONS(26659), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549417] = 2,
    ACTIONS(26661), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549428] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(26663), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549441] = 3,
    ACTIONS(26665), 1,
      sym__immediate_varid,
    STATE(16982), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549454] = 3,
    ACTIONS(26667), 1,
      anon_sym_LBRACE,
    ACTIONS(26669), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549467] = 2,
    ACTIONS(18936), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549478] = 2,
    ACTIONS(22561), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549489] = 2,
    ACTIONS(26671), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549500] = 2,
    ACTIONS(25593), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549511] = 2,
    ACTIONS(25598), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549522] = 2,
    ACTIONS(26673), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549533] = 3,
    ACTIONS(26675), 1,
      anon_sym_in,
    STATE(9714), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549546] = 2,
    ACTIONS(24341), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549557] = 2,
    ACTIONS(26677), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549568] = 3,
    ACTIONS(26679), 1,
      sym__immediate_varid,
    STATE(16887), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549581] = 3,
    ACTIONS(26681), 1,
      anon_sym_LBRACE,
    ACTIONS(26683), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549594] = 2,
    ACTIONS(24357), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549605] = 2,
    ACTIONS(22577), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549616] = 2,
    ACTIONS(24367), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549627] = 2,
    ACTIONS(21841), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549638] = 2,
    ACTIONS(25557), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549649] = 2,
    ACTIONS(24369), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549660] = 3,
    ACTIONS(26685), 1,
      sym__immediate_varid,
    STATE(16792), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549673] = 3,
    ACTIONS(26687), 1,
      anon_sym_LBRACE,
    ACTIONS(26689), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549686] = 2,
    ACTIONS(26691), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549697] = 2,
    ACTIONS(19744), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549708] = 2,
    ACTIONS(26693), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549719] = 3,
    ACTIONS(26695), 1,
      sym__immediate_varid,
    STATE(4070), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549732] = 2,
    ACTIONS(26697), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549743] = 3,
    ACTIONS(26699), 1,
      sym__immediate_varid,
    STATE(16697), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549756] = 3,
    ACTIONS(26701), 1,
      anon_sym_LBRACE,
    ACTIONS(26703), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549769] = 2,
    ACTIONS(22627), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549780] = 2,
    ACTIONS(19673), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549791] = 2,
    ACTIONS(26705), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549802] = 3,
    ACTIONS(26707), 1,
      sym__immediate_varid,
    STATE(16602), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549815] = 3,
    ACTIONS(26709), 1,
      anon_sym_LBRACE,
    ACTIONS(26711), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549828] = 3,
    ACTIONS(26713), 1,
      sym__immediate_varid,
    STATE(5103), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549841] = 2,
    ACTIONS(22631), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549852] = 2,
    ACTIONS(25539), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549863] = 2,
    ACTIONS(26715), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549874] = 2,
    ACTIONS(26717), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549885] = 2,
    ACTIONS(24440), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549896] = 2,
    ACTIONS(26719), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549907] = 3,
    ACTIONS(26721), 1,
      sym__immediate_varid,
    STATE(16507), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549920] = 2,
    ACTIONS(26723), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549931] = 2,
    ACTIONS(21982), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549942] = 3,
    ACTIONS(26725), 1,
      anon_sym_LBRACE,
    ACTIONS(26727), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549955] = 2,
    ACTIONS(20760), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549966] = 2,
    ACTIONS(24608), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549977] = 2,
    ACTIONS(21909), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [549988] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26729), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550001] = 3,
    ACTIONS(26731), 1,
      sym__immediate_varid,
    STATE(16412), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550014] = 3,
    ACTIONS(26733), 1,
      sym__immediate_varid,
    STATE(4472), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550027] = 2,
    ACTIONS(26735), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550038] = 3,
    ACTIONS(26737), 1,
      anon_sym_LBRACE,
    ACTIONS(26739), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550051] = 2,
    ACTIONS(26741), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550062] = 2,
    ACTIONS(26743), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550073] = 2,
    ACTIONS(26745), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550084] = 2,
    ACTIONS(22701), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550095] = 3,
    ACTIONS(26747), 1,
      sym__immediate_varid,
    STATE(16317), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550108] = 3,
    ACTIONS(26749), 1,
      anon_sym_LBRACE,
    ACTIONS(26751), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550121] = 2,
    ACTIONS(24716), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550132] = 2,
    ACTIONS(26753), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550143] = 2,
    ACTIONS(25448), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550154] = 3,
    ACTIONS(26755), 1,
      anon_sym_SEMI,
    ACTIONS(26757), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550167] = 2,
    ACTIONS(24768), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550178] = 2,
    ACTIONS(25485), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550189] = 2,
    ACTIONS(25503), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550200] = 3,
    ACTIONS(26759), 1,
      sym__immediate_varid,
    STATE(16222), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550213] = 2,
    ACTIONS(24768), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550224] = 3,
    ACTIONS(26761), 1,
      anon_sym_LBRACE,
    ACTIONS(26763), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550237] = 2,
    ACTIONS(26765), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550248] = 3,
    ACTIONS(26767), 1,
      anon_sym_SEMI,
    ACTIONS(26769), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550261] = 2,
    ACTIONS(24772), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550272] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(26771), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550285] = 2,
    ACTIONS(24436), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550296] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19345), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550309] = 3,
    ACTIONS(26773), 1,
      anon_sym_LBRACE,
    ACTIONS(26775), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550322] = 3,
    ACTIONS(26777), 1,
      sym__immediate_varid,
    STATE(16127), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550335] = 2,
    ACTIONS(19955), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550346] = 2,
    ACTIONS(26779), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550357] = 3,
    ACTIONS(26781), 1,
      anon_sym_LBRACE,
    ACTIONS(26783), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550370] = 2,
    ACTIONS(26785), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550381] = 2,
    ACTIONS(24784), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550392] = 2,
    ACTIONS(26787), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550403] = 3,
    ACTIONS(26789), 1,
      sym__immediate_varid,
    STATE(5697), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550416] = 3,
    ACTIONS(26791), 1,
      anon_sym_SEMI,
    ACTIONS(26793), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550429] = 3,
    ACTIONS(26795), 1,
      sym__immediate_varid,
    STATE(16032), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550442] = 2,
    ACTIONS(26797), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550453] = 3,
    ACTIONS(26799), 1,
      anon_sym_LBRACE,
    ACTIONS(26801), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550466] = 3,
    ACTIONS(26803), 1,
      anon_sym_in,
    STATE(11881), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550479] = 2,
    ACTIONS(24823), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550490] = 3,
    ACTIONS(26805), 1,
      anon_sym_in,
    STATE(12400), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550503] = 2,
    ACTIONS(26807), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550514] = 2,
    ACTIONS(16107), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550525] = 2,
    ACTIONS(26809), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550536] = 2,
    ACTIONS(25444), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550547] = 2,
    ACTIONS(24886), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550558] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26811), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550571] = 3,
    ACTIONS(26813), 1,
      sym__immediate_varid,
    STATE(15937), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550584] = 2,
    ACTIONS(26815), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550595] = 3,
    ACTIONS(26817), 1,
      anon_sym_LBRACE,
    ACTIONS(26819), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550608] = 3,
    ACTIONS(26821), 1,
      anon_sym_SEMI,
    ACTIONS(26823), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550621] = 2,
    ACTIONS(22046), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550632] = 3,
    ACTIONS(26825), 1,
      sym__immediate_varid,
    STATE(3839), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550645] = 2,
    ACTIONS(26827), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550656] = 2,
    ACTIONS(25412), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550667] = 2,
    ACTIONS(20786), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550678] = 3,
    ACTIONS(26829), 1,
      sym__immediate_varid,
    STATE(15842), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550691] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(26831), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550704] = 3,
    ACTIONS(26833), 1,
      anon_sym_LBRACE,
    ACTIONS(26835), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550717] = 2,
    ACTIONS(26837), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550728] = 2,
    ACTIONS(26839), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550739] = 2,
    ACTIONS(20767), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550750] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26841), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550763] = 3,
    ACTIONS(26843), 1,
      sym__immediate_varid,
    STATE(15747), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550776] = 2,
    ACTIONS(26845), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550787] = 2,
    ACTIONS(26847), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550798] = 3,
    ACTIONS(26849), 1,
      anon_sym_LBRACE,
    ACTIONS(26851), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550811] = 2,
    ACTIONS(19536), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550822] = 2,
    ACTIONS(26853), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550833] = 3,
    ACTIONS(26855), 1,
      anon_sym_SEMI,
    ACTIONS(26857), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550846] = 3,
    ACTIONS(26859), 1,
      sym__immediate_varid,
    STATE(15652), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550859] = 3,
    ACTIONS(26861), 1,
      anon_sym_LBRACE,
    ACTIONS(26863), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550872] = 2,
    ACTIONS(25399), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550883] = 2,
    ACTIONS(25408), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550894] = 2,
    ACTIONS(25235), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550905] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19384), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550918] = 3,
    ACTIONS(26865), 1,
      sym__immediate_varid,
    STATE(18494), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550931] = 2,
    ACTIONS(26867), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550942] = 2,
    ACTIONS(22775), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550953] = 2,
    ACTIONS(26869), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550964] = 3,
    ACTIONS(26871), 1,
      sym__immediate_varid,
    STATE(15557), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550977] = 2,
    ACTIONS(22110), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [550988] = 3,
    ACTIONS(26873), 1,
      anon_sym_LBRACE,
    ACTIONS(26875), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551001] = 3,
    ACTIONS(26877), 1,
      sym__immediate_varid,
    STATE(11778), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551014] = 2,
    ACTIONS(26879), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551025] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26881), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551038] = 2,
    ACTIONS(26883), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551049] = 3,
    ACTIONS(26885), 1,
      sym__immediate_varid,
    STATE(15467), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551062] = 2,
    ACTIONS(26887), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551073] = 2,
    ACTIONS(26889), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551084] = 3,
    ACTIONS(26891), 1,
      anon_sym_LBRACE,
    ACTIONS(26893), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551097] = 2,
    ACTIONS(25854), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551108] = 2,
    ACTIONS(26895), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551119] = 3,
    ACTIONS(26897), 1,
      sym__immediate_varid,
    STATE(15538), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551132] = 2,
    ACTIONS(26899), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551143] = 3,
    ACTIONS(26901), 1,
      anon_sym_LBRACE,
    ACTIONS(26903), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551156] = 2,
    ACTIONS(25339), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551167] = 2,
    ACTIONS(26905), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551178] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(26907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551191] = 3,
    ACTIONS(26909), 1,
      anon_sym_SEMI,
    ACTIONS(26911), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551204] = 3,
    ACTIONS(26913), 1,
      anon_sym_SEMI,
    ACTIONS(26915), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551217] = 2,
    ACTIONS(26917), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551228] = 2,
    ACTIONS(25353), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551239] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(26919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551252] = 3,
    ACTIONS(26921), 1,
      sym__immediate_varid,
    STATE(15696), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551265] = 3,
    ACTIONS(26923), 1,
      anon_sym_LBRACE,
    ACTIONS(26925), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551278] = 2,
    ACTIONS(26927), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551289] = 2,
    ACTIONS(25116), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551300] = 2,
    ACTIONS(16103), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551311] = 3,
    ACTIONS(26929), 1,
      anon_sym_SEMI,
    ACTIONS(26931), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551324] = 2,
    ACTIONS(22689), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551335] = 2,
    ACTIONS(18893), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551346] = 3,
    ACTIONS(26933), 1,
      sym__immediate_varid,
    STATE(15927), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551359] = 3,
    ACTIONS(26935), 1,
      anon_sym_in,
    STATE(11829), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551372] = 3,
    ACTIONS(26937), 1,
      anon_sym_LBRACE,
    ACTIONS(26939), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551385] = 2,
    ACTIONS(26941), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551396] = 3,
    ACTIONS(26943), 1,
      anon_sym_in,
    STATE(12650), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551409] = 2,
    ACTIONS(26945), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551420] = 2,
    ACTIONS(26111), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551431] = 3,
    ACTIONS(26947), 1,
      sym__immediate_varid,
    STATE(16106), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551444] = 3,
    ACTIONS(26949), 1,
      anon_sym_LBRACE,
    ACTIONS(26951), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551457] = 2,
    ACTIONS(22217), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551468] = 3,
    ACTIONS(26953), 1,
      sym__immediate_varid,
    STATE(4360), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551481] = 2,
    ACTIONS(26955), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551492] = 2,
    ACTIONS(26957), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551503] = 3,
    ACTIONS(26959), 1,
      sym__immediate_varid,
    STATE(16294), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551516] = 2,
    ACTIONS(26111), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551527] = 3,
    ACTIONS(26961), 1,
      anon_sym_LBRACE,
    ACTIONS(26963), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551540] = 2,
    ACTIONS(26965), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551551] = 2,
    ACTIONS(26173), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551562] = 2,
    ACTIONS(22285), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551573] = 2,
    ACTIONS(25297), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551584] = 2,
    ACTIONS(18739), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551595] = 2,
    ACTIONS(26157), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551606] = 2,
    ACTIONS(18905), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551617] = 2,
    ACTIONS(26967), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551628] = 3,
    ACTIONS(26969), 1,
      sym__immediate_varid,
    STATE(16384), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551641] = 2,
    ACTIONS(26971), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551652] = 2,
    ACTIONS(20208), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551663] = 3,
    ACTIONS(26973), 1,
      anon_sym_LBRACE,
    ACTIONS(26975), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551676] = 2,
    ACTIONS(26977), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551687] = 2,
    ACTIONS(18879), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551698] = 2,
    ACTIONS(26010), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551709] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(26979), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551722] = 2,
    ACTIONS(18561), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551733] = 3,
    ACTIONS(26981), 1,
      sym__immediate_varid,
    STATE(16718), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551746] = 2,
    ACTIONS(26983), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551757] = 3,
    ACTIONS(26985), 1,
      anon_sym_LBRACE,
    ACTIONS(26987), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551770] = 2,
    ACTIONS(25261), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551781] = 3,
    ACTIONS(21225), 1,
      sym_comma,
    STATE(15998), 1,
      aux_sym_type_list_repeat1,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551794] = 2,
    ACTIONS(18877), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551805] = 2,
    ACTIONS(22675), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551816] = 2,
    ACTIONS(25335), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551827] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26989), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551840] = 2,
    ACTIONS(22653), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551851] = 2,
    ACTIONS(20130), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551862] = 2,
    ACTIONS(26991), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551873] = 2,
    ACTIONS(16089), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551884] = 2,
    ACTIONS(22301), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551895] = 3,
    ACTIONS(26993), 1,
      sym__immediate_varid,
    STATE(16869), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551908] = 2,
    ACTIONS(25249), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551919] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(26995), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551932] = 3,
    ACTIONS(26997), 1,
      anon_sym_LBRACE,
    ACTIONS(26999), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551945] = 2,
    ACTIONS(27001), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551956] = 2,
    ACTIONS(27003), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551967] = 2,
    ACTIONS(27005), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551978] = 3,
    ACTIONS(27007), 1,
      sym__immediate_varid,
    STATE(11389), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [551991] = 2,
    ACTIONS(25688), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552002] = 3,
    ACTIONS(27009), 1,
      sym__immediate_varid,
    STATE(5277), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552015] = 3,
    ACTIONS(27011), 1,
      sym__immediate_varid,
    STATE(17116), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552028] = 3,
    ACTIONS(27013), 1,
      anon_sym_LBRACE,
    ACTIONS(27015), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552041] = 2,
    ACTIONS(27017), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552052] = 3,
    ACTIONS(27019), 1,
      anon_sym_SEMI,
    ACTIONS(27021), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552065] = 2,
    ACTIONS(19454), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552076] = 2,
    ACTIONS(27023), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552087] = 2,
    ACTIONS(27025), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552098] = 3,
    ACTIONS(27027), 1,
      anon_sym_SEMI,
    ACTIONS(27029), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552111] = 3,
    ACTIONS(27031), 1,
      anon_sym_SEMI,
    ACTIONS(27033), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552124] = 3,
    ACTIONS(27035), 1,
      sym__immediate_varid,
    STATE(17351), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552137] = 2,
    ACTIONS(27037), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552148] = 3,
    ACTIONS(27039), 1,
      anon_sym_LBRACE,
    ACTIONS(27041), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552161] = 3,
    ACTIONS(27043), 1,
      anon_sym_in,
    STATE(12148), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552174] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27045), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552187] = 2,
    ACTIONS(25191), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552198] = 2,
    ACTIONS(27047), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552209] = 3,
    ACTIONS(27049), 1,
      sym__immediate_varid,
    STATE(17627), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552222] = 2,
    ACTIONS(27051), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552233] = 3,
    ACTIONS(27053), 1,
      anon_sym_LBRACE,
    ACTIONS(27055), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552246] = 2,
    ACTIONS(27057), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552257] = 2,
    ACTIONS(25203), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552268] = 2,
    ACTIONS(27059), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552279] = 2,
    ACTIONS(22385), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552290] = 3,
    ACTIONS(27061), 1,
      sym__immediate_varid,
    STATE(9968), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552303] = 2,
    ACTIONS(27063), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552314] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19500), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552327] = 3,
    ACTIONS(27065), 1,
      sym__immediate_varid,
    STATE(17742), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552340] = 3,
    ACTIONS(27067), 1,
      anon_sym_LBRACE,
    ACTIONS(27069), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552353] = 2,
    ACTIONS(27071), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552364] = 2,
    ACTIONS(20487), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552375] = 3,
    ACTIONS(27073), 1,
      sym__immediate_varid,
    STATE(17550), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552388] = 2,
    ACTIONS(27075), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552399] = 3,
    ACTIONS(27077), 1,
      anon_sym_LBRACE,
    ACTIONS(27079), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552412] = 2,
    ACTIONS(22565), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552423] = 2,
    ACTIONS(22559), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552434] = 2,
    ACTIONS(27081), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552445] = 2,
    ACTIONS(24692), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552456] = 2,
    ACTIONS(24317), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552467] = 3,
    ACTIONS(27083), 1,
      sym__immediate_varid,
    STATE(17379), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552480] = 3,
    ACTIONS(27085), 1,
      anon_sym_LBRACE,
    ACTIONS(27087), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552493] = 2,
    ACTIONS(22479), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552504] = 2,
    ACTIONS(25463), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552515] = 2,
    ACTIONS(27089), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552526] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(27091), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552539] = 3,
    ACTIONS(27093), 1,
      sym__immediate_varid,
    STATE(9393), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552552] = 2,
    ACTIONS(27095), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552563] = 2,
    ACTIONS(27097), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552574] = 2,
    ACTIONS(27099), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552585] = 3,
    ACTIONS(27101), 1,
      sym__immediate_varid,
    STATE(17090), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552598] = 2,
    ACTIONS(25153), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552609] = 3,
    ACTIONS(27103), 1,
      anon_sym_LBRACE,
    ACTIONS(27105), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552622] = 2,
    ACTIONS(24692), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552633] = 3,
    ACTIONS(27107), 1,
      sym__immediate_varid,
    STATE(5220), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552646] = 2,
    ACTIONS(27109), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552657] = 3,
    ACTIONS(27111), 1,
      anon_sym_SEMI,
    ACTIONS(27113), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552670] = 2,
    ACTIONS(22537), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552681] = 2,
    ACTIONS(24132), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552692] = 3,
    ACTIONS(27115), 1,
      anon_sym_SEMI,
    ACTIONS(27117), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552705] = 3,
    ACTIONS(27119), 1,
      sym__immediate_varid,
    STATE(16825), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552718] = 2,
    ACTIONS(24882), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552729] = 3,
    ACTIONS(16879), 1,
      sym__varid,
    STATE(17054), 1,
      sym_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552742] = 3,
    ACTIONS(27121), 1,
      anon_sym_LBRACE,
    ACTIONS(27123), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552755] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19752), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552768] = 3,
    ACTIONS(27125), 1,
      anon_sym_in,
    STATE(12424), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552781] = 2,
    ACTIONS(27127), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552792] = 2,
    ACTIONS(22635), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552803] = 2,
    ACTIONS(22515), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552814] = 2,
    ACTIONS(22507), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552825] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27129), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552838] = 3,
    ACTIONS(27131), 1,
      sym__immediate_varid,
    STATE(16586), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552851] = 2,
    ACTIONS(27133), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552862] = 3,
    ACTIONS(27135), 1,
      anon_sym_LBRACE,
    ACTIONS(27137), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552875] = 2,
    ACTIONS(27139), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552886] = 2,
    ACTIONS(22573), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552897] = 2,
    ACTIONS(27141), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552908] = 3,
    ACTIONS(27143), 1,
      sym__immediate_varid,
    STATE(9883), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552921] = 2,
    ACTIONS(27145), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552932] = 3,
    ACTIONS(27147), 1,
      sym__immediate_varid,
    STATE(16482), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552945] = 2,
    ACTIONS(25090), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552956] = 2,
    ACTIONS(20804), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552967] = 3,
    ACTIONS(27149), 1,
      anon_sym_LBRACE,
    ACTIONS(27151), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552980] = 2,
    ACTIONS(27153), 2,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [552991] = 2,
    ACTIONS(27155), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553002] = 2,
    ACTIONS(22483), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553013] = 2,
    ACTIONS(22447), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553024] = 2,
    ACTIONS(18873), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553035] = 2,
    ACTIONS(18968), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553046] = 2,
    ACTIONS(27157), 2,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553057] = 2,
    ACTIONS(18861), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553068] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19542), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553081] = 2,
    ACTIONS(27159), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553092] = 3,
    ACTIONS(27161), 1,
      sym__immediate_varid,
    STATE(16261), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553105] = 3,
    ACTIONS(27163), 1,
      anon_sym_LBRACE,
    ACTIONS(27165), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553118] = 2,
    ACTIONS(27167), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553129] = 2,
    ACTIONS(18849), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553140] = 2,
    ACTIONS(18847), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553151] = 3,
    ACTIONS(27169), 1,
      sym__immediate_varid,
    STATE(15088), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553164] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(27171), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553177] = 3,
    ACTIONS(27173), 1,
      sym__immediate_varid,
    STATE(5262), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553190] = 2,
    ACTIONS(27175), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553201] = 2,
    ACTIONS(25037), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553212] = 2,
    ACTIONS(22363), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553223] = 2,
    ACTIONS(25064), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553234] = 3,
    ACTIONS(27177), 1,
      anon_sym_SEMI,
    ACTIONS(27179), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553247] = 3,
    ACTIONS(27181), 1,
      sym__immediate_varid,
    STATE(16167), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553260] = 2,
    ACTIONS(24977), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553271] = 3,
    ACTIONS(27183), 1,
      anon_sym_LBRACE,
    ACTIONS(27185), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553284] = 2,
    ACTIONS(25045), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553295] = 2,
    ACTIONS(22671), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553306] = 3,
    ACTIONS(27187), 1,
      anon_sym_SEMI,
    ACTIONS(27189), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553319] = 2,
    ACTIONS(18739), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553330] = 2,
    ACTIONS(27191), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553341] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553354] = 3,
    ACTIONS(27195), 1,
      anon_sym_SEMI,
    ACTIONS(27197), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553367] = 3,
    ACTIONS(27199), 1,
      sym__immediate_varid,
    STATE(5158), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553380] = 2,
    ACTIONS(27201), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553391] = 3,
    ACTIONS(27203), 1,
      anon_sym_SEMI,
    ACTIONS(27205), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553404] = 3,
    ACTIONS(27207), 1,
      sym__immediate_varid,
    STATE(16089), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553417] = 3,
    ACTIONS(27209), 1,
      anon_sym_LBRACE,
    ACTIONS(27211), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553430] = 2,
    ACTIONS(27213), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553441] = 2,
    ACTIONS(27215), 2,
      sym__immediate_dot,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553452] = 2,
    ACTIONS(20275), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553463] = 2,
    ACTIONS(27217), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553474] = 2,
    ACTIONS(27219), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553485] = 3,
    ACTIONS(27221), 1,
      anon_sym_in,
    STATE(11966), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553498] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553511] = 2,
    ACTIONS(19963), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553522] = 3,
    ACTIONS(27225), 1,
      sym__immediate_varid,
    STATE(15980), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553535] = 2,
    ACTIONS(27227), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553546] = 3,
    ACTIONS(27229), 1,
      anon_sym_LBRACE,
    ACTIONS(27231), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553559] = 2,
    ACTIONS(27233), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553570] = 3,
    ACTIONS(13614), 1,
      sym__varid,
    STATE(17267), 1,
      sym_type_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553583] = 2,
    ACTIONS(22122), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553594] = 2,
    ACTIONS(22337), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553605] = 3,
    ACTIONS(27235), 1,
      anon_sym_in,
    STATE(12006), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553618] = 2,
    ACTIONS(24958), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553629] = 2,
    ACTIONS(24983), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553640] = 3,
    ACTIONS(27237), 1,
      sym__immediate_varid,
    STATE(9499), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553653] = 2,
    ACTIONS(27239), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553664] = 2,
    ACTIONS(22751), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553675] = 2,
    ACTIONS(27241), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553686] = 2,
    ACTIONS(27243), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553697] = 2,
    ACTIONS(27245), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553708] = 2,
    ACTIONS(27247), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553719] = 3,
    ACTIONS(27249), 1,
      sym__immediate_varid,
    STATE(15900), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553732] = 3,
    ACTIONS(27251), 1,
      anon_sym_LBRACE,
    ACTIONS(27253), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553745] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553758] = 2,
    ACTIONS(22279), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553769] = 2,
    ACTIONS(27257), 2,
      sym__varid,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553780] = 2,
    ACTIONS(27259), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553791] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27261), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553804] = 2,
    ACTIONS(27263), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553815] = 2,
    ACTIONS(27265), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553826] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(27267), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553839] = 2,
    ACTIONS(27269), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553850] = 3,
    ACTIONS(27271), 1,
      sym__immediate_varid,
    STATE(15802), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553863] = 2,
    ACTIONS(27273), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553874] = 2,
    ACTIONS(23019), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553885] = 3,
    ACTIONS(27275), 1,
      anon_sym_LBRACE,
    ACTIONS(27277), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553898] = 2,
    ACTIONS(27279), 2,
      anon_sym_,
      anon_sym_EQ_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553909] = 2,
    ACTIONS(22835), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553920] = 3,
    ACTIONS(27281), 1,
      sym__immediate_varid,
    STATE(11032), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553933] = 3,
    ACTIONS(27283), 1,
      anon_sym_LBRACE,
    ACTIONS(27285), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553946] = 2,
    ACTIONS(27287), 2,
      anon_sym_2,
      anon_sym_DASH_GT,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553957] = 2,
    ACTIONS(27289), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553968] = 2,
    ACTIONS(24922), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553979] = 3,
    ACTIONS(27291), 1,
      sym__immediate_varid,
    STATE(10978), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [553992] = 2,
    ACTIONS(22199), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554003] = 3,
    ACTIONS(27293), 1,
      anon_sym_SEMI,
    ACTIONS(27295), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554016] = 2,
    ACTIONS(27297), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554027] = 2,
    ACTIONS(22894), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554038] = 2,
    ACTIONS(27299), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554049] = 2,
    ACTIONS(22186), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554060] = 2,
    ACTIONS(22166), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554071] = 3,
    ACTIONS(27301), 1,
      anon_sym_SEMI,
    ACTIONS(27303), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554084] = 3,
    ACTIONS(27305), 1,
      anon_sym_in,
    STATE(12205), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554097] = 2,
    ACTIONS(22975), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554108] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27307), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554121] = 3,
    ACTIONS(27309), 1,
      sym__immediate_varid,
    STATE(15646), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554134] = 3,
    ACTIONS(27311), 1,
      anon_sym_SEMI,
    ACTIONS(27313), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554147] = 2,
    ACTIONS(27315), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554158] = 3,
    ACTIONS(27317), 1,
      anon_sym_LBRACE,
    ACTIONS(27319), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554171] = 2,
    ACTIONS(22166), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554182] = 2,
    ACTIONS(19220), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554193] = 2,
    ACTIONS(27321), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554204] = 2,
    ACTIONS(27323), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554215] = 2,
    ACTIONS(22931), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554226] = 3,
    ACTIONS(27325), 1,
      anon_sym_SEMI,
    ACTIONS(27327), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554239] = 2,
    ACTIONS(22906), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554250] = 3,
    ACTIONS(27329), 1,
      sym__immediate_varid,
    STATE(5800), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554263] = 3,
    ACTIONS(27331), 1,
      anon_sym_SEMI,
    ACTIONS(27333), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554276] = 2,
    ACTIONS(27335), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554287] = 2,
    ACTIONS(22132), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554298] = 2,
    ACTIONS(25129), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554309] = 2,
    ACTIONS(24862), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554320] = 2,
    ACTIONS(22130), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554331] = 2,
    ACTIONS(27337), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554342] = 2,
    ACTIONS(18809), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554353] = 2,
    ACTIONS(27339), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554364] = 2,
    ACTIONS(22036), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554375] = 2,
    ACTIONS(22120), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554386] = 2,
    ACTIONS(22114), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554397] = 3,
    ACTIONS(27341), 1,
      anon_sym_LBRACE,
    ACTIONS(27343), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554410] = 3,
    ACTIONS(27345), 1,
      anon_sym_in,
    STATE(11029), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554423] = 2,
    ACTIONS(21996), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554434] = 2,
    ACTIONS(27347), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554445] = 3,
    ACTIONS(27349), 1,
      anon_sym_LBRACE,
    ACTIONS(27351), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554458] = 2,
    ACTIONS(27353), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554469] = 3,
    ACTIONS(27355), 1,
      anon_sym_SEMI,
    ACTIONS(27357), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554482] = 2,
    ACTIONS(27359), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554493] = 2,
    ACTIONS(27361), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554504] = 2,
    ACTIONS(21975), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554515] = 2,
    ACTIONS(21947), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554526] = 2,
    ACTIONS(21947), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554537] = 2,
    ACTIONS(24807), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554548] = 3,
    ACTIONS(27363), 1,
      anon_sym_SEMI,
    ACTIONS(27365), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554561] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19721), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554574] = 2,
    ACTIONS(22991), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554585] = 2,
    ACTIONS(24829), 2,
      sym_comma,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554596] = 2,
    ACTIONS(21947), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554607] = 3,
    ACTIONS(27367), 1,
      sym__immediate_varid,
    STATE(4688), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554620] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(27369), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554633] = 2,
    ACTIONS(27371), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554644] = 2,
    ACTIONS(24811), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554655] = 3,
    ACTIONS(27373), 1,
      sym__immediate_varid,
    STATE(15465), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554668] = 3,
    ACTIONS(27375), 1,
      anon_sym_LBRACE,
    ACTIONS(27377), 1,
      sym__layout_start,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554681] = 2,
    ACTIONS(27379), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554692] = 2,
    ACTIONS(27381), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554703] = 3,
    ACTIONS(27383), 1,
      anon_sym_SEMI,
    ACTIONS(27385), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554716] = 2,
    ACTIONS(27387), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554727] = 2,
    ACTIONS(19173), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554738] = 2,
    ACTIONS(27389), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554749] = 2,
    ACTIONS(23042), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554760] = 2,
    ACTIONS(24793), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554771] = 2,
    ACTIONS(27391), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554782] = 2,
    ACTIONS(27393), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554793] = 2,
    ACTIONS(23062), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554804] = 2,
    ACTIONS(27395), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554815] = 2,
    ACTIONS(27397), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554826] = 2,
    ACTIONS(21739), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554837] = 2,
    ACTIONS(27399), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554848] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27401), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554861] = 3,
    ACTIONS(27403), 1,
      anon_sym_in,
    STATE(12028), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554874] = 2,
    ACTIONS(21927), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554885] = 2,
    ACTIONS(27405), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554896] = 3,
    ACTIONS(27407), 1,
      anon_sym_SEMI,
    ACTIONS(27409), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554909] = 2,
    ACTIONS(27411), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554920] = 2,
    ACTIONS(16138), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554931] = 2,
    ACTIONS(23086), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554942] = 2,
    ACTIONS(27413), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554953] = 2,
    ACTIONS(27415), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554964] = 2,
    ACTIONS(27417), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554975] = 2,
    ACTIONS(24746), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554986] = 2,
    ACTIONS(23114), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [554997] = 3,
    ACTIONS(27419), 1,
      anon_sym_SEMI,
    ACTIONS(27421), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555010] = 2,
    ACTIONS(27423), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555021] = 2,
    ACTIONS(27425), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555032] = 2,
    ACTIONS(21923), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555043] = 2,
    ACTIONS(21921), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555054] = 2,
    ACTIONS(27427), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555065] = 2,
    ACTIONS(23142), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555076] = 2,
    ACTIONS(16071), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555087] = 2,
    ACTIONS(27429), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555098] = 2,
    ACTIONS(27431), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555109] = 3,
    ACTIONS(18418), 1,
      anon_sym_EQ,
    STATE(17782), 1,
      sym__newtype,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555122] = 2,
    ACTIONS(27433), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555133] = 2,
    ACTIONS(23164), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555144] = 2,
    ACTIONS(27435), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555155] = 2,
    ACTIONS(27437), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555166] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27439), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555179] = 2,
    ACTIONS(27441), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555190] = 2,
    ACTIONS(21901), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555201] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(27443), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555214] = 2,
    ACTIONS(27445), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555225] = 2,
    ACTIONS(23200), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555236] = 2,
    ACTIONS(27447), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555247] = 2,
    ACTIONS(23190), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555258] = 2,
    ACTIONS(27449), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555269] = 2,
    ACTIONS(23224), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555280] = 2,
    ACTIONS(24686), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555291] = 3,
    ACTIONS(27451), 1,
      sym__immediate_varid,
    STATE(10521), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555304] = 2,
    ACTIONS(24694), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555315] = 3,
    ACTIONS(27453), 1,
      anon_sym_SEMI,
    ACTIONS(27455), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555328] = 2,
    ACTIONS(27457), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555339] = 2,
    ACTIONS(27459), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555350] = 2,
    ACTIONS(27461), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555361] = 2,
    ACTIONS(27463), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555372] = 2,
    ACTIONS(23245), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555383] = 2,
    ACTIONS(27465), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555394] = 2,
    ACTIONS(21859), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555405] = 2,
    ACTIONS(27467), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555416] = 2,
    ACTIONS(21009), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555427] = 2,
    ACTIONS(27469), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555438] = 3,
    ACTIONS(27471), 1,
      sym__immediate_varid,
    STATE(10027), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555451] = 2,
    ACTIONS(23271), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555462] = 2,
    ACTIONS(27473), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555473] = 2,
    ACTIONS(27475), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555484] = 2,
    ACTIONS(21835), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555495] = 2,
    ACTIONS(24629), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555506] = 2,
    ACTIONS(27477), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555517] = 2,
    ACTIONS(19981), 2,
      anon_sym_3,
      anon_sym_LT_DASH,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555528] = 2,
    ACTIONS(23293), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555539] = 2,
    ACTIONS(24758), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555550] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555563] = 3,
    ACTIONS(27481), 1,
      anon_sym_in,
    STATE(12071), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555576] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27483), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555589] = 2,
    ACTIONS(27485), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555600] = 2,
    ACTIONS(27487), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555611] = 3,
    ACTIONS(27489), 1,
      sym__immediate_varid,
    STATE(11544), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555624] = 2,
    ACTIONS(27491), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555635] = 2,
    ACTIONS(24637), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555646] = 2,
    ACTIONS(23315), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555657] = 2,
    ACTIONS(27493), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555668] = 2,
    ACTIONS(27495), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555679] = 2,
    ACTIONS(27497), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555690] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27499), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555703] = 2,
    ACTIONS(27501), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555714] = 2,
    ACTIONS(23337), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555725] = 3,
    ACTIONS(27503), 1,
      sym__immediate_varid,
    STATE(4001), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555738] = 2,
    ACTIONS(27505), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555749] = 2,
    ACTIONS(21797), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555760] = 2,
    ACTIONS(27507), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555771] = 2,
    ACTIONS(24624), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555782] = 2,
    ACTIONS(27509), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555793] = 2,
    ACTIONS(23361), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555804] = 2,
    ACTIONS(27511), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555815] = 2,
    ACTIONS(21797), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555826] = 2,
    ACTIONS(21797), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555837] = 2,
    ACTIONS(27513), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555848] = 2,
    ACTIONS(27515), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555859] = 2,
    ACTIONS(23385), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555870] = 2,
    ACTIONS(23494), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555881] = 2,
    ACTIONS(23301), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555892] = 2,
    ACTIONS(27517), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555903] = 2,
    ACTIONS(24558), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555914] = 2,
    ACTIONS(27519), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555925] = 2,
    ACTIONS(21797), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555936] = 2,
    ACTIONS(21797), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555947] = 2,
    ACTIONS(27521), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555958] = 2,
    ACTIONS(24568), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555969] = 2,
    ACTIONS(23399), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555980] = 2,
    ACTIONS(21765), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [555991] = 2,
    ACTIONS(22016), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556002] = 2,
    ACTIONS(27523), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556013] = 2,
    ACTIONS(27525), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556024] = 2,
    ACTIONS(27527), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556035] = 2,
    ACTIONS(22008), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556046] = 2,
    ACTIONS(27529), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556057] = 2,
    ACTIONS(23417), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556068] = 3,
    ACTIONS(27531), 1,
      sym__immediate_varid,
    STATE(10676), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556081] = 2,
    ACTIONS(21765), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556092] = 2,
    ACTIONS(24547), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556103] = 2,
    ACTIONS(21763), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556114] = 2,
    ACTIONS(21765), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556125] = 2,
    ACTIONS(27533), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556136] = 2,
    ACTIONS(27535), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556147] = 2,
    ACTIONS(27537), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556158] = 2,
    ACTIONS(21745), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556169] = 2,
    ACTIONS(27539), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556180] = 2,
    ACTIONS(27541), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556191] = 2,
    ACTIONS(23437), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556202] = 2,
    ACTIONS(16071), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556213] = 2,
    ACTIONS(27543), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556224] = 2,
    ACTIONS(21745), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556235] = 2,
    ACTIONS(27545), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556246] = 2,
    ACTIONS(27547), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556257] = 2,
    ACTIONS(21763), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556268] = 2,
    ACTIONS(27549), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556279] = 2,
    ACTIONS(24502), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556290] = 2,
    ACTIONS(27551), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556301] = 2,
    ACTIONS(23468), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556312] = 2,
    ACTIONS(21743), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556323] = 2,
    ACTIONS(27553), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556334] = 2,
    ACTIONS(21691), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556345] = 2,
    ACTIONS(26717), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556356] = 2,
    ACTIONS(27555), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556367] = 2,
    ACTIONS(21691), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556378] = 2,
    ACTIONS(23441), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556389] = 2,
    ACTIONS(27557), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556400] = 2,
    ACTIONS(27559), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556411] = 2,
    ACTIONS(23486), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556422] = 2,
    ACTIONS(21691), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556433] = 3,
    ACTIONS(27561), 1,
      sym__immediate_varid,
    STATE(11424), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556446] = 2,
    ACTIONS(27563), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556457] = 2,
    ACTIONS(27565), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556468] = 2,
    ACTIONS(24450), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556479] = 2,
    ACTIONS(27567), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556490] = 2,
    ACTIONS(27569), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556501] = 2,
    ACTIONS(23508), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556512] = 2,
    ACTIONS(27571), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556523] = 3,
    ACTIONS(27573), 1,
      sym__immediate_varid,
    STATE(5646), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556536] = 3,
    ACTIONS(27575), 1,
      anon_sym_in,
    STATE(11718), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556549] = 2,
    ACTIONS(27577), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556560] = 2,
    ACTIONS(27579), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556571] = 2,
    ACTIONS(24464), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556582] = 2,
    ACTIONS(23536), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556593] = 2,
    ACTIONS(27581), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556604] = 2,
    ACTIONS(24466), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556615] = 2,
    ACTIONS(16107), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556626] = 2,
    ACTIONS(27583), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556637] = 2,
    ACTIONS(27585), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556648] = 2,
    ACTIONS(27587), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556659] = 3,
    ACTIONS(27589), 1,
      sym__immediate_varid,
    STATE(4326), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556672] = 2,
    ACTIONS(27591), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556683] = 2,
    ACTIONS(23556), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556694] = 2,
    ACTIONS(20889), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556705] = 2,
    ACTIONS(16103), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556716] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556729] = 2,
    ACTIONS(24416), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556740] = 2,
    ACTIONS(24602), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556751] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19850), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556764] = 2,
    ACTIONS(27595), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556775] = 2,
    ACTIONS(27597), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556786] = 3,
    ACTIONS(27599), 1,
      anon_sym_SEMI,
    ACTIONS(27601), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556799] = 2,
    ACTIONS(27603), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556810] = 2,
    ACTIONS(27605), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556821] = 2,
    ACTIONS(23584), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556832] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27607), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556845] = 2,
    ACTIONS(27609), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556856] = 2,
    ACTIONS(21739), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556867] = 2,
    ACTIONS(24393), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556878] = 2,
    ACTIONS(27611), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556889] = 2,
    ACTIONS(27613), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556900] = 3,
    ACTIONS(27615), 1,
      anon_sym_SEMI,
    ACTIONS(27617), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556913] = 3,
    ACTIONS(16574), 1,
      sym_where,
    STATE(16387), 1,
      sym__gadt_rhs,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556926] = 2,
    ACTIONS(27619), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556937] = 2,
    ACTIONS(24404), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556948] = 2,
    ACTIONS(23636), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556959] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(27621), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556972] = 2,
    ACTIONS(27623), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556983] = 2,
    ACTIONS(27625), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [556994] = 2,
    ACTIONS(21745), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557005] = 2,
    ACTIONS(27627), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557016] = 2,
    ACTIONS(27629), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557027] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19913), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557040] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557053] = 2,
    ACTIONS(23656), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557064] = 2,
    ACTIONS(27633), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557075] = 2,
    ACTIONS(23690), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557086] = 3,
    ACTIONS(27635), 1,
      sym__immediate_varid,
    STATE(4807), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557099] = 2,
    ACTIONS(24232), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557110] = 2,
    ACTIONS(27637), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557121] = 2,
    ACTIONS(27639), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557132] = 2,
    ACTIONS(27641), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557143] = 2,
    ACTIONS(27643), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557154] = 2,
    ACTIONS(27645), 2,
      sym_comma,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557165] = 3,
    ACTIONS(27647), 1,
      anon_sym_in,
    STATE(10015), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557178] = 2,
    ACTIONS(27649), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557189] = 2,
    ACTIONS(23740), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557200] = 3,
    ACTIONS(425), 1,
      sym__consym,
    STATE(20454), 1,
      sym_constructor_operator,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557213] = 2,
    ACTIONS(27651), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557224] = 3,
    ACTIONS(27653), 1,
      anon_sym_SEMI,
    ACTIONS(27655), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557237] = 2,
    ACTIONS(19981), 2,
      sym__unboxed_close,
      anon_sym_PIPE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557248] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27657), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557261] = 2,
    ACTIONS(27659), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557272] = 2,
    ACTIONS(24323), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557283] = 2,
    ACTIONS(27661), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557294] = 3,
    ACTIONS(27663), 1,
      anon_sym_SEMI,
    ACTIONS(27665), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557307] = 2,
    ACTIONS(27667), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557318] = 2,
    ACTIONS(27669), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557329] = 3,
    ACTIONS(27671), 1,
      anon_sym_SEMI,
    ACTIONS(27673), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557342] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557355] = 2,
    ACTIONS(23803), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557366] = 2,
    ACTIONS(27677), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557377] = 2,
    ACTIONS(16089), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557388] = 2,
    ACTIONS(16085), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557399] = 2,
    ACTIONS(27679), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557410] = 3,
    ACTIONS(27681), 1,
      sym__immediate_varid,
    STATE(4610), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557423] = 2,
    ACTIONS(23843), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557434] = 2,
    ACTIONS(27683), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557445] = 2,
    ACTIONS(27685), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557456] = 2,
    ACTIONS(23851), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557467] = 3,
    ACTIONS(27687), 1,
      anon_sym_in,
    STATE(11810), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557480] = 2,
    ACTIONS(15574), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557491] = 3,
    ACTIONS(27689), 1,
      anon_sym_in,
    STATE(11815), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557504] = 2,
    ACTIONS(27691), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557515] = 2,
    ACTIONS(24520), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557526] = 3,
    ACTIONS(27693), 1,
      anon_sym_SEMI,
    ACTIONS(27695), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557539] = 2,
    ACTIONS(27697), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557550] = 2,
    ACTIONS(15578), 2,
      sym__consym,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557561] = 2,
    ACTIONS(27699), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557572] = 2,
    ACTIONS(23889), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557583] = 2,
    ACTIONS(23863), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557594] = 2,
    ACTIONS(23839), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557605] = 2,
    ACTIONS(24273), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557616] = 3,
    ACTIONS(27701), 1,
      anon_sym_SEMI,
    ACTIONS(27703), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557629] = 3,
    ACTIONS(27705), 1,
      sym__immediate_varid,
    STATE(11229), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557642] = 2,
    ACTIONS(27707), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557653] = 2,
    ACTIONS(27709), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557664] = 3,
    ACTIONS(27711), 1,
      sym__immediate_varid,
    STATE(10830), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557677] = 3,
    ACTIONS(17433), 1,
      sym__conid,
    STATE(20733), 1,
      sym_constructor,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557690] = 2,
    ACTIONS(27713), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557701] = 2,
    ACTIONS(16085), 2,
      anon_sym_PIPE,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557712] = 2,
    ACTIONS(27715), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557723] = 2,
    ACTIONS(23931), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557734] = 2,
    ACTIONS(27717), 2,
      anon_sym_SEMI,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557745] = 3,
    ACTIONS(27719), 1,
      anon_sym_SEMI,
    ACTIONS(27721), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557758] = 3,
    ACTIONS(27723), 1,
      sym__immediate_varid,
    STATE(4960), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557771] = 2,
    ACTIONS(27725), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557782] = 2,
    ACTIONS(27727), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557793] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557806] = 3,
    ACTIONS(27731), 1,
      anon_sym_SEMI,
    ACTIONS(27733), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557819] = 2,
    ACTIONS(27735), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557830] = 2,
    ACTIONS(27737), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557841] = 3,
    ACTIONS(27739), 1,
      anon_sym_SEMI,
    ACTIONS(27741), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557854] = 2,
    ACTIONS(27743), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557865] = 2,
    ACTIONS(23989), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557876] = 2,
    ACTIONS(20989), 2,
      sym_comma,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557887] = 2,
    ACTIONS(27745), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557898] = 2,
    ACTIONS(27747), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557909] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27749), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557922] = 2,
    ACTIONS(27751), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557933] = 2,
    ACTIONS(24058), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557944] = 2,
    ACTIONS(24218), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557955] = 2,
    ACTIONS(24053), 2,
      sym_comma,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557966] = 2,
    ACTIONS(27753), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557977] = 2,
    ACTIONS(27755), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557988] = 2,
    ACTIONS(27757), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [557999] = 2,
    ACTIONS(24184), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558010] = 3,
    ACTIONS(27759), 1,
      sym__immediate_varid,
    STATE(11276), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558023] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(27761), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558036] = 2,
    ACTIONS(27763), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558047] = 2,
    ACTIONS(24047), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558058] = 3,
    ACTIONS(27765), 1,
      anon_sym_in,
    STATE(12003), 1,
      sym_exp_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558071] = 2,
    ACTIONS(24158), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558082] = 2,
    ACTIONS(27767), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558093] = 2,
    ACTIONS(27769), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558104] = 2,
    ACTIONS(27771), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558115] = 2,
    ACTIONS(27773), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558126] = 2,
    ACTIONS(27775), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558137] = 3,
    ACTIONS(27777), 1,
      sym__immediate_varid,
    STATE(10650), 1,
      sym__immediate_variable,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558150] = 3,
    ACTIONS(19293), 1,
      sym_comma,
    ACTIONS(19729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558163] = 2,
    ACTIONS(24114), 2,
      anon_sym_PIPE_RBRACK,
      anon_sym_8,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558174] = 3,
    ACTIONS(6264), 1,
      sym__dot,
    ACTIONS(27779), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558187] = 2,
    ACTIONS(27781), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558197] = 2,
    ACTIONS(27783), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558207] = 2,
    ACTIONS(27785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558217] = 2,
    ACTIONS(27787), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558227] = 2,
    ACTIONS(20262), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558237] = 2,
    ACTIONS(27789), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558247] = 2,
    ACTIONS(27791), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558257] = 2,
    ACTIONS(27793), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558267] = 2,
    ACTIONS(27795), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558277] = 2,
    ACTIONS(27797), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558287] = 2,
    ACTIONS(27799), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558297] = 2,
    ACTIONS(27801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558307] = 2,
    ACTIONS(27803), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558317] = 2,
    ACTIONS(27805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558327] = 2,
    ACTIONS(27807), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558337] = 2,
    ACTIONS(27809), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558347] = 2,
    ACTIONS(27811), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558357] = 2,
    ACTIONS(27813), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558367] = 2,
    ACTIONS(20244), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558377] = 2,
    ACTIONS(27815), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558387] = 2,
    ACTIONS(27817), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558397] = 2,
    ACTIONS(21007), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558407] = 2,
    ACTIONS(27819), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558417] = 2,
    ACTIONS(27821), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558427] = 2,
    ACTIONS(27823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558437] = 2,
    ACTIONS(27825), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558447] = 2,
    ACTIONS(27827), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558457] = 2,
    ACTIONS(27829), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558467] = 2,
    ACTIONS(27831), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558477] = 2,
    ACTIONS(27833), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558487] = 2,
    ACTIONS(27835), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558497] = 2,
    ACTIONS(27837), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558507] = 2,
    ACTIONS(27839), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558517] = 2,
    ACTIONS(27779), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558527] = 2,
    ACTIONS(27841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558537] = 2,
    ACTIONS(27843), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558547] = 2,
    ACTIONS(27845), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558557] = 2,
    ACTIONS(27847), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558567] = 2,
    ACTIONS(27849), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558577] = 2,
    ACTIONS(27851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558587] = 2,
    ACTIONS(27853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558597] = 2,
    ACTIONS(27855), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558607] = 2,
    ACTIONS(27857), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558617] = 2,
    ACTIONS(15309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558627] = 2,
    ACTIONS(27859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558637] = 2,
    ACTIONS(27861), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558647] = 2,
    ACTIONS(27863), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558657] = 2,
    ACTIONS(27865), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558667] = 2,
    ACTIONS(27867), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558677] = 2,
    ACTIONS(27869), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558687] = 2,
    ACTIONS(27871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558697] = 2,
    ACTIONS(27873), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558707] = 2,
    ACTIONS(27875), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558717] = 2,
    ACTIONS(27877), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558727] = 2,
    ACTIONS(27879), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558737] = 2,
    ACTIONS(27881), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558747] = 2,
    ACTIONS(27883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558757] = 2,
    ACTIONS(27885), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558767] = 2,
    ACTIONS(15433), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558777] = 2,
    ACTIONS(27887), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558787] = 2,
    ACTIONS(27889), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558797] = 2,
    ACTIONS(27891), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558807] = 2,
    ACTIONS(27893), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558817] = 2,
    ACTIONS(27895), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558827] = 2,
    ACTIONS(27897), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558837] = 2,
    ACTIONS(27899), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558847] = 2,
    ACTIONS(27901), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558857] = 2,
    ACTIONS(27903), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558867] = 2,
    ACTIONS(27905), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558877] = 2,
    ACTIONS(27907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558887] = 2,
    ACTIONS(27909), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558897] = 2,
    ACTIONS(27911), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558907] = 2,
    ACTIONS(27913), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558917] = 2,
    ACTIONS(27915), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558927] = 2,
    ACTIONS(27917), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558937] = 2,
    ACTIONS(27919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558947] = 2,
    ACTIONS(27921), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558957] = 2,
    ACTIONS(27923), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558967] = 2,
    ACTIONS(27925), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558977] = 2,
    ACTIONS(27927), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558987] = 2,
    ACTIONS(27929), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [558997] = 2,
    ACTIONS(27931), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559007] = 2,
    ACTIONS(27933), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559017] = 2,
    ACTIONS(20088), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559027] = 2,
    ACTIONS(27935), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559037] = 2,
    ACTIONS(20943), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559047] = 2,
    ACTIONS(27937), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559057] = 2,
    ACTIONS(27939), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559067] = 2,
    ACTIONS(27941), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559077] = 2,
    ACTIONS(27943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559087] = 2,
    ACTIONS(20059), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559097] = 2,
    ACTIONS(27945), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559107] = 2,
    ACTIONS(27947), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559117] = 2,
    ACTIONS(15415), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559127] = 2,
    ACTIONS(27949), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559137] = 2,
    ACTIONS(27951), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559147] = 2,
    ACTIONS(27953), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559157] = 2,
    ACTIONS(27955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559167] = 2,
    ACTIONS(27729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559177] = 2,
    ACTIONS(27957), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559187] = 2,
    ACTIONS(27959), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559197] = 2,
    ACTIONS(27961), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559207] = 2,
    ACTIONS(27963), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559217] = 2,
    ACTIONS(27965), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559227] = 2,
    ACTIONS(27967), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559237] = 2,
    ACTIONS(26639), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559247] = 2,
    ACTIONS(20047), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559257] = 2,
    ACTIONS(20043), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559267] = 2,
    ACTIONS(27969), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559277] = 2,
    ACTIONS(27971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559287] = 2,
    ACTIONS(27973), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559297] = 2,
    ACTIONS(27975), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559307] = 2,
    ACTIONS(27977), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559317] = 2,
    ACTIONS(27979), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559327] = 2,
    ACTIONS(27981), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559337] = 2,
    ACTIONS(27983), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559347] = 2,
    ACTIONS(27985), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559357] = 2,
    ACTIONS(27987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559367] = 2,
    ACTIONS(27989), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559377] = 2,
    ACTIONS(27991), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559387] = 2,
    ACTIONS(27993), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559397] = 2,
    ACTIONS(27995), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559407] = 2,
    ACTIONS(27997), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559417] = 2,
    ACTIONS(21024), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559427] = 2,
    ACTIONS(27999), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559437] = 2,
    ACTIONS(28001), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559447] = 2,
    ACTIONS(28003), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559457] = 2,
    ACTIONS(28005), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559467] = 2,
    ACTIONS(28007), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559477] = 2,
    ACTIONS(28009), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559487] = 2,
    ACTIONS(28011), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559497] = 2,
    ACTIONS(28013), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559507] = 2,
    ACTIONS(28015), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559517] = 2,
    ACTIONS(28017), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559527] = 2,
    ACTIONS(28019), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559537] = 2,
    ACTIONS(28021), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559547] = 2,
    ACTIONS(28023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559557] = 2,
    ACTIONS(28025), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559567] = 2,
    ACTIONS(4165), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559577] = 2,
    ACTIONS(28027), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559587] = 2,
    ACTIONS(28029), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559597] = 2,
    ACTIONS(28031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559607] = 2,
    ACTIONS(28033), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559617] = 2,
    ACTIONS(28035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559627] = 2,
    ACTIONS(28037), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559637] = 2,
    ACTIONS(4109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559647] = 2,
    ACTIONS(28039), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559657] = 2,
    ACTIONS(28041), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559667] = 2,
    ACTIONS(28043), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559677] = 2,
    ACTIONS(28045), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559687] = 2,
    ACTIONS(28047), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559697] = 2,
    ACTIONS(28049), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559707] = 2,
    ACTIONS(28051), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559717] = 2,
    ACTIONS(4297), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559727] = 2,
    ACTIONS(28053), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559737] = 2,
    ACTIONS(28055), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559747] = 2,
    ACTIONS(28057), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559757] = 2,
    ACTIONS(28059), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559767] = 2,
    ACTIONS(28061), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559777] = 2,
    ACTIONS(28063), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559787] = 2,
    ACTIONS(28065), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559797] = 2,
    ACTIONS(28067), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559807] = 2,
    ACTIONS(28069), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559817] = 2,
    ACTIONS(28071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559827] = 2,
    ACTIONS(28073), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559837] = 2,
    ACTIONS(28075), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559847] = 2,
    ACTIONS(28077), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559857] = 2,
    ACTIONS(28079), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559867] = 2,
    ACTIONS(28081), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559877] = 2,
    ACTIONS(28083), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559887] = 2,
    ACTIONS(28085), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559897] = 2,
    ACTIONS(28087), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559907] = 2,
    ACTIONS(28089), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559917] = 2,
    ACTIONS(28091), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559927] = 2,
    ACTIONS(28093), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559937] = 2,
    ACTIONS(28095), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559947] = 2,
    ACTIONS(28097), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559957] = 2,
    ACTIONS(28099), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559967] = 2,
    ACTIONS(28101), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559977] = 2,
    ACTIONS(28103), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559987] = 2,
    ACTIONS(28105), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [559997] = 2,
    ACTIONS(28107), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560007] = 2,
    ACTIONS(28109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560017] = 2,
    ACTIONS(28111), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560027] = 2,
    ACTIONS(4275), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560037] = 2,
    ACTIONS(27761), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560047] = 2,
    ACTIONS(28113), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560057] = 2,
    ACTIONS(28115), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560067] = 2,
    ACTIONS(28117), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560077] = 2,
    ACTIONS(28119), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560087] = 2,
    ACTIONS(28121), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560097] = 2,
    ACTIONS(28123), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560107] = 2,
    ACTIONS(28125), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560117] = 2,
    ACTIONS(28127), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560127] = 2,
    ACTIONS(28129), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560137] = 2,
    ACTIONS(28131), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560147] = 2,
    ACTIONS(28133), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560157] = 2,
    ACTIONS(28135), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560167] = 2,
    ACTIONS(28137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560177] = 2,
    ACTIONS(15297), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560187] = 2,
    ACTIONS(28139), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560197] = 2,
    ACTIONS(15429), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560207] = 2,
    ACTIONS(28141), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560217] = 2,
    ACTIONS(4219), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560227] = 2,
    ACTIONS(28143), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560237] = 2,
    ACTIONS(28145), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560247] = 2,
    ACTIONS(28147), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560257] = 2,
    ACTIONS(28149), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560267] = 2,
    ACTIONS(19953), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560277] = 2,
    ACTIONS(28151), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560287] = 2,
    ACTIONS(28153), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560297] = 2,
    ACTIONS(28155), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560307] = 2,
    ACTIONS(28157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560317] = 2,
    ACTIONS(28159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560327] = 2,
    ACTIONS(27675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560337] = 2,
    ACTIONS(28161), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560347] = 2,
    ACTIONS(28163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560357] = 2,
    ACTIONS(28165), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560367] = 2,
    ACTIONS(28167), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560377] = 2,
    ACTIONS(28169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560387] = 2,
    ACTIONS(28171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560397] = 2,
    ACTIONS(28173), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560407] = 2,
    ACTIONS(28175), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560417] = 2,
    ACTIONS(20909), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560427] = 2,
    ACTIONS(28177), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560437] = 2,
    ACTIONS(28179), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560447] = 2,
    ACTIONS(28181), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560457] = 2,
    ACTIONS(28183), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560467] = 2,
    ACTIONS(28185), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560477] = 2,
    ACTIONS(28187), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560487] = 2,
    ACTIONS(19959), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560497] = 2,
    ACTIONS(15413), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560507] = 2,
    ACTIONS(20340), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560517] = 2,
    ACTIONS(28189), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560527] = 2,
    ACTIONS(28191), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560537] = 2,
    ACTIONS(28193), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560547] = 2,
    ACTIONS(28195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560557] = 2,
    ACTIONS(28197), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560567] = 2,
    ACTIONS(20346), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560577] = 2,
    ACTIONS(28199), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560587] = 2,
    ACTIONS(28201), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560597] = 2,
    ACTIONS(15321), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560607] = 2,
    ACTIONS(28203), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560617] = 2,
    ACTIONS(28205), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560627] = 2,
    ACTIONS(28207), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560637] = 2,
    ACTIONS(28209), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560647] = 2,
    ACTIONS(28211), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560657] = 2,
    ACTIONS(28213), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560667] = 2,
    ACTIONS(28215), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560677] = 2,
    ACTIONS(28217), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560687] = 2,
    ACTIONS(28219), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560697] = 2,
    ACTIONS(28221), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560707] = 2,
    ACTIONS(28223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560717] = 2,
    ACTIONS(28225), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560727] = 2,
    ACTIONS(28227), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560737] = 2,
    ACTIONS(28229), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560747] = 2,
    ACTIONS(28231), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560757] = 2,
    ACTIONS(28233), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560767] = 2,
    ACTIONS(28235), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560777] = 2,
    ACTIONS(28237), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560787] = 2,
    ACTIONS(20901), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560797] = 2,
    ACTIONS(4199), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560807] = 2,
    ACTIONS(15343), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560817] = 2,
    ACTIONS(28239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560827] = 2,
    ACTIONS(28241), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560837] = 2,
    ACTIONS(28243), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560847] = 2,
    ACTIONS(19245), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560857] = 2,
    ACTIONS(28245), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560867] = 2,
    ACTIONS(28247), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560877] = 2,
    ACTIONS(28249), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560887] = 2,
    ACTIONS(28251), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560897] = 2,
    ACTIONS(4281), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560907] = 2,
    ACTIONS(28253), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560917] = 2,
    ACTIONS(28255), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560927] = 2,
    ACTIONS(28257), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560937] = 2,
    ACTIONS(28259), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560947] = 2,
    ACTIONS(28261), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560957] = 2,
    ACTIONS(28263), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560967] = 2,
    ACTIONS(28265), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560977] = 2,
    ACTIONS(28267), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560987] = 2,
    ACTIONS(19991), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [560997] = 2,
    ACTIONS(28269), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561007] = 2,
    ACTIONS(28271), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561017] = 2,
    ACTIONS(28273), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561027] = 2,
    ACTIONS(28275), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561037] = 2,
    ACTIONS(28277), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561047] = 2,
    ACTIONS(28279), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561057] = 2,
    ACTIONS(28281), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561067] = 2,
    ACTIONS(28283), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561077] = 2,
    ACTIONS(28285), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561087] = 2,
    ACTIONS(28287), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561097] = 2,
    ACTIONS(28289), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561107] = 2,
    ACTIONS(28291), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561117] = 2,
    ACTIONS(28293), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561127] = 2,
    ACTIONS(27621), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561137] = 2,
    ACTIONS(28295), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561147] = 2,
    ACTIONS(28297), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561157] = 2,
    ACTIONS(28299), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561167] = 2,
    ACTIONS(28301), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561177] = 2,
    ACTIONS(4285), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561187] = 2,
    ACTIONS(28303), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561197] = 2,
    ACTIONS(28305), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561207] = 2,
    ACTIONS(28307), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561217] = 2,
    ACTIONS(28309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561227] = 2,
    ACTIONS(28311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561237] = 2,
    ACTIONS(28313), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561247] = 2,
    ACTIONS(28315), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561257] = 2,
    ACTIONS(20802), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561267] = 2,
    ACTIONS(20001), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561277] = 2,
    ACTIONS(28317), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561287] = 2,
    ACTIONS(28319), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561297] = 2,
    ACTIONS(28321), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561307] = 2,
    ACTIONS(28323), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561317] = 2,
    ACTIONS(20009), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561327] = 2,
    ACTIONS(28325), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561337] = 2,
    ACTIONS(28327), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561347] = 2,
    ACTIONS(20378), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561357] = 2,
    ACTIONS(28329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561367] = 2,
    ACTIONS(20881), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561377] = 2,
    ACTIONS(28331), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561387] = 2,
    ACTIONS(28333), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561397] = 2,
    ACTIONS(26715), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561407] = 2,
    ACTIONS(28335), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561417] = 2,
    ACTIONS(28337), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561427] = 2,
    ACTIONS(28339), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561437] = 2,
    ACTIONS(28341), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561447] = 2,
    ACTIONS(28343), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561457] = 2,
    ACTIONS(20021), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561467] = 2,
    ACTIONS(28345), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561477] = 2,
    ACTIONS(28347), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561487] = 2,
    ACTIONS(28349), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561497] = 2,
    ACTIONS(28351), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561507] = 2,
    ACTIONS(28353), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561517] = 2,
    ACTIONS(28355), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561527] = 2,
    ACTIONS(28357), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561537] = 2,
    ACTIONS(28359), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561547] = 2,
    ACTIONS(28361), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561557] = 2,
    ACTIONS(28363), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561567] = 2,
    ACTIONS(28365), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561577] = 2,
    ACTIONS(28367), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561587] = 2,
    ACTIONS(28369), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561597] = 2,
    ACTIONS(28371), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561607] = 2,
    ACTIONS(28373), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561617] = 2,
    ACTIONS(28375), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561627] = 2,
    ACTIONS(28377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561637] = 2,
    ACTIONS(28379), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561647] = 2,
    ACTIONS(28381), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561657] = 2,
    ACTIONS(28383), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561667] = 2,
    ACTIONS(28385), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561677] = 2,
    ACTIONS(28387), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561687] = 2,
    ACTIONS(28389), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561697] = 2,
    ACTIONS(28391), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561707] = 2,
    ACTIONS(28393), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561717] = 2,
    ACTIONS(28395), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561727] = 2,
    ACTIONS(28397), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561737] = 2,
    ACTIONS(28399), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561747] = 2,
    ACTIONS(28401), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561757] = 2,
    ACTIONS(28403), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561767] = 2,
    ACTIONS(15419), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561777] = 2,
    ACTIONS(15303), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561787] = 2,
    ACTIONS(28405), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561797] = 2,
    ACTIONS(28407), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561807] = 2,
    ACTIONS(28409), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561817] = 2,
    ACTIONS(28411), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561827] = 2,
    ACTIONS(28413), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561837] = 2,
    ACTIONS(28415), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561847] = 2,
    ACTIONS(28417), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561857] = 2,
    ACTIONS(26907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561867] = 2,
    ACTIONS(28419), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561877] = 2,
    ACTIONS(28421), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561887] = 2,
    ACTIONS(28423), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561897] = 2,
    ACTIONS(15323), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561907] = 2,
    ACTIONS(28425), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561917] = 2,
    ACTIONS(28427), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561927] = 2,
    ACTIONS(28429), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561937] = 2,
    ACTIONS(28431), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561947] = 2,
    ACTIONS(28433), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561957] = 2,
    ACTIONS(15405), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561967] = 2,
    ACTIONS(28435), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561977] = 2,
    ACTIONS(4201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561987] = 2,
    ACTIONS(28437), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [561997] = 2,
    ACTIONS(28439), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562007] = 2,
    ACTIONS(28441), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562017] = 2,
    ACTIONS(28443), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562027] = 2,
    ACTIONS(28445), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562037] = 2,
    ACTIONS(28447), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562047] = 2,
    ACTIONS(28449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562057] = 2,
    ACTIONS(28451), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562067] = 2,
    ACTIONS(28453), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562077] = 2,
    ACTIONS(28455), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562087] = 2,
    ACTIONS(28457), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562097] = 2,
    ACTIONS(28459), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562107] = 2,
    ACTIONS(28461), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562117] = 2,
    ACTIONS(15383), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562127] = 2,
    ACTIONS(28463), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562137] = 2,
    ACTIONS(28465), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562147] = 2,
    ACTIONS(28467), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562157] = 2,
    ACTIONS(28469), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562167] = 2,
    ACTIONS(28471), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562177] = 2,
    ACTIONS(28473), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562187] = 2,
    ACTIONS(28475), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562197] = 2,
    ACTIONS(28477), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562207] = 2,
    ACTIONS(15243), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562217] = 2,
    ACTIONS(28479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562227] = 2,
    ACTIONS(28481), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562237] = 2,
    ACTIONS(28483), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562247] = 2,
    ACTIONS(28485), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562257] = 2,
    ACTIONS(28487), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562267] = 2,
    ACTIONS(28489), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562277] = 2,
    ACTIONS(28491), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562287] = 2,
    ACTIONS(19384), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562297] = 2,
    ACTIONS(28493), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562307] = 2,
    ACTIONS(15381), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562317] = 2,
    ACTIONS(28495), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562327] = 2,
    ACTIONS(28497), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562337] = 2,
    ACTIONS(28499), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562347] = 2,
    ACTIONS(28501), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562357] = 2,
    ACTIONS(28503), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562367] = 2,
    ACTIONS(28505), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562377] = 2,
    ACTIONS(28507), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562387] = 2,
    ACTIONS(28509), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562397] = 2,
    ACTIONS(28511), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562407] = 2,
    ACTIONS(20350), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562417] = 2,
    ACTIONS(15349), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562427] = 2,
    ACTIONS(28513), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562437] = 2,
    ACTIONS(28515), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562447] = 2,
    ACTIONS(20419), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562457] = 2,
    ACTIONS(28517), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562467] = 2,
    ACTIONS(28519), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562477] = 2,
    ACTIONS(28521), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562487] = 2,
    ACTIONS(28523), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562497] = 2,
    ACTIONS(28525), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562507] = 2,
    ACTIONS(28527), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562517] = 2,
    ACTIONS(28529), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562527] = 2,
    ACTIONS(28531), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562537] = 2,
    ACTIONS(28533), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562547] = 2,
    ACTIONS(28535), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562557] = 2,
    ACTIONS(28537), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562567] = 2,
    ACTIONS(28539), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562577] = 2,
    ACTIONS(28541), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562587] = 2,
    ACTIONS(28543), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562597] = 2,
    ACTIONS(28545), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562607] = 2,
    ACTIONS(15307), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562617] = 2,
    ACTIONS(28547), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562627] = 2,
    ACTIONS(28549), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562637] = 2,
    ACTIONS(28551), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562647] = 2,
    ACTIONS(28553), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562657] = 2,
    ACTIONS(28555), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562667] = 2,
    ACTIONS(20433), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562677] = 2,
    ACTIONS(28557), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562687] = 2,
    ACTIONS(15353), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562697] = 2,
    ACTIONS(28559), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562707] = 2,
    ACTIONS(28561), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562717] = 2,
    ACTIONS(27499), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562727] = 2,
    ACTIONS(28563), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562737] = 2,
    ACTIONS(28565), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562747] = 2,
    ACTIONS(28567), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562757] = 2,
    ACTIONS(28569), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562767] = 2,
    ACTIONS(28571), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562777] = 2,
    ACTIONS(28573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562787] = 2,
    ACTIONS(28575), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562797] = 2,
    ACTIONS(20118), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562807] = 2,
    ACTIONS(28577), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562817] = 2,
    ACTIONS(28579), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562827] = 2,
    ACTIONS(28581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562837] = 2,
    ACTIONS(28583), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562847] = 2,
    ACTIONS(28585), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562857] = 2,
    ACTIONS(28587), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562867] = 2,
    ACTIONS(28589), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562877] = 2,
    ACTIONS(28591), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562887] = 2,
    ACTIONS(28593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562897] = 2,
    ACTIONS(15279), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562907] = 2,
    ACTIONS(28595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562917] = 2,
    ACTIONS(28597), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562927] = 2,
    ACTIONS(28599), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562937] = 2,
    ACTIONS(28601), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562947] = 2,
    ACTIONS(28603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562957] = 2,
    ACTIONS(28605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562967] = 2,
    ACTIONS(28607), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562977] = 2,
    ACTIONS(28609), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562987] = 2,
    ACTIONS(28611), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [562997] = 2,
    ACTIONS(28613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563007] = 2,
    ACTIONS(28615), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563017] = 2,
    ACTIONS(20504), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563027] = 2,
    ACTIONS(28617), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563037] = 2,
    ACTIONS(4251), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563047] = 2,
    ACTIONS(28619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563057] = 2,
    ACTIONS(28621), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563067] = 2,
    ACTIONS(4293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563077] = 2,
    ACTIONS(28623), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563087] = 2,
    ACTIONS(28625), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563097] = 2,
    ACTIONS(28627), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563107] = 2,
    ACTIONS(28629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563117] = 2,
    ACTIONS(28631), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563127] = 2,
    ACTIONS(28633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563137] = 2,
    ACTIONS(28635), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563147] = 2,
    ACTIONS(28637), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563157] = 2,
    ACTIONS(28639), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563167] = 2,
    ACTIONS(28641), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563177] = 2,
    ACTIONS(28643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563187] = 2,
    ACTIONS(28645), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563197] = 2,
    ACTIONS(28647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563207] = 2,
    ACTIONS(28649), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563217] = 2,
    ACTIONS(28651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563227] = 2,
    ACTIONS(15341), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563237] = 2,
    ACTIONS(28653), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563247] = 2,
    ACTIONS(28655), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563257] = 2,
    ACTIONS(28657), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563267] = 2,
    ACTIONS(28659), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563277] = 2,
    ACTIONS(28661), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563287] = 2,
    ACTIONS(28663), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563297] = 2,
    ACTIONS(28665), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563307] = 2,
    ACTIONS(28667), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563317] = 2,
    ACTIONS(28669), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563327] = 2,
    ACTIONS(28671), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563337] = 2,
    ACTIONS(28673), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563347] = 2,
    ACTIONS(15291), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563357] = 2,
    ACTIONS(28675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563367] = 2,
    ACTIONS(28677), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563377] = 2,
    ACTIONS(28679), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563387] = 2,
    ACTIONS(28681), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563397] = 2,
    ACTIONS(28683), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563407] = 2,
    ACTIONS(28685), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563417] = 2,
    ACTIONS(28687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563427] = 2,
    ACTIONS(28689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563437] = 2,
    ACTIONS(28691), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563447] = 2,
    ACTIONS(28693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563457] = 2,
    ACTIONS(28695), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563467] = 2,
    ACTIONS(28697), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563477] = 2,
    ACTIONS(27593), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563487] = 2,
    ACTIONS(28699), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563497] = 2,
    ACTIONS(15401), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563507] = 2,
    ACTIONS(4271), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563517] = 2,
    ACTIONS(28701), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563527] = 2,
    ACTIONS(20524), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563537] = 2,
    ACTIONS(28703), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563547] = 2,
    ACTIONS(28705), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563557] = 2,
    ACTIONS(28707), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563567] = 2,
    ACTIONS(20546), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563577] = 2,
    ACTIONS(28709), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563587] = 2,
    ACTIONS(28711), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563597] = 2,
    ACTIONS(28713), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563607] = 2,
    ACTIONS(28715), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563617] = 2,
    ACTIONS(28717), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563627] = 2,
    ACTIONS(28719), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563637] = 2,
    ACTIONS(28721), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563647] = 2,
    ACTIONS(28723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563657] = 2,
    ACTIONS(28725), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563667] = 2,
    ACTIONS(28727), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563677] = 2,
    ACTIONS(28729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563687] = 2,
    ACTIONS(28731), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563697] = 2,
    ACTIONS(28733), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563707] = 2,
    ACTIONS(28735), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563717] = 2,
    ACTIONS(28737), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563727] = 2,
    ACTIONS(28739), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563737] = 2,
    ACTIONS(28741), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563747] = 2,
    ACTIONS(20164), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563757] = 2,
    ACTIONS(28743), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563767] = 2,
    ACTIONS(28745), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563777] = 2,
    ACTIONS(28747), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563787] = 2,
    ACTIONS(28749), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563797] = 2,
    ACTIONS(28751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563807] = 2,
    ACTIONS(27443), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563817] = 2,
    ACTIONS(28753), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563827] = 2,
    ACTIONS(28755), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563837] = 2,
    ACTIONS(28757), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563847] = 2,
    ACTIONS(28759), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563857] = 2,
    ACTIONS(28761), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563867] = 2,
    ACTIONS(21003), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563877] = 2,
    ACTIONS(28763), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563887] = 2,
    ACTIONS(28765), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563897] = 2,
    ACTIONS(28767), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563907] = 2,
    ACTIONS(28769), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563917] = 2,
    ACTIONS(28771), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563927] = 2,
    ACTIONS(28773), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563937] = 2,
    ACTIONS(28775), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563947] = 2,
    ACTIONS(28777), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563957] = 2,
    ACTIONS(28779), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563967] = 2,
    ACTIONS(28781), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563977] = 2,
    ACTIONS(28783), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563987] = 2,
    ACTIONS(20178), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [563997] = 2,
    ACTIONS(20182), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564007] = 2,
    ACTIONS(28785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564017] = 2,
    ACTIONS(28787), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564027] = 2,
    ACTIONS(28789), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564037] = 2,
    ACTIONS(28791), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564047] = 2,
    ACTIONS(15287), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564057] = 2,
    ACTIONS(28793), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564067] = 2,
    ACTIONS(28795), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564077] = 2,
    ACTIONS(28797), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564087] = 2,
    ACTIONS(20611), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564097] = 2,
    ACTIONS(28799), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564107] = 2,
    ACTIONS(28801), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564117] = 2,
    ACTIONS(28803), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564127] = 2,
    ACTIONS(28805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564137] = 2,
    ACTIONS(28807), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564147] = 2,
    ACTIONS(28809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564157] = 2,
    ACTIONS(28811), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564167] = 2,
    ACTIONS(28813), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564177] = 2,
    ACTIONS(20186), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564187] = 2,
    ACTIONS(20512), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564197] = 2,
    ACTIONS(28815), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564207] = 2,
    ACTIONS(28817), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564217] = 2,
    ACTIONS(28819), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564227] = 2,
    ACTIONS(28821), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564237] = 2,
    ACTIONS(28823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564247] = 2,
    ACTIONS(28825), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564257] = 2,
    ACTIONS(28827), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564267] = 2,
    ACTIONS(28829), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564277] = 2,
    ACTIONS(28831), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564287] = 2,
    ACTIONS(28833), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564297] = 2,
    ACTIONS(28835), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564307] = 2,
    ACTIONS(28837), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564317] = 2,
    ACTIONS(28839), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564327] = 2,
    ACTIONS(28841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564337] = 2,
    ACTIONS(28843), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564347] = 2,
    ACTIONS(28845), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564357] = 2,
    ACTIONS(28847), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564367] = 2,
    ACTIONS(15393), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564377] = 2,
    ACTIONS(28849), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564387] = 2,
    ACTIONS(28851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564397] = 2,
    ACTIONS(28853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564407] = 2,
    ACTIONS(28855), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564417] = 2,
    ACTIONS(28857), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564427] = 2,
    ACTIONS(28859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564437] = 2,
    ACTIONS(28861), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564447] = 2,
    ACTIONS(28863), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564457] = 2,
    ACTIONS(28865), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564467] = 2,
    ACTIONS(28867), 1,
      sym_where,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564477] = 2,
    ACTIONS(28869), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564487] = 2,
    ACTIONS(28871), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564497] = 2,
    ACTIONS(27483), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564507] = 2,
    ACTIONS(27261), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564517] = 2,
    ACTIONS(28873), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564527] = 2,
    ACTIONS(151), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564537] = 2,
    ACTIONS(4263), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564547] = 2,
    ACTIONS(4217), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564557] = 2,
    ACTIONS(28875), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564567] = 2,
    ACTIONS(27369), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564577] = 2,
    ACTIONS(28877), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564587] = 2,
    ACTIONS(28879), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564597] = 2,
    ACTIONS(28881), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564607] = 2,
    ACTIONS(28883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564617] = 2,
    ACTIONS(28885), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564627] = 2,
    ACTIONS(28887), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564637] = 2,
    ACTIONS(20566), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564647] = 2,
    ACTIONS(28889), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564657] = 2,
    ACTIONS(28891), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564667] = 2,
    ACTIONS(28893), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564677] = 2,
    ACTIONS(28895), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564687] = 2,
    ACTIONS(15327), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564697] = 2,
    ACTIONS(20429), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564707] = 2,
    ACTIONS(28897), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564717] = 2,
    ACTIONS(15239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564727] = 2,
    ACTIONS(28899), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564737] = 2,
    ACTIONS(28901), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564747] = 2,
    ACTIONS(28903), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564757] = 2,
    ACTIONS(28905), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564767] = 2,
    ACTIONS(28907), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564777] = 2,
    ACTIONS(28909), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564787] = 2,
    ACTIONS(28911), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564797] = 2,
    ACTIONS(28913), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564807] = 2,
    ACTIONS(28915), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564817] = 2,
    ACTIONS(28917), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564827] = 2,
    ACTIONS(28919), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564837] = 2,
    ACTIONS(28921), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564847] = 2,
    ACTIONS(28923), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564857] = 2,
    ACTIONS(19500), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564867] = 2,
    ACTIONS(28925), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564877] = 2,
    ACTIONS(28927), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564887] = 2,
    ACTIONS(28929), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564897] = 2,
    ACTIONS(28931), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564907] = 2,
    ACTIONS(28933), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564917] = 2,
    ACTIONS(28935), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564927] = 2,
    ACTIONS(28937), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564937] = 2,
    ACTIONS(28939), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564947] = 2,
    ACTIONS(28941), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564957] = 2,
    ACTIONS(28943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564967] = 2,
    ACTIONS(28945), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564977] = 2,
    ACTIONS(28947), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564987] = 2,
    ACTIONS(15345), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [564997] = 2,
    ACTIONS(28949), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565007] = 2,
    ACTIONS(28951), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565017] = 2,
    ACTIONS(28953), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565027] = 2,
    ACTIONS(28955), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565037] = 2,
    ACTIONS(28957), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565047] = 2,
    ACTIONS(28959), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565057] = 2,
    ACTIONS(20288), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565067] = 2,
    ACTIONS(27401), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565077] = 2,
    ACTIONS(28961), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565087] = 2,
    ACTIONS(4261), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565097] = 2,
    ACTIONS(4291), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565107] = 2,
    ACTIONS(28963), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565117] = 2,
    ACTIONS(28965), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565127] = 2,
    ACTIONS(28967), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565137] = 2,
    ACTIONS(28969), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565147] = 2,
    ACTIONS(15251), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565157] = 2,
    ACTIONS(28971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565167] = 2,
    ACTIONS(28973), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565177] = 2,
    ACTIONS(28975), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565187] = 2,
    ACTIONS(28977), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565197] = 2,
    ACTIONS(22937), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565207] = 2,
    ACTIONS(28979), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565217] = 2,
    ACTIONS(28981), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565227] = 2,
    ACTIONS(28983), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565237] = 2,
    ACTIONS(28985), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565247] = 2,
    ACTIONS(19222), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565257] = 2,
    ACTIONS(28987), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565267] = 2,
    ACTIONS(20621), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565277] = 2,
    ACTIONS(20296), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565287] = 2,
    ACTIONS(28989), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565297] = 2,
    ACTIONS(28991), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565307] = 2,
    ACTIONS(28993), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565317] = 2,
    ACTIONS(15277), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565327] = 2,
    ACTIONS(28995), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565337] = 2,
    ACTIONS(28997), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565347] = 2,
    ACTIONS(28999), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565357] = 2,
    ACTIONS(29001), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565367] = 2,
    ACTIONS(29003), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565377] = 2,
    ACTIONS(29005), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565387] = 2,
    ACTIONS(29007), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565397] = 2,
    ACTIONS(29009), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565407] = 2,
    ACTIONS(29011), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565417] = 2,
    ACTIONS(29013), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565427] = 2,
    ACTIONS(29015), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565437] = 2,
    ACTIONS(29017), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565447] = 2,
    ACTIONS(29019), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565457] = 2,
    ACTIONS(29021), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565467] = 2,
    ACTIONS(29023), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565477] = 2,
    ACTIONS(29025), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565487] = 2,
    ACTIONS(29027), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565497] = 2,
    ACTIONS(29029), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565507] = 2,
    ACTIONS(29031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565517] = 2,
    ACTIONS(29033), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565527] = 2,
    ACTIONS(29035), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565537] = 2,
    ACTIONS(29037), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565547] = 2,
    ACTIONS(29039), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565557] = 2,
    ACTIONS(29041), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565567] = 2,
    ACTIONS(29043), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565577] = 2,
    ACTIONS(20266), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565587] = 2,
    ACTIONS(29045), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565597] = 2,
    ACTIONS(29047), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565607] = 2,
    ACTIONS(29049), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565617] = 2,
    ACTIONS(29051), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565627] = 2,
    ACTIONS(29053), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565637] = 2,
    ACTIONS(29055), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565647] = 2,
    ACTIONS(29057), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565657] = 2,
    ACTIONS(29059), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565667] = 2,
    ACTIONS(29061), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565677] = 2,
    ACTIONS(12401), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565687] = 2,
    ACTIONS(29063), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565697] = 2,
    ACTIONS(29065), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565707] = 2,
    ACTIONS(29067), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565717] = 2,
    ACTIONS(29069), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565727] = 2,
    ACTIONS(29071), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565737] = 2,
    ACTIONS(29073), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565747] = 2,
    ACTIONS(29075), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565757] = 2,
    ACTIONS(29077), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565767] = 2,
    ACTIONS(29079), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565777] = 2,
    ACTIONS(29081), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565787] = 2,
    ACTIONS(29083), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565797] = 2,
    ACTIONS(19345), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565807] = 2,
    ACTIONS(29085), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565817] = 2,
    ACTIONS(29087), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565827] = 2,
    ACTIONS(29089), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565837] = 2,
    ACTIONS(29091), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565847] = 2,
    ACTIONS(29093), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565857] = 2,
    ACTIONS(29095), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565867] = 2,
    ACTIONS(27267), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565877] = 2,
    ACTIONS(29097), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565887] = 2,
    ACTIONS(29099), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565897] = 2,
    ACTIONS(29101), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565907] = 2,
    ACTIONS(15335), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565917] = 2,
    ACTIONS(20228), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565927] = 2,
    ACTIONS(29103), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565937] = 2,
    ACTIONS(29105), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565947] = 2,
    ACTIONS(29107), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565957] = 2,
    ACTIONS(29109), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565967] = 2,
    ACTIONS(29111), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565977] = 2,
    ACTIONS(29113), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565987] = 2,
    ACTIONS(29115), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [565997] = 2,
    ACTIONS(29117), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566007] = 2,
    ACTIONS(29119), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566017] = 2,
    ACTIONS(29121), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566027] = 2,
    ACTIONS(29123), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566037] = 2,
    ACTIONS(29125), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566047] = 2,
    ACTIONS(29127), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566057] = 2,
    ACTIONS(29129), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566067] = 2,
    ACTIONS(29131), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566077] = 2,
    ACTIONS(29133), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566087] = 2,
    ACTIONS(29135), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566097] = 2,
    ACTIONS(29137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566107] = 2,
    ACTIONS(29139), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566117] = 2,
    ACTIONS(29141), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566127] = 2,
    ACTIONS(29143), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566137] = 2,
    ACTIONS(20356), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566147] = 2,
    ACTIONS(29145), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566157] = 2,
    ACTIONS(29147), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566167] = 2,
    ACTIONS(20362), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566177] = 2,
    ACTIONS(15293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566187] = 2,
    ACTIONS(29149), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566197] = 2,
    ACTIONS(29151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566207] = 2,
    ACTIONS(29153), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566217] = 2,
    ACTIONS(27307), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566227] = 2,
    ACTIONS(19291), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566237] = 2,
    ACTIONS(4257), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566247] = 2,
    ACTIONS(29155), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566257] = 2,
    ACTIONS(4253), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566267] = 2,
    ACTIONS(29157), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566277] = 2,
    ACTIONS(15265), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566287] = 2,
    ACTIONS(29159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566297] = 2,
    ACTIONS(29161), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566307] = 2,
    ACTIONS(29163), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566317] = 2,
    ACTIONS(29165), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566327] = 2,
    ACTIONS(15289), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566337] = 2,
    ACTIONS(29167), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566347] = 2,
    ACTIONS(29169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566357] = 2,
    ACTIONS(29171), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566367] = 2,
    ACTIONS(29173), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566377] = 2,
    ACTIONS(29175), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566387] = 2,
    ACTIONS(19752), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566397] = 2,
    ACTIONS(20366), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566407] = 2,
    ACTIONS(29177), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566417] = 2,
    ACTIONS(29179), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566427] = 2,
    ACTIONS(29181), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566437] = 2,
    ACTIONS(29183), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566447] = 2,
    ACTIONS(29185), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566457] = 2,
    ACTIONS(29187), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566467] = 2,
    ACTIONS(29189), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566477] = 2,
    ACTIONS(29191), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566487] = 2,
    ACTIONS(29193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566497] = 2,
    ACTIONS(29195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566507] = 2,
    ACTIONS(29197), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566517] = 2,
    ACTIONS(29199), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566527] = 2,
    ACTIONS(29201), 1,
      anon_sym_using,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566537] = 2,
    ACTIONS(29203), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566547] = 2,
    ACTIONS(29205), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566557] = 2,
    ACTIONS(29207), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566567] = 2,
    ACTIONS(29209), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566577] = 2,
    ACTIONS(29211), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566587] = 2,
    ACTIONS(29213), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566597] = 2,
    ACTIONS(29215), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566607] = 2,
    ACTIONS(29217), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566617] = 2,
    ACTIONS(29219), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566627] = 2,
    ACTIONS(29221), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566637] = 2,
    ACTIONS(20391), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566647] = 2,
    ACTIONS(29223), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566657] = 2,
    ACTIONS(29225), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566667] = 2,
    ACTIONS(20076), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566677] = 2,
    ACTIONS(29227), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566687] = 2,
    ACTIONS(29229), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566697] = 2,
    ACTIONS(29231), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566707] = 2,
    ACTIONS(29233), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566717] = 2,
    ACTIONS(27129), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566727] = 2,
    ACTIONS(29235), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566737] = 2,
    ACTIONS(15397), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566747] = 2,
    ACTIONS(29237), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566757] = 2,
    ACTIONS(29239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566767] = 2,
    ACTIONS(20670), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566777] = 2,
    ACTIONS(27223), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566787] = 2,
    ACTIONS(29241), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566797] = 2,
    ACTIONS(20037), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566807] = 2,
    ACTIONS(4239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566817] = 2,
    ACTIONS(20449), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566827] = 2,
    ACTIONS(29243), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566837] = 2,
    ACTIONS(29245), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566847] = 2,
    ACTIONS(29247), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566857] = 2,
    ACTIONS(29249), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566867] = 2,
    ACTIONS(29251), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566877] = 2,
    ACTIONS(29253), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566887] = 2,
    ACTIONS(29255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566897] = 2,
    ACTIONS(29257), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566907] = 2,
    ACTIONS(29259), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566917] = 2,
    ACTIONS(29261), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566927] = 2,
    ACTIONS(29263), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566937] = 2,
    ACTIONS(29265), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566947] = 2,
    ACTIONS(29267), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566957] = 2,
    ACTIONS(27171), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566967] = 2,
    ACTIONS(29269), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566977] = 2,
    ACTIONS(29271), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566987] = 2,
    ACTIONS(29273), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [566997] = 2,
    ACTIONS(29275), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567007] = 2,
    ACTIONS(29277), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567017] = 2,
    ACTIONS(29279), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567027] = 2,
    ACTIONS(19971), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567037] = 2,
    ACTIONS(19424), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567047] = 2,
    ACTIONS(29281), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567057] = 2,
    ACTIONS(29283), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567067] = 2,
    ACTIONS(29285), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567077] = 2,
    ACTIONS(29287), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567087] = 2,
    ACTIONS(29289), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567097] = 2,
    ACTIONS(29291), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567107] = 2,
    ACTIONS(29293), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567117] = 2,
    ACTIONS(29295), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567127] = 2,
    ACTIONS(29297), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567137] = 2,
    ACTIONS(29299), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567147] = 2,
    ACTIONS(29301), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567157] = 2,
    ACTIONS(29303), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567167] = 2,
    ACTIONS(29305), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567177] = 2,
    ACTIONS(29307), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567187] = 2,
    ACTIONS(29309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567197] = 2,
    ACTIONS(29311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567207] = 2,
    ACTIONS(29313), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567217] = 2,
    ACTIONS(29315), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567227] = 2,
    ACTIONS(29317), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567237] = 2,
    ACTIONS(29319), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567247] = 2,
    ACTIONS(29321), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567257] = 2,
    ACTIONS(20441), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567267] = 2,
    ACTIONS(29323), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567277] = 2,
    ACTIONS(29325), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567287] = 2,
    ACTIONS(29327), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567297] = 2,
    ACTIONS(29329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567307] = 2,
    ACTIONS(29331), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567317] = 2,
    ACTIONS(29333), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567327] = 2,
    ACTIONS(29335), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567337] = 2,
    ACTIONS(29337), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567347] = 2,
    ACTIONS(29339), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567357] = 2,
    ACTIONS(19175), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567367] = 2,
    ACTIONS(29341), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567377] = 2,
    ACTIONS(4247), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567387] = 2,
    ACTIONS(29343), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567397] = 2,
    ACTIONS(29345), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567407] = 2,
    ACTIONS(29347), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567417] = 2,
    ACTIONS(29349), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567427] = 2,
    ACTIONS(29351), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567437] = 2,
    ACTIONS(29353), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567447] = 2,
    ACTIONS(19931), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567457] = 2,
    ACTIONS(29355), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567467] = 2,
    ACTIONS(29357), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567477] = 2,
    ACTIONS(29359), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567487] = 2,
    ACTIONS(29361), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567497] = 2,
    ACTIONS(29363), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567507] = 2,
    ACTIONS(29365), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567517] = 2,
    ACTIONS(20536), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567527] = 2,
    ACTIONS(29367), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567537] = 2,
    ACTIONS(29369), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567547] = 2,
    ACTIONS(29371), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567557] = 2,
    ACTIONS(29373), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567567] = 2,
    ACTIONS(29375), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567577] = 2,
    ACTIONS(29377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567587] = 2,
    ACTIONS(15261), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567597] = 2,
    ACTIONS(29379), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567607] = 2,
    ACTIONS(29381), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567617] = 2,
    ACTIONS(29383), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567627] = 2,
    ACTIONS(29385), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567637] = 2,
    ACTIONS(29387), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567647] = 2,
    ACTIONS(29389), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567657] = 2,
    ACTIONS(29391), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567667] = 2,
    ACTIONS(29393), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567677] = 2,
    ACTIONS(29395), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567687] = 2,
    ACTIONS(29397), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567697] = 2,
    ACTIONS(29399), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567707] = 2,
    ACTIONS(29401), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567717] = 2,
    ACTIONS(29403), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567727] = 2,
    ACTIONS(29405), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567737] = 2,
    ACTIONS(29407), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567747] = 2,
    ACTIONS(29409), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567757] = 2,
    ACTIONS(29411), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567767] = 2,
    ACTIONS(29413), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567777] = 2,
    ACTIONS(20318), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567787] = 2,
    ACTIONS(4131), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567797] = 2,
    ACTIONS(29415), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567807] = 2,
    ACTIONS(29417), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567817] = 2,
    ACTIONS(29419), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567827] = 2,
    ACTIONS(29421), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567837] = 2,
    ACTIONS(29423), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567847] = 2,
    ACTIONS(29425), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567857] = 2,
    ACTIONS(15241), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567867] = 2,
    ACTIONS(26597), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567877] = 2,
    ACTIONS(29427), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567887] = 2,
    ACTIONS(29429), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567897] = 2,
    ACTIONS(29431), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567907] = 2,
    ACTIONS(29433), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567917] = 2,
    ACTIONS(29435), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567927] = 2,
    ACTIONS(29437), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567937] = 2,
    ACTIONS(27091), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567947] = 2,
    ACTIONS(29439), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567957] = 2,
    ACTIONS(29441), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567967] = 2,
    ACTIONS(29443), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567977] = 2,
    ACTIONS(29445), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567987] = 2,
    ACTIONS(29447), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [567997] = 2,
    ACTIONS(29449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568007] = 2,
    ACTIONS(29451), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568017] = 2,
    ACTIONS(20425), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568027] = 2,
    ACTIONS(29453), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568037] = 2,
    ACTIONS(29455), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568047] = 2,
    ACTIONS(29457), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568057] = 2,
    ACTIONS(15257), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568067] = 2,
    ACTIONS(29459), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568077] = 2,
    ACTIONS(15301), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568087] = 2,
    ACTIONS(22461), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568097] = 2,
    ACTIONS(29461), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568107] = 2,
    ACTIONS(29463), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568117] = 2,
    ACTIONS(29465), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568127] = 2,
    ACTIONS(29467), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568137] = 2,
    ACTIONS(29469), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568147] = 2,
    ACTIONS(29471), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568157] = 2,
    ACTIONS(29473), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568167] = 2,
    ACTIONS(29475), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568177] = 2,
    ACTIONS(29477), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568187] = 2,
    ACTIONS(29479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568197] = 2,
    ACTIONS(29481), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568207] = 2,
    ACTIONS(29483), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568217] = 2,
    ACTIONS(29485), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568227] = 2,
    ACTIONS(29487), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568237] = 2,
    ACTIONS(29489), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568247] = 2,
    ACTIONS(29491), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568257] = 2,
    ACTIONS(29493), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568267] = 2,
    ACTIONS(15379), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568277] = 2,
    ACTIONS(29495), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568287] = 2,
    ACTIONS(29497), 1,
      sym_where,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568297] = 2,
    ACTIONS(29499), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568307] = 2,
    ACTIONS(29501), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568317] = 2,
    ACTIONS(29503), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568327] = 2,
    ACTIONS(19913), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568337] = 2,
    ACTIONS(29505), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568347] = 2,
    ACTIONS(29507), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568357] = 2,
    ACTIONS(15285), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568367] = 2,
    ACTIONS(29509), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568377] = 2,
    ACTIONS(29511), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568387] = 2,
    ACTIONS(29513), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568397] = 2,
    ACTIONS(29515), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568407] = 2,
    ACTIONS(20532), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568417] = 2,
    ACTIONS(29517), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568427] = 2,
    ACTIONS(29519), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568437] = 2,
    ACTIONS(29521), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568447] = 2,
    ACTIONS(29523), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568457] = 2,
    ACTIONS(29525), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568467] = 2,
    ACTIONS(29527), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568477] = 2,
    ACTIONS(29529), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568487] = 2,
    ACTIONS(29531), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568497] = 2,
    ACTIONS(29533), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568507] = 2,
    ACTIONS(29535), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568517] = 2,
    ACTIONS(15249), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568527] = 2,
    ACTIONS(19721), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568537] = 2,
    ACTIONS(29537), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568547] = 2,
    ACTIONS(29539), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568557] = 2,
    ACTIONS(20540), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568567] = 2,
    ACTIONS(29541), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568577] = 2,
    ACTIONS(29543), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568587] = 2,
    ACTIONS(29545), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568597] = 2,
    ACTIONS(29547), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568607] = 2,
    ACTIONS(29549), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568617] = 2,
    ACTIONS(29551), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568627] = 2,
    ACTIONS(29553), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568637] = 2,
    ACTIONS(29555), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568647] = 2,
    ACTIONS(29557), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568657] = 2,
    ACTIONS(29559), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568667] = 2,
    ACTIONS(29561), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568677] = 2,
    ACTIONS(29563), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568687] = 2,
    ACTIONS(4279), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568697] = 2,
    ACTIONS(29565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568707] = 2,
    ACTIONS(29567), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568717] = 2,
    ACTIONS(27193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568727] = 2,
    ACTIONS(29569), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568737] = 2,
    ACTIONS(29571), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568747] = 2,
    ACTIONS(29573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568757] = 2,
    ACTIONS(29575), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568767] = 2,
    ACTIONS(29577), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568777] = 2,
    ACTIONS(29579), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568787] = 2,
    ACTIONS(29581), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568797] = 2,
    ACTIONS(20140), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568807] = 2,
    ACTIONS(29583), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568817] = 2,
    ACTIONS(29585), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568827] = 2,
    ACTIONS(29587), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568837] = 2,
    ACTIONS(20873), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568847] = 2,
    ACTIONS(29589), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568857] = 2,
    ACTIONS(29591), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568867] = 2,
    ACTIONS(18970), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568877] = 2,
    ACTIONS(29593), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568887] = 2,
    ACTIONS(29595), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568897] = 2,
    ACTIONS(4303), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568907] = 2,
    ACTIONS(29597), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568917] = 2,
    ACTIONS(29599), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568927] = 2,
    ACTIONS(29601), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568937] = 2,
    ACTIONS(29603), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568947] = 2,
    ACTIONS(29605), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568957] = 2,
    ACTIONS(29607), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568967] = 2,
    ACTIONS(20574), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568977] = 2,
    ACTIONS(20959), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568987] = 2,
    ACTIONS(29609), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [568997] = 2,
    ACTIONS(29611), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569007] = 2,
    ACTIONS(29613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569017] = 2,
    ACTIONS(26995), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569027] = 2,
    ACTIONS(27657), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569037] = 2,
    ACTIONS(4197), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569047] = 2,
    ACTIONS(29615), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569057] = 2,
    ACTIONS(15269), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569067] = 2,
    ACTIONS(29617), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569077] = 2,
    ACTIONS(29619), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569087] = 2,
    ACTIONS(29621), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569097] = 2,
    ACTIONS(20973), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569107] = 2,
    ACTIONS(29623), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569117] = 2,
    ACTIONS(29625), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569127] = 2,
    ACTIONS(29627), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569137] = 2,
    ACTIONS(29629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569147] = 2,
    ACTIONS(29631), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569157] = 2,
    ACTIONS(29633), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569167] = 2,
    ACTIONS(29635), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569177] = 2,
    ACTIONS(29637), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569187] = 2,
    ACTIONS(29639), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569197] = 2,
    ACTIONS(29641), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569207] = 2,
    ACTIONS(29643), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569217] = 2,
    ACTIONS(29645), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569227] = 2,
    ACTIONS(29647), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569237] = 2,
    ACTIONS(29649), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569247] = 2,
    ACTIONS(29651), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569257] = 2,
    ACTIONS(29653), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569267] = 2,
    ACTIONS(29655), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569277] = 2,
    ACTIONS(16053), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569287] = 2,
    ACTIONS(29657), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569297] = 2,
    ACTIONS(29659), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569307] = 2,
    ACTIONS(29661), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569317] = 2,
    ACTIONS(27607), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569327] = 2,
    ACTIONS(29663), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569337] = 2,
    ACTIONS(29665), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569347] = 2,
    ACTIONS(29667), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569357] = 2,
    ACTIONS(29669), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569367] = 2,
    ACTIONS(29671), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569377] = 2,
    ACTIONS(29673), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569387] = 2,
    ACTIONS(29675), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569397] = 2,
    ACTIONS(29677), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569407] = 2,
    ACTIONS(29679), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569417] = 2,
    ACTIONS(29681), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569427] = 2,
    ACTIONS(29683), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569437] = 2,
    ACTIONS(29685), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569447] = 2,
    ACTIONS(29687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569457] = 2,
    ACTIONS(29689), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569467] = 2,
    ACTIONS(29691), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569477] = 2,
    ACTIONS(15295), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569487] = 2,
    ACTIONS(29693), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569497] = 2,
    ACTIONS(29695), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569507] = 2,
    ACTIONS(15387), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569517] = 2,
    ACTIONS(29697), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569527] = 2,
    ACTIONS(29699), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569537] = 2,
    ACTIONS(29701), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569547] = 2,
    ACTIONS(29703), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569557] = 2,
    ACTIONS(29705), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569567] = 2,
    ACTIONS(29707), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569577] = 2,
    ACTIONS(20650), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569587] = 2,
    ACTIONS(29709), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569597] = 2,
    ACTIONS(29711), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569607] = 2,
    ACTIONS(4183), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569617] = 2,
    ACTIONS(29713), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569627] = 2,
    ACTIONS(15337), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569637] = 2,
    ACTIONS(15315), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569647] = 2,
    ACTIONS(29715), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569657] = 2,
    ACTIONS(29717), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569667] = 2,
    ACTIONS(29719), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569677] = 2,
    ACTIONS(20114), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569687] = 2,
    ACTIONS(29721), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569697] = 2,
    ACTIONS(29723), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569707] = 2,
    ACTIONS(29725), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569717] = 2,
    ACTIONS(29727), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569727] = 2,
    ACTIONS(29729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569737] = 2,
    ACTIONS(29731), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569747] = 2,
    ACTIONS(29733), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569757] = 2,
    ACTIONS(29735), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569767] = 2,
    ACTIONS(29737), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569777] = 2,
    ACTIONS(29739), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569787] = 2,
    ACTIONS(29741), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569797] = 2,
    ACTIONS(29743), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569807] = 2,
    ACTIONS(29745), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569817] = 2,
    ACTIONS(29747), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569827] = 2,
    ACTIONS(29749), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569837] = 2,
    ACTIONS(29751), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569847] = 2,
    ACTIONS(20660), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569857] = 2,
    ACTIONS(29753), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569867] = 2,
    ACTIONS(29755), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569877] = 2,
    ACTIONS(29757), 1,
      sym_where,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569887] = 2,
    ACTIONS(29759), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569897] = 2,
    ACTIONS(29761), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569907] = 2,
    ACTIONS(29763), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569917] = 2,
    ACTIONS(29765), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569927] = 2,
    ACTIONS(29767), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569937] = 2,
    ACTIONS(21046), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569947] = 2,
    ACTIONS(29769), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569957] = 2,
    ACTIONS(29771), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569967] = 2,
    ACTIONS(29773), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569977] = 2,
    ACTIONS(29775), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569987] = 2,
    ACTIONS(29777), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [569997] = 2,
    ACTIONS(29779), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570007] = 2,
    ACTIONS(29781), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570017] = 2,
    ACTIONS(29783), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570027] = 2,
    ACTIONS(29785), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570037] = 2,
    ACTIONS(29787), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570047] = 2,
    ACTIONS(29789), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570057] = 2,
    ACTIONS(29791), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570067] = 2,
    ACTIONS(29793), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570077] = 2,
    ACTIONS(29795), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570087] = 2,
    ACTIONS(29797), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570097] = 2,
    ACTIONS(29799), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570107] = 2,
    ACTIONS(29801), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570117] = 2,
    ACTIONS(29803), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570127] = 2,
    ACTIONS(29805), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570137] = 2,
    ACTIONS(29807), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570147] = 2,
    ACTIONS(29809), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570157] = 2,
    ACTIONS(29811), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570167] = 2,
    ACTIONS(21016), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570177] = 2,
    ACTIONS(29813), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570187] = 2,
    ACTIONS(29815), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570197] = 2,
    ACTIONS(29817), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570207] = 2,
    ACTIONS(29819), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570217] = 2,
    ACTIONS(29821), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570227] = 2,
    ACTIONS(29823), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570237] = 2,
    ACTIONS(27749), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570247] = 2,
    ACTIONS(29825), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570257] = 2,
    ACTIONS(29827), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570267] = 2,
    ACTIONS(29829), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570277] = 2,
    ACTIONS(29831), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570287] = 2,
    ACTIONS(29833), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570297] = 2,
    ACTIONS(19504), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570307] = 2,
    ACTIONS(29835), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570317] = 2,
    ACTIONS(26881), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570327] = 2,
    ACTIONS(29837), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570337] = 2,
    ACTIONS(4069), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570347] = 2,
    ACTIONS(29839), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570357] = 2,
    ACTIONS(29841), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570367] = 2,
    ACTIONS(15283), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570377] = 2,
    ACTIONS(29843), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570387] = 2,
    ACTIONS(20983), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570397] = 2,
    ACTIONS(29845), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570407] = 2,
    ACTIONS(29847), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570417] = 2,
    ACTIONS(29849), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570427] = 2,
    ACTIONS(29851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570437] = 2,
    ACTIONS(29853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570447] = 2,
    ACTIONS(29855), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570457] = 2,
    ACTIONS(29857), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570467] = 2,
    ACTIONS(29859), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570477] = 2,
    ACTIONS(29861), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570487] = 2,
    ACTIONS(29863), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570497] = 2,
    ACTIONS(29865), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570507] = 2,
    ACTIONS(26771), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570517] = 2,
    ACTIONS(29867), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570527] = 2,
    ACTIONS(4167), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570537] = 2,
    ACTIONS(29869), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570547] = 2,
    ACTIONS(29871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570557] = 2,
    ACTIONS(29873), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570567] = 2,
    ACTIONS(29875), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570577] = 2,
    ACTIONS(29877), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570587] = 2,
    ACTIONS(29879), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570597] = 2,
    ACTIONS(29881), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570607] = 2,
    ACTIONS(29883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570617] = 2,
    ACTIONS(29885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570627] = 2,
    ACTIONS(29887), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570637] = 2,
    ACTIONS(29889), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570647] = 2,
    ACTIONS(29891), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570657] = 2,
    ACTIONS(29893), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570667] = 2,
    ACTIONS(29895), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570677] = 2,
    ACTIONS(29897), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570687] = 2,
    ACTIONS(29899), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570697] = 2,
    ACTIONS(29901), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570707] = 2,
    ACTIONS(29903), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570717] = 2,
    ACTIONS(29905), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570727] = 2,
    ACTIONS(15255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570737] = 2,
    ACTIONS(29907), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570747] = 2,
    ACTIONS(29909), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570757] = 2,
    ACTIONS(26841), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570767] = 2,
    ACTIONS(29911), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570777] = 2,
    ACTIONS(29913), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570787] = 2,
    ACTIONS(29915), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570797] = 2,
    ACTIONS(29917), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570807] = 2,
    ACTIONS(19512), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570817] = 2,
    ACTIONS(29919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570827] = 2,
    ACTIONS(29921), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570837] = 2,
    ACTIONS(29923), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570847] = 2,
    ACTIONS(29925), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570857] = 2,
    ACTIONS(29927), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570867] = 2,
    ACTIONS(29929), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570877] = 2,
    ACTIONS(15355), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570887] = 2,
    ACTIONS(29931), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570897] = 2,
    ACTIONS(20720), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570907] = 2,
    ACTIONS(29933), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570917] = 2,
    ACTIONS(29935), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570927] = 2,
    ACTIONS(29937), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570937] = 2,
    ACTIONS(29939), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570947] = 2,
    ACTIONS(29941), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570957] = 2,
    ACTIONS(29943), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570967] = 2,
    ACTIONS(26811), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570977] = 2,
    ACTIONS(29945), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570987] = 2,
    ACTIONS(4249), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [570997] = 2,
    ACTIONS(26663), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571007] = 2,
    ACTIONS(4157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571017] = 2,
    ACTIONS(29947), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571027] = 2,
    ACTIONS(29949), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571037] = 2,
    ACTIONS(29951), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571047] = 2,
    ACTIONS(29953), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571057] = 2,
    ACTIONS(29955), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571067] = 2,
    ACTIONS(20730), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571077] = 2,
    ACTIONS(29957), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571087] = 2,
    ACTIONS(29959), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571097] = 2,
    ACTIONS(29961), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571107] = 2,
    ACTIONS(29963), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571117] = 2,
    ACTIONS(29965), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571127] = 2,
    ACTIONS(29967), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571137] = 2,
    ACTIONS(29969), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571147] = 2,
    ACTIONS(29971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571157] = 2,
    ACTIONS(29973), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571167] = 2,
    ACTIONS(29975), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571177] = 2,
    ACTIONS(29977), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571187] = 2,
    ACTIONS(20849), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571197] = 2,
    ACTIONS(29979), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571207] = 2,
    ACTIONS(29981), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571217] = 2,
    ACTIONS(29983), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571227] = 2,
    ACTIONS(29985), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571237] = 2,
    ACTIONS(29987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571247] = 2,
    ACTIONS(29989), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571257] = 2,
    ACTIONS(29991), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571267] = 2,
    ACTIONS(29993), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571277] = 2,
    ACTIONS(20734), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571287] = 2,
    ACTIONS(19860), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571297] = 2,
    ACTIONS(29995), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571307] = 2,
    ACTIONS(29997), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571317] = 2,
    ACTIONS(29999), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571327] = 2,
    ACTIONS(30001), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571337] = 2,
    ACTIONS(30003), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571347] = 2,
    ACTIONS(30005), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571357] = 2,
    ACTIONS(30007), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571367] = 2,
    ACTIONS(30009), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571377] = 2,
    ACTIONS(30011), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571387] = 2,
    ACTIONS(26611), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571397] = 2,
    ACTIONS(30013), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571407] = 2,
    ACTIONS(4147), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571417] = 2,
    ACTIONS(30015), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571427] = 2,
    ACTIONS(30017), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571437] = 2,
    ACTIONS(30019), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571447] = 2,
    ACTIONS(15311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571457] = 2,
    ACTIONS(30021), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571467] = 2,
    ACTIONS(30023), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571477] = 2,
    ACTIONS(20816), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571487] = 2,
    ACTIONS(30025), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571497] = 2,
    ACTIONS(30027), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571507] = 2,
    ACTIONS(30029), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571517] = 2,
    ACTIONS(4189), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571527] = 2,
    ACTIONS(30031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571537] = 2,
    ACTIONS(30033), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571547] = 2,
    ACTIONS(30035), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571557] = 2,
    ACTIONS(30037), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571567] = 2,
    ACTIONS(30039), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571577] = 2,
    ACTIONS(30041), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571587] = 2,
    ACTIONS(30043), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571597] = 2,
    ACTIONS(30045), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571607] = 2,
    ACTIONS(30047), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571617] = 2,
    ACTIONS(30049), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571627] = 2,
    ACTIONS(4093), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571637] = 2,
    ACTIONS(15403), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571647] = 2,
    ACTIONS(30051), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571657] = 2,
    ACTIONS(30053), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571667] = 2,
    ACTIONS(30055), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571677] = 2,
    ACTIONS(30057), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571687] = 2,
    ACTIONS(30059), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571697] = 2,
    ACTIONS(26729), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571707] = 2,
    ACTIONS(30061), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571717] = 2,
    ACTIONS(30063), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571727] = 2,
    ACTIONS(30065), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571737] = 2,
    ACTIONS(30067), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571747] = 2,
    ACTIONS(20744), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571757] = 2,
    ACTIONS(20794), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571767] = 2,
    ACTIONS(30069), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571777] = 2,
    ACTIONS(30071), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571787] = 2,
    ACTIONS(30073), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571797] = 2,
    ACTIONS(15237), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571807] = 2,
    ACTIONS(30075), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571817] = 2,
    ACTIONS(30077), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571827] = 2,
    ACTIONS(30079), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571837] = 2,
    ACTIONS(30081), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571847] = 2,
    ACTIONS(30083), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571857] = 2,
    ACTIONS(30085), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571867] = 2,
    ACTIONS(30087), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571877] = 2,
    ACTIONS(26569), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571887] = 2,
    ACTIONS(30089), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571897] = 2,
    ACTIONS(30091), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571907] = 2,
    ACTIONS(4139), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571917] = 2,
    ACTIONS(30093), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571927] = 2,
    ACTIONS(30095), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571937] = 2,
    ACTIONS(30097), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571947] = 2,
    ACTIONS(30099), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571957] = 2,
    ACTIONS(30101), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571967] = 2,
    ACTIONS(30103), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571977] = 2,
    ACTIONS(30105), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571987] = 2,
    ACTIONS(30107), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [571997] = 2,
    ACTIONS(30109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572007] = 2,
    ACTIONS(30111), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572017] = 2,
    ACTIONS(15305), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572027] = 2,
    ACTIONS(30113), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572037] = 2,
    ACTIONS(30115), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572047] = 2,
    ACTIONS(20857), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572057] = 2,
    ACTIONS(15263), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572067] = 2,
    ACTIONS(30117), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572077] = 2,
    ACTIONS(4283), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572087] = 2,
    ACTIONS(30119), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572097] = 2,
    ACTIONS(30121), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572107] = 2,
    ACTIONS(30123), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572117] = 2,
    ACTIONS(30125), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572127] = 2,
    ACTIONS(30127), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572137] = 2,
    ACTIONS(19738), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572147] = 2,
    ACTIONS(30129), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572157] = 2,
    ACTIONS(15347), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572167] = 2,
    ACTIONS(30131), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572177] = 2,
    ACTIONS(15409), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572187] = 2,
    ACTIONS(30133), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572197] = 2,
    ACTIONS(30135), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572207] = 2,
    ACTIONS(30137), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572217] = 2,
    ACTIONS(30139), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572227] = 2,
    ACTIONS(30141), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572237] = 2,
    ACTIONS(30143), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572247] = 2,
    ACTIONS(30145), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572257] = 2,
    ACTIONS(30147), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572267] = 2,
    ACTIONS(30149), 1,
      sym_where,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572277] = 2,
    ACTIONS(30151), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572287] = 2,
    ACTIONS(30153), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572297] = 2,
    ACTIONS(30155), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572307] = 2,
    ACTIONS(30157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572317] = 2,
    ACTIONS(30159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572327] = 2,
    ACTIONS(30161), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572337] = 2,
    ACTIONS(20780), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572347] = 2,
    ACTIONS(30163), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572357] = 2,
    ACTIONS(30165), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572367] = 2,
    ACTIONS(30167), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572377] = 2,
    ACTIONS(30169), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572387] = 2,
    ACTIONS(4187), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572397] = 2,
    ACTIONS(30171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572407] = 2,
    ACTIONS(26527), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572417] = 2,
    ACTIONS(30173), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572427] = 2,
    ACTIONS(30175), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572437] = 2,
    ACTIONS(30177), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572447] = 2,
    ACTIONS(4091), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572457] = 2,
    ACTIONS(20784), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572467] = 2,
    ACTIONS(30179), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572477] = 2,
    ACTIONS(30181), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572487] = 2,
    ACTIONS(30183), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572497] = 2,
    ACTIONS(30185), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572507] = 2,
    ACTIONS(30187), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572517] = 2,
    ACTIONS(30189), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572527] = 2,
    ACTIONS(30191), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572537] = 2,
    ACTIONS(30193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572547] = 2,
    ACTIONS(13129), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572557] = 2,
    ACTIONS(30195), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572567] = 2,
    ACTIONS(30197), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572577] = 2,
    ACTIONS(30199), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572587] = 2,
    ACTIONS(30201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572597] = 2,
    ACTIONS(30203), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572607] = 2,
    ACTIONS(30205), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572617] = 2,
    ACTIONS(30207), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572627] = 2,
    ACTIONS(30209), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572637] = 2,
    ACTIONS(30211), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572647] = 2,
    ACTIONS(30213), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572657] = 2,
    ACTIONS(30215), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572667] = 2,
    ACTIONS(30217), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572677] = 2,
    ACTIONS(30219), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572687] = 2,
    ACTIONS(30221), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572697] = 2,
    ACTIONS(30223), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572707] = 2,
    ACTIONS(30225), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572717] = 2,
    ACTIONS(30227), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572727] = 2,
    ACTIONS(30229), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572737] = 2,
    ACTIONS(30231), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572747] = 2,
    ACTIONS(30233), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572757] = 2,
    ACTIONS(30235), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572767] = 2,
    ACTIONS(30237), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572777] = 2,
    ACTIONS(30239), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572787] = 2,
    ACTIONS(30241), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572797] = 2,
    ACTIONS(30243), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572807] = 2,
    ACTIONS(30245), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572817] = 2,
    ACTIONS(12947), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572827] = 2,
    ACTIONS(30247), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572837] = 2,
    ACTIONS(30249), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572847] = 2,
    ACTIONS(30251), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572857] = 2,
    ACTIONS(30253), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572867] = 2,
    ACTIONS(30255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572877] = 2,
    ACTIONS(30257), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572887] = 2,
    ACTIONS(19609), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572897] = 2,
    ACTIONS(30259), 1,
      sym_where,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572907] = 2,
    ACTIONS(30261), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572917] = 2,
    ACTIONS(30263), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572927] = 2,
    ACTIONS(30265), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572937] = 2,
    ACTIONS(30267), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572947] = 2,
    ACTIONS(30269), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572957] = 2,
    ACTIONS(30271), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572967] = 2,
    ACTIONS(215), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572977] = 2,
    ACTIONS(20560), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572987] = 2,
    ACTIONS(30273), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [572997] = 2,
    ACTIONS(15299), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573007] = 2,
    ACTIONS(4299), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573017] = 2,
    ACTIONS(30275), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573027] = 2,
    ACTIONS(30277), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573037] = 2,
    ACTIONS(21661), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573047] = 2,
    ACTIONS(20550), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573057] = 2,
    ACTIONS(30279), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573067] = 2,
    ACTIONS(30281), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573077] = 2,
    ACTIONS(13736), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573087] = 2,
    ACTIONS(30283), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573097] = 2,
    ACTIONS(19595), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573107] = 2,
    ACTIONS(30285), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573117] = 2,
    ACTIONS(30287), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573127] = 2,
    ACTIONS(21713), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573137] = 2,
    ACTIONS(30289), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573147] = 2,
    ACTIONS(30291), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573157] = 2,
    ACTIONS(30293), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573167] = 2,
    ACTIONS(30295), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573177] = 2,
    ACTIONS(30297), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573187] = 2,
    ACTIONS(30299), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573197] = 2,
    ACTIONS(30301), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573207] = 2,
    ACTIONS(20520), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573217] = 2,
    ACTIONS(30303), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573227] = 2,
    ACTIONS(30305), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573237] = 2,
    ACTIONS(30307), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573247] = 2,
    ACTIONS(30309), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573257] = 2,
    ACTIONS(30311), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573267] = 2,
    ACTIONS(30313), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573277] = 2,
    ACTIONS(30315), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573287] = 2,
    ACTIONS(30317), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573297] = 2,
    ACTIONS(30319), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573307] = 2,
    ACTIONS(30321), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573317] = 2,
    ACTIONS(20839), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573327] = 2,
    ACTIONS(30323), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573337] = 2,
    ACTIONS(30325), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573347] = 2,
    ACTIONS(30327), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573357] = 2,
    ACTIONS(30329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573367] = 2,
    ACTIONS(20477), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573377] = 2,
    ACTIONS(30331), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573387] = 2,
    ACTIONS(30333), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573397] = 2,
    ACTIONS(30335), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573407] = 2,
    ACTIONS(30337), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573417] = 2,
    ACTIONS(18907), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573427] = 2,
    ACTIONS(30339), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573437] = 2,
    ACTIONS(30341), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573447] = 2,
    ACTIONS(30343), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573457] = 2,
    ACTIONS(30345), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573467] = 2,
    ACTIONS(30347), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573477] = 2,
    ACTIONS(30349), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573487] = 2,
    ACTIONS(30351), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573497] = 2,
    ACTIONS(30353), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573507] = 2,
    ACTIONS(30355), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573517] = 2,
    ACTIONS(30357), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573527] = 2,
    ACTIONS(30359), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573537] = 2,
    ACTIONS(30361), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573547] = 2,
    ACTIONS(30363), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573557] = 2,
    ACTIONS(26613), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573567] = 2,
    ACTIONS(30365), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573577] = 2,
    ACTIONS(20845), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573587] = 2,
    ACTIONS(30367), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573597] = 2,
    ACTIONS(30369), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573607] = 2,
    ACTIONS(30371), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573617] = 2,
    ACTIONS(20455), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573627] = 2,
    ACTIONS(30373), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573637] = 2,
    ACTIONS(30375), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573647] = 2,
    ACTIONS(30377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573657] = 2,
    ACTIONS(30379), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573667] = 2,
    ACTIONS(30381), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573677] = 2,
    ACTIONS(30383), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573687] = 2,
    ACTIONS(30385), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573697] = 2,
    ACTIONS(20885), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573707] = 2,
    ACTIONS(30387), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573717] = 2,
    ACTIONS(30389), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573727] = 2,
    ACTIONS(30391), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573737] = 2,
    ACTIONS(30393), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573747] = 2,
    ACTIONS(30395), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573757] = 2,
    ACTIONS(30397), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573767] = 2,
    ACTIONS(30399), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573777] = 2,
    ACTIONS(30401), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573787] = 2,
    ACTIONS(30403), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573797] = 2,
    ACTIONS(30405), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573807] = 2,
    ACTIONS(30407), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573817] = 2,
    ACTIONS(30409), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573827] = 2,
    ACTIONS(30411), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573837] = 2,
    ACTIONS(30413), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573847] = 2,
    ACTIONS(30415), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573857] = 2,
    ACTIONS(30417), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573867] = 2,
    ACTIONS(30419), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573877] = 2,
    ACTIONS(30421), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573887] = 2,
    ACTIONS(30423), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573897] = 2,
    ACTIONS(30425), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573907] = 2,
    ACTIONS(30427), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573917] = 2,
    ACTIONS(30429), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573927] = 2,
    ACTIONS(30431), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573937] = 2,
    ACTIONS(30433), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573947] = 2,
    ACTIONS(30435), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573957] = 2,
    ACTIONS(30437), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573967] = 2,
    ACTIONS(30439), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573977] = 2,
    ACTIONS(30441), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573987] = 2,
    ACTIONS(30443), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [573997] = 2,
    ACTIONS(30445), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574007] = 2,
    ACTIONS(30447), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574017] = 2,
    ACTIONS(30449), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574027] = 2,
    ACTIONS(30451), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574037] = 2,
    ACTIONS(19729), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574047] = 2,
    ACTIONS(30453), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574057] = 2,
    ACTIONS(30455), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574067] = 2,
    ACTIONS(30457), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574077] = 2,
    ACTIONS(15331), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574087] = 2,
    ACTIONS(30459), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574097] = 2,
    ACTIONS(30461), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574107] = 2,
    ACTIONS(30463), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574117] = 2,
    ACTIONS(30465), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574127] = 2,
    ACTIONS(30467), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574137] = 2,
    ACTIONS(26831), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574147] = 2,
    ACTIONS(30469), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574157] = 2,
    ACTIONS(4255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574167] = 2,
    ACTIONS(15385), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574177] = 2,
    ACTIONS(30471), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574187] = 2,
    ACTIONS(30473), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574197] = 2,
    ACTIONS(20877), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574207] = 2,
    ACTIONS(30475), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574217] = 2,
    ACTIONS(30477), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574227] = 2,
    ACTIONS(30479), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574237] = 2,
    ACTIONS(30481), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574247] = 2,
    ACTIONS(30483), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574257] = 2,
    ACTIONS(30485), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574267] = 2,
    ACTIONS(30487), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574277] = 2,
    ACTIONS(30489), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574287] = 2,
    ACTIONS(30491), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574297] = 2,
    ACTIONS(30493), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574307] = 2,
    ACTIONS(30495), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574317] = 2,
    ACTIONS(30497), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574327] = 2,
    ACTIONS(15235), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574337] = 2,
    ACTIONS(30499), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574347] = 2,
    ACTIONS(30501), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574357] = 2,
    ACTIONS(30503), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574367] = 2,
    ACTIONS(30505), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574377] = 2,
    ACTIONS(30507), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574387] = 2,
    ACTIONS(30509), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574397] = 2,
    ACTIONS(30511), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574407] = 2,
    ACTIONS(30513), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574417] = 2,
    ACTIONS(30515), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574427] = 2,
    ACTIONS(30517), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574437] = 2,
    ACTIONS(15339), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574447] = 2,
    ACTIONS(30519), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574457] = 2,
    ACTIONS(20897), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574467] = 2,
    ACTIONS(30521), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574477] = 2,
    ACTIONS(26587), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574487] = 2,
    ACTIONS(4307), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574497] = 2,
    ACTIONS(30523), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574507] = 2,
    ACTIONS(30525), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574517] = 2,
    ACTIONS(30527), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574527] = 2,
    ACTIONS(30529), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574537] = 2,
    ACTIONS(15377), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574547] = 2,
    ACTIONS(30531), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574557] = 2,
    ACTIONS(4305), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574567] = 2,
    ACTIONS(27631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574577] = 2,
    ACTIONS(30533), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574587] = 2,
    ACTIONS(30535), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574597] = 2,
    ACTIONS(30537), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574607] = 2,
    ACTIONS(30539), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574617] = 2,
    ACTIONS(30541), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574627] = 2,
    ACTIONS(30543), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574637] = 2,
    ACTIONS(30545), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574647] = 2,
    ACTIONS(30547), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574657] = 2,
    ACTIONS(30549), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574667] = 2,
    ACTIONS(30551), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574677] = 2,
    ACTIONS(30553), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574687] = 2,
    ACTIONS(30555), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574697] = 2,
    ACTIONS(27479), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574707] = 2,
    ACTIONS(30557), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574717] = 2,
    ACTIONS(30559), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574727] = 2,
    ACTIONS(30561), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574737] = 2,
    ACTIONS(15399), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574747] = 2,
    ACTIONS(30563), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574757] = 2,
    ACTIONS(20947), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574767] = 2,
    ACTIONS(30565), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574777] = 2,
    ACTIONS(30567), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574787] = 2,
    ACTIONS(30569), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574797] = 2,
    ACTIONS(30571), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574807] = 2,
    ACTIONS(30573), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574817] = 2,
    ACTIONS(30575), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574827] = 2,
    ACTIONS(30577), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574837] = 2,
    ACTIONS(30579), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574847] = 2,
    ACTIONS(30581), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574857] = 2,
    ACTIONS(30583), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574867] = 2,
    ACTIONS(30585), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574877] = 2,
    ACTIONS(30587), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574887] = 2,
    ACTIONS(13131), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574897] = 2,
    ACTIONS(30589), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574907] = 2,
    ACTIONS(30591), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574917] = 2,
    ACTIONS(30593), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574927] = 2,
    ACTIONS(20955), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574937] = 2,
    ACTIONS(30595), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574947] = 2,
    ACTIONS(30597), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574957] = 2,
    ACTIONS(20292), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574967] = 2,
    ACTIONS(30599), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574977] = 2,
    ACTIONS(30601), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574987] = 2,
    ACTIONS(30603), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [574997] = 2,
    ACTIONS(30605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575007] = 2,
    ACTIONS(30607), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575017] = 2,
    ACTIONS(30609), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575027] = 2,
    ACTIONS(30611), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575037] = 2,
    ACTIONS(30613), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575047] = 2,
    ACTIONS(30615), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575057] = 2,
    ACTIONS(30617), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575067] = 2,
    ACTIONS(30619), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575077] = 2,
    ACTIONS(30621), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575087] = 2,
    ACTIONS(30623), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575097] = 2,
    ACTIONS(30625), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575107] = 2,
    ACTIONS(30627), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575117] = 2,
    ACTIONS(30629), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575127] = 2,
    ACTIONS(30631), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575137] = 2,
    ACTIONS(30633), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575147] = 2,
    ACTIONS(30635), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575157] = 2,
    ACTIONS(30637), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575167] = 2,
    ACTIONS(30639), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575177] = 2,
    ACTIONS(30641), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575187] = 2,
    ACTIONS(30643), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575197] = 2,
    ACTIONS(30645), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575207] = 2,
    ACTIONS(15333), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575217] = 2,
    ACTIONS(30647), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575227] = 2,
    ACTIONS(30649), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575237] = 2,
    ACTIONS(19850), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575247] = 2,
    ACTIONS(12555), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575257] = 2,
    ACTIONS(30651), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575267] = 2,
    ACTIONS(30653), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575277] = 2,
    ACTIONS(30655), 1,
      anon_sym_EQ,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575287] = 2,
    ACTIONS(30657), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575297] = 2,
    ACTIONS(30659), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575307] = 2,
    ACTIONS(30661), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575317] = 2,
    ACTIONS(30663), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575327] = 2,
    ACTIONS(30665), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575337] = 2,
    ACTIONS(30667), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575347] = 2,
    ACTIONS(30669), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575357] = 2,
    ACTIONS(30671), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575367] = 2,
    ACTIONS(30673), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575377] = 2,
    ACTIONS(30675), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575387] = 2,
    ACTIONS(30677), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575397] = 2,
    ACTIONS(20144), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575407] = 2,
    ACTIONS(4173), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575417] = 2,
    ACTIONS(20134), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575427] = 2,
    ACTIONS(30679), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575437] = 2,
    ACTIONS(30681), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575447] = 2,
    ACTIONS(14042), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575457] = 2,
    ACTIONS(26979), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575467] = 2,
    ACTIONS(30683), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575477] = 2,
    ACTIONS(20126), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575487] = 2,
    ACTIONS(30685), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575497] = 2,
    ACTIONS(30687), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575507] = 2,
    ACTIONS(30689), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575517] = 2,
    ACTIONS(20108), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575527] = 2,
    ACTIONS(30691), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575537] = 2,
    ACTIONS(30693), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575547] = 2,
    ACTIONS(30695), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575557] = 2,
    ACTIONS(30697), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575567] = 2,
    ACTIONS(27439), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575577] = 2,
    ACTIONS(30699), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575587] = 2,
    ACTIONS(30701), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575597] = 2,
    ACTIONS(21351), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575607] = 2,
    ACTIONS(30703), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575617] = 2,
    ACTIONS(30705), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575627] = 2,
    ACTIONS(30707), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575637] = 2,
    ACTIONS(30709), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575647] = 2,
    ACTIONS(30711), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575657] = 2,
    ACTIONS(30713), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575667] = 2,
    ACTIONS(30715), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575677] = 2,
    ACTIONS(30717), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575687] = 2,
    ACTIONS(30719), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575697] = 2,
    ACTIONS(20055), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575707] = 2,
    ACTIONS(15247), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575717] = 2,
    ACTIONS(30721), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575727] = 2,
    ACTIONS(26537), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575737] = 2,
    ACTIONS(4065), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575747] = 2,
    ACTIONS(30723), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575757] = 2,
    ACTIONS(30725), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575767] = 2,
    ACTIONS(30727), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575777] = 2,
    ACTIONS(30729), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575787] = 2,
    ACTIONS(30731), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575797] = 2,
    ACTIONS(30733), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575807] = 2,
    ACTIONS(30735), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575817] = 2,
    ACTIONS(30737), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575827] = 2,
    ACTIONS(30739), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575837] = 2,
    ACTIONS(30741), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575847] = 2,
    ACTIONS(21056), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575857] = 2,
    ACTIONS(20029), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575867] = 2,
    ACTIONS(30743), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575877] = 2,
    ACTIONS(30745), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575887] = 2,
    ACTIONS(30747), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575897] = 2,
    ACTIONS(30749), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575907] = 2,
    ACTIONS(30751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575917] = 2,
    ACTIONS(30753), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575927] = 2,
    ACTIONS(30755), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575937] = 2,
    ACTIONS(30757), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575947] = 2,
    ACTIONS(30759), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575957] = 2,
    ACTIONS(30761), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575967] = 2,
    ACTIONS(30763), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575977] = 2,
    ACTIONS(30765), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575987] = 2,
    ACTIONS(30767), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [575997] = 2,
    ACTIONS(30769), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576007] = 2,
    ACTIONS(30771), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576017] = 2,
    ACTIONS(30773), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576027] = 2,
    ACTIONS(30775), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576037] = 2,
    ACTIONS(21072), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576047] = 2,
    ACTIONS(30777), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576057] = 2,
    ACTIONS(26539), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576067] = 2,
    ACTIONS(30779), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576077] = 2,
    ACTIONS(30781), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576087] = 2,
    ACTIONS(30783), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576097] = 2,
    ACTIONS(30785), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576107] = 2,
    ACTIONS(30787), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576117] = 2,
    ACTIONS(30789), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576127] = 2,
    ACTIONS(30791), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576137] = 2,
    ACTIONS(30793), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576147] = 2,
    ACTIONS(19995), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576157] = 2,
    ACTIONS(30795), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576167] = 2,
    ACTIONS(30797), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576177] = 2,
    ACTIONS(30799), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576187] = 2,
    ACTIONS(30801), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576197] = 2,
    ACTIONS(30803), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576207] = 2,
    ACTIONS(30805), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576217] = 2,
    ACTIONS(30807), 1,
      anon_sym_in,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576227] = 2,
    ACTIONS(30809), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576237] = 2,
    ACTIONS(30811), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576247] = 2,
    ACTIONS(30813), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576257] = 2,
    ACTIONS(30815), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576267] = 2,
    ACTIONS(30817), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576277] = 2,
    ACTIONS(21117), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576287] = 2,
    ACTIONS(30819), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576297] = 2,
    ACTIONS(30821), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576307] = 2,
    ACTIONS(30823), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576317] = 2,
    ACTIONS(30825), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576327] = 2,
    ACTIONS(30827), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576337] = 2,
    ACTIONS(30829), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576347] = 2,
    ACTIONS(30831), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576357] = 2,
    ACTIONS(30833), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576367] = 2,
    ACTIONS(20336), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576377] = 2,
    ACTIONS(26515), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576387] = 2,
    ACTIONS(30835), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576397] = 2,
    ACTIONS(30837), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576407] = 2,
    ACTIONS(30839), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576417] = 2,
    ACTIONS(30841), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576427] = 2,
    ACTIONS(30843), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576437] = 2,
    ACTIONS(30845), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576447] = 2,
    ACTIONS(30847), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576457] = 2,
    ACTIONS(30849), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576467] = 2,
    ACTIONS(30851), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576477] = 2,
    ACTIONS(30853), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576487] = 2,
    ACTIONS(4149), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576497] = 2,
    ACTIONS(30855), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576507] = 2,
    ACTIONS(15357), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576517] = 2,
    ACTIONS(26501), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576527] = 2,
    ACTIONS(30857), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576537] = 2,
    ACTIONS(30859), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576547] = 2,
    ACTIONS(30861), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576557] = 2,
    ACTIONS(30863), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576567] = 2,
    ACTIONS(30865), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576577] = 2,
    ACTIONS(30867), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576587] = 2,
    ACTIONS(30869), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576597] = 2,
    ACTIONS(13272), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576607] = 2,
    ACTIONS(30871), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576617] = 2,
    ACTIONS(30873), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576627] = 2,
    ACTIONS(26489), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576637] = 2,
    ACTIONS(30875), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576647] = 2,
    ACTIONS(30877), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576657] = 2,
    ACTIONS(30879), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576667] = 2,
    ACTIONS(30881), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576677] = 2,
    ACTIONS(27255), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576687] = 2,
    ACTIONS(30883), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576697] = 2,
    ACTIONS(30885), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576707] = 2,
    ACTIONS(26481), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576717] = 2,
    ACTIONS(30887), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576727] = 2,
    ACTIONS(30889), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576737] = 2,
    ACTIONS(30891), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576747] = 2,
    ACTIONS(30893), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576757] = 2,
    ACTIONS(30895), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576767] = 2,
    ACTIONS(30897), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576777] = 2,
    ACTIONS(26475), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576787] = 2,
    ACTIONS(15431), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576797] = 2,
    ACTIONS(30899), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576807] = 2,
    ACTIONS(30901), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576817] = 2,
    ACTIONS(30903), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576827] = 2,
    ACTIONS(30905), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576837] = 2,
    ACTIONS(30907), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576847] = 2,
    ACTIONS(26463), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576857] = 2,
    ACTIONS(30909), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576867] = 2,
    ACTIONS(30911), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576877] = 2,
    ACTIONS(30913), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576887] = 2,
    ACTIONS(30915), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576897] = 2,
    ACTIONS(30917), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576907] = 2,
    ACTIONS(30919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576917] = 2,
    ACTIONS(26453), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576927] = 2,
    ACTIONS(30921), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576937] = 2,
    ACTIONS(30923), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576947] = 2,
    ACTIONS(30925), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576957] = 2,
    ACTIONS(30927), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576967] = 2,
    ACTIONS(30929), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576977] = 2,
    ACTIONS(30931), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576987] = 2,
    ACTIONS(26445), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [576997] = 2,
    ACTIONS(4077), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577007] = 2,
    ACTIONS(30933), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577017] = 2,
    ACTIONS(30935), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577027] = 2,
    ACTIONS(30937), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577037] = 2,
    ACTIONS(26919), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577047] = 2,
    ACTIONS(30939), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577057] = 2,
    ACTIONS(26437), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577067] = 2,
    ACTIONS(30941), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577077] = 2,
    ACTIONS(30943), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577087] = 2,
    ACTIONS(30945), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577097] = 2,
    ACTIONS(15253), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577107] = 2,
    ACTIONS(30947), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577117] = 2,
    ACTIONS(26431), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577127] = 2,
    ACTIONS(30949), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577137] = 2,
    ACTIONS(30951), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577147] = 2,
    ACTIONS(30953), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577157] = 2,
    ACTIONS(4181), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577167] = 2,
    ACTIONS(30955), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577177] = 2,
    ACTIONS(26423), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577187] = 2,
    ACTIONS(15267), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577197] = 2,
    ACTIONS(30957), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577207] = 2,
    ACTIONS(30959), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577217] = 2,
    ACTIONS(30961), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577227] = 2,
    ACTIONS(30963), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577237] = 2,
    ACTIONS(26411), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577247] = 2,
    ACTIONS(15421), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577257] = 2,
    ACTIONS(30965), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577267] = 2,
    ACTIONS(30967), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577277] = 2,
    ACTIONS(30969), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577287] = 2,
    ACTIONS(30971), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577297] = 2,
    ACTIONS(26405), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577307] = 2,
    ACTIONS(30973), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577317] = 2,
    ACTIONS(30975), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577327] = 2,
    ACTIONS(30977), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577337] = 2,
    ACTIONS(30979), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577347] = 2,
    ACTIONS(30981), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577357] = 2,
    ACTIONS(26397), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577367] = 2,
    ACTIONS(30983), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577377] = 2,
    ACTIONS(30985), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577387] = 2,
    ACTIONS(30987), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577397] = 2,
    ACTIONS(30989), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577407] = 2,
    ACTIONS(30991), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577417] = 2,
    ACTIONS(26389), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577427] = 2,
    ACTIONS(26605), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577437] = 2,
    ACTIONS(30993), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577447] = 2,
    ACTIONS(30995), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577457] = 2,
    ACTIONS(15329), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577467] = 2,
    ACTIONS(30997), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577477] = 2,
    ACTIONS(26381), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577487] = 2,
    ACTIONS(30999), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577497] = 2,
    ACTIONS(31001), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577507] = 2,
    ACTIONS(31003), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577517] = 2,
    ACTIONS(31005), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577527] = 2,
    ACTIONS(31007), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577537] = 2,
    ACTIONS(26375), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577547] = 2,
    ACTIONS(31009), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577557] = 2,
    ACTIONS(31011), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577567] = 2,
    ACTIONS(31013), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577577] = 2,
    ACTIONS(31015), 1,
      sym_quasiquote_bar,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577587] = 2,
    ACTIONS(31017), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577597] = 2,
    ACTIONS(26367), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577607] = 2,
    ACTIONS(31019), 1,
      anon_sym_of,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577617] = 2,
    ACTIONS(31021), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577627] = 2,
    ACTIONS(31023), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577637] = 2,
    ACTIONS(15317), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577647] = 2,
    ACTIONS(31025), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577657] = 2,
    ACTIONS(26361), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577667] = 2,
    ACTIONS(31027), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577677] = 2,
    ACTIONS(31029), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577687] = 2,
    ACTIONS(31031), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577697] = 2,
    ACTIONS(31033), 1,
      anon_sym_case,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577707] = 2,
    ACTIONS(31035), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577717] = 2,
    ACTIONS(26351), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577727] = 2,
    ACTIONS(21087), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577737] = 2,
    ACTIONS(31037), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577747] = 2,
    ACTIONS(4051), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577757] = 2,
    ACTIONS(31039), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577767] = 2,
    ACTIONS(31041), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577777] = 2,
    ACTIONS(26341), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577787] = 2,
    ACTIONS(31043), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577797] = 2,
    ACTIONS(31045), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577807] = 2,
    ACTIONS(31047), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577817] = 2,
    ACTIONS(31049), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577827] = 2,
    ACTIONS(31051), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577837] = 2,
    ACTIONS(26331), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577847] = 2,
    ACTIONS(31053), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577857] = 2,
    ACTIONS(31055), 1,
      anon_sym_then,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577867] = 2,
    ACTIONS(31057), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577877] = 2,
    ACTIONS(26329), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577887] = 2,
    ACTIONS(18074), 1,
      sym__dot,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577897] = 2,
    ACTIONS(31059), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577907] = 2,
    ACTIONS(26327), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577917] = 2,
    ACTIONS(31061), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577927] = 2,
    ACTIONS(15281), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577937] = 2,
    ACTIONS(26321), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577947] = 2,
    ACTIONS(31063), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577957] = 2,
    ACTIONS(31065), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577967] = 2,
    ACTIONS(26319), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577977] = 2,
    ACTIONS(31067), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577987] = 2,
    ACTIONS(19542), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [577997] = 2,
    ACTIONS(26315), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578007] = 2,
    ACTIONS(31069), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578017] = 2,
    ACTIONS(31071), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578027] = 2,
    ACTIONS(26311), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578037] = 2,
    ACTIONS(31073), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578047] = 2,
    ACTIONS(31075), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578057] = 2,
    ACTIONS(26305), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578067] = 2,
    ACTIONS(31077), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578077] = 2,
    ACTIONS(31079), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578087] = 2,
    ACTIONS(26299), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578097] = 2,
    ACTIONS(31081), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578107] = 2,
    ACTIONS(31083), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578117] = 2,
    ACTIONS(26295), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578127] = 2,
    ACTIONS(31085), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578137] = 2,
    ACTIONS(31087), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578147] = 2,
    ACTIONS(26293), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578157] = 2,
    ACTIONS(31089), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578167] = 2,
    ACTIONS(31091), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578177] = 2,
    ACTIONS(26291), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578187] = 2,
    ACTIONS(31093), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578197] = 2,
    ACTIONS(31095), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578207] = 2,
    ACTIONS(26289), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578217] = 2,
    ACTIONS(31097), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578227] = 2,
    ACTIONS(31099), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578237] = 2,
    ACTIONS(26279), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578247] = 2,
    ACTIONS(31101), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578257] = 2,
    ACTIONS(31103), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578267] = 2,
    ACTIONS(26277), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578277] = 2,
    ACTIONS(31105), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578287] = 2,
    ACTIONS(31107), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578297] = 2,
    ACTIONS(26275), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578307] = 2,
    ACTIONS(15411), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578317] = 2,
    ACTIONS(31109), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578327] = 2,
    ACTIONS(26273), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578337] = 2,
    ACTIONS(31111), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578347] = 2,
    ACTIONS(31113), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578357] = 2,
    ACTIONS(26271), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578367] = 2,
    ACTIONS(31115), 1,
      anon_sym_else,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578377] = 2,
    ACTIONS(31117), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578387] = 2,
    ACTIONS(26265), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578397] = 2,
    ACTIONS(31119), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578407] = 2,
    ACTIONS(31121), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578417] = 2,
    ACTIONS(26261), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578427] = 2,
    ACTIONS(31123), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578437] = 2,
    ACTIONS(4301), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578447] = 2,
    ACTIONS(26259), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578457] = 2,
    ACTIONS(27045), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578467] = 2,
    ACTIONS(31125), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578477] = 2,
    ACTIONS(26255), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578487] = 2,
    ACTIONS(31127), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578497] = 2,
    ACTIONS(31129), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578507] = 2,
    ACTIONS(26253), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578517] = 2,
    ACTIONS(20090), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578527] = 2,
    ACTIONS(31131), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578537] = 2,
    ACTIONS(26251), 1,
      anon_sym_BQUOTE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578547] = 2,
    ACTIONS(31133), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578557] = 2,
    ACTIONS(31135), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578567] = 2,
    ACTIONS(31137), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578577] = 2,
    ACTIONS(15395), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578587] = 2,
    ACTIONS(31139), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578597] = 2,
    ACTIONS(31141), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578607] = 2,
    ACTIONS(31143), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578617] = 2,
    ACTIONS(31145), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578627] = 2,
    ACTIONS(31147), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578637] = 2,
    ACTIONS(31149), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578647] = 2,
    ACTIONS(31151), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578657] = 2,
    ACTIONS(31153), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578667] = 2,
    ACTIONS(31155), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578677] = 2,
    ACTIONS(31157), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578687] = 2,
    ACTIONS(31159), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578697] = 2,
    ACTIONS(31161), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578707] = 2,
    ACTIONS(21095), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578717] = 2,
    ACTIONS(31163), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578727] = 2,
    ACTIONS(31165), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578737] = 2,
    ACTIONS(31167), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578747] = 2,
    ACTIONS(15407), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578757] = 2,
    ACTIONS(4295), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578767] = 2,
    ACTIONS(31169), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578777] = 2,
    ACTIONS(4215), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578787] = 2,
    ACTIONS(15389), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578797] = 2,
    ACTIONS(31171), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578807] = 2,
    ACTIONS(21107), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578817] = 2,
    ACTIONS(31173), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578827] = 2,
    ACTIONS(31175), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578837] = 2,
    ACTIONS(31177), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578847] = 2,
    ACTIONS(31179), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578857] = 2,
    ACTIONS(31181), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578867] = 2,
    ACTIONS(31183), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578877] = 2,
    ACTIONS(31185), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578887] = 2,
    ACTIONS(31187), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578897] = 2,
    ACTIONS(31189), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578907] = 2,
    ACTIONS(31191), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578917] = 2,
    ACTIONS(31193), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578927] = 2,
    ACTIONS(31195), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578937] = 2,
    ACTIONS(31197), 1,
      sym__unboxed_close,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578947] = 2,
    ACTIONS(31199), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578957] = 2,
    ACTIONS(31201), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578967] = 2,
    ACTIONS(31203), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578977] = 2,
    ACTIONS(31205), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578987] = 2,
    ACTIONS(31207), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
  [578997] = 2,
    ACTIONS(31209), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 4,
      sym_comment,
      sym_cpp,
      sym_pragma,
      aux_sym__token1,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2733)] = 0,
  [SMALL_STATE(2734)] = 109,
  [SMALL_STATE(2735)] = 220,
  [SMALL_STATE(2736)] = 331,
  [SMALL_STATE(2737)] = 440,
  [SMALL_STATE(2738)] = 553,
  [SMALL_STATE(2739)] = 662,
  [SMALL_STATE(2740)] = 791,
  [SMALL_STATE(2741)] = 902,
  [SMALL_STATE(2742)] = 1031,
  [SMALL_STATE(2743)] = 1140,
  [SMALL_STATE(2744)] = 1269,
  [SMALL_STATE(2745)] = 1380,
  [SMALL_STATE(2746)] = 1491,
  [SMALL_STATE(2747)] = 1602,
  [SMALL_STATE(2748)] = 1715,
  [SMALL_STATE(2749)] = 1824,
  [SMALL_STATE(2750)] = 1935,
  [SMALL_STATE(2751)] = 2048,
  [SMALL_STATE(2752)] = 2161,
  [SMALL_STATE(2753)] = 2272,
  [SMALL_STATE(2754)] = 2383,
  [SMALL_STATE(2755)] = 2494,
  [SMALL_STATE(2756)] = 2605,
  [SMALL_STATE(2757)] = 2716,
  [SMALL_STATE(2758)] = 2825,
  [SMALL_STATE(2759)] = 2936,
  [SMALL_STATE(2760)] = 3047,
  [SMALL_STATE(2761)] = 3156,
  [SMALL_STATE(2762)] = 3265,
  [SMALL_STATE(2763)] = 3374,
  [SMALL_STATE(2764)] = 3485,
  [SMALL_STATE(2765)] = 3607,
  [SMALL_STATE(2766)] = 3715,
  [SMALL_STATE(2767)] = 3845,
  [SMALL_STATE(2768)] = 3953,
  [SMALL_STATE(2769)] = 4063,
  [SMALL_STATE(2770)] = 4193,
  [SMALL_STATE(2771)] = 4313,
  [SMALL_STATE(2772)] = 4425,
  [SMALL_STATE(2773)] = 4545,
  [SMALL_STATE(2774)] = 4655,
  [SMALL_STATE(2775)] = 4763,
  [SMALL_STATE(2776)] = 4873,
  [SMALL_STATE(2777)] = 5003,
  [SMALL_STATE(2778)] = 5133,
  [SMALL_STATE(2779)] = 5253,
  [SMALL_STATE(2780)] = 5373,
  [SMALL_STATE(2781)] = 5483,
  [SMALL_STATE(2782)] = 5613,
  [SMALL_STATE(2783)] = 5743,
  [SMALL_STATE(2784)] = 5870,
  [SMALL_STATE(2785)] = 5981,
  [SMALL_STATE(2786)] = 6088,
  [SMALL_STATE(2787)] = 6197,
  [SMALL_STATE(2788)] = 6304,
  [SMALL_STATE(2789)] = 6413,
  [SMALL_STATE(2790)] = 6534,
  [SMALL_STATE(2791)] = 6655,
  [SMALL_STATE(2792)] = 6770,
  [SMALL_STATE(2793)] = 6879,
  [SMALL_STATE(2794)] = 6994,
  [SMALL_STATE(2795)] = 7109,
  [SMALL_STATE(2796)] = 7224,
  [SMALL_STATE(2797)] = 7351,
  [SMALL_STATE(2798)] = 7462,
  [SMALL_STATE(2799)] = 7589,
  [SMALL_STATE(2800)] = 7696,
  [SMALL_STATE(2801)] = 7811,
  [SMALL_STATE(2802)] = 7926,
  [SMALL_STATE(2803)] = 8033,
  [SMALL_STATE(2804)] = 8140,
  [SMALL_STATE(2805)] = 8267,
  [SMALL_STATE(2806)] = 8376,
  [SMALL_STATE(2807)] = 8491,
  [SMALL_STATE(2808)] = 8606,
  [SMALL_STATE(2809)] = 8733,
  [SMALL_STATE(2810)] = 8848,
  [SMALL_STATE(2811)] = 8955,
  [SMALL_STATE(2812)] = 9070,
  [SMALL_STATE(2813)] = 9185,
  [SMALL_STATE(2814)] = 9312,
  [SMALL_STATE(2815)] = 9427,
  [SMALL_STATE(2816)] = 9541,
  [SMALL_STATE(2817)] = 9649,
  [SMALL_STATE(2818)] = 9763,
  [SMALL_STATE(2819)] = 9871,
  [SMALL_STATE(2820)] = 9985,
  [SMALL_STATE(2821)] = 10099,
  [SMALL_STATE(2822)] = 10213,
  [SMALL_STATE(2823)] = 10327,
  [SMALL_STATE(2824)] = 10439,
  [SMALL_STATE(2825)] = 10551,
  [SMALL_STATE(2826)] = 10671,
  [SMALL_STATE(2827)] = 10787,
  [SMALL_STATE(2828)] = 10895,
  [SMALL_STATE(2829)] = 11007,
  [SMALL_STATE(2830)] = 11123,
  [SMALL_STATE(2831)] = 11237,
  [SMALL_STATE(2832)] = 11351,
  [SMALL_STATE(2833)] = 11463,
  [SMALL_STATE(2834)] = 11586,
  [SMALL_STATE(2835)] = 11709,
  [SMALL_STATE(2836)] = 11832,
  [SMALL_STATE(2837)] = 11955,
  [SMALL_STATE(2838)] = 12078,
  [SMALL_STATE(2839)] = 12201,
  [SMALL_STATE(2840)] = 12324,
  [SMALL_STATE(2841)] = 12431,
  [SMALL_STATE(2842)] = 12546,
  [SMALL_STATE(2843)] = 12669,
  [SMALL_STATE(2844)] = 12776,
  [SMALL_STATE(2845)] = 12899,
  [SMALL_STATE(2846)] = 13022,
  [SMALL_STATE(2847)] = 13145,
  [SMALL_STATE(2848)] = 13268,
  [SMALL_STATE(2849)] = 13375,
  [SMALL_STATE(2850)] = 13498,
  [SMALL_STATE(2851)] = 13617,
  [SMALL_STATE(2852)] = 13740,
  [SMALL_STATE(2853)] = 13863,
  [SMALL_STATE(2854)] = 13986,
  [SMALL_STATE(2855)] = 14105,
  [SMALL_STATE(2856)] = 14228,
  [SMALL_STATE(2857)] = 14351,
  [SMALL_STATE(2858)] = 14474,
  [SMALL_STATE(2859)] = 14581,
  [SMALL_STATE(2860)] = 14688,
  [SMALL_STATE(2861)] = 14811,
  [SMALL_STATE(2862)] = 14934,
  [SMALL_STATE(2863)] = 15057,
  [SMALL_STATE(2864)] = 15180,
  [SMALL_STATE(2865)] = 15303,
  [SMALL_STATE(2866)] = 15418,
  [SMALL_STATE(2867)] = 15525,
  [SMALL_STATE(2868)] = 15636,
  [SMALL_STATE(2869)] = 15759,
  [SMALL_STATE(2870)] = 15882,
  [SMALL_STATE(2871)] = 16001,
  [SMALL_STATE(2872)] = 16124,
  [SMALL_STATE(2873)] = 16231,
  [SMALL_STATE(2874)] = 16354,
  [SMALL_STATE(2875)] = 16477,
  [SMALL_STATE(2876)] = 16600,
  [SMALL_STATE(2877)] = 16723,
  [SMALL_STATE(2878)] = 16846,
  [SMALL_STATE(2879)] = 16969,
  [SMALL_STATE(2880)] = 17092,
  [SMALL_STATE(2881)] = 17213,
  [SMALL_STATE(2882)] = 17332,
  [SMALL_STATE(2883)] = 17453,
  [SMALL_STATE(2884)] = 17576,
  [SMALL_STATE(2885)] = 17699,
  [SMALL_STATE(2886)] = 17820,
  [SMALL_STATE(2887)] = 17939,
  [SMALL_STATE(2888)] = 18062,
  [SMALL_STATE(2889)] = 18185,
  [SMALL_STATE(2890)] = 18308,
  [SMALL_STATE(2891)] = 18423,
  [SMALL_STATE(2892)] = 18538,
  [SMALL_STATE(2893)] = 18661,
  [SMALL_STATE(2894)] = 18784,
  [SMALL_STATE(2895)] = 18907,
  [SMALL_STATE(2896)] = 19018,
  [SMALL_STATE(2897)] = 19141,
  [SMALL_STATE(2898)] = 19264,
  [SMALL_STATE(2899)] = 19387,
  [SMALL_STATE(2900)] = 19494,
  [SMALL_STATE(2901)] = 19617,
  [SMALL_STATE(2902)] = 19740,
  [SMALL_STATE(2903)] = 19863,
  [SMALL_STATE(2904)] = 19986,
  [SMALL_STATE(2905)] = 20109,
  [SMALL_STATE(2906)] = 20232,
  [SMALL_STATE(2907)] = 20355,
  [SMALL_STATE(2908)] = 20462,
  [SMALL_STATE(2909)] = 20582,
  [SMALL_STATE(2910)] = 20702,
  [SMALL_STATE(2911)] = 20822,
  [SMALL_STATE(2912)] = 20942,
  [SMALL_STATE(2913)] = 21062,
  [SMALL_STATE(2914)] = 21182,
  [SMALL_STATE(2915)] = 21302,
  [SMALL_STATE(2916)] = 21422,
  [SMALL_STATE(2917)] = 21542,
  [SMALL_STATE(2918)] = 21662,
  [SMALL_STATE(2919)] = 21782,
  [SMALL_STATE(2920)] = 21902,
  [SMALL_STATE(2921)] = 22022,
  [SMALL_STATE(2922)] = 22142,
  [SMALL_STATE(2923)] = 22262,
  [SMALL_STATE(2924)] = 22382,
  [SMALL_STATE(2925)] = 22502,
  [SMALL_STATE(2926)] = 22622,
  [SMALL_STATE(2927)] = 22742,
  [SMALL_STATE(2928)] = 22862,
  [SMALL_STATE(2929)] = 22976,
  [SMALL_STATE(2930)] = 23096,
  [SMALL_STATE(2931)] = 23216,
  [SMALL_STATE(2932)] = 23336,
  [SMALL_STATE(2933)] = 23456,
  [SMALL_STATE(2934)] = 23576,
  [SMALL_STATE(2935)] = 23696,
  [SMALL_STATE(2936)] = 23816,
  [SMALL_STATE(2937)] = 23936,
  [SMALL_STATE(2938)] = 24056,
  [SMALL_STATE(2939)] = 24176,
  [SMALL_STATE(2940)] = 24296,
  [SMALL_STATE(2941)] = 24416,
  [SMALL_STATE(2942)] = 24536,
  [SMALL_STATE(2943)] = 24656,
  [SMALL_STATE(2944)] = 24776,
  [SMALL_STATE(2945)] = 24896,
  [SMALL_STATE(2946)] = 25016,
  [SMALL_STATE(2947)] = 25136,
  [SMALL_STATE(2948)] = 25256,
  [SMALL_STATE(2949)] = 25376,
  [SMALL_STATE(2950)] = 25496,
  [SMALL_STATE(2951)] = 25616,
  [SMALL_STATE(2952)] = 25736,
  [SMALL_STATE(2953)] = 25856,
  [SMALL_STATE(2954)] = 25972,
  [SMALL_STATE(2955)] = 26092,
  [SMALL_STATE(2956)] = 26212,
  [SMALL_STATE(2957)] = 26332,
  [SMALL_STATE(2958)] = 26452,
  [SMALL_STATE(2959)] = 26572,
  [SMALL_STATE(2960)] = 26692,
  [SMALL_STATE(2961)] = 26812,
  [SMALL_STATE(2962)] = 26932,
  [SMALL_STATE(2963)] = 27052,
  [SMALL_STATE(2964)] = 27172,
  [SMALL_STATE(2965)] = 27292,
  [SMALL_STATE(2966)] = 27412,
  [SMALL_STATE(2967)] = 27516,
  [SMALL_STATE(2968)] = 27636,
  [SMALL_STATE(2969)] = 27756,
  [SMALL_STATE(2970)] = 27862,
  [SMALL_STATE(2971)] = 27982,
  [SMALL_STATE(2972)] = 28098,
  [SMALL_STATE(2973)] = 28218,
  [SMALL_STATE(2974)] = 28338,
  [SMALL_STATE(2975)] = 28458,
  [SMALL_STATE(2976)] = 28578,
  [SMALL_STATE(2977)] = 28698,
  [SMALL_STATE(2978)] = 28818,
  [SMALL_STATE(2979)] = 28938,
  [SMALL_STATE(2980)] = 29058,
  [SMALL_STATE(2981)] = 29178,
  [SMALL_STATE(2982)] = 29298,
  [SMALL_STATE(2983)] = 29418,
  [SMALL_STATE(2984)] = 29538,
  [SMALL_STATE(2985)] = 29658,
  [SMALL_STATE(2986)] = 29778,
  [SMALL_STATE(2987)] = 29898,
  [SMALL_STATE(2988)] = 30018,
  [SMALL_STATE(2989)] = 30138,
  [SMALL_STATE(2990)] = 30258,
  [SMALL_STATE(2991)] = 30378,
  [SMALL_STATE(2992)] = 30482,
  [SMALL_STATE(2993)] = 30602,
  [SMALL_STATE(2994)] = 30722,
  [SMALL_STATE(2995)] = 30842,
  [SMALL_STATE(2996)] = 30962,
  [SMALL_STATE(2997)] = 31082,
  [SMALL_STATE(2998)] = 31200,
  [SMALL_STATE(2999)] = 31310,
  [SMALL_STATE(3000)] = 31430,
  [SMALL_STATE(3001)] = 31550,
  [SMALL_STATE(3002)] = 31670,
  [SMALL_STATE(3003)] = 31790,
  [SMALL_STATE(3004)] = 31910,
  [SMALL_STATE(3005)] = 32030,
  [SMALL_STATE(3006)] = 32150,
  [SMALL_STATE(3007)] = 32270,
  [SMALL_STATE(3008)] = 32390,
  [SMALL_STATE(3009)] = 32510,
  [SMALL_STATE(3010)] = 32630,
  [SMALL_STATE(3011)] = 32750,
  [SMALL_STATE(3012)] = 32870,
  [SMALL_STATE(3013)] = 32988,
  [SMALL_STATE(3014)] = 33108,
  [SMALL_STATE(3015)] = 33228,
  [SMALL_STATE(3016)] = 33348,
  [SMALL_STATE(3017)] = 33468,
  [SMALL_STATE(3018)] = 33588,
  [SMALL_STATE(3019)] = 33708,
  [SMALL_STATE(3020)] = 33828,
  [SMALL_STATE(3021)] = 33948,
  [SMALL_STATE(3022)] = 34068,
  [SMALL_STATE(3023)] = 34188,
  [SMALL_STATE(3024)] = 34308,
  [SMALL_STATE(3025)] = 34428,
  [SMALL_STATE(3026)] = 34548,
  [SMALL_STATE(3027)] = 34668,
  [SMALL_STATE(3028)] = 34788,
  [SMALL_STATE(3029)] = 34908,
  [SMALL_STATE(3030)] = 35028,
  [SMALL_STATE(3031)] = 35148,
  [SMALL_STATE(3032)] = 35268,
  [SMALL_STATE(3033)] = 35388,
  [SMALL_STATE(3034)] = 35508,
  [SMALL_STATE(3035)] = 35628,
  [SMALL_STATE(3036)] = 35748,
  [SMALL_STATE(3037)] = 35868,
  [SMALL_STATE(3038)] = 35988,
  [SMALL_STATE(3039)] = 36108,
  [SMALL_STATE(3040)] = 36228,
  [SMALL_STATE(3041)] = 36348,
  [SMALL_STATE(3042)] = 36468,
  [SMALL_STATE(3043)] = 36588,
  [SMALL_STATE(3044)] = 36708,
  [SMALL_STATE(3045)] = 36828,
  [SMALL_STATE(3046)] = 36948,
  [SMALL_STATE(3047)] = 37068,
  [SMALL_STATE(3048)] = 37188,
  [SMALL_STATE(3049)] = 37308,
  [SMALL_STATE(3050)] = 37428,
  [SMALL_STATE(3051)] = 37548,
  [SMALL_STATE(3052)] = 37668,
  [SMALL_STATE(3053)] = 37788,
  [SMALL_STATE(3054)] = 37908,
  [SMALL_STATE(3055)] = 38028,
  [SMALL_STATE(3056)] = 38148,
  [SMALL_STATE(3057)] = 38268,
  [SMALL_STATE(3058)] = 38388,
  [SMALL_STATE(3059)] = 38508,
  [SMALL_STATE(3060)] = 38618,
  [SMALL_STATE(3061)] = 38738,
  [SMALL_STATE(3062)] = 38858,
  [SMALL_STATE(3063)] = 38978,
  [SMALL_STATE(3064)] = 39098,
  [SMALL_STATE(3065)] = 39218,
  [SMALL_STATE(3066)] = 39338,
  [SMALL_STATE(3067)] = 39458,
  [SMALL_STATE(3068)] = 39578,
  [SMALL_STATE(3069)] = 39698,
  [SMALL_STATE(3070)] = 39818,
  [SMALL_STATE(3071)] = 39938,
  [SMALL_STATE(3072)] = 40058,
  [SMALL_STATE(3073)] = 40162,
  [SMALL_STATE(3074)] = 40282,
  [SMALL_STATE(3075)] = 40402,
  [SMALL_STATE(3076)] = 40522,
  [SMALL_STATE(3077)] = 40642,
  [SMALL_STATE(3078)] = 40762,
  [SMALL_STATE(3079)] = 40882,
  [SMALL_STATE(3080)] = 41002,
  [SMALL_STATE(3081)] = 41122,
  [SMALL_STATE(3082)] = 41242,
  [SMALL_STATE(3083)] = 41362,
  [SMALL_STATE(3084)] = 41482,
  [SMALL_STATE(3085)] = 41602,
  [SMALL_STATE(3086)] = 41722,
  [SMALL_STATE(3087)] = 41842,
  [SMALL_STATE(3088)] = 41962,
  [SMALL_STATE(3089)] = 42082,
  [SMALL_STATE(3090)] = 42202,
  [SMALL_STATE(3091)] = 42322,
  [SMALL_STATE(3092)] = 42432,
  [SMALL_STATE(3093)] = 42552,
  [SMALL_STATE(3094)] = 42672,
  [SMALL_STATE(3095)] = 42792,
  [SMALL_STATE(3096)] = 42912,
  [SMALL_STATE(3097)] = 43032,
  [SMALL_STATE(3098)] = 43152,
  [SMALL_STATE(3099)] = 43272,
  [SMALL_STATE(3100)] = 43392,
  [SMALL_STATE(3101)] = 43512,
  [SMALL_STATE(3102)] = 43632,
  [SMALL_STATE(3103)] = 43752,
  [SMALL_STATE(3104)] = 43872,
  [SMALL_STATE(3105)] = 43992,
  [SMALL_STATE(3106)] = 44112,
  [SMALL_STATE(3107)] = 44232,
  [SMALL_STATE(3108)] = 44352,
  [SMALL_STATE(3109)] = 44472,
  [SMALL_STATE(3110)] = 44592,
  [SMALL_STATE(3111)] = 44712,
  [SMALL_STATE(3112)] = 44832,
  [SMALL_STATE(3113)] = 44952,
  [SMALL_STATE(3114)] = 45072,
  [SMALL_STATE(3115)] = 45192,
  [SMALL_STATE(3116)] = 45312,
  [SMALL_STATE(3117)] = 45432,
  [SMALL_STATE(3118)] = 45552,
  [SMALL_STATE(3119)] = 45672,
  [SMALL_STATE(3120)] = 45792,
  [SMALL_STATE(3121)] = 45912,
  [SMALL_STATE(3122)] = 46032,
  [SMALL_STATE(3123)] = 46152,
  [SMALL_STATE(3124)] = 46262,
  [SMALL_STATE(3125)] = 46382,
  [SMALL_STATE(3126)] = 46502,
  [SMALL_STATE(3127)] = 46622,
  [SMALL_STATE(3128)] = 46738,
  [SMALL_STATE(3129)] = 46858,
  [SMALL_STATE(3130)] = 46978,
  [SMALL_STATE(3131)] = 47098,
  [SMALL_STATE(3132)] = 47218,
  [SMALL_STATE(3133)] = 47338,
  [SMALL_STATE(3134)] = 47458,
  [SMALL_STATE(3135)] = 47568,
  [SMALL_STATE(3136)] = 47688,
  [SMALL_STATE(3137)] = 47808,
  [SMALL_STATE(3138)] = 47928,
  [SMALL_STATE(3139)] = 48048,
  [SMALL_STATE(3140)] = 48168,
  [SMALL_STATE(3141)] = 48288,
  [SMALL_STATE(3142)] = 48408,
  [SMALL_STATE(3143)] = 48528,
  [SMALL_STATE(3144)] = 48638,
  [SMALL_STATE(3145)] = 48754,
  [SMALL_STATE(3146)] = 48874,
  [SMALL_STATE(3147)] = 48994,
  [SMALL_STATE(3148)] = 49114,
  [SMALL_STATE(3149)] = 49234,
  [SMALL_STATE(3150)] = 49354,
  [SMALL_STATE(3151)] = 49474,
  [SMALL_STATE(3152)] = 49594,
  [SMALL_STATE(3153)] = 49714,
  [SMALL_STATE(3154)] = 49834,
  [SMALL_STATE(3155)] = 49940,
  [SMALL_STATE(3156)] = 50060,
  [SMALL_STATE(3157)] = 50180,
  [SMALL_STATE(3158)] = 50300,
  [SMALL_STATE(3159)] = 50420,
  [SMALL_STATE(3160)] = 50540,
  [SMALL_STATE(3161)] = 50654,
  [SMALL_STATE(3162)] = 50774,
  [SMALL_STATE(3163)] = 50894,
  [SMALL_STATE(3164)] = 51014,
  [SMALL_STATE(3165)] = 51134,
  [SMALL_STATE(3166)] = 51254,
  [SMALL_STATE(3167)] = 51374,
  [SMALL_STATE(3168)] = 51478,
  [SMALL_STATE(3169)] = 51598,
  [SMALL_STATE(3170)] = 51718,
  [SMALL_STATE(3171)] = 51836,
  [SMALL_STATE(3172)] = 51956,
  [SMALL_STATE(3173)] = 52076,
  [SMALL_STATE(3174)] = 52196,
  [SMALL_STATE(3175)] = 52316,
  [SMALL_STATE(3176)] = 52436,
  [SMALL_STATE(3177)] = 52556,
  [SMALL_STATE(3178)] = 52676,
  [SMALL_STATE(3179)] = 52796,
  [SMALL_STATE(3180)] = 52916,
  [SMALL_STATE(3181)] = 53019,
  [SMALL_STATE(3182)] = 53132,
  [SMALL_STATE(3183)] = 53245,
  [SMALL_STATE(3184)] = 53348,
  [SMALL_STATE(3185)] = 53465,
  [SMALL_STATE(3186)] = 53568,
  [SMALL_STATE(3187)] = 53685,
  [SMALL_STATE(3188)] = 53798,
  [SMALL_STATE(3189)] = 53911,
  [SMALL_STATE(3190)] = 54014,
  [SMALL_STATE(3191)] = 54127,
  [SMALL_STATE(3192)] = 54242,
  [SMALL_STATE(3193)] = 54357,
  [SMALL_STATE(3194)] = 54460,
  [SMALL_STATE(3195)] = 54575,
  [SMALL_STATE(3196)] = 54690,
  [SMALL_STATE(3197)] = 54803,
  [SMALL_STATE(3198)] = 54916,
  [SMALL_STATE(3199)] = 55029,
  [SMALL_STATE(3200)] = 55132,
  [SMALL_STATE(3201)] = 55247,
  [SMALL_STATE(3202)] = 55360,
  [SMALL_STATE(3203)] = 55477,
  [SMALL_STATE(3204)] = 55594,
  [SMALL_STATE(3205)] = 55709,
  [SMALL_STATE(3206)] = 55824,
  [SMALL_STATE(3207)] = 55939,
  [SMALL_STATE(3208)] = 56054,
  [SMALL_STATE(3209)] = 56171,
  [SMALL_STATE(3210)] = 56284,
  [SMALL_STATE(3211)] = 56398,
  [SMALL_STATE(3212)] = 56512,
  [SMALL_STATE(3213)] = 56624,
  [SMALL_STATE(3214)] = 56736,
  [SMALL_STATE(3215)] = 56850,
  [SMALL_STATE(3216)] = 56964,
  [SMALL_STATE(3217)] = 57078,
  [SMALL_STATE(3218)] = 57184,
  [SMALL_STATE(3219)] = 57298,
  [SMALL_STATE(3220)] = 57410,
  [SMALL_STATE(3221)] = 57522,
  [SMALL_STATE(3222)] = 57634,
  [SMALL_STATE(3223)] = 57748,
  [SMALL_STATE(3224)] = 57862,
  [SMALL_STATE(3225)] = 57974,
  [SMALL_STATE(3226)] = 58086,
  [SMALL_STATE(3227)] = 58198,
  [SMALL_STATE(3228)] = 58312,
  [SMALL_STATE(3229)] = 58414,
  [SMALL_STATE(3230)] = 58528,
  [SMALL_STATE(3231)] = 58642,
  [SMALL_STATE(3232)] = 58744,
  [SMALL_STATE(3233)] = 58856,
  [SMALL_STATE(3234)] = 58970,
  [SMALL_STATE(3235)] = 59082,
  [SMALL_STATE(3236)] = 59194,
  [SMALL_STATE(3237)] = 59308,
  [SMALL_STATE(3238)] = 59422,
  [SMALL_STATE(3239)] = 59536,
  [SMALL_STATE(3240)] = 59638,
  [SMALL_STATE(3241)] = 59752,
  [SMALL_STATE(3242)] = 59864,
  [SMALL_STATE(3243)] = 59976,
  [SMALL_STATE(3244)] = 60090,
  [SMALL_STATE(3245)] = 60204,
  [SMALL_STATE(3246)] = 60318,
  [SMALL_STATE(3247)] = 60430,
  [SMALL_STATE(3248)] = 60542,
  [SMALL_STATE(3249)] = 60654,
  [SMALL_STATE(3250)] = 60766,
  [SMALL_STATE(3251)] = 60880,
  [SMALL_STATE(3252)] = 60994,
  [SMALL_STATE(3253)] = 61096,
  [SMALL_STATE(3254)] = 61198,
  [SMALL_STATE(3255)] = 61312,
  [SMALL_STATE(3256)] = 61414,
  [SMALL_STATE(3257)] = 61528,
  [SMALL_STATE(3258)] = 61642,
  [SMALL_STATE(3259)] = 61756,
  [SMALL_STATE(3260)] = 61870,
  [SMALL_STATE(3261)] = 61984,
  [SMALL_STATE(3262)] = 62098,
  [SMALL_STATE(3263)] = 62212,
  [SMALL_STATE(3264)] = 62316,
  [SMALL_STATE(3265)] = 62430,
  [SMALL_STATE(3266)] = 62544,
  [SMALL_STATE(3267)] = 62658,
  [SMALL_STATE(3268)] = 62772,
  [SMALL_STATE(3269)] = 62873,
  [SMALL_STATE(3270)] = 62982,
  [SMALL_STATE(3271)] = 63091,
  [SMALL_STATE(3272)] = 63200,
  [SMALL_STATE(3273)] = 63309,
  [SMALL_STATE(3274)] = 63418,
  [SMALL_STATE(3275)] = 63527,
  [SMALL_STATE(3276)] = 63636,
  [SMALL_STATE(3277)] = 63745,
  [SMALL_STATE(3278)] = 63854,
  [SMALL_STATE(3279)] = 63963,
  [SMALL_STATE(3280)] = 64072,
  [SMALL_STATE(3281)] = 64181,
  [SMALL_STATE(3282)] = 64290,
  [SMALL_STATE(3283)] = 64399,
  [SMALL_STATE(3284)] = 64508,
  [SMALL_STATE(3285)] = 64617,
  [SMALL_STATE(3286)] = 64726,
  [SMALL_STATE(3287)] = 64835,
  [SMALL_STATE(3288)] = 64944,
  [SMALL_STATE(3289)] = 65053,
  [SMALL_STATE(3290)] = 65162,
  [SMALL_STATE(3291)] = 65271,
  [SMALL_STATE(3292)] = 65380,
  [SMALL_STATE(3293)] = 65485,
  [SMALL_STATE(3294)] = 65594,
  [SMALL_STATE(3295)] = 65703,
  [SMALL_STATE(3296)] = 65808,
  [SMALL_STATE(3297)] = 65917,
  [SMALL_STATE(3298)] = 66026,
  [SMALL_STATE(3299)] = 66135,
  [SMALL_STATE(3300)] = 66244,
  [SMALL_STATE(3301)] = 66353,
  [SMALL_STATE(3302)] = 66462,
  [SMALL_STATE(3303)] = 66571,
  [SMALL_STATE(3304)] = 66680,
  [SMALL_STATE(3305)] = 66789,
  [SMALL_STATE(3306)] = 66900,
  [SMALL_STATE(3307)] = 67009,
  [SMALL_STATE(3308)] = 67112,
  [SMALL_STATE(3309)] = 67221,
  [SMALL_STATE(3310)] = 67330,
  [SMALL_STATE(3311)] = 67441,
  [SMALL_STATE(3312)] = 67546,
  [SMALL_STATE(3313)] = 67647,
  [SMALL_STATE(3314)] = 67756,
  [SMALL_STATE(3315)] = 67865,
  [SMALL_STATE(3316)] = 67974,
  [SMALL_STATE(3317)] = 68083,
  [SMALL_STATE(3318)] = 68184,
  [SMALL_STATE(3319)] = 68293,
  [SMALL_STATE(3320)] = 68402,
  [SMALL_STATE(3321)] = 68511,
  [SMALL_STATE(3322)] = 68620,
  [SMALL_STATE(3323)] = 68722,
  [SMALL_STATE(3324)] = 68824,
  [SMALL_STATE(3325)] = 68926,
  [SMALL_STATE(3326)] = 69028,
  [SMALL_STATE(3327)] = 69130,
  [SMALL_STATE(3328)] = 69232,
  [SMALL_STATE(3329)] = 69334,
  [SMALL_STATE(3330)] = 69446,
  [SMALL_STATE(3331)] = 69552,
  [SMALL_STATE(3332)] = 69654,
  [SMALL_STATE(3333)] = 69756,
  [SMALL_STATE(3334)] = 69862,
  [SMALL_STATE(3335)] = 69964,
  [SMALL_STATE(3336)] = 70066,
  [SMALL_STATE(3337)] = 70168,
  [SMALL_STATE(3338)] = 70270,
  [SMALL_STATE(3339)] = 70376,
  [SMALL_STATE(3340)] = 70488,
  [SMALL_STATE(3341)] = 70600,
  [SMALL_STATE(3342)] = 70712,
  [SMALL_STATE(3343)] = 70824,
  [SMALL_STATE(3344)] = 70936,
  [SMALL_STATE(3345)] = 71042,
  [SMALL_STATE(3346)] = 71154,
  [SMALL_STATE(3347)] = 71266,
  [SMALL_STATE(3348)] = 71368,
  [SMALL_STATE(3349)] = 71470,
  [SMALL_STATE(3350)] = 71572,
  [SMALL_STATE(3351)] = 71674,
  [SMALL_STATE(3352)] = 71786,
  [SMALL_STATE(3353)] = 71892,
  [SMALL_STATE(3354)] = 71994,
  [SMALL_STATE(3355)] = 72106,
  [SMALL_STATE(3356)] = 72218,
  [SMALL_STATE(3357)] = 72320,
  [SMALL_STATE(3358)] = 72422,
  [SMALL_STATE(3359)] = 72528,
  [SMALL_STATE(3360)] = 72630,
  [SMALL_STATE(3361)] = 72732,
  [SMALL_STATE(3362)] = 72834,
  [SMALL_STATE(3363)] = 72936,
  [SMALL_STATE(3364)] = 73038,
  [SMALL_STATE(3365)] = 73140,
  [SMALL_STATE(3366)] = 73252,
  [SMALL_STATE(3367)] = 73358,
  [SMALL_STATE(3368)] = 73464,
  [SMALL_STATE(3369)] = 73570,
  [SMALL_STATE(3370)] = 73672,
  [SMALL_STATE(3371)] = 73774,
  [SMALL_STATE(3372)] = 73876,
  [SMALL_STATE(3373)] = 73978,
  [SMALL_STATE(3374)] = 74080,
  [SMALL_STATE(3375)] = 74182,
  [SMALL_STATE(3376)] = 74294,
  [SMALL_STATE(3377)] = 74406,
  [SMALL_STATE(3378)] = 74512,
  [SMALL_STATE(3379)] = 74614,
  [SMALL_STATE(3380)] = 74716,
  [SMALL_STATE(3381)] = 74818,
  [SMALL_STATE(3382)] = 74920,
  [SMALL_STATE(3383)] = 75026,
  [SMALL_STATE(3384)] = 75128,
  [SMALL_STATE(3385)] = 75230,
  [SMALL_STATE(3386)] = 75332,
  [SMALL_STATE(3387)] = 75434,
  [SMALL_STATE(3388)] = 75546,
  [SMALL_STATE(3389)] = 75648,
  [SMALL_STATE(3390)] = 75760,
  [SMALL_STATE(3391)] = 75862,
  [SMALL_STATE(3392)] = 75974,
  [SMALL_STATE(3393)] = 76076,
  [SMALL_STATE(3394)] = 76178,
  [SMALL_STATE(3395)] = 76280,
  [SMALL_STATE(3396)] = 76382,
  [SMALL_STATE(3397)] = 76484,
  [SMALL_STATE(3398)] = 76596,
  [SMALL_STATE(3399)] = 76698,
  [SMALL_STATE(3400)] = 76800,
  [SMALL_STATE(3401)] = 76906,
  [SMALL_STATE(3402)] = 77008,
  [SMALL_STATE(3403)] = 77114,
  [SMALL_STATE(3404)] = 77226,
  [SMALL_STATE(3405)] = 77328,
  [SMALL_STATE(3406)] = 77440,
  [SMALL_STATE(3407)] = 77542,
  [SMALL_STATE(3408)] = 77644,
  [SMALL_STATE(3409)] = 77746,
  [SMALL_STATE(3410)] = 77858,
  [SMALL_STATE(3411)] = 77960,
  [SMALL_STATE(3412)] = 78072,
  [SMALL_STATE(3413)] = 78178,
  [SMALL_STATE(3414)] = 78280,
  [SMALL_STATE(3415)] = 78386,
  [SMALL_STATE(3416)] = 78498,
  [SMALL_STATE(3417)] = 78604,
  [SMALL_STATE(3418)] = 78706,
  [SMALL_STATE(3419)] = 78812,
  [SMALL_STATE(3420)] = 78921,
  [SMALL_STATE(3421)] = 79032,
  [SMALL_STATE(3422)] = 79143,
  [SMALL_STATE(3423)] = 79254,
  [SMALL_STATE(3424)] = 79355,
  [SMALL_STATE(3425)] = 79456,
  [SMALL_STATE(3426)] = 79564,
  [SMALL_STATE(3427)] = 79662,
  [SMALL_STATE(3428)] = 79760,
  [SMALL_STATE(3429)] = 79868,
  [SMALL_STATE(3430)] = 79976,
  [SMALL_STATE(3431)] = 80084,
  [SMALL_STATE(3432)] = 80192,
  [SMALL_STATE(3433)] = 80300,
  [SMALL_STATE(3434)] = 80408,
  [SMALL_STATE(3435)] = 80506,
  [SMALL_STATE(3436)] = 80604,
  [SMALL_STATE(3437)] = 80712,
  [SMALL_STATE(3438)] = 80810,
  [SMALL_STATE(3439)] = 80918,
  [SMALL_STATE(3440)] = 81026,
  [SMALL_STATE(3441)] = 81134,
  [SMALL_STATE(3442)] = 81242,
  [SMALL_STATE(3443)] = 81350,
  [SMALL_STATE(3444)] = 81448,
  [SMALL_STATE(3445)] = 81546,
  [SMALL_STATE(3446)] = 81644,
  [SMALL_STATE(3447)] = 81742,
  [SMALL_STATE(3448)] = 81840,
  [SMALL_STATE(3449)] = 81938,
  [SMALL_STATE(3450)] = 82046,
  [SMALL_STATE(3451)] = 82154,
  [SMALL_STATE(3452)] = 82262,
  [SMALL_STATE(3453)] = 82370,
  [SMALL_STATE(3454)] = 82468,
  [SMALL_STATE(3455)] = 82566,
  [SMALL_STATE(3456)] = 82674,
  [SMALL_STATE(3457)] = 82772,
  [SMALL_STATE(3458)] = 82880,
  [SMALL_STATE(3459)] = 82988,
  [SMALL_STATE(3460)] = 83086,
  [SMALL_STATE(3461)] = 83184,
  [SMALL_STATE(3462)] = 83292,
  [SMALL_STATE(3463)] = 83400,
  [SMALL_STATE(3464)] = 83508,
  [SMALL_STATE(3465)] = 83606,
  [SMALL_STATE(3466)] = 83704,
  [SMALL_STATE(3467)] = 83802,
  [SMALL_STATE(3468)] = 83900,
  [SMALL_STATE(3469)] = 83959,
  [SMALL_STATE(3470)] = 84044,
  [SMALL_STATE(3471)] = 84105,
  [SMALL_STATE(3472)] = 84166,
  [SMALL_STATE(3473)] = 84227,
  [SMALL_STATE(3474)] = 84288,
  [SMALL_STATE(3475)] = 84373,
  [SMALL_STATE(3476)] = 84434,
  [SMALL_STATE(3477)] = 84493,
  [SMALL_STATE(3478)] = 84554,
  [SMALL_STATE(3479)] = 84613,
  [SMALL_STATE(3480)] = 84717,
  [SMALL_STATE(3481)] = 84821,
  [SMALL_STATE(3482)] = 84879,
  [SMALL_STATE(3483)] = 84937,
  [SMALL_STATE(3484)] = 85031,
  [SMALL_STATE(3485)] = 85125,
  [SMALL_STATE(3486)] = 85219,
  [SMALL_STATE(3487)] = 85323,
  [SMALL_STATE(3488)] = 85427,
  [SMALL_STATE(3489)] = 85531,
  [SMALL_STATE(3490)] = 85589,
  [SMALL_STATE(3491)] = 85693,
  [SMALL_STATE(3492)] = 85787,
  [SMALL_STATE(3493)] = 85891,
  [SMALL_STATE(3494)] = 85985,
  [SMALL_STATE(3495)] = 86079,
  [SMALL_STATE(3496)] = 86161,
  [SMALL_STATE(3497)] = 86255,
  [SMALL_STATE(3498)] = 86359,
  [SMALL_STATE(3499)] = 86453,
  [SMALL_STATE(3500)] = 86547,
  [SMALL_STATE(3501)] = 86641,
  [SMALL_STATE(3502)] = 86745,
  [SMALL_STATE(3503)] = 86849,
  [SMALL_STATE(3504)] = 86953,
  [SMALL_STATE(3505)] = 87057,
  [SMALL_STATE(3506)] = 87161,
  [SMALL_STATE(3507)] = 87265,
  [SMALL_STATE(3508)] = 87359,
  [SMALL_STATE(3509)] = 87453,
  [SMALL_STATE(3510)] = 87557,
  [SMALL_STATE(3511)] = 87661,
  [SMALL_STATE(3512)] = 87719,
  [SMALL_STATE(3513)] = 87813,
  [SMALL_STATE(3514)] = 87907,
  [SMALL_STATE(3515)] = 87965,
  [SMALL_STATE(3516)] = 88069,
  [SMALL_STATE(3517)] = 88163,
  [SMALL_STATE(3518)] = 88257,
  [SMALL_STATE(3519)] = 88361,
  [SMALL_STATE(3520)] = 88455,
  [SMALL_STATE(3521)] = 88549,
  [SMALL_STATE(3522)] = 88643,
  [SMALL_STATE(3523)] = 88747,
  [SMALL_STATE(3524)] = 88841,
  [SMALL_STATE(3525)] = 88945,
  [SMALL_STATE(3526)] = 89049,
  [SMALL_STATE(3527)] = 89153,
  [SMALL_STATE(3528)] = 89247,
  [SMALL_STATE(3529)] = 89341,
  [SMALL_STATE(3530)] = 89435,
  [SMALL_STATE(3531)] = 89529,
  [SMALL_STATE(3532)] = 89623,
  [SMALL_STATE(3533)] = 89717,
  [SMALL_STATE(3534)] = 89775,
  [SMALL_STATE(3535)] = 89879,
  [SMALL_STATE(3536)] = 89973,
  [SMALL_STATE(3537)] = 90067,
  [SMALL_STATE(3538)] = 90171,
  [SMALL_STATE(3539)] = 90265,
  [SMALL_STATE(3540)] = 90359,
  [SMALL_STATE(3541)] = 90463,
  [SMALL_STATE(3542)] = 90545,
  [SMALL_STATE(3543)] = 90649,
  [SMALL_STATE(3544)] = 90707,
  [SMALL_STATE(3545)] = 90811,
  [SMALL_STATE(3546)] = 90905,
  [SMALL_STATE(3547)] = 90963,
  [SMALL_STATE(3548)] = 91021,
  [SMALL_STATE(3549)] = 91125,
  [SMALL_STATE(3550)] = 91183,
  [SMALL_STATE(3551)] = 91287,
  [SMALL_STATE(3552)] = 91391,
  [SMALL_STATE(3553)] = 91495,
  [SMALL_STATE(3554)] = 91589,
  [SMALL_STATE(3555)] = 91673,
  [SMALL_STATE(3556)] = 91767,
  [SMALL_STATE(3557)] = 91871,
  [SMALL_STATE(3558)] = 91975,
  [SMALL_STATE(3559)] = 92069,
  [SMALL_STATE(3560)] = 92163,
  [SMALL_STATE(3561)] = 92267,
  [SMALL_STATE(3562)] = 92361,
  [SMALL_STATE(3563)] = 92419,
  [SMALL_STATE(3564)] = 92513,
  [SMALL_STATE(3565)] = 92607,
  [SMALL_STATE(3566)] = 92711,
  [SMALL_STATE(3567)] = 92805,
  [SMALL_STATE(3568)] = 92909,
  [SMALL_STATE(3569)] = 93013,
  [SMALL_STATE(3570)] = 93107,
  [SMALL_STATE(3571)] = 93201,
  [SMALL_STATE(3572)] = 93295,
  [SMALL_STATE(3573)] = 93389,
  [SMALL_STATE(3574)] = 93483,
  [SMALL_STATE(3575)] = 93577,
  [SMALL_STATE(3576)] = 93681,
  [SMALL_STATE(3577)] = 93739,
  [SMALL_STATE(3578)] = 93797,
  [SMALL_STATE(3579)] = 93891,
  [SMALL_STATE(3580)] = 93995,
  [SMALL_STATE(3581)] = 94089,
  [SMALL_STATE(3582)] = 94183,
  [SMALL_STATE(3583)] = 94277,
  [SMALL_STATE(3584)] = 94371,
  [SMALL_STATE(3585)] = 94475,
  [SMALL_STATE(3586)] = 94569,
  [SMALL_STATE(3587)] = 94673,
  [SMALL_STATE(3588)] = 94767,
  [SMALL_STATE(3589)] = 94861,
  [SMALL_STATE(3590)] = 94965,
  [SMALL_STATE(3591)] = 95069,
  [SMALL_STATE(3592)] = 95127,
  [SMALL_STATE(3593)] = 95221,
  [SMALL_STATE(3594)] = 95315,
  [SMALL_STATE(3595)] = 95409,
  [SMALL_STATE(3596)] = 95467,
  [SMALL_STATE(3597)] = 95571,
  [SMALL_STATE(3598)] = 95629,
  [SMALL_STATE(3599)] = 95733,
  [SMALL_STATE(3600)] = 95837,
  [SMALL_STATE(3601)] = 95897,
  [SMALL_STATE(3602)] = 95955,
  [SMALL_STATE(3603)] = 96013,
  [SMALL_STATE(3604)] = 96107,
  [SMALL_STATE(3605)] = 96201,
  [SMALL_STATE(3606)] = 96295,
  [SMALL_STATE(3607)] = 96353,
  [SMALL_STATE(3608)] = 96447,
  [SMALL_STATE(3609)] = 96505,
  [SMALL_STATE(3610)] = 96563,
  [SMALL_STATE(3611)] = 96657,
  [SMALL_STATE(3612)] = 96751,
  [SMALL_STATE(3613)] = 96855,
  [SMALL_STATE(3614)] = 96959,
  [SMALL_STATE(3615)] = 97053,
  [SMALL_STATE(3616)] = 97147,
  [SMALL_STATE(3617)] = 97251,
  [SMALL_STATE(3618)] = 97309,
  [SMALL_STATE(3619)] = 97413,
  [SMALL_STATE(3620)] = 97471,
  [SMALL_STATE(3621)] = 97575,
  [SMALL_STATE(3622)] = 97679,
  [SMALL_STATE(3623)] = 97773,
  [SMALL_STATE(3624)] = 97877,
  [SMALL_STATE(3625)] = 97971,
  [SMALL_STATE(3626)] = 98065,
  [SMALL_STATE(3627)] = 98169,
  [SMALL_STATE(3628)] = 98273,
  [SMALL_STATE(3629)] = 98331,
  [SMALL_STATE(3630)] = 98425,
  [SMALL_STATE(3631)] = 98529,
  [SMALL_STATE(3632)] = 98633,
  [SMALL_STATE(3633)] = 98697,
  [SMALL_STATE(3634)] = 98791,
  [SMALL_STATE(3635)] = 98885,
  [SMALL_STATE(3636)] = 98979,
  [SMALL_STATE(3637)] = 99073,
  [SMALL_STATE(3638)] = 99177,
  [SMALL_STATE(3639)] = 99281,
  [SMALL_STATE(3640)] = 99385,
  [SMALL_STATE(3641)] = 99489,
  [SMALL_STATE(3642)] = 99593,
  [SMALL_STATE(3643)] = 99697,
  [SMALL_STATE(3644)] = 99791,
  [SMALL_STATE(3645)] = 99885,
  [SMALL_STATE(3646)] = 99979,
  [SMALL_STATE(3647)] = 100083,
  [SMALL_STATE(3648)] = 100141,
  [SMALL_STATE(3649)] = 100235,
  [SMALL_STATE(3650)] = 100339,
  [SMALL_STATE(3651)] = 100433,
  [SMALL_STATE(3652)] = 100491,
  [SMALL_STATE(3653)] = 100595,
  [SMALL_STATE(3654)] = 100689,
  [SMALL_STATE(3655)] = 100783,
  [SMALL_STATE(3656)] = 100877,
  [SMALL_STATE(3657)] = 100935,
  [SMALL_STATE(3658)] = 101039,
  [SMALL_STATE(3659)] = 101133,
  [SMALL_STATE(3660)] = 101227,
  [SMALL_STATE(3661)] = 101321,
  [SMALL_STATE(3662)] = 101379,
  [SMALL_STATE(3663)] = 101437,
  [SMALL_STATE(3664)] = 101541,
  [SMALL_STATE(3665)] = 101645,
  [SMALL_STATE(3666)] = 101749,
  [SMALL_STATE(3667)] = 101843,
  [SMALL_STATE(3668)] = 101937,
  [SMALL_STATE(3669)] = 101995,
  [SMALL_STATE(3670)] = 102099,
  [SMALL_STATE(3671)] = 102203,
  [SMALL_STATE(3672)] = 102297,
  [SMALL_STATE(3673)] = 102401,
  [SMALL_STATE(3674)] = 102459,
  [SMALL_STATE(3675)] = 102553,
  [SMALL_STATE(3676)] = 102647,
  [SMALL_STATE(3677)] = 102741,
  [SMALL_STATE(3678)] = 102799,
  [SMALL_STATE(3679)] = 102903,
  [SMALL_STATE(3680)] = 103007,
  [SMALL_STATE(3681)] = 103111,
  [SMALL_STATE(3682)] = 103215,
  [SMALL_STATE(3683)] = 103319,
  [SMALL_STATE(3684)] = 103423,
  [SMALL_STATE(3685)] = 103527,
  [SMALL_STATE(3686)] = 103585,
  [SMALL_STATE(3687)] = 103689,
  [SMALL_STATE(3688)] = 103783,
  [SMALL_STATE(3689)] = 103877,
  [SMALL_STATE(3690)] = 103971,
  [SMALL_STATE(3691)] = 104065,
  [SMALL_STATE(3692)] = 104169,
  [SMALL_STATE(3693)] = 104229,
  [SMALL_STATE(3694)] = 104323,
  [SMALL_STATE(3695)] = 104417,
  [SMALL_STATE(3696)] = 104511,
  [SMALL_STATE(3697)] = 104615,
  [SMALL_STATE(3698)] = 104709,
  [SMALL_STATE(3699)] = 104803,
  [SMALL_STATE(3700)] = 104861,
  [SMALL_STATE(3701)] = 104955,
  [SMALL_STATE(3702)] = 105013,
  [SMALL_STATE(3703)] = 105107,
  [SMALL_STATE(3704)] = 105165,
  [SMALL_STATE(3705)] = 105269,
  [SMALL_STATE(3706)] = 105329,
  [SMALL_STATE(3707)] = 105423,
  [SMALL_STATE(3708)] = 105527,
  [SMALL_STATE(3709)] = 105585,
  [SMALL_STATE(3710)] = 105679,
  [SMALL_STATE(3711)] = 105783,
  [SMALL_STATE(3712)] = 105887,
  [SMALL_STATE(3713)] = 105991,
  [SMALL_STATE(3714)] = 106095,
  [SMALL_STATE(3715)] = 106199,
  [SMALL_STATE(3716)] = 106293,
  [SMALL_STATE(3717)] = 106397,
  [SMALL_STATE(3718)] = 106501,
  [SMALL_STATE(3719)] = 106605,
  [SMALL_STATE(3720)] = 106709,
  [SMALL_STATE(3721)] = 106803,
  [SMALL_STATE(3722)] = 106907,
  [SMALL_STATE(3723)] = 107001,
  [SMALL_STATE(3724)] = 107105,
  [SMALL_STATE(3725)] = 107199,
  [SMALL_STATE(3726)] = 107293,
  [SMALL_STATE(3727)] = 107387,
  [SMALL_STATE(3728)] = 107481,
  [SMALL_STATE(3729)] = 107575,
  [SMALL_STATE(3730)] = 107669,
  [SMALL_STATE(3731)] = 107763,
  [SMALL_STATE(3732)] = 107867,
  [SMALL_STATE(3733)] = 107961,
  [SMALL_STATE(3734)] = 108019,
  [SMALL_STATE(3735)] = 108076,
  [SMALL_STATE(3736)] = 108133,
  [SMALL_STATE(3737)] = 108192,
  [SMALL_STATE(3738)] = 108249,
  [SMALL_STATE(3739)] = 108306,
  [SMALL_STATE(3740)] = 108363,
  [SMALL_STATE(3741)] = 108420,
  [SMALL_STATE(3742)] = 108479,
  [SMALL_STATE(3743)] = 108536,
  [SMALL_STATE(3744)] = 108593,
  [SMALL_STATE(3745)] = 108650,
  [SMALL_STATE(3746)] = 108707,
  [SMALL_STATE(3747)] = 108764,
  [SMALL_STATE(3748)] = 108821,
  [SMALL_STATE(3749)] = 108878,
  [SMALL_STATE(3750)] = 108935,
  [SMALL_STATE(3751)] = 108992,
  [SMALL_STATE(3752)] = 109049,
  [SMALL_STATE(3753)] = 109108,
  [SMALL_STATE(3754)] = 109165,
  [SMALL_STATE(3755)] = 109222,
  [SMALL_STATE(3756)] = 109279,
  [SMALL_STATE(3757)] = 109336,
  [SMALL_STATE(3758)] = 109393,
  [SMALL_STATE(3759)] = 109450,
  [SMALL_STATE(3760)] = 109509,
  [SMALL_STATE(3761)] = 109566,
  [SMALL_STATE(3762)] = 109623,
  [SMALL_STATE(3763)] = 109680,
  [SMALL_STATE(3764)] = 109737,
  [SMALL_STATE(3765)] = 109794,
  [SMALL_STATE(3766)] = 109851,
  [SMALL_STATE(3767)] = 109908,
  [SMALL_STATE(3768)] = 109965,
  [SMALL_STATE(3769)] = 110022,
  [SMALL_STATE(3770)] = 110103,
  [SMALL_STATE(3771)] = 110160,
  [SMALL_STATE(3772)] = 110217,
  [SMALL_STATE(3773)] = 110274,
  [SMALL_STATE(3774)] = 110331,
  [SMALL_STATE(3775)] = 110388,
  [SMALL_STATE(3776)] = 110445,
  [SMALL_STATE(3777)] = 110502,
  [SMALL_STATE(3778)] = 110561,
  [SMALL_STATE(3779)] = 110618,
  [SMALL_STATE(3780)] = 110675,
  [SMALL_STATE(3781)] = 110738,
  [SMALL_STATE(3782)] = 110795,
  [SMALL_STATE(3783)] = 110852,
  [SMALL_STATE(3784)] = 110909,
  [SMALL_STATE(3785)] = 110966,
  [SMALL_STATE(3786)] = 111023,
  [SMALL_STATE(3787)] = 111082,
  [SMALL_STATE(3788)] = 111139,
  [SMALL_STATE(3789)] = 111196,
  [SMALL_STATE(3790)] = 111254,
  [SMALL_STATE(3791)] = 111310,
  [SMALL_STATE(3792)] = 111366,
  [SMALL_STATE(3793)] = 111422,
  [SMALL_STATE(3794)] = 111478,
  [SMALL_STATE(3795)] = 111534,
  [SMALL_STATE(3796)] = 111590,
  [SMALL_STATE(3797)] = 111646,
  [SMALL_STATE(3798)] = 111702,
  [SMALL_STATE(3799)] = 111758,
  [SMALL_STATE(3800)] = 111814,
  [SMALL_STATE(3801)] = 111870,
  [SMALL_STATE(3802)] = 111926,
  [SMALL_STATE(3803)] = 111982,
  [SMALL_STATE(3804)] = 112038,
  [SMALL_STATE(3805)] = 112094,
  [SMALL_STATE(3806)] = 112150,
  [SMALL_STATE(3807)] = 112206,
  [SMALL_STATE(3808)] = 112262,
  [SMALL_STATE(3809)] = 112318,
  [SMALL_STATE(3810)] = 112374,
  [SMALL_STATE(3811)] = 112430,
  [SMALL_STATE(3812)] = 112486,
  [SMALL_STATE(3813)] = 112542,
  [SMALL_STATE(3814)] = 112598,
  [SMALL_STATE(3815)] = 112654,
  [SMALL_STATE(3816)] = 112710,
  [SMALL_STATE(3817)] = 112766,
  [SMALL_STATE(3818)] = 112830,
  [SMALL_STATE(3819)] = 112888,
  [SMALL_STATE(3820)] = 112944,
  [SMALL_STATE(3821)] = 113000,
  [SMALL_STATE(3822)] = 113064,
  [SMALL_STATE(3823)] = 113120,
  [SMALL_STATE(3824)] = 113178,
  [SMALL_STATE(3825)] = 113234,
  [SMALL_STATE(3826)] = 113290,
  [SMALL_STATE(3827)] = 113346,
  [SMALL_STATE(3828)] = 113402,
  [SMALL_STATE(3829)] = 113458,
  [SMALL_STATE(3830)] = 113514,
  [SMALL_STATE(3831)] = 113570,
  [SMALL_STATE(3832)] = 113626,
  [SMALL_STATE(3833)] = 113682,
  [SMALL_STATE(3834)] = 113738,
  [SMALL_STATE(3835)] = 113794,
  [SMALL_STATE(3836)] = 113850,
  [SMALL_STATE(3837)] = 113906,
  [SMALL_STATE(3838)] = 113962,
  [SMALL_STATE(3839)] = 114018,
  [SMALL_STATE(3840)] = 114074,
  [SMALL_STATE(3841)] = 114130,
  [SMALL_STATE(3842)] = 114186,
  [SMALL_STATE(3843)] = 114242,
  [SMALL_STATE(3844)] = 114298,
  [SMALL_STATE(3845)] = 114354,
  [SMALL_STATE(3846)] = 114410,
  [SMALL_STATE(3847)] = 114466,
  [SMALL_STATE(3848)] = 114522,
  [SMALL_STATE(3849)] = 114578,
  [SMALL_STATE(3850)] = 114634,
  [SMALL_STATE(3851)] = 114690,
  [SMALL_STATE(3852)] = 114746,
  [SMALL_STATE(3853)] = 114802,
  [SMALL_STATE(3854)] = 114858,
  [SMALL_STATE(3855)] = 114914,
  [SMALL_STATE(3856)] = 114970,
  [SMALL_STATE(3857)] = 115025,
  [SMALL_STATE(3858)] = 115082,
  [SMALL_STATE(3859)] = 115137,
  [SMALL_STATE(3860)] = 115192,
  [SMALL_STATE(3861)] = 115247,
  [SMALL_STATE(3862)] = 115304,
  [SMALL_STATE(3863)] = 115361,
  [SMALL_STATE(3864)] = 115418,
  [SMALL_STATE(3865)] = 115473,
  [SMALL_STATE(3866)] = 115528,
  [SMALL_STATE(3867)] = 115585,
  [SMALL_STATE(3868)] = 115640,
  [SMALL_STATE(3869)] = 115695,
  [SMALL_STATE(3870)] = 115750,
  [SMALL_STATE(3871)] = 115805,
  [SMALL_STATE(3872)] = 115866,
  [SMALL_STATE(3873)] = 115921,
  [SMALL_STATE(3874)] = 115978,
  [SMALL_STATE(3875)] = 116033,
  [SMALL_STATE(3876)] = 116088,
  [SMALL_STATE(3877)] = 116143,
  [SMALL_STATE(3878)] = 116198,
  [SMALL_STATE(3879)] = 116253,
  [SMALL_STATE(3880)] = 116308,
  [SMALL_STATE(3881)] = 116365,
  [SMALL_STATE(3882)] = 116420,
  [SMALL_STATE(3883)] = 116475,
  [SMALL_STATE(3884)] = 116530,
  [SMALL_STATE(3885)] = 116585,
  [SMALL_STATE(3886)] = 116642,
  [SMALL_STATE(3887)] = 116697,
  [SMALL_STATE(3888)] = 116754,
  [SMALL_STATE(3889)] = 116811,
  [SMALL_STATE(3890)] = 116866,
  [SMALL_STATE(3891)] = 116921,
  [SMALL_STATE(3892)] = 116978,
  [SMALL_STATE(3893)] = 117033,
  [SMALL_STATE(3894)] = 117088,
  [SMALL_STATE(3895)] = 117143,
  [SMALL_STATE(3896)] = 117200,
  [SMALL_STATE(3897)] = 117263,
  [SMALL_STATE(3898)] = 117318,
  [SMALL_STATE(3899)] = 117373,
  [SMALL_STATE(3900)] = 117428,
  [SMALL_STATE(3901)] = 117485,
  [SMALL_STATE(3902)] = 117540,
  [SMALL_STATE(3903)] = 117595,
  [SMALL_STATE(3904)] = 117650,
  [SMALL_STATE(3905)] = 117705,
  [SMALL_STATE(3906)] = 117759,
  [SMALL_STATE(3907)] = 117815,
  [SMALL_STATE(3908)] = 117869,
  [SMALL_STATE(3909)] = 117929,
  [SMALL_STATE(3910)] = 117983,
  [SMALL_STATE(3911)] = 118037,
  [SMALL_STATE(3912)] = 118099,
  [SMALL_STATE(3913)] = 118155,
  [SMALL_STATE(3914)] = 118209,
  [SMALL_STATE(3915)] = 118263,
  [SMALL_STATE(3916)] = 118317,
  [SMALL_STATE(3917)] = 118371,
  [SMALL_STATE(3918)] = 118425,
  [SMALL_STATE(3919)] = 118481,
  [SMALL_STATE(3920)] = 118535,
  [SMALL_STATE(3921)] = 118591,
  [SMALL_STATE(3922)] = 118647,
  [SMALL_STATE(3923)] = 118701,
  [SMALL_STATE(3924)] = 118755,
  [SMALL_STATE(3925)] = 118809,
  [SMALL_STATE(3926)] = 118863,
  [SMALL_STATE(3927)] = 118917,
  [SMALL_STATE(3928)] = 118973,
  [SMALL_STATE(3929)] = 119029,
  [SMALL_STATE(3930)] = 119083,
  [SMALL_STATE(3931)] = 119137,
  [SMALL_STATE(3932)] = 119193,
  [SMALL_STATE(3933)] = 119247,
  [SMALL_STATE(3934)] = 119303,
  [SMALL_STATE(3935)] = 119357,
  [SMALL_STATE(3936)] = 119411,
  [SMALL_STATE(3937)] = 119465,
  [SMALL_STATE(3938)] = 119527,
  [SMALL_STATE(3939)] = 119581,
  [SMALL_STATE(3940)] = 119635,
  [SMALL_STATE(3941)] = 119689,
  [SMALL_STATE(3942)] = 119743,
  [SMALL_STATE(3943)] = 119797,
  [SMALL_STATE(3944)] = 119851,
  [SMALL_STATE(3945)] = 119905,
  [SMALL_STATE(3946)] = 119959,
  [SMALL_STATE(3947)] = 120015,
  [SMALL_STATE(3948)] = 120069,
  [SMALL_STATE(3949)] = 120123,
  [SMALL_STATE(3950)] = 120177,
  [SMALL_STATE(3951)] = 120239,
  [SMALL_STATE(3952)] = 120293,
  [SMALL_STATE(3953)] = 120347,
  [SMALL_STATE(3954)] = 120401,
  [SMALL_STATE(3955)] = 120455,
  [SMALL_STATE(3956)] = 120509,
  [SMALL_STATE(3957)] = 120563,
  [SMALL_STATE(3958)] = 120617,
  [SMALL_STATE(3959)] = 120671,
  [SMALL_STATE(3960)] = 120725,
  [SMALL_STATE(3961)] = 120779,
  [SMALL_STATE(3962)] = 120833,
  [SMALL_STATE(3963)] = 120887,
  [SMALL_STATE(3964)] = 120941,
  [SMALL_STATE(3965)] = 120995,
  [SMALL_STATE(3966)] = 121049,
  [SMALL_STATE(3967)] = 121103,
  [SMALL_STATE(3968)] = 121157,
  [SMALL_STATE(3969)] = 121211,
  [SMALL_STATE(3970)] = 121267,
  [SMALL_STATE(3971)] = 121321,
  [SMALL_STATE(3972)] = 121377,
  [SMALL_STATE(3973)] = 121437,
  [SMALL_STATE(3974)] = 121491,
  [SMALL_STATE(3975)] = 121545,
  [SMALL_STATE(3976)] = 121599,
  [SMALL_STATE(3977)] = 121655,
  [SMALL_STATE(3978)] = 121711,
  [SMALL_STATE(3979)] = 121767,
  [SMALL_STATE(3980)] = 121823,
  [SMALL_STATE(3981)] = 121877,
  [SMALL_STATE(3982)] = 121931,
  [SMALL_STATE(3983)] = 121985,
  [SMALL_STATE(3984)] = 122041,
  [SMALL_STATE(3985)] = 122095,
  [SMALL_STATE(3986)] = 122149,
  [SMALL_STATE(3987)] = 122203,
  [SMALL_STATE(3988)] = 122257,
  [SMALL_STATE(3989)] = 122311,
  [SMALL_STATE(3990)] = 122367,
  [SMALL_STATE(3991)] = 122429,
  [SMALL_STATE(3992)] = 122485,
  [SMALL_STATE(3993)] = 122539,
  [SMALL_STATE(3994)] = 122595,
  [SMALL_STATE(3995)] = 122649,
  [SMALL_STATE(3996)] = 122703,
  [SMALL_STATE(3997)] = 122757,
  [SMALL_STATE(3998)] = 122811,
  [SMALL_STATE(3999)] = 122865,
  [SMALL_STATE(4000)] = 122925,
  [SMALL_STATE(4001)] = 122987,
  [SMALL_STATE(4002)] = 123041,
  [SMALL_STATE(4003)] = 123095,
  [SMALL_STATE(4004)] = 123149,
  [SMALL_STATE(4005)] = 123203,
  [SMALL_STATE(4006)] = 123257,
  [SMALL_STATE(4007)] = 123311,
  [SMALL_STATE(4008)] = 123365,
  [SMALL_STATE(4009)] = 123419,
  [SMALL_STATE(4010)] = 123475,
  [SMALL_STATE(4011)] = 123529,
  [SMALL_STATE(4012)] = 123583,
  [SMALL_STATE(4013)] = 123639,
  [SMALL_STATE(4014)] = 123697,
  [SMALL_STATE(4015)] = 123751,
  [SMALL_STATE(4016)] = 123812,
  [SMALL_STATE(4017)] = 123865,
  [SMALL_STATE(4018)] = 123918,
  [SMALL_STATE(4019)] = 123971,
  [SMALL_STATE(4020)] = 124024,
  [SMALL_STATE(4021)] = 124077,
  [SMALL_STATE(4022)] = 124130,
  [SMALL_STATE(4023)] = 124183,
  [SMALL_STATE(4024)] = 124238,
  [SMALL_STATE(4025)] = 124291,
  [SMALL_STATE(4026)] = 124344,
  [SMALL_STATE(4027)] = 124397,
  [SMALL_STATE(4028)] = 124450,
  [SMALL_STATE(4029)] = 124503,
  [SMALL_STATE(4030)] = 124556,
  [SMALL_STATE(4031)] = 124609,
  [SMALL_STATE(4032)] = 124662,
  [SMALL_STATE(4033)] = 124715,
  [SMALL_STATE(4034)] = 124768,
  [SMALL_STATE(4035)] = 124821,
  [SMALL_STATE(4036)] = 124874,
  [SMALL_STATE(4037)] = 124927,
  [SMALL_STATE(4038)] = 124980,
  [SMALL_STATE(4039)] = 125033,
  [SMALL_STATE(4040)] = 125086,
  [SMALL_STATE(4041)] = 125139,
  [SMALL_STATE(4042)] = 125192,
  [SMALL_STATE(4043)] = 125245,
  [SMALL_STATE(4044)] = 125298,
  [SMALL_STATE(4045)] = 125351,
  [SMALL_STATE(4046)] = 125404,
  [SMALL_STATE(4047)] = 125457,
  [SMALL_STATE(4048)] = 125510,
  [SMALL_STATE(4049)] = 125563,
  [SMALL_STATE(4050)] = 125616,
  [SMALL_STATE(4051)] = 125671,
  [SMALL_STATE(4052)] = 125724,
  [SMALL_STATE(4053)] = 125777,
  [SMALL_STATE(4054)] = 125830,
  [SMALL_STATE(4055)] = 125883,
  [SMALL_STATE(4056)] = 125936,
  [SMALL_STATE(4057)] = 125989,
  [SMALL_STATE(4058)] = 126042,
  [SMALL_STATE(4059)] = 126097,
  [SMALL_STATE(4060)] = 126150,
  [SMALL_STATE(4061)] = 126203,
  [SMALL_STATE(4062)] = 126256,
  [SMALL_STATE(4063)] = 126309,
  [SMALL_STATE(4064)] = 126362,
  [SMALL_STATE(4065)] = 126415,
  [SMALL_STATE(4066)] = 126470,
  [SMALL_STATE(4067)] = 126523,
  [SMALL_STATE(4068)] = 126576,
  [SMALL_STATE(4069)] = 126629,
  [SMALL_STATE(4070)] = 126682,
  [SMALL_STATE(4071)] = 126735,
  [SMALL_STATE(4072)] = 126788,
  [SMALL_STATE(4073)] = 126849,
  [SMALL_STATE(4074)] = 126902,
  [SMALL_STATE(4075)] = 126957,
  [SMALL_STATE(4076)] = 127010,
  [SMALL_STATE(4077)] = 127063,
  [SMALL_STATE(4078)] = 127116,
  [SMALL_STATE(4079)] = 127169,
  [SMALL_STATE(4080)] = 127224,
  [SMALL_STATE(4081)] = 127277,
  [SMALL_STATE(4082)] = 127330,
  [SMALL_STATE(4083)] = 127383,
  [SMALL_STATE(4084)] = 127436,
  [SMALL_STATE(4085)] = 127489,
  [SMALL_STATE(4086)] = 127542,
  [SMALL_STATE(4087)] = 127595,
  [SMALL_STATE(4088)] = 127648,
  [SMALL_STATE(4089)] = 127709,
  [SMALL_STATE(4090)] = 127764,
  [SMALL_STATE(4091)] = 127817,
  [SMALL_STATE(4092)] = 127870,
  [SMALL_STATE(4093)] = 127923,
  [SMALL_STATE(4094)] = 127976,
  [SMALL_STATE(4095)] = 128029,
  [SMALL_STATE(4096)] = 128084,
  [SMALL_STATE(4097)] = 128137,
  [SMALL_STATE(4098)] = 128190,
  [SMALL_STATE(4099)] = 128243,
  [SMALL_STATE(4100)] = 128296,
  [SMALL_STATE(4101)] = 128349,
  [SMALL_STATE(4102)] = 128402,
  [SMALL_STATE(4103)] = 128455,
  [SMALL_STATE(4104)] = 128508,
  [SMALL_STATE(4105)] = 128561,
  [SMALL_STATE(4106)] = 128614,
  [SMALL_STATE(4107)] = 128667,
  [SMALL_STATE(4108)] = 128720,
  [SMALL_STATE(4109)] = 128773,
  [SMALL_STATE(4110)] = 128826,
  [SMALL_STATE(4111)] = 128879,
  [SMALL_STATE(4112)] = 128932,
  [SMALL_STATE(4113)] = 128985,
  [SMALL_STATE(4114)] = 129038,
  [SMALL_STATE(4115)] = 129091,
  [SMALL_STATE(4116)] = 129144,
  [SMALL_STATE(4117)] = 129197,
  [SMALL_STATE(4118)] = 129250,
  [SMALL_STATE(4119)] = 129303,
  [SMALL_STATE(4120)] = 129356,
  [SMALL_STATE(4121)] = 129409,
  [SMALL_STATE(4122)] = 129462,
  [SMALL_STATE(4123)] = 129515,
  [SMALL_STATE(4124)] = 129568,
  [SMALL_STATE(4125)] = 129621,
  [SMALL_STATE(4126)] = 129676,
  [SMALL_STATE(4127)] = 129729,
  [SMALL_STATE(4128)] = 129782,
  [SMALL_STATE(4129)] = 129835,
  [SMALL_STATE(4130)] = 129892,
  [SMALL_STATE(4131)] = 129945,
  [SMALL_STATE(4132)] = 129998,
  [SMALL_STATE(4133)] = 130051,
  [SMALL_STATE(4134)] = 130104,
  [SMALL_STATE(4135)] = 130157,
  [SMALL_STATE(4136)] = 130210,
  [SMALL_STATE(4137)] = 130263,
  [SMALL_STATE(4138)] = 130316,
  [SMALL_STATE(4139)] = 130369,
  [SMALL_STATE(4140)] = 130422,
  [SMALL_STATE(4141)] = 130481,
  [SMALL_STATE(4142)] = 130534,
  [SMALL_STATE(4143)] = 130587,
  [SMALL_STATE(4144)] = 130640,
  [SMALL_STATE(4145)] = 130693,
  [SMALL_STATE(4146)] = 130754,
  [SMALL_STATE(4147)] = 130807,
  [SMALL_STATE(4148)] = 130860,
  [SMALL_STATE(4149)] = 130913,
  [SMALL_STATE(4150)] = 130966,
  [SMALL_STATE(4151)] = 131019,
  [SMALL_STATE(4152)] = 131074,
  [SMALL_STATE(4153)] = 131127,
  [SMALL_STATE(4154)] = 131180,
  [SMALL_STATE(4155)] = 131233,
  [SMALL_STATE(4156)] = 131286,
  [SMALL_STATE(4157)] = 131339,
  [SMALL_STATE(4158)] = 131392,
  [SMALL_STATE(4159)] = 131451,
  [SMALL_STATE(4160)] = 131504,
  [SMALL_STATE(4161)] = 131557,
  [SMALL_STATE(4162)] = 131610,
  [SMALL_STATE(4163)] = 131667,
  [SMALL_STATE(4164)] = 131720,
  [SMALL_STATE(4165)] = 131773,
  [SMALL_STATE(4166)] = 131826,
  [SMALL_STATE(4167)] = 131879,
  [SMALL_STATE(4168)] = 131934,
  [SMALL_STATE(4169)] = 131987,
  [SMALL_STATE(4170)] = 132040,
  [SMALL_STATE(4171)] = 132093,
  [SMALL_STATE(4172)] = 132146,
  [SMALL_STATE(4173)] = 132199,
  [SMALL_STATE(4174)] = 132252,
  [SMALL_STATE(4175)] = 132305,
  [SMALL_STATE(4176)] = 132362,
  [SMALL_STATE(4177)] = 132415,
  [SMALL_STATE(4178)] = 132468,
  [SMALL_STATE(4179)] = 132521,
  [SMALL_STATE(4180)] = 132574,
  [SMALL_STATE(4181)] = 132627,
  [SMALL_STATE(4182)] = 132680,
  [SMALL_STATE(4183)] = 132733,
  [SMALL_STATE(4184)] = 132786,
  [SMALL_STATE(4185)] = 132839,
  [SMALL_STATE(4186)] = 132892,
  [SMALL_STATE(4187)] = 132945,
  [SMALL_STATE(4188)] = 132998,
  [SMALL_STATE(4189)] = 133051,
  [SMALL_STATE(4190)] = 133104,
  [SMALL_STATE(4191)] = 133157,
  [SMALL_STATE(4192)] = 133210,
  [SMALL_STATE(4193)] = 133263,
  [SMALL_STATE(4194)] = 133316,
  [SMALL_STATE(4195)] = 133377,
  [SMALL_STATE(4196)] = 133430,
  [SMALL_STATE(4197)] = 133491,
  [SMALL_STATE(4198)] = 133546,
  [SMALL_STATE(4199)] = 133599,
  [SMALL_STATE(4200)] = 133652,
  [SMALL_STATE(4201)] = 133709,
  [SMALL_STATE(4202)] = 133762,
  [SMALL_STATE(4203)] = 133815,
  [SMALL_STATE(4204)] = 133867,
  [SMALL_STATE(4205)] = 133923,
  [SMALL_STATE(4206)] = 133975,
  [SMALL_STATE(4207)] = 134027,
  [SMALL_STATE(4208)] = 134079,
  [SMALL_STATE(4209)] = 134131,
  [SMALL_STATE(4210)] = 134185,
  [SMALL_STATE(4211)] = 134237,
  [SMALL_STATE(4212)] = 134289,
  [SMALL_STATE(4213)] = 134343,
  [SMALL_STATE(4214)] = 134397,
  [SMALL_STATE(4215)] = 134453,
  [SMALL_STATE(4216)] = 134507,
  [SMALL_STATE(4217)] = 134561,
  [SMALL_STATE(4218)] = 134615,
  [SMALL_STATE(4219)] = 134667,
  [SMALL_STATE(4220)] = 134721,
  [SMALL_STATE(4221)] = 134773,
  [SMALL_STATE(4222)] = 134831,
  [SMALL_STATE(4223)] = 134885,
  [SMALL_STATE(4224)] = 134937,
  [SMALL_STATE(4225)] = 134989,
  [SMALL_STATE(4226)] = 135041,
  [SMALL_STATE(4227)] = 135093,
  [SMALL_STATE(4228)] = 135145,
  [SMALL_STATE(4229)] = 135197,
  [SMALL_STATE(4230)] = 135249,
  [SMALL_STATE(4231)] = 135307,
  [SMALL_STATE(4232)] = 135359,
  [SMALL_STATE(4233)] = 135411,
  [SMALL_STATE(4234)] = 135465,
  [SMALL_STATE(4235)] = 135517,
  [SMALL_STATE(4236)] = 135569,
  [SMALL_STATE(4237)] = 135623,
  [SMALL_STATE(4238)] = 135675,
  [SMALL_STATE(4239)] = 135727,
  [SMALL_STATE(4240)] = 135779,
  [SMALL_STATE(4241)] = 135831,
  [SMALL_STATE(4242)] = 135883,
  [SMALL_STATE(4243)] = 135941,
  [SMALL_STATE(4244)] = 135995,
  [SMALL_STATE(4245)] = 136047,
  [SMALL_STATE(4246)] = 136101,
  [SMALL_STATE(4247)] = 136153,
  [SMALL_STATE(4248)] = 136205,
  [SMALL_STATE(4249)] = 136257,
  [SMALL_STATE(4250)] = 136309,
  [SMALL_STATE(4251)] = 136361,
  [SMALL_STATE(4252)] = 136413,
  [SMALL_STATE(4253)] = 136471,
  [SMALL_STATE(4254)] = 136523,
  [SMALL_STATE(4255)] = 136577,
  [SMALL_STATE(4256)] = 136631,
  [SMALL_STATE(4257)] = 136685,
  [SMALL_STATE(4258)] = 136739,
  [SMALL_STATE(4259)] = 136791,
  [SMALL_STATE(4260)] = 136843,
  [SMALL_STATE(4261)] = 136895,
  [SMALL_STATE(4262)] = 136949,
  [SMALL_STATE(4263)] = 137001,
  [SMALL_STATE(4264)] = 137053,
  [SMALL_STATE(4265)] = 137109,
  [SMALL_STATE(4266)] = 137163,
  [SMALL_STATE(4267)] = 137217,
  [SMALL_STATE(4268)] = 137269,
  [SMALL_STATE(4269)] = 137323,
  [SMALL_STATE(4270)] = 137375,
  [SMALL_STATE(4271)] = 137427,
  [SMALL_STATE(4272)] = 137479,
  [SMALL_STATE(4273)] = 137531,
  [SMALL_STATE(4274)] = 137591,
  [SMALL_STATE(4275)] = 137643,
  [SMALL_STATE(4276)] = 137699,
  [SMALL_STATE(4277)] = 137751,
  [SMALL_STATE(4278)] = 137803,
  [SMALL_STATE(4279)] = 137857,
  [SMALL_STATE(4280)] = 137911,
  [SMALL_STATE(4281)] = 137963,
  [SMALL_STATE(4282)] = 138015,
  [SMALL_STATE(4283)] = 138067,
  [SMALL_STATE(4284)] = 138119,
  [SMALL_STATE(4285)] = 138175,
  [SMALL_STATE(4286)] = 138229,
  [SMALL_STATE(4287)] = 138283,
  [SMALL_STATE(4288)] = 138335,
  [SMALL_STATE(4289)] = 138389,
  [SMALL_STATE(4290)] = 138441,
  [SMALL_STATE(4291)] = 138493,
  [SMALL_STATE(4292)] = 138545,
  [SMALL_STATE(4293)] = 138597,
  [SMALL_STATE(4294)] = 138655,
  [SMALL_STATE(4295)] = 138707,
  [SMALL_STATE(4296)] = 138759,
  [SMALL_STATE(4297)] = 138811,
  [SMALL_STATE(4298)] = 138863,
  [SMALL_STATE(4299)] = 138915,
  [SMALL_STATE(4300)] = 138967,
  [SMALL_STATE(4301)] = 139019,
  [SMALL_STATE(4302)] = 139071,
  [SMALL_STATE(4303)] = 139125,
  [SMALL_STATE(4304)] = 139177,
  [SMALL_STATE(4305)] = 139231,
  [SMALL_STATE(4306)] = 139283,
  [SMALL_STATE(4307)] = 139337,
  [SMALL_STATE(4308)] = 139391,
  [SMALL_STATE(4309)] = 139445,
  [SMALL_STATE(4310)] = 139499,
  [SMALL_STATE(4311)] = 139551,
  [SMALL_STATE(4312)] = 139605,
  [SMALL_STATE(4313)] = 139657,
  [SMALL_STATE(4314)] = 139709,
  [SMALL_STATE(4315)] = 139761,
  [SMALL_STATE(4316)] = 139813,
  [SMALL_STATE(4317)] = 139865,
  [SMALL_STATE(4318)] = 139917,
  [SMALL_STATE(4319)] = 139969,
  [SMALL_STATE(4320)] = 140023,
  [SMALL_STATE(4321)] = 140075,
  [SMALL_STATE(4322)] = 140127,
  [SMALL_STATE(4323)] = 140181,
  [SMALL_STATE(4324)] = 140233,
  [SMALL_STATE(4325)] = 140285,
  [SMALL_STATE(4326)] = 140337,
  [SMALL_STATE(4327)] = 140389,
  [SMALL_STATE(4328)] = 140441,
  [SMALL_STATE(4329)] = 140493,
  [SMALL_STATE(4330)] = 140545,
  [SMALL_STATE(4331)] = 140597,
  [SMALL_STATE(4332)] = 140649,
  [SMALL_STATE(4333)] = 140701,
  [SMALL_STATE(4334)] = 140761,
  [SMALL_STATE(4335)] = 140815,
  [SMALL_STATE(4336)] = 140869,
  [SMALL_STATE(4337)] = 140921,
  [SMALL_STATE(4338)] = 140973,
  [SMALL_STATE(4339)] = 141025,
  [SMALL_STATE(4340)] = 141077,
  [SMALL_STATE(4341)] = 141129,
  [SMALL_STATE(4342)] = 141181,
  [SMALL_STATE(4343)] = 141235,
  [SMALL_STATE(4344)] = 141293,
  [SMALL_STATE(4345)] = 141351,
  [SMALL_STATE(4346)] = 141403,
  [SMALL_STATE(4347)] = 141455,
  [SMALL_STATE(4348)] = 141507,
  [SMALL_STATE(4349)] = 141559,
  [SMALL_STATE(4350)] = 141610,
  [SMALL_STATE(4351)] = 141661,
  [SMALL_STATE(4352)] = 141714,
  [SMALL_STATE(4353)] = 141765,
  [SMALL_STATE(4354)] = 141816,
  [SMALL_STATE(4355)] = 141867,
  [SMALL_STATE(4356)] = 141918,
  [SMALL_STATE(4357)] = 141969,
  [SMALL_STATE(4358)] = 142020,
  [SMALL_STATE(4359)] = 142073,
  [SMALL_STATE(4360)] = 142124,
  [SMALL_STATE(4361)] = 142175,
  [SMALL_STATE(4362)] = 142228,
  [SMALL_STATE(4363)] = 142279,
  [SMALL_STATE(4364)] = 142334,
  [SMALL_STATE(4365)] = 142385,
  [SMALL_STATE(4366)] = 142436,
  [SMALL_STATE(4367)] = 142487,
  [SMALL_STATE(4368)] = 142538,
  [SMALL_STATE(4369)] = 142589,
  [SMALL_STATE(4370)] = 142640,
  [SMALL_STATE(4371)] = 142691,
  [SMALL_STATE(4372)] = 142742,
  [SMALL_STATE(4373)] = 142793,
  [SMALL_STATE(4374)] = 142844,
  [SMALL_STATE(4375)] = 142895,
  [SMALL_STATE(4376)] = 142946,
  [SMALL_STATE(4377)] = 142997,
  [SMALL_STATE(4378)] = 143048,
  [SMALL_STATE(4379)] = 143099,
  [SMALL_STATE(4380)] = 143150,
  [SMALL_STATE(4381)] = 143201,
  [SMALL_STATE(4382)] = 143252,
  [SMALL_STATE(4383)] = 143303,
  [SMALL_STATE(4384)] = 143354,
  [SMALL_STATE(4385)] = 143405,
  [SMALL_STATE(4386)] = 143456,
  [SMALL_STATE(4387)] = 143509,
  [SMALL_STATE(4388)] = 143560,
  [SMALL_STATE(4389)] = 143617,
  [SMALL_STATE(4390)] = 143668,
  [SMALL_STATE(4391)] = 143721,
  [SMALL_STATE(4392)] = 143772,
  [SMALL_STATE(4393)] = 143823,
  [SMALL_STATE(4394)] = 143874,
  [SMALL_STATE(4395)] = 143925,
  [SMALL_STATE(4396)] = 143976,
  [SMALL_STATE(4397)] = 144027,
  [SMALL_STATE(4398)] = 144078,
  [SMALL_STATE(4399)] = 144129,
  [SMALL_STATE(4400)] = 144180,
  [SMALL_STATE(4401)] = 144233,
  [SMALL_STATE(4402)] = 144284,
  [SMALL_STATE(4403)] = 144341,
  [SMALL_STATE(4404)] = 144392,
  [SMALL_STATE(4405)] = 144447,
  [SMALL_STATE(4406)] = 144502,
  [SMALL_STATE(4407)] = 144555,
  [SMALL_STATE(4408)] = 144606,
  [SMALL_STATE(4409)] = 144657,
  [SMALL_STATE(4410)] = 144708,
  [SMALL_STATE(4411)] = 144759,
  [SMALL_STATE(4412)] = 144810,
  [SMALL_STATE(4413)] = 144861,
  [SMALL_STATE(4414)] = 144912,
  [SMALL_STATE(4415)] = 144963,
  [SMALL_STATE(4416)] = 145014,
  [SMALL_STATE(4417)] = 145065,
  [SMALL_STATE(4418)] = 145118,
  [SMALL_STATE(4419)] = 145175,
  [SMALL_STATE(4420)] = 145226,
  [SMALL_STATE(4421)] = 145277,
  [SMALL_STATE(4422)] = 145328,
  [SMALL_STATE(4423)] = 145379,
  [SMALL_STATE(4424)] = 145434,
  [SMALL_STATE(4425)] = 145485,
  [SMALL_STATE(4426)] = 145542,
  [SMALL_STATE(4427)] = 145593,
  [SMALL_STATE(4428)] = 145644,
  [SMALL_STATE(4429)] = 145697,
  [SMALL_STATE(4430)] = 145748,
  [SMALL_STATE(4431)] = 145799,
  [SMALL_STATE(4432)] = 145854,
  [SMALL_STATE(4433)] = 145907,
  [SMALL_STATE(4434)] = 145960,
  [SMALL_STATE(4435)] = 146013,
  [SMALL_STATE(4436)] = 146064,
  [SMALL_STATE(4437)] = 146115,
  [SMALL_STATE(4438)] = 146170,
  [SMALL_STATE(4439)] = 146225,
  [SMALL_STATE(4440)] = 146276,
  [SMALL_STATE(4441)] = 146327,
  [SMALL_STATE(4442)] = 146378,
  [SMALL_STATE(4443)] = 146429,
  [SMALL_STATE(4444)] = 146480,
  [SMALL_STATE(4445)] = 146531,
  [SMALL_STATE(4446)] = 146582,
  [SMALL_STATE(4447)] = 146633,
  [SMALL_STATE(4448)] = 146690,
  [SMALL_STATE(4449)] = 146741,
  [SMALL_STATE(4450)] = 146792,
  [SMALL_STATE(4451)] = 146843,
  [SMALL_STATE(4452)] = 146894,
  [SMALL_STATE(4453)] = 146947,
  [SMALL_STATE(4454)] = 146998,
  [SMALL_STATE(4455)] = 147049,
  [SMALL_STATE(4456)] = 147102,
  [SMALL_STATE(4457)] = 147153,
  [SMALL_STATE(4458)] = 147204,
  [SMALL_STATE(4459)] = 147255,
  [SMALL_STATE(4460)] = 147306,
  [SMALL_STATE(4461)] = 147357,
  [SMALL_STATE(4462)] = 147408,
  [SMALL_STATE(4463)] = 147459,
  [SMALL_STATE(4464)] = 147510,
  [SMALL_STATE(4465)] = 147563,
  [SMALL_STATE(4466)] = 147616,
  [SMALL_STATE(4467)] = 147667,
  [SMALL_STATE(4468)] = 147718,
  [SMALL_STATE(4469)] = 147769,
  [SMALL_STATE(4470)] = 147820,
  [SMALL_STATE(4471)] = 147871,
  [SMALL_STATE(4472)] = 147922,
  [SMALL_STATE(4473)] = 147973,
  [SMALL_STATE(4474)] = 148024,
  [SMALL_STATE(4475)] = 148075,
  [SMALL_STATE(4476)] = 148126,
  [SMALL_STATE(4477)] = 148177,
  [SMALL_STATE(4478)] = 148228,
  [SMALL_STATE(4479)] = 148279,
  [SMALL_STATE(4480)] = 148330,
  [SMALL_STATE(4481)] = 148381,
  [SMALL_STATE(4482)] = 148432,
  [SMALL_STATE(4483)] = 148483,
  [SMALL_STATE(4484)] = 148534,
  [SMALL_STATE(4485)] = 148585,
  [SMALL_STATE(4486)] = 148636,
  [SMALL_STATE(4487)] = 148687,
  [SMALL_STATE(4488)] = 148738,
  [SMALL_STATE(4489)] = 148789,
  [SMALL_STATE(4490)] = 148840,
  [SMALL_STATE(4491)] = 148891,
  [SMALL_STATE(4492)] = 148942,
  [SMALL_STATE(4493)] = 148993,
  [SMALL_STATE(4494)] = 149044,
  [SMALL_STATE(4495)] = 149095,
  [SMALL_STATE(4496)] = 149146,
  [SMALL_STATE(4497)] = 149197,
  [SMALL_STATE(4498)] = 149248,
  [SMALL_STATE(4499)] = 149301,
  [SMALL_STATE(4500)] = 149352,
  [SMALL_STATE(4501)] = 149403,
  [SMALL_STATE(4502)] = 149456,
  [SMALL_STATE(4503)] = 149507,
  [SMALL_STATE(4504)] = 149558,
  [SMALL_STATE(4505)] = 149609,
  [SMALL_STATE(4506)] = 149660,
  [SMALL_STATE(4507)] = 149711,
  [SMALL_STATE(4508)] = 149762,
  [SMALL_STATE(4509)] = 149813,
  [SMALL_STATE(4510)] = 149864,
  [SMALL_STATE(4511)] = 149915,
  [SMALL_STATE(4512)] = 149968,
  [SMALL_STATE(4513)] = 150019,
  [SMALL_STATE(4514)] = 150070,
  [SMALL_STATE(4515)] = 150121,
  [SMALL_STATE(4516)] = 150172,
  [SMALL_STATE(4517)] = 150223,
  [SMALL_STATE(4518)] = 150274,
  [SMALL_STATE(4519)] = 150327,
  [SMALL_STATE(4520)] = 150378,
  [SMALL_STATE(4521)] = 150429,
  [SMALL_STATE(4522)] = 150480,
  [SMALL_STATE(4523)] = 150531,
  [SMALL_STATE(4524)] = 150582,
  [SMALL_STATE(4525)] = 150633,
  [SMALL_STATE(4526)] = 150684,
  [SMALL_STATE(4527)] = 150735,
  [SMALL_STATE(4528)] = 150786,
  [SMALL_STATE(4529)] = 150837,
  [SMALL_STATE(4530)] = 150888,
  [SMALL_STATE(4531)] = 150941,
  [SMALL_STATE(4532)] = 150994,
  [SMALL_STATE(4533)] = 151047,
  [SMALL_STATE(4534)] = 151098,
  [SMALL_STATE(4535)] = 151149,
  [SMALL_STATE(4536)] = 151202,
  [SMALL_STATE(4537)] = 151255,
  [SMALL_STATE(4538)] = 151306,
  [SMALL_STATE(4539)] = 151357,
  [SMALL_STATE(4540)] = 151410,
  [SMALL_STATE(4541)] = 151463,
  [SMALL_STATE(4542)] = 151514,
  [SMALL_STATE(4543)] = 151565,
  [SMALL_STATE(4544)] = 151622,
  [SMALL_STATE(4545)] = 151673,
  [SMALL_STATE(4546)] = 151728,
  [SMALL_STATE(4547)] = 151781,
  [SMALL_STATE(4548)] = 151832,
  [SMALL_STATE(4549)] = 151885,
  [SMALL_STATE(4550)] = 151938,
  [SMALL_STATE(4551)] = 151989,
  [SMALL_STATE(4552)] = 152040,
  [SMALL_STATE(4553)] = 152093,
  [SMALL_STATE(4554)] = 152144,
  [SMALL_STATE(4555)] = 152195,
  [SMALL_STATE(4556)] = 152246,
  [SMALL_STATE(4557)] = 152297,
  [SMALL_STATE(4558)] = 152348,
  [SMALL_STATE(4559)] = 152399,
  [SMALL_STATE(4560)] = 152450,
  [SMALL_STATE(4561)] = 152501,
  [SMALL_STATE(4562)] = 152552,
  [SMALL_STATE(4563)] = 152605,
  [SMALL_STATE(4564)] = 152658,
  [SMALL_STATE(4565)] = 152709,
  [SMALL_STATE(4566)] = 152760,
  [SMALL_STATE(4567)] = 152811,
  [SMALL_STATE(4568)] = 152862,
  [SMALL_STATE(4569)] = 152913,
  [SMALL_STATE(4570)] = 152964,
  [SMALL_STATE(4571)] = 153015,
  [SMALL_STATE(4572)] = 153066,
  [SMALL_STATE(4573)] = 153117,
  [SMALL_STATE(4574)] = 153168,
  [SMALL_STATE(4575)] = 153225,
  [SMALL_STATE(4576)] = 153276,
  [SMALL_STATE(4577)] = 153327,
  [SMALL_STATE(4578)] = 153378,
  [SMALL_STATE(4579)] = 153429,
  [SMALL_STATE(4580)] = 153480,
  [SMALL_STATE(4581)] = 153531,
  [SMALL_STATE(4582)] = 153582,
  [SMALL_STATE(4583)] = 153633,
  [SMALL_STATE(4584)] = 153684,
  [SMALL_STATE(4585)] = 153735,
  [SMALL_STATE(4586)] = 153786,
  [SMALL_STATE(4587)] = 153845,
  [SMALL_STATE(4588)] = 153896,
  [SMALL_STATE(4589)] = 153949,
  [SMALL_STATE(4590)] = 154000,
  [SMALL_STATE(4591)] = 154051,
  [SMALL_STATE(4592)] = 154106,
  [SMALL_STATE(4593)] = 154157,
  [SMALL_STATE(4594)] = 154208,
  [SMALL_STATE(4595)] = 154259,
  [SMALL_STATE(4596)] = 154316,
  [SMALL_STATE(4597)] = 154367,
  [SMALL_STATE(4598)] = 154418,
  [SMALL_STATE(4599)] = 154469,
  [SMALL_STATE(4600)] = 154520,
  [SMALL_STATE(4601)] = 154573,
  [SMALL_STATE(4602)] = 154624,
  [SMALL_STATE(4603)] = 154675,
  [SMALL_STATE(4604)] = 154726,
  [SMALL_STATE(4605)] = 154777,
  [SMALL_STATE(4606)] = 154828,
  [SMALL_STATE(4607)] = 154879,
  [SMALL_STATE(4608)] = 154930,
  [SMALL_STATE(4609)] = 154981,
  [SMALL_STATE(4610)] = 155032,
  [SMALL_STATE(4611)] = 155083,
  [SMALL_STATE(4612)] = 155134,
  [SMALL_STATE(4613)] = 155185,
  [SMALL_STATE(4614)] = 155236,
  [SMALL_STATE(4615)] = 155287,
  [SMALL_STATE(4616)] = 155338,
  [SMALL_STATE(4617)] = 155389,
  [SMALL_STATE(4618)] = 155440,
  [SMALL_STATE(4619)] = 155491,
  [SMALL_STATE(4620)] = 155542,
  [SMALL_STATE(4621)] = 155593,
  [SMALL_STATE(4622)] = 155644,
  [SMALL_STATE(4623)] = 155695,
  [SMALL_STATE(4624)] = 155746,
  [SMALL_STATE(4625)] = 155801,
  [SMALL_STATE(4626)] = 155854,
  [SMALL_STATE(4627)] = 155905,
  [SMALL_STATE(4628)] = 155956,
  [SMALL_STATE(4629)] = 156009,
  [SMALL_STATE(4630)] = 156060,
  [SMALL_STATE(4631)] = 156111,
  [SMALL_STATE(4632)] = 156162,
  [SMALL_STATE(4633)] = 156215,
  [SMALL_STATE(4634)] = 156266,
  [SMALL_STATE(4635)] = 156317,
  [SMALL_STATE(4636)] = 156368,
  [SMALL_STATE(4637)] = 156419,
  [SMALL_STATE(4638)] = 156470,
  [SMALL_STATE(4639)] = 156521,
  [SMALL_STATE(4640)] = 156572,
  [SMALL_STATE(4641)] = 156623,
  [SMALL_STATE(4642)] = 156674,
  [SMALL_STATE(4643)] = 156725,
  [SMALL_STATE(4644)] = 156776,
  [SMALL_STATE(4645)] = 156827,
  [SMALL_STATE(4646)] = 156878,
  [SMALL_STATE(4647)] = 156929,
  [SMALL_STATE(4648)] = 156980,
  [SMALL_STATE(4649)] = 157031,
  [SMALL_STATE(4650)] = 157082,
  [SMALL_STATE(4651)] = 157135,
  [SMALL_STATE(4652)] = 157188,
  [SMALL_STATE(4653)] = 157239,
  [SMALL_STATE(4654)] = 157290,
  [SMALL_STATE(4655)] = 157341,
  [SMALL_STATE(4656)] = 157392,
  [SMALL_STATE(4657)] = 157443,
  [SMALL_STATE(4658)] = 157494,
  [SMALL_STATE(4659)] = 157545,
  [SMALL_STATE(4660)] = 157596,
  [SMALL_STATE(4661)] = 157651,
  [SMALL_STATE(4662)] = 157704,
  [SMALL_STATE(4663)] = 157755,
  [SMALL_STATE(4664)] = 157808,
  [SMALL_STATE(4665)] = 157859,
  [SMALL_STATE(4666)] = 157910,
  [SMALL_STATE(4667)] = 157963,
  [SMALL_STATE(4668)] = 158014,
  [SMALL_STATE(4669)] = 158065,
  [SMALL_STATE(4670)] = 158116,
  [SMALL_STATE(4671)] = 158167,
  [SMALL_STATE(4672)] = 158218,
  [SMALL_STATE(4673)] = 158269,
  [SMALL_STATE(4674)] = 158320,
  [SMALL_STATE(4675)] = 158377,
  [SMALL_STATE(4676)] = 158432,
  [SMALL_STATE(4677)] = 158483,
  [SMALL_STATE(4678)] = 158538,
  [SMALL_STATE(4679)] = 158589,
  [SMALL_STATE(4680)] = 158640,
  [SMALL_STATE(4681)] = 158691,
  [SMALL_STATE(4682)] = 158742,
  [SMALL_STATE(4683)] = 158795,
  [SMALL_STATE(4684)] = 158848,
  [SMALL_STATE(4685)] = 158899,
  [SMALL_STATE(4686)] = 158950,
  [SMALL_STATE(4687)] = 159001,
  [SMALL_STATE(4688)] = 159052,
  [SMALL_STATE(4689)] = 159103,
  [SMALL_STATE(4690)] = 159154,
  [SMALL_STATE(4691)] = 159205,
  [SMALL_STATE(4692)] = 159256,
  [SMALL_STATE(4693)] = 159307,
  [SMALL_STATE(4694)] = 159358,
  [SMALL_STATE(4695)] = 159409,
  [SMALL_STATE(4696)] = 159460,
  [SMALL_STATE(4697)] = 159511,
  [SMALL_STATE(4698)] = 159562,
  [SMALL_STATE(4699)] = 159613,
  [SMALL_STATE(4700)] = 159664,
  [SMALL_STATE(4701)] = 159715,
  [SMALL_STATE(4702)] = 159766,
  [SMALL_STATE(4703)] = 159817,
  [SMALL_STATE(4704)] = 159868,
  [SMALL_STATE(4705)] = 159919,
  [SMALL_STATE(4706)] = 159970,
  [SMALL_STATE(4707)] = 160021,
  [SMALL_STATE(4708)] = 160072,
  [SMALL_STATE(4709)] = 160123,
  [SMALL_STATE(4710)] = 160174,
  [SMALL_STATE(4711)] = 160225,
  [SMALL_STATE(4712)] = 160278,
  [SMALL_STATE(4713)] = 160329,
  [SMALL_STATE(4714)] = 160380,
  [SMALL_STATE(4715)] = 160431,
  [SMALL_STATE(4716)] = 160482,
  [SMALL_STATE(4717)] = 160535,
  [SMALL_STATE(4718)] = 160586,
  [SMALL_STATE(4719)] = 160637,
  [SMALL_STATE(4720)] = 160688,
  [SMALL_STATE(4721)] = 160739,
  [SMALL_STATE(4722)] = 160790,
  [SMALL_STATE(4723)] = 160841,
  [SMALL_STATE(4724)] = 160896,
  [SMALL_STATE(4725)] = 160947,
  [SMALL_STATE(4726)] = 160998,
  [SMALL_STATE(4727)] = 161049,
  [SMALL_STATE(4728)] = 161100,
  [SMALL_STATE(4729)] = 161151,
  [SMALL_STATE(4730)] = 161202,
  [SMALL_STATE(4731)] = 161253,
  [SMALL_STATE(4732)] = 161304,
  [SMALL_STATE(4733)] = 161355,
  [SMALL_STATE(4734)] = 161408,
  [SMALL_STATE(4735)] = 161459,
  [SMALL_STATE(4736)] = 161510,
  [SMALL_STATE(4737)] = 161561,
  [SMALL_STATE(4738)] = 161612,
  [SMALL_STATE(4739)] = 161663,
  [SMALL_STATE(4740)] = 161714,
  [SMALL_STATE(4741)] = 161765,
  [SMALL_STATE(4742)] = 161816,
  [SMALL_STATE(4743)] = 161867,
  [SMALL_STATE(4744)] = 161918,
  [SMALL_STATE(4745)] = 161969,
  [SMALL_STATE(4746)] = 162020,
  [SMALL_STATE(4747)] = 162071,
  [SMALL_STATE(4748)] = 162122,
  [SMALL_STATE(4749)] = 162177,
  [SMALL_STATE(4750)] = 162230,
  [SMALL_STATE(4751)] = 162281,
  [SMALL_STATE(4752)] = 162332,
  [SMALL_STATE(4753)] = 162383,
  [SMALL_STATE(4754)] = 162434,
  [SMALL_STATE(4755)] = 162485,
  [SMALL_STATE(4756)] = 162536,
  [SMALL_STATE(4757)] = 162587,
  [SMALL_STATE(4758)] = 162638,
  [SMALL_STATE(4759)] = 162689,
  [SMALL_STATE(4760)] = 162740,
  [SMALL_STATE(4761)] = 162791,
  [SMALL_STATE(4762)] = 162842,
  [SMALL_STATE(4763)] = 162893,
  [SMALL_STATE(4764)] = 162944,
  [SMALL_STATE(4765)] = 162995,
  [SMALL_STATE(4766)] = 163046,
  [SMALL_STATE(4767)] = 163097,
  [SMALL_STATE(4768)] = 163148,
  [SMALL_STATE(4769)] = 163199,
  [SMALL_STATE(4770)] = 163250,
  [SMALL_STATE(4771)] = 163301,
  [SMALL_STATE(4772)] = 163352,
  [SMALL_STATE(4773)] = 163403,
  [SMALL_STATE(4774)] = 163454,
  [SMALL_STATE(4775)] = 163505,
  [SMALL_STATE(4776)] = 163556,
  [SMALL_STATE(4777)] = 163607,
  [SMALL_STATE(4778)] = 163658,
  [SMALL_STATE(4779)] = 163711,
  [SMALL_STATE(4780)] = 163762,
  [SMALL_STATE(4781)] = 163813,
  [SMALL_STATE(4782)] = 163864,
  [SMALL_STATE(4783)] = 163921,
  [SMALL_STATE(4784)] = 163972,
  [SMALL_STATE(4785)] = 164023,
  [SMALL_STATE(4786)] = 164074,
  [SMALL_STATE(4787)] = 164125,
  [SMALL_STATE(4788)] = 164176,
  [SMALL_STATE(4789)] = 164227,
  [SMALL_STATE(4790)] = 164278,
  [SMALL_STATE(4791)] = 164329,
  [SMALL_STATE(4792)] = 164380,
  [SMALL_STATE(4793)] = 164431,
  [SMALL_STATE(4794)] = 164482,
  [SMALL_STATE(4795)] = 164533,
  [SMALL_STATE(4796)] = 164584,
  [SMALL_STATE(4797)] = 164635,
  [SMALL_STATE(4798)] = 164686,
  [SMALL_STATE(4799)] = 164737,
  [SMALL_STATE(4800)] = 164788,
  [SMALL_STATE(4801)] = 164839,
  [SMALL_STATE(4802)] = 164890,
  [SMALL_STATE(4803)] = 164941,
  [SMALL_STATE(4804)] = 164992,
  [SMALL_STATE(4805)] = 165043,
  [SMALL_STATE(4806)] = 165094,
  [SMALL_STATE(4807)] = 165147,
  [SMALL_STATE(4808)] = 165198,
  [SMALL_STATE(4809)] = 165249,
  [SMALL_STATE(4810)] = 165300,
  [SMALL_STATE(4811)] = 165351,
  [SMALL_STATE(4812)] = 165402,
  [SMALL_STATE(4813)] = 165453,
  [SMALL_STATE(4814)] = 165504,
  [SMALL_STATE(4815)] = 165561,
  [SMALL_STATE(4816)] = 165612,
  [SMALL_STATE(4817)] = 165663,
  [SMALL_STATE(4818)] = 165714,
  [SMALL_STATE(4819)] = 165765,
  [SMALL_STATE(4820)] = 165816,
  [SMALL_STATE(4821)] = 165867,
  [SMALL_STATE(4822)] = 165918,
  [SMALL_STATE(4823)] = 165969,
  [SMALL_STATE(4824)] = 166020,
  [SMALL_STATE(4825)] = 166071,
  [SMALL_STATE(4826)] = 166122,
  [SMALL_STATE(4827)] = 166173,
  [SMALL_STATE(4828)] = 166226,
  [SMALL_STATE(4829)] = 166279,
  [SMALL_STATE(4830)] = 166330,
  [SMALL_STATE(4831)] = 166381,
  [SMALL_STATE(4832)] = 166432,
  [SMALL_STATE(4833)] = 166483,
  [SMALL_STATE(4834)] = 166534,
  [SMALL_STATE(4835)] = 166585,
  [SMALL_STATE(4836)] = 166636,
  [SMALL_STATE(4837)] = 166687,
  [SMALL_STATE(4838)] = 166738,
  [SMALL_STATE(4839)] = 166793,
  [SMALL_STATE(4840)] = 166844,
  [SMALL_STATE(4841)] = 166895,
  [SMALL_STATE(4842)] = 166946,
  [SMALL_STATE(4843)] = 166997,
  [SMALL_STATE(4844)] = 167048,
  [SMALL_STATE(4845)] = 167099,
  [SMALL_STATE(4846)] = 167150,
  [SMALL_STATE(4847)] = 167201,
  [SMALL_STATE(4848)] = 167252,
  [SMALL_STATE(4849)] = 167303,
  [SMALL_STATE(4850)] = 167354,
  [SMALL_STATE(4851)] = 167405,
  [SMALL_STATE(4852)] = 167456,
  [SMALL_STATE(4853)] = 167507,
  [SMALL_STATE(4854)] = 167558,
  [SMALL_STATE(4855)] = 167609,
  [SMALL_STATE(4856)] = 167660,
  [SMALL_STATE(4857)] = 167711,
  [SMALL_STATE(4858)] = 167762,
  [SMALL_STATE(4859)] = 167813,
  [SMALL_STATE(4860)] = 167864,
  [SMALL_STATE(4861)] = 167914,
  [SMALL_STATE(4862)] = 167964,
  [SMALL_STATE(4863)] = 168014,
  [SMALL_STATE(4864)] = 168066,
  [SMALL_STATE(4865)] = 168116,
  [SMALL_STATE(4866)] = 168166,
  [SMALL_STATE(4867)] = 168216,
  [SMALL_STATE(4868)] = 168266,
  [SMALL_STATE(4869)] = 168316,
  [SMALL_STATE(4870)] = 168366,
  [SMALL_STATE(4871)] = 168416,
  [SMALL_STATE(4872)] = 168466,
  [SMALL_STATE(4873)] = 168516,
  [SMALL_STATE(4874)] = 168566,
  [SMALL_STATE(4875)] = 168616,
  [SMALL_STATE(4876)] = 168666,
  [SMALL_STATE(4877)] = 168716,
  [SMALL_STATE(4878)] = 168766,
  [SMALL_STATE(4879)] = 168820,
  [SMALL_STATE(4880)] = 168870,
  [SMALL_STATE(4881)] = 168920,
  [SMALL_STATE(4882)] = 168970,
  [SMALL_STATE(4883)] = 169020,
  [SMALL_STATE(4884)] = 169070,
  [SMALL_STATE(4885)] = 169120,
  [SMALL_STATE(4886)] = 169170,
  [SMALL_STATE(4887)] = 169220,
  [SMALL_STATE(4888)] = 169270,
  [SMALL_STATE(4889)] = 169320,
  [SMALL_STATE(4890)] = 169370,
  [SMALL_STATE(4891)] = 169420,
  [SMALL_STATE(4892)] = 169470,
  [SMALL_STATE(4893)] = 169520,
  [SMALL_STATE(4894)] = 169570,
  [SMALL_STATE(4895)] = 169620,
  [SMALL_STATE(4896)] = 169670,
  [SMALL_STATE(4897)] = 169720,
  [SMALL_STATE(4898)] = 169770,
  [SMALL_STATE(4899)] = 169820,
  [SMALL_STATE(4900)] = 169870,
  [SMALL_STATE(4901)] = 169920,
  [SMALL_STATE(4902)] = 169970,
  [SMALL_STATE(4903)] = 170022,
  [SMALL_STATE(4904)] = 170072,
  [SMALL_STATE(4905)] = 170122,
  [SMALL_STATE(4906)] = 170172,
  [SMALL_STATE(4907)] = 170222,
  [SMALL_STATE(4908)] = 170272,
  [SMALL_STATE(4909)] = 170322,
  [SMALL_STATE(4910)] = 170372,
  [SMALL_STATE(4911)] = 170422,
  [SMALL_STATE(4912)] = 170472,
  [SMALL_STATE(4913)] = 170524,
  [SMALL_STATE(4914)] = 170574,
  [SMALL_STATE(4915)] = 170626,
  [SMALL_STATE(4916)] = 170678,
  [SMALL_STATE(4917)] = 170728,
  [SMALL_STATE(4918)] = 170778,
  [SMALL_STATE(4919)] = 170828,
  [SMALL_STATE(4920)] = 170880,
  [SMALL_STATE(4921)] = 170930,
  [SMALL_STATE(4922)] = 170980,
  [SMALL_STATE(4923)] = 171030,
  [SMALL_STATE(4924)] = 171080,
  [SMALL_STATE(4925)] = 171130,
  [SMALL_STATE(4926)] = 171180,
  [SMALL_STATE(4927)] = 171230,
  [SMALL_STATE(4928)] = 171280,
  [SMALL_STATE(4929)] = 171330,
  [SMALL_STATE(4930)] = 171380,
  [SMALL_STATE(4931)] = 171432,
  [SMALL_STATE(4932)] = 171482,
  [SMALL_STATE(4933)] = 171532,
  [SMALL_STATE(4934)] = 171582,
  [SMALL_STATE(4935)] = 171632,
  [SMALL_STATE(4936)] = 171684,
  [SMALL_STATE(4937)] = 171734,
  [SMALL_STATE(4938)] = 171784,
  [SMALL_STATE(4939)] = 171834,
  [SMALL_STATE(4940)] = 171884,
  [SMALL_STATE(4941)] = 171934,
  [SMALL_STATE(4942)] = 171984,
  [SMALL_STATE(4943)] = 172034,
  [SMALL_STATE(4944)] = 172084,
  [SMALL_STATE(4945)] = 172138,
  [SMALL_STATE(4946)] = 172188,
  [SMALL_STATE(4947)] = 172238,
  [SMALL_STATE(4948)] = 172288,
  [SMALL_STATE(4949)] = 172342,
  [SMALL_STATE(4950)] = 172392,
  [SMALL_STATE(4951)] = 172442,
  [SMALL_STATE(4952)] = 172492,
  [SMALL_STATE(4953)] = 172542,
  [SMALL_STATE(4954)] = 172592,
  [SMALL_STATE(4955)] = 172642,
  [SMALL_STATE(4956)] = 172692,
  [SMALL_STATE(4957)] = 172742,
  [SMALL_STATE(4958)] = 172792,
  [SMALL_STATE(4959)] = 172842,
  [SMALL_STATE(4960)] = 172894,
  [SMALL_STATE(4961)] = 172944,
  [SMALL_STATE(4962)] = 172994,
  [SMALL_STATE(4963)] = 173044,
  [SMALL_STATE(4964)] = 173094,
  [SMALL_STATE(4965)] = 173144,
  [SMALL_STATE(4966)] = 173194,
  [SMALL_STATE(4967)] = 173244,
  [SMALL_STATE(4968)] = 173294,
  [SMALL_STATE(4969)] = 173344,
  [SMALL_STATE(4970)] = 173394,
  [SMALL_STATE(4971)] = 173444,
  [SMALL_STATE(4972)] = 173494,
  [SMALL_STATE(4973)] = 173544,
  [SMALL_STATE(4974)] = 173598,
  [SMALL_STATE(4975)] = 173648,
  [SMALL_STATE(4976)] = 173700,
  [SMALL_STATE(4977)] = 173750,
  [SMALL_STATE(4978)] = 173800,
  [SMALL_STATE(4979)] = 173850,
  [SMALL_STATE(4980)] = 173900,
  [SMALL_STATE(4981)] = 173950,
  [SMALL_STATE(4982)] = 174000,
  [SMALL_STATE(4983)] = 174050,
  [SMALL_STATE(4984)] = 174100,
  [SMALL_STATE(4985)] = 174150,
  [SMALL_STATE(4986)] = 174200,
  [SMALL_STATE(4987)] = 174250,
  [SMALL_STATE(4988)] = 174300,
  [SMALL_STATE(4989)] = 174350,
  [SMALL_STATE(4990)] = 174400,
  [SMALL_STATE(4991)] = 174450,
  [SMALL_STATE(4992)] = 174500,
  [SMALL_STATE(4993)] = 174550,
  [SMALL_STATE(4994)] = 174600,
  [SMALL_STATE(4995)] = 174650,
  [SMALL_STATE(4996)] = 174700,
  [SMALL_STATE(4997)] = 174750,
  [SMALL_STATE(4998)] = 174800,
  [SMALL_STATE(4999)] = 174850,
  [SMALL_STATE(5000)] = 174900,
  [SMALL_STATE(5001)] = 174950,
  [SMALL_STATE(5002)] = 175000,
  [SMALL_STATE(5003)] = 175050,
  [SMALL_STATE(5004)] = 175100,
  [SMALL_STATE(5005)] = 175150,
  [SMALL_STATE(5006)] = 175200,
  [SMALL_STATE(5007)] = 175250,
  [SMALL_STATE(5008)] = 175300,
  [SMALL_STATE(5009)] = 175350,
  [SMALL_STATE(5010)] = 175400,
  [SMALL_STATE(5011)] = 175450,
  [SMALL_STATE(5012)] = 175500,
  [SMALL_STATE(5013)] = 175550,
  [SMALL_STATE(5014)] = 175600,
  [SMALL_STATE(5015)] = 175650,
  [SMALL_STATE(5016)] = 175700,
  [SMALL_STATE(5017)] = 175750,
  [SMALL_STATE(5018)] = 175800,
  [SMALL_STATE(5019)] = 175852,
  [SMALL_STATE(5020)] = 175902,
  [SMALL_STATE(5021)] = 175952,
  [SMALL_STATE(5022)] = 176008,
  [SMALL_STATE(5023)] = 176058,
  [SMALL_STATE(5024)] = 176108,
  [SMALL_STATE(5025)] = 176158,
  [SMALL_STATE(5026)] = 176208,
  [SMALL_STATE(5027)] = 176258,
  [SMALL_STATE(5028)] = 176308,
  [SMALL_STATE(5029)] = 176358,
  [SMALL_STATE(5030)] = 176408,
  [SMALL_STATE(5031)] = 176458,
  [SMALL_STATE(5032)] = 176508,
  [SMALL_STATE(5033)] = 176558,
  [SMALL_STATE(5034)] = 176608,
  [SMALL_STATE(5035)] = 176658,
  [SMALL_STATE(5036)] = 176708,
  [SMALL_STATE(5037)] = 176758,
  [SMALL_STATE(5038)] = 176808,
  [SMALL_STATE(5039)] = 176858,
  [SMALL_STATE(5040)] = 176908,
  [SMALL_STATE(5041)] = 176958,
  [SMALL_STATE(5042)] = 177008,
  [SMALL_STATE(5043)] = 177058,
  [SMALL_STATE(5044)] = 177108,
  [SMALL_STATE(5045)] = 177158,
  [SMALL_STATE(5046)] = 177212,
  [SMALL_STATE(5047)] = 177262,
  [SMALL_STATE(5048)] = 177318,
  [SMALL_STATE(5049)] = 177368,
  [SMALL_STATE(5050)] = 177418,
  [SMALL_STATE(5051)] = 177468,
  [SMALL_STATE(5052)] = 177518,
  [SMALL_STATE(5053)] = 177568,
  [SMALL_STATE(5054)] = 177618,
  [SMALL_STATE(5055)] = 177668,
  [SMALL_STATE(5056)] = 177718,
  [SMALL_STATE(5057)] = 177768,
  [SMALL_STATE(5058)] = 177818,
  [SMALL_STATE(5059)] = 177868,
  [SMALL_STATE(5060)] = 177918,
  [SMALL_STATE(5061)] = 177968,
  [SMALL_STATE(5062)] = 178018,
  [SMALL_STATE(5063)] = 178068,
  [SMALL_STATE(5064)] = 178118,
  [SMALL_STATE(5065)] = 178168,
  [SMALL_STATE(5066)] = 178218,
  [SMALL_STATE(5067)] = 178268,
  [SMALL_STATE(5068)] = 178318,
  [SMALL_STATE(5069)] = 178368,
  [SMALL_STATE(5070)] = 178418,
  [SMALL_STATE(5071)] = 178468,
  [SMALL_STATE(5072)] = 178520,
  [SMALL_STATE(5073)] = 178570,
  [SMALL_STATE(5074)] = 178620,
  [SMALL_STATE(5075)] = 178670,
  [SMALL_STATE(5076)] = 178720,
  [SMALL_STATE(5077)] = 178776,
  [SMALL_STATE(5078)] = 178826,
  [SMALL_STATE(5079)] = 178876,
  [SMALL_STATE(5080)] = 178926,
  [SMALL_STATE(5081)] = 178976,
  [SMALL_STATE(5082)] = 179026,
  [SMALL_STATE(5083)] = 179076,
  [SMALL_STATE(5084)] = 179126,
  [SMALL_STATE(5085)] = 179176,
  [SMALL_STATE(5086)] = 179226,
  [SMALL_STATE(5087)] = 179278,
  [SMALL_STATE(5088)] = 179328,
  [SMALL_STATE(5089)] = 179378,
  [SMALL_STATE(5090)] = 179428,
  [SMALL_STATE(5091)] = 179478,
  [SMALL_STATE(5092)] = 179528,
  [SMALL_STATE(5093)] = 179578,
  [SMALL_STATE(5094)] = 179628,
  [SMALL_STATE(5095)] = 179678,
  [SMALL_STATE(5096)] = 179728,
  [SMALL_STATE(5097)] = 179778,
  [SMALL_STATE(5098)] = 179830,
  [SMALL_STATE(5099)] = 179880,
  [SMALL_STATE(5100)] = 179930,
  [SMALL_STATE(5101)] = 179984,
  [SMALL_STATE(5102)] = 180038,
  [SMALL_STATE(5103)] = 180092,
  [SMALL_STATE(5104)] = 180142,
  [SMALL_STATE(5105)] = 180192,
  [SMALL_STATE(5106)] = 180242,
  [SMALL_STATE(5107)] = 180292,
  [SMALL_STATE(5108)] = 180342,
  [SMALL_STATE(5109)] = 180392,
  [SMALL_STATE(5110)] = 180442,
  [SMALL_STATE(5111)] = 180492,
  [SMALL_STATE(5112)] = 180542,
  [SMALL_STATE(5113)] = 180592,
  [SMALL_STATE(5114)] = 180642,
  [SMALL_STATE(5115)] = 180692,
  [SMALL_STATE(5116)] = 180742,
  [SMALL_STATE(5117)] = 180792,
  [SMALL_STATE(5118)] = 180842,
  [SMALL_STATE(5119)] = 180892,
  [SMALL_STATE(5120)] = 180942,
  [SMALL_STATE(5121)] = 180992,
  [SMALL_STATE(5122)] = 181042,
  [SMALL_STATE(5123)] = 181092,
  [SMALL_STATE(5124)] = 181142,
  [SMALL_STATE(5125)] = 181192,
  [SMALL_STATE(5126)] = 181242,
  [SMALL_STATE(5127)] = 181292,
  [SMALL_STATE(5128)] = 181342,
  [SMALL_STATE(5129)] = 181392,
  [SMALL_STATE(5130)] = 181442,
  [SMALL_STATE(5131)] = 181492,
  [SMALL_STATE(5132)] = 181542,
  [SMALL_STATE(5133)] = 181592,
  [SMALL_STATE(5134)] = 181642,
  [SMALL_STATE(5135)] = 181692,
  [SMALL_STATE(5136)] = 181742,
  [SMALL_STATE(5137)] = 181792,
  [SMALL_STATE(5138)] = 181842,
  [SMALL_STATE(5139)] = 181892,
  [SMALL_STATE(5140)] = 181942,
  [SMALL_STATE(5141)] = 181992,
  [SMALL_STATE(5142)] = 182042,
  [SMALL_STATE(5143)] = 182094,
  [SMALL_STATE(5144)] = 182144,
  [SMALL_STATE(5145)] = 182194,
  [SMALL_STATE(5146)] = 182244,
  [SMALL_STATE(5147)] = 182294,
  [SMALL_STATE(5148)] = 182344,
  [SMALL_STATE(5149)] = 182394,
  [SMALL_STATE(5150)] = 182444,
  [SMALL_STATE(5151)] = 182494,
  [SMALL_STATE(5152)] = 182546,
  [SMALL_STATE(5153)] = 182596,
  [SMALL_STATE(5154)] = 182646,
  [SMALL_STATE(5155)] = 182696,
  [SMALL_STATE(5156)] = 182746,
  [SMALL_STATE(5157)] = 182796,
  [SMALL_STATE(5158)] = 182846,
  [SMALL_STATE(5159)] = 182896,
  [SMALL_STATE(5160)] = 182946,
  [SMALL_STATE(5161)] = 182996,
  [SMALL_STATE(5162)] = 183046,
  [SMALL_STATE(5163)] = 183096,
  [SMALL_STATE(5164)] = 183146,
  [SMALL_STATE(5165)] = 183196,
  [SMALL_STATE(5166)] = 183246,
  [SMALL_STATE(5167)] = 183296,
  [SMALL_STATE(5168)] = 183346,
  [SMALL_STATE(5169)] = 183396,
  [SMALL_STATE(5170)] = 183446,
  [SMALL_STATE(5171)] = 183496,
  [SMALL_STATE(5172)] = 183546,
  [SMALL_STATE(5173)] = 183598,
  [SMALL_STATE(5174)] = 183648,
  [SMALL_STATE(5175)] = 183698,
  [SMALL_STATE(5176)] = 183748,
  [SMALL_STATE(5177)] = 183798,
  [SMALL_STATE(5178)] = 183848,
  [SMALL_STATE(5179)] = 183898,
  [SMALL_STATE(5180)] = 183948,
  [SMALL_STATE(5181)] = 183998,
  [SMALL_STATE(5182)] = 184048,
  [SMALL_STATE(5183)] = 184098,
  [SMALL_STATE(5184)] = 184148,
  [SMALL_STATE(5185)] = 184198,
  [SMALL_STATE(5186)] = 184248,
  [SMALL_STATE(5187)] = 184298,
  [SMALL_STATE(5188)] = 184350,
  [SMALL_STATE(5189)] = 184400,
  [SMALL_STATE(5190)] = 184450,
  [SMALL_STATE(5191)] = 184500,
  [SMALL_STATE(5192)] = 184550,
  [SMALL_STATE(5193)] = 184600,
  [SMALL_STATE(5194)] = 184654,
  [SMALL_STATE(5195)] = 184706,
  [SMALL_STATE(5196)] = 184760,
  [SMALL_STATE(5197)] = 184810,
  [SMALL_STATE(5198)] = 184860,
  [SMALL_STATE(5199)] = 184910,
  [SMALL_STATE(5200)] = 184960,
  [SMALL_STATE(5201)] = 185010,
  [SMALL_STATE(5202)] = 185060,
  [SMALL_STATE(5203)] = 185110,
  [SMALL_STATE(5204)] = 185160,
  [SMALL_STATE(5205)] = 185210,
  [SMALL_STATE(5206)] = 185260,
  [SMALL_STATE(5207)] = 185310,
  [SMALL_STATE(5208)] = 185364,
  [SMALL_STATE(5209)] = 185414,
  [SMALL_STATE(5210)] = 185464,
  [SMALL_STATE(5211)] = 185514,
  [SMALL_STATE(5212)] = 185564,
  [SMALL_STATE(5213)] = 185614,
  [SMALL_STATE(5214)] = 185664,
  [SMALL_STATE(5215)] = 185714,
  [SMALL_STATE(5216)] = 185764,
  [SMALL_STATE(5217)] = 185814,
  [SMALL_STATE(5218)] = 185864,
  [SMALL_STATE(5219)] = 185914,
  [SMALL_STATE(5220)] = 185964,
  [SMALL_STATE(5221)] = 186014,
  [SMALL_STATE(5222)] = 186064,
  [SMALL_STATE(5223)] = 186114,
  [SMALL_STATE(5224)] = 186164,
  [SMALL_STATE(5225)] = 186214,
  [SMALL_STATE(5226)] = 186264,
  [SMALL_STATE(5227)] = 186314,
  [SMALL_STATE(5228)] = 186364,
  [SMALL_STATE(5229)] = 186414,
  [SMALL_STATE(5230)] = 186464,
  [SMALL_STATE(5231)] = 186514,
  [SMALL_STATE(5232)] = 186564,
  [SMALL_STATE(5233)] = 186614,
  [SMALL_STATE(5234)] = 186664,
  [SMALL_STATE(5235)] = 186714,
  [SMALL_STATE(5236)] = 186764,
  [SMALL_STATE(5237)] = 186814,
  [SMALL_STATE(5238)] = 186864,
  [SMALL_STATE(5239)] = 186914,
  [SMALL_STATE(5240)] = 186964,
  [SMALL_STATE(5241)] = 187014,
  [SMALL_STATE(5242)] = 187064,
  [SMALL_STATE(5243)] = 187114,
  [SMALL_STATE(5244)] = 187164,
  [SMALL_STATE(5245)] = 187214,
  [SMALL_STATE(5246)] = 187264,
  [SMALL_STATE(5247)] = 187314,
  [SMALL_STATE(5248)] = 187364,
  [SMALL_STATE(5249)] = 187414,
  [SMALL_STATE(5250)] = 187464,
  [SMALL_STATE(5251)] = 187514,
  [SMALL_STATE(5252)] = 187564,
  [SMALL_STATE(5253)] = 187614,
  [SMALL_STATE(5254)] = 187664,
  [SMALL_STATE(5255)] = 187714,
  [SMALL_STATE(5256)] = 187764,
  [SMALL_STATE(5257)] = 187814,
  [SMALL_STATE(5258)] = 187864,
  [SMALL_STATE(5259)] = 187914,
  [SMALL_STATE(5260)] = 187966,
  [SMALL_STATE(5261)] = 188016,
  [SMALL_STATE(5262)] = 188066,
  [SMALL_STATE(5263)] = 188116,
  [SMALL_STATE(5264)] = 188166,
  [SMALL_STATE(5265)] = 188216,
  [SMALL_STATE(5266)] = 188266,
  [SMALL_STATE(5267)] = 188316,
  [SMALL_STATE(5268)] = 188366,
  [SMALL_STATE(5269)] = 188416,
  [SMALL_STATE(5270)] = 188466,
  [SMALL_STATE(5271)] = 188516,
  [SMALL_STATE(5272)] = 188566,
  [SMALL_STATE(5273)] = 188616,
  [SMALL_STATE(5274)] = 188666,
  [SMALL_STATE(5275)] = 188716,
  [SMALL_STATE(5276)] = 188766,
  [SMALL_STATE(5277)] = 188816,
  [SMALL_STATE(5278)] = 188866,
  [SMALL_STATE(5279)] = 188916,
  [SMALL_STATE(5280)] = 188966,
  [SMALL_STATE(5281)] = 189016,
  [SMALL_STATE(5282)] = 189066,
  [SMALL_STATE(5283)] = 189116,
  [SMALL_STATE(5284)] = 189166,
  [SMALL_STATE(5285)] = 189216,
  [SMALL_STATE(5286)] = 189266,
  [SMALL_STATE(5287)] = 189316,
  [SMALL_STATE(5288)] = 189366,
  [SMALL_STATE(5289)] = 189416,
  [SMALL_STATE(5290)] = 189470,
  [SMALL_STATE(5291)] = 189520,
  [SMALL_STATE(5292)] = 189570,
  [SMALL_STATE(5293)] = 189620,
  [SMALL_STATE(5294)] = 189670,
  [SMALL_STATE(5295)] = 189720,
  [SMALL_STATE(5296)] = 189770,
  [SMALL_STATE(5297)] = 189820,
  [SMALL_STATE(5298)] = 189870,
  [SMALL_STATE(5299)] = 189920,
  [SMALL_STATE(5300)] = 189970,
  [SMALL_STATE(5301)] = 190020,
  [SMALL_STATE(5302)] = 190070,
  [SMALL_STATE(5303)] = 190120,
  [SMALL_STATE(5304)] = 190170,
  [SMALL_STATE(5305)] = 190220,
  [SMALL_STATE(5306)] = 190270,
  [SMALL_STATE(5307)] = 190322,
  [SMALL_STATE(5308)] = 190372,
  [SMALL_STATE(5309)] = 190422,
  [SMALL_STATE(5310)] = 190472,
  [SMALL_STATE(5311)] = 190522,
  [SMALL_STATE(5312)] = 190572,
  [SMALL_STATE(5313)] = 190622,
  [SMALL_STATE(5314)] = 190672,
  [SMALL_STATE(5315)] = 190724,
  [SMALL_STATE(5316)] = 190774,
  [SMALL_STATE(5317)] = 190824,
  [SMALL_STATE(5318)] = 190874,
  [SMALL_STATE(5319)] = 190924,
  [SMALL_STATE(5320)] = 190974,
  [SMALL_STATE(5321)] = 191024,
  [SMALL_STATE(5322)] = 191074,
  [SMALL_STATE(5323)] = 191124,
  [SMALL_STATE(5324)] = 191174,
  [SMALL_STATE(5325)] = 191224,
  [SMALL_STATE(5326)] = 191274,
  [SMALL_STATE(5327)] = 191324,
  [SMALL_STATE(5328)] = 191374,
  [SMALL_STATE(5329)] = 191424,
  [SMALL_STATE(5330)] = 191474,
  [SMALL_STATE(5331)] = 191524,
  [SMALL_STATE(5332)] = 191574,
  [SMALL_STATE(5333)] = 191626,
  [SMALL_STATE(5334)] = 191676,
  [SMALL_STATE(5335)] = 191726,
  [SMALL_STATE(5336)] = 191776,
  [SMALL_STATE(5337)] = 191826,
  [SMALL_STATE(5338)] = 191876,
  [SMALL_STATE(5339)] = 191926,
  [SMALL_STATE(5340)] = 191976,
  [SMALL_STATE(5341)] = 192026,
  [SMALL_STATE(5342)] = 192076,
  [SMALL_STATE(5343)] = 192130,
  [SMALL_STATE(5344)] = 192180,
  [SMALL_STATE(5345)] = 192230,
  [SMALL_STATE(5346)] = 192280,
  [SMALL_STATE(5347)] = 192330,
  [SMALL_STATE(5348)] = 192380,
  [SMALL_STATE(5349)] = 192434,
  [SMALL_STATE(5350)] = 192484,
  [SMALL_STATE(5351)] = 192534,
  [SMALL_STATE(5352)] = 192584,
  [SMALL_STATE(5353)] = 192634,
  [SMALL_STATE(5354)] = 192684,
  [SMALL_STATE(5355)] = 192734,
  [SMALL_STATE(5356)] = 192784,
  [SMALL_STATE(5357)] = 192834,
  [SMALL_STATE(5358)] = 192884,
  [SMALL_STATE(5359)] = 192934,
  [SMALL_STATE(5360)] = 192984,
  [SMALL_STATE(5361)] = 193034,
  [SMALL_STATE(5362)] = 193084,
  [SMALL_STATE(5363)] = 193134,
  [SMALL_STATE(5364)] = 193184,
  [SMALL_STATE(5365)] = 193234,
  [SMALL_STATE(5366)] = 193284,
  [SMALL_STATE(5367)] = 193334,
  [SMALL_STATE(5368)] = 193384,
  [SMALL_STATE(5369)] = 193434,
  [SMALL_STATE(5370)] = 193484,
  [SMALL_STATE(5371)] = 193536,
  [SMALL_STATE(5372)] = 193586,
  [SMALL_STATE(5373)] = 193636,
  [SMALL_STATE(5374)] = 193686,
  [SMALL_STATE(5375)] = 193736,
  [SMALL_STATE(5376)] = 193786,
  [SMALL_STATE(5377)] = 193836,
  [SMALL_STATE(5378)] = 193886,
  [SMALL_STATE(5379)] = 193936,
  [SMALL_STATE(5380)] = 193986,
  [SMALL_STATE(5381)] = 194036,
  [SMALL_STATE(5382)] = 194086,
  [SMALL_STATE(5383)] = 194136,
  [SMALL_STATE(5384)] = 194186,
  [SMALL_STATE(5385)] = 194236,
  [SMALL_STATE(5386)] = 194286,
  [SMALL_STATE(5387)] = 194336,
  [SMALL_STATE(5388)] = 194386,
  [SMALL_STATE(5389)] = 194436,
  [SMALL_STATE(5390)] = 194486,
  [SMALL_STATE(5391)] = 194536,
  [SMALL_STATE(5392)] = 194586,
  [SMALL_STATE(5393)] = 194636,
  [SMALL_STATE(5394)] = 194686,
  [SMALL_STATE(5395)] = 194736,
  [SMALL_STATE(5396)] = 194786,
  [SMALL_STATE(5397)] = 194836,
  [SMALL_STATE(5398)] = 194886,
  [SMALL_STATE(5399)] = 194936,
  [SMALL_STATE(5400)] = 194986,
  [SMALL_STATE(5401)] = 195036,
  [SMALL_STATE(5402)] = 195086,
  [SMALL_STATE(5403)] = 195136,
  [SMALL_STATE(5404)] = 195186,
  [SMALL_STATE(5405)] = 195236,
  [SMALL_STATE(5406)] = 195288,
  [SMALL_STATE(5407)] = 195338,
  [SMALL_STATE(5408)] = 195388,
  [SMALL_STATE(5409)] = 195438,
  [SMALL_STATE(5410)] = 195490,
  [SMALL_STATE(5411)] = 195540,
  [SMALL_STATE(5412)] = 195590,
  [SMALL_STATE(5413)] = 195640,
  [SMALL_STATE(5414)] = 195690,
  [SMALL_STATE(5415)] = 195740,
  [SMALL_STATE(5416)] = 195790,
  [SMALL_STATE(5417)] = 195840,
  [SMALL_STATE(5418)] = 195890,
  [SMALL_STATE(5419)] = 195940,
  [SMALL_STATE(5420)] = 195990,
  [SMALL_STATE(5421)] = 196040,
  [SMALL_STATE(5422)] = 196090,
  [SMALL_STATE(5423)] = 196142,
  [SMALL_STATE(5424)] = 196192,
  [SMALL_STATE(5425)] = 196242,
  [SMALL_STATE(5426)] = 196292,
  [SMALL_STATE(5427)] = 196342,
  [SMALL_STATE(5428)] = 196392,
  [SMALL_STATE(5429)] = 196442,
  [SMALL_STATE(5430)] = 196492,
  [SMALL_STATE(5431)] = 196546,
  [SMALL_STATE(5432)] = 196596,
  [SMALL_STATE(5433)] = 196646,
  [SMALL_STATE(5434)] = 196696,
  [SMALL_STATE(5435)] = 196746,
  [SMALL_STATE(5436)] = 196796,
  [SMALL_STATE(5437)] = 196848,
  [SMALL_STATE(5438)] = 196898,
  [SMALL_STATE(5439)] = 196948,
  [SMALL_STATE(5440)] = 196998,
  [SMALL_STATE(5441)] = 197048,
  [SMALL_STATE(5442)] = 197098,
  [SMALL_STATE(5443)] = 197148,
  [SMALL_STATE(5444)] = 197198,
  [SMALL_STATE(5445)] = 197248,
  [SMALL_STATE(5446)] = 197298,
  [SMALL_STATE(5447)] = 197348,
  [SMALL_STATE(5448)] = 197398,
  [SMALL_STATE(5449)] = 197448,
  [SMALL_STATE(5450)] = 197498,
  [SMALL_STATE(5451)] = 197548,
  [SMALL_STATE(5452)] = 197598,
  [SMALL_STATE(5453)] = 197648,
  [SMALL_STATE(5454)] = 197698,
  [SMALL_STATE(5455)] = 197748,
  [SMALL_STATE(5456)] = 197798,
  [SMALL_STATE(5457)] = 197848,
  [SMALL_STATE(5458)] = 197898,
  [SMALL_STATE(5459)] = 197948,
  [SMALL_STATE(5460)] = 197998,
  [SMALL_STATE(5461)] = 198048,
  [SMALL_STATE(5462)] = 198098,
  [SMALL_STATE(5463)] = 198148,
  [SMALL_STATE(5464)] = 198198,
  [SMALL_STATE(5465)] = 198248,
  [SMALL_STATE(5466)] = 198298,
  [SMALL_STATE(5467)] = 198348,
  [SMALL_STATE(5468)] = 198398,
  [SMALL_STATE(5469)] = 198448,
  [SMALL_STATE(5470)] = 198498,
  [SMALL_STATE(5471)] = 198548,
  [SMALL_STATE(5472)] = 198598,
  [SMALL_STATE(5473)] = 198648,
  [SMALL_STATE(5474)] = 198698,
  [SMALL_STATE(5475)] = 198750,
  [SMALL_STATE(5476)] = 198800,
  [SMALL_STATE(5477)] = 198850,
  [SMALL_STATE(5478)] = 198902,
  [SMALL_STATE(5479)] = 198952,
  [SMALL_STATE(5480)] = 199002,
  [SMALL_STATE(5481)] = 199052,
  [SMALL_STATE(5482)] = 199102,
  [SMALL_STATE(5483)] = 199152,
  [SMALL_STATE(5484)] = 199202,
  [SMALL_STATE(5485)] = 199252,
  [SMALL_STATE(5486)] = 199302,
  [SMALL_STATE(5487)] = 199352,
  [SMALL_STATE(5488)] = 199402,
  [SMALL_STATE(5489)] = 199452,
  [SMALL_STATE(5490)] = 199501,
  [SMALL_STATE(5491)] = 199550,
  [SMALL_STATE(5492)] = 199601,
  [SMALL_STATE(5493)] = 199650,
  [SMALL_STATE(5494)] = 199699,
  [SMALL_STATE(5495)] = 199748,
  [SMALL_STATE(5496)] = 199797,
  [SMALL_STATE(5497)] = 199846,
  [SMALL_STATE(5498)] = 199895,
  [SMALL_STATE(5499)] = 199944,
  [SMALL_STATE(5500)] = 199993,
  [SMALL_STATE(5501)] = 200042,
  [SMALL_STATE(5502)] = 200091,
  [SMALL_STATE(5503)] = 200140,
  [SMALL_STATE(5504)] = 200189,
  [SMALL_STATE(5505)] = 200238,
  [SMALL_STATE(5506)] = 200287,
  [SMALL_STATE(5507)] = 200336,
  [SMALL_STATE(5508)] = 200385,
  [SMALL_STATE(5509)] = 200434,
  [SMALL_STATE(5510)] = 200483,
  [SMALL_STATE(5511)] = 200532,
  [SMALL_STATE(5512)] = 200581,
  [SMALL_STATE(5513)] = 200630,
  [SMALL_STATE(5514)] = 200679,
  [SMALL_STATE(5515)] = 200728,
  [SMALL_STATE(5516)] = 200777,
  [SMALL_STATE(5517)] = 200826,
  [SMALL_STATE(5518)] = 200875,
  [SMALL_STATE(5519)] = 200924,
  [SMALL_STATE(5520)] = 200973,
  [SMALL_STATE(5521)] = 201022,
  [SMALL_STATE(5522)] = 201071,
  [SMALL_STATE(5523)] = 201120,
  [SMALL_STATE(5524)] = 201169,
  [SMALL_STATE(5525)] = 201218,
  [SMALL_STATE(5526)] = 201267,
  [SMALL_STATE(5527)] = 201316,
  [SMALL_STATE(5528)] = 201365,
  [SMALL_STATE(5529)] = 201414,
  [SMALL_STATE(5530)] = 201465,
  [SMALL_STATE(5531)] = 201514,
  [SMALL_STATE(5532)] = 201563,
  [SMALL_STATE(5533)] = 201612,
  [SMALL_STATE(5534)] = 201661,
  [SMALL_STATE(5535)] = 201710,
  [SMALL_STATE(5536)] = 201759,
  [SMALL_STATE(5537)] = 201808,
  [SMALL_STATE(5538)] = 201857,
  [SMALL_STATE(5539)] = 201906,
  [SMALL_STATE(5540)] = 201955,
  [SMALL_STATE(5541)] = 202004,
  [SMALL_STATE(5542)] = 202053,
  [SMALL_STATE(5543)] = 202104,
  [SMALL_STATE(5544)] = 202155,
  [SMALL_STATE(5545)] = 202204,
  [SMALL_STATE(5546)] = 202253,
  [SMALL_STATE(5547)] = 202302,
  [SMALL_STATE(5548)] = 202351,
  [SMALL_STATE(5549)] = 202400,
  [SMALL_STATE(5550)] = 202449,
  [SMALL_STATE(5551)] = 202498,
  [SMALL_STATE(5552)] = 202549,
  [SMALL_STATE(5553)] = 202598,
  [SMALL_STATE(5554)] = 202647,
  [SMALL_STATE(5555)] = 202696,
  [SMALL_STATE(5556)] = 202745,
  [SMALL_STATE(5557)] = 202796,
  [SMALL_STATE(5558)] = 202845,
  [SMALL_STATE(5559)] = 202894,
  [SMALL_STATE(5560)] = 202943,
  [SMALL_STATE(5561)] = 202992,
  [SMALL_STATE(5562)] = 203041,
  [SMALL_STATE(5563)] = 203090,
  [SMALL_STATE(5564)] = 203139,
  [SMALL_STATE(5565)] = 203188,
  [SMALL_STATE(5566)] = 203237,
  [SMALL_STATE(5567)] = 203286,
  [SMALL_STATE(5568)] = 203335,
  [SMALL_STATE(5569)] = 203384,
  [SMALL_STATE(5570)] = 203433,
  [SMALL_STATE(5571)] = 203482,
  [SMALL_STATE(5572)] = 203531,
  [SMALL_STATE(5573)] = 203582,
  [SMALL_STATE(5574)] = 203631,
  [SMALL_STATE(5575)] = 203680,
  [SMALL_STATE(5576)] = 203729,
  [SMALL_STATE(5577)] = 203778,
  [SMALL_STATE(5578)] = 203827,
  [SMALL_STATE(5579)] = 203876,
  [SMALL_STATE(5580)] = 203925,
  [SMALL_STATE(5581)] = 203974,
  [SMALL_STATE(5582)] = 204023,
  [SMALL_STATE(5583)] = 204072,
  [SMALL_STATE(5584)] = 204121,
  [SMALL_STATE(5585)] = 204170,
  [SMALL_STATE(5586)] = 204219,
  [SMALL_STATE(5587)] = 204268,
  [SMALL_STATE(5588)] = 204319,
  [SMALL_STATE(5589)] = 204368,
  [SMALL_STATE(5590)] = 204417,
  [SMALL_STATE(5591)] = 204466,
  [SMALL_STATE(5592)] = 204515,
  [SMALL_STATE(5593)] = 204564,
  [SMALL_STATE(5594)] = 204613,
  [SMALL_STATE(5595)] = 204662,
  [SMALL_STATE(5596)] = 204711,
  [SMALL_STATE(5597)] = 204760,
  [SMALL_STATE(5598)] = 204809,
  [SMALL_STATE(5599)] = 204858,
  [SMALL_STATE(5600)] = 204907,
  [SMALL_STATE(5601)] = 204956,
  [SMALL_STATE(5602)] = 205005,
  [SMALL_STATE(5603)] = 205054,
  [SMALL_STATE(5604)] = 205103,
  [SMALL_STATE(5605)] = 205152,
  [SMALL_STATE(5606)] = 205201,
  [SMALL_STATE(5607)] = 205250,
  [SMALL_STATE(5608)] = 205299,
  [SMALL_STATE(5609)] = 205348,
  [SMALL_STATE(5610)] = 205397,
  [SMALL_STATE(5611)] = 205446,
  [SMALL_STATE(5612)] = 205495,
  [SMALL_STATE(5613)] = 205544,
  [SMALL_STATE(5614)] = 205593,
  [SMALL_STATE(5615)] = 205642,
  [SMALL_STATE(5616)] = 205691,
  [SMALL_STATE(5617)] = 205740,
  [SMALL_STATE(5618)] = 205789,
  [SMALL_STATE(5619)] = 205838,
  [SMALL_STATE(5620)] = 205887,
  [SMALL_STATE(5621)] = 205936,
  [SMALL_STATE(5622)] = 205985,
  [SMALL_STATE(5623)] = 206034,
  [SMALL_STATE(5624)] = 206083,
  [SMALL_STATE(5625)] = 206132,
  [SMALL_STATE(5626)] = 206181,
  [SMALL_STATE(5627)] = 206230,
  [SMALL_STATE(5628)] = 206279,
  [SMALL_STATE(5629)] = 206328,
  [SMALL_STATE(5630)] = 206377,
  [SMALL_STATE(5631)] = 206426,
  [SMALL_STATE(5632)] = 206475,
  [SMALL_STATE(5633)] = 206524,
  [SMALL_STATE(5634)] = 206573,
  [SMALL_STATE(5635)] = 206622,
  [SMALL_STATE(5636)] = 206671,
  [SMALL_STATE(5637)] = 206720,
  [SMALL_STATE(5638)] = 206769,
  [SMALL_STATE(5639)] = 206820,
  [SMALL_STATE(5640)] = 206869,
  [SMALL_STATE(5641)] = 206920,
  [SMALL_STATE(5642)] = 206971,
  [SMALL_STATE(5643)] = 207020,
  [SMALL_STATE(5644)] = 207069,
  [SMALL_STATE(5645)] = 207118,
  [SMALL_STATE(5646)] = 207167,
  [SMALL_STATE(5647)] = 207216,
  [SMALL_STATE(5648)] = 207265,
  [SMALL_STATE(5649)] = 207314,
  [SMALL_STATE(5650)] = 207363,
  [SMALL_STATE(5651)] = 207412,
  [SMALL_STATE(5652)] = 207461,
  [SMALL_STATE(5653)] = 207510,
  [SMALL_STATE(5654)] = 207559,
  [SMALL_STATE(5655)] = 207608,
  [SMALL_STATE(5656)] = 207657,
  [SMALL_STATE(5657)] = 207706,
  [SMALL_STATE(5658)] = 207755,
  [SMALL_STATE(5659)] = 207806,
  [SMALL_STATE(5660)] = 207857,
  [SMALL_STATE(5661)] = 207906,
  [SMALL_STATE(5662)] = 207955,
  [SMALL_STATE(5663)] = 208006,
  [SMALL_STATE(5664)] = 208057,
  [SMALL_STATE(5665)] = 208106,
  [SMALL_STATE(5666)] = 208155,
  [SMALL_STATE(5667)] = 208204,
  [SMALL_STATE(5668)] = 208253,
  [SMALL_STATE(5669)] = 208302,
  [SMALL_STATE(5670)] = 208351,
  [SMALL_STATE(5671)] = 208400,
  [SMALL_STATE(5672)] = 208449,
  [SMALL_STATE(5673)] = 208498,
  [SMALL_STATE(5674)] = 208547,
  [SMALL_STATE(5675)] = 208602,
  [SMALL_STATE(5676)] = 208651,
  [SMALL_STATE(5677)] = 208700,
  [SMALL_STATE(5678)] = 208749,
  [SMALL_STATE(5679)] = 208798,
  [SMALL_STATE(5680)] = 208847,
  [SMALL_STATE(5681)] = 208896,
  [SMALL_STATE(5682)] = 208947,
  [SMALL_STATE(5683)] = 208996,
  [SMALL_STATE(5684)] = 209045,
  [SMALL_STATE(5685)] = 209094,
  [SMALL_STATE(5686)] = 209143,
  [SMALL_STATE(5687)] = 209192,
  [SMALL_STATE(5688)] = 209241,
  [SMALL_STATE(5689)] = 209290,
  [SMALL_STATE(5690)] = 209339,
  [SMALL_STATE(5691)] = 209388,
  [SMALL_STATE(5692)] = 209437,
  [SMALL_STATE(5693)] = 209486,
  [SMALL_STATE(5694)] = 209535,
  [SMALL_STATE(5695)] = 209584,
  [SMALL_STATE(5696)] = 209633,
  [SMALL_STATE(5697)] = 209682,
  [SMALL_STATE(5698)] = 209731,
  [SMALL_STATE(5699)] = 209780,
  [SMALL_STATE(5700)] = 209829,
  [SMALL_STATE(5701)] = 209878,
  [SMALL_STATE(5702)] = 209927,
  [SMALL_STATE(5703)] = 209976,
  [SMALL_STATE(5704)] = 210025,
  [SMALL_STATE(5705)] = 210074,
  [SMALL_STATE(5706)] = 210123,
  [SMALL_STATE(5707)] = 210172,
  [SMALL_STATE(5708)] = 210221,
  [SMALL_STATE(5709)] = 210270,
  [SMALL_STATE(5710)] = 210319,
  [SMALL_STATE(5711)] = 210368,
  [SMALL_STATE(5712)] = 210417,
  [SMALL_STATE(5713)] = 210466,
  [SMALL_STATE(5714)] = 210515,
  [SMALL_STATE(5715)] = 210564,
  [SMALL_STATE(5716)] = 210613,
  [SMALL_STATE(5717)] = 210662,
  [SMALL_STATE(5718)] = 210711,
  [SMALL_STATE(5719)] = 210760,
  [SMALL_STATE(5720)] = 210809,
  [SMALL_STATE(5721)] = 210858,
  [SMALL_STATE(5722)] = 210907,
  [SMALL_STATE(5723)] = 210956,
  [SMALL_STATE(5724)] = 211005,
  [SMALL_STATE(5725)] = 211054,
  [SMALL_STATE(5726)] = 211103,
  [SMALL_STATE(5727)] = 211152,
  [SMALL_STATE(5728)] = 211201,
  [SMALL_STATE(5729)] = 211250,
  [SMALL_STATE(5730)] = 211299,
  [SMALL_STATE(5731)] = 211348,
  [SMALL_STATE(5732)] = 211397,
  [SMALL_STATE(5733)] = 211446,
  [SMALL_STATE(5734)] = 211495,
  [SMALL_STATE(5735)] = 211544,
  [SMALL_STATE(5736)] = 211593,
  [SMALL_STATE(5737)] = 211642,
  [SMALL_STATE(5738)] = 211691,
  [SMALL_STATE(5739)] = 211740,
  [SMALL_STATE(5740)] = 211789,
  [SMALL_STATE(5741)] = 211838,
  [SMALL_STATE(5742)] = 211887,
  [SMALL_STATE(5743)] = 211936,
  [SMALL_STATE(5744)] = 211985,
  [SMALL_STATE(5745)] = 212034,
  [SMALL_STATE(5746)] = 212083,
  [SMALL_STATE(5747)] = 212132,
  [SMALL_STATE(5748)] = 212181,
  [SMALL_STATE(5749)] = 212230,
  [SMALL_STATE(5750)] = 212279,
  [SMALL_STATE(5751)] = 212328,
  [SMALL_STATE(5752)] = 212377,
  [SMALL_STATE(5753)] = 212426,
  [SMALL_STATE(5754)] = 212475,
  [SMALL_STATE(5755)] = 212524,
  [SMALL_STATE(5756)] = 212573,
  [SMALL_STATE(5757)] = 212622,
  [SMALL_STATE(5758)] = 212671,
  [SMALL_STATE(5759)] = 212720,
  [SMALL_STATE(5760)] = 212769,
  [SMALL_STATE(5761)] = 212818,
  [SMALL_STATE(5762)] = 212867,
  [SMALL_STATE(5763)] = 212915,
  [SMALL_STATE(5764)] = 212963,
  [SMALL_STATE(5765)] = 213011,
  [SMALL_STATE(5766)] = 213059,
  [SMALL_STATE(5767)] = 213107,
  [SMALL_STATE(5768)] = 213155,
  [SMALL_STATE(5769)] = 213203,
  [SMALL_STATE(5770)] = 213251,
  [SMALL_STATE(5771)] = 213299,
  [SMALL_STATE(5772)] = 213347,
  [SMALL_STATE(5773)] = 213395,
  [SMALL_STATE(5774)] = 213443,
  [SMALL_STATE(5775)] = 213491,
  [SMALL_STATE(5776)] = 213539,
  [SMALL_STATE(5777)] = 213587,
  [SMALL_STATE(5778)] = 213635,
  [SMALL_STATE(5779)] = 213683,
  [SMALL_STATE(5780)] = 213731,
  [SMALL_STATE(5781)] = 213779,
  [SMALL_STATE(5782)] = 213827,
  [SMALL_STATE(5783)] = 213875,
  [SMALL_STATE(5784)] = 213923,
  [SMALL_STATE(5785)] = 213971,
  [SMALL_STATE(5786)] = 214019,
  [SMALL_STATE(5787)] = 214069,
  [SMALL_STATE(5788)] = 214119,
  [SMALL_STATE(5789)] = 214167,
  [SMALL_STATE(5790)] = 214217,
  [SMALL_STATE(5791)] = 214265,
  [SMALL_STATE(5792)] = 214313,
  [SMALL_STATE(5793)] = 214363,
  [SMALL_STATE(5794)] = 214413,
  [SMALL_STATE(5795)] = 214463,
  [SMALL_STATE(5796)] = 214511,
  [SMALL_STATE(5797)] = 214559,
  [SMALL_STATE(5798)] = 214607,
  [SMALL_STATE(5799)] = 214655,
  [SMALL_STATE(5800)] = 214703,
  [SMALL_STATE(5801)] = 214751,
  [SMALL_STATE(5802)] = 214799,
  [SMALL_STATE(5803)] = 214847,
  [SMALL_STATE(5804)] = 214895,
  [SMALL_STATE(5805)] = 214943,
  [SMALL_STATE(5806)] = 214991,
  [SMALL_STATE(5807)] = 215039,
  [SMALL_STATE(5808)] = 215087,
  [SMALL_STATE(5809)] = 215135,
  [SMALL_STATE(5810)] = 215183,
  [SMALL_STATE(5811)] = 215231,
  [SMALL_STATE(5812)] = 215281,
  [SMALL_STATE(5813)] = 215329,
  [SMALL_STATE(5814)] = 215377,
  [SMALL_STATE(5815)] = 215425,
  [SMALL_STATE(5816)] = 215473,
  [SMALL_STATE(5817)] = 215521,
  [SMALL_STATE(5818)] = 215569,
  [SMALL_STATE(5819)] = 215617,
  [SMALL_STATE(5820)] = 215665,
  [SMALL_STATE(5821)] = 215713,
  [SMALL_STATE(5822)] = 215761,
  [SMALL_STATE(5823)] = 215809,
  [SMALL_STATE(5824)] = 215857,
  [SMALL_STATE(5825)] = 215905,
  [SMALL_STATE(5826)] = 215953,
  [SMALL_STATE(5827)] = 216001,
  [SMALL_STATE(5828)] = 216049,
  [SMALL_STATE(5829)] = 216097,
  [SMALL_STATE(5830)] = 216145,
  [SMALL_STATE(5831)] = 216193,
  [SMALL_STATE(5832)] = 216241,
  [SMALL_STATE(5833)] = 216289,
  [SMALL_STATE(5834)] = 216337,
  [SMALL_STATE(5835)] = 216385,
  [SMALL_STATE(5836)] = 216433,
  [SMALL_STATE(5837)] = 216481,
  [SMALL_STATE(5838)] = 216529,
  [SMALL_STATE(5839)] = 216577,
  [SMALL_STATE(5840)] = 216625,
  [SMALL_STATE(5841)] = 216673,
  [SMALL_STATE(5842)] = 216721,
  [SMALL_STATE(5843)] = 216769,
  [SMALL_STATE(5844)] = 216817,
  [SMALL_STATE(5845)] = 216865,
  [SMALL_STATE(5846)] = 216913,
  [SMALL_STATE(5847)] = 216961,
  [SMALL_STATE(5848)] = 217009,
  [SMALL_STATE(5849)] = 217057,
  [SMALL_STATE(5850)] = 217105,
  [SMALL_STATE(5851)] = 217153,
  [SMALL_STATE(5852)] = 217201,
  [SMALL_STATE(5853)] = 217249,
  [SMALL_STATE(5854)] = 217297,
  [SMALL_STATE(5855)] = 217345,
  [SMALL_STATE(5856)] = 217395,
  [SMALL_STATE(5857)] = 217461,
  [SMALL_STATE(5858)] = 217509,
  [SMALL_STATE(5859)] = 217557,
  [SMALL_STATE(5860)] = 217605,
  [SMALL_STATE(5861)] = 217655,
  [SMALL_STATE(5862)] = 217703,
  [SMALL_STATE(5863)] = 217753,
  [SMALL_STATE(5864)] = 217801,
  [SMALL_STATE(5865)] = 217849,
  [SMALL_STATE(5866)] = 217899,
  [SMALL_STATE(5867)] = 217949,
  [SMALL_STATE(5868)] = 217999,
  [SMALL_STATE(5869)] = 218049,
  [SMALL_STATE(5870)] = 218097,
  [SMALL_STATE(5871)] = 218145,
  [SMALL_STATE(5872)] = 218193,
  [SMALL_STATE(5873)] = 218241,
  [SMALL_STATE(5874)] = 218289,
  [SMALL_STATE(5875)] = 218337,
  [SMALL_STATE(5876)] = 218385,
  [SMALL_STATE(5877)] = 218435,
  [SMALL_STATE(5878)] = 218485,
  [SMALL_STATE(5879)] = 218533,
  [SMALL_STATE(5880)] = 218581,
  [SMALL_STATE(5881)] = 218631,
  [SMALL_STATE(5882)] = 218679,
  [SMALL_STATE(5883)] = 218727,
  [SMALL_STATE(5884)] = 218775,
  [SMALL_STATE(5885)] = 218823,
  [SMALL_STATE(5886)] = 218871,
  [SMALL_STATE(5887)] = 218919,
  [SMALL_STATE(5888)] = 218967,
  [SMALL_STATE(5889)] = 219015,
  [SMALL_STATE(5890)] = 219063,
  [SMALL_STATE(5891)] = 219111,
  [SMALL_STATE(5892)] = 219159,
  [SMALL_STATE(5893)] = 219207,
  [SMALL_STATE(5894)] = 219255,
  [SMALL_STATE(5895)] = 219303,
  [SMALL_STATE(5896)] = 219351,
  [SMALL_STATE(5897)] = 219399,
  [SMALL_STATE(5898)] = 219449,
  [SMALL_STATE(5899)] = 219499,
  [SMALL_STATE(5900)] = 219547,
  [SMALL_STATE(5901)] = 219597,
  [SMALL_STATE(5902)] = 219647,
  [SMALL_STATE(5903)] = 219695,
  [SMALL_STATE(5904)] = 219743,
  [SMALL_STATE(5905)] = 219793,
  [SMALL_STATE(5906)] = 219841,
  [SMALL_STATE(5907)] = 219889,
  [SMALL_STATE(5908)] = 219937,
  [SMALL_STATE(5909)] = 219985,
  [SMALL_STATE(5910)] = 220033,
  [SMALL_STATE(5911)] = 220083,
  [SMALL_STATE(5912)] = 220131,
  [SMALL_STATE(5913)] = 220179,
  [SMALL_STATE(5914)] = 220229,
  [SMALL_STATE(5915)] = 220277,
  [SMALL_STATE(5916)] = 220325,
  [SMALL_STATE(5917)] = 220373,
  [SMALL_STATE(5918)] = 220421,
  [SMALL_STATE(5919)] = 220469,
  [SMALL_STATE(5920)] = 220517,
  [SMALL_STATE(5921)] = 220565,
  [SMALL_STATE(5922)] = 220613,
  [SMALL_STATE(5923)] = 220661,
  [SMALL_STATE(5924)] = 220709,
  [SMALL_STATE(5925)] = 220757,
  [SMALL_STATE(5926)] = 220805,
  [SMALL_STATE(5927)] = 220853,
  [SMALL_STATE(5928)] = 220901,
  [SMALL_STATE(5929)] = 220949,
  [SMALL_STATE(5930)] = 220997,
  [SMALL_STATE(5931)] = 221045,
  [SMALL_STATE(5932)] = 221095,
  [SMALL_STATE(5933)] = 221145,
  [SMALL_STATE(5934)] = 221195,
  [SMALL_STATE(5935)] = 221243,
  [SMALL_STATE(5936)] = 221291,
  [SMALL_STATE(5937)] = 221339,
  [SMALL_STATE(5938)] = 221389,
  [SMALL_STATE(5939)] = 221439,
  [SMALL_STATE(5940)] = 221487,
  [SMALL_STATE(5941)] = 221537,
  [SMALL_STATE(5942)] = 221587,
  [SMALL_STATE(5943)] = 221635,
  [SMALL_STATE(5944)] = 221683,
  [SMALL_STATE(5945)] = 221733,
  [SMALL_STATE(5946)] = 221781,
  [SMALL_STATE(5947)] = 221829,
  [SMALL_STATE(5948)] = 221879,
  [SMALL_STATE(5949)] = 221926,
  [SMALL_STATE(5950)] = 221973,
  [SMALL_STATE(5951)] = 222020,
  [SMALL_STATE(5952)] = 222067,
  [SMALL_STATE(5953)] = 222114,
  [SMALL_STATE(5954)] = 222161,
  [SMALL_STATE(5955)] = 222208,
  [SMALL_STATE(5956)] = 222255,
  [SMALL_STATE(5957)] = 222302,
  [SMALL_STATE(5958)] = 222349,
  [SMALL_STATE(5959)] = 222396,
  [SMALL_STATE(5960)] = 222443,
  [SMALL_STATE(5961)] = 222490,
  [SMALL_STATE(5962)] = 222539,
  [SMALL_STATE(5963)] = 222588,
  [SMALL_STATE(5964)] = 222637,
  [SMALL_STATE(5965)] = 222684,
  [SMALL_STATE(5966)] = 222733,
  [SMALL_STATE(5967)] = 222780,
  [SMALL_STATE(5968)] = 222827,
  [SMALL_STATE(5969)] = 222876,
  [SMALL_STATE(5970)] = 222925,
  [SMALL_STATE(5971)] = 222972,
  [SMALL_STATE(5972)] = 223019,
  [SMALL_STATE(5973)] = 223066,
  [SMALL_STATE(5974)] = 223113,
  [SMALL_STATE(5975)] = 223160,
  [SMALL_STATE(5976)] = 223207,
  [SMALL_STATE(5977)] = 223254,
  [SMALL_STATE(5978)] = 223313,
  [SMALL_STATE(5979)] = 223360,
  [SMALL_STATE(5980)] = 223407,
  [SMALL_STATE(5981)] = 223454,
  [SMALL_STATE(5982)] = 223501,
  [SMALL_STATE(5983)] = 223548,
  [SMALL_STATE(5984)] = 223595,
  [SMALL_STATE(5985)] = 223642,
  [SMALL_STATE(5986)] = 223689,
  [SMALL_STATE(5987)] = 223736,
  [SMALL_STATE(5988)] = 223783,
  [SMALL_STATE(5989)] = 223830,
  [SMALL_STATE(5990)] = 223879,
  [SMALL_STATE(5991)] = 223926,
  [SMALL_STATE(5992)] = 223973,
  [SMALL_STATE(5993)] = 224020,
  [SMALL_STATE(5994)] = 224067,
  [SMALL_STATE(5995)] = 224114,
  [SMALL_STATE(5996)] = 224163,
  [SMALL_STATE(5997)] = 224210,
  [SMALL_STATE(5998)] = 224257,
  [SMALL_STATE(5999)] = 224304,
  [SMALL_STATE(6000)] = 224351,
  [SMALL_STATE(6001)] = 224398,
  [SMALL_STATE(6002)] = 224447,
  [SMALL_STATE(6003)] = 224494,
  [SMALL_STATE(6004)] = 224541,
  [SMALL_STATE(6005)] = 224588,
  [SMALL_STATE(6006)] = 224637,
  [SMALL_STATE(6007)] = 224684,
  [SMALL_STATE(6008)] = 224731,
  [SMALL_STATE(6009)] = 224780,
  [SMALL_STATE(6010)] = 224827,
  [SMALL_STATE(6011)] = 224874,
  [SMALL_STATE(6012)] = 224921,
  [SMALL_STATE(6013)] = 224982,
  [SMALL_STATE(6014)] = 225029,
  [SMALL_STATE(6015)] = 225076,
  [SMALL_STATE(6016)] = 225125,
  [SMALL_STATE(6017)] = 225172,
  [SMALL_STATE(6018)] = 225221,
  [SMALL_STATE(6019)] = 225270,
  [SMALL_STATE(6020)] = 225319,
  [SMALL_STATE(6021)] = 225366,
  [SMALL_STATE(6022)] = 225413,
  [SMALL_STATE(6023)] = 225460,
  [SMALL_STATE(6024)] = 225507,
  [SMALL_STATE(6025)] = 225554,
  [SMALL_STATE(6026)] = 225603,
  [SMALL_STATE(6027)] = 225650,
  [SMALL_STATE(6028)] = 225697,
  [SMALL_STATE(6029)] = 225746,
  [SMALL_STATE(6030)] = 225793,
  [SMALL_STATE(6031)] = 225840,
  [SMALL_STATE(6032)] = 225887,
  [SMALL_STATE(6033)] = 225934,
  [SMALL_STATE(6034)] = 225983,
  [SMALL_STATE(6035)] = 226030,
  [SMALL_STATE(6036)] = 226077,
  [SMALL_STATE(6037)] = 226124,
  [SMALL_STATE(6038)] = 226173,
  [SMALL_STATE(6039)] = 226220,
  [SMALL_STATE(6040)] = 226267,
  [SMALL_STATE(6041)] = 226314,
  [SMALL_STATE(6042)] = 226361,
  [SMALL_STATE(6043)] = 226408,
  [SMALL_STATE(6044)] = 226455,
  [SMALL_STATE(6045)] = 226516,
  [SMALL_STATE(6046)] = 226563,
  [SMALL_STATE(6047)] = 226610,
  [SMALL_STATE(6048)] = 226659,
  [SMALL_STATE(6049)] = 226706,
  [SMALL_STATE(6050)] = 226753,
  [SMALL_STATE(6051)] = 226800,
  [SMALL_STATE(6052)] = 226847,
  [SMALL_STATE(6053)] = 226894,
  [SMALL_STATE(6054)] = 226941,
  [SMALL_STATE(6055)] = 226988,
  [SMALL_STATE(6056)] = 227035,
  [SMALL_STATE(6057)] = 227084,
  [SMALL_STATE(6058)] = 227131,
  [SMALL_STATE(6059)] = 227178,
  [SMALL_STATE(6060)] = 227225,
  [SMALL_STATE(6061)] = 227272,
  [SMALL_STATE(6062)] = 227321,
  [SMALL_STATE(6063)] = 227368,
  [SMALL_STATE(6064)] = 227415,
  [SMALL_STATE(6065)] = 227462,
  [SMALL_STATE(6066)] = 227509,
  [SMALL_STATE(6067)] = 227556,
  [SMALL_STATE(6068)] = 227603,
  [SMALL_STATE(6069)] = 227650,
  [SMALL_STATE(6070)] = 227697,
  [SMALL_STATE(6071)] = 227744,
  [SMALL_STATE(6072)] = 227793,
  [SMALL_STATE(6073)] = 227840,
  [SMALL_STATE(6074)] = 227889,
  [SMALL_STATE(6075)] = 227936,
  [SMALL_STATE(6076)] = 227983,
  [SMALL_STATE(6077)] = 228030,
  [SMALL_STATE(6078)] = 228079,
  [SMALL_STATE(6079)] = 228126,
  [SMALL_STATE(6080)] = 228173,
  [SMALL_STATE(6081)] = 228220,
  [SMALL_STATE(6082)] = 228267,
  [SMALL_STATE(6083)] = 228314,
  [SMALL_STATE(6084)] = 228361,
  [SMALL_STATE(6085)] = 228408,
  [SMALL_STATE(6086)] = 228455,
  [SMALL_STATE(6087)] = 228502,
  [SMALL_STATE(6088)] = 228549,
  [SMALL_STATE(6089)] = 228596,
  [SMALL_STATE(6090)] = 228643,
  [SMALL_STATE(6091)] = 228690,
  [SMALL_STATE(6092)] = 228737,
  [SMALL_STATE(6093)] = 228784,
  [SMALL_STATE(6094)] = 228831,
  [SMALL_STATE(6095)] = 228878,
  [SMALL_STATE(6096)] = 228925,
  [SMALL_STATE(6097)] = 228972,
  [SMALL_STATE(6098)] = 229019,
  [SMALL_STATE(6099)] = 229066,
  [SMALL_STATE(6100)] = 229113,
  [SMALL_STATE(6101)] = 229160,
  [SMALL_STATE(6102)] = 229207,
  [SMALL_STATE(6103)] = 229254,
  [SMALL_STATE(6104)] = 229301,
  [SMALL_STATE(6105)] = 229350,
  [SMALL_STATE(6106)] = 229399,
  [SMALL_STATE(6107)] = 229446,
  [SMALL_STATE(6108)] = 229493,
  [SMALL_STATE(6109)] = 229540,
  [SMALL_STATE(6110)] = 229587,
  [SMALL_STATE(6111)] = 229634,
  [SMALL_STATE(6112)] = 229681,
  [SMALL_STATE(6113)] = 229728,
  [SMALL_STATE(6114)] = 229775,
  [SMALL_STATE(6115)] = 229822,
  [SMALL_STATE(6116)] = 229869,
  [SMALL_STATE(6117)] = 229916,
  [SMALL_STATE(6118)] = 229963,
  [SMALL_STATE(6119)] = 230012,
  [SMALL_STATE(6120)] = 230059,
  [SMALL_STATE(6121)] = 230106,
  [SMALL_STATE(6122)] = 230155,
  [SMALL_STATE(6123)] = 230202,
  [SMALL_STATE(6124)] = 230249,
  [SMALL_STATE(6125)] = 230296,
  [SMALL_STATE(6126)] = 230343,
  [SMALL_STATE(6127)] = 230390,
  [SMALL_STATE(6128)] = 230439,
  [SMALL_STATE(6129)] = 230488,
  [SMALL_STATE(6130)] = 230535,
  [SMALL_STATE(6131)] = 230582,
  [SMALL_STATE(6132)] = 230629,
  [SMALL_STATE(6133)] = 230676,
  [SMALL_STATE(6134)] = 230723,
  [SMALL_STATE(6135)] = 230770,
  [SMALL_STATE(6136)] = 230817,
  [SMALL_STATE(6137)] = 230864,
  [SMALL_STATE(6138)] = 230911,
  [SMALL_STATE(6139)] = 230960,
  [SMALL_STATE(6140)] = 231007,
  [SMALL_STATE(6141)] = 231054,
  [SMALL_STATE(6142)] = 231101,
  [SMALL_STATE(6143)] = 231150,
  [SMALL_STATE(6144)] = 231197,
  [SMALL_STATE(6145)] = 231244,
  [SMALL_STATE(6146)] = 231291,
  [SMALL_STATE(6147)] = 231338,
  [SMALL_STATE(6148)] = 231387,
  [SMALL_STATE(6149)] = 231434,
  [SMALL_STATE(6150)] = 231483,
  [SMALL_STATE(6151)] = 231532,
  [SMALL_STATE(6152)] = 231579,
  [SMALL_STATE(6153)] = 231626,
  [SMALL_STATE(6154)] = 231673,
  [SMALL_STATE(6155)] = 231720,
  [SMALL_STATE(6156)] = 231767,
  [SMALL_STATE(6157)] = 231814,
  [SMALL_STATE(6158)] = 231863,
  [SMALL_STATE(6159)] = 231910,
  [SMALL_STATE(6160)] = 231957,
  [SMALL_STATE(6161)] = 232004,
  [SMALL_STATE(6162)] = 232051,
  [SMALL_STATE(6163)] = 232098,
  [SMALL_STATE(6164)] = 232145,
  [SMALL_STATE(6165)] = 232192,
  [SMALL_STATE(6166)] = 232239,
  [SMALL_STATE(6167)] = 232286,
  [SMALL_STATE(6168)] = 232333,
  [SMALL_STATE(6169)] = 232382,
  [SMALL_STATE(6170)] = 232429,
  [SMALL_STATE(6171)] = 232476,
  [SMALL_STATE(6172)] = 232523,
  [SMALL_STATE(6173)] = 232570,
  [SMALL_STATE(6174)] = 232617,
  [SMALL_STATE(6175)] = 232664,
  [SMALL_STATE(6176)] = 232713,
  [SMALL_STATE(6177)] = 232760,
  [SMALL_STATE(6178)] = 232807,
  [SMALL_STATE(6179)] = 232856,
  [SMALL_STATE(6180)] = 232903,
  [SMALL_STATE(6181)] = 232950,
  [SMALL_STATE(6182)] = 232999,
  [SMALL_STATE(6183)] = 233048,
  [SMALL_STATE(6184)] = 233095,
  [SMALL_STATE(6185)] = 233144,
  [SMALL_STATE(6186)] = 233191,
  [SMALL_STATE(6187)] = 233238,
  [SMALL_STATE(6188)] = 233285,
  [SMALL_STATE(6189)] = 233332,
  [SMALL_STATE(6190)] = 233379,
  [SMALL_STATE(6191)] = 233426,
  [SMALL_STATE(6192)] = 233473,
  [SMALL_STATE(6193)] = 233520,
  [SMALL_STATE(6194)] = 233567,
  [SMALL_STATE(6195)] = 233614,
  [SMALL_STATE(6196)] = 233661,
  [SMALL_STATE(6197)] = 233708,
  [SMALL_STATE(6198)] = 233755,
  [SMALL_STATE(6199)] = 233802,
  [SMALL_STATE(6200)] = 233849,
  [SMALL_STATE(6201)] = 233896,
  [SMALL_STATE(6202)] = 233943,
  [SMALL_STATE(6203)] = 233990,
  [SMALL_STATE(6204)] = 234037,
  [SMALL_STATE(6205)] = 234084,
  [SMALL_STATE(6206)] = 234131,
  [SMALL_STATE(6207)] = 234178,
  [SMALL_STATE(6208)] = 234225,
  [SMALL_STATE(6209)] = 234272,
  [SMALL_STATE(6210)] = 234319,
  [SMALL_STATE(6211)] = 234368,
  [SMALL_STATE(6212)] = 234415,
  [SMALL_STATE(6213)] = 234462,
  [SMALL_STATE(6214)] = 234509,
  [SMALL_STATE(6215)] = 234558,
  [SMALL_STATE(6216)] = 234605,
  [SMALL_STATE(6217)] = 234652,
  [SMALL_STATE(6218)] = 234699,
  [SMALL_STATE(6219)] = 234746,
  [SMALL_STATE(6220)] = 234795,
  [SMALL_STATE(6221)] = 234844,
  [SMALL_STATE(6222)] = 234893,
  [SMALL_STATE(6223)] = 234942,
  [SMALL_STATE(6224)] = 234989,
  [SMALL_STATE(6225)] = 235038,
  [SMALL_STATE(6226)] = 235085,
  [SMALL_STATE(6227)] = 235134,
  [SMALL_STATE(6228)] = 235193,
  [SMALL_STATE(6229)] = 235240,
  [SMALL_STATE(6230)] = 235287,
  [SMALL_STATE(6231)] = 235334,
  [SMALL_STATE(6232)] = 235381,
  [SMALL_STATE(6233)] = 235427,
  [SMALL_STATE(6234)] = 235473,
  [SMALL_STATE(6235)] = 235519,
  [SMALL_STATE(6236)] = 235565,
  [SMALL_STATE(6237)] = 235611,
  [SMALL_STATE(6238)] = 235657,
  [SMALL_STATE(6239)] = 235705,
  [SMALL_STATE(6240)] = 235751,
  [SMALL_STATE(6241)] = 235797,
  [SMALL_STATE(6242)] = 235843,
  [SMALL_STATE(6243)] = 235889,
  [SMALL_STATE(6244)] = 235935,
  [SMALL_STATE(6245)] = 235981,
  [SMALL_STATE(6246)] = 236027,
  [SMALL_STATE(6247)] = 236073,
  [SMALL_STATE(6248)] = 236119,
  [SMALL_STATE(6249)] = 236165,
  [SMALL_STATE(6250)] = 236211,
  [SMALL_STATE(6251)] = 236259,
  [SMALL_STATE(6252)] = 236305,
  [SMALL_STATE(6253)] = 236351,
  [SMALL_STATE(6254)] = 236399,
  [SMALL_STATE(6255)] = 236445,
  [SMALL_STATE(6256)] = 236491,
  [SMALL_STATE(6257)] = 236537,
  [SMALL_STATE(6258)] = 236583,
  [SMALL_STATE(6259)] = 236629,
  [SMALL_STATE(6260)] = 236675,
  [SMALL_STATE(6261)] = 236721,
  [SMALL_STATE(6262)] = 236767,
  [SMALL_STATE(6263)] = 236813,
  [SMALL_STATE(6264)] = 236859,
  [SMALL_STATE(6265)] = 236905,
  [SMALL_STATE(6266)] = 236951,
  [SMALL_STATE(6267)] = 236997,
  [SMALL_STATE(6268)] = 237043,
  [SMALL_STATE(6269)] = 237091,
  [SMALL_STATE(6270)] = 237137,
  [SMALL_STATE(6271)] = 237183,
  [SMALL_STATE(6272)] = 237229,
  [SMALL_STATE(6273)] = 237275,
  [SMALL_STATE(6274)] = 237321,
  [SMALL_STATE(6275)] = 237385,
  [SMALL_STATE(6276)] = 237431,
  [SMALL_STATE(6277)] = 237479,
  [SMALL_STATE(6278)] = 237525,
  [SMALL_STATE(6279)] = 237571,
  [SMALL_STATE(6280)] = 237617,
  [SMALL_STATE(6281)] = 237663,
  [SMALL_STATE(6282)] = 237709,
  [SMALL_STATE(6283)] = 237755,
  [SMALL_STATE(6284)] = 237801,
  [SMALL_STATE(6285)] = 237847,
  [SMALL_STATE(6286)] = 237893,
  [SMALL_STATE(6287)] = 237939,
  [SMALL_STATE(6288)] = 237985,
  [SMALL_STATE(6289)] = 238031,
  [SMALL_STATE(6290)] = 238077,
  [SMALL_STATE(6291)] = 238123,
  [SMALL_STATE(6292)] = 238169,
  [SMALL_STATE(6293)] = 238215,
  [SMALL_STATE(6294)] = 238261,
  [SMALL_STATE(6295)] = 238307,
  [SMALL_STATE(6296)] = 238353,
  [SMALL_STATE(6297)] = 238399,
  [SMALL_STATE(6298)] = 238445,
  [SMALL_STATE(6299)] = 238491,
  [SMALL_STATE(6300)] = 238539,
  [SMALL_STATE(6301)] = 238585,
  [SMALL_STATE(6302)] = 238631,
  [SMALL_STATE(6303)] = 238677,
  [SMALL_STATE(6304)] = 238725,
  [SMALL_STATE(6305)] = 238771,
  [SMALL_STATE(6306)] = 238817,
  [SMALL_STATE(6307)] = 238863,
  [SMALL_STATE(6308)] = 238911,
  [SMALL_STATE(6309)] = 238957,
  [SMALL_STATE(6310)] = 239003,
  [SMALL_STATE(6311)] = 239049,
  [SMALL_STATE(6312)] = 239095,
  [SMALL_STATE(6313)] = 239141,
  [SMALL_STATE(6314)] = 239187,
  [SMALL_STATE(6315)] = 239233,
  [SMALL_STATE(6316)] = 239279,
  [SMALL_STATE(6317)] = 239325,
  [SMALL_STATE(6318)] = 239383,
  [SMALL_STATE(6319)] = 239429,
  [SMALL_STATE(6320)] = 239475,
  [SMALL_STATE(6321)] = 239521,
  [SMALL_STATE(6322)] = 239569,
  [SMALL_STATE(6323)] = 239617,
  [SMALL_STATE(6324)] = 239663,
  [SMALL_STATE(6325)] = 239709,
  [SMALL_STATE(6326)] = 239755,
  [SMALL_STATE(6327)] = 239801,
  [SMALL_STATE(6328)] = 239847,
  [SMALL_STATE(6329)] = 239895,
  [SMALL_STATE(6330)] = 239943,
  [SMALL_STATE(6331)] = 239989,
  [SMALL_STATE(6332)] = 240037,
  [SMALL_STATE(6333)] = 240083,
  [SMALL_STATE(6334)] = 240129,
  [SMALL_STATE(6335)] = 240175,
  [SMALL_STATE(6336)] = 240221,
  [SMALL_STATE(6337)] = 240267,
  [SMALL_STATE(6338)] = 240313,
  [SMALL_STATE(6339)] = 240359,
  [SMALL_STATE(6340)] = 240405,
  [SMALL_STATE(6341)] = 240451,
  [SMALL_STATE(6342)] = 240497,
  [SMALL_STATE(6343)] = 240543,
  [SMALL_STATE(6344)] = 240589,
  [SMALL_STATE(6345)] = 240635,
  [SMALL_STATE(6346)] = 240681,
  [SMALL_STATE(6347)] = 240727,
  [SMALL_STATE(6348)] = 240773,
  [SMALL_STATE(6349)] = 240819,
  [SMALL_STATE(6350)] = 240865,
  [SMALL_STATE(6351)] = 240911,
  [SMALL_STATE(6352)] = 240957,
  [SMALL_STATE(6353)] = 241005,
  [SMALL_STATE(6354)] = 241051,
  [SMALL_STATE(6355)] = 241097,
  [SMALL_STATE(6356)] = 241143,
  [SMALL_STATE(6357)] = 241189,
  [SMALL_STATE(6358)] = 241235,
  [SMALL_STATE(6359)] = 241281,
  [SMALL_STATE(6360)] = 241327,
  [SMALL_STATE(6361)] = 241373,
  [SMALL_STATE(6362)] = 241419,
  [SMALL_STATE(6363)] = 241467,
  [SMALL_STATE(6364)] = 241515,
  [SMALL_STATE(6365)] = 241561,
  [SMALL_STATE(6366)] = 241607,
  [SMALL_STATE(6367)] = 241655,
  [SMALL_STATE(6368)] = 241701,
  [SMALL_STATE(6369)] = 241747,
  [SMALL_STATE(6370)] = 241793,
  [SMALL_STATE(6371)] = 241839,
  [SMALL_STATE(6372)] = 241885,
  [SMALL_STATE(6373)] = 241931,
  [SMALL_STATE(6374)] = 241977,
  [SMALL_STATE(6375)] = 242023,
  [SMALL_STATE(6376)] = 242069,
  [SMALL_STATE(6377)] = 242115,
  [SMALL_STATE(6378)] = 242161,
  [SMALL_STATE(6379)] = 242217,
  [SMALL_STATE(6380)] = 242263,
  [SMALL_STATE(6381)] = 242309,
  [SMALL_STATE(6382)] = 242355,
  [SMALL_STATE(6383)] = 242401,
  [SMALL_STATE(6384)] = 242447,
  [SMALL_STATE(6385)] = 242493,
  [SMALL_STATE(6386)] = 242539,
  [SMALL_STATE(6387)] = 242585,
  [SMALL_STATE(6388)] = 242631,
  [SMALL_STATE(6389)] = 242677,
  [SMALL_STATE(6390)] = 242723,
  [SMALL_STATE(6391)] = 242769,
  [SMALL_STATE(6392)] = 242815,
  [SMALL_STATE(6393)] = 242861,
  [SMALL_STATE(6394)] = 242909,
  [SMALL_STATE(6395)] = 242955,
  [SMALL_STATE(6396)] = 243001,
  [SMALL_STATE(6397)] = 243047,
  [SMALL_STATE(6398)] = 243093,
  [SMALL_STATE(6399)] = 243141,
  [SMALL_STATE(6400)] = 243187,
  [SMALL_STATE(6401)] = 243233,
  [SMALL_STATE(6402)] = 243279,
  [SMALL_STATE(6403)] = 243325,
  [SMALL_STATE(6404)] = 243373,
  [SMALL_STATE(6405)] = 243419,
  [SMALL_STATE(6406)] = 243465,
  [SMALL_STATE(6407)] = 243511,
  [SMALL_STATE(6408)] = 243557,
  [SMALL_STATE(6409)] = 243603,
  [SMALL_STATE(6410)] = 243649,
  [SMALL_STATE(6411)] = 243695,
  [SMALL_STATE(6412)] = 243741,
  [SMALL_STATE(6413)] = 243787,
  [SMALL_STATE(6414)] = 243833,
  [SMALL_STATE(6415)] = 243881,
  [SMALL_STATE(6416)] = 243927,
  [SMALL_STATE(6417)] = 243973,
  [SMALL_STATE(6418)] = 244029,
  [SMALL_STATE(6419)] = 244075,
  [SMALL_STATE(6420)] = 244123,
  [SMALL_STATE(6421)] = 244169,
  [SMALL_STATE(6422)] = 244215,
  [SMALL_STATE(6423)] = 244261,
  [SMALL_STATE(6424)] = 244307,
  [SMALL_STATE(6425)] = 244353,
  [SMALL_STATE(6426)] = 244399,
  [SMALL_STATE(6427)] = 244445,
  [SMALL_STATE(6428)] = 244491,
  [SMALL_STATE(6429)] = 244537,
  [SMALL_STATE(6430)] = 244583,
  [SMALL_STATE(6431)] = 244629,
  [SMALL_STATE(6432)] = 244675,
  [SMALL_STATE(6433)] = 244721,
  [SMALL_STATE(6434)] = 244767,
  [SMALL_STATE(6435)] = 244813,
  [SMALL_STATE(6436)] = 244859,
  [SMALL_STATE(6437)] = 244905,
  [SMALL_STATE(6438)] = 244951,
  [SMALL_STATE(6439)] = 244997,
  [SMALL_STATE(6440)] = 245043,
  [SMALL_STATE(6441)] = 245091,
  [SMALL_STATE(6442)] = 245137,
  [SMALL_STATE(6443)] = 245183,
  [SMALL_STATE(6444)] = 245229,
  [SMALL_STATE(6445)] = 245275,
  [SMALL_STATE(6446)] = 245321,
  [SMALL_STATE(6447)] = 245367,
  [SMALL_STATE(6448)] = 245413,
  [SMALL_STATE(6449)] = 245459,
  [SMALL_STATE(6450)] = 245505,
  [SMALL_STATE(6451)] = 245551,
  [SMALL_STATE(6452)] = 245597,
  [SMALL_STATE(6453)] = 245643,
  [SMALL_STATE(6454)] = 245689,
  [SMALL_STATE(6455)] = 245735,
  [SMALL_STATE(6456)] = 245781,
  [SMALL_STATE(6457)] = 245827,
  [SMALL_STATE(6458)] = 245873,
  [SMALL_STATE(6459)] = 245919,
  [SMALL_STATE(6460)] = 245965,
  [SMALL_STATE(6461)] = 246011,
  [SMALL_STATE(6462)] = 246057,
  [SMALL_STATE(6463)] = 246103,
  [SMALL_STATE(6464)] = 246149,
  [SMALL_STATE(6465)] = 246195,
  [SMALL_STATE(6466)] = 246241,
  [SMALL_STATE(6467)] = 246287,
  [SMALL_STATE(6468)] = 246333,
  [SMALL_STATE(6469)] = 246379,
  [SMALL_STATE(6470)] = 246425,
  [SMALL_STATE(6471)] = 246471,
  [SMALL_STATE(6472)] = 246517,
  [SMALL_STATE(6473)] = 246563,
  [SMALL_STATE(6474)] = 246609,
  [SMALL_STATE(6475)] = 246655,
  [SMALL_STATE(6476)] = 246701,
  [SMALL_STATE(6477)] = 246749,
  [SMALL_STATE(6478)] = 246795,
  [SMALL_STATE(6479)] = 246843,
  [SMALL_STATE(6480)] = 246889,
  [SMALL_STATE(6481)] = 246937,
  [SMALL_STATE(6482)] = 246983,
  [SMALL_STATE(6483)] = 247029,
  [SMALL_STATE(6484)] = 247075,
  [SMALL_STATE(6485)] = 247121,
  [SMALL_STATE(6486)] = 247167,
  [SMALL_STATE(6487)] = 247213,
  [SMALL_STATE(6488)] = 247259,
  [SMALL_STATE(6489)] = 247305,
  [SMALL_STATE(6490)] = 247351,
  [SMALL_STATE(6491)] = 247397,
  [SMALL_STATE(6492)] = 247443,
  [SMALL_STATE(6493)] = 247489,
  [SMALL_STATE(6494)] = 247535,
  [SMALL_STATE(6495)] = 247581,
  [SMALL_STATE(6496)] = 247627,
  [SMALL_STATE(6497)] = 247673,
  [SMALL_STATE(6498)] = 247719,
  [SMALL_STATE(6499)] = 247765,
  [SMALL_STATE(6500)] = 247811,
  [SMALL_STATE(6501)] = 247857,
  [SMALL_STATE(6502)] = 247903,
  [SMALL_STATE(6503)] = 247949,
  [SMALL_STATE(6504)] = 247997,
  [SMALL_STATE(6505)] = 248043,
  [SMALL_STATE(6506)] = 248089,
  [SMALL_STATE(6507)] = 248135,
  [SMALL_STATE(6508)] = 248181,
  [SMALL_STATE(6509)] = 248227,
  [SMALL_STATE(6510)] = 248273,
  [SMALL_STATE(6511)] = 248319,
  [SMALL_STATE(6512)] = 248365,
  [SMALL_STATE(6513)] = 248411,
  [SMALL_STATE(6514)] = 248457,
  [SMALL_STATE(6515)] = 248503,
  [SMALL_STATE(6516)] = 248549,
  [SMALL_STATE(6517)] = 248595,
  [SMALL_STATE(6518)] = 248641,
  [SMALL_STATE(6519)] = 248687,
  [SMALL_STATE(6520)] = 248733,
  [SMALL_STATE(6521)] = 248779,
  [SMALL_STATE(6522)] = 248825,
  [SMALL_STATE(6523)] = 248871,
  [SMALL_STATE(6524)] = 248917,
  [SMALL_STATE(6525)] = 248963,
  [SMALL_STATE(6526)] = 249009,
  [SMALL_STATE(6527)] = 249055,
  [SMALL_STATE(6528)] = 249103,
  [SMALL_STATE(6529)] = 249149,
  [SMALL_STATE(6530)] = 249195,
  [SMALL_STATE(6531)] = 249243,
  [SMALL_STATE(6532)] = 249289,
  [SMALL_STATE(6533)] = 249335,
  [SMALL_STATE(6534)] = 249381,
  [SMALL_STATE(6535)] = 249427,
  [SMALL_STATE(6536)] = 249473,
  [SMALL_STATE(6537)] = 249519,
  [SMALL_STATE(6538)] = 249567,
  [SMALL_STATE(6539)] = 249613,
  [SMALL_STATE(6540)] = 249659,
  [SMALL_STATE(6541)] = 249705,
  [SMALL_STATE(6542)] = 249751,
  [SMALL_STATE(6543)] = 249799,
  [SMALL_STATE(6544)] = 249845,
  [SMALL_STATE(6545)] = 249891,
  [SMALL_STATE(6546)] = 249937,
  [SMALL_STATE(6547)] = 249983,
  [SMALL_STATE(6548)] = 250029,
  [SMALL_STATE(6549)] = 250077,
  [SMALL_STATE(6550)] = 250123,
  [SMALL_STATE(6551)] = 250169,
  [SMALL_STATE(6552)] = 250215,
  [SMALL_STATE(6553)] = 250261,
  [SMALL_STATE(6554)] = 250307,
  [SMALL_STATE(6555)] = 250353,
  [SMALL_STATE(6556)] = 250399,
  [SMALL_STATE(6557)] = 250445,
  [SMALL_STATE(6558)] = 250491,
  [SMALL_STATE(6559)] = 250539,
  [SMALL_STATE(6560)] = 250585,
  [SMALL_STATE(6561)] = 250631,
  [SMALL_STATE(6562)] = 250677,
  [SMALL_STATE(6563)] = 250723,
  [SMALL_STATE(6564)] = 250769,
  [SMALL_STATE(6565)] = 250815,
  [SMALL_STATE(6566)] = 250861,
  [SMALL_STATE(6567)] = 250907,
  [SMALL_STATE(6568)] = 250953,
  [SMALL_STATE(6569)] = 250999,
  [SMALL_STATE(6570)] = 251045,
  [SMALL_STATE(6571)] = 251091,
  [SMALL_STATE(6572)] = 251137,
  [SMALL_STATE(6573)] = 251185,
  [SMALL_STATE(6574)] = 251231,
  [SMALL_STATE(6575)] = 251277,
  [SMALL_STATE(6576)] = 251323,
  [SMALL_STATE(6577)] = 251369,
  [SMALL_STATE(6578)] = 251415,
  [SMALL_STATE(6579)] = 251461,
  [SMALL_STATE(6580)] = 251507,
  [SMALL_STATE(6581)] = 251553,
  [SMALL_STATE(6582)] = 251599,
  [SMALL_STATE(6583)] = 251645,
  [SMALL_STATE(6584)] = 251691,
  [SMALL_STATE(6585)] = 251737,
  [SMALL_STATE(6586)] = 251783,
  [SMALL_STATE(6587)] = 251829,
  [SMALL_STATE(6588)] = 251875,
  [SMALL_STATE(6589)] = 251921,
  [SMALL_STATE(6590)] = 251967,
  [SMALL_STATE(6591)] = 252012,
  [SMALL_STATE(6592)] = 252057,
  [SMALL_STATE(6593)] = 252102,
  [SMALL_STATE(6594)] = 252147,
  [SMALL_STATE(6595)] = 252192,
  [SMALL_STATE(6596)] = 252239,
  [SMALL_STATE(6597)] = 252284,
  [SMALL_STATE(6598)] = 252329,
  [SMALL_STATE(6599)] = 252374,
  [SMALL_STATE(6600)] = 252419,
  [SMALL_STATE(6601)] = 252464,
  [SMALL_STATE(6602)] = 252509,
  [SMALL_STATE(6603)] = 252554,
  [SMALL_STATE(6604)] = 252599,
  [SMALL_STATE(6605)] = 252644,
  [SMALL_STATE(6606)] = 252691,
  [SMALL_STATE(6607)] = 252736,
  [SMALL_STATE(6608)] = 252781,
  [SMALL_STATE(6609)] = 252826,
  [SMALL_STATE(6610)] = 252871,
  [SMALL_STATE(6611)] = 252916,
  [SMALL_STATE(6612)] = 252961,
  [SMALL_STATE(6613)] = 253006,
  [SMALL_STATE(6614)] = 253051,
  [SMALL_STATE(6615)] = 253096,
  [SMALL_STATE(6616)] = 253141,
  [SMALL_STATE(6617)] = 253186,
  [SMALL_STATE(6618)] = 253231,
  [SMALL_STATE(6619)] = 253276,
  [SMALL_STATE(6620)] = 253321,
  [SMALL_STATE(6621)] = 253366,
  [SMALL_STATE(6622)] = 253411,
  [SMALL_STATE(6623)] = 253456,
  [SMALL_STATE(6624)] = 253501,
  [SMALL_STATE(6625)] = 253546,
  [SMALL_STATE(6626)] = 253591,
  [SMALL_STATE(6627)] = 253636,
  [SMALL_STATE(6628)] = 253681,
  [SMALL_STATE(6629)] = 253726,
  [SMALL_STATE(6630)] = 253771,
  [SMALL_STATE(6631)] = 253816,
  [SMALL_STATE(6632)] = 253861,
  [SMALL_STATE(6633)] = 253906,
  [SMALL_STATE(6634)] = 253951,
  [SMALL_STATE(6635)] = 253998,
  [SMALL_STATE(6636)] = 254045,
  [SMALL_STATE(6637)] = 254090,
  [SMALL_STATE(6638)] = 254135,
  [SMALL_STATE(6639)] = 254180,
  [SMALL_STATE(6640)] = 254225,
  [SMALL_STATE(6641)] = 254270,
  [SMALL_STATE(6642)] = 254315,
  [SMALL_STATE(6643)] = 254360,
  [SMALL_STATE(6644)] = 254405,
  [SMALL_STATE(6645)] = 254452,
  [SMALL_STATE(6646)] = 254497,
  [SMALL_STATE(6647)] = 254542,
  [SMALL_STATE(6648)] = 254587,
  [SMALL_STATE(6649)] = 254632,
  [SMALL_STATE(6650)] = 254677,
  [SMALL_STATE(6651)] = 254722,
  [SMALL_STATE(6652)] = 254767,
  [SMALL_STATE(6653)] = 254812,
  [SMALL_STATE(6654)] = 254859,
  [SMALL_STATE(6655)] = 254904,
  [SMALL_STATE(6656)] = 254967,
  [SMALL_STATE(6657)] = 255012,
  [SMALL_STATE(6658)] = 255057,
  [SMALL_STATE(6659)] = 255102,
  [SMALL_STATE(6660)] = 255147,
  [SMALL_STATE(6661)] = 255192,
  [SMALL_STATE(6662)] = 255237,
  [SMALL_STATE(6663)] = 255282,
  [SMALL_STATE(6664)] = 255327,
  [SMALL_STATE(6665)] = 255372,
  [SMALL_STATE(6666)] = 255417,
  [SMALL_STATE(6667)] = 255462,
  [SMALL_STATE(6668)] = 255507,
  [SMALL_STATE(6669)] = 255552,
  [SMALL_STATE(6670)] = 255597,
  [SMALL_STATE(6671)] = 255642,
  [SMALL_STATE(6672)] = 255687,
  [SMALL_STATE(6673)] = 255732,
  [SMALL_STATE(6674)] = 255777,
  [SMALL_STATE(6675)] = 255822,
  [SMALL_STATE(6676)] = 255867,
  [SMALL_STATE(6677)] = 255912,
  [SMALL_STATE(6678)] = 255957,
  [SMALL_STATE(6679)] = 256002,
  [SMALL_STATE(6680)] = 256047,
  [SMALL_STATE(6681)] = 256092,
  [SMALL_STATE(6682)] = 256137,
  [SMALL_STATE(6683)] = 256182,
  [SMALL_STATE(6684)] = 256227,
  [SMALL_STATE(6685)] = 256272,
  [SMALL_STATE(6686)] = 256317,
  [SMALL_STATE(6687)] = 256362,
  [SMALL_STATE(6688)] = 256407,
  [SMALL_STATE(6689)] = 256454,
  [SMALL_STATE(6690)] = 256501,
  [SMALL_STATE(6691)] = 256546,
  [SMALL_STATE(6692)] = 256591,
  [SMALL_STATE(6693)] = 256636,
  [SMALL_STATE(6694)] = 256681,
  [SMALL_STATE(6695)] = 256726,
  [SMALL_STATE(6696)] = 256771,
  [SMALL_STATE(6697)] = 256816,
  [SMALL_STATE(6698)] = 256861,
  [SMALL_STATE(6699)] = 256906,
  [SMALL_STATE(6700)] = 256951,
  [SMALL_STATE(6701)] = 256996,
  [SMALL_STATE(6702)] = 257041,
  [SMALL_STATE(6703)] = 257088,
  [SMALL_STATE(6704)] = 257133,
  [SMALL_STATE(6705)] = 257180,
  [SMALL_STATE(6706)] = 257225,
  [SMALL_STATE(6707)] = 257272,
  [SMALL_STATE(6708)] = 257317,
  [SMALL_STATE(6709)] = 257362,
  [SMALL_STATE(6710)] = 257407,
  [SMALL_STATE(6711)] = 257452,
  [SMALL_STATE(6712)] = 257497,
  [SMALL_STATE(6713)] = 257542,
  [SMALL_STATE(6714)] = 257587,
  [SMALL_STATE(6715)] = 257634,
  [SMALL_STATE(6716)] = 257681,
  [SMALL_STATE(6717)] = 257736,
  [SMALL_STATE(6718)] = 257781,
  [SMALL_STATE(6719)] = 257826,
  [SMALL_STATE(6720)] = 257871,
  [SMALL_STATE(6721)] = 257916,
  [SMALL_STATE(6722)] = 257961,
  [SMALL_STATE(6723)] = 258006,
  [SMALL_STATE(6724)] = 258051,
  [SMALL_STATE(6725)] = 258096,
  [SMALL_STATE(6726)] = 258141,
  [SMALL_STATE(6727)] = 258186,
  [SMALL_STATE(6728)] = 258231,
  [SMALL_STATE(6729)] = 258276,
  [SMALL_STATE(6730)] = 258321,
  [SMALL_STATE(6731)] = 258366,
  [SMALL_STATE(6732)] = 258411,
  [SMALL_STATE(6733)] = 258456,
  [SMALL_STATE(6734)] = 258501,
  [SMALL_STATE(6735)] = 258546,
  [SMALL_STATE(6736)] = 258593,
  [SMALL_STATE(6737)] = 258638,
  [SMALL_STATE(6738)] = 258683,
  [SMALL_STATE(6739)] = 258728,
  [SMALL_STATE(6740)] = 258773,
  [SMALL_STATE(6741)] = 258820,
  [SMALL_STATE(6742)] = 258865,
  [SMALL_STATE(6743)] = 258910,
  [SMALL_STATE(6744)] = 258955,
  [SMALL_STATE(6745)] = 259000,
  [SMALL_STATE(6746)] = 259045,
  [SMALL_STATE(6747)] = 259090,
  [SMALL_STATE(6748)] = 259135,
  [SMALL_STATE(6749)] = 259180,
  [SMALL_STATE(6750)] = 259225,
  [SMALL_STATE(6751)] = 259270,
  [SMALL_STATE(6752)] = 259315,
  [SMALL_STATE(6753)] = 259360,
  [SMALL_STATE(6754)] = 259405,
  [SMALL_STATE(6755)] = 259450,
  [SMALL_STATE(6756)] = 259495,
  [SMALL_STATE(6757)] = 259540,
  [SMALL_STATE(6758)] = 259585,
  [SMALL_STATE(6759)] = 259630,
  [SMALL_STATE(6760)] = 259675,
  [SMALL_STATE(6761)] = 259720,
  [SMALL_STATE(6762)] = 259765,
  [SMALL_STATE(6763)] = 259810,
  [SMALL_STATE(6764)] = 259855,
  [SMALL_STATE(6765)] = 259900,
  [SMALL_STATE(6766)] = 259945,
  [SMALL_STATE(6767)] = 259990,
  [SMALL_STATE(6768)] = 260035,
  [SMALL_STATE(6769)] = 260080,
  [SMALL_STATE(6770)] = 260125,
  [SMALL_STATE(6771)] = 260172,
  [SMALL_STATE(6772)] = 260217,
  [SMALL_STATE(6773)] = 260262,
  [SMALL_STATE(6774)] = 260307,
  [SMALL_STATE(6775)] = 260354,
  [SMALL_STATE(6776)] = 260399,
  [SMALL_STATE(6777)] = 260444,
  [SMALL_STATE(6778)] = 260489,
  [SMALL_STATE(6779)] = 260534,
  [SMALL_STATE(6780)] = 260579,
  [SMALL_STATE(6781)] = 260624,
  [SMALL_STATE(6782)] = 260671,
  [SMALL_STATE(6783)] = 260718,
  [SMALL_STATE(6784)] = 260763,
  [SMALL_STATE(6785)] = 260808,
  [SMALL_STATE(6786)] = 260853,
  [SMALL_STATE(6787)] = 260900,
  [SMALL_STATE(6788)] = 260945,
  [SMALL_STATE(6789)] = 260990,
  [SMALL_STATE(6790)] = 261035,
  [SMALL_STATE(6791)] = 261081,
  [SMALL_STATE(6792)] = 261131,
  [SMALL_STATE(6793)] = 261181,
  [SMALL_STATE(6794)] = 261231,
  [SMALL_STATE(6795)] = 261281,
  [SMALL_STATE(6796)] = 261331,
  [SMALL_STATE(6797)] = 261375,
  [SMALL_STATE(6798)] = 261425,
  [SMALL_STATE(6799)] = 261471,
  [SMALL_STATE(6800)] = 261515,
  [SMALL_STATE(6801)] = 261565,
  [SMALL_STATE(6802)] = 261615,
  [SMALL_STATE(6803)] = 261665,
  [SMALL_STATE(6804)] = 261715,
  [SMALL_STATE(6805)] = 261765,
  [SMALL_STATE(6806)] = 261815,
  [SMALL_STATE(6807)] = 261865,
  [SMALL_STATE(6808)] = 261915,
  [SMALL_STATE(6809)] = 261965,
  [SMALL_STATE(6810)] = 262015,
  [SMALL_STATE(6811)] = 262065,
  [SMALL_STATE(6812)] = 262115,
  [SMALL_STATE(6813)] = 262165,
  [SMALL_STATE(6814)] = 262215,
  [SMALL_STATE(6815)] = 262265,
  [SMALL_STATE(6816)] = 262315,
  [SMALL_STATE(6817)] = 262365,
  [SMALL_STATE(6818)] = 262411,
  [SMALL_STATE(6819)] = 262461,
  [SMALL_STATE(6820)] = 262511,
  [SMALL_STATE(6821)] = 262557,
  [SMALL_STATE(6822)] = 262607,
  [SMALL_STATE(6823)] = 262657,
  [SMALL_STATE(6824)] = 262707,
  [SMALL_STATE(6825)] = 262757,
  [SMALL_STATE(6826)] = 262807,
  [SMALL_STATE(6827)] = 262857,
  [SMALL_STATE(6828)] = 262907,
  [SMALL_STATE(6829)] = 262957,
  [SMALL_STATE(6830)] = 263007,
  [SMALL_STATE(6831)] = 263057,
  [SMALL_STATE(6832)] = 263107,
  [SMALL_STATE(6833)] = 263157,
  [SMALL_STATE(6834)] = 263201,
  [SMALL_STATE(6835)] = 263251,
  [SMALL_STATE(6836)] = 263301,
  [SMALL_STATE(6837)] = 263351,
  [SMALL_STATE(6838)] = 263401,
  [SMALL_STATE(6839)] = 263447,
  [SMALL_STATE(6840)] = 263497,
  [SMALL_STATE(6841)] = 263547,
  [SMALL_STATE(6842)] = 263597,
  [SMALL_STATE(6843)] = 263647,
  [SMALL_STATE(6844)] = 263693,
  [SMALL_STATE(6845)] = 263743,
  [SMALL_STATE(6846)] = 263787,
  [SMALL_STATE(6847)] = 263837,
  [SMALL_STATE(6848)] = 263887,
  [SMALL_STATE(6849)] = 263937,
  [SMALL_STATE(6850)] = 263983,
  [SMALL_STATE(6851)] = 264029,
  [SMALL_STATE(6852)] = 264073,
  [SMALL_STATE(6853)] = 264123,
  [SMALL_STATE(6854)] = 264173,
  [SMALL_STATE(6855)] = 264223,
  [SMALL_STATE(6856)] = 264269,
  [SMALL_STATE(6857)] = 264313,
  [SMALL_STATE(6858)] = 264359,
  [SMALL_STATE(6859)] = 264403,
  [SMALL_STATE(6860)] = 264447,
  [SMALL_STATE(6861)] = 264491,
  [SMALL_STATE(6862)] = 264535,
  [SMALL_STATE(6863)] = 264579,
  [SMALL_STATE(6864)] = 264629,
  [SMALL_STATE(6865)] = 264679,
  [SMALL_STATE(6866)] = 264729,
  [SMALL_STATE(6867)] = 264773,
  [SMALL_STATE(6868)] = 264817,
  [SMALL_STATE(6869)] = 264863,
  [SMALL_STATE(6870)] = 264913,
  [SMALL_STATE(6871)] = 264957,
  [SMALL_STATE(6872)] = 265007,
  [SMALL_STATE(6873)] = 265051,
  [SMALL_STATE(6874)] = 265101,
  [SMALL_STATE(6875)] = 265145,
  [SMALL_STATE(6876)] = 265189,
  [SMALL_STATE(6877)] = 265233,
  [SMALL_STATE(6878)] = 265283,
  [SMALL_STATE(6879)] = 265333,
  [SMALL_STATE(6880)] = 265377,
  [SMALL_STATE(6881)] = 265421,
  [SMALL_STATE(6882)] = 265471,
  [SMALL_STATE(6883)] = 265515,
  [SMALL_STATE(6884)] = 265559,
  [SMALL_STATE(6885)] = 265609,
  [SMALL_STATE(6886)] = 265659,
  [SMALL_STATE(6887)] = 265705,
  [SMALL_STATE(6888)] = 265755,
  [SMALL_STATE(6889)] = 265805,
  [SMALL_STATE(6890)] = 265855,
  [SMALL_STATE(6891)] = 265905,
  [SMALL_STATE(6892)] = 265949,
  [SMALL_STATE(6893)] = 265993,
  [SMALL_STATE(6894)] = 266037,
  [SMALL_STATE(6895)] = 266087,
  [SMALL_STATE(6896)] = 266131,
  [SMALL_STATE(6897)] = 266175,
  [SMALL_STATE(6898)] = 266219,
  [SMALL_STATE(6899)] = 266269,
  [SMALL_STATE(6900)] = 266313,
  [SMALL_STATE(6901)] = 266363,
  [SMALL_STATE(6902)] = 266407,
  [SMALL_STATE(6903)] = 266451,
  [SMALL_STATE(6904)] = 266501,
  [SMALL_STATE(6905)] = 266551,
  [SMALL_STATE(6906)] = 266597,
  [SMALL_STATE(6907)] = 266647,
  [SMALL_STATE(6908)] = 266691,
  [SMALL_STATE(6909)] = 266735,
  [SMALL_STATE(6910)] = 266785,
  [SMALL_STATE(6911)] = 266829,
  [SMALL_STATE(6912)] = 266875,
  [SMALL_STATE(6913)] = 266919,
  [SMALL_STATE(6914)] = 266969,
  [SMALL_STATE(6915)] = 267013,
  [SMALL_STATE(6916)] = 267057,
  [SMALL_STATE(6917)] = 267107,
  [SMALL_STATE(6918)] = 267151,
  [SMALL_STATE(6919)] = 267201,
  [SMALL_STATE(6920)] = 267251,
  [SMALL_STATE(6921)] = 267301,
  [SMALL_STATE(6922)] = 267351,
  [SMALL_STATE(6923)] = 267395,
  [SMALL_STATE(6924)] = 267445,
  [SMALL_STATE(6925)] = 267489,
  [SMALL_STATE(6926)] = 267533,
  [SMALL_STATE(6927)] = 267583,
  [SMALL_STATE(6928)] = 267633,
  [SMALL_STATE(6929)] = 267677,
  [SMALL_STATE(6930)] = 267721,
  [SMALL_STATE(6931)] = 267765,
  [SMALL_STATE(6932)] = 267809,
  [SMALL_STATE(6933)] = 267859,
  [SMALL_STATE(6934)] = 267905,
  [SMALL_STATE(6935)] = 267951,
  [SMALL_STATE(6936)] = 268001,
  [SMALL_STATE(6937)] = 268047,
  [SMALL_STATE(6938)] = 268091,
  [SMALL_STATE(6939)] = 268141,
  [SMALL_STATE(6940)] = 268185,
  [SMALL_STATE(6941)] = 268235,
  [SMALL_STATE(6942)] = 268279,
  [SMALL_STATE(6943)] = 268325,
  [SMALL_STATE(6944)] = 268369,
  [SMALL_STATE(6945)] = 268413,
  [SMALL_STATE(6946)] = 268457,
  [SMALL_STATE(6947)] = 268503,
  [SMALL_STATE(6948)] = 268549,
  [SMALL_STATE(6949)] = 268593,
  [SMALL_STATE(6950)] = 268643,
  [SMALL_STATE(6951)] = 268693,
  [SMALL_STATE(6952)] = 268739,
  [SMALL_STATE(6953)] = 268789,
  [SMALL_STATE(6954)] = 268835,
  [SMALL_STATE(6955)] = 268879,
  [SMALL_STATE(6956)] = 268923,
  [SMALL_STATE(6957)] = 268967,
  [SMALL_STATE(6958)] = 269017,
  [SMALL_STATE(6959)] = 269063,
  [SMALL_STATE(6960)] = 269107,
  [SMALL_STATE(6961)] = 269151,
  [SMALL_STATE(6962)] = 269201,
  [SMALL_STATE(6963)] = 269251,
  [SMALL_STATE(6964)] = 269295,
  [SMALL_STATE(6965)] = 269339,
  [SMALL_STATE(6966)] = 269383,
  [SMALL_STATE(6967)] = 269433,
  [SMALL_STATE(6968)] = 269483,
  [SMALL_STATE(6969)] = 269527,
  [SMALL_STATE(6970)] = 269571,
  [SMALL_STATE(6971)] = 269621,
  [SMALL_STATE(6972)] = 269667,
  [SMALL_STATE(6973)] = 269711,
  [SMALL_STATE(6974)] = 269755,
  [SMALL_STATE(6975)] = 269805,
  [SMALL_STATE(6976)] = 269849,
  [SMALL_STATE(6977)] = 269893,
  [SMALL_STATE(6978)] = 269937,
  [SMALL_STATE(6979)] = 269981,
  [SMALL_STATE(6980)] = 270031,
  [SMALL_STATE(6981)] = 270075,
  [SMALL_STATE(6982)] = 270125,
  [SMALL_STATE(6983)] = 270171,
  [SMALL_STATE(6984)] = 270215,
  [SMALL_STATE(6985)] = 270259,
  [SMALL_STATE(6986)] = 270303,
  [SMALL_STATE(6987)] = 270347,
  [SMALL_STATE(6988)] = 270391,
  [SMALL_STATE(6989)] = 270435,
  [SMALL_STATE(6990)] = 270481,
  [SMALL_STATE(6991)] = 270525,
  [SMALL_STATE(6992)] = 270571,
  [SMALL_STATE(6993)] = 270615,
  [SMALL_STATE(6994)] = 270659,
  [SMALL_STATE(6995)] = 270705,
  [SMALL_STATE(6996)] = 270751,
  [SMALL_STATE(6997)] = 270801,
  [SMALL_STATE(6998)] = 270847,
  [SMALL_STATE(6999)] = 270891,
  [SMALL_STATE(7000)] = 270941,
  [SMALL_STATE(7001)] = 270991,
  [SMALL_STATE(7002)] = 271035,
  [SMALL_STATE(7003)] = 271079,
  [SMALL_STATE(7004)] = 271123,
  [SMALL_STATE(7005)] = 271167,
  [SMALL_STATE(7006)] = 271211,
  [SMALL_STATE(7007)] = 271255,
  [SMALL_STATE(7008)] = 271305,
  [SMALL_STATE(7009)] = 271349,
  [SMALL_STATE(7010)] = 271393,
  [SMALL_STATE(7011)] = 271437,
  [SMALL_STATE(7012)] = 271481,
  [SMALL_STATE(7013)] = 271531,
  [SMALL_STATE(7014)] = 271581,
  [SMALL_STATE(7015)] = 271631,
  [SMALL_STATE(7016)] = 271675,
  [SMALL_STATE(7017)] = 271719,
  [SMALL_STATE(7018)] = 271763,
  [SMALL_STATE(7019)] = 271813,
  [SMALL_STATE(7020)] = 271857,
  [SMALL_STATE(7021)] = 271907,
  [SMALL_STATE(7022)] = 271957,
  [SMALL_STATE(7023)] = 272001,
  [SMALL_STATE(7024)] = 272047,
  [SMALL_STATE(7025)] = 272091,
  [SMALL_STATE(7026)] = 272135,
  [SMALL_STATE(7027)] = 272179,
  [SMALL_STATE(7028)] = 272223,
  [SMALL_STATE(7029)] = 272267,
  [SMALL_STATE(7030)] = 272311,
  [SMALL_STATE(7031)] = 272365,
  [SMALL_STATE(7032)] = 272409,
  [SMALL_STATE(7033)] = 272453,
  [SMALL_STATE(7034)] = 272497,
  [SMALL_STATE(7035)] = 272541,
  [SMALL_STATE(7036)] = 272585,
  [SMALL_STATE(7037)] = 272635,
  [SMALL_STATE(7038)] = 272679,
  [SMALL_STATE(7039)] = 272723,
  [SMALL_STATE(7040)] = 272767,
  [SMALL_STATE(7041)] = 272811,
  [SMALL_STATE(7042)] = 272857,
  [SMALL_STATE(7043)] = 272907,
  [SMALL_STATE(7044)] = 272957,
  [SMALL_STATE(7045)] = 273001,
  [SMALL_STATE(7046)] = 273045,
  [SMALL_STATE(7047)] = 273091,
  [SMALL_STATE(7048)] = 273135,
  [SMALL_STATE(7049)] = 273179,
  [SMALL_STATE(7050)] = 273229,
  [SMALL_STATE(7051)] = 273273,
  [SMALL_STATE(7052)] = 273323,
  [SMALL_STATE(7053)] = 273382,
  [SMALL_STATE(7054)] = 273425,
  [SMALL_STATE(7055)] = 273468,
  [SMALL_STATE(7056)] = 273513,
  [SMALL_STATE(7057)] = 273556,
  [SMALL_STATE(7058)] = 273607,
  [SMALL_STATE(7059)] = 273650,
  [SMALL_STATE(7060)] = 273693,
  [SMALL_STATE(7061)] = 273736,
  [SMALL_STATE(7062)] = 273779,
  [SMALL_STATE(7063)] = 273822,
  [SMALL_STATE(7064)] = 273883,
  [SMALL_STATE(7065)] = 273926,
  [SMALL_STATE(7066)] = 273985,
  [SMALL_STATE(7067)] = 274028,
  [SMALL_STATE(7068)] = 274071,
  [SMALL_STATE(7069)] = 274114,
  [SMALL_STATE(7070)] = 274157,
  [SMALL_STATE(7071)] = 274200,
  [SMALL_STATE(7072)] = 274243,
  [SMALL_STATE(7073)] = 274302,
  [SMALL_STATE(7074)] = 274345,
  [SMALL_STATE(7075)] = 274388,
  [SMALL_STATE(7076)] = 274431,
  [SMALL_STATE(7077)] = 274474,
  [SMALL_STATE(7078)] = 274519,
  [SMALL_STATE(7079)] = 274564,
  [SMALL_STATE(7080)] = 274615,
  [SMALL_STATE(7081)] = 274658,
  [SMALL_STATE(7082)] = 274701,
  [SMALL_STATE(7083)] = 274746,
  [SMALL_STATE(7084)] = 274789,
  [SMALL_STATE(7085)] = 274832,
  [SMALL_STATE(7086)] = 274875,
  [SMALL_STATE(7087)] = 274918,
  [SMALL_STATE(7088)] = 274961,
  [SMALL_STATE(7089)] = 275006,
  [SMALL_STATE(7090)] = 275049,
  [SMALL_STATE(7091)] = 275092,
  [SMALL_STATE(7092)] = 275135,
  [SMALL_STATE(7093)] = 275178,
  [SMALL_STATE(7094)] = 275221,
  [SMALL_STATE(7095)] = 275264,
  [SMALL_STATE(7096)] = 275307,
  [SMALL_STATE(7097)] = 275350,
  [SMALL_STATE(7098)] = 275411,
  [SMALL_STATE(7099)] = 275454,
  [SMALL_STATE(7100)] = 275497,
  [SMALL_STATE(7101)] = 275540,
  [SMALL_STATE(7102)] = 275583,
  [SMALL_STATE(7103)] = 275626,
  [SMALL_STATE(7104)] = 275669,
  [SMALL_STATE(7105)] = 275712,
  [SMALL_STATE(7106)] = 275755,
  [SMALL_STATE(7107)] = 275800,
  [SMALL_STATE(7108)] = 275843,
  [SMALL_STATE(7109)] = 275888,
  [SMALL_STATE(7110)] = 275931,
  [SMALL_STATE(7111)] = 275976,
  [SMALL_STATE(7112)] = 276019,
  [SMALL_STATE(7113)] = 276062,
  [SMALL_STATE(7114)] = 276105,
  [SMALL_STATE(7115)] = 276148,
  [SMALL_STATE(7116)] = 276191,
  [SMALL_STATE(7117)] = 276234,
  [SMALL_STATE(7118)] = 276277,
  [SMALL_STATE(7119)] = 276320,
  [SMALL_STATE(7120)] = 276363,
  [SMALL_STATE(7121)] = 276406,
  [SMALL_STATE(7122)] = 276449,
  [SMALL_STATE(7123)] = 276492,
  [SMALL_STATE(7124)] = 276535,
  [SMALL_STATE(7125)] = 276578,
  [SMALL_STATE(7126)] = 276621,
  [SMALL_STATE(7127)] = 276664,
  [SMALL_STATE(7128)] = 276707,
  [SMALL_STATE(7129)] = 276750,
  [SMALL_STATE(7130)] = 276793,
  [SMALL_STATE(7131)] = 276838,
  [SMALL_STATE(7132)] = 276883,
  [SMALL_STATE(7133)] = 276926,
  [SMALL_STATE(7134)] = 276969,
  [SMALL_STATE(7135)] = 277012,
  [SMALL_STATE(7136)] = 277055,
  [SMALL_STATE(7137)] = 277098,
  [SMALL_STATE(7138)] = 277141,
  [SMALL_STATE(7139)] = 277184,
  [SMALL_STATE(7140)] = 277227,
  [SMALL_STATE(7141)] = 277270,
  [SMALL_STATE(7142)] = 277313,
  [SMALL_STATE(7143)] = 277356,
  [SMALL_STATE(7144)] = 277401,
  [SMALL_STATE(7145)] = 277444,
  [SMALL_STATE(7146)] = 277487,
  [SMALL_STATE(7147)] = 277530,
  [SMALL_STATE(7148)] = 277573,
  [SMALL_STATE(7149)] = 277616,
  [SMALL_STATE(7150)] = 277661,
  [SMALL_STATE(7151)] = 277704,
  [SMALL_STATE(7152)] = 277747,
  [SMALL_STATE(7153)] = 277790,
  [SMALL_STATE(7154)] = 277833,
  [SMALL_STATE(7155)] = 277876,
  [SMALL_STATE(7156)] = 277921,
  [SMALL_STATE(7157)] = 277964,
  [SMALL_STATE(7158)] = 278007,
  [SMALL_STATE(7159)] = 278050,
  [SMALL_STATE(7160)] = 278093,
  [SMALL_STATE(7161)] = 278152,
  [SMALL_STATE(7162)] = 278195,
  [SMALL_STATE(7163)] = 278238,
  [SMALL_STATE(7164)] = 278281,
  [SMALL_STATE(7165)] = 278324,
  [SMALL_STATE(7166)] = 278369,
  [SMALL_STATE(7167)] = 278414,
  [SMALL_STATE(7168)] = 278457,
  [SMALL_STATE(7169)] = 278500,
  [SMALL_STATE(7170)] = 278543,
  [SMALL_STATE(7171)] = 278586,
  [SMALL_STATE(7172)] = 278629,
  [SMALL_STATE(7173)] = 278672,
  [SMALL_STATE(7174)] = 278717,
  [SMALL_STATE(7175)] = 278760,
  [SMALL_STATE(7176)] = 278803,
  [SMALL_STATE(7177)] = 278848,
  [SMALL_STATE(7178)] = 278891,
  [SMALL_STATE(7179)] = 278934,
  [SMALL_STATE(7180)] = 278977,
  [SMALL_STATE(7181)] = 279020,
  [SMALL_STATE(7182)] = 279063,
  [SMALL_STATE(7183)] = 279106,
  [SMALL_STATE(7184)] = 279151,
  [SMALL_STATE(7185)] = 279194,
  [SMALL_STATE(7186)] = 279237,
  [SMALL_STATE(7187)] = 279280,
  [SMALL_STATE(7188)] = 279323,
  [SMALL_STATE(7189)] = 279366,
  [SMALL_STATE(7190)] = 279409,
  [SMALL_STATE(7191)] = 279452,
  [SMALL_STATE(7192)] = 279495,
  [SMALL_STATE(7193)] = 279538,
  [SMALL_STATE(7194)] = 279581,
  [SMALL_STATE(7195)] = 279624,
  [SMALL_STATE(7196)] = 279667,
  [SMALL_STATE(7197)] = 279710,
  [SMALL_STATE(7198)] = 279753,
  [SMALL_STATE(7199)] = 279796,
  [SMALL_STATE(7200)] = 279839,
  [SMALL_STATE(7201)] = 279882,
  [SMALL_STATE(7202)] = 279925,
  [SMALL_STATE(7203)] = 279968,
  [SMALL_STATE(7204)] = 280011,
  [SMALL_STATE(7205)] = 280054,
  [SMALL_STATE(7206)] = 280097,
  [SMALL_STATE(7207)] = 280140,
  [SMALL_STATE(7208)] = 280185,
  [SMALL_STATE(7209)] = 280228,
  [SMALL_STATE(7210)] = 280271,
  [SMALL_STATE(7211)] = 280314,
  [SMALL_STATE(7212)] = 280357,
  [SMALL_STATE(7213)] = 280400,
  [SMALL_STATE(7214)] = 280443,
  [SMALL_STATE(7215)] = 280502,
  [SMALL_STATE(7216)] = 280545,
  [SMALL_STATE(7217)] = 280588,
  [SMALL_STATE(7218)] = 280631,
  [SMALL_STATE(7219)] = 280674,
  [SMALL_STATE(7220)] = 280717,
  [SMALL_STATE(7221)] = 280760,
  [SMALL_STATE(7222)] = 280803,
  [SMALL_STATE(7223)] = 280846,
  [SMALL_STATE(7224)] = 280889,
  [SMALL_STATE(7225)] = 280932,
  [SMALL_STATE(7226)] = 280975,
  [SMALL_STATE(7227)] = 281018,
  [SMALL_STATE(7228)] = 281061,
  [SMALL_STATE(7229)] = 281104,
  [SMALL_STATE(7230)] = 281147,
  [SMALL_STATE(7231)] = 281190,
  [SMALL_STATE(7232)] = 281233,
  [SMALL_STATE(7233)] = 281276,
  [SMALL_STATE(7234)] = 281319,
  [SMALL_STATE(7235)] = 281362,
  [SMALL_STATE(7236)] = 281405,
  [SMALL_STATE(7237)] = 281448,
  [SMALL_STATE(7238)] = 281491,
  [SMALL_STATE(7239)] = 281550,
  [SMALL_STATE(7240)] = 281593,
  [SMALL_STATE(7241)] = 281636,
  [SMALL_STATE(7242)] = 281679,
  [SMALL_STATE(7243)] = 281722,
  [SMALL_STATE(7244)] = 281765,
  [SMALL_STATE(7245)] = 281808,
  [SMALL_STATE(7246)] = 281851,
  [SMALL_STATE(7247)] = 281894,
  [SMALL_STATE(7248)] = 281937,
  [SMALL_STATE(7249)] = 281982,
  [SMALL_STATE(7250)] = 282025,
  [SMALL_STATE(7251)] = 282068,
  [SMALL_STATE(7252)] = 282111,
  [SMALL_STATE(7253)] = 282154,
  [SMALL_STATE(7254)] = 282197,
  [SMALL_STATE(7255)] = 282240,
  [SMALL_STATE(7256)] = 282283,
  [SMALL_STATE(7257)] = 282328,
  [SMALL_STATE(7258)] = 282371,
  [SMALL_STATE(7259)] = 282416,
  [SMALL_STATE(7260)] = 282461,
  [SMALL_STATE(7261)] = 282504,
  [SMALL_STATE(7262)] = 282547,
  [SMALL_STATE(7263)] = 282590,
  [SMALL_STATE(7264)] = 282633,
  [SMALL_STATE(7265)] = 282676,
  [SMALL_STATE(7266)] = 282719,
  [SMALL_STATE(7267)] = 282762,
  [SMALL_STATE(7268)] = 282805,
  [SMALL_STATE(7269)] = 282850,
  [SMALL_STATE(7270)] = 282893,
  [SMALL_STATE(7271)] = 282936,
  [SMALL_STATE(7272)] = 282979,
  [SMALL_STATE(7273)] = 283022,
  [SMALL_STATE(7274)] = 283065,
  [SMALL_STATE(7275)] = 283108,
  [SMALL_STATE(7276)] = 283151,
  [SMALL_STATE(7277)] = 283196,
  [SMALL_STATE(7278)] = 283239,
  [SMALL_STATE(7279)] = 283282,
  [SMALL_STATE(7280)] = 283327,
  [SMALL_STATE(7281)] = 283372,
  [SMALL_STATE(7282)] = 283415,
  [SMALL_STATE(7283)] = 283458,
  [SMALL_STATE(7284)] = 283501,
  [SMALL_STATE(7285)] = 283546,
  [SMALL_STATE(7286)] = 283589,
  [SMALL_STATE(7287)] = 283632,
  [SMALL_STATE(7288)] = 283677,
  [SMALL_STATE(7289)] = 283720,
  [SMALL_STATE(7290)] = 283765,
  [SMALL_STATE(7291)] = 283808,
  [SMALL_STATE(7292)] = 283851,
  [SMALL_STATE(7293)] = 283896,
  [SMALL_STATE(7294)] = 283939,
  [SMALL_STATE(7295)] = 283984,
  [SMALL_STATE(7296)] = 284029,
  [SMALL_STATE(7297)] = 284072,
  [SMALL_STATE(7298)] = 284117,
  [SMALL_STATE(7299)] = 284160,
  [SMALL_STATE(7300)] = 284205,
  [SMALL_STATE(7301)] = 284248,
  [SMALL_STATE(7302)] = 284291,
  [SMALL_STATE(7303)] = 284334,
  [SMALL_STATE(7304)] = 284379,
  [SMALL_STATE(7305)] = 284422,
  [SMALL_STATE(7306)] = 284465,
  [SMALL_STATE(7307)] = 284508,
  [SMALL_STATE(7308)] = 284551,
  [SMALL_STATE(7309)] = 284594,
  [SMALL_STATE(7310)] = 284639,
  [SMALL_STATE(7311)] = 284682,
  [SMALL_STATE(7312)] = 284725,
  [SMALL_STATE(7313)] = 284768,
  [SMALL_STATE(7314)] = 284813,
  [SMALL_STATE(7315)] = 284858,
  [SMALL_STATE(7316)] = 284901,
  [SMALL_STATE(7317)] = 284946,
  [SMALL_STATE(7318)] = 284989,
  [SMALL_STATE(7319)] = 285032,
  [SMALL_STATE(7320)] = 285075,
  [SMALL_STATE(7321)] = 285117,
  [SMALL_STATE(7322)] = 285159,
  [SMALL_STATE(7323)] = 285201,
  [SMALL_STATE(7324)] = 285243,
  [SMALL_STATE(7325)] = 285285,
  [SMALL_STATE(7326)] = 285327,
  [SMALL_STATE(7327)] = 285369,
  [SMALL_STATE(7328)] = 285411,
  [SMALL_STATE(7329)] = 285453,
  [SMALL_STATE(7330)] = 285495,
  [SMALL_STATE(7331)] = 285537,
  [SMALL_STATE(7332)] = 285579,
  [SMALL_STATE(7333)] = 285621,
  [SMALL_STATE(7334)] = 285663,
  [SMALL_STATE(7335)] = 285705,
  [SMALL_STATE(7336)] = 285747,
  [SMALL_STATE(7337)] = 285789,
  [SMALL_STATE(7338)] = 285831,
  [SMALL_STATE(7339)] = 285873,
  [SMALL_STATE(7340)] = 285915,
  [SMALL_STATE(7341)] = 285957,
  [SMALL_STATE(7342)] = 285999,
  [SMALL_STATE(7343)] = 286041,
  [SMALL_STATE(7344)] = 286083,
  [SMALL_STATE(7345)] = 286125,
  [SMALL_STATE(7346)] = 286167,
  [SMALL_STATE(7347)] = 286209,
  [SMALL_STATE(7348)] = 286251,
  [SMALL_STATE(7349)] = 286293,
  [SMALL_STATE(7350)] = 286335,
  [SMALL_STATE(7351)] = 286377,
  [SMALL_STATE(7352)] = 286419,
  [SMALL_STATE(7353)] = 286461,
  [SMALL_STATE(7354)] = 286503,
  [SMALL_STATE(7355)] = 286547,
  [SMALL_STATE(7356)] = 286589,
  [SMALL_STATE(7357)] = 286631,
  [SMALL_STATE(7358)] = 286687,
  [SMALL_STATE(7359)] = 286729,
  [SMALL_STATE(7360)] = 286771,
  [SMALL_STATE(7361)] = 286813,
  [SMALL_STATE(7362)] = 286857,
  [SMALL_STATE(7363)] = 286899,
  [SMALL_STATE(7364)] = 286941,
  [SMALL_STATE(7365)] = 286983,
  [SMALL_STATE(7366)] = 287025,
  [SMALL_STATE(7367)] = 287067,
  [SMALL_STATE(7368)] = 287109,
  [SMALL_STATE(7369)] = 287151,
  [SMALL_STATE(7370)] = 287193,
  [SMALL_STATE(7371)] = 287235,
  [SMALL_STATE(7372)] = 287277,
  [SMALL_STATE(7373)] = 287321,
  [SMALL_STATE(7374)] = 287363,
  [SMALL_STATE(7375)] = 287405,
  [SMALL_STATE(7376)] = 287447,
  [SMALL_STATE(7377)] = 287489,
  [SMALL_STATE(7378)] = 287531,
  [SMALL_STATE(7379)] = 287573,
  [SMALL_STATE(7380)] = 287615,
  [SMALL_STATE(7381)] = 287657,
  [SMALL_STATE(7382)] = 287699,
  [SMALL_STATE(7383)] = 287755,
  [SMALL_STATE(7384)] = 287797,
  [SMALL_STATE(7385)] = 287839,
  [SMALL_STATE(7386)] = 287881,
  [SMALL_STATE(7387)] = 287923,
  [SMALL_STATE(7388)] = 287965,
  [SMALL_STATE(7389)] = 288011,
  [SMALL_STATE(7390)] = 288055,
  [SMALL_STATE(7391)] = 288097,
  [SMALL_STATE(7392)] = 288139,
  [SMALL_STATE(7393)] = 288181,
  [SMALL_STATE(7394)] = 288223,
  [SMALL_STATE(7395)] = 288265,
  [SMALL_STATE(7396)] = 288307,
  [SMALL_STATE(7397)] = 288349,
  [SMALL_STATE(7398)] = 288391,
  [SMALL_STATE(7399)] = 288433,
  [SMALL_STATE(7400)] = 288475,
  [SMALL_STATE(7401)] = 288517,
  [SMALL_STATE(7402)] = 288559,
  [SMALL_STATE(7403)] = 288601,
  [SMALL_STATE(7404)] = 288643,
  [SMALL_STATE(7405)] = 288685,
  [SMALL_STATE(7406)] = 288727,
  [SMALL_STATE(7407)] = 288769,
  [SMALL_STATE(7408)] = 288811,
  [SMALL_STATE(7409)] = 288853,
  [SMALL_STATE(7410)] = 288895,
  [SMALL_STATE(7411)] = 288937,
  [SMALL_STATE(7412)] = 288979,
  [SMALL_STATE(7413)] = 289021,
  [SMALL_STATE(7414)] = 289063,
  [SMALL_STATE(7415)] = 289105,
  [SMALL_STATE(7416)] = 289147,
  [SMALL_STATE(7417)] = 289189,
  [SMALL_STATE(7418)] = 289231,
  [SMALL_STATE(7419)] = 289273,
  [SMALL_STATE(7420)] = 289315,
  [SMALL_STATE(7421)] = 289357,
  [SMALL_STATE(7422)] = 289399,
  [SMALL_STATE(7423)] = 289443,
  [SMALL_STATE(7424)] = 289485,
  [SMALL_STATE(7425)] = 289527,
  [SMALL_STATE(7426)] = 289569,
  [SMALL_STATE(7427)] = 289611,
  [SMALL_STATE(7428)] = 289653,
  [SMALL_STATE(7429)] = 289695,
  [SMALL_STATE(7430)] = 289737,
  [SMALL_STATE(7431)] = 289779,
  [SMALL_STATE(7432)] = 289839,
  [SMALL_STATE(7433)] = 289881,
  [SMALL_STATE(7434)] = 289923,
  [SMALL_STATE(7435)] = 289965,
  [SMALL_STATE(7436)] = 290007,
  [SMALL_STATE(7437)] = 290049,
  [SMALL_STATE(7438)] = 290091,
  [SMALL_STATE(7439)] = 290135,
  [SMALL_STATE(7440)] = 290177,
  [SMALL_STATE(7441)] = 290219,
  [SMALL_STATE(7442)] = 290261,
  [SMALL_STATE(7443)] = 290303,
  [SMALL_STATE(7444)] = 290345,
  [SMALL_STATE(7445)] = 290387,
  [SMALL_STATE(7446)] = 290429,
  [SMALL_STATE(7447)] = 290471,
  [SMALL_STATE(7448)] = 290513,
  [SMALL_STATE(7449)] = 290555,
  [SMALL_STATE(7450)] = 290597,
  [SMALL_STATE(7451)] = 290639,
  [SMALL_STATE(7452)] = 290681,
  [SMALL_STATE(7453)] = 290723,
  [SMALL_STATE(7454)] = 290765,
  [SMALL_STATE(7455)] = 290809,
  [SMALL_STATE(7456)] = 290851,
  [SMALL_STATE(7457)] = 290893,
  [SMALL_STATE(7458)] = 290935,
  [SMALL_STATE(7459)] = 290977,
  [SMALL_STATE(7460)] = 291019,
  [SMALL_STATE(7461)] = 291061,
  [SMALL_STATE(7462)] = 291103,
  [SMALL_STATE(7463)] = 291145,
  [SMALL_STATE(7464)] = 291187,
  [SMALL_STATE(7465)] = 291229,
  [SMALL_STATE(7466)] = 291271,
  [SMALL_STATE(7467)] = 291313,
  [SMALL_STATE(7468)] = 291355,
  [SMALL_STATE(7469)] = 291397,
  [SMALL_STATE(7470)] = 291439,
  [SMALL_STATE(7471)] = 291481,
  [SMALL_STATE(7472)] = 291525,
  [SMALL_STATE(7473)] = 291567,
  [SMALL_STATE(7474)] = 291623,
  [SMALL_STATE(7475)] = 291667,
  [SMALL_STATE(7476)] = 291709,
  [SMALL_STATE(7477)] = 291751,
  [SMALL_STATE(7478)] = 291793,
  [SMALL_STATE(7479)] = 291835,
  [SMALL_STATE(7480)] = 291895,
  [SMALL_STATE(7481)] = 291937,
  [SMALL_STATE(7482)] = 291979,
  [SMALL_STATE(7483)] = 292021,
  [SMALL_STATE(7484)] = 292063,
  [SMALL_STATE(7485)] = 292105,
  [SMALL_STATE(7486)] = 292147,
  [SMALL_STATE(7487)] = 292189,
  [SMALL_STATE(7488)] = 292249,
  [SMALL_STATE(7489)] = 292291,
  [SMALL_STATE(7490)] = 292333,
  [SMALL_STATE(7491)] = 292375,
  [SMALL_STATE(7492)] = 292417,
  [SMALL_STATE(7493)] = 292459,
  [SMALL_STATE(7494)] = 292501,
  [SMALL_STATE(7495)] = 292543,
  [SMALL_STATE(7496)] = 292587,
  [SMALL_STATE(7497)] = 292629,
  [SMALL_STATE(7498)] = 292671,
  [SMALL_STATE(7499)] = 292713,
  [SMALL_STATE(7500)] = 292755,
  [SMALL_STATE(7501)] = 292797,
  [SMALL_STATE(7502)] = 292839,
  [SMALL_STATE(7503)] = 292881,
  [SMALL_STATE(7504)] = 292923,
  [SMALL_STATE(7505)] = 292965,
  [SMALL_STATE(7506)] = 293007,
  [SMALL_STATE(7507)] = 293063,
  [SMALL_STATE(7508)] = 293105,
  [SMALL_STATE(7509)] = 293147,
  [SMALL_STATE(7510)] = 293189,
  [SMALL_STATE(7511)] = 293231,
  [SMALL_STATE(7512)] = 293291,
  [SMALL_STATE(7513)] = 293333,
  [SMALL_STATE(7514)] = 293375,
  [SMALL_STATE(7515)] = 293417,
  [SMALL_STATE(7516)] = 293459,
  [SMALL_STATE(7517)] = 293501,
  [SMALL_STATE(7518)] = 293543,
  [SMALL_STATE(7519)] = 293585,
  [SMALL_STATE(7520)] = 293627,
  [SMALL_STATE(7521)] = 293669,
  [SMALL_STATE(7522)] = 293711,
  [SMALL_STATE(7523)] = 293753,
  [SMALL_STATE(7524)] = 293795,
  [SMALL_STATE(7525)] = 293837,
  [SMALL_STATE(7526)] = 293879,
  [SMALL_STATE(7527)] = 293923,
  [SMALL_STATE(7528)] = 293965,
  [SMALL_STATE(7529)] = 294007,
  [SMALL_STATE(7530)] = 294049,
  [SMALL_STATE(7531)] = 294091,
  [SMALL_STATE(7532)] = 294133,
  [SMALL_STATE(7533)] = 294175,
  [SMALL_STATE(7534)] = 294217,
  [SMALL_STATE(7535)] = 294259,
  [SMALL_STATE(7536)] = 294303,
  [SMALL_STATE(7537)] = 294345,
  [SMALL_STATE(7538)] = 294405,
  [SMALL_STATE(7539)] = 294461,
  [SMALL_STATE(7540)] = 294503,
  [SMALL_STATE(7541)] = 294545,
  [SMALL_STATE(7542)] = 294587,
  [SMALL_STATE(7543)] = 294629,
  [SMALL_STATE(7544)] = 294671,
  [SMALL_STATE(7545)] = 294713,
  [SMALL_STATE(7546)] = 294755,
  [SMALL_STATE(7547)] = 294799,
  [SMALL_STATE(7548)] = 294841,
  [SMALL_STATE(7549)] = 294883,
  [SMALL_STATE(7550)] = 294925,
  [SMALL_STATE(7551)] = 294967,
  [SMALL_STATE(7552)] = 295009,
  [SMALL_STATE(7553)] = 295051,
  [SMALL_STATE(7554)] = 295093,
  [SMALL_STATE(7555)] = 295135,
  [SMALL_STATE(7556)] = 295177,
  [SMALL_STATE(7557)] = 295219,
  [SMALL_STATE(7558)] = 295261,
  [SMALL_STATE(7559)] = 295303,
  [SMALL_STATE(7560)] = 295345,
  [SMALL_STATE(7561)] = 295389,
  [SMALL_STATE(7562)] = 295449,
  [SMALL_STATE(7563)] = 295491,
  [SMALL_STATE(7564)] = 295533,
  [SMALL_STATE(7565)] = 295575,
  [SMALL_STATE(7566)] = 295617,
  [SMALL_STATE(7567)] = 295673,
  [SMALL_STATE(7568)] = 295717,
  [SMALL_STATE(7569)] = 295759,
  [SMALL_STATE(7570)] = 295801,
  [SMALL_STATE(7571)] = 295843,
  [SMALL_STATE(7572)] = 295885,
  [SMALL_STATE(7573)] = 295927,
  [SMALL_STATE(7574)] = 295969,
  [SMALL_STATE(7575)] = 296013,
  [SMALL_STATE(7576)] = 296055,
  [SMALL_STATE(7577)] = 296097,
  [SMALL_STATE(7578)] = 296139,
  [SMALL_STATE(7579)] = 296181,
  [SMALL_STATE(7580)] = 296223,
  [SMALL_STATE(7581)] = 296265,
  [SMALL_STATE(7582)] = 296307,
  [SMALL_STATE(7583)] = 296349,
  [SMALL_STATE(7584)] = 296391,
  [SMALL_STATE(7585)] = 296433,
  [SMALL_STATE(7586)] = 296475,
  [SMALL_STATE(7587)] = 296517,
  [SMALL_STATE(7588)] = 296559,
  [SMALL_STATE(7589)] = 296601,
  [SMALL_STATE(7590)] = 296643,
  [SMALL_STATE(7591)] = 296685,
  [SMALL_STATE(7592)] = 296727,
  [SMALL_STATE(7593)] = 296771,
  [SMALL_STATE(7594)] = 296813,
  [SMALL_STATE(7595)] = 296855,
  [SMALL_STATE(7596)] = 296897,
  [SMALL_STATE(7597)] = 296940,
  [SMALL_STATE(7598)] = 296999,
  [SMALL_STATE(7599)] = 297040,
  [SMALL_STATE(7600)] = 297081,
  [SMALL_STATE(7601)] = 297122,
  [SMALL_STATE(7602)] = 297167,
  [SMALL_STATE(7603)] = 297208,
  [SMALL_STATE(7604)] = 297249,
  [SMALL_STATE(7605)] = 297290,
  [SMALL_STATE(7606)] = 297331,
  [SMALL_STATE(7607)] = 297372,
  [SMALL_STATE(7608)] = 297413,
  [SMALL_STATE(7609)] = 297454,
  [SMALL_STATE(7610)] = 297495,
  [SMALL_STATE(7611)] = 297538,
  [SMALL_STATE(7612)] = 297579,
  [SMALL_STATE(7613)] = 297620,
  [SMALL_STATE(7614)] = 297661,
  [SMALL_STATE(7615)] = 297704,
  [SMALL_STATE(7616)] = 297745,
  [SMALL_STATE(7617)] = 297788,
  [SMALL_STATE(7618)] = 297829,
  [SMALL_STATE(7619)] = 297888,
  [SMALL_STATE(7620)] = 297931,
  [SMALL_STATE(7621)] = 297974,
  [SMALL_STATE(7622)] = 298033,
  [SMALL_STATE(7623)] = 298074,
  [SMALL_STATE(7624)] = 298115,
  [SMALL_STATE(7625)] = 298156,
  [SMALL_STATE(7626)] = 298205,
  [SMALL_STATE(7627)] = 298246,
  [SMALL_STATE(7628)] = 298287,
  [SMALL_STATE(7629)] = 298328,
  [SMALL_STATE(7630)] = 298369,
  [SMALL_STATE(7631)] = 298410,
  [SMALL_STATE(7632)] = 298451,
  [SMALL_STATE(7633)] = 298494,
  [SMALL_STATE(7634)] = 298537,
  [SMALL_STATE(7635)] = 298578,
  [SMALL_STATE(7636)] = 298619,
  [SMALL_STATE(7637)] = 298660,
  [SMALL_STATE(7638)] = 298701,
  [SMALL_STATE(7639)] = 298742,
  [SMALL_STATE(7640)] = 298783,
  [SMALL_STATE(7641)] = 298824,
  [SMALL_STATE(7642)] = 298865,
  [SMALL_STATE(7643)] = 298906,
  [SMALL_STATE(7644)] = 298947,
  [SMALL_STATE(7645)] = 298988,
  [SMALL_STATE(7646)] = 299029,
  [SMALL_STATE(7647)] = 299088,
  [SMALL_STATE(7648)] = 299131,
  [SMALL_STATE(7649)] = 299174,
  [SMALL_STATE(7650)] = 299215,
  [SMALL_STATE(7651)] = 299256,
  [SMALL_STATE(7652)] = 299315,
  [SMALL_STATE(7653)] = 299356,
  [SMALL_STATE(7654)] = 299397,
  [SMALL_STATE(7655)] = 299438,
  [SMALL_STATE(7656)] = 299487,
  [SMALL_STATE(7657)] = 299528,
  [SMALL_STATE(7658)] = 299569,
  [SMALL_STATE(7659)] = 299610,
  [SMALL_STATE(7660)] = 299651,
  [SMALL_STATE(7661)] = 299692,
  [SMALL_STATE(7662)] = 299735,
  [SMALL_STATE(7663)] = 299798,
  [SMALL_STATE(7664)] = 299847,
  [SMALL_STATE(7665)] = 299888,
  [SMALL_STATE(7666)] = 299929,
  [SMALL_STATE(7667)] = 299970,
  [SMALL_STATE(7668)] = 300013,
  [SMALL_STATE(7669)] = 300054,
  [SMALL_STATE(7670)] = 300095,
  [SMALL_STATE(7671)] = 300136,
  [SMALL_STATE(7672)] = 300195,
  [SMALL_STATE(7673)] = 300254,
  [SMALL_STATE(7674)] = 300295,
  [SMALL_STATE(7675)] = 300336,
  [SMALL_STATE(7676)] = 300377,
  [SMALL_STATE(7677)] = 300418,
  [SMALL_STATE(7678)] = 300459,
  [SMALL_STATE(7679)] = 300500,
  [SMALL_STATE(7680)] = 300541,
  [SMALL_STATE(7681)] = 300582,
  [SMALL_STATE(7682)] = 300625,
  [SMALL_STATE(7683)] = 300666,
  [SMALL_STATE(7684)] = 300707,
  [SMALL_STATE(7685)] = 300750,
  [SMALL_STATE(7686)] = 300791,
  [SMALL_STATE(7687)] = 300832,
  [SMALL_STATE(7688)] = 300873,
  [SMALL_STATE(7689)] = 300914,
  [SMALL_STATE(7690)] = 300955,
  [SMALL_STATE(7691)] = 301014,
  [SMALL_STATE(7692)] = 301055,
  [SMALL_STATE(7693)] = 301096,
  [SMALL_STATE(7694)] = 301137,
  [SMALL_STATE(7695)] = 301196,
  [SMALL_STATE(7696)] = 301237,
  [SMALL_STATE(7697)] = 301278,
  [SMALL_STATE(7698)] = 301318,
  [SMALL_STATE(7699)] = 301360,
  [SMALL_STATE(7700)] = 301402,
  [SMALL_STATE(7701)] = 301444,
  [SMALL_STATE(7702)] = 301486,
  [SMALL_STATE(7703)] = 301528,
  [SMALL_STATE(7704)] = 301568,
  [SMALL_STATE(7705)] = 301608,
  [SMALL_STATE(7706)] = 301648,
  [SMALL_STATE(7707)] = 301688,
  [SMALL_STATE(7708)] = 301730,
  [SMALL_STATE(7709)] = 301772,
  [SMALL_STATE(7710)] = 301812,
  [SMALL_STATE(7711)] = 301854,
  [SMALL_STATE(7712)] = 301896,
  [SMALL_STATE(7713)] = 301938,
  [SMALL_STATE(7714)] = 301978,
  [SMALL_STATE(7715)] = 302036,
  [SMALL_STATE(7716)] = 302078,
  [SMALL_STATE(7717)] = 302118,
  [SMALL_STATE(7718)] = 302180,
  [SMALL_STATE(7719)] = 302220,
  [SMALL_STATE(7720)] = 302262,
  [SMALL_STATE(7721)] = 302302,
  [SMALL_STATE(7722)] = 302342,
  [SMALL_STATE(7723)] = 302384,
  [SMALL_STATE(7724)] = 302426,
  [SMALL_STATE(7725)] = 302468,
  [SMALL_STATE(7726)] = 302508,
  [SMALL_STATE(7727)] = 302550,
  [SMALL_STATE(7728)] = 302592,
  [SMALL_STATE(7729)] = 302634,
  [SMALL_STATE(7730)] = 302674,
  [SMALL_STATE(7731)] = 302714,
  [SMALL_STATE(7732)] = 302754,
  [SMALL_STATE(7733)] = 302794,
  [SMALL_STATE(7734)] = 302836,
  [SMALL_STATE(7735)] = 302878,
  [SMALL_STATE(7736)] = 302920,
  [SMALL_STATE(7737)] = 302962,
  [SMALL_STATE(7738)] = 303002,
  [SMALL_STATE(7739)] = 303042,
  [SMALL_STATE(7740)] = 303082,
  [SMALL_STATE(7741)] = 303122,
  [SMALL_STATE(7742)] = 303164,
  [SMALL_STATE(7743)] = 303206,
  [SMALL_STATE(7744)] = 303246,
  [SMALL_STATE(7745)] = 303286,
  [SMALL_STATE(7746)] = 303326,
  [SMALL_STATE(7747)] = 303366,
  [SMALL_STATE(7748)] = 303408,
  [SMALL_STATE(7749)] = 303448,
  [SMALL_STATE(7750)] = 303488,
  [SMALL_STATE(7751)] = 303528,
  [SMALL_STATE(7752)] = 303568,
  [SMALL_STATE(7753)] = 303608,
  [SMALL_STATE(7754)] = 303648,
  [SMALL_STATE(7755)] = 303690,
  [SMALL_STATE(7756)] = 303730,
  [SMALL_STATE(7757)] = 303772,
  [SMALL_STATE(7758)] = 303814,
  [SMALL_STATE(7759)] = 303856,
  [SMALL_STATE(7760)] = 303898,
  [SMALL_STATE(7761)] = 303940,
  [SMALL_STATE(7762)] = 303980,
  [SMALL_STATE(7763)] = 304020,
  [SMALL_STATE(7764)] = 304060,
  [SMALL_STATE(7765)] = 304100,
  [SMALL_STATE(7766)] = 304142,
  [SMALL_STATE(7767)] = 304184,
  [SMALL_STATE(7768)] = 304224,
  [SMALL_STATE(7769)] = 304264,
  [SMALL_STATE(7770)] = 304306,
  [SMALL_STATE(7771)] = 304348,
  [SMALL_STATE(7772)] = 304390,
  [SMALL_STATE(7773)] = 304448,
  [SMALL_STATE(7774)] = 304488,
  [SMALL_STATE(7775)] = 304528,
  [SMALL_STATE(7776)] = 304570,
  [SMALL_STATE(7777)] = 304610,
  [SMALL_STATE(7778)] = 304650,
  [SMALL_STATE(7779)] = 304690,
  [SMALL_STATE(7780)] = 304732,
  [SMALL_STATE(7781)] = 304772,
  [SMALL_STATE(7782)] = 304830,
  [SMALL_STATE(7783)] = 304872,
  [SMALL_STATE(7784)] = 304912,
  [SMALL_STATE(7785)] = 304954,
  [SMALL_STATE(7786)] = 304998,
  [SMALL_STATE(7787)] = 305044,
  [SMALL_STATE(7788)] = 305084,
  [SMALL_STATE(7789)] = 305126,
  [SMALL_STATE(7790)] = 305168,
  [SMALL_STATE(7791)] = 305210,
  [SMALL_STATE(7792)] = 305252,
  [SMALL_STATE(7793)] = 305294,
  [SMALL_STATE(7794)] = 305334,
  [SMALL_STATE(7795)] = 305376,
  [SMALL_STATE(7796)] = 305418,
  [SMALL_STATE(7797)] = 305458,
  [SMALL_STATE(7798)] = 305500,
  [SMALL_STATE(7799)] = 305542,
  [SMALL_STATE(7800)] = 305584,
  [SMALL_STATE(7801)] = 305626,
  [SMALL_STATE(7802)] = 305668,
  [SMALL_STATE(7803)] = 305708,
  [SMALL_STATE(7804)] = 305770,
  [SMALL_STATE(7805)] = 305812,
  [SMALL_STATE(7806)] = 305854,
  [SMALL_STATE(7807)] = 305896,
  [SMALL_STATE(7808)] = 305954,
  [SMALL_STATE(7809)] = 305994,
  [SMALL_STATE(7810)] = 306044,
  [SMALL_STATE(7811)] = 306084,
  [SMALL_STATE(7812)] = 306124,
  [SMALL_STATE(7813)] = 306168,
  [SMALL_STATE(7814)] = 306210,
  [SMALL_STATE(7815)] = 306250,
  [SMALL_STATE(7816)] = 306290,
  [SMALL_STATE(7817)] = 306332,
  [SMALL_STATE(7818)] = 306374,
  [SMALL_STATE(7819)] = 306414,
  [SMALL_STATE(7820)] = 306456,
  [SMALL_STATE(7821)] = 306496,
  [SMALL_STATE(7822)] = 306538,
  [SMALL_STATE(7823)] = 306580,
  [SMALL_STATE(7824)] = 306620,
  [SMALL_STATE(7825)] = 306660,
  [SMALL_STATE(7826)] = 306702,
  [SMALL_STATE(7827)] = 306744,
  [SMALL_STATE(7828)] = 306802,
  [SMALL_STATE(7829)] = 306842,
  [SMALL_STATE(7830)] = 306884,
  [SMALL_STATE(7831)] = 306926,
  [SMALL_STATE(7832)] = 306966,
  [SMALL_STATE(7833)] = 307006,
  [SMALL_STATE(7834)] = 307048,
  [SMALL_STATE(7835)] = 307088,
  [SMALL_STATE(7836)] = 307128,
  [SMALL_STATE(7837)] = 307168,
  [SMALL_STATE(7838)] = 307210,
  [SMALL_STATE(7839)] = 307256,
  [SMALL_STATE(7840)] = 307296,
  [SMALL_STATE(7841)] = 307338,
  [SMALL_STATE(7842)] = 307380,
  [SMALL_STATE(7843)] = 307422,
  [SMALL_STATE(7844)] = 307464,
  [SMALL_STATE(7845)] = 307504,
  [SMALL_STATE(7846)] = 307546,
  [SMALL_STATE(7847)] = 307592,
  [SMALL_STATE(7848)] = 307634,
  [SMALL_STATE(7849)] = 307674,
  [SMALL_STATE(7850)] = 307714,
  [SMALL_STATE(7851)] = 307754,
  [SMALL_STATE(7852)] = 307794,
  [SMALL_STATE(7853)] = 307836,
  [SMALL_STATE(7854)] = 307876,
  [SMALL_STATE(7855)] = 307916,
  [SMALL_STATE(7856)] = 307958,
  [SMALL_STATE(7857)] = 307998,
  [SMALL_STATE(7858)] = 308038,
  [SMALL_STATE(7859)] = 308080,
  [SMALL_STATE(7860)] = 308120,
  [SMALL_STATE(7861)] = 308162,
  [SMALL_STATE(7862)] = 308202,
  [SMALL_STATE(7863)] = 308242,
  [SMALL_STATE(7864)] = 308282,
  [SMALL_STATE(7865)] = 308324,
  [SMALL_STATE(7866)] = 308366,
  [SMALL_STATE(7867)] = 308406,
  [SMALL_STATE(7868)] = 308446,
  [SMALL_STATE(7869)] = 308486,
  [SMALL_STATE(7870)] = 308528,
  [SMALL_STATE(7871)] = 308570,
  [SMALL_STATE(7872)] = 308612,
  [SMALL_STATE(7873)] = 308652,
  [SMALL_STATE(7874)] = 308692,
  [SMALL_STATE(7875)] = 308732,
  [SMALL_STATE(7876)] = 308771,
  [SMALL_STATE(7877)] = 308820,
  [SMALL_STATE(7878)] = 308859,
  [SMALL_STATE(7879)] = 308898,
  [SMALL_STATE(7880)] = 308939,
  [SMALL_STATE(7881)] = 308978,
  [SMALL_STATE(7882)] = 309017,
  [SMALL_STATE(7883)] = 309056,
  [SMALL_STATE(7884)] = 309095,
  [SMALL_STATE(7885)] = 309134,
  [SMALL_STATE(7886)] = 309173,
  [SMALL_STATE(7887)] = 309214,
  [SMALL_STATE(7888)] = 309253,
  [SMALL_STATE(7889)] = 309292,
  [SMALL_STATE(7890)] = 309333,
  [SMALL_STATE(7891)] = 309372,
  [SMALL_STATE(7892)] = 309411,
  [SMALL_STATE(7893)] = 309450,
  [SMALL_STATE(7894)] = 309491,
  [SMALL_STATE(7895)] = 309530,
  [SMALL_STATE(7896)] = 309587,
  [SMALL_STATE(7897)] = 309626,
  [SMALL_STATE(7898)] = 309665,
  [SMALL_STATE(7899)] = 309704,
  [SMALL_STATE(7900)] = 309743,
  [SMALL_STATE(7901)] = 309782,
  [SMALL_STATE(7902)] = 309821,
  [SMALL_STATE(7903)] = 309860,
  [SMALL_STATE(7904)] = 309899,
  [SMALL_STATE(7905)] = 309938,
  [SMALL_STATE(7906)] = 309979,
  [SMALL_STATE(7907)] = 310020,
  [SMALL_STATE(7908)] = 310061,
  [SMALL_STATE(7909)] = 310118,
  [SMALL_STATE(7910)] = 310157,
  [SMALL_STATE(7911)] = 310198,
  [SMALL_STATE(7912)] = 310239,
  [SMALL_STATE(7913)] = 310278,
  [SMALL_STATE(7914)] = 310317,
  [SMALL_STATE(7915)] = 310356,
  [SMALL_STATE(7916)] = 310397,
  [SMALL_STATE(7917)] = 310436,
  [SMALL_STATE(7918)] = 310475,
  [SMALL_STATE(7919)] = 310514,
  [SMALL_STATE(7920)] = 310553,
  [SMALL_STATE(7921)] = 310592,
  [SMALL_STATE(7922)] = 310631,
  [SMALL_STATE(7923)] = 310670,
  [SMALL_STATE(7924)] = 310709,
  [SMALL_STATE(7925)] = 310748,
  [SMALL_STATE(7926)] = 310787,
  [SMALL_STATE(7927)] = 310826,
  [SMALL_STATE(7928)] = 310865,
  [SMALL_STATE(7929)] = 310906,
  [SMALL_STATE(7930)] = 310945,
  [SMALL_STATE(7931)] = 310988,
  [SMALL_STATE(7932)] = 311029,
  [SMALL_STATE(7933)] = 311068,
  [SMALL_STATE(7934)] = 311107,
  [SMALL_STATE(7935)] = 311146,
  [SMALL_STATE(7936)] = 311187,
  [SMALL_STATE(7937)] = 311234,
  [SMALL_STATE(7938)] = 311275,
  [SMALL_STATE(7939)] = 311314,
  [SMALL_STATE(7940)] = 311353,
  [SMALL_STATE(7941)] = 311408,
  [SMALL_STATE(7942)] = 311447,
  [SMALL_STATE(7943)] = 311493,
  [SMALL_STATE(7944)] = 311535,
  [SMALL_STATE(7945)] = 311573,
  [SMALL_STATE(7946)] = 311611,
  [SMALL_STATE(7947)] = 311649,
  [SMALL_STATE(7948)] = 311687,
  [SMALL_STATE(7949)] = 311725,
  [SMALL_STATE(7950)] = 311763,
  [SMALL_STATE(7951)] = 311801,
  [SMALL_STATE(7952)] = 311847,
  [SMALL_STATE(7953)] = 311885,
  [SMALL_STATE(7954)] = 311923,
  [SMALL_STATE(7955)] = 311961,
  [SMALL_STATE(7956)] = 311999,
  [SMALL_STATE(7957)] = 312037,
  [SMALL_STATE(7958)] = 312075,
  [SMALL_STATE(7959)] = 312113,
  [SMALL_STATE(7960)] = 312151,
  [SMALL_STATE(7961)] = 312189,
  [SMALL_STATE(7962)] = 312227,
  [SMALL_STATE(7963)] = 312265,
  [SMALL_STATE(7964)] = 312303,
  [SMALL_STATE(7965)] = 312343,
  [SMALL_STATE(7966)] = 312381,
  [SMALL_STATE(7967)] = 312419,
  [SMALL_STATE(7968)] = 312457,
  [SMALL_STATE(7969)] = 312511,
  [SMALL_STATE(7970)] = 312549,
  [SMALL_STATE(7971)] = 312587,
  [SMALL_STATE(7972)] = 312625,
  [SMALL_STATE(7973)] = 312663,
  [SMALL_STATE(7974)] = 312701,
  [SMALL_STATE(7975)] = 312739,
  [SMALL_STATE(7976)] = 312777,
  [SMALL_STATE(7977)] = 312817,
  [SMALL_STATE(7978)] = 312855,
  [SMALL_STATE(7979)] = 312893,
  [SMALL_STATE(7980)] = 312931,
  [SMALL_STATE(7981)] = 312969,
  [SMALL_STATE(7982)] = 313007,
  [SMALL_STATE(7983)] = 313045,
  [SMALL_STATE(7984)] = 313083,
  [SMALL_STATE(7985)] = 313121,
  [SMALL_STATE(7986)] = 313159,
  [SMALL_STATE(7987)] = 313197,
  [SMALL_STATE(7988)] = 313235,
  [SMALL_STATE(7989)] = 313273,
  [SMALL_STATE(7990)] = 313311,
  [SMALL_STATE(7991)] = 313349,
  [SMALL_STATE(7992)] = 313387,
  [SMALL_STATE(7993)] = 313425,
  [SMALL_STATE(7994)] = 313465,
  [SMALL_STATE(7995)] = 313503,
  [SMALL_STATE(7996)] = 313541,
  [SMALL_STATE(7997)] = 313579,
  [SMALL_STATE(7998)] = 313617,
  [SMALL_STATE(7999)] = 313655,
  [SMALL_STATE(8000)] = 313693,
  [SMALL_STATE(8001)] = 313731,
  [SMALL_STATE(8002)] = 313769,
  [SMALL_STATE(8003)] = 313807,
  [SMALL_STATE(8004)] = 313845,
  [SMALL_STATE(8005)] = 313883,
  [SMALL_STATE(8006)] = 313921,
  [SMALL_STATE(8007)] = 313959,
  [SMALL_STATE(8008)] = 313997,
  [SMALL_STATE(8009)] = 314035,
  [SMALL_STATE(8010)] = 314073,
  [SMALL_STATE(8011)] = 314111,
  [SMALL_STATE(8012)] = 314151,
  [SMALL_STATE(8013)] = 314205,
  [SMALL_STATE(8014)] = 314243,
  [SMALL_STATE(8015)] = 314281,
  [SMALL_STATE(8016)] = 314319,
  [SMALL_STATE(8017)] = 314357,
  [SMALL_STATE(8018)] = 314397,
  [SMALL_STATE(8019)] = 314457,
  [SMALL_STATE(8020)] = 314495,
  [SMALL_STATE(8021)] = 314535,
  [SMALL_STATE(8022)] = 314573,
  [SMALL_STATE(8023)] = 314613,
  [SMALL_STATE(8024)] = 314655,
  [SMALL_STATE(8025)] = 314693,
  [SMALL_STATE(8026)] = 314733,
  [SMALL_STATE(8027)] = 314771,
  [SMALL_STATE(8028)] = 314809,
  [SMALL_STATE(8029)] = 314847,
  [SMALL_STATE(8030)] = 314885,
  [SMALL_STATE(8031)] = 314923,
  [SMALL_STATE(8032)] = 314963,
  [SMALL_STATE(8033)] = 315001,
  [SMALL_STATE(8034)] = 315039,
  [SMALL_STATE(8035)] = 315077,
  [SMALL_STATE(8036)] = 315115,
  [SMALL_STATE(8037)] = 315153,
  [SMALL_STATE(8038)] = 315191,
  [SMALL_STATE(8039)] = 315229,
  [SMALL_STATE(8040)] = 315267,
  [SMALL_STATE(8041)] = 315305,
  [SMALL_STATE(8042)] = 315345,
  [SMALL_STATE(8043)] = 315383,
  [SMALL_STATE(8044)] = 315437,
  [SMALL_STATE(8045)] = 315475,
  [SMALL_STATE(8046)] = 315513,
  [SMALL_STATE(8047)] = 315551,
  [SMALL_STATE(8048)] = 315589,
  [SMALL_STATE(8049)] = 315627,
  [SMALL_STATE(8050)] = 315665,
  [SMALL_STATE(8051)] = 315707,
  [SMALL_STATE(8052)] = 315745,
  [SMALL_STATE(8053)] = 315783,
  [SMALL_STATE(8054)] = 315821,
  [SMALL_STATE(8055)] = 315859,
  [SMALL_STATE(8056)] = 315897,
  [SMALL_STATE(8057)] = 315937,
  [SMALL_STATE(8058)] = 315975,
  [SMALL_STATE(8059)] = 316013,
  [SMALL_STATE(8060)] = 316053,
  [SMALL_STATE(8061)] = 316091,
  [SMALL_STATE(8062)] = 316131,
  [SMALL_STATE(8063)] = 316171,
  [SMALL_STATE(8064)] = 316209,
  [SMALL_STATE(8065)] = 316247,
  [SMALL_STATE(8066)] = 316285,
  [SMALL_STATE(8067)] = 316323,
  [SMALL_STATE(8068)] = 316361,
  [SMALL_STATE(8069)] = 316399,
  [SMALL_STATE(8070)] = 316439,
  [SMALL_STATE(8071)] = 316477,
  [SMALL_STATE(8072)] = 316517,
  [SMALL_STATE(8073)] = 316555,
  [SMALL_STATE(8074)] = 316593,
  [SMALL_STATE(8075)] = 316633,
  [SMALL_STATE(8076)] = 316673,
  [SMALL_STATE(8077)] = 316711,
  [SMALL_STATE(8078)] = 316749,
  [SMALL_STATE(8079)] = 316787,
  [SMALL_STATE(8080)] = 316827,
  [SMALL_STATE(8081)] = 316865,
  [SMALL_STATE(8082)] = 316903,
  [SMALL_STATE(8083)] = 316941,
  [SMALL_STATE(8084)] = 316979,
  [SMALL_STATE(8085)] = 317017,
  [SMALL_STATE(8086)] = 317055,
  [SMALL_STATE(8087)] = 317093,
  [SMALL_STATE(8088)] = 317131,
  [SMALL_STATE(8089)] = 317169,
  [SMALL_STATE(8090)] = 317207,
  [SMALL_STATE(8091)] = 317245,
  [SMALL_STATE(8092)] = 317283,
  [SMALL_STATE(8093)] = 317321,
  [SMALL_STATE(8094)] = 317359,
  [SMALL_STATE(8095)] = 317397,
  [SMALL_STATE(8096)] = 317435,
  [SMALL_STATE(8097)] = 317475,
  [SMALL_STATE(8098)] = 317515,
  [SMALL_STATE(8099)] = 317553,
  [SMALL_STATE(8100)] = 317591,
  [SMALL_STATE(8101)] = 317629,
  [SMALL_STATE(8102)] = 317671,
  [SMALL_STATE(8103)] = 317709,
  [SMALL_STATE(8104)] = 317747,
  [SMALL_STATE(8105)] = 317785,
  [SMALL_STATE(8106)] = 317823,
  [SMALL_STATE(8107)] = 317861,
  [SMALL_STATE(8108)] = 317899,
  [SMALL_STATE(8109)] = 317937,
  [SMALL_STATE(8110)] = 317991,
  [SMALL_STATE(8111)] = 318031,
  [SMALL_STATE(8112)] = 318069,
  [SMALL_STATE(8113)] = 318111,
  [SMALL_STATE(8114)] = 318165,
  [SMALL_STATE(8115)] = 318203,
  [SMALL_STATE(8116)] = 318241,
  [SMALL_STATE(8117)] = 318281,
  [SMALL_STATE(8118)] = 318319,
  [SMALL_STATE(8119)] = 318375,
  [SMALL_STATE(8120)] = 318421,
  [SMALL_STATE(8121)] = 318459,
  [SMALL_STATE(8122)] = 318497,
  [SMALL_STATE(8123)] = 318535,
  [SMALL_STATE(8124)] = 318573,
  [SMALL_STATE(8125)] = 318611,
  [SMALL_STATE(8126)] = 318649,
  [SMALL_STATE(8127)] = 318687,
  [SMALL_STATE(8128)] = 318725,
  [SMALL_STATE(8129)] = 318763,
  [SMALL_STATE(8130)] = 318801,
  [SMALL_STATE(8131)] = 318841,
  [SMALL_STATE(8132)] = 318879,
  [SMALL_STATE(8133)] = 318917,
  [SMALL_STATE(8134)] = 318957,
  [SMALL_STATE(8135)] = 318997,
  [SMALL_STATE(8136)] = 319035,
  [SMALL_STATE(8137)] = 319073,
  [SMALL_STATE(8138)] = 319113,
  [SMALL_STATE(8139)] = 319153,
  [SMALL_STATE(8140)] = 319199,
  [SMALL_STATE(8141)] = 319237,
  [SMALL_STATE(8142)] = 319277,
  [SMALL_STATE(8143)] = 319315,
  [SMALL_STATE(8144)] = 319353,
  [SMALL_STATE(8145)] = 319391,
  [SMALL_STATE(8146)] = 319431,
  [SMALL_STATE(8147)] = 319469,
  [SMALL_STATE(8148)] = 319507,
  [SMALL_STATE(8149)] = 319545,
  [SMALL_STATE(8150)] = 319583,
  [SMALL_STATE(8151)] = 319621,
  [SMALL_STATE(8152)] = 319659,
  [SMALL_STATE(8153)] = 319699,
  [SMALL_STATE(8154)] = 319736,
  [SMALL_STATE(8155)] = 319773,
  [SMALL_STATE(8156)] = 319812,
  [SMALL_STATE(8157)] = 319849,
  [SMALL_STATE(8158)] = 319888,
  [SMALL_STATE(8159)] = 319925,
  [SMALL_STATE(8160)] = 319962,
  [SMALL_STATE(8161)] = 319999,
  [SMALL_STATE(8162)] = 320036,
  [SMALL_STATE(8163)] = 320073,
  [SMALL_STATE(8164)] = 320112,
  [SMALL_STATE(8165)] = 320149,
  [SMALL_STATE(8166)] = 320186,
  [SMALL_STATE(8167)] = 320223,
  [SMALL_STATE(8168)] = 320260,
  [SMALL_STATE(8169)] = 320297,
  [SMALL_STATE(8170)] = 320334,
  [SMALL_STATE(8171)] = 320371,
  [SMALL_STATE(8172)] = 320408,
  [SMALL_STATE(8173)] = 320445,
  [SMALL_STATE(8174)] = 320482,
  [SMALL_STATE(8175)] = 320519,
  [SMALL_STATE(8176)] = 320556,
  [SMALL_STATE(8177)] = 320593,
  [SMALL_STATE(8178)] = 320630,
  [SMALL_STATE(8179)] = 320667,
  [SMALL_STATE(8180)] = 320704,
  [SMALL_STATE(8181)] = 320741,
  [SMALL_STATE(8182)] = 320778,
  [SMALL_STATE(8183)] = 320815,
  [SMALL_STATE(8184)] = 320852,
  [SMALL_STATE(8185)] = 320889,
  [SMALL_STATE(8186)] = 320926,
  [SMALL_STATE(8187)] = 320963,
  [SMALL_STATE(8188)] = 321002,
  [SMALL_STATE(8189)] = 321039,
  [SMALL_STATE(8190)] = 321076,
  [SMALL_STATE(8191)] = 321113,
  [SMALL_STATE(8192)] = 321150,
  [SMALL_STATE(8193)] = 321187,
  [SMALL_STATE(8194)] = 321224,
  [SMALL_STATE(8195)] = 321261,
  [SMALL_STATE(8196)] = 321298,
  [SMALL_STATE(8197)] = 321335,
  [SMALL_STATE(8198)] = 321374,
  [SMALL_STATE(8199)] = 321411,
  [SMALL_STATE(8200)] = 321448,
  [SMALL_STATE(8201)] = 321485,
  [SMALL_STATE(8202)] = 321522,
  [SMALL_STATE(8203)] = 321559,
  [SMALL_STATE(8204)] = 321604,
  [SMALL_STATE(8205)] = 321641,
  [SMALL_STATE(8206)] = 321678,
  [SMALL_STATE(8207)] = 321719,
  [SMALL_STATE(8208)] = 321756,
  [SMALL_STATE(8209)] = 321793,
  [SMALL_STATE(8210)] = 321830,
  [SMALL_STATE(8211)] = 321869,
  [SMALL_STATE(8212)] = 321928,
  [SMALL_STATE(8213)] = 321965,
  [SMALL_STATE(8214)] = 322010,
  [SMALL_STATE(8215)] = 322047,
  [SMALL_STATE(8216)] = 322084,
  [SMALL_STATE(8217)] = 322121,
  [SMALL_STATE(8218)] = 322158,
  [SMALL_STATE(8219)] = 322195,
  [SMALL_STATE(8220)] = 322232,
  [SMALL_STATE(8221)] = 322269,
  [SMALL_STATE(8222)] = 322306,
  [SMALL_STATE(8223)] = 322343,
  [SMALL_STATE(8224)] = 322380,
  [SMALL_STATE(8225)] = 322417,
  [SMALL_STATE(8226)] = 322454,
  [SMALL_STATE(8227)] = 322491,
  [SMALL_STATE(8228)] = 322528,
  [SMALL_STATE(8229)] = 322565,
  [SMALL_STATE(8230)] = 322602,
  [SMALL_STATE(8231)] = 322639,
  [SMALL_STATE(8232)] = 322676,
  [SMALL_STATE(8233)] = 322715,
  [SMALL_STATE(8234)] = 322752,
  [SMALL_STATE(8235)] = 322789,
  [SMALL_STATE(8236)] = 322828,
  [SMALL_STATE(8237)] = 322865,
  [SMALL_STATE(8238)] = 322902,
  [SMALL_STATE(8239)] = 322955,
  [SMALL_STATE(8240)] = 323008,
  [SMALL_STATE(8241)] = 323045,
  [SMALL_STATE(8242)] = 323084,
  [SMALL_STATE(8243)] = 323121,
  [SMALL_STATE(8244)] = 323158,
  [SMALL_STATE(8245)] = 323195,
  [SMALL_STATE(8246)] = 323232,
  [SMALL_STATE(8247)] = 323269,
  [SMALL_STATE(8248)] = 323306,
  [SMALL_STATE(8249)] = 323343,
  [SMALL_STATE(8250)] = 323380,
  [SMALL_STATE(8251)] = 323417,
  [SMALL_STATE(8252)] = 323454,
  [SMALL_STATE(8253)] = 323491,
  [SMALL_STATE(8254)] = 323528,
  [SMALL_STATE(8255)] = 323565,
  [SMALL_STATE(8256)] = 323602,
  [SMALL_STATE(8257)] = 323639,
  [SMALL_STATE(8258)] = 323676,
  [SMALL_STATE(8259)] = 323713,
  [SMALL_STATE(8260)] = 323750,
  [SMALL_STATE(8261)] = 323787,
  [SMALL_STATE(8262)] = 323840,
  [SMALL_STATE(8263)] = 323877,
  [SMALL_STATE(8264)] = 323914,
  [SMALL_STATE(8265)] = 323951,
  [SMALL_STATE(8266)] = 323988,
  [SMALL_STATE(8267)] = 324025,
  [SMALL_STATE(8268)] = 324064,
  [SMALL_STATE(8269)] = 324101,
  [SMALL_STATE(8270)] = 324138,
  [SMALL_STATE(8271)] = 324175,
  [SMALL_STATE(8272)] = 324212,
  [SMALL_STATE(8273)] = 324249,
  [SMALL_STATE(8274)] = 324286,
  [SMALL_STATE(8275)] = 324323,
  [SMALL_STATE(8276)] = 324360,
  [SMALL_STATE(8277)] = 324397,
  [SMALL_STATE(8278)] = 324436,
  [SMALL_STATE(8279)] = 324473,
  [SMALL_STATE(8280)] = 324510,
  [SMALL_STATE(8281)] = 324547,
  [SMALL_STATE(8282)] = 324584,
  [SMALL_STATE(8283)] = 324623,
  [SMALL_STATE(8284)] = 324660,
  [SMALL_STATE(8285)] = 324697,
  [SMALL_STATE(8286)] = 324734,
  [SMALL_STATE(8287)] = 324771,
  [SMALL_STATE(8288)] = 324812,
  [SMALL_STATE(8289)] = 324849,
  [SMALL_STATE(8290)] = 324886,
  [SMALL_STATE(8291)] = 324925,
  [SMALL_STATE(8292)] = 324962,
  [SMALL_STATE(8293)] = 324999,
  [SMALL_STATE(8294)] = 325036,
  [SMALL_STATE(8295)] = 325073,
  [SMALL_STATE(8296)] = 325110,
  [SMALL_STATE(8297)] = 325147,
  [SMALL_STATE(8298)] = 325184,
  [SMALL_STATE(8299)] = 325223,
  [SMALL_STATE(8300)] = 325260,
  [SMALL_STATE(8301)] = 325313,
  [SMALL_STATE(8302)] = 325354,
  [SMALL_STATE(8303)] = 325391,
  [SMALL_STATE(8304)] = 325428,
  [SMALL_STATE(8305)] = 325465,
  [SMALL_STATE(8306)] = 325504,
  [SMALL_STATE(8307)] = 325541,
  [SMALL_STATE(8308)] = 325578,
  [SMALL_STATE(8309)] = 325615,
  [SMALL_STATE(8310)] = 325652,
  [SMALL_STATE(8311)] = 325705,
  [SMALL_STATE(8312)] = 325742,
  [SMALL_STATE(8313)] = 325801,
  [SMALL_STATE(8314)] = 325838,
  [SMALL_STATE(8315)] = 325891,
  [SMALL_STATE(8316)] = 325928,
  [SMALL_STATE(8317)] = 325965,
  [SMALL_STATE(8318)] = 326004,
  [SMALL_STATE(8319)] = 326043,
  [SMALL_STATE(8320)] = 326080,
  [SMALL_STATE(8321)] = 326117,
  [SMALL_STATE(8322)] = 326154,
  [SMALL_STATE(8323)] = 326191,
  [SMALL_STATE(8324)] = 326228,
  [SMALL_STATE(8325)] = 326267,
  [SMALL_STATE(8326)] = 326304,
  [SMALL_STATE(8327)] = 326341,
  [SMALL_STATE(8328)] = 326400,
  [SMALL_STATE(8329)] = 326437,
  [SMALL_STATE(8330)] = 326474,
  [SMALL_STATE(8331)] = 326513,
  [SMALL_STATE(8332)] = 326550,
  [SMALL_STATE(8333)] = 326587,
  [SMALL_STATE(8334)] = 326624,
  [SMALL_STATE(8335)] = 326661,
  [SMALL_STATE(8336)] = 326700,
  [SMALL_STATE(8337)] = 326737,
  [SMALL_STATE(8338)] = 326774,
  [SMALL_STATE(8339)] = 326811,
  [SMALL_STATE(8340)] = 326848,
  [SMALL_STATE(8341)] = 326887,
  [SMALL_STATE(8342)] = 326924,
  [SMALL_STATE(8343)] = 326961,
  [SMALL_STATE(8344)] = 327000,
  [SMALL_STATE(8345)] = 327039,
  [SMALL_STATE(8346)] = 327076,
  [SMALL_STATE(8347)] = 327113,
  [SMALL_STATE(8348)] = 327150,
  [SMALL_STATE(8349)] = 327187,
  [SMALL_STATE(8350)] = 327224,
  [SMALL_STATE(8351)] = 327261,
  [SMALL_STATE(8352)] = 327298,
  [SMALL_STATE(8353)] = 327335,
  [SMALL_STATE(8354)] = 327372,
  [SMALL_STATE(8355)] = 327409,
  [SMALL_STATE(8356)] = 327446,
  [SMALL_STATE(8357)] = 327483,
  [SMALL_STATE(8358)] = 327522,
  [SMALL_STATE(8359)] = 327561,
  [SMALL_STATE(8360)] = 327598,
  [SMALL_STATE(8361)] = 327635,
  [SMALL_STATE(8362)] = 327672,
  [SMALL_STATE(8363)] = 327711,
  [SMALL_STATE(8364)] = 327748,
  [SMALL_STATE(8365)] = 327785,
  [SMALL_STATE(8366)] = 327822,
  [SMALL_STATE(8367)] = 327859,
  [SMALL_STATE(8368)] = 327896,
  [SMALL_STATE(8369)] = 327933,
  [SMALL_STATE(8370)] = 327970,
  [SMALL_STATE(8371)] = 328007,
  [SMALL_STATE(8372)] = 328044,
  [SMALL_STATE(8373)] = 328081,
  [SMALL_STATE(8374)] = 328118,
  [SMALL_STATE(8375)] = 328155,
  [SMALL_STATE(8376)] = 328192,
  [SMALL_STATE(8377)] = 328229,
  [SMALL_STATE(8378)] = 328266,
  [SMALL_STATE(8379)] = 328303,
  [SMALL_STATE(8380)] = 328340,
  [SMALL_STATE(8381)] = 328377,
  [SMALL_STATE(8382)] = 328414,
  [SMALL_STATE(8383)] = 328451,
  [SMALL_STATE(8384)] = 328488,
  [SMALL_STATE(8385)] = 328525,
  [SMALL_STATE(8386)] = 328562,
  [SMALL_STATE(8387)] = 328599,
  [SMALL_STATE(8388)] = 328636,
  [SMALL_STATE(8389)] = 328673,
  [SMALL_STATE(8390)] = 328710,
  [SMALL_STATE(8391)] = 328747,
  [SMALL_STATE(8392)] = 328784,
  [SMALL_STATE(8393)] = 328821,
  [SMALL_STATE(8394)] = 328858,
  [SMALL_STATE(8395)] = 328895,
  [SMALL_STATE(8396)] = 328932,
  [SMALL_STATE(8397)] = 328971,
  [SMALL_STATE(8398)] = 329010,
  [SMALL_STATE(8399)] = 329049,
  [SMALL_STATE(8400)] = 329102,
  [SMALL_STATE(8401)] = 329138,
  [SMALL_STATE(8402)] = 329174,
  [SMALL_STATE(8403)] = 329210,
  [SMALL_STATE(8404)] = 329246,
  [SMALL_STATE(8405)] = 329282,
  [SMALL_STATE(8406)] = 329318,
  [SMALL_STATE(8407)] = 329354,
  [SMALL_STATE(8408)] = 329390,
  [SMALL_STATE(8409)] = 329426,
  [SMALL_STATE(8410)] = 329462,
  [SMALL_STATE(8411)] = 329498,
  [SMALL_STATE(8412)] = 329534,
  [SMALL_STATE(8413)] = 329570,
  [SMALL_STATE(8414)] = 329606,
  [SMALL_STATE(8415)] = 329642,
  [SMALL_STATE(8416)] = 329678,
  [SMALL_STATE(8417)] = 329714,
  [SMALL_STATE(8418)] = 329750,
  [SMALL_STATE(8419)] = 329786,
  [SMALL_STATE(8420)] = 329822,
  [SMALL_STATE(8421)] = 329858,
  [SMALL_STATE(8422)] = 329894,
  [SMALL_STATE(8423)] = 329930,
  [SMALL_STATE(8424)] = 329966,
  [SMALL_STATE(8425)] = 330002,
  [SMALL_STATE(8426)] = 330038,
  [SMALL_STATE(8427)] = 330074,
  [SMALL_STATE(8428)] = 330112,
  [SMALL_STATE(8429)] = 330148,
  [SMALL_STATE(8430)] = 330184,
  [SMALL_STATE(8431)] = 330220,
  [SMALL_STATE(8432)] = 330256,
  [SMALL_STATE(8433)] = 330292,
  [SMALL_STATE(8434)] = 330328,
  [SMALL_STATE(8435)] = 330364,
  [SMALL_STATE(8436)] = 330400,
  [SMALL_STATE(8437)] = 330436,
  [SMALL_STATE(8438)] = 330472,
  [SMALL_STATE(8439)] = 330508,
  [SMALL_STATE(8440)] = 330544,
  [SMALL_STATE(8441)] = 330580,
  [SMALL_STATE(8442)] = 330616,
  [SMALL_STATE(8443)] = 330652,
  [SMALL_STATE(8444)] = 330688,
  [SMALL_STATE(8445)] = 330724,
  [SMALL_STATE(8446)] = 330760,
  [SMALL_STATE(8447)] = 330796,
  [SMALL_STATE(8448)] = 330832,
  [SMALL_STATE(8449)] = 330868,
  [SMALL_STATE(8450)] = 330904,
  [SMALL_STATE(8451)] = 330940,
  [SMALL_STATE(8452)] = 330976,
  [SMALL_STATE(8453)] = 331012,
  [SMALL_STATE(8454)] = 331048,
  [SMALL_STATE(8455)] = 331084,
  [SMALL_STATE(8456)] = 331120,
  [SMALL_STATE(8457)] = 331156,
  [SMALL_STATE(8458)] = 331192,
  [SMALL_STATE(8459)] = 331228,
  [SMALL_STATE(8460)] = 331264,
  [SMALL_STATE(8461)] = 331300,
  [SMALL_STATE(8462)] = 331336,
  [SMALL_STATE(8463)] = 331372,
  [SMALL_STATE(8464)] = 331408,
  [SMALL_STATE(8465)] = 331444,
  [SMALL_STATE(8466)] = 331480,
  [SMALL_STATE(8467)] = 331516,
  [SMALL_STATE(8468)] = 331552,
  [SMALL_STATE(8469)] = 331588,
  [SMALL_STATE(8470)] = 331624,
  [SMALL_STATE(8471)] = 331660,
  [SMALL_STATE(8472)] = 331696,
  [SMALL_STATE(8473)] = 331732,
  [SMALL_STATE(8474)] = 331768,
  [SMALL_STATE(8475)] = 331804,
  [SMALL_STATE(8476)] = 331840,
  [SMALL_STATE(8477)] = 331876,
  [SMALL_STATE(8478)] = 331912,
  [SMALL_STATE(8479)] = 331948,
  [SMALL_STATE(8480)] = 331984,
  [SMALL_STATE(8481)] = 332020,
  [SMALL_STATE(8482)] = 332056,
  [SMALL_STATE(8483)] = 332092,
  [SMALL_STATE(8484)] = 332128,
  [SMALL_STATE(8485)] = 332164,
  [SMALL_STATE(8486)] = 332200,
  [SMALL_STATE(8487)] = 332236,
  [SMALL_STATE(8488)] = 332272,
  [SMALL_STATE(8489)] = 332308,
  [SMALL_STATE(8490)] = 332344,
  [SMALL_STATE(8491)] = 332380,
  [SMALL_STATE(8492)] = 332416,
  [SMALL_STATE(8493)] = 332452,
  [SMALL_STATE(8494)] = 332488,
  [SMALL_STATE(8495)] = 332524,
  [SMALL_STATE(8496)] = 332562,
  [SMALL_STATE(8497)] = 332598,
  [SMALL_STATE(8498)] = 332634,
  [SMALL_STATE(8499)] = 332670,
  [SMALL_STATE(8500)] = 332706,
  [SMALL_STATE(8501)] = 332742,
  [SMALL_STATE(8502)] = 332778,
  [SMALL_STATE(8503)] = 332814,
  [SMALL_STATE(8504)] = 332850,
  [SMALL_STATE(8505)] = 332886,
  [SMALL_STATE(8506)] = 332922,
  [SMALL_STATE(8507)] = 332958,
  [SMALL_STATE(8508)] = 332994,
  [SMALL_STATE(8509)] = 333030,
  [SMALL_STATE(8510)] = 333066,
  [SMALL_STATE(8511)] = 333104,
  [SMALL_STATE(8512)] = 333140,
  [SMALL_STATE(8513)] = 333176,
  [SMALL_STATE(8514)] = 333212,
  [SMALL_STATE(8515)] = 333248,
  [SMALL_STATE(8516)] = 333286,
  [SMALL_STATE(8517)] = 333324,
  [SMALL_STATE(8518)] = 333360,
  [SMALL_STATE(8519)] = 333396,
  [SMALL_STATE(8520)] = 333432,
  [SMALL_STATE(8521)] = 333468,
  [SMALL_STATE(8522)] = 333506,
  [SMALL_STATE(8523)] = 333542,
  [SMALL_STATE(8524)] = 333578,
  [SMALL_STATE(8525)] = 333614,
  [SMALL_STATE(8526)] = 333650,
  [SMALL_STATE(8527)] = 333686,
  [SMALL_STATE(8528)] = 333722,
  [SMALL_STATE(8529)] = 333758,
  [SMALL_STATE(8530)] = 333794,
  [SMALL_STATE(8531)] = 333830,
  [SMALL_STATE(8532)] = 333866,
  [SMALL_STATE(8533)] = 333902,
  [SMALL_STATE(8534)] = 333938,
  [SMALL_STATE(8535)] = 333974,
  [SMALL_STATE(8536)] = 334010,
  [SMALL_STATE(8537)] = 334046,
  [SMALL_STATE(8538)] = 334082,
  [SMALL_STATE(8539)] = 334118,
  [SMALL_STATE(8540)] = 334154,
  [SMALL_STATE(8541)] = 334190,
  [SMALL_STATE(8542)] = 334226,
  [SMALL_STATE(8543)] = 334262,
  [SMALL_STATE(8544)] = 334298,
  [SMALL_STATE(8545)] = 334334,
  [SMALL_STATE(8546)] = 334370,
  [SMALL_STATE(8547)] = 334408,
  [SMALL_STATE(8548)] = 334446,
  [SMALL_STATE(8549)] = 334482,
  [SMALL_STATE(8550)] = 334518,
  [SMALL_STATE(8551)] = 334554,
  [SMALL_STATE(8552)] = 334592,
  [SMALL_STATE(8553)] = 334628,
  [SMALL_STATE(8554)] = 334668,
  [SMALL_STATE(8555)] = 334704,
  [SMALL_STATE(8556)] = 334740,
  [SMALL_STATE(8557)] = 334776,
  [SMALL_STATE(8558)] = 334812,
  [SMALL_STATE(8559)] = 334848,
  [SMALL_STATE(8560)] = 334884,
  [SMALL_STATE(8561)] = 334920,
  [SMALL_STATE(8562)] = 334956,
  [SMALL_STATE(8563)] = 334992,
  [SMALL_STATE(8564)] = 335028,
  [SMALL_STATE(8565)] = 335064,
  [SMALL_STATE(8566)] = 335100,
  [SMALL_STATE(8567)] = 335136,
  [SMALL_STATE(8568)] = 335172,
  [SMALL_STATE(8569)] = 335208,
  [SMALL_STATE(8570)] = 335244,
  [SMALL_STATE(8571)] = 335280,
  [SMALL_STATE(8572)] = 335318,
  [SMALL_STATE(8573)] = 335354,
  [SMALL_STATE(8574)] = 335390,
  [SMALL_STATE(8575)] = 335426,
  [SMALL_STATE(8576)] = 335478,
  [SMALL_STATE(8577)] = 335514,
  [SMALL_STATE(8578)] = 335550,
  [SMALL_STATE(8579)] = 335586,
  [SMALL_STATE(8580)] = 335624,
  [SMALL_STATE(8581)] = 335660,
  [SMALL_STATE(8582)] = 335696,
  [SMALL_STATE(8583)] = 335732,
  [SMALL_STATE(8584)] = 335768,
  [SMALL_STATE(8585)] = 335804,
  [SMALL_STATE(8586)] = 335840,
  [SMALL_STATE(8587)] = 335876,
  [SMALL_STATE(8588)] = 335912,
  [SMALL_STATE(8589)] = 335948,
  [SMALL_STATE(8590)] = 335984,
  [SMALL_STATE(8591)] = 336020,
  [SMALL_STATE(8592)] = 336056,
  [SMALL_STATE(8593)] = 336094,
  [SMALL_STATE(8594)] = 336130,
  [SMALL_STATE(8595)] = 336166,
  [SMALL_STATE(8596)] = 336202,
  [SMALL_STATE(8597)] = 336238,
  [SMALL_STATE(8598)] = 336274,
  [SMALL_STATE(8599)] = 336310,
  [SMALL_STATE(8600)] = 336346,
  [SMALL_STATE(8601)] = 336382,
  [SMALL_STATE(8602)] = 336418,
  [SMALL_STATE(8603)] = 336454,
  [SMALL_STATE(8604)] = 336490,
  [SMALL_STATE(8605)] = 336526,
  [SMALL_STATE(8606)] = 336564,
  [SMALL_STATE(8607)] = 336600,
  [SMALL_STATE(8608)] = 336636,
  [SMALL_STATE(8609)] = 336672,
  [SMALL_STATE(8610)] = 336710,
  [SMALL_STATE(8611)] = 336746,
  [SMALL_STATE(8612)] = 336782,
  [SMALL_STATE(8613)] = 336840,
  [SMALL_STATE(8614)] = 336876,
  [SMALL_STATE(8615)] = 336914,
  [SMALL_STATE(8616)] = 336950,
  [SMALL_STATE(8617)] = 336986,
  [SMALL_STATE(8618)] = 337022,
  [SMALL_STATE(8619)] = 337058,
  [SMALL_STATE(8620)] = 337094,
  [SMALL_STATE(8621)] = 337130,
  [SMALL_STATE(8622)] = 337166,
  [SMALL_STATE(8623)] = 337202,
  [SMALL_STATE(8624)] = 337238,
  [SMALL_STATE(8625)] = 337274,
  [SMALL_STATE(8626)] = 337310,
  [SMALL_STATE(8627)] = 337346,
  [SMALL_STATE(8628)] = 337382,
  [SMALL_STATE(8629)] = 337418,
  [SMALL_STATE(8630)] = 337454,
  [SMALL_STATE(8631)] = 337490,
  [SMALL_STATE(8632)] = 337526,
  [SMALL_STATE(8633)] = 337562,
  [SMALL_STATE(8634)] = 337598,
  [SMALL_STATE(8635)] = 337634,
  [SMALL_STATE(8636)] = 337670,
  [SMALL_STATE(8637)] = 337706,
  [SMALL_STATE(8638)] = 337742,
  [SMALL_STATE(8639)] = 337778,
  [SMALL_STATE(8640)] = 337814,
  [SMALL_STATE(8641)] = 337850,
  [SMALL_STATE(8642)] = 337886,
  [SMALL_STATE(8643)] = 337922,
  [SMALL_STATE(8644)] = 337958,
  [SMALL_STATE(8645)] = 338016,
  [SMALL_STATE(8646)] = 338052,
  [SMALL_STATE(8647)] = 338088,
  [SMALL_STATE(8648)] = 338124,
  [SMALL_STATE(8649)] = 338160,
  [SMALL_STATE(8650)] = 338196,
  [SMALL_STATE(8651)] = 338232,
  [SMALL_STATE(8652)] = 338284,
  [SMALL_STATE(8653)] = 338320,
  [SMALL_STATE(8654)] = 338356,
  [SMALL_STATE(8655)] = 338392,
  [SMALL_STATE(8656)] = 338428,
  [SMALL_STATE(8657)] = 338464,
  [SMALL_STATE(8658)] = 338500,
  [SMALL_STATE(8659)] = 338536,
  [SMALL_STATE(8660)] = 338574,
  [SMALL_STATE(8661)] = 338610,
  [SMALL_STATE(8662)] = 338646,
  [SMALL_STATE(8663)] = 338682,
  [SMALL_STATE(8664)] = 338718,
  [SMALL_STATE(8665)] = 338754,
  [SMALL_STATE(8666)] = 338790,
  [SMALL_STATE(8667)] = 338826,
  [SMALL_STATE(8668)] = 338862,
  [SMALL_STATE(8669)] = 338900,
  [SMALL_STATE(8670)] = 338936,
  [SMALL_STATE(8671)] = 338972,
  [SMALL_STATE(8672)] = 339008,
  [SMALL_STATE(8673)] = 339044,
  [SMALL_STATE(8674)] = 339080,
  [SMALL_STATE(8675)] = 339116,
  [SMALL_STATE(8676)] = 339152,
  [SMALL_STATE(8677)] = 339188,
  [SMALL_STATE(8678)] = 339224,
  [SMALL_STATE(8679)] = 339260,
  [SMALL_STATE(8680)] = 339296,
  [SMALL_STATE(8681)] = 339332,
  [SMALL_STATE(8682)] = 339368,
  [SMALL_STATE(8683)] = 339404,
  [SMALL_STATE(8684)] = 339442,
  [SMALL_STATE(8685)] = 339478,
  [SMALL_STATE(8686)] = 339514,
  [SMALL_STATE(8687)] = 339550,
  [SMALL_STATE(8688)] = 339586,
  [SMALL_STATE(8689)] = 339622,
  [SMALL_STATE(8690)] = 339658,
  [SMALL_STATE(8691)] = 339694,
  [SMALL_STATE(8692)] = 339730,
  [SMALL_STATE(8693)] = 339766,
  [SMALL_STATE(8694)] = 339802,
  [SMALL_STATE(8695)] = 339838,
  [SMALL_STATE(8696)] = 339874,
  [SMALL_STATE(8697)] = 339910,
  [SMALL_STATE(8698)] = 339946,
  [SMALL_STATE(8699)] = 339982,
  [SMALL_STATE(8700)] = 340018,
  [SMALL_STATE(8701)] = 340054,
  [SMALL_STATE(8702)] = 340092,
  [SMALL_STATE(8703)] = 340128,
  [SMALL_STATE(8704)] = 340164,
  [SMALL_STATE(8705)] = 340200,
  [SMALL_STATE(8706)] = 340236,
  [SMALL_STATE(8707)] = 340272,
  [SMALL_STATE(8708)] = 340308,
  [SMALL_STATE(8709)] = 340346,
  [SMALL_STATE(8710)] = 340382,
  [SMALL_STATE(8711)] = 340418,
  [SMALL_STATE(8712)] = 340454,
  [SMALL_STATE(8713)] = 340490,
  [SMALL_STATE(8714)] = 340526,
  [SMALL_STATE(8715)] = 340564,
  [SMALL_STATE(8716)] = 340600,
  [SMALL_STATE(8717)] = 340636,
  [SMALL_STATE(8718)] = 340672,
  [SMALL_STATE(8719)] = 340710,
  [SMALL_STATE(8720)] = 340748,
  [SMALL_STATE(8721)] = 340784,
  [SMALL_STATE(8722)] = 340820,
  [SMALL_STATE(8723)] = 340856,
  [SMALL_STATE(8724)] = 340892,
  [SMALL_STATE(8725)] = 340928,
  [SMALL_STATE(8726)] = 340964,
  [SMALL_STATE(8727)] = 341000,
  [SMALL_STATE(8728)] = 341036,
  [SMALL_STATE(8729)] = 341072,
  [SMALL_STATE(8730)] = 341108,
  [SMALL_STATE(8731)] = 341144,
  [SMALL_STATE(8732)] = 341180,
  [SMALL_STATE(8733)] = 341215,
  [SMALL_STATE(8734)] = 341250,
  [SMALL_STATE(8735)] = 341285,
  [SMALL_STATE(8736)] = 341336,
  [SMALL_STATE(8737)] = 341371,
  [SMALL_STATE(8738)] = 341406,
  [SMALL_STATE(8739)] = 341441,
  [SMALL_STATE(8740)] = 341476,
  [SMALL_STATE(8741)] = 341511,
  [SMALL_STATE(8742)] = 341546,
  [SMALL_STATE(8743)] = 341581,
  [SMALL_STATE(8744)] = 341616,
  [SMALL_STATE(8745)] = 341651,
  [SMALL_STATE(8746)] = 341686,
  [SMALL_STATE(8747)] = 341721,
  [SMALL_STATE(8748)] = 341756,
  [SMALL_STATE(8749)] = 341791,
  [SMALL_STATE(8750)] = 341826,
  [SMALL_STATE(8751)] = 341861,
  [SMALL_STATE(8752)] = 341896,
  [SMALL_STATE(8753)] = 341931,
  [SMALL_STATE(8754)] = 341966,
  [SMALL_STATE(8755)] = 342001,
  [SMALL_STATE(8756)] = 342036,
  [SMALL_STATE(8757)] = 342071,
  [SMALL_STATE(8758)] = 342106,
  [SMALL_STATE(8759)] = 342141,
  [SMALL_STATE(8760)] = 342198,
  [SMALL_STATE(8761)] = 342233,
  [SMALL_STATE(8762)] = 342268,
  [SMALL_STATE(8763)] = 342303,
  [SMALL_STATE(8764)] = 342338,
  [SMALL_STATE(8765)] = 342373,
  [SMALL_STATE(8766)] = 342408,
  [SMALL_STATE(8767)] = 342443,
  [SMALL_STATE(8768)] = 342478,
  [SMALL_STATE(8769)] = 342513,
  [SMALL_STATE(8770)] = 342548,
  [SMALL_STATE(8771)] = 342583,
  [SMALL_STATE(8772)] = 342618,
  [SMALL_STATE(8773)] = 342653,
  [SMALL_STATE(8774)] = 342688,
  [SMALL_STATE(8775)] = 342745,
  [SMALL_STATE(8776)] = 342780,
  [SMALL_STATE(8777)] = 342815,
  [SMALL_STATE(8778)] = 342850,
  [SMALL_STATE(8779)] = 342885,
  [SMALL_STATE(8780)] = 342920,
  [SMALL_STATE(8781)] = 342977,
  [SMALL_STATE(8782)] = 343012,
  [SMALL_STATE(8783)] = 343047,
  [SMALL_STATE(8784)] = 343082,
  [SMALL_STATE(8785)] = 343117,
  [SMALL_STATE(8786)] = 343152,
  [SMALL_STATE(8787)] = 343209,
  [SMALL_STATE(8788)] = 343244,
  [SMALL_STATE(8789)] = 343279,
  [SMALL_STATE(8790)] = 343314,
  [SMALL_STATE(8791)] = 343349,
  [SMALL_STATE(8792)] = 343384,
  [SMALL_STATE(8793)] = 343419,
  [SMALL_STATE(8794)] = 343454,
  [SMALL_STATE(8795)] = 343489,
  [SMALL_STATE(8796)] = 343524,
  [SMALL_STATE(8797)] = 343581,
  [SMALL_STATE(8798)] = 343638,
  [SMALL_STATE(8799)] = 343673,
  [SMALL_STATE(8800)] = 343708,
  [SMALL_STATE(8801)] = 343743,
  [SMALL_STATE(8802)] = 343778,
  [SMALL_STATE(8803)] = 343813,
  [SMALL_STATE(8804)] = 343848,
  [SMALL_STATE(8805)] = 343883,
  [SMALL_STATE(8806)] = 343918,
  [SMALL_STATE(8807)] = 343953,
  [SMALL_STATE(8808)] = 343988,
  [SMALL_STATE(8809)] = 344023,
  [SMALL_STATE(8810)] = 344058,
  [SMALL_STATE(8811)] = 344093,
  [SMALL_STATE(8812)] = 344128,
  [SMALL_STATE(8813)] = 344163,
  [SMALL_STATE(8814)] = 344198,
  [SMALL_STATE(8815)] = 344233,
  [SMALL_STATE(8816)] = 344268,
  [SMALL_STATE(8817)] = 344303,
  [SMALL_STATE(8818)] = 344338,
  [SMALL_STATE(8819)] = 344373,
  [SMALL_STATE(8820)] = 344408,
  [SMALL_STATE(8821)] = 344443,
  [SMALL_STATE(8822)] = 344478,
  [SMALL_STATE(8823)] = 344513,
  [SMALL_STATE(8824)] = 344548,
  [SMALL_STATE(8825)] = 344583,
  [SMALL_STATE(8826)] = 344618,
  [SMALL_STATE(8827)] = 344653,
  [SMALL_STATE(8828)] = 344688,
  [SMALL_STATE(8829)] = 344723,
  [SMALL_STATE(8830)] = 344758,
  [SMALL_STATE(8831)] = 344793,
  [SMALL_STATE(8832)] = 344828,
  [SMALL_STATE(8833)] = 344863,
  [SMALL_STATE(8834)] = 344898,
  [SMALL_STATE(8835)] = 344933,
  [SMALL_STATE(8836)] = 344968,
  [SMALL_STATE(8837)] = 345003,
  [SMALL_STATE(8838)] = 345038,
  [SMALL_STATE(8839)] = 345073,
  [SMALL_STATE(8840)] = 345108,
  [SMALL_STATE(8841)] = 345143,
  [SMALL_STATE(8842)] = 345178,
  [SMALL_STATE(8843)] = 345213,
  [SMALL_STATE(8844)] = 345248,
  [SMALL_STATE(8845)] = 345283,
  [SMALL_STATE(8846)] = 345318,
  [SMALL_STATE(8847)] = 345353,
  [SMALL_STATE(8848)] = 345388,
  [SMALL_STATE(8849)] = 345445,
  [SMALL_STATE(8850)] = 345480,
  [SMALL_STATE(8851)] = 345515,
  [SMALL_STATE(8852)] = 345550,
  [SMALL_STATE(8853)] = 345585,
  [SMALL_STATE(8854)] = 345620,
  [SMALL_STATE(8855)] = 345655,
  [SMALL_STATE(8856)] = 345690,
  [SMALL_STATE(8857)] = 345725,
  [SMALL_STATE(8858)] = 345760,
  [SMALL_STATE(8859)] = 345795,
  [SMALL_STATE(8860)] = 345830,
  [SMALL_STATE(8861)] = 345865,
  [SMALL_STATE(8862)] = 345900,
  [SMALL_STATE(8863)] = 345935,
  [SMALL_STATE(8864)] = 345970,
  [SMALL_STATE(8865)] = 346005,
  [SMALL_STATE(8866)] = 346040,
  [SMALL_STATE(8867)] = 346075,
  [SMALL_STATE(8868)] = 346110,
  [SMALL_STATE(8869)] = 346145,
  [SMALL_STATE(8870)] = 346180,
  [SMALL_STATE(8871)] = 346215,
  [SMALL_STATE(8872)] = 346250,
  [SMALL_STATE(8873)] = 346285,
  [SMALL_STATE(8874)] = 346320,
  [SMALL_STATE(8875)] = 346355,
  [SMALL_STATE(8876)] = 346390,
  [SMALL_STATE(8877)] = 346425,
  [SMALL_STATE(8878)] = 346460,
  [SMALL_STATE(8879)] = 346511,
  [SMALL_STATE(8880)] = 346546,
  [SMALL_STATE(8881)] = 346581,
  [SMALL_STATE(8882)] = 346616,
  [SMALL_STATE(8883)] = 346651,
  [SMALL_STATE(8884)] = 346688,
  [SMALL_STATE(8885)] = 346723,
  [SMALL_STATE(8886)] = 346758,
  [SMALL_STATE(8887)] = 346793,
  [SMALL_STATE(8888)] = 346830,
  [SMALL_STATE(8889)] = 346865,
  [SMALL_STATE(8890)] = 346900,
  [SMALL_STATE(8891)] = 346935,
  [SMALL_STATE(8892)] = 346970,
  [SMALL_STATE(8893)] = 347005,
  [SMALL_STATE(8894)] = 347042,
  [SMALL_STATE(8895)] = 347077,
  [SMALL_STATE(8896)] = 347112,
  [SMALL_STATE(8897)] = 347147,
  [SMALL_STATE(8898)] = 347182,
  [SMALL_STATE(8899)] = 347217,
  [SMALL_STATE(8900)] = 347252,
  [SMALL_STATE(8901)] = 347287,
  [SMALL_STATE(8902)] = 347322,
  [SMALL_STATE(8903)] = 347357,
  [SMALL_STATE(8904)] = 347392,
  [SMALL_STATE(8905)] = 347427,
  [SMALL_STATE(8906)] = 347462,
  [SMALL_STATE(8907)] = 347497,
  [SMALL_STATE(8908)] = 347532,
  [SMALL_STATE(8909)] = 347567,
  [SMALL_STATE(8910)] = 347602,
  [SMALL_STATE(8911)] = 347637,
  [SMALL_STATE(8912)] = 347672,
  [SMALL_STATE(8913)] = 347707,
  [SMALL_STATE(8914)] = 347742,
  [SMALL_STATE(8915)] = 347777,
  [SMALL_STATE(8916)] = 347812,
  [SMALL_STATE(8917)] = 347847,
  [SMALL_STATE(8918)] = 347882,
  [SMALL_STATE(8919)] = 347917,
  [SMALL_STATE(8920)] = 347952,
  [SMALL_STATE(8921)] = 348009,
  [SMALL_STATE(8922)] = 348044,
  [SMALL_STATE(8923)] = 348079,
  [SMALL_STATE(8924)] = 348114,
  [SMALL_STATE(8925)] = 348149,
  [SMALL_STATE(8926)] = 348184,
  [SMALL_STATE(8927)] = 348219,
  [SMALL_STATE(8928)] = 348276,
  [SMALL_STATE(8929)] = 348311,
  [SMALL_STATE(8930)] = 348346,
  [SMALL_STATE(8931)] = 348381,
  [SMALL_STATE(8932)] = 348416,
  [SMALL_STATE(8933)] = 348451,
  [SMALL_STATE(8934)] = 348486,
  [SMALL_STATE(8935)] = 348523,
  [SMALL_STATE(8936)] = 348558,
  [SMALL_STATE(8937)] = 348593,
  [SMALL_STATE(8938)] = 348630,
  [SMALL_STATE(8939)] = 348665,
  [SMALL_STATE(8940)] = 348722,
  [SMALL_STATE(8941)] = 348757,
  [SMALL_STATE(8942)] = 348792,
  [SMALL_STATE(8943)] = 348827,
  [SMALL_STATE(8944)] = 348862,
  [SMALL_STATE(8945)] = 348897,
  [SMALL_STATE(8946)] = 348932,
  [SMALL_STATE(8947)] = 348967,
  [SMALL_STATE(8948)] = 349002,
  [SMALL_STATE(8949)] = 349037,
  [SMALL_STATE(8950)] = 349072,
  [SMALL_STATE(8951)] = 349107,
  [SMALL_STATE(8952)] = 349142,
  [SMALL_STATE(8953)] = 349177,
  [SMALL_STATE(8954)] = 349212,
  [SMALL_STATE(8955)] = 349247,
  [SMALL_STATE(8956)] = 349282,
  [SMALL_STATE(8957)] = 349317,
  [SMALL_STATE(8958)] = 349352,
  [SMALL_STATE(8959)] = 349387,
  [SMALL_STATE(8960)] = 349422,
  [SMALL_STATE(8961)] = 349457,
  [SMALL_STATE(8962)] = 349492,
  [SMALL_STATE(8963)] = 349527,
  [SMALL_STATE(8964)] = 349562,
  [SMALL_STATE(8965)] = 349597,
  [SMALL_STATE(8966)] = 349632,
  [SMALL_STATE(8967)] = 349667,
  [SMALL_STATE(8968)] = 349702,
  [SMALL_STATE(8969)] = 349737,
  [SMALL_STATE(8970)] = 349772,
  [SMALL_STATE(8971)] = 349807,
  [SMALL_STATE(8972)] = 349842,
  [SMALL_STATE(8973)] = 349877,
  [SMALL_STATE(8974)] = 349912,
  [SMALL_STATE(8975)] = 349947,
  [SMALL_STATE(8976)] = 349982,
  [SMALL_STATE(8977)] = 350017,
  [SMALL_STATE(8978)] = 350052,
  [SMALL_STATE(8979)] = 350087,
  [SMALL_STATE(8980)] = 350124,
  [SMALL_STATE(8981)] = 350159,
  [SMALL_STATE(8982)] = 350194,
  [SMALL_STATE(8983)] = 350229,
  [SMALL_STATE(8984)] = 350264,
  [SMALL_STATE(8985)] = 350299,
  [SMALL_STATE(8986)] = 350334,
  [SMALL_STATE(8987)] = 350369,
  [SMALL_STATE(8988)] = 350404,
  [SMALL_STATE(8989)] = 350439,
  [SMALL_STATE(8990)] = 350474,
  [SMALL_STATE(8991)] = 350509,
  [SMALL_STATE(8992)] = 350544,
  [SMALL_STATE(8993)] = 350598,
  [SMALL_STATE(8994)] = 350652,
  [SMALL_STATE(8995)] = 350686,
  [SMALL_STATE(8996)] = 350720,
  [SMALL_STATE(8997)] = 350754,
  [SMALL_STATE(8998)] = 350808,
  [SMALL_STATE(8999)] = 350862,
  [SMALL_STATE(9000)] = 350896,
  [SMALL_STATE(9001)] = 350930,
  [SMALL_STATE(9002)] = 350984,
  [SMALL_STATE(9003)] = 351018,
  [SMALL_STATE(9004)] = 351052,
  [SMALL_STATE(9005)] = 351086,
  [SMALL_STATE(9006)] = 351140,
  [SMALL_STATE(9007)] = 351174,
  [SMALL_STATE(9008)] = 351208,
  [SMALL_STATE(9009)] = 351262,
  [SMALL_STATE(9010)] = 351316,
  [SMALL_STATE(9011)] = 351370,
  [SMALL_STATE(9012)] = 351424,
  [SMALL_STATE(9013)] = 351458,
  [SMALL_STATE(9014)] = 351512,
  [SMALL_STATE(9015)] = 351568,
  [SMALL_STATE(9016)] = 351622,
  [SMALL_STATE(9017)] = 351656,
  [SMALL_STATE(9018)] = 351690,
  [SMALL_STATE(9019)] = 351744,
  [SMALL_STATE(9020)] = 351800,
  [SMALL_STATE(9021)] = 351854,
  [SMALL_STATE(9022)] = 351888,
  [SMALL_STATE(9023)] = 351942,
  [SMALL_STATE(9024)] = 351996,
  [SMALL_STATE(9025)] = 352050,
  [SMALL_STATE(9026)] = 352104,
  [SMALL_STATE(9027)] = 352138,
  [SMALL_STATE(9028)] = 352172,
  [SMALL_STATE(9029)] = 352226,
  [SMALL_STATE(9030)] = 352280,
  [SMALL_STATE(9031)] = 352314,
  [SMALL_STATE(9032)] = 352368,
  [SMALL_STATE(9033)] = 352422,
  [SMALL_STATE(9034)] = 352476,
  [SMALL_STATE(9035)] = 352530,
  [SMALL_STATE(9036)] = 352564,
  [SMALL_STATE(9037)] = 352618,
  [SMALL_STATE(9038)] = 352672,
  [SMALL_STATE(9039)] = 352726,
  [SMALL_STATE(9040)] = 352780,
  [SMALL_STATE(9041)] = 352814,
  [SMALL_STATE(9042)] = 352868,
  [SMALL_STATE(9043)] = 352922,
  [SMALL_STATE(9044)] = 352956,
  [SMALL_STATE(9045)] = 352990,
  [SMALL_STATE(9046)] = 353024,
  [SMALL_STATE(9047)] = 353078,
  [SMALL_STATE(9048)] = 353112,
  [SMALL_STATE(9049)] = 353166,
  [SMALL_STATE(9050)] = 353220,
  [SMALL_STATE(9051)] = 353274,
  [SMALL_STATE(9052)] = 353328,
  [SMALL_STATE(9053)] = 353362,
  [SMALL_STATE(9054)] = 353418,
  [SMALL_STATE(9055)] = 353472,
  [SMALL_STATE(9056)] = 353526,
  [SMALL_STATE(9057)] = 353580,
  [SMALL_STATE(9058)] = 353614,
  [SMALL_STATE(9059)] = 353648,
  [SMALL_STATE(9060)] = 353702,
  [SMALL_STATE(9061)] = 353756,
  [SMALL_STATE(9062)] = 353810,
  [SMALL_STATE(9063)] = 353864,
  [SMALL_STATE(9064)] = 353920,
  [SMALL_STATE(9065)] = 353954,
  [SMALL_STATE(9066)] = 354010,
  [SMALL_STATE(9067)] = 354064,
  [SMALL_STATE(9068)] = 354118,
  [SMALL_STATE(9069)] = 354172,
  [SMALL_STATE(9070)] = 354206,
  [SMALL_STATE(9071)] = 354260,
  [SMALL_STATE(9072)] = 354314,
  [SMALL_STATE(9073)] = 354370,
  [SMALL_STATE(9074)] = 354424,
  [SMALL_STATE(9075)] = 354458,
  [SMALL_STATE(9076)] = 354512,
  [SMALL_STATE(9077)] = 354546,
  [SMALL_STATE(9078)] = 354580,
  [SMALL_STATE(9079)] = 354634,
  [SMALL_STATE(9080)] = 354668,
  [SMALL_STATE(9081)] = 354702,
  [SMALL_STATE(9082)] = 354738,
  [SMALL_STATE(9083)] = 354794,
  [SMALL_STATE(9084)] = 354848,
  [SMALL_STATE(9085)] = 354902,
  [SMALL_STATE(9086)] = 354956,
  [SMALL_STATE(9087)] = 354994,
  [SMALL_STATE(9088)] = 355028,
  [SMALL_STATE(9089)] = 355066,
  [SMALL_STATE(9090)] = 355120,
  [SMALL_STATE(9091)] = 355154,
  [SMALL_STATE(9092)] = 355208,
  [SMALL_STATE(9093)] = 355262,
  [SMALL_STATE(9094)] = 355296,
  [SMALL_STATE(9095)] = 355350,
  [SMALL_STATE(9096)] = 355384,
  [SMALL_STATE(9097)] = 355438,
  [SMALL_STATE(9098)] = 355472,
  [SMALL_STATE(9099)] = 355506,
  [SMALL_STATE(9100)] = 355560,
  [SMALL_STATE(9101)] = 355614,
  [SMALL_STATE(9102)] = 355668,
  [SMALL_STATE(9103)] = 355722,
  [SMALL_STATE(9104)] = 355756,
  [SMALL_STATE(9105)] = 355810,
  [SMALL_STATE(9106)] = 355864,
  [SMALL_STATE(9107)] = 355898,
  [SMALL_STATE(9108)] = 355932,
  [SMALL_STATE(9109)] = 355986,
  [SMALL_STATE(9110)] = 356040,
  [SMALL_STATE(9111)] = 356096,
  [SMALL_STATE(9112)] = 356130,
  [SMALL_STATE(9113)] = 356186,
  [SMALL_STATE(9114)] = 356240,
  [SMALL_STATE(9115)] = 356274,
  [SMALL_STATE(9116)] = 356328,
  [SMALL_STATE(9117)] = 356384,
  [SMALL_STATE(9118)] = 356440,
  [SMALL_STATE(9119)] = 356474,
  [SMALL_STATE(9120)] = 356528,
  [SMALL_STATE(9121)] = 356562,
  [SMALL_STATE(9122)] = 356618,
  [SMALL_STATE(9123)] = 356672,
  [SMALL_STATE(9124)] = 356726,
  [SMALL_STATE(9125)] = 356780,
  [SMALL_STATE(9126)] = 356814,
  [SMALL_STATE(9127)] = 356868,
  [SMALL_STATE(9128)] = 356922,
  [SMALL_STATE(9129)] = 356978,
  [SMALL_STATE(9130)] = 357034,
  [SMALL_STATE(9131)] = 357068,
  [SMALL_STATE(9132)] = 357122,
  [SMALL_STATE(9133)] = 357176,
  [SMALL_STATE(9134)] = 357230,
  [SMALL_STATE(9135)] = 357264,
  [SMALL_STATE(9136)] = 357320,
  [SMALL_STATE(9137)] = 357374,
  [SMALL_STATE(9138)] = 357428,
  [SMALL_STATE(9139)] = 357462,
  [SMALL_STATE(9140)] = 357498,
  [SMALL_STATE(9141)] = 357532,
  [SMALL_STATE(9142)] = 357586,
  [SMALL_STATE(9143)] = 357620,
  [SMALL_STATE(9144)] = 357674,
  [SMALL_STATE(9145)] = 357728,
  [SMALL_STATE(9146)] = 357762,
  [SMALL_STATE(9147)] = 357816,
  [SMALL_STATE(9148)] = 357870,
  [SMALL_STATE(9149)] = 357924,
  [SMALL_STATE(9150)] = 357978,
  [SMALL_STATE(9151)] = 358034,
  [SMALL_STATE(9152)] = 358088,
  [SMALL_STATE(9153)] = 358122,
  [SMALL_STATE(9154)] = 358176,
  [SMALL_STATE(9155)] = 358230,
  [SMALL_STATE(9156)] = 358284,
  [SMALL_STATE(9157)] = 358338,
  [SMALL_STATE(9158)] = 358372,
  [SMALL_STATE(9159)] = 358406,
  [SMALL_STATE(9160)] = 358460,
  [SMALL_STATE(9161)] = 358514,
  [SMALL_STATE(9162)] = 358548,
  [SMALL_STATE(9163)] = 358602,
  [SMALL_STATE(9164)] = 358658,
  [SMALL_STATE(9165)] = 358692,
  [SMALL_STATE(9166)] = 358726,
  [SMALL_STATE(9167)] = 358760,
  [SMALL_STATE(9168)] = 358794,
  [SMALL_STATE(9169)] = 358828,
  [SMALL_STATE(9170)] = 358862,
  [SMALL_STATE(9171)] = 358916,
  [SMALL_STATE(9172)] = 358970,
  [SMALL_STATE(9173)] = 359024,
  [SMALL_STATE(9174)] = 359078,
  [SMALL_STATE(9175)] = 359132,
  [SMALL_STATE(9176)] = 359166,
  [SMALL_STATE(9177)] = 359220,
  [SMALL_STATE(9178)] = 359274,
  [SMALL_STATE(9179)] = 359328,
  [SMALL_STATE(9180)] = 359382,
  [SMALL_STATE(9181)] = 359436,
  [SMALL_STATE(9182)] = 359490,
  [SMALL_STATE(9183)] = 359544,
  [SMALL_STATE(9184)] = 359598,
  [SMALL_STATE(9185)] = 359652,
  [SMALL_STATE(9186)] = 359686,
  [SMALL_STATE(9187)] = 359742,
  [SMALL_STATE(9188)] = 359796,
  [SMALL_STATE(9189)] = 359850,
  [SMALL_STATE(9190)] = 359906,
  [SMALL_STATE(9191)] = 359960,
  [SMALL_STATE(9192)] = 360016,
  [SMALL_STATE(9193)] = 360050,
  [SMALL_STATE(9194)] = 360104,
  [SMALL_STATE(9195)] = 360160,
  [SMALL_STATE(9196)] = 360214,
  [SMALL_STATE(9197)] = 360268,
  [SMALL_STATE(9198)] = 360322,
  [SMALL_STATE(9199)] = 360376,
  [SMALL_STATE(9200)] = 360432,
  [SMALL_STATE(9201)] = 360488,
  [SMALL_STATE(9202)] = 360544,
  [SMALL_STATE(9203)] = 360600,
  [SMALL_STATE(9204)] = 360656,
  [SMALL_STATE(9205)] = 360710,
  [SMALL_STATE(9206)] = 360764,
  [SMALL_STATE(9207)] = 360820,
  [SMALL_STATE(9208)] = 360854,
  [SMALL_STATE(9209)] = 360910,
  [SMALL_STATE(9210)] = 360964,
  [SMALL_STATE(9211)] = 361018,
  [SMALL_STATE(9212)] = 361072,
  [SMALL_STATE(9213)] = 361128,
  [SMALL_STATE(9214)] = 361162,
  [SMALL_STATE(9215)] = 361196,
  [SMALL_STATE(9216)] = 361250,
  [SMALL_STATE(9217)] = 361304,
  [SMALL_STATE(9218)] = 361338,
  [SMALL_STATE(9219)] = 361379,
  [SMALL_STATE(9220)] = 361434,
  [SMALL_STATE(9221)] = 361489,
  [SMALL_STATE(9222)] = 361522,
  [SMALL_STATE(9223)] = 361555,
  [SMALL_STATE(9224)] = 361590,
  [SMALL_STATE(9225)] = 361625,
  [SMALL_STATE(9226)] = 361658,
  [SMALL_STATE(9227)] = 361693,
  [SMALL_STATE(9228)] = 361748,
  [SMALL_STATE(9229)] = 361781,
  [SMALL_STATE(9230)] = 361814,
  [SMALL_STATE(9231)] = 361849,
  [SMALL_STATE(9232)] = 361882,
  [SMALL_STATE(9233)] = 361915,
  [SMALL_STATE(9234)] = 361948,
  [SMALL_STATE(9235)] = 361997,
  [SMALL_STATE(9236)] = 362032,
  [SMALL_STATE(9237)] = 362087,
  [SMALL_STATE(9238)] = 362136,
  [SMALL_STATE(9239)] = 362169,
  [SMALL_STATE(9240)] = 362202,
  [SMALL_STATE(9241)] = 362237,
  [SMALL_STATE(9242)] = 362292,
  [SMALL_STATE(9243)] = 362325,
  [SMALL_STATE(9244)] = 362358,
  [SMALL_STATE(9245)] = 362412,
  [SMALL_STATE(9246)] = 362444,
  [SMALL_STATE(9247)] = 362476,
  [SMALL_STATE(9248)] = 362508,
  [SMALL_STATE(9249)] = 362540,
  [SMALL_STATE(9250)] = 362572,
  [SMALL_STATE(9251)] = 362604,
  [SMALL_STATE(9252)] = 362636,
  [SMALL_STATE(9253)] = 362668,
  [SMALL_STATE(9254)] = 362700,
  [SMALL_STATE(9255)] = 362732,
  [SMALL_STATE(9256)] = 362764,
  [SMALL_STATE(9257)] = 362796,
  [SMALL_STATE(9258)] = 362850,
  [SMALL_STATE(9259)] = 362882,
  [SMALL_STATE(9260)] = 362936,
  [SMALL_STATE(9261)] = 362970,
  [SMALL_STATE(9262)] = 363002,
  [SMALL_STATE(9263)] = 363034,
  [SMALL_STATE(9264)] = 363070,
  [SMALL_STATE(9265)] = 363102,
  [SMALL_STATE(9266)] = 363134,
  [SMALL_STATE(9267)] = 363166,
  [SMALL_STATE(9268)] = 363198,
  [SMALL_STATE(9269)] = 363232,
  [SMALL_STATE(9270)] = 363286,
  [SMALL_STATE(9271)] = 363318,
  [SMALL_STATE(9272)] = 363350,
  [SMALL_STATE(9273)] = 363404,
  [SMALL_STATE(9274)] = 363458,
  [SMALL_STATE(9275)] = 363490,
  [SMALL_STATE(9276)] = 363522,
  [SMALL_STATE(9277)] = 363554,
  [SMALL_STATE(9278)] = 363592,
  [SMALL_STATE(9279)] = 363624,
  [SMALL_STATE(9280)] = 363656,
  [SMALL_STATE(9281)] = 363710,
  [SMALL_STATE(9282)] = 363764,
  [SMALL_STATE(9283)] = 363798,
  [SMALL_STATE(9284)] = 363830,
  [SMALL_STATE(9285)] = 363864,
  [SMALL_STATE(9286)] = 363896,
  [SMALL_STATE(9287)] = 363928,
  [SMALL_STATE(9288)] = 363960,
  [SMALL_STATE(9289)] = 363992,
  [SMALL_STATE(9290)] = 364024,
  [SMALL_STATE(9291)] = 364078,
  [SMALL_STATE(9292)] = 364110,
  [SMALL_STATE(9293)] = 364142,
  [SMALL_STATE(9294)] = 364196,
  [SMALL_STATE(9295)] = 364228,
  [SMALL_STATE(9296)] = 364282,
  [SMALL_STATE(9297)] = 364314,
  [SMALL_STATE(9298)] = 364368,
  [SMALL_STATE(9299)] = 364400,
  [SMALL_STATE(9300)] = 364432,
  [SMALL_STATE(9301)] = 364464,
  [SMALL_STATE(9302)] = 364496,
  [SMALL_STATE(9303)] = 364550,
  [SMALL_STATE(9304)] = 364582,
  [SMALL_STATE(9305)] = 364614,
  [SMALL_STATE(9306)] = 364668,
  [SMALL_STATE(9307)] = 364700,
  [SMALL_STATE(9308)] = 364754,
  [SMALL_STATE(9309)] = 364808,
  [SMALL_STATE(9310)] = 364862,
  [SMALL_STATE(9311)] = 364894,
  [SMALL_STATE(9312)] = 364948,
  [SMALL_STATE(9313)] = 365002,
  [SMALL_STATE(9314)] = 365034,
  [SMALL_STATE(9315)] = 365088,
  [SMALL_STATE(9316)] = 365120,
  [SMALL_STATE(9317)] = 365174,
  [SMALL_STATE(9318)] = 365206,
  [SMALL_STATE(9319)] = 365238,
  [SMALL_STATE(9320)] = 365270,
  [SMALL_STATE(9321)] = 365302,
  [SMALL_STATE(9322)] = 365334,
  [SMALL_STATE(9323)] = 365388,
  [SMALL_STATE(9324)] = 365420,
  [SMALL_STATE(9325)] = 365452,
  [SMALL_STATE(9326)] = 365484,
  [SMALL_STATE(9327)] = 365538,
  [SMALL_STATE(9328)] = 365570,
  [SMALL_STATE(9329)] = 365624,
  [SMALL_STATE(9330)] = 365678,
  [SMALL_STATE(9331)] = 365732,
  [SMALL_STATE(9332)] = 365786,
  [SMALL_STATE(9333)] = 365824,
  [SMALL_STATE(9334)] = 365856,
  [SMALL_STATE(9335)] = 365888,
  [SMALL_STATE(9336)] = 365920,
  [SMALL_STATE(9337)] = 365952,
  [SMALL_STATE(9338)] = 365984,
  [SMALL_STATE(9339)] = 366024,
  [SMALL_STATE(9340)] = 366078,
  [SMALL_STATE(9341)] = 366110,
  [SMALL_STATE(9342)] = 366142,
  [SMALL_STATE(9343)] = 366174,
  [SMALL_STATE(9344)] = 366206,
  [SMALL_STATE(9345)] = 366238,
  [SMALL_STATE(9346)] = 366270,
  [SMALL_STATE(9347)] = 366302,
  [SMALL_STATE(9348)] = 366334,
  [SMALL_STATE(9349)] = 366366,
  [SMALL_STATE(9350)] = 366398,
  [SMALL_STATE(9351)] = 366430,
  [SMALL_STATE(9352)] = 366462,
  [SMALL_STATE(9353)] = 366494,
  [SMALL_STATE(9354)] = 366526,
  [SMALL_STATE(9355)] = 366580,
  [SMALL_STATE(9356)] = 366618,
  [SMALL_STATE(9357)] = 366650,
  [SMALL_STATE(9358)] = 366682,
  [SMALL_STATE(9359)] = 366720,
  [SMALL_STATE(9360)] = 366752,
  [SMALL_STATE(9361)] = 366806,
  [SMALL_STATE(9362)] = 366860,
  [SMALL_STATE(9363)] = 366892,
  [SMALL_STATE(9364)] = 366924,
  [SMALL_STATE(9365)] = 366956,
  [SMALL_STATE(9366)] = 366988,
  [SMALL_STATE(9367)] = 367020,
  [SMALL_STATE(9368)] = 367052,
  [SMALL_STATE(9369)] = 367106,
  [SMALL_STATE(9370)] = 367138,
  [SMALL_STATE(9371)] = 367170,
  [SMALL_STATE(9372)] = 367202,
  [SMALL_STATE(9373)] = 367234,
  [SMALL_STATE(9374)] = 367288,
  [SMALL_STATE(9375)] = 367320,
  [SMALL_STATE(9376)] = 367352,
  [SMALL_STATE(9377)] = 367384,
  [SMALL_STATE(9378)] = 367438,
  [SMALL_STATE(9379)] = 367470,
  [SMALL_STATE(9380)] = 367501,
  [SMALL_STATE(9381)] = 367532,
  [SMALL_STATE(9382)] = 367563,
  [SMALL_STATE(9383)] = 367594,
  [SMALL_STATE(9384)] = 367625,
  [SMALL_STATE(9385)] = 367656,
  [SMALL_STATE(9386)] = 367687,
  [SMALL_STATE(9387)] = 367718,
  [SMALL_STATE(9388)] = 367749,
  [SMALL_STATE(9389)] = 367780,
  [SMALL_STATE(9390)] = 367811,
  [SMALL_STATE(9391)] = 367842,
  [SMALL_STATE(9392)] = 367873,
  [SMALL_STATE(9393)] = 367904,
  [SMALL_STATE(9394)] = 367935,
  [SMALL_STATE(9395)] = 367966,
  [SMALL_STATE(9396)] = 367997,
  [SMALL_STATE(9397)] = 368028,
  [SMALL_STATE(9398)] = 368059,
  [SMALL_STATE(9399)] = 368090,
  [SMALL_STATE(9400)] = 368121,
  [SMALL_STATE(9401)] = 368152,
  [SMALL_STATE(9402)] = 368183,
  [SMALL_STATE(9403)] = 368214,
  [SMALL_STATE(9404)] = 368245,
  [SMALL_STATE(9405)] = 368276,
  [SMALL_STATE(9406)] = 368307,
  [SMALL_STATE(9407)] = 368338,
  [SMALL_STATE(9408)] = 368371,
  [SMALL_STATE(9409)] = 368404,
  [SMALL_STATE(9410)] = 368435,
  [SMALL_STATE(9411)] = 368466,
  [SMALL_STATE(9412)] = 368497,
  [SMALL_STATE(9413)] = 368528,
  [SMALL_STATE(9414)] = 368559,
  [SMALL_STATE(9415)] = 368590,
  [SMALL_STATE(9416)] = 368621,
  [SMALL_STATE(9417)] = 368652,
  [SMALL_STATE(9418)] = 368683,
  [SMALL_STATE(9419)] = 368714,
  [SMALL_STATE(9420)] = 368745,
  [SMALL_STATE(9421)] = 368776,
  [SMALL_STATE(9422)] = 368807,
  [SMALL_STATE(9423)] = 368838,
  [SMALL_STATE(9424)] = 368869,
  [SMALL_STATE(9425)] = 368902,
  [SMALL_STATE(9426)] = 368933,
  [SMALL_STATE(9427)] = 368964,
  [SMALL_STATE(9428)] = 368995,
  [SMALL_STATE(9429)] = 369026,
  [SMALL_STATE(9430)] = 369063,
  [SMALL_STATE(9431)] = 369094,
  [SMALL_STATE(9432)] = 369125,
  [SMALL_STATE(9433)] = 369156,
  [SMALL_STATE(9434)] = 369189,
  [SMALL_STATE(9435)] = 369220,
  [SMALL_STATE(9436)] = 369251,
  [SMALL_STATE(9437)] = 369284,
  [SMALL_STATE(9438)] = 369315,
  [SMALL_STATE(9439)] = 369346,
  [SMALL_STATE(9440)] = 369379,
  [SMALL_STATE(9441)] = 369416,
  [SMALL_STATE(9442)] = 369446,
  [SMALL_STATE(9443)] = 369482,
  [SMALL_STATE(9444)] = 369512,
  [SMALL_STATE(9445)] = 369542,
  [SMALL_STATE(9446)] = 369572,
  [SMALL_STATE(9447)] = 369602,
  [SMALL_STATE(9448)] = 369632,
  [SMALL_STATE(9449)] = 369662,
  [SMALL_STATE(9450)] = 369694,
  [SMALL_STATE(9451)] = 369724,
  [SMALL_STATE(9452)] = 369770,
  [SMALL_STATE(9453)] = 369800,
  [SMALL_STATE(9454)] = 369830,
  [SMALL_STATE(9455)] = 369860,
  [SMALL_STATE(9456)] = 369906,
  [SMALL_STATE(9457)] = 369936,
  [SMALL_STATE(9458)] = 369966,
  [SMALL_STATE(9459)] = 369998,
  [SMALL_STATE(9460)] = 370036,
  [SMALL_STATE(9461)] = 370066,
  [SMALL_STATE(9462)] = 370096,
  [SMALL_STATE(9463)] = 370126,
  [SMALL_STATE(9464)] = 370156,
  [SMALL_STATE(9465)] = 370186,
  [SMALL_STATE(9466)] = 370216,
  [SMALL_STATE(9467)] = 370246,
  [SMALL_STATE(9468)] = 370276,
  [SMALL_STATE(9469)] = 370306,
  [SMALL_STATE(9470)] = 370336,
  [SMALL_STATE(9471)] = 370366,
  [SMALL_STATE(9472)] = 370396,
  [SMALL_STATE(9473)] = 370426,
  [SMALL_STATE(9474)] = 370456,
  [SMALL_STATE(9475)] = 370486,
  [SMALL_STATE(9476)] = 370516,
  [SMALL_STATE(9477)] = 370546,
  [SMALL_STATE(9478)] = 370576,
  [SMALL_STATE(9479)] = 370606,
  [SMALL_STATE(9480)] = 370636,
  [SMALL_STATE(9481)] = 370668,
  [SMALL_STATE(9482)] = 370700,
  [SMALL_STATE(9483)] = 370730,
  [SMALL_STATE(9484)] = 370760,
  [SMALL_STATE(9485)] = 370790,
  [SMALL_STATE(9486)] = 370828,
  [SMALL_STATE(9487)] = 370858,
  [SMALL_STATE(9488)] = 370888,
  [SMALL_STATE(9489)] = 370918,
  [SMALL_STATE(9490)] = 370948,
  [SMALL_STATE(9491)] = 370978,
  [SMALL_STATE(9492)] = 371008,
  [SMALL_STATE(9493)] = 371038,
  [SMALL_STATE(9494)] = 371068,
  [SMALL_STATE(9495)] = 371098,
  [SMALL_STATE(9496)] = 371128,
  [SMALL_STATE(9497)] = 371158,
  [SMALL_STATE(9498)] = 371188,
  [SMALL_STATE(9499)] = 371218,
  [SMALL_STATE(9500)] = 371248,
  [SMALL_STATE(9501)] = 371278,
  [SMALL_STATE(9502)] = 371308,
  [SMALL_STATE(9503)] = 371338,
  [SMALL_STATE(9504)] = 371368,
  [SMALL_STATE(9505)] = 371398,
  [SMALL_STATE(9506)] = 371428,
  [SMALL_STATE(9507)] = 371458,
  [SMALL_STATE(9508)] = 371488,
  [SMALL_STATE(9509)] = 371518,
  [SMALL_STATE(9510)] = 371548,
  [SMALL_STATE(9511)] = 371594,
  [SMALL_STATE(9512)] = 371624,
  [SMALL_STATE(9513)] = 371654,
  [SMALL_STATE(9514)] = 371684,
  [SMALL_STATE(9515)] = 371714,
  [SMALL_STATE(9516)] = 371744,
  [SMALL_STATE(9517)] = 371774,
  [SMALL_STATE(9518)] = 371803,
  [SMALL_STATE(9519)] = 371834,
  [SMALL_STATE(9520)] = 371863,
  [SMALL_STATE(9521)] = 371894,
  [SMALL_STATE(9522)] = 371923,
  [SMALL_STATE(9523)] = 371952,
  [SMALL_STATE(9524)] = 371981,
  [SMALL_STATE(9525)] = 372010,
  [SMALL_STATE(9526)] = 372039,
  [SMALL_STATE(9527)] = 372068,
  [SMALL_STATE(9528)] = 372113,
  [SMALL_STATE(9529)] = 372142,
  [SMALL_STATE(9530)] = 372171,
  [SMALL_STATE(9531)] = 372204,
  [SMALL_STATE(9532)] = 372233,
  [SMALL_STATE(9533)] = 372262,
  [SMALL_STATE(9534)] = 372291,
  [SMALL_STATE(9535)] = 372320,
  [SMALL_STATE(9536)] = 372349,
  [SMALL_STATE(9537)] = 372378,
  [SMALL_STATE(9538)] = 372409,
  [SMALL_STATE(9539)] = 372446,
  [SMALL_STATE(9540)] = 372475,
  [SMALL_STATE(9541)] = 372504,
  [SMALL_STATE(9542)] = 372533,
  [SMALL_STATE(9543)] = 372562,
  [SMALL_STATE(9544)] = 372591,
  [SMALL_STATE(9545)] = 372626,
  [SMALL_STATE(9546)] = 372663,
  [SMALL_STATE(9547)] = 372692,
  [SMALL_STATE(9548)] = 372723,
  [SMALL_STATE(9549)] = 372752,
  [SMALL_STATE(9550)] = 372781,
  [SMALL_STATE(9551)] = 372810,
  [SMALL_STATE(9552)] = 372839,
  [SMALL_STATE(9553)] = 372868,
  [SMALL_STATE(9554)] = 372897,
  [SMALL_STATE(9555)] = 372926,
  [SMALL_STATE(9556)] = 372955,
  [SMALL_STATE(9557)] = 372984,
  [SMALL_STATE(9558)] = 373013,
  [SMALL_STATE(9559)] = 373044,
  [SMALL_STATE(9560)] = 373073,
  [SMALL_STATE(9561)] = 373108,
  [SMALL_STATE(9562)] = 373137,
  [SMALL_STATE(9563)] = 373166,
  [SMALL_STATE(9564)] = 373197,
  [SMALL_STATE(9565)] = 373226,
  [SMALL_STATE(9566)] = 373255,
  [SMALL_STATE(9567)] = 373290,
  [SMALL_STATE(9568)] = 373319,
  [SMALL_STATE(9569)] = 373348,
  [SMALL_STATE(9570)] = 373377,
  [SMALL_STATE(9571)] = 373406,
  [SMALL_STATE(9572)] = 373443,
  [SMALL_STATE(9573)] = 373478,
  [SMALL_STATE(9574)] = 373507,
  [SMALL_STATE(9575)] = 373544,
  [SMALL_STATE(9576)] = 373575,
  [SMALL_STATE(9577)] = 373604,
  [SMALL_STATE(9578)] = 373635,
  [SMALL_STATE(9579)] = 373664,
  [SMALL_STATE(9580)] = 373701,
  [SMALL_STATE(9581)] = 373730,
  [SMALL_STATE(9582)] = 373759,
  [SMALL_STATE(9583)] = 373788,
  [SMALL_STATE(9584)] = 373833,
  [SMALL_STATE(9585)] = 373862,
  [SMALL_STATE(9586)] = 373899,
  [SMALL_STATE(9587)] = 373927,
  [SMALL_STATE(9588)] = 373955,
  [SMALL_STATE(9589)] = 373983,
  [SMALL_STATE(9590)] = 374025,
  [SMALL_STATE(9591)] = 374053,
  [SMALL_STATE(9592)] = 374081,
  [SMALL_STATE(9593)] = 374109,
  [SMALL_STATE(9594)] = 374137,
  [SMALL_STATE(9595)] = 374165,
  [SMALL_STATE(9596)] = 374193,
  [SMALL_STATE(9597)] = 374229,
  [SMALL_STATE(9598)] = 374265,
  [SMALL_STATE(9599)] = 374293,
  [SMALL_STATE(9600)] = 374321,
  [SMALL_STATE(9601)] = 374363,
  [SMALL_STATE(9602)] = 374391,
  [SMALL_STATE(9603)] = 374419,
  [SMALL_STATE(9604)] = 374447,
  [SMALL_STATE(9605)] = 374475,
  [SMALL_STATE(9606)] = 374509,
  [SMALL_STATE(9607)] = 374537,
  [SMALL_STATE(9608)] = 374579,
  [SMALL_STATE(9609)] = 374609,
  [SMALL_STATE(9610)] = 374637,
  [SMALL_STATE(9611)] = 374665,
  [SMALL_STATE(9612)] = 374693,
  [SMALL_STATE(9613)] = 374721,
  [SMALL_STATE(9614)] = 374749,
  [SMALL_STATE(9615)] = 374777,
  [SMALL_STATE(9616)] = 374819,
  [SMALL_STATE(9617)] = 374847,
  [SMALL_STATE(9618)] = 374875,
  [SMALL_STATE(9619)] = 374903,
  [SMALL_STATE(9620)] = 374933,
  [SMALL_STATE(9621)] = 374961,
  [SMALL_STATE(9622)] = 374995,
  [SMALL_STATE(9623)] = 375023,
  [SMALL_STATE(9624)] = 375051,
  [SMALL_STATE(9625)] = 375079,
  [SMALL_STATE(9626)] = 375107,
  [SMALL_STATE(9627)] = 375149,
  [SMALL_STATE(9628)] = 375179,
  [SMALL_STATE(9629)] = 375207,
  [SMALL_STATE(9630)] = 375239,
  [SMALL_STATE(9631)] = 375267,
  [SMALL_STATE(9632)] = 375295,
  [SMALL_STATE(9633)] = 375323,
  [SMALL_STATE(9634)] = 375353,
  [SMALL_STATE(9635)] = 375389,
  [SMALL_STATE(9636)] = 375419,
  [SMALL_STATE(9637)] = 375447,
  [SMALL_STATE(9638)] = 375475,
  [SMALL_STATE(9639)] = 375505,
  [SMALL_STATE(9640)] = 375539,
  [SMALL_STATE(9641)] = 375567,
  [SMALL_STATE(9642)] = 375595,
  [SMALL_STATE(9643)] = 375623,
  [SMALL_STATE(9644)] = 375651,
  [SMALL_STATE(9645)] = 375679,
  [SMALL_STATE(9646)] = 375707,
  [SMALL_STATE(9647)] = 375735,
  [SMALL_STATE(9648)] = 375763,
  [SMALL_STATE(9649)] = 375791,
  [SMALL_STATE(9650)] = 375819,
  [SMALL_STATE(9651)] = 375847,
  [SMALL_STATE(9652)] = 375875,
  [SMALL_STATE(9653)] = 375903,
  [SMALL_STATE(9654)] = 375945,
  [SMALL_STATE(9655)] = 375973,
  [SMALL_STATE(9656)] = 376009,
  [SMALL_STATE(9657)] = 376037,
  [SMALL_STATE(9658)] = 376065,
  [SMALL_STATE(9659)] = 376107,
  [SMALL_STATE(9660)] = 376135,
  [SMALL_STATE(9661)] = 376163,
  [SMALL_STATE(9662)] = 376191,
  [SMALL_STATE(9663)] = 376219,
  [SMALL_STATE(9664)] = 376247,
  [SMALL_STATE(9665)] = 376275,
  [SMALL_STATE(9666)] = 376303,
  [SMALL_STATE(9667)] = 376331,
  [SMALL_STATE(9668)] = 376359,
  [SMALL_STATE(9669)] = 376387,
  [SMALL_STATE(9670)] = 376415,
  [SMALL_STATE(9671)] = 376443,
  [SMALL_STATE(9672)] = 376475,
  [SMALL_STATE(9673)] = 376511,
  [SMALL_STATE(9674)] = 376541,
  [SMALL_STATE(9675)] = 376583,
  [SMALL_STATE(9676)] = 376625,
  [SMALL_STATE(9677)] = 376669,
  [SMALL_STATE(9678)] = 376697,
  [SMALL_STATE(9679)] = 376725,
  [SMALL_STATE(9680)] = 376759,
  [SMALL_STATE(9681)] = 376787,
  [SMALL_STATE(9682)] = 376821,
  [SMALL_STATE(9683)] = 376849,
  [SMALL_STATE(9684)] = 376879,
  [SMALL_STATE(9685)] = 376907,
  [SMALL_STATE(9686)] = 376935,
  [SMALL_STATE(9687)] = 376965,
  [SMALL_STATE(9688)] = 376995,
  [SMALL_STATE(9689)] = 377023,
  [SMALL_STATE(9690)] = 377051,
  [SMALL_STATE(9691)] = 377081,
  [SMALL_STATE(9692)] = 377115,
  [SMALL_STATE(9693)] = 377143,
  [SMALL_STATE(9694)] = 377171,
  [SMALL_STATE(9695)] = 377213,
  [SMALL_STATE(9696)] = 377241,
  [SMALL_STATE(9697)] = 377269,
  [SMALL_STATE(9698)] = 377297,
  [SMALL_STATE(9699)] = 377333,
  [SMALL_STATE(9700)] = 377361,
  [SMALL_STATE(9701)] = 377391,
  [SMALL_STATE(9702)] = 377419,
  [SMALL_STATE(9703)] = 377447,
  [SMALL_STATE(9704)] = 377477,
  [SMALL_STATE(9705)] = 377505,
  [SMALL_STATE(9706)] = 377533,
  [SMALL_STATE(9707)] = 377563,
  [SMALL_STATE(9708)] = 377593,
  [SMALL_STATE(9709)] = 377621,
  [SMALL_STATE(9710)] = 377649,
  [SMALL_STATE(9711)] = 377677,
  [SMALL_STATE(9712)] = 377705,
  [SMALL_STATE(9713)] = 377747,
  [SMALL_STATE(9714)] = 377783,
  [SMALL_STATE(9715)] = 377811,
  [SMALL_STATE(9716)] = 377839,
  [SMALL_STATE(9717)] = 377867,
  [SMALL_STATE(9718)] = 377910,
  [SMALL_STATE(9719)] = 377937,
  [SMALL_STATE(9720)] = 377980,
  [SMALL_STATE(9721)] = 378007,
  [SMALL_STATE(9722)] = 378042,
  [SMALL_STATE(9723)] = 378069,
  [SMALL_STATE(9724)] = 378096,
  [SMALL_STATE(9725)] = 378123,
  [SMALL_STATE(9726)] = 378166,
  [SMALL_STATE(9727)] = 378209,
  [SMALL_STATE(9728)] = 378252,
  [SMALL_STATE(9729)] = 378295,
  [SMALL_STATE(9730)] = 378322,
  [SMALL_STATE(9731)] = 378365,
  [SMALL_STATE(9732)] = 378392,
  [SMALL_STATE(9733)] = 378419,
  [SMALL_STATE(9734)] = 378446,
  [SMALL_STATE(9735)] = 378489,
  [SMALL_STATE(9736)] = 378532,
  [SMALL_STATE(9737)] = 378559,
  [SMALL_STATE(9738)] = 378588,
  [SMALL_STATE(9739)] = 378617,
  [SMALL_STATE(9740)] = 378644,
  [SMALL_STATE(9741)] = 378671,
  [SMALL_STATE(9742)] = 378714,
  [SMALL_STATE(9743)] = 378741,
  [SMALL_STATE(9744)] = 378784,
  [SMALL_STATE(9745)] = 378811,
  [SMALL_STATE(9746)] = 378838,
  [SMALL_STATE(9747)] = 378881,
  [SMALL_STATE(9748)] = 378924,
  [SMALL_STATE(9749)] = 378953,
  [SMALL_STATE(9750)] = 378996,
  [SMALL_STATE(9751)] = 379023,
  [SMALL_STATE(9752)] = 379050,
  [SMALL_STATE(9753)] = 379093,
  [SMALL_STATE(9754)] = 379136,
  [SMALL_STATE(9755)] = 379179,
  [SMALL_STATE(9756)] = 379222,
  [SMALL_STATE(9757)] = 379249,
  [SMALL_STATE(9758)] = 379276,
  [SMALL_STATE(9759)] = 379305,
  [SMALL_STATE(9760)] = 379336,
  [SMALL_STATE(9761)] = 379379,
  [SMALL_STATE(9762)] = 379422,
  [SMALL_STATE(9763)] = 379449,
  [SMALL_STATE(9764)] = 379492,
  [SMALL_STATE(9765)] = 379535,
  [SMALL_STATE(9766)] = 379578,
  [SMALL_STATE(9767)] = 379609,
  [SMALL_STATE(9768)] = 379652,
  [SMALL_STATE(9769)] = 379679,
  [SMALL_STATE(9770)] = 379722,
  [SMALL_STATE(9771)] = 379749,
  [SMALL_STATE(9772)] = 379776,
  [SMALL_STATE(9773)] = 379803,
  [SMALL_STATE(9774)] = 379846,
  [SMALL_STATE(9775)] = 379873,
  [SMALL_STATE(9776)] = 379900,
  [SMALL_STATE(9777)] = 379931,
  [SMALL_STATE(9778)] = 379960,
  [SMALL_STATE(9779)] = 380003,
  [SMALL_STATE(9780)] = 380034,
  [SMALL_STATE(9781)] = 380077,
  [SMALL_STATE(9782)] = 380104,
  [SMALL_STATE(9783)] = 380131,
  [SMALL_STATE(9784)] = 380158,
  [SMALL_STATE(9785)] = 380191,
  [SMALL_STATE(9786)] = 380218,
  [SMALL_STATE(9787)] = 380245,
  [SMALL_STATE(9788)] = 380288,
  [SMALL_STATE(9789)] = 380317,
  [SMALL_STATE(9790)] = 380344,
  [SMALL_STATE(9791)] = 380373,
  [SMALL_STATE(9792)] = 380424,
  [SMALL_STATE(9793)] = 380453,
  [SMALL_STATE(9794)] = 380480,
  [SMALL_STATE(9795)] = 380507,
  [SMALL_STATE(9796)] = 380534,
  [SMALL_STATE(9797)] = 380561,
  [SMALL_STATE(9798)] = 380604,
  [SMALL_STATE(9799)] = 380631,
  [SMALL_STATE(9800)] = 380660,
  [SMALL_STATE(9801)] = 380703,
  [SMALL_STATE(9802)] = 380730,
  [SMALL_STATE(9803)] = 380757,
  [SMALL_STATE(9804)] = 380784,
  [SMALL_STATE(9805)] = 380827,
  [SMALL_STATE(9806)] = 380854,
  [SMALL_STATE(9807)] = 380881,
  [SMALL_STATE(9808)] = 380924,
  [SMALL_STATE(9809)] = 380967,
  [SMALL_STATE(9810)] = 380994,
  [SMALL_STATE(9811)] = 381021,
  [SMALL_STATE(9812)] = 381064,
  [SMALL_STATE(9813)] = 381091,
  [SMALL_STATE(9814)] = 381118,
  [SMALL_STATE(9815)] = 381145,
  [SMALL_STATE(9816)] = 381176,
  [SMALL_STATE(9817)] = 381219,
  [SMALL_STATE(9818)] = 381246,
  [SMALL_STATE(9819)] = 381273,
  [SMALL_STATE(9820)] = 381300,
  [SMALL_STATE(9821)] = 381343,
  [SMALL_STATE(9822)] = 381386,
  [SMALL_STATE(9823)] = 381413,
  [SMALL_STATE(9824)] = 381440,
  [SMALL_STATE(9825)] = 381467,
  [SMALL_STATE(9826)] = 381510,
  [SMALL_STATE(9827)] = 381553,
  [SMALL_STATE(9828)] = 381580,
  [SMALL_STATE(9829)] = 381623,
  [SMALL_STATE(9830)] = 381666,
  [SMALL_STATE(9831)] = 381693,
  [SMALL_STATE(9832)] = 381720,
  [SMALL_STATE(9833)] = 381763,
  [SMALL_STATE(9834)] = 381790,
  [SMALL_STATE(9835)] = 381833,
  [SMALL_STATE(9836)] = 381860,
  [SMALL_STATE(9837)] = 381887,
  [SMALL_STATE(9838)] = 381930,
  [SMALL_STATE(9839)] = 381973,
  [SMALL_STATE(9840)] = 382000,
  [SMALL_STATE(9841)] = 382027,
  [SMALL_STATE(9842)] = 382070,
  [SMALL_STATE(9843)] = 382097,
  [SMALL_STATE(9844)] = 382124,
  [SMALL_STATE(9845)] = 382151,
  [SMALL_STATE(9846)] = 382180,
  [SMALL_STATE(9847)] = 382207,
  [SMALL_STATE(9848)] = 382250,
  [SMALL_STATE(9849)] = 382293,
  [SMALL_STATE(9850)] = 382328,
  [SMALL_STATE(9851)] = 382355,
  [SMALL_STATE(9852)] = 382382,
  [SMALL_STATE(9853)] = 382409,
  [SMALL_STATE(9854)] = 382436,
  [SMALL_STATE(9855)] = 382479,
  [SMALL_STATE(9856)] = 382506,
  [SMALL_STATE(9857)] = 382549,
  [SMALL_STATE(9858)] = 382592,
  [SMALL_STATE(9859)] = 382619,
  [SMALL_STATE(9860)] = 382662,
  [SMALL_STATE(9861)] = 382689,
  [SMALL_STATE(9862)] = 382732,
  [SMALL_STATE(9863)] = 382759,
  [SMALL_STATE(9864)] = 382786,
  [SMALL_STATE(9865)] = 382829,
  [SMALL_STATE(9866)] = 382856,
  [SMALL_STATE(9867)] = 382899,
  [SMALL_STATE(9868)] = 382926,
  [SMALL_STATE(9869)] = 382953,
  [SMALL_STATE(9870)] = 382996,
  [SMALL_STATE(9871)] = 383023,
  [SMALL_STATE(9872)] = 383050,
  [SMALL_STATE(9873)] = 383077,
  [SMALL_STATE(9874)] = 383104,
  [SMALL_STATE(9875)] = 383131,
  [SMALL_STATE(9876)] = 383158,
  [SMALL_STATE(9877)] = 383187,
  [SMALL_STATE(9878)] = 383214,
  [SMALL_STATE(9879)] = 383241,
  [SMALL_STATE(9880)] = 383284,
  [SMALL_STATE(9881)] = 383327,
  [SMALL_STATE(9882)] = 383356,
  [SMALL_STATE(9883)] = 383399,
  [SMALL_STATE(9884)] = 383426,
  [SMALL_STATE(9885)] = 383469,
  [SMALL_STATE(9886)] = 383512,
  [SMALL_STATE(9887)] = 383555,
  [SMALL_STATE(9888)] = 383582,
  [SMALL_STATE(9889)] = 383609,
  [SMALL_STATE(9890)] = 383652,
  [SMALL_STATE(9891)] = 383679,
  [SMALL_STATE(9892)] = 383706,
  [SMALL_STATE(9893)] = 383733,
  [SMALL_STATE(9894)] = 383762,
  [SMALL_STATE(9895)] = 383805,
  [SMALL_STATE(9896)] = 383848,
  [SMALL_STATE(9897)] = 383875,
  [SMALL_STATE(9898)] = 383918,
  [SMALL_STATE(9899)] = 383945,
  [SMALL_STATE(9900)] = 383970,
  [SMALL_STATE(9901)] = 384001,
  [SMALL_STATE(9902)] = 384028,
  [SMALL_STATE(9903)] = 384055,
  [SMALL_STATE(9904)] = 384098,
  [SMALL_STATE(9905)] = 384141,
  [SMALL_STATE(9906)] = 384184,
  [SMALL_STATE(9907)] = 384211,
  [SMALL_STATE(9908)] = 384238,
  [SMALL_STATE(9909)] = 384281,
  [SMALL_STATE(9910)] = 384310,
  [SMALL_STATE(9911)] = 384353,
  [SMALL_STATE(9912)] = 384384,
  [SMALL_STATE(9913)] = 384413,
  [SMALL_STATE(9914)] = 384456,
  [SMALL_STATE(9915)] = 384499,
  [SMALL_STATE(9916)] = 384542,
  [SMALL_STATE(9917)] = 384585,
  [SMALL_STATE(9918)] = 384612,
  [SMALL_STATE(9919)] = 384639,
  [SMALL_STATE(9920)] = 384682,
  [SMALL_STATE(9921)] = 384725,
  [SMALL_STATE(9922)] = 384768,
  [SMALL_STATE(9923)] = 384811,
  [SMALL_STATE(9924)] = 384844,
  [SMALL_STATE(9925)] = 384871,
  [SMALL_STATE(9926)] = 384898,
  [SMALL_STATE(9927)] = 384925,
  [SMALL_STATE(9928)] = 384952,
  [SMALL_STATE(9929)] = 384979,
  [SMALL_STATE(9930)] = 385022,
  [SMALL_STATE(9931)] = 385065,
  [SMALL_STATE(9932)] = 385092,
  [SMALL_STATE(9933)] = 385119,
  [SMALL_STATE(9934)] = 385146,
  [SMALL_STATE(9935)] = 385175,
  [SMALL_STATE(9936)] = 385202,
  [SMALL_STATE(9937)] = 385245,
  [SMALL_STATE(9938)] = 385272,
  [SMALL_STATE(9939)] = 385303,
  [SMALL_STATE(9940)] = 385346,
  [SMALL_STATE(9941)] = 385375,
  [SMALL_STATE(9942)] = 385404,
  [SMALL_STATE(9943)] = 385431,
  [SMALL_STATE(9944)] = 385458,
  [SMALL_STATE(9945)] = 385487,
  [SMALL_STATE(9946)] = 385530,
  [SMALL_STATE(9947)] = 385557,
  [SMALL_STATE(9948)] = 385600,
  [SMALL_STATE(9949)] = 385643,
  [SMALL_STATE(9950)] = 385674,
  [SMALL_STATE(9951)] = 385709,
  [SMALL_STATE(9952)] = 385736,
  [SMALL_STATE(9953)] = 385763,
  [SMALL_STATE(9954)] = 385790,
  [SMALL_STATE(9955)] = 385817,
  [SMALL_STATE(9956)] = 385844,
  [SMALL_STATE(9957)] = 385887,
  [SMALL_STATE(9958)] = 385914,
  [SMALL_STATE(9959)] = 385941,
  [SMALL_STATE(9960)] = 385968,
  [SMALL_STATE(9961)] = 385995,
  [SMALL_STATE(9962)] = 386022,
  [SMALL_STATE(9963)] = 386049,
  [SMALL_STATE(9964)] = 386092,
  [SMALL_STATE(9965)] = 386135,
  [SMALL_STATE(9966)] = 386164,
  [SMALL_STATE(9967)] = 386207,
  [SMALL_STATE(9968)] = 386234,
  [SMALL_STATE(9969)] = 386261,
  [SMALL_STATE(9970)] = 386288,
  [SMALL_STATE(9971)] = 386323,
  [SMALL_STATE(9972)] = 386350,
  [SMALL_STATE(9973)] = 386393,
  [SMALL_STATE(9974)] = 386436,
  [SMALL_STATE(9975)] = 386464,
  [SMALL_STATE(9976)] = 386506,
  [SMALL_STATE(9977)] = 386532,
  [SMALL_STATE(9978)] = 386574,
  [SMALL_STATE(9979)] = 386600,
  [SMALL_STATE(9980)] = 386648,
  [SMALL_STATE(9981)] = 386690,
  [SMALL_STATE(9982)] = 386732,
  [SMALL_STATE(9983)] = 386758,
  [SMALL_STATE(9984)] = 386788,
  [SMALL_STATE(9985)] = 386816,
  [SMALL_STATE(9986)] = 386858,
  [SMALL_STATE(9987)] = 386884,
  [SMALL_STATE(9988)] = 386926,
  [SMALL_STATE(9989)] = 386968,
  [SMALL_STATE(9990)] = 387010,
  [SMALL_STATE(9991)] = 387052,
  [SMALL_STATE(9992)] = 387094,
  [SMALL_STATE(9993)] = 387120,
  [SMALL_STATE(9994)] = 387150,
  [SMALL_STATE(9995)] = 387192,
  [SMALL_STATE(9996)] = 387220,
  [SMALL_STATE(9997)] = 387246,
  [SMALL_STATE(9998)] = 387272,
  [SMALL_STATE(9999)] = 387298,
  [SMALL_STATE(10000)] = 387324,
  [SMALL_STATE(10001)] = 387350,
  [SMALL_STATE(10002)] = 387376,
  [SMALL_STATE(10003)] = 387402,
  [SMALL_STATE(10004)] = 387428,
  [SMALL_STATE(10005)] = 387454,
  [SMALL_STATE(10006)] = 387480,
  [SMALL_STATE(10007)] = 387522,
  [SMALL_STATE(10008)] = 387548,
  [SMALL_STATE(10009)] = 387574,
  [SMALL_STATE(10010)] = 387600,
  [SMALL_STATE(10011)] = 387642,
  [SMALL_STATE(10012)] = 387668,
  [SMALL_STATE(10013)] = 387694,
  [SMALL_STATE(10014)] = 387720,
  [SMALL_STATE(10015)] = 387752,
  [SMALL_STATE(10016)] = 387778,
  [SMALL_STATE(10017)] = 387806,
  [SMALL_STATE(10018)] = 387832,
  [SMALL_STATE(10019)] = 387858,
  [SMALL_STATE(10020)] = 387900,
  [SMALL_STATE(10021)] = 387926,
  [SMALL_STATE(10022)] = 387952,
  [SMALL_STATE(10023)] = 387978,
  [SMALL_STATE(10024)] = 388004,
  [SMALL_STATE(10025)] = 388030,
  [SMALL_STATE(10026)] = 388056,
  [SMALL_STATE(10027)] = 388098,
  [SMALL_STATE(10028)] = 388124,
  [SMALL_STATE(10029)] = 388150,
  [SMALL_STATE(10030)] = 388178,
  [SMALL_STATE(10031)] = 388204,
  [SMALL_STATE(10032)] = 388234,
  [SMALL_STATE(10033)] = 388260,
  [SMALL_STATE(10034)] = 388286,
  [SMALL_STATE(10035)] = 388312,
  [SMALL_STATE(10036)] = 388340,
  [SMALL_STATE(10037)] = 388366,
  [SMALL_STATE(10038)] = 388392,
  [SMALL_STATE(10039)] = 388418,
  [SMALL_STATE(10040)] = 388444,
  [SMALL_STATE(10041)] = 388470,
  [SMALL_STATE(10042)] = 388496,
  [SMALL_STATE(10043)] = 388522,
  [SMALL_STATE(10044)] = 388548,
  [SMALL_STATE(10045)] = 388576,
  [SMALL_STATE(10046)] = 388602,
  [SMALL_STATE(10047)] = 388628,
  [SMALL_STATE(10048)] = 388654,
  [SMALL_STATE(10049)] = 388680,
  [SMALL_STATE(10050)] = 388706,
  [SMALL_STATE(10051)] = 388748,
  [SMALL_STATE(10052)] = 388774,
  [SMALL_STATE(10053)] = 388800,
  [SMALL_STATE(10054)] = 388842,
  [SMALL_STATE(10055)] = 388868,
  [SMALL_STATE(10056)] = 388894,
  [SMALL_STATE(10057)] = 388920,
  [SMALL_STATE(10058)] = 388948,
  [SMALL_STATE(10059)] = 388974,
  [SMALL_STATE(10060)] = 389000,
  [SMALL_STATE(10061)] = 389042,
  [SMALL_STATE(10062)] = 389068,
  [SMALL_STATE(10063)] = 389106,
  [SMALL_STATE(10064)] = 389140,
  [SMALL_STATE(10065)] = 389166,
  [SMALL_STATE(10066)] = 389192,
  [SMALL_STATE(10067)] = 389220,
  [SMALL_STATE(10068)] = 389250,
  [SMALL_STATE(10069)] = 389276,
  [SMALL_STATE(10070)] = 389318,
  [SMALL_STATE(10071)] = 389360,
  [SMALL_STATE(10072)] = 389402,
  [SMALL_STATE(10073)] = 389444,
  [SMALL_STATE(10074)] = 389486,
  [SMALL_STATE(10075)] = 389528,
  [SMALL_STATE(10076)] = 389570,
  [SMALL_STATE(10077)] = 389596,
  [SMALL_STATE(10078)] = 389638,
  [SMALL_STATE(10079)] = 389678,
  [SMALL_STATE(10080)] = 389720,
  [SMALL_STATE(10081)] = 389762,
  [SMALL_STATE(10082)] = 389804,
  [SMALL_STATE(10083)] = 389846,
  [SMALL_STATE(10084)] = 389888,
  [SMALL_STATE(10085)] = 389930,
  [SMALL_STATE(10086)] = 389958,
  [SMALL_STATE(10087)] = 390000,
  [SMALL_STATE(10088)] = 390042,
  [SMALL_STATE(10089)] = 390072,
  [SMALL_STATE(10090)] = 390098,
  [SMALL_STATE(10091)] = 390140,
  [SMALL_STATE(10092)] = 390166,
  [SMALL_STATE(10093)] = 390196,
  [SMALL_STATE(10094)] = 390236,
  [SMALL_STATE(10095)] = 390278,
  [SMALL_STATE(10096)] = 390306,
  [SMALL_STATE(10097)] = 390332,
  [SMALL_STATE(10098)] = 390360,
  [SMALL_STATE(10099)] = 390386,
  [SMALL_STATE(10100)] = 390428,
  [SMALL_STATE(10101)] = 390458,
  [SMALL_STATE(10102)] = 390484,
  [SMALL_STATE(10103)] = 390510,
  [SMALL_STATE(10104)] = 390536,
  [SMALL_STATE(10105)] = 390564,
  [SMALL_STATE(10106)] = 390592,
  [SMALL_STATE(10107)] = 390624,
  [SMALL_STATE(10108)] = 390652,
  [SMALL_STATE(10109)] = 390694,
  [SMALL_STATE(10110)] = 390736,
  [SMALL_STATE(10111)] = 390778,
  [SMALL_STATE(10112)] = 390820,
  [SMALL_STATE(10113)] = 390862,
  [SMALL_STATE(10114)] = 390894,
  [SMALL_STATE(10115)] = 390924,
  [SMALL_STATE(10116)] = 390954,
  [SMALL_STATE(10117)] = 390996,
  [SMALL_STATE(10118)] = 391036,
  [SMALL_STATE(10119)] = 391064,
  [SMALL_STATE(10120)] = 391096,
  [SMALL_STATE(10121)] = 391122,
  [SMALL_STATE(10122)] = 391148,
  [SMALL_STATE(10123)] = 391190,
  [SMALL_STATE(10124)] = 391220,
  [SMALL_STATE(10125)] = 391246,
  [SMALL_STATE(10126)] = 391288,
  [SMALL_STATE(10127)] = 391318,
  [SMALL_STATE(10128)] = 391360,
  [SMALL_STATE(10129)] = 391388,
  [SMALL_STATE(10130)] = 391430,
  [SMALL_STATE(10131)] = 391456,
  [SMALL_STATE(10132)] = 391498,
  [SMALL_STATE(10133)] = 391540,
  [SMALL_STATE(10134)] = 391582,
  [SMALL_STATE(10135)] = 391624,
  [SMALL_STATE(10136)] = 391666,
  [SMALL_STATE(10137)] = 391700,
  [SMALL_STATE(10138)] = 391742,
  [SMALL_STATE(10139)] = 391784,
  [SMALL_STATE(10140)] = 391826,
  [SMALL_STATE(10141)] = 391852,
  [SMALL_STATE(10142)] = 391894,
  [SMALL_STATE(10143)] = 391924,
  [SMALL_STATE(10144)] = 391966,
  [SMALL_STATE(10145)] = 392008,
  [SMALL_STATE(10146)] = 392034,
  [SMALL_STATE(10147)] = 392076,
  [SMALL_STATE(10148)] = 392102,
  [SMALL_STATE(10149)] = 392144,
  [SMALL_STATE(10150)] = 392186,
  [SMALL_STATE(10151)] = 392228,
  [SMALL_STATE(10152)] = 392270,
  [SMALL_STATE(10153)] = 392298,
  [SMALL_STATE(10154)] = 392324,
  [SMALL_STATE(10155)] = 392366,
  [SMALL_STATE(10156)] = 392408,
  [SMALL_STATE(10157)] = 392434,
  [SMALL_STATE(10158)] = 392476,
  [SMALL_STATE(10159)] = 392502,
  [SMALL_STATE(10160)] = 392544,
  [SMALL_STATE(10161)] = 392586,
  [SMALL_STATE(10162)] = 392628,
  [SMALL_STATE(10163)] = 392670,
  [SMALL_STATE(10164)] = 392696,
  [SMALL_STATE(10165)] = 392724,
  [SMALL_STATE(10166)] = 392766,
  [SMALL_STATE(10167)] = 392794,
  [SMALL_STATE(10168)] = 392820,
  [SMALL_STATE(10169)] = 392862,
  [SMALL_STATE(10170)] = 392904,
  [SMALL_STATE(10171)] = 392930,
  [SMALL_STATE(10172)] = 392958,
  [SMALL_STATE(10173)] = 393000,
  [SMALL_STATE(10174)] = 393042,
  [SMALL_STATE(10175)] = 393072,
  [SMALL_STATE(10176)] = 393102,
  [SMALL_STATE(10177)] = 393128,
  [SMALL_STATE(10178)] = 393170,
  [SMALL_STATE(10179)] = 393200,
  [SMALL_STATE(10180)] = 393230,
  [SMALL_STATE(10181)] = 393272,
  [SMALL_STATE(10182)] = 393314,
  [SMALL_STATE(10183)] = 393356,
  [SMALL_STATE(10184)] = 393384,
  [SMALL_STATE(10185)] = 393410,
  [SMALL_STATE(10186)] = 393436,
  [SMALL_STATE(10187)] = 393478,
  [SMALL_STATE(10188)] = 393506,
  [SMALL_STATE(10189)] = 393532,
  [SMALL_STATE(10190)] = 393574,
  [SMALL_STATE(10191)] = 393616,
  [SMALL_STATE(10192)] = 393644,
  [SMALL_STATE(10193)] = 393672,
  [SMALL_STATE(10194)] = 393714,
  [SMALL_STATE(10195)] = 393740,
  [SMALL_STATE(10196)] = 393782,
  [SMALL_STATE(10197)] = 393808,
  [SMALL_STATE(10198)] = 393850,
  [SMALL_STATE(10199)] = 393892,
  [SMALL_STATE(10200)] = 393934,
  [SMALL_STATE(10201)] = 393962,
  [SMALL_STATE(10202)] = 394004,
  [SMALL_STATE(10203)] = 394046,
  [SMALL_STATE(10204)] = 394088,
  [SMALL_STATE(10205)] = 394130,
  [SMALL_STATE(10206)] = 394160,
  [SMALL_STATE(10207)] = 394202,
  [SMALL_STATE(10208)] = 394244,
  [SMALL_STATE(10209)] = 394272,
  [SMALL_STATE(10210)] = 394314,
  [SMALL_STATE(10211)] = 394342,
  [SMALL_STATE(10212)] = 394370,
  [SMALL_STATE(10213)] = 394412,
  [SMALL_STATE(10214)] = 394454,
  [SMALL_STATE(10215)] = 394494,
  [SMALL_STATE(10216)] = 394524,
  [SMALL_STATE(10217)] = 394552,
  [SMALL_STATE(10218)] = 394578,
  [SMALL_STATE(10219)] = 394620,
  [SMALL_STATE(10220)] = 394662,
  [SMALL_STATE(10221)] = 394704,
  [SMALL_STATE(10222)] = 394732,
  [SMALL_STATE(10223)] = 394758,
  [SMALL_STATE(10224)] = 394786,
  [SMALL_STATE(10225)] = 394828,
  [SMALL_STATE(10226)] = 394856,
  [SMALL_STATE(10227)] = 394898,
  [SMALL_STATE(10228)] = 394940,
  [SMALL_STATE(10229)] = 394982,
  [SMALL_STATE(10230)] = 395008,
  [SMALL_STATE(10231)] = 395036,
  [SMALL_STATE(10232)] = 395062,
  [SMALL_STATE(10233)] = 395104,
  [SMALL_STATE(10234)] = 395130,
  [SMALL_STATE(10235)] = 395170,
  [SMALL_STATE(10236)] = 395196,
  [SMALL_STATE(10237)] = 395222,
  [SMALL_STATE(10238)] = 395248,
  [SMALL_STATE(10239)] = 395274,
  [SMALL_STATE(10240)] = 395300,
  [SMALL_STATE(10241)] = 395326,
  [SMALL_STATE(10242)] = 395352,
  [SMALL_STATE(10243)] = 395378,
  [SMALL_STATE(10244)] = 395404,
  [SMALL_STATE(10245)] = 395452,
  [SMALL_STATE(10246)] = 395494,
  [SMALL_STATE(10247)] = 395520,
  [SMALL_STATE(10248)] = 395552,
  [SMALL_STATE(10249)] = 395578,
  [SMALL_STATE(10250)] = 395604,
  [SMALL_STATE(10251)] = 395630,
  [SMALL_STATE(10252)] = 395672,
  [SMALL_STATE(10253)] = 395714,
  [SMALL_STATE(10254)] = 395746,
  [SMALL_STATE(10255)] = 395778,
  [SMALL_STATE(10256)] = 395804,
  [SMALL_STATE(10257)] = 395846,
  [SMALL_STATE(10258)] = 395872,
  [SMALL_STATE(10259)] = 395898,
  [SMALL_STATE(10260)] = 395940,
  [SMALL_STATE(10261)] = 395982,
  [SMALL_STATE(10262)] = 396014,
  [SMALL_STATE(10263)] = 396056,
  [SMALL_STATE(10264)] = 396098,
  [SMALL_STATE(10265)] = 396124,
  [SMALL_STATE(10266)] = 396152,
  [SMALL_STATE(10267)] = 396194,
  [SMALL_STATE(10268)] = 396220,
  [SMALL_STATE(10269)] = 396268,
  [SMALL_STATE(10270)] = 396316,
  [SMALL_STATE(10271)] = 396342,
  [SMALL_STATE(10272)] = 396368,
  [SMALL_STATE(10273)] = 396410,
  [SMALL_STATE(10274)] = 396452,
  [SMALL_STATE(10275)] = 396482,
  [SMALL_STATE(10276)] = 396508,
  [SMALL_STATE(10277)] = 396550,
  [SMALL_STATE(10278)] = 396592,
  [SMALL_STATE(10279)] = 396634,
  [SMALL_STATE(10280)] = 396676,
  [SMALL_STATE(10281)] = 396702,
  [SMALL_STATE(10282)] = 396730,
  [SMALL_STATE(10283)] = 396758,
  [SMALL_STATE(10284)] = 396800,
  [SMALL_STATE(10285)] = 396842,
  [SMALL_STATE(10286)] = 396882,
  [SMALL_STATE(10287)] = 396924,
  [SMALL_STATE(10288)] = 396966,
  [SMALL_STATE(10289)] = 397008,
  [SMALL_STATE(10290)] = 397048,
  [SMALL_STATE(10291)] = 397074,
  [SMALL_STATE(10292)] = 397116,
  [SMALL_STATE(10293)] = 397158,
  [SMALL_STATE(10294)] = 397188,
  [SMALL_STATE(10295)] = 397216,
  [SMALL_STATE(10296)] = 397258,
  [SMALL_STATE(10297)] = 397284,
  [SMALL_STATE(10298)] = 397326,
  [SMALL_STATE(10299)] = 397368,
  [SMALL_STATE(10300)] = 397410,
  [SMALL_STATE(10301)] = 397450,
  [SMALL_STATE(10302)] = 397498,
  [SMALL_STATE(10303)] = 397528,
  [SMALL_STATE(10304)] = 397554,
  [SMALL_STATE(10305)] = 397596,
  [SMALL_STATE(10306)] = 397638,
  [SMALL_STATE(10307)] = 397666,
  [SMALL_STATE(10308)] = 397708,
  [SMALL_STATE(10309)] = 397750,
  [SMALL_STATE(10310)] = 397776,
  [SMALL_STATE(10311)] = 397818,
  [SMALL_STATE(10312)] = 397842,
  [SMALL_STATE(10313)] = 397866,
  [SMALL_STATE(10314)] = 397908,
  [SMALL_STATE(10315)] = 397936,
  [SMALL_STATE(10316)] = 397978,
  [SMALL_STATE(10317)] = 398006,
  [SMALL_STATE(10318)] = 398048,
  [SMALL_STATE(10319)] = 398072,
  [SMALL_STATE(10320)] = 398097,
  [SMALL_STATE(10321)] = 398122,
  [SMALL_STATE(10322)] = 398147,
  [SMALL_STATE(10323)] = 398172,
  [SMALL_STATE(10324)] = 398197,
  [SMALL_STATE(10325)] = 398224,
  [SMALL_STATE(10326)] = 398249,
  [SMALL_STATE(10327)] = 398274,
  [SMALL_STATE(10328)] = 398299,
  [SMALL_STATE(10329)] = 398324,
  [SMALL_STATE(10330)] = 398349,
  [SMALL_STATE(10331)] = 398388,
  [SMALL_STATE(10332)] = 398413,
  [SMALL_STATE(10333)] = 398438,
  [SMALL_STATE(10334)] = 398463,
  [SMALL_STATE(10335)] = 398488,
  [SMALL_STATE(10336)] = 398517,
  [SMALL_STATE(10337)] = 398542,
  [SMALL_STATE(10338)] = 398567,
  [SMALL_STATE(10339)] = 398596,
  [SMALL_STATE(10340)] = 398621,
  [SMALL_STATE(10341)] = 398646,
  [SMALL_STATE(10342)] = 398671,
  [SMALL_STATE(10343)] = 398696,
  [SMALL_STATE(10344)] = 398723,
  [SMALL_STATE(10345)] = 398748,
  [SMALL_STATE(10346)] = 398787,
  [SMALL_STATE(10347)] = 398812,
  [SMALL_STATE(10348)] = 398837,
  [SMALL_STATE(10349)] = 398862,
  [SMALL_STATE(10350)] = 398887,
  [SMALL_STATE(10351)] = 398912,
  [SMALL_STATE(10352)] = 398937,
  [SMALL_STATE(10353)] = 398962,
  [SMALL_STATE(10354)] = 398991,
  [SMALL_STATE(10355)] = 399016,
  [SMALL_STATE(10356)] = 399043,
  [SMALL_STATE(10357)] = 399068,
  [SMALL_STATE(10358)] = 399093,
  [SMALL_STATE(10359)] = 399118,
  [SMALL_STATE(10360)] = 399143,
  [SMALL_STATE(10361)] = 399172,
  [SMALL_STATE(10362)] = 399197,
  [SMALL_STATE(10363)] = 399222,
  [SMALL_STATE(10364)] = 399247,
  [SMALL_STATE(10365)] = 399272,
  [SMALL_STATE(10366)] = 399299,
  [SMALL_STATE(10367)] = 399324,
  [SMALL_STATE(10368)] = 399361,
  [SMALL_STATE(10369)] = 399386,
  [SMALL_STATE(10370)] = 399411,
  [SMALL_STATE(10371)] = 399438,
  [SMALL_STATE(10372)] = 399467,
  [SMALL_STATE(10373)] = 399492,
  [SMALL_STATE(10374)] = 399521,
  [SMALL_STATE(10375)] = 399546,
  [SMALL_STATE(10376)] = 399573,
  [SMALL_STATE(10377)] = 399598,
  [SMALL_STATE(10378)] = 399627,
  [SMALL_STATE(10379)] = 399652,
  [SMALL_STATE(10380)] = 399677,
  [SMALL_STATE(10381)] = 399702,
  [SMALL_STATE(10382)] = 399727,
  [SMALL_STATE(10383)] = 399752,
  [SMALL_STATE(10384)] = 399777,
  [SMALL_STATE(10385)] = 399806,
  [SMALL_STATE(10386)] = 399833,
  [SMALL_STATE(10387)] = 399858,
  [SMALL_STATE(10388)] = 399883,
  [SMALL_STATE(10389)] = 399908,
  [SMALL_STATE(10390)] = 399933,
  [SMALL_STATE(10391)] = 399958,
  [SMALL_STATE(10392)] = 399987,
  [SMALL_STATE(10393)] = 400012,
  [SMALL_STATE(10394)] = 400037,
  [SMALL_STATE(10395)] = 400062,
  [SMALL_STATE(10396)] = 400087,
  [SMALL_STATE(10397)] = 400114,
  [SMALL_STATE(10398)] = 400139,
  [SMALL_STATE(10399)] = 400164,
  [SMALL_STATE(10400)] = 400189,
  [SMALL_STATE(10401)] = 400214,
  [SMALL_STATE(10402)] = 400239,
  [SMALL_STATE(10403)] = 400266,
  [SMALL_STATE(10404)] = 400293,
  [SMALL_STATE(10405)] = 400318,
  [SMALL_STATE(10406)] = 400343,
  [SMALL_STATE(10407)] = 400374,
  [SMALL_STATE(10408)] = 400399,
  [SMALL_STATE(10409)] = 400424,
  [SMALL_STATE(10410)] = 400451,
  [SMALL_STATE(10411)] = 400476,
  [SMALL_STATE(10412)] = 400501,
  [SMALL_STATE(10413)] = 400526,
  [SMALL_STATE(10414)] = 400553,
  [SMALL_STATE(10415)] = 400578,
  [SMALL_STATE(10416)] = 400603,
  [SMALL_STATE(10417)] = 400640,
  [SMALL_STATE(10418)] = 400667,
  [SMALL_STATE(10419)] = 400692,
  [SMALL_STATE(10420)] = 400721,
  [SMALL_STATE(10421)] = 400746,
  [SMALL_STATE(10422)] = 400771,
  [SMALL_STATE(10423)] = 400796,
  [SMALL_STATE(10424)] = 400821,
  [SMALL_STATE(10425)] = 400846,
  [SMALL_STATE(10426)] = 400871,
  [SMALL_STATE(10427)] = 400900,
  [SMALL_STATE(10428)] = 400925,
  [SMALL_STATE(10429)] = 400952,
  [SMALL_STATE(10430)] = 400981,
  [SMALL_STATE(10431)] = 401006,
  [SMALL_STATE(10432)] = 401031,
  [SMALL_STATE(10433)] = 401056,
  [SMALL_STATE(10434)] = 401081,
  [SMALL_STATE(10435)] = 401106,
  [SMALL_STATE(10436)] = 401131,
  [SMALL_STATE(10437)] = 401156,
  [SMALL_STATE(10438)] = 401181,
  [SMALL_STATE(10439)] = 401206,
  [SMALL_STATE(10440)] = 401231,
  [SMALL_STATE(10441)] = 401256,
  [SMALL_STATE(10442)] = 401281,
  [SMALL_STATE(10443)] = 401306,
  [SMALL_STATE(10444)] = 401331,
  [SMALL_STATE(10445)] = 401356,
  [SMALL_STATE(10446)] = 401385,
  [SMALL_STATE(10447)] = 401414,
  [SMALL_STATE(10448)] = 401439,
  [SMALL_STATE(10449)] = 401464,
  [SMALL_STATE(10450)] = 401489,
  [SMALL_STATE(10451)] = 401514,
  [SMALL_STATE(10452)] = 401539,
  [SMALL_STATE(10453)] = 401564,
  [SMALL_STATE(10454)] = 401589,
  [SMALL_STATE(10455)] = 401614,
  [SMALL_STATE(10456)] = 401639,
  [SMALL_STATE(10457)] = 401664,
  [SMALL_STATE(10458)] = 401689,
  [SMALL_STATE(10459)] = 401714,
  [SMALL_STATE(10460)] = 401739,
  [SMALL_STATE(10461)] = 401764,
  [SMALL_STATE(10462)] = 401789,
  [SMALL_STATE(10463)] = 401814,
  [SMALL_STATE(10464)] = 401839,
  [SMALL_STATE(10465)] = 401864,
  [SMALL_STATE(10466)] = 401889,
  [SMALL_STATE(10467)] = 401914,
  [SMALL_STATE(10468)] = 401939,
  [SMALL_STATE(10469)] = 401964,
  [SMALL_STATE(10470)] = 401989,
  [SMALL_STATE(10471)] = 402018,
  [SMALL_STATE(10472)] = 402043,
  [SMALL_STATE(10473)] = 402068,
  [SMALL_STATE(10474)] = 402093,
  [SMALL_STATE(10475)] = 402118,
  [SMALL_STATE(10476)] = 402143,
  [SMALL_STATE(10477)] = 402168,
  [SMALL_STATE(10478)] = 402193,
  [SMALL_STATE(10479)] = 402218,
  [SMALL_STATE(10480)] = 402243,
  [SMALL_STATE(10481)] = 402268,
  [SMALL_STATE(10482)] = 402293,
  [SMALL_STATE(10483)] = 402318,
  [SMALL_STATE(10484)] = 402343,
  [SMALL_STATE(10485)] = 402368,
  [SMALL_STATE(10486)] = 402395,
  [SMALL_STATE(10487)] = 402420,
  [SMALL_STATE(10488)] = 402445,
  [SMALL_STATE(10489)] = 402470,
  [SMALL_STATE(10490)] = 402495,
  [SMALL_STATE(10491)] = 402520,
  [SMALL_STATE(10492)] = 402545,
  [SMALL_STATE(10493)] = 402570,
  [SMALL_STATE(10494)] = 402595,
  [SMALL_STATE(10495)] = 402620,
  [SMALL_STATE(10496)] = 402645,
  [SMALL_STATE(10497)] = 402670,
  [SMALL_STATE(10498)] = 402695,
  [SMALL_STATE(10499)] = 402720,
  [SMALL_STATE(10500)] = 402749,
  [SMALL_STATE(10501)] = 402774,
  [SMALL_STATE(10502)] = 402799,
  [SMALL_STATE(10503)] = 402824,
  [SMALL_STATE(10504)] = 402849,
  [SMALL_STATE(10505)] = 402874,
  [SMALL_STATE(10506)] = 402901,
  [SMALL_STATE(10507)] = 402926,
  [SMALL_STATE(10508)] = 402951,
  [SMALL_STATE(10509)] = 402976,
  [SMALL_STATE(10510)] = 403001,
  [SMALL_STATE(10511)] = 403028,
  [SMALL_STATE(10512)] = 403053,
  [SMALL_STATE(10513)] = 403078,
  [SMALL_STATE(10514)] = 403103,
  [SMALL_STATE(10515)] = 403128,
  [SMALL_STATE(10516)] = 403153,
  [SMALL_STATE(10517)] = 403178,
  [SMALL_STATE(10518)] = 403203,
  [SMALL_STATE(10519)] = 403228,
  [SMALL_STATE(10520)] = 403255,
  [SMALL_STATE(10521)] = 403282,
  [SMALL_STATE(10522)] = 403307,
  [SMALL_STATE(10523)] = 403332,
  [SMALL_STATE(10524)] = 403357,
  [SMALL_STATE(10525)] = 403382,
  [SMALL_STATE(10526)] = 403409,
  [SMALL_STATE(10527)] = 403434,
  [SMALL_STATE(10528)] = 403459,
  [SMALL_STATE(10529)] = 403484,
  [SMALL_STATE(10530)] = 403509,
  [SMALL_STATE(10531)] = 403534,
  [SMALL_STATE(10532)] = 403559,
  [SMALL_STATE(10533)] = 403584,
  [SMALL_STATE(10534)] = 403609,
  [SMALL_STATE(10535)] = 403634,
  [SMALL_STATE(10536)] = 403659,
  [SMALL_STATE(10537)] = 403698,
  [SMALL_STATE(10538)] = 403723,
  [SMALL_STATE(10539)] = 403748,
  [SMALL_STATE(10540)] = 403773,
  [SMALL_STATE(10541)] = 403802,
  [SMALL_STATE(10542)] = 403827,
  [SMALL_STATE(10543)] = 403856,
  [SMALL_STATE(10544)] = 403885,
  [SMALL_STATE(10545)] = 403914,
  [SMALL_STATE(10546)] = 403941,
  [SMALL_STATE(10547)] = 403966,
  [SMALL_STATE(10548)] = 403993,
  [SMALL_STATE(10549)] = 404024,
  [SMALL_STATE(10550)] = 404051,
  [SMALL_STATE(10551)] = 404078,
  [SMALL_STATE(10552)] = 404103,
  [SMALL_STATE(10553)] = 404128,
  [SMALL_STATE(10554)] = 404167,
  [SMALL_STATE(10555)] = 404192,
  [SMALL_STATE(10556)] = 404219,
  [SMALL_STATE(10557)] = 404244,
  [SMALL_STATE(10558)] = 404269,
  [SMALL_STATE(10559)] = 404294,
  [SMALL_STATE(10560)] = 404323,
  [SMALL_STATE(10561)] = 404350,
  [SMALL_STATE(10562)] = 404375,
  [SMALL_STATE(10563)] = 404402,
  [SMALL_STATE(10564)] = 404427,
  [SMALL_STATE(10565)] = 404452,
  [SMALL_STATE(10566)] = 404477,
  [SMALL_STATE(10567)] = 404522,
  [SMALL_STATE(10568)] = 404547,
  [SMALL_STATE(10569)] = 404572,
  [SMALL_STATE(10570)] = 404597,
  [SMALL_STATE(10571)] = 404624,
  [SMALL_STATE(10572)] = 404651,
  [SMALL_STATE(10573)] = 404676,
  [SMALL_STATE(10574)] = 404701,
  [SMALL_STATE(10575)] = 404726,
  [SMALL_STATE(10576)] = 404751,
  [SMALL_STATE(10577)] = 404776,
  [SMALL_STATE(10578)] = 404801,
  [SMALL_STATE(10579)] = 404826,
  [SMALL_STATE(10580)] = 404851,
  [SMALL_STATE(10581)] = 404876,
  [SMALL_STATE(10582)] = 404901,
  [SMALL_STATE(10583)] = 404936,
  [SMALL_STATE(10584)] = 404961,
  [SMALL_STATE(10585)] = 404988,
  [SMALL_STATE(10586)] = 405013,
  [SMALL_STATE(10587)] = 405038,
  [SMALL_STATE(10588)] = 405063,
  [SMALL_STATE(10589)] = 405090,
  [SMALL_STATE(10590)] = 405119,
  [SMALL_STATE(10591)] = 405144,
  [SMALL_STATE(10592)] = 405171,
  [SMALL_STATE(10593)] = 405202,
  [SMALL_STATE(10594)] = 405229,
  [SMALL_STATE(10595)] = 405256,
  [SMALL_STATE(10596)] = 405281,
  [SMALL_STATE(10597)] = 405306,
  [SMALL_STATE(10598)] = 405331,
  [SMALL_STATE(10599)] = 405356,
  [SMALL_STATE(10600)] = 405381,
  [SMALL_STATE(10601)] = 405406,
  [SMALL_STATE(10602)] = 405431,
  [SMALL_STATE(10603)] = 405456,
  [SMALL_STATE(10604)] = 405481,
  [SMALL_STATE(10605)] = 405506,
  [SMALL_STATE(10606)] = 405533,
  [SMALL_STATE(10607)] = 405562,
  [SMALL_STATE(10608)] = 405589,
  [SMALL_STATE(10609)] = 405614,
  [SMALL_STATE(10610)] = 405639,
  [SMALL_STATE(10611)] = 405664,
  [SMALL_STATE(10612)] = 405691,
  [SMALL_STATE(10613)] = 405716,
  [SMALL_STATE(10614)] = 405745,
  [SMALL_STATE(10615)] = 405772,
  [SMALL_STATE(10616)] = 405797,
  [SMALL_STATE(10617)] = 405822,
  [SMALL_STATE(10618)] = 405849,
  [SMALL_STATE(10619)] = 405874,
  [SMALL_STATE(10620)] = 405899,
  [SMALL_STATE(10621)] = 405926,
  [SMALL_STATE(10622)] = 405951,
  [SMALL_STATE(10623)] = 405980,
  [SMALL_STATE(10624)] = 406009,
  [SMALL_STATE(10625)] = 406034,
  [SMALL_STATE(10626)] = 406059,
  [SMALL_STATE(10627)] = 406090,
  [SMALL_STATE(10628)] = 406115,
  [SMALL_STATE(10629)] = 406142,
  [SMALL_STATE(10630)] = 406167,
  [SMALL_STATE(10631)] = 406192,
  [SMALL_STATE(10632)] = 406217,
  [SMALL_STATE(10633)] = 406242,
  [SMALL_STATE(10634)] = 406267,
  [SMALL_STATE(10635)] = 406292,
  [SMALL_STATE(10636)] = 406317,
  [SMALL_STATE(10637)] = 406342,
  [SMALL_STATE(10638)] = 406367,
  [SMALL_STATE(10639)] = 406392,
  [SMALL_STATE(10640)] = 406417,
  [SMALL_STATE(10641)] = 406442,
  [SMALL_STATE(10642)] = 406467,
  [SMALL_STATE(10643)] = 406492,
  [SMALL_STATE(10644)] = 406521,
  [SMALL_STATE(10645)] = 406550,
  [SMALL_STATE(10646)] = 406575,
  [SMALL_STATE(10647)] = 406600,
  [SMALL_STATE(10648)] = 406625,
  [SMALL_STATE(10649)] = 406650,
  [SMALL_STATE(10650)] = 406675,
  [SMALL_STATE(10651)] = 406700,
  [SMALL_STATE(10652)] = 406727,
  [SMALL_STATE(10653)] = 406756,
  [SMALL_STATE(10654)] = 406781,
  [SMALL_STATE(10655)] = 406806,
  [SMALL_STATE(10656)] = 406831,
  [SMALL_STATE(10657)] = 406856,
  [SMALL_STATE(10658)] = 406881,
  [SMALL_STATE(10659)] = 406906,
  [SMALL_STATE(10660)] = 406931,
  [SMALL_STATE(10661)] = 406956,
  [SMALL_STATE(10662)] = 406981,
  [SMALL_STATE(10663)] = 407006,
  [SMALL_STATE(10664)] = 407035,
  [SMALL_STATE(10665)] = 407064,
  [SMALL_STATE(10666)] = 407091,
  [SMALL_STATE(10667)] = 407122,
  [SMALL_STATE(10668)] = 407147,
  [SMALL_STATE(10669)] = 407172,
  [SMALL_STATE(10670)] = 407197,
  [SMALL_STATE(10671)] = 407222,
  [SMALL_STATE(10672)] = 407251,
  [SMALL_STATE(10673)] = 407276,
  [SMALL_STATE(10674)] = 407301,
  [SMALL_STATE(10675)] = 407332,
  [SMALL_STATE(10676)] = 407361,
  [SMALL_STATE(10677)] = 407386,
  [SMALL_STATE(10678)] = 407411,
  [SMALL_STATE(10679)] = 407436,
  [SMALL_STATE(10680)] = 407461,
  [SMALL_STATE(10681)] = 407486,
  [SMALL_STATE(10682)] = 407515,
  [SMALL_STATE(10683)] = 407544,
  [SMALL_STATE(10684)] = 407569,
  [SMALL_STATE(10685)] = 407594,
  [SMALL_STATE(10686)] = 407619,
  [SMALL_STATE(10687)] = 407644,
  [SMALL_STATE(10688)] = 407669,
  [SMALL_STATE(10689)] = 407698,
  [SMALL_STATE(10690)] = 407723,
  [SMALL_STATE(10691)] = 407748,
  [SMALL_STATE(10692)] = 407773,
  [SMALL_STATE(10693)] = 407798,
  [SMALL_STATE(10694)] = 407823,
  [SMALL_STATE(10695)] = 407848,
  [SMALL_STATE(10696)] = 407873,
  [SMALL_STATE(10697)] = 407898,
  [SMALL_STATE(10698)] = 407923,
  [SMALL_STATE(10699)] = 407948,
  [SMALL_STATE(10700)] = 407973,
  [SMALL_STATE(10701)] = 407998,
  [SMALL_STATE(10702)] = 408023,
  [SMALL_STATE(10703)] = 408048,
  [SMALL_STATE(10704)] = 408073,
  [SMALL_STATE(10705)] = 408098,
  [SMALL_STATE(10706)] = 408123,
  [SMALL_STATE(10707)] = 408148,
  [SMALL_STATE(10708)] = 408173,
  [SMALL_STATE(10709)] = 408198,
  [SMALL_STATE(10710)] = 408223,
  [SMALL_STATE(10711)] = 408252,
  [SMALL_STATE(10712)] = 408277,
  [SMALL_STATE(10713)] = 408304,
  [SMALL_STATE(10714)] = 408329,
  [SMALL_STATE(10715)] = 408354,
  [SMALL_STATE(10716)] = 408379,
  [SMALL_STATE(10717)] = 408404,
  [SMALL_STATE(10718)] = 408429,
  [SMALL_STATE(10719)] = 408458,
  [SMALL_STATE(10720)] = 408483,
  [SMALL_STATE(10721)] = 408508,
  [SMALL_STATE(10722)] = 408533,
  [SMALL_STATE(10723)] = 408558,
  [SMALL_STATE(10724)] = 408583,
  [SMALL_STATE(10725)] = 408612,
  [SMALL_STATE(10726)] = 408637,
  [SMALL_STATE(10727)] = 408662,
  [SMALL_STATE(10728)] = 408687,
  [SMALL_STATE(10729)] = 408712,
  [SMALL_STATE(10730)] = 408737,
  [SMALL_STATE(10731)] = 408762,
  [SMALL_STATE(10732)] = 408787,
  [SMALL_STATE(10733)] = 408814,
  [SMALL_STATE(10734)] = 408839,
  [SMALL_STATE(10735)] = 408864,
  [SMALL_STATE(10736)] = 408889,
  [SMALL_STATE(10737)] = 408914,
  [SMALL_STATE(10738)] = 408939,
  [SMALL_STATE(10739)] = 408964,
  [SMALL_STATE(10740)] = 408989,
  [SMALL_STATE(10741)] = 409014,
  [SMALL_STATE(10742)] = 409039,
  [SMALL_STATE(10743)] = 409064,
  [SMALL_STATE(10744)] = 409089,
  [SMALL_STATE(10745)] = 409114,
  [SMALL_STATE(10746)] = 409139,
  [SMALL_STATE(10747)] = 409164,
  [SMALL_STATE(10748)] = 409189,
  [SMALL_STATE(10749)] = 409214,
  [SMALL_STATE(10750)] = 409239,
  [SMALL_STATE(10751)] = 409264,
  [SMALL_STATE(10752)] = 409289,
  [SMALL_STATE(10753)] = 409314,
  [SMALL_STATE(10754)] = 409339,
  [SMALL_STATE(10755)] = 409364,
  [SMALL_STATE(10756)] = 409389,
  [SMALL_STATE(10757)] = 409416,
  [SMALL_STATE(10758)] = 409441,
  [SMALL_STATE(10759)] = 409466,
  [SMALL_STATE(10760)] = 409491,
  [SMALL_STATE(10761)] = 409516,
  [SMALL_STATE(10762)] = 409541,
  [SMALL_STATE(10763)] = 409566,
  [SMALL_STATE(10764)] = 409593,
  [SMALL_STATE(10765)] = 409618,
  [SMALL_STATE(10766)] = 409643,
  [SMALL_STATE(10767)] = 409668,
  [SMALL_STATE(10768)] = 409693,
  [SMALL_STATE(10769)] = 409718,
  [SMALL_STATE(10770)] = 409743,
  [SMALL_STATE(10771)] = 409768,
  [SMALL_STATE(10772)] = 409793,
  [SMALL_STATE(10773)] = 409818,
  [SMALL_STATE(10774)] = 409843,
  [SMALL_STATE(10775)] = 409868,
  [SMALL_STATE(10776)] = 409893,
  [SMALL_STATE(10777)] = 409918,
  [SMALL_STATE(10778)] = 409943,
  [SMALL_STATE(10779)] = 409968,
  [SMALL_STATE(10780)] = 409993,
  [SMALL_STATE(10781)] = 410018,
  [SMALL_STATE(10782)] = 410043,
  [SMALL_STATE(10783)] = 410068,
  [SMALL_STATE(10784)] = 410093,
  [SMALL_STATE(10785)] = 410118,
  [SMALL_STATE(10786)] = 410143,
  [SMALL_STATE(10787)] = 410168,
  [SMALL_STATE(10788)] = 410193,
  [SMALL_STATE(10789)] = 410218,
  [SMALL_STATE(10790)] = 410243,
  [SMALL_STATE(10791)] = 410268,
  [SMALL_STATE(10792)] = 410295,
  [SMALL_STATE(10793)] = 410320,
  [SMALL_STATE(10794)] = 410345,
  [SMALL_STATE(10795)] = 410370,
  [SMALL_STATE(10796)] = 410395,
  [SMALL_STATE(10797)] = 410420,
  [SMALL_STATE(10798)] = 410445,
  [SMALL_STATE(10799)] = 410470,
  [SMALL_STATE(10800)] = 410495,
  [SMALL_STATE(10801)] = 410520,
  [SMALL_STATE(10802)] = 410545,
  [SMALL_STATE(10803)] = 410570,
  [SMALL_STATE(10804)] = 410595,
  [SMALL_STATE(10805)] = 410620,
  [SMALL_STATE(10806)] = 410645,
  [SMALL_STATE(10807)] = 410672,
  [SMALL_STATE(10808)] = 410697,
  [SMALL_STATE(10809)] = 410722,
  [SMALL_STATE(10810)] = 410747,
  [SMALL_STATE(10811)] = 410772,
  [SMALL_STATE(10812)] = 410797,
  [SMALL_STATE(10813)] = 410826,
  [SMALL_STATE(10814)] = 410853,
  [SMALL_STATE(10815)] = 410878,
  [SMALL_STATE(10816)] = 410903,
  [SMALL_STATE(10817)] = 410928,
  [SMALL_STATE(10818)] = 410955,
  [SMALL_STATE(10819)] = 410982,
  [SMALL_STATE(10820)] = 411007,
  [SMALL_STATE(10821)] = 411032,
  [SMALL_STATE(10822)] = 411057,
  [SMALL_STATE(10823)] = 411082,
  [SMALL_STATE(10824)] = 411107,
  [SMALL_STATE(10825)] = 411132,
  [SMALL_STATE(10826)] = 411157,
  [SMALL_STATE(10827)] = 411182,
  [SMALL_STATE(10828)] = 411213,
  [SMALL_STATE(10829)] = 411242,
  [SMALL_STATE(10830)] = 411267,
  [SMALL_STATE(10831)] = 411292,
  [SMALL_STATE(10832)] = 411317,
  [SMALL_STATE(10833)] = 411342,
  [SMALL_STATE(10834)] = 411367,
  [SMALL_STATE(10835)] = 411396,
  [SMALL_STATE(10836)] = 411421,
  [SMALL_STATE(10837)] = 411446,
  [SMALL_STATE(10838)] = 411471,
  [SMALL_STATE(10839)] = 411496,
  [SMALL_STATE(10840)] = 411521,
  [SMALL_STATE(10841)] = 411546,
  [SMALL_STATE(10842)] = 411571,
  [SMALL_STATE(10843)] = 411596,
  [SMALL_STATE(10844)] = 411621,
  [SMALL_STATE(10845)] = 411646,
  [SMALL_STATE(10846)] = 411671,
  [SMALL_STATE(10847)] = 411696,
  [SMALL_STATE(10848)] = 411721,
  [SMALL_STATE(10849)] = 411750,
  [SMALL_STATE(10850)] = 411775,
  [SMALL_STATE(10851)] = 411800,
  [SMALL_STATE(10852)] = 411825,
  [SMALL_STATE(10853)] = 411850,
  [SMALL_STATE(10854)] = 411879,
  [SMALL_STATE(10855)] = 411904,
  [SMALL_STATE(10856)] = 411929,
  [SMALL_STATE(10857)] = 411954,
  [SMALL_STATE(10858)] = 411985,
  [SMALL_STATE(10859)] = 412009,
  [SMALL_STATE(10860)] = 412033,
  [SMALL_STATE(10861)] = 412057,
  [SMALL_STATE(10862)] = 412081,
  [SMALL_STATE(10863)] = 412107,
  [SMALL_STATE(10864)] = 412131,
  [SMALL_STATE(10865)] = 412155,
  [SMALL_STATE(10866)] = 412179,
  [SMALL_STATE(10867)] = 412203,
  [SMALL_STATE(10868)] = 412227,
  [SMALL_STATE(10869)] = 412251,
  [SMALL_STATE(10870)] = 412275,
  [SMALL_STATE(10871)] = 412301,
  [SMALL_STATE(10872)] = 412327,
  [SMALL_STATE(10873)] = 412351,
  [SMALL_STATE(10874)] = 412373,
  [SMALL_STATE(10875)] = 412395,
  [SMALL_STATE(10876)] = 412417,
  [SMALL_STATE(10877)] = 412441,
  [SMALL_STATE(10878)] = 412465,
  [SMALL_STATE(10879)] = 412489,
  [SMALL_STATE(10880)] = 412513,
  [SMALL_STATE(10881)] = 412537,
  [SMALL_STATE(10882)] = 412561,
  [SMALL_STATE(10883)] = 412587,
  [SMALL_STATE(10884)] = 412609,
  [SMALL_STATE(10885)] = 412633,
  [SMALL_STATE(10886)] = 412657,
  [SMALL_STATE(10887)] = 412681,
  [SMALL_STATE(10888)] = 412711,
  [SMALL_STATE(10889)] = 412735,
  [SMALL_STATE(10890)] = 412759,
  [SMALL_STATE(10891)] = 412783,
  [SMALL_STATE(10892)] = 412807,
  [SMALL_STATE(10893)] = 412831,
  [SMALL_STATE(10894)] = 412855,
  [SMALL_STATE(10895)] = 412879,
  [SMALL_STATE(10896)] = 412903,
  [SMALL_STATE(10897)] = 412925,
  [SMALL_STATE(10898)] = 412949,
  [SMALL_STATE(10899)] = 412973,
  [SMALL_STATE(10900)] = 412997,
  [SMALL_STATE(10901)] = 413021,
  [SMALL_STATE(10902)] = 413045,
  [SMALL_STATE(10903)] = 413069,
  [SMALL_STATE(10904)] = 413093,
  [SMALL_STATE(10905)] = 413117,
  [SMALL_STATE(10906)] = 413141,
  [SMALL_STATE(10907)] = 413165,
  [SMALL_STATE(10908)] = 413189,
  [SMALL_STATE(10909)] = 413213,
  [SMALL_STATE(10910)] = 413235,
  [SMALL_STATE(10911)] = 413259,
  [SMALL_STATE(10912)] = 413283,
  [SMALL_STATE(10913)] = 413305,
  [SMALL_STATE(10914)] = 413329,
  [SMALL_STATE(10915)] = 413353,
  [SMALL_STATE(10916)] = 413377,
  [SMALL_STATE(10917)] = 413401,
  [SMALL_STATE(10918)] = 413425,
  [SMALL_STATE(10919)] = 413453,
  [SMALL_STATE(10920)] = 413477,
  [SMALL_STATE(10921)] = 413501,
  [SMALL_STATE(10922)] = 413523,
  [SMALL_STATE(10923)] = 413545,
  [SMALL_STATE(10924)] = 413569,
  [SMALL_STATE(10925)] = 413593,
  [SMALL_STATE(10926)] = 413617,
  [SMALL_STATE(10927)] = 413641,
  [SMALL_STATE(10928)] = 413665,
  [SMALL_STATE(10929)] = 413689,
  [SMALL_STATE(10930)] = 413715,
  [SMALL_STATE(10931)] = 413739,
  [SMALL_STATE(10932)] = 413763,
  [SMALL_STATE(10933)] = 413787,
  [SMALL_STATE(10934)] = 413811,
  [SMALL_STATE(10935)] = 413835,
  [SMALL_STATE(10936)] = 413859,
  [SMALL_STATE(10937)] = 413883,
  [SMALL_STATE(10938)] = 413907,
  [SMALL_STATE(10939)] = 413929,
  [SMALL_STATE(10940)] = 413951,
  [SMALL_STATE(10941)] = 413975,
  [SMALL_STATE(10942)] = 413999,
  [SMALL_STATE(10943)] = 414029,
  [SMALL_STATE(10944)] = 414053,
  [SMALL_STATE(10945)] = 414081,
  [SMALL_STATE(10946)] = 414105,
  [SMALL_STATE(10947)] = 414129,
  [SMALL_STATE(10948)] = 414153,
  [SMALL_STATE(10949)] = 414177,
  [SMALL_STATE(10950)] = 414201,
  [SMALL_STATE(10951)] = 414225,
  [SMALL_STATE(10952)] = 414249,
  [SMALL_STATE(10953)] = 414273,
  [SMALL_STATE(10954)] = 414297,
  [SMALL_STATE(10955)] = 414321,
  [SMALL_STATE(10956)] = 414345,
  [SMALL_STATE(10957)] = 414369,
  [SMALL_STATE(10958)] = 414393,
  [SMALL_STATE(10959)] = 414417,
  [SMALL_STATE(10960)] = 414441,
  [SMALL_STATE(10961)] = 414469,
  [SMALL_STATE(10962)] = 414493,
  [SMALL_STATE(10963)] = 414521,
  [SMALL_STATE(10964)] = 414545,
  [SMALL_STATE(10965)] = 414569,
  [SMALL_STATE(10966)] = 414593,
  [SMALL_STATE(10967)] = 414617,
  [SMALL_STATE(10968)] = 414641,
  [SMALL_STATE(10969)] = 414665,
  [SMALL_STATE(10970)] = 414689,
  [SMALL_STATE(10971)] = 414713,
  [SMALL_STATE(10972)] = 414735,
  [SMALL_STATE(10973)] = 414761,
  [SMALL_STATE(10974)] = 414785,
  [SMALL_STATE(10975)] = 414809,
  [SMALL_STATE(10976)] = 414833,
  [SMALL_STATE(10977)] = 414857,
  [SMALL_STATE(10978)] = 414881,
  [SMALL_STATE(10979)] = 414905,
  [SMALL_STATE(10980)] = 414929,
  [SMALL_STATE(10981)] = 414953,
  [SMALL_STATE(10982)] = 414977,
  [SMALL_STATE(10983)] = 415001,
  [SMALL_STATE(10984)] = 415025,
  [SMALL_STATE(10985)] = 415047,
  [SMALL_STATE(10986)] = 415071,
  [SMALL_STATE(10987)] = 415095,
  [SMALL_STATE(10988)] = 415119,
  [SMALL_STATE(10989)] = 415143,
  [SMALL_STATE(10990)] = 415167,
  [SMALL_STATE(10991)] = 415191,
  [SMALL_STATE(10992)] = 415215,
  [SMALL_STATE(10993)] = 415239,
  [SMALL_STATE(10994)] = 415263,
  [SMALL_STATE(10995)] = 415291,
  [SMALL_STATE(10996)] = 415329,
  [SMALL_STATE(10997)] = 415353,
  [SMALL_STATE(10998)] = 415377,
  [SMALL_STATE(10999)] = 415401,
  [SMALL_STATE(11000)] = 415425,
  [SMALL_STATE(11001)] = 415449,
  [SMALL_STATE(11002)] = 415471,
  [SMALL_STATE(11003)] = 415495,
  [SMALL_STATE(11004)] = 415519,
  [SMALL_STATE(11005)] = 415543,
  [SMALL_STATE(11006)] = 415567,
  [SMALL_STATE(11007)] = 415589,
  [SMALL_STATE(11008)] = 415613,
  [SMALL_STATE(11009)] = 415637,
  [SMALL_STATE(11010)] = 415661,
  [SMALL_STATE(11011)] = 415685,
  [SMALL_STATE(11012)] = 415709,
  [SMALL_STATE(11013)] = 415733,
  [SMALL_STATE(11014)] = 415763,
  [SMALL_STATE(11015)] = 415787,
  [SMALL_STATE(11016)] = 415811,
  [SMALL_STATE(11017)] = 415835,
  [SMALL_STATE(11018)] = 415859,
  [SMALL_STATE(11019)] = 415883,
  [SMALL_STATE(11020)] = 415907,
  [SMALL_STATE(11021)] = 415931,
  [SMALL_STATE(11022)] = 415955,
  [SMALL_STATE(11023)] = 415979,
  [SMALL_STATE(11024)] = 416005,
  [SMALL_STATE(11025)] = 416029,
  [SMALL_STATE(11026)] = 416053,
  [SMALL_STATE(11027)] = 416077,
  [SMALL_STATE(11028)] = 416101,
  [SMALL_STATE(11029)] = 416123,
  [SMALL_STATE(11030)] = 416145,
  [SMALL_STATE(11031)] = 416173,
  [SMALL_STATE(11032)] = 416197,
  [SMALL_STATE(11033)] = 416221,
  [SMALL_STATE(11034)] = 416245,
  [SMALL_STATE(11035)] = 416269,
  [SMALL_STATE(11036)] = 416293,
  [SMALL_STATE(11037)] = 416317,
  [SMALL_STATE(11038)] = 416341,
  [SMALL_STATE(11039)] = 416369,
  [SMALL_STATE(11040)] = 416395,
  [SMALL_STATE(11041)] = 416419,
  [SMALL_STATE(11042)] = 416443,
  [SMALL_STATE(11043)] = 416467,
  [SMALL_STATE(11044)] = 416491,
  [SMALL_STATE(11045)] = 416515,
  [SMALL_STATE(11046)] = 416541,
  [SMALL_STATE(11047)] = 416565,
  [SMALL_STATE(11048)] = 416593,
  [SMALL_STATE(11049)] = 416615,
  [SMALL_STATE(11050)] = 416641,
  [SMALL_STATE(11051)] = 416669,
  [SMALL_STATE(11052)] = 416699,
  [SMALL_STATE(11053)] = 416723,
  [SMALL_STATE(11054)] = 416747,
  [SMALL_STATE(11055)] = 416771,
  [SMALL_STATE(11056)] = 416795,
  [SMALL_STATE(11057)] = 416819,
  [SMALL_STATE(11058)] = 416843,
  [SMALL_STATE(11059)] = 416867,
  [SMALL_STATE(11060)] = 416895,
  [SMALL_STATE(11061)] = 416919,
  [SMALL_STATE(11062)] = 416943,
  [SMALL_STATE(11063)] = 416967,
  [SMALL_STATE(11064)] = 416991,
  [SMALL_STATE(11065)] = 417015,
  [SMALL_STATE(11066)] = 417039,
  [SMALL_STATE(11067)] = 417063,
  [SMALL_STATE(11068)] = 417087,
  [SMALL_STATE(11069)] = 417111,
  [SMALL_STATE(11070)] = 417135,
  [SMALL_STATE(11071)] = 417159,
  [SMALL_STATE(11072)] = 417183,
  [SMALL_STATE(11073)] = 417207,
  [SMALL_STATE(11074)] = 417231,
  [SMALL_STATE(11075)] = 417255,
  [SMALL_STATE(11076)] = 417279,
  [SMALL_STATE(11077)] = 417303,
  [SMALL_STATE(11078)] = 417327,
  [SMALL_STATE(11079)] = 417351,
  [SMALL_STATE(11080)] = 417387,
  [SMALL_STATE(11081)] = 417411,
  [SMALL_STATE(11082)] = 417435,
  [SMALL_STATE(11083)] = 417463,
  [SMALL_STATE(11084)] = 417487,
  [SMALL_STATE(11085)] = 417511,
  [SMALL_STATE(11086)] = 417541,
  [SMALL_STATE(11087)] = 417565,
  [SMALL_STATE(11088)] = 417589,
  [SMALL_STATE(11089)] = 417613,
  [SMALL_STATE(11090)] = 417637,
  [SMALL_STATE(11091)] = 417661,
  [SMALL_STATE(11092)] = 417689,
  [SMALL_STATE(11093)] = 417713,
  [SMALL_STATE(11094)] = 417737,
  [SMALL_STATE(11095)] = 417761,
  [SMALL_STATE(11096)] = 417785,
  [SMALL_STATE(11097)] = 417809,
  [SMALL_STATE(11098)] = 417833,
  [SMALL_STATE(11099)] = 417857,
  [SMALL_STATE(11100)] = 417881,
  [SMALL_STATE(11101)] = 417905,
  [SMALL_STATE(11102)] = 417929,
  [SMALL_STATE(11103)] = 417953,
  [SMALL_STATE(11104)] = 417977,
  [SMALL_STATE(11105)] = 418001,
  [SMALL_STATE(11106)] = 418025,
  [SMALL_STATE(11107)] = 418049,
  [SMALL_STATE(11108)] = 418073,
  [SMALL_STATE(11109)] = 418097,
  [SMALL_STATE(11110)] = 418121,
  [SMALL_STATE(11111)] = 418145,
  [SMALL_STATE(11112)] = 418169,
  [SMALL_STATE(11113)] = 418193,
  [SMALL_STATE(11114)] = 418219,
  [SMALL_STATE(11115)] = 418257,
  [SMALL_STATE(11116)] = 418281,
  [SMALL_STATE(11117)] = 418305,
  [SMALL_STATE(11118)] = 418329,
  [SMALL_STATE(11119)] = 418353,
  [SMALL_STATE(11120)] = 418377,
  [SMALL_STATE(11121)] = 418403,
  [SMALL_STATE(11122)] = 418427,
  [SMALL_STATE(11123)] = 418455,
  [SMALL_STATE(11124)] = 418479,
  [SMALL_STATE(11125)] = 418503,
  [SMALL_STATE(11126)] = 418527,
  [SMALL_STATE(11127)] = 418551,
  [SMALL_STATE(11128)] = 418575,
  [SMALL_STATE(11129)] = 418599,
  [SMALL_STATE(11130)] = 418623,
  [SMALL_STATE(11131)] = 418647,
  [SMALL_STATE(11132)] = 418673,
  [SMALL_STATE(11133)] = 418697,
  [SMALL_STATE(11134)] = 418721,
  [SMALL_STATE(11135)] = 418745,
  [SMALL_STATE(11136)] = 418769,
  [SMALL_STATE(11137)] = 418793,
  [SMALL_STATE(11138)] = 418817,
  [SMALL_STATE(11139)] = 418841,
  [SMALL_STATE(11140)] = 418865,
  [SMALL_STATE(11141)] = 418889,
  [SMALL_STATE(11142)] = 418913,
  [SMALL_STATE(11143)] = 418937,
  [SMALL_STATE(11144)] = 418961,
  [SMALL_STATE(11145)] = 418985,
  [SMALL_STATE(11146)] = 419009,
  [SMALL_STATE(11147)] = 419037,
  [SMALL_STATE(11148)] = 419061,
  [SMALL_STATE(11149)] = 419085,
  [SMALL_STATE(11150)] = 419113,
  [SMALL_STATE(11151)] = 419141,
  [SMALL_STATE(11152)] = 419165,
  [SMALL_STATE(11153)] = 419193,
  [SMALL_STATE(11154)] = 419221,
  [SMALL_STATE(11155)] = 419245,
  [SMALL_STATE(11156)] = 419269,
  [SMALL_STATE(11157)] = 419297,
  [SMALL_STATE(11158)] = 419321,
  [SMALL_STATE(11159)] = 419345,
  [SMALL_STATE(11160)] = 419369,
  [SMALL_STATE(11161)] = 419393,
  [SMALL_STATE(11162)] = 419417,
  [SMALL_STATE(11163)] = 419441,
  [SMALL_STATE(11164)] = 419465,
  [SMALL_STATE(11165)] = 419493,
  [SMALL_STATE(11166)] = 419517,
  [SMALL_STATE(11167)] = 419541,
  [SMALL_STATE(11168)] = 419565,
  [SMALL_STATE(11169)] = 419593,
  [SMALL_STATE(11170)] = 419617,
  [SMALL_STATE(11171)] = 419641,
  [SMALL_STATE(11172)] = 419665,
  [SMALL_STATE(11173)] = 419693,
  [SMALL_STATE(11174)] = 419717,
  [SMALL_STATE(11175)] = 419741,
  [SMALL_STATE(11176)] = 419771,
  [SMALL_STATE(11177)] = 419795,
  [SMALL_STATE(11178)] = 419819,
  [SMALL_STATE(11179)] = 419843,
  [SMALL_STATE(11180)] = 419867,
  [SMALL_STATE(11181)] = 419891,
  [SMALL_STATE(11182)] = 419915,
  [SMALL_STATE(11183)] = 419939,
  [SMALL_STATE(11184)] = 419963,
  [SMALL_STATE(11185)] = 419987,
  [SMALL_STATE(11186)] = 420011,
  [SMALL_STATE(11187)] = 420035,
  [SMALL_STATE(11188)] = 420059,
  [SMALL_STATE(11189)] = 420083,
  [SMALL_STATE(11190)] = 420107,
  [SMALL_STATE(11191)] = 420131,
  [SMALL_STATE(11192)] = 420155,
  [SMALL_STATE(11193)] = 420179,
  [SMALL_STATE(11194)] = 420209,
  [SMALL_STATE(11195)] = 420233,
  [SMALL_STATE(11196)] = 420257,
  [SMALL_STATE(11197)] = 420281,
  [SMALL_STATE(11198)] = 420305,
  [SMALL_STATE(11199)] = 420329,
  [SMALL_STATE(11200)] = 420357,
  [SMALL_STATE(11201)] = 420381,
  [SMALL_STATE(11202)] = 420405,
  [SMALL_STATE(11203)] = 420429,
  [SMALL_STATE(11204)] = 420453,
  [SMALL_STATE(11205)] = 420477,
  [SMALL_STATE(11206)] = 420501,
  [SMALL_STATE(11207)] = 420525,
  [SMALL_STATE(11208)] = 420549,
  [SMALL_STATE(11209)] = 420573,
  [SMALL_STATE(11210)] = 420597,
  [SMALL_STATE(11211)] = 420621,
  [SMALL_STATE(11212)] = 420645,
  [SMALL_STATE(11213)] = 420669,
  [SMALL_STATE(11214)] = 420693,
  [SMALL_STATE(11215)] = 420717,
  [SMALL_STATE(11216)] = 420741,
  [SMALL_STATE(11217)] = 420765,
  [SMALL_STATE(11218)] = 420789,
  [SMALL_STATE(11219)] = 420813,
  [SMALL_STATE(11220)] = 420837,
  [SMALL_STATE(11221)] = 420861,
  [SMALL_STATE(11222)] = 420885,
  [SMALL_STATE(11223)] = 420909,
  [SMALL_STATE(11224)] = 420933,
  [SMALL_STATE(11225)] = 420957,
  [SMALL_STATE(11226)] = 420981,
  [SMALL_STATE(11227)] = 421005,
  [SMALL_STATE(11228)] = 421029,
  [SMALL_STATE(11229)] = 421053,
  [SMALL_STATE(11230)] = 421077,
  [SMALL_STATE(11231)] = 421101,
  [SMALL_STATE(11232)] = 421125,
  [SMALL_STATE(11233)] = 421149,
  [SMALL_STATE(11234)] = 421179,
  [SMALL_STATE(11235)] = 421203,
  [SMALL_STATE(11236)] = 421227,
  [SMALL_STATE(11237)] = 421251,
  [SMALL_STATE(11238)] = 421275,
  [SMALL_STATE(11239)] = 421299,
  [SMALL_STATE(11240)] = 421323,
  [SMALL_STATE(11241)] = 421347,
  [SMALL_STATE(11242)] = 421377,
  [SMALL_STATE(11243)] = 421401,
  [SMALL_STATE(11244)] = 421425,
  [SMALL_STATE(11245)] = 421449,
  [SMALL_STATE(11246)] = 421473,
  [SMALL_STATE(11247)] = 421497,
  [SMALL_STATE(11248)] = 421521,
  [SMALL_STATE(11249)] = 421559,
  [SMALL_STATE(11250)] = 421583,
  [SMALL_STATE(11251)] = 421607,
  [SMALL_STATE(11252)] = 421631,
  [SMALL_STATE(11253)] = 421655,
  [SMALL_STATE(11254)] = 421679,
  [SMALL_STATE(11255)] = 421703,
  [SMALL_STATE(11256)] = 421727,
  [SMALL_STATE(11257)] = 421751,
  [SMALL_STATE(11258)] = 421775,
  [SMALL_STATE(11259)] = 421799,
  [SMALL_STATE(11260)] = 421823,
  [SMALL_STATE(11261)] = 421847,
  [SMALL_STATE(11262)] = 421871,
  [SMALL_STATE(11263)] = 421895,
  [SMALL_STATE(11264)] = 421919,
  [SMALL_STATE(11265)] = 421943,
  [SMALL_STATE(11266)] = 421967,
  [SMALL_STATE(11267)] = 421991,
  [SMALL_STATE(11268)] = 422015,
  [SMALL_STATE(11269)] = 422039,
  [SMALL_STATE(11270)] = 422063,
  [SMALL_STATE(11271)] = 422087,
  [SMALL_STATE(11272)] = 422111,
  [SMALL_STATE(11273)] = 422135,
  [SMALL_STATE(11274)] = 422159,
  [SMALL_STATE(11275)] = 422183,
  [SMALL_STATE(11276)] = 422207,
  [SMALL_STATE(11277)] = 422231,
  [SMALL_STATE(11278)] = 422255,
  [SMALL_STATE(11279)] = 422293,
  [SMALL_STATE(11280)] = 422317,
  [SMALL_STATE(11281)] = 422341,
  [SMALL_STATE(11282)] = 422365,
  [SMALL_STATE(11283)] = 422389,
  [SMALL_STATE(11284)] = 422413,
  [SMALL_STATE(11285)] = 422437,
  [SMALL_STATE(11286)] = 422463,
  [SMALL_STATE(11287)] = 422487,
  [SMALL_STATE(11288)] = 422511,
  [SMALL_STATE(11289)] = 422535,
  [SMALL_STATE(11290)] = 422559,
  [SMALL_STATE(11291)] = 422583,
  [SMALL_STATE(11292)] = 422607,
  [SMALL_STATE(11293)] = 422631,
  [SMALL_STATE(11294)] = 422655,
  [SMALL_STATE(11295)] = 422679,
  [SMALL_STATE(11296)] = 422703,
  [SMALL_STATE(11297)] = 422727,
  [SMALL_STATE(11298)] = 422751,
  [SMALL_STATE(11299)] = 422777,
  [SMALL_STATE(11300)] = 422801,
  [SMALL_STATE(11301)] = 422825,
  [SMALL_STATE(11302)] = 422849,
  [SMALL_STATE(11303)] = 422873,
  [SMALL_STATE(11304)] = 422897,
  [SMALL_STATE(11305)] = 422921,
  [SMALL_STATE(11306)] = 422945,
  [SMALL_STATE(11307)] = 422971,
  [SMALL_STATE(11308)] = 422995,
  [SMALL_STATE(11309)] = 423019,
  [SMALL_STATE(11310)] = 423041,
  [SMALL_STATE(11311)] = 423067,
  [SMALL_STATE(11312)] = 423091,
  [SMALL_STATE(11313)] = 423115,
  [SMALL_STATE(11314)] = 423139,
  [SMALL_STATE(11315)] = 423163,
  [SMALL_STATE(11316)] = 423187,
  [SMALL_STATE(11317)] = 423211,
  [SMALL_STATE(11318)] = 423235,
  [SMALL_STATE(11319)] = 423261,
  [SMALL_STATE(11320)] = 423287,
  [SMALL_STATE(11321)] = 423315,
  [SMALL_STATE(11322)] = 423339,
  [SMALL_STATE(11323)] = 423369,
  [SMALL_STATE(11324)] = 423393,
  [SMALL_STATE(11325)] = 423417,
  [SMALL_STATE(11326)] = 423443,
  [SMALL_STATE(11327)] = 423467,
  [SMALL_STATE(11328)] = 423493,
  [SMALL_STATE(11329)] = 423517,
  [SMALL_STATE(11330)] = 423541,
  [SMALL_STATE(11331)] = 423565,
  [SMALL_STATE(11332)] = 423587,
  [SMALL_STATE(11333)] = 423611,
  [SMALL_STATE(11334)] = 423635,
  [SMALL_STATE(11335)] = 423659,
  [SMALL_STATE(11336)] = 423683,
  [SMALL_STATE(11337)] = 423707,
  [SMALL_STATE(11338)] = 423731,
  [SMALL_STATE(11339)] = 423755,
  [SMALL_STATE(11340)] = 423779,
  [SMALL_STATE(11341)] = 423803,
  [SMALL_STATE(11342)] = 423827,
  [SMALL_STATE(11343)] = 423853,
  [SMALL_STATE(11344)] = 423877,
  [SMALL_STATE(11345)] = 423901,
  [SMALL_STATE(11346)] = 423925,
  [SMALL_STATE(11347)] = 423949,
  [SMALL_STATE(11348)] = 423973,
  [SMALL_STATE(11349)] = 423997,
  [SMALL_STATE(11350)] = 424021,
  [SMALL_STATE(11351)] = 424045,
  [SMALL_STATE(11352)] = 424069,
  [SMALL_STATE(11353)] = 424093,
  [SMALL_STATE(11354)] = 424117,
  [SMALL_STATE(11355)] = 424141,
  [SMALL_STATE(11356)] = 424167,
  [SMALL_STATE(11357)] = 424191,
  [SMALL_STATE(11358)] = 424215,
  [SMALL_STATE(11359)] = 424239,
  [SMALL_STATE(11360)] = 424263,
  [SMALL_STATE(11361)] = 424287,
  [SMALL_STATE(11362)] = 424311,
  [SMALL_STATE(11363)] = 424335,
  [SMALL_STATE(11364)] = 424359,
  [SMALL_STATE(11365)] = 424383,
  [SMALL_STATE(11366)] = 424407,
  [SMALL_STATE(11367)] = 424431,
  [SMALL_STATE(11368)] = 424455,
  [SMALL_STATE(11369)] = 424479,
  [SMALL_STATE(11370)] = 424503,
  [SMALL_STATE(11371)] = 424529,
  [SMALL_STATE(11372)] = 424553,
  [SMALL_STATE(11373)] = 424577,
  [SMALL_STATE(11374)] = 424601,
  [SMALL_STATE(11375)] = 424625,
  [SMALL_STATE(11376)] = 424649,
  [SMALL_STATE(11377)] = 424673,
  [SMALL_STATE(11378)] = 424697,
  [SMALL_STATE(11379)] = 424721,
  [SMALL_STATE(11380)] = 424745,
  [SMALL_STATE(11381)] = 424769,
  [SMALL_STATE(11382)] = 424793,
  [SMALL_STATE(11383)] = 424817,
  [SMALL_STATE(11384)] = 424841,
  [SMALL_STATE(11385)] = 424865,
  [SMALL_STATE(11386)] = 424889,
  [SMALL_STATE(11387)] = 424913,
  [SMALL_STATE(11388)] = 424937,
  [SMALL_STATE(11389)] = 424961,
  [SMALL_STATE(11390)] = 424985,
  [SMALL_STATE(11391)] = 425009,
  [SMALL_STATE(11392)] = 425033,
  [SMALL_STATE(11393)] = 425057,
  [SMALL_STATE(11394)] = 425081,
  [SMALL_STATE(11395)] = 425107,
  [SMALL_STATE(11396)] = 425131,
  [SMALL_STATE(11397)] = 425155,
  [SMALL_STATE(11398)] = 425179,
  [SMALL_STATE(11399)] = 425203,
  [SMALL_STATE(11400)] = 425227,
  [SMALL_STATE(11401)] = 425251,
  [SMALL_STATE(11402)] = 425275,
  [SMALL_STATE(11403)] = 425299,
  [SMALL_STATE(11404)] = 425323,
  [SMALL_STATE(11405)] = 425347,
  [SMALL_STATE(11406)] = 425371,
  [SMALL_STATE(11407)] = 425395,
  [SMALL_STATE(11408)] = 425433,
  [SMALL_STATE(11409)] = 425457,
  [SMALL_STATE(11410)] = 425481,
  [SMALL_STATE(11411)] = 425505,
  [SMALL_STATE(11412)] = 425529,
  [SMALL_STATE(11413)] = 425553,
  [SMALL_STATE(11414)] = 425577,
  [SMALL_STATE(11415)] = 425601,
  [SMALL_STATE(11416)] = 425625,
  [SMALL_STATE(11417)] = 425649,
  [SMALL_STATE(11418)] = 425673,
  [SMALL_STATE(11419)] = 425697,
  [SMALL_STATE(11420)] = 425721,
  [SMALL_STATE(11421)] = 425745,
  [SMALL_STATE(11422)] = 425769,
  [SMALL_STATE(11423)] = 425793,
  [SMALL_STATE(11424)] = 425817,
  [SMALL_STATE(11425)] = 425841,
  [SMALL_STATE(11426)] = 425865,
  [SMALL_STATE(11427)] = 425889,
  [SMALL_STATE(11428)] = 425913,
  [SMALL_STATE(11429)] = 425937,
  [SMALL_STATE(11430)] = 425961,
  [SMALL_STATE(11431)] = 425985,
  [SMALL_STATE(11432)] = 426009,
  [SMALL_STATE(11433)] = 426033,
  [SMALL_STATE(11434)] = 426057,
  [SMALL_STATE(11435)] = 426081,
  [SMALL_STATE(11436)] = 426105,
  [SMALL_STATE(11437)] = 426129,
  [SMALL_STATE(11438)] = 426153,
  [SMALL_STATE(11439)] = 426177,
  [SMALL_STATE(11440)] = 426201,
  [SMALL_STATE(11441)] = 426225,
  [SMALL_STATE(11442)] = 426249,
  [SMALL_STATE(11443)] = 426273,
  [SMALL_STATE(11444)] = 426297,
  [SMALL_STATE(11445)] = 426321,
  [SMALL_STATE(11446)] = 426345,
  [SMALL_STATE(11447)] = 426369,
  [SMALL_STATE(11448)] = 426393,
  [SMALL_STATE(11449)] = 426417,
  [SMALL_STATE(11450)] = 426441,
  [SMALL_STATE(11451)] = 426465,
  [SMALL_STATE(11452)] = 426493,
  [SMALL_STATE(11453)] = 426519,
  [SMALL_STATE(11454)] = 426545,
  [SMALL_STATE(11455)] = 426569,
  [SMALL_STATE(11456)] = 426593,
  [SMALL_STATE(11457)] = 426617,
  [SMALL_STATE(11458)] = 426641,
  [SMALL_STATE(11459)] = 426665,
  [SMALL_STATE(11460)] = 426689,
  [SMALL_STATE(11461)] = 426713,
  [SMALL_STATE(11462)] = 426737,
  [SMALL_STATE(11463)] = 426761,
  [SMALL_STATE(11464)] = 426785,
  [SMALL_STATE(11465)] = 426809,
  [SMALL_STATE(11466)] = 426833,
  [SMALL_STATE(11467)] = 426861,
  [SMALL_STATE(11468)] = 426885,
  [SMALL_STATE(11469)] = 426909,
  [SMALL_STATE(11470)] = 426935,
  [SMALL_STATE(11471)] = 426961,
  [SMALL_STATE(11472)] = 426985,
  [SMALL_STATE(11473)] = 427009,
  [SMALL_STATE(11474)] = 427039,
  [SMALL_STATE(11475)] = 427063,
  [SMALL_STATE(11476)] = 427087,
  [SMALL_STATE(11477)] = 427111,
  [SMALL_STATE(11478)] = 427137,
  [SMALL_STATE(11479)] = 427161,
  [SMALL_STATE(11480)] = 427185,
  [SMALL_STATE(11481)] = 427213,
  [SMALL_STATE(11482)] = 427237,
  [SMALL_STATE(11483)] = 427261,
  [SMALL_STATE(11484)] = 427285,
  [SMALL_STATE(11485)] = 427309,
  [SMALL_STATE(11486)] = 427333,
  [SMALL_STATE(11487)] = 427357,
  [SMALL_STATE(11488)] = 427381,
  [SMALL_STATE(11489)] = 427407,
  [SMALL_STATE(11490)] = 427431,
  [SMALL_STATE(11491)] = 427457,
  [SMALL_STATE(11492)] = 427481,
  [SMALL_STATE(11493)] = 427511,
  [SMALL_STATE(11494)] = 427535,
  [SMALL_STATE(11495)] = 427559,
  [SMALL_STATE(11496)] = 427583,
  [SMALL_STATE(11497)] = 427607,
  [SMALL_STATE(11498)] = 427631,
  [SMALL_STATE(11499)] = 427655,
  [SMALL_STATE(11500)] = 427679,
  [SMALL_STATE(11501)] = 427703,
  [SMALL_STATE(11502)] = 427727,
  [SMALL_STATE(11503)] = 427751,
  [SMALL_STATE(11504)] = 427775,
  [SMALL_STATE(11505)] = 427799,
  [SMALL_STATE(11506)] = 427820,
  [SMALL_STATE(11507)] = 427843,
  [SMALL_STATE(11508)] = 427866,
  [SMALL_STATE(11509)] = 427901,
  [SMALL_STATE(11510)] = 427938,
  [SMALL_STATE(11511)] = 427961,
  [SMALL_STATE(11512)] = 427984,
  [SMALL_STATE(11513)] = 428007,
  [SMALL_STATE(11514)] = 428030,
  [SMALL_STATE(11515)] = 428053,
  [SMALL_STATE(11516)] = 428076,
  [SMALL_STATE(11517)] = 428099,
  [SMALL_STATE(11518)] = 428122,
  [SMALL_STATE(11519)] = 428159,
  [SMALL_STATE(11520)] = 428200,
  [SMALL_STATE(11521)] = 428223,
  [SMALL_STATE(11522)] = 428246,
  [SMALL_STATE(11523)] = 428269,
  [SMALL_STATE(11524)] = 428292,
  [SMALL_STATE(11525)] = 428315,
  [SMALL_STATE(11526)] = 428338,
  [SMALL_STATE(11527)] = 428361,
  [SMALL_STATE(11528)] = 428384,
  [SMALL_STATE(11529)] = 428407,
  [SMALL_STATE(11530)] = 428430,
  [SMALL_STATE(11531)] = 428467,
  [SMALL_STATE(11532)] = 428490,
  [SMALL_STATE(11533)] = 428513,
  [SMALL_STATE(11534)] = 428534,
  [SMALL_STATE(11535)] = 428557,
  [SMALL_STATE(11536)] = 428578,
  [SMALL_STATE(11537)] = 428601,
  [SMALL_STATE(11538)] = 428624,
  [SMALL_STATE(11539)] = 428647,
  [SMALL_STATE(11540)] = 428684,
  [SMALL_STATE(11541)] = 428721,
  [SMALL_STATE(11542)] = 428744,
  [SMALL_STATE(11543)] = 428767,
  [SMALL_STATE(11544)] = 428790,
  [SMALL_STATE(11545)] = 428813,
  [SMALL_STATE(11546)] = 428836,
  [SMALL_STATE(11547)] = 428859,
  [SMALL_STATE(11548)] = 428882,
  [SMALL_STATE(11549)] = 428905,
  [SMALL_STATE(11550)] = 428930,
  [SMALL_STATE(11551)] = 428953,
  [SMALL_STATE(11552)] = 428976,
  [SMALL_STATE(11553)] = 428999,
  [SMALL_STATE(11554)] = 429036,
  [SMALL_STATE(11555)] = 429073,
  [SMALL_STATE(11556)] = 429096,
  [SMALL_STATE(11557)] = 429119,
  [SMALL_STATE(11558)] = 429142,
  [SMALL_STATE(11559)] = 429163,
  [SMALL_STATE(11560)] = 429186,
  [SMALL_STATE(11561)] = 429209,
  [SMALL_STATE(11562)] = 429232,
  [SMALL_STATE(11563)] = 429255,
  [SMALL_STATE(11564)] = 429278,
  [SMALL_STATE(11565)] = 429301,
  [SMALL_STATE(11566)] = 429324,
  [SMALL_STATE(11567)] = 429347,
  [SMALL_STATE(11568)] = 429370,
  [SMALL_STATE(11569)] = 429393,
  [SMALL_STATE(11570)] = 429416,
  [SMALL_STATE(11571)] = 429439,
  [SMALL_STATE(11572)] = 429462,
  [SMALL_STATE(11573)] = 429485,
  [SMALL_STATE(11574)] = 429508,
  [SMALL_STATE(11575)] = 429529,
  [SMALL_STATE(11576)] = 429552,
  [SMALL_STATE(11577)] = 429575,
  [SMALL_STATE(11578)] = 429598,
  [SMALL_STATE(11579)] = 429619,
  [SMALL_STATE(11580)] = 429642,
  [SMALL_STATE(11581)] = 429665,
  [SMALL_STATE(11582)] = 429688,
  [SMALL_STATE(11583)] = 429711,
  [SMALL_STATE(11584)] = 429734,
  [SMALL_STATE(11585)] = 429757,
  [SMALL_STATE(11586)] = 429780,
  [SMALL_STATE(11587)] = 429803,
  [SMALL_STATE(11588)] = 429826,
  [SMALL_STATE(11589)] = 429847,
  [SMALL_STATE(11590)] = 429870,
  [SMALL_STATE(11591)] = 429893,
  [SMALL_STATE(11592)] = 429930,
  [SMALL_STATE(11593)] = 429953,
  [SMALL_STATE(11594)] = 429976,
  [SMALL_STATE(11595)] = 430013,
  [SMALL_STATE(11596)] = 430036,
  [SMALL_STATE(11597)] = 430059,
  [SMALL_STATE(11598)] = 430082,
  [SMALL_STATE(11599)] = 430109,
  [SMALL_STATE(11600)] = 430134,
  [SMALL_STATE(11601)] = 430157,
  [SMALL_STATE(11602)] = 430180,
  [SMALL_STATE(11603)] = 430203,
  [SMALL_STATE(11604)] = 430226,
  [SMALL_STATE(11605)] = 430249,
  [SMALL_STATE(11606)] = 430272,
  [SMALL_STATE(11607)] = 430295,
  [SMALL_STATE(11608)] = 430318,
  [SMALL_STATE(11609)] = 430355,
  [SMALL_STATE(11610)] = 430378,
  [SMALL_STATE(11611)] = 430401,
  [SMALL_STATE(11612)] = 430424,
  [SMALL_STATE(11613)] = 430447,
  [SMALL_STATE(11614)] = 430470,
  [SMALL_STATE(11615)] = 430499,
  [SMALL_STATE(11616)] = 430522,
  [SMALL_STATE(11617)] = 430545,
  [SMALL_STATE(11618)] = 430568,
  [SMALL_STATE(11619)] = 430591,
  [SMALL_STATE(11620)] = 430614,
  [SMALL_STATE(11621)] = 430639,
  [SMALL_STATE(11622)] = 430662,
  [SMALL_STATE(11623)] = 430683,
  [SMALL_STATE(11624)] = 430708,
  [SMALL_STATE(11625)] = 430729,
  [SMALL_STATE(11626)] = 430752,
  [SMALL_STATE(11627)] = 430789,
  [SMALL_STATE(11628)] = 430812,
  [SMALL_STATE(11629)] = 430835,
  [SMALL_STATE(11630)] = 430858,
  [SMALL_STATE(11631)] = 430881,
  [SMALL_STATE(11632)] = 430918,
  [SMALL_STATE(11633)] = 430941,
  [SMALL_STATE(11634)] = 430964,
  [SMALL_STATE(11635)] = 430987,
  [SMALL_STATE(11636)] = 431010,
  [SMALL_STATE(11637)] = 431033,
  [SMALL_STATE(11638)] = 431056,
  [SMALL_STATE(11639)] = 431077,
  [SMALL_STATE(11640)] = 431098,
  [SMALL_STATE(11641)] = 431135,
  [SMALL_STATE(11642)] = 431158,
  [SMALL_STATE(11643)] = 431179,
  [SMALL_STATE(11644)] = 431202,
  [SMALL_STATE(11645)] = 431225,
  [SMALL_STATE(11646)] = 431250,
  [SMALL_STATE(11647)] = 431271,
  [SMALL_STATE(11648)] = 431308,
  [SMALL_STATE(11649)] = 431331,
  [SMALL_STATE(11650)] = 431368,
  [SMALL_STATE(11651)] = 431393,
  [SMALL_STATE(11652)] = 431416,
  [SMALL_STATE(11653)] = 431437,
  [SMALL_STATE(11654)] = 431460,
  [SMALL_STATE(11655)] = 431483,
  [SMALL_STATE(11656)] = 431506,
  [SMALL_STATE(11657)] = 431527,
  [SMALL_STATE(11658)] = 431548,
  [SMALL_STATE(11659)] = 431571,
  [SMALL_STATE(11660)] = 431592,
  [SMALL_STATE(11661)] = 431613,
  [SMALL_STATE(11662)] = 431634,
  [SMALL_STATE(11663)] = 431657,
  [SMALL_STATE(11664)] = 431694,
  [SMALL_STATE(11665)] = 431717,
  [SMALL_STATE(11666)] = 431740,
  [SMALL_STATE(11667)] = 431763,
  [SMALL_STATE(11668)] = 431786,
  [SMALL_STATE(11669)] = 431807,
  [SMALL_STATE(11670)] = 431828,
  [SMALL_STATE(11671)] = 431851,
  [SMALL_STATE(11672)] = 431874,
  [SMALL_STATE(11673)] = 431897,
  [SMALL_STATE(11674)] = 431918,
  [SMALL_STATE(11675)] = 431941,
  [SMALL_STATE(11676)] = 431962,
  [SMALL_STATE(11677)] = 431985,
  [SMALL_STATE(11678)] = 432008,
  [SMALL_STATE(11679)] = 432031,
  [SMALL_STATE(11680)] = 432054,
  [SMALL_STATE(11681)] = 432091,
  [SMALL_STATE(11682)] = 432114,
  [SMALL_STATE(11683)] = 432151,
  [SMALL_STATE(11684)] = 432176,
  [SMALL_STATE(11685)] = 432213,
  [SMALL_STATE(11686)] = 432234,
  [SMALL_STATE(11687)] = 432257,
  [SMALL_STATE(11688)] = 432280,
  [SMALL_STATE(11689)] = 432303,
  [SMALL_STATE(11690)] = 432326,
  [SMALL_STATE(11691)] = 432347,
  [SMALL_STATE(11692)] = 432370,
  [SMALL_STATE(11693)] = 432393,
  [SMALL_STATE(11694)] = 432430,
  [SMALL_STATE(11695)] = 432451,
  [SMALL_STATE(11696)] = 432474,
  [SMALL_STATE(11697)] = 432497,
  [SMALL_STATE(11698)] = 432520,
  [SMALL_STATE(11699)] = 432543,
  [SMALL_STATE(11700)] = 432564,
  [SMALL_STATE(11701)] = 432589,
  [SMALL_STATE(11702)] = 432612,
  [SMALL_STATE(11703)] = 432633,
  [SMALL_STATE(11704)] = 432656,
  [SMALL_STATE(11705)] = 432679,
  [SMALL_STATE(11706)] = 432702,
  [SMALL_STATE(11707)] = 432739,
  [SMALL_STATE(11708)] = 432762,
  [SMALL_STATE(11709)] = 432783,
  [SMALL_STATE(11710)] = 432804,
  [SMALL_STATE(11711)] = 432827,
  [SMALL_STATE(11712)] = 432850,
  [SMALL_STATE(11713)] = 432887,
  [SMALL_STATE(11714)] = 432910,
  [SMALL_STATE(11715)] = 432933,
  [SMALL_STATE(11716)] = 432956,
  [SMALL_STATE(11717)] = 432979,
  [SMALL_STATE(11718)] = 433000,
  [SMALL_STATE(11719)] = 433021,
  [SMALL_STATE(11720)] = 433046,
  [SMALL_STATE(11721)] = 433067,
  [SMALL_STATE(11722)] = 433088,
  [SMALL_STATE(11723)] = 433111,
  [SMALL_STATE(11724)] = 433132,
  [SMALL_STATE(11725)] = 433153,
  [SMALL_STATE(11726)] = 433174,
  [SMALL_STATE(11727)] = 433197,
  [SMALL_STATE(11728)] = 433220,
  [SMALL_STATE(11729)] = 433241,
  [SMALL_STATE(11730)] = 433264,
  [SMALL_STATE(11731)] = 433287,
  [SMALL_STATE(11732)] = 433310,
  [SMALL_STATE(11733)] = 433331,
  [SMALL_STATE(11734)] = 433354,
  [SMALL_STATE(11735)] = 433377,
  [SMALL_STATE(11736)] = 433398,
  [SMALL_STATE(11737)] = 433421,
  [SMALL_STATE(11738)] = 433444,
  [SMALL_STATE(11739)] = 433467,
  [SMALL_STATE(11740)] = 433488,
  [SMALL_STATE(11741)] = 433511,
  [SMALL_STATE(11742)] = 433534,
  [SMALL_STATE(11743)] = 433557,
  [SMALL_STATE(11744)] = 433594,
  [SMALL_STATE(11745)] = 433615,
  [SMALL_STATE(11746)] = 433652,
  [SMALL_STATE(11747)] = 433675,
  [SMALL_STATE(11748)] = 433698,
  [SMALL_STATE(11749)] = 433721,
  [SMALL_STATE(11750)] = 433744,
  [SMALL_STATE(11751)] = 433765,
  [SMALL_STATE(11752)] = 433790,
  [SMALL_STATE(11753)] = 433825,
  [SMALL_STATE(11754)] = 433848,
  [SMALL_STATE(11755)] = 433871,
  [SMALL_STATE(11756)] = 433892,
  [SMALL_STATE(11757)] = 433929,
  [SMALL_STATE(11758)] = 433950,
  [SMALL_STATE(11759)] = 433973,
  [SMALL_STATE(11760)] = 433994,
  [SMALL_STATE(11761)] = 434015,
  [SMALL_STATE(11762)] = 434050,
  [SMALL_STATE(11763)] = 434087,
  [SMALL_STATE(11764)] = 434110,
  [SMALL_STATE(11765)] = 434133,
  [SMALL_STATE(11766)] = 434156,
  [SMALL_STATE(11767)] = 434179,
  [SMALL_STATE(11768)] = 434202,
  [SMALL_STATE(11769)] = 434243,
  [SMALL_STATE(11770)] = 434266,
  [SMALL_STATE(11771)] = 434303,
  [SMALL_STATE(11772)] = 434344,
  [SMALL_STATE(11773)] = 434367,
  [SMALL_STATE(11774)] = 434388,
  [SMALL_STATE(11775)] = 434411,
  [SMALL_STATE(11776)] = 434434,
  [SMALL_STATE(11777)] = 434455,
  [SMALL_STATE(11778)] = 434476,
  [SMALL_STATE(11779)] = 434499,
  [SMALL_STATE(11780)] = 434520,
  [SMALL_STATE(11781)] = 434557,
  [SMALL_STATE(11782)] = 434580,
  [SMALL_STATE(11783)] = 434601,
  [SMALL_STATE(11784)] = 434624,
  [SMALL_STATE(11785)] = 434647,
  [SMALL_STATE(11786)] = 434670,
  [SMALL_STATE(11787)] = 434693,
  [SMALL_STATE(11788)] = 434716,
  [SMALL_STATE(11789)] = 434745,
  [SMALL_STATE(11790)] = 434774,
  [SMALL_STATE(11791)] = 434811,
  [SMALL_STATE(11792)] = 434834,
  [SMALL_STATE(11793)] = 434855,
  [SMALL_STATE(11794)] = 434876,
  [SMALL_STATE(11795)] = 434899,
  [SMALL_STATE(11796)] = 434936,
  [SMALL_STATE(11797)] = 434959,
  [SMALL_STATE(11798)] = 434980,
  [SMALL_STATE(11799)] = 435017,
  [SMALL_STATE(11800)] = 435040,
  [SMALL_STATE(11801)] = 435063,
  [SMALL_STATE(11802)] = 435100,
  [SMALL_STATE(11803)] = 435123,
  [SMALL_STATE(11804)] = 435146,
  [SMALL_STATE(11805)] = 435169,
  [SMALL_STATE(11806)] = 435190,
  [SMALL_STATE(11807)] = 435211,
  [SMALL_STATE(11808)] = 435248,
  [SMALL_STATE(11809)] = 435269,
  [SMALL_STATE(11810)] = 435292,
  [SMALL_STATE(11811)] = 435313,
  [SMALL_STATE(11812)] = 435342,
  [SMALL_STATE(11813)] = 435365,
  [SMALL_STATE(11814)] = 435386,
  [SMALL_STATE(11815)] = 435409,
  [SMALL_STATE(11816)] = 435430,
  [SMALL_STATE(11817)] = 435467,
  [SMALL_STATE(11818)] = 435490,
  [SMALL_STATE(11819)] = 435511,
  [SMALL_STATE(11820)] = 435534,
  [SMALL_STATE(11821)] = 435571,
  [SMALL_STATE(11822)] = 435612,
  [SMALL_STATE(11823)] = 435633,
  [SMALL_STATE(11824)] = 435674,
  [SMALL_STATE(11825)] = 435697,
  [SMALL_STATE(11826)] = 435720,
  [SMALL_STATE(11827)] = 435743,
  [SMALL_STATE(11828)] = 435766,
  [SMALL_STATE(11829)] = 435787,
  [SMALL_STATE(11830)] = 435808,
  [SMALL_STATE(11831)] = 435831,
  [SMALL_STATE(11832)] = 435868,
  [SMALL_STATE(11833)] = 435891,
  [SMALL_STATE(11834)] = 435914,
  [SMALL_STATE(11835)] = 435951,
  [SMALL_STATE(11836)] = 435974,
  [SMALL_STATE(11837)] = 435997,
  [SMALL_STATE(11838)] = 436020,
  [SMALL_STATE(11839)] = 436055,
  [SMALL_STATE(11840)] = 436092,
  [SMALL_STATE(11841)] = 436115,
  [SMALL_STATE(11842)] = 436152,
  [SMALL_STATE(11843)] = 436175,
  [SMALL_STATE(11844)] = 436196,
  [SMALL_STATE(11845)] = 436237,
  [SMALL_STATE(11846)] = 436260,
  [SMALL_STATE(11847)] = 436283,
  [SMALL_STATE(11848)] = 436306,
  [SMALL_STATE(11849)] = 436331,
  [SMALL_STATE(11850)] = 436354,
  [SMALL_STATE(11851)] = 436377,
  [SMALL_STATE(11852)] = 436414,
  [SMALL_STATE(11853)] = 436437,
  [SMALL_STATE(11854)] = 436460,
  [SMALL_STATE(11855)] = 436483,
  [SMALL_STATE(11856)] = 436512,
  [SMALL_STATE(11857)] = 436535,
  [SMALL_STATE(11858)] = 436558,
  [SMALL_STATE(11859)] = 436585,
  [SMALL_STATE(11860)] = 436608,
  [SMALL_STATE(11861)] = 436631,
  [SMALL_STATE(11862)] = 436654,
  [SMALL_STATE(11863)] = 436677,
  [SMALL_STATE(11864)] = 436700,
  [SMALL_STATE(11865)] = 436723,
  [SMALL_STATE(11866)] = 436752,
  [SMALL_STATE(11867)] = 436775,
  [SMALL_STATE(11868)] = 436798,
  [SMALL_STATE(11869)] = 436821,
  [SMALL_STATE(11870)] = 436844,
  [SMALL_STATE(11871)] = 436865,
  [SMALL_STATE(11872)] = 436888,
  [SMALL_STATE(11873)] = 436929,
  [SMALL_STATE(11874)] = 436950,
  [SMALL_STATE(11875)] = 436973,
  [SMALL_STATE(11876)] = 436996,
  [SMALL_STATE(11877)] = 437017,
  [SMALL_STATE(11878)] = 437040,
  [SMALL_STATE(11879)] = 437063,
  [SMALL_STATE(11880)] = 437086,
  [SMALL_STATE(11881)] = 437123,
  [SMALL_STATE(11882)] = 437146,
  [SMALL_STATE(11883)] = 437169,
  [SMALL_STATE(11884)] = 437192,
  [SMALL_STATE(11885)] = 437215,
  [SMALL_STATE(11886)] = 437238,
  [SMALL_STATE(11887)] = 437275,
  [SMALL_STATE(11888)] = 437298,
  [SMALL_STATE(11889)] = 437327,
  [SMALL_STATE(11890)] = 437350,
  [SMALL_STATE(11891)] = 437373,
  [SMALL_STATE(11892)] = 437396,
  [SMALL_STATE(11893)] = 437419,
  [SMALL_STATE(11894)] = 437442,
  [SMALL_STATE(11895)] = 437463,
  [SMALL_STATE(11896)] = 437486,
  [SMALL_STATE(11897)] = 437509,
  [SMALL_STATE(11898)] = 437532,
  [SMALL_STATE(11899)] = 437555,
  [SMALL_STATE(11900)] = 437578,
  [SMALL_STATE(11901)] = 437607,
  [SMALL_STATE(11902)] = 437644,
  [SMALL_STATE(11903)] = 437685,
  [SMALL_STATE(11904)] = 437706,
  [SMALL_STATE(11905)] = 437729,
  [SMALL_STATE(11906)] = 437750,
  [SMALL_STATE(11907)] = 437773,
  [SMALL_STATE(11908)] = 437796,
  [SMALL_STATE(11909)] = 437819,
  [SMALL_STATE(11910)] = 437842,
  [SMALL_STATE(11911)] = 437865,
  [SMALL_STATE(11912)] = 437888,
  [SMALL_STATE(11913)] = 437925,
  [SMALL_STATE(11914)] = 437948,
  [SMALL_STATE(11915)] = 437971,
  [SMALL_STATE(11916)] = 437994,
  [SMALL_STATE(11917)] = 438017,
  [SMALL_STATE(11918)] = 438040,
  [SMALL_STATE(11919)] = 438063,
  [SMALL_STATE(11920)] = 438086,
  [SMALL_STATE(11921)] = 438123,
  [SMALL_STATE(11922)] = 438146,
  [SMALL_STATE(11923)] = 438169,
  [SMALL_STATE(11924)] = 438192,
  [SMALL_STATE(11925)] = 438215,
  [SMALL_STATE(11926)] = 438238,
  [SMALL_STATE(11927)] = 438261,
  [SMALL_STATE(11928)] = 438296,
  [SMALL_STATE(11929)] = 438319,
  [SMALL_STATE(11930)] = 438342,
  [SMALL_STATE(11931)] = 438365,
  [SMALL_STATE(11932)] = 438388,
  [SMALL_STATE(11933)] = 438425,
  [SMALL_STATE(11934)] = 438448,
  [SMALL_STATE(11935)] = 438471,
  [SMALL_STATE(11936)] = 438512,
  [SMALL_STATE(11937)] = 438549,
  [SMALL_STATE(11938)] = 438572,
  [SMALL_STATE(11939)] = 438595,
  [SMALL_STATE(11940)] = 438618,
  [SMALL_STATE(11941)] = 438641,
  [SMALL_STATE(11942)] = 438664,
  [SMALL_STATE(11943)] = 438687,
  [SMALL_STATE(11944)] = 438709,
  [SMALL_STATE(11945)] = 438729,
  [SMALL_STATE(11946)] = 438751,
  [SMALL_STATE(11947)] = 438771,
  [SMALL_STATE(11948)] = 438791,
  [SMALL_STATE(11949)] = 438811,
  [SMALL_STATE(11950)] = 438833,
  [SMALL_STATE(11951)] = 438863,
  [SMALL_STATE(11952)] = 438885,
  [SMALL_STATE(11953)] = 438907,
  [SMALL_STATE(11954)] = 438929,
  [SMALL_STATE(11955)] = 438951,
  [SMALL_STATE(11956)] = 438973,
  [SMALL_STATE(11957)] = 438995,
  [SMALL_STATE(11958)] = 439033,
  [SMALL_STATE(11959)] = 439055,
  [SMALL_STATE(11960)] = 439093,
  [SMALL_STATE(11961)] = 439113,
  [SMALL_STATE(11962)] = 439133,
  [SMALL_STATE(11963)] = 439155,
  [SMALL_STATE(11964)] = 439175,
  [SMALL_STATE(11965)] = 439195,
  [SMALL_STATE(11966)] = 439215,
  [SMALL_STATE(11967)] = 439235,
  [SMALL_STATE(11968)] = 439255,
  [SMALL_STATE(11969)] = 439293,
  [SMALL_STATE(11970)] = 439315,
  [SMALL_STATE(11971)] = 439337,
  [SMALL_STATE(11972)] = 439359,
  [SMALL_STATE(11973)] = 439379,
  [SMALL_STATE(11974)] = 439401,
  [SMALL_STATE(11975)] = 439423,
  [SMALL_STATE(11976)] = 439461,
  [SMALL_STATE(11977)] = 439481,
  [SMALL_STATE(11978)] = 439503,
  [SMALL_STATE(11979)] = 439525,
  [SMALL_STATE(11980)] = 439547,
  [SMALL_STATE(11981)] = 439567,
  [SMALL_STATE(11982)] = 439587,
  [SMALL_STATE(11983)] = 439607,
  [SMALL_STATE(11984)] = 439627,
  [SMALL_STATE(11985)] = 439647,
  [SMALL_STATE(11986)] = 439667,
  [SMALL_STATE(11987)] = 439687,
  [SMALL_STATE(11988)] = 439707,
  [SMALL_STATE(11989)] = 439727,
  [SMALL_STATE(11990)] = 439749,
  [SMALL_STATE(11991)] = 439769,
  [SMALL_STATE(11992)] = 439789,
  [SMALL_STATE(11993)] = 439811,
  [SMALL_STATE(11994)] = 439833,
  [SMALL_STATE(11995)] = 439855,
  [SMALL_STATE(11996)] = 439883,
  [SMALL_STATE(11997)] = 439905,
  [SMALL_STATE(11998)] = 439925,
  [SMALL_STATE(11999)] = 439947,
  [SMALL_STATE(12000)] = 439967,
  [SMALL_STATE(12001)] = 439987,
  [SMALL_STATE(12002)] = 440007,
  [SMALL_STATE(12003)] = 440027,
  [SMALL_STATE(12004)] = 440047,
  [SMALL_STATE(12005)] = 440069,
  [SMALL_STATE(12006)] = 440089,
  [SMALL_STATE(12007)] = 440109,
  [SMALL_STATE(12008)] = 440131,
  [SMALL_STATE(12009)] = 440151,
  [SMALL_STATE(12010)] = 440189,
  [SMALL_STATE(12011)] = 440227,
  [SMALL_STATE(12012)] = 440247,
  [SMALL_STATE(12013)] = 440269,
  [SMALL_STATE(12014)] = 440307,
  [SMALL_STATE(12015)] = 440329,
  [SMALL_STATE(12016)] = 440353,
  [SMALL_STATE(12017)] = 440375,
  [SMALL_STATE(12018)] = 440395,
  [SMALL_STATE(12019)] = 440415,
  [SMALL_STATE(12020)] = 440453,
  [SMALL_STATE(12021)] = 440475,
  [SMALL_STATE(12022)] = 440501,
  [SMALL_STATE(12023)] = 440531,
  [SMALL_STATE(12024)] = 440551,
  [SMALL_STATE(12025)] = 440573,
  [SMALL_STATE(12026)] = 440595,
  [SMALL_STATE(12027)] = 440615,
  [SMALL_STATE(12028)] = 440637,
  [SMALL_STATE(12029)] = 440657,
  [SMALL_STATE(12030)] = 440679,
  [SMALL_STATE(12031)] = 440701,
  [SMALL_STATE(12032)] = 440723,
  [SMALL_STATE(12033)] = 440745,
  [SMALL_STATE(12034)] = 440767,
  [SMALL_STATE(12035)] = 440787,
  [SMALL_STATE(12036)] = 440809,
  [SMALL_STATE(12037)] = 440829,
  [SMALL_STATE(12038)] = 440849,
  [SMALL_STATE(12039)] = 440869,
  [SMALL_STATE(12040)] = 440891,
  [SMALL_STATE(12041)] = 440923,
  [SMALL_STATE(12042)] = 440943,
  [SMALL_STATE(12043)] = 440963,
  [SMALL_STATE(12044)] = 440983,
  [SMALL_STATE(12045)] = 441003,
  [SMALL_STATE(12046)] = 441025,
  [SMALL_STATE(12047)] = 441045,
  [SMALL_STATE(12048)] = 441065,
  [SMALL_STATE(12049)] = 441085,
  [SMALL_STATE(12050)] = 441107,
  [SMALL_STATE(12051)] = 441129,
  [SMALL_STATE(12052)] = 441151,
  [SMALL_STATE(12053)] = 441171,
  [SMALL_STATE(12054)] = 441191,
  [SMALL_STATE(12055)] = 441229,
  [SMALL_STATE(12056)] = 441251,
  [SMALL_STATE(12057)] = 441279,
  [SMALL_STATE(12058)] = 441299,
  [SMALL_STATE(12059)] = 441319,
  [SMALL_STATE(12060)] = 441339,
  [SMALL_STATE(12061)] = 441363,
  [SMALL_STATE(12062)] = 441383,
  [SMALL_STATE(12063)] = 441403,
  [SMALL_STATE(12064)] = 441425,
  [SMALL_STATE(12065)] = 441445,
  [SMALL_STATE(12066)] = 441467,
  [SMALL_STATE(12067)] = 441489,
  [SMALL_STATE(12068)] = 441511,
  [SMALL_STATE(12069)] = 441533,
  [SMALL_STATE(12070)] = 441553,
  [SMALL_STATE(12071)] = 441573,
  [SMALL_STATE(12072)] = 441593,
  [SMALL_STATE(12073)] = 441613,
  [SMALL_STATE(12074)] = 441635,
  [SMALL_STATE(12075)] = 441655,
  [SMALL_STATE(12076)] = 441675,
  [SMALL_STATE(12077)] = 441713,
  [SMALL_STATE(12078)] = 441733,
  [SMALL_STATE(12079)] = 441755,
  [SMALL_STATE(12080)] = 441781,
  [SMALL_STATE(12081)] = 441801,
  [SMALL_STATE(12082)] = 441839,
  [SMALL_STATE(12083)] = 441861,
  [SMALL_STATE(12084)] = 441899,
  [SMALL_STATE(12085)] = 441933,
  [SMALL_STATE(12086)] = 441955,
  [SMALL_STATE(12087)] = 441975,
  [SMALL_STATE(12088)] = 442013,
  [SMALL_STATE(12089)] = 442033,
  [SMALL_STATE(12090)] = 442067,
  [SMALL_STATE(12091)] = 442089,
  [SMALL_STATE(12092)] = 442123,
  [SMALL_STATE(12093)] = 442143,
  [SMALL_STATE(12094)] = 442165,
  [SMALL_STATE(12095)] = 442185,
  [SMALL_STATE(12096)] = 442205,
  [SMALL_STATE(12097)] = 442227,
  [SMALL_STATE(12098)] = 442247,
  [SMALL_STATE(12099)] = 442267,
  [SMALL_STATE(12100)] = 442289,
  [SMALL_STATE(12101)] = 442309,
  [SMALL_STATE(12102)] = 442331,
  [SMALL_STATE(12103)] = 442353,
  [SMALL_STATE(12104)] = 442383,
  [SMALL_STATE(12105)] = 442405,
  [SMALL_STATE(12106)] = 442427,
  [SMALL_STATE(12107)] = 442449,
  [SMALL_STATE(12108)] = 442487,
  [SMALL_STATE(12109)] = 442507,
  [SMALL_STATE(12110)] = 442527,
  [SMALL_STATE(12111)] = 442551,
  [SMALL_STATE(12112)] = 442583,
  [SMALL_STATE(12113)] = 442603,
  [SMALL_STATE(12114)] = 442623,
  [SMALL_STATE(12115)] = 442645,
  [SMALL_STATE(12116)] = 442683,
  [SMALL_STATE(12117)] = 442703,
  [SMALL_STATE(12118)] = 442725,
  [SMALL_STATE(12119)] = 442745,
  [SMALL_STATE(12120)] = 442773,
  [SMALL_STATE(12121)] = 442793,
  [SMALL_STATE(12122)] = 442831,
  [SMALL_STATE(12123)] = 442851,
  [SMALL_STATE(12124)] = 442871,
  [SMALL_STATE(12125)] = 442891,
  [SMALL_STATE(12126)] = 442911,
  [SMALL_STATE(12127)] = 442931,
  [SMALL_STATE(12128)] = 442969,
  [SMALL_STATE(12129)] = 443007,
  [SMALL_STATE(12130)] = 443045,
  [SMALL_STATE(12131)] = 443065,
  [SMALL_STATE(12132)] = 443085,
  [SMALL_STATE(12133)] = 443105,
  [SMALL_STATE(12134)] = 443143,
  [SMALL_STATE(12135)] = 443173,
  [SMALL_STATE(12136)] = 443203,
  [SMALL_STATE(12137)] = 443223,
  [SMALL_STATE(12138)] = 443243,
  [SMALL_STATE(12139)] = 443263,
  [SMALL_STATE(12140)] = 443285,
  [SMALL_STATE(12141)] = 443305,
  [SMALL_STATE(12142)] = 443325,
  [SMALL_STATE(12143)] = 443345,
  [SMALL_STATE(12144)] = 443367,
  [SMALL_STATE(12145)] = 443389,
  [SMALL_STATE(12146)] = 443409,
  [SMALL_STATE(12147)] = 443431,
  [SMALL_STATE(12148)] = 443451,
  [SMALL_STATE(12149)] = 443473,
  [SMALL_STATE(12150)] = 443493,
  [SMALL_STATE(12151)] = 443513,
  [SMALL_STATE(12152)] = 443535,
  [SMALL_STATE(12153)] = 443573,
  [SMALL_STATE(12154)] = 443593,
  [SMALL_STATE(12155)] = 443613,
  [SMALL_STATE(12156)] = 443635,
  [SMALL_STATE(12157)] = 443655,
  [SMALL_STATE(12158)] = 443693,
  [SMALL_STATE(12159)] = 443717,
  [SMALL_STATE(12160)] = 443737,
  [SMALL_STATE(12161)] = 443757,
  [SMALL_STATE(12162)] = 443777,
  [SMALL_STATE(12163)] = 443797,
  [SMALL_STATE(12164)] = 443819,
  [SMALL_STATE(12165)] = 443839,
  [SMALL_STATE(12166)] = 443859,
  [SMALL_STATE(12167)] = 443885,
  [SMALL_STATE(12168)] = 443911,
  [SMALL_STATE(12169)] = 443939,
  [SMALL_STATE(12170)] = 443961,
  [SMALL_STATE(12171)] = 443983,
  [SMALL_STATE(12172)] = 444003,
  [SMALL_STATE(12173)] = 444025,
  [SMALL_STATE(12174)] = 444047,
  [SMALL_STATE(12175)] = 444085,
  [SMALL_STATE(12176)] = 444107,
  [SMALL_STATE(12177)] = 444127,
  [SMALL_STATE(12178)] = 444165,
  [SMALL_STATE(12179)] = 444185,
  [SMALL_STATE(12180)] = 444207,
  [SMALL_STATE(12181)] = 444227,
  [SMALL_STATE(12182)] = 444257,
  [SMALL_STATE(12183)] = 444279,
  [SMALL_STATE(12184)] = 444307,
  [SMALL_STATE(12185)] = 444345,
  [SMALL_STATE(12186)] = 444367,
  [SMALL_STATE(12187)] = 444399,
  [SMALL_STATE(12188)] = 444421,
  [SMALL_STATE(12189)] = 444443,
  [SMALL_STATE(12190)] = 444481,
  [SMALL_STATE(12191)] = 444503,
  [SMALL_STATE(12192)] = 444535,
  [SMALL_STATE(12193)] = 444557,
  [SMALL_STATE(12194)] = 444591,
  [SMALL_STATE(12195)] = 444613,
  [SMALL_STATE(12196)] = 444643,
  [SMALL_STATE(12197)] = 444665,
  [SMALL_STATE(12198)] = 444699,
  [SMALL_STATE(12199)] = 444719,
  [SMALL_STATE(12200)] = 444749,
  [SMALL_STATE(12201)] = 444769,
  [SMALL_STATE(12202)] = 444791,
  [SMALL_STATE(12203)] = 444811,
  [SMALL_STATE(12204)] = 444839,
  [SMALL_STATE(12205)] = 444861,
  [SMALL_STATE(12206)] = 444881,
  [SMALL_STATE(12207)] = 444903,
  [SMALL_STATE(12208)] = 444925,
  [SMALL_STATE(12209)] = 444945,
  [SMALL_STATE(12210)] = 444983,
  [SMALL_STATE(12211)] = 445003,
  [SMALL_STATE(12212)] = 445025,
  [SMALL_STATE(12213)] = 445063,
  [SMALL_STATE(12214)] = 445085,
  [SMALL_STATE(12215)] = 445107,
  [SMALL_STATE(12216)] = 445129,
  [SMALL_STATE(12217)] = 445153,
  [SMALL_STATE(12218)] = 445173,
  [SMALL_STATE(12219)] = 445193,
  [SMALL_STATE(12220)] = 445215,
  [SMALL_STATE(12221)] = 445237,
  [SMALL_STATE(12222)] = 445257,
  [SMALL_STATE(12223)] = 445279,
  [SMALL_STATE(12224)] = 445301,
  [SMALL_STATE(12225)] = 445321,
  [SMALL_STATE(12226)] = 445343,
  [SMALL_STATE(12227)] = 445381,
  [SMALL_STATE(12228)] = 445403,
  [SMALL_STATE(12229)] = 445423,
  [SMALL_STATE(12230)] = 445445,
  [SMALL_STATE(12231)] = 445483,
  [SMALL_STATE(12232)] = 445503,
  [SMALL_STATE(12233)] = 445536,
  [SMALL_STATE(12234)] = 445555,
  [SMALL_STATE(12235)] = 445590,
  [SMALL_STATE(12236)] = 445625,
  [SMALL_STATE(12237)] = 445646,
  [SMALL_STATE(12238)] = 445665,
  [SMALL_STATE(12239)] = 445684,
  [SMALL_STATE(12240)] = 445717,
  [SMALL_STATE(12241)] = 445736,
  [SMALL_STATE(12242)] = 445755,
  [SMALL_STATE(12243)] = 445788,
  [SMALL_STATE(12244)] = 445815,
  [SMALL_STATE(12245)] = 445848,
  [SMALL_STATE(12246)] = 445867,
  [SMALL_STATE(12247)] = 445886,
  [SMALL_STATE(12248)] = 445907,
  [SMALL_STATE(12249)] = 445942,
  [SMALL_STATE(12250)] = 445961,
  [SMALL_STATE(12251)] = 445982,
  [SMALL_STATE(12252)] = 446007,
  [SMALL_STATE(12253)] = 446042,
  [SMALL_STATE(12254)] = 446061,
  [SMALL_STATE(12255)] = 446096,
  [SMALL_STATE(12256)] = 446115,
  [SMALL_STATE(12257)] = 446134,
  [SMALL_STATE(12258)] = 446167,
  [SMALL_STATE(12259)] = 446186,
  [SMALL_STATE(12260)] = 446205,
  [SMALL_STATE(12261)] = 446238,
  [SMALL_STATE(12262)] = 446257,
  [SMALL_STATE(12263)] = 446290,
  [SMALL_STATE(12264)] = 446325,
  [SMALL_STATE(12265)] = 446344,
  [SMALL_STATE(12266)] = 446375,
  [SMALL_STATE(12267)] = 446408,
  [SMALL_STATE(12268)] = 446433,
  [SMALL_STATE(12269)] = 446452,
  [SMALL_STATE(12270)] = 446471,
  [SMALL_STATE(12271)] = 446490,
  [SMALL_STATE(12272)] = 446511,
  [SMALL_STATE(12273)] = 446544,
  [SMALL_STATE(12274)] = 446579,
  [SMALL_STATE(12275)] = 446612,
  [SMALL_STATE(12276)] = 446647,
  [SMALL_STATE(12277)] = 446680,
  [SMALL_STATE(12278)] = 446715,
  [SMALL_STATE(12279)] = 446734,
  [SMALL_STATE(12280)] = 446753,
  [SMALL_STATE(12281)] = 446786,
  [SMALL_STATE(12282)] = 446805,
  [SMALL_STATE(12283)] = 446840,
  [SMALL_STATE(12284)] = 446859,
  [SMALL_STATE(12285)] = 446894,
  [SMALL_STATE(12286)] = 446913,
  [SMALL_STATE(12287)] = 446932,
  [SMALL_STATE(12288)] = 446967,
  [SMALL_STATE(12289)] = 446986,
  [SMALL_STATE(12290)] = 447005,
  [SMALL_STATE(12291)] = 447026,
  [SMALL_STATE(12292)] = 447059,
  [SMALL_STATE(12293)] = 447078,
  [SMALL_STATE(12294)] = 447105,
  [SMALL_STATE(12295)] = 447124,
  [SMALL_STATE(12296)] = 447159,
  [SMALL_STATE(12297)] = 447178,
  [SMALL_STATE(12298)] = 447197,
  [SMALL_STATE(12299)] = 447216,
  [SMALL_STATE(12300)] = 447235,
  [SMALL_STATE(12301)] = 447254,
  [SMALL_STATE(12302)] = 447273,
  [SMALL_STATE(12303)] = 447304,
  [SMALL_STATE(12304)] = 447325,
  [SMALL_STATE(12305)] = 447358,
  [SMALL_STATE(12306)] = 447393,
  [SMALL_STATE(12307)] = 447418,
  [SMALL_STATE(12308)] = 447437,
  [SMALL_STATE(12309)] = 447472,
  [SMALL_STATE(12310)] = 447491,
  [SMALL_STATE(12311)] = 447524,
  [SMALL_STATE(12312)] = 447559,
  [SMALL_STATE(12313)] = 447580,
  [SMALL_STATE(12314)] = 447599,
  [SMALL_STATE(12315)] = 447620,
  [SMALL_STATE(12316)] = 447639,
  [SMALL_STATE(12317)] = 447672,
  [SMALL_STATE(12318)] = 447693,
  [SMALL_STATE(12319)] = 447714,
  [SMALL_STATE(12320)] = 447733,
  [SMALL_STATE(12321)] = 447768,
  [SMALL_STATE(12322)] = 447787,
  [SMALL_STATE(12323)] = 447806,
  [SMALL_STATE(12324)] = 447825,
  [SMALL_STATE(12325)] = 447860,
  [SMALL_STATE(12326)] = 447889,
  [SMALL_STATE(12327)] = 447908,
  [SMALL_STATE(12328)] = 447927,
  [SMALL_STATE(12329)] = 447962,
  [SMALL_STATE(12330)] = 447981,
  [SMALL_STATE(12331)] = 448000,
  [SMALL_STATE(12332)] = 448035,
  [SMALL_STATE(12333)] = 448054,
  [SMALL_STATE(12334)] = 448075,
  [SMALL_STATE(12335)] = 448108,
  [SMALL_STATE(12336)] = 448143,
  [SMALL_STATE(12337)] = 448176,
  [SMALL_STATE(12338)] = 448197,
  [SMALL_STATE(12339)] = 448216,
  [SMALL_STATE(12340)] = 448235,
  [SMALL_STATE(12341)] = 448256,
  [SMALL_STATE(12342)] = 448283,
  [SMALL_STATE(12343)] = 448318,
  [SMALL_STATE(12344)] = 448353,
  [SMALL_STATE(12345)] = 448372,
  [SMALL_STATE(12346)] = 448397,
  [SMALL_STATE(12347)] = 448416,
  [SMALL_STATE(12348)] = 448451,
  [SMALL_STATE(12349)] = 448486,
  [SMALL_STATE(12350)] = 448505,
  [SMALL_STATE(12351)] = 448524,
  [SMALL_STATE(12352)] = 448543,
  [SMALL_STATE(12353)] = 448562,
  [SMALL_STATE(12354)] = 448589,
  [SMALL_STATE(12355)] = 448624,
  [SMALL_STATE(12356)] = 448659,
  [SMALL_STATE(12357)] = 448692,
  [SMALL_STATE(12358)] = 448725,
  [SMALL_STATE(12359)] = 448748,
  [SMALL_STATE(12360)] = 448781,
  [SMALL_STATE(12361)] = 448816,
  [SMALL_STATE(12362)] = 448849,
  [SMALL_STATE(12363)] = 448884,
  [SMALL_STATE(12364)] = 448919,
  [SMALL_STATE(12365)] = 448940,
  [SMALL_STATE(12366)] = 448961,
  [SMALL_STATE(12367)] = 448994,
  [SMALL_STATE(12368)] = 449023,
  [SMALL_STATE(12369)] = 449056,
  [SMALL_STATE(12370)] = 449081,
  [SMALL_STATE(12371)] = 449116,
  [SMALL_STATE(12372)] = 449143,
  [SMALL_STATE(12373)] = 449164,
  [SMALL_STATE(12374)] = 449199,
  [SMALL_STATE(12375)] = 449232,
  [SMALL_STATE(12376)] = 449267,
  [SMALL_STATE(12377)] = 449302,
  [SMALL_STATE(12378)] = 449337,
  [SMALL_STATE(12379)] = 449362,
  [SMALL_STATE(12380)] = 449395,
  [SMALL_STATE(12381)] = 449414,
  [SMALL_STATE(12382)] = 449449,
  [SMALL_STATE(12383)] = 449482,
  [SMALL_STATE(12384)] = 449515,
  [SMALL_STATE(12385)] = 449548,
  [SMALL_STATE(12386)] = 449567,
  [SMALL_STATE(12387)] = 449586,
  [SMALL_STATE(12388)] = 449613,
  [SMALL_STATE(12389)] = 449632,
  [SMALL_STATE(12390)] = 449667,
  [SMALL_STATE(12391)] = 449686,
  [SMALL_STATE(12392)] = 449705,
  [SMALL_STATE(12393)] = 449738,
  [SMALL_STATE(12394)] = 449757,
  [SMALL_STATE(12395)] = 449792,
  [SMALL_STATE(12396)] = 449811,
  [SMALL_STATE(12397)] = 449830,
  [SMALL_STATE(12398)] = 449851,
  [SMALL_STATE(12399)] = 449870,
  [SMALL_STATE(12400)] = 449889,
  [SMALL_STATE(12401)] = 449908,
  [SMALL_STATE(12402)] = 449941,
  [SMALL_STATE(12403)] = 449974,
  [SMALL_STATE(12404)] = 450007,
  [SMALL_STATE(12405)] = 450040,
  [SMALL_STATE(12406)] = 450075,
  [SMALL_STATE(12407)] = 450110,
  [SMALL_STATE(12408)] = 450129,
  [SMALL_STATE(12409)] = 450162,
  [SMALL_STATE(12410)] = 450197,
  [SMALL_STATE(12411)] = 450216,
  [SMALL_STATE(12412)] = 450235,
  [SMALL_STATE(12413)] = 450254,
  [SMALL_STATE(12414)] = 450289,
  [SMALL_STATE(12415)] = 450308,
  [SMALL_STATE(12416)] = 450341,
  [SMALL_STATE(12417)] = 450360,
  [SMALL_STATE(12418)] = 450395,
  [SMALL_STATE(12419)] = 450430,
  [SMALL_STATE(12420)] = 450463,
  [SMALL_STATE(12421)] = 450496,
  [SMALL_STATE(12422)] = 450531,
  [SMALL_STATE(12423)] = 450552,
  [SMALL_STATE(12424)] = 450585,
  [SMALL_STATE(12425)] = 450604,
  [SMALL_STATE(12426)] = 450631,
  [SMALL_STATE(12427)] = 450650,
  [SMALL_STATE(12428)] = 450669,
  [SMALL_STATE(12429)] = 450688,
  [SMALL_STATE(12430)] = 450707,
  [SMALL_STATE(12431)] = 450740,
  [SMALL_STATE(12432)] = 450759,
  [SMALL_STATE(12433)] = 450788,
  [SMALL_STATE(12434)] = 450809,
  [SMALL_STATE(12435)] = 450828,
  [SMALL_STATE(12436)] = 450847,
  [SMALL_STATE(12437)] = 450868,
  [SMALL_STATE(12438)] = 450901,
  [SMALL_STATE(12439)] = 450936,
  [SMALL_STATE(12440)] = 450971,
  [SMALL_STATE(12441)] = 450996,
  [SMALL_STATE(12442)] = 451029,
  [SMALL_STATE(12443)] = 451064,
  [SMALL_STATE(12444)] = 451089,
  [SMALL_STATE(12445)] = 451108,
  [SMALL_STATE(12446)] = 451127,
  [SMALL_STATE(12447)] = 451146,
  [SMALL_STATE(12448)] = 451179,
  [SMALL_STATE(12449)] = 451212,
  [SMALL_STATE(12450)] = 451231,
  [SMALL_STATE(12451)] = 451260,
  [SMALL_STATE(12452)] = 451285,
  [SMALL_STATE(12453)] = 451306,
  [SMALL_STATE(12454)] = 451341,
  [SMALL_STATE(12455)] = 451362,
  [SMALL_STATE(12456)] = 451381,
  [SMALL_STATE(12457)] = 451414,
  [SMALL_STATE(12458)] = 451449,
  [SMALL_STATE(12459)] = 451482,
  [SMALL_STATE(12460)] = 451511,
  [SMALL_STATE(12461)] = 451532,
  [SMALL_STATE(12462)] = 451561,
  [SMALL_STATE(12463)] = 451596,
  [SMALL_STATE(12464)] = 451631,
  [SMALL_STATE(12465)] = 451666,
  [SMALL_STATE(12466)] = 451701,
  [SMALL_STATE(12467)] = 451722,
  [SMALL_STATE(12468)] = 451743,
  [SMALL_STATE(12469)] = 451776,
  [SMALL_STATE(12470)] = 451797,
  [SMALL_STATE(12471)] = 451816,
  [SMALL_STATE(12472)] = 451837,
  [SMALL_STATE(12473)] = 451856,
  [SMALL_STATE(12474)] = 451891,
  [SMALL_STATE(12475)] = 451926,
  [SMALL_STATE(12476)] = 451961,
  [SMALL_STATE(12477)] = 451996,
  [SMALL_STATE(12478)] = 452015,
  [SMALL_STATE(12479)] = 452034,
  [SMALL_STATE(12480)] = 452055,
  [SMALL_STATE(12481)] = 452090,
  [SMALL_STATE(12482)] = 452123,
  [SMALL_STATE(12483)] = 452158,
  [SMALL_STATE(12484)] = 452181,
  [SMALL_STATE(12485)] = 452202,
  [SMALL_STATE(12486)] = 452223,
  [SMALL_STATE(12487)] = 452242,
  [SMALL_STATE(12488)] = 452265,
  [SMALL_STATE(12489)] = 452300,
  [SMALL_STATE(12490)] = 452319,
  [SMALL_STATE(12491)] = 452354,
  [SMALL_STATE(12492)] = 452389,
  [SMALL_STATE(12493)] = 452422,
  [SMALL_STATE(12494)] = 452441,
  [SMALL_STATE(12495)] = 452462,
  [SMALL_STATE(12496)] = 452497,
  [SMALL_STATE(12497)] = 452530,
  [SMALL_STATE(12498)] = 452551,
  [SMALL_STATE(12499)] = 452576,
  [SMALL_STATE(12500)] = 452611,
  [SMALL_STATE(12501)] = 452643,
  [SMALL_STATE(12502)] = 452675,
  [SMALL_STATE(12503)] = 452693,
  [SMALL_STATE(12504)] = 452725,
  [SMALL_STATE(12505)] = 452753,
  [SMALL_STATE(12506)] = 452785,
  [SMALL_STATE(12507)] = 452817,
  [SMALL_STATE(12508)] = 452849,
  [SMALL_STATE(12509)] = 452881,
  [SMALL_STATE(12510)] = 452903,
  [SMALL_STATE(12511)] = 452923,
  [SMALL_STATE(12512)] = 452941,
  [SMALL_STATE(12513)] = 452973,
  [SMALL_STATE(12514)] = 452993,
  [SMALL_STATE(12515)] = 453015,
  [SMALL_STATE(12516)] = 453033,
  [SMALL_STATE(12517)] = 453053,
  [SMALL_STATE(12518)] = 453071,
  [SMALL_STATE(12519)] = 453089,
  [SMALL_STATE(12520)] = 453113,
  [SMALL_STATE(12521)] = 453131,
  [SMALL_STATE(12522)] = 453149,
  [SMALL_STATE(12523)] = 453171,
  [SMALL_STATE(12524)] = 453203,
  [SMALL_STATE(12525)] = 453221,
  [SMALL_STATE(12526)] = 453253,
  [SMALL_STATE(12527)] = 453273,
  [SMALL_STATE(12528)] = 453295,
  [SMALL_STATE(12529)] = 453327,
  [SMALL_STATE(12530)] = 453345,
  [SMALL_STATE(12531)] = 453373,
  [SMALL_STATE(12532)] = 453395,
  [SMALL_STATE(12533)] = 453417,
  [SMALL_STATE(12534)] = 453435,
  [SMALL_STATE(12535)] = 453467,
  [SMALL_STATE(12536)] = 453499,
  [SMALL_STATE(12537)] = 453517,
  [SMALL_STATE(12538)] = 453549,
  [SMALL_STATE(12539)] = 453581,
  [SMALL_STATE(12540)] = 453601,
  [SMALL_STATE(12541)] = 453623,
  [SMALL_STATE(12542)] = 453641,
  [SMALL_STATE(12543)] = 453661,
  [SMALL_STATE(12544)] = 453679,
  [SMALL_STATE(12545)] = 453701,
  [SMALL_STATE(12546)] = 453733,
  [SMALL_STATE(12547)] = 453765,
  [SMALL_STATE(12548)] = 453783,
  [SMALL_STATE(12549)] = 453801,
  [SMALL_STATE(12550)] = 453833,
  [SMALL_STATE(12551)] = 453865,
  [SMALL_STATE(12552)] = 453889,
  [SMALL_STATE(12553)] = 453921,
  [SMALL_STATE(12554)] = 453953,
  [SMALL_STATE(12555)] = 453971,
  [SMALL_STATE(12556)] = 453993,
  [SMALL_STATE(12557)] = 454025,
  [SMALL_STATE(12558)] = 454057,
  [SMALL_STATE(12559)] = 454089,
  [SMALL_STATE(12560)] = 454107,
  [SMALL_STATE(12561)] = 454125,
  [SMALL_STATE(12562)] = 454143,
  [SMALL_STATE(12563)] = 454165,
  [SMALL_STATE(12564)] = 454197,
  [SMALL_STATE(12565)] = 454229,
  [SMALL_STATE(12566)] = 454261,
  [SMALL_STATE(12567)] = 454293,
  [SMALL_STATE(12568)] = 454325,
  [SMALL_STATE(12569)] = 454343,
  [SMALL_STATE(12570)] = 454375,
  [SMALL_STATE(12571)] = 454397,
  [SMALL_STATE(12572)] = 454429,
  [SMALL_STATE(12573)] = 454447,
  [SMALL_STATE(12574)] = 454465,
  [SMALL_STATE(12575)] = 454483,
  [SMALL_STATE(12576)] = 454505,
  [SMALL_STATE(12577)] = 454527,
  [SMALL_STATE(12578)] = 454549,
  [SMALL_STATE(12579)] = 454567,
  [SMALL_STATE(12580)] = 454599,
  [SMALL_STATE(12581)] = 454621,
  [SMALL_STATE(12582)] = 454653,
  [SMALL_STATE(12583)] = 454685,
  [SMALL_STATE(12584)] = 454709,
  [SMALL_STATE(12585)] = 454741,
  [SMALL_STATE(12586)] = 454773,
  [SMALL_STATE(12587)] = 454805,
  [SMALL_STATE(12588)] = 454827,
  [SMALL_STATE(12589)] = 454859,
  [SMALL_STATE(12590)] = 454891,
  [SMALL_STATE(12591)] = 454923,
  [SMALL_STATE(12592)] = 454955,
  [SMALL_STATE(12593)] = 454973,
  [SMALL_STATE(12594)] = 454991,
  [SMALL_STATE(12595)] = 455013,
  [SMALL_STATE(12596)] = 455031,
  [SMALL_STATE(12597)] = 455053,
  [SMALL_STATE(12598)] = 455085,
  [SMALL_STATE(12599)] = 455117,
  [SMALL_STATE(12600)] = 455135,
  [SMALL_STATE(12601)] = 455153,
  [SMALL_STATE(12602)] = 455171,
  [SMALL_STATE(12603)] = 455189,
  [SMALL_STATE(12604)] = 455207,
  [SMALL_STATE(12605)] = 455239,
  [SMALL_STATE(12606)] = 455261,
  [SMALL_STATE(12607)] = 455279,
  [SMALL_STATE(12608)] = 455297,
  [SMALL_STATE(12609)] = 455315,
  [SMALL_STATE(12610)] = 455333,
  [SMALL_STATE(12611)] = 455353,
  [SMALL_STATE(12612)] = 455371,
  [SMALL_STATE(12613)] = 455393,
  [SMALL_STATE(12614)] = 455411,
  [SMALL_STATE(12615)] = 455429,
  [SMALL_STATE(12616)] = 455447,
  [SMALL_STATE(12617)] = 455465,
  [SMALL_STATE(12618)] = 455497,
  [SMALL_STATE(12619)] = 455529,
  [SMALL_STATE(12620)] = 455555,
  [SMALL_STATE(12621)] = 455581,
  [SMALL_STATE(12622)] = 455599,
  [SMALL_STATE(12623)] = 455631,
  [SMALL_STATE(12624)] = 455649,
  [SMALL_STATE(12625)] = 455667,
  [SMALL_STATE(12626)] = 455699,
  [SMALL_STATE(12627)] = 455717,
  [SMALL_STATE(12628)] = 455735,
  [SMALL_STATE(12629)] = 455767,
  [SMALL_STATE(12630)] = 455789,
  [SMALL_STATE(12631)] = 455807,
  [SMALL_STATE(12632)] = 455839,
  [SMALL_STATE(12633)] = 455859,
  [SMALL_STATE(12634)] = 455881,
  [SMALL_STATE(12635)] = 455905,
  [SMALL_STATE(12636)] = 455937,
  [SMALL_STATE(12637)] = 455955,
  [SMALL_STATE(12638)] = 455987,
  [SMALL_STATE(12639)] = 456007,
  [SMALL_STATE(12640)] = 456039,
  [SMALL_STATE(12641)] = 456071,
  [SMALL_STATE(12642)] = 456103,
  [SMALL_STATE(12643)] = 456121,
  [SMALL_STATE(12644)] = 456139,
  [SMALL_STATE(12645)] = 456157,
  [SMALL_STATE(12646)] = 456177,
  [SMALL_STATE(12647)] = 456209,
  [SMALL_STATE(12648)] = 456227,
  [SMALL_STATE(12649)] = 456245,
  [SMALL_STATE(12650)] = 456277,
  [SMALL_STATE(12651)] = 456295,
  [SMALL_STATE(12652)] = 456327,
  [SMALL_STATE(12653)] = 456345,
  [SMALL_STATE(12654)] = 456363,
  [SMALL_STATE(12655)] = 456383,
  [SMALL_STATE(12656)] = 456415,
  [SMALL_STATE(12657)] = 456433,
  [SMALL_STATE(12658)] = 456465,
  [SMALL_STATE(12659)] = 456485,
  [SMALL_STATE(12660)] = 456503,
  [SMALL_STATE(12661)] = 456523,
  [SMALL_STATE(12662)] = 456555,
  [SMALL_STATE(12663)] = 456587,
  [SMALL_STATE(12664)] = 456605,
  [SMALL_STATE(12665)] = 456625,
  [SMALL_STATE(12666)] = 456657,
  [SMALL_STATE(12667)] = 456675,
  [SMALL_STATE(12668)] = 456695,
  [SMALL_STATE(12669)] = 456713,
  [SMALL_STATE(12670)] = 456731,
  [SMALL_STATE(12671)] = 456763,
  [SMALL_STATE(12672)] = 456795,
  [SMALL_STATE(12673)] = 456827,
  [SMALL_STATE(12674)] = 456847,
  [SMALL_STATE(12675)] = 456873,
  [SMALL_STATE(12676)] = 456895,
  [SMALL_STATE(12677)] = 456927,
  [SMALL_STATE(12678)] = 456959,
  [SMALL_STATE(12679)] = 456977,
  [SMALL_STATE(12680)] = 456997,
  [SMALL_STATE(12681)] = 457017,
  [SMALL_STATE(12682)] = 457049,
  [SMALL_STATE(12683)] = 457081,
  [SMALL_STATE(12684)] = 457105,
  [SMALL_STATE(12685)] = 457123,
  [SMALL_STATE(12686)] = 457155,
  [SMALL_STATE(12687)] = 457177,
  [SMALL_STATE(12688)] = 457207,
  [SMALL_STATE(12689)] = 457239,
  [SMALL_STATE(12690)] = 457257,
  [SMALL_STATE(12691)] = 457275,
  [SMALL_STATE(12692)] = 457293,
  [SMALL_STATE(12693)] = 457311,
  [SMALL_STATE(12694)] = 457329,
  [SMALL_STATE(12695)] = 457347,
  [SMALL_STATE(12696)] = 457365,
  [SMALL_STATE(12697)] = 457383,
  [SMALL_STATE(12698)] = 457401,
  [SMALL_STATE(12699)] = 457433,
  [SMALL_STATE(12700)] = 457465,
  [SMALL_STATE(12701)] = 457483,
  [SMALL_STATE(12702)] = 457515,
  [SMALL_STATE(12703)] = 457533,
  [SMALL_STATE(12704)] = 457565,
  [SMALL_STATE(12705)] = 457587,
  [SMALL_STATE(12706)] = 457619,
  [SMALL_STATE(12707)] = 457639,
  [SMALL_STATE(12708)] = 457661,
  [SMALL_STATE(12709)] = 457679,
  [SMALL_STATE(12710)] = 457711,
  [SMALL_STATE(12711)] = 457735,
  [SMALL_STATE(12712)] = 457767,
  [SMALL_STATE(12713)] = 457799,
  [SMALL_STATE(12714)] = 457831,
  [SMALL_STATE(12715)] = 457863,
  [SMALL_STATE(12716)] = 457887,
  [SMALL_STATE(12717)] = 457919,
  [SMALL_STATE(12718)] = 457941,
  [SMALL_STATE(12719)] = 457959,
  [SMALL_STATE(12720)] = 457991,
  [SMALL_STATE(12721)] = 458013,
  [SMALL_STATE(12722)] = 458043,
  [SMALL_STATE(12723)] = 458075,
  [SMALL_STATE(12724)] = 458097,
  [SMALL_STATE(12725)] = 458115,
  [SMALL_STATE(12726)] = 458133,
  [SMALL_STATE(12727)] = 458165,
  [SMALL_STATE(12728)] = 458182,
  [SMALL_STATE(12729)] = 458209,
  [SMALL_STATE(12730)] = 458226,
  [SMALL_STATE(12731)] = 458245,
  [SMALL_STATE(12732)] = 458274,
  [SMALL_STATE(12733)] = 458303,
  [SMALL_STATE(12734)] = 458332,
  [SMALL_STATE(12735)] = 458361,
  [SMALL_STATE(12736)] = 458380,
  [SMALL_STATE(12737)] = 458409,
  [SMALL_STATE(12738)] = 458432,
  [SMALL_STATE(12739)] = 458451,
  [SMALL_STATE(12740)] = 458470,
  [SMALL_STATE(12741)] = 458499,
  [SMALL_STATE(12742)] = 458528,
  [SMALL_STATE(12743)] = 458557,
  [SMALL_STATE(12744)] = 458586,
  [SMALL_STATE(12745)] = 458615,
  [SMALL_STATE(12746)] = 458644,
  [SMALL_STATE(12747)] = 458673,
  [SMALL_STATE(12748)] = 458700,
  [SMALL_STATE(12749)] = 458729,
  [SMALL_STATE(12750)] = 458750,
  [SMALL_STATE(12751)] = 458777,
  [SMALL_STATE(12752)] = 458806,
  [SMALL_STATE(12753)] = 458823,
  [SMALL_STATE(12754)] = 458840,
  [SMALL_STATE(12755)] = 458857,
  [SMALL_STATE(12756)] = 458886,
  [SMALL_STATE(12757)] = 458905,
  [SMALL_STATE(12758)] = 458932,
  [SMALL_STATE(12759)] = 458961,
  [SMALL_STATE(12760)] = 458984,
  [SMALL_STATE(12761)] = 459013,
  [SMALL_STATE(12762)] = 459042,
  [SMALL_STATE(12763)] = 459065,
  [SMALL_STATE(12764)] = 459094,
  [SMALL_STATE(12765)] = 459119,
  [SMALL_STATE(12766)] = 459136,
  [SMALL_STATE(12767)] = 459165,
  [SMALL_STATE(12768)] = 459192,
  [SMALL_STATE(12769)] = 459221,
  [SMALL_STATE(12770)] = 459242,
  [SMALL_STATE(12771)] = 459265,
  [SMALL_STATE(12772)] = 459294,
  [SMALL_STATE(12773)] = 459323,
  [SMALL_STATE(12774)] = 459352,
  [SMALL_STATE(12775)] = 459381,
  [SMALL_STATE(12776)] = 459410,
  [SMALL_STATE(12777)] = 459437,
  [SMALL_STATE(12778)] = 459466,
  [SMALL_STATE(12779)] = 459495,
  [SMALL_STATE(12780)] = 459524,
  [SMALL_STATE(12781)] = 459553,
  [SMALL_STATE(12782)] = 459570,
  [SMALL_STATE(12783)] = 459589,
  [SMALL_STATE(12784)] = 459618,
  [SMALL_STATE(12785)] = 459647,
  [SMALL_STATE(12786)] = 459664,
  [SMALL_STATE(12787)] = 459693,
  [SMALL_STATE(12788)] = 459722,
  [SMALL_STATE(12789)] = 459743,
  [SMALL_STATE(12790)] = 459772,
  [SMALL_STATE(12791)] = 459801,
  [SMALL_STATE(12792)] = 459818,
  [SMALL_STATE(12793)] = 459835,
  [SMALL_STATE(12794)] = 459864,
  [SMALL_STATE(12795)] = 459893,
  [SMALL_STATE(12796)] = 459922,
  [SMALL_STATE(12797)] = 459951,
  [SMALL_STATE(12798)] = 459980,
  [SMALL_STATE(12799)] = 459999,
  [SMALL_STATE(12800)] = 460028,
  [SMALL_STATE(12801)] = 460057,
  [SMALL_STATE(12802)] = 460086,
  [SMALL_STATE(12803)] = 460103,
  [SMALL_STATE(12804)] = 460120,
  [SMALL_STATE(12805)] = 460149,
  [SMALL_STATE(12806)] = 460178,
  [SMALL_STATE(12807)] = 460199,
  [SMALL_STATE(12808)] = 460228,
  [SMALL_STATE(12809)] = 460247,
  [SMALL_STATE(12810)] = 460276,
  [SMALL_STATE(12811)] = 460303,
  [SMALL_STATE(12812)] = 460324,
  [SMALL_STATE(12813)] = 460347,
  [SMALL_STATE(12814)] = 460376,
  [SMALL_STATE(12815)] = 460405,
  [SMALL_STATE(12816)] = 460434,
  [SMALL_STATE(12817)] = 460463,
  [SMALL_STATE(12818)] = 460484,
  [SMALL_STATE(12819)] = 460513,
  [SMALL_STATE(12820)] = 460542,
  [SMALL_STATE(12821)] = 460571,
  [SMALL_STATE(12822)] = 460600,
  [SMALL_STATE(12823)] = 460627,
  [SMALL_STATE(12824)] = 460656,
  [SMALL_STATE(12825)] = 460685,
  [SMALL_STATE(12826)] = 460706,
  [SMALL_STATE(12827)] = 460735,
  [SMALL_STATE(12828)] = 460764,
  [SMALL_STATE(12829)] = 460783,
  [SMALL_STATE(12830)] = 460800,
  [SMALL_STATE(12831)] = 460829,
  [SMALL_STATE(12832)] = 460858,
  [SMALL_STATE(12833)] = 460883,
  [SMALL_STATE(12834)] = 460912,
  [SMALL_STATE(12835)] = 460939,
  [SMALL_STATE(12836)] = 460968,
  [SMALL_STATE(12837)] = 460997,
  [SMALL_STATE(12838)] = 461026,
  [SMALL_STATE(12839)] = 461045,
  [SMALL_STATE(12840)] = 461066,
  [SMALL_STATE(12841)] = 461095,
  [SMALL_STATE(12842)] = 461124,
  [SMALL_STATE(12843)] = 461147,
  [SMALL_STATE(12844)] = 461176,
  [SMALL_STATE(12845)] = 461205,
  [SMALL_STATE(12846)] = 461232,
  [SMALL_STATE(12847)] = 461261,
  [SMALL_STATE(12848)] = 461278,
  [SMALL_STATE(12849)] = 461307,
  [SMALL_STATE(12850)] = 461334,
  [SMALL_STATE(12851)] = 461363,
  [SMALL_STATE(12852)] = 461392,
  [SMALL_STATE(12853)] = 461421,
  [SMALL_STATE(12854)] = 461442,
  [SMALL_STATE(12855)] = 461471,
  [SMALL_STATE(12856)] = 461500,
  [SMALL_STATE(12857)] = 461529,
  [SMALL_STATE(12858)] = 461558,
  [SMALL_STATE(12859)] = 461585,
  [SMALL_STATE(12860)] = 461614,
  [SMALL_STATE(12861)] = 461643,
  [SMALL_STATE(12862)] = 461670,
  [SMALL_STATE(12863)] = 461699,
  [SMALL_STATE(12864)] = 461728,
  [SMALL_STATE(12865)] = 461755,
  [SMALL_STATE(12866)] = 461774,
  [SMALL_STATE(12867)] = 461803,
  [SMALL_STATE(12868)] = 461832,
  [SMALL_STATE(12869)] = 461861,
  [SMALL_STATE(12870)] = 461890,
  [SMALL_STATE(12871)] = 461919,
  [SMALL_STATE(12872)] = 461948,
  [SMALL_STATE(12873)] = 461977,
  [SMALL_STATE(12874)] = 461996,
  [SMALL_STATE(12875)] = 462015,
  [SMALL_STATE(12876)] = 462036,
  [SMALL_STATE(12877)] = 462055,
  [SMALL_STATE(12878)] = 462072,
  [SMALL_STATE(12879)] = 462099,
  [SMALL_STATE(12880)] = 462128,
  [SMALL_STATE(12881)] = 462157,
  [SMALL_STATE(12882)] = 462174,
  [SMALL_STATE(12883)] = 462199,
  [SMALL_STATE(12884)] = 462228,
  [SMALL_STATE(12885)] = 462245,
  [SMALL_STATE(12886)] = 462264,
  [SMALL_STATE(12887)] = 462293,
  [SMALL_STATE(12888)] = 462322,
  [SMALL_STATE(12889)] = 462351,
  [SMALL_STATE(12890)] = 462380,
  [SMALL_STATE(12891)] = 462401,
  [SMALL_STATE(12892)] = 462418,
  [SMALL_STATE(12893)] = 462447,
  [SMALL_STATE(12894)] = 462464,
  [SMALL_STATE(12895)] = 462487,
  [SMALL_STATE(12896)] = 462516,
  [SMALL_STATE(12897)] = 462543,
  [SMALL_STATE(12898)] = 462562,
  [SMALL_STATE(12899)] = 462591,
  [SMALL_STATE(12900)] = 462620,
  [SMALL_STATE(12901)] = 462639,
  [SMALL_STATE(12902)] = 462668,
  [SMALL_STATE(12903)] = 462693,
  [SMALL_STATE(12904)] = 462720,
  [SMALL_STATE(12905)] = 462749,
  [SMALL_STATE(12906)] = 462776,
  [SMALL_STATE(12907)] = 462795,
  [SMALL_STATE(12908)] = 462824,
  [SMALL_STATE(12909)] = 462841,
  [SMALL_STATE(12910)] = 462858,
  [SMALL_STATE(12911)] = 462875,
  [SMALL_STATE(12912)] = 462892,
  [SMALL_STATE(12913)] = 462921,
  [SMALL_STATE(12914)] = 462950,
  [SMALL_STATE(12915)] = 462979,
  [SMALL_STATE(12916)] = 463008,
  [SMALL_STATE(12917)] = 463037,
  [SMALL_STATE(12918)] = 463062,
  [SMALL_STATE(12919)] = 463091,
  [SMALL_STATE(12920)] = 463120,
  [SMALL_STATE(12921)] = 463137,
  [SMALL_STATE(12922)] = 463166,
  [SMALL_STATE(12923)] = 463195,
  [SMALL_STATE(12924)] = 463224,
  [SMALL_STATE(12925)] = 463247,
  [SMALL_STATE(12926)] = 463264,
  [SMALL_STATE(12927)] = 463293,
  [SMALL_STATE(12928)] = 463310,
  [SMALL_STATE(12929)] = 463339,
  [SMALL_STATE(12930)] = 463368,
  [SMALL_STATE(12931)] = 463397,
  [SMALL_STATE(12932)] = 463426,
  [SMALL_STATE(12933)] = 463455,
  [SMALL_STATE(12934)] = 463484,
  [SMALL_STATE(12935)] = 463513,
  [SMALL_STATE(12936)] = 463532,
  [SMALL_STATE(12937)] = 463551,
  [SMALL_STATE(12938)] = 463580,
  [SMALL_STATE(12939)] = 463609,
  [SMALL_STATE(12940)] = 463626,
  [SMALL_STATE(12941)] = 463643,
  [SMALL_STATE(12942)] = 463672,
  [SMALL_STATE(12943)] = 463689,
  [SMALL_STATE(12944)] = 463706,
  [SMALL_STATE(12945)] = 463723,
  [SMALL_STATE(12946)] = 463752,
  [SMALL_STATE(12947)] = 463779,
  [SMALL_STATE(12948)] = 463796,
  [SMALL_STATE(12949)] = 463823,
  [SMALL_STATE(12950)] = 463852,
  [SMALL_STATE(12951)] = 463881,
  [SMALL_STATE(12952)] = 463910,
  [SMALL_STATE(12953)] = 463939,
  [SMALL_STATE(12954)] = 463968,
  [SMALL_STATE(12955)] = 463997,
  [SMALL_STATE(12956)] = 464024,
  [SMALL_STATE(12957)] = 464045,
  [SMALL_STATE(12958)] = 464074,
  [SMALL_STATE(12959)] = 464103,
  [SMALL_STATE(12960)] = 464130,
  [SMALL_STATE(12961)] = 464159,
  [SMALL_STATE(12962)] = 464178,
  [SMALL_STATE(12963)] = 464207,
  [SMALL_STATE(12964)] = 464224,
  [SMALL_STATE(12965)] = 464253,
  [SMALL_STATE(12966)] = 464282,
  [SMALL_STATE(12967)] = 464309,
  [SMALL_STATE(12968)] = 464338,
  [SMALL_STATE(12969)] = 464365,
  [SMALL_STATE(12970)] = 464394,
  [SMALL_STATE(12971)] = 464423,
  [SMALL_STATE(12972)] = 464452,
  [SMALL_STATE(12973)] = 464477,
  [SMALL_STATE(12974)] = 464506,
  [SMALL_STATE(12975)] = 464535,
  [SMALL_STATE(12976)] = 464564,
  [SMALL_STATE(12977)] = 464593,
  [SMALL_STATE(12978)] = 464622,
  [SMALL_STATE(12979)] = 464651,
  [SMALL_STATE(12980)] = 464680,
  [SMALL_STATE(12981)] = 464697,
  [SMALL_STATE(12982)] = 464714,
  [SMALL_STATE(12983)] = 464743,
  [SMALL_STATE(12984)] = 464772,
  [SMALL_STATE(12985)] = 464801,
  [SMALL_STATE(12986)] = 464830,
  [SMALL_STATE(12987)] = 464859,
  [SMALL_STATE(12988)] = 464888,
  [SMALL_STATE(12989)] = 464917,
  [SMALL_STATE(12990)] = 464946,
  [SMALL_STATE(12991)] = 464975,
  [SMALL_STATE(12992)] = 465004,
  [SMALL_STATE(12993)] = 465033,
  [SMALL_STATE(12994)] = 465056,
  [SMALL_STATE(12995)] = 465085,
  [SMALL_STATE(12996)] = 465114,
  [SMALL_STATE(12997)] = 465139,
  [SMALL_STATE(12998)] = 465168,
  [SMALL_STATE(12999)] = 465197,
  [SMALL_STATE(13000)] = 465226,
  [SMALL_STATE(13001)] = 465255,
  [SMALL_STATE(13002)] = 465284,
  [SMALL_STATE(13003)] = 465313,
  [SMALL_STATE(13004)] = 465342,
  [SMALL_STATE(13005)] = 465371,
  [SMALL_STATE(13006)] = 465388,
  [SMALL_STATE(13007)] = 465417,
  [SMALL_STATE(13008)] = 465446,
  [SMALL_STATE(13009)] = 465475,
  [SMALL_STATE(13010)] = 465504,
  [SMALL_STATE(13011)] = 465533,
  [SMALL_STATE(13012)] = 465562,
  [SMALL_STATE(13013)] = 465587,
  [SMALL_STATE(13014)] = 465616,
  [SMALL_STATE(13015)] = 465633,
  [SMALL_STATE(13016)] = 465662,
  [SMALL_STATE(13017)] = 465679,
  [SMALL_STATE(13018)] = 465708,
  [SMALL_STATE(13019)] = 465733,
  [SMALL_STATE(13020)] = 465762,
  [SMALL_STATE(13021)] = 465791,
  [SMALL_STATE(13022)] = 465812,
  [SMALL_STATE(13023)] = 465829,
  [SMALL_STATE(13024)] = 465856,
  [SMALL_STATE(13025)] = 465885,
  [SMALL_STATE(13026)] = 465904,
  [SMALL_STATE(13027)] = 465921,
  [SMALL_STATE(13028)] = 465950,
  [SMALL_STATE(13029)] = 465979,
  [SMALL_STATE(13030)] = 465998,
  [SMALL_STATE(13031)] = 466027,
  [SMALL_STATE(13032)] = 466056,
  [SMALL_STATE(13033)] = 466077,
  [SMALL_STATE(13034)] = 466102,
  [SMALL_STATE(13035)] = 466131,
  [SMALL_STATE(13036)] = 466150,
  [SMALL_STATE(13037)] = 466171,
  [SMALL_STATE(13038)] = 466200,
  [SMALL_STATE(13039)] = 466229,
  [SMALL_STATE(13040)] = 466250,
  [SMALL_STATE(13041)] = 466279,
  [SMALL_STATE(13042)] = 466308,
  [SMALL_STATE(13043)] = 466331,
  [SMALL_STATE(13044)] = 466348,
  [SMALL_STATE(13045)] = 466365,
  [SMALL_STATE(13046)] = 466394,
  [SMALL_STATE(13047)] = 466423,
  [SMALL_STATE(13048)] = 466440,
  [SMALL_STATE(13049)] = 466469,
  [SMALL_STATE(13050)] = 466498,
  [SMALL_STATE(13051)] = 466527,
  [SMALL_STATE(13052)] = 466556,
  [SMALL_STATE(13053)] = 466585,
  [SMALL_STATE(13054)] = 466608,
  [SMALL_STATE(13055)] = 466627,
  [SMALL_STATE(13056)] = 466656,
  [SMALL_STATE(13057)] = 466685,
  [SMALL_STATE(13058)] = 466714,
  [SMALL_STATE(13059)] = 466731,
  [SMALL_STATE(13060)] = 466754,
  [SMALL_STATE(13061)] = 466771,
  [SMALL_STATE(13062)] = 466800,
  [SMALL_STATE(13063)] = 466829,
  [SMALL_STATE(13064)] = 466852,
  [SMALL_STATE(13065)] = 466881,
  [SMALL_STATE(13066)] = 466910,
  [SMALL_STATE(13067)] = 466939,
  [SMALL_STATE(13068)] = 466968,
  [SMALL_STATE(13069)] = 466997,
  [SMALL_STATE(13070)] = 467026,
  [SMALL_STATE(13071)] = 467055,
  [SMALL_STATE(13072)] = 467072,
  [SMALL_STATE(13073)] = 467095,
  [SMALL_STATE(13074)] = 467124,
  [SMALL_STATE(13075)] = 467153,
  [SMALL_STATE(13076)] = 467172,
  [SMALL_STATE(13077)] = 467191,
  [SMALL_STATE(13078)] = 467208,
  [SMALL_STATE(13079)] = 467237,
  [SMALL_STATE(13080)] = 467266,
  [SMALL_STATE(13081)] = 467285,
  [SMALL_STATE(13082)] = 467304,
  [SMALL_STATE(13083)] = 467333,
  [SMALL_STATE(13084)] = 467354,
  [SMALL_STATE(13085)] = 467371,
  [SMALL_STATE(13086)] = 467400,
  [SMALL_STATE(13087)] = 467419,
  [SMALL_STATE(13088)] = 467448,
  [SMALL_STATE(13089)] = 467477,
  [SMALL_STATE(13090)] = 467494,
  [SMALL_STATE(13091)] = 467523,
  [SMALL_STATE(13092)] = 467552,
  [SMALL_STATE(13093)] = 467579,
  [SMALL_STATE(13094)] = 467606,
  [SMALL_STATE(13095)] = 467625,
  [SMALL_STATE(13096)] = 467644,
  [SMALL_STATE(13097)] = 467673,
  [SMALL_STATE(13098)] = 467702,
  [SMALL_STATE(13099)] = 467731,
  [SMALL_STATE(13100)] = 467747,
  [SMALL_STATE(13101)] = 467763,
  [SMALL_STATE(13102)] = 467779,
  [SMALL_STATE(13103)] = 467795,
  [SMALL_STATE(13104)] = 467813,
  [SMALL_STATE(13105)] = 467831,
  [SMALL_STATE(13106)] = 467847,
  [SMALL_STATE(13107)] = 467867,
  [SMALL_STATE(13108)] = 467891,
  [SMALL_STATE(13109)] = 467907,
  [SMALL_STATE(13110)] = 467923,
  [SMALL_STATE(13111)] = 467939,
  [SMALL_STATE(13112)] = 467963,
  [SMALL_STATE(13113)] = 467983,
  [SMALL_STATE(13114)] = 468003,
  [SMALL_STATE(13115)] = 468019,
  [SMALL_STATE(13116)] = 468035,
  [SMALL_STATE(13117)] = 468053,
  [SMALL_STATE(13118)] = 468069,
  [SMALL_STATE(13119)] = 468085,
  [SMALL_STATE(13120)] = 468101,
  [SMALL_STATE(13121)] = 468117,
  [SMALL_STATE(13122)] = 468133,
  [SMALL_STATE(13123)] = 468149,
  [SMALL_STATE(13124)] = 468169,
  [SMALL_STATE(13125)] = 468191,
  [SMALL_STATE(13126)] = 468207,
  [SMALL_STATE(13127)] = 468223,
  [SMALL_STATE(13128)] = 468239,
  [SMALL_STATE(13129)] = 468257,
  [SMALL_STATE(13130)] = 468273,
  [SMALL_STATE(13131)] = 468291,
  [SMALL_STATE(13132)] = 468307,
  [SMALL_STATE(13133)] = 468323,
  [SMALL_STATE(13134)] = 468351,
  [SMALL_STATE(13135)] = 468367,
  [SMALL_STATE(13136)] = 468389,
  [SMALL_STATE(13137)] = 468411,
  [SMALL_STATE(13138)] = 468427,
  [SMALL_STATE(13139)] = 468451,
  [SMALL_STATE(13140)] = 468471,
  [SMALL_STATE(13141)] = 468499,
  [SMALL_STATE(13142)] = 468515,
  [SMALL_STATE(13143)] = 468531,
  [SMALL_STATE(13144)] = 468547,
  [SMALL_STATE(13145)] = 468563,
  [SMALL_STATE(13146)] = 468579,
  [SMALL_STATE(13147)] = 468601,
  [SMALL_STATE(13148)] = 468617,
  [SMALL_STATE(13149)] = 468633,
  [SMALL_STATE(13150)] = 468655,
  [SMALL_STATE(13151)] = 468671,
  [SMALL_STATE(13152)] = 468687,
  [SMALL_STATE(13153)] = 468703,
  [SMALL_STATE(13154)] = 468725,
  [SMALL_STATE(13155)] = 468741,
  [SMALL_STATE(13156)] = 468759,
  [SMALL_STATE(13157)] = 468781,
  [SMALL_STATE(13158)] = 468805,
  [SMALL_STATE(13159)] = 468823,
  [SMALL_STATE(13160)] = 468839,
  [SMALL_STATE(13161)] = 468855,
  [SMALL_STATE(13162)] = 468873,
  [SMALL_STATE(13163)] = 468889,
  [SMALL_STATE(13164)] = 468905,
  [SMALL_STATE(13165)] = 468921,
  [SMALL_STATE(13166)] = 468947,
  [SMALL_STATE(13167)] = 468963,
  [SMALL_STATE(13168)] = 468979,
  [SMALL_STATE(13169)] = 468995,
  [SMALL_STATE(13170)] = 469023,
  [SMALL_STATE(13171)] = 469039,
  [SMALL_STATE(13172)] = 469055,
  [SMALL_STATE(13173)] = 469081,
  [SMALL_STATE(13174)] = 469097,
  [SMALL_STATE(13175)] = 469121,
  [SMALL_STATE(13176)] = 469143,
  [SMALL_STATE(13177)] = 469159,
  [SMALL_STATE(13178)] = 469177,
  [SMALL_STATE(13179)] = 469193,
  [SMALL_STATE(13180)] = 469211,
  [SMALL_STATE(13181)] = 469227,
  [SMALL_STATE(13182)] = 469243,
  [SMALL_STATE(13183)] = 469259,
  [SMALL_STATE(13184)] = 469275,
  [SMALL_STATE(13185)] = 469291,
  [SMALL_STATE(13186)] = 469307,
  [SMALL_STATE(13187)] = 469323,
  [SMALL_STATE(13188)] = 469339,
  [SMALL_STATE(13189)] = 469355,
  [SMALL_STATE(13190)] = 469381,
  [SMALL_STATE(13191)] = 469397,
  [SMALL_STATE(13192)] = 469413,
  [SMALL_STATE(13193)] = 469429,
  [SMALL_STATE(13194)] = 469445,
  [SMALL_STATE(13195)] = 469461,
  [SMALL_STATE(13196)] = 469477,
  [SMALL_STATE(13197)] = 469495,
  [SMALL_STATE(13198)] = 469511,
  [SMALL_STATE(13199)] = 469527,
  [SMALL_STATE(13200)] = 469543,
  [SMALL_STATE(13201)] = 469559,
  [SMALL_STATE(13202)] = 469575,
  [SMALL_STATE(13203)] = 469591,
  [SMALL_STATE(13204)] = 469617,
  [SMALL_STATE(13205)] = 469633,
  [SMALL_STATE(13206)] = 469649,
  [SMALL_STATE(13207)] = 469673,
  [SMALL_STATE(13208)] = 469689,
  [SMALL_STATE(13209)] = 469705,
  [SMALL_STATE(13210)] = 469731,
  [SMALL_STATE(13211)] = 469757,
  [SMALL_STATE(13212)] = 469775,
  [SMALL_STATE(13213)] = 469795,
  [SMALL_STATE(13214)] = 469817,
  [SMALL_STATE(13215)] = 469839,
  [SMALL_STATE(13216)] = 469855,
  [SMALL_STATE(13217)] = 469875,
  [SMALL_STATE(13218)] = 469897,
  [SMALL_STATE(13219)] = 469913,
  [SMALL_STATE(13220)] = 469929,
  [SMALL_STATE(13221)] = 469945,
  [SMALL_STATE(13222)] = 469965,
  [SMALL_STATE(13223)] = 469981,
  [SMALL_STATE(13224)] = 469997,
  [SMALL_STATE(13225)] = 470023,
  [SMALL_STATE(13226)] = 470039,
  [SMALL_STATE(13227)] = 470055,
  [SMALL_STATE(13228)] = 470071,
  [SMALL_STATE(13229)] = 470087,
  [SMALL_STATE(13230)] = 470103,
  [SMALL_STATE(13231)] = 470119,
  [SMALL_STATE(13232)] = 470135,
  [SMALL_STATE(13233)] = 470151,
  [SMALL_STATE(13234)] = 470167,
  [SMALL_STATE(13235)] = 470183,
  [SMALL_STATE(13236)] = 470199,
  [SMALL_STATE(13237)] = 470215,
  [SMALL_STATE(13238)] = 470237,
  [SMALL_STATE(13239)] = 470253,
  [SMALL_STATE(13240)] = 470269,
  [SMALL_STATE(13241)] = 470295,
  [SMALL_STATE(13242)] = 470321,
  [SMALL_STATE(13243)] = 470337,
  [SMALL_STATE(13244)] = 470353,
  [SMALL_STATE(13245)] = 470369,
  [SMALL_STATE(13246)] = 470391,
  [SMALL_STATE(13247)] = 470407,
  [SMALL_STATE(13248)] = 470425,
  [SMALL_STATE(13249)] = 470441,
  [SMALL_STATE(13250)] = 470457,
  [SMALL_STATE(13251)] = 470473,
  [SMALL_STATE(13252)] = 470489,
  [SMALL_STATE(13253)] = 470505,
  [SMALL_STATE(13254)] = 470531,
  [SMALL_STATE(13255)] = 470549,
  [SMALL_STATE(13256)] = 470565,
  [SMALL_STATE(13257)] = 470589,
  [SMALL_STATE(13258)] = 470615,
  [SMALL_STATE(13259)] = 470633,
  [SMALL_STATE(13260)] = 470649,
  [SMALL_STATE(13261)] = 470665,
  [SMALL_STATE(13262)] = 470681,
  [SMALL_STATE(13263)] = 470697,
  [SMALL_STATE(13264)] = 470713,
  [SMALL_STATE(13265)] = 470739,
  [SMALL_STATE(13266)] = 470765,
  [SMALL_STATE(13267)] = 470781,
  [SMALL_STATE(13268)] = 470797,
  [SMALL_STATE(13269)] = 470813,
  [SMALL_STATE(13270)] = 470837,
  [SMALL_STATE(13271)] = 470853,
  [SMALL_STATE(13272)] = 470873,
  [SMALL_STATE(13273)] = 470891,
  [SMALL_STATE(13274)] = 470915,
  [SMALL_STATE(13275)] = 470931,
  [SMALL_STATE(13276)] = 470947,
  [SMALL_STATE(13277)] = 470963,
  [SMALL_STATE(13278)] = 470979,
  [SMALL_STATE(13279)] = 471005,
  [SMALL_STATE(13280)] = 471027,
  [SMALL_STATE(13281)] = 471043,
  [SMALL_STATE(13282)] = 471059,
  [SMALL_STATE(13283)] = 471075,
  [SMALL_STATE(13284)] = 471091,
  [SMALL_STATE(13285)] = 471107,
  [SMALL_STATE(13286)] = 471131,
  [SMALL_STATE(13287)] = 471147,
  [SMALL_STATE(13288)] = 471163,
  [SMALL_STATE(13289)] = 471185,
  [SMALL_STATE(13290)] = 471201,
  [SMALL_STATE(13291)] = 471217,
  [SMALL_STATE(13292)] = 471233,
  [SMALL_STATE(13293)] = 471249,
  [SMALL_STATE(13294)] = 471265,
  [SMALL_STATE(13295)] = 471281,
  [SMALL_STATE(13296)] = 471297,
  [SMALL_STATE(13297)] = 471313,
  [SMALL_STATE(13298)] = 471329,
  [SMALL_STATE(13299)] = 471345,
  [SMALL_STATE(13300)] = 471361,
  [SMALL_STATE(13301)] = 471377,
  [SMALL_STATE(13302)] = 471395,
  [SMALL_STATE(13303)] = 471411,
  [SMALL_STATE(13304)] = 471431,
  [SMALL_STATE(13305)] = 471447,
  [SMALL_STATE(13306)] = 471463,
  [SMALL_STATE(13307)] = 471479,
  [SMALL_STATE(13308)] = 471495,
  [SMALL_STATE(13309)] = 471511,
  [SMALL_STATE(13310)] = 471527,
  [SMALL_STATE(13311)] = 471549,
  [SMALL_STATE(13312)] = 471565,
  [SMALL_STATE(13313)] = 471591,
  [SMALL_STATE(13314)] = 471617,
  [SMALL_STATE(13315)] = 471633,
  [SMALL_STATE(13316)] = 471649,
  [SMALL_STATE(13317)] = 471665,
  [SMALL_STATE(13318)] = 471683,
  [SMALL_STATE(13319)] = 471709,
  [SMALL_STATE(13320)] = 471725,
  [SMALL_STATE(13321)] = 471743,
  [SMALL_STATE(13322)] = 471759,
  [SMALL_STATE(13323)] = 471775,
  [SMALL_STATE(13324)] = 471801,
  [SMALL_STATE(13325)] = 471817,
  [SMALL_STATE(13326)] = 471833,
  [SMALL_STATE(13327)] = 471849,
  [SMALL_STATE(13328)] = 471875,
  [SMALL_STATE(13329)] = 471891,
  [SMALL_STATE(13330)] = 471907,
  [SMALL_STATE(13331)] = 471933,
  [SMALL_STATE(13332)] = 471949,
  [SMALL_STATE(13333)] = 471965,
  [SMALL_STATE(13334)] = 471983,
  [SMALL_STATE(13335)] = 471999,
  [SMALL_STATE(13336)] = 472015,
  [SMALL_STATE(13337)] = 472031,
  [SMALL_STATE(13338)] = 472051,
  [SMALL_STATE(13339)] = 472067,
  [SMALL_STATE(13340)] = 472083,
  [SMALL_STATE(13341)] = 472099,
  [SMALL_STATE(13342)] = 472125,
  [SMALL_STATE(13343)] = 472141,
  [SMALL_STATE(13344)] = 472157,
  [SMALL_STATE(13345)] = 472173,
  [SMALL_STATE(13346)] = 472189,
  [SMALL_STATE(13347)] = 472205,
  [SMALL_STATE(13348)] = 472221,
  [SMALL_STATE(13349)] = 472245,
  [SMALL_STATE(13350)] = 472267,
  [SMALL_STATE(13351)] = 472283,
  [SMALL_STATE(13352)] = 472303,
  [SMALL_STATE(13353)] = 472319,
  [SMALL_STATE(13354)] = 472335,
  [SMALL_STATE(13355)] = 472351,
  [SMALL_STATE(13356)] = 472367,
  [SMALL_STATE(13357)] = 472383,
  [SMALL_STATE(13358)] = 472399,
  [SMALL_STATE(13359)] = 472415,
  [SMALL_STATE(13360)] = 472433,
  [SMALL_STATE(13361)] = 472449,
  [SMALL_STATE(13362)] = 472465,
  [SMALL_STATE(13363)] = 472483,
  [SMALL_STATE(13364)] = 472499,
  [SMALL_STATE(13365)] = 472515,
  [SMALL_STATE(13366)] = 472537,
  [SMALL_STATE(13367)] = 472553,
  [SMALL_STATE(13368)] = 472577,
  [SMALL_STATE(13369)] = 472593,
  [SMALL_STATE(13370)] = 472609,
  [SMALL_STATE(13371)] = 472625,
  [SMALL_STATE(13372)] = 472641,
  [SMALL_STATE(13373)] = 472667,
  [SMALL_STATE(13374)] = 472683,
  [SMALL_STATE(13375)] = 472699,
  [SMALL_STATE(13376)] = 472715,
  [SMALL_STATE(13377)] = 472731,
  [SMALL_STATE(13378)] = 472747,
  [SMALL_STATE(13379)] = 472763,
  [SMALL_STATE(13380)] = 472779,
  [SMALL_STATE(13381)] = 472795,
  [SMALL_STATE(13382)] = 472817,
  [SMALL_STATE(13383)] = 472833,
  [SMALL_STATE(13384)] = 472849,
  [SMALL_STATE(13385)] = 472865,
  [SMALL_STATE(13386)] = 472891,
  [SMALL_STATE(13387)] = 472907,
  [SMALL_STATE(13388)] = 472929,
  [SMALL_STATE(13389)] = 472945,
  [SMALL_STATE(13390)] = 472968,
  [SMALL_STATE(13391)] = 472993,
  [SMALL_STATE(13392)] = 473018,
  [SMALL_STATE(13393)] = 473037,
  [SMALL_STATE(13394)] = 473052,
  [SMALL_STATE(13395)] = 473067,
  [SMALL_STATE(13396)] = 473092,
  [SMALL_STATE(13397)] = 473115,
  [SMALL_STATE(13398)] = 473140,
  [SMALL_STATE(13399)] = 473159,
  [SMALL_STATE(13400)] = 473182,
  [SMALL_STATE(13401)] = 473197,
  [SMALL_STATE(13402)] = 473216,
  [SMALL_STATE(13403)] = 473231,
  [SMALL_STATE(13404)] = 473246,
  [SMALL_STATE(13405)] = 473271,
  [SMALL_STATE(13406)] = 473296,
  [SMALL_STATE(13407)] = 473315,
  [SMALL_STATE(13408)] = 473332,
  [SMALL_STATE(13409)] = 473353,
  [SMALL_STATE(13410)] = 473370,
  [SMALL_STATE(13411)] = 473395,
  [SMALL_STATE(13412)] = 473420,
  [SMALL_STATE(13413)] = 473445,
  [SMALL_STATE(13414)] = 473464,
  [SMALL_STATE(13415)] = 473489,
  [SMALL_STATE(13416)] = 473504,
  [SMALL_STATE(13417)] = 473519,
  [SMALL_STATE(13418)] = 473544,
  [SMALL_STATE(13419)] = 473559,
  [SMALL_STATE(13420)] = 473574,
  [SMALL_STATE(13421)] = 473589,
  [SMALL_STATE(13422)] = 473614,
  [SMALL_STATE(13423)] = 473631,
  [SMALL_STATE(13424)] = 473648,
  [SMALL_STATE(13425)] = 473665,
  [SMALL_STATE(13426)] = 473680,
  [SMALL_STATE(13427)] = 473695,
  [SMALL_STATE(13428)] = 473720,
  [SMALL_STATE(13429)] = 473735,
  [SMALL_STATE(13430)] = 473750,
  [SMALL_STATE(13431)] = 473765,
  [SMALL_STATE(13432)] = 473780,
  [SMALL_STATE(13433)] = 473805,
  [SMALL_STATE(13434)] = 473830,
  [SMALL_STATE(13435)] = 473845,
  [SMALL_STATE(13436)] = 473870,
  [SMALL_STATE(13437)] = 473885,
  [SMALL_STATE(13438)] = 473910,
  [SMALL_STATE(13439)] = 473935,
  [SMALL_STATE(13440)] = 473950,
  [SMALL_STATE(13441)] = 473969,
  [SMALL_STATE(13442)] = 473984,
  [SMALL_STATE(13443)] = 473999,
  [SMALL_STATE(13444)] = 474014,
  [SMALL_STATE(13445)] = 474029,
  [SMALL_STATE(13446)] = 474044,
  [SMALL_STATE(13447)] = 474059,
  [SMALL_STATE(13448)] = 474078,
  [SMALL_STATE(13449)] = 474093,
  [SMALL_STATE(13450)] = 474118,
  [SMALL_STATE(13451)] = 474133,
  [SMALL_STATE(13452)] = 474148,
  [SMALL_STATE(13453)] = 474163,
  [SMALL_STATE(13454)] = 474188,
  [SMALL_STATE(13455)] = 474203,
  [SMALL_STATE(13456)] = 474218,
  [SMALL_STATE(13457)] = 474233,
  [SMALL_STATE(13458)] = 474248,
  [SMALL_STATE(13459)] = 474263,
  [SMALL_STATE(13460)] = 474288,
  [SMALL_STATE(13461)] = 474303,
  [SMALL_STATE(13462)] = 474318,
  [SMALL_STATE(13463)] = 474343,
  [SMALL_STATE(13464)] = 474358,
  [SMALL_STATE(13465)] = 474373,
  [SMALL_STATE(13466)] = 474388,
  [SMALL_STATE(13467)] = 474405,
  [SMALL_STATE(13468)] = 474430,
  [SMALL_STATE(13469)] = 474455,
  [SMALL_STATE(13470)] = 474470,
  [SMALL_STATE(13471)] = 474485,
  [SMALL_STATE(13472)] = 474510,
  [SMALL_STATE(13473)] = 474533,
  [SMALL_STATE(13474)] = 474548,
  [SMALL_STATE(13475)] = 474569,
  [SMALL_STATE(13476)] = 474584,
  [SMALL_STATE(13477)] = 474609,
  [SMALL_STATE(13478)] = 474634,
  [SMALL_STATE(13479)] = 474657,
  [SMALL_STATE(13480)] = 474682,
  [SMALL_STATE(13481)] = 474707,
  [SMALL_STATE(13482)] = 474732,
  [SMALL_STATE(13483)] = 474757,
  [SMALL_STATE(13484)] = 474782,
  [SMALL_STATE(13485)] = 474803,
  [SMALL_STATE(13486)] = 474828,
  [SMALL_STATE(13487)] = 474853,
  [SMALL_STATE(13488)] = 474868,
  [SMALL_STATE(13489)] = 474883,
  [SMALL_STATE(13490)] = 474908,
  [SMALL_STATE(13491)] = 474933,
  [SMALL_STATE(13492)] = 474952,
  [SMALL_STATE(13493)] = 474977,
  [SMALL_STATE(13494)] = 475002,
  [SMALL_STATE(13495)] = 475027,
  [SMALL_STATE(13496)] = 475048,
  [SMALL_STATE(13497)] = 475069,
  [SMALL_STATE(13498)] = 475094,
  [SMALL_STATE(13499)] = 475119,
  [SMALL_STATE(13500)] = 475144,
  [SMALL_STATE(13501)] = 475169,
  [SMALL_STATE(13502)] = 475188,
  [SMALL_STATE(13503)] = 475213,
  [SMALL_STATE(13504)] = 475238,
  [SMALL_STATE(13505)] = 475263,
  [SMALL_STATE(13506)] = 475282,
  [SMALL_STATE(13507)] = 475307,
  [SMALL_STATE(13508)] = 475326,
  [SMALL_STATE(13509)] = 475351,
  [SMALL_STATE(13510)] = 475372,
  [SMALL_STATE(13511)] = 475397,
  [SMALL_STATE(13512)] = 475412,
  [SMALL_STATE(13513)] = 475429,
  [SMALL_STATE(13514)] = 475448,
  [SMALL_STATE(13515)] = 475467,
  [SMALL_STATE(13516)] = 475492,
  [SMALL_STATE(13517)] = 475517,
  [SMALL_STATE(13518)] = 475542,
  [SMALL_STATE(13519)] = 475559,
  [SMALL_STATE(13520)] = 475584,
  [SMALL_STATE(13521)] = 475601,
  [SMALL_STATE(13522)] = 475616,
  [SMALL_STATE(13523)] = 475631,
  [SMALL_STATE(13524)] = 475656,
  [SMALL_STATE(13525)] = 475681,
  [SMALL_STATE(13526)] = 475696,
  [SMALL_STATE(13527)] = 475711,
  [SMALL_STATE(13528)] = 475726,
  [SMALL_STATE(13529)] = 475745,
  [SMALL_STATE(13530)] = 475770,
  [SMALL_STATE(13531)] = 475785,
  [SMALL_STATE(13532)] = 475810,
  [SMALL_STATE(13533)] = 475825,
  [SMALL_STATE(13534)] = 475850,
  [SMALL_STATE(13535)] = 475873,
  [SMALL_STATE(13536)] = 475898,
  [SMALL_STATE(13537)] = 475923,
  [SMALL_STATE(13538)] = 475938,
  [SMALL_STATE(13539)] = 475959,
  [SMALL_STATE(13540)] = 475984,
  [SMALL_STATE(13541)] = 476009,
  [SMALL_STATE(13542)] = 476034,
  [SMALL_STATE(13543)] = 476059,
  [SMALL_STATE(13544)] = 476080,
  [SMALL_STATE(13545)] = 476099,
  [SMALL_STATE(13546)] = 476124,
  [SMALL_STATE(13547)] = 476143,
  [SMALL_STATE(13548)] = 476162,
  [SMALL_STATE(13549)] = 476187,
  [SMALL_STATE(13550)] = 476212,
  [SMALL_STATE(13551)] = 476231,
  [SMALL_STATE(13552)] = 476256,
  [SMALL_STATE(13553)] = 476273,
  [SMALL_STATE(13554)] = 476298,
  [SMALL_STATE(13555)] = 476319,
  [SMALL_STATE(13556)] = 476340,
  [SMALL_STATE(13557)] = 476361,
  [SMALL_STATE(13558)] = 476386,
  [SMALL_STATE(13559)] = 476407,
  [SMALL_STATE(13560)] = 476432,
  [SMALL_STATE(13561)] = 476457,
  [SMALL_STATE(13562)] = 476476,
  [SMALL_STATE(13563)] = 476497,
  [SMALL_STATE(13564)] = 476514,
  [SMALL_STATE(13565)] = 476539,
  [SMALL_STATE(13566)] = 476564,
  [SMALL_STATE(13567)] = 476589,
  [SMALL_STATE(13568)] = 476604,
  [SMALL_STATE(13569)] = 476619,
  [SMALL_STATE(13570)] = 476638,
  [SMALL_STATE(13571)] = 476657,
  [SMALL_STATE(13572)] = 476682,
  [SMALL_STATE(13573)] = 476699,
  [SMALL_STATE(13574)] = 476724,
  [SMALL_STATE(13575)] = 476743,
  [SMALL_STATE(13576)] = 476762,
  [SMALL_STATE(13577)] = 476781,
  [SMALL_STATE(13578)] = 476800,
  [SMALL_STATE(13579)] = 476825,
  [SMALL_STATE(13580)] = 476850,
  [SMALL_STATE(13581)] = 476869,
  [SMALL_STATE(13582)] = 476888,
  [SMALL_STATE(13583)] = 476913,
  [SMALL_STATE(13584)] = 476934,
  [SMALL_STATE(13585)] = 476949,
  [SMALL_STATE(13586)] = 476964,
  [SMALL_STATE(13587)] = 476985,
  [SMALL_STATE(13588)] = 477006,
  [SMALL_STATE(13589)] = 477031,
  [SMALL_STATE(13590)] = 477052,
  [SMALL_STATE(13591)] = 477067,
  [SMALL_STATE(13592)] = 477090,
  [SMALL_STATE(13593)] = 477113,
  [SMALL_STATE(13594)] = 477128,
  [SMALL_STATE(13595)] = 477143,
  [SMALL_STATE(13596)] = 477162,
  [SMALL_STATE(13597)] = 477187,
  [SMALL_STATE(13598)] = 477206,
  [SMALL_STATE(13599)] = 477221,
  [SMALL_STATE(13600)] = 477236,
  [SMALL_STATE(13601)] = 477257,
  [SMALL_STATE(13602)] = 477280,
  [SMALL_STATE(13603)] = 477305,
  [SMALL_STATE(13604)] = 477320,
  [SMALL_STATE(13605)] = 477337,
  [SMALL_STATE(13606)] = 477362,
  [SMALL_STATE(13607)] = 477377,
  [SMALL_STATE(13608)] = 477394,
  [SMALL_STATE(13609)] = 477409,
  [SMALL_STATE(13610)] = 477424,
  [SMALL_STATE(13611)] = 477439,
  [SMALL_STATE(13612)] = 477454,
  [SMALL_STATE(13613)] = 477471,
  [SMALL_STATE(13614)] = 477496,
  [SMALL_STATE(13615)] = 477511,
  [SMALL_STATE(13616)] = 477528,
  [SMALL_STATE(13617)] = 477543,
  [SMALL_STATE(13618)] = 477564,
  [SMALL_STATE(13619)] = 477579,
  [SMALL_STATE(13620)] = 477594,
  [SMALL_STATE(13621)] = 477619,
  [SMALL_STATE(13622)] = 477644,
  [SMALL_STATE(13623)] = 477659,
  [SMALL_STATE(13624)] = 477680,
  [SMALL_STATE(13625)] = 477695,
  [SMALL_STATE(13626)] = 477710,
  [SMALL_STATE(13627)] = 477729,
  [SMALL_STATE(13628)] = 477754,
  [SMALL_STATE(13629)] = 477769,
  [SMALL_STATE(13630)] = 477784,
  [SMALL_STATE(13631)] = 477809,
  [SMALL_STATE(13632)] = 477824,
  [SMALL_STATE(13633)] = 477839,
  [SMALL_STATE(13634)] = 477858,
  [SMALL_STATE(13635)] = 477883,
  [SMALL_STATE(13636)] = 477902,
  [SMALL_STATE(13637)] = 477917,
  [SMALL_STATE(13638)] = 477936,
  [SMALL_STATE(13639)] = 477951,
  [SMALL_STATE(13640)] = 477970,
  [SMALL_STATE(13641)] = 477989,
  [SMALL_STATE(13642)] = 478004,
  [SMALL_STATE(13643)] = 478023,
  [SMALL_STATE(13644)] = 478042,
  [SMALL_STATE(13645)] = 478067,
  [SMALL_STATE(13646)] = 478082,
  [SMALL_STATE(13647)] = 478101,
  [SMALL_STATE(13648)] = 478116,
  [SMALL_STATE(13649)] = 478131,
  [SMALL_STATE(13650)] = 478146,
  [SMALL_STATE(13651)] = 478167,
  [SMALL_STATE(13652)] = 478182,
  [SMALL_STATE(13653)] = 478197,
  [SMALL_STATE(13654)] = 478222,
  [SMALL_STATE(13655)] = 478241,
  [SMALL_STATE(13656)] = 478256,
  [SMALL_STATE(13657)] = 478277,
  [SMALL_STATE(13658)] = 478298,
  [SMALL_STATE(13659)] = 478313,
  [SMALL_STATE(13660)] = 478338,
  [SMALL_STATE(13661)] = 478353,
  [SMALL_STATE(13662)] = 478368,
  [SMALL_STATE(13663)] = 478383,
  [SMALL_STATE(13664)] = 478404,
  [SMALL_STATE(13665)] = 478429,
  [SMALL_STATE(13666)] = 478448,
  [SMALL_STATE(13667)] = 478463,
  [SMALL_STATE(13668)] = 478478,
  [SMALL_STATE(13669)] = 478493,
  [SMALL_STATE(13670)] = 478508,
  [SMALL_STATE(13671)] = 478523,
  [SMALL_STATE(13672)] = 478548,
  [SMALL_STATE(13673)] = 478563,
  [SMALL_STATE(13674)] = 478578,
  [SMALL_STATE(13675)] = 478593,
  [SMALL_STATE(13676)] = 478610,
  [SMALL_STATE(13677)] = 478635,
  [SMALL_STATE(13678)] = 478654,
  [SMALL_STATE(13679)] = 478669,
  [SMALL_STATE(13680)] = 478684,
  [SMALL_STATE(13681)] = 478701,
  [SMALL_STATE(13682)] = 478720,
  [SMALL_STATE(13683)] = 478735,
  [SMALL_STATE(13684)] = 478760,
  [SMALL_STATE(13685)] = 478775,
  [SMALL_STATE(13686)] = 478790,
  [SMALL_STATE(13687)] = 478805,
  [SMALL_STATE(13688)] = 478826,
  [SMALL_STATE(13689)] = 478841,
  [SMALL_STATE(13690)] = 478864,
  [SMALL_STATE(13691)] = 478879,
  [SMALL_STATE(13692)] = 478900,
  [SMALL_STATE(13693)] = 478917,
  [SMALL_STATE(13694)] = 478932,
  [SMALL_STATE(13695)] = 478957,
  [SMALL_STATE(13696)] = 478982,
  [SMALL_STATE(13697)] = 479001,
  [SMALL_STATE(13698)] = 479016,
  [SMALL_STATE(13699)] = 479041,
  [SMALL_STATE(13700)] = 479066,
  [SMALL_STATE(13701)] = 479081,
  [SMALL_STATE(13702)] = 479096,
  [SMALL_STATE(13703)] = 479111,
  [SMALL_STATE(13704)] = 479126,
  [SMALL_STATE(13705)] = 479147,
  [SMALL_STATE(13706)] = 479168,
  [SMALL_STATE(13707)] = 479183,
  [SMALL_STATE(13708)] = 479198,
  [SMALL_STATE(13709)] = 479223,
  [SMALL_STATE(13710)] = 479238,
  [SMALL_STATE(13711)] = 479253,
  [SMALL_STATE(13712)] = 479268,
  [SMALL_STATE(13713)] = 479289,
  [SMALL_STATE(13714)] = 479304,
  [SMALL_STATE(13715)] = 479329,
  [SMALL_STATE(13716)] = 479344,
  [SMALL_STATE(13717)] = 479359,
  [SMALL_STATE(13718)] = 479384,
  [SMALL_STATE(13719)] = 479399,
  [SMALL_STATE(13720)] = 479420,
  [SMALL_STATE(13721)] = 479435,
  [SMALL_STATE(13722)] = 479450,
  [SMALL_STATE(13723)] = 479465,
  [SMALL_STATE(13724)] = 479488,
  [SMALL_STATE(13725)] = 479503,
  [SMALL_STATE(13726)] = 479528,
  [SMALL_STATE(13727)] = 479553,
  [SMALL_STATE(13728)] = 479574,
  [SMALL_STATE(13729)] = 479589,
  [SMALL_STATE(13730)] = 479604,
  [SMALL_STATE(13731)] = 479619,
  [SMALL_STATE(13732)] = 479644,
  [SMALL_STATE(13733)] = 479659,
  [SMALL_STATE(13734)] = 479674,
  [SMALL_STATE(13735)] = 479689,
  [SMALL_STATE(13736)] = 479704,
  [SMALL_STATE(13737)] = 479719,
  [SMALL_STATE(13738)] = 479744,
  [SMALL_STATE(13739)] = 479769,
  [SMALL_STATE(13740)] = 479792,
  [SMALL_STATE(13741)] = 479807,
  [SMALL_STATE(13742)] = 479822,
  [SMALL_STATE(13743)] = 479837,
  [SMALL_STATE(13744)] = 479852,
  [SMALL_STATE(13745)] = 479867,
  [SMALL_STATE(13746)] = 479888,
  [SMALL_STATE(13747)] = 479909,
  [SMALL_STATE(13748)] = 479928,
  [SMALL_STATE(13749)] = 479953,
  [SMALL_STATE(13750)] = 479978,
  [SMALL_STATE(13751)] = 479995,
  [SMALL_STATE(13752)] = 480012,
  [SMALL_STATE(13753)] = 480031,
  [SMALL_STATE(13754)] = 480056,
  [SMALL_STATE(13755)] = 480081,
  [SMALL_STATE(13756)] = 480100,
  [SMALL_STATE(13757)] = 480117,
  [SMALL_STATE(13758)] = 480132,
  [SMALL_STATE(13759)] = 480157,
  [SMALL_STATE(13760)] = 480180,
  [SMALL_STATE(13761)] = 480203,
  [SMALL_STATE(13762)] = 480228,
  [SMALL_STATE(13763)] = 480251,
  [SMALL_STATE(13764)] = 480276,
  [SMALL_STATE(13765)] = 480291,
  [SMALL_STATE(13766)] = 480316,
  [SMALL_STATE(13767)] = 480341,
  [SMALL_STATE(13768)] = 480364,
  [SMALL_STATE(13769)] = 480389,
  [SMALL_STATE(13770)] = 480412,
  [SMALL_STATE(13771)] = 480437,
  [SMALL_STATE(13772)] = 480462,
  [SMALL_STATE(13773)] = 480477,
  [SMALL_STATE(13774)] = 480494,
  [SMALL_STATE(13775)] = 480509,
  [SMALL_STATE(13776)] = 480532,
  [SMALL_STATE(13777)] = 480555,
  [SMALL_STATE(13778)] = 480580,
  [SMALL_STATE(13779)] = 480601,
  [SMALL_STATE(13780)] = 480622,
  [SMALL_STATE(13781)] = 480637,
  [SMALL_STATE(13782)] = 480654,
  [SMALL_STATE(13783)] = 480679,
  [SMALL_STATE(13784)] = 480704,
  [SMALL_STATE(13785)] = 480723,
  [SMALL_STATE(13786)] = 480742,
  [SMALL_STATE(13787)] = 480757,
  [SMALL_STATE(13788)] = 480774,
  [SMALL_STATE(13789)] = 480799,
  [SMALL_STATE(13790)] = 480822,
  [SMALL_STATE(13791)] = 480845,
  [SMALL_STATE(13792)] = 480866,
  [SMALL_STATE(13793)] = 480891,
  [SMALL_STATE(13794)] = 480916,
  [SMALL_STATE(13795)] = 480941,
  [SMALL_STATE(13796)] = 480964,
  [SMALL_STATE(13797)] = 480987,
  [SMALL_STATE(13798)] = 481010,
  [SMALL_STATE(13799)] = 481033,
  [SMALL_STATE(13800)] = 481056,
  [SMALL_STATE(13801)] = 481081,
  [SMALL_STATE(13802)] = 481106,
  [SMALL_STATE(13803)] = 481131,
  [SMALL_STATE(13804)] = 481154,
  [SMALL_STATE(13805)] = 481177,
  [SMALL_STATE(13806)] = 481200,
  [SMALL_STATE(13807)] = 481215,
  [SMALL_STATE(13808)] = 481240,
  [SMALL_STATE(13809)] = 481265,
  [SMALL_STATE(13810)] = 481290,
  [SMALL_STATE(13811)] = 481315,
  [SMALL_STATE(13812)] = 481334,
  [SMALL_STATE(13813)] = 481355,
  [SMALL_STATE(13814)] = 481374,
  [SMALL_STATE(13815)] = 481393,
  [SMALL_STATE(13816)] = 481416,
  [SMALL_STATE(13817)] = 481439,
  [SMALL_STATE(13818)] = 481462,
  [SMALL_STATE(13819)] = 481487,
  [SMALL_STATE(13820)] = 481506,
  [SMALL_STATE(13821)] = 481529,
  [SMALL_STATE(13822)] = 481554,
  [SMALL_STATE(13823)] = 481575,
  [SMALL_STATE(13824)] = 481598,
  [SMALL_STATE(13825)] = 481617,
  [SMALL_STATE(13826)] = 481636,
  [SMALL_STATE(13827)] = 481661,
  [SMALL_STATE(13828)] = 481676,
  [SMALL_STATE(13829)] = 481701,
  [SMALL_STATE(13830)] = 481720,
  [SMALL_STATE(13831)] = 481735,
  [SMALL_STATE(13832)] = 481750,
  [SMALL_STATE(13833)] = 481765,
  [SMALL_STATE(13834)] = 481784,
  [SMALL_STATE(13835)] = 481809,
  [SMALL_STATE(13836)] = 481824,
  [SMALL_STATE(13837)] = 481849,
  [SMALL_STATE(13838)] = 481868,
  [SMALL_STATE(13839)] = 481891,
  [SMALL_STATE(13840)] = 481914,
  [SMALL_STATE(13841)] = 481939,
  [SMALL_STATE(13842)] = 481964,
  [SMALL_STATE(13843)] = 481989,
  [SMALL_STATE(13844)] = 482004,
  [SMALL_STATE(13845)] = 482027,
  [SMALL_STATE(13846)] = 482052,
  [SMALL_STATE(13847)] = 482071,
  [SMALL_STATE(13848)] = 482090,
  [SMALL_STATE(13849)] = 482109,
  [SMALL_STATE(13850)] = 482132,
  [SMALL_STATE(13851)] = 482149,
  [SMALL_STATE(13852)] = 482174,
  [SMALL_STATE(13853)] = 482193,
  [SMALL_STATE(13854)] = 482218,
  [SMALL_STATE(13855)] = 482235,
  [SMALL_STATE(13856)] = 482254,
  [SMALL_STATE(13857)] = 482279,
  [SMALL_STATE(13858)] = 482304,
  [SMALL_STATE(13859)] = 482329,
  [SMALL_STATE(13860)] = 482352,
  [SMALL_STATE(13861)] = 482371,
  [SMALL_STATE(13862)] = 482386,
  [SMALL_STATE(13863)] = 482411,
  [SMALL_STATE(13864)] = 482430,
  [SMALL_STATE(13865)] = 482451,
  [SMALL_STATE(13866)] = 482474,
  [SMALL_STATE(13867)] = 482497,
  [SMALL_STATE(13868)] = 482522,
  [SMALL_STATE(13869)] = 482541,
  [SMALL_STATE(13870)] = 482566,
  [SMALL_STATE(13871)] = 482591,
  [SMALL_STATE(13872)] = 482608,
  [SMALL_STATE(13873)] = 482627,
  [SMALL_STATE(13874)] = 482650,
  [SMALL_STATE(13875)] = 482675,
  [SMALL_STATE(13876)] = 482700,
  [SMALL_STATE(13877)] = 482725,
  [SMALL_STATE(13878)] = 482744,
  [SMALL_STATE(13879)] = 482761,
  [SMALL_STATE(13880)] = 482776,
  [SMALL_STATE(13881)] = 482801,
  [SMALL_STATE(13882)] = 482824,
  [SMALL_STATE(13883)] = 482847,
  [SMALL_STATE(13884)] = 482872,
  [SMALL_STATE(13885)] = 482897,
  [SMALL_STATE(13886)] = 482922,
  [SMALL_STATE(13887)] = 482945,
  [SMALL_STATE(13888)] = 482968,
  [SMALL_STATE(13889)] = 482993,
  [SMALL_STATE(13890)] = 483008,
  [SMALL_STATE(13891)] = 483031,
  [SMALL_STATE(13892)] = 483054,
  [SMALL_STATE(13893)] = 483077,
  [SMALL_STATE(13894)] = 483098,
  [SMALL_STATE(13895)] = 483113,
  [SMALL_STATE(13896)] = 483128,
  [SMALL_STATE(13897)] = 483151,
  [SMALL_STATE(13898)] = 483174,
  [SMALL_STATE(13899)] = 483189,
  [SMALL_STATE(13900)] = 483212,
  [SMALL_STATE(13901)] = 483235,
  [SMALL_STATE(13902)] = 483260,
  [SMALL_STATE(13903)] = 483285,
  [SMALL_STATE(13904)] = 483308,
  [SMALL_STATE(13905)] = 483323,
  [SMALL_STATE(13906)] = 483348,
  [SMALL_STATE(13907)] = 483371,
  [SMALL_STATE(13908)] = 483390,
  [SMALL_STATE(13909)] = 483415,
  [SMALL_STATE(13910)] = 483434,
  [SMALL_STATE(13911)] = 483449,
  [SMALL_STATE(13912)] = 483474,
  [SMALL_STATE(13913)] = 483489,
  [SMALL_STATE(13914)] = 483504,
  [SMALL_STATE(13915)] = 483529,
  [SMALL_STATE(13916)] = 483554,
  [SMALL_STATE(13917)] = 483577,
  [SMALL_STATE(13918)] = 483596,
  [SMALL_STATE(13919)] = 483615,
  [SMALL_STATE(13920)] = 483638,
  [SMALL_STATE(13921)] = 483653,
  [SMALL_STATE(13922)] = 483668,
  [SMALL_STATE(13923)] = 483693,
  [SMALL_STATE(13924)] = 483718,
  [SMALL_STATE(13925)] = 483743,
  [SMALL_STATE(13926)] = 483768,
  [SMALL_STATE(13927)] = 483791,
  [SMALL_STATE(13928)] = 483816,
  [SMALL_STATE(13929)] = 483831,
  [SMALL_STATE(13930)] = 483850,
  [SMALL_STATE(13931)] = 483867,
  [SMALL_STATE(13932)] = 483892,
  [SMALL_STATE(13933)] = 483915,
  [SMALL_STATE(13934)] = 483940,
  [SMALL_STATE(13935)] = 483955,
  [SMALL_STATE(13936)] = 483980,
  [SMALL_STATE(13937)] = 484005,
  [SMALL_STATE(13938)] = 484030,
  [SMALL_STATE(13939)] = 484053,
  [SMALL_STATE(13940)] = 484078,
  [SMALL_STATE(13941)] = 484103,
  [SMALL_STATE(13942)] = 484124,
  [SMALL_STATE(13943)] = 484149,
  [SMALL_STATE(13944)] = 484174,
  [SMALL_STATE(13945)] = 484195,
  [SMALL_STATE(13946)] = 484218,
  [SMALL_STATE(13947)] = 484243,
  [SMALL_STATE(13948)] = 484266,
  [SMALL_STATE(13949)] = 484291,
  [SMALL_STATE(13950)] = 484312,
  [SMALL_STATE(13951)] = 484337,
  [SMALL_STATE(13952)] = 484362,
  [SMALL_STATE(13953)] = 484381,
  [SMALL_STATE(13954)] = 484406,
  [SMALL_STATE(13955)] = 484429,
  [SMALL_STATE(13956)] = 484454,
  [SMALL_STATE(13957)] = 484477,
  [SMALL_STATE(13958)] = 484494,
  [SMALL_STATE(13959)] = 484515,
  [SMALL_STATE(13960)] = 484540,
  [SMALL_STATE(13961)] = 484565,
  [SMALL_STATE(13962)] = 484580,
  [SMALL_STATE(13963)] = 484605,
  [SMALL_STATE(13964)] = 484630,
  [SMALL_STATE(13965)] = 484653,
  [SMALL_STATE(13966)] = 484676,
  [SMALL_STATE(13967)] = 484701,
  [SMALL_STATE(13968)] = 484726,
  [SMALL_STATE(13969)] = 484749,
  [SMALL_STATE(13970)] = 484774,
  [SMALL_STATE(13971)] = 484789,
  [SMALL_STATE(13972)] = 484804,
  [SMALL_STATE(13973)] = 484823,
  [SMALL_STATE(13974)] = 484848,
  [SMALL_STATE(13975)] = 484863,
  [SMALL_STATE(13976)] = 484888,
  [SMALL_STATE(13977)] = 484913,
  [SMALL_STATE(13978)] = 484938,
  [SMALL_STATE(13979)] = 484953,
  [SMALL_STATE(13980)] = 484972,
  [SMALL_STATE(13981)] = 484997,
  [SMALL_STATE(13982)] = 485016,
  [SMALL_STATE(13983)] = 485038,
  [SMALL_STATE(13984)] = 485052,
  [SMALL_STATE(13985)] = 485070,
  [SMALL_STATE(13986)] = 485092,
  [SMALL_STATE(13987)] = 485106,
  [SMALL_STATE(13988)] = 485128,
  [SMALL_STATE(13989)] = 485150,
  [SMALL_STATE(13990)] = 485170,
  [SMALL_STATE(13991)] = 485192,
  [SMALL_STATE(13992)] = 485206,
  [SMALL_STATE(13993)] = 485228,
  [SMALL_STATE(13994)] = 485244,
  [SMALL_STATE(13995)] = 485258,
  [SMALL_STATE(13996)] = 485280,
  [SMALL_STATE(13997)] = 485302,
  [SMALL_STATE(13998)] = 485316,
  [SMALL_STATE(13999)] = 485330,
  [SMALL_STATE(14000)] = 485352,
  [SMALL_STATE(14001)] = 485366,
  [SMALL_STATE(14002)] = 485388,
  [SMALL_STATE(14003)] = 485404,
  [SMALL_STATE(14004)] = 485426,
  [SMALL_STATE(14005)] = 485448,
  [SMALL_STATE(14006)] = 485470,
  [SMALL_STATE(14007)] = 485484,
  [SMALL_STATE(14008)] = 485500,
  [SMALL_STATE(14009)] = 485520,
  [SMALL_STATE(14010)] = 485534,
  [SMALL_STATE(14011)] = 485556,
  [SMALL_STATE(14012)] = 485578,
  [SMALL_STATE(14013)] = 485592,
  [SMALL_STATE(14014)] = 485606,
  [SMALL_STATE(14015)] = 485626,
  [SMALL_STATE(14016)] = 485648,
  [SMALL_STATE(14017)] = 485662,
  [SMALL_STATE(14018)] = 485676,
  [SMALL_STATE(14019)] = 485690,
  [SMALL_STATE(14020)] = 485706,
  [SMALL_STATE(14021)] = 485720,
  [SMALL_STATE(14022)] = 485742,
  [SMALL_STATE(14023)] = 485756,
  [SMALL_STATE(14024)] = 485770,
  [SMALL_STATE(14025)] = 485784,
  [SMALL_STATE(14026)] = 485806,
  [SMALL_STATE(14027)] = 485828,
  [SMALL_STATE(14028)] = 485846,
  [SMALL_STATE(14029)] = 485860,
  [SMALL_STATE(14030)] = 485874,
  [SMALL_STATE(14031)] = 485890,
  [SMALL_STATE(14032)] = 485904,
  [SMALL_STATE(14033)] = 485926,
  [SMALL_STATE(14034)] = 485940,
  [SMALL_STATE(14035)] = 485954,
  [SMALL_STATE(14036)] = 485968,
  [SMALL_STATE(14037)] = 485982,
  [SMALL_STATE(14038)] = 485998,
  [SMALL_STATE(14039)] = 486012,
  [SMALL_STATE(14040)] = 486026,
  [SMALL_STATE(14041)] = 486040,
  [SMALL_STATE(14042)] = 486054,
  [SMALL_STATE(14043)] = 486070,
  [SMALL_STATE(14044)] = 486084,
  [SMALL_STATE(14045)] = 486098,
  [SMALL_STATE(14046)] = 486112,
  [SMALL_STATE(14047)] = 486134,
  [SMALL_STATE(14048)] = 486156,
  [SMALL_STATE(14049)] = 486170,
  [SMALL_STATE(14050)] = 486184,
  [SMALL_STATE(14051)] = 486198,
  [SMALL_STATE(14052)] = 486212,
  [SMALL_STATE(14053)] = 486228,
  [SMALL_STATE(14054)] = 486242,
  [SMALL_STATE(14055)] = 486258,
  [SMALL_STATE(14056)] = 486272,
  [SMALL_STATE(14057)] = 486288,
  [SMALL_STATE(14058)] = 486302,
  [SMALL_STATE(14059)] = 486324,
  [SMALL_STATE(14060)] = 486346,
  [SMALL_STATE(14061)] = 486360,
  [SMALL_STATE(14062)] = 486382,
  [SMALL_STATE(14063)] = 486398,
  [SMALL_STATE(14064)] = 486420,
  [SMALL_STATE(14065)] = 486442,
  [SMALL_STATE(14066)] = 486464,
  [SMALL_STATE(14067)] = 486480,
  [SMALL_STATE(14068)] = 486502,
  [SMALL_STATE(14069)] = 486520,
  [SMALL_STATE(14070)] = 486542,
  [SMALL_STATE(14071)] = 486562,
  [SMALL_STATE(14072)] = 486584,
  [SMALL_STATE(14073)] = 486606,
  [SMALL_STATE(14074)] = 486624,
  [SMALL_STATE(14075)] = 486640,
  [SMALL_STATE(14076)] = 486662,
  [SMALL_STATE(14077)] = 486676,
  [SMALL_STATE(14078)] = 486692,
  [SMALL_STATE(14079)] = 486710,
  [SMALL_STATE(14080)] = 486724,
  [SMALL_STATE(14081)] = 486738,
  [SMALL_STATE(14082)] = 486760,
  [SMALL_STATE(14083)] = 486776,
  [SMALL_STATE(14084)] = 486794,
  [SMALL_STATE(14085)] = 486810,
  [SMALL_STATE(14086)] = 486832,
  [SMALL_STATE(14087)] = 486850,
  [SMALL_STATE(14088)] = 486868,
  [SMALL_STATE(14089)] = 486884,
  [SMALL_STATE(14090)] = 486906,
  [SMALL_STATE(14091)] = 486928,
  [SMALL_STATE(14092)] = 486950,
  [SMALL_STATE(14093)] = 486972,
  [SMALL_STATE(14094)] = 486986,
  [SMALL_STATE(14095)] = 487008,
  [SMALL_STATE(14096)] = 487028,
  [SMALL_STATE(14097)] = 487050,
  [SMALL_STATE(14098)] = 487064,
  [SMALL_STATE(14099)] = 487078,
  [SMALL_STATE(14100)] = 487100,
  [SMALL_STATE(14101)] = 487120,
  [SMALL_STATE(14102)] = 487134,
  [SMALL_STATE(14103)] = 487150,
  [SMALL_STATE(14104)] = 487164,
  [SMALL_STATE(14105)] = 487184,
  [SMALL_STATE(14106)] = 487206,
  [SMALL_STATE(14107)] = 487228,
  [SMALL_STATE(14108)] = 487250,
  [SMALL_STATE(14109)] = 487264,
  [SMALL_STATE(14110)] = 487286,
  [SMALL_STATE(14111)] = 487300,
  [SMALL_STATE(14112)] = 487314,
  [SMALL_STATE(14113)] = 487334,
  [SMALL_STATE(14114)] = 487348,
  [SMALL_STATE(14115)] = 487370,
  [SMALL_STATE(14116)] = 487392,
  [SMALL_STATE(14117)] = 487406,
  [SMALL_STATE(14118)] = 487420,
  [SMALL_STATE(14119)] = 487442,
  [SMALL_STATE(14120)] = 487456,
  [SMALL_STATE(14121)] = 487470,
  [SMALL_STATE(14122)] = 487488,
  [SMALL_STATE(14123)] = 487510,
  [SMALL_STATE(14124)] = 487526,
  [SMALL_STATE(14125)] = 487546,
  [SMALL_STATE(14126)] = 487568,
  [SMALL_STATE(14127)] = 487590,
  [SMALL_STATE(14128)] = 487612,
  [SMALL_STATE(14129)] = 487634,
  [SMALL_STATE(14130)] = 487648,
  [SMALL_STATE(14131)] = 487662,
  [SMALL_STATE(14132)] = 487678,
  [SMALL_STATE(14133)] = 487692,
  [SMALL_STATE(14134)] = 487706,
  [SMALL_STATE(14135)] = 487722,
  [SMALL_STATE(14136)] = 487738,
  [SMALL_STATE(14137)] = 487756,
  [SMALL_STATE(14138)] = 487770,
  [SMALL_STATE(14139)] = 487784,
  [SMALL_STATE(14140)] = 487798,
  [SMALL_STATE(14141)] = 487820,
  [SMALL_STATE(14142)] = 487842,
  [SMALL_STATE(14143)] = 487856,
  [SMALL_STATE(14144)] = 487878,
  [SMALL_STATE(14145)] = 487894,
  [SMALL_STATE(14146)] = 487908,
  [SMALL_STATE(14147)] = 487930,
  [SMALL_STATE(14148)] = 487944,
  [SMALL_STATE(14149)] = 487962,
  [SMALL_STATE(14150)] = 487980,
  [SMALL_STATE(14151)] = 487996,
  [SMALL_STATE(14152)] = 488014,
  [SMALL_STATE(14153)] = 488030,
  [SMALL_STATE(14154)] = 488052,
  [SMALL_STATE(14155)] = 488066,
  [SMALL_STATE(14156)] = 488084,
  [SMALL_STATE(14157)] = 488098,
  [SMALL_STATE(14158)] = 488116,
  [SMALL_STATE(14159)] = 488134,
  [SMALL_STATE(14160)] = 488152,
  [SMALL_STATE(14161)] = 488168,
  [SMALL_STATE(14162)] = 488190,
  [SMALL_STATE(14163)] = 488208,
  [SMALL_STATE(14164)] = 488226,
  [SMALL_STATE(14165)] = 488244,
  [SMALL_STATE(14166)] = 488266,
  [SMALL_STATE(14167)] = 488288,
  [SMALL_STATE(14168)] = 488304,
  [SMALL_STATE(14169)] = 488326,
  [SMALL_STATE(14170)] = 488340,
  [SMALL_STATE(14171)] = 488354,
  [SMALL_STATE(14172)] = 488368,
  [SMALL_STATE(14173)] = 488386,
  [SMALL_STATE(14174)] = 488408,
  [SMALL_STATE(14175)] = 488422,
  [SMALL_STATE(14176)] = 488436,
  [SMALL_STATE(14177)] = 488456,
  [SMALL_STATE(14178)] = 488472,
  [SMALL_STATE(14179)] = 488486,
  [SMALL_STATE(14180)] = 488500,
  [SMALL_STATE(14181)] = 488514,
  [SMALL_STATE(14182)] = 488536,
  [SMALL_STATE(14183)] = 488550,
  [SMALL_STATE(14184)] = 488568,
  [SMALL_STATE(14185)] = 488582,
  [SMALL_STATE(14186)] = 488596,
  [SMALL_STATE(14187)] = 488614,
  [SMALL_STATE(14188)] = 488628,
  [SMALL_STATE(14189)] = 488646,
  [SMALL_STATE(14190)] = 488660,
  [SMALL_STATE(14191)] = 488674,
  [SMALL_STATE(14192)] = 488688,
  [SMALL_STATE(14193)] = 488702,
  [SMALL_STATE(14194)] = 488718,
  [SMALL_STATE(14195)] = 488736,
  [SMALL_STATE(14196)] = 488758,
  [SMALL_STATE(14197)] = 488772,
  [SMALL_STATE(14198)] = 488794,
  [SMALL_STATE(14199)] = 488810,
  [SMALL_STATE(14200)] = 488828,
  [SMALL_STATE(14201)] = 488850,
  [SMALL_STATE(14202)] = 488872,
  [SMALL_STATE(14203)] = 488894,
  [SMALL_STATE(14204)] = 488910,
  [SMALL_STATE(14205)] = 488932,
  [SMALL_STATE(14206)] = 488954,
  [SMALL_STATE(14207)] = 488974,
  [SMALL_STATE(14208)] = 488996,
  [SMALL_STATE(14209)] = 489018,
  [SMALL_STATE(14210)] = 489038,
  [SMALL_STATE(14211)] = 489052,
  [SMALL_STATE(14212)] = 489066,
  [SMALL_STATE(14213)] = 489088,
  [SMALL_STATE(14214)] = 489110,
  [SMALL_STATE(14215)] = 489128,
  [SMALL_STATE(14216)] = 489148,
  [SMALL_STATE(14217)] = 489162,
  [SMALL_STATE(14218)] = 489184,
  [SMALL_STATE(14219)] = 489204,
  [SMALL_STATE(14220)] = 489218,
  [SMALL_STATE(14221)] = 489236,
  [SMALL_STATE(14222)] = 489250,
  [SMALL_STATE(14223)] = 489270,
  [SMALL_STATE(14224)] = 489284,
  [SMALL_STATE(14225)] = 489302,
  [SMALL_STATE(14226)] = 489316,
  [SMALL_STATE(14227)] = 489338,
  [SMALL_STATE(14228)] = 489360,
  [SMALL_STATE(14229)] = 489374,
  [SMALL_STATE(14230)] = 489388,
  [SMALL_STATE(14231)] = 489402,
  [SMALL_STATE(14232)] = 489416,
  [SMALL_STATE(14233)] = 489430,
  [SMALL_STATE(14234)] = 489444,
  [SMALL_STATE(14235)] = 489466,
  [SMALL_STATE(14236)] = 489480,
  [SMALL_STATE(14237)] = 489494,
  [SMALL_STATE(14238)] = 489516,
  [SMALL_STATE(14239)] = 489530,
  [SMALL_STATE(14240)] = 489550,
  [SMALL_STATE(14241)] = 489572,
  [SMALL_STATE(14242)] = 489586,
  [SMALL_STATE(14243)] = 489602,
  [SMALL_STATE(14244)] = 489624,
  [SMALL_STATE(14245)] = 489638,
  [SMALL_STATE(14246)] = 489660,
  [SMALL_STATE(14247)] = 489674,
  [SMALL_STATE(14248)] = 489696,
  [SMALL_STATE(14249)] = 489714,
  [SMALL_STATE(14250)] = 489736,
  [SMALL_STATE(14251)] = 489750,
  [SMALL_STATE(14252)] = 489768,
  [SMALL_STATE(14253)] = 489782,
  [SMALL_STATE(14254)] = 489796,
  [SMALL_STATE(14255)] = 489810,
  [SMALL_STATE(14256)] = 489832,
  [SMALL_STATE(14257)] = 489854,
  [SMALL_STATE(14258)] = 489874,
  [SMALL_STATE(14259)] = 489892,
  [SMALL_STATE(14260)] = 489910,
  [SMALL_STATE(14261)] = 489924,
  [SMALL_STATE(14262)] = 489940,
  [SMALL_STATE(14263)] = 489956,
  [SMALL_STATE(14264)] = 489972,
  [SMALL_STATE(14265)] = 489992,
  [SMALL_STATE(14266)] = 490014,
  [SMALL_STATE(14267)] = 490028,
  [SMALL_STATE(14268)] = 490048,
  [SMALL_STATE(14269)] = 490070,
  [SMALL_STATE(14270)] = 490092,
  [SMALL_STATE(14271)] = 490106,
  [SMALL_STATE(14272)] = 490120,
  [SMALL_STATE(14273)] = 490142,
  [SMALL_STATE(14274)] = 490156,
  [SMALL_STATE(14275)] = 490174,
  [SMALL_STATE(14276)] = 490192,
  [SMALL_STATE(14277)] = 490206,
  [SMALL_STATE(14278)] = 490220,
  [SMALL_STATE(14279)] = 490234,
  [SMALL_STATE(14280)] = 490252,
  [SMALL_STATE(14281)] = 490266,
  [SMALL_STATE(14282)] = 490288,
  [SMALL_STATE(14283)] = 490302,
  [SMALL_STATE(14284)] = 490316,
  [SMALL_STATE(14285)] = 490336,
  [SMALL_STATE(14286)] = 490350,
  [SMALL_STATE(14287)] = 490364,
  [SMALL_STATE(14288)] = 490382,
  [SMALL_STATE(14289)] = 490400,
  [SMALL_STATE(14290)] = 490418,
  [SMALL_STATE(14291)] = 490436,
  [SMALL_STATE(14292)] = 490458,
  [SMALL_STATE(14293)] = 490480,
  [SMALL_STATE(14294)] = 490502,
  [SMALL_STATE(14295)] = 490524,
  [SMALL_STATE(14296)] = 490546,
  [SMALL_STATE(14297)] = 490562,
  [SMALL_STATE(14298)] = 490584,
  [SMALL_STATE(14299)] = 490598,
  [SMALL_STATE(14300)] = 490618,
  [SMALL_STATE(14301)] = 490640,
  [SMALL_STATE(14302)] = 490660,
  [SMALL_STATE(14303)] = 490674,
  [SMALL_STATE(14304)] = 490696,
  [SMALL_STATE(14305)] = 490714,
  [SMALL_STATE(14306)] = 490732,
  [SMALL_STATE(14307)] = 490748,
  [SMALL_STATE(14308)] = 490762,
  [SMALL_STATE(14309)] = 490784,
  [SMALL_STATE(14310)] = 490802,
  [SMALL_STATE(14311)] = 490824,
  [SMALL_STATE(14312)] = 490838,
  [SMALL_STATE(14313)] = 490860,
  [SMALL_STATE(14314)] = 490882,
  [SMALL_STATE(14315)] = 490896,
  [SMALL_STATE(14316)] = 490918,
  [SMALL_STATE(14317)] = 490932,
  [SMALL_STATE(14318)] = 490952,
  [SMALL_STATE(14319)] = 490966,
  [SMALL_STATE(14320)] = 490980,
  [SMALL_STATE(14321)] = 490994,
  [SMALL_STATE(14322)] = 491008,
  [SMALL_STATE(14323)] = 491022,
  [SMALL_STATE(14324)] = 491040,
  [SMALL_STATE(14325)] = 491054,
  [SMALL_STATE(14326)] = 491072,
  [SMALL_STATE(14327)] = 491086,
  [SMALL_STATE(14328)] = 491100,
  [SMALL_STATE(14329)] = 491118,
  [SMALL_STATE(14330)] = 491132,
  [SMALL_STATE(14331)] = 491146,
  [SMALL_STATE(14332)] = 491160,
  [SMALL_STATE(14333)] = 491178,
  [SMALL_STATE(14334)] = 491192,
  [SMALL_STATE(14335)] = 491208,
  [SMALL_STATE(14336)] = 491230,
  [SMALL_STATE(14337)] = 491250,
  [SMALL_STATE(14338)] = 491272,
  [SMALL_STATE(14339)] = 491286,
  [SMALL_STATE(14340)] = 491302,
  [SMALL_STATE(14341)] = 491320,
  [SMALL_STATE(14342)] = 491338,
  [SMALL_STATE(14343)] = 491354,
  [SMALL_STATE(14344)] = 491376,
  [SMALL_STATE(14345)] = 491398,
  [SMALL_STATE(14346)] = 491420,
  [SMALL_STATE(14347)] = 491442,
  [SMALL_STATE(14348)] = 491464,
  [SMALL_STATE(14349)] = 491486,
  [SMALL_STATE(14350)] = 491508,
  [SMALL_STATE(14351)] = 491524,
  [SMALL_STATE(14352)] = 491542,
  [SMALL_STATE(14353)] = 491558,
  [SMALL_STATE(14354)] = 491572,
  [SMALL_STATE(14355)] = 491592,
  [SMALL_STATE(14356)] = 491614,
  [SMALL_STATE(14357)] = 491636,
  [SMALL_STATE(14358)] = 491658,
  [SMALL_STATE(14359)] = 491678,
  [SMALL_STATE(14360)] = 491700,
  [SMALL_STATE(14361)] = 491720,
  [SMALL_STATE(14362)] = 491734,
  [SMALL_STATE(14363)] = 491750,
  [SMALL_STATE(14364)] = 491764,
  [SMALL_STATE(14365)] = 491786,
  [SMALL_STATE(14366)] = 491804,
  [SMALL_STATE(14367)] = 491822,
  [SMALL_STATE(14368)] = 491838,
  [SMALL_STATE(14369)] = 491860,
  [SMALL_STATE(14370)] = 491882,
  [SMALL_STATE(14371)] = 491904,
  [SMALL_STATE(14372)] = 491918,
  [SMALL_STATE(14373)] = 491936,
  [SMALL_STATE(14374)] = 491952,
  [SMALL_STATE(14375)] = 491966,
  [SMALL_STATE(14376)] = 491988,
  [SMALL_STATE(14377)] = 492002,
  [SMALL_STATE(14378)] = 492016,
  [SMALL_STATE(14379)] = 492038,
  [SMALL_STATE(14380)] = 492052,
  [SMALL_STATE(14381)] = 492074,
  [SMALL_STATE(14382)] = 492092,
  [SMALL_STATE(14383)] = 492106,
  [SMALL_STATE(14384)] = 492120,
  [SMALL_STATE(14385)] = 492134,
  [SMALL_STATE(14386)] = 492156,
  [SMALL_STATE(14387)] = 492178,
  [SMALL_STATE(14388)] = 492200,
  [SMALL_STATE(14389)] = 492218,
  [SMALL_STATE(14390)] = 492240,
  [SMALL_STATE(14391)] = 492254,
  [SMALL_STATE(14392)] = 492276,
  [SMALL_STATE(14393)] = 492294,
  [SMALL_STATE(14394)] = 492312,
  [SMALL_STATE(14395)] = 492334,
  [SMALL_STATE(14396)] = 492356,
  [SMALL_STATE(14397)] = 492374,
  [SMALL_STATE(14398)] = 492396,
  [SMALL_STATE(14399)] = 492412,
  [SMALL_STATE(14400)] = 492426,
  [SMALL_STATE(14401)] = 492446,
  [SMALL_STATE(14402)] = 492460,
  [SMALL_STATE(14403)] = 492474,
  [SMALL_STATE(14404)] = 492488,
  [SMALL_STATE(14405)] = 492502,
  [SMALL_STATE(14406)] = 492516,
  [SMALL_STATE(14407)] = 492530,
  [SMALL_STATE(14408)] = 492548,
  [SMALL_STATE(14409)] = 492568,
  [SMALL_STATE(14410)] = 492590,
  [SMALL_STATE(14411)] = 492604,
  [SMALL_STATE(14412)] = 492626,
  [SMALL_STATE(14413)] = 492642,
  [SMALL_STATE(14414)] = 492662,
  [SMALL_STATE(14415)] = 492676,
  [SMALL_STATE(14416)] = 492694,
  [SMALL_STATE(14417)] = 492708,
  [SMALL_STATE(14418)] = 492722,
  [SMALL_STATE(14419)] = 492736,
  [SMALL_STATE(14420)] = 492758,
  [SMALL_STATE(14421)] = 492776,
  [SMALL_STATE(14422)] = 492790,
  [SMALL_STATE(14423)] = 492810,
  [SMALL_STATE(14424)] = 492830,
  [SMALL_STATE(14425)] = 492848,
  [SMALL_STATE(14426)] = 492870,
  [SMALL_STATE(14427)] = 492892,
  [SMALL_STATE(14428)] = 492910,
  [SMALL_STATE(14429)] = 492924,
  [SMALL_STATE(14430)] = 492946,
  [SMALL_STATE(14431)] = 492966,
  [SMALL_STATE(14432)] = 492980,
  [SMALL_STATE(14433)] = 492994,
  [SMALL_STATE(14434)] = 493008,
  [SMALL_STATE(14435)] = 493028,
  [SMALL_STATE(14436)] = 493048,
  [SMALL_STATE(14437)] = 493070,
  [SMALL_STATE(14438)] = 493092,
  [SMALL_STATE(14439)] = 493106,
  [SMALL_STATE(14440)] = 493120,
  [SMALL_STATE(14441)] = 493134,
  [SMALL_STATE(14442)] = 493156,
  [SMALL_STATE(14443)] = 493174,
  [SMALL_STATE(14444)] = 493188,
  [SMALL_STATE(14445)] = 493204,
  [SMALL_STATE(14446)] = 493226,
  [SMALL_STATE(14447)] = 493240,
  [SMALL_STATE(14448)] = 493262,
  [SMALL_STATE(14449)] = 493280,
  [SMALL_STATE(14450)] = 493298,
  [SMALL_STATE(14451)] = 493312,
  [SMALL_STATE(14452)] = 493334,
  [SMALL_STATE(14453)] = 493356,
  [SMALL_STATE(14454)] = 493370,
  [SMALL_STATE(14455)] = 493386,
  [SMALL_STATE(14456)] = 493406,
  [SMALL_STATE(14457)] = 493428,
  [SMALL_STATE(14458)] = 493446,
  [SMALL_STATE(14459)] = 493460,
  [SMALL_STATE(14460)] = 493482,
  [SMALL_STATE(14461)] = 493504,
  [SMALL_STATE(14462)] = 493518,
  [SMALL_STATE(14463)] = 493532,
  [SMALL_STATE(14464)] = 493554,
  [SMALL_STATE(14465)] = 493576,
  [SMALL_STATE(14466)] = 493590,
  [SMALL_STATE(14467)] = 493604,
  [SMALL_STATE(14468)] = 493626,
  [SMALL_STATE(14469)] = 493646,
  [SMALL_STATE(14470)] = 493668,
  [SMALL_STATE(14471)] = 493690,
  [SMALL_STATE(14472)] = 493706,
  [SMALL_STATE(14473)] = 493728,
  [SMALL_STATE(14474)] = 493742,
  [SMALL_STATE(14475)] = 493764,
  [SMALL_STATE(14476)] = 493778,
  [SMALL_STATE(14477)] = 493792,
  [SMALL_STATE(14478)] = 493806,
  [SMALL_STATE(14479)] = 493828,
  [SMALL_STATE(14480)] = 493846,
  [SMALL_STATE(14481)] = 493866,
  [SMALL_STATE(14482)] = 493888,
  [SMALL_STATE(14483)] = 493910,
  [SMALL_STATE(14484)] = 493924,
  [SMALL_STATE(14485)] = 493940,
  [SMALL_STATE(14486)] = 493962,
  [SMALL_STATE(14487)] = 493982,
  [SMALL_STATE(14488)] = 494004,
  [SMALL_STATE(14489)] = 494018,
  [SMALL_STATE(14490)] = 494040,
  [SMALL_STATE(14491)] = 494062,
  [SMALL_STATE(14492)] = 494076,
  [SMALL_STATE(14493)] = 494098,
  [SMALL_STATE(14494)] = 494116,
  [SMALL_STATE(14495)] = 494134,
  [SMALL_STATE(14496)] = 494156,
  [SMALL_STATE(14497)] = 494172,
  [SMALL_STATE(14498)] = 494194,
  [SMALL_STATE(14499)] = 494216,
  [SMALL_STATE(14500)] = 494234,
  [SMALL_STATE(14501)] = 494252,
  [SMALL_STATE(14502)] = 494266,
  [SMALL_STATE(14503)] = 494284,
  [SMALL_STATE(14504)] = 494306,
  [SMALL_STATE(14505)] = 494328,
  [SMALL_STATE(14506)] = 494350,
  [SMALL_STATE(14507)] = 494372,
  [SMALL_STATE(14508)] = 494386,
  [SMALL_STATE(14509)] = 494408,
  [SMALL_STATE(14510)] = 494430,
  [SMALL_STATE(14511)] = 494452,
  [SMALL_STATE(14512)] = 494474,
  [SMALL_STATE(14513)] = 494494,
  [SMALL_STATE(14514)] = 494516,
  [SMALL_STATE(14515)] = 494538,
  [SMALL_STATE(14516)] = 494554,
  [SMALL_STATE(14517)] = 494570,
  [SMALL_STATE(14518)] = 494592,
  [SMALL_STATE(14519)] = 494606,
  [SMALL_STATE(14520)] = 494622,
  [SMALL_STATE(14521)] = 494642,
  [SMALL_STATE(14522)] = 494664,
  [SMALL_STATE(14523)] = 494686,
  [SMALL_STATE(14524)] = 494702,
  [SMALL_STATE(14525)] = 494716,
  [SMALL_STATE(14526)] = 494730,
  [SMALL_STATE(14527)] = 494748,
  [SMALL_STATE(14528)] = 494762,
  [SMALL_STATE(14529)] = 494776,
  [SMALL_STATE(14530)] = 494790,
  [SMALL_STATE(14531)] = 494812,
  [SMALL_STATE(14532)] = 494826,
  [SMALL_STATE(14533)] = 494848,
  [SMALL_STATE(14534)] = 494862,
  [SMALL_STATE(14535)] = 494876,
  [SMALL_STATE(14536)] = 494890,
  [SMALL_STATE(14537)] = 494908,
  [SMALL_STATE(14538)] = 494926,
  [SMALL_STATE(14539)] = 494948,
  [SMALL_STATE(14540)] = 494962,
  [SMALL_STATE(14541)] = 494980,
  [SMALL_STATE(14542)] = 494994,
  [SMALL_STATE(14543)] = 495008,
  [SMALL_STATE(14544)] = 495030,
  [SMALL_STATE(14545)] = 495044,
  [SMALL_STATE(14546)] = 495058,
  [SMALL_STATE(14547)] = 495076,
  [SMALL_STATE(14548)] = 495090,
  [SMALL_STATE(14549)] = 495108,
  [SMALL_STATE(14550)] = 495122,
  [SMALL_STATE(14551)] = 495138,
  [SMALL_STATE(14552)] = 495152,
  [SMALL_STATE(14553)] = 495166,
  [SMALL_STATE(14554)] = 495184,
  [SMALL_STATE(14555)] = 495206,
  [SMALL_STATE(14556)] = 495228,
  [SMALL_STATE(14557)] = 495244,
  [SMALL_STATE(14558)] = 495266,
  [SMALL_STATE(14559)] = 495280,
  [SMALL_STATE(14560)] = 495300,
  [SMALL_STATE(14561)] = 495322,
  [SMALL_STATE(14562)] = 495336,
  [SMALL_STATE(14563)] = 495354,
  [SMALL_STATE(14564)] = 495376,
  [SMALL_STATE(14565)] = 495398,
  [SMALL_STATE(14566)] = 495414,
  [SMALL_STATE(14567)] = 495430,
  [SMALL_STATE(14568)] = 495452,
  [SMALL_STATE(14569)] = 495466,
  [SMALL_STATE(14570)] = 495482,
  [SMALL_STATE(14571)] = 495496,
  [SMALL_STATE(14572)] = 495514,
  [SMALL_STATE(14573)] = 495532,
  [SMALL_STATE(14574)] = 495546,
  [SMALL_STATE(14575)] = 495568,
  [SMALL_STATE(14576)] = 495588,
  [SMALL_STATE(14577)] = 495604,
  [SMALL_STATE(14578)] = 495618,
  [SMALL_STATE(14579)] = 495632,
  [SMALL_STATE(14580)] = 495648,
  [SMALL_STATE(14581)] = 495664,
  [SMALL_STATE(14582)] = 495678,
  [SMALL_STATE(14583)] = 495692,
  [SMALL_STATE(14584)] = 495706,
  [SMALL_STATE(14585)] = 495720,
  [SMALL_STATE(14586)] = 495742,
  [SMALL_STATE(14587)] = 495756,
  [SMALL_STATE(14588)] = 495772,
  [SMALL_STATE(14589)] = 495792,
  [SMALL_STATE(14590)] = 495806,
  [SMALL_STATE(14591)] = 495828,
  [SMALL_STATE(14592)] = 495842,
  [SMALL_STATE(14593)] = 495856,
  [SMALL_STATE(14594)] = 495878,
  [SMALL_STATE(14595)] = 495900,
  [SMALL_STATE(14596)] = 495922,
  [SMALL_STATE(14597)] = 495938,
  [SMALL_STATE(14598)] = 495952,
  [SMALL_STATE(14599)] = 495972,
  [SMALL_STATE(14600)] = 495990,
  [SMALL_STATE(14601)] = 496010,
  [SMALL_STATE(14602)] = 496032,
  [SMALL_STATE(14603)] = 496054,
  [SMALL_STATE(14604)] = 496070,
  [SMALL_STATE(14605)] = 496092,
  [SMALL_STATE(14606)] = 496106,
  [SMALL_STATE(14607)] = 496123,
  [SMALL_STATE(14608)] = 496142,
  [SMALL_STATE(14609)] = 496159,
  [SMALL_STATE(14610)] = 496178,
  [SMALL_STATE(14611)] = 496195,
  [SMALL_STATE(14612)] = 496214,
  [SMALL_STATE(14613)] = 496229,
  [SMALL_STATE(14614)] = 496246,
  [SMALL_STATE(14615)] = 496263,
  [SMALL_STATE(14616)] = 496280,
  [SMALL_STATE(14617)] = 496297,
  [SMALL_STATE(14618)] = 496314,
  [SMALL_STATE(14619)] = 496333,
  [SMALL_STATE(14620)] = 496350,
  [SMALL_STATE(14621)] = 496369,
  [SMALL_STATE(14622)] = 496388,
  [SMALL_STATE(14623)] = 496401,
  [SMALL_STATE(14624)] = 496418,
  [SMALL_STATE(14625)] = 496435,
  [SMALL_STATE(14626)] = 496448,
  [SMALL_STATE(14627)] = 496461,
  [SMALL_STATE(14628)] = 496478,
  [SMALL_STATE(14629)] = 496495,
  [SMALL_STATE(14630)] = 496512,
  [SMALL_STATE(14631)] = 496529,
  [SMALL_STATE(14632)] = 496548,
  [SMALL_STATE(14633)] = 496561,
  [SMALL_STATE(14634)] = 496578,
  [SMALL_STATE(14635)] = 496591,
  [SMALL_STATE(14636)] = 496608,
  [SMALL_STATE(14637)] = 496625,
  [SMALL_STATE(14638)] = 496644,
  [SMALL_STATE(14639)] = 496661,
  [SMALL_STATE(14640)] = 496678,
  [SMALL_STATE(14641)] = 496691,
  [SMALL_STATE(14642)] = 496708,
  [SMALL_STATE(14643)] = 496721,
  [SMALL_STATE(14644)] = 496740,
  [SMALL_STATE(14645)] = 496755,
  [SMALL_STATE(14646)] = 496774,
  [SMALL_STATE(14647)] = 496791,
  [SMALL_STATE(14648)] = 496808,
  [SMALL_STATE(14649)] = 496821,
  [SMALL_STATE(14650)] = 496840,
  [SMALL_STATE(14651)] = 496853,
  [SMALL_STATE(14652)] = 496870,
  [SMALL_STATE(14653)] = 496883,
  [SMALL_STATE(14654)] = 496900,
  [SMALL_STATE(14655)] = 496913,
  [SMALL_STATE(14656)] = 496926,
  [SMALL_STATE(14657)] = 496939,
  [SMALL_STATE(14658)] = 496952,
  [SMALL_STATE(14659)] = 496965,
  [SMALL_STATE(14660)] = 496984,
  [SMALL_STATE(14661)] = 497001,
  [SMALL_STATE(14662)] = 497018,
  [SMALL_STATE(14663)] = 497031,
  [SMALL_STATE(14664)] = 497048,
  [SMALL_STATE(14665)] = 497067,
  [SMALL_STATE(14666)] = 497080,
  [SMALL_STATE(14667)] = 497097,
  [SMALL_STATE(14668)] = 497110,
  [SMALL_STATE(14669)] = 497127,
  [SMALL_STATE(14670)] = 497140,
  [SMALL_STATE(14671)] = 497153,
  [SMALL_STATE(14672)] = 497170,
  [SMALL_STATE(14673)] = 497183,
  [SMALL_STATE(14674)] = 497200,
  [SMALL_STATE(14675)] = 497219,
  [SMALL_STATE(14676)] = 497236,
  [SMALL_STATE(14677)] = 497253,
  [SMALL_STATE(14678)] = 497266,
  [SMALL_STATE(14679)] = 497283,
  [SMALL_STATE(14680)] = 497300,
  [SMALL_STATE(14681)] = 497317,
  [SMALL_STATE(14682)] = 497336,
  [SMALL_STATE(14683)] = 497353,
  [SMALL_STATE(14684)] = 497372,
  [SMALL_STATE(14685)] = 497391,
  [SMALL_STATE(14686)] = 497404,
  [SMALL_STATE(14687)] = 497423,
  [SMALL_STATE(14688)] = 497440,
  [SMALL_STATE(14689)] = 497457,
  [SMALL_STATE(14690)] = 497474,
  [SMALL_STATE(14691)] = 497487,
  [SMALL_STATE(14692)] = 497504,
  [SMALL_STATE(14693)] = 497523,
  [SMALL_STATE(14694)] = 497536,
  [SMALL_STATE(14695)] = 497553,
  [SMALL_STATE(14696)] = 497570,
  [SMALL_STATE(14697)] = 497589,
  [SMALL_STATE(14698)] = 497608,
  [SMALL_STATE(14699)] = 497625,
  [SMALL_STATE(14700)] = 497638,
  [SMALL_STATE(14701)] = 497651,
  [SMALL_STATE(14702)] = 497664,
  [SMALL_STATE(14703)] = 497683,
  [SMALL_STATE(14704)] = 497696,
  [SMALL_STATE(14705)] = 497709,
  [SMALL_STATE(14706)] = 497722,
  [SMALL_STATE(14707)] = 497739,
  [SMALL_STATE(14708)] = 497752,
  [SMALL_STATE(14709)] = 497769,
  [SMALL_STATE(14710)] = 497786,
  [SMALL_STATE(14711)] = 497803,
  [SMALL_STATE(14712)] = 497816,
  [SMALL_STATE(14713)] = 497833,
  [SMALL_STATE(14714)] = 497850,
  [SMALL_STATE(14715)] = 497863,
  [SMALL_STATE(14716)] = 497882,
  [SMALL_STATE(14717)] = 497901,
  [SMALL_STATE(14718)] = 497920,
  [SMALL_STATE(14719)] = 497937,
  [SMALL_STATE(14720)] = 497954,
  [SMALL_STATE(14721)] = 497971,
  [SMALL_STATE(14722)] = 497988,
  [SMALL_STATE(14723)] = 498007,
  [SMALL_STATE(14724)] = 498024,
  [SMALL_STATE(14725)] = 498043,
  [SMALL_STATE(14726)] = 498062,
  [SMALL_STATE(14727)] = 498079,
  [SMALL_STATE(14728)] = 498098,
  [SMALL_STATE(14729)] = 498115,
  [SMALL_STATE(14730)] = 498132,
  [SMALL_STATE(14731)] = 498151,
  [SMALL_STATE(14732)] = 498164,
  [SMALL_STATE(14733)] = 498181,
  [SMALL_STATE(14734)] = 498200,
  [SMALL_STATE(14735)] = 498213,
  [SMALL_STATE(14736)] = 498228,
  [SMALL_STATE(14737)] = 498247,
  [SMALL_STATE(14738)] = 498264,
  [SMALL_STATE(14739)] = 498281,
  [SMALL_STATE(14740)] = 498298,
  [SMALL_STATE(14741)] = 498315,
  [SMALL_STATE(14742)] = 498332,
  [SMALL_STATE(14743)] = 498351,
  [SMALL_STATE(14744)] = 498364,
  [SMALL_STATE(14745)] = 498381,
  [SMALL_STATE(14746)] = 498400,
  [SMALL_STATE(14747)] = 498419,
  [SMALL_STATE(14748)] = 498438,
  [SMALL_STATE(14749)] = 498455,
  [SMALL_STATE(14750)] = 498474,
  [SMALL_STATE(14751)] = 498491,
  [SMALL_STATE(14752)] = 498508,
  [SMALL_STATE(14753)] = 498521,
  [SMALL_STATE(14754)] = 498538,
  [SMALL_STATE(14755)] = 498551,
  [SMALL_STATE(14756)] = 498564,
  [SMALL_STATE(14757)] = 498577,
  [SMALL_STATE(14758)] = 498594,
  [SMALL_STATE(14759)] = 498611,
  [SMALL_STATE(14760)] = 498624,
  [SMALL_STATE(14761)] = 498637,
  [SMALL_STATE(14762)] = 498656,
  [SMALL_STATE(14763)] = 498673,
  [SMALL_STATE(14764)] = 498690,
  [SMALL_STATE(14765)] = 498703,
  [SMALL_STATE(14766)] = 498722,
  [SMALL_STATE(14767)] = 498735,
  [SMALL_STATE(14768)] = 498752,
  [SMALL_STATE(14769)] = 498769,
  [SMALL_STATE(14770)] = 498784,
  [SMALL_STATE(14771)] = 498797,
  [SMALL_STATE(14772)] = 498814,
  [SMALL_STATE(14773)] = 498831,
  [SMALL_STATE(14774)] = 498844,
  [SMALL_STATE(14775)] = 498861,
  [SMALL_STATE(14776)] = 498876,
  [SMALL_STATE(14777)] = 498895,
  [SMALL_STATE(14778)] = 498912,
  [SMALL_STATE(14779)] = 498931,
  [SMALL_STATE(14780)] = 498944,
  [SMALL_STATE(14781)] = 498961,
  [SMALL_STATE(14782)] = 498978,
  [SMALL_STATE(14783)] = 498997,
  [SMALL_STATE(14784)] = 499010,
  [SMALL_STATE(14785)] = 499029,
  [SMALL_STATE(14786)] = 499046,
  [SMALL_STATE(14787)] = 499063,
  [SMALL_STATE(14788)] = 499082,
  [SMALL_STATE(14789)] = 499099,
  [SMALL_STATE(14790)] = 499116,
  [SMALL_STATE(14791)] = 499133,
  [SMALL_STATE(14792)] = 499150,
  [SMALL_STATE(14793)] = 499167,
  [SMALL_STATE(14794)] = 499184,
  [SMALL_STATE(14795)] = 499201,
  [SMALL_STATE(14796)] = 499220,
  [SMALL_STATE(14797)] = 499237,
  [SMALL_STATE(14798)] = 499254,
  [SMALL_STATE(14799)] = 499271,
  [SMALL_STATE(14800)] = 499288,
  [SMALL_STATE(14801)] = 499305,
  [SMALL_STATE(14802)] = 499322,
  [SMALL_STATE(14803)] = 499339,
  [SMALL_STATE(14804)] = 499358,
  [SMALL_STATE(14805)] = 499377,
  [SMALL_STATE(14806)] = 499390,
  [SMALL_STATE(14807)] = 499407,
  [SMALL_STATE(14808)] = 499422,
  [SMALL_STATE(14809)] = 499439,
  [SMALL_STATE(14810)] = 499454,
  [SMALL_STATE(14811)] = 499471,
  [SMALL_STATE(14812)] = 499488,
  [SMALL_STATE(14813)] = 499505,
  [SMALL_STATE(14814)] = 499520,
  [SMALL_STATE(14815)] = 499535,
  [SMALL_STATE(14816)] = 499552,
  [SMALL_STATE(14817)] = 499571,
  [SMALL_STATE(14818)] = 499590,
  [SMALL_STATE(14819)] = 499603,
  [SMALL_STATE(14820)] = 499616,
  [SMALL_STATE(14821)] = 499635,
  [SMALL_STATE(14822)] = 499654,
  [SMALL_STATE(14823)] = 499673,
  [SMALL_STATE(14824)] = 499690,
  [SMALL_STATE(14825)] = 499707,
  [SMALL_STATE(14826)] = 499720,
  [SMALL_STATE(14827)] = 499739,
  [SMALL_STATE(14828)] = 499752,
  [SMALL_STATE(14829)] = 499771,
  [SMALL_STATE(14830)] = 499790,
  [SMALL_STATE(14831)] = 499807,
  [SMALL_STATE(14832)] = 499824,
  [SMALL_STATE(14833)] = 499841,
  [SMALL_STATE(14834)] = 499858,
  [SMALL_STATE(14835)] = 499877,
  [SMALL_STATE(14836)] = 499890,
  [SMALL_STATE(14837)] = 499909,
  [SMALL_STATE(14838)] = 499926,
  [SMALL_STATE(14839)] = 499945,
  [SMALL_STATE(14840)] = 499962,
  [SMALL_STATE(14841)] = 499979,
  [SMALL_STATE(14842)] = 499996,
  [SMALL_STATE(14843)] = 500015,
  [SMALL_STATE(14844)] = 500032,
  [SMALL_STATE(14845)] = 500049,
  [SMALL_STATE(14846)] = 500066,
  [SMALL_STATE(14847)] = 500083,
  [SMALL_STATE(14848)] = 500100,
  [SMALL_STATE(14849)] = 500113,
  [SMALL_STATE(14850)] = 500130,
  [SMALL_STATE(14851)] = 500147,
  [SMALL_STATE(14852)] = 500164,
  [SMALL_STATE(14853)] = 500183,
  [SMALL_STATE(14854)] = 500202,
  [SMALL_STATE(14855)] = 500221,
  [SMALL_STATE(14856)] = 500240,
  [SMALL_STATE(14857)] = 500253,
  [SMALL_STATE(14858)] = 500272,
  [SMALL_STATE(14859)] = 500289,
  [SMALL_STATE(14860)] = 500306,
  [SMALL_STATE(14861)] = 500323,
  [SMALL_STATE(14862)] = 500336,
  [SMALL_STATE(14863)] = 500355,
  [SMALL_STATE(14864)] = 500368,
  [SMALL_STATE(14865)] = 500385,
  [SMALL_STATE(14866)] = 500404,
  [SMALL_STATE(14867)] = 500421,
  [SMALL_STATE(14868)] = 500434,
  [SMALL_STATE(14869)] = 500453,
  [SMALL_STATE(14870)] = 500466,
  [SMALL_STATE(14871)] = 500479,
  [SMALL_STATE(14872)] = 500496,
  [SMALL_STATE(14873)] = 500513,
  [SMALL_STATE(14874)] = 500532,
  [SMALL_STATE(14875)] = 500551,
  [SMALL_STATE(14876)] = 500564,
  [SMALL_STATE(14877)] = 500579,
  [SMALL_STATE(14878)] = 500598,
  [SMALL_STATE(14879)] = 500617,
  [SMALL_STATE(14880)] = 500630,
  [SMALL_STATE(14881)] = 500647,
  [SMALL_STATE(14882)] = 500660,
  [SMALL_STATE(14883)] = 500673,
  [SMALL_STATE(14884)] = 500690,
  [SMALL_STATE(14885)] = 500707,
  [SMALL_STATE(14886)] = 500726,
  [SMALL_STATE(14887)] = 500745,
  [SMALL_STATE(14888)] = 500762,
  [SMALL_STATE(14889)] = 500775,
  [SMALL_STATE(14890)] = 500792,
  [SMALL_STATE(14891)] = 500809,
  [SMALL_STATE(14892)] = 500822,
  [SMALL_STATE(14893)] = 500839,
  [SMALL_STATE(14894)] = 500856,
  [SMALL_STATE(14895)] = 500873,
  [SMALL_STATE(14896)] = 500886,
  [SMALL_STATE(14897)] = 500903,
  [SMALL_STATE(14898)] = 500920,
  [SMALL_STATE(14899)] = 500933,
  [SMALL_STATE(14900)] = 500950,
  [SMALL_STATE(14901)] = 500963,
  [SMALL_STATE(14902)] = 500980,
  [SMALL_STATE(14903)] = 500997,
  [SMALL_STATE(14904)] = 501014,
  [SMALL_STATE(14905)] = 501027,
  [SMALL_STATE(14906)] = 501044,
  [SMALL_STATE(14907)] = 501061,
  [SMALL_STATE(14908)] = 501078,
  [SMALL_STATE(14909)] = 501095,
  [SMALL_STATE(14910)] = 501108,
  [SMALL_STATE(14911)] = 501125,
  [SMALL_STATE(14912)] = 501144,
  [SMALL_STATE(14913)] = 501161,
  [SMALL_STATE(14914)] = 501180,
  [SMALL_STATE(14915)] = 501197,
  [SMALL_STATE(14916)] = 501216,
  [SMALL_STATE(14917)] = 501233,
  [SMALL_STATE(14918)] = 501246,
  [SMALL_STATE(14919)] = 501259,
  [SMALL_STATE(14920)] = 501274,
  [SMALL_STATE(14921)] = 501291,
  [SMALL_STATE(14922)] = 501308,
  [SMALL_STATE(14923)] = 501325,
  [SMALL_STATE(14924)] = 501342,
  [SMALL_STATE(14925)] = 501359,
  [SMALL_STATE(14926)] = 501378,
  [SMALL_STATE(14927)] = 501395,
  [SMALL_STATE(14928)] = 501408,
  [SMALL_STATE(14929)] = 501425,
  [SMALL_STATE(14930)] = 501442,
  [SMALL_STATE(14931)] = 501455,
  [SMALL_STATE(14932)] = 501470,
  [SMALL_STATE(14933)] = 501489,
  [SMALL_STATE(14934)] = 501502,
  [SMALL_STATE(14935)] = 501515,
  [SMALL_STATE(14936)] = 501528,
  [SMALL_STATE(14937)] = 501545,
  [SMALL_STATE(14938)] = 501562,
  [SMALL_STATE(14939)] = 501575,
  [SMALL_STATE(14940)] = 501592,
  [SMALL_STATE(14941)] = 501605,
  [SMALL_STATE(14942)] = 501622,
  [SMALL_STATE(14943)] = 501639,
  [SMALL_STATE(14944)] = 501658,
  [SMALL_STATE(14945)] = 501675,
  [SMALL_STATE(14946)] = 501688,
  [SMALL_STATE(14947)] = 501701,
  [SMALL_STATE(14948)] = 501714,
  [SMALL_STATE(14949)] = 501727,
  [SMALL_STATE(14950)] = 501744,
  [SMALL_STATE(14951)] = 501757,
  [SMALL_STATE(14952)] = 501770,
  [SMALL_STATE(14953)] = 501783,
  [SMALL_STATE(14954)] = 501800,
  [SMALL_STATE(14955)] = 501819,
  [SMALL_STATE(14956)] = 501836,
  [SMALL_STATE(14957)] = 501849,
  [SMALL_STATE(14958)] = 501866,
  [SMALL_STATE(14959)] = 501879,
  [SMALL_STATE(14960)] = 501896,
  [SMALL_STATE(14961)] = 501913,
  [SMALL_STATE(14962)] = 501926,
  [SMALL_STATE(14963)] = 501943,
  [SMALL_STATE(14964)] = 501960,
  [SMALL_STATE(14965)] = 501977,
  [SMALL_STATE(14966)] = 501990,
  [SMALL_STATE(14967)] = 502009,
  [SMALL_STATE(14968)] = 502026,
  [SMALL_STATE(14969)] = 502045,
  [SMALL_STATE(14970)] = 502062,
  [SMALL_STATE(14971)] = 502075,
  [SMALL_STATE(14972)] = 502092,
  [SMALL_STATE(14973)] = 502105,
  [SMALL_STATE(14974)] = 502118,
  [SMALL_STATE(14975)] = 502131,
  [SMALL_STATE(14976)] = 502144,
  [SMALL_STATE(14977)] = 502157,
  [SMALL_STATE(14978)] = 502176,
  [SMALL_STATE(14979)] = 502193,
  [SMALL_STATE(14980)] = 502206,
  [SMALL_STATE(14981)] = 502223,
  [SMALL_STATE(14982)] = 502240,
  [SMALL_STATE(14983)] = 502257,
  [SMALL_STATE(14984)] = 502276,
  [SMALL_STATE(14985)] = 502293,
  [SMALL_STATE(14986)] = 502312,
  [SMALL_STATE(14987)] = 502329,
  [SMALL_STATE(14988)] = 502346,
  [SMALL_STATE(14989)] = 502363,
  [SMALL_STATE(14990)] = 502376,
  [SMALL_STATE(14991)] = 502389,
  [SMALL_STATE(14992)] = 502402,
  [SMALL_STATE(14993)] = 502415,
  [SMALL_STATE(14994)] = 502432,
  [SMALL_STATE(14995)] = 502449,
  [SMALL_STATE(14996)] = 502466,
  [SMALL_STATE(14997)] = 502485,
  [SMALL_STATE(14998)] = 502498,
  [SMALL_STATE(14999)] = 502515,
  [SMALL_STATE(15000)] = 502532,
  [SMALL_STATE(15001)] = 502545,
  [SMALL_STATE(15002)] = 502564,
  [SMALL_STATE(15003)] = 502577,
  [SMALL_STATE(15004)] = 502590,
  [SMALL_STATE(15005)] = 502609,
  [SMALL_STATE(15006)] = 502626,
  [SMALL_STATE(15007)] = 502643,
  [SMALL_STATE(15008)] = 502662,
  [SMALL_STATE(15009)] = 502679,
  [SMALL_STATE(15010)] = 502698,
  [SMALL_STATE(15011)] = 502715,
  [SMALL_STATE(15012)] = 502734,
  [SMALL_STATE(15013)] = 502751,
  [SMALL_STATE(15014)] = 502764,
  [SMALL_STATE(15015)] = 502783,
  [SMALL_STATE(15016)] = 502802,
  [SMALL_STATE(15017)] = 502819,
  [SMALL_STATE(15018)] = 502838,
  [SMALL_STATE(15019)] = 502855,
  [SMALL_STATE(15020)] = 502874,
  [SMALL_STATE(15021)] = 502891,
  [SMALL_STATE(15022)] = 502908,
  [SMALL_STATE(15023)] = 502925,
  [SMALL_STATE(15024)] = 502942,
  [SMALL_STATE(15025)] = 502959,
  [SMALL_STATE(15026)] = 502976,
  [SMALL_STATE(15027)] = 502993,
  [SMALL_STATE(15028)] = 503010,
  [SMALL_STATE(15029)] = 503027,
  [SMALL_STATE(15030)] = 503042,
  [SMALL_STATE(15031)] = 503055,
  [SMALL_STATE(15032)] = 503072,
  [SMALL_STATE(15033)] = 503089,
  [SMALL_STATE(15034)] = 503106,
  [SMALL_STATE(15035)] = 503119,
  [SMALL_STATE(15036)] = 503136,
  [SMALL_STATE(15037)] = 503149,
  [SMALL_STATE(15038)] = 503166,
  [SMALL_STATE(15039)] = 503183,
  [SMALL_STATE(15040)] = 503200,
  [SMALL_STATE(15041)] = 503217,
  [SMALL_STATE(15042)] = 503234,
  [SMALL_STATE(15043)] = 503251,
  [SMALL_STATE(15044)] = 503268,
  [SMALL_STATE(15045)] = 503285,
  [SMALL_STATE(15046)] = 503302,
  [SMALL_STATE(15047)] = 503321,
  [SMALL_STATE(15048)] = 503334,
  [SMALL_STATE(15049)] = 503351,
  [SMALL_STATE(15050)] = 503364,
  [SMALL_STATE(15051)] = 503381,
  [SMALL_STATE(15052)] = 503398,
  [SMALL_STATE(15053)] = 503417,
  [SMALL_STATE(15054)] = 503434,
  [SMALL_STATE(15055)] = 503453,
  [SMALL_STATE(15056)] = 503466,
  [SMALL_STATE(15057)] = 503479,
  [SMALL_STATE(15058)] = 503492,
  [SMALL_STATE(15059)] = 503509,
  [SMALL_STATE(15060)] = 503526,
  [SMALL_STATE(15061)] = 503543,
  [SMALL_STATE(15062)] = 503556,
  [SMALL_STATE(15063)] = 503575,
  [SMALL_STATE(15064)] = 503588,
  [SMALL_STATE(15065)] = 503601,
  [SMALL_STATE(15066)] = 503618,
  [SMALL_STATE(15067)] = 503631,
  [SMALL_STATE(15068)] = 503644,
  [SMALL_STATE(15069)] = 503657,
  [SMALL_STATE(15070)] = 503674,
  [SMALL_STATE(15071)] = 503691,
  [SMALL_STATE(15072)] = 503710,
  [SMALL_STATE(15073)] = 503727,
  [SMALL_STATE(15074)] = 503744,
  [SMALL_STATE(15075)] = 503761,
  [SMALL_STATE(15076)] = 503780,
  [SMALL_STATE(15077)] = 503793,
  [SMALL_STATE(15078)] = 503810,
  [SMALL_STATE(15079)] = 503827,
  [SMALL_STATE(15080)] = 503842,
  [SMALL_STATE(15081)] = 503861,
  [SMALL_STATE(15082)] = 503880,
  [SMALL_STATE(15083)] = 503897,
  [SMALL_STATE(15084)] = 503916,
  [SMALL_STATE(15085)] = 503929,
  [SMALL_STATE(15086)] = 503946,
  [SMALL_STATE(15087)] = 503963,
  [SMALL_STATE(15088)] = 503976,
  [SMALL_STATE(15089)] = 503989,
  [SMALL_STATE(15090)] = 504002,
  [SMALL_STATE(15091)] = 504019,
  [SMALL_STATE(15092)] = 504036,
  [SMALL_STATE(15093)] = 504055,
  [SMALL_STATE(15094)] = 504074,
  [SMALL_STATE(15095)] = 504091,
  [SMALL_STATE(15096)] = 504108,
  [SMALL_STATE(15097)] = 504127,
  [SMALL_STATE(15098)] = 504144,
  [SMALL_STATE(15099)] = 504161,
  [SMALL_STATE(15100)] = 504180,
  [SMALL_STATE(15101)] = 504199,
  [SMALL_STATE(15102)] = 504216,
  [SMALL_STATE(15103)] = 504229,
  [SMALL_STATE(15104)] = 504248,
  [SMALL_STATE(15105)] = 504265,
  [SMALL_STATE(15106)] = 504282,
  [SMALL_STATE(15107)] = 504295,
  [SMALL_STATE(15108)] = 504314,
  [SMALL_STATE(15109)] = 504333,
  [SMALL_STATE(15110)] = 504352,
  [SMALL_STATE(15111)] = 504369,
  [SMALL_STATE(15112)] = 504382,
  [SMALL_STATE(15113)] = 504401,
  [SMALL_STATE(15114)] = 504416,
  [SMALL_STATE(15115)] = 504433,
  [SMALL_STATE(15116)] = 504452,
  [SMALL_STATE(15117)] = 504471,
  [SMALL_STATE(15118)] = 504484,
  [SMALL_STATE(15119)] = 504501,
  [SMALL_STATE(15120)] = 504514,
  [SMALL_STATE(15121)] = 504533,
  [SMALL_STATE(15122)] = 504550,
  [SMALL_STATE(15123)] = 504567,
  [SMALL_STATE(15124)] = 504584,
  [SMALL_STATE(15125)] = 504603,
  [SMALL_STATE(15126)] = 504620,
  [SMALL_STATE(15127)] = 504633,
  [SMALL_STATE(15128)] = 504650,
  [SMALL_STATE(15129)] = 504663,
  [SMALL_STATE(15130)] = 504682,
  [SMALL_STATE(15131)] = 504699,
  [SMALL_STATE(15132)] = 504718,
  [SMALL_STATE(15133)] = 504735,
  [SMALL_STATE(15134)] = 504748,
  [SMALL_STATE(15135)] = 504767,
  [SMALL_STATE(15136)] = 504780,
  [SMALL_STATE(15137)] = 504793,
  [SMALL_STATE(15138)] = 504810,
  [SMALL_STATE(15139)] = 504823,
  [SMALL_STATE(15140)] = 504842,
  [SMALL_STATE(15141)] = 504855,
  [SMALL_STATE(15142)] = 504872,
  [SMALL_STATE(15143)] = 504891,
  [SMALL_STATE(15144)] = 504908,
  [SMALL_STATE(15145)] = 504927,
  [SMALL_STATE(15146)] = 504940,
  [SMALL_STATE(15147)] = 504957,
  [SMALL_STATE(15148)] = 504974,
  [SMALL_STATE(15149)] = 504991,
  [SMALL_STATE(15150)] = 505008,
  [SMALL_STATE(15151)] = 505027,
  [SMALL_STATE(15152)] = 505044,
  [SMALL_STATE(15153)] = 505061,
  [SMALL_STATE(15154)] = 505078,
  [SMALL_STATE(15155)] = 505097,
  [SMALL_STATE(15156)] = 505110,
  [SMALL_STATE(15157)] = 505129,
  [SMALL_STATE(15158)] = 505144,
  [SMALL_STATE(15159)] = 505161,
  [SMALL_STATE(15160)] = 505178,
  [SMALL_STATE(15161)] = 505191,
  [SMALL_STATE(15162)] = 505210,
  [SMALL_STATE(15163)] = 505229,
  [SMALL_STATE(15164)] = 505246,
  [SMALL_STATE(15165)] = 505259,
  [SMALL_STATE(15166)] = 505276,
  [SMALL_STATE(15167)] = 505293,
  [SMALL_STATE(15168)] = 505306,
  [SMALL_STATE(15169)] = 505323,
  [SMALL_STATE(15170)] = 505342,
  [SMALL_STATE(15171)] = 505355,
  [SMALL_STATE(15172)] = 505368,
  [SMALL_STATE(15173)] = 505381,
  [SMALL_STATE(15174)] = 505398,
  [SMALL_STATE(15175)] = 505415,
  [SMALL_STATE(15176)] = 505428,
  [SMALL_STATE(15177)] = 505441,
  [SMALL_STATE(15178)] = 505458,
  [SMALL_STATE(15179)] = 505471,
  [SMALL_STATE(15180)] = 505488,
  [SMALL_STATE(15181)] = 505501,
  [SMALL_STATE(15182)] = 505518,
  [SMALL_STATE(15183)] = 505531,
  [SMALL_STATE(15184)] = 505544,
  [SMALL_STATE(15185)] = 505561,
  [SMALL_STATE(15186)] = 505578,
  [SMALL_STATE(15187)] = 505593,
  [SMALL_STATE(15188)] = 505610,
  [SMALL_STATE(15189)] = 505627,
  [SMALL_STATE(15190)] = 505644,
  [SMALL_STATE(15191)] = 505661,
  [SMALL_STATE(15192)] = 505678,
  [SMALL_STATE(15193)] = 505695,
  [SMALL_STATE(15194)] = 505708,
  [SMALL_STATE(15195)] = 505725,
  [SMALL_STATE(15196)] = 505744,
  [SMALL_STATE(15197)] = 505763,
  [SMALL_STATE(15198)] = 505776,
  [SMALL_STATE(15199)] = 505795,
  [SMALL_STATE(15200)] = 505812,
  [SMALL_STATE(15201)] = 505829,
  [SMALL_STATE(15202)] = 505846,
  [SMALL_STATE(15203)] = 505863,
  [SMALL_STATE(15204)] = 505880,
  [SMALL_STATE(15205)] = 505893,
  [SMALL_STATE(15206)] = 505906,
  [SMALL_STATE(15207)] = 505923,
  [SMALL_STATE(15208)] = 505942,
  [SMALL_STATE(15209)] = 505955,
  [SMALL_STATE(15210)] = 505968,
  [SMALL_STATE(15211)] = 505985,
  [SMALL_STATE(15212)] = 506004,
  [SMALL_STATE(15213)] = 506021,
  [SMALL_STATE(15214)] = 506038,
  [SMALL_STATE(15215)] = 506057,
  [SMALL_STATE(15216)] = 506074,
  [SMALL_STATE(15217)] = 506091,
  [SMALL_STATE(15218)] = 506104,
  [SMALL_STATE(15219)] = 506121,
  [SMALL_STATE(15220)] = 506138,
  [SMALL_STATE(15221)] = 506151,
  [SMALL_STATE(15222)] = 506164,
  [SMALL_STATE(15223)] = 506177,
  [SMALL_STATE(15224)] = 506190,
  [SMALL_STATE(15225)] = 506207,
  [SMALL_STATE(15226)] = 506220,
  [SMALL_STATE(15227)] = 506233,
  [SMALL_STATE(15228)] = 506246,
  [SMALL_STATE(15229)] = 506259,
  [SMALL_STATE(15230)] = 506276,
  [SMALL_STATE(15231)] = 506295,
  [SMALL_STATE(15232)] = 506312,
  [SMALL_STATE(15233)] = 506329,
  [SMALL_STATE(15234)] = 506346,
  [SMALL_STATE(15235)] = 506359,
  [SMALL_STATE(15236)] = 506372,
  [SMALL_STATE(15237)] = 506389,
  [SMALL_STATE(15238)] = 506406,
  [SMALL_STATE(15239)] = 506423,
  [SMALL_STATE(15240)] = 506440,
  [SMALL_STATE(15241)] = 506459,
  [SMALL_STATE(15242)] = 506472,
  [SMALL_STATE(15243)] = 506489,
  [SMALL_STATE(15244)] = 506506,
  [SMALL_STATE(15245)] = 506519,
  [SMALL_STATE(15246)] = 506536,
  [SMALL_STATE(15247)] = 506549,
  [SMALL_STATE(15248)] = 506562,
  [SMALL_STATE(15249)] = 506579,
  [SMALL_STATE(15250)] = 506596,
  [SMALL_STATE(15251)] = 506613,
  [SMALL_STATE(15252)] = 506632,
  [SMALL_STATE(15253)] = 506645,
  [SMALL_STATE(15254)] = 506662,
  [SMALL_STATE(15255)] = 506679,
  [SMALL_STATE(15256)] = 506692,
  [SMALL_STATE(15257)] = 506709,
  [SMALL_STATE(15258)] = 506722,
  [SMALL_STATE(15259)] = 506735,
  [SMALL_STATE(15260)] = 506752,
  [SMALL_STATE(15261)] = 506765,
  [SMALL_STATE(15262)] = 506784,
  [SMALL_STATE(15263)] = 506801,
  [SMALL_STATE(15264)] = 506820,
  [SMALL_STATE(15265)] = 506833,
  [SMALL_STATE(15266)] = 506850,
  [SMALL_STATE(15267)] = 506869,
  [SMALL_STATE(15268)] = 506888,
  [SMALL_STATE(15269)] = 506907,
  [SMALL_STATE(15270)] = 506926,
  [SMALL_STATE(15271)] = 506943,
  [SMALL_STATE(15272)] = 506960,
  [SMALL_STATE(15273)] = 506977,
  [SMALL_STATE(15274)] = 506996,
  [SMALL_STATE(15275)] = 507009,
  [SMALL_STATE(15276)] = 507026,
  [SMALL_STATE(15277)] = 507043,
  [SMALL_STATE(15278)] = 507062,
  [SMALL_STATE(15279)] = 507081,
  [SMALL_STATE(15280)] = 507098,
  [SMALL_STATE(15281)] = 507115,
  [SMALL_STATE(15282)] = 507132,
  [SMALL_STATE(15283)] = 507151,
  [SMALL_STATE(15284)] = 507170,
  [SMALL_STATE(15285)] = 507187,
  [SMALL_STATE(15286)] = 507204,
  [SMALL_STATE(15287)] = 507221,
  [SMALL_STATE(15288)] = 507238,
  [SMALL_STATE(15289)] = 507255,
  [SMALL_STATE(15290)] = 507274,
  [SMALL_STATE(15291)] = 507287,
  [SMALL_STATE(15292)] = 507304,
  [SMALL_STATE(15293)] = 507317,
  [SMALL_STATE(15294)] = 507336,
  [SMALL_STATE(15295)] = 507349,
  [SMALL_STATE(15296)] = 507368,
  [SMALL_STATE(15297)] = 507387,
  [SMALL_STATE(15298)] = 507404,
  [SMALL_STATE(15299)] = 507423,
  [SMALL_STATE(15300)] = 507440,
  [SMALL_STATE(15301)] = 507457,
  [SMALL_STATE(15302)] = 507472,
  [SMALL_STATE(15303)] = 507489,
  [SMALL_STATE(15304)] = 507506,
  [SMALL_STATE(15305)] = 507525,
  [SMALL_STATE(15306)] = 507542,
  [SMALL_STATE(15307)] = 507555,
  [SMALL_STATE(15308)] = 507568,
  [SMALL_STATE(15309)] = 507581,
  [SMALL_STATE(15310)] = 507600,
  [SMALL_STATE(15311)] = 507617,
  [SMALL_STATE(15312)] = 507634,
  [SMALL_STATE(15313)] = 507651,
  [SMALL_STATE(15314)] = 507668,
  [SMALL_STATE(15315)] = 507685,
  [SMALL_STATE(15316)] = 507704,
  [SMALL_STATE(15317)] = 507723,
  [SMALL_STATE(15318)] = 507740,
  [SMALL_STATE(15319)] = 507757,
  [SMALL_STATE(15320)] = 507774,
  [SMALL_STATE(15321)] = 507793,
  [SMALL_STATE(15322)] = 507812,
  [SMALL_STATE(15323)] = 507829,
  [SMALL_STATE(15324)] = 507842,
  [SMALL_STATE(15325)] = 507859,
  [SMALL_STATE(15326)] = 507876,
  [SMALL_STATE(15327)] = 507895,
  [SMALL_STATE(15328)] = 507908,
  [SMALL_STATE(15329)] = 507925,
  [SMALL_STATE(15330)] = 507942,
  [SMALL_STATE(15331)] = 507957,
  [SMALL_STATE(15332)] = 507974,
  [SMALL_STATE(15333)] = 507987,
  [SMALL_STATE(15334)] = 508004,
  [SMALL_STATE(15335)] = 508023,
  [SMALL_STATE(15336)] = 508042,
  [SMALL_STATE(15337)] = 508059,
  [SMALL_STATE(15338)] = 508072,
  [SMALL_STATE(15339)] = 508089,
  [SMALL_STATE(15340)] = 508108,
  [SMALL_STATE(15341)] = 508127,
  [SMALL_STATE(15342)] = 508140,
  [SMALL_STATE(15343)] = 508159,
  [SMALL_STATE(15344)] = 508172,
  [SMALL_STATE(15345)] = 508189,
  [SMALL_STATE(15346)] = 508202,
  [SMALL_STATE(15347)] = 508219,
  [SMALL_STATE(15348)] = 508238,
  [SMALL_STATE(15349)] = 508255,
  [SMALL_STATE(15350)] = 508274,
  [SMALL_STATE(15351)] = 508291,
  [SMALL_STATE(15352)] = 508308,
  [SMALL_STATE(15353)] = 508325,
  [SMALL_STATE(15354)] = 508344,
  [SMALL_STATE(15355)] = 508361,
  [SMALL_STATE(15356)] = 508378,
  [SMALL_STATE(15357)] = 508395,
  [SMALL_STATE(15358)] = 508412,
  [SMALL_STATE(15359)] = 508429,
  [SMALL_STATE(15360)] = 508446,
  [SMALL_STATE(15361)] = 508463,
  [SMALL_STATE(15362)] = 508480,
  [SMALL_STATE(15363)] = 508497,
  [SMALL_STATE(15364)] = 508516,
  [SMALL_STATE(15365)] = 508535,
  [SMALL_STATE(15366)] = 508548,
  [SMALL_STATE(15367)] = 508565,
  [SMALL_STATE(15368)] = 508582,
  [SMALL_STATE(15369)] = 508595,
  [SMALL_STATE(15370)] = 508612,
  [SMALL_STATE(15371)] = 508629,
  [SMALL_STATE(15372)] = 508646,
  [SMALL_STATE(15373)] = 508665,
  [SMALL_STATE(15374)] = 508684,
  [SMALL_STATE(15375)] = 508699,
  [SMALL_STATE(15376)] = 508714,
  [SMALL_STATE(15377)] = 508733,
  [SMALL_STATE(15378)] = 508750,
  [SMALL_STATE(15379)] = 508765,
  [SMALL_STATE(15380)] = 508782,
  [SMALL_STATE(15381)] = 508799,
  [SMALL_STATE(15382)] = 508816,
  [SMALL_STATE(15383)] = 508833,
  [SMALL_STATE(15384)] = 508846,
  [SMALL_STATE(15385)] = 508863,
  [SMALL_STATE(15386)] = 508880,
  [SMALL_STATE(15387)] = 508899,
  [SMALL_STATE(15388)] = 508916,
  [SMALL_STATE(15389)] = 508935,
  [SMALL_STATE(15390)] = 508952,
  [SMALL_STATE(15391)] = 508969,
  [SMALL_STATE(15392)] = 508982,
  [SMALL_STATE(15393)] = 508999,
  [SMALL_STATE(15394)] = 509016,
  [SMALL_STATE(15395)] = 509033,
  [SMALL_STATE(15396)] = 509050,
  [SMALL_STATE(15397)] = 509063,
  [SMALL_STATE(15398)] = 509082,
  [SMALL_STATE(15399)] = 509095,
  [SMALL_STATE(15400)] = 509112,
  [SMALL_STATE(15401)] = 509125,
  [SMALL_STATE(15402)] = 509138,
  [SMALL_STATE(15403)] = 509151,
  [SMALL_STATE(15404)] = 509168,
  [SMALL_STATE(15405)] = 509181,
  [SMALL_STATE(15406)] = 509200,
  [SMALL_STATE(15407)] = 509213,
  [SMALL_STATE(15408)] = 509230,
  [SMALL_STATE(15409)] = 509249,
  [SMALL_STATE(15410)] = 509262,
  [SMALL_STATE(15411)] = 509279,
  [SMALL_STATE(15412)] = 509296,
  [SMALL_STATE(15413)] = 509309,
  [SMALL_STATE(15414)] = 509326,
  [SMALL_STATE(15415)] = 509343,
  [SMALL_STATE(15416)] = 509356,
  [SMALL_STATE(15417)] = 509373,
  [SMALL_STATE(15418)] = 509392,
  [SMALL_STATE(15419)] = 509405,
  [SMALL_STATE(15420)] = 509422,
  [SMALL_STATE(15421)] = 509435,
  [SMALL_STATE(15422)] = 509454,
  [SMALL_STATE(15423)] = 509473,
  [SMALL_STATE(15424)] = 509486,
  [SMALL_STATE(15425)] = 509499,
  [SMALL_STATE(15426)] = 509518,
  [SMALL_STATE(15427)] = 509531,
  [SMALL_STATE(15428)] = 509544,
  [SMALL_STATE(15429)] = 509561,
  [SMALL_STATE(15430)] = 509575,
  [SMALL_STATE(15431)] = 509591,
  [SMALL_STATE(15432)] = 509603,
  [SMALL_STATE(15433)] = 509619,
  [SMALL_STATE(15434)] = 509633,
  [SMALL_STATE(15435)] = 509649,
  [SMALL_STATE(15436)] = 509665,
  [SMALL_STATE(15437)] = 509681,
  [SMALL_STATE(15438)] = 509697,
  [SMALL_STATE(15439)] = 509711,
  [SMALL_STATE(15440)] = 509727,
  [SMALL_STATE(15441)] = 509741,
  [SMALL_STATE(15442)] = 509755,
  [SMALL_STATE(15443)] = 509769,
  [SMALL_STATE(15444)] = 509783,
  [SMALL_STATE(15445)] = 509797,
  [SMALL_STATE(15446)] = 509811,
  [SMALL_STATE(15447)] = 509825,
  [SMALL_STATE(15448)] = 509839,
  [SMALL_STATE(15449)] = 509855,
  [SMALL_STATE(15450)] = 509871,
  [SMALL_STATE(15451)] = 509885,
  [SMALL_STATE(15452)] = 509899,
  [SMALL_STATE(15453)] = 509911,
  [SMALL_STATE(15454)] = 509925,
  [SMALL_STATE(15455)] = 509941,
  [SMALL_STATE(15456)] = 509957,
  [SMALL_STATE(15457)] = 509971,
  [SMALL_STATE(15458)] = 509987,
  [SMALL_STATE(15459)] = 510001,
  [SMALL_STATE(15460)] = 510017,
  [SMALL_STATE(15461)] = 510031,
  [SMALL_STATE(15462)] = 510047,
  [SMALL_STATE(15463)] = 510063,
  [SMALL_STATE(15464)] = 510079,
  [SMALL_STATE(15465)] = 510093,
  [SMALL_STATE(15466)] = 510109,
  [SMALL_STATE(15467)] = 510125,
  [SMALL_STATE(15468)] = 510141,
  [SMALL_STATE(15469)] = 510157,
  [SMALL_STATE(15470)] = 510171,
  [SMALL_STATE(15471)] = 510187,
  [SMALL_STATE(15472)] = 510203,
  [SMALL_STATE(15473)] = 510219,
  [SMALL_STATE(15474)] = 510235,
  [SMALL_STATE(15475)] = 510251,
  [SMALL_STATE(15476)] = 510265,
  [SMALL_STATE(15477)] = 510281,
  [SMALL_STATE(15478)] = 510297,
  [SMALL_STATE(15479)] = 510313,
  [SMALL_STATE(15480)] = 510327,
  [SMALL_STATE(15481)] = 510343,
  [SMALL_STATE(15482)] = 510359,
  [SMALL_STATE(15483)] = 510375,
  [SMALL_STATE(15484)] = 510391,
  [SMALL_STATE(15485)] = 510407,
  [SMALL_STATE(15486)] = 510423,
  [SMALL_STATE(15487)] = 510439,
  [SMALL_STATE(15488)] = 510455,
  [SMALL_STATE(15489)] = 510471,
  [SMALL_STATE(15490)] = 510485,
  [SMALL_STATE(15491)] = 510501,
  [SMALL_STATE(15492)] = 510517,
  [SMALL_STATE(15493)] = 510533,
  [SMALL_STATE(15494)] = 510549,
  [SMALL_STATE(15495)] = 510565,
  [SMALL_STATE(15496)] = 510581,
  [SMALL_STATE(15497)] = 510593,
  [SMALL_STATE(15498)] = 510609,
  [SMALL_STATE(15499)] = 510625,
  [SMALL_STATE(15500)] = 510641,
  [SMALL_STATE(15501)] = 510657,
  [SMALL_STATE(15502)] = 510669,
  [SMALL_STATE(15503)] = 510685,
  [SMALL_STATE(15504)] = 510701,
  [SMALL_STATE(15505)] = 510717,
  [SMALL_STATE(15506)] = 510733,
  [SMALL_STATE(15507)] = 510749,
  [SMALL_STATE(15508)] = 510765,
  [SMALL_STATE(15509)] = 510781,
  [SMALL_STATE(15510)] = 510797,
  [SMALL_STATE(15511)] = 510813,
  [SMALL_STATE(15512)] = 510829,
  [SMALL_STATE(15513)] = 510845,
  [SMALL_STATE(15514)] = 510861,
  [SMALL_STATE(15515)] = 510877,
  [SMALL_STATE(15516)] = 510893,
  [SMALL_STATE(15517)] = 510909,
  [SMALL_STATE(15518)] = 510925,
  [SMALL_STATE(15519)] = 510941,
  [SMALL_STATE(15520)] = 510957,
  [SMALL_STATE(15521)] = 510973,
  [SMALL_STATE(15522)] = 510989,
  [SMALL_STATE(15523)] = 511005,
  [SMALL_STATE(15524)] = 511021,
  [SMALL_STATE(15525)] = 511037,
  [SMALL_STATE(15526)] = 511053,
  [SMALL_STATE(15527)] = 511067,
  [SMALL_STATE(15528)] = 511083,
  [SMALL_STATE(15529)] = 511097,
  [SMALL_STATE(15530)] = 511109,
  [SMALL_STATE(15531)] = 511125,
  [SMALL_STATE(15532)] = 511141,
  [SMALL_STATE(15533)] = 511153,
  [SMALL_STATE(15534)] = 511169,
  [SMALL_STATE(15535)] = 511185,
  [SMALL_STATE(15536)] = 511201,
  [SMALL_STATE(15537)] = 511217,
  [SMALL_STATE(15538)] = 511233,
  [SMALL_STATE(15539)] = 511249,
  [SMALL_STATE(15540)] = 511265,
  [SMALL_STATE(15541)] = 511281,
  [SMALL_STATE(15542)] = 511297,
  [SMALL_STATE(15543)] = 511311,
  [SMALL_STATE(15544)] = 511327,
  [SMALL_STATE(15545)] = 511343,
  [SMALL_STATE(15546)] = 511359,
  [SMALL_STATE(15547)] = 511375,
  [SMALL_STATE(15548)] = 511389,
  [SMALL_STATE(15549)] = 511405,
  [SMALL_STATE(15550)] = 511421,
  [SMALL_STATE(15551)] = 511437,
  [SMALL_STATE(15552)] = 511453,
  [SMALL_STATE(15553)] = 511469,
  [SMALL_STATE(15554)] = 511485,
  [SMALL_STATE(15555)] = 511501,
  [SMALL_STATE(15556)] = 511515,
  [SMALL_STATE(15557)] = 511531,
  [SMALL_STATE(15558)] = 511547,
  [SMALL_STATE(15559)] = 511563,
  [SMALL_STATE(15560)] = 511575,
  [SMALL_STATE(15561)] = 511591,
  [SMALL_STATE(15562)] = 511603,
  [SMALL_STATE(15563)] = 511619,
  [SMALL_STATE(15564)] = 511635,
  [SMALL_STATE(15565)] = 511649,
  [SMALL_STATE(15566)] = 511665,
  [SMALL_STATE(15567)] = 511681,
  [SMALL_STATE(15568)] = 511693,
  [SMALL_STATE(15569)] = 511709,
  [SMALL_STATE(15570)] = 511725,
  [SMALL_STATE(15571)] = 511741,
  [SMALL_STATE(15572)] = 511757,
  [SMALL_STATE(15573)] = 511773,
  [SMALL_STATE(15574)] = 511789,
  [SMALL_STATE(15575)] = 511805,
  [SMALL_STATE(15576)] = 511821,
  [SMALL_STATE(15577)] = 511835,
  [SMALL_STATE(15578)] = 511851,
  [SMALL_STATE(15579)] = 511867,
  [SMALL_STATE(15580)] = 511883,
  [SMALL_STATE(15581)] = 511899,
  [SMALL_STATE(15582)] = 511915,
  [SMALL_STATE(15583)] = 511929,
  [SMALL_STATE(15584)] = 511945,
  [SMALL_STATE(15585)] = 511961,
  [SMALL_STATE(15586)] = 511973,
  [SMALL_STATE(15587)] = 511989,
  [SMALL_STATE(15588)] = 512005,
  [SMALL_STATE(15589)] = 512021,
  [SMALL_STATE(15590)] = 512037,
  [SMALL_STATE(15591)] = 512051,
  [SMALL_STATE(15592)] = 512067,
  [SMALL_STATE(15593)] = 512083,
  [SMALL_STATE(15594)] = 512099,
  [SMALL_STATE(15595)] = 512115,
  [SMALL_STATE(15596)] = 512131,
  [SMALL_STATE(15597)] = 512143,
  [SMALL_STATE(15598)] = 512159,
  [SMALL_STATE(15599)] = 512175,
  [SMALL_STATE(15600)] = 512189,
  [SMALL_STATE(15601)] = 512201,
  [SMALL_STATE(15602)] = 512215,
  [SMALL_STATE(15603)] = 512231,
  [SMALL_STATE(15604)] = 512247,
  [SMALL_STATE(15605)] = 512259,
  [SMALL_STATE(15606)] = 512275,
  [SMALL_STATE(15607)] = 512289,
  [SMALL_STATE(15608)] = 512305,
  [SMALL_STATE(15609)] = 512321,
  [SMALL_STATE(15610)] = 512335,
  [SMALL_STATE(15611)] = 512349,
  [SMALL_STATE(15612)] = 512365,
  [SMALL_STATE(15613)] = 512379,
  [SMALL_STATE(15614)] = 512393,
  [SMALL_STATE(15615)] = 512407,
  [SMALL_STATE(15616)] = 512423,
  [SMALL_STATE(15617)] = 512437,
  [SMALL_STATE(15618)] = 512453,
  [SMALL_STATE(15619)] = 512469,
  [SMALL_STATE(15620)] = 512485,
  [SMALL_STATE(15621)] = 512501,
  [SMALL_STATE(15622)] = 512517,
  [SMALL_STATE(15623)] = 512531,
  [SMALL_STATE(15624)] = 512545,
  [SMALL_STATE(15625)] = 512561,
  [SMALL_STATE(15626)] = 512575,
  [SMALL_STATE(15627)] = 512591,
  [SMALL_STATE(15628)] = 512607,
  [SMALL_STATE(15629)] = 512623,
  [SMALL_STATE(15630)] = 512639,
  [SMALL_STATE(15631)] = 512655,
  [SMALL_STATE(15632)] = 512669,
  [SMALL_STATE(15633)] = 512685,
  [SMALL_STATE(15634)] = 512701,
  [SMALL_STATE(15635)] = 512717,
  [SMALL_STATE(15636)] = 512731,
  [SMALL_STATE(15637)] = 512747,
  [SMALL_STATE(15638)] = 512763,
  [SMALL_STATE(15639)] = 512779,
  [SMALL_STATE(15640)] = 512795,
  [SMALL_STATE(15641)] = 512811,
  [SMALL_STATE(15642)] = 512827,
  [SMALL_STATE(15643)] = 512843,
  [SMALL_STATE(15644)] = 512859,
  [SMALL_STATE(15645)] = 512873,
  [SMALL_STATE(15646)] = 512889,
  [SMALL_STATE(15647)] = 512905,
  [SMALL_STATE(15648)] = 512921,
  [SMALL_STATE(15649)] = 512937,
  [SMALL_STATE(15650)] = 512953,
  [SMALL_STATE(15651)] = 512967,
  [SMALL_STATE(15652)] = 512983,
  [SMALL_STATE(15653)] = 512999,
  [SMALL_STATE(15654)] = 513015,
  [SMALL_STATE(15655)] = 513031,
  [SMALL_STATE(15656)] = 513043,
  [SMALL_STATE(15657)] = 513059,
  [SMALL_STATE(15658)] = 513075,
  [SMALL_STATE(15659)] = 513091,
  [SMALL_STATE(15660)] = 513107,
  [SMALL_STATE(15661)] = 513123,
  [SMALL_STATE(15662)] = 513139,
  [SMALL_STATE(15663)] = 513155,
  [SMALL_STATE(15664)] = 513171,
  [SMALL_STATE(15665)] = 513187,
  [SMALL_STATE(15666)] = 513203,
  [SMALL_STATE(15667)] = 513215,
  [SMALL_STATE(15668)] = 513231,
  [SMALL_STATE(15669)] = 513247,
  [SMALL_STATE(15670)] = 513263,
  [SMALL_STATE(15671)] = 513279,
  [SMALL_STATE(15672)] = 513293,
  [SMALL_STATE(15673)] = 513309,
  [SMALL_STATE(15674)] = 513325,
  [SMALL_STATE(15675)] = 513341,
  [SMALL_STATE(15676)] = 513357,
  [SMALL_STATE(15677)] = 513373,
  [SMALL_STATE(15678)] = 513389,
  [SMALL_STATE(15679)] = 513405,
  [SMALL_STATE(15680)] = 513421,
  [SMALL_STATE(15681)] = 513437,
  [SMALL_STATE(15682)] = 513453,
  [SMALL_STATE(15683)] = 513469,
  [SMALL_STATE(15684)] = 513485,
  [SMALL_STATE(15685)] = 513501,
  [SMALL_STATE(15686)] = 513517,
  [SMALL_STATE(15687)] = 513533,
  [SMALL_STATE(15688)] = 513549,
  [SMALL_STATE(15689)] = 513565,
  [SMALL_STATE(15690)] = 513581,
  [SMALL_STATE(15691)] = 513597,
  [SMALL_STATE(15692)] = 513613,
  [SMALL_STATE(15693)] = 513629,
  [SMALL_STATE(15694)] = 513645,
  [SMALL_STATE(15695)] = 513659,
  [SMALL_STATE(15696)] = 513675,
  [SMALL_STATE(15697)] = 513691,
  [SMALL_STATE(15698)] = 513707,
  [SMALL_STATE(15699)] = 513723,
  [SMALL_STATE(15700)] = 513739,
  [SMALL_STATE(15701)] = 513751,
  [SMALL_STATE(15702)] = 513767,
  [SMALL_STATE(15703)] = 513783,
  [SMALL_STATE(15704)] = 513797,
  [SMALL_STATE(15705)] = 513813,
  [SMALL_STATE(15706)] = 513829,
  [SMALL_STATE(15707)] = 513845,
  [SMALL_STATE(15708)] = 513861,
  [SMALL_STATE(15709)] = 513873,
  [SMALL_STATE(15710)] = 513889,
  [SMALL_STATE(15711)] = 513905,
  [SMALL_STATE(15712)] = 513921,
  [SMALL_STATE(15713)] = 513937,
  [SMALL_STATE(15714)] = 513953,
  [SMALL_STATE(15715)] = 513969,
  [SMALL_STATE(15716)] = 513985,
  [SMALL_STATE(15717)] = 513997,
  [SMALL_STATE(15718)] = 514013,
  [SMALL_STATE(15719)] = 514027,
  [SMALL_STATE(15720)] = 514041,
  [SMALL_STATE(15721)] = 514055,
  [SMALL_STATE(15722)] = 514067,
  [SMALL_STATE(15723)] = 514079,
  [SMALL_STATE(15724)] = 514095,
  [SMALL_STATE(15725)] = 514107,
  [SMALL_STATE(15726)] = 514119,
  [SMALL_STATE(15727)] = 514131,
  [SMALL_STATE(15728)] = 514147,
  [SMALL_STATE(15729)] = 514159,
  [SMALL_STATE(15730)] = 514175,
  [SMALL_STATE(15731)] = 514187,
  [SMALL_STATE(15732)] = 514203,
  [SMALL_STATE(15733)] = 514219,
  [SMALL_STATE(15734)] = 514235,
  [SMALL_STATE(15735)] = 514247,
  [SMALL_STATE(15736)] = 514263,
  [SMALL_STATE(15737)] = 514279,
  [SMALL_STATE(15738)] = 514295,
  [SMALL_STATE(15739)] = 514307,
  [SMALL_STATE(15740)] = 514319,
  [SMALL_STATE(15741)] = 514331,
  [SMALL_STATE(15742)] = 514347,
  [SMALL_STATE(15743)] = 514363,
  [SMALL_STATE(15744)] = 514379,
  [SMALL_STATE(15745)] = 514391,
  [SMALL_STATE(15746)] = 514405,
  [SMALL_STATE(15747)] = 514421,
  [SMALL_STATE(15748)] = 514437,
  [SMALL_STATE(15749)] = 514453,
  [SMALL_STATE(15750)] = 514465,
  [SMALL_STATE(15751)] = 514477,
  [SMALL_STATE(15752)] = 514489,
  [SMALL_STATE(15753)] = 514505,
  [SMALL_STATE(15754)] = 514521,
  [SMALL_STATE(15755)] = 514537,
  [SMALL_STATE(15756)] = 514553,
  [SMALL_STATE(15757)] = 514569,
  [SMALL_STATE(15758)] = 514583,
  [SMALL_STATE(15759)] = 514599,
  [SMALL_STATE(15760)] = 514611,
  [SMALL_STATE(15761)] = 514627,
  [SMALL_STATE(15762)] = 514639,
  [SMALL_STATE(15763)] = 514655,
  [SMALL_STATE(15764)] = 514671,
  [SMALL_STATE(15765)] = 514683,
  [SMALL_STATE(15766)] = 514695,
  [SMALL_STATE(15767)] = 514707,
  [SMALL_STATE(15768)] = 514723,
  [SMALL_STATE(15769)] = 514739,
  [SMALL_STATE(15770)] = 514755,
  [SMALL_STATE(15771)] = 514771,
  [SMALL_STATE(15772)] = 514787,
  [SMALL_STATE(15773)] = 514799,
  [SMALL_STATE(15774)] = 514815,
  [SMALL_STATE(15775)] = 514831,
  [SMALL_STATE(15776)] = 514847,
  [SMALL_STATE(15777)] = 514863,
  [SMALL_STATE(15778)] = 514879,
  [SMALL_STATE(15779)] = 514895,
  [SMALL_STATE(15780)] = 514909,
  [SMALL_STATE(15781)] = 514921,
  [SMALL_STATE(15782)] = 514933,
  [SMALL_STATE(15783)] = 514949,
  [SMALL_STATE(15784)] = 514965,
  [SMALL_STATE(15785)] = 514979,
  [SMALL_STATE(15786)] = 514995,
  [SMALL_STATE(15787)] = 515009,
  [SMALL_STATE(15788)] = 515025,
  [SMALL_STATE(15789)] = 515041,
  [SMALL_STATE(15790)] = 515057,
  [SMALL_STATE(15791)] = 515071,
  [SMALL_STATE(15792)] = 515083,
  [SMALL_STATE(15793)] = 515099,
  [SMALL_STATE(15794)] = 515115,
  [SMALL_STATE(15795)] = 515129,
  [SMALL_STATE(15796)] = 515141,
  [SMALL_STATE(15797)] = 515157,
  [SMALL_STATE(15798)] = 515173,
  [SMALL_STATE(15799)] = 515187,
  [SMALL_STATE(15800)] = 515199,
  [SMALL_STATE(15801)] = 515215,
  [SMALL_STATE(15802)] = 515231,
  [SMALL_STATE(15803)] = 515247,
  [SMALL_STATE(15804)] = 515263,
  [SMALL_STATE(15805)] = 515279,
  [SMALL_STATE(15806)] = 515295,
  [SMALL_STATE(15807)] = 515311,
  [SMALL_STATE(15808)] = 515327,
  [SMALL_STATE(15809)] = 515339,
  [SMALL_STATE(15810)] = 515355,
  [SMALL_STATE(15811)] = 515371,
  [SMALL_STATE(15812)] = 515387,
  [SMALL_STATE(15813)] = 515399,
  [SMALL_STATE(15814)] = 515413,
  [SMALL_STATE(15815)] = 515429,
  [SMALL_STATE(15816)] = 515443,
  [SMALL_STATE(15817)] = 515459,
  [SMALL_STATE(15818)] = 515475,
  [SMALL_STATE(15819)] = 515491,
  [SMALL_STATE(15820)] = 515503,
  [SMALL_STATE(15821)] = 515515,
  [SMALL_STATE(15822)] = 515527,
  [SMALL_STATE(15823)] = 515543,
  [SMALL_STATE(15824)] = 515555,
  [SMALL_STATE(15825)] = 515571,
  [SMALL_STATE(15826)] = 515587,
  [SMALL_STATE(15827)] = 515603,
  [SMALL_STATE(15828)] = 515619,
  [SMALL_STATE(15829)] = 515635,
  [SMALL_STATE(15830)] = 515651,
  [SMALL_STATE(15831)] = 515667,
  [SMALL_STATE(15832)] = 515683,
  [SMALL_STATE(15833)] = 515695,
  [SMALL_STATE(15834)] = 515711,
  [SMALL_STATE(15835)] = 515723,
  [SMALL_STATE(15836)] = 515739,
  [SMALL_STATE(15837)] = 515755,
  [SMALL_STATE(15838)] = 515771,
  [SMALL_STATE(15839)] = 515787,
  [SMALL_STATE(15840)] = 515803,
  [SMALL_STATE(15841)] = 515817,
  [SMALL_STATE(15842)] = 515833,
  [SMALL_STATE(15843)] = 515849,
  [SMALL_STATE(15844)] = 515865,
  [SMALL_STATE(15845)] = 515877,
  [SMALL_STATE(15846)] = 515889,
  [SMALL_STATE(15847)] = 515901,
  [SMALL_STATE(15848)] = 515917,
  [SMALL_STATE(15849)] = 515933,
  [SMALL_STATE(15850)] = 515949,
  [SMALL_STATE(15851)] = 515965,
  [SMALL_STATE(15852)] = 515977,
  [SMALL_STATE(15853)] = 515993,
  [SMALL_STATE(15854)] = 516009,
  [SMALL_STATE(15855)] = 516021,
  [SMALL_STATE(15856)] = 516037,
  [SMALL_STATE(15857)] = 516049,
  [SMALL_STATE(15858)] = 516065,
  [SMALL_STATE(15859)] = 516077,
  [SMALL_STATE(15860)] = 516093,
  [SMALL_STATE(15861)] = 516109,
  [SMALL_STATE(15862)] = 516125,
  [SMALL_STATE(15863)] = 516141,
  [SMALL_STATE(15864)] = 516153,
  [SMALL_STATE(15865)] = 516169,
  [SMALL_STATE(15866)] = 516185,
  [SMALL_STATE(15867)] = 516201,
  [SMALL_STATE(15868)] = 516213,
  [SMALL_STATE(15869)] = 516229,
  [SMALL_STATE(15870)] = 516245,
  [SMALL_STATE(15871)] = 516259,
  [SMALL_STATE(15872)] = 516275,
  [SMALL_STATE(15873)] = 516291,
  [SMALL_STATE(15874)] = 516307,
  [SMALL_STATE(15875)] = 516323,
  [SMALL_STATE(15876)] = 516339,
  [SMALL_STATE(15877)] = 516355,
  [SMALL_STATE(15878)] = 516367,
  [SMALL_STATE(15879)] = 516383,
  [SMALL_STATE(15880)] = 516397,
  [SMALL_STATE(15881)] = 516413,
  [SMALL_STATE(15882)] = 516427,
  [SMALL_STATE(15883)] = 516443,
  [SMALL_STATE(15884)] = 516459,
  [SMALL_STATE(15885)] = 516475,
  [SMALL_STATE(15886)] = 516491,
  [SMALL_STATE(15887)] = 516507,
  [SMALL_STATE(15888)] = 516523,
  [SMALL_STATE(15889)] = 516539,
  [SMALL_STATE(15890)] = 516555,
  [SMALL_STATE(15891)] = 516571,
  [SMALL_STATE(15892)] = 516587,
  [SMALL_STATE(15893)] = 516603,
  [SMALL_STATE(15894)] = 516617,
  [SMALL_STATE(15895)] = 516633,
  [SMALL_STATE(15896)] = 516649,
  [SMALL_STATE(15897)] = 516665,
  [SMALL_STATE(15898)] = 516681,
  [SMALL_STATE(15899)] = 516695,
  [SMALL_STATE(15900)] = 516711,
  [SMALL_STATE(15901)] = 516727,
  [SMALL_STATE(15902)] = 516743,
  [SMALL_STATE(15903)] = 516759,
  [SMALL_STATE(15904)] = 516771,
  [SMALL_STATE(15905)] = 516787,
  [SMALL_STATE(15906)] = 516803,
  [SMALL_STATE(15907)] = 516819,
  [SMALL_STATE(15908)] = 516835,
  [SMALL_STATE(15909)] = 516849,
  [SMALL_STATE(15910)] = 516865,
  [SMALL_STATE(15911)] = 516879,
  [SMALL_STATE(15912)] = 516891,
  [SMALL_STATE(15913)] = 516907,
  [SMALL_STATE(15914)] = 516923,
  [SMALL_STATE(15915)] = 516935,
  [SMALL_STATE(15916)] = 516947,
  [SMALL_STATE(15917)] = 516959,
  [SMALL_STATE(15918)] = 516975,
  [SMALL_STATE(15919)] = 516987,
  [SMALL_STATE(15920)] = 517003,
  [SMALL_STATE(15921)] = 517019,
  [SMALL_STATE(15922)] = 517031,
  [SMALL_STATE(15923)] = 517043,
  [SMALL_STATE(15924)] = 517059,
  [SMALL_STATE(15925)] = 517075,
  [SMALL_STATE(15926)] = 517091,
  [SMALL_STATE(15927)] = 517107,
  [SMALL_STATE(15928)] = 517123,
  [SMALL_STATE(15929)] = 517139,
  [SMALL_STATE(15930)] = 517151,
  [SMALL_STATE(15931)] = 517167,
  [SMALL_STATE(15932)] = 517183,
  [SMALL_STATE(15933)] = 517195,
  [SMALL_STATE(15934)] = 517211,
  [SMALL_STATE(15935)] = 517227,
  [SMALL_STATE(15936)] = 517241,
  [SMALL_STATE(15937)] = 517257,
  [SMALL_STATE(15938)] = 517273,
  [SMALL_STATE(15939)] = 517289,
  [SMALL_STATE(15940)] = 517305,
  [SMALL_STATE(15941)] = 517321,
  [SMALL_STATE(15942)] = 517333,
  [SMALL_STATE(15943)] = 517349,
  [SMALL_STATE(15944)] = 517365,
  [SMALL_STATE(15945)] = 517379,
  [SMALL_STATE(15946)] = 517395,
  [SMALL_STATE(15947)] = 517411,
  [SMALL_STATE(15948)] = 517427,
  [SMALL_STATE(15949)] = 517443,
  [SMALL_STATE(15950)] = 517455,
  [SMALL_STATE(15951)] = 517471,
  [SMALL_STATE(15952)] = 517483,
  [SMALL_STATE(15953)] = 517497,
  [SMALL_STATE(15954)] = 517513,
  [SMALL_STATE(15955)] = 517529,
  [SMALL_STATE(15956)] = 517545,
  [SMALL_STATE(15957)] = 517557,
  [SMALL_STATE(15958)] = 517573,
  [SMALL_STATE(15959)] = 517589,
  [SMALL_STATE(15960)] = 517605,
  [SMALL_STATE(15961)] = 517621,
  [SMALL_STATE(15962)] = 517633,
  [SMALL_STATE(15963)] = 517647,
  [SMALL_STATE(15964)] = 517663,
  [SMALL_STATE(15965)] = 517679,
  [SMALL_STATE(15966)] = 517693,
  [SMALL_STATE(15967)] = 517709,
  [SMALL_STATE(15968)] = 517725,
  [SMALL_STATE(15969)] = 517741,
  [SMALL_STATE(15970)] = 517757,
  [SMALL_STATE(15971)] = 517771,
  [SMALL_STATE(15972)] = 517783,
  [SMALL_STATE(15973)] = 517799,
  [SMALL_STATE(15974)] = 517815,
  [SMALL_STATE(15975)] = 517831,
  [SMALL_STATE(15976)] = 517847,
  [SMALL_STATE(15977)] = 517859,
  [SMALL_STATE(15978)] = 517873,
  [SMALL_STATE(15979)] = 517889,
  [SMALL_STATE(15980)] = 517905,
  [SMALL_STATE(15981)] = 517921,
  [SMALL_STATE(15982)] = 517937,
  [SMALL_STATE(15983)] = 517953,
  [SMALL_STATE(15984)] = 517969,
  [SMALL_STATE(15985)] = 517985,
  [SMALL_STATE(15986)] = 517997,
  [SMALL_STATE(15987)] = 518013,
  [SMALL_STATE(15988)] = 518029,
  [SMALL_STATE(15989)] = 518041,
  [SMALL_STATE(15990)] = 518057,
  [SMALL_STATE(15991)] = 518073,
  [SMALL_STATE(15992)] = 518089,
  [SMALL_STATE(15993)] = 518105,
  [SMALL_STATE(15994)] = 518121,
  [SMALL_STATE(15995)] = 518135,
  [SMALL_STATE(15996)] = 518151,
  [SMALL_STATE(15997)] = 518165,
  [SMALL_STATE(15998)] = 518177,
  [SMALL_STATE(15999)] = 518193,
  [SMALL_STATE(16000)] = 518209,
  [SMALL_STATE(16001)] = 518223,
  [SMALL_STATE(16002)] = 518239,
  [SMALL_STATE(16003)] = 518253,
  [SMALL_STATE(16004)] = 518267,
  [SMALL_STATE(16005)] = 518283,
  [SMALL_STATE(16006)] = 518297,
  [SMALL_STATE(16007)] = 518313,
  [SMALL_STATE(16008)] = 518329,
  [SMALL_STATE(16009)] = 518345,
  [SMALL_STATE(16010)] = 518361,
  [SMALL_STATE(16011)] = 518377,
  [SMALL_STATE(16012)] = 518393,
  [SMALL_STATE(16013)] = 518405,
  [SMALL_STATE(16014)] = 518421,
  [SMALL_STATE(16015)] = 518437,
  [SMALL_STATE(16016)] = 518453,
  [SMALL_STATE(16017)] = 518469,
  [SMALL_STATE(16018)] = 518485,
  [SMALL_STATE(16019)] = 518501,
  [SMALL_STATE(16020)] = 518517,
  [SMALL_STATE(16021)] = 518533,
  [SMALL_STATE(16022)] = 518549,
  [SMALL_STATE(16023)] = 518565,
  [SMALL_STATE(16024)] = 518577,
  [SMALL_STATE(16025)] = 518593,
  [SMALL_STATE(16026)] = 518609,
  [SMALL_STATE(16027)] = 518625,
  [SMALL_STATE(16028)] = 518641,
  [SMALL_STATE(16029)] = 518657,
  [SMALL_STATE(16030)] = 518673,
  [SMALL_STATE(16031)] = 518687,
  [SMALL_STATE(16032)] = 518703,
  [SMALL_STATE(16033)] = 518719,
  [SMALL_STATE(16034)] = 518735,
  [SMALL_STATE(16035)] = 518751,
  [SMALL_STATE(16036)] = 518763,
  [SMALL_STATE(16037)] = 518775,
  [SMALL_STATE(16038)] = 518791,
  [SMALL_STATE(16039)] = 518807,
  [SMALL_STATE(16040)] = 518823,
  [SMALL_STATE(16041)] = 518839,
  [SMALL_STATE(16042)] = 518851,
  [SMALL_STATE(16043)] = 518863,
  [SMALL_STATE(16044)] = 518879,
  [SMALL_STATE(16045)] = 518891,
  [SMALL_STATE(16046)] = 518907,
  [SMALL_STATE(16047)] = 518919,
  [SMALL_STATE(16048)] = 518933,
  [SMALL_STATE(16049)] = 518949,
  [SMALL_STATE(16050)] = 518961,
  [SMALL_STATE(16051)] = 518973,
  [SMALL_STATE(16052)] = 518987,
  [SMALL_STATE(16053)] = 519003,
  [SMALL_STATE(16054)] = 519019,
  [SMALL_STATE(16055)] = 519035,
  [SMALL_STATE(16056)] = 519051,
  [SMALL_STATE(16057)] = 519067,
  [SMALL_STATE(16058)] = 519079,
  [SMALL_STATE(16059)] = 519095,
  [SMALL_STATE(16060)] = 519111,
  [SMALL_STATE(16061)] = 519123,
  [SMALL_STATE(16062)] = 519139,
  [SMALL_STATE(16063)] = 519151,
  [SMALL_STATE(16064)] = 519167,
  [SMALL_STATE(16065)] = 519179,
  [SMALL_STATE(16066)] = 519193,
  [SMALL_STATE(16067)] = 519209,
  [SMALL_STATE(16068)] = 519225,
  [SMALL_STATE(16069)] = 519241,
  [SMALL_STATE(16070)] = 519253,
  [SMALL_STATE(16071)] = 519269,
  [SMALL_STATE(16072)] = 519285,
  [SMALL_STATE(16073)] = 519301,
  [SMALL_STATE(16074)] = 519317,
  [SMALL_STATE(16075)] = 519329,
  [SMALL_STATE(16076)] = 519345,
  [SMALL_STATE(16077)] = 519361,
  [SMALL_STATE(16078)] = 519377,
  [SMALL_STATE(16079)] = 519393,
  [SMALL_STATE(16080)] = 519407,
  [SMALL_STATE(16081)] = 519419,
  [SMALL_STATE(16082)] = 519431,
  [SMALL_STATE(16083)] = 519447,
  [SMALL_STATE(16084)] = 519463,
  [SMALL_STATE(16085)] = 519475,
  [SMALL_STATE(16086)] = 519487,
  [SMALL_STATE(16087)] = 519503,
  [SMALL_STATE(16088)] = 519519,
  [SMALL_STATE(16089)] = 519531,
  [SMALL_STATE(16090)] = 519547,
  [SMALL_STATE(16091)] = 519563,
  [SMALL_STATE(16092)] = 519579,
  [SMALL_STATE(16093)] = 519595,
  [SMALL_STATE(16094)] = 519611,
  [SMALL_STATE(16095)] = 519627,
  [SMALL_STATE(16096)] = 519643,
  [SMALL_STATE(16097)] = 519659,
  [SMALL_STATE(16098)] = 519675,
  [SMALL_STATE(16099)] = 519689,
  [SMALL_STATE(16100)] = 519705,
  [SMALL_STATE(16101)] = 519719,
  [SMALL_STATE(16102)] = 519731,
  [SMALL_STATE(16103)] = 519747,
  [SMALL_STATE(16104)] = 519763,
  [SMALL_STATE(16105)] = 519775,
  [SMALL_STATE(16106)] = 519791,
  [SMALL_STATE(16107)] = 519807,
  [SMALL_STATE(16108)] = 519823,
  [SMALL_STATE(16109)] = 519839,
  [SMALL_STATE(16110)] = 519855,
  [SMALL_STATE(16111)] = 519867,
  [SMALL_STATE(16112)] = 519881,
  [SMALL_STATE(16113)] = 519897,
  [SMALL_STATE(16114)] = 519909,
  [SMALL_STATE(16115)] = 519925,
  [SMALL_STATE(16116)] = 519941,
  [SMALL_STATE(16117)] = 519957,
  [SMALL_STATE(16118)] = 519969,
  [SMALL_STATE(16119)] = 519981,
  [SMALL_STATE(16120)] = 519993,
  [SMALL_STATE(16121)] = 520005,
  [SMALL_STATE(16122)] = 520021,
  [SMALL_STATE(16123)] = 520037,
  [SMALL_STATE(16124)] = 520049,
  [SMALL_STATE(16125)] = 520065,
  [SMALL_STATE(16126)] = 520079,
  [SMALL_STATE(16127)] = 520095,
  [SMALL_STATE(16128)] = 520111,
  [SMALL_STATE(16129)] = 520127,
  [SMALL_STATE(16130)] = 520139,
  [SMALL_STATE(16131)] = 520155,
  [SMALL_STATE(16132)] = 520171,
  [SMALL_STATE(16133)] = 520187,
  [SMALL_STATE(16134)] = 520203,
  [SMALL_STATE(16135)] = 520219,
  [SMALL_STATE(16136)] = 520235,
  [SMALL_STATE(16137)] = 520251,
  [SMALL_STATE(16138)] = 520267,
  [SMALL_STATE(16139)] = 520283,
  [SMALL_STATE(16140)] = 520295,
  [SMALL_STATE(16141)] = 520311,
  [SMALL_STATE(16142)] = 520323,
  [SMALL_STATE(16143)] = 520335,
  [SMALL_STATE(16144)] = 520351,
  [SMALL_STATE(16145)] = 520363,
  [SMALL_STATE(16146)] = 520379,
  [SMALL_STATE(16147)] = 520393,
  [SMALL_STATE(16148)] = 520407,
  [SMALL_STATE(16149)] = 520419,
  [SMALL_STATE(16150)] = 520435,
  [SMALL_STATE(16151)] = 520451,
  [SMALL_STATE(16152)] = 520467,
  [SMALL_STATE(16153)] = 520479,
  [SMALL_STATE(16154)] = 520495,
  [SMALL_STATE(16155)] = 520511,
  [SMALL_STATE(16156)] = 520527,
  [SMALL_STATE(16157)] = 520543,
  [SMALL_STATE(16158)] = 520557,
  [SMALL_STATE(16159)] = 520573,
  [SMALL_STATE(16160)] = 520585,
  [SMALL_STATE(16161)] = 520597,
  [SMALL_STATE(16162)] = 520613,
  [SMALL_STATE(16163)] = 520629,
  [SMALL_STATE(16164)] = 520645,
  [SMALL_STATE(16165)] = 520659,
  [SMALL_STATE(16166)] = 520675,
  [SMALL_STATE(16167)] = 520691,
  [SMALL_STATE(16168)] = 520707,
  [SMALL_STATE(16169)] = 520723,
  [SMALL_STATE(16170)] = 520739,
  [SMALL_STATE(16171)] = 520755,
  [SMALL_STATE(16172)] = 520771,
  [SMALL_STATE(16173)] = 520787,
  [SMALL_STATE(16174)] = 520803,
  [SMALL_STATE(16175)] = 520815,
  [SMALL_STATE(16176)] = 520831,
  [SMALL_STATE(16177)] = 520843,
  [SMALL_STATE(16178)] = 520859,
  [SMALL_STATE(16179)] = 520873,
  [SMALL_STATE(16180)] = 520887,
  [SMALL_STATE(16181)] = 520901,
  [SMALL_STATE(16182)] = 520917,
  [SMALL_STATE(16183)] = 520929,
  [SMALL_STATE(16184)] = 520945,
  [SMALL_STATE(16185)] = 520961,
  [SMALL_STATE(16186)] = 520977,
  [SMALL_STATE(16187)] = 520993,
  [SMALL_STATE(16188)] = 521005,
  [SMALL_STATE(16189)] = 521021,
  [SMALL_STATE(16190)] = 521037,
  [SMALL_STATE(16191)] = 521053,
  [SMALL_STATE(16192)] = 521069,
  [SMALL_STATE(16193)] = 521085,
  [SMALL_STATE(16194)] = 521099,
  [SMALL_STATE(16195)] = 521115,
  [SMALL_STATE(16196)] = 521129,
  [SMALL_STATE(16197)] = 521141,
  [SMALL_STATE(16198)] = 521157,
  [SMALL_STATE(16199)] = 521173,
  [SMALL_STATE(16200)] = 521185,
  [SMALL_STATE(16201)] = 521197,
  [SMALL_STATE(16202)] = 521213,
  [SMALL_STATE(16203)] = 521229,
  [SMALL_STATE(16204)] = 521245,
  [SMALL_STATE(16205)] = 521261,
  [SMALL_STATE(16206)] = 521273,
  [SMALL_STATE(16207)] = 521285,
  [SMALL_STATE(16208)] = 521301,
  [SMALL_STATE(16209)] = 521313,
  [SMALL_STATE(16210)] = 521329,
  [SMALL_STATE(16211)] = 521341,
  [SMALL_STATE(16212)] = 521357,
  [SMALL_STATE(16213)] = 521373,
  [SMALL_STATE(16214)] = 521389,
  [SMALL_STATE(16215)] = 521401,
  [SMALL_STATE(16216)] = 521417,
  [SMALL_STATE(16217)] = 521433,
  [SMALL_STATE(16218)] = 521449,
  [SMALL_STATE(16219)] = 521465,
  [SMALL_STATE(16220)] = 521481,
  [SMALL_STATE(16221)] = 521495,
  [SMALL_STATE(16222)] = 521511,
  [SMALL_STATE(16223)] = 521527,
  [SMALL_STATE(16224)] = 521543,
  [SMALL_STATE(16225)] = 521557,
  [SMALL_STATE(16226)] = 521569,
  [SMALL_STATE(16227)] = 521585,
  [SMALL_STATE(16228)] = 521601,
  [SMALL_STATE(16229)] = 521613,
  [SMALL_STATE(16230)] = 521629,
  [SMALL_STATE(16231)] = 521645,
  [SMALL_STATE(16232)] = 521657,
  [SMALL_STATE(16233)] = 521673,
  [SMALL_STATE(16234)] = 521689,
  [SMALL_STATE(16235)] = 521701,
  [SMALL_STATE(16236)] = 521717,
  [SMALL_STATE(16237)] = 521729,
  [SMALL_STATE(16238)] = 521743,
  [SMALL_STATE(16239)] = 521759,
  [SMALL_STATE(16240)] = 521771,
  [SMALL_STATE(16241)] = 521787,
  [SMALL_STATE(16242)] = 521799,
  [SMALL_STATE(16243)] = 521813,
  [SMALL_STATE(16244)] = 521829,
  [SMALL_STATE(16245)] = 521845,
  [SMALL_STATE(16246)] = 521861,
  [SMALL_STATE(16247)] = 521877,
  [SMALL_STATE(16248)] = 521889,
  [SMALL_STATE(16249)] = 521905,
  [SMALL_STATE(16250)] = 521921,
  [SMALL_STATE(16251)] = 521933,
  [SMALL_STATE(16252)] = 521949,
  [SMALL_STATE(16253)] = 521961,
  [SMALL_STATE(16254)] = 521977,
  [SMALL_STATE(16255)] = 521991,
  [SMALL_STATE(16256)] = 522007,
  [SMALL_STATE(16257)] = 522019,
  [SMALL_STATE(16258)] = 522031,
  [SMALL_STATE(16259)] = 522047,
  [SMALL_STATE(16260)] = 522063,
  [SMALL_STATE(16261)] = 522079,
  [SMALL_STATE(16262)] = 522095,
  [SMALL_STATE(16263)] = 522111,
  [SMALL_STATE(16264)] = 522127,
  [SMALL_STATE(16265)] = 522143,
  [SMALL_STATE(16266)] = 522159,
  [SMALL_STATE(16267)] = 522175,
  [SMALL_STATE(16268)] = 522191,
  [SMALL_STATE(16269)] = 522207,
  [SMALL_STATE(16270)] = 522219,
  [SMALL_STATE(16271)] = 522235,
  [SMALL_STATE(16272)] = 522247,
  [SMALL_STATE(16273)] = 522263,
  [SMALL_STATE(16274)] = 522279,
  [SMALL_STATE(16275)] = 522295,
  [SMALL_STATE(16276)] = 522307,
  [SMALL_STATE(16277)] = 522323,
  [SMALL_STATE(16278)] = 522339,
  [SMALL_STATE(16279)] = 522355,
  [SMALL_STATE(16280)] = 522371,
  [SMALL_STATE(16281)] = 522387,
  [SMALL_STATE(16282)] = 522403,
  [SMALL_STATE(16283)] = 522419,
  [SMALL_STATE(16284)] = 522435,
  [SMALL_STATE(16285)] = 522449,
  [SMALL_STATE(16286)] = 522465,
  [SMALL_STATE(16287)] = 522481,
  [SMALL_STATE(16288)] = 522497,
  [SMALL_STATE(16289)] = 522511,
  [SMALL_STATE(16290)] = 522527,
  [SMALL_STATE(16291)] = 522541,
  [SMALL_STATE(16292)] = 522553,
  [SMALL_STATE(16293)] = 522569,
  [SMALL_STATE(16294)] = 522585,
  [SMALL_STATE(16295)] = 522601,
  [SMALL_STATE(16296)] = 522613,
  [SMALL_STATE(16297)] = 522625,
  [SMALL_STATE(16298)] = 522641,
  [SMALL_STATE(16299)] = 522653,
  [SMALL_STATE(16300)] = 522669,
  [SMALL_STATE(16301)] = 522685,
  [SMALL_STATE(16302)] = 522699,
  [SMALL_STATE(16303)] = 522715,
  [SMALL_STATE(16304)] = 522731,
  [SMALL_STATE(16305)] = 522743,
  [SMALL_STATE(16306)] = 522757,
  [SMALL_STATE(16307)] = 522773,
  [SMALL_STATE(16308)] = 522789,
  [SMALL_STATE(16309)] = 522805,
  [SMALL_STATE(16310)] = 522817,
  [SMALL_STATE(16311)] = 522833,
  [SMALL_STATE(16312)] = 522849,
  [SMALL_STATE(16313)] = 522863,
  [SMALL_STATE(16314)] = 522879,
  [SMALL_STATE(16315)] = 522891,
  [SMALL_STATE(16316)] = 522905,
  [SMALL_STATE(16317)] = 522921,
  [SMALL_STATE(16318)] = 522937,
  [SMALL_STATE(16319)] = 522953,
  [SMALL_STATE(16320)] = 522965,
  [SMALL_STATE(16321)] = 522979,
  [SMALL_STATE(16322)] = 522995,
  [SMALL_STATE(16323)] = 523011,
  [SMALL_STATE(16324)] = 523027,
  [SMALL_STATE(16325)] = 523043,
  [SMALL_STATE(16326)] = 523059,
  [SMALL_STATE(16327)] = 523075,
  [SMALL_STATE(16328)] = 523091,
  [SMALL_STATE(16329)] = 523107,
  [SMALL_STATE(16330)] = 523123,
  [SMALL_STATE(16331)] = 523139,
  [SMALL_STATE(16332)] = 523153,
  [SMALL_STATE(16333)] = 523167,
  [SMALL_STATE(16334)] = 523181,
  [SMALL_STATE(16335)] = 523193,
  [SMALL_STATE(16336)] = 523205,
  [SMALL_STATE(16337)] = 523221,
  [SMALL_STATE(16338)] = 523233,
  [SMALL_STATE(16339)] = 523249,
  [SMALL_STATE(16340)] = 523261,
  [SMALL_STATE(16341)] = 523277,
  [SMALL_STATE(16342)] = 523293,
  [SMALL_STATE(16343)] = 523307,
  [SMALL_STATE(16344)] = 523323,
  [SMALL_STATE(16345)] = 523339,
  [SMALL_STATE(16346)] = 523355,
  [SMALL_STATE(16347)] = 523371,
  [SMALL_STATE(16348)] = 523387,
  [SMALL_STATE(16349)] = 523403,
  [SMALL_STATE(16350)] = 523419,
  [SMALL_STATE(16351)] = 523431,
  [SMALL_STATE(16352)] = 523445,
  [SMALL_STATE(16353)] = 523461,
  [SMALL_STATE(16354)] = 523477,
  [SMALL_STATE(16355)] = 523489,
  [SMALL_STATE(16356)] = 523505,
  [SMALL_STATE(16357)] = 523519,
  [SMALL_STATE(16358)] = 523535,
  [SMALL_STATE(16359)] = 523551,
  [SMALL_STATE(16360)] = 523563,
  [SMALL_STATE(16361)] = 523575,
  [SMALL_STATE(16362)] = 523591,
  [SMALL_STATE(16363)] = 523607,
  [SMALL_STATE(16364)] = 523623,
  [SMALL_STATE(16365)] = 523637,
  [SMALL_STATE(16366)] = 523653,
  [SMALL_STATE(16367)] = 523665,
  [SMALL_STATE(16368)] = 523681,
  [SMALL_STATE(16369)] = 523697,
  [SMALL_STATE(16370)] = 523713,
  [SMALL_STATE(16371)] = 523725,
  [SMALL_STATE(16372)] = 523741,
  [SMALL_STATE(16373)] = 523757,
  [SMALL_STATE(16374)] = 523769,
  [SMALL_STATE(16375)] = 523785,
  [SMALL_STATE(16376)] = 523801,
  [SMALL_STATE(16377)] = 523815,
  [SMALL_STATE(16378)] = 523827,
  [SMALL_STATE(16379)] = 523843,
  [SMALL_STATE(16380)] = 523857,
  [SMALL_STATE(16381)] = 523869,
  [SMALL_STATE(16382)] = 523881,
  [SMALL_STATE(16383)] = 523893,
  [SMALL_STATE(16384)] = 523907,
  [SMALL_STATE(16385)] = 523923,
  [SMALL_STATE(16386)] = 523937,
  [SMALL_STATE(16387)] = 523949,
  [SMALL_STATE(16388)] = 523961,
  [SMALL_STATE(16389)] = 523975,
  [SMALL_STATE(16390)] = 523991,
  [SMALL_STATE(16391)] = 524003,
  [SMALL_STATE(16392)] = 524017,
  [SMALL_STATE(16393)] = 524033,
  [SMALL_STATE(16394)] = 524045,
  [SMALL_STATE(16395)] = 524061,
  [SMALL_STATE(16396)] = 524077,
  [SMALL_STATE(16397)] = 524089,
  [SMALL_STATE(16398)] = 524101,
  [SMALL_STATE(16399)] = 524113,
  [SMALL_STATE(16400)] = 524129,
  [SMALL_STATE(16401)] = 524145,
  [SMALL_STATE(16402)] = 524161,
  [SMALL_STATE(16403)] = 524177,
  [SMALL_STATE(16404)] = 524189,
  [SMALL_STATE(16405)] = 524205,
  [SMALL_STATE(16406)] = 524221,
  [SMALL_STATE(16407)] = 524237,
  [SMALL_STATE(16408)] = 524253,
  [SMALL_STATE(16409)] = 524269,
  [SMALL_STATE(16410)] = 524285,
  [SMALL_STATE(16411)] = 524299,
  [SMALL_STATE(16412)] = 524315,
  [SMALL_STATE(16413)] = 524331,
  [SMALL_STATE(16414)] = 524347,
  [SMALL_STATE(16415)] = 524363,
  [SMALL_STATE(16416)] = 524375,
  [SMALL_STATE(16417)] = 524389,
  [SMALL_STATE(16418)] = 524405,
  [SMALL_STATE(16419)] = 524419,
  [SMALL_STATE(16420)] = 524433,
  [SMALL_STATE(16421)] = 524447,
  [SMALL_STATE(16422)] = 524463,
  [SMALL_STATE(16423)] = 524477,
  [SMALL_STATE(16424)] = 524493,
  [SMALL_STATE(16425)] = 524509,
  [SMALL_STATE(16426)] = 524525,
  [SMALL_STATE(16427)] = 524537,
  [SMALL_STATE(16428)] = 524551,
  [SMALL_STATE(16429)] = 524567,
  [SMALL_STATE(16430)] = 524583,
  [SMALL_STATE(16431)] = 524599,
  [SMALL_STATE(16432)] = 524615,
  [SMALL_STATE(16433)] = 524629,
  [SMALL_STATE(16434)] = 524645,
  [SMALL_STATE(16435)] = 524657,
  [SMALL_STATE(16436)] = 524673,
  [SMALL_STATE(16437)] = 524687,
  [SMALL_STATE(16438)] = 524701,
  [SMALL_STATE(16439)] = 524717,
  [SMALL_STATE(16440)] = 524733,
  [SMALL_STATE(16441)] = 524749,
  [SMALL_STATE(16442)] = 524765,
  [SMALL_STATE(16443)] = 524779,
  [SMALL_STATE(16444)] = 524795,
  [SMALL_STATE(16445)] = 524811,
  [SMALL_STATE(16446)] = 524825,
  [SMALL_STATE(16447)] = 524837,
  [SMALL_STATE(16448)] = 524853,
  [SMALL_STATE(16449)] = 524869,
  [SMALL_STATE(16450)] = 524883,
  [SMALL_STATE(16451)] = 524899,
  [SMALL_STATE(16452)] = 524915,
  [SMALL_STATE(16453)] = 524929,
  [SMALL_STATE(16454)] = 524945,
  [SMALL_STATE(16455)] = 524961,
  [SMALL_STATE(16456)] = 524977,
  [SMALL_STATE(16457)] = 524993,
  [SMALL_STATE(16458)] = 525009,
  [SMALL_STATE(16459)] = 525025,
  [SMALL_STATE(16460)] = 525039,
  [SMALL_STATE(16461)] = 525051,
  [SMALL_STATE(16462)] = 525065,
  [SMALL_STATE(16463)] = 525081,
  [SMALL_STATE(16464)] = 525095,
  [SMALL_STATE(16465)] = 525111,
  [SMALL_STATE(16466)] = 525127,
  [SMALL_STATE(16467)] = 525143,
  [SMALL_STATE(16468)] = 525155,
  [SMALL_STATE(16469)] = 525171,
  [SMALL_STATE(16470)] = 525185,
  [SMALL_STATE(16471)] = 525199,
  [SMALL_STATE(16472)] = 525215,
  [SMALL_STATE(16473)] = 525231,
  [SMALL_STATE(16474)] = 525247,
  [SMALL_STATE(16475)] = 525263,
  [SMALL_STATE(16476)] = 525279,
  [SMALL_STATE(16477)] = 525293,
  [SMALL_STATE(16478)] = 525309,
  [SMALL_STATE(16479)] = 525323,
  [SMALL_STATE(16480)] = 525339,
  [SMALL_STATE(16481)] = 525353,
  [SMALL_STATE(16482)] = 525365,
  [SMALL_STATE(16483)] = 525381,
  [SMALL_STATE(16484)] = 525397,
  [SMALL_STATE(16485)] = 525411,
  [SMALL_STATE(16486)] = 525425,
  [SMALL_STATE(16487)] = 525441,
  [SMALL_STATE(16488)] = 525453,
  [SMALL_STATE(16489)] = 525469,
  [SMALL_STATE(16490)] = 525485,
  [SMALL_STATE(16491)] = 525499,
  [SMALL_STATE(16492)] = 525515,
  [SMALL_STATE(16493)] = 525531,
  [SMALL_STATE(16494)] = 525547,
  [SMALL_STATE(16495)] = 525561,
  [SMALL_STATE(16496)] = 525575,
  [SMALL_STATE(16497)] = 525591,
  [SMALL_STATE(16498)] = 525607,
  [SMALL_STATE(16499)] = 525619,
  [SMALL_STATE(16500)] = 525635,
  [SMALL_STATE(16501)] = 525649,
  [SMALL_STATE(16502)] = 525665,
  [SMALL_STATE(16503)] = 525679,
  [SMALL_STATE(16504)] = 525693,
  [SMALL_STATE(16505)] = 525707,
  [SMALL_STATE(16506)] = 525721,
  [SMALL_STATE(16507)] = 525737,
  [SMALL_STATE(16508)] = 525753,
  [SMALL_STATE(16509)] = 525769,
  [SMALL_STATE(16510)] = 525785,
  [SMALL_STATE(16511)] = 525799,
  [SMALL_STATE(16512)] = 525811,
  [SMALL_STATE(16513)] = 525827,
  [SMALL_STATE(16514)] = 525841,
  [SMALL_STATE(16515)] = 525857,
  [SMALL_STATE(16516)] = 525871,
  [SMALL_STATE(16517)] = 525887,
  [SMALL_STATE(16518)] = 525903,
  [SMALL_STATE(16519)] = 525919,
  [SMALL_STATE(16520)] = 525933,
  [SMALL_STATE(16521)] = 525949,
  [SMALL_STATE(16522)] = 525963,
  [SMALL_STATE(16523)] = 525977,
  [SMALL_STATE(16524)] = 525993,
  [SMALL_STATE(16525)] = 526005,
  [SMALL_STATE(16526)] = 526019,
  [SMALL_STATE(16527)] = 526033,
  [SMALL_STATE(16528)] = 526049,
  [SMALL_STATE(16529)] = 526063,
  [SMALL_STATE(16530)] = 526077,
  [SMALL_STATE(16531)] = 526093,
  [SMALL_STATE(16532)] = 526107,
  [SMALL_STATE(16533)] = 526123,
  [SMALL_STATE(16534)] = 526139,
  [SMALL_STATE(16535)] = 526155,
  [SMALL_STATE(16536)] = 526169,
  [SMALL_STATE(16537)] = 526185,
  [SMALL_STATE(16538)] = 526199,
  [SMALL_STATE(16539)] = 526215,
  [SMALL_STATE(16540)] = 526231,
  [SMALL_STATE(16541)] = 526245,
  [SMALL_STATE(16542)] = 526261,
  [SMALL_STATE(16543)] = 526277,
  [SMALL_STATE(16544)] = 526293,
  [SMALL_STATE(16545)] = 526307,
  [SMALL_STATE(16546)] = 526323,
  [SMALL_STATE(16547)] = 526337,
  [SMALL_STATE(16548)] = 526351,
  [SMALL_STATE(16549)] = 526367,
  [SMALL_STATE(16550)] = 526381,
  [SMALL_STATE(16551)] = 526397,
  [SMALL_STATE(16552)] = 526413,
  [SMALL_STATE(16553)] = 526429,
  [SMALL_STATE(16554)] = 526445,
  [SMALL_STATE(16555)] = 526459,
  [SMALL_STATE(16556)] = 526473,
  [SMALL_STATE(16557)] = 526487,
  [SMALL_STATE(16558)] = 526503,
  [SMALL_STATE(16559)] = 526519,
  [SMALL_STATE(16560)] = 526533,
  [SMALL_STATE(16561)] = 526547,
  [SMALL_STATE(16562)] = 526563,
  [SMALL_STATE(16563)] = 526577,
  [SMALL_STATE(16564)] = 526593,
  [SMALL_STATE(16565)] = 526609,
  [SMALL_STATE(16566)] = 526623,
  [SMALL_STATE(16567)] = 526637,
  [SMALL_STATE(16568)] = 526651,
  [SMALL_STATE(16569)] = 526665,
  [SMALL_STATE(16570)] = 526681,
  [SMALL_STATE(16571)] = 526695,
  [SMALL_STATE(16572)] = 526707,
  [SMALL_STATE(16573)] = 526719,
  [SMALL_STATE(16574)] = 526733,
  [SMALL_STATE(16575)] = 526747,
  [SMALL_STATE(16576)] = 526761,
  [SMALL_STATE(16577)] = 526775,
  [SMALL_STATE(16578)] = 526791,
  [SMALL_STATE(16579)] = 526805,
  [SMALL_STATE(16580)] = 526821,
  [SMALL_STATE(16581)] = 526837,
  [SMALL_STATE(16582)] = 526853,
  [SMALL_STATE(16583)] = 526867,
  [SMALL_STATE(16584)] = 526883,
  [SMALL_STATE(16585)] = 526897,
  [SMALL_STATE(16586)] = 526911,
  [SMALL_STATE(16587)] = 526927,
  [SMALL_STATE(16588)] = 526943,
  [SMALL_STATE(16589)] = 526957,
  [SMALL_STATE(16590)] = 526973,
  [SMALL_STATE(16591)] = 526987,
  [SMALL_STATE(16592)] = 527003,
  [SMALL_STATE(16593)] = 527015,
  [SMALL_STATE(16594)] = 527031,
  [SMALL_STATE(16595)] = 527045,
  [SMALL_STATE(16596)] = 527059,
  [SMALL_STATE(16597)] = 527075,
  [SMALL_STATE(16598)] = 527091,
  [SMALL_STATE(16599)] = 527105,
  [SMALL_STATE(16600)] = 527119,
  [SMALL_STATE(16601)] = 527133,
  [SMALL_STATE(16602)] = 527149,
  [SMALL_STATE(16603)] = 527165,
  [SMALL_STATE(16604)] = 527179,
  [SMALL_STATE(16605)] = 527193,
  [SMALL_STATE(16606)] = 527205,
  [SMALL_STATE(16607)] = 527217,
  [SMALL_STATE(16608)] = 527233,
  [SMALL_STATE(16609)] = 527249,
  [SMALL_STATE(16610)] = 527263,
  [SMALL_STATE(16611)] = 527279,
  [SMALL_STATE(16612)] = 527293,
  [SMALL_STATE(16613)] = 527307,
  [SMALL_STATE(16614)] = 527323,
  [SMALL_STATE(16615)] = 527339,
  [SMALL_STATE(16616)] = 527355,
  [SMALL_STATE(16617)] = 527367,
  [SMALL_STATE(16618)] = 527383,
  [SMALL_STATE(16619)] = 527397,
  [SMALL_STATE(16620)] = 527409,
  [SMALL_STATE(16621)] = 527423,
  [SMALL_STATE(16622)] = 527435,
  [SMALL_STATE(16623)] = 527449,
  [SMALL_STATE(16624)] = 527465,
  [SMALL_STATE(16625)] = 527479,
  [SMALL_STATE(16626)] = 527495,
  [SMALL_STATE(16627)] = 527511,
  [SMALL_STATE(16628)] = 527527,
  [SMALL_STATE(16629)] = 527543,
  [SMALL_STATE(16630)] = 527559,
  [SMALL_STATE(16631)] = 527575,
  [SMALL_STATE(16632)] = 527591,
  [SMALL_STATE(16633)] = 527605,
  [SMALL_STATE(16634)] = 527621,
  [SMALL_STATE(16635)] = 527635,
  [SMALL_STATE(16636)] = 527651,
  [SMALL_STATE(16637)] = 527667,
  [SMALL_STATE(16638)] = 527683,
  [SMALL_STATE(16639)] = 527699,
  [SMALL_STATE(16640)] = 527715,
  [SMALL_STATE(16641)] = 527731,
  [SMALL_STATE(16642)] = 527743,
  [SMALL_STATE(16643)] = 527759,
  [SMALL_STATE(16644)] = 527775,
  [SMALL_STATE(16645)] = 527791,
  [SMALL_STATE(16646)] = 527807,
  [SMALL_STATE(16647)] = 527823,
  [SMALL_STATE(16648)] = 527839,
  [SMALL_STATE(16649)] = 527855,
  [SMALL_STATE(16650)] = 527871,
  [SMALL_STATE(16651)] = 527883,
  [SMALL_STATE(16652)] = 527899,
  [SMALL_STATE(16653)] = 527915,
  [SMALL_STATE(16654)] = 527927,
  [SMALL_STATE(16655)] = 527943,
  [SMALL_STATE(16656)] = 527955,
  [SMALL_STATE(16657)] = 527971,
  [SMALL_STATE(16658)] = 527987,
  [SMALL_STATE(16659)] = 528001,
  [SMALL_STATE(16660)] = 528017,
  [SMALL_STATE(16661)] = 528031,
  [SMALL_STATE(16662)] = 528047,
  [SMALL_STATE(16663)] = 528059,
  [SMALL_STATE(16664)] = 528071,
  [SMALL_STATE(16665)] = 528085,
  [SMALL_STATE(16666)] = 528101,
  [SMALL_STATE(16667)] = 528117,
  [SMALL_STATE(16668)] = 528131,
  [SMALL_STATE(16669)] = 528145,
  [SMALL_STATE(16670)] = 528161,
  [SMALL_STATE(16671)] = 528175,
  [SMALL_STATE(16672)] = 528191,
  [SMALL_STATE(16673)] = 528207,
  [SMALL_STATE(16674)] = 528223,
  [SMALL_STATE(16675)] = 528235,
  [SMALL_STATE(16676)] = 528251,
  [SMALL_STATE(16677)] = 528267,
  [SMALL_STATE(16678)] = 528283,
  [SMALL_STATE(16679)] = 528299,
  [SMALL_STATE(16680)] = 528315,
  [SMALL_STATE(16681)] = 528331,
  [SMALL_STATE(16682)] = 528347,
  [SMALL_STATE(16683)] = 528361,
  [SMALL_STATE(16684)] = 528373,
  [SMALL_STATE(16685)] = 528389,
  [SMALL_STATE(16686)] = 528405,
  [SMALL_STATE(16687)] = 528421,
  [SMALL_STATE(16688)] = 528433,
  [SMALL_STATE(16689)] = 528445,
  [SMALL_STATE(16690)] = 528459,
  [SMALL_STATE(16691)] = 528475,
  [SMALL_STATE(16692)] = 528489,
  [SMALL_STATE(16693)] = 528505,
  [SMALL_STATE(16694)] = 528521,
  [SMALL_STATE(16695)] = 528537,
  [SMALL_STATE(16696)] = 528551,
  [SMALL_STATE(16697)] = 528567,
  [SMALL_STATE(16698)] = 528583,
  [SMALL_STATE(16699)] = 528599,
  [SMALL_STATE(16700)] = 528615,
  [SMALL_STATE(16701)] = 528631,
  [SMALL_STATE(16702)] = 528643,
  [SMALL_STATE(16703)] = 528659,
  [SMALL_STATE(16704)] = 528675,
  [SMALL_STATE(16705)] = 528691,
  [SMALL_STATE(16706)] = 528705,
  [SMALL_STATE(16707)] = 528721,
  [SMALL_STATE(16708)] = 528737,
  [SMALL_STATE(16709)] = 528753,
  [SMALL_STATE(16710)] = 528769,
  [SMALL_STATE(16711)] = 528785,
  [SMALL_STATE(16712)] = 528799,
  [SMALL_STATE(16713)] = 528815,
  [SMALL_STATE(16714)] = 528831,
  [SMALL_STATE(16715)] = 528847,
  [SMALL_STATE(16716)] = 528861,
  [SMALL_STATE(16717)] = 528877,
  [SMALL_STATE(16718)] = 528893,
  [SMALL_STATE(16719)] = 528909,
  [SMALL_STATE(16720)] = 528925,
  [SMALL_STATE(16721)] = 528941,
  [SMALL_STATE(16722)] = 528953,
  [SMALL_STATE(16723)] = 528969,
  [SMALL_STATE(16724)] = 528985,
  [SMALL_STATE(16725)] = 529001,
  [SMALL_STATE(16726)] = 529017,
  [SMALL_STATE(16727)] = 529033,
  [SMALL_STATE(16728)] = 529049,
  [SMALL_STATE(16729)] = 529065,
  [SMALL_STATE(16730)] = 529081,
  [SMALL_STATE(16731)] = 529095,
  [SMALL_STATE(16732)] = 529111,
  [SMALL_STATE(16733)] = 529127,
  [SMALL_STATE(16734)] = 529143,
  [SMALL_STATE(16735)] = 529159,
  [SMALL_STATE(16736)] = 529175,
  [SMALL_STATE(16737)] = 529191,
  [SMALL_STATE(16738)] = 529207,
  [SMALL_STATE(16739)] = 529223,
  [SMALL_STATE(16740)] = 529237,
  [SMALL_STATE(16741)] = 529251,
  [SMALL_STATE(16742)] = 529265,
  [SMALL_STATE(16743)] = 529281,
  [SMALL_STATE(16744)] = 529297,
  [SMALL_STATE(16745)] = 529313,
  [SMALL_STATE(16746)] = 529329,
  [SMALL_STATE(16747)] = 529341,
  [SMALL_STATE(16748)] = 529357,
  [SMALL_STATE(16749)] = 529373,
  [SMALL_STATE(16750)] = 529389,
  [SMALL_STATE(16751)] = 529405,
  [SMALL_STATE(16752)] = 529421,
  [SMALL_STATE(16753)] = 529437,
  [SMALL_STATE(16754)] = 529451,
  [SMALL_STATE(16755)] = 529463,
  [SMALL_STATE(16756)] = 529477,
  [SMALL_STATE(16757)] = 529489,
  [SMALL_STATE(16758)] = 529503,
  [SMALL_STATE(16759)] = 529517,
  [SMALL_STATE(16760)] = 529533,
  [SMALL_STATE(16761)] = 529549,
  [SMALL_STATE(16762)] = 529563,
  [SMALL_STATE(16763)] = 529575,
  [SMALL_STATE(16764)] = 529589,
  [SMALL_STATE(16765)] = 529603,
  [SMALL_STATE(16766)] = 529617,
  [SMALL_STATE(16767)] = 529629,
  [SMALL_STATE(16768)] = 529645,
  [SMALL_STATE(16769)] = 529661,
  [SMALL_STATE(16770)] = 529677,
  [SMALL_STATE(16771)] = 529691,
  [SMALL_STATE(16772)] = 529703,
  [SMALL_STATE(16773)] = 529715,
  [SMALL_STATE(16774)] = 529731,
  [SMALL_STATE(16775)] = 529747,
  [SMALL_STATE(16776)] = 529761,
  [SMALL_STATE(16777)] = 529773,
  [SMALL_STATE(16778)] = 529789,
  [SMALL_STATE(16779)] = 529805,
  [SMALL_STATE(16780)] = 529819,
  [SMALL_STATE(16781)] = 529833,
  [SMALL_STATE(16782)] = 529849,
  [SMALL_STATE(16783)] = 529863,
  [SMALL_STATE(16784)] = 529879,
  [SMALL_STATE(16785)] = 529895,
  [SMALL_STATE(16786)] = 529911,
  [SMALL_STATE(16787)] = 529927,
  [SMALL_STATE(16788)] = 529943,
  [SMALL_STATE(16789)] = 529959,
  [SMALL_STATE(16790)] = 529975,
  [SMALL_STATE(16791)] = 529989,
  [SMALL_STATE(16792)] = 530005,
  [SMALL_STATE(16793)] = 530021,
  [SMALL_STATE(16794)] = 530037,
  [SMALL_STATE(16795)] = 530051,
  [SMALL_STATE(16796)] = 530067,
  [SMALL_STATE(16797)] = 530079,
  [SMALL_STATE(16798)] = 530095,
  [SMALL_STATE(16799)] = 530107,
  [SMALL_STATE(16800)] = 530123,
  [SMALL_STATE(16801)] = 530137,
  [SMALL_STATE(16802)] = 530151,
  [SMALL_STATE(16803)] = 530165,
  [SMALL_STATE(16804)] = 530181,
  [SMALL_STATE(16805)] = 530197,
  [SMALL_STATE(16806)] = 530213,
  [SMALL_STATE(16807)] = 530227,
  [SMALL_STATE(16808)] = 530243,
  [SMALL_STATE(16809)] = 530255,
  [SMALL_STATE(16810)] = 530267,
  [SMALL_STATE(16811)] = 530279,
  [SMALL_STATE(16812)] = 530291,
  [SMALL_STATE(16813)] = 530307,
  [SMALL_STATE(16814)] = 530323,
  [SMALL_STATE(16815)] = 530339,
  [SMALL_STATE(16816)] = 530355,
  [SMALL_STATE(16817)] = 530371,
  [SMALL_STATE(16818)] = 530387,
  [SMALL_STATE(16819)] = 530403,
  [SMALL_STATE(16820)] = 530419,
  [SMALL_STATE(16821)] = 530435,
  [SMALL_STATE(16822)] = 530451,
  [SMALL_STATE(16823)] = 530465,
  [SMALL_STATE(16824)] = 530481,
  [SMALL_STATE(16825)] = 530497,
  [SMALL_STATE(16826)] = 530513,
  [SMALL_STATE(16827)] = 530529,
  [SMALL_STATE(16828)] = 530545,
  [SMALL_STATE(16829)] = 530561,
  [SMALL_STATE(16830)] = 530577,
  [SMALL_STATE(16831)] = 530593,
  [SMALL_STATE(16832)] = 530609,
  [SMALL_STATE(16833)] = 530623,
  [SMALL_STATE(16834)] = 530639,
  [SMALL_STATE(16835)] = 530655,
  [SMALL_STATE(16836)] = 530669,
  [SMALL_STATE(16837)] = 530681,
  [SMALL_STATE(16838)] = 530697,
  [SMALL_STATE(16839)] = 530713,
  [SMALL_STATE(16840)] = 530729,
  [SMALL_STATE(16841)] = 530745,
  [SMALL_STATE(16842)] = 530761,
  [SMALL_STATE(16843)] = 530777,
  [SMALL_STATE(16844)] = 530793,
  [SMALL_STATE(16845)] = 530809,
  [SMALL_STATE(16846)] = 530825,
  [SMALL_STATE(16847)] = 530841,
  [SMALL_STATE(16848)] = 530857,
  [SMALL_STATE(16849)] = 530873,
  [SMALL_STATE(16850)] = 530889,
  [SMALL_STATE(16851)] = 530905,
  [SMALL_STATE(16852)] = 530921,
  [SMALL_STATE(16853)] = 530933,
  [SMALL_STATE(16854)] = 530949,
  [SMALL_STATE(16855)] = 530963,
  [SMALL_STATE(16856)] = 530975,
  [SMALL_STATE(16857)] = 530991,
  [SMALL_STATE(16858)] = 531003,
  [SMALL_STATE(16859)] = 531017,
  [SMALL_STATE(16860)] = 531033,
  [SMALL_STATE(16861)] = 531047,
  [SMALL_STATE(16862)] = 531063,
  [SMALL_STATE(16863)] = 531079,
  [SMALL_STATE(16864)] = 531093,
  [SMALL_STATE(16865)] = 531109,
  [SMALL_STATE(16866)] = 531123,
  [SMALL_STATE(16867)] = 531139,
  [SMALL_STATE(16868)] = 531155,
  [SMALL_STATE(16869)] = 531171,
  [SMALL_STATE(16870)] = 531187,
  [SMALL_STATE(16871)] = 531203,
  [SMALL_STATE(16872)] = 531219,
  [SMALL_STATE(16873)] = 531235,
  [SMALL_STATE(16874)] = 531249,
  [SMALL_STATE(16875)] = 531261,
  [SMALL_STATE(16876)] = 531277,
  [SMALL_STATE(16877)] = 531293,
  [SMALL_STATE(16878)] = 531309,
  [SMALL_STATE(16879)] = 531325,
  [SMALL_STATE(16880)] = 531339,
  [SMALL_STATE(16881)] = 531355,
  [SMALL_STATE(16882)] = 531371,
  [SMALL_STATE(16883)] = 531387,
  [SMALL_STATE(16884)] = 531403,
  [SMALL_STATE(16885)] = 531419,
  [SMALL_STATE(16886)] = 531433,
  [SMALL_STATE(16887)] = 531449,
  [SMALL_STATE(16888)] = 531465,
  [SMALL_STATE(16889)] = 531479,
  [SMALL_STATE(16890)] = 531491,
  [SMALL_STATE(16891)] = 531507,
  [SMALL_STATE(16892)] = 531523,
  [SMALL_STATE(16893)] = 531539,
  [SMALL_STATE(16894)] = 531553,
  [SMALL_STATE(16895)] = 531565,
  [SMALL_STATE(16896)] = 531581,
  [SMALL_STATE(16897)] = 531597,
  [SMALL_STATE(16898)] = 531609,
  [SMALL_STATE(16899)] = 531625,
  [SMALL_STATE(16900)] = 531641,
  [SMALL_STATE(16901)] = 531657,
  [SMALL_STATE(16902)] = 531673,
  [SMALL_STATE(16903)] = 531689,
  [SMALL_STATE(16904)] = 531703,
  [SMALL_STATE(16905)] = 531719,
  [SMALL_STATE(16906)] = 531731,
  [SMALL_STATE(16907)] = 531743,
  [SMALL_STATE(16908)] = 531759,
  [SMALL_STATE(16909)] = 531775,
  [SMALL_STATE(16910)] = 531791,
  [SMALL_STATE(16911)] = 531807,
  [SMALL_STATE(16912)] = 531821,
  [SMALL_STATE(16913)] = 531837,
  [SMALL_STATE(16914)] = 531853,
  [SMALL_STATE(16915)] = 531869,
  [SMALL_STATE(16916)] = 531883,
  [SMALL_STATE(16917)] = 531899,
  [SMALL_STATE(16918)] = 531915,
  [SMALL_STATE(16919)] = 531931,
  [SMALL_STATE(16920)] = 531947,
  [SMALL_STATE(16921)] = 531963,
  [SMALL_STATE(16922)] = 531979,
  [SMALL_STATE(16923)] = 531993,
  [SMALL_STATE(16924)] = 532009,
  [SMALL_STATE(16925)] = 532025,
  [SMALL_STATE(16926)] = 532041,
  [SMALL_STATE(16927)] = 532057,
  [SMALL_STATE(16928)] = 532071,
  [SMALL_STATE(16929)] = 532087,
  [SMALL_STATE(16930)] = 532099,
  [SMALL_STATE(16931)] = 532113,
  [SMALL_STATE(16932)] = 532125,
  [SMALL_STATE(16933)] = 532141,
  [SMALL_STATE(16934)] = 532157,
  [SMALL_STATE(16935)] = 532169,
  [SMALL_STATE(16936)] = 532181,
  [SMALL_STATE(16937)] = 532193,
  [SMALL_STATE(16938)] = 532209,
  [SMALL_STATE(16939)] = 532221,
  [SMALL_STATE(16940)] = 532233,
  [SMALL_STATE(16941)] = 532245,
  [SMALL_STATE(16942)] = 532261,
  [SMALL_STATE(16943)] = 532273,
  [SMALL_STATE(16944)] = 532285,
  [SMALL_STATE(16945)] = 532299,
  [SMALL_STATE(16946)] = 532315,
  [SMALL_STATE(16947)] = 532327,
  [SMALL_STATE(16948)] = 532339,
  [SMALL_STATE(16949)] = 532351,
  [SMALL_STATE(16950)] = 532365,
  [SMALL_STATE(16951)] = 532381,
  [SMALL_STATE(16952)] = 532393,
  [SMALL_STATE(16953)] = 532405,
  [SMALL_STATE(16954)] = 532419,
  [SMALL_STATE(16955)] = 532433,
  [SMALL_STATE(16956)] = 532447,
  [SMALL_STATE(16957)] = 532463,
  [SMALL_STATE(16958)] = 532475,
  [SMALL_STATE(16959)] = 532491,
  [SMALL_STATE(16960)] = 532503,
  [SMALL_STATE(16961)] = 532517,
  [SMALL_STATE(16962)] = 532533,
  [SMALL_STATE(16963)] = 532549,
  [SMALL_STATE(16964)] = 532565,
  [SMALL_STATE(16965)] = 532581,
  [SMALL_STATE(16966)] = 532593,
  [SMALL_STATE(16967)] = 532609,
  [SMALL_STATE(16968)] = 532621,
  [SMALL_STATE(16969)] = 532637,
  [SMALL_STATE(16970)] = 532653,
  [SMALL_STATE(16971)] = 532667,
  [SMALL_STATE(16972)] = 532683,
  [SMALL_STATE(16973)] = 532695,
  [SMALL_STATE(16974)] = 532707,
  [SMALL_STATE(16975)] = 532719,
  [SMALL_STATE(16976)] = 532735,
  [SMALL_STATE(16977)] = 532751,
  [SMALL_STATE(16978)] = 532767,
  [SMALL_STATE(16979)] = 532781,
  [SMALL_STATE(16980)] = 532795,
  [SMALL_STATE(16981)] = 532809,
  [SMALL_STATE(16982)] = 532825,
  [SMALL_STATE(16983)] = 532841,
  [SMALL_STATE(16984)] = 532857,
  [SMALL_STATE(16985)] = 532873,
  [SMALL_STATE(16986)] = 532885,
  [SMALL_STATE(16987)] = 532897,
  [SMALL_STATE(16988)] = 532913,
  [SMALL_STATE(16989)] = 532929,
  [SMALL_STATE(16990)] = 532945,
  [SMALL_STATE(16991)] = 532957,
  [SMALL_STATE(16992)] = 532973,
  [SMALL_STATE(16993)] = 532989,
  [SMALL_STATE(16994)] = 533005,
  [SMALL_STATE(16995)] = 533017,
  [SMALL_STATE(16996)] = 533033,
  [SMALL_STATE(16997)] = 533045,
  [SMALL_STATE(16998)] = 533061,
  [SMALL_STATE(16999)] = 533077,
  [SMALL_STATE(17000)] = 533089,
  [SMALL_STATE(17001)] = 533101,
  [SMALL_STATE(17002)] = 533113,
  [SMALL_STATE(17003)] = 533127,
  [SMALL_STATE(17004)] = 533139,
  [SMALL_STATE(17005)] = 533155,
  [SMALL_STATE(17006)] = 533171,
  [SMALL_STATE(17007)] = 533183,
  [SMALL_STATE(17008)] = 533195,
  [SMALL_STATE(17009)] = 533211,
  [SMALL_STATE(17010)] = 533227,
  [SMALL_STATE(17011)] = 533241,
  [SMALL_STATE(17012)] = 533257,
  [SMALL_STATE(17013)] = 533271,
  [SMALL_STATE(17014)] = 533287,
  [SMALL_STATE(17015)] = 533301,
  [SMALL_STATE(17016)] = 533317,
  [SMALL_STATE(17017)] = 533329,
  [SMALL_STATE(17018)] = 533345,
  [SMALL_STATE(17019)] = 533361,
  [SMALL_STATE(17020)] = 533377,
  [SMALL_STATE(17021)] = 533393,
  [SMALL_STATE(17022)] = 533409,
  [SMALL_STATE(17023)] = 533425,
  [SMALL_STATE(17024)] = 533441,
  [SMALL_STATE(17025)] = 533453,
  [SMALL_STATE(17026)] = 533469,
  [SMALL_STATE(17027)] = 533481,
  [SMALL_STATE(17028)] = 533497,
  [SMALL_STATE(17029)] = 533513,
  [SMALL_STATE(17030)] = 533529,
  [SMALL_STATE(17031)] = 533541,
  [SMALL_STATE(17032)] = 533553,
  [SMALL_STATE(17033)] = 533569,
  [SMALL_STATE(17034)] = 533585,
  [SMALL_STATE(17035)] = 533601,
  [SMALL_STATE(17036)] = 533617,
  [SMALL_STATE(17037)] = 533633,
  [SMALL_STATE(17038)] = 533647,
  [SMALL_STATE(17039)] = 533663,
  [SMALL_STATE(17040)] = 533679,
  [SMALL_STATE(17041)] = 533695,
  [SMALL_STATE(17042)] = 533707,
  [SMALL_STATE(17043)] = 533723,
  [SMALL_STATE(17044)] = 533739,
  [SMALL_STATE(17045)] = 533755,
  [SMALL_STATE(17046)] = 533771,
  [SMALL_STATE(17047)] = 533785,
  [SMALL_STATE(17048)] = 533801,
  [SMALL_STATE(17049)] = 533815,
  [SMALL_STATE(17050)] = 533831,
  [SMALL_STATE(17051)] = 533845,
  [SMALL_STATE(17052)] = 533861,
  [SMALL_STATE(17053)] = 533875,
  [SMALL_STATE(17054)] = 533889,
  [SMALL_STATE(17055)] = 533901,
  [SMALL_STATE(17056)] = 533917,
  [SMALL_STATE(17057)] = 533933,
  [SMALL_STATE(17058)] = 533949,
  [SMALL_STATE(17059)] = 533961,
  [SMALL_STATE(17060)] = 533977,
  [SMALL_STATE(17061)] = 533989,
  [SMALL_STATE(17062)] = 534003,
  [SMALL_STATE(17063)] = 534015,
  [SMALL_STATE(17064)] = 534031,
  [SMALL_STATE(17065)] = 534047,
  [SMALL_STATE(17066)] = 534063,
  [SMALL_STATE(17067)] = 534079,
  [SMALL_STATE(17068)] = 534095,
  [SMALL_STATE(17069)] = 534109,
  [SMALL_STATE(17070)] = 534125,
  [SMALL_STATE(17071)] = 534141,
  [SMALL_STATE(17072)] = 534155,
  [SMALL_STATE(17073)] = 534169,
  [SMALL_STATE(17074)] = 534185,
  [SMALL_STATE(17075)] = 534199,
  [SMALL_STATE(17076)] = 534215,
  [SMALL_STATE(17077)] = 534231,
  [SMALL_STATE(17078)] = 534247,
  [SMALL_STATE(17079)] = 534263,
  [SMALL_STATE(17080)] = 534279,
  [SMALL_STATE(17081)] = 534295,
  [SMALL_STATE(17082)] = 534311,
  [SMALL_STATE(17083)] = 534325,
  [SMALL_STATE(17084)] = 534339,
  [SMALL_STATE(17085)] = 534355,
  [SMALL_STATE(17086)] = 534369,
  [SMALL_STATE(17087)] = 534383,
  [SMALL_STATE(17088)] = 534399,
  [SMALL_STATE(17089)] = 534415,
  [SMALL_STATE(17090)] = 534427,
  [SMALL_STATE(17091)] = 534443,
  [SMALL_STATE(17092)] = 534459,
  [SMALL_STATE(17093)] = 534475,
  [SMALL_STATE(17094)] = 534491,
  [SMALL_STATE(17095)] = 534507,
  [SMALL_STATE(17096)] = 534523,
  [SMALL_STATE(17097)] = 534539,
  [SMALL_STATE(17098)] = 534555,
  [SMALL_STATE(17099)] = 534571,
  [SMALL_STATE(17100)] = 534587,
  [SMALL_STATE(17101)] = 534603,
  [SMALL_STATE(17102)] = 534619,
  [SMALL_STATE(17103)] = 534635,
  [SMALL_STATE(17104)] = 534649,
  [SMALL_STATE(17105)] = 534665,
  [SMALL_STATE(17106)] = 534681,
  [SMALL_STATE(17107)] = 534697,
  [SMALL_STATE(17108)] = 534713,
  [SMALL_STATE(17109)] = 534727,
  [SMALL_STATE(17110)] = 534743,
  [SMALL_STATE(17111)] = 534759,
  [SMALL_STATE(17112)] = 534775,
  [SMALL_STATE(17113)] = 534791,
  [SMALL_STATE(17114)] = 534805,
  [SMALL_STATE(17115)] = 534821,
  [SMALL_STATE(17116)] = 534835,
  [SMALL_STATE(17117)] = 534851,
  [SMALL_STATE(17118)] = 534867,
  [SMALL_STATE(17119)] = 534883,
  [SMALL_STATE(17120)] = 534899,
  [SMALL_STATE(17121)] = 534915,
  [SMALL_STATE(17122)] = 534927,
  [SMALL_STATE(17123)] = 534943,
  [SMALL_STATE(17124)] = 534959,
  [SMALL_STATE(17125)] = 534971,
  [SMALL_STATE(17126)] = 534987,
  [SMALL_STATE(17127)] = 534999,
  [SMALL_STATE(17128)] = 535015,
  [SMALL_STATE(17129)] = 535029,
  [SMALL_STATE(17130)] = 535041,
  [SMALL_STATE(17131)] = 535055,
  [SMALL_STATE(17132)] = 535071,
  [SMALL_STATE(17133)] = 535083,
  [SMALL_STATE(17134)] = 535099,
  [SMALL_STATE(17135)] = 535115,
  [SMALL_STATE(17136)] = 535129,
  [SMALL_STATE(17137)] = 535145,
  [SMALL_STATE(17138)] = 535159,
  [SMALL_STATE(17139)] = 535175,
  [SMALL_STATE(17140)] = 535189,
  [SMALL_STATE(17141)] = 535205,
  [SMALL_STATE(17142)] = 535221,
  [SMALL_STATE(17143)] = 535235,
  [SMALL_STATE(17144)] = 535251,
  [SMALL_STATE(17145)] = 535265,
  [SMALL_STATE(17146)] = 535281,
  [SMALL_STATE(17147)] = 535297,
  [SMALL_STATE(17148)] = 535313,
  [SMALL_STATE(17149)] = 535329,
  [SMALL_STATE(17150)] = 535341,
  [SMALL_STATE(17151)] = 535357,
  [SMALL_STATE(17152)] = 535369,
  [SMALL_STATE(17153)] = 535385,
  [SMALL_STATE(17154)] = 535397,
  [SMALL_STATE(17155)] = 535413,
  [SMALL_STATE(17156)] = 535429,
  [SMALL_STATE(17157)] = 535445,
  [SMALL_STATE(17158)] = 535461,
  [SMALL_STATE(17159)] = 535475,
  [SMALL_STATE(17160)] = 535491,
  [SMALL_STATE(17161)] = 535505,
  [SMALL_STATE(17162)] = 535521,
  [SMALL_STATE(17163)] = 535537,
  [SMALL_STATE(17164)] = 535549,
  [SMALL_STATE(17165)] = 535561,
  [SMALL_STATE(17166)] = 535577,
  [SMALL_STATE(17167)] = 535593,
  [SMALL_STATE(17168)] = 535609,
  [SMALL_STATE(17169)] = 535621,
  [SMALL_STATE(17170)] = 535635,
  [SMALL_STATE(17171)] = 535651,
  [SMALL_STATE(17172)] = 535665,
  [SMALL_STATE(17173)] = 535681,
  [SMALL_STATE(17174)] = 535697,
  [SMALL_STATE(17175)] = 535713,
  [SMALL_STATE(17176)] = 535729,
  [SMALL_STATE(17177)] = 535745,
  [SMALL_STATE(17178)] = 535757,
  [SMALL_STATE(17179)] = 535769,
  [SMALL_STATE(17180)] = 535781,
  [SMALL_STATE(17181)] = 535793,
  [SMALL_STATE(17182)] = 535809,
  [SMALL_STATE(17183)] = 535825,
  [SMALL_STATE(17184)] = 535841,
  [SMALL_STATE(17185)] = 535857,
  [SMALL_STATE(17186)] = 535873,
  [SMALL_STATE(17187)] = 535889,
  [SMALL_STATE(17188)] = 535905,
  [SMALL_STATE(17189)] = 535919,
  [SMALL_STATE(17190)] = 535935,
  [SMALL_STATE(17191)] = 535951,
  [SMALL_STATE(17192)] = 535963,
  [SMALL_STATE(17193)] = 535979,
  [SMALL_STATE(17194)] = 535995,
  [SMALL_STATE(17195)] = 536011,
  [SMALL_STATE(17196)] = 536025,
  [SMALL_STATE(17197)] = 536039,
  [SMALL_STATE(17198)] = 536055,
  [SMALL_STATE(17199)] = 536071,
  [SMALL_STATE(17200)] = 536085,
  [SMALL_STATE(17201)] = 536097,
  [SMALL_STATE(17202)] = 536113,
  [SMALL_STATE(17203)] = 536129,
  [SMALL_STATE(17204)] = 536145,
  [SMALL_STATE(17205)] = 536157,
  [SMALL_STATE(17206)] = 536169,
  [SMALL_STATE(17207)] = 536185,
  [SMALL_STATE(17208)] = 536197,
  [SMALL_STATE(17209)] = 536211,
  [SMALL_STATE(17210)] = 536227,
  [SMALL_STATE(17211)] = 536243,
  [SMALL_STATE(17212)] = 536259,
  [SMALL_STATE(17213)] = 536271,
  [SMALL_STATE(17214)] = 536287,
  [SMALL_STATE(17215)] = 536303,
  [SMALL_STATE(17216)] = 536319,
  [SMALL_STATE(17217)] = 536335,
  [SMALL_STATE(17218)] = 536347,
  [SMALL_STATE(17219)] = 536361,
  [SMALL_STATE(17220)] = 536375,
  [SMALL_STATE(17221)] = 536391,
  [SMALL_STATE(17222)] = 536405,
  [SMALL_STATE(17223)] = 536419,
  [SMALL_STATE(17224)] = 536431,
  [SMALL_STATE(17225)] = 536445,
  [SMALL_STATE(17226)] = 536457,
  [SMALL_STATE(17227)] = 536473,
  [SMALL_STATE(17228)] = 536485,
  [SMALL_STATE(17229)] = 536501,
  [SMALL_STATE(17230)] = 536517,
  [SMALL_STATE(17231)] = 536533,
  [SMALL_STATE(17232)] = 536549,
  [SMALL_STATE(17233)] = 536565,
  [SMALL_STATE(17234)] = 536579,
  [SMALL_STATE(17235)] = 536595,
  [SMALL_STATE(17236)] = 536611,
  [SMALL_STATE(17237)] = 536625,
  [SMALL_STATE(17238)] = 536637,
  [SMALL_STATE(17239)] = 536653,
  [SMALL_STATE(17240)] = 536669,
  [SMALL_STATE(17241)] = 536685,
  [SMALL_STATE(17242)] = 536701,
  [SMALL_STATE(17243)] = 536717,
  [SMALL_STATE(17244)] = 536733,
  [SMALL_STATE(17245)] = 536747,
  [SMALL_STATE(17246)] = 536763,
  [SMALL_STATE(17247)] = 536779,
  [SMALL_STATE(17248)] = 536795,
  [SMALL_STATE(17249)] = 536811,
  [SMALL_STATE(17250)] = 536827,
  [SMALL_STATE(17251)] = 536841,
  [SMALL_STATE(17252)] = 536857,
  [SMALL_STATE(17253)] = 536871,
  [SMALL_STATE(17254)] = 536883,
  [SMALL_STATE(17255)] = 536899,
  [SMALL_STATE(17256)] = 536913,
  [SMALL_STATE(17257)] = 536929,
  [SMALL_STATE(17258)] = 536945,
  [SMALL_STATE(17259)] = 536961,
  [SMALL_STATE(17260)] = 536977,
  [SMALL_STATE(17261)] = 536993,
  [SMALL_STATE(17262)] = 537009,
  [SMALL_STATE(17263)] = 537025,
  [SMALL_STATE(17264)] = 537039,
  [SMALL_STATE(17265)] = 537053,
  [SMALL_STATE(17266)] = 537069,
  [SMALL_STATE(17267)] = 537085,
  [SMALL_STATE(17268)] = 537099,
  [SMALL_STATE(17269)] = 537113,
  [SMALL_STATE(17270)] = 537129,
  [SMALL_STATE(17271)] = 537145,
  [SMALL_STATE(17272)] = 537161,
  [SMALL_STATE(17273)] = 537175,
  [SMALL_STATE(17274)] = 537187,
  [SMALL_STATE(17275)] = 537203,
  [SMALL_STATE(17276)] = 537219,
  [SMALL_STATE(17277)] = 537235,
  [SMALL_STATE(17278)] = 537249,
  [SMALL_STATE(17279)] = 537265,
  [SMALL_STATE(17280)] = 537281,
  [SMALL_STATE(17281)] = 537297,
  [SMALL_STATE(17282)] = 537311,
  [SMALL_STATE(17283)] = 537327,
  [SMALL_STATE(17284)] = 537341,
  [SMALL_STATE(17285)] = 537357,
  [SMALL_STATE(17286)] = 537373,
  [SMALL_STATE(17287)] = 537389,
  [SMALL_STATE(17288)] = 537405,
  [SMALL_STATE(17289)] = 537419,
  [SMALL_STATE(17290)] = 537431,
  [SMALL_STATE(17291)] = 537445,
  [SMALL_STATE(17292)] = 537457,
  [SMALL_STATE(17293)] = 537471,
  [SMALL_STATE(17294)] = 537485,
  [SMALL_STATE(17295)] = 537501,
  [SMALL_STATE(17296)] = 537515,
  [SMALL_STATE(17297)] = 537531,
  [SMALL_STATE(17298)] = 537547,
  [SMALL_STATE(17299)] = 537563,
  [SMALL_STATE(17300)] = 537579,
  [SMALL_STATE(17301)] = 537595,
  [SMALL_STATE(17302)] = 537611,
  [SMALL_STATE(17303)] = 537627,
  [SMALL_STATE(17304)] = 537641,
  [SMALL_STATE(17305)] = 537657,
  [SMALL_STATE(17306)] = 537673,
  [SMALL_STATE(17307)] = 537689,
  [SMALL_STATE(17308)] = 537705,
  [SMALL_STATE(17309)] = 537721,
  [SMALL_STATE(17310)] = 537737,
  [SMALL_STATE(17311)] = 537753,
  [SMALL_STATE(17312)] = 537767,
  [SMALL_STATE(17313)] = 537781,
  [SMALL_STATE(17314)] = 537797,
  [SMALL_STATE(17315)] = 537811,
  [SMALL_STATE(17316)] = 537827,
  [SMALL_STATE(17317)] = 537843,
  [SMALL_STATE(17318)] = 537857,
  [SMALL_STATE(17319)] = 537873,
  [SMALL_STATE(17320)] = 537889,
  [SMALL_STATE(17321)] = 537905,
  [SMALL_STATE(17322)] = 537919,
  [SMALL_STATE(17323)] = 537935,
  [SMALL_STATE(17324)] = 537951,
  [SMALL_STATE(17325)] = 537967,
  [SMALL_STATE(17326)] = 537983,
  [SMALL_STATE(17327)] = 537997,
  [SMALL_STATE(17328)] = 538013,
  [SMALL_STATE(17329)] = 538029,
  [SMALL_STATE(17330)] = 538045,
  [SMALL_STATE(17331)] = 538059,
  [SMALL_STATE(17332)] = 538075,
  [SMALL_STATE(17333)] = 538091,
  [SMALL_STATE(17334)] = 538107,
  [SMALL_STATE(17335)] = 538121,
  [SMALL_STATE(17336)] = 538135,
  [SMALL_STATE(17337)] = 538149,
  [SMALL_STATE(17338)] = 538165,
  [SMALL_STATE(17339)] = 538181,
  [SMALL_STATE(17340)] = 538197,
  [SMALL_STATE(17341)] = 538213,
  [SMALL_STATE(17342)] = 538229,
  [SMALL_STATE(17343)] = 538245,
  [SMALL_STATE(17344)] = 538259,
  [SMALL_STATE(17345)] = 538275,
  [SMALL_STATE(17346)] = 538289,
  [SMALL_STATE(17347)] = 538305,
  [SMALL_STATE(17348)] = 538321,
  [SMALL_STATE(17349)] = 538337,
  [SMALL_STATE(17350)] = 538353,
  [SMALL_STATE(17351)] = 538369,
  [SMALL_STATE(17352)] = 538385,
  [SMALL_STATE(17353)] = 538401,
  [SMALL_STATE(17354)] = 538415,
  [SMALL_STATE(17355)] = 538431,
  [SMALL_STATE(17356)] = 538447,
  [SMALL_STATE(17357)] = 538463,
  [SMALL_STATE(17358)] = 538477,
  [SMALL_STATE(17359)] = 538493,
  [SMALL_STATE(17360)] = 538509,
  [SMALL_STATE(17361)] = 538523,
  [SMALL_STATE(17362)] = 538537,
  [SMALL_STATE(17363)] = 538553,
  [SMALL_STATE(17364)] = 538569,
  [SMALL_STATE(17365)] = 538585,
  [SMALL_STATE(17366)] = 538601,
  [SMALL_STATE(17367)] = 538617,
  [SMALL_STATE(17368)] = 538633,
  [SMALL_STATE(17369)] = 538649,
  [SMALL_STATE(17370)] = 538665,
  [SMALL_STATE(17371)] = 538679,
  [SMALL_STATE(17372)] = 538695,
  [SMALL_STATE(17373)] = 538711,
  [SMALL_STATE(17374)] = 538723,
  [SMALL_STATE(17375)] = 538737,
  [SMALL_STATE(17376)] = 538751,
  [SMALL_STATE(17377)] = 538765,
  [SMALL_STATE(17378)] = 538781,
  [SMALL_STATE(17379)] = 538797,
  [SMALL_STATE(17380)] = 538813,
  [SMALL_STATE(17381)] = 538825,
  [SMALL_STATE(17382)] = 538839,
  [SMALL_STATE(17383)] = 538851,
  [SMALL_STATE(17384)] = 538867,
  [SMALL_STATE(17385)] = 538881,
  [SMALL_STATE(17386)] = 538897,
  [SMALL_STATE(17387)] = 538913,
  [SMALL_STATE(17388)] = 538929,
  [SMALL_STATE(17389)] = 538943,
  [SMALL_STATE(17390)] = 538959,
  [SMALL_STATE(17391)] = 538975,
  [SMALL_STATE(17392)] = 538991,
  [SMALL_STATE(17393)] = 539007,
  [SMALL_STATE(17394)] = 539023,
  [SMALL_STATE(17395)] = 539039,
  [SMALL_STATE(17396)] = 539051,
  [SMALL_STATE(17397)] = 539067,
  [SMALL_STATE(17398)] = 539081,
  [SMALL_STATE(17399)] = 539097,
  [SMALL_STATE(17400)] = 539113,
  [SMALL_STATE(17401)] = 539129,
  [SMALL_STATE(17402)] = 539141,
  [SMALL_STATE(17403)] = 539157,
  [SMALL_STATE(17404)] = 539171,
  [SMALL_STATE(17405)] = 539187,
  [SMALL_STATE(17406)] = 539201,
  [SMALL_STATE(17407)] = 539217,
  [SMALL_STATE(17408)] = 539231,
  [SMALL_STATE(17409)] = 539245,
  [SMALL_STATE(17410)] = 539259,
  [SMALL_STATE(17411)] = 539275,
  [SMALL_STATE(17412)] = 539291,
  [SMALL_STATE(17413)] = 539303,
  [SMALL_STATE(17414)] = 539319,
  [SMALL_STATE(17415)] = 539335,
  [SMALL_STATE(17416)] = 539351,
  [SMALL_STATE(17417)] = 539367,
  [SMALL_STATE(17418)] = 539383,
  [SMALL_STATE(17419)] = 539397,
  [SMALL_STATE(17420)] = 539411,
  [SMALL_STATE(17421)] = 539427,
  [SMALL_STATE(17422)] = 539443,
  [SMALL_STATE(17423)] = 539457,
  [SMALL_STATE(17424)] = 539473,
  [SMALL_STATE(17425)] = 539489,
  [SMALL_STATE(17426)] = 539505,
  [SMALL_STATE(17427)] = 539521,
  [SMALL_STATE(17428)] = 539535,
  [SMALL_STATE(17429)] = 539551,
  [SMALL_STATE(17430)] = 539567,
  [SMALL_STATE(17431)] = 539583,
  [SMALL_STATE(17432)] = 539599,
  [SMALL_STATE(17433)] = 539615,
  [SMALL_STATE(17434)] = 539631,
  [SMALL_STATE(17435)] = 539647,
  [SMALL_STATE(17436)] = 539663,
  [SMALL_STATE(17437)] = 539677,
  [SMALL_STATE(17438)] = 539691,
  [SMALL_STATE(17439)] = 539705,
  [SMALL_STATE(17440)] = 539721,
  [SMALL_STATE(17441)] = 539737,
  [SMALL_STATE(17442)] = 539751,
  [SMALL_STATE(17443)] = 539765,
  [SMALL_STATE(17444)] = 539779,
  [SMALL_STATE(17445)] = 539795,
  [SMALL_STATE(17446)] = 539811,
  [SMALL_STATE(17447)] = 539825,
  [SMALL_STATE(17448)] = 539841,
  [SMALL_STATE(17449)] = 539857,
  [SMALL_STATE(17450)] = 539873,
  [SMALL_STATE(17451)] = 539887,
  [SMALL_STATE(17452)] = 539903,
  [SMALL_STATE(17453)] = 539919,
  [SMALL_STATE(17454)] = 539931,
  [SMALL_STATE(17455)] = 539947,
  [SMALL_STATE(17456)] = 539963,
  [SMALL_STATE(17457)] = 539979,
  [SMALL_STATE(17458)] = 539995,
  [SMALL_STATE(17459)] = 540011,
  [SMALL_STATE(17460)] = 540023,
  [SMALL_STATE(17461)] = 540037,
  [SMALL_STATE(17462)] = 540053,
  [SMALL_STATE(17463)] = 540069,
  [SMALL_STATE(17464)] = 540081,
  [SMALL_STATE(17465)] = 540097,
  [SMALL_STATE(17466)] = 540109,
  [SMALL_STATE(17467)] = 540125,
  [SMALL_STATE(17468)] = 540139,
  [SMALL_STATE(17469)] = 540153,
  [SMALL_STATE(17470)] = 540167,
  [SMALL_STATE(17471)] = 540181,
  [SMALL_STATE(17472)] = 540197,
  [SMALL_STATE(17473)] = 540209,
  [SMALL_STATE(17474)] = 540225,
  [SMALL_STATE(17475)] = 540241,
  [SMALL_STATE(17476)] = 540257,
  [SMALL_STATE(17477)] = 540273,
  [SMALL_STATE(17478)] = 540287,
  [SMALL_STATE(17479)] = 540299,
  [SMALL_STATE(17480)] = 540313,
  [SMALL_STATE(17481)] = 540329,
  [SMALL_STATE(17482)] = 540343,
  [SMALL_STATE(17483)] = 540359,
  [SMALL_STATE(17484)] = 540373,
  [SMALL_STATE(17485)] = 540387,
  [SMALL_STATE(17486)] = 540401,
  [SMALL_STATE(17487)] = 540417,
  [SMALL_STATE(17488)] = 540433,
  [SMALL_STATE(17489)] = 540449,
  [SMALL_STATE(17490)] = 540465,
  [SMALL_STATE(17491)] = 540481,
  [SMALL_STATE(17492)] = 540497,
  [SMALL_STATE(17493)] = 540513,
  [SMALL_STATE(17494)] = 540529,
  [SMALL_STATE(17495)] = 540545,
  [SMALL_STATE(17496)] = 540561,
  [SMALL_STATE(17497)] = 540577,
  [SMALL_STATE(17498)] = 540589,
  [SMALL_STATE(17499)] = 540603,
  [SMALL_STATE(17500)] = 540619,
  [SMALL_STATE(17501)] = 540633,
  [SMALL_STATE(17502)] = 540645,
  [SMALL_STATE(17503)] = 540659,
  [SMALL_STATE(17504)] = 540675,
  [SMALL_STATE(17505)] = 540691,
  [SMALL_STATE(17506)] = 540707,
  [SMALL_STATE(17507)] = 540723,
  [SMALL_STATE(17508)] = 540739,
  [SMALL_STATE(17509)] = 540753,
  [SMALL_STATE(17510)] = 540767,
  [SMALL_STATE(17511)] = 540783,
  [SMALL_STATE(17512)] = 540799,
  [SMALL_STATE(17513)] = 540813,
  [SMALL_STATE(17514)] = 540829,
  [SMALL_STATE(17515)] = 540845,
  [SMALL_STATE(17516)] = 540861,
  [SMALL_STATE(17517)] = 540877,
  [SMALL_STATE(17518)] = 540893,
  [SMALL_STATE(17519)] = 540909,
  [SMALL_STATE(17520)] = 540921,
  [SMALL_STATE(17521)] = 540937,
  [SMALL_STATE(17522)] = 540953,
  [SMALL_STATE(17523)] = 540967,
  [SMALL_STATE(17524)] = 540983,
  [SMALL_STATE(17525)] = 540999,
  [SMALL_STATE(17526)] = 541013,
  [SMALL_STATE(17527)] = 541029,
  [SMALL_STATE(17528)] = 541043,
  [SMALL_STATE(17529)] = 541059,
  [SMALL_STATE(17530)] = 541073,
  [SMALL_STATE(17531)] = 541089,
  [SMALL_STATE(17532)] = 541103,
  [SMALL_STATE(17533)] = 541119,
  [SMALL_STATE(17534)] = 541135,
  [SMALL_STATE(17535)] = 541151,
  [SMALL_STATE(17536)] = 541167,
  [SMALL_STATE(17537)] = 541183,
  [SMALL_STATE(17538)] = 541199,
  [SMALL_STATE(17539)] = 541215,
  [SMALL_STATE(17540)] = 541231,
  [SMALL_STATE(17541)] = 541245,
  [SMALL_STATE(17542)] = 541259,
  [SMALL_STATE(17543)] = 541275,
  [SMALL_STATE(17544)] = 541289,
  [SMALL_STATE(17545)] = 541305,
  [SMALL_STATE(17546)] = 541321,
  [SMALL_STATE(17547)] = 541335,
  [SMALL_STATE(17548)] = 541349,
  [SMALL_STATE(17549)] = 541365,
  [SMALL_STATE(17550)] = 541381,
  [SMALL_STATE(17551)] = 541397,
  [SMALL_STATE(17552)] = 541413,
  [SMALL_STATE(17553)] = 541429,
  [SMALL_STATE(17554)] = 541441,
  [SMALL_STATE(17555)] = 541457,
  [SMALL_STATE(17556)] = 541473,
  [SMALL_STATE(17557)] = 541489,
  [SMALL_STATE(17558)] = 541505,
  [SMALL_STATE(17559)] = 541521,
  [SMALL_STATE(17560)] = 541537,
  [SMALL_STATE(17561)] = 541551,
  [SMALL_STATE(17562)] = 541567,
  [SMALL_STATE(17563)] = 541581,
  [SMALL_STATE(17564)] = 541597,
  [SMALL_STATE(17565)] = 541611,
  [SMALL_STATE(17566)] = 541627,
  [SMALL_STATE(17567)] = 541639,
  [SMALL_STATE(17568)] = 541655,
  [SMALL_STATE(17569)] = 541667,
  [SMALL_STATE(17570)] = 541683,
  [SMALL_STATE(17571)] = 541699,
  [SMALL_STATE(17572)] = 541715,
  [SMALL_STATE(17573)] = 541729,
  [SMALL_STATE(17574)] = 541743,
  [SMALL_STATE(17575)] = 541757,
  [SMALL_STATE(17576)] = 541773,
  [SMALL_STATE(17577)] = 541789,
  [SMALL_STATE(17578)] = 541805,
  [SMALL_STATE(17579)] = 541821,
  [SMALL_STATE(17580)] = 541837,
  [SMALL_STATE(17581)] = 541853,
  [SMALL_STATE(17582)] = 541869,
  [SMALL_STATE(17583)] = 541885,
  [SMALL_STATE(17584)] = 541901,
  [SMALL_STATE(17585)] = 541915,
  [SMALL_STATE(17586)] = 541927,
  [SMALL_STATE(17587)] = 541943,
  [SMALL_STATE(17588)] = 541959,
  [SMALL_STATE(17589)] = 541975,
  [SMALL_STATE(17590)] = 541991,
  [SMALL_STATE(17591)] = 542003,
  [SMALL_STATE(17592)] = 542017,
  [SMALL_STATE(17593)] = 542031,
  [SMALL_STATE(17594)] = 542045,
  [SMALL_STATE(17595)] = 542057,
  [SMALL_STATE(17596)] = 542073,
  [SMALL_STATE(17597)] = 542085,
  [SMALL_STATE(17598)] = 542099,
  [SMALL_STATE(17599)] = 542115,
  [SMALL_STATE(17600)] = 542131,
  [SMALL_STATE(17601)] = 542147,
  [SMALL_STATE(17602)] = 542163,
  [SMALL_STATE(17603)] = 542179,
  [SMALL_STATE(17604)] = 542195,
  [SMALL_STATE(17605)] = 542211,
  [SMALL_STATE(17606)] = 542225,
  [SMALL_STATE(17607)] = 542241,
  [SMALL_STATE(17608)] = 542257,
  [SMALL_STATE(17609)] = 542273,
  [SMALL_STATE(17610)] = 542287,
  [SMALL_STATE(17611)] = 542303,
  [SMALL_STATE(17612)] = 542319,
  [SMALL_STATE(17613)] = 542335,
  [SMALL_STATE(17614)] = 542351,
  [SMALL_STATE(17615)] = 542367,
  [SMALL_STATE(17616)] = 542383,
  [SMALL_STATE(17617)] = 542397,
  [SMALL_STATE(17618)] = 542413,
  [SMALL_STATE(17619)] = 542427,
  [SMALL_STATE(17620)] = 542443,
  [SMALL_STATE(17621)] = 542459,
  [SMALL_STATE(17622)] = 542475,
  [SMALL_STATE(17623)] = 542489,
  [SMALL_STATE(17624)] = 542505,
  [SMALL_STATE(17625)] = 542519,
  [SMALL_STATE(17626)] = 542535,
  [SMALL_STATE(17627)] = 542551,
  [SMALL_STATE(17628)] = 542567,
  [SMALL_STATE(17629)] = 542583,
  [SMALL_STATE(17630)] = 542599,
  [SMALL_STATE(17631)] = 542615,
  [SMALL_STATE(17632)] = 542631,
  [SMALL_STATE(17633)] = 542647,
  [SMALL_STATE(17634)] = 542663,
  [SMALL_STATE(17635)] = 542677,
  [SMALL_STATE(17636)] = 542693,
  [SMALL_STATE(17637)] = 542707,
  [SMALL_STATE(17638)] = 542723,
  [SMALL_STATE(17639)] = 542739,
  [SMALL_STATE(17640)] = 542755,
  [SMALL_STATE(17641)] = 542769,
  [SMALL_STATE(17642)] = 542785,
  [SMALL_STATE(17643)] = 542801,
  [SMALL_STATE(17644)] = 542815,
  [SMALL_STATE(17645)] = 542831,
  [SMALL_STATE(17646)] = 542845,
  [SMALL_STATE(17647)] = 542861,
  [SMALL_STATE(17648)] = 542877,
  [SMALL_STATE(17649)] = 542893,
  [SMALL_STATE(17650)] = 542909,
  [SMALL_STATE(17651)] = 542925,
  [SMALL_STATE(17652)] = 542941,
  [SMALL_STATE(17653)] = 542957,
  [SMALL_STATE(17654)] = 542971,
  [SMALL_STATE(17655)] = 542985,
  [SMALL_STATE(17656)] = 542999,
  [SMALL_STATE(17657)] = 543011,
  [SMALL_STATE(17658)] = 543027,
  [SMALL_STATE(17659)] = 543043,
  [SMALL_STATE(17660)] = 543059,
  [SMALL_STATE(17661)] = 543075,
  [SMALL_STATE(17662)] = 543091,
  [SMALL_STATE(17663)] = 543107,
  [SMALL_STATE(17664)] = 543121,
  [SMALL_STATE(17665)] = 543137,
  [SMALL_STATE(17666)] = 543151,
  [SMALL_STATE(17667)] = 543167,
  [SMALL_STATE(17668)] = 543181,
  [SMALL_STATE(17669)] = 543197,
  [SMALL_STATE(17670)] = 543213,
  [SMALL_STATE(17671)] = 543229,
  [SMALL_STATE(17672)] = 543245,
  [SMALL_STATE(17673)] = 543261,
  [SMALL_STATE(17674)] = 543277,
  [SMALL_STATE(17675)] = 543291,
  [SMALL_STATE(17676)] = 543307,
  [SMALL_STATE(17677)] = 543323,
  [SMALL_STATE(17678)] = 543339,
  [SMALL_STATE(17679)] = 543353,
  [SMALL_STATE(17680)] = 543369,
  [SMALL_STATE(17681)] = 543385,
  [SMALL_STATE(17682)] = 543401,
  [SMALL_STATE(17683)] = 543415,
  [SMALL_STATE(17684)] = 543429,
  [SMALL_STATE(17685)] = 543443,
  [SMALL_STATE(17686)] = 543457,
  [SMALL_STATE(17687)] = 543471,
  [SMALL_STATE(17688)] = 543487,
  [SMALL_STATE(17689)] = 543499,
  [SMALL_STATE(17690)] = 543511,
  [SMALL_STATE(17691)] = 543523,
  [SMALL_STATE(17692)] = 543539,
  [SMALL_STATE(17693)] = 543555,
  [SMALL_STATE(17694)] = 543571,
  [SMALL_STATE(17695)] = 543587,
  [SMALL_STATE(17696)] = 543603,
  [SMALL_STATE(17697)] = 543619,
  [SMALL_STATE(17698)] = 543635,
  [SMALL_STATE(17699)] = 543649,
  [SMALL_STATE(17700)] = 543665,
  [SMALL_STATE(17701)] = 543679,
  [SMALL_STATE(17702)] = 543693,
  [SMALL_STATE(17703)] = 543709,
  [SMALL_STATE(17704)] = 543725,
  [SMALL_STATE(17705)] = 543741,
  [SMALL_STATE(17706)] = 543753,
  [SMALL_STATE(17707)] = 543769,
  [SMALL_STATE(17708)] = 543785,
  [SMALL_STATE(17709)] = 543799,
  [SMALL_STATE(17710)] = 543813,
  [SMALL_STATE(17711)] = 543829,
  [SMALL_STATE(17712)] = 543845,
  [SMALL_STATE(17713)] = 543861,
  [SMALL_STATE(17714)] = 543877,
  [SMALL_STATE(17715)] = 543893,
  [SMALL_STATE(17716)] = 543907,
  [SMALL_STATE(17717)] = 543921,
  [SMALL_STATE(17718)] = 543935,
  [SMALL_STATE(17719)] = 543951,
  [SMALL_STATE(17720)] = 543967,
  [SMALL_STATE(17721)] = 543981,
  [SMALL_STATE(17722)] = 543993,
  [SMALL_STATE(17723)] = 544009,
  [SMALL_STATE(17724)] = 544023,
  [SMALL_STATE(17725)] = 544039,
  [SMALL_STATE(17726)] = 544051,
  [SMALL_STATE(17727)] = 544065,
  [SMALL_STATE(17728)] = 544081,
  [SMALL_STATE(17729)] = 544097,
  [SMALL_STATE(17730)] = 544111,
  [SMALL_STATE(17731)] = 544127,
  [SMALL_STATE(17732)] = 544139,
  [SMALL_STATE(17733)] = 544155,
  [SMALL_STATE(17734)] = 544171,
  [SMALL_STATE(17735)] = 544187,
  [SMALL_STATE(17736)] = 544203,
  [SMALL_STATE(17737)] = 544219,
  [SMALL_STATE(17738)] = 544235,
  [SMALL_STATE(17739)] = 544249,
  [SMALL_STATE(17740)] = 544265,
  [SMALL_STATE(17741)] = 544281,
  [SMALL_STATE(17742)] = 544297,
  [SMALL_STATE(17743)] = 544313,
  [SMALL_STATE(17744)] = 544329,
  [SMALL_STATE(17745)] = 544343,
  [SMALL_STATE(17746)] = 544359,
  [SMALL_STATE(17747)] = 544373,
  [SMALL_STATE(17748)] = 544387,
  [SMALL_STATE(17749)] = 544401,
  [SMALL_STATE(17750)] = 544417,
  [SMALL_STATE(17751)] = 544433,
  [SMALL_STATE(17752)] = 544449,
  [SMALL_STATE(17753)] = 544461,
  [SMALL_STATE(17754)] = 544477,
  [SMALL_STATE(17755)] = 544489,
  [SMALL_STATE(17756)] = 544503,
  [SMALL_STATE(17757)] = 544519,
  [SMALL_STATE(17758)] = 544535,
  [SMALL_STATE(17759)] = 544551,
  [SMALL_STATE(17760)] = 544567,
  [SMALL_STATE(17761)] = 544581,
  [SMALL_STATE(17762)] = 544597,
  [SMALL_STATE(17763)] = 544611,
  [SMALL_STATE(17764)] = 544627,
  [SMALL_STATE(17765)] = 544641,
  [SMALL_STATE(17766)] = 544657,
  [SMALL_STATE(17767)] = 544673,
  [SMALL_STATE(17768)] = 544685,
  [SMALL_STATE(17769)] = 544701,
  [SMALL_STATE(17770)] = 544717,
  [SMALL_STATE(17771)] = 544731,
  [SMALL_STATE(17772)] = 544747,
  [SMALL_STATE(17773)] = 544763,
  [SMALL_STATE(17774)] = 544779,
  [SMALL_STATE(17775)] = 544795,
  [SMALL_STATE(17776)] = 544811,
  [SMALL_STATE(17777)] = 544827,
  [SMALL_STATE(17778)] = 544841,
  [SMALL_STATE(17779)] = 544857,
  [SMALL_STATE(17780)] = 544871,
  [SMALL_STATE(17781)] = 544887,
  [SMALL_STATE(17782)] = 544903,
  [SMALL_STATE(17783)] = 544915,
  [SMALL_STATE(17784)] = 544931,
  [SMALL_STATE(17785)] = 544947,
  [SMALL_STATE(17786)] = 544963,
  [SMALL_STATE(17787)] = 544977,
  [SMALL_STATE(17788)] = 544989,
  [SMALL_STATE(17789)] = 545005,
  [SMALL_STATE(17790)] = 545021,
  [SMALL_STATE(17791)] = 545035,
  [SMALL_STATE(17792)] = 545051,
  [SMALL_STATE(17793)] = 545067,
  [SMALL_STATE(17794)] = 545083,
  [SMALL_STATE(17795)] = 545095,
  [SMALL_STATE(17796)] = 545111,
  [SMALL_STATE(17797)] = 545127,
  [SMALL_STATE(17798)] = 545143,
  [SMALL_STATE(17799)] = 545159,
  [SMALL_STATE(17800)] = 545173,
  [SMALL_STATE(17801)] = 545187,
  [SMALL_STATE(17802)] = 545203,
  [SMALL_STATE(17803)] = 545219,
  [SMALL_STATE(17804)] = 545233,
  [SMALL_STATE(17805)] = 545249,
  [SMALL_STATE(17806)] = 545265,
  [SMALL_STATE(17807)] = 545281,
  [SMALL_STATE(17808)] = 545297,
  [SMALL_STATE(17809)] = 545313,
  [SMALL_STATE(17810)] = 545329,
  [SMALL_STATE(17811)] = 545345,
  [SMALL_STATE(17812)] = 545359,
  [SMALL_STATE(17813)] = 545375,
  [SMALL_STATE(17814)] = 545389,
  [SMALL_STATE(17815)] = 545402,
  [SMALL_STATE(17816)] = 545413,
  [SMALL_STATE(17817)] = 545424,
  [SMALL_STATE(17818)] = 545435,
  [SMALL_STATE(17819)] = 545446,
  [SMALL_STATE(17820)] = 545457,
  [SMALL_STATE(17821)] = 545468,
  [SMALL_STATE(17822)] = 545479,
  [SMALL_STATE(17823)] = 545490,
  [SMALL_STATE(17824)] = 545501,
  [SMALL_STATE(17825)] = 545512,
  [SMALL_STATE(17826)] = 545523,
  [SMALL_STATE(17827)] = 545534,
  [SMALL_STATE(17828)] = 545545,
  [SMALL_STATE(17829)] = 545556,
  [SMALL_STATE(17830)] = 545567,
  [SMALL_STATE(17831)] = 545578,
  [SMALL_STATE(17832)] = 545589,
  [SMALL_STATE(17833)] = 545600,
  [SMALL_STATE(17834)] = 545611,
  [SMALL_STATE(17835)] = 545622,
  [SMALL_STATE(17836)] = 545633,
  [SMALL_STATE(17837)] = 545644,
  [SMALL_STATE(17838)] = 545655,
  [SMALL_STATE(17839)] = 545666,
  [SMALL_STATE(17840)] = 545677,
  [SMALL_STATE(17841)] = 545688,
  [SMALL_STATE(17842)] = 545699,
  [SMALL_STATE(17843)] = 545710,
  [SMALL_STATE(17844)] = 545721,
  [SMALL_STATE(17845)] = 545732,
  [SMALL_STATE(17846)] = 545743,
  [SMALL_STATE(17847)] = 545754,
  [SMALL_STATE(17848)] = 545765,
  [SMALL_STATE(17849)] = 545776,
  [SMALL_STATE(17850)] = 545787,
  [SMALL_STATE(17851)] = 545798,
  [SMALL_STATE(17852)] = 545809,
  [SMALL_STATE(17853)] = 545820,
  [SMALL_STATE(17854)] = 545831,
  [SMALL_STATE(17855)] = 545844,
  [SMALL_STATE(17856)] = 545855,
  [SMALL_STATE(17857)] = 545866,
  [SMALL_STATE(17858)] = 545879,
  [SMALL_STATE(17859)] = 545890,
  [SMALL_STATE(17860)] = 545901,
  [SMALL_STATE(17861)] = 545914,
  [SMALL_STATE(17862)] = 545925,
  [SMALL_STATE(17863)] = 545936,
  [SMALL_STATE(17864)] = 545947,
  [SMALL_STATE(17865)] = 545958,
  [SMALL_STATE(17866)] = 545969,
  [SMALL_STATE(17867)] = 545980,
  [SMALL_STATE(17868)] = 545991,
  [SMALL_STATE(17869)] = 546002,
  [SMALL_STATE(17870)] = 546013,
  [SMALL_STATE(17871)] = 546024,
  [SMALL_STATE(17872)] = 546035,
  [SMALL_STATE(17873)] = 546046,
  [SMALL_STATE(17874)] = 546057,
  [SMALL_STATE(17875)] = 546068,
  [SMALL_STATE(17876)] = 546079,
  [SMALL_STATE(17877)] = 546090,
  [SMALL_STATE(17878)] = 546103,
  [SMALL_STATE(17879)] = 546116,
  [SMALL_STATE(17880)] = 546127,
  [SMALL_STATE(17881)] = 546140,
  [SMALL_STATE(17882)] = 546151,
  [SMALL_STATE(17883)] = 546162,
  [SMALL_STATE(17884)] = 546175,
  [SMALL_STATE(17885)] = 546186,
  [SMALL_STATE(17886)] = 546199,
  [SMALL_STATE(17887)] = 546210,
  [SMALL_STATE(17888)] = 546221,
  [SMALL_STATE(17889)] = 546234,
  [SMALL_STATE(17890)] = 546245,
  [SMALL_STATE(17891)] = 546256,
  [SMALL_STATE(17892)] = 546267,
  [SMALL_STATE(17893)] = 546278,
  [SMALL_STATE(17894)] = 546291,
  [SMALL_STATE(17895)] = 546304,
  [SMALL_STATE(17896)] = 546315,
  [SMALL_STATE(17897)] = 546326,
  [SMALL_STATE(17898)] = 546339,
  [SMALL_STATE(17899)] = 546350,
  [SMALL_STATE(17900)] = 546363,
  [SMALL_STATE(17901)] = 546376,
  [SMALL_STATE(17902)] = 546387,
  [SMALL_STATE(17903)] = 546398,
  [SMALL_STATE(17904)] = 546411,
  [SMALL_STATE(17905)] = 546424,
  [SMALL_STATE(17906)] = 546435,
  [SMALL_STATE(17907)] = 546446,
  [SMALL_STATE(17908)] = 546459,
  [SMALL_STATE(17909)] = 546472,
  [SMALL_STATE(17910)] = 546485,
  [SMALL_STATE(17911)] = 546496,
  [SMALL_STATE(17912)] = 546509,
  [SMALL_STATE(17913)] = 546522,
  [SMALL_STATE(17914)] = 546535,
  [SMALL_STATE(17915)] = 546548,
  [SMALL_STATE(17916)] = 546561,
  [SMALL_STATE(17917)] = 546572,
  [SMALL_STATE(17918)] = 546583,
  [SMALL_STATE(17919)] = 546594,
  [SMALL_STATE(17920)] = 546607,
  [SMALL_STATE(17921)] = 546618,
  [SMALL_STATE(17922)] = 546629,
  [SMALL_STATE(17923)] = 546642,
  [SMALL_STATE(17924)] = 546653,
  [SMALL_STATE(17925)] = 546664,
  [SMALL_STATE(17926)] = 546677,
  [SMALL_STATE(17927)] = 546688,
  [SMALL_STATE(17928)] = 546701,
  [SMALL_STATE(17929)] = 546714,
  [SMALL_STATE(17930)] = 546727,
  [SMALL_STATE(17931)] = 546738,
  [SMALL_STATE(17932)] = 546751,
  [SMALL_STATE(17933)] = 546764,
  [SMALL_STATE(17934)] = 546777,
  [SMALL_STATE(17935)] = 546788,
  [SMALL_STATE(17936)] = 546799,
  [SMALL_STATE(17937)] = 546810,
  [SMALL_STATE(17938)] = 546823,
  [SMALL_STATE(17939)] = 546834,
  [SMALL_STATE(17940)] = 546847,
  [SMALL_STATE(17941)] = 546858,
  [SMALL_STATE(17942)] = 546871,
  [SMALL_STATE(17943)] = 546882,
  [SMALL_STATE(17944)] = 546895,
  [SMALL_STATE(17945)] = 546908,
  [SMALL_STATE(17946)] = 546919,
  [SMALL_STATE(17947)] = 546930,
  [SMALL_STATE(17948)] = 546943,
  [SMALL_STATE(17949)] = 546956,
  [SMALL_STATE(17950)] = 546969,
  [SMALL_STATE(17951)] = 546980,
  [SMALL_STATE(17952)] = 546991,
  [SMALL_STATE(17953)] = 547004,
  [SMALL_STATE(17954)] = 547017,
  [SMALL_STATE(17955)] = 547028,
  [SMALL_STATE(17956)] = 547041,
  [SMALL_STATE(17957)] = 547054,
  [SMALL_STATE(17958)] = 547067,
  [SMALL_STATE(17959)] = 547078,
  [SMALL_STATE(17960)] = 547089,
  [SMALL_STATE(17961)] = 547102,
  [SMALL_STATE(17962)] = 547115,
  [SMALL_STATE(17963)] = 547128,
  [SMALL_STATE(17964)] = 547139,
  [SMALL_STATE(17965)] = 547152,
  [SMALL_STATE(17966)] = 547165,
  [SMALL_STATE(17967)] = 547178,
  [SMALL_STATE(17968)] = 547189,
  [SMALL_STATE(17969)] = 547202,
  [SMALL_STATE(17970)] = 547213,
  [SMALL_STATE(17971)] = 547226,
  [SMALL_STATE(17972)] = 547239,
  [SMALL_STATE(17973)] = 547252,
  [SMALL_STATE(17974)] = 547265,
  [SMALL_STATE(17975)] = 547276,
  [SMALL_STATE(17976)] = 547289,
  [SMALL_STATE(17977)] = 547302,
  [SMALL_STATE(17978)] = 547315,
  [SMALL_STATE(17979)] = 547326,
  [SMALL_STATE(17980)] = 547337,
  [SMALL_STATE(17981)] = 547350,
  [SMALL_STATE(17982)] = 547363,
  [SMALL_STATE(17983)] = 547374,
  [SMALL_STATE(17984)] = 547387,
  [SMALL_STATE(17985)] = 547400,
  [SMALL_STATE(17986)] = 547413,
  [SMALL_STATE(17987)] = 547426,
  [SMALL_STATE(17988)] = 547439,
  [SMALL_STATE(17989)] = 547450,
  [SMALL_STATE(17990)] = 547461,
  [SMALL_STATE(17991)] = 547474,
  [SMALL_STATE(17992)] = 547487,
  [SMALL_STATE(17993)] = 547498,
  [SMALL_STATE(17994)] = 547511,
  [SMALL_STATE(17995)] = 547524,
  [SMALL_STATE(17996)] = 547537,
  [SMALL_STATE(17997)] = 547550,
  [SMALL_STATE(17998)] = 547561,
  [SMALL_STATE(17999)] = 547572,
  [SMALL_STATE(18000)] = 547585,
  [SMALL_STATE(18001)] = 547598,
  [SMALL_STATE(18002)] = 547611,
  [SMALL_STATE(18003)] = 547624,
  [SMALL_STATE(18004)] = 547635,
  [SMALL_STATE(18005)] = 547648,
  [SMALL_STATE(18006)] = 547661,
  [SMALL_STATE(18007)] = 547674,
  [SMALL_STATE(18008)] = 547687,
  [SMALL_STATE(18009)] = 547700,
  [SMALL_STATE(18010)] = 547711,
  [SMALL_STATE(18011)] = 547724,
  [SMALL_STATE(18012)] = 547737,
  [SMALL_STATE(18013)] = 547750,
  [SMALL_STATE(18014)] = 547761,
  [SMALL_STATE(18015)] = 547774,
  [SMALL_STATE(18016)] = 547787,
  [SMALL_STATE(18017)] = 547800,
  [SMALL_STATE(18018)] = 547811,
  [SMALL_STATE(18019)] = 547824,
  [SMALL_STATE(18020)] = 547837,
  [SMALL_STATE(18021)] = 547850,
  [SMALL_STATE(18022)] = 547861,
  [SMALL_STATE(18023)] = 547874,
  [SMALL_STATE(18024)] = 547887,
  [SMALL_STATE(18025)] = 547900,
  [SMALL_STATE(18026)] = 547913,
  [SMALL_STATE(18027)] = 547926,
  [SMALL_STATE(18028)] = 547939,
  [SMALL_STATE(18029)] = 547950,
  [SMALL_STATE(18030)] = 547963,
  [SMALL_STATE(18031)] = 547976,
  [SMALL_STATE(18032)] = 547989,
  [SMALL_STATE(18033)] = 548000,
  [SMALL_STATE(18034)] = 548013,
  [SMALL_STATE(18035)] = 548026,
  [SMALL_STATE(18036)] = 548039,
  [SMALL_STATE(18037)] = 548052,
  [SMALL_STATE(18038)] = 548063,
  [SMALL_STATE(18039)] = 548074,
  [SMALL_STATE(18040)] = 548087,
  [SMALL_STATE(18041)] = 548100,
  [SMALL_STATE(18042)] = 548113,
  [SMALL_STATE(18043)] = 548124,
  [SMALL_STATE(18044)] = 548135,
  [SMALL_STATE(18045)] = 548146,
  [SMALL_STATE(18046)] = 548159,
  [SMALL_STATE(18047)] = 548170,
  [SMALL_STATE(18048)] = 548181,
  [SMALL_STATE(18049)] = 548192,
  [SMALL_STATE(18050)] = 548205,
  [SMALL_STATE(18051)] = 548216,
  [SMALL_STATE(18052)] = 548229,
  [SMALL_STATE(18053)] = 548240,
  [SMALL_STATE(18054)] = 548251,
  [SMALL_STATE(18055)] = 548262,
  [SMALL_STATE(18056)] = 548273,
  [SMALL_STATE(18057)] = 548286,
  [SMALL_STATE(18058)] = 548299,
  [SMALL_STATE(18059)] = 548310,
  [SMALL_STATE(18060)] = 548321,
  [SMALL_STATE(18061)] = 548332,
  [SMALL_STATE(18062)] = 548343,
  [SMALL_STATE(18063)] = 548356,
  [SMALL_STATE(18064)] = 548367,
  [SMALL_STATE(18065)] = 548380,
  [SMALL_STATE(18066)] = 548391,
  [SMALL_STATE(18067)] = 548402,
  [SMALL_STATE(18068)] = 548413,
  [SMALL_STATE(18069)] = 548424,
  [SMALL_STATE(18070)] = 548437,
  [SMALL_STATE(18071)] = 548450,
  [SMALL_STATE(18072)] = 548461,
  [SMALL_STATE(18073)] = 548472,
  [SMALL_STATE(18074)] = 548485,
  [SMALL_STATE(18075)] = 548496,
  [SMALL_STATE(18076)] = 548507,
  [SMALL_STATE(18077)] = 548518,
  [SMALL_STATE(18078)] = 548531,
  [SMALL_STATE(18079)] = 548542,
  [SMALL_STATE(18080)] = 548553,
  [SMALL_STATE(18081)] = 548564,
  [SMALL_STATE(18082)] = 548575,
  [SMALL_STATE(18083)] = 548586,
  [SMALL_STATE(18084)] = 548597,
  [SMALL_STATE(18085)] = 548608,
  [SMALL_STATE(18086)] = 548619,
  [SMALL_STATE(18087)] = 548630,
  [SMALL_STATE(18088)] = 548641,
  [SMALL_STATE(18089)] = 548654,
  [SMALL_STATE(18090)] = 548667,
  [SMALL_STATE(18091)] = 548678,
  [SMALL_STATE(18092)] = 548689,
  [SMALL_STATE(18093)] = 548700,
  [SMALL_STATE(18094)] = 548711,
  [SMALL_STATE(18095)] = 548722,
  [SMALL_STATE(18096)] = 548735,
  [SMALL_STATE(18097)] = 548746,
  [SMALL_STATE(18098)] = 548759,
  [SMALL_STATE(18099)] = 548772,
  [SMALL_STATE(18100)] = 548783,
  [SMALL_STATE(18101)] = 548796,
  [SMALL_STATE(18102)] = 548807,
  [SMALL_STATE(18103)] = 548820,
  [SMALL_STATE(18104)] = 548833,
  [SMALL_STATE(18105)] = 548844,
  [SMALL_STATE(18106)] = 548857,
  [SMALL_STATE(18107)] = 548868,
  [SMALL_STATE(18108)] = 548881,
  [SMALL_STATE(18109)] = 548892,
  [SMALL_STATE(18110)] = 548903,
  [SMALL_STATE(18111)] = 548914,
  [SMALL_STATE(18112)] = 548927,
  [SMALL_STATE(18113)] = 548940,
  [SMALL_STATE(18114)] = 548951,
  [SMALL_STATE(18115)] = 548962,
  [SMALL_STATE(18116)] = 548975,
  [SMALL_STATE(18117)] = 548988,
  [SMALL_STATE(18118)] = 548999,
  [SMALL_STATE(18119)] = 549010,
  [SMALL_STATE(18120)] = 549021,
  [SMALL_STATE(18121)] = 549034,
  [SMALL_STATE(18122)] = 549045,
  [SMALL_STATE(18123)] = 549058,
  [SMALL_STATE(18124)] = 549069,
  [SMALL_STATE(18125)] = 549080,
  [SMALL_STATE(18126)] = 549091,
  [SMALL_STATE(18127)] = 549104,
  [SMALL_STATE(18128)] = 549115,
  [SMALL_STATE(18129)] = 549128,
  [SMALL_STATE(18130)] = 549139,
  [SMALL_STATE(18131)] = 549150,
  [SMALL_STATE(18132)] = 549161,
  [SMALL_STATE(18133)] = 549172,
  [SMALL_STATE(18134)] = 549183,
  [SMALL_STATE(18135)] = 549194,
  [SMALL_STATE(18136)] = 549207,
  [SMALL_STATE(18137)] = 549218,
  [SMALL_STATE(18138)] = 549229,
  [SMALL_STATE(18139)] = 549240,
  [SMALL_STATE(18140)] = 549251,
  [SMALL_STATE(18141)] = 549264,
  [SMALL_STATE(18142)] = 549275,
  [SMALL_STATE(18143)] = 549288,
  [SMALL_STATE(18144)] = 549299,
  [SMALL_STATE(18145)] = 549310,
  [SMALL_STATE(18146)] = 549321,
  [SMALL_STATE(18147)] = 549334,
  [SMALL_STATE(18148)] = 549345,
  [SMALL_STATE(18149)] = 549356,
  [SMALL_STATE(18150)] = 549369,
  [SMALL_STATE(18151)] = 549380,
  [SMALL_STATE(18152)] = 549393,
  [SMALL_STATE(18153)] = 549406,
  [SMALL_STATE(18154)] = 549417,
  [SMALL_STATE(18155)] = 549428,
  [SMALL_STATE(18156)] = 549441,
  [SMALL_STATE(18157)] = 549454,
  [SMALL_STATE(18158)] = 549467,
  [SMALL_STATE(18159)] = 549478,
  [SMALL_STATE(18160)] = 549489,
  [SMALL_STATE(18161)] = 549500,
  [SMALL_STATE(18162)] = 549511,
  [SMALL_STATE(18163)] = 549522,
  [SMALL_STATE(18164)] = 549533,
  [SMALL_STATE(18165)] = 549546,
  [SMALL_STATE(18166)] = 549557,
  [SMALL_STATE(18167)] = 549568,
  [SMALL_STATE(18168)] = 549581,
  [SMALL_STATE(18169)] = 549594,
  [SMALL_STATE(18170)] = 549605,
  [SMALL_STATE(18171)] = 549616,
  [SMALL_STATE(18172)] = 549627,
  [SMALL_STATE(18173)] = 549638,
  [SMALL_STATE(18174)] = 549649,
  [SMALL_STATE(18175)] = 549660,
  [SMALL_STATE(18176)] = 549673,
  [SMALL_STATE(18177)] = 549686,
  [SMALL_STATE(18178)] = 549697,
  [SMALL_STATE(18179)] = 549708,
  [SMALL_STATE(18180)] = 549719,
  [SMALL_STATE(18181)] = 549732,
  [SMALL_STATE(18182)] = 549743,
  [SMALL_STATE(18183)] = 549756,
  [SMALL_STATE(18184)] = 549769,
  [SMALL_STATE(18185)] = 549780,
  [SMALL_STATE(18186)] = 549791,
  [SMALL_STATE(18187)] = 549802,
  [SMALL_STATE(18188)] = 549815,
  [SMALL_STATE(18189)] = 549828,
  [SMALL_STATE(18190)] = 549841,
  [SMALL_STATE(18191)] = 549852,
  [SMALL_STATE(18192)] = 549863,
  [SMALL_STATE(18193)] = 549874,
  [SMALL_STATE(18194)] = 549885,
  [SMALL_STATE(18195)] = 549896,
  [SMALL_STATE(18196)] = 549907,
  [SMALL_STATE(18197)] = 549920,
  [SMALL_STATE(18198)] = 549931,
  [SMALL_STATE(18199)] = 549942,
  [SMALL_STATE(18200)] = 549955,
  [SMALL_STATE(18201)] = 549966,
  [SMALL_STATE(18202)] = 549977,
  [SMALL_STATE(18203)] = 549988,
  [SMALL_STATE(18204)] = 550001,
  [SMALL_STATE(18205)] = 550014,
  [SMALL_STATE(18206)] = 550027,
  [SMALL_STATE(18207)] = 550038,
  [SMALL_STATE(18208)] = 550051,
  [SMALL_STATE(18209)] = 550062,
  [SMALL_STATE(18210)] = 550073,
  [SMALL_STATE(18211)] = 550084,
  [SMALL_STATE(18212)] = 550095,
  [SMALL_STATE(18213)] = 550108,
  [SMALL_STATE(18214)] = 550121,
  [SMALL_STATE(18215)] = 550132,
  [SMALL_STATE(18216)] = 550143,
  [SMALL_STATE(18217)] = 550154,
  [SMALL_STATE(18218)] = 550167,
  [SMALL_STATE(18219)] = 550178,
  [SMALL_STATE(18220)] = 550189,
  [SMALL_STATE(18221)] = 550200,
  [SMALL_STATE(18222)] = 550213,
  [SMALL_STATE(18223)] = 550224,
  [SMALL_STATE(18224)] = 550237,
  [SMALL_STATE(18225)] = 550248,
  [SMALL_STATE(18226)] = 550261,
  [SMALL_STATE(18227)] = 550272,
  [SMALL_STATE(18228)] = 550285,
  [SMALL_STATE(18229)] = 550296,
  [SMALL_STATE(18230)] = 550309,
  [SMALL_STATE(18231)] = 550322,
  [SMALL_STATE(18232)] = 550335,
  [SMALL_STATE(18233)] = 550346,
  [SMALL_STATE(18234)] = 550357,
  [SMALL_STATE(18235)] = 550370,
  [SMALL_STATE(18236)] = 550381,
  [SMALL_STATE(18237)] = 550392,
  [SMALL_STATE(18238)] = 550403,
  [SMALL_STATE(18239)] = 550416,
  [SMALL_STATE(18240)] = 550429,
  [SMALL_STATE(18241)] = 550442,
  [SMALL_STATE(18242)] = 550453,
  [SMALL_STATE(18243)] = 550466,
  [SMALL_STATE(18244)] = 550479,
  [SMALL_STATE(18245)] = 550490,
  [SMALL_STATE(18246)] = 550503,
  [SMALL_STATE(18247)] = 550514,
  [SMALL_STATE(18248)] = 550525,
  [SMALL_STATE(18249)] = 550536,
  [SMALL_STATE(18250)] = 550547,
  [SMALL_STATE(18251)] = 550558,
  [SMALL_STATE(18252)] = 550571,
  [SMALL_STATE(18253)] = 550584,
  [SMALL_STATE(18254)] = 550595,
  [SMALL_STATE(18255)] = 550608,
  [SMALL_STATE(18256)] = 550621,
  [SMALL_STATE(18257)] = 550632,
  [SMALL_STATE(18258)] = 550645,
  [SMALL_STATE(18259)] = 550656,
  [SMALL_STATE(18260)] = 550667,
  [SMALL_STATE(18261)] = 550678,
  [SMALL_STATE(18262)] = 550691,
  [SMALL_STATE(18263)] = 550704,
  [SMALL_STATE(18264)] = 550717,
  [SMALL_STATE(18265)] = 550728,
  [SMALL_STATE(18266)] = 550739,
  [SMALL_STATE(18267)] = 550750,
  [SMALL_STATE(18268)] = 550763,
  [SMALL_STATE(18269)] = 550776,
  [SMALL_STATE(18270)] = 550787,
  [SMALL_STATE(18271)] = 550798,
  [SMALL_STATE(18272)] = 550811,
  [SMALL_STATE(18273)] = 550822,
  [SMALL_STATE(18274)] = 550833,
  [SMALL_STATE(18275)] = 550846,
  [SMALL_STATE(18276)] = 550859,
  [SMALL_STATE(18277)] = 550872,
  [SMALL_STATE(18278)] = 550883,
  [SMALL_STATE(18279)] = 550894,
  [SMALL_STATE(18280)] = 550905,
  [SMALL_STATE(18281)] = 550918,
  [SMALL_STATE(18282)] = 550931,
  [SMALL_STATE(18283)] = 550942,
  [SMALL_STATE(18284)] = 550953,
  [SMALL_STATE(18285)] = 550964,
  [SMALL_STATE(18286)] = 550977,
  [SMALL_STATE(18287)] = 550988,
  [SMALL_STATE(18288)] = 551001,
  [SMALL_STATE(18289)] = 551014,
  [SMALL_STATE(18290)] = 551025,
  [SMALL_STATE(18291)] = 551038,
  [SMALL_STATE(18292)] = 551049,
  [SMALL_STATE(18293)] = 551062,
  [SMALL_STATE(18294)] = 551073,
  [SMALL_STATE(18295)] = 551084,
  [SMALL_STATE(18296)] = 551097,
  [SMALL_STATE(18297)] = 551108,
  [SMALL_STATE(18298)] = 551119,
  [SMALL_STATE(18299)] = 551132,
  [SMALL_STATE(18300)] = 551143,
  [SMALL_STATE(18301)] = 551156,
  [SMALL_STATE(18302)] = 551167,
  [SMALL_STATE(18303)] = 551178,
  [SMALL_STATE(18304)] = 551191,
  [SMALL_STATE(18305)] = 551204,
  [SMALL_STATE(18306)] = 551217,
  [SMALL_STATE(18307)] = 551228,
  [SMALL_STATE(18308)] = 551239,
  [SMALL_STATE(18309)] = 551252,
  [SMALL_STATE(18310)] = 551265,
  [SMALL_STATE(18311)] = 551278,
  [SMALL_STATE(18312)] = 551289,
  [SMALL_STATE(18313)] = 551300,
  [SMALL_STATE(18314)] = 551311,
  [SMALL_STATE(18315)] = 551324,
  [SMALL_STATE(18316)] = 551335,
  [SMALL_STATE(18317)] = 551346,
  [SMALL_STATE(18318)] = 551359,
  [SMALL_STATE(18319)] = 551372,
  [SMALL_STATE(18320)] = 551385,
  [SMALL_STATE(18321)] = 551396,
  [SMALL_STATE(18322)] = 551409,
  [SMALL_STATE(18323)] = 551420,
  [SMALL_STATE(18324)] = 551431,
  [SMALL_STATE(18325)] = 551444,
  [SMALL_STATE(18326)] = 551457,
  [SMALL_STATE(18327)] = 551468,
  [SMALL_STATE(18328)] = 551481,
  [SMALL_STATE(18329)] = 551492,
  [SMALL_STATE(18330)] = 551503,
  [SMALL_STATE(18331)] = 551516,
  [SMALL_STATE(18332)] = 551527,
  [SMALL_STATE(18333)] = 551540,
  [SMALL_STATE(18334)] = 551551,
  [SMALL_STATE(18335)] = 551562,
  [SMALL_STATE(18336)] = 551573,
  [SMALL_STATE(18337)] = 551584,
  [SMALL_STATE(18338)] = 551595,
  [SMALL_STATE(18339)] = 551606,
  [SMALL_STATE(18340)] = 551617,
  [SMALL_STATE(18341)] = 551628,
  [SMALL_STATE(18342)] = 551641,
  [SMALL_STATE(18343)] = 551652,
  [SMALL_STATE(18344)] = 551663,
  [SMALL_STATE(18345)] = 551676,
  [SMALL_STATE(18346)] = 551687,
  [SMALL_STATE(18347)] = 551698,
  [SMALL_STATE(18348)] = 551709,
  [SMALL_STATE(18349)] = 551722,
  [SMALL_STATE(18350)] = 551733,
  [SMALL_STATE(18351)] = 551746,
  [SMALL_STATE(18352)] = 551757,
  [SMALL_STATE(18353)] = 551770,
  [SMALL_STATE(18354)] = 551781,
  [SMALL_STATE(18355)] = 551794,
  [SMALL_STATE(18356)] = 551805,
  [SMALL_STATE(18357)] = 551816,
  [SMALL_STATE(18358)] = 551827,
  [SMALL_STATE(18359)] = 551840,
  [SMALL_STATE(18360)] = 551851,
  [SMALL_STATE(18361)] = 551862,
  [SMALL_STATE(18362)] = 551873,
  [SMALL_STATE(18363)] = 551884,
  [SMALL_STATE(18364)] = 551895,
  [SMALL_STATE(18365)] = 551908,
  [SMALL_STATE(18366)] = 551919,
  [SMALL_STATE(18367)] = 551932,
  [SMALL_STATE(18368)] = 551945,
  [SMALL_STATE(18369)] = 551956,
  [SMALL_STATE(18370)] = 551967,
  [SMALL_STATE(18371)] = 551978,
  [SMALL_STATE(18372)] = 551991,
  [SMALL_STATE(18373)] = 552002,
  [SMALL_STATE(18374)] = 552015,
  [SMALL_STATE(18375)] = 552028,
  [SMALL_STATE(18376)] = 552041,
  [SMALL_STATE(18377)] = 552052,
  [SMALL_STATE(18378)] = 552065,
  [SMALL_STATE(18379)] = 552076,
  [SMALL_STATE(18380)] = 552087,
  [SMALL_STATE(18381)] = 552098,
  [SMALL_STATE(18382)] = 552111,
  [SMALL_STATE(18383)] = 552124,
  [SMALL_STATE(18384)] = 552137,
  [SMALL_STATE(18385)] = 552148,
  [SMALL_STATE(18386)] = 552161,
  [SMALL_STATE(18387)] = 552174,
  [SMALL_STATE(18388)] = 552187,
  [SMALL_STATE(18389)] = 552198,
  [SMALL_STATE(18390)] = 552209,
  [SMALL_STATE(18391)] = 552222,
  [SMALL_STATE(18392)] = 552233,
  [SMALL_STATE(18393)] = 552246,
  [SMALL_STATE(18394)] = 552257,
  [SMALL_STATE(18395)] = 552268,
  [SMALL_STATE(18396)] = 552279,
  [SMALL_STATE(18397)] = 552290,
  [SMALL_STATE(18398)] = 552303,
  [SMALL_STATE(18399)] = 552314,
  [SMALL_STATE(18400)] = 552327,
  [SMALL_STATE(18401)] = 552340,
  [SMALL_STATE(18402)] = 552353,
  [SMALL_STATE(18403)] = 552364,
  [SMALL_STATE(18404)] = 552375,
  [SMALL_STATE(18405)] = 552388,
  [SMALL_STATE(18406)] = 552399,
  [SMALL_STATE(18407)] = 552412,
  [SMALL_STATE(18408)] = 552423,
  [SMALL_STATE(18409)] = 552434,
  [SMALL_STATE(18410)] = 552445,
  [SMALL_STATE(18411)] = 552456,
  [SMALL_STATE(18412)] = 552467,
  [SMALL_STATE(18413)] = 552480,
  [SMALL_STATE(18414)] = 552493,
  [SMALL_STATE(18415)] = 552504,
  [SMALL_STATE(18416)] = 552515,
  [SMALL_STATE(18417)] = 552526,
  [SMALL_STATE(18418)] = 552539,
  [SMALL_STATE(18419)] = 552552,
  [SMALL_STATE(18420)] = 552563,
  [SMALL_STATE(18421)] = 552574,
  [SMALL_STATE(18422)] = 552585,
  [SMALL_STATE(18423)] = 552598,
  [SMALL_STATE(18424)] = 552609,
  [SMALL_STATE(18425)] = 552622,
  [SMALL_STATE(18426)] = 552633,
  [SMALL_STATE(18427)] = 552646,
  [SMALL_STATE(18428)] = 552657,
  [SMALL_STATE(18429)] = 552670,
  [SMALL_STATE(18430)] = 552681,
  [SMALL_STATE(18431)] = 552692,
  [SMALL_STATE(18432)] = 552705,
  [SMALL_STATE(18433)] = 552718,
  [SMALL_STATE(18434)] = 552729,
  [SMALL_STATE(18435)] = 552742,
  [SMALL_STATE(18436)] = 552755,
  [SMALL_STATE(18437)] = 552768,
  [SMALL_STATE(18438)] = 552781,
  [SMALL_STATE(18439)] = 552792,
  [SMALL_STATE(18440)] = 552803,
  [SMALL_STATE(18441)] = 552814,
  [SMALL_STATE(18442)] = 552825,
  [SMALL_STATE(18443)] = 552838,
  [SMALL_STATE(18444)] = 552851,
  [SMALL_STATE(18445)] = 552862,
  [SMALL_STATE(18446)] = 552875,
  [SMALL_STATE(18447)] = 552886,
  [SMALL_STATE(18448)] = 552897,
  [SMALL_STATE(18449)] = 552908,
  [SMALL_STATE(18450)] = 552921,
  [SMALL_STATE(18451)] = 552932,
  [SMALL_STATE(18452)] = 552945,
  [SMALL_STATE(18453)] = 552956,
  [SMALL_STATE(18454)] = 552967,
  [SMALL_STATE(18455)] = 552980,
  [SMALL_STATE(18456)] = 552991,
  [SMALL_STATE(18457)] = 553002,
  [SMALL_STATE(18458)] = 553013,
  [SMALL_STATE(18459)] = 553024,
  [SMALL_STATE(18460)] = 553035,
  [SMALL_STATE(18461)] = 553046,
  [SMALL_STATE(18462)] = 553057,
  [SMALL_STATE(18463)] = 553068,
  [SMALL_STATE(18464)] = 553081,
  [SMALL_STATE(18465)] = 553092,
  [SMALL_STATE(18466)] = 553105,
  [SMALL_STATE(18467)] = 553118,
  [SMALL_STATE(18468)] = 553129,
  [SMALL_STATE(18469)] = 553140,
  [SMALL_STATE(18470)] = 553151,
  [SMALL_STATE(18471)] = 553164,
  [SMALL_STATE(18472)] = 553177,
  [SMALL_STATE(18473)] = 553190,
  [SMALL_STATE(18474)] = 553201,
  [SMALL_STATE(18475)] = 553212,
  [SMALL_STATE(18476)] = 553223,
  [SMALL_STATE(18477)] = 553234,
  [SMALL_STATE(18478)] = 553247,
  [SMALL_STATE(18479)] = 553260,
  [SMALL_STATE(18480)] = 553271,
  [SMALL_STATE(18481)] = 553284,
  [SMALL_STATE(18482)] = 553295,
  [SMALL_STATE(18483)] = 553306,
  [SMALL_STATE(18484)] = 553319,
  [SMALL_STATE(18485)] = 553330,
  [SMALL_STATE(18486)] = 553341,
  [SMALL_STATE(18487)] = 553354,
  [SMALL_STATE(18488)] = 553367,
  [SMALL_STATE(18489)] = 553380,
  [SMALL_STATE(18490)] = 553391,
  [SMALL_STATE(18491)] = 553404,
  [SMALL_STATE(18492)] = 553417,
  [SMALL_STATE(18493)] = 553430,
  [SMALL_STATE(18494)] = 553441,
  [SMALL_STATE(18495)] = 553452,
  [SMALL_STATE(18496)] = 553463,
  [SMALL_STATE(18497)] = 553474,
  [SMALL_STATE(18498)] = 553485,
  [SMALL_STATE(18499)] = 553498,
  [SMALL_STATE(18500)] = 553511,
  [SMALL_STATE(18501)] = 553522,
  [SMALL_STATE(18502)] = 553535,
  [SMALL_STATE(18503)] = 553546,
  [SMALL_STATE(18504)] = 553559,
  [SMALL_STATE(18505)] = 553570,
  [SMALL_STATE(18506)] = 553583,
  [SMALL_STATE(18507)] = 553594,
  [SMALL_STATE(18508)] = 553605,
  [SMALL_STATE(18509)] = 553618,
  [SMALL_STATE(18510)] = 553629,
  [SMALL_STATE(18511)] = 553640,
  [SMALL_STATE(18512)] = 553653,
  [SMALL_STATE(18513)] = 553664,
  [SMALL_STATE(18514)] = 553675,
  [SMALL_STATE(18515)] = 553686,
  [SMALL_STATE(18516)] = 553697,
  [SMALL_STATE(18517)] = 553708,
  [SMALL_STATE(18518)] = 553719,
  [SMALL_STATE(18519)] = 553732,
  [SMALL_STATE(18520)] = 553745,
  [SMALL_STATE(18521)] = 553758,
  [SMALL_STATE(18522)] = 553769,
  [SMALL_STATE(18523)] = 553780,
  [SMALL_STATE(18524)] = 553791,
  [SMALL_STATE(18525)] = 553804,
  [SMALL_STATE(18526)] = 553815,
  [SMALL_STATE(18527)] = 553826,
  [SMALL_STATE(18528)] = 553839,
  [SMALL_STATE(18529)] = 553850,
  [SMALL_STATE(18530)] = 553863,
  [SMALL_STATE(18531)] = 553874,
  [SMALL_STATE(18532)] = 553885,
  [SMALL_STATE(18533)] = 553898,
  [SMALL_STATE(18534)] = 553909,
  [SMALL_STATE(18535)] = 553920,
  [SMALL_STATE(18536)] = 553933,
  [SMALL_STATE(18537)] = 553946,
  [SMALL_STATE(18538)] = 553957,
  [SMALL_STATE(18539)] = 553968,
  [SMALL_STATE(18540)] = 553979,
  [SMALL_STATE(18541)] = 553992,
  [SMALL_STATE(18542)] = 554003,
  [SMALL_STATE(18543)] = 554016,
  [SMALL_STATE(18544)] = 554027,
  [SMALL_STATE(18545)] = 554038,
  [SMALL_STATE(18546)] = 554049,
  [SMALL_STATE(18547)] = 554060,
  [SMALL_STATE(18548)] = 554071,
  [SMALL_STATE(18549)] = 554084,
  [SMALL_STATE(18550)] = 554097,
  [SMALL_STATE(18551)] = 554108,
  [SMALL_STATE(18552)] = 554121,
  [SMALL_STATE(18553)] = 554134,
  [SMALL_STATE(18554)] = 554147,
  [SMALL_STATE(18555)] = 554158,
  [SMALL_STATE(18556)] = 554171,
  [SMALL_STATE(18557)] = 554182,
  [SMALL_STATE(18558)] = 554193,
  [SMALL_STATE(18559)] = 554204,
  [SMALL_STATE(18560)] = 554215,
  [SMALL_STATE(18561)] = 554226,
  [SMALL_STATE(18562)] = 554239,
  [SMALL_STATE(18563)] = 554250,
  [SMALL_STATE(18564)] = 554263,
  [SMALL_STATE(18565)] = 554276,
  [SMALL_STATE(18566)] = 554287,
  [SMALL_STATE(18567)] = 554298,
  [SMALL_STATE(18568)] = 554309,
  [SMALL_STATE(18569)] = 554320,
  [SMALL_STATE(18570)] = 554331,
  [SMALL_STATE(18571)] = 554342,
  [SMALL_STATE(18572)] = 554353,
  [SMALL_STATE(18573)] = 554364,
  [SMALL_STATE(18574)] = 554375,
  [SMALL_STATE(18575)] = 554386,
  [SMALL_STATE(18576)] = 554397,
  [SMALL_STATE(18577)] = 554410,
  [SMALL_STATE(18578)] = 554423,
  [SMALL_STATE(18579)] = 554434,
  [SMALL_STATE(18580)] = 554445,
  [SMALL_STATE(18581)] = 554458,
  [SMALL_STATE(18582)] = 554469,
  [SMALL_STATE(18583)] = 554482,
  [SMALL_STATE(18584)] = 554493,
  [SMALL_STATE(18585)] = 554504,
  [SMALL_STATE(18586)] = 554515,
  [SMALL_STATE(18587)] = 554526,
  [SMALL_STATE(18588)] = 554537,
  [SMALL_STATE(18589)] = 554548,
  [SMALL_STATE(18590)] = 554561,
  [SMALL_STATE(18591)] = 554574,
  [SMALL_STATE(18592)] = 554585,
  [SMALL_STATE(18593)] = 554596,
  [SMALL_STATE(18594)] = 554607,
  [SMALL_STATE(18595)] = 554620,
  [SMALL_STATE(18596)] = 554633,
  [SMALL_STATE(18597)] = 554644,
  [SMALL_STATE(18598)] = 554655,
  [SMALL_STATE(18599)] = 554668,
  [SMALL_STATE(18600)] = 554681,
  [SMALL_STATE(18601)] = 554692,
  [SMALL_STATE(18602)] = 554703,
  [SMALL_STATE(18603)] = 554716,
  [SMALL_STATE(18604)] = 554727,
  [SMALL_STATE(18605)] = 554738,
  [SMALL_STATE(18606)] = 554749,
  [SMALL_STATE(18607)] = 554760,
  [SMALL_STATE(18608)] = 554771,
  [SMALL_STATE(18609)] = 554782,
  [SMALL_STATE(18610)] = 554793,
  [SMALL_STATE(18611)] = 554804,
  [SMALL_STATE(18612)] = 554815,
  [SMALL_STATE(18613)] = 554826,
  [SMALL_STATE(18614)] = 554837,
  [SMALL_STATE(18615)] = 554848,
  [SMALL_STATE(18616)] = 554861,
  [SMALL_STATE(18617)] = 554874,
  [SMALL_STATE(18618)] = 554885,
  [SMALL_STATE(18619)] = 554896,
  [SMALL_STATE(18620)] = 554909,
  [SMALL_STATE(18621)] = 554920,
  [SMALL_STATE(18622)] = 554931,
  [SMALL_STATE(18623)] = 554942,
  [SMALL_STATE(18624)] = 554953,
  [SMALL_STATE(18625)] = 554964,
  [SMALL_STATE(18626)] = 554975,
  [SMALL_STATE(18627)] = 554986,
  [SMALL_STATE(18628)] = 554997,
  [SMALL_STATE(18629)] = 555010,
  [SMALL_STATE(18630)] = 555021,
  [SMALL_STATE(18631)] = 555032,
  [SMALL_STATE(18632)] = 555043,
  [SMALL_STATE(18633)] = 555054,
  [SMALL_STATE(18634)] = 555065,
  [SMALL_STATE(18635)] = 555076,
  [SMALL_STATE(18636)] = 555087,
  [SMALL_STATE(18637)] = 555098,
  [SMALL_STATE(18638)] = 555109,
  [SMALL_STATE(18639)] = 555122,
  [SMALL_STATE(18640)] = 555133,
  [SMALL_STATE(18641)] = 555144,
  [SMALL_STATE(18642)] = 555155,
  [SMALL_STATE(18643)] = 555166,
  [SMALL_STATE(18644)] = 555179,
  [SMALL_STATE(18645)] = 555190,
  [SMALL_STATE(18646)] = 555201,
  [SMALL_STATE(18647)] = 555214,
  [SMALL_STATE(18648)] = 555225,
  [SMALL_STATE(18649)] = 555236,
  [SMALL_STATE(18650)] = 555247,
  [SMALL_STATE(18651)] = 555258,
  [SMALL_STATE(18652)] = 555269,
  [SMALL_STATE(18653)] = 555280,
  [SMALL_STATE(18654)] = 555291,
  [SMALL_STATE(18655)] = 555304,
  [SMALL_STATE(18656)] = 555315,
  [SMALL_STATE(18657)] = 555328,
  [SMALL_STATE(18658)] = 555339,
  [SMALL_STATE(18659)] = 555350,
  [SMALL_STATE(18660)] = 555361,
  [SMALL_STATE(18661)] = 555372,
  [SMALL_STATE(18662)] = 555383,
  [SMALL_STATE(18663)] = 555394,
  [SMALL_STATE(18664)] = 555405,
  [SMALL_STATE(18665)] = 555416,
  [SMALL_STATE(18666)] = 555427,
  [SMALL_STATE(18667)] = 555438,
  [SMALL_STATE(18668)] = 555451,
  [SMALL_STATE(18669)] = 555462,
  [SMALL_STATE(18670)] = 555473,
  [SMALL_STATE(18671)] = 555484,
  [SMALL_STATE(18672)] = 555495,
  [SMALL_STATE(18673)] = 555506,
  [SMALL_STATE(18674)] = 555517,
  [SMALL_STATE(18675)] = 555528,
  [SMALL_STATE(18676)] = 555539,
  [SMALL_STATE(18677)] = 555550,
  [SMALL_STATE(18678)] = 555563,
  [SMALL_STATE(18679)] = 555576,
  [SMALL_STATE(18680)] = 555589,
  [SMALL_STATE(18681)] = 555600,
  [SMALL_STATE(18682)] = 555611,
  [SMALL_STATE(18683)] = 555624,
  [SMALL_STATE(18684)] = 555635,
  [SMALL_STATE(18685)] = 555646,
  [SMALL_STATE(18686)] = 555657,
  [SMALL_STATE(18687)] = 555668,
  [SMALL_STATE(18688)] = 555679,
  [SMALL_STATE(18689)] = 555690,
  [SMALL_STATE(18690)] = 555703,
  [SMALL_STATE(18691)] = 555714,
  [SMALL_STATE(18692)] = 555725,
  [SMALL_STATE(18693)] = 555738,
  [SMALL_STATE(18694)] = 555749,
  [SMALL_STATE(18695)] = 555760,
  [SMALL_STATE(18696)] = 555771,
  [SMALL_STATE(18697)] = 555782,
  [SMALL_STATE(18698)] = 555793,
  [SMALL_STATE(18699)] = 555804,
  [SMALL_STATE(18700)] = 555815,
  [SMALL_STATE(18701)] = 555826,
  [SMALL_STATE(18702)] = 555837,
  [SMALL_STATE(18703)] = 555848,
  [SMALL_STATE(18704)] = 555859,
  [SMALL_STATE(18705)] = 555870,
  [SMALL_STATE(18706)] = 555881,
  [SMALL_STATE(18707)] = 555892,
  [SMALL_STATE(18708)] = 555903,
  [SMALL_STATE(18709)] = 555914,
  [SMALL_STATE(18710)] = 555925,
  [SMALL_STATE(18711)] = 555936,
  [SMALL_STATE(18712)] = 555947,
  [SMALL_STATE(18713)] = 555958,
  [SMALL_STATE(18714)] = 555969,
  [SMALL_STATE(18715)] = 555980,
  [SMALL_STATE(18716)] = 555991,
  [SMALL_STATE(18717)] = 556002,
  [SMALL_STATE(18718)] = 556013,
  [SMALL_STATE(18719)] = 556024,
  [SMALL_STATE(18720)] = 556035,
  [SMALL_STATE(18721)] = 556046,
  [SMALL_STATE(18722)] = 556057,
  [SMALL_STATE(18723)] = 556068,
  [SMALL_STATE(18724)] = 556081,
  [SMALL_STATE(18725)] = 556092,
  [SMALL_STATE(18726)] = 556103,
  [SMALL_STATE(18727)] = 556114,
  [SMALL_STATE(18728)] = 556125,
  [SMALL_STATE(18729)] = 556136,
  [SMALL_STATE(18730)] = 556147,
  [SMALL_STATE(18731)] = 556158,
  [SMALL_STATE(18732)] = 556169,
  [SMALL_STATE(18733)] = 556180,
  [SMALL_STATE(18734)] = 556191,
  [SMALL_STATE(18735)] = 556202,
  [SMALL_STATE(18736)] = 556213,
  [SMALL_STATE(18737)] = 556224,
  [SMALL_STATE(18738)] = 556235,
  [SMALL_STATE(18739)] = 556246,
  [SMALL_STATE(18740)] = 556257,
  [SMALL_STATE(18741)] = 556268,
  [SMALL_STATE(18742)] = 556279,
  [SMALL_STATE(18743)] = 556290,
  [SMALL_STATE(18744)] = 556301,
  [SMALL_STATE(18745)] = 556312,
  [SMALL_STATE(18746)] = 556323,
  [SMALL_STATE(18747)] = 556334,
  [SMALL_STATE(18748)] = 556345,
  [SMALL_STATE(18749)] = 556356,
  [SMALL_STATE(18750)] = 556367,
  [SMALL_STATE(18751)] = 556378,
  [SMALL_STATE(18752)] = 556389,
  [SMALL_STATE(18753)] = 556400,
  [SMALL_STATE(18754)] = 556411,
  [SMALL_STATE(18755)] = 556422,
  [SMALL_STATE(18756)] = 556433,
  [SMALL_STATE(18757)] = 556446,
  [SMALL_STATE(18758)] = 556457,
  [SMALL_STATE(18759)] = 556468,
  [SMALL_STATE(18760)] = 556479,
  [SMALL_STATE(18761)] = 556490,
  [SMALL_STATE(18762)] = 556501,
  [SMALL_STATE(18763)] = 556512,
  [SMALL_STATE(18764)] = 556523,
  [SMALL_STATE(18765)] = 556536,
  [SMALL_STATE(18766)] = 556549,
  [SMALL_STATE(18767)] = 556560,
  [SMALL_STATE(18768)] = 556571,
  [SMALL_STATE(18769)] = 556582,
  [SMALL_STATE(18770)] = 556593,
  [SMALL_STATE(18771)] = 556604,
  [SMALL_STATE(18772)] = 556615,
  [SMALL_STATE(18773)] = 556626,
  [SMALL_STATE(18774)] = 556637,
  [SMALL_STATE(18775)] = 556648,
  [SMALL_STATE(18776)] = 556659,
  [SMALL_STATE(18777)] = 556672,
  [SMALL_STATE(18778)] = 556683,
  [SMALL_STATE(18779)] = 556694,
  [SMALL_STATE(18780)] = 556705,
  [SMALL_STATE(18781)] = 556716,
  [SMALL_STATE(18782)] = 556729,
  [SMALL_STATE(18783)] = 556740,
  [SMALL_STATE(18784)] = 556751,
  [SMALL_STATE(18785)] = 556764,
  [SMALL_STATE(18786)] = 556775,
  [SMALL_STATE(18787)] = 556786,
  [SMALL_STATE(18788)] = 556799,
  [SMALL_STATE(18789)] = 556810,
  [SMALL_STATE(18790)] = 556821,
  [SMALL_STATE(18791)] = 556832,
  [SMALL_STATE(18792)] = 556845,
  [SMALL_STATE(18793)] = 556856,
  [SMALL_STATE(18794)] = 556867,
  [SMALL_STATE(18795)] = 556878,
  [SMALL_STATE(18796)] = 556889,
  [SMALL_STATE(18797)] = 556900,
  [SMALL_STATE(18798)] = 556913,
  [SMALL_STATE(18799)] = 556926,
  [SMALL_STATE(18800)] = 556937,
  [SMALL_STATE(18801)] = 556948,
  [SMALL_STATE(18802)] = 556959,
  [SMALL_STATE(18803)] = 556972,
  [SMALL_STATE(18804)] = 556983,
  [SMALL_STATE(18805)] = 556994,
  [SMALL_STATE(18806)] = 557005,
  [SMALL_STATE(18807)] = 557016,
  [SMALL_STATE(18808)] = 557027,
  [SMALL_STATE(18809)] = 557040,
  [SMALL_STATE(18810)] = 557053,
  [SMALL_STATE(18811)] = 557064,
  [SMALL_STATE(18812)] = 557075,
  [SMALL_STATE(18813)] = 557086,
  [SMALL_STATE(18814)] = 557099,
  [SMALL_STATE(18815)] = 557110,
  [SMALL_STATE(18816)] = 557121,
  [SMALL_STATE(18817)] = 557132,
  [SMALL_STATE(18818)] = 557143,
  [SMALL_STATE(18819)] = 557154,
  [SMALL_STATE(18820)] = 557165,
  [SMALL_STATE(18821)] = 557178,
  [SMALL_STATE(18822)] = 557189,
  [SMALL_STATE(18823)] = 557200,
  [SMALL_STATE(18824)] = 557213,
  [SMALL_STATE(18825)] = 557224,
  [SMALL_STATE(18826)] = 557237,
  [SMALL_STATE(18827)] = 557248,
  [SMALL_STATE(18828)] = 557261,
  [SMALL_STATE(18829)] = 557272,
  [SMALL_STATE(18830)] = 557283,
  [SMALL_STATE(18831)] = 557294,
  [SMALL_STATE(18832)] = 557307,
  [SMALL_STATE(18833)] = 557318,
  [SMALL_STATE(18834)] = 557329,
  [SMALL_STATE(18835)] = 557342,
  [SMALL_STATE(18836)] = 557355,
  [SMALL_STATE(18837)] = 557366,
  [SMALL_STATE(18838)] = 557377,
  [SMALL_STATE(18839)] = 557388,
  [SMALL_STATE(18840)] = 557399,
  [SMALL_STATE(18841)] = 557410,
  [SMALL_STATE(18842)] = 557423,
  [SMALL_STATE(18843)] = 557434,
  [SMALL_STATE(18844)] = 557445,
  [SMALL_STATE(18845)] = 557456,
  [SMALL_STATE(18846)] = 557467,
  [SMALL_STATE(18847)] = 557480,
  [SMALL_STATE(18848)] = 557491,
  [SMALL_STATE(18849)] = 557504,
  [SMALL_STATE(18850)] = 557515,
  [SMALL_STATE(18851)] = 557526,
  [SMALL_STATE(18852)] = 557539,
  [SMALL_STATE(18853)] = 557550,
  [SMALL_STATE(18854)] = 557561,
  [SMALL_STATE(18855)] = 557572,
  [SMALL_STATE(18856)] = 557583,
  [SMALL_STATE(18857)] = 557594,
  [SMALL_STATE(18858)] = 557605,
  [SMALL_STATE(18859)] = 557616,
  [SMALL_STATE(18860)] = 557629,
  [SMALL_STATE(18861)] = 557642,
  [SMALL_STATE(18862)] = 557653,
  [SMALL_STATE(18863)] = 557664,
  [SMALL_STATE(18864)] = 557677,
  [SMALL_STATE(18865)] = 557690,
  [SMALL_STATE(18866)] = 557701,
  [SMALL_STATE(18867)] = 557712,
  [SMALL_STATE(18868)] = 557723,
  [SMALL_STATE(18869)] = 557734,
  [SMALL_STATE(18870)] = 557745,
  [SMALL_STATE(18871)] = 557758,
  [SMALL_STATE(18872)] = 557771,
  [SMALL_STATE(18873)] = 557782,
  [SMALL_STATE(18874)] = 557793,
  [SMALL_STATE(18875)] = 557806,
  [SMALL_STATE(18876)] = 557819,
  [SMALL_STATE(18877)] = 557830,
  [SMALL_STATE(18878)] = 557841,
  [SMALL_STATE(18879)] = 557854,
  [SMALL_STATE(18880)] = 557865,
  [SMALL_STATE(18881)] = 557876,
  [SMALL_STATE(18882)] = 557887,
  [SMALL_STATE(18883)] = 557898,
  [SMALL_STATE(18884)] = 557909,
  [SMALL_STATE(18885)] = 557922,
  [SMALL_STATE(18886)] = 557933,
  [SMALL_STATE(18887)] = 557944,
  [SMALL_STATE(18888)] = 557955,
  [SMALL_STATE(18889)] = 557966,
  [SMALL_STATE(18890)] = 557977,
  [SMALL_STATE(18891)] = 557988,
  [SMALL_STATE(18892)] = 557999,
  [SMALL_STATE(18893)] = 558010,
  [SMALL_STATE(18894)] = 558023,
  [SMALL_STATE(18895)] = 558036,
  [SMALL_STATE(18896)] = 558047,
  [SMALL_STATE(18897)] = 558058,
  [SMALL_STATE(18898)] = 558071,
  [SMALL_STATE(18899)] = 558082,
  [SMALL_STATE(18900)] = 558093,
  [SMALL_STATE(18901)] = 558104,
  [SMALL_STATE(18902)] = 558115,
  [SMALL_STATE(18903)] = 558126,
  [SMALL_STATE(18904)] = 558137,
  [SMALL_STATE(18905)] = 558150,
  [SMALL_STATE(18906)] = 558163,
  [SMALL_STATE(18907)] = 558174,
  [SMALL_STATE(18908)] = 558187,
  [SMALL_STATE(18909)] = 558197,
  [SMALL_STATE(18910)] = 558207,
  [SMALL_STATE(18911)] = 558217,
  [SMALL_STATE(18912)] = 558227,
  [SMALL_STATE(18913)] = 558237,
  [SMALL_STATE(18914)] = 558247,
  [SMALL_STATE(18915)] = 558257,
  [SMALL_STATE(18916)] = 558267,
  [SMALL_STATE(18917)] = 558277,
  [SMALL_STATE(18918)] = 558287,
  [SMALL_STATE(18919)] = 558297,
  [SMALL_STATE(18920)] = 558307,
  [SMALL_STATE(18921)] = 558317,
  [SMALL_STATE(18922)] = 558327,
  [SMALL_STATE(18923)] = 558337,
  [SMALL_STATE(18924)] = 558347,
  [SMALL_STATE(18925)] = 558357,
  [SMALL_STATE(18926)] = 558367,
  [SMALL_STATE(18927)] = 558377,
  [SMALL_STATE(18928)] = 558387,
  [SMALL_STATE(18929)] = 558397,
  [SMALL_STATE(18930)] = 558407,
  [SMALL_STATE(18931)] = 558417,
  [SMALL_STATE(18932)] = 558427,
  [SMALL_STATE(18933)] = 558437,
  [SMALL_STATE(18934)] = 558447,
  [SMALL_STATE(18935)] = 558457,
  [SMALL_STATE(18936)] = 558467,
  [SMALL_STATE(18937)] = 558477,
  [SMALL_STATE(18938)] = 558487,
  [SMALL_STATE(18939)] = 558497,
  [SMALL_STATE(18940)] = 558507,
  [SMALL_STATE(18941)] = 558517,
  [SMALL_STATE(18942)] = 558527,
  [SMALL_STATE(18943)] = 558537,
  [SMALL_STATE(18944)] = 558547,
  [SMALL_STATE(18945)] = 558557,
  [SMALL_STATE(18946)] = 558567,
  [SMALL_STATE(18947)] = 558577,
  [SMALL_STATE(18948)] = 558587,
  [SMALL_STATE(18949)] = 558597,
  [SMALL_STATE(18950)] = 558607,
  [SMALL_STATE(18951)] = 558617,
  [SMALL_STATE(18952)] = 558627,
  [SMALL_STATE(18953)] = 558637,
  [SMALL_STATE(18954)] = 558647,
  [SMALL_STATE(18955)] = 558657,
  [SMALL_STATE(18956)] = 558667,
  [SMALL_STATE(18957)] = 558677,
  [SMALL_STATE(18958)] = 558687,
  [SMALL_STATE(18959)] = 558697,
  [SMALL_STATE(18960)] = 558707,
  [SMALL_STATE(18961)] = 558717,
  [SMALL_STATE(18962)] = 558727,
  [SMALL_STATE(18963)] = 558737,
  [SMALL_STATE(18964)] = 558747,
  [SMALL_STATE(18965)] = 558757,
  [SMALL_STATE(18966)] = 558767,
  [SMALL_STATE(18967)] = 558777,
  [SMALL_STATE(18968)] = 558787,
  [SMALL_STATE(18969)] = 558797,
  [SMALL_STATE(18970)] = 558807,
  [SMALL_STATE(18971)] = 558817,
  [SMALL_STATE(18972)] = 558827,
  [SMALL_STATE(18973)] = 558837,
  [SMALL_STATE(18974)] = 558847,
  [SMALL_STATE(18975)] = 558857,
  [SMALL_STATE(18976)] = 558867,
  [SMALL_STATE(18977)] = 558877,
  [SMALL_STATE(18978)] = 558887,
  [SMALL_STATE(18979)] = 558897,
  [SMALL_STATE(18980)] = 558907,
  [SMALL_STATE(18981)] = 558917,
  [SMALL_STATE(18982)] = 558927,
  [SMALL_STATE(18983)] = 558937,
  [SMALL_STATE(18984)] = 558947,
  [SMALL_STATE(18985)] = 558957,
  [SMALL_STATE(18986)] = 558967,
  [SMALL_STATE(18987)] = 558977,
  [SMALL_STATE(18988)] = 558987,
  [SMALL_STATE(18989)] = 558997,
  [SMALL_STATE(18990)] = 559007,
  [SMALL_STATE(18991)] = 559017,
  [SMALL_STATE(18992)] = 559027,
  [SMALL_STATE(18993)] = 559037,
  [SMALL_STATE(18994)] = 559047,
  [SMALL_STATE(18995)] = 559057,
  [SMALL_STATE(18996)] = 559067,
  [SMALL_STATE(18997)] = 559077,
  [SMALL_STATE(18998)] = 559087,
  [SMALL_STATE(18999)] = 559097,
  [SMALL_STATE(19000)] = 559107,
  [SMALL_STATE(19001)] = 559117,
  [SMALL_STATE(19002)] = 559127,
  [SMALL_STATE(19003)] = 559137,
  [SMALL_STATE(19004)] = 559147,
  [SMALL_STATE(19005)] = 559157,
  [SMALL_STATE(19006)] = 559167,
  [SMALL_STATE(19007)] = 559177,
  [SMALL_STATE(19008)] = 559187,
  [SMALL_STATE(19009)] = 559197,
  [SMALL_STATE(19010)] = 559207,
  [SMALL_STATE(19011)] = 559217,
  [SMALL_STATE(19012)] = 559227,
  [SMALL_STATE(19013)] = 559237,
  [SMALL_STATE(19014)] = 559247,
  [SMALL_STATE(19015)] = 559257,
  [SMALL_STATE(19016)] = 559267,
  [SMALL_STATE(19017)] = 559277,
  [SMALL_STATE(19018)] = 559287,
  [SMALL_STATE(19019)] = 559297,
  [SMALL_STATE(19020)] = 559307,
  [SMALL_STATE(19021)] = 559317,
  [SMALL_STATE(19022)] = 559327,
  [SMALL_STATE(19023)] = 559337,
  [SMALL_STATE(19024)] = 559347,
  [SMALL_STATE(19025)] = 559357,
  [SMALL_STATE(19026)] = 559367,
  [SMALL_STATE(19027)] = 559377,
  [SMALL_STATE(19028)] = 559387,
  [SMALL_STATE(19029)] = 559397,
  [SMALL_STATE(19030)] = 559407,
  [SMALL_STATE(19031)] = 559417,
  [SMALL_STATE(19032)] = 559427,
  [SMALL_STATE(19033)] = 559437,
  [SMALL_STATE(19034)] = 559447,
  [SMALL_STATE(19035)] = 559457,
  [SMALL_STATE(19036)] = 559467,
  [SMALL_STATE(19037)] = 559477,
  [SMALL_STATE(19038)] = 559487,
  [SMALL_STATE(19039)] = 559497,
  [SMALL_STATE(19040)] = 559507,
  [SMALL_STATE(19041)] = 559517,
  [SMALL_STATE(19042)] = 559527,
  [SMALL_STATE(19043)] = 559537,
  [SMALL_STATE(19044)] = 559547,
  [SMALL_STATE(19045)] = 559557,
  [SMALL_STATE(19046)] = 559567,
  [SMALL_STATE(19047)] = 559577,
  [SMALL_STATE(19048)] = 559587,
  [SMALL_STATE(19049)] = 559597,
  [SMALL_STATE(19050)] = 559607,
  [SMALL_STATE(19051)] = 559617,
  [SMALL_STATE(19052)] = 559627,
  [SMALL_STATE(19053)] = 559637,
  [SMALL_STATE(19054)] = 559647,
  [SMALL_STATE(19055)] = 559657,
  [SMALL_STATE(19056)] = 559667,
  [SMALL_STATE(19057)] = 559677,
  [SMALL_STATE(19058)] = 559687,
  [SMALL_STATE(19059)] = 559697,
  [SMALL_STATE(19060)] = 559707,
  [SMALL_STATE(19061)] = 559717,
  [SMALL_STATE(19062)] = 559727,
  [SMALL_STATE(19063)] = 559737,
  [SMALL_STATE(19064)] = 559747,
  [SMALL_STATE(19065)] = 559757,
  [SMALL_STATE(19066)] = 559767,
  [SMALL_STATE(19067)] = 559777,
  [SMALL_STATE(19068)] = 559787,
  [SMALL_STATE(19069)] = 559797,
  [SMALL_STATE(19070)] = 559807,
  [SMALL_STATE(19071)] = 559817,
  [SMALL_STATE(19072)] = 559827,
  [SMALL_STATE(19073)] = 559837,
  [SMALL_STATE(19074)] = 559847,
  [SMALL_STATE(19075)] = 559857,
  [SMALL_STATE(19076)] = 559867,
  [SMALL_STATE(19077)] = 559877,
  [SMALL_STATE(19078)] = 559887,
  [SMALL_STATE(19079)] = 559897,
  [SMALL_STATE(19080)] = 559907,
  [SMALL_STATE(19081)] = 559917,
  [SMALL_STATE(19082)] = 559927,
  [SMALL_STATE(19083)] = 559937,
  [SMALL_STATE(19084)] = 559947,
  [SMALL_STATE(19085)] = 559957,
  [SMALL_STATE(19086)] = 559967,
  [SMALL_STATE(19087)] = 559977,
  [SMALL_STATE(19088)] = 559987,
  [SMALL_STATE(19089)] = 559997,
  [SMALL_STATE(19090)] = 560007,
  [SMALL_STATE(19091)] = 560017,
  [SMALL_STATE(19092)] = 560027,
  [SMALL_STATE(19093)] = 560037,
  [SMALL_STATE(19094)] = 560047,
  [SMALL_STATE(19095)] = 560057,
  [SMALL_STATE(19096)] = 560067,
  [SMALL_STATE(19097)] = 560077,
  [SMALL_STATE(19098)] = 560087,
  [SMALL_STATE(19099)] = 560097,
  [SMALL_STATE(19100)] = 560107,
  [SMALL_STATE(19101)] = 560117,
  [SMALL_STATE(19102)] = 560127,
  [SMALL_STATE(19103)] = 560137,
  [SMALL_STATE(19104)] = 560147,
  [SMALL_STATE(19105)] = 560157,
  [SMALL_STATE(19106)] = 560167,
  [SMALL_STATE(19107)] = 560177,
  [SMALL_STATE(19108)] = 560187,
  [SMALL_STATE(19109)] = 560197,
  [SMALL_STATE(19110)] = 560207,
  [SMALL_STATE(19111)] = 560217,
  [SMALL_STATE(19112)] = 560227,
  [SMALL_STATE(19113)] = 560237,
  [SMALL_STATE(19114)] = 560247,
  [SMALL_STATE(19115)] = 560257,
  [SMALL_STATE(19116)] = 560267,
  [SMALL_STATE(19117)] = 560277,
  [SMALL_STATE(19118)] = 560287,
  [SMALL_STATE(19119)] = 560297,
  [SMALL_STATE(19120)] = 560307,
  [SMALL_STATE(19121)] = 560317,
  [SMALL_STATE(19122)] = 560327,
  [SMALL_STATE(19123)] = 560337,
  [SMALL_STATE(19124)] = 560347,
  [SMALL_STATE(19125)] = 560357,
  [SMALL_STATE(19126)] = 560367,
  [SMALL_STATE(19127)] = 560377,
  [SMALL_STATE(19128)] = 560387,
  [SMALL_STATE(19129)] = 560397,
  [SMALL_STATE(19130)] = 560407,
  [SMALL_STATE(19131)] = 560417,
  [SMALL_STATE(19132)] = 560427,
  [SMALL_STATE(19133)] = 560437,
  [SMALL_STATE(19134)] = 560447,
  [SMALL_STATE(19135)] = 560457,
  [SMALL_STATE(19136)] = 560467,
  [SMALL_STATE(19137)] = 560477,
  [SMALL_STATE(19138)] = 560487,
  [SMALL_STATE(19139)] = 560497,
  [SMALL_STATE(19140)] = 560507,
  [SMALL_STATE(19141)] = 560517,
  [SMALL_STATE(19142)] = 560527,
  [SMALL_STATE(19143)] = 560537,
  [SMALL_STATE(19144)] = 560547,
  [SMALL_STATE(19145)] = 560557,
  [SMALL_STATE(19146)] = 560567,
  [SMALL_STATE(19147)] = 560577,
  [SMALL_STATE(19148)] = 560587,
  [SMALL_STATE(19149)] = 560597,
  [SMALL_STATE(19150)] = 560607,
  [SMALL_STATE(19151)] = 560617,
  [SMALL_STATE(19152)] = 560627,
  [SMALL_STATE(19153)] = 560637,
  [SMALL_STATE(19154)] = 560647,
  [SMALL_STATE(19155)] = 560657,
  [SMALL_STATE(19156)] = 560667,
  [SMALL_STATE(19157)] = 560677,
  [SMALL_STATE(19158)] = 560687,
  [SMALL_STATE(19159)] = 560697,
  [SMALL_STATE(19160)] = 560707,
  [SMALL_STATE(19161)] = 560717,
  [SMALL_STATE(19162)] = 560727,
  [SMALL_STATE(19163)] = 560737,
  [SMALL_STATE(19164)] = 560747,
  [SMALL_STATE(19165)] = 560757,
  [SMALL_STATE(19166)] = 560767,
  [SMALL_STATE(19167)] = 560777,
  [SMALL_STATE(19168)] = 560787,
  [SMALL_STATE(19169)] = 560797,
  [SMALL_STATE(19170)] = 560807,
  [SMALL_STATE(19171)] = 560817,
  [SMALL_STATE(19172)] = 560827,
  [SMALL_STATE(19173)] = 560837,
  [SMALL_STATE(19174)] = 560847,
  [SMALL_STATE(19175)] = 560857,
  [SMALL_STATE(19176)] = 560867,
  [SMALL_STATE(19177)] = 560877,
  [SMALL_STATE(19178)] = 560887,
  [SMALL_STATE(19179)] = 560897,
  [SMALL_STATE(19180)] = 560907,
  [SMALL_STATE(19181)] = 560917,
  [SMALL_STATE(19182)] = 560927,
  [SMALL_STATE(19183)] = 560937,
  [SMALL_STATE(19184)] = 560947,
  [SMALL_STATE(19185)] = 560957,
  [SMALL_STATE(19186)] = 560967,
  [SMALL_STATE(19187)] = 560977,
  [SMALL_STATE(19188)] = 560987,
  [SMALL_STATE(19189)] = 560997,
  [SMALL_STATE(19190)] = 561007,
  [SMALL_STATE(19191)] = 561017,
  [SMALL_STATE(19192)] = 561027,
  [SMALL_STATE(19193)] = 561037,
  [SMALL_STATE(19194)] = 561047,
  [SMALL_STATE(19195)] = 561057,
  [SMALL_STATE(19196)] = 561067,
  [SMALL_STATE(19197)] = 561077,
  [SMALL_STATE(19198)] = 561087,
  [SMALL_STATE(19199)] = 561097,
  [SMALL_STATE(19200)] = 561107,
  [SMALL_STATE(19201)] = 561117,
  [SMALL_STATE(19202)] = 561127,
  [SMALL_STATE(19203)] = 561137,
  [SMALL_STATE(19204)] = 561147,
  [SMALL_STATE(19205)] = 561157,
  [SMALL_STATE(19206)] = 561167,
  [SMALL_STATE(19207)] = 561177,
  [SMALL_STATE(19208)] = 561187,
  [SMALL_STATE(19209)] = 561197,
  [SMALL_STATE(19210)] = 561207,
  [SMALL_STATE(19211)] = 561217,
  [SMALL_STATE(19212)] = 561227,
  [SMALL_STATE(19213)] = 561237,
  [SMALL_STATE(19214)] = 561247,
  [SMALL_STATE(19215)] = 561257,
  [SMALL_STATE(19216)] = 561267,
  [SMALL_STATE(19217)] = 561277,
  [SMALL_STATE(19218)] = 561287,
  [SMALL_STATE(19219)] = 561297,
  [SMALL_STATE(19220)] = 561307,
  [SMALL_STATE(19221)] = 561317,
  [SMALL_STATE(19222)] = 561327,
  [SMALL_STATE(19223)] = 561337,
  [SMALL_STATE(19224)] = 561347,
  [SMALL_STATE(19225)] = 561357,
  [SMALL_STATE(19226)] = 561367,
  [SMALL_STATE(19227)] = 561377,
  [SMALL_STATE(19228)] = 561387,
  [SMALL_STATE(19229)] = 561397,
  [SMALL_STATE(19230)] = 561407,
  [SMALL_STATE(19231)] = 561417,
  [SMALL_STATE(19232)] = 561427,
  [SMALL_STATE(19233)] = 561437,
  [SMALL_STATE(19234)] = 561447,
  [SMALL_STATE(19235)] = 561457,
  [SMALL_STATE(19236)] = 561467,
  [SMALL_STATE(19237)] = 561477,
  [SMALL_STATE(19238)] = 561487,
  [SMALL_STATE(19239)] = 561497,
  [SMALL_STATE(19240)] = 561507,
  [SMALL_STATE(19241)] = 561517,
  [SMALL_STATE(19242)] = 561527,
  [SMALL_STATE(19243)] = 561537,
  [SMALL_STATE(19244)] = 561547,
  [SMALL_STATE(19245)] = 561557,
  [SMALL_STATE(19246)] = 561567,
  [SMALL_STATE(19247)] = 561577,
  [SMALL_STATE(19248)] = 561587,
  [SMALL_STATE(19249)] = 561597,
  [SMALL_STATE(19250)] = 561607,
  [SMALL_STATE(19251)] = 561617,
  [SMALL_STATE(19252)] = 561627,
  [SMALL_STATE(19253)] = 561637,
  [SMALL_STATE(19254)] = 561647,
  [SMALL_STATE(19255)] = 561657,
  [SMALL_STATE(19256)] = 561667,
  [SMALL_STATE(19257)] = 561677,
  [SMALL_STATE(19258)] = 561687,
  [SMALL_STATE(19259)] = 561697,
  [SMALL_STATE(19260)] = 561707,
  [SMALL_STATE(19261)] = 561717,
  [SMALL_STATE(19262)] = 561727,
  [SMALL_STATE(19263)] = 561737,
  [SMALL_STATE(19264)] = 561747,
  [SMALL_STATE(19265)] = 561757,
  [SMALL_STATE(19266)] = 561767,
  [SMALL_STATE(19267)] = 561777,
  [SMALL_STATE(19268)] = 561787,
  [SMALL_STATE(19269)] = 561797,
  [SMALL_STATE(19270)] = 561807,
  [SMALL_STATE(19271)] = 561817,
  [SMALL_STATE(19272)] = 561827,
  [SMALL_STATE(19273)] = 561837,
  [SMALL_STATE(19274)] = 561847,
  [SMALL_STATE(19275)] = 561857,
  [SMALL_STATE(19276)] = 561867,
  [SMALL_STATE(19277)] = 561877,
  [SMALL_STATE(19278)] = 561887,
  [SMALL_STATE(19279)] = 561897,
  [SMALL_STATE(19280)] = 561907,
  [SMALL_STATE(19281)] = 561917,
  [SMALL_STATE(19282)] = 561927,
  [SMALL_STATE(19283)] = 561937,
  [SMALL_STATE(19284)] = 561947,
  [SMALL_STATE(19285)] = 561957,
  [SMALL_STATE(19286)] = 561967,
  [SMALL_STATE(19287)] = 561977,
  [SMALL_STATE(19288)] = 561987,
  [SMALL_STATE(19289)] = 561997,
  [SMALL_STATE(19290)] = 562007,
  [SMALL_STATE(19291)] = 562017,
  [SMALL_STATE(19292)] = 562027,
  [SMALL_STATE(19293)] = 562037,
  [SMALL_STATE(19294)] = 562047,
  [SMALL_STATE(19295)] = 562057,
  [SMALL_STATE(19296)] = 562067,
  [SMALL_STATE(19297)] = 562077,
  [SMALL_STATE(19298)] = 562087,
  [SMALL_STATE(19299)] = 562097,
  [SMALL_STATE(19300)] = 562107,
  [SMALL_STATE(19301)] = 562117,
  [SMALL_STATE(19302)] = 562127,
  [SMALL_STATE(19303)] = 562137,
  [SMALL_STATE(19304)] = 562147,
  [SMALL_STATE(19305)] = 562157,
  [SMALL_STATE(19306)] = 562167,
  [SMALL_STATE(19307)] = 562177,
  [SMALL_STATE(19308)] = 562187,
  [SMALL_STATE(19309)] = 562197,
  [SMALL_STATE(19310)] = 562207,
  [SMALL_STATE(19311)] = 562217,
  [SMALL_STATE(19312)] = 562227,
  [SMALL_STATE(19313)] = 562237,
  [SMALL_STATE(19314)] = 562247,
  [SMALL_STATE(19315)] = 562257,
  [SMALL_STATE(19316)] = 562267,
  [SMALL_STATE(19317)] = 562277,
  [SMALL_STATE(19318)] = 562287,
  [SMALL_STATE(19319)] = 562297,
  [SMALL_STATE(19320)] = 562307,
  [SMALL_STATE(19321)] = 562317,
  [SMALL_STATE(19322)] = 562327,
  [SMALL_STATE(19323)] = 562337,
  [SMALL_STATE(19324)] = 562347,
  [SMALL_STATE(19325)] = 562357,
  [SMALL_STATE(19326)] = 562367,
  [SMALL_STATE(19327)] = 562377,
  [SMALL_STATE(19328)] = 562387,
  [SMALL_STATE(19329)] = 562397,
  [SMALL_STATE(19330)] = 562407,
  [SMALL_STATE(19331)] = 562417,
  [SMALL_STATE(19332)] = 562427,
  [SMALL_STATE(19333)] = 562437,
  [SMALL_STATE(19334)] = 562447,
  [SMALL_STATE(19335)] = 562457,
  [SMALL_STATE(19336)] = 562467,
  [SMALL_STATE(19337)] = 562477,
  [SMALL_STATE(19338)] = 562487,
  [SMALL_STATE(19339)] = 562497,
  [SMALL_STATE(19340)] = 562507,
  [SMALL_STATE(19341)] = 562517,
  [SMALL_STATE(19342)] = 562527,
  [SMALL_STATE(19343)] = 562537,
  [SMALL_STATE(19344)] = 562547,
  [SMALL_STATE(19345)] = 562557,
  [SMALL_STATE(19346)] = 562567,
  [SMALL_STATE(19347)] = 562577,
  [SMALL_STATE(19348)] = 562587,
  [SMALL_STATE(19349)] = 562597,
  [SMALL_STATE(19350)] = 562607,
  [SMALL_STATE(19351)] = 562617,
  [SMALL_STATE(19352)] = 562627,
  [SMALL_STATE(19353)] = 562637,
  [SMALL_STATE(19354)] = 562647,
  [SMALL_STATE(19355)] = 562657,
  [SMALL_STATE(19356)] = 562667,
  [SMALL_STATE(19357)] = 562677,
  [SMALL_STATE(19358)] = 562687,
  [SMALL_STATE(19359)] = 562697,
  [SMALL_STATE(19360)] = 562707,
  [SMALL_STATE(19361)] = 562717,
  [SMALL_STATE(19362)] = 562727,
  [SMALL_STATE(19363)] = 562737,
  [SMALL_STATE(19364)] = 562747,
  [SMALL_STATE(19365)] = 562757,
  [SMALL_STATE(19366)] = 562767,
  [SMALL_STATE(19367)] = 562777,
  [SMALL_STATE(19368)] = 562787,
  [SMALL_STATE(19369)] = 562797,
  [SMALL_STATE(19370)] = 562807,
  [SMALL_STATE(19371)] = 562817,
  [SMALL_STATE(19372)] = 562827,
  [SMALL_STATE(19373)] = 562837,
  [SMALL_STATE(19374)] = 562847,
  [SMALL_STATE(19375)] = 562857,
  [SMALL_STATE(19376)] = 562867,
  [SMALL_STATE(19377)] = 562877,
  [SMALL_STATE(19378)] = 562887,
  [SMALL_STATE(19379)] = 562897,
  [SMALL_STATE(19380)] = 562907,
  [SMALL_STATE(19381)] = 562917,
  [SMALL_STATE(19382)] = 562927,
  [SMALL_STATE(19383)] = 562937,
  [SMALL_STATE(19384)] = 562947,
  [SMALL_STATE(19385)] = 562957,
  [SMALL_STATE(19386)] = 562967,
  [SMALL_STATE(19387)] = 562977,
  [SMALL_STATE(19388)] = 562987,
  [SMALL_STATE(19389)] = 562997,
  [SMALL_STATE(19390)] = 563007,
  [SMALL_STATE(19391)] = 563017,
  [SMALL_STATE(19392)] = 563027,
  [SMALL_STATE(19393)] = 563037,
  [SMALL_STATE(19394)] = 563047,
  [SMALL_STATE(19395)] = 563057,
  [SMALL_STATE(19396)] = 563067,
  [SMALL_STATE(19397)] = 563077,
  [SMALL_STATE(19398)] = 563087,
  [SMALL_STATE(19399)] = 563097,
  [SMALL_STATE(19400)] = 563107,
  [SMALL_STATE(19401)] = 563117,
  [SMALL_STATE(19402)] = 563127,
  [SMALL_STATE(19403)] = 563137,
  [SMALL_STATE(19404)] = 563147,
  [SMALL_STATE(19405)] = 563157,
  [SMALL_STATE(19406)] = 563167,
  [SMALL_STATE(19407)] = 563177,
  [SMALL_STATE(19408)] = 563187,
  [SMALL_STATE(19409)] = 563197,
  [SMALL_STATE(19410)] = 563207,
  [SMALL_STATE(19411)] = 563217,
  [SMALL_STATE(19412)] = 563227,
  [SMALL_STATE(19413)] = 563237,
  [SMALL_STATE(19414)] = 563247,
  [SMALL_STATE(19415)] = 563257,
  [SMALL_STATE(19416)] = 563267,
  [SMALL_STATE(19417)] = 563277,
  [SMALL_STATE(19418)] = 563287,
  [SMALL_STATE(19419)] = 563297,
  [SMALL_STATE(19420)] = 563307,
  [SMALL_STATE(19421)] = 563317,
  [SMALL_STATE(19422)] = 563327,
  [SMALL_STATE(19423)] = 563337,
  [SMALL_STATE(19424)] = 563347,
  [SMALL_STATE(19425)] = 563357,
  [SMALL_STATE(19426)] = 563367,
  [SMALL_STATE(19427)] = 563377,
  [SMALL_STATE(19428)] = 563387,
  [SMALL_STATE(19429)] = 563397,
  [SMALL_STATE(19430)] = 563407,
  [SMALL_STATE(19431)] = 563417,
  [SMALL_STATE(19432)] = 563427,
  [SMALL_STATE(19433)] = 563437,
  [SMALL_STATE(19434)] = 563447,
  [SMALL_STATE(19435)] = 563457,
  [SMALL_STATE(19436)] = 563467,
  [SMALL_STATE(19437)] = 563477,
  [SMALL_STATE(19438)] = 563487,
  [SMALL_STATE(19439)] = 563497,
  [SMALL_STATE(19440)] = 563507,
  [SMALL_STATE(19441)] = 563517,
  [SMALL_STATE(19442)] = 563527,
  [SMALL_STATE(19443)] = 563537,
  [SMALL_STATE(19444)] = 563547,
  [SMALL_STATE(19445)] = 563557,
  [SMALL_STATE(19446)] = 563567,
  [SMALL_STATE(19447)] = 563577,
  [SMALL_STATE(19448)] = 563587,
  [SMALL_STATE(19449)] = 563597,
  [SMALL_STATE(19450)] = 563607,
  [SMALL_STATE(19451)] = 563617,
  [SMALL_STATE(19452)] = 563627,
  [SMALL_STATE(19453)] = 563637,
  [SMALL_STATE(19454)] = 563647,
  [SMALL_STATE(19455)] = 563657,
  [SMALL_STATE(19456)] = 563667,
  [SMALL_STATE(19457)] = 563677,
  [SMALL_STATE(19458)] = 563687,
  [SMALL_STATE(19459)] = 563697,
  [SMALL_STATE(19460)] = 563707,
  [SMALL_STATE(19461)] = 563717,
  [SMALL_STATE(19462)] = 563727,
  [SMALL_STATE(19463)] = 563737,
  [SMALL_STATE(19464)] = 563747,
  [SMALL_STATE(19465)] = 563757,
  [SMALL_STATE(19466)] = 563767,
  [SMALL_STATE(19467)] = 563777,
  [SMALL_STATE(19468)] = 563787,
  [SMALL_STATE(19469)] = 563797,
  [SMALL_STATE(19470)] = 563807,
  [SMALL_STATE(19471)] = 563817,
  [SMALL_STATE(19472)] = 563827,
  [SMALL_STATE(19473)] = 563837,
  [SMALL_STATE(19474)] = 563847,
  [SMALL_STATE(19475)] = 563857,
  [SMALL_STATE(19476)] = 563867,
  [SMALL_STATE(19477)] = 563877,
  [SMALL_STATE(19478)] = 563887,
  [SMALL_STATE(19479)] = 563897,
  [SMALL_STATE(19480)] = 563907,
  [SMALL_STATE(19481)] = 563917,
  [SMALL_STATE(19482)] = 563927,
  [SMALL_STATE(19483)] = 563937,
  [SMALL_STATE(19484)] = 563947,
  [SMALL_STATE(19485)] = 563957,
  [SMALL_STATE(19486)] = 563967,
  [SMALL_STATE(19487)] = 563977,
  [SMALL_STATE(19488)] = 563987,
  [SMALL_STATE(19489)] = 563997,
  [SMALL_STATE(19490)] = 564007,
  [SMALL_STATE(19491)] = 564017,
  [SMALL_STATE(19492)] = 564027,
  [SMALL_STATE(19493)] = 564037,
  [SMALL_STATE(19494)] = 564047,
  [SMALL_STATE(19495)] = 564057,
  [SMALL_STATE(19496)] = 564067,
  [SMALL_STATE(19497)] = 564077,
  [SMALL_STATE(19498)] = 564087,
  [SMALL_STATE(19499)] = 564097,
  [SMALL_STATE(19500)] = 564107,
  [SMALL_STATE(19501)] = 564117,
  [SMALL_STATE(19502)] = 564127,
  [SMALL_STATE(19503)] = 564137,
  [SMALL_STATE(19504)] = 564147,
  [SMALL_STATE(19505)] = 564157,
  [SMALL_STATE(19506)] = 564167,
  [SMALL_STATE(19507)] = 564177,
  [SMALL_STATE(19508)] = 564187,
  [SMALL_STATE(19509)] = 564197,
  [SMALL_STATE(19510)] = 564207,
  [SMALL_STATE(19511)] = 564217,
  [SMALL_STATE(19512)] = 564227,
  [SMALL_STATE(19513)] = 564237,
  [SMALL_STATE(19514)] = 564247,
  [SMALL_STATE(19515)] = 564257,
  [SMALL_STATE(19516)] = 564267,
  [SMALL_STATE(19517)] = 564277,
  [SMALL_STATE(19518)] = 564287,
  [SMALL_STATE(19519)] = 564297,
  [SMALL_STATE(19520)] = 564307,
  [SMALL_STATE(19521)] = 564317,
  [SMALL_STATE(19522)] = 564327,
  [SMALL_STATE(19523)] = 564337,
  [SMALL_STATE(19524)] = 564347,
  [SMALL_STATE(19525)] = 564357,
  [SMALL_STATE(19526)] = 564367,
  [SMALL_STATE(19527)] = 564377,
  [SMALL_STATE(19528)] = 564387,
  [SMALL_STATE(19529)] = 564397,
  [SMALL_STATE(19530)] = 564407,
  [SMALL_STATE(19531)] = 564417,
  [SMALL_STATE(19532)] = 564427,
  [SMALL_STATE(19533)] = 564437,
  [SMALL_STATE(19534)] = 564447,
  [SMALL_STATE(19535)] = 564457,
  [SMALL_STATE(19536)] = 564467,
  [SMALL_STATE(19537)] = 564477,
  [SMALL_STATE(19538)] = 564487,
  [SMALL_STATE(19539)] = 564497,
  [SMALL_STATE(19540)] = 564507,
  [SMALL_STATE(19541)] = 564517,
  [SMALL_STATE(19542)] = 564527,
  [SMALL_STATE(19543)] = 564537,
  [SMALL_STATE(19544)] = 564547,
  [SMALL_STATE(19545)] = 564557,
  [SMALL_STATE(19546)] = 564567,
  [SMALL_STATE(19547)] = 564577,
  [SMALL_STATE(19548)] = 564587,
  [SMALL_STATE(19549)] = 564597,
  [SMALL_STATE(19550)] = 564607,
  [SMALL_STATE(19551)] = 564617,
  [SMALL_STATE(19552)] = 564627,
  [SMALL_STATE(19553)] = 564637,
  [SMALL_STATE(19554)] = 564647,
  [SMALL_STATE(19555)] = 564657,
  [SMALL_STATE(19556)] = 564667,
  [SMALL_STATE(19557)] = 564677,
  [SMALL_STATE(19558)] = 564687,
  [SMALL_STATE(19559)] = 564697,
  [SMALL_STATE(19560)] = 564707,
  [SMALL_STATE(19561)] = 564717,
  [SMALL_STATE(19562)] = 564727,
  [SMALL_STATE(19563)] = 564737,
  [SMALL_STATE(19564)] = 564747,
  [SMALL_STATE(19565)] = 564757,
  [SMALL_STATE(19566)] = 564767,
  [SMALL_STATE(19567)] = 564777,
  [SMALL_STATE(19568)] = 564787,
  [SMALL_STATE(19569)] = 564797,
  [SMALL_STATE(19570)] = 564807,
  [SMALL_STATE(19571)] = 564817,
  [SMALL_STATE(19572)] = 564827,
  [SMALL_STATE(19573)] = 564837,
  [SMALL_STATE(19574)] = 564847,
  [SMALL_STATE(19575)] = 564857,
  [SMALL_STATE(19576)] = 564867,
  [SMALL_STATE(19577)] = 564877,
  [SMALL_STATE(19578)] = 564887,
  [SMALL_STATE(19579)] = 564897,
  [SMALL_STATE(19580)] = 564907,
  [SMALL_STATE(19581)] = 564917,
  [SMALL_STATE(19582)] = 564927,
  [SMALL_STATE(19583)] = 564937,
  [SMALL_STATE(19584)] = 564947,
  [SMALL_STATE(19585)] = 564957,
  [SMALL_STATE(19586)] = 564967,
  [SMALL_STATE(19587)] = 564977,
  [SMALL_STATE(19588)] = 564987,
  [SMALL_STATE(19589)] = 564997,
  [SMALL_STATE(19590)] = 565007,
  [SMALL_STATE(19591)] = 565017,
  [SMALL_STATE(19592)] = 565027,
  [SMALL_STATE(19593)] = 565037,
  [SMALL_STATE(19594)] = 565047,
  [SMALL_STATE(19595)] = 565057,
  [SMALL_STATE(19596)] = 565067,
  [SMALL_STATE(19597)] = 565077,
  [SMALL_STATE(19598)] = 565087,
  [SMALL_STATE(19599)] = 565097,
  [SMALL_STATE(19600)] = 565107,
  [SMALL_STATE(19601)] = 565117,
  [SMALL_STATE(19602)] = 565127,
  [SMALL_STATE(19603)] = 565137,
  [SMALL_STATE(19604)] = 565147,
  [SMALL_STATE(19605)] = 565157,
  [SMALL_STATE(19606)] = 565167,
  [SMALL_STATE(19607)] = 565177,
  [SMALL_STATE(19608)] = 565187,
  [SMALL_STATE(19609)] = 565197,
  [SMALL_STATE(19610)] = 565207,
  [SMALL_STATE(19611)] = 565217,
  [SMALL_STATE(19612)] = 565227,
  [SMALL_STATE(19613)] = 565237,
  [SMALL_STATE(19614)] = 565247,
  [SMALL_STATE(19615)] = 565257,
  [SMALL_STATE(19616)] = 565267,
  [SMALL_STATE(19617)] = 565277,
  [SMALL_STATE(19618)] = 565287,
  [SMALL_STATE(19619)] = 565297,
  [SMALL_STATE(19620)] = 565307,
  [SMALL_STATE(19621)] = 565317,
  [SMALL_STATE(19622)] = 565327,
  [SMALL_STATE(19623)] = 565337,
  [SMALL_STATE(19624)] = 565347,
  [SMALL_STATE(19625)] = 565357,
  [SMALL_STATE(19626)] = 565367,
  [SMALL_STATE(19627)] = 565377,
  [SMALL_STATE(19628)] = 565387,
  [SMALL_STATE(19629)] = 565397,
  [SMALL_STATE(19630)] = 565407,
  [SMALL_STATE(19631)] = 565417,
  [SMALL_STATE(19632)] = 565427,
  [SMALL_STATE(19633)] = 565437,
  [SMALL_STATE(19634)] = 565447,
  [SMALL_STATE(19635)] = 565457,
  [SMALL_STATE(19636)] = 565467,
  [SMALL_STATE(19637)] = 565477,
  [SMALL_STATE(19638)] = 565487,
  [SMALL_STATE(19639)] = 565497,
  [SMALL_STATE(19640)] = 565507,
  [SMALL_STATE(19641)] = 565517,
  [SMALL_STATE(19642)] = 565527,
  [SMALL_STATE(19643)] = 565537,
  [SMALL_STATE(19644)] = 565547,
  [SMALL_STATE(19645)] = 565557,
  [SMALL_STATE(19646)] = 565567,
  [SMALL_STATE(19647)] = 565577,
  [SMALL_STATE(19648)] = 565587,
  [SMALL_STATE(19649)] = 565597,
  [SMALL_STATE(19650)] = 565607,
  [SMALL_STATE(19651)] = 565617,
  [SMALL_STATE(19652)] = 565627,
  [SMALL_STATE(19653)] = 565637,
  [SMALL_STATE(19654)] = 565647,
  [SMALL_STATE(19655)] = 565657,
  [SMALL_STATE(19656)] = 565667,
  [SMALL_STATE(19657)] = 565677,
  [SMALL_STATE(19658)] = 565687,
  [SMALL_STATE(19659)] = 565697,
  [SMALL_STATE(19660)] = 565707,
  [SMALL_STATE(19661)] = 565717,
  [SMALL_STATE(19662)] = 565727,
  [SMALL_STATE(19663)] = 565737,
  [SMALL_STATE(19664)] = 565747,
  [SMALL_STATE(19665)] = 565757,
  [SMALL_STATE(19666)] = 565767,
  [SMALL_STATE(19667)] = 565777,
  [SMALL_STATE(19668)] = 565787,
  [SMALL_STATE(19669)] = 565797,
  [SMALL_STATE(19670)] = 565807,
  [SMALL_STATE(19671)] = 565817,
  [SMALL_STATE(19672)] = 565827,
  [SMALL_STATE(19673)] = 565837,
  [SMALL_STATE(19674)] = 565847,
  [SMALL_STATE(19675)] = 565857,
  [SMALL_STATE(19676)] = 565867,
  [SMALL_STATE(19677)] = 565877,
  [SMALL_STATE(19678)] = 565887,
  [SMALL_STATE(19679)] = 565897,
  [SMALL_STATE(19680)] = 565907,
  [SMALL_STATE(19681)] = 565917,
  [SMALL_STATE(19682)] = 565927,
  [SMALL_STATE(19683)] = 565937,
  [SMALL_STATE(19684)] = 565947,
  [SMALL_STATE(19685)] = 565957,
  [SMALL_STATE(19686)] = 565967,
  [SMALL_STATE(19687)] = 565977,
  [SMALL_STATE(19688)] = 565987,
  [SMALL_STATE(19689)] = 565997,
  [SMALL_STATE(19690)] = 566007,
  [SMALL_STATE(19691)] = 566017,
  [SMALL_STATE(19692)] = 566027,
  [SMALL_STATE(19693)] = 566037,
  [SMALL_STATE(19694)] = 566047,
  [SMALL_STATE(19695)] = 566057,
  [SMALL_STATE(19696)] = 566067,
  [SMALL_STATE(19697)] = 566077,
  [SMALL_STATE(19698)] = 566087,
  [SMALL_STATE(19699)] = 566097,
  [SMALL_STATE(19700)] = 566107,
  [SMALL_STATE(19701)] = 566117,
  [SMALL_STATE(19702)] = 566127,
  [SMALL_STATE(19703)] = 566137,
  [SMALL_STATE(19704)] = 566147,
  [SMALL_STATE(19705)] = 566157,
  [SMALL_STATE(19706)] = 566167,
  [SMALL_STATE(19707)] = 566177,
  [SMALL_STATE(19708)] = 566187,
  [SMALL_STATE(19709)] = 566197,
  [SMALL_STATE(19710)] = 566207,
  [SMALL_STATE(19711)] = 566217,
  [SMALL_STATE(19712)] = 566227,
  [SMALL_STATE(19713)] = 566237,
  [SMALL_STATE(19714)] = 566247,
  [SMALL_STATE(19715)] = 566257,
  [SMALL_STATE(19716)] = 566267,
  [SMALL_STATE(19717)] = 566277,
  [SMALL_STATE(19718)] = 566287,
  [SMALL_STATE(19719)] = 566297,
  [SMALL_STATE(19720)] = 566307,
  [SMALL_STATE(19721)] = 566317,
  [SMALL_STATE(19722)] = 566327,
  [SMALL_STATE(19723)] = 566337,
  [SMALL_STATE(19724)] = 566347,
  [SMALL_STATE(19725)] = 566357,
  [SMALL_STATE(19726)] = 566367,
  [SMALL_STATE(19727)] = 566377,
  [SMALL_STATE(19728)] = 566387,
  [SMALL_STATE(19729)] = 566397,
  [SMALL_STATE(19730)] = 566407,
  [SMALL_STATE(19731)] = 566417,
  [SMALL_STATE(19732)] = 566427,
  [SMALL_STATE(19733)] = 566437,
  [SMALL_STATE(19734)] = 566447,
  [SMALL_STATE(19735)] = 566457,
  [SMALL_STATE(19736)] = 566467,
  [SMALL_STATE(19737)] = 566477,
  [SMALL_STATE(19738)] = 566487,
  [SMALL_STATE(19739)] = 566497,
  [SMALL_STATE(19740)] = 566507,
  [SMALL_STATE(19741)] = 566517,
  [SMALL_STATE(19742)] = 566527,
  [SMALL_STATE(19743)] = 566537,
  [SMALL_STATE(19744)] = 566547,
  [SMALL_STATE(19745)] = 566557,
  [SMALL_STATE(19746)] = 566567,
  [SMALL_STATE(19747)] = 566577,
  [SMALL_STATE(19748)] = 566587,
  [SMALL_STATE(19749)] = 566597,
  [SMALL_STATE(19750)] = 566607,
  [SMALL_STATE(19751)] = 566617,
  [SMALL_STATE(19752)] = 566627,
  [SMALL_STATE(19753)] = 566637,
  [SMALL_STATE(19754)] = 566647,
  [SMALL_STATE(19755)] = 566657,
  [SMALL_STATE(19756)] = 566667,
  [SMALL_STATE(19757)] = 566677,
  [SMALL_STATE(19758)] = 566687,
  [SMALL_STATE(19759)] = 566697,
  [SMALL_STATE(19760)] = 566707,
  [SMALL_STATE(19761)] = 566717,
  [SMALL_STATE(19762)] = 566727,
  [SMALL_STATE(19763)] = 566737,
  [SMALL_STATE(19764)] = 566747,
  [SMALL_STATE(19765)] = 566757,
  [SMALL_STATE(19766)] = 566767,
  [SMALL_STATE(19767)] = 566777,
  [SMALL_STATE(19768)] = 566787,
  [SMALL_STATE(19769)] = 566797,
  [SMALL_STATE(19770)] = 566807,
  [SMALL_STATE(19771)] = 566817,
  [SMALL_STATE(19772)] = 566827,
  [SMALL_STATE(19773)] = 566837,
  [SMALL_STATE(19774)] = 566847,
  [SMALL_STATE(19775)] = 566857,
  [SMALL_STATE(19776)] = 566867,
  [SMALL_STATE(19777)] = 566877,
  [SMALL_STATE(19778)] = 566887,
  [SMALL_STATE(19779)] = 566897,
  [SMALL_STATE(19780)] = 566907,
  [SMALL_STATE(19781)] = 566917,
  [SMALL_STATE(19782)] = 566927,
  [SMALL_STATE(19783)] = 566937,
  [SMALL_STATE(19784)] = 566947,
  [SMALL_STATE(19785)] = 566957,
  [SMALL_STATE(19786)] = 566967,
  [SMALL_STATE(19787)] = 566977,
  [SMALL_STATE(19788)] = 566987,
  [SMALL_STATE(19789)] = 566997,
  [SMALL_STATE(19790)] = 567007,
  [SMALL_STATE(19791)] = 567017,
  [SMALL_STATE(19792)] = 567027,
  [SMALL_STATE(19793)] = 567037,
  [SMALL_STATE(19794)] = 567047,
  [SMALL_STATE(19795)] = 567057,
  [SMALL_STATE(19796)] = 567067,
  [SMALL_STATE(19797)] = 567077,
  [SMALL_STATE(19798)] = 567087,
  [SMALL_STATE(19799)] = 567097,
  [SMALL_STATE(19800)] = 567107,
  [SMALL_STATE(19801)] = 567117,
  [SMALL_STATE(19802)] = 567127,
  [SMALL_STATE(19803)] = 567137,
  [SMALL_STATE(19804)] = 567147,
  [SMALL_STATE(19805)] = 567157,
  [SMALL_STATE(19806)] = 567167,
  [SMALL_STATE(19807)] = 567177,
  [SMALL_STATE(19808)] = 567187,
  [SMALL_STATE(19809)] = 567197,
  [SMALL_STATE(19810)] = 567207,
  [SMALL_STATE(19811)] = 567217,
  [SMALL_STATE(19812)] = 567227,
  [SMALL_STATE(19813)] = 567237,
  [SMALL_STATE(19814)] = 567247,
  [SMALL_STATE(19815)] = 567257,
  [SMALL_STATE(19816)] = 567267,
  [SMALL_STATE(19817)] = 567277,
  [SMALL_STATE(19818)] = 567287,
  [SMALL_STATE(19819)] = 567297,
  [SMALL_STATE(19820)] = 567307,
  [SMALL_STATE(19821)] = 567317,
  [SMALL_STATE(19822)] = 567327,
  [SMALL_STATE(19823)] = 567337,
  [SMALL_STATE(19824)] = 567347,
  [SMALL_STATE(19825)] = 567357,
  [SMALL_STATE(19826)] = 567367,
  [SMALL_STATE(19827)] = 567377,
  [SMALL_STATE(19828)] = 567387,
  [SMALL_STATE(19829)] = 567397,
  [SMALL_STATE(19830)] = 567407,
  [SMALL_STATE(19831)] = 567417,
  [SMALL_STATE(19832)] = 567427,
  [SMALL_STATE(19833)] = 567437,
  [SMALL_STATE(19834)] = 567447,
  [SMALL_STATE(19835)] = 567457,
  [SMALL_STATE(19836)] = 567467,
  [SMALL_STATE(19837)] = 567477,
  [SMALL_STATE(19838)] = 567487,
  [SMALL_STATE(19839)] = 567497,
  [SMALL_STATE(19840)] = 567507,
  [SMALL_STATE(19841)] = 567517,
  [SMALL_STATE(19842)] = 567527,
  [SMALL_STATE(19843)] = 567537,
  [SMALL_STATE(19844)] = 567547,
  [SMALL_STATE(19845)] = 567557,
  [SMALL_STATE(19846)] = 567567,
  [SMALL_STATE(19847)] = 567577,
  [SMALL_STATE(19848)] = 567587,
  [SMALL_STATE(19849)] = 567597,
  [SMALL_STATE(19850)] = 567607,
  [SMALL_STATE(19851)] = 567617,
  [SMALL_STATE(19852)] = 567627,
  [SMALL_STATE(19853)] = 567637,
  [SMALL_STATE(19854)] = 567647,
  [SMALL_STATE(19855)] = 567657,
  [SMALL_STATE(19856)] = 567667,
  [SMALL_STATE(19857)] = 567677,
  [SMALL_STATE(19858)] = 567687,
  [SMALL_STATE(19859)] = 567697,
  [SMALL_STATE(19860)] = 567707,
  [SMALL_STATE(19861)] = 567717,
  [SMALL_STATE(19862)] = 567727,
  [SMALL_STATE(19863)] = 567737,
  [SMALL_STATE(19864)] = 567747,
  [SMALL_STATE(19865)] = 567757,
  [SMALL_STATE(19866)] = 567767,
  [SMALL_STATE(19867)] = 567777,
  [SMALL_STATE(19868)] = 567787,
  [SMALL_STATE(19869)] = 567797,
  [SMALL_STATE(19870)] = 567807,
  [SMALL_STATE(19871)] = 567817,
  [SMALL_STATE(19872)] = 567827,
  [SMALL_STATE(19873)] = 567837,
  [SMALL_STATE(19874)] = 567847,
  [SMALL_STATE(19875)] = 567857,
  [SMALL_STATE(19876)] = 567867,
  [SMALL_STATE(19877)] = 567877,
  [SMALL_STATE(19878)] = 567887,
  [SMALL_STATE(19879)] = 567897,
  [SMALL_STATE(19880)] = 567907,
  [SMALL_STATE(19881)] = 567917,
  [SMALL_STATE(19882)] = 567927,
  [SMALL_STATE(19883)] = 567937,
  [SMALL_STATE(19884)] = 567947,
  [SMALL_STATE(19885)] = 567957,
  [SMALL_STATE(19886)] = 567967,
  [SMALL_STATE(19887)] = 567977,
  [SMALL_STATE(19888)] = 567987,
  [SMALL_STATE(19889)] = 567997,
  [SMALL_STATE(19890)] = 568007,
  [SMALL_STATE(19891)] = 568017,
  [SMALL_STATE(19892)] = 568027,
  [SMALL_STATE(19893)] = 568037,
  [SMALL_STATE(19894)] = 568047,
  [SMALL_STATE(19895)] = 568057,
  [SMALL_STATE(19896)] = 568067,
  [SMALL_STATE(19897)] = 568077,
  [SMALL_STATE(19898)] = 568087,
  [SMALL_STATE(19899)] = 568097,
  [SMALL_STATE(19900)] = 568107,
  [SMALL_STATE(19901)] = 568117,
  [SMALL_STATE(19902)] = 568127,
  [SMALL_STATE(19903)] = 568137,
  [SMALL_STATE(19904)] = 568147,
  [SMALL_STATE(19905)] = 568157,
  [SMALL_STATE(19906)] = 568167,
  [SMALL_STATE(19907)] = 568177,
  [SMALL_STATE(19908)] = 568187,
  [SMALL_STATE(19909)] = 568197,
  [SMALL_STATE(19910)] = 568207,
  [SMALL_STATE(19911)] = 568217,
  [SMALL_STATE(19912)] = 568227,
  [SMALL_STATE(19913)] = 568237,
  [SMALL_STATE(19914)] = 568247,
  [SMALL_STATE(19915)] = 568257,
  [SMALL_STATE(19916)] = 568267,
  [SMALL_STATE(19917)] = 568277,
  [SMALL_STATE(19918)] = 568287,
  [SMALL_STATE(19919)] = 568297,
  [SMALL_STATE(19920)] = 568307,
  [SMALL_STATE(19921)] = 568317,
  [SMALL_STATE(19922)] = 568327,
  [SMALL_STATE(19923)] = 568337,
  [SMALL_STATE(19924)] = 568347,
  [SMALL_STATE(19925)] = 568357,
  [SMALL_STATE(19926)] = 568367,
  [SMALL_STATE(19927)] = 568377,
  [SMALL_STATE(19928)] = 568387,
  [SMALL_STATE(19929)] = 568397,
  [SMALL_STATE(19930)] = 568407,
  [SMALL_STATE(19931)] = 568417,
  [SMALL_STATE(19932)] = 568427,
  [SMALL_STATE(19933)] = 568437,
  [SMALL_STATE(19934)] = 568447,
  [SMALL_STATE(19935)] = 568457,
  [SMALL_STATE(19936)] = 568467,
  [SMALL_STATE(19937)] = 568477,
  [SMALL_STATE(19938)] = 568487,
  [SMALL_STATE(19939)] = 568497,
  [SMALL_STATE(19940)] = 568507,
  [SMALL_STATE(19941)] = 568517,
  [SMALL_STATE(19942)] = 568527,
  [SMALL_STATE(19943)] = 568537,
  [SMALL_STATE(19944)] = 568547,
  [SMALL_STATE(19945)] = 568557,
  [SMALL_STATE(19946)] = 568567,
  [SMALL_STATE(19947)] = 568577,
  [SMALL_STATE(19948)] = 568587,
  [SMALL_STATE(19949)] = 568597,
  [SMALL_STATE(19950)] = 568607,
  [SMALL_STATE(19951)] = 568617,
  [SMALL_STATE(19952)] = 568627,
  [SMALL_STATE(19953)] = 568637,
  [SMALL_STATE(19954)] = 568647,
  [SMALL_STATE(19955)] = 568657,
  [SMALL_STATE(19956)] = 568667,
  [SMALL_STATE(19957)] = 568677,
  [SMALL_STATE(19958)] = 568687,
  [SMALL_STATE(19959)] = 568697,
  [SMALL_STATE(19960)] = 568707,
  [SMALL_STATE(19961)] = 568717,
  [SMALL_STATE(19962)] = 568727,
  [SMALL_STATE(19963)] = 568737,
  [SMALL_STATE(19964)] = 568747,
  [SMALL_STATE(19965)] = 568757,
  [SMALL_STATE(19966)] = 568767,
  [SMALL_STATE(19967)] = 568777,
  [SMALL_STATE(19968)] = 568787,
  [SMALL_STATE(19969)] = 568797,
  [SMALL_STATE(19970)] = 568807,
  [SMALL_STATE(19971)] = 568817,
  [SMALL_STATE(19972)] = 568827,
  [SMALL_STATE(19973)] = 568837,
  [SMALL_STATE(19974)] = 568847,
  [SMALL_STATE(19975)] = 568857,
  [SMALL_STATE(19976)] = 568867,
  [SMALL_STATE(19977)] = 568877,
  [SMALL_STATE(19978)] = 568887,
  [SMALL_STATE(19979)] = 568897,
  [SMALL_STATE(19980)] = 568907,
  [SMALL_STATE(19981)] = 568917,
  [SMALL_STATE(19982)] = 568927,
  [SMALL_STATE(19983)] = 568937,
  [SMALL_STATE(19984)] = 568947,
  [SMALL_STATE(19985)] = 568957,
  [SMALL_STATE(19986)] = 568967,
  [SMALL_STATE(19987)] = 568977,
  [SMALL_STATE(19988)] = 568987,
  [SMALL_STATE(19989)] = 568997,
  [SMALL_STATE(19990)] = 569007,
  [SMALL_STATE(19991)] = 569017,
  [SMALL_STATE(19992)] = 569027,
  [SMALL_STATE(19993)] = 569037,
  [SMALL_STATE(19994)] = 569047,
  [SMALL_STATE(19995)] = 569057,
  [SMALL_STATE(19996)] = 569067,
  [SMALL_STATE(19997)] = 569077,
  [SMALL_STATE(19998)] = 569087,
  [SMALL_STATE(19999)] = 569097,
  [SMALL_STATE(20000)] = 569107,
  [SMALL_STATE(20001)] = 569117,
  [SMALL_STATE(20002)] = 569127,
  [SMALL_STATE(20003)] = 569137,
  [SMALL_STATE(20004)] = 569147,
  [SMALL_STATE(20005)] = 569157,
  [SMALL_STATE(20006)] = 569167,
  [SMALL_STATE(20007)] = 569177,
  [SMALL_STATE(20008)] = 569187,
  [SMALL_STATE(20009)] = 569197,
  [SMALL_STATE(20010)] = 569207,
  [SMALL_STATE(20011)] = 569217,
  [SMALL_STATE(20012)] = 569227,
  [SMALL_STATE(20013)] = 569237,
  [SMALL_STATE(20014)] = 569247,
  [SMALL_STATE(20015)] = 569257,
  [SMALL_STATE(20016)] = 569267,
  [SMALL_STATE(20017)] = 569277,
  [SMALL_STATE(20018)] = 569287,
  [SMALL_STATE(20019)] = 569297,
  [SMALL_STATE(20020)] = 569307,
  [SMALL_STATE(20021)] = 569317,
  [SMALL_STATE(20022)] = 569327,
  [SMALL_STATE(20023)] = 569337,
  [SMALL_STATE(20024)] = 569347,
  [SMALL_STATE(20025)] = 569357,
  [SMALL_STATE(20026)] = 569367,
  [SMALL_STATE(20027)] = 569377,
  [SMALL_STATE(20028)] = 569387,
  [SMALL_STATE(20029)] = 569397,
  [SMALL_STATE(20030)] = 569407,
  [SMALL_STATE(20031)] = 569417,
  [SMALL_STATE(20032)] = 569427,
  [SMALL_STATE(20033)] = 569437,
  [SMALL_STATE(20034)] = 569447,
  [SMALL_STATE(20035)] = 569457,
  [SMALL_STATE(20036)] = 569467,
  [SMALL_STATE(20037)] = 569477,
  [SMALL_STATE(20038)] = 569487,
  [SMALL_STATE(20039)] = 569497,
  [SMALL_STATE(20040)] = 569507,
  [SMALL_STATE(20041)] = 569517,
  [SMALL_STATE(20042)] = 569527,
  [SMALL_STATE(20043)] = 569537,
  [SMALL_STATE(20044)] = 569547,
  [SMALL_STATE(20045)] = 569557,
  [SMALL_STATE(20046)] = 569567,
  [SMALL_STATE(20047)] = 569577,
  [SMALL_STATE(20048)] = 569587,
  [SMALL_STATE(20049)] = 569597,
  [SMALL_STATE(20050)] = 569607,
  [SMALL_STATE(20051)] = 569617,
  [SMALL_STATE(20052)] = 569627,
  [SMALL_STATE(20053)] = 569637,
  [SMALL_STATE(20054)] = 569647,
  [SMALL_STATE(20055)] = 569657,
  [SMALL_STATE(20056)] = 569667,
  [SMALL_STATE(20057)] = 569677,
  [SMALL_STATE(20058)] = 569687,
  [SMALL_STATE(20059)] = 569697,
  [SMALL_STATE(20060)] = 569707,
  [SMALL_STATE(20061)] = 569717,
  [SMALL_STATE(20062)] = 569727,
  [SMALL_STATE(20063)] = 569737,
  [SMALL_STATE(20064)] = 569747,
  [SMALL_STATE(20065)] = 569757,
  [SMALL_STATE(20066)] = 569767,
  [SMALL_STATE(20067)] = 569777,
  [SMALL_STATE(20068)] = 569787,
  [SMALL_STATE(20069)] = 569797,
  [SMALL_STATE(20070)] = 569807,
  [SMALL_STATE(20071)] = 569817,
  [SMALL_STATE(20072)] = 569827,
  [SMALL_STATE(20073)] = 569837,
  [SMALL_STATE(20074)] = 569847,
  [SMALL_STATE(20075)] = 569857,
  [SMALL_STATE(20076)] = 569867,
  [SMALL_STATE(20077)] = 569877,
  [SMALL_STATE(20078)] = 569887,
  [SMALL_STATE(20079)] = 569897,
  [SMALL_STATE(20080)] = 569907,
  [SMALL_STATE(20081)] = 569917,
  [SMALL_STATE(20082)] = 569927,
  [SMALL_STATE(20083)] = 569937,
  [SMALL_STATE(20084)] = 569947,
  [SMALL_STATE(20085)] = 569957,
  [SMALL_STATE(20086)] = 569967,
  [SMALL_STATE(20087)] = 569977,
  [SMALL_STATE(20088)] = 569987,
  [SMALL_STATE(20089)] = 569997,
  [SMALL_STATE(20090)] = 570007,
  [SMALL_STATE(20091)] = 570017,
  [SMALL_STATE(20092)] = 570027,
  [SMALL_STATE(20093)] = 570037,
  [SMALL_STATE(20094)] = 570047,
  [SMALL_STATE(20095)] = 570057,
  [SMALL_STATE(20096)] = 570067,
  [SMALL_STATE(20097)] = 570077,
  [SMALL_STATE(20098)] = 570087,
  [SMALL_STATE(20099)] = 570097,
  [SMALL_STATE(20100)] = 570107,
  [SMALL_STATE(20101)] = 570117,
  [SMALL_STATE(20102)] = 570127,
  [SMALL_STATE(20103)] = 570137,
  [SMALL_STATE(20104)] = 570147,
  [SMALL_STATE(20105)] = 570157,
  [SMALL_STATE(20106)] = 570167,
  [SMALL_STATE(20107)] = 570177,
  [SMALL_STATE(20108)] = 570187,
  [SMALL_STATE(20109)] = 570197,
  [SMALL_STATE(20110)] = 570207,
  [SMALL_STATE(20111)] = 570217,
  [SMALL_STATE(20112)] = 570227,
  [SMALL_STATE(20113)] = 570237,
  [SMALL_STATE(20114)] = 570247,
  [SMALL_STATE(20115)] = 570257,
  [SMALL_STATE(20116)] = 570267,
  [SMALL_STATE(20117)] = 570277,
  [SMALL_STATE(20118)] = 570287,
  [SMALL_STATE(20119)] = 570297,
  [SMALL_STATE(20120)] = 570307,
  [SMALL_STATE(20121)] = 570317,
  [SMALL_STATE(20122)] = 570327,
  [SMALL_STATE(20123)] = 570337,
  [SMALL_STATE(20124)] = 570347,
  [SMALL_STATE(20125)] = 570357,
  [SMALL_STATE(20126)] = 570367,
  [SMALL_STATE(20127)] = 570377,
  [SMALL_STATE(20128)] = 570387,
  [SMALL_STATE(20129)] = 570397,
  [SMALL_STATE(20130)] = 570407,
  [SMALL_STATE(20131)] = 570417,
  [SMALL_STATE(20132)] = 570427,
  [SMALL_STATE(20133)] = 570437,
  [SMALL_STATE(20134)] = 570447,
  [SMALL_STATE(20135)] = 570457,
  [SMALL_STATE(20136)] = 570467,
  [SMALL_STATE(20137)] = 570477,
  [SMALL_STATE(20138)] = 570487,
  [SMALL_STATE(20139)] = 570497,
  [SMALL_STATE(20140)] = 570507,
  [SMALL_STATE(20141)] = 570517,
  [SMALL_STATE(20142)] = 570527,
  [SMALL_STATE(20143)] = 570537,
  [SMALL_STATE(20144)] = 570547,
  [SMALL_STATE(20145)] = 570557,
  [SMALL_STATE(20146)] = 570567,
  [SMALL_STATE(20147)] = 570577,
  [SMALL_STATE(20148)] = 570587,
  [SMALL_STATE(20149)] = 570597,
  [SMALL_STATE(20150)] = 570607,
  [SMALL_STATE(20151)] = 570617,
  [SMALL_STATE(20152)] = 570627,
  [SMALL_STATE(20153)] = 570637,
  [SMALL_STATE(20154)] = 570647,
  [SMALL_STATE(20155)] = 570657,
  [SMALL_STATE(20156)] = 570667,
  [SMALL_STATE(20157)] = 570677,
  [SMALL_STATE(20158)] = 570687,
  [SMALL_STATE(20159)] = 570697,
  [SMALL_STATE(20160)] = 570707,
  [SMALL_STATE(20161)] = 570717,
  [SMALL_STATE(20162)] = 570727,
  [SMALL_STATE(20163)] = 570737,
  [SMALL_STATE(20164)] = 570747,
  [SMALL_STATE(20165)] = 570757,
  [SMALL_STATE(20166)] = 570767,
  [SMALL_STATE(20167)] = 570777,
  [SMALL_STATE(20168)] = 570787,
  [SMALL_STATE(20169)] = 570797,
  [SMALL_STATE(20170)] = 570807,
  [SMALL_STATE(20171)] = 570817,
  [SMALL_STATE(20172)] = 570827,
  [SMALL_STATE(20173)] = 570837,
  [SMALL_STATE(20174)] = 570847,
  [SMALL_STATE(20175)] = 570857,
  [SMALL_STATE(20176)] = 570867,
  [SMALL_STATE(20177)] = 570877,
  [SMALL_STATE(20178)] = 570887,
  [SMALL_STATE(20179)] = 570897,
  [SMALL_STATE(20180)] = 570907,
  [SMALL_STATE(20181)] = 570917,
  [SMALL_STATE(20182)] = 570927,
  [SMALL_STATE(20183)] = 570937,
  [SMALL_STATE(20184)] = 570947,
  [SMALL_STATE(20185)] = 570957,
  [SMALL_STATE(20186)] = 570967,
  [SMALL_STATE(20187)] = 570977,
  [SMALL_STATE(20188)] = 570987,
  [SMALL_STATE(20189)] = 570997,
  [SMALL_STATE(20190)] = 571007,
  [SMALL_STATE(20191)] = 571017,
  [SMALL_STATE(20192)] = 571027,
  [SMALL_STATE(20193)] = 571037,
  [SMALL_STATE(20194)] = 571047,
  [SMALL_STATE(20195)] = 571057,
  [SMALL_STATE(20196)] = 571067,
  [SMALL_STATE(20197)] = 571077,
  [SMALL_STATE(20198)] = 571087,
  [SMALL_STATE(20199)] = 571097,
  [SMALL_STATE(20200)] = 571107,
  [SMALL_STATE(20201)] = 571117,
  [SMALL_STATE(20202)] = 571127,
  [SMALL_STATE(20203)] = 571137,
  [SMALL_STATE(20204)] = 571147,
  [SMALL_STATE(20205)] = 571157,
  [SMALL_STATE(20206)] = 571167,
  [SMALL_STATE(20207)] = 571177,
  [SMALL_STATE(20208)] = 571187,
  [SMALL_STATE(20209)] = 571197,
  [SMALL_STATE(20210)] = 571207,
  [SMALL_STATE(20211)] = 571217,
  [SMALL_STATE(20212)] = 571227,
  [SMALL_STATE(20213)] = 571237,
  [SMALL_STATE(20214)] = 571247,
  [SMALL_STATE(20215)] = 571257,
  [SMALL_STATE(20216)] = 571267,
  [SMALL_STATE(20217)] = 571277,
  [SMALL_STATE(20218)] = 571287,
  [SMALL_STATE(20219)] = 571297,
  [SMALL_STATE(20220)] = 571307,
  [SMALL_STATE(20221)] = 571317,
  [SMALL_STATE(20222)] = 571327,
  [SMALL_STATE(20223)] = 571337,
  [SMALL_STATE(20224)] = 571347,
  [SMALL_STATE(20225)] = 571357,
  [SMALL_STATE(20226)] = 571367,
  [SMALL_STATE(20227)] = 571377,
  [SMALL_STATE(20228)] = 571387,
  [SMALL_STATE(20229)] = 571397,
  [SMALL_STATE(20230)] = 571407,
  [SMALL_STATE(20231)] = 571417,
  [SMALL_STATE(20232)] = 571427,
  [SMALL_STATE(20233)] = 571437,
  [SMALL_STATE(20234)] = 571447,
  [SMALL_STATE(20235)] = 571457,
  [SMALL_STATE(20236)] = 571467,
  [SMALL_STATE(20237)] = 571477,
  [SMALL_STATE(20238)] = 571487,
  [SMALL_STATE(20239)] = 571497,
  [SMALL_STATE(20240)] = 571507,
  [SMALL_STATE(20241)] = 571517,
  [SMALL_STATE(20242)] = 571527,
  [SMALL_STATE(20243)] = 571537,
  [SMALL_STATE(20244)] = 571547,
  [SMALL_STATE(20245)] = 571557,
  [SMALL_STATE(20246)] = 571567,
  [SMALL_STATE(20247)] = 571577,
  [SMALL_STATE(20248)] = 571587,
  [SMALL_STATE(20249)] = 571597,
  [SMALL_STATE(20250)] = 571607,
  [SMALL_STATE(20251)] = 571617,
  [SMALL_STATE(20252)] = 571627,
  [SMALL_STATE(20253)] = 571637,
  [SMALL_STATE(20254)] = 571647,
  [SMALL_STATE(20255)] = 571657,
  [SMALL_STATE(20256)] = 571667,
  [SMALL_STATE(20257)] = 571677,
  [SMALL_STATE(20258)] = 571687,
  [SMALL_STATE(20259)] = 571697,
  [SMALL_STATE(20260)] = 571707,
  [SMALL_STATE(20261)] = 571717,
  [SMALL_STATE(20262)] = 571727,
  [SMALL_STATE(20263)] = 571737,
  [SMALL_STATE(20264)] = 571747,
  [SMALL_STATE(20265)] = 571757,
  [SMALL_STATE(20266)] = 571767,
  [SMALL_STATE(20267)] = 571777,
  [SMALL_STATE(20268)] = 571787,
  [SMALL_STATE(20269)] = 571797,
  [SMALL_STATE(20270)] = 571807,
  [SMALL_STATE(20271)] = 571817,
  [SMALL_STATE(20272)] = 571827,
  [SMALL_STATE(20273)] = 571837,
  [SMALL_STATE(20274)] = 571847,
  [SMALL_STATE(20275)] = 571857,
  [SMALL_STATE(20276)] = 571867,
  [SMALL_STATE(20277)] = 571877,
  [SMALL_STATE(20278)] = 571887,
  [SMALL_STATE(20279)] = 571897,
  [SMALL_STATE(20280)] = 571907,
  [SMALL_STATE(20281)] = 571917,
  [SMALL_STATE(20282)] = 571927,
  [SMALL_STATE(20283)] = 571937,
  [SMALL_STATE(20284)] = 571947,
  [SMALL_STATE(20285)] = 571957,
  [SMALL_STATE(20286)] = 571967,
  [SMALL_STATE(20287)] = 571977,
  [SMALL_STATE(20288)] = 571987,
  [SMALL_STATE(20289)] = 571997,
  [SMALL_STATE(20290)] = 572007,
  [SMALL_STATE(20291)] = 572017,
  [SMALL_STATE(20292)] = 572027,
  [SMALL_STATE(20293)] = 572037,
  [SMALL_STATE(20294)] = 572047,
  [SMALL_STATE(20295)] = 572057,
  [SMALL_STATE(20296)] = 572067,
  [SMALL_STATE(20297)] = 572077,
  [SMALL_STATE(20298)] = 572087,
  [SMALL_STATE(20299)] = 572097,
  [SMALL_STATE(20300)] = 572107,
  [SMALL_STATE(20301)] = 572117,
  [SMALL_STATE(20302)] = 572127,
  [SMALL_STATE(20303)] = 572137,
  [SMALL_STATE(20304)] = 572147,
  [SMALL_STATE(20305)] = 572157,
  [SMALL_STATE(20306)] = 572167,
  [SMALL_STATE(20307)] = 572177,
  [SMALL_STATE(20308)] = 572187,
  [SMALL_STATE(20309)] = 572197,
  [SMALL_STATE(20310)] = 572207,
  [SMALL_STATE(20311)] = 572217,
  [SMALL_STATE(20312)] = 572227,
  [SMALL_STATE(20313)] = 572237,
  [SMALL_STATE(20314)] = 572247,
  [SMALL_STATE(20315)] = 572257,
  [SMALL_STATE(20316)] = 572267,
  [SMALL_STATE(20317)] = 572277,
  [SMALL_STATE(20318)] = 572287,
  [SMALL_STATE(20319)] = 572297,
  [SMALL_STATE(20320)] = 572307,
  [SMALL_STATE(20321)] = 572317,
  [SMALL_STATE(20322)] = 572327,
  [SMALL_STATE(20323)] = 572337,
  [SMALL_STATE(20324)] = 572347,
  [SMALL_STATE(20325)] = 572357,
  [SMALL_STATE(20326)] = 572367,
  [SMALL_STATE(20327)] = 572377,
  [SMALL_STATE(20328)] = 572387,
  [SMALL_STATE(20329)] = 572397,
  [SMALL_STATE(20330)] = 572407,
  [SMALL_STATE(20331)] = 572417,
  [SMALL_STATE(20332)] = 572427,
  [SMALL_STATE(20333)] = 572437,
  [SMALL_STATE(20334)] = 572447,
  [SMALL_STATE(20335)] = 572457,
  [SMALL_STATE(20336)] = 572467,
  [SMALL_STATE(20337)] = 572477,
  [SMALL_STATE(20338)] = 572487,
  [SMALL_STATE(20339)] = 572497,
  [SMALL_STATE(20340)] = 572507,
  [SMALL_STATE(20341)] = 572517,
  [SMALL_STATE(20342)] = 572527,
  [SMALL_STATE(20343)] = 572537,
  [SMALL_STATE(20344)] = 572547,
  [SMALL_STATE(20345)] = 572557,
  [SMALL_STATE(20346)] = 572567,
  [SMALL_STATE(20347)] = 572577,
  [SMALL_STATE(20348)] = 572587,
  [SMALL_STATE(20349)] = 572597,
  [SMALL_STATE(20350)] = 572607,
  [SMALL_STATE(20351)] = 572617,
  [SMALL_STATE(20352)] = 572627,
  [SMALL_STATE(20353)] = 572637,
  [SMALL_STATE(20354)] = 572647,
  [SMALL_STATE(20355)] = 572657,
  [SMALL_STATE(20356)] = 572667,
  [SMALL_STATE(20357)] = 572677,
  [SMALL_STATE(20358)] = 572687,
  [SMALL_STATE(20359)] = 572697,
  [SMALL_STATE(20360)] = 572707,
  [SMALL_STATE(20361)] = 572717,
  [SMALL_STATE(20362)] = 572727,
  [SMALL_STATE(20363)] = 572737,
  [SMALL_STATE(20364)] = 572747,
  [SMALL_STATE(20365)] = 572757,
  [SMALL_STATE(20366)] = 572767,
  [SMALL_STATE(20367)] = 572777,
  [SMALL_STATE(20368)] = 572787,
  [SMALL_STATE(20369)] = 572797,
  [SMALL_STATE(20370)] = 572807,
  [SMALL_STATE(20371)] = 572817,
  [SMALL_STATE(20372)] = 572827,
  [SMALL_STATE(20373)] = 572837,
  [SMALL_STATE(20374)] = 572847,
  [SMALL_STATE(20375)] = 572857,
  [SMALL_STATE(20376)] = 572867,
  [SMALL_STATE(20377)] = 572877,
  [SMALL_STATE(20378)] = 572887,
  [SMALL_STATE(20379)] = 572897,
  [SMALL_STATE(20380)] = 572907,
  [SMALL_STATE(20381)] = 572917,
  [SMALL_STATE(20382)] = 572927,
  [SMALL_STATE(20383)] = 572937,
  [SMALL_STATE(20384)] = 572947,
  [SMALL_STATE(20385)] = 572957,
  [SMALL_STATE(20386)] = 572967,
  [SMALL_STATE(20387)] = 572977,
  [SMALL_STATE(20388)] = 572987,
  [SMALL_STATE(20389)] = 572997,
  [SMALL_STATE(20390)] = 573007,
  [SMALL_STATE(20391)] = 573017,
  [SMALL_STATE(20392)] = 573027,
  [SMALL_STATE(20393)] = 573037,
  [SMALL_STATE(20394)] = 573047,
  [SMALL_STATE(20395)] = 573057,
  [SMALL_STATE(20396)] = 573067,
  [SMALL_STATE(20397)] = 573077,
  [SMALL_STATE(20398)] = 573087,
  [SMALL_STATE(20399)] = 573097,
  [SMALL_STATE(20400)] = 573107,
  [SMALL_STATE(20401)] = 573117,
  [SMALL_STATE(20402)] = 573127,
  [SMALL_STATE(20403)] = 573137,
  [SMALL_STATE(20404)] = 573147,
  [SMALL_STATE(20405)] = 573157,
  [SMALL_STATE(20406)] = 573167,
  [SMALL_STATE(20407)] = 573177,
  [SMALL_STATE(20408)] = 573187,
  [SMALL_STATE(20409)] = 573197,
  [SMALL_STATE(20410)] = 573207,
  [SMALL_STATE(20411)] = 573217,
  [SMALL_STATE(20412)] = 573227,
  [SMALL_STATE(20413)] = 573237,
  [SMALL_STATE(20414)] = 573247,
  [SMALL_STATE(20415)] = 573257,
  [SMALL_STATE(20416)] = 573267,
  [SMALL_STATE(20417)] = 573277,
  [SMALL_STATE(20418)] = 573287,
  [SMALL_STATE(20419)] = 573297,
  [SMALL_STATE(20420)] = 573307,
  [SMALL_STATE(20421)] = 573317,
  [SMALL_STATE(20422)] = 573327,
  [SMALL_STATE(20423)] = 573337,
  [SMALL_STATE(20424)] = 573347,
  [SMALL_STATE(20425)] = 573357,
  [SMALL_STATE(20426)] = 573367,
  [SMALL_STATE(20427)] = 573377,
  [SMALL_STATE(20428)] = 573387,
  [SMALL_STATE(20429)] = 573397,
  [SMALL_STATE(20430)] = 573407,
  [SMALL_STATE(20431)] = 573417,
  [SMALL_STATE(20432)] = 573427,
  [SMALL_STATE(20433)] = 573437,
  [SMALL_STATE(20434)] = 573447,
  [SMALL_STATE(20435)] = 573457,
  [SMALL_STATE(20436)] = 573467,
  [SMALL_STATE(20437)] = 573477,
  [SMALL_STATE(20438)] = 573487,
  [SMALL_STATE(20439)] = 573497,
  [SMALL_STATE(20440)] = 573507,
  [SMALL_STATE(20441)] = 573517,
  [SMALL_STATE(20442)] = 573527,
  [SMALL_STATE(20443)] = 573537,
  [SMALL_STATE(20444)] = 573547,
  [SMALL_STATE(20445)] = 573557,
  [SMALL_STATE(20446)] = 573567,
  [SMALL_STATE(20447)] = 573577,
  [SMALL_STATE(20448)] = 573587,
  [SMALL_STATE(20449)] = 573597,
  [SMALL_STATE(20450)] = 573607,
  [SMALL_STATE(20451)] = 573617,
  [SMALL_STATE(20452)] = 573627,
  [SMALL_STATE(20453)] = 573637,
  [SMALL_STATE(20454)] = 573647,
  [SMALL_STATE(20455)] = 573657,
  [SMALL_STATE(20456)] = 573667,
  [SMALL_STATE(20457)] = 573677,
  [SMALL_STATE(20458)] = 573687,
  [SMALL_STATE(20459)] = 573697,
  [SMALL_STATE(20460)] = 573707,
  [SMALL_STATE(20461)] = 573717,
  [SMALL_STATE(20462)] = 573727,
  [SMALL_STATE(20463)] = 573737,
  [SMALL_STATE(20464)] = 573747,
  [SMALL_STATE(20465)] = 573757,
  [SMALL_STATE(20466)] = 573767,
  [SMALL_STATE(20467)] = 573777,
  [SMALL_STATE(20468)] = 573787,
  [SMALL_STATE(20469)] = 573797,
  [SMALL_STATE(20470)] = 573807,
  [SMALL_STATE(20471)] = 573817,
  [SMALL_STATE(20472)] = 573827,
  [SMALL_STATE(20473)] = 573837,
  [SMALL_STATE(20474)] = 573847,
  [SMALL_STATE(20475)] = 573857,
  [SMALL_STATE(20476)] = 573867,
  [SMALL_STATE(20477)] = 573877,
  [SMALL_STATE(20478)] = 573887,
  [SMALL_STATE(20479)] = 573897,
  [SMALL_STATE(20480)] = 573907,
  [SMALL_STATE(20481)] = 573917,
  [SMALL_STATE(20482)] = 573927,
  [SMALL_STATE(20483)] = 573937,
  [SMALL_STATE(20484)] = 573947,
  [SMALL_STATE(20485)] = 573957,
  [SMALL_STATE(20486)] = 573967,
  [SMALL_STATE(20487)] = 573977,
  [SMALL_STATE(20488)] = 573987,
  [SMALL_STATE(20489)] = 573997,
  [SMALL_STATE(20490)] = 574007,
  [SMALL_STATE(20491)] = 574017,
  [SMALL_STATE(20492)] = 574027,
  [SMALL_STATE(20493)] = 574037,
  [SMALL_STATE(20494)] = 574047,
  [SMALL_STATE(20495)] = 574057,
  [SMALL_STATE(20496)] = 574067,
  [SMALL_STATE(20497)] = 574077,
  [SMALL_STATE(20498)] = 574087,
  [SMALL_STATE(20499)] = 574097,
  [SMALL_STATE(20500)] = 574107,
  [SMALL_STATE(20501)] = 574117,
  [SMALL_STATE(20502)] = 574127,
  [SMALL_STATE(20503)] = 574137,
  [SMALL_STATE(20504)] = 574147,
  [SMALL_STATE(20505)] = 574157,
  [SMALL_STATE(20506)] = 574167,
  [SMALL_STATE(20507)] = 574177,
  [SMALL_STATE(20508)] = 574187,
  [SMALL_STATE(20509)] = 574197,
  [SMALL_STATE(20510)] = 574207,
  [SMALL_STATE(20511)] = 574217,
  [SMALL_STATE(20512)] = 574227,
  [SMALL_STATE(20513)] = 574237,
  [SMALL_STATE(20514)] = 574247,
  [SMALL_STATE(20515)] = 574257,
  [SMALL_STATE(20516)] = 574267,
  [SMALL_STATE(20517)] = 574277,
  [SMALL_STATE(20518)] = 574287,
  [SMALL_STATE(20519)] = 574297,
  [SMALL_STATE(20520)] = 574307,
  [SMALL_STATE(20521)] = 574317,
  [SMALL_STATE(20522)] = 574327,
  [SMALL_STATE(20523)] = 574337,
  [SMALL_STATE(20524)] = 574347,
  [SMALL_STATE(20525)] = 574357,
  [SMALL_STATE(20526)] = 574367,
  [SMALL_STATE(20527)] = 574377,
  [SMALL_STATE(20528)] = 574387,
  [SMALL_STATE(20529)] = 574397,
  [SMALL_STATE(20530)] = 574407,
  [SMALL_STATE(20531)] = 574417,
  [SMALL_STATE(20532)] = 574427,
  [SMALL_STATE(20533)] = 574437,
  [SMALL_STATE(20534)] = 574447,
  [SMALL_STATE(20535)] = 574457,
  [SMALL_STATE(20536)] = 574467,
  [SMALL_STATE(20537)] = 574477,
  [SMALL_STATE(20538)] = 574487,
  [SMALL_STATE(20539)] = 574497,
  [SMALL_STATE(20540)] = 574507,
  [SMALL_STATE(20541)] = 574517,
  [SMALL_STATE(20542)] = 574527,
  [SMALL_STATE(20543)] = 574537,
  [SMALL_STATE(20544)] = 574547,
  [SMALL_STATE(20545)] = 574557,
  [SMALL_STATE(20546)] = 574567,
  [SMALL_STATE(20547)] = 574577,
  [SMALL_STATE(20548)] = 574587,
  [SMALL_STATE(20549)] = 574597,
  [SMALL_STATE(20550)] = 574607,
  [SMALL_STATE(20551)] = 574617,
  [SMALL_STATE(20552)] = 574627,
  [SMALL_STATE(20553)] = 574637,
  [SMALL_STATE(20554)] = 574647,
  [SMALL_STATE(20555)] = 574657,
  [SMALL_STATE(20556)] = 574667,
  [SMALL_STATE(20557)] = 574677,
  [SMALL_STATE(20558)] = 574687,
  [SMALL_STATE(20559)] = 574697,
  [SMALL_STATE(20560)] = 574707,
  [SMALL_STATE(20561)] = 574717,
  [SMALL_STATE(20562)] = 574727,
  [SMALL_STATE(20563)] = 574737,
  [SMALL_STATE(20564)] = 574747,
  [SMALL_STATE(20565)] = 574757,
  [SMALL_STATE(20566)] = 574767,
  [SMALL_STATE(20567)] = 574777,
  [SMALL_STATE(20568)] = 574787,
  [SMALL_STATE(20569)] = 574797,
  [SMALL_STATE(20570)] = 574807,
  [SMALL_STATE(20571)] = 574817,
  [SMALL_STATE(20572)] = 574827,
  [SMALL_STATE(20573)] = 574837,
  [SMALL_STATE(20574)] = 574847,
  [SMALL_STATE(20575)] = 574857,
  [SMALL_STATE(20576)] = 574867,
  [SMALL_STATE(20577)] = 574877,
  [SMALL_STATE(20578)] = 574887,
  [SMALL_STATE(20579)] = 574897,
  [SMALL_STATE(20580)] = 574907,
  [SMALL_STATE(20581)] = 574917,
  [SMALL_STATE(20582)] = 574927,
  [SMALL_STATE(20583)] = 574937,
  [SMALL_STATE(20584)] = 574947,
  [SMALL_STATE(20585)] = 574957,
  [SMALL_STATE(20586)] = 574967,
  [SMALL_STATE(20587)] = 574977,
  [SMALL_STATE(20588)] = 574987,
  [SMALL_STATE(20589)] = 574997,
  [SMALL_STATE(20590)] = 575007,
  [SMALL_STATE(20591)] = 575017,
  [SMALL_STATE(20592)] = 575027,
  [SMALL_STATE(20593)] = 575037,
  [SMALL_STATE(20594)] = 575047,
  [SMALL_STATE(20595)] = 575057,
  [SMALL_STATE(20596)] = 575067,
  [SMALL_STATE(20597)] = 575077,
  [SMALL_STATE(20598)] = 575087,
  [SMALL_STATE(20599)] = 575097,
  [SMALL_STATE(20600)] = 575107,
  [SMALL_STATE(20601)] = 575117,
  [SMALL_STATE(20602)] = 575127,
  [SMALL_STATE(20603)] = 575137,
  [SMALL_STATE(20604)] = 575147,
  [SMALL_STATE(20605)] = 575157,
  [SMALL_STATE(20606)] = 575167,
  [SMALL_STATE(20607)] = 575177,
  [SMALL_STATE(20608)] = 575187,
  [SMALL_STATE(20609)] = 575197,
  [SMALL_STATE(20610)] = 575207,
  [SMALL_STATE(20611)] = 575217,
  [SMALL_STATE(20612)] = 575227,
  [SMALL_STATE(20613)] = 575237,
  [SMALL_STATE(20614)] = 575247,
  [SMALL_STATE(20615)] = 575257,
  [SMALL_STATE(20616)] = 575267,
  [SMALL_STATE(20617)] = 575277,
  [SMALL_STATE(20618)] = 575287,
  [SMALL_STATE(20619)] = 575297,
  [SMALL_STATE(20620)] = 575307,
  [SMALL_STATE(20621)] = 575317,
  [SMALL_STATE(20622)] = 575327,
  [SMALL_STATE(20623)] = 575337,
  [SMALL_STATE(20624)] = 575347,
  [SMALL_STATE(20625)] = 575357,
  [SMALL_STATE(20626)] = 575367,
  [SMALL_STATE(20627)] = 575377,
  [SMALL_STATE(20628)] = 575387,
  [SMALL_STATE(20629)] = 575397,
  [SMALL_STATE(20630)] = 575407,
  [SMALL_STATE(20631)] = 575417,
  [SMALL_STATE(20632)] = 575427,
  [SMALL_STATE(20633)] = 575437,
  [SMALL_STATE(20634)] = 575447,
  [SMALL_STATE(20635)] = 575457,
  [SMALL_STATE(20636)] = 575467,
  [SMALL_STATE(20637)] = 575477,
  [SMALL_STATE(20638)] = 575487,
  [SMALL_STATE(20639)] = 575497,
  [SMALL_STATE(20640)] = 575507,
  [SMALL_STATE(20641)] = 575517,
  [SMALL_STATE(20642)] = 575527,
  [SMALL_STATE(20643)] = 575537,
  [SMALL_STATE(20644)] = 575547,
  [SMALL_STATE(20645)] = 575557,
  [SMALL_STATE(20646)] = 575567,
  [SMALL_STATE(20647)] = 575577,
  [SMALL_STATE(20648)] = 575587,
  [SMALL_STATE(20649)] = 575597,
  [SMALL_STATE(20650)] = 575607,
  [SMALL_STATE(20651)] = 575617,
  [SMALL_STATE(20652)] = 575627,
  [SMALL_STATE(20653)] = 575637,
  [SMALL_STATE(20654)] = 575647,
  [SMALL_STATE(20655)] = 575657,
  [SMALL_STATE(20656)] = 575667,
  [SMALL_STATE(20657)] = 575677,
  [SMALL_STATE(20658)] = 575687,
  [SMALL_STATE(20659)] = 575697,
  [SMALL_STATE(20660)] = 575707,
  [SMALL_STATE(20661)] = 575717,
  [SMALL_STATE(20662)] = 575727,
  [SMALL_STATE(20663)] = 575737,
  [SMALL_STATE(20664)] = 575747,
  [SMALL_STATE(20665)] = 575757,
  [SMALL_STATE(20666)] = 575767,
  [SMALL_STATE(20667)] = 575777,
  [SMALL_STATE(20668)] = 575787,
  [SMALL_STATE(20669)] = 575797,
  [SMALL_STATE(20670)] = 575807,
  [SMALL_STATE(20671)] = 575817,
  [SMALL_STATE(20672)] = 575827,
  [SMALL_STATE(20673)] = 575837,
  [SMALL_STATE(20674)] = 575847,
  [SMALL_STATE(20675)] = 575857,
  [SMALL_STATE(20676)] = 575867,
  [SMALL_STATE(20677)] = 575877,
  [SMALL_STATE(20678)] = 575887,
  [SMALL_STATE(20679)] = 575897,
  [SMALL_STATE(20680)] = 575907,
  [SMALL_STATE(20681)] = 575917,
  [SMALL_STATE(20682)] = 575927,
  [SMALL_STATE(20683)] = 575937,
  [SMALL_STATE(20684)] = 575947,
  [SMALL_STATE(20685)] = 575957,
  [SMALL_STATE(20686)] = 575967,
  [SMALL_STATE(20687)] = 575977,
  [SMALL_STATE(20688)] = 575987,
  [SMALL_STATE(20689)] = 575997,
  [SMALL_STATE(20690)] = 576007,
  [SMALL_STATE(20691)] = 576017,
  [SMALL_STATE(20692)] = 576027,
  [SMALL_STATE(20693)] = 576037,
  [SMALL_STATE(20694)] = 576047,
  [SMALL_STATE(20695)] = 576057,
  [SMALL_STATE(20696)] = 576067,
  [SMALL_STATE(20697)] = 576077,
  [SMALL_STATE(20698)] = 576087,
  [SMALL_STATE(20699)] = 576097,
  [SMALL_STATE(20700)] = 576107,
  [SMALL_STATE(20701)] = 576117,
  [SMALL_STATE(20702)] = 576127,
  [SMALL_STATE(20703)] = 576137,
  [SMALL_STATE(20704)] = 576147,
  [SMALL_STATE(20705)] = 576157,
  [SMALL_STATE(20706)] = 576167,
  [SMALL_STATE(20707)] = 576177,
  [SMALL_STATE(20708)] = 576187,
  [SMALL_STATE(20709)] = 576197,
  [SMALL_STATE(20710)] = 576207,
  [SMALL_STATE(20711)] = 576217,
  [SMALL_STATE(20712)] = 576227,
  [SMALL_STATE(20713)] = 576237,
  [SMALL_STATE(20714)] = 576247,
  [SMALL_STATE(20715)] = 576257,
  [SMALL_STATE(20716)] = 576267,
  [SMALL_STATE(20717)] = 576277,
  [SMALL_STATE(20718)] = 576287,
  [SMALL_STATE(20719)] = 576297,
  [SMALL_STATE(20720)] = 576307,
  [SMALL_STATE(20721)] = 576317,
  [SMALL_STATE(20722)] = 576327,
  [SMALL_STATE(20723)] = 576337,
  [SMALL_STATE(20724)] = 576347,
  [SMALL_STATE(20725)] = 576357,
  [SMALL_STATE(20726)] = 576367,
  [SMALL_STATE(20727)] = 576377,
  [SMALL_STATE(20728)] = 576387,
  [SMALL_STATE(20729)] = 576397,
  [SMALL_STATE(20730)] = 576407,
  [SMALL_STATE(20731)] = 576417,
  [SMALL_STATE(20732)] = 576427,
  [SMALL_STATE(20733)] = 576437,
  [SMALL_STATE(20734)] = 576447,
  [SMALL_STATE(20735)] = 576457,
  [SMALL_STATE(20736)] = 576467,
  [SMALL_STATE(20737)] = 576477,
  [SMALL_STATE(20738)] = 576487,
  [SMALL_STATE(20739)] = 576497,
  [SMALL_STATE(20740)] = 576507,
  [SMALL_STATE(20741)] = 576517,
  [SMALL_STATE(20742)] = 576527,
  [SMALL_STATE(20743)] = 576537,
  [SMALL_STATE(20744)] = 576547,
  [SMALL_STATE(20745)] = 576557,
  [SMALL_STATE(20746)] = 576567,
  [SMALL_STATE(20747)] = 576577,
  [SMALL_STATE(20748)] = 576587,
  [SMALL_STATE(20749)] = 576597,
  [SMALL_STATE(20750)] = 576607,
  [SMALL_STATE(20751)] = 576617,
  [SMALL_STATE(20752)] = 576627,
  [SMALL_STATE(20753)] = 576637,
  [SMALL_STATE(20754)] = 576647,
  [SMALL_STATE(20755)] = 576657,
  [SMALL_STATE(20756)] = 576667,
  [SMALL_STATE(20757)] = 576677,
  [SMALL_STATE(20758)] = 576687,
  [SMALL_STATE(20759)] = 576697,
  [SMALL_STATE(20760)] = 576707,
  [SMALL_STATE(20761)] = 576717,
  [SMALL_STATE(20762)] = 576727,
  [SMALL_STATE(20763)] = 576737,
  [SMALL_STATE(20764)] = 576747,
  [SMALL_STATE(20765)] = 576757,
  [SMALL_STATE(20766)] = 576767,
  [SMALL_STATE(20767)] = 576777,
  [SMALL_STATE(20768)] = 576787,
  [SMALL_STATE(20769)] = 576797,
  [SMALL_STATE(20770)] = 576807,
  [SMALL_STATE(20771)] = 576817,
  [SMALL_STATE(20772)] = 576827,
  [SMALL_STATE(20773)] = 576837,
  [SMALL_STATE(20774)] = 576847,
  [SMALL_STATE(20775)] = 576857,
  [SMALL_STATE(20776)] = 576867,
  [SMALL_STATE(20777)] = 576877,
  [SMALL_STATE(20778)] = 576887,
  [SMALL_STATE(20779)] = 576897,
  [SMALL_STATE(20780)] = 576907,
  [SMALL_STATE(20781)] = 576917,
  [SMALL_STATE(20782)] = 576927,
  [SMALL_STATE(20783)] = 576937,
  [SMALL_STATE(20784)] = 576947,
  [SMALL_STATE(20785)] = 576957,
  [SMALL_STATE(20786)] = 576967,
  [SMALL_STATE(20787)] = 576977,
  [SMALL_STATE(20788)] = 576987,
  [SMALL_STATE(20789)] = 576997,
  [SMALL_STATE(20790)] = 577007,
  [SMALL_STATE(20791)] = 577017,
  [SMALL_STATE(20792)] = 577027,
  [SMALL_STATE(20793)] = 577037,
  [SMALL_STATE(20794)] = 577047,
  [SMALL_STATE(20795)] = 577057,
  [SMALL_STATE(20796)] = 577067,
  [SMALL_STATE(20797)] = 577077,
  [SMALL_STATE(20798)] = 577087,
  [SMALL_STATE(20799)] = 577097,
  [SMALL_STATE(20800)] = 577107,
  [SMALL_STATE(20801)] = 577117,
  [SMALL_STATE(20802)] = 577127,
  [SMALL_STATE(20803)] = 577137,
  [SMALL_STATE(20804)] = 577147,
  [SMALL_STATE(20805)] = 577157,
  [SMALL_STATE(20806)] = 577167,
  [SMALL_STATE(20807)] = 577177,
  [SMALL_STATE(20808)] = 577187,
  [SMALL_STATE(20809)] = 577197,
  [SMALL_STATE(20810)] = 577207,
  [SMALL_STATE(20811)] = 577217,
  [SMALL_STATE(20812)] = 577227,
  [SMALL_STATE(20813)] = 577237,
  [SMALL_STATE(20814)] = 577247,
  [SMALL_STATE(20815)] = 577257,
  [SMALL_STATE(20816)] = 577267,
  [SMALL_STATE(20817)] = 577277,
  [SMALL_STATE(20818)] = 577287,
  [SMALL_STATE(20819)] = 577297,
  [SMALL_STATE(20820)] = 577307,
  [SMALL_STATE(20821)] = 577317,
  [SMALL_STATE(20822)] = 577327,
  [SMALL_STATE(20823)] = 577337,
  [SMALL_STATE(20824)] = 577347,
  [SMALL_STATE(20825)] = 577357,
  [SMALL_STATE(20826)] = 577367,
  [SMALL_STATE(20827)] = 577377,
  [SMALL_STATE(20828)] = 577387,
  [SMALL_STATE(20829)] = 577397,
  [SMALL_STATE(20830)] = 577407,
  [SMALL_STATE(20831)] = 577417,
  [SMALL_STATE(20832)] = 577427,
  [SMALL_STATE(20833)] = 577437,
  [SMALL_STATE(20834)] = 577447,
  [SMALL_STATE(20835)] = 577457,
  [SMALL_STATE(20836)] = 577467,
  [SMALL_STATE(20837)] = 577477,
  [SMALL_STATE(20838)] = 577487,
  [SMALL_STATE(20839)] = 577497,
  [SMALL_STATE(20840)] = 577507,
  [SMALL_STATE(20841)] = 577517,
  [SMALL_STATE(20842)] = 577527,
  [SMALL_STATE(20843)] = 577537,
  [SMALL_STATE(20844)] = 577547,
  [SMALL_STATE(20845)] = 577557,
  [SMALL_STATE(20846)] = 577567,
  [SMALL_STATE(20847)] = 577577,
  [SMALL_STATE(20848)] = 577587,
  [SMALL_STATE(20849)] = 577597,
  [SMALL_STATE(20850)] = 577607,
  [SMALL_STATE(20851)] = 577617,
  [SMALL_STATE(20852)] = 577627,
  [SMALL_STATE(20853)] = 577637,
  [SMALL_STATE(20854)] = 577647,
  [SMALL_STATE(20855)] = 577657,
  [SMALL_STATE(20856)] = 577667,
  [SMALL_STATE(20857)] = 577677,
  [SMALL_STATE(20858)] = 577687,
  [SMALL_STATE(20859)] = 577697,
  [SMALL_STATE(20860)] = 577707,
  [SMALL_STATE(20861)] = 577717,
  [SMALL_STATE(20862)] = 577727,
  [SMALL_STATE(20863)] = 577737,
  [SMALL_STATE(20864)] = 577747,
  [SMALL_STATE(20865)] = 577757,
  [SMALL_STATE(20866)] = 577767,
  [SMALL_STATE(20867)] = 577777,
  [SMALL_STATE(20868)] = 577787,
  [SMALL_STATE(20869)] = 577797,
  [SMALL_STATE(20870)] = 577807,
  [SMALL_STATE(20871)] = 577817,
  [SMALL_STATE(20872)] = 577827,
  [SMALL_STATE(20873)] = 577837,
  [SMALL_STATE(20874)] = 577847,
  [SMALL_STATE(20875)] = 577857,
  [SMALL_STATE(20876)] = 577867,
  [SMALL_STATE(20877)] = 577877,
  [SMALL_STATE(20878)] = 577887,
  [SMALL_STATE(20879)] = 577897,
  [SMALL_STATE(20880)] = 577907,
  [SMALL_STATE(20881)] = 577917,
  [SMALL_STATE(20882)] = 577927,
  [SMALL_STATE(20883)] = 577937,
  [SMALL_STATE(20884)] = 577947,
  [SMALL_STATE(20885)] = 577957,
  [SMALL_STATE(20886)] = 577967,
  [SMALL_STATE(20887)] = 577977,
  [SMALL_STATE(20888)] = 577987,
  [SMALL_STATE(20889)] = 577997,
  [SMALL_STATE(20890)] = 578007,
  [SMALL_STATE(20891)] = 578017,
  [SMALL_STATE(20892)] = 578027,
  [SMALL_STATE(20893)] = 578037,
  [SMALL_STATE(20894)] = 578047,
  [SMALL_STATE(20895)] = 578057,
  [SMALL_STATE(20896)] = 578067,
  [SMALL_STATE(20897)] = 578077,
  [SMALL_STATE(20898)] = 578087,
  [SMALL_STATE(20899)] = 578097,
  [SMALL_STATE(20900)] = 578107,
  [SMALL_STATE(20901)] = 578117,
  [SMALL_STATE(20902)] = 578127,
  [SMALL_STATE(20903)] = 578137,
  [SMALL_STATE(20904)] = 578147,
  [SMALL_STATE(20905)] = 578157,
  [SMALL_STATE(20906)] = 578167,
  [SMALL_STATE(20907)] = 578177,
  [SMALL_STATE(20908)] = 578187,
  [SMALL_STATE(20909)] = 578197,
  [SMALL_STATE(20910)] = 578207,
  [SMALL_STATE(20911)] = 578217,
  [SMALL_STATE(20912)] = 578227,
  [SMALL_STATE(20913)] = 578237,
  [SMALL_STATE(20914)] = 578247,
  [SMALL_STATE(20915)] = 578257,
  [SMALL_STATE(20916)] = 578267,
  [SMALL_STATE(20917)] = 578277,
  [SMALL_STATE(20918)] = 578287,
  [SMALL_STATE(20919)] = 578297,
  [SMALL_STATE(20920)] = 578307,
  [SMALL_STATE(20921)] = 578317,
  [SMALL_STATE(20922)] = 578327,
  [SMALL_STATE(20923)] = 578337,
  [SMALL_STATE(20924)] = 578347,
  [SMALL_STATE(20925)] = 578357,
  [SMALL_STATE(20926)] = 578367,
  [SMALL_STATE(20927)] = 578377,
  [SMALL_STATE(20928)] = 578387,
  [SMALL_STATE(20929)] = 578397,
  [SMALL_STATE(20930)] = 578407,
  [SMALL_STATE(20931)] = 578417,
  [SMALL_STATE(20932)] = 578427,
  [SMALL_STATE(20933)] = 578437,
  [SMALL_STATE(20934)] = 578447,
  [SMALL_STATE(20935)] = 578457,
  [SMALL_STATE(20936)] = 578467,
  [SMALL_STATE(20937)] = 578477,
  [SMALL_STATE(20938)] = 578487,
  [SMALL_STATE(20939)] = 578497,
  [SMALL_STATE(20940)] = 578507,
  [SMALL_STATE(20941)] = 578517,
  [SMALL_STATE(20942)] = 578527,
  [SMALL_STATE(20943)] = 578537,
  [SMALL_STATE(20944)] = 578547,
  [SMALL_STATE(20945)] = 578557,
  [SMALL_STATE(20946)] = 578567,
  [SMALL_STATE(20947)] = 578577,
  [SMALL_STATE(20948)] = 578587,
  [SMALL_STATE(20949)] = 578597,
  [SMALL_STATE(20950)] = 578607,
  [SMALL_STATE(20951)] = 578617,
  [SMALL_STATE(20952)] = 578627,
  [SMALL_STATE(20953)] = 578637,
  [SMALL_STATE(20954)] = 578647,
  [SMALL_STATE(20955)] = 578657,
  [SMALL_STATE(20956)] = 578667,
  [SMALL_STATE(20957)] = 578677,
  [SMALL_STATE(20958)] = 578687,
  [SMALL_STATE(20959)] = 578697,
  [SMALL_STATE(20960)] = 578707,
  [SMALL_STATE(20961)] = 578717,
  [SMALL_STATE(20962)] = 578727,
  [SMALL_STATE(20963)] = 578737,
  [SMALL_STATE(20964)] = 578747,
  [SMALL_STATE(20965)] = 578757,
  [SMALL_STATE(20966)] = 578767,
  [SMALL_STATE(20967)] = 578777,
  [SMALL_STATE(20968)] = 578787,
  [SMALL_STATE(20969)] = 578797,
  [SMALL_STATE(20970)] = 578807,
  [SMALL_STATE(20971)] = 578817,
  [SMALL_STATE(20972)] = 578827,
  [SMALL_STATE(20973)] = 578837,
  [SMALL_STATE(20974)] = 578847,
  [SMALL_STATE(20975)] = 578857,
  [SMALL_STATE(20976)] = 578867,
  [SMALL_STATE(20977)] = 578877,
  [SMALL_STATE(20978)] = 578887,
  [SMALL_STATE(20979)] = 578897,
  [SMALL_STATE(20980)] = 578907,
  [SMALL_STATE(20981)] = 578917,
  [SMALL_STATE(20982)] = 578927,
  [SMALL_STATE(20983)] = 578937,
  [SMALL_STATE(20984)] = 578947,
  [SMALL_STATE(20985)] = 578957,
  [SMALL_STATE(20986)] = 578967,
  [SMALL_STATE(20987)] = 578977,
  [SMALL_STATE(20988)] = 578987,
  [SMALL_STATE(20989)] = 578997,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3790),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4727),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4729),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4729),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5710),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4333),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3860),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12492),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11519),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2781),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12533),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3659),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3431),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14730),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17914),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2871),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13010),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13723),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2796),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13012),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2808),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20917),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3200),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10995),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17904),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15446),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10260),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12945),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20941),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3902),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19542),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3547),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4586),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12257),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11821),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19548),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2777),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3655),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3660),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1574),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18519),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2861),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12994),
  [129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2783),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12996),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2804),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19620),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3204),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11407),
  [141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18024),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17653),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10138),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13024),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20386),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20194),
  [153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19295),
  [155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3811),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4521),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4795),
  [167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4273),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12382),
  [179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11768),
  [181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2776),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3449),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1652),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18424),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2834),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12901),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2813),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12902),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2798),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19538),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3206),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11114),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18034),
  [213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17746),
  [215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20227),
  [217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10094),
  [219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13038),
  [221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_haskell, 3),
  [223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19022),
  [225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_haskell, 2),
  [227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3845),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3875),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1400),
  [241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12863),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12274),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18422),
  [255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12554),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18555),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15779),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10218),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7857),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7859),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12983),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9833),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12854),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18478),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13030),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18518),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13051),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17981),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4724),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13007),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18501),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12926),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18529),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11133),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12856),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18465),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12758),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18552),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5093),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11350),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(927),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10670),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10641),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12850),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18598),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9568),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10774),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12888),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18374),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12887),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18383),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10699),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9349),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12862),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18432),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12852),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18491),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3514),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(903),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9264),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12823),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18443),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(39),
  [419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8664),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19266),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16616),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16886),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12877),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16731),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15615),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9120),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17791),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7914),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17372),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12268),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15899),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8693),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16696),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8339),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16299),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8665),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16542),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13532),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16789),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8650),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17575),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13300),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17544),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13290),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15936),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9319),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15800),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8822),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16550),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13475),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15841),
  [487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13338),
  [489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16774),
  [491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13220),
  [493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16506),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8143),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15979),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13322),
  [501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15699),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8106),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16583),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13537),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16704),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15746),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12572),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16259),
  [517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8948),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17358),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8762),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16532),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8565),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17389),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8100),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16083),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4263),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4800),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4800),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4401),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3882),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12437),
  [555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13026),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3494),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(890),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18503),
  [571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16568),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10177),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12779),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10607),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11122),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10126),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9738),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9759),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10962),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5045),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11469),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10663),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4532),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4095),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10384),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4973),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10559),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5086),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11199),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4935),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4162),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10606),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11120),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11030),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5289),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4560),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20074),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3701),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3701),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3943),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12201),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12380),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13318),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18580),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16237),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10073),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12826),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3526),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(25),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1589),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1590),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1590),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12432),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19703),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11513),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19945),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5549),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20631),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18411),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19969),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5553),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20582),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9772),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20451),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19999),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4885),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19771),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9473),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19014),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11856),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19841),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5571),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19464),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19681),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9536),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19766),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11753),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19553),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6201),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20179),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5850),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20217),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5407),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19729),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20704),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11979),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19476),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10765),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20509),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20265),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20335),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11593),
  [781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19188),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5155),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18926),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11052),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19617),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11602),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19507),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19226),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11027),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20585),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5634),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20128),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20674),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11899),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19215),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17007),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19792),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10130),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20447),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5498),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19334),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19391),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11254),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20459),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12436),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19224),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11992),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18991),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11874),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19031),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5692),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19138),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4904),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19891),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9982),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19235),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11695),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20717),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11279),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19442),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5888),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19146),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10881),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20970),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5492),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20208),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5909),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4253),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4497),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3877),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12845),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18230),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15908),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10313),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12793),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12227),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5510),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12219),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5530),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9739),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5930),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4985),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12204),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5386),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14230),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11833),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10865),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13243),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8068),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13693),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10752),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5525),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5660),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11802),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10924),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4274),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11767),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11628),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5379),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13200),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10030),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5664),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4337),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5539),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5680),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12073),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11495),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5616),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10068),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11323),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9279),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4862),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11484),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9733),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11300),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17024),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11852),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11953),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9542),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5014),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8544),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13774),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10859),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11840),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18169),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11678),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5945),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11971),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10943),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10963),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9552),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13246),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8900),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10687),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5025),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10975),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12485),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11635),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7918),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4403),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8465),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17212),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11849),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11610),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12390),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9367),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4870),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5739),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5942),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11866),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3897),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11667),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11691),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5928),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11681),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8004),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11803),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12494),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5503),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5760),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5564),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5799),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18236),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13159),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8678),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10231),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8593),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5203),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5506),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5633),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5621),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5212),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5566),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6144),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10267),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13735),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6158),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12602),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11655),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13248),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8308),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12752),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12644),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9507),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5087),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8916),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9064),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8832),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9502),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8425),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4450),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5224),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5473),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5473),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(37),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12448),
  [1189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 1), REDUCE(aux_sym__pat_unboxed_sum_repeat1, 1),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13199),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [1196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3520),
  [1198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [1200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(872),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1614),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18435),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15623),
  [1208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10287),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12898),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3642),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3641),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [1222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [1224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pat_unboxed_sum_repeat1, 1),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3960),
  [1228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [1230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4110),
  [1232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [1234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4114),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [1240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9771),
  [1248] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12415),
  [1250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3523),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [1256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [1258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1546),
  [1260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18532),
  [1262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15879),
  [1264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10151),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12952),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3865),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9578),
  [1272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [1274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12607),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9324),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13151),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10414),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8740),
  [1286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8864),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8667),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7909),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4842),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9000),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5488),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13619),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13058),
  [1302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8567),
  [1304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10581),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13294),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12285),
  [1312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10876),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10968),
  [1316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13263),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13593),
  [1320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9345),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8177),
  [1324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8028),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13443),
  [1328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8622),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3628),
  [1332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3608),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [1336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8778),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8713),
  [1340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13235),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13181),
  [1344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8099),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10677),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8131),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10612),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8666),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9357),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [1360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4772),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4913),
  [1364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5032),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5032),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [1372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3944),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [1378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13287),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15601),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10019),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12934),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [1390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3890),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [1396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(585),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11817),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13008),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3820),
  [1404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18252),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12915),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18231),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [1416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13088),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18151),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [1424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12928),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18350),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12824),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18221),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4791),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12801),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18261),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12880),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18390),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11707),
  [1448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(906),
  [1450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12860),
  [1452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18451),
  [1454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [1456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12951),
  [1458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18275),
  [1460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12869),
  [1464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18309),
  [1466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12872),
  [1468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18400),
  [1470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11337),
  [1472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12780),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18187),
  [1476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11022),
  [1480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12904),
  [1482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18364),
  [1484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [1486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5424),
  [1488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12867),
  [1490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18412),
  [1492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [1494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10668),
  [1496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12837),
  [1498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18156),
  [1500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [1502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [1504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12930),
  [1506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18341),
  [1508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5687),
  [1512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12840),
  [1514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18317),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [1518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9682),
  [1520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12949),
  [1522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18285),
  [1524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10089),
  [1528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12978),
  [1530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18140),
  [1532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [1534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4811),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12814),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18204),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [1542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11160),
  [1544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12932),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18330),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5563),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4941),
  [1556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12937),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18324),
  [1560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [1562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4761),
  [1564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12772),
  [1566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18182),
  [1568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [1570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5083),
  [1572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12938),
  [1574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18240),
  [1576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [1578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11202),
  [1580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12995),
  [1582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18268),
  [1584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [1586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11147),
  [1588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12818),
  [1590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18212),
  [1592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(921),
  [1594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10334),
  [1596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12998),
  [1598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18292),
  [1600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [1602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10435),
  [1604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12809),
  [1606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18196),
  [1608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5371),
  [1612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12870),
  [1614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18404),
  [1616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [1618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10838),
  [1620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13078),
  [1622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18167),
  [1624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [1626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12766),
  [1628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18175),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12886),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18298),
  [1634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3533),
  [1636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_apply, 1),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [1640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3595),
  [1642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_apply, 1),
  [1644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [1646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(3468),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [1651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12232),
  [1653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12389),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3441),
  [1661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [1663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [1665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18310),
  [1667] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1),
  [1670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1),
  [1673] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(3468),
  [1677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3481),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [1681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [1683] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(3476),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [1689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12475),
  [1691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [1693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(3476),
  [1696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [1698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [1700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4010),
  [1702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [1704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4004),
  [1706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [1708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [1710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [1712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(576),
  [1714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(3892),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [1719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12336),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12495),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [1729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1687),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18344),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17405),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10201),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12970),
  [1741] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(3892),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4355),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [1751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(562),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9645),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5767),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9443),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5575),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10533),
  [1771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6925),
  [1773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7364),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7579),
  [1777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7579),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20479),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [1785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14894),
  [1789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7296),
  [1791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9146),
  [1795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14571),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14571),
  [1799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7362),
  [1801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16930),
  [1803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10304),
  [1805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20724),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15462),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12819),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [1813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11502),
  [1815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9907),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5331),
  [1821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19696),
  [1823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7592),
  [1825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20466),
  [1827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17337),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10811),
  [1831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11178),
  [1833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5528),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11738),
  [1837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4085),
  [1839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(586),
  [1843] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4007),
  [1847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12462),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [1853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10649),
  [1855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11014),
  [1857] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(3820),
  [1861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12439),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [1865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(3820),
  [1868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [1870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [1872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12117),
  [1874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20376),
  [1876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11431),
  [1878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [1880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10819),
  [1882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11577),
  [1884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10022),
  [1886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10989),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3826),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5287),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11258),
  [1894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4971),
  [1896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [1898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10645),
  [1902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [1904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5512),
  [1906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11633),
  [1908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20275),
  [1910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4113),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11382),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [1916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4007),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9745),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10908),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5090),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4798),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4352),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9422),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4251),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4244),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4280),
  [1945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [1947] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4020),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12356),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12473),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3563),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [1965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18152),
  [1969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16741),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10284),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12760),
  [1975] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4020),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20417),
  [1986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20133),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6321),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20132),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17065),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19312),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19316),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19299),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6393),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19297),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16587),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19694),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19807),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7560),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19808),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17722),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20902),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5811),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20899),
  [2022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17476),
  [2024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19184),
  [2026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5989),
  [2028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19185),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16421),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19212),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5938),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19213),
  [2038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16413),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20242),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7869),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20239),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17265),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19645),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5965),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19661),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17759),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20339),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7294),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20342),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16729),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20986),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7438),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20985),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17417),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20949),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7728),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20950),
  [2078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15938),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4680),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4429),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [2092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [2094] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4299),
  [2098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12383),
  [2102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12308),
  [2104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3603),
  [2106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [2110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [2112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1653),
  [2114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18263),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17509),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9987),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13068),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19483),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6181),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19482),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16617),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19578),
  [2132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5962),
  [2134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19592),
  [2136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17785),
  [2138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20872),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7361),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20870),
  [2144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17329),
  [2146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20087),
  [2148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6253),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20086),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17034),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19325),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7268),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19303),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15556),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19568),
  [2164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7616),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19567),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17542),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20184),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6689),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20182),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17080),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19533),
  [2180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6542),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19532),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16623),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20287),
  [2188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20284),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19451),
  [2192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19452),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20780),
  [2196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20778),
  [2200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17308),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6595),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16031),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20116),
  [2208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5018),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20120),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17633),
  [2214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19155),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19156),
  [2220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16433),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19249),
  [2224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6635),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19245),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16580),
  [2230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19362),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19497),
  [2234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20107),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7647),
  [2238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20105),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17296),
  [2242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20483),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6398),
  [2246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20481),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17120),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20349),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7860),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20348),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17234),
  [2258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6328),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17761),
  [2262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19123),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7082),
  [2266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19119),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16564),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7256),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16221),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20415),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20422),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7495),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16850),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20255),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6363),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20258),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17582),
  [2290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4262),
  [2293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12406),
  [2295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19068),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6850),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19069),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16468),
  [2305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4713),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4662),
  [2309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4771),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4771),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [2317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [2319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4346),
  [2322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [2324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12239),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12499),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [2330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3578),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [2336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1694),
  [2338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18352),
  [2340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17374),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10206),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12967),
  [2346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19027),
  [2348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19026),
  [2350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4629),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4706),
  [2354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4741),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4741),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [2360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4756),
  [2362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(581),
  [2364] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4223),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [2370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12374),
  [2372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12311),
  [2374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3573),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [2378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3428),
  [2380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [2382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1632),
  [2384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18207),
  [2386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17293),
  [2388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10099),
  [2390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12923),
  [2392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4223),
  [2395] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4262),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19010),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6331),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19011),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16492),
  [2407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4577),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4558),
  [2411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4696),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [2419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [2421] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4339),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [2427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12244),
  [2429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12360),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3667),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3463),
  [2437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [2439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1625),
  [2441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18183),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17171),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10137),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12841),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20272),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7023),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20270),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17134),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7474),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17668),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20325),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6857),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20320),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17157),
  [2469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4339),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7546),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16108),
  [2476] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4346),
  [2480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18956),
  [2482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6307),
  [2484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18957),
  [2486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16509),
  [2488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19864),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7166),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19860),
  [2494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16902),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19265),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6706),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19258),
  [2502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17606),
  [2504] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4299),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20677),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6644),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20680),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17539),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18981),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6047),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18982),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16501),
  [2523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2730),
  [2525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4407),
  [2527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7388),
  [2529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4573),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [2535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(568),
  [2537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4272),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [2542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12368),
  [2544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12373),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3532),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3528),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [2552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [2554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1698),
  [2556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18401),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3546),
  [2560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5104),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4866),
  [2564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5190),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [2572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(573),
  [2574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4659),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12384),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12324),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3648),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1668),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18413),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16193),
  [2597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10197),
  [2599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12778),
  [2601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10658),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4949),
  [2605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4976),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5312),
  [2609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [2611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [2613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5481),
  [2615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [2617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4596),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [2622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12430),
  [2624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12234),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [2632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [2634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1642),
  [2636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18242),
  [2638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17470),
  [2640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10053),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13037),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10404),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19806),
  [2648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [2650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8849),
  [2652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20007),
  [2654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17084),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5309),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4734),
  [2660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5345),
  [2662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4936),
  [2664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5009),
  [2666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5009),
  [2668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [2670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [2672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(584),
  [2674] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4611),
  [2678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [2680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12304),
  [2682] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12457),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [2686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3625),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3450),
  [2690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [2692] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1679),
  [2694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18325),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17591),
  [2698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10143),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13019),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5479),
  [2704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3647),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11257),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4670),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11913),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10917),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11144),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10471),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5570),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9353),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10407),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4801),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5489),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10608),
  [2730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4611),
  [2733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5484),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4937),
  [2737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5198),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5329),
  [2745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [2747] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4720),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [2753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12496),
  [2755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12335),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3615),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3462),
  [2763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [2765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1658),
  [2767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18276),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17547),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9977),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13098),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9751),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10516),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4229),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11472),
  [2783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4810),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [2789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [2791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4232),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [2796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12310),
  [2798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12273),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [2802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3507),
  [2804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3432),
  [2806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [2808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1637),
  [2810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18223),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20139),
  [2814] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4659),
  [2818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [2822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10895),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11186),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10393),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9557),
  [2832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10575),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11000),
  [2836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3947),
  [2838] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4232),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5049),
  [2844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5077),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5033),
  [2848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5080),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5080),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5110),
  [2856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [2858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4775),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [2863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12334),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12347),
  [2867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [2873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [2875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1686),
  [2877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18406),
  [2879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16383),
  [2881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10110),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12795),
  [2885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [2887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5175),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9614),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4940),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [2899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [2901] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4831),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [2907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12275),
  [2909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11601),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9999),
  [2915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple, 2, .production_id = 21),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2919] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4272),
  [2923] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4596),
  [2927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4720),
  [2930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4831),
  [2933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4784),
  [2935] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4775),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9310),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5075),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5063),
  [2945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5535),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5669),
  [2949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5597),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [2955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(583),
  [2957] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(5357),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [2963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12417),
  [2965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16047),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10050),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12871),
  [2973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5536),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5749),
  [2977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5637),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5637),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [2985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(578),
  [2987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(5199),
  [2990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [2992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12361),
  [2994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12409),
  [2996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3666),
  [2998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3671),
  [3000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3461),
  [3002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [3004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1669),
  [3006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18319),
  [3008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17622),
  [3010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10141),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13020),
  [3014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4832),
  [3016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [3018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(575),
  [3020] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4228),
  [3024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [3026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12295),
  [3028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [3030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [3032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [3034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 1),
  [3036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4228),
  [3039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_tuple_repeat1, 1),
  [3041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5139),
  [3043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4861),
  [3047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [3049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4777),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1269),
  [3055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12392),
  [3057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3636),
  [3059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3635),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [3063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [3065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1606),
  [3067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18454),
  [3069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(5357),
  [3072] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(5199),
  [3076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20150),
  [3078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(855),
  [3080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20149),
  [3082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16162),
  [3084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20982),
  [3086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20974),
  [3088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17440),
  [3090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11714),
  [3092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20024),
  [3094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20022),
  [3096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16357),
  [3098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19863),
  [3100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15406),
  [3102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19862),
  [3104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17420),
  [3106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9486),
  [3108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6742),
  [3110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7467),
  [3112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9488),
  [3114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [3116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4007),
  [3118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10886),
  [3120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10888),
  [3122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10950),
  [3124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7237),
  [3126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10952),
  [3128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5272),
  [3130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5271),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19273),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8554),
  [3136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19271),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17739),
  [3140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5120),
  [3142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [3144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [3146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5234),
  [3148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5121),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19584),
  [3154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8793),
  [3156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19708),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16752),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19911),
  [3162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19912),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16316),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6963),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11796),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11637),
  [3174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5181),
  [3176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [3178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19747),
  [3180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19746),
  [3182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11941),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6876),
  [3186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7594),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [3190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [3192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19765),
  [3194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19764),
  [3196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16820),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9399),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9401),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5073),
  [3204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7385),
  [3206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [3208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [3210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5608),
  [3212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19812),
  [3214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19811),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16878),
  [3218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9432),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9434),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7198),
  [3224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19927),
  [3226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19924),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16926),
  [3230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11940),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6785),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20144),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20154),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16411),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7360),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19586),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19585),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16657),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11701),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19990),
  [3254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19985),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16969),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9500),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19639),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8279),
  [3264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19638),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17451),
  [3268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5806),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5807),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11386),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20029),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20027),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16997),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11716),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11710),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5835),
  [3286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5823),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [3290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20226),
  [3294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20225),
  [3296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17100),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5824),
  [3300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4492),
  [3302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [3304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6616),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [3308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [3310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [3312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20370),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14120),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20369),
  [3318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17186),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9489),
  [3322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [3326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6554),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6746),
  [3330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20449),
  [3332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20450),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16601),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19525),
  [3338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19523),
  [3340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17482),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20351),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8453),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20469),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17216),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19430),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8391),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19429),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16608),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4739),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4605),
  [3362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [3364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5023),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5554),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11137),
  [3370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11044),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3805),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20558),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8929),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20557),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17235),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5707),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11088),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11089),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19890),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8296),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19902),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16871),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4478),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19386),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19382),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20643),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8313),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20642),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17262),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5708),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18988),
  [3416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18986),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17630),
  [3420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19417),
  [3422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19415),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17513),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5745),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10383),
  [3430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20737),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8532),
  [3436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20736),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17286),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5094),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4692),
  [3444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [3446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6481),
  [3448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5746),
  [3450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [3452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [3454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20471),
  [3456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14024),
  [3458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20467),
  [3460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17161),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10694),
  [3464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10695),
  [3466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19341),
  [3468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19339),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16597),
  [3472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7182),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4972),
  [3478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10729),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4708),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4709),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10730),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20826),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20824),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19194),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19192),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16569),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11216),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19805),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7383),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20909),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20906),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17352),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10452),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19044),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19042),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16558),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19154),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19153),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17637),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11353),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11297),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11185),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20939),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20938),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17368),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11357),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3768),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10488),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10486),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18913),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17910),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18914),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16527),
  [3556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3770),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11458),
  [3560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11266),
  [3562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20963),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20962),
  [3566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17396),
  [3568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10356),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10354),
  [3572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11268),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5722),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19644),
  [3578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13568),
  [3580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19643),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16681),
  [3584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5720),
  [3586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11174),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4968),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [3592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11459),
  [3594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6256),
  [3596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3775),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20942),
  [3600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20944),
  [3602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17458),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18946),
  [3608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18945),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17699),
  [3612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19686),
  [3614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8942),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19689),
  [3618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16126),
  [3620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9786),
  [3624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11641),
  [3626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5617),
  [3628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7501),
  [3630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11411),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11410),
  [3634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5040),
  [3636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5042),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6003),
  [3640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11369),
  [3642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11365),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6230),
  [3646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20603),
  [3648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20602),
  [3650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17075),
  [3652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5994),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18935),
  [3656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7956),
  [3658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18936),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16517),
  [3662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9789),
  [3664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5443),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6311),
  [3668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20828),
  [3670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20830),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17494),
  [3674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19090),
  [3676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19105),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17730),
  [3680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20419),
  [3682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20443),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16523),
  [3686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5444),
  [3688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20653),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20656),
  [3692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16791),
  [3694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6469),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11734),
  [3698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11731),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5620),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11521),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20759),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20762),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17520),
  [3710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4022),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4815),
  [3716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4821),
  [3718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7395),
  [3720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20744),
  [3722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20742),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15645),
  [3726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11522),
  [3728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4850),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4849),
  [3732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9962),
  [3734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5585),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6729),
  [3738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [3740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5584),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [3744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4149),
  [3746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20654),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8030),
  [3750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20554),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17563),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19144),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19158),
  [3758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9611),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7140),
  [3762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9862),
  [3764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19449),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19351),
  [3768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17804),
  [3770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20198),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20199),
  [3774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17608),
  [3776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11081),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11086),
  [3780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19039),
  [3782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19040),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16483),
  [3786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10380),
  [3788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9863),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20033),
  [3792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20043),
  [3794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17652),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5461),
  [3798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11126),
  [3800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11214),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5462),
  [3804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19839),
  [3806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19972),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17677),
  [3810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11308),
  [3812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19097),
  [3814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14518),
  [3816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19098),
  [3818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16455),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5184),
  [3822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19884),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19886),
  [3826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17697),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19126),
  [3830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14707),
  [3832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19127),
  [3834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16444),
  [3836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19965),
  [3838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19964),
  [3840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17327),
  [3842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20593),
  [3844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20478),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15539),
  [3848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11165),
  [3850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19906),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19905),
  [3854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16824),
  [3856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6564),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11445),
  [3860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11444),
  [3862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6183),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11162),
  [3866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6416),
  [3868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6845),
  [3870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5297),
  [3872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5298),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10058),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10056),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11471),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6171),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11399),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5410),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4786),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6146),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6339),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5842),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19732),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19737),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17737),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10039),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10037),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11127),
  [3908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10503),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7080),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7293),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19846),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19842),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15466),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7600),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10678),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10679),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5204),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11557),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [3934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5627),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4993),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5678),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11951),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4189),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11952),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10478),
  [3958] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__exp_apply, 1), REDUCE(sym__fexp, 1), SHIFT(4777),
  [3962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12305),
  [3964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10477),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10432),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7796),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [3974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4348),
  [3976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12031),
  [3978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10836),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12032),
  [3982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10431),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9925),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10003),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9927),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11136),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18968),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8994),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18970),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15651),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10773),
  [4002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7831),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10776),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7682),
  [4008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__exp_apply, 1), SHIFT(4777),
  [4011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20761),
  [4013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20758),
  [4015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16981),
  [4017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10926),
  [4019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9663),
  [4021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9665),
  [4023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9708),
  [4025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9709),
  [4027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9960),
  [4029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5423),
  [4031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4240),
  [4033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5421),
  [4035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5375),
  [4037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [4039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10837),
  [4041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10847),
  [4043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10849),
  [4045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [4047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [4049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [4051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [4053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2695),
  [4055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [4057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [4059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2716),
  [4061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4775),
  [4063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [4065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9636),
  [4067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [4069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10657),
  [4071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [4073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4720),
  [4075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(857),
  [4077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10465),
  [4079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2691),
  [4081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [4083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(858),
  [4085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [4087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [4089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5088),
  [4093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5020),
  [4095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9457),
  [4097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9549),
  [4099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9573),
  [4101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9573),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9576),
  [4107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [4109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__minus, 1, .production_id = 11),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9493),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [4115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12423),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20856),
  [4123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18492),
  [4125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17683),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9994),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12919),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10898),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3926),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10934),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4232),
  [4145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [4147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [4149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4468),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [4155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [4157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11704),
  [4159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2729),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [4163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [4165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4028),
  [4167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [4169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2694),
  [4171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5357),
  [4173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9245),
  [4175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [4177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [4179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [4181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9374),
  [4183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [4185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [4187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4760),
  [4189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11259),
  [4191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2719),
  [4193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [4195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(859),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10672),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5365),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4081),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2696),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3892),
  [4207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [4211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [4213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(808),
  [4215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4658),
  [4217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9535),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9343),
  [4225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [4227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [4229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12403),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [4233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [4235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20322),
  [4237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18466),
  [4239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11393),
  [4241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [4243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4272),
  [4245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10441),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10586),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9795),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5522),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11532),
  [4259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10568),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11107),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2672),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4346),
  [4269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4638),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10597),
  [4277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4025),
  [4279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10933),
  [4281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10350),
  [4283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3562),
  [4285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [4287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2728),
  [4289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [4291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3876),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10007),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5547),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [4301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4470),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11273),
  [4309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9222),
  [4311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9378),
  [4313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9348),
  [4315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9348),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [4319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [4321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9243),
  [4323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16379),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10108),
  [4329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12748),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [4333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(40),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [4337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10635),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11301),
  [4341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10953),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10953),
  [4345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [4347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [4349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10366),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17219),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10252),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12950),
  [4359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10140),
  [4361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10715),
  [4363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10686),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10686),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10627),
  [4371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(31),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10290),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [4377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12481),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19844),
  [4385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18375),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17281),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10292),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12954),
  [4393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10309),
  [4395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10538),
  [4397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10420),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10420),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [4403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10320),
  [4405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10156),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [4411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12291),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [4417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20195),
  [4419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18445),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15526),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10109),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12913),
  [4427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10690),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11487),
  [4431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10867),
  [4433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10867),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [4437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10436),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17048),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10286),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12933),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [4451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [4453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [4455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [4457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10982),
  [4459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [4461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [4463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12316),
  [4465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [4467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [4469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19948),
  [4471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18385),
  [4473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9593),
  [4475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9877),
  [4477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9723),
  [4479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9723),
  [4481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [4483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9898),
  [4485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [4487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9702),
  [4489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [4491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12242),
  [4493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [4495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [4497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20534),
  [4499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18480),
  [4501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17441),
  [4503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10190),
  [4505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13041),
  [4507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10222),
  [4509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10518),
  [4511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10590),
  [4513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10590),
  [4515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [4517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(34),
  [4519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10170),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17409),
  [4525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10080),
  [4527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13011),
  [4529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9229),
  [4531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9283),
  [4533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9346),
  [4535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9346),
  [4537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [4539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(35),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9231),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15451),
  [4547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10219),
  [4549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13050),
  [4551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10303),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10796),
  [4555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10727),
  [4557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10727),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11861),
  [4563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10296),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [4569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12420),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3592),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20730),
  [4577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18599),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15614),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10317),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13062),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19510),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20240),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20501),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11080),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19513),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20300),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20115),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9870),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5425),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19459),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19463),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20701),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19353),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20062),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12033),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20009),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4367),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20063),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19674),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20364),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10835),
  [4629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11794),
  [4631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19963),
  [4633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19894),
  [4635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20168),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10480),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19600),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19411),
  [4643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18999),
  [4645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20698),
  [4647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20775),
  [4649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5019),
  [4651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19845),
  [4653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20205),
  [4655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20254),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19367),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19165),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10669),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19502),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19772),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20529),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10034),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19198),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19613),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19637),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3767),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19653),
  [4681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19282),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19791),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9397),
  [4687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20309),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11397),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20358),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18933),
  [4695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19550),
  [4697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20204),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20425),
  [4701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19236),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5296),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4476),
  [4707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19678),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19163),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11040),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18916),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19759),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19087),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11218),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20527),
  [4723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19495),
  [4725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19020),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19564),
  [4729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19738),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19840),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20261),
  [4735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20716),
  [4737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11524),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5581),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19000),
  [4743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5705),
  [4745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18922),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20589),
  [4749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19928),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18944),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20722),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18963),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20764),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19997),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9491),
  [4767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19980),
  [4769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9662),
  [4771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19677),
  [4773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20326),
  [4775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20064),
  [4777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18992),
  [4779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5716),
  [4781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11460),
  [4783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20044),
  [4785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19021),
  [4787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4967),
  [4789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19172),
  [4791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11269),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19869),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19211),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19050),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20010),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19970),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20567),
  [4805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20146),
  [4807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19619),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4812),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20810),
  [4815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19937),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19079),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20223),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10693),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4690),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20858),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20283),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19376),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19108),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4607),
  [4835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19137),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20893),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20591),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20723),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20785),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11596),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19124),
  [4849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19166),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3850),
  [4853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11418),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20350),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9933),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19195),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20852),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20927),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5463),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19222),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10954),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18980),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20921),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5273),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5804),
  [4879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20678),
  [4881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20956),
  [4883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20988),
  [4885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [4887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19223),
  [4889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19743),
  [4891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [4893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10504),
  [4895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20108),
  [4897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20433),
  [4899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20977),
  [4901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19816),
  [4903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20957),
  [4905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20637),
  [4907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [4909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [4911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [4913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9291),
  [4915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [4917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3221),
  [4919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16141),
  [4921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14302),
  [4923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12507),
  [4925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14746),
  [4927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [4929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3568),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20387),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18408),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18929),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16874),
  [4939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [4941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3219),
  [4943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12508),
  [4945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15363),
  [4947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17225),
  [4949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18663),
  [4951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15791),
  [4953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17026),
  [4955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15877),
  [4957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18573),
  [4959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [4961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [4963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [4965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [4967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__let_decls, 4),
  [4969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11248),
  [4971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18604),
  [4973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20378),
  [4975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(47),
  [4977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18339),
  [4979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19446),
  [4981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16906),
  [4983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15832),
  [4985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20083),
  [4987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15264),
  [4989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20393),
  [4991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20431),
  [4993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20629),
  [4995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17459),
  [4997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19609),
  [4999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13607),
  [5001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20402),
  [5003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15996),
  [5005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__let_decls, 1),
  [5007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14401),
  [5009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20218),
  [5011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16208),
  [5013] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__let_decls, 3),
  [5015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15929),
  [5017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18557),
  [5019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14076),
  [5021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14333),
  [5023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20649),
  [5025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14931),
  [5027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4161),
  [5030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2),
  [5032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4163),
  [5035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4068),
  [5038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4068),
  [5041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2210),
  [5044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1262),
  [5047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(3963),
  [5050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2251),
  [5053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9181),
  [5056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4093),
  [5059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2),
  [5061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(15962),
  [5064] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10112),
  [5067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12914),
  [5070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16939),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15113),
  [5076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4161),
  [5078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__btype, 1),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4163),
  [5082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4068),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4068),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [5088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1262),
  [5090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(3963),
  [5093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [5095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9181),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [5100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__btype, 1),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15962),
  [5104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10112),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12914),
  [5108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15128),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16934),
  [5112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [5114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11278),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15119),
  [5118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13957),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17472),
  [5122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13878),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19614),
  [5126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(8739),
  [5129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__atype, 1),
  [5131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8945),
  [5134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(8863),
  [5137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8863),
  [5140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2143),
  [5143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 1, .production_id = 14),
  [5145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1115),
  [5148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8055),
  [5151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2238),
  [5154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9176),
  [5157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8949),
  [5160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__atype, 1),
  [5162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(17208),
  [5165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(10256),
  [5168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(12895),
  [5171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17497),
  [5173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16351),
  [5175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16419),
  [5177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_apply, 2),
  [5179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(3963),
  [5182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9181),
  [5185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_apply, 2),
  [5187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15157),
  [5189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19825),
  [5191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4603),
  [5193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [5195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4652),
  [5197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4652),
  [5199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [5201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [5203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(4317),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [5208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9205),
  [5211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [5213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17144),
  [5215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10139),
  [5217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12836),
  [5219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(4317),
  [5222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9205),
  [5225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4603),
  [5228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4542),
  [5231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4652),
  [5234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4652),
  [5237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2168),
  [5240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(999),
  [5243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4317),
  [5246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2256),
  [5249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9205),
  [5252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4541),
  [5255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17144),
  [5258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10139),
  [5261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12836),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20659),
  [5266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3424),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16295),
  [5270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [5272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2667),
  [5274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7559),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7397),
  [5278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7376),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7376),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [5284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7269),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [5290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9143),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7396),
  [5294] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16368),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17726),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10069),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13064),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19756),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16214),
  [5310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(805),
  [5312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6973),
  [5314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9181),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3727),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [5320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5003),
  [5323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4881),
  [5326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5061),
  [5329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5061),
  [5332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2167),
  [5335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1104),
  [5338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4581),
  [5341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2353),
  [5344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9023),
  [5347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(4880),
  [5350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17446),
  [5353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10074),
  [5356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13028),
  [5359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7091),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3629),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3561),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20410),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18211),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6858),
  [5373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5003),
  [5375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4881),
  [5377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5061),
  [5379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [5381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [5383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [5385] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(4581),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2353),
  [5390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9023),
  [5393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [5395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17446),
  [5397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10074),
  [5399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13028),
  [5401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(4581),
  [5404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9023),
  [5407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7660),
  [5409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7627),
  [5411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7683),
  [5413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7683),
  [5415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [5417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [5419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14636),
  [5421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7374),
  [5423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [5425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9067),
  [5427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7629),
  [5429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16770),
  [5431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10273),
  [5433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12787),
  [5435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10807),
  [5437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7027),
  [5439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8885),
  [5441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3423),
  [5443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2660),
  [5445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2664),
  [5447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11754),
  [5449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17832),
  [5451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15856),
  [5453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14974),
  [5455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [5457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6439),
  [5459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18541),
  [5461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6405),
  [5463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8342),
  [5465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6568),
  [5467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4718),
  [5469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15956),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6687),
  [5473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6371),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3800),
  [5477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7517),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9461),
  [5481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6211),
  [5483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11405),
  [5485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7691),
  [5487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17200),
  [5489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11220),
  [5491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5643),
  [5493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6340),
  [5495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [5497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5719),
  [5499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8091),
  [5501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7059),
  [5503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10615),
  [5505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6492),
  [5507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17754),
  [5509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7472),
  [5511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5283),
  [5513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9817),
  [5515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9846),
  [5517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [5519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6743),
  [5521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4992),
  [5523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [5525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8935),
  [5527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7424),
  [5529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7983),
  [5531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7001),
  [5533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [5535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18578),
  [5537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6070),
  [5539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17851),
  [5541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11207),
  [5543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [5545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11512),
  [5547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7217),
  [5549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10248),
  [5551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4900),
  [5553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7631),
  [5555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4898),
  [5557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [5559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7421),
  [5561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14236),
  [5563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8367),
  [5565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7773),
  [5567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6641),
  [5569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4888),
  [5571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [5573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7026),
  [5575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4895),
  [5577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5781),
  [5579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7363),
  [5581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9027),
  [5583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6300),
  [5585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13454),
  [5587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14034),
  [5589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11063),
  [5591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7243),
  [5593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3762),
  [5595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8389),
  [5597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11253),
  [5599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8674),
  [5601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7113),
  [5603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7732),
  [5605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5879),
  [5607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3961),
  [5609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10969),
  [5611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4276),
  [5613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8982),
  [5615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11363),
  [5617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5889),
  [5619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6035),
  [5621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15228),
  [5623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8418),
  [5625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7349),
  [5627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11061),
  [5629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11916),
  [5631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5990),
  [5633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7209),
  [5635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7379),
  [5637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10767),
  [5639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10755),
  [5641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10475),
  [5643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8459),
  [5645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5511),
  [5647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8799),
  [5649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7169),
  [5651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [5653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9632),
  [5655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5960),
  [5657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8260),
  [5659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6760),
  [5661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9392),
  [5663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12179),
  [5665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8416),
  [5667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6272),
  [5669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6494),
  [5671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4773),
  [5673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6598),
  [5675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5397),
  [5677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14311),
  [5679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5956),
  [5681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7626),
  [5683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8464),
  [5685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6675),
  [5687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8768),
  [5689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8333),
  [5691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8947),
  [5693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7181),
  [5695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6575),
  [5697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8966),
  [5699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5908),
  [5701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6072),
  [5703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8816),
  [5705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5843),
  [5709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7226),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7053),
  [5713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4643),
  [5715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14667),
  [5717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13647),
  [5719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8556),
  [5721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6544),
  [5723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8127),
  [5725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7356),
  [5727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8528),
  [5729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6164),
  [5731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14142),
  [5733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7767),
  [5735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7231),
  [5737] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5785),
  [5740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5892),
  [5743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5838),
  [5746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5838),
  [5749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2185),
  [5752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1252),
  [5755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5665),
  [5758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2253),
  [5761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9055),
  [5764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5895),
  [5767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16420),
  [5770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10146),
  [5773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12991),
  [5776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17875),
  [5778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7440),
  [5780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6117),
  [5782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7580),
  [5784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6896),
  [5786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7413),
  [5788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9030),
  [5790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6917),
  [5792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3535),
  [5794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [5796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5785),
  [5798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5892),
  [5800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5838),
  [5802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5838),
  [5804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [5806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [5808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5665),
  [5811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2253),
  [5813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9055),
  [5816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5895),
  [5818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16420),
  [5820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10146),
  [5822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12991),
  [5824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15415),
  [5826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6305),
  [5828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14044),
  [5830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7986),
  [5832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6696),
  [5834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6465),
  [5836] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5665),
  [5839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9055),
  [5842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6206),
  [5844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8158),
  [5846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6490),
  [5848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6578),
  [5850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7123),
  [5852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7236),
  [5854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6681),
  [5856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6633),
  [5858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6565),
  [5860] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5768),
  [5863] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5783),
  [5866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5912),
  [5869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5912),
  [5872] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2171),
  [5875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1038),
  [5878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5557),
  [5881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2247),
  [5884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9115),
  [5887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5784),
  [5890] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17336),
  [5893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10086),
  [5896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12999),
  [5899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8739),
  [5902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6694),
  [5904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7650),
  [5906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6124),
  [5908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14529),
  [5910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6358),
  [5912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7513),
  [5914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5768),
  [5916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5783),
  [5918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5912),
  [5920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5912),
  [5922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [5924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [5926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5557),
  [5929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2247),
  [5931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9115),
  [5934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [5936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17336),
  [5938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10086),
  [5940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12999),
  [5942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6249),
  [5944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8326),
  [5946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5557),
  [5949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9115),
  [5952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7418),
  [5954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7366),
  [5956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8170),
  [5958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7866),
  [5960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5048),
  [5962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6874),
  [5964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6170),
  [5966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6297),
  [5968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6347),
  [5970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6455),
  [5972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6455),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [5976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14753),
  [5980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6080),
  [5982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [5984] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9182),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6350),
  [5988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16504),
  [5990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10172),
  [5992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12974),
  [5994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [5996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15010),
  [5998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [6000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9205),
  [6002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7437),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7485),
  [6006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7384),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7384),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [6012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14907),
  [6016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7114),
  [6018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [6020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9031),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7342),
  [6024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15813),
  [6026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10251),
  [6028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12866),
  [6030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5768),
  [6032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(813),
  [6034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14629),
  [6036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5557),
  [6038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9115),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15392),
  [6042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7853),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7818),
  [6046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7832),
  [6048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7832),
  [6050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [6052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(851),
  [6054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14791),
  [6056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7657),
  [6058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [6060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9083),
  [6062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7828),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17498),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10159),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12977),
  [6070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6120),
  [6073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6026),
  [6076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6091),
  [6079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6091),
  [6082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2192),
  [6085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1163),
  [6088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5893),
  [6091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2248),
  [6094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9075),
  [6097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6024),
  [6100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17597),
  [6103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9985),
  [6106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13090),
  [6109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15072),
  [6111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7555),
  [6113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7581),
  [6115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7593),
  [6117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7593),
  [6119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [6121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [6123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14890),
  [6125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7223),
  [6127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [6129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9198),
  [6131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7578),
  [6133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17196),
  [6135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10135),
  [6137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13034),
  [6139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7851),
  [6141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7705),
  [6143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7815),
  [6145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7815),
  [6147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2184),
  [6149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [6151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14963),
  [6153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7628),
  [6155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [6157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9050),
  [6159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7704),
  [6161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17529),
  [6163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10154),
  [6165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12990),
  [6167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7358),
  [6169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7386),
  [6171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7504),
  [6173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7504),
  [6175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [6177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(861),
  [6179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15153),
  [6181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7135),
  [6183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [6185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9029),
  [6187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7390),
  [6189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16782),
  [6191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10305),
  [6193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12771),
  [6195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6048),
  [6197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6228),
  [6199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6218),
  [6201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6218),
  [6203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2120),
  [6205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(889),
  [6207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14689),
  [6209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5763),
  [6211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [6213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9177),
  [6215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6229),
  [6217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16500),
  [6219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10168),
  [6221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12975),
  [6223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8292),
  [6226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 1),
  [6228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8351),
  [6231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8309),
  [6234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8309),
  [6237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(2164),
  [6240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13),
  [6242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(1060),
  [6245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8081),
  [6248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(2313),
  [6251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(9211),
  [6254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8349),
  [6257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16307),
  [6259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_data_constructor, 1),
  [6261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(16585),
  [6264] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__modid, 1, .production_id = 2),
  [6266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(10209),
  [6269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(12813),
  [6272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3604),
  [6274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3607),
  [6276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6154),
  [6278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6064),
  [6280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6134),
  [6282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [6284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [6286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [6288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5863),
  [6291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [6293] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9197),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6063),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16595),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10220),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12731),
  [6304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6736),
  [6306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6592),
  [6308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6709),
  [6310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6709),
  [6312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2166),
  [6314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15006),
  [6318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6394),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [6322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9051),
  [6324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6593),
  [6326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16763),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10262),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12859),
  [6332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5863),
  [6335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9197),
  [6338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6110),
  [6340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5958),
  [6342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6139),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6139),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [6348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14786),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5894),
  [6354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [6356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9089),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5959),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17618),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9988),
  [6364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13087),
  [6366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7283),
  [6368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7104),
  [6370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7134),
  [6372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7134),
  [6374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [6376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [6378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14767),
  [6380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6944),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [6384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9020),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7105),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16953),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10295),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12918),
  [6394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6159),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5998),
  [6398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6174),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6174),
  [6402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [6404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [6406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14811),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5873),
  [6410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [6412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9070),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [6416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16442),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10150),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12988),
  [6422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [6424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5763),
  [6427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9177),
  [6430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5763),
  [6433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9177),
  [6436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7112),
  [6438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7208),
  [6440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7277),
  [6442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7277),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [6446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [6448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15200),
  [6450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6879),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [6454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9036),
  [6456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7205),
  [6458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16801),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10315),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12773),
  [6464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6110),
  [6467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5958),
  [6470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6139),
  [6473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6139),
  [6476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2212),
  [6479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1168),
  [6482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5894),
  [6485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2283),
  [6488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9089),
  [6491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5959),
  [6494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17618),
  [6497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9988),
  [6500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13087),
  [6503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7119),
  [6505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7156),
  [6507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7235),
  [6509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7235),
  [6511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [6513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [6515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15318),
  [6517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6972),
  [6519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [6521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9102),
  [6523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7150),
  [6525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16288),
  [6527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10180),
  [6529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12790),
  [6531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7288),
  [6533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7224),
  [6535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7168),
  [6537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7168),
  [6539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [6541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [6543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14986),
  [6545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6943),
  [6547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [6549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9009),
  [6551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7230),
  [6553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16634),
  [6555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10259),
  [6557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12742),
  [6559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6891),
  [6561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7019),
  [6563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6893),
  [6565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6893),
  [6567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [6569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [6571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15125),
  [6573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6780),
  [6575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [6577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9147),
  [6579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7016),
  [6581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16979),
  [6583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10279),
  [6585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12794),
  [6587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6275),
  [6589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6389),
  [6591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6314),
  [6593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6314),
  [6595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [6597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(839),
  [6599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15110),
  [6601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6113),
  [6603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [6605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9188),
  [6607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6400),
  [6609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16603),
  [6611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10226),
  [6613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12734),
  [6615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6120),
  [6617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6026),
  [6619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6091),
  [6621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6091),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [6625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [6627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14785),
  [6629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5893),
  [6631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2248),
  [6633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9075),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6024),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17597),
  [6639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9985),
  [6641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13090),
  [6643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6570),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6475),
  [6647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6259),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6259),
  [6651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [6653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [6655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15245),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6216),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [6661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9122),
  [6663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6474),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16865),
  [6667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10307),
  [6669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12777),
  [6671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6159),
  [6673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [6675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5873),
  [6678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9070),
  [6681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6701),
  [6683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6751),
  [6685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6673),
  [6687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6673),
  [6689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [6691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [6693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14949),
  [6695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6269),
  [6697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [6699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9100),
  [6701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6764),
  [6703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17361),
  [6705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10084),
  [6707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13003),
  [6709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6225),
  [6712] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5955),
  [6715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6155),
  [6718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6155),
  [6721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2227),
  [6724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1250),
  [6727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5874),
  [6730] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2271),
  [6733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9062),
  [6736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5957),
  [6739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16432),
  [6742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10148),
  [6745] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12989),
  [6748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6556),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6388),
  [6752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6430),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6430),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [6758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [6760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14630),
  [6762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6079),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [6766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9160),
  [6768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6401),
  [6770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16490),
  [6772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10165),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12979),
  [6776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6870),
  [6778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7008),
  [6780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6914),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6914),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [6786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [6788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15238),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6778),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [6794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9144),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7009),
  [6798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16954),
  [6800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10291),
  [6802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12789),
  [6804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5873),
  [6807] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9070),
  [6810] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6154),
  [6813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6064),
  [6816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6134),
  [6819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6134),
  [6822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2150),
  [6825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1166),
  [6828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5863),
  [6831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2335),
  [6834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9197),
  [6837] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6063),
  [6840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16595),
  [6843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10220),
  [6846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12731),
  [6849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6120),
  [6851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [6853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5893),
  [6856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9075),
  [6859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6225),
  [6861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5955),
  [6863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6155),
  [6865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6155),
  [6867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [6869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [6871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5874),
  [6874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [6876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9062),
  [6879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5957),
  [6881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16432),
  [6883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10148),
  [6885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12989),
  [6887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5874),
  [6890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9062),
  [6893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(814),
  [6895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14893),
  [6897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5874),
  [6899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9062),
  [6901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6408),
  [6903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6357),
  [6905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6296),
  [6907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6296),
  [6909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [6911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14922),
  [6915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6101),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [6919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9148),
  [6921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6368),
  [6923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16576),
  [6925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10207),
  [6927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12851),
  [6929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7261),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7278),
  [6933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7129),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7129),
  [6937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [6939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(854),
  [6941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14810),
  [6943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7037),
  [6945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [6947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9156),
  [6949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7286),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16562),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10202),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12879),
  [6957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7554),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7406),
  [6961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7562),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7562),
  [6965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [6967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [6969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15287),
  [6971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7154),
  [6973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [6975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9056),
  [6977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7411),
  [6979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17573),
  [6981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9981),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13096),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6110),
  [6987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [6989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(5894),
  [6992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9089),
  [6995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8269),
  [6998] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8348),
  [7001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8179),
  [7004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8179),
  [7007] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(2180),
  [7010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(1030),
  [7013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8146),
  [7016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(2350),
  [7019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(9174),
  [7022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8347),
  [7025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16777),
  [7027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(17799),
  [7030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(10075),
  [7033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(13046),
  [7036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3593),
  [7038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3594),
  [7040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6698),
  [7042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6722),
  [7044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6646),
  [7046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6646),
  [7048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [7050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(838),
  [7052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15351),
  [7054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6308),
  [7056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [7058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9132),
  [7060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6727),
  [7062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16915),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10298),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12786),
  [7068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7446),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7576),
  [7072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7490),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7490),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [7078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [7080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14763),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7062),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [7086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9154),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7595),
  [7090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17272),
  [7092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10122),
  [7094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12922),
  [7096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5893),
  [7099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9075),
  [7102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(5894),
  [7105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9089),
  [7108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6154),
  [7110] = {.entry = {.count = 1, .reusable = false}}, SHIFT(829),
  [7112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15038),
  [7114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5863),
  [7116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9197),
  [7118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [7120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14944),
  [7122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5665),
  [7124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9055),
  [7126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6519),
  [7128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6402),
  [7130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6571),
  [7132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6571),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [7136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15122),
  [7140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6153),
  [7142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [7144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9010),
  [7146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6397),
  [7148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17427),
  [7150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10079),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13013),
  [7154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [7156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15288),
  [7158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [7160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9023),
  [7162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6048),
  [7165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6228),
  [7168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6218),
  [7171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6218),
  [7174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2120),
  [7177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1236),
  [7180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5763),
  [7183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2311),
  [7186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9177),
  [7189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6229),
  [7192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16500),
  [7195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10168),
  [7198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12975),
  [7201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6627),
  [7203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6622),
  [7205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6604),
  [7207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6604),
  [7209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [7211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(886),
  [7213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15413),
  [7215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6511),
  [7217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [7219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9193),
  [7221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6625),
  [7223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17747),
  [7225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10070),
  [7227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13055),
  [7229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6251),
  [7231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6425),
  [7233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6380),
  [7235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6380),
  [7237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [7239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [7241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15329),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6038),
  [7245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [7247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9094),
  [7249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6426),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17685),
  [7253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10010),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13069),
  [7257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6912),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7045),
  [7261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6883),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6883),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [7267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14688),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6783),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [7275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9113),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7044),
  [7279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16476),
  [7281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10160),
  [7283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12984),
  [7285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6486),
  [7287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6432),
  [7289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6364),
  [7291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6364),
  [7293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [7295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [7297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15393),
  [7299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6223),
  [7301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [7303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9127),
  [7305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6431),
  [7307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16893),
  [7309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10299),
  [7311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12784),
  [7313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6731),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6771),
  [7317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6784),
  [7319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6784),
  [7321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [7323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(847),
  [7325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14866),
  [7327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6252),
  [7329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [7331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9071),
  [7333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6772),
  [7335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16567),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10204),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12868),
  [7341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7245),
  [7343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7144),
  [7345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7204),
  [7347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7204),
  [7349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [7351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15166),
  [7355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7029),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [7359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9049),
  [7361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7145),
  [7363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16003),
  [7365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10272),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12736),
  [7369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7608),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7606),
  [7373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7665),
  [7375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7665),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [7379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(849),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15191),
  [7383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7344),
  [7385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [7387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9039),
  [7389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7604),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17560),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10144),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13017),
  [7397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6454),
  [7399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6509),
  [7401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6410),
  [7403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6410),
  [7405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [7407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [7409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14610),
  [7411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6231),
  [7413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [7415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8993),
  [7417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6513),
  [7419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16002),
  [7421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10232),
  [7423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13061),
  [7425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6159),
  [7428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5998),
  [7431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6174),
  [7434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6174),
  [7437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2200),
  [7440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1246),
  [7443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5873),
  [7446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2355),
  [7449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9070),
  [7452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(5999),
  [7455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16442),
  [7458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10150),
  [7461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12988),
  [7464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6454),
  [7467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6509),
  [7470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6410),
  [7473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6410),
  [7476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2133),
  [7479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1251),
  [7482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6231),
  [7485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2315),
  [7488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8993),
  [7491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6513),
  [7494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16002),
  [7497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10232),
  [7500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13061),
  [7503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [7505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [7507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6079),
  [7510] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9160),
  [7513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8585),
  [7516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8413),
  [7519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8019),
  [7522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8019),
  [7525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(2196),
  [7528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(1079),
  [7531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(7867),
  [7534] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(2296),
  [7537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(9172),
  [7540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8423),
  [7543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16278),
  [7545] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(17012),
  [7548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(10263),
  [7551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(12816),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6297),
  [7560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [7562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6080),
  [7565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9182),
  [7568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6080),
  [7571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9182),
  [7574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6570),
  [7577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6475),
  [7580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6259),
  [7583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6259),
  [7586] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2221),
  [7589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1089),
  [7592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6216),
  [7595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2343),
  [7598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9122),
  [7601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6474),
  [7604] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16865),
  [7607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10307),
  [7610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12777),
  [7613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6486),
  [7616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6432),
  [7619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6364),
  [7622] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6364),
  [7625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2106),
  [7628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1054),
  [7631] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6223),
  [7634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2338),
  [7637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9127),
  [7640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6431),
  [7643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16893),
  [7646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10299),
  [7649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12784),
  [7652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [7654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6231),
  [7657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(8993),
  [7660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6079),
  [7663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9160),
  [7666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [7668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6101),
  [7671] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9148),
  [7674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6101),
  [7677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9148),
  [7680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [7682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6038),
  [7685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9094),
  [7688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6408),
  [7691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6357),
  [7694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6296),
  [7697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6296),
  [7700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2219),
  [7703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1172),
  [7706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6101),
  [7709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2261),
  [7712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9148),
  [7715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6368),
  [7718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16576),
  [7721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10207),
  [7724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12851),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6275),
  [7729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [7731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6113),
  [7734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9188),
  [7737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6556),
  [7740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6388),
  [7743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6430),
  [7746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6430),
  [7749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2114),
  [7752] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1238),
  [7755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6079),
  [7758] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2328),
  [7761] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9160),
  [7764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6401),
  [7767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16490),
  [7770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10165),
  [7773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12979),
  [7776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6113),
  [7779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9188),
  [7782] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6519),
  [7785] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6402),
  [7788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6571),
  [7791] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6571),
  [7794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2110),
  [7797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1094),
  [7800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6153),
  [7803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2316),
  [7806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9010),
  [7809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6397),
  [7812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17427),
  [7815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10079),
  [7818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13013),
  [7821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6519),
  [7823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [7825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6153),
  [7828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9010),
  [7831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6275),
  [7834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6389),
  [7837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6314),
  [7840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6314),
  [7843] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2127),
  [7846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1148),
  [7849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6113),
  [7852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2245),
  [7855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9188),
  [7858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6400),
  [7861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16603),
  [7864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10226),
  [7867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12734),
  [7870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6038),
  [7873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9094),
  [7876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6153),
  [7879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9010),
  [7882] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6297),
  [7885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6347),
  [7888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6455),
  [7891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6455),
  [7894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2174),
  [7897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1233),
  [7900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6080),
  [7903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2307),
  [7906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9182),
  [7909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6350),
  [7912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16504),
  [7915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10172),
  [7918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12974),
  [7921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6570),
  [7923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [7925] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6216),
  [7928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9122),
  [7931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6216),
  [7934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9122),
  [7937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6231),
  [7940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(8993),
  [7943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6486),
  [7945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [7947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6223),
  [7950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9127),
  [7953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6223),
  [7956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9127),
  [7959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6251),
  [7962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6425),
  [7965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6380),
  [7968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6380),
  [7971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2108),
  [7974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1180),
  [7977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6038),
  [7980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2300),
  [7983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9094),
  [7986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6426),
  [7989] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17685),
  [7992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10010),
  [7995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13069),
  [7998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6698),
  [8000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1022),
  [8002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6308),
  [8005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9132),
  [8008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6308),
  [8011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9132),
  [8014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6701),
  [8016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [8018] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6269),
  [8021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9100),
  [8024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6736),
  [8027] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6592),
  [8030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6709),
  [8033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6709),
  [8036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2166),
  [8039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(971),
  [8042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6394),
  [8045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2304),
  [8048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9051),
  [8051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6593),
  [8054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16763),
  [8057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10262),
  [8060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12859),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4161),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6731),
  [8067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [8069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6252),
  [8072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9071),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6627),
  [8077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [8079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6511),
  [8082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9193),
  [8085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(971),
  [8087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6394),
  [8090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9051),
  [8093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6627),
  [8096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6622),
  [8099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6604),
  [8102] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6604),
  [8105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2223),
  [8108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1197),
  [8111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6511),
  [8114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2326),
  [8117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9193),
  [8120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6625),
  [8123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17747),
  [8126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10070),
  [8129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13055),
  [8132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6701),
  [8135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6751),
  [8138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6673),
  [8141] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6673),
  [8144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2140),
  [8147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1046),
  [8150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6269),
  [8153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2331),
  [8156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9100),
  [8159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6764),
  [8162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17361),
  [8165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10084),
  [8168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13003),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7559),
  [8173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6511),
  [8176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9193),
  [8179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6252),
  [8182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9071),
  [8185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6698),
  [8188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6722),
  [8191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6646),
  [8194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6646),
  [8197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2113),
  [8200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1022),
  [8203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6308),
  [8206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2325),
  [8209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9132),
  [8212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6727),
  [8215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16915),
  [8218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10298),
  [8221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12786),
  [8224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6269),
  [8227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9100),
  [8230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6394),
  [8233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9051),
  [8236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6731),
  [8239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6771),
  [8242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6784),
  [8245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6784),
  [8248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2214),
  [8251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1056),
  [8254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6252),
  [8257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2234),
  [8260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9071),
  [8263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6772),
  [8266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16567),
  [8269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10204),
  [8272] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12868),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6891),
  [8277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [8279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6780),
  [8282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9147),
  [8285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6780),
  [8288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9147),
  [8291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6870),
  [8293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [8295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6778),
  [8298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9144),
  [8301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6778),
  [8304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9144),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [8309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [8313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [8315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [8317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6783),
  [8320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9113),
  [8323] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6783),
  [8326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9113),
  [8329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6891),
  [8332] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7019),
  [8335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6893),
  [8338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6893),
  [8341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2169),
  [8344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1004),
  [8347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6780),
  [8350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2285),
  [8353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9147),
  [8356] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7016),
  [8359] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16979),
  [8362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10279),
  [8365] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12794),
  [8368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6870),
  [8371] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7008),
  [8374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6914),
  [8377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6914),
  [8380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2147),
  [8383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(994),
  [8386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6778),
  [8389] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2289),
  [8392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9144),
  [8395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7009),
  [8398] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16954),
  [8401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10291),
  [8404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12789),
  [8407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6912),
  [8410] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7045),
  [8413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6883),
  [8416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6883),
  [8419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2097),
  [8422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1239),
  [8425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6783),
  [8428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2354),
  [8431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9113),
  [8434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7044),
  [8437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16476),
  [8440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10160),
  [8443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12984),
  [8446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2675),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [8450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [8454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2674),
  [8456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(810),
  [8458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9059),
  [8460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2698),
  [8462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10578),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10684),
  [8466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10448),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10448),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [8472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10508),
  [8474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(594),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10270),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [8480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12419),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3688),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19083),
  [8488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18295),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17709),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10087),
  [8494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13067),
  [8496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [8498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10394),
  [8500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [8502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [8504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12357),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18917),
  [8512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18176),
  [8514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7119),
  [8516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1260),
  [8518] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6972),
  [8521] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9102),
  [8524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7283),
  [8526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [8528] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6944),
  [8531] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9020),
  [8534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1205),
  [8536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7037),
  [8539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9156),
  [8542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7037),
  [8545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9156),
  [8548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7245),
  [8551] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7144),
  [8554] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7204),
  [8557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7204),
  [8560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2183),
  [8563] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1261),
  [8566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7029),
  [8569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2278),
  [8572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9049),
  [8575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7145),
  [8578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16003),
  [8581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10272),
  [8584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12736),
  [8587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7112),
  [8590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7208),
  [8593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7277),
  [8596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7277),
  [8599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2156),
  [8602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1102),
  [8605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6879),
  [8608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2324),
  [8611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9036),
  [8614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7205),
  [8617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16801),
  [8620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10315),
  [8623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12773),
  [8626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7261),
  [8629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7278),
  [8632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7129),
  [8635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7129),
  [8638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2178),
  [8641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1205),
  [8644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7037),
  [8647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2255),
  [8650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9156),
  [8653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7286),
  [8656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16562),
  [8659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10202),
  [8662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12879),
  [8665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11288),
  [8667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10970),
  [8669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11118),
  [8671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11118),
  [8673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [8675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11352),
  [8677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(572),
  [8679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10423),
  [8681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [8683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12280),
  [8685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [8687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [8689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19735),
  [8691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18367),
  [8693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17343),
  [8695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10212),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12960),
  [8699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [8701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [8703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [8705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [8707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(571),
  [8709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [8711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10864),
  [8713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11294),
  [8715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11313),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11313),
  [8719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11206),
  [8723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [8725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10703),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [8729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12458),
  [8731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3687),
  [8735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19465),
  [8737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18188),
  [8739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17224),
  [8741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10134),
  [8743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12899),
  [8745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [8747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7029),
  [8750] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9049),
  [8753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11630),
  [8755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11917),
  [8757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11571),
  [8759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11571),
  [8761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [8763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [8765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11205),
  [8767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [8769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17277),
  [8771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10116),
  [8773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12846),
  [8775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10810),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10449),
  [8779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10357),
  [8781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10357),
  [8783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [8785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10585),
  [8787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [8789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10176),
  [8791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [8793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12260),
  [8795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3650),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3654),
  [8799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20076),
  [8801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18199),
  [8803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17255),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10129),
  [8807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12912),
  [8809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9661),
  [8811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9630),
  [8813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9606),
  [8815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9606),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9656),
  [8821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(579),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9543),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [8827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12401),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3658),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [8833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19181),
  [8835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18287),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17643),
  [8839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9989),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13085),
  [8843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1102),
  [8845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6879),
  [8848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9036),
  [8851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6879),
  [8854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9036),
  [8857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14393),
  [8859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7283),
  [8862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7104),
  [8865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7134),
  [8868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7134),
  [8871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2131),
  [8874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1019),
  [8877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6944),
  [8880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2323),
  [8883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9020),
  [8886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7105),
  [8889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16953),
  [8892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10295),
  [8895] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12918),
  [8898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13574),
  [8900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [8902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9342),
  [8904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [8906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [8908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12272),
  [8910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3521),
  [8912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [8914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20840),
  [8916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18234),
  [8918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13544),
  [8920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13413),
  [8922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10455),
  [8924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10363),
  [8926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10495),
  [8928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10495),
  [8930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [8932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10731),
  [8934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [8936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10103),
  [8938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [8940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12262),
  [8942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3512),
  [8944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3513),
  [8946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19302),
  [8948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18157),
  [8950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16764),
  [8952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10297),
  [8954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12768),
  [8956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11666),
  [8958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11772),
  [8960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11665),
  [8962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11665),
  [8964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11537),
  [8968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [8970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10966),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [8974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12441),
  [8976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3539),
  [8978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [8980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20203),
  [8982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18254),
  [8984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17485),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10006),
  [8988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13056),
  [8990] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7288),
  [8993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7224),
  [8996] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7168),
  [8999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7168),
  [9002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2201),
  [9005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(980),
  [9008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6943),
  [9011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2244),
  [9014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9009),
  [9017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7230),
  [9020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16634),
  [9023] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10259),
  [9026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12742),
  [9029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [9031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(577),
  [9033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [9035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6972),
  [9038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9102),
  [9041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7119),
  [9044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7156),
  [9047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7235),
  [9050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7235),
  [9053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2209),
  [9056] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1260),
  [9059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6972),
  [9062] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2254),
  [9065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9102),
  [9068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7150),
  [9071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16288),
  [9074] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10180),
  [9077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12790),
  [9080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7029),
  [9083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9049),
  [9086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11307),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11475),
  [9090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11170),
  [9092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11170),
  [9094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10868),
  [9098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(582),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10541),
  [9102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [9104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12359),
  [9106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3566),
  [9108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19627),
  [9112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18332),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17436),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10195),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12971),
  [9120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10332),
  [9122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10418),
  [9124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10372),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10372),
  [9128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10552),
  [9132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10025),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [9138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12468),
  [9140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [9142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [9144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19084),
  [9146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18168),
  [9148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16835),
  [9150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10310),
  [9152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12775),
  [9154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13877),
  [9156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10915),
  [9158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11159),
  [9160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10931),
  [9162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10931),
  [9164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [9166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11476),
  [9168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [9170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10587),
  [9172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [9174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12408),
  [9176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [9178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [9180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19721),
  [9182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18271),
  [9184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17527),
  [9186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9980),
  [9188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13091),
  [9190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6944),
  [9193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9020),
  [9196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14305),
  [9198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7288),
  [9200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(980),
  [9202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(6943),
  [9205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9009),
  [9208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(6943),
  [9211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9009),
  [9214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [9216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10362),
  [9218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [9220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [9222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12366),
  [9224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [9226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [9228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19392),
  [9230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18300),
  [9232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [9234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [9236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [9238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9978),
  [9240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10271),
  [9242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(10005),
  [9244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10005),
  [9246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [9248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10194),
  [9250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(580),
  [9252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9824),
  [9254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [9256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12402),
  [9258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [9260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [9262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19487),
  [9264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18142),
  [9266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16556),
  [9268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10199),
  [9270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12916),
  [9272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11074),
  [9274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11261),
  [9276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11376),
  [9278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11376),
  [9280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [9282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10999),
  [9284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [9286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10539),
  [9288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [9290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12447),
  [9292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [9294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20859),
  [9298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18213),
  [9300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17321),
  [9302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10060),
  [9304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12997),
  [9306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [9308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11282),
  [9310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [9312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [9314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12404),
  [9316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3531),
  [9318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3530),
  [9320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20068),
  [9322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18392),
  [9324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(6925),
  [9327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7364),
  [9330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7579),
  [9333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7579),
  [9336] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2118),
  [9339] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1005),
  [9342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7296),
  [9345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2346),
  [9348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9146),
  [9351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7362),
  [9354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16930),
  [9357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10304),
  [9360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12819),
  [9363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7555),
  [9366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7581),
  [9369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7593),
  [9372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7593),
  [9375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2145),
  [9378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1012),
  [9381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7223),
  [9384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2284),
  [9387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9198),
  [9390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7578),
  [9393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17196),
  [9396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10135),
  [9399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13034),
  [9402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7358),
  [9404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(972),
  [9406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7135),
  [9409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9029),
  [9412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6925),
  [9414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [9416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7296),
  [9419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9146),
  [9422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7446),
  [9425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7576),
  [9428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7490),
  [9431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7490),
  [9434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2135),
  [9437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1024),
  [9440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7062),
  [9443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2340),
  [9446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9154),
  [9449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7595),
  [9452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17272),
  [9455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10122),
  [9458] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12922),
  [9461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7296),
  [9464] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9146),
  [9467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [9469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7223),
  [9472] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9198),
  [9475] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7559),
  [9478] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7397),
  [9481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7376),
  [9484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7376),
  [9487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2162),
  [9490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1190),
  [9493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7269),
  [9496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2349),
  [9499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9143),
  [9502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7396),
  [9505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17726),
  [9508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10069),
  [9511] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13064),
  [9514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7135),
  [9517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9029),
  [9520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [9522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7269),
  [9525] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9143),
  [9528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1116),
  [9530] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7114),
  [9533] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9031),
  [9536] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7114),
  [9539] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9031),
  [9542] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7223),
  [9545] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9198),
  [9548] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7269),
  [9551] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9143),
  [9554] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7358),
  [9557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7386),
  [9560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7504),
  [9563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7504),
  [9566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2197),
  [9569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(972),
  [9572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7135),
  [9575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2286),
  [9578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9029),
  [9581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7390),
  [9584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16782),
  [9587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10305),
  [9590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12771),
  [9593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [9595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7062),
  [9598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9154),
  [9601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7062),
  [9604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9154),
  [9607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7554),
  [9609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [9611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7154),
  [9614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9056),
  [9617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7154),
  [9620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9056),
  [9623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7554),
  [9626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7406),
  [9629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7562),
  [9632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7562),
  [9635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2172),
  [9638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1158),
  [9641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7154),
  [9644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2282),
  [9647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9056),
  [9650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7411),
  [9653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17573),
  [9656] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9981),
  [9659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13096),
  [9662] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7437),
  [9665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7485),
  [9668] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7384),
  [9671] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7384),
  [9674] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2202),
  [9677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1116),
  [9680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7114),
  [9683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2265),
  [9686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9031),
  [9689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7342),
  [9692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(15813),
  [9695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10251),
  [9698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12866),
  [9701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7849),
  [9703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__apat, 1),
  [9705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7924),
  [9707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7917),
  [9709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7917),
  [9711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [9713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [9715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(7615),
  [9718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [9720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12127),
  [9722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7877),
  [9724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16180),
  [9726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10198),
  [9728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13045),
  [9730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [9732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [9734] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7660),
  [9737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7627),
  [9740] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7683),
  [9743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7683),
  [9746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2122),
  [9749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1302),
  [9752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7374),
  [9755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2334),
  [9758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9067),
  [9761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7629),
  [9764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16770),
  [9767] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10273),
  [9770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12787),
  [9773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [9775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9215),
  [9777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7660),
  [9779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [9781] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7374),
  [9784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9067),
  [9787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [9789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9025),
  [9791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7608),
  [9794] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7606),
  [9797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7665),
  [9800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7665),
  [9803] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2159),
  [9806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1264),
  [9809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7344),
  [9812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2228),
  [9815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9039),
  [9818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7604),
  [9821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17560),
  [9824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10144),
  [9827] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13017),
  [9830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7374),
  [9833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9067),
  [9836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [9838] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7344),
  [9841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9039),
  [9844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(807),
  [9846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9005),
  [9848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(841),
  [9850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9028),
  [9852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7344),
  [9855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9039),
  [9858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(852),
  [9860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8992),
  [9862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [9864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2725),
  [9866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7851),
  [9869] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7705),
  [9872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7815),
  [9875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7815),
  [9878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2184),
  [9881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1299),
  [9884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7628),
  [9887] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2276),
  [9890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9050),
  [9893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7704),
  [9896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17529),
  [9899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10154),
  [9902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12990),
  [9905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8255),
  [9908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8354),
  [9911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(8337),
  [9914] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8337),
  [9917] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2213),
  [9920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1080),
  [9923] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8107),
  [9926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2239),
  [9929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9066),
  [9932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8356),
  [9935] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(17086),
  [9938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(10161),
  [9941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(12831),
  [9944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7851),
  [9946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [9948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7628),
  [9951] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9050),
  [9954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7882),
  [9956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8048),
  [9958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8151),
  [9960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8151),
  [9962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [9964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(75),
  [9966] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(7836),
  [9969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [9971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12212),
  [9973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7998),
  [9975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17720),
  [9977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10125),
  [9979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13002),
  [9981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [9983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [9985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7922),
  [9987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8149),
  [9989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8058),
  [9991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8058),
  [9993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [9995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(70),
  [9997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(3987),
  [10000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [10002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12076),
  [10004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7966),
  [10006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16755),
  [10008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10288),
  [10010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12733),
  [10012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [10014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [10016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8193),
  [10019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8316),
  [10022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(8264),
  [10025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8264),
  [10028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2109),
  [10031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1076),
  [10034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8105),
  [10037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2344),
  [10040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9124),
  [10043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8311),
  [10046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(15794),
  [10049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(10162),
  [10052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(13004),
  [10055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2671),
  [10057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9207),
  [10060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9169),
  [10063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9021),
  [10066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9021),
  [10069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2173),
  [10072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1297),
  [10075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), REDUCE(sym_constraint, 1, .production_id = 14),
  [10078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8908),
  [10081] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2288),
  [10084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9179),
  [10087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(9213),
  [10090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(16478),
  [10093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(10077),
  [10096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(12805),
  [10099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [10101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12992),
  [10103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2708),
  [10105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7853),
  [10107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1286),
  [10109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7657),
  [10112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9083),
  [10115] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7628),
  [10118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9050),
  [10121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7853),
  [10124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7818),
  [10127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7832),
  [10130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7832),
  [10133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2165),
  [10136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1286),
  [10139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7657),
  [10142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2352),
  [10145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9083),
  [10148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7828),
  [10151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17498),
  [10154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10159),
  [10157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12977),
  [10160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13057),
  [10162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2697),
  [10164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [10166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12743),
  [10168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2684),
  [10170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7657),
  [10173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9083),
  [10176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2720),
  [10178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8679),
  [10181] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8646),
  [10184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(8524),
  [10187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8524),
  [10190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2182),
  [10193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1059),
  [10196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8191),
  [10199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2266),
  [10202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9171),
  [10205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8642),
  [10208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(17052),
  [10211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(10203),
  [10214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(12815),
  [10217] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8601),
  [10220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8491),
  [10223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(8578),
  [10226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8578),
  [10229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2206),
  [10232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(984),
  [10235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8240),
  [10238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2260),
  [10241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9024),
  [10244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8492),
  [10247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(16604),
  [10250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(10083),
  [10253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(12761),
  [10256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8292),
  [10258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor, 2),
  [10260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8351),
  [10262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8309),
  [10264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8309),
  [10266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [10268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1060),
  [10270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8081),
  [10272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [10274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9211),
  [10276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8349),
  [10278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_data_constructor, 2),
  [10280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16585),
  [10282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10209),
  [10284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12813),
  [10286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8269),
  [10288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8348),
  [10290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8179),
  [10292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8179),
  [10294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [10296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [10298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8146),
  [10300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [10302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9174),
  [10304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8347),
  [10306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17799),
  [10308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10075),
  [10310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13046),
  [10312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7992),
  [10314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8245),
  [10316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8169),
  [10318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8169),
  [10320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [10322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [10324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(7938),
  [10327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [10329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12174),
  [10331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8176),
  [10333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15718),
  [10335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10127),
  [10337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12883),
  [10339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [10341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3503),
  [10343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7849),
  [10346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2),
  [10348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7924),
  [10351] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7917),
  [10354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7917),
  [10357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(350),
  [10360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(49),
  [10363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7615),
  [10366] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(502),
  [10369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7877),
  [10372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(16180),
  [10375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10198),
  [10378] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(13045),
  [10381] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3696),
  [10384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3616),
  [10387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8562),
  [10390] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8426),
  [10393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(8457),
  [10396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8457),
  [10399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2218),
  [10402] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1090),
  [10405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8231),
  [10408] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2231),
  [10411] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9210),
  [10414] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8428),
  [10417] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(17115),
  [10420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(10149),
  [10423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(12833),
  [10426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8292),
  [10429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2),
  [10431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8351),
  [10434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8309),
  [10437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8309),
  [10440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(2164),
  [10443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(1060),
  [10446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8081),
  [10449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(2313),
  [10452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(9211),
  [10455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8349),
  [10458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2),
  [10460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(16585),
  [10463] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(10209),
  [10466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(12813),
  [10469] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(3604),
  [10472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(3607),
  [10475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_apply, 2),
  [10477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(7615),
  [10480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8269),
  [10483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8348),
  [10486] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8179),
  [10489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8179),
  [10492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(2180),
  [10495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(1030),
  [10498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8146),
  [10501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(2350),
  [10504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(9174),
  [10507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8347),
  [10510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(17799),
  [10513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(10075),
  [10516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(13046),
  [10519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(3593),
  [10522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(3594),
  [10525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12802),
  [10527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19987),
  [10529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13378),
  [10531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13232),
  [10533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13232),
  [10535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [10537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3550),
  [10539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [10541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7957),
  [10543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [10545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5914),
  [10547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13252),
  [10549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16098),
  [10551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10213),
  [10553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12763),
  [10555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [10557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3492),
  [10559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12116),
  [10561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12470),
  [10563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12322),
  [10565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12322),
  [10567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [10569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3679),
  [10571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(62),
  [10573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7615),
  [10575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [10577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16331),
  [10579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10111),
  [10581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12797),
  [10583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19015),
  [10585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11869),
  [10587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19815),
  [10589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9494),
  [10591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20675),
  [10593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12163),
  [10595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20294),
  [10597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12467),
  [10599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20518),
  [10601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17501),
  [10603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8967),
  [10606] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8732),
  [10609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(8941),
  [10612] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8941),
  [10615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2098),
  [10618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1153),
  [10621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8435),
  [10624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2241),
  [10627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9126),
  [10630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8925),
  [10633] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(16858),
  [10636] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(10308),
  [10639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(12892),
  [10642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7882),
  [10645] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8048),
  [10648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8151),
  [10651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8151),
  [10654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(392),
  [10657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(75),
  [10660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7836),
  [10663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(540),
  [10666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7998),
  [10669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(17720),
  [10672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10125),
  [10675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(13002),
  [10678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3630),
  [10681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3631),
  [10684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20421),
  [10686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5500),
  [10688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8826),
  [10691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8989),
  [10694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(8803),
  [10697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8803),
  [10700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2189),
  [10703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(1070),
  [10706] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8494),
  [10709] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2249),
  [10712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(9173),
  [10715] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8988),
  [10718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(17072),
  [10721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(10169),
  [10724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(12820),
  [10727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20264),
  [10729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5826),
  [10731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19595),
  [10733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11653),
  [10735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18993),
  [10737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5673),
  [10739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19867),
  [10741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10091),
  [10743] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8148),
  [10746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7989),
  [10749] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7961),
  [10752] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7961),
  [10755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2146),
  [10758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1169),
  [10761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7939),
  [10764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2302),
  [10767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9187),
  [10770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7990),
  [10773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16515),
  [10776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10173),
  [10779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12969),
  [10782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20574),
  [10784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15922),
  [10786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8226),
  [10788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8662),
  [10790] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8680),
  [10792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8680),
  [10794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [10796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [10798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8136),
  [10801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [10803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12019),
  [10805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8442),
  [10807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17770),
  [10809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10071),
  [10811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13049),
  [10813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3657),
  [10815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3704),
  [10817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19508),
  [10819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10759),
  [10821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19498),
  [10823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6180),
  [10825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20047),
  [10827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12139),
  [10829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8178),
  [10831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8434),
  [10833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8726),
  [10835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8726),
  [10837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [10839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [10841] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8046),
  [10844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [10846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12209),
  [10848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8654),
  [10850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16540),
  [10852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10155),
  [10854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12962),
  [10856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [10858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3717),
  [10860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20196),
  [10862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [10864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20106),
  [10866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [10868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20237),
  [10870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4345),
  [10872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8029),
  [10874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8094),
  [10876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8129),
  [10878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8129),
  [10880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [10882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1202),
  [10884] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7919),
  [10887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [10889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9092),
  [10892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8095),
  [10894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17384),
  [10896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10081),
  [10898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13006),
  [10900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7919),
  [10903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9092),
  [10906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20323),
  [10908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11611),
  [10910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(54),
  [10912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20340),
  [10914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18566),
  [10916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20426),
  [10918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4249),
  [10920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20057),
  [10922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5624),
  [10924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(7836),
  [10927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8775),
  [10930] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8809),
  [10933] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(8960),
  [10936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8960),
  [10939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2208),
  [10942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(992),
  [10945] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(7916),
  [10948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(2246),
  [10951] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__atype, 1), SHIFT(8998),
  [10954] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(8810),
  [10957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(16664),
  [10960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(10266),
  [10963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__atype, 1), SHIFT(12746),
  [10966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8585),
  [10968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8413),
  [10970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8019),
  [10972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8019),
  [10974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [10976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1079),
  [10978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7867),
  [10980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [10982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9172),
  [10984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8423),
  [10986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17012),
  [10988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10263),
  [10990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12816),
  [10992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19330),
  [10994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10863),
  [10996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19116),
  [10998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4875),
  [11000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8306),
  [11002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8502),
  [11004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8633),
  [11006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8633),
  [11008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [11010] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [11012] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(7957),
  [11015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [11017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11959),
  [11019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8485),
  [11021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17312),
  [11023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10224),
  [11025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12958),
  [11027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [11029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3678),
  [11031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [11033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8148),
  [11035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7989),
  [11037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7961),
  [11039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7961),
  [11041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [11043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [11045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__btype, 1), SHIFT(7939),
  [11048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2302),
  [11050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__btype, 1), SHIFT(9187),
  [11053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7990),
  [11055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16515),
  [11057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10173),
  [11059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12969),
  [11061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19168),
  [11063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11008),
  [11065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19769),
  [11067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10185),
  [11069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19616),
  [11071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11711),
  [11073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19930),
  [11075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5555),
  [11077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19356),
  [11079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4378),
  [11081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19706),
  [11083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5603),
  [11085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20535),
  [11087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3799),
  [11089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8303),
  [11091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8608),
  [11093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8653),
  [11095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8653),
  [11097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [11099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [11101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(7987),
  [11104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [11106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12177),
  [11108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8527),
  [11110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17250),
  [11112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10245),
  [11114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12953),
  [11116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3599),
  [11118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3598),
  [11120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20693),
  [11122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11283),
  [11124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20960),
  [11126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5517),
  [11128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8181),
  [11130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8600),
  [11132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8558),
  [11134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8558),
  [11136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [11138] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [11140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8117),
  [11143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [11145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11968),
  [11147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8569),
  [11149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17715),
  [11151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10132),
  [11153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13031),
  [11155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [11157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [11159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18998),
  [11161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11827),
  [11163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19986),
  [11165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5598),
  [11167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19647),
  [11169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9546),
  [11171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7922),
  [11174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8149),
  [11177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8058),
  [11180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8058),
  [11183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(244),
  [11186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(70),
  [11189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3987),
  [11192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(536),
  [11195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7966),
  [11198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(16755),
  [11201] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10288),
  [11204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(12733),
  [11207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3487),
  [11210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3488),
  [11213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(3987),
  [11216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19753),
  [11218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11548),
  [11220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19216),
  [11222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5183),
  [11224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19140),
  [11226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12093),
  [11228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8585),
  [11231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8413),
  [11234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8019),
  [11237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8019),
  [11240] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(2196),
  [11243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(1079),
  [11246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(7867),
  [11249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(2296),
  [11252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(9172),
  [11255] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(8423),
  [11258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(17012),
  [11261] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(10263),
  [11264] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(12816),
  [11267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(3730),
  [11270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_data_constructor_repeat1, 2), SHIFT_REPEAT(3726),
  [11273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20726),
  [11275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5691),
  [11277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20862),
  [11279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11878),
  [11281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19559),
  [11283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5919),
  [11285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8029),
  [11288] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8094),
  [11291] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8129),
  [11294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8129),
  [11297] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2130),
  [11300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1202),
  [11303] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7919),
  [11306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2262),
  [11309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9092),
  [11312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8095),
  [11315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17384),
  [11318] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10081),
  [11321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13006),
  [11324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18912),
  [11326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10988),
  [11328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19973),
  [11330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [11332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19489),
  [11334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [11336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19369),
  [11338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11457),
  [11340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20565),
  [11342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9756),
  [11344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19221),
  [11346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11737),
  [11348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19488),
  [11350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5039),
  [11352] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_apply, 2), SHIFT(7939),
  [11355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_apply, 2), SHIFT(9187),
  [11358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5765),
  [11360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5015),
  [11362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10958),
  [11364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5010),
  [11366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10964),
  [11368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11835),
  [11370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11494),
  [11372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11500),
  [11374] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(7938),
  [11377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [11379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
  [11381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11698),
  [11383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11832),
  [11385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11741),
  [11387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [11389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11842),
  [11391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3868),
  [11393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5534),
  [11395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5526),
  [11397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5635),
  [11399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6143),
  [11401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6454),
  [11403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11847),
  [11405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [11407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5630),
  [11409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6145),
  [11411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9508),
  [11413] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8193),
  [11416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8316),
  [11419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8264),
  [11422] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8264),
  [11425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2109),
  [11428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1076),
  [11431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8105),
  [11434] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2344),
  [11437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9124),
  [11440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8311),
  [11443] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(15794),
  [11446] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10162),
  [11449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(13004),
  [11452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9506),
  [11454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4315),
  [11456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4341),
  [11458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4868),
  [11460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4874),
  [11462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4064),
  [11464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8255),
  [11467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8354),
  [11470] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8337),
  [11473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8337),
  [11476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2213),
  [11479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1080),
  [11482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8107),
  [11485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2239),
  [11488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9066),
  [11491] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8356),
  [11494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17086),
  [11497] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10161),
  [11500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12831),
  [11503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12146),
  [11505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5568),
  [11507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8696),
  [11509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8856),
  [11511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8748),
  [11513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8748),
  [11515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [11517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [11519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8285),
  [11522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [11524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12087),
  [11526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8891),
  [11528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16549),
  [11530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10193),
  [11532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12957),
  [11534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3714),
  [11536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [11538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8148),
  [11540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7939),
  [11542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9187),
  [11544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [11546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [11548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11774),
  [11550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5565),
  [11552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11763),
  [11554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11617),
  [11556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11644),
  [11558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8716),
  [11560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8846),
  [11562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8868),
  [11564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8868),
  [11566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [11568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [11570] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8220),
  [11573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [11575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12230),
  [11577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8772),
  [11579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17684),
  [11581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10133),
  [11583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13027),
  [11585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [11587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [11589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9556),
  [11591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11993),
  [11593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11962),
  [11595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5661),
  [11597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9517),
  [11599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5657),
  [11601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5376),
  [11603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5380),
  [11605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5623),
  [11607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11629),
  [11609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5679),
  [11611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18755),
  [11613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18750),
  [11615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18747),
  [11617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11625),
  [11619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5030),
  [11621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5147),
  [11623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11969),
  [11625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5507),
  [11627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5729),
  [11629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5505),
  [11631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12471),
  [11633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5899),
  [11635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5743),
  [11637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12188),
  [11639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18727),
  [11641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8255),
  [11643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 2, .production_id = 14),
  [11645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8354),
  [11647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8337),
  [11649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8337),
  [11651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [11653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [11655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8107),
  [11657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [11659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9066),
  [11661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8356),
  [11663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17086),
  [11665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10161),
  [11667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12831),
  [11669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18724),
  [11671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18715),
  [11673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11862),
  [11675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12229),
  [11677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10275),
  [11679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12497),
  [11681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10927),
  [11683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10264),
  [11685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10911),
  [11687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7245),
  [11689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [11691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [11693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16938),
  [11695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15751),
  [11697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16940),
  [11699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16942),
  [11701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [11703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15750),
  [11705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15739),
  [11707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [11709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10860),
  [11711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [11713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15724),
  [11715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15722),
  [11717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15700),
  [11719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5943),
  [11721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5927),
  [11723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10866),
  [11725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9732),
  [11727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9736),
  [11729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5939),
  [11731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6736),
  [11733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [11735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8029),
  [11737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7919),
  [11739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9092),
  [11741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [11743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [11745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16967),
  [11747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4408),
  [11749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11846),
  [11751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6251),
  [11753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5497),
  [11755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16974),
  [11757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16985),
  [11759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5514),
  [11761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4412),
  [11763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5929),
  [11765] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7992),
  [11768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8245),
  [11771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8169),
  [11774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8169),
  [11777] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(461),
  [11780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(52),
  [11783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7938),
  [11786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(521),
  [11789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8176),
  [11792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(15718),
  [11795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10127),
  [11798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(12883),
  [11801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3504),
  [11804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3503),
  [11807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11335),
  [11809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10052),
  [11811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11662),
  [11813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11321),
  [11815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8193),
  [11817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8316),
  [11819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8264),
  [11821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8264),
  [11823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [11825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [11827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8105),
  [11829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [11831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9124),
  [11833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8311),
  [11835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15794),
  [11837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10162),
  [11839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13004),
  [11841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10076),
  [11843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8597),
  [11845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8940),
  [11847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8767),
  [11849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8767),
  [11851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [11853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(90),
  [11855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(8346),
  [11858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [11860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12009),
  [11862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8951),
  [11864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16531),
  [11866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10186),
  [11868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12964),
  [11870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3672),
  [11872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [11874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11670),
  [11876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10750),
  [11878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10751),
  [11880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8601),
  [11883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8491),
  [11886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8578),
  [11889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8578),
  [11892] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2206),
  [11895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(984),
  [11898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8240),
  [11901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2260),
  [11904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9024),
  [11907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8492),
  [11910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16604),
  [11913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10083),
  [11916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12761),
  [11919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8306),
  [11922] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8502),
  [11925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8633),
  [11928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8633),
  [11931] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(315),
  [11934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(45),
  [11937] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7957),
  [11940] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(527),
  [11943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8485),
  [11946] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(17312),
  [11949] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10224),
  [11952] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(12958),
  [11955] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3670),
  [11958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3678),
  [11961] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8136),
  [11964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8601),
  [11966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8491),
  [11968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8578),
  [11970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8578),
  [11972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [11974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(984),
  [11976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8240),
  [11978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [11980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9024),
  [11982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8492),
  [11984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16604),
  [11986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10083),
  [11988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12761),
  [11990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8562),
  [11992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8426),
  [11994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8457),
  [11996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8457),
  [11998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [12000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [12002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8231),
  [12004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [12006] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9210),
  [12008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8428),
  [12010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17115),
  [12012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10149),
  [12014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12833),
  [12016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8303),
  [12019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8608),
  [12022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8653),
  [12025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8653),
  [12028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(481),
  [12031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(51),
  [12034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(7987),
  [12037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(501),
  [12040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8527),
  [12043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(17250),
  [12046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10245),
  [12049] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(12953),
  [12052] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3599),
  [12055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3598),
  [12058] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8226),
  [12061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8662),
  [12064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8680),
  [12067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8680),
  [12070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(354),
  [12073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(59),
  [12076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8136),
  [12079] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(542),
  [12082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8442),
  [12085] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(17770),
  [12088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10071),
  [12091] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(13049),
  [12094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3657),
  [12097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3704),
  [12100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8562),
  [12103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8426),
  [12106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8457),
  [12109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8457),
  [12112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2218),
  [12115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1090),
  [12118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8231),
  [12121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2231),
  [12124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9210),
  [12127] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8428),
  [12130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17115),
  [12133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10149),
  [12136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12833),
  [12139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8046),
  [12142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8679),
  [12144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8646),
  [12146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8524),
  [12148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8524),
  [12150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [12152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [12154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8191),
  [12156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2266),
  [12158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9171),
  [12160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8642),
  [12162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17052),
  [12164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10203),
  [12166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12815),
  [12168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7437),
  [12170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8181),
  [12173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8600),
  [12176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8558),
  [12179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8558),
  [12182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(423),
  [12185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(93),
  [12188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8117),
  [12191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(508),
  [12194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8569),
  [12197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(17715),
  [12200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10132),
  [12203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(13031),
  [12206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3707),
  [12209] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3710),
  [12212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8178),
  [12215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8434),
  [12218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8726),
  [12221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8726),
  [12224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(417),
  [12227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(53),
  [12230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8046),
  [12233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(532),
  [12236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8654),
  [12239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(16540),
  [12242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10155),
  [12245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(12962),
  [12248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3711),
  [12251] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3717),
  [12254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(7987),
  [12257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8679),
  [12260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8646),
  [12263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8524),
  [12266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8524),
  [12269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2182),
  [12272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1059),
  [12275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8191),
  [12278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2266),
  [12281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9171),
  [12284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8642),
  [12287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17052),
  [12290] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10203),
  [12293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12815),
  [12296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [12298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9061),
  [12300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(7957),
  [12303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8880),
  [12305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9106),
  [12307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9007),
  [12309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9007),
  [12311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [12313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [12315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__apat, 1), SHIFT(3943),
  [12318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [12320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12115),
  [12322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9016),
  [12324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17665),
  [12326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9990),
  [12328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13082),
  [12330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [12332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [12334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [12336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9041),
  [12338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(826),
  [12340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9022),
  [12342] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8117),
  [12345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12963),
  [12347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13356),
  [12349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13170),
  [12351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13170),
  [12353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [12355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3618),
  [12357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(77),
  [12359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8046),
  [12361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [12363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13227),
  [12365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16691),
  [12367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10276),
  [12369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12751),
  [12371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [12373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3665),
  [12375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12541),
  [12377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13060),
  [12379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13044),
  [12381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13044),
  [12383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [12385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3524),
  [12387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(83),
  [12389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7938),
  [12391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [12393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15443),
  [12395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10283),
  [12397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12921),
  [12399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20749),
  [12401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17721),
  [12403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20806),
  [12405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17688),
  [12407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(50),
  [12409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13242),
  [12411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13394),
  [12413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13616),
  [12415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13616),
  [12417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [12419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [12421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [12423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8346),
  [12425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [12427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13706),
  [12429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16622),
  [12431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10189),
  [12433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12741),
  [12435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [12437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [12439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8739),
  [12442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8945),
  [12445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8863),
  [12448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8863),
  [12451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(2143),
  [12454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(1115),
  [12457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8055),
  [12460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(2238),
  [12463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(9176),
  [12466] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(8949),
  [12469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_pat, 1, .production_id = 12),
  [12471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(17208),
  [12474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(10256),
  [12477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(12895),
  [12480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8945),
  [12482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8863),
  [12484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8863),
  [12486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [12488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(923),
  [12490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7916),
  [12492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [12494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9176),
  [12496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8949),
  [12498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [12500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13001),
  [12502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3445),
  [12504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17208),
  [12506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10256),
  [12508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12895),
  [12510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8346),
  [12513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [12515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8055),
  [12517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [12519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12800),
  [12521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3448),
  [12523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13127),
  [12525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13590),
  [12527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13445),
  [12529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13445),
  [12531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [12533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3505),
  [12535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(92),
  [12537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8220),
  [12539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [12541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13764),
  [12543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16573),
  [12545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9991),
  [12547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12821),
  [12549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [12551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3723),
  [12553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20578),
  [12555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15951),
  [12557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8220),
  [12560] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8696),
  [12563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8856),
  [12566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8748),
  [12569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8748),
  [12572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(473),
  [12575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(66),
  [12578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8285),
  [12581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(499),
  [12584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8891),
  [12587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(16549),
  [12590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10193),
  [12593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(12957),
  [12596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3714),
  [12599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3716),
  [12602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8775),
  [12605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8809),
  [12608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8960),
  [12611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8960),
  [12614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2208),
  [12617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(992),
  [12620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(7916),
  [12623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2246),
  [12626] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8998),
  [12629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8810),
  [12632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16664),
  [12635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10266),
  [12638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12746),
  [12641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12940),
  [12643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13328),
  [12645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13307),
  [12647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13307),
  [12649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [12651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [12653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [12655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7987),
  [12657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [12659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17137),
  [12661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10277),
  [12663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12941),
  [12665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8826),
  [12667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8989),
  [12669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8803),
  [12671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8803),
  [12673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [12675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [12677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8494),
  [12679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [12681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9173),
  [12683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8988),
  [12685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17072),
  [12687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10169),
  [12689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12820),
  [12691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20586),
  [12693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15941),
  [12695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12729),
  [12697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13274),
  [12699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13137),
  [12701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13137),
  [12703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [12705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [12707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(64),
  [12709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8117),
  [12711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [12713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13122),
  [12715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16668),
  [12717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10131),
  [12719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12848),
  [12721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3652),
  [12723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [12725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20371),
  [12727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18458),
  [12729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8716),
  [12732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8846),
  [12735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8868),
  [12738] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8868),
  [12741] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(476),
  [12744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(84),
  [12747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8220),
  [12750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(500),
  [12753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8772),
  [12756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(17684),
  [12759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10133),
  [12762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(13027),
  [12765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3621),
  [12768] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3560),
  [12771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13016),
  [12773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13099),
  [12775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13370),
  [12777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13370),
  [12779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [12781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [12783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(60),
  [12785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8136),
  [12787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [12789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17811),
  [12791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10072),
  [12793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13048),
  [12795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8826),
  [12798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8989),
  [12801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8803),
  [12804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8803),
  [12807] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2189),
  [12810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1070),
  [12813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8494),
  [12816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2249),
  [12819] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9173),
  [12822] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8988),
  [12825] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17072),
  [12828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10169),
  [12831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12820),
  [12834] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(8285),
  [12837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8597),
  [12840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8940),
  [12843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8767),
  [12846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8767),
  [12849] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(336),
  [12852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(90),
  [12855] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8346),
  [12858] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(531),
  [12861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8951),
  [12864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(16531),
  [12867] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(10186),
  [12870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(12964),
  [12873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3672),
  [12876] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3663),
  [12879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13171),
  [12881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13393),
  [12883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13584),
  [12885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13584),
  [12887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [12889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [12891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [12893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8285),
  [12895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [12897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13743),
  [12899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16715),
  [12901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10278),
  [12903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12755),
  [12905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [12907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3613),
  [12909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12249),
  [12911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12718),
  [12913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12689),
  [12915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12689),
  [12917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [12919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3638),
  [12921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [12923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7836),
  [12925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [12927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17479),
  [12929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10026),
  [12931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12889),
  [12933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19657),
  [12935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17237),
  [12937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20347),
  [12939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18556),
  [12941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20614),
  [12943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16088),
  [12945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20344),
  [12947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18546),
  [12949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8775),
  [12951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8809),
  [12953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8960),
  [12955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8960),
  [12957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [12959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [12961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [12963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8998),
  [12965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8810),
  [12967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16664),
  [12969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10266),
  [12971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12746),
  [12973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8967),
  [12975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8732),
  [12977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8941),
  [12979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8941),
  [12981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [12983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [12985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8435),
  [12987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [12989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9126),
  [12991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8925),
  [12993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16858),
  [12995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10308),
  [12997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12892),
  [12999] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8967),
  [13002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8732),
  [13005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8941),
  [13008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8941),
  [13011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2098),
  [13014] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1153),
  [13017] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8435),
  [13020] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2241),
  [13023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9126),
  [13026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8925),
  [13029] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16858),
  [13032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10308),
  [13035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12892),
  [13038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [13040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [13042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8739),
  [13045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8945),
  [13048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8863),
  [13051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8863),
  [13054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2143),
  [13057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1115),
  [13060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8055),
  [13063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2238),
  [13066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9176),
  [13069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8949),
  [13072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(17208),
  [13075] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10256),
  [13078] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12895),
  [13081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8739),
  [13083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1115),
  [13085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15728),
  [13087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18671),
  [13089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15730),
  [13091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18694),
  [13093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18700),
  [13095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16951),
  [13097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15761),
  [13099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15725),
  [13101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18710),
  [13103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16947),
  [13105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18731),
  [13107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16946),
  [13109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15765),
  [13111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16943),
  [13113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15766),
  [13115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15781),
  [13117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18737),
  [13119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18805),
  [13121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15726),
  [13123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15780),
  [13125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18745),
  [13127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16619),
  [13129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18585),
  [13131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15846),
  [13133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17001),
  [13135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18547),
  [13137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_apply, 2), SHIFT(3943),
  [13140] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(8739),
  [13143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(8945),
  [13146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1), SHIFT(8863),
  [13149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(8863),
  [13152] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(2143),
  [13155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1), SHIFT(1115),
  [13158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1),
  [13160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(8055),
  [13163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(2238),
  [13166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1), SHIFT(9176),
  [13169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(8949),
  [13172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_pat, 1, .production_id = 1),
  [13174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(17208),
  [13177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(10256),
  [13180] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(12895),
  [13183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17705),
  [13185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(8880),
  [13188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9106),
  [13191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9007),
  [13194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9007),
  [13197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(475),
  [13200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(48),
  [13203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3943),
  [13206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(504),
  [13209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9016),
  [13212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(17665),
  [13215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9990),
  [13218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(13082),
  [13221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3556),
  [13224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3557),
  [13227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17845),
  [13229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9207),
  [13232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9169),
  [13235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9021),
  [13238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9021),
  [13241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2173),
  [13244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(1297),
  [13247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(8908),
  [13250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(2288),
  [13253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9179),
  [13256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(9213),
  [13259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(16478),
  [13262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(10077),
  [13265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_apply_repeat1, 2), SHIFT_REPEAT(12805),
  [13268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16994),
  [13270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16999),
  [13272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17178),
  [13274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9207),
  [13276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9169),
  [13278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9021),
  [13280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9021),
  [13282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [13284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [13286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8908),
  [13288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [13290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9179),
  [13292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9213),
  [13294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16478),
  [13296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10077),
  [13298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12805),
  [13300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15949),
  [13302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17000),
  [13304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7446),
  [13306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6912),
  [13308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9221),
  [13310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9321),
  [13312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9341),
  [13314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9341),
  [13316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [13318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1674),
  [13320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(65),
  [13322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9079),
  [13324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [13326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9356),
  [13328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16146),
  [13330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9975),
  [13332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12843),
  [13334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [13336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [13338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7112),
  [13340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [13342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [13344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [13346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [13348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [13350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [13352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [13354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1689),
  [13356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5785),
  [13358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [13360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1258),
  [13362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [13364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [13366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5003),
  [13368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7555),
  [13370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [13372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [13374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [13376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1075),
  [13378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6048),
  [13380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [13382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1448),
  [13384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6408),
  [13386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1526),
  [13388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [13390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1375),
  [13392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6225),
  [13394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [13396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [13398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [13400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [13402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [13404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7261),
  [13406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1459),
  [13408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1600),
  [13410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [13412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [13414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [13416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7608),
  [13418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9221),
  [13421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9321),
  [13424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9341),
  [13427] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9341),
  [13430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(367),
  [13433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(65),
  [13436] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9079),
  [13439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(544),
  [13442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9356),
  [13445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(16146),
  [13448] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(9975),
  [13451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(12843),
  [13454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3681),
  [13457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_lambda_repeat1, 2), SHIFT_REPEAT(3680),
  [13460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7888),
  [13462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9318),
  [13464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [13466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [13468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [13470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funvar, 1, .production_id = 9),
  [13472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9336),
  [13474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3551),
  [13476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [13478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(7888),
  [13481] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(9318),
  [13484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(8019),
  [13487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(8019),
  [13490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(284),
  [13493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(94),
  [13496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(7867),
  [13499] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(522),
  [13502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2),
  [13504] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(9336),
  [13507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(17012),
  [13510] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(10263),
  [13513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(12816),
  [13516] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(3551),
  [13519] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 2), SHIFT_REPEAT(3552),
  [13522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funvar, 2, .production_id = 26),
  [13524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8739),
  [13526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4418),
  [13528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2574),
  [13530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [13532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4293),
  [13534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4230),
  [13536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4574),
  [13538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5021),
  [13540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4595),
  [13542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3871),
  [13544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [13546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13081),
  [13548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15221),
  [13550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15409),
  [13552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15409),
  [13554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [13556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(969),
  [13558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12428),
  [13560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [13562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9085),
  [13564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15220),
  [13566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16736),
  [13568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17777),
  [13570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10082),
  [13572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13040),
  [13574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3972),
  [13576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [13578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4221),
  [13580] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5674),
  [13582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3780),
  [13584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3632),
  [13586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3999),
  [13588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [13590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [13592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2606),
  [13594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [13596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5076),
  [13598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4425),
  [13600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4543),
  [13602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4402),
  [13604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_pat, 2, .production_id = 12),
  [13606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_pat, 2, .production_id = 1),
  [13608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4158),
  [13610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4782),
  [13612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4344),
  [13614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11703),
  [13616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14252),
  [13618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14023),
  [13620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14023),
  [13622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [13624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [13626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9899),
  [13628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [13630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9105),
  [13632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14253),
  [13634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16308),
  [13636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17467),
  [13638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10182),
  [13640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12973),
  [13642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12303),
  [13644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13448),
  [13646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13636),
  [13648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13636),
  [13650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [13652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1142),
  [13654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11744),
  [13656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [13658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9015),
  [13660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13446),
  [13662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16369),
  [13664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16612),
  [13666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10228),
  [13668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12740),
  [13670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5047),
  [13672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4447),
  [13674] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4343),
  [13676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2367),
  [13678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [13680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor, 1),
  [13682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 1),
  [13684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_name, 1),
  [13686] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_name, 1), REDUCE(sym__fun_name, 1, .production_id = 1),
  [13689] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_name, 1), REDUCE(sym__fun_name, 1, .production_id = 1),
  [13692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 1), SHIFT(2381),
  [13695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_name, 1), REDUCE(sym_pat_name, 1),
  [13698] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_exp_name, 1), REDUCE(sym_pat_name, 1), REDUCE(sym__fun_name, 1, .production_id = 1),
  [13702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_name, 1),
  [13704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 1), REDUCE(sym__fun_name, 1, .production_id = 1),
  [13707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fun_name, 1, .production_id = 1),
  [13709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3639),
  [13711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15558),
  [13713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fun_name, 1, .production_id = 1),
  [13715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_constructor, 2),
  [13717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_constructor, 2),
  [13719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qcon, 1),
  [13721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qcon, 1),
  [13723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 1), SHIFT(2369),
  [13726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [13728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12885),
  [13730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(67),
  [13732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12738),
  [13734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable, 1),
  [13736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable, 1),
  [13738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 4),
  [13740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 4),
  [13742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10880),
  [13744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11433),
  [13746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [13748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1025),
  [13750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2277),
  [13752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9073),
  [13754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11440),
  [13756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11501),
  [13758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10940),
  [13760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [13762] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [13764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [13766] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9101),
  [13768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10936),
  [13770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(73),
  [13772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12539),
  [13774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_name, 3),
  [13776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_name, 3),
  [13778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(63),
  [13780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11692),
  [13782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4820),
  [13784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4667),
  [13786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [13788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1175),
  [13790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2306),
  [13792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9149),
  [13794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [13796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_name, 3), REDUCE(sym__fun_name, 3, .production_id = 28),
  [13799] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_name, 3), REDUCE(sym__fun_name, 3, .production_id = 28),
  [13802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 3), SHIFT(2369),
  [13805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_name, 3), REDUCE(sym_pat_name, 3),
  [13808] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_exp_name, 3), REDUCE(sym_pat_name, 3), REDUCE(sym__fun_name, 3, .production_id = 28),
  [13812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 3), REDUCE(sym__fun_name, 3, .production_id = 28),
  [13815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fun_name, 3, .production_id = 28),
  [13817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fun_name, 3, .production_id = 28),
  [13819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [13821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12897),
  [13823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10511),
  [13825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10842),
  [13827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [13829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [13831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2293),
  [13833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9162),
  [13835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10745),
  [13837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10347),
  [13839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10824),
  [13841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [13843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1023),
  [13845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [13847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9008),
  [13849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10825),
  [13851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(85),
  [13853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12114),
  [13855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4883),
  [13857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [13859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [13861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1042),
  [13863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [13865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9137),
  [13867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [13869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(72),
  [13871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal, 1),
  [13873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal, 1),
  [13875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10340),
  [13877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10780),
  [13879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2204),
  [13881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [13883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [13885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9136),
  [13887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10789),
  [13889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_con_unit, 2),
  [13891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_con_unit, 2),
  [13893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9383),
  [13895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9381),
  [13897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [13899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [13901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [13903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9204),
  [13905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9388),
  [13907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [13909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [13911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [13913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [13915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [13917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9153),
  [13919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [13921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [13923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12542),
  [13925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5433),
  [13927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4865),
  [13929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [13931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [13933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [13935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9155),
  [13937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [13939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [13941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12466),
  [13943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4926),
  [13945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4945),
  [13947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [13949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [13951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2305),
  [13953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9195),
  [13955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4954),
  [13957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5005),
  [13959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5303),
  [13961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [13963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [13965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [13967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9184),
  [13969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5304),
  [13971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12012),
  [13973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12185),
  [13975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [13977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [13979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [13981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9037),
  [13983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12182),
  [13985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [13987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12658),
  [13989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17869),
  [13991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17844),
  [13993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17871),
  [13995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17871),
  [13997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [13999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [14001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13994),
  [14003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [14005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9196),
  [14007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17859),
  [14009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16522),
  [14011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10181),
  [14013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12965),
  [14015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [14017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12654),
  [14019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11749),
  [14021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11547),
  [14023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [14025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [14027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [14029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9190),
  [14031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11550),
  [14033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [14035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12667),
  [14037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 3), SHIFT(2381),
  [14040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_variable, 2),
  [14042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_variable, 2),
  [14044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4717),
  [14046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [14048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [14050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1137),
  [14052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2321),
  [14054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9183),
  [14056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [14058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_con_tuple, 3),
  [14060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_con_tuple, 3),
  [14062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_integer, 1),
  [14064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_integer, 1),
  [14066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14759),
  [14068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14991),
  [14070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14672),
  [14072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14672),
  [14074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [14076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1227),
  [14078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14589),
  [14080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [14082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9078),
  [14084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14992),
  [14086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16452),
  [14088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10090),
  [14090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12987),
  [14092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 1), SHIFT(2360),
  [14095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9839),
  [14097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9871),
  [14099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2138),
  [14101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [14103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [14105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9131),
  [14107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9873),
  [14109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qcon, 3),
  [14111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qcon, 3),
  [14113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [14115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [14117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [14119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [14121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [14123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9209),
  [14125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [14127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [14129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11163),
  [14131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11033),
  [14133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [14135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [14137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [14139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9060),
  [14141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11024),
  [14143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11812),
  [14145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11879),
  [14147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2199),
  [14149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1120),
  [14151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [14153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9178),
  [14155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11904),
  [14157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11686),
  [14159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11561),
  [14161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2100),
  [14163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [14165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [14167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9011),
  [14169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11877),
  [14171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [14173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4700),
  [14175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [14177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [14179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [14181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9054),
  [14183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4691),
  [14185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_parens, 3, .production_id = 16),
  [14187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_parens, 3, .production_id = 16),
  [14189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 3),
  [14191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 3),
  [14193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [14195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [14197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [14199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [14201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [14203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9099),
  [14205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [14207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11329),
  [14209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11396),
  [14211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [14213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(966),
  [14215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [14217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9123),
  [14219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11351),
  [14221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10120),
  [14223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10257),
  [14225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [14227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [14229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [14231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8997),
  [14233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10258),
  [14235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [14237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5358),
  [14239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [14241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [14243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [14245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9180),
  [14247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [14249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 2),
  [14251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 2),
  [14253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8269),
  [14255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_splice, 2),
  [14257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_splice, 2),
  [14259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type, 2, .production_id = 31),
  [14261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type, 2, .production_id = 31),
  [14263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8292),
  [14265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 4, .production_id = 48),
  [14267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 4, .production_id = 48),
  [14269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_con_list, 2),
  [14271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_con_list, 2),
  [14273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14057),
  [14275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14031),
  [14277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14137),
  [14279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14137),
  [14281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [14283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [14285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13710),
  [14287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [14289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9151),
  [14291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14028),
  [14293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17014),
  [14295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10227),
  [14297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12799),
  [14299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5339),
  [14301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5305),
  [14303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [14305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [14307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2290),
  [14309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9119),
  [14311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [14313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10974),
  [14315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11106),
  [14317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [14319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [14321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [14323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9133),
  [14325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11117),
  [14327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4943),
  [14329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [14331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [14333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [14335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [14337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9046),
  [14339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5060),
  [14341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2),
  [14343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_lambda_case, 2),
  [14345] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2879),
  [14348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [14350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5837),
  [14352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5828),
  [14354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [14356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [14358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [14360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9048),
  [14362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5818),
  [14364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5369),
  [14366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5167),
  [14368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [14370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1304),
  [14372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [14374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9033),
  [14376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [14378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9887),
  [14380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9830),
  [14382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [14384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [14386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2322),
  [14388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9216),
  [14390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9831),
  [14392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10456),
  [14394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10629),
  [14396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [14398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1020),
  [14400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2341),
  [14402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9042),
  [14404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10630),
  [14406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9598),
  [14408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9664),
  [14410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [14412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [14414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [14416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9108),
  [14418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9667),
  [14420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3798),
  [14422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [14424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [14426] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [14428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [14430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9159),
  [14432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [14434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5607),
  [14436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5544),
  [14438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2207),
  [14440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [14442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [14444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9096),
  [14446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5545),
  [14448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5686),
  [14450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5701),
  [14452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2129),
  [14454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [14456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [14458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9038),
  [14460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5700),
  [14462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [14464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4788),
  [14466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [14468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [14470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [14472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9013),
  [14474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4789),
  [14476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_quasiquote, 5, .production_id = 48),
  [14478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_quasiquote, 5, .production_id = 48),
  [14480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [14482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4168),
  [14484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [14486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [14488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [14490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9084),
  [14492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4164),
  [14494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11128),
  [14496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11226),
  [14498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [14500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1016),
  [14502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [14504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9032),
  [14506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11224),
  [14508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10333),
  [14510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10490),
  [14512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [14514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [14516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [14518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9104),
  [14520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10491),
  [14522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14483),
  [14524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14273),
  [14526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14525),
  [14528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14525),
  [14530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [14532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1223),
  [14534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13757),
  [14536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2336),
  [14538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9109),
  [14540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14270),
  [14542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16463),
  [14544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10157),
  [14546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12985),
  [14548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promoted_tycon, 2, .production_id = 31),
  [14550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promoted_tycon, 2, .production_id = 31),
  [14552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [14554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [14556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [14558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [14560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [14562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9091),
  [14564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [14566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5513),
  [14568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5655),
  [14570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [14572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [14574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [14576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9001),
  [14578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [14580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11119),
  [14582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11180),
  [14584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2124),
  [14586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [14588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [14590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9141),
  [14592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11179),
  [14594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13),
  [14596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [14598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3745),
  [14600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [14602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [14604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [14606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9034),
  [14608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3746),
  [14610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9492),
  [14612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9448),
  [14614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [14616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [14618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [14620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9068),
  [14622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9447),
  [14624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11274),
  [14626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11196),
  [14628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [14630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [14632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2275),
  [14634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9018),
  [14636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11194),
  [14638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8585),
  [14640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17817),
  [14642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17839),
  [14644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [14646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [14648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [14650] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9170),
  [14652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17840),
  [14654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 3),
  [14656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 3),
  [14658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_unboxed_tuple, 4, .production_id = 51),
  [14660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_unboxed_tuple, 4, .production_id = 51),
  [14662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promoted_tycon, 4),
  [14664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promoted_tycon, 4),
  [14666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_list, 4),
  [14668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 4),
  [14670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_unboxed_tuple, 3),
  [14672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_unboxed_tuple, 3),
  [14674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_name, 1),
  [14676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_unboxed_sum, 3),
  [14678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_unboxed_sum, 3),
  [14680] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_list, 3),
  [14682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_list, 3),
  [14684] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parens, 3),
  [14686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parens, 3),
  [14688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_literal, 1),
  [14690] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_literal, 1),
  [14692] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_star, 1),
  [14694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_star, 1),
  [14696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_tuple, 3),
  [14698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_tuple, 3),
  [14700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tycon_arrow, 3),
  [14702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tycon_arrow, 3),
  [14704] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_unboxed_tuple, 2),
  [14706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_unboxed_tuple, 2),
  [14708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_th_quoted_name, 2),
  [14710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_th_quoted_name, 2),
  [14712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_variable, 1),
  [14714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_variable, 1),
  [14716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__aexp, 1),
  [14718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__aexp, 1),
  [14720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18128),
  [14722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_tuple, 3, .production_id = 16),
  [14724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_tuple, 3, .production_id = 16),
  [14726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_list, 3, .production_id = 16),
  [14728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_list, 3, .production_id = 16),
  [14730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_unboxed_sum, 3, .production_id = 16),
  [14732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_unboxed_sum, 3, .production_id = 16),
  [14734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_unboxed_tuple, 3, .production_id = 16),
  [14736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_unboxed_tuple, 3, .production_id = 16),
  [14738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_annotated_type_variable, 4, .production_id = 35),
  [14740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_annotated_type_variable, 4, .production_id = 35),
  [14742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_projection, 3, .production_id = 43),
  [14744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_projection, 3, .production_id = 43),
  [14746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_unboxed_tuple, 2),
  [14748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_unboxed_tuple, 2),
  [14750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_projection_selector, 4, .production_id = 43),
  [14752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_projection_selector, 4, .production_id = 43),
  [14754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_arithmetic_sequence, 7, .production_id = 83),
  [14756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_arithmetic_sequence, 7, .production_id = 83),
  [14758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_section_right, 4),
  [14760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_section_right, 4),
  [14762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_section_left, 4),
  [14764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_section_left, 4),
  [14766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_arithmetic_sequence, 4, .production_id = 52),
  [14768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_arithmetic_sequence, 4, .production_id = 52),
  [14770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 3), SHIFT(2360),
  [14773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_list_comprehension, 6, .production_id = 16),
  [14775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_list_comprehension, 6, .production_id = 16),
  [14777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_list, 4, .production_id = 51),
  [14779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_list, 4, .production_id = 51),
  [14781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_arithmetic_sequence, 6, .production_id = 79),
  [14783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_arithmetic_sequence, 6, .production_id = 79),
  [14785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_promoted_literal, 2),
  [14787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_promoted_literal, 2),
  [14789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_record, 5),
  [14791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_record, 5),
  [14793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_unboxed_tuple, 4),
  [14795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_unboxed_tuple, 4),
  [14797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_record, 4),
  [14799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_record, 4),
  [14801] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2856),
  [14804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [14806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_th_quoted_name, 4),
  [14808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_th_quoted_name, 4),
  [14810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_projection_selector, 5, .production_id = 65),
  [14812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_projection_selector, 5, .production_id = 65),
  [14814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_arithmetic_sequence, 5, .production_id = 69),
  [14816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_arithmetic_sequence, 5, .production_id = 69),
  [14818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_list_comprehension, 5, .production_id = 16),
  [14820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_list_comprehension, 5, .production_id = 16),
  [14822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promoted_tycon, 2),
  [14824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promoted_tycon, 2),
  [14826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_section_right, 6),
  [14828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_section_right, 6),
  [14830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18257),
  [14832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alts, 2),
  [14834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alts, 2),
  [14836] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_do, 4),
  [14838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_do, 4),
  [14840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alts, 3),
  [14842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alts, 3),
  [14844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_do, 5),
  [14846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_do, 5),
  [14848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_name, 1), REDUCE(sym__pat_constructor, 1, .production_id = 3),
  [14851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_name, 1), REDUCE(sym__pat_constructor, 1, .production_id = 3),
  [14854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_constructor, 1, .production_id = 3),
  [14856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pat_constructor, 1, .production_id = 3),
  [14858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alts, 4),
  [14860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alts, 4),
  [14862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_type_application, 2),
  [14864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_type_application, 2),
  [14866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_do, 6),
  [14868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_do, 6),
  [14870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alts, 5),
  [14872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alts, 5),
  [14874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_do, 3),
  [14876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_do, 3),
  [14878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_lambda_case, 3),
  [14880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_lambda_case, 3),
  [14882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2902),
  [14885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2987),
  [14887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_name, 1),
  [14889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [14891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18692),
  [14893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2857),
  [14896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2982),
  [14898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2863),
  [14901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3157),
  [14903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3502),
  [14905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18098),
  [14907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__aexp_projection, 1),
  [14909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__aexp_projection, 1),
  [14911] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__aexp_projection, 1), REDUCE(sym__apat, 1, .production_id = 4),
  [14914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18180),
  [14916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__aexp_projection, 1), REDUCE(sym__apat, 1),
  [14919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_exp_unboxed_tuple, 2), REDUCE(sym_pat_unboxed_tuple, 2),
  [14922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context_constraints, 2),
  [14924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_name, 3),
  [14926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2877),
  [14929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3106),
  [14931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_unboxed_tuple, 2),
  [14933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__apat, 1, .production_id = 4),
  [14935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18776),
  [14937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2893),
  [14940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [14942] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2901),
  [14945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [14947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3684),
  [14949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2906),
  [14952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [14954] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2869),
  [14957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [14959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2855),
  [14962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [14964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [14966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2884),
  [14969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [14971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2896),
  [14974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3085),
  [14976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2888),
  [14979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [14981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18327),
  [14983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2842),
  [14986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3095),
  [14988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18205),
  [14990] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2876),
  [14993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [14995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2864),
  [14998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3158),
  [15000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2878),
  [15003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [15005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18841),
  [15007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18594),
  [15009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18813),
  [15011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2846),
  [15014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [15016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [15018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18871),
  [15020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17928),
  [15022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2833),
  [15025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [15027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2844),
  [15030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3058),
  [15032] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2898),
  [15035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3105),
  [15037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18488),
  [15039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18472),
  [15041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18373),
  [15043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18189),
  [15045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18426),
  [15047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18102),
  [15049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18764),
  [15051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18238),
  [15053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18064),
  [15055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2852),
  [15058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [15060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18563),
  [15062] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_infix, 1),
  [15064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14344),
  [15066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10416),
  [15068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_infix, 1),
  [15070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9446),
  [15072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3381),
  [15074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 1, .production_id = 12),
  [15076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(12247),
  [15079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(18019),
  [15082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simpletype, 1, .production_id = 12),
  [15084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [15086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(18105),
  [15089] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(16616),
  [15092] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(14889),
  [15095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(12318),
  [15098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(18002),
  [15101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_infix, 1), SHIFT(14344),
  [15104] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_infix, 1), SHIFT(9899),
  [15107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_infix, 1), SHIFT(9446),
  [15110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [15112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(12610),
  [15115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(18029),
  [15118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 3, .production_id = 28),
  [15120] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(12247),
  [15123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(18019),
  [15126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simpletype, 3, .production_id = 28),
  [15128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(12318),
  [15131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(18002),
  [15134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3361),
  [15136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(12610),
  [15139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(18029),
  [15142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(11703),
  [15145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(18103),
  [15148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), REDUCE(sym__simpletype, 1, .production_id = 12),
  [15151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 1), SHIFT(2440),
  [15154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(11703),
  [15157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(18103),
  [15160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), REDUCE(sym__simpletype, 3, .production_id = 28),
  [15163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [15165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [15167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3620),
  [15169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [15171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 1), SHIFT(2366),
  [15174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_con_tuple_repeat1, 2),
  [15176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_con_tuple_repeat1, 2),
  [15178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_con_tuple_repeat1, 2), SHIFT_REPEAT(7388),
  [15181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [15183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3380),
  [15185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [15187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 3), SHIFT(2440),
  [15190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [15192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3379),
  [15194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [15196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_pat_name, 3), SHIFT(2366),
  [15199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [15201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__apat, 1),
  [15203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11975),
  [15205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [15207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [15209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [15211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [15213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [15215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp, 1),
  [15217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [15219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7725),
  [15221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12796),
  [15223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [15225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [15227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3362),
  [15229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [15231] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qvarop_nominus, 1),
  [15233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qvarop_nominus, 1),
  [15235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9693),
  [15237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10643),
  [15239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3601),
  [15241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4840),
  [15243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [15245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_constructor_operator, 2),
  [15247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_constructor_operator, 2),
  [15249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11236),
  [15251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9365),
  [15253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [15255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4214),
  [15257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11394),
  [15259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [15261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10100),
  [15263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [15265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10379),
  [15267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [15269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10577),
  [15271] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__minus, 1, .production_id = 11),
  [15273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_name, 1),
  [15275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [15277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10932),
  [15279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5024),
  [15281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5334),
  [15283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10918),
  [15285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [15287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10564),
  [15289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9876),
  [15291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5602),
  [15293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [15295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4762),
  [15297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9901),
  [15299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10502),
  [15301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10848),
  [15303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5170),
  [15305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [15307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10749),
  [15309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10890),
  [15311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10319),
  [15313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3390),
  [15315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11026),
  [15317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [15319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [15321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10188),
  [15323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5229),
  [15325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11957),
  [15327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9581),
  [15329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [15331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4197),
  [15333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10526),
  [15335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10960),
  [15337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [15339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [15341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11082),
  [15343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [15345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10560),
  [15347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9347),
  [15349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [15351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2430),
  [15353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4878),
  [15355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10325),
  [15357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11887),
  [15359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [15361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(12303),
  [15364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 1, .production_id = 13), SHIFT(17996),
  [15367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qop, 3),
  [15369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qop, 3),
  [15371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qvarop, 3),
  [15373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qvarop, 3),
  [15375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12184),
  [15377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10644),
  [15379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10882),
  [15381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [15383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [15385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5499),
  [15387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [15389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11520),
  [15391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [15393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [15395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5420),
  [15397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4841),
  [15399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [15401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11332),
  [15403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11267),
  [15405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4826),
  [15407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11486),
  [15409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9815),
  [15411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5430),
  [15413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11172),
  [15415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4748),
  [15417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator, 1),
  [15419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator, 1),
  [15421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5034),
  [15423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_operator, 1),
  [15425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_operator, 1),
  [15427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_operator, 2),
  [15429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_operator, 2),
  [15431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [15433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10499),
  [15435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_record, 2, .production_id = 23),
  [15437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_record, 2, .production_id = 23),
  [15439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_wildcard, 1),
  [15441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_wildcard, 1),
  [15443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3637),
  [15445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_list, 3),
  [15447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_list, 3),
  [15449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_unboxed_sum, 3),
  [15451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_unboxed_sum, 3),
  [15453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_unboxed_tuple, 3),
  [15455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_unboxed_tuple, 3),
  [15457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_irrefutable, 2),
  [15459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_irrefutable, 2),
  [15461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [15463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_strict, 2),
  [15465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_strict, 2),
  [15467] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__qvarop_nominus, 3),
  [15469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qvarop_nominus, 3),
  [15471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_as, 3, .production_id = 39),
  [15473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_as, 3, .production_id = 39),
  [15475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_fields, 2),
  [15477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_fields, 2),
  [15479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_tuple, 4),
  [15481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_tuple, 4),
  [15483] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_list, 4),
  [15485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_list, 4),
  [15487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_parens, 3),
  [15489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_parens, 3),
  [15491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_fields, 3),
  [15493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_fields, 3),
  [15495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3404),
  [15497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [15499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_fields, 4),
  [15501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_fields, 4),
  [15503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_name, 3),
  [15505] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_unboxed_tuple, 2),
  [15507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12133),
  [15509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__apat, 1, .production_id = 4),
  [15511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pat_unboxed_tuple, 4),
  [15513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_unboxed_tuple, 4),
  [15515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 3), SHIFT(12303),
  [15518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_name, 3), SHIFT(17996),
  [15521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [15523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(15317),
  [15526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12081),
  [15528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [15530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [15532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [15534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12152),
  [15536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [15538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12121),
  [15540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3669),
  [15542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12226),
  [15544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3408),
  [15546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12054),
  [15548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [15550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [15552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(14635),
  [15555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_name, 1), SHIFT(14906),
  [15558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [15560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3544),
  [15562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18105),
  [15564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15390),
  [15566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12013),
  [15568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [15570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14889),
  [15572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_strict_type, 2),
  [15574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_strict_type, 2),
  [15576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lazy_type, 2),
  [15578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lazy_type, 2),
  [15580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [15582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [15584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [15586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [15588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12107),
  [15590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [15592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12083),
  [15594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3515),
  [15596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3399),
  [15598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [15600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3406),
  [15602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3575),
  [15604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [15606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3378),
  [15608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [15610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12010),
  [15612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [15614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3522),
  [15616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [15618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2435),
  [15620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7725),
  [15622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [15624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3417),
  [15626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [15628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [15630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [15632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [15634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [15636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [15638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2414),
  [15640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [15642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [15644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [15646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2416),
  [15648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [15650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [15652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [15654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [15656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [15658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [15660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [15662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [15664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1883),
  [15666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [15668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [15670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1969),
  [15672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1881),
  [15674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [15676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [15678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [15680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [15682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1952),
  [15684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [15686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1920),
  [15688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [15690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [15692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [15694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [15696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [15698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [15700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [15702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1904),
  [15704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [15706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1878),
  [15708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [15710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1824),
  [15712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [15714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [15716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [15718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1917),
  [15720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [15722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [15724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [15726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2441),
  [15728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [15730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [15732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1882),
  [15734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1855),
  [15736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [15738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [15740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1950),
  [15742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2434),
  [15744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [15746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [15748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1914),
  [15750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [15752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [15754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [15756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [15758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [15760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2429),
  [15762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [15764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [15766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [15768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12189),
  [15770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12128),
  [15772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [15774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [15776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [15778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [15780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1961),
  [15782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [15784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1941),
  [15786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [15788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [15790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1942),
  [15792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1948),
  [15794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [15796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [15798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [15800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [15802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1958),
  [15804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [15806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1962),
  [15808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1820),
  [15810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1963),
  [15812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [15814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1966),
  [15816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [15818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [15820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [15822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1833),
  [15824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [15826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [15828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [15830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [15832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1918),
  [15834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [15836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [15838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [15840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1856),
  [15842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1884),
  [15844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1861),
  [15846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [15848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1972),
  [15850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [15852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [15854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [15856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [15858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [15860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [15862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [15864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [15866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [15868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [15870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [15872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [15874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [15876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [15878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [15880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [15882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [15884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [15886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [15888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [15890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [15892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1953),
  [15894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [15896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [15898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [15900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1889),
  [15902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [15904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [15906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [15908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [15910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [15912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1924),
  [15914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [15916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [15918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [15920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [15922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [15924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [15926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [15928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [15930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [15932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [15934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2624),
  [15936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [15938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3605),
  [15940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [15942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2438),
  [15944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [15946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2432),
  [15948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_context, 1),
  [15950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_context, 1),
  [15952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [15954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [15956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [15958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_forall, 2),
  [15960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_forall, 2),
  [15962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [15964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context, 2),
  [15966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__context, 2),
  [15968] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__fun_patterns, 1),
  [15970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__fun_patterns, 1),
  [15972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_if_guard, 2),
  [15974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_if_guard, 2),
  [15976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constraint, 1),
  [15978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_if_guard_repeat1, 2),
  [15980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_exp_if_guard_repeat1, 2),
  [15982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_if_guard_repeat1, 2), SHIFT_REPEAT(554),
  [15985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [15987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [15989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_infix, 3, .production_id = 58),
  [15991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_infix, 3, .production_id = 58),
  [15993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [15995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2836),
  [15998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2989),
  [16000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_case, 3, .production_id = 16),
  [16002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_case, 3, .production_id = 16),
  [16004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2836),
  [16006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fun_arrow, 2),
  [16008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fun_arrow, 2),
  [16010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_varop, 1),
  [16012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varop, 1),
  [16014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18418),
  [16016] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_varop, 3),
  [16018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_varop, 3),
  [16020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2889),
  [16022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [16024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2889),
  [16027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [16029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_negation, 2),
  [16031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_negation, 2),
  [16033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12252),
  [16035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard, 1),
  [16037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern_guard, 3),
  [16039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [16041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ticked_qtycon, 3),
  [16043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ticked_qtycon, 3),
  [16045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ticked_qtycon, 3, .production_id = 31),
  [16047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ticked_qtycon, 3, .production_id = 31),
  [16049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__promoted_tyconop, 2),
  [16051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__promoted_tyconop, 2),
  [16053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type_operator, 2),
  [16055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_type_operator, 2),
  [16057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18511),
  [16059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [16061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3385),
  [16063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_cond, 7, .production_id = 85),
  [16065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_cond, 7, .production_id = 85),
  [16067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_cond, 6, .production_id = 80),
  [16069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_cond, 6, .production_id = 80),
  [16071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_annotation, 2, .production_id = 40),
  [16073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_annotation, 2, .production_id = 40),
  [16075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_cond, 8, .production_id = 93),
  [16077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_cond, 8, .production_id = 93),
  [16079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_cond, 7, .production_id = 86),
  [16081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_cond, 7, .production_id = 86),
  [16083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_top_splice, 1),
  [16085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_param, 2, .production_id = 16),
  [16087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_param, 2, .production_id = 16),
  [16089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_context, 2),
  [16091] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_context, 2),
  [16093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_case, 4, .production_id = 16),
  [16095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_case, 4, .production_id = 16),
  [16097] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_lambda, 4, .production_id = 53),
  [16099] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_lambda, 4, .production_id = 53),
  [16101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2643),
  [16103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_quantifiers, 3),
  [16105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_quantifiers, 3),
  [16107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_fun, 3),
  [16109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_fun, 3),
  [16111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2904),
  [16113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3136),
  [16115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [16117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gdpat, 3, .production_id = 35),
  [16119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_gdpat, 3, .production_id = 35),
  [16121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_infix, 3),
  [16123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_infix, 3),
  [16125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_in, 2, .production_id = 16),
  [16127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_in, 2, .production_id = 16),
  [16129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2904),
  [16132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_apply, 2),
  [16134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp_apply, 2),
  [16136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12331),
  [16138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp, 2, .production_id = 16),
  [16140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__exp, 2, .production_id = 16),
  [16142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let_in, 2),
  [16144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_let_in, 2),
  [16146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2645),
  [16148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [16150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [16152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__fexp, 1, .production_id = 5),
  [16154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__fexp, 1, .production_id = 5),
  [16156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [16158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2654),
  [16160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [16162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2847),
  [16164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [16166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [16168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18056),
  [16170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [16172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2874),
  [16175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3108),
  [16177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2663),
  [16179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [16181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2847),
  [16184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2874),
  [16186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2637),
  [16188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [16190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5288),
  [16192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10662),
  [16194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [16196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11270),
  [16198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11787),
  [16200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9704),
  [16202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5704),
  [16204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11942),
  [16206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10769),
  [16208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5715),
  [16210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11166),
  [16212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11715),
  [16214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4489),
  [16216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [16218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4183),
  [16220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11730),
  [16222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10833),
  [16224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10850),
  [16226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5038),
  [16228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11222),
  [16230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11221),
  [16232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [16234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4475),
  [16236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11525),
  [16238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [16240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10728),
  [16242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10033),
  [16244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10055),
  [16246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11584),
  [16248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [16250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13228),
  [16252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9945),
  [16254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19918),
  [16256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16069),
  [16258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13890),
  [16260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19898),
  [16262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11442),
  [16264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5744),
  [16266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [16268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4966),
  [16270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4851),
  [16272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10481),
  [16274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4608),
  [16276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5122),
  [16278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5275),
  [16280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5235),
  [16282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [16284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11400),
  [16286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4809),
  [16288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10692),
  [16290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9396),
  [16292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [16294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9431),
  [16296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10889),
  [16298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5152),
  [16300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5117),
  [16302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [16304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11125),
  [16306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5821),
  [16308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5632),
  [16310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11956),
  [16312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4090),
  [16314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11358),
  [16316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10433),
  [16318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11462),
  [16320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12035),
  [16322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3852),
  [16324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10955),
  [16326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5803),
  [16328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3803),
  [16330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5537),
  [16332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11371),
  [16334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11037),
  [16336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4576),
  [16338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10957),
  [16340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9511),
  [16342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [16344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3922),
  [16346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5377),
  [16348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5445),
  [16350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18449),
  [16352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9441),
  [16354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [16356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11076),
  [16358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5406),
  [16360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5426),
  [16362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5682),
  [16364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4392),
  [16366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [16368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10506),
  [16370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5464),
  [16372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18397),
  [16374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11419),
  [16376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2851),
  [16379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [16381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [16383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19053),
  [16385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19319),
  [16387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9874),
  [16389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9967),
  [16391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2851),
  [16393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2587),
  [16395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [16397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9802),
  [16399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9928),
  [16401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12354),
  [16403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9659),
  [16405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2568),
  [16407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5026),
  [16409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10321),
  [16411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9221),
  [16413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9267),
  [16415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [16417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5484),
  [16419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [16421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20077),
  [16423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10915),
  [16425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [16427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7569),
  [16429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7572),
  [16431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [16433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2883),
  [16435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [16437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6062),
  [16439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5983),
  [16441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [16443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [16445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [16447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6053),
  [16449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5970),
  [16451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [16453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9661),
  [16455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [16457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8880),
  [16459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9165),
  [16461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [16463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13127),
  [16465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13420),
  [16467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [16469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9457),
  [16471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [16473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18667),
  [16475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11666),
  [16477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [16479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6443),
  [16481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6324),
  [16483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [16485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5139),
  [16487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [16489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12249),
  [16491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12643),
  [16493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [16495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2868),
  [16498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [16500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12348),
  [16502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5535),
  [16504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [16506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [16508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [16510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11074),
  [16512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [16514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat, 1),
  [16516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14437),
  [16518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9192),
  [16520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [16522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7492),
  [16524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7519),
  [16526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [16528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6597),
  [16530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6763),
  [16532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [16534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8226),
  [16536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8652),
  [16538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [16540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13016),
  [16542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13173),
  [16544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [16546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [16548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [16550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [16552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4925),
  [16554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [16556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8286),
  [16558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8242),
  [16560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [16562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9157),
  [16564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9114),
  [16566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [16568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 4, .production_id = 55),
  [16570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [16572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12276),
  [16574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14553),
  [16576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6569),
  [16578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6442),
  [16580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [16582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10222),
  [16584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [16586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8013),
  [16588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8103),
  [16590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [16592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15307),
  [16594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15401),
  [16596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [16598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8594),
  [16600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8461),
  [16602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [16604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [16606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6650),
  [16608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [16610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5788),
  [16612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5890),
  [16614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [16616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10578),
  [16618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [16620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14625),
  [16622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14670),
  [16624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [16626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2868),
  [16628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [16630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12456),
  [16632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14279),
  [16634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [16636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [16638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4629),
  [16640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [16642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2873),
  [16645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [16647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9222),
  [16649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [16651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10309),
  [16653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [16655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [16657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [16659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12116),
  [16661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12431),
  [16663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [16665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [16667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [16669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [16671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11630),
  [16673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [16675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 3, .production_id = 29),
  [16677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7552),
  [16679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7381),
  [16681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [16683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7882),
  [16685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8015),
  [16687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [16689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7992),
  [16691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8328),
  [16693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [16695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10810),
  [16697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [16699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12729),
  [16701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13160),
  [16703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [16705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8181),
  [16707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8538),
  [16709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [16711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8716),
  [16713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8812),
  [16715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [16717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10864),
  [16719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [16721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7409),
  [16723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7493),
  [16725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [16727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2553),
  [16729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [16731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [16733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3533),
  [16735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [16737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [16739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [16741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [16743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5536),
  [16745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [16747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2900),
  [16750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [16752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5345),
  [16754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [16756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7630),
  [16758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7617),
  [16760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [16762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5871),
  [16764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5839),
  [16766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [16768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6089),
  [16770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6152),
  [16772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [16774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8658),
  [16776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8525),
  [16778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [16780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6090),
  [16782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6173),
  [16784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [16786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [16788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [16790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7777),
  [16792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7839),
  [16794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [16796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8178),
  [16798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8723),
  [16800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [16802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14583),
  [16804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14527),
  [16806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [16808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7835),
  [16810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7872),
  [16812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [16814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7035),
  [16816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6880),
  [16818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [16820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8199),
  [16822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8297),
  [16824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [16826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8256),
  [16828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8219),
  [16830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [16832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6258),
  [16834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6559),
  [16836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [16838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6102),
  [16840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6217),
  [16842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [16844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8921),
  [16846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8972),
  [16848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [16850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6278),
  [16852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6457),
  [16854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [16856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8073),
  [16858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7967),
  [16860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [16862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2900),
  [16864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [16866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [16868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2903),
  [16871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [16873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7266),
  [16875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7133),
  [16877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [16879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13228),
  [16881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17873),
  [16883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [16885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13835),
  [16887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13991),
  [16889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [16891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8597),
  [16893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8776),
  [16895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [16897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13242),
  [16899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13638),
  [16901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [16903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9593),
  [16905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [16907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8696),
  [16909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8742),
  [16911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [16913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11307),
  [16915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [16917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [16919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [16921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7849),
  [16923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7880),
  [16925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [16927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9978),
  [16929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [16931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4010),
  [16933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [16935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7141),
  [16937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7136),
  [16939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [16941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8572),
  [16943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8602),
  [16945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [16947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6651),
  [16949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6628),
  [16951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [16953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2883),
  [16956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4713),
  [16958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [16960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6351),
  [16962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6234),
  [16964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [16966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8284),
  [16968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8276),
  [16970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [16972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11288),
  [16974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [16976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12802),
  [16978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13302),
  [16980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [16982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3890),
  [16984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [16986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9229),
  [16988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [16990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6177),
  [16992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6081),
  [16994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [16996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8306),
  [16998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8533),
  [17000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [17002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6420),
  [17004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6468),
  [17006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [17008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14473),
  [17010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14178),
  [17012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [17014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13744),
  [17016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13666),
  [17018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [17020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6361),
  [17022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6318),
  [17024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [17026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18077),
  [17028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8303),
  [17030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8577),
  [17032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [17034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7503),
  [17036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7453),
  [17038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [17040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10635),
  [17042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [17044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2873),
  [17046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8955),
  [17048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8884),
  [17050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [17052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7122),
  [17054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7267),
  [17056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [17058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [17060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [17062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [17064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6703),
  [17066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [17068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7888),
  [17070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8039),
  [17072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [17074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8825),
  [17076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8950),
  [17078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [17080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20316),
  [17082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7312),
  [17084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7094),
  [17086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [17088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7677),
  [17090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7613),
  [17092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [17094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12963),
  [17096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13202),
  [17098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [17100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12940),
  [17102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13125),
  [17104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [17106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13171),
  [17108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13608),
  [17110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [17112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6975),
  [17114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6931),
  [17116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [17118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12541),
  [17120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12927),
  [17122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [17124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4251),
  [17126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [17128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 2, .production_id = 19),
  [17130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10690),
  [17132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [17134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4940),
  [17136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [17138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7922),
  [17140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8115),
  [17142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [17144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7005),
  [17146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7033),
  [17148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [17150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10140),
  [17152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [17154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [17156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7148),
  [17158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7137),
  [17160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [17162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10455),
  [17164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [17166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6640),
  [17168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6596),
  [17170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [17172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6506),
  [17174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6496),
  [17176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [17178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7489),
  [17180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7468),
  [17182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [17184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7532),
  [17186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7393),
  [17188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [17190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6248),
  [17192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6270),
  [17194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [17196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8895),
  [17198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8907),
  [17200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [17202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10332),
  [17204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [17206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [17208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [17210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12375),
  [17212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7163),
  [17214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7147),
  [17216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [17218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10303),
  [17220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [17222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [17224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12379),
  [17226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15314),
  [17228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2905),
  [17230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2915),
  [17232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2835),
  [17234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [17236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2860),
  [17239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [17241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14347),
  [17243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2905),
  [17246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2875),
  [17249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2909),
  [17251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9466),
  [17253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2835),
  [17256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2887),
  [17259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [17261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2887),
  [17263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2845),
  [17265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2940),
  [17267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2892),
  [17269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [17271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17961),
  [17273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18654),
  [17275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18904),
  [17277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18723),
  [17279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2897),
  [17281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [17283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2897),
  [17286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12488),
  [17288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2892),
  [17291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2860),
  [17293] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(11703),
  [17296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__forall_repeat1, 2),
  [17298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(18103),
  [17301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2845),
  [17304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18863),
  [17306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2875),
  [17308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12247),
  [17310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18019),
  [17312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12363),
  [17314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18535),
  [17316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14734),
  [17318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14742),
  [17320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14766),
  [17322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14764),
  [17324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12318),
  [17326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18002),
  [17328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18062),
  [17330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18540),
  [17332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14467),
  [17334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2853),
  [17336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [17338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14869),
  [17340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14782),
  [17342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14870),
  [17344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15402),
  [17346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12464),
  [17348] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2853),
  [17351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2894),
  [17353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3094),
  [17355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 4, .production_id = 28),
  [17357] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simpletype, 4, .production_id = 28),
  [17359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 2, .production_id = 12),
  [17361] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simpletype, 2, .production_id = 12),
  [17363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12442),
  [17365] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(12247),
  [17368] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(18019),
  [17371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__forall_repeat1, 2),
  [17373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(12318),
  [17376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(18002),
  [17379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14314),
  [17381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14822),
  [17383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14271),
  [17385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14446),
  [17387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15002),
  [17389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15004),
  [17391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14930),
  [17393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15274),
  [17395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18860),
  [17397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2837),
  [17399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [17401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18371),
  [17403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12328),
  [17405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18893),
  [17407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12235),
  [17409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17689),
  [17411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14855),
  [17413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17596),
  [17415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17690),
  [17417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2894),
  [17420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18756),
  [17422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2837),
  [17425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18149),
  [17427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14602),
  [17429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14586),
  [17431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11823),
  [17433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12529),
  [17435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12585),
  [17437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3427),
  [17439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13777),
  [17441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2885),
  [17443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12480),
  [17445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12320),
  [17447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2838),
  [17449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [17451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [17453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17975),
  [17455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12342),
  [17457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18682),
  [17459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18288),
  [17461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12463),
  [17463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12490),
  [17465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14514),
  [17467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14487),
  [17469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [17471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9423),
  [17473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18073),
  [17475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__typed_pat, 1),
  [17477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9426),
  [17479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12637),
  [17481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3444),
  [17483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13553),
  [17485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2882),
  [17487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14586),
  [17489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20750),
  [17491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12610),
  [17493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18029),
  [17495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(12610),
  [17498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(18029),
  [17501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [17503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12566),
  [17505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3437),
  [17507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13621),
  [17509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [17511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20515),
  [17513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14441),
  [17515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20485),
  [17517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12287),
  [17519] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_exp_lambda_case, 2), SHIFT(2838),
  [17522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12376),
  [17524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20031),
  [17526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12394),
  [17528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [17530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20289),
  [17532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14557),
  [17534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20152),
  [17536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 5, .production_id = 70),
  [17538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12687),
  [17540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7946),
  [17542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18258),
  [17544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13347),
  [17546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13340),
  [17548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7900),
  [17550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2629),
  [17552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13682),
  [17554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9103),
  [17556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8871),
  [17558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13344),
  [17560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18103),
  [17562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 3, .production_id = 30),
  [17564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12476),
  [17566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20435),
  [17568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8482),
  [17570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2651),
  [17572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12277),
  [17574] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12282),
  [17576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12636),
  [17578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8511),
  [17580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8806),
  [17582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14521),
  [17584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13722),
  [17586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 3),
  [17588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14675),
  [17590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14494),
  [17592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14509),
  [17594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8956),
  [17596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18014),
  [17598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20286),
  [17600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14421),
  [17602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [17604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8627),
  [17606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12256),
  [17608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9266),
  [17610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20017),
  [17612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8216),
  [17614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 4, .production_id = 56),
  [17616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8694),
  [17618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [17620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12939),
  [17622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13118),
  [17624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2615),
  [17626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8035),
  [17628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20060),
  [17630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9265),
  [17632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20681),
  [17634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15367),
  [17636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14027),
  [17638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14368),
  [17640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2569),
  [17642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13304),
  [17644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12521),
  [17646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8412),
  [17648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13910),
  [17650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11608),
  [17652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12721),
  [17654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18241),
  [17656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11530),
  [17658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11820),
  [17660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [17662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11834),
  [17664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12948),
  [17666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16064),
  [17668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15431),
  [17670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18010),
  [17672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17089),
  [17674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11936),
  [17676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11801),
  [17678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11912),
  [17680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17453),
  [17682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14994),
  [17684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15331),
  [17686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12418),
  [17688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11756),
  [17690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11839),
  [17692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2703),
  [17694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15529),
  [17696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_negation, 2),
  [17698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11539),
  [17700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11745),
  [17702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [17704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11553),
  [17706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11780),
  [17708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11554),
  [17710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__qualifying_module, 2),
  [17712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__qualifying_module, 2),
  [17714] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__qualifying_module, 2), SHIFT_REPEAT(9899),
  [17717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11649),
  [17719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11509),
  [17721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2564),
  [17723] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(13081),
  [17726] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(18010),
  [17729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [17731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11920),
  [17733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11841),
  [17735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11518),
  [17737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11594),
  [17739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17519),
  [17741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11626),
  [17743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11631),
  [17745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17996),
  [17747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18113),
  [17749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [17751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11798),
  [17753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15819),
  [17755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [17757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16196),
  [17759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11693),
  [17761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11684),
  [17763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11682),
  [17765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [17767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11795),
  [17769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11647),
  [17771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11932),
  [17773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11807),
  [17775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11591),
  [17777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16396),
  [17779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11680),
  [17781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11901),
  [17783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11640),
  [17785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11770),
  [17787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15915),
  [17789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11851),
  [17791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [17793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11743),
  [17795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 1),
  [17797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2025),
  [17799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let, 1),
  [17801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2027),
  [17803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11880),
  [17805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18356),
  [17807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11706),
  [17809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(12303),
  [17812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__forall_repeat1, 2), SHIFT_REPEAT(17996),
  [17815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11790),
  [17817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11712),
  [17819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18632),
  [17821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2706),
  [17823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11816),
  [17825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16398),
  [17827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11886),
  [17829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18574),
  [17831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11540),
  [17833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16035),
  [17835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18475),
  [17837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11831),
  [17839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11663),
  [17841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_class, 2, .production_id = 20),
  [17843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context_constraints, 1),
  [17845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15130),
  [17847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14220),
  [17849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [17851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9512),
  [17853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [17855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [17857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [17859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [17861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12804),
  [17863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11935),
  [17865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13275),
  [17867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13073),
  [17869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13930),
  [17871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datainst, 1),
  [17873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_role, 4),
  [17875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13268),
  [17877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14651),
  [17879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14537),
  [17881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_role, 4, .production_id = 54),
  [17883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11373),
  [17885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [17887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [17889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [17891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [17893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datainst, 3),
  [17895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5651),
  [17897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [17899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [17901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [17903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [17905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_role, 6),
  [17907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13343),
  [17909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4069),
  [17911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [17913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [17915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [17917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [17919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [17921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [17923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [17925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [17927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [17929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11844),
  [17931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12513),
  [17933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11771),
  [17935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12372),
  [17937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4947),
  [17939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [17941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1146),
  [17943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [17945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [17947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5642),
  [17949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [17951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [17953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [17955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [17957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_role_repeat1, 2),
  [17959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_role_repeat1, 2), SHIFT_REPEAT(13343),
  [17962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9953),
  [17964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [17966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [17968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [17970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [17972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 1),
  [17974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13214),
  [17976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [17978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11576),
  [17980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [17982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [17984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [17986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [17988] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_role_repeat1, 2), SHIFT_REPEAT(13268),
  [17991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__fun_guards, 2),
  [17993] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__fun_guards, 2), SHIFT_REPEAT(554),
  [17996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11872),
  [17998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12314),
  [18000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11722),
  [18002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [18004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [18006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [18008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [18010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10619),
  [18012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [18014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [18016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [18018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [18020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [18022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [18024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [18026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [18028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1427),
  [18030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [18032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datainst, 2),
  [18034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [18036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [18038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [18040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [18042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [18044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9892),
  [18046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [18048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [18050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [18052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [18054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14659),
  [18056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20397),
  [18058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16590),
  [18060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15733),
  [18062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16757),
  [18064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16599),
  [18066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [18068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16005),
  [18070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_datainst, 3, .production_id = 35),
  [18072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__qmodid, 1),
  [18074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14814),
  [18076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16611),
  [18078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16620),
  [18080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16632),
  [18082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11902),
  [18084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13295),
  [18086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [18088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9505),
  [18090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16660),
  [18092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14787),
  [18094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16376),
  [18096] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_role_repeat1, 2), SHIFT_REPEAT(13426),
  [18099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14681),
  [18101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16689),
  [18103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16711),
  [18105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15296),
  [18107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16740),
  [18109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16594),
  [18111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_datainst, 3, .production_id = 35),
  [18113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16100),
  [18115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [18117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 3),
  [18119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12405),
  [18121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19572),
  [18123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13273),
  [18125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13799),
  [18127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16761),
  [18129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16780),
  [18131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16800),
  [18133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5698),
  [18135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16832),
  [18137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14955),
  [18139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15419),
  [18141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16863),
  [18143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16195),
  [18145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16525),
  [18147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9890),
  [18149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16888),
  [18151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16911),
  [18153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16758),
  [18155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16949),
  [18157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16290),
  [18159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 1, .production_id = 9),
  [18161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15910),
  [18163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16978),
  [18165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16385),
  [18167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16332),
  [18169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17010),
  [18171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16480),
  [18173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [18175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 2),
  [18177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13367),
  [18179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13790),
  [18181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13668),
  [18183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fundep, 3),
  [18185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16584),
  [18187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17046),
  [18189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17130),
  [18191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13426),
  [18193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16922),
  [18195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17071),
  [18197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16575),
  [18199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [18201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13400),
  [18203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16242),
  [18205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4356),
  [18207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17085),
  [18209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13958),
  [18211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17113),
  [18213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 4, .production_id = 60),
  [18215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13111),
  [18217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13804),
  [18219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20641),
  [18221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18026),
  [18223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16187),
  [18225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17142),
  [18227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17169),
  [18229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16147),
  [18231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [18233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [18235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17290),
  [18237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16670),
  [18239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14643),
  [18241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16574),
  [18243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19131),
  [18245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16798),
  [18247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4037),
  [18249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16765),
  [18251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 3, .production_id = 33),
  [18253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13285),
  [18255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13798),
  [18257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13779),
  [18259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18215),
  [18261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20263),
  [18263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15815),
  [18265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16566),
  [18267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16051),
  [18269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12248),
  [18271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20391),
  [18273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13206),
  [18275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13899),
  [18277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16560),
  [18279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype_infix, 3, .production_id = 38),
  [18281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13791),
  [18283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15720),
  [18285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17484),
  [18287] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(13668),
  [18290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2),
  [18292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simpletype, 3, .production_id = 19),
  [18294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16860),
  [18296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17199),
  [18298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [18300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15625),
  [18302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17222),
  [18304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13797),
  [18306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13189),
  [18308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2766),
  [18310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [18312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14829),
  [18314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14852),
  [18316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3534),
  [18318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5648),
  [18320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17244),
  [18322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15528),
  [18324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15965),
  [18326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16555),
  [18328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16955),
  [18330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17701),
  [18332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15444),
  [18334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17268),
  [18336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17292),
  [18338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9959),
  [18340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10655),
  [18342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17050),
  [18344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15599),
  [18346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17139),
  [18348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15453),
  [18350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14925),
  [18352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19573),
  [18354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17221),
  [18356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15881),
  [18358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17252),
  [18360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17283),
  [18362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14686),
  [18364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16546),
  [18366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17314),
  [18368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14911),
  [18370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17345),
  [18372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_module, 2),
  [18374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16537),
  [18376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16529),
  [18378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16521),
  [18380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13157),
  [18382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13916),
  [18384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17376),
  [18386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13174),
  [18388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13932),
  [18390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16513),
  [18392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17407),
  [18394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17438),
  [18396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [18398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17469),
  [18400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16503),
  [18402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16495),
  [18404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11564),
  [18406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17500),
  [18408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16485),
  [18410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11385),
  [18412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15784),
  [18414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16470),
  [18416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16461),
  [18418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15480),
  [18420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16449),
  [18422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16437),
  [18424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16427),
  [18426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17531),
  [18428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16418),
  [18430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13844),
  [18432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13172),
  [18434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2782),
  [18436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17317),
  [18438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17335),
  [18440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17716),
  [18442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17360),
  [18444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15786),
  [18446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17381),
  [18448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20394),
  [18450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18359),
  [18452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13796),
  [18454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13203),
  [18456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17403),
  [18458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2769),
  [18460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17422),
  [18462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11592),
  [18464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17562),
  [18466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2620),
  [18468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17593),
  [18470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17624),
  [18472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13107),
  [18474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13592),
  [18476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17655),
  [18478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17686),
  [18480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17443),
  [18482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17717),
  [18484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13719),
  [18486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17195),
  [18488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [18490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(13400),
  [18493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17468),
  [18495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17748),
  [18497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17779),
  [18499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17437),
  [18501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__forall, 2),
  [18503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16178),
  [18505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17800),
  [18507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17813),
  [18509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17764),
  [18511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15475),
  [18513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15662),
  [18515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17744),
  [18517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17483),
  [18519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__alt_variants, 1),
  [18521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16000),
  [18523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15616),
  [18525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15429),
  [18527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17708),
  [18529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17508),
  [18531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17682),
  [18533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [18535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_datainst, 2, .production_id = 16),
  [18537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4957),
  [18539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17663),
  [18541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17640),
  [18543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17616),
  [18545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17592),
  [18547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17525),
  [18549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20101),
  [18551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13712),
  [18553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18333),
  [18555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20046),
  [18557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17572),
  [18559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17546),
  [18561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 5, .production_id = 60),
  [18563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13689),
  [18565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13816),
  [18567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_head, 1, .production_id = 9),
  [18569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_infix, 5),
  [18571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_infix, 1), REDUCE(sym_constraint, 1),
  [18574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_datafam, 3, .production_id = 29),
  [18576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 3, .production_id = 71),
  [18578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [18580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14008),
  [18582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(12247),
  [18585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9467),
  [18587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_datafam, 2, .production_id = 19),
  [18589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_tyfam, 2, .production_id = 19),
  [18591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 4),
  [18593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13591),
  [18595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_infix, 3),
  [18597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18823),
  [18599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13900),
  [18601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 4, .production_id = 33),
  [18603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13601),
  [18605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13789),
  [18607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13891),
  [18609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18575),
  [18611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3479),
  [18613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14477),
  [18615] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_tyfam, 3, .production_id = 29),
  [18617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 2),
  [18619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [18621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [18623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(12318),
  [18626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_datafam, 3, .production_id = 29),
  [18628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_injectivity, 4),
  [18630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12247),
  [18632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18645),
  [18634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17058),
  [18636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3497),
  [18638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_class, 3, .production_id = 36),
  [18640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [18642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15812),
  [18644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_role, 1),
  [18646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13805),
  [18648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__foreign_pre, 1),
  [18650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__foreign_pre, 1),
  [18652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16159),
  [18654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13803),
  [18656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 3, .production_id = 47),
  [18658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(14477),
  [18661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 2, .production_id = 61),
  [18663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2647),
  [18665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15911),
  [18667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2026),
  [18669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2032),
  [18671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12370),
  [18673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19651),
  [18675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13534),
  [18677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13896),
  [18679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17382),
  [18681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13472),
  [18683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13881),
  [18685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12318),
  [18687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13478),
  [18689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13882),
  [18691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13396),
  [18693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13866),
  [18695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [18697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__adt_rhs, 3),
  [18699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructors, 2),
  [18701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [18703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 3, .production_id = 72),
  [18705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5478),
  [18707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [18709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [18711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [18713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [18715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 3, .production_id = 32),
  [18717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9641),
  [18719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [18721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1307),
  [18723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [18725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [18727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 3),
  [18729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11481),
  [18731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [18733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [18735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [18737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [18739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 5, .production_id = 56),
  [18741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__newtype, 3),
  [18743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 2, .production_id = 15),
  [18745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13892),
  [18747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10513),
  [18749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [18751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1284),
  [18753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1282),
  [18755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [18757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13897),
  [18759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4463),
  [18761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [18763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [18765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [18767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [18769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11726),
  [18771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [18773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [18775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [18777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1342),
  [18779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 6, .production_id = 96),
  [18781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5291),
  [18783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [18785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [18787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [18789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [18791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 5, .production_id = 90),
  [18793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11043),
  [18795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [18797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [18799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [18801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [18803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 5, .production_id = 88),
  [18805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructors, 4),
  [18807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [18809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 7, .production_id = 60),
  [18811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructors, 3),
  [18813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fundeps, 3),
  [18815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15322),
  [18817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9385),
  [18819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [18821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [18823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [18825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [18827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2),
  [18829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2), SHIFT_REPEAT(14757),
  [18832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13903),
  [18834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 4),
  [18836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 4, .production_id = 72),
  [18838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructors_repeat1, 2),
  [18840] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constructors_repeat1, 2), SHIFT_REPEAT(2193),
  [18843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12191),
  [18845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14906),
  [18847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 6),
  [18849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 6, .production_id = 60),
  [18851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5350),
  [18853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [18855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [18857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [18859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [18861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 6, .production_id = 33),
  [18863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [18865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [18867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [18869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [18871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1339),
  [18873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 6, .production_id = 70),
  [18875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14757),
  [18877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 5),
  [18879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 5, .production_id = 33),
  [18881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15547),
  [18883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10997),
  [18885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [18887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [18889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [18891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [18893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 5, .production_id = 55),
  [18895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [18897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [18899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [18901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [18903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [18905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decls, 2),
  [18907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_decls, 2),
  [18909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2024),
  [18911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [18913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12040),
  [18915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14635),
  [18917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4678),
  [18919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [18921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [18923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [18925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [18927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 4, .production_id = 29),
  [18929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fundeps, 2),
  [18931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__adt_rhs_repeat1, 2),
  [18933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__adt_rhs_repeat1, 2), SHIFT_REPEAT(12276),
  [18936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 4, .production_id = 30),
  [18938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 2, .production_id = 62),
  [18940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__adt_rhs, 2),
  [18942] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructors, 1),
  [18944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15719),
  [18946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__newtype, 2),
  [18948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alt, 3, .production_id = 16),
  [18950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [18952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [18954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15158),
  [18956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5221),
  [18958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [18960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [18962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [18964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [18966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12610),
  [18968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decls, 3),
  [18970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_decls, 3),
  [18972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10551),
  [18974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [18976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [18978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [18980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [18982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5675),
  [18984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [18986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [18988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [18990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [18992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_inj, 1),
  [18994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18027),
  [18996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12063),
  [18998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [19000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1289),
  [19002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [19004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [19006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11439),
  [19008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [19010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [19012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [19014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [19016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15961),
  [19018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15317),
  [19020] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2020),
  [19022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [19024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_adt, 3, .production_id = 19),
  [19026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4794),
  [19028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [19030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [19032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [19034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1332),
  [19036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(12610),
  [19039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5269),
  [19041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [19043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [19045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [19047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [19049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 2),
  [19051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12903),
  [19053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11295),
  [19055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [19057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [19059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [19061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [19063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1456),
  [19065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [19067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2440),
  [19069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12186),
  [19071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 3),
  [19073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18455),
  [19075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14641),
  [19077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18461),
  [19079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2705),
  [19081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10637),
  [19083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [19085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [19087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1265),
  [19089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [19091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11015),
  [19093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [19095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [19097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [19099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [19101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 4),
  [19103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16944),
  [19105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2),
  [19107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2), SHIFT_REPEAT(12903),
  [19110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [19112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__adt_rhs_repeat1, 2), SHIFT_REPEAT(12456),
  [19115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10816),
  [19117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [19119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [19121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [19123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [19125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 5),
  [19127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixity, 6),
  [19129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [19131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [19133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [19135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [19137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [19139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [19141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3925),
  [19143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [19145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [19147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [19149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [19151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10020),
  [19153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [19155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [19157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [19159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [19161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14628),
  [19163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [19165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [19167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [19169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [19171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [19173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decls, 5),
  [19175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_decls, 5),
  [19177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2701),
  [19179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12111),
  [19181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [19183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [19185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [19187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [19189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [19191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [19193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_sig, 1),
  [19195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [19197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_calling_convention, 1),
  [19199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_calling_convention, 1),
  [19201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14638),
  [19203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard_equation, 3, .production_id = 35),
  [19205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11311),
  [19207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [19209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [19211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [19213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1367),
  [19215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constructors_repeat1, 2), SHIFT_REPEAT(2195),
  [19218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [19220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decls, 4),
  [19222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__let_decls, 4),
  [19224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5791),
  [19226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [19228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [19230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [19232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [19234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18505),
  [19236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2), SHIFT_REPEAT(15322),
  [19239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [19241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [19243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8403),
  [19245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datainst, 3, .production_id = 35),
  [19247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6197),
  [19249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11510),
  [19251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18470),
  [19253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [19255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 4, .production_id = 81),
  [19257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [19259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8874),
  [19261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8888),
  [19263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2648),
  [19265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [19267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5299),
  [19269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9643),
  [19271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13334),
  [19273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2543),
  [19275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7380),
  [19277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6281),
  [19279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8154),
  [19281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2625),
  [19283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2019),
  [19285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [19287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7944),
  [19289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10238),
  [19291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3576),
  [19293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [19295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11443),
  [19297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2607),
  [19299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [19301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10496),
  [19303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 4),
  [19305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3246),
  [19307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3286),
  [19309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [19311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5612),
  [19313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [19315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2656),
  [19317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5325),
  [19319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7975),
  [19321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [19323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_record, 2),
  [19325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [19327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9850),
  [19329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [19331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2662),
  [19333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5776),
  [19335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8632),
  [19337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8715),
  [19339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5455),
  [19341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18018),
  [19343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17863),
  [19345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9366),
  [19347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6998),
  [19349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5471),
  [19351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2633),
  [19353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9592),
  [19355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tyfam_injectivity_repeat1, 2), SHIFT_REPEAT(11703),
  [19358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6356),
  [19360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [19362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12849),
  [19364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2628),
  [19366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12944),
  [19368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [19370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14327),
  [19372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14947),
  [19374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10461),
  [19376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7190),
  [19378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5978),
  [19380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6021),
  [19382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9801),
  [19384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [19386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2565),
  [19388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12864),
  [19390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 2, .production_id = 31),
  [19392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6720),
  [19394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7553),
  [19396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5836),
  [19398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let, 2),
  [19400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [19402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 1, .production_id = 45),
  [19404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8082),
  [19406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11054),
  [19408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guards, 3),
  [19410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [19412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4933),
  [19414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [19416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6487),
  [19418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14225),
  [19420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6429),
  [19422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11468),
  [19424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datainst, 2, .production_id = 16),
  [19426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [19428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8946),
  [19430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11250),
  [19432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10734),
  [19434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [19436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9414),
  [19438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12747),
  [19440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2608),
  [19442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [19444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [19446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [19448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2634),
  [19450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7737),
  [19452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [19454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, .production_id = 16),
  [19456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__adt_rhs_repeat1, 2), SHIFT_REPEAT(12379),
  [19459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4350),
  [19461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2610),
  [19463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [19465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15040),
  [19467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4294),
  [19469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructors_repeat1, 4),
  [19471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_infix, 5),
  [19473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [19475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [19477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2), SHIFT_REPEAT(12747),
  [19480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2655),
  [19482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7761),
  [19484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13354),
  [19486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [19488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14417),
  [19490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [19492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5757),
  [19494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [19496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12253),
  [19498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11748),
  [19500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10928),
  [19502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8202),
  [19504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [19506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10781),
  [19508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4953),
  [19510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_class, 3, .production_id = 20),
  [19512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [19514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_constructors_repeat1, 3),
  [19516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [19518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [19520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 1),
  [19522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1992),
  [19524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [19526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [19528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18434),
  [19530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2815),
  [19532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6752),
  [19534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7430),
  [19536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 3),
  [19538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7179),
  [19540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7640),
  [19542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9584),
  [19544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11290),
  [19546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2536),
  [19548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13895),
  [19550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11099),
  [19552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5280),
  [19554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13685),
  [19556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6246),
  [19558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6051),
  [19560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [19562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 3, .production_id = 75),
  [19564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12955),
  [19566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_field_repeat1, 2, .production_id = 78), SHIFT_REPEAT(18470),
  [19569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_field_repeat1, 2, .production_id = 78),
  [19571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [19573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [19575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 2, .production_id = 47),
  [19577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13288),
  [19579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10800),
  [19581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8446),
  [19583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6011),
  [19585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_rhs, 1),
  [19587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12855),
  [19589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13257),
  [19591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8963),
  [19593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_data_constructor_infix, 3),
  [19595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__datainst, 4, .production_id = 53),
  [19597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [19599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8375),
  [19601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13092),
  [19603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9390),
  [19605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9285),
  [19607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [19609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18460),
  [19611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [19613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [19615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5926),
  [19617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat2, 2), SHIFT_REPEAT(2079),
  [19620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat2, 2),
  [19622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [19624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6085),
  [19626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10024),
  [19628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [19630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 1, .production_id = 13),
  [19632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guards, 2),
  [19634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [19636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8837),
  [19638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7539),
  [19640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5796),
  [19642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13293),
  [19644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15183),
  [19646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6313),
  [19648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [19650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2555),
  [19652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [19654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11330),
  [19656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [19658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6382),
  [19660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2650),
  [19662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8249),
  [19664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2646),
  [19666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9158),
  [19668] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_constructors_repeat1, 2), SHIFT_REPEAT(2116),
  [19671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [19673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_fields, 4),
  [19675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17823),
  [19677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11585),
  [19679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13463),
  [19681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [19683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_guards_repeat1, 2),
  [19685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guards_repeat1, 2), SHIFT_REPEAT(555),
  [19688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13148),
  [19690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5690),
  [19692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 5),
  [19694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3224),
  [19696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3313),
  [19698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7180),
  [19700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10821),
  [19702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 5, .production_id = 53),
  [19704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3232),
  [19706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [19708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [19710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [19712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_result_type, 2),
  [19714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [19716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14466),
  [19718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fundeps_repeat1, 2), SHIFT_REPEAT(15040),
  [19721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9902),
  [19723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7193),
  [19725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9376),
  [19727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2567),
  [19729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5028),
  [19731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2), SHIFT_REPEAT(12955),
  [19734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13728),
  [19736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [19738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [19740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8711),
  [19742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8384),
  [19744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_class, 4, .production_id = 36),
  [19746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11018),
  [19748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2310),
  [19750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 4),
  [19752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10610),
  [19754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8787),
  [19756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [19758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12050),
  [19760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14040),
  [19762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10596),
  [19764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7092),
  [19766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [19768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [19770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13319),
  [19772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_instance, 2),
  [19774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2086),
  [19776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [19778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4766),
  [19780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8436),
  [19782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10993),
  [19784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [19786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7322),
  [19788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8513),
  [19790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2589),
  [19792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12190),
  [19794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4686),
  [19796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7040),
  [19798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2291),
  [19800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11284),
  [19802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7461),
  [19804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [19806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5231),
  [19808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [19810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12697),
  [19812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7892),
  [19814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8845),
  [19816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3212),
  [19818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [19820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3248),
  [19822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [19824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [19826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [19828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7229),
  [19830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6987),
  [19832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3213),
  [19834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [19836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10599),
  [19838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9495),
  [19840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11402),
  [19842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10529),
  [19844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9152),
  [19846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [19848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4750),
  [19850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10500),
  [19852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10987),
  [19854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [19856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5432),
  [19858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2029),
  [19860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16074),
  [19862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6516),
  [19864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2653),
  [19866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11246),
  [19868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7450),
  [19870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [19872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2012),
  [19874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6626),
  [19876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11429),
  [19878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9454),
  [19880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12835),
  [19882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13278),
  [19884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8470),
  [19886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6664),
  [19888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [19890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 2, .production_id = 63),
  [19892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11003),
  [19894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8033),
  [19896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2572),
  [19898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [19900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5683),
  [19902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2562),
  [19904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2), SHIFT_REPEAT(12849),
  [19907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6721),
  [19909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [19911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11925),
  [19913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5558),
  [19915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12593),
  [19917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4804),
  [19919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [19921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7686),
  [19923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9239),
  [19925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [19927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [19929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [19931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11875),
  [19933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6451),
  [19935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2642),
  [19937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8480),
  [19939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [19941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [19943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_instance, 1),
  [19945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14457),
  [19947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [19949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [19951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [19953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5311),
  [19955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 3),
  [19957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [19959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [19961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funpat, 2, .production_id = 25),
  [19963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2, .production_id = 16),
  [19965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1293),
  [19967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [19969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [19971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10196),
  [19973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [19975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [19977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [19979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [19981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_typed, 2, .production_id = 24),
  [19983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13822),
  [19985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [19987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [19989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [19991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [19993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [19995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12082),
  [19997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [19999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2932),
  [20001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5202),
  [20003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [20005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [20007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2934),
  [20009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11800),
  [20011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3233),
  [20013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3222),
  [20015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14266),
  [20017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17993),
  [20019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [20021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11747),
  [20023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [20025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [20027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [20029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12105),
  [20031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [20033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context_newtype, 1, .production_id = 9),
  [20035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [20037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10229),
  [20039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [20041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [20043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11854),
  [20045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [20047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11826),
  [20049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [20051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__decl_fun, 1, .dynamic_precedence = 1, .production_id = 8),
  [20053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [20055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16101),
  [20057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [20059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11804),
  [20061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [20063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [20065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_via, 2),
  [20067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_haskell_repeat1, 2), SHIFT_REPEAT(14),
  [20070] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_haskell_repeat1, 2),
  [20072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [20074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [20076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17191),
  [20078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3146),
  [20080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [20082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [20084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [20086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [20088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11864),
  [20090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_haskell, 1),
  [20092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [20094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [20096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [20098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [20100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [20102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13617),
  [20104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2091),
  [20106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13313),
  [20108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16023),
  [20110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [20112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3150),
  [20114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5521),
  [20116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [20118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11497),
  [20120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [20122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [20124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [20126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15997),
  [20128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13093),
  [20130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 3),
  [20132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [20134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18338),
  [20136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tyfam_inj, 2),
  [20138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [20140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5538),
  [20142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [20144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17465),
  [20146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 4, .production_id = 53),
  [20148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14396),
  [20150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [20152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [20154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14392),
  [20156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3299),
  [20158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [20160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [20162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [20164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [20166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2008),
  [20168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [20170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [20172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [20174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [20176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2910),
  [20178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5027),
  [20180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [20182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [20184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [20186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5037),
  [20188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3290),
  [20190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1186),
  [20192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [20194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [20196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [20198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [20200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15845),
  [20202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [20204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [20206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14599),
  [20208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context_constraints, 3),
  [20210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constraint, 3),
  [20212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [20214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 3, .production_id = 59),
  [20216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18576),
  [20218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3169),
  [20220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3100),
  [20222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [20224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15721),
  [20226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [20228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9548),
  [20230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__alt_variants, 2, .production_id = 16),
  [20232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [20234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [20236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15764),
  [20238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [20240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [20242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [20244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10977),
  [20246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3316),
  [20248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [20250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [20252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3114),
  [20254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [20256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15749),
  [20258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13253),
  [20260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3084),
  [20262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10946),
  [20264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [20266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9564),
  [20268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alts_repeat2, 2), SHIFT_REPEAT(3186),
  [20271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alts_repeat2, 2),
  [20273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2935),
  [20275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2),
  [20277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2), SHIFT_REPEAT(2390),
  [20280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [20282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13265),
  [20284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [20286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [20288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11676),
  [20290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [20292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5712),
  [20294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [20296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11654),
  [20298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [20300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [20302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3089),
  [20304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [20306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3244),
  [20308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3152),
  [20310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alt, 2, .production_id = 16),
  [20312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13656),
  [20314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 7, .production_id = 96),
  [20316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [20318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10028),
  [20320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12959),
  [20322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3069),
  [20324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat2, 2, .production_id = 99), SHIFT_REPEAT(3203),
  [20327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat2, 2, .production_id = 99),
  [20329] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat2, 2), SHIFT_REPEAT(2076),
  [20332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [20334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [20336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5516),
  [20338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3083),
  [20340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12213),
  [20342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [20344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [20346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10861),
  [20348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [20350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10858),
  [20352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [20354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [20356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11555),
  [20358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [20360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [20362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5619),
  [20364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [20366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [20368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3120),
  [20370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 6, .production_id = 90),
  [20372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 6, .production_id = 88),
  [20374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constraint, 1),
  [20376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [20378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12101),
  [20380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [20382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [20384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_repeat1, 2),
  [20386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_repeat1, 2), SHIFT_REPEAT(18434),
  [20389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3009),
  [20391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11600),
  [20393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [20395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat2, 2, .dynamic_precedence = 1),
  [20397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [20399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [20401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [20403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [20405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3011),
  [20407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [20409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [20411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [20413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_newtype_constructor, 2),
  [20415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3062),
  [20417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [20419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [20421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [20423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [20425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10000),
  [20427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3116),
  [20429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5946),
  [20431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3137),
  [20433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4398),
  [20435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [20437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [20439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [20441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9501),
  [20443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 3, .production_id = 61),
  [20445] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 3, .production_id = 62),
  [20447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [20449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9498),
  [20451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 2, .production_id = 31),
  [20453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [20455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [20457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3151),
  [20459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [20461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3098),
  [20463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16972),
  [20465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [20467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2058),
  [20469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15067),
  [20471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17987),
  [20473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [20475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [20477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [20479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3283),
  [20481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 2, .production_id = 22),
  [20483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [20485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [20487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 1),
  [20489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [20491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3275),
  [20493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16996),
  [20495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat2, 2), SHIFT_REPEAT(3382),
  [20498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat2, 2),
  [20500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 2, .production_id = 27),
  [20502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [20504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11343),
  [20506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [20508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [20510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [20512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10754),
  [20514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [20516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [20518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [20520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18457),
  [20522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [20524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5920),
  [20526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3112),
  [20528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [20530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [20532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5561),
  [20534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [20536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5601),
  [20538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [20540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5560),
  [20542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3179),
  [20544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2055),
  [20546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16931),
  [20548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13209),
  [20550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18507),
  [20552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 4, .production_id = 71),
  [20554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [20556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [20558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [20560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18521),
  [20562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2071),
  [20564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [20566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6179),
  [20568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1242),
  [20570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [20572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [20574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5615),
  [20576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [20578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [20580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context_newtype, 2, .production_id = 19),
  [20582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat2, 2), SHIFT_REPEAT(2016),
  [20585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat2, 2),
  [20587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [20589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [20591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 3, .production_id = 41),
  [20593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [20595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3168),
  [20597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [20599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1280),
  [20601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13241),
  [20603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [20605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [20607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [20609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [20611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6161),
  [20613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [20615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2952),
  [20617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [20619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3173),
  [20621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11679),
  [20623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3016),
  [20625] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat2, 2), SHIFT_REPEAT(2077),
  [20628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_field_repeat1, 2, .production_id = 76),
  [20630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 5),
  [20632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [20634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3270),
  [20636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3274),
  [20638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3273),
  [20640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18586),
  [20642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [20644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [20646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [20648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3019),
  [20650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11954),
  [20652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [20654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [20656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18613),
  [20658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [20660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12090),
  [20662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving, 5, .production_id = 72),
  [20664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [20666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [20668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [20670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11705),
  [20672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [20674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [20676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18701),
  [20678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 4, .production_id = 49),
  [20680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3294),
  [20682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [20684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [20686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18726),
  [20688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_field, 3),
  [20690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rec_repeat2, 2), SHIFT_REPEAT(486),
  [20693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rec_repeat2, 2),
  [20695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3249),
  [20697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [20699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [20701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [20703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [20705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [20707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3247),
  [20709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3304),
  [20711] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__gadt_rhs_repeat2, 2), SHIFT_REPEAT(13865),
  [20714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__gadt_rhs_repeat2, 2),
  [20716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3029),
  [20718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [20720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5820),
  [20722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [20724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [20726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [20728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [20730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5387),
  [20732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [20734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5394),
  [20736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [20738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [20740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [20742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [20744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5805),
  [20746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [20748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [20750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [20752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [20754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [20756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [20758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [20760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 3),
  [20762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_fixity_repeat1, 2), SHIFT_REPEAT(12959),
  [20765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [20767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_signature, 5, .production_id = 67),
  [20769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_haskell_repeat1, 2), SHIFT_REPEAT(15),
  [20772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17814),
  [20774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3049),
  [20776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [20778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [20780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11615),
  [20782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [20784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11612),
  [20786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 4),
  [20788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [20790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [20792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [20794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [20796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [20798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [20800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [20802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17787),
  [20804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funrhs, 4, .production_id = 47),
  [20806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 1, .production_id = 13),
  [20808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [20810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [20812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2007),
  [20814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2977),
  [20816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [20818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [20820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [20822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_signature_repeat1, 2, .production_id = 42),
  [20824] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_signature_repeat1, 2, .production_id = 42), SHIFT_REPEAT(15558),
  [20827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [20829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [20831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3056),
  [20833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [20835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [20837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [20839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5502),
  [20841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [20843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [20845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5501),
  [20847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [20849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5915),
  [20851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [20853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [20855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [20857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12484),
  [20859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [20861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 4),
  [20863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [20865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [20867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [20869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [20871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [20873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4984),
  [20875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [20877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3801),
  [20879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [20881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10992),
  [20883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [20885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12469),
  [20887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [20889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 2),
  [20891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [20893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [20895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [20897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [20899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [20901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10979),
  [20903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [20905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [20907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13385),
  [20909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17590),
  [20911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3147),
  [20913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3148),
  [20915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17129),
  [20917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [20919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [20921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [20923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__instance, 4, .production_id = 57),
  [20925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [20927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [20929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [20931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [20933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [20935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [20937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13746),
  [20939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [20941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [20943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5666),
  [20945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [20947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9744),
  [20949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1181),
  [20951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [20953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [20955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9750),
  [20957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [20959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5922),
  [20961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13009),
  [20963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13165),
  [20965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [20967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [20969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [20971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [20973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4946),
  [20975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [20977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3234),
  [20979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [20981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [20983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [20985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [20987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [20989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_view, 3, .production_id = 21),
  [20991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2092),
  [20993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [20995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3315),
  [20997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [20999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17164),
  [21001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [21003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10758),
  [21005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2001),
  [21007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17731),
  [21009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pat_tuple_repeat1, 2),
  [21011] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pat_tuple_repeat1, 2), SHIFT_REPEAT(550),
  [21014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [21016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [21018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [21020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [21022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [21024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5672),
  [21026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [21028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [21030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [21032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [21034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [21036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [21038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [21040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [21042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [21044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [21046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15155),
  [21048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [21050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14138),
  [21052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18006),
  [21054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [21056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11891),
  [21058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [21060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [21062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [21064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14493),
  [21066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [21068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14502),
  [21070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [21072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11377),
  [21074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [21076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_instance_repeat2, 2), SHIFT_REPEAT(2250),
  [21079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_instance_repeat2, 2),
  [21081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [21083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [21085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [21087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11868),
  [21089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [21091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [21093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [21095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5524),
  [21097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [21099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [21101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [21103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [21105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [21107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5518),
  [21109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [21111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [21113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2009),
  [21115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [21117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11287),
  [21119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7332),
  [21121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17934),
  [21123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [21125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [21127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14176),
  [21129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [21131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11121),
  [21133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12343),
  [21135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8731),
  [21137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12355),
  [21139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11129),
  [21141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [21143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3142),
  [21145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13043),
  [21147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17951),
  [21149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13022),
  [21151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17997),
  [21153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [21155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18055),
  [21157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8894),
  [21159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [21161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8892),
  [21163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9317),
  [21165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17967),
  [21167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4458),
  [21169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18082),
  [21171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12647),
  [21173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12656),
  [21175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16687),
  [21177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10492),
  [21179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [21181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11566),
  [21183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9254),
  [21185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18042),
  [21187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12561),
  [21189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [21191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16732),
  [21193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12574),
  [21195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12909),
  [21197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18038),
  [21199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18281),
  [21201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11581),
  [21203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10482),
  [21205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8867),
  [21207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10476),
  [21209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [21211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8866),
  [21213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12627),
  [21215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11729),
  [21217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12724),
  [21219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9252),
  [21221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17989),
  [21223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5278),
  [21225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [21227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5282),
  [21229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5717),
  [21231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9303),
  [21233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9394),
  [21235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10469),
  [21237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8862),
  [21239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16359),
  [21241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [21243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [21245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10466),
  [21247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8834),
  [21249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11853),
  [21251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10462),
  [21253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [21255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10459),
  [21257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12669),
  [21259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [21261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11867),
  [21263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12663),
  [21265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5328),
  [21267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_pattern, 2, .production_id = 16),
  [21269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [21271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5610),
  [21273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11871),
  [21275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3166),
  [21277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_pattern, 2, .production_id = 18),
  [21279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11924),
  [21281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11115),
  [21283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [21285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10440),
  [21287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8828),
  [21289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5550),
  [21291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11111),
  [21293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5527),
  [21295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10430),
  [21297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8561),
  [21299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11109),
  [21301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [21303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [21305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [21307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9791),
  [21309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15717),
  [21311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12482),
  [21313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16144),
  [21315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8671),
  [21317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11102),
  [21319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3771),
  [21321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [21323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11733),
  [21325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5614),
  [21327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12559),
  [21329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10410),
  [21331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18054),
  [21333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5618),
  [21335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10329),
  [21337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18058),
  [21339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_deriving_strategy, 1),
  [21341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [21343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11696),
  [21345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_deriving, 2),
  [21347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3054),
  [21349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [21351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15029),
  [21353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8606),
  [21355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11087),
  [21357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8611),
  [21359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11065),
  [21361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12421),
  [21363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5695),
  [21365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5108),
  [21367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18043),
  [21369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13312),
  [21371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13546),
  [21373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [21375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [21377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9646),
  [21379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [21381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [21383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [21385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5699),
  [21387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_unboxed_sum, 1, .production_id = 21),
  [21389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_unboxed_sum, 1),
  [21391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [21393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10388),
  [21395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18076),
  [21397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7201),
  [21399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9587),
  [21401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15233),
  [21403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9666),
  [21405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12377),
  [21407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15132),
  [21409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13264),
  [21411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18272),
  [21413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17320),
  [21415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5441),
  [21417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11062),
  [21419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5447),
  [21421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13505),
  [21423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13501),
  [21425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2005),
  [21427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [21429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [21431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15121),
  [21433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [21435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3276),
  [21437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15834),
  [21439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8648),
  [21441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9680),
  [21443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8669),
  [21445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [21447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9689),
  [21449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9692),
  [21451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9696),
  [21453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3101),
  [21455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15821),
  [21457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2821),
  [21459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18185),
  [21461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13491),
  [21463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5457),
  [21465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [21467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5469),
  [21469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [21471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [21473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [21475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18053),
  [21477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [21479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18066),
  [21481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [21483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9701),
  [21485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_pattern, 2, .production_id = 17),
  [21487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [21489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15738),
  [21491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4797),
  [21493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18273),
  [21495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9710),
  [21497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [21499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [21501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3122),
  [21503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2830),
  [21505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10621),
  [21507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18109),
  [21509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10748),
  [21511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18099),
  [21513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8985),
  [21515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8983),
  [21517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3776),
  [21519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [21521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5714),
  [21523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18536),
  [21525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5483),
  [21527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18094),
  [21529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3102),
  [21531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5482),
  [21533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18106),
  [21535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9371),
  [21537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4983),
  [21539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9364),
  [21541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12642),
  [21543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4980),
  [21545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9242),
  [21547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple, 2, .production_id = 16),
  [21549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5723),
  [21551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [21553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [21555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [21557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12615),
  [21559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8987),
  [21561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3291),
  [21563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15759),
  [21565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [21567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5470),
  [21569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [21571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [21573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10574),
  [21575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18117),
  [21577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4198),
  [21579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9372),
  [21581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [21583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9370),
  [21585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5466),
  [21587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18118),
  [21589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9047),
  [21591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5465),
  [21593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8990),
  [21595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3735),
  [21597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_type, 3, .production_id = 30),
  [21599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_or_implicit, 1), SHIFT(18343),
  [21602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type_or_implicit, 1), SHIFT(2665),
  [21605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5460),
  [21607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11658),
  [21609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11634),
  [21611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18343),
  [21613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2665),
  [21615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [21617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14229),
  [21619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18159),
  [21621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14228),
  [21623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4049),
  [21625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4929),
  [21627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4928),
  [21629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [21631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15338),
  [21633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9362),
  [21635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [21637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [21639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5456),
  [21641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9363),
  [21643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [21645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [21647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5454),
  [21649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [21651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5452),
  [21653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11568),
  [21655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5450),
  [21657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11583),
  [21659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2057),
  [21661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19976),
  [21663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3129),
  [21665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8986),
  [21667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14223),
  [21669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12491),
  [21671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14219),
  [21673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3772),
  [21675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18407),
  [21677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [21679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [21681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [21683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [21685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [21687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5446),
  [21689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13309),
  [21691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 9, .production_id = 98),
  [21693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9271),
  [21695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5442),
  [21697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8189),
  [21699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18093),
  [21701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [21703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [21705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3055),
  [21707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3111),
  [21709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_type, 2, .production_id = 16),
  [21711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [21713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16179),
  [21715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12474),
  [21717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13210),
  [21719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14381),
  [21721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2013),
  [21723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [21725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 3, .production_id = 34),
  [21727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [21729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [21731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8180),
  [21733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18145),
  [21735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8183),
  [21737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18153),
  [21739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 7, .production_id = 95),
  [21741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [21743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 10),
  [21745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 10, .production_id = 53),
  [21747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [21749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [21751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [21753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12453),
  [21755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_newtype, 3, .production_id = 19),
  [21757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13224),
  [21759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11467),
  [21761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14439),
  [21763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 8, .production_id = 98),
  [21765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 8, .production_id = 95),
  [21767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14448),
  [21769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14449),
  [21771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [21773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_deriving, 3),
  [21775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8195),
  [21777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18163),
  [21779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11463),
  [21781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5730),
  [21783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11450),
  [21785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [21787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8926),
  [21789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [21791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [21793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18593),
  [21795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7740),
  [21797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 9, .production_id = 53),
  [21799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7739),
  [21801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8924),
  [21803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3071),
  [21805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18793),
  [21807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14491),
  [21809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14499),
  [21811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11438),
  [21813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [21815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [21817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11428),
  [21819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [21821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11427),
  [21823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [21825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18740),
  [21827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11425),
  [21829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [21831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18172),
  [21833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_default, 3),
  [21835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 9),
  [21837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16142),
  [21839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7721),
  [21841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [21843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18181),
  [21845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7718),
  [21847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8188),
  [21849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18125),
  [21851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12486),
  [21853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3044),
  [21855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12478),
  [21857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [21859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 6),
  [21861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [21863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11375),
  [21865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8315),
  [21867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18134),
  [21869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4027),
  [21871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11344),
  [21873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [21875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18208),
  [21877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9334),
  [21879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [21881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [21883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12286),
  [21885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4143),
  [21887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12299),
  [21889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3070),
  [21891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4061),
  [21893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_haskell_repeat1, 2, .dynamic_precedence = 1),
  [21895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5747),
  [21897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13667),
  [21899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4053),
  [21901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_rhs, 6),
  [21903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7432),
  [21905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18202),
  [21907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5742),
  [21909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7451),
  [21911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18209),
  [21913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3289),
  [21915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18711),
  [21917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [21919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12391),
  [21921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 6),
  [21923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 8, .production_id = 60),
  [21925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [21927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 7, .production_id = 59),
  [21929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5752),
  [21931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [21933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_unboxed_sum, 2, .production_id = 37),
  [21935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [21937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10770),
  [21939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [21941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12386),
  [21943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4469),
  [21945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12690),
  [21947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 8, .production_id = 53),
  [21949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [21951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pat_unboxed_sum, 2),
  [21953] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_tuple_repeat1, 2, .production_id = 37), SHIFT_REPEAT(962),
  [21956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_tuple_repeat1, 2, .production_id = 37),
  [21958] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, .production_id = 37), SHIFT_REPEAT(959),
  [21961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_unboxed_sum_repeat1, 2, .production_id = 37),
  [21963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [21965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7523),
  [21967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18233),
  [21969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13439),
  [21971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [21973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10772),
  [21975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 8),
  [21977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [21979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pat_unboxed_sum_repeat1, 2), SHIFT_REPEAT(489),
  [21982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pat_unboxed_sum_repeat1, 2),
  [21984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [21986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [21988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_signature_repeat1, 2, .production_id = 38),
  [21990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [21992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7750),
  [21994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7753),
  [21996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_instance, 7),
  [21998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [22000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [22002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12346),
  [22004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4026),
  [22006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [22008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stmt, 1),
  [22010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5732),
  [22012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4481),
  [22014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [22016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stmt, 1, .production_id = 21),
  [22018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [22020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [22022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1662),
  [22024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [22026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [22028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4485),
  [22030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14861),
  [22032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [22034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14863),
  [22036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 5),
  [22038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7762),
  [22040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [22042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18256),
  [22044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7764),
  [22046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4165),
  [22048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18265),
  [22050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5740),
  [22052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [22054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12981),
  [22056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12980),
  [22058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13669),
  [22060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [22062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4488),
  [22064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5727),
  [22066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3836),
  [22068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [22070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [22072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [22074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_field, 1),
  [22076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13670),
  [22078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5724),
  [22080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3028),
  [22082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12684),
  [22084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4076),
  [22086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18291),
  [22088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12237),
  [22090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [22092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12910),
  [22094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10784),
  [22096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10785),
  [22098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [22100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12908),
  [22102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [22104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [22106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18286),
  [22108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [22110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [22112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18294),
  [22114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_rhs, 5),
  [22116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [22118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [22120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 5),
  [22122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 7),
  [22124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13674),
  [22126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5709),
  [22128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12753),
  [22130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_import, 7, .production_id = 33),
  [22132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_arrow, 6, .production_id = 59),
  [22134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13678),
  [22136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [22138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple, 3, .production_id = 50),
  [22140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11764),
  [22142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5703),
  [22144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [22146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12829),
  [22148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3812),
  [22150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3796),
  [22152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [22154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18320),
  [22156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13193),
  [22158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11784),
  [22160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7249),
  [22162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple, 3, .production_id = 51),
  [22164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4035),
  [22166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 7, .production_id = 53),
  [22168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11892),
  [22170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [22172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6399),
  [22174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18248),
  [22176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2949),
  [22178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5734),
  [22180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [22182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7637),
  [22184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7638),
  [22186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 7),
  [22188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [22190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12803),
  [22192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [22194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2, .production_id = 37),
  [22196] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_list_repeat1, 2, .production_id = 37), SHIFT_REPEAT(1595),
  [22199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_instance, 6),
  [22201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2958),
  [22203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [22205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3797),
  [22207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11830),
  [22209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4182),
  [22211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18326),
  [22213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [22215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11857),
  [22217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4181),
  [22219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18329),
  [22221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11863),
  [22223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7953),
  [22225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11896),
  [22227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7950),
  [22229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [22231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyinst, 4),
  [22233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5693),
  [22235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7643),
  [22237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [22239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7649),
  [22241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4075),
  [22243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18368),
  [22245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [22247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8086),
  [22249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4365),
  [22251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7947),
  [22253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [22255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11938),
  [22257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [22259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_type, 4, .production_id = 19),
  [22261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14809),
  [22263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11934),
  [22265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13715),
  [22267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13690),
  [22269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [22271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7948),
  [22273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18533),
  [22275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9359),
  [22277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8901),
  [22279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 4),
  [22281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_tuple, 2),
  [22283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8830),
  [22285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6289),
  [22287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18379),
  [22289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [22291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6239),
  [22293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18335),
  [22295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7241),
  [22297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18363),
  [22299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [22301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7242),
  [22303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18376),
  [22305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_sum, 2),
  [22307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4375),
  [22309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7954),
  [22311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [22313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4376),
  [22315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7955),
  [22317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [22319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [22321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13382),
  [22323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5123),
  [22325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [22327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [22329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [22331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3138),
  [22333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5279),
  [22335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [22337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_rhs, 4),
  [22339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [22341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8877),
  [22343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8869),
  [22345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [22347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [22349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [22351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7254),
  [22353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18391),
  [22355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6676),
  [22357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [22359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [22361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4389),
  [22363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 4),
  [22365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5270),
  [22367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [22369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5934),
  [22371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3051),
  [22373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_equals, 3, .production_id = 59),
  [22375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5261),
  [22377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [22379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5504),
  [22381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18396),
  [22383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5127),
  [22385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5515),
  [22387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18402),
  [22389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9304),
  [22391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5137),
  [22393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9300),
  [22395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [22397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13346),
  [22399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [22401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5249),
  [22403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5247),
  [22405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [22407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 2),
  [22409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [22411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [22413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [22415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5241),
  [22417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace, 1),
  [22419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5239),
  [22421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9961),
  [22423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12263),
  [22425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [22427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13331),
  [22429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [22431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [22433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [22435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5509),
  [22437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18419),
  [22439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5232),
  [22441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7996),
  [22443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [22445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5924),
  [22447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyfam, 6),
  [22449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9969),
  [22451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9247),
  [22453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5923),
  [22455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9957),
  [22457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9246),
  [22459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7551),
  [22461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19536),
  [22463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10269),
  [22465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13321),
  [22467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [22469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13282),
  [22471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18414),
  [22473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 4, .production_id = 34),
  [22475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [22477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [22479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13283),
  [22481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18420),
  [22483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_instance, 5),
  [22485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13316),
  [22487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7548),
  [22489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7958),
  [22491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5191),
  [22493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9946),
  [22495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7481),
  [22497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9250),
  [22499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_datainst, 4, .production_id = 35),
  [22501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7887),
  [22503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18389),
  [22505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [22507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_foreign_export, 5),
  [22509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9942),
  [22511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9258),
  [22513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9391),
  [22515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_foreign_import, 5),
  [22517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_newtype, 4, .production_id = 30),
  [22519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_datafam, 4, .production_id = 56),
  [22521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9937),
  [22523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9935),
  [22525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18864),
  [22527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13326),
  [22529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18444),
  [22531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8978),
  [22533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9395),
  [22535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7502),
  [22537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_class, 5, .production_id = 36),
  [22539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7500),
  [22541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3163),
  [22543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9403),
  [22545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [22547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9931),
  [22549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9292),
  [22551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9924),
  [22553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3171),
  [22555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15241),
  [22557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15244),
  [22559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3),
  [22561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_default, 4),
  [22563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [22565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_default, 5),
  [22567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16855),
  [22569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9276),
  [22571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18447),
  [22573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9350),
  [22575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18450),
  [22577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_class, 4, .production_id = 20),
  [22579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8021),
  [22581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9413),
  [22583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8024),
  [22585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [22587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9416),
  [22589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9888),
  [22591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9417),
  [22593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9294),
  [22595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18473),
  [22597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9419),
  [22599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_safety, 1),
  [22601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__foreign_pre, 2),
  [22603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10910),
  [22605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15260),
  [22607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [22609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15258),
  [22611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13266),
  [22613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9875),
  [22615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [22617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8036),
  [22619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13262),
  [22621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9858),
  [22623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [22625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9430),
  [22627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_foreign_import, 4),
  [22629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8037),
  [22631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_foreign_export, 4),
  [22633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9435),
  [22635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7878),
  [22637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18416),
  [22639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7883),
  [22641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18439),
  [22643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2965),
  [22645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7679),
  [22647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7680),
  [22649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9844),
  [22651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8040),
  [22653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_rhs, 3),
  [22655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [22657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9835),
  [22659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8042),
  [22661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9823),
  [22663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5688),
  [22665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5178),
  [22667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18482),
  [22669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9813),
  [22671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5177),
  [22673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18489),
  [22675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_list, 3),
  [22677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7687),
  [22679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12573),
  [22681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [22683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7689),
  [22685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10885),
  [22687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13709),
  [22689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_type, 4, .production_id = 53),
  [22691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10892),
  [22693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [22695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [22697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [22699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [22701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_instance, 4),
  [22703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9805),
  [22705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8044),
  [22707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9783),
  [22709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [22711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [22713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5154),
  [22715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18504),
  [22717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7109),
  [22719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [22721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3010),
  [22723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14301),
  [22725] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_list_repeat1, 2), SHIFT_REPEAT(2361),
  [22728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [22730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7066),
  [22732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_projection_selector_repeat1, 2, .production_id = 66), SHIFT_REPEAT(18281),
  [22735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_projection_selector_repeat1, 2, .production_id = 66),
  [22737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__exp_tuple, 4, .production_id = 68),
  [22739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17826),
  [22741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17825),
  [22743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3591),
  [22745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18513),
  [22747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7084),
  [22749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5677),
  [22751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [22753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18512),
  [22755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7903),
  [22757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10905),
  [22759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5138),
  [22761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7881),
  [22763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [22765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5136),
  [22767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [22769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5131),
  [22771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [22773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9504),
  [22775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_tyinst, 5),
  [22777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17822),
  [22779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12630),
  [22781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17820),
  [22783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9497),
  [22785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7901),
  [22787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [22789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13711),
  [22791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10920),
  [22793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [22795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [22797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [22799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13713),
  [22801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5113),
  [22803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10937),
  [22805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9484),
  [22807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [22809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7902),
  [22811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [22813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8439),
  [22815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7192),
  [22817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7195),
  [22819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8438),
  [22821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [22823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9478),
  [22825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7934),
  [22827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13716),
  [22829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7212),
  [22831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18534),
  [22833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10949),
  [22835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7206),
  [22837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18538),
  [22839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13718),
  [22841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [22843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10956),
  [22845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9475),
  [22847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8186),
  [22849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7904),
  [22851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9270),
  [22853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18517),
  [22855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9470),
  [22857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9456),
  [22859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15757),
  [22861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11025),
  [22863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18016),
  [22865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8424),
  [22867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [22869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8419),
  [22871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7158),
  [22873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18558),
  [22875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11035),
  [22877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [22879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [22881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11046),
  [22883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9514),
  [22885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7912),
  [22887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9487),
  [22889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3014),
  [22891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__type_sum_repeat1, 2), SHIFT_REPEAT(2396),
  [22894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_sum_repeat1, 2),
  [22896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8388),
  [22898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10998),
  [22900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8387),
  [22902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12261),
  [22904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18562),
  [22906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12398),
  [22908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18570),
  [22910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3606),
  [22912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18528),
  [22914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13168),
  [22916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [22918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11066),
  [22920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13164),
  [22922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [22924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [22926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11068),
  [22928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat1, 2), SHIFT_REPEAT(2078),
  [22931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__let_decls_repeat1, 2),
  [22933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11072),
  [22935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [22937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13675),
  [22939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11075),
  [22941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5797),
  [22943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5604),
  [22945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8378),
  [22947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8376),
  [22949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12281),
  [22951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18596),
  [22953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [22955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13733),
  [22957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [22959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11084),
  [22961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15582),
  [22963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13734),
  [22965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11090),
  [22967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [22969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18025),
  [22971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13102),
  [22973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5808),
  [22975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9313),
  [22977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18526),
  [22979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13101),
  [22981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9320),
  [22983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18550),
  [22985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [22987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18591),
  [22989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [22991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5066),
  [22993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18600),
  [22995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [22997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [22999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3838),
  [23001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5810),
  [23003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13114),
  [23005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12362),
  [23007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [23009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [23011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5812),
  [23013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13115),
  [23015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5813),
  [23017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [23019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__context_constraints_repeat1, 2),
  [23021] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__context_constraints_repeat1, 2), SHIFT_REPEAT(2665),
  [23024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5815),
  [23026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5050),
  [23028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18623),
  [23030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4349),
  [23032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5852),
  [23034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [23036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5853),
  [23038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18603),
  [23040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [23042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5846),
  [23044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18605),
  [23046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5844),
  [23048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18606),
  [23050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6133),
  [23052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6131),
  [23054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18608),
  [23056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12215),
  [23058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [23060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12207),
  [23062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6137),
  [23064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18609),
  [23066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3806),
  [23068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9145),
  [23070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [23072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [23074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6141),
  [23076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18610),
  [23078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6176),
  [23080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4697),
  [23082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6160),
  [23084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18618),
  [23086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6167),
  [23088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18620),
  [23090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [23092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4698),
  [23094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [23096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [23098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6169),
  [23100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18622),
  [23102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4702),
  [23104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14656),
  [23106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14654),
  [23108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18624),
  [23110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2988),
  [23112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12187),
  [23114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14648),
  [23116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18625),
  [23118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12169),
  [23120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [23122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14665),
  [23124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18627),
  [23126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [23128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8838),
  [23130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14542),
  [23132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8844),
  [23134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [23136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4705),
  [23138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14549),
  [23140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18629),
  [23142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14533),
  [23144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18633),
  [23146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4710),
  [23148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14531),
  [23150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18634),
  [23152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [23154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [23156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [23158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6861),
  [23160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6859),
  [23162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18637),
  [23164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6867),
  [23166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18639),
  [23168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3964),
  [23170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [23172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9140),
  [23174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [23176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [23178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6872),
  [23180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18640),
  [23182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9138),
  [23184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9040),
  [23186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18650),
  [23188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3974),
  [23190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9043),
  [23192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18662),
  [23194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5802),
  [23196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6586),
  [23198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18644),
  [23200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6581),
  [23202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18647),
  [23204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8851),
  [23206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8859),
  [23208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5827),
  [23210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6574),
  [23212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18648),
  [23214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [23216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6589),
  [23218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9118),
  [23220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6187),
  [23222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18649),
  [23224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6196),
  [23226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18651),
  [23228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10524),
  [23230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [23232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pat_tuple_repeat1, 2), SHIFT_REPEAT(548),
  [23235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6205),
  [23237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18652),
  [23239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6189),
  [23241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6499),
  [23243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18657),
  [23245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6471),
  [23247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18658),
  [23249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6467),
  [23251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18661),
  [23253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9080),
  [23255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18687),
  [23257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13284),
  [23259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10515),
  [23261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9111),
  [23263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6485),
  [23265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8003),
  [23267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18664),
  [23269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10535),
  [23271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7994),
  [23273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18666),
  [23275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9074),
  [23277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7991),
  [23279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18668),
  [23281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13126),
  [23283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7999),
  [23285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11312),
  [23287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17898),
  [23289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18669),
  [23291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11360),
  [23293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17881),
  [23295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18673),
  [23297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17879),
  [23299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18675),
  [23301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [23303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18736),
  [23305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8582),
  [23307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18642),
  [23309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17890),
  [23311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8805),
  [23313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18680),
  [23315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8785),
  [23317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18683),
  [23319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10361),
  [23321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8781),
  [23323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18685),
  [23325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8798),
  [23327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [23329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10358),
  [23331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8698),
  [23333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18686),
  [23335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10352),
  [23337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8707),
  [23339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18690),
  [23341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10331),
  [23343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8166),
  [23345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8712),
  [23347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18691),
  [23349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8165),
  [23351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8656),
  [23353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11504),
  [23355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8751),
  [23357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18693),
  [23359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11491),
  [23361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8736),
  [23363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18697),
  [23365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [23367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2925),
  [23369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8737),
  [23371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18698),
  [23373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8745),
  [23375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4002),
  [23377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [23379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10344),
  [23381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9997),
  [23383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18702),
  [23385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10001),
  [23387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18703),
  [23389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10002),
  [23391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18704),
  [23393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10346),
  [23395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7075),
  [23397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18709),
  [23399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7281),
  [23401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18712),
  [23403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [23405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7285),
  [23407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18714),
  [23409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10659),
  [23411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7056),
  [23413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6591),
  [23415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18718),
  [23417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6637),
  [23419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18721),
  [23421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6710),
  [23423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18722),
  [23425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [23427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18706),
  [23429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6448),
  [23431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18729),
  [23433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13442),
  [23435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18751),
  [23437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6335),
  [23439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18733),
  [23441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13441),
  [23443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18760),
  [23445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6546),
  [23447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18734),
  [23449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9077),
  [23451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4856),
  [23453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18803),
  [23455] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__exp_tuple_repeat1, 2, .production_id = 37), SHIFT_REPEAT(961),
  [23458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6607),
  [23460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8519),
  [23462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8212),
  [23464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18738),
  [23466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8140),
  [23468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8247),
  [23470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18743),
  [23472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8156),
  [23474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18744),
  [23476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10689),
  [23478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6413),
  [23480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6100),
  [23482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18749),
  [23484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8229),
  [23486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6116),
  [23488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18752),
  [23490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11348),
  [23492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10696),
  [23494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8564),
  [23496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18681),
  [23498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6123),
  [23500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18754),
  [23502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8234),
  [23504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6525),
  [23506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18758),
  [23508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6536),
  [23510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18761),
  [23512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13436),
  [23514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18792),
  [23516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11423),
  [23518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6549),
  [23520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18762),
  [23522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8559),
  [23524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18705),
  [23526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11408),
  [23528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8201),
  [23530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13661),
  [23532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18766),
  [23534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6444),
  [23536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13649),
  [23538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18767),
  [23540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13648),
  [23542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18769),
  [23544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6620),
  [23546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6438),
  [23548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6623),
  [23550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6109),
  [23552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13631),
  [23554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18773),
  [23556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13625),
  [23558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18774),
  [23560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13624),
  [23562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18778),
  [23564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6533),
  [23566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7272),
  [23568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18785),
  [23570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11391),
  [23572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [23574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10705),
  [23576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [23578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11390),
  [23580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8272),
  [23582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11381),
  [23584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7253),
  [23586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18789),
  [23588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11379),
  [23590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7250),
  [23592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18790),
  [23594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [23596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [23598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5822),
  [23600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6656),
  [23602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5829),
  [23604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6659),
  [23606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10708),
  [23608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [23610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [23612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [23614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5845),
  [23616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [23618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11372),
  [23620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2939),
  [23622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5848),
  [23624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11364),
  [23626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6765),
  [23628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [23630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8981),
  [23632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18795),
  [23634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8273),
  [23636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8974),
  [23638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18799),
  [23640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6776),
  [23642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8973),
  [23644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18801),
  [23646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6031),
  [23648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [23650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13163),
  [23652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18810),
  [23654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6023),
  [23656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13187),
  [23658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18816),
  [23660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [23662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10716),
  [23664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6010),
  [23666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8501),
  [23668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [23670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [23672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6009),
  [23674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8500),
  [23676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [23678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13655),
  [23680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13197),
  [23682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18807),
  [23684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9979),
  [23686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6428),
  [23688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4805),
  [23690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13186),
  [23692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18811),
  [23694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6427),
  [23696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13183),
  [23698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18812),
  [23700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5972),
  [23702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5976),
  [23704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [23706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13204),
  [23708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18828),
  [23710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8690),
  [23712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4808),
  [23714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6713),
  [23716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6705),
  [23718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5980),
  [23720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4822),
  [23722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5981),
  [23724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13628),
  [23726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13603),
  [23728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18817),
  [23730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [23732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10722),
  [23734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11930),
  [23736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8289),
  [23738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11929),
  [23740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13611),
  [23742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18821),
  [23744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10805),
  [23746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8488),
  [23748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4601),
  [23750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13594),
  [23752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18822),
  [23754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8486),
  [23756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2916),
  [23758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [23760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14940),
  [23762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [23764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14946),
  [23766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [23768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [23770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14951),
  [23772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4847),
  [23774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14952),
  [23776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [23778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7255),
  [23780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [23782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18830),
  [23784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12947),
  [23786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_con_tuple_repeat1, 2), SHIFT_REPEAT(16732),
  [23789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11918),
  [23791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13327),
  [23793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11506),
  [23795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10711),
  [23797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [23799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7676),
  [23801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18806),
  [23803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [23805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18832),
  [23807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [23809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18836),
  [23811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [23813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [23815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14338),
  [23817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14330),
  [23819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4844),
  [23821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14324),
  [23823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [23825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14320),
  [23827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [23829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8977),
  [23831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10523),
  [23833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18840),
  [23835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8092),
  [23837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18857),
  [23839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8089),
  [23841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18872),
  [23843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7664),
  [23845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18837),
  [23847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8468),
  [23849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8466),
  [23851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10512),
  [23853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18843),
  [23855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6686),
  [23857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18856),
  [23859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10509),
  [23861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18845),
  [23863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6685),
  [23865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18865),
  [23867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6960),
  [23869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6968),
  [23871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7003),
  [23873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7659),
  [23875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18842),
  [23877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7006),
  [23879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13192),
  [23881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7508),
  [23883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18849),
  [23885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13314),
  [23887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [23889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7359),
  [23891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18854),
  [23893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11240),
  [23895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7330),
  [23897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18855),
  [23899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [23901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10233),
  [23903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10237),
  [23905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4958),
  [23907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10240),
  [23909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10241),
  [23911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13598),
  [23913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6638),
  [23915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18877),
  [23917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11228),
  [23919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11215),
  [23921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7124),
  [23923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18861),
  [23925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8450),
  [23927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11212),
  [23929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11223),
  [23931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7152),
  [23933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18867),
  [23935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7172),
  [23937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18868),
  [23939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8077),
  [23941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18895),
  [23943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7447),
  [23945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [23947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7448),
  [23949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6418),
  [23951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6359),
  [23953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13872),
  [23955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [23957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11200),
  [23959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6293),
  [23961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6233),
  [23963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [23965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11198),
  [23967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11191),
  [23969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10400),
  [23971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18876),
  [23973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11213),
  [23975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4965),
  [23977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9516),
  [23979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13357),
  [23981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7464),
  [23983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4970),
  [23985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7466),
  [23987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9503),
  [23989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10389),
  [23991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18879),
  [23993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3003),
  [23995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13358),
  [23997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10386),
  [23999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18880),
  [24001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [24003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11167),
  [24005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11238),
  [24007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6192),
  [24009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11242),
  [24011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11158),
  [24013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6194),
  [24015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8489),
  [24017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11243),
  [24019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [24021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [24023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6199),
  [24025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6200),
  [24027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7427),
  [24029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8490),
  [24031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat2, 2, .dynamic_precedence = 1, .production_id = 94),
  [24033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11245),
  [24035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6515),
  [24037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18883),
  [24039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9477),
  [24041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8968),
  [24043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18896),
  [24045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9476),
  [24047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8991),
  [24049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18899),
  [24051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8365),
  [24053] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_default_repeat1, 2),
  [24055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_default_repeat1, 2), SHIFT_REPEAT(3350),
  [24058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6470),
  [24060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18885),
  [24062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8368),
  [24064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6237),
  [24066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18886),
  [24068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8505),
  [24070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11265),
  [24072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8506),
  [24074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11271),
  [24076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6263),
  [24078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8248),
  [24080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6279),
  [24082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7488),
  [24084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18882),
  [24086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6283),
  [24088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10648),
  [24090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6284),
  [24092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6288),
  [24094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18890),
  [24096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4997),
  [24098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13368),
  [24100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13306),
  [24102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [24104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4999),
  [24106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8931),
  [24108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18889),
  [24110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8596),
  [24112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10656),
  [24114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6327),
  [24116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18901),
  [24118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13369),
  [24120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11289),
  [24122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10691),
  [24124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6336),
  [24126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18906),
  [24128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7970),
  [24130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7974),
  [24132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cdecl, 1, .production_id = 73),
  [24134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11009),
  [24136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7979),
  [24138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11002),
  [24140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8010),
  [24142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7132),
  [24144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6692),
  [24146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18900),
  [24148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2002),
  [24150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [24152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8534),
  [24154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8543),
  [24156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10719),
  [24158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6684),
  [24160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18903),
  [24162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5012),
  [24164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [24166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10714),
  [24168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6682),
  [24170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18898),
  [24172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10720),
  [24174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17867),
  [24176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10733),
  [24178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17864),
  [24180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8395),
  [24182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17861),
  [24184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7462),
  [24186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17815),
  [24188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10959),
  [24190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17868),
  [24192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10948),
  [24194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6939),
  [24196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18902),
  [24198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [24200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7452),
  [24202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18892),
  [24204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [24206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10757),
  [24208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_constr_type, 6),
  [24210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_constr_type, 5),
  [24212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10778),
  [24214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [24216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8350),
  [24218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6928),
  [24220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18891),
  [24222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3025),
  [24224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7120),
  [24226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18814),
  [24228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6922),
  [24230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18887),
  [24232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7118),
  [24234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18852),
  [24236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [24238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_fun, 3),
  [24240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [24242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_constr_type, 4),
  [24244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2817),
  [24246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5036),
  [24248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4271),
  [24250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat1, 2, .production_id = 99), SHIFT_REPEAT(3208),
  [24253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat1, 2, .production_id = 99),
  [24255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3068),
  [24257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4269),
  [24259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11736),
  [24261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6908),
  [24263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18873),
  [24265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10829),
  [24267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13375),
  [24269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5043),
  [24271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [24273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6901),
  [24275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18862),
  [24277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6897),
  [24279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18858),
  [24281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7099),
  [24283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18824),
  [24285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10832),
  [24287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8854),
  [24289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7184),
  [24291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10839),
  [24293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7187),
  [24295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11727),
  [24297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7194),
  [24299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7211),
  [24301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [24303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [24305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [24307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14170),
  [24309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18844),
  [24311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [24313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10844),
  [24315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_signature_repeat1, 4, .production_id = 74),
  [24317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rec, 3),
  [24319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [24321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10831),
  [24323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14147),
  [24325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18833),
  [24327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10852),
  [24329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8002),
  [24331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18783),
  [24333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10855),
  [24335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14145),
  [24337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18829),
  [24339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10721),
  [24341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_tyinst, 5),
  [24343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10726),
  [24345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [24347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [24349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4507),
  [24351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9134),
  [24353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10739),
  [24355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [24357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rec, 6),
  [24359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11559),
  [24361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [24363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10851),
  [24365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9142),
  [24367] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_datafam, 4, .production_id = 56),
  [24369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_tyfam, 4, .production_id = 56),
  [24371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10846),
  [24373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10742),
  [24375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6508),
  [24377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11672),
  [24379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [24381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8541),
  [24383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18815),
  [24385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11664),
  [24387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [24389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13879),
  [24391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rec_repeat2, 2, .dynamic_precedence = 1),
  [24393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_fields_repeat1, 2),
  [24395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_fields_repeat1, 2), SHIFT_REPEAT(17320),
  [24398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8842),
  [24400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11632),
  [24402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [24404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8530),
  [24406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18804),
  [24408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13889),
  [24410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10879),
  [24412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18782),
  [24414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8839),
  [24416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10884),
  [24418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18763),
  [24420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11607),
  [24422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8529),
  [24424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18800),
  [24426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1476),
  [24428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [24430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [24432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9167),
  [24434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9168),
  [24436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_constr_type, 3),
  [24438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [24440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 4),
  [24442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6754),
  [24444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6755),
  [24446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6320),
  [24448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4323),
  [24450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_names_repeat1, 2),
  [24452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_names_repeat1, 2), SHIFT_REPEAT(13941),
  [24455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8835),
  [24457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18786),
  [24459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [24461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rec_repeat1, 2), SHIFT_REPEAT(487),
  [24464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rec_repeat1, 2),
  [24466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8824),
  [24468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18775),
  [24470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8821),
  [24472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18771),
  [24474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6271),
  [24476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10901),
  [24478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18719),
  [24480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [24482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6265),
  [24484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6244),
  [24486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6241),
  [24488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6603),
  [24490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [24492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8321),
  [24494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18757),
  [24496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7949),
  [24498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18559),
  [24500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8744),
  [24502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8325),
  [24504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18746),
  [24506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8331),
  [24508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18742),
  [24510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6385),
  [24512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6384),
  [24514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5636),
  [24516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10804),
  [24518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10802),
  [24520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_con_names_repeat1, 2),
  [24522] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_con_names_repeat1, 2), SHIFT_REPEAT(13944),
  [24525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13912),
  [24527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10798),
  [24529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10797),
  [24531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8817),
  [24533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4329),
  [24535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11517),
  [24537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [24539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [24541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8477),
  [24543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18728),
  [24545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4324),
  [24547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_record_repeat1, 2),
  [24549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_record_repeat1, 2), SHIFT_REPEAT(12343),
  [24552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [24554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5611),
  [24556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [24558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_field, 3),
  [24560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6376),
  [24562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13913),
  [24564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6373),
  [24566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8815),
  [24568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8473),
  [24570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18717),
  [24572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3141),
  [24574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8472),
  [24576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18713),
  [24578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11526),
  [24580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8456),
  [24582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [24584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [24586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6326),
  [24588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [24590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16965),
  [24592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [24594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8454),
  [24596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [24598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8811),
  [24600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18796),
  [24602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8000),
  [24604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18741),
  [24606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8444),
  [24608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_decl, 2, .production_id = 94),
  [24610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8443),
  [24612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6924),
  [24614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4635),
  [24616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18699),
  [24618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [24620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13289),
  [24622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18672),
  [24624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pat_fields_repeat1, 2),
  [24626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pat_fields_repeat1, 2), SHIFT_REPEAT(12355),
  [24629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13286),
  [24631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18660),
  [24633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8743),
  [24635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [24637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4640),
  [24639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18688),
  [24641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [24643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4641),
  [24645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18684),
  [24647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5600),
  [24649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8381),
  [24651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8379),
  [24653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [24655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16986),
  [24657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13920),
  [24659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10061),
  [24661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7202),
  [24663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8373),
  [24665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8372),
  [24667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6902),
  [24669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [24671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18670),
  [24673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [24675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13277),
  [24677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18636),
  [24679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14009),
  [24681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10032),
  [24683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat1, 2), SHIFT_REPEAT(3333),
  [24686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat1, 2),
  [24688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5595),
  [24690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10040),
  [24692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bind_pattern, 3, .production_id = 35),
  [24694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [24696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18659),
  [24698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13921),
  [24700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [24702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18655),
  [24704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [24706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3930),
  [24708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8750),
  [24710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6088),
  [24712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6086),
  [24714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_tyfam_repeat2, 2, .dynamic_precedence = 1),
  [24716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_eq, 3),
  [24718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10042),
  [24720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6083),
  [24722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6082),
  [24724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [24726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10045),
  [24728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14154),
  [24730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10047),
  [24732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7441),
  [24734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18641),
  [24736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10049),
  [24738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5593),
  [24740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [24742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5590),
  [24744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [24746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7530),
  [24748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18630),
  [24750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7571),
  [24752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18626),
  [24754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [24756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6306),
  [24758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8752),
  [24760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18695),
  [24762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [24764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10054),
  [24766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6312),
  [24768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_datainst, 4, .production_id = 35),
  [24770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10059),
  [24772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_tyinst, 4),
  [24774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8754),
  [24776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18676),
  [24778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4604),
  [24780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [24782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [24784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rec, 5),
  [24786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6323),
  [24788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6325),
  [24790] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2017),
  [24793] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2),
  [24795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8539),
  [24797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11234),
  [24799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18612),
  [24801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10981),
  [24803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18588),
  [24805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [24807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10986),
  [24809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18579),
  [24811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11260),
  [24813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18601),
  [24815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat2, 2, .dynamic_precedence = 1),
  [24817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11263),
  [24819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18597),
  [24821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3119),
  [24823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_datafam, 3, .production_id = 30),
  [24825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11315),
  [24827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11317),
  [24829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_list_comprehension_repeat1, 2),
  [24831] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exp_list_comprehension_repeat1, 2), SHIFT_REPEAT(208),
  [24834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11334),
  [24836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11336),
  [24838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11007),
  [24840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18565),
  [24842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7868),
  [24844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8827),
  [24846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10412),
  [24848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18583),
  [24850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5997),
  [24852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6002),
  [24854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [24856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5586),
  [24858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [24860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13928),
  [24862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10405),
  [24864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18572),
  [24866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6013),
  [24868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5580),
  [24870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6020),
  [24872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11446),
  [24874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14440),
  [24876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8682),
  [24878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18433),
  [24880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11441),
  [24882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8687),
  [24884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18545),
  [24886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_tyfam, 3, .production_id = 30),
  [24888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [24890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10398),
  [24892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18568),
  [24894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13855),
  [24896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3174),
  [24898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13469),
  [24900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13464),
  [24902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13460),
  [24904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13458),
  [24906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8323),
  [24908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7536),
  [24910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18554),
  [24912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8728),
  [24914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18530),
  [24916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7713),
  [24918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3319),
  [24920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17674),
  [24922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7516),
  [24924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18543),
  [24926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6043),
  [24928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6045),
  [24930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7203),
  [24932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7514),
  [24934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18539),
  [24936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7188),
  [24938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7189),
  [24940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [24942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11552),
  [24944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18479),
  [24946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6055),
  [24948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [24950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7197),
  [24952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10661),
  [24954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18509),
  [24956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7199),
  [24958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10660),
  [24960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18502),
  [24962] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_deriving_repeat1, 2, .production_id = 89),
  [24964] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_deriving_repeat1, 2, .production_id = 89), SHIFT_REPEAT(2741),
  [24967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11436),
  [24969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8474),
  [24971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11434),
  [24973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4731),
  [24975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18525),
  [24977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11545),
  [24979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18448),
  [24981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alts_repeat2, 2, .dynamic_precedence = 1),
  [24983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [24985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18514),
  [24987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4738),
  [24989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18510),
  [24991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13342),
  [24993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10639),
  [24995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18493),
  [24997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7602),
  [24999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8783),
  [25001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8784),
  [25003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13386),
  [25005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11083),
  [25007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11095),
  [25009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14438),
  [25011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [25013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11417),
  [25015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8789),
  [25017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8791),
  [25019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11100),
  [25021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4637),
  [25023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11105),
  [25025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [25027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11416),
  [25029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18496),
  [25031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8484),
  [25033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18474),
  [25035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14404),
  [25037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8598),
  [25039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18464),
  [25041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11414),
  [25043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14377),
  [25045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11398),
  [25047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18485),
  [25049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [25051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7177),
  [25053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11392),
  [25055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18481),
  [25057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4764),
  [25059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4765),
  [25061] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_alts_repeat1, 2), SHIFT_REPEAT(3184),
  [25064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_alts_repeat1, 2),
  [25066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4768),
  [25068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8570),
  [25070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18446),
  [25072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4769),
  [25074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7529),
  [25076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5902),
  [25078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18467),
  [25080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7373),
  [25082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7401),
  [25084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7175),
  [25086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11542),
  [25088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18361),
  [25090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5906),
  [25092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18456),
  [25094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5907),
  [25096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18452),
  [25098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7528),
  [25100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7478),
  [25102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7331),
  [25104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7525),
  [25106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7329),
  [25108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [25110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11142),
  [25112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18312),
  [25114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7324),
  [25116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11143),
  [25118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18421),
  [25120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14433),
  [25122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7325),
  [25124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11403),
  [25126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__gadt_rhs_repeat1, 2), SHIFT_REPEAT(13859),
  [25129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__gadt_rhs_repeat1, 2),
  [25131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14428),
  [25133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11395),
  [25135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6766),
  [25137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18438),
  [25139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [25141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13184),
  [25143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5302),
  [25145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11145),
  [25147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18405),
  [25149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8857),
  [25151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13167),
  [25153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6728),
  [25155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18427),
  [25157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6726),
  [25159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18423),
  [25161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4964),
  [25163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [25165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11291),
  [25167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11286),
  [25169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11280),
  [25171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11277),
  [25173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4952),
  [25175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8121),
  [25177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18409),
  [25179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [25181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7941),
  [25183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4793),
  [25185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18388),
  [25187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9740),
  [25189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18516),
  [25191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4799),
  [25193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18384),
  [25195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7428),
  [25197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7433),
  [25199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5274),
  [25201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__gadt_rhs_repeat2, 2, .dynamic_precedence = 1),
  [25203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8125),
  [25205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18398),
  [25207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [25209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8126),
  [25211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18394),
  [25213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13154),
  [25215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7234),
  [25217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7232),
  [25219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4819),
  [25221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18370),
  [25223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8580),
  [25225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [25227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7222),
  [25229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7221),
  [25231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5753),
  [25233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5755),
  [25235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__gadt_constr_type, 2),
  [25237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10572),
  [25239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18380),
  [25241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5402),
  [25243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13145),
  [25245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5758),
  [25247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5761),
  [25249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10579),
  [25251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18369),
  [25253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11387),
  [25255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4011),
  [25257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18353),
  [25259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [25261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4014),
  [25263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18342),
  [25265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2820),
  [25267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10580),
  [25269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18365),
  [25271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10595),
  [25273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10561),
  [25275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [25277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5378),
  [25279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10601),
  [25281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10602),
  [25283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7531),
  [25285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6562),
  [25287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18351),
  [25289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3929),
  [25291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18328),
  [25293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15420),
  [25295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7507),
  [25297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6583),
  [25299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18340),
  [25301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7524),
  [25303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3744),
  [25305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3743),
  [25307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14406),
  [25309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6585),
  [25311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18336),
  [25313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14405),
  [25315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4754),
  [25317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4753),
  [25319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3738),
  [25321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [25323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [25325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18179),
  [25327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13944),
  [25329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4745),
  [25331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11176),
  [25333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18301),
  [25335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9757),
  [25337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18393),
  [25339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11181),
  [25341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18297),
  [25343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [25345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9762),
  [25347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18357),
  [25349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4981),
  [25351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18322),
  [25353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5016),
  [25355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18311),
  [25357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18777),
  [25359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13941),
  [25361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5404),
  [25363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5017),
  [25365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18307),
  [25367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13121),
  [25369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10991),
  [25371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10990),
  [25373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11189),
  [25375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18284),
  [25377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8162),
  [25379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [25381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10983),
  [25383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [25385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4917),
  [25387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11055),
  [25389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5065),
  [25391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18293),
  [25393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3145),
  [25395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4922),
  [25397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [25399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_import_list_repeat1, 2),
  [25401] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_list_repeat1, 2), SHIFT_REPEAT(12709),
  [25404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14016),
  [25406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18259),
  [25408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5082),
  [25410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18282),
  [25412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14013),
  [25414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18246),
  [25416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [25418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18278),
  [25420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6524),
  [25422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6521),
  [25424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6512),
  [25426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6500),
  [25428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5905),
  [25430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11586),
  [25432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18264),
  [25434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12517),
  [25436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18216),
  [25438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [25440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13998),
  [25442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18237),
  [25444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11616),
  [25446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18253),
  [25448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12626),
  [25450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18101),
  [25452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11618),
  [25454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18249),
  [25456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11231),
  [25458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11232),
  [25460] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__module_repeat1, 2), SHIFT_REPEAT(16),
  [25463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__module_repeat1, 2),
  [25465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6464),
  [25467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6458),
  [25469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6449),
  [25471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6446),
  [25473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11252),
  [25475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11256),
  [25477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [25479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7697),
  [25481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18219),
  [25483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12223),
  [25485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7873),
  [25487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18210),
  [25489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4514),
  [25491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18235),
  [25493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8681),
  [25495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11958),
  [25497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [25499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8421),
  [25501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8414),
  [25503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4486),
  [25505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18224),
  [25507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [25509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18220),
  [25511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6658),
  [25513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6663),
  [25515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7848),
  [25517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18197),
  [25519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5156),
  [25521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6667),
  [25523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6674),
  [25525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6507),
  [25527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6505),
  [25529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3080),
  [25531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10902),
  [25533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18206),
  [25535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18289),
  [25537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6473),
  [25539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10919),
  [25541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18195),
  [25543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6437),
  [25545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10923),
  [25547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18191),
  [25549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9793),
  [25551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7730),
  [25553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18173),
  [25555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5354),
  [25557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7716),
  [25559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18160),
  [25561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9796),
  [25563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18730),
  [25565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5398),
  [25567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [25569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5395),
  [25571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11977),
  [25573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [25575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6745),
  [25577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [25579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18177),
  [25581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12653),
  [25583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18068),
  [25585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7670),
  [25587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7874),
  [25589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18150),
  [25591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13376),
  [25593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exports_repeat1, 2),
  [25595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_exports_repeat1, 2), SHIFT_REPEAT(10566),
  [25598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5222),
  [25600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18166),
  [25602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5214),
  [25604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18162),
  [25606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8085),
  [25608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8084),
  [25610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5044),
  [25612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6985),
  [25614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6986),
  [25616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8487),
  [25618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8080),
  [25620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6990),
  [25622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8076),
  [25624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12085),
  [25626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6992),
  [25628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7599),
  [25630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18138),
  [25632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8684),
  [25634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7607),
  [25636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18127),
  [25638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8124),
  [25640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7510),
  [25642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18148),
  [25644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11989),
  [25646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [25648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4987),
  [25650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12254),
  [25652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8493),
  [25654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7369),
  [25656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18137),
  [25658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7408),
  [25660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18133),
  [25662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7605),
  [25664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18110),
  [25666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8649),
  [25668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7048),
  [25670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7050),
  [25672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7038),
  [25674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6733),
  [25676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6732),
  [25678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7034),
  [25680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [25682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8688),
  [25684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6058),
  [25686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18119),
  [25688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_gadt_constructor, 2),
  [25690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6717),
  [25692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7095),
  [25694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6712),
  [25696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11994),
  [25698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5029),
  [25700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18096),
  [25702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6065),
  [25704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18108),
  [25706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5031),
  [25708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18087),
  [25710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3135),
  [25712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17124),
  [25714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6067),
  [25716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18104),
  [25718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9806),
  [25720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9798),
  [25722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14043),
  [25724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14041),
  [25726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4934),
  [25728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8496),
  [25730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14038),
  [25732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [25734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18071),
  [25736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6670),
  [25738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14036),
  [25740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6094),
  [25742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18090),
  [25744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10472),
  [25746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10468),
  [25748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [25750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13240),
  [25752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4909),
  [25754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8498),
  [25756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6112),
  [25758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18079),
  [25760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10454),
  [25762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6114),
  [25764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18075),
  [25766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10453),
  [25768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [25770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8640),
  [25772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5582),
  [25774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18060),
  [25776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8655),
  [25778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5576),
  [25780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17918),
  [25782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12030),
  [25784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8699),
  [25786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12039),
  [25788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8727),
  [25790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7101),
  [25792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8691),
  [25794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8686),
  [25796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5011),
  [25798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9586),
  [25800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18061),
  [25802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14231),
  [25804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5622),
  [25806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18037),
  [25808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4899),
  [25810] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7086),
  [25812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9613),
  [25814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18050),
  [25816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9622),
  [25818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9590),
  [25820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9612),
  [25822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18046),
  [25824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7081),
  [25826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8147),
  [25828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18144),
  [25830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8957),
  [25832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8961),
  [25834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9594),
  [25836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8971),
  [25838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9595),
  [25840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8975),
  [25842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3609),
  [25844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18013),
  [25846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9004),
  [25848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18032),
  [25850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [25852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18009),
  [25854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alt, 4, .production_id = 16),
  [25856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [25858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [25860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [25862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [25864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12049),
  [25866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8995),
  [25868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18021),
  [25870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8518),
  [25872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8996),
  [25874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18017),
  [25876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4882),
  [25878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3662),
  [25880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17998),
  [25882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7339),
  [25884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8243),
  [25886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8246),
  [25888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3060),
  [25890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5779),
  [25892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5778),
  [25894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8251),
  [25896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8252),
  [25898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6370),
  [25900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18003),
  [25902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [25904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13909),
  [25906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5774),
  [25908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6261),
  [25910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17992),
  [25912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9570),
  [25914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17950),
  [25916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8860),
  [25918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17978),
  [25920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6262),
  [25922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17988),
  [25924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8858),
  [25926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17969),
  [25928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [25930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17149),
  [25932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8420),
  [25934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8604),
  [25936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8402),
  [25938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13907),
  [25940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8409),
  [25942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8410),
  [25944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8850),
  [25946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17954),
  [25948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10483),
  [25950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17974),
  [25952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9559),
  [25954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17923),
  [25956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13373),
  [25958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5321),
  [25960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5322),
  [25962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13371),
  [25964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8639),
  [25966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10463),
  [25968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17963),
  [25970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10457),
  [25972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17959),
  [25974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5326),
  [25976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [25978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5327),
  [25980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [25982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4557),
  [25984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8573),
  [25986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17935),
  [25988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8135),
  [25990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18028),
  [25992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8576),
  [25994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17920),
  [25996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4555),
  [25998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8132),
  [26000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17982),
  [26002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7337),
  [26004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7417),
  [26006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17945),
  [26008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5435),
  [26010] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_signature, 2),
  [26012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7347),
  [26014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17930),
  [26016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9421),
  [26018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9420),
  [26020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8587),
  [26022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17906),
  [26024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9404),
  [26026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9402),
  [26028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11413),
  [26030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11421),
  [26032] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_instance_repeat1, 2), SHIFT_REPEAT(2252),
  [26035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_instance_repeat1, 2),
  [26037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6693),
  [26039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17916),
  [26041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8574),
  [26043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2006),
  [26045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11454),
  [26047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5428),
  [26049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11456),
  [26051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6668),
  [26053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17905),
  [26055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13336),
  [26057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [26059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17889),
  [26061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6662),
  [26063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17901),
  [26065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [26067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17882),
  [26069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7518),
  [26071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2945),
  [26073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7522),
  [26075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_instance_repeat2, 2, .dynamic_precedence = 1),
  [26077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5372),
  [26079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9540),
  [26081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17828),
  [26083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13329),
  [26085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7570),
  [26087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7586),
  [26089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6060),
  [26091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [26093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17865),
  [26095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6404),
  [26097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8617),
  [26099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17887),
  [26101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9853),
  [26103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8657),
  [26105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17876),
  [26107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7568),
  [26109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7351),
  [26111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_datainst, 3, .production_id = 16),
  [26113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9852),
  [26115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13276),
  [26117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8661),
  [26119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17872),
  [26121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5340),
  [26123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7398),
  [26125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [26127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7403),
  [26129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5381),
  [26131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [26133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15418),
  [26135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17853),
  [26137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5403),
  [26139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15404),
  [26141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17841),
  [26143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2947),
  [26145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4892),
  [26147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9840),
  [26149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [26151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6107),
  [26153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13360),
  [26155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17858),
  [26157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rec, 4),
  [26159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13299),
  [26161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [26163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15424),
  [26165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17831),
  [26167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8999),
  [26169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [26171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [26173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inst_tyinst, 3),
  [26175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5418),
  [26177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [26179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [26181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9842),
  [26183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8168),
  [26185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17838),
  [26187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8164),
  [26189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17818),
  [26191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [26193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5391),
  [26195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8160),
  [26197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17829),
  [26199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11538),
  [26201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11543),
  [26203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5393),
  [26205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11514),
  [26207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11528),
  [26209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13296),
  [26211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13383),
  [26213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17843),
  [26215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [26217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13379),
  [26219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17847),
  [26221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2839),
  [26223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [26225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7496),
  [26227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8161),
  [26229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9532),
  [26231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8159),
  [26233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15426),
  [26235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 4, .production_id = 82),
  [26237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15423),
  [26239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13364),
  [26241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13350),
  [26243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20926),
  [26245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [26247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [26249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8620),
  [26251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1799),
  [26253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [26255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1795),
  [26257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [26259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1793),
  [26261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [26263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8603),
  [26265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [26267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20911),
  [26269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [26271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1785),
  [26273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [26275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [26277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [26279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [26281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12509),
  [26283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12514),
  [26285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6677),
  [26287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8595),
  [26289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [26291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [26293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [26295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1764),
  [26297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [26299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [26301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [26303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [26305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1759),
  [26307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6711),
  [26309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5567),
  [26311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [26313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8586),
  [26315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [26317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9551),
  [26319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1749),
  [26321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [26323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5486),
  [26325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1454),
  [26327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [26329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [26331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1739),
  [26333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7414),
  [26335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transform, 4, .production_id = 84),
  [26337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20875),
  [26339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1604),
  [26341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [26343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [26345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funlhs, 1, .dynamic_precedence = 1, .production_id = 7),
  [26347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20869),
  [26349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [26351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [26353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7336),
  [26355] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funlhs, 1, .dynamic_precedence = 2, .production_id = 10),
  [26357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20863),
  [26359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1628),
  [26361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [26363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20857),
  [26365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1635),
  [26367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [26369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20851),
  [26371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [26373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8840),
  [26375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [26377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20845),
  [26379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [26381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1719),
  [26383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20839),
  [26385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [26387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10487),
  [26389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [26391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10479),
  [26393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20833),
  [26395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [26397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1713),
  [26399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20827),
  [26401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [26403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8852),
  [26405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [26407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20821),
  [26409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [26411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [26413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [26415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10489),
  [26417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11643),
  [26419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20815),
  [26421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [26423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1704),
  [26425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20809),
  [26427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [26429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15621),
  [26431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [26433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20803),
  [26435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [26437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [26439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20797),
  [26441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [26443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9261),
  [26445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1707),
  [26447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20791),
  [26449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [26451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6365),
  [26453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [26455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20784),
  [26457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [26459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12911),
  [26461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [26463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1722),
  [26465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20802),
  [26467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [26469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20777),
  [26471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [26473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6422),
  [26475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [26477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20770),
  [26479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1607),
  [26481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [26483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20763),
  [26485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [26487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [26489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [26491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20756),
  [26493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [26495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12045),
  [26497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20792),
  [26499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [26501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [26503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9003),
  [26505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20745),
  [26507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1567),
  [26509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12605),
  [26511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12612),
  [26513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8144),
  [26515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [26517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9012),
  [26519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20731),
  [26521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [26523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12575),
  [26525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12577),
  [26527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5336),
  [26529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5559),
  [26531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12884),
  [26533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20411),
  [26535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [26537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9697),
  [26539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3245),
  [26541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9301),
  [26543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5124),
  [26545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20645),
  [26547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1655),
  [26549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9616),
  [26551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20605),
  [26553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [26555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5099),
  [26557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9649),
  [26559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10390),
  [26561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9620),
  [26563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11064),
  [26565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5706),
  [26567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12678),
  [26569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11489),
  [26571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [26573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10368),
  [26575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_module, 2),
  [26577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_module, 2),
  [26579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6106),
  [26581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4796),
  [26583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [26585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1601),
  [26587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [26589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6092),
  [26591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8345),
  [26593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [26595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10567),
  [26597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11328),
  [26599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12652),
  [26601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5468),
  [26603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5467),
  [26605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10494),
  [26607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6059),
  [26609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7612),
  [26611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4391),
  [26613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [26615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10381),
  [26617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5453),
  [26619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6057),
  [26621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20398),
  [26623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [26625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8190),
  [26627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20365),
  [26629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [26631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7603),
  [26633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3761),
  [26635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7327),
  [26637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17162),
  [26639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 4),
  [26641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [26643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [26645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8150),
  [26647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7335),
  [26649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11465),
  [26651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7709),
  [26653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17076),
  [26655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [26657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [26659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8194),
  [26661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_con_names, 3, .production_id = 87),
  [26663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11523),
  [26665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16982),
  [26667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [26669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [26671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7844),
  [26673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8200),
  [26675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [26677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5344),
  [26679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16887),
  [26681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [26683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [26685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16792),
  [26687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [26689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [26691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [26693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_con_names, 3),
  [26695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4070),
  [26697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [26699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16697),
  [26701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [26703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [26705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 3, .production_id = 31),
  [26707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16602),
  [26709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [26711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [26713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [26715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field, 3),
  [26717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__exp_tuple_repeat1, 2, .production_id = 16),
  [26719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10904),
  [26721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16507),
  [26723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7854),
  [26725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [26727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [26729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [26731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16412),
  [26733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4472),
  [26735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10891),
  [26737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [26739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [26741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [26743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7512),
  [26745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7850),
  [26747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16317),
  [26749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [26751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [26753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_names, 2),
  [26755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20220),
  [26757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [26759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16222),
  [26761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [26763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [26765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4513),
  [26767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20169),
  [26769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1353),
  [26771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5414),
  [26773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [26775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [26777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16127),
  [26779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7565),
  [26781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [26783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [26785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [26787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13997),
  [26789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5697),
  [26791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20147),
  [26793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [26795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16032),
  [26797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 1, .production_id = 44),
  [26799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [26801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [26803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [26805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [26807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14000),
  [26809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6573),
  [26811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7810),
  [26813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15937),
  [26815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11595),
  [26817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [26819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [26821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20209),
  [26823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [26825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [26827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_field, 1, .production_id = 44),
  [26829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15842),
  [26831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10328),
  [26833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [26835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [26837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11575),
  [26839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [26841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [26843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15747),
  [26845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__funpat_infix, 3, .production_id = 46),
  [26847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_names, 3, .production_id = 87),
  [26849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [26851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [26853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4813),
  [26855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20175),
  [26857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [26859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15652),
  [26861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [26863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [26865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18494),
  [26867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5072),
  [26869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11190),
  [26871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15557),
  [26873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [26875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [26877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11778),
  [26879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_names, 3),
  [26881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [26883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4032),
  [26885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15467),
  [26887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5062),
  [26889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [26891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [26893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [26895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11188),
  [26897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15538),
  [26899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qual, 1),
  [26901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [26903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [26905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 3, .production_id = 31),
  [26907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11251),
  [26909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20085),
  [26911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [26913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20158),
  [26915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [26917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qual, 1, .production_id = 21),
  [26919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9337),
  [26921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15696),
  [26923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [26925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [26927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5002),
  [26929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20078),
  [26931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [26933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15927),
  [26935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [26937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [26939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [26941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4534),
  [26943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [26945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4962),
  [26947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16106),
  [26949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [26951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [26953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4360),
  [26955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3907),
  [26957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [26959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16294),
  [26961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [26963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [26965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_con_names, 2),
  [26967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6567),
  [26969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16384),
  [26971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3942),
  [26973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [26975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [26977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__constraint_context, 2),
  [26979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5255),
  [26981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16718),
  [26983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6561),
  [26985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [26987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [26989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9463),
  [26991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11565),
  [26993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16869),
  [26995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [26997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [26999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [27001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [27003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10573),
  [27005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4843),
  [27007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11389),
  [27009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5277),
  [27011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17116),
  [27013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [27015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [27017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7252),
  [27019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19962),
  [27021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [27023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6395),
  [27025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10546),
  [27027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19602),
  [27029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [27031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19955),
  [27033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [27035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17351),
  [27037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4816),
  [27039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [27041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [27043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [27045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [27047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7925),
  [27049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17627),
  [27051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7270),
  [27053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(200),
  [27055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [27057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9742),
  [27059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 1),
  [27061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9968),
  [27063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8122),
  [27065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17742),
  [27067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [27069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [27071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5508),
  [27073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17550),
  [27075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11148),
  [27077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [27079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [27081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8120),
  [27083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17379),
  [27085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [27087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [27089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7884),
  [27091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [27093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9393),
  [27095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5519),
  [27097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13325),
  [27099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11177),
  [27101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17090),
  [27103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [27105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [27107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [27109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6759),
  [27111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19855),
  [27113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [27115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19850),
  [27117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [27119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16825),
  [27121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [27123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [27125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [27127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6744),
  [27129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5129),
  [27131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16586),
  [27133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13223),
  [27135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [27137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [27139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8557),
  [27141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11541),
  [27143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9883),
  [27145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9315),
  [27147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16482),
  [27149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [27151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [27153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impent, 1),
  [27155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5903),
  [27157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expent, 1),
  [27159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8584),
  [27161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16261),
  [27163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [27165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [27167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5762),
  [27169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15088),
  [27171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [27173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [27175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9256),
  [27177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19794),
  [27179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [27181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16167),
  [27183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [27185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [27187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19758),
  [27189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [27191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11412),
  [27193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4825),
  [27195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19781),
  [27197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1553),
  [27199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [27201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5157),
  [27203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19750),
  [27205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1592),
  [27207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16089),
  [27209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(207),
  [27211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [27213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10624),
  [27215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_exp_projection_selector_repeat1, 2, .production_id = 64),
  [27217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11420),
  [27219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_transform, 2, .production_id = 16),
  [27221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1691),
  [27223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11031),
  [27225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15980),
  [27227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10642),
  [27229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [27231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [27233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5135),
  [27235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1478),
  [27237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9499),
  [27239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3482),
  [27241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4732),
  [27243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_deriving_repeat1, 2, .production_id = 62),
  [27245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9720),
  [27247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9251),
  [27249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15900),
  [27251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [27253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [27255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3602),
  [27257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ticked_tycon, 3, .production_id = 31),
  [27259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__quantified_constraint, 3),
  [27261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4998),
  [27263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4730),
  [27265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9274),
  [27267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [27269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [27271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15802),
  [27273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8725),
  [27275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [27277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [27279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__context_constraints, 4),
  [27281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11032),
  [27283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2862),
  [27285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [27287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier, 2),
  [27289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7159),
  [27291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10978),
  [27293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19634),
  [27295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [27297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7533),
  [27299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8729),
  [27301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19631),
  [27303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [27305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [27307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4763),
  [27309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15646),
  [27311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19672),
  [27313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [27315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7540),
  [27317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [27319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [27321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7139),
  [27323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7978),
  [27325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19618),
  [27327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [27329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5800),
  [27331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19881),
  [27333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [27335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11017),
  [27337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12269),
  [27339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10411),
  [27341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2849),
  [27343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [27345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1550),
  [27347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11005),
  [27349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [27351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [27353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 2, .production_id = 13),
  [27355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19626),
  [27357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1487),
  [27359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10424),
  [27361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 2),
  [27363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19534),
  [27365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [27367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4688),
  [27369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [27371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12338),
  [27373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15465),
  [27375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [27377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [27379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [27381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11235),
  [27383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19563),
  [27385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [27387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5854),
  [27389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5830),
  [27391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6130),
  [27393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6132),
  [27395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 5, .production_id = 91),
  [27397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11132),
  [27399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pat_field, 5),
  [27401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10576),
  [27403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [27405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6156),
  [27407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19551),
  [27409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1492),
  [27411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6162),
  [27413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5035),
  [27415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14652),
  [27417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14655),
  [27419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19438),
  [27421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [27423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14551),
  [27425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7469),
  [27427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14545),
  [27429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13259),
  [27431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6856),
  [27433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6860),
  [27435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7353),
  [27437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8591),
  [27439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5639),
  [27441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6540),
  [27443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [27445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6587),
  [27447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6186),
  [27449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6188),
  [27451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10521),
  [27453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19416),
  [27455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [27457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6501),
  [27459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6489),
  [27461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [27463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13281),
  [27465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9076),
  [27467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8006),
  [27469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8001),
  [27471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10027),
  [27473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17902),
  [27475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [27477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17895),
  [27479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [27481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [27483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11244),
  [27485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8808),
  [27487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8581),
  [27489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11544),
  [27491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8802),
  [27493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8697),
  [27495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9164),
  [27497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4636),
  [27499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10184),
  [27501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8700),
  [27503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [27505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8756),
  [27507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8807),
  [27509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8747),
  [27511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4634),
  [27513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9996),
  [27515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9998),
  [27517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_name, 3),
  [27519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7282),
  [27521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7058),
  [27523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8476),
  [27525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6645),
  [27527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10916),
  [27529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6608),
  [27531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10676),
  [27533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8483),
  [27535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6466),
  [27537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_con_names, 4),
  [27539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_item, 5),
  [27541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6447),
  [27543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4857),
  [27545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8217),
  [27547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 3, .production_id = 77),
  [27549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7952),
  [27551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8205),
  [27553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8322),
  [27555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6098),
  [27557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6103),
  [27559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name, 3),
  [27561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11424),
  [27563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8320),
  [27565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6504),
  [27567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13470),
  [27569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6529),
  [27571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10897),
  [27573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5646),
  [27575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [27577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13662),
  [27579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13660),
  [27581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 2, .production_id = 13),
  [27583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13632),
  [27585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13629),
  [27587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8833),
  [27589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [27591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_names, 4),
  [27593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4829),
  [27595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7310),
  [27597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8841),
  [27599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19255),
  [27601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1464),
  [27603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 5),
  [27605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7257),
  [27607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3948),
  [27609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13434),
  [27611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8861),
  [27613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8843),
  [27615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19240),
  [27617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [27619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8980),
  [27621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3243),
  [27623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4817),
  [27625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8540),
  [27627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7696),
  [27629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13198),
  [27631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [27633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13195),
  [27635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4807),
  [27637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8542),
  [27639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13201),
  [27641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13606),
  [27643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export, 2, .production_id = 34),
  [27645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_field, 6, .production_id = 97),
  [27647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [27649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13599),
  [27651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7085),
  [27653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19117),
  [27655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1649),
  [27657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10376),
  [27659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13141),
  [27661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [27663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19104),
  [27665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [27667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [27669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14169),
  [27671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19007),
  [27673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1378),
  [27675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [27677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7675),
  [27679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10531),
  [27681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [27683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10522),
  [27685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14171),
  [27687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [27689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [27691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7590),
  [27693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19147),
  [27695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [27697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7100),
  [27699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7505),
  [27701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19072),
  [27703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1436),
  [27705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11229),
  [27707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7107),
  [27709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6907),
  [27711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10830),
  [27713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6639),
  [27715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7126),
  [27717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_arrow_repeat1, 2, .production_id = 94),
  [27719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18989),
  [27721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [27723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4960),
  [27725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8078),
  [27727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6910),
  [27729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10569),
  [27731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19060),
  [27733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [27735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10408),
  [27737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6615),
  [27739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19078),
  [27741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [27743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10399),
  [27745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7377),
  [27747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6531),
  [27749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10894),
  [27751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6510),
  [27753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8882),
  [27755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6280),
  [27757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6937),
  [27759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11276),
  [27761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10753),
  [27763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8067),
  [27765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [27767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8932),
  [27769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6707),
  [27771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6298),
  [27773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6941),
  [27775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6590),
  [27777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10650),
  [27779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3223),
  [27781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10065),
  [27783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12611),
  [27785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6929),
  [27787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10794),
  [27789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17852),
  [27791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17855),
  [27793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17856),
  [27795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10951),
  [27797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10445),
  [27799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17862),
  [27801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7598),
  [27803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6456),
  [27805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10961),
  [27807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17866),
  [27809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10736),
  [27811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5013),
  [27813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10845),
  [27815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5007),
  [27817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11314),
  [27819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14180),
  [27821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14410),
  [27823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6700),
  [27825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7319),
  [27827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10446),
  [27829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7982),
  [27831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7981),
  [27833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7980),
  [27835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10996),
  [27837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11292),
  [27839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7977),
  [27841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6708),
  [27843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11010),
  [27845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7973),
  [27847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11011),
  [27849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11012),
  [27851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10698),
  [27853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8072),
  [27855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11239),
  [27857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7083),
  [27859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6983),
  [27861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6796),
  [27863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6330),
  [27865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8228),
  [27867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6287),
  [27869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6286),
  [27871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6285),
  [27873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7549),
  [27875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10646),
  [27877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6282),
  [27879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10327),
  [27881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6266),
  [27883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8508),
  [27885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8352),
  [27887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11264),
  [27889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9090),
  [27891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10633),
  [27893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9087),
  [27895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9474),
  [27897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8359),
  [27899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7161),
  [27901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8610),
  [27903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6930),
  [27905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6965),
  [27907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6247),
  [27909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10795),
  [27911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9490),
  [27913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3793),
  [27915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6207),
  [27917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6203),
  [27919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6202),
  [27921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11151),
  [27923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11155),
  [27925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3814),
  [27927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6198),
  [27929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [27931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1382),
  [27933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7240),
  [27935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6193),
  [27937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4977),
  [27939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11785),
  [27941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11237),
  [27943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7067),
  [27945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7465),
  [27947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9069),
  [27949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12155),
  [27951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11769),
  [27953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6697),
  [27955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6723),
  [27957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1381),
  [27959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11184),
  [27961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11187),
  [27963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6355),
  [27965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6319),
  [27967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6304),
  [27969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6349),
  [27971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13806),
  [27973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10815),
  [27975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4270),
  [27977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4320),
  [27979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6386),
  [27981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 9, .production_id = 34),
  [27983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7449),
  [27985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7445),
  [27987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10557),
  [27989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7444),
  [27991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7443),
  [27993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8090),
  [27995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7920),
  [27997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12393),
  [27999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [28001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6346),
  [28003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6367),
  [28005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7263),
  [28007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8919),
  [28009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11209),
  [28011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4259),
  [28013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10246),
  [28015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10243),
  [28017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10242),
  [28019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [28021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6669),
  [28023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4208),
  [28025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10239),
  [28027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10820),
  [28029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14277),
  [28031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7116),
  [28033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10236),
  [28035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6984),
  [28037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13332),
  [28039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4955),
  [28041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8621),
  [28043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8954),
  [28045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9983),
  [28047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11071),
  [28049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9217),
  [28051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [28053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6243),
  [28055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6254),
  [28057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7321),
  [28059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15308),
  [28061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11211),
  [28063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11210),
  [28065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [28067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7011),
  [28069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7010),
  [28071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [28073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [28075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [28077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7002),
  [28079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10735),
  [28081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13968),
  [28083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15068),
  [28085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [28087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6964),
  [28089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11296),
  [28091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4942),
  [28093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8517),
  [28095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10205),
  [28097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10142),
  [28099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10843),
  [28101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [28103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7186),
  [28105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10175),
  [28107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4835),
  [28109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [28111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7246),
  [28113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8583),
  [28115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [28117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5052),
  [28119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14316),
  [28121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14318),
  [28123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14319),
  [28125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [28127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8479),
  [28129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7191),
  [28131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14326),
  [28133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [28135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [28137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17870),
  [28139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14331),
  [28141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11671),
  [28143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [28145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7669),
  [28147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10737),
  [28149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7213),
  [28151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [28153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14558),
  [28155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7215),
  [28157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7491),
  [28159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7307),
  [28161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7227),
  [28163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11914),
  [28165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8262),
  [28167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14965),
  [28169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14958),
  [28171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14956),
  [28173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4858),
  [28175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [28177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14948),
  [28179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14184),
  [28181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8953),
  [28183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8142),
  [28185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8263),
  [28187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14945),
  [28189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [28191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11926),
  [28193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [28195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9479),
  [28197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11931),
  [28199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [28201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10856),
  [28203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7434),
  [28205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13610),
  [28207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10854),
  [28209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11933),
  [28211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11939),
  [28213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5987),
  [28215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5986),
  [28217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5982),
  [28219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9464),
  [28221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4823),
  [28223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6649),
  [28225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5979),
  [28227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6695),
  [28229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10723),
  [28231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6435),
  [28233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [28235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5973),
  [28237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13132),
  [28239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8299),
  [28241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8566),
  [28243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6718),
  [28245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7387),
  [28247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4803),
  [28249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10738),
  [28251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13609),
  [28253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13208),
  [28255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9560),
  [28257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4802),
  [28259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11674),
  [28261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5966),
  [28263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5967),
  [28265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5975),
  [28267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10743),
  [28269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10717),
  [28271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [28273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4792),
  [28275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10744),
  [28277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6022),
  [28279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10747),
  [28281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6027),
  [28283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [28285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10713),
  [28287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10803),
  [28289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12250),
  [28291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9868),
  [28293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10841),
  [28295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8613),
  [28297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11356),
  [28299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8209),
  [28301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13207),
  [28303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8928),
  [28305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8531),
  [28307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11359),
  [28309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9453),
  [28311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5859),
  [28313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5858),
  [28315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5851),
  [28317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5840),
  [28319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5652),
  [28321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10840),
  [28323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6526),
  [28325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5825),
  [28327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6657),
  [28329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17819),
  [28331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11378),
  [28333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11380),
  [28335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [28337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8938),
  [28339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13130),
  [28341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7305),
  [28343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9166),
  [28345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6749),
  [28347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [28349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10124),
  [28351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9544),
  [28353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1465),
  [28355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6434),
  [28357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6753),
  [28359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4313),
  [28361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6756),
  [28363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6757),
  [28365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7311),
  [28367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12936),
  [28369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13652),
  [28371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6758),
  [28373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4565),
  [28375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4564),
  [28377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8952),
  [28379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6799),
  [28381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6624),
  [28383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [28385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8288),
  [28387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6619),
  [28389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6618),
  [28391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [28393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5649),
  [28395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13651),
  [28397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8766),
  [28399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13673),
  [28401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13894),
  [28403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6614),
  [28405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14461),
  [28407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6452),
  [28409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11401),
  [28411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8607),
  [28413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9045),
  [28415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8618),
  [28417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10697),
  [28419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13672),
  [28421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7318),
  [28423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6242),
  [28425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9175),
  [28427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13418),
  [28429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6267),
  [28431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14805),
  [28433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13086),
  [28435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6264),
  [28437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11430),
  [28439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18232),
  [28441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6245),
  [28443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6369),
  [28445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13196),
  [28447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6006),
  [28449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8026),
  [28451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 8, .production_id = 34),
  [28453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6240),
  [28455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6236),
  [28457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6096),
  [28459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6235),
  [28461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4338),
  [28463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10031),
  [28465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7301),
  [28467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13100),
  [28469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8259),
  [28471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6030),
  [28473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13732),
  [28475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8268),
  [28477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8503),
  [28479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [28481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6392),
  [28483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5948),
  [28485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13194),
  [28487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11455),
  [28489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6391),
  [28491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6390),
  [28493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14616),
  [28495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8266),
  [28497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6483),
  [28499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6522),
  [28501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6383),
  [28503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7300),
  [28505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8847),
  [28507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [28509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5891),
  [28511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10914),
  [28513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10799),
  [28515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11516),
  [28517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6421),
  [28519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6191),
  [28521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [28523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10793),
  [28525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10787),
  [28527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10341),
  [28529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10786),
  [28531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10349),
  [28533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
  [28535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8361),
  [28537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8537),
  [28539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8431),
  [28541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6789),
  [28543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8258),
  [28545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7151),
  [28547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [28549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11786),
  [28551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6374),
  [28553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10654),
  [28555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10092),
  [28557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5606),
  [28559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7146),
  [28561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6459),
  [28563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7544),
  [28565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [28567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9095),
  [28569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13377),
  [28571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10652),
  [28573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8455),
  [28575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4282),
  [28577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8795),
  [28579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8734),
  [28581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6672),
  [28583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8738),
  [28585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [28587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8445),
  [28589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11479),
  [28591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8923),
  [28593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8400),
  [28595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4988),
  [28597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10387),
  [28599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8441),
  [28601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8704),
  [28603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7271),
  [28605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8703),
  [28607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8433),
  [28609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10339),
  [28611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8052),
  [28613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [28615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10685),
  [28617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10664),
  [28619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [28621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8790),
  [28623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8792),
  [28625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7545),
  [28627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8471),
  [28629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [28631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8801),
  [28633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10018),
  [28635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9107),
  [28637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [28639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11388),
  [28641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11572),
  [28643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17884),
  [28645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17924),
  [28647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17886),
  [28649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10335),
  [28651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8380),
  [28653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [28655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11304),
  [28657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11303),
  [28659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1610),
  [28661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11302),
  [28663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10023),
  [28665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7995),
  [28667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8053),
  [28669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7997),
  [28671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8374),
  [28673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10467),
  [28675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13320),
  [28677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5832),
  [28679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8371),
  [28681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5831),
  [28683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8370),
  [28685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8369),
  [28687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6482),
  [28689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6557),
  [28691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6484),
  [28693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13144),
  [28695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9214),
  [28697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7064),
  [28699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [28701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7527),
  [28703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6195),
  [28705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6108),
  [28707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6190),
  [28709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10532),
  [28711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10041),
  [28713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3941),
  [28715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3988),
  [28717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6613),
  [28719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6612),
  [28721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8733),
  [28723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10425),
  [28725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6584),
  [28727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6291),
  [28729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6588),
  [28731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [28733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6602),
  [28735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [28737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11589),
  [28739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10558),
  [28741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6087),
  [28743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10373),
  [28745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11154),
  [28747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6866),
  [28749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7022),
  [28751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6862),
  [28753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [28755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4712),
  [28757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6084),
  [28759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [28761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [28763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9926),
  [28765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6076),
  [28767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14534),
  [28769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14578),
  [28771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14539),
  [28773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6075),
  [28775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6074),
  [28777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10048),
  [28779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10051),
  [28781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7543),
  [28783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9938),
  [28785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7455),
  [28787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14658),
  [28789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14632),
  [28791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14657),
  [28793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12173),
  [28795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7668),
  [28797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7583),
  [28799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4703),
  [28801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [28803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7345),
  [28805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [28807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6166),
  [28809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6097),
  [28811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6165),
  [28813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [28815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5588),
  [28817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7623),
  [28819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tyfam_pat, 3, .production_id = 92),
  [28821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8647),
  [28823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6309),
  [28825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7128),
  [28827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6136),
  [28829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6093),
  [28831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6135),
  [28833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6315),
  [28835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12206),
  [28837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12220),
  [28839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10064),
  [28841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11814),
  [28843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11943),
  [28845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5816),
  [28847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12096),
  [28849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5847),
  [28851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5870),
  [28853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5849),
  [28855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6334),
  [28857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4695),
  [28859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6337),
  [28861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6338),
  [28863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [28865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5814),
  [28867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 3),
  [28869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11448),
  [28871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3295),
  [28873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15460),
  [28875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5884),
  [28877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5668),
  [28879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 5, .production_id = 34),
  [28881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13255),
  [28883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7436),
  [28885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [28887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5667),
  [28889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4685),
  [28891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11447),
  [28893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3951),
  [28895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [28897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [28899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1578),
  [28901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [28903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11316),
  [28905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12798),
  [28907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3791),
  [28909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7652),
  [28911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7653),
  [28913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11340),
  [28915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5834),
  [28917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7846),
  [28919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12381),
  [28921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14751),
  [28923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11333),
  [28925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18360),
  [28927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4673),
  [28929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5964),
  [28931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7357),
  [28933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11094),
  [28935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11093),
  [28937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5790),
  [28939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8392),
  [28941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8761),
  [28943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11217),
  [28945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11345),
  [28947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13820),
  [28949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11021),
  [28951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14823),
  [28953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [28955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5988),
  [28957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5993),
  [28959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8222),
  [28961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12388),
  [28963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8377),
  [28965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6660),
  [28967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [28969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6004),
  [28971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11019),
  [28973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7778),
  [28975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11077),
  [28977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13150),
  [28979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5795),
  [28981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [28983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11073),
  [28985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [28987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10540),
  [28989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [28991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13465),
  [28993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [28995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9949),
  [28997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15644),
  [28999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [29001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13461),
  [29003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [29005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10671),
  [29007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11004),
  [29009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6767),
  [29011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8385),
  [29013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [29015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9468),
  [29017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9471),
  [29019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [29021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8478),
  [29023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13729),
  [29025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17821),
  [29027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8393),
  [29029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8394),
  [29031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13457),
  [29033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11060),
  [29035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1566),
  [29037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13456),
  [29039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13455),
  [29041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6036),
  [29043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7534),
  [29045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7588),
  [29047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8102),
  [29049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7786),
  [29051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12438),
  [29053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7111),
  [29055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7577),
  [29057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7542),
  [29059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8855),
  [29061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7566),
  [29063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7117),
  [29065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9513),
  [29067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [29069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6039),
  [29071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8917),
  [29073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13906),
  [29075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8879),
  [29077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3091),
  [29079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11016),
  [29081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5578),
  [29083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9469),
  [29085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6041),
  [29087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6050),
  [29089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [29091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15798),
  [29093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9722),
  [29095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4639),
  [29097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8749),
  [29099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6054),
  [29101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13707),
  [29103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10976),
  [29105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10947),
  [29107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11478),
  [29109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [29111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8764),
  [29113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12664),
  [29115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8437),
  [29117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8763),
  [29119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7196),
  [29121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7220),
  [29123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [29125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8440),
  [29127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7483),
  [29129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7382),
  [29131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7476),
  [29133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5107),
  [29135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9483),
  [29137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8214),
  [29139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7185),
  [29141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11437),
  [29143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11435),
  [29145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15898),
  [29147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7200),
  [29149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8758),
  [29151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12781),
  [29153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7407),
  [29155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9296),
  [29157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [29159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13419),
  [29161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7890),
  [29163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9509),
  [29165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10353),
  [29167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10338),
  [29169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7863),
  [29171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [29173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5133),
  [29175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8746),
  [29177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15977),
  [29179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [29181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11069),
  [29183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10907),
  [29185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9515),
  [29187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10426),
  [29189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10903),
  [29191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11078),
  [29193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4744),
  [29195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7125),
  [29197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17824),
  [29199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10967),
  [29201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1562),
  [29203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8755),
  [29205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6560),
  [29207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17842),
  [29209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17827),
  [29211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17830),
  [29213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [29215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11098),
  [29217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1599),
  [29219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9770),
  [29221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8788),
  [29223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16079),
  [29225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6277),
  [29227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9775),
  [29229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [29231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11104),
  [29233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8794),
  [29235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8233),
  [29237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4746),
  [29239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4751),
  [29241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [29243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8875),
  [29245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [29247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6528),
  [29249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [29251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16157),
  [29253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10710),
  [29255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17108),
  [29257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9809),
  [29259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5245),
  [29261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [29263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9822),
  [29265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13324),
  [29267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7178),
  [29269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13134),
  [29271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10878),
  [29273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7103),
  [29275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10877),
  [29277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14257),
  [29279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11374),
  [29281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [29283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8507),
  [29285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6423),
  [29287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17006),
  [29289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16333),
  [29291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8108),
  [29293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4767),
  [29295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7685),
  [29297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9437),
  [29299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9409),
  [29301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7678),
  [29303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8965),
  [29305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8779),
  [29307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7365),
  [29309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7368),
  [29311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9855),
  [29313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4770),
  [29315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11362),
  [29317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11361),
  [29319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5323),
  [29321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7371),
  [29323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15257),
  [29325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [29327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5878),
  [29329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5809),
  [29331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16356),
  [29333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [29335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14117),
  [29337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7913),
  [29339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9425),
  [29341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9298),
  [29343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4190),
  [29345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4062),
  [29347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9411),
  [29349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14086),
  [29351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8032),
  [29353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9891),
  [29355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11164),
  [29357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7174),
  [29359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13229),
  [29361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16578),
  [29363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [29365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7521),
  [29367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9729),
  [29369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9896),
  [29371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11466),
  [29373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7315),
  [29375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9731),
  [29377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6738),
  [29379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5237),
  [29381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1519),
  [29383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13292),
  [29385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9917),
  [29387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9918),
  [29389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7323),
  [29391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1518),
  [29393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16802),
  [29395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11409),
  [29397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15246),
  [29399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7333),
  [29401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7308),
  [29403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15235),
  [29405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15234),
  [29407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15255),
  [29409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7306),
  [29411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6683),
  [29413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9405),
  [29415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [29417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7557),
  [29419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6661),
  [29421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6725),
  [29423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [29425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17083),
  [29427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9932),
  [29429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13218),
  [29431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9718),
  [29433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12756),
  [29435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [29437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7477),
  [29439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4991),
  [29441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7929),
  [29443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4990),
  [29445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5064),
  [29447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9389),
  [29449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [29451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8281),
  [29453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17334),
  [29455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4961),
  [29457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10464),
  [29459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13305),
  [29461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7547),
  [29463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4889),
  [29465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9382),
  [29467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8283),
  [29469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [29471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7587),
  [29473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4029),
  [29475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [29477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11281),
  [29479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9952),
  [29481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17541),
  [29483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7423),
  [29485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5916),
  [29487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5917),
  [29489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5921),
  [29491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [29493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6119),
  [29495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [29497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 2),
  [29499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7971),
  [29501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5925),
  [29503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11275),
  [29505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7885),
  [29507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10493),
  [29509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17755),
  [29511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10498),
  [29513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4951),
  [29515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8645),
  [29517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9287),
  [29519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9955),
  [29521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8098),
  [29523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10857),
  [29525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8045),
  [29527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5268),
  [29529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5240),
  [29531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5242),
  [29533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5243),
  [29535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [29537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17645),
  [29539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14416),
  [29541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7442),
  [29543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9951),
  [29545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10406),
  [29547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8672),
  [29549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8918),
  [29551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5132),
  [29553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5257),
  [29555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5126),
  [29557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9185),
  [29559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1629),
  [29561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [29563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [29565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [29567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17375),
  [29569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [29571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4785),
  [29573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [29575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5266),
  [29577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3742),
  [29579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11536),
  [29581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6882),
  [29583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5935),
  [29585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7225),
  [29587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5738),
  [29589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7121),
  [29591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5748),
  [29593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17128),
  [29595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5756),
  [29597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [29599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8332),
  [29601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7219),
  [29603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7506),
  [29605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [29607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [29609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [29611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5281),
  [29613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4780),
  [29615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16873),
  [29617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6129),
  [29619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [29621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [29623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9462),
  [29625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12479),
  [29627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5112),
  [29629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5292),
  [29631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11384),
  [29633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15400),
  [29635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5356),
  [29637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7951),
  [29639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10293),
  [29641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11135),
  [29643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [29645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16739),
  [29647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6892),
  [29649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7157),
  [29651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10600),
  [29653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8899),
  [29655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5384),
  [29657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12838),
  [29659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7338),
  [29661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8902),
  [29663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4123),
  [29665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11919),
  [29667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [29669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11921),
  [29671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10603),
  [29673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11124),
  [29675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16526),
  [29677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11123),
  [29679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14022),
  [29681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11013),
  [29683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4371),
  [29685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3748),
  [29687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5670),
  [29689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6232),
  [29691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6273),
  [29693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18522),
  [29695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [29697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5689),
  [29699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12608),
  [29701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [29703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8295),
  [29705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16301),
  [29707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18154),
  [29709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [29711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4184),
  [29713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5735),
  [29715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13686),
  [29717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7965),
  [29719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [29721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11598),
  [29723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11169),
  [29725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13692),
  [29727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16111),
  [29729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6566),
  [29731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7645),
  [29733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [29735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5320),
  [29737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11909),
  [29739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [29741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11858),
  [29743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11884),
  [29745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14051),
  [29747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12337),
  [29749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11367),
  [29751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4747),
  [29753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15944),
  [29755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10179),
  [29757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 5),
  [29759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [29761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3855),
  [29763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [29765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4736),
  [29767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16247),
  [29769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15208),
  [29771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [29773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6551),
  [29775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6550),
  [29777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7674),
  [29779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15703),
  [29781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4939),
  [29783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5141),
  [29785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7654),
  [29787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6345),
  [29789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11809),
  [29791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5721),
  [29793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4974),
  [29795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7639),
  [29797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7636),
  [29799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14157),
  [29801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18139),
  [29803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15249),
  [29805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13143),
  [29807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15542),
  [29809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8329),
  [29811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7635),
  [29813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7634),
  [29815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11799),
  [29817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5733),
  [29819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13688),
  [29821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7090),
  [29823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3792),
  [29825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3802),
  [29827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6543),
  [29829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4894),
  [29831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15464),
  [29833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14060),
  [29835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4901),
  [29837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10985),
  [29839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12925),
  [29841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5310),
  [29843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11746),
  [29845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4918),
  [29847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10980),
  [29849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15555),
  [29851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6541),
  [29853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6539),
  [29855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5711),
  [29857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14188),
  [29859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14190),
  [29861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11677),
  [29863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7486),
  [29865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7936),
  [29867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4054),
  [29869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7558),
  [29871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10792),
  [29873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15650),
  [29875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [29877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [29879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [29881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11836),
  [29883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11837),
  [29885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12891),
  [29887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12440),
  [29889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3840),
  [29891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10790),
  [29893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11973),
  [29895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10788),
  [29897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11970),
  [29899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1471),
  [29901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15745),
  [29903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5475),
  [29905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10783),
  [29907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [29909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9351),
  [29911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18753),
  [29913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [29915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6617),
  [29917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [29919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8689),
  [29921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5476),
  [29923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15840),
  [29925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6514),
  [29927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1470),
  [29929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7834),
  [29931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6498),
  [29933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12727),
  [29935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [29937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6629),
  [29939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10253),
  [29941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6630),
  [29943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8563),
  [29945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15935),
  [29947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5984),
  [29949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [29951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7811),
  [29953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 6, .production_id = 34),
  [29955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10106),
  [29957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17180),
  [29959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11208),
  [29961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11227),
  [29963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11230),
  [29965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16030),
  [29967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11247),
  [29969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11146),
  [29971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7763),
  [29973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [29975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5523),
  [29977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [29979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1377),
  [29981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [29983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4048),
  [29985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4034),
  [29987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8813),
  [29989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5223),
  [29991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16125),
  [29993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6450),
  [29995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14432),
  [29997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [29999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5731),
  [30001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6678),
  [30003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11255),
  [30005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6445),
  [30007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5351),
  [30009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5352),
  [30011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__module, 7, .production_id = 34),
  [30013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16220),
  [30015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5971),
  [30017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9465),
  [30019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13833),
  [30021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7755),
  [30023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11091),
  [30025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7748),
  [30027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7746),
  [30029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7304),
  [30031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7745),
  [30033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16315),
  [30035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [30037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7814),
  [30039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [30041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4120),
  [30043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [30045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8638),
  [30047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7484),
  [30049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [30051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6948),
  [30053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6553),
  [30055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8291),
  [30057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16410),
  [30059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6552),
  [30061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6666),
  [30063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10771),
  [30065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4467),
  [30067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18270),
  [30069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6538),
  [30071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6488),
  [30073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [30075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6954),
  [30077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16505),
  [30079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6955),
  [30081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13811),
  [30083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16857),
  [30085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6417),
  [30087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5676),
  [30089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [30091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11449),
  [30093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9057),
  [30095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [30097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6472),
  [30099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7273),
  [30101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16600),
  [30103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15194),
  [30105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7265),
  [30107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14462),
  [30109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12306),
  [30111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [30113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11324),
  [30115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11326),
  [30117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5750),
  [30119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8057),
  [30121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16695),
  [30123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9794),
  [30125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [30127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12609),
  [30129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9238),
  [30131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14548),
  [30133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14677),
  [30135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6969),
  [30137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12255),
  [30139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12333),
  [30141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4044),
  [30143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16790),
  [30145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14017),
  [30147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5416),
  [30149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exports, 4),
  [30151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9429),
  [30153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8509),
  [30155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5385),
  [30157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6976),
  [30159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [30161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9440),
  [30163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16721),
  [30165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6977),
  [30167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7720),
  [30169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16885),
  [30171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7823),
  [30173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5427),
  [30175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11422),
  [30177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11426),
  [30179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6332),
  [30181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8469),
  [30183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3753),
  [30185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7054),
  [30187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18617),
  [30189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16980),
  [30191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7073),
  [30193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8087),
  [30195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7738),
  [30197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7749),
  [30199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18587),
  [30201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7751),
  [30203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7752),
  [30205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14221),
  [30207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8675),
  [30209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8334),
  [30211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8083),
  [30213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8208),
  [30215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17074),
  [30217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11978),
  [30219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8227),
  [30221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14053),
  [30223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16373),
  [30225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8590),
  [30227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11474),
  [30229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3760),
  [30231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6988),
  [30233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7076),
  [30235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [30237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18707),
  [30239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6993),
  [30241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17160),
  [30243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14050),
  [30245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14049),
  [30247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [30249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [30251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7556),
  [30253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7520),
  [30255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6716),
  [30257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [30259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16099),
  [30261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17233),
  [30263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16298),
  [30265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11482),
  [30267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8943),
  [30269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17264),
  [30271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7367),
  [30273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17295),
  [30275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12465),
  [30277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17326),
  [30279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7642),
  [30281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17357),
  [30283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [30285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17388),
  [30287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5438),
  [30289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5439),
  [30291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17419),
  [30293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7838),
  [30295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8499),
  [30297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8449),
  [30299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17450),
  [30301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8230),
  [30303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1650),
  [30305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17481),
  [30307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4986),
  [30309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8959),
  [30311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7575),
  [30313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17512),
  [30315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [30317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14981),
  [30319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [30321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17543),
  [30323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7573),
  [30325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7473),
  [30327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17574),
  [30329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8721),
  [30331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6734),
  [30333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17605),
  [30335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3781),
  [30337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10326),
  [30339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17636),
  [30341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [30343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5449),
  [30345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13512),
  [30347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17667),
  [30349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5754),
  [30351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [30353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5451),
  [30355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17698),
  [30357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [30359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4648),
  [30361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4353),
  [30363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17729),
  [30365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7039),
  [30367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17760),
  [30369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4910),
  [30371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4911),
  [30373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17790),
  [30375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [30377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15152),
  [30379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15184),
  [30381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17803),
  [30383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [30385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15057),
  [30387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17786),
  [30389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14179),
  [30391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6724),
  [30393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7032),
  [30395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17762),
  [30397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14232),
  [30399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7057),
  [30401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14233),
  [30403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17738),
  [30405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8677),
  [30407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11605),
  [30409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14235),
  [30411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17723),
  [30413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4932),
  [30415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11766),
  [30417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5459),
  [30419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17700),
  [30421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [30423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9812),
  [30425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [30427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17678),
  [30429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6316),
  [30431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12893),
  [30433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6295),
  [30435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17654),
  [30437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11888),
  [30439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4157),
  [30441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9669),
  [30443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17634),
  [30445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5008),
  [30447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5985),
  [30449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6049),
  [30451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17609),
  [30453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6412),
  [30455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6773),
  [30457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17584),
  [30459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6341),
  [30461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12344),
  [30463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17564),
  [30465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7564),
  [30467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7102),
  [30469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17540),
  [30471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9803),
  [30473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17522),
  [30475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9340),
  [30477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13978),
  [30479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17502),
  [30481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [30483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5472),
  [30485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12079),
  [30487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17477),
  [30489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5725),
  [30491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17126),
  [30493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7093),
  [30495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17460),
  [30497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9691),
  [30499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3783),
  [30501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17442),
  [30503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [30505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6730),
  [30507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8881),
  [30509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17418),
  [30511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4982),
  [30513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5480),
  [30515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [30517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17397),
  [30519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9639),
  [30521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17370),
  [30523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9410),
  [30525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17353),
  [30527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7898),
  [30529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14054),
  [30531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17330),
  [30533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14039),
  [30535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17311),
  [30537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9715),
  [30539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9711),
  [30541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11974),
  [30543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17288),
  [30545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12659),
  [30547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8063),
  [30549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14035),
  [30551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17263),
  [30553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8889),
  [30555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8890),
  [30557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17236),
  [30559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [30561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [30563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17218),
  [30565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10473),
  [30567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5458),
  [30569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17188),
  [30571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9810),
  [30573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11042),
  [30575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5798),
  [30577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17158),
  [30579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5974),
  [30581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15823),
  [30583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9699),
  [30585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17135),
  [30587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9695),
  [30589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6042),
  [30591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17103),
  [30593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [30595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8432),
  [30597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17082),
  [30599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15844),
  [30601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10447),
  [30603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17068),
  [30605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8153),
  [30607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11293),
  [30609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8060),
  [30611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17037),
  [30613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9814),
  [30615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11053),
  [30617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5448),
  [30619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17002),
  [30621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8634),
  [30623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5440),
  [30625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15126),
  [30627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16970),
  [30629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12029),
  [30631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5437),
  [30633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5434),
  [30635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16927),
  [30637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [30639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8088),
  [30641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8720),
  [30643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16903),
  [30645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7589),
  [30647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8710),
  [30649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16879),
  [30651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8265),
  [30653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16854),
  [30655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [30657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11613),
  [30659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12695),
  [30661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16822),
  [30663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11546),
  [30665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7933),
  [30667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5696),
  [30669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16794),
  [30671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15117),
  [30673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13986),
  [30675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14012),
  [30677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16775),
  [30679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16753),
  [30681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15087),
  [30683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16730),
  [30685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9642),
  [30687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8676),
  [30689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16705),
  [30691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8184),
  [30693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8185),
  [30695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16682),
  [30697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [30699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8623),
  [30701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16658),
  [30703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11092),
  [30705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9640),
  [30707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16624),
  [30709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5631),
  [30711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8064),
  [30713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16618),
  [30715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5629),
  [30717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [30719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16609),
  [30721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16598),
  [30723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16588),
  [30725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14340),
  [30727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5613),
  [30729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16582),
  [30731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10422),
  [30733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10427),
  [30735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16570),
  [30737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13109),
  [30739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7538),
  [30741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16565),
  [30743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16559),
  [30745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6606),
  [30747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5531),
  [30749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16554),
  [30751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6609),
  [30753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13604),
  [30755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16544),
  [30757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6353),
  [30759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11885),
  [30761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16535),
  [30763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11112),
  [30765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11116),
  [30767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16528),
  [30769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11895),
  [30771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8958),
  [30773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16519),
  [30775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4897),
  [30777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16510),
  [30779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12680),
  [30781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16502),
  [30783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5333),
  [30785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11320),
  [30787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16494),
  [30789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5609),
  [30791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9623),
  [30793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16484),
  [30795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8897),
  [30797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16469),
  [30799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12876),
  [30801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10458),
  [30803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16459),
  [30805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10460),
  [30807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let, 2),
  [30809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16445),
  [30811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14424),
  [30813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9412),
  [30815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16436),
  [30817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [30819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16422),
  [30821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9591),
  [30823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6493),
  [30825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16416),
  [30827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8629),
  [30829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6643),
  [30831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6378),
  [30833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4956),
  [30835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5684),
  [30837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8970),
  [30839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11480),
  [30841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [30843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5286),
  [30845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [30847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5415),
  [30849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8976),
  [30851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8628),
  [30853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8626),
  [30855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5726),
  [30857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5728),
  [30859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9125),
  [30861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5741),
  [30863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [30865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13353),
  [30867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6409),
  [30869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8237),
  [30871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10887),
  [30873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7856),
  [30875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11742),
  [30877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7787),
  [30879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5267),
  [30881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1582),
  [30883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5264),
  [30885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10439),
  [30887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [30889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10438),
  [30891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1603),
  [30893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [30895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10474),
  [30897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5780),
  [30899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11740),
  [30901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [30903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [30905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8870),
  [30907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8250),
  [30909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7074),
  [30911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8253),
  [30913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1648),
  [30915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4743),
  [30917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9249),
  [30919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4742),
  [30921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12920),
  [30923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7302),
  [30925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [30927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10437),
  [30929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8548),
  [30931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6333),
  [30933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15398),
  [30935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [30937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [30939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4890),
  [30941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5540),
  [30943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [30945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12051),
  [30947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4896),
  [30949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [30951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [30953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10470),
  [30955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17153),
  [30957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [30959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9418),
  [30961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7824),
  [30963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4704),
  [30965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [30967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8407),
  [30969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12606),
  [30971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7774),
  [30973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11597),
  [30975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [30977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8831),
  [30979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8411),
  [30981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9427),
  [30983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9428),
  [30985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [30987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9609),
  [30989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9605),
  [30991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9617),
  [30993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1659),
  [30995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7355),
  [30997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5319),
  [30999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8876),
  [31001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1654),
  [31003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9355),
  [31005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10497),
  [31007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [31009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11897),
  [31011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1643),
  [31013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5324),
  [31015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15606),
  [31017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7400),
  [31019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9358),
  [31021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [31023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9618),
  [31025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12067),
  [31027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9679),
  [31029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [31031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7470),
  [31033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10724),
  [31035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7457),
  [31037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [31039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [31041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13361),
  [31043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [31045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [31047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7425),
  [31049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_haskell, 1, .production_id = 6),
  [31051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7515),
  [31053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13104),
  [31055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [31057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7340),
  [31059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6654),
  [31061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8504),
  [31063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8027),
  [31065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12175),
  [31067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7692),
  [31069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8497),
  [31071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4905),
  [31073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5313),
  [31075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11339),
  [31077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8568),
  [31079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9379),
  [31081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5770),
  [31083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11406),
  [31085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5771),
  [31087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9398),
  [31089] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [31091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5317),
  [31093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10537),
  [31095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5318),
  [31097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [31099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6777),
  [31101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8224),
  [31103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8829),
  [31105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3292),
  [31107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8016),
  [31109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5769),
  [31111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5366),
  [31113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5367),
  [31115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [31117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11604),
  [31119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [31121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7641),
  [31123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7563),
  [31125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7591),
  [31127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11590),
  [31129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11587),
  [31131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [31133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5361),
  [31135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8514),
  [31137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15323),
  [31139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5417),
  [31141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7069),
  [31143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7071),
  [31145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9860),
  [31147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7415),
  [31149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7343),
  [31151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6671),
  [31153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9851),
  [31155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5364),
  [31157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [31159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5766),
  [31161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5196),
  [31163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [31165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [31167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [31169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13105),
  [31171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15396),
  [31173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11432),
  [31175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [31177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11141),
  [31179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11498),
  [31181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5390),
  [31183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10336),
  [31185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7460),
  [31187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9716),
  [31189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11139),
  [31191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11507),
  [31193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7429),
  [31195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11496),
  [31197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [31199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11531),
  [31201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7459),
  [31203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7458),
  [31205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [31207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11499),
  [31209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8236),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_haskell_external_scanner_create(void);
void tree_sitter_haskell_external_scanner_destroy(void *);
bool tree_sitter_haskell_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_haskell_external_scanner_serialize(void *, char *);
void tree_sitter_haskell_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_haskell(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__varid,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_haskell_external_scanner_create,
      tree_sitter_haskell_external_scanner_destroy,
      tree_sitter_haskell_external_scanner_scan,
      tree_sitter_haskell_external_scanner_serialize,
      tree_sitter_haskell_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
